## AWS.jl

[![CI](https://github.com/JuliaCloud/AWS.jl/actions/workflows/CI.yaml/badge.svg?branch=master)](https://github.com/JuliaCloud/AWS.jl/actions/workflows/CI.yaml?query=branch%3Amaster)
[![Code Style: Blue](https://img.shields.io/badge/code%20style-blue-4495d1.svg)](https://github.com/invenia/BlueStyle)
[![ColPrac: Contributor's Guide on Collaborative Practices for Community Packages](https://img.shields.io/badge/ColPrac-Contributor's%20Guide-blueviolet)](https://github.com/SciML/ColPrac)

[![Docs: stable](https://img.shields.io/badge/docs-stable-blue.svg)](https://juliacloud.github.io/AWS.jl/stable)
[![Docs: dev](https://img.shields.io/badge/docs-dev-blue.svg)](https://juliacloud.github.io/AWS.jl/dev)

## Overview
A Julia interface for [Amazon Web Services](https://aws.amazon.com).

This package replaces [AWSCore.jl](https://github.com/JuliaCloud/AWSCore.jl) and [AWSSDK.jl](https://github.com/JuliaCloud/AWSSDK.jl) which previously provided low-level and high-level APIs respectively.
It includes automated code generation to ensure all new AWS services are available, as well as keeping existing services up to date.

semver note: AWS.jl uses [semver](https://semver.org/) to imbue it's version numbers with semantic meaning. In particular, breaking changes to the programmatic interface provided by AWS.jl (e.g. the `@service` macro, the [backends](https://juliacloud.github.io/AWS.jl/stable/backends.html) mechanism, etc) will only occur when the major version number changes. However, breaking changes to the upstream AWS-provided API are **not** reflected in the AWS.jl version number. For example, if AWS removes functionality, changes a keyword argument, etc, then the corresponding changes will be made here (via an automated update mechanism) **without** a corresponding breaking release to AWS.jl. These changes will always be made as a *feature release*, i.e. a minor-version bump to AWS.jl. Therefore it is recommended to use the [tilde specifier](https://pkgdocs.julialang.org/v1/compatibility/#Tilde-specifiers) in your compat bounds with AWS.jl if your code is sensitive to such changes.

To see an overview of the architecture see the [design document](https://github.com/JuliaCloud/AWS.jl/wiki/v1-Design-Document).

## Installation
```julia
julia> Pkg.add("AWS")
```

## Usage
`AWS.jl` can be used with low-level and high-level API requests.
Please note when passing parameters for a request they must be a subtype of `AbstractDict{String, <:Any}`.

### Low-Level
To use the low-level API, you must know how to perform the request you are making.
If you do not know how to perform a request you can reference the [AWS Documentation](https://docs.aws.amazon.com/).
Alternatively you can look at `/src/services/{Service}.jl` to find a list of available requests, as well as their required and optional parameters.

For example, to list the objects in an S3 bucket you must pass in the request method (`"GET"`) and the endpoint (`"/${bucket}"`):

```julia
using AWS.AWSServices: s3

s3("GET", "/your-bucket")
```

### High-Level
To use the high-level API, you only need to know the name of the request you wish to make.
For example again, to list the objects in an S3 bucket:

```julia
using AWS: @service
@service S3

S3.list_objects("your-bucket") # note: no '/' in front of bucket name
```

Working with public buckets that require "--no-sign-request", e.g. [copernicus data](https://registry.opendata.aws/copernicus-dem/),  you'll need to set AWS credentials to `nothing`:

```julia
using AWS: @service
@service S3

aws_config = AWSConfig(; creds=nothing, region="eu-central-1")
a = S3.list_objects("copernicus-dem-30m/"; aws_config)
```


The high-level function calls are wrapped around the low-level function calls, meaning you can still pass along any low-level `kwargs` such as `aws_config` when making these requests.

**Note:** When calling the `@service` macro you **CANNOT** match the predefined constant for the low level API. The low level API constants are named in all lowercase, and spaces are replaced with underscores.

```julia
using AWS.AWSServices: secrets_manager
using AWS: @service

# This matches the constant and will error!
@service secrets_manager
> ERROR: cannot assign a value to variable AWSServices.secrets_manager from module Main

# This does NOT match the filename structure and will error!
@service secretsmanager
> ERROR: could not open file /.julia/dev/AWS.jl/src/services/secretsmanager.jl

# All of the examples below are valid!
@service Secrets_Manager
@service SECRETS_MANAGER
@service sECRETS_MANAGER
```

## Limitations
Currently there are a few limitations with the high-level APIs.
For example, with S3's DeleteMultipleObjects call.
To remove multiple objects you must pass in an XML string (see below) in the body of the request.

Low-Level API Example:
```julia
using AWS.AWSServices: s3

body = """
    <Delete xmlns="http://s3.amazonaws.com/doc/2006-03-01/">
        <Object>
            <Key>test.txt</Key>
        </Object>
    </Delete>
    """
bucket_name = "example-bucket"

s3("POST", "/$bucket_name?delete", Dict("body" => body))  # Delete multiple objects
```

There is no-programatic way to see this from the [aws-sdk-js](https://github.com/aws/aws-sdk-js/blob/master/apis/s3-2006-03-01.normal.json), so the high-level function will not work.

High-Level API Example:
```julia
using AWS: @service
@service S3

body = """
    <Delete xmlns="http://s3.amazonaws.com/doc/2006-03-01/">
        <Object>
            <Key>test.txt</Key>
        </Object>
    </Delete>
    """
bucket_name = "example-bucket"

S3.DeleteObjects(bucket_name, body)  # Delete multiple objects
> ERROR: AWS.AWSExceptions.AWSException("MissingRequestBodyError", "Request Body is empty")
```
There are most likely other similar functions which require more intricate details in how the requests are performed, both in the S3 definitions and in other services.

## Modifying Functionality

There are sometimes situations, in which default behavior of AWS.jl might be overridden, for example when this package is used to access S3-compatible object storage of a different cloud service provider, which might have different ways of joining the endpoint url, encoding the region in the signature etc.

In many cases this can be achieved by creating a user-defined subtype of `AbstractAWSConfig` where some of the default methods are overwritten.
For example, if you want to use the S3 high-level interface to access public data from GCS without authorization, you could define:

````julia
struct AnonymousGCS <: AbstractAWSConfig end
struct NoCredentials end

AWS.region(aws::AnonymousGCS) = "" # No region
AWS.credentials(aws::AnonymousGCS) = NoCredentials() # No credentials
AWS.check_credentials(c::NoCredentials) = c # Skip credentials check
AWS.sign!(aws::AnonymousGCS, ::AWS.Request) = nothing # Don't sign request
function AWS.generate_service_url(aws::AnonymousGCS, service::String, resource::String)
    service == "s3" || throw(ArgumentError("Can only handle s3 requests to GCS"))
    return string("https://storage.googleapis.com.", resource)
end

with_aws_config(AnonymousGCS()) do
    ...
end
````

which skips some of the signature and credentials checking and modifies the generation of the endpoint url.
A more extended example would be to use this package to access a custom minio server, we can define:

````julia
struct MinioConfig <: AbstractAWSConfig
   endpoint::String
   region::String
   creds
end
AWS.region(c::MinioConfig) = c.region
AWS.credentials(c::MinioConfig) = c.creds
````

and we define our own credentials type:

````julia
struct SimpleCredentials
    access_key_id::String
    secret_key::String
    token::String
end
AWS.check_credentials(c::SimpleCredentials) = c
````

as well as a custom url generator:

````julia
function AWS.generate_service_url(aws::MinioConfig, service::String, resource::String)
    service == "s3" || throw(ArgumentError("Can only handle s3 requests to Minio"))
    return string(aws.endpoint, resource)
end

with_aws_config(MinioConfig("http://127.0.0.1:9000", "aregion", SimpleCredentials("minio", "minio123", ""))) do
    ...
end
````

Now we are ready to use AWS.jl to do S3-compatible requests to a minio server.


## Alternative Solutions
There are a few alternatives to this package, the two below are being deprecated in favour of this package:
* [AWSCore.jl](https://github.com/JuliaCloud/AWSCore.jl) - Low-level AWS interface
* [AWSSDK.jl](https://github.com/JuliaCloud/AWSSDK.jl) - High-level AWS interface

As well as some hand-written packages for specific AWS services:
* [AWSS3.jl](https://github.com/JuliaCloud/AWSS3.jl) - Julia 1.0+
* [AWSSQS.jl](https://github.com/JuliaCloud/AWSSQS.jl) - Julia 1.0+
* [AWSSNS.jl](https://github.com/samoconnor/AWSSNS.jl) - Julia 0.7
* [AWSIAM.jl](https://github.com/samoconnor/AWSIAM.jl) - Julia 0.6
* [AWSEC2.jl](https://github.com/samoconnor/AWSEC2.jl) - Julia 0.6
* [AWSLambda.jl](https://github.com/samoconnor/AWSLambda.jl) - Julia 0.6
* [AWSSES.jl](https://github.com/samoconnor/AWSSES.jl) - Julia 0.6
* [AWSSDB.jl](https://github.com/samoconnor/AWSSDB.jl) - Julia 0.6

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: finspace
using AWS.Compat
using AWS.UUIDs

"""
    create_environment(name)
    create_environment(name, params::Dict{String,<:Any})

Create a new FinSpace environment.

# Arguments
- `name`: The name of the FinSpace environment to be created.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"dataBundles"`: The list of Amazon Resource Names (ARN) of the data bundles to install.
  Currently supported data bundle ARNs:
  arn:aws:finspace:{Region}::data-bundle/capital-markets-sample - Contains sample Capital
  Markets datasets, categories and controlled vocabularies.
  arn:aws:finspace:{Region}::data-bundle/taq (default) - Contains trades and quotes data in
  addition to sample Capital Markets data.
- `"description"`: The description of the FinSpace environment to be created.
- `"federationMode"`: Authentication mode for the environment.    FEDERATED - Users access
  FinSpace through Single Sign On (SSO) via your Identity provider.    LOCAL - Users access
  FinSpace via email and password managed within the FinSpace environment.
- `"federationParameters"`: Configuration information when authentication mode is FEDERATED.
- `"kmsKeyId"`: The KMS key id to encrypt your data in the FinSpace environment.
- `"superuserParameters"`: Configuration information for the superuser.
- `"tags"`: Add tags to your FinSpace environment.
"""
function create_environment(name; aws_config::AbstractAWSConfig=current_aws_config())
    return finspace(
        "POST",
        "/environment",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_environment(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return finspace(
        "POST",
        "/environment",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_kx_changeset(change_requests, client_token, database_name, environment_id)
    create_kx_changeset(change_requests, client_token, database_name, environment_id, params::Dict{String,<:Any})

 Creates a changeset for a kdb database. A changeset allows you to add and delete existing
files by using an ordered list of change requests.

# Arguments
- `change_requests`: A list of change request objects that are run in order. A change
  request object consists of changeType , s3Path, and dbPath. A changeType can have the
  following values:    PUT – Adds or updates files in a database.   DELETE – Deletes
  files in a database.   All the change requests require a mandatory dbPath attribute that
  defines the path within the database directory. All database paths must start with a
  leading / and end with a trailing /. The s3Path attribute defines the s3 source file path
  and is required for a PUT change type. The s3path must end with a trailing / if it is a
  directory and must end without a trailing / if it is a file.  Here are few examples of how
  you can use the change request object:   This request adds a single sym file at database
  root location.   { \"changeType\": \"PUT\", \"s3Path\":\"s3://bucket/db/sym\",
  \"dbPath\":\"/\"}    This request adds files in the given s3Path under the 2020.01.02
  partition of the database.  { \"changeType\": \"PUT\",
  \"s3Path\":\"s3://bucket/db/2020.01.02/\", \"dbPath\":\"/2020.01.02/\"}    This request
  adds files in the given s3Path under the taq table partition of the database.  [ {
  \"changeType\": \"PUT\", \"s3Path\":\"s3://bucket/db/2020.01.02/taq/\",
  \"dbPath\":\"/2020.01.02/taq/\"}]    This request deletes the 2020.01.02 partition of the
  database.  [{ \"changeType\": \"DELETE\", \"dbPath\": \"/2020.01.02/\"} ]    The DELETE
  request allows you to delete the existing files under the 2020.01.02 partition of the
  database, and the PUT request adds a new taq table under it.  [ {\"changeType\":
  \"DELETE\", \"dbPath\":\"/2020.01.02/\"}, {\"changeType\": \"PUT\",
  \"s3Path\":\"s3://bucket/db/2020.01.02/taq/\", \"dbPath\":\"/2020.01.02/taq/\"}]
- `client_token`: A token that ensures idempotency. This token expires in 10 minutes.
- `database_name`: The name of the kdb database.
- `environment_id`: A unique identifier of the kdb environment.

"""
function create_kx_changeset(
    changeRequests,
    clientToken,
    databaseName,
    environmentId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "POST",
        "/kx/environments/$(environmentId)/databases/$(databaseName)/changesets",
        Dict{String,Any}("changeRequests" => changeRequests, "clientToken" => clientToken);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_kx_changeset(
    changeRequests,
    clientToken,
    databaseName,
    environmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "POST",
        "/kx/environments/$(environmentId)/databases/$(databaseName)/changesets",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "changeRequests" => changeRequests, "clientToken" => clientToken
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_kx_cluster(az_mode, cluster_name, cluster_type, environment_id, release_label, vpc_configuration)
    create_kx_cluster(az_mode, cluster_name, cluster_type, environment_id, release_label, vpc_configuration, params::Dict{String,<:Any})

Creates a new kdb cluster.

# Arguments
- `az_mode`: The number of availability zones you want to assign per cluster. This can be
  one of the following     SINGLE – Assigns one availability zone per cluster.    MULTI –
  Assigns all the availability zones per cluster.
- `cluster_name`: A unique name for the cluster that you want to create.
- `cluster_type`: Specifies the type of KDB database that is being created. The following
  types are available:    HDB – A Historical Database. The data is only accessible with
  read-only permissions from one of the FinSpace managed kdb databases mounted to the
  cluster.   RDB – A Realtime Database. This type of database captures all the data from a
  ticker plant and stores it in memory until the end of day, after which it writes all of its
  data to a disk and reloads the HDB. This cluster type requires local storage for temporary
  storage of data during the savedown process. If you specify this field in your request, you
  must provide the savedownStorageConfiguration parameter.   GATEWAY – A gateway cluster
  allows you to access data across processes in kdb systems. It allows you to create your own
  routing logic using the initialization scripts and custom code. This type of cluster does
  not require a writable local storage.   GP – A general purpose cluster allows you to
  quickly iterate on code during development by granting greater access to system commands
  and enabling a fast reload of custom code. This cluster type can optionally mount databases
  including cache and savedown storage. For this cluster type, the node count is fixed at 1.
  It does not support autoscaling and supports only SINGLE AZ mode.   Tickerplant – A
  tickerplant cluster allows you to subscribe to feed handlers based on IAM permissions. It
  can publish to RDBs, other Tickerplants, and real-time subscribers (RTS). Tickerplants can
  persist messages to log, which is readable by any RDB environment. It supports only
  single-node that is only one kdb process.
- `environment_id`: A unique identifier for the kdb environment.
- `release_label`: The version of FinSpace managed kdb to run.
- `vpc_configuration`: Configuration details about the network where the Privatelink
  endpoint of the cluster resides.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"autoScalingConfiguration"`: The configuration based on which FinSpace will scale in or
  scale out nodes in your cluster.
- `"availabilityZoneId"`: The availability zone identifiers for the requested regions.
- `"cacheStorageConfigurations"`: The configurations for a read only cache storage
  associated with a cluster. This cache will be stored as an FSx Lustre that reads from the
  S3 store.
- `"capacityConfiguration"`: A structure for the metadata of a cluster. It includes
  information like the CPUs needed, memory of instances, and number of instances.
- `"clientToken"`: A token that ensures idempotency. This token expires in 10 minutes.
- `"clusterDescription"`: A description of the cluster.
- `"code"`: The details of the custom code that you want to use inside a cluster when
  analyzing a data. It consists of the S3 source bucket, location, S3 object version, and the
  relative path from where the custom code is loaded into the cluster.
- `"commandLineArguments"`: Defines the key-value pairs to make them available inside the
  cluster.
- `"databases"`: A list of databases that will be available for querying.
- `"executionRole"`: An IAM role that defines a set of permissions associated with a
  cluster. These permissions are assumed when a cluster attempts to access another cluster.
- `"initializationScript"`: Specifies a Q program that will be run at launch of a cluster.
  It is a relative path within .zip file that contains the custom code, which will be loaded
  on the cluster. It must include the file name itself. For example, somedir/init.q.
- `"savedownStorageConfiguration"`: The size and type of the temporary storage that is used
  to hold data during the savedown process. This parameter is required when you choose
  clusterType as RDB. All the data written to this storage space is lost when the cluster
  node is restarted.
- `"scalingGroupConfiguration"`: The structure that stores the configuration details of a
  scaling group.
- `"tags"`: A list of key-value pairs to label the cluster. You can add up to 50 tags to a
  cluster.
- `"tickerplantLogConfiguration"`:  A configuration to store Tickerplant logs. It consists
  of a list of volumes that will be mounted to your cluster. For the cluster type
  Tickerplant, the location of the TP volume on the cluster will be available by using the
  global variable .aws.tp_log_path.
"""
function create_kx_cluster(
    azMode,
    clusterName,
    clusterType,
    environmentId,
    releaseLabel,
    vpcConfiguration;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "POST",
        "/kx/environments/$(environmentId)/clusters",
        Dict{String,Any}(
            "azMode" => azMode,
            "clusterName" => clusterName,
            "clusterType" => clusterType,
            "releaseLabel" => releaseLabel,
            "vpcConfiguration" => vpcConfiguration,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_kx_cluster(
    azMode,
    clusterName,
    clusterType,
    environmentId,
    releaseLabel,
    vpcConfiguration,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "POST",
        "/kx/environments/$(environmentId)/clusters",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "azMode" => azMode,
                    "clusterName" => clusterName,
                    "clusterType" => clusterType,
                    "releaseLabel" => releaseLabel,
                    "vpcConfiguration" => vpcConfiguration,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_kx_database(client_token, database_name, environment_id)
    create_kx_database(client_token, database_name, environment_id, params::Dict{String,<:Any})

Creates a new kdb database in the environment.

# Arguments
- `client_token`: A token that ensures idempotency. This token expires in 10 minutes.
- `database_name`: The name of the kdb database.
- `environment_id`: A unique identifier for the kdb environment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A description of the database.
- `"tags"`: A list of key-value pairs to label the kdb database. You can add up to 50 tags
  to your kdb database
"""
function create_kx_database(
    clientToken,
    databaseName,
    environmentId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "POST",
        "/kx/environments/$(environmentId)/databases",
        Dict{String,Any}("clientToken" => clientToken, "databaseName" => databaseName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_kx_database(
    clientToken,
    databaseName,
    environmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "POST",
        "/kx/environments/$(environmentId)/databases",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "clientToken" => clientToken, "databaseName" => databaseName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_kx_dataview(az_mode, client_token, database_name, dataview_name, environment_id)
    create_kx_dataview(az_mode, client_token, database_name, dataview_name, environment_id, params::Dict{String,<:Any})

 Creates a snapshot of kdb database with tiered storage capabilities and a pre-warmed
cache, ready for mounting on kdb clusters. Dataviews are only available for clusters
running on a scaling group. They are not supported on dedicated clusters.

# Arguments
- `az_mode`: The number of availability zones you want to assign per volume. Currently,
  FinSpace only supports SINGLE for volumes. This places dataview in a single AZ.
- `client_token`: A token that ensures idempotency. This token expires in 10 minutes.
- `database_name`:  The name of the database where you want to create a dataview.
- `dataview_name`: A unique identifier for the dataview.
- `environment_id`: A unique identifier for the kdb environment, where you want to create
  the dataview.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"autoUpdate"`: The option to specify whether you want to apply all the future additions
  and corrections automatically to the dataview, when you ingest new changesets. The default
  value is false.
- `"availabilityZoneId"`:  The identifier of the availability zones.
- `"changesetId"`:  A unique identifier of the changeset that you want to use to ingest
  data.
- `"description"`: A description of the dataview.
- `"readWrite"`:  The option to specify whether you want to make the dataview writable to
  perform database maintenance. The following are some considerations related to writable
  dataviews.&#x2028;&#x2028;   You cannot create partial writable dataviews. When you create
  writeable dataviews you must provide the entire database path.   You cannot perform updates
  on a writeable dataview. Hence, autoUpdate must be set as False if readWrite is True for a
  dataview.   You must also use a unique volume for creating a writeable dataview. So, if you
  choose a volume that is already in use by another dataview, the dataview creation fails.
  Once you create a dataview as writeable, you cannot change it to read-only. So, you cannot
  update the readWrite parameter later.
- `"segmentConfigurations"`:  The configuration that contains the database path of the data
  that you want to place on each selected volume. Each segment must have a unique database
  path for each volume. If you do not explicitly specify any database path for a volume, they
  are accessible from the cluster through the default S3/object store segment.
- `"tags"`:  A list of key-value pairs to label the dataview. You can add up to 50 tags to
  a dataview.
"""
function create_kx_dataview(
    azMode,
    clientToken,
    databaseName,
    dataviewName,
    environmentId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "POST",
        "/kx/environments/$(environmentId)/databases/$(databaseName)/dataviews",
        Dict{String,Any}(
            "azMode" => azMode, "clientToken" => clientToken, "dataviewName" => dataviewName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_kx_dataview(
    azMode,
    clientToken,
    databaseName,
    dataviewName,
    environmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "POST",
        "/kx/environments/$(environmentId)/databases/$(databaseName)/dataviews",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "azMode" => azMode,
                    "clientToken" => clientToken,
                    "dataviewName" => dataviewName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_kx_environment(kms_key_id, name)
    create_kx_environment(kms_key_id, name, params::Dict{String,<:Any})

Creates a managed kdb environment for the account.

# Arguments
- `kms_key_id`: The KMS key ID to encrypt your data in the FinSpace environment.
- `name`: The name of the kdb environment that you want to create.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A token that ensures idempotency. This token expires in 10 minutes.
- `"description"`: A description for the kdb environment.
- `"tags"`: A list of key-value pairs to label the kdb environment. You can add up to 50
  tags to your kdb environment.
"""
function create_kx_environment(
    kmsKeyId, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return finspace(
        "POST",
        "/kx/environments",
        Dict{String,Any}(
            "kmsKeyId" => kmsKeyId, "name" => name, "clientToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_kx_environment(
    kmsKeyId,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "POST",
        "/kx/environments",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "kmsKeyId" => kmsKeyId, "name" => name, "clientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_kx_scaling_group(availability_zone_id, client_token, environment_id, host_type, scaling_group_name)
    create_kx_scaling_group(availability_zone_id, client_token, environment_id, host_type, scaling_group_name, params::Dict{String,<:Any})

Creates a new scaling group.

# Arguments
- `availability_zone_id`: The identifier of the availability zones.
- `client_token`: A token that ensures idempotency. This token expires in 10 minutes.
- `environment_id`: A unique identifier for the kdb environment, where you want to create
  the scaling group.
- `host_type`:  The memory and CPU capabilities of the scaling group host on which FinSpace
  Managed kdb clusters will be placed. You can add one of the following values:
  kx.sg.4xlarge – The host type with a configuration of 108 GiB memory and 16 vCPUs.
  kx.sg.8xlarge – The host type with a configuration of 216 GiB memory and 32 vCPUs.
  kx.sg.16xlarge – The host type with a configuration of 432 GiB memory and 64 vCPUs.
  kx.sg.32xlarge – The host type with a configuration of 864 GiB memory and 128 vCPUs.
  kx.sg1.16xlarge – The host type with a configuration of 1949 GiB memory and 64 vCPUs.
  kx.sg1.24xlarge – The host type with a configuration of 2948 GiB memory and 96 vCPUs.
- `scaling_group_name`: A unique identifier for the kdb scaling group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tags"`:  A list of key-value pairs to label the scaling group. You can add up to 50
  tags to a scaling group.
"""
function create_kx_scaling_group(
    availabilityZoneId,
    clientToken,
    environmentId,
    hostType,
    scalingGroupName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "POST",
        "/kx/environments/$(environmentId)/scalingGroups",
        Dict{String,Any}(
            "availabilityZoneId" => availabilityZoneId,
            "clientToken" => clientToken,
            "hostType" => hostType,
            "scalingGroupName" => scalingGroupName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_kx_scaling_group(
    availabilityZoneId,
    clientToken,
    environmentId,
    hostType,
    scalingGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "POST",
        "/kx/environments/$(environmentId)/scalingGroups",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "availabilityZoneId" => availabilityZoneId,
                    "clientToken" => clientToken,
                    "hostType" => hostType,
                    "scalingGroupName" => scalingGroupName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_kx_user(environment_id, iam_role, user_name)
    create_kx_user(environment_id, iam_role, user_name, params::Dict{String,<:Any})

Creates a user in FinSpace kdb environment with an associated IAM role.

# Arguments
- `environment_id`: A unique identifier for the kdb environment where you want to create a
  user.
- `iam_role`: The IAM role ARN that will be associated with the user.
- `user_name`: A unique identifier for the user.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A token that ensures idempotency. This token expires in 10 minutes.
- `"tags"`: A list of key-value pairs to label the user. You can add up to 50 tags to a
  user.
"""
function create_kx_user(
    environmentId, iamRole, userName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return finspace(
        "POST",
        "/kx/environments/$(environmentId)/users",
        Dict{String,Any}(
            "iamRole" => iamRole, "userName" => userName, "clientToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_kx_user(
    environmentId,
    iamRole,
    userName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "POST",
        "/kx/environments/$(environmentId)/users",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "iamRole" => iamRole,
                    "userName" => userName,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_kx_volume(availability_zone_ids, az_mode, environment_id, volume_name, volume_type)
    create_kx_volume(availability_zone_ids, az_mode, environment_id, volume_name, volume_type, params::Dict{String,<:Any})

 Creates a new volume with a specific amount of throughput and storage capacity.

# Arguments
- `availability_zone_ids`: The identifier of the availability zones.
- `az_mode`: The number of availability zones you want to assign per volume. Currently,
  FinSpace only supports SINGLE for volumes. This places dataview in a single AZ.
- `environment_id`: A unique identifier for the kdb environment, whose clusters can attach
  to the volume.
- `volume_name`: A unique identifier for the volume.
- `volume_type`:  The type of file system volume. Currently, FinSpace only supports NAS_1
  volume type. When you select NAS_1 volume type, you must also provide nas1Configuration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A token that ensures idempotency. This token expires in 10 minutes.
- `"description"`:  A description of the volume.
- `"nas1Configuration"`:  Specifies the configuration for the Network attached storage
  (NAS_1) file system volume. This parameter is required when you choose volumeType as NAS_1.
- `"tags"`:  A list of key-value pairs to label the volume. You can add up to 50 tags to a
  volume.
"""
function create_kx_volume(
    availabilityZoneIds,
    azMode,
    environmentId,
    volumeName,
    volumeType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "POST",
        "/kx/environments/$(environmentId)/kxvolumes",
        Dict{String,Any}(
            "availabilityZoneIds" => availabilityZoneIds,
            "azMode" => azMode,
            "volumeName" => volumeName,
            "volumeType" => volumeType,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_kx_volume(
    availabilityZoneIds,
    azMode,
    environmentId,
    volumeName,
    volumeType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "POST",
        "/kx/environments/$(environmentId)/kxvolumes",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "availabilityZoneIds" => availabilityZoneIds,
                    "azMode" => azMode,
                    "volumeName" => volumeName,
                    "volumeType" => volumeType,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_environment(environment_id)
    delete_environment(environment_id, params::Dict{String,<:Any})

Delete an FinSpace environment.

# Arguments
- `environment_id`: The identifier for the FinSpace environment.

"""
function delete_environment(
    environmentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return finspace(
        "DELETE",
        "/environment/$(environmentId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_environment(
    environmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "DELETE",
        "/environment/$(environmentId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_kx_cluster(cluster_name, environment_id)
    delete_kx_cluster(cluster_name, environment_id, params::Dict{String,<:Any})

Deletes a kdb cluster.

# Arguments
- `cluster_name`: The name of the cluster that you want to delete.
- `environment_id`: A unique identifier for the kdb environment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A token that ensures idempotency. This token expires in 10 minutes.
"""
function delete_kx_cluster(
    clusterName, environmentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return finspace(
        "DELETE",
        "/kx/environments/$(environmentId)/clusters/$(clusterName)",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_kx_cluster(
    clusterName,
    environmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "DELETE",
        "/kx/environments/$(environmentId)/clusters/$(clusterName)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_kx_cluster_node(cluster_name, environment_id, node_id)
    delete_kx_cluster_node(cluster_name, environment_id, node_id, params::Dict{String,<:Any})

Deletes the specified nodes from a cluster.

# Arguments
- `cluster_name`: The name of the cluster, for which you want to delete the nodes.
- `environment_id`: A unique identifier for the kdb environment.
- `node_id`: A unique identifier for the node that you want to delete.

"""
function delete_kx_cluster_node(
    clusterName, environmentId, nodeId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return finspace(
        "DELETE",
        "/kx/environments/$(environmentId)/clusters/$(clusterName)/nodes/$(nodeId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_kx_cluster_node(
    clusterName,
    environmentId,
    nodeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "DELETE",
        "/kx/environments/$(environmentId)/clusters/$(clusterName)/nodes/$(nodeId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_kx_database(client_token, database_name, environment_id)
    delete_kx_database(client_token, database_name, environment_id, params::Dict{String,<:Any})

Deletes the specified database and all of its associated data. This action is irreversible.
You must copy any data out of the database before deleting it if the data is to be retained.

# Arguments
- `client_token`: A token that ensures idempotency. This token expires in 10 minutes.
- `database_name`: The name of the kdb database that you want to delete.
- `environment_id`: A unique identifier for the kdb environment.

"""
function delete_kx_database(
    clientToken,
    databaseName,
    environmentId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "DELETE",
        "/kx/environments/$(environmentId)/databases/$(databaseName)",
        Dict{String,Any}("clientToken" => clientToken);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_kx_database(
    clientToken,
    databaseName,
    environmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "DELETE",
        "/kx/environments/$(environmentId)/databases/$(databaseName)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => clientToken), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_kx_dataview(client_token, database_name, dataview_name, environment_id)
    delete_kx_dataview(client_token, database_name, dataview_name, environment_id, params::Dict{String,<:Any})

 Deletes the specified dataview. Before deleting a dataview, make sure that it is not in
use by any cluster.

# Arguments
- `client_token`: A token that ensures idempotency. This token expires in 10 minutes.
- `database_name`: The name of the database whose dataview you want to delete.
- `dataview_name`: The name of the dataview that you want to delete.
- `environment_id`: A unique identifier for the kdb environment, from where you want to
  delete the dataview.

"""
function delete_kx_dataview(
    clientToken,
    databaseName,
    dataviewName,
    environmentId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "DELETE",
        "/kx/environments/$(environmentId)/databases/$(databaseName)/dataviews/$(dataviewName)",
        Dict{String,Any}("clientToken" => clientToken);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_kx_dataview(
    clientToken,
    databaseName,
    dataviewName,
    environmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "DELETE",
        "/kx/environments/$(environmentId)/databases/$(databaseName)/dataviews/$(dataviewName)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => clientToken), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_kx_environment(environment_id)
    delete_kx_environment(environment_id, params::Dict{String,<:Any})

Deletes the kdb environment. This action is irreversible. Deleting a kdb environment will
remove all the associated data and any services running in it.

# Arguments
- `environment_id`: A unique identifier for the kdb environment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A token that ensures idempotency. This token expires in 10 minutes.
"""
function delete_kx_environment(
    environmentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return finspace(
        "DELETE",
        "/kx/environments/$(environmentId)",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_kx_environment(
    environmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "DELETE",
        "/kx/environments/$(environmentId)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_kx_scaling_group(environment_id, scaling_group_name)
    delete_kx_scaling_group(environment_id, scaling_group_name, params::Dict{String,<:Any})

 Deletes the specified scaling group. This action is irreversible. You cannot delete a
scaling group until all the clusters running on it have been deleted.

# Arguments
- `environment_id`: A unique identifier for the kdb environment, from where you want to
  delete the dataview.
- `scaling_group_name`: A unique identifier for the kdb scaling group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A token that ensures idempotency. This token expires in 10 minutes.
"""
function delete_kx_scaling_group(
    environmentId, scalingGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return finspace(
        "DELETE",
        "/kx/environments/$(environmentId)/scalingGroups/$(scalingGroupName)",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_kx_scaling_group(
    environmentId,
    scalingGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "DELETE",
        "/kx/environments/$(environmentId)/scalingGroups/$(scalingGroupName)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_kx_user(environment_id, user_name)
    delete_kx_user(environment_id, user_name, params::Dict{String,<:Any})

Deletes a user in the specified kdb environment.

# Arguments
- `environment_id`: A unique identifier for the kdb environment.
- `user_name`: A unique identifier for the user that you want to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A token that ensures idempotency. This token expires in 10 minutes.
"""
function delete_kx_user(
    environmentId, userName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return finspace(
        "DELETE",
        "/kx/environments/$(environmentId)/users/$(userName)",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_kx_user(
    environmentId,
    userName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "DELETE",
        "/kx/environments/$(environmentId)/users/$(userName)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_kx_volume(environment_id, volume_name)
    delete_kx_volume(environment_id, volume_name, params::Dict{String,<:Any})

 Deletes a volume. You can only delete a volume if it's not attached to a cluster or a
dataview. When a volume is deleted, any data on the volume is lost. This action is
irreversible.

# Arguments
- `environment_id`: A unique identifier for the kdb environment, whose clusters can attach
  to the volume.
- `volume_name`:  The name of the volume that you want to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A token that ensures idempotency. This token expires in 10 minutes.
"""
function delete_kx_volume(
    environmentId, volumeName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return finspace(
        "DELETE",
        "/kx/environments/$(environmentId)/kxvolumes/$(volumeName)",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_kx_volume(
    environmentId,
    volumeName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "DELETE",
        "/kx/environments/$(environmentId)/kxvolumes/$(volumeName)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_environment(environment_id)
    get_environment(environment_id, params::Dict{String,<:Any})

Returns the FinSpace environment object.

# Arguments
- `environment_id`: The identifier of the FinSpace environment.

"""
function get_environment(environmentId; aws_config::AbstractAWSConfig=current_aws_config())
    return finspace(
        "GET",
        "/environment/$(environmentId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_environment(
    environmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "GET",
        "/environment/$(environmentId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_kx_changeset(changeset_id, database_name, environment_id)
    get_kx_changeset(changeset_id, database_name, environment_id, params::Dict{String,<:Any})

Returns information about a kdb changeset.

# Arguments
- `changeset_id`: A unique identifier of the changeset for which you want to retrieve data.
- `database_name`: The name of the kdb database.
- `environment_id`: A unique identifier for the kdb environment.

"""
function get_kx_changeset(
    changesetId,
    databaseName,
    environmentId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "GET",
        "/kx/environments/$(environmentId)/databases/$(databaseName)/changesets/$(changesetId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_kx_changeset(
    changesetId,
    databaseName,
    environmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "GET",
        "/kx/environments/$(environmentId)/databases/$(databaseName)/changesets/$(changesetId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_kx_cluster(cluster_name, environment_id)
    get_kx_cluster(cluster_name, environment_id, params::Dict{String,<:Any})

Retrieves information about a kdb cluster.

# Arguments
- `cluster_name`: The name of the cluster that you want to retrieve.
- `environment_id`: A unique identifier for the kdb environment.

"""
function get_kx_cluster(
    clusterName, environmentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return finspace(
        "GET",
        "/kx/environments/$(environmentId)/clusters/$(clusterName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_kx_cluster(
    clusterName,
    environmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "GET",
        "/kx/environments/$(environmentId)/clusters/$(clusterName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_kx_connection_string(cluster_name, environment_id, user_arn)
    get_kx_connection_string(cluster_name, environment_id, user_arn, params::Dict{String,<:Any})

Retrieves a connection string for a user to connect to a kdb cluster. You must call this
API using the same role that you have defined while creating a user.

# Arguments
- `cluster_name`: A name of the kdb cluster.
- `environment_id`: A unique identifier for the kdb environment.
- `user_arn`:  The Amazon Resource Name (ARN) that identifies the user. For more
  information about ARNs and how to use ARNs in policies, see IAM Identifiers in the IAM User
  Guide.

"""
function get_kx_connection_string(
    clusterName, environmentId, userArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return finspace(
        "GET",
        "/kx/environments/$(environmentId)/connectionString",
        Dict{String,Any}("clusterName" => clusterName, "userArn" => userArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_kx_connection_string(
    clusterName,
    environmentId,
    userArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "GET",
        "/kx/environments/$(environmentId)/connectionString",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("clusterName" => clusterName, "userArn" => userArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_kx_database(database_name, environment_id)
    get_kx_database(database_name, environment_id, params::Dict{String,<:Any})

Returns database information for the specified environment ID.

# Arguments
- `database_name`: The name of the kdb database.
- `environment_id`: A unique identifier for the kdb environment.

"""
function get_kx_database(
    databaseName, environmentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return finspace(
        "GET",
        "/kx/environments/$(environmentId)/databases/$(databaseName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_kx_database(
    databaseName,
    environmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "GET",
        "/kx/environments/$(environmentId)/databases/$(databaseName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_kx_dataview(database_name, dataview_name, environment_id)
    get_kx_dataview(database_name, dataview_name, environment_id, params::Dict{String,<:Any})

 Retrieves details of the dataview.

# Arguments
- `database_name`:  The name of the database where you created the dataview.
- `dataview_name`: A unique identifier for the dataview.
- `environment_id`: A unique identifier for the kdb environment, from where you want to
  retrieve the dataview details.

"""
function get_kx_dataview(
    databaseName,
    dataviewName,
    environmentId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "GET",
        "/kx/environments/$(environmentId)/databases/$(databaseName)/dataviews/$(dataviewName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_kx_dataview(
    databaseName,
    dataviewName,
    environmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "GET",
        "/kx/environments/$(environmentId)/databases/$(databaseName)/dataviews/$(dataviewName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_kx_environment(environment_id)
    get_kx_environment(environment_id, params::Dict{String,<:Any})

Retrieves all the information for the specified kdb environment.

# Arguments
- `environment_id`: A unique identifier for the kdb environment.

"""
function get_kx_environment(
    environmentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return finspace(
        "GET",
        "/kx/environments/$(environmentId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_kx_environment(
    environmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "GET",
        "/kx/environments/$(environmentId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_kx_scaling_group(environment_id, scaling_group_name)
    get_kx_scaling_group(environment_id, scaling_group_name, params::Dict{String,<:Any})

 Retrieves details of a scaling group.

# Arguments
- `environment_id`: A unique identifier for the kdb environment.
- `scaling_group_name`: A unique identifier for the kdb scaling group.

"""
function get_kx_scaling_group(
    environmentId, scalingGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return finspace(
        "GET",
        "/kx/environments/$(environmentId)/scalingGroups/$(scalingGroupName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_kx_scaling_group(
    environmentId,
    scalingGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "GET",
        "/kx/environments/$(environmentId)/scalingGroups/$(scalingGroupName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_kx_user(environment_id, user_name)
    get_kx_user(environment_id, user_name, params::Dict{String,<:Any})

Retrieves information about the specified kdb user.

# Arguments
- `environment_id`: A unique identifier for the kdb environment.
- `user_name`: A unique identifier for the user.

"""
function get_kx_user(
    environmentId, userName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return finspace(
        "GET",
        "/kx/environments/$(environmentId)/users/$(userName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_kx_user(
    environmentId,
    userName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "GET",
        "/kx/environments/$(environmentId)/users/$(userName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_kx_volume(environment_id, volume_name)
    get_kx_volume(environment_id, volume_name, params::Dict{String,<:Any})

 Retrieves the information about the volume.

# Arguments
- `environment_id`: A unique identifier for the kdb environment, whose clusters can attach
  to the volume.
- `volume_name`: A unique identifier for the volume.

"""
function get_kx_volume(
    environmentId, volumeName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return finspace(
        "GET",
        "/kx/environments/$(environmentId)/kxvolumes/$(volumeName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_kx_volume(
    environmentId,
    volumeName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "GET",
        "/kx/environments/$(environmentId)/kxvolumes/$(volumeName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_environments()
    list_environments(params::Dict{String,<:Any})

A list of all of your FinSpace environments.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in this request.
- `"nextToken"`: A token generated by FinSpace that specifies where to continue pagination
  if a previous request was truncated. To get the next set of pages, pass in the
  nextTokennextToken value from the response object of the previous page call.
"""
function list_environments(; aws_config::AbstractAWSConfig=current_aws_config())
    return finspace(
        "GET", "/environment"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_environments(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return finspace(
        "GET",
        "/environment",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_kx_changesets(database_name, environment_id)
    list_kx_changesets(database_name, environment_id, params::Dict{String,<:Any})

Returns a list of all the changesets for a database.

# Arguments
- `database_name`: The name of the kdb database.
- `environment_id`: A unique identifier for the kdb environment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in this request.
- `"nextToken"`: A token that indicates where a results page should begin.
"""
function list_kx_changesets(
    databaseName, environmentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return finspace(
        "GET",
        "/kx/environments/$(environmentId)/databases/$(databaseName)/changesets";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_kx_changesets(
    databaseName,
    environmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "GET",
        "/kx/environments/$(environmentId)/databases/$(databaseName)/changesets",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_kx_cluster_nodes(cluster_name, environment_id)
    list_kx_cluster_nodes(cluster_name, environment_id, params::Dict{String,<:Any})

Lists all the nodes in a kdb cluster.

# Arguments
- `cluster_name`: A unique name for the cluster.
- `environment_id`: A unique identifier for the kdb environment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in this request.
- `"nextToken"`: A token that indicates where a results page should begin.
"""
function list_kx_cluster_nodes(
    clusterName, environmentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return finspace(
        "GET",
        "/kx/environments/$(environmentId)/clusters/$(clusterName)/nodes";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_kx_cluster_nodes(
    clusterName,
    environmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "GET",
        "/kx/environments/$(environmentId)/clusters/$(clusterName)/nodes",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_kx_clusters(environment_id)
    list_kx_clusters(environment_id, params::Dict{String,<:Any})

Returns a list of clusters.

# Arguments
- `environment_id`: A unique identifier for the kdb environment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clusterType"`: Specifies the type of KDB database that is being created. The following
  types are available:    HDB – A Historical Database. The data is only accessible with
  read-only permissions from one of the FinSpace managed kdb databases mounted to the
  cluster.   RDB – A Realtime Database. This type of database captures all the data from a
  ticker plant and stores it in memory until the end of day, after which it writes all of its
  data to a disk and reloads the HDB. This cluster type requires local storage for temporary
  storage of data during the savedown process. If you specify this field in your request, you
  must provide the savedownStorageConfiguration parameter.   GATEWAY – A gateway cluster
  allows you to access data across processes in kdb systems. It allows you to create your own
  routing logic using the initialization scripts and custom code. This type of cluster does
  not require a writable local storage.   GP – A general purpose cluster allows you to
  quickly iterate on code during development by granting greater access to system commands
  and enabling a fast reload of custom code. This cluster type can optionally mount databases
  including cache and savedown storage. For this cluster type, the node count is fixed at 1.
  It does not support autoscaling and supports only SINGLE AZ mode.   Tickerplant – A
  tickerplant cluster allows you to subscribe to feed handlers based on IAM permissions. It
  can publish to RDBs, other Tickerplants, and real-time subscribers (RTS). Tickerplants can
  persist messages to log, which is readable by any RDB environment. It supports only
  single-node that is only one kdb process.
- `"maxResults"`: The maximum number of results to return in this request.
- `"nextToken"`: A token that indicates where a results page should begin.
"""
function list_kx_clusters(environmentId; aws_config::AbstractAWSConfig=current_aws_config())
    return finspace(
        "GET",
        "/kx/environments/$(environmentId)/clusters";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_kx_clusters(
    environmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "GET",
        "/kx/environments/$(environmentId)/clusters",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_kx_databases(environment_id)
    list_kx_databases(environment_id, params::Dict{String,<:Any})

Returns a list of all the databases in the kdb environment.

# Arguments
- `environment_id`: A unique identifier for the kdb environment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in this request.
- `"nextToken"`: A token that indicates where a results page should begin.
"""
function list_kx_databases(
    environmentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return finspace(
        "GET",
        "/kx/environments/$(environmentId)/databases";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_kx_databases(
    environmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "GET",
        "/kx/environments/$(environmentId)/databases",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_kx_dataviews(database_name, environment_id)
    list_kx_dataviews(database_name, environment_id, params::Dict{String,<:Any})

 Returns a list of all the dataviews in the database.

# Arguments
- `database_name`:  The name of the database where the dataviews were created.
- `environment_id`: A unique identifier for the kdb environment, for which you want to
  retrieve a list of dataviews.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in this request.
- `"nextToken"`:  A token that indicates where a results page should begin.
"""
function list_kx_dataviews(
    databaseName, environmentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return finspace(
        "GET",
        "/kx/environments/$(environmentId)/databases/$(databaseName)/dataviews";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_kx_dataviews(
    databaseName,
    environmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "GET",
        "/kx/environments/$(environmentId)/databases/$(databaseName)/dataviews",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_kx_environments()
    list_kx_environments(params::Dict{String,<:Any})

Returns a list of kdb environments created in an account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in this request.
- `"nextToken"`: A token that indicates where a results page should begin.
"""
function list_kx_environments(; aws_config::AbstractAWSConfig=current_aws_config())
    return finspace(
        "GET", "/kx/environments"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_kx_environments(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return finspace(
        "GET",
        "/kx/environments",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_kx_scaling_groups(environment_id)
    list_kx_scaling_groups(environment_id, params::Dict{String,<:Any})

 Returns a list of scaling groups in a kdb environment.

# Arguments
- `environment_id`: A unique identifier for the kdb environment, for which you want to
  retrieve a list of scaling groups.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in this request.
- `"nextToken"`:  A token that indicates where a results page should begin.
"""
function list_kx_scaling_groups(
    environmentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return finspace(
        "GET",
        "/kx/environments/$(environmentId)/scalingGroups";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_kx_scaling_groups(
    environmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "GET",
        "/kx/environments/$(environmentId)/scalingGroups",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_kx_users(environment_id)
    list_kx_users(environment_id, params::Dict{String,<:Any})

Lists all the users in a kdb environment.

# Arguments
- `environment_id`: A unique identifier for the kdb environment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in this request.
- `"nextToken"`: A token that indicates where a results page should begin.
"""
function list_kx_users(environmentId; aws_config::AbstractAWSConfig=current_aws_config())
    return finspace(
        "GET",
        "/kx/environments/$(environmentId)/users";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_kx_users(
    environmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "GET",
        "/kx/environments/$(environmentId)/users",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_kx_volumes(environment_id)
    list_kx_volumes(environment_id, params::Dict{String,<:Any})

 Lists all the volumes in a kdb environment.

# Arguments
- `environment_id`: A unique identifier for the kdb environment, whose clusters can attach
  to the volume.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in this request.
- `"nextToken"`: A token that indicates where a results page should begin.
- `"volumeType"`:  The type of file system volume. Currently, FinSpace only supports NAS_1
  volume type.
"""
function list_kx_volumes(environmentId; aws_config::AbstractAWSConfig=current_aws_config())
    return finspace(
        "GET",
        "/kx/environments/$(environmentId)/kxvolumes";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_kx_volumes(
    environmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "GET",
        "/kx/environments/$(environmentId)/kxvolumes",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

A list of all tags for a resource.

# Arguments
- `resource_arn`: The Amazon Resource Name of the resource.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return finspace(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds metadata tags to a FinSpace resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) for the resource.
- `tags`: One or more tags to be assigned to the resource.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return finspace(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes metadata tags from a FinSpace resource.

# Arguments
- `resource_arn`: A FinSpace resource from which you want to remove a tag or tags. The
  value for this parameter is an Amazon Resource Name (ARN).
- `tag_keys`: The tag keys (names) of one or more tags to be removed.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return finspace(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_environment(environment_id)
    update_environment(environment_id, params::Dict{String,<:Any})

Update your FinSpace environment.

# Arguments
- `environment_id`: The identifier of the FinSpace environment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description of the environment.
- `"federationMode"`: Authentication mode for the environment.    FEDERATED - Users access
  FinSpace through Single Sign On (SSO) via your Identity provider.    LOCAL - Users access
  FinSpace via email and password managed within the FinSpace environment.
- `"federationParameters"`:
- `"name"`: The name of the environment.
"""
function update_environment(
    environmentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return finspace(
        "PUT",
        "/environment/$(environmentId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_environment(
    environmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "PUT",
        "/environment/$(environmentId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_kx_cluster_code_configuration(cluster_name, code, environment_id)
    update_kx_cluster_code_configuration(cluster_name, code, environment_id, params::Dict{String,<:Any})

 Allows you to update code configuration on a running cluster. By using this API you can
update the code, the initialization script path, and the command line arguments for a
specific cluster. The configuration that you want to update will override any existing
configurations on the cluster.

# Arguments
- `cluster_name`: The name of the cluster.
- `code`:
- `environment_id`:  A unique identifier of the kdb environment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A token that ensures idempotency. This token expires in 10 minutes.
- `"commandLineArguments"`: Specifies the key-value pairs to make them available inside the
  cluster. You cannot update this parameter for a NO_RESTART deployment.
- `"deploymentConfiguration"`:  The configuration that allows you to choose how you want to
  update the code on a cluster.
- `"initializationScript"`: Specifies a Q program that will be run at launch of a cluster.
  It is a relative path within .zip file that contains the custom code, which will be loaded
  on the cluster. It must include the file name itself. For example, somedir/init.q. You
  cannot update this parameter for a NO_RESTART deployment.
"""
function update_kx_cluster_code_configuration(
    clusterName, code, environmentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return finspace(
        "PUT",
        "/kx/environments/$(environmentId)/clusters/$(clusterName)/configuration/code",
        Dict{String,Any}("code" => code, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_kx_cluster_code_configuration(
    clusterName,
    code,
    environmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "PUT",
        "/kx/environments/$(environmentId)/clusters/$(clusterName)/configuration/code",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("code" => code, "clientToken" => string(uuid4())),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_kx_cluster_databases(cluster_name, databases, environment_id)
    update_kx_cluster_databases(cluster_name, databases, environment_id, params::Dict{String,<:Any})

Updates the databases mounted on a kdb cluster, which includes the changesetId and all the
dbPaths to be cached. This API does not allow you to change a database name or add a
database if you created a cluster without one.  Using this API you can point a cluster to a
different changeset and modify a list of partitions being cached.

# Arguments
- `cluster_name`: A unique name for the cluster that you want to modify.
- `databases`:  The structure of databases mounted on the cluster.
- `environment_id`: The unique identifier of a kdb environment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A token that ensures idempotency. This token expires in 10 minutes.
- `"deploymentConfiguration"`:  The configuration that allows you to choose how you want to
  update the databases on a cluster.
"""
function update_kx_cluster_databases(
    clusterName,
    databases,
    environmentId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "PUT",
        "/kx/environments/$(environmentId)/clusters/$(clusterName)/configuration/databases",
        Dict{String,Any}("databases" => databases, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_kx_cluster_databases(
    clusterName,
    databases,
    environmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "PUT",
        "/kx/environments/$(environmentId)/clusters/$(clusterName)/configuration/databases",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "databases" => databases, "clientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_kx_database(client_token, database_name, environment_id)
    update_kx_database(client_token, database_name, environment_id, params::Dict{String,<:Any})

Updates information for the given kdb database.

# Arguments
- `client_token`: A token that ensures idempotency. This token expires in 10 minutes.
- `database_name`: The name of the kdb database.
- `environment_id`: A unique identifier for the kdb environment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A description of the database.
"""
function update_kx_database(
    clientToken,
    databaseName,
    environmentId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "PUT",
        "/kx/environments/$(environmentId)/databases/$(databaseName)",
        Dict{String,Any}("clientToken" => clientToken);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_kx_database(
    clientToken,
    databaseName,
    environmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "PUT",
        "/kx/environments/$(environmentId)/databases/$(databaseName)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => clientToken), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_kx_dataview(client_token, database_name, dataview_name, environment_id)
    update_kx_dataview(client_token, database_name, dataview_name, environment_id, params::Dict{String,<:Any})

 Updates the specified dataview. The dataviews get automatically updated when any new
changesets are ingested. Each update of the dataview creates a new version, including
changeset details and cache configurations

# Arguments
- `client_token`: A token that ensures idempotency. This token expires in 10 minutes.
- `database_name`:  The name of the database.
- `dataview_name`: The name of the dataview that you want to update.
- `environment_id`: A unique identifier for the kdb environment, where you want to update
  the dataview.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"changesetId"`: A unique identifier for the changeset.
- `"description"`:  The description for a dataview.
- `"segmentConfigurations"`:  The configuration that contains the database path of the data
  that you want to place on each selected volume. Each segment must have a unique database
  path for each volume. If you do not explicitly specify any database path for a volume, they
  are accessible from the cluster through the default S3/object store segment.
"""
function update_kx_dataview(
    clientToken,
    databaseName,
    dataviewName,
    environmentId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "PUT",
        "/kx/environments/$(environmentId)/databases/$(databaseName)/dataviews/$(dataviewName)",
        Dict{String,Any}("clientToken" => clientToken);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_kx_dataview(
    clientToken,
    databaseName,
    dataviewName,
    environmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "PUT",
        "/kx/environments/$(environmentId)/databases/$(databaseName)/dataviews/$(dataviewName)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => clientToken), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_kx_environment(environment_id)
    update_kx_environment(environment_id, params::Dict{String,<:Any})

Updates information for the given kdb environment.

# Arguments
- `environment_id`: A unique identifier for the kdb environment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A token that ensures idempotency. This token expires in 10 minutes.
- `"description"`: A description of the kdb environment.
- `"name"`: The name of the kdb environment.
"""
function update_kx_environment(
    environmentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return finspace(
        "PUT",
        "/kx/environments/$(environmentId)",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_kx_environment(
    environmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "PUT",
        "/kx/environments/$(environmentId)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_kx_environment_network(environment_id)
    update_kx_environment_network(environment_id, params::Dict{String,<:Any})

Updates environment network to connect to your internal network by using a transit gateway.
This API supports request to create a transit gateway attachment from FinSpace VPC to your
transit gateway ID and create a custom Route-53 outbound resolvers. Once you send a request
to update a network, you cannot change it again. Network update might require termination
of any clusters that are running in the existing network.

# Arguments
- `environment_id`: A unique identifier for the kdb environment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A token that ensures idempotency. This token expires in 10 minutes.
- `"customDNSConfiguration"`: A list of DNS server name and server IP. This is used to set
  up Route-53 outbound resolvers.
- `"transitGatewayConfiguration"`: Specifies the transit gateway and network configuration
  to connect the kdb environment to an internal network.
"""
function update_kx_environment_network(
    environmentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return finspace(
        "PUT",
        "/kx/environments/$(environmentId)/network",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_kx_environment_network(
    environmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "PUT",
        "/kx/environments/$(environmentId)/network",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_kx_user(environment_id, iam_role, user_name)
    update_kx_user(environment_id, iam_role, user_name, params::Dict{String,<:Any})

Updates the user details. You can only update the IAM role associated with a user.

# Arguments
- `environment_id`: A unique identifier for the kdb environment.
- `iam_role`: The IAM role ARN that is associated with the user.
- `user_name`: A unique identifier for the user.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A token that ensures idempotency. This token expires in 10 minutes.
"""
function update_kx_user(
    environmentId, iamRole, userName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return finspace(
        "PUT",
        "/kx/environments/$(environmentId)/users/$(userName)",
        Dict{String,Any}("iamRole" => iamRole, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_kx_user(
    environmentId,
    iamRole,
    userName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "PUT",
        "/kx/environments/$(environmentId)/users/$(userName)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("iamRole" => iamRole, "clientToken" => string(uuid4())),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_kx_volume(environment_id, volume_name)
    update_kx_volume(environment_id, volume_name, params::Dict{String,<:Any})

 Updates the throughput or capacity of a volume. During the update process, the filesystem
might be unavailable for a few minutes. You can retry any operations after the update is
complete.

# Arguments
- `environment_id`: A unique identifier for the kdb environment where you created the
  storage volume.
- `volume_name`:  A unique identifier for the volume.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A token that ensures idempotency. This token expires in 10 minutes.
- `"description"`:  A description of the volume.
- `"nas1Configuration"`:  Specifies the configuration for the Network attached storage
  (NAS_1) file system volume.
"""
function update_kx_volume(
    environmentId, volumeName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return finspace(
        "PATCH",
        "/kx/environments/$(environmentId)/kxvolumes/$(volumeName)",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_kx_volume(
    environmentId,
    volumeName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace(
        "PATCH",
        "/kx/environments/$(environmentId)/kxvolumes/$(volumeName)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: trustedadvisor
using AWS.Compat
using AWS.UUIDs

"""
    batch_update_recommendation_resource_exclusion(recommendation_resource_exclusions)
    batch_update_recommendation_resource_exclusion(recommendation_resource_exclusions, params::Dict{String,<:Any})

Update one or more exclusion status for a list of recommendation resources

# Arguments
- `recommendation_resource_exclusions`: A list of recommendation resource ARNs and
  exclusion status to update

"""
function batch_update_recommendation_resource_exclusion(
    recommendationResourceExclusions; aws_config::AbstractAWSConfig=current_aws_config()
)
    return trustedadvisor(
        "PUT",
        "/v1/batch-update-recommendation-resource-exclusion",
        Dict{String,Any}(
            "recommendationResourceExclusions" => recommendationResourceExclusions
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_update_recommendation_resource_exclusion(
    recommendationResourceExclusions,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return trustedadvisor(
        "PUT",
        "/v1/batch-update-recommendation-resource-exclusion",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "recommendationResourceExclusions" => recommendationResourceExclusions
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_organization_recommendation(organization_recommendation_identifier)
    get_organization_recommendation(organization_recommendation_identifier, params::Dict{String,<:Any})

Get a specific recommendation within an AWS Organizations organization. This API supports
only prioritized recommendations.

# Arguments
- `organization_recommendation_identifier`: The Recommendation identifier

"""
function get_organization_recommendation(
    organizationRecommendationIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return trustedadvisor(
        "GET",
        "/v1/organization-recommendations/$(organizationRecommendationIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_organization_recommendation(
    organizationRecommendationIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return trustedadvisor(
        "GET",
        "/v1/organization-recommendations/$(organizationRecommendationIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_recommendation(recommendation_identifier)
    get_recommendation(recommendation_identifier, params::Dict{String,<:Any})

Get a specific Recommendation

# Arguments
- `recommendation_identifier`: The Recommendation identifier

"""
function get_recommendation(
    recommendationIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return trustedadvisor(
        "GET",
        "/v1/recommendations/$(recommendationIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_recommendation(
    recommendationIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return trustedadvisor(
        "GET",
        "/v1/recommendations/$(recommendationIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_checks()
    list_checks(params::Dict{String,<:Any})

List a filterable set of Checks

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"awsService"`: The aws service associated with the check
- `"language"`: The ISO 639-1 code for the language that you want your checks to appear in.
- `"maxResults"`: The maximum number of results to return per page.
- `"nextToken"`: The token for the next set of results. Use the value returned in the
  previous response in the next request to retrieve the next set of results.
- `"pillar"`: The pillar of the check
- `"source"`: The source of the check
"""
function list_checks(; aws_config::AbstractAWSConfig=current_aws_config())
    return trustedadvisor(
        "GET", "/v1/checks"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_checks(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return trustedadvisor(
        "GET", "/v1/checks", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_organization_recommendation_accounts(organization_recommendation_identifier)
    list_organization_recommendation_accounts(organization_recommendation_identifier, params::Dict{String,<:Any})

Lists the accounts that own the resources for an organization aggregate recommendation.
This API only supports prioritized recommendations.

# Arguments
- `organization_recommendation_identifier`: The Recommendation identifier

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"affectedAccountId"`: An account affected by this organization recommendation
- `"maxResults"`: The maximum number of results to return per page.
- `"nextToken"`: The token for the next set of results. Use the value returned in the
  previous response in the next request to retrieve the next set of results.
"""
function list_organization_recommendation_accounts(
    organizationRecommendationIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return trustedadvisor(
        "GET",
        "/v1/organization-recommendations/$(organizationRecommendationIdentifier)/accounts";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_organization_recommendation_accounts(
    organizationRecommendationIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return trustedadvisor(
        "GET",
        "/v1/organization-recommendations/$(organizationRecommendationIdentifier)/accounts",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_organization_recommendation_resources(organization_recommendation_identifier)
    list_organization_recommendation_resources(organization_recommendation_identifier, params::Dict{String,<:Any})

List Resources of a Recommendation within an Organization. This API only supports
prioritized recommendations.

# Arguments
- `organization_recommendation_identifier`: The AWS Organization organization's
  Recommendation identifier

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"affectedAccountId"`: An account affected by this organization recommendation
- `"exclusionStatus"`: The exclusion status of the resource
- `"maxResults"`: The maximum number of results to return per page.
- `"nextToken"`: The token for the next set of results. Use the value returned in the
  previous response in the next request to retrieve the next set of results.
- `"regionCode"`: The AWS Region code of the resource
- `"status"`: The status of the resource
"""
function list_organization_recommendation_resources(
    organizationRecommendationIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return trustedadvisor(
        "GET",
        "/v1/organization-recommendations/$(organizationRecommendationIdentifier)/resources";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_organization_recommendation_resources(
    organizationRecommendationIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return trustedadvisor(
        "GET",
        "/v1/organization-recommendations/$(organizationRecommendationIdentifier)/resources",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_organization_recommendations()
    list_organization_recommendations(params::Dict{String,<:Any})

List a filterable set of Recommendations within an Organization. This API only supports
prioritized recommendations.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"afterLastUpdatedAt"`: After the last update of the Recommendation
- `"awsService"`: The aws service associated with the Recommendation
- `"beforeLastUpdatedAt"`: Before the last update of the Recommendation
- `"checkIdentifier"`: The check identifier of the Recommendation
- `"maxResults"`: The maximum number of results to return per page.
- `"nextToken"`: The token for the next set of results. Use the value returned in the
  previous response in the next request to retrieve the next set of results.
- `"pillar"`: The pillar of the Recommendation
- `"source"`: The source of the Recommendation
- `"status"`: The status of the Recommendation
- `"type"`: The type of the Recommendation
"""
function list_organization_recommendations(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return trustedadvisor(
        "GET",
        "/v1/organization-recommendations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_organization_recommendations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return trustedadvisor(
        "GET",
        "/v1/organization-recommendations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_recommendation_resources(recommendation_identifier)
    list_recommendation_resources(recommendation_identifier, params::Dict{String,<:Any})

List Resources of a Recommendation

# Arguments
- `recommendation_identifier`: The Recommendation identifier

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"exclusionStatus"`: The exclusion status of the resource
- `"maxResults"`: The maximum number of results to return per page.
- `"nextToken"`: The token for the next set of results. Use the value returned in the
  previous response in the next request to retrieve the next set of results.
- `"regionCode"`: The AWS Region code of the resource
- `"status"`: The status of the resource
"""
function list_recommendation_resources(
    recommendationIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return trustedadvisor(
        "GET",
        "/v1/recommendations/$(recommendationIdentifier)/resources";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_recommendation_resources(
    recommendationIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return trustedadvisor(
        "GET",
        "/v1/recommendations/$(recommendationIdentifier)/resources",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_recommendations()
    list_recommendations(params::Dict{String,<:Any})

List a filterable set of Recommendations

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"afterLastUpdatedAt"`: After the last update of the Recommendation
- `"awsService"`: The aws service associated with the Recommendation
- `"beforeLastUpdatedAt"`: Before the last update of the Recommendation
- `"checkIdentifier"`: The check identifier of the Recommendation
- `"maxResults"`: The maximum number of results to return per page.
- `"nextToken"`: The token for the next set of results. Use the value returned in the
  previous response in the next request to retrieve the next set of results.
- `"pillar"`: The pillar of the Recommendation
- `"source"`: The source of the Recommendation
- `"status"`: The status of the Recommendation
- `"type"`: The type of the Recommendation
"""
function list_recommendations(; aws_config::AbstractAWSConfig=current_aws_config())
    return trustedadvisor(
        "GET", "/v1/recommendations"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_recommendations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return trustedadvisor(
        "GET",
        "/v1/recommendations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_organization_recommendation_lifecycle(lifecycle_stage, organization_recommendation_identifier)
    update_organization_recommendation_lifecycle(lifecycle_stage, organization_recommendation_identifier, params::Dict{String,<:Any})

Update the lifecycle of a Recommendation within an Organization. This API only supports
prioritized recommendations.

# Arguments
- `lifecycle_stage`: The new lifecycle stage
- `organization_recommendation_identifier`: The Recommendation identifier for AWS Trusted
  Advisor Priority recommendations

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"updateReason"`: Reason for the lifecycle stage change
- `"updateReasonCode"`: Reason code for the lifecycle state change
"""
function update_organization_recommendation_lifecycle(
    lifecycleStage,
    organizationRecommendationIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return trustedadvisor(
        "PUT",
        "/v1/organization-recommendations/$(organizationRecommendationIdentifier)/lifecycle",
        Dict{String,Any}("lifecycleStage" => lifecycleStage);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_organization_recommendation_lifecycle(
    lifecycleStage,
    organizationRecommendationIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return trustedadvisor(
        "PUT",
        "/v1/organization-recommendations/$(organizationRecommendationIdentifier)/lifecycle",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("lifecycleStage" => lifecycleStage), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_recommendation_lifecycle(lifecycle_stage, recommendation_identifier)
    update_recommendation_lifecycle(lifecycle_stage, recommendation_identifier, params::Dict{String,<:Any})

Update the lifecyle of a Recommendation. This API only supports prioritized recommendations.

# Arguments
- `lifecycle_stage`: The new lifecycle stage
- `recommendation_identifier`: The Recommendation identifier for AWS Trusted Advisor
  Priority recommendations

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"updateReason"`: Reason for the lifecycle stage change
- `"updateReasonCode"`: Reason code for the lifecycle state change
"""
function update_recommendation_lifecycle(
    lifecycleStage,
    recommendationIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return trustedadvisor(
        "PUT",
        "/v1/recommendations/$(recommendationIdentifier)/lifecycle",
        Dict{String,Any}("lifecycleStage" => lifecycleStage);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_recommendation_lifecycle(
    lifecycleStage,
    recommendationIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return trustedadvisor(
        "PUT",
        "/v1/recommendations/$(recommendationIdentifier)/lifecycle",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("lifecycleStage" => lifecycleStage), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWS.jl
using AWS
using AWS.AWSServices: supplychain
using AWS.Compat
using AWS.UUIDs

"""
    create_bill_of_materials_import_job(instance_id, s3uri)
    create_bill_of_materials_import_job(instance_id, s3uri, params::Dict{String,<:Any})

CreateBillOfMaterialsImportJob creates an import job for the Product Bill Of Materials
(BOM) entity. For information on the product_bom entity, see the AWS Supply Chain User
Guide. The CSV file must be located in an Amazon S3 location accessible to AWS Supply
Chain. It is recommended to use the same Amazon S3 bucket created during your AWS Supply
Chain instance creation.

# Arguments
- `instance_id`: The AWS Supply Chain instance identifier.
- `s3uri`: The S3 URI of the CSV file to be imported. The bucket must grant permissions for
  AWS Supply Chain to read the file.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: An idempotency token.
"""
function create_bill_of_materials_import_job end

function create_bill_of_materials_import_job(
    instanceId, s3uri; aws_config::AbstractAWSConfig=current_aws_config()
)
    return supplychain(
        "POST",
        "/api/configuration/instances/$(instanceId)/bill-of-materials-import-jobs",
        Dict{String,Any}("s3uri" => s3uri, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function create_bill_of_materials_import_job(
    instanceId,
    s3uri,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return supplychain(
        "POST",
        "/api/configuration/instances/$(instanceId)/bill-of-materials-import-jobs",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("s3uri" => s3uri, "clientToken" => string(uuid4())),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_bill_of_materials_import_job(instance_id, job_id)
    get_bill_of_materials_import_job(instance_id, job_id, params::Dict{String,<:Any})

Get status and details of a BillOfMaterialsImportJob.

# Arguments
- `instance_id`: The AWS Supply Chain instance identifier.
- `job_id`: The BillOfMaterialsImportJob identifier.

"""
function get_bill_of_materials_import_job end

function get_bill_of_materials_import_job(
    instanceId, jobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return supplychain(
        "GET",
        "/api/configuration/instances/$(instanceId)/bill-of-materials-import-jobs/$(jobId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function get_bill_of_materials_import_job(
    instanceId,
    jobId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return supplychain(
        "GET",
        "/api/configuration/instances/$(instanceId)/bill-of-materials-import-jobs/$(jobId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    send_data_integration_event(data, event_group_id, event_type, instance_id)
    send_data_integration_event(data, event_group_id, event_type, instance_id, params::Dict{String,<:Any})

Send the transactional data payload for the event with real-time data for analysis or
monitoring. The real-time data events are stored in an Amazon Web Services service before
being processed and stored in data lake. New data events are synced with data lake at 5 PM
GMT everyday. The updated transactional data is available in data lake after ingestion.

# Arguments
- `data`: The data payload of the event. For more information on the data schema to use,
  see Data entities supported in AWS Supply Chain .
- `event_group_id`: Event identifier (for example, orderId for InboundOrder) used for data
  sharing or partitioning.
- `event_type`: The data event type.
- `instance_id`: The AWS Supply Chain instance identifier.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: The idempotent client token.
- `"eventTimestamp"`: The event timestamp (in epoch seconds).
"""
function send_data_integration_event end

function send_data_integration_event(
    data,
    eventGroupId,
    eventType,
    instanceId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return supplychain(
        "POST",
        "/api-data/data-integration/instance/$(instanceId)/data-integration-events",
        Dict{String,Any}(
            "data" => data,
            "eventGroupId" => eventGroupId,
            "eventType" => eventType,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function send_data_integration_event(
    data,
    eventGroupId,
    eventType,
    instanceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return supplychain(
        "POST",
        "/api-data/data-integration/instance/$(instanceId)/data-integration-events",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "data" => data,
                    "eventGroupId" => eventGroupId,
                    "eventType" => eventType,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWS.jl
using AWS
using AWS.AWSServices: license_manager_linux_subscriptions
using AWS.Compat
using AWS.UUIDs

"""
    deregister_subscription_provider(subscription_provider_arn)
    deregister_subscription_provider(subscription_provider_arn, params::Dict{String,<:Any})

Remove a third-party subscription provider from the Bring Your Own License (BYOL)
subscriptions registered to your account.

# Arguments
- `subscription_provider_arn`: The Amazon Resource Name (ARN) of the subscription provider
  resource to deregister.

"""
function deregister_subscription_provider end

function deregister_subscription_provider(
    SubscriptionProviderArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return license_manager_linux_subscriptions(
        "POST",
        "/subscription/DeregisterSubscriptionProvider",
        Dict{String,Any}("SubscriptionProviderArn" => SubscriptionProviderArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function deregister_subscription_provider(
    SubscriptionProviderArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager_linux_subscriptions(
        "POST",
        "/subscription/DeregisterSubscriptionProvider",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("SubscriptionProviderArn" => SubscriptionProviderArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_registered_subscription_provider(subscription_provider_arn)
    get_registered_subscription_provider(subscription_provider_arn, params::Dict{String,<:Any})

Get details for a Bring Your Own License (BYOL) subscription that's registered to your
account.

# Arguments
- `subscription_provider_arn`: The Amazon Resource Name (ARN) of the BYOL registration
  resource to get details for.

"""
function get_registered_subscription_provider end

function get_registered_subscription_provider(
    SubscriptionProviderArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return license_manager_linux_subscriptions(
        "POST",
        "/subscription/GetRegisteredSubscriptionProvider",
        Dict{String,Any}("SubscriptionProviderArn" => SubscriptionProviderArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function get_registered_subscription_provider(
    SubscriptionProviderArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager_linux_subscriptions(
        "POST",
        "/subscription/GetRegisteredSubscriptionProvider",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("SubscriptionProviderArn" => SubscriptionProviderArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_service_settings()
    get_service_settings(params::Dict{String,<:Any})

Lists the Linux subscriptions service settings for your account.

"""
function get_service_settings end

function get_service_settings(; aws_config::AbstractAWSConfig=current_aws_config())
    return license_manager_linux_subscriptions(
        "POST",
        "/subscription/GetServiceSettings";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function get_service_settings(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return license_manager_linux_subscriptions(
        "POST",
        "/subscription/GetServiceSettings",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_linux_subscription_instances()
    list_linux_subscription_instances(params::Dict{String,<:Any})

Lists the running Amazon EC2 instances that were discovered with commercial Linux
subscriptions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: An array of structures that you can use to filter the results by your
  specified criteria. For example, you can specify Region in the Name, with the contains
  operator to list all subscriptions that match a partial string in the Value, such as
  us-west. For each filter, you can specify one of the following values for the Name key to
  streamline results:    AccountID     AmiID     DualSubscription     InstanceID
  InstanceType     ProductCode     Region     Status     UsageOperation    For each filter,
  you can use one of the following Operator values to define the behavior of the filter:
  contains     equals     Notequal
- `"MaxResults"`: The maximum items to return in a request.
- `"NextToken"`: A token to specify where to start paginating. This is the nextToken from a
  previously truncated response.
"""
function list_linux_subscription_instances end

function list_linux_subscription_instances(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return license_manager_linux_subscriptions(
        "POST",
        "/subscription/ListLinuxSubscriptionInstances";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function list_linux_subscription_instances(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return license_manager_linux_subscriptions(
        "POST",
        "/subscription/ListLinuxSubscriptionInstances",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_linux_subscriptions()
    list_linux_subscriptions(params::Dict{String,<:Any})

Lists the Linux subscriptions that have been discovered. If you have linked your
organization, the returned results will include data aggregated across your accounts in
Organizations.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: An array of structures that you can use to filter the results to those that
  match one or more sets of key-value pairs that you specify. For example, you can filter by
  the name of Subscription with an optional operator to see subscriptions that match,
  partially match, or don't match a certain subscription's name. The valid names for this
  filter are:    Subscription    The valid Operators for this filter are:    contains
  equals     Notequal
- `"MaxResults"`: The maximum items to return in a request.
- `"NextToken"`: A token to specify where to start paginating. This is the nextToken from a
  previously truncated response.
"""
function list_linux_subscriptions end

function list_linux_subscriptions(; aws_config::AbstractAWSConfig=current_aws_config())
    return license_manager_linux_subscriptions(
        "POST",
        "/subscription/ListLinuxSubscriptions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function list_linux_subscriptions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return license_manager_linux_subscriptions(
        "POST",
        "/subscription/ListLinuxSubscriptions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_registered_subscription_providers()
    list_registered_subscription_providers(params::Dict{String,<:Any})

List Bring Your Own License (BYOL) subscription registration resources for your account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum items to return in a request.
- `"NextToken"`: A token to specify where to start paginating. This is the nextToken from a
  previously truncated response.
- `"SubscriptionProviderSources"`: To filter your results, specify which subscription
  providers to return in the list.
"""
function list_registered_subscription_providers end

function list_registered_subscription_providers(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return license_manager_linux_subscriptions(
        "POST",
        "/subscription/ListRegisteredSubscriptionProviders";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function list_registered_subscription_providers(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return license_manager_linux_subscriptions(
        "POST",
        "/subscription/ListRegisteredSubscriptionProviders",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

List the metadata tags that are assigned to the specified Amazon Web Services resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource for which to list metadata
  tags.

"""
function list_tags_for_resource end

function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return license_manager_linux_subscriptions(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager_linux_subscriptions(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    register_subscription_provider(secret_arn, subscription_provider_source)
    register_subscription_provider(secret_arn, subscription_provider_source, params::Dict{String,<:Any})

Register the supported third-party subscription provider for your Bring Your Own License
(BYOL) subscription.

# Arguments
- `secret_arn`: The Amazon Resource Name (ARN) of the secret where you've stored your
  subscription provider's access token. For RHEL subscriptions managed through the Red Hat
  Subscription Manager (RHSM), the secret contains your Red Hat Offline token.
- `subscription_provider_source`: The supported Linux subscription provider to register.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: The metadata tags to assign to your registered Linux subscription provider
  resource.
"""
function register_subscription_provider end

function register_subscription_provider(
    SecretArn,
    SubscriptionProviderSource;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager_linux_subscriptions(
        "POST",
        "/subscription/RegisterSubscriptionProvider",
        Dict{String,Any}(
            "SecretArn" => SecretArn,
            "SubscriptionProviderSource" => SubscriptionProviderSource,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function register_subscription_provider(
    SecretArn,
    SubscriptionProviderSource,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager_linux_subscriptions(
        "POST",
        "/subscription/RegisterSubscriptionProvider",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "SecretArn" => SecretArn,
                    "SubscriptionProviderSource" => SubscriptionProviderSource,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Add metadata tags to the specified Amazon Web Services resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the Amazon Web Services resource to
  which to add the specified metadata tags.
- `tags`: The metadata tags to assign to the Amazon Web Services resource. Tags are
  formatted as key value pairs.

"""
function tag_resource end

function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return license_manager_linux_subscriptions(
        "PUT",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager_linux_subscriptions(
        "PUT",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Remove one or more metadata tag from the specified Amazon Web Services resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the Amazon Web Services resource to
  remove the metadata tags from.
- `tag_keys`: A list of metadata tag keys to remove from the requested resource.

"""
function untag_resource end

function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return license_manager_linux_subscriptions(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager_linux_subscriptions(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_service_settings(linux_subscriptions_discovery, linux_subscriptions_discovery_settings)
    update_service_settings(linux_subscriptions_discovery, linux_subscriptions_discovery_settings, params::Dict{String,<:Any})

Updates the service settings for Linux subscriptions.

# Arguments
- `linux_subscriptions_discovery`: Describes if the discovery of Linux subscriptions is
  enabled.
- `linux_subscriptions_discovery_settings`: The settings defined for Linux subscriptions
  discovery. The settings include if Organizations integration has been enabled, and which
  Regions data will be aggregated from.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AllowUpdate"`: Describes if updates are allowed to the service settings for Linux
  subscriptions. If you allow updates, you can aggregate Linux subscription data in more than
  one home Region.
"""
function update_service_settings end

function update_service_settings(
    LinuxSubscriptionsDiscovery,
    LinuxSubscriptionsDiscoverySettings;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager_linux_subscriptions(
        "POST",
        "/subscription/UpdateServiceSettings",
        Dict{String,Any}(
            "LinuxSubscriptionsDiscovery" => LinuxSubscriptionsDiscovery,
            "LinuxSubscriptionsDiscoverySettings" => LinuxSubscriptionsDiscoverySettings,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function update_service_settings(
    LinuxSubscriptionsDiscovery,
    LinuxSubscriptionsDiscoverySettings,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager_linux_subscriptions(
        "POST",
        "/subscription/UpdateServiceSettings",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "LinuxSubscriptionsDiscovery" => LinuxSubscriptionsDiscovery,
                    "LinuxSubscriptionsDiscoverySettings" =>
                        LinuxSubscriptionsDiscoverySettings,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: emr_serverless
using AWS.Compat
using AWS.UUIDs

"""
    cancel_job_run(application_id, job_run_id)
    cancel_job_run(application_id, job_run_id, params::Dict{String,<:Any})

Cancels a job run.

# Arguments
- `application_id`: The ID of the application on which the job run will be canceled.
- `job_run_id`: The ID of the job run to cancel.

"""
function cancel_job_run(
    applicationId, jobRunId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr_serverless(
        "DELETE",
        "/applications/$(applicationId)/jobruns/$(jobRunId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_job_run(
    applicationId,
    jobRunId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr_serverless(
        "DELETE",
        "/applications/$(applicationId)/jobruns/$(jobRunId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_application(client_token, release_label, type)
    create_application(client_token, release_label, type, params::Dict{String,<:Any})

Creates an application.

# Arguments
- `client_token`: The client idempotency token of the application to create. Its value must
  be unique for each request.
- `release_label`: The Amazon EMR release associated with the application.
- `type`: The type of application you want to start, such as Spark or Hive.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"architecture"`: The CPU architecture of an application.
- `"autoStartConfiguration"`: The configuration for an application to automatically start
  on job submission.
- `"autoStopConfiguration"`: The configuration for an application to automatically stop
  after a certain amount of time being idle.
- `"imageConfiguration"`: The image configuration for all worker types. You can either set
  this parameter or imageConfiguration for each worker type in workerTypeSpecifications.
- `"initialCapacity"`: The capacity to initialize when the application is created.
- `"interactiveConfiguration"`: The interactive configuration object that enables the
  interactive use cases to use when running an application.
- `"maximumCapacity"`: The maximum capacity to allocate when the application is created.
  This is cumulative across all workers at any given point in time, not just when an
  application is created. No new resources will be created once any one of the defined limits
  is hit.
- `"monitoringConfiguration"`: The configuration setting for monitoring.
- `"name"`: The name of the application.
- `"networkConfiguration"`: The network configuration for customer VPC connectivity.
- `"runtimeConfiguration"`: The Configuration specifications to use when creating an
  application. Each configuration consists of a classification and properties. This
  configuration is applied to all the job runs submitted under the application.
- `"tags"`: The tags assigned to the application.
- `"workerTypeSpecifications"`: The key-value pairs that specify worker type to
  WorkerTypeSpecificationInput. This parameter must contain all valid worker types for a
  Spark or Hive application. Valid worker types include Driver and Executor for Spark
  applications and HiveDriver and TezTask for Hive applications. You can either set image
  details in this parameter for each worker type, or in imageConfiguration for all worker
  types.
"""
function create_application(
    clientToken, releaseLabel, type; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr_serverless(
        "POST",
        "/applications",
        Dict{String,Any}(
            "clientToken" => clientToken, "releaseLabel" => releaseLabel, "type" => type
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_application(
    clientToken,
    releaseLabel,
    type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr_serverless(
        "POST",
        "/applications",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "clientToken" => clientToken,
                    "releaseLabel" => releaseLabel,
                    "type" => type,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_application(application_id)
    delete_application(application_id, params::Dict{String,<:Any})

Deletes an application. An application has to be in a stopped or created state in order to
be deleted.

# Arguments
- `application_id`: The ID of the application that will be deleted.

"""
function delete_application(
    applicationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr_serverless(
        "DELETE",
        "/applications/$(applicationId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_application(
    applicationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr_serverless(
        "DELETE",
        "/applications/$(applicationId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_application(application_id)
    get_application(application_id, params::Dict{String,<:Any})

Displays detailed information about a specified application.

# Arguments
- `application_id`: The ID of the application that will be described.

"""
function get_application(applicationId; aws_config::AbstractAWSConfig=current_aws_config())
    return emr_serverless(
        "GET",
        "/applications/$(applicationId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_application(
    applicationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr_serverless(
        "GET",
        "/applications/$(applicationId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_dashboard_for_job_run(application_id, job_run_id)
    get_dashboard_for_job_run(application_id, job_run_id, params::Dict{String,<:Any})

Creates and returns a URL that you can use to access the application UIs for a job run. For
jobs in a running state, the application UI is a live user interface such as the Spark or
Tez web UI. For completed jobs, the application UI is a persistent application user
interface such as the Spark History Server or persistent Tez UI.  The URL is valid for one
hour after you generate it. To access the application UI after that hour elapses, you must
invoke the API again to generate a new URL.

# Arguments
- `application_id`: The ID of the application.
- `job_run_id`: The ID of the job run.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"attempt"`: An optimal parameter that indicates the amount of attempts for the job. If
  not specified, this value defaults to the attempt of the latest job.
"""
function get_dashboard_for_job_run(
    applicationId, jobRunId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr_serverless(
        "GET",
        "/applications/$(applicationId)/jobruns/$(jobRunId)/dashboard";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_dashboard_for_job_run(
    applicationId,
    jobRunId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr_serverless(
        "GET",
        "/applications/$(applicationId)/jobruns/$(jobRunId)/dashboard",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_job_run(application_id, job_run_id)
    get_job_run(application_id, job_run_id, params::Dict{String,<:Any})

Displays detailed information about a job run.

# Arguments
- `application_id`: The ID of the application on which the job run is submitted.
- `job_run_id`: The ID of the job run.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"attempt"`: An optimal parameter that indicates the amount of attempts for the job. If
  not specified, this value defaults to the attempt of the latest job.
"""
function get_job_run(
    applicationId, jobRunId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr_serverless(
        "GET",
        "/applications/$(applicationId)/jobruns/$(jobRunId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_job_run(
    applicationId,
    jobRunId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr_serverless(
        "GET",
        "/applications/$(applicationId)/jobruns/$(jobRunId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_applications()
    list_applications(params::Dict{String,<:Any})

Lists applications based on a set of parameters.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of applications that can be listed.
- `"nextToken"`: The token for the next set of application results.
- `"states"`: An optional filter for application states. Note that if this filter contains
  multiple states, the resulting list will be grouped by the state.
"""
function list_applications(; aws_config::AbstractAWSConfig=current_aws_config())
    return emr_serverless(
        "GET", "/applications"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_applications(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr_serverless(
        "GET",
        "/applications",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_job_run_attempts(application_id, job_run_id)
    list_job_run_attempts(application_id, job_run_id, params::Dict{String,<:Any})

Lists all attempt of a job run.

# Arguments
- `application_id`: The ID of the application for which to list job runs.
- `job_run_id`: The ID of the job run to list.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of job run attempts to list.
- `"nextToken"`: The token for the next set of job run attempt results.
"""
function list_job_run_attempts(
    applicationId, jobRunId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr_serverless(
        "GET",
        "/applications/$(applicationId)/jobruns/$(jobRunId)/attempts";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_job_run_attempts(
    applicationId,
    jobRunId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr_serverless(
        "GET",
        "/applications/$(applicationId)/jobruns/$(jobRunId)/attempts",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_job_runs(application_id)
    list_job_runs(application_id, params::Dict{String,<:Any})

Lists job runs based on a set of parameters.

# Arguments
- `application_id`: The ID of the application for which to list the job run.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"createdAtAfter"`: The lower bound of the option to filter by creation date and time.
- `"createdAtBefore"`: The upper bound of the option to filter by creation date and time.
- `"maxResults"`: The maximum number of job runs that can be listed.
- `"mode"`: The mode of the job runs to list.
- `"nextToken"`: The token for the next set of job run results.
- `"states"`: An optional filter for job run states. Note that if this filter contains
  multiple states, the resulting list will be grouped by the state.
"""
function list_job_runs(applicationId; aws_config::AbstractAWSConfig=current_aws_config())
    return emr_serverless(
        "GET",
        "/applications/$(applicationId)/jobruns";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_job_runs(
    applicationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr_serverless(
        "GET",
        "/applications/$(applicationId)/jobruns",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists the tags assigned to the resources.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) that identifies the resource to list the
  tags for. Currently, the supported resources are Amazon EMR Serverless applications and job
  runs.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr_serverless(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr_serverless(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_application(application_id)
    start_application(application_id, params::Dict{String,<:Any})

Starts a specified application and initializes initial capacity if configured.

# Arguments
- `application_id`: The ID of the application to start.

"""
function start_application(
    applicationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr_serverless(
        "POST",
        "/applications/$(applicationId)/start";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_application(
    applicationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr_serverless(
        "POST",
        "/applications/$(applicationId)/start",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_job_run(application_id, client_token, execution_role_arn)
    start_job_run(application_id, client_token, execution_role_arn, params::Dict{String,<:Any})

Starts a job run.

# Arguments
- `application_id`: The ID of the application on which to run the job.
- `client_token`: The client idempotency token of the job run to start. Its value must be
  unique for each request.
- `execution_role_arn`: The execution role ARN for the job run.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"configurationOverrides"`: The configuration overrides for the job run.
- `"executionTimeoutMinutes"`: The maximum duration for the job run to run. If the job run
  runs beyond this duration, it will be automatically cancelled.
- `"jobDriver"`: The job driver for the job run.
- `"mode"`: The mode of the job run when it starts.
- `"name"`: The optional job run name. This doesn't have to be unique.
- `"retryPolicy"`: The retry policy when job run starts.
- `"tags"`: The tags assigned to the job run.
"""
function start_job_run(
    applicationId,
    clientToken,
    executionRoleArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr_serverless(
        "POST",
        "/applications/$(applicationId)/jobruns",
        Dict{String,Any}(
            "clientToken" => clientToken, "executionRoleArn" => executionRoleArn
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_job_run(
    applicationId,
    clientToken,
    executionRoleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr_serverless(
        "POST",
        "/applications/$(applicationId)/jobruns",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "clientToken" => clientToken, "executionRoleArn" => executionRoleArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_application(application_id)
    stop_application(application_id, params::Dict{String,<:Any})

Stops a specified application and releases initial capacity if configured. All scheduled
and running jobs must be completed or cancelled before stopping an application.

# Arguments
- `application_id`: The ID of the application to stop.

"""
function stop_application(applicationId; aws_config::AbstractAWSConfig=current_aws_config())
    return emr_serverless(
        "POST",
        "/applications/$(applicationId)/stop";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_application(
    applicationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr_serverless(
        "POST",
        "/applications/$(applicationId)/stop",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Assigns tags to resources. A tag is a label that you assign to an Amazon Web Services
resource. Each tag consists of a key and an optional value, both of which you define. Tags
enable you to categorize your Amazon Web Services resources by attributes such as purpose,
owner, or environment. When you have many resources of the same type, you can quickly
identify a specific resource based on the tags you've assigned to it.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) that identifies the resource to list the
  tags for. Currently, the supported resources are Amazon EMR Serverless applications and job
  runs.
- `tags`: The tags to add to the resource. A tag is an array of key-value pairs.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return emr_serverless(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr_serverless(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes tags from resources.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) that identifies the resource to list the
  tags for. Currently, the supported resources are Amazon EMR Serverless applications and job
  runs.
- `tag_keys`: The keys of the tags to be removed.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr_serverless(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr_serverless(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_application(application_id, client_token)
    update_application(application_id, client_token, params::Dict{String,<:Any})

Updates a specified application. An application has to be in a stopped or created state in
order to be updated.

# Arguments
- `application_id`: The ID of the application to update.
- `client_token`: The client idempotency token of the application to update. Its value must
  be unique for each request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"architecture"`: The CPU architecture of an application.
- `"autoStartConfiguration"`: The configuration for an application to automatically start
  on job submission.
- `"autoStopConfiguration"`: The configuration for an application to automatically stop
  after a certain amount of time being idle.
- `"imageConfiguration"`: The image configuration to be used for all worker types. You can
  either set this parameter or imageConfiguration for each worker type in
  WorkerTypeSpecificationInput.
- `"initialCapacity"`: The capacity to initialize when the application is updated.
- `"interactiveConfiguration"`: The interactive configuration object that contains new
  interactive use cases when the application is updated.
- `"maximumCapacity"`: The maximum capacity to allocate when the application is updated.
  This is cumulative across all workers at any given point in time during the lifespan of the
  application. No new resources will be created once any one of the defined limits is hit.
- `"monitoringConfiguration"`: The configuration setting for monitoring.
- `"networkConfiguration"`:
- `"releaseLabel"`: The Amazon EMR release label for the application. You can change the
  release label to use a different release of Amazon EMR.
- `"runtimeConfiguration"`: The Configuration specifications to use when updating an
  application. Each configuration consists of a classification and properties. This
  configuration is applied across all the job runs submitted under the application.
- `"workerTypeSpecifications"`: The key-value pairs that specify worker type to
  WorkerTypeSpecificationInput. This parameter must contain all valid worker types for a
  Spark or Hive application. Valid worker types include Driver and Executor for Spark
  applications and HiveDriver and TezTask for Hive applications. You can either set image
  details in this parameter for each worker type, or in imageConfiguration for all worker
  types.
"""
function update_application(
    applicationId, clientToken; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr_serverless(
        "PATCH",
        "/applications/$(applicationId)",
        Dict{String,Any}("clientToken" => clientToken);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_application(
    applicationId,
    clientToken,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr_serverless(
        "PATCH",
        "/applications/$(applicationId)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => clientToken), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

using AWS
using Documenter

"Transform snake-case names, like `this_name`, to pascal-snake-case, like `This_Name`."
pascal_snake_case(s) = join(titlecase.(split(s, "_")), "_")

"""
    _generate_high_level_services_docs(service_dir) -> Vector{Pair{String,String}}

Generate a documentation page for each high-level AWS Service API, and
return a `Vector` of `"service name" => "docs/src/services/service_name.md"` pairs.

Documentation pages are created at `docs/src/services/{service_name}.md`, and
populated with all docstrings from a module created with `@service Service_Name`.
"""
function _generate_high_level_services_docs(
    services_dir=joinpath(@__DIR__, "src", "services")
)
    mkpath(services_dir)

    # Remove service doc files to ensure old services that no longer exist are removed.
    for path in readdir(services_dir; join=true)
        if isfile(path) && endswith(path, ".md")
            rm(path)
        end
    end

    services_pages = Pair{String,String}[]
    for jl_file in readdir(joinpath(pkgdir(AWS), "src", "services"))
        service = first(splitext(jl_file))
        # Create a module, e.g. `@service S3`, so we can extract docstrings from it.
        service_module = Symbol(pascal_snake_case(service))
        @eval @service $service_module

        # Avoid `_`s in sidebar/titles/contents as it causes italics in markdown contexts.
        service_name = replace(string(service_module), "_" => " ")

        @info "Generating documentation page for `@service $service_module`"
        md_file = string(service, ".md")
        open(joinpath(services_dir, md_file), "w") do md
            write(
                md,
                """
                ```@meta
                CurrentModule = Main.$service_module
                ```

                # $service_name

                This page documents function available when using the `$service_module`
                module, created with [`@service $service_module`](@ref AWS.@service).

                ### Index
                ```@index
                Pages   = ["$md_file"]
                Modules = [$service_module]
                ```

                ### Documentation
                ```@autodocs
                Modules = [$service_module]
                ```
                """,
            )
        end
        push!(services_pages, service_name => joinpath("services", md_file))
    end

    return services_pages
end

service_pages = _generate_high_level_services_docs()

makedocs(;
    modules=[AWS],
    repo="https://github.com/JuliaCloud/AWS.jl/blob/{commit}{path}#{line}",
    sitename="AWS.jl",
    format=Documenter.HTML(;
        canonical="https://juliacloud.github.io/AWS.jl",
        prettyurls=false,
        size_threshold_ignore=[last(page)::String for page in service_pages],
    ),
    pages=[
        "Home" => "index.md",
        "Backends" => "backends.md",
        "AWS" => "aws.md",
        "IMDS" => "imds.md",
        "Services" => service_pages,
    ],
    checkdocs=:exports,
)

deploydocs(; repo="github.com/JuliaCloud/AWS.jl", push_preview=true)

# https://github.com/JuliaCloud/AWS.jl/issues/515
@testset "issue 515" begin
    function _incomplete_patch(; data, num_attempts_to_fail=4)
        attempt_num = 0
        n = length(data)

        function _downloads_response(content_length)
            headers = ["content-length" => string(content_length)]
            return Downloads.Response("http", "", 200, "HTTP/1.1 200 OK", headers)
        end

        patch = if AWS.DEFAULT_BACKEND[] isa AWS.HTTPBackend
            @patch function HTTP.request(args...; response_stream, kwargs...)
                attempt_num += 1
                if attempt_num <= num_attempts_to_fail
                    write(response_stream, data[1:(n - 1)]) # an incomplete stream that shouldn't be retained
                    throw(HTTP.RequestError(HTTP.Request(), EOFError()))
                else
                    write(response_stream, data)
                    return HTTP.Response(200, "{\"Location\": \"us-east-1\"}")
                end
            end
        elseif AWS.DEFAULT_BACKEND[] isa AWS.DownloadsBackend
            @patch function Downloads.request(args...; output, kwargs...)
                attempt_num += 1
                if attempt_num <= num_attempts_to_fail
                    write(output, data[1:(n - 1)])  # an incomplete stream that shouldn't be retained
                    message = "transfer closed with 1 bytes remaining to read"
                    e = Downloads.RequestError("", 18, message, _downloads_response(n))
                    throw(e)
                else
                    write(output, data)
                    return _downloads_response(n)
                end
            end
        end

        return patch
    end

    n = 100
    data = rand(UInt8, n)
    bucket = "julialang2"  # use public bucket as dummy
    key = "bin/versions.json"
    config = AWSConfig(; creds=nothing, region="us-east-1")

    @testset "Fail 2 attempts then succeed" begin
        apply(_incomplete_patch(; data=data, num_attempts_to_fail=2)) do
            retrieved = S3.get_object(bucket, key; aws_config=config)

            @test length(retrieved) == n
            @test retrieved == data
        end
    end

    @testset "Fail all 4 attempts then throw" begin
        err_t = if AWS.DEFAULT_BACKEND[] isa AWS.HTTPBackend
            HTTP.RequestError
        else
            Downloads.RequestError
        end
        io = IOBuffer()

        apply(_incomplete_patch(; data=data, num_attempts_to_fail=4)) do
            params = Dict("response_stream" => io)
            @test_throws err_t S3.get_object(bucket, key, params; aws_config=config)

            seekstart(io)
            retrieved = read(io)
            @test length(retrieved) == n - 1
            @test retrieved == data[1:(n - 1)]
        end
    end
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: eks
using AWS.Compat
using AWS.UUIDs

"""
    associate_access_policy(access_scope, name, policy_arn, principal_arn)
    associate_access_policy(access_scope, name, policy_arn, principal_arn, params::Dict{String,<:Any})

Associates an access policy and its scope to an access entry. For more information about
associating access policies, see Associating and disassociating access policies to and from
access entries in the Amazon EKS User Guide.

# Arguments
- `access_scope`: The scope for the AccessPolicy. You can scope access policies to an
  entire cluster or to specific Kubernetes namespaces.
- `name`: The name of your cluster.
- `policy_arn`: The ARN of the AccessPolicy that you're associating. For a list of ARNs,
  use ListAccessPolicies.
- `principal_arn`: The Amazon Resource Name (ARN) of the IAM user or role for the
  AccessEntry that you're associating the access policy to.

"""
function associate_access_policy(
    accessScope,
    name,
    policyArn,
    principalArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eks(
        "POST",
        "/clusters/$(name)/access-entries/$(principalArn)/access-policies",
        Dict{String,Any}("accessScope" => accessScope, "policyArn" => policyArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_access_policy(
    accessScope,
    name,
    policyArn,
    principalArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eks(
        "POST",
        "/clusters/$(name)/access-entries/$(principalArn)/access-policies",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("accessScope" => accessScope, "policyArn" => policyArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_encryption_config(encryption_config, name)
    associate_encryption_config(encryption_config, name, params::Dict{String,<:Any})

Associates an encryption configuration to an existing cluster. Use this API to enable
encryption on existing clusters that don't already have encryption enabled. This allows you
to implement a defense-in-depth security strategy without migrating applications to new
Amazon EKS clusters.

# Arguments
- `encryption_config`: The configuration you are using for encryption.
- `name`: The name of your cluster.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientRequestToken"`: A unique, case-sensitive identifier that you provide to ensure
  the idempotency of the request.
"""
function associate_encryption_config(
    encryptionConfig, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eks(
        "POST",
        "/clusters/$(name)/encryption-config/associate",
        Dict{String,Any}(
            "encryptionConfig" => encryptionConfig, "clientRequestToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_encryption_config(
    encryptionConfig,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eks(
        "POST",
        "/clusters/$(name)/encryption-config/associate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "encryptionConfig" => encryptionConfig,
                    "clientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_identity_provider_config(name, oidc)
    associate_identity_provider_config(name, oidc, params::Dict{String,<:Any})

Associates an identity provider configuration to a cluster. If you want to authenticate
identities using an identity provider, you can create an identity provider configuration
and associate it to your cluster. After configuring authentication to your cluster you can
create Kubernetes Role and ClusterRole objects, assign permissions to them, and then bind
them to the identities using Kubernetes RoleBinding and ClusterRoleBinding objects. For
more information see Using RBAC Authorization in the Kubernetes documentation.

# Arguments
- `name`: The name of your cluster.
- `oidc`: An object representing an OpenID Connect (OIDC) identity provider configuration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientRequestToken"`: A unique, case-sensitive identifier that you provide to ensure
  the idempotency of the request.
- `"tags"`: Metadata that assists with categorization and organization. Each tag consists
  of a key and an optional value. You define both. Tags don't propagate to any other cluster
  or Amazon Web Services resources.
"""
function associate_identity_provider_config(
    name, oidc; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eks(
        "POST",
        "/clusters/$(name)/identity-provider-configs/associate",
        Dict{String,Any}("oidc" => oidc, "clientRequestToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_identity_provider_config(
    name,
    oidc,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eks(
        "POST",
        "/clusters/$(name)/identity-provider-configs/associate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("oidc" => oidc, "clientRequestToken" => string(uuid4())),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_access_entry(name, principal_arn)
    create_access_entry(name, principal_arn, params::Dict{String,<:Any})

Creates an access entry. An access entry allows an IAM principal to access your cluster.
Access entries can replace the need to maintain entries in the aws-auth ConfigMap for
authentication. You have the following options for authorizing an IAM principal to access
Kubernetes objects on your cluster: Kubernetes role-based access control (RBAC), Amazon
EKS, or both. Kubernetes RBAC authorization requires you to create and manage Kubernetes
Role, ClusterRole, RoleBinding, and ClusterRoleBinding objects, in addition to managing
access entries. If you use Amazon EKS authorization exclusively, you don't need to create
and manage Kubernetes Role, ClusterRole, RoleBinding, and ClusterRoleBinding objects. For
more information about access entries, see Access entries in the Amazon EKS User Guide.

# Arguments
- `name`: The name of your cluster.
- `principal_arn`: The ARN of the IAM principal for the AccessEntry. You can specify one
  ARN for each access entry. You can't specify the same ARN in more than one access entry.
  This value can't be changed after access entry creation. The valid principals differ
  depending on the type of the access entry in the type field. The only valid ARN is IAM
  roles for the types of access entries for nodes:  . You can use every IAM principal type
  for STANDARD access entries. You can't use the STS session principal type with access
  entries because this is a temporary principal for each session and not a permanent identity
  that can be assigned permissions.  IAM best practices recommend using IAM roles with
  temporary credentials, rather than IAM users with long-term credentials.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientRequestToken"`: A unique, case-sensitive identifier that you provide to ensure
  the idempotency of the request.
- `"kubernetesGroups"`: The value for name that you've specified for kind: Group as a
  subject in a Kubernetes RoleBinding or ClusterRoleBinding object. Amazon EKS doesn't
  confirm that the value for name exists in any bindings on your cluster. You can specify one
  or more names. Kubernetes authorizes the principalArn of the access entry to access any
  cluster objects that you've specified in a Kubernetes Role or ClusterRole object that is
  also specified in a binding's roleRef. For more information about creating Kubernetes
  RoleBinding, ClusterRoleBinding, Role, or ClusterRole objects, see Using RBAC Authorization
  in the Kubernetes documentation. If you want Amazon EKS to authorize the principalArn
  (instead of, or in addition to Kubernetes authorizing the principalArn), you can associate
  one or more access policies to the access entry using AssociateAccessPolicy. If you
  associate any access policies, the principalARN has all permissions assigned in the
  associated access policies and all permissions in any Kubernetes Role or ClusterRole
  objects that the group names are bound to.
- `"tags"`: Metadata that assists with categorization and organization. Each tag consists
  of a key and an optional value. You define both. Tags don't propagate to any other cluster
  or Amazon Web Services resources.
- `"type"`: The type of the new access entry. Valid values are Standard, FARGATE_LINUX,
  EC2_LINUX, and EC2_WINDOWS. If the principalArn is for an IAM role that's used for
  self-managed Amazon EC2 nodes, specify EC2_LINUX or EC2_WINDOWS. Amazon EKS grants the
  necessary permissions to the node for you. If the principalArn is for any other purpose,
  specify STANDARD. If you don't specify a value, Amazon EKS sets the value to STANDARD. It's
  unnecessary to create access entries for IAM roles used with Fargate profiles or managed
  Amazon EC2 nodes, because Amazon EKS creates entries in the aws-auth ConfigMap for the
  roles. You can't change this value once you've created the access entry. If you set the
  value to EC2_LINUX or EC2_WINDOWS, you can't specify values for kubernetesGroups, or
  associate an AccessPolicy to the access entry.
- `"username"`: The username to authenticate to Kubernetes with. We recommend not
  specifying a username and letting Amazon EKS specify it for you. For more information about
  the value Amazon EKS specifies for you, or constraints before specifying your own username,
  see Creating access entries in the Amazon EKS User Guide.
"""
function create_access_entry(
    name, principalArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eks(
        "POST",
        "/clusters/$(name)/access-entries",
        Dict{String,Any}(
            "principalArn" => principalArn, "clientRequestToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_access_entry(
    name,
    principalArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eks(
        "POST",
        "/clusters/$(name)/access-entries",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "principalArn" => principalArn, "clientRequestToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_addon(addon_name, name)
    create_addon(addon_name, name, params::Dict{String,<:Any})

Creates an Amazon EKS add-on. Amazon EKS add-ons help to automate the provisioning and
lifecycle management of common operational software for Amazon EKS clusters. For more
information, see Amazon EKS add-ons in the Amazon EKS User Guide.

# Arguments
- `addon_name`: The name of the add-on. The name must match one of the names returned by
  DescribeAddonVersions.
- `name`: The name of your cluster.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"addonVersion"`: The version of the add-on. The version must match one of the versions
  returned by  DescribeAddonVersions .
- `"clientRequestToken"`: A unique, case-sensitive identifier that you provide to ensure
  the idempotency of the request.
- `"configurationValues"`: The set of configuration values for the add-on that's created.
  The values that you provide are validated against the schema returned by
  DescribeAddonConfiguration.
- `"podIdentityAssociations"`: An array of Pod Identity Assocations to be created. Each EKS
  Pod Identity association maps a Kubernetes service account to an IAM Role. For more
  information, see Attach an IAM Role to an Amazon EKS add-on using Pod Identity in the EKS
  User Guide.
- `"resolveConflicts"`: How to resolve field value conflicts for an Amazon EKS add-on.
  Conflicts are handled based on the value you choose:    None – If the self-managed
  version of the add-on is installed on your cluster, Amazon EKS doesn't change the value.
  Creation of the add-on might fail.    Overwrite – If the self-managed version of the
  add-on is installed on your cluster and the Amazon EKS default value is different than the
  existing value, Amazon EKS changes the value to the Amazon EKS default value.    Preserve
  – This is similar to the NONE option. If the self-managed version of the add-on is
  installed on your cluster Amazon EKS doesn't change the add-on resource properties.
  Creation of the add-on might fail if conflicts are detected. This option works differently
  during the update operation. For more information, see UpdateAddon.   If you don't
  currently have the self-managed version of the add-on installed on your cluster, the Amazon
  EKS add-on is installed. Amazon EKS sets all values to default values, regardless of the
  option that you specify.
- `"serviceAccountRoleArn"`: The Amazon Resource Name (ARN) of an existing IAM role to bind
  to the add-on's service account. The role must be assigned the IAM permissions required by
  the add-on. If you don't specify an existing IAM role, then the add-on uses the permissions
  assigned to the node IAM role. For more information, see Amazon EKS node IAM role in the
  Amazon EKS User Guide.  To specify an existing IAM role, you must have an IAM OpenID
  Connect (OIDC) provider created for your cluster. For more information, see Enabling IAM
  roles for service accounts on your cluster in the Amazon EKS User Guide.
- `"tags"`: Metadata that assists with categorization and organization. Each tag consists
  of a key and an optional value. You define both. Tags don't propagate to any other cluster
  or Amazon Web Services resources.
"""
function create_addon(addonName, name; aws_config::AbstractAWSConfig=current_aws_config())
    return eks(
        "POST",
        "/clusters/$(name)/addons",
        Dict{String,Any}("addonName" => addonName, "clientRequestToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_addon(
    addonName,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eks(
        "POST",
        "/clusters/$(name)/addons",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "addonName" => addonName, "clientRequestToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_cluster(name, resources_vpc_config, role_arn)
    create_cluster(name, resources_vpc_config, role_arn, params::Dict{String,<:Any})

Creates an Amazon EKS control plane. The Amazon EKS control plane consists of control plane
instances that run the Kubernetes software, such as etcd and the API server. The control
plane runs in an account managed by Amazon Web Services, and the Kubernetes API is exposed
by the Amazon EKS API server endpoint. Each Amazon EKS cluster control plane is single
tenant and unique. It runs on its own set of Amazon EC2 instances. The cluster control
plane is provisioned across multiple Availability Zones and fronted by an Elastic Load
Balancing Network Load Balancer. Amazon EKS also provisions elastic network interfaces in
your VPC subnets to provide connectivity from the control plane instances to the nodes (for
example, to support kubectl exec, logs, and proxy data flows). Amazon EKS nodes run in your
Amazon Web Services account and connect to your cluster's control plane over the Kubernetes
API server endpoint and a certificate file that is created for your cluster. You can use
the endpointPublicAccess and endpointPrivateAccess parameters to enable or disable public
and private access to your cluster's Kubernetes API server endpoint. By default, public
access is enabled, and private access is disabled. For more information, see Amazon EKS
Cluster Endpoint Access Control in the  Amazon EKS User Guide .  You can use the logging
parameter to enable or disable exporting the Kubernetes control plane logs for your cluster
to CloudWatch Logs. By default, cluster control plane logs aren't exported to CloudWatch
Logs. For more information, see Amazon EKS Cluster Control Plane Logs in the  Amazon EKS
User Guide .  CloudWatch Logs ingestion, archive storage, and data scanning rates apply to
exported control plane logs. For more information, see CloudWatch Pricing.  In most cases,
it takes several minutes to create a cluster. After you create an Amazon EKS cluster, you
must configure your Kubernetes tooling to communicate with the API server and launch nodes
into your cluster. For more information, see Allowing users to access your cluster and
Launching Amazon EKS nodes in the Amazon EKS User Guide.

# Arguments
- `name`: The unique name to give to your cluster.
- `resources_vpc_config`: The VPC configuration that's used by the cluster control plane.
  Amazon EKS VPC resources have specific requirements to work properly with Kubernetes. For
  more information, see Cluster VPC Considerations and Cluster Security Group Considerations
  in the Amazon EKS User Guide. You must specify at least two subnets. You can specify up to
  five security groups. However, we recommend that you use a dedicated security group for
  your cluster control plane.
- `role_arn`: The Amazon Resource Name (ARN) of the IAM role that provides permissions for
  the Kubernetes control plane to make calls to Amazon Web Services API operations on your
  behalf. For more information, see Amazon EKS Service IAM Role in the  Amazon EKS User Guide
  .

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accessConfig"`: The access configuration for the cluster.
- `"clientRequestToken"`: A unique, case-sensitive identifier that you provide to ensure
  the idempotency of the request.
- `"encryptionConfig"`: The encryption configuration for the cluster.
- `"kubernetesNetworkConfig"`: The Kubernetes network configuration for the cluster.
- `"logging"`: Enable or disable exporting the Kubernetes control plane logs for your
  cluster to CloudWatch Logs. By default, cluster control plane logs aren't exported to
  CloudWatch Logs. For more information, see Amazon EKS Cluster control plane logs in the
  Amazon EKS User Guide .  CloudWatch Logs ingestion, archive storage, and data scanning
  rates apply to exported control plane logs. For more information, see CloudWatch Pricing.
- `"outpostConfig"`: An object representing the configuration of your local Amazon EKS
  cluster on an Amazon Web Services Outpost. Before creating a local cluster on an Outpost,
  review Local clusters for Amazon EKS on Amazon Web Services Outposts in the Amazon EKS User
  Guide. This object isn't available for creating Amazon EKS clusters on the Amazon Web
  Services cloud.
- `"tags"`: Metadata that assists with categorization and organization. Each tag consists
  of a key and an optional value. You define both. Tags don't propagate to any other cluster
  or Amazon Web Services resources.
- `"version"`: The desired Kubernetes version for your cluster. If you don't specify a
  value here, the default version available in Amazon EKS is used.  The default version might
  not be the latest version available.
"""
function create_cluster(
    name, resourcesVpcConfig, roleArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eks(
        "POST",
        "/clusters",
        Dict{String,Any}(
            "name" => name,
            "resourcesVpcConfig" => resourcesVpcConfig,
            "roleArn" => roleArn,
            "clientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_cluster(
    name,
    resourcesVpcConfig,
    roleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eks(
        "POST",
        "/clusters",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "name" => name,
                    "resourcesVpcConfig" => resourcesVpcConfig,
                    "roleArn" => roleArn,
                    "clientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_eks_anywhere_subscription(name, term)
    create_eks_anywhere_subscription(name, term, params::Dict{String,<:Any})

Creates an EKS Anywhere subscription. When a subscription is created, it is a contract
agreement for the length of the term specified in the request. Licenses that are used to
validate support are provisioned in Amazon Web Services License Manager and the caller
account is granted access to EKS Anywhere Curated Packages.

# Arguments
- `name`: The unique name for your subscription. It must be unique in your Amazon Web
  Services account in the Amazon Web Services Region you're creating the subscription in. The
  name can contain only alphanumeric characters (case-sensitive), hyphens, and underscores.
  It must start with an alphabetic character and can't be longer than 100 characters.
- `term`: An object representing the term duration and term unit type of your subscription.
  This determines the term length of your subscription. Valid values are MONTHS for term unit
  and 12 or 36 for term duration, indicating a 12 month or 36 month subscription. This value
  cannot be changed after creating the subscription.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"autoRenew"`: A boolean indicating whether the subscription auto renews at the end of
  the term.
- `"clientRequestToken"`: A unique, case-sensitive identifier that you provide to ensure
  the idempotency of the request.
- `"licenseQuantity"`: The number of licenses to purchase with the subscription. Valid
  values are between 1 and 100. This value can't be changed after creating the subscription.
- `"licenseType"`: The license type for all licenses in the subscription. Valid value is
  CLUSTER. With the CLUSTER license type, each license covers support for a single EKS
  Anywhere cluster.
- `"tags"`: The metadata for a subscription to assist with categorization and organization.
  Each tag consists of a key and an optional value. Subscription tags don't propagate to any
  other resources associated with the subscription.
"""
function create_eks_anywhere_subscription(
    name, term; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eks(
        "POST",
        "/eks-anywhere-subscriptions",
        Dict{String,Any}(
            "name" => name, "term" => term, "clientRequestToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_eks_anywhere_subscription(
    name,
    term,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eks(
        "POST",
        "/eks-anywhere-subscriptions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "name" => name, "term" => term, "clientRequestToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_fargate_profile(fargate_profile_name, name, pod_execution_role_arn)
    create_fargate_profile(fargate_profile_name, name, pod_execution_role_arn, params::Dict{String,<:Any})

Creates an Fargate profile for your Amazon EKS cluster. You must have at least one Fargate
profile in a cluster to be able to run pods on Fargate. The Fargate profile allows an
administrator to declare which pods run on Fargate and specify which pods run on which
Fargate profile. This declaration is done through the profile’s selectors. Each profile
can have up to five selectors that contain a namespace and labels. A namespace is required
for every selector. The label field consists of multiple optional key-value pairs. Pods
that match the selectors are scheduled on Fargate. If a to-be-scheduled pod matches any of
the selectors in the Fargate profile, then that pod is run on Fargate. When you create a
Fargate profile, you must specify a pod execution role to use with the pods that are
scheduled with the profile. This role is added to the cluster's Kubernetes Role Based
Access Control (RBAC) for authorization so that the kubelet that is running on the Fargate
infrastructure can register with your Amazon EKS cluster so that it can appear in your
cluster as a node. The pod execution role also provides IAM permissions to the Fargate
infrastructure to allow read access to Amazon ECR image repositories. For more information,
see Pod Execution Role in the Amazon EKS User Guide. Fargate profiles are immutable.
However, you can create a new updated profile to replace an existing profile and then
delete the original after the updated profile has finished creating. If any Fargate
profiles in a cluster are in the DELETING status, you must wait for that Fargate profile to
finish deleting before you can create any other profiles in that cluster. For more
information, see Fargate profile in the Amazon EKS User Guide.

# Arguments
- `fargate_profile_name`: The name of the Fargate profile.
- `name`: The name of your cluster.
- `pod_execution_role_arn`: The Amazon Resource Name (ARN) of the Pod execution role to use
  for a Pod that matches the selectors in the Fargate profile. The Pod execution role allows
  Fargate infrastructure to register with your cluster as a node, and it provides read access
  to Amazon ECR image repositories. For more information, see  Pod execution role in the
  Amazon EKS User Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientRequestToken"`: A unique, case-sensitive identifier that you provide to ensure
  the idempotency of the request.
- `"selectors"`: The selectors to match for a Pod to use this Fargate profile. Each
  selector must have an associated Kubernetes namespace. Optionally, you can also specify
  labels for a namespace. You may specify up to five selectors in a Fargate profile.
- `"subnets"`: The IDs of subnets to launch a Pod into. A Pod running on Fargate isn't
  assigned a public IP address, so only private subnets (with no direct route to an Internet
  Gateway) are accepted for this parameter.
- `"tags"`: Metadata that assists with categorization and organization. Each tag consists
  of a key and an optional value. You define both. Tags don't propagate to any other cluster
  or Amazon Web Services resources.
"""
function create_fargate_profile(
    fargateProfileName,
    name,
    podExecutionRoleArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eks(
        "POST",
        "/clusters/$(name)/fargate-profiles",
        Dict{String,Any}(
            "fargateProfileName" => fargateProfileName,
            "podExecutionRoleArn" => podExecutionRoleArn,
            "clientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_fargate_profile(
    fargateProfileName,
    name,
    podExecutionRoleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eks(
        "POST",
        "/clusters/$(name)/fargate-profiles",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "fargateProfileName" => fargateProfileName,
                    "podExecutionRoleArn" => podExecutionRoleArn,
                    "clientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_nodegroup(name, node_role, nodegroup_name, subnets)
    create_nodegroup(name, node_role, nodegroup_name, subnets, params::Dict{String,<:Any})

Creates a managed node group for an Amazon EKS cluster. You can only create a node group
for your cluster that is equal to the current Kubernetes version for the cluster. All node
groups are created with the latest AMI release version for the respective minor Kubernetes
version of the cluster, unless you deploy a custom AMI using a launch template. For more
information about using launch templates, see Customizing managed nodes with launch
templates. An Amazon EKS managed node group is an Amazon EC2 Auto Scaling group and
associated Amazon EC2 instances that are managed by Amazon Web Services for an Amazon EKS
cluster. For more information, see Managed node groups in the Amazon EKS User Guide.
Windows AMI types are only supported for commercial Amazon Web Services Regions that
support Windows on Amazon EKS.

# Arguments
- `name`: The name of your cluster.
- `node_role`: The Amazon Resource Name (ARN) of the IAM role to associate with your node
  group. The Amazon EKS worker node kubelet daemon makes calls to Amazon Web Services APIs on
  your behalf. Nodes receive permissions for these API calls through an IAM instance profile
  and associated policies. Before you can launch nodes and register them into a cluster, you
  must create an IAM role for those nodes to use when they are launched. For more
  information, see Amazon EKS node IAM role in the  Amazon EKS User Guide . If you specify
  launchTemplate, then don't specify  IamInstanceProfile  in your launch template, or the
  node group deployment will fail. For more information about using launch templates with
  Amazon EKS, see Customizing managed nodes with launch templates in the Amazon EKS User
  Guide.
- `nodegroup_name`: The unique name to give your node group.
- `subnets`: The subnets to use for the Auto Scaling group that is created for your node
  group. If you specify launchTemplate, then don't specify  SubnetId  in your launch
  template, or the node group deployment will fail. For more information about using launch
  templates with Amazon EKS, see Customizing managed nodes with launch templates in the
  Amazon EKS User Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"amiType"`: The AMI type for your node group. If you specify launchTemplate, and your
  launch template uses a custom AMI, then don't specify amiType, or the node group deployment
  will fail. If your launch template uses a Windows custom AMI, then add
  eks:kube-proxy-windows to your Windows nodes rolearn in the aws-auth ConfigMap. For more
  information about using launch templates with Amazon EKS, see Customizing managed nodes
  with launch templates in the Amazon EKS User Guide.
- `"capacityType"`: The capacity type for your node group.
- `"clientRequestToken"`: A unique, case-sensitive identifier that you provide to ensure
  the idempotency of the request.
- `"diskSize"`: The root device disk size (in GiB) for your node group instances. The
  default disk size is 20 GiB for Linux and Bottlerocket. The default disk size is 50 GiB for
  Windows. If you specify launchTemplate, then don't specify diskSize, or the node group
  deployment will fail. For more information about using launch templates with Amazon EKS,
  see Customizing managed nodes with launch templates in the Amazon EKS User Guide.
- `"instanceTypes"`: Specify the instance types for a node group. If you specify a GPU
  instance type, make sure to also specify an applicable GPU AMI type with the amiType
  parameter. If you specify launchTemplate, then you can specify zero or one instance type in
  your launch template or you can specify 0-20 instance types for instanceTypes. If however,
  you specify an instance type in your launch template and specify any instanceTypes, the
  node group deployment will fail. If you don't specify an instance type in a launch template
  or for instanceTypes, then t3.medium is used, by default. If you specify Spot for
  capacityType, then we recommend specifying multiple values for instanceTypes. For more
  information, see Managed node group capacity types and Customizing managed nodes with
  launch templates in the Amazon EKS User Guide.
- `"labels"`: The Kubernetes labels to apply to the nodes in the node group when they are
  created.
- `"launchTemplate"`: An object representing a node group's launch template specification.
  When using this object, don't directly specify instanceTypes, diskSize, or remoteAccess.
  Make sure that the launch template meets the requirements in launchTemplateSpecification.
  Also refer to Customizing managed nodes with launch templates in the Amazon EKS User Guide.
- `"releaseVersion"`: The AMI version of the Amazon EKS optimized AMI to use with your node
  group. By default, the latest available AMI version for the node group's current Kubernetes
  version is used. For information about Linux versions, see Amazon EKS optimized Amazon
  Linux AMI versions in the Amazon EKS User Guide. Amazon EKS managed node groups support the
  November 2022 and later releases of the Windows AMIs. For information about Windows
  versions, see Amazon EKS optimized Windows AMI versions in the Amazon EKS User Guide. If
  you specify launchTemplate, and your launch template uses a custom AMI, then don't specify
  releaseVersion, or the node group deployment will fail. For more information about using
  launch templates with Amazon EKS, see Customizing managed nodes with launch templates in
  the Amazon EKS User Guide.
- `"remoteAccess"`: The remote access configuration to use with your node group. For Linux,
  the protocol is SSH. For Windows, the protocol is RDP. If you specify launchTemplate, then
  don't specify remoteAccess, or the node group deployment will fail. For more information
  about using launch templates with Amazon EKS, see Customizing managed nodes with launch
  templates in the Amazon EKS User Guide.
- `"scalingConfig"`: The scaling configuration details for the Auto Scaling group that is
  created for your node group.
- `"tags"`: Metadata that assists with categorization and organization. Each tag consists
  of a key and an optional value. You define both. Tags don't propagate to any other cluster
  or Amazon Web Services resources.
- `"taints"`: The Kubernetes taints to be applied to the nodes in the node group. For more
  information, see Node taints on managed node groups.
- `"updateConfig"`: The node group update configuration.
- `"version"`: The Kubernetes version to use for your managed nodes. By default, the
  Kubernetes version of the cluster is used, and this is the only accepted specified value.
  If you specify launchTemplate, and your launch template uses a custom AMI, then don't
  specify version, or the node group deployment will fail. For more information about using
  launch templates with Amazon EKS, see Customizing managed nodes with launch templates in
  the Amazon EKS User Guide.
"""
function create_nodegroup(
    name,
    nodeRole,
    nodegroupName,
    subnets;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eks(
        "POST",
        "/clusters/$(name)/node-groups",
        Dict{String,Any}(
            "nodeRole" => nodeRole,
            "nodegroupName" => nodegroupName,
            "subnets" => subnets,
            "clientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_nodegroup(
    name,
    nodeRole,
    nodegroupName,
    subnets,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eks(
        "POST",
        "/clusters/$(name)/node-groups",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "nodeRole" => nodeRole,
                    "nodegroupName" => nodegroupName,
                    "subnets" => subnets,
                    "clientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_pod_identity_association(name, namespace, role_arn, service_account)
    create_pod_identity_association(name, namespace, role_arn, service_account, params::Dict{String,<:Any})

Creates an EKS Pod Identity association between a service account in an Amazon EKS cluster
and an IAM role with EKS Pod Identity. Use EKS Pod Identity to give temporary IAM
credentials to pods and the credentials are rotated automatically. Amazon EKS Pod Identity
associations provide the ability to manage credentials for your applications, similar to
the way that Amazon EC2 instance profiles provide credentials to Amazon EC2 instances. If a
pod uses a service account that has an association, Amazon EKS sets environment variables
in the containers of the pod. The environment variables configure the Amazon Web Services
SDKs, including the Command Line Interface, to use the EKS Pod Identity credentials. Pod
Identity is a simpler method than IAM roles for service accounts, as this method doesn't
use OIDC identity providers. Additionally, you can configure a role for Pod Identity once,
and reuse it across clusters.

# Arguments
- `name`: The name of the cluster to create the association in.
- `namespace`: The name of the Kubernetes namespace inside the cluster to create the
  association in. The service account and the pods that use the service account must be in
  this namespace.
- `role_arn`: The Amazon Resource Name (ARN) of the IAM role to associate with the service
  account. The EKS Pod Identity agent manages credentials to assume this role for
  applications in the containers in the pods that use this service account.
- `service_account`: The name of the Kubernetes service account inside the cluster to
  associate the IAM credentials with.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientRequestToken"`: A unique, case-sensitive identifier that you provide to ensure
  the idempotency of the request.
- `"tags"`: Metadata that assists with categorization and organization. Each tag consists
  of a key and an optional value. You define both. Tags don't propagate to any other cluster
  or Amazon Web Services resources. The following basic restrictions apply to tags:   Maximum
  number of tags per resource – 50   For each resource, each tag key must be unique, and
  each tag key can have only one value.   Maximum key length – 128 Unicode characters in
  UTF-8   Maximum value length – 256 Unicode characters in UTF-8   If your tagging schema
  is used across multiple services and resources, remember that other services may have
  restrictions on allowed characters. Generally allowed characters are: letters, numbers, and
  spaces representable in UTF-8, and the following characters: + - = . _ : / @.   Tag keys
  and values are case-sensitive.   Do not use aws:, AWS:, or any upper or lowercase
  combination of such as a prefix for either keys or values as it is reserved for Amazon Web
  Services use. You cannot edit or delete tag keys or values with this prefix. Tags with this
  prefix do not count against your tags per resource limit.
"""
function create_pod_identity_association(
    name,
    namespace,
    roleArn,
    serviceAccount;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eks(
        "POST",
        "/clusters/$(name)/pod-identity-associations",
        Dict{String,Any}(
            "namespace" => namespace,
            "roleArn" => roleArn,
            "serviceAccount" => serviceAccount,
            "clientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_pod_identity_association(
    name,
    namespace,
    roleArn,
    serviceAccount,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eks(
        "POST",
        "/clusters/$(name)/pod-identity-associations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "namespace" => namespace,
                    "roleArn" => roleArn,
                    "serviceAccount" => serviceAccount,
                    "clientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_access_entry(name, principal_arn)
    delete_access_entry(name, principal_arn, params::Dict{String,<:Any})

Deletes an access entry. Deleting an access entry of a type other than Standard can cause
your cluster to function improperly. If you delete an access entry in error, you can
recreate it.

# Arguments
- `name`: The name of your cluster.
- `principal_arn`: The ARN of the IAM principal for the AccessEntry.

"""
function delete_access_entry(
    name, principalArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eks(
        "DELETE",
        "/clusters/$(name)/access-entries/$(principalArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_access_entry(
    name,
    principalArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eks(
        "DELETE",
        "/clusters/$(name)/access-entries/$(principalArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_addon(addon_name, name)
    delete_addon(addon_name, name, params::Dict{String,<:Any})

Deletes an Amazon EKS add-on. When you remove an add-on, it's deleted from the cluster. You
can always manually start an add-on on the cluster using the Kubernetes API.

# Arguments
- `addon_name`: The name of the add-on. The name must match one of the names returned by
  ListAddons .
- `name`: The name of your cluster.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"preserve"`: Specifying this option preserves the add-on software on your cluster but
  Amazon EKS stops managing any settings for the add-on. If an IAM account is associated with
  the add-on, it isn't removed.
"""
function delete_addon(addonName, name; aws_config::AbstractAWSConfig=current_aws_config())
    return eks(
        "DELETE",
        "/clusters/$(name)/addons/$(addonName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_addon(
    addonName,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eks(
        "DELETE",
        "/clusters/$(name)/addons/$(addonName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_cluster(name)
    delete_cluster(name, params::Dict{String,<:Any})

Deletes an Amazon EKS cluster control plane. If you have active services in your cluster
that are associated with a load balancer, you must delete those services before deleting
the cluster so that the load balancers are deleted properly. Otherwise, you can have
orphaned resources in your VPC that prevent you from being able to delete the VPC. For more
information, see Deleting a cluster in the Amazon EKS User Guide. If you have managed node
groups or Fargate profiles attached to the cluster, you must delete them first. For more
information, see DeleteNodgroup and DeleteFargateProfile.

# Arguments
- `name`: The name of the cluster to delete.

"""
function delete_cluster(name; aws_config::AbstractAWSConfig=current_aws_config())
    return eks(
        "DELETE",
        "/clusters/$(name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_cluster(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eks(
        "DELETE",
        "/clusters/$(name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_eks_anywhere_subscription(id)
    delete_eks_anywhere_subscription(id, params::Dict{String,<:Any})

Deletes an expired or inactive subscription. Deleting inactive subscriptions removes them
from the Amazon Web Services Management Console view and from list/describe API responses.
Subscriptions can only be cancelled within 7 days of creation and are cancelled by creating
a ticket in the Amazon Web Services Support Center.

# Arguments
- `id`: The ID of the subscription.

"""
function delete_eks_anywhere_subscription(
    id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eks(
        "DELETE",
        "/eks-anywhere-subscriptions/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_eks_anywhere_subscription(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eks(
        "DELETE",
        "/eks-anywhere-subscriptions/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_fargate_profile(fargate_profile_name, name)
    delete_fargate_profile(fargate_profile_name, name, params::Dict{String,<:Any})

Deletes an Fargate profile. When you delete a Fargate profile, any Pod running on Fargate
that was created with the profile is deleted. If the Pod matches another Fargate profile,
then it is scheduled on Fargate with that profile. If it no longer matches any Fargate
profiles, then it's not scheduled on Fargate and may remain in a pending state. Only one
Fargate profile in a cluster can be in the DELETING status at a time. You must wait for a
Fargate profile to finish deleting before you can delete any other profiles in that cluster.

# Arguments
- `fargate_profile_name`: The name of the Fargate profile to delete.
- `name`: The name of your cluster.

"""
function delete_fargate_profile(
    fargateProfileName, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eks(
        "DELETE",
        "/clusters/$(name)/fargate-profiles/$(fargateProfileName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_fargate_profile(
    fargateProfileName,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eks(
        "DELETE",
        "/clusters/$(name)/fargate-profiles/$(fargateProfileName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_nodegroup(name, nodegroup_name)
    delete_nodegroup(name, nodegroup_name, params::Dict{String,<:Any})

Deletes a managed node group.

# Arguments
- `name`: The name of your cluster.
- `nodegroup_name`: The name of the node group to delete.

"""
function delete_nodegroup(
    name, nodegroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eks(
        "DELETE",
        "/clusters/$(name)/node-groups/$(nodegroupName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_nodegroup(
    name,
    nodegroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eks(
        "DELETE",
        "/clusters/$(name)/node-groups/$(nodegroupName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_pod_identity_association(association_id, name)
    delete_pod_identity_association(association_id, name, params::Dict{String,<:Any})

Deletes a EKS Pod Identity association. The temporary Amazon Web Services credentials from
the previous IAM role session might still be valid until the session expiry. If you need to
immediately revoke the temporary session credentials, then go to the role in the IAM
console.

# Arguments
- `association_id`: The ID of the association to be deleted.
- `name`: The cluster name that

"""
function delete_pod_identity_association(
    associationId, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eks(
        "DELETE",
        "/clusters/$(name)/pod-identity-associations/$(associationId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_pod_identity_association(
    associationId,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eks(
        "DELETE",
        "/clusters/$(name)/pod-identity-associations/$(associationId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    deregister_cluster(name)
    deregister_cluster(name, params::Dict{String,<:Any})

Deregisters a connected cluster to remove it from the Amazon EKS control plane. A connected
cluster is a Kubernetes cluster that you've connected to your control plane using the
Amazon EKS Connector.

# Arguments
- `name`: The name of the connected cluster to deregister.

"""
function deregister_cluster(name; aws_config::AbstractAWSConfig=current_aws_config())
    return eks(
        "DELETE",
        "/cluster-registrations/$(name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function deregister_cluster(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eks(
        "DELETE",
        "/cluster-registrations/$(name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_access_entry(name, principal_arn)
    describe_access_entry(name, principal_arn, params::Dict{String,<:Any})

Describes an access entry.

# Arguments
- `name`: The name of your cluster.
- `principal_arn`: The ARN of the IAM principal for the AccessEntry.

"""
function describe_access_entry(
    name, principalArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eks(
        "GET",
        "/clusters/$(name)/access-entries/$(principalArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_access_entry(
    name,
    principalArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eks(
        "GET",
        "/clusters/$(name)/access-entries/$(principalArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_addon(addon_name, name)
    describe_addon(addon_name, name, params::Dict{String,<:Any})

Describes an Amazon EKS add-on.

# Arguments
- `addon_name`: The name of the add-on. The name must match one of the names returned by
  ListAddons .
- `name`: The name of your cluster.

"""
function describe_addon(addonName, name; aws_config::AbstractAWSConfig=current_aws_config())
    return eks(
        "GET",
        "/clusters/$(name)/addons/$(addonName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_addon(
    addonName,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eks(
        "GET",
        "/clusters/$(name)/addons/$(addonName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_addon_configuration(addon_name, addon_version)
    describe_addon_configuration(addon_name, addon_version, params::Dict{String,<:Any})

Returns configuration options.

# Arguments
- `addon_name`: The name of the add-on. The name must match one of the names returned by
  DescribeAddonVersions.
- `addon_version`: The version of the add-on. The version must match one of the versions
  returned by  DescribeAddonVersions .

"""
function describe_addon_configuration(
    addonName, addonVersion; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eks(
        "GET",
        "/addons/configuration-schemas",
        Dict{String,Any}("addonName" => addonName, "addonVersion" => addonVersion);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_addon_configuration(
    addonName,
    addonVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eks(
        "GET",
        "/addons/configuration-schemas",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("addonName" => addonName, "addonVersion" => addonVersion),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_addon_versions()
    describe_addon_versions(params::Dict{String,<:Any})

Describes the versions for an add-on. Information such as the Kubernetes versions that you
can use the add-on with, the owner, publisher, and the type of the add-on are returned.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"addonName"`: The name of the add-on. The name must match one of the names returned by
  ListAddons .
- `"kubernetesVersion"`: The Kubernetes versions that you can use the add-on with.
- `"maxResults"`: The maximum number of results, returned in paginated output. You receive
  maxResults in a single page, along with a nextToken response element. You can see the
  remaining results of the initial request by sending another request with the returned
  nextToken value. This value can be between 1 and 100. If you don't use this parameter, 100
  results and a nextToken value, if applicable, are returned.
- `"nextToken"`: The nextToken value returned from a previous paginated request, where
  maxResults was used and the results exceeded the value of that parameter. Pagination
  continues from the end of the previous results that returned the nextToken value. This
  value is null when there are no more results to return.  This token should be treated as an
  opaque identifier that is used only to retrieve the next items in a list and not for other
  programmatic purposes.
- `"owners"`: The owner of the add-on. For valid owners, don't specify a value for this
  property.
- `"publishers"`: The publisher of the add-on. For valid publishers, don't specify a value
  for this property.
- `"types"`: The type of the add-on. For valid types, don't specify a value for this
  property.
"""
function describe_addon_versions(; aws_config::AbstractAWSConfig=current_aws_config())
    return eks(
        "GET",
        "/addons/supported-versions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_addon_versions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eks(
        "GET",
        "/addons/supported-versions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_cluster(name)
    describe_cluster(name, params::Dict{String,<:Any})

Describes an Amazon EKS cluster. The API server endpoint and certificate authority data
returned by this operation are required for kubelet and kubectl to communicate with your
Kubernetes API server. For more information, see Creating or updating a kubeconfig file for
an Amazon EKS cluster.  The API server endpoint and certificate authority data aren't
available until the cluster reaches the ACTIVE state.

# Arguments
- `name`: The name of your cluster.

"""
function describe_cluster(name; aws_config::AbstractAWSConfig=current_aws_config())
    return eks(
        "GET", "/clusters/$(name)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_cluster(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eks(
        "GET",
        "/clusters/$(name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_eks_anywhere_subscription(id)
    describe_eks_anywhere_subscription(id, params::Dict{String,<:Any})

Returns descriptive information about a subscription.

# Arguments
- `id`: The ID of the subscription.

"""
function describe_eks_anywhere_subscription(
    id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eks(
        "GET",
        "/eks-anywhere-subscriptions/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_eks_anywhere_subscription(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eks(
        "GET",
        "/eks-anywhere-subscriptions/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_fargate_profile(fargate_profile_name, name)
    describe_fargate_profile(fargate_profile_name, name, params::Dict{String,<:Any})

Describes an Fargate profile.

# Arguments
- `fargate_profile_name`: The name of the Fargate profile to describe.
- `name`: The name of your cluster.

"""
function describe_fargate_profile(
    fargateProfileName, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eks(
        "GET",
        "/clusters/$(name)/fargate-profiles/$(fargateProfileName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_fargate_profile(
    fargateProfileName,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eks(
        "GET",
        "/clusters/$(name)/fargate-profiles/$(fargateProfileName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_identity_provider_config(identity_provider_config, name)
    describe_identity_provider_config(identity_provider_config, name, params::Dict{String,<:Any})

Describes an identity provider configuration.

# Arguments
- `identity_provider_config`: An object representing an identity provider configuration.
- `name`: The name of your cluster.

"""
function describe_identity_provider_config(
    identityProviderConfig, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eks(
        "POST",
        "/clusters/$(name)/identity-provider-configs/describe",
        Dict{String,Any}("identityProviderConfig" => identityProviderConfig);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_identity_provider_config(
    identityProviderConfig,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eks(
        "POST",
        "/clusters/$(name)/identity-provider-configs/describe",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("identityProviderConfig" => identityProviderConfig),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_insight(id, name)
    describe_insight(id, name, params::Dict{String,<:Any})

Returns details about an insight that you specify using its ID.

# Arguments
- `id`: The identity of the insight to describe.
- `name`: The name of the cluster to describe the insight for.

"""
function describe_insight(id, name; aws_config::AbstractAWSConfig=current_aws_config())
    return eks(
        "GET",
        "/clusters/$(name)/insights/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_insight(
    id,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eks(
        "GET",
        "/clusters/$(name)/insights/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_nodegroup(name, nodegroup_name)
    describe_nodegroup(name, nodegroup_name, params::Dict{String,<:Any})

Describes a managed node group.

# Arguments
- `name`: The name of your cluster.
- `nodegroup_name`: The name of the node group to describe.

"""
function describe_nodegroup(
    name, nodegroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eks(
        "GET",
        "/clusters/$(name)/node-groups/$(nodegroupName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_nodegroup(
    name,
    nodegroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eks(
        "GET",
        "/clusters/$(name)/node-groups/$(nodegroupName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_pod_identity_association(association_id, name)
    describe_pod_identity_association(association_id, name, params::Dict{String,<:Any})

Returns descriptive information about an EKS Pod Identity association. This action requires
the ID of the association. You can get the ID from the response to the
CreatePodIdentityAssocation for newly created associations. Or, you can list the IDs for
associations with ListPodIdentityAssociations and filter the list by namespace or service
account.

# Arguments
- `association_id`: The ID of the association that you want the description of.
- `name`: The name of the cluster that the association is in.

"""
function describe_pod_identity_association(
    associationId, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eks(
        "GET",
        "/clusters/$(name)/pod-identity-associations/$(associationId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_pod_identity_association(
    associationId,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eks(
        "GET",
        "/clusters/$(name)/pod-identity-associations/$(associationId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_update(name, update_id)
    describe_update(name, update_id, params::Dict{String,<:Any})

Describes an update to an Amazon EKS resource. When the status of the update is Succeeded,
the update is complete. If an update fails, the status is Failed, and an error detail
explains the reason for the failure.

# Arguments
- `name`: The name of the Amazon EKS cluster associated with the update.
- `update_id`: The ID of the update to describe.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"addonName"`: The name of the add-on. The name must match one of the names returned by
  ListAddons . This parameter is required if the update is an add-on update.
- `"nodegroupName"`: The name of the Amazon EKS node group associated with the update. This
  parameter is required if the update is a node group update.
"""
function describe_update(name, updateId; aws_config::AbstractAWSConfig=current_aws_config())
    return eks(
        "GET",
        "/clusters/$(name)/updates/$(updateId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_update(
    name,
    updateId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eks(
        "GET",
        "/clusters/$(name)/updates/$(updateId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_access_policy(name, policy_arn, principal_arn)
    disassociate_access_policy(name, policy_arn, principal_arn, params::Dict{String,<:Any})

Disassociates an access policy from an access entry.

# Arguments
- `name`: The name of your cluster.
- `policy_arn`: The ARN of the policy to disassociate from the access entry. For a list of
  associated policies ARNs, use ListAssociatedAccessPolicies.
- `principal_arn`: The ARN of the IAM principal for the AccessEntry.

"""
function disassociate_access_policy(
    name, policyArn, principalArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eks(
        "DELETE",
        "/clusters/$(name)/access-entries/$(principalArn)/access-policies/$(policyArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_access_policy(
    name,
    policyArn,
    principalArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eks(
        "DELETE",
        "/clusters/$(name)/access-entries/$(principalArn)/access-policies/$(policyArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_identity_provider_config(identity_provider_config, name)
    disassociate_identity_provider_config(identity_provider_config, name, params::Dict{String,<:Any})

Disassociates an identity provider configuration from a cluster. If you disassociate an
identity provider from your cluster, users included in the provider can no longer access
the cluster. However, you can still access the cluster with IAM principals.

# Arguments
- `identity_provider_config`: An object representing an identity provider configuration.
- `name`: The name of your cluster.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientRequestToken"`: A unique, case-sensitive identifier that you provide to ensure
  the idempotency of the request.
"""
function disassociate_identity_provider_config(
    identityProviderConfig, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eks(
        "POST",
        "/clusters/$(name)/identity-provider-configs/disassociate",
        Dict{String,Any}(
            "identityProviderConfig" => identityProviderConfig,
            "clientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_identity_provider_config(
    identityProviderConfig,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eks(
        "POST",
        "/clusters/$(name)/identity-provider-configs/disassociate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "identityProviderConfig" => identityProviderConfig,
                    "clientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_access_entries(name)
    list_access_entries(name, params::Dict{String,<:Any})

Lists the access entries for your cluster.

# Arguments
- `name`: The name of your cluster.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"associatedPolicyArn"`: The ARN of an AccessPolicy. When you specify an access policy
  ARN, only the access entries associated to that access policy are returned. For a list of
  available policy ARNs, use ListAccessPolicies.
- `"maxResults"`: The maximum number of results, returned in paginated output. You receive
  maxResults in a single page, along with a nextToken response element. You can see the
  remaining results of the initial request by sending another request with the returned
  nextToken value. This value can be between 1 and 100. If you don't use this parameter, 100
  results and a nextToken value, if applicable, are returned.
- `"nextToken"`: The nextToken value returned from a previous paginated request, where
  maxResults was used and the results exceeded the value of that parameter. Pagination
  continues from the end of the previous results that returned the nextToken value. This
  value is null when there are no more results to return.  This token should be treated as an
  opaque identifier that is used only to retrieve the next items in a list and not for other
  programmatic purposes.
"""
function list_access_entries(name; aws_config::AbstractAWSConfig=current_aws_config())
    return eks(
        "GET",
        "/clusters/$(name)/access-entries";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_access_entries(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eks(
        "GET",
        "/clusters/$(name)/access-entries",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_access_policies()
    list_access_policies(params::Dict{String,<:Any})

Lists the available access policies.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results, returned in paginated output. You receive
  maxResults in a single page, along with a nextToken response element. You can see the
  remaining results of the initial request by sending another request with the returned
  nextToken value. This value can be between 1 and 100. If you don't use this parameter, 100
  results and a nextToken value, if applicable, are returned.
- `"nextToken"`: The nextToken value returned from a previous paginated request, where
  maxResults was used and the results exceeded the value of that parameter. Pagination
  continues from the end of the previous results that returned the nextToken value. This
  value is null when there are no more results to return.  This token should be treated as an
  opaque identifier that is used only to retrieve the next items in a list and not for other
  programmatic purposes.
"""
function list_access_policies(; aws_config::AbstractAWSConfig=current_aws_config())
    return eks(
        "GET", "/access-policies"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_access_policies(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eks(
        "GET",
        "/access-policies",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_addons(name)
    list_addons(name, params::Dict{String,<:Any})

Lists the installed add-ons.

# Arguments
- `name`: The name of your cluster.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results, returned in paginated output. You receive
  maxResults in a single page, along with a nextToken response element. You can see the
  remaining results of the initial request by sending another request with the returned
  nextToken value. This value can be between 1 and 100. If you don't use this parameter, 100
  results and a nextToken value, if applicable, are returned.
- `"nextToken"`: The nextToken value returned from a previous paginated request, where
  maxResults was used and the results exceeded the value of that parameter. Pagination
  continues from the end of the previous results that returned the nextToken value. This
  value is null when there are no more results to return.  This token should be treated as an
  opaque identifier that is used only to retrieve the next items in a list and not for other
  programmatic purposes.
"""
function list_addons(name; aws_config::AbstractAWSConfig=current_aws_config())
    return eks(
        "GET",
        "/clusters/$(name)/addons";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_addons(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eks(
        "GET",
        "/clusters/$(name)/addons",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_associated_access_policies(name, principal_arn)
    list_associated_access_policies(name, principal_arn, params::Dict{String,<:Any})

Lists the access policies associated with an access entry.

# Arguments
- `name`: The name of your cluster.
- `principal_arn`: The ARN of the IAM principal for the AccessEntry.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results, returned in paginated output. You receive
  maxResults in a single page, along with a nextToken response element. You can see the
  remaining results of the initial request by sending another request with the returned
  nextToken value. This value can be between 1 and 100. If you don't use this parameter, 100
  results and a nextToken value, if applicable, are returned.
- `"nextToken"`: The nextToken value returned from a previous paginated request, where
  maxResults was used and the results exceeded the value of that parameter. Pagination
  continues from the end of the previous results that returned the nextToken value. This
  value is null when there are no more results to return.  This token should be treated as an
  opaque identifier that is used only to retrieve the next items in a list and not for other
  programmatic purposes.
"""
function list_associated_access_policies(
    name, principalArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eks(
        "GET",
        "/clusters/$(name)/access-entries/$(principalArn)/access-policies";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_associated_access_policies(
    name,
    principalArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eks(
        "GET",
        "/clusters/$(name)/access-entries/$(principalArn)/access-policies",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_clusters()
    list_clusters(params::Dict{String,<:Any})

Lists the Amazon EKS clusters in your Amazon Web Services account in the specified Amazon
Web Services Region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"include"`: Indicates whether external clusters are included in the returned list. Use
  'all' to return
  https://docs.aws.amazon.com/eks/latest/userguide/eks-connector.htmlconnected clusters, or
  blank to return only Amazon EKS clusters. 'all' must be in lowercase otherwise an error
  occurs.
- `"maxResults"`: The maximum number of results, returned in paginated output. You receive
  maxResults in a single page, along with a nextToken response element. You can see the
  remaining results of the initial request by sending another request with the returned
  nextToken value. This value can be between 1 and 100. If you don't use this parameter, 100
  results and a nextToken value, if applicable, are returned.
- `"nextToken"`: The nextToken value returned from a previous paginated request, where
  maxResults was used and the results exceeded the value of that parameter. Pagination
  continues from the end of the previous results that returned the nextToken value. This
  value is null when there are no more results to return.  This token should be treated as an
  opaque identifier that is used only to retrieve the next items in a list and not for other
  programmatic purposes.
"""
function list_clusters(; aws_config::AbstractAWSConfig=current_aws_config())
    return eks("GET", "/clusters"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_clusters(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eks(
        "GET", "/clusters", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_eks_anywhere_subscriptions()
    list_eks_anywhere_subscriptions(params::Dict{String,<:Any})

Displays the full description of the subscription.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"includeStatus"`: An array of subscription statuses to filter on.
- `"maxResults"`: The maximum number of cluster results returned by
  ListEksAnywhereSubscriptions in paginated output. When you use this parameter,
  ListEksAnywhereSubscriptions returns only maxResults results in a single page along with a
  nextToken response element. You can see the remaining results of the initial request by
  sending another ListEksAnywhereSubscriptions request with the returned nextToken value.
  This value can be between 1 and 100. If you don't use this parameter,
  ListEksAnywhereSubscriptions returns up to 10 results and a nextToken value if applicable.
- `"nextToken"`: The nextToken value returned from a previous paginated
  ListEksAnywhereSubscriptions request where maxResults was used and the results exceeded the
  value of that parameter. Pagination continues from the end of the previous results that
  returned the nextToken value.
"""
function list_eks_anywhere_subscriptions(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return eks(
        "GET",
        "/eks-anywhere-subscriptions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_eks_anywhere_subscriptions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eks(
        "GET",
        "/eks-anywhere-subscriptions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_fargate_profiles(name)
    list_fargate_profiles(name, params::Dict{String,<:Any})

Lists the Fargate profiles associated with the specified cluster in your Amazon Web
Services account in the specified Amazon Web Services Region.

# Arguments
- `name`: The name of your cluster.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results, returned in paginated output. You receive
  maxResults in a single page, along with a nextToken response element. You can see the
  remaining results of the initial request by sending another request with the returned
  nextToken value. This value can be between 1 and 100. If you don't use this parameter, 100
  results and a nextToken value, if applicable, are returned.
- `"nextToken"`: The nextToken value returned from a previous paginated request, where
  maxResults was used and the results exceeded the value of that parameter. Pagination
  continues from the end of the previous results that returned the nextToken value. This
  value is null when there are no more results to return.  This token should be treated as an
  opaque identifier that is used only to retrieve the next items in a list and not for other
  programmatic purposes.
"""
function list_fargate_profiles(name; aws_config::AbstractAWSConfig=current_aws_config())
    return eks(
        "GET",
        "/clusters/$(name)/fargate-profiles";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_fargate_profiles(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eks(
        "GET",
        "/clusters/$(name)/fargate-profiles",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_identity_provider_configs(name)
    list_identity_provider_configs(name, params::Dict{String,<:Any})

Lists the identity provider configurations for your cluster.

# Arguments
- `name`: The name of your cluster.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results, returned in paginated output. You receive
  maxResults in a single page, along with a nextToken response element. You can see the
  remaining results of the initial request by sending another request with the returned
  nextToken value. This value can be between 1 and 100. If you don't use this parameter, 100
  results and a nextToken value, if applicable, are returned.
- `"nextToken"`: The nextToken value returned from a previous paginated request, where
  maxResults was used and the results exceeded the value of that parameter. Pagination
  continues from the end of the previous results that returned the nextToken value. This
  value is null when there are no more results to return.  This token should be treated as an
  opaque identifier that is used only to retrieve the next items in a list and not for other
  programmatic purposes.
"""
function list_identity_provider_configs(
    name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eks(
        "GET",
        "/clusters/$(name)/identity-provider-configs";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_identity_provider_configs(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eks(
        "GET",
        "/clusters/$(name)/identity-provider-configs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_insights(name)
    list_insights(name, params::Dict{String,<:Any})

Returns a list of all insights checked for against the specified cluster. You can filter
which insights are returned by category, associated Kubernetes version, and status.

# Arguments
- `name`: The name of the Amazon EKS cluster associated with the insights.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filter"`: The criteria to filter your list of insights for your cluster. You can filter
  which insights are returned by category, associated Kubernetes version, and status.
- `"maxResults"`: The maximum number of identity provider configurations returned by
  ListInsights in paginated output. When you use this parameter, ListInsights returns only
  maxResults results in a single page along with a nextToken response element. You can see
  the remaining results of the initial request by sending another ListInsights request with
  the returned nextToken value. This value can be between 1 and 100. If you don't use this
  parameter, ListInsights returns up to 100 results and a nextToken value, if applicable.
- `"nextToken"`: The nextToken value returned from a previous paginated ListInsights
  request. When the results of a ListInsights request exceed maxResults, you can use this
  value to retrieve the next page of results. This value is null when there are no more
  results to return.
"""
function list_insights(name; aws_config::AbstractAWSConfig=current_aws_config())
    return eks(
        "POST",
        "/clusters/$(name)/insights";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_insights(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eks(
        "POST",
        "/clusters/$(name)/insights",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_nodegroups(name)
    list_nodegroups(name, params::Dict{String,<:Any})

Lists the managed node groups associated with the specified cluster in your Amazon Web
Services account in the specified Amazon Web Services Region. Self-managed node groups
aren't listed.

# Arguments
- `name`: The name of your cluster.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results, returned in paginated output. You receive
  maxResults in a single page, along with a nextToken response element. You can see the
  remaining results of the initial request by sending another request with the returned
  nextToken value. This value can be between 1 and 100. If you don't use this parameter, 100
  results and a nextToken value, if applicable, are returned.
- `"nextToken"`: The nextToken value returned from a previous paginated request, where
  maxResults was used and the results exceeded the value of that parameter. Pagination
  continues from the end of the previous results that returned the nextToken value. This
  value is null when there are no more results to return.  This token should be treated as an
  opaque identifier that is used only to retrieve the next items in a list and not for other
  programmatic purposes.
"""
function list_nodegroups(name; aws_config::AbstractAWSConfig=current_aws_config())
    return eks(
        "GET",
        "/clusters/$(name)/node-groups";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_nodegroups(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eks(
        "GET",
        "/clusters/$(name)/node-groups",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_pod_identity_associations(name)
    list_pod_identity_associations(name, params::Dict{String,<:Any})

List the EKS Pod Identity associations in a cluster. You can filter the list by the
namespace that the association is in or the service account that the association uses.

# Arguments
- `name`: The name of the cluster that the associations are in.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of EKS Pod Identity association results returned by
  ListPodIdentityAssociations in paginated output. When you use this parameter,
  ListPodIdentityAssociations returns only maxResults results in a single page along with a
  nextToken response element. You can see the remaining results of the initial request by
  sending another ListPodIdentityAssociations request with the returned nextToken value. This
  value can be between 1 and 100. If you don't use this parameter,
  ListPodIdentityAssociations returns up to 100 results and a nextToken value if applicable.
- `"namespace"`: The name of the Kubernetes namespace inside the cluster that the
  associations are in.
- `"nextToken"`: The nextToken value returned from a previous paginated ListUpdates request
  where maxResults was used and the results exceeded the value of that parameter. Pagination
  continues from the end of the previous results that returned the nextToken value.  This
  token should be treated as an opaque identifier that is used only to retrieve the next
  items in a list and not for other programmatic purposes.
- `"serviceAccount"`: The name of the Kubernetes service account that the associations use.
"""
function list_pod_identity_associations(
    name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eks(
        "GET",
        "/clusters/$(name)/pod-identity-associations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_pod_identity_associations(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eks(
        "GET",
        "/clusters/$(name)/pod-identity-associations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

List the tags for an Amazon EKS resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) that identifies the resource to list tags
  for.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eks(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eks(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_updates(name)
    list_updates(name, params::Dict{String,<:Any})

Lists the updates associated with an Amazon EKS resource in your Amazon Web Services
account, in the specified Amazon Web Services Region.

# Arguments
- `name`: The name of the Amazon EKS cluster to list updates for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"addonName"`: The names of the installed add-ons that have available updates.
- `"maxResults"`: The maximum number of results, returned in paginated output. You receive
  maxResults in a single page, along with a nextToken response element. You can see the
  remaining results of the initial request by sending another request with the returned
  nextToken value. This value can be between 1 and 100. If you don't use this parameter, 100
  results and a nextToken value, if applicable, are returned.
- `"nextToken"`: The nextToken value returned from a previous paginated request, where
  maxResults was used and the results exceeded the value of that parameter. Pagination
  continues from the end of the previous results that returned the nextToken value. This
  value is null when there are no more results to return.  This token should be treated as an
  opaque identifier that is used only to retrieve the next items in a list and not for other
  programmatic purposes.
- `"nodegroupName"`: The name of the Amazon EKS managed node group to list updates for.
"""
function list_updates(name; aws_config::AbstractAWSConfig=current_aws_config())
    return eks(
        "GET",
        "/clusters/$(name)/updates";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_updates(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eks(
        "GET",
        "/clusters/$(name)/updates",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    register_cluster(connector_config, name)
    register_cluster(connector_config, name, params::Dict{String,<:Any})

Connects a Kubernetes cluster to the Amazon EKS control plane.  Any Kubernetes cluster can
be connected to the Amazon EKS control plane to view current information about the cluster
and its nodes.  Cluster connection requires two steps. First, send a
RegisterClusterRequest  to add it to the Amazon EKS control plane. Second, a Manifest
containing the activationID and activationCode must be applied to the Kubernetes cluster
through it's native provider to provide visibility. After the manifest is updated and
applied, the connected cluster is visible to the Amazon EKS control plane. If the manifest
isn't applied within three days, the connected cluster will no longer be visible and must
be deregistered using DeregisterCluster.

# Arguments
- `connector_config`: The configuration settings required to connect the Kubernetes cluster
  to the Amazon EKS control plane.
- `name`: A unique name for this cluster in your Amazon Web Services Region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientRequestToken"`: A unique, case-sensitive identifier that you provide to ensure
  the idempotency of the request.
- `"tags"`: Metadata that assists with categorization and organization. Each tag consists
  of a key and an optional value. You define both. Tags don't propagate to any other cluster
  or Amazon Web Services resources.
"""
function register_cluster(
    connectorConfig, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eks(
        "POST",
        "/cluster-registrations",
        Dict{String,Any}(
            "connectorConfig" => connectorConfig,
            "name" => name,
            "clientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function register_cluster(
    connectorConfig,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eks(
        "POST",
        "/cluster-registrations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "connectorConfig" => connectorConfig,
                    "name" => name,
                    "clientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Associates the specified tags to an Amazon EKS resource with the specified resourceArn. If
existing tags on a resource are not specified in the request parameters, they aren't
changed. When a resource is deleted, the tags associated with that resource are also
deleted. Tags that you create for Amazon EKS resources don't propagate to any other
resources associated with the cluster. For example, if you tag a cluster with this
operation, that tag doesn't automatically propagate to the subnets and nodes associated
with the cluster.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource to add tags to.
- `tags`: Metadata that assists with categorization and organization. Each tag consists of
  a key and an optional value. You define both. Tags don't propagate to any other cluster or
  Amazon Web Services resources.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return eks(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eks(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Deletes specified tags from an Amazon EKS resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource to delete tags from.
- `tag_keys`: The keys of the tags to remove.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eks(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eks(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_access_entry(name, principal_arn)
    update_access_entry(name, principal_arn, params::Dict{String,<:Any})

Updates an access entry.

# Arguments
- `name`: The name of your cluster.
- `principal_arn`: The ARN of the IAM principal for the AccessEntry.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientRequestToken"`: A unique, case-sensitive identifier that you provide to ensure
  the idempotency of the request.
- `"kubernetesGroups"`: The value for name that you've specified for kind: Group as a
  subject in a Kubernetes RoleBinding or ClusterRoleBinding object. Amazon EKS doesn't
  confirm that the value for name exists in any bindings on your cluster. You can specify one
  or more names. Kubernetes authorizes the principalArn of the access entry to access any
  cluster objects that you've specified in a Kubernetes Role or ClusterRole object that is
  also specified in a binding's roleRef. For more information about creating Kubernetes
  RoleBinding, ClusterRoleBinding, Role, or ClusterRole objects, see Using RBAC Authorization
  in the Kubernetes documentation. If you want Amazon EKS to authorize the principalArn
  (instead of, or in addition to Kubernetes authorizing the principalArn), you can associate
  one or more access policies to the access entry using AssociateAccessPolicy. If you
  associate any access policies, the principalARN has all permissions assigned in the
  associated access policies and all permissions in any Kubernetes Role or ClusterRole
  objects that the group names are bound to.
- `"username"`: The username to authenticate to Kubernetes with. We recommend not
  specifying a username and letting Amazon EKS specify it for you. For more information about
  the value Amazon EKS specifies for you, or constraints before specifying your own username,
  see Creating access entries in the Amazon EKS User Guide.
"""
function update_access_entry(
    name, principalArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eks(
        "POST",
        "/clusters/$(name)/access-entries/$(principalArn)",
        Dict{String,Any}("clientRequestToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_access_entry(
    name,
    principalArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eks(
        "POST",
        "/clusters/$(name)/access-entries/$(principalArn)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("clientRequestToken" => string(uuid4())), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_addon(addon_name, name)
    update_addon(addon_name, name, params::Dict{String,<:Any})

Updates an Amazon EKS add-on.

# Arguments
- `addon_name`: The name of the add-on. The name must match one of the names returned by
  ListAddons .
- `name`: The name of your cluster.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"addonVersion"`: The version of the add-on. The version must match one of the versions
  returned by  DescribeAddonVersions .
- `"clientRequestToken"`: A unique, case-sensitive identifier that you provide to ensure
  the idempotency of the request.
- `"configurationValues"`: The set of configuration values for the add-on that's created.
  The values that you provide are validated against the schema returned by
  DescribeAddonConfiguration.
- `"podIdentityAssociations"`: An array of Pod Identity Assocations to be updated. Each EKS
  Pod Identity association maps a Kubernetes service account to an IAM Role. If this value is
  left blank, no change. If an empty array is provided, existing Pod Identity Assocations
  owned by the Addon are deleted. For more information, see Attach an IAM Role to an Amazon
  EKS add-on using Pod Identity in the EKS User Guide.
- `"resolveConflicts"`: How to resolve field value conflicts for an Amazon EKS add-on if
  you've changed a value from the Amazon EKS default value. Conflicts are handled based on
  the option you choose:    None – Amazon EKS doesn't change the value. The update might
  fail.    Overwrite – Amazon EKS overwrites the changed value back to the Amazon EKS
  default value.    Preserve – Amazon EKS preserves the value. If you choose this option,
  we recommend that you test any field and value changes on a non-production cluster before
  updating the add-on on your production cluster.
- `"serviceAccountRoleArn"`: The Amazon Resource Name (ARN) of an existing IAM role to bind
  to the add-on's service account. The role must be assigned the IAM permissions required by
  the add-on. If you don't specify an existing IAM role, then the add-on uses the permissions
  assigned to the node IAM role. For more information, see Amazon EKS node IAM role in the
  Amazon EKS User Guide.  To specify an existing IAM role, you must have an IAM OpenID
  Connect (OIDC) provider created for your cluster. For more information, see Enabling IAM
  roles for service accounts on your cluster in the Amazon EKS User Guide.
"""
function update_addon(addonName, name; aws_config::AbstractAWSConfig=current_aws_config())
    return eks(
        "POST",
        "/clusters/$(name)/addons/$(addonName)/update",
        Dict{String,Any}("clientRequestToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_addon(
    addonName,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eks(
        "POST",
        "/clusters/$(name)/addons/$(addonName)/update",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("clientRequestToken" => string(uuid4())), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_cluster_config(name)
    update_cluster_config(name, params::Dict{String,<:Any})

Updates an Amazon EKS cluster configuration. Your cluster continues to function during the
update. The response output includes an update ID that you can use to track the status of
your cluster update with DescribeUpdate\"/&gt;. You can use this API operation to enable or
disable exporting the Kubernetes control plane logs for your cluster to CloudWatch Logs. By
default, cluster control plane logs aren't exported to CloudWatch Logs. For more
information, see Amazon EKS Cluster control plane logs in the  Amazon EKS User Guide .
CloudWatch Logs ingestion, archive storage, and data scanning rates apply to exported
control plane logs. For more information, see CloudWatch Pricing.  You can also use this
API operation to enable or disable public and private access to your cluster's Kubernetes
API server endpoint. By default, public access is enabled, and private access is disabled.
For more information, see Amazon EKS cluster endpoint access control in the  Amazon EKS
User Guide . You can also use this API operation to choose different subnets and security
groups for the cluster. You must specify at least two subnets that are in different
Availability Zones. You can't change which VPC the subnets are from, the subnets must be in
the same VPC as the subnets that the cluster was created with. For more information about
the VPC requirements, see
https://docs.aws.amazon.com/eks/latest/userguide/network_reqs.html in the  Amazon EKS User
Guide . Cluster updates are asynchronous, and they should finish within a few minutes.
During an update, the cluster status moves to UPDATING (this status transition is
eventually consistent). When the update is complete (either Failed or Successful), the
cluster status moves to Active.

# Arguments
- `name`: The name of the Amazon EKS cluster to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accessConfig"`: The access configuration for the cluster.
- `"clientRequestToken"`: A unique, case-sensitive identifier that you provide to ensure
  the idempotency of the request.
- `"logging"`: Enable or disable exporting the Kubernetes control plane logs for your
  cluster to CloudWatch Logs. By default, cluster control plane logs aren't exported to
  CloudWatch Logs. For more information, see Amazon EKS cluster control plane logs in the
  Amazon EKS User Guide .  CloudWatch Logs ingestion, archive storage, and data scanning
  rates apply to exported control plane logs. For more information, see CloudWatch Pricing.
- `"resourcesVpcConfig"`:
"""
function update_cluster_config(name; aws_config::AbstractAWSConfig=current_aws_config())
    return eks(
        "POST",
        "/clusters/$(name)/update-config",
        Dict{String,Any}("clientRequestToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_cluster_config(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eks(
        "POST",
        "/clusters/$(name)/update-config",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("clientRequestToken" => string(uuid4())), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_cluster_version(name, version)
    update_cluster_version(name, version, params::Dict{String,<:Any})

Updates an Amazon EKS cluster to the specified Kubernetes version. Your cluster continues
to function during the update. The response output includes an update ID that you can use
to track the status of your cluster update with the DescribeUpdate API operation. Cluster
updates are asynchronous, and they should finish within a few minutes. During an update,
the cluster status moves to UPDATING (this status transition is eventually consistent).
When the update is complete (either Failed or Successful), the cluster status moves to
Active. If your cluster has managed node groups attached to it, all of your node groups’
Kubernetes versions must match the cluster’s Kubernetes version in order to update the
cluster to a new Kubernetes version.

# Arguments
- `name`: The name of the Amazon EKS cluster to update.
- `version`: The desired Kubernetes version following a successful update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientRequestToken"`: A unique, case-sensitive identifier that you provide to ensure
  the idempotency of the request.
"""
function update_cluster_version(
    name, version; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eks(
        "POST",
        "/clusters/$(name)/updates",
        Dict{String,Any}("version" => version, "clientRequestToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_cluster_version(
    name,
    version,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eks(
        "POST",
        "/clusters/$(name)/updates",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "version" => version, "clientRequestToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_eks_anywhere_subscription(auto_renew, id)
    update_eks_anywhere_subscription(auto_renew, id, params::Dict{String,<:Any})

Update an EKS Anywhere Subscription. Only auto renewal and tags can be updated after
subscription creation.

# Arguments
- `auto_renew`: A boolean indicating whether or not to automatically renew the subscription.
- `id`: The ID of the subscription.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientRequestToken"`: Unique, case-sensitive identifier to ensure the idempotency of
  the request.
"""
function update_eks_anywhere_subscription(
    autoRenew, id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eks(
        "POST",
        "/eks-anywhere-subscriptions/$(id)",
        Dict{String,Any}("autoRenew" => autoRenew, "clientRequestToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_eks_anywhere_subscription(
    autoRenew,
    id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eks(
        "POST",
        "/eks-anywhere-subscriptions/$(id)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "autoRenew" => autoRenew, "clientRequestToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_nodegroup_config(name, nodegroup_name)
    update_nodegroup_config(name, nodegroup_name, params::Dict{String,<:Any})

Updates an Amazon EKS managed node group configuration. Your node group continues to
function during the update. The response output includes an update ID that you can use to
track the status of your node group update with the DescribeUpdate API operation. Currently
you can update the Kubernetes labels for a node group or the scaling configuration.

# Arguments
- `name`: The name of your cluster.
- `nodegroup_name`: The name of the managed node group to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientRequestToken"`: A unique, case-sensitive identifier that you provide to ensure
  the idempotency of the request.
- `"labels"`: The Kubernetes labels to apply to the nodes in the node group after the
  update.
- `"scalingConfig"`: The scaling configuration details for the Auto Scaling group after the
  update.
- `"taints"`: The Kubernetes taints to be applied to the nodes in the node group after the
  update. For more information, see Node taints on managed node groups.
- `"updateConfig"`: The node group update configuration.
"""
function update_nodegroup_config(
    name, nodegroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eks(
        "POST",
        "/clusters/$(name)/node-groups/$(nodegroupName)/update-config",
        Dict{String,Any}("clientRequestToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_nodegroup_config(
    name,
    nodegroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eks(
        "POST",
        "/clusters/$(name)/node-groups/$(nodegroupName)/update-config",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("clientRequestToken" => string(uuid4())), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_nodegroup_version(name, nodegroup_name)
    update_nodegroup_version(name, nodegroup_name, params::Dict{String,<:Any})

Updates the Kubernetes version or AMI version of an Amazon EKS managed node group. You can
update a node group using a launch template only if the node group was originally deployed
with a launch template. If you need to update a custom AMI in a node group that was
deployed with a launch template, then update your custom AMI, specify the new ID in a new
version of the launch template, and then update the node group to the new version of the
launch template. If you update without a launch template, then you can update to the latest
available AMI version of a node group's current Kubernetes version by not specifying a
Kubernetes version in the request. You can update to the latest AMI version of your
cluster's current Kubernetes version by specifying your cluster's Kubernetes version in the
request. For information about Linux versions, see Amazon EKS optimized Amazon Linux AMI
versions in the Amazon EKS User Guide. For information about Windows versions, see Amazon
EKS optimized Windows AMI versions in the Amazon EKS User Guide.  You cannot roll back a
node group to an earlier Kubernetes version or AMI version. When a node in a managed node
group is terminated due to a scaling action or update, every Pod on that node is drained
first. Amazon EKS attempts to drain the nodes gracefully and will fail if it is unable to
do so. You can force the update if Amazon EKS is unable to drain the nodes as a result of a
Pod disruption budget issue.

# Arguments
- `name`: The name of your cluster.
- `nodegroup_name`: The name of the managed node group to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientRequestToken"`: A unique, case-sensitive identifier that you provide to ensure
  the idempotency of the request.
- `"force"`: Force the update if any Pod on the existing node group can't be drained due to
  a Pod disruption budget issue. If an update fails because all Pods can't be drained, you
  can force the update after it fails to terminate the old node whether or not any Pod is
  running on the node.
- `"launchTemplate"`: An object representing a node group's launch template specification.
  You can only update a node group using a launch template if the node group was originally
  deployed with a launch template.
- `"releaseVersion"`: The AMI version of the Amazon EKS optimized AMI to use for the
  update. By default, the latest available AMI version for the node group's Kubernetes
  version is used. For information about Linux versions, see Amazon EKS optimized Amazon
  Linux AMI versions in the Amazon EKS User Guide. Amazon EKS managed node groups support the
  November 2022 and later releases of the Windows AMIs. For information about Windows
  versions, see Amazon EKS optimized Windows AMI versions in the Amazon EKS User Guide. If
  you specify launchTemplate, and your launch template uses a custom AMI, then don't specify
  releaseVersion, or the node group update will fail. For more information about using launch
  templates with Amazon EKS, see Customizing managed nodes with launch templates in the
  Amazon EKS User Guide.
- `"version"`: The Kubernetes version to update to. If no version is specified, then the
  Kubernetes version of the node group does not change. You can specify the Kubernetes
  version of the cluster to update the node group to the latest AMI version of the cluster's
  Kubernetes version. If you specify launchTemplate, and your launch template uses a custom
  AMI, then don't specify version, or the node group update will fail. For more information
  about using launch templates with Amazon EKS, see Customizing managed nodes with launch
  templates in the Amazon EKS User Guide.
"""
function update_nodegroup_version(
    name, nodegroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eks(
        "POST",
        "/clusters/$(name)/node-groups/$(nodegroupName)/update-version",
        Dict{String,Any}("clientRequestToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_nodegroup_version(
    name,
    nodegroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eks(
        "POST",
        "/clusters/$(name)/node-groups/$(nodegroupName)/update-version",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("clientRequestToken" => string(uuid4())), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_pod_identity_association(association_id, name)
    update_pod_identity_association(association_id, name, params::Dict{String,<:Any})

Updates a EKS Pod Identity association. Only the IAM role can be changed; an association
can't be moved between clusters, namespaces, or service accounts. If you need to edit the
namespace or service account, you need to delete the association and then create a new
association with your desired settings.

# Arguments
- `association_id`: The ID of the association to be updated.
- `name`: The name of the cluster that you want to update the association in.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientRequestToken"`: A unique, case-sensitive identifier that you provide to ensure
  the idempotency of the request.
- `"roleArn"`: The new IAM role to change the
"""
function update_pod_identity_association(
    associationId, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eks(
        "POST",
        "/clusters/$(name)/pod-identity-associations/$(associationId)",
        Dict{String,Any}("clientRequestToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_pod_identity_association(
    associationId,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eks(
        "POST",
        "/clusters/$(name)/pod-identity-associations/$(associationId)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("clientRequestToken" => string(uuid4())), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: batch
using AWS.Compat
using AWS.UUIDs

"""
    cancel_job(job_id, reason)
    cancel_job(job_id, reason, params::Dict{String,<:Any})

Cancels a job in an Batch job queue. Jobs that are in the SUBMITTED or PENDING are
canceled. A job inRUNNABLE remains in RUNNABLE until it reaches the head of the job queue.
Then the job status is updated to FAILED.  A PENDING job is canceled after all dependency
jobs are completed. Therefore, it may take longer than expected to cancel a job in PENDING
status. When you try to cancel an array parent job in PENDING, Batch attempts to cancel all
child jobs. The array parent job is canceled when all child jobs are completed.  Jobs that
progressed to the STARTING or RUNNING state aren't canceled. However, the API operation
still succeeds, even if no job is canceled. These jobs must be terminated with the
TerminateJob operation.

# Arguments
- `job_id`: The Batch job ID of the job to cancel.
- `reason`: A message to attach to the job that explains the reason for canceling it. This
  message is returned by future DescribeJobs operations on the job. This message is also
  recorded in the Batch activity logs.

"""
function cancel_job(jobId, reason; aws_config::AbstractAWSConfig=current_aws_config())
    return batch(
        "POST",
        "/v1/canceljob",
        Dict{String,Any}("jobId" => jobId, "reason" => reason);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_job(
    jobId,
    reason,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return batch(
        "POST",
        "/v1/canceljob",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("jobId" => jobId, "reason" => reason), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_compute_environment(compute_environment_name, type)
    create_compute_environment(compute_environment_name, type, params::Dict{String,<:Any})

Creates an Batch compute environment. You can create MANAGED or UNMANAGED compute
environments. MANAGED compute environments can use Amazon EC2 or Fargate resources.
UNMANAGED compute environments can only use EC2 resources. In a managed compute
environment, Batch manages the capacity and instance types of the compute resources within
the environment. This is based on the compute resource specification that you define or the
launch template that you specify when you create the compute environment. Either, you can
choose to use EC2 On-Demand Instances and EC2 Spot Instances. Or, you can use Fargate and
Fargate Spot capacity in your managed compute environment. You can optionally set a maximum
price so that Spot Instances only launch when the Spot Instance price is less than a
specified percentage of the On-Demand price.  Multi-node parallel jobs aren't supported on
Spot Instances.  In an unmanaged compute environment, you can manage your own EC2 compute
resources and have flexibility with how you configure your compute resources. For example,
you can use custom AMIs. However, you must verify that each of your AMIs meet the Amazon
ECS container instance AMI specification. For more information, see container instance AMIs
in the Amazon Elastic Container Service Developer Guide. After you created your unmanaged
compute environment, you can use the DescribeComputeEnvironments operation to find the
Amazon ECS cluster that's associated with it. Then, launch your container instances into
that Amazon ECS cluster. For more information, see Launching an Amazon ECS container
instance in the Amazon Elastic Container Service Developer Guide.  To create a compute
environment that uses EKS resources, the caller must have permissions to call
eks:DescribeCluster.   Batch doesn't automatically upgrade the AMIs in a compute
environment after it's created. For example, it also doesn't update the AMIs in your
compute environment when a newer version of the Amazon ECS optimized AMI is available.
You're responsible for the management of the guest operating system. This includes any
updates and security patches. You're also responsible for any additional application
software or utilities that you install on the compute resources. There are two ways to use
a new AMI for your Batch jobs. The original method is to complete these steps:   Create a
new compute environment with the new AMI.   Add the compute environment to an existing job
queue.   Remove the earlier compute environment from your job queue.   Delete the earlier
compute environment.   In April 2022, Batch added enhanced support for updating compute
environments. For more information, see Updating compute environments. To use the enhanced
updating of compute environments to update AMIs, follow these rules:   Either don't set the
service role (serviceRole) parameter or set it to the AWSBatchServiceRole service-linked
role.   Set the allocation strategy (allocationStrategy) parameter to BEST_FIT_PROGRESSIVE,
SPOT_CAPACITY_OPTIMIZED, or SPOT_PRICE_CAPACITY_OPTIMIZED.   Set the update to latest image
version (updateToLatestImageVersion) parameter to true. The updateToLatestImageVersion
parameter is used when you update a compute environment. This parameter is ignored when you
create a compute environment.   Don't specify an AMI ID in imageId, imageIdOverride (in
ec2Configuration ), or in the launch template (launchTemplate). In that case, Batch selects
the latest Amazon ECS optimized AMI that's supported by Batch at the time the
infrastructure update is initiated. Alternatively, you can specify the AMI ID in the
imageId or imageIdOverride parameters, or the launch template identified by the
LaunchTemplate properties. Changing any of these properties starts an infrastructure
update. If the AMI ID is specified in the launch template, it can't be replaced by
specifying an AMI ID in either the imageId or imageIdOverride parameters. It can only be
replaced by specifying a different launch template, or if the launch template version is
set to Default or Latest, by setting either a new default version for the launch template
(if Default) or by adding a new version to the launch template (if Latest).   If these
rules are followed, any update that starts an infrastructure update causes the AMI ID to be
re-selected. If the version setting in the launch template (launchTemplate) is set to
Latest or Default, the latest or default version of the launch template is evaluated up at
the time of the infrastructure update, even if the launchTemplate wasn't updated.

# Arguments
- `compute_environment_name`: The name for your compute environment. It can be up to 128
  characters long. It can contain uppercase and lowercase letters, numbers, hyphens (-), and
  underscores (_).
- `type`: The type of the compute environment: MANAGED or UNMANAGED. For more information,
  see Compute Environments in the Batch User Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"computeResources"`: Details about the compute resources managed by the compute
  environment. This parameter is required for managed compute environments. For more
  information, see Compute Environments in the Batch User Guide.
- `"eksConfiguration"`: The details for the Amazon EKS cluster that supports the compute
  environment.
- `"serviceRole"`: The full Amazon Resource Name (ARN) of the IAM role that allows Batch to
  make calls to other Amazon Web Services services on your behalf. For more information, see
  Batch service IAM role in the Batch User Guide.  If your account already created the Batch
  service-linked role, that role is used by default for your compute environment unless you
  specify a different role here. If the Batch service-linked role doesn't exist in your
  account, and no role is specified here, the service attempts to create the Batch
  service-linked role in your account.  If your specified role has a path other than /, then
  you must specify either the full role ARN (recommended) or prefix the role name with the
  path. For example, if a role with the name bar has a path of /foo/, specify /foo/bar as the
  role name. For more information, see Friendly names and paths in the IAM User Guide.
  Depending on how you created your Batch service role, its ARN might contain the
  service-role path prefix. When you only specify the name of the service role, Batch assumes
  that your ARN doesn't use the service-role path prefix. Because of this, we recommend that
  you specify the full ARN of your service role when you create compute environments.
- `"state"`: The state of the compute environment. If the state is ENABLED, then the
  compute environment accepts jobs from a queue and can scale out automatically based on
  queues. If the state is ENABLED, then the Batch scheduler can attempt to place jobs from an
  associated job queue on the compute resources within the environment. If the compute
  environment is managed, then it can scale its instances out or in automatically, based on
  the job queue demand. If the state is DISABLED, then the Batch scheduler doesn't attempt to
  place jobs within the environment. Jobs in a STARTING or RUNNING state continue to progress
  normally. Managed compute environments in the DISABLED state don't scale out.   Compute
  environments in a DISABLED state may continue to incur billing charges. To prevent
  additional charges, turn off and then delete the compute environment. For more information,
  see State in the Batch User Guide.  When an instance is idle, the instance scales down to
  the minvCpus value. However, the instance size doesn't change. For example, consider a
  c5.8xlarge instance with a minvCpus value of 4 and a desiredvCpus value of 36. This
  instance doesn't scale down to a c5.large instance.
- `"tags"`: The tags that you apply to the compute environment to help you categorize and
  organize your resources. Each tag consists of a key and an optional value. For more
  information, see Tagging Amazon Web Services Resources in Amazon Web Services General
  Reference. These tags can be updated or removed using the TagResource and UntagResource API
  operations. These tags don't propagate to the underlying compute resources.
- `"unmanagedvCpus"`: The maximum number of vCPUs for an unmanaged compute environment.
  This parameter is only used for fair share scheduling to reserve vCPU capacity for new
  share identifiers. If this parameter isn't provided for a fair share job queue, no vCPU
  capacity is reserved.  This parameter is only supported when the type parameter is set to
  UNMANAGED.
"""
function create_compute_environment(
    computeEnvironmentName, type; aws_config::AbstractAWSConfig=current_aws_config()
)
    return batch(
        "POST",
        "/v1/createcomputeenvironment",
        Dict{String,Any}(
            "computeEnvironmentName" => computeEnvironmentName, "type" => type
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_compute_environment(
    computeEnvironmentName,
    type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return batch(
        "POST",
        "/v1/createcomputeenvironment",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "computeEnvironmentName" => computeEnvironmentName, "type" => type
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_job_queue(compute_environment_order, job_queue_name, priority)
    create_job_queue(compute_environment_order, job_queue_name, priority, params::Dict{String,<:Any})

Creates an Batch job queue. When you create a job queue, you associate one or more compute
environments to the queue and assign an order of preference for the compute environments.
You also set a priority to the job queue that determines the order that the Batch scheduler
places jobs onto its associated compute environments. For example, if a compute environment
is associated with more than one job queue, the job queue with a higher priority is given
preference for scheduling jobs to that compute environment.

# Arguments
- `compute_environment_order`: The set of compute environments mapped to a job queue and
  their order relative to each other. The job scheduler uses this parameter to determine
  which compute environment runs a specific job. Compute environments must be in the VALID
  state before you can associate them with a job queue. You can associate up to three compute
  environments with a job queue. All of the compute environments must be either EC2 (EC2 or
  SPOT) or Fargate (FARGATE or FARGATE_SPOT); EC2 and Fargate compute environments can't be
  mixed.  All compute environments that are associated with a job queue must share the same
  architecture. Batch doesn't support mixing compute environment architecture types in a
  single job queue.
- `job_queue_name`: The name of the job queue. It can be up to 128 letters long. It can
  contain uppercase and lowercase letters, numbers, hyphens (-), and underscores (_).
- `priority`: The priority of the job queue. Job queues with a higher priority (or a higher
  integer value for the priority parameter) are evaluated first when associated with the same
  compute environment. Priority is determined in descending order. For example, a job queue
  with a priority value of 10 is given scheduling preference over a job queue with a priority
  value of 1. All of the compute environments must be either EC2 (EC2 or SPOT) or Fargate
  (FARGATE or FARGATE_SPOT); EC2 and Fargate compute environments can't be mixed.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"jobStateTimeLimitActions"`: The set of actions that Batch performs on jobs that remain
  at the head of the job queue in the specified state longer than specified times. Batch will
  perform each action after maxTimeSeconds has passed.
- `"schedulingPolicyArn"`: The Amazon Resource Name (ARN) of the fair share scheduling
  policy. If this parameter is specified, the job queue uses a fair share scheduling policy.
  If this parameter isn't specified, the job queue uses a first in, first out (FIFO)
  scheduling policy. After a job queue is created, you can replace but can't remove the fair
  share scheduling policy. The format is
  aws:Partition:batch:Region:Account:scheduling-policy/Name . An example is
  aws:aws:batch:us-west-2:123456789012:scheduling-policy/MySchedulingPolicy.
- `"state"`: The state of the job queue. If the job queue state is ENABLED, it is able to
  accept jobs. If the job queue state is DISABLED, new jobs can't be added to the queue, but
  jobs already in the queue can finish.
- `"tags"`: The tags that you apply to the job queue to help you categorize and organize
  your resources. Each tag consists of a key and an optional value. For more information, see
  Tagging your Batch resources in Batch User Guide.
"""
function create_job_queue(
    computeEnvironmentOrder,
    jobQueueName,
    priority;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return batch(
        "POST",
        "/v1/createjobqueue",
        Dict{String,Any}(
            "computeEnvironmentOrder" => computeEnvironmentOrder,
            "jobQueueName" => jobQueueName,
            "priority" => priority,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_job_queue(
    computeEnvironmentOrder,
    jobQueueName,
    priority,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return batch(
        "POST",
        "/v1/createjobqueue",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "computeEnvironmentOrder" => computeEnvironmentOrder,
                    "jobQueueName" => jobQueueName,
                    "priority" => priority,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_scheduling_policy(name)
    create_scheduling_policy(name, params::Dict{String,<:Any})

Creates an Batch scheduling policy.

# Arguments
- `name`: The name of the scheduling policy. It can be up to 128 letters long. It can
  contain uppercase and lowercase letters, numbers, hyphens (-), and underscores (_).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"fairsharePolicy"`: The fair share policy of the scheduling policy.
- `"tags"`: The tags that you apply to the scheduling policy to help you categorize and
  organize your resources. Each tag consists of a key and an optional value. For more
  information, see Tagging Amazon Web Services Resources in Amazon Web Services General
  Reference. These tags can be updated or removed using the TagResource and UntagResource API
  operations.
"""
function create_scheduling_policy(name; aws_config::AbstractAWSConfig=current_aws_config())
    return batch(
        "POST",
        "/v1/createschedulingpolicy",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_scheduling_policy(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return batch(
        "POST",
        "/v1/createschedulingpolicy",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_compute_environment(compute_environment)
    delete_compute_environment(compute_environment, params::Dict{String,<:Any})

Deletes an Batch compute environment. Before you can delete a compute environment, you must
set its state to DISABLED with the UpdateComputeEnvironment API operation and disassociate
it from any job queues with the UpdateJobQueue API operation. Compute environments that use
Fargate resources must terminate all active jobs on that compute environment before
deleting the compute environment. If this isn't done, the compute environment enters an
invalid state.

# Arguments
- `compute_environment`: The name or Amazon Resource Name (ARN) of the compute environment
  to delete.

"""
function delete_compute_environment(
    computeEnvironment; aws_config::AbstractAWSConfig=current_aws_config()
)
    return batch(
        "POST",
        "/v1/deletecomputeenvironment",
        Dict{String,Any}("computeEnvironment" => computeEnvironment);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_compute_environment(
    computeEnvironment,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return batch(
        "POST",
        "/v1/deletecomputeenvironment",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("computeEnvironment" => computeEnvironment), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_job_queue(job_queue)
    delete_job_queue(job_queue, params::Dict{String,<:Any})

Deletes the specified job queue. You must first disable submissions for a queue with the
UpdateJobQueue operation. All jobs in the queue are eventually terminated when you delete a
job queue. The jobs are terminated at a rate of about 16 jobs each second. It's not
necessary to disassociate compute environments from a queue before submitting a
DeleteJobQueue request.

# Arguments
- `job_queue`: The short name or full Amazon Resource Name (ARN) of the queue to delete.

"""
function delete_job_queue(jobQueue; aws_config::AbstractAWSConfig=current_aws_config())
    return batch(
        "POST",
        "/v1/deletejobqueue",
        Dict{String,Any}("jobQueue" => jobQueue);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_job_queue(
    jobQueue,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return batch(
        "POST",
        "/v1/deletejobqueue",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("jobQueue" => jobQueue), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_scheduling_policy(arn)
    delete_scheduling_policy(arn, params::Dict{String,<:Any})

Deletes the specified scheduling policy. You can't delete a scheduling policy that's used
in any job queues.

# Arguments
- `arn`: The Amazon Resource Name (ARN) of the scheduling policy to delete.

"""
function delete_scheduling_policy(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return batch(
        "POST",
        "/v1/deleteschedulingpolicy",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_scheduling_policy(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return batch(
        "POST",
        "/v1/deleteschedulingpolicy",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    deregister_job_definition(job_definition)
    deregister_job_definition(job_definition, params::Dict{String,<:Any})

Deregisters an Batch job definition. Job definitions are permanently deleted after 180 days.

# Arguments
- `job_definition`: The name and revision (name:revision) or full Amazon Resource Name
  (ARN) of the job definition to deregister.

"""
function deregister_job_definition(
    jobDefinition; aws_config::AbstractAWSConfig=current_aws_config()
)
    return batch(
        "POST",
        "/v1/deregisterjobdefinition",
        Dict{String,Any}("jobDefinition" => jobDefinition);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function deregister_job_definition(
    jobDefinition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return batch(
        "POST",
        "/v1/deregisterjobdefinition",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("jobDefinition" => jobDefinition), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_compute_environments()
    describe_compute_environments(params::Dict{String,<:Any})

Describes one or more of your compute environments. If you're using an unmanaged compute
environment, you can use the DescribeComputeEnvironment operation to determine the
ecsClusterArn that you launch your Amazon ECS container instances into.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"computeEnvironments"`: A list of up to 100 compute environment names or full Amazon
  Resource Name (ARN) entries.
- `"maxResults"`: The maximum number of cluster results returned by
  DescribeComputeEnvironments in paginated output. When this parameter is used,
  DescribeComputeEnvironments only returns maxResults results in a single page along with a
  nextToken response element. The remaining results of the initial request can be seen by
  sending another DescribeComputeEnvironments request with the returned nextToken value. This
  value can be between 1 and 100. If this parameter isn't used, then
  DescribeComputeEnvironments returns up to 100 results and a nextToken value if applicable.
- `"nextToken"`: The nextToken value returned from a previous paginated
  DescribeComputeEnvironments request where maxResults was used and the results exceeded the
  value of that parameter. Pagination continues from the end of the previous results that
  returned the nextToken value. This value is null when there are no more results to return.
  Treat this token as an opaque identifier that's only used to retrieve the next items in a
  list and not for other programmatic purposes.
"""
function describe_compute_environments(; aws_config::AbstractAWSConfig=current_aws_config())
    return batch(
        "POST",
        "/v1/describecomputeenvironments";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_compute_environments(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return batch(
        "POST",
        "/v1/describecomputeenvironments",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_job_definitions()
    describe_job_definitions(params::Dict{String,<:Any})

Describes a list of job definitions. You can specify a status (such as ACTIVE) to only
return job definitions that match that status.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"jobDefinitionName"`: The name of the job definition to describe.
- `"jobDefinitions"`: A list of up to 100 job definitions. Each entry in the list can
  either be an ARN in the format
  arn:aws:batch:{Region}:{Account}:job-definition/{JobDefinitionName}:{Revision} or a short
  version using the form {JobDefinitionName}:{Revision}. This parameter can't be used with
  other parameters.
- `"maxResults"`: The maximum number of results returned by DescribeJobDefinitions in
  paginated output. When this parameter is used, DescribeJobDefinitions only returns
  maxResults results in a single page and a nextToken response element. The remaining results
  of the initial request can be seen by sending another DescribeJobDefinitions request with
  the returned nextToken value. This value can be between 1 and 100. If this parameter isn't
  used, then DescribeJobDefinitions returns up to 100 results and a nextToken value if
  applicable.
- `"nextToken"`: The nextToken value returned from a previous paginated
  DescribeJobDefinitions request where maxResults was used and the results exceeded the value
  of that parameter. Pagination continues from the end of the previous results that returned
  the nextToken value. This value is null when there are no more results to return.  Treat
  this token as an opaque identifier that's only used to retrieve the next items in a list
  and not for other programmatic purposes.
- `"status"`: The status used to filter job definitions.
"""
function describe_job_definitions(; aws_config::AbstractAWSConfig=current_aws_config())
    return batch(
        "POST",
        "/v1/describejobdefinitions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_job_definitions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return batch(
        "POST",
        "/v1/describejobdefinitions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_job_queues()
    describe_job_queues(params::Dict{String,<:Any})

Describes one or more of your job queues.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"jobQueues"`: A list of up to 100 queue names or full queue Amazon Resource Name (ARN)
  entries.
- `"maxResults"`: The maximum number of results returned by DescribeJobQueues in paginated
  output. When this parameter is used, DescribeJobQueues only returns maxResults results in a
  single page and a nextToken response element. The remaining results of the initial request
  can be seen by sending another DescribeJobQueues request with the returned nextToken value.
  This value can be between 1 and 100. If this parameter isn't used, then DescribeJobQueues
  returns up to 100 results and a nextToken value if applicable.
- `"nextToken"`: The nextToken value returned from a previous paginated DescribeJobQueues
  request where maxResults was used and the results exceeded the value of that parameter.
  Pagination continues from the end of the previous results that returned the nextToken
  value. This value is null when there are no more results to return.  Treat this token as an
  opaque identifier that's only used to retrieve the next items in a list and not for other
  programmatic purposes.
"""
function describe_job_queues(; aws_config::AbstractAWSConfig=current_aws_config())
    return batch(
        "POST",
        "/v1/describejobqueues";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_job_queues(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return batch(
        "POST",
        "/v1/describejobqueues",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_jobs(jobs)
    describe_jobs(jobs, params::Dict{String,<:Any})

Describes a list of Batch jobs.

# Arguments
- `jobs`: A list of up to 100 job IDs.

"""
function describe_jobs(jobs; aws_config::AbstractAWSConfig=current_aws_config())
    return batch(
        "POST",
        "/v1/describejobs",
        Dict{String,Any}("jobs" => jobs);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_jobs(
    jobs, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return batch(
        "POST",
        "/v1/describejobs",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("jobs" => jobs), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_scheduling_policies(arns)
    describe_scheduling_policies(arns, params::Dict{String,<:Any})

Describes one or more of your scheduling policies.

# Arguments
- `arns`: A list of up to 100 scheduling policy Amazon Resource Name (ARN) entries.

"""
function describe_scheduling_policies(
    arns; aws_config::AbstractAWSConfig=current_aws_config()
)
    return batch(
        "POST",
        "/v1/describeschedulingpolicies",
        Dict{String,Any}("arns" => arns);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_scheduling_policies(
    arns, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return batch(
        "POST",
        "/v1/describeschedulingpolicies",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arns" => arns), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_job_queue_snapshot(job_queue)
    get_job_queue_snapshot(job_queue, params::Dict{String,<:Any})

Provides a list of the first 100 RUNNABLE jobs associated to a single job queue.

# Arguments
- `job_queue`: The job queue’s name or full queue Amazon Resource Name (ARN).

"""
function get_job_queue_snapshot(
    jobQueue; aws_config::AbstractAWSConfig=current_aws_config()
)
    return batch(
        "POST",
        "/v1/getjobqueuesnapshot",
        Dict{String,Any}("jobQueue" => jobQueue);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_job_queue_snapshot(
    jobQueue,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return batch(
        "POST",
        "/v1/getjobqueuesnapshot",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("jobQueue" => jobQueue), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_jobs()
    list_jobs(params::Dict{String,<:Any})

Returns a list of Batch jobs. You must specify only one of the following items:   A job
queue ID to return a list of jobs in that job queue   A multi-node parallel job ID to
return a list of nodes for that job   An array job ID to return a list of the children for
that job   You can filter the results by job status with the jobStatus parameter. If you
don't specify a status, only RUNNING jobs are returned.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"arrayJobId"`: The job ID for an array job. Specifying an array job ID with this
  parameter lists all child jobs from within the specified array.
- `"filters"`: The filter to apply to the query. Only one filter can be used at a time.
  When the filter is used, jobStatus is ignored. The filter doesn't apply to child jobs in an
  array or multi-node parallel (MNP) jobs. The results are sorted by the createdAt field,
  with the most recent jobs being first.  JOB_NAME  The value of the filter is a
  case-insensitive match for the job name. If the value ends with an asterisk (*), the filter
  matches any job name that begins with the string before the '*'. This corresponds to the
  jobName value. For example, test1 matches both Test1 and test1, and test1* matches both
  test1 and Test10. When the JOB_NAME filter is used, the results are grouped by the job name
  and version.  JOB_DEFINITION  The value for the filter is the name or Amazon Resource Name
  (ARN) of the job definition. This corresponds to the jobDefinition value. The value is case
  sensitive. When the value for the filter is the job definition name, the results include
  all the jobs that used any revision of that job definition name. If the value ends with an
  asterisk (*), the filter matches any job definition name that begins with the string before
  the '*'. For example, jd1 matches only jd1, and jd1* matches both jd1 and jd1A. The version
  of the job definition that's used doesn't affect the sort order. When the JOB_DEFINITION
  filter is used and the ARN is used (which is in the form
  arn:{Partition}:batch:{Region}:{Account}:job-definition/{JobDefinitionName}:{Revision}),
  the results include jobs that used the specified revision of the job definition. Asterisk
  (*) isn't supported when the ARN is used.  BEFORE_CREATED_AT  The value for the filter is
  the time that's before the job was created. This corresponds to the createdAt value. The
  value is a string representation of the number of milliseconds since 00:00:00 UTC
  (midnight) on January 1, 1970.  AFTER_CREATED_AT  The value for the filter is the time
  that's after the job was created. This corresponds to the createdAt value. The value is a
  string representation of the number of milliseconds since 00:00:00 UTC (midnight) on
  January 1, 1970.
- `"jobQueue"`: The name or full Amazon Resource Name (ARN) of the job queue used to list
  jobs.
- `"jobStatus"`: The job status used to filter jobs in the specified queue. If the filters
  parameter is specified, the jobStatus parameter is ignored and jobs with any status are
  returned. If you don't specify a status, only RUNNING jobs are returned.
- `"maxResults"`: The maximum number of results returned by ListJobs in a paginated output.
  When this parameter is used, ListJobs returns up to maxResults results in a single page and
  a nextToken response element, if applicable. The remaining results of the initial request
  can be seen by sending another ListJobs request with the returned nextToken value. The
  following outlines key parameters and limitations:   The minimum value is 1.    When
  --job-status is used, Batch returns up to 1000 values.    When --filters is used, Batch
  returns up to 100 values.   If neither parameter is used, then ListJobs returns up to 1000
  results (jobs that are in the RUNNING status) and a nextToken value, if applicable.
- `"multiNodeJobId"`: The job ID for a multi-node parallel job. Specifying a multi-node
  parallel job ID with this parameter lists all nodes that are associated with the specified
  job.
- `"nextToken"`: The nextToken value returned from a previous paginated ListJobs request
  where maxResults was used and the results exceeded the value of that parameter. Pagination
  continues from the end of the previous results that returned the nextToken value. This
  value is null when there are no more results to return.  Treat this token as an opaque
  identifier that's only used to retrieve the next items in a list and not for other
  programmatic purposes.
"""
function list_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return batch(
        "POST", "/v1/listjobs"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return batch(
        "POST",
        "/v1/listjobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_scheduling_policies()
    list_scheduling_policies(params::Dict{String,<:Any})

Returns a list of Batch scheduling policies.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results that's returned by ListSchedulingPolicies
  in paginated output. When this parameter is used, ListSchedulingPolicies only returns
  maxResults results in a single page and a nextToken response element. You can see the
  remaining results of the initial request by sending another ListSchedulingPolicies request
  with the returned nextToken value. This value can be between 1 and 100. If this parameter
  isn't used, ListSchedulingPolicies returns up to 100 results and a nextToken value if
  applicable.
- `"nextToken"`: The nextToken value that's returned from a previous paginated
  ListSchedulingPolicies request where maxResults was used and the results exceeded the value
  of that parameter. Pagination continues from the end of the previous results that returned
  the nextToken value. This value is null when there are no more results to return.  Treat
  this token as an opaque identifier that's only used to retrieve the next items in a list
  and not for other programmatic purposes.
"""
function list_scheduling_policies(; aws_config::AbstractAWSConfig=current_aws_config())
    return batch(
        "POST",
        "/v1/listschedulingpolicies";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_scheduling_policies(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return batch(
        "POST",
        "/v1/listschedulingpolicies",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists the tags for an Batch resource. Batch resources that support tags are compute
environments, jobs, job definitions, job queues, and scheduling policies. ARNs for child
jobs of array and multi-node parallel (MNP) jobs aren't supported.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) that identifies the resource that tags are
  listed for. Batch resources that support tags are compute environments, jobs, job
  definitions, job queues, and scheduling policies. ARNs for child jobs of array and
  multi-node parallel (MNP) jobs aren't supported.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return batch(
        "GET",
        "/v1/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return batch(
        "GET",
        "/v1/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    register_job_definition(job_definition_name, type)
    register_job_definition(job_definition_name, type, params::Dict{String,<:Any})

Registers an Batch job definition.

# Arguments
- `job_definition_name`: The name of the job definition to register. It can be up to 128
  letters long. It can contain uppercase and lowercase letters, numbers, hyphens (-), and
  underscores (_).
- `type`: The type of job definition. For more information about multi-node parallel jobs,
  see Creating a multi-node parallel job definition in the Batch User Guide.   If the value
  is container, then one of the following is required: containerProperties, ecsProperties, or
  eksProperties.   If the value is multinode, then nodeProperties is required.    If the job
  is run on Fargate resources, then multinode isn't supported.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"containerProperties"`: An object with properties specific to Amazon ECS-based
  single-node container-based jobs. If the job definition's type parameter is container, then
  you must specify either containerProperties or nodeProperties. This must not be specified
  for Amazon EKS-based job definitions.  If the job runs on Fargate resources, then you must
  not specify nodeProperties; use only containerProperties.
- `"ecsProperties"`: An object with properties that are specific to Amazon ECS-based jobs.
  This must not be specified for Amazon EKS-based job definitions.
- `"eksProperties"`: An object with properties that are specific to Amazon EKS-based jobs.
  This must not be specified for Amazon ECS based job definitions.
- `"nodeProperties"`: An object with properties specific to multi-node parallel jobs. If
  you specify node properties for a job, it becomes a multi-node parallel job. For more
  information, see Multi-node Parallel Jobs in the Batch User Guide.  If the job runs on
  Fargate resources, then you must not specify nodeProperties; use containerProperties
  instead.   If the job runs on Amazon EKS resources, then you must not specify
  nodeProperties.
- `"parameters"`: Default parameter substitution placeholders to set in the job definition.
  Parameters are specified as a key-value pair mapping. Parameters in a SubmitJob request
  override any corresponding parameter defaults from the job definition.
- `"platformCapabilities"`: The platform capabilities required by the job definition. If no
  value is specified, it defaults to EC2. To run the job on Fargate resources, specify
  FARGATE.  If the job runs on Amazon EKS resources, then you must not specify
  platformCapabilities.
- `"propagateTags"`: Specifies whether to propagate the tags from the job or job definition
  to the corresponding Amazon ECS task. If no value is specified, the tags are not
  propagated. Tags can only be propagated to the tasks during task creation. For tags with
  the same name, job tags are given priority over job definitions tags. If the total number
  of combined tags from the job and job definition is over 50, the job is moved to the FAILED
  state.  If the job runs on Amazon EKS resources, then you must not specify propagateTags.
- `"retryStrategy"`: The retry strategy to use for failed jobs that are submitted with this
  job definition. Any retry strategy that's specified during a SubmitJob operation overrides
  the retry strategy defined here. If a job is terminated due to a timeout, it isn't retried.
- `"schedulingPriority"`: The scheduling priority for jobs that are submitted with this job
  definition. This only affects jobs in job queues with a fair share policy. Jobs with a
  higher scheduling priority are scheduled before jobs with a lower scheduling priority. The
  minimum supported value is 0 and the maximum supported value is 9999.
- `"tags"`: The tags that you apply to the job definition to help you categorize and
  organize your resources. Each tag consists of a key and an optional value. For more
  information, see Tagging Amazon Web Services Resources in Batch User Guide.
- `"timeout"`: The timeout configuration for jobs that are submitted with this job
  definition, after which Batch terminates your jobs if they have not finished. If a job is
  terminated due to a timeout, it isn't retried. The minimum value for the timeout is 60
  seconds. Any timeout configuration that's specified during a SubmitJob operation overrides
  the timeout configuration defined here. For more information, see Job Timeouts in the Batch
  User Guide.
"""
function register_job_definition(
    jobDefinitionName, type; aws_config::AbstractAWSConfig=current_aws_config()
)
    return batch(
        "POST",
        "/v1/registerjobdefinition",
        Dict{String,Any}("jobDefinitionName" => jobDefinitionName, "type" => type);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function register_job_definition(
    jobDefinitionName,
    type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return batch(
        "POST",
        "/v1/registerjobdefinition",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("jobDefinitionName" => jobDefinitionName, "type" => type),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    submit_job(job_definition, job_name, job_queue)
    submit_job(job_definition, job_name, job_queue, params::Dict{String,<:Any})

Submits an Batch job from a job definition. Parameters that are specified during SubmitJob
override parameters defined in the job definition. vCPU and memory requirements that are
specified in the resourceRequirements objects in the job definition are the exception. They
can't be overridden this way using the memory and vcpus parameters. Rather, you must
specify updates to job definition parameters in a resourceRequirements object that's
included in the containerOverrides parameter.  Job queues with a scheduling policy are
limited to 500 active fair share identifiers at a time.    Jobs that run on Fargate
resources can't be guaranteed to run for more than 14 days. This is because, after 14 days,
Fargate resources might become unavailable and job might be terminated.

# Arguments
- `job_definition`: The job definition used by this job. This value can be one of
  definition-name, definition-name:revision, or the Amazon Resource Name (ARN) for the job
  definition, with or without the revision
  (arn:aws:batch:region:account:job-definition/definition-name:revision , or
  arn:aws:batch:region:account:job-definition/definition-name ). If the revision is not
  specified, then the latest active revision is used.
- `job_name`: The name of the job. It can be up to 128 letters long. The first character
  must be alphanumeric, can contain uppercase and lowercase letters, numbers, hyphens (-),
  and underscores (_).
- `job_queue`: The job queue where the job is submitted. You can specify either the name or
  the Amazon Resource Name (ARN) of the queue.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"arrayProperties"`: The array properties for the submitted job, such as the size of the
  array. The array size can be between 2 and 10,000. If you specify array properties for a
  job, it becomes an array job. For more information, see Array Jobs in the Batch User Guide.
- `"containerOverrides"`: An object with properties that override the defaults for the job
  definition that specify the name of a container in the specified job definition and the
  overrides it should receive. You can override the default command for a container, which is
  specified in the job definition or the Docker image, with a command override. You can also
  override existing environment variables on a container or add new environment variables to
  it with an environment override.
- `"dependsOn"`: A list of dependencies for the job. A job can depend upon a maximum of 20
  jobs. You can specify a SEQUENTIAL type dependency without specifying a job ID for array
  jobs so that each child array job completes sequentially, starting at index 0. You can also
  specify an N_TO_N type dependency with a job ID for array jobs. In that case, each index
  child of this job must wait for the corresponding index child of each dependency to
  complete before it can begin.
- `"ecsPropertiesOverride"`: An object, with properties that override defaults for the job
  definition, can only be specified for jobs that are run on Amazon ECS resources.
- `"eksPropertiesOverride"`: An object, with properties that override defaults for the job
  definition, can only be specified for jobs that are run on Amazon EKS resources.
- `"nodeOverrides"`: A list of node overrides in JSON format that specify the node range to
  target and the container overrides for that node range.  This parameter isn't applicable to
  jobs that are running on Fargate resources; use containerOverrides instead.
- `"parameters"`: Additional parameters passed to the job that replace parameter
  substitution placeholders that are set in the job definition. Parameters are specified as a
  key and value pair mapping. Parameters in a SubmitJob request override any corresponding
  parameter defaults from the job definition.
- `"propagateTags"`: Specifies whether to propagate the tags from the job or job definition
  to the corresponding Amazon ECS task. If no value is specified, the tags aren't propagated.
  Tags can only be propagated to the tasks during task creation. For tags with the same name,
  job tags are given priority over job definitions tags. If the total number of combined tags
  from the job and job definition is over 50, the job is moved to the FAILED state. When
  specified, this overrides the tag propagation setting in the job definition.
- `"retryStrategy"`: The retry strategy to use for failed jobs from this SubmitJob
  operation. When a retry strategy is specified here, it overrides the retry strategy defined
  in the job definition.
- `"schedulingPriorityOverride"`: The scheduling priority for the job. This only affects
  jobs in job queues with a fair share policy. Jobs with a higher scheduling priority are
  scheduled before jobs with a lower scheduling priority. This overrides any scheduling
  priority in the job definition and works only within a single share identifier. The minimum
  supported value is 0 and the maximum supported value is 9999.
- `"shareIdentifier"`: The share identifier for the job. Don't specify this parameter if
  the job queue doesn't have a scheduling policy. If the job queue has a scheduling policy,
  then this parameter must be specified. This string is limited to 255 alphanumeric
  characters, and can be followed by an asterisk (*).
- `"tags"`: The tags that you apply to the job request to help you categorize and organize
  your resources. Each tag consists of a key and an optional value. For more information, see
  Tagging Amazon Web Services Resources in Amazon Web Services General Reference.
- `"timeout"`: The timeout configuration for this SubmitJob operation. You can specify a
  timeout duration after which Batch terminates your jobs if they haven't finished. If a job
  is terminated due to a timeout, it isn't retried. The minimum value for the timeout is 60
  seconds. This configuration overrides any timeout configuration specified in the job
  definition. For array jobs, child jobs have the same timeout configuration as the parent
  job. For more information, see Job Timeouts in the Amazon Elastic Container Service
  Developer Guide.
"""
function submit_job(
    jobDefinition, jobName, jobQueue; aws_config::AbstractAWSConfig=current_aws_config()
)
    return batch(
        "POST",
        "/v1/submitjob",
        Dict{String,Any}(
            "jobDefinition" => jobDefinition, "jobName" => jobName, "jobQueue" => jobQueue
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function submit_job(
    jobDefinition,
    jobName,
    jobQueue,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return batch(
        "POST",
        "/v1/submitjob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "jobDefinition" => jobDefinition,
                    "jobName" => jobName,
                    "jobQueue" => jobQueue,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Associates the specified tags to a resource with the specified resourceArn. If existing
tags on a resource aren't specified in the request parameters, they aren't changed. When a
resource is deleted, the tags that are associated with that resource are deleted as well.
Batch resources that support tags are compute environments, jobs, job definitions, job
queues, and scheduling policies. ARNs for child jobs of array and multi-node parallel (MNP)
jobs aren't supported.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource that tags are added to.
  Batch resources that support tags are compute environments, jobs, job definitions, job
  queues, and scheduling policies. ARNs for child jobs of array and multi-node parallel (MNP)
  jobs aren't supported.
- `tags`: The tags that you apply to the resource to help you categorize and organize your
  resources. Each tag consists of a key and an optional value. For more information, see
  Tagging Amazon Web Services Resources in Amazon Web Services General Reference.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return batch(
        "POST",
        "/v1/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return batch(
        "POST",
        "/v1/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    terminate_job(job_id, reason)
    terminate_job(job_id, reason, params::Dict{String,<:Any})

Terminates a job in a job queue. Jobs that are in the STARTING or RUNNING state are
terminated, which causes them to transition to FAILED. Jobs that have not progressed to the
STARTING state are cancelled.

# Arguments
- `job_id`: The Batch job ID of the job to terminate.
- `reason`: A message to attach to the job that explains the reason for canceling it. This
  message is returned by future DescribeJobs operations on the job. This message is also
  recorded in the Batch activity logs.

"""
function terminate_job(jobId, reason; aws_config::AbstractAWSConfig=current_aws_config())
    return batch(
        "POST",
        "/v1/terminatejob",
        Dict{String,Any}("jobId" => jobId, "reason" => reason);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function terminate_job(
    jobId,
    reason,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return batch(
        "POST",
        "/v1/terminatejob",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("jobId" => jobId, "reason" => reason), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Deletes specified tags from an Batch resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource from which to delete tags.
  Batch resources that support tags are compute environments, jobs, job definitions, job
  queues, and scheduling policies. ARNs for child jobs of array and multi-node parallel (MNP)
  jobs aren't supported.
- `tag_keys`: The keys of the tags to be removed.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return batch(
        "DELETE",
        "/v1/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return batch(
        "DELETE",
        "/v1/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_compute_environment(compute_environment)
    update_compute_environment(compute_environment, params::Dict{String,<:Any})

Updates an Batch compute environment.

# Arguments
- `compute_environment`: The name or full Amazon Resource Name (ARN) of the compute
  environment to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"computeResources"`: Details of the compute resources managed by the compute
  environment. Required for a managed compute environment. For more information, see Compute
  Environments in the Batch User Guide.
- `"serviceRole"`: The full Amazon Resource Name (ARN) of the IAM role that allows Batch to
  make calls to other Amazon Web Services services on your behalf. For more information, see
  Batch service IAM role in the Batch User Guide.  If the compute environment has a
  service-linked role, it can't be changed to use a regular IAM role. Likewise, if the
  compute environment has a regular IAM role, it can't be changed to use a service-linked
  role. To update the parameters for the compute environment that require an infrastructure
  update to change, the AWSServiceRoleForBatch service-linked role must be used. For more
  information, see Updating compute environments in the Batch User Guide.  If your specified
  role has a path other than /, then you must either specify the full role ARN (recommended)
  or prefix the role name with the path.  Depending on how you created your Batch service
  role, its ARN might contain the service-role path prefix. When you only specify the name of
  the service role, Batch assumes that your ARN doesn't use the service-role path prefix.
  Because of this, we recommend that you specify the full ARN of your service role when you
  create compute environments.
- `"state"`: The state of the compute environment. Compute environments in the ENABLED
  state can accept jobs from a queue and scale in or out automatically based on the workload
  demand of its associated queues. If the state is ENABLED, then the Batch scheduler can
  attempt to place jobs from an associated job queue on the compute resources within the
  environment. If the compute environment is managed, then it can scale its instances out or
  in automatically, based on the job queue demand. If the state is DISABLED, then the Batch
  scheduler doesn't attempt to place jobs within the environment. Jobs in a STARTING or
  RUNNING state continue to progress normally. Managed compute environments in the DISABLED
  state don't scale out.   Compute environments in a DISABLED state may continue to incur
  billing charges. To prevent additional charges, turn off and then delete the compute
  environment. For more information, see State in the Batch User Guide.  When an instance is
  idle, the instance scales down to the minvCpus value. However, the instance size doesn't
  change. For example, consider a c5.8xlarge instance with a minvCpus value of 4 and a
  desiredvCpus value of 36. This instance doesn't scale down to a c5.large instance.
- `"unmanagedvCpus"`: The maximum number of vCPUs expected to be used for an unmanaged
  compute environment. Don't specify this parameter for a managed compute environment. This
  parameter is only used for fair share scheduling to reserve vCPU capacity for new share
  identifiers. If this parameter isn't provided for a fair share job queue, no vCPU capacity
  is reserved.
- `"updatePolicy"`: Specifies the updated infrastructure update policy for the compute
  environment. For more information about infrastructure updates, see Updating compute
  environments in the Batch User Guide.
"""
function update_compute_environment(
    computeEnvironment; aws_config::AbstractAWSConfig=current_aws_config()
)
    return batch(
        "POST",
        "/v1/updatecomputeenvironment",
        Dict{String,Any}("computeEnvironment" => computeEnvironment);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_compute_environment(
    computeEnvironment,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return batch(
        "POST",
        "/v1/updatecomputeenvironment",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("computeEnvironment" => computeEnvironment), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_job_queue(job_queue)
    update_job_queue(job_queue, params::Dict{String,<:Any})

Updates a job queue.

# Arguments
- `job_queue`: The name or the Amazon Resource Name (ARN) of the job queue.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"computeEnvironmentOrder"`: Details the set of compute environments mapped to a job
  queue and their order relative to each other. This is one of the parameters used by the job
  scheduler to determine which compute environment runs a given job. Compute environments
  must be in the VALID state before you can associate them with a job queue. All of the
  compute environments must be either EC2 (EC2 or SPOT) or Fargate (FARGATE or FARGATE_SPOT).
  EC2 and Fargate compute environments can't be mixed.  All compute environments that are
  associated with a job queue must share the same architecture. Batch doesn't support mixing
  compute environment architecture types in a single job queue.
- `"jobStateTimeLimitActions"`: The set of actions that Batch perform on jobs that remain
  at the head of the job queue in the specified state longer than specified times. Batch will
  perform each action after maxTimeSeconds has passed.
- `"priority"`: The priority of the job queue. Job queues with a higher priority (or a
  higher integer value for the priority parameter) are evaluated first when associated with
  the same compute environment. Priority is determined in descending order. For example, a
  job queue with a priority value of 10 is given scheduling preference over a job queue with
  a priority value of 1. All of the compute environments must be either EC2 (EC2 or SPOT) or
  Fargate (FARGATE or FARGATE_SPOT). EC2 and Fargate compute environments can't be mixed.
- `"schedulingPolicyArn"`: Amazon Resource Name (ARN) of the fair share scheduling policy.
  Once a job queue is created, the fair share scheduling policy can be replaced but not
  removed. The format is aws:Partition:batch:Region:Account:scheduling-policy/Name . For
  example, aws:aws:batch:us-west-2:123456789012:scheduling-policy/MySchedulingPolicy.
- `"state"`: Describes the queue's ability to accept new jobs. If the job queue state is
  ENABLED, it can accept jobs. If the job queue state is DISABLED, new jobs can't be added to
  the queue, but jobs already in the queue can finish.
"""
function update_job_queue(jobQueue; aws_config::AbstractAWSConfig=current_aws_config())
    return batch(
        "POST",
        "/v1/updatejobqueue",
        Dict{String,Any}("jobQueue" => jobQueue);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_job_queue(
    jobQueue,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return batch(
        "POST",
        "/v1/updatejobqueue",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("jobQueue" => jobQueue), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_scheduling_policy(arn)
    update_scheduling_policy(arn, params::Dict{String,<:Any})

Updates a scheduling policy.

# Arguments
- `arn`: The Amazon Resource Name (ARN) of the scheduling policy to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"fairsharePolicy"`: The fair share policy.
"""
function update_scheduling_policy(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return batch(
        "POST",
        "/v1/updateschedulingpolicy",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_scheduling_policy(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return batch(
        "POST",
        "/v1/updateschedulingpolicy",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: appsync
using AWS.Compat
using AWS.UUIDs

"""
    associate_api(api_id, domain_name)
    associate_api(api_id, domain_name, params::Dict{String,<:Any})

Maps an endpoint to your custom domain.

# Arguments
- `api_id`: The API ID. Private APIs can not be associated with custom domains.
- `domain_name`: The domain name.

"""
function associate_api(
    apiId, domainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appsync(
        "POST",
        "/v1/domainnames/$(domainName)/apiassociation",
        Dict{String,Any}("apiId" => apiId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_api(
    apiId,
    domainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appsync(
        "POST",
        "/v1/domainnames/$(domainName)/apiassociation",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("apiId" => apiId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_merged_graphql_api(merged_api_identifier, source_api_identifier)
    associate_merged_graphql_api(merged_api_identifier, source_api_identifier, params::Dict{String,<:Any})

Creates an association between a Merged API and source API using the source API's
identifier.

# Arguments
- `merged_api_identifier`: The identifier of the AppSync Merged API. This is generated by
  the AppSync service. In most cases, Merged APIs (especially in your account) only require
  the API ID value or ARN of the merged API. However, Merged APIs in other accounts
  (cross-account use cases) strictly require the full resource ARN of the merged API.
- `source_api_identifier`: The identifier of the AppSync Source API. This is generated by
  the AppSync service. In most cases, source APIs (especially in your account) only require
  the API ID value or ARN of the source API. However, source APIs from other accounts
  (cross-account use cases) strictly require the full resource ARN of the source API.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description field.
- `"sourceApiAssociationConfig"`: The SourceApiAssociationConfig object data.
"""
function associate_merged_graphql_api(
    mergedApiIdentifier,
    sourceApiIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appsync(
        "POST",
        "/v1/sourceApis/$(sourceApiIdentifier)/mergedApiAssociations",
        Dict{String,Any}("mergedApiIdentifier" => mergedApiIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_merged_graphql_api(
    mergedApiIdentifier,
    sourceApiIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appsync(
        "POST",
        "/v1/sourceApis/$(sourceApiIdentifier)/mergedApiAssociations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("mergedApiIdentifier" => mergedApiIdentifier),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_source_graphql_api(merged_api_identifier, source_api_identifier)
    associate_source_graphql_api(merged_api_identifier, source_api_identifier, params::Dict{String,<:Any})

Creates an association between a Merged API and source API using the Merged API's
identifier.

# Arguments
- `merged_api_identifier`: The identifier of the AppSync Merged API. This is generated by
  the AppSync service. In most cases, Merged APIs (especially in your account) only require
  the API ID value or ARN of the merged API. However, Merged APIs in other accounts
  (cross-account use cases) strictly require the full resource ARN of the merged API.
- `source_api_identifier`: The identifier of the AppSync Source API. This is generated by
  the AppSync service. In most cases, source APIs (especially in your account) only require
  the API ID value or ARN of the source API. However, source APIs from other accounts
  (cross-account use cases) strictly require the full resource ARN of the source API.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description field.
- `"sourceApiAssociationConfig"`: The SourceApiAssociationConfig object data.
"""
function associate_source_graphql_api(
    mergedApiIdentifier,
    sourceApiIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appsync(
        "POST",
        "/v1/mergedApis/$(mergedApiIdentifier)/sourceApiAssociations",
        Dict{String,Any}("sourceApiIdentifier" => sourceApiIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_source_graphql_api(
    mergedApiIdentifier,
    sourceApiIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appsync(
        "POST",
        "/v1/mergedApis/$(mergedApiIdentifier)/sourceApiAssociations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("sourceApiIdentifier" => sourceApiIdentifier),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_api_cache(api_caching_behavior, api_id, ttl, type)
    create_api_cache(api_caching_behavior, api_id, ttl, type, params::Dict{String,<:Any})

Creates a cache for the GraphQL API.

# Arguments
- `api_caching_behavior`: Caching behavior.    FULL_REQUEST_CACHING: All requests are fully
  cached.    PER_RESOLVER_CACHING: Individual resolvers that you specify are cached.
- `api_id`: The GraphQL API ID.
- `ttl`: TTL in seconds for cache entries. Valid values are 1–3,600 seconds.
- `type`: The cache instance type. Valid values are     SMALL     MEDIUM     LARGE
  XLARGE     LARGE_2X     LARGE_4X     LARGE_8X (not available in all regions)    LARGE_12X
   Historically, instance types were identified by an EC2-style value. As of July 2020, this
  is deprecated, and the generic identifiers above should be used. The following legacy
  instance types are available, but their use is discouraged:    T2_SMALL: A t2.small
  instance type.    T2_MEDIUM: A t2.medium instance type.    R4_LARGE: A r4.large instance
  type.    R4_XLARGE: A r4.xlarge instance type.    R4_2XLARGE: A r4.2xlarge instance type.
   R4_4XLARGE: A r4.4xlarge instance type.    R4_8XLARGE: A r4.8xlarge instance type.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"atRestEncryptionEnabled"`: At-rest encryption flag for cache. You cannot update this
  setting after creation.
- `"healthMetricsConfig"`: Controls how cache health metrics will be emitted to CloudWatch.
  Cache health metrics include:   NetworkBandwidthOutAllowanceExceeded: The network packets
  dropped because the throughput exceeded the aggregated bandwidth limit. This is useful for
  diagnosing bottlenecks in a cache configuration.   EngineCPUUtilization: The CPU
  utilization (percentage) allocated to the Redis process. This is useful for diagnosing
  bottlenecks in a cache configuration.   Metrics will be recorded by API ID. You can set the
  value to ENABLED or DISABLED.
- `"transitEncryptionEnabled"`: Transit encryption flag when connecting to cache. You
  cannot update this setting after creation.
"""
function create_api_cache(
    apiCachingBehavior, apiId, ttl, type; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appsync(
        "POST",
        "/v1/apis/$(apiId)/ApiCaches",
        Dict{String,Any}(
            "apiCachingBehavior" => apiCachingBehavior, "ttl" => ttl, "type" => type
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_api_cache(
    apiCachingBehavior,
    apiId,
    ttl,
    type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appsync(
        "POST",
        "/v1/apis/$(apiId)/ApiCaches",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "apiCachingBehavior" => apiCachingBehavior, "ttl" => ttl, "type" => type
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_api_key(api_id)
    create_api_key(api_id, params::Dict{String,<:Any})

Creates a unique key that you can distribute to clients who invoke your API.

# Arguments
- `api_id`: The ID for your GraphQL API.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A description of the purpose of the API key.
- `"expires"`: From the creation time, the time after which the API key expires. The date
  is represented as seconds since the epoch, rounded down to the nearest hour. The default
  value for this parameter is 7 days from creation time. For more information, see .
"""
function create_api_key(apiId; aws_config::AbstractAWSConfig=current_aws_config())
    return appsync(
        "POST",
        "/v1/apis/$(apiId)/apikeys";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_api_key(
    apiId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appsync(
        "POST",
        "/v1/apis/$(apiId)/apikeys",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_data_source(api_id, name, type)
    create_data_source(api_id, name, type, params::Dict{String,<:Any})

Creates a DataSource object.

# Arguments
- `api_id`: The API ID for the GraphQL API for the DataSource.
- `name`: A user-supplied name for the DataSource.
- `type`: The type of the DataSource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A description of the DataSource.
- `"dynamodbConfig"`: Amazon DynamoDB settings.
- `"elasticsearchConfig"`: Amazon OpenSearch Service settings. As of September 2021, Amazon
  Elasticsearch service is Amazon OpenSearch Service. This configuration is deprecated. For
  new data sources, use CreateDataSourceRequestopenSearchServiceConfig to create an
  OpenSearch data source.
- `"eventBridgeConfig"`: Amazon EventBridge settings.
- `"httpConfig"`: HTTP endpoint settings.
- `"lambdaConfig"`: Lambda settings.
- `"metricsConfig"`: Enables or disables enhanced data source metrics for specified data
  sources. Note that metricsConfig won't be used unless the dataSourceLevelMetricsBehavior
  value is set to PER_DATA_SOURCE_METRICS. If the dataSourceLevelMetricsBehavior is set to
  FULL_REQUEST_DATA_SOURCE_METRICS instead, metricsConfig will be ignored. However, you can
  still set its value.  metricsConfig can be ENABLED or DISABLED.
- `"openSearchServiceConfig"`: Amazon OpenSearch Service settings.
- `"relationalDatabaseConfig"`: Relational database settings.
- `"serviceRoleArn"`: The Identity and Access Management (IAM) service role Amazon Resource
  Name (ARN) for the data source. The system assumes this role when accessing the data source.
"""
function create_data_source(
    apiId, name, type; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appsync(
        "POST",
        "/v1/apis/$(apiId)/datasources",
        Dict{String,Any}("name" => name, "type" => type);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_data_source(
    apiId,
    name,
    type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appsync(
        "POST",
        "/v1/apis/$(apiId)/datasources",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("name" => name, "type" => type), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_domain_name(certificate_arn, domain_name)
    create_domain_name(certificate_arn, domain_name, params::Dict{String,<:Any})

Creates a custom DomainName object.

# Arguments
- `certificate_arn`: The Amazon Resource Name (ARN) of the certificate. This can be an
  Certificate Manager (ACM) certificate or an Identity and Access Management (IAM) server
  certificate.
- `domain_name`: The domain name.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A description of the DomainName.
"""
function create_domain_name(
    certificateArn, domainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appsync(
        "POST",
        "/v1/domainnames",
        Dict{String,Any}("certificateArn" => certificateArn, "domainName" => domainName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_domain_name(
    certificateArn,
    domainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appsync(
        "POST",
        "/v1/domainnames",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "certificateArn" => certificateArn, "domainName" => domainName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_function(api_id, data_source_name, name)
    create_function(api_id, data_source_name, name, params::Dict{String,<:Any})

Creates a Function object. A function is a reusable entity. You can use multiple functions
to compose the resolver logic.

# Arguments
- `api_id`: The GraphQL API ID.
- `data_source_name`: The Function DataSource name.
- `name`: The Function name. The function name does not have to be unique.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"code"`: The function code that contains the request and response functions. When code
  is used, the runtime is required. The runtime value must be APPSYNC_JS.
- `"description"`: The Function description.
- `"functionVersion"`: The version of the request mapping template. Currently, the
  supported value is 2018-05-29. Note that when using VTL and mapping templates, the
  functionVersion is required.
- `"maxBatchSize"`: The maximum batching size for a resolver.
- `"requestMappingTemplate"`: The Function request mapping template. Functions support only
  the 2018-05-29 version of the request mapping template.
- `"responseMappingTemplate"`: The Function response mapping template.
- `"runtime"`:
- `"syncConfig"`:
"""
function create_function(
    apiId, dataSourceName, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appsync(
        "POST",
        "/v1/apis/$(apiId)/functions",
        Dict{String,Any}("dataSourceName" => dataSourceName, "name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_function(
    apiId,
    dataSourceName,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appsync(
        "POST",
        "/v1/apis/$(apiId)/functions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("dataSourceName" => dataSourceName, "name" => name),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_graphql_api(authentication_type, name)
    create_graphql_api(authentication_type, name, params::Dict{String,<:Any})

Creates a GraphqlApi object.

# Arguments
- `authentication_type`: The authentication type: API key, Identity and Access Management
  (IAM), OpenID Connect (OIDC), Amazon Cognito user pools, or Lambda.
- `name`: A user-supplied name for the GraphqlApi.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"additionalAuthenticationProviders"`: A list of additional authentication providers for
  the GraphqlApi API.
- `"apiType"`: The value that indicates whether the GraphQL API is a standard API (GRAPHQL)
  or merged API (MERGED).
- `"enhancedMetricsConfig"`: The enhancedMetricsConfig object.
- `"introspectionConfig"`: Sets the value of the GraphQL API to enable (ENABLED) or disable
  (DISABLED) introspection. If no value is provided, the introspection configuration will be
  set to ENABLED by default. This field will produce an error if the operation attempts to
  use the introspection feature while this field is disabled. For more information about
  introspection, see GraphQL introspection.
- `"lambdaAuthorizerConfig"`: Configuration for Lambda function authorization.
- `"logConfig"`: The Amazon CloudWatch Logs configuration.
- `"mergedApiExecutionRoleArn"`: The Identity and Access Management service role ARN for a
  merged API. The AppSync service assumes this role on behalf of the Merged API to validate
  access to source APIs at runtime and to prompt the AUTO_MERGE to update the merged API
  endpoint with the source API changes automatically.
- `"openIDConnectConfig"`: The OIDC configuration.
- `"ownerContact"`: The owner contact information for an API resource. This field accepts
  any string input with a length of 0 - 256 characters.
- `"queryDepthLimit"`: The maximum depth a query can have in a single request. Depth refers
  to the amount of nested levels allowed in the body of query. The default value is 0 (or
  unspecified), which indicates there's no depth limit. If you set a limit, it can be between
  1 and 75 nested levels. This field will produce a limit error if the operation falls out of
  bounds. Note that fields can still be set to nullable or non-nullable. If a non-nullable
  field produces an error, the error will be thrown upwards to the first nullable field
  available.
- `"resolverCountLimit"`: The maximum number of resolvers that can be invoked in a single
  request. The default value is 0 (or unspecified), which will set the limit to 10000. When
  specified, the limit value can be between 1 and 10000. This field will produce a limit
  error if the operation falls out of bounds.
- `"tags"`: A TagMap object.
- `"userPoolConfig"`: The Amazon Cognito user pool configuration.
- `"visibility"`: Sets the value of the GraphQL API to public (GLOBAL) or private
  (PRIVATE). If no value is provided, the visibility will be set to GLOBAL by default. This
  value cannot be changed once the API has been created.
- `"xrayEnabled"`: A flag indicating whether to use X-Ray tracing for the GraphqlApi.
"""
function create_graphql_api(
    authenticationType, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appsync(
        "POST",
        "/v1/apis",
        Dict{String,Any}("authenticationType" => authenticationType, "name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_graphql_api(
    authenticationType,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appsync(
        "POST",
        "/v1/apis",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "authenticationType" => authenticationType, "name" => name
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_resolver(api_id, field_name, type_name)
    create_resolver(api_id, field_name, type_name, params::Dict{String,<:Any})

Creates a Resolver object. A resolver converts incoming requests into a format that a data
source can understand, and converts the data source's responses into GraphQL.

# Arguments
- `api_id`: The ID for the GraphQL API for which the resolver is being created.
- `field_name`: The name of the field to attach the resolver to.
- `type_name`: The name of the Type.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"cachingConfig"`: The caching configuration for the resolver.
- `"code"`: The resolver code that contains the request and response functions. When code
  is used, the runtime is required. The runtime value must be APPSYNC_JS.
- `"dataSourceName"`: The name of the data source for which the resolver is being created.
- `"kind"`: The resolver type.    UNIT: A UNIT resolver type. A UNIT resolver is the
  default resolver type. You can use a UNIT resolver to run a GraphQL query against a single
  data source.    PIPELINE: A PIPELINE resolver type. You can use a PIPELINE resolver to
  invoke a series of Function objects in a serial manner. You can use a pipeline resolver to
  run a GraphQL query against multiple data sources.
- `"maxBatchSize"`: The maximum batching size for a resolver.
- `"metricsConfig"`: Enables or disables enhanced resolver metrics for specified resolvers.
  Note that metricsConfig won't be used unless the resolverLevelMetricsBehavior value is set
  to PER_RESOLVER_METRICS. If the resolverLevelMetricsBehavior is set to
  FULL_REQUEST_RESOLVER_METRICS instead, metricsConfig will be ignored. However, you can
  still set its value.  metricsConfig can be ENABLED or DISABLED.
- `"pipelineConfig"`: The PipelineConfig.
- `"requestMappingTemplate"`: The mapping template to use for requests. A resolver uses a
  request mapping template to convert a GraphQL expression into a format that a data source
  can understand. Mapping templates are written in Apache Velocity Template Language (VTL).
  VTL request mapping templates are optional when using an Lambda data source. For all other
  data sources, VTL request and response mapping templates are required.
- `"responseMappingTemplate"`: The mapping template to use for responses from the data
  source.
- `"runtime"`:
- `"syncConfig"`: The SyncConfig for a resolver attached to a versioned data source.
"""
function create_resolver(
    apiId, fieldName, typeName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appsync(
        "POST",
        "/v1/apis/$(apiId)/types/$(typeName)/resolvers",
        Dict{String,Any}("fieldName" => fieldName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_resolver(
    apiId,
    fieldName,
    typeName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appsync(
        "POST",
        "/v1/apis/$(apiId)/types/$(typeName)/resolvers",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("fieldName" => fieldName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_type(api_id, definition, format)
    create_type(api_id, definition, format, params::Dict{String,<:Any})

Creates a Type object.

# Arguments
- `api_id`: The API ID.
- `definition`: The type definition, in GraphQL Schema Definition Language (SDL) format.
  For more information, see the GraphQL SDL documentation.
- `format`: The type format: SDL or JSON.

"""
function create_type(
    apiId, definition, format; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appsync(
        "POST",
        "/v1/apis/$(apiId)/types",
        Dict{String,Any}("definition" => definition, "format" => format);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_type(
    apiId,
    definition,
    format,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appsync(
        "POST",
        "/v1/apis/$(apiId)/types",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("definition" => definition, "format" => format),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_api_cache(api_id)
    delete_api_cache(api_id, params::Dict{String,<:Any})

Deletes an ApiCache object.

# Arguments
- `api_id`: The API ID.

"""
function delete_api_cache(apiId; aws_config::AbstractAWSConfig=current_aws_config())
    return appsync(
        "DELETE",
        "/v1/apis/$(apiId)/ApiCaches";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_api_cache(
    apiId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appsync(
        "DELETE",
        "/v1/apis/$(apiId)/ApiCaches",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_api_key(api_id, id)
    delete_api_key(api_id, id, params::Dict{String,<:Any})

Deletes an API key.

# Arguments
- `api_id`: The API ID.
- `id`: The ID for the API key.

"""
function delete_api_key(apiId, id; aws_config::AbstractAWSConfig=current_aws_config())
    return appsync(
        "DELETE",
        "/v1/apis/$(apiId)/apikeys/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_api_key(
    apiId,
    id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appsync(
        "DELETE",
        "/v1/apis/$(apiId)/apikeys/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_data_source(api_id, name)
    delete_data_source(api_id, name, params::Dict{String,<:Any})

Deletes a DataSource object.

# Arguments
- `api_id`: The API ID.
- `name`: The name of the data source.

"""
function delete_data_source(apiId, name; aws_config::AbstractAWSConfig=current_aws_config())
    return appsync(
        "DELETE",
        "/v1/apis/$(apiId)/datasources/$(name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_data_source(
    apiId,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appsync(
        "DELETE",
        "/v1/apis/$(apiId)/datasources/$(name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_domain_name(domain_name)
    delete_domain_name(domain_name, params::Dict{String,<:Any})

Deletes a custom DomainName object.

# Arguments
- `domain_name`: The domain name.

"""
function delete_domain_name(domainName; aws_config::AbstractAWSConfig=current_aws_config())
    return appsync(
        "DELETE",
        "/v1/domainnames/$(domainName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_domain_name(
    domainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appsync(
        "DELETE",
        "/v1/domainnames/$(domainName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_function(api_id, function_id)
    delete_function(api_id, function_id, params::Dict{String,<:Any})

Deletes a Function.

# Arguments
- `api_id`: The GraphQL API ID.
- `function_id`: The Function ID.

"""
function delete_function(
    apiId, functionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appsync(
        "DELETE",
        "/v1/apis/$(apiId)/functions/$(functionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_function(
    apiId,
    functionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appsync(
        "DELETE",
        "/v1/apis/$(apiId)/functions/$(functionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_graphql_api(api_id)
    delete_graphql_api(api_id, params::Dict{String,<:Any})

Deletes a GraphqlApi object.

# Arguments
- `api_id`: The API ID.

"""
function delete_graphql_api(apiId; aws_config::AbstractAWSConfig=current_aws_config())
    return appsync(
        "DELETE",
        "/v1/apis/$(apiId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_graphql_api(
    apiId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appsync(
        "DELETE",
        "/v1/apis/$(apiId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_resolver(api_id, field_name, type_name)
    delete_resolver(api_id, field_name, type_name, params::Dict{String,<:Any})

Deletes a Resolver object.

# Arguments
- `api_id`: The API ID.
- `field_name`: The resolver field name.
- `type_name`: The name of the resolver type.

"""
function delete_resolver(
    apiId, fieldName, typeName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appsync(
        "DELETE",
        "/v1/apis/$(apiId)/types/$(typeName)/resolvers/$(fieldName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_resolver(
    apiId,
    fieldName,
    typeName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appsync(
        "DELETE",
        "/v1/apis/$(apiId)/types/$(typeName)/resolvers/$(fieldName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_type(api_id, type_name)
    delete_type(api_id, type_name, params::Dict{String,<:Any})

Deletes a Type object.

# Arguments
- `api_id`: The API ID.
- `type_name`: The type name.

"""
function delete_type(apiId, typeName; aws_config::AbstractAWSConfig=current_aws_config())
    return appsync(
        "DELETE",
        "/v1/apis/$(apiId)/types/$(typeName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_type(
    apiId,
    typeName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appsync(
        "DELETE",
        "/v1/apis/$(apiId)/types/$(typeName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_api(domain_name)
    disassociate_api(domain_name, params::Dict{String,<:Any})

Removes an ApiAssociation object from a custom domain.

# Arguments
- `domain_name`: The domain name.

"""
function disassociate_api(domainName; aws_config::AbstractAWSConfig=current_aws_config())
    return appsync(
        "DELETE",
        "/v1/domainnames/$(domainName)/apiassociation";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_api(
    domainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appsync(
        "DELETE",
        "/v1/domainnames/$(domainName)/apiassociation",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_merged_graphql_api(association_id, source_api_identifier)
    disassociate_merged_graphql_api(association_id, source_api_identifier, params::Dict{String,<:Any})

Deletes an association between a Merged API and source API using the source API's
identifier and the association ID.

# Arguments
- `association_id`: The ID generated by the AppSync service for the source API association.
- `source_api_identifier`: The identifier of the AppSync Source API. This is generated by
  the AppSync service. In most cases, source APIs (especially in your account) only require
  the API ID value or ARN of the source API. However, source APIs from other accounts
  (cross-account use cases) strictly require the full resource ARN of the source API.

"""
function disassociate_merged_graphql_api(
    associationId, sourceApiIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appsync(
        "DELETE",
        "/v1/sourceApis/$(sourceApiIdentifier)/mergedApiAssociations/$(associationId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_merged_graphql_api(
    associationId,
    sourceApiIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appsync(
        "DELETE",
        "/v1/sourceApis/$(sourceApiIdentifier)/mergedApiAssociations/$(associationId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_source_graphql_api(association_id, merged_api_identifier)
    disassociate_source_graphql_api(association_id, merged_api_identifier, params::Dict{String,<:Any})

Deletes an association between a Merged API and source API using the Merged API's
identifier and the association ID.

# Arguments
- `association_id`: The ID generated by the AppSync service for the source API association.
- `merged_api_identifier`: The identifier of the AppSync Merged API. This is generated by
  the AppSync service. In most cases, Merged APIs (especially in your account) only require
  the API ID value or ARN of the merged API. However, Merged APIs in other accounts
  (cross-account use cases) strictly require the full resource ARN of the merged API.

"""
function disassociate_source_graphql_api(
    associationId, mergedApiIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appsync(
        "DELETE",
        "/v1/mergedApis/$(mergedApiIdentifier)/sourceApiAssociations/$(associationId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_source_graphql_api(
    associationId,
    mergedApiIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appsync(
        "DELETE",
        "/v1/mergedApis/$(mergedApiIdentifier)/sourceApiAssociations/$(associationId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    evaluate_code(code, context, runtime)
    evaluate_code(code, context, runtime, params::Dict{String,<:Any})

Evaluates the given code and returns the response. The code definition requirements depend
on the specified runtime. For APPSYNC_JS runtimes, the code defines the request and
response functions. The request function takes the incoming request after a GraphQL
operation is parsed and converts it into a request configuration for the selected data
source operation. The response function interprets responses from the data source and maps
it to the shape of the GraphQL field output type.

# Arguments
- `code`: The code definition to be evaluated. Note that code and runtime are both required
  for this action. The runtime value must be APPSYNC_JS.
- `context`: The map that holds all of the contextual information for your resolver
  invocation. A context is required for this action.
- `runtime`: The runtime to be used when evaluating the code. Currently, only the
  APPSYNC_JS runtime is supported.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"function"`: The function within the code to be evaluated. If provided, the valid values
  are request and response.
"""
function evaluate_code(
    code, context, runtime; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appsync(
        "POST",
        "/v1/dataplane-evaluatecode",
        Dict{String,Any}("code" => code, "context" => context, "runtime" => runtime);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function evaluate_code(
    code,
    context,
    runtime,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appsync(
        "POST",
        "/v1/dataplane-evaluatecode",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "code" => code, "context" => context, "runtime" => runtime
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    evaluate_mapping_template(context, template)
    evaluate_mapping_template(context, template, params::Dict{String,<:Any})

Evaluates a given template and returns the response. The mapping template can be a request
or response template. Request templates take the incoming request after a GraphQL operation
is parsed and convert it into a request configuration for the selected data source
operation. Response templates interpret responses from the data source and map it to the
shape of the GraphQL field output type. Mapping templates are written in the Apache
Velocity Template Language (VTL).

# Arguments
- `context`: The map that holds all of the contextual information for your resolver
  invocation. A context is required for this action.
- `template`: The mapping template; this can be a request or response template. A template
  is required for this action.

"""
function evaluate_mapping_template(
    context, template; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appsync(
        "POST",
        "/v1/dataplane-evaluatetemplate",
        Dict{String,Any}("context" => context, "template" => template);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function evaluate_mapping_template(
    context,
    template,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appsync(
        "POST",
        "/v1/dataplane-evaluatetemplate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("context" => context, "template" => template),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    flush_api_cache(api_id)
    flush_api_cache(api_id, params::Dict{String,<:Any})

Flushes an ApiCache object.

# Arguments
- `api_id`: The API ID.

"""
function flush_api_cache(apiId; aws_config::AbstractAWSConfig=current_aws_config())
    return appsync(
        "DELETE",
        "/v1/apis/$(apiId)/FlushCache";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function flush_api_cache(
    apiId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appsync(
        "DELETE",
        "/v1/apis/$(apiId)/FlushCache",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_api_association(domain_name)
    get_api_association(domain_name, params::Dict{String,<:Any})

Retrieves an ApiAssociation object.

# Arguments
- `domain_name`: The domain name.

"""
function get_api_association(domainName; aws_config::AbstractAWSConfig=current_aws_config())
    return appsync(
        "GET",
        "/v1/domainnames/$(domainName)/apiassociation";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_api_association(
    domainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appsync(
        "GET",
        "/v1/domainnames/$(domainName)/apiassociation",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_api_cache(api_id)
    get_api_cache(api_id, params::Dict{String,<:Any})

Retrieves an ApiCache object.

# Arguments
- `api_id`: The API ID.

"""
function get_api_cache(apiId; aws_config::AbstractAWSConfig=current_aws_config())
    return appsync(
        "GET",
        "/v1/apis/$(apiId)/ApiCaches";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_api_cache(
    apiId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appsync(
        "GET",
        "/v1/apis/$(apiId)/ApiCaches",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_data_source(api_id, name)
    get_data_source(api_id, name, params::Dict{String,<:Any})

Retrieves a DataSource object.

# Arguments
- `api_id`: The API ID.
- `name`: The name of the data source.

"""
function get_data_source(apiId, name; aws_config::AbstractAWSConfig=current_aws_config())
    return appsync(
        "GET",
        "/v1/apis/$(apiId)/datasources/$(name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_data_source(
    apiId,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appsync(
        "GET",
        "/v1/apis/$(apiId)/datasources/$(name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_data_source_introspection(introspection_id)
    get_data_source_introspection(introspection_id, params::Dict{String,<:Any})

Retrieves the record of an existing introspection. If the retrieval is successful, the
result of the instrospection will also be returned. If the retrieval fails the operation,
an error message will be returned instead.

# Arguments
- `introspection_id`: The introspection ID. Each introspection contains a unique ID that
  can be used to reference the instrospection record.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"includeModelsSDL"`: A boolean flag that determines whether SDL should be generated for
  introspected types or not. If set to true, each model will contain an sdl property that
  contains the SDL for that type. The SDL only contains the type data and no additional
  metadata or directives.
- `"maxResults"`: The maximum number of introspected types that will be returned in a
  single response.
- `"nextToken"`: Determines the number of types to be returned in a single response before
  paginating. This value is typically taken from nextToken value from the previous response.
"""
function get_data_source_introspection(
    introspectionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appsync(
        "GET",
        "/v1/datasources/introspections/$(introspectionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_data_source_introspection(
    introspectionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appsync(
        "GET",
        "/v1/datasources/introspections/$(introspectionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_domain_name(domain_name)
    get_domain_name(domain_name, params::Dict{String,<:Any})

Retrieves a custom DomainName object.

# Arguments
- `domain_name`: The domain name.

"""
function get_domain_name(domainName; aws_config::AbstractAWSConfig=current_aws_config())
    return appsync(
        "GET",
        "/v1/domainnames/$(domainName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_domain_name(
    domainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appsync(
        "GET",
        "/v1/domainnames/$(domainName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_function(api_id, function_id)
    get_function(api_id, function_id, params::Dict{String,<:Any})

Get a Function.

# Arguments
- `api_id`: The GraphQL API ID.
- `function_id`: The Function ID.

"""
function get_function(apiId, functionId; aws_config::AbstractAWSConfig=current_aws_config())
    return appsync(
        "GET",
        "/v1/apis/$(apiId)/functions/$(functionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_function(
    apiId,
    functionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appsync(
        "GET",
        "/v1/apis/$(apiId)/functions/$(functionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_graphql_api(api_id)
    get_graphql_api(api_id, params::Dict{String,<:Any})

Retrieves a GraphqlApi object.

# Arguments
- `api_id`: The API ID for the GraphQL API.

"""
function get_graphql_api(apiId; aws_config::AbstractAWSConfig=current_aws_config())
    return appsync(
        "GET", "/v1/apis/$(apiId)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_graphql_api(
    apiId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appsync(
        "GET",
        "/v1/apis/$(apiId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_graphql_api_environment_variables(api_id)
    get_graphql_api_environment_variables(api_id, params::Dict{String,<:Any})

Retrieves the list of environmental variable key-value pairs associated with an API by its
ID value.

# Arguments
- `api_id`: The ID of the API from which the environmental variable list will be retrieved.

"""
function get_graphql_api_environment_variables(
    apiId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appsync(
        "GET",
        "/v1/apis/$(apiId)/environmentVariables";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_graphql_api_environment_variables(
    apiId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appsync(
        "GET",
        "/v1/apis/$(apiId)/environmentVariables",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_introspection_schema(api_id, format)
    get_introspection_schema(api_id, format, params::Dict{String,<:Any})

Retrieves the introspection schema for a GraphQL API.

# Arguments
- `api_id`: The API ID.
- `format`: The schema format: SDL or JSON.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"includeDirectives"`: A flag that specifies whether the schema introspection should
  contain directives.
"""
function get_introspection_schema(
    apiId, format; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appsync(
        "GET",
        "/v1/apis/$(apiId)/schema",
        Dict{String,Any}("format" => format);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_introspection_schema(
    apiId,
    format,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appsync(
        "GET",
        "/v1/apis/$(apiId)/schema",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("format" => format), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_resolver(api_id, field_name, type_name)
    get_resolver(api_id, field_name, type_name, params::Dict{String,<:Any})

Retrieves a Resolver object.

# Arguments
- `api_id`: The API ID.
- `field_name`: The resolver field name.
- `type_name`: The resolver type name.

"""
function get_resolver(
    apiId, fieldName, typeName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appsync(
        "GET",
        "/v1/apis/$(apiId)/types/$(typeName)/resolvers/$(fieldName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_resolver(
    apiId,
    fieldName,
    typeName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appsync(
        "GET",
        "/v1/apis/$(apiId)/types/$(typeName)/resolvers/$(fieldName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_schema_creation_status(api_id)
    get_schema_creation_status(api_id, params::Dict{String,<:Any})

Retrieves the current status of a schema creation operation.

# Arguments
- `api_id`: The API ID.

"""
function get_schema_creation_status(
    apiId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appsync(
        "GET",
        "/v1/apis/$(apiId)/schemacreation";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_schema_creation_status(
    apiId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appsync(
        "GET",
        "/v1/apis/$(apiId)/schemacreation",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_source_api_association(association_id, merged_api_identifier)
    get_source_api_association(association_id, merged_api_identifier, params::Dict{String,<:Any})

Retrieves a SourceApiAssociation object.

# Arguments
- `association_id`: The ID generated by the AppSync service for the source API association.
- `merged_api_identifier`: The identifier of the AppSync Merged API. This is generated by
  the AppSync service. In most cases, Merged APIs (especially in your account) only require
  the API ID value or ARN of the merged API. However, Merged APIs in other accounts
  (cross-account use cases) strictly require the full resource ARN of the merged API.

"""
function get_source_api_association(
    associationId, mergedApiIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appsync(
        "GET",
        "/v1/mergedApis/$(mergedApiIdentifier)/sourceApiAssociations/$(associationId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_source_api_association(
    associationId,
    mergedApiIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appsync(
        "GET",
        "/v1/mergedApis/$(mergedApiIdentifier)/sourceApiAssociations/$(associationId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_type(api_id, format, type_name)
    get_type(api_id, format, type_name, params::Dict{String,<:Any})

Retrieves a Type object.

# Arguments
- `api_id`: The API ID.
- `format`: The type format: SDL or JSON.
- `type_name`: The type name.

"""
function get_type(
    apiId, format, typeName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appsync(
        "GET",
        "/v1/apis/$(apiId)/types/$(typeName)",
        Dict{String,Any}("format" => format);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_type(
    apiId,
    format,
    typeName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appsync(
        "GET",
        "/v1/apis/$(apiId)/types/$(typeName)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("format" => format), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_api_keys(api_id)
    list_api_keys(api_id, params::Dict{String,<:Any})

Lists the API keys for a given API.  API keys are deleted automatically 60 days after they
expire. However, they may still be included in the response until they have actually been
deleted. You can safely call DeleteApiKey to manually delete a key before it's
automatically deleted.

# Arguments
- `api_id`: The API ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results that you want the request to return.
- `"nextToken"`: An identifier that was returned from the previous call to this operation,
  which you can use to return the next set of items in the list.
"""
function list_api_keys(apiId; aws_config::AbstractAWSConfig=current_aws_config())
    return appsync(
        "GET",
        "/v1/apis/$(apiId)/apikeys";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_api_keys(
    apiId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appsync(
        "GET",
        "/v1/apis/$(apiId)/apikeys",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_data_sources(api_id)
    list_data_sources(api_id, params::Dict{String,<:Any})

Lists the data sources for a given API.

# Arguments
- `api_id`: The API ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results that you want the request to return.
- `"nextToken"`: An identifier that was returned from the previous call to this operation,
  which you can use to return the next set of items in the list.
"""
function list_data_sources(apiId; aws_config::AbstractAWSConfig=current_aws_config())
    return appsync(
        "GET",
        "/v1/apis/$(apiId)/datasources";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_data_sources(
    apiId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appsync(
        "GET",
        "/v1/apis/$(apiId)/datasources",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_domain_names()
    list_domain_names(params::Dict{String,<:Any})

Lists multiple custom domain names.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results that you want the request to return.
- `"nextToken"`: An identifier that was returned from the previous call to this operation,
  which you can use to return the next set of items in the list.
"""
function list_domain_names(; aws_config::AbstractAWSConfig=current_aws_config())
    return appsync(
        "GET", "/v1/domainnames"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_domain_names(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appsync(
        "GET",
        "/v1/domainnames",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_functions(api_id)
    list_functions(api_id, params::Dict{String,<:Any})

List multiple functions.

# Arguments
- `api_id`: The GraphQL API ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results that you want the request to return.
- `"nextToken"`: An identifier that was returned from the previous call to this operation,
  which you can use to return the next set of items in the list.
"""
function list_functions(apiId; aws_config::AbstractAWSConfig=current_aws_config())
    return appsync(
        "GET",
        "/v1/apis/$(apiId)/functions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_functions(
    apiId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appsync(
        "GET",
        "/v1/apis/$(apiId)/functions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_graphql_apis()
    list_graphql_apis(params::Dict{String,<:Any})

Lists your GraphQL APIs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"apiType"`: The value that indicates whether the GraphQL API is a standard API (GRAPHQL)
  or merged API (MERGED).
- `"maxResults"`: The maximum number of results that you want the request to return.
- `"nextToken"`: An identifier that was returned from the previous call to this operation,
  which you can use to return the next set of items in the list.
- `"owner"`: The account owner of the GraphQL API.
"""
function list_graphql_apis(; aws_config::AbstractAWSConfig=current_aws_config())
    return appsync(
        "GET", "/v1/apis"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_graphql_apis(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appsync(
        "GET", "/v1/apis", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_resolvers(api_id, type_name)
    list_resolvers(api_id, type_name, params::Dict{String,<:Any})

Lists the resolvers for a given API and type.

# Arguments
- `api_id`: The API ID.
- `type_name`: The type name.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results that you want the request to return.
- `"nextToken"`: An identifier that was returned from the previous call to this operation,
  which you can use to return the next set of items in the list.
"""
function list_resolvers(apiId, typeName; aws_config::AbstractAWSConfig=current_aws_config())
    return appsync(
        "GET",
        "/v1/apis/$(apiId)/types/$(typeName)/resolvers";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_resolvers(
    apiId,
    typeName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appsync(
        "GET",
        "/v1/apis/$(apiId)/types/$(typeName)/resolvers",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_resolvers_by_function(api_id, function_id)
    list_resolvers_by_function(api_id, function_id, params::Dict{String,<:Any})

List the resolvers that are associated with a specific function.

# Arguments
- `api_id`: The API ID.
- `function_id`: The function ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results that you want the request to return.
- `"nextToken"`: An identifier that was returned from the previous call to this operation,
  which you can use to return the next set of items in the list.
"""
function list_resolvers_by_function(
    apiId, functionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appsync(
        "GET",
        "/v1/apis/$(apiId)/functions/$(functionId)/resolvers";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_resolvers_by_function(
    apiId,
    functionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appsync(
        "GET",
        "/v1/apis/$(apiId)/functions/$(functionId)/resolvers",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_source_api_associations(api_id)
    list_source_api_associations(api_id, params::Dict{String,<:Any})

Lists the SourceApiAssociationSummary data.

# Arguments
- `api_id`: The API ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results that you want the request to return.
- `"nextToken"`: An identifier that was returned from the previous call to this operation,
  which you can use to return the next set of items in the list.
"""
function list_source_api_associations(
    apiId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appsync(
        "GET",
        "/v1/apis/$(apiId)/sourceApiAssociations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_source_api_associations(
    apiId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appsync(
        "GET",
        "/v1/apis/$(apiId)/sourceApiAssociations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists the tags for a resource.

# Arguments
- `resource_arn`: The GraphqlApi Amazon Resource Name (ARN).

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appsync(
        "GET",
        "/v1/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appsync(
        "GET",
        "/v1/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_types(api_id, format)
    list_types(api_id, format, params::Dict{String,<:Any})

Lists the types for a given API.

# Arguments
- `api_id`: The API ID.
- `format`: The type format: SDL or JSON.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results that you want the request to return.
- `"nextToken"`: An identifier that was returned from the previous call to this operation,
  which you can use to return the next set of items in the list.
"""
function list_types(apiId, format; aws_config::AbstractAWSConfig=current_aws_config())
    return appsync(
        "GET",
        "/v1/apis/$(apiId)/types",
        Dict{String,Any}("format" => format);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_types(
    apiId,
    format,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appsync(
        "GET",
        "/v1/apis/$(apiId)/types",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("format" => format), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_types_by_association(association_id, format, merged_api_identifier)
    list_types_by_association(association_id, format, merged_api_identifier, params::Dict{String,<:Any})

Lists Type objects by the source API association ID.

# Arguments
- `association_id`: The ID generated by the AppSync service for the source API association.
- `format`: The format type.
- `merged_api_identifier`: The identifier of the AppSync Merged API. This is generated by
  the AppSync service. In most cases, Merged APIs (especially in your account) only require
  the API ID value or ARN of the merged API. However, Merged APIs in other accounts
  (cross-account use cases) strictly require the full resource ARN of the merged API.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results that you want the request to return.
- `"nextToken"`: An identifier that was returned from the previous call to this operation,
  which you can use to return the next set of items in the list.
"""
function list_types_by_association(
    associationId,
    format,
    mergedApiIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appsync(
        "GET",
        "/v1/mergedApis/$(mergedApiIdentifier)/sourceApiAssociations/$(associationId)/types",
        Dict{String,Any}("format" => format);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_types_by_association(
    associationId,
    format,
    mergedApiIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appsync(
        "GET",
        "/v1/mergedApis/$(mergedApiIdentifier)/sourceApiAssociations/$(associationId)/types",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("format" => format), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_graphql_api_environment_variables(api_id, environment_variables)
    put_graphql_api_environment_variables(api_id, environment_variables, params::Dict{String,<:Any})

Creates a list of environmental variables in an API by its ID value.  When creating an
environmental variable, it must follow the constraints below:   Both JavaScript and VTL
templates support environmental variables.   Environmental variables are not evaluated
before function invocation.   Environmental variables only support string values.   Any
defined value in an environmental variable is considered a string literal and not expanded.
  Variable evaluations should ideally be performed in the function code.   When creating an
environmental variable key-value pair, it must follow the additional constraints below:
Keys must begin with a letter.   Keys must be at least two characters long.   Keys can only
contain letters, numbers, and the underscore character (_).   Values can be up to 512
characters long.   You can configure up to 50 key-value pairs in a GraphQL API.   You can
create a list of environmental variables by adding it to the environmentVariables payload
as a list in the format {\"key1\":\"value1\",\"key2\":\"value2\", …}. Note that each call
of the PutGraphqlApiEnvironmentVariables action will result in the overwriting of the
existing environmental variable list of that API. This means the existing environmental
variables will be lost. To avoid this, you must include all existing and new environmental
variables in the list each time you call this action.

# Arguments
- `api_id`: The ID of the API to which the environmental variable list will be written.
- `environment_variables`: The list of environmental variables to add to the API. When
  creating an environmental variable key-value pair, it must follow the additional
  constraints below:   Keys must begin with a letter.   Keys must be at least two characters
  long.   Keys can only contain letters, numbers, and the underscore character (_).   Values
  can be up to 512 characters long.   You can configure up to 50 key-value pairs in a GraphQL
  API.   You can create a list of environmental variables by adding it to the
  environmentVariables payload as a list in the format
  {\"key1\":\"value1\",\"key2\":\"value2\", …}. Note that each call of the
  PutGraphqlApiEnvironmentVariables action will result in the overwriting of the existing
  environmental variable list of that API. This means the existing environmental variables
  will be lost. To avoid this, you must include all existing and new environmental variables
  in the list each time you call this action.

"""
function put_graphql_api_environment_variables(
    apiId, environmentVariables; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appsync(
        "PUT",
        "/v1/apis/$(apiId)/environmentVariables",
        Dict{String,Any}("environmentVariables" => environmentVariables);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_graphql_api_environment_variables(
    apiId,
    environmentVariables,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appsync(
        "PUT",
        "/v1/apis/$(apiId)/environmentVariables",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("environmentVariables" => environmentVariables),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_data_source_introspection()
    start_data_source_introspection(params::Dict{String,<:Any})

Creates a new introspection. Returns the introspectionId of the new introspection after its
creation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"rdsDataApiConfig"`: The rdsDataApiConfig object data.
"""
function start_data_source_introspection(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return appsync(
        "POST",
        "/v1/datasources/introspections";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_data_source_introspection(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appsync(
        "POST",
        "/v1/datasources/introspections",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_schema_creation(api_id, definition)
    start_schema_creation(api_id, definition, params::Dict{String,<:Any})

Adds a new schema to your GraphQL API. This operation is asynchronous. Use to determine
when it has completed.

# Arguments
- `api_id`: The API ID.
- `definition`: The schema definition, in GraphQL schema language format.

"""
function start_schema_creation(
    apiId, definition; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appsync(
        "POST",
        "/v1/apis/$(apiId)/schemacreation",
        Dict{String,Any}("definition" => definition);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_schema_creation(
    apiId,
    definition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appsync(
        "POST",
        "/v1/apis/$(apiId)/schemacreation",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("definition" => definition), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_schema_merge(association_id, merged_api_identifier)
    start_schema_merge(association_id, merged_api_identifier, params::Dict{String,<:Any})

Initiates a merge operation. Returns a status that shows the result of the merge operation.

# Arguments
- `association_id`: The ID generated by the AppSync service for the source API association.
- `merged_api_identifier`: The identifier of the AppSync Merged API. This is generated by
  the AppSync service. In most cases, Merged APIs (especially in your account) only require
  the API ID value or ARN of the merged API. However, Merged APIs in other accounts
  (cross-account use cases) strictly require the full resource ARN of the merged API.

"""
function start_schema_merge(
    associationId, mergedApiIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appsync(
        "POST",
        "/v1/mergedApis/$(mergedApiIdentifier)/sourceApiAssociations/$(associationId)/merge";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_schema_merge(
    associationId,
    mergedApiIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appsync(
        "POST",
        "/v1/mergedApis/$(mergedApiIdentifier)/sourceApiAssociations/$(associationId)/merge",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Tags a resource with user-supplied tags.

# Arguments
- `resource_arn`: The GraphqlApi Amazon Resource Name (ARN).
- `tags`: A TagMap object.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return appsync(
        "POST",
        "/v1/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appsync(
        "POST",
        "/v1/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Untags a resource.

# Arguments
- `resource_arn`: The GraphqlApi Amazon Resource Name (ARN).
- `tag_keys`: A list of TagKey objects.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appsync(
        "DELETE",
        "/v1/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appsync(
        "DELETE",
        "/v1/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_api_cache(api_caching_behavior, api_id, ttl, type)
    update_api_cache(api_caching_behavior, api_id, ttl, type, params::Dict{String,<:Any})

Updates the cache for the GraphQL API.

# Arguments
- `api_caching_behavior`: Caching behavior.    FULL_REQUEST_CACHING: All requests are fully
  cached.    PER_RESOLVER_CACHING: Individual resolvers that you specify are cached.
- `api_id`: The GraphQL API ID.
- `ttl`: TTL in seconds for cache entries. Valid values are 1–3,600 seconds.
- `type`: The cache instance type. Valid values are     SMALL     MEDIUM     LARGE
  XLARGE     LARGE_2X     LARGE_4X     LARGE_8X (not available in all regions)    LARGE_12X
   Historically, instance types were identified by an EC2-style value. As of July 2020, this
  is deprecated, and the generic identifiers above should be used. The following legacy
  instance types are available, but their use is discouraged:    T2_SMALL: A t2.small
  instance type.    T2_MEDIUM: A t2.medium instance type.    R4_LARGE: A r4.large instance
  type.    R4_XLARGE: A r4.xlarge instance type.    R4_2XLARGE: A r4.2xlarge instance type.
   R4_4XLARGE: A r4.4xlarge instance type.    R4_8XLARGE: A r4.8xlarge instance type.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"healthMetricsConfig"`: Controls how cache health metrics will be emitted to CloudWatch.
  Cache health metrics include:   NetworkBandwidthOutAllowanceExceeded: The network packets
  dropped because the throughput exceeded the aggregated bandwidth limit. This is useful for
  diagnosing bottlenecks in a cache configuration.   EngineCPUUtilization: The CPU
  utilization (percentage) allocated to the Redis process. This is useful for diagnosing
  bottlenecks in a cache configuration.   Metrics will be recorded by API ID. You can set the
  value to ENABLED or DISABLED.
"""
function update_api_cache(
    apiCachingBehavior, apiId, ttl, type; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appsync(
        "POST",
        "/v1/apis/$(apiId)/ApiCaches/update",
        Dict{String,Any}(
            "apiCachingBehavior" => apiCachingBehavior, "ttl" => ttl, "type" => type
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_api_cache(
    apiCachingBehavior,
    apiId,
    ttl,
    type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appsync(
        "POST",
        "/v1/apis/$(apiId)/ApiCaches/update",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "apiCachingBehavior" => apiCachingBehavior, "ttl" => ttl, "type" => type
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_api_key(api_id, id)
    update_api_key(api_id, id, params::Dict{String,<:Any})

Updates an API key. You can update the key as long as it's not deleted.

# Arguments
- `api_id`: The ID for the GraphQL API.
- `id`: The API key ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A description of the purpose of the API key.
- `"expires"`: From the update time, the time after which the API key expires. The date is
  represented as seconds since the epoch. For more information, see .
"""
function update_api_key(apiId, id; aws_config::AbstractAWSConfig=current_aws_config())
    return appsync(
        "POST",
        "/v1/apis/$(apiId)/apikeys/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_api_key(
    apiId,
    id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appsync(
        "POST",
        "/v1/apis/$(apiId)/apikeys/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_data_source(api_id, name, type)
    update_data_source(api_id, name, type, params::Dict{String,<:Any})

Updates a DataSource object.

# Arguments
- `api_id`: The API ID.
- `name`: The new name for the data source.
- `type`: The new data source type.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The new description for the data source.
- `"dynamodbConfig"`: The new Amazon DynamoDB configuration.
- `"elasticsearchConfig"`: The new OpenSearch configuration. As of September 2021, Amazon
  Elasticsearch service is Amazon OpenSearch Service. This configuration is deprecated.
  Instead, use UpdateDataSourceRequestopenSearchServiceConfig to update an OpenSearch data
  source.
- `"eventBridgeConfig"`: The new Amazon EventBridge settings.
- `"httpConfig"`: The new HTTP endpoint configuration.
- `"lambdaConfig"`: The new Lambda configuration.
- `"metricsConfig"`: Enables or disables enhanced data source metrics for specified data
  sources. Note that metricsConfig won't be used unless the dataSourceLevelMetricsBehavior
  value is set to PER_DATA_SOURCE_METRICS. If the dataSourceLevelMetricsBehavior is set to
  FULL_REQUEST_DATA_SOURCE_METRICS instead, metricsConfig will be ignored. However, you can
  still set its value.  metricsConfig can be ENABLED or DISABLED.
- `"openSearchServiceConfig"`: The new OpenSearch configuration.
- `"relationalDatabaseConfig"`: The new relational database configuration.
- `"serviceRoleArn"`: The new service role Amazon Resource Name (ARN) for the data source.
"""
function update_data_source(
    apiId, name, type; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appsync(
        "POST",
        "/v1/apis/$(apiId)/datasources/$(name)",
        Dict{String,Any}("type" => type);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_data_source(
    apiId,
    name,
    type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appsync(
        "POST",
        "/v1/apis/$(apiId)/datasources/$(name)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("type" => type), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_domain_name(domain_name)
    update_domain_name(domain_name, params::Dict{String,<:Any})

Updates a custom DomainName object.

# Arguments
- `domain_name`: The domain name.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A description of the DomainName.
"""
function update_domain_name(domainName; aws_config::AbstractAWSConfig=current_aws_config())
    return appsync(
        "POST",
        "/v1/domainnames/$(domainName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_domain_name(
    domainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appsync(
        "POST",
        "/v1/domainnames/$(domainName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_function(api_id, data_source_name, function_id, name)
    update_function(api_id, data_source_name, function_id, name, params::Dict{String,<:Any})

Updates a Function object.

# Arguments
- `api_id`: The GraphQL API ID.
- `data_source_name`: The Function DataSource name.
- `function_id`: The function ID.
- `name`: The Function name.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"code"`: The function code that contains the request and response functions. When code
  is used, the runtime is required. The runtime value must be APPSYNC_JS.
- `"description"`: The Function description.
- `"functionVersion"`: The version of the request mapping template. Currently, the
  supported value is 2018-05-29. Note that when using VTL and mapping templates, the
  functionVersion is required.
- `"maxBatchSize"`: The maximum batching size for a resolver.
- `"requestMappingTemplate"`: The Function request mapping template. Functions support only
  the 2018-05-29 version of the request mapping template.
- `"responseMappingTemplate"`: The Function request mapping template.
- `"runtime"`:
- `"syncConfig"`:
"""
function update_function(
    apiId,
    dataSourceName,
    functionId,
    name;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appsync(
        "POST",
        "/v1/apis/$(apiId)/functions/$(functionId)",
        Dict{String,Any}("dataSourceName" => dataSourceName, "name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_function(
    apiId,
    dataSourceName,
    functionId,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appsync(
        "POST",
        "/v1/apis/$(apiId)/functions/$(functionId)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("dataSourceName" => dataSourceName, "name" => name),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_graphql_api(api_id, authentication_type, name)
    update_graphql_api(api_id, authentication_type, name, params::Dict{String,<:Any})

Updates a GraphqlApi object.

# Arguments
- `api_id`: The API ID.
- `authentication_type`: The new authentication type for the GraphqlApi object.
- `name`: The new name for the GraphqlApi object.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"additionalAuthenticationProviders"`: A list of additional authentication providers for
  the GraphqlApi API.
- `"enhancedMetricsConfig"`: The enhancedMetricsConfig object.
- `"introspectionConfig"`: Sets the value of the GraphQL API to enable (ENABLED) or disable
  (DISABLED) introspection. If no value is provided, the introspection configuration will be
  set to ENABLED by default. This field will produce an error if the operation attempts to
  use the introspection feature while this field is disabled. For more information about
  introspection, see GraphQL introspection.
- `"lambdaAuthorizerConfig"`: Configuration for Lambda function authorization.
- `"logConfig"`: The Amazon CloudWatch Logs configuration for the GraphqlApi object.
- `"mergedApiExecutionRoleArn"`: The Identity and Access Management service role ARN for a
  merged API. The AppSync service assumes this role on behalf of the Merged API to validate
  access to source APIs at runtime and to prompt the AUTO_MERGE to update the merged API
  endpoint with the source API changes automatically.
- `"openIDConnectConfig"`: The OpenID Connect configuration for the GraphqlApi object.
- `"ownerContact"`: The owner contact information for an API resource. This field accepts
  any string input with a length of 0 - 256 characters.
- `"queryDepthLimit"`: The maximum depth a query can have in a single request. Depth refers
  to the amount of nested levels allowed in the body of query. The default value is 0 (or
  unspecified), which indicates there's no depth limit. If you set a limit, it can be between
  1 and 75 nested levels. This field will produce a limit error if the operation falls out of
  bounds. Note that fields can still be set to nullable or non-nullable. If a non-nullable
  field produces an error, the error will be thrown upwards to the first nullable field
  available.
- `"resolverCountLimit"`: The maximum number of resolvers that can be invoked in a single
  request. The default value is 0 (or unspecified), which will set the limit to 10000. When
  specified, the limit value can be between 1 and 10000. This field will produce a limit
  error if the operation falls out of bounds.
- `"userPoolConfig"`: The new Amazon Cognito user pool configuration for the ~GraphqlApi
  object.
- `"xrayEnabled"`: A flag indicating whether to use X-Ray tracing for the GraphqlApi.
"""
function update_graphql_api(
    apiId, authenticationType, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appsync(
        "POST",
        "/v1/apis/$(apiId)",
        Dict{String,Any}("authenticationType" => authenticationType, "name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_graphql_api(
    apiId,
    authenticationType,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appsync(
        "POST",
        "/v1/apis/$(apiId)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "authenticationType" => authenticationType, "name" => name
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_resolver(api_id, field_name, type_name)
    update_resolver(api_id, field_name, type_name, params::Dict{String,<:Any})

Updates a Resolver object.

# Arguments
- `api_id`: The API ID.
- `field_name`: The new field name.
- `type_name`: The new type name.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"cachingConfig"`: The caching configuration for the resolver.
- `"code"`: The resolver code that contains the request and response functions. When code
  is used, the runtime is required. The runtime value must be APPSYNC_JS.
- `"dataSourceName"`: The new data source name.
- `"kind"`: The resolver type.    UNIT: A UNIT resolver type. A UNIT resolver is the
  default resolver type. You can use a UNIT resolver to run a GraphQL query against a single
  data source.    PIPELINE: A PIPELINE resolver type. You can use a PIPELINE resolver to
  invoke a series of Function objects in a serial manner. You can use a pipeline resolver to
  run a GraphQL query against multiple data sources.
- `"maxBatchSize"`: The maximum batching size for a resolver.
- `"metricsConfig"`: Enables or disables enhanced resolver metrics for specified resolvers.
  Note that metricsConfig won't be used unless the resolverLevelMetricsBehavior value is set
  to PER_RESOLVER_METRICS. If the resolverLevelMetricsBehavior is set to
  FULL_REQUEST_RESOLVER_METRICS instead, metricsConfig will be ignored. However, you can
  still set its value.  metricsConfig can be ENABLED or DISABLED.
- `"pipelineConfig"`: The PipelineConfig.
- `"requestMappingTemplate"`: The new request mapping template. A resolver uses a request
  mapping template to convert a GraphQL expression into a format that a data source can
  understand. Mapping templates are written in Apache Velocity Template Language (VTL). VTL
  request mapping templates are optional when using an Lambda data source. For all other data
  sources, VTL request and response mapping templates are required.
- `"responseMappingTemplate"`: The new response mapping template.
- `"runtime"`:
- `"syncConfig"`: The SyncConfig for a resolver attached to a versioned data source.
"""
function update_resolver(
    apiId, fieldName, typeName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appsync(
        "POST",
        "/v1/apis/$(apiId)/types/$(typeName)/resolvers/$(fieldName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_resolver(
    apiId,
    fieldName,
    typeName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appsync(
        "POST",
        "/v1/apis/$(apiId)/types/$(typeName)/resolvers/$(fieldName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_source_api_association(association_id, merged_api_identifier)
    update_source_api_association(association_id, merged_api_identifier, params::Dict{String,<:Any})

Updates some of the configuration choices of a particular source API association.

# Arguments
- `association_id`: The ID generated by the AppSync service for the source API association.
- `merged_api_identifier`: The identifier of the AppSync Merged API. This is generated by
  the AppSync service. In most cases, Merged APIs (especially in your account) only require
  the API ID value or ARN of the merged API. However, Merged APIs in other accounts
  (cross-account use cases) strictly require the full resource ARN of the merged API.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description field.
- `"sourceApiAssociationConfig"`: The SourceApiAssociationConfig object data.
"""
function update_source_api_association(
    associationId, mergedApiIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appsync(
        "POST",
        "/v1/mergedApis/$(mergedApiIdentifier)/sourceApiAssociations/$(associationId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_source_api_association(
    associationId,
    mergedApiIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appsync(
        "POST",
        "/v1/mergedApis/$(mergedApiIdentifier)/sourceApiAssociations/$(associationId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_type(api_id, format, type_name)
    update_type(api_id, format, type_name, params::Dict{String,<:Any})

Updates a Type object.

# Arguments
- `api_id`: The API ID.
- `format`: The new type format: SDL or JSON.
- `type_name`: The new type name.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"definition"`: The new definition.
"""
function update_type(
    apiId, format, typeName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appsync(
        "POST",
        "/v1/apis/$(apiId)/types/$(typeName)",
        Dict{String,Any}("format" => format);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_type(
    apiId,
    format,
    typeName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appsync(
        "POST",
        "/v1/apis/$(apiId)/types/$(typeName)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("format" => format), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: payment_cryptography
using AWS.Compat
using AWS.UUIDs

"""
    create_alias(alias_name)
    create_alias(alias_name, params::Dict{String,<:Any})

Creates an alias, or a friendly name, for an Amazon Web Services Payment Cryptography key.
You can use an alias to identify a key in the console and when you call cryptographic
operations such as EncryptData or DecryptData. You can associate the alias with any key in
the same Amazon Web Services Region. Each alias is associated with only one key at a time,
but a key can have multiple aliases. You can't create an alias without a key. The alias
must be unique in the account and Amazon Web Services Region, but you can create another
alias with the same name in a different Amazon Web Services Region. To change the key
that's associated with the alias, call UpdateAlias. To delete the alias, call DeleteAlias.
These operations don't affect the underlying key. To get the alias that you created, call
ListAliases.  Cross-account use: This operation can't be used across different Amazon Web
Services accounts.  Related operations:     DeleteAlias     GetAlias     ListAliases
UpdateAlias

# Arguments
- `alias_name`: A friendly name that you can use to refer to a key. An alias must begin
  with alias/ followed by a name, for example alias/ExampleAlias. It can contain only
  alphanumeric characters, forward slashes (/), underscores (_), and dashes (-).  Don't
  include personal, confidential or sensitive information in this field. This field may be
  displayed in plaintext in CloudTrail logs and other output.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"KeyArn"`: The KeyARN of the key to associate with the alias.
"""
function create_alias(AliasName; aws_config::AbstractAWSConfig=current_aws_config())
    return payment_cryptography(
        "CreateAlias",
        Dict{String,Any}("AliasName" => AliasName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_alias(
    AliasName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return payment_cryptography(
        "CreateAlias",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AliasName" => AliasName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_key(exportable, key_attributes)
    create_key(exportable, key_attributes, params::Dict{String,<:Any})

Creates an Amazon Web Services Payment Cryptography key, a logical representation of a
cryptographic key, that is unique in your account and Amazon Web Services Region. You use
keys for cryptographic functions such as encryption and decryption.  In addition to the key
material used in cryptographic operations, an Amazon Web Services Payment Cryptography key
includes metadata such as the key ARN, key usage, key origin, creation date, description,
and key state. When you create a key, you specify both immutable and mutable data about the
key. The immutable data contains key attributes that define the scope and cryptographic
operations that you can perform using the key, for example key class (example:
SYMMETRIC_KEY), key algorithm (example: TDES_2KEY), key usage (example:
TR31_P0_PIN_ENCRYPTION_KEY) and key modes of use (example: Encrypt). For information about
valid combinations of key attributes, see Understanding key attributes in the Amazon Web
Services Payment Cryptography User Guide. The mutable data contained within a key includes
usage timestamp and key deletion timestamp and can be modified after creation. Amazon Web
Services Payment Cryptography binds key attributes to keys using key blocks when you store
or export them. Amazon Web Services Payment Cryptography stores the key contents wrapped
and never stores or transmits them in the clear.   Cross-account use: This operation can't
be used across different Amazon Web Services accounts.  Related operations:     DeleteKey
  GetKey     ListKeys

# Arguments
- `exportable`: Specifies whether the key is exportable from the service.
- `key_attributes`: The role of the key, the algorithm it supports, and the cryptographic
  operations allowed with the key. This data is immutable after the key is created.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Enabled"`: Specifies whether to enable the key. If the key is enabled, it is activated
  for use within the service. If the key is not enabled, then it is created but not
  activated. The default value is enabled.
- `"KeyCheckValueAlgorithm"`: The algorithm that Amazon Web Services Payment Cryptography
  uses to calculate the key check value (KCV). It is used to validate the key integrity. For
  TDES keys, the KCV is computed by encrypting 8 bytes, each with value of zero, with the key
  to be checked and retaining the 3 highest order bytes of the encrypted result. For AES
  keys, the KCV is computed using a CMAC algorithm where the input data is 16 bytes of zero
  and retaining the 3 highest order bytes of the encrypted result.
- `"Tags"`: Assigns one or more tags to the Amazon Web Services Payment Cryptography key.
  Use this parameter to tag a key when it is created. To tag an existing Amazon Web Services
  Payment Cryptography key, use the TagResource operation. Each tag consists of a tag key and
  a tag value. Both the tag key and the tag value are required, but the tag value can be an
  empty (null) string. You can't have more than one tag on an Amazon Web Services Payment
  Cryptography key with the same tag key.   Don't include personal, confidential or sensitive
  information in this field. This field may be displayed in plaintext in CloudTrail logs and
  other output.   Tagging or untagging an Amazon Web Services Payment Cryptography key can
  allow or deny permission to the key.
"""
function create_key(
    Exportable, KeyAttributes; aws_config::AbstractAWSConfig=current_aws_config()
)
    return payment_cryptography(
        "CreateKey",
        Dict{String,Any}("Exportable" => Exportable, "KeyAttributes" => KeyAttributes);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_key(
    Exportable,
    KeyAttributes,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return payment_cryptography(
        "CreateKey",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Exportable" => Exportable, "KeyAttributes" => KeyAttributes
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_alias(alias_name)
    delete_alias(alias_name, params::Dict{String,<:Any})

Deletes the alias, but doesn't affect the underlying key. Each key can have multiple
aliases. To get the aliases of all keys, use the UpdateAlias operation. To change the alias
of a key, first use DeleteAlias to delete the current alias and then use CreateAlias to
create a new alias. To associate an existing alias with a different key, call UpdateAlias.
Cross-account use: This operation can't be used across different Amazon Web Services
accounts.  Related operations:     CreateAlias     GetAlias     ListAliases     UpdateAlias


# Arguments
- `alias_name`: A friendly name that you can use to refer Amazon Web Services Payment
  Cryptography key. This value must begin with alias/ followed by a name, such as
  alias/ExampleAlias.

"""
function delete_alias(AliasName; aws_config::AbstractAWSConfig=current_aws_config())
    return payment_cryptography(
        "DeleteAlias",
        Dict{String,Any}("AliasName" => AliasName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_alias(
    AliasName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return payment_cryptography(
        "DeleteAlias",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AliasName" => AliasName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_key(key_identifier)
    delete_key(key_identifier, params::Dict{String,<:Any})

Deletes the key material and metadata associated with Amazon Web Services Payment
Cryptography key. Key deletion is irreversible. After a key is deleted, you can't perform
cryptographic operations using the key. For example, you can't decrypt data that was
encrypted by a deleted Amazon Web Services Payment Cryptography key, and the data may
become unrecoverable. Because key deletion is destructive, Amazon Web Services Payment
Cryptography has a safety mechanism to prevent accidental deletion of a key. When you call
this operation, Amazon Web Services Payment Cryptography disables the specified key but
doesn't delete it until after a waiting period set using DeleteKeyInDays. The default
waiting period is 7 days. During the waiting period, the KeyState is DELETE_PENDING. After
the key is deleted, the KeyState is DELETE_COMPLETE. You should delete a key only when you
are sure that you don't need to use it anymore and no other parties are utilizing this key.
If you aren't sure, consider deactivating it instead by calling StopKeyUsage.
Cross-account use: This operation can't be used across different Amazon Web Services
accounts.  Related operations:     RestoreKey     StartKeyUsage     StopKeyUsage

# Arguments
- `key_identifier`: The KeyARN of the key that is scheduled for deletion.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DeleteKeyInDays"`: The waiting period for key deletion. The default value is seven days.
"""
function delete_key(KeyIdentifier; aws_config::AbstractAWSConfig=current_aws_config())
    return payment_cryptography(
        "DeleteKey",
        Dict{String,Any}("KeyIdentifier" => KeyIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_key(
    KeyIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return payment_cryptography(
        "DeleteKey",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("KeyIdentifier" => KeyIdentifier), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    export_key(export_key_identifier, key_material)
    export_key(export_key_identifier, key_material, params::Dict{String,<:Any})

Exports a key from Amazon Web Services Payment Cryptography. Amazon Web Services Payment
Cryptography simplifies key exchange by replacing the existing paper-based approach with a
modern electronic approach. With ExportKey you can export symmetric keys using either
symmetric and asymmetric key exchange mechanisms. Using this operation, you can share your
Amazon Web Services Payment Cryptography generated keys with other service partners to
perform cryptographic operations outside of Amazon Web Services Payment Cryptography  For
symmetric key exchange, Amazon Web Services Payment Cryptography uses the ANSI X9 TR-31
norm in accordance with PCI PIN guidelines. And for asymmetric key exchange, Amazon Web
Services Payment Cryptography supports ANSI X9 TR-34 norm and RSA wrap and unwrap key
exchange mechanism. Asymmetric key exchange methods are typically used to establish
bi-directional trust between the two parties exhanging keys and are used for initial key
exchange such as Key Encryption Key (KEK). After which you can export working keys using
symmetric method to perform various cryptographic operations within Amazon Web Services
Payment Cryptography. The TR-34 norm is intended for exchanging 3DES keys only and keys are
imported in a WrappedKeyBlock format. Key attributes (such as KeyUsage, KeyAlgorithm,
KeyModesOfUse, Exportability) are contained within the key block. With RSA wrap and unwrap,
you can exchange both 3DES and AES-128 keys. The keys are imported in a
WrappedKeyCryptogram format and you will need to specify the key attributes during import.
You can also use ExportKey functionality to generate and export an IPEK (Initial Pin
Encryption Key) from Amazon Web Services Payment Cryptography using either TR-31 or TR-34
export key exchange. IPEK is generated from BDK (Base Derivation Key) and
ExportDukptInitialKey attribute KSN (KeySerialNumber). The generated IPEK does not persist
within Amazon Web Services Payment Cryptography and has to be re-generated each time during
export. For key exchange using TR-31 or TR-34 key blocks, you can also export optional
blocks within the key block header which contain additional attribute information about the
key. The KeyVersion within KeyBlockHeaders indicates the version of the key within the key
block. Furthermore, KeyExportability within KeyBlockHeaders can be used to further restrict
exportability of the key after export from Amazon Web Services Payment Cryptography. The
OptionalBlocks contain the additional data related to the key. For information on data type
that can be included within optional blocks, refer to ASC X9.143-2022.  Data included in
key block headers is signed but transmitted in clear text. Sensitive or confidential
information should not be included in optional blocks. Refer to ASC X9.143-2022 standard
for information on allowed data type.   To export initial keys (KEK) or IPEK using TR-34
Using this operation, you can export initial key using TR-34 asymmetric key exchange. You
can only export KEK generated within Amazon Web Services Payment Cryptography. In TR-34
terminology, the sending party of the key is called Key Distribution Host (KDH) and the
receiving party of the key is called Key Receiving Device (KRD). During key export process,
KDH is Amazon Web Services Payment Cryptography which initiates key export and KRD is the
user receiving the key. To initiate TR-34 key export, the KRD must obtain an export token
by calling GetParametersForExport. This operation also generates a key pair for the purpose
of key export, signs the key and returns back the signing public key certificate (also
known as KDH signing certificate) and root certificate chain. The KDH uses the private key
to sign the the export payload and the signing public key certificate is provided to KRD to
verify the signature. The KRD can import the root certificate into its Hardware Security
Module (HSM), as required. The export token and the associated KDH signing certificate
expires after 7 days.  Next the KRD generates a key pair for the the purpose of encrypting
the KDH key and provides the public key cerificate (also known as KRD wrapping certificate)
back to KDH. The KRD will also import the root cerificate chain into Amazon Web Services
Payment Cryptography by calling ImportKey for RootCertificatePublicKey. The KDH, Amazon Web
Services Payment Cryptography, will use the KRD wrapping cerificate to encrypt (wrap) the
key under export and signs it with signing private key to generate a TR-34 WrappedKeyBlock.
For more information on TR-34 key export, see section Exporting symmetric keys in the
Amazon Web Services Payment Cryptography User Guide.  Set the following parameters:
ExportAttributes: Specify export attributes in case of IPEK export. This parameter is
optional for KEK export.    ExportKeyIdentifier: The KeyARN of the KEK or BDK (in case of
IPEK) under export.    KeyMaterial: Use Tr34KeyBlock parameters.
CertificateAuthorityPublicKeyIdentifier: The KeyARN of the certificate chain that signed
the KRD wrapping key certificate.    ExportToken: Obtained from KDH by calling
GetParametersForImport.    WrappingKeyCertificate: The public key certificate in PEM format
(base64 encoded) of the KRD wrapping key Amazon Web Services Payment Cryptography uses for
encryption of the TR-34 export payload. This certificate must be signed by the root
certificate (CertificateAuthorityPublicKeyIdentifier) imported into Amazon Web Services
Payment Cryptography.   When this operation is successful, Amazon Web Services Payment
Cryptography returns the KEK or IPEK as a TR-34 WrappedKeyBlock.   To export initial keys
(KEK) or IPEK using RSA Wrap and Unwrap  Using this operation, you can export initial key
using asymmetric RSA wrap and unwrap key exchange method. To initiate export, generate an
asymmetric key pair on the receiving HSM and obtain the public key certificate in PEM
format (base64 encoded) for the purpose of wrapping and the root certifiate chain. Import
the root certificate into Amazon Web Services Payment Cryptography by calling ImportKey for
RootCertificatePublicKey. Next call ExportKey and set the following parameters:
CertificateAuthorityPublicKeyIdentifier: The KeyARN of the certificate chain that signed
wrapping key certificate.    KeyMaterial: Set to KeyCryptogram.    WrappingKeyCertificate:
The public key certificate in PEM format (base64 encoded) obtained by the receiving HSM and
signed by the root certificate (CertificateAuthorityPublicKeyIdentifier) imported into
Amazon Web Services Payment Cryptography. The receiving HSM uses its private key component
to unwrap the WrappedKeyCryptogram.   When this operation is successful, Amazon Web
Services Payment Cryptography returns the WrappedKeyCryptogram.   To export working keys or
IPEK using TR-31  Using this operation, you can export working keys or IPEK using TR-31
symmetric key exchange. In TR-31, you must use an initial key such as KEK to encrypt or
wrap the key under export. To establish a KEK, you can use CreateKey or ImportKey.  Set the
following parameters:    ExportAttributes: Specify export attributes in case of IPEK
export. This parameter is optional for KEK export.    ExportKeyIdentifier: The KeyARN of
the KEK or BDK (in case of IPEK) under export.    KeyMaterial: Use Tr31KeyBlock parameters.
  When this operation is successful, Amazon Web Services Payment Cryptography returns the
working key or IPEK as a TR-31 WrappedKeyBlock.  Cross-account use: This operation can't be
used across different Amazon Web Services accounts.  Related operations:
GetParametersForExport     ImportKey

# Arguments
- `export_key_identifier`: The KeyARN of the key under export from Amazon Web Services
  Payment Cryptography.
- `key_material`: The key block format type, for example, TR-34 or TR-31, to use during key
  material export.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ExportAttributes"`: The attributes for IPEK generation during export.
"""
function export_key(
    ExportKeyIdentifier, KeyMaterial; aws_config::AbstractAWSConfig=current_aws_config()
)
    return payment_cryptography(
        "ExportKey",
        Dict{String,Any}(
            "ExportKeyIdentifier" => ExportKeyIdentifier, "KeyMaterial" => KeyMaterial
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function export_key(
    ExportKeyIdentifier,
    KeyMaterial,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return payment_cryptography(
        "ExportKey",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ExportKeyIdentifier" => ExportKeyIdentifier,
                    "KeyMaterial" => KeyMaterial,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_alias(alias_name)
    get_alias(alias_name, params::Dict{String,<:Any})

Gets the Amazon Web Services Payment Cryptography key associated with the alias.
Cross-account use: This operation can't be used across different Amazon Web Services
accounts.  Related operations:     CreateAlias     DeleteAlias     ListAliases
UpdateAlias

# Arguments
- `alias_name`: The alias of the Amazon Web Services Payment Cryptography key.

"""
function get_alias(AliasName; aws_config::AbstractAWSConfig=current_aws_config())
    return payment_cryptography(
        "GetAlias",
        Dict{String,Any}("AliasName" => AliasName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_alias(
    AliasName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return payment_cryptography(
        "GetAlias",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AliasName" => AliasName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_key(key_identifier)
    get_key(key_identifier, params::Dict{String,<:Any})

Gets the key material for an Amazon Web Services Payment Cryptography key, including the
immutable and mutable data specified when the key was created.  Cross-account use: This
operation can't be used across different Amazon Web Services accounts.  Related operations:
    CreateKey     DeleteKey     ListKeys

# Arguments
- `key_identifier`: The KeyARN of the Amazon Web Services Payment Cryptography key.

"""
function get_key(KeyIdentifier; aws_config::AbstractAWSConfig=current_aws_config())
    return payment_cryptography(
        "GetKey",
        Dict{String,Any}("KeyIdentifier" => KeyIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_key(
    KeyIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return payment_cryptography(
        "GetKey",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("KeyIdentifier" => KeyIdentifier), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_parameters_for_export(key_material_type, signing_key_algorithm)
    get_parameters_for_export(key_material_type, signing_key_algorithm, params::Dict{String,<:Any})

Gets the export token and the signing key certificate to initiate a TR-34 key export from
Amazon Web Services Payment Cryptography. The signing key certificate signs the wrapped key
under export within the TR-34 key payload. The export token and signing key certificate
must be in place and operational before calling ExportKey. The export token expires in 7
days. You can use the same export token to export multiple keys from your service account.
Cross-account use: This operation can't be used across different Amazon Web Services
accounts.  Related operations:     ExportKey     GetParametersForImport

# Arguments
- `key_material_type`: The key block format type (for example, TR-34 or TR-31) to use
  during key material export. Export token is only required for a TR-34 key export,
  TR34_KEY_BLOCK. Export token is not required for TR-31 key export.
- `signing_key_algorithm`: The signing key algorithm to generate a signing key certificate.
  This certificate signs the wrapped key under export within the TR-34 key block. RSA_2048 is
  the only signing key algorithm allowed.

"""
function get_parameters_for_export(
    KeyMaterialType, SigningKeyAlgorithm; aws_config::AbstractAWSConfig=current_aws_config()
)
    return payment_cryptography(
        "GetParametersForExport",
        Dict{String,Any}(
            "KeyMaterialType" => KeyMaterialType,
            "SigningKeyAlgorithm" => SigningKeyAlgorithm,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_parameters_for_export(
    KeyMaterialType,
    SigningKeyAlgorithm,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return payment_cryptography(
        "GetParametersForExport",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "KeyMaterialType" => KeyMaterialType,
                    "SigningKeyAlgorithm" => SigningKeyAlgorithm,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_parameters_for_import(key_material_type, wrapping_key_algorithm)
    get_parameters_for_import(key_material_type, wrapping_key_algorithm, params::Dict{String,<:Any})

Gets the import token and the wrapping key certificate in PEM format (base64 encoded) to
initiate a TR-34 WrappedKeyBlock or a RSA WrappedKeyCryptogram import into Amazon Web
Services Payment Cryptography. The wrapping key certificate wraps the key under import. The
import token and wrapping key certificate must be in place and operational before calling
ImportKey. The import token expires in 7 days. You can use the same import token to import
multiple keys into your service account.  Cross-account use: This operation can't be used
across different Amazon Web Services accounts.  Related operations:
GetParametersForExport     ImportKey

# Arguments
- `key_material_type`: The method to use for key material import. Import token is only
  required for TR-34 WrappedKeyBlock (TR34_KEY_BLOCK) and RSA WrappedKeyCryptogram
  (KEY_CRYPTOGRAM). Import token is not required for TR-31, root public key cerificate or
  trusted public key certificate.
- `wrapping_key_algorithm`: The wrapping key algorithm to generate a wrapping key
  certificate. This certificate wraps the key under import. At this time, RSA_2048 is the
  allowed algorithm for TR-34 WrappedKeyBlock import. Additionally, RSA_2048, RSA_3072,
  RSA_4096 are the allowed algorithms for RSA WrappedKeyCryptogram import.

"""
function get_parameters_for_import(
    KeyMaterialType,
    WrappingKeyAlgorithm;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return payment_cryptography(
        "GetParametersForImport",
        Dict{String,Any}(
            "KeyMaterialType" => KeyMaterialType,
            "WrappingKeyAlgorithm" => WrappingKeyAlgorithm,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_parameters_for_import(
    KeyMaterialType,
    WrappingKeyAlgorithm,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return payment_cryptography(
        "GetParametersForImport",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "KeyMaterialType" => KeyMaterialType,
                    "WrappingKeyAlgorithm" => WrappingKeyAlgorithm,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_public_key_certificate(key_identifier)
    get_public_key_certificate(key_identifier, params::Dict{String,<:Any})

Gets the public key certificate of the asymmetric key pair that exists within Amazon Web
Services Payment Cryptography. Unlike the private key of an asymmetric key, which never
leaves Amazon Web Services Payment Cryptography unencrypted, callers with
GetPublicKeyCertificate permission can download the public key certificate of the
asymmetric key. You can share the public key certificate to allow others to encrypt
messages and verify signatures outside of Amazon Web Services Payment Cryptography
Cross-account use: This operation can't be used across different Amazon Web Services
accounts.

# Arguments
- `key_identifier`: The KeyARN of the asymmetric key pair.

"""
function get_public_key_certificate(
    KeyIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return payment_cryptography(
        "GetPublicKeyCertificate",
        Dict{String,Any}("KeyIdentifier" => KeyIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_public_key_certificate(
    KeyIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return payment_cryptography(
        "GetPublicKeyCertificate",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("KeyIdentifier" => KeyIdentifier), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    import_key(key_material)
    import_key(key_material, params::Dict{String,<:Any})

Imports symmetric keys and public key certificates in PEM format (base64 encoded) into
Amazon Web Services Payment Cryptography. Amazon Web Services Payment Cryptography
simplifies key exchange by replacing the existing paper-based approach with a modern
electronic approach. With ImportKey you can import symmetric keys using either symmetric
and asymmetric key exchange mechanisms. For symmetric key exchange, Amazon Web Services
Payment Cryptography uses the ANSI X9 TR-31 norm in accordance with PCI PIN guidelines. And
for asymmetric key exchange, Amazon Web Services Payment Cryptography supports ANSI X9
TR-34 norm and RSA wrap and unwrap key exchange mechanisms. Asymmetric key exchange methods
are typically used to establish bi-directional trust between the two parties exhanging keys
and are used for initial key exchange such as Key Encryption Key (KEK) or Zone Master Key
(ZMK). After which you can import working keys using symmetric method to perform various
cryptographic operations within Amazon Web Services Payment Cryptography. The TR-34 norm is
intended for exchanging 3DES keys only and keys are imported in a WrappedKeyBlock format.
Key attributes (such as KeyUsage, KeyAlgorithm, KeyModesOfUse, Exportability) are contained
within the key block. With RSA wrap and unwrap, you can exchange both 3DES and AES-128
keys. The keys are imported in a WrappedKeyCryptogram format and you will need to specify
the key attributes during import.  You can also import a root public key certificate, used
to sign other public key certificates, or a trusted public key certificate under an already
established root public key certificate.  To import a public root key certificate  You can
also import a root public key certificate, used to sign other public key certificates, or a
trusted public key certificate under an already established root public key certificate.
To import a public root key certificate  Using this operation, you can import the public
component (in PEM cerificate format) of your private root key. You can use the imported
public root key certificate for digital signatures, for example signing wrapping key or
signing key in TR-34, within your Amazon Web Services Payment Cryptography account. Set the
following parameters:    KeyMaterial: RootCertificatePublicKey     KeyClass: PUBLIC_KEY
KeyModesOfUse: Verify     KeyUsage: TR31_S0_ASYMMETRIC_KEY_FOR_DIGITAL_SIGNATURE
PublicKeyCertificate: The public key certificate in PEM format (base64 encoded) of the
private root key under import.    To import a trusted public key certificate  The root
public key certificate must be in place and operational before you import a trusted public
key certificate. Set the following parameters:    KeyMaterial: TrustedCertificatePublicKey
   CertificateAuthorityPublicKeyIdentifier: KeyArn of the RootCertificatePublicKey.
KeyModesOfUse and KeyUsage: Corresponding to the cryptographic operations such as wrap,
sign, or encrypt that you will allow the trusted public key certificate to perform.
PublicKeyCertificate: The trusted public key certificate in PEM format (base64 encoded)
under import.    To import initial keys (KEK or ZMK or similar) using TR-34  Using this
operation, you can import initial key using TR-34 asymmetric key exchange. In TR-34
terminology, the sending party of the key is called Key Distribution Host (KDH) and the
receiving party of the key is called Key Receiving Device (KRD). During the key import
process, KDH is the user who initiates the key import and KRD is Amazon Web Services
Payment Cryptography who receives the key. To initiate TR-34 key import, the KDH must
obtain an import token by calling GetParametersForImport. This operation generates an
encryption keypair for the purpose of key import, signs the key and returns back the
wrapping key certificate (also known as KRD wrapping certificate) and the root certificate
chain. The KDH must trust and install the KRD wrapping certificate on its HSM and use it to
encrypt (wrap) the KDH key during TR-34 WrappedKeyBlock generation. The import token and
associated KRD wrapping certificate expires after 7 days. Next the KDH generates a key pair
for the purpose of signing the encrypted KDH key and provides the public certificate of the
signing key to Amazon Web Services Payment Cryptography. The KDH will also need to import
the root certificate chain of the KDH signing certificate by calling ImportKey for
RootCertificatePublicKey. For more information on TR-34 key import, see section Importing
symmetric keys in the Amazon Web Services Payment Cryptography User Guide. Set the
following parameters:    KeyMaterial: Use Tr34KeyBlock parameters.
CertificateAuthorityPublicKeyIdentifier: The KeyARN of the certificate chain that signed
the KDH signing key certificate.    ImportToken: Obtained from KRD by calling
GetParametersForImport.    WrappedKeyBlock: The TR-34 wrapped key material from KDH. It
contains the KDH key under import, wrapped with KRD wrapping certificate and signed by KDH
signing private key. This TR-34 key block is typically generated by the KDH Hardware
Security Module (HSM) outside of Amazon Web Services Payment Cryptography.
SigningKeyCertificate: The public key certificate in PEM format (base64 encoded) of the KDH
signing key generated under the root certificate (CertificateAuthorityPublicKeyIdentifier)
imported in Amazon Web Services Payment Cryptography.    To import initial keys (KEK or ZMK
or similar) using RSA Wrap and Unwrap  Using this operation, you can import initial key
using asymmetric RSA wrap and unwrap key exchange method. To initiate import, call
GetParametersForImport with KeyMaterial set to KEY_CRYPTOGRAM to generate an import token.
This operation also generates an encryption keypair for the purpose of key import, signs
the key and returns back the wrapping key certificate in PEM format (base64 encoded) and
its root certificate chain. The import token and associated KRD wrapping certificate
expires after 7 days.  You must trust and install the wrapping certificate and its
certificate chain on the sending HSM and use it to wrap the key under export for
WrappedKeyCryptogram generation. Next call ImportKey with KeyMaterial set to KEY_CRYPTOGRAM
and provide the ImportToken and KeyAttributes for the key under import.  To import working
keys using TR-31  Amazon Web Services Payment Cryptography uses TR-31 symmetric key
exchange norm to import working keys. A KEK must be established within Amazon Web Services
Payment Cryptography by using TR-34 key import or by using CreateKey. To initiate a TR-31
key import, set the following parameters:    KeyMaterial: Use Tr31KeyBlock parameters.
WrappedKeyBlock: The TR-31 wrapped key material. It contains the key under import,
encrypted using KEK. The TR-31 key block is typically generated by a HSM outside of Amazon
Web Services Payment Cryptography.     WrappingKeyIdentifier: The KeyArn of the KEK that
Amazon Web Services Payment Cryptography uses to decrypt or unwrap the key under import.
Cross-account use: This operation can't be used across different Amazon Web Services
accounts.  Related operations:     ExportKey     GetParametersForImport

# Arguments
- `key_material`: The key or public key certificate type to use during key material import,
  for example TR-34 or RootCertificatePublicKey.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Enabled"`: Specifies whether import key is enabled.
- `"KeyCheckValueAlgorithm"`: The algorithm that Amazon Web Services Payment Cryptography
  uses to calculate the key check value (KCV). It is used to validate the key integrity. For
  TDES keys, the KCV is computed by encrypting 8 bytes, each with value of zero, with the key
  to be checked and retaining the 3 highest order bytes of the encrypted result. For AES
  keys, the KCV is computed using a CMAC algorithm where the input data is 16 bytes of zero
  and retaining the 3 highest order bytes of the encrypted result.
- `"Tags"`: Assigns one or more tags to the Amazon Web Services Payment Cryptography key.
  Use this parameter to tag a key when it is imported. To tag an existing Amazon Web Services
  Payment Cryptography key, use the TagResource operation. Each tag consists of a tag key and
  a tag value. Both the tag key and the tag value are required, but the tag value can be an
  empty (null) string. You can't have more than one tag on an Amazon Web Services Payment
  Cryptography key with the same tag key. If you specify an existing tag key with a different
  tag value, Amazon Web Services Payment Cryptography replaces the current tag value with the
  specified one.  Don't include personal, confidential or sensitive information in this
  field. This field may be displayed in plaintext in CloudTrail logs and other output.
  Tagging or untagging an Amazon Web Services Payment Cryptography key can allow or deny
  permission to the key.
"""
function import_key(KeyMaterial; aws_config::AbstractAWSConfig=current_aws_config())
    return payment_cryptography(
        "ImportKey",
        Dict{String,Any}("KeyMaterial" => KeyMaterial);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function import_key(
    KeyMaterial,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return payment_cryptography(
        "ImportKey",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("KeyMaterial" => KeyMaterial), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_aliases()
    list_aliases(params::Dict{String,<:Any})

Lists the aliases for all keys in the caller's Amazon Web Services account and Amazon Web
Services Region. You can filter the list of aliases. For more information, see Using
aliases in the Amazon Web Services Payment Cryptography User Guide. This is a paginated
operation, which means that each response might contain only a subset of all the aliases.
When the response contains only a subset of aliases, it includes a NextToken value. Use
this value in a subsequent ListAliases request to get more aliases. When you receive a
response with no NextToken (or an empty or null value), that means there are no more
aliases to get.  Cross-account use: This operation can't be used across different Amazon
Web Services accounts.  Related operations:     CreateAlias     DeleteAlias     GetAlias
 UpdateAlias

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Use this parameter to specify the maximum number of items to return. When
  this value is present, Amazon Web Services Payment Cryptography does not return more than
  the specified number of items, but it might return fewer. This value is optional. If you
  include a value, it must be between 1 and 100, inclusive. If you do not include a value, it
  defaults to 50.
- `"NextToken"`: Use this parameter in a subsequent request after you receive a response
  with truncated results. Set it to the value of NextToken from the truncated response you
  just received.
"""
function list_aliases(; aws_config::AbstractAWSConfig=current_aws_config())
    return payment_cryptography(
        "ListAliases"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_aliases(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return payment_cryptography(
        "ListAliases", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_keys()
    list_keys(params::Dict{String,<:Any})

Lists the keys in the caller's Amazon Web Services account and Amazon Web Services Region.
You can filter the list of keys. This is a paginated operation, which means that each
response might contain only a subset of all the keys. When the response contains only a
subset of keys, it includes a NextToken value. Use this value in a subsequent ListKeys
request to get more keys. When you receive a response with no NextToken (or an empty or
null value), that means there are no more keys to get.  Cross-account use: This operation
can't be used across different Amazon Web Services accounts.  Related operations:
CreateKey     DeleteKey     GetKey

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"KeyState"`: The key state of the keys you want to list.
- `"MaxResults"`: Use this parameter to specify the maximum number of items to return. When
  this value is present, Amazon Web Services Payment Cryptography does not return more than
  the specified number of items, but it might return fewer. This value is optional. If you
  include a value, it must be between 1 and 100, inclusive. If you do not include a value, it
  defaults to 50.
- `"NextToken"`: Use this parameter in a subsequent request after you receive a response
  with truncated results. Set it to the value of NextToken from the truncated response you
  just received.
"""
function list_keys(; aws_config::AbstractAWSConfig=current_aws_config())
    return payment_cryptography(
        "ListKeys"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_keys(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return payment_cryptography(
        "ListKeys", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists the tags for an Amazon Web Services resource. This is a paginated operation, which
means that each response might contain only a subset of all the tags. When the response
contains only a subset of tags, it includes a NextToken value. Use this value in a
subsequent ListTagsForResource request to get more tags. When you receive a response with
no NextToken (or an empty or null value), that means there are no more tags to get.
Cross-account use: This operation can't be used across different Amazon Web Services
accounts.  Related operations:     TagResource     UntagResource

# Arguments
- `resource_arn`: The KeyARN of the key whose tags you are getting.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Use this parameter to specify the maximum number of items to return. When
  this value is present, Amazon Web Services Payment Cryptography does not return more than
  the specified number of items, but it might return fewer. This value is optional. If you
  include a value, it must be between 1 and 100, inclusive. If you do not include a value, it
  defaults to 50.
- `"NextToken"`: Use this parameter in a subsequent request after you receive a response
  with truncated results. Set it to the value of NextToken from the truncated response you
  just received.
"""
function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return payment_cryptography(
        "ListTagsForResource",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return payment_cryptography(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    restore_key(key_identifier)
    restore_key(key_identifier, params::Dict{String,<:Any})

Cancels a scheduled key deletion during the waiting period. Use this operation to restore a
Key that is scheduled for deletion. During the waiting period, the KeyState is
DELETE_PENDING and deletePendingTimestamp contains the date and time after which the Key
will be deleted. After Key is restored, the KeyState is CREATE_COMPLETE, and the value for
deletePendingTimestamp is removed.  Cross-account use: This operation can't be used across
different Amazon Web Services accounts.  Related operations:     DeleteKey
StartKeyUsage     StopKeyUsage

# Arguments
- `key_identifier`: The KeyARN of the key to be restored within Amazon Web Services Payment
  Cryptography.

"""
function restore_key(KeyIdentifier; aws_config::AbstractAWSConfig=current_aws_config())
    return payment_cryptography(
        "RestoreKey",
        Dict{String,Any}("KeyIdentifier" => KeyIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function restore_key(
    KeyIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return payment_cryptography(
        "RestoreKey",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("KeyIdentifier" => KeyIdentifier), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_key_usage(key_identifier)
    start_key_usage(key_identifier, params::Dict{String,<:Any})

Enables an Amazon Web Services Payment Cryptography key, which makes it active for
cryptographic operations within Amazon Web Services Payment Cryptography  Cross-account
use: This operation can't be used across different Amazon Web Services accounts.  Related
operations:     StopKeyUsage

# Arguments
- `key_identifier`: The KeyArn of the key.

"""
function start_key_usage(KeyIdentifier; aws_config::AbstractAWSConfig=current_aws_config())
    return payment_cryptography(
        "StartKeyUsage",
        Dict{String,Any}("KeyIdentifier" => KeyIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_key_usage(
    KeyIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return payment_cryptography(
        "StartKeyUsage",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("KeyIdentifier" => KeyIdentifier), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_key_usage(key_identifier)
    stop_key_usage(key_identifier, params::Dict{String,<:Any})

Disables an Amazon Web Services Payment Cryptography key, which makes it inactive within
Amazon Web Services Payment Cryptography. You can use this operation instead of DeleteKey
to deactivate a key. You can enable the key in the future by calling StartKeyUsage.
Cross-account use: This operation can't be used across different Amazon Web Services
accounts.  Related operations:     DeleteKey     StartKeyUsage

# Arguments
- `key_identifier`: The KeyArn of the key.

"""
function stop_key_usage(KeyIdentifier; aws_config::AbstractAWSConfig=current_aws_config())
    return payment_cryptography(
        "StopKeyUsage",
        Dict{String,Any}("KeyIdentifier" => KeyIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_key_usage(
    KeyIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return payment_cryptography(
        "StopKeyUsage",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("KeyIdentifier" => KeyIdentifier), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds or edits tags on an Amazon Web Services Payment Cryptography key.  Tagging or
untagging an Amazon Web Services Payment Cryptography key can allow or deny permission to
the key.  Each tag consists of a tag key and a tag value, both of which are case-sensitive
strings. The tag value can be an empty (null) string. To add a tag, specify a new tag key
and a tag value. To edit a tag, specify an existing tag key and a new tag value. You can
also add tags to an Amazon Web Services Payment Cryptography key when you create it with
CreateKey.  Cross-account use: This operation can't be used across different Amazon Web
Services accounts.  Related operations:     ListTagsForResource     UntagResource

# Arguments
- `resource_arn`: The KeyARN of the key whose tags are being updated.
- `tags`: One or more tags. Each tag consists of a tag key and a tag value. The tag value
  can be an empty (null) string. You can't have more than one tag on an Amazon Web Services
  Payment Cryptography key with the same tag key. If you specify an existing tag key with a
  different tag value, Amazon Web Services Payment Cryptography replaces the current tag
  value with the new one.  Don't include personal, confidential or sensitive information in
  this field. This field may be displayed in plaintext in CloudTrail logs and other output.
  To use this parameter, you must have TagResource permission in an IAM policy.  Don't
  include personal, confidential or sensitive information in this field. This field may be
  displayed in plaintext in CloudTrail logs and other output.

"""
function tag_resource(ResourceArn, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return payment_cryptography(
        "TagResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceArn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return payment_cryptography(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Deletes a tag from an Amazon Web Services Payment Cryptography key.  Tagging or untagging
an Amazon Web Services Payment Cryptography key can allow or deny permission to the key.
Cross-account use: This operation can't be used across different Amazon Web Services
accounts.  Related operations:     ListTagsForResource     TagResource

# Arguments
- `resource_arn`: The KeyARN of the key whose tags are being removed.
- `tag_keys`: One or more tag keys. Don't include the tag values. If the Amazon Web
  Services Payment Cryptography key doesn't have the specified tag key, Amazon Web Services
  Payment Cryptography doesn't throw an exception or return a response. To confirm that the
  operation succeeded, use the ListTagsForResource operation.

"""
function untag_resource(
    ResourceArn, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return payment_cryptography(
        "UntagResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceArn,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return payment_cryptography(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_alias(alias_name)
    update_alias(alias_name, params::Dict{String,<:Any})

Associates an existing Amazon Web Services Payment Cryptography alias with a different key.
Each alias is associated with only one Amazon Web Services Payment Cryptography key at a
time, although a key can have multiple aliases. The alias and the Amazon Web Services
Payment Cryptography key must be in the same Amazon Web Services account and Amazon Web
Services Region  Cross-account use: This operation can't be used across different Amazon
Web Services accounts.  Related operations:     CreateAlias     DeleteAlias     GetAlias
 ListAliases

# Arguments
- `alias_name`: The alias whose associated key is changing.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"KeyArn"`: The KeyARN for the key that you are updating or removing from the alias.
"""
function update_alias(AliasName; aws_config::AbstractAWSConfig=current_aws_config())
    return payment_cryptography(
        "UpdateAlias",
        Dict{String,Any}("AliasName" => AliasName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_alias(
    AliasName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return payment_cryptography(
        "UpdateAlias",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AliasName" => AliasName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: fsx
using AWS.Compat
using AWS.UUIDs

"""
    associate_file_system_aliases(aliases, file_system_id)
    associate_file_system_aliases(aliases, file_system_id, params::Dict{String,<:Any})

Use this action to associate one or more Domain Name Server (DNS) aliases with an existing
Amazon FSx for Windows File Server file system. A file system can have a maximum of 50 DNS
aliases associated with it at any one time. If you try to associate a DNS alias that is
already associated with the file system, FSx takes no action on that alias in the request.
For more information, see Working with DNS Aliases and Walkthrough 5: Using DNS aliases to
access your file system, including additional steps you must take to be able to access your
file system using a DNS alias. The system response shows the DNS aliases that Amazon FSx is
attempting to associate with the file system. Use the API operation to monitor the status
of the aliases Amazon FSx is associating with the file system.

# Arguments
- `aliases`: An array of one or more DNS alias names to associate with the file system. The
  alias name has to comply with the following formatting requirements:   Formatted as a
  fully-qualified domain name (FQDN),  hostname.domain , for example,
  accounting.corp.example.com.   Can contain alphanumeric characters and the hyphen (-).
  Cannot start or end with a hyphen.   Can start with a numeric.   For DNS alias names,
  Amazon FSx stores alphabetic characters as lowercase letters (a-z), regardless of how you
  specify them: as uppercase letters, lowercase letters, or the corresponding letters in
  escape codes.
- `file_system_id`: Specifies the file system with which you want to associate one or more
  DNS aliases.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`:
"""
function associate_file_system_aliases(
    Aliases, FileSystemId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fsx(
        "AssociateFileSystemAliases",
        Dict{String,Any}(
            "Aliases" => Aliases,
            "FileSystemId" => FileSystemId,
            "ClientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_file_system_aliases(
    Aliases,
    FileSystemId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fsx(
        "AssociateFileSystemAliases",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Aliases" => Aliases,
                    "FileSystemId" => FileSystemId,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_data_repository_task(task_id)
    cancel_data_repository_task(task_id, params::Dict{String,<:Any})

Cancels an existing Amazon FSx for Lustre data repository task if that task is in either
the PENDING or EXECUTING state. When you cancel am export task, Amazon FSx does the
following.   Any files that FSx has already exported are not reverted.   FSx continues to
export any files that are in-flight when the cancel operation is received.   FSx does not
export any files that have not yet been exported.   For a release task, Amazon FSx will
stop releasing files upon cancellation. Any files that have already been released will
remain in the released state.

# Arguments
- `task_id`: Specifies the data repository task to cancel.

"""
function cancel_data_repository_task(
    TaskId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fsx(
        "CancelDataRepositoryTask",
        Dict{String,Any}("TaskId" => TaskId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_data_repository_task(
    TaskId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fsx(
        "CancelDataRepositoryTask",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("TaskId" => TaskId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    copy_backup(source_backup_id)
    copy_backup(source_backup_id, params::Dict{String,<:Any})

Copies an existing backup within the same Amazon Web Services account to another Amazon Web
Services Region (cross-Region copy) or within the same Amazon Web Services Region
(in-Region copy). You can have up to five backup copy requests in progress to a single
destination Region per account. You can use cross-Region backup copies for cross-Region
disaster recovery. You can periodically take backups and copy them to another Region so
that in the event of a disaster in the primary Region, you can restore from backup and
recover availability quickly in the other Region. You can make cross-Region copies only
within your Amazon Web Services partition. A partition is a grouping of Regions. Amazon Web
Services currently has three partitions: aws (Standard Regions), aws-cn (China Regions),
and aws-us-gov (Amazon Web Services GovCloud [US] Regions). You can also use backup copies
to clone your file dataset to another Region or within the same Region. You can use the
SourceRegion parameter to specify the Amazon Web Services Region from which the backup will
be copied. For example, if you make the call from the us-west-1 Region and want to copy a
backup from the us-east-2 Region, you specify us-east-2 in the SourceRegion parameter to
make a cross-Region copy. If you don't specify a Region, the backup copy is created in the
same Region where the request is sent from (in-Region copy). For more information about
creating backup copies, see  Copying backups in the Amazon FSx for Windows User Guide,
Copying backups in the Amazon FSx for Lustre User Guide, and Copying backups in the Amazon
FSx for OpenZFS User Guide.

# Arguments
- `source_backup_id`: The ID of the source backup. Specifies the ID of the backup that's
  being copied.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`:
- `"CopyTags"`: A Boolean flag indicating whether tags from the source backup should be
  copied to the backup copy. This value defaults to false. If you set CopyTags to true and
  the source backup has existing tags, you can use the Tags parameter to create new tags,
  provided that the sum of the source backup tags and the new tags doesn't exceed 50. Both
  sets of tags are merged. If there are tag conflicts (for example, two tags with the same
  key but different values), the tags created with the Tags parameter take precedence.
- `"KmsKeyId"`:
- `"SourceRegion"`: The source Amazon Web Services Region of the backup. Specifies the
  Amazon Web Services Region from which the backup is being copied. The source and
  destination Regions must be in the same Amazon Web Services partition. If you don't specify
  a Region, SourceRegion defaults to the Region where the request is sent from (in-Region
  copy).
- `"Tags"`:
"""
function copy_backup(SourceBackupId; aws_config::AbstractAWSConfig=current_aws_config())
    return fsx(
        "CopyBackup",
        Dict{String,Any}(
            "SourceBackupId" => SourceBackupId, "ClientRequestToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function copy_backup(
    SourceBackupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fsx(
        "CopyBackup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "SourceBackupId" => SourceBackupId,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    copy_snapshot_and_update_volume(source_snapshot_arn, volume_id)
    copy_snapshot_and_update_volume(source_snapshot_arn, volume_id, params::Dict{String,<:Any})

Updates an existing volume by using a snapshot from another Amazon FSx for OpenZFS file
system. For more information, see on-demand data replication in the Amazon FSx for OpenZFS
User Guide.

# Arguments
- `source_snapshot_arn`:
- `volume_id`: Specifies the ID of the volume that you are copying the snapshot to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`:
- `"CopyStrategy"`: Specifies the strategy to use when copying data from a snapshot to the
  volume.     FULL_COPY - Copies all data from the snapshot to the volume.
  INCREMENTAL_COPY - Copies only the snapshot data that's changed since the previous
  replication.     CLONE isn't a valid copy strategy option for the
  CopySnapshotAndUpdateVolume operation.
- `"Options"`: Confirms that you want to delete data on the destination volume that
  wasn’t there during the previous snapshot replication. Your replication will fail if you
  don’t include an option for a specific type of data and that data is on your destination.
  For example, if you don’t include DELETE_INTERMEDIATE_SNAPSHOTS and there are
  intermediate snapshots on the destination, you can’t copy the snapshot.
  DELETE_INTERMEDIATE_SNAPSHOTS - Deletes snapshots on the destination volume that aren’t
  on the source volume.    DELETE_CLONED_VOLUMES - Deletes snapshot clones on the destination
  volume that aren't on the source volume.    DELETE_INTERMEDIATE_DATA - Overwrites snapshots
  on the destination volume that don’t match the source snapshot that you’re copying.
"""
function copy_snapshot_and_update_volume(
    SourceSnapshotARN, VolumeId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fsx(
        "CopySnapshotAndUpdateVolume",
        Dict{String,Any}(
            "SourceSnapshotARN" => SourceSnapshotARN,
            "VolumeId" => VolumeId,
            "ClientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function copy_snapshot_and_update_volume(
    SourceSnapshotARN,
    VolumeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fsx(
        "CopySnapshotAndUpdateVolume",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "SourceSnapshotARN" => SourceSnapshotARN,
                    "VolumeId" => VolumeId,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_backup()
    create_backup(params::Dict{String,<:Any})

Creates a backup of an existing Amazon FSx for Windows File Server file system, Amazon FSx
for Lustre file system, Amazon FSx for NetApp ONTAP volume, or Amazon FSx for OpenZFS file
system. We recommend creating regular backups so that you can restore a file system or
volume from a backup if an issue arises with the original file system or volume. For Amazon
FSx for Lustre file systems, you can create a backup only for file systems that have the
following configuration:   A Persistent deployment type   Are not linked to a data
repository   For more information about backups, see the following:   For Amazon FSx for
Lustre, see Working with FSx for Lustre backups.   For Amazon FSx for Windows, see Working
with FSx for Windows backups.   For Amazon FSx for NetApp ONTAP, see Working with FSx for
NetApp ONTAP backups.   For Amazon FSx for OpenZFS, see Working with FSx for OpenZFS
backups.   If a backup with the specified client request token exists and the parameters
match, this operation returns the description of the existing backup. If a backup with the
specified client request token exists and the parameters don't match, this operation
returns IncompatibleParameterError. If a backup with the specified client request token
doesn't exist, CreateBackup does the following:    Creates a new Amazon FSx backup with an
assigned ID, and an initial lifecycle state of CREATING.   Returns the description of the
backup.   By using the idempotent operation, you can retry a CreateBackup operation without
the risk of creating an extra backup. This approach can be useful when an initial call
fails in a way that makes it unclear whether a backup was created. If you use the same
client request token and the initial call created a backup, the operation returns a
successful result because all the parameters are the same. The CreateBackup operation
returns while the backup's lifecycle state is still CREATING. You can check the backup
creation status by calling the DescribeBackups operation, which returns the backup state
along with other information.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: (Optional) A string of up to 63 ASCII characters that Amazon FSx
  uses to ensure idempotent creation. This string is automatically filled on your behalf when
  you use the Command Line Interface (CLI) or an Amazon Web Services SDK.
- `"FileSystemId"`: The ID of the file system to back up.
- `"Tags"`: (Optional) The tags to apply to the backup at backup creation. The key value of
  the Name tag appears in the console as the backup name. If you have set CopyTagsToBackups
  to true, and you specify one or more tags using the CreateBackup operation, no existing
  file system tags are copied from the file system to the backup.
- `"VolumeId"`: (Optional) The ID of the FSx for ONTAP volume to back up.
"""
function create_backup(; aws_config::AbstractAWSConfig=current_aws_config())
    return fsx(
        "CreateBackup",
        Dict{String,Any}("ClientRequestToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_backup(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fsx(
        "CreateBackup",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ClientRequestToken" => string(uuid4())), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_data_repository_association(data_repository_path, file_system_id)
    create_data_repository_association(data_repository_path, file_system_id, params::Dict{String,<:Any})

Creates an Amazon FSx for Lustre data repository association (DRA). A data repository
association is a link between a directory on the file system and an Amazon S3 bucket or
prefix. You can have a maximum of 8 data repository associations on a file system. Data
repository associations are supported on all FSx for Lustre 2.12 and 2.15 file systems,
excluding scratch_1 deployment type. Each data repository association must have a unique
Amazon FSx file system directory and a unique S3 bucket or prefix associated with it. You
can configure a data repository association for automatic import only, for automatic export
only, or for both. To learn more about linking a data repository to your file system, see
Linking your file system to an S3 bucket.   CreateDataRepositoryAssociation isn't supported
on Amazon File Cache resources. To create a DRA on Amazon File Cache, use the
CreateFileCache operation.

# Arguments
- `data_repository_path`: The path to the Amazon S3 data repository that will be linked to
  the file system. The path can be an S3 bucket or prefix in the format
  s3://myBucket/myPrefix/. This path specifies where in the S3 data repository files will be
  imported from or exported to.
- `file_system_id`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"BatchImportMetaDataOnCreate"`: Set to true to run an import data repository task to
  import metadata from the data repository to the file system after the data repository
  association is created. Default is false.
- `"ClientRequestToken"`:
- `"FileSystemPath"`: A path on the file system that points to a high-level directory (such
  as /ns1/) or subdirectory (such as /ns1/subdir/) that will be mapped 1-1 with
  DataRepositoryPath. The leading forward slash in the name is required. Two data repository
  associations cannot have overlapping file system paths. For example, if a data repository
  is associated with file system path /ns1/, then you cannot link another data repository
  with file system path /ns1/ns2. This path specifies where in your file system files will be
  exported from or imported to. This file system directory can be linked to only one Amazon
  S3 bucket, and no other S3 bucket can be linked to the directory.  If you specify only a
  forward slash (/) as the file system path, you can link only one data repository to the
  file system. You can only specify \"/\" as the file system path for the first data
  repository associated with a file system.
- `"ImportedFileChunkSize"`: For files imported from a data repository, this value
  determines the stripe count and maximum amount of data per file (in MiB) stored on a single
  physical disk. The maximum number of disks that a single file can be striped across is
  limited by the total number of disks that make up the file system. The default chunk size
  is 1,024 MiB (1 GiB) and can go as high as 512,000 MiB (500 GiB). Amazon S3 objects have a
  maximum size of 5 TB.
- `"S3"`: The configuration for an Amazon S3 data repository linked to an Amazon FSx Lustre
  file system with a data repository association. The configuration defines which file events
  (new, changed, or deleted files or directories) are automatically imported from the linked
  data repository to the file system or automatically exported from the file system to the
  data repository.
- `"Tags"`:
"""
function create_data_repository_association(
    DataRepositoryPath, FileSystemId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fsx(
        "CreateDataRepositoryAssociation",
        Dict{String,Any}(
            "DataRepositoryPath" => DataRepositoryPath,
            "FileSystemId" => FileSystemId,
            "ClientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_data_repository_association(
    DataRepositoryPath,
    FileSystemId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fsx(
        "CreateDataRepositoryAssociation",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DataRepositoryPath" => DataRepositoryPath,
                    "FileSystemId" => FileSystemId,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_data_repository_task(file_system_id, report, type)
    create_data_repository_task(file_system_id, report, type, params::Dict{String,<:Any})

Creates an Amazon FSx for Lustre data repository task. A CreateDataRepositoryTask operation
will fail if a data repository is not linked to the FSx file system. You use import and
export data repository tasks to perform bulk operations between your FSx for Lustre file
system and its linked data repositories. An example of a data repository task is exporting
any data and metadata changes, including POSIX metadata, to files, directories, and
symbolic links (symlinks) from your FSx file system to a linked data repository. You use
release data repository tasks to release data from your file system for files that are
exported to S3. The metadata of released files remains on the file system so users or
applications can still access released files by reading the files again, which will restore
data from Amazon S3 to the FSx for Lustre file system. To learn more about data repository
tasks, see Data Repository Tasks. To learn more about linking a data repository to your
file system, see Linking your file system to an S3 bucket.

# Arguments
- `file_system_id`:
- `report`: Defines whether or not Amazon FSx provides a CompletionReport once the task has
  completed. A CompletionReport provides a detailed report on the files that Amazon FSx
  processed that meet the criteria specified by the Scope parameter. For more information,
  see Working with Task Completion Reports.
- `type`: Specifies the type of data repository task to create.    EXPORT_TO_REPOSITORY
  tasks export from your Amazon FSx for Lustre file system to a linked data repository.
  IMPORT_METADATA_FROM_REPOSITORY tasks import metadata changes from a linked S3 bucket to
  your Amazon FSx for Lustre file system.    RELEASE_DATA_FROM_FILESYSTEM tasks release files
  in your Amazon FSx for Lustre file system that have been exported to a linked S3 bucket and
  that meet your specified release criteria.    AUTO_RELEASE_DATA tasks automatically release
  files from an Amazon File Cache resource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CapacityToRelease"`: Specifies the amount of data to release, in GiB, by an Amazon File
  Cache AUTO_RELEASE_DATA task that automatically releases files from the cache.
- `"ClientRequestToken"`:
- `"Paths"`: A list of paths for the data repository task to use when the task is
  processed. If a path that you provide isn't valid, the task fails. If you don't provide
  paths, the default behavior is to export all files to S3 (for export tasks), import all
  files from S3 (for import tasks), or release all exported files that meet the last accessed
  time criteria (for release tasks).   For export tasks, the list contains paths on the FSx
  for Lustre file system from which the files are exported to the Amazon S3 bucket. The
  default path is the file system root directory. The paths you provide need to be relative
  to the mount point of the file system. If the mount point is /mnt/fsx and /mnt/fsx/path1 is
  a directory or file on the file system you want to export, then the path to provide is
  path1.   For import tasks, the list contains paths in the Amazon S3 bucket from which POSIX
  metadata changes are imported to the FSx for Lustre file system. The path can be an S3
  bucket or prefix in the format s3://myBucket/myPrefix (where myPrefix is optional).    For
  release tasks, the list contains directory or file paths on the FSx for Lustre file system
  from which to release exported files. If a directory is specified, files within the
  directory are released. If a file path is specified, only that file is released. To release
  all exported files in the file system, specify a forward slash (/) as the path.  A file
  must also meet the last accessed time criteria specified in for the file to be released.
- `"ReleaseConfiguration"`: The configuration that specifies the last accessed time
  criteria for files that will be released from an Amazon FSx for Lustre file system.
- `"Tags"`:
"""
function create_data_repository_task(
    FileSystemId, Report, Type; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fsx(
        "CreateDataRepositoryTask",
        Dict{String,Any}(
            "FileSystemId" => FileSystemId,
            "Report" => Report,
            "Type" => Type,
            "ClientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_data_repository_task(
    FileSystemId,
    Report,
    Type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fsx(
        "CreateDataRepositoryTask",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "FileSystemId" => FileSystemId,
                    "Report" => Report,
                    "Type" => Type,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_file_cache(file_cache_type, file_cache_type_version, storage_capacity, subnet_ids)
    create_file_cache(file_cache_type, file_cache_type_version, storage_capacity, subnet_ids, params::Dict{String,<:Any})

Creates a new Amazon File Cache resource. You can use this operation with a client request
token in the request that Amazon File Cache uses to ensure idempotent creation. If a cache
with the specified client request token exists and the parameters match, CreateFileCache
returns the description of the existing cache. If a cache with the specified client request
token exists and the parameters don't match, this call returns IncompatibleParameterError.
If a file cache with the specified client request token doesn't exist, CreateFileCache does
the following:    Creates a new, empty Amazon File Cache resourcewith an assigned ID, and
an initial lifecycle state of CREATING.   Returns the description of the cache in JSON
format.    The CreateFileCache call returns while the cache's lifecycle state is still
CREATING. You can check the cache creation status by calling the DescribeFileCaches
operation, which returns the cache state along with other information.

# Arguments
- `file_cache_type`: The type of cache that you're creating, which must be LUSTRE.
- `file_cache_type_version`: Sets the Lustre version for the cache that you're creating,
  which must be 2.12.
- `storage_capacity`: The storage capacity of the cache in gibibytes (GiB). Valid values
  are 1200 GiB, 2400 GiB, and increments of 2400 GiB.
- `subnet_ids`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: An idempotency token for resource creation, in a string of up to
  63 ASCII characters. This token is automatically filled on your behalf when you use the
  Command Line Interface (CLI) or an Amazon Web Services SDK. By using the idempotent
  operation, you can retry a CreateFileCache operation without the risk of creating an extra
  cache. This approach can be useful when an initial call fails in a way that makes it
  unclear whether a cache was created. Examples are if a transport level timeout occurred, or
  your connection was reset. If you use the same client request token and the initial call
  created a cache, the client receives success as long as the parameters are the same.
- `"CopyTagsToDataRepositoryAssociations"`: A boolean flag indicating whether tags for the
  cache should be copied to data repository associations. This value defaults to false.
- `"DataRepositoryAssociations"`: A list of up to 8 configurations for data repository
  associations (DRAs) to be created during the cache creation. The DRAs link the cache to
  either an Amazon S3 data repository or a Network File System (NFS) data repository that
  supports the NFSv3 protocol. The DRA configurations must meet the following requirements:
  All configurations on the list must be of the same data repository type, either all S3 or
  all NFS. A cache can't link to different data repository types at the same time.   An NFS
  DRA must link to an NFS file system that supports the NFSv3 protocol.   DRA automatic
  import and automatic export is not supported.
- `"KmsKeyId"`: Specifies the ID of the Key Management Service (KMS) key to use for
  encrypting data on an Amazon File Cache. If a KmsKeyId isn't specified, the Amazon
  FSx-managed KMS key for your account is used. For more information, see Encrypt in the Key
  Management Service API Reference.
- `"LustreConfiguration"`: The configuration for the Amazon File Cache resource being
  created.
- `"SecurityGroupIds"`: A list of IDs specifying the security groups to apply to all
  network interfaces created for Amazon File Cache access. This list isn't returned in later
  requests to describe the cache.
- `"Tags"`:
"""
function create_file_cache(
    FileCacheType,
    FileCacheTypeVersion,
    StorageCapacity,
    SubnetIds;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fsx(
        "CreateFileCache",
        Dict{String,Any}(
            "FileCacheType" => FileCacheType,
            "FileCacheTypeVersion" => FileCacheTypeVersion,
            "StorageCapacity" => StorageCapacity,
            "SubnetIds" => SubnetIds,
            "ClientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_file_cache(
    FileCacheType,
    FileCacheTypeVersion,
    StorageCapacity,
    SubnetIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fsx(
        "CreateFileCache",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "FileCacheType" => FileCacheType,
                    "FileCacheTypeVersion" => FileCacheTypeVersion,
                    "StorageCapacity" => StorageCapacity,
                    "SubnetIds" => SubnetIds,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_file_system(file_system_type, storage_capacity, subnet_ids)
    create_file_system(file_system_type, storage_capacity, subnet_ids, params::Dict{String,<:Any})

Creates a new, empty Amazon FSx file system. You can create the following supported Amazon
FSx file systems using the CreateFileSystem API operation:   Amazon FSx for Lustre   Amazon
FSx for NetApp ONTAP   Amazon FSx for OpenZFS   Amazon FSx for Windows File Server   This
operation requires a client request token in the request that Amazon FSx uses to ensure
idempotent creation. This means that calling the operation multiple times with the same
client request token has no effect. By using the idempotent operation, you can retry a
CreateFileSystem operation without the risk of creating an extra file system. This approach
can be useful when an initial call fails in a way that makes it unclear whether a file
system was created. Examples are if a transport level timeout occurred, or your connection
was reset. If you use the same client request token and the initial call created a file
system, the client receives success as long as the parameters are the same. If a file
system with the specified client request token exists and the parameters match,
CreateFileSystem returns the description of the existing file system. If a file system with
the specified client request token exists and the parameters don't match, this call returns
IncompatibleParameterError. If a file system with the specified client request token
doesn't exist, CreateFileSystem does the following:   Creates a new, empty Amazon FSx file
system with an assigned ID, and an initial lifecycle state of CREATING.   Returns the
description of the file system in JSON format.    The CreateFileSystem call returns while
the file system's lifecycle state is still CREATING. You can check the file-system creation
status by calling the DescribeFileSystems operation, which returns the file system state
along with other information.

# Arguments
- `file_system_type`: The type of Amazon FSx file system to create. Valid values are
  WINDOWS, LUSTRE, ONTAP, and OPENZFS.
- `storage_capacity`: Sets the storage capacity of the file system that you're creating, in
  gibibytes (GiB).  FSx for Lustre file systems - The amount of storage capacity that you can
  configure depends on the value that you set for StorageType and the Lustre DeploymentType,
  as follows:   For SCRATCH_2, PERSISTENT_2, and PERSISTENT_1 deployment types using SSD
  storage type, the valid values are 1200 GiB, 2400 GiB, and increments of 2400 GiB.   For
  PERSISTENT_1 HDD file systems, valid values are increments of 6000 GiB for 12 MB/s/TiB file
  systems and increments of 1800 GiB for 40 MB/s/TiB file systems.   For SCRATCH_1 deployment
  type, valid values are 1200 GiB, 2400 GiB, and increments of 3600 GiB.    FSx for ONTAP
  file systems - The amount of storage capacity that you can configure depends on the value
  of the HAPairs property. The minimum value is calculated as 1,024 * HAPairs and the maximum
  is calculated as 524,288 * HAPairs.   FSx for OpenZFS file systems - The amount of storage
  capacity that you can configure is from 64 GiB up to 524,288 GiB (512 TiB).  FSx for
  Windows File Server file systems - The amount of storage capacity that you can configure
  depends on the value that you set for StorageType as follows:   For SSD storage, valid
  values are 32 GiB-65,536 GiB (64 TiB).   For HDD storage, valid values are 2000 GiB-65,536
  GiB (64 TiB).
- `subnet_ids`: Specifies the IDs of the subnets that the file system will be accessible
  from. For Windows and ONTAP MULTI_AZ_1 deployment types,provide exactly two subnet IDs, one
  for the preferred file server and one for the standby file server. You specify one of these
  subnets as the preferred subnet using the WindowsConfiguration &gt; PreferredSubnetID or
  OntapConfiguration &gt; PreferredSubnetID properties. For more information about Multi-AZ
  file system configuration, see  Availability and durability: Single-AZ and Multi-AZ file
  systems in the Amazon FSx for Windows User Guide and  Availability and durability in the
  Amazon FSx for ONTAP User Guide. For Windows SINGLE_AZ_1 and SINGLE_AZ_2 and all Lustre
  deployment types, provide exactly one subnet ID. The file server is launched in that
  subnet's Availability Zone.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: A string of up to 63 ASCII characters that Amazon FSx uses to
  ensure idempotent creation. This string is automatically filled on your behalf when you use
  the Command Line Interface (CLI) or an Amazon Web Services SDK.
- `"FileSystemTypeVersion"`: For FSx for Lustre file systems, sets the Lustre version for
  the file system that you're creating. Valid values are 2.10, 2.12, and 2.15:    2.10 is
  supported by the Scratch and Persistent_1 Lustre deployment types.    2.12 is supported by
  all Lustre deployment types, except for PERSISTENT_2 with a metadata configuration mode.
  2.15 is supported by all Lustre deployment types and is recommended for all new file
  systems.   Default value is 2.10, except for the following deployments:   Default value is
  2.12 when DeploymentType is set to PERSISTENT_2 without a metadata configuration mode.
  Default value is 2.15 when DeploymentType is set to PERSISTENT_2 with a metadata
  configuration mode.
- `"KmsKeyId"`:
- `"LustreConfiguration"`:
- `"OntapConfiguration"`:
- `"OpenZFSConfiguration"`: The OpenZFS configuration for the file system that's being
  created.
- `"SecurityGroupIds"`: A list of IDs specifying the security groups to apply to all
  network interfaces created for file system access. This list isn't returned in later
  requests to describe the file system.  You must specify a security group if you are
  creating a Multi-AZ FSx for ONTAP file system in a VPC subnet that has been shared with
  you.
- `"StorageType"`: Sets the storage type for the file system that you're creating. Valid
  values are SSD and HDD.   Set to SSD to use solid state drive storage. SSD is supported on
  all Windows, Lustre, ONTAP, and OpenZFS deployment types.   Set to HDD to use hard disk
  drive storage. HDD is supported on SINGLE_AZ_2 and MULTI_AZ_1 Windows file system
  deployment types, and on PERSISTENT_1 Lustre file system deployment types.   Default value
  is SSD. For more information, see  Storage type options in the FSx for Windows File Server
  User Guide and Multiple storage options in the FSx for Lustre User Guide.
- `"Tags"`: The tags to apply to the file system that's being created. The key value of the
  Name tag appears in the console as the file system name.
- `"WindowsConfiguration"`: The Microsoft Windows configuration for the file system that's
  being created.
"""
function create_file_system(
    FileSystemType,
    StorageCapacity,
    SubnetIds;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fsx(
        "CreateFileSystem",
        Dict{String,Any}(
            "FileSystemType" => FileSystemType,
            "StorageCapacity" => StorageCapacity,
            "SubnetIds" => SubnetIds,
            "ClientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_file_system(
    FileSystemType,
    StorageCapacity,
    SubnetIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fsx(
        "CreateFileSystem",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "FileSystemType" => FileSystemType,
                    "StorageCapacity" => StorageCapacity,
                    "SubnetIds" => SubnetIds,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_file_system_from_backup(backup_id, subnet_ids)
    create_file_system_from_backup(backup_id, subnet_ids, params::Dict{String,<:Any})

Creates a new Amazon FSx for Lustre, Amazon FSx for Windows File Server, or Amazon FSx for
OpenZFS file system from an existing Amazon FSx backup. If a file system with the specified
client request token exists and the parameters match, this operation returns the
description of the file system. If a file system with the specified client request token
exists but the parameters don't match, this call returns IncompatibleParameterError. If a
file system with the specified client request token doesn't exist, this operation does the
following:   Creates a new Amazon FSx file system from backup with an assigned ID, and an
initial lifecycle state of CREATING.   Returns the description of the file system.
Parameters like the Active Directory, default share name, automatic backup, and backup
settings default to the parameters of the file system that was backed up, unless
overridden. You can explicitly supply other settings. By using the idempotent operation,
you can retry a CreateFileSystemFromBackup call without the risk of creating an extra file
system. This approach can be useful when an initial call fails in a way that makes it
unclear whether a file system was created. Examples are if a transport level timeout
occurred, or your connection was reset. If you use the same client request token and the
initial call created a file system, the client receives a success message as long as the
parameters are the same.  The CreateFileSystemFromBackup call returns while the file
system's lifecycle state is still CREATING. You can check the file-system creation status
by calling the  DescribeFileSystems operation, which returns the file system state along
with other information.

# Arguments
- `backup_id`:
- `subnet_ids`: Specifies the IDs of the subnets that the file system will be accessible
  from. For Windows MULTI_AZ_1 file system deployment types, provide exactly two subnet IDs,
  one for the preferred file server and one for the standby file server. You specify one of
  these subnets as the preferred subnet using the WindowsConfiguration &gt; PreferredSubnetID
  property. Windows SINGLE_AZ_1 and SINGLE_AZ_2 file system deployment types, Lustre file
  systems, and OpenZFS file systems provide exactly one subnet ID. The file server is
  launched in that subnet's Availability Zone.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: A string of up to 63 ASCII characters that Amazon FSx uses to
  ensure idempotent creation. This string is automatically filled on your behalf when you use
  the Command Line Interface (CLI) or an Amazon Web Services SDK.
- `"FileSystemTypeVersion"`: Sets the version for the Amazon FSx for Lustre file system
  that you're creating from a backup. Valid values are 2.10, 2.12, and 2.15. You don't need
  to specify FileSystemTypeVersion because it will be applied using the backup's
  FileSystemTypeVersion setting. If you choose to specify FileSystemTypeVersion when creating
  from backup, the value must match the backup's FileSystemTypeVersion setting.
- `"KmsKeyId"`:
- `"LustreConfiguration"`:
- `"OpenZFSConfiguration"`: The OpenZFS configuration for the file system that's being
  created.
- `"SecurityGroupIds"`: A list of IDs for the security groups that apply to the specified
  network interfaces created for file system access. These security groups apply to all
  network interfaces. This value isn't returned in later DescribeFileSystem requests.
- `"StorageCapacity"`: Sets the storage capacity of the OpenZFS file system that you're
  creating from a backup, in gibibytes (GiB). Valid values are from 64 GiB up to 524,288 GiB
  (512 TiB). However, the value that you specify must be equal to or greater than the
  backup's storage capacity value. If you don't use the StorageCapacity parameter, the
  default is the backup's StorageCapacity value. If used to create a file system other than
  OpenZFS, you must provide a value that matches the backup's StorageCapacity value. If you
  provide any other value, Amazon FSx responds with with an HTTP status code 400 Bad Request.
- `"StorageType"`: Sets the storage type for the Windows or OpenZFS file system that you're
  creating from a backup. Valid values are SSD and HDD.   Set to SSD to use solid state drive
  storage. SSD is supported on all Windows and OpenZFS deployment types.   Set to HDD to use
  hard disk drive storage. HDD is supported on SINGLE_AZ_2 and MULTI_AZ_1 FSx for Windows
  File Server file system deployment types.    The default value is SSD.   HDD and SSD
  storage types have different minimum storage capacity requirements. A restored file
  system's storage capacity is tied to the file system that was backed up. You can create a
  file system that uses HDD storage from a backup of a file system that used SSD storage if
  the original SSD file system had a storage capacity of at least 2000 GiB.
- `"Tags"`: The tags to be applied to the file system at file system creation. The key
  value of the Name tag appears in the console as the file system name.
- `"WindowsConfiguration"`: The configuration for this Microsoft Windows file system.
"""
function create_file_system_from_backup(
    BackupId, SubnetIds; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fsx(
        "CreateFileSystemFromBackup",
        Dict{String,Any}(
            "BackupId" => BackupId,
            "SubnetIds" => SubnetIds,
            "ClientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_file_system_from_backup(
    BackupId,
    SubnetIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fsx(
        "CreateFileSystemFromBackup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "BackupId" => BackupId,
                    "SubnetIds" => SubnetIds,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_snapshot(name, volume_id)
    create_snapshot(name, volume_id, params::Dict{String,<:Any})

Creates a snapshot of an existing Amazon FSx for OpenZFS volume. With snapshots, you can
easily undo file changes and compare file versions by restoring the volume to a previous
version. If a snapshot with the specified client request token exists, and the parameters
match, this operation returns the description of the existing snapshot. If a snapshot with
the specified client request token exists, and the parameters don't match, this operation
returns IncompatibleParameterError. If a snapshot with the specified client request token
doesn't exist, CreateSnapshot does the following:   Creates a new OpenZFS snapshot with an
assigned ID, and an initial lifecycle state of CREATING.   Returns the description of the
snapshot.   By using the idempotent operation, you can retry a CreateSnapshot operation
without the risk of creating an extra snapshot. This approach can be useful when an initial
call fails in a way that makes it unclear whether a snapshot was created. If you use the
same client request token and the initial call created a snapshot, the operation returns a
successful result because all the parameters are the same. The CreateSnapshot operation
returns while the snapshot's lifecycle state is still CREATING. You can check the snapshot
creation status by calling the DescribeSnapshots operation, which returns the snapshot
state along with other information.

# Arguments
- `name`: The name of the snapshot.
- `volume_id`: The ID of the volume that you are taking a snapshot of.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`:
- `"Tags"`:
"""
function create_snapshot(Name, VolumeId; aws_config::AbstractAWSConfig=current_aws_config())
    return fsx(
        "CreateSnapshot",
        Dict{String,Any}(
            "Name" => Name, "VolumeId" => VolumeId, "ClientRequestToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_snapshot(
    Name,
    VolumeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fsx(
        "CreateSnapshot",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Name" => Name,
                    "VolumeId" => VolumeId,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_storage_virtual_machine(file_system_id, name)
    create_storage_virtual_machine(file_system_id, name, params::Dict{String,<:Any})

Creates a storage virtual machine (SVM) for an Amazon FSx for ONTAP file system.

# Arguments
- `file_system_id`:
- `name`: The name of the SVM.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ActiveDirectoryConfiguration"`: Describes the self-managed Microsoft Active Directory
  to which you want to join the SVM. Joining an Active Directory provides user authentication
  and access control for SMB clients, including Microsoft Windows and macOS clients accessing
  the file system.
- `"ClientRequestToken"`:
- `"RootVolumeSecurityStyle"`: The security style of the root volume of the SVM. Specify
  one of the following values:    UNIX if the file system is managed by a UNIX administrator,
  the majority of users are NFS clients, and an application accessing the data uses a UNIX
  user as the service account.    NTFS if the file system is managed by a Microsoft Windows
  administrator, the majority of users are SMB clients, and an application accessing the data
  uses a Microsoft Windows user as the service account.    MIXED This is an advanced setting.
  For more information, see Volume security style in the Amazon FSx for NetApp ONTAP User
  Guide.
- `"SvmAdminPassword"`: The password to use when managing the SVM using the NetApp ONTAP
  CLI or REST API. If you do not specify a password, you can still use the file system's
  fsxadmin user to manage the SVM.
- `"Tags"`:
"""
function create_storage_virtual_machine(
    FileSystemId, Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fsx(
        "CreateStorageVirtualMachine",
        Dict{String,Any}(
            "FileSystemId" => FileSystemId,
            "Name" => Name,
            "ClientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_storage_virtual_machine(
    FileSystemId,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fsx(
        "CreateStorageVirtualMachine",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "FileSystemId" => FileSystemId,
                    "Name" => Name,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_volume(name, volume_type)
    create_volume(name, volume_type, params::Dict{String,<:Any})

Creates an FSx for ONTAP or Amazon FSx for OpenZFS storage volume.

# Arguments
- `name`: Specifies the name of the volume that you're creating.
- `volume_type`: Specifies the type of volume to create; ONTAP and OPENZFS are the only
  valid volume types.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`:
- `"OntapConfiguration"`: Specifies the configuration to use when creating the ONTAP volume.
- `"OpenZFSConfiguration"`: Specifies the configuration to use when creating the OpenZFS
  volume.
- `"Tags"`:
"""
function create_volume(Name, VolumeType; aws_config::AbstractAWSConfig=current_aws_config())
    return fsx(
        "CreateVolume",
        Dict{String,Any}(
            "Name" => Name,
            "VolumeType" => VolumeType,
            "ClientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_volume(
    Name,
    VolumeType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fsx(
        "CreateVolume",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Name" => Name,
                    "VolumeType" => VolumeType,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_volume_from_backup(backup_id, name)
    create_volume_from_backup(backup_id, name, params::Dict{String,<:Any})

Creates a new Amazon FSx for NetApp ONTAP volume from an existing Amazon FSx volume backup.

# Arguments
- `backup_id`:
- `name`: The name of the new volume you're creating.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`:
- `"OntapConfiguration"`: Specifies the configuration of the ONTAP volume that you are
  creating.
- `"Tags"`:
"""
function create_volume_from_backup(
    BackupId, Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fsx(
        "CreateVolumeFromBackup",
        Dict{String,Any}(
            "BackupId" => BackupId, "Name" => Name, "ClientRequestToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_volume_from_backup(
    BackupId,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fsx(
        "CreateVolumeFromBackup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "BackupId" => BackupId,
                    "Name" => Name,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_backup(backup_id)
    delete_backup(backup_id, params::Dict{String,<:Any})

Deletes an Amazon FSx backup. After deletion, the backup no longer exists, and its data is
gone. The DeleteBackup call returns instantly. The backup won't show up in later
DescribeBackups calls.  The data in a deleted backup is also deleted and can't be recovered
by any means.

# Arguments
- `backup_id`: The ID of the backup that you want to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: A string of up to 63 ASCII characters that Amazon FSx uses to
  ensure idempotent deletion. This parameter is automatically filled on your behalf when
  using the CLI or SDK.
"""
function delete_backup(BackupId; aws_config::AbstractAWSConfig=current_aws_config())
    return fsx(
        "DeleteBackup",
        Dict{String,Any}("BackupId" => BackupId, "ClientRequestToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_backup(
    BackupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fsx(
        "DeleteBackup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "BackupId" => BackupId, "ClientRequestToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_data_repository_association(association_id)
    delete_data_repository_association(association_id, params::Dict{String,<:Any})

Deletes a data repository association on an Amazon FSx for Lustre file system. Deleting the
data repository association unlinks the file system from the Amazon S3 bucket. When
deleting a data repository association, you have the option of deleting the data in the
file system that corresponds to the data repository association. Data repository
associations are supported on all FSx for Lustre 2.12 and 2.15 file systems, excluding
scratch_1 deployment type.

# Arguments
- `association_id`: The ID of the data repository association that you want to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`:
- `"DeleteDataInFileSystem"`: Set to true to delete the data in the file system that
  corresponds to the data repository association.
"""
function delete_data_repository_association(
    AssociationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fsx(
        "DeleteDataRepositoryAssociation",
        Dict{String,Any}(
            "AssociationId" => AssociationId, "ClientRequestToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_data_repository_association(
    AssociationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fsx(
        "DeleteDataRepositoryAssociation",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AssociationId" => AssociationId,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_file_cache(file_cache_id)
    delete_file_cache(file_cache_id, params::Dict{String,<:Any})

Deletes an Amazon File Cache resource. After deletion, the cache no longer exists, and its
data is gone. The DeleteFileCache operation returns while the cache has the DELETING
status. You can check the cache deletion status by calling the DescribeFileCaches
operation, which returns a list of caches in your account. If you pass the cache ID for a
deleted cache, the DescribeFileCaches operation returns a FileCacheNotFound error.  The
data in a deleted cache is also deleted and can't be recovered by any means.

# Arguments
- `file_cache_id`: The ID of the cache that's being deleted.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`:
"""
function delete_file_cache(FileCacheId; aws_config::AbstractAWSConfig=current_aws_config())
    return fsx(
        "DeleteFileCache",
        Dict{String,Any}(
            "FileCacheId" => FileCacheId, "ClientRequestToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_file_cache(
    FileCacheId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fsx(
        "DeleteFileCache",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "FileCacheId" => FileCacheId, "ClientRequestToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_file_system(file_system_id)
    delete_file_system(file_system_id, params::Dict{String,<:Any})

Deletes a file system. After deletion, the file system no longer exists, and its data is
gone. Any existing automatic backups and snapshots are also deleted. To delete an Amazon
FSx for NetApp ONTAP file system, first delete all the volumes and storage virtual machines
(SVMs) on the file system. Then provide a FileSystemId value to the DeleteFileSystem
operation. By default, when you delete an Amazon FSx for Windows File Server file system, a
final backup is created upon deletion. This final backup isn't subject to the file system's
retention policy, and must be manually deleted. To delete an Amazon FSx for Lustre file
system, first unmount it from every connected Amazon EC2 instance, then provide a
FileSystemId value to the DeleteFileSystem operation. By default, Amazon FSx will not take
a final backup when the DeleteFileSystem operation is invoked. On file systems not linked
to an Amazon S3 bucket, set SkipFinalBackup to false to take a final backup of the file
system you are deleting. Backups cannot be enabled on S3-linked file systems. To ensure all
of your data is written back to S3 before deleting your file system, you can either monitor
for the AgeOfOldestQueuedMessage metric to be zero (if using automatic export) or you can
run an export data repository task. If you have automatic export enabled and want to use an
export data repository task, you have to disable automatic export before executing the
export data repository task. The DeleteFileSystem operation returns while the file system
has the DELETING status. You can check the file system deletion status by calling the
DescribeFileSystems operation, which returns a list of file systems in your account. If you
pass the file system ID for a deleted file system, the DescribeFileSystems operation
returns a FileSystemNotFound error.  If a data repository task is in a PENDING or EXECUTING
state, deleting an Amazon FSx for Lustre file system will fail with an HTTP status code 400
(Bad Request).   The data in a deleted file system is also deleted and can't be recovered
by any means.

# Arguments
- `file_system_id`: The ID of the file system that you want to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: A string of up to 63 ASCII characters that Amazon FSx uses to
  ensure idempotent deletion. This token is automatically filled on your behalf when using
  the Command Line Interface (CLI) or an Amazon Web Services SDK.
- `"LustreConfiguration"`:
- `"OpenZFSConfiguration"`: The configuration object for the OpenZFS file system used in
  the DeleteFileSystem operation.
- `"WindowsConfiguration"`:
"""
function delete_file_system(
    FileSystemId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fsx(
        "DeleteFileSystem",
        Dict{String,Any}(
            "FileSystemId" => FileSystemId, "ClientRequestToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_file_system(
    FileSystemId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fsx(
        "DeleteFileSystem",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "FileSystemId" => FileSystemId, "ClientRequestToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_snapshot(snapshot_id)
    delete_snapshot(snapshot_id, params::Dict{String,<:Any})

Deletes an Amazon FSx for OpenZFS snapshot. After deletion, the snapshot no longer exists,
and its data is gone. Deleting a snapshot doesn't affect snapshots stored in a file system
backup.  The DeleteSnapshot operation returns instantly. The snapshot appears with the
lifecycle status of DELETING until the deletion is complete.

# Arguments
- `snapshot_id`: The ID of the snapshot that you want to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`:
"""
function delete_snapshot(SnapshotId; aws_config::AbstractAWSConfig=current_aws_config())
    return fsx(
        "DeleteSnapshot",
        Dict{String,Any}(
            "SnapshotId" => SnapshotId, "ClientRequestToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_snapshot(
    SnapshotId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fsx(
        "DeleteSnapshot",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "SnapshotId" => SnapshotId, "ClientRequestToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_storage_virtual_machine(storage_virtual_machine_id)
    delete_storage_virtual_machine(storage_virtual_machine_id, params::Dict{String,<:Any})

Deletes an existing Amazon FSx for ONTAP storage virtual machine (SVM). Prior to deleting
an SVM, you must delete all non-root volumes in the SVM, otherwise the operation will fail.

# Arguments
- `storage_virtual_machine_id`: The ID of the SVM that you want to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`:
"""
function delete_storage_virtual_machine(
    StorageVirtualMachineId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fsx(
        "DeleteStorageVirtualMachine",
        Dict{String,Any}(
            "StorageVirtualMachineId" => StorageVirtualMachineId,
            "ClientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_storage_virtual_machine(
    StorageVirtualMachineId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fsx(
        "DeleteStorageVirtualMachine",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "StorageVirtualMachineId" => StorageVirtualMachineId,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_volume(volume_id)
    delete_volume(volume_id, params::Dict{String,<:Any})

Deletes an Amazon FSx for NetApp ONTAP or Amazon FSx for OpenZFS volume.

# Arguments
- `volume_id`: The ID of the volume that you are deleting.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`:
- `"OntapConfiguration"`: For Amazon FSx for ONTAP volumes, specify whether to take a final
  backup of the volume and apply tags to the backup. To apply tags to the backup, you must
  have the fsx:TagResource permission.
- `"OpenZFSConfiguration"`: For Amazon FSx for OpenZFS volumes, specify whether to delete
  all child volumes and snapshots.
"""
function delete_volume(VolumeId; aws_config::AbstractAWSConfig=current_aws_config())
    return fsx(
        "DeleteVolume",
        Dict{String,Any}("VolumeId" => VolumeId, "ClientRequestToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_volume(
    VolumeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fsx(
        "DeleteVolume",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "VolumeId" => VolumeId, "ClientRequestToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_backups()
    describe_backups(params::Dict{String,<:Any})

Returns the description of a specific Amazon FSx backup, if a BackupIds value is provided
for that backup. Otherwise, it returns all backups owned by your Amazon Web Services
account in the Amazon Web Services Region of the endpoint that you're calling. When
retrieving all backups, you can optionally specify the MaxResults parameter to limit the
number of backups in a response. If more backups remain, Amazon FSx returns a NextToken
value in the response. In this case, send a later request with the NextToken request
parameter set to the value of the NextToken value from the last response. This operation is
used in an iterative process to retrieve a list of your backups. DescribeBackups is called
first without a NextToken value. Then the operation continues to be called with the
NextToken parameter set to the value of the last NextToken value until a response has no
NextToken value. When using this operation, keep the following in mind:   The operation
might return fewer than the MaxResults value of backup descriptions while still including a
NextToken value.   The order of the backups returned in the response of one DescribeBackups
call and the order of the backups returned across the responses of a multi-call iteration
is unspecified.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"BackupIds"`: The IDs of the backups that you want to retrieve. This parameter value
  overrides any filters. If any IDs aren't found, a BackupNotFound error occurs.
- `"Filters"`: The filters structure. The supported names are file-system-id, backup-type,
  file-system-type, and volume-id.
- `"MaxResults"`: Maximum number of backups to return in the response. This parameter value
  must be greater than 0. The number of items that Amazon FSx returns is the minimum of the
  MaxResults parameter specified in the request and the service's internal maximum number of
  items per page.
- `"NextToken"`: An opaque pagination token returned from a previous DescribeBackups
  operation. If a token is present, the operation continues the list from where the returning
  call left off.
"""
function describe_backups(; aws_config::AbstractAWSConfig=current_aws_config())
    return fsx("DescribeBackups"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function describe_backups(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fsx(
        "DescribeBackups", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_data_repository_associations()
    describe_data_repository_associations(params::Dict{String,<:Any})

Returns the description of specific Amazon FSx for Lustre or Amazon File Cache data
repository associations, if one or more AssociationIds values are provided in the request,
or if filters are used in the request. Data repository associations are supported on Amazon
File Cache resources and all FSx for Lustre 2.12 and 2,15 file systems, excluding scratch_1
deployment type. You can use filters to narrow the response to include just data repository
associations for specific file systems (use the file-system-id filter with the ID of the
file system) or caches (use the file-cache-id filter with the ID of the cache), or data
repository associations for a specific repository type (use the data-repository-type filter
with a value of S3 or NFS). If you don't use filters, the response returns all data
repository associations owned by your Amazon Web Services account in the Amazon Web
Services Region of the endpoint that you're calling. When retrieving all data repository
associations, you can paginate the response by using the optional MaxResults parameter to
limit the number of data repository associations returned in a response. If more data
repository associations remain, a NextToken value is returned in the response. In this
case, send a later request with the NextToken request parameter set to the value of
NextToken from the last response.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AssociationIds"`: IDs of the data repository associations whose descriptions you want
  to retrieve (String).
- `"Filters"`:
- `"MaxResults"`: The maximum number of resources to return in the response. This value
  must be an integer greater than zero.
- `"NextToken"`:
"""
function describe_data_repository_associations(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return fsx(
        "DescribeDataRepositoryAssociations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_data_repository_associations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fsx(
        "DescribeDataRepositoryAssociations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_data_repository_tasks()
    describe_data_repository_tasks(params::Dict{String,<:Any})

Returns the description of specific Amazon FSx for Lustre or Amazon File Cache data
repository tasks, if one or more TaskIds values are provided in the request, or if filters
are used in the request. You can use filters to narrow the response to include just tasks
for specific file systems or caches, or tasks in a specific lifecycle state. Otherwise, it
returns all data repository tasks owned by your Amazon Web Services account in the Amazon
Web Services Region of the endpoint that you're calling. When retrieving all tasks, you can
paginate the response by using the optional MaxResults parameter to limit the number of
tasks returned in a response. If more tasks remain, a NextToken value is returned in the
response. In this case, send a later request with the NextToken request parameter set to
the value of NextToken from the last response.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: (Optional) You can use filters to narrow the DescribeDataRepositoryTasks
  response to include just tasks for specific file systems, or tasks in a specific lifecycle
  state.
- `"MaxResults"`:
- `"NextToken"`:
- `"TaskIds"`: (Optional) IDs of the tasks whose descriptions you want to retrieve (String).
"""
function describe_data_repository_tasks(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return fsx(
        "DescribeDataRepositoryTasks";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_data_repository_tasks(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fsx(
        "DescribeDataRepositoryTasks",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_file_caches()
    describe_file_caches(params::Dict{String,<:Any})

Returns the description of a specific Amazon File Cache resource, if a FileCacheIds value
is provided for that cache. Otherwise, it returns descriptions of all caches owned by your
Amazon Web Services account in the Amazon Web Services Region of the endpoint that you're
calling. When retrieving all cache descriptions, you can optionally specify the MaxResults
parameter to limit the number of descriptions in a response. If more cache descriptions
remain, the operation returns a NextToken value in the response. In this case, send a later
request with the NextToken request parameter set to the value of NextToken from the last
response. This operation is used in an iterative process to retrieve a list of your cache
descriptions. DescribeFileCaches is called first without a NextTokenvalue. Then the
operation continues to be called with the NextToken parameter set to the value of the last
NextToken value until a response has no NextToken. When using this operation, keep the
following in mind:   The implementation might return fewer than MaxResults cache
descriptions while still including a NextToken value.   The order of caches returned in the
response of one DescribeFileCaches call and the order of caches returned across the
responses of a multicall iteration is unspecified.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FileCacheIds"`: IDs of the caches whose descriptions you want to retrieve (String).
- `"MaxResults"`:
- `"NextToken"`:
"""
function describe_file_caches(; aws_config::AbstractAWSConfig=current_aws_config())
    return fsx("DescribeFileCaches"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function describe_file_caches(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fsx(
        "DescribeFileCaches", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_file_system_aliases(file_system_id)
    describe_file_system_aliases(file_system_id, params::Dict{String,<:Any})

Returns the DNS aliases that are associated with the specified Amazon FSx for Windows File
Server file system. A history of all DNS aliases that have been associated with and
disassociated from the file system is available in the list of AdministrativeAction
provided in the DescribeFileSystems operation response.

# Arguments
- `file_system_id`: The ID of the file system to return the associated DNS aliases for
  (String).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`:
- `"MaxResults"`: Maximum number of DNS aliases to return in the response (integer). This
  parameter value must be greater than 0. The number of items that Amazon FSx returns is the
  minimum of the MaxResults parameter specified in the request and the service's internal
  maximum number of items per page.
- `"NextToken"`: Opaque pagination token returned from a previous DescribeFileSystemAliases
  operation (String). If a token is included in the request, the action continues the list
  from where the previous returning call left off.
"""
function describe_file_system_aliases(
    FileSystemId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fsx(
        "DescribeFileSystemAliases",
        Dict{String,Any}(
            "FileSystemId" => FileSystemId, "ClientRequestToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_file_system_aliases(
    FileSystemId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fsx(
        "DescribeFileSystemAliases",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "FileSystemId" => FileSystemId, "ClientRequestToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_file_systems()
    describe_file_systems(params::Dict{String,<:Any})

Returns the description of specific Amazon FSx file systems, if a FileSystemIds value is
provided for that file system. Otherwise, it returns descriptions of all file systems owned
by your Amazon Web Services account in the Amazon Web Services Region of the endpoint that
you're calling. When retrieving all file system descriptions, you can optionally specify
the MaxResults parameter to limit the number of descriptions in a response. If more file
system descriptions remain, Amazon FSx returns a NextToken value in the response. In this
case, send a later request with the NextToken request parameter set to the value of
NextToken from the last response. This operation is used in an iterative process to
retrieve a list of your file system descriptions. DescribeFileSystems is called first
without a NextTokenvalue. Then the operation continues to be called with the NextToken
parameter set to the value of the last NextToken value until a response has no NextToken.
When using this operation, keep the following in mind:   The implementation might return
fewer than MaxResults file system descriptions while still including a NextToken value.
The order of file systems returned in the response of one DescribeFileSystems call and the
order of file systems returned across the responses of a multicall iteration is
unspecified.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FileSystemIds"`: IDs of the file systems whose descriptions you want to retrieve
  (String).
- `"MaxResults"`: Maximum number of file systems to return in the response (integer). This
  parameter value must be greater than 0. The number of items that Amazon FSx returns is the
  minimum of the MaxResults parameter specified in the request and the service's internal
  maximum number of items per page.
- `"NextToken"`: Opaque pagination token returned from a previous DescribeFileSystems
  operation (String). If a token present, the operation continues the list from where the
  returning call left off.
"""
function describe_file_systems(; aws_config::AbstractAWSConfig=current_aws_config())
    return fsx(
        "DescribeFileSystems"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_file_systems(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fsx(
        "DescribeFileSystems",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_shared_vpc_configuration()
    describe_shared_vpc_configuration(params::Dict{String,<:Any})

Indicates whether participant accounts in your organization can create Amazon FSx for
NetApp ONTAP Multi-AZ file systems in subnets that are shared by a virtual private cloud
(VPC) owner. For more information, see Creating FSx for ONTAP file systems in shared
subnets.

"""
function describe_shared_vpc_configuration(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return fsx(
        "DescribeSharedVpcConfiguration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_shared_vpc_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fsx(
        "DescribeSharedVpcConfiguration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_snapshots()
    describe_snapshots(params::Dict{String,<:Any})

Returns the description of specific Amazon FSx for OpenZFS snapshots, if a SnapshotIds
value is provided. Otherwise, this operation returns all snapshots owned by your Amazon Web
Services account in the Amazon Web Services Region of the endpoint that you're calling.
When retrieving all snapshots, you can optionally specify the MaxResults parameter to limit
the number of snapshots in a response. If more backups remain, Amazon FSx returns a
NextToken value in the response. In this case, send a later request with the NextToken
request parameter set to the value of NextToken from the last response.  Use this operation
in an iterative process to retrieve a list of your snapshots. DescribeSnapshots is called
first without a NextToken value. Then the operation continues to be called with the
NextToken parameter set to the value of the last NextToken value until a response has no
NextToken value. When using this operation, keep the following in mind:   The operation
might return fewer than the MaxResults value of snapshot descriptions while still including
a NextToken value.   The order of snapshots returned in the response of one
DescribeSnapshots call and the order of backups returned across the responses of a
multi-call iteration is unspecified.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: The filters structure. The supported names are file-system-id or volume-id.
- `"IncludeShared"`: Set to false (default) if you want to only see the snapshots owned by
  your Amazon Web Services account. Set to true if you want to see the snapshots in your
  account and the ones shared with you from another account.
- `"MaxResults"`:
- `"NextToken"`:
- `"SnapshotIds"`: The IDs of the snapshots that you want to retrieve. This parameter value
  overrides any filters. If any IDs aren't found, a SnapshotNotFound error occurs.
"""
function describe_snapshots(; aws_config::AbstractAWSConfig=current_aws_config())
    return fsx("DescribeSnapshots"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function describe_snapshots(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fsx(
        "DescribeSnapshots", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_storage_virtual_machines()
    describe_storage_virtual_machines(params::Dict{String,<:Any})

Describes one or more Amazon FSx for NetApp ONTAP storage virtual machines (SVMs).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: Enter a filter name:value pair to view a select set of SVMs.
- `"MaxResults"`:
- `"NextToken"`:
- `"StorageVirtualMachineIds"`: Enter the ID of one or more SVMs that you want to view.
"""
function describe_storage_virtual_machines(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return fsx(
        "DescribeStorageVirtualMachines";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_storage_virtual_machines(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fsx(
        "DescribeStorageVirtualMachines",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_volumes()
    describe_volumes(params::Dict{String,<:Any})

Describes one or more Amazon FSx for NetApp ONTAP or Amazon FSx for OpenZFS volumes.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: Enter a filter Name and Values pair to view a select set of volumes.
- `"MaxResults"`:
- `"NextToken"`:
- `"VolumeIds"`: The IDs of the volumes whose descriptions you want to retrieve.
"""
function describe_volumes(; aws_config::AbstractAWSConfig=current_aws_config())
    return fsx("DescribeVolumes"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function describe_volumes(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fsx(
        "DescribeVolumes", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    disassociate_file_system_aliases(aliases, file_system_id)
    disassociate_file_system_aliases(aliases, file_system_id, params::Dict{String,<:Any})

Use this action to disassociate, or remove, one or more Domain Name Service (DNS) aliases
from an Amazon FSx for Windows File Server file system. If you attempt to disassociate a
DNS alias that is not associated with the file system, Amazon FSx responds with an HTTP
status code 400 (Bad Request). For more information, see Working with DNS Aliases. The
system generated response showing the DNS aliases that Amazon FSx is attempting to
disassociate from the file system. Use the API operation to monitor the status of the
aliases Amazon FSx is disassociating with the file system.

# Arguments
- `aliases`: An array of one or more DNS alias names to disassociate, or remove, from the
  file system.
- `file_system_id`: Specifies the file system from which to disassociate the DNS aliases.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`:
"""
function disassociate_file_system_aliases(
    Aliases, FileSystemId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fsx(
        "DisassociateFileSystemAliases",
        Dict{String,Any}(
            "Aliases" => Aliases,
            "FileSystemId" => FileSystemId,
            "ClientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_file_system_aliases(
    Aliases,
    FileSystemId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fsx(
        "DisassociateFileSystemAliases",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Aliases" => Aliases,
                    "FileSystemId" => FileSystemId,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists tags for Amazon FSx resources. When retrieving all tags, you can optionally specify
the MaxResults parameter to limit the number of tags in a response. If more tags remain,
Amazon FSx returns a NextToken value in the response. In this case, send a later request
with the NextToken request parameter set to the value of NextToken from the last response.
This action is used in an iterative process to retrieve a list of your tags.
ListTagsForResource is called first without a NextTokenvalue. Then the action continues to
be called with the NextToken parameter set to the value of the last NextToken value until a
response has no NextToken. When using this action, keep the following in mind:   The
implementation might return fewer than MaxResults file system descriptions while still
including a NextToken value.   The order of tags returned in the response of one
ListTagsForResource call and the order of tags returned across the responses of a
multi-call iteration is unspecified.

# Arguments
- `resource_arn`: The ARN of the Amazon FSx resource that will have its tags listed.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Maximum number of tags to return in the response (integer). This
  parameter value must be greater than 0. The number of items that Amazon FSx returns is the
  minimum of the MaxResults parameter specified in the request and the service's internal
  maximum number of items per page.
- `"NextToken"`: Opaque pagination token returned from a previous ListTagsForResource
  operation (String). If a token present, the action continues the list from where the
  returning call left off.
"""
function list_tags_for_resource(
    ResourceARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fsx(
        "ListTagsForResource",
        Dict{String,Any}("ResourceARN" => ResourceARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fsx(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceARN" => ResourceARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    release_file_system_nfs_v3_locks(file_system_id)
    release_file_system_nfs_v3_locks(file_system_id, params::Dict{String,<:Any})

Releases the file system lock from an Amazon FSx for OpenZFS file system.

# Arguments
- `file_system_id`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`:
"""
function release_file_system_nfs_v3_locks(
    FileSystemId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fsx(
        "ReleaseFileSystemNfsV3Locks",
        Dict{String,Any}(
            "FileSystemId" => FileSystemId, "ClientRequestToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function release_file_system_nfs_v3_locks(
    FileSystemId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fsx(
        "ReleaseFileSystemNfsV3Locks",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "FileSystemId" => FileSystemId, "ClientRequestToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    restore_volume_from_snapshot(snapshot_id, volume_id)
    restore_volume_from_snapshot(snapshot_id, volume_id, params::Dict{String,<:Any})

Returns an Amazon FSx for OpenZFS volume to the state saved by the specified snapshot.

# Arguments
- `snapshot_id`: The ID of the source snapshot. Specifies the snapshot that you are
  restoring from.
- `volume_id`: The ID of the volume that you are restoring.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`:
- `"Options"`: The settings used when restoring the specified volume from snapshot.
  DELETE_INTERMEDIATE_SNAPSHOTS - Deletes snapshots between the current state and the
  specified snapshot. If there are intermediate snapshots and this option isn't used,
  RestoreVolumeFromSnapshot fails.    DELETE_CLONED_VOLUMES - Deletes any dependent clone
  volumes created from intermediate snapshots. If there are any dependent clone volumes and
  this option isn't used, RestoreVolumeFromSnapshot fails.
"""
function restore_volume_from_snapshot(
    SnapshotId, VolumeId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fsx(
        "RestoreVolumeFromSnapshot",
        Dict{String,Any}(
            "SnapshotId" => SnapshotId,
            "VolumeId" => VolumeId,
            "ClientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function restore_volume_from_snapshot(
    SnapshotId,
    VolumeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fsx(
        "RestoreVolumeFromSnapshot",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "SnapshotId" => SnapshotId,
                    "VolumeId" => VolumeId,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_misconfigured_state_recovery(file_system_id)
    start_misconfigured_state_recovery(file_system_id, params::Dict{String,<:Any})

After performing steps to repair the Active Directory configuration of an FSx for Windows
File Server file system, use this action to initiate the process of Amazon FSx attempting
to reconnect to the file system.

# Arguments
- `file_system_id`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`:
"""
function start_misconfigured_state_recovery(
    FileSystemId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fsx(
        "StartMisconfiguredStateRecovery",
        Dict{String,Any}(
            "FileSystemId" => FileSystemId, "ClientRequestToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_misconfigured_state_recovery(
    FileSystemId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fsx(
        "StartMisconfiguredStateRecovery",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "FileSystemId" => FileSystemId, "ClientRequestToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Tags an Amazon FSx resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the Amazon FSx resource that you want
  to tag.
- `tags`: A list of tags for the resource. If a tag with a given key already exists, the
  value is replaced by the one specified in this parameter.

"""
function tag_resource(ResourceARN, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return fsx(
        "TagResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceARN,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fsx(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

This action removes a tag from an Amazon FSx resource.

# Arguments
- `resource_arn`: The ARN of the Amazon FSx resource to untag.
- `tag_keys`: A list of keys of tags on the resource to untag. In case the tag key doesn't
  exist, the call will still succeed to be idempotent.

"""
function untag_resource(
    ResourceARN, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fsx(
        "UntagResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceARN,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fsx(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_data_repository_association(association_id)
    update_data_repository_association(association_id, params::Dict{String,<:Any})

Updates the configuration of an existing data repository association on an Amazon FSx for
Lustre file system. Data repository associations are supported on all FSx for Lustre 2.12
and 2.15 file systems, excluding scratch_1 deployment type.

# Arguments
- `association_id`: The ID of the data repository association that you are updating.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`:
- `"ImportedFileChunkSize"`: For files imported from a data repository, this value
  determines the stripe count and maximum amount of data per file (in MiB) stored on a single
  physical disk. The maximum number of disks that a single file can be striped across is
  limited by the total number of disks that make up the file system. The default chunk size
  is 1,024 MiB (1 GiB) and can go as high as 512,000 MiB (500 GiB). Amazon S3 objects have a
  maximum size of 5 TB.
- `"S3"`: The configuration for an Amazon S3 data repository linked to an Amazon FSx Lustre
  file system with a data repository association. The configuration defines which file events
  (new, changed, or deleted files or directories) are automatically imported from the linked
  data repository to the file system or automatically exported from the file system to the
  data repository.
"""
function update_data_repository_association(
    AssociationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fsx(
        "UpdateDataRepositoryAssociation",
        Dict{String,Any}(
            "AssociationId" => AssociationId, "ClientRequestToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_data_repository_association(
    AssociationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fsx(
        "UpdateDataRepositoryAssociation",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AssociationId" => AssociationId,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_file_cache(file_cache_id)
    update_file_cache(file_cache_id, params::Dict{String,<:Any})

Updates the configuration of an existing Amazon File Cache resource. You can update
multiple properties in a single request.

# Arguments
- `file_cache_id`: The ID of the cache that you are updating.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`:
- `"LustreConfiguration"`: The configuration updates for an Amazon File Cache resource.
"""
function update_file_cache(FileCacheId; aws_config::AbstractAWSConfig=current_aws_config())
    return fsx(
        "UpdateFileCache",
        Dict{String,Any}(
            "FileCacheId" => FileCacheId, "ClientRequestToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_file_cache(
    FileCacheId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fsx(
        "UpdateFileCache",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "FileCacheId" => FileCacheId, "ClientRequestToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_file_system(file_system_id)
    update_file_system(file_system_id, params::Dict{String,<:Any})

Use this operation to update the configuration of an existing Amazon FSx file system. You
can update multiple properties in a single request. For FSx for Windows File Server file
systems, you can update the following properties:    AuditLogConfiguration
AutomaticBackupRetentionDays     DailyAutomaticBackupStartTime
SelfManagedActiveDirectoryConfiguration     StorageCapacity     StorageType
ThroughputCapacity     DiskIopsConfiguration     WeeklyMaintenanceStartTime    For FSx for
Lustre file systems, you can update the following properties:    AutoImportPolicy
AutomaticBackupRetentionDays     DailyAutomaticBackupStartTime     DataCompressionType
LogConfiguration     LustreRootSquashConfiguration     MetadataConfiguration
PerUnitStorageThroughput     StorageCapacity     WeeklyMaintenanceStartTime    For FSx for
ONTAP file systems, you can update the following properties:    AddRouteTableIds
AutomaticBackupRetentionDays     DailyAutomaticBackupStartTime     DiskIopsConfiguration
 FsxAdminPassword     HAPairs     RemoveRouteTableIds     StorageCapacity
ThroughputCapacity     ThroughputCapacityPerHAPair     WeeklyMaintenanceStartTime    For
FSx for OpenZFS file systems, you can update the following properties:    AddRouteTableIds
   AutomaticBackupRetentionDays     CopyTagsToBackups     CopyTagsToVolumes
DailyAutomaticBackupStartTime     DiskIopsConfiguration     RemoveRouteTableIds
StorageCapacity     ThroughputCapacity     WeeklyMaintenanceStartTime

# Arguments
- `file_system_id`: The ID of the file system that you are updating.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: A string of up to 63 ASCII characters that Amazon FSx uses to
  ensure idempotent updates. This string is automatically filled on your behalf when you use
  the Command Line Interface (CLI) or an Amazon Web Services SDK.
- `"LustreConfiguration"`:
- `"OntapConfiguration"`:
- `"OpenZFSConfiguration"`: The configuration updates for an FSx for OpenZFS file system.
- `"StorageCapacity"`: Use this parameter to increase the storage capacity of an FSx for
  Windows File Server, FSx for Lustre, FSx for OpenZFS, or FSx for ONTAP file system.
  Specifies the storage capacity target value, in GiB, to increase the storage capacity for
  the file system that you're updating.   You can't make a storage capacity increase request
  if there is an existing storage capacity increase request in progress.  For Lustre file
  systems, the storage capacity target value can be the following:   For SCRATCH_2,
  PERSISTENT_1, and PERSISTENT_2 SSD deployment types, valid values are in multiples of 2400
  GiB. The value must be greater than the current storage capacity.   For PERSISTENT HDD file
  systems, valid values are multiples of 6000 GiB for 12-MBps throughput per TiB file systems
  and multiples of 1800 GiB for 40-MBps throughput per TiB file systems. The values must be
  greater than the current storage capacity.   For SCRATCH_1 file systems, you can't increase
  the storage capacity.   For more information, see Managing storage and throughput capacity
  in the FSx for Lustre User Guide. For FSx for OpenZFS file systems, the storage capacity
  target value must be at least 10 percent greater than the current storage capacity value.
  For more information, see Managing storage capacity in the FSx for OpenZFS User Guide. For
  Windows file systems, the storage capacity target value must be at least 10 percent greater
  than the current storage capacity value. To increase storage capacity, the file system must
  have at least 16 MBps of throughput capacity. For more information, see Managing storage
  capacity in the Amazon FSxfor Windows File Server User Guide. For ONTAP file systems, the
  storage capacity target value must be at least 10 percent greater than the current storage
  capacity value. For more information, see Managing storage capacity and provisioned IOPS in
  the Amazon FSx for NetApp ONTAP User Guide.
- `"StorageType"`:
- `"WindowsConfiguration"`: The configuration updates for an Amazon FSx for Windows File
  Server file system.
"""
function update_file_system(
    FileSystemId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fsx(
        "UpdateFileSystem",
        Dict{String,Any}(
            "FileSystemId" => FileSystemId, "ClientRequestToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_file_system(
    FileSystemId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fsx(
        "UpdateFileSystem",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "FileSystemId" => FileSystemId, "ClientRequestToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_shared_vpc_configuration()
    update_shared_vpc_configuration(params::Dict{String,<:Any})

Configures whether participant accounts in your organization can create Amazon FSx for
NetApp ONTAP Multi-AZ file systems in subnets that are shared by a virtual private cloud
(VPC) owner. For more information, see the Amazon FSx for NetApp ONTAP User Guide.  We
strongly recommend that participant-created Multi-AZ file systems in the shared VPC are
deleted before you disable this feature. Once the feature is disabled, these file systems
will enter a MISCONFIGURED state and behave like Single-AZ file systems. For more
information, see Important considerations before disabling shared VPC support for Multi-AZ
file systems.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`:
- `"EnableFsxRouteTableUpdatesFromParticipantAccounts"`: Specifies whether participant
  accounts can create FSx for ONTAP Multi-AZ file systems in shared subnets. Set to true to
  enable or false to disable.
"""
function update_shared_vpc_configuration(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return fsx(
        "UpdateSharedVpcConfiguration",
        Dict{String,Any}("ClientRequestToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_shared_vpc_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fsx(
        "UpdateSharedVpcConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ClientRequestToken" => string(uuid4())), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_snapshot(name, snapshot_id)
    update_snapshot(name, snapshot_id, params::Dict{String,<:Any})

Updates the name of an Amazon FSx for OpenZFS snapshot.

# Arguments
- `name`: The name of the snapshot to update.
- `snapshot_id`: The ID of the snapshot that you want to update, in the format
  fsvolsnap-0123456789abcdef0.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`:
"""
function update_snapshot(
    Name, SnapshotId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fsx(
        "UpdateSnapshot",
        Dict{String,Any}(
            "Name" => Name,
            "SnapshotId" => SnapshotId,
            "ClientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_snapshot(
    Name,
    SnapshotId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fsx(
        "UpdateSnapshot",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Name" => Name,
                    "SnapshotId" => SnapshotId,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_storage_virtual_machine(storage_virtual_machine_id)
    update_storage_virtual_machine(storage_virtual_machine_id, params::Dict{String,<:Any})

Updates an FSx for ONTAP storage virtual machine (SVM).

# Arguments
- `storage_virtual_machine_id`: The ID of the SVM that you want to update, in the format
  svm-0123456789abcdef0.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ActiveDirectoryConfiguration"`: Specifies updates to an SVM's Microsoft Active
  Directory (AD) configuration.
- `"ClientRequestToken"`:
- `"SvmAdminPassword"`: Specifies a new SvmAdminPassword.
"""
function update_storage_virtual_machine(
    StorageVirtualMachineId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fsx(
        "UpdateStorageVirtualMachine",
        Dict{String,Any}(
            "StorageVirtualMachineId" => StorageVirtualMachineId,
            "ClientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_storage_virtual_machine(
    StorageVirtualMachineId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fsx(
        "UpdateStorageVirtualMachine",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "StorageVirtualMachineId" => StorageVirtualMachineId,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_volume(volume_id)
    update_volume(volume_id, params::Dict{String,<:Any})

Updates the configuration of an Amazon FSx for NetApp ONTAP or Amazon FSx for OpenZFS
volume.

# Arguments
- `volume_id`: The ID of the volume that you want to update, in the format
  fsvol-0123456789abcdef0.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`:
- `"Name"`: The name of the OpenZFS volume. OpenZFS root volumes are automatically named
  FSX. Child volume names must be unique among their parent volume's children. The name of
  the volume is part of the mount string for the OpenZFS volume.
- `"OntapConfiguration"`: The configuration of the ONTAP volume that you are updating.
- `"OpenZFSConfiguration"`: The configuration of the OpenZFS volume that you are updating.
"""
function update_volume(VolumeId; aws_config::AbstractAWSConfig=current_aws_config())
    return fsx(
        "UpdateVolume",
        Dict{String,Any}("VolumeId" => VolumeId, "ClientRequestToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_volume(
    VolumeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fsx(
        "UpdateVolume",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "VolumeId" => VolumeId, "ClientRequestToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: iot_jobs_data_plane
using AWS.Compat
using AWS.UUIDs

"""
    describe_job_execution(job_id, thing_name)
    describe_job_execution(job_id, thing_name, params::Dict{String,<:Any})

Gets details of a job execution.

# Arguments
- `job_id`: The unique identifier assigned to this job when it was created.
- `thing_name`: The thing name associated with the device the job execution is running on.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"executionNumber"`: Optional. A number that identifies a particular job execution on a
  particular device. If not specified, the latest job execution is returned.
- `"includeJobDocument"`: Optional. When set to true, the response contains the job
  document. The default is false.
"""
function describe_job_execution(
    jobId, thingName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_jobs_data_plane(
        "GET",
        "/things/$(thingName)/jobs/$(jobId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_job_execution(
    jobId,
    thingName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_jobs_data_plane(
        "GET",
        "/things/$(thingName)/jobs/$(jobId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_pending_job_executions(thing_name)
    get_pending_job_executions(thing_name, params::Dict{String,<:Any})

Gets the list of all jobs for a thing that are not in a terminal status.

# Arguments
- `thing_name`: The name of the thing that is executing the job.

"""
function get_pending_job_executions(
    thingName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_jobs_data_plane(
        "GET",
        "/things/$(thingName)/jobs";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_pending_job_executions(
    thingName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_jobs_data_plane(
        "GET",
        "/things/$(thingName)/jobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_next_pending_job_execution(thing_name)
    start_next_pending_job_execution(thing_name, params::Dict{String,<:Any})

Gets and starts the next pending (status IN_PROGRESS or QUEUED) job execution for a thing.

# Arguments
- `thing_name`: The name of the thing associated with the device.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"statusDetails"`: A collection of name/value pairs that describe the status of the job
  execution. If not specified, the statusDetails are unchanged.
- `"stepTimeoutInMinutes"`: Specifies the amount of time this device has to finish
  execution of this job. If the job execution status is not set to a terminal state before
  this timer expires, or before the timer is reset (by calling UpdateJobExecution, setting
  the status to IN_PROGRESS and specifying a new timeout value in field stepTimeoutInMinutes)
  the job execution status will be automatically set to TIMED_OUT. Note that setting this
  timeout has no effect on that job execution timeout which may have been specified when the
  job was created (CreateJob using field timeoutConfig).
"""
function start_next_pending_job_execution(
    thingName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_jobs_data_plane(
        "PUT",
        "/things/$(thingName)/jobs/$next";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_next_pending_job_execution(
    thingName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_jobs_data_plane(
        "PUT",
        "/things/$(thingName)/jobs/$next",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_job_execution(job_id, status, thing_name)
    update_job_execution(job_id, status, thing_name, params::Dict{String,<:Any})

Updates the status of a job execution.

# Arguments
- `job_id`: The unique identifier assigned to this job when it was created.
- `status`: The new status for the job execution (IN_PROGRESS, FAILED, SUCCESS, or
  REJECTED). This must be specified on every update.
- `thing_name`: The name of the thing associated with the device.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"executionNumber"`: Optional. A number that identifies a particular job execution on a
  particular device.
- `"expectedVersion"`: Optional. The expected current version of the job execution. Each
  time you update the job execution, its version is incremented. If the version of the job
  execution stored in Jobs does not match, the update is rejected with a VersionMismatch
  error, and an ErrorResponse that contains the current job execution status data is
  returned. (This makes it unnecessary to perform a separate DescribeJobExecution request in
  order to obtain the job execution status data.)
- `"includeJobDocument"`: Optional. When set to true, the response contains the job
  document. The default is false.
- `"includeJobExecutionState"`: Optional. When included and set to true, the response
  contains the JobExecutionState data. The default is false.
- `"statusDetails"`:  Optional. A collection of name/value pairs that describe the status
  of the job execution. If not specified, the statusDetails are unchanged.
- `"stepTimeoutInMinutes"`: Specifies the amount of time this device has to finish
  execution of this job. If the job execution status is not set to a terminal state before
  this timer expires, or before the timer is reset (by again calling UpdateJobExecution,
  setting the status to IN_PROGRESS and specifying a new timeout value in this field) the job
  execution status will be automatically set to TIMED_OUT. Note that setting or resetting
  this timeout has no effect on that job execution timeout which may have been specified when
  the job was created (CreateJob using field timeoutConfig).
"""
function update_job_execution(
    jobId, status, thingName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_jobs_data_plane(
        "POST",
        "/things/$(thingName)/jobs/$(jobId)",
        Dict{String,Any}("status" => status);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_job_execution(
    jobId,
    status,
    thingName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_jobs_data_plane(
        "POST",
        "/things/$(thingName)/jobs/$(jobId)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("status" => status), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: polly
using AWS.Compat
using AWS.UUIDs

"""
    delete_lexicon(lexicon_name)
    delete_lexicon(lexicon_name, params::Dict{String,<:Any})

Deletes the specified pronunciation lexicon stored in an Amazon Web Services Region. A
lexicon which has been deleted is not available for speech synthesis, nor is it possible to
retrieve it using either the GetLexicon or ListLexicon APIs. For more information, see
Managing Lexicons.

# Arguments
- `lexicon_name`: The name of the lexicon to delete. Must be an existing lexicon in the
  region.

"""
function delete_lexicon(LexiconName; aws_config::AbstractAWSConfig=current_aws_config())
    return polly(
        "DELETE",
        "/v1/lexicons/$(LexiconName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_lexicon(
    LexiconName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return polly(
        "DELETE",
        "/v1/lexicons/$(LexiconName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_voices()
    describe_voices(params::Dict{String,<:Any})

Returns the list of voices that are available for use when requesting speech synthesis.
Each voice speaks a specified language, is either male or female, and is identified by an
ID, which is the ASCII version of the voice name.  When synthesizing speech (
SynthesizeSpeech ), you provide the voice ID for the voice you want from the list of voices
returned by DescribeVoices. For example, you want your news reader application to read news
in a specific language, but giving a user the option to choose the voice. Using the
DescribeVoices operation you can provide the user with a list of available voices to select
from.  You can optionally specify a language code to filter the available voices. For
example, if you specify en-US, the operation returns a list of all available US English
voices.  This operation requires permissions to perform the polly:DescribeVoices action.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Engine"`: Specifies the engine (standard, neural, long-form or generative) used by
  Amazon Polly when processing input text for speech synthesis.
- `"IncludeAdditionalLanguageCodes"`: Boolean value indicating whether to return any
  bilingual voices that use the specified language as an additional language. For instance,
  if you request all languages that use US English (es-US), and there is an Italian voice
  that speaks both Italian (it-IT) and US English, that voice will be included if you specify
  yes but not if you specify no.
- `"LanguageCode"`:  The language identification tag (ISO 639 code for the language
  name-ISO 3166 country code) for filtering the list of voices returned. If you don't specify
  this optional parameter, all available voices are returned.
- `"NextToken"`: An opaque pagination token returned from the previous DescribeVoices
  operation. If present, this indicates where to continue the listing.
"""
function describe_voices(; aws_config::AbstractAWSConfig=current_aws_config())
    return polly(
        "GET", "/v1/voices"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_voices(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return polly(
        "GET", "/v1/voices", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_lexicon(lexicon_name)
    get_lexicon(lexicon_name, params::Dict{String,<:Any})

Returns the content of the specified pronunciation lexicon stored in an Amazon Web Services
Region. For more information, see Managing Lexicons.

# Arguments
- `lexicon_name`: Name of the lexicon.

"""
function get_lexicon(LexiconName; aws_config::AbstractAWSConfig=current_aws_config())
    return polly(
        "GET",
        "/v1/lexicons/$(LexiconName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_lexicon(
    LexiconName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return polly(
        "GET",
        "/v1/lexicons/$(LexiconName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_speech_synthesis_task(task_id)
    get_speech_synthesis_task(task_id, params::Dict{String,<:Any})

Retrieves a specific SpeechSynthesisTask object based on its TaskID. This object contains
information about the given speech synthesis task, including the status of the task, and a
link to the S3 bucket containing the output of the task.

# Arguments
- `task_id`: The Amazon Polly generated identifier for a speech synthesis task.

"""
function get_speech_synthesis_task(
    TaskId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return polly(
        "GET",
        "/v1/synthesisTasks/$(TaskId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_speech_synthesis_task(
    TaskId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return polly(
        "GET",
        "/v1/synthesisTasks/$(TaskId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_lexicons()
    list_lexicons(params::Dict{String,<:Any})

Returns a list of pronunciation lexicons stored in an Amazon Web Services Region. For more
information, see Managing Lexicons.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: An opaque pagination token returned from previous ListLexicons operation.
  If present, indicates where to continue the list of lexicons.
"""
function list_lexicons(; aws_config::AbstractAWSConfig=current_aws_config())
    return polly(
        "GET", "/v1/lexicons"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_lexicons(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return polly(
        "GET",
        "/v1/lexicons",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_speech_synthesis_tasks()
    list_speech_synthesis_tasks(params::Dict{String,<:Any})

Returns a list of SpeechSynthesisTask objects ordered by their creation date. This
operation can filter the tasks by their status, for example, allowing users to list only
tasks that are completed.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Maximum number of speech synthesis tasks returned in a List operation.
- `"NextToken"`: The pagination token to use in the next request to continue the listing of
  speech synthesis tasks.
- `"Status"`: Status of the speech synthesis tasks returned in a List operation
"""
function list_speech_synthesis_tasks(; aws_config::AbstractAWSConfig=current_aws_config())
    return polly(
        "GET", "/v1/synthesisTasks"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_speech_synthesis_tasks(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return polly(
        "GET",
        "/v1/synthesisTasks",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_lexicon(content, lexicon_name)
    put_lexicon(content, lexicon_name, params::Dict{String,<:Any})

Stores a pronunciation lexicon in an Amazon Web Services Region. If a lexicon with the same
name already exists in the region, it is overwritten by the new lexicon. Lexicon operations
have eventual consistency, therefore, it might take some time before the lexicon is
available to the SynthesizeSpeech operation. For more information, see Managing Lexicons.

# Arguments
- `content`: Content of the PLS lexicon as string data.
- `lexicon_name`: Name of the lexicon. The name must follow the regular express format
  [0-9A-Za-z]{1,20}. That is, the name is a case-sensitive alphanumeric string up to 20
  characters long.

"""
function put_lexicon(
    Content, LexiconName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return polly(
        "PUT",
        "/v1/lexicons/$(LexiconName)",
        Dict{String,Any}("Content" => Content);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_lexicon(
    Content,
    LexiconName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return polly(
        "PUT",
        "/v1/lexicons/$(LexiconName)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Content" => Content), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_speech_synthesis_task(output_format, output_s3_bucket_name, text, voice_id)
    start_speech_synthesis_task(output_format, output_s3_bucket_name, text, voice_id, params::Dict{String,<:Any})

Allows the creation of an asynchronous synthesis task, by starting a new
SpeechSynthesisTask. This operation requires all the standard information needed for speech
synthesis, plus the name of an Amazon S3 bucket for the service to store the output of the
synthesis task and two optional parameters (OutputS3KeyPrefix and SnsTopicArn). Once the
synthesis task is created, this operation will return a SpeechSynthesisTask object, which
will include an identifier of this task as well as the current status. The
SpeechSynthesisTask object is available for 72 hours after starting the asynchronous
synthesis task.

# Arguments
- `output_format`: The format in which the returned output will be encoded. For audio
  stream, this will be mp3, ogg_vorbis, or pcm. For speech marks, this will be json.
- `output_s3_bucket_name`: Amazon S3 bucket name to which the output file will be saved.
- `text`: The input text to synthesize. If you specify ssml as the TextType, follow the
  SSML format for the input text.
- `voice_id`: Voice ID to use for the synthesis.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Engine"`: Specifies the engine (standard, neural, long-form or generative) for Amazon
  Polly to use when processing input text for speech synthesis. Using a voice that is not
  supported for the engine selected will result in an error.
- `"LanguageCode"`: Optional language code for the Speech Synthesis request. This is only
  necessary if using a bilingual voice, such as Aditi, which can be used for either Indian
  English (en-IN) or Hindi (hi-IN).  If a bilingual voice is used and no language code is
  specified, Amazon Polly uses the default language of the bilingual voice. The default
  language for any voice is the one returned by the DescribeVoices operation for the
  LanguageCode parameter. For example, if no language code is specified, Aditi will use
  Indian English rather than Hindi.
- `"LexiconNames"`: List of one or more pronunciation lexicon names you want the service to
  apply during synthesis. Lexicons are applied only if the language of the lexicon is the
  same as the language of the voice.
- `"OutputS3KeyPrefix"`: The Amazon S3 key prefix for the output speech file.
- `"SampleRate"`: The audio frequency specified in Hz. The valid values for mp3 and
  ogg_vorbis are \"8000\", \"16000\", \"22050\", and \"24000\". The default value for
  standard voices is \"22050\". The default value for neural voices is \"24000\". The default
  value for long-form voices is \"24000\". The default value for generative voices is
  \"24000\". Valid values for pcm are \"8000\" and \"16000\" The default value is \"16000\".
- `"SnsTopicArn"`: ARN for the SNS topic optionally used for providing status notification
  for a speech synthesis task.
- `"SpeechMarkTypes"`: The type of speech marks returned for the input text.
- `"TextType"`: Specifies whether the input text is plain text or SSML. The default value
  is plain text.
"""
function start_speech_synthesis_task(
    OutputFormat,
    OutputS3BucketName,
    Text,
    VoiceId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return polly(
        "POST",
        "/v1/synthesisTasks",
        Dict{String,Any}(
            "OutputFormat" => OutputFormat,
            "OutputS3BucketName" => OutputS3BucketName,
            "Text" => Text,
            "VoiceId" => VoiceId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_speech_synthesis_task(
    OutputFormat,
    OutputS3BucketName,
    Text,
    VoiceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return polly(
        "POST",
        "/v1/synthesisTasks",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "OutputFormat" => OutputFormat,
                    "OutputS3BucketName" => OutputS3BucketName,
                    "Text" => Text,
                    "VoiceId" => VoiceId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    synthesize_speech(output_format, text, voice_id)
    synthesize_speech(output_format, text, voice_id, params::Dict{String,<:Any})

Synthesizes UTF-8 input, plain text or SSML, to a stream of bytes. SSML input must be
valid, well-formed SSML. Some alphabets might not be available with all the voices (for
example, Cyrillic might not be read at all by English voices) unless phoneme mapping is
used. For more information, see How it Works.

# Arguments
- `output_format`:  The format in which the returned output will be encoded. For audio
  stream, this will be mp3, ogg_vorbis, or pcm. For speech marks, this will be json.  When
  pcm is used, the content returned is audio/pcm in a signed 16-bit, 1 channel (mono),
  little-endian format.
- `text`:  Input text to synthesize. If you specify ssml as the TextType, follow the SSML
  format for the input text.
- `voice_id`:  Voice ID to use for the synthesis. You can get a list of available voice IDs
  by calling the DescribeVoices operation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Engine"`: Specifies the engine (standard, neural, long-form, or generative) for Amazon
  Polly to use when processing input text for speech synthesis. Provide an engine that is
  supported by the voice you select. If you don't provide an engine, the standard engine is
  selected by default. If a chosen voice isn't supported by the standard engine, this will
  result in an error. For information on Amazon Polly voices and which voices are available
  for each engine, see Available Voices. Type: String Valid Values: standard | neural |
  long-form | generative  Required: Yes
- `"LanguageCode"`: Optional language code for the Synthesize Speech request. This is only
  necessary if using a bilingual voice, such as Aditi, which can be used for either Indian
  English (en-IN) or Hindi (hi-IN).  If a bilingual voice is used and no language code is
  specified, Amazon Polly uses the default language of the bilingual voice. The default
  language for any voice is the one returned by the DescribeVoices operation for the
  LanguageCode parameter. For example, if no language code is specified, Aditi will use
  Indian English rather than Hindi.
- `"LexiconNames"`: List of one or more pronunciation lexicon names you want the service to
  apply during synthesis. Lexicons are applied only if the language of the lexicon is the
  same as the language of the voice. For information about storing lexicons, see PutLexicon.
- `"SampleRate"`: The audio frequency specified in Hz. The valid values for mp3 and
  ogg_vorbis are \"8000\", \"16000\", \"22050\", and \"24000\". The default value for
  standard voices is \"22050\". The default value for neural voices is \"24000\". The default
  value for long-form voices is \"24000\". The default value for generative voices is
  \"24000\". Valid values for pcm are \"8000\" and \"16000\" The default value is \"16000\".
- `"SpeechMarkTypes"`: The type of speech marks returned for the input text.
- `"TextType"`:  Specifies whether the input text is plain text or SSML. The default value
  is plain text. For more information, see Using SSML.
"""
function synthesize_speech(
    OutputFormat, Text, VoiceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return polly(
        "POST",
        "/v1/speech",
        Dict{String,Any}(
            "OutputFormat" => OutputFormat, "Text" => Text, "VoiceId" => VoiceId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function synthesize_speech(
    OutputFormat,
    Text,
    VoiceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return polly(
        "POST",
        "/v1/speech",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "OutputFormat" => OutputFormat, "Text" => Text, "VoiceId" => VoiceId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: iotfleetwise
using AWS.Compat
using AWS.UUIDs

"""
    associate_vehicle_fleet(fleet_id, vehicle_name)
    associate_vehicle_fleet(fleet_id, vehicle_name, params::Dict{String,<:Any})

 Adds, or associates, a vehicle with a fleet.

# Arguments
- `fleet_id`:  The ID of a fleet.
- `vehicle_name`:  The unique ID of the vehicle to associate with the fleet.

"""
function associate_vehicle_fleet(
    fleetId, vehicleName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotfleetwise(
        "AssociateVehicleFleet",
        Dict{String,Any}("fleetId" => fleetId, "vehicleName" => vehicleName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_vehicle_fleet(
    fleetId,
    vehicleName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotfleetwise(
        "AssociateVehicleFleet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("fleetId" => fleetId, "vehicleName" => vehicleName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_create_vehicle(vehicles)
    batch_create_vehicle(vehicles, params::Dict{String,<:Any})

 Creates a group, or batch, of vehicles.    You must specify a decoder manifest and a
vehicle model (model manifest) for each vehicle.   For more information, see Create
multiple vehicles (AWS CLI) in the Amazon Web Services IoT FleetWise Developer Guide.

# Arguments
- `vehicles`:  A list of information about each vehicle to create. For more information,
  see the API data type.

"""
function batch_create_vehicle(vehicles; aws_config::AbstractAWSConfig=current_aws_config())
    return iotfleetwise(
        "BatchCreateVehicle",
        Dict{String,Any}("vehicles" => vehicles);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_create_vehicle(
    vehicles,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotfleetwise(
        "BatchCreateVehicle",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("vehicles" => vehicles), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_update_vehicle(vehicles)
    batch_update_vehicle(vehicles, params::Dict{String,<:Any})

 Updates a group, or batch, of vehicles.   You must specify a decoder manifest and a
vehicle model (model manifest) for each vehicle.   For more information, see Update
multiple vehicles (AWS CLI) in the Amazon Web Services IoT FleetWise Developer Guide.

# Arguments
- `vehicles`:  A list of information about the vehicles to update. For more information,
  see the API data type.

"""
function batch_update_vehicle(vehicles; aws_config::AbstractAWSConfig=current_aws_config())
    return iotfleetwise(
        "BatchUpdateVehicle",
        Dict{String,Any}("vehicles" => vehicles);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_update_vehicle(
    vehicles,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotfleetwise(
        "BatchUpdateVehicle",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("vehicles" => vehicles), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_campaign(collection_scheme, name, signal_catalog_arn, target_arn)
    create_campaign(collection_scheme, name, signal_catalog_arn, target_arn, params::Dict{String,<:Any})

Creates an orchestration of data collection rules. The Amazon Web Services IoT FleetWise
Edge Agent software running in vehicles uses campaigns to decide how to collect and
transfer data to the cloud. You create campaigns in the cloud. After you or your team
approve campaigns, Amazon Web Services IoT FleetWise automatically deploys them to
vehicles.  For more information, see Collect and transfer data with campaigns in the Amazon
Web Services IoT FleetWise Developer Guide.

# Arguments
- `collection_scheme`:  The data collection scheme associated with the campaign. You can
  specify a scheme that collects data based on time or an event.
- `name`:  The name of the campaign to create.
- `signal_catalog_arn`: The Amazon Resource Name (ARN) of the signal catalog to associate
  with the campaign.
- `target_arn`:  The ARN of the vehicle or fleet to deploy a campaign to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"compression"`:  (Optional) Whether to compress signals before transmitting data to
  Amazon Web Services IoT FleetWise. If you don't want to compress the signals, use OFF. If
  it's not specified, SNAPPY is used.  Default: SNAPPY
- `"dataDestinationConfigs"`: The destination where the campaign sends data. You can choose
  to send data to be stored in Amazon S3 or Amazon Timestream. Amazon S3 optimizes the cost
  of data storage and provides additional mechanisms to use vehicle data, such as data lakes,
  centralized data storage, data processing pipelines, and analytics. Amazon Web Services IoT
  FleetWise supports at-least-once file delivery to S3. Your vehicle data is stored on
  multiple Amazon Web Services IoT FleetWise servers for redundancy and high availability.
  You can use Amazon Timestream to access and analyze time series data, and Timestream to
  query vehicle data so that you can identify trends and patterns.
- `"dataExtraDimensions"`:  (Optional) A list of vehicle attributes to associate with a
  campaign.  Enrich the data with specified vehicle attributes. For example, add make and
  model to the campaign, and Amazon Web Services IoT FleetWise will associate the data with
  those attributes as dimensions in Amazon Timestream. You can then query the data against
  make and model. Default: An empty array
- `"description"`: An optional description of the campaign to help identify its purpose.
- `"diagnosticsMode"`:  (Optional) Option for a vehicle to send diagnostic trouble codes to
  Amazon Web Services IoT FleetWise. If you want to send diagnostic trouble codes, use
  SEND_ACTIVE_DTCS. If it's not specified, OFF is used. Default: OFF
- `"expiryTime"`:  (Optional) The time the campaign expires, in seconds since epoch
  (January 1, 1970 at midnight UTC time). Vehicle data isn't collected after the campaign
  expires.  Default: 253402214400 (December 31, 9999, 00:00:00 UTC)
- `"postTriggerCollectionDuration"`:  (Optional) How long (in milliseconds) to collect raw
  data after a triggering event initiates the collection. If it's not specified, 0 is used.
  Default: 0
- `"priority"`: (Optional) A number indicating the priority of one campaign over another
  campaign for a certain vehicle or fleet. A campaign with the lowest value is deployed to
  vehicles before any other campaigns. If it's not specified, 0 is used.  Default: 0
- `"signalsToCollect"`: (Optional) A list of information about signals to collect.
- `"spoolingMode"`: (Optional) Whether to store collected data after a vehicle lost a
  connection with the cloud. After a connection is re-established, the data is automatically
  forwarded to Amazon Web Services IoT FleetWise. If you want to store collected data when a
  vehicle loses connection with the cloud, use TO_DISK. If it's not specified, OFF is used.
  Default: OFF
- `"startTime"`: (Optional) The time, in milliseconds, to deliver a campaign after it was
  approved. If it's not specified, 0 is used. Default: 0
- `"tags"`: Metadata that can be used to manage the campaign.
"""
function create_campaign(
    collectionScheme,
    name,
    signalCatalogArn,
    targetArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotfleetwise(
        "CreateCampaign",
        Dict{String,Any}(
            "collectionScheme" => collectionScheme,
            "name" => name,
            "signalCatalogArn" => signalCatalogArn,
            "targetArn" => targetArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_campaign(
    collectionScheme,
    name,
    signalCatalogArn,
    targetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotfleetwise(
        "CreateCampaign",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "collectionScheme" => collectionScheme,
                    "name" => name,
                    "signalCatalogArn" => signalCatalogArn,
                    "targetArn" => targetArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_decoder_manifest(model_manifest_arn, name)
    create_decoder_manifest(model_manifest_arn, name, params::Dict{String,<:Any})

Creates the decoder manifest associated with a model manifest. To create a decoder
manifest, the following must be true:   Every signal decoder has a unique name.   Each
signal decoder is associated with a network interface.   Each network interface has a
unique ID.   The signal decoders are specified in the model manifest.

# Arguments
- `model_manifest_arn`:  The Amazon Resource Name (ARN) of the vehicle model (model
  manifest).
- `name`:  The unique name of the decoder manifest to create.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`:  A brief description of the decoder manifest.
- `"networkInterfaces"`:  A list of information about available network interfaces.
- `"signalDecoders"`:  A list of information about signal decoders.
- `"tags"`: Metadata that can be used to manage the decoder manifest.
"""
function create_decoder_manifest(
    modelManifestArn, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotfleetwise(
        "CreateDecoderManifest",
        Dict{String,Any}("modelManifestArn" => modelManifestArn, "name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_decoder_manifest(
    modelManifestArn,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotfleetwise(
        "CreateDecoderManifest",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("modelManifestArn" => modelManifestArn, "name" => name),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_fleet(fleet_id, signal_catalog_arn)
    create_fleet(fleet_id, signal_catalog_arn, params::Dict{String,<:Any})

 Creates a fleet that represents a group of vehicles.   You must create both a signal
catalog and vehicles before you can create a fleet.   For more information, see Fleets in
the Amazon Web Services IoT FleetWise Developer Guide.

# Arguments
- `fleet_id`:  The unique ID of the fleet to create.
- `signal_catalog_arn`:  The Amazon Resource Name (ARN) of a signal catalog.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`:  A brief description of the fleet to create.
- `"tags"`: Metadata that can be used to manage the fleet.
"""
function create_fleet(
    fleetId, signalCatalogArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotfleetwise(
        "CreateFleet",
        Dict{String,Any}("fleetId" => fleetId, "signalCatalogArn" => signalCatalogArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_fleet(
    fleetId,
    signalCatalogArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotfleetwise(
        "CreateFleet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "fleetId" => fleetId, "signalCatalogArn" => signalCatalogArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_model_manifest(name, nodes, signal_catalog_arn)
    create_model_manifest(name, nodes, signal_catalog_arn, params::Dict{String,<:Any})

 Creates a vehicle model (model manifest) that specifies signals (attributes, branches,
sensors, and actuators).  For more information, see Vehicle models in the Amazon Web
Services IoT FleetWise Developer Guide.

# Arguments
- `name`:  The name of the vehicle model to create.
- `nodes`:  A list of nodes, which are a general abstraction of signals.
- `signal_catalog_arn`:  The Amazon Resource Name (ARN) of a signal catalog.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`:  A brief description of the vehicle model.
- `"tags"`: Metadata that can be used to manage the vehicle model.
"""
function create_model_manifest(
    name, nodes, signalCatalogArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotfleetwise(
        "CreateModelManifest",
        Dict{String,Any}(
            "name" => name, "nodes" => nodes, "signalCatalogArn" => signalCatalogArn
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_model_manifest(
    name,
    nodes,
    signalCatalogArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotfleetwise(
        "CreateModelManifest",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "name" => name, "nodes" => nodes, "signalCatalogArn" => signalCatalogArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_signal_catalog(name)
    create_signal_catalog(name, params::Dict{String,<:Any})

 Creates a collection of standardized signals that can be reused to create vehicle models.

# Arguments
- `name`:  The name of the signal catalog to create.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A brief description of the signal catalog.
- `"nodes"`:  A list of information about nodes, which are a general abstraction of
  signals. For more information, see the API data type.
- `"tags"`: Metadata that can be used to manage the signal catalog.
"""
function create_signal_catalog(name; aws_config::AbstractAWSConfig=current_aws_config())
    return iotfleetwise(
        "CreateSignalCatalog",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_signal_catalog(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotfleetwise(
        "CreateSignalCatalog",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_vehicle(decoder_manifest_arn, model_manifest_arn, vehicle_name)
    create_vehicle(decoder_manifest_arn, model_manifest_arn, vehicle_name, params::Dict{String,<:Any})

 Creates a vehicle, which is an instance of a vehicle model (model manifest). Vehicles
created from the same vehicle model consist of the same signals inherited from the vehicle
model.   If you have an existing Amazon Web Services IoT thing, you can use Amazon Web
Services IoT FleetWise to create a vehicle and collect data from your thing.   For more
information, see Create a vehicle (AWS CLI) in the Amazon Web Services IoT FleetWise
Developer Guide.

# Arguments
- `decoder_manifest_arn`:  The ARN of a decoder manifest.
- `model_manifest_arn`:  The Amazon Resource Name ARN of a vehicle model.
- `vehicle_name`:  The unique ID of the vehicle to create.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"associationBehavior"`:  An option to create a new Amazon Web Services IoT thing when
  creating a vehicle, or to validate an existing Amazon Web Services IoT thing as a vehicle.
  Default:
- `"attributes"`: Static information about a vehicle in a key-value pair. For example:
  \"engineType\" : \"1.3 L R2\"  A campaign must include the keys (attribute names) in
  dataExtraDimensions for them to display in Amazon Timestream.
- `"tags"`: Metadata that can be used to manage the vehicle.
"""
function create_vehicle(
    decoderManifestArn,
    modelManifestArn,
    vehicleName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotfleetwise(
        "CreateVehicle",
        Dict{String,Any}(
            "decoderManifestArn" => decoderManifestArn,
            "modelManifestArn" => modelManifestArn,
            "vehicleName" => vehicleName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_vehicle(
    decoderManifestArn,
    modelManifestArn,
    vehicleName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotfleetwise(
        "CreateVehicle",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "decoderManifestArn" => decoderManifestArn,
                    "modelManifestArn" => modelManifestArn,
                    "vehicleName" => vehicleName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_campaign(name)
    delete_campaign(name, params::Dict{String,<:Any})

 Deletes a data collection campaign. Deleting a campaign suspends all data collection and
removes it from any vehicles.

# Arguments
- `name`:  The name of the campaign to delete.

"""
function delete_campaign(name; aws_config::AbstractAWSConfig=current_aws_config())
    return iotfleetwise(
        "DeleteCampaign",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_campaign(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotfleetwise(
        "DeleteCampaign",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_decoder_manifest(name)
    delete_decoder_manifest(name, params::Dict{String,<:Any})

 Deletes a decoder manifest. You can't delete a decoder manifest if it has vehicles
associated with it.   If the decoder manifest is successfully deleted, Amazon Web Services
IoT FleetWise sends back an HTTP 200 response with an empty body.

# Arguments
- `name`:  The name of the decoder manifest to delete.

"""
function delete_decoder_manifest(name; aws_config::AbstractAWSConfig=current_aws_config())
    return iotfleetwise(
        "DeleteDecoderManifest",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_decoder_manifest(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotfleetwise(
        "DeleteDecoderManifest",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_fleet(fleet_id)
    delete_fleet(fleet_id, params::Dict{String,<:Any})

 Deletes a fleet. Before you delete a fleet, all vehicles must be dissociated from the
fleet. For more information, see Delete a fleet (AWS CLI) in the Amazon Web Services IoT
FleetWise Developer Guide.  If the fleet is successfully deleted, Amazon Web Services IoT
FleetWise sends back an HTTP 200 response with an empty body.

# Arguments
- `fleet_id`:  The ID of the fleet to delete.

"""
function delete_fleet(fleetId; aws_config::AbstractAWSConfig=current_aws_config())
    return iotfleetwise(
        "DeleteFleet",
        Dict{String,Any}("fleetId" => fleetId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_fleet(
    fleetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotfleetwise(
        "DeleteFleet",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("fleetId" => fleetId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_model_manifest(name)
    delete_model_manifest(name, params::Dict{String,<:Any})

 Deletes a vehicle model (model manifest).  If the vehicle model is successfully deleted,
Amazon Web Services IoT FleetWise sends back an HTTP 200 response with an empty body.

# Arguments
- `name`:  The name of the model manifest to delete.

"""
function delete_model_manifest(name; aws_config::AbstractAWSConfig=current_aws_config())
    return iotfleetwise(
        "DeleteModelManifest",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_model_manifest(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotfleetwise(
        "DeleteModelManifest",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_signal_catalog(name)
    delete_signal_catalog(name, params::Dict{String,<:Any})

 Deletes a signal catalog.   If the signal catalog is successfully deleted, Amazon Web
Services IoT FleetWise sends back an HTTP 200 response with an empty body.

# Arguments
- `name`:  The name of the signal catalog to delete.

"""
function delete_signal_catalog(name; aws_config::AbstractAWSConfig=current_aws_config())
    return iotfleetwise(
        "DeleteSignalCatalog",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_signal_catalog(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotfleetwise(
        "DeleteSignalCatalog",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_vehicle(vehicle_name)
    delete_vehicle(vehicle_name, params::Dict{String,<:Any})

 Deletes a vehicle and removes it from any campaigns.  If the vehicle is successfully
deleted, Amazon Web Services IoT FleetWise sends back an HTTP 200 response with an empty
body.

# Arguments
- `vehicle_name`: The ID of the vehicle to delete.

"""
function delete_vehicle(vehicleName; aws_config::AbstractAWSConfig=current_aws_config())
    return iotfleetwise(
        "DeleteVehicle",
        Dict{String,Any}("vehicleName" => vehicleName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_vehicle(
    vehicleName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotfleetwise(
        "DeleteVehicle",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("vehicleName" => vehicleName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_vehicle_fleet(fleet_id, vehicle_name)
    disassociate_vehicle_fleet(fleet_id, vehicle_name, params::Dict{String,<:Any})

Removes, or disassociates, a vehicle from a fleet. Disassociating a vehicle from a fleet
doesn't delete the vehicle.  If the vehicle is successfully dissociated from a fleet,
Amazon Web Services IoT FleetWise sends back an HTTP 200 response with an empty body.

# Arguments
- `fleet_id`:  The unique ID of a fleet.
- `vehicle_name`:  The unique ID of the vehicle to disassociate from the fleet.

"""
function disassociate_vehicle_fleet(
    fleetId, vehicleName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotfleetwise(
        "DisassociateVehicleFleet",
        Dict{String,Any}("fleetId" => fleetId, "vehicleName" => vehicleName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_vehicle_fleet(
    fleetId,
    vehicleName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotfleetwise(
        "DisassociateVehicleFleet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("fleetId" => fleetId, "vehicleName" => vehicleName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_campaign(name)
    get_campaign(name, params::Dict{String,<:Any})

 Retrieves information about a campaign.

# Arguments
- `name`:  The name of the campaign to retrieve information about.

"""
function get_campaign(name; aws_config::AbstractAWSConfig=current_aws_config())
    return iotfleetwise(
        "GetCampaign",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_campaign(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotfleetwise(
        "GetCampaign",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_decoder_manifest(name)
    get_decoder_manifest(name, params::Dict{String,<:Any})

 Retrieves information about a created decoder manifest.

# Arguments
- `name`:  The name of the decoder manifest to retrieve information about.

"""
function get_decoder_manifest(name; aws_config::AbstractAWSConfig=current_aws_config())
    return iotfleetwise(
        "GetDecoderManifest",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_decoder_manifest(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotfleetwise(
        "GetDecoderManifest",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_encryption_configuration()
    get_encryption_configuration(params::Dict{String,<:Any})

Retrieves the encryption configuration for resources and data in Amazon Web Services IoT
FleetWise.

"""
function get_encryption_configuration(; aws_config::AbstractAWSConfig=current_aws_config())
    return iotfleetwise(
        "GetEncryptionConfiguration"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_encryption_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotfleetwise(
        "GetEncryptionConfiguration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_fleet(fleet_id)
    get_fleet(fleet_id, params::Dict{String,<:Any})

 Retrieves information about a fleet.

# Arguments
- `fleet_id`:  The ID of the fleet to retrieve information about.

"""
function get_fleet(fleetId; aws_config::AbstractAWSConfig=current_aws_config())
    return iotfleetwise(
        "GetFleet",
        Dict{String,Any}("fleetId" => fleetId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_fleet(
    fleetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotfleetwise(
        "GetFleet",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("fleetId" => fleetId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_logging_options()
    get_logging_options(params::Dict{String,<:Any})

Retrieves the logging options.

"""
function get_logging_options(; aws_config::AbstractAWSConfig=current_aws_config())
    return iotfleetwise(
        "GetLoggingOptions"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_logging_options(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotfleetwise(
        "GetLoggingOptions", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_model_manifest(name)
    get_model_manifest(name, params::Dict{String,<:Any})

 Retrieves information about a vehicle model (model manifest).

# Arguments
- `name`:  The name of the vehicle model to retrieve information about.

"""
function get_model_manifest(name; aws_config::AbstractAWSConfig=current_aws_config())
    return iotfleetwise(
        "GetModelManifest",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_model_manifest(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotfleetwise(
        "GetModelManifest",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_register_account_status()
    get_register_account_status(params::Dict{String,<:Any})

 Retrieves information about the status of registering your Amazon Web Services account,
IAM, and Amazon Timestream resources so that Amazon Web Services IoT FleetWise can transfer
your vehicle data to the Amazon Web Services Cloud.  For more information, including
step-by-step procedures, see Setting up Amazon Web Services IoT FleetWise.   This API
operation doesn't require input parameters.

"""
function get_register_account_status(; aws_config::AbstractAWSConfig=current_aws_config())
    return iotfleetwise(
        "GetRegisterAccountStatus"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_register_account_status(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotfleetwise(
        "GetRegisterAccountStatus",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_signal_catalog(name)
    get_signal_catalog(name, params::Dict{String,<:Any})

 Retrieves information about a signal catalog.

# Arguments
- `name`:  The name of the signal catalog to retrieve information about.

"""
function get_signal_catalog(name; aws_config::AbstractAWSConfig=current_aws_config())
    return iotfleetwise(
        "GetSignalCatalog",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_signal_catalog(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotfleetwise(
        "GetSignalCatalog",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_vehicle(vehicle_name)
    get_vehicle(vehicle_name, params::Dict{String,<:Any})

 Retrieves information about a vehicle.

# Arguments
- `vehicle_name`:  The ID of the vehicle to retrieve information about.

"""
function get_vehicle(vehicleName; aws_config::AbstractAWSConfig=current_aws_config())
    return iotfleetwise(
        "GetVehicle",
        Dict{String,Any}("vehicleName" => vehicleName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_vehicle(
    vehicleName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotfleetwise(
        "GetVehicle",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("vehicleName" => vehicleName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_vehicle_status(vehicle_name)
    get_vehicle_status(vehicle_name, params::Dict{String,<:Any})

 Retrieves information about the status of a vehicle with any associated campaigns.

# Arguments
- `vehicle_name`:  The ID of the vehicle to retrieve information about.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:  The maximum number of items to return, between 1 and 100, inclusive.
- `"nextToken"`: A pagination token for the next set of results. If the results of a search
  are large, only a portion of the results are returned, and a nextToken pagination token is
  returned in the response. To retrieve the next set of results, reissue the search request
  and include the returned token. When all results have been returned, the response does not
  contain a pagination token value.
"""
function get_vehicle_status(vehicleName; aws_config::AbstractAWSConfig=current_aws_config())
    return iotfleetwise(
        "GetVehicleStatus",
        Dict{String,Any}("vehicleName" => vehicleName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_vehicle_status(
    vehicleName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotfleetwise(
        "GetVehicleStatus",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("vehicleName" => vehicleName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    import_decoder_manifest(name, network_file_definitions)
    import_decoder_manifest(name, network_file_definitions, params::Dict{String,<:Any})

 Creates a decoder manifest using your existing CAN DBC file from your local device.

# Arguments
- `name`:  The name of the decoder manifest to import.
- `network_file_definitions`:  The file to load into an Amazon Web Services account.

"""
function import_decoder_manifest(
    name, networkFileDefinitions; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotfleetwise(
        "ImportDecoderManifest",
        Dict{String,Any}(
            "name" => name, "networkFileDefinitions" => networkFileDefinitions
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function import_decoder_manifest(
    name,
    networkFileDefinitions,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotfleetwise(
        "ImportDecoderManifest",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "name" => name, "networkFileDefinitions" => networkFileDefinitions
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    import_signal_catalog(name)
    import_signal_catalog(name, params::Dict{String,<:Any})

 Creates a signal catalog using your existing VSS formatted content from your local device.

# Arguments
- `name`: The name of the signal catalog to import.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`:  A brief description of the signal catalog.
- `"tags"`: Metadata that can be used to manage the signal catalog.
- `"vss"`: The contents of the Vehicle Signal Specification (VSS) configuration. VSS is a
  precise language used to describe and model signals in vehicle networks.
"""
function import_signal_catalog(name; aws_config::AbstractAWSConfig=current_aws_config())
    return iotfleetwise(
        "ImportSignalCatalog",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function import_signal_catalog(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotfleetwise(
        "ImportSignalCatalog",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_campaigns()
    list_campaigns(params::Dict{String,<:Any})

 Lists information about created campaigns.   This API operation uses pagination. Specify
the nextToken parameter in the request to return more results.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:  The maximum number of items to return, between 1 and 100, inclusive.
- `"nextToken"`: A pagination token for the next set of results. If the results of a search
  are large, only a portion of the results are returned, and a nextToken pagination token is
  returned in the response. To retrieve the next set of results, reissue the search request
  and include the returned token. When all results have been returned, the response does not
  contain a pagination token value.
- `"status"`: Optional parameter to filter the results by the status of each created
  campaign in your account. The status can be one of: CREATING, WAITING_FOR_APPROVAL,
  RUNNING, or SUSPENDED.
"""
function list_campaigns(; aws_config::AbstractAWSConfig=current_aws_config())
    return iotfleetwise(
        "ListCampaigns"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_campaigns(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotfleetwise(
        "ListCampaigns", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_decoder_manifest_network_interfaces(name)
    list_decoder_manifest_network_interfaces(name, params::Dict{String,<:Any})

 Lists the network interfaces specified in a decoder manifest.   This API operation uses
pagination. Specify the nextToken parameter in the request to return more results.

# Arguments
- `name`:  The name of the decoder manifest to list information about.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:  The maximum number of items to return, between 1 and 100, inclusive.
- `"nextToken"`: A pagination token for the next set of results. If the results of a search
  are large, only a portion of the results are returned, and a nextToken pagination token is
  returned in the response. To retrieve the next set of results, reissue the search request
  and include the returned token. When all results have been returned, the response does not
  contain a pagination token value.
"""
function list_decoder_manifest_network_interfaces(
    name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotfleetwise(
        "ListDecoderManifestNetworkInterfaces",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_decoder_manifest_network_interfaces(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotfleetwise(
        "ListDecoderManifestNetworkInterfaces",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_decoder_manifest_signals(name)
    list_decoder_manifest_signals(name, params::Dict{String,<:Any})

 A list of information about signal decoders specified in a decoder manifest.   This API
operation uses pagination. Specify the nextToken parameter in the request to return more
results.

# Arguments
- `name`:  The name of the decoder manifest to list information about.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:  The maximum number of items to return, between 1 and 100, inclusive.
- `"nextToken"`: A pagination token for the next set of results. If the results of a search
  are large, only a portion of the results are returned, and a nextToken pagination token is
  returned in the response. To retrieve the next set of results, reissue the search request
  and include the returned token. When all results have been returned, the response does not
  contain a pagination token value.
"""
function list_decoder_manifest_signals(
    name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotfleetwise(
        "ListDecoderManifestSignals",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_decoder_manifest_signals(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotfleetwise(
        "ListDecoderManifestSignals",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_decoder_manifests()
    list_decoder_manifests(params::Dict{String,<:Any})

 Lists decoder manifests.   This API operation uses pagination. Specify the nextToken
parameter in the request to return more results.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:  The maximum number of items to return, between 1 and 100, inclusive.
- `"modelManifestArn"`:  The Amazon Resource Name (ARN) of a vehicle model (model manifest)
  associated with the decoder manifest.
- `"nextToken"`: A pagination token for the next set of results. If the results of a search
  are large, only a portion of the results are returned, and a nextToken pagination token is
  returned in the response. To retrieve the next set of results, reissue the search request
  and include the returned token. When all results have been returned, the response does not
  contain a pagination token value.
"""
function list_decoder_manifests(; aws_config::AbstractAWSConfig=current_aws_config())
    return iotfleetwise(
        "ListDecoderManifests"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_decoder_manifests(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotfleetwise(
        "ListDecoderManifests",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_fleets()
    list_fleets(params::Dict{String,<:Any})

 Retrieves information for each created fleet in an Amazon Web Services account.   This API
operation uses pagination. Specify the nextToken parameter in the request to return more
results.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:  The maximum number of items to return, between 1 and 100, inclusive.
- `"nextToken"`: A pagination token for the next set of results. If the results of a search
  are large, only a portion of the results are returned, and a nextToken pagination token is
  returned in the response. To retrieve the next set of results, reissue the search request
  and include the returned token. When all results have been returned, the response does not
  contain a pagination token value.
"""
function list_fleets(; aws_config::AbstractAWSConfig=current_aws_config())
    return iotfleetwise(
        "ListFleets"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_fleets(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotfleetwise(
        "ListFleets", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_fleets_for_vehicle(vehicle_name)
    list_fleets_for_vehicle(vehicle_name, params::Dict{String,<:Any})

Retrieves a list of IDs for all fleets that the vehicle is associated with.  This API
operation uses pagination. Specify the nextToken parameter in the request to return more
results.

# Arguments
- `vehicle_name`:  The ID of the vehicle to retrieve information about.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:  The maximum number of items to return, between 1 and 100, inclusive.
- `"nextToken"`: A pagination token for the next set of results. If the results of a search
  are large, only a portion of the results are returned, and a nextToken pagination token is
  returned in the response. To retrieve the next set of results, reissue the search request
  and include the returned token. When all results have been returned, the response does not
  contain a pagination token value.
"""
function list_fleets_for_vehicle(
    vehicleName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotfleetwise(
        "ListFleetsForVehicle",
        Dict{String,Any}("vehicleName" => vehicleName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_fleets_for_vehicle(
    vehicleName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotfleetwise(
        "ListFleetsForVehicle",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("vehicleName" => vehicleName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_model_manifest_nodes(name)
    list_model_manifest_nodes(name, params::Dict{String,<:Any})

 Lists information about nodes specified in a vehicle model (model manifest).   This API
operation uses pagination. Specify the nextToken parameter in the request to return more
results.

# Arguments
- `name`:  The name of the vehicle model to list information about.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:  The maximum number of items to return, between 1 and 100, inclusive.
- `"nextToken"`: A pagination token for the next set of results. If the results of a search
  are large, only a portion of the results are returned, and a nextToken pagination token is
  returned in the response. To retrieve the next set of results, reissue the search request
  and include the returned token. When all results have been returned, the response does not
  contain a pagination token value.
"""
function list_model_manifest_nodes(name; aws_config::AbstractAWSConfig=current_aws_config())
    return iotfleetwise(
        "ListModelManifestNodes",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_model_manifest_nodes(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotfleetwise(
        "ListModelManifestNodes",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_model_manifests()
    list_model_manifests(params::Dict{String,<:Any})

 Retrieves a list of vehicle models (model manifests).   This API operation uses
pagination. Specify the nextToken parameter in the request to return more results.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:  The maximum number of items to return, between 1 and 100, inclusive.
- `"nextToken"`: A pagination token for the next set of results. If the results of a search
  are large, only a portion of the results are returned, and a nextToken pagination token is
  returned in the response. To retrieve the next set of results, reissue the search request
  and include the returned token. When all results have been returned, the response does not
  contain a pagination token value.
- `"signalCatalogArn"`:  The ARN of a signal catalog. If you specify a signal catalog, only
  the vehicle models associated with it are returned.
"""
function list_model_manifests(; aws_config::AbstractAWSConfig=current_aws_config())
    return iotfleetwise(
        "ListModelManifests"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_model_manifests(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotfleetwise(
        "ListModelManifests", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_signal_catalog_nodes(name)
    list_signal_catalog_nodes(name, params::Dict{String,<:Any})

 Lists of information about the signals (nodes) specified in a signal catalog.   This API
operation uses pagination. Specify the nextToken parameter in the request to return more
results.

# Arguments
- `name`:  The name of the signal catalog to list information about.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:  The maximum number of items to return, between 1 and 100, inclusive.
- `"nextToken"`: A pagination token for the next set of results. If the results of a search
  are large, only a portion of the results are returned, and a nextToken pagination token is
  returned in the response. To retrieve the next set of results, reissue the search request
  and include the returned token. When all results have been returned, the response does not
  contain a pagination token value.
- `"signalNodeType"`: The type of node in the signal catalog.
"""
function list_signal_catalog_nodes(name; aws_config::AbstractAWSConfig=current_aws_config())
    return iotfleetwise(
        "ListSignalCatalogNodes",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_signal_catalog_nodes(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotfleetwise(
        "ListSignalCatalogNodes",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_signal_catalogs()
    list_signal_catalogs(params::Dict{String,<:Any})

 Lists all the created signal catalogs in an Amazon Web Services account.  You can use to
list information about each signal (node) specified in a signal catalog.  This API
operation uses pagination. Specify the nextToken parameter in the request to return more
results.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:  The maximum number of items to return, between 1 and 100, inclusive.
- `"nextToken"`: A pagination token for the next set of results. If the results of a search
  are large, only a portion of the results are returned, and a nextToken pagination token is
  returned in the response. To retrieve the next set of results, reissue the search request
  and include the returned token. When all results have been returned, the response does not
  contain a pagination token value.
"""
function list_signal_catalogs(; aws_config::AbstractAWSConfig=current_aws_config())
    return iotfleetwise(
        "ListSignalCatalogs"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_signal_catalogs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotfleetwise(
        "ListSignalCatalogs", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists the tags (metadata) you have assigned to the resource.

# Arguments
- `resource_arn`: The ARN of the resource.

"""
function list_tags_for_resource(
    ResourceARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotfleetwise(
        "ListTagsForResource",
        Dict{String,Any}("ResourceARN" => ResourceARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotfleetwise(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceARN" => ResourceARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_vehicles()
    list_vehicles(params::Dict{String,<:Any})

 Retrieves a list of summaries of created vehicles.   This API operation uses pagination.
Specify the nextToken parameter in the request to return more results.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"attributeNames"`: The fully qualified names of the attributes. For example, the fully
  qualified name of an attribute might be Vehicle.Body.Engine.Type.
- `"attributeValues"`: Static information about a vehicle attribute value in string format.
  For example:  \"1.3 L R2\"
- `"maxResults"`:  The maximum number of items to return, between 1 and 100, inclusive.
- `"modelManifestArn"`:  The Amazon Resource Name (ARN) of a vehicle model (model
  manifest). You can use this optional parameter to list only the vehicles created from a
  certain vehicle model.
- `"nextToken"`: A pagination token for the next set of results. If the results of a search
  are large, only a portion of the results are returned, and a nextToken pagination token is
  returned in the response. To retrieve the next set of results, reissue the search request
  and include the returned token. When all results have been returned, the response does not
  contain a pagination token value.
"""
function list_vehicles(; aws_config::AbstractAWSConfig=current_aws_config())
    return iotfleetwise(
        "ListVehicles"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_vehicles(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotfleetwise(
        "ListVehicles", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_vehicles_in_fleet(fleet_id)
    list_vehicles_in_fleet(fleet_id, params::Dict{String,<:Any})

 Retrieves a list of summaries of all vehicles associated with a fleet.   This API
operation uses pagination. Specify the nextToken parameter in the request to return more
results.

# Arguments
- `fleet_id`:  The ID of a fleet.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:  The maximum number of items to return, between 1 and 100, inclusive.
- `"nextToken"`: A pagination token for the next set of results. If the results of a search
  are large, only a portion of the results are returned, and a nextToken pagination token is
  returned in the response. To retrieve the next set of results, reissue the search request
  and include the returned token. When all results have been returned, the response does not
  contain a pagination token value.
"""
function list_vehicles_in_fleet(fleetId; aws_config::AbstractAWSConfig=current_aws_config())
    return iotfleetwise(
        "ListVehiclesInFleet",
        Dict{String,Any}("fleetId" => fleetId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_vehicles_in_fleet(
    fleetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotfleetwise(
        "ListVehiclesInFleet",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("fleetId" => fleetId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_encryption_configuration(encryption_type)
    put_encryption_configuration(encryption_type, params::Dict{String,<:Any})

Creates or updates the encryption configuration. Amazon Web Services IoT FleetWise can
encrypt your data and resources using an Amazon Web Services managed key. Or, you can use a
KMS key that you own and manage. For more information, see Data encryption in the Amazon
Web Services IoT FleetWise Developer Guide.

# Arguments
- `encryption_type`: The type of encryption. Choose KMS_BASED_ENCRYPTION to use a KMS key
  or FLEETWISE_DEFAULT_ENCRYPTION to use an Amazon Web Services managed key.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"kmsKeyId"`: The ID of the KMS key that is used for encryption.
"""
function put_encryption_configuration(
    encryptionType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotfleetwise(
        "PutEncryptionConfiguration",
        Dict{String,Any}("encryptionType" => encryptionType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_encryption_configuration(
    encryptionType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotfleetwise(
        "PutEncryptionConfiguration",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("encryptionType" => encryptionType), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_logging_options(cloud_watch_log_delivery)
    put_logging_options(cloud_watch_log_delivery, params::Dict{String,<:Any})

Creates or updates the logging option.

# Arguments
- `cloud_watch_log_delivery`: Creates or updates the log delivery option to Amazon
  CloudWatch Logs.

"""
function put_logging_options(
    cloudWatchLogDelivery; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotfleetwise(
        "PutLoggingOptions",
        Dict{String,Any}("cloudWatchLogDelivery" => cloudWatchLogDelivery);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_logging_options(
    cloudWatchLogDelivery,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotfleetwise(
        "PutLoggingOptions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("cloudWatchLogDelivery" => cloudWatchLogDelivery),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    register_account()
    register_account(params::Dict{String,<:Any})

 This API operation contains deprecated parameters. Register your account again without the
Timestream resources parameter so that Amazon Web Services IoT FleetWise can remove the
Timestream metadata stored. You should then pass the data destination into the
CreateCampaign API operation. You must delete any existing campaigns that include an empty
data destination before you register your account again. For more information, see the
DeleteCampaign API operation. If you want to delete the Timestream inline policy from the
service-linked role, such as to mitigate an overly permissive policy, you must first delete
any existing campaigns. Then delete the service-linked role and register your account again
to enable CloudWatch metrics. For more information, see DeleteServiceLinkedRole in the
Identity and Access Management API Reference.  Registers your Amazon Web Services account,
IAM, and Amazon Timestream resources so Amazon Web Services IoT FleetWise can transfer your
vehicle data to the Amazon Web Services Cloud. For more information, including step-by-step
procedures, see Setting up Amazon Web Services IoT FleetWise.   An Amazon Web Services
account is not the same thing as a \"user.\" An Amazon Web Services user is an identity
that you create using Identity and Access Management (IAM) and takes the form of either an
IAM user or an IAM role, both with credentials. A single Amazon Web Services account can,
and typically does, contain many users and roles.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"iamResources"`: The IAM resource that allows Amazon Web Services IoT FleetWise to send
  data to Amazon Timestream.
- `"timestreamResources"`:
"""
function register_account(; aws_config::AbstractAWSConfig=current_aws_config())
    return iotfleetwise(
        "RegisterAccount"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function register_account(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotfleetwise(
        "RegisterAccount", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds to or modifies the tags of the given resource. Tags are metadata which can be used to
manage a resource.

# Arguments
- `resource_arn`: The ARN of the resource.
- `tags`: The new or modified tags for the resource.

"""
function tag_resource(ResourceARN, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return iotfleetwise(
        "TagResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceARN,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotfleetwise(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes the given tags (metadata) from the resource.

# Arguments
- `resource_arn`: The ARN of the resource.
- `tag_keys`: A list of the keys of the tags to be removed from the resource.

"""
function untag_resource(
    ResourceARN, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotfleetwise(
        "UntagResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceARN,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotfleetwise(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_campaign(action, name)
    update_campaign(action, name, params::Dict{String,<:Any})

 Updates a campaign.

# Arguments
- `action`:  Specifies how to update a campaign. The action can be one of the following:
  APPROVE - To approve delivering a data collection scheme to vehicles.     SUSPEND - To
  suspend collecting signal data. The campaign is deleted from vehicles and all vehicles in
  the suspended campaign will stop sending data.    RESUME - To reactivate the SUSPEND
  campaign. The campaign is redeployed to all vehicles and the vehicles will resume sending
  data.    UPDATE - To update a campaign.
- `name`:  The name of the campaign to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"dataExtraDimensions"`:  A list of vehicle attributes to associate with a signal.
  Default: An empty array
- `"description"`: The description of the campaign.
"""
function update_campaign(action, name; aws_config::AbstractAWSConfig=current_aws_config())
    return iotfleetwise(
        "UpdateCampaign",
        Dict{String,Any}("action" => action, "name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_campaign(
    action,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotfleetwise(
        "UpdateCampaign",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("action" => action, "name" => name), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_decoder_manifest(name)
    update_decoder_manifest(name, params::Dict{String,<:Any})

 Updates a decoder manifest. A decoder manifest can only be updated when the status is
DRAFT. Only ACTIVE decoder manifests can be associated with vehicles.

# Arguments
- `name`:  The name of the decoder manifest to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`:  A brief description of the decoder manifest to update.
- `"networkInterfacesToAdd"`:  A list of information about the network interfaces to add to
  the decoder manifest.
- `"networkInterfacesToRemove"`:  A list of network interfaces to remove from the decoder
  manifest.
- `"networkInterfacesToUpdate"`:  A list of information about the network interfaces to
  update in the decoder manifest.
- `"signalDecodersToAdd"`:  A list of information about decoding additional signals to add
  to the decoder manifest.
- `"signalDecodersToRemove"`:  A list of signal decoders to remove from the decoder
  manifest.
- `"signalDecodersToUpdate"`:  A list of updated information about decoding signals to
  update in the decoder manifest.
- `"status"`:  The state of the decoder manifest. If the status is ACTIVE, the decoder
  manifest can't be edited. If the status is DRAFT, you can edit the decoder manifest.
"""
function update_decoder_manifest(name; aws_config::AbstractAWSConfig=current_aws_config())
    return iotfleetwise(
        "UpdateDecoderManifest",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_decoder_manifest(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotfleetwise(
        "UpdateDecoderManifest",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_fleet(fleet_id)
    update_fleet(fleet_id, params::Dict{String,<:Any})

 Updates the description of an existing fleet.   If the fleet is successfully updated,
Amazon Web Services IoT FleetWise sends back an HTTP 200 response with an empty HTTP body.

# Arguments
- `fleet_id`:  The ID of the fleet to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`:  An updated description of the fleet.
"""
function update_fleet(fleetId; aws_config::AbstractAWSConfig=current_aws_config())
    return iotfleetwise(
        "UpdateFleet",
        Dict{String,Any}("fleetId" => fleetId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_fleet(
    fleetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotfleetwise(
        "UpdateFleet",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("fleetId" => fleetId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_model_manifest(name)
    update_model_manifest(name, params::Dict{String,<:Any})

 Updates a vehicle model (model manifest). If created vehicles are associated with a
vehicle model, it can't be updated.

# Arguments
- `name`:  The name of the vehicle model to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`:  A brief description of the vehicle model.
- `"nodesToAdd"`:  A list of fullyQualifiedName of nodes, which are a general abstraction
  of signals, to add to the vehicle model.
- `"nodesToRemove"`:  A list of fullyQualifiedName of nodes, which are a general
  abstraction of signals, to remove from the vehicle model.
- `"status"`:  The state of the vehicle model. If the status is ACTIVE, the vehicle model
  can't be edited. If the status is DRAFT, you can edit the vehicle model.
"""
function update_model_manifest(name; aws_config::AbstractAWSConfig=current_aws_config())
    return iotfleetwise(
        "UpdateModelManifest",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_model_manifest(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotfleetwise(
        "UpdateModelManifest",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_signal_catalog(name)
    update_signal_catalog(name, params::Dict{String,<:Any})

 Updates a signal catalog.

# Arguments
- `name`:  The name of the signal catalog to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`:  A brief description of the signal catalog to update.
- `"nodesToAdd"`:  A list of information about nodes to add to the signal catalog.
- `"nodesToRemove"`:  A list of fullyQualifiedName of nodes to remove from the signal
  catalog.
- `"nodesToUpdate"`:  A list of information about nodes to update in the signal catalog.
"""
function update_signal_catalog(name; aws_config::AbstractAWSConfig=current_aws_config())
    return iotfleetwise(
        "UpdateSignalCatalog",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_signal_catalog(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotfleetwise(
        "UpdateSignalCatalog",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_vehicle(vehicle_name)
    update_vehicle(vehicle_name, params::Dict{String,<:Any})

 Updates a vehicle.

# Arguments
- `vehicle_name`: The unique ID of the vehicle to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"attributeUpdateMode"`: The method the specified attributes will update the existing
  attributes on the vehicle. UseOverwite to replace the vehicle attributes with the specified
  attributes. Or use Merge to combine all attributes. This is required if attributes are
  present in the input.
- `"attributes"`: Static information about a vehicle in a key-value pair. For example:
  \"engineType\" : \"1.3 L R2\"
- `"decoderManifestArn"`: The ARN of the decoder manifest associated with this vehicle.
- `"modelManifestArn"`: The ARN of a vehicle model (model manifest) associated with the
  vehicle.
"""
function update_vehicle(vehicleName; aws_config::AbstractAWSConfig=current_aws_config())
    return iotfleetwise(
        "UpdateVehicle",
        Dict{String,Any}("vehicleName" => vehicleName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_vehicle(
    vehicleName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotfleetwise(
        "UpdateVehicle",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("vehicleName" => vehicleName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: datazone
using AWS.Compat
using AWS.UUIDs

"""
    accept_predictions(domain_identifier, identifier)
    accept_predictions(domain_identifier, identifier, params::Dict{String,<:Any})

Accepts automatically generated business-friendly metadata for your Amazon DataZone assets.

# Arguments
- `domain_identifier`: The identifier of the Amazon DataZone domain.
- `identifier`: The identifier of the asset.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"acceptChoices"`: Specifies the prediction (aka, the automatically generated piece of
  metadata) and the target (for example, a column name) that can be accepted.
- `"acceptRule"`: Specifies the rule (or the conditions) under which a prediction can be
  accepted.
- `"clientToken"`: A unique, case-sensitive identifier to ensure idempotency of the
  request. This field is automatically populated if not provided.
- `"revision"`: The revision that is to be made to the asset.
"""
function accept_predictions(
    domainIdentifier, identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "PUT",
        "/v2/domains/$(domainIdentifier)/assets/$(identifier)/accept-predictions",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function accept_predictions(
    domainIdentifier,
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "PUT",
        "/v2/domains/$(domainIdentifier)/assets/$(identifier)/accept-predictions",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    accept_subscription_request(domain_identifier, identifier)
    accept_subscription_request(domain_identifier, identifier, params::Dict{String,<:Any})

Accepts a subscription request to a specific asset.

# Arguments
- `domain_identifier`: The Amazon DataZone domain where the specified subscription request
  is being accepted.
- `identifier`: The unique identifier of the subscription request that is to be accepted.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"decisionComment"`: A description that specifies the reason for accepting the specified
  subscription request.
"""
function accept_subscription_request(
    domainIdentifier, identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "PUT",
        "/v2/domains/$(domainIdentifier)/subscription-requests/$(identifier)/accept";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function accept_subscription_request(
    domainIdentifier,
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "PUT",
        "/v2/domains/$(domainIdentifier)/subscription-requests/$(identifier)/accept",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_environment_role(domain_identifier, environment_identifier, environment_role_arn)
    associate_environment_role(domain_identifier, environment_identifier, environment_role_arn, params::Dict{String,<:Any})

Associates the environment role in Amazon DataZone.

# Arguments
- `domain_identifier`: The ID of the Amazon DataZone domain in which the environment role
  is associated.
- `environment_identifier`: The ID of the Amazon DataZone environment.
- `environment_role_arn`: The ARN of the environment role.

"""
function associate_environment_role(
    domainIdentifier,
    environmentIdentifier,
    environmentRoleArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "PUT",
        "/v2/domains/$(domainIdentifier)/environments/$(environmentIdentifier)/roles/$(environmentRoleArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_environment_role(
    domainIdentifier,
    environmentIdentifier,
    environmentRoleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "PUT",
        "/v2/domains/$(domainIdentifier)/environments/$(environmentIdentifier)/roles/$(environmentRoleArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_metadata_generation_run(domain_identifier, identifier)
    cancel_metadata_generation_run(domain_identifier, identifier, params::Dict{String,<:Any})

Cancels the metadata generation run.

# Arguments
- `domain_identifier`: The ID of the Amazon DataZone domain in which the metadata
  generation run is to be cancelled.
- `identifier`: The ID of the metadata generation run.

"""
function cancel_metadata_generation_run(
    domainIdentifier, identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "POST",
        "/v2/domains/$(domainIdentifier)/metadata-generation-runs/$(identifier)/cancel";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_metadata_generation_run(
    domainIdentifier,
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "POST",
        "/v2/domains/$(domainIdentifier)/metadata-generation-runs/$(identifier)/cancel",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_subscription(domain_identifier, identifier)
    cancel_subscription(domain_identifier, identifier, params::Dict{String,<:Any})

Cancels the subscription to the specified asset.

# Arguments
- `domain_identifier`: The unique identifier of the Amazon DataZone domain where the
  subscription request is being cancelled.
- `identifier`: The unique identifier of the subscription that is being cancelled.

"""
function cancel_subscription(
    domainIdentifier, identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "PUT",
        "/v2/domains/$(domainIdentifier)/subscriptions/$(identifier)/cancel";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_subscription(
    domainIdentifier,
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "PUT",
        "/v2/domains/$(domainIdentifier)/subscriptions/$(identifier)/cancel",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_asset(domain_identifier, name, owning_project_identifier, type_identifier)
    create_asset(domain_identifier, name, owning_project_identifier, type_identifier, params::Dict{String,<:Any})

Creates an asset in Amazon DataZone catalog.

# Arguments
- `domain_identifier`: Amazon DataZone domain where the asset is created.
- `name`: Asset name.
- `owning_project_identifier`: The unique identifier of the project that owns this asset.
- `type_identifier`: The unique identifier of this asset's type.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier that is provided to ensure the
  idempotency of the request.
- `"description"`: Asset description.
- `"externalIdentifier"`: The external identifier of the asset.
- `"formsInput"`: Metadata forms attached to the asset.
- `"glossaryTerms"`: Glossary terms attached to the asset.
- `"predictionConfiguration"`: The configuration of the automatically generated
  business-friendly metadata for the asset.
- `"typeRevision"`: The revision of this asset's type.
"""
function create_asset(
    domainIdentifier,
    name,
    owningProjectIdentifier,
    typeIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "POST",
        "/v2/domains/$(domainIdentifier)/assets",
        Dict{String,Any}(
            "name" => name,
            "owningProjectIdentifier" => owningProjectIdentifier,
            "typeIdentifier" => typeIdentifier,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_asset(
    domainIdentifier,
    name,
    owningProjectIdentifier,
    typeIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "POST",
        "/v2/domains/$(domainIdentifier)/assets",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "name" => name,
                    "owningProjectIdentifier" => owningProjectIdentifier,
                    "typeIdentifier" => typeIdentifier,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_asset_revision(domain_identifier, identifier, name)
    create_asset_revision(domain_identifier, identifier, name, params::Dict{String,<:Any})

Creates a revision of the asset.

# Arguments
- `domain_identifier`: The unique identifier of the domain where the asset is being revised.
- `identifier`: The identifier of the asset.
- `name`: Te revised name of the asset.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier that is provided to ensure the
  idempotency of the request.
- `"description"`: The revised description of the asset.
- `"formsInput"`: The metadata forms to be attached to the asset as part of asset revision.
- `"glossaryTerms"`: The glossary terms to be attached to the asset as part of asset
  revision.
- `"predictionConfiguration"`: The configuration of the automatically generated
  business-friendly metadata for the asset.
- `"typeRevision"`: The revision type of the asset.
"""
function create_asset_revision(
    domainIdentifier, identifier, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "POST",
        "/v2/domains/$(domainIdentifier)/assets/$(identifier)/revisions",
        Dict{String,Any}("name" => name, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_asset_revision(
    domainIdentifier,
    identifier,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "POST",
        "/v2/domains/$(domainIdentifier)/assets/$(identifier)/revisions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("name" => name, "clientToken" => string(uuid4())),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_asset_type(domain_identifier, forms_input, name, owning_project_identifier)
    create_asset_type(domain_identifier, forms_input, name, owning_project_identifier, params::Dict{String,<:Any})

Creates a custom asset type.

# Arguments
- `domain_identifier`: The unique identifier of the Amazon DataZone domain where the custom
  asset type is being created.
- `forms_input`: The metadata forms that are to be attached to the custom asset type.
- `name`: The name of the custom asset type.
- `owning_project_identifier`: The identifier of the Amazon DataZone project that is to own
  the custom asset type.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The descripton of the custom asset type.
"""
function create_asset_type(
    domainIdentifier,
    formsInput,
    name,
    owningProjectIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "POST",
        "/v2/domains/$(domainIdentifier)/asset-types",
        Dict{String,Any}(
            "formsInput" => formsInput,
            "name" => name,
            "owningProjectIdentifier" => owningProjectIdentifier,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_asset_type(
    domainIdentifier,
    formsInput,
    name,
    owningProjectIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "POST",
        "/v2/domains/$(domainIdentifier)/asset-types",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "formsInput" => formsInput,
                    "name" => name,
                    "owningProjectIdentifier" => owningProjectIdentifier,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_data_source(domain_identifier, environment_identifier, name, project_identifier, type)
    create_data_source(domain_identifier, environment_identifier, name, project_identifier, type, params::Dict{String,<:Any})

Creates an Amazon DataZone data source.

# Arguments
- `domain_identifier`: The ID of the Amazon DataZone domain where the data source is
  created.
- `environment_identifier`: The unique identifier of the Amazon DataZone environment to
  which the data source publishes assets.
- `name`: The name of the data source.
- `project_identifier`: The identifier of the Amazon DataZone project in which you want to
  add this data source.
- `type`: The type of the data source.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"assetFormsInput"`: The metadata forms that are to be attached to the assets that this
  data source works with.
- `"clientToken"`: A unique, case-sensitive identifier that is provided to ensure the
  idempotency of the request.
- `"configuration"`: Specifies the configuration of the data source. It can be set to
  either glueRunConfiguration or redshiftRunConfiguration.
- `"description"`: The description of the data source.
- `"enableSetting"`: Specifies whether the data source is enabled.
- `"publishOnImport"`: Specifies whether the assets that this data source creates in the
  inventory are to be also automatically published to the catalog.
- `"recommendation"`: Specifies whether the business name generation is to be enabled for
  this data source.
- `"schedule"`: The schedule of the data source runs.
"""
function create_data_source(
    domainIdentifier,
    environmentIdentifier,
    name,
    projectIdentifier,
    type;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "POST",
        "/v2/domains/$(domainIdentifier)/data-sources",
        Dict{String,Any}(
            "environmentIdentifier" => environmentIdentifier,
            "name" => name,
            "projectIdentifier" => projectIdentifier,
            "type" => type,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_data_source(
    domainIdentifier,
    environmentIdentifier,
    name,
    projectIdentifier,
    type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "POST",
        "/v2/domains/$(domainIdentifier)/data-sources",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "environmentIdentifier" => environmentIdentifier,
                    "name" => name,
                    "projectIdentifier" => projectIdentifier,
                    "type" => type,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_domain(domain_execution_role, name)
    create_domain(domain_execution_role, name, params::Dict{String,<:Any})

Creates an Amazon DataZone domain.

# Arguments
- `domain_execution_role`: The domain execution role that is created when an Amazon
  DataZone domain is created. The domain execution role is created in the Amazon Web Services
  account that houses the Amazon DataZone domain.
- `name`: The name of the Amazon DataZone domain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier that is provided to ensure the
  idempotency of the request.
- `"description"`: The description of the Amazon DataZone domain.
- `"kmsKeyIdentifier"`: The identifier of the Amazon Web Services Key Management Service
  (KMS) key that is used to encrypt the Amazon DataZone domain, metadata, and reporting data.
- `"singleSignOn"`: The single-sign on configuration of the Amazon DataZone domain.
- `"tags"`: The tags specified for the Amazon DataZone domain.
"""
function create_domain(
    domainExecutionRole, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "POST",
        "/v2/domains",
        Dict{String,Any}(
            "domainExecutionRole" => domainExecutionRole,
            "name" => name,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_domain(
    domainExecutionRole,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "POST",
        "/v2/domains",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "domainExecutionRole" => domainExecutionRole,
                    "name" => name,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_environment(domain_identifier, environment_profile_identifier, name, project_identifier)
    create_environment(domain_identifier, environment_profile_identifier, name, project_identifier, params::Dict{String,<:Any})

Create an Amazon DataZone environment.

# Arguments
- `domain_identifier`: The identifier of the Amazon DataZone domain in which the
  environment is created.
- `environment_profile_identifier`: The identifier of the environment profile that is used
  to create this Amazon DataZone environment.
- `name`: The name of the Amazon DataZone environment.
- `project_identifier`: The identifier of the Amazon DataZone project in which this
  environment is created.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description of the Amazon DataZone environment.
- `"environmentAccountIdentifier"`: The ID of the account in which the environment is being
  created.
- `"environmentAccountRegion"`: The region of the account in which the environment is being
  created.
- `"environmentBlueprintIdentifier"`: The ID of the blueprint with which the environment is
  being created.
- `"glossaryTerms"`: The glossary terms that can be used in this Amazon DataZone
  environment.
- `"userParameters"`: The user parameters of this Amazon DataZone environment.
"""
function create_environment(
    domainIdentifier,
    environmentProfileIdentifier,
    name,
    projectIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "POST",
        "/v2/domains/$(domainIdentifier)/environments",
        Dict{String,Any}(
            "environmentProfileIdentifier" => environmentProfileIdentifier,
            "name" => name,
            "projectIdentifier" => projectIdentifier,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_environment(
    domainIdentifier,
    environmentProfileIdentifier,
    name,
    projectIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "POST",
        "/v2/domains/$(domainIdentifier)/environments",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "environmentProfileIdentifier" => environmentProfileIdentifier,
                    "name" => name,
                    "projectIdentifier" => projectIdentifier,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_environment_action(domain_identifier, environment_identifier, name, parameters)
    create_environment_action(domain_identifier, environment_identifier, name, parameters, params::Dict{String,<:Any})

Creates an action for the environment, for example, creates a console link for an analytics
tool that is available in this environment.

# Arguments
- `domain_identifier`: The ID of the Amazon DataZone domain in which the environment action
  is created.
- `environment_identifier`: The ID of the environment in which the environment action is
  created.
- `name`: The name of the environment action.
- `parameters`: The parameters of the environment action.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description of the environment action that is being created in the
  environment.
"""
function create_environment_action(
    domainIdentifier,
    environmentIdentifier,
    name,
    parameters;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "POST",
        "/v2/domains/$(domainIdentifier)/environments/$(environmentIdentifier)/actions",
        Dict{String,Any}("name" => name, "parameters" => parameters);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_environment_action(
    domainIdentifier,
    environmentIdentifier,
    name,
    parameters,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "POST",
        "/v2/domains/$(domainIdentifier)/environments/$(environmentIdentifier)/actions",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("name" => name, "parameters" => parameters), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_environment_profile(domain_identifier, environment_blueprint_identifier, name, project_identifier)
    create_environment_profile(domain_identifier, environment_blueprint_identifier, name, project_identifier, params::Dict{String,<:Any})

Creates an Amazon DataZone environment profile.

# Arguments
- `domain_identifier`: The ID of the Amazon DataZone domain in which this environment
  profile is created.
- `environment_blueprint_identifier`: The ID of the blueprint with which this environment
  profile is created.
- `name`: The name of this Amazon DataZone environment profile.
- `project_identifier`: The identifier of the project in which to create the environment
  profile.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"awsAccountId"`: The Amazon Web Services account in which the Amazon DataZone
  environment is created.
- `"awsAccountRegion"`: The Amazon Web Services region in which this environment profile is
  created.
- `"description"`: The description of this Amazon DataZone environment profile.
- `"userParameters"`: The user parameters of this Amazon DataZone environment profile.
"""
function create_environment_profile(
    domainIdentifier,
    environmentBlueprintIdentifier,
    name,
    projectIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "POST",
        "/v2/domains/$(domainIdentifier)/environment-profiles",
        Dict{String,Any}(
            "environmentBlueprintIdentifier" => environmentBlueprintIdentifier,
            "name" => name,
            "projectIdentifier" => projectIdentifier,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_environment_profile(
    domainIdentifier,
    environmentBlueprintIdentifier,
    name,
    projectIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "POST",
        "/v2/domains/$(domainIdentifier)/environment-profiles",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "environmentBlueprintIdentifier" => environmentBlueprintIdentifier,
                    "name" => name,
                    "projectIdentifier" => projectIdentifier,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_form_type(domain_identifier, model, name, owning_project_identifier)
    create_form_type(domain_identifier, model, name, owning_project_identifier, params::Dict{String,<:Any})

Creates a metadata form type.

# Arguments
- `domain_identifier`: The ID of the Amazon DataZone domain in which this metadata form
  type is created.
- `model`: The model of this Amazon DataZone metadata form type.
- `name`: The name of this Amazon DataZone metadata form type.
- `owning_project_identifier`: The ID of the Amazon DataZone project that owns this
  metadata form type.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description of this Amazon DataZone metadata form type.
- `"status"`: The status of this Amazon DataZone metadata form type.
"""
function create_form_type(
    domainIdentifier,
    model,
    name,
    owningProjectIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "POST",
        "/v2/domains/$(domainIdentifier)/form-types",
        Dict{String,Any}(
            "model" => model,
            "name" => name,
            "owningProjectIdentifier" => owningProjectIdentifier,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_form_type(
    domainIdentifier,
    model,
    name,
    owningProjectIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "POST",
        "/v2/domains/$(domainIdentifier)/form-types",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "model" => model,
                    "name" => name,
                    "owningProjectIdentifier" => owningProjectIdentifier,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_glossary(domain_identifier, name, owning_project_identifier)
    create_glossary(domain_identifier, name, owning_project_identifier, params::Dict{String,<:Any})

Creates an Amazon DataZone business glossary.

# Arguments
- `domain_identifier`: The ID of the Amazon DataZone domain in which this business glossary
  is created.
- `name`: The name of this business glossary.
- `owning_project_identifier`: The ID of the project that currently owns business glossary.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier that is provided to ensure the
  idempotency of the request.
- `"description"`: The description of this business glossary.
- `"status"`: The status of this business glossary.
"""
function create_glossary(
    domainIdentifier,
    name,
    owningProjectIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "POST",
        "/v2/domains/$(domainIdentifier)/glossaries",
        Dict{String,Any}(
            "name" => name,
            "owningProjectIdentifier" => owningProjectIdentifier,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_glossary(
    domainIdentifier,
    name,
    owningProjectIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "POST",
        "/v2/domains/$(domainIdentifier)/glossaries",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "name" => name,
                    "owningProjectIdentifier" => owningProjectIdentifier,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_glossary_term(domain_identifier, glossary_identifier, name)
    create_glossary_term(domain_identifier, glossary_identifier, name, params::Dict{String,<:Any})

Creates a business glossary term.

# Arguments
- `domain_identifier`: The ID of the Amazon DataZone domain in which this business glossary
  term is created.
- `glossary_identifier`: The ID of the business glossary in which this term is created.
- `name`: The name of this business glossary term.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier that is provided to ensure the
  idempotency of the request.
- `"longDescription"`: The long description of this business glossary term.
- `"shortDescription"`: The short description of this business glossary term.
- `"status"`: The status of this business glossary term.
- `"termRelations"`: The term relations of this business glossary term.
"""
function create_glossary_term(
    domainIdentifier,
    glossaryIdentifier,
    name;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "POST",
        "/v2/domains/$(domainIdentifier)/glossary-terms",
        Dict{String,Any}(
            "glossaryIdentifier" => glossaryIdentifier,
            "name" => name,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_glossary_term(
    domainIdentifier,
    glossaryIdentifier,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "POST",
        "/v2/domains/$(domainIdentifier)/glossary-terms",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "glossaryIdentifier" => glossaryIdentifier,
                    "name" => name,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_group_profile(domain_identifier, group_identifier)
    create_group_profile(domain_identifier, group_identifier, params::Dict{String,<:Any})

Creates a group profile in Amazon DataZone.

# Arguments
- `domain_identifier`: The identifier of the Amazon DataZone domain in which the group
  profile is created.
- `group_identifier`: The identifier of the group for which the group profile is created.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`:  A unique, case-sensitive identifier that is provided to ensure the
  idempotency of the request.
"""
function create_group_profile(
    domainIdentifier, groupIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "POST",
        "/v2/domains/$(domainIdentifier)/group-profiles",
        Dict{String,Any}(
            "groupIdentifier" => groupIdentifier, "clientToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_group_profile(
    domainIdentifier,
    groupIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "POST",
        "/v2/domains/$(domainIdentifier)/group-profiles",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "groupIdentifier" => groupIdentifier, "clientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_listing_change_set(action, domain_identifier, entity_identifier, entity_type)
    create_listing_change_set(action, domain_identifier, entity_identifier, entity_type, params::Dict{String,<:Any})

Publishes a listing (a record of an asset at a given time) or removes a listing from the
catalog.

# Arguments
- `action`: Specifies whether to publish or unpublish a listing.
- `domain_identifier`: The ID of the Amazon DataZone domain.
- `entity_identifier`: The ID of the asset.
- `entity_type`: The type of an entity.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier that is provided to ensure the
  idempotency of the request.
- `"entityRevision"`: The revision of an asset.
"""
function create_listing_change_set(
    action,
    domainIdentifier,
    entityIdentifier,
    entityType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "POST",
        "/v2/domains/$(domainIdentifier)/listings/change-set",
        Dict{String,Any}(
            "action" => action,
            "entityIdentifier" => entityIdentifier,
            "entityType" => entityType,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_listing_change_set(
    action,
    domainIdentifier,
    entityIdentifier,
    entityType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "POST",
        "/v2/domains/$(domainIdentifier)/listings/change-set",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "action" => action,
                    "entityIdentifier" => entityIdentifier,
                    "entityType" => entityType,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_project(domain_identifier, name)
    create_project(domain_identifier, name, params::Dict{String,<:Any})

Creates an Amazon DataZone project.

# Arguments
- `domain_identifier`: The ID of the Amazon DataZone domain in which this project is
  created.
- `name`: The name of the Amazon DataZone project.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description of the Amazon DataZone project.
- `"glossaryTerms"`: The glossary terms that can be used in this Amazon DataZone project.
"""
function create_project(
    domainIdentifier, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "POST",
        "/v2/domains/$(domainIdentifier)/projects",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_project(
    domainIdentifier,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "POST",
        "/v2/domains/$(domainIdentifier)/projects",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_project_membership(designation, domain_identifier, member, project_identifier)
    create_project_membership(designation, domain_identifier, member, project_identifier, params::Dict{String,<:Any})

Creates a project membership in Amazon DataZone.

# Arguments
- `designation`: The designation of the project membership.
- `domain_identifier`: The ID of the Amazon DataZone domain in which project membership is
  created.
- `member`: The project member whose project membership was created.
- `project_identifier`: The ID of the project for which this project membership was created.

"""
function create_project_membership(
    designation,
    domainIdentifier,
    member,
    projectIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "POST",
        "/v2/domains/$(domainIdentifier)/projects/$(projectIdentifier)/createMembership",
        Dict{String,Any}("designation" => designation, "member" => member);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_project_membership(
    designation,
    domainIdentifier,
    member,
    projectIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "POST",
        "/v2/domains/$(domainIdentifier)/projects/$(projectIdentifier)/createMembership",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("designation" => designation, "member" => member),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_subscription_grant(domain_identifier, environment_identifier, granted_entity, subscription_target_identifier)
    create_subscription_grant(domain_identifier, environment_identifier, granted_entity, subscription_target_identifier, params::Dict{String,<:Any})

Creates a subsscription grant in Amazon DataZone.

# Arguments
- `domain_identifier`: The ID of the Amazon DataZone domain in which the subscription grant
  is created.
- `environment_identifier`: The ID of the environment in which the subscription grant is
  created.
- `granted_entity`: The entity to which the subscription is to be granted.
- `subscription_target_identifier`: The ID of the subscription target for which the
  subscription grant is created.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"assetTargetNames"`: The names of the assets for which the subscription grant is created.
- `"clientToken"`: A unique, case-sensitive identifier that is provided to ensure the
  idempotency of the request.
"""
function create_subscription_grant(
    domainIdentifier,
    environmentIdentifier,
    grantedEntity,
    subscriptionTargetIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "POST",
        "/v2/domains/$(domainIdentifier)/subscription-grants",
        Dict{String,Any}(
            "environmentIdentifier" => environmentIdentifier,
            "grantedEntity" => grantedEntity,
            "subscriptionTargetIdentifier" => subscriptionTargetIdentifier,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_subscription_grant(
    domainIdentifier,
    environmentIdentifier,
    grantedEntity,
    subscriptionTargetIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "POST",
        "/v2/domains/$(domainIdentifier)/subscription-grants",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "environmentIdentifier" => environmentIdentifier,
                    "grantedEntity" => grantedEntity,
                    "subscriptionTargetIdentifier" => subscriptionTargetIdentifier,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_subscription_request(domain_identifier, request_reason, subscribed_listings, subscribed_principals)
    create_subscription_request(domain_identifier, request_reason, subscribed_listings, subscribed_principals, params::Dict{String,<:Any})

Creates a subscription request in Amazon DataZone.

# Arguments
- `domain_identifier`: The ID of the Amazon DataZone domain in which the subscription
  request is created.
- `request_reason`: The reason for the subscription request.
- `subscribed_listings`: The published asset for which the subscription grant is to be
  created.
- `subscribed_principals`: The Amazon DataZone principals for whom the subscription request
  is created.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier that is provided to ensure the
  idempotency of the request.
"""
function create_subscription_request(
    domainIdentifier,
    requestReason,
    subscribedListings,
    subscribedPrincipals;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "POST",
        "/v2/domains/$(domainIdentifier)/subscription-requests",
        Dict{String,Any}(
            "requestReason" => requestReason,
            "subscribedListings" => subscribedListings,
            "subscribedPrincipals" => subscribedPrincipals,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_subscription_request(
    domainIdentifier,
    requestReason,
    subscribedListings,
    subscribedPrincipals,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "POST",
        "/v2/domains/$(domainIdentifier)/subscription-requests",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "requestReason" => requestReason,
                    "subscribedListings" => subscribedListings,
                    "subscribedPrincipals" => subscribedPrincipals,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_subscription_target(applicable_asset_types, authorized_principals, domain_identifier, environment_identifier, manage_access_role, name, subscription_target_config, type)
    create_subscription_target(applicable_asset_types, authorized_principals, domain_identifier, environment_identifier, manage_access_role, name, subscription_target_config, type, params::Dict{String,<:Any})

Creates a subscription target in Amazon DataZone.

# Arguments
- `applicable_asset_types`: The asset types that can be included in the subscription target.
- `authorized_principals`: The authorized principals of the subscription target.
- `domain_identifier`: The ID of the Amazon DataZone domain in which subscription target is
  created.
- `environment_identifier`: The ID of the environment in which subscription target is
  created.
- `manage_access_role`: The manage access role that is used to create the subscription
  target.
- `name`: The name of the subscription target.
- `subscription_target_config`: The configuration of the subscription target.
- `type`: The type of the subscription target.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier that is provided to ensure the
  idempotency of the request.
- `"provider"`: The provider of the subscription target.
"""
function create_subscription_target(
    applicableAssetTypes,
    authorizedPrincipals,
    domainIdentifier,
    environmentIdentifier,
    manageAccessRole,
    name,
    subscriptionTargetConfig,
    type;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "POST",
        "/v2/domains/$(domainIdentifier)/environments/$(environmentIdentifier)/subscription-targets",
        Dict{String,Any}(
            "applicableAssetTypes" => applicableAssetTypes,
            "authorizedPrincipals" => authorizedPrincipals,
            "manageAccessRole" => manageAccessRole,
            "name" => name,
            "subscriptionTargetConfig" => subscriptionTargetConfig,
            "type" => type,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_subscription_target(
    applicableAssetTypes,
    authorizedPrincipals,
    domainIdentifier,
    environmentIdentifier,
    manageAccessRole,
    name,
    subscriptionTargetConfig,
    type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "POST",
        "/v2/domains/$(domainIdentifier)/environments/$(environmentIdentifier)/subscription-targets",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "applicableAssetTypes" => applicableAssetTypes,
                    "authorizedPrincipals" => authorizedPrincipals,
                    "manageAccessRole" => manageAccessRole,
                    "name" => name,
                    "subscriptionTargetConfig" => subscriptionTargetConfig,
                    "type" => type,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_user_profile(domain_identifier, user_identifier)
    create_user_profile(domain_identifier, user_identifier, params::Dict{String,<:Any})

Creates a user profile in Amazon DataZone.

# Arguments
- `domain_identifier`: The identifier of the Amazon DataZone domain in which a user profile
  is created.
- `user_identifier`: The identifier of the user for which the user profile is created.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier that is provided to ensure the
  idempotency of the request.
- `"userType"`: The user type of the user for which the user profile is created.
"""
function create_user_profile(
    domainIdentifier, userIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "POST",
        "/v2/domains/$(domainIdentifier)/user-profiles",
        Dict{String,Any}(
            "userIdentifier" => userIdentifier, "clientToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_user_profile(
    domainIdentifier,
    userIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "POST",
        "/v2/domains/$(domainIdentifier)/user-profiles",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "userIdentifier" => userIdentifier, "clientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_asset(domain_identifier, identifier)
    delete_asset(domain_identifier, identifier, params::Dict{String,<:Any})

Delets an asset in Amazon DataZone.

# Arguments
- `domain_identifier`: The ID of the Amazon DataZone domain in which the asset is deleted.
- `identifier`: The identifier of the asset that is deleted.

"""
function delete_asset(
    domainIdentifier, identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "DELETE",
        "/v2/domains/$(domainIdentifier)/assets/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_asset(
    domainIdentifier,
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "DELETE",
        "/v2/domains/$(domainIdentifier)/assets/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_asset_type(domain_identifier, identifier)
    delete_asset_type(domain_identifier, identifier, params::Dict{String,<:Any})

Deletes an asset type in Amazon DataZone.

# Arguments
- `domain_identifier`: The ID of the Amazon DataZone domain in which the asset type is
  deleted.
- `identifier`: The identifier of the asset type that is deleted.

"""
function delete_asset_type(
    domainIdentifier, identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "DELETE",
        "/v2/domains/$(domainIdentifier)/asset-types/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_asset_type(
    domainIdentifier,
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "DELETE",
        "/v2/domains/$(domainIdentifier)/asset-types/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_data_source(domain_identifier, identifier)
    delete_data_source(domain_identifier, identifier, params::Dict{String,<:Any})

Deletes a data source in Amazon DataZone.

# Arguments
- `domain_identifier`: The ID of the Amazon DataZone domain in which the data source is
  deleted.
- `identifier`: The identifier of the data source that is deleted.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier that is provided to ensure the
  idempotency of the request.
- `"retainPermissionsOnRevokeFailure"`: Specifies that the granted permissions are retained
  in case of a self-subscribe functionality failure for a data source.
"""
function delete_data_source(
    domainIdentifier, identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "DELETE",
        "/v2/domains/$(domainIdentifier)/data-sources/$(identifier)",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_data_source(
    domainIdentifier,
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "DELETE",
        "/v2/domains/$(domainIdentifier)/data-sources/$(identifier)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_domain(identifier)
    delete_domain(identifier, params::Dict{String,<:Any})

Deletes a Amazon DataZone domain.

# Arguments
- `identifier`: The identifier of the Amazon Web Services domain that is to be deleted.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier that is provided to ensure the
  idempotency of the request.
- `"skipDeletionCheck"`: Specifies the optional flag to delete all child entities within
  the domain.
"""
function delete_domain(identifier; aws_config::AbstractAWSConfig=current_aws_config())
    return datazone(
        "DELETE",
        "/v2/domains/$(identifier)",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_domain(
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "DELETE",
        "/v2/domains/$(identifier)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_environment(domain_identifier, identifier)
    delete_environment(domain_identifier, identifier, params::Dict{String,<:Any})

Deletes an environment in Amazon DataZone.

# Arguments
- `domain_identifier`: The ID of the Amazon DataZone domain in which the environment is
  deleted.
- `identifier`: The identifier of the environment that is to be deleted.

"""
function delete_environment(
    domainIdentifier, identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "DELETE",
        "/v2/domains/$(domainIdentifier)/environments/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_environment(
    domainIdentifier,
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "DELETE",
        "/v2/domains/$(domainIdentifier)/environments/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_environment_action(domain_identifier, environment_identifier, identifier)
    delete_environment_action(domain_identifier, environment_identifier, identifier, params::Dict{String,<:Any})

Deletes an action for the environment, for example, deletes a console link for an analytics
tool that is available in this environment.

# Arguments
- `domain_identifier`: The ID of the Amazon DataZone domain in which an environment action
  is deleted.
- `environment_identifier`: The ID of the environment where an environment action is
  deleted.
- `identifier`: The ID of the environment action that is deleted.

"""
function delete_environment_action(
    domainIdentifier,
    environmentIdentifier,
    identifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "DELETE",
        "/v2/domains/$(domainIdentifier)/environments/$(environmentIdentifier)/actions/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_environment_action(
    domainIdentifier,
    environmentIdentifier,
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "DELETE",
        "/v2/domains/$(domainIdentifier)/environments/$(environmentIdentifier)/actions/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_environment_blueprint_configuration(domain_identifier, environment_blueprint_identifier)
    delete_environment_blueprint_configuration(domain_identifier, environment_blueprint_identifier, params::Dict{String,<:Any})

Deletes the blueprint configuration in Amazon DataZone.

# Arguments
- `domain_identifier`: The ID of the Amazon DataZone domain in which the blueprint
  configuration is deleted.
- `environment_blueprint_identifier`: The ID of the blueprint the configuration of which is
  deleted.

"""
function delete_environment_blueprint_configuration(
    domainIdentifier,
    environmentBlueprintIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "DELETE",
        "/v2/domains/$(domainIdentifier)/environment-blueprint-configurations/$(environmentBlueprintIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_environment_blueprint_configuration(
    domainIdentifier,
    environmentBlueprintIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "DELETE",
        "/v2/domains/$(domainIdentifier)/environment-blueprint-configurations/$(environmentBlueprintIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_environment_profile(domain_identifier, identifier)
    delete_environment_profile(domain_identifier, identifier, params::Dict{String,<:Any})

Deletes an environment profile in Amazon DataZone.

# Arguments
- `domain_identifier`: The ID of the Amazon DataZone domain in which the environment
  profile is deleted.
- `identifier`: The ID of the environment profile that is deleted.

"""
function delete_environment_profile(
    domainIdentifier, identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "DELETE",
        "/v2/domains/$(domainIdentifier)/environment-profiles/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_environment_profile(
    domainIdentifier,
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "DELETE",
        "/v2/domains/$(domainIdentifier)/environment-profiles/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_form_type(domain_identifier, form_type_identifier)
    delete_form_type(domain_identifier, form_type_identifier, params::Dict{String,<:Any})

Delets and metadata form type in Amazon DataZone.

# Arguments
- `domain_identifier`: The ID of the Amazon DataZone domain in which the metadata form type
  is deleted.
- `form_type_identifier`: The ID of the metadata form type that is deleted.

"""
function delete_form_type(
    domainIdentifier, formTypeIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "DELETE",
        "/v2/domains/$(domainIdentifier)/form-types/$(formTypeIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_form_type(
    domainIdentifier,
    formTypeIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "DELETE",
        "/v2/domains/$(domainIdentifier)/form-types/$(formTypeIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_glossary(domain_identifier, identifier)
    delete_glossary(domain_identifier, identifier, params::Dict{String,<:Any})

Deletes a business glossary in Amazon DataZone.

# Arguments
- `domain_identifier`: The ID of the Amazon DataZone domain in which the business glossary
  is deleted.
- `identifier`: The ID of the business glossary that is deleted.

"""
function delete_glossary(
    domainIdentifier, identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "DELETE",
        "/v2/domains/$(domainIdentifier)/glossaries/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_glossary(
    domainIdentifier,
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "DELETE",
        "/v2/domains/$(domainIdentifier)/glossaries/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_glossary_term(domain_identifier, identifier)
    delete_glossary_term(domain_identifier, identifier, params::Dict{String,<:Any})

Deletes a business glossary term in Amazon DataZone.

# Arguments
- `domain_identifier`: The ID of the Amazon DataZone domain in which the business glossary
  term is deleted.
- `identifier`: The ID of the business glossary term that is deleted.

"""
function delete_glossary_term(
    domainIdentifier, identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "DELETE",
        "/v2/domains/$(domainIdentifier)/glossary-terms/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_glossary_term(
    domainIdentifier,
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "DELETE",
        "/v2/domains/$(domainIdentifier)/glossary-terms/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_listing(domain_identifier, identifier)
    delete_listing(domain_identifier, identifier, params::Dict{String,<:Any})

Deletes a listing (a record of an asset at a given time).

# Arguments
- `domain_identifier`: The ID of the Amazon DataZone domain.
- `identifier`: The ID of the listing to be deleted.

"""
function delete_listing(
    domainIdentifier, identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "DELETE",
        "/v2/domains/$(domainIdentifier)/listings/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_listing(
    domainIdentifier,
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "DELETE",
        "/v2/domains/$(domainIdentifier)/listings/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_project(domain_identifier, identifier)
    delete_project(domain_identifier, identifier, params::Dict{String,<:Any})

Deletes a project in Amazon DataZone.

# Arguments
- `domain_identifier`: The ID of the Amazon DataZone domain in which the project is deleted.
- `identifier`: The identifier of the project that is to be deleted.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"skipDeletionCheck"`: Specifies the optional flag to delete all child entities within
  the project.
"""
function delete_project(
    domainIdentifier, identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "DELETE",
        "/v2/domains/$(domainIdentifier)/projects/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_project(
    domainIdentifier,
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "DELETE",
        "/v2/domains/$(domainIdentifier)/projects/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_project_membership(domain_identifier, member, project_identifier)
    delete_project_membership(domain_identifier, member, project_identifier, params::Dict{String,<:Any})

Deletes project membership in Amazon DataZone.

# Arguments
- `domain_identifier`: The ID of the Amazon DataZone domain where project membership is
  deleted.
- `member`: The project member whose project membership is deleted.
- `project_identifier`: The ID of the Amazon DataZone project the membership to which is
  deleted.

"""
function delete_project_membership(
    domainIdentifier,
    member,
    projectIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "POST",
        "/v2/domains/$(domainIdentifier)/projects/$(projectIdentifier)/deleteMembership",
        Dict{String,Any}("member" => member);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_project_membership(
    domainIdentifier,
    member,
    projectIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "POST",
        "/v2/domains/$(domainIdentifier)/projects/$(projectIdentifier)/deleteMembership",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("member" => member), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_subscription_grant(domain_identifier, identifier)
    delete_subscription_grant(domain_identifier, identifier, params::Dict{String,<:Any})

Deletes and subscription grant in Amazon DataZone.

# Arguments
- `domain_identifier`: The ID of the Amazon DataZone domain where the subscription grant is
  deleted.
- `identifier`: The ID of the subscription grant that is deleted.

"""
function delete_subscription_grant(
    domainIdentifier, identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "DELETE",
        "/v2/domains/$(domainIdentifier)/subscription-grants/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_subscription_grant(
    domainIdentifier,
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "DELETE",
        "/v2/domains/$(domainIdentifier)/subscription-grants/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_subscription_request(domain_identifier, identifier)
    delete_subscription_request(domain_identifier, identifier, params::Dict{String,<:Any})

Deletes a subscription request in Amazon DataZone.

# Arguments
- `domain_identifier`: The ID of the Amazon DataZone domain in which the subscription
  request is deleted.
- `identifier`: The ID of the subscription request that is deleted.

"""
function delete_subscription_request(
    domainIdentifier, identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "DELETE",
        "/v2/domains/$(domainIdentifier)/subscription-requests/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_subscription_request(
    domainIdentifier,
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "DELETE",
        "/v2/domains/$(domainIdentifier)/subscription-requests/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_subscription_target(domain_identifier, environment_identifier, identifier)
    delete_subscription_target(domain_identifier, environment_identifier, identifier, params::Dict{String,<:Any})

Deletes a subscription target in Amazon DataZone.

# Arguments
- `domain_identifier`: The ID of the Amazon DataZone domain in which the subscription
  target is deleted.
- `environment_identifier`: The ID of the Amazon DataZone environment in which the
  subscription target is deleted.
- `identifier`: The ID of the subscription target that is deleted.

"""
function delete_subscription_target(
    domainIdentifier,
    environmentIdentifier,
    identifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "DELETE",
        "/v2/domains/$(domainIdentifier)/environments/$(environmentIdentifier)/subscription-targets/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_subscription_target(
    domainIdentifier,
    environmentIdentifier,
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "DELETE",
        "/v2/domains/$(domainIdentifier)/environments/$(environmentIdentifier)/subscription-targets/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_time_series_data_points(domain_identifier, entity_identifier, entity_type, form_name)
    delete_time_series_data_points(domain_identifier, entity_identifier, entity_type, form_name, params::Dict{String,<:Any})

Deletes the specified time series form for the specified asset.

# Arguments
- `domain_identifier`: The ID of the Amazon DataZone domain that houses the asset for which
  you want to delete a time series form.
- `entity_identifier`: The ID of the asset for which you want to delete a time series form.
- `entity_type`: The type of the asset for which you want to delete a time series form.
- `form_name`: The name of the time series form that you want to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier to ensure idempotency of the
  request. This field is automatically populated if not provided.
"""
function delete_time_series_data_points(
    domainIdentifier,
    entityIdentifier,
    entityType,
    formName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "DELETE",
        "/v2/domains/$(domainIdentifier)/entities/$(entityType)/$(entityIdentifier)/time-series-data-points",
        Dict{String,Any}("formName" => formName, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_time_series_data_points(
    domainIdentifier,
    entityIdentifier,
    entityType,
    formName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "DELETE",
        "/v2/domains/$(domainIdentifier)/entities/$(entityType)/$(entityIdentifier)/time-series-data-points",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("formName" => formName, "clientToken" => string(uuid4())),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_environment_role(domain_identifier, environment_identifier, environment_role_arn)
    disassociate_environment_role(domain_identifier, environment_identifier, environment_role_arn, params::Dict{String,<:Any})

Disassociates the environment role in Amazon DataZone.

# Arguments
- `domain_identifier`: The ID of the Amazon DataZone domain in which an environment role is
  disassociated.
- `environment_identifier`: The ID of the environment.
- `environment_role_arn`: The ARN of the environment role.

"""
function disassociate_environment_role(
    domainIdentifier,
    environmentIdentifier,
    environmentRoleArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "DELETE",
        "/v2/domains/$(domainIdentifier)/environments/$(environmentIdentifier)/roles/$(environmentRoleArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_environment_role(
    domainIdentifier,
    environmentIdentifier,
    environmentRoleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "DELETE",
        "/v2/domains/$(domainIdentifier)/environments/$(environmentIdentifier)/roles/$(environmentRoleArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_asset(domain_identifier, identifier)
    get_asset(domain_identifier, identifier, params::Dict{String,<:Any})

Gets an Amazon DataZone asset.

# Arguments
- `domain_identifier`: The ID of the Amazon DataZone domain to which the asset belongs.
- `identifier`: The ID of the Amazon DataZone asset.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"revision"`: The revision of the Amazon DataZone asset.
"""
function get_asset(
    domainIdentifier, identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/assets/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_asset(
    domainIdentifier,
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/assets/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_asset_type(domain_identifier, identifier)
    get_asset_type(domain_identifier, identifier, params::Dict{String,<:Any})

Gets an Amazon DataZone asset type.

# Arguments
- `domain_identifier`: The ID of the Amazon DataZone domain in which the asset type exists.
- `identifier`: The ID of the asset type.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"revision"`: The revision of the asset type.
"""
function get_asset_type(
    domainIdentifier, identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/asset-types/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_asset_type(
    domainIdentifier,
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/asset-types/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_data_source(domain_identifier, identifier)
    get_data_source(domain_identifier, identifier, params::Dict{String,<:Any})

Gets an Amazon DataZone data source.

# Arguments
- `domain_identifier`: The ID of the Amazon DataZone domain in which the data source exists.
- `identifier`: The ID of the Amazon DataZone data source.

"""
function get_data_source(
    domainIdentifier, identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/data-sources/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_data_source(
    domainIdentifier,
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/data-sources/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_data_source_run(domain_identifier, identifier)
    get_data_source_run(domain_identifier, identifier, params::Dict{String,<:Any})

Gets an Amazon DataZone data source run.

# Arguments
- `domain_identifier`: The ID of the domain in which this data source run was performed.
- `identifier`: The ID of the data source run.

"""
function get_data_source_run(
    domainIdentifier, identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/data-source-runs/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_data_source_run(
    domainIdentifier,
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/data-source-runs/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_domain(identifier)
    get_domain(identifier, params::Dict{String,<:Any})

Gets an Amazon DataZone domain.

# Arguments
- `identifier`: The identifier of the specified Amazon DataZone domain.

"""
function get_domain(identifier; aws_config::AbstractAWSConfig=current_aws_config())
    return datazone(
        "GET",
        "/v2/domains/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_domain(
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "GET",
        "/v2/domains/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_environment(domain_identifier, identifier)
    get_environment(domain_identifier, identifier, params::Dict{String,<:Any})

Gets an Amazon DataZone environment.

# Arguments
- `domain_identifier`: The ID of the Amazon DataZone domain where the environment exists.
- `identifier`: The ID of the Amazon DataZone environment.

"""
function get_environment(
    domainIdentifier, identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/environments/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_environment(
    domainIdentifier,
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/environments/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_environment_action(domain_identifier, environment_identifier, identifier)
    get_environment_action(domain_identifier, environment_identifier, identifier, params::Dict{String,<:Any})

Gets the specified environment action.

# Arguments
- `domain_identifier`: The ID of the Amazon DataZone domain in which the
  GetEnvironmentAction API is invoked.
- `environment_identifier`: The environment ID of the environment action.
- `identifier`: The ID of the environment action

"""
function get_environment_action(
    domainIdentifier,
    environmentIdentifier,
    identifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/environments/$(environmentIdentifier)/actions/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_environment_action(
    domainIdentifier,
    environmentIdentifier,
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/environments/$(environmentIdentifier)/actions/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_environment_blueprint(domain_identifier, identifier)
    get_environment_blueprint(domain_identifier, identifier, params::Dict{String,<:Any})

Gets an Amazon DataZone blueprint.

# Arguments
- `domain_identifier`: The identifier of the domain in which this blueprint exists.
- `identifier`: The ID of this Amazon DataZone blueprint.

"""
function get_environment_blueprint(
    domainIdentifier, identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/environment-blueprints/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_environment_blueprint(
    domainIdentifier,
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/environment-blueprints/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_environment_blueprint_configuration(domain_identifier, environment_blueprint_identifier)
    get_environment_blueprint_configuration(domain_identifier, environment_blueprint_identifier, params::Dict{String,<:Any})

Gets the blueprint configuration in Amazon DataZone.

# Arguments
- `domain_identifier`: The ID of the Amazon DataZone domain where this blueprint exists.
- `environment_blueprint_identifier`: He ID of the blueprint.

"""
function get_environment_blueprint_configuration(
    domainIdentifier,
    environmentBlueprintIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/environment-blueprint-configurations/$(environmentBlueprintIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_environment_blueprint_configuration(
    domainIdentifier,
    environmentBlueprintIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/environment-blueprint-configurations/$(environmentBlueprintIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_environment_profile(domain_identifier, identifier)
    get_environment_profile(domain_identifier, identifier, params::Dict{String,<:Any})

Gets an evinronment profile in Amazon DataZone.

# Arguments
- `domain_identifier`: The ID of the Amazon DataZone domain in which this environment
  profile exists.
- `identifier`: The ID of the environment profile.

"""
function get_environment_profile(
    domainIdentifier, identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/environment-profiles/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_environment_profile(
    domainIdentifier,
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/environment-profiles/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_form_type(domain_identifier, form_type_identifier)
    get_form_type(domain_identifier, form_type_identifier, params::Dict{String,<:Any})

Gets a metadata form type in Amazon DataZone.

# Arguments
- `domain_identifier`: The ID of the Amazon DataZone domain in which this metadata form
  type exists.
- `form_type_identifier`: The ID of the metadata form type.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"revision"`: The revision of this metadata form type.
"""
function get_form_type(
    domainIdentifier, formTypeIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/form-types/$(formTypeIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_form_type(
    domainIdentifier,
    formTypeIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/form-types/$(formTypeIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_glossary(domain_identifier, identifier)
    get_glossary(domain_identifier, identifier, params::Dict{String,<:Any})

Gets a business glossary in Amazon DataZone.

# Arguments
- `domain_identifier`: The ID of the Amazon DataZone domain in which this business glossary
  exists.
- `identifier`: The ID of the business glossary.

"""
function get_glossary(
    domainIdentifier, identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/glossaries/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_glossary(
    domainIdentifier,
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/glossaries/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_glossary_term(domain_identifier, identifier)
    get_glossary_term(domain_identifier, identifier, params::Dict{String,<:Any})

Gets a business glossary term in Amazon DataZone.

# Arguments
- `domain_identifier`: The ID of the Amazon DataZone domain in which this business glossary
  term exists.
- `identifier`: The ID of the business glossary term.

"""
function get_glossary_term(
    domainIdentifier, identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/glossary-terms/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_glossary_term(
    domainIdentifier,
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/glossary-terms/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_group_profile(domain_identifier, group_identifier)
    get_group_profile(domain_identifier, group_identifier, params::Dict{String,<:Any})

Gets a group profile in Amazon DataZone.

# Arguments
- `domain_identifier`: The identifier of the Amazon DataZone domain in which the group
  profile exists.
- `group_identifier`: The identifier of the group profile.

"""
function get_group_profile(
    domainIdentifier, groupIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/group-profiles/$(groupIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_group_profile(
    domainIdentifier,
    groupIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/group-profiles/$(groupIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_iam_portal_login_url(domain_identifier)
    get_iam_portal_login_url(domain_identifier, params::Dict{String,<:Any})

Gets the data portal URL for the specified Amazon DataZone domain.

# Arguments
- `domain_identifier`: the ID of the Amazon DataZone domain the data portal of which you
  want to get.

"""
function get_iam_portal_login_url(
    domainIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "POST",
        "/v2/domains/$(domainIdentifier)/get-portal-login-url";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_iam_portal_login_url(
    domainIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "POST",
        "/v2/domains/$(domainIdentifier)/get-portal-login-url",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_listing(domain_identifier, identifier)
    get_listing(domain_identifier, identifier, params::Dict{String,<:Any})

Gets a listing (a record of an asset at a given time).

# Arguments
- `domain_identifier`: The ID of the Amazon DataZone domain.
- `identifier`: The ID of the listing.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"listingRevision"`: The revision of the listing.
"""
function get_listing(
    domainIdentifier, identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/listings/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_listing(
    domainIdentifier,
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/listings/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_metadata_generation_run(domain_identifier, identifier)
    get_metadata_generation_run(domain_identifier, identifier, params::Dict{String,<:Any})

Gets a metadata generation run in Amazon DataZone.

# Arguments
- `domain_identifier`: The ID of the Amazon DataZone domain the metadata generation run of
  which you want to get.
- `identifier`: The identifier of the metadata generation run.

"""
function get_metadata_generation_run(
    domainIdentifier, identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/metadata-generation-runs/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_metadata_generation_run(
    domainIdentifier,
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/metadata-generation-runs/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_project(domain_identifier, identifier)
    get_project(domain_identifier, identifier, params::Dict{String,<:Any})

Gets a project in Amazon DataZone.

# Arguments
- `domain_identifier`: The ID of the Amazon DataZone domain in which the project exists.
- `identifier`: The ID of the project.

"""
function get_project(
    domainIdentifier, identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/projects/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_project(
    domainIdentifier,
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/projects/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_subscription(domain_identifier, identifier)
    get_subscription(domain_identifier, identifier, params::Dict{String,<:Any})

Gets a subscription in Amazon DataZone.

# Arguments
- `domain_identifier`: The ID of the Amazon DataZone domain in which the subscription
  exists.
- `identifier`: The ID of the subscription.

"""
function get_subscription(
    domainIdentifier, identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/subscriptions/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_subscription(
    domainIdentifier,
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/subscriptions/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_subscription_grant(domain_identifier, identifier)
    get_subscription_grant(domain_identifier, identifier, params::Dict{String,<:Any})

Gets the subscription grant in Amazon DataZone.

# Arguments
- `domain_identifier`: The ID of the Amazon DataZone domain in which the subscription grant
  exists.
- `identifier`: The ID of the subscription grant.

"""
function get_subscription_grant(
    domainIdentifier, identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/subscription-grants/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_subscription_grant(
    domainIdentifier,
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/subscription-grants/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_subscription_request_details(domain_identifier, identifier)
    get_subscription_request_details(domain_identifier, identifier, params::Dict{String,<:Any})

Gets the details of the specified subscription request.

# Arguments
- `domain_identifier`: The identifier of the Amazon DataZone domain in which to get the
  subscription request details.
- `identifier`: The identifier of the subscription request the details of which to get.

"""
function get_subscription_request_details(
    domainIdentifier, identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/subscription-requests/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_subscription_request_details(
    domainIdentifier,
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/subscription-requests/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_subscription_target(domain_identifier, environment_identifier, identifier)
    get_subscription_target(domain_identifier, environment_identifier, identifier, params::Dict{String,<:Any})

Gets the subscription target in Amazon DataZone.

# Arguments
- `domain_identifier`: The ID of the Amazon DataZone domain in which the subscription
  target exists.
- `environment_identifier`: The ID of the environment associated with the subscription
  target.
- `identifier`: The ID of the subscription target.

"""
function get_subscription_target(
    domainIdentifier,
    environmentIdentifier,
    identifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/environments/$(environmentIdentifier)/subscription-targets/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_subscription_target(
    domainIdentifier,
    environmentIdentifier,
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/environments/$(environmentIdentifier)/subscription-targets/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_time_series_data_point(domain_identifier, entity_identifier, entity_type, form_name, identifier)
    get_time_series_data_point(domain_identifier, entity_identifier, entity_type, form_name, identifier, params::Dict{String,<:Any})

Gets the existing data point for the asset.

# Arguments
- `domain_identifier`: The ID of the Amazon DataZone domain that houses the asset for which
  you want to get the data point.
- `entity_identifier`: The ID of the asset for which you want to get the data point.
- `entity_type`: The type of the asset for which you want to get the data point.
- `form_name`: The name of the time series form that houses the data point that you want to
  get.
- `identifier`: The ID of the data point that you want to get.

"""
function get_time_series_data_point(
    domainIdentifier,
    entityIdentifier,
    entityType,
    formName,
    identifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/entities/$(entityType)/$(entityIdentifier)/time-series-data-points/$(identifier)",
        Dict{String,Any}("formName" => formName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_time_series_data_point(
    domainIdentifier,
    entityIdentifier,
    entityType,
    formName,
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/entities/$(entityType)/$(entityIdentifier)/time-series-data-points/$(identifier)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("formName" => formName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_user_profile(domain_identifier, user_identifier)
    get_user_profile(domain_identifier, user_identifier, params::Dict{String,<:Any})

Gets a user profile in Amazon DataZone.

# Arguments
- `domain_identifier`: the ID of the Amazon DataZone domain the data portal of which you
  want to get.
- `user_identifier`: The identifier of the user for which you want to get the user profile.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"type"`: The type of the user profile.
"""
function get_user_profile(
    domainIdentifier, userIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/user-profiles/$(userIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_user_profile(
    domainIdentifier,
    userIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/user-profiles/$(userIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_asset_revisions(domain_identifier, identifier)
    list_asset_revisions(domain_identifier, identifier, params::Dict{String,<:Any})

Lists the revisions for the asset.

# Arguments
- `domain_identifier`: The identifier of the domain.
- `identifier`: The identifier of the asset.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of revisions to return in a single call to
  ListAssetRevisions. When the number of revisions to be listed is greater than the value of
  MaxResults, the response contains a NextToken value that you can use in a subsequent call
  to ListAssetRevisions to list the next set of revisions.
- `"nextToken"`: When the number of revisions is greater than the default value for the
  MaxResults parameter, or if you explicitly specify a value for MaxResults that is less than
  the number of revisions, the response includes a pagination token named NextToken. You can
  specify this NextToken value in a subsequent call to ListAssetRevisions to list the next
  set of revisions.
"""
function list_asset_revisions(
    domainIdentifier, identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/assets/$(identifier)/revisions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_asset_revisions(
    domainIdentifier,
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/assets/$(identifier)/revisions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_data_source_run_activities(domain_identifier, identifier)
    list_data_source_run_activities(domain_identifier, identifier, params::Dict{String,<:Any})

Lists data source run activities.

# Arguments
- `domain_identifier`: The identifier of the Amazon DataZone domain in which to list data
  source run activities.
- `identifier`: The identifier of the data source run.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of activities to return in a single call to
  ListDataSourceRunActivities. When the number of activities to be listed is greater than the
  value of MaxResults, the response contains a NextToken value that you can use in a
  subsequent call to ListDataSourceRunActivities to list the next set of activities.
- `"nextToken"`: When the number of activities is greater than the default value for the
  MaxResults parameter, or if you explicitly specify a value for MaxResults that is less than
  the number of activities, the response includes a pagination token named NextToken. You can
  specify this NextToken value in a subsequent call to ListDataSourceRunActivities to list
  the next set of activities.
- `"status"`: The status of the data source run.
"""
function list_data_source_run_activities(
    domainIdentifier, identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/data-source-runs/$(identifier)/activities";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_data_source_run_activities(
    domainIdentifier,
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/data-source-runs/$(identifier)/activities",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_data_source_runs(data_source_identifier, domain_identifier)
    list_data_source_runs(data_source_identifier, domain_identifier, params::Dict{String,<:Any})

Lists data source runs in Amazon DataZone.

# Arguments
- `data_source_identifier`: The identifier of the data source.
- `domain_identifier`: The identifier of the Amazon DataZone domain in which to invoke the
  ListDataSourceRuns action.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of runs to return in a single call to
  ListDataSourceRuns. When the number of runs to be listed is greater than the value of
  MaxResults, the response contains a NextToken value that you can use in a subsequent call
  to ListDataSourceRuns to list the next set of runs.
- `"nextToken"`: When the number of runs is greater than the default value for the
  MaxResults parameter, or if you explicitly specify a value for MaxResults that is less than
  the number of runs, the response includes a pagination token named NextToken. You can
  specify this NextToken value in a subsequent call to ListDataSourceRuns to list the next
  set of runs.
- `"status"`: The status of the data source.
"""
function list_data_source_runs(
    dataSourceIdentifier,
    domainIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/data-sources/$(dataSourceIdentifier)/runs";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_data_source_runs(
    dataSourceIdentifier,
    domainIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/data-sources/$(dataSourceIdentifier)/runs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_data_sources(domain_identifier, project_identifier)
    list_data_sources(domain_identifier, project_identifier, params::Dict{String,<:Any})

Lists data sources in Amazon DataZone.

# Arguments
- `domain_identifier`: The identifier of the Amazon DataZone domain in which to list the
  data sources.
- `project_identifier`: The identifier of the project in which to list data sources.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"environmentIdentifier"`: The identifier of the environment in which to list the data
  sources.
- `"maxResults"`: The maximum number of data sources to return in a single call to
  ListDataSources. When the number of data sources to be listed is greater than the value of
  MaxResults, the response contains a NextToken value that you can use in a subsequent call
  to ListDataSources to list the next set of data sources.
- `"name"`: The name of the data source.
- `"nextToken"`: When the number of data sources is greater than the default value for the
  MaxResults parameter, or if you explicitly specify a value for MaxResults that is less than
  the number of data sources, the response includes a pagination token named NextToken. You
  can specify this NextToken value in a subsequent call to ListDataSources to list the next
  set of data sources.
- `"status"`: The status of the data source.
- `"type"`: The type of the data source.
"""
function list_data_sources(
    domainIdentifier, projectIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/data-sources",
        Dict{String,Any}("projectIdentifier" => projectIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_data_sources(
    domainIdentifier,
    projectIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/data-sources",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("projectIdentifier" => projectIdentifier), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_domains()
    list_domains(params::Dict{String,<:Any})

Lists Amazon DataZone domains.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of domains to return in a single call to ListDomains.
  When the number of domains to be listed is greater than the value of MaxResults, the
  response contains a NextToken value that you can use in a subsequent call to ListDomains to
  list the next set of domains.
- `"nextToken"`: When the number of domains is greater than the default value for the
  MaxResults parameter, or if you explicitly specify a value for MaxResults that is less than
  the number of domains, the response includes a pagination token named NextToken. You can
  specify this NextToken value in a subsequent call to ListDomains to list the next set of
  domains.
- `"status"`: The status of the data source.
"""
function list_domains(; aws_config::AbstractAWSConfig=current_aws_config())
    return datazone(
        "GET", "/v2/domains"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_domains(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "GET", "/v2/domains", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_environment_actions(domain_identifier, environment_identifier)
    list_environment_actions(domain_identifier, environment_identifier, params::Dict{String,<:Any})

Lists existing environment actions.

# Arguments
- `domain_identifier`: The ID of the Amazon DataZone domain in which the environment
  actions are listed.
- `environment_identifier`: The ID of the envrironment whose environment actions are listed.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of environment actions to return in a single call to
  ListEnvironmentActions. When the number of environment actions to be listed is greater than
  the value of MaxResults, the response contains a NextToken value that you can use in a
  subsequent call to ListEnvironmentActions to list the next set of environment actions.
- `"nextToken"`: When the number of environment actions is greater than the default value
  for the MaxResults parameter, or if you explicitly specify a value for MaxResults that is
  less than the number of environment actions, the response includes a pagination token named
  NextToken. You can specify this NextToken value in a subsequent call to
  ListEnvironmentActions to list the next set of environment actions.
"""
function list_environment_actions(
    domainIdentifier,
    environmentIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/environments/$(environmentIdentifier)/actions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_environment_actions(
    domainIdentifier,
    environmentIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/environments/$(environmentIdentifier)/actions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_environment_blueprint_configurations(domain_identifier)
    list_environment_blueprint_configurations(domain_identifier, params::Dict{String,<:Any})

Lists blueprint configurations for a Amazon DataZone environment.

# Arguments
- `domain_identifier`: The identifier of the Amazon DataZone domain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of blueprint configurations to return in a single call
  to ListEnvironmentBlueprintConfigurations. When the number of configurations to be listed
  is greater than the value of MaxResults, the response contains a NextToken value that you
  can use in a subsequent call to ListEnvironmentBlueprintConfigurations to list the next set
  of configurations.
- `"nextToken"`: When the number of blueprint configurations is greater than the default
  value for the MaxResults parameter, or if you explicitly specify a value for MaxResults
  that is less than the number of configurations, the response includes a pagination token
  named NextToken. You can specify this NextToken value in a subsequent call to
  ListEnvironmentBlueprintConfigurations to list the next set of configurations.
"""
function list_environment_blueprint_configurations(
    domainIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/environment-blueprint-configurations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_environment_blueprint_configurations(
    domainIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/environment-blueprint-configurations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_environment_blueprints(domain_identifier)
    list_environment_blueprints(domain_identifier, params::Dict{String,<:Any})

Lists blueprints in an Amazon DataZone environment.

# Arguments
- `domain_identifier`: The identifier of the Amazon DataZone domain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"managed"`: Specifies whether the environment blueprint is managed by Amazon DataZone.
- `"maxResults"`: The maximum number of blueprints to return in a single call to
  ListEnvironmentBlueprints. When the number of blueprints to be listed is greater than the
  value of MaxResults, the response contains a NextToken value that you can use in a
  subsequent call to ListEnvironmentBlueprints to list the next set of blueprints.
- `"name"`: The name of the Amazon DataZone environment.
- `"nextToken"`: When the number of blueprints in the environment is greater than the
  default value for the MaxResults parameter, or if you explicitly specify a value for
  MaxResults that is less than the number of blueprints in the environment, the response
  includes a pagination token named NextToken. You can specify this NextToken value in a
  subsequent call to ListEnvironmentBlueprintsto list the next set of blueprints.
"""
function list_environment_blueprints(
    domainIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/environment-blueprints";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_environment_blueprints(
    domainIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/environment-blueprints",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_environment_profiles(domain_identifier)
    list_environment_profiles(domain_identifier, params::Dict{String,<:Any})

Lists Amazon DataZone environment profiles.

# Arguments
- `domain_identifier`: The identifier of the Amazon DataZone domain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"awsAccountId"`: The identifier of the Amazon Web Services account where you want to
  list environment profiles.
- `"awsAccountRegion"`: The Amazon Web Services region where you want to list environment
  profiles.
- `"environmentBlueprintIdentifier"`: The identifier of the blueprint that was used to
  create the environment profiles that you want to list.
- `"maxResults"`: The maximum number of environment profiles to return in a single call to
  ListEnvironmentProfiles. When the number of environment profiles to be listed is greater
  than the value of MaxResults, the response contains a NextToken value that you can use in a
  subsequent call to ListEnvironmentProfiles to list the next set of environment profiles.
- `"name"`:
- `"nextToken"`: When the number of environment profiles is greater than the default value
  for the MaxResults parameter, or if you explicitly specify a value for MaxResults that is
  less than the number of environment profiles, the response includes a pagination token
  named NextToken. You can specify this NextToken value in a subsequent call to
  ListEnvironmentProfiles to list the next set of environment profiles.
- `"projectIdentifier"`: The identifier of the Amazon DataZone project.
"""
function list_environment_profiles(
    domainIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/environment-profiles";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_environment_profiles(
    domainIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/environment-profiles",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_environments(domain_identifier, project_identifier)
    list_environments(domain_identifier, project_identifier, params::Dict{String,<:Any})

Lists Amazon DataZone environments.

# Arguments
- `domain_identifier`: The identifier of the Amazon DataZone domain.
- `project_identifier`: The identifier of the Amazon DataZone project.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"awsAccountId"`: The identifier of the Amazon Web Services account where you want to
  list environments.
- `"awsAccountRegion"`: The Amazon Web Services region where you want to list environments.
- `"environmentBlueprintIdentifier"`: The identifier of the Amazon DataZone blueprint.
- `"environmentProfileIdentifier"`: The identifier of the environment profile.
- `"maxResults"`: The maximum number of environments to return in a single call to
  ListEnvironments. When the number of environments to be listed is greater than the value of
  MaxResults, the response contains a NextToken value that you can use in a subsequent call
  to ListEnvironments to list the next set of environments.
- `"name"`: The name of the environment.
- `"nextToken"`: When the number of environments is greater than the default value for the
  MaxResults parameter, or if you explicitly specify a value for MaxResults that is less than
  the number of environments, the response includes a pagination token named NextToken. You
  can specify this NextToken value in a subsequent call to ListEnvironments to list the next
  set of environments.
- `"provider"`: The provider of the environment.
- `"status"`: The status of the environments that you want to list.
"""
function list_environments(
    domainIdentifier, projectIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/environments",
        Dict{String,Any}("projectIdentifier" => projectIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_environments(
    domainIdentifier,
    projectIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/environments",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("projectIdentifier" => projectIdentifier), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_metadata_generation_runs(domain_identifier)
    list_metadata_generation_runs(domain_identifier, params::Dict{String,<:Any})

Lists all metadata generation runs.

# Arguments
- `domain_identifier`: The ID of the Amazon DataZone domain where you want to list metadata
  generation runs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of metadata generation runs to return in a single call
  to ListMetadataGenerationRuns. When the number of metadata generation runs to be listed is
  greater than the value of MaxResults, the response contains a NextToken value that you can
  use in a subsequent call to ListMetadataGenerationRuns to list the next set of revisions.
- `"nextToken"`: When the number of metadata generation runs is greater than the default
  value for the MaxResults parameter, or if you explicitly specify a value for MaxResults
  that is less than the number of metadata generation runs, the response includes a
  pagination token named NextToken. You can specify this NextToken value in a subsequent call
  to ListMetadataGenerationRuns to list the next set of revisions.
- `"status"`: The status of the metadata generation runs.
- `"type"`: The type of the metadata generation runs.
"""
function list_metadata_generation_runs(
    domainIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/metadata-generation-runs";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_metadata_generation_runs(
    domainIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/metadata-generation-runs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_notifications(domain_identifier, type)
    list_notifications(domain_identifier, type, params::Dict{String,<:Any})

Lists all Amazon DataZone notifications.

# Arguments
- `domain_identifier`: The identifier of the Amazon DataZone domain.
- `type`: The type of notifications.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"afterTimestamp"`: The time after which you want to list notifications.
- `"beforeTimestamp"`: The time before which you want to list notifications.
- `"maxResults"`: The maximum number of notifications to return in a single call to
  ListNotifications. When the number of notifications to be listed is greater than the value
  of MaxResults, the response contains a NextToken value that you can use in a subsequent
  call to ListNotifications to list the next set of notifications.
- `"nextToken"`: When the number of notifications is greater than the default value for the
  MaxResults parameter, or if you explicitly specify a value for MaxResults that is less than
  the number of notifications, the response includes a pagination token named NextToken. You
  can specify this NextToken value in a subsequent call to ListNotifications to list the next
  set of notifications.
- `"subjects"`: The subjects of notifications.
- `"taskStatus"`: The task status of notifications.
"""
function list_notifications(
    domainIdentifier, type; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/notifications",
        Dict{String,Any}("type" => type);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_notifications(
    domainIdentifier,
    type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/notifications",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("type" => type), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_project_memberships(domain_identifier, project_identifier)
    list_project_memberships(domain_identifier, project_identifier, params::Dict{String,<:Any})

Lists all members of the specified project.

# Arguments
- `domain_identifier`: The identifier of the Amazon DataZone domain in which you want to
  list project memberships.
- `project_identifier`: The identifier of the project whose memberships you want to list.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of memberships to return in a single call to
  ListProjectMemberships. When the number of memberships to be listed is greater than the
  value of MaxResults, the response contains a NextToken value that you can use in a
  subsequent call to ListProjectMemberships to list the next set of memberships.
- `"nextToken"`: When the number of memberships is greater than the default value for the
  MaxResults parameter, or if you explicitly specify a value for MaxResults that is less than
  the number of memberships, the response includes a pagination token named NextToken. You
  can specify this NextToken value in a subsequent call to ListProjectMemberships to list the
  next set of memberships.
- `"sortBy"`: The method by which you want to sort the project memberships.
- `"sortOrder"`: The sort order of the project memberships.
"""
function list_project_memberships(
    domainIdentifier, projectIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/projects/$(projectIdentifier)/memberships";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_project_memberships(
    domainIdentifier,
    projectIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/projects/$(projectIdentifier)/memberships",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_projects(domain_identifier)
    list_projects(domain_identifier, params::Dict{String,<:Any})

Lists Amazon DataZone projects.

# Arguments
- `domain_identifier`: The identifier of the Amazon DataZone domain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"groupIdentifier"`: The identifier of a group.
- `"maxResults"`: The maximum number of projects to return in a single call to
  ListProjects. When the number of projects to be listed is greater than the value of
  MaxResults, the response contains a NextToken value that you can use in a subsequent call
  to ListProjects to list the next set of projects.
- `"name"`: The name of the project.
- `"nextToken"`: When the number of projects is greater than the default value for the
  MaxResults parameter, or if you explicitly specify a value for MaxResults that is less than
  the number of projects, the response includes a pagination token named NextToken. You can
  specify this NextToken value in a subsequent call to ListProjects to list the next set of
  projects.
- `"userIdentifier"`: The identifier of the Amazon DataZone user.
"""
function list_projects(domainIdentifier; aws_config::AbstractAWSConfig=current_aws_config())
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/projects";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_projects(
    domainIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/projects",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_subscription_grants(domain_identifier)
    list_subscription_grants(domain_identifier, params::Dict{String,<:Any})

Lists subscription grants.

# Arguments
- `domain_identifier`: The identifier of the Amazon DataZone domain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"environmentId"`: The identifier of the Amazon DataZone environment.
- `"maxResults"`: The maximum number of subscription grants to return in a single call to
  ListSubscriptionGrants. When the number of subscription grants to be listed is greater than
  the value of MaxResults, the response contains a NextToken value that you can use in a
  subsequent call to ListSubscriptionGrants to list the next set of subscription grants.
- `"nextToken"`: When the number of subscription grants is greater than the default value
  for the MaxResults parameter, or if you explicitly specify a value for MaxResults that is
  less than the number of subscription grants, the response includes a pagination token named
  NextToken. You can specify this NextToken value in a subsequent call to
  ListSubscriptionGrants to list the next set of subscription grants.
- `"sortBy"`: Specifies the way of sorting the results of this action.
- `"sortOrder"`: Specifies the sort order of this action.
- `"subscribedListingId"`: The identifier of the subscribed listing.
- `"subscriptionId"`: The identifier of the subscription.
- `"subscriptionTargetId"`: The identifier of the subscription target.
"""
function list_subscription_grants(
    domainIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/subscription-grants";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_subscription_grants(
    domainIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/subscription-grants",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_subscription_requests(domain_identifier)
    list_subscription_requests(domain_identifier, params::Dict{String,<:Any})

Lists Amazon DataZone subscription requests.

# Arguments
- `domain_identifier`: The identifier of the Amazon DataZone domain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"approverProjectId"`: The identifier of the subscription request approver's project.
- `"maxResults"`: The maximum number of subscription requests to return in a single call to
  ListSubscriptionRequests. When the number of subscription requests to be listed is greater
  than the value of MaxResults, the response contains a NextToken value that you can use in a
  subsequent call to ListSubscriptionRequests to list the next set of subscription requests.
- `"nextToken"`: When the number of subscription requests is greater than the default value
  for the MaxResults parameter, or if you explicitly specify a value for MaxResults that is
  less than the number of subscription requests, the response includes a pagination token
  named NextToken. You can specify this NextToken value in a subsequent call to
  ListSubscriptionRequests to list the next set of subscription requests.
- `"owningProjectId"`: The identifier of the project for the subscription requests.
- `"sortBy"`: Specifies the way to sort the results of this action.
- `"sortOrder"`: Specifies the sort order for the results of this action.
- `"status"`: Specifies the status of the subscription requests.
- `"subscribedListingId"`: The identifier of the subscribed listing.
"""
function list_subscription_requests(
    domainIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/subscription-requests";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_subscription_requests(
    domainIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/subscription-requests",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_subscription_targets(domain_identifier, environment_identifier)
    list_subscription_targets(domain_identifier, environment_identifier, params::Dict{String,<:Any})

Lists subscription targets in Amazon DataZone.

# Arguments
- `domain_identifier`: The identifier of the Amazon DataZone domain where you want to list
  subscription targets.
- `environment_identifier`: The identifier of the environment where you want to list
  subscription targets.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of subscription targets to return in a single call to
  ListSubscriptionTargets. When the number of subscription targets to be listed is greater
  than the value of MaxResults, the response contains a NextToken value that you can use in a
  subsequent call to ListSubscriptionTargets to list the next set of subscription targets.
- `"nextToken"`: When the number of subscription targets is greater than the default value
  for the MaxResults parameter, or if you explicitly specify a value for MaxResults that is
  less than the number of subscription targets, the response includes a pagination token
  named NextToken. You can specify this NextToken value in a subsequent call to
  ListSubscriptionTargets to list the next set of subscription targets.
- `"sortBy"`: Specifies the way in which the results of this action are to be sorted.
- `"sortOrder"`: Specifies the sort order for the results of this action.
"""
function list_subscription_targets(
    domainIdentifier,
    environmentIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/environments/$(environmentIdentifier)/subscription-targets";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_subscription_targets(
    domainIdentifier,
    environmentIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/environments/$(environmentIdentifier)/subscription-targets",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_subscriptions(domain_identifier)
    list_subscriptions(domain_identifier, params::Dict{String,<:Any})

Lists subscriptions in Amazon DataZone.

# Arguments
- `domain_identifier`: The identifier of the Amazon DataZone domain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"approverProjectId"`: The identifier of the project for the subscription's approver.
- `"maxResults"`: The maximum number of subscriptions to return in a single call to
  ListSubscriptions. When the number of subscriptions to be listed is greater than the value
  of MaxResults, the response contains a NextToken value that you can use in a subsequent
  call to ListSubscriptions to list the next set of Subscriptions.
- `"nextToken"`: When the number of subscriptions is greater than the default value for the
  MaxResults parameter, or if you explicitly specify a value for MaxResults that is less than
  the number of subscriptions, the response includes a pagination token named NextToken. You
  can specify this NextToken value in a subsequent call to ListSubscriptions to list the next
  set of subscriptions.
- `"owningProjectId"`: The identifier of the owning project.
- `"sortBy"`: Specifies the way in which the results of this action are to be sorted.
- `"sortOrder"`: Specifies the sort order for the results of this action.
- `"status"`: The status of the subscriptions that you want to list.
- `"subscribedListingId"`: The identifier of the subscribed listing for the subscriptions
  that you want to list.
- `"subscriptionRequestIdentifier"`: The identifier of the subscription request for the
  subscriptions that you want to list.
"""
function list_subscriptions(
    domainIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/subscriptions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_subscriptions(
    domainIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/subscriptions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists tags for the specified resource in Amazon DataZone.

# Arguments
- `resource_arn`: The ARN of the resource whose tags you want to list.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_time_series_data_points(domain_identifier, entity_identifier, entity_type, form_name)
    list_time_series_data_points(domain_identifier, entity_identifier, entity_type, form_name, params::Dict{String,<:Any})

Lists time series data points.

# Arguments
- `domain_identifier`: The ID of the Amazon DataZone domain that houses the assets for
  which you want to list time series data points.
- `entity_identifier`: The ID of the asset for which you want to list data points.
- `entity_type`: The type of the asset for which you want to list data points.
- `form_name`: The name of the time series data points form.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"endedAt"`: The timestamp at which the data points that you wanted to list ended.
- `"maxResults"`: The maximum number of data points to return in a single call to
  ListTimeSeriesDataPoints. When the number of data points to be listed is greater than the
  value of MaxResults, the response contains a NextToken value that you can use in a
  subsequent call to ListTimeSeriesDataPoints to list the next set of data points.
- `"nextToken"`: When the number of data points is greater than the default value for the
  MaxResults parameter, or if you explicitly specify a value for MaxResults that is less than
  the number of data points, the response includes a pagination token named NextToken. You
  can specify this NextToken value in a subsequent call to ListTimeSeriesDataPoints to list
  the next set of data points.
- `"startedAt"`: The timestamp at which the data points that you want to list started.
"""
function list_time_series_data_points(
    domainIdentifier,
    entityIdentifier,
    entityType,
    formName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/entities/$(entityType)/$(entityIdentifier)/time-series-data-points",
        Dict{String,Any}("formName" => formName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_time_series_data_points(
    domainIdentifier,
    entityIdentifier,
    entityType,
    formName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "GET",
        "/v2/domains/$(domainIdentifier)/entities/$(entityType)/$(entityIdentifier)/time-series-data-points",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("formName" => formName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    post_time_series_data_points(domain_identifier, entity_identifier, entity_type, forms)
    post_time_series_data_points(domain_identifier, entity_identifier, entity_type, forms, params::Dict{String,<:Any})

Posts time series data points to Amazon DataZone for the specified asset.

# Arguments
- `domain_identifier`: The ID of the Amazon DataZone domain in which you want to post time
  series data points.
- `entity_identifier`: The ID of the asset for which you want to post time series data
  points.
- `entity_type`: The type of the asset for which you want to post data points.
- `forms`: The forms that contain the data points that you want to post.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier that is provided to ensure the
  idempotency of the request.
"""
function post_time_series_data_points(
    domainIdentifier,
    entityIdentifier,
    entityType,
    forms;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "POST",
        "/v2/domains/$(domainIdentifier)/entities/$(entityType)/$(entityIdentifier)/time-series-data-points",
        Dict{String,Any}("forms" => forms, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function post_time_series_data_points(
    domainIdentifier,
    entityIdentifier,
    entityType,
    forms,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "POST",
        "/v2/domains/$(domainIdentifier)/entities/$(entityType)/$(entityIdentifier)/time-series-data-points",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("forms" => forms, "clientToken" => string(uuid4())),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_environment_blueprint_configuration(domain_identifier, enabled_regions, environment_blueprint_identifier)
    put_environment_blueprint_configuration(domain_identifier, enabled_regions, environment_blueprint_identifier, params::Dict{String,<:Any})

Writes the configuration for the specified environment blueprint in Amazon DataZone.

# Arguments
- `domain_identifier`: The identifier of the Amazon DataZone domain.
- `enabled_regions`: Specifies the enabled Amazon Web Services Regions.
- `environment_blueprint_identifier`: The identifier of the environment blueprint.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"manageAccessRoleArn"`: The ARN of the manage access role.
- `"provisioningRoleArn"`: The ARN of the provisioning role.
- `"regionalParameters"`: The regional parameters in the environment blueprint.
"""
function put_environment_blueprint_configuration(
    domainIdentifier,
    enabledRegions,
    environmentBlueprintIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "PUT",
        "/v2/domains/$(domainIdentifier)/environment-blueprint-configurations/$(environmentBlueprintIdentifier)",
        Dict{String,Any}("enabledRegions" => enabledRegions);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_environment_blueprint_configuration(
    domainIdentifier,
    enabledRegions,
    environmentBlueprintIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "PUT",
        "/v2/domains/$(domainIdentifier)/environment-blueprint-configurations/$(environmentBlueprintIdentifier)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("enabledRegions" => enabledRegions), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    reject_predictions(domain_identifier, identifier)
    reject_predictions(domain_identifier, identifier, params::Dict{String,<:Any})

Rejects automatically generated business-friendly metadata for your Amazon DataZone assets.

# Arguments
- `domain_identifier`: The identifier of the Amazon DataZone domain.
- `identifier`: The identifier of the prediction.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier that is provided to ensure the
  idempotency of the request.
- `"rejectChoices"`: Specifies the prediction (aka, the automatically generated piece of
  metadata) and the target (for example, a column name) that can be rejected.
- `"rejectRule"`: Specifies the rule (or the conditions) under which a prediction can be
  rejected.
- `"revision"`: The revision that is to be made to the asset.
"""
function reject_predictions(
    domainIdentifier, identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "PUT",
        "/v2/domains/$(domainIdentifier)/assets/$(identifier)/reject-predictions",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function reject_predictions(
    domainIdentifier,
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "PUT",
        "/v2/domains/$(domainIdentifier)/assets/$(identifier)/reject-predictions",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    reject_subscription_request(domain_identifier, identifier)
    reject_subscription_request(domain_identifier, identifier, params::Dict{String,<:Any})

Rejects the specified subscription request.

# Arguments
- `domain_identifier`: The identifier of the Amazon DataZone domain in which the
  subscription request was rejected.
- `identifier`: The identifier of the subscription request that was rejected.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"decisionComment"`: The decision comment of the rejected subscription request.
"""
function reject_subscription_request(
    domainIdentifier, identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "PUT",
        "/v2/domains/$(domainIdentifier)/subscription-requests/$(identifier)/reject";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function reject_subscription_request(
    domainIdentifier,
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "PUT",
        "/v2/domains/$(domainIdentifier)/subscription-requests/$(identifier)/reject",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    revoke_subscription(domain_identifier, identifier)
    revoke_subscription(domain_identifier, identifier, params::Dict{String,<:Any})

Revokes a specified subscription in Amazon DataZone.

# Arguments
- `domain_identifier`: The identifier of the Amazon DataZone domain where you want to
  revoke a subscription.
- `identifier`: The identifier of the revoked subscription.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"retainPermissions"`: Specifies whether permissions are retained when the subscription
  is revoked.
"""
function revoke_subscription(
    domainIdentifier, identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "PUT",
        "/v2/domains/$(domainIdentifier)/subscriptions/$(identifier)/revoke";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function revoke_subscription(
    domainIdentifier,
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "PUT",
        "/v2/domains/$(domainIdentifier)/subscriptions/$(identifier)/revoke",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    search(domain_identifier, search_scope)
    search(domain_identifier, search_scope, params::Dict{String,<:Any})

Searches for assets in Amazon DataZone.

# Arguments
- `domain_identifier`: The identifier of the Amazon DataZone domain.
- `search_scope`: The scope of the search.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"additionalAttributes"`: Specifies additional attributes for the Search action.
- `"filters"`: Specifies the search filters.
- `"maxResults"`: The maximum number of results to return in a single call to Search. When
  the number of results to be listed is greater than the value of MaxResults, the response
  contains a NextToken value that you can use in a subsequent call to Search to list the next
  set of results.
- `"nextToken"`: When the number of results is greater than the default value for the
  MaxResults parameter, or if you explicitly specify a value for MaxResults that is less than
  the number of results, the response includes a pagination token named NextToken. You can
  specify this NextToken value in a subsequent call to Search to list the next set of results.
- `"owningProjectIdentifier"`: The identifier of the owning project specified for the
  search.
- `"searchIn"`: The details of the search.
- `"searchText"`: Specifies the text for which to search.
- `"sort"`: Specifies the way in which the search results are to be sorted.
"""
function search(
    domainIdentifier, searchScope; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "POST",
        "/v2/domains/$(domainIdentifier)/search",
        Dict{String,Any}("searchScope" => searchScope);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function search(
    domainIdentifier,
    searchScope,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "POST",
        "/v2/domains/$(domainIdentifier)/search",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("searchScope" => searchScope), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    search_group_profiles(domain_identifier, group_type)
    search_group_profiles(domain_identifier, group_type, params::Dict{String,<:Any})

Searches group profiles in Amazon DataZone.

# Arguments
- `domain_identifier`: The identifier of the Amazon DataZone domain in which you want to
  search group profiles.
- `group_type`: The group type for which to search.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in a single call to
  SearchGroupProfiles. When the number of results to be listed is greater than the value of
  MaxResults, the response contains a NextToken value that you can use in a subsequent call
  to SearchGroupProfiles to list the next set of results.
- `"nextToken"`: When the number of results is greater than the default value for the
  MaxResults parameter, or if you explicitly specify a value for MaxResults that is less than
  the number of results, the response includes a pagination token named NextToken. You can
  specify this NextToken value in a subsequent call to SearchGroupProfiles to list the next
  set of results.
- `"searchText"`: Specifies the text for which to search.
"""
function search_group_profiles(
    domainIdentifier, groupType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "POST",
        "/v2/domains/$(domainIdentifier)/search-group-profiles",
        Dict{String,Any}("groupType" => groupType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function search_group_profiles(
    domainIdentifier,
    groupType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "POST",
        "/v2/domains/$(domainIdentifier)/search-group-profiles",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("groupType" => groupType), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    search_listings(domain_identifier)
    search_listings(domain_identifier, params::Dict{String,<:Any})

Searches listings (records of an asset at a given time) in Amazon DataZone.

# Arguments
- `domain_identifier`: The identifier of the domain in which to search listings.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"additionalAttributes"`: Specifies additional attributes for the search.
- `"filters"`: Specifies the filters for the search of listings.
- `"maxResults"`: The maximum number of results to return in a single call to
  SearchListings. When the number of results to be listed is greater than the value of
  MaxResults, the response contains a NextToken value that you can use in a subsequent call
  to SearchListings to list the next set of results.
- `"nextToken"`: When the number of results is greater than the default value for the
  MaxResults parameter, or if you explicitly specify a value for MaxResults that is less than
  the number of results, the response includes a pagination token named NextToken. You can
  specify this NextToken value in a subsequent call to SearchListings to list the next set of
  results.
- `"searchIn"`: The details of the search.
- `"searchText"`: Specifies the text for which to search.
- `"sort"`: Specifies the way for sorting the search results.
"""
function search_listings(
    domainIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "POST",
        "/v2/domains/$(domainIdentifier)/listings/search";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function search_listings(
    domainIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "POST",
        "/v2/domains/$(domainIdentifier)/listings/search",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    search_types(domain_identifier, managed, search_scope)
    search_types(domain_identifier, managed, search_scope, params::Dict{String,<:Any})

Searches for types in Amazon DataZone.

# Arguments
- `domain_identifier`: The identifier of the Amazon DataZone domain in which to invoke the
  SearchTypes action.
- `managed`: Specifies whether the search is managed.
- `search_scope`: Specifies the scope of the search for types.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: The filters for the SearchTypes action.
- `"maxResults"`: The maximum number of results to return in a single call to SearchTypes.
  When the number of results to be listed is greater than the value of MaxResults, the
  response contains a NextToken value that you can use in a subsequent call to SearchTypes to
  list the next set of results.
- `"nextToken"`: When the number of results is greater than the default value for the
  MaxResults parameter, or if you explicitly specify a value for MaxResults that is less than
  the number of results, the response includes a pagination token named NextToken. You can
  specify this NextToken value in a subsequent call to SearchTypes to list the next set of
  results.
- `"searchIn"`: The details of the search.
- `"searchText"`: Specifies the text for which to search.
- `"sort"`: The specifies the way to sort the SearchTypes results.
"""
function search_types(
    domainIdentifier,
    managed,
    searchScope;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "POST",
        "/v2/domains/$(domainIdentifier)/types-search",
        Dict{String,Any}("managed" => managed, "searchScope" => searchScope);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function search_types(
    domainIdentifier,
    managed,
    searchScope,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "POST",
        "/v2/domains/$(domainIdentifier)/types-search",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("managed" => managed, "searchScope" => searchScope),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    search_user_profiles(domain_identifier, user_type)
    search_user_profiles(domain_identifier, user_type, params::Dict{String,<:Any})

Searches user profiles in Amazon DataZone.

# Arguments
- `domain_identifier`: The identifier of the Amazon DataZone domain in which you want to
  search user profiles.
- `user_type`: Specifies the user type for the SearchUserProfiles action.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in a single call to
  SearchUserProfiles. When the number of results to be listed is greater than the value of
  MaxResults, the response contains a NextToken value that you can use in a subsequent call
  to SearchUserProfiles to list the next set of results.
- `"nextToken"`: When the number of results is greater than the default value for the
  MaxResults parameter, or if you explicitly specify a value for MaxResults that is less than
  the number of results, the response includes a pagination token named NextToken. You can
  specify this NextToken value in a subsequent call to SearchUserProfiles to list the next
  set of results.
- `"searchText"`: Specifies the text for which to search.
"""
function search_user_profiles(
    domainIdentifier, userType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "POST",
        "/v2/domains/$(domainIdentifier)/search-user-profiles",
        Dict{String,Any}("userType" => userType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function search_user_profiles(
    domainIdentifier,
    userType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "POST",
        "/v2/domains/$(domainIdentifier)/search-user-profiles",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("userType" => userType), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_data_source_run(data_source_identifier, domain_identifier)
    start_data_source_run(data_source_identifier, domain_identifier, params::Dict{String,<:Any})

Start the run of the specified data source in Amazon DataZone.

# Arguments
- `data_source_identifier`: The identifier of the data source.
- `domain_identifier`: The identifier of the Amazon DataZone domain in which to start a
  data source run.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier that is provided to ensure the
  idempotency of the request.
"""
function start_data_source_run(
    dataSourceIdentifier,
    domainIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "POST",
        "/v2/domains/$(domainIdentifier)/data-sources/$(dataSourceIdentifier)/runs",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_data_source_run(
    dataSourceIdentifier,
    domainIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "POST",
        "/v2/domains/$(domainIdentifier)/data-sources/$(dataSourceIdentifier)/runs",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_metadata_generation_run(domain_identifier, owning_project_identifier, target, type)
    start_metadata_generation_run(domain_identifier, owning_project_identifier, target, type, params::Dict{String,<:Any})

Starts the metadata generation run.

# Arguments
- `domain_identifier`: The ID of the Amazon DataZone domain where you want to start a
  metadata generation run.
- `owning_project_identifier`: The ID of the project that owns the asset for which you want
  to start a metadata generation run.
- `target`: The asset for which you want to start a metadata generation run.
- `type`: The type of the metadata generation run.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier to ensure idempotency of the
  request. This field is automatically populated if not provided.
"""
function start_metadata_generation_run(
    domainIdentifier,
    owningProjectIdentifier,
    target,
    type;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "POST",
        "/v2/domains/$(domainIdentifier)/metadata-generation-runs",
        Dict{String,Any}(
            "owningProjectIdentifier" => owningProjectIdentifier,
            "target" => target,
            "type" => type,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_metadata_generation_run(
    domainIdentifier,
    owningProjectIdentifier,
    target,
    type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "POST",
        "/v2/domains/$(domainIdentifier)/metadata-generation-runs",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "owningProjectIdentifier" => owningProjectIdentifier,
                    "target" => target,
                    "type" => type,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Tags a resource in Amazon DataZone.

# Arguments
- `resource_arn`: The ARN of the resource to be tagged in Amazon DataZone.
- `tags`: Specifies the tags for the TagResource action.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return datazone(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Untags a resource in Amazon DataZone.

# Arguments
- `resource_arn`: The ARN of the resource to be untagged in Amazon DataZone.
- `tag_keys`: Specifies the tag keys for the UntagResource action.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_data_source(domain_identifier, identifier)
    update_data_source(domain_identifier, identifier, params::Dict{String,<:Any})

Updates the specified data source in Amazon DataZone.

# Arguments
- `domain_identifier`: The identifier of the domain in which to update a data source.
- `identifier`: The identifier of the data source to be updated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"assetFormsInput"`: The asset forms to be updated as part of the UpdateDataSource action.
- `"configuration"`: The configuration to be updated as part of the UpdateDataSource action.
- `"description"`: The description to be updated as part of the UpdateDataSource action.
- `"enableSetting"`: The enable setting to be updated as part of the UpdateDataSource
  action.
- `"name"`: The name to be updated as part of the UpdateDataSource action.
- `"publishOnImport"`: The publish on import setting to be updated as part of the
  UpdateDataSource action.
- `"recommendation"`: The recommendation to be updated as part of the UpdateDataSource
  action.
- `"retainPermissionsOnRevokeFailure"`: Specifies that the granted permissions are retained
  in case of a self-subscribe functionality failure for a data source.
- `"schedule"`: The schedule to be updated as part of the UpdateDataSource action.
"""
function update_data_source(
    domainIdentifier, identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "PATCH",
        "/v2/domains/$(domainIdentifier)/data-sources/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_data_source(
    domainIdentifier,
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "PATCH",
        "/v2/domains/$(domainIdentifier)/data-sources/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_domain(identifier)
    update_domain(identifier, params::Dict{String,<:Any})

Updates a Amazon DataZone domain.

# Arguments
- `identifier`: The ID of the Amazon Web Services domain that is to be updated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier that is provided to ensure the
  idempotency of the request.
- `"description"`: The description to be updated as part of the UpdateDomain action.
- `"domainExecutionRole"`: The domain execution role to be updated as part of the
  UpdateDomain action.
- `"name"`: The name to be updated as part of the UpdateDomain action.
- `"singleSignOn"`: The single sign-on option to be updated as part of the UpdateDomain
  action.
"""
function update_domain(identifier; aws_config::AbstractAWSConfig=current_aws_config())
    return datazone(
        "PUT",
        "/v2/domains/$(identifier)",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_domain(
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "PUT",
        "/v2/domains/$(identifier)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_environment(domain_identifier, identifier)
    update_environment(domain_identifier, identifier, params::Dict{String,<:Any})

Updates the specified environment in Amazon DataZone.

# Arguments
- `domain_identifier`: The identifier of the domain in which the environment is to be
  updated.
- `identifier`: The identifier of the environment that is to be updated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description to be updated as part of the UpdateEnvironment action.
- `"glossaryTerms"`: The glossary terms to be updated as part of the UpdateEnvironment
  action.
- `"name"`: The name to be updated as part of the UpdateEnvironment action.
"""
function update_environment(
    domainIdentifier, identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "PATCH",
        "/v2/domains/$(domainIdentifier)/environments/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_environment(
    domainIdentifier,
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "PATCH",
        "/v2/domains/$(domainIdentifier)/environments/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_environment_action(domain_identifier, environment_identifier, identifier)
    update_environment_action(domain_identifier, environment_identifier, identifier, params::Dict{String,<:Any})

Updates an environment action.

# Arguments
- `domain_identifier`: The domain ID of the environment action.
- `environment_identifier`: The environment ID of the environment action.
- `identifier`: The ID of the environment action.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description of the environment action.
- `"name"`: The name of the environment action.
- `"parameters"`: The parameters of the environment action.
"""
function update_environment_action(
    domainIdentifier,
    environmentIdentifier,
    identifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "PATCH",
        "/v2/domains/$(domainIdentifier)/environments/$(environmentIdentifier)/actions/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_environment_action(
    domainIdentifier,
    environmentIdentifier,
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "PATCH",
        "/v2/domains/$(domainIdentifier)/environments/$(environmentIdentifier)/actions/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_environment_profile(domain_identifier, identifier)
    update_environment_profile(domain_identifier, identifier, params::Dict{String,<:Any})

Updates the specified environment profile in Amazon DataZone.

# Arguments
- `domain_identifier`: The identifier of the Amazon DataZone domain in which an environment
  profile is to be updated.
- `identifier`: The identifier of the environment profile that is to be updated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"awsAccountId"`: The Amazon Web Services account in which a specified environment
  profile is to be udpated.
- `"awsAccountRegion"`: The Amazon Web Services Region in which a specified environment
  profile is to be updated.
- `"description"`: The description to be updated as part of the UpdateEnvironmentProfile
  action.
- `"name"`: The name to be updated as part of the UpdateEnvironmentProfile action.
- `"userParameters"`: The user parameters to be updated as part of the
  UpdateEnvironmentProfile action.
"""
function update_environment_profile(
    domainIdentifier, identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "PATCH",
        "/v2/domains/$(domainIdentifier)/environment-profiles/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_environment_profile(
    domainIdentifier,
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "PATCH",
        "/v2/domains/$(domainIdentifier)/environment-profiles/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_glossary(domain_identifier, identifier)
    update_glossary(domain_identifier, identifier, params::Dict{String,<:Any})

Updates the business glossary in Amazon DataZone.

# Arguments
- `domain_identifier`: The identifier of the Amazon DataZone domain in which a business
  glossary is to be updated.
- `identifier`: The identifier of the business glossary to be updated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier that is provided to ensure the
  idempotency of the request.
- `"description"`: The description to be updated as part of the UpdateGlossary action.
- `"name"`: The name to be updated as part of the UpdateGlossary action.
- `"status"`: The status to be updated as part of the UpdateGlossary action.
"""
function update_glossary(
    domainIdentifier, identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "PATCH",
        "/v2/domains/$(domainIdentifier)/glossaries/$(identifier)",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_glossary(
    domainIdentifier,
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "PATCH",
        "/v2/domains/$(domainIdentifier)/glossaries/$(identifier)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_glossary_term(domain_identifier, identifier)
    update_glossary_term(domain_identifier, identifier, params::Dict{String,<:Any})

Updates a business glossary term in Amazon DataZone.

# Arguments
- `domain_identifier`: The identifier of the Amazon DataZone domain in which a business
  glossary term is to be updated.
- `identifier`: The identifier of the business glossary term that is to be updated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"glossaryIdentifier"`: The identifier of the business glossary in which a term is to be
  updated.
- `"longDescription"`: The long description to be updated as part of the UpdateGlossaryTerm
  action.
- `"name"`: The name to be updated as part of the UpdateGlossaryTerm action.
- `"shortDescription"`: The short description to be updated as part of the
  UpdateGlossaryTerm action.
- `"status"`: The status to be updated as part of the UpdateGlossaryTerm action.
- `"termRelations"`: The term relations to be updated as part of the UpdateGlossaryTerm
  action.
"""
function update_glossary_term(
    domainIdentifier, identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "PATCH",
        "/v2/domains/$(domainIdentifier)/glossary-terms/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_glossary_term(
    domainIdentifier,
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "PATCH",
        "/v2/domains/$(domainIdentifier)/glossary-terms/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_group_profile(domain_identifier, group_identifier, status)
    update_group_profile(domain_identifier, group_identifier, status, params::Dict{String,<:Any})

Updates the specified group profile in Amazon DataZone.

# Arguments
- `domain_identifier`: The identifier of the Amazon DataZone domain in which a group
  profile is updated.
- `group_identifier`: The identifier of the group profile that is updated.
- `status`: The status of the group profile that is updated.

"""
function update_group_profile(
    domainIdentifier,
    groupIdentifier,
    status;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "PUT",
        "/v2/domains/$(domainIdentifier)/group-profiles/$(groupIdentifier)",
        Dict{String,Any}("status" => status);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_group_profile(
    domainIdentifier,
    groupIdentifier,
    status,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "PUT",
        "/v2/domains/$(domainIdentifier)/group-profiles/$(groupIdentifier)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("status" => status), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_project(domain_identifier, identifier)
    update_project(domain_identifier, identifier, params::Dict{String,<:Any})

Updates the specified project in Amazon DataZone.

# Arguments
- `domain_identifier`: The identifier of the Amazon DataZone domain in which a project is
  to be updated.
- `identifier`: The identifier of the project that is to be updated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description to be updated as part of the UpdateProject action.
- `"glossaryTerms"`: The glossary terms to be updated as part of the UpdateProject action.
- `"name"`: The name to be updated as part of the UpdateProject action.
"""
function update_project(
    domainIdentifier, identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datazone(
        "PATCH",
        "/v2/domains/$(domainIdentifier)/projects/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_project(
    domainIdentifier,
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "PATCH",
        "/v2/domains/$(domainIdentifier)/projects/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_subscription_grant_status(asset_identifier, domain_identifier, identifier, status)
    update_subscription_grant_status(asset_identifier, domain_identifier, identifier, status, params::Dict{String,<:Any})

Updates the status of the specified subscription grant status in Amazon DataZone.

# Arguments
- `asset_identifier`: The identifier of the asset the subscription grant status of which is
  to be updated.
- `domain_identifier`: The identifier of the Amazon DataZone domain in which a subscription
  grant status is to be updated.
- `identifier`: The identifier of the subscription grant the status of which is to be
  updated.
- `status`: The status to be updated as part of the UpdateSubscriptionGrantStatus action.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"failureCause"`: Specifies the error message that is returned if the operation cannot be
  successfully completed.
- `"targetName"`: The target name to be updated as part of the
  UpdateSubscriptionGrantStatus action.
"""
function update_subscription_grant_status(
    assetIdentifier,
    domainIdentifier,
    identifier,
    status;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "PATCH",
        "/v2/domains/$(domainIdentifier)/subscription-grants/$(identifier)/status/$(assetIdentifier)",
        Dict{String,Any}("status" => status);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_subscription_grant_status(
    assetIdentifier,
    domainIdentifier,
    identifier,
    status,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "PATCH",
        "/v2/domains/$(domainIdentifier)/subscription-grants/$(identifier)/status/$(assetIdentifier)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("status" => status), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_subscription_request(domain_identifier, identifier, request_reason)
    update_subscription_request(domain_identifier, identifier, request_reason, params::Dict{String,<:Any})

Updates a specified subscription request in Amazon DataZone.

# Arguments
- `domain_identifier`: The identifier of the Amazon DataZone domain in which a subscription
  request is to be updated.
- `identifier`: The identifier of the subscription request that is to be updated.
- `request_reason`: The reason for the UpdateSubscriptionRequest action.

"""
function update_subscription_request(
    domainIdentifier,
    identifier,
    requestReason;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "PATCH",
        "/v2/domains/$(domainIdentifier)/subscription-requests/$(identifier)",
        Dict{String,Any}("requestReason" => requestReason);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_subscription_request(
    domainIdentifier,
    identifier,
    requestReason,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "PATCH",
        "/v2/domains/$(domainIdentifier)/subscription-requests/$(identifier)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("requestReason" => requestReason), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_subscription_target(domain_identifier, environment_identifier, identifier)
    update_subscription_target(domain_identifier, environment_identifier, identifier, params::Dict{String,<:Any})

Updates the specified subscription target in Amazon DataZone.

# Arguments
- `domain_identifier`: The identifier of the Amazon DataZone domain in which a subscription
  target is to be updated.
- `environment_identifier`: The identifier of the environment in which a subscription
  target is to be updated.
- `identifier`: Identifier of the subscription target that is to be updated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"applicableAssetTypes"`: The applicable asset types to be updated as part of the
  UpdateSubscriptionTarget action.
- `"authorizedPrincipals"`: The authorized principals to be updated as part of the
  UpdateSubscriptionTarget action.
- `"manageAccessRole"`: The manage access role to be updated as part of the
  UpdateSubscriptionTarget action.
- `"name"`: The name to be updated as part of the UpdateSubscriptionTarget action.
- `"provider"`: The provider to be updated as part of the UpdateSubscriptionTarget action.
- `"subscriptionTargetConfig"`: The configuration to be updated as part of the
  UpdateSubscriptionTarget action.
"""
function update_subscription_target(
    domainIdentifier,
    environmentIdentifier,
    identifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "PATCH",
        "/v2/domains/$(domainIdentifier)/environments/$(environmentIdentifier)/subscription-targets/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_subscription_target(
    domainIdentifier,
    environmentIdentifier,
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "PATCH",
        "/v2/domains/$(domainIdentifier)/environments/$(environmentIdentifier)/subscription-targets/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_user_profile(domain_identifier, status, user_identifier)
    update_user_profile(domain_identifier, status, user_identifier, params::Dict{String,<:Any})

Updates the specified user profile in Amazon DataZone.

# Arguments
- `domain_identifier`: The identifier of the Amazon DataZone domain in which a user profile
  is updated.
- `status`: The status of the user profile that are to be updated.
- `user_identifier`: The identifier of the user whose user profile is to be updated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"type"`: The type of the user profile that are to be updated.
"""
function update_user_profile(
    domainIdentifier,
    status,
    userIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "PUT",
        "/v2/domains/$(domainIdentifier)/user-profiles/$(userIdentifier)",
        Dict{String,Any}("status" => status);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_user_profile(
    domainIdentifier,
    status,
    userIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datazone(
        "PUT",
        "/v2/domains/$(domainIdentifier)/user-profiles/$(userIdentifier)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("status" => status), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: appconfig
using AWS.Compat
using AWS.UUIDs

"""
    create_application(name)
    create_application(name, params::Dict{String,<:Any})

Creates an application. In AppConfig, an application is simply an organizational construct
like a folder. This organizational construct has a relationship with some unit of
executable code. For example, you could create an application called MyMobileApp to
organize and manage configuration data for a mobile application installed by your users.

# Arguments
- `name`: A name for the application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description of the application.
- `"Tags"`: Metadata to assign to the application. Tags help organize and categorize your
  AppConfig resources. Each tag consists of a key and an optional value, both of which you
  define.
"""
function create_application(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return appconfig(
        "POST",
        "/applications",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_application(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appconfig(
        "POST",
        "/applications",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_configuration_profile(application_id, location_uri, name)
    create_configuration_profile(application_id, location_uri, name, params::Dict{String,<:Any})

Creates a configuration profile, which is information that enables AppConfig to access the
configuration source. Valid configuration sources include the following:   Configuration
data in YAML, JSON, and other formats stored in the AppConfig hosted configuration store
Configuration data stored as objects in an Amazon Simple Storage Service (Amazon S3) bucket
  Pipelines stored in CodePipeline   Secrets stored in Secrets Manager   Standard and
secure string parameters stored in Amazon Web Services Systems Manager Parameter Store
Configuration data in SSM documents stored in the Systems Manager document store   A
configuration profile includes the following information:   The URI location of the
configuration data.   The Identity and Access Management (IAM) role that provides access to
the configuration data.   A validator for the configuration data. Available validators
include either a JSON Schema or an Amazon Web Services Lambda function.   For more
information, see Create a Configuration and a Configuration Profile in the AppConfig User
Guide.

# Arguments
- `application_id`: The application ID.
- `location_uri`: A URI to locate the configuration. You can specify the following:   For
  the AppConfig hosted configuration store and for feature flags, specify hosted.   For an
  Amazon Web Services Systems Manager Parameter Store parameter, specify either the parameter
  name in the format ssm-parameter://&lt;parameter name&gt; or the ARN.   For an Amazon Web
  Services CodePipeline pipeline, specify the URI in the following format:
  codepipeline://&lt;pipeline name&gt;.   For an Secrets Manager secret, specify the URI in
  the following format: secretsmanager://&lt;secret name&gt;.   For an Amazon S3 object,
  specify the URI in the following format: s3://&lt;bucket&gt;/&lt;objectKey&gt; . Here is an
  example: s3://my-bucket/my-app/us-east-1/my-config.json    For an SSM document, specify
  either the document name in the format ssm-document://&lt;document name&gt; or the Amazon
  Resource Name (ARN).
- `name`: A name for the configuration profile.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description of the configuration profile.
- `"KmsKeyIdentifier"`: The identifier for an Key Management Service key to encrypt new
  configuration data versions in the AppConfig hosted configuration store. This attribute is
  only used for hosted configuration types. The identifier can be an KMS key ID, alias, or
  the Amazon Resource Name (ARN) of the key ID or alias. To encrypt data managed in other
  configuration stores, see the documentation for how to specify an KMS key for that
  particular service.
- `"RetrievalRoleArn"`: The ARN of an IAM role with permission to access the configuration
  at the specified LocationUri.  A retrieval role ARN is not required for configurations
  stored in the AppConfig hosted configuration store. It is required for all other sources
  that store your configuration.
- `"Tags"`: Metadata to assign to the configuration profile. Tags help organize and
  categorize your AppConfig resources. Each tag consists of a key and an optional value, both
  of which you define.
- `"Type"`: The type of configurations contained in the profile. AppConfig supports feature
  flags and freeform configurations. We recommend you create feature flag configurations to
  enable or disable new features and freeform configurations to distribute configurations to
  an application. When calling this API, enter one of the following values for Type:
  AWS.AppConfig.FeatureFlags   AWS.Freeform
- `"Validators"`: A list of methods for validating the configuration.
"""
function create_configuration_profile(
    ApplicationId, LocationUri, Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appconfig(
        "POST",
        "/applications/$(ApplicationId)/configurationprofiles",
        Dict{String,Any}("LocationUri" => LocationUri, "Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_configuration_profile(
    ApplicationId,
    LocationUri,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appconfig(
        "POST",
        "/applications/$(ApplicationId)/configurationprofiles",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("LocationUri" => LocationUri, "Name" => Name),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_deployment_strategy(deployment_duration_in_minutes, growth_factor, name)
    create_deployment_strategy(deployment_duration_in_minutes, growth_factor, name, params::Dict{String,<:Any})

Creates a deployment strategy that defines important criteria for rolling out your
configuration to the designated targets. A deployment strategy includes the overall
duration required, a percentage of targets to receive the deployment during each interval,
an algorithm that defines how percentage grows, and bake time.

# Arguments
- `deployment_duration_in_minutes`: Total amount of time for a deployment to last.
- `growth_factor`: The percentage of targets to receive a deployed configuration during
  each interval.
- `name`: A name for the deployment strategy.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description of the deployment strategy.
- `"FinalBakeTimeInMinutes"`: Specifies the amount of time AppConfig monitors for Amazon
  CloudWatch alarms after the configuration has been deployed to 100% of its targets, before
  considering the deployment to be complete. If an alarm is triggered during this time,
  AppConfig rolls back the deployment. You must configure permissions for AppConfig to roll
  back based on CloudWatch alarms. For more information, see Configuring permissions for
  rollback based on Amazon CloudWatch alarms in the AppConfig User Guide.
- `"GrowthType"`: The algorithm used to define how percentage grows over time. AppConfig
  supports the following growth types:  Linear: For this type, AppConfig processes the
  deployment by dividing the total number of targets by the value specified for Step
  percentage. For example, a linear deployment that uses a Step percentage of 10 deploys the
  configuration to 10 percent of the hosts. After those deployments are complete, the system
  deploys the configuration to the next 10 percent. This continues until 100% of the targets
  have successfully received the configuration.  Exponential: For this type, AppConfig
  processes the deployment exponentially using the following formula: G*(2^N). In this
  formula, G is the growth factor specified by the user and N is the number of steps until
  the configuration is deployed to all targets. For example, if you specify a growth factor
  of 2, then the system rolls out the configuration as follows:  2*(2^0)   2*(2^1)   2*(2^2)
  Expressed numerically, the deployment rolls out as follows: 2% of the targets, 4% of the
  targets, 8% of the targets, and continues until the configuration has been deployed to all
  targets.
- `"ReplicateTo"`: Save the deployment strategy to a Systems Manager (SSM) document.
- `"Tags"`: Metadata to assign to the deployment strategy. Tags help organize and
  categorize your AppConfig resources. Each tag consists of a key and an optional value, both
  of which you define.
"""
function create_deployment_strategy(
    DeploymentDurationInMinutes,
    GrowthFactor,
    Name;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appconfig(
        "POST",
        "/deploymentstrategies",
        Dict{String,Any}(
            "DeploymentDurationInMinutes" => DeploymentDurationInMinutes,
            "GrowthFactor" => GrowthFactor,
            "Name" => Name,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_deployment_strategy(
    DeploymentDurationInMinutes,
    GrowthFactor,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appconfig(
        "POST",
        "/deploymentstrategies",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DeploymentDurationInMinutes" => DeploymentDurationInMinutes,
                    "GrowthFactor" => GrowthFactor,
                    "Name" => Name,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_environment(application_id, name)
    create_environment(application_id, name, params::Dict{String,<:Any})

Creates an environment. For each application, you define one or more environments. An
environment is a deployment group of AppConfig targets, such as applications in a Beta or
Production environment. You can also define environments for application subcomponents such
as the Web, Mobile and Back-end components for your application. You can configure Amazon
CloudWatch alarms for each environment. The system monitors alarms during a configuration
deployment. If an alarm is triggered, the system rolls back the configuration.

# Arguments
- `application_id`: The application ID.
- `name`: A name for the environment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description of the environment.
- `"Monitors"`: Amazon CloudWatch alarms to monitor during the deployment process.
- `"Tags"`: Metadata to assign to the environment. Tags help organize and categorize your
  AppConfig resources. Each tag consists of a key and an optional value, both of which you
  define.
"""
function create_environment(
    ApplicationId, Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appconfig(
        "POST",
        "/applications/$(ApplicationId)/environments",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_environment(
    ApplicationId,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appconfig(
        "POST",
        "/applications/$(ApplicationId)/environments",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_extension(actions, name)
    create_extension(actions, name, params::Dict{String,<:Any})

Creates an AppConfig extension. An extension augments your ability to inject logic or
behavior at different points during the AppConfig workflow of creating or deploying a
configuration. You can create your own extensions or use the Amazon Web Services authored
extensions provided by AppConfig. For an AppConfig extension that uses Lambda, you must
create a Lambda function to perform any computation and processing defined in the
extension. If you plan to create custom versions of the Amazon Web Services authored
notification extensions, you only need to specify an Amazon Resource Name (ARN) in the Uri
field for the new extension version.   For a custom EventBridge notification extension,
enter the ARN of the EventBridge default events in the Uri field.   For a custom Amazon SNS
notification extension, enter the ARN of an Amazon SNS topic in the Uri field.   For a
custom Amazon SQS notification extension, enter the ARN of an Amazon SQS message queue in
the Uri field.    For more information about extensions, see Extending workflows in the
AppConfig User Guide.

# Arguments
- `actions`: The actions defined in the extension.
- `name`: A name for the extension. Each extension name in your account must be unique.
  Extension versions use the same name.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: Information about the extension.
- `"Latest-Version-Number"`: You can omit this field when you create an extension. When you
  create a new version, specify the most recent current version number. For example, you
  create version 3, enter 2 for this field.
- `"Parameters"`: The parameters accepted by the extension. You specify parameter values
  when you associate the extension to an AppConfig resource by using the
  CreateExtensionAssociation API action. For Lambda extension actions, these parameters are
  included in the Lambda request object.
- `"Tags"`: Adds one or more tags for the specified extension. Tags are metadata that help
  you categorize resources in different ways, for example, by purpose, owner, or environment.
  Each tag consists of a key and an optional value, both of which you define.
"""
function create_extension(Actions, Name; aws_config::AbstractAWSConfig=current_aws_config())
    return appconfig(
        "POST",
        "/extensions",
        Dict{String,Any}("Actions" => Actions, "Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_extension(
    Actions,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appconfig(
        "POST",
        "/extensions",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("Actions" => Actions, "Name" => Name), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_extension_association(extension_identifier, resource_identifier)
    create_extension_association(extension_identifier, resource_identifier, params::Dict{String,<:Any})

When you create an extension or configure an Amazon Web Services authored extension, you
associate the extension with an AppConfig application, environment, or configuration
profile. For example, you can choose to run the AppConfig deployment events to Amazon SNS
Amazon Web Services authored extension and receive notifications on an Amazon SNS topic
anytime a configuration deployment is started for a specific application. Defining which
extension to associate with an AppConfig resource is called an extension association. An
extension association is a specified relationship between an extension and an AppConfig
resource, such as an application or a configuration profile. For more information about
extensions and associations, see Extending workflows in the AppConfig User Guide.

# Arguments
- `extension_identifier`: The name, the ID, or the Amazon Resource Name (ARN) of the
  extension.
- `resource_identifier`: The ARN of an application, configuration profile, or environment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ExtensionVersionNumber"`: The version number of the extension. If not specified,
  AppConfig uses the maximum version of the extension.
- `"Parameters"`: The parameter names and values defined in the extensions. Extension
  parameters marked Required must be entered for this field.
- `"Tags"`: Adds one or more tags for the specified extension association. Tags are
  metadata that help you categorize resources in different ways, for example, by purpose,
  owner, or environment. Each tag consists of a key and an optional value, both of which you
  define.
"""
function create_extension_association(
    ExtensionIdentifier,
    ResourceIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appconfig(
        "POST",
        "/extensionassociations",
        Dict{String,Any}(
            "ExtensionIdentifier" => ExtensionIdentifier,
            "ResourceIdentifier" => ResourceIdentifier,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_extension_association(
    ExtensionIdentifier,
    ResourceIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appconfig(
        "POST",
        "/extensionassociations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ExtensionIdentifier" => ExtensionIdentifier,
                    "ResourceIdentifier" => ResourceIdentifier,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_hosted_configuration_version(application_id, configuration_profile_id, content, content-_type)
    create_hosted_configuration_version(application_id, configuration_profile_id, content, content-_type, params::Dict{String,<:Any})

Creates a new configuration in the AppConfig hosted configuration store.

# Arguments
- `application_id`: The application ID.
- `configuration_profile_id`: The configuration profile ID.
- `content`: The content of the configuration or the configuration data.
- `content-_type`: A standard MIME type describing the format of the configuration content.
  For more information, see Content-Type.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description of the configuration.
- `"Latest-Version-Number"`: An optional locking token used to prevent race conditions from
  overwriting configuration updates when creating a new version. To ensure your data is not
  overwritten when creating multiple hosted configuration versions in rapid succession,
  specify the version number of the latest hosted configuration version.
- `"VersionLabel"`: An optional, user-defined label for the AppConfig hosted configuration
  version. This value must contain at least one non-numeric character. For example,
  \"v2.2.0\".
"""
function create_hosted_configuration_version(
    ApplicationId,
    ConfigurationProfileId,
    Content,
    Content_Type;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appconfig(
        "POST",
        "/applications/$(ApplicationId)/configurationprofiles/$(ConfigurationProfileId)/hostedconfigurationversions",
        Dict{String,Any}(
            "Content" => Content,
            "headers" => Dict{String,Any}("Content-Type" => Content_Type),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_hosted_configuration_version(
    ApplicationId,
    ConfigurationProfileId,
    Content,
    Content_Type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appconfig(
        "POST",
        "/applications/$(ApplicationId)/configurationprofiles/$(ConfigurationProfileId)/hostedconfigurationversions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Content" => Content,
                    "headers" => Dict{String,Any}("Content-Type" => Content_Type),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_application(application_id)
    delete_application(application_id, params::Dict{String,<:Any})

Deletes an application. Deleting an application does not delete a configuration from a host.

# Arguments
- `application_id`: The ID of the application to delete.

"""
function delete_application(
    ApplicationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appconfig(
        "DELETE",
        "/applications/$(ApplicationId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_application(
    ApplicationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appconfig(
        "DELETE",
        "/applications/$(ApplicationId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_configuration_profile(application_id, configuration_profile_id)
    delete_configuration_profile(application_id, configuration_profile_id, params::Dict{String,<:Any})

Deletes a configuration profile. Deleting a configuration profile does not delete a
configuration from a host.

# Arguments
- `application_id`: The application ID that includes the configuration profile you want to
  delete.
- `configuration_profile_id`: The ID of the configuration profile you want to delete.

"""
function delete_configuration_profile(
    ApplicationId,
    ConfigurationProfileId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appconfig(
        "DELETE",
        "/applications/$(ApplicationId)/configurationprofiles/$(ConfigurationProfileId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_configuration_profile(
    ApplicationId,
    ConfigurationProfileId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appconfig(
        "DELETE",
        "/applications/$(ApplicationId)/configurationprofiles/$(ConfigurationProfileId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_deployment_strategy(deployment_strategy_id)
    delete_deployment_strategy(deployment_strategy_id, params::Dict{String,<:Any})

Deletes a deployment strategy. Deleting a deployment strategy does not delete a
configuration from a host.

# Arguments
- `deployment_strategy_id`: The ID of the deployment strategy you want to delete.

"""
function delete_deployment_strategy(
    DeploymentStrategyId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appconfig(
        "DELETE",
        "/deployementstrategies/$(DeploymentStrategyId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_deployment_strategy(
    DeploymentStrategyId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appconfig(
        "DELETE",
        "/deployementstrategies/$(DeploymentStrategyId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_environment(application_id, environment_id)
    delete_environment(application_id, environment_id, params::Dict{String,<:Any})

Deletes an environment. Deleting an environment does not delete a configuration from a host.

# Arguments
- `application_id`: The application ID that includes the environment that you want to
  delete.
- `environment_id`: The ID of the environment that you want to delete.

"""
function delete_environment(
    ApplicationId, EnvironmentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appconfig(
        "DELETE",
        "/applications/$(ApplicationId)/environments/$(EnvironmentId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_environment(
    ApplicationId,
    EnvironmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appconfig(
        "DELETE",
        "/applications/$(ApplicationId)/environments/$(EnvironmentId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_extension(extension_identifier)
    delete_extension(extension_identifier, params::Dict{String,<:Any})

Deletes an AppConfig extension. You must delete all associations to an extension before you
delete the extension.

# Arguments
- `extension_identifier`: The name, ID, or Amazon Resource Name (ARN) of the extension you
  want to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"version"`: A specific version of an extension to delete. If omitted, the highest
  version is deleted.
"""
function delete_extension(
    ExtensionIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appconfig(
        "DELETE",
        "/extensions/$(ExtensionIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_extension(
    ExtensionIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appconfig(
        "DELETE",
        "/extensions/$(ExtensionIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_extension_association(extension_association_id)
    delete_extension_association(extension_association_id, params::Dict{String,<:Any})

Deletes an extension association. This action doesn't delete extensions defined in the
association.

# Arguments
- `extension_association_id`: The ID of the extension association to delete.

"""
function delete_extension_association(
    ExtensionAssociationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appconfig(
        "DELETE",
        "/extensionassociations/$(ExtensionAssociationId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_extension_association(
    ExtensionAssociationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appconfig(
        "DELETE",
        "/extensionassociations/$(ExtensionAssociationId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_hosted_configuration_version(application_id, configuration_profile_id, version_number)
    delete_hosted_configuration_version(application_id, configuration_profile_id, version_number, params::Dict{String,<:Any})

Deletes a version of a configuration from the AppConfig hosted configuration store.

# Arguments
- `application_id`: The application ID.
- `configuration_profile_id`: The configuration profile ID.
- `version_number`: The versions number to delete.

"""
function delete_hosted_configuration_version(
    ApplicationId,
    ConfigurationProfileId,
    VersionNumber;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appconfig(
        "DELETE",
        "/applications/$(ApplicationId)/configurationprofiles/$(ConfigurationProfileId)/hostedconfigurationversions/$(VersionNumber)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_hosted_configuration_version(
    ApplicationId,
    ConfigurationProfileId,
    VersionNumber,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appconfig(
        "DELETE",
        "/applications/$(ApplicationId)/configurationprofiles/$(ConfigurationProfileId)/hostedconfigurationversions/$(VersionNumber)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_application(application_id)
    get_application(application_id, params::Dict{String,<:Any})

Retrieves information about an application.

# Arguments
- `application_id`: The ID of the application you want to get.

"""
function get_application(ApplicationId; aws_config::AbstractAWSConfig=current_aws_config())
    return appconfig(
        "GET",
        "/applications/$(ApplicationId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_application(
    ApplicationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appconfig(
        "GET",
        "/applications/$(ApplicationId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_configuration(application, configuration, environment, client_id)
    get_configuration(application, configuration, environment, client_id, params::Dict{String,<:Any})

(Deprecated) Retrieves the latest deployed configuration.  Note the following important
information.   This API action is deprecated. Calls to receive configuration data should
use the StartConfigurationSession and GetLatestConfiguration APIs instead.
GetConfiguration is a priced call. For more information, see Pricing.

# Arguments
- `application`: The application to get. Specify either the application name or the
  application ID.
- `configuration`: The configuration to get. Specify either the configuration name or the
  configuration ID.
- `environment`: The environment to get. Specify either the environment name or the
  environment ID.
- `client_id`: The clientId parameter in the following command is a unique, user-specified
  ID to identify the client for the configuration. This ID enables AppConfig to deploy the
  configuration in intervals, as defined in the deployment strategy.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"client_configuration_version"`: The configuration version returned in the most recent
  GetConfiguration response.  AppConfig uses the value of the ClientConfigurationVersion
  parameter to identify the configuration version on your clients. If you don’t send
  ClientConfigurationVersion with each call to GetConfiguration, your clients receive the
  current configuration. You are charged each time your clients receive a configuration. To
  avoid excess charges, we recommend you use the StartConfigurationSession and
  GetLatestConfiguration APIs, which track the client configuration version on your behalf.
  If you choose to continue using GetConfiguration, we recommend that you include the
  ClientConfigurationVersion value with every call to GetConfiguration. The value to use for
  ClientConfigurationVersion comes from the ConfigurationVersion attribute returned by
  GetConfiguration when there is new or updated data, and should be saved for subsequent
  calls to GetConfiguration.  For more information about working with configurations, see
  Retrieving the Configuration in the AppConfig User Guide.
"""
function get_configuration(
    Application,
    Configuration,
    Environment,
    client_id;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appconfig(
        "GET",
        "/applications/$(Application)/environments/$(Environment)/configurations/$(Configuration)",
        Dict{String,Any}("client_id" => client_id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_configuration(
    Application,
    Configuration,
    Environment,
    client_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appconfig(
        "GET",
        "/applications/$(Application)/environments/$(Environment)/configurations/$(Configuration)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("client_id" => client_id), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_configuration_profile(application_id, configuration_profile_id)
    get_configuration_profile(application_id, configuration_profile_id, params::Dict{String,<:Any})

Retrieves information about a configuration profile.

# Arguments
- `application_id`: The ID of the application that includes the configuration profile you
  want to get.
- `configuration_profile_id`: The ID of the configuration profile that you want to get.

"""
function get_configuration_profile(
    ApplicationId,
    ConfigurationProfileId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appconfig(
        "GET",
        "/applications/$(ApplicationId)/configurationprofiles/$(ConfigurationProfileId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_configuration_profile(
    ApplicationId,
    ConfigurationProfileId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appconfig(
        "GET",
        "/applications/$(ApplicationId)/configurationprofiles/$(ConfigurationProfileId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_deployment(application_id, deployment_number, environment_id)
    get_deployment(application_id, deployment_number, environment_id, params::Dict{String,<:Any})

Retrieves information about a configuration deployment.

# Arguments
- `application_id`: The ID of the application that includes the deployment you want to get.
- `deployment_number`: The sequence number of the deployment.
- `environment_id`: The ID of the environment that includes the deployment you want to get.

"""
function get_deployment(
    ApplicationId,
    DeploymentNumber,
    EnvironmentId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appconfig(
        "GET",
        "/applications/$(ApplicationId)/environments/$(EnvironmentId)/deployments/$(DeploymentNumber)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_deployment(
    ApplicationId,
    DeploymentNumber,
    EnvironmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appconfig(
        "GET",
        "/applications/$(ApplicationId)/environments/$(EnvironmentId)/deployments/$(DeploymentNumber)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_deployment_strategy(deployment_strategy_id)
    get_deployment_strategy(deployment_strategy_id, params::Dict{String,<:Any})

Retrieves information about a deployment strategy. A deployment strategy defines important
criteria for rolling out your configuration to the designated targets. A deployment
strategy includes the overall duration required, a percentage of targets to receive the
deployment during each interval, an algorithm that defines how percentage grows, and bake
time.

# Arguments
- `deployment_strategy_id`: The ID of the deployment strategy to get.

"""
function get_deployment_strategy(
    DeploymentStrategyId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appconfig(
        "GET",
        "/deploymentstrategies/$(DeploymentStrategyId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_deployment_strategy(
    DeploymentStrategyId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appconfig(
        "GET",
        "/deploymentstrategies/$(DeploymentStrategyId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_environment(application_id, environment_id)
    get_environment(application_id, environment_id, params::Dict{String,<:Any})

Retrieves information about an environment. An environment is a deployment group of
AppConfig applications, such as applications in a Production environment or in an EU_Region
environment. Each configuration deployment targets an environment. You can enable one or
more Amazon CloudWatch alarms for an environment. If an alarm is triggered during a
deployment, AppConfig roles back the configuration.

# Arguments
- `application_id`: The ID of the application that includes the environment you want to get.
- `environment_id`: The ID of the environment that you want to get.

"""
function get_environment(
    ApplicationId, EnvironmentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appconfig(
        "GET",
        "/applications/$(ApplicationId)/environments/$(EnvironmentId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_environment(
    ApplicationId,
    EnvironmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appconfig(
        "GET",
        "/applications/$(ApplicationId)/environments/$(EnvironmentId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_extension(extension_identifier)
    get_extension(extension_identifier, params::Dict{String,<:Any})

Returns information about an AppConfig extension.

# Arguments
- `extension_identifier`: The name, the ID, or the Amazon Resource Name (ARN) of the
  extension.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"version_number"`: The extension version number. If no version number was defined,
  AppConfig uses the highest version.
"""
function get_extension(
    ExtensionIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appconfig(
        "GET",
        "/extensions/$(ExtensionIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_extension(
    ExtensionIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appconfig(
        "GET",
        "/extensions/$(ExtensionIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_extension_association(extension_association_id)
    get_extension_association(extension_association_id, params::Dict{String,<:Any})

Returns information about an AppConfig extension association. For more information about
extensions and associations, see Extending workflows in the AppConfig User Guide.

# Arguments
- `extension_association_id`: The extension association ID to get.

"""
function get_extension_association(
    ExtensionAssociationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appconfig(
        "GET",
        "/extensionassociations/$(ExtensionAssociationId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_extension_association(
    ExtensionAssociationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appconfig(
        "GET",
        "/extensionassociations/$(ExtensionAssociationId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_hosted_configuration_version(application_id, configuration_profile_id, version_number)
    get_hosted_configuration_version(application_id, configuration_profile_id, version_number, params::Dict{String,<:Any})

Retrieves information about a specific configuration version.

# Arguments
- `application_id`: The application ID.
- `configuration_profile_id`: The configuration profile ID.
- `version_number`: The version.

"""
function get_hosted_configuration_version(
    ApplicationId,
    ConfigurationProfileId,
    VersionNumber;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appconfig(
        "GET",
        "/applications/$(ApplicationId)/configurationprofiles/$(ConfigurationProfileId)/hostedconfigurationversions/$(VersionNumber)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_hosted_configuration_version(
    ApplicationId,
    ConfigurationProfileId,
    VersionNumber,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appconfig(
        "GET",
        "/applications/$(ApplicationId)/configurationprofiles/$(ConfigurationProfileId)/hostedconfigurationversions/$(VersionNumber)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_applications()
    list_applications(params::Dict{String,<:Any})

Lists all applications in your Amazon Web Services account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"max_results"`: The maximum number of items to return for this call. The call also
  returns a token that you can specify in a subsequent call to get the next set of results.
- `"next_token"`: A token to start the list. Next token is a pagination token generated by
  AppConfig to describe what page the previous List call ended on. For the first List
  request, the nextToken should not be set. On subsequent calls, the nextToken parameter
  should be set to the previous responses nextToken value. Use this token to get the next set
  of results.
"""
function list_applications(; aws_config::AbstractAWSConfig=current_aws_config())
    return appconfig(
        "GET", "/applications"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_applications(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appconfig(
        "GET",
        "/applications",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_configuration_profiles(application_id)
    list_configuration_profiles(application_id, params::Dict{String,<:Any})

Lists the configuration profiles for an application.

# Arguments
- `application_id`: The application ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"max_results"`: The maximum number of items to return for this call. The call also
  returns a token that you can specify in a subsequent call to get the next set of results.
- `"next_token"`: A token to start the list. Use this token to get the next set of results.
- `"type"`: A filter based on the type of configurations that the configuration profile
  contains. A configuration can be a feature flag or a freeform configuration.
"""
function list_configuration_profiles(
    ApplicationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appconfig(
        "GET",
        "/applications/$(ApplicationId)/configurationprofiles";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_configuration_profiles(
    ApplicationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appconfig(
        "GET",
        "/applications/$(ApplicationId)/configurationprofiles",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_deployment_strategies()
    list_deployment_strategies(params::Dict{String,<:Any})

Lists deployment strategies.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"max_results"`: The maximum number of items to return for this call. The call also
  returns a token that you can specify in a subsequent call to get the next set of results.
- `"next_token"`: A token to start the list. Use this token to get the next set of results.
"""
function list_deployment_strategies(; aws_config::AbstractAWSConfig=current_aws_config())
    return appconfig(
        "GET",
        "/deploymentstrategies";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_deployment_strategies(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appconfig(
        "GET",
        "/deploymentstrategies",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_deployments(application_id, environment_id)
    list_deployments(application_id, environment_id, params::Dict{String,<:Any})

Lists the deployments for an environment in descending deployment number order.

# Arguments
- `application_id`: The application ID.
- `environment_id`: The environment ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"max_results"`: The maximum number of items that may be returned for this call. If there
  are items that have not yet been returned, the response will include a non-null NextToken
  that you can provide in a subsequent call to get the next set of results.
- `"next_token"`: The token returned by a prior call to this operation indicating the next
  set of results to be returned. If not specified, the operation will return the first set of
  results.
"""
function list_deployments(
    ApplicationId, EnvironmentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appconfig(
        "GET",
        "/applications/$(ApplicationId)/environments/$(EnvironmentId)/deployments";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_deployments(
    ApplicationId,
    EnvironmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appconfig(
        "GET",
        "/applications/$(ApplicationId)/environments/$(EnvironmentId)/deployments",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_environments(application_id)
    list_environments(application_id, params::Dict{String,<:Any})

Lists the environments for an application.

# Arguments
- `application_id`: The application ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"max_results"`: The maximum number of items to return for this call. The call also
  returns a token that you can specify in a subsequent call to get the next set of results.
- `"next_token"`: A token to start the list. Use this token to get the next set of results.
"""
function list_environments(
    ApplicationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appconfig(
        "GET",
        "/applications/$(ApplicationId)/environments";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_environments(
    ApplicationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appconfig(
        "GET",
        "/applications/$(ApplicationId)/environments",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_extension_associations()
    list_extension_associations(params::Dict{String,<:Any})

Lists all AppConfig extension associations in the account. For more information about
extensions and associations, see Extending workflows in the AppConfig User Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"extension_identifier"`: The name, the ID, or the Amazon Resource Name (ARN) of the
  extension.
- `"extension_version_number"`: The version number for the extension defined in the
  association.
- `"max_results"`: The maximum number of items to return for this call. The call also
  returns a token that you can specify in a subsequent call to get the next set of results.
- `"next_token"`: A token to start the list. Use this token to get the next set of results
  or pass null to get the first set of results.
- `"resource_identifier"`: The ARN of an application, configuration profile, or environment.
"""
function list_extension_associations(; aws_config::AbstractAWSConfig=current_aws_config())
    return appconfig(
        "GET",
        "/extensionassociations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_extension_associations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appconfig(
        "GET",
        "/extensionassociations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_extensions()
    list_extensions(params::Dict{String,<:Any})

Lists all custom and Amazon Web Services authored AppConfig extensions in the account. For
more information about extensions, see Extending workflows in the AppConfig User Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"max_results"`: The maximum number of items to return for this call. The call also
  returns a token that you can specify in a subsequent call to get the next set of results.
- `"name"`: The extension name.
- `"next_token"`: A token to start the list. Use this token to get the next set of results.
"""
function list_extensions(; aws_config::AbstractAWSConfig=current_aws_config())
    return appconfig(
        "GET", "/extensions"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_extensions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appconfig(
        "GET", "/extensions", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_hosted_configuration_versions(application_id, configuration_profile_id)
    list_hosted_configuration_versions(application_id, configuration_profile_id, params::Dict{String,<:Any})

Lists configurations stored in the AppConfig hosted configuration store by version.

# Arguments
- `application_id`: The application ID.
- `configuration_profile_id`: The configuration profile ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"max_results"`: The maximum number of items to return for this call. The call also
  returns a token that you can specify in a subsequent call to get the next set of results.
- `"next_token"`: A token to start the list. Use this token to get the next set of results.
- `"version_label"`: An optional filter that can be used to specify the version label of an
  AppConfig hosted configuration version. This parameter supports filtering by prefix using a
  wildcard, for example \"v2*\". If you don't specify an asterisk at the end of the value,
  only an exact match is returned.
"""
function list_hosted_configuration_versions(
    ApplicationId,
    ConfigurationProfileId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appconfig(
        "GET",
        "/applications/$(ApplicationId)/configurationprofiles/$(ConfigurationProfileId)/hostedconfigurationversions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_hosted_configuration_versions(
    ApplicationId,
    ConfigurationProfileId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appconfig(
        "GET",
        "/applications/$(ApplicationId)/configurationprofiles/$(ConfigurationProfileId)/hostedconfigurationversions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Retrieves the list of key-value tags assigned to the resource.

# Arguments
- `resource_arn`: The resource ARN.

"""
function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appconfig(
        "GET",
        "/tags/$(ResourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appconfig(
        "GET",
        "/tags/$(ResourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_deployment(application_id, configuration_profile_id, configuration_version, deployment_strategy_id, environment_id)
    start_deployment(application_id, configuration_profile_id, configuration_version, deployment_strategy_id, environment_id, params::Dict{String,<:Any})

Starts a deployment.

# Arguments
- `application_id`: The application ID.
- `configuration_profile_id`: The configuration profile ID.
- `configuration_version`: The configuration version to deploy. If deploying an AppConfig
  hosted configuration version, you can specify either the version number or version label.
  For all other configurations, you must specify the version number.
- `deployment_strategy_id`: The deployment strategy ID.
- `environment_id`: The environment ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description of the deployment.
- `"DynamicExtensionParameters"`: A map of dynamic extension parameter names to values to
  pass to associated extensions with PRE_START_DEPLOYMENT actions.
- `"KmsKeyIdentifier"`: The KMS key identifier (key ID, key alias, or key ARN). AppConfig
  uses this ID to encrypt the configuration data using a customer managed key.
- `"Tags"`: Metadata to assign to the deployment. Tags help organize and categorize your
  AppConfig resources. Each tag consists of a key and an optional value, both of which you
  define.
"""
function start_deployment(
    ApplicationId,
    ConfigurationProfileId,
    ConfigurationVersion,
    DeploymentStrategyId,
    EnvironmentId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appconfig(
        "POST",
        "/applications/$(ApplicationId)/environments/$(EnvironmentId)/deployments",
        Dict{String,Any}(
            "ConfigurationProfileId" => ConfigurationProfileId,
            "ConfigurationVersion" => ConfigurationVersion,
            "DeploymentStrategyId" => DeploymentStrategyId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_deployment(
    ApplicationId,
    ConfigurationProfileId,
    ConfigurationVersion,
    DeploymentStrategyId,
    EnvironmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appconfig(
        "POST",
        "/applications/$(ApplicationId)/environments/$(EnvironmentId)/deployments",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ConfigurationProfileId" => ConfigurationProfileId,
                    "ConfigurationVersion" => ConfigurationVersion,
                    "DeploymentStrategyId" => DeploymentStrategyId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_deployment(application_id, deployment_number, environment_id)
    stop_deployment(application_id, deployment_number, environment_id, params::Dict{String,<:Any})

Stops a deployment. This API action works only on deployments that have a status of
DEPLOYING. This action moves the deployment to a status of ROLLED_BACK.

# Arguments
- `application_id`: The application ID.
- `deployment_number`: The sequence number of the deployment.
- `environment_id`: The environment ID.

"""
function stop_deployment(
    ApplicationId,
    DeploymentNumber,
    EnvironmentId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appconfig(
        "DELETE",
        "/applications/$(ApplicationId)/environments/$(EnvironmentId)/deployments/$(DeploymentNumber)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_deployment(
    ApplicationId,
    DeploymentNumber,
    EnvironmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appconfig(
        "DELETE",
        "/applications/$(ApplicationId)/environments/$(EnvironmentId)/deployments/$(DeploymentNumber)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Assigns metadata to an AppConfig resource. Tags help organize and categorize your AppConfig
resources. Each tag consists of a key and an optional value, both of which you define. You
can specify a maximum of 50 tags for a resource.

# Arguments
- `resource_arn`: The ARN of the resource for which to retrieve tags.
- `tags`: The key-value string map. The valid character set is [a-zA-Z+-=._:/]. The tag key
  can be up to 128 characters and must not start with aws:. The tag value can be up to 256
  characters.

"""
function tag_resource(ResourceArn, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return appconfig(
        "POST",
        "/tags/$(ResourceArn)",
        Dict{String,Any}("Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceArn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appconfig(
        "POST",
        "/tags/$(ResourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Tags" => Tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Deletes a tag key and value from an AppConfig resource.

# Arguments
- `resource_arn`: The ARN of the resource for which to remove tags.
- `tag_keys`: The tag keys to delete.

"""
function untag_resource(
    ResourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appconfig(
        "DELETE",
        "/tags/$(ResourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appconfig(
        "DELETE",
        "/tags/$(ResourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_application(application_id)
    update_application(application_id, params::Dict{String,<:Any})

Updates an application.

# Arguments
- `application_id`: The application ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description of the application.
- `"Name"`: The name of the application.
"""
function update_application(
    ApplicationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appconfig(
        "PATCH",
        "/applications/$(ApplicationId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_application(
    ApplicationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appconfig(
        "PATCH",
        "/applications/$(ApplicationId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_configuration_profile(application_id, configuration_profile_id)
    update_configuration_profile(application_id, configuration_profile_id, params::Dict{String,<:Any})

Updates a configuration profile.

# Arguments
- `application_id`: The application ID.
- `configuration_profile_id`: The ID of the configuration profile.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description of the configuration profile.
- `"KmsKeyIdentifier"`: The identifier for a Key Management Service key to encrypt new
  configuration data versions in the AppConfig hosted configuration store. This attribute is
  only used for hosted configuration types. The identifier can be an KMS key ID, alias, or
  the Amazon Resource Name (ARN) of the key ID or alias. To encrypt data managed in other
  configuration stores, see the documentation for how to specify an KMS key for that
  particular service.
- `"Name"`: The name of the configuration profile.
- `"RetrievalRoleArn"`: The ARN of an IAM role with permission to access the configuration
  at the specified LocationUri.
- `"Validators"`: A list of methods for validating the configuration.
"""
function update_configuration_profile(
    ApplicationId,
    ConfigurationProfileId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appconfig(
        "PATCH",
        "/applications/$(ApplicationId)/configurationprofiles/$(ConfigurationProfileId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_configuration_profile(
    ApplicationId,
    ConfigurationProfileId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appconfig(
        "PATCH",
        "/applications/$(ApplicationId)/configurationprofiles/$(ConfigurationProfileId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_deployment_strategy(deployment_strategy_id)
    update_deployment_strategy(deployment_strategy_id, params::Dict{String,<:Any})

Updates a deployment strategy.

# Arguments
- `deployment_strategy_id`: The deployment strategy ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DeploymentDurationInMinutes"`: Total amount of time for a deployment to last.
- `"Description"`: A description of the deployment strategy.
- `"FinalBakeTimeInMinutes"`: The amount of time that AppConfig monitors for alarms before
  considering the deployment to be complete and no longer eligible for automatic rollback.
- `"GrowthFactor"`: The percentage of targets to receive a deployed configuration during
  each interval.
- `"GrowthType"`: The algorithm used to define how percentage grows over time. AppConfig
  supports the following growth types:  Linear: For this type, AppConfig processes the
  deployment by increments of the growth factor evenly distributed over the deployment time.
  For example, a linear deployment that uses a growth factor of 20 initially makes the
  configuration available to 20 percent of the targets. After 1/5th of the deployment time
  has passed, the system updates the percentage to 40 percent. This continues until 100% of
  the targets are set to receive the deployed configuration.  Exponential: For this type,
  AppConfig processes the deployment exponentially using the following formula: G*(2^N). In
  this formula, G is the growth factor specified by the user and N is the number of steps
  until the configuration is deployed to all targets. For example, if you specify a growth
  factor of 2, then the system rolls out the configuration as follows:  2*(2^0)   2*(2^1)
  2*(2^2)  Expressed numerically, the deployment rolls out as follows: 2% of the targets, 4%
  of the targets, 8% of the targets, and continues until the configuration has been deployed
  to all targets.
"""
function update_deployment_strategy(
    DeploymentStrategyId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appconfig(
        "PATCH",
        "/deploymentstrategies/$(DeploymentStrategyId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_deployment_strategy(
    DeploymentStrategyId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appconfig(
        "PATCH",
        "/deploymentstrategies/$(DeploymentStrategyId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_environment(application_id, environment_id)
    update_environment(application_id, environment_id, params::Dict{String,<:Any})

Updates an environment.

# Arguments
- `application_id`: The application ID.
- `environment_id`: The environment ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description of the environment.
- `"Monitors"`: Amazon CloudWatch alarms to monitor during the deployment process.
- `"Name"`: The name of the environment.
"""
function update_environment(
    ApplicationId, EnvironmentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appconfig(
        "PATCH",
        "/applications/$(ApplicationId)/environments/$(EnvironmentId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_environment(
    ApplicationId,
    EnvironmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appconfig(
        "PATCH",
        "/applications/$(ApplicationId)/environments/$(EnvironmentId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_extension(extension_identifier)
    update_extension(extension_identifier, params::Dict{String,<:Any})

Updates an AppConfig extension. For more information about extensions, see Extending
workflows in the AppConfig User Guide.

# Arguments
- `extension_identifier`: The name, the ID, or the Amazon Resource Name (ARN) of the
  extension.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Actions"`: The actions defined in the extension.
- `"Description"`: Information about the extension.
- `"Parameters"`: One or more parameters for the actions called by the extension.
- `"VersionNumber"`: The extension version number.
"""
function update_extension(
    ExtensionIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appconfig(
        "PATCH",
        "/extensions/$(ExtensionIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_extension(
    ExtensionIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appconfig(
        "PATCH",
        "/extensions/$(ExtensionIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_extension_association(extension_association_id)
    update_extension_association(extension_association_id, params::Dict{String,<:Any})

Updates an association. For more information about extensions and associations, see
Extending workflows in the AppConfig User Guide.

# Arguments
- `extension_association_id`: The system-generated ID for the association.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Parameters"`: The parameter names and values defined in the extension.
"""
function update_extension_association(
    ExtensionAssociationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appconfig(
        "PATCH",
        "/extensionassociations/$(ExtensionAssociationId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_extension_association(
    ExtensionAssociationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appconfig(
        "PATCH",
        "/extensionassociations/$(ExtensionAssociationId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    validate_configuration(application_id, configuration_profile_id, configuration_version)
    validate_configuration(application_id, configuration_profile_id, configuration_version, params::Dict{String,<:Any})

Uses the validators in a configuration profile to validate a configuration.

# Arguments
- `application_id`: The application ID.
- `configuration_profile_id`: The configuration profile ID.
- `configuration_version`: The version of the configuration to validate.

"""
function validate_configuration(
    ApplicationId,
    ConfigurationProfileId,
    configuration_version;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appconfig(
        "POST",
        "/applications/$(ApplicationId)/configurationprofiles/$(ConfigurationProfileId)/validators",
        Dict{String,Any}("configuration_version" => configuration_version);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function validate_configuration(
    ApplicationId,
    ConfigurationProfileId,
    configuration_version,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appconfig(
        "POST",
        "/applications/$(ApplicationId)/configurationprofiles/$(ConfigurationProfileId)/validators",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("configuration_version" => configuration_version),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: chime_sdk_voice
using AWS.Compat
using AWS.UUIDs

"""
    associate_phone_numbers_with_voice_connector(e164_phone_numbers, voice_connector_id)
    associate_phone_numbers_with_voice_connector(e164_phone_numbers, voice_connector_id, params::Dict{String,<:Any})

Associates phone numbers with the specified Amazon Chime SDK Voice Connector.

# Arguments
- `e164_phone_numbers`: List of phone numbers, in E.164 format.
- `voice_connector_id`: The Voice Connector ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ForceAssociate"`: If true, associates the provided phone numbers with the provided
  Amazon Chime SDK Voice Connector and removes any previously existing associations. If
  false, does not associate any phone numbers that have previously existing associations.
"""
function associate_phone_numbers_with_voice_connector(
    E164PhoneNumbers, voiceConnectorId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "POST",
        "/voice-connectors/$(voiceConnectorId)?operation=associate-phone-numbers",
        Dict{String,Any}("E164PhoneNumbers" => E164PhoneNumbers);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_phone_numbers_with_voice_connector(
    E164PhoneNumbers,
    voiceConnectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "POST",
        "/voice-connectors/$(voiceConnectorId)?operation=associate-phone-numbers",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("E164PhoneNumbers" => E164PhoneNumbers), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_phone_numbers_with_voice_connector_group(e164_phone_numbers, voice_connector_group_id)
    associate_phone_numbers_with_voice_connector_group(e164_phone_numbers, voice_connector_group_id, params::Dict{String,<:Any})

Associates phone numbers with the specified Amazon Chime SDK Voice Connector group.

# Arguments
- `e164_phone_numbers`: List of phone numbers, in E.164 format.
- `voice_connector_group_id`: The Amazon Chime SDK Voice Connector group ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ForceAssociate"`: If true, associates the provided phone numbers with the provided
  Amazon Chime SDK Voice Connector Group and removes any previously existing associations. If
  false, does not associate any phone numbers that have previously existing associations.
"""
function associate_phone_numbers_with_voice_connector_group(
    E164PhoneNumbers,
    voiceConnectorGroupId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "POST",
        "/voice-connector-groups/$(voiceConnectorGroupId)?operation=associate-phone-numbers",
        Dict{String,Any}("E164PhoneNumbers" => E164PhoneNumbers);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_phone_numbers_with_voice_connector_group(
    E164PhoneNumbers,
    voiceConnectorGroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "POST",
        "/voice-connector-groups/$(voiceConnectorGroupId)?operation=associate-phone-numbers",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("E164PhoneNumbers" => E164PhoneNumbers), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_delete_phone_number(phone_number_ids)
    batch_delete_phone_number(phone_number_ids, params::Dict{String,<:Any})

 Moves phone numbers into the Deletion queue. Phone numbers must be disassociated from any
users or Amazon Chime SDK Voice Connectors before they can be deleted.   Phone numbers
remain in the Deletion queue for 7 days before they are deleted permanently.

# Arguments
- `phone_number_ids`: List of phone number IDs.

"""
function batch_delete_phone_number(
    PhoneNumberIds; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "POST",
        "/phone-numbers?operation=batch-delete",
        Dict{String,Any}("PhoneNumberIds" => PhoneNumberIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_delete_phone_number(
    PhoneNumberIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "POST",
        "/phone-numbers?operation=batch-delete",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("PhoneNumberIds" => PhoneNumberIds), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_update_phone_number(update_phone_number_request_items)
    batch_update_phone_number(update_phone_number_request_items, params::Dict{String,<:Any})

Updates phone number product types, calling names, or phone number names. You can update
one attribute at a time for each UpdatePhoneNumberRequestItem. For example, you can update
the product type, the calling name, or phone name.   You cannot have a duplicate
phoneNumberId in a request.

# Arguments
- `update_phone_number_request_items`: Lists the phone numbers in the update request.

"""
function batch_update_phone_number(
    UpdatePhoneNumberRequestItems; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "POST",
        "/phone-numbers?operation=batch-update",
        Dict{String,Any}("UpdatePhoneNumberRequestItems" => UpdatePhoneNumberRequestItems);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_update_phone_number(
    UpdatePhoneNumberRequestItems,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "POST",
        "/phone-numbers?operation=batch-update",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "UpdatePhoneNumberRequestItems" => UpdatePhoneNumberRequestItems
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_phone_number_order(e164_phone_numbers, product_type)
    create_phone_number_order(e164_phone_numbers, product_type, params::Dict{String,<:Any})

Creates an order for phone numbers to be provisioned. For numbers outside the U.S., you
must use the Amazon Chime SDK SIP media application dial-in product type.

# Arguments
- `e164_phone_numbers`: List of phone numbers, in E.164 format.
- `product_type`: The phone number product type.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Name"`: Specifies the name assigned to one or more phone numbers.
"""
function create_phone_number_order(
    E164PhoneNumbers, ProductType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "POST",
        "/phone-number-orders",
        Dict{String,Any}(
            "E164PhoneNumbers" => E164PhoneNumbers, "ProductType" => ProductType
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_phone_number_order(
    E164PhoneNumbers,
    ProductType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "POST",
        "/phone-number-orders",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "E164PhoneNumbers" => E164PhoneNumbers, "ProductType" => ProductType
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_proxy_session(capabilities, participant_phone_numbers, voice_connector_id)
    create_proxy_session(capabilities, participant_phone_numbers, voice_connector_id, params::Dict{String,<:Any})

Creates a proxy session for the specified Amazon Chime SDK Voice Connector for the
specified participant phone numbers.

# Arguments
- `capabilities`: The proxy session's capabilities.
- `participant_phone_numbers`: The participant phone numbers.
- `voice_connector_id`: The Voice Connector ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ExpiryMinutes"`: The number of minutes allowed for the proxy session.
- `"GeoMatchLevel"`: The preference for matching the country or area code of the proxy
  phone number with that of the first participant.
- `"GeoMatchParams"`: The country and area code for the proxy phone number.
- `"Name"`: The name of the proxy session.
- `"NumberSelectionBehavior"`: The preference for proxy phone number reuse, or stickiness,
  between the same participants across sessions.
"""
function create_proxy_session(
    Capabilities,
    ParticipantPhoneNumbers,
    voiceConnectorId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "POST",
        "/voice-connectors/$(voiceConnectorId)/proxy-sessions",
        Dict{String,Any}(
            "Capabilities" => Capabilities,
            "ParticipantPhoneNumbers" => ParticipantPhoneNumbers,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_proxy_session(
    Capabilities,
    ParticipantPhoneNumbers,
    voiceConnectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "POST",
        "/voice-connectors/$(voiceConnectorId)/proxy-sessions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Capabilities" => Capabilities,
                    "ParticipantPhoneNumbers" => ParticipantPhoneNumbers,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_sip_media_application(aws_region, endpoints, name)
    create_sip_media_application(aws_region, endpoints, name, params::Dict{String,<:Any})

Creates a SIP media application. For more information about SIP media applications, see
Managing SIP media applications and rules in the Amazon Chime SDK Administrator Guide.

# Arguments
- `aws_region`: The AWS Region assigned to the SIP media application.
- `endpoints`: List of endpoints (Lambda ARNs) specified for the SIP media application.
- `name`: The SIP media application's name.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: The tags assigned to the SIP media application.
"""
function create_sip_media_application(
    AwsRegion, Endpoints, Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "POST",
        "/sip-media-applications",
        Dict{String,Any}(
            "AwsRegion" => AwsRegion, "Endpoints" => Endpoints, "Name" => Name
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_sip_media_application(
    AwsRegion,
    Endpoints,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "POST",
        "/sip-media-applications",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AwsRegion" => AwsRegion, "Endpoints" => Endpoints, "Name" => Name
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_sip_media_application_call(from_phone_number, to_phone_number, sip_media_application_id)
    create_sip_media_application_call(from_phone_number, to_phone_number, sip_media_application_id, params::Dict{String,<:Any})

Creates an outbound call to a phone number from the phone number specified in the request,
and it invokes the endpoint of the specified sipMediaApplicationId.

# Arguments
- `from_phone_number`: The phone number that a user calls from. This is a phone number in
  your Amazon Chime SDK phone number inventory.
- `to_phone_number`: The phone number that the service should call.
- `sip_media_application_id`: The ID of the SIP media application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ArgumentsMap"`: Context passed to a CreateSipMediaApplication API call. For example,
  you could pass key-value pairs such as: \"FirstName\": \"John\", \"LastName\": \"Doe\"
- `"SipHeaders"`: The SIP headers added to an outbound call leg.
"""
function create_sip_media_application_call(
    FromPhoneNumber,
    ToPhoneNumber,
    sipMediaApplicationId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "POST",
        "/sip-media-applications/$(sipMediaApplicationId)/calls",
        Dict{String,Any}(
            "FromPhoneNumber" => FromPhoneNumber, "ToPhoneNumber" => ToPhoneNumber
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_sip_media_application_call(
    FromPhoneNumber,
    ToPhoneNumber,
    sipMediaApplicationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "POST",
        "/sip-media-applications/$(sipMediaApplicationId)/calls",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "FromPhoneNumber" => FromPhoneNumber, "ToPhoneNumber" => ToPhoneNumber
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_sip_rule(name, trigger_type, trigger_value)
    create_sip_rule(name, trigger_type, trigger_value, params::Dict{String,<:Any})

Creates a SIP rule, which can be used to run a SIP media application as a target for a
specific trigger type. For more information about SIP rules, see Managing SIP media
applications and rules in the Amazon Chime SDK Administrator Guide.

# Arguments
- `name`: The name of the SIP rule.
- `trigger_type`: The type of trigger assigned to the SIP rule in TriggerValue, currently
  RequestUriHostname or ToPhoneNumber.
- `trigger_value`: If TriggerType is RequestUriHostname, the value can be the outbound host
  name of a Voice Connector. If TriggerType is ToPhoneNumber, the value can be a
  customer-owned phone number in the E164 format. The SipMediaApplication specified in the
  SipRule is triggered if the request URI in an incoming SIP request matches the
  RequestUriHostname, or if the To header in the incoming SIP request matches the
  ToPhoneNumber value.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Disabled"`: Disables or enables a SIP rule. You must disable SIP rules before you can
  delete them.
- `"TargetApplications"`: List of SIP media applications, with priority and AWS Region.
  Only one SIP application per AWS Region can be used.
"""
function create_sip_rule(
    Name, TriggerType, TriggerValue; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "POST",
        "/sip-rules",
        Dict{String,Any}(
            "Name" => Name, "TriggerType" => TriggerType, "TriggerValue" => TriggerValue
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_sip_rule(
    Name,
    TriggerType,
    TriggerValue,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "POST",
        "/sip-rules",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Name" => Name,
                    "TriggerType" => TriggerType,
                    "TriggerValue" => TriggerValue,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_voice_connector(name, require_encryption)
    create_voice_connector(name, require_encryption, params::Dict{String,<:Any})

Creates an Amazon Chime SDK Voice Connector. For more information about Voice Connectors,
see Managing Amazon Chime SDK Voice Connector groups in the Amazon Chime SDK Administrator
Guide.

# Arguments
- `name`: The name of the Voice Connector.
- `require_encryption`: Enables or disables encryption for the Voice Connector.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AwsRegion"`: The AWS Region in which the Amazon Chime SDK Voice Connector is created.
  Default value: us-east-1 .
- `"Tags"`: The tags assigned to the Voice Connector.
"""
function create_voice_connector(
    Name, RequireEncryption; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "POST",
        "/voice-connectors",
        Dict{String,Any}("Name" => Name, "RequireEncryption" => RequireEncryption);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_voice_connector(
    Name,
    RequireEncryption,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "POST",
        "/voice-connectors",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Name" => Name, "RequireEncryption" => RequireEncryption),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_voice_connector_group(name)
    create_voice_connector_group(name, params::Dict{String,<:Any})

Creates an Amazon Chime SDK Voice Connector group under the administrator's AWS account.
You can associate Amazon Chime SDK Voice Connectors with the Voice Connector group by
including VoiceConnectorItems in the request.  You can include Voice Connectors from
different AWS Regions in your group. This creates a fault tolerant mechanism for fallback
in case of availability events.

# Arguments
- `name`: The name of the Voice Connector group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"VoiceConnectorItems"`: Lists the Voice Connectors that inbound calls are routed to.
"""
function create_voice_connector_group(
    Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "POST",
        "/voice-connector-groups",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_voice_connector_group(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "POST",
        "/voice-connector-groups",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_voice_profile(speaker_search_task_id)
    create_voice_profile(speaker_search_task_id, params::Dict{String,<:Any})

Creates a voice profile, which consists of an enrolled user and their latest voice print.
Before creating any voice profiles, you must provide all notices and obtain all consents
from the speaker as required under applicable privacy and biometrics laws, and as required
under the AWS service terms for the Amazon Chime SDK.  For more information about voice
profiles and voice analytics, see Using Amazon Chime SDK Voice Analytics in the Amazon
Chime SDK Developer Guide.

# Arguments
- `speaker_search_task_id`: The ID of the speaker search task.

"""
function create_voice_profile(
    SpeakerSearchTaskId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "POST",
        "/voice-profiles",
        Dict{String,Any}("SpeakerSearchTaskId" => SpeakerSearchTaskId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_voice_profile(
    SpeakerSearchTaskId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "POST",
        "/voice-profiles",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("SpeakerSearchTaskId" => SpeakerSearchTaskId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_voice_profile_domain(name, server_side_encryption_configuration)
    create_voice_profile_domain(name, server_side_encryption_configuration, params::Dict{String,<:Any})

Creates a voice profile domain, a collection of voice profiles, their voice prints, and
encrypted enrollment audio.  Before creating any voice profiles, you must provide all
notices and obtain all consents from the speaker as required under applicable privacy and
biometrics laws, and as required under the AWS service terms for the Amazon Chime SDK.  For
more information about voice profile domains, see Using Amazon Chime SDK Voice Analytics in
the Amazon Chime SDK Developer Guide.

# Arguments
- `name`: The name of the voice profile domain.
- `server_side_encryption_configuration`: The server-side encryption configuration for the
  request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: The unique identifier for the client request. Use a different
  token for different domain creation requests.
- `"Description"`: A description of the voice profile domain.
- `"Tags"`: The tags assigned to the domain.
"""
function create_voice_profile_domain(
    Name,
    ServerSideEncryptionConfiguration;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "POST",
        "/voice-profile-domains",
        Dict{String,Any}(
            "Name" => Name,
            "ServerSideEncryptionConfiguration" => ServerSideEncryptionConfiguration,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_voice_profile_domain(
    Name,
    ServerSideEncryptionConfiguration,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "POST",
        "/voice-profile-domains",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Name" => Name,
                    "ServerSideEncryptionConfiguration" =>
                        ServerSideEncryptionConfiguration,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_phone_number(phone_number_id)
    delete_phone_number(phone_number_id, params::Dict{String,<:Any})

Moves the specified phone number into the Deletion queue. A phone number must be
disassociated from any users or Amazon Chime SDK Voice Connectors before it can be deleted.
Deleted phone numbers remain in the Deletion queue queue for 7 days before they are deleted
permanently.

# Arguments
- `phone_number_id`: The phone number ID.

"""
function delete_phone_number(
    phoneNumberId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "DELETE",
        "/phone-numbers/$(phoneNumberId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_phone_number(
    phoneNumberId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "DELETE",
        "/phone-numbers/$(phoneNumberId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_proxy_session(proxy_session_id, voice_connector_id)
    delete_proxy_session(proxy_session_id, voice_connector_id, params::Dict{String,<:Any})

Deletes the specified proxy session from the specified Amazon Chime SDK Voice Connector.

# Arguments
- `proxy_session_id`: The proxy session ID.
- `voice_connector_id`: The Voice Connector ID.

"""
function delete_proxy_session(
    proxySessionId, voiceConnectorId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "DELETE",
        "/voice-connectors/$(voiceConnectorId)/proxy-sessions/$(proxySessionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_proxy_session(
    proxySessionId,
    voiceConnectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "DELETE",
        "/voice-connectors/$(voiceConnectorId)/proxy-sessions/$(proxySessionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_sip_media_application(sip_media_application_id)
    delete_sip_media_application(sip_media_application_id, params::Dict{String,<:Any})

Deletes a SIP media application.

# Arguments
- `sip_media_application_id`: The SIP media application ID.

"""
function delete_sip_media_application(
    sipMediaApplicationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "DELETE",
        "/sip-media-applications/$(sipMediaApplicationId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_sip_media_application(
    sipMediaApplicationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "DELETE",
        "/sip-media-applications/$(sipMediaApplicationId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_sip_rule(sip_rule_id)
    delete_sip_rule(sip_rule_id, params::Dict{String,<:Any})

Deletes a SIP rule.

# Arguments
- `sip_rule_id`: The SIP rule ID.

"""
function delete_sip_rule(sipRuleId; aws_config::AbstractAWSConfig=current_aws_config())
    return chime_sdk_voice(
        "DELETE",
        "/sip-rules/$(sipRuleId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_sip_rule(
    sipRuleId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "DELETE",
        "/sip-rules/$(sipRuleId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_voice_connector(voice_connector_id)
    delete_voice_connector(voice_connector_id, params::Dict{String,<:Any})

Deletes an Amazon Chime SDK Voice Connector. Any phone numbers associated with the Amazon
Chime SDK Voice Connector must be disassociated from it before it can be deleted.

# Arguments
- `voice_connector_id`: The Voice Connector ID.

"""
function delete_voice_connector(
    voiceConnectorId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "DELETE",
        "/voice-connectors/$(voiceConnectorId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_voice_connector(
    voiceConnectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "DELETE",
        "/voice-connectors/$(voiceConnectorId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_voice_connector_emergency_calling_configuration(voice_connector_id)
    delete_voice_connector_emergency_calling_configuration(voice_connector_id, params::Dict{String,<:Any})

Deletes the emergency calling details from the specified Amazon Chime SDK Voice Connector.

# Arguments
- `voice_connector_id`: The Voice Connector ID.

"""
function delete_voice_connector_emergency_calling_configuration(
    voiceConnectorId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "DELETE",
        "/voice-connectors/$(voiceConnectorId)/emergency-calling-configuration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_voice_connector_emergency_calling_configuration(
    voiceConnectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "DELETE",
        "/voice-connectors/$(voiceConnectorId)/emergency-calling-configuration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_voice_connector_group(voice_connector_group_id)
    delete_voice_connector_group(voice_connector_group_id, params::Dict{String,<:Any})

Deletes an Amazon Chime SDK Voice Connector group. Any VoiceConnectorItems and phone
numbers associated with the group must be removed before it can be deleted.

# Arguments
- `voice_connector_group_id`: The Voice Connector Group ID.

"""
function delete_voice_connector_group(
    voiceConnectorGroupId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "DELETE",
        "/voice-connector-groups/$(voiceConnectorGroupId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_voice_connector_group(
    voiceConnectorGroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "DELETE",
        "/voice-connector-groups/$(voiceConnectorGroupId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_voice_connector_origination(voice_connector_id)
    delete_voice_connector_origination(voice_connector_id, params::Dict{String,<:Any})

Deletes the origination settings for the specified Amazon Chime SDK Voice Connector.   If
emergency calling is configured for the Voice Connector, it must be deleted prior to
deleting the origination settings.

# Arguments
- `voice_connector_id`: The Voice Connector ID.

"""
function delete_voice_connector_origination(
    voiceConnectorId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "DELETE",
        "/voice-connectors/$(voiceConnectorId)/origination";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_voice_connector_origination(
    voiceConnectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "DELETE",
        "/voice-connectors/$(voiceConnectorId)/origination",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_voice_connector_proxy(voice_connector_id)
    delete_voice_connector_proxy(voice_connector_id, params::Dict{String,<:Any})

Deletes the proxy configuration from the specified Amazon Chime SDK Voice Connector.

# Arguments
- `voice_connector_id`: The Voice Connector ID.

"""
function delete_voice_connector_proxy(
    voiceConnectorId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "DELETE",
        "/voice-connectors/$(voiceConnectorId)/programmable-numbers/proxy";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_voice_connector_proxy(
    voiceConnectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "DELETE",
        "/voice-connectors/$(voiceConnectorId)/programmable-numbers/proxy",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_voice_connector_streaming_configuration(voice_connector_id)
    delete_voice_connector_streaming_configuration(voice_connector_id, params::Dict{String,<:Any})

Deletes a Voice Connector's streaming configuration.

# Arguments
- `voice_connector_id`: The Voice Connector ID.

"""
function delete_voice_connector_streaming_configuration(
    voiceConnectorId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "DELETE",
        "/voice-connectors/$(voiceConnectorId)/streaming-configuration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_voice_connector_streaming_configuration(
    voiceConnectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "DELETE",
        "/voice-connectors/$(voiceConnectorId)/streaming-configuration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_voice_connector_termination(voice_connector_id)
    delete_voice_connector_termination(voice_connector_id, params::Dict{String,<:Any})

Deletes the termination settings for the specified Amazon Chime SDK Voice Connector.  If
emergency calling is configured for the Voice Connector, it must be deleted prior to
deleting the termination settings.

# Arguments
- `voice_connector_id`: The Voice Connector ID.

"""
function delete_voice_connector_termination(
    voiceConnectorId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "DELETE",
        "/voice-connectors/$(voiceConnectorId)/termination";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_voice_connector_termination(
    voiceConnectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "DELETE",
        "/voice-connectors/$(voiceConnectorId)/termination",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_voice_connector_termination_credentials(usernames, voice_connector_id)
    delete_voice_connector_termination_credentials(usernames, voice_connector_id, params::Dict{String,<:Any})

Deletes the specified SIP credentials used by your equipment to authenticate during call
termination.

# Arguments
- `usernames`: The RFC2617 compliant username associated with the SIP credentials, in
  US-ASCII format.
- `voice_connector_id`: The Voice Connector ID.

"""
function delete_voice_connector_termination_credentials(
    Usernames, voiceConnectorId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "POST",
        "/voice-connectors/$(voiceConnectorId)/termination/credentials?operation=delete",
        Dict{String,Any}("Usernames" => Usernames);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_voice_connector_termination_credentials(
    Usernames,
    voiceConnectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "POST",
        "/voice-connectors/$(voiceConnectorId)/termination/credentials?operation=delete",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Usernames" => Usernames), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_voice_profile(voice_profile_id)
    delete_voice_profile(voice_profile_id, params::Dict{String,<:Any})

Deletes a voice profile, including its voice print and enrollment data. WARNING: This
action is not reversible.

# Arguments
- `voice_profile_id`: The voice profile ID.

"""
function delete_voice_profile(
    VoiceProfileId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "DELETE",
        "/voice-profiles/$(VoiceProfileId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_voice_profile(
    VoiceProfileId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "DELETE",
        "/voice-profiles/$(VoiceProfileId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_voice_profile_domain(voice_profile_domain_id)
    delete_voice_profile_domain(voice_profile_domain_id, params::Dict{String,<:Any})

Deletes all voice profiles in the domain. WARNING: This action is not reversible.

# Arguments
- `voice_profile_domain_id`: The voice profile domain ID.

"""
function delete_voice_profile_domain(
    VoiceProfileDomainId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "DELETE",
        "/voice-profile-domains/$(VoiceProfileDomainId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_voice_profile_domain(
    VoiceProfileDomainId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "DELETE",
        "/voice-profile-domains/$(VoiceProfileDomainId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_phone_numbers_from_voice_connector(e164_phone_numbers, voice_connector_id)
    disassociate_phone_numbers_from_voice_connector(e164_phone_numbers, voice_connector_id, params::Dict{String,<:Any})

Disassociates the specified phone numbers from the specified Amazon Chime SDK Voice
Connector.

# Arguments
- `e164_phone_numbers`: List of phone numbers, in E.164 format.
- `voice_connector_id`: The Voice Connector ID.

"""
function disassociate_phone_numbers_from_voice_connector(
    E164PhoneNumbers, voiceConnectorId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "POST",
        "/voice-connectors/$(voiceConnectorId)?operation=disassociate-phone-numbers",
        Dict{String,Any}("E164PhoneNumbers" => E164PhoneNumbers);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_phone_numbers_from_voice_connector(
    E164PhoneNumbers,
    voiceConnectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "POST",
        "/voice-connectors/$(voiceConnectorId)?operation=disassociate-phone-numbers",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("E164PhoneNumbers" => E164PhoneNumbers), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_phone_numbers_from_voice_connector_group(e164_phone_numbers, voice_connector_group_id)
    disassociate_phone_numbers_from_voice_connector_group(e164_phone_numbers, voice_connector_group_id, params::Dict{String,<:Any})

Disassociates the specified phone numbers from the specified Amazon Chime SDK Voice
Connector group.

# Arguments
- `e164_phone_numbers`: The list of phone numbers, in E.164 format.
- `voice_connector_group_id`: The Voice Connector group ID.

"""
function disassociate_phone_numbers_from_voice_connector_group(
    E164PhoneNumbers,
    voiceConnectorGroupId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "POST",
        "/voice-connector-groups/$(voiceConnectorGroupId)?operation=disassociate-phone-numbers",
        Dict{String,Any}("E164PhoneNumbers" => E164PhoneNumbers);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_phone_numbers_from_voice_connector_group(
    E164PhoneNumbers,
    voiceConnectorGroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "POST",
        "/voice-connector-groups/$(voiceConnectorGroupId)?operation=disassociate-phone-numbers",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("E164PhoneNumbers" => E164PhoneNumbers), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_global_settings()
    get_global_settings(params::Dict{String,<:Any})

Retrieves the global settings for the Amazon Chime SDK Voice Connectors in an AWS account.

"""
function get_global_settings(; aws_config::AbstractAWSConfig=current_aws_config())
    return chime_sdk_voice(
        "GET", "/settings"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_global_settings(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "GET", "/settings", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_phone_number(phone_number_id)
    get_phone_number(phone_number_id, params::Dict{String,<:Any})

Retrieves details for the specified phone number ID, such as associations, capabilities,
and product type.

# Arguments
- `phone_number_id`: The phone number ID.

"""
function get_phone_number(phoneNumberId; aws_config::AbstractAWSConfig=current_aws_config())
    return chime_sdk_voice(
        "GET",
        "/phone-numbers/$(phoneNumberId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_phone_number(
    phoneNumberId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "GET",
        "/phone-numbers/$(phoneNumberId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_phone_number_order(phone_number_order_id)
    get_phone_number_order(phone_number_order_id, params::Dict{String,<:Any})

Retrieves details for the specified phone number order, such as the order creation
timestamp, phone numbers in E.164 format, product type, and order status.

# Arguments
- `phone_number_order_id`: The ID of the phone number order .

"""
function get_phone_number_order(
    phoneNumberOrderId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "GET",
        "/phone-number-orders/$(phoneNumberOrderId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_phone_number_order(
    phoneNumberOrderId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "GET",
        "/phone-number-orders/$(phoneNumberOrderId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_phone_number_settings()
    get_phone_number_settings(params::Dict{String,<:Any})

Retrieves the phone number settings for the administrator's AWS account, such as the
default outbound calling name.

"""
function get_phone_number_settings(; aws_config::AbstractAWSConfig=current_aws_config())
    return chime_sdk_voice(
        "GET",
        "/settings/phone-number";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_phone_number_settings(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "GET",
        "/settings/phone-number",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_proxy_session(proxy_session_id, voice_connector_id)
    get_proxy_session(proxy_session_id, voice_connector_id, params::Dict{String,<:Any})

Retrieves the specified proxy session details for the specified Amazon Chime SDK Voice
Connector.

# Arguments
- `proxy_session_id`: The proxy session ID.
- `voice_connector_id`: The Voice Connector ID.

"""
function get_proxy_session(
    proxySessionId, voiceConnectorId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "GET",
        "/voice-connectors/$(voiceConnectorId)/proxy-sessions/$(proxySessionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_proxy_session(
    proxySessionId,
    voiceConnectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "GET",
        "/voice-connectors/$(voiceConnectorId)/proxy-sessions/$(proxySessionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_sip_media_application(sip_media_application_id)
    get_sip_media_application(sip_media_application_id, params::Dict{String,<:Any})

Retrieves the information for a SIP media application, including name, AWS Region, and
endpoints.

# Arguments
- `sip_media_application_id`: The SIP media application ID .

"""
function get_sip_media_application(
    sipMediaApplicationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "GET",
        "/sip-media-applications/$(sipMediaApplicationId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_sip_media_application(
    sipMediaApplicationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "GET",
        "/sip-media-applications/$(sipMediaApplicationId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_sip_media_application_alexa_skill_configuration(sip_media_application_id)
    get_sip_media_application_alexa_skill_configuration(sip_media_application_id, params::Dict{String,<:Any})

Gets the Alexa Skill configuration for the SIP media application.  Due to changes made by
the Amazon Alexa service, this API is no longer available for use. For more information,
refer to the Alexa Smart Properties page.

# Arguments
- `sip_media_application_id`: The SIP media application ID.

"""
function get_sip_media_application_alexa_skill_configuration(
    sipMediaApplicationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "GET",
        "/sip-media-applications/$(sipMediaApplicationId)/alexa-skill-configuration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_sip_media_application_alexa_skill_configuration(
    sipMediaApplicationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "GET",
        "/sip-media-applications/$(sipMediaApplicationId)/alexa-skill-configuration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_sip_media_application_logging_configuration(sip_media_application_id)
    get_sip_media_application_logging_configuration(sip_media_application_id, params::Dict{String,<:Any})

Retrieves the logging configuration for the specified SIP media application.

# Arguments
- `sip_media_application_id`: The SIP media application ID.

"""
function get_sip_media_application_logging_configuration(
    sipMediaApplicationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "GET",
        "/sip-media-applications/$(sipMediaApplicationId)/logging-configuration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_sip_media_application_logging_configuration(
    sipMediaApplicationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "GET",
        "/sip-media-applications/$(sipMediaApplicationId)/logging-configuration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_sip_rule(sip_rule_id)
    get_sip_rule(sip_rule_id, params::Dict{String,<:Any})

Retrieves the details of a SIP rule, such as the rule ID, name, triggers, and target
endpoints.

# Arguments
- `sip_rule_id`: The SIP rule ID.

"""
function get_sip_rule(sipRuleId; aws_config::AbstractAWSConfig=current_aws_config())
    return chime_sdk_voice(
        "GET",
        "/sip-rules/$(sipRuleId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_sip_rule(
    sipRuleId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "GET",
        "/sip-rules/$(sipRuleId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_speaker_search_task(speaker_search_task_id, voice_connector_id)
    get_speaker_search_task(speaker_search_task_id, voice_connector_id, params::Dict{String,<:Any})

Retrieves the details of the specified speaker search task.

# Arguments
- `speaker_search_task_id`: The ID of the speaker search task.
- `voice_connector_id`: The Voice Connector ID.

"""
function get_speaker_search_task(
    SpeakerSearchTaskId,
    VoiceConnectorId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "GET",
        "/voice-connectors/$(VoiceConnectorId)/speaker-search-tasks/$(SpeakerSearchTaskId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_speaker_search_task(
    SpeakerSearchTaskId,
    VoiceConnectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "GET",
        "/voice-connectors/$(VoiceConnectorId)/speaker-search-tasks/$(SpeakerSearchTaskId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_voice_connector(voice_connector_id)
    get_voice_connector(voice_connector_id, params::Dict{String,<:Any})

Retrieves details for the specified Amazon Chime SDK Voice Connector, such as
timestamps,name, outbound host, and encryption requirements.

# Arguments
- `voice_connector_id`: The Voice Connector ID.

"""
function get_voice_connector(
    voiceConnectorId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "GET",
        "/voice-connectors/$(voiceConnectorId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_voice_connector(
    voiceConnectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "GET",
        "/voice-connectors/$(voiceConnectorId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_voice_connector_emergency_calling_configuration(voice_connector_id)
    get_voice_connector_emergency_calling_configuration(voice_connector_id, params::Dict{String,<:Any})

Retrieves the emergency calling configuration details for the specified Voice Connector.

# Arguments
- `voice_connector_id`: The Voice Connector ID.

"""
function get_voice_connector_emergency_calling_configuration(
    voiceConnectorId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "GET",
        "/voice-connectors/$(voiceConnectorId)/emergency-calling-configuration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_voice_connector_emergency_calling_configuration(
    voiceConnectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "GET",
        "/voice-connectors/$(voiceConnectorId)/emergency-calling-configuration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_voice_connector_group(voice_connector_group_id)
    get_voice_connector_group(voice_connector_group_id, params::Dict{String,<:Any})

Retrieves details for the specified Amazon Chime SDK Voice Connector group, such as
timestamps,name, and associated VoiceConnectorItems.

# Arguments
- `voice_connector_group_id`: The Voice Connector group ID.

"""
function get_voice_connector_group(
    voiceConnectorGroupId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "GET",
        "/voice-connector-groups/$(voiceConnectorGroupId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_voice_connector_group(
    voiceConnectorGroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "GET",
        "/voice-connector-groups/$(voiceConnectorGroupId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_voice_connector_logging_configuration(voice_connector_id)
    get_voice_connector_logging_configuration(voice_connector_id, params::Dict{String,<:Any})

Retrieves the logging configuration settings for the specified Voice Connector. Shows
whether SIP message logs are enabled for sending to Amazon CloudWatch Logs.

# Arguments
- `voice_connector_id`: The Voice Connector ID.

"""
function get_voice_connector_logging_configuration(
    voiceConnectorId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "GET",
        "/voice-connectors/$(voiceConnectorId)/logging-configuration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_voice_connector_logging_configuration(
    voiceConnectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "GET",
        "/voice-connectors/$(voiceConnectorId)/logging-configuration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_voice_connector_origination(voice_connector_id)
    get_voice_connector_origination(voice_connector_id, params::Dict{String,<:Any})

Retrieves the origination settings for the specified Voice Connector.

# Arguments
- `voice_connector_id`: The Voice Connector ID.

"""
function get_voice_connector_origination(
    voiceConnectorId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "GET",
        "/voice-connectors/$(voiceConnectorId)/origination";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_voice_connector_origination(
    voiceConnectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "GET",
        "/voice-connectors/$(voiceConnectorId)/origination",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_voice_connector_proxy(voice_connector_id)
    get_voice_connector_proxy(voice_connector_id, params::Dict{String,<:Any})

Retrieves the proxy configuration details for the specified Amazon Chime SDK Voice
Connector.

# Arguments
- `voice_connector_id`: The Voice Connector ID.

"""
function get_voice_connector_proxy(
    voiceConnectorId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "GET",
        "/voice-connectors/$(voiceConnectorId)/programmable-numbers/proxy";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_voice_connector_proxy(
    voiceConnectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "GET",
        "/voice-connectors/$(voiceConnectorId)/programmable-numbers/proxy",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_voice_connector_streaming_configuration(voice_connector_id)
    get_voice_connector_streaming_configuration(voice_connector_id, params::Dict{String,<:Any})

Retrieves the streaming configuration details for the specified Amazon Chime SDK Voice
Connector. Shows whether media streaming is enabled for sending to Amazon Kinesis. It also
shows the retention period, in hours, for the Amazon Kinesis data.

# Arguments
- `voice_connector_id`: The Voice Connector ID.

"""
function get_voice_connector_streaming_configuration(
    voiceConnectorId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "GET",
        "/voice-connectors/$(voiceConnectorId)/streaming-configuration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_voice_connector_streaming_configuration(
    voiceConnectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "GET",
        "/voice-connectors/$(voiceConnectorId)/streaming-configuration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_voice_connector_termination(voice_connector_id)
    get_voice_connector_termination(voice_connector_id, params::Dict{String,<:Any})

Retrieves the termination setting details for the specified Voice Connector.

# Arguments
- `voice_connector_id`: The Voice Connector ID.

"""
function get_voice_connector_termination(
    voiceConnectorId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "GET",
        "/voice-connectors/$(voiceConnectorId)/termination";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_voice_connector_termination(
    voiceConnectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "GET",
        "/voice-connectors/$(voiceConnectorId)/termination",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_voice_connector_termination_health(voice_connector_id)
    get_voice_connector_termination_health(voice_connector_id, params::Dict{String,<:Any})

Retrieves information about the last time a SIP OPTIONS ping was received from your SIP
infrastructure for the specified Amazon Chime SDK Voice Connector.

# Arguments
- `voice_connector_id`: The Voice Connector ID.

"""
function get_voice_connector_termination_health(
    voiceConnectorId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "GET",
        "/voice-connectors/$(voiceConnectorId)/termination/health";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_voice_connector_termination_health(
    voiceConnectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "GET",
        "/voice-connectors/$(voiceConnectorId)/termination/health",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_voice_profile(voice_profile_id)
    get_voice_profile(voice_profile_id, params::Dict{String,<:Any})

Retrieves the details of the specified voice profile.

# Arguments
- `voice_profile_id`: The voice profile ID.

"""
function get_voice_profile(
    VoiceProfileId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "GET",
        "/voice-profiles/$(VoiceProfileId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_voice_profile(
    VoiceProfileId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "GET",
        "/voice-profiles/$(VoiceProfileId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_voice_profile_domain(voice_profile_domain_id)
    get_voice_profile_domain(voice_profile_domain_id, params::Dict{String,<:Any})

Retrieves the details of the specified voice profile domain.

# Arguments
- `voice_profile_domain_id`: The voice profile domain ID.

"""
function get_voice_profile_domain(
    VoiceProfileDomainId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "GET",
        "/voice-profile-domains/$(VoiceProfileDomainId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_voice_profile_domain(
    VoiceProfileDomainId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "GET",
        "/voice-profile-domains/$(VoiceProfileDomainId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_voice_tone_analysis_task(voice_connector_id, voice_tone_analysis_task_id, is_caller)
    get_voice_tone_analysis_task(voice_connector_id, voice_tone_analysis_task_id, is_caller, params::Dict{String,<:Any})

Retrieves the details of a voice tone analysis task.

# Arguments
- `voice_connector_id`: The Voice Connector ID.
- `voice_tone_analysis_task_id`: The ID of the voice tone anlysis task.
- `is_caller`: Specifies whether the voice being analyzed is the caller (originator) or the
  callee (responder).

"""
function get_voice_tone_analysis_task(
    VoiceConnectorId,
    VoiceToneAnalysisTaskId,
    isCaller;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "GET",
        "/voice-connectors/$(VoiceConnectorId)/voice-tone-analysis-tasks/$(VoiceToneAnalysisTaskId)",
        Dict{String,Any}("isCaller" => isCaller);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_voice_tone_analysis_task(
    VoiceConnectorId,
    VoiceToneAnalysisTaskId,
    isCaller,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "GET",
        "/voice-connectors/$(VoiceConnectorId)/voice-tone-analysis-tasks/$(VoiceToneAnalysisTaskId)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("isCaller" => isCaller), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_available_voice_connector_regions()
    list_available_voice_connector_regions(params::Dict{String,<:Any})

Lists the available AWS Regions in which you can create an Amazon Chime SDK Voice Connector.

"""
function list_available_voice_connector_regions(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "GET",
        "/voice-connector-regions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_available_voice_connector_regions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "GET",
        "/voice-connector-regions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_phone_number_orders()
    list_phone_number_orders(params::Dict{String,<:Any})

Lists the phone numbers for an administrator's Amazon Chime SDK account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"max-results"`: The maximum number of results to return in a single call.
- `"next-token"`: The token used to retrieve the next page of results.
"""
function list_phone_number_orders(; aws_config::AbstractAWSConfig=current_aws_config())
    return chime_sdk_voice(
        "GET",
        "/phone-number-orders";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_phone_number_orders(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "GET",
        "/phone-number-orders",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_phone_numbers()
    list_phone_numbers(params::Dict{String,<:Any})

Lists the phone numbers for the specified Amazon Chime SDK account, Amazon Chime SDK user,
Amazon Chime SDK Voice Connector, or Amazon Chime SDK Voice Connector group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filter-name"`: The filter to limit the number of results.
- `"filter-value"`: The filter value.
- `"max-results"`: The maximum number of results to return in a single call.
- `"next-token"`: The token used to return the next page of results.
- `"product-type"`: The phone number product types.
- `"status"`: The status of your organization's phone numbers.
"""
function list_phone_numbers(; aws_config::AbstractAWSConfig=current_aws_config())
    return chime_sdk_voice(
        "GET", "/phone-numbers"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_phone_numbers(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "GET",
        "/phone-numbers",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_proxy_sessions(voice_connector_id)
    list_proxy_sessions(voice_connector_id, params::Dict{String,<:Any})

Lists the proxy sessions for the specified Amazon Chime SDK Voice Connector.

# Arguments
- `voice_connector_id`: The Voice Connector ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"max-results"`: The maximum number of results to return in a single call.
- `"next-token"`: The token used to retrieve the next page of results.
- `"status"`: The proxy session status.
"""
function list_proxy_sessions(
    voiceConnectorId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "GET",
        "/voice-connectors/$(voiceConnectorId)/proxy-sessions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_proxy_sessions(
    voiceConnectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "GET",
        "/voice-connectors/$(voiceConnectorId)/proxy-sessions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_sip_media_applications()
    list_sip_media_applications(params::Dict{String,<:Any})

Lists the SIP media applications under the administrator's AWS account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"max-results"`: The maximum number of results to return in a single call. Defaults to
  100.
- `"next-token"`: The token used to return the next page of results.
"""
function list_sip_media_applications(; aws_config::AbstractAWSConfig=current_aws_config())
    return chime_sdk_voice(
        "GET",
        "/sip-media-applications";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_sip_media_applications(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "GET",
        "/sip-media-applications",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_sip_rules()
    list_sip_rules(params::Dict{String,<:Any})

Lists the SIP rules under the administrator's AWS account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"max-results"`: The maximum number of results to return in a single call. Defaults to
  100.
- `"next-token"`: The token used to return the next page of results.
- `"sip-media-application"`: The SIP media application ID.
"""
function list_sip_rules(; aws_config::AbstractAWSConfig=current_aws_config())
    return chime_sdk_voice(
        "GET", "/sip-rules"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_sip_rules(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "GET", "/sip-rules", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_supported_phone_number_countries(product-type)
    list_supported_phone_number_countries(product-type, params::Dict{String,<:Any})

Lists the countries that you can order phone numbers from.

# Arguments
- `product-type`: The phone number product type.

"""
function list_supported_phone_number_countries(
    product_type; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "GET",
        "/phone-number-countries",
        Dict{String,Any}("product-type" => product_type);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_supported_phone_number_countries(
    product_type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "GET",
        "/phone-number-countries",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("product-type" => product_type), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(arn)
    list_tags_for_resource(arn, params::Dict{String,<:Any})

Returns a list of the tags in a given resource.

# Arguments
- `arn`: The resource ARN.

"""
function list_tags_for_resource(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return chime_sdk_voice(
        "GET",
        "/tags",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "GET",
        "/tags",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_voice_connector_groups()
    list_voice_connector_groups(params::Dict{String,<:Any})

Lists the Amazon Chime SDK Voice Connector groups in the administrator's AWS account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"max-results"`: The maximum number of results to return in a single call.
- `"next-token"`: The token used to return the next page of results.
"""
function list_voice_connector_groups(; aws_config::AbstractAWSConfig=current_aws_config())
    return chime_sdk_voice(
        "GET",
        "/voice-connector-groups";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_voice_connector_groups(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "GET",
        "/voice-connector-groups",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_voice_connector_termination_credentials(voice_connector_id)
    list_voice_connector_termination_credentials(voice_connector_id, params::Dict{String,<:Any})

Lists the SIP credentials for the specified Amazon Chime SDK Voice Connector.

# Arguments
- `voice_connector_id`: The Voice Connector ID.

"""
function list_voice_connector_termination_credentials(
    voiceConnectorId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "GET",
        "/voice-connectors/$(voiceConnectorId)/termination/credentials";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_voice_connector_termination_credentials(
    voiceConnectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "GET",
        "/voice-connectors/$(voiceConnectorId)/termination/credentials",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_voice_connectors()
    list_voice_connectors(params::Dict{String,<:Any})

Lists the Amazon Chime SDK Voice Connectors in the administrators AWS account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"max-results"`: The maximum number of results to return in a single call.
- `"next-token"`: The token used to return the next page of results.
"""
function list_voice_connectors(; aws_config::AbstractAWSConfig=current_aws_config())
    return chime_sdk_voice(
        "GET", "/voice-connectors"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_voice_connectors(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "GET",
        "/voice-connectors",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_voice_profile_domains()
    list_voice_profile_domains(params::Dict{String,<:Any})

Lists the specified voice profile domains in the administrator's AWS account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"max-results"`: The maximum number of results to return in a single call.
- `"next-token"`: The token used to return the next page of results.
"""
function list_voice_profile_domains(; aws_config::AbstractAWSConfig=current_aws_config())
    return chime_sdk_voice(
        "GET",
        "/voice-profile-domains";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_voice_profile_domains(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "GET",
        "/voice-profile-domains",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_voice_profiles(voice-profile-domain-id)
    list_voice_profiles(voice-profile-domain-id, params::Dict{String,<:Any})

Lists the voice profiles in a voice profile domain.

# Arguments
- `voice-profile-domain-id`: The ID of the voice profile domain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"max-results"`: The maximum number of results in the request.
- `"next-token"`: The token used to retrieve the next page of results.
"""
function list_voice_profiles(
    voice_profile_domain_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "GET",
        "/voice-profiles",
        Dict{String,Any}("voice-profile-domain-id" => voice_profile_domain_id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_voice_profiles(
    voice_profile_domain_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "GET",
        "/voice-profiles",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("voice-profile-domain-id" => voice_profile_domain_id),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_sip_media_application_alexa_skill_configuration(sip_media_application_id)
    put_sip_media_application_alexa_skill_configuration(sip_media_application_id, params::Dict{String,<:Any})

Updates the Alexa Skill configuration for the SIP media application.  Due to changes made
by the Amazon Alexa service, this API is no longer available for use. For more information,
refer to the Alexa Smart Properties page.

# Arguments
- `sip_media_application_id`: The SIP media application ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"SipMediaApplicationAlexaSkillConfiguration"`: The Alexa Skill configuration.
"""
function put_sip_media_application_alexa_skill_configuration(
    sipMediaApplicationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "PUT",
        "/sip-media-applications/$(sipMediaApplicationId)/alexa-skill-configuration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_sip_media_application_alexa_skill_configuration(
    sipMediaApplicationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "PUT",
        "/sip-media-applications/$(sipMediaApplicationId)/alexa-skill-configuration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_sip_media_application_logging_configuration(sip_media_application_id)
    put_sip_media_application_logging_configuration(sip_media_application_id, params::Dict{String,<:Any})

Updates the logging configuration for the specified SIP media application.

# Arguments
- `sip_media_application_id`: The SIP media application ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"SipMediaApplicationLoggingConfiguration"`: The logging configuration for the specified
  SIP media application.
"""
function put_sip_media_application_logging_configuration(
    sipMediaApplicationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "PUT",
        "/sip-media-applications/$(sipMediaApplicationId)/logging-configuration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_sip_media_application_logging_configuration(
    sipMediaApplicationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "PUT",
        "/sip-media-applications/$(sipMediaApplicationId)/logging-configuration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_voice_connector_emergency_calling_configuration(emergency_calling_configuration, voice_connector_id)
    put_voice_connector_emergency_calling_configuration(emergency_calling_configuration, voice_connector_id, params::Dict{String,<:Any})

Updates a Voice Connector's emergency calling configuration.

# Arguments
- `emergency_calling_configuration`: The configuration being updated.
- `voice_connector_id`: The Voice Connector ID.

"""
function put_voice_connector_emergency_calling_configuration(
    EmergencyCallingConfiguration,
    voiceConnectorId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "PUT",
        "/voice-connectors/$(voiceConnectorId)/emergency-calling-configuration",
        Dict{String,Any}("EmergencyCallingConfiguration" => EmergencyCallingConfiguration);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_voice_connector_emergency_calling_configuration(
    EmergencyCallingConfiguration,
    voiceConnectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "PUT",
        "/voice-connectors/$(voiceConnectorId)/emergency-calling-configuration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EmergencyCallingConfiguration" => EmergencyCallingConfiguration
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_voice_connector_logging_configuration(logging_configuration, voice_connector_id)
    put_voice_connector_logging_configuration(logging_configuration, voice_connector_id, params::Dict{String,<:Any})

Updates a Voice Connector's logging configuration.

# Arguments
- `logging_configuration`: The logging configuration being updated.
- `voice_connector_id`: The Voice Connector ID.

"""
function put_voice_connector_logging_configuration(
    LoggingConfiguration,
    voiceConnectorId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "PUT",
        "/voice-connectors/$(voiceConnectorId)/logging-configuration",
        Dict{String,Any}("LoggingConfiguration" => LoggingConfiguration);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_voice_connector_logging_configuration(
    LoggingConfiguration,
    voiceConnectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "PUT",
        "/voice-connectors/$(voiceConnectorId)/logging-configuration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("LoggingConfiguration" => LoggingConfiguration),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_voice_connector_origination(origination, voice_connector_id)
    put_voice_connector_origination(origination, voice_connector_id, params::Dict{String,<:Any})

Updates a Voice Connector's origination settings.

# Arguments
- `origination`: The origination settings being updated.
- `voice_connector_id`: The Voice Connector ID.

"""
function put_voice_connector_origination(
    Origination, voiceConnectorId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "PUT",
        "/voice-connectors/$(voiceConnectorId)/origination",
        Dict{String,Any}("Origination" => Origination);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_voice_connector_origination(
    Origination,
    voiceConnectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "PUT",
        "/voice-connectors/$(voiceConnectorId)/origination",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Origination" => Origination), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_voice_connector_proxy(default_session_expiry_minutes, phone_number_pool_countries, voice_connector_id)
    put_voice_connector_proxy(default_session_expiry_minutes, phone_number_pool_countries, voice_connector_id, params::Dict{String,<:Any})

Puts the specified proxy configuration to the specified Amazon Chime SDK Voice Connector.

# Arguments
- `default_session_expiry_minutes`: The default number of minutes allowed for proxy session.
- `phone_number_pool_countries`: The countries for proxy phone numbers to be selected from.
- `voice_connector_id`: The Voice Connector ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Disabled"`: When true, stops proxy sessions from being created on the specified Amazon
  Chime SDK Voice Connector.
- `"FallBackPhoneNumber"`: The phone number to route calls to after a proxy session expires.
"""
function put_voice_connector_proxy(
    DefaultSessionExpiryMinutes,
    PhoneNumberPoolCountries,
    voiceConnectorId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "PUT",
        "/voice-connectors/$(voiceConnectorId)/programmable-numbers/proxy",
        Dict{String,Any}(
            "DefaultSessionExpiryMinutes" => DefaultSessionExpiryMinutes,
            "PhoneNumberPoolCountries" => PhoneNumberPoolCountries,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_voice_connector_proxy(
    DefaultSessionExpiryMinutes,
    PhoneNumberPoolCountries,
    voiceConnectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "PUT",
        "/voice-connectors/$(voiceConnectorId)/programmable-numbers/proxy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DefaultSessionExpiryMinutes" => DefaultSessionExpiryMinutes,
                    "PhoneNumberPoolCountries" => PhoneNumberPoolCountries,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_voice_connector_streaming_configuration(streaming_configuration, voice_connector_id)
    put_voice_connector_streaming_configuration(streaming_configuration, voice_connector_id, params::Dict{String,<:Any})

Updates a Voice Connector's streaming configuration settings.

# Arguments
- `streaming_configuration`: The streaming settings being updated.
- `voice_connector_id`: The Voice Connector ID.

"""
function put_voice_connector_streaming_configuration(
    StreamingConfiguration,
    voiceConnectorId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "PUT",
        "/voice-connectors/$(voiceConnectorId)/streaming-configuration",
        Dict{String,Any}("StreamingConfiguration" => StreamingConfiguration);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_voice_connector_streaming_configuration(
    StreamingConfiguration,
    voiceConnectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "PUT",
        "/voice-connectors/$(voiceConnectorId)/streaming-configuration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("StreamingConfiguration" => StreamingConfiguration),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_voice_connector_termination(termination, voice_connector_id)
    put_voice_connector_termination(termination, voice_connector_id, params::Dict{String,<:Any})

Updates a Voice Connector's termination settings.

# Arguments
- `termination`: The termination settings to be updated.
- `voice_connector_id`: The Voice Connector ID.

"""
function put_voice_connector_termination(
    Termination, voiceConnectorId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "PUT",
        "/voice-connectors/$(voiceConnectorId)/termination",
        Dict{String,Any}("Termination" => Termination);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_voice_connector_termination(
    Termination,
    voiceConnectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "PUT",
        "/voice-connectors/$(voiceConnectorId)/termination",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Termination" => Termination), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_voice_connector_termination_credentials(voice_connector_id)
    put_voice_connector_termination_credentials(voice_connector_id, params::Dict{String,<:Any})

Updates a Voice Connector's termination credentials.

# Arguments
- `voice_connector_id`: The Voice Connector ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Credentials"`: The termination credentials being updated.
"""
function put_voice_connector_termination_credentials(
    voiceConnectorId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "POST",
        "/voice-connectors/$(voiceConnectorId)/termination/credentials?operation=put";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_voice_connector_termination_credentials(
    voiceConnectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "POST",
        "/voice-connectors/$(voiceConnectorId)/termination/credentials?operation=put",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    restore_phone_number(phone_number_id)
    restore_phone_number(phone_number_id, params::Dict{String,<:Any})

Restores a deleted phone number.

# Arguments
- `phone_number_id`: The ID of the phone number being restored.

"""
function restore_phone_number(
    phoneNumberId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "POST",
        "/phone-numbers/$(phoneNumberId)?operation=restore";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function restore_phone_number(
    phoneNumberId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "POST",
        "/phone-numbers/$(phoneNumberId)?operation=restore",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    search_available_phone_numbers()
    search_available_phone_numbers(params::Dict{String,<:Any})

Searches the provisioned phone numbers in an organization.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"area-code"`: Confines a search to just the phone numbers associated with the specified
  area code.
- `"city"`: Confines a search to just the phone numbers associated with the specified city.
- `"country"`: Confines a search to just the phone numbers associated with the specified
  country.
- `"max-results"`: The maximum number of results to return.
- `"next-token"`: The token used to return the next page of results.
- `"phone-number-type"`: Confines a search to just the phone numbers associated with the
  specified phone number type, either local or toll-free.
- `"state"`: Confines a search to just the phone numbers associated with the specified
  state.
- `"toll-free-prefix"`: Confines a search to just the phone numbers associated with the
  specified toll-free prefix.
"""
function search_available_phone_numbers(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "GET",
        "/search?type=phone-numbers";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function search_available_phone_numbers(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "GET",
        "/search?type=phone-numbers",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_speaker_search_task(transaction_id, voice_connector_id, voice_profile_domain_id)
    start_speaker_search_task(transaction_id, voice_connector_id, voice_profile_domain_id, params::Dict{String,<:Any})

Starts a speaker search task.  Before starting any speaker search tasks, you must provide
all notices and obtain all consents from the speaker as required under applicable privacy
and biometrics laws, and as required under the AWS service terms for the Amazon Chime SDK.

# Arguments
- `transaction_id`: The transaction ID of the call being analyzed.
- `voice_connector_id`: The Voice Connector ID.
- `voice_profile_domain_id`: The ID of the voice profile domain that will store the voice
  profile.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CallLeg"`: Specifies which call leg to stream for speaker search.
- `"ClientRequestToken"`: The unique identifier for the client request. Use a different
  token for different speaker search tasks.
"""
function start_speaker_search_task(
    TransactionId,
    VoiceConnectorId,
    VoiceProfileDomainId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "POST",
        "/voice-connectors/$(VoiceConnectorId)/speaker-search-tasks",
        Dict{String,Any}(
            "TransactionId" => TransactionId, "VoiceProfileDomainId" => VoiceProfileDomainId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_speaker_search_task(
    TransactionId,
    VoiceConnectorId,
    VoiceProfileDomainId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "POST",
        "/voice-connectors/$(VoiceConnectorId)/speaker-search-tasks",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "TransactionId" => TransactionId,
                    "VoiceProfileDomainId" => VoiceProfileDomainId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_voice_tone_analysis_task(language_code, transaction_id, voice_connector_id)
    start_voice_tone_analysis_task(language_code, transaction_id, voice_connector_id, params::Dict{String,<:Any})

Starts a voice tone analysis task. For more information about voice tone analysis, see
Using Amazon Chime SDK voice analytics in the Amazon Chime SDK Developer Guide.  Before
starting any voice tone analysis tasks, you must provide all notices and obtain all
consents from the speaker as required under applicable privacy and biometrics laws, and as
required under the AWS service terms for the Amazon Chime SDK.

# Arguments
- `language_code`: The language code.
- `transaction_id`: The transaction ID.
- `voice_connector_id`: The Voice Connector ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: The unique identifier for the client request. Use a different
  token for different voice tone analysis tasks.
"""
function start_voice_tone_analysis_task(
    LanguageCode,
    TransactionId,
    VoiceConnectorId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "POST",
        "/voice-connectors/$(VoiceConnectorId)/voice-tone-analysis-tasks",
        Dict{String,Any}("LanguageCode" => LanguageCode, "TransactionId" => TransactionId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_voice_tone_analysis_task(
    LanguageCode,
    TransactionId,
    VoiceConnectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "POST",
        "/voice-connectors/$(VoiceConnectorId)/voice-tone-analysis-tasks",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "LanguageCode" => LanguageCode, "TransactionId" => TransactionId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_speaker_search_task(speaker_search_task_id, voice_connector_id)
    stop_speaker_search_task(speaker_search_task_id, voice_connector_id, params::Dict{String,<:Any})

Stops a speaker search task.

# Arguments
- `speaker_search_task_id`: The speaker search task ID.
- `voice_connector_id`: The Voice Connector ID.

"""
function stop_speaker_search_task(
    SpeakerSearchTaskId,
    VoiceConnectorId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "POST",
        "/voice-connectors/$(VoiceConnectorId)/speaker-search-tasks/$(SpeakerSearchTaskId)?operation=stop";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_speaker_search_task(
    SpeakerSearchTaskId,
    VoiceConnectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "POST",
        "/voice-connectors/$(VoiceConnectorId)/speaker-search-tasks/$(SpeakerSearchTaskId)?operation=stop",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_voice_tone_analysis_task(voice_connector_id, voice_tone_analysis_task_id)
    stop_voice_tone_analysis_task(voice_connector_id, voice_tone_analysis_task_id, params::Dict{String,<:Any})

Stops a voice tone analysis task.

# Arguments
- `voice_connector_id`: The Voice Connector ID.
- `voice_tone_analysis_task_id`: The ID of the voice tone analysis task.

"""
function stop_voice_tone_analysis_task(
    VoiceConnectorId,
    VoiceToneAnalysisTaskId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "POST",
        "/voice-connectors/$(VoiceConnectorId)/voice-tone-analysis-tasks/$(VoiceToneAnalysisTaskId)?operation=stop";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_voice_tone_analysis_task(
    VoiceConnectorId,
    VoiceToneAnalysisTaskId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "POST",
        "/voice-connectors/$(VoiceConnectorId)/voice-tone-analysis-tasks/$(VoiceToneAnalysisTaskId)?operation=stop",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds a tag to the specified resource.

# Arguments
- `resource_arn`: The ARN of the resource being tagged.
- `tags`: A list of the tags being added to the resource.

"""
function tag_resource(ResourceARN, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return chime_sdk_voice(
        "POST",
        "/tags?operation=tag-resource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceARN,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "POST",
        "/tags?operation=tag-resource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes tags from a resource.

# Arguments
- `resource_arn`: The ARN of the resource having its tags removed.
- `tag_keys`: The keys of the tags being removed from the resource.

"""
function untag_resource(
    ResourceARN, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "POST",
        "/tags?operation=untag-resource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceARN,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "POST",
        "/tags?operation=untag-resource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_global_settings()
    update_global_settings(params::Dict{String,<:Any})

Updates global settings for the Amazon Chime SDK Voice Connectors in an AWS account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"VoiceConnector"`: The Voice Connector settings.
"""
function update_global_settings(; aws_config::AbstractAWSConfig=current_aws_config())
    return chime_sdk_voice(
        "PUT", "/settings"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function update_global_settings(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "PUT", "/settings", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    update_phone_number(phone_number_id)
    update_phone_number(phone_number_id, params::Dict{String,<:Any})

Updates phone number details, such as product type, calling name, or phone number name for
the specified phone number ID. You can update one phone number detail at a time. For
example, you can update either the product type, calling name, or phone number name in one
action. For numbers outside the U.S., you must use the Amazon Chime SDK SIP Media
Application Dial-In product type. Updates to outbound calling names can take 72 hours to
complete. Pending updates to outbound calling names must be complete before you can request
another update.

# Arguments
- `phone_number_id`: The phone number ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CallingName"`: The outbound calling name associated with the phone number.
- `"Name"`: Specifies the updated name assigned to one or more phone numbers.
- `"ProductType"`: The product type.
"""
function update_phone_number(
    phoneNumberId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "POST",
        "/phone-numbers/$(phoneNumberId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_phone_number(
    phoneNumberId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "POST",
        "/phone-numbers/$(phoneNumberId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_phone_number_settings(calling_name)
    update_phone_number_settings(calling_name, params::Dict{String,<:Any})

Updates the phone number settings for the administrator's AWS account, such as the default
outbound calling name. You can update the default outbound calling name once every seven
days. Outbound calling names can take up to 72 hours to update.

# Arguments
- `calling_name`: The default outbound calling name for the account.

"""
function update_phone_number_settings(
    CallingName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "PUT",
        "/settings/phone-number",
        Dict{String,Any}("CallingName" => CallingName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_phone_number_settings(
    CallingName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "PUT",
        "/settings/phone-number",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("CallingName" => CallingName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_proxy_session(capabilities, proxy_session_id, voice_connector_id)
    update_proxy_session(capabilities, proxy_session_id, voice_connector_id, params::Dict{String,<:Any})

Updates the specified proxy session details, such as voice or SMS capabilities.

# Arguments
- `capabilities`: The proxy session capabilities.
- `proxy_session_id`: The proxy session ID.
- `voice_connector_id`: The Voice Connector ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ExpiryMinutes"`: The number of minutes allowed for the proxy session.
"""
function update_proxy_session(
    Capabilities,
    proxySessionId,
    voiceConnectorId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "POST",
        "/voice-connectors/$(voiceConnectorId)/proxy-sessions/$(proxySessionId)",
        Dict{String,Any}("Capabilities" => Capabilities);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_proxy_session(
    Capabilities,
    proxySessionId,
    voiceConnectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "POST",
        "/voice-connectors/$(voiceConnectorId)/proxy-sessions/$(proxySessionId)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Capabilities" => Capabilities), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_sip_media_application(sip_media_application_id)
    update_sip_media_application(sip_media_application_id, params::Dict{String,<:Any})

Updates the details of the specified SIP media application.

# Arguments
- `sip_media_application_id`: The SIP media application ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Endpoints"`: The new set of endpoints for the specified SIP media application.
- `"Name"`: The new name for the specified SIP media application.
"""
function update_sip_media_application(
    sipMediaApplicationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "PUT",
        "/sip-media-applications/$(sipMediaApplicationId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_sip_media_application(
    sipMediaApplicationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "PUT",
        "/sip-media-applications/$(sipMediaApplicationId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_sip_media_application_call(arguments, sip_media_application_id, transaction_id)
    update_sip_media_application_call(arguments, sip_media_application_id, transaction_id, params::Dict{String,<:Any})

Invokes the AWS Lambda function associated with the SIP media application and transaction
ID in an update request. The Lambda function can then return a new set of actions.

# Arguments
- `arguments`: Arguments made available to the Lambda function as part of the
  CALL_UPDATE_REQUESTED event. Can contain 0-20 key-value pairs.
- `sip_media_application_id`: The ID of the SIP media application handling the call.
- `transaction_id`: The ID of the call transaction.

"""
function update_sip_media_application_call(
    Arguments,
    sipMediaApplicationId,
    transactionId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "POST",
        "/sip-media-applications/$(sipMediaApplicationId)/calls/$(transactionId)",
        Dict{String,Any}("Arguments" => Arguments);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_sip_media_application_call(
    Arguments,
    sipMediaApplicationId,
    transactionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "POST",
        "/sip-media-applications/$(sipMediaApplicationId)/calls/$(transactionId)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Arguments" => Arguments), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_sip_rule(name, sip_rule_id)
    update_sip_rule(name, sip_rule_id, params::Dict{String,<:Any})

Updates the details of the specified SIP rule.

# Arguments
- `name`: The new name for the specified SIP rule.
- `sip_rule_id`: The SIP rule ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Disabled"`: The new value that indicates whether the rule is disabled.
- `"TargetApplications"`: The new list of target applications.
"""
function update_sip_rule(
    Name, sipRuleId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "PUT",
        "/sip-rules/$(sipRuleId)",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_sip_rule(
    Name,
    sipRuleId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "PUT",
        "/sip-rules/$(sipRuleId)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_voice_connector(name, require_encryption, voice_connector_id)
    update_voice_connector(name, require_encryption, voice_connector_id, params::Dict{String,<:Any})

Updates the details for the specified Amazon Chime SDK Voice Connector.

# Arguments
- `name`: The name of the Voice Connector.
- `require_encryption`: When enabled, requires encryption for the Voice Connector.
- `voice_connector_id`: The Voice Connector ID.

"""
function update_voice_connector(
    Name,
    RequireEncryption,
    voiceConnectorId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "PUT",
        "/voice-connectors/$(voiceConnectorId)",
        Dict{String,Any}("Name" => Name, "RequireEncryption" => RequireEncryption);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_voice_connector(
    Name,
    RequireEncryption,
    voiceConnectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "PUT",
        "/voice-connectors/$(voiceConnectorId)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Name" => Name, "RequireEncryption" => RequireEncryption),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_voice_connector_group(name, voice_connector_items, voice_connector_group_id)
    update_voice_connector_group(name, voice_connector_items, voice_connector_group_id, params::Dict{String,<:Any})

Updates the settings for the specified Amazon Chime SDK Voice Connector group.

# Arguments
- `name`: The name of the Voice Connector group.
- `voice_connector_items`: The VoiceConnectorItems to associate with the Voice Connector
  group.
- `voice_connector_group_id`: The Voice Connector ID.

"""
function update_voice_connector_group(
    Name,
    VoiceConnectorItems,
    voiceConnectorGroupId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "PUT",
        "/voice-connector-groups/$(voiceConnectorGroupId)",
        Dict{String,Any}("Name" => Name, "VoiceConnectorItems" => VoiceConnectorItems);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_voice_connector_group(
    Name,
    VoiceConnectorItems,
    voiceConnectorGroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "PUT",
        "/voice-connector-groups/$(voiceConnectorGroupId)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Name" => Name, "VoiceConnectorItems" => VoiceConnectorItems
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_voice_profile(speaker_search_task_id, voice_profile_id)
    update_voice_profile(speaker_search_task_id, voice_profile_id, params::Dict{String,<:Any})

Updates the specified voice profile’s voice print and refreshes its expiration timestamp.
 As a condition of using this feature, you acknowledge that the collection, use, storage,
and retention of your caller’s biometric identifiers and biometric information
(“biometric data”) in the form of a digital voiceprint requires the caller’s informed
consent via a written release. Such consent is required under various state laws, including
biometrics laws in Illinois, Texas, Washington and other state privacy laws. You must
provide a written release to each caller through a process that clearly reflects each
caller’s informed consent before using Amazon Chime SDK Voice Insights service, as
required under the terms of your agreement with AWS governing your use of the service.

# Arguments
- `speaker_search_task_id`: The ID of the speaker search task.
- `voice_profile_id`: The profile ID.

"""
function update_voice_profile(
    SpeakerSearchTaskId, VoiceProfileId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "PUT",
        "/voice-profiles/$(VoiceProfileId)",
        Dict{String,Any}("SpeakerSearchTaskId" => SpeakerSearchTaskId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_voice_profile(
    SpeakerSearchTaskId,
    VoiceProfileId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "PUT",
        "/voice-profiles/$(VoiceProfileId)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("SpeakerSearchTaskId" => SpeakerSearchTaskId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_voice_profile_domain(voice_profile_domain_id)
    update_voice_profile_domain(voice_profile_domain_id, params::Dict{String,<:Any})

Updates the settings for the specified voice profile domain.

# Arguments
- `voice_profile_domain_id`: The domain ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: The description of the voice profile domain.
- `"Name"`: The name of the voice profile domain.
"""
function update_voice_profile_domain(
    VoiceProfileDomainId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_voice(
        "PUT",
        "/voice-profile-domains/$(VoiceProfileDomainId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_voice_profile_domain(
    VoiceProfileDomainId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "PUT",
        "/voice-profile-domains/$(VoiceProfileDomainId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    validate_e911_address(aws_account_id, city, country, postal_code, state, street_info, street_number)
    validate_e911_address(aws_account_id, city, country, postal_code, state, street_info, street_number, params::Dict{String,<:Any})

Validates an address to be used for 911 calls made with Amazon Chime SDK Voice Connectors.
You can use validated addresses in a Presence Information Data Format Location Object file
that you include in SIP requests. That helps ensure that addresses are routed to the
appropriate Public Safety Answering Point.

# Arguments
- `aws_account_id`: The AWS account ID.
- `city`: The address city, such as Portland.
- `country`: The country in the address being validated.
- `postal_code`: The dress postal code, such 04352.
- `state`: The address state, such as ME.
- `street_info`: The address street information, such as 8th Avenue.
- `street_number`: The address street number, such as 200 or 2121.

"""
function validate_e911_address(
    AwsAccountId,
    City,
    Country,
    PostalCode,
    State,
    StreetInfo,
    StreetNumber;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "POST",
        "/emergency-calling/address",
        Dict{String,Any}(
            "AwsAccountId" => AwsAccountId,
            "City" => City,
            "Country" => Country,
            "PostalCode" => PostalCode,
            "State" => State,
            "StreetInfo" => StreetInfo,
            "StreetNumber" => StreetNumber,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function validate_e911_address(
    AwsAccountId,
    City,
    Country,
    PostalCode,
    State,
    StreetInfo,
    StreetNumber,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_voice(
        "POST",
        "/emergency-calling/address",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AwsAccountId" => AwsAccountId,
                    "City" => City,
                    "Country" => Country,
                    "PostalCode" => PostalCode,
                    "State" => State,
                    "StreetInfo" => StreetInfo,
                    "StreetNumber" => StreetNumber,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: proton
using AWS.Compat
using AWS.UUIDs

"""
    accept_environment_account_connection(id)
    accept_environment_account_connection(id, params::Dict{String,<:Any})

In a management account, an environment account connection request is accepted. When the
environment account connection request is accepted, Proton can use the associated IAM role
to provision environment infrastructure resources in the associated environment account.
For more information, see Environment account connections in the Proton User guide.

# Arguments
- `id`: The ID of the environment account connection.

"""
function accept_environment_account_connection(
    id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "AcceptEnvironmentAccountConnection",
        Dict{String,Any}("id" => id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function accept_environment_account_connection(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "AcceptEnvironmentAccountConnection",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("id" => id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_component_deployment(component_name)
    cancel_component_deployment(component_name, params::Dict{String,<:Any})

Attempts to cancel a component deployment (for a component that is in the IN_PROGRESS
deployment status). For more information about components, see Proton components in the
Proton User Guide.

# Arguments
- `component_name`: The name of the component with the deployment to cancel.

"""
function cancel_component_deployment(
    componentName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "CancelComponentDeployment",
        Dict{String,Any}("componentName" => componentName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_component_deployment(
    componentName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "CancelComponentDeployment",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("componentName" => componentName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_environment_deployment(environment_name)
    cancel_environment_deployment(environment_name, params::Dict{String,<:Any})

Attempts to cancel an environment deployment on an UpdateEnvironment action, if the
deployment is IN_PROGRESS. For more information, see Update an environment in the Proton
User guide. The following list includes potential cancellation scenarios.   If the
cancellation attempt succeeds, the resulting deployment state is CANCELLED.   If the
cancellation attempt fails, the resulting deployment state is FAILED.   If the current
UpdateEnvironment action succeeds before the cancellation attempt starts, the resulting
deployment state is SUCCEEDED and the cancellation attempt has no effect.

# Arguments
- `environment_name`: The name of the environment with the deployment to cancel.

"""
function cancel_environment_deployment(
    environmentName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "CancelEnvironmentDeployment",
        Dict{String,Any}("environmentName" => environmentName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_environment_deployment(
    environmentName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "CancelEnvironmentDeployment",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("environmentName" => environmentName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_service_instance_deployment(service_instance_name, service_name)
    cancel_service_instance_deployment(service_instance_name, service_name, params::Dict{String,<:Any})

Attempts to cancel a service instance deployment on an UpdateServiceInstance action, if the
deployment is IN_PROGRESS. For more information, see Update a service instance in the
Proton User guide. The following list includes potential cancellation scenarios.   If the
cancellation attempt succeeds, the resulting deployment state is CANCELLED.   If the
cancellation attempt fails, the resulting deployment state is FAILED.   If the current
UpdateServiceInstance action succeeds before the cancellation attempt starts, the resulting
deployment state is SUCCEEDED and the cancellation attempt has no effect.

# Arguments
- `service_instance_name`: The name of the service instance with the deployment to cancel.
- `service_name`: The name of the service with the service instance deployment to cancel.

"""
function cancel_service_instance_deployment(
    serviceInstanceName, serviceName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "CancelServiceInstanceDeployment",
        Dict{String,Any}(
            "serviceInstanceName" => serviceInstanceName, "serviceName" => serviceName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_service_instance_deployment(
    serviceInstanceName,
    serviceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "CancelServiceInstanceDeployment",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "serviceInstanceName" => serviceInstanceName,
                    "serviceName" => serviceName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_service_pipeline_deployment(service_name)
    cancel_service_pipeline_deployment(service_name, params::Dict{String,<:Any})

Attempts to cancel a service pipeline deployment on an UpdateServicePipeline action, if the
deployment is IN_PROGRESS. For more information, see Update a service pipeline in the
Proton User guide. The following list includes potential cancellation scenarios.   If the
cancellation attempt succeeds, the resulting deployment state is CANCELLED.   If the
cancellation attempt fails, the resulting deployment state is FAILED.   If the current
UpdateServicePipeline action succeeds before the cancellation attempt starts, the resulting
deployment state is SUCCEEDED and the cancellation attempt has no effect.

# Arguments
- `service_name`: The name of the service with the service pipeline deployment to cancel.

"""
function cancel_service_pipeline_deployment(
    serviceName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "CancelServicePipelineDeployment",
        Dict{String,Any}("serviceName" => serviceName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_service_pipeline_deployment(
    serviceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "CancelServicePipelineDeployment",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("serviceName" => serviceName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_component(manifest, name, template_file)
    create_component(manifest, name, template_file, params::Dict{String,<:Any})

Create an Proton component. A component is an infrastructure extension for a service
instance. For more information about components, see Proton components in the Proton User
Guide.

# Arguments
- `manifest`: A path to a manifest file that lists the Infrastructure as Code (IaC) file,
  template language, and rendering engine for infrastructure that a custom component
  provisions.
- `name`: The customer-provided name of the component.
- `template_file`: A path to the Infrastructure as Code (IaC) file describing
  infrastructure that a custom component provisions.  Components support a single IaC file,
  even if you use Terraform as your template language.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: The client token for the created component.
- `"description"`: An optional customer-provided description of the component.
- `"environmentName"`: The name of the Proton environment that you want to associate this
  component with. You must specify this when you don't specify serviceInstanceName and
  serviceName.
- `"serviceInstanceName"`: The name of the service instance that you want to attach this
  component to. If you don't specify this, the component isn't attached to any service
  instance. Specify both serviceInstanceName and serviceName or neither of them.
- `"serviceName"`: The name of the service that serviceInstanceName is associated with. If
  you don't specify this, the component isn't attached to any service instance. Specify both
  serviceInstanceName and serviceName or neither of them.
- `"serviceSpec"`: The service spec that you want the component to use to access service
  inputs. Set this only when you attach the component to a service instance.
- `"tags"`: An optional list of metadata items that you can associate with the Proton
  component. A tag is a key-value pair. For more information, see Proton resources and
  tagging in the Proton User Guide.
"""
function create_component(
    manifest, name, templateFile; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "CreateComponent",
        Dict{String,Any}(
            "manifest" => manifest,
            "name" => name,
            "templateFile" => templateFile,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_component(
    manifest,
    name,
    templateFile,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "CreateComponent",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "manifest" => manifest,
                    "name" => name,
                    "templateFile" => templateFile,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_environment(name, spec, template_major_version, template_name)
    create_environment(name, spec, template_major_version, template_name, params::Dict{String,<:Any})

Deploy a new environment. An Proton environment is created from an environment template
that defines infrastructure and resources that can be shared across services.  You can
provision environments using the following methods:    Amazon Web Services-managed
provisioning: Proton makes direct calls to provision your resources.   Self-managed
provisioning: Proton makes pull requests on your repository to provide compiled
infrastructure as code (IaC) files that your IaC engine uses to provision resources.   For
more information, see Environments and Provisioning methods in the Proton User Guide.

# Arguments
- `name`: The name of the environment.
- `spec`: A YAML formatted string that provides inputs as defined in the environment
  template bundle schema file. For more information, see Environments in the Proton User
  Guide.
- `template_major_version`: The major version of the environment template.
- `template_name`: The name of the environment template. For more information, see
  Environment Templates in the Proton User Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"codebuildRoleArn"`: The Amazon Resource Name (ARN) of the IAM service role that allows
  Proton to provision infrastructure using CodeBuild-based provisioning on your behalf. To
  use CodeBuild-based provisioning for the environment or for any service instance running in
  the environment, specify either the environmentAccountConnectionId or codebuildRoleArn
  parameter.
- `"componentRoleArn"`: The Amazon Resource Name (ARN) of the IAM service role that Proton
  uses when provisioning directly defined components in this environment. It determines the
  scope of infrastructure that a component can provision. You must specify componentRoleArn
  to allow directly defined components to be associated with this environment. For more
  information about components, see Proton components in the Proton User Guide.
- `"description"`: A description of the environment that's being created and deployed.
- `"environmentAccountConnectionId"`: The ID of the environment account connection that you
  provide if you're provisioning your environment infrastructure resources to an environment
  account. For more information, see Environment account connections in the Proton User
  guide. To use Amazon Web Services-managed provisioning for the environment, specify either
  the environmentAccountConnectionId or protonServiceRoleArn parameter and omit the
  provisioningRepository parameter.
- `"protonServiceRoleArn"`: The Amazon Resource Name (ARN) of the Proton service role that
  allows Proton to make calls to other services on your behalf. To use Amazon Web
  Services-managed provisioning for the environment, specify either the
  environmentAccountConnectionId or protonServiceRoleArn parameter and omit the
  provisioningRepository parameter.
- `"provisioningRepository"`: The linked repository that you use to host your rendered
  infrastructure templates for self-managed provisioning. A linked repository is a repository
  that has been registered with Proton. For more information, see CreateRepository. To use
  self-managed provisioning for the environment, specify this parameter and omit the
  environmentAccountConnectionId and protonServiceRoleArn parameters.
- `"tags"`: An optional list of metadata items that you can associate with the Proton
  environment. A tag is a key-value pair. For more information, see Proton resources and
  tagging in the Proton User Guide.
- `"templateMinorVersion"`: The minor version of the environment template.
"""
function create_environment(
    name,
    spec,
    templateMajorVersion,
    templateName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "CreateEnvironment",
        Dict{String,Any}(
            "name" => name,
            "spec" => spec,
            "templateMajorVersion" => templateMajorVersion,
            "templateName" => templateName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_environment(
    name,
    spec,
    templateMajorVersion,
    templateName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "CreateEnvironment",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "name" => name,
                    "spec" => spec,
                    "templateMajorVersion" => templateMajorVersion,
                    "templateName" => templateName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_environment_account_connection(environment_name, management_account_id)
    create_environment_account_connection(environment_name, management_account_id, params::Dict{String,<:Any})

Create an environment account connection in an environment account so that environment
infrastructure resources can be provisioned in the environment account from a management
account. An environment account connection is a secure bi-directional connection between a
management account and an environment account that maintains authorization and permissions.
For more information, see Environment account connections in the Proton User guide.

# Arguments
- `environment_name`: The name of the Proton environment that's created in the associated
  management account.
- `management_account_id`: The ID of the management account that accepts or rejects the
  environment account connection. You create and manage the Proton environment in this
  account. If the management account accepts the environment account connection, Proton can
  use the associated IAM role to provision environment infrastructure resources in the
  associated environment account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: When included, if two identical requests are made with the same client
  token, Proton returns the environment account connection that the first request created.
- `"codebuildRoleArn"`: The Amazon Resource Name (ARN) of an IAM service role in the
  environment account. Proton uses this role to provision infrastructure resources using
  CodeBuild-based provisioning in the associated environment account.
- `"componentRoleArn"`: The Amazon Resource Name (ARN) of the IAM service role that Proton
  uses when provisioning directly defined components in the associated environment account.
  It determines the scope of infrastructure that a component can provision in the account.
  You must specify componentRoleArn to allow directly defined components to be associated
  with any environments running in this account. For more information about components, see
  Proton components in the Proton User Guide.
- `"roleArn"`: The Amazon Resource Name (ARN) of the IAM service role that's created in the
  environment account. Proton uses this role to provision infrastructure resources in the
  associated environment account.
- `"tags"`: An optional list of metadata items that you can associate with the Proton
  environment account connection. A tag is a key-value pair. For more information, see Proton
  resources and tagging in the Proton User Guide.
"""
function create_environment_account_connection(
    environmentName, managementAccountId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "CreateEnvironmentAccountConnection",
        Dict{String,Any}(
            "environmentName" => environmentName,
            "managementAccountId" => managementAccountId,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_environment_account_connection(
    environmentName,
    managementAccountId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "CreateEnvironmentAccountConnection",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "environmentName" => environmentName,
                    "managementAccountId" => managementAccountId,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_environment_template(name)
    create_environment_template(name, params::Dict{String,<:Any})

Create an environment template for Proton. For more information, see Environment Templates
in the Proton User Guide. You can create an environment template in one of the two
following ways:   Register and publish a standard environment template that instructs
Proton to deploy and manage environment infrastructure.   Register and publish a customer
managed environment template that connects Proton to your existing provisioned
infrastructure that you manage. Proton doesn't manage your existing provisioned
infrastructure. To create an environment template for customer provisioned and managed
infrastructure, include the provisioning parameter and set the value to CUSTOMER_MANAGED.
For more information, see Register and publish an environment template in the Proton User
Guide.

# Arguments
- `name`: The name of the environment template.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A description of the environment template.
- `"displayName"`: The environment template name as displayed in the developer interface.
- `"encryptionKey"`: A customer provided encryption key that Proton uses to encrypt data.
- `"provisioning"`: When included, indicates that the environment template is for customer
  provisioned and managed infrastructure.
- `"tags"`: An optional list of metadata items that you can associate with the Proton
  environment template. A tag is a key-value pair. For more information, see Proton resources
  and tagging in the Proton User Guide.
"""
function create_environment_template(
    name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "CreateEnvironmentTemplate",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_environment_template(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "CreateEnvironmentTemplate",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_environment_template_version(source, template_name)
    create_environment_template_version(source, template_name, params::Dict{String,<:Any})

Create a new major or minor version of an environment template. A major version of an
environment template is a version that isn't backwards compatible. A minor version of an
environment template is a version that's backwards compatible within its major version.

# Arguments
- `source`: An object that includes the template bundle S3 bucket path and name for the new
  version of an template.
- `template_name`: The name of the environment template.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: When included, if two identical requests are made with the same client
  token, Proton returns the environment template version that the first request created.
- `"description"`: A description of the new version of an environment template.
- `"majorVersion"`: To create a new minor version of the environment template, include
  major Version. To create a new major and minor version of the environment template, exclude
  major Version.
- `"tags"`: An optional list of metadata items that you can associate with the Proton
  environment template version. A tag is a key-value pair. For more information, see Proton
  resources and tagging in the Proton User Guide.
"""
function create_environment_template_version(
    source, templateName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "CreateEnvironmentTemplateVersion",
        Dict{String,Any}(
            "source" => source,
            "templateName" => templateName,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_environment_template_version(
    source,
    templateName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "CreateEnvironmentTemplateVersion",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "source" => source,
                    "templateName" => templateName,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_repository(connection_arn, name, provider)
    create_repository(connection_arn, name, provider, params::Dict{String,<:Any})

Create and register a link to a repository. Proton uses the link to repeatedly access the
repository, to either push to it (self-managed provisioning) or pull from it (template
sync). You can share a linked repository across multiple resources (like environments using
self-managed provisioning, or synced templates). When you create a repository link, Proton
creates a service-linked role for you. For more information, see Self-managed provisioning,
Template bundles, and Template sync configurations in the Proton User Guide.

# Arguments
- `connection_arn`: The Amazon Resource Name (ARN) of your AWS CodeStar connection that
  connects Proton to your repository provider account. For more information, see Setting up
  for Proton in the Proton User Guide.
- `name`: The repository name (for example, myrepos/myrepo).
- `provider`: The repository provider.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"encryptionKey"`: The ARN of your customer Amazon Web Services Key Management Service
  (Amazon Web Services KMS) key.
- `"tags"`: An optional list of metadata items that you can associate with the Proton
  repository. A tag is a key-value pair. For more information, see Proton resources and
  tagging in the Proton User Guide.
"""
function create_repository(
    connectionArn, name, provider; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "CreateRepository",
        Dict{String,Any}(
            "connectionArn" => connectionArn, "name" => name, "provider" => provider
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_repository(
    connectionArn,
    name,
    provider,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "CreateRepository",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "connectionArn" => connectionArn, "name" => name, "provider" => provider
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_service(name, spec, template_major_version, template_name)
    create_service(name, spec, template_major_version, template_name, params::Dict{String,<:Any})

Create an Proton service. An Proton service is an instantiation of a service template and
often includes several service instances and pipeline. For more information, see Services
in the Proton User Guide.

# Arguments
- `name`: The service name.
- `spec`: A link to a spec file that provides inputs as defined in the service template
  bundle schema file. The spec file is in YAML format. Don’t include pipeline inputs in the
  spec if your service template doesn’t include a service pipeline. For more information,
  see Create a service in the Proton User Guide.
- `template_major_version`: The major version of the service template that was used to
  create the service.
- `template_name`: The name of the service template that's used to create the service.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"branchName"`: The name of the code repository branch that holds the code that's
  deployed in Proton. Don't include this parameter if your service template doesn't include a
  service pipeline.
- `"description"`: A description of the Proton service.
- `"repositoryConnectionArn"`: The Amazon Resource Name (ARN) of the repository connection.
  For more information, see Setting up an AWS CodeStar connection in the Proton User Guide.
  Don't include this parameter if your service template doesn't include a service pipeline.
- `"repositoryId"`: The ID of the code repository. Don't include this parameter if your
  service template doesn't include a service pipeline.
- `"tags"`: An optional list of metadata items that you can associate with the Proton
  service. A tag is a key-value pair. For more information, see Proton resources and tagging
  in the Proton User Guide.
- `"templateMinorVersion"`: The minor version of the service template that was used to
  create the service.
"""
function create_service(
    name,
    spec,
    templateMajorVersion,
    templateName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "CreateService",
        Dict{String,Any}(
            "name" => name,
            "spec" => spec,
            "templateMajorVersion" => templateMajorVersion,
            "templateName" => templateName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_service(
    name,
    spec,
    templateMajorVersion,
    templateName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "CreateService",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "name" => name,
                    "spec" => spec,
                    "templateMajorVersion" => templateMajorVersion,
                    "templateName" => templateName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_service_instance(name, service_name, spec)
    create_service_instance(name, service_name, spec, params::Dict{String,<:Any})

Create a service instance.

# Arguments
- `name`: The name of the service instance to create.
- `service_name`: The name of the service the service instance is added to.
- `spec`: The spec for the service instance you want to create.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: The client token of the service instance to create.
- `"tags"`: An optional list of metadata items that you can associate with the Proton
  service instance. A tag is a key-value pair. For more information, see Proton resources and
  tagging in the Proton User Guide.
- `"templateMajorVersion"`: To create a new major and minor version of the service
  template, exclude major Version.
- `"templateMinorVersion"`: To create a new minor version of the service template, include
  a major Version.
"""
function create_service_instance(
    name, serviceName, spec; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "CreateServiceInstance",
        Dict{String,Any}(
            "name" => name,
            "serviceName" => serviceName,
            "spec" => spec,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_service_instance(
    name,
    serviceName,
    spec,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "CreateServiceInstance",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "name" => name,
                    "serviceName" => serviceName,
                    "spec" => spec,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_service_sync_config(branch, file_path, repository_name, repository_provider, service_name)
    create_service_sync_config(branch, file_path, repository_name, repository_provider, service_name, params::Dict{String,<:Any})

Create the Proton Ops configuration file.

# Arguments
- `branch`: The repository branch for your Proton Ops file.
- `file_path`: The path to the Proton Ops file.
- `repository_name`: The repository name.
- `repository_provider`: The provider type for your repository.
- `service_name`: The name of the service the Proton Ops file is for.

"""
function create_service_sync_config(
    branch,
    filePath,
    repositoryName,
    repositoryProvider,
    serviceName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "CreateServiceSyncConfig",
        Dict{String,Any}(
            "branch" => branch,
            "filePath" => filePath,
            "repositoryName" => repositoryName,
            "repositoryProvider" => repositoryProvider,
            "serviceName" => serviceName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_service_sync_config(
    branch,
    filePath,
    repositoryName,
    repositoryProvider,
    serviceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "CreateServiceSyncConfig",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "branch" => branch,
                    "filePath" => filePath,
                    "repositoryName" => repositoryName,
                    "repositoryProvider" => repositoryProvider,
                    "serviceName" => serviceName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_service_template(name)
    create_service_template(name, params::Dict{String,<:Any})

Create a service template. The administrator creates a service template to define
standardized infrastructure and an optional CI/CD service pipeline. Developers, in turn,
select the service template from Proton. If the selected service template includes a
service pipeline definition, they provide a link to their source code repository. Proton
then deploys and manages the infrastructure defined by the selected service template. For
more information, see Proton templates in the Proton User Guide.

# Arguments
- `name`: The name of the service template.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A description of the service template.
- `"displayName"`: The name of the service template as displayed in the developer interface.
- `"encryptionKey"`: A customer provided encryption key that's used to encrypt data.
- `"pipelineProvisioning"`: By default, Proton provides a service pipeline for your
  service. When this parameter is included, it indicates that an Proton service pipeline
  isn't provided for your service. After it's included, it can't be changed. For more
  information, see Template bundles in the Proton User Guide.
- `"tags"`: An optional list of metadata items that you can associate with the Proton
  service template. A tag is a key-value pair. For more information, see Proton resources and
  tagging in the Proton User Guide.
"""
function create_service_template(name; aws_config::AbstractAWSConfig=current_aws_config())
    return proton(
        "CreateServiceTemplate",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_service_template(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "CreateServiceTemplate",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_service_template_version(compatible_environment_templates, source, template_name)
    create_service_template_version(compatible_environment_templates, source, template_name, params::Dict{String,<:Any})

Create a new major or minor version of a service template. A major version of a service
template is a version that isn't backward compatible. A minor version of a service template
is a version that's backward compatible within its major version.

# Arguments
- `compatible_environment_templates`: An array of environment template objects that are
  compatible with the new service template version. A service instance based on this service
  template version can run in environments based on compatible templates.
- `source`: An object that includes the template bundle S3 bucket path and name for the new
  version of a service template.
- `template_name`: The name of the service template.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: When included, if two identical requests are made with the same client
  token, Proton returns the service template version that the first request created.
- `"description"`: A description of the new version of a service template.
- `"majorVersion"`: To create a new minor version of the service template, include a major
  Version. To create a new major and minor version of the service template, exclude major
  Version.
- `"supportedComponentSources"`: An array of supported component sources. Components with
  supported sources can be attached to service instances based on this service template
  version. For more information about components, see Proton components in the Proton User
  Guide.
- `"tags"`: An optional list of metadata items that you can associate with the Proton
  service template version. A tag is a key-value pair. For more information, see Proton
  resources and tagging in the Proton User Guide.
"""
function create_service_template_version(
    compatibleEnvironmentTemplates,
    source,
    templateName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "CreateServiceTemplateVersion",
        Dict{String,Any}(
            "compatibleEnvironmentTemplates" => compatibleEnvironmentTemplates,
            "source" => source,
            "templateName" => templateName,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_service_template_version(
    compatibleEnvironmentTemplates,
    source,
    templateName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "CreateServiceTemplateVersion",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "compatibleEnvironmentTemplates" => compatibleEnvironmentTemplates,
                    "source" => source,
                    "templateName" => templateName,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_template_sync_config(branch, repository_name, repository_provider, template_name, template_type)
    create_template_sync_config(branch, repository_name, repository_provider, template_name, template_type, params::Dict{String,<:Any})

Set up a template to create new template versions automatically by tracking a linked
repository. A linked repository is a repository that has been registered with Proton. For
more information, see CreateRepository. When a commit is pushed to your linked repository,
Proton checks for changes to your repository template bundles. If it detects a template
bundle change, a new major or minor version of its template is created, if the version
doesn’t already exist. For more information, see Template sync configurations in the
Proton User Guide.

# Arguments
- `branch`: The repository branch for your template.
- `repository_name`: The repository name (for example, myrepos/myrepo).
- `repository_provider`: The provider type for your repository.
- `template_name`: The name of your registered template.
- `template_type`: The type of the registered template.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"subdirectory"`: A repository subdirectory path to your template bundle directory. When
  included, Proton limits the template bundle search to this repository directory.
"""
function create_template_sync_config(
    branch,
    repositoryName,
    repositoryProvider,
    templateName,
    templateType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "CreateTemplateSyncConfig",
        Dict{String,Any}(
            "branch" => branch,
            "repositoryName" => repositoryName,
            "repositoryProvider" => repositoryProvider,
            "templateName" => templateName,
            "templateType" => templateType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_template_sync_config(
    branch,
    repositoryName,
    repositoryProvider,
    templateName,
    templateType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "CreateTemplateSyncConfig",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "branch" => branch,
                    "repositoryName" => repositoryName,
                    "repositoryProvider" => repositoryProvider,
                    "templateName" => templateName,
                    "templateType" => templateType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_component(name)
    delete_component(name, params::Dict{String,<:Any})

Delete an Proton component resource. For more information about components, see Proton
components in the Proton User Guide.

# Arguments
- `name`: The name of the component to delete.

"""
function delete_component(name; aws_config::AbstractAWSConfig=current_aws_config())
    return proton(
        "DeleteComponent",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_component(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "DeleteComponent",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_deployment(id)
    delete_deployment(id, params::Dict{String,<:Any})

Delete the deployment.

# Arguments
- `id`: The ID of the deployment to delete.

"""
function delete_deployment(id; aws_config::AbstractAWSConfig=current_aws_config())
    return proton(
        "DeleteDeployment",
        Dict{String,Any}("id" => id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_deployment(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "DeleteDeployment",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("id" => id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_environment(name)
    delete_environment(name, params::Dict{String,<:Any})

Delete an environment.

# Arguments
- `name`: The name of the environment to delete.

"""
function delete_environment(name; aws_config::AbstractAWSConfig=current_aws_config())
    return proton(
        "DeleteEnvironment",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_environment(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "DeleteEnvironment",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_environment_account_connection(id)
    delete_environment_account_connection(id, params::Dict{String,<:Any})

In an environment account, delete an environment account connection. After you delete an
environment account connection that’s in use by an Proton environment, Proton can’t
manage the environment infrastructure resources until a new environment account connection
is accepted for the environment account and associated environment. You're responsible for
cleaning up provisioned resources that remain without an environment connection. For more
information, see Environment account connections in the Proton User guide.

# Arguments
- `id`: The ID of the environment account connection to delete.

"""
function delete_environment_account_connection(
    id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "DeleteEnvironmentAccountConnection",
        Dict{String,Any}("id" => id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_environment_account_connection(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "DeleteEnvironmentAccountConnection",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("id" => id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_environment_template(name)
    delete_environment_template(name, params::Dict{String,<:Any})

If no other major or minor versions of an environment template exist, delete the
environment template.

# Arguments
- `name`: The name of the environment template to delete.

"""
function delete_environment_template(
    name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "DeleteEnvironmentTemplate",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_environment_template(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "DeleteEnvironmentTemplate",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_environment_template_version(major_version, minor_version, template_name)
    delete_environment_template_version(major_version, minor_version, template_name, params::Dict{String,<:Any})

If no other minor versions of an environment template exist, delete a major version of the
environment template if it's not the Recommended version. Delete the Recommended version of
the environment template if no other major versions or minor versions of the environment
template exist. A major version of an environment template is a version that's not backward
compatible. Delete a minor version of an environment template if it isn't the Recommended
version. Delete a Recommended minor version of the environment template if no other minor
versions of the environment template exist. A minor version of an environment template is a
version that's backward compatible.

# Arguments
- `major_version`: The environment template major version to delete.
- `minor_version`: The environment template minor version to delete.
- `template_name`: The name of the environment template.

"""
function delete_environment_template_version(
    majorVersion,
    minorVersion,
    templateName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "DeleteEnvironmentTemplateVersion",
        Dict{String,Any}(
            "majorVersion" => majorVersion,
            "minorVersion" => minorVersion,
            "templateName" => templateName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_environment_template_version(
    majorVersion,
    minorVersion,
    templateName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "DeleteEnvironmentTemplateVersion",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "majorVersion" => majorVersion,
                    "minorVersion" => minorVersion,
                    "templateName" => templateName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_repository(name, provider)
    delete_repository(name, provider, params::Dict{String,<:Any})

De-register and unlink your repository.

# Arguments
- `name`: The repository name.
- `provider`: The repository provider.

"""
function delete_repository(
    name, provider; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "DeleteRepository",
        Dict{String,Any}("name" => name, "provider" => provider);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_repository(
    name,
    provider,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "DeleteRepository",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("name" => name, "provider" => provider), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_service(name)
    delete_service(name, params::Dict{String,<:Any})

Delete a service, with its instances and pipeline.  You can't delete a service if it has
any service instances that have components attached to them. For more information about
components, see Proton components in the Proton User Guide.

# Arguments
- `name`: The name of the service to delete.

"""
function delete_service(name; aws_config::AbstractAWSConfig=current_aws_config())
    return proton(
        "DeleteService",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_service(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "DeleteService",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_service_sync_config(service_name)
    delete_service_sync_config(service_name, params::Dict{String,<:Any})

Delete the Proton Ops file.

# Arguments
- `service_name`: The name of the service that you want to delete the service sync
  configuration for.

"""
function delete_service_sync_config(
    serviceName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "DeleteServiceSyncConfig",
        Dict{String,Any}("serviceName" => serviceName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_service_sync_config(
    serviceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "DeleteServiceSyncConfig",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("serviceName" => serviceName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_service_template(name)
    delete_service_template(name, params::Dict{String,<:Any})

If no other major or minor versions of the service template exist, delete the service
template.

# Arguments
- `name`: The name of the service template to delete.

"""
function delete_service_template(name; aws_config::AbstractAWSConfig=current_aws_config())
    return proton(
        "DeleteServiceTemplate",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_service_template(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "DeleteServiceTemplate",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_service_template_version(major_version, minor_version, template_name)
    delete_service_template_version(major_version, minor_version, template_name, params::Dict{String,<:Any})

If no other minor versions of a service template exist, delete a major version of the
service template if it's not the Recommended version. Delete the Recommended version of the
service template if no other major versions or minor versions of the service template
exist. A major version of a service template is a version that isn't backwards compatible.
Delete a minor version of a service template if it's not the Recommended version. Delete a
Recommended minor version of the service template if no other minor versions of the service
template exist. A minor version of a service template is a version that's backwards
compatible.

# Arguments
- `major_version`: The service template major version to delete.
- `minor_version`: The service template minor version to delete.
- `template_name`: The name of the service template.

"""
function delete_service_template_version(
    majorVersion,
    minorVersion,
    templateName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "DeleteServiceTemplateVersion",
        Dict{String,Any}(
            "majorVersion" => majorVersion,
            "minorVersion" => minorVersion,
            "templateName" => templateName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_service_template_version(
    majorVersion,
    minorVersion,
    templateName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "DeleteServiceTemplateVersion",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "majorVersion" => majorVersion,
                    "minorVersion" => minorVersion,
                    "templateName" => templateName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_template_sync_config(template_name, template_type)
    delete_template_sync_config(template_name, template_type, params::Dict{String,<:Any})

Delete a template sync configuration.

# Arguments
- `template_name`: The template name.
- `template_type`: The template type.

"""
function delete_template_sync_config(
    templateName, templateType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "DeleteTemplateSyncConfig",
        Dict{String,Any}("templateName" => templateName, "templateType" => templateType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_template_sync_config(
    templateName,
    templateType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "DeleteTemplateSyncConfig",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "templateName" => templateName, "templateType" => templateType
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_account_settings()
    get_account_settings(params::Dict{String,<:Any})

Get detail data for Proton account-wide settings.

"""
function get_account_settings(; aws_config::AbstractAWSConfig=current_aws_config())
    return proton(
        "GetAccountSettings"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_account_settings(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "GetAccountSettings", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_component(name)
    get_component(name, params::Dict{String,<:Any})

Get detailed data for a component. For more information about components, see Proton
components in the Proton User Guide.

# Arguments
- `name`: The name of the component that you want to get the detailed data for.

"""
function get_component(name; aws_config::AbstractAWSConfig=current_aws_config())
    return proton(
        "GetComponent",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_component(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "GetComponent",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_deployment(id)
    get_deployment(id, params::Dict{String,<:Any})

Get detailed data for a deployment.

# Arguments
- `id`: The ID of the deployment that you want to get the detailed data for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"componentName"`: The name of a component that you want to get the detailed data for.
- `"environmentName"`: The name of a environment that you want to get the detailed data for.
- `"serviceInstanceName"`: The name of the service instance associated with the given
  deployment ID. serviceName must be specified to identify the service instance.
- `"serviceName"`: The name of the service associated with the given deployment ID.
"""
function get_deployment(id; aws_config::AbstractAWSConfig=current_aws_config())
    return proton(
        "GetDeployment",
        Dict{String,Any}("id" => id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_deployment(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "GetDeployment",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("id" => id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_environment(name)
    get_environment(name, params::Dict{String,<:Any})

Get detailed data for an environment.

# Arguments
- `name`: The name of the environment that you want to get the detailed data for.

"""
function get_environment(name; aws_config::AbstractAWSConfig=current_aws_config())
    return proton(
        "GetEnvironment",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_environment(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "GetEnvironment",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_environment_account_connection(id)
    get_environment_account_connection(id, params::Dict{String,<:Any})

In an environment account, get the detailed data for an environment account connection. For
more information, see Environment account connections in the Proton User guide.

# Arguments
- `id`: The ID of the environment account connection that you want to get the detailed data
  for.

"""
function get_environment_account_connection(
    id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "GetEnvironmentAccountConnection",
        Dict{String,Any}("id" => id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_environment_account_connection(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "GetEnvironmentAccountConnection",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("id" => id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_environment_template(name)
    get_environment_template(name, params::Dict{String,<:Any})

Get detailed data for an environment template.

# Arguments
- `name`: The name of the environment template that you want to get the detailed data for.

"""
function get_environment_template(name; aws_config::AbstractAWSConfig=current_aws_config())
    return proton(
        "GetEnvironmentTemplate",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_environment_template(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "GetEnvironmentTemplate",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_environment_template_version(major_version, minor_version, template_name)
    get_environment_template_version(major_version, minor_version, template_name, params::Dict{String,<:Any})

Get detailed data for a major or minor version of an environment template.

# Arguments
- `major_version`: To get environment template major version detail data, include major
  Version.
- `minor_version`: To get environment template minor version detail data, include
  minorVersion.
- `template_name`: The name of the environment template a version of which you want to get
  detailed data for.

"""
function get_environment_template_version(
    majorVersion,
    minorVersion,
    templateName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "GetEnvironmentTemplateVersion",
        Dict{String,Any}(
            "majorVersion" => majorVersion,
            "minorVersion" => minorVersion,
            "templateName" => templateName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_environment_template_version(
    majorVersion,
    minorVersion,
    templateName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "GetEnvironmentTemplateVersion",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "majorVersion" => majorVersion,
                    "minorVersion" => minorVersion,
                    "templateName" => templateName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_repository(name, provider)
    get_repository(name, provider, params::Dict{String,<:Any})

Get detail data for a linked repository.

# Arguments
- `name`: The repository name, for example myrepos/myrepo.
- `provider`: The repository provider.

"""
function get_repository(name, provider; aws_config::AbstractAWSConfig=current_aws_config())
    return proton(
        "GetRepository",
        Dict{String,Any}("name" => name, "provider" => provider);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_repository(
    name,
    provider,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "GetRepository",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("name" => name, "provider" => provider), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_repository_sync_status(branch, repository_name, repository_provider, sync_type)
    get_repository_sync_status(branch, repository_name, repository_provider, sync_type, params::Dict{String,<:Any})

Get the sync status of a repository used for Proton template sync. For more information
about template sync, see .  A repository sync status isn't tied to the Proton Repository
resource (or any other Proton resource). Therefore, tags on an Proton Repository resource
have no effect on this action. Specifically, you can't use these tags to control access to
this action using Attribute-based access control (ABAC). For more information about ABAC,
see ABAC in the Proton User Guide.

# Arguments
- `branch`: The repository branch.
- `repository_name`: The repository name.
- `repository_provider`: The repository provider.
- `sync_type`: The repository sync type.

"""
function get_repository_sync_status(
    branch,
    repositoryName,
    repositoryProvider,
    syncType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "GetRepositorySyncStatus",
        Dict{String,Any}(
            "branch" => branch,
            "repositoryName" => repositoryName,
            "repositoryProvider" => repositoryProvider,
            "syncType" => syncType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_repository_sync_status(
    branch,
    repositoryName,
    repositoryProvider,
    syncType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "GetRepositorySyncStatus",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "branch" => branch,
                    "repositoryName" => repositoryName,
                    "repositoryProvider" => repositoryProvider,
                    "syncType" => syncType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_resources_summary()
    get_resources_summary(params::Dict{String,<:Any})

Get counts of Proton resources. For infrastructure-provisioning resources (environments,
services, service instances, pipelines), the action returns staleness counts. A resource is
stale when it's behind the recommended version of the Proton template that it uses and it
needs an update to become current. The action returns staleness counts (counts of resources
that are up-to-date, behind a template major version, or behind a template minor version),
the total number of resources, and the number of resources that are in a failed state,
grouped by resource type. Components, environments, and service templates return less
information - see the components, environments, and serviceTemplates field descriptions.
For context, the action also returns the total number of each type of Proton template in
the Amazon Web Services account. For more information, see Proton dashboard in the Proton
User Guide.

"""
function get_resources_summary(; aws_config::AbstractAWSConfig=current_aws_config())
    return proton(
        "GetResourcesSummary"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_resources_summary(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "GetResourcesSummary",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_service(name)
    get_service(name, params::Dict{String,<:Any})

Get detailed data for a service.

# Arguments
- `name`: The name of the service that you want to get the detailed data for.

"""
function get_service(name; aws_config::AbstractAWSConfig=current_aws_config())
    return proton(
        "GetService",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_service(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "GetService",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_service_instance(name, service_name)
    get_service_instance(name, service_name, params::Dict{String,<:Any})

Get detailed data for a service instance. A service instance is an instantiation of service
template and it runs in a specific environment.

# Arguments
- `name`: The name of a service instance that you want to get the detailed data for.
- `service_name`: The name of the service that you want the service instance input for.

"""
function get_service_instance(
    name, serviceName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "GetServiceInstance",
        Dict{String,Any}("name" => name, "serviceName" => serviceName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_service_instance(
    name,
    serviceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "GetServiceInstance",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("name" => name, "serviceName" => serviceName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_service_instance_sync_status(service_instance_name, service_name)
    get_service_instance_sync_status(service_instance_name, service_name, params::Dict{String,<:Any})

Get the status of the synced service instance.

# Arguments
- `service_instance_name`: The name of the service instance that you want the sync status
  input for.
- `service_name`: The name of the service that the service instance belongs to.

"""
function get_service_instance_sync_status(
    serviceInstanceName, serviceName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "GetServiceInstanceSyncStatus",
        Dict{String,Any}(
            "serviceInstanceName" => serviceInstanceName, "serviceName" => serviceName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_service_instance_sync_status(
    serviceInstanceName,
    serviceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "GetServiceInstanceSyncStatus",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "serviceInstanceName" => serviceInstanceName,
                    "serviceName" => serviceName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_service_sync_blocker_summary(service_name)
    get_service_sync_blocker_summary(service_name, params::Dict{String,<:Any})

Get detailed data for the service sync blocker summary.

# Arguments
- `service_name`: The name of the service that you want to get the service sync blocker
  summary for. If given only the service name, all instances are blocked.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"serviceInstanceName"`: The name of the service instance that you want to get the
  service sync blocker summary for. If given bothe the instance name and the service name,
  only the instance is blocked.
"""
function get_service_sync_blocker_summary(
    serviceName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "GetServiceSyncBlockerSummary",
        Dict{String,Any}("serviceName" => serviceName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_service_sync_blocker_summary(
    serviceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "GetServiceSyncBlockerSummary",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("serviceName" => serviceName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_service_sync_config(service_name)
    get_service_sync_config(service_name, params::Dict{String,<:Any})

Get detailed information for the service sync configuration.

# Arguments
- `service_name`: The name of the service that you want to get the service sync
  configuration for.

"""
function get_service_sync_config(
    serviceName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "GetServiceSyncConfig",
        Dict{String,Any}("serviceName" => serviceName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_service_sync_config(
    serviceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "GetServiceSyncConfig",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("serviceName" => serviceName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_service_template(name)
    get_service_template(name, params::Dict{String,<:Any})

Get detailed data for a service template.

# Arguments
- `name`: The name of the service template that you want to get detailed data for.

"""
function get_service_template(name; aws_config::AbstractAWSConfig=current_aws_config())
    return proton(
        "GetServiceTemplate",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_service_template(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "GetServiceTemplate",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_service_template_version(major_version, minor_version, template_name)
    get_service_template_version(major_version, minor_version, template_name, params::Dict{String,<:Any})

Get detailed data for a major or minor version of a service template.

# Arguments
- `major_version`: To get service template major version detail data, include major Version.
- `minor_version`: To get service template minor version detail data, include minorVersion.
- `template_name`: The name of the service template a version of which you want to get
  detailed data for.

"""
function get_service_template_version(
    majorVersion,
    minorVersion,
    templateName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "GetServiceTemplateVersion",
        Dict{String,Any}(
            "majorVersion" => majorVersion,
            "minorVersion" => minorVersion,
            "templateName" => templateName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_service_template_version(
    majorVersion,
    minorVersion,
    templateName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "GetServiceTemplateVersion",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "majorVersion" => majorVersion,
                    "minorVersion" => minorVersion,
                    "templateName" => templateName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_template_sync_config(template_name, template_type)
    get_template_sync_config(template_name, template_type, params::Dict{String,<:Any})

Get detail data for a template sync configuration.

# Arguments
- `template_name`: The template name.
- `template_type`: The template type.

"""
function get_template_sync_config(
    templateName, templateType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "GetTemplateSyncConfig",
        Dict{String,Any}("templateName" => templateName, "templateType" => templateType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_template_sync_config(
    templateName,
    templateType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "GetTemplateSyncConfig",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "templateName" => templateName, "templateType" => templateType
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_template_sync_status(template_name, template_type, template_version)
    get_template_sync_status(template_name, template_type, template_version, params::Dict{String,<:Any})

Get the status of a template sync.

# Arguments
- `template_name`: The template name.
- `template_type`: The template type.
- `template_version`: The template major version.

"""
function get_template_sync_status(
    templateName,
    templateType,
    templateVersion;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "GetTemplateSyncStatus",
        Dict{String,Any}(
            "templateName" => templateName,
            "templateType" => templateType,
            "templateVersion" => templateVersion,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_template_sync_status(
    templateName,
    templateType,
    templateVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "GetTemplateSyncStatus",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "templateName" => templateName,
                    "templateType" => templateType,
                    "templateVersion" => templateVersion,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_component_outputs(component_name)
    list_component_outputs(component_name, params::Dict{String,<:Any})

Get a list of component Infrastructure as Code (IaC) outputs. For more information about
components, see Proton components in the Proton User Guide.

# Arguments
- `component_name`: The name of the component whose outputs you want.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"deploymentId"`: The ID of the deployment whose outputs you want.
- `"nextToken"`: A token that indicates the location of the next output in the array of
  outputs, after the list of outputs that was previously requested.
"""
function list_component_outputs(
    componentName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "ListComponentOutputs",
        Dict{String,Any}("componentName" => componentName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_component_outputs(
    componentName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "ListComponentOutputs",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("componentName" => componentName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_component_provisioned_resources(component_name)
    list_component_provisioned_resources(component_name, params::Dict{String,<:Any})

List provisioned resources for a component with details. For more information about
components, see Proton components in the Proton User Guide.

# Arguments
- `component_name`: The name of the component whose provisioned resources you want.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: A token that indicates the location of the next provisioned resource in
  the array of provisioned resources, after the list of provisioned resources that was
  previously requested.
"""
function list_component_provisioned_resources(
    componentName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "ListComponentProvisionedResources",
        Dict{String,Any}("componentName" => componentName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_component_provisioned_resources(
    componentName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "ListComponentProvisionedResources",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("componentName" => componentName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_components()
    list_components(params::Dict{String,<:Any})

List components with summary data. You can filter the result list by environment, service,
or a single service instance. For more information about components, see Proton components
in the Proton User Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"environmentName"`: The name of an environment for result list filtering. Proton returns
  components associated with the environment or attached to service instances running in it.
- `"maxResults"`: The maximum number of components to list.
- `"nextToken"`: A token that indicates the location of the next component in the array of
  components, after the list of components that was previously requested.
- `"serviceInstanceName"`: The name of a service instance for result list filtering. Proton
  returns the component attached to the service instance, if any.
- `"serviceName"`: The name of a service for result list filtering. Proton returns
  components attached to service instances of the service.
"""
function list_components(; aws_config::AbstractAWSConfig=current_aws_config())
    return proton("ListComponents"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_components(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "ListComponents", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_deployments()
    list_deployments(params::Dict{String,<:Any})

List deployments. You can filter the result list by environment, service, or a single
service instance.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"componentName"`: The name of a component for result list filtering. Proton returns
  deployments associated with that component.
- `"environmentName"`: The name of an environment for result list filtering. Proton returns
  deployments associated with the environment.
- `"maxResults"`: The maximum number of deployments to list.
- `"nextToken"`: A token that indicates the location of the next deployment in the array of
  deployment, after the list of deployment that was previously requested.
- `"serviceInstanceName"`: The name of a service instance for result list filtering. Proton
  returns the deployments associated with the service instance.
- `"serviceName"`: The name of a service for result list filtering. Proton returns
  deployments associated with service instances of the service.
"""
function list_deployments(; aws_config::AbstractAWSConfig=current_aws_config())
    return proton("ListDeployments"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_deployments(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "ListDeployments", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_environment_account_connections(requested_by)
    list_environment_account_connections(requested_by, params::Dict{String,<:Any})

View a list of environment account connections. For more information, see Environment
account connections in the Proton User guide.

# Arguments
- `requested_by`: The type of account making the ListEnvironmentAccountConnections request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"environmentName"`: The environment name that's associated with each listed environment
  account connection.
- `"maxResults"`: The maximum number of environment account connections to list.
- `"nextToken"`: A token that indicates the location of the next environment account
  connection in the array of environment account connections, after the list of environment
  account connections that was previously requested.
- `"statuses"`: The status details for each listed environment account connection.
"""
function list_environment_account_connections(
    requestedBy; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "ListEnvironmentAccountConnections",
        Dict{String,Any}("requestedBy" => requestedBy);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_environment_account_connections(
    requestedBy,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "ListEnvironmentAccountConnections",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("requestedBy" => requestedBy), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_environment_outputs(environment_name)
    list_environment_outputs(environment_name, params::Dict{String,<:Any})

List the infrastructure as code outputs for your environment.

# Arguments
- `environment_name`: The environment name.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"deploymentId"`: The ID of the deployment whose outputs you want.
- `"nextToken"`: A token that indicates the location of the next environment output in the
  array of environment outputs, after the list of environment outputs that was previously
  requested.
"""
function list_environment_outputs(
    environmentName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "ListEnvironmentOutputs",
        Dict{String,Any}("environmentName" => environmentName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_environment_outputs(
    environmentName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "ListEnvironmentOutputs",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("environmentName" => environmentName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_environment_provisioned_resources(environment_name)
    list_environment_provisioned_resources(environment_name, params::Dict{String,<:Any})

List the provisioned resources for your environment.

# Arguments
- `environment_name`: The environment name.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: A token that indicates the location of the next environment provisioned
  resource in the array of environment provisioned resources, after the list of environment
  provisioned resources that was previously requested.
"""
function list_environment_provisioned_resources(
    environmentName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "ListEnvironmentProvisionedResources",
        Dict{String,Any}("environmentName" => environmentName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_environment_provisioned_resources(
    environmentName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "ListEnvironmentProvisionedResources",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("environmentName" => environmentName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_environment_template_versions(template_name)
    list_environment_template_versions(template_name, params::Dict{String,<:Any})

List major or minor versions of an environment template with detail data.

# Arguments
- `template_name`: The name of the environment template.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"majorVersion"`: To view a list of minor of versions under a major version of an
  environment template, include major Version. To view a list of major versions of an
  environment template, exclude major Version.
- `"maxResults"`: The maximum number of major or minor versions of an environment template
  to list.
- `"nextToken"`: A token that indicates the location of the next major or minor version in
  the array of major or minor versions of an environment template, after the list of major or
  minor versions that was previously requested.
"""
function list_environment_template_versions(
    templateName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "ListEnvironmentTemplateVersions",
        Dict{String,Any}("templateName" => templateName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_environment_template_versions(
    templateName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "ListEnvironmentTemplateVersions",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("templateName" => templateName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_environment_templates()
    list_environment_templates(params::Dict{String,<:Any})

List environment templates.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of environment templates to list.
- `"nextToken"`: A token that indicates the location of the next environment template in
  the array of environment templates, after the list of environment templates that was
  previously requested.
"""
function list_environment_templates(; aws_config::AbstractAWSConfig=current_aws_config())
    return proton(
        "ListEnvironmentTemplates"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_environment_templates(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "ListEnvironmentTemplates",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_environments()
    list_environments(params::Dict{String,<:Any})

List environments with detail data summaries.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"environmentTemplates"`: An array of the versions of the environment template.
- `"maxResults"`: The maximum number of environments to list.
- `"nextToken"`: A token that indicates the location of the next environment in the array
  of environments, after the list of environments that was previously requested.
"""
function list_environments(; aws_config::AbstractAWSConfig=current_aws_config())
    return proton(
        "ListEnvironments"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_environments(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "ListEnvironments", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_repositories()
    list_repositories(params::Dict{String,<:Any})

List linked repositories with detail data.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of repositories to list.
- `"nextToken"`: A token that indicates the location of the next repository in the array of
  repositories, after the list of repositories previously requested.
"""
function list_repositories(; aws_config::AbstractAWSConfig=current_aws_config())
    return proton(
        "ListRepositories"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_repositories(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "ListRepositories", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_repository_sync_definitions(repository_name, repository_provider, sync_type)
    list_repository_sync_definitions(repository_name, repository_provider, sync_type, params::Dict{String,<:Any})

List repository sync definitions with detail data.

# Arguments
- `repository_name`: The repository name.
- `repository_provider`: The repository provider.
- `sync_type`: The sync type. The only supported value is TEMPLATE_SYNC.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: A token that indicates the location of the next repository sync definition
  in the array of repository sync definitions, after the list of repository sync definitions
  previously requested.
"""
function list_repository_sync_definitions(
    repositoryName,
    repositoryProvider,
    syncType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "ListRepositorySyncDefinitions",
        Dict{String,Any}(
            "repositoryName" => repositoryName,
            "repositoryProvider" => repositoryProvider,
            "syncType" => syncType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_repository_sync_definitions(
    repositoryName,
    repositoryProvider,
    syncType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "ListRepositorySyncDefinitions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "repositoryName" => repositoryName,
                    "repositoryProvider" => repositoryProvider,
                    "syncType" => syncType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_service_instance_outputs(service_instance_name, service_name)
    list_service_instance_outputs(service_instance_name, service_name, params::Dict{String,<:Any})

Get a list service of instance Infrastructure as Code (IaC) outputs.

# Arguments
- `service_instance_name`: The name of the service instance whose outputs you want.
- `service_name`: The name of the service that serviceInstanceName is associated to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"deploymentId"`: The ID of the deployment whose outputs you want.
- `"nextToken"`: A token that indicates the location of the next output in the array of
  outputs, after the list of outputs that was previously requested.
"""
function list_service_instance_outputs(
    serviceInstanceName, serviceName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "ListServiceInstanceOutputs",
        Dict{String,Any}(
            "serviceInstanceName" => serviceInstanceName, "serviceName" => serviceName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_service_instance_outputs(
    serviceInstanceName,
    serviceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "ListServiceInstanceOutputs",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "serviceInstanceName" => serviceInstanceName,
                    "serviceName" => serviceName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_service_instance_provisioned_resources(service_instance_name, service_name)
    list_service_instance_provisioned_resources(service_instance_name, service_name, params::Dict{String,<:Any})

List provisioned resources for a service instance with details.

# Arguments
- `service_instance_name`: The name of the service instance whose provisioned resources you
  want.
- `service_name`: The name of the service that serviceInstanceName is associated to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: A token that indicates the location of the next provisioned resource in
  the array of provisioned resources, after the list of provisioned resources that was
  previously requested.
"""
function list_service_instance_provisioned_resources(
    serviceInstanceName, serviceName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "ListServiceInstanceProvisionedResources",
        Dict{String,Any}(
            "serviceInstanceName" => serviceInstanceName, "serviceName" => serviceName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_service_instance_provisioned_resources(
    serviceInstanceName,
    serviceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "ListServiceInstanceProvisionedResources",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "serviceInstanceName" => serviceInstanceName,
                    "serviceName" => serviceName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_service_instances()
    list_service_instances(params::Dict{String,<:Any})

List service instances with summary data. This action lists service instances of all
services in the Amazon Web Services account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: An array of filtering criteria that scope down the result list. By default,
  all service instances in the Amazon Web Services account are returned.
- `"maxResults"`: The maximum number of service instances to list.
- `"nextToken"`: A token that indicates the location of the next service in the array of
  service instances, after the list of service instances that was previously requested.
- `"serviceName"`: The name of the service that the service instance belongs to.
- `"sortBy"`: The field that the result list is sorted by. When you choose to sort by
  serviceName, service instances within each service are sorted by service instance name.
  Default: serviceName
- `"sortOrder"`: Result list sort order. Default: ASCENDING
"""
function list_service_instances(; aws_config::AbstractAWSConfig=current_aws_config())
    return proton(
        "ListServiceInstances"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_service_instances(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "ListServiceInstances",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_service_pipeline_outputs(service_name)
    list_service_pipeline_outputs(service_name, params::Dict{String,<:Any})

Get a list of service pipeline Infrastructure as Code (IaC) outputs.

# Arguments
- `service_name`: The name of the service whose pipeline's outputs you want.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"deploymentId"`: The ID of the deployment you want the outputs for.
- `"nextToken"`: A token that indicates the location of the next output in the array of
  outputs, after the list of outputs that was previously requested.
"""
function list_service_pipeline_outputs(
    serviceName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "ListServicePipelineOutputs",
        Dict{String,Any}("serviceName" => serviceName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_service_pipeline_outputs(
    serviceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "ListServicePipelineOutputs",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("serviceName" => serviceName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_service_pipeline_provisioned_resources(service_name)
    list_service_pipeline_provisioned_resources(service_name, params::Dict{String,<:Any})

List provisioned resources for a service and pipeline with details.

# Arguments
- `service_name`: The name of the service whose pipeline's provisioned resources you want.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: A token that indicates the location of the next provisioned resource in
  the array of provisioned resources, after the list of provisioned resources that was
  previously requested.
"""
function list_service_pipeline_provisioned_resources(
    serviceName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "ListServicePipelineProvisionedResources",
        Dict{String,Any}("serviceName" => serviceName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_service_pipeline_provisioned_resources(
    serviceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "ListServicePipelineProvisionedResources",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("serviceName" => serviceName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_service_template_versions(template_name)
    list_service_template_versions(template_name, params::Dict{String,<:Any})

List major or minor versions of a service template with detail data.

# Arguments
- `template_name`: The name of the service template.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"majorVersion"`: To view a list of minor of versions under a major version of a service
  template, include major Version. To view a list of major versions of a service template,
  exclude major Version.
- `"maxResults"`: The maximum number of major or minor versions of a service template to
  list.
- `"nextToken"`: A token that indicates the location of the next major or minor version in
  the array of major or minor versions of a service template, after the list of major or
  minor versions that was previously requested.
"""
function list_service_template_versions(
    templateName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "ListServiceTemplateVersions",
        Dict{String,Any}("templateName" => templateName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_service_template_versions(
    templateName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "ListServiceTemplateVersions",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("templateName" => templateName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_service_templates()
    list_service_templates(params::Dict{String,<:Any})

List service templates with detail data.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of service templates to list.
- `"nextToken"`: A token that indicates the location of the next service template in the
  array of service templates, after the list of service templates previously requested.
"""
function list_service_templates(; aws_config::AbstractAWSConfig=current_aws_config())
    return proton(
        "ListServiceTemplates"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_service_templates(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "ListServiceTemplates",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_services()
    list_services(params::Dict{String,<:Any})

List services with summaries of detail data.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of services to list.
- `"nextToken"`: A token that indicates the location of the next service in the array of
  services, after the list of services that was previously requested.
"""
function list_services(; aws_config::AbstractAWSConfig=current_aws_config())
    return proton("ListServices"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_services(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "ListServices", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

List tags for a resource. For more information, see Proton resources and tagging in the
Proton User Guide.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource for the listed tags.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of tags to list.
- `"nextToken"`: A token that indicates the location of the next resource tag in the array
  of resource tags, after the list of resource tags that was previously requested.
"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "ListTagsForResource",
        Dict{String,Any}("resourceArn" => resourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceArn" => resourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    notify_resource_deployment_status_change(resource_arn)
    notify_resource_deployment_status_change(resource_arn, params::Dict{String,<:Any})

Notify Proton of status changes to a provisioned resource when you use self-managed
provisioning. For more information, see Self-managed provisioning in the Proton User Guide.

# Arguments
- `resource_arn`: The provisioned resource Amazon Resource Name (ARN).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"deploymentId"`: The deployment ID for your provisioned resource.
- `"outputs"`: The provisioned resource state change detail data that's returned by Proton.
- `"status"`: The status of your provisioned resource.
- `"statusMessage"`: The deployment status message for your provisioned resource.
"""
function notify_resource_deployment_status_change(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "NotifyResourceDeploymentStatusChange",
        Dict{String,Any}("resourceArn" => resourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function notify_resource_deployment_status_change(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "NotifyResourceDeploymentStatusChange",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceArn" => resourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    reject_environment_account_connection(id)
    reject_environment_account_connection(id, params::Dict{String,<:Any})

In a management account, reject an environment account connection from another environment
account. After you reject an environment account connection request, you can't accept or
use the rejected environment account connection. You can’t reject an environment account
connection that's connected to an environment. For more information, see Environment
account connections in the Proton User guide.

# Arguments
- `id`: The ID of the environment account connection to reject.

"""
function reject_environment_account_connection(
    id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "RejectEnvironmentAccountConnection",
        Dict{String,Any}("id" => id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function reject_environment_account_connection(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "RejectEnvironmentAccountConnection",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("id" => id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Tag a resource. A tag is a key-value pair of metadata that you associate with an Proton
resource. For more information, see Proton resources and tagging in the Proton User Guide.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the Proton resource to apply customer
  tags to.
- `tags`: A list of customer tags to apply to the Proton resource.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return proton(
        "TagResource",
        Dict{String,Any}("resourceArn" => resourceArn, "tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceArn" => resourceArn, "tags" => tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Remove a customer tag from a resource. A tag is a key-value pair of metadata associated
with an Proton resource. For more information, see Proton resources and tagging in the
Proton User Guide.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource to remove customer tags
  from.
- `tag_keys`: A list of customer tag keys that indicate the customer tags to be removed
  from the resource.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "UntagResource",
        Dict{String,Any}("resourceArn" => resourceArn, "tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceArn" => resourceArn, "tagKeys" => tagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_account_settings()
    update_account_settings(params::Dict{String,<:Any})

Update Proton settings that are used for multiple services in the Amazon Web Services
account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"deletePipelineProvisioningRepository"`: Set to true to remove a configured pipeline
  repository from the account settings. Don't set this field if you are updating the
  configured pipeline repository.
- `"pipelineCodebuildRoleArn"`: The Amazon Resource Name (ARN) of the service role you want
  to use for provisioning pipelines. Proton assumes this role for CodeBuild-based
  provisioning.
- `"pipelineProvisioningRepository"`: A linked repository for pipeline provisioning.
  Specify it if you have environments configured for self-managed provisioning with services
  that include pipelines. A linked repository is a repository that has been registered with
  Proton. For more information, see CreateRepository. To remove a previously configured
  repository, set deletePipelineProvisioningRepository to true, and don't set
  pipelineProvisioningRepository.
- `"pipelineServiceRoleArn"`: The Amazon Resource Name (ARN) of the service role you want
  to use for provisioning pipelines. Assumed by Proton for Amazon Web Services-managed
  provisioning, and by customer-owned automation for self-managed provisioning. To remove a
  previously configured ARN, specify an empty string.
"""
function update_account_settings(; aws_config::AbstractAWSConfig=current_aws_config())
    return proton(
        "UpdateAccountSettings"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function update_account_settings(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "UpdateAccountSettings",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_component(deployment_type, name)
    update_component(deployment_type, name, params::Dict{String,<:Any})

Update a component. There are a few modes for updating a component. The deploymentType
field defines the mode.  You can't update a component while its deployment status, or the
deployment status of a service instance attached to it, is IN_PROGRESS.  For more
information about components, see Proton components in the Proton User Guide.

# Arguments
- `deployment_type`: The deployment type. It defines the mode for updating a component, as
  follows:     NONE  In this mode, a deployment doesn't occur. Only the requested metadata
  parameters are updated. You can only specify description in this mode.     CURRENT_VERSION
  In this mode, the component is deployed and updated with the new serviceSpec,
  templateSource, and/or type that you provide. Only requested parameters are updated.
- `name`: The name of the component to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: The client token for the updated component.
- `"description"`: An optional customer-provided description of the component.
- `"serviceInstanceName"`: The name of the service instance that you want to attach this
  component to. Don't specify to keep the component's current service instance attachment.
  Specify an empty string to detach the component from the service instance it's attached to.
  Specify non-empty values for both serviceInstanceName and serviceName or for neither of
  them.
- `"serviceName"`: The name of the service that serviceInstanceName is associated with.
  Don't specify to keep the component's current service instance attachment. Specify an empty
  string to detach the component from the service instance it's attached to. Specify
  non-empty values for both serviceInstanceName and serviceName or for neither of them.
- `"serviceSpec"`: The service spec that you want the component to use to access service
  inputs. Set this only when the component is attached to a service instance.
- `"templateFile"`: A path to the Infrastructure as Code (IaC) file describing
  infrastructure that a custom component provisions.  Components support a single IaC file,
  even if you use Terraform as your template language.
"""
function update_component(
    deploymentType, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "UpdateComponent",
        Dict{String,Any}(
            "deploymentType" => deploymentType,
            "name" => name,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_component(
    deploymentType,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "UpdateComponent",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "deploymentType" => deploymentType,
                    "name" => name,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_environment(deployment_type, name)
    update_environment(deployment_type, name, params::Dict{String,<:Any})

Update an environment. If the environment is associated with an environment account
connection, don't update or include the protonServiceRoleArn and provisioningRepository
parameter to update or connect to an environment account connection. You can only update to
a new environment account connection if that connection was created in the same environment
account that the current environment account connection was created in. The account
connection must also be associated with the current environment. If the environment isn't
associated with an environment account connection, don't update or include the
environmentAccountConnectionId parameter. You can't update or connect the environment to an
environment account connection if it isn't already associated with an environment
connection. You can update either the environmentAccountConnectionId or
protonServiceRoleArn parameter and value. You can’t update both. If the environment was
configured for Amazon Web Services-managed provisioning, omit the provisioningRepository
parameter. If the environment was configured for self-managed provisioning, specify the
provisioningRepository parameter and omit the protonServiceRoleArn and
environmentAccountConnectionId parameters. For more information, see Environments and
Provisioning methods in the Proton User Guide. There are four modes for updating an
environment. The deploymentType field defines the mode.     NONE  In this mode, a
deployment doesn't occur. Only the requested metadata parameters are updated.
CURRENT_VERSION  In this mode, the environment is deployed and updated with the new spec
that you provide. Only requested parameters are updated. Don’t include minor or major
version parameters when you use this deployment-type.     MINOR_VERSION  In this mode, the
environment is deployed and updated with the published, recommended (latest) minor version
of the current major version in use, by default. You can also specify a different minor
version of the current major version in use.     MAJOR_VERSION  In this mode, the
environment is deployed and updated with the published, recommended (latest) major and
minor version of the current template, by default. You can also specify a different major
version that's higher than the major version in use and a minor version.

# Arguments
- `deployment_type`: There are four modes for updating an environment. The deploymentType
  field defines the mode.     NONE  In this mode, a deployment doesn't occur. Only the
  requested metadata parameters are updated.     CURRENT_VERSION  In this mode, the
  environment is deployed and updated with the new spec that you provide. Only requested
  parameters are updated. Don’t include major or minor version parameters when you use this
  deployment-type.     MINOR_VERSION  In this mode, the environment is deployed and updated
  with the published, recommended (latest) minor version of the current major version in use,
  by default. You can also specify a different minor version of the current major version in
  use.     MAJOR_VERSION  In this mode, the environment is deployed and updated with the
  published, recommended (latest) major and minor version of the current template, by
  default. You can also specify a different major version that is higher than the major
  version in use and a minor version (optional).
- `name`: The name of the environment to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"codebuildRoleArn"`: The Amazon Resource Name (ARN) of the IAM service role that allows
  Proton to provision infrastructure using CodeBuild-based provisioning on your behalf.
- `"componentRoleArn"`: The Amazon Resource Name (ARN) of the IAM service role that Proton
  uses when provisioning directly defined components in this environment. It determines the
  scope of infrastructure that a component can provision. The environment must have a
  componentRoleArn to allow directly defined components to be associated with the
  environment. For more information about components, see Proton components in the Proton
  User Guide.
- `"description"`: A description of the environment update.
- `"environmentAccountConnectionId"`: The ID of the environment account connection. You can
  only update to a new environment account connection if it was created in the same
  environment account that the current environment account connection was created in and is
  associated with the current environment.
- `"protonServiceRoleArn"`: The Amazon Resource Name (ARN) of the Proton service role that
  allows Proton to make API calls to other services your behalf.
- `"provisioningRepository"`: The linked repository that you use to host your rendered
  infrastructure templates for self-managed provisioning. A linked repository is a repository
  that has been registered with Proton. For more information, see CreateRepository.
- `"spec"`: The formatted specification that defines the update.
- `"templateMajorVersion"`: The major version of the environment to update.
- `"templateMinorVersion"`: The minor version of the environment to update.
"""
function update_environment(
    deploymentType, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "UpdateEnvironment",
        Dict{String,Any}("deploymentType" => deploymentType, "name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_environment(
    deploymentType,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "UpdateEnvironment",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("deploymentType" => deploymentType, "name" => name),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_environment_account_connection(id)
    update_environment_account_connection(id, params::Dict{String,<:Any})

In an environment account, update an environment account connection to use a new IAM role.
For more information, see Environment account connections in the Proton User guide.

# Arguments
- `id`: The ID of the environment account connection to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"codebuildRoleArn"`: The Amazon Resource Name (ARN) of an IAM service role in the
  environment account. Proton uses this role to provision infrastructure resources using
  CodeBuild-based provisioning in the associated environment account.
- `"componentRoleArn"`: The Amazon Resource Name (ARN) of the IAM service role that Proton
  uses when provisioning directly defined components in the associated environment account.
  It determines the scope of infrastructure that a component can provision in the account.
  The environment account connection must have a componentRoleArn to allow directly defined
  components to be associated with any environments running in the account. For more
  information about components, see Proton components in the Proton User Guide.
- `"roleArn"`: The Amazon Resource Name (ARN) of the IAM service role that's associated
  with the environment account connection to update.
"""
function update_environment_account_connection(
    id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "UpdateEnvironmentAccountConnection",
        Dict{String,Any}("id" => id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_environment_account_connection(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "UpdateEnvironmentAccountConnection",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("id" => id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_environment_template(name)
    update_environment_template(name, params::Dict{String,<:Any})

Update an environment template.

# Arguments
- `name`: The name of the environment template to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A description of the environment template update.
- `"displayName"`: The name of the environment template to update as displayed in the
  developer interface.
"""
function update_environment_template(
    name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "UpdateEnvironmentTemplate",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_environment_template(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "UpdateEnvironmentTemplate",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_environment_template_version(major_version, minor_version, template_name)
    update_environment_template_version(major_version, minor_version, template_name, params::Dict{String,<:Any})

Update a major or minor version of an environment template.

# Arguments
- `major_version`: To update a major version of an environment template, include major
  Version.
- `minor_version`: To update a minor version of an environment template, include
  minorVersion.
- `template_name`: The name of the environment template.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A description of environment template version to update.
- `"status"`: The status of the environment template minor version to update.
"""
function update_environment_template_version(
    majorVersion,
    minorVersion,
    templateName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "UpdateEnvironmentTemplateVersion",
        Dict{String,Any}(
            "majorVersion" => majorVersion,
            "minorVersion" => minorVersion,
            "templateName" => templateName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_environment_template_version(
    majorVersion,
    minorVersion,
    templateName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "UpdateEnvironmentTemplateVersion",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "majorVersion" => majorVersion,
                    "minorVersion" => minorVersion,
                    "templateName" => templateName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_service(name)
    update_service(name, params::Dict{String,<:Any})

Edit a service description or use a spec to add and delete service instances.  Existing
service instances and the service pipeline can't be edited using this API. They can only be
deleted.  Use the description parameter to modify the description. Edit the spec parameter
to add or delete instances.  You can't delete a service instance (remove it from the spec)
if it has an attached component. For more information about components, see Proton
components in the Proton User Guide.

# Arguments
- `name`: The name of the service to edit.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The edited service description.
- `"spec"`: Lists the service instances to add and the existing service instances to
  remain. Omit the existing service instances to delete from the list. Don't include edits to
  the existing service instances or pipeline. For more information, see Edit a service in the
  Proton User Guide.
"""
function update_service(name; aws_config::AbstractAWSConfig=current_aws_config())
    return proton(
        "UpdateService",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_service(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "UpdateService",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_service_instance(deployment_type, name, service_name)
    update_service_instance(deployment_type, name, service_name, params::Dict{String,<:Any})

Update a service instance. There are a few modes for updating a service instance. The
deploymentType field defines the mode.  You can't update a service instance while its
deployment status, or the deployment status of a component attached to it, is IN_PROGRESS.
For more information about components, see Proton components in the Proton User Guide.

# Arguments
- `deployment_type`: The deployment type. It defines the mode for updating a service
  instance, as follows:     NONE  In this mode, a deployment doesn't occur. Only the
  requested metadata parameters are updated.     CURRENT_VERSION  In this mode, the service
  instance is deployed and updated with the new spec that you provide. Only requested
  parameters are updated. Don’t include major or minor version parameters when you use this
  deployment type.     MINOR_VERSION  In this mode, the service instance is deployed and
  updated with the published, recommended (latest) minor version of the current major version
  in use, by default. You can also specify a different minor version of the current major
  version in use.     MAJOR_VERSION  In this mode, the service instance is deployed and
  updated with the published, recommended (latest) major and minor version of the current
  template, by default. You can specify a different major version that's higher than the
  major version in use and a minor version.
- `name`: The name of the service instance to update.
- `service_name`: The name of the service that the service instance belongs to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: The client token of the service instance to update.
- `"spec"`: The formatted specification that defines the service instance update.
- `"templateMajorVersion"`: The major version of the service template to update.
- `"templateMinorVersion"`: The minor version of the service template to update.
"""
function update_service_instance(
    deploymentType, name, serviceName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "UpdateServiceInstance",
        Dict{String,Any}(
            "deploymentType" => deploymentType,
            "name" => name,
            "serviceName" => serviceName,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_service_instance(
    deploymentType,
    name,
    serviceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "UpdateServiceInstance",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "deploymentType" => deploymentType,
                    "name" => name,
                    "serviceName" => serviceName,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_service_pipeline(deployment_type, service_name, spec)
    update_service_pipeline(deployment_type, service_name, spec, params::Dict{String,<:Any})

Update the service pipeline. There are four modes for updating a service pipeline. The
deploymentType field defines the mode.     NONE  In this mode, a deployment doesn't occur.
Only the requested metadata parameters are updated.     CURRENT_VERSION  In this mode, the
service pipeline is deployed and updated with the new spec that you provide. Only requested
parameters are updated. Don’t include major or minor version parameters when you use this
deployment-type.     MINOR_VERSION  In this mode, the service pipeline is deployed and
updated with the published, recommended (latest) minor version of the current major version
in use, by default. You can specify a different minor version of the current major version
in use.     MAJOR_VERSION  In this mode, the service pipeline is deployed and updated with
the published, recommended (latest) major and minor version of the current template by
default. You can specify a different major version that's higher than the major version in
use and a minor version.

# Arguments
- `deployment_type`: The deployment type. There are four modes for updating a service
  pipeline. The deploymentType field defines the mode.     NONE  In this mode, a deployment
  doesn't occur. Only the requested metadata parameters are updated.     CURRENT_VERSION  In
  this mode, the service pipeline is deployed and updated with the new spec that you provide.
  Only requested parameters are updated. Don’t include major or minor version parameters
  when you use this deployment-type.     MINOR_VERSION  In this mode, the service pipeline is
  deployed and updated with the published, recommended (latest) minor version of the current
  major version in use, by default. You can specify a different minor version of the current
  major version in use.     MAJOR_VERSION  In this mode, the service pipeline is deployed and
  updated with the published, recommended (latest) major and minor version of the current
  template, by default. You can specify a different major version that's higher than the
  major version in use and a minor version.
- `service_name`: The name of the service to that the pipeline is associated with.
- `spec`: The spec for the service pipeline to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"templateMajorVersion"`: The major version of the service template that was used to
  create the service that the pipeline is associated with.
- `"templateMinorVersion"`: The minor version of the service template that was used to
  create the service that the pipeline is associated with.
"""
function update_service_pipeline(
    deploymentType, serviceName, spec; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "UpdateServicePipeline",
        Dict{String,Any}(
            "deploymentType" => deploymentType, "serviceName" => serviceName, "spec" => spec
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_service_pipeline(
    deploymentType,
    serviceName,
    spec,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "UpdateServicePipeline",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "deploymentType" => deploymentType,
                    "serviceName" => serviceName,
                    "spec" => spec,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_service_sync_blocker(id, resolved_reason)
    update_service_sync_blocker(id, resolved_reason, params::Dict{String,<:Any})

Update the service sync blocker by resolving it.

# Arguments
- `id`: The ID of the service sync blocker.
- `resolved_reason`: The reason the service sync blocker was resolved.

"""
function update_service_sync_blocker(
    id, resolvedReason; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "UpdateServiceSyncBlocker",
        Dict{String,Any}("id" => id, "resolvedReason" => resolvedReason);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_service_sync_blocker(
    id,
    resolvedReason,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "UpdateServiceSyncBlocker",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("id" => id, "resolvedReason" => resolvedReason),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_service_sync_config(branch, file_path, repository_name, repository_provider, service_name)
    update_service_sync_config(branch, file_path, repository_name, repository_provider, service_name, params::Dict{String,<:Any})

Update the Proton Ops config file.

# Arguments
- `branch`: The name of the code repository branch where the Proton Ops file is found.
- `file_path`: The path to the Proton Ops file.
- `repository_name`: The name of the repository where the Proton Ops file is found.
- `repository_provider`: The name of the repository provider where the Proton Ops file is
  found.
- `service_name`: The name of the service the Proton Ops file is for.

"""
function update_service_sync_config(
    branch,
    filePath,
    repositoryName,
    repositoryProvider,
    serviceName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "UpdateServiceSyncConfig",
        Dict{String,Any}(
            "branch" => branch,
            "filePath" => filePath,
            "repositoryName" => repositoryName,
            "repositoryProvider" => repositoryProvider,
            "serviceName" => serviceName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_service_sync_config(
    branch,
    filePath,
    repositoryName,
    repositoryProvider,
    serviceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "UpdateServiceSyncConfig",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "branch" => branch,
                    "filePath" => filePath,
                    "repositoryName" => repositoryName,
                    "repositoryProvider" => repositoryProvider,
                    "serviceName" => serviceName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_service_template(name)
    update_service_template(name, params::Dict{String,<:Any})

Update a service template.

# Arguments
- `name`: The name of the service template to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A description of the service template update.
- `"displayName"`: The name of the service template to update that's displayed in the
  developer interface.
"""
function update_service_template(name; aws_config::AbstractAWSConfig=current_aws_config())
    return proton(
        "UpdateServiceTemplate",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_service_template(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return proton(
        "UpdateServiceTemplate",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_service_template_version(major_version, minor_version, template_name)
    update_service_template_version(major_version, minor_version, template_name, params::Dict{String,<:Any})

Update a major or minor version of a service template.

# Arguments
- `major_version`: To update a major version of a service template, include major Version.
- `minor_version`: To update a minor version of a service template, include minorVersion.
- `template_name`: The name of the service template.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"compatibleEnvironmentTemplates"`: An array of environment template objects that are
  compatible with this service template version. A service instance based on this service
  template version can run in environments based on compatible templates.
- `"description"`: A description of a service template version to update.
- `"status"`: The status of the service template minor version to update.
- `"supportedComponentSources"`: An array of supported component sources. Components with
  supported sources can be attached to service instances based on this service template
  version.  A change to supportedComponentSources doesn't impact existing component
  attachments to instances based on this template version. A change only affects later
  associations.  For more information about components, see Proton components in the Proton
  User Guide.
"""
function update_service_template_version(
    majorVersion,
    minorVersion,
    templateName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "UpdateServiceTemplateVersion",
        Dict{String,Any}(
            "majorVersion" => majorVersion,
            "minorVersion" => minorVersion,
            "templateName" => templateName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_service_template_version(
    majorVersion,
    minorVersion,
    templateName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "UpdateServiceTemplateVersion",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "majorVersion" => majorVersion,
                    "minorVersion" => minorVersion,
                    "templateName" => templateName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_template_sync_config(branch, repository_name, repository_provider, template_name, template_type)
    update_template_sync_config(branch, repository_name, repository_provider, template_name, template_type, params::Dict{String,<:Any})

Update template sync configuration parameters, except for the templateName and
templateType. Repository details (branch, name, and provider) should be of a linked
repository. A linked repository is a repository that has been registered with Proton. For
more information, see CreateRepository.

# Arguments
- `branch`: The repository branch for your template.
- `repository_name`: The repository name (for example, myrepos/myrepo).
- `repository_provider`: The repository provider.
- `template_name`: The synced template name.
- `template_type`: The synced template type.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"subdirectory"`: A subdirectory path to your template bundle version. When included,
  limits the template bundle search to this repository directory.
"""
function update_template_sync_config(
    branch,
    repositoryName,
    repositoryProvider,
    templateName,
    templateType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "UpdateTemplateSyncConfig",
        Dict{String,Any}(
            "branch" => branch,
            "repositoryName" => repositoryName,
            "repositoryProvider" => repositoryProvider,
            "templateName" => templateName,
            "templateType" => templateType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_template_sync_config(
    branch,
    repositoryName,
    repositoryProvider,
    templateName,
    templateType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return proton(
        "UpdateTemplateSyncConfig",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "branch" => branch,
                    "repositoryName" => repositoryName,
                    "repositoryProvider" => repositoryProvider,
                    "templateName" => templateName,
                    "templateType" => templateType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: sagemaker_a2i_runtime
using AWS.Compat
using AWS.UUIDs

"""
    delete_human_loop(human_loop_name)
    delete_human_loop(human_loop_name, params::Dict{String,<:Any})

Deletes the specified human loop for a flow definition. If the human loop was deleted, this
operation will return a ResourceNotFoundException.

# Arguments
- `human_loop_name`: The name of the human loop that you want to delete.

"""
function delete_human_loop(
    HumanLoopName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sagemaker_a2i_runtime(
        "DELETE",
        "/human-loops/$(HumanLoopName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_human_loop(
    HumanLoopName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sagemaker_a2i_runtime(
        "DELETE",
        "/human-loops/$(HumanLoopName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_human_loop(human_loop_name)
    describe_human_loop(human_loop_name, params::Dict{String,<:Any})

Returns information about the specified human loop. If the human loop was deleted, this
operation will return a ResourceNotFoundException error.

# Arguments
- `human_loop_name`: The name of the human loop that you want information about.

"""
function describe_human_loop(
    HumanLoopName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sagemaker_a2i_runtime(
        "GET",
        "/human-loops/$(HumanLoopName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_human_loop(
    HumanLoopName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sagemaker_a2i_runtime(
        "GET",
        "/human-loops/$(HumanLoopName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_human_loops(flow_definition_arn)
    list_human_loops(flow_definition_arn, params::Dict{String,<:Any})

Returns information about human loops, given the specified parameters. If a human loop was
deleted, it will not be included.

# Arguments
- `flow_definition_arn`: The Amazon Resource Name (ARN) of a flow definition.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CreationTimeAfter"`: (Optional) The timestamp of the date when you want the human loops
  to begin in ISO 8601 format. For example, 2020-02-24.
- `"CreationTimeBefore"`: (Optional) The timestamp of the date before which you want the
  human loops to begin in ISO 8601 format. For example, 2020-02-24.
- `"MaxResults"`: The total number of items to return. If the total number of available
  items is more than the value specified in MaxResults, then a NextToken is returned in the
  output. You can use this token to display the next page of results.
- `"NextToken"`: A token to display the next page of results.
- `"SortOrder"`: Optional. The order for displaying results. Valid values: Ascending and
  Descending.
"""
function list_human_loops(
    FlowDefinitionArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sagemaker_a2i_runtime(
        "GET",
        "/human-loops",
        Dict{String,Any}("FlowDefinitionArn" => FlowDefinitionArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_human_loops(
    FlowDefinitionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sagemaker_a2i_runtime(
        "GET",
        "/human-loops",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("FlowDefinitionArn" => FlowDefinitionArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_human_loop(flow_definition_arn, human_loop_input, human_loop_name)
    start_human_loop(flow_definition_arn, human_loop_input, human_loop_name, params::Dict{String,<:Any})

Starts a human loop, provided that at least one activation condition is met.

# Arguments
- `flow_definition_arn`: The Amazon Resource Name (ARN) of the flow definition associated
  with this human loop.
- `human_loop_input`: An object that contains information about the human loop.
- `human_loop_name`: The name of the human loop.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DataAttributes"`: Attributes of the specified data. Use DataAttributes to specify if
  your data is free of personally identifiable information and/or free of adult content.
"""
function start_human_loop(
    FlowDefinitionArn,
    HumanLoopInput,
    HumanLoopName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sagemaker_a2i_runtime(
        "POST",
        "/human-loops",
        Dict{String,Any}(
            "FlowDefinitionArn" => FlowDefinitionArn,
            "HumanLoopInput" => HumanLoopInput,
            "HumanLoopName" => HumanLoopName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_human_loop(
    FlowDefinitionArn,
    HumanLoopInput,
    HumanLoopName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sagemaker_a2i_runtime(
        "POST",
        "/human-loops",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "FlowDefinitionArn" => FlowDefinitionArn,
                    "HumanLoopInput" => HumanLoopInput,
                    "HumanLoopName" => HumanLoopName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_human_loop(human_loop_name)
    stop_human_loop(human_loop_name, params::Dict{String,<:Any})

Stops the specified human loop.

# Arguments
- `human_loop_name`: The name of the human loop that you want to stop.

"""
function stop_human_loop(HumanLoopName; aws_config::AbstractAWSConfig=current_aws_config())
    return sagemaker_a2i_runtime(
        "POST",
        "/human-loops/stop",
        Dict{String,Any}("HumanLoopName" => HumanLoopName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_human_loop(
    HumanLoopName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sagemaker_a2i_runtime(
        "POST",
        "/human-loops/stop",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("HumanLoopName" => HumanLoopName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: cost_optimization_hub
using AWS.Compat
using AWS.UUIDs

"""
    get_preferences()
    get_preferences(params::Dict{String,<:Any})

Returns a set of preferences for an account in order to add account-specific preferences
into the service. These preferences impact how the savings associated with recommendations
are presented—estimated savings after discounts or estimated savings before discounts,
for example.

"""
function get_preferences(; aws_config::AbstractAWSConfig=current_aws_config())
    return cost_optimization_hub(
        "GetPreferences"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_preferences(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cost_optimization_hub(
        "GetPreferences", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_recommendation(recommendation_id)
    get_recommendation(recommendation_id, params::Dict{String,<:Any})

Returns both the current and recommended resource configuration and the estimated cost
impact for a recommendation. The recommendationId is only valid for up to a maximum of 24
hours as recommendations are refreshed daily. To retrieve the recommendationId, use the
ListRecommendations API.

# Arguments
- `recommendation_id`: The ID for the recommendation.

"""
function get_recommendation(
    recommendationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cost_optimization_hub(
        "GetRecommendation",
        Dict{String,Any}("recommendationId" => recommendationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_recommendation(
    recommendationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cost_optimization_hub(
        "GetRecommendation",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("recommendationId" => recommendationId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_enrollment_statuses()
    list_enrollment_statuses(params::Dict{String,<:Any})

Retrieves the enrollment status for an account. It can also return the list of accounts
that are enrolled under the organization.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountId"`: The account ID of a member account in the organization.
- `"includeOrganizationInfo"`: Indicates whether to return the enrollment status for the
  organization.
- `"maxResults"`: The maximum number of objects that are returned for the request.
- `"nextToken"`: The token to retrieve the next set of results.
"""
function list_enrollment_statuses(; aws_config::AbstractAWSConfig=current_aws_config())
    return cost_optimization_hub(
        "ListEnrollmentStatuses"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_enrollment_statuses(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cost_optimization_hub(
        "ListEnrollmentStatuses",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_recommendation_summaries(group_by)
    list_recommendation_summaries(group_by, params::Dict{String,<:Any})

Returns a concise representation of savings estimates for resources. Also returns de-duped
savings across different types of recommendations.  The following filters are not supported
for this API: recommendationIds, resourceArns, and resourceIds.

# Arguments
- `group_by`: The grouping of recommendations by a dimension.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filter"`:
- `"maxResults"`: The maximum number of recommendations that are returned for the request.
- `"nextToken"`: The token to retrieve the next set of results.
"""
function list_recommendation_summaries(
    groupBy; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cost_optimization_hub(
        "ListRecommendationSummaries",
        Dict{String,Any}("groupBy" => groupBy);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_recommendation_summaries(
    groupBy,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cost_optimization_hub(
        "ListRecommendationSummaries",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("groupBy" => groupBy), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_recommendations()
    list_recommendations(params::Dict{String,<:Any})

Returns a list of recommendations.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filter"`: The constraints that you want all returned recommendations to match.
- `"includeAllRecommendations"`: List of all recommendations for a resource, or a single
  recommendation if de-duped by resourceId.
- `"maxResults"`: The maximum number of recommendations that are returned for the request.
- `"nextToken"`: The token to retrieve the next set of results.
- `"orderBy"`: The ordering of recommendations by a dimension.
"""
function list_recommendations(; aws_config::AbstractAWSConfig=current_aws_config())
    return cost_optimization_hub(
        "ListRecommendations"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_recommendations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cost_optimization_hub(
        "ListRecommendations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_enrollment_status(status)
    update_enrollment_status(status, params::Dict{String,<:Any})

Updates the enrollment (opt in and opt out) status of an account to the Cost Optimization
Hub service. If the account is a management account of an organization, this action can
also be used to enroll member accounts of the organization. You must have the appropriate
permissions to opt in to Cost Optimization Hub and to view its recommendations. When you
opt in, Cost Optimization Hub automatically creates a service-linked role in your account
to access its data.

# Arguments
- `status`: Sets the account status.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"includeMemberAccounts"`: Indicates whether to enroll member accounts of the
  organization if the account is the management account.
"""
function update_enrollment_status(
    status; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cost_optimization_hub(
        "UpdateEnrollmentStatus",
        Dict{String,Any}("status" => status);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_enrollment_status(
    status, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cost_optimization_hub(
        "UpdateEnrollmentStatus",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("status" => status), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_preferences()
    update_preferences(params::Dict{String,<:Any})

Updates a set of preferences for an account in order to add account-specific preferences
into the service. These preferences impact how the savings associated with recommendations
are presented.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"memberAccountDiscountVisibility"`: Sets the \"member account discount visibility\"
  preference.
- `"savingsEstimationMode"`: Sets the \"savings estimation mode\" preference.
"""
function update_preferences(; aws_config::AbstractAWSConfig=current_aws_config())
    return cost_optimization_hub(
        "UpdatePreferences"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function update_preferences(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cost_optimization_hub(
        "UpdatePreferences", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: neptune
using AWS.Compat
using AWS.UUIDs

"""
    add_role_to_dbcluster(dbcluster_identifier, role_arn)
    add_role_to_dbcluster(dbcluster_identifier, role_arn, params::Dict{String,<:Any})

Associates an Identity and Access Management (IAM) role with an Neptune DB cluster.

# Arguments
- `dbcluster_identifier`: The name of the DB cluster to associate the IAM role with.
- `role_arn`: The Amazon Resource Name (ARN) of the IAM role to associate with the Neptune
  DB cluster, for example arn:aws:iam::123456789012:role/NeptuneAccessRole.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FeatureName"`: The name of the feature for the Neptune DB cluster that the IAM role is
  to be associated with. For the list of supported feature names, see DBEngineVersion.
"""
function add_role_to_dbcluster(
    DBClusterIdentifier, RoleArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptune(
        "AddRoleToDBCluster",
        Dict{String,Any}(
            "DBClusterIdentifier" => DBClusterIdentifier, "RoleArn" => RoleArn
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_role_to_dbcluster(
    DBClusterIdentifier,
    RoleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "AddRoleToDBCluster",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DBClusterIdentifier" => DBClusterIdentifier, "RoleArn" => RoleArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    add_source_identifier_to_subscription(source_identifier, subscription_name)
    add_source_identifier_to_subscription(source_identifier, subscription_name, params::Dict{String,<:Any})

Adds a source identifier to an existing event notification subscription.

# Arguments
- `source_identifier`: The identifier of the event source to be added. Constraints:   If
  the source type is a DB instance, then a DBInstanceIdentifier must be supplied.   If the
  source type is a DB security group, a DBSecurityGroupName must be supplied.   If the source
  type is a DB parameter group, a DBParameterGroupName must be supplied.   If the source type
  is a DB snapshot, a DBSnapshotIdentifier must be supplied.
- `subscription_name`: The name of the event notification subscription you want to add a
  source identifier to.

"""
function add_source_identifier_to_subscription(
    SourceIdentifier, SubscriptionName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptune(
        "AddSourceIdentifierToSubscription",
        Dict{String,Any}(
            "SourceIdentifier" => SourceIdentifier, "SubscriptionName" => SubscriptionName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_source_identifier_to_subscription(
    SourceIdentifier,
    SubscriptionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "AddSourceIdentifierToSubscription",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "SourceIdentifier" => SourceIdentifier,
                    "SubscriptionName" => SubscriptionName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    add_tags_to_resource(resource_name, tag)
    add_tags_to_resource(resource_name, tag, params::Dict{String,<:Any})

Adds metadata tags to an Amazon Neptune resource. These tags can also be used with cost
allocation reporting to track cost associated with Amazon Neptune resources, or used in a
Condition statement in an IAM policy for Amazon Neptune.

# Arguments
- `resource_name`: The Amazon Neptune resource that the tags are added to. This value is an
  Amazon Resource Name (ARN). For information about creating an ARN, see  Constructing an
  Amazon Resource Name (ARN).
- `tag`: The tags to be assigned to the Amazon Neptune resource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: The tags to be assigned to the Amazon Neptune resource.
"""
function add_tags_to_resource(
    ResourceName, Tag; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptune(
        "AddTagsToResource",
        Dict{String,Any}("ResourceName" => ResourceName, "Tag" => Tag);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_tags_to_resource(
    ResourceName,
    Tag,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "AddTagsToResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceName" => ResourceName, "Tag" => Tag),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    apply_pending_maintenance_action(apply_action, opt_in_type, resource_identifier)
    apply_pending_maintenance_action(apply_action, opt_in_type, resource_identifier, params::Dict{String,<:Any})

Applies a pending maintenance action to a resource (for example, to a DB instance).

# Arguments
- `apply_action`: The pending maintenance action to apply to this resource. Valid values:
  system-update, db-upgrade
- `opt_in_type`: A value that specifies the type of opt-in request, or undoes an opt-in
  request. An opt-in request of type immediate can't be undone. Valid values:    immediate -
  Apply the maintenance action immediately.    next-maintenance - Apply the maintenance
  action during the next maintenance window for the resource.    undo-opt-in - Cancel any
  existing next-maintenance opt-in requests.
- `resource_identifier`: The Amazon Resource Name (ARN) of the resource that the pending
  maintenance action applies to. For information about creating an ARN, see  Constructing an
  Amazon Resource Name (ARN).

"""
function apply_pending_maintenance_action(
    ApplyAction,
    OptInType,
    ResourceIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "ApplyPendingMaintenanceAction",
        Dict{String,Any}(
            "ApplyAction" => ApplyAction,
            "OptInType" => OptInType,
            "ResourceIdentifier" => ResourceIdentifier,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function apply_pending_maintenance_action(
    ApplyAction,
    OptInType,
    ResourceIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "ApplyPendingMaintenanceAction",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplyAction" => ApplyAction,
                    "OptInType" => OptInType,
                    "ResourceIdentifier" => ResourceIdentifier,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    copy_dbcluster_parameter_group(source_dbcluster_parameter_group_identifier, target_dbcluster_parameter_group_description, target_dbcluster_parameter_group_identifier)
    copy_dbcluster_parameter_group(source_dbcluster_parameter_group_identifier, target_dbcluster_parameter_group_description, target_dbcluster_parameter_group_identifier, params::Dict{String,<:Any})

Copies the specified DB cluster parameter group.

# Arguments
- `source_dbcluster_parameter_group_identifier`: The identifier or Amazon Resource Name
  (ARN) for the source DB cluster parameter group. For information about creating an ARN, see
   Constructing an Amazon Resource Name (ARN). Constraints:   Must specify a valid DB cluster
  parameter group.   If the source DB cluster parameter group is in the same Amazon Region as
  the copy, specify a valid DB parameter group identifier, for example
  my-db-cluster-param-group, or a valid ARN.   If the source DB parameter group is in a
  different Amazon Region than the copy, specify a valid DB cluster parameter group ARN, for
  example arn:aws:rds:us-east-1:123456789012:cluster-pg:custom-cluster-group1.
- `target_dbcluster_parameter_group_description`: A description for the copied DB cluster
  parameter group.
- `target_dbcluster_parameter_group_identifier`: The identifier for the copied DB cluster
  parameter group. Constraints:   Cannot be null, empty, or blank   Must contain from 1 to
  255 letters, numbers, or hyphens   First character must be a letter   Cannot end with a
  hyphen or contain two consecutive hyphens   Example: my-cluster-param-group1

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: The tags to be assigned to the copied DB cluster parameter group.
"""
function copy_dbcluster_parameter_group(
    SourceDBClusterParameterGroupIdentifier,
    TargetDBClusterParameterGroupDescription,
    TargetDBClusterParameterGroupIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "CopyDBClusterParameterGroup",
        Dict{String,Any}(
            "SourceDBClusterParameterGroupIdentifier" =>
                SourceDBClusterParameterGroupIdentifier,
            "TargetDBClusterParameterGroupDescription" =>
                TargetDBClusterParameterGroupDescription,
            "TargetDBClusterParameterGroupIdentifier" =>
                TargetDBClusterParameterGroupIdentifier,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function copy_dbcluster_parameter_group(
    SourceDBClusterParameterGroupIdentifier,
    TargetDBClusterParameterGroupDescription,
    TargetDBClusterParameterGroupIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "CopyDBClusterParameterGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "SourceDBClusterParameterGroupIdentifier" =>
                        SourceDBClusterParameterGroupIdentifier,
                    "TargetDBClusterParameterGroupDescription" =>
                        TargetDBClusterParameterGroupDescription,
                    "TargetDBClusterParameterGroupIdentifier" =>
                        TargetDBClusterParameterGroupIdentifier,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    copy_dbcluster_snapshot(source_dbcluster_snapshot_identifier, target_dbcluster_snapshot_identifier)
    copy_dbcluster_snapshot(source_dbcluster_snapshot_identifier, target_dbcluster_snapshot_identifier, params::Dict{String,<:Any})

Copies a snapshot of a DB cluster. To copy a DB cluster snapshot from a shared manual DB
cluster snapshot, SourceDBClusterSnapshotIdentifier must be the Amazon Resource Name (ARN)
of the shared DB cluster snapshot.

# Arguments
- `source_dbcluster_snapshot_identifier`: The identifier of the DB cluster snapshot to
  copy. This parameter is not case-sensitive. Constraints:   Must specify a valid system
  snapshot in the \"available\" state.   Specify a valid DB snapshot identifier.   Example:
  my-cluster-snapshot1
- `target_dbcluster_snapshot_identifier`: The identifier of the new DB cluster snapshot to
  create from the source DB cluster snapshot. This parameter is not case-sensitive.
  Constraints:   Must contain from 1 to 63 letters, numbers, or hyphens.   First character
  must be a letter.   Cannot end with a hyphen or contain two consecutive hyphens.   Example:
  my-cluster-snapshot2

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CopyTags"`: True to copy all tags from the source DB cluster snapshot to the target DB
  cluster snapshot, and otherwise false. The default is false.
- `"KmsKeyId"`: The Amazon Amazon KMS key ID for an encrypted DB cluster snapshot. The KMS
  key ID is the Amazon Resource Name (ARN), KMS key identifier, or the KMS key alias for the
  KMS encryption key. If you copy an encrypted DB cluster snapshot from your Amazon account,
  you can specify a value for KmsKeyId to encrypt the copy with a new KMS encryption key. If
  you don't specify a value for KmsKeyId, then the copy of the DB cluster snapshot is
  encrypted with the same KMS key as the source DB cluster snapshot. If you copy an encrypted
  DB cluster snapshot that is shared from another Amazon account, then you must specify a
  value for KmsKeyId.  KMS encryption keys are specific to the Amazon Region that they are
  created in, and you can't use encryption keys from one Amazon Region in another Amazon
  Region. You cannot encrypt an unencrypted DB cluster snapshot when you copy it. If you try
  to copy an unencrypted DB cluster snapshot and specify a value for the KmsKeyId parameter,
  an error is returned.
- `"PreSignedUrl"`: Not currently supported.
- `"Tags"`: The tags to assign to the new DB cluster snapshot copy.
"""
function copy_dbcluster_snapshot(
    SourceDBClusterSnapshotIdentifier,
    TargetDBClusterSnapshotIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "CopyDBClusterSnapshot",
        Dict{String,Any}(
            "SourceDBClusterSnapshotIdentifier" => SourceDBClusterSnapshotIdentifier,
            "TargetDBClusterSnapshotIdentifier" => TargetDBClusterSnapshotIdentifier,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function copy_dbcluster_snapshot(
    SourceDBClusterSnapshotIdentifier,
    TargetDBClusterSnapshotIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "CopyDBClusterSnapshot",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "SourceDBClusterSnapshotIdentifier" =>
                        SourceDBClusterSnapshotIdentifier,
                    "TargetDBClusterSnapshotIdentifier" =>
                        TargetDBClusterSnapshotIdentifier,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    copy_dbparameter_group(source_dbparameter_group_identifier, target_dbparameter_group_description, target_dbparameter_group_identifier)
    copy_dbparameter_group(source_dbparameter_group_identifier, target_dbparameter_group_description, target_dbparameter_group_identifier, params::Dict{String,<:Any})

Copies the specified DB parameter group.

# Arguments
- `source_dbparameter_group_identifier`: The identifier or ARN for the source DB parameter
  group. For information about creating an ARN, see  Constructing an Amazon Resource Name
  (ARN). Constraints:   Must specify a valid DB parameter group.   Must specify a valid DB
  parameter group identifier, for example my-db-param-group, or a valid ARN.
- `target_dbparameter_group_description`: A description for the copied DB parameter group.
- `target_dbparameter_group_identifier`: The identifier for the copied DB parameter group.
  Constraints:   Cannot be null, empty, or blank.   Must contain from 1 to 255 letters,
  numbers, or hyphens.   First character must be a letter.   Cannot end with a hyphen or
  contain two consecutive hyphens.   Example: my-db-parameter-group

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: The tags to be assigned to the copied DB parameter group.
"""
function copy_dbparameter_group(
    SourceDBParameterGroupIdentifier,
    TargetDBParameterGroupDescription,
    TargetDBParameterGroupIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "CopyDBParameterGroup",
        Dict{String,Any}(
            "SourceDBParameterGroupIdentifier" => SourceDBParameterGroupIdentifier,
            "TargetDBParameterGroupDescription" => TargetDBParameterGroupDescription,
            "TargetDBParameterGroupIdentifier" => TargetDBParameterGroupIdentifier,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function copy_dbparameter_group(
    SourceDBParameterGroupIdentifier,
    TargetDBParameterGroupDescription,
    TargetDBParameterGroupIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "CopyDBParameterGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "SourceDBParameterGroupIdentifier" => SourceDBParameterGroupIdentifier,
                    "TargetDBParameterGroupDescription" =>
                        TargetDBParameterGroupDescription,
                    "TargetDBParameterGroupIdentifier" => TargetDBParameterGroupIdentifier,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_dbcluster(dbcluster_identifier, engine)
    create_dbcluster(dbcluster_identifier, engine, params::Dict{String,<:Any})

Creates a new Amazon Neptune DB cluster. You can use the ReplicationSourceIdentifier
parameter to create the DB cluster as a Read Replica of another DB cluster or Amazon
Neptune DB instance. Note that when you create a new cluster using CreateDBCluster
directly, deletion protection is disabled by default (when you create a new production
cluster in the console, deletion protection is enabled by default). You can only delete a
DB cluster if its DeletionProtection field is set to false.

# Arguments
- `dbcluster_identifier`: The DB cluster identifier. This parameter is stored as a
  lowercase string. Constraints:   Must contain from 1 to 63 letters, numbers, or hyphens.
  First character must be a letter.   Cannot end with a hyphen or contain two consecutive
  hyphens.   Example: my-cluster1
- `engine`: The name of the database engine to be used for this DB cluster. Valid Values:
  neptune

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AvailabilityZones"`: A list of EC2 Availability Zones that instances in the DB cluster
  can be created in.
- `"BackupRetentionPeriod"`: The number of days for which automated backups are retained.
  You must specify a minimum value of 1. Default: 1 Constraints:   Must be a value from 1 to
  35
- `"CharacterSetName"`:  (Not supported by Neptune)
- `"CopyTagsToSnapshot"`:  If set to true, tags are copied to any snapshot of the DB
  cluster that is created.
- `"DBClusterParameterGroupName"`:  The name of the DB cluster parameter group to associate
  with this DB cluster. If this argument is omitted, the default is used. Constraints:   If
  supplied, must match the name of an existing DBClusterParameterGroup.
- `"DBSubnetGroupName"`: A DB subnet group to associate with this DB cluster. Constraints:
  Must match the name of an existing DBSubnetGroup. Must not be default. Example:
  mySubnetgroup
- `"DatabaseName"`: The name for your database of up to 64 alpha-numeric characters. If you
  do not provide a name, Amazon Neptune will not create a database in the DB cluster you are
  creating.
- `"DeletionProtection"`: A value that indicates whether the DB cluster has deletion
  protection enabled. The database can't be deleted when deletion protection is enabled. By
  default, deletion protection is enabled.
- `"EnableCloudwatchLogsExports"`: A list of the log types that this DB cluster should
  export to CloudWatch Logs. Valid log types are: audit (to publish audit logs) and slowquery
  (to publish slow-query logs). See Publishing Neptune logs to Amazon CloudWatch logs.
- `"EnableIAMDatabaseAuthentication"`: If set to true, enables Amazon Identity and Access
  Management (IAM) authentication for the entire DB cluster (this cannot be set at an
  instance level). Default: false.
- `"EngineVersion"`: The version number of the database engine to use for the new DB
  cluster. Example: 1.0.2.1
- `"GlobalClusterIdentifier"`: The ID of the Neptune global database to which this new DB
  cluster should be added.
- `"KmsKeyId"`: The Amazon KMS key identifier for an encrypted DB cluster. The KMS key
  identifier is the Amazon Resource Name (ARN) for the KMS encryption key. If you are
  creating a DB cluster with the same Amazon account that owns the KMS encryption key used to
  encrypt the new DB cluster, then you can use the KMS key alias instead of the ARN for the
  KMS encryption key. If an encryption key is not specified in KmsKeyId:   If
  ReplicationSourceIdentifier identifies an encrypted source, then Amazon Neptune will use
  the encryption key used to encrypt the source. Otherwise, Amazon Neptune will use your
  default encryption key.   If the StorageEncrypted parameter is true and
  ReplicationSourceIdentifier is not specified, then Amazon Neptune will use your default
  encryption key.   Amazon KMS creates the default encryption key for your Amazon account.
  Your Amazon account has a different default encryption key for each Amazon Region. If you
  create a Read Replica of an encrypted DB cluster in another Amazon Region, you must set
  KmsKeyId to a KMS key ID that is valid in the destination Amazon Region. This key is used
  to encrypt the Read Replica in that Amazon Region.
- `"MasterUserPassword"`: Not supported by Neptune.
- `"MasterUsername"`: Not supported by Neptune.
- `"OptionGroupName"`:  (Not supported by Neptune)
- `"Port"`: The port number on which the instances in the DB cluster accept connections.
  Default: 8182
- `"PreSignedUrl"`: This parameter is not currently supported.
- `"PreferredBackupWindow"`: The daily time range during which automated backups are
  created if automated backups are enabled using the BackupRetentionPeriod parameter. The
  default is a 30-minute window selected at random from an 8-hour block of time for each
  Amazon Region. To see the time blocks available, see Neptune Maintenance Window in the
  Amazon Neptune User Guide.  Constraints:   Must be in the format hh24:mi-hh24:mi.   Must be
  in Universal Coordinated Time (UTC).   Must not conflict with the preferred maintenance
  window.   Must be at least 30 minutes.
- `"PreferredMaintenanceWindow"`: The weekly time range during which system maintenance can
  occur, in Universal Coordinated Time (UTC). Format: ddd:hh24:mi-ddd:hh24:mi  The default is
  a 30-minute window selected at random from an 8-hour block of time for each Amazon Region,
  occurring on a random day of the week. To see the time blocks available, see Neptune
  Maintenance Window in the Amazon Neptune User Guide.  Valid Days: Mon, Tue, Wed, Thu, Fri,
  Sat, Sun. Constraints: Minimum 30-minute window.
- `"ReplicationSourceIdentifier"`: The Amazon Resource Name (ARN) of the source DB instance
  or DB cluster if this DB cluster is created as a Read Replica.
- `"ServerlessV2ScalingConfiguration"`: Contains the scaling configuration of a Neptune
  Serverless DB cluster. For more information, see Using Amazon Neptune Serverless in the
  Amazon Neptune User Guide.
- `"StorageEncrypted"`: Specifies whether the DB cluster is encrypted.
- `"StorageType"`: The storage type to associate with the DB cluster. Valid Values:
  standard | iopt1    Default:    standard     When you create a Neptune cluster with the
  storage type set to iopt1, the storage type is returned in the response. The storage type
  isn't returned when you set it to standard.
- `"Tags"`: The tags to assign to the new DB cluster.
- `"VpcSecurityGroupIds"`: A list of EC2 VPC security groups to associate with this DB
  cluster.
"""
function create_dbcluster(
    DBClusterIdentifier, Engine; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptune(
        "CreateDBCluster",
        Dict{String,Any}("DBClusterIdentifier" => DBClusterIdentifier, "Engine" => Engine);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_dbcluster(
    DBClusterIdentifier,
    Engine,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "CreateDBCluster",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DBClusterIdentifier" => DBClusterIdentifier, "Engine" => Engine
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_dbcluster_endpoint(dbcluster_endpoint_identifier, dbcluster_identifier, endpoint_type)
    create_dbcluster_endpoint(dbcluster_endpoint_identifier, dbcluster_identifier, endpoint_type, params::Dict{String,<:Any})

Creates a new custom endpoint and associates it with an Amazon Neptune DB cluster.

# Arguments
- `dbcluster_endpoint_identifier`: The identifier to use for the new endpoint. This
  parameter is stored as a lowercase string.
- `dbcluster_identifier`: The DB cluster identifier of the DB cluster associated with the
  endpoint. This parameter is stored as a lowercase string.
- `endpoint_type`: The type of the endpoint. One of: READER, WRITER, ANY.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ExcludedMembers"`: List of DB instance identifiers that aren't part of the custom
  endpoint group. All other eligible instances are reachable through the custom endpoint.
  Only relevant if the list of static members is empty.
- `"StaticMembers"`: List of DB instance identifiers that are part of the custom endpoint
  group.
- `"Tags"`: The tags to be assigned to the Amazon Neptune resource.
"""
function create_dbcluster_endpoint(
    DBClusterEndpointIdentifier,
    DBClusterIdentifier,
    EndpointType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "CreateDBClusterEndpoint",
        Dict{String,Any}(
            "DBClusterEndpointIdentifier" => DBClusterEndpointIdentifier,
            "DBClusterIdentifier" => DBClusterIdentifier,
            "EndpointType" => EndpointType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_dbcluster_endpoint(
    DBClusterEndpointIdentifier,
    DBClusterIdentifier,
    EndpointType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "CreateDBClusterEndpoint",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DBClusterEndpointIdentifier" => DBClusterEndpointIdentifier,
                    "DBClusterIdentifier" => DBClusterIdentifier,
                    "EndpointType" => EndpointType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_dbcluster_parameter_group(dbcluster_parameter_group_name, dbparameter_group_family, description)
    create_dbcluster_parameter_group(dbcluster_parameter_group_name, dbparameter_group_family, description, params::Dict{String,<:Any})

Creates a new DB cluster parameter group. Parameters in a DB cluster parameter group apply
to all of the instances in a DB cluster.  A DB cluster parameter group is initially created
with the default parameters for the database engine used by instances in the DB cluster. To
provide custom values for any of the parameters, you must modify the group after creating
it using ModifyDBClusterParameterGroup. Once you've created a DB cluster parameter group,
you need to associate it with your DB cluster using ModifyDBCluster. When you associate a
new DB cluster parameter group with a running DB cluster, you need to reboot the DB
instances in the DB cluster without failover for the new DB cluster parameter group and
associated settings to take effect.  After you create a DB cluster parameter group, you
should wait at least 5 minutes before creating your first DB cluster that uses that DB
cluster parameter group as the default parameter group. This allows Amazon Neptune to fully
complete the create action before the DB cluster parameter group is used as the default for
a new DB cluster. This is especially important for parameters that are critical when
creating the default database for a DB cluster, such as the character set for the default
database defined by the character_set_database parameter. You can use the Parameter Groups
option of the Amazon Neptune console or the DescribeDBClusterParameters command to verify
that your DB cluster parameter group has been created or modified.

# Arguments
- `dbcluster_parameter_group_name`: The name of the DB cluster parameter group.
  Constraints:   Must match the name of an existing DBClusterParameterGroup.    This value is
  stored as a lowercase string.
- `dbparameter_group_family`: The DB cluster parameter group family name. A DB cluster
  parameter group can be associated with one and only one DB cluster parameter group family,
  and can be applied only to a DB cluster running a database engine and engine version
  compatible with that DB cluster parameter group family.
- `description`: The description for the DB cluster parameter group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: The tags to be assigned to the new DB cluster parameter group.
"""
function create_dbcluster_parameter_group(
    DBClusterParameterGroupName,
    DBParameterGroupFamily,
    Description;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "CreateDBClusterParameterGroup",
        Dict{String,Any}(
            "DBClusterParameterGroupName" => DBClusterParameterGroupName,
            "DBParameterGroupFamily" => DBParameterGroupFamily,
            "Description" => Description,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_dbcluster_parameter_group(
    DBClusterParameterGroupName,
    DBParameterGroupFamily,
    Description,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "CreateDBClusterParameterGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DBClusterParameterGroupName" => DBClusterParameterGroupName,
                    "DBParameterGroupFamily" => DBParameterGroupFamily,
                    "Description" => Description,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_dbcluster_snapshot(dbcluster_identifier, dbcluster_snapshot_identifier)
    create_dbcluster_snapshot(dbcluster_identifier, dbcluster_snapshot_identifier, params::Dict{String,<:Any})

Creates a snapshot of a DB cluster.

# Arguments
- `dbcluster_identifier`: The identifier of the DB cluster to create a snapshot for. This
  parameter is not case-sensitive. Constraints:   Must match the identifier of an existing
  DBCluster.   Example: my-cluster1
- `dbcluster_snapshot_identifier`: The identifier of the DB cluster snapshot. This
  parameter is stored as a lowercase string. Constraints:   Must contain from 1 to 63
  letters, numbers, or hyphens.   First character must be a letter.   Cannot end with a
  hyphen or contain two consecutive hyphens.   Example: my-cluster1-snapshot1

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: The tags to be assigned to the DB cluster snapshot.
"""
function create_dbcluster_snapshot(
    DBClusterIdentifier,
    DBClusterSnapshotIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "CreateDBClusterSnapshot",
        Dict{String,Any}(
            "DBClusterIdentifier" => DBClusterIdentifier,
            "DBClusterSnapshotIdentifier" => DBClusterSnapshotIdentifier,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_dbcluster_snapshot(
    DBClusterIdentifier,
    DBClusterSnapshotIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "CreateDBClusterSnapshot",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DBClusterIdentifier" => DBClusterIdentifier,
                    "DBClusterSnapshotIdentifier" => DBClusterSnapshotIdentifier,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_dbinstance(dbcluster_identifier, dbinstance_class, dbinstance_identifier, engine)
    create_dbinstance(dbcluster_identifier, dbinstance_class, dbinstance_identifier, engine, params::Dict{String,<:Any})

Creates a new DB instance.

# Arguments
- `dbcluster_identifier`: The identifier of the DB cluster that the instance will belong
  to. For information on creating a DB cluster, see CreateDBCluster. Type: String
- `dbinstance_class`: The compute and memory capacity of the DB instance, for example,
  db.m4.large. Not all DB instance classes are available in all Amazon Regions.
- `dbinstance_identifier`: The DB instance identifier. This parameter is stored as a
  lowercase string. Constraints:   Must contain from 1 to 63 letters, numbers, or hyphens.
  First character must be a letter.   Cannot end with a hyphen or contain two consecutive
  hyphens.   Example: mydbinstance
- `engine`: The name of the database engine to be used for this instance. Valid Values:
  neptune

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AllocatedStorage"`: Not supported by Neptune.
- `"AutoMinorVersionUpgrade"`: Indicates that minor engine upgrades are applied
  automatically to the DB instance during the maintenance window. Default: true
- `"AvailabilityZone"`:  The EC2 Availability Zone that the DB instance is created in
  Default: A random, system-chosen Availability Zone in the endpoint's Amazon Region.
  Example: us-east-1d   Constraint: The AvailabilityZone parameter can't be specified if the
  MultiAZ parameter is set to true. The specified Availability Zone must be in the same
  Amazon Region as the current endpoint.
- `"BackupRetentionPeriod"`: The number of days for which automated backups are retained.
  Not applicable. The retention period for automated backups is managed by the DB cluster.
  For more information, see CreateDBCluster. Default: 1 Constraints:   Must be a value from 0
  to 35   Cannot be set to 0 if the DB instance is a source to Read Replicas
- `"CharacterSetName"`:  (Not supported by Neptune)
- `"CopyTagsToSnapshot"`: True to copy all tags from the DB instance to snapshots of the DB
  instance, and otherwise false. The default is false.
- `"DBName"`: Not supported.
- `"DBParameterGroupName"`: The name of the DB parameter group to associate with this DB
  instance. If this argument is omitted, the default DBParameterGroup for the specified
  engine is used. Constraints:   Must be 1 to 255 letters, numbers, or hyphens.   First
  character must be a letter   Cannot end with a hyphen or contain two consecutive hyphens
- `"DBSecurityGroups"`: A list of DB security groups to associate with this DB instance.
  Default: The default DB security group for the database engine.
- `"DBSubnetGroupName"`: A DB subnet group to associate with this DB instance. If there is
  no DB subnet group, then it is a non-VPC DB instance.
- `"DeletionProtection"`: A value that indicates whether the DB instance has deletion
  protection enabled. The database can't be deleted when deletion protection is enabled. By
  default, deletion protection is disabled. See Deleting a DB Instance. DB instances in a DB
  cluster can be deleted even when deletion protection is enabled in their parent DB cluster.
- `"Domain"`: Specify the Active Directory Domain to create the instance in.
- `"DomainIAMRoleName"`: Specify the name of the IAM role to be used when making API calls
  to the Directory Service.
- `"EnableCloudwatchLogsExports"`: The list of log types that need to be enabled for
  exporting to CloudWatch Logs.
- `"EnableIAMDatabaseAuthentication"`: Not supported by Neptune (ignored).
- `"EnablePerformanceInsights"`:  (Not supported by Neptune)
- `"EngineVersion"`: The version number of the database engine to use. Currently, setting
  this parameter has no effect.
- `"Iops"`: The amount of Provisioned IOPS (input/output operations per second) to be
  initially allocated for the DB instance.
- `"KmsKeyId"`: The Amazon KMS key identifier for an encrypted DB instance. The KMS key
  identifier is the Amazon Resource Name (ARN) for the KMS encryption key. If you are
  creating a DB instance with the same Amazon account that owns the KMS encryption key used
  to encrypt the new DB instance, then you can use the KMS key alias instead of the ARN for
  the KM encryption key. Not applicable. The KMS key identifier is managed by the DB cluster.
  For more information, see CreateDBCluster. If the StorageEncrypted parameter is true, and
  you do not specify a value for the KmsKeyId parameter, then Amazon Neptune will use your
  default encryption key. Amazon KMS creates the default encryption key for your Amazon
  account. Your Amazon account has a different default encryption key for each Amazon Region.
- `"LicenseModel"`: License model information for this DB instance.  Valid values:
  license-included | bring-your-own-license | general-public-license
- `"MasterUserPassword"`: Not supported by Neptune.
- `"MasterUsername"`: Not supported by Neptune.
- `"MonitoringInterval"`: The interval, in seconds, between points when Enhanced Monitoring
  metrics are collected for the DB instance. To disable collecting Enhanced Monitoring
  metrics, specify 0. The default is 0. If MonitoringRoleArn is specified, then you must also
  set MonitoringInterval to a value other than 0. Valid Values: 0, 1, 5, 10, 15, 30, 60
- `"MonitoringRoleArn"`: The ARN for the IAM role that permits Neptune to send enhanced
  monitoring metrics to Amazon CloudWatch Logs. For example,
  arn:aws:iam:123456789012:role/emaccess. If MonitoringInterval is set to a value other than
  0, then you must supply a MonitoringRoleArn value.
- `"MultiAZ"`: Specifies if the DB instance is a Multi-AZ deployment. You can't set the
  AvailabilityZone parameter if the MultiAZ parameter is set to true.
- `"OptionGroupName"`:  (Not supported by Neptune)
- `"PerformanceInsightsKMSKeyId"`:  (Not supported by Neptune)
- `"Port"`: The port number on which the database accepts connections. Not applicable. The
  port is managed by the DB cluster. For more information, see CreateDBCluster.  Default:
  8182  Type: Integer
- `"PreferredBackupWindow"`:  The daily time range during which automated backups are
  created. Not applicable. The daily time range for creating automated backups is managed by
  the DB cluster. For more information, see CreateDBCluster.
- `"PreferredMaintenanceWindow"`: The time range each week during which system maintenance
  can occur, in Universal Coordinated Time (UTC).  Format: ddd:hh24:mi-ddd:hh24:mi  The
  default is a 30-minute window selected at random from an 8-hour block of time for each
  Amazon Region, occurring on a random day of the week. Valid Days: Mon, Tue, Wed, Thu, Fri,
  Sat, Sun. Constraints: Minimum 30-minute window.
- `"PromotionTier"`: A value that specifies the order in which an Read Replica is promoted
  to the primary instance after a failure of the existing primary instance.  Default: 1 Valid
  Values: 0 - 15
- `"PubliclyAccessible"`: This flag should no longer be used.
- `"StorageEncrypted"`: Specifies whether the DB instance is encrypted. Not applicable. The
  encryption for DB instances is managed by the DB cluster. For more information, see
  CreateDBCluster. Default: false
- `"StorageType"`: Specifies the storage type to be associated with the DB instance. Not
  applicable. Storage is managed by the DB Cluster.
- `"Tags"`: The tags to assign to the new instance.
- `"TdeCredentialArn"`: The ARN from the key store with which to associate the instance for
  TDE encryption.
- `"TdeCredentialPassword"`: The password for the given ARN from the key store in order to
  access the device.
- `"Timezone"`: The time zone of the DB instance.
- `"VpcSecurityGroupIds"`: A list of EC2 VPC security groups to associate with this DB
  instance. Not applicable. The associated list of EC2 VPC security groups is managed by the
  DB cluster. For more information, see CreateDBCluster. Default: The default EC2 VPC
  security group for the DB subnet group's VPC.
"""
function create_dbinstance(
    DBClusterIdentifier,
    DBInstanceClass,
    DBInstanceIdentifier,
    Engine;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "CreateDBInstance",
        Dict{String,Any}(
            "DBClusterIdentifier" => DBClusterIdentifier,
            "DBInstanceClass" => DBInstanceClass,
            "DBInstanceIdentifier" => DBInstanceIdentifier,
            "Engine" => Engine,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_dbinstance(
    DBClusterIdentifier,
    DBInstanceClass,
    DBInstanceIdentifier,
    Engine,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "CreateDBInstance",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DBClusterIdentifier" => DBClusterIdentifier,
                    "DBInstanceClass" => DBInstanceClass,
                    "DBInstanceIdentifier" => DBInstanceIdentifier,
                    "Engine" => Engine,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_dbparameter_group(dbparameter_group_family, dbparameter_group_name, description)
    create_dbparameter_group(dbparameter_group_family, dbparameter_group_name, description, params::Dict{String,<:Any})

Creates a new DB parameter group. A DB parameter group is initially created with the
default parameters for the database engine used by the DB instance. To provide custom
values for any of the parameters, you must modify the group after creating it using
ModifyDBParameterGroup. Once you've created a DB parameter group, you need to associate it
with your DB instance using ModifyDBInstance. When you associate a new DB parameter group
with a running DB instance, you need to reboot the DB instance without failover for the new
DB parameter group and associated settings to take effect.  After you create a DB parameter
group, you should wait at least 5 minutes before creating your first DB instance that uses
that DB parameter group as the default parameter group. This allows Amazon Neptune to fully
complete the create action before the parameter group is used as the default for a new DB
instance. This is especially important for parameters that are critical when creating the
default database for a DB instance, such as the character set for the default database
defined by the character_set_database parameter. You can use the Parameter Groups option of
the Amazon Neptune console or the DescribeDBParameters command to verify that your DB
parameter group has been created or modified.

# Arguments
- `dbparameter_group_family`: The DB parameter group family name. A DB parameter group can
  be associated with one and only one DB parameter group family, and can be applied only to a
  DB instance running a database engine and engine version compatible with that DB parameter
  group family.
- `dbparameter_group_name`: The name of the DB parameter group. Constraints:   Must be 1 to
  255 letters, numbers, or hyphens.   First character must be a letter   Cannot end with a
  hyphen or contain two consecutive hyphens    This value is stored as a lowercase string.
- `description`: The description for the DB parameter group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: The tags to be assigned to the new DB parameter group.
"""
function create_dbparameter_group(
    DBParameterGroupFamily,
    DBParameterGroupName,
    Description;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "CreateDBParameterGroup",
        Dict{String,Any}(
            "DBParameterGroupFamily" => DBParameterGroupFamily,
            "DBParameterGroupName" => DBParameterGroupName,
            "Description" => Description,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_dbparameter_group(
    DBParameterGroupFamily,
    DBParameterGroupName,
    Description,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "CreateDBParameterGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DBParameterGroupFamily" => DBParameterGroupFamily,
                    "DBParameterGroupName" => DBParameterGroupName,
                    "Description" => Description,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_dbsubnet_group(dbsubnet_group_description, dbsubnet_group_name, subnet_identifier)
    create_dbsubnet_group(dbsubnet_group_description, dbsubnet_group_name, subnet_identifier, params::Dict{String,<:Any})

Creates a new DB subnet group. DB subnet groups must contain at least one subnet in at
least two AZs in the Amazon Region.

# Arguments
- `dbsubnet_group_description`: The description for the DB subnet group.
- `dbsubnet_group_name`: The name for the DB subnet group. This value is stored as a
  lowercase string. Constraints: Must contain no more than 255 letters, numbers, periods,
  underscores, spaces, or hyphens. Must not be default. Example: mySubnetgroup
- `subnet_identifier`: The EC2 Subnet IDs for the DB subnet group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"SubnetIds"`: The EC2 Subnet IDs for the DB subnet group.
- `"Tags"`: The tags to be assigned to the new DB subnet group.
"""
function create_dbsubnet_group(
    DBSubnetGroupDescription,
    DBSubnetGroupName,
    SubnetIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "CreateDBSubnetGroup",
        Dict{String,Any}(
            "DBSubnetGroupDescription" => DBSubnetGroupDescription,
            "DBSubnetGroupName" => DBSubnetGroupName,
            "SubnetIdentifier" => SubnetIdentifier,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_dbsubnet_group(
    DBSubnetGroupDescription,
    DBSubnetGroupName,
    SubnetIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "CreateDBSubnetGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DBSubnetGroupDescription" => DBSubnetGroupDescription,
                    "DBSubnetGroupName" => DBSubnetGroupName,
                    "SubnetIdentifier" => SubnetIdentifier,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_event_subscription(sns_topic_arn, subscription_name)
    create_event_subscription(sns_topic_arn, subscription_name, params::Dict{String,<:Any})

Creates an event notification subscription. This action requires a topic ARN (Amazon
Resource Name) created by either the Neptune console, the SNS console, or the SNS API. To
obtain an ARN with SNS, you must create a topic in Amazon SNS and subscribe to the topic.
The ARN is displayed in the SNS console. You can specify the type of source (SourceType)
you want to be notified of, provide a list of Neptune sources (SourceIds) that triggers the
events, and provide a list of event categories (EventCategories) for events you want to be
notified of. For example, you can specify SourceType = db-instance, SourceIds =
mydbinstance1, mydbinstance2 and EventCategories = Availability, Backup. If you specify
both the SourceType and SourceIds, such as SourceType = db-instance and SourceIdentifier =
myDBInstance1, you are notified of all the db-instance events for the specified source. If
you specify a SourceType but do not specify a SourceIdentifier, you receive notice of the
events for that source type for all your Neptune sources. If you do not specify either the
SourceType nor the SourceIdentifier, you are notified of events generated from all Neptune
sources belonging to your customer account.

# Arguments
- `sns_topic_arn`: The Amazon Resource Name (ARN) of the SNS topic created for event
  notification. The ARN is created by Amazon SNS when you create a topic and subscribe to it.
- `subscription_name`: The name of the subscription. Constraints: The name must be less
  than 255 characters.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Enabled"`:  A Boolean value; set to true to activate the subscription, set to false to
  create the subscription but not active it.
- `"EventCategories"`:  A list of event categories for a SourceType that you want to
  subscribe to. You can see a list of the categories for a given SourceType by using the
  DescribeEventCategories action.
- `"SourceIds"`: The list of identifiers of the event sources for which events are
  returned. If not specified, then all sources are included in the response. An identifier
  must begin with a letter and must contain only ASCII letters, digits, and hyphens; it can't
  end with a hyphen or contain two consecutive hyphens. Constraints:   If SourceIds are
  supplied, SourceType must also be provided.   If the source type is a DB instance, then a
  DBInstanceIdentifier must be supplied.   If the source type is a DB security group, a
  DBSecurityGroupName must be supplied.   If the source type is a DB parameter group, a
  DBParameterGroupName must be supplied.   If the source type is a DB snapshot, a
  DBSnapshotIdentifier must be supplied.
- `"SourceType"`: The type of source that is generating the events. For example, if you
  want to be notified of events generated by a DB instance, you would set this parameter to
  db-instance. if this value is not specified, all events are returned. Valid values:
  db-instance | db-cluster | db-parameter-group | db-security-group | db-snapshot |
  db-cluster-snapshot
- `"Tags"`: The tags to be applied to the new event subscription.
"""
function create_event_subscription(
    SnsTopicArn, SubscriptionName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptune(
        "CreateEventSubscription",
        Dict{String,Any}(
            "SnsTopicArn" => SnsTopicArn, "SubscriptionName" => SubscriptionName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_event_subscription(
    SnsTopicArn,
    SubscriptionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "CreateEventSubscription",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "SnsTopicArn" => SnsTopicArn, "SubscriptionName" => SubscriptionName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_global_cluster(global_cluster_identifier)
    create_global_cluster(global_cluster_identifier, params::Dict{String,<:Any})

Creates a Neptune global database spread across multiple Amazon Regions. The global
database contains a single primary cluster with read-write capability, and read-only
secondary clusters that receive data from the primary cluster through high-speed
replication performed by the Neptune storage subsystem. You can create a global database
that is initially empty, and then add a primary cluster and secondary clusters to it, or
you can specify an existing Neptune cluster during the create operation to become the
primary cluster of the global database.

# Arguments
- `global_cluster_identifier`: The cluster identifier of the new global database cluster.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DeletionProtection"`: The deletion protection setting for the new global database. The
  global database can't be deleted when deletion protection is enabled.
- `"Engine"`: The name of the database engine to be used in the global database. Valid
  values: neptune
- `"EngineVersion"`: The Neptune engine version to be used by the global database. Valid
  values: 1.2.0.0 or above.
- `"SourceDBClusterIdentifier"`: (Optional) The Amazon Resource Name (ARN) of an existing
  Neptune DB cluster to use as the primary cluster of the new global database.
- `"StorageEncrypted"`: The storage encryption setting for the new global database cluster.
"""
function create_global_cluster(
    GlobalClusterIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptune(
        "CreateGlobalCluster",
        Dict{String,Any}("GlobalClusterIdentifier" => GlobalClusterIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_global_cluster(
    GlobalClusterIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "CreateGlobalCluster",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("GlobalClusterIdentifier" => GlobalClusterIdentifier),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_dbcluster(dbcluster_identifier)
    delete_dbcluster(dbcluster_identifier, params::Dict{String,<:Any})

The DeleteDBCluster action deletes a previously provisioned DB cluster. When you delete a
DB cluster, all automated backups for that DB cluster are deleted and can't be recovered.
Manual DB cluster snapshots of the specified DB cluster are not deleted. Note that the DB
Cluster cannot be deleted if deletion protection is enabled. To delete it, you must first
set its DeletionProtection field to False.

# Arguments
- `dbcluster_identifier`: The DB cluster identifier for the DB cluster to be deleted. This
  parameter isn't case-sensitive. Constraints:   Must match an existing DBClusterIdentifier.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FinalDBSnapshotIdentifier"`:  The DB cluster snapshot identifier of the new DB cluster
  snapshot created when SkipFinalSnapshot is set to false.   Specifying this parameter and
  also setting the SkipFinalShapshot parameter to true results in an error.  Constraints:
  Must be 1 to 255 letters, numbers, or hyphens.   First character must be a letter   Cannot
  end with a hyphen or contain two consecutive hyphens
- `"SkipFinalSnapshot"`:  Determines whether a final DB cluster snapshot is created before
  the DB cluster is deleted. If true is specified, no DB cluster snapshot is created. If
  false is specified, a DB cluster snapshot is created before the DB cluster is deleted.  You
  must specify a FinalDBSnapshotIdentifier parameter if SkipFinalSnapshot is false.  Default:
  false
"""
function delete_dbcluster(
    DBClusterIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptune(
        "DeleteDBCluster",
        Dict{String,Any}("DBClusterIdentifier" => DBClusterIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_dbcluster(
    DBClusterIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "DeleteDBCluster",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DBClusterIdentifier" => DBClusterIdentifier),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_dbcluster_endpoint(dbcluster_endpoint_identifier)
    delete_dbcluster_endpoint(dbcluster_endpoint_identifier, params::Dict{String,<:Any})

Deletes a custom endpoint and removes it from an Amazon Neptune DB cluster.

# Arguments
- `dbcluster_endpoint_identifier`: The identifier associated with the custom endpoint. This
  parameter is stored as a lowercase string.

"""
function delete_dbcluster_endpoint(
    DBClusterEndpointIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptune(
        "DeleteDBClusterEndpoint",
        Dict{String,Any}("DBClusterEndpointIdentifier" => DBClusterEndpointIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_dbcluster_endpoint(
    DBClusterEndpointIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "DeleteDBClusterEndpoint",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DBClusterEndpointIdentifier" => DBClusterEndpointIdentifier
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_dbcluster_parameter_group(dbcluster_parameter_group_name)
    delete_dbcluster_parameter_group(dbcluster_parameter_group_name, params::Dict{String,<:Any})

Deletes a specified DB cluster parameter group. The DB cluster parameter group to be
deleted can't be associated with any DB clusters.

# Arguments
- `dbcluster_parameter_group_name`: The name of the DB cluster parameter group.
  Constraints:   Must be the name of an existing DB cluster parameter group.   You can't
  delete a default DB cluster parameter group.   Cannot be associated with any DB clusters.

"""
function delete_dbcluster_parameter_group(
    DBClusterParameterGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptune(
        "DeleteDBClusterParameterGroup",
        Dict{String,Any}("DBClusterParameterGroupName" => DBClusterParameterGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_dbcluster_parameter_group(
    DBClusterParameterGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "DeleteDBClusterParameterGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DBClusterParameterGroupName" => DBClusterParameterGroupName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_dbcluster_snapshot(dbcluster_snapshot_identifier)
    delete_dbcluster_snapshot(dbcluster_snapshot_identifier, params::Dict{String,<:Any})

Deletes a DB cluster snapshot. If the snapshot is being copied, the copy operation is
terminated.  The DB cluster snapshot must be in the available state to be deleted.

# Arguments
- `dbcluster_snapshot_identifier`: The identifier of the DB cluster snapshot to delete.
  Constraints: Must be the name of an existing DB cluster snapshot in the available state.

"""
function delete_dbcluster_snapshot(
    DBClusterSnapshotIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptune(
        "DeleteDBClusterSnapshot",
        Dict{String,Any}("DBClusterSnapshotIdentifier" => DBClusterSnapshotIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_dbcluster_snapshot(
    DBClusterSnapshotIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "DeleteDBClusterSnapshot",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DBClusterSnapshotIdentifier" => DBClusterSnapshotIdentifier
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_dbinstance(dbinstance_identifier)
    delete_dbinstance(dbinstance_identifier, params::Dict{String,<:Any})

The DeleteDBInstance action deletes a previously provisioned DB instance. When you delete a
DB instance, all automated backups for that instance are deleted and can't be recovered.
Manual DB snapshots of the DB instance to be deleted by DeleteDBInstance are not deleted.
If you request a final DB snapshot the status of the Amazon Neptune DB instance is deleting
until the DB snapshot is created. The API action DescribeDBInstance is used to monitor the
status of this operation. The action can't be canceled or reverted once submitted. Note
that when a DB instance is in a failure state and has a status of failed,
incompatible-restore, or incompatible-network, you can only delete it when the
SkipFinalSnapshot parameter is set to true. You can't delete a DB instance if it is the
only instance in the DB cluster, or if it has deletion protection enabled.

# Arguments
- `dbinstance_identifier`: The DB instance identifier for the DB instance to be deleted.
  This parameter isn't case-sensitive. Constraints:   Must match the name of an existing DB
  instance.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FinalDBSnapshotIdentifier"`:  The DBSnapshotIdentifier of the new DBSnapshot created
  when SkipFinalSnapshot is set to false.  Specifying this parameter and also setting the
  SkipFinalShapshot parameter to true results in an error.  Constraints:   Must be 1 to 255
  letters or numbers.   First character must be a letter   Cannot end with a hyphen or
  contain two consecutive hyphens   Cannot be specified when deleting a Read Replica.
- `"SkipFinalSnapshot"`:  Determines whether a final DB snapshot is created before the DB
  instance is deleted. If true is specified, no DBSnapshot is created. If false is specified,
  a DB snapshot is created before the DB instance is deleted. Note that when a DB instance is
  in a failure state and has a status of 'failed', 'incompatible-restore', or
  'incompatible-network', it can only be deleted when the SkipFinalSnapshot parameter is set
  to \"true\". Specify true when deleting a Read Replica.  The FinalDBSnapshotIdentifier
  parameter must be specified if SkipFinalSnapshot is false.  Default: false
"""
function delete_dbinstance(
    DBInstanceIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptune(
        "DeleteDBInstance",
        Dict{String,Any}("DBInstanceIdentifier" => DBInstanceIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_dbinstance(
    DBInstanceIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "DeleteDBInstance",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DBInstanceIdentifier" => DBInstanceIdentifier),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_dbparameter_group(dbparameter_group_name)
    delete_dbparameter_group(dbparameter_group_name, params::Dict{String,<:Any})

Deletes a specified DBParameterGroup. The DBParameterGroup to be deleted can't be
associated with any DB instances.

# Arguments
- `dbparameter_group_name`: The name of the DB parameter group. Constraints:   Must be the
  name of an existing DB parameter group   You can't delete a default DB parameter group
  Cannot be associated with any DB instances

"""
function delete_dbparameter_group(
    DBParameterGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptune(
        "DeleteDBParameterGroup",
        Dict{String,Any}("DBParameterGroupName" => DBParameterGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_dbparameter_group(
    DBParameterGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "DeleteDBParameterGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DBParameterGroupName" => DBParameterGroupName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_dbsubnet_group(dbsubnet_group_name)
    delete_dbsubnet_group(dbsubnet_group_name, params::Dict{String,<:Any})

Deletes a DB subnet group.  The specified database subnet group must not be associated with
any DB instances.

# Arguments
- `dbsubnet_group_name`: The name of the database subnet group to delete.  You can't delete
  the default subnet group.  Constraints: Constraints: Must match the name of an existing
  DBSubnetGroup. Must not be default. Example: mySubnetgroup

"""
function delete_dbsubnet_group(
    DBSubnetGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptune(
        "DeleteDBSubnetGroup",
        Dict{String,Any}("DBSubnetGroupName" => DBSubnetGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_dbsubnet_group(
    DBSubnetGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "DeleteDBSubnetGroup",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("DBSubnetGroupName" => DBSubnetGroupName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_event_subscription(subscription_name)
    delete_event_subscription(subscription_name, params::Dict{String,<:Any})

Deletes an event notification subscription.

# Arguments
- `subscription_name`: The name of the event notification subscription you want to delete.

"""
function delete_event_subscription(
    SubscriptionName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptune(
        "DeleteEventSubscription",
        Dict{String,Any}("SubscriptionName" => SubscriptionName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_event_subscription(
    SubscriptionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "DeleteEventSubscription",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("SubscriptionName" => SubscriptionName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_global_cluster(global_cluster_identifier)
    delete_global_cluster(global_cluster_identifier, params::Dict{String,<:Any})

Deletes a global database. The primary and all secondary clusters must already be detached
or deleted first.

# Arguments
- `global_cluster_identifier`: The cluster identifier of the global database cluster being
  deleted.

"""
function delete_global_cluster(
    GlobalClusterIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptune(
        "DeleteGlobalCluster",
        Dict{String,Any}("GlobalClusterIdentifier" => GlobalClusterIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_global_cluster(
    GlobalClusterIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "DeleteGlobalCluster",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("GlobalClusterIdentifier" => GlobalClusterIdentifier),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_dbcluster_endpoints()
    describe_dbcluster_endpoints(params::Dict{String,<:Any})

Returns information about endpoints for an Amazon Neptune DB cluster.  This operation can
also return information for Amazon RDS clusters and Amazon DocDB clusters.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DBClusterEndpointIdentifier"`: The identifier of the endpoint to describe. This
  parameter is stored as a lowercase string.
- `"DBClusterIdentifier"`: The DB cluster identifier of the DB cluster associated with the
  endpoint. This parameter is stored as a lowercase string.
- `"Filters"`: A set of name-value pairs that define which endpoints to include in the
  output. The filters are specified as name-value pairs, in the format
  Name=endpoint_type,Values=endpoint_type1,endpoint_type2,.... Name can be one of:
  db-cluster-endpoint-type, db-cluster-endpoint-custom-type, db-cluster-endpoint-id,
  db-cluster-endpoint-status. Values for the  db-cluster-endpoint-type filter can be one or
  more of: reader, writer, custom. Values for the db-cluster-endpoint-custom-type filter can
  be one or more of: reader, any. Values for the db-cluster-endpoint-status filter can be one
  or more of: available, creating, deleting, inactive, modifying.
- `"Marker"`:  An optional pagination token provided by a previous
  DescribeDBClusterEndpoints request. If this parameter is specified, the response includes
  only records beyond the marker, up to the value specified by MaxRecords.
- `"MaxRecords"`: The maximum number of records to include in the response. If more records
  exist than the specified MaxRecords value, a pagination token called a marker is included
  in the response so you can retrieve the remaining results.  Default: 100 Constraints:
  Minimum 20, maximum 100.
"""
function describe_dbcluster_endpoints(; aws_config::AbstractAWSConfig=current_aws_config())
    return neptune(
        "DescribeDBClusterEndpoints"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_dbcluster_endpoints(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptune(
        "DescribeDBClusterEndpoints",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_dbcluster_parameter_groups()
    describe_dbcluster_parameter_groups(params::Dict{String,<:Any})

 Returns a list of DBClusterParameterGroup descriptions. If a DBClusterParameterGroupName
parameter is specified, the list will contain only the description of the specified DB
cluster parameter group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DBClusterParameterGroupName"`: The name of a specific DB cluster parameter group to
  return details for. Constraints:   If supplied, must match the name of an existing
  DBClusterParameterGroup.
- `"Filters"`: This parameter is not currently supported.
- `"Marker"`:  An optional pagination token provided by a previous
  DescribeDBClusterParameterGroups request. If this parameter is specified, the response
  includes only records beyond the marker, up to the value specified by MaxRecords.
- `"MaxRecords"`:  The maximum number of records to include in the response. If more
  records exist than the specified MaxRecords value, a pagination token called a marker is
  included in the response so that the remaining results can be retrieved. Default: 100
  Constraints: Minimum 20, maximum 100.
"""
function describe_dbcluster_parameter_groups(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptune(
        "DescribeDBClusterParameterGroups";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_dbcluster_parameter_groups(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptune(
        "DescribeDBClusterParameterGroups",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_dbcluster_parameters(dbcluster_parameter_group_name)
    describe_dbcluster_parameters(dbcluster_parameter_group_name, params::Dict{String,<:Any})

Returns the detailed parameter list for a particular DB cluster parameter group.

# Arguments
- `dbcluster_parameter_group_name`: The name of a specific DB cluster parameter group to
  return parameter details for. Constraints:   If supplied, must match the name of an
  existing DBClusterParameterGroup.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: This parameter is not currently supported.
- `"Marker"`:  An optional pagination token provided by a previous
  DescribeDBClusterParameters request. If this parameter is specified, the response includes
  only records beyond the marker, up to the value specified by MaxRecords.
- `"MaxRecords"`:  The maximum number of records to include in the response. If more
  records exist than the specified MaxRecords value, a pagination token called a marker is
  included in the response so that the remaining results can be retrieved. Default: 100
  Constraints: Minimum 20, maximum 100.
- `"Source"`:  A value that indicates to return only parameters for a specific source.
  Parameter sources can be engine, service, or customer.
"""
function describe_dbcluster_parameters(
    DBClusterParameterGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptune(
        "DescribeDBClusterParameters",
        Dict{String,Any}("DBClusterParameterGroupName" => DBClusterParameterGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_dbcluster_parameters(
    DBClusterParameterGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "DescribeDBClusterParameters",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DBClusterParameterGroupName" => DBClusterParameterGroupName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_dbcluster_snapshot_attributes(dbcluster_snapshot_identifier)
    describe_dbcluster_snapshot_attributes(dbcluster_snapshot_identifier, params::Dict{String,<:Any})

Returns a list of DB cluster snapshot attribute names and values for a manual DB cluster
snapshot. When sharing snapshots with other Amazon accounts,
DescribeDBClusterSnapshotAttributes returns the restore attribute and a list of IDs for the
Amazon accounts that are authorized to copy or restore the manual DB cluster snapshot. If
all is included in the list of values for the restore attribute, then the manual DB cluster
snapshot is public and can be copied or restored by all Amazon accounts. To add or remove
access for an Amazon account to copy or restore a manual DB cluster snapshot, or to make
the manual DB cluster snapshot public or private, use the ModifyDBClusterSnapshotAttribute
API action.

# Arguments
- `dbcluster_snapshot_identifier`: The identifier for the DB cluster snapshot to describe
  the attributes for.

"""
function describe_dbcluster_snapshot_attributes(
    DBClusterSnapshotIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptune(
        "DescribeDBClusterSnapshotAttributes",
        Dict{String,Any}("DBClusterSnapshotIdentifier" => DBClusterSnapshotIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_dbcluster_snapshot_attributes(
    DBClusterSnapshotIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "DescribeDBClusterSnapshotAttributes",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DBClusterSnapshotIdentifier" => DBClusterSnapshotIdentifier
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_dbcluster_snapshots()
    describe_dbcluster_snapshots(params::Dict{String,<:Any})

Returns information about DB cluster snapshots. This API action supports pagination.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DBClusterIdentifier"`: The ID of the DB cluster to retrieve the list of DB cluster
  snapshots for. This parameter can't be used in conjunction with the
  DBClusterSnapshotIdentifier parameter. This parameter is not case-sensitive. Constraints:
  If supplied, must match the identifier of an existing DBCluster.
- `"DBClusterSnapshotIdentifier"`: A specific DB cluster snapshot identifier to describe.
  This parameter can't be used in conjunction with the DBClusterIdentifier parameter. This
  value is stored as a lowercase string. Constraints:   If supplied, must match the
  identifier of an existing DBClusterSnapshot.   If this identifier is for an automated
  snapshot, the SnapshotType parameter must also be specified.
- `"Filters"`: This parameter is not currently supported.
- `"IncludePublic"`: True to include manual DB cluster snapshots that are public and can be
  copied or restored by any Amazon account, and otherwise false. The default is false. The
  default is false. You can share a manual DB cluster snapshot as public by using the
  ModifyDBClusterSnapshotAttribute API action.
- `"IncludeShared"`: True to include shared manual DB cluster snapshots from other Amazon
  accounts that this Amazon account has been given permission to copy or restore, and
  otherwise false. The default is false. You can give an Amazon account permission to restore
  a manual DB cluster snapshot from another Amazon account by the
  ModifyDBClusterSnapshotAttribute API action.
- `"Marker"`: An optional pagination token provided by a previous
  DescribeDBClusterSnapshots request. If this parameter is specified, the response includes
  only records beyond the marker, up to the value specified by MaxRecords.
- `"MaxRecords"`: The maximum number of records to include in the response. If more records
  exist than the specified MaxRecords value, a pagination token called a marker is included
  in the response so that the remaining results can be retrieved. Default: 100 Constraints:
  Minimum 20, maximum 100.
- `"SnapshotType"`: The type of DB cluster snapshots to be returned. You can specify one of
  the following values:    automated - Return all DB cluster snapshots that have been
  automatically taken by Amazon Neptune for my Amazon account.    manual - Return all DB
  cluster snapshots that have been taken by my Amazon account.    shared - Return all manual
  DB cluster snapshots that have been shared to my Amazon account.    public - Return all DB
  cluster snapshots that have been marked as public.   If you don't specify a SnapshotType
  value, then both automated and manual DB cluster snapshots are returned. You can include
  shared DB cluster snapshots with these results by setting the IncludeShared parameter to
  true. You can include public DB cluster snapshots with these results by setting the
  IncludePublic parameter to true. The IncludeShared and IncludePublic parameters don't apply
  for SnapshotType values of manual or automated. The IncludePublic parameter doesn't apply
  when SnapshotType is set to shared. The IncludeShared parameter doesn't apply when
  SnapshotType is set to public.
"""
function describe_dbcluster_snapshots(; aws_config::AbstractAWSConfig=current_aws_config())
    return neptune(
        "DescribeDBClusterSnapshots"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_dbcluster_snapshots(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptune(
        "DescribeDBClusterSnapshots",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_dbclusters()
    describe_dbclusters(params::Dict{String,<:Any})

Returns information about provisioned DB clusters, and supports pagination.  This operation
can also return information for Amazon RDS clusters and Amazon DocDB clusters.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DBClusterIdentifier"`: The user-supplied DB cluster identifier. If this parameter is
  specified, information from only the specific DB cluster is returned. This parameter isn't
  case-sensitive. Constraints:   If supplied, must match an existing DBClusterIdentifier.
- `"Filters"`: A filter that specifies one or more DB clusters to describe. Supported
  filters:    db-cluster-id - Accepts DB cluster identifiers and DB cluster Amazon Resource
  Names (ARNs). The results list will only include information about the DB clusters
  identified by these ARNs.    engine - Accepts an engine name (such as neptune), and
  restricts the results list to DB clusters created by that engine.   For example, to invoke
  this API from the Amazon CLI and filter so that only Neptune DB clusters are returned, you
  could use the following command:
- `"Marker"`: An optional pagination token provided by a previous DescribeDBClusters
  request. If this parameter is specified, the response includes only records beyond the
  marker, up to the value specified by MaxRecords.
- `"MaxRecords"`: The maximum number of records to include in the response. If more records
  exist than the specified MaxRecords value, a pagination token called a marker is included
  in the response so that the remaining results can be retrieved. Default: 100 Constraints:
  Minimum 20, maximum 100.
"""
function describe_dbclusters(; aws_config::AbstractAWSConfig=current_aws_config())
    return neptune(
        "DescribeDBClusters"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_dbclusters(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptune(
        "DescribeDBClusters", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_dbengine_versions()
    describe_dbengine_versions(params::Dict{String,<:Any})

Returns a list of the available DB engines.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DBParameterGroupFamily"`: The name of a specific DB parameter group family to return
  details for. Constraints:   If supplied, must match an existing DBParameterGroupFamily.
- `"DefaultOnly"`: Indicates that only the default version of the specified engine or
  engine and major version combination is returned.
- `"Engine"`: The database engine to return.
- `"EngineVersion"`: The database engine version to return. Example: 5.1.49
- `"Filters"`: Not currently supported.
- `"ListSupportedCharacterSets"`: If this parameter is specified and the requested engine
  supports the CharacterSetName parameter for CreateDBInstance, the response includes a list
  of supported character sets for each engine version.
- `"ListSupportedTimezones"`: If this parameter is specified and the requested engine
  supports the TimeZone parameter for CreateDBInstance, the response includes a list of
  supported time zones for each engine version.
- `"Marker"`:  An optional pagination token provided by a previous request. If this
  parameter is specified, the response includes only records beyond the marker, up to the
  value specified by MaxRecords.
- `"MaxRecords"`:  The maximum number of records to include in the response. If more than
  the MaxRecords value is available, a pagination token called a marker is included in the
  response so that the following results can be retrieved. Default: 100 Constraints: Minimum
  20, maximum 100.
"""
function describe_dbengine_versions(; aws_config::AbstractAWSConfig=current_aws_config())
    return neptune(
        "DescribeDBEngineVersions"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_dbengine_versions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptune(
        "DescribeDBEngineVersions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_dbinstances()
    describe_dbinstances(params::Dict{String,<:Any})

Returns information about provisioned instances, and supports pagination.  This operation
can also return information for Amazon RDS instances and Amazon DocDB instances.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DBInstanceIdentifier"`: The user-supplied instance identifier. If this parameter is
  specified, information from only the specific DB instance is returned. This parameter isn't
  case-sensitive. Constraints:   If supplied, must match the identifier of an existing
  DBInstance.
- `"Filters"`: A filter that specifies one or more DB instances to describe. Supported
  filters:    db-cluster-id - Accepts DB cluster identifiers and DB cluster Amazon Resource
  Names (ARNs). The results list will only include information about the DB instances
  associated with the DB clusters identified by these ARNs.    engine - Accepts an engine
  name (such as neptune), and restricts the results list to DB instances created by that
  engine.   For example, to invoke this API from the Amazon CLI and filter so that only
  Neptune DB instances are returned, you could use the following command:
- `"Marker"`:  An optional pagination token provided by a previous DescribeDBInstances
  request. If this parameter is specified, the response includes only records beyond the
  marker, up to the value specified by MaxRecords.
- `"MaxRecords"`:  The maximum number of records to include in the response. If more
  records exist than the specified MaxRecords value, a pagination token called a marker is
  included in the response so that the remaining results can be retrieved. Default: 100
  Constraints: Minimum 20, maximum 100.
"""
function describe_dbinstances(; aws_config::AbstractAWSConfig=current_aws_config())
    return neptune(
        "DescribeDBInstances"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_dbinstances(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptune(
        "DescribeDBInstances",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_dbparameter_groups()
    describe_dbparameter_groups(params::Dict{String,<:Any})

Returns a list of DBParameterGroup descriptions. If a DBParameterGroupName is specified,
the list will contain only the description of the specified DB parameter group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DBParameterGroupName"`: The name of a specific DB parameter group to return details
  for. Constraints:   If supplied, must match the name of an existing
  DBClusterParameterGroup.
- `"Filters"`: This parameter is not currently supported.
- `"Marker"`: An optional pagination token provided by a previous DescribeDBParameterGroups
  request. If this parameter is specified, the response includes only records beyond the
  marker, up to the value specified by MaxRecords.
- `"MaxRecords"`: The maximum number of records to include in the response. If more records
  exist than the specified MaxRecords value, a pagination token called a marker is included
  in the response so that the remaining results can be retrieved. Default: 100 Constraints:
  Minimum 20, maximum 100.
"""
function describe_dbparameter_groups(; aws_config::AbstractAWSConfig=current_aws_config())
    return neptune(
        "DescribeDBParameterGroups"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_dbparameter_groups(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptune(
        "DescribeDBParameterGroups",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_dbparameters(dbparameter_group_name)
    describe_dbparameters(dbparameter_group_name, params::Dict{String,<:Any})

Returns the detailed parameter list for a particular DB parameter group.

# Arguments
- `dbparameter_group_name`: The name of a specific DB parameter group to return details
  for. Constraints:   If supplied, must match the name of an existing DBParameterGroup.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: This parameter is not currently supported.
- `"Marker"`: An optional pagination token provided by a previous DescribeDBParameters
  request. If this parameter is specified, the response includes only records beyond the
  marker, up to the value specified by MaxRecords.
- `"MaxRecords"`: The maximum number of records to include in the response. If more records
  exist than the specified MaxRecords value, a pagination token called a marker is included
  in the response so that the remaining results can be retrieved. Default: 100 Constraints:
  Minimum 20, maximum 100.
- `"Source"`: The parameter types to return. Default: All parameter types returned Valid
  Values: user | system | engine-default
"""
function describe_dbparameters(
    DBParameterGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptune(
        "DescribeDBParameters",
        Dict{String,Any}("DBParameterGroupName" => DBParameterGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_dbparameters(
    DBParameterGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "DescribeDBParameters",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DBParameterGroupName" => DBParameterGroupName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_dbsubnet_groups()
    describe_dbsubnet_groups(params::Dict{String,<:Any})

Returns a list of DBSubnetGroup descriptions. If a DBSubnetGroupName is specified, the list
will contain only the descriptions of the specified DBSubnetGroup. For an overview of CIDR
ranges, go to the Wikipedia Tutorial.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DBSubnetGroupName"`: The name of the DB subnet group to return details for.
- `"Filters"`: This parameter is not currently supported.
- `"Marker"`:  An optional pagination token provided by a previous DescribeDBSubnetGroups
  request. If this parameter is specified, the response includes only records beyond the
  marker, up to the value specified by MaxRecords.
- `"MaxRecords"`:  The maximum number of records to include in the response. If more
  records exist than the specified MaxRecords value, a pagination token called a marker is
  included in the response so that the remaining results can be retrieved. Default: 100
  Constraints: Minimum 20, maximum 100.
"""
function describe_dbsubnet_groups(; aws_config::AbstractAWSConfig=current_aws_config())
    return neptune(
        "DescribeDBSubnetGroups"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_dbsubnet_groups(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptune(
        "DescribeDBSubnetGroups",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_engine_default_cluster_parameters(dbparameter_group_family)
    describe_engine_default_cluster_parameters(dbparameter_group_family, params::Dict{String,<:Any})

Returns the default engine and system parameter information for the cluster database engine.

# Arguments
- `dbparameter_group_family`: The name of the DB cluster parameter group family to return
  engine parameter information for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: This parameter is not currently supported.
- `"Marker"`:  An optional pagination token provided by a previous
  DescribeEngineDefaultClusterParameters request. If this parameter is specified, the
  response includes only records beyond the marker, up to the value specified by MaxRecords.
- `"MaxRecords"`:  The maximum number of records to include in the response. If more
  records exist than the specified MaxRecords value, a pagination token called a marker is
  included in the response so that the remaining results can be retrieved. Default: 100
  Constraints: Minimum 20, maximum 100.
"""
function describe_engine_default_cluster_parameters(
    DBParameterGroupFamily; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptune(
        "DescribeEngineDefaultClusterParameters",
        Dict{String,Any}("DBParameterGroupFamily" => DBParameterGroupFamily);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_engine_default_cluster_parameters(
    DBParameterGroupFamily,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "DescribeEngineDefaultClusterParameters",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DBParameterGroupFamily" => DBParameterGroupFamily),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_engine_default_parameters(dbparameter_group_family)
    describe_engine_default_parameters(dbparameter_group_family, params::Dict{String,<:Any})

Returns the default engine and system parameter information for the specified database
engine.

# Arguments
- `dbparameter_group_family`: The name of the DB parameter group family.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: Not currently supported.
- `"Marker"`:  An optional pagination token provided by a previous
  DescribeEngineDefaultParameters request. If this parameter is specified, the response
  includes only records beyond the marker, up to the value specified by MaxRecords.
- `"MaxRecords"`:  The maximum number of records to include in the response. If more
  records exist than the specified MaxRecords value, a pagination token called a marker is
  included in the response so that the remaining results can be retrieved. Default: 100
  Constraints: Minimum 20, maximum 100.
"""
function describe_engine_default_parameters(
    DBParameterGroupFamily; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptune(
        "DescribeEngineDefaultParameters",
        Dict{String,Any}("DBParameterGroupFamily" => DBParameterGroupFamily);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_engine_default_parameters(
    DBParameterGroupFamily,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "DescribeEngineDefaultParameters",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DBParameterGroupFamily" => DBParameterGroupFamily),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_event_categories()
    describe_event_categories(params::Dict{String,<:Any})

Displays a list of categories for all event source types, or, if specified, for a specified
source type.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: This parameter is not currently supported.
- `"SourceType"`: The type of source that is generating the events. Valid values:
  db-instance | db-parameter-group | db-security-group | db-snapshot
"""
function describe_event_categories(; aws_config::AbstractAWSConfig=current_aws_config())
    return neptune(
        "DescribeEventCategories"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_event_categories(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptune(
        "DescribeEventCategories",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_event_subscriptions()
    describe_event_subscriptions(params::Dict{String,<:Any})

Lists all the subscription descriptions for a customer account. The description for a
subscription includes SubscriptionName, SNSTopicARN, CustomerID, SourceType, SourceID,
CreationTime, and Status. If you specify a SubscriptionName, lists the description for that
subscription.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: This parameter is not currently supported.
- `"Marker"`:  An optional pagination token provided by a previous
  DescribeOrderableDBInstanceOptions request. If this parameter is specified, the response
  includes only records beyond the marker, up to the value specified by MaxRecords .
- `"MaxRecords"`:  The maximum number of records to include in the response. If more
  records exist than the specified MaxRecords value, a pagination token called a marker is
  included in the response so that the remaining results can be retrieved. Default: 100
  Constraints: Minimum 20, maximum 100.
- `"SubscriptionName"`: The name of the event notification subscription you want to
  describe.
"""
function describe_event_subscriptions(; aws_config::AbstractAWSConfig=current_aws_config())
    return neptune(
        "DescribeEventSubscriptions"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_event_subscriptions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptune(
        "DescribeEventSubscriptions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_events()
    describe_events(params::Dict{String,<:Any})

Returns events related to DB instances, DB security groups, DB snapshots, and DB parameter
groups for the past 14 days. Events specific to a particular DB instance, DB security
group, database snapshot, or DB parameter group can be obtained by providing the name as a
parameter. By default, the past hour of events are returned.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Duration"`: The number of minutes to retrieve events for. Default: 60
- `"EndTime"`:  The end of the time interval for which to retrieve events, specified in ISO
  8601 format. For more information about ISO 8601, go to the ISO8601 Wikipedia page.
  Example: 2009-07-08T18:00Z
- `"EventCategories"`: A list of event categories that trigger notifications for a event
  notification subscription.
- `"Filters"`: This parameter is not currently supported.
- `"Marker"`:  An optional pagination token provided by a previous DescribeEvents request.
  If this parameter is specified, the response includes only records beyond the marker, up to
  the value specified by MaxRecords.
- `"MaxRecords"`:  The maximum number of records to include in the response. If more
  records exist than the specified MaxRecords value, a pagination token called a marker is
  included in the response so that the remaining results can be retrieved. Default: 100
  Constraints: Minimum 20, maximum 100.
- `"SourceIdentifier"`: The identifier of the event source for which events are returned.
  If not specified, then all sources are included in the response. Constraints:   If
  SourceIdentifier is supplied, SourceType must also be provided.   If the source type is
  DBInstance, then a DBInstanceIdentifier must be supplied.   If the source type is
  DBSecurityGroup, a DBSecurityGroupName must be supplied.   If the source type is
  DBParameterGroup, a DBParameterGroupName must be supplied.   If the source type is
  DBSnapshot, a DBSnapshotIdentifier must be supplied.   Cannot end with a hyphen or contain
  two consecutive hyphens.
- `"SourceType"`: The event source to retrieve events for. If no value is specified, all
  events are returned.
- `"StartTime"`:  The beginning of the time interval to retrieve events for, specified in
  ISO 8601 format. For more information about ISO 8601, go to the ISO8601 Wikipedia page.
  Example: 2009-07-08T18:00Z
"""
function describe_events(; aws_config::AbstractAWSConfig=current_aws_config())
    return neptune("DescribeEvents"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function describe_events(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptune(
        "DescribeEvents", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_global_clusters()
    describe_global_clusters(params::Dict{String,<:Any})

Returns information about Neptune global database clusters. This API supports pagination.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"GlobalClusterIdentifier"`: The user-supplied DB cluster identifier. If this parameter
  is specified, only information about the specified DB cluster is returned. This parameter
  is not case-sensitive. Constraints: If supplied, must match an existing DB cluster
  identifier.
- `"Marker"`: (Optional) A pagination token returned by a previous call to
  DescribeGlobalClusters. If this parameter is specified, the response will only include
  records beyond the marker, up to the number specified by MaxRecords.
- `"MaxRecords"`: The maximum number of records to include in the response. If more records
  exist than the specified MaxRecords value, a pagination marker token is included in the
  response that you can use to retrieve the remaining results. Default: 100  Constraints:
  Minimum 20, maximum 100.
"""
function describe_global_clusters(; aws_config::AbstractAWSConfig=current_aws_config())
    return neptune(
        "DescribeGlobalClusters"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_global_clusters(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptune(
        "DescribeGlobalClusters",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_orderable_dbinstance_options(engine)
    describe_orderable_dbinstance_options(engine, params::Dict{String,<:Any})

Returns a list of orderable DB instance options for the specified engine.

# Arguments
- `engine`: The name of the engine to retrieve DB instance options for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DBInstanceClass"`: The DB instance class filter value. Specify this parameter to show
  only the available offerings matching the specified DB instance class.
- `"EngineVersion"`: The engine version filter value. Specify this parameter to show only
  the available offerings matching the specified engine version.
- `"Filters"`: This parameter is not currently supported.
- `"LicenseModel"`: The license model filter value. Specify this parameter to show only the
  available offerings matching the specified license model.
- `"Marker"`:  An optional pagination token provided by a previous
  DescribeOrderableDBInstanceOptions request. If this parameter is specified, the response
  includes only records beyond the marker, up to the value specified by MaxRecords .
- `"MaxRecords"`:  The maximum number of records to include in the response. If more
  records exist than the specified MaxRecords value, a pagination token called a marker is
  included in the response so that the remaining results can be retrieved. Default: 100
  Constraints: Minimum 20, maximum 100.
- `"Vpc"`: The VPC filter value. Specify this parameter to show only the available VPC or
  non-VPC offerings.
"""
function describe_orderable_dbinstance_options(
    Engine; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptune(
        "DescribeOrderableDBInstanceOptions",
        Dict{String,Any}("Engine" => Engine);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_orderable_dbinstance_options(
    Engine, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptune(
        "DescribeOrderableDBInstanceOptions",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Engine" => Engine), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_pending_maintenance_actions()
    describe_pending_maintenance_actions(params::Dict{String,<:Any})

Returns a list of resources (for example, DB instances) that have at least one pending
maintenance action.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: A filter that specifies one or more resources to return pending maintenance
  actions for. Supported filters:    db-cluster-id - Accepts DB cluster identifiers and DB
  cluster Amazon Resource Names (ARNs). The results list will only include pending
  maintenance actions for the DB clusters identified by these ARNs.    db-instance-id -
  Accepts DB instance identifiers and DB instance ARNs. The results list will only include
  pending maintenance actions for the DB instances identified by these ARNs.
- `"Marker"`:  An optional pagination token provided by a previous
  DescribePendingMaintenanceActions request. If this parameter is specified, the response
  includes only records beyond the marker, up to a number of records specified by MaxRecords.
- `"MaxRecords"`:  The maximum number of records to include in the response. If more
  records exist than the specified MaxRecords value, a pagination token called a marker is
  included in the response so that the remaining results can be retrieved. Default: 100
  Constraints: Minimum 20, maximum 100.
- `"ResourceIdentifier"`: The ARN of a resource to return pending maintenance actions for.
"""
function describe_pending_maintenance_actions(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptune(
        "DescribePendingMaintenanceActions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_pending_maintenance_actions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptune(
        "DescribePendingMaintenanceActions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_valid_dbinstance_modifications(dbinstance_identifier)
    describe_valid_dbinstance_modifications(dbinstance_identifier, params::Dict{String,<:Any})

You can call DescribeValidDBInstanceModifications to learn what modifications you can make
to your DB instance. You can use this information when you call ModifyDBInstance.

# Arguments
- `dbinstance_identifier`: The customer identifier or the ARN of your DB instance.

"""
function describe_valid_dbinstance_modifications(
    DBInstanceIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptune(
        "DescribeValidDBInstanceModifications",
        Dict{String,Any}("DBInstanceIdentifier" => DBInstanceIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_valid_dbinstance_modifications(
    DBInstanceIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "DescribeValidDBInstanceModifications",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DBInstanceIdentifier" => DBInstanceIdentifier),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    failover_dbcluster()
    failover_dbcluster(params::Dict{String,<:Any})

Forces a failover for a DB cluster. A failover for a DB cluster promotes one of the Read
Replicas (read-only instances) in the DB cluster to be the primary instance (the cluster
writer). Amazon Neptune will automatically fail over to a Read Replica, if one exists, when
the primary instance fails. You can force a failover when you want to simulate a failure of
a primary instance for testing. Because each instance in a DB cluster has its own endpoint
address, you will need to clean up and re-establish any existing connections that use those
endpoint addresses when the failover is complete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DBClusterIdentifier"`: A DB cluster identifier to force a failover for. This parameter
  is not case-sensitive. Constraints:   Must match the identifier of an existing DBCluster.
- `"TargetDBInstanceIdentifier"`: The name of the instance to promote to the primary
  instance. You must specify the instance identifier for an Read Replica in the DB cluster.
  For example, mydbcluster-replica1.
"""
function failover_dbcluster(; aws_config::AbstractAWSConfig=current_aws_config())
    return neptune(
        "FailoverDBCluster"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function failover_dbcluster(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptune(
        "FailoverDBCluster", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    failover_global_cluster(global_cluster_identifier, target_db_cluster_identifier)
    failover_global_cluster(global_cluster_identifier, target_db_cluster_identifier, params::Dict{String,<:Any})

Initiates the failover process for a Neptune global database. A failover for a Neptune
global database promotes one of secondary read-only DB clusters to be the primary DB
cluster and demotes the primary DB cluster to being a secondary (read-only) DB cluster. In
other words, the role of the current primary DB cluster and the selected target secondary
DB cluster are switched. The selected secondary DB cluster assumes full read/write
capabilities for the Neptune global database.  This action applies only to Neptune global
databases. This action is only intended for use on healthy Neptune global databases with
healthy Neptune DB clusters and no region-wide outages, to test disaster recovery scenarios
or to reconfigure the global database topology.

# Arguments
- `global_cluster_identifier`: Identifier of the Neptune global database that should be
  failed over. The identifier is the unique key assigned by the user when the Neptune global
  database was created. In other words, it's the name of the global database that you want to
  fail over. Constraints: Must match the identifier of an existing Neptune global database.
- `target_db_cluster_identifier`: The Amazon Resource Name (ARN) of the secondary Neptune
  DB cluster that you want to promote to primary for the global database.

"""
function failover_global_cluster(
    GlobalClusterIdentifier,
    TargetDbClusterIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "FailoverGlobalCluster",
        Dict{String,Any}(
            "GlobalClusterIdentifier" => GlobalClusterIdentifier,
            "TargetDbClusterIdentifier" => TargetDbClusterIdentifier,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function failover_global_cluster(
    GlobalClusterIdentifier,
    TargetDbClusterIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "FailoverGlobalCluster",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "GlobalClusterIdentifier" => GlobalClusterIdentifier,
                    "TargetDbClusterIdentifier" => TargetDbClusterIdentifier,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_name)
    list_tags_for_resource(resource_name, params::Dict{String,<:Any})

Lists all tags on an Amazon Neptune resource.

# Arguments
- `resource_name`: The Amazon Neptune resource with tags to be listed. This value is an
  Amazon Resource Name (ARN). For information about creating an ARN, see  Constructing an
  Amazon Resource Name (ARN).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: This parameter is not currently supported.
"""
function list_tags_for_resource(
    ResourceName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptune(
        "ListTagsForResource",
        Dict{String,Any}("ResourceName" => ResourceName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceName" => ResourceName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    modify_dbcluster(dbcluster_identifier)
    modify_dbcluster(dbcluster_identifier, params::Dict{String,<:Any})

Modify a setting for a DB cluster. You can change one or more database configuration
parameters by specifying these parameters and the new values in the request.

# Arguments
- `dbcluster_identifier`: The DB cluster identifier for the cluster being modified. This
  parameter is not case-sensitive. Constraints:   Must match the identifier of an existing
  DBCluster.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AllowMajorVersionUpgrade"`: A value that indicates whether upgrades between different
  major versions are allowed. Constraints: You must set the allow-major-version-upgrade flag
  when providing an EngineVersion parameter that uses a different major version than the DB
  cluster's current version.
- `"ApplyImmediately"`: A value that specifies whether the modifications in this request
  and any pending modifications are asynchronously applied as soon as possible, regardless of
  the PreferredMaintenanceWindow setting for the DB cluster. If this parameter is set to
  false, changes to the DB cluster are applied during the next maintenance window. The
  ApplyImmediately parameter only affects NewDBClusterIdentifier values. If you set the
  ApplyImmediately parameter value to false, then changes to NewDBClusterIdentifier values
  are applied during the next maintenance window. All other changes are applied immediately,
  regardless of the value of the ApplyImmediately parameter. Default: false
- `"BackupRetentionPeriod"`: The number of days for which automated backups are retained.
  You must specify a minimum value of 1. Default: 1 Constraints:   Must be a value from 1 to
  35
- `"CloudwatchLogsExportConfiguration"`: The configuration setting for the log types to be
  enabled for export to CloudWatch Logs for a specific DB cluster. See Using the CLI to
  publish Neptune audit logs to CloudWatch Logs.
- `"CopyTagsToSnapshot"`:  If set to true, tags are copied to any snapshot of the DB
  cluster that is created.
- `"DBClusterParameterGroupName"`: The name of the DB cluster parameter group to use for
  the DB cluster.
- `"DBInstanceParameterGroupName"`: The name of the DB parameter group to apply to all
  instances of the DB cluster.   When you apply a parameter group using
  DBInstanceParameterGroupName, parameter changes aren't applied during the next maintenance
  window but instead are applied immediately.  Default: The existing name setting
  Constraints:   The DB parameter group must be in the same DB parameter group family as the
  target DB cluster version.   The DBInstanceParameterGroupName parameter is only valid in
  combination with the AllowMajorVersionUpgrade parameter.
- `"DeletionProtection"`: A value that indicates whether the DB cluster has deletion
  protection enabled. The database can't be deleted when deletion protection is enabled. By
  default, deletion protection is disabled.
- `"EnableIAMDatabaseAuthentication"`: True to enable mapping of Amazon Identity and Access
  Management (IAM) accounts to database accounts, and otherwise false. Default: false
- `"EngineVersion"`: The version number of the database engine to which you want to
  upgrade. Changing this parameter results in an outage. The change is applied during the
  next maintenance window unless the ApplyImmediately parameter is set to true. For a list of
  valid engine versions, see Engine Releases for Amazon Neptune, or call
  DescribeDBEngineVersions.
- `"MasterUserPassword"`: Not supported by Neptune.
- `"NewDBClusterIdentifier"`: The new DB cluster identifier for the DB cluster when
  renaming a DB cluster. This value is stored as a lowercase string. Constraints:   Must
  contain from 1 to 63 letters, numbers, or hyphens   The first character must be a letter
  Cannot end with a hyphen or contain two consecutive hyphens   Example: my-cluster2
- `"OptionGroupName"`:  Not supported by Neptune.
- `"Port"`: The port number on which the DB cluster accepts connections. Constraints: Value
  must be 1150-65535  Default: The same port as the original DB cluster.
- `"PreferredBackupWindow"`: The daily time range during which automated backups are
  created if automated backups are enabled, using the BackupRetentionPeriod parameter. The
  default is a 30-minute window selected at random from an 8-hour block of time for each
  Amazon Region. Constraints:   Must be in the format hh24:mi-hh24:mi.   Must be in Universal
  Coordinated Time (UTC).   Must not conflict with the preferred maintenance window.   Must
  be at least 30 minutes.
- `"PreferredMaintenanceWindow"`: The weekly time range during which system maintenance can
  occur, in Universal Coordinated Time (UTC). Format: ddd:hh24:mi-ddd:hh24:mi  The default is
  a 30-minute window selected at random from an 8-hour block of time for each Amazon Region,
  occurring on a random day of the week. Valid Days: Mon, Tue, Wed, Thu, Fri, Sat, Sun.
  Constraints: Minimum 30-minute window.
- `"ServerlessV2ScalingConfiguration"`: Contains the scaling configuration of a Neptune
  Serverless DB cluster. For more information, see Using Amazon Neptune Serverless in the
  Amazon Neptune User Guide.
- `"StorageType"`: The storage type to associate with the DB cluster. Valid Values:
  standard | iopt1    Default:    standard
- `"VpcSecurityGroupIds"`: A list of VPC security groups that the DB cluster will belong to.
"""
function modify_dbcluster(
    DBClusterIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptune(
        "ModifyDBCluster",
        Dict{String,Any}("DBClusterIdentifier" => DBClusterIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function modify_dbcluster(
    DBClusterIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "ModifyDBCluster",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DBClusterIdentifier" => DBClusterIdentifier),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    modify_dbcluster_endpoint(dbcluster_endpoint_identifier)
    modify_dbcluster_endpoint(dbcluster_endpoint_identifier, params::Dict{String,<:Any})

Modifies the properties of an endpoint in an Amazon Neptune DB cluster.

# Arguments
- `dbcluster_endpoint_identifier`: The identifier of the endpoint to modify. This parameter
  is stored as a lowercase string.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EndpointType"`: The type of the endpoint. One of: READER, WRITER, ANY.
- `"ExcludedMembers"`: List of DB instance identifiers that aren't part of the custom
  endpoint group. All other eligible instances are reachable through the custom endpoint.
  Only relevant if the list of static members is empty.
- `"StaticMembers"`: List of DB instance identifiers that are part of the custom endpoint
  group.
"""
function modify_dbcluster_endpoint(
    DBClusterEndpointIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptune(
        "ModifyDBClusterEndpoint",
        Dict{String,Any}("DBClusterEndpointIdentifier" => DBClusterEndpointIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function modify_dbcluster_endpoint(
    DBClusterEndpointIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "ModifyDBClusterEndpoint",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DBClusterEndpointIdentifier" => DBClusterEndpointIdentifier
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    modify_dbcluster_parameter_group(dbcluster_parameter_group_name, parameter)
    modify_dbcluster_parameter_group(dbcluster_parameter_group_name, parameter, params::Dict{String,<:Any})

 Modifies the parameters of a DB cluster parameter group. To modify more than one
parameter, submit a list of the following: ParameterName, ParameterValue, and ApplyMethod.
A maximum of 20 parameters can be modified in a single request.  Changes to dynamic
parameters are applied immediately. Changes to static parameters require a reboot without
failover to the DB cluster associated with the parameter group before the change can take
effect.   After you create a DB cluster parameter group, you should wait at least 5 minutes
before creating your first DB cluster that uses that DB cluster parameter group as the
default parameter group. This allows Amazon Neptune to fully complete the create action
before the parameter group is used as the default for a new DB cluster. This is especially
important for parameters that are critical when creating the default database for a DB
cluster, such as the character set for the default database defined by the
character_set_database parameter. You can use the Parameter Groups option of the Amazon
Neptune console or the DescribeDBClusterParameters command to verify that your DB cluster
parameter group has been created or modified.

# Arguments
- `dbcluster_parameter_group_name`: The name of the DB cluster parameter group to modify.
- `parameter`: A list of parameters in the DB cluster parameter group to modify.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Parameters"`: A list of parameters in the DB cluster parameter group to modify.
"""
function modify_dbcluster_parameter_group(
    DBClusterParameterGroupName,
    Parameter;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "ModifyDBClusterParameterGroup",
        Dict{String,Any}(
            "DBClusterParameterGroupName" => DBClusterParameterGroupName,
            "Parameter" => Parameter,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function modify_dbcluster_parameter_group(
    DBClusterParameterGroupName,
    Parameter,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "ModifyDBClusterParameterGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DBClusterParameterGroupName" => DBClusterParameterGroupName,
                    "Parameter" => Parameter,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    modify_dbcluster_snapshot_attribute(attribute_name, dbcluster_snapshot_identifier)
    modify_dbcluster_snapshot_attribute(attribute_name, dbcluster_snapshot_identifier, params::Dict{String,<:Any})

Adds an attribute and values to, or removes an attribute and values from, a manual DB
cluster snapshot. To share a manual DB cluster snapshot with other Amazon accounts, specify
restore as the AttributeName and use the ValuesToAdd parameter to add a list of IDs of the
Amazon accounts that are authorized to restore the manual DB cluster snapshot. Use the
value all to make the manual DB cluster snapshot public, which means that it can be copied
or restored by all Amazon accounts. Do not add the all value for any manual DB cluster
snapshots that contain private information that you don't want available to all Amazon
accounts. If a manual DB cluster snapshot is encrypted, it can be shared, but only by
specifying a list of authorized Amazon account IDs for the ValuesToAdd parameter. You can't
use all as a value for that parameter in this case. To view which Amazon accounts have
access to copy or restore a manual DB cluster snapshot, or whether a manual DB cluster
snapshot public or private, use the DescribeDBClusterSnapshotAttributes API action.

# Arguments
- `attribute_name`: The name of the DB cluster snapshot attribute to modify. To manage
  authorization for other Amazon accounts to copy or restore a manual DB cluster snapshot,
  set this value to restore.
- `dbcluster_snapshot_identifier`: The identifier for the DB cluster snapshot to modify the
  attributes for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ValuesToAdd"`: A list of DB cluster snapshot attributes to add to the attribute
  specified by AttributeName. To authorize other Amazon accounts to copy or restore a manual
  DB cluster snapshot, set this list to include one or more Amazon account IDs, or all to
  make the manual DB cluster snapshot restorable by any Amazon account. Do not add the all
  value for any manual DB cluster snapshots that contain private information that you don't
  want available to all Amazon accounts.
- `"ValuesToRemove"`: A list of DB cluster snapshot attributes to remove from the attribute
  specified by AttributeName. To remove authorization for other Amazon accounts to copy or
  restore a manual DB cluster snapshot, set this list to include one or more Amazon account
  identifiers, or all to remove authorization for any Amazon account to copy or restore the
  DB cluster snapshot. If you specify all, an Amazon account whose account ID is explicitly
  added to the restore attribute can still copy or restore a manual DB cluster snapshot.
"""
function modify_dbcluster_snapshot_attribute(
    AttributeName,
    DBClusterSnapshotIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "ModifyDBClusterSnapshotAttribute",
        Dict{String,Any}(
            "AttributeName" => AttributeName,
            "DBClusterSnapshotIdentifier" => DBClusterSnapshotIdentifier,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function modify_dbcluster_snapshot_attribute(
    AttributeName,
    DBClusterSnapshotIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "ModifyDBClusterSnapshotAttribute",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AttributeName" => AttributeName,
                    "DBClusterSnapshotIdentifier" => DBClusterSnapshotIdentifier,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    modify_dbinstance(dbinstance_identifier)
    modify_dbinstance(dbinstance_identifier, params::Dict{String,<:Any})

Modifies settings for a DB instance. You can change one or more database configuration
parameters by specifying these parameters and the new values in the request. To learn what
modifications you can make to your DB instance, call DescribeValidDBInstanceModifications
before you call ModifyDBInstance.

# Arguments
- `dbinstance_identifier`: The DB instance identifier. This value is stored as a lowercase
  string. Constraints:   Must match the identifier of an existing DBInstance.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AllocatedStorage"`: Not supported by Neptune.
- `"AllowMajorVersionUpgrade"`: Indicates that major version upgrades are allowed. Changing
  this parameter doesn't result in an outage and the change is asynchronously applied as soon
  as possible.
- `"ApplyImmediately"`: Specifies whether the modifications in this request and any pending
  modifications are asynchronously applied as soon as possible, regardless of the
  PreferredMaintenanceWindow setting for the DB instance.  If this parameter is set to false,
  changes to the DB instance are applied during the next maintenance window. Some parameter
  changes can cause an outage and are applied on the next call to RebootDBInstance, or the
  next failure reboot. Default: false
- `"AutoMinorVersionUpgrade"`:  Indicates that minor version upgrades are applied
  automatically to the DB instance during the maintenance window. Changing this parameter
  doesn't result in an outage except in the following case and the change is asynchronously
  applied as soon as possible. An outage will result if this parameter is set to true during
  the maintenance window, and a newer minor version is available, and Neptune has enabled
  auto patching for that engine version.
- `"BackupRetentionPeriod"`: Not applicable. The retention period for automated backups is
  managed by the DB cluster. For more information, see ModifyDBCluster. Default: Uses
  existing setting
- `"CACertificateIdentifier"`: Indicates the certificate that needs to be associated with
  the instance.
- `"CloudwatchLogsExportConfiguration"`: The configuration setting for the log types to be
  enabled for export to CloudWatch Logs for a specific DB instance or DB cluster.
- `"CopyTagsToSnapshot"`: True to copy all tags from the DB instance to snapshots of the DB
  instance, and otherwise false. The default is false.
- `"DBInstanceClass"`: The new compute and memory capacity of the DB instance, for example,
  db.m4.large. Not all DB instance classes are available in all Amazon Regions. If you modify
  the DB instance class, an outage occurs during the change. The change is applied during the
  next maintenance window, unless ApplyImmediately is specified as true for this request.
  Default: Uses existing setting
- `"DBParameterGroupName"`: The name of the DB parameter group to apply to the DB instance.
  Changing this setting doesn't result in an outage. The parameter group name itself is
  changed immediately, but the actual parameter changes are not applied until you reboot the
  instance without failover. The db instance will NOT be rebooted automatically and the
  parameter changes will NOT be applied during the next maintenance window. Default: Uses
  existing setting Constraints: The DB parameter group must be in the same DB parameter group
  family as this DB instance.
- `"DBPortNumber"`: The port number on which the database accepts connections. The value of
  the DBPortNumber parameter must not match any of the port values specified for options in
  the option group for the DB instance. Your database will restart when you change the
  DBPortNumber value regardless of the value of the ApplyImmediately parameter.  Default:
  8182
- `"DBSecurityGroups"`: A list of DB security groups to authorize on this DB instance.
  Changing this setting doesn't result in an outage and the change is asynchronously applied
  as soon as possible. Constraints:   If supplied, must match existing DBSecurityGroups.
- `"DBSubnetGroupName"`: The new DB subnet group for the DB instance. You can use this
  parameter to move your DB instance to a different VPC. Changing the subnet group causes an
  outage during the change. The change is applied during the next maintenance window, unless
  you specify true for the ApplyImmediately parameter. Constraints: If supplied, must match
  the name of an existing DBSubnetGroup. Example: mySubnetGroup
- `"DeletionProtection"`: A value that indicates whether the DB instance has deletion
  protection enabled. The database can't be deleted when deletion protection is enabled. By
  default, deletion protection is disabled. See Deleting a DB Instance.
- `"Domain"`: Not supported.
- `"DomainIAMRoleName"`: Not supported
- `"EnableIAMDatabaseAuthentication"`: True to enable mapping of Amazon Identity and Access
  Management (IAM) accounts to database accounts, and otherwise false. You can enable IAM
  database authentication for the following database engines Not applicable. Mapping Amazon
  IAM accounts to database accounts is managed by the DB cluster. For more information, see
  ModifyDBCluster. Default: false
- `"EnablePerformanceInsights"`:  (Not supported by Neptune)
- `"EngineVersion"`: The version number of the database engine to upgrade to. Currently,
  setting this parameter has no effect. To upgrade your database engine to the most recent
  release, use the ApplyPendingMaintenanceAction API.
- `"Iops"`: The new Provisioned IOPS (I/O operations per second) value for the instance.
  Changing this setting doesn't result in an outage and the change is applied during the next
  maintenance window unless the ApplyImmediately parameter is set to true for this request.
  Default: Uses existing setting
- `"LicenseModel"`: Not supported by Neptune.
- `"MasterUserPassword"`: Not supported by Neptune.
- `"MonitoringInterval"`: The interval, in seconds, between points when Enhanced Monitoring
  metrics are collected for the DB instance. To disable collecting Enhanced Monitoring
  metrics, specify 0. The default is 0. If MonitoringRoleArn is specified, then you must also
  set MonitoringInterval to a value other than 0. Valid Values: 0, 1, 5, 10, 15, 30, 60
- `"MonitoringRoleArn"`: The ARN for the IAM role that permits Neptune to send enhanced
  monitoring metrics to Amazon CloudWatch Logs. For example,
  arn:aws:iam:123456789012:role/emaccess. If MonitoringInterval is set to a value other than
  0, then you must supply a MonitoringRoleArn value.
- `"MultiAZ"`: Specifies if the DB instance is a Multi-AZ deployment. Changing this
  parameter doesn't result in an outage and the change is applied during the next maintenance
  window unless the ApplyImmediately parameter is set to true for this request.
- `"NewDBInstanceIdentifier"`:  The new DB instance identifier for the DB instance when
  renaming a DB instance. When you change the DB instance identifier, an instance reboot will
  occur immediately if you set Apply Immediately to true, or will occur during the next
  maintenance window if Apply Immediately to false. This value is stored as a lowercase
  string. Constraints:   Must contain from 1 to 63 letters, numbers, or hyphens.   The first
  character must be a letter.   Cannot end with a hyphen or contain two consecutive hyphens.
   Example: mydbinstance
- `"OptionGroupName"`:  (Not supported by Neptune)
- `"PerformanceInsightsKMSKeyId"`:  (Not supported by Neptune)
- `"PreferredBackupWindow"`:  The daily time range during which automated backups are
  created if automated backups are enabled. Not applicable. The daily time range for creating
  automated backups is managed by the DB cluster. For more information, see ModifyDBCluster.
  Constraints:   Must be in the format hh24:mi-hh24:mi   Must be in Universal Time
  Coordinated (UTC)   Must not conflict with the preferred maintenance window   Must be at
  least 30 minutes
- `"PreferredMaintenanceWindow"`: The weekly time range (in UTC) during which system
  maintenance can occur, which might result in an outage. Changing this parameter doesn't
  result in an outage, except in the following situation, and the change is asynchronously
  applied as soon as possible. If there are pending actions that cause a reboot, and the
  maintenance window is changed to include the current time, then changing this parameter
  will cause a reboot of the DB instance. If moving this window to the current time, there
  must be at least 30 minutes between the current time and end of the window to ensure
  pending changes are applied. Default: Uses existing setting Format: ddd:hh24:mi-ddd:hh24:mi
  Valid Days: Mon | Tue | Wed | Thu | Fri | Sat | Sun Constraints: Must be at least 30 minutes
- `"PromotionTier"`: A value that specifies the order in which a Read Replica is promoted
  to the primary instance after a failure of the existing primary instance. Default: 1 Valid
  Values: 0 - 15
- `"PubliclyAccessible"`: This flag should no longer be used.
- `"StorageType"`: Not supported.
- `"TdeCredentialArn"`: The ARN from the key store with which to associate the instance for
  TDE encryption.
- `"TdeCredentialPassword"`: The password for the given ARN from the key store in order to
  access the device.
- `"VpcSecurityGroupIds"`: A list of EC2 VPC security groups to authorize on this DB
  instance. This change is asynchronously applied as soon as possible. Not applicable. The
  associated list of EC2 VPC security groups is managed by the DB cluster. For more
  information, see ModifyDBCluster. Constraints:   If supplied, must match existing
  VpcSecurityGroupIds.
"""
function modify_dbinstance(
    DBInstanceIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptune(
        "ModifyDBInstance",
        Dict{String,Any}("DBInstanceIdentifier" => DBInstanceIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function modify_dbinstance(
    DBInstanceIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "ModifyDBInstance",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DBInstanceIdentifier" => DBInstanceIdentifier),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    modify_dbparameter_group(dbparameter_group_name, parameter)
    modify_dbparameter_group(dbparameter_group_name, parameter, params::Dict{String,<:Any})

Modifies the parameters of a DB parameter group. To modify more than one parameter, submit
a list of the following: ParameterName, ParameterValue, and ApplyMethod. A maximum of 20
parameters can be modified in a single request.  Changes to dynamic parameters are applied
immediately. Changes to static parameters require a reboot without failover to the DB
instance associated with the parameter group before the change can take effect.   After you
modify a DB parameter group, you should wait at least 5 minutes before creating your first
DB instance that uses that DB parameter group as the default parameter group. This allows
Amazon Neptune to fully complete the modify action before the parameter group is used as
the default for a new DB instance. This is especially important for parameters that are
critical when creating the default database for a DB instance, such as the character set
for the default database defined by the character_set_database parameter. You can use the
Parameter Groups option of the Amazon Neptune console or the DescribeDBParameters command
to verify that your DB parameter group has been created or modified.

# Arguments
- `dbparameter_group_name`: The name of the DB parameter group. Constraints:   If supplied,
  must match the name of an existing DBParameterGroup.
- `parameter`: An array of parameter names, values, and the apply method for the parameter
  update. At least one parameter name, value, and apply method must be supplied; subsequent
  arguments are optional. A maximum of 20 parameters can be modified in a single request.
  Valid Values (for the application method): immediate | pending-reboot   You can use the
  immediate value with dynamic parameters only. You can use the pending-reboot value for both
  dynamic and static parameters, and changes are applied when you reboot the DB instance
  without failover.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Parameters"`: An array of parameter names, values, and the apply method for the
  parameter update. At least one parameter name, value, and apply method must be supplied;
  subsequent arguments are optional. A maximum of 20 parameters can be modified in a single
  request. Valid Values (for the application method): immediate | pending-reboot   You can
  use the immediate value with dynamic parameters only. You can use the pending-reboot value
  for both dynamic and static parameters, and changes are applied when you reboot the DB
  instance without failover.
"""
function modify_dbparameter_group(
    DBParameterGroupName, Parameter; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptune(
        "ModifyDBParameterGroup",
        Dict{String,Any}(
            "DBParameterGroupName" => DBParameterGroupName, "Parameter" => Parameter
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function modify_dbparameter_group(
    DBParameterGroupName,
    Parameter,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "ModifyDBParameterGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DBParameterGroupName" => DBParameterGroupName, "Parameter" => Parameter
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    modify_dbsubnet_group(dbsubnet_group_name, subnet_identifier)
    modify_dbsubnet_group(dbsubnet_group_name, subnet_identifier, params::Dict{String,<:Any})

Modifies an existing DB subnet group. DB subnet groups must contain at least one subnet in
at least two AZs in the Amazon Region.

# Arguments
- `dbsubnet_group_name`: The name for the DB subnet group. This value is stored as a
  lowercase string. You can't modify the default subnet group. Constraints: Must match the
  name of an existing DBSubnetGroup. Must not be default. Example: mySubnetgroup
- `subnet_identifier`: The EC2 subnet IDs for the DB subnet group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DBSubnetGroupDescription"`: The description for the DB subnet group.
- `"SubnetIds"`: The EC2 subnet IDs for the DB subnet group.
"""
function modify_dbsubnet_group(
    DBSubnetGroupName, SubnetIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptune(
        "ModifyDBSubnetGroup",
        Dict{String,Any}(
            "DBSubnetGroupName" => DBSubnetGroupName, "SubnetIdentifier" => SubnetIdentifier
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function modify_dbsubnet_group(
    DBSubnetGroupName,
    SubnetIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "ModifyDBSubnetGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DBSubnetGroupName" => DBSubnetGroupName,
                    "SubnetIdentifier" => SubnetIdentifier,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    modify_event_subscription(subscription_name)
    modify_event_subscription(subscription_name, params::Dict{String,<:Any})

Modifies an existing event notification subscription. Note that you can't modify the source
identifiers using this call; to change source identifiers for a subscription, use the
AddSourceIdentifierToSubscription and RemoveSourceIdentifierFromSubscription calls. You can
see a list of the event categories for a given SourceType by using the
DescribeEventCategories action.

# Arguments
- `subscription_name`: The name of the event notification subscription.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Enabled"`:  A Boolean value; set to true to activate the subscription.
- `"EventCategories"`:  A list of event categories for a SourceType that you want to
  subscribe to. You can see a list of the categories for a given SourceType by using the
  DescribeEventCategories action.
- `"SnsTopicArn"`: The Amazon Resource Name (ARN) of the SNS topic created for event
  notification. The ARN is created by Amazon SNS when you create a topic and subscribe to it.
- `"SourceType"`: The type of source that is generating the events. For example, if you
  want to be notified of events generated by a DB instance, you would set this parameter to
  db-instance. if this value is not specified, all events are returned. Valid values:
  db-instance | db-parameter-group | db-security-group | db-snapshot
"""
function modify_event_subscription(
    SubscriptionName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptune(
        "ModifyEventSubscription",
        Dict{String,Any}("SubscriptionName" => SubscriptionName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function modify_event_subscription(
    SubscriptionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "ModifyEventSubscription",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("SubscriptionName" => SubscriptionName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    modify_global_cluster(global_cluster_identifier)
    modify_global_cluster(global_cluster_identifier, params::Dict{String,<:Any})

Modify a setting for an Amazon Neptune global cluster. You can change one or more database
configuration parameters by specifying these parameters and their new values in the request.

# Arguments
- `global_cluster_identifier`: The DB cluster identifier for the global cluster being
  modified. This parameter is not case-sensitive. Constraints: Must match the identifier of
  an existing global database cluster.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AllowMajorVersionUpgrade"`: A value that indicates whether major version upgrades are
  allowed. Constraints: You must allow major version upgrades if you specify a value for the
  EngineVersion parameter that is a different major version than the DB cluster's current
  version. If you upgrade the major version of a global database, the cluster and DB instance
  parameter groups are set to the default parameter groups for the new version, so you will
  need to apply any custom parameter groups after completing the upgrade.
- `"DeletionProtection"`: Indicates whether the global database has deletion protection
  enabled. The global database cannot be deleted when deletion protection is enabled.
- `"EngineVersion"`: The version number of the database engine to which you want to
  upgrade. Changing this parameter will result in an outage. The change is applied during the
  next maintenance window unless ApplyImmediately is enabled. To list all of the available
  Neptune engine versions, use the following command:
- `"NewGlobalClusterIdentifier"`: A new cluster identifier to assign to the global
  database. This value is stored as a lowercase string. Constraints:   Must contain from 1 to
  63 letters, numbers, or hyphens.   The first character must be a letter.   Can't end with a
  hyphen or contain two consecutive hyphens   Example: my-cluster2
"""
function modify_global_cluster(
    GlobalClusterIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptune(
        "ModifyGlobalCluster",
        Dict{String,Any}("GlobalClusterIdentifier" => GlobalClusterIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function modify_global_cluster(
    GlobalClusterIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "ModifyGlobalCluster",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("GlobalClusterIdentifier" => GlobalClusterIdentifier),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    promote_read_replica_dbcluster(dbcluster_identifier)
    promote_read_replica_dbcluster(dbcluster_identifier, params::Dict{String,<:Any})

Not supported.

# Arguments
- `dbcluster_identifier`: Not supported.

"""
function promote_read_replica_dbcluster(
    DBClusterIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptune(
        "PromoteReadReplicaDBCluster",
        Dict{String,Any}("DBClusterIdentifier" => DBClusterIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function promote_read_replica_dbcluster(
    DBClusterIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "PromoteReadReplicaDBCluster",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DBClusterIdentifier" => DBClusterIdentifier),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    reboot_dbinstance(dbinstance_identifier)
    reboot_dbinstance(dbinstance_identifier, params::Dict{String,<:Any})

You might need to reboot your DB instance, usually for maintenance reasons. For example, if
you make certain modifications, or if you change the DB parameter group associated with the
DB instance, you must reboot the instance for the changes to take effect. Rebooting a DB
instance restarts the database engine service. Rebooting a DB instance results in a
momentary outage, during which the DB instance status is set to rebooting.

# Arguments
- `dbinstance_identifier`: The DB instance identifier. This parameter is stored as a
  lowercase string. Constraints:   Must match the identifier of an existing DBInstance.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ForceFailover"`:  When true, the reboot is conducted through a MultiAZ failover.
  Constraint: You can't specify true if the instance is not configured for MultiAZ.
"""
function reboot_dbinstance(
    DBInstanceIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptune(
        "RebootDBInstance",
        Dict{String,Any}("DBInstanceIdentifier" => DBInstanceIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function reboot_dbinstance(
    DBInstanceIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "RebootDBInstance",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DBInstanceIdentifier" => DBInstanceIdentifier),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_from_global_cluster(db_cluster_identifier, global_cluster_identifier)
    remove_from_global_cluster(db_cluster_identifier, global_cluster_identifier, params::Dict{String,<:Any})

Detaches a Neptune DB cluster from a Neptune global database. A secondary cluster becomes a
normal standalone cluster with read-write capability instead of being read-only, and no
longer receives data from a the primary cluster.

# Arguments
- `db_cluster_identifier`: The Amazon Resource Name (ARN) identifying the cluster to be
  detached from the Neptune global database cluster.
- `global_cluster_identifier`: The identifier of the Neptune global database from which to
  detach the specified Neptune DB cluster.

"""
function remove_from_global_cluster(
    DbClusterIdentifier,
    GlobalClusterIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "RemoveFromGlobalCluster",
        Dict{String,Any}(
            "DbClusterIdentifier" => DbClusterIdentifier,
            "GlobalClusterIdentifier" => GlobalClusterIdentifier,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_from_global_cluster(
    DbClusterIdentifier,
    GlobalClusterIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "RemoveFromGlobalCluster",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DbClusterIdentifier" => DbClusterIdentifier,
                    "GlobalClusterIdentifier" => GlobalClusterIdentifier,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_role_from_dbcluster(dbcluster_identifier, role_arn)
    remove_role_from_dbcluster(dbcluster_identifier, role_arn, params::Dict{String,<:Any})

Disassociates an Identity and Access Management (IAM) role from a DB cluster.

# Arguments
- `dbcluster_identifier`: The name of the DB cluster to disassociate the IAM role from.
- `role_arn`: The Amazon Resource Name (ARN) of the IAM role to disassociate from the DB
  cluster, for example arn:aws:iam::123456789012:role/NeptuneAccessRole.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FeatureName"`: The name of the feature for the DB cluster that the IAM role is to be
  disassociated from. For the list of supported feature names, see DescribeDBEngineVersions.
"""
function remove_role_from_dbcluster(
    DBClusterIdentifier, RoleArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptune(
        "RemoveRoleFromDBCluster",
        Dict{String,Any}(
            "DBClusterIdentifier" => DBClusterIdentifier, "RoleArn" => RoleArn
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_role_from_dbcluster(
    DBClusterIdentifier,
    RoleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "RemoveRoleFromDBCluster",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DBClusterIdentifier" => DBClusterIdentifier, "RoleArn" => RoleArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_source_identifier_from_subscription(source_identifier, subscription_name)
    remove_source_identifier_from_subscription(source_identifier, subscription_name, params::Dict{String,<:Any})

Removes a source identifier from an existing event notification subscription.

# Arguments
- `source_identifier`:  The source identifier to be removed from the subscription, such as
  the DB instance identifier for a DB instance or the name of a security group.
- `subscription_name`: The name of the event notification subscription you want to remove a
  source identifier from.

"""
function remove_source_identifier_from_subscription(
    SourceIdentifier, SubscriptionName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptune(
        "RemoveSourceIdentifierFromSubscription",
        Dict{String,Any}(
            "SourceIdentifier" => SourceIdentifier, "SubscriptionName" => SubscriptionName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_source_identifier_from_subscription(
    SourceIdentifier,
    SubscriptionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "RemoveSourceIdentifierFromSubscription",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "SourceIdentifier" => SourceIdentifier,
                    "SubscriptionName" => SubscriptionName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_tags_from_resource(resource_name, tag_keys)
    remove_tags_from_resource(resource_name, tag_keys, params::Dict{String,<:Any})

Removes metadata tags from an Amazon Neptune resource.

# Arguments
- `resource_name`: The Amazon Neptune resource that the tags are removed from. This value
  is an Amazon Resource Name (ARN). For information about creating an ARN, see  Constructing
  an Amazon Resource Name (ARN).
- `tag_keys`: The tag key (name) of the tag to be removed.

"""
function remove_tags_from_resource(
    ResourceName, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptune(
        "RemoveTagsFromResource",
        Dict{String,Any}("ResourceName" => ResourceName, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_tags_from_resource(
    ResourceName,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "RemoveTagsFromResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceName" => ResourceName, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    reset_dbcluster_parameter_group(dbcluster_parameter_group_name)
    reset_dbcluster_parameter_group(dbcluster_parameter_group_name, params::Dict{String,<:Any})

 Modifies the parameters of a DB cluster parameter group to the default value. To reset
specific parameters submit a list of the following: ParameterName and ApplyMethod. To reset
the entire DB cluster parameter group, specify the DBClusterParameterGroupName and
ResetAllParameters parameters.  When resetting the entire group, dynamic parameters are
updated immediately and static parameters are set to pending-reboot to take effect on the
next DB instance restart or RebootDBInstance request. You must call RebootDBInstance for
every DB instance in your DB cluster that you want the updated static parameter to apply to.

# Arguments
- `dbcluster_parameter_group_name`: The name of the DB cluster parameter group to reset.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Parameters"`: A list of parameter names in the DB cluster parameter group to reset to
  the default values. You can't use this parameter if the ResetAllParameters parameter is set
  to true.
- `"ResetAllParameters"`: A value that is set to true to reset all parameters in the DB
  cluster parameter group to their default values, and false otherwise. You can't use this
  parameter if there is a list of parameter names specified for the Parameters parameter.
"""
function reset_dbcluster_parameter_group(
    DBClusterParameterGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptune(
        "ResetDBClusterParameterGroup",
        Dict{String,Any}("DBClusterParameterGroupName" => DBClusterParameterGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function reset_dbcluster_parameter_group(
    DBClusterParameterGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "ResetDBClusterParameterGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DBClusterParameterGroupName" => DBClusterParameterGroupName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    reset_dbparameter_group(dbparameter_group_name)
    reset_dbparameter_group(dbparameter_group_name, params::Dict{String,<:Any})

Modifies the parameters of a DB parameter group to the engine/system default value. To
reset specific parameters, provide a list of the following: ParameterName and ApplyMethod.
To reset the entire DB parameter group, specify the DBParameterGroup name and
ResetAllParameters parameters. When resetting the entire group, dynamic parameters are
updated immediately and static parameters are set to pending-reboot to take effect on the
next DB instance restart or RebootDBInstance request.

# Arguments
- `dbparameter_group_name`: The name of the DB parameter group. Constraints:   Must match
  the name of an existing DBParameterGroup.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Parameters"`: To reset the entire DB parameter group, specify the DBParameterGroup name
  and ResetAllParameters parameters. To reset specific parameters, provide a list of the
  following: ParameterName and ApplyMethod. A maximum of 20 parameters can be modified in a
  single request. Valid Values (for Apply method): pending-reboot
- `"ResetAllParameters"`: Specifies whether (true) or not (false) to reset all parameters
  in the DB parameter group to default values. Default: true
"""
function reset_dbparameter_group(
    DBParameterGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptune(
        "ResetDBParameterGroup",
        Dict{String,Any}("DBParameterGroupName" => DBParameterGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function reset_dbparameter_group(
    DBParameterGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "ResetDBParameterGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DBParameterGroupName" => DBParameterGroupName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    restore_dbcluster_from_snapshot(dbcluster_identifier, engine, snapshot_identifier)
    restore_dbcluster_from_snapshot(dbcluster_identifier, engine, snapshot_identifier, params::Dict{String,<:Any})

Creates a new DB cluster from a DB snapshot or DB cluster snapshot. If a DB snapshot is
specified, the target DB cluster is created from the source DB snapshot with a default
configuration and default security group. If a DB cluster snapshot is specified, the target
DB cluster is created from the source DB cluster restore point with the same configuration
as the original source DB cluster, except that the new DB cluster is created with the
default security group.

# Arguments
- `dbcluster_identifier`: The name of the DB cluster to create from the DB snapshot or DB
  cluster snapshot. This parameter isn't case-sensitive. Constraints:   Must contain from 1
  to 63 letters, numbers, or hyphens   First character must be a letter   Cannot end with a
  hyphen or contain two consecutive hyphens   Example: my-snapshot-id
- `engine`: The database engine to use for the new DB cluster. Default: The same as source
  Constraint: Must be compatible with the engine of the source
- `snapshot_identifier`: The identifier for the DB snapshot or DB cluster snapshot to
  restore from. You can use either the name or the Amazon Resource Name (ARN) to specify a DB
  cluster snapshot. However, you can use only the ARN to specify a DB snapshot. Constraints:
   Must match the identifier of an existing Snapshot.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AvailabilityZones"`: Provides the list of EC2 Availability Zones that instances in the
  restored DB cluster can be created in.
- `"CopyTagsToSnapshot"`:  If set to true, tags are copied to any snapshot of the restored
  DB cluster that is created.
- `"DBClusterParameterGroupName"`: The name of the DB cluster parameter group to associate
  with the new DB cluster. Constraints:   If supplied, must match the name of an existing
  DBClusterParameterGroup.
- `"DBSubnetGroupName"`: The name of the DB subnet group to use for the new DB cluster.
  Constraints: If supplied, must match the name of an existing DBSubnetGroup. Example:
  mySubnetgroup
- `"DatabaseName"`: Not supported.
- `"DeletionProtection"`: A value that indicates whether the DB cluster has deletion
  protection enabled. The database can't be deleted when deletion protection is enabled. By
  default, deletion protection is disabled.
- `"EnableCloudwatchLogsExports"`: The list of logs that the restored DB cluster is to
  export to Amazon CloudWatch Logs.
- `"EnableIAMDatabaseAuthentication"`: True to enable mapping of Amazon Identity and Access
  Management (IAM) accounts to database accounts, and otherwise false. Default: false
- `"EngineVersion"`: The version of the database engine to use for the new DB cluster.
- `"KmsKeyId"`: The Amazon KMS key identifier to use when restoring an encrypted DB cluster
  from a DB snapshot or DB cluster snapshot. The KMS key identifier is the Amazon Resource
  Name (ARN) for the KMS encryption key. If you are restoring a DB cluster with the same
  Amazon account that owns the KMS encryption key used to encrypt the new DB cluster, then
  you can use the KMS key alias instead of the ARN for the KMS encryption key. If you do not
  specify a value for the KmsKeyId parameter, then the following will occur:   If the DB
  snapshot or DB cluster snapshot in SnapshotIdentifier is encrypted, then the restored DB
  cluster is encrypted using the KMS key that was used to encrypt the DB snapshot or DB
  cluster snapshot.   If the DB snapshot or DB cluster snapshot in SnapshotIdentifier is not
  encrypted, then the restored DB cluster is not encrypted.
- `"OptionGroupName"`:  (Not supported by Neptune)
- `"Port"`: The port number on which the new DB cluster accepts connections. Constraints:
  Value must be 1150-65535  Default: The same port as the original DB cluster.
- `"ServerlessV2ScalingConfiguration"`: Contains the scaling configuration of a Neptune
  Serverless DB cluster. For more information, see Using Amazon Neptune Serverless in the
  Amazon Neptune User Guide.
- `"StorageType"`: Specifies the storage type to be associated with the DB cluster. Valid
  values: standard, iopt1  Default: standard
- `"Tags"`: The tags to be assigned to the restored DB cluster.
- `"VpcSecurityGroupIds"`: A list of VPC security groups that the new DB cluster will
  belong to.
"""
function restore_dbcluster_from_snapshot(
    DBClusterIdentifier,
    Engine,
    SnapshotIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "RestoreDBClusterFromSnapshot",
        Dict{String,Any}(
            "DBClusterIdentifier" => DBClusterIdentifier,
            "Engine" => Engine,
            "SnapshotIdentifier" => SnapshotIdentifier,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function restore_dbcluster_from_snapshot(
    DBClusterIdentifier,
    Engine,
    SnapshotIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "RestoreDBClusterFromSnapshot",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DBClusterIdentifier" => DBClusterIdentifier,
                    "Engine" => Engine,
                    "SnapshotIdentifier" => SnapshotIdentifier,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    restore_dbcluster_to_point_in_time(dbcluster_identifier, source_dbcluster_identifier)
    restore_dbcluster_to_point_in_time(dbcluster_identifier, source_dbcluster_identifier, params::Dict{String,<:Any})

Restores a DB cluster to an arbitrary point in time. Users can restore to any point in time
before LatestRestorableTime for up to BackupRetentionPeriod days. The target DB cluster is
created from the source DB cluster with the same configuration as the original DB cluster,
except that the new DB cluster is created with the default DB security group.  This action
only restores the DB cluster, not the DB instances for that DB cluster. You must invoke the
CreateDBInstance action to create DB instances for the restored DB cluster, specifying the
identifier of the restored DB cluster in DBClusterIdentifier. You can create DB instances
only after the RestoreDBClusterToPointInTime action has completed and the DB cluster is
available.

# Arguments
- `dbcluster_identifier`: The name of the new DB cluster to be created. Constraints:   Must
  contain from 1 to 63 letters, numbers, or hyphens   First character must be a letter
  Cannot end with a hyphen or contain two consecutive hyphens
- `source_dbcluster_identifier`: The identifier of the source DB cluster from which to
  restore. Constraints:   Must match the identifier of an existing DBCluster.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DBClusterParameterGroupName"`: The name of the DB cluster parameter group to associate
  with the new DB cluster. Constraints:   If supplied, must match the name of an existing
  DBClusterParameterGroup.
- `"DBSubnetGroupName"`: The DB subnet group name to use for the new DB cluster.
  Constraints: If supplied, must match the name of an existing DBSubnetGroup. Example:
  mySubnetgroup
- `"DeletionProtection"`: A value that indicates whether the DB cluster has deletion
  protection enabled. The database can't be deleted when deletion protection is enabled. By
  default, deletion protection is disabled.
- `"EnableCloudwatchLogsExports"`: The list of logs that the restored DB cluster is to
  export to CloudWatch Logs.
- `"EnableIAMDatabaseAuthentication"`: True to enable mapping of Amazon Identity and Access
  Management (IAM) accounts to database accounts, and otherwise false. Default: false
- `"KmsKeyId"`: The Amazon KMS key identifier to use when restoring an encrypted DB cluster
  from an encrypted DB cluster. The KMS key identifier is the Amazon Resource Name (ARN) for
  the KMS encryption key. If you are restoring a DB cluster with the same Amazon account that
  owns the KMS encryption key used to encrypt the new DB cluster, then you can use the KMS
  key alias instead of the ARN for the KMS encryption key. You can restore to a new DB
  cluster and encrypt the new DB cluster with a KMS key that is different than the KMS key
  used to encrypt the source DB cluster. The new DB cluster is encrypted with the KMS key
  identified by the KmsKeyId parameter. If you do not specify a value for the KmsKeyId
  parameter, then the following will occur:   If the DB cluster is encrypted, then the
  restored DB cluster is encrypted using the KMS key that was used to encrypt the source DB
  cluster.   If the DB cluster is not encrypted, then the restored DB cluster is not
  encrypted.   If DBClusterIdentifier refers to a DB cluster that is not encrypted, then the
  restore request is rejected.
- `"OptionGroupName"`:  (Not supported by Neptune)
- `"Port"`: The port number on which the new DB cluster accepts connections. Constraints:
  Value must be 1150-65535  Default: The same port as the original DB cluster.
- `"RestoreToTime"`: The date and time to restore the DB cluster to. Valid Values: Value
  must be a time in Universal Coordinated Time (UTC) format Constraints:   Must be before the
  latest restorable time for the DB instance   Must be specified if UseLatestRestorableTime
  parameter is not provided   Cannot be specified if UseLatestRestorableTime parameter is
  true   Cannot be specified if RestoreType parameter is copy-on-write    Example:
  2015-03-07T23:45:00Z
- `"RestoreType"`: The type of restore to be performed. You can specify one of the
  following values:    full-copy - The new DB cluster is restored as a full copy of the
  source DB cluster.    copy-on-write - The new DB cluster is restored as a clone of the
  source DB cluster.   If you don't specify a RestoreType value, then the new DB cluster is
  restored as a full copy of the source DB cluster.
- `"ServerlessV2ScalingConfiguration"`: Contains the scaling configuration of a Neptune
  Serverless DB cluster. For more information, see Using Amazon Neptune Serverless in the
  Amazon Neptune User Guide.
- `"StorageType"`: Specifies the storage type to be associated with the DB cluster. Valid
  values: standard, iopt1  Default: standard
- `"Tags"`: The tags to be applied to the restored DB cluster.
- `"UseLatestRestorableTime"`: A value that is set to true to restore the DB cluster to the
  latest restorable backup time, and false otherwise. Default: false  Constraints: Cannot be
  specified if RestoreToTime parameter is provided.
- `"VpcSecurityGroupIds"`: A list of VPC security groups that the new DB cluster belongs to.
"""
function restore_dbcluster_to_point_in_time(
    DBClusterIdentifier,
    SourceDBClusterIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "RestoreDBClusterToPointInTime",
        Dict{String,Any}(
            "DBClusterIdentifier" => DBClusterIdentifier,
            "SourceDBClusterIdentifier" => SourceDBClusterIdentifier,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function restore_dbcluster_to_point_in_time(
    DBClusterIdentifier,
    SourceDBClusterIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "RestoreDBClusterToPointInTime",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DBClusterIdentifier" => DBClusterIdentifier,
                    "SourceDBClusterIdentifier" => SourceDBClusterIdentifier,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_dbcluster(dbcluster_identifier)
    start_dbcluster(dbcluster_identifier, params::Dict{String,<:Any})

Starts an Amazon Neptune DB cluster that was stopped using the Amazon console, the Amazon
CLI stop-db-cluster command, or the StopDBCluster API.

# Arguments
- `dbcluster_identifier`: The DB cluster identifier of the Neptune DB cluster to be
  started. This parameter is stored as a lowercase string.

"""
function start_dbcluster(
    DBClusterIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptune(
        "StartDBCluster",
        Dict{String,Any}("DBClusterIdentifier" => DBClusterIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_dbcluster(
    DBClusterIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "StartDBCluster",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DBClusterIdentifier" => DBClusterIdentifier),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_dbcluster(dbcluster_identifier)
    stop_dbcluster(dbcluster_identifier, params::Dict{String,<:Any})

Stops an Amazon Neptune DB cluster. When you stop a DB cluster, Neptune retains the DB
cluster's metadata, including its endpoints and DB parameter groups. Neptune also retains
the transaction logs so you can do a point-in-time restore if necessary.

# Arguments
- `dbcluster_identifier`: The DB cluster identifier of the Neptune DB cluster to be
  stopped. This parameter is stored as a lowercase string.

"""
function stop_dbcluster(
    DBClusterIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptune(
        "StopDBCluster",
        Dict{String,Any}("DBClusterIdentifier" => DBClusterIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_dbcluster(
    DBClusterIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptune(
        "StopDBCluster",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DBClusterIdentifier" => DBClusterIdentifier),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: firehose
using AWS.Compat
using AWS.UUIDs

"""
    create_delivery_stream(delivery_stream_name)
    create_delivery_stream(delivery_stream_name, params::Dict{String,<:Any})

Creates a Firehose delivery stream. By default, you can create up to 50 delivery streams
per Amazon Web Services Region. This is an asynchronous operation that immediately returns.
The initial status of the delivery stream is CREATING. After the delivery stream is
created, its status is ACTIVE and it now accepts data. If the delivery stream creation
fails, the status transitions to CREATING_FAILED. Attempts to send data to a delivery
stream that is not in the ACTIVE state cause an exception. To check the state of a delivery
stream, use DescribeDeliveryStream. If the status of a delivery stream is CREATING_FAILED,
this status doesn't change, and you can't invoke CreateDeliveryStream again on it. However,
you can invoke the DeleteDeliveryStream operation to delete it. A Firehose delivery stream
can be configured to receive records directly from providers using PutRecord or
PutRecordBatch, or it can be configured to use an existing Kinesis stream as its source. To
specify a Kinesis data stream as input, set the DeliveryStreamType parameter to
KinesisStreamAsSource, and provide the Kinesis stream Amazon Resource Name (ARN) and role
ARN in the KinesisStreamSourceConfiguration parameter. To create a delivery stream with
server-side encryption (SSE) enabled, include DeliveryStreamEncryptionConfigurationInput in
your request. This is optional. You can also invoke StartDeliveryStreamEncryption to turn
on SSE for an existing delivery stream that doesn't have SSE enabled. A delivery stream is
configured with a single destination, such as Amazon Simple Storage Service (Amazon S3),
Amazon Redshift, Amazon OpenSearch Service, Amazon OpenSearch Serverless, Splunk, and any
custom HTTP endpoint or HTTP endpoints owned by or supported by third-party service
providers, including Datadog, Dynatrace, LogicMonitor, MongoDB, New Relic, and Sumo Logic.
You must specify only one of the following destination configuration parameters:
ExtendedS3DestinationConfiguration, S3DestinationConfiguration,
ElasticsearchDestinationConfiguration, RedshiftDestinationConfiguration, or
SplunkDestinationConfiguration. When you specify S3DestinationConfiguration, you can also
provide the following optional values: BufferingHints, EncryptionConfiguration, and
CompressionFormat. By default, if no BufferingHints value is provided, Firehose buffers
data up to 5 MB or for 5 minutes, whichever condition is satisfied first. BufferingHints is
a hint, so there are some cases where the service cannot adhere to these conditions
strictly. For example, record boundaries might be such that the size is a little over or
under the configured buffering size. By default, no encryption is performed. We strongly
recommend that you enable encryption to ensure secure data storage in Amazon S3. A few
notes about Amazon Redshift as a destination:   An Amazon Redshift destination requires an
S3 bucket as intermediate location. Firehose first delivers data to Amazon S3 and then uses
COPY syntax to load data into an Amazon Redshift table. This is specified in the
RedshiftDestinationConfiguration.S3Configuration parameter.   The compression formats
SNAPPY or ZIP cannot be specified in RedshiftDestinationConfiguration.S3Configuration
because the Amazon Redshift COPY operation that reads from the S3 bucket doesn't support
these compression formats.   We strongly recommend that you use the user name and password
you provide exclusively with Firehose, and that the permissions for the account are
restricted for Amazon Redshift INSERT permissions.   Firehose assumes the IAM role that is
configured as part of the destination. The role should allow the Firehose principal to
assume the role, and the role should have permissions that allow the service to deliver the
data. For more information, see Grant Firehose Access to an Amazon S3 Destination in the
Amazon Firehose Developer Guide.

# Arguments
- `delivery_stream_name`: The name of the delivery stream. This name must be unique per
  Amazon Web Services account in the same Amazon Web Services Region. If the delivery streams
  are in different accounts or different Regions, you can have multiple delivery streams with
  the same name.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AmazonOpenSearchServerlessDestinationConfiguration"`: The destination in the Serverless
  offering for Amazon OpenSearch Service. You can specify only one destination.
- `"AmazonopensearchserviceDestinationConfiguration"`: The destination in Amazon OpenSearch
  Service. You can specify only one destination.
- `"DeliveryStreamEncryptionConfigurationInput"`: Used to specify the type and Amazon
  Resource Name (ARN) of the KMS key needed for Server-Side Encryption (SSE).
- `"DeliveryStreamType"`: The delivery stream type. This parameter can be one of the
  following values:    DirectPut: Provider applications access the delivery stream directly.
    KinesisStreamAsSource: The delivery stream uses a Kinesis data stream as a source.
- `"ElasticsearchDestinationConfiguration"`: The destination in Amazon ES. You can specify
  only one destination.
- `"ExtendedS3DestinationConfiguration"`: The destination in Amazon S3. You can specify
  only one destination.
- `"HttpEndpointDestinationConfiguration"`: Enables configuring Kinesis Firehose to deliver
  data to any HTTP endpoint destination. You can specify only one destination.
- `"KinesisStreamSourceConfiguration"`: When a Kinesis data stream is used as the source
  for the delivery stream, a KinesisStreamSourceConfiguration containing the Kinesis data
  stream Amazon Resource Name (ARN) and the role ARN for the source stream.
- `"MSKSourceConfiguration"`:
- `"RedshiftDestinationConfiguration"`: The destination in Amazon Redshift. You can specify
  only one destination.
- `"S3DestinationConfiguration"`: [Deprecated] The destination in Amazon S3. You can
  specify only one destination.
- `"SnowflakeDestinationConfiguration"`: Configure Snowflake destination
- `"SplunkDestinationConfiguration"`: The destination in Splunk. You can specify only one
  destination.
- `"Tags"`: A set of tags to assign to the delivery stream. A tag is a key-value pair that
  you can define and assign to Amazon Web Services resources. Tags are metadata. For example,
  you can add friendly names and descriptions or other types of information that can help you
  distinguish the delivery stream. For more information about tags, see Using Cost Allocation
  Tags in the Amazon Web Services Billing and Cost Management User Guide. You can specify up
  to 50 tags when creating a delivery stream. If you specify tags in the CreateDeliveryStream
  action, Amazon Data Firehose performs an additional authorization on the
  firehose:TagDeliveryStream action to verify if users have permissions to create tags. If
  you do not provide this permission, requests to create new Firehose delivery streams with
  IAM resource tags will fail with an AccessDeniedException such as following.
  AccessDeniedException  User: arn:aws:sts::x:assumed-role/x/x is not authorized to perform:
  firehose:TagDeliveryStream on resource: arn:aws:firehose:us-east-1:x:deliverystream/x with
  an explicit deny in an identity-based policy. For an example IAM policy, see Tag example.
"""
function create_delivery_stream(
    DeliveryStreamName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return firehose(
        "CreateDeliveryStream",
        Dict{String,Any}("DeliveryStreamName" => DeliveryStreamName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_delivery_stream(
    DeliveryStreamName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return firehose(
        "CreateDeliveryStream",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("DeliveryStreamName" => DeliveryStreamName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_delivery_stream(delivery_stream_name)
    delete_delivery_stream(delivery_stream_name, params::Dict{String,<:Any})

Deletes a delivery stream and its data. You can delete a delivery stream only if it is in
one of the following states: ACTIVE, DELETING, CREATING_FAILED, or DELETING_FAILED. You
can't delete a delivery stream that is in the CREATING state. To check the state of a
delivery stream, use DescribeDeliveryStream.  DeleteDeliveryStream is an asynchronous API.
When an API request to DeleteDeliveryStream succeeds, the delivery stream is marked for
deletion, and it goes into the DELETING state.While the delivery stream is in the DELETING
state, the service might continue to accept records, but it doesn't make any guarantees
with respect to delivering the data. Therefore, as a best practice, first stop any
applications that are sending records before you delete a delivery stream. Removal of a
delivery stream that is in the DELETING state is a low priority operation for the service.
A stream may remain in the DELETING state for several minutes. Therefore, as a best
practice, applications should not wait for streams in the DELETING state to be removed.

# Arguments
- `delivery_stream_name`: The name of the delivery stream.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AllowForceDelete"`: Set this to true if you want to delete the delivery stream even if
  Firehose is unable to retire the grant for the CMK. Firehose might be unable to retire the
  grant due to a customer error, such as when the CMK or the grant are in an invalid state.
  If you force deletion, you can then use the RevokeGrant operation to revoke the grant you
  gave to Firehose. If a failure to retire the grant happens due to an Amazon Web Services
  KMS issue, Firehose keeps retrying the delete operation. The default value is false.
"""
function delete_delivery_stream(
    DeliveryStreamName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return firehose(
        "DeleteDeliveryStream",
        Dict{String,Any}("DeliveryStreamName" => DeliveryStreamName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_delivery_stream(
    DeliveryStreamName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return firehose(
        "DeleteDeliveryStream",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("DeliveryStreamName" => DeliveryStreamName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_delivery_stream(delivery_stream_name)
    describe_delivery_stream(delivery_stream_name, params::Dict{String,<:Any})

Describes the specified delivery stream and its status. For example, after your delivery
stream is created, call DescribeDeliveryStream to see whether the delivery stream is ACTIVE
and therefore ready for data to be sent to it.  If the status of a delivery stream is
CREATING_FAILED, this status doesn't change, and you can't invoke CreateDeliveryStream
again on it. However, you can invoke the DeleteDeliveryStream operation to delete it. If
the status is DELETING_FAILED, you can force deletion by invoking DeleteDeliveryStream
again but with DeleteDeliveryStreamInputAllowForceDelete set to true.

# Arguments
- `delivery_stream_name`: The name of the delivery stream.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ExclusiveStartDestinationId"`: The ID of the destination to start returning the
  destination information. Firehose supports one destination per delivery stream.
- `"Limit"`: The limit on the number of destinations to return. You can have one
  destination per delivery stream.
"""
function describe_delivery_stream(
    DeliveryStreamName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return firehose(
        "DescribeDeliveryStream",
        Dict{String,Any}("DeliveryStreamName" => DeliveryStreamName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_delivery_stream(
    DeliveryStreamName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return firehose(
        "DescribeDeliveryStream",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("DeliveryStreamName" => DeliveryStreamName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_delivery_streams()
    list_delivery_streams(params::Dict{String,<:Any})

Lists your delivery streams in alphabetical order of their names. The number of delivery
streams might be too large to return using a single call to ListDeliveryStreams. You can
limit the number of delivery streams returned, using the Limit parameter. To determine
whether there are more delivery streams to list, check the value of HasMoreDeliveryStreams
in the output. If there are more delivery streams to list, you can request them by calling
this operation again and setting the ExclusiveStartDeliveryStreamName parameter to the name
of the last delivery stream returned in the last call.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DeliveryStreamType"`: The delivery stream type. This can be one of the following
  values:    DirectPut: Provider applications access the delivery stream directly.
  KinesisStreamAsSource: The delivery stream uses a Kinesis data stream as a source.   This
  parameter is optional. If this parameter is omitted, delivery streams of all types are
  returned.
- `"ExclusiveStartDeliveryStreamName"`: The list of delivery streams returned by this call
  to ListDeliveryStreams will start with the delivery stream whose name comes alphabetically
  immediately after the name you specify in ExclusiveStartDeliveryStreamName.
- `"Limit"`: The maximum number of delivery streams to list. The default value is 10.
"""
function list_delivery_streams(; aws_config::AbstractAWSConfig=current_aws_config())
    return firehose(
        "ListDeliveryStreams"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_delivery_streams(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return firehose(
        "ListDeliveryStreams",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_delivery_stream(delivery_stream_name)
    list_tags_for_delivery_stream(delivery_stream_name, params::Dict{String,<:Any})

Lists the tags for the specified delivery stream. This operation has a limit of five
transactions per second per account.

# Arguments
- `delivery_stream_name`: The name of the delivery stream whose tags you want to list.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ExclusiveStartTagKey"`: The key to use as the starting point for the list of tags. If
  you set this parameter, ListTagsForDeliveryStream gets all tags that occur after
  ExclusiveStartTagKey.
- `"Limit"`: The number of tags to return. If this number is less than the total number of
  tags associated with the delivery stream, HasMoreTags is set to true in the response. To
  list additional tags, set ExclusiveStartTagKey to the last key in the response.
"""
function list_tags_for_delivery_stream(
    DeliveryStreamName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return firehose(
        "ListTagsForDeliveryStream",
        Dict{String,Any}("DeliveryStreamName" => DeliveryStreamName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_delivery_stream(
    DeliveryStreamName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return firehose(
        "ListTagsForDeliveryStream",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("DeliveryStreamName" => DeliveryStreamName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_record(delivery_stream_name, record)
    put_record(delivery_stream_name, record, params::Dict{String,<:Any})

Writes a single data record into an Amazon Firehose delivery stream. To write multiple data
records into a delivery stream, use PutRecordBatch. Applications using these operations are
referred to as producers. By default, each delivery stream can take in up to 2,000
transactions per second, 5,000 records per second, or 5 MB per second. If you use PutRecord
and PutRecordBatch, the limits are an aggregate across these two operations for each
delivery stream. For more information about limits and how to request an increase, see
Amazon Firehose Limits.  Firehose accumulates and publishes a particular metric for a
customer account in one minute intervals. It is possible that the bursts of incoming
bytes/records ingested to a delivery stream last only for a few seconds. Due to this, the
actual spikes in the traffic might not be fully visible in the customer's 1 minute
CloudWatch metrics. You must specify the name of the delivery stream and the data record
when using PutRecord. The data record consists of a data blob that can be up to 1,000 KiB
in size, and any kind of data. For example, it can be a segment from a log file, geographic
location data, website clickstream data, and so on. Firehose buffers records before
delivering them to the destination. To disambiguate the data blobs at the destination, a
common solution is to use delimiters in the data, such as a newline (n) or some other
character unique within the data. This allows the consumer application to parse individual
data items when reading the data from the destination. The PutRecord operation returns a
RecordId, which is a unique string assigned to each record. Producer applications can use
this ID for purposes such as auditability and investigation. If the PutRecord operation
throws a ServiceUnavailableException, the API is automatically reinvoked (retried) 3 times.
If the exception persists, it is possible that the throughput limits have been exceeded for
the delivery stream.  Re-invoking the Put API operations (for example, PutRecord and
PutRecordBatch) can result in data duplicates. For larger data assets, allow for a longer
time out before retrying Put API operations. Data records sent to Firehose are stored for
24 hours from the time they are added to a delivery stream as it tries to send the records
to the destination. If the destination is unreachable for more than 24 hours, the data is
no longer available.  Don't concatenate two or more base64 strings to form the data fields
of your records. Instead, concatenate the raw data, then perform base64 encoding.

# Arguments
- `delivery_stream_name`: The name of the delivery stream.
- `record`: The record.

"""
function put_record(
    DeliveryStreamName, Record; aws_config::AbstractAWSConfig=current_aws_config()
)
    return firehose(
        "PutRecord",
        Dict{String,Any}("DeliveryStreamName" => DeliveryStreamName, "Record" => Record);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_record(
    DeliveryStreamName,
    Record,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return firehose(
        "PutRecord",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DeliveryStreamName" => DeliveryStreamName, "Record" => Record
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_record_batch(delivery_stream_name, records)
    put_record_batch(delivery_stream_name, records, params::Dict{String,<:Any})

Writes multiple data records into a delivery stream in a single call, which can achieve
higher throughput per producer than when writing single records. To write single data
records into a delivery stream, use PutRecord. Applications using these operations are
referred to as producers. Firehose accumulates and publishes a particular metric for a
customer account in one minute intervals. It is possible that the bursts of incoming
bytes/records ingested to a delivery stream last only for a few seconds. Due to this, the
actual spikes in the traffic might not be fully visible in the customer's 1 minute
CloudWatch metrics. For information about service quota, see Amazon Firehose Quota. Each
PutRecordBatch request supports up to 500 records. Each record in the request can be as
large as 1,000 KB (before base64 encoding), up to a limit of 4 MB for the entire request.
These limits cannot be changed. You must specify the name of the delivery stream and the
data record when using PutRecord. The data record consists of a data blob that can be up to
1,000 KB in size, and any kind of data. For example, it could be a segment from a log file,
geographic location data, website clickstream data, and so on. Firehose buffers records
before delivering them to the destination. To disambiguate the data blobs at the
destination, a common solution is to use delimiters in the data, such as a newline (n) or
some other character unique within the data. This allows the consumer application to parse
individual data items when reading the data from the destination. The PutRecordBatch
response includes a count of failed records, FailedPutCount, and an array of responses,
RequestResponses. Even if the PutRecordBatch call succeeds, the value of FailedPutCount may
be greater than 0, indicating that there are records for which the operation didn't
succeed. Each entry in the RequestResponses array provides additional information about the
processed record. It directly correlates with a record in the request array using the same
ordering, from the top to the bottom. The response array always includes the same number of
records as the request array. RequestResponses includes both successfully and
unsuccessfully processed records. Firehose tries to process all records in each
PutRecordBatch request. A single record failure does not stop the processing of subsequent
records.  A successfully processed record includes a RecordId value, which is unique for
the record. An unsuccessfully processed record includes ErrorCode and ErrorMessage values.
ErrorCode reflects the type of error, and is one of the following values:
ServiceUnavailableException or InternalFailure. ErrorMessage provides more detailed
information about the error. If there is an internal server error or a timeout, the write
might have completed or it might have failed. If FailedPutCount is greater than 0, retry
the request, resending only those records that might have failed processing. This minimizes
the possible duplicate records and also reduces the total bytes sent (and corresponding
charges). We recommend that you handle any duplicates at the destination. If PutRecordBatch
throws ServiceUnavailableException, the API is automatically reinvoked (retried) 3 times.
If the exception persists, it is possible that the throughput limits have been exceeded for
the delivery stream. Re-invoking the Put API operations (for example, PutRecord and
PutRecordBatch) can result in data duplicates. For larger data assets, allow for a longer
time out before retrying Put API operations. Data records sent to Firehose are stored for
24 hours from the time they are added to a delivery stream as it attempts to send the
records to the destination. If the destination is unreachable for more than 24 hours, the
data is no longer available.  Don't concatenate two or more base64 strings to form the data
fields of your records. Instead, concatenate the raw data, then perform base64 encoding.

# Arguments
- `delivery_stream_name`: The name of the delivery stream.
- `records`: One or more records.

"""
function put_record_batch(
    DeliveryStreamName, Records; aws_config::AbstractAWSConfig=current_aws_config()
)
    return firehose(
        "PutRecordBatch",
        Dict{String,Any}("DeliveryStreamName" => DeliveryStreamName, "Records" => Records);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_record_batch(
    DeliveryStreamName,
    Records,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return firehose(
        "PutRecordBatch",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DeliveryStreamName" => DeliveryStreamName, "Records" => Records
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_delivery_stream_encryption(delivery_stream_name)
    start_delivery_stream_encryption(delivery_stream_name, params::Dict{String,<:Any})

Enables server-side encryption (SSE) for the delivery stream.  This operation is
asynchronous. It returns immediately. When you invoke it, Firehose first sets the
encryption status of the stream to ENABLING, and then to ENABLED. The encryption status of
a delivery stream is the Status property in DeliveryStreamEncryptionConfiguration. If the
operation fails, the encryption status changes to ENABLING_FAILED. You can continue to read
and write data to your delivery stream while the encryption status is ENABLING, but the
data is not encrypted. It can take up to 5 seconds after the encryption status changes to
ENABLED before all records written to the delivery stream are encrypted. To find out
whether a record or a batch of records was encrypted, check the response elements
PutRecordOutputEncrypted and PutRecordBatchOutputEncrypted, respectively. To check the
encryption status of a delivery stream, use DescribeDeliveryStream. Even if encryption is
currently enabled for a delivery stream, you can still invoke this operation on it to
change the ARN of the CMK or both its type and ARN. If you invoke this method to change the
CMK, and the old CMK is of type CUSTOMER_MANAGED_CMK, Firehose schedules the grant it had
on the old CMK for retirement. If the new CMK is of type CUSTOMER_MANAGED_CMK, Firehose
creates a grant that enables it to use the new CMK to encrypt and decrypt data and to
manage the grant. For the KMS grant creation to be successful, the Firehose API operations
StartDeliveryStreamEncryption and CreateDeliveryStream should not be called with session
credentials that are more than 6 hours old. If a delivery stream already has encryption
enabled and then you invoke this operation to change the ARN of the CMK or both its type
and ARN and you get ENABLING_FAILED, this only means that the attempt to change the CMK
failed. In this case, encryption remains enabled with the old CMK. If the encryption status
of your delivery stream is ENABLING_FAILED, you can invoke this operation again with a
valid CMK. The CMK must be enabled and the key policy mustn't explicitly deny the
permission for Firehose to invoke KMS encrypt and decrypt operations. You can enable SSE
for a delivery stream only if it's a delivery stream that uses DirectPut as its source.
The StartDeliveryStreamEncryption and StopDeliveryStreamEncryption operations have a
combined limit of 25 calls per delivery stream per 24 hours. For example, you reach the
limit if you call StartDeliveryStreamEncryption 13 times and StopDeliveryStreamEncryption
12 times for the same delivery stream in a 24-hour period.

# Arguments
- `delivery_stream_name`: The name of the delivery stream for which you want to enable
  server-side encryption (SSE).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DeliveryStreamEncryptionConfigurationInput"`: Used to specify the type and Amazon
  Resource Name (ARN) of the KMS key needed for Server-Side Encryption (SSE).
"""
function start_delivery_stream_encryption(
    DeliveryStreamName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return firehose(
        "StartDeliveryStreamEncryption",
        Dict{String,Any}("DeliveryStreamName" => DeliveryStreamName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_delivery_stream_encryption(
    DeliveryStreamName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return firehose(
        "StartDeliveryStreamEncryption",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("DeliveryStreamName" => DeliveryStreamName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_delivery_stream_encryption(delivery_stream_name)
    stop_delivery_stream_encryption(delivery_stream_name, params::Dict{String,<:Any})

Disables server-side encryption (SSE) for the delivery stream.  This operation is
asynchronous. It returns immediately. When you invoke it, Firehose first sets the
encryption status of the stream to DISABLING, and then to DISABLED. You can continue to
read and write data to your stream while its status is DISABLING. It can take up to 5
seconds after the encryption status changes to DISABLED before all records written to the
delivery stream are no longer subject to encryption. To find out whether a record or a
batch of records was encrypted, check the response elements PutRecordOutputEncrypted and
PutRecordBatchOutputEncrypted, respectively. To check the encryption state of a delivery
stream, use DescribeDeliveryStream.  If SSE is enabled using a customer managed CMK and
then you invoke StopDeliveryStreamEncryption, Firehose schedules the related KMS grant for
retirement and then retires it after it ensures that it is finished delivering records to
the destination. The StartDeliveryStreamEncryption and StopDeliveryStreamEncryption
operations have a combined limit of 25 calls per delivery stream per 24 hours. For example,
you reach the limit if you call StartDeliveryStreamEncryption 13 times and
StopDeliveryStreamEncryption 12 times for the same delivery stream in a 24-hour period.

# Arguments
- `delivery_stream_name`: The name of the delivery stream for which you want to disable
  server-side encryption (SSE).

"""
function stop_delivery_stream_encryption(
    DeliveryStreamName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return firehose(
        "StopDeliveryStreamEncryption",
        Dict{String,Any}("DeliveryStreamName" => DeliveryStreamName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_delivery_stream_encryption(
    DeliveryStreamName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return firehose(
        "StopDeliveryStreamEncryption",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("DeliveryStreamName" => DeliveryStreamName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_delivery_stream(delivery_stream_name, tags)
    tag_delivery_stream(delivery_stream_name, tags, params::Dict{String,<:Any})

Adds or updates tags for the specified delivery stream. A tag is a key-value pair that you
can define and assign to Amazon Web Services resources. If you specify a tag that already
exists, the tag value is replaced with the value that you specify in the request. Tags are
metadata. For example, you can add friendly names and descriptions or other types of
information that can help you distinguish the delivery stream. For more information about
tags, see Using Cost Allocation Tags in the Amazon Web Services Billing and Cost Management
User Guide.  Each delivery stream can have up to 50 tags.  This operation has a limit of
five transactions per second per account.

# Arguments
- `delivery_stream_name`: The name of the delivery stream to which you want to add the tags.
- `tags`: A set of key-value pairs to use to create the tags.

"""
function tag_delivery_stream(
    DeliveryStreamName, Tags; aws_config::AbstractAWSConfig=current_aws_config()
)
    return firehose(
        "TagDeliveryStream",
        Dict{String,Any}("DeliveryStreamName" => DeliveryStreamName, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_delivery_stream(
    DeliveryStreamName,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return firehose(
        "TagDeliveryStream",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DeliveryStreamName" => DeliveryStreamName, "Tags" => Tags
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_delivery_stream(delivery_stream_name, tag_keys)
    untag_delivery_stream(delivery_stream_name, tag_keys, params::Dict{String,<:Any})

Removes tags from the specified delivery stream. Removed tags are deleted, and you can't
recover them after this operation successfully completes. If you specify a tag that doesn't
exist, the operation ignores it. This operation has a limit of five transactions per second
per account.

# Arguments
- `delivery_stream_name`: The name of the delivery stream.
- `tag_keys`: A list of tag keys. Each corresponding tag is removed from the delivery
  stream.

"""
function untag_delivery_stream(
    DeliveryStreamName, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return firehose(
        "UntagDeliveryStream",
        Dict{String,Any}("DeliveryStreamName" => DeliveryStreamName, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_delivery_stream(
    DeliveryStreamName,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return firehose(
        "UntagDeliveryStream",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DeliveryStreamName" => DeliveryStreamName, "TagKeys" => TagKeys
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_destination(current_delivery_stream_version_id, delivery_stream_name, destination_id)
    update_destination(current_delivery_stream_version_id, delivery_stream_name, destination_id, params::Dict{String,<:Any})

Updates the specified destination of the specified delivery stream. Use this operation to
change the destination type (for example, to replace the Amazon S3 destination with Amazon
Redshift) or change the parameters associated with a destination (for example, to change
the bucket name of the Amazon S3 destination). The update might not occur immediately. The
target delivery stream remains active while the configurations are updated, so data writes
to the delivery stream can continue during this process. The updated configurations are
usually effective within a few minutes. Switching between Amazon OpenSearch Service and
other services is not supported. For an Amazon OpenSearch Service destination, you can only
update to another Amazon OpenSearch Service destination. If the destination type is the
same, Firehose merges the configuration parameters specified with the destination
configuration that already exists on the delivery stream. If any of the parameters are not
specified in the call, the existing values are retained. For example, in the Amazon S3
destination, if EncryptionConfiguration is not specified, then the existing
EncryptionConfiguration is maintained on the destination. If the destination type is not
the same, for example, changing the destination from Amazon S3 to Amazon Redshift, Firehose
does not merge any parameters. In this case, all parameters must be specified. Firehose
uses CurrentDeliveryStreamVersionId to avoid race conditions and conflicting merges. This
is a required field, and the service updates the configuration only if the existing
configuration has a version ID that matches. After the update is applied successfully, the
version ID is updated, and can be retrieved using DescribeDeliveryStream. Use the new
version ID to set CurrentDeliveryStreamVersionId in the next call.

# Arguments
- `current_delivery_stream_version_id`: Obtain this value from the VersionId result of
  DeliveryStreamDescription. This value is required, and helps the service perform
  conditional operations. For example, if there is an interleaving update and this value is
  null, then the update destination fails. After the update is successful, the VersionId
  value is updated. The service then performs a merge of the old configuration with the new
  configuration.
- `delivery_stream_name`: The name of the delivery stream.
- `destination_id`: The ID of the destination.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AmazonOpenSearchServerlessDestinationUpdate"`: Describes an update for a destination in
  the Serverless offering for Amazon OpenSearch Service.
- `"AmazonopensearchserviceDestinationUpdate"`: Describes an update for a destination in
  Amazon OpenSearch Service.
- `"ElasticsearchDestinationUpdate"`: Describes an update for a destination in Amazon ES.
- `"ExtendedS3DestinationUpdate"`: Describes an update for a destination in Amazon S3.
- `"HttpEndpointDestinationUpdate"`: Describes an update to the specified HTTP endpoint
  destination.
- `"RedshiftDestinationUpdate"`: Describes an update for a destination in Amazon Redshift.
- `"S3DestinationUpdate"`: [Deprecated] Describes an update for a destination in Amazon S3.
- `"SnowflakeDestinationUpdate"`: Update to the Snowflake destination configuration
  settings.
- `"SplunkDestinationUpdate"`: Describes an update for a destination in Splunk.
"""
function update_destination(
    CurrentDeliveryStreamVersionId,
    DeliveryStreamName,
    DestinationId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return firehose(
        "UpdateDestination",
        Dict{String,Any}(
            "CurrentDeliveryStreamVersionId" => CurrentDeliveryStreamVersionId,
            "DeliveryStreamName" => DeliveryStreamName,
            "DestinationId" => DestinationId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_destination(
    CurrentDeliveryStreamVersionId,
    DeliveryStreamName,
    DestinationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return firehose(
        "UpdateDestination",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CurrentDeliveryStreamVersionId" => CurrentDeliveryStreamVersionId,
                    "DeliveryStreamName" => DeliveryStreamName,
                    "DestinationId" => DestinationId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: resiliencehub
using AWS.Compat
using AWS.UUIDs

"""
    add_draft_app_version_resource_mappings(app_arn, resource_mappings)
    add_draft_app_version_resource_mappings(app_arn, resource_mappings, params::Dict{String,<:Any})

Adds the source of resource-maps to the draft version of an application. During assessment,
Resilience Hub will use these resource-maps to resolve the latest physical ID for each
resource in the application template. For more information about different types of
resources suported by Resilience Hub and how to add them in your application, see Step 2:
How is your application managed? in the Resilience Hub User Guide.

# Arguments
- `app_arn`: Amazon Resource Name (ARN) of the Resilience Hub application. The format for
  this ARN is: arn:partition:resiliencehub:region:account:app/app-id. For more information
  about ARNs, see  Amazon Resource Names (ARNs) in the Amazon Web Services General Reference
  guide.
- `resource_mappings`: Mappings used to map logical resources from the template to physical
  resources. You can use the mapping type CFN_STACK if the application template uses a
  logical stack name. Or you can map individual resources by using the mapping type RESOURCE.
  We recommend using the mapping type CFN_STACK if the application is backed by a
  CloudFormation stack.

"""
function add_draft_app_version_resource_mappings(
    appArn, resourceMappings; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resiliencehub(
        "POST",
        "/add-draft-app-version-resource-mappings",
        Dict{String,Any}("appArn" => appArn, "resourceMappings" => resourceMappings);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_draft_app_version_resource_mappings(
    appArn,
    resourceMappings,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return resiliencehub(
        "POST",
        "/add-draft-app-version-resource-mappings",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "appArn" => appArn, "resourceMappings" => resourceMappings
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_update_recommendation_status(app_arn, request_entries)
    batch_update_recommendation_status(app_arn, request_entries, params::Dict{String,<:Any})

Enables you to include or exclude one or more operational recommendations.

# Arguments
- `app_arn`: Amazon Resource Name (ARN) of the Resilience Hub application. The format for
  this ARN is: arn:partition:resiliencehub:region:account:app/app-id. For more information
  about ARNs, see  Amazon Resource Names (ARNs) in the Amazon Web Services General Reference
  guide.
- `request_entries`: Defines the list of operational recommendations that need to be
  included or excluded.

"""
function batch_update_recommendation_status(
    appArn, requestEntries; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resiliencehub(
        "POST",
        "/batch-update-recommendation-status",
        Dict{String,Any}("appArn" => appArn, "requestEntries" => requestEntries);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_update_recommendation_status(
    appArn,
    requestEntries,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return resiliencehub(
        "POST",
        "/batch-update-recommendation-status",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("appArn" => appArn, "requestEntries" => requestEntries),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_app(name)
    create_app(name, params::Dict{String,<:Any})

Creates an Resilience Hub application. An Resilience Hub application is a collection of
Amazon Web Services resources structured to prevent and recover Amazon Web Services
application disruptions. To describe a Resilience Hub application, you provide an
application name, resources from one or more CloudFormation stacks, Resource Groups,
Terraform state files, AppRegistry applications, and an appropriate resiliency policy. In
addition, you can also add resources that are located on Amazon Elastic Kubernetes Service
(Amazon EKS) clusters as optional resources. For more information about the number of
resources supported per application, see Service quotas. After you create an Resilience Hub
application, you publish it so that you can run a resiliency assessment on it. You can then
use recommendations from the assessment to improve resiliency by running another
assessment, comparing results, and then iterating the process until you achieve your goals
for recovery time objective (RTO) and recovery point objective (RPO).

# Arguments
- `name`: Name of the application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"assessmentSchedule"`:  Assessment execution schedule with 'Daily' or 'Disabled' values.
- `"clientToken"`: Used for an idempotency token. A client token is a unique,
  case-sensitive string of up to 64 ASCII characters. You should not reuse the same client
  token for other API requests.
- `"description"`: The optional description for an app.
- `"eventSubscriptions"`: The list of events you would like to subscribe and get
  notification for. Currently, Resilience Hub supports only Drift detected and Scheduled
  assessment failure events notification.
- `"permissionModel"`: Defines the roles and credentials that Resilience Hub would use
  while creating the application, importing its resources, and running an assessment.
- `"policyArn"`: Amazon Resource Name (ARN) of the resiliency policy. The format for this
  ARN is: arn:partition:resiliencehub:region:account:resiliency-policy/policy-id. For more
  information about ARNs, see  Amazon Resource Names (ARNs) in the Amazon Web Services
  General Reference guide.
- `"tags"`: Tags assigned to the resource. A tag is a label that you assign to an Amazon
  Web Services resource. Each tag consists of a key/value pair.
"""
function create_app(name; aws_config::AbstractAWSConfig=current_aws_config())
    return resiliencehub(
        "POST",
        "/create-app",
        Dict{String,Any}("name" => name, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_app(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resiliencehub(
        "POST",
        "/create-app",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("name" => name, "clientToken" => string(uuid4())),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_app_version_app_component(app_arn, name, type)
    create_app_version_app_component(app_arn, name, type, params::Dict{String,<:Any})

Creates a new Application Component in the Resilience Hub application.  This API updates
the Resilience Hub application draft version. To use this Application Component for running
assessments, you must publish the Resilience Hub application using the PublishAppVersion
API.

# Arguments
- `app_arn`: Amazon Resource Name (ARN) of the Resilience Hub application. The format for
  this ARN is: arn:partition:resiliencehub:region:account:app/app-id. For more information
  about ARNs, see  Amazon Resource Names (ARNs) in the Amazon Web Services General Reference
  guide.
- `name`: Name of the Application Component.
- `type`: Type of Application Component. For more information about the types of
  Application Component, see Grouping resources in an AppComponent.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"additionalInfo"`: Currently, there is no supported additional information for
  Application Components.
- `"clientToken"`: Used for an idempotency token. A client token is a unique,
  case-sensitive string of up to 64 ASCII characters. You should not reuse the same client
  token for other API requests.
- `"id"`: Identifier of the Application Component.
"""
function create_app_version_app_component(
    appArn, name, type; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resiliencehub(
        "POST",
        "/create-app-version-app-component",
        Dict{String,Any}(
            "appArn" => appArn,
            "name" => name,
            "type" => type,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_app_version_app_component(
    appArn,
    name,
    type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return resiliencehub(
        "POST",
        "/create-app-version-app-component",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "appArn" => appArn,
                    "name" => name,
                    "type" => type,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_app_version_resource(app_arn, app_components, logical_resource_id, physical_resource_id, resource_type)
    create_app_version_resource(app_arn, app_components, logical_resource_id, physical_resource_id, resource_type, params::Dict{String,<:Any})

Adds a resource to the Resilience Hub application and assigns it to the specified
Application Components. If you specify a new Application Component, Resilience Hub will
automatically create the Application Component.    This action has no effect outside
Resilience Hub.   This API updates the Resilience Hub application draft version. To use
this resource for running resiliency assessments, you must publish the Resilience Hub
application using the PublishAppVersion API.   To update application version with new
physicalResourceID, you must call ResolveAppVersionResources API.

# Arguments
- `app_arn`: Amazon Resource Name (ARN) of the Resilience Hub application. The format for
  this ARN is: arn:partition:resiliencehub:region:account:app/app-id. For more information
  about ARNs, see  Amazon Resource Names (ARNs) in the Amazon Web Services General Reference
  guide.
- `app_components`: List of Application Components that this resource belongs to. If an
  Application Component is not part of the Resilience Hub application, it will be added.
- `logical_resource_id`: Logical identifier of the resource.
- `physical_resource_id`: Physical identifier of the resource.
- `resource_type`: Type of resource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"additionalInfo"`: Currently, there is no supported additional information for resources.
- `"awsAccountId"`: Amazon Web Services account that owns the physical resource.
- `"awsRegion"`: Amazon Web Services region that owns the physical resource.
- `"clientToken"`: Used for an idempotency token. A client token is a unique,
  case-sensitive string of up to 64 ASCII characters. You should not reuse the same client
  token for other API requests.
- `"resourceName"`: Name of the resource.
"""
function create_app_version_resource(
    appArn,
    appComponents,
    logicalResourceId,
    physicalResourceId,
    resourceType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return resiliencehub(
        "POST",
        "/create-app-version-resource",
        Dict{String,Any}(
            "appArn" => appArn,
            "appComponents" => appComponents,
            "logicalResourceId" => logicalResourceId,
            "physicalResourceId" => physicalResourceId,
            "resourceType" => resourceType,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_app_version_resource(
    appArn,
    appComponents,
    logicalResourceId,
    physicalResourceId,
    resourceType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return resiliencehub(
        "POST",
        "/create-app-version-resource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "appArn" => appArn,
                    "appComponents" => appComponents,
                    "logicalResourceId" => logicalResourceId,
                    "physicalResourceId" => physicalResourceId,
                    "resourceType" => resourceType,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_recommendation_template(assessment_arn, name)
    create_recommendation_template(assessment_arn, name, params::Dict{String,<:Any})

Creates a new recommendation template for the Resilience Hub application.

# Arguments
- `assessment_arn`: Amazon Resource Name (ARN) of the assessment. The format for this ARN
  is: arn:partition:resiliencehub:region:account:app-assessment/app-id. For more information
  about ARNs, see  Amazon Resource Names (ARNs) in the Amazon Web Services General Reference
  guide.
- `name`: The name for the recommendation template.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"bucketName"`: The name of the Amazon S3 bucket that will contain the recommendation
  template.
- `"clientToken"`: Used for an idempotency token. A client token is a unique,
  case-sensitive string of up to 64 ASCII characters. You should not reuse the same client
  token for other API requests.
- `"format"`: The format for the recommendation template.  CfnJson  The template is
  CloudFormation JSON.  CfnYaml  The template is CloudFormation YAML.
- `"recommendationIds"`: Identifiers for the recommendations used to create a
  recommendation template.
- `"recommendationTypes"`: An array of strings that specify the recommendation template
  type or types.  Alarm  The template is an AlarmRecommendation template.  Sop  The template
  is a SopRecommendation template.  Test  The template is a TestRecommendation template.
- `"tags"`: Tags assigned to the resource. A tag is a label that you assign to an Amazon
  Web Services resource. Each tag consists of a key/value pair.
"""
function create_recommendation_template(
    assessmentArn, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resiliencehub(
        "POST",
        "/create-recommendation-template",
        Dict{String,Any}(
            "assessmentArn" => assessmentArn,
            "name" => name,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_recommendation_template(
    assessmentArn,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return resiliencehub(
        "POST",
        "/create-recommendation-template",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "assessmentArn" => assessmentArn,
                    "name" => name,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_resiliency_policy(policy, policy_name, tier)
    create_resiliency_policy(policy, policy_name, tier, params::Dict{String,<:Any})

Creates a resiliency policy for an application.  Resilience Hub allows you to provide a
value of zero for rtoInSecs and rpoInSecs of your resiliency policy. But, while assessing
your application, the lowest possible assessment result is near zero. Hence, if you provide
value zero for rtoInSecs and rpoInSecs, the estimated workload RTO and estimated workload
RPO result will be near zero and the Compliance status for your application will be set to
Policy breached.

# Arguments
- `policy`: The type of resiliency policy to be created, including the recovery time
  objective (RTO) and recovery point objective (RPO) in seconds.
- `policy_name`: The name of the policy
- `tier`: The tier for this resiliency policy, ranging from the highest severity
  (MissionCritical) to lowest (NonCritical).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Used for an idempotency token. A client token is a unique,
  case-sensitive string of up to 64 ASCII characters. You should not reuse the same client
  token for other API requests.
- `"dataLocationConstraint"`: Specifies a high-level geographical location constraint for
  where your resilience policy data can be stored.
- `"policyDescription"`: The description for the policy.
- `"tags"`: Tags assigned to the resource. A tag is a label that you assign to an Amazon
  Web Services resource. Each tag consists of a key/value pair.
"""
function create_resiliency_policy(
    policy, policyName, tier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resiliencehub(
        "POST",
        "/create-resiliency-policy",
        Dict{String,Any}(
            "policy" => policy,
            "policyName" => policyName,
            "tier" => tier,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_resiliency_policy(
    policy,
    policyName,
    tier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return resiliencehub(
        "POST",
        "/create-resiliency-policy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "policy" => policy,
                    "policyName" => policyName,
                    "tier" => tier,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_app(app_arn)
    delete_app(app_arn, params::Dict{String,<:Any})

Deletes an Resilience Hub application. This is a destructive action that can't be undone.

# Arguments
- `app_arn`: Amazon Resource Name (ARN) of the Resilience Hub application. The format for
  this ARN is: arn:partition:resiliencehub:region:account:app/app-id. For more information
  about ARNs, see  Amazon Resource Names (ARNs) in the Amazon Web Services General Reference
  guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Used for an idempotency token. A client token is a unique,
  case-sensitive string of up to 64 ASCII characters. You should not reuse the same client
  token for other API requests.
- `"forceDelete"`: A boolean option to force the deletion of an Resilience Hub application.
"""
function delete_app(appArn; aws_config::AbstractAWSConfig=current_aws_config())
    return resiliencehub(
        "POST",
        "/delete-app",
        Dict{String,Any}("appArn" => appArn, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_app(
    appArn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resiliencehub(
        "POST",
        "/delete-app",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("appArn" => appArn, "clientToken" => string(uuid4())),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_app_assessment(assessment_arn)
    delete_app_assessment(assessment_arn, params::Dict{String,<:Any})

Deletes an Resilience Hub application assessment. This is a destructive action that can't
be undone.

# Arguments
- `assessment_arn`: Amazon Resource Name (ARN) of the assessment. The format for this ARN
  is: arn:partition:resiliencehub:region:account:app-assessment/app-id. For more information
  about ARNs, see  Amazon Resource Names (ARNs) in the Amazon Web Services General Reference
  guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Used for an idempotency token. A client token is a unique,
  case-sensitive string of up to 64 ASCII characters. You should not reuse the same client
  token for other API requests.
"""
function delete_app_assessment(
    assessmentArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resiliencehub(
        "POST",
        "/delete-app-assessment",
        Dict{String,Any}(
            "assessmentArn" => assessmentArn, "clientToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_app_assessment(
    assessmentArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return resiliencehub(
        "POST",
        "/delete-app-assessment",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "assessmentArn" => assessmentArn, "clientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_app_input_source(app_arn)
    delete_app_input_source(app_arn, params::Dict{String,<:Any})

Deletes the input source and all of its imported resources from the Resilience Hub
application.

# Arguments
- `app_arn`: Amazon Resource Name (ARN) of the Resilience Hub application. The format for
  this ARN is: arn:partition:resiliencehub:region:account:app/app-id. For more information
  about ARNs, see  Amazon Resource Names (ARNs) in the Amazon Web Services General Reference
  guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Used for an idempotency token. A client token is a unique,
  case-sensitive string of up to 64 ASCII characters. You should not reuse the same client
  token for other API requests.
- `"eksSourceClusterNamespace"`: The namespace on your Amazon Elastic Kubernetes Service
  cluster that you want to delete from the Resilience Hub application.
- `"sourceArn"`: The Amazon Resource Name (ARN) of the imported resource you want to remove
  from the Resilience Hub application. For more information about ARNs, see  Amazon Resource
  Names (ARNs) in the Amazon Web Services General Reference guide.
- `"terraformSource"`: The imported Terraform s3 state ﬁle you want to remove from the
  Resilience Hub application.
"""
function delete_app_input_source(appArn; aws_config::AbstractAWSConfig=current_aws_config())
    return resiliencehub(
        "POST",
        "/delete-app-input-source",
        Dict{String,Any}("appArn" => appArn, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_app_input_source(
    appArn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resiliencehub(
        "POST",
        "/delete-app-input-source",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("appArn" => appArn, "clientToken" => string(uuid4())),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_app_version_app_component(app_arn, id)
    delete_app_version_app_component(app_arn, id, params::Dict{String,<:Any})

Deletes an Application Component from the Resilience Hub application.    This API updates
the Resilience Hub application draft version. To use this Application Component for running
assessments, you must publish the Resilience Hub application using the PublishAppVersion
API.   You will not be able to delete an Application Component if it has resources
associated with it.

# Arguments
- `app_arn`: Amazon Resource Name (ARN) of the Resilience Hub application. The format for
  this ARN is: arn:partition:resiliencehub:region:account:app/app-id. For more information
  about ARNs, see  Amazon Resource Names (ARNs) in the Amazon Web Services General Reference
  guide.
- `id`: Identifier of the Application Component.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Used for an idempotency token. A client token is a unique,
  case-sensitive string of up to 64 ASCII characters. You should not reuse the same client
  token for other API requests.
"""
function delete_app_version_app_component(
    appArn, id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resiliencehub(
        "POST",
        "/delete-app-version-app-component",
        Dict{String,Any}("appArn" => appArn, "id" => id, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_app_version_app_component(
    appArn,
    id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return resiliencehub(
        "POST",
        "/delete-app-version-app-component",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "appArn" => appArn, "id" => id, "clientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_app_version_resource(app_arn)
    delete_app_version_resource(app_arn, params::Dict{String,<:Any})

Deletes a resource from the Resilience Hub application.    You can only delete a manually
added resource. To exclude non-manually added resources, use the UpdateAppVersionResource
API.   This action has no effect outside Resilience Hub.   This API updates the Resilience
Hub application draft version. To use this resource for running resiliency assessments, you
must publish the Resilience Hub application using the PublishAppVersion API.

# Arguments
- `app_arn`: Amazon Resource Name (ARN) of the Resilience Hub application. The format for
  this ARN is: arn:partition:resiliencehub:region:account:app/app-id. For more information
  about ARNs, see  Amazon Resource Names (ARNs) in the Amazon Web Services General Reference
  guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"awsAccountId"`: Amazon Web Services account that owns the physical resource.
- `"awsRegion"`: Amazon Web Services region that owns the physical resource.
- `"clientToken"`: Used for an idempotency token. A client token is a unique,
  case-sensitive string of up to 64 ASCII characters. You should not reuse the same client
  token for other API requests.
- `"logicalResourceId"`: Logical identifier of the resource.
- `"physicalResourceId"`: Physical identifier of the resource.
- `"resourceName"`: Name of the resource.
"""
function delete_app_version_resource(
    appArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resiliencehub(
        "POST",
        "/delete-app-version-resource",
        Dict{String,Any}("appArn" => appArn, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_app_version_resource(
    appArn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resiliencehub(
        "POST",
        "/delete-app-version-resource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("appArn" => appArn, "clientToken" => string(uuid4())),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_recommendation_template(recommendation_template_arn)
    delete_recommendation_template(recommendation_template_arn, params::Dict{String,<:Any})

Deletes a recommendation template. This is a destructive action that can't be undone.

# Arguments
- `recommendation_template_arn`: The Amazon Resource Name (ARN) for a recommendation
  template.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Used for an idempotency token. A client token is a unique,
  case-sensitive string of up to 64 ASCII characters. You should not reuse the same client
  token for other API requests.
"""
function delete_recommendation_template(
    recommendationTemplateArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resiliencehub(
        "POST",
        "/delete-recommendation-template",
        Dict{String,Any}(
            "recommendationTemplateArn" => recommendationTemplateArn,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_recommendation_template(
    recommendationTemplateArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return resiliencehub(
        "POST",
        "/delete-recommendation-template",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "recommendationTemplateArn" => recommendationTemplateArn,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_resiliency_policy(policy_arn)
    delete_resiliency_policy(policy_arn, params::Dict{String,<:Any})

Deletes a resiliency policy. This is a destructive action that can't be undone.

# Arguments
- `policy_arn`: Amazon Resource Name (ARN) of the resiliency policy. The format for this
  ARN is: arn:partition:resiliencehub:region:account:resiliency-policy/policy-id. For more
  information about ARNs, see  Amazon Resource Names (ARNs) in the Amazon Web Services
  General Reference guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Used for an idempotency token. A client token is a unique,
  case-sensitive string of up to 64 ASCII characters. You should not reuse the same client
  token for other API requests.
"""
function delete_resiliency_policy(
    policyArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resiliencehub(
        "POST",
        "/delete-resiliency-policy",
        Dict{String,Any}("policyArn" => policyArn, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_resiliency_policy(
    policyArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return resiliencehub(
        "POST",
        "/delete-resiliency-policy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "policyArn" => policyArn, "clientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_app(app_arn)
    describe_app(app_arn, params::Dict{String,<:Any})

Describes an Resilience Hub application.

# Arguments
- `app_arn`: Amazon Resource Name (ARN) of the Resilience Hub application. The format for
  this ARN is: arn:partition:resiliencehub:region:account:app/app-id. For more information
  about ARNs, see  Amazon Resource Names (ARNs) in the Amazon Web Services General Reference
  guide.

"""
function describe_app(appArn; aws_config::AbstractAWSConfig=current_aws_config())
    return resiliencehub(
        "POST",
        "/describe-app",
        Dict{String,Any}("appArn" => appArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_app(
    appArn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resiliencehub(
        "POST",
        "/describe-app",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("appArn" => appArn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_app_assessment(assessment_arn)
    describe_app_assessment(assessment_arn, params::Dict{String,<:Any})

Describes an assessment for an Resilience Hub application.

# Arguments
- `assessment_arn`: Amazon Resource Name (ARN) of the assessment. The format for this ARN
  is: arn:partition:resiliencehub:region:account:app-assessment/app-id. For more information
  about ARNs, see  Amazon Resource Names (ARNs) in the Amazon Web Services General Reference
  guide.

"""
function describe_app_assessment(
    assessmentArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resiliencehub(
        "POST",
        "/describe-app-assessment",
        Dict{String,Any}("assessmentArn" => assessmentArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_app_assessment(
    assessmentArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return resiliencehub(
        "POST",
        "/describe-app-assessment",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("assessmentArn" => assessmentArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_app_version(app_arn, app_version)
    describe_app_version(app_arn, app_version, params::Dict{String,<:Any})

Describes the Resilience Hub application version.

# Arguments
- `app_arn`: Amazon Resource Name (ARN) of the Resilience Hub application. The format for
  this ARN is: arn:partition:resiliencehub:region:account:app/app-id. For more information
  about ARNs, see  Amazon Resource Names (ARNs) in the Amazon Web Services General Reference
  guide.
- `app_version`: Resilience Hub application version.

"""
function describe_app_version(
    appArn, appVersion; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resiliencehub(
        "POST",
        "/describe-app-version",
        Dict{String,Any}("appArn" => appArn, "appVersion" => appVersion);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_app_version(
    appArn,
    appVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return resiliencehub(
        "POST",
        "/describe-app-version",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("appArn" => appArn, "appVersion" => appVersion),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_app_version_app_component(app_arn, app_version, id)
    describe_app_version_app_component(app_arn, app_version, id, params::Dict{String,<:Any})

Describes an Application Component in the Resilience Hub application.

# Arguments
- `app_arn`: Amazon Resource Name (ARN) of the Resilience Hub application. The format for
  this ARN is: arn:partition:resiliencehub:region:account:app/app-id. For more information
  about ARNs, see  Amazon Resource Names (ARNs) in the Amazon Web Services General Reference
  guide.
- `app_version`: Resilience Hub application version.
- `id`: Identifier of the Application Component.

"""
function describe_app_version_app_component(
    appArn, appVersion, id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resiliencehub(
        "POST",
        "/describe-app-version-app-component",
        Dict{String,Any}("appArn" => appArn, "appVersion" => appVersion, "id" => id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_app_version_app_component(
    appArn,
    appVersion,
    id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return resiliencehub(
        "POST",
        "/describe-app-version-app-component",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "appArn" => appArn, "appVersion" => appVersion, "id" => id
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_app_version_resource(app_arn, app_version)
    describe_app_version_resource(app_arn, app_version, params::Dict{String,<:Any})

Describes a resource of the Resilience Hub application.  This API accepts only one of the
following parameters to descibe the resource:    resourceName     logicalResourceId
physicalResourceId (Along with physicalResourceId, you can also provide awsAccountId, and
awsRegion)

# Arguments
- `app_arn`: Amazon Resource Name (ARN) of the Resilience Hub application. The format for
  this ARN is: arn:partition:resiliencehub:region:account:app/app-id. For more information
  about ARNs, see  Amazon Resource Names (ARNs) in the Amazon Web Services General Reference
  guide.
- `app_version`: Resilience Hub application version.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"awsAccountId"`: Amazon Web Services account that owns the physical resource.
- `"awsRegion"`: Amazon Web Services region that owns the physical resource.
- `"logicalResourceId"`: Logical identifier of the resource.
- `"physicalResourceId"`: Physical identifier of the resource.
- `"resourceName"`: Name of the resource.
"""
function describe_app_version_resource(
    appArn, appVersion; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resiliencehub(
        "POST",
        "/describe-app-version-resource",
        Dict{String,Any}("appArn" => appArn, "appVersion" => appVersion);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_app_version_resource(
    appArn,
    appVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return resiliencehub(
        "POST",
        "/describe-app-version-resource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("appArn" => appArn, "appVersion" => appVersion),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_app_version_resources_resolution_status(app_arn, app_version)
    describe_app_version_resources_resolution_status(app_arn, app_version, params::Dict{String,<:Any})

Returns the resolution status for the specified resolution identifier for an application
version. If resolutionId is not specified, the current resolution status is returned.

# Arguments
- `app_arn`: Amazon Resource Name (ARN) of the Resilience Hub application. The format for
  this ARN is: arn:partition:resiliencehub:region:account:app/app-id. For more information
  about ARNs, see  Amazon Resource Names (ARNs) in the Amazon Web Services General Reference
  guide.
- `app_version`: The version of the application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"resolutionId"`: The identifier for a specific resolution.
"""
function describe_app_version_resources_resolution_status(
    appArn, appVersion; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resiliencehub(
        "POST",
        "/describe-app-version-resources-resolution-status",
        Dict{String,Any}("appArn" => appArn, "appVersion" => appVersion);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_app_version_resources_resolution_status(
    appArn,
    appVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return resiliencehub(
        "POST",
        "/describe-app-version-resources-resolution-status",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("appArn" => appArn, "appVersion" => appVersion),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_app_version_template(app_arn, app_version)
    describe_app_version_template(app_arn, app_version, params::Dict{String,<:Any})

Describes details about an Resilience Hub application.

# Arguments
- `app_arn`: Amazon Resource Name (ARN) of the Resilience Hub application. The format for
  this ARN is: arn:partition:resiliencehub:region:account:app/app-id. For more information
  about ARNs, see  Amazon Resource Names (ARNs) in the Amazon Web Services General Reference
  guide.
- `app_version`: The version of the application.

"""
function describe_app_version_template(
    appArn, appVersion; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resiliencehub(
        "POST",
        "/describe-app-version-template",
        Dict{String,Any}("appArn" => appArn, "appVersion" => appVersion);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_app_version_template(
    appArn,
    appVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return resiliencehub(
        "POST",
        "/describe-app-version-template",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("appArn" => appArn, "appVersion" => appVersion),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_draft_app_version_resources_import_status(app_arn)
    describe_draft_app_version_resources_import_status(app_arn, params::Dict{String,<:Any})

Describes the status of importing resources to an application version.  If you get a 404
error with ResourceImportStatusNotFoundAppMetadataException, you must call
importResourcesToDraftAppVersion after creating the application and before calling
describeDraftAppVersionResourcesImportStatus to obtain the status.

# Arguments
- `app_arn`: Amazon Resource Name (ARN) of the Resilience Hub application. The format for
  this ARN is: arn:partition:resiliencehub:region:account:app/app-id. For more information
  about ARNs, see  Amazon Resource Names (ARNs) in the Amazon Web Services General Reference
  guide.

"""
function describe_draft_app_version_resources_import_status(
    appArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resiliencehub(
        "POST",
        "/describe-draft-app-version-resources-import-status",
        Dict{String,Any}("appArn" => appArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_draft_app_version_resources_import_status(
    appArn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resiliencehub(
        "POST",
        "/describe-draft-app-version-resources-import-status",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("appArn" => appArn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_resiliency_policy(policy_arn)
    describe_resiliency_policy(policy_arn, params::Dict{String,<:Any})

Describes a specified resiliency policy for an Resilience Hub application. The returned
policy object includes creation time, data location constraints, the Amazon Resource Name
(ARN) for the policy, tags, tier, and more.

# Arguments
- `policy_arn`: Amazon Resource Name (ARN) of the resiliency policy. The format for this
  ARN is: arn:partition:resiliencehub:region:account:resiliency-policy/policy-id. For more
  information about ARNs, see  Amazon Resource Names (ARNs) in the Amazon Web Services
  General Reference guide.

"""
function describe_resiliency_policy(
    policyArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resiliencehub(
        "POST",
        "/describe-resiliency-policy",
        Dict{String,Any}("policyArn" => policyArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_resiliency_policy(
    policyArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return resiliencehub(
        "POST",
        "/describe-resiliency-policy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("policyArn" => policyArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    import_resources_to_draft_app_version(app_arn)
    import_resources_to_draft_app_version(app_arn, params::Dict{String,<:Any})

Imports resources to Resilience Hub application draft version from different input sources.
For more information about the input sources supported by Resilience Hub, see Discover the
structure and describe your Resilience Hub application.

# Arguments
- `app_arn`: Amazon Resource Name (ARN) of the Resilience Hub application. The format for
  this ARN is: arn:partition:resiliencehub:region:account:app/app-id. For more information
  about ARNs, see  Amazon Resource Names (ARNs) in the Amazon Web Services General Reference
  guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"eksSources"`: The input sources of the Amazon Elastic Kubernetes Service resources you
  need to import.
- `"importStrategy"`: The import strategy you would like to set to import resources into
  Resilience Hub application.
- `"sourceArns"`: The Amazon Resource Names (ARNs) for the resources.
- `"terraformSources"`:  A list of terraform file s3 URLs you need to import.
"""
function import_resources_to_draft_app_version(
    appArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resiliencehub(
        "POST",
        "/import-resources-to-draft-app-version",
        Dict{String,Any}("appArn" => appArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function import_resources_to_draft_app_version(
    appArn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resiliencehub(
        "POST",
        "/import-resources-to-draft-app-version",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("appArn" => appArn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_alarm_recommendations(assessment_arn)
    list_alarm_recommendations(assessment_arn, params::Dict{String,<:Any})

Lists the alarm recommendations for an Resilience Hub application.

# Arguments
- `assessment_arn`: Amazon Resource Name (ARN) of the assessment. The format for this ARN
  is: arn:partition:resiliencehub:region:account:app-assessment/app-id. For more information
  about ARNs, see  Amazon Resource Names (ARNs) in the Amazon Web Services General Reference
  guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Maximum number of results to include in the response. If more results
  exist than the specified MaxResults value, a token is included in the response so that the
  remaining results can be retrieved.
- `"nextToken"`: Null, or the token from a previous call to get the next set of results.
"""
function list_alarm_recommendations(
    assessmentArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resiliencehub(
        "POST",
        "/list-alarm-recommendations",
        Dict{String,Any}("assessmentArn" => assessmentArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_alarm_recommendations(
    assessmentArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return resiliencehub(
        "POST",
        "/list-alarm-recommendations",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("assessmentArn" => assessmentArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_app_assessment_compliance_drifts(assessment_arn)
    list_app_assessment_compliance_drifts(assessment_arn, params::Dict{String,<:Any})

List of compliance drifts that were detected while running an assessment.

# Arguments
- `assessment_arn`: Amazon Resource Name (ARN) of the assessment. The format for this ARN
  is: arn:partition:resiliencehub:region:account:app-assessment/app-id. For more information
  about ARNs, see  Amazon Resource Names (ARNs) in the Amazon Web Services General Reference
  guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Indicates the maximum number of applications requested.
- `"nextToken"`: Indicates the unique token number of the next application to be checked
  for compliance and regulatory requirements from the list of applications.
"""
function list_app_assessment_compliance_drifts(
    assessmentArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resiliencehub(
        "POST",
        "/list-app-assessment-compliance-drifts",
        Dict{String,Any}("assessmentArn" => assessmentArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_app_assessment_compliance_drifts(
    assessmentArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return resiliencehub(
        "POST",
        "/list-app-assessment-compliance-drifts",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("assessmentArn" => assessmentArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_app_assessment_resource_drifts(assessment_arn)
    list_app_assessment_resource_drifts(assessment_arn, params::Dict{String,<:Any})

Indicates the list of resource drifts that were detected while running an assessment.

# Arguments
- `assessment_arn`: Amazon Resource Name (ARN) of the assessment. The format for this ARN
  is: arn:partition:resiliencehub:region:account:app-assessment/app-id. For more information
  about ARNs, see  Amazon Resource Names (ARNs) in the Amazon Web Services General Reference
  guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Indicates the maximum number of drift results to include in the response.
  If more results exist than the specified MaxResults value, a token is included in the
  response so that the remaining results can be retrieved.
- `"nextToken"`: Null, or the token from a previous call to get the next set of results.
"""
function list_app_assessment_resource_drifts(
    assessmentArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resiliencehub(
        "POST",
        "/list-app-assessment-resource-drifts",
        Dict{String,Any}("assessmentArn" => assessmentArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_app_assessment_resource_drifts(
    assessmentArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return resiliencehub(
        "POST",
        "/list-app-assessment-resource-drifts",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("assessmentArn" => assessmentArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_app_assessments()
    list_app_assessments(params::Dict{String,<:Any})

Lists the assessments for an Resilience Hub application. You can use request parameters to
refine the results for the response object.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"appArn"`: Amazon Resource Name (ARN) of the Resilience Hub application. The format for
  this ARN is: arn:partition:resiliencehub:region:account:app/app-id. For more information
  about ARNs, see  Amazon Resource Names (ARNs) in the Amazon Web Services General Reference
  guide.
- `"assessmentName"`: The name for the assessment.
- `"assessmentStatus"`: The current status of the assessment for the resiliency policy.
- `"complianceStatus"`: The current status of compliance for the resiliency policy.
- `"invoker"`: Specifies the entity that invoked a specific assessment, either a User or
  the System.
- `"maxResults"`: Maximum number of results to include in the response. If more results
  exist than the specified MaxResults value, a token is included in the response so that the
  remaining results can be retrieved.
- `"nextToken"`: Null, or the token from a previous call to get the next set of results.
- `"reverseOrder"`: The default is to sort by ascending startTime. To sort by descending
  startTime, set reverseOrder to true.
"""
function list_app_assessments(; aws_config::AbstractAWSConfig=current_aws_config())
    return resiliencehub(
        "GET",
        "/list-app-assessments";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_app_assessments(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resiliencehub(
        "GET",
        "/list-app-assessments",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_app_component_compliances(assessment_arn)
    list_app_component_compliances(assessment_arn, params::Dict{String,<:Any})

Lists the compliances for an Resilience Hub Application Component.

# Arguments
- `assessment_arn`: Amazon Resource Name (ARN) of the assessment. The format for this ARN
  is: arn:partition:resiliencehub:region:account:app-assessment/app-id. For more information
  about ARNs, see  Amazon Resource Names (ARNs) in the Amazon Web Services General Reference
  guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Maximum number of results to include in the response. If more results
  exist than the specified MaxResults value, a token is included in the response so that the
  remaining results can be retrieved.
- `"nextToken"`: Null, or the token from a previous call to get the next set of results.
"""
function list_app_component_compliances(
    assessmentArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resiliencehub(
        "POST",
        "/list-app-component-compliances",
        Dict{String,Any}("assessmentArn" => assessmentArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_app_component_compliances(
    assessmentArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return resiliencehub(
        "POST",
        "/list-app-component-compliances",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("assessmentArn" => assessmentArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_app_component_recommendations(assessment_arn)
    list_app_component_recommendations(assessment_arn, params::Dict{String,<:Any})

Lists the recommendations for an Resilience Hub Application Component.

# Arguments
- `assessment_arn`: Amazon Resource Name (ARN) of the assessment. The format for this ARN
  is: arn:partition:resiliencehub:region:account:app-assessment/app-id. For more information
  about ARNs, see  Amazon Resource Names (ARNs) in the Amazon Web Services General Reference
  guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Maximum number of results to include in the response. If more results
  exist than the specified MaxResults value, a token is included in the response so that the
  remaining results can be retrieved.
- `"nextToken"`: Null, or the token from a previous call to get the next set of results.
"""
function list_app_component_recommendations(
    assessmentArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resiliencehub(
        "POST",
        "/list-app-component-recommendations",
        Dict{String,Any}("assessmentArn" => assessmentArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_app_component_recommendations(
    assessmentArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return resiliencehub(
        "POST",
        "/list-app-component-recommendations",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("assessmentArn" => assessmentArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_app_input_sources(app_arn, app_version)
    list_app_input_sources(app_arn, app_version, params::Dict{String,<:Any})

Lists all the input sources of the Resilience Hub application. For more information about
the input sources supported by Resilience Hub, see Discover the structure and describe your
Resilience Hub application.

# Arguments
- `app_arn`: Amazon Resource Name (ARN) of the Resilience Hub application. The format for
  this ARN is: arn:partition:resiliencehub:region:account:app/app-id. For more information
  about ARNs, see  Amazon Resource Names (ARNs) in the Amazon Web Services General Reference
  guide.
- `app_version`: Resilience Hub application version.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Maximum number of input sources to be displayed per Resilience Hub
  application.
- `"nextToken"`: Null, or the token from a previous call to get the next set of results.
"""
function list_app_input_sources(
    appArn, appVersion; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resiliencehub(
        "POST",
        "/list-app-input-sources",
        Dict{String,Any}("appArn" => appArn, "appVersion" => appVersion);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_app_input_sources(
    appArn,
    appVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return resiliencehub(
        "POST",
        "/list-app-input-sources",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("appArn" => appArn, "appVersion" => appVersion),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_app_version_app_components(app_arn, app_version)
    list_app_version_app_components(app_arn, app_version, params::Dict{String,<:Any})

Lists all the Application Components in the Resilience Hub application.

# Arguments
- `app_arn`: Amazon Resource Name (ARN) of the Resilience Hub application. The format for
  this ARN is: arn:partition:resiliencehub:region:account:app/app-id. For more information
  about ARNs, see  Amazon Resource Names (ARNs) in the Amazon Web Services General Reference
  guide.
- `app_version`: Version of the Application Component.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Maximum number of Application Components to be displayed per Resilience
  Hub application version.
- `"nextToken"`: Null, or the token from a previous call to get the next set of results.
"""
function list_app_version_app_components(
    appArn, appVersion; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resiliencehub(
        "POST",
        "/list-app-version-app-components",
        Dict{String,Any}("appArn" => appArn, "appVersion" => appVersion);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_app_version_app_components(
    appArn,
    appVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return resiliencehub(
        "POST",
        "/list-app-version-app-components",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("appArn" => appArn, "appVersion" => appVersion),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_app_version_resource_mappings(app_arn, app_version)
    list_app_version_resource_mappings(app_arn, app_version, params::Dict{String,<:Any})

Lists how the resources in an application version are mapped/sourced from. Mappings can be
physical resource identifiers, CloudFormation stacks, resource-groups, or an application
registry app.

# Arguments
- `app_arn`: Amazon Resource Name (ARN) of the Resilience Hub application. The format for
  this ARN is: arn:partition:resiliencehub:region:account:app/app-id. For more information
  about ARNs, see  Amazon Resource Names (ARNs) in the Amazon Web Services General Reference
  guide.
- `app_version`: The version of the application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Maximum number of results to include in the response. If more results
  exist than the specified MaxResults value, a token is included in the response so that the
  remaining results can be retrieved.
- `"nextToken"`: Null, or the token from a previous call to get the next set of results.
"""
function list_app_version_resource_mappings(
    appArn, appVersion; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resiliencehub(
        "POST",
        "/list-app-version-resource-mappings",
        Dict{String,Any}("appArn" => appArn, "appVersion" => appVersion);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_app_version_resource_mappings(
    appArn,
    appVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return resiliencehub(
        "POST",
        "/list-app-version-resource-mappings",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("appArn" => appArn, "appVersion" => appVersion),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_app_version_resources(app_arn, app_version)
    list_app_version_resources(app_arn, app_version, params::Dict{String,<:Any})

Lists all the resources in an Resilience Hub application.

# Arguments
- `app_arn`: Amazon Resource Name (ARN) of the Resilience Hub application. The format for
  this ARN is: arn:partition:resiliencehub:region:account:app/app-id. For more information
  about ARNs, see  Amazon Resource Names (ARNs) in the Amazon Web Services General Reference
  guide.
- `app_version`: The version of the application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Maximum number of results to include in the response. If more results
  exist than the specified MaxResults value, a token is included in the response so that the
  remaining results can be retrieved.
- `"nextToken"`: Null, or the token from a previous call to get the next set of results.
- `"resolutionId"`: The identifier for a specific resolution.
"""
function list_app_version_resources(
    appArn, appVersion; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resiliencehub(
        "POST",
        "/list-app-version-resources",
        Dict{String,Any}("appArn" => appArn, "appVersion" => appVersion);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_app_version_resources(
    appArn,
    appVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return resiliencehub(
        "POST",
        "/list-app-version-resources",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("appArn" => appArn, "appVersion" => appVersion),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_app_versions(app_arn)
    list_app_versions(app_arn, params::Dict{String,<:Any})

Lists the different versions for the Resilience Hub applications.

# Arguments
- `app_arn`: Amazon Resource Name (ARN) of the Resilience Hub application. The format for
  this ARN is: arn:partition:resiliencehub:region:account:app/app-id. For more information
  about ARNs, see  Amazon Resource Names (ARNs) in the Amazon Web Services General Reference
  guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"endTime"`: Upper limit of the time range to filter the application versions.
- `"maxResults"`: Maximum number of results to include in the response. If more results
  exist than the specified MaxResults value, a token is included in the response so that the
  remaining results can be retrieved.
- `"nextToken"`: Null, or the token from a previous call to get the next set of results.
- `"startTime"`: Lower limit of the time range to filter the application versions.
"""
function list_app_versions(appArn; aws_config::AbstractAWSConfig=current_aws_config())
    return resiliencehub(
        "POST",
        "/list-app-versions",
        Dict{String,Any}("appArn" => appArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_app_versions(
    appArn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resiliencehub(
        "POST",
        "/list-app-versions",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("appArn" => appArn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_apps()
    list_apps(params::Dict{String,<:Any})

Lists your Resilience Hub applications.  You can filter applications using only one filter
at a time or without using any filter. If you try to filter applications using multiple
filters, you will get the following error:  An error occurred (ValidationException) when
calling the ListApps operation: Only one filter is supported for this operation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"appArn"`: Amazon Resource Name (ARN) of the Resilience Hub application. The format for
  this ARN is: arn:partition:resiliencehub:region:account:app/app-id. For more information
  about ARNs, see  Amazon Resource Names (ARNs) in the Amazon Web Services General Reference
  guide.
- `"fromLastAssessmentTime"`: Indicates the lower limit of the range that is used to filter
  applications based on their last assessment times.
- `"maxResults"`: Maximum number of results to include in the response. If more results
  exist than the specified MaxResults value, a token is included in the response so that the
  remaining results can be retrieved.
- `"name"`: The name for the one of the listed applications.
- `"nextToken"`: Null, or the token from a previous call to get the next set of results.
- `"reverseOrder"`: The application list is sorted based on the values of
  lastAppComplianceEvaluationTime field. By default, application list is sorted in ascending
  order. To sort the appliation list in descending order, set this field to True.
- `"toLastAssessmentTime"`: Indicates the upper limit of the range that is used to filter
  the applications based on their last assessment times.
"""
function list_apps(; aws_config::AbstractAWSConfig=current_aws_config())
    return resiliencehub(
        "GET", "/list-apps"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_apps(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resiliencehub(
        "GET", "/list-apps", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_recommendation_templates()
    list_recommendation_templates(params::Dict{String,<:Any})

Lists the recommendation templates for the Resilience Hub applications.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"assessmentArn"`: Amazon Resource Name (ARN) of the assessment. The format for this ARN
  is: arn:partition:resiliencehub:region:account:app-assessment/app-id. For more information
  about ARNs, see  Amazon Resource Names (ARNs) in the Amazon Web Services General Reference
  guide.
- `"maxResults"`: Maximum number of results to include in the response. If more results
  exist than the specified MaxResults value, a token is included in the response so that the
  remaining results can be retrieved.
- `"name"`: The name for one of the listed recommendation templates.
- `"nextToken"`: Null, or the token from a previous call to get the next set of results.
- `"recommendationTemplateArn"`: The Amazon Resource Name (ARN) for a recommendation
  template.
- `"reverseOrder"`: The default is to sort by ascending startTime. To sort by descending
  startTime, set reverseOrder to true.
- `"status"`: Status of the action.
"""
function list_recommendation_templates(; aws_config::AbstractAWSConfig=current_aws_config())
    return resiliencehub(
        "GET",
        "/list-recommendation-templates";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_recommendation_templates(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resiliencehub(
        "GET",
        "/list-recommendation-templates",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_resiliency_policies()
    list_resiliency_policies(params::Dict{String,<:Any})

Lists the resiliency policies for the Resilience Hub applications.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Maximum number of results to include in the response. If more results
  exist than the specified MaxResults value, a token is included in the response so that the
  remaining results can be retrieved.
- `"nextToken"`: Null, or the token from a previous call to get the next set of results.
- `"policyName"`: The name of the policy
"""
function list_resiliency_policies(; aws_config::AbstractAWSConfig=current_aws_config())
    return resiliencehub(
        "GET",
        "/list-resiliency-policies";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_resiliency_policies(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resiliencehub(
        "GET",
        "/list-resiliency-policies",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_sop_recommendations(assessment_arn)
    list_sop_recommendations(assessment_arn, params::Dict{String,<:Any})

Lists the standard operating procedure (SOP) recommendations for the Resilience Hub
applications.

# Arguments
- `assessment_arn`: Amazon Resource Name (ARN) of the assessment. The format for this ARN
  is: arn:partition:resiliencehub:region:account:app-assessment/app-id. For more information
  about ARNs, see  Amazon Resource Names (ARNs) in the Amazon Web Services General Reference
  guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Maximum number of results to include in the response. If more results
  exist than the specified MaxResults value, a token is included in the response so that the
  remaining results can be retrieved.
- `"nextToken"`: Null, or the token from a previous call to get the next set of results.
"""
function list_sop_recommendations(
    assessmentArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resiliencehub(
        "POST",
        "/list-sop-recommendations",
        Dict{String,Any}("assessmentArn" => assessmentArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_sop_recommendations(
    assessmentArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return resiliencehub(
        "POST",
        "/list-sop-recommendations",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("assessmentArn" => assessmentArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_suggested_resiliency_policies()
    list_suggested_resiliency_policies(params::Dict{String,<:Any})

Lists the suggested resiliency policies for the Resilience Hub applications.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Maximum number of results to include in the response. If more results
  exist than the specified MaxResults value, a token is included in the response so that the
  remaining results can be retrieved.
- `"nextToken"`: Null, or the token from a previous call to get the next set of results.
"""
function list_suggested_resiliency_policies(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return resiliencehub(
        "GET",
        "/list-suggested-resiliency-policies";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_suggested_resiliency_policies(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resiliencehub(
        "GET",
        "/list-suggested-resiliency-policies",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists the tags for your resources in your Resilience Hub applications.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) for a specific resource in your Resilience
  Hub application.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resiliencehub(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return resiliencehub(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_test_recommendations(assessment_arn)
    list_test_recommendations(assessment_arn, params::Dict{String,<:Any})

Lists the test recommendations for the Resilience Hub application.

# Arguments
- `assessment_arn`: Amazon Resource Name (ARN) of the assessment. The format for this ARN
  is: arn:partition:resiliencehub:region:account:app-assessment/app-id. For more information
  about ARNs, see  Amazon Resource Names (ARNs) in the Amazon Web Services General Reference
  guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Maximum number of results to include in the response. If more results
  exist than the specified MaxResults value, a token is included in the response so that the
  remaining results can be retrieved.
- `"nextToken"`: Null, or the token from a previous call to get the next set of results.
"""
function list_test_recommendations(
    assessmentArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resiliencehub(
        "POST",
        "/list-test-recommendations",
        Dict{String,Any}("assessmentArn" => assessmentArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_test_recommendations(
    assessmentArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return resiliencehub(
        "POST",
        "/list-test-recommendations",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("assessmentArn" => assessmentArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_unsupported_app_version_resources(app_arn, app_version)
    list_unsupported_app_version_resources(app_arn, app_version, params::Dict{String,<:Any})

Lists the resources that are not currently supported in Resilience Hub. An unsupported
resource is a resource that exists in the object that was used to create an app, but is not
supported by Resilience Hub.

# Arguments
- `app_arn`: Amazon Resource Name (ARN) of the Resilience Hub application. The format for
  this ARN is: arn:partition:resiliencehub:region:account:app/app-id. For more information
  about ARNs, see  Amazon Resource Names (ARNs) in the Amazon Web Services General Reference
  guide.
- `app_version`: The version of the application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Maximum number of results to include in the response. If more results
  exist than the specified MaxResults value, a token is included in the response so that the
  remaining results can be retrieved.
- `"nextToken"`: Null, or the token from a previous call to get the next set of results.
- `"resolutionId"`: The identifier for a specific resolution.
"""
function list_unsupported_app_version_resources(
    appArn, appVersion; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resiliencehub(
        "POST",
        "/list-unsupported-app-version-resources",
        Dict{String,Any}("appArn" => appArn, "appVersion" => appVersion);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_unsupported_app_version_resources(
    appArn,
    appVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return resiliencehub(
        "POST",
        "/list-unsupported-app-version-resources",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("appArn" => appArn, "appVersion" => appVersion),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    publish_app_version(app_arn)
    publish_app_version(app_arn, params::Dict{String,<:Any})

Publishes a new version of a specific Resilience Hub application.

# Arguments
- `app_arn`: Amazon Resource Name (ARN) of the Resilience Hub application. The format for
  this ARN is: arn:partition:resiliencehub:region:account:app/app-id. For more information
  about ARNs, see  Amazon Resource Names (ARNs) in the Amazon Web Services General Reference
  guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"versionName"`: Name of the application version.
"""
function publish_app_version(appArn; aws_config::AbstractAWSConfig=current_aws_config())
    return resiliencehub(
        "POST",
        "/publish-app-version",
        Dict{String,Any}("appArn" => appArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function publish_app_version(
    appArn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resiliencehub(
        "POST",
        "/publish-app-version",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("appArn" => appArn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_draft_app_version_template(app_arn, app_template_body)
    put_draft_app_version_template(app_arn, app_template_body, params::Dict{String,<:Any})

Adds or updates the app template for an Resilience Hub application draft version.

# Arguments
- `app_arn`: Amazon Resource Name (ARN) of the Resilience Hub application. The format for
  this ARN is: arn:partition:resiliencehub:region:account:app/app-id. For more information
  about ARNs, see  Amazon Resource Names (ARNs) in the Amazon Web Services General Reference
  guide.
- `app_template_body`: A JSON string that provides information about your application
  structure. To learn more about the appTemplateBody template, see the sample template
  provided in the Examples section. The appTemplateBody JSON string has the following
  structure:     resources   The list of logical resources that must be included in the
  Resilience Hub application. Type: Array  Don't add the resources that you want to exclude.
  Each resources array item includes the following fields:     logicalResourceId   Logical
  identifier of the resource. Type: Object Each logicalResourceId object includes the
  following fields:    identifier  Identifier of the resource. Type: String
  logicalStackName  The name of the CloudFormation stack this resource belongs to. Type:
  String    resourceGroupName  The name of the resource group this resource belongs to. Type:
  String    terraformSourceName  The name of the Terraform S3 state file this resource
  belongs to. Type: String    eksSourceName  Name of the Amazon Elastic Kubernetes Service
  cluster and namespace this resource belongs to.  This parameter accepts values in
  \"eks-cluster/namespace\" format.  Type: String       type   The type of resource. Type:
  string     name   The name of the resource. Type: String    additionalInfo  Additional
  configuration parameters for an Resilience Hub application. If you want to implement
  additionalInfo through the Resilience Hub console rather than using an API call, see
  Configure the application configuration parameters.  Currently, this parameter accepts a
  key-value mapping (in a string format) of only one failover region and one associated
  account. Key: \"failover-regions\"  Value: \"[{\"region\":\"&lt;REGION&gt;\",
  \"accounts\":[{\"id\":\"&lt;ACCOUNT_ID&gt;\"}]}]\"         appComponents   List of
  Application Components that this resource belongs to. If an Application Component is not
  part of the Resilience Hub application, it will be added. Type: Array Each appComponents
  array item includes the following fields:    name  Name of the Application Component. Type:
  String    type  Type of Application Component. For more information about the types of
  Application Component, see Grouping resources in an AppComponent. Type: String
  resourceNames  The list of included resources that are assigned to the Application
  Component. Type: Array of strings    additionalInfo  Additional configuration parameters
  for an Resilience Hub application. If you want to implement additionalInfo through the
  Resilience Hub console rather than using an API call, see Configure the application
  configuration parameters.  Currently, this parameter accepts a key-value mapping (in a
  string format) of only one failover region and one associated account. Key:
  \"failover-regions\"  Value: \"[{\"region\":\"&lt;REGION&gt;\",
  \"accounts\":[{\"id\":\"&lt;ACCOUNT_ID&gt;\"}]}]\"         excludedResources   The list of
  logical resource identifiers to be excluded from the application. Type: Array  Don't add
  the resources that you want to include.  Each excludedResources array item includes the
  following fields:     logicalResourceIds   Logical identifier of the resource. Type: Object
   You can configure only one of the following fields:    logicalStackName
  resourceGroupName     terraformSourceName     eksSourceName     Each logicalResourceIds
  object includes the following fields:    identifier  Identifier of the resource. Type:
  String    logicalStackName  The name of the CloudFormation stack this resource belongs to.
  Type: String    resourceGroupName  The name of the resource group this resource belongs to.
  Type: String    terraformSourceName  The name of the Terraform S3 state file this resource
  belongs to. Type: String    eksSourceName  Name of the Amazon Elastic Kubernetes Service
  cluster and namespace this resource belongs to.  This parameter accepts values in
  \"eks-cluster/namespace\" format.  Type: String         version   Resilience Hub
  application version.    additionalInfo  Additional configuration parameters for an
  Resilience Hub application. If you want to implement additionalInfo through the Resilience
  Hub console rather than using an API call, see Configure the application configuration
  parameters.  Currently, this parameter accepts a key-value mapping (in a string format) of
  only one failover region and one associated account. Key: \"failover-regions\"  Value:
  \"[{\"region\":\"&lt;REGION&gt;\", \"accounts\":[{\"id\":\"&lt;ACCOUNT_ID&gt;\"}]}]\"

"""
function put_draft_app_version_template(
    appArn, appTemplateBody; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resiliencehub(
        "POST",
        "/put-draft-app-version-template",
        Dict{String,Any}("appArn" => appArn, "appTemplateBody" => appTemplateBody);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_draft_app_version_template(
    appArn,
    appTemplateBody,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return resiliencehub(
        "POST",
        "/put-draft-app-version-template",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("appArn" => appArn, "appTemplateBody" => appTemplateBody),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_draft_app_version_resource_mappings(app_arn)
    remove_draft_app_version_resource_mappings(app_arn, params::Dict{String,<:Any})

Removes resource mappings from a draft application version.

# Arguments
- `app_arn`: Amazon Resource Name (ARN) of the Resilience Hub application. The format for
  this ARN is: arn:partition:resiliencehub:region:account:app/app-id. For more information
  about ARNs, see  Amazon Resource Names (ARNs) in the Amazon Web Services General Reference
  guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"appRegistryAppNames"`: The names of the registered applications you want to remove from
  the resource mappings.
- `"eksSourceNames"`: The names of the Amazon Elastic Kubernetes Service clusters and
  namespaces you want to remove from the resource mappings.  This parameter accepts values in
  \"eks-cluster/namespace\" format.
- `"logicalStackNames"`: The names of the CloudFormation stacks you want to remove from the
  resource mappings.
- `"resourceGroupNames"`: The names of the resource groups you want to remove from the
  resource mappings.
- `"resourceNames"`: The names of the resources you want to remove from the resource
  mappings.
- `"terraformSourceNames"`: The names of the Terraform sources you want to remove from the
  resource mappings.
"""
function remove_draft_app_version_resource_mappings(
    appArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resiliencehub(
        "POST",
        "/remove-draft-app-version-resource-mappings",
        Dict{String,Any}("appArn" => appArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_draft_app_version_resource_mappings(
    appArn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resiliencehub(
        "POST",
        "/remove-draft-app-version-resource-mappings",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("appArn" => appArn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    resolve_app_version_resources(app_arn, app_version)
    resolve_app_version_resources(app_arn, app_version, params::Dict{String,<:Any})

Resolves the resources for an application version.

# Arguments
- `app_arn`: Amazon Resource Name (ARN) of the Resilience Hub application. The format for
  this ARN is: arn:partition:resiliencehub:region:account:app/app-id. For more information
  about ARNs, see  Amazon Resource Names (ARNs) in the Amazon Web Services General Reference
  guide.
- `app_version`: The version of the application.

"""
function resolve_app_version_resources(
    appArn, appVersion; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resiliencehub(
        "POST",
        "/resolve-app-version-resources",
        Dict{String,Any}("appArn" => appArn, "appVersion" => appVersion);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function resolve_app_version_resources(
    appArn,
    appVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return resiliencehub(
        "POST",
        "/resolve-app-version-resources",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("appArn" => appArn, "appVersion" => appVersion),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_app_assessment(app_arn, app_version, assessment_name)
    start_app_assessment(app_arn, app_version, assessment_name, params::Dict{String,<:Any})

Creates a new application assessment for an application.

# Arguments
- `app_arn`: Amazon Resource Name (ARN) of the Resilience Hub application. The format for
  this ARN is: arn:partition:resiliencehub:region:account:app/app-id. For more information
  about ARNs, see  Amazon Resource Names (ARNs) in the Amazon Web Services General Reference
  guide.
- `app_version`: The version of the application.
- `assessment_name`: The name for the assessment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Used for an idempotency token. A client token is a unique,
  case-sensitive string of up to 64 ASCII characters. You should not reuse the same client
  token for other API requests.
- `"tags"`: Tags assigned to the resource. A tag is a label that you assign to an Amazon
  Web Services resource. Each tag consists of a key/value pair.
"""
function start_app_assessment(
    appArn, appVersion, assessmentName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resiliencehub(
        "POST",
        "/start-app-assessment",
        Dict{String,Any}(
            "appArn" => appArn,
            "appVersion" => appVersion,
            "assessmentName" => assessmentName,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_app_assessment(
    appArn,
    appVersion,
    assessmentName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return resiliencehub(
        "POST",
        "/start-app-assessment",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "appArn" => appArn,
                    "appVersion" => appVersion,
                    "assessmentName" => assessmentName,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Applies one or more tags to a resource.

# Arguments
- `resource_arn`: Amazon Resource Name (ARN) of the resource.
- `tags`: The tags to assign to the resource. Each tag consists of a key/value pair.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return resiliencehub(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return resiliencehub(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes one or more tags from a resource.

# Arguments
- `resource_arn`: Amazon Resource Name (ARN) of the resource.
- `tag_keys`: The keys of the tags you want to remove.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resiliencehub(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return resiliencehub(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_app(app_arn)
    update_app(app_arn, params::Dict{String,<:Any})

Updates an application.

# Arguments
- `app_arn`: Amazon Resource Name (ARN) of the Resilience Hub application. The format for
  this ARN is: arn:partition:resiliencehub:region:account:app/app-id. For more information
  about ARNs, see  Amazon Resource Names (ARNs) in the Amazon Web Services General Reference
  guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"assessmentSchedule"`:  Assessment execution schedule with 'Daily' or 'Disabled' values.
- `"clearResiliencyPolicyArn"`: Specifies if the resiliency policy ARN should be cleared.
- `"description"`: The optional description for an app.
- `"eventSubscriptions"`: The list of events you would like to subscribe and get
  notification for. Currently, Resilience Hub supports notifications only for Drift detected
  and Scheduled assessment failure events.
- `"permissionModel"`: Defines the roles and credentials that Resilience Hub would use
  while creating an application, importing its resources, and running an assessment.
- `"policyArn"`: Amazon Resource Name (ARN) of the resiliency policy. The format for this
  ARN is: arn:partition:resiliencehub:region:account:resiliency-policy/policy-id. For more
  information about ARNs, see  Amazon Resource Names (ARNs) in the Amazon Web Services
  General Reference guide.
"""
function update_app(appArn; aws_config::AbstractAWSConfig=current_aws_config())
    return resiliencehub(
        "POST",
        "/update-app",
        Dict{String,Any}("appArn" => appArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_app(
    appArn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resiliencehub(
        "POST",
        "/update-app",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("appArn" => appArn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_app_version(app_arn)
    update_app_version(app_arn, params::Dict{String,<:Any})

Updates the Resilience Hub application version.  This API updates the Resilience Hub
application draft version. To use this information for running resiliency assessments, you
must publish the Resilience Hub application using the PublishAppVersion API.

# Arguments
- `app_arn`: Amazon Resource Name (ARN) of the Resilience Hub application. The format for
  this ARN is: arn:partition:resiliencehub:region:account:app/app-id. For more information
  about ARNs, see  Amazon Resource Names (ARNs) in the Amazon Web Services General Reference
  guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"additionalInfo"`: Additional configuration parameters for an Resilience Hub
  application. If you want to implement additionalInfo through the Resilience Hub console
  rather than using an API call, see Configure the application configuration parameters.
  Currently, this parameter accepts a key-value mapping (in a string format) of only one
  failover region and one associated account. Key: \"failover-regions\"  Value:
  \"[{\"region\":\"&lt;REGION&gt;\", \"accounts\":[{\"id\":\"&lt;ACCOUNT_ID&gt;\"}]}]\"
"""
function update_app_version(appArn; aws_config::AbstractAWSConfig=current_aws_config())
    return resiliencehub(
        "POST",
        "/update-app-version",
        Dict{String,Any}("appArn" => appArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_app_version(
    appArn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resiliencehub(
        "POST",
        "/update-app-version",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("appArn" => appArn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_app_version_app_component(app_arn, id)
    update_app_version_app_component(app_arn, id, params::Dict{String,<:Any})

Updates an existing Application Component in the Resilience Hub application.  This API
updates the Resilience Hub application draft version. To use this Application Component for
running assessments, you must publish the Resilience Hub application using the
PublishAppVersion API.

# Arguments
- `app_arn`: Amazon Resource Name (ARN) of the Resilience Hub application. The format for
  this ARN is: arn:partition:resiliencehub:region:account:app/app-id. For more information
  about ARNs, see  Amazon Resource Names (ARNs) in the Amazon Web Services General Reference
  guide.
- `id`: Identifier of the Application Component.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"additionalInfo"`: Currently, there is no supported additional information for
  Application Components.
- `"name"`: Name of the Application Component.
- `"type"`: Type of Application Component. For more information about the types of
  Application Component, see Grouping resources in an AppComponent.
"""
function update_app_version_app_component(
    appArn, id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resiliencehub(
        "POST",
        "/update-app-version-app-component",
        Dict{String,Any}("appArn" => appArn, "id" => id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_app_version_app_component(
    appArn,
    id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return resiliencehub(
        "POST",
        "/update-app-version-app-component",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("appArn" => appArn, "id" => id), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_app_version_resource(app_arn)
    update_app_version_resource(app_arn, params::Dict{String,<:Any})

Updates the resource details in the Resilience Hub application.    This action has no
effect outside Resilience Hub.   This API updates the Resilience Hub application draft
version. To use this resource for running resiliency assessments, you must publish the
Resilience Hub application using the PublishAppVersion API.   To update application version
with new physicalResourceID, you must call ResolveAppVersionResources API.

# Arguments
- `app_arn`: Amazon Resource Name (ARN) of the Resilience Hub application. The format for
  this ARN is: arn:partition:resiliencehub:region:account:app/app-id. For more information
  about ARNs, see  Amazon Resource Names (ARNs) in the Amazon Web Services General Reference
  guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"additionalInfo"`: Currently, there is no supported additional information for resources.
- `"appComponents"`: List of Application Components that this resource belongs to. If an
  Application Component is not part of the Resilience Hub application, it will be added.
- `"awsAccountId"`: Amazon Web Services account that owns the physical resource.
- `"awsRegion"`: Amazon Web Services region that owns the physical resource.
- `"excluded"`: Indicates if a resource is excluded from an Resilience Hub application.
  You can exclude only imported resources from an Resilience Hub application.
- `"logicalResourceId"`: Logical identifier of the resource.
- `"physicalResourceId"`: Physical identifier of the resource.
- `"resourceName"`: Name of the resource.
- `"resourceType"`: Type of resource.
"""
function update_app_version_resource(
    appArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resiliencehub(
        "POST",
        "/update-app-version-resource",
        Dict{String,Any}("appArn" => appArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_app_version_resource(
    appArn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resiliencehub(
        "POST",
        "/update-app-version-resource",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("appArn" => appArn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_resiliency_policy(policy_arn)
    update_resiliency_policy(policy_arn, params::Dict{String,<:Any})

Updates a resiliency policy.  Resilience Hub allows you to provide a value of zero for
rtoInSecs and rpoInSecs of your resiliency policy. But, while assessing your application,
the lowest possible assessment result is near zero. Hence, if you provide value zero for
rtoInSecs and rpoInSecs, the estimated workload RTO and estimated workload RPO result will
be near zero and the Compliance status for your application will be set to Policy breached.

# Arguments
- `policy_arn`: Amazon Resource Name (ARN) of the resiliency policy. The format for this
  ARN is: arn:partition:resiliencehub:region:account:resiliency-policy/policy-id. For more
  information about ARNs, see  Amazon Resource Names (ARNs) in the Amazon Web Services
  General Reference guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"dataLocationConstraint"`: Specifies a high-level geographical location constraint for
  where your resilience policy data can be stored.
- `"policy"`: The type of resiliency policy to be created, including the recovery time
  objective (RTO) and recovery point objective (RPO) in seconds.
- `"policyDescription"`: The description for the policy.
- `"policyName"`: The name of the policy
- `"tier"`: The tier for this resiliency policy, ranging from the highest severity
  (MissionCritical) to lowest (NonCritical).
"""
function update_resiliency_policy(
    policyArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resiliencehub(
        "POST",
        "/update-resiliency-policy",
        Dict{String,Any}("policyArn" => policyArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_resiliency_policy(
    policyArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return resiliencehub(
        "POST",
        "/update-resiliency-policy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("policyArn" => policyArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWS.jl
using AWS
using AWS.AWSServices: pcs
using AWS.Compat
using AWS.UUIDs

"""
    create_cluster(cluster_name, networking, scheduler, size)
    create_cluster(cluster_name, networking, scheduler, size, params::Dict{String,<:Any})

Creates a cluster in your account. Amazon Web Services PCS creates the cluster controller
in a service-owned account. The cluster controller communicates with the cluster resources
in your account. The subnets and security groups for the cluster must already exist before
you use this API action.  It takes time for Amazon Web Services PCS to create the cluster.
The cluster is in a Creating state until it is ready to use. There can only be 1 cluster in
a Creating state per Amazon Web Services Region per Amazon Web Services account.
CreateCluster fails with a ServiceQuotaExceededException if there is already a cluster in a
Creating state.

# Arguments
- `cluster_name`: A name to identify the cluster. Example: MyCluster
- `networking`: The networking configuration used to set up the cluster's control plane.
- `scheduler`: The cluster management and job scheduling software associated with the
  cluster.
- `size`: A value that determines the maximum number of compute nodes in the cluster and
  the maximum number of jobs (active and queued).    SMALL: 32 compute nodes and 256 jobs
  MEDIUM: 512 compute nodes and 8192 jobs    LARGE: 2048 compute nodes and 16,384 jobs

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. Idempotency ensures that an API request completes only once.
  With an idempotent request, if the original request completes successfully, the subsequent
  retries with the same client token return the result from the original successful request
  and they have no additional effect. If you don't specify a client token, the CLI and SDK
  automatically generate 1 for you.
- `"slurmConfiguration"`: Additional options related to the Slurm scheduler.
- `"tags"`: 1 or more tags added to the resource. Each tag consists of a tag key and tag
  value. The tag value is optional and can be an empty string.
"""
function create_cluster end

function create_cluster(
    clusterName,
    networking,
    scheduler,
    size;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pcs(
        "CreateCluster",
        Dict{String,Any}(
            "clusterName" => clusterName,
            "networking" => networking,
            "scheduler" => scheduler,
            "size" => size,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function create_cluster(
    clusterName,
    networking,
    scheduler,
    size,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pcs(
        "CreateCluster",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "clusterName" => clusterName,
                    "networking" => networking,
                    "scheduler" => scheduler,
                    "size" => size,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_compute_node_group(cluster_identifier, compute_node_group_name, custom_launch_template, iam_instance_profile_arn, instance_configs, scaling_configuration, subnet_ids)
    create_compute_node_group(cluster_identifier, compute_node_group_name, custom_launch_template, iam_instance_profile_arn, instance_configs, scaling_configuration, subnet_ids, params::Dict{String,<:Any})

Creates a managed set of compute nodes. You associate a compute node group with a cluster
through 1 or more Amazon Web Services PCS queues or as part of the login fleet. A compute
node group includes the definition of the compute properties and lifecycle management.
Amazon Web Services PCS uses the information you provide to this API action to launch
compute nodes in your account. You can only specify subnets in the same Amazon VPC as your
cluster. You receive billing charges for the compute nodes that Amazon Web Services PCS
launches in your account. You must already have a launch template before you call this API.
For more information, see Launch an instance from a launch template in the Amazon Elastic
Compute Cloud User Guide for Linux Instances.

# Arguments
- `cluster_identifier`: The name or ID of the cluster to create a compute node group in.
- `compute_node_group_name`: A name to identify the cluster. Example: MyCluster
- `custom_launch_template`:
- `iam_instance_profile_arn`: The Amazon Resource Name (ARN) of the IAM instance profile
  used to pass an IAM role when launching EC2 instances. The role contained in your instance
  profile must have pcs:RegisterComputeNodeGroupInstance permissions attached in order to
  provision instances correctly. The resource identifier of the ARN must start with AWSPCS.
  For example, arn:aws:iam:123456789012:instance-profile/AWSPCSMyComputeNodeInstanceProfile.
- `instance_configs`: A list of EC2 instance configurations that Amazon Web Services PCS
  can provision in the compute node group.
- `scaling_configuration`: Specifies the boundaries of the compute node group auto scaling.
- `subnet_ids`: The list of subnet IDs where the compute node group launches instances.
  Subnets must be in the same VPC as the cluster.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"amiId"`:  The ID of the Amazon Machine Image (AMI) that Amazon Web Services PCS uses to
  launch compute nodes (Amazon EC2 instances). If you don't provide this value, Amazon Web
  Services PCS uses the AMI ID specified in the custom launch template.
- `"clientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. Idempotency ensures that an API request completes only once.
  With an idempotent request, if the original request completes successfully, the subsequent
  retries with the same client token return the result from the original successful request
  and they have no additional effect. If you don't specify a client token, the CLI and SDK
  automatically generate 1 for you.
- `"purchaseOption"`: Specifies how EC2 instances are purchased on your behalf. Amazon Web
  Services PCS supports On-Demand and Spot instances. For more information, see Instance
  purchasing options in the Amazon Elastic Compute Cloud User Guide. If you don't provide
  this option, it defaults to On-Demand.
- `"slurmConfiguration"`: Additional options related to the Slurm scheduler.
- `"spotOptions"`:
- `"tags"`: 1 or more tags added to the resource. Each tag consists of a tag key and tag
  value. The tag value is optional and can be an empty string.
"""
function create_compute_node_group end

function create_compute_node_group(
    clusterIdentifier,
    computeNodeGroupName,
    customLaunchTemplate,
    iamInstanceProfileArn,
    instanceConfigs,
    scalingConfiguration,
    subnetIds;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pcs(
        "CreateComputeNodeGroup",
        Dict{String,Any}(
            "clusterIdentifier" => clusterIdentifier,
            "computeNodeGroupName" => computeNodeGroupName,
            "customLaunchTemplate" => customLaunchTemplate,
            "iamInstanceProfileArn" => iamInstanceProfileArn,
            "instanceConfigs" => instanceConfigs,
            "scalingConfiguration" => scalingConfiguration,
            "subnetIds" => subnetIds,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function create_compute_node_group(
    clusterIdentifier,
    computeNodeGroupName,
    customLaunchTemplate,
    iamInstanceProfileArn,
    instanceConfigs,
    scalingConfiguration,
    subnetIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pcs(
        "CreateComputeNodeGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "clusterIdentifier" => clusterIdentifier,
                    "computeNodeGroupName" => computeNodeGroupName,
                    "customLaunchTemplate" => customLaunchTemplate,
                    "iamInstanceProfileArn" => iamInstanceProfileArn,
                    "instanceConfigs" => instanceConfigs,
                    "scalingConfiguration" => scalingConfiguration,
                    "subnetIds" => subnetIds,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_queue(cluster_identifier, queue_name)
    create_queue(cluster_identifier, queue_name, params::Dict{String,<:Any})

Creates a job queue. You must associate 1 or more compute node groups with the queue. You
can associate 1 compute node group with multiple queues.

# Arguments
- `cluster_identifier`: The name or ID of the cluster for which to create a queue.
- `queue_name`: A name to identify the queue.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. Idempotency ensures that an API request completes only once.
  With an idempotent request, if the original request completes successfully, the subsequent
  retries with the same client token return the result from the original successful request
  and they have no additional effect. If you don't specify a client token, the CLI and SDK
  automatically generate 1 for you.
- `"computeNodeGroupConfigurations"`: The list of compute node group configurations to
  associate with the queue. Queues assign jobs to associated compute node groups.
- `"tags"`: 1 or more tags added to the resource. Each tag consists of a tag key and tag
  value. The tag value is optional and can be an empty string.
"""
function create_queue end

function create_queue(
    clusterIdentifier, queueName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pcs(
        "CreateQueue",
        Dict{String,Any}(
            "clusterIdentifier" => clusterIdentifier,
            "queueName" => queueName,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function create_queue(
    clusterIdentifier,
    queueName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pcs(
        "CreateQueue",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "clusterIdentifier" => clusterIdentifier,
                    "queueName" => queueName,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_cluster(cluster_identifier)
    delete_cluster(cluster_identifier, params::Dict{String,<:Any})

Deletes a cluster and all its linked resources. You must delete all queues and compute node
groups associated with the cluster before you can delete the cluster.

# Arguments
- `cluster_identifier`: The name or ID of the cluster to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. Idempotency ensures that an API request completes only once.
  With an idempotent request, if the original request completes successfully, the subsequent
  retries with the same client token return the result from the original successful request
  and they have no additional effect. If you don't specify a client token, the CLI and SDK
  automatically generate 1 for you.
"""
function delete_cluster end

function delete_cluster(
    clusterIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pcs(
        "DeleteCluster",
        Dict{String,Any}(
            "clusterIdentifier" => clusterIdentifier, "clientToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function delete_cluster(
    clusterIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pcs(
        "DeleteCluster",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "clusterIdentifier" => clusterIdentifier,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_compute_node_group(cluster_identifier, compute_node_group_identifier)
    delete_compute_node_group(cluster_identifier, compute_node_group_identifier, params::Dict{String,<:Any})

Deletes a compute node group. You must delete all queues associated with the compute node
group first.

# Arguments
- `cluster_identifier`: The name or ID of the cluster of the compute node group.
- `compute_node_group_identifier`: The name or ID of the compute node group to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. Idempotency ensures that an API request completes only once.
  With an idempotent request, if the original request completes successfully, the subsequent
  retries with the same client token return the result from the original successful request
  and they have no additional effect. If you don't specify a client token, the CLI and SDK
  automatically generate 1 for you.
"""
function delete_compute_node_group end

function delete_compute_node_group(
    clusterIdentifier,
    computeNodeGroupIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pcs(
        "DeleteComputeNodeGroup",
        Dict{String,Any}(
            "clusterIdentifier" => clusterIdentifier,
            "computeNodeGroupIdentifier" => computeNodeGroupIdentifier,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function delete_compute_node_group(
    clusterIdentifier,
    computeNodeGroupIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pcs(
        "DeleteComputeNodeGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "clusterIdentifier" => clusterIdentifier,
                    "computeNodeGroupIdentifier" => computeNodeGroupIdentifier,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_queue(cluster_identifier, queue_identifier)
    delete_queue(cluster_identifier, queue_identifier, params::Dict{String,<:Any})

Deletes a job queue. If the compute node group associated with this queue isn't associated
with any other queues, Amazon Web Services PCS terminates all the compute nodes for this
queue.

# Arguments
- `cluster_identifier`: The name or ID of the cluster of the queue.
- `queue_identifier`: The name or ID of the queue to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. Idempotency ensures that an API request completes only once.
  With an idempotent request, if the original request completes successfully, the subsequent
  retries with the same client token return the result from the original successful request
  and they have no additional effect. If you don't specify a client token, the CLI and SDK
  automatically generate 1 for you.
"""
function delete_queue end

function delete_queue(
    clusterIdentifier, queueIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pcs(
        "DeleteQueue",
        Dict{String,Any}(
            "clusterIdentifier" => clusterIdentifier,
            "queueIdentifier" => queueIdentifier,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function delete_queue(
    clusterIdentifier,
    queueIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pcs(
        "DeleteQueue",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "clusterIdentifier" => clusterIdentifier,
                    "queueIdentifier" => queueIdentifier,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_cluster(cluster_identifier)
    get_cluster(cluster_identifier, params::Dict{String,<:Any})

Returns detailed information about a running cluster in your account. This API action
provides networking information, endpoint information for communication with the scheduler,
and provisioning status.

# Arguments
- `cluster_identifier`: The name or ID of the cluster of the queue.

"""
function get_cluster end

function get_cluster(clusterIdentifier; aws_config::AbstractAWSConfig=current_aws_config())
    return pcs(
        "GetCluster",
        Dict{String,Any}("clusterIdentifier" => clusterIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function get_cluster(
    clusterIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pcs(
        "GetCluster",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("clusterIdentifier" => clusterIdentifier), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_compute_node_group(cluster_identifier, compute_node_group_identifier)
    get_compute_node_group(cluster_identifier, compute_node_group_identifier, params::Dict{String,<:Any})

Returns detailed information about a compute node group. This API action provides
networking information, EC2 instance type, compute node group status, and scheduler (such
as Slurm) configuration.

# Arguments
- `cluster_identifier`: The name or ID of the cluster.
- `compute_node_group_identifier`: The name or ID of the compute node group.

"""
function get_compute_node_group end

function get_compute_node_group(
    clusterIdentifier,
    computeNodeGroupIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pcs(
        "GetComputeNodeGroup",
        Dict{String,Any}(
            "clusterIdentifier" => clusterIdentifier,
            "computeNodeGroupIdentifier" => computeNodeGroupIdentifier,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function get_compute_node_group(
    clusterIdentifier,
    computeNodeGroupIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pcs(
        "GetComputeNodeGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "clusterIdentifier" => clusterIdentifier,
                    "computeNodeGroupIdentifier" => computeNodeGroupIdentifier,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_queue(cluster_identifier, queue_identifier)
    get_queue(cluster_identifier, queue_identifier, params::Dict{String,<:Any})

Returns detailed information about a queue. The information includes the compute node
groups that the queue uses to schedule jobs.

# Arguments
- `cluster_identifier`: The name or ID of the cluster of the queue.
- `queue_identifier`: The name or ID of the queue.

"""
function get_queue end

function get_queue(
    clusterIdentifier, queueIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pcs(
        "GetQueue",
        Dict{String,Any}(
            "clusterIdentifier" => clusterIdentifier, "queueIdentifier" => queueIdentifier
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function get_queue(
    clusterIdentifier,
    queueIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pcs(
        "GetQueue",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "clusterIdentifier" => clusterIdentifier,
                    "queueIdentifier" => queueIdentifier,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_clusters()
    list_clusters(params::Dict{String,<:Any})

Returns a list of running clusters in your account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results that are returned per call. You can use
  nextToken to obtain further pages of results. The default is 10 results, and the maximum
  allowed page size is 100 results. A value of 0 uses the default.
- `"nextToken"`: The value of nextToken is a unique pagination token for each page of
  results returned. If nextToken is returned, there are more results available. Make the call
  again using the returned token to retrieve the next page. Keep all other arguments
  unchanged. Each pagination token expires after 24 hours. Using an expired pagination token
  returns an HTTP 400 InvalidToken error.
"""
function list_clusters end

function list_clusters(; aws_config::AbstractAWSConfig=current_aws_config())
    return pcs("ListClusters"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end

function list_clusters(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pcs(
        "ListClusters", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_compute_node_groups(cluster_identifier)
    list_compute_node_groups(cluster_identifier, params::Dict{String,<:Any})

Returns a list of all compute node groups associated with a cluster.

# Arguments
- `cluster_identifier`: The name or ID of the cluster to list compute node groups for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results that are returned per call. You can use
  nextToken to obtain further pages of results. The default is 10 results, and the maximum
  allowed page size is 100 results. A value of 0 uses the default.
- `"nextToken"`: The value of nextToken is a unique pagination token for each page of
  results returned. If nextToken is returned, there are more results available. Make the call
  again using the returned token to retrieve the next page. Keep all other arguments
  unchanged. Each pagination token expires after 24 hours. Using an expired pagination token
  returns an HTTP 400 InvalidToken error.
"""
function list_compute_node_groups end

function list_compute_node_groups(
    clusterIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pcs(
        "ListComputeNodeGroups",
        Dict{String,Any}("clusterIdentifier" => clusterIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function list_compute_node_groups(
    clusterIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pcs(
        "ListComputeNodeGroups",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("clusterIdentifier" => clusterIdentifier), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_queues(cluster_identifier)
    list_queues(cluster_identifier, params::Dict{String,<:Any})

Returns a list of all queues associated with a cluster.

# Arguments
- `cluster_identifier`: The name or ID of the cluster to list queues for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results that are returned per call. You can use
  nextToken to obtain further pages of results. The default is 10 results, and the maximum
  allowed page size is 100 results. A value of 0 uses the default.
- `"nextToken"`: The value of nextToken is a unique pagination token for each page of
  results returned. If nextToken is returned, there are more results available. Make the call
  again using the returned token to retrieve the next page. Keep all other arguments
  unchanged. Each pagination token expires after 24 hours. Using an expired pagination token
  returns an HTTP 400 InvalidToken error.
"""
function list_queues end

function list_queues(clusterIdentifier; aws_config::AbstractAWSConfig=current_aws_config())
    return pcs(
        "ListQueues",
        Dict{String,Any}("clusterIdentifier" => clusterIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function list_queues(
    clusterIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pcs(
        "ListQueues",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("clusterIdentifier" => clusterIdentifier), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Returns a list of all tags on an Amazon Web Services PCS resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource for which to list tags.

"""
function list_tags_for_resource end

function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pcs(
        "ListTagsForResource",
        Dict{String,Any}("resourceArn" => resourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pcs(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceArn" => resourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    register_compute_node_group_instance(bootstrap_id, cluster_identifier)
    register_compute_node_group_instance(bootstrap_id, cluster_identifier, params::Dict{String,<:Any})

 This API action isn't intended for you to use.  Amazon Web Services PCS uses this API
action to register the compute nodes it launches in your account.

# Arguments
- `bootstrap_id`: The client-generated token to allow for retries.
- `cluster_identifier`: The name or ID of the cluster to register the compute node group
  instance in.

"""
function register_compute_node_group_instance end

function register_compute_node_group_instance(
    bootstrapId, clusterIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pcs(
        "RegisterComputeNodeGroupInstance",
        Dict{String,Any}(
            "bootstrapId" => bootstrapId, "clusterIdentifier" => clusterIdentifier
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function register_compute_node_group_instance(
    bootstrapId,
    clusterIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pcs(
        "RegisterComputeNodeGroupInstance",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "bootstrapId" => bootstrapId, "clusterIdentifier" => clusterIdentifier
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds or edits tags on an Amazon Web Services PCS resource. Each tag consists of a tag key
and a tag value. The tag key and tag value are case-sensitive strings. The tag value can be
an empty (null) string. To add a tag, specify a new tag key and a tag value. To edit a tag,
specify an existing tag key and a new tag value.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.
- `tags`: 1 or more tags added to the resource. Each tag consists of a tag key and tag
  value. The tag value is optional and can be an empty string.

"""
function tag_resource end

function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return pcs(
        "TagResource",
        Dict{String,Any}("resourceArn" => resourceArn, "tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pcs(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceArn" => resourceArn, "tags" => tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Deletes tags from an Amazon Web Services PCS resource. To delete a tag, specify the tag key
and the Amazon Resource Name (ARN) of the Amazon Web Services PCS resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.
- `tag_keys`: 1 or more tag keys to remove from the resource. Specify only tag keys and not
  tag values.

"""
function untag_resource end

function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pcs(
        "UntagResource",
        Dict{String,Any}("resourceArn" => resourceArn, "tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pcs(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceArn" => resourceArn, "tagKeys" => tagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_compute_node_group(cluster_identifier, compute_node_group_identifier)
    update_compute_node_group(cluster_identifier, compute_node_group_identifier, params::Dict{String,<:Any})

Updates a compute node group. You can update many of the fields related to your compute
node group including the configurations for networking, compute nodes, and settings
specific to your scheduler (such as Slurm).

# Arguments
- `cluster_identifier`: The name or ID of the cluster of the compute node group.
- `compute_node_group_identifier`: The name or ID of the compute node group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"amiId"`: The ID of the Amazon Machine Image (AMI) that Amazon Web Services PCS uses to
  launch instances. If not provided, Amazon Web Services PCS uses the AMI ID specified in the
  custom launch template.
- `"clientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. Idempotency ensures that an API request completes only once.
  With an idempotent request, if the original request completes successfully, the subsequent
  retries with the same client token return the result from the original successful request
  and they have no additional effect. If you don't specify a client token, the CLI and SDK
  automatically generate 1 for you.
- `"customLaunchTemplate"`:
- `"iamInstanceProfileArn"`: The Amazon Resource Name (ARN) of the IAM instance profile
  used to pass an IAM role when launching EC2 instances. The role contained in your instance
  profile must have pcs:RegisterComputeNodeGroupInstance permissions attached to provision
  instances correctly.
- `"purchaseOption"`: Specifies how EC2 instances are purchased on your behalf. Amazon Web
  Services PCS supports On-Demand and Spot instances. For more information, see Instance
  purchasing options in the Amazon Elastic Compute Cloud User Guide. If you don't provide
  this option, it defaults to On-Demand.
- `"scalingConfiguration"`: Specifies the boundaries of the compute node group auto scaling.
- `"slurmConfiguration"`: Additional options related to the Slurm scheduler.
- `"spotOptions"`:
- `"subnetIds"`: The list of subnet IDs where the compute node group provisions instances.
  The subnets must be in the same VPC as the cluster.
"""
function update_compute_node_group end

function update_compute_node_group(
    clusterIdentifier,
    computeNodeGroupIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pcs(
        "UpdateComputeNodeGroup",
        Dict{String,Any}(
            "clusterIdentifier" => clusterIdentifier,
            "computeNodeGroupIdentifier" => computeNodeGroupIdentifier,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function update_compute_node_group(
    clusterIdentifier,
    computeNodeGroupIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pcs(
        "UpdateComputeNodeGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "clusterIdentifier" => clusterIdentifier,
                    "computeNodeGroupIdentifier" => computeNodeGroupIdentifier,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_queue(cluster_identifier, queue_identifier)
    update_queue(cluster_identifier, queue_identifier, params::Dict{String,<:Any})

Updates the compute node group configuration of a queue. Use this API to change the compute
node groups that the queue can send jobs to.

# Arguments
- `cluster_identifier`: The name or ID of the cluster of the queue.
- `queue_identifier`: The name or ID of the queue.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. Idempotency ensures that an API request completes only once.
  With an idempotent request, if the original request completes successfully, the subsequent
  retries with the same client token return the result from the original successful request
  and they have no additional effect. If you don't specify a client token, the CLI and SDK
  automatically generate 1 for you.
- `"computeNodeGroupConfigurations"`: The list of compute node group configurations to
  associate with the queue. Queues assign jobs to associated compute node groups.
"""
function update_queue end

function update_queue(
    clusterIdentifier, queueIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pcs(
        "UpdateQueue",
        Dict{String,Any}(
            "clusterIdentifier" => clusterIdentifier,
            "queueIdentifier" => queueIdentifier,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function update_queue(
    clusterIdentifier,
    queueIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pcs(
        "UpdateQueue",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "clusterIdentifier" => clusterIdentifier,
                    "queueIdentifier" => queueIdentifier,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: cloudwatch
using AWS.Compat
using AWS.UUIDs

"""
    delete_alarms(alarm_names)
    delete_alarms(alarm_names, params::Dict{String,<:Any})

Deletes the specified alarms. You can delete up to 100 alarms in one operation. However,
this total can include no more than one composite alarm. For example, you could delete 99
metric alarms and one composite alarms with one operation, but you can't delete two
composite alarms with one operation.  If you specify an incorrect alarm name or make any
other error in the operation, no alarms are deleted. To confirm that alarms were deleted
successfully, you can use the DescribeAlarms operation after using DeleteAlarms.  It is
possible to create a loop or cycle of composite alarms, where composite alarm A depends on
composite alarm B, and composite alarm B also depends on composite alarm A. In this
scenario, you can't delete any composite alarm that is part of the cycle because there is
always still a composite alarm that depends on that alarm that you want to delete. To get
out of such a situation, you must break the cycle by changing the rule of one of the
composite alarms in the cycle to remove a dependency that creates the cycle. The simplest
change to make to break a cycle is to change the AlarmRule of one of the alarms to false.
Additionally, the evaluation of composite alarms stops if CloudWatch detects a cycle in the
evaluation path.

# Arguments
- `alarm_names`: The alarms to be deleted. Do not enclose the alarm names in quote marks.

"""
function delete_alarms(AlarmNames; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch(
        "DeleteAlarms",
        Dict{String,Any}("AlarmNames" => AlarmNames);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_alarms(
    AlarmNames,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch(
        "DeleteAlarms",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AlarmNames" => AlarmNames), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_anomaly_detector()
    delete_anomaly_detector(params::Dict{String,<:Any})

 Deletes the specified anomaly detection model from your account. For more information
about how to delete an anomaly detection model, see Deleting an anomaly detection model in
the CloudWatch User Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Dimensions"`: The metric dimensions associated with the anomaly detection model to
  delete.
- `"MetricMathAnomalyDetector"`: The metric math anomaly detector to be deleted. When using
  MetricMathAnomalyDetector, you cannot include following parameters in the same operation:
   Dimensions,    MetricName     Namespace     Stat    the SingleMetricAnomalyDetector
  parameters of DeleteAnomalyDetectorInput    Instead, specify the metric math anomaly
  detector attributes as part of the MetricMathAnomalyDetector property.
- `"MetricName"`: The metric name associated with the anomaly detection model to delete.
- `"Namespace"`: The namespace associated with the anomaly detection model to delete.
- `"SingleMetricAnomalyDetector"`: A single metric anomaly detector to be deleted. When
  using SingleMetricAnomalyDetector, you cannot include the following parameters in the same
  operation:    Dimensions,    MetricName     Namespace     Stat    the
  MetricMathAnomalyDetector parameters of DeleteAnomalyDetectorInput    Instead, specify the
  single metric anomaly detector attributes as part of the SingleMetricAnomalyDetector
  property.
- `"Stat"`: The statistic associated with the anomaly detection model to delete.
"""
function delete_anomaly_detector(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch(
        "DeleteAnomalyDetector"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function delete_anomaly_detector(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch(
        "DeleteAnomalyDetector",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_dashboards(dashboard_names)
    delete_dashboards(dashboard_names, params::Dict{String,<:Any})

Deletes all dashboards that you specify. You can specify up to 100 dashboards to delete. If
there is an error during this call, no dashboards are deleted.

# Arguments
- `dashboard_names`: The dashboards to be deleted. This parameter is required.

"""
function delete_dashboards(
    DashboardNames; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch(
        "DeleteDashboards",
        Dict{String,Any}("DashboardNames" => DashboardNames);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_dashboards(
    DashboardNames,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch(
        "DeleteDashboards",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DashboardNames" => DashboardNames), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_insight_rules(rule_names)
    delete_insight_rules(rule_names, params::Dict{String,<:Any})

Permanently deletes the specified Contributor Insights rules. If you create a rule, delete
it, and then re-create it with the same name, historical data from the first time the rule
was created might not be available.

# Arguments
- `rule_names`: An array of the rule names to delete. If you need to find out the names of
  your rules, use DescribeInsightRules.

"""
function delete_insight_rules(RuleNames; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch(
        "DeleteInsightRules",
        Dict{String,Any}("RuleNames" => RuleNames);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_insight_rules(
    RuleNames,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch(
        "DeleteInsightRules",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("RuleNames" => RuleNames), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_metric_stream(name)
    delete_metric_stream(name, params::Dict{String,<:Any})

Permanently deletes the metric stream that you specify.

# Arguments
- `name`: The name of the metric stream to delete.

"""
function delete_metric_stream(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch(
        "DeleteMetricStream",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_metric_stream(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch(
        "DeleteMetricStream",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_alarm_history()
    describe_alarm_history(params::Dict{String,<:Any})

Retrieves the history for the specified alarm. You can filter the results by date range or
item type. If an alarm name is not specified, the histories for either all metric alarms or
all composite alarms are returned. CloudWatch retains the history of an alarm even if you
delete the alarm. To use this operation and return information about a composite alarm, you
must be signed on with the cloudwatch:DescribeAlarmHistory permission that is scoped to *.
You can't return information about composite alarms if your cloudwatch:DescribeAlarmHistory
permission has a narrower scope.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AlarmName"`: The name of the alarm.
- `"AlarmTypes"`: Use this parameter to specify whether you want the operation to return
  metric alarms or composite alarms. If you omit this parameter, only metric alarms are
  returned.
- `"EndDate"`: The ending date to retrieve alarm history.
- `"HistoryItemType"`: The type of alarm histories to retrieve.
- `"MaxRecords"`: The maximum number of alarm history records to retrieve.
- `"NextToken"`: The token returned by a previous call to indicate that there is more data
  available.
- `"ScanBy"`: Specified whether to return the newest or oldest alarm history first. Specify
  TimestampDescending to have the newest event history returned first, and specify
  TimestampAscending to have the oldest history returned first.
- `"StartDate"`: The starting date to retrieve alarm history.
"""
function describe_alarm_history(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch(
        "DescribeAlarmHistory"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_alarm_history(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch(
        "DescribeAlarmHistory",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_alarms()
    describe_alarms(params::Dict{String,<:Any})

Retrieves the specified alarms. You can filter the results by specifying a prefix for the
alarm name, the alarm state, or a prefix for any action. To use this operation and return
information about composite alarms, you must be signed on with the
cloudwatch:DescribeAlarms permission that is scoped to *. You can't return information
about composite alarms if your cloudwatch:DescribeAlarms permission has a narrower scope.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ActionPrefix"`: Use this parameter to filter the results of the operation to only those
  alarms that use a certain alarm action. For example, you could specify the ARN of an SNS
  topic to find all alarms that send notifications to that topic.
- `"AlarmNamePrefix"`: An alarm name prefix. If you specify this parameter, you receive
  information about all alarms that have names that start with this prefix. If this parameter
  is specified, you cannot specify AlarmNames.
- `"AlarmNames"`: The names of the alarms to retrieve information about.
- `"AlarmTypes"`: Use this parameter to specify whether you want the operation to return
  metric alarms or composite alarms. If you omit this parameter, only metric alarms are
  returned, even if composite alarms exist in the account. For example, if you omit this
  parameter or specify MetricAlarms, the operation returns only a list of metric alarms. It
  does not return any composite alarms, even if composite alarms exist in the account. If you
  specify CompositeAlarms, the operation returns only a list of composite alarms, and does
  not return any metric alarms.
- `"ChildrenOfAlarmName"`: If you use this parameter and specify the name of a composite
  alarm, the operation returns information about the \"children\" alarms of the alarm you
  specify. These are the metric alarms and composite alarms referenced in the AlarmRule field
  of the composite alarm that you specify in ChildrenOfAlarmName. Information about the
  composite alarm that you name in ChildrenOfAlarmName is not returned. If you specify
  ChildrenOfAlarmName, you cannot specify any other parameters in the request except for
  MaxRecords and NextToken. If you do so, you receive a validation error.  Only the Alarm
  Name, ARN, StateValue (OK/ALARM/INSUFFICIENT_DATA), and StateUpdatedTimestamp information
  are returned by this operation when you use this parameter. To get complete information
  about these alarms, perform another DescribeAlarms operation and specify the parent alarm
  names in the AlarmNames parameter.
- `"MaxRecords"`: The maximum number of alarm descriptions to retrieve.
- `"NextToken"`: The token returned by a previous call to indicate that there is more data
  available.
- `"ParentsOfAlarmName"`: If you use this parameter and specify the name of a metric or
  composite alarm, the operation returns information about the \"parent\" alarms of the alarm
  you specify. These are the composite alarms that have AlarmRule parameters that reference
  the alarm named in ParentsOfAlarmName. Information about the alarm that you specify in
  ParentsOfAlarmName is not returned. If you specify ParentsOfAlarmName, you cannot specify
  any other parameters in the request except for MaxRecords and NextToken. If you do so, you
  receive a validation error.  Only the Alarm Name and ARN are returned by this operation
  when you use this parameter. To get complete information about these alarms, perform
  another DescribeAlarms operation and specify the parent alarm names in the AlarmNames
  parameter.
- `"StateValue"`: Specify this parameter to receive information only about alarms that are
  currently in the state that you specify.
"""
function describe_alarms(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch(
        "DescribeAlarms"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_alarms(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch(
        "DescribeAlarms", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_alarms_for_metric(metric_name, namespace)
    describe_alarms_for_metric(metric_name, namespace, params::Dict{String,<:Any})

Retrieves the alarms for the specified metric. To filter the results, specify a statistic,
period, or unit. This operation retrieves only standard alarms that are based on the
specified metric. It does not return alarms based on math expressions that use the
specified metric, or composite alarms that use the specified metric.

# Arguments
- `metric_name`: The name of the metric.
- `namespace`: The namespace of the metric.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Dimensions"`: The dimensions associated with the metric. If the metric has any
  associated dimensions, you must specify them in order for the call to succeed.
- `"ExtendedStatistic"`: The percentile statistic for the metric. Specify a value between
  p0.0 and p100.
- `"Period"`: The period, in seconds, over which the statistic is applied.
- `"Statistic"`: The statistic for the metric, other than percentiles. For percentile
  statistics, use ExtendedStatistics.
- `"Unit"`: The unit for the metric.
"""
function describe_alarms_for_metric(
    MetricName, Namespace; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch(
        "DescribeAlarmsForMetric",
        Dict{String,Any}("MetricName" => MetricName, "Namespace" => Namespace);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_alarms_for_metric(
    MetricName,
    Namespace,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch(
        "DescribeAlarmsForMetric",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("MetricName" => MetricName, "Namespace" => Namespace),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_anomaly_detectors()
    describe_anomaly_detectors(params::Dict{String,<:Any})

Lists the anomaly detection models that you have created in your account. For single metric
anomaly detectors, you can list all of the models in your account or filter the results to
only the models that are related to a certain namespace, metric name, or metric dimension.
For metric math anomaly detectors, you can list them by adding METRIC_MATH to the
AnomalyDetectorTypes array. This will return all metric math anomaly detectors in your
account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AnomalyDetectorTypes"`: The anomaly detector types to request when using
  DescribeAnomalyDetectorsInput. If empty, defaults to SINGLE_METRIC.
- `"Dimensions"`: Limits the results to only the anomaly detection models that are
  associated with the specified metric dimensions. If there are multiple metrics that have
  these dimensions and have anomaly detection models associated, they're all returned.
- `"MaxResults"`: The maximum number of results to return in one operation. The maximum
  value that you can specify is 100. To retrieve the remaining results, make another call
  with the returned NextToken value.
- `"MetricName"`: Limits the results to only the anomaly detection models that are
  associated with the specified metric name. If there are multiple metrics with this name in
  different namespaces that have anomaly detection models, they're all returned.
- `"Namespace"`: Limits the results to only the anomaly detection models that are
  associated with the specified namespace.
- `"NextToken"`: Use the token returned by the previous operation to request the next page
  of results.
"""
function describe_anomaly_detectors(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch(
        "DescribeAnomalyDetectors"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_anomaly_detectors(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch(
        "DescribeAnomalyDetectors",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_insight_rules()
    describe_insight_rules(params::Dict{String,<:Any})

Returns a list of all the Contributor Insights rules in your account. For more information
about Contributor Insights, see Using Contributor Insights to Analyze High-Cardinality Data.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to return in one operation. If you omit
  this parameter, the default of 500 is used.
- `"NextToken"`: Include this value, if it was returned by the previous operation, to get
  the next set of rules.
"""
function describe_insight_rules(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch(
        "DescribeInsightRules"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_insight_rules(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch(
        "DescribeInsightRules",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disable_alarm_actions(alarm_names)
    disable_alarm_actions(alarm_names, params::Dict{String,<:Any})

Disables the actions for the specified alarms. When an alarm's actions are disabled, the
alarm actions do not execute when the alarm state changes.

# Arguments
- `alarm_names`: The names of the alarms.

"""
function disable_alarm_actions(
    AlarmNames; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch(
        "DisableAlarmActions",
        Dict{String,Any}("AlarmNames" => AlarmNames);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disable_alarm_actions(
    AlarmNames,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch(
        "DisableAlarmActions",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AlarmNames" => AlarmNames), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disable_insight_rules(rule_names)
    disable_insight_rules(rule_names, params::Dict{String,<:Any})

Disables the specified Contributor Insights rules. When rules are disabled, they do not
analyze log groups and do not incur costs.

# Arguments
- `rule_names`: An array of the rule names to disable. If you need to find out the names of
  your rules, use DescribeInsightRules.

"""
function disable_insight_rules(
    RuleNames; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch(
        "DisableInsightRules",
        Dict{String,Any}("RuleNames" => RuleNames);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disable_insight_rules(
    RuleNames,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch(
        "DisableInsightRules",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("RuleNames" => RuleNames), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    enable_alarm_actions(alarm_names)
    enable_alarm_actions(alarm_names, params::Dict{String,<:Any})

Enables the actions for the specified alarms.

# Arguments
- `alarm_names`: The names of the alarms.

"""
function enable_alarm_actions(
    AlarmNames; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch(
        "EnableAlarmActions",
        Dict{String,Any}("AlarmNames" => AlarmNames);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function enable_alarm_actions(
    AlarmNames,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch(
        "EnableAlarmActions",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AlarmNames" => AlarmNames), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    enable_insight_rules(rule_names)
    enable_insight_rules(rule_names, params::Dict{String,<:Any})

Enables the specified Contributor Insights rules. When rules are enabled, they immediately
begin analyzing log data.

# Arguments
- `rule_names`: An array of the rule names to enable. If you need to find out the names of
  your rules, use DescribeInsightRules.

"""
function enable_insight_rules(RuleNames; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch(
        "EnableInsightRules",
        Dict{String,Any}("RuleNames" => RuleNames);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function enable_insight_rules(
    RuleNames,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch(
        "EnableInsightRules",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("RuleNames" => RuleNames), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_dashboard(dashboard_name)
    get_dashboard(dashboard_name, params::Dict{String,<:Any})

Displays the details of the dashboard that you specify. To copy an existing dashboard, use
GetDashboard, and then use the data returned within DashboardBody as the template for the
new dashboard when you call PutDashboard to create the copy.

# Arguments
- `dashboard_name`: The name of the dashboard to be described.

"""
function get_dashboard(DashboardName; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch(
        "GetDashboard",
        Dict{String,Any}("DashboardName" => DashboardName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_dashboard(
    DashboardName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch(
        "GetDashboard",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DashboardName" => DashboardName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_insight_rule_report(end_time, period, rule_name, start_time)
    get_insight_rule_report(end_time, period, rule_name, start_time, params::Dict{String,<:Any})

This operation returns the time series data collected by a Contributor Insights rule. The
data includes the identity and number of contributors to the log group. You can also
optionally return one or more statistics about each data point in the time series. These
statistics can include the following:    UniqueContributors -- the number of unique
contributors for each data point.    MaxContributorValue -- the value of the top
contributor for each data point. The identity of the contributor might change for each data
point in the graph. If this rule aggregates by COUNT, the top contributor for each data
point is the contributor with the most occurrences in that period. If the rule aggregates
by SUM, the top contributor is the contributor with the highest sum in the log field
specified by the rule's Value, during that period.    SampleCount -- the number of data
points matched by the rule.    Sum -- the sum of the values from all contributors during
the time period represented by that data point.    Minimum -- the minimum value from a
single observation during the time period represented by that data point.    Maximum -- the
maximum value from a single observation during the time period represented by that data
point.    Average -- the average value from all contributors during the time period
represented by that data point.

# Arguments
- `end_time`: The end time of the data to use in the report. When used in a raw HTTP Query
  API, it is formatted as yyyy-MM-dd'T'HH:mm:ss. For example, 2019-07-01T23:59:59.
- `period`: The period, in seconds, to use for the statistics in the
  InsightRuleMetricDatapoint results.
- `rule_name`: The name of the rule that you want to see data from.
- `start_time`: The start time of the data to use in the report. When used in a raw HTTP
  Query API, it is formatted as yyyy-MM-dd'T'HH:mm:ss. For example, 2019-07-01T23:59:59.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxContributorCount"`: The maximum number of contributors to include in the report. The
  range is 1 to 100. If you omit this, the default of 10 is used.
- `"Metrics"`: Specifies which metrics to use for aggregation of contributor values for the
  report. You can specify one or more of the following metrics:    UniqueContributors -- the
  number of unique contributors for each data point.    MaxContributorValue -- the value of
  the top contributor for each data point. The identity of the contributor might change for
  each data point in the graph. If this rule aggregates by COUNT, the top contributor for
  each data point is the contributor with the most occurrences in that period. If the rule
  aggregates by SUM, the top contributor is the contributor with the highest sum in the log
  field specified by the rule's Value, during that period.    SampleCount -- the number of
  data points matched by the rule.    Sum -- the sum of the values from all contributors
  during the time period represented by that data point.    Minimum -- the minimum value from
  a single observation during the time period represented by that data point.    Maximum --
  the maximum value from a single observation during the time period represented by that data
  point.    Average -- the average value from all contributors during the time period
  represented by that data point.
- `"OrderBy"`: Determines what statistic to use to rank the contributors. Valid values are
  Sum and Maximum.
"""
function get_insight_rule_report(
    EndTime, Period, RuleName, StartTime; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch(
        "GetInsightRuleReport",
        Dict{String,Any}(
            "EndTime" => EndTime,
            "Period" => Period,
            "RuleName" => RuleName,
            "StartTime" => StartTime,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_insight_rule_report(
    EndTime,
    Period,
    RuleName,
    StartTime,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch(
        "GetInsightRuleReport",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EndTime" => EndTime,
                    "Period" => Period,
                    "RuleName" => RuleName,
                    "StartTime" => StartTime,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_metric_data(end_time, metric_data_queries, start_time)
    get_metric_data(end_time, metric_data_queries, start_time, params::Dict{String,<:Any})

You can use the GetMetricData API to retrieve CloudWatch metric values. The operation can
also include a CloudWatch Metrics Insights query, and one or more metric math functions. A
GetMetricData operation that does not include a query can retrieve as many as 500 different
metrics in a single request, with a total of as many as 100,800 data points. You can also
optionally perform metric math expressions on the values of the returned statistics, to
create new time series that represent new insights into your data. For example, using
Lambda metrics, you could divide the Errors metric by the Invocations metric to get an
error rate time series. For more information about metric math expressions, see Metric Math
Syntax and Functions in the Amazon CloudWatch User Guide. If you include a Metrics Insights
query, each GetMetricData operation can include only one query. But the same GetMetricData
operation can also retrieve other metrics. Metrics Insights queries can query only the most
recent three hours of metric data. For more information about Metrics Insights, see Query
your metrics with CloudWatch Metrics Insights. Calls to the GetMetricData API have a
different pricing structure than calls to GetMetricStatistics. For more information about
pricing, see Amazon CloudWatch Pricing. Amazon CloudWatch retains metric data as follows:
Data points with a period of less than 60 seconds are available for 3 hours. These data
points are high-resolution metrics and are available only for custom metrics that have been
defined with a StorageResolution of 1.   Data points with a period of 60 seconds (1-minute)
are available for 15 days.   Data points with a period of 300 seconds (5-minute) are
available for 63 days.   Data points with a period of 3600 seconds (1 hour) are available
for 455 days (15 months).   Data points that are initially published with a shorter period
are aggregated together for long-term storage. For example, if you collect data using a
period of 1 minute, the data remains available for 15 days with 1-minute resolution. After
15 days, this data is still available, but is aggregated and retrievable only with a
resolution of 5 minutes. After 63 days, the data is further aggregated and is available
with a resolution of 1 hour. If you omit Unit in your request, all data that was collected
with any unit is returned, along with the corresponding units that were specified when the
data was reported to CloudWatch. If you specify a unit, the operation returns only data
that was collected with that unit specified. If you specify a unit that does not match the
data collected, the results of the operation are null. CloudWatch does not perform unit
conversions.  Using Metrics Insights queries with metric math  You can't mix a Metric
Insights query and metric math syntax in the same expression, but you can reference results
from a Metrics Insights query within other Metric math expressions. A Metrics Insights
query without a GROUP BY clause returns a single time-series (TS), and can be used as input
for a metric math expression that expects a single time series. A Metrics Insights query
with a GROUP BY clause returns an array of time-series (TS[]), and can be used as input for
a metric math expression that expects an array of time series.

# Arguments
- `end_time`: The time stamp indicating the latest data to be returned. The value specified
  is exclusive; results include data points up to the specified time stamp. For better
  performance, specify StartTime and EndTime values that align with the value of the metric's
  Period and sync up with the beginning and end of an hour. For example, if the Period of a
  metric is 5 minutes, specifying 12:05 or 12:30 as EndTime can get a faster response from
  CloudWatch than setting 12:07 or 12:29 as the EndTime.
- `metric_data_queries`: The metric queries to be returned. A single GetMetricData call can
  include as many as 500 MetricDataQuery structures. Each of these structures can specify
  either a metric to retrieve, a Metrics Insights query, or a math expression to perform on
  retrieved data.
- `start_time`: The time stamp indicating the earliest data to be returned. The value
  specified is inclusive; results include data points with the specified time stamp.
  CloudWatch rounds the specified time stamp as follows:   Start time less than 15 days ago -
  Round down to the nearest whole minute. For example, 12:32:34 is rounded down to 12:32:00.
   Start time between 15 and 63 days ago - Round down to the nearest 5-minute clock interval.
  For example, 12:32:34 is rounded down to 12:30:00.   Start time greater than 63 days ago -
  Round down to the nearest 1-hour clock interval. For example, 12:32:34 is rounded down to
  12:00:00.   If you set Period to 5, 10, or 30, the start time of your request is rounded
  down to the nearest time that corresponds to even 5-, 10-, or 30-second divisions of a
  minute. For example, if you make a query at (HH:mm:ss) 01:05:23 for the previous 10-second
  period, the start time of your request is rounded down and you receive data from 01:05:10
  to 01:05:20. If you make a query at 15:07:17 for the previous 5 minutes of data, using a
  period of 5 seconds, you receive data timestamped between 15:02:15 and 15:07:15.  For
  better performance, specify StartTime and EndTime values that align with the value of the
  metric's Period and sync up with the beginning and end of an hour. For example, if the
  Period of a metric is 5 minutes, specifying 12:05 or 12:30 as StartTime can get a faster
  response from CloudWatch than setting 12:07 or 12:29 as the StartTime.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"LabelOptions"`: This structure includes the Timezone parameter, which you can use to
  specify your time zone so that the labels of returned data display the correct time for
  your time zone.
- `"MaxDatapoints"`: The maximum number of data points the request should return before
  paginating. If you omit this, the default of 100,800 is used.
- `"NextToken"`: Include this value, if it was returned by the previous GetMetricData
  operation, to get the next set of data points.
- `"ScanBy"`: The order in which data points should be returned. TimestampDescending
  returns the newest data first and paginates when the MaxDatapoints limit is reached.
  TimestampAscending returns the oldest data first and paginates when the MaxDatapoints limit
  is reached. If you omit this parameter, the default of TimestampDescending is used.
"""
function get_metric_data(
    EndTime,
    MetricDataQueries,
    StartTime;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch(
        "GetMetricData",
        Dict{String,Any}(
            "EndTime" => EndTime,
            "MetricDataQueries" => MetricDataQueries,
            "StartTime" => StartTime,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_metric_data(
    EndTime,
    MetricDataQueries,
    StartTime,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch(
        "GetMetricData",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EndTime" => EndTime,
                    "MetricDataQueries" => MetricDataQueries,
                    "StartTime" => StartTime,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_metric_statistics(end_time, metric_name, namespace, period, start_time)
    get_metric_statistics(end_time, metric_name, namespace, period, start_time, params::Dict{String,<:Any})

Gets statistics for the specified metric. The maximum number of data points returned from a
single call is 1,440. If you request more than 1,440 data points, CloudWatch returns an
error. To reduce the number of data points, you can narrow the specified time range and
make multiple requests across adjacent time ranges, or you can increase the specified
period. Data points are not returned in chronological order. CloudWatch aggregates data
points based on the length of the period that you specify. For example, if you request
statistics with a one-hour period, CloudWatch aggregates all data points with time stamps
that fall within each one-hour period. Therefore, the number of values aggregated by
CloudWatch is larger than the number of data points returned. CloudWatch needs raw data
points to calculate percentile statistics. If you publish data using a statistic set
instead, you can only retrieve percentile statistics for this data if one of the following
conditions is true:   The SampleCount value of the statistic set is 1.   The Min and the
Max values of the statistic set are equal.   Percentile statistics are not available for
metrics when any of the metric values are negative numbers. Amazon CloudWatch retains
metric data as follows:   Data points with a period of less than 60 seconds are available
for 3 hours. These data points are high-resolution metrics and are available only for
custom metrics that have been defined with a StorageResolution of 1.   Data points with a
period of 60 seconds (1-minute) are available for 15 days.   Data points with a period of
300 seconds (5-minute) are available for 63 days.   Data points with a period of 3600
seconds (1 hour) are available for 455 days (15 months).   Data points that are initially
published with a shorter period are aggregated together for long-term storage. For example,
if you collect data using a period of 1 minute, the data remains available for 15 days with
1-minute resolution. After 15 days, this data is still available, but is aggregated and
retrievable only with a resolution of 5 minutes. After 63 days, the data is further
aggregated and is available with a resolution of 1 hour. CloudWatch started retaining
5-minute and 1-hour metric data as of July 9, 2016. For information about metrics and
dimensions supported by Amazon Web Services services, see the Amazon CloudWatch Metrics and
Dimensions Reference in the Amazon CloudWatch User Guide.

# Arguments
- `end_time`: The time stamp that determines the last data point to return. The value
  specified is exclusive; results include data points up to the specified time stamp. In a
  raw HTTP query, the time stamp must be in ISO 8601 UTC format (for example,
  2016-10-10T23:00:00Z).
- `metric_name`: The name of the metric, with or without spaces.
- `namespace`: The namespace of the metric, with or without spaces.
- `period`: The granularity, in seconds, of the returned data points. For metrics with
  regular resolution, a period can be as short as one minute (60 seconds) and must be a
  multiple of 60. For high-resolution metrics that are collected at intervals of less than
  one minute, the period can be 1, 5, 10, 30, 60, or any multiple of 60. High-resolution
  metrics are those metrics stored by a PutMetricData call that includes a StorageResolution
  of 1 second. If the StartTime parameter specifies a time stamp that is greater than 3 hours
  ago, you must specify the period as follows or no data points in that time range is
  returned:   Start time between 3 hours and 15 days ago - Use a multiple of 60 seconds (1
  minute).   Start time between 15 and 63 days ago - Use a multiple of 300 seconds (5
  minutes).   Start time greater than 63 days ago - Use a multiple of 3600 seconds (1 hour).
- `start_time`: The time stamp that determines the first data point to return. Start times
  are evaluated relative to the time that CloudWatch receives the request. The value
  specified is inclusive; results include data points with the specified time stamp. In a raw
  HTTP query, the time stamp must be in ISO 8601 UTC format (for example,
  2016-10-03T23:00:00Z). CloudWatch rounds the specified time stamp as follows:   Start time
  less than 15 days ago - Round down to the nearest whole minute. For example, 12:32:34 is
  rounded down to 12:32:00.   Start time between 15 and 63 days ago - Round down to the
  nearest 5-minute clock interval. For example, 12:32:34 is rounded down to 12:30:00.   Start
  time greater than 63 days ago - Round down to the nearest 1-hour clock interval. For
  example, 12:32:34 is rounded down to 12:00:00.   If you set Period to 5, 10, or 30, the
  start time of your request is rounded down to the nearest time that corresponds to even 5-,
  10-, or 30-second divisions of a minute. For example, if you make a query at (HH:mm:ss)
  01:05:23 for the previous 10-second period, the start time of your request is rounded down
  and you receive data from 01:05:10 to 01:05:20. If you make a query at 15:07:17 for the
  previous 5 minutes of data, using a period of 5 seconds, you receive data timestamped
  between 15:02:15 and 15:07:15.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Dimensions"`: The dimensions. If the metric contains multiple dimensions, you must
  include a value for each dimension. CloudWatch treats each unique combination of dimensions
  as a separate metric. If a specific combination of dimensions was not published, you can't
  retrieve statistics for it. You must specify the same dimensions that were used when the
  metrics were created. For an example, see Dimension Combinations in the Amazon CloudWatch
  User Guide. For more information about specifying dimensions, see Publishing Metrics in the
  Amazon CloudWatch User Guide.
- `"ExtendedStatistics"`: The percentile statistics. Specify values between p0.0 and p100.
  When calling GetMetricStatistics, you must specify either Statistics or ExtendedStatistics,
  but not both. Percentile statistics are not available for metrics when any of the metric
  values are negative numbers.
- `"Statistics"`: The metric statistics, other than percentile. For percentile statistics,
  use ExtendedStatistics. When calling GetMetricStatistics, you must specify either
  Statistics or ExtendedStatistics, but not both.
- `"Unit"`: The unit for a given metric. If you omit Unit, all data that was collected with
  any unit is returned, along with the corresponding units that were specified when the data
  was reported to CloudWatch. If you specify a unit, the operation returns only data that was
  collected with that unit specified. If you specify a unit that does not match the data
  collected, the results of the operation are null. CloudWatch does not perform unit
  conversions.
"""
function get_metric_statistics(
    EndTime,
    MetricName,
    Namespace,
    Period,
    StartTime;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch(
        "GetMetricStatistics",
        Dict{String,Any}(
            "EndTime" => EndTime,
            "MetricName" => MetricName,
            "Namespace" => Namespace,
            "Period" => Period,
            "StartTime" => StartTime,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_metric_statistics(
    EndTime,
    MetricName,
    Namespace,
    Period,
    StartTime,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch(
        "GetMetricStatistics",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EndTime" => EndTime,
                    "MetricName" => MetricName,
                    "Namespace" => Namespace,
                    "Period" => Period,
                    "StartTime" => StartTime,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_metric_stream(name)
    get_metric_stream(name, params::Dict{String,<:Any})

Returns information about the metric stream that you specify.

# Arguments
- `name`: The name of the metric stream to retrieve information about.

"""
function get_metric_stream(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch(
        "GetMetricStream",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_metric_stream(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch(
        "GetMetricStream",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_metric_widget_image(metric_widget)
    get_metric_widget_image(metric_widget, params::Dict{String,<:Any})

You can use the GetMetricWidgetImage API to retrieve a snapshot graph of one or more Amazon
CloudWatch metrics as a bitmap image. You can then embed this image into your services and
products, such as wiki pages, reports, and documents. You could also retrieve images
regularly, such as every minute, and create your own custom live dashboard. The graph you
retrieve can include all CloudWatch metric graph features, including metric math and
horizontal and vertical annotations. There is a limit of 20 transactions per second for
this API. Each GetMetricWidgetImage action has the following limits:   As many as 100
metrics in the graph.   Up to 100 KB uncompressed payload.

# Arguments
- `metric_widget`: A JSON string that defines the bitmap graph to be retrieved. The string
  includes the metrics to include in the graph, statistics, annotations, title, axis limits,
  and so on. You can include only one MetricWidget parameter in each GetMetricWidgetImage
  call. For more information about the syntax of MetricWidget see GetMetricWidgetImage:
  Metric Widget Structure and Syntax. If any metric on the graph could not load all the
  requested data points, an orange triangle with an exclamation point appears next to the
  graph legend.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"OutputFormat"`: The format of the resulting image. Only PNG images are supported. The
  default is png. If you specify png, the API returns an HTTP response with the content-type
  set to text/xml. The image data is in a MetricWidgetImage field. For example:
  &lt;GetMetricWidgetImageResponse xmlns=&lt;URLstring&gt;&gt;
  &lt;GetMetricWidgetImageResult&gt;    &lt;MetricWidgetImage&gt;
  iVBORw0KGgoAAAANSUhEUgAAAlgAAAGQEAYAAAAip...    &lt;/MetricWidgetImage&gt;
  &lt;/GetMetricWidgetImageResult&gt;    &lt;ResponseMetadata&gt;
  &lt;RequestId&gt;6f0d4192-4d42-11e8-82c1-f539a07e0e3b&lt;/RequestId&gt;
  &lt;/ResponseMetadata&gt;   &lt;/GetMetricWidgetImageResponse&gt;  The image/png setting is
  intended only for custom HTTP requests. For most use cases, and all actions using an Amazon
  Web Services SDK, you should use png. If you specify image/png, the HTTP response has a
  content-type set to image/png, and the body of the response is a PNG image.
"""
function get_metric_widget_image(
    MetricWidget; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch(
        "GetMetricWidgetImage",
        Dict{String,Any}("MetricWidget" => MetricWidget);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_metric_widget_image(
    MetricWidget,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch(
        "GetMetricWidgetImage",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("MetricWidget" => MetricWidget), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_dashboards()
    list_dashboards(params::Dict{String,<:Any})

Returns a list of the dashboards for your account. If you include DashboardNamePrefix, only
those dashboards with names starting with the prefix are listed. Otherwise, all dashboards
in your account are listed.   ListDashboards returns up to 1000 results on one page. If
there are more than 1000 dashboards, you can call ListDashboards again and include the
value you received for NextToken in the first call, to receive the next 1000 results.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DashboardNamePrefix"`: If you specify this parameter, only the dashboards with names
  starting with the specified string are listed. The maximum length is 255, and valid
  characters are A-Z, a-z, 0-9, \".\", \"-\", and \"_\".
- `"NextToken"`: The token returned by a previous call to indicate that there is more data
  available.
"""
function list_dashboards(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch(
        "ListDashboards"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_dashboards(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch(
        "ListDashboards", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_managed_insight_rules(resource_arn)
    list_managed_insight_rules(resource_arn, params::Dict{String,<:Any})

 Returns a list that contains the number of managed Contributor Insights rules in your
account.

# Arguments
- `resource_arn`:  The ARN of an Amazon Web Services resource that has managed Contributor
  Insights rules.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`:  The maximum number of results to return in one operation. If you omit
  this parameter, the default number is used. The default number is 100.
- `"NextToken"`:  Include this value to get the next set of rules if the value was returned
  by the previous operation.
"""
function list_managed_insight_rules(
    ResourceARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch(
        "ListManagedInsightRules",
        Dict{String,Any}("ResourceARN" => ResourceARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_managed_insight_rules(
    ResourceARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch(
        "ListManagedInsightRules",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceARN" => ResourceARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_metric_streams()
    list_metric_streams(params::Dict{String,<:Any})

Returns a list of metric streams in this account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to return in one operation.
- `"NextToken"`: Include this value, if it was returned by the previous call, to get the
  next set of metric streams.
"""
function list_metric_streams(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch(
        "ListMetricStreams"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_metric_streams(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch(
        "ListMetricStreams", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_metrics()
    list_metrics(params::Dict{String,<:Any})

List the specified metrics. You can use the returned metrics with GetMetricData or
GetMetricStatistics to get statistical data. Up to 500 results are returned for any one
call. To retrieve additional results, use the returned token with subsequent calls. After
you create a metric, allow up to 15 minutes for the metric to appear. To see metric
statistics sooner, use GetMetricData or GetMetricStatistics. If you are using CloudWatch
cross-account observability, you can use this operation in a monitoring account and view
metrics from the linked source accounts. For more information, see CloudWatch cross-account
observability.  ListMetrics doesn't return information about metrics if those metrics
haven't reported data in the past two weeks. To retrieve those metrics, use GetMetricData
or GetMetricStatistics.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Dimensions"`: The dimensions to filter against. Only the dimensions that match exactly
  will be returned.
- `"IncludeLinkedAccounts"`: If you are using this operation in a monitoring account,
  specify true to include metrics from source accounts in the returned data. The default is
  false.
- `"MetricName"`: The name of the metric to filter against. Only the metrics with names
  that match exactly will be returned.
- `"Namespace"`: The metric namespace to filter against. Only the namespace that matches
  exactly will be returned.
- `"NextToken"`: The token returned by a previous call to indicate that there is more data
  available.
- `"OwningAccount"`: When you use this operation in a monitoring account, use this field to
  return metrics only from one source account. To do so, specify that source account ID in
  this field, and also specify true for IncludeLinkedAccounts.
- `"RecentlyActive"`: To filter the results to show only metrics that have had data points
  published in the past three hours, specify this parameter with a value of PT3H. This is the
  only valid value for this parameter. The results that are returned are an approximation of
  the value you specify. There is a low probability that the returned results include metrics
  with last published data as much as 40 minutes more than the specified time interval.
"""
function list_metrics(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch("ListMetrics"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_metrics(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch(
        "ListMetrics", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Displays the tags associated with a CloudWatch resource. Currently, alarms and Contributor
Insights rules support tagging.

# Arguments
- `resource_arn`: The ARN of the CloudWatch resource that you want to view tags for. The
  ARN format of an alarm is arn:aws:cloudwatch:Region:account-id:alarm:alarm-name   The ARN
  format of a Contributor Insights rule is
  arn:aws:cloudwatch:Region:account-id:insight-rule/insight-rule-name   For more information
  about ARN format, see  Resource Types Defined by Amazon CloudWatch in the Amazon Web
  Services General Reference.

"""
function list_tags_for_resource(
    ResourceARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch(
        "ListTagsForResource",
        Dict{String,Any}("ResourceARN" => ResourceARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceARN" => ResourceARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_anomaly_detector()
    put_anomaly_detector(params::Dict{String,<:Any})

Creates an anomaly detection model for a CloudWatch metric. You can use the model to
display a band of expected normal values when the metric is graphed. If you have enabled
unified cross-account observability, and this account is a monitoring account, the metric
can be in the same account or a source account. You can specify the account ID in the
object you specify in the SingleMetricAnomalyDetector parameter. For more information, see
CloudWatch Anomaly Detection.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Configuration"`: The configuration specifies details about how the anomaly detection
  model is to be trained, including time ranges to exclude when training and updating the
  model. You can specify as many as 10 time ranges. The configuration can also include the
  time zone to use for the metric.
- `"Dimensions"`: The metric dimensions to create the anomaly detection model for.
- `"MetricCharacteristics"`: Use this object to include parameters to provide information
  about your metric to CloudWatch to help it build more accurate anomaly detection models.
  Currently, it includes the PeriodicSpikes parameter.
- `"MetricMathAnomalyDetector"`: The metric math anomaly detector to be created. When using
  MetricMathAnomalyDetector, you cannot include the following parameters in the same
  operation:    Dimensions     MetricName     Namespace     Stat    the
  SingleMetricAnomalyDetector parameters of PutAnomalyDetectorInput    Instead, specify the
  metric math anomaly detector attributes as part of the property MetricMathAnomalyDetector.
- `"MetricName"`: The name of the metric to create the anomaly detection model for.
- `"Namespace"`: The namespace of the metric to create the anomaly detection model for.
- `"SingleMetricAnomalyDetector"`: A single metric anomaly detector to be created. When
  using SingleMetricAnomalyDetector, you cannot include the following parameters in the same
  operation:    Dimensions     MetricName     Namespace     Stat    the
  MetricMathAnomalyDetector parameters of PutAnomalyDetectorInput    Instead, specify the
  single metric anomaly detector attributes as part of the property
  SingleMetricAnomalyDetector.
- `"Stat"`: The statistic to use for the metric and the anomaly detection model.
"""
function put_anomaly_detector(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch(
        "PutAnomalyDetector"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function put_anomaly_detector(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch(
        "PutAnomalyDetector", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    put_composite_alarm(alarm_name, alarm_rule)
    put_composite_alarm(alarm_name, alarm_rule, params::Dict{String,<:Any})

Creates or updates a composite alarm. When you create a composite alarm, you specify a rule
expression for the alarm that takes into account the alarm states of other alarms that you
have created. The composite alarm goes into ALARM state only if all conditions of the rule
are met. The alarms specified in a composite alarm's rule expression can include metric
alarms and other composite alarms. The rule expression of a composite alarm can include as
many as 100 underlying alarms. Any single alarm can be included in the rule expressions of
as many as 150 composite alarms. Using composite alarms can reduce alarm noise. You can
create multiple metric alarms, and also create a composite alarm and set up alerts only for
the composite alarm. For example, you could create a composite alarm that goes into ALARM
state only when more than one of the underlying metric alarms are in ALARM state. Composite
alarms can take the following actions:   Notify Amazon SNS topics.   Invoke Lambda
functions.   Create OpsItems in Systems Manager Ops Center.   Create incidents in Systems
Manager Incident Manager.    It is possible to create a loop or cycle of composite alarms,
where composite alarm A depends on composite alarm B, and composite alarm B also depends on
composite alarm A. In this scenario, you can't delete any composite alarm that is part of
the cycle because there is always still a composite alarm that depends on that alarm that
you want to delete. To get out of such a situation, you must break the cycle by changing
the rule of one of the composite alarms in the cycle to remove a dependency that creates
the cycle. The simplest change to make to break a cycle is to change the AlarmRule of one
of the alarms to false.  Additionally, the evaluation of composite alarms stops if
CloudWatch detects a cycle in the evaluation path.   When this operation creates an alarm,
the alarm state is immediately set to INSUFFICIENT_DATA. The alarm is then evaluated and
its state is set appropriately. Any actions associated with the new state are then
executed. For a composite alarm, this initial time after creation is the only time that the
alarm can be in INSUFFICIENT_DATA state. When you update an existing alarm, its state is
left unchanged, but the update completely overwrites the previous configuration of the
alarm. To use this operation, you must be signed on with the cloudwatch:PutCompositeAlarm
permission that is scoped to *. You can't create a composite alarms if your
cloudwatch:PutCompositeAlarm permission has a narrower scope. If you are an IAM user, you
must have iam:CreateServiceLinkedRole to create a composite alarm that has Systems Manager
OpsItem actions.

# Arguments
- `alarm_name`: The name for the composite alarm. This name must be unique within the
  Region.
- `alarm_rule`: An expression that specifies which other alarms are to be evaluated to
  determine this composite alarm's state. For each alarm that you reference, you designate a
  function that specifies whether that alarm needs to be in ALARM state, OK state, or
  INSUFFICIENT_DATA state. You can use operators (AND, OR and NOT) to combine multiple
  functions in a single expression. You can use parenthesis to logically group the functions
  in your expression. You can use either alarm names or ARNs to reference the other alarms
  that are to be evaluated. Functions can include the following:    ALARM(\"alarm-name or
  alarm-ARN\") is TRUE if the named alarm is in ALARM state.    OK(\"alarm-name or
  alarm-ARN\") is TRUE if the named alarm is in OK state.    INSUFFICIENT_DATA(\"alarm-name
  or alarm-ARN\") is TRUE if the named alarm is in INSUFFICIENT_DATA state.    TRUE always
  evaluates to TRUE.    FALSE always evaluates to FALSE.   TRUE and FALSE are useful for
  testing a complex AlarmRule structure, and for testing your alarm actions. Alarm names
  specified in AlarmRule can be surrounded with double-quotes (\"), but do not have to be.
  The following are some examples of AlarmRule:    ALARM(CPUUtilizationTooHigh) AND
  ALARM(DiskReadOpsTooHigh) specifies that the composite alarm goes into ALARM state only if
  both CPUUtilizationTooHigh and DiskReadOpsTooHigh alarms are in ALARM state.
  ALARM(CPUUtilizationTooHigh) AND NOT ALARM(DeploymentInProgress) specifies that the alarm
  goes to ALARM state if CPUUtilizationTooHigh is in ALARM state and DeploymentInProgress is
  not in ALARM state. This example reduces alarm noise during a known deployment window.
  (ALARM(CPUUtilizationTooHigh) OR ALARM(DiskReadOpsTooHigh)) AND OK(NetworkOutTooHigh) goes
  into ALARM state if CPUUtilizationTooHigh OR DiskReadOpsTooHigh is in ALARM state, and if
  NetworkOutTooHigh is in OK state. This provides another example of using a composite alarm
  to prevent noise. This rule ensures that you are not notified with an alarm action on high
  CPU or disk usage if a known network problem is also occurring.   The AlarmRule can specify
  as many as 100 \"children\" alarms. The AlarmRule expression can have as many as 500
  elements. Elements are child alarms, TRUE or FALSE statements, and parentheses.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ActionsEnabled"`: Indicates whether actions should be executed during any changes to
  the alarm state of the composite alarm. The default is TRUE.
- `"ActionsSuppressor"`:  Actions will be suppressed if the suppressor alarm is in the
  ALARM state. ActionsSuppressor can be an AlarmName or an Amazon Resource Name (ARN) from an
  existing alarm.
- `"ActionsSuppressorExtensionPeriod"`:  The maximum time in seconds that the composite
  alarm waits after suppressor alarm goes out of the ALARM state. After this time, the
  composite alarm performs its actions.    ExtensionPeriod is required only when
  ActionsSuppressor is specified.
- `"ActionsSuppressorWaitPeriod"`:  The maximum time in seconds that the composite alarm
  waits for the suppressor alarm to go into the ALARM state. After this time, the composite
  alarm performs its actions.    WaitPeriod is required only when ActionsSuppressor is
  specified.
- `"AlarmActions"`: The actions to execute when this alarm transitions to the ALARM state
  from any other state. Each action is specified as an Amazon Resource Name (ARN). Valid
  Values: ]  Amazon SNS actions:   arn:aws:sns:region:account-id:sns-topic-name    Lambda
  actions:    Invoke the latest version of a Lambda function:
  arn:aws:lambda:region:account-id:function:function-name     Invoke a specific version of a
  Lambda function: arn:aws:lambda:region:account-id:function:function-name:version-number
  Invoke a function by using an alias Lambda function:
  arn:aws:lambda:region:account-id:function:function-name:alias-name      Systems Manager
  actions:   arn:aws:ssm:region:account-id:opsitem:severity
- `"AlarmDescription"`: The description for the composite alarm.
- `"InsufficientDataActions"`: The actions to execute when this alarm transitions to the
  INSUFFICIENT_DATA state from any other state. Each action is specified as an Amazon
  Resource Name (ARN). Valid Values: ]  Amazon SNS actions:
  arn:aws:sns:region:account-id:sns-topic-name    Lambda actions:    Invoke the latest
  version of a Lambda function: arn:aws:lambda:region:account-id:function:function-name
  Invoke a specific version of a Lambda function:
  arn:aws:lambda:region:account-id:function:function-name:version-number     Invoke a
  function by using an alias Lambda function:
  arn:aws:lambda:region:account-id:function:function-name:alias-name
- `"OKActions"`: The actions to execute when this alarm transitions to an OK state from any
  other state. Each action is specified as an Amazon Resource Name (ARN). Valid Values: ]
  Amazon SNS actions:   arn:aws:sns:region:account-id:sns-topic-name    Lambda actions:
  Invoke the latest version of a Lambda function:
  arn:aws:lambda:region:account-id:function:function-name     Invoke a specific version of a
  Lambda function: arn:aws:lambda:region:account-id:function:function-name:version-number
  Invoke a function by using an alias Lambda function:
  arn:aws:lambda:region:account-id:function:function-name:alias-name
- `"Tags"`: A list of key-value pairs to associate with the alarm. You can associate as
  many as 50 tags with an alarm. To be able to associate tags with the alarm when you create
  the alarm, you must have the cloudwatch:TagResource permission. Tags can help you organize
  and categorize your resources. You can also use them to scope user permissions by granting
  a user permission to access or change only resources with certain tag values. If you are
  using this operation to update an existing alarm, any tags you specify in this parameter
  are ignored. To change the tags of an existing alarm, use TagResource or UntagResource.
"""
function put_composite_alarm(
    AlarmName, AlarmRule; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch(
        "PutCompositeAlarm",
        Dict{String,Any}("AlarmName" => AlarmName, "AlarmRule" => AlarmRule);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_composite_alarm(
    AlarmName,
    AlarmRule,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch(
        "PutCompositeAlarm",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("AlarmName" => AlarmName, "AlarmRule" => AlarmRule),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_dashboard(dashboard_body, dashboard_name)
    put_dashboard(dashboard_body, dashboard_name, params::Dict{String,<:Any})

Creates a dashboard if it does not already exist, or updates an existing dashboard. If you
update a dashboard, the entire contents are replaced with what you specify here. All
dashboards in your account are global, not region-specific. A simple way to create a
dashboard using PutDashboard is to copy an existing dashboard. To copy an existing
dashboard using the console, you can load the dashboard and then use the View/edit source
command in the Actions menu to display the JSON block for that dashboard. Another way to
copy a dashboard is to use GetDashboard, and then use the data returned within
DashboardBody as the template for the new dashboard when you call PutDashboard. When you
create a dashboard with PutDashboard, a good practice is to add a text widget at the top of
the dashboard with a message that the dashboard was created by script and should not be
changed in the console. This message could also point console users to the location of the
DashboardBody script or the CloudFormation template used to create the dashboard.

# Arguments
- `dashboard_body`: The detailed information about the dashboard in JSON format, including
  the widgets to include and their location on the dashboard. This parameter is required. For
  more information about the syntax, see Dashboard Body Structure and Syntax.
- `dashboard_name`: The name of the dashboard. If a dashboard with this name already
  exists, this call modifies that dashboard, replacing its current contents. Otherwise, a new
  dashboard is created. The maximum length is 255, and valid characters are A-Z, a-z, 0-9,
  \"-\", and \"_\". This parameter is required.

"""
function put_dashboard(
    DashboardBody, DashboardName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch(
        "PutDashboard",
        Dict{String,Any}(
            "DashboardBody" => DashboardBody, "DashboardName" => DashboardName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_dashboard(
    DashboardBody,
    DashboardName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch(
        "PutDashboard",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DashboardBody" => DashboardBody, "DashboardName" => DashboardName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_insight_rule(rule_definition, rule_name)
    put_insight_rule(rule_definition, rule_name, params::Dict{String,<:Any})

Creates a Contributor Insights rule. Rules evaluate log events in a CloudWatch Logs log
group, enabling you to find contributor data for the log events in that log group. For more
information, see Using Contributor Insights to Analyze High-Cardinality Data. If you create
a rule, delete it, and then re-create it with the same name, historical data from the first
time the rule was created might not be available.

# Arguments
- `rule_definition`: The definition of the rule, as a JSON object. For details on the valid
  syntax, see Contributor Insights Rule Syntax.
- `rule_name`: A unique name for the rule.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"RuleState"`: The state of the rule. Valid values are ENABLED and DISABLED.
- `"Tags"`: A list of key-value pairs to associate with the Contributor Insights rule. You
  can associate as many as 50 tags with a rule. Tags can help you organize and categorize
  your resources. You can also use them to scope user permissions, by granting a user
  permission to access or change only the resources that have certain tag values. To be able
  to associate tags with a rule, you must have the cloudwatch:TagResource permission in
  addition to the cloudwatch:PutInsightRule permission. If you are using this operation to
  update an existing Contributor Insights rule, any tags you specify in this parameter are
  ignored. To change the tags of an existing rule, use TagResource.
"""
function put_insight_rule(
    RuleDefinition, RuleName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch(
        "PutInsightRule",
        Dict{String,Any}("RuleDefinition" => RuleDefinition, "RuleName" => RuleName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_insight_rule(
    RuleDefinition,
    RuleName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch(
        "PutInsightRule",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "RuleDefinition" => RuleDefinition, "RuleName" => RuleName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_managed_insight_rules(managed_rules)
    put_managed_insight_rules(managed_rules, params::Dict{String,<:Any})

 Creates a managed Contributor Insights rule for a specified Amazon Web Services resource.
When you enable a managed rule, you create a Contributor Insights rule that collects data
from Amazon Web Services services. You cannot edit these rules with PutInsightRule. The
rules can be enabled, disabled, and deleted using EnableInsightRules, DisableInsightRules,
and DeleteInsightRules. If a previously created managed rule is currently disabled, a
subsequent call to this API will re-enable it. Use ListManagedInsightRules to describe all
available rules.

# Arguments
- `managed_rules`:  A list of ManagedRules to enable.

"""
function put_managed_insight_rules(
    ManagedRules; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch(
        "PutManagedInsightRules",
        Dict{String,Any}("ManagedRules" => ManagedRules);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_managed_insight_rules(
    ManagedRules,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch(
        "PutManagedInsightRules",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ManagedRules" => ManagedRules), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_metric_alarm(alarm_name, comparison_operator, evaluation_periods)
    put_metric_alarm(alarm_name, comparison_operator, evaluation_periods, params::Dict{String,<:Any})

Creates or updates an alarm and associates it with the specified metric, metric math
expression, anomaly detection model, or Metrics Insights query. For more information about
using a Metrics Insights query for an alarm, see Create alarms on Metrics Insights queries.
Alarms based on anomaly detection models cannot have Auto Scaling actions. When this
operation creates an alarm, the alarm state is immediately set to INSUFFICIENT_DATA. The
alarm is then evaluated and its state is set appropriately. Any actions associated with the
new state are then executed. When you update an existing alarm, its state is left
unchanged, but the update completely overwrites the previous configuration of the alarm. If
you are an IAM user, you must have Amazon EC2 permissions for some alarm operations:   The
iam:CreateServiceLinkedRole permission for all alarms with EC2 actions   The
iam:CreateServiceLinkedRole permissions to create an alarm with Systems Manager OpsItem or
response plan actions.   The first time you create an alarm in the Amazon Web Services
Management Console, the CLI, or by using the PutMetricAlarm API, CloudWatch creates the
necessary service-linked role for you. The service-linked roles are called
AWSServiceRoleForCloudWatchEvents and AWSServiceRoleForCloudWatchAlarms_ActionSSM. For more
information, see Amazon Web Services service-linked role. Each PutMetricAlarm action has a
maximum uncompressed payload of 120 KB.  Cross-account alarms  You can set an alarm on
metrics in the current account, or in another account. To create a cross-account alarm that
watches a metric in a different account, you must have completed the following
pre-requisites:   The account where the metrics are located (the sharing account) must
already have a sharing role named CloudWatch-CrossAccountSharingRole. If it does not
already have this role, you must create it using the instructions in Set up a sharing
account in  Cross-account cross-Region CloudWatch console. The policy for that role must
grant access to the ID of the account where you are creating the alarm.    The account
where you are creating the alarm (the monitoring account) must already have a
service-linked role named AWSServiceRoleForCloudWatchCrossAccount to allow CloudWatch to
assume the sharing role in the sharing account. If it does not, you must create it
following the directions in Set up a monitoring account in  Cross-account cross-Region
CloudWatch console.

# Arguments
- `alarm_name`: The name for the alarm. This name must be unique within the Region. The
  name must contain only UTF-8 characters, and can't contain ASCII control characters
- `comparison_operator`:  The arithmetic operation to use when comparing the specified
  statistic and threshold. The specified statistic value is used as the first operand. The
  values LessThanLowerOrGreaterThanUpperThreshold, LessThanLowerThreshold, and
  GreaterThanUpperThreshold are used only for alarms based on anomaly detection models.
- `evaluation_periods`: The number of periods over which data is compared to the specified
  threshold. If you are setting an alarm that requires that a number of consecutive data
  points be breaching to trigger the alarm, this value specifies that number. If you are
  setting an \"M out of N\" alarm, this value is the N. An alarm's total current evaluation
  period can be no longer than one day, so this number multiplied by Period cannot be more
  than 86,400 seconds.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ActionsEnabled"`: Indicates whether actions should be executed during any changes to
  the alarm state. The default is TRUE.
- `"AlarmActions"`: The actions to execute when this alarm transitions to the ALARM state
  from any other state. Each action is specified as an Amazon Resource Name (ARN). Valid
  values:  EC2 actions:     arn:aws:automate:region:ec2:stop
  arn:aws:automate:region:ec2:terminate     arn:aws:automate:region:ec2:reboot
  arn:aws:automate:region:ec2:recover
  arn:aws:swf:region:account-id:action/actions/AWS_EC2.InstanceId.Stop/1.0
  arn:aws:swf:region:account-id:action/actions/AWS_EC2.InstanceId.Terminate/1.0
  arn:aws:swf:region:account-id:action/actions/AWS_EC2.InstanceId.Reboot/1.0
  arn:aws:swf:region:account-id:action/actions/AWS_EC2.InstanceId.Recover/1.0     Autoscaling
  action:
  arn:aws:autoscaling:region:account-id:scalingPolicy:policy-id:autoScalingGroupName/group-fri
  endly-name:policyName/policy-friendly-name      Lambda actions:    Invoke the latest
  version of a Lambda function: arn:aws:lambda:region:account-id:function:function-name
  Invoke a specific version of a Lambda function:
  arn:aws:lambda:region:account-id:function:function-name:version-number     Invoke a
  function by using an alias Lambda function:
  arn:aws:lambda:region:account-id:function:function-name:alias-name      SNS notification
  action:     arn:aws:sns:region:account-id:sns-topic-name      SSM integration actions:
  arn:aws:ssm:region:account-id:opsitem:severity#CATEGORY=category-name
  arn:aws:ssm-incidents::account-id:responseplan/response-plan-name
- `"AlarmDescription"`: The description for the alarm.
- `"DatapointsToAlarm"`: The number of data points that must be breaching to trigger the
  alarm. This is used only if you are setting an \"M out of N\" alarm. In that case, this
  value is the M. For more information, see Evaluating an Alarm in the Amazon CloudWatch User
  Guide.
- `"Dimensions"`: The dimensions for the metric specified in MetricName.
- `"EvaluateLowSampleCountPercentile"`:  Used only for alarms based on percentiles. If you
  specify ignore, the alarm state does not change during periods with too few data points to
  be statistically significant. If you specify evaluate or omit this parameter, the alarm is
  always evaluated and possibly changes state no matter how many data points are available.
  For more information, see Percentile-Based CloudWatch Alarms and Low Data Samples. Valid
  Values: evaluate | ignore
- `"ExtendedStatistic"`: The extended statistic for the metric specified in MetricName.
  When you call PutMetricAlarm and specify a MetricName, you must specify either Statistic or
  ExtendedStatistic but not both. If you specify ExtendedStatistic, the following are valid
  values:    p90     tm90     tc90     ts90     wm90     IQM     PR(n:m) where n and m are
  values of the metric    TC(X%:X%) where X is between 10 and 90 inclusive.    TM(X%:X%)
  where X is between 10 and 90 inclusive.    TS(X%:X%) where X is between 10 and 90
  inclusive.    WM(X%:X%) where X is between 10 and 90 inclusive.   For more information
  about these extended statistics, see CloudWatch statistics definitions.
- `"InsufficientDataActions"`: The actions to execute when this alarm transitions to the
  INSUFFICIENT_DATA state from any other state. Each action is specified as an Amazon
  Resource Name (ARN). Valid values:  EC2 actions:     arn:aws:automate:region:ec2:stop
  arn:aws:automate:region:ec2:terminate     arn:aws:automate:region:ec2:reboot
  arn:aws:automate:region:ec2:recover
  arn:aws:swf:region:account-id:action/actions/AWS_EC2.InstanceId.Stop/1.0
  arn:aws:swf:region:account-id:action/actions/AWS_EC2.InstanceId.Terminate/1.0
  arn:aws:swf:region:account-id:action/actions/AWS_EC2.InstanceId.Reboot/1.0
  arn:aws:swf:region:account-id:action/actions/AWS_EC2.InstanceId.Recover/1.0     Autoscaling
  action:
  arn:aws:autoscaling:region:account-id:scalingPolicy:policy-id:autoScalingGroupName/group-fri
  endly-name:policyName/policy-friendly-name      Lambda actions:    Invoke the latest
  version of a Lambda function: arn:aws:lambda:region:account-id:function:function-name
  Invoke a specific version of a Lambda function:
  arn:aws:lambda:region:account-id:function:function-name:version-number     Invoke a
  function by using an alias Lambda function:
  arn:aws:lambda:region:account-id:function:function-name:alias-name      SNS notification
  action:     arn:aws:sns:region:account-id:sns-topic-name      SSM integration actions:
  arn:aws:ssm:region:account-id:opsitem:severity#CATEGORY=category-name
  arn:aws:ssm-incidents::account-id:responseplan/response-plan-name
- `"MetricName"`: The name for the metric associated with the alarm. For each
  PutMetricAlarm operation, you must specify either MetricName or a Metrics array. If you are
  creating an alarm based on a math expression, you cannot specify this parameter, or any of
  the Namespace, Dimensions, Period, Unit, Statistic, or ExtendedStatistic parameters.
  Instead, you specify all this information in the Metrics array.
- `"Metrics"`: An array of MetricDataQuery structures that enable you to create an alarm
  based on the result of a metric math expression. For each PutMetricAlarm operation, you
  must specify either MetricName or a Metrics array. Each item in the Metrics array either
  retrieves a metric or performs a math expression. One item in the Metrics array is the
  expression that the alarm watches. You designate this expression by setting ReturnData to
  true for this object in the array. For more information, see MetricDataQuery. If you use
  the Metrics parameter, you cannot include the Namespace, MetricName, Dimensions, Period,
  Unit, Statistic, or ExtendedStatistic parameters of PutMetricAlarm in the same operation.
  Instead, you retrieve the metrics you are using in your math expression as part of the
  Metrics array.
- `"Namespace"`: The namespace for the metric associated specified in MetricName.
- `"OKActions"`: The actions to execute when this alarm transitions to an OK state from any
  other state. Each action is specified as an Amazon Resource Name (ARN). Valid values:  EC2
  actions:     arn:aws:automate:region:ec2:stop     arn:aws:automate:region:ec2:terminate
  arn:aws:automate:region:ec2:reboot     arn:aws:automate:region:ec2:recover
  arn:aws:swf:region:account-id:action/actions/AWS_EC2.InstanceId.Stop/1.0
  arn:aws:swf:region:account-id:action/actions/AWS_EC2.InstanceId.Terminate/1.0
  arn:aws:swf:region:account-id:action/actions/AWS_EC2.InstanceId.Reboot/1.0
  arn:aws:swf:region:account-id:action/actions/AWS_EC2.InstanceId.Recover/1.0     Autoscaling
  action:
  arn:aws:autoscaling:region:account-id:scalingPolicy:policy-id:autoScalingGroupName/group-fri
  endly-name:policyName/policy-friendly-name      Lambda actions:    Invoke the latest
  version of a Lambda function: arn:aws:lambda:region:account-id:function:function-name
  Invoke a specific version of a Lambda function:
  arn:aws:lambda:region:account-id:function:function-name:version-number     Invoke a
  function by using an alias Lambda function:
  arn:aws:lambda:region:account-id:function:function-name:alias-name      SNS notification
  action:     arn:aws:sns:region:account-id:sns-topic-name      SSM integration actions:
  arn:aws:ssm:region:account-id:opsitem:severity#CATEGORY=category-name
  arn:aws:ssm-incidents::account-id:responseplan/response-plan-name
- `"Period"`: The length, in seconds, used each time the metric specified in MetricName is
  evaluated. Valid values are 10, 30, and any multiple of 60.  Period is required for alarms
  based on static thresholds. If you are creating an alarm based on a metric math expression,
  you specify the period for each metric within the objects in the Metrics array. Be sure to
  specify 10 or 30 only for metrics that are stored by a PutMetricData call with a
  StorageResolution of 1. If you specify a period of 10 or 30 for a metric that does not have
  sub-minute resolution, the alarm still attempts to gather data at the period rate that you
  specify. In this case, it does not receive data for the attempts that do not correspond to
  a one-minute data resolution, and the alarm might often lapse into INSUFFICENT_DATA status.
  Specifying 10 or 30 also sets this alarm as a high-resolution alarm, which has a higher
  charge than other alarms. For more information about pricing, see Amazon CloudWatch
  Pricing. An alarm's total current evaluation period can be no longer than one day, so
  Period multiplied by EvaluationPeriods cannot be more than 86,400 seconds.
- `"Statistic"`: The statistic for the metric specified in MetricName, other than
  percentile. For percentile statistics, use ExtendedStatistic. When you call PutMetricAlarm
  and specify a MetricName, you must specify either Statistic or ExtendedStatistic, but not
  both.
- `"Tags"`: A list of key-value pairs to associate with the alarm. You can associate as
  many as 50 tags with an alarm. To be able to associate tags with the alarm when you create
  the alarm, you must have the cloudwatch:TagResource permission. Tags can help you organize
  and categorize your resources. You can also use them to scope user permissions by granting
  a user permission to access or change only resources with certain tag values. If you are
  using this operation to update an existing alarm, any tags you specify in this parameter
  are ignored. To change the tags of an existing alarm, use TagResource or UntagResource.
- `"Threshold"`: The value against which the specified statistic is compared. This
  parameter is required for alarms based on static thresholds, but should not be used for
  alarms based on anomaly detection models.
- `"ThresholdMetricId"`: If this is an alarm based on an anomaly detection model, make this
  value match the ID of the ANOMALY_DETECTION_BAND function. For an example of how to use
  this parameter, see the Anomaly Detection Model Alarm example on this page. If your alarm
  uses this parameter, it cannot have Auto Scaling actions.
- `"TreatMissingData"`:  Sets how this alarm is to handle missing data points. If
  TreatMissingData is omitted, the default behavior of missing is used. For more information,
  see Configuring How CloudWatch Alarms Treats Missing Data. Valid Values: breaching |
  notBreaching | ignore | missing   Alarms that evaluate metrics in the AWS/DynamoDB
  namespace always ignore missing data even if you choose a different option for
  TreatMissingData. When an AWS/DynamoDB metric has missing data, alarms that evaluate that
  metric remain in their current state.
- `"Unit"`: The unit of measure for the statistic. For example, the units for the Amazon
  EC2 NetworkIn metric are Bytes because NetworkIn tracks the number of bytes that an
  instance receives on all network interfaces. You can also specify a unit when you create a
  custom metric. Units help provide conceptual meaning to your data. Metric data points that
  specify a unit of measure, such as Percent, are aggregated separately. If you are creating
  an alarm based on a metric math expression, you can specify the unit for each metric (if
  needed) within the objects in the Metrics array. If you don't specify Unit, CloudWatch
  retrieves all unit types that have been published for the metric and attempts to evaluate
  the alarm. Usually, metrics are published with only one unit, so the alarm works as
  intended. However, if the metric is published with multiple types of units and you don't
  specify a unit, the alarm's behavior is not defined and it behaves unpredictably. We
  recommend omitting Unit so that you don't inadvertently specify an incorrect unit that is
  not published for this metric. Doing so causes the alarm to be stuck in the INSUFFICIENT
  DATA state.
"""
function put_metric_alarm(
    AlarmName,
    ComparisonOperator,
    EvaluationPeriods;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch(
        "PutMetricAlarm",
        Dict{String,Any}(
            "AlarmName" => AlarmName,
            "ComparisonOperator" => ComparisonOperator,
            "EvaluationPeriods" => EvaluationPeriods,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_metric_alarm(
    AlarmName,
    ComparisonOperator,
    EvaluationPeriods,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch(
        "PutMetricAlarm",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AlarmName" => AlarmName,
                    "ComparisonOperator" => ComparisonOperator,
                    "EvaluationPeriods" => EvaluationPeriods,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_metric_data(metric_data, namespace)
    put_metric_data(metric_data, namespace, params::Dict{String,<:Any})

Publishes metric data points to Amazon CloudWatch. CloudWatch associates the data points
with the specified metric. If the specified metric does not exist, CloudWatch creates the
metric. When CloudWatch creates a metric, it can take up to fifteen minutes for the metric
to appear in calls to ListMetrics. You can publish either individual data points in the
Value field, or arrays of values and the number of times each value occurred during the
period by using the Values and Counts fields in the MetricData structure. Using the Values
and Counts method enables you to publish up to 150 values per metric with one PutMetricData
request, and supports retrieving percentile statistics on this data. Each PutMetricData
request is limited to 1 MB in size for HTTP POST requests. You can send a payload
compressed by gzip. Each request is also limited to no more than 1000 different metrics.
Although the Value parameter accepts numbers of type Double, CloudWatch rejects values that
are either too small or too large. Values must be in the range of -2^360 to 2^360. In
addition, special values (for example, NaN, +Infinity, -Infinity) are not supported. You
can use up to 30 dimensions per metric to further clarify what data the metric collects.
Each dimension consists of a Name and Value pair. For more information about specifying
dimensions, see Publishing Metrics in the Amazon CloudWatch User Guide. You specify the
time stamp to be associated with each data point. You can specify time stamps that are as
much as two weeks before the current date, and as much as 2 hours after the current day and
time. Data points with time stamps from 24 hours ago or longer can take at least 48 hours
to become available for GetMetricData or GetMetricStatistics from the time they are
submitted. Data points with time stamps between 3 and 24 hours ago can take as much as 2
hours to become available for for GetMetricData or GetMetricStatistics. CloudWatch needs
raw data points to calculate percentile statistics. If you publish data using a statistic
set instead, you can only retrieve percentile statistics for this data if one of the
following conditions is true:   The SampleCount value of the statistic set is 1 and Min,
Max, and Sum are all equal.   The Min and Max are equal, and Sum is equal to Min multiplied
by SampleCount.

# Arguments
- `metric_data`: The data for the metric. The array can include no more than 1000 metrics
  per call.
- `namespace`: The namespace for the metric data. You can use ASCII characters for the
  namespace, except for control characters which are not supported. To avoid conflicts with
  Amazon Web Services service namespaces, you should not specify a namespace that begins with
  AWS/

"""
function put_metric_data(
    MetricData, Namespace; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch(
        "PutMetricData",
        Dict{String,Any}("MetricData" => MetricData, "Namespace" => Namespace);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_metric_data(
    MetricData,
    Namespace,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch(
        "PutMetricData",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("MetricData" => MetricData, "Namespace" => Namespace),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_metric_stream(firehose_arn, name, output_format, role_arn)
    put_metric_stream(firehose_arn, name, output_format, role_arn, params::Dict{String,<:Any})

Creates or updates a metric stream. Metric streams can automatically stream CloudWatch
metrics to Amazon Web Services destinations, including Amazon S3, and to many third-party
solutions. For more information, see  Using Metric Streams. To create a metric stream, you
must be signed in to an account that has the iam:PassRole permission and either the
CloudWatchFullAccess policy or the cloudwatch:PutMetricStream permission. When you create
or update a metric stream, you choose one of the following:   Stream metrics from all
metric namespaces in the account.   Stream metrics from all metric namespaces in the
account, except for the namespaces that you list in ExcludeFilters.   Stream metrics from
only the metric namespaces that you list in IncludeFilters.   By default, a metric stream
always sends the MAX, MIN, SUM, and SAMPLECOUNT statistics for each metric that is
streamed. You can use the StatisticsConfigurations parameter to have the metric stream send
additional statistics in the stream. Streaming additional statistics incurs additional
costs. For more information, see Amazon CloudWatch Pricing.  When you use PutMetricStream
to create a new metric stream, the stream is created in the running state. If you use it to
update an existing stream, the state of the stream is not changed. If you are using
CloudWatch cross-account observability and you create a metric stream in a monitoring
account, you can choose whether to include metrics from source accounts in the stream. For
more information, see CloudWatch cross-account observability.

# Arguments
- `firehose_arn`: The ARN of the Amazon Kinesis Data Firehose delivery stream to use for
  this metric stream. This Amazon Kinesis Data Firehose delivery stream must already exist
  and must be in the same account as the metric stream.
- `name`: If you are creating a new metric stream, this is the name for the new stream. The
  name must be different than the names of other metric streams in this account and Region.
  If you are updating a metric stream, specify the name of that stream here. Valid characters
  are A-Z, a-z, 0-9, \"-\" and \"_\".
- `output_format`: The output format for the stream. Valid values are json,
  opentelemetry1.0, and opentelemetry0.7. For more information about metric stream output
  formats, see  Metric streams output formats.
- `role_arn`: The ARN of an IAM role that this metric stream will use to access Amazon
  Kinesis Data Firehose resources. This IAM role must already exist and must be in the same
  account as the metric stream. This IAM role must include the following permissions:
  firehose:PutRecord   firehose:PutRecordBatch

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ExcludeFilters"`: If you specify this parameter, the stream sends metrics from all
  metric namespaces except for the namespaces that you specify here. You cannot include
  ExcludeFilters and IncludeFilters in the same operation.
- `"IncludeFilters"`: If you specify this parameter, the stream sends only the metrics from
  the metric namespaces that you specify here. You cannot include IncludeFilters and
  ExcludeFilters in the same operation.
- `"IncludeLinkedAccountsMetrics"`: If you are creating a metric stream in a monitoring
  account, specify true to include metrics from source accounts in the metric stream.
- `"StatisticsConfigurations"`: By default, a metric stream always sends the MAX, MIN, SUM,
  and SAMPLECOUNT statistics for each metric that is streamed. You can use this parameter to
  have the metric stream also send additional statistics in the stream. This array can have
  up to 100 members. For each entry in this array, you specify one or more metrics and the
  list of additional statistics to stream for those metrics. The additional statistics that
  you can stream depend on the stream's OutputFormat. If the OutputFormat is json, you can
  stream any additional statistic that is supported by CloudWatch, listed in  CloudWatch
  statistics definitions. If the OutputFormat is opentelemetry1.0 or opentelemetry0.7, you
  can stream percentile statistics such as p95, p99.9, and so on.
- `"Tags"`: A list of key-value pairs to associate with the metric stream. You can
  associate as many as 50 tags with a metric stream. Tags can help you organize and
  categorize your resources. You can also use them to scope user permissions by granting a
  user permission to access or change only resources with certain tag values. You can use
  this parameter only when you are creating a new metric stream. If you are using this
  operation to update an existing metric stream, any tags you specify in this parameter are
  ignored. To change the tags of an existing metric stream, use TagResource or UntagResource.
"""
function put_metric_stream(
    FirehoseArn,
    Name,
    OutputFormat,
    RoleArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch(
        "PutMetricStream",
        Dict{String,Any}(
            "FirehoseArn" => FirehoseArn,
            "Name" => Name,
            "OutputFormat" => OutputFormat,
            "RoleArn" => RoleArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_metric_stream(
    FirehoseArn,
    Name,
    OutputFormat,
    RoleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch(
        "PutMetricStream",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "FirehoseArn" => FirehoseArn,
                    "Name" => Name,
                    "OutputFormat" => OutputFormat,
                    "RoleArn" => RoleArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    set_alarm_state(alarm_name, state_reason, state_value)
    set_alarm_state(alarm_name, state_reason, state_value, params::Dict{String,<:Any})

Temporarily sets the state of an alarm for testing purposes. When the updated state differs
from the previous value, the action configured for the appropriate state is invoked. For
example, if your alarm is configured to send an Amazon SNS message when an alarm is
triggered, temporarily changing the alarm state to ALARM sends an SNS message. Metric
alarms returns to their actual state quickly, often within seconds. Because the metric
alarm state change happens quickly, it is typically only visible in the alarm's History tab
in the Amazon CloudWatch console or through DescribeAlarmHistory. If you use SetAlarmState
on a composite alarm, the composite alarm is not guaranteed to return to its actual state.
It returns to its actual state only once any of its children alarms change state. It is
also reevaluated if you update its configuration. If an alarm triggers EC2 Auto Scaling
policies or application Auto Scaling policies, you must include information in the
StateReasonData parameter to enable the policy to take the correct action.

# Arguments
- `alarm_name`: The name of the alarm.
- `state_reason`: The reason that this alarm is set to this specific state, in text format.
- `state_value`: The value of the state.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"StateReasonData"`: The reason that this alarm is set to this specific state, in JSON
  format. For SNS or EC2 alarm actions, this is just informational. But for EC2 Auto Scaling
  or application Auto Scaling alarm actions, the Auto Scaling policy uses the information in
  this field to take the correct action.
"""
function set_alarm_state(
    AlarmName, StateReason, StateValue; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch(
        "SetAlarmState",
        Dict{String,Any}(
            "AlarmName" => AlarmName,
            "StateReason" => StateReason,
            "StateValue" => StateValue,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function set_alarm_state(
    AlarmName,
    StateReason,
    StateValue,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch(
        "SetAlarmState",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AlarmName" => AlarmName,
                    "StateReason" => StateReason,
                    "StateValue" => StateValue,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_metric_streams(names)
    start_metric_streams(names, params::Dict{String,<:Any})

Starts the streaming of metrics for one or more of your metric streams.

# Arguments
- `names`: The array of the names of metric streams to start streaming. This is an \"all or
  nothing\" operation. If you do not have permission to access all of the metric streams that
  you list here, then none of the streams that you list in the operation will start streaming.

"""
function start_metric_streams(Names; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch(
        "StartMetricStreams",
        Dict{String,Any}("Names" => Names);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_metric_streams(
    Names, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch(
        "StartMetricStreams",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Names" => Names), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_metric_streams(names)
    stop_metric_streams(names, params::Dict{String,<:Any})

Stops the streaming of metrics for one or more of your metric streams.

# Arguments
- `names`: The array of the names of metric streams to stop streaming. This is an \"all or
  nothing\" operation. If you do not have permission to access all of the metric streams that
  you list here, then none of the streams that you list in the operation will stop streaming.

"""
function stop_metric_streams(Names; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch(
        "StopMetricStreams",
        Dict{String,Any}("Names" => Names);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_metric_streams(
    Names, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch(
        "StopMetricStreams",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Names" => Names), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Assigns one or more tags (key-value pairs) to the specified CloudWatch resource. Currently,
the only CloudWatch resources that can be tagged are alarms and Contributor Insights rules.
Tags can help you organize and categorize your resources. You can also use them to scope
user permissions by granting a user permission to access or change only resources with
certain tag values. Tags don't have any semantic meaning to Amazon Web Services and are
interpreted strictly as strings of characters. You can use the TagResource action with an
alarm that already has tags. If you specify a new tag key for the alarm, this tag is
appended to the list of tags associated with the alarm. If you specify a tag key that is
already associated with the alarm, the new tag value that you specify replaces the previous
value for that tag. You can associate as many as 50 tags with a CloudWatch resource.

# Arguments
- `resource_arn`: The ARN of the CloudWatch resource that you're adding tags to. The ARN
  format of an alarm is arn:aws:cloudwatch:Region:account-id:alarm:alarm-name   The ARN
  format of a Contributor Insights rule is
  arn:aws:cloudwatch:Region:account-id:insight-rule/insight-rule-name   For more information
  about ARN format, see  Resource Types Defined by Amazon CloudWatch in the Amazon Web
  Services General Reference.
- `tags`: The list of key-value pairs to associate with the alarm.

"""
function tag_resource(ResourceARN, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch(
        "TagResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceARN,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes one or more tags from the specified resource.

# Arguments
- `resource_arn`: The ARN of the CloudWatch resource that you're removing tags from. The
  ARN format of an alarm is arn:aws:cloudwatch:Region:account-id:alarm:alarm-name   The ARN
  format of a Contributor Insights rule is
  arn:aws:cloudwatch:Region:account-id:insight-rule/insight-rule-name   For more information
  about ARN format, see  Resource Types Defined by Amazon CloudWatch in the Amazon Web
  Services General Reference.
- `tag_keys`: The list of tag keys to remove from the resource.

"""
function untag_resource(
    ResourceARN, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch(
        "UntagResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceARN,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: athena
using AWS.Compat
using AWS.UUIDs

"""
    batch_get_named_query(named_query_ids)
    batch_get_named_query(named_query_ids, params::Dict{String,<:Any})

Returns the details of a single named query or a list of up to 50 queries, which you
provide as an array of query ID strings. Requires you to have access to the workgroup in
which the queries were saved. Use ListNamedQueriesInput to get the list of named query IDs
in the specified workgroup. If information could not be retrieved for a submitted query ID,
information about the query ID submitted is listed under UnprocessedNamedQueryId. Named
queries differ from executed queries. Use BatchGetQueryExecutionInput to get details about
each unique query execution, and ListQueryExecutionsInput to get a list of query execution
IDs.

# Arguments
- `named_query_ids`: An array of query IDs.

"""
function batch_get_named_query(
    NamedQueryIds; aws_config::AbstractAWSConfig=current_aws_config()
)
    return athena(
        "BatchGetNamedQuery",
        Dict{String,Any}("NamedQueryIds" => NamedQueryIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_named_query(
    NamedQueryIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return athena(
        "BatchGetNamedQuery",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("NamedQueryIds" => NamedQueryIds), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_get_prepared_statement(prepared_statement_names, work_group)
    batch_get_prepared_statement(prepared_statement_names, work_group, params::Dict{String,<:Any})

Returns the details of a single prepared statement or a list of up to 256 prepared
statements for the array of prepared statement names that you provide. Requires you to have
access to the workgroup to which the prepared statements belong. If a prepared statement
cannot be retrieved for the name specified, the statement is listed in
UnprocessedPreparedStatementNames.

# Arguments
- `prepared_statement_names`: A list of prepared statement names to return.
- `work_group`: The name of the workgroup to which the prepared statements belong.

"""
function batch_get_prepared_statement(
    PreparedStatementNames, WorkGroup; aws_config::AbstractAWSConfig=current_aws_config()
)
    return athena(
        "BatchGetPreparedStatement",
        Dict{String,Any}(
            "PreparedStatementNames" => PreparedStatementNames, "WorkGroup" => WorkGroup
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_prepared_statement(
    PreparedStatementNames,
    WorkGroup,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return athena(
        "BatchGetPreparedStatement",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "PreparedStatementNames" => PreparedStatementNames,
                    "WorkGroup" => WorkGroup,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_get_query_execution(query_execution_ids)
    batch_get_query_execution(query_execution_ids, params::Dict{String,<:Any})

Returns the details of a single query execution or a list of up to 50 query executions,
which you provide as an array of query execution ID strings. Requires you to have access to
the workgroup in which the queries ran. To get a list of query execution IDs, use
ListQueryExecutionsInputWorkGroup. Query executions differ from named (saved) queries. Use
BatchGetNamedQueryInput to get details about named queries.

# Arguments
- `query_execution_ids`: An array of query execution IDs.

"""
function batch_get_query_execution(
    QueryExecutionIds; aws_config::AbstractAWSConfig=current_aws_config()
)
    return athena(
        "BatchGetQueryExecution",
        Dict{String,Any}("QueryExecutionIds" => QueryExecutionIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_query_execution(
    QueryExecutionIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return athena(
        "BatchGetQueryExecution",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("QueryExecutionIds" => QueryExecutionIds), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_capacity_reservation(name)
    cancel_capacity_reservation(name, params::Dict{String,<:Any})

Cancels the capacity reservation with the specified name. Cancelled reservations remain in
your account and will be deleted 45 days after cancellation. During the 45 days, you cannot
re-purpose or reuse a reservation that has been cancelled, but you can refer to its tags
and view it for historical reference.

# Arguments
- `name`: The name of the capacity reservation to cancel.

"""
function cancel_capacity_reservation(
    Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return athena(
        "CancelCapacityReservation",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_capacity_reservation(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return athena(
        "CancelCapacityReservation",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_capacity_reservation(name, target_dpus)
    create_capacity_reservation(name, target_dpus, params::Dict{String,<:Any})

Creates a capacity reservation with the specified name and number of requested data
processing units.

# Arguments
- `name`: The name of the capacity reservation to create.
- `target_dpus`: The number of requested data processing units.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: The tags for the capacity reservation.
"""
function create_capacity_reservation(
    Name, TargetDpus; aws_config::AbstractAWSConfig=current_aws_config()
)
    return athena(
        "CreateCapacityReservation",
        Dict{String,Any}("Name" => Name, "TargetDpus" => TargetDpus);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_capacity_reservation(
    Name,
    TargetDpus,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return athena(
        "CreateCapacityReservation",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("Name" => Name, "TargetDpus" => TargetDpus), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_data_catalog(name, type)
    create_data_catalog(name, type, params::Dict{String,<:Any})

Creates (registers) a data catalog with the specified name and properties. Catalogs created
are visible to all users of the same Amazon Web Services account.

# Arguments
- `name`: The name of the data catalog to create. The catalog name must be unique for the
  Amazon Web Services account and can use a maximum of 127 alphanumeric, underscore, at sign,
  or hyphen characters. The remainder of the length constraint of 256 is reserved for use by
  Athena.
- `type`: The type of data catalog to create: LAMBDA for a federated catalog, HIVE for an
  external hive metastore, or GLUE for an Glue Data Catalog.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description of the data catalog to be created.
- `"Parameters"`: Specifies the Lambda function or functions to use for creating the data
  catalog. This is a mapping whose values depend on the catalog type.    For the HIVE data
  catalog type, use the following syntax. The metadata-function parameter is required. The
  sdk-version parameter is optional and defaults to the currently supported version.
  metadata-function=lambda_arn, sdk-version=version_number     For the LAMBDA data catalog
  type, use one of the following sets of required parameters, but not both.   If you have one
  Lambda function that processes metadata and another for reading the actual data, use the
  following syntax. Both parameters are required.  metadata-function=lambda_arn,
  record-function=lambda_arn      If you have a composite Lambda function that processes both
  metadata and data, use the following syntax to specify your Lambda function.
  function=lambda_arn       The GLUE type takes a catalog ID parameter and is required. The
  catalog_id  is the account ID of the Amazon Web Services account to which the Glue Data
  Catalog belongs.  catalog-id=catalog_id     The GLUE data catalog type also applies to the
  default AwsDataCatalog that already exists in your account, of which you can have only one
  and cannot modify.
- `"Tags"`: A list of comma separated tags to add to the data catalog that is created.
"""
function create_data_catalog(Name, Type; aws_config::AbstractAWSConfig=current_aws_config())
    return athena(
        "CreateDataCatalog",
        Dict{String,Any}("Name" => Name, "Type" => Type);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_data_catalog(
    Name,
    Type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return athena(
        "CreateDataCatalog",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Name" => Name, "Type" => Type), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_named_query(database, name, query_string)
    create_named_query(database, name, query_string, params::Dict{String,<:Any})

Creates a named query in the specified workgroup. Requires that you have access to the
workgroup.

# Arguments
- `database`: The database to which the query belongs.
- `name`: The query name.
- `query_string`: The contents of the query with all query statements.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: A unique case-sensitive string used to ensure the request to
  create the query is idempotent (executes only once). If another CreateNamedQuery request is
  received, the same response is returned and another query is not created. If a parameter
  has changed, for example, the QueryString, an error is returned.  This token is listed as
  not required because Amazon Web Services SDKs (for example the Amazon Web Services SDK for
  Java) auto-generate the token for users. If you are not using the Amazon Web Services SDK
  or the Amazon Web Services CLI, you must provide this token or the action will fail.
- `"Description"`: The query description.
- `"WorkGroup"`: The name of the workgroup in which the named query is being created.
"""
function create_named_query(
    Database, Name, QueryString; aws_config::AbstractAWSConfig=current_aws_config()
)
    return athena(
        "CreateNamedQuery",
        Dict{String,Any}(
            "Database" => Database,
            "Name" => Name,
            "QueryString" => QueryString,
            "ClientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_named_query(
    Database,
    Name,
    QueryString,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return athena(
        "CreateNamedQuery",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Database" => Database,
                    "Name" => Name,
                    "QueryString" => QueryString,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_notebook(name, work_group)
    create_notebook(name, work_group, params::Dict{String,<:Any})

Creates an empty ipynb file in the specified Apache Spark enabled workgroup. Throws an
error if a file in the workgroup with the same name already exists.

# Arguments
- `name`: The name of the ipynb file to be created in the Spark workgroup, without the
  .ipynb extension.
- `work_group`: The name of the Spark enabled workgroup in which the notebook will be
  created.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: A unique case-sensitive string used to ensure the request to
  create the notebook is idempotent (executes only once).  This token is listed as not
  required because Amazon Web Services SDKs (for example the Amazon Web Services SDK for
  Java) auto-generate the token for you. If you are not using the Amazon Web Services SDK or
  the Amazon Web Services CLI, you must provide this token or the action will fail.
"""
function create_notebook(
    Name, WorkGroup; aws_config::AbstractAWSConfig=current_aws_config()
)
    return athena(
        "CreateNotebook",
        Dict{String,Any}("Name" => Name, "WorkGroup" => WorkGroup);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_notebook(
    Name,
    WorkGroup,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return athena(
        "CreateNotebook",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("Name" => Name, "WorkGroup" => WorkGroup), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_prepared_statement(query_statement, statement_name, work_group)
    create_prepared_statement(query_statement, statement_name, work_group, params::Dict{String,<:Any})

Creates a prepared statement for use with SQL queries in Athena.

# Arguments
- `query_statement`: The query string for the prepared statement.
- `statement_name`: The name of the prepared statement.
- `work_group`: The name of the workgroup to which the prepared statement belongs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: The description of the prepared statement.
"""
function create_prepared_statement(
    QueryStatement,
    StatementName,
    WorkGroup;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return athena(
        "CreatePreparedStatement",
        Dict{String,Any}(
            "QueryStatement" => QueryStatement,
            "StatementName" => StatementName,
            "WorkGroup" => WorkGroup,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_prepared_statement(
    QueryStatement,
    StatementName,
    WorkGroup,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return athena(
        "CreatePreparedStatement",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "QueryStatement" => QueryStatement,
                    "StatementName" => StatementName,
                    "WorkGroup" => WorkGroup,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_presigned_notebook_url(session_id)
    create_presigned_notebook_url(session_id, params::Dict{String,<:Any})

Gets an authentication token and the URL at which the notebook can be accessed. During
programmatic access, CreatePresignedNotebookUrl must be called every 10 minutes to refresh
the authentication token. For information about granting programmatic access, see Grant
programmatic access.

# Arguments
- `session_id`: The session ID.

"""
function create_presigned_notebook_url(
    SessionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return athena(
        "CreatePresignedNotebookUrl",
        Dict{String,Any}("SessionId" => SessionId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_presigned_notebook_url(
    SessionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return athena(
        "CreatePresignedNotebookUrl",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("SessionId" => SessionId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_work_group(name)
    create_work_group(name, params::Dict{String,<:Any})

Creates a workgroup with the specified name. A workgroup can be an Apache Spark enabled
workgroup or an Athena SQL workgroup.

# Arguments
- `name`: The workgroup name.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Configuration"`: Contains configuration information for creating an Athena SQL
  workgroup or Spark enabled Athena workgroup. Athena SQL workgroup configuration includes
  the location in Amazon S3 where query and calculation results are stored, the encryption
  configuration, if any, used for encrypting query results, whether the Amazon CloudWatch
  Metrics are enabled for the workgroup, the limit for the amount of bytes scanned (cutoff)
  per query, if it is specified, and whether workgroup's settings (specified with
  EnforceWorkGroupConfiguration) in the WorkGroupConfiguration override client-side settings.
  See WorkGroupConfigurationEnforceWorkGroupConfiguration.
- `"Description"`: The workgroup description.
- `"Tags"`: A list of comma separated tags to add to the workgroup that is created.
"""
function create_work_group(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return athena(
        "CreateWorkGroup",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_work_group(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return athena(
        "CreateWorkGroup",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_capacity_reservation(name)
    delete_capacity_reservation(name, params::Dict{String,<:Any})

Deletes a cancelled capacity reservation. A reservation must be cancelled before it can be
deleted. A deleted reservation is immediately removed from your account and can no longer
be referenced, including by its ARN. A deleted reservation cannot be called by
GetCapacityReservation, and deleted reservations do not appear in the output of
ListCapacityReservations.

# Arguments
- `name`: The name of the capacity reservation to delete.

"""
function delete_capacity_reservation(
    Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return athena(
        "DeleteCapacityReservation",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_capacity_reservation(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return athena(
        "DeleteCapacityReservation",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_data_catalog(name)
    delete_data_catalog(name, params::Dict{String,<:Any})

Deletes a data catalog.

# Arguments
- `name`: The name of the data catalog to delete.

"""
function delete_data_catalog(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return athena(
        "DeleteDataCatalog",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_data_catalog(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return athena(
        "DeleteDataCatalog",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_named_query(named_query_id)
    delete_named_query(named_query_id, params::Dict{String,<:Any})

Deletes the named query if you have access to the workgroup in which the query was saved.

# Arguments
- `named_query_id`: The unique ID of the query to delete.

"""
function delete_named_query(
    NamedQueryId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return athena(
        "DeleteNamedQuery",
        Dict{String,Any}("NamedQueryId" => NamedQueryId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_named_query(
    NamedQueryId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return athena(
        "DeleteNamedQuery",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("NamedQueryId" => NamedQueryId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_notebook(notebook_id)
    delete_notebook(notebook_id, params::Dict{String,<:Any})

Deletes the specified notebook.

# Arguments
- `notebook_id`: The ID of the notebook to delete.

"""
function delete_notebook(NotebookId; aws_config::AbstractAWSConfig=current_aws_config())
    return athena(
        "DeleteNotebook",
        Dict{String,Any}("NotebookId" => NotebookId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_notebook(
    NotebookId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return athena(
        "DeleteNotebook",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("NotebookId" => NotebookId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_prepared_statement(statement_name, work_group)
    delete_prepared_statement(statement_name, work_group, params::Dict{String,<:Any})

Deletes the prepared statement with the specified name from the specified workgroup.

# Arguments
- `statement_name`: The name of the prepared statement to delete.
- `work_group`: The workgroup to which the statement to be deleted belongs.

"""
function delete_prepared_statement(
    StatementName, WorkGroup; aws_config::AbstractAWSConfig=current_aws_config()
)
    return athena(
        "DeletePreparedStatement",
        Dict{String,Any}("StatementName" => StatementName, "WorkGroup" => WorkGroup);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_prepared_statement(
    StatementName,
    WorkGroup,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return athena(
        "DeletePreparedStatement",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "StatementName" => StatementName, "WorkGroup" => WorkGroup
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_work_group(work_group)
    delete_work_group(work_group, params::Dict{String,<:Any})

Deletes the workgroup with the specified name. The primary workgroup cannot be deleted.

# Arguments
- `work_group`: The unique name of the workgroup to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"RecursiveDeleteOption"`: The option to delete the workgroup and its contents even if
  the workgroup contains any named queries, query executions, or notebooks.
"""
function delete_work_group(WorkGroup; aws_config::AbstractAWSConfig=current_aws_config())
    return athena(
        "DeleteWorkGroup",
        Dict{String,Any}("WorkGroup" => WorkGroup);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_work_group(
    WorkGroup,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return athena(
        "DeleteWorkGroup",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("WorkGroup" => WorkGroup), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    export_notebook(notebook_id)
    export_notebook(notebook_id, params::Dict{String,<:Any})

Exports the specified notebook and its metadata.

# Arguments
- `notebook_id`: The ID of the notebook to export.

"""
function export_notebook(NotebookId; aws_config::AbstractAWSConfig=current_aws_config())
    return athena(
        "ExportNotebook",
        Dict{String,Any}("NotebookId" => NotebookId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function export_notebook(
    NotebookId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return athena(
        "ExportNotebook",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("NotebookId" => NotebookId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_calculation_execution(calculation_execution_id)
    get_calculation_execution(calculation_execution_id, params::Dict{String,<:Any})

Describes a previously submitted calculation execution.

# Arguments
- `calculation_execution_id`: The calculation execution UUID.

"""
function get_calculation_execution(
    CalculationExecutionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return athena(
        "GetCalculationExecution",
        Dict{String,Any}("CalculationExecutionId" => CalculationExecutionId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_calculation_execution(
    CalculationExecutionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return athena(
        "GetCalculationExecution",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("CalculationExecutionId" => CalculationExecutionId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_calculation_execution_code(calculation_execution_id)
    get_calculation_execution_code(calculation_execution_id, params::Dict{String,<:Any})

Retrieves the unencrypted code that was executed for the calculation.

# Arguments
- `calculation_execution_id`: The calculation execution UUID.

"""
function get_calculation_execution_code(
    CalculationExecutionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return athena(
        "GetCalculationExecutionCode",
        Dict{String,Any}("CalculationExecutionId" => CalculationExecutionId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_calculation_execution_code(
    CalculationExecutionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return athena(
        "GetCalculationExecutionCode",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("CalculationExecutionId" => CalculationExecutionId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_calculation_execution_status(calculation_execution_id)
    get_calculation_execution_status(calculation_execution_id, params::Dict{String,<:Any})

Gets the status of a current calculation.

# Arguments
- `calculation_execution_id`: The calculation execution UUID.

"""
function get_calculation_execution_status(
    CalculationExecutionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return athena(
        "GetCalculationExecutionStatus",
        Dict{String,Any}("CalculationExecutionId" => CalculationExecutionId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_calculation_execution_status(
    CalculationExecutionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return athena(
        "GetCalculationExecutionStatus",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("CalculationExecutionId" => CalculationExecutionId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_capacity_assignment_configuration(capacity_reservation_name)
    get_capacity_assignment_configuration(capacity_reservation_name, params::Dict{String,<:Any})

Gets the capacity assignment configuration for a capacity reservation, if one exists.

# Arguments
- `capacity_reservation_name`: The name of the capacity reservation to retrieve the
  capacity assignment configuration for.

"""
function get_capacity_assignment_configuration(
    CapacityReservationName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return athena(
        "GetCapacityAssignmentConfiguration",
        Dict{String,Any}("CapacityReservationName" => CapacityReservationName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_capacity_assignment_configuration(
    CapacityReservationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return athena(
        "GetCapacityAssignmentConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("CapacityReservationName" => CapacityReservationName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_capacity_reservation(name)
    get_capacity_reservation(name, params::Dict{String,<:Any})

Returns information about the capacity reservation with the specified name.

# Arguments
- `name`: The name of the capacity reservation.

"""
function get_capacity_reservation(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return athena(
        "GetCapacityReservation",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_capacity_reservation(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return athena(
        "GetCapacityReservation",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_data_catalog(name)
    get_data_catalog(name, params::Dict{String,<:Any})

Returns the specified data catalog.

# Arguments
- `name`: The name of the data catalog to return.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"WorkGroup"`: The name of the workgroup. Required if making an IAM Identity Center
  request.
"""
function get_data_catalog(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return athena(
        "GetDataCatalog",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_data_catalog(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return athena(
        "GetDataCatalog",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_database(catalog_name, database_name)
    get_database(catalog_name, database_name, params::Dict{String,<:Any})

Returns a database object for the specified database and data catalog.

# Arguments
- `catalog_name`: The name of the data catalog that contains the database to return.
- `database_name`: The name of the database to return.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"WorkGroup"`: The name of the workgroup for which the metadata is being fetched.
  Required if requesting an IAM Identity Center enabled Glue Data Catalog.
"""
function get_database(
    CatalogName, DatabaseName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return athena(
        "GetDatabase",
        Dict{String,Any}("CatalogName" => CatalogName, "DatabaseName" => DatabaseName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_database(
    CatalogName,
    DatabaseName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return athena(
        "GetDatabase",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CatalogName" => CatalogName, "DatabaseName" => DatabaseName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_named_query(named_query_id)
    get_named_query(named_query_id, params::Dict{String,<:Any})

Returns information about a single query. Requires that you have access to the workgroup in
which the query was saved.

# Arguments
- `named_query_id`: The unique ID of the query. Use ListNamedQueries to get query IDs.

"""
function get_named_query(NamedQueryId; aws_config::AbstractAWSConfig=current_aws_config())
    return athena(
        "GetNamedQuery",
        Dict{String,Any}("NamedQueryId" => NamedQueryId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_named_query(
    NamedQueryId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return athena(
        "GetNamedQuery",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("NamedQueryId" => NamedQueryId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_notebook_metadata(notebook_id)
    get_notebook_metadata(notebook_id, params::Dict{String,<:Any})

Retrieves notebook metadata for the specified notebook ID.

# Arguments
- `notebook_id`: The ID of the notebook whose metadata is to be retrieved.

"""
function get_notebook_metadata(
    NotebookId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return athena(
        "GetNotebookMetadata",
        Dict{String,Any}("NotebookId" => NotebookId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_notebook_metadata(
    NotebookId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return athena(
        "GetNotebookMetadata",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("NotebookId" => NotebookId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_prepared_statement(statement_name, work_group)
    get_prepared_statement(statement_name, work_group, params::Dict{String,<:Any})

Retrieves the prepared statement with the specified name from the specified workgroup.

# Arguments
- `statement_name`: The name of the prepared statement to retrieve.
- `work_group`: The workgroup to which the statement to be retrieved belongs.

"""
function get_prepared_statement(
    StatementName, WorkGroup; aws_config::AbstractAWSConfig=current_aws_config()
)
    return athena(
        "GetPreparedStatement",
        Dict{String,Any}("StatementName" => StatementName, "WorkGroup" => WorkGroup);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_prepared_statement(
    StatementName,
    WorkGroup,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return athena(
        "GetPreparedStatement",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "StatementName" => StatementName, "WorkGroup" => WorkGroup
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_query_execution(query_execution_id)
    get_query_execution(query_execution_id, params::Dict{String,<:Any})

Returns information about a single execution of a query if you have access to the workgroup
in which the query ran. Each time a query executes, information about the query execution
is saved with a unique ID.

# Arguments
- `query_execution_id`: The unique ID of the query execution.

"""
function get_query_execution(
    QueryExecutionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return athena(
        "GetQueryExecution",
        Dict{String,Any}("QueryExecutionId" => QueryExecutionId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_query_execution(
    QueryExecutionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return athena(
        "GetQueryExecution",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("QueryExecutionId" => QueryExecutionId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_query_results(query_execution_id)
    get_query_results(query_execution_id, params::Dict{String,<:Any})

Streams the results of a single query execution specified by QueryExecutionId from the
Athena query results location in Amazon S3. For more information, see Working with query
results, recent queries, and output files in the Amazon Athena User Guide. This request
does not execute the query but returns results. Use StartQueryExecution to run a query. To
stream query results successfully, the IAM principal with permission to call
GetQueryResults also must have permissions to the Amazon S3 GetObject action for the Athena
query results location.  IAM principals with permission to the Amazon S3 GetObject action
for the query results location are able to retrieve query results from Amazon S3 even if
permission to the GetQueryResults action is denied. To restrict user or role access, ensure
that Amazon S3 permissions to the Athena query location are denied.

# Arguments
- `query_execution_id`: The unique ID of the query execution.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results (rows) to return in this request.
- `"NextToken"`: A token generated by the Athena service that specifies where to continue
  pagination if a previous request was truncated. To obtain the next set of pages, pass in
  the NextToken from the response object of the previous page call.
"""
function get_query_results(
    QueryExecutionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return athena(
        "GetQueryResults",
        Dict{String,Any}("QueryExecutionId" => QueryExecutionId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_query_results(
    QueryExecutionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return athena(
        "GetQueryResults",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("QueryExecutionId" => QueryExecutionId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_query_runtime_statistics(query_execution_id)
    get_query_runtime_statistics(query_execution_id, params::Dict{String,<:Any})

Returns query execution runtime statistics related to a single execution of a query if you
have access to the workgroup in which the query ran. Statistics from the Timeline section
of the response object are available as soon as QueryExecutionStatusState is in a SUCCEEDED
or FAILED state. The remaining non-timeline statistics in the response (like stage-level
input and output row count and data size) are updated asynchronously and may not be
available immediately after a query completes. The non-timeline statistics are also not
included when a query has row-level filters defined in Lake Formation.

# Arguments
- `query_execution_id`: The unique ID of the query execution.

"""
function get_query_runtime_statistics(
    QueryExecutionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return athena(
        "GetQueryRuntimeStatistics",
        Dict{String,Any}("QueryExecutionId" => QueryExecutionId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_query_runtime_statistics(
    QueryExecutionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return athena(
        "GetQueryRuntimeStatistics",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("QueryExecutionId" => QueryExecutionId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_session(session_id)
    get_session(session_id, params::Dict{String,<:Any})

Gets the full details of a previously created session, including the session status and
configuration.

# Arguments
- `session_id`: The session ID.

"""
function get_session(SessionId; aws_config::AbstractAWSConfig=current_aws_config())
    return athena(
        "GetSession",
        Dict{String,Any}("SessionId" => SessionId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_session(
    SessionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return athena(
        "GetSession",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("SessionId" => SessionId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_session_status(session_id)
    get_session_status(session_id, params::Dict{String,<:Any})

Gets the current status of a session.

# Arguments
- `session_id`: The session ID.

"""
function get_session_status(SessionId; aws_config::AbstractAWSConfig=current_aws_config())
    return athena(
        "GetSessionStatus",
        Dict{String,Any}("SessionId" => SessionId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_session_status(
    SessionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return athena(
        "GetSessionStatus",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("SessionId" => SessionId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_table_metadata(catalog_name, database_name, table_name)
    get_table_metadata(catalog_name, database_name, table_name, params::Dict{String,<:Any})

Returns table metadata for the specified catalog, database, and table.

# Arguments
- `catalog_name`: The name of the data catalog that contains the database and table
  metadata to return.
- `database_name`: The name of the database that contains the table metadata to return.
- `table_name`: The name of the table for which metadata is returned.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"WorkGroup"`: The name of the workgroup for which the metadata is being fetched.
  Required if requesting an IAM Identity Center enabled Glue Data Catalog.
"""
function get_table_metadata(
    CatalogName, DatabaseName, TableName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return athena(
        "GetTableMetadata",
        Dict{String,Any}(
            "CatalogName" => CatalogName,
            "DatabaseName" => DatabaseName,
            "TableName" => TableName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_table_metadata(
    CatalogName,
    DatabaseName,
    TableName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return athena(
        "GetTableMetadata",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CatalogName" => CatalogName,
                    "DatabaseName" => DatabaseName,
                    "TableName" => TableName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_work_group(work_group)
    get_work_group(work_group, params::Dict{String,<:Any})

Returns information about the workgroup with the specified name.

# Arguments
- `work_group`: The name of the workgroup.

"""
function get_work_group(WorkGroup; aws_config::AbstractAWSConfig=current_aws_config())
    return athena(
        "GetWorkGroup",
        Dict{String,Any}("WorkGroup" => WorkGroup);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_work_group(
    WorkGroup,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return athena(
        "GetWorkGroup",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("WorkGroup" => WorkGroup), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    import_notebook(name, type, work_group)
    import_notebook(name, type, work_group, params::Dict{String,<:Any})

Imports a single ipynb file to a Spark enabled workgroup. To import the notebook, the
request must specify a value for either Payload or NoteBookS3LocationUri. If neither is
specified or both are specified, an InvalidRequestException occurs. The maximum file size
that can be imported is 10 megabytes. If an ipynb file with the same name already exists in
the workgroup, throws an error.

# Arguments
- `name`: The name of the notebook to import.
- `type`: The notebook content type. Currently, the only valid type is IPYNB.
- `work_group`: The name of the Spark enabled workgroup to import the notebook to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: A unique case-sensitive string used to ensure the request to
  import the notebook is idempotent (executes only once).  This token is listed as not
  required because Amazon Web Services SDKs (for example the Amazon Web Services SDK for
  Java) auto-generate the token for you. If you are not using the Amazon Web Services SDK or
  the Amazon Web Services CLI, you must provide this token or the action will fail.
- `"NotebookS3LocationUri"`: A URI that specifies the Amazon S3 location of a notebook file
  in ipynb format.
- `"Payload"`: The notebook content to be imported. The payload must be in ipynb format.
"""
function import_notebook(
    Name, Type, WorkGroup; aws_config::AbstractAWSConfig=current_aws_config()
)
    return athena(
        "ImportNotebook",
        Dict{String,Any}("Name" => Name, "Type" => Type, "WorkGroup" => WorkGroup);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function import_notebook(
    Name,
    Type,
    WorkGroup,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return athena(
        "ImportNotebook",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Name" => Name, "Type" => Type, "WorkGroup" => WorkGroup),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_application_dpusizes()
    list_application_dpusizes(params::Dict{String,<:Any})

Returns the supported DPU sizes for the supported application runtimes (for example, Athena
notebook version 1).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Specifies the maximum number of results to return.
- `"NextToken"`: A token generated by the Athena service that specifies where to continue
  pagination if a previous request was truncated.
"""
function list_application_dpusizes(; aws_config::AbstractAWSConfig=current_aws_config())
    return athena(
        "ListApplicationDPUSizes"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_application_dpusizes(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return athena(
        "ListApplicationDPUSizes",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_calculation_executions(session_id)
    list_calculation_executions(session_id, params::Dict{String,<:Any})

Lists the calculations that have been submitted to a session in descending order. Newer
calculations are listed first; older calculations are listed later.

# Arguments
- `session_id`: The session ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of calculation executions to return.
- `"NextToken"`: A token generated by the Athena service that specifies where to continue
  pagination if a previous request was truncated. To obtain the next set of pages, pass in
  the NextToken from the response object of the previous page call.
- `"StateFilter"`: A filter for a specific calculation execution state. A description of
  each state follows.  CREATING - The calculation is in the process of being created.
  CREATED - The calculation has been created and is ready to run.  QUEUED - The calculation
  has been queued for processing.  RUNNING - The calculation is running.  CANCELING - A
  request to cancel the calculation has been received and the system is working to stop it.
  CANCELED - The calculation is no longer running as the result of a cancel request.
  COMPLETED - The calculation has completed without error.  FAILED - The calculation failed
  and is no longer running.
"""
function list_calculation_executions(
    SessionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return athena(
        "ListCalculationExecutions",
        Dict{String,Any}("SessionId" => SessionId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_calculation_executions(
    SessionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return athena(
        "ListCalculationExecutions",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("SessionId" => SessionId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_capacity_reservations()
    list_capacity_reservations(params::Dict{String,<:Any})

Lists the capacity reservations for the current account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Specifies the maximum number of results to return.
- `"NextToken"`: A token generated by the Athena service that specifies where to continue
  pagination if a previous request was truncated.
"""
function list_capacity_reservations(; aws_config::AbstractAWSConfig=current_aws_config())
    return athena(
        "ListCapacityReservations"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_capacity_reservations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return athena(
        "ListCapacityReservations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_data_catalogs()
    list_data_catalogs(params::Dict{String,<:Any})

Lists the data catalogs in the current Amazon Web Services account.  In the Athena console,
data catalogs are listed as \"data sources\" on the Data sources page under the Data source
name column.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Specifies the maximum number of data catalogs to return.
- `"NextToken"`: A token generated by the Athena service that specifies where to continue
  pagination if a previous request was truncated. To obtain the next set of pages, pass in
  the NextToken from the response object of the previous page call.
- `"WorkGroup"`: The name of the workgroup. Required if making an IAM Identity Center
  request.
"""
function list_data_catalogs(; aws_config::AbstractAWSConfig=current_aws_config())
    return athena(
        "ListDataCatalogs"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_data_catalogs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return athena(
        "ListDataCatalogs", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_databases(catalog_name)
    list_databases(catalog_name, params::Dict{String,<:Any})

Lists the databases in the specified data catalog.

# Arguments
- `catalog_name`: The name of the data catalog that contains the databases to return.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Specifies the maximum number of results to return.
- `"NextToken"`: A token generated by the Athena service that specifies where to continue
  pagination if a previous request was truncated. To obtain the next set of pages, pass in
  the NextToken from the response object of the previous page call.
- `"WorkGroup"`: The name of the workgroup for which the metadata is being fetched.
  Required if requesting an IAM Identity Center enabled Glue Data Catalog.
"""
function list_databases(CatalogName; aws_config::AbstractAWSConfig=current_aws_config())
    return athena(
        "ListDatabases",
        Dict{String,Any}("CatalogName" => CatalogName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_databases(
    CatalogName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return athena(
        "ListDatabases",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("CatalogName" => CatalogName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_engine_versions()
    list_engine_versions(params::Dict{String,<:Any})

Returns a list of engine versions that are available to choose from, including the Auto
option.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of engine versions to return in this request.
- `"NextToken"`: A token generated by the Athena service that specifies where to continue
  pagination if a previous request was truncated. To obtain the next set of pages, pass in
  the NextToken from the response object of the previous page call.
"""
function list_engine_versions(; aws_config::AbstractAWSConfig=current_aws_config())
    return athena(
        "ListEngineVersions"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_engine_versions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return athena(
        "ListEngineVersions", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_executors(session_id)
    list_executors(session_id, params::Dict{String,<:Any})

Lists, in descending order, the executors that joined a session. Newer executors are listed
first; older executors are listed later. The result can be optionally filtered by state.

# Arguments
- `session_id`: The session ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ExecutorStateFilter"`: A filter for a specific executor state. A description of each
  state follows.  CREATING - The executor is being started, including acquiring resources.
  CREATED - The executor has been started.  REGISTERED - The executor has been registered.
  TERMINATING - The executor is in the process of shutting down.  TERMINATED - The executor
  is no longer running.  FAILED - Due to a failure, the executor is no longer running.
- `"MaxResults"`: The maximum number of executors to return.
- `"NextToken"`: A token generated by the Athena service that specifies where to continue
  pagination if a previous request was truncated. To obtain the next set of pages, pass in
  the NextToken from the response object of the previous page call.
"""
function list_executors(SessionId; aws_config::AbstractAWSConfig=current_aws_config())
    return athena(
        "ListExecutors",
        Dict{String,Any}("SessionId" => SessionId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_executors(
    SessionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return athena(
        "ListExecutors",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("SessionId" => SessionId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_named_queries()
    list_named_queries(params::Dict{String,<:Any})

Provides a list of available query IDs only for queries saved in the specified workgroup.
Requires that you have access to the specified workgroup. If a workgroup is not specified,
lists the saved queries for the primary workgroup.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of queries to return in this request.
- `"NextToken"`: A token generated by the Athena service that specifies where to continue
  pagination if a previous request was truncated. To obtain the next set of pages, pass in
  the NextToken from the response object of the previous page call.
- `"WorkGroup"`: The name of the workgroup from which the named queries are being returned.
  If a workgroup is not specified, the saved queries for the primary workgroup are returned.
"""
function list_named_queries(; aws_config::AbstractAWSConfig=current_aws_config())
    return athena(
        "ListNamedQueries"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_named_queries(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return athena(
        "ListNamedQueries", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_notebook_metadata(work_group)
    list_notebook_metadata(work_group, params::Dict{String,<:Any})

Displays the notebook files for the specified workgroup in paginated format.

# Arguments
- `work_group`: The name of the Spark enabled workgroup to retrieve notebook metadata for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: Search filter string.
- `"MaxResults"`: Specifies the maximum number of results to return.
- `"NextToken"`: A token generated by the Athena service that specifies where to continue
  pagination if a previous request was truncated.
"""
function list_notebook_metadata(
    WorkGroup; aws_config::AbstractAWSConfig=current_aws_config()
)
    return athena(
        "ListNotebookMetadata",
        Dict{String,Any}("WorkGroup" => WorkGroup);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_notebook_metadata(
    WorkGroup,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return athena(
        "ListNotebookMetadata",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("WorkGroup" => WorkGroup), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_notebook_sessions(notebook_id)
    list_notebook_sessions(notebook_id, params::Dict{String,<:Any})

Lists, in descending order, the sessions that have been created in a notebook that are in
an active state like CREATING, CREATED, IDLE or BUSY. Newer sessions are listed first;
older sessions are listed later.

# Arguments
- `notebook_id`: The ID of the notebook to list sessions for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of notebook sessions to return.
- `"NextToken"`: A token generated by the Athena service that specifies where to continue
  pagination if a previous request was truncated. To obtain the next set of pages, pass in
  the NextToken from the response object of the previous page call.
"""
function list_notebook_sessions(
    NotebookId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return athena(
        "ListNotebookSessions",
        Dict{String,Any}("NotebookId" => NotebookId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_notebook_sessions(
    NotebookId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return athena(
        "ListNotebookSessions",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("NotebookId" => NotebookId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_prepared_statements(work_group)
    list_prepared_statements(work_group, params::Dict{String,<:Any})

Lists the prepared statements in the specified workgroup.

# Arguments
- `work_group`: The workgroup to list the prepared statements for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to return in this request.
- `"NextToken"`: A token generated by the Athena service that specifies where to continue
  pagination if a previous request was truncated. To obtain the next set of pages, pass in
  the NextToken from the response object of the previous page call.
"""
function list_prepared_statements(
    WorkGroup; aws_config::AbstractAWSConfig=current_aws_config()
)
    return athena(
        "ListPreparedStatements",
        Dict{String,Any}("WorkGroup" => WorkGroup);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_prepared_statements(
    WorkGroup,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return athena(
        "ListPreparedStatements",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("WorkGroup" => WorkGroup), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_query_executions()
    list_query_executions(params::Dict{String,<:Any})

Provides a list of available query execution IDs for the queries in the specified
workgroup. Athena keeps a query history for 45 days. If a workgroup is not specified,
returns a list of query execution IDs for the primary workgroup. Requires you to have
access to the workgroup in which the queries ran.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of query executions to return in this request.
- `"NextToken"`: A token generated by the Athena service that specifies where to continue
  pagination if a previous request was truncated. To obtain the next set of pages, pass in
  the NextToken from the response object of the previous page call.
- `"WorkGroup"`: The name of the workgroup from which queries are being returned. If a
  workgroup is not specified, a list of available query execution IDs for the queries in the
  primary workgroup is returned.
"""
function list_query_executions(; aws_config::AbstractAWSConfig=current_aws_config())
    return athena(
        "ListQueryExecutions"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_query_executions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return athena(
        "ListQueryExecutions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_sessions(work_group)
    list_sessions(work_group, params::Dict{String,<:Any})

Lists the sessions in a workgroup that are in an active state like CREATING, CREATED, IDLE,
or BUSY. Newer sessions are listed first; older sessions are listed later.

# Arguments
- `work_group`: The workgroup to which the session belongs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of sessions to return.
- `"NextToken"`: A token generated by the Athena service that specifies where to continue
  pagination if a previous request was truncated. To obtain the next set of pages, pass in
  the NextToken from the response object of the previous page call.
- `"StateFilter"`: A filter for a specific session state. A description of each state
  follows.  CREATING - The session is being started, including acquiring resources.  CREATED
  - The session has been started.  IDLE - The session is able to accept a calculation.  BUSY
  - The session is processing another task and is unable to accept a calculation.
  TERMINATING - The session is in the process of shutting down.  TERMINATED - The session and
  its resources are no longer running.  DEGRADED - The session has no healthy coordinators.
  FAILED - Due to a failure, the session and its resources are no longer running.
"""
function list_sessions(WorkGroup; aws_config::AbstractAWSConfig=current_aws_config())
    return athena(
        "ListSessions",
        Dict{String,Any}("WorkGroup" => WorkGroup);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_sessions(
    WorkGroup,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return athena(
        "ListSessions",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("WorkGroup" => WorkGroup), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_table_metadata(catalog_name, database_name)
    list_table_metadata(catalog_name, database_name, params::Dict{String,<:Any})

Lists the metadata for the tables in the specified data catalog database.

# Arguments
- `catalog_name`: The name of the data catalog for which table metadata should be returned.
- `database_name`: The name of the database for which table metadata should be returned.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Expression"`: A regex filter that pattern-matches table names. If no expression is
  supplied, metadata for all tables are listed.
- `"MaxResults"`: Specifies the maximum number of results to return.
- `"NextToken"`: A token generated by the Athena service that specifies where to continue
  pagination if a previous request was truncated. To obtain the next set of pages, pass in
  the NextToken from the response object of the previous page call.
- `"WorkGroup"`: The name of the workgroup for which the metadata is being fetched.
  Required if requesting an IAM Identity Center enabled Glue Data Catalog.
"""
function list_table_metadata(
    CatalogName, DatabaseName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return athena(
        "ListTableMetadata",
        Dict{String,Any}("CatalogName" => CatalogName, "DatabaseName" => DatabaseName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_table_metadata(
    CatalogName,
    DatabaseName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return athena(
        "ListTableMetadata",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CatalogName" => CatalogName, "DatabaseName" => DatabaseName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists the tags associated with an Athena resource.

# Arguments
- `resource_arn`: Lists the tags for the resource with the specified ARN.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to be returned per request that lists the
  tags for the resource.
- `"NextToken"`: The token for the next set of results, or null if there are no additional
  results for this request, where the request lists the tags for the resource with the
  specified ARN.
"""
function list_tags_for_resource(
    ResourceARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return athena(
        "ListTagsForResource",
        Dict{String,Any}("ResourceARN" => ResourceARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return athena(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceARN" => ResourceARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_work_groups()
    list_work_groups(params::Dict{String,<:Any})

Lists available workgroups for the account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of workgroups to return in this request.
- `"NextToken"`: A token generated by the Athena service that specifies where to continue
  pagination if a previous request was truncated. To obtain the next set of pages, pass in
  the NextToken from the response object of the previous page call.
"""
function list_work_groups(; aws_config::AbstractAWSConfig=current_aws_config())
    return athena("ListWorkGroups"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_work_groups(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return athena(
        "ListWorkGroups", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    put_capacity_assignment_configuration(capacity_assignments, capacity_reservation_name)
    put_capacity_assignment_configuration(capacity_assignments, capacity_reservation_name, params::Dict{String,<:Any})

Puts a new capacity assignment configuration for a specified capacity reservation. If a
capacity assignment configuration already exists for the capacity reservation, replaces the
existing capacity assignment configuration.

# Arguments
- `capacity_assignments`: The list of assignments for the capacity assignment configuration.
- `capacity_reservation_name`: The name of the capacity reservation to put a capacity
  assignment configuration for.

"""
function put_capacity_assignment_configuration(
    CapacityAssignments,
    CapacityReservationName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return athena(
        "PutCapacityAssignmentConfiguration",
        Dict{String,Any}(
            "CapacityAssignments" => CapacityAssignments,
            "CapacityReservationName" => CapacityReservationName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_capacity_assignment_configuration(
    CapacityAssignments,
    CapacityReservationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return athena(
        "PutCapacityAssignmentConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CapacityAssignments" => CapacityAssignments,
                    "CapacityReservationName" => CapacityReservationName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_calculation_execution(session_id)
    start_calculation_execution(session_id, params::Dict{String,<:Any})

Submits calculations for execution within a session. You can supply the code to run as an
inline code block within the request.  The request syntax requires the
StartCalculationExecutionRequestCodeBlock parameter or the
CalculationConfigurationCodeBlock parameter, but not both. Because
CalculationConfigurationCodeBlock is deprecated, use the
StartCalculationExecutionRequestCodeBlock parameter instead.

# Arguments
- `session_id`: The session ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CalculationConfiguration"`: Contains configuration information for the calculation.
- `"ClientRequestToken"`: A unique case-sensitive string used to ensure the request to
  create the calculation is idempotent (executes only once). If another
  StartCalculationExecutionRequest is received, the same response is returned and another
  calculation is not created. If a parameter has changed, an error is returned.  This token
  is listed as not required because Amazon Web Services SDKs (for example the Amazon Web
  Services SDK for Java) auto-generate the token for users. If you are not using the Amazon
  Web Services SDK or the Amazon Web Services CLI, you must provide this token or the action
  will fail.
- `"CodeBlock"`: A string that contains the code of the calculation. Use this parameter
  instead of CalculationConfigurationCodeBlock, which is deprecated.
- `"Description"`: A description of the calculation.
"""
function start_calculation_execution(
    SessionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return athena(
        "StartCalculationExecution",
        Dict{String,Any}("SessionId" => SessionId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_calculation_execution(
    SessionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return athena(
        "StartCalculationExecution",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("SessionId" => SessionId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_query_execution(query_string)
    start_query_execution(query_string, params::Dict{String,<:Any})

Runs the SQL query statements contained in the Query. Requires you to have access to the
workgroup in which the query ran. Running queries against an external catalog requires
GetDataCatalog permission to the catalog. For code samples using the Amazon Web Services
SDK for Java, see Examples and Code Samples in the Amazon Athena User Guide.

# Arguments
- `query_string`: The SQL query statements to be executed.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: A unique case-sensitive string used to ensure the request to
  create the query is idempotent (executes only once). If another StartQueryExecution request
  is received, the same response is returned and another query is not created. An error is
  returned if a parameter, such as QueryString, has changed. A call to StartQueryExecution
  that uses a previous client request token returns the same QueryExecutionId even if the
  requester doesn't have permission on the tables specified in QueryString.  This token is
  listed as not required because Amazon Web Services SDKs (for example the Amazon Web
  Services SDK for Java) auto-generate the token for users. If you are not using the Amazon
  Web Services SDK or the Amazon Web Services CLI, you must provide this token or the action
  will fail.
- `"ExecutionParameters"`: A list of values for the parameters in a query. The values are
  applied sequentially to the parameters in the query in the order in which the parameters
  occur.
- `"QueryExecutionContext"`: The database within which the query executes.
- `"ResultConfiguration"`: Specifies information about where and how to save the results of
  the query execution. If the query runs in a workgroup, then workgroup's settings may
  override query settings. This affects the query results location. The workgroup settings
  override is specified in EnforceWorkGroupConfiguration (true/false) in the
  WorkGroupConfiguration. See WorkGroupConfigurationEnforceWorkGroupConfiguration.
- `"ResultReuseConfiguration"`: Specifies the query result reuse behavior for the query.
- `"WorkGroup"`: The name of the workgroup in which the query is being started.
"""
function start_query_execution(
    QueryString; aws_config::AbstractAWSConfig=current_aws_config()
)
    return athena(
        "StartQueryExecution",
        Dict{String,Any}(
            "QueryString" => QueryString, "ClientRequestToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_query_execution(
    QueryString,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return athena(
        "StartQueryExecution",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "QueryString" => QueryString, "ClientRequestToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_session(engine_configuration, work_group)
    start_session(engine_configuration, work_group, params::Dict{String,<:Any})

Creates a session for running calculations within a workgroup. The session is ready when it
reaches an IDLE state.

# Arguments
- `engine_configuration`: Contains engine data processing unit (DPU) configuration settings
  and parameter mappings.
- `work_group`: The workgroup to which the session belongs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: A unique case-sensitive string used to ensure the request to
  create the session is idempotent (executes only once). If another StartSessionRequest is
  received, the same response is returned and another session is not created. If a parameter
  has changed, an error is returned.  This token is listed as not required because Amazon Web
  Services SDKs (for example the Amazon Web Services SDK for Java) auto-generate the token
  for users. If you are not using the Amazon Web Services SDK or the Amazon Web Services CLI,
  you must provide this token or the action will fail.
- `"Description"`: The session description.
- `"NotebookVersion"`: The notebook version. This value is supplied automatically for
  notebook sessions in the Athena console and is not required for programmatic session
  access. The only valid notebook version is Athena notebook version 1. If you specify a
  value for NotebookVersion, you must also specify a value for NotebookId. See
  EngineConfigurationAdditionalConfigs.
- `"SessionIdleTimeoutInMinutes"`: The idle timeout in minutes for the session.
"""
function start_session(
    EngineConfiguration, WorkGroup; aws_config::AbstractAWSConfig=current_aws_config()
)
    return athena(
        "StartSession",
        Dict{String,Any}(
            "EngineConfiguration" => EngineConfiguration, "WorkGroup" => WorkGroup
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_session(
    EngineConfiguration,
    WorkGroup,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return athena(
        "StartSession",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EngineConfiguration" => EngineConfiguration, "WorkGroup" => WorkGroup
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_calculation_execution(calculation_execution_id)
    stop_calculation_execution(calculation_execution_id, params::Dict{String,<:Any})

Requests the cancellation of a calculation. A StopCalculationExecution call on a
calculation that is already in a terminal state (for example, STOPPED, FAILED, or
COMPLETED) succeeds but has no effect.  Cancelling a calculation is done on a best effort
basis. If a calculation cannot be cancelled, you can be charged for its completion. If you
are concerned about being charged for a calculation that cannot be cancelled, consider
terminating the session in which the calculation is running.

# Arguments
- `calculation_execution_id`: The calculation execution UUID.

"""
function stop_calculation_execution(
    CalculationExecutionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return athena(
        "StopCalculationExecution",
        Dict{String,Any}("CalculationExecutionId" => CalculationExecutionId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_calculation_execution(
    CalculationExecutionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return athena(
        "StopCalculationExecution",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("CalculationExecutionId" => CalculationExecutionId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_query_execution(query_execution_id)
    stop_query_execution(query_execution_id, params::Dict{String,<:Any})

Stops a query execution. Requires you to have access to the workgroup in which the query
ran.

# Arguments
- `query_execution_id`: The unique ID of the query execution to stop.

"""
function stop_query_execution(
    QueryExecutionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return athena(
        "StopQueryExecution",
        Dict{String,Any}("QueryExecutionId" => QueryExecutionId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_query_execution(
    QueryExecutionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return athena(
        "StopQueryExecution",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("QueryExecutionId" => QueryExecutionId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds one or more tags to an Athena resource. A tag is a label that you assign to a
resource. Each tag consists of a key and an optional value, both of which you define. For
example, you can use tags to categorize Athena workgroups, data catalogs, or capacity
reservations by purpose, owner, or environment. Use a consistent set of tag keys to make it
easier to search and filter the resources in your account. For best practices, see Tagging
Best Practices. Tag keys can be from 1 to 128 UTF-8 Unicode characters, and tag values can
be from 0 to 256 UTF-8 Unicode characters. Tags can use letters and numbers representable
in UTF-8, and the following characters: + - = . _ : / @. Tag keys and values are
case-sensitive. Tag keys must be unique per resource. If you specify more than one tag,
separate them by commas.

# Arguments
- `resource_arn`: Specifies the ARN of the Athena resource to which tags are to be added.
- `tags`: A collection of one or more tags, separated by commas, to be added to an Athena
  resource.

"""
function tag_resource(ResourceARN, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return athena(
        "TagResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceARN,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return athena(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    terminate_session(session_id)
    terminate_session(session_id, params::Dict{String,<:Any})

Terminates an active session. A TerminateSession call on a session that is already inactive
(for example, in a FAILED, TERMINATED or TERMINATING state) succeeds but has no effect.
Calculations running in the session when TerminateSession is called are forcefully stopped,
but may display as FAILED instead of STOPPED.

# Arguments
- `session_id`: The session ID.

"""
function terminate_session(SessionId; aws_config::AbstractAWSConfig=current_aws_config())
    return athena(
        "TerminateSession",
        Dict{String,Any}("SessionId" => SessionId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function terminate_session(
    SessionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return athena(
        "TerminateSession",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("SessionId" => SessionId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes one or more tags from an Athena resource.

# Arguments
- `resource_arn`: Specifies the ARN of the resource from which tags are to be removed.
- `tag_keys`: A comma-separated list of one or more tag keys whose tags are to be removed
  from the specified resource.

"""
function untag_resource(
    ResourceARN, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return athena(
        "UntagResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceARN,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return athena(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_capacity_reservation(name, target_dpus)
    update_capacity_reservation(name, target_dpus, params::Dict{String,<:Any})

Updates the number of requested data processing units for the capacity reservation with the
specified name.

# Arguments
- `name`: The name of the capacity reservation.
- `target_dpus`: The new number of requested data processing units.

"""
function update_capacity_reservation(
    Name, TargetDpus; aws_config::AbstractAWSConfig=current_aws_config()
)
    return athena(
        "UpdateCapacityReservation",
        Dict{String,Any}("Name" => Name, "TargetDpus" => TargetDpus);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_capacity_reservation(
    Name,
    TargetDpus,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return athena(
        "UpdateCapacityReservation",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("Name" => Name, "TargetDpus" => TargetDpus), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_data_catalog(name, type)
    update_data_catalog(name, type, params::Dict{String,<:Any})

Updates the data catalog that has the specified name.

# Arguments
- `name`: The name of the data catalog to update. The catalog name must be unique for the
  Amazon Web Services account and can use a maximum of 127 alphanumeric, underscore, at sign,
  or hyphen characters. The remainder of the length constraint of 256 is reserved for use by
  Athena.
- `type`: Specifies the type of data catalog to update. Specify LAMBDA for a federated
  catalog, HIVE for an external hive metastore, or GLUE for an Glue Data Catalog.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: New or modified text that describes the data catalog.
- `"Parameters"`: Specifies the Lambda function or functions to use for updating the data
  catalog. This is a mapping whose values depend on the catalog type.    For the HIVE data
  catalog type, use the following syntax. The metadata-function parameter is required. The
  sdk-version parameter is optional and defaults to the currently supported version.
  metadata-function=lambda_arn, sdk-version=version_number     For the LAMBDA data catalog
  type, use one of the following sets of required parameters, but not both.   If you have one
  Lambda function that processes metadata and another for reading the actual data, use the
  following syntax. Both parameters are required.  metadata-function=lambda_arn,
  record-function=lambda_arn      If you have a composite Lambda function that processes both
  metadata and data, use the following syntax to specify your Lambda function.
  function=lambda_arn
"""
function update_data_catalog(Name, Type; aws_config::AbstractAWSConfig=current_aws_config())
    return athena(
        "UpdateDataCatalog",
        Dict{String,Any}("Name" => Name, "Type" => Type);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_data_catalog(
    Name,
    Type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return athena(
        "UpdateDataCatalog",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Name" => Name, "Type" => Type), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_named_query(name, named_query_id, query_string)
    update_named_query(name, named_query_id, query_string, params::Dict{String,<:Any})

Updates a NamedQuery object. The database or workgroup cannot be updated.

# Arguments
- `name`: The name of the query.
- `named_query_id`: The unique identifier (UUID) of the query.
- `query_string`: The contents of the query with all query statements.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: The query description.
"""
function update_named_query(
    Name, NamedQueryId, QueryString; aws_config::AbstractAWSConfig=current_aws_config()
)
    return athena(
        "UpdateNamedQuery",
        Dict{String,Any}(
            "Name" => Name, "NamedQueryId" => NamedQueryId, "QueryString" => QueryString
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_named_query(
    Name,
    NamedQueryId,
    QueryString,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return athena(
        "UpdateNamedQuery",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Name" => Name,
                    "NamedQueryId" => NamedQueryId,
                    "QueryString" => QueryString,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_notebook(notebook_id, payload, type)
    update_notebook(notebook_id, payload, type, params::Dict{String,<:Any})

Updates the contents of a Spark notebook.

# Arguments
- `notebook_id`: The ID of the notebook to update.
- `payload`: The updated content for the notebook.
- `type`: The notebook content type. Currently, the only valid type is IPYNB.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: A unique case-sensitive string used to ensure the request to
  create the notebook is idempotent (executes only once).  This token is listed as not
  required because Amazon Web Services SDKs (for example the Amazon Web Services SDK for
  Java) auto-generate the token for you. If you are not using the Amazon Web Services SDK or
  the Amazon Web Services CLI, you must provide this token or the action will fail.
- `"SessionId"`: The active notebook session ID. Required if the notebook has an active
  session.
"""
function update_notebook(
    NotebookId, Payload, Type; aws_config::AbstractAWSConfig=current_aws_config()
)
    return athena(
        "UpdateNotebook",
        Dict{String,Any}("NotebookId" => NotebookId, "Payload" => Payload, "Type" => Type);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_notebook(
    NotebookId,
    Payload,
    Type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return athena(
        "UpdateNotebook",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "NotebookId" => NotebookId, "Payload" => Payload, "Type" => Type
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_notebook_metadata(name, notebook_id)
    update_notebook_metadata(name, notebook_id, params::Dict{String,<:Any})

Updates the metadata for a notebook.

# Arguments
- `name`: The name to update the notebook to.
- `notebook_id`: The ID of the notebook to update the metadata for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: A unique case-sensitive string used to ensure the request to
  create the notebook is idempotent (executes only once).  This token is listed as not
  required because Amazon Web Services SDKs (for example the Amazon Web Services SDK for
  Java) auto-generate the token for you. If you are not using the Amazon Web Services SDK or
  the Amazon Web Services CLI, you must provide this token or the action will fail.
"""
function update_notebook_metadata(
    Name, NotebookId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return athena(
        "UpdateNotebookMetadata",
        Dict{String,Any}("Name" => Name, "NotebookId" => NotebookId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_notebook_metadata(
    Name,
    NotebookId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return athena(
        "UpdateNotebookMetadata",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("Name" => Name, "NotebookId" => NotebookId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_prepared_statement(query_statement, statement_name, work_group)
    update_prepared_statement(query_statement, statement_name, work_group, params::Dict{String,<:Any})

Updates a prepared statement.

# Arguments
- `query_statement`: The query string for the prepared statement.
- `statement_name`: The name of the prepared statement.
- `work_group`: The workgroup for the prepared statement.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: The description of the prepared statement.
"""
function update_prepared_statement(
    QueryStatement,
    StatementName,
    WorkGroup;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return athena(
        "UpdatePreparedStatement",
        Dict{String,Any}(
            "QueryStatement" => QueryStatement,
            "StatementName" => StatementName,
            "WorkGroup" => WorkGroup,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_prepared_statement(
    QueryStatement,
    StatementName,
    WorkGroup,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return athena(
        "UpdatePreparedStatement",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "QueryStatement" => QueryStatement,
                    "StatementName" => StatementName,
                    "WorkGroup" => WorkGroup,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_work_group(work_group)
    update_work_group(work_group, params::Dict{String,<:Any})

Updates the workgroup with the specified name. The workgroup's name cannot be changed. Only
ConfigurationUpdates can be specified.

# Arguments
- `work_group`: The specified workgroup that will be updated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConfigurationUpdates"`: Contains configuration updates for an Athena SQL workgroup.
- `"Description"`: The workgroup description.
- `"State"`: The workgroup state that will be updated for the given workgroup.
"""
function update_work_group(WorkGroup; aws_config::AbstractAWSConfig=current_aws_config())
    return athena(
        "UpdateWorkGroup",
        Dict{String,Any}("WorkGroup" => WorkGroup);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_work_group(
    WorkGroup,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return athena(
        "UpdateWorkGroup",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("WorkGroup" => WorkGroup), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: pinpoint_sms_voice_v2
using AWS.Compat
using AWS.UUIDs

"""
    associate_origination_identity(iso_country_code, origination_identity, pool_id)
    associate_origination_identity(iso_country_code, origination_identity, pool_id, params::Dict{String,<:Any})

Associates the specified origination identity with a pool. If the origination identity is a
phone number and is already associated with another pool, an error is returned. A sender ID
can be associated with multiple pools. If the origination identity configuration doesn't
match the pool's configuration, an error is returned.

# Arguments
- `iso_country_code`: The new two-character code, in ISO 3166-1 alpha-2 format, for the
  country or region of the origination identity.
- `origination_identity`: The origination identity to use, such as PhoneNumberId,
  PhoneNumberArn, SenderId, or SenderIdArn. You can use DescribePhoneNumbers to find the
  values for PhoneNumberId and PhoneNumberArn, while DescribeSenderIds can be used to get the
  values for SenderId and SenderIdArn.
- `pool_id`: The pool to update with the new Identity. This value can be either the PoolId
  or PoolArn, and you can find these values using DescribePools.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If you don't specify a client token, a randomly generated token
  is used for the request to ensure idempotency.
"""
function associate_origination_identity(
    IsoCountryCode,
    OriginationIdentity,
    PoolId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "AssociateOriginationIdentity",
        Dict{String,Any}(
            "IsoCountryCode" => IsoCountryCode,
            "OriginationIdentity" => OriginationIdentity,
            "PoolId" => PoolId,
            "ClientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_origination_identity(
    IsoCountryCode,
    OriginationIdentity,
    PoolId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "AssociateOriginationIdentity",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "IsoCountryCode" => IsoCountryCode,
                    "OriginationIdentity" => OriginationIdentity,
                    "PoolId" => PoolId,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_protect_configuration(configuration_set_name, protect_configuration_id)
    associate_protect_configuration(configuration_set_name, protect_configuration_id, params::Dict{String,<:Any})

Associate a protect configuration with a configuration set. This replaces the configuration
sets current protect configuration. A configuration set can only be associated with one
protect configuration at a time. A protect configuration can be associated with multiple
configuration sets.

# Arguments
- `configuration_set_name`: The name of the ConfigurationSet.
- `protect_configuration_id`: The unique identifier for the protect configuration.

"""
function associate_protect_configuration(
    ConfigurationSetName,
    ProtectConfigurationId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "AssociateProtectConfiguration",
        Dict{String,Any}(
            "ConfigurationSetName" => ConfigurationSetName,
            "ProtectConfigurationId" => ProtectConfigurationId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_protect_configuration(
    ConfigurationSetName,
    ProtectConfigurationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "AssociateProtectConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ConfigurationSetName" => ConfigurationSetName,
                    "ProtectConfigurationId" => ProtectConfigurationId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_configuration_set(configuration_set_name)
    create_configuration_set(configuration_set_name, params::Dict{String,<:Any})

Creates a new configuration set. After you create the configuration set, you can add one or
more event destinations to it. A configuration set is a set of rules that you apply to the
SMS and voice messages that you send. When you send a message, you can optionally specify a
single configuration set.

# Arguments
- `configuration_set_name`: The name to use for the new configuration set.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If you don't specify a client token, a randomly generated token
  is used for the request to ensure idempotency.
- `"Tags"`: An array of key and value pair tags that's associated with the new
  configuration set.
"""
function create_configuration_set(
    ConfigurationSetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "CreateConfigurationSet",
        Dict{String,Any}(
            "ConfigurationSetName" => ConfigurationSetName, "ClientToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_configuration_set(
    ConfigurationSetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "CreateConfigurationSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ConfigurationSetName" => ConfigurationSetName,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_event_destination(configuration_set_name, event_destination_name, matching_event_types)
    create_event_destination(configuration_set_name, event_destination_name, matching_event_types, params::Dict{String,<:Any})

Creates a new event destination in a configuration set. An event destination is a location
where you send message events. The event options are Amazon CloudWatch, Amazon Kinesis Data
Firehose, or Amazon SNS. For example, when a message is delivered successfully, you can
send information about that event to an event destination, or send notifications to
endpoints that are subscribed to an Amazon SNS topic. Each configuration set can contain
between 0 and 5 event destinations. Each event destination can contain a reference to a
single destination, such as a CloudWatch or Kinesis Data Firehose destination.

# Arguments
- `configuration_set_name`: Either the name of the configuration set or the configuration
  set ARN to apply event logging to. The ConfigurateSetName and ConfigurationSetArn can be
  found using the DescribeConfigurationSets action.
- `event_destination_name`: The name that identifies the event destination.
- `matching_event_types`: An array of event types that determine which events to log. If
  \"ALL\" is used, then Amazon Pinpoint logs every event type.  The TEXT_SENT event type is
  not supported.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If you don't specify a client token, a randomly generated token
  is used for the request to ensure idempotency.
- `"CloudWatchLogsDestination"`: An object that contains information about an event
  destination for logging to Amazon CloudWatch Logs.
- `"KinesisFirehoseDestination"`: An object that contains information about an event
  destination for logging to Amazon Kinesis Data Firehose.
- `"SnsDestination"`: An object that contains information about an event destination for
  logging to Amazon SNS.
"""
function create_event_destination(
    ConfigurationSetName,
    EventDestinationName,
    MatchingEventTypes;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "CreateEventDestination",
        Dict{String,Any}(
            "ConfigurationSetName" => ConfigurationSetName,
            "EventDestinationName" => EventDestinationName,
            "MatchingEventTypes" => MatchingEventTypes,
            "ClientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_event_destination(
    ConfigurationSetName,
    EventDestinationName,
    MatchingEventTypes,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "CreateEventDestination",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ConfigurationSetName" => ConfigurationSetName,
                    "EventDestinationName" => EventDestinationName,
                    "MatchingEventTypes" => MatchingEventTypes,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_opt_out_list(opt_out_list_name)
    create_opt_out_list(opt_out_list_name, params::Dict{String,<:Any})

Creates a new opt-out list. If the opt-out list name already exists, an error is returned.
An opt-out list is a list of phone numbers that are opted out, meaning you can't send SMS
or voice messages to them. If end user replies with the keyword \"STOP,\" an entry for the
phone number is added to the opt-out list. In addition to STOP, your recipients can use any
supported opt-out keyword, such as CANCEL or OPTOUT. For a list of supported opt-out
keywords, see  SMS opt out  in the Amazon Pinpoint User Guide.

# Arguments
- `opt_out_list_name`: The name of the new OptOutList.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If you don't specify a client token, a randomly generated token
  is used for the request to ensure idempotency.
- `"Tags"`: An array of tags (key and value pairs) to associate with the new OptOutList.
"""
function create_opt_out_list(
    OptOutListName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "CreateOptOutList",
        Dict{String,Any}(
            "OptOutListName" => OptOutListName, "ClientToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_opt_out_list(
    OptOutListName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "CreateOptOutList",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "OptOutListName" => OptOutListName, "ClientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_pool(iso_country_code, message_type, origination_identity)
    create_pool(iso_country_code, message_type, origination_identity, params::Dict{String,<:Any})

Creates a new pool and associates the specified origination identity to the pool. A pool
can include one or more phone numbers and SenderIds that are associated with your Amazon
Web Services account. The new pool inherits its configuration from the specified
origination identity. This includes keywords, message type, opt-out list, two-way
configuration, and self-managed opt-out configuration. Deletion protection isn't inherited
from the origination identity and defaults to false. If the origination identity is a phone
number and is already associated with another pool, an error is returned. A sender ID can
be associated with multiple pools.

# Arguments
- `iso_country_code`: The new two-character code, in ISO 3166-1 alpha-2 format, for the
  country or region of the new pool.
- `message_type`: The type of message. Valid values are TRANSACTIONAL for messages that are
  critical or time-sensitive and PROMOTIONAL for messages that aren't critical or
  time-sensitive.
- `origination_identity`: The origination identity to use such as a PhoneNumberId,
  PhoneNumberArn, SenderId or SenderIdArn. You can use DescribePhoneNumbers to find the
  values for PhoneNumberId and PhoneNumberArn while DescribeSenderIds can be used to get the
  values for SenderId and SenderIdArn.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If you don't specify a client token, a randomly generated token
  is used for the request to ensure idempotency.
- `"DeletionProtectionEnabled"`: By default this is set to false. When set to true the pool
  can't be deleted. You can change this value using the UpdatePool action.
- `"Tags"`: An array of tags (key and value pairs) associated with the pool.
"""
function create_pool(
    IsoCountryCode,
    MessageType,
    OriginationIdentity;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "CreatePool",
        Dict{String,Any}(
            "IsoCountryCode" => IsoCountryCode,
            "MessageType" => MessageType,
            "OriginationIdentity" => OriginationIdentity,
            "ClientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_pool(
    IsoCountryCode,
    MessageType,
    OriginationIdentity,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "CreatePool",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "IsoCountryCode" => IsoCountryCode,
                    "MessageType" => MessageType,
                    "OriginationIdentity" => OriginationIdentity,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_protect_configuration()
    create_protect_configuration(params::Dict{String,<:Any})

Create a new protect configuration. By default all country rule sets for each capability
are set to ALLOW. Update the country rule sets using
UpdateProtectConfigurationCountryRuleSet. A protect configurations name is stored as a Tag
with the key set to Name and value as the name of the protect configuration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If you don't specify a client token, a randomly generated token
  is used for the request to ensure idempotency.
- `"DeletionProtectionEnabled"`: When set to true deletion protection is enabled. By
  default this is set to false.
- `"Tags"`: An array of key and value pair tags that are associated with the resource.
"""
function create_protect_configuration(; aws_config::AbstractAWSConfig=current_aws_config())
    return pinpoint_sms_voice_v2(
        "CreateProtectConfiguration",
        Dict{String,Any}("ClientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_protect_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "CreateProtectConfiguration",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ClientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_registration(registration_type)
    create_registration(registration_type, params::Dict{String,<:Any})

Creates a new registration based on the RegistrationType field.

# Arguments
- `registration_type`: The type of registration form to create. The list of
  RegistrationTypes can be found using the DescribeRegistrationTypeDefinitions action.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If you don't specify a client token, a randomly generated token
  is used for the request to ensure idempotency.
- `"Tags"`: An array of tags (key and value pairs) to associate with the registration.
"""
function create_registration(
    RegistrationType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "CreateRegistration",
        Dict{String,Any}(
            "RegistrationType" => RegistrationType, "ClientToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_registration(
    RegistrationType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "CreateRegistration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "RegistrationType" => RegistrationType, "ClientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_registration_association(registration_id, resource_id)
    create_registration_association(registration_id, resource_id, params::Dict{String,<:Any})

Associate the registration with an origination identity such as a phone number or sender ID.

# Arguments
- `registration_id`: The unique identifier for the registration.
- `resource_id`: The unique identifier for the origination identity. For example this could
  be a PhoneNumberId or SenderId.

"""
function create_registration_association(
    RegistrationId, ResourceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "CreateRegistrationAssociation",
        Dict{String,Any}("RegistrationId" => RegistrationId, "ResourceId" => ResourceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_registration_association(
    RegistrationId,
    ResourceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "CreateRegistrationAssociation",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "RegistrationId" => RegistrationId, "ResourceId" => ResourceId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_registration_attachment()
    create_registration_attachment(params::Dict{String,<:Any})

Create a new registration attachment to use for uploading a file or a URL to a file. The
maximum file size is 1MiB and valid file extensions are PDF, JPEG and PNG. For example,
many sender ID registrations require a signed “letter of authorization” (LOA) to be
submitted.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AttachmentBody"`: The registration file to upload. The maximum file size is 1MiB and
  valid file extensions are PDF, JPEG and PNG.
- `"AttachmentUrl"`: A URL to the required registration file. For example, you can provide
  the S3 object URL.
- `"ClientToken"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If you don't specify a client token, a randomly generated token
  is used for the request to ensure idempotency.
- `"Tags"`: An array of tags (key and value pairs) to associate with the registration
  attachment.
"""
function create_registration_attachment(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "CreateRegistrationAttachment",
        Dict{String,Any}("ClientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_registration_attachment(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "CreateRegistrationAttachment",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ClientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_registration_version(registration_id)
    create_registration_version(registration_id, params::Dict{String,<:Any})

Create a new version of the registration and increase the VersionNumber. The previous
version of the registration becomes read-only.

# Arguments
- `registration_id`: The unique identifier for the registration.

"""
function create_registration_version(
    RegistrationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "CreateRegistrationVersion",
        Dict{String,Any}("RegistrationId" => RegistrationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_registration_version(
    RegistrationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "CreateRegistrationVersion",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("RegistrationId" => RegistrationId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_verified_destination_number(destination_phone_number)
    create_verified_destination_number(destination_phone_number, params::Dict{String,<:Any})

You can only send messages to verified destination numbers when your account is in the
sandbox. You can add up to 10 verified destination numbers.

# Arguments
- `destination_phone_number`: The verified destination phone number, in E.164 format.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If you don't specify a client token, a randomly generated token
  is used for the request to ensure idempotency.
- `"Tags"`: An array of tags (key and value pairs) to associate with the destination number.
"""
function create_verified_destination_number(
    DestinationPhoneNumber; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "CreateVerifiedDestinationNumber",
        Dict{String,Any}(
            "DestinationPhoneNumber" => DestinationPhoneNumber,
            "ClientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_verified_destination_number(
    DestinationPhoneNumber,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "CreateVerifiedDestinationNumber",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DestinationPhoneNumber" => DestinationPhoneNumber,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_account_default_protect_configuration()
    delete_account_default_protect_configuration(params::Dict{String,<:Any})

Removes the current account default protect configuration.

"""
function delete_account_default_protect_configuration(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "DeleteAccountDefaultProtectConfiguration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_account_default_protect_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "DeleteAccountDefaultProtectConfiguration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_configuration_set(configuration_set_name)
    delete_configuration_set(configuration_set_name, params::Dict{String,<:Any})

Deletes an existing configuration set. A configuration set is a set of rules that you apply
to voice and SMS messages that you send. In a configuration set, you can specify a
destination for specific types of events related to voice and SMS messages.

# Arguments
- `configuration_set_name`: The name of the configuration set or the configuration set ARN
  that you want to delete. The ConfigurationSetName and ConfigurationSetArn can be found
  using the DescribeConfigurationSets action.

"""
function delete_configuration_set(
    ConfigurationSetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "DeleteConfigurationSet",
        Dict{String,Any}("ConfigurationSetName" => ConfigurationSetName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_configuration_set(
    ConfigurationSetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "DeleteConfigurationSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ConfigurationSetName" => ConfigurationSetName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_default_message_type(configuration_set_name)
    delete_default_message_type(configuration_set_name, params::Dict{String,<:Any})

Deletes an existing default message type on a configuration set.  A message type is a type
of messages that you plan to send. If you send account-related messages or time-sensitive
messages such as one-time passcodes, choose Transactional. If you plan to send messages
that contain marketing material or other promotional content, choose Promotional. This
setting applies to your entire Amazon Web Services account.

# Arguments
- `configuration_set_name`: The name of the configuration set or the configuration set
  Amazon Resource Name (ARN) to delete the default message type from. The
  ConfigurationSetName and ConfigurationSetArn can be found using the
  DescribeConfigurationSets action.

"""
function delete_default_message_type(
    ConfigurationSetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "DeleteDefaultMessageType",
        Dict{String,Any}("ConfigurationSetName" => ConfigurationSetName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_default_message_type(
    ConfigurationSetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "DeleteDefaultMessageType",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ConfigurationSetName" => ConfigurationSetName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_default_sender_id(configuration_set_name)
    delete_default_sender_id(configuration_set_name, params::Dict{String,<:Any})

Deletes an existing default sender ID on a configuration set. A default sender ID is the
identity that appears on recipients' devices when they receive SMS messages. Support for
sender ID capabilities varies by country or region.

# Arguments
- `configuration_set_name`: The name of the configuration set or the configuration set
  Amazon Resource Name (ARN) to delete the default sender ID from. The ConfigurationSetName
  and ConfigurationSetArn can be found using the DescribeConfigurationSets action.

"""
function delete_default_sender_id(
    ConfigurationSetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "DeleteDefaultSenderId",
        Dict{String,Any}("ConfigurationSetName" => ConfigurationSetName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_default_sender_id(
    ConfigurationSetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "DeleteDefaultSenderId",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ConfigurationSetName" => ConfigurationSetName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_event_destination(configuration_set_name, event_destination_name)
    delete_event_destination(configuration_set_name, event_destination_name, params::Dict{String,<:Any})

Deletes an existing event destination. An event destination is a location where you send
response information about the messages that you send. For example, when a message is
delivered successfully, you can send information about that event to an Amazon CloudWatch
destination, or send notifications to endpoints that are subscribed to an Amazon SNS topic.

# Arguments
- `configuration_set_name`: The name of the configuration set or the configuration set's
  Amazon Resource Name (ARN) to remove the event destination from. The ConfigurateSetName and
  ConfigurationSetArn can be found using the DescribeConfigurationSets action.
- `event_destination_name`: The name of the event destination to delete.

"""
function delete_event_destination(
    ConfigurationSetName,
    EventDestinationName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "DeleteEventDestination",
        Dict{String,Any}(
            "ConfigurationSetName" => ConfigurationSetName,
            "EventDestinationName" => EventDestinationName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_event_destination(
    ConfigurationSetName,
    EventDestinationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "DeleteEventDestination",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ConfigurationSetName" => ConfigurationSetName,
                    "EventDestinationName" => EventDestinationName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_keyword(keyword, origination_identity)
    delete_keyword(keyword, origination_identity, params::Dict{String,<:Any})

Deletes an existing keyword from an origination phone number or pool. A keyword is a word
that you can search for on a particular phone number or pool. It is also a specific word or
phrase that an end user can send to your number to elicit a response, such as an
informational message or a special offer. When your number receives a message that begins
with a keyword, Amazon Pinpoint responds with a customizable message. Keywords \"HELP\" and
\"STOP\" can't be deleted or modified.

# Arguments
- `keyword`: The keyword to delete.
- `origination_identity`: The origination identity to use such as a PhoneNumberId,
  PhoneNumberArn, PoolId or PoolArn. You can use DescribePhoneNumbers to find the values for
  PhoneNumberId and PhoneNumberArn and DescribePools to find the values of PoolId and PoolArn.

"""
function delete_keyword(
    Keyword, OriginationIdentity; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "DeleteKeyword",
        Dict{String,Any}(
            "Keyword" => Keyword, "OriginationIdentity" => OriginationIdentity
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_keyword(
    Keyword,
    OriginationIdentity,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "DeleteKeyword",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Keyword" => Keyword, "OriginationIdentity" => OriginationIdentity
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_media_message_spend_limit_override()
    delete_media_message_spend_limit_override(params::Dict{String,<:Any})

Deletes an account-level monthly spending limit override for sending multimedia messages
(MMS). Deleting a spend limit override will set the EnforcedLimit to equal the MaxLimit,
which is controlled by Amazon Web Services. For more information on spend limits (quotas)
see Quotas for Server Migration Service in the Server Migration Service User Guide.

"""
function delete_media_message_spend_limit_override(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "DeleteMediaMessageSpendLimitOverride";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_media_message_spend_limit_override(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "DeleteMediaMessageSpendLimitOverride",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_opt_out_list(opt_out_list_name)
    delete_opt_out_list(opt_out_list_name, params::Dict{String,<:Any})

Deletes an existing opt-out list. All opted out phone numbers in the opt-out list are
deleted. If the specified opt-out list name doesn't exist or is in-use by an origination
phone number or pool, an error is returned.

# Arguments
- `opt_out_list_name`: The OptOutListName or OptOutListArn of the OptOutList to delete. You
  can use DescribeOptOutLists to find the values for OptOutListName and OptOutListArn.

"""
function delete_opt_out_list(
    OptOutListName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "DeleteOptOutList",
        Dict{String,Any}("OptOutListName" => OptOutListName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_opt_out_list(
    OptOutListName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "DeleteOptOutList",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("OptOutListName" => OptOutListName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_opted_out_number(opt_out_list_name, opted_out_number)
    delete_opted_out_number(opt_out_list_name, opted_out_number, params::Dict{String,<:Any})

Deletes an existing opted out destination phone number from the specified opt-out list.
Each destination phone number can only be deleted once every 30 days. If the specified
destination phone number doesn't exist or if the opt-out list doesn't exist, an error is
returned.

# Arguments
- `opt_out_list_name`: The OptOutListName or OptOutListArn to remove the phone number from.
- `opted_out_number`: The phone number, in E.164 format, to remove from the OptOutList.

"""
function delete_opted_out_number(
    OptOutListName, OptedOutNumber; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "DeleteOptedOutNumber",
        Dict{String,Any}(
            "OptOutListName" => OptOutListName, "OptedOutNumber" => OptedOutNumber
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_opted_out_number(
    OptOutListName,
    OptedOutNumber,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "DeleteOptedOutNumber",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "OptOutListName" => OptOutListName, "OptedOutNumber" => OptedOutNumber
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_pool(pool_id)
    delete_pool(pool_id, params::Dict{String,<:Any})

Deletes an existing pool. Deleting a pool disassociates all origination identities from
that pool. If the pool status isn't active or if deletion protection is enabled, an error
is returned. A pool is a collection of phone numbers and SenderIds. A pool can include one
or more phone numbers and SenderIds that are associated with your Amazon Web Services
account.

# Arguments
- `pool_id`: The PoolId or PoolArn of the pool to delete. You can use DescribePools to find
  the values for PoolId and PoolArn .

"""
function delete_pool(PoolId; aws_config::AbstractAWSConfig=current_aws_config())
    return pinpoint_sms_voice_v2(
        "DeletePool",
        Dict{String,Any}("PoolId" => PoolId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_pool(
    PoolId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "DeletePool",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("PoolId" => PoolId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_protect_configuration(protect_configuration_id)
    delete_protect_configuration(protect_configuration_id, params::Dict{String,<:Any})

Permanently delete the protect configuration. The protect configuration must have deletion
protection disabled and must not be associated as the account default protect configuration
or associated with a configuration set.

# Arguments
- `protect_configuration_id`: The unique identifier for the protect configuration.

"""
function delete_protect_configuration(
    ProtectConfigurationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "DeleteProtectConfiguration",
        Dict{String,Any}("ProtectConfigurationId" => ProtectConfigurationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_protect_configuration(
    ProtectConfigurationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "DeleteProtectConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ProtectConfigurationId" => ProtectConfigurationId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_registration(registration_id)
    delete_registration(registration_id, params::Dict{String,<:Any})

Permanently delete an existing registration from your account.

# Arguments
- `registration_id`: The unique identifier for the registration.

"""
function delete_registration(
    RegistrationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "DeleteRegistration",
        Dict{String,Any}("RegistrationId" => RegistrationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_registration(
    RegistrationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "DeleteRegistration",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("RegistrationId" => RegistrationId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_registration_attachment(registration_attachment_id)
    delete_registration_attachment(registration_attachment_id, params::Dict{String,<:Any})

Permanently delete the specified registration attachment.

# Arguments
- `registration_attachment_id`: The unique identifier for the registration attachment.

"""
function delete_registration_attachment(
    RegistrationAttachmentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "DeleteRegistrationAttachment",
        Dict{String,Any}("RegistrationAttachmentId" => RegistrationAttachmentId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_registration_attachment(
    RegistrationAttachmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "DeleteRegistrationAttachment",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("RegistrationAttachmentId" => RegistrationAttachmentId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_registration_field_value(field_path, registration_id)
    delete_registration_field_value(field_path, registration_id, params::Dict{String,<:Any})

Delete the value in a registration form field.

# Arguments
- `field_path`: The path to the registration form field. You can use
  DescribeRegistrationFieldDefinitions for a list of FieldPaths.
- `registration_id`: The unique identifier for the registration.

"""
function delete_registration_field_value(
    FieldPath, RegistrationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "DeleteRegistrationFieldValue",
        Dict{String,Any}("FieldPath" => FieldPath, "RegistrationId" => RegistrationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_registration_field_value(
    FieldPath,
    RegistrationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "DeleteRegistrationFieldValue",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "FieldPath" => FieldPath, "RegistrationId" => RegistrationId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_text_message_spend_limit_override()
    delete_text_message_spend_limit_override(params::Dict{String,<:Any})

Deletes an account-level monthly spending limit override for sending text messages.
Deleting a spend limit override will set the EnforcedLimit to equal the MaxLimit, which is
controlled by Amazon Web Services. For more information on spend limits (quotas) see Amazon
Pinpoint quotas  in the Amazon Pinpoint Developer Guide.

"""
function delete_text_message_spend_limit_override(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "DeleteTextMessageSpendLimitOverride";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_text_message_spend_limit_override(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "DeleteTextMessageSpendLimitOverride",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_verified_destination_number(verified_destination_number_id)
    delete_verified_destination_number(verified_destination_number_id, params::Dict{String,<:Any})

Delete a verified destination phone number.

# Arguments
- `verified_destination_number_id`: The unique identifier for the verified destination
  phone number.

"""
function delete_verified_destination_number(
    VerifiedDestinationNumberId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "DeleteVerifiedDestinationNumber",
        Dict{String,Any}("VerifiedDestinationNumberId" => VerifiedDestinationNumberId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_verified_destination_number(
    VerifiedDestinationNumberId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "DeleteVerifiedDestinationNumber",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "VerifiedDestinationNumberId" => VerifiedDestinationNumberId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_voice_message_spend_limit_override()
    delete_voice_message_spend_limit_override(params::Dict{String,<:Any})

Deletes an account level monthly spend limit override for sending voice messages. Deleting
a spend limit override sets the EnforcedLimit equal to the MaxLimit, which is controlled by
Amazon Web Services. For more information on spending limits (quotas) see Amazon Pinpoint
quotas in the Amazon Pinpoint Developer Guide.

"""
function delete_voice_message_spend_limit_override(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "DeleteVoiceMessageSpendLimitOverride";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_voice_message_spend_limit_override(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "DeleteVoiceMessageSpendLimitOverride",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_account_attributes()
    describe_account_attributes(params::Dict{String,<:Any})

Describes attributes of your Amazon Web Services account. The supported account attributes
include account tier, which indicates whether your account is in the sandbox or production
environment. When you're ready to move your account out of the sandbox, create an Amazon
Web Services Support case for a service limit increase request. New Amazon Pinpoint
accounts are placed into an SMS or voice sandbox. The sandbox protects both Amazon Web
Services end recipients and SMS or voice recipients from fraud and abuse.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to return per each request.
- `"NextToken"`: The token to be used for the next set of paginated results. You don't need
  to supply a value for this field in the initial request.
"""
function describe_account_attributes(; aws_config::AbstractAWSConfig=current_aws_config())
    return pinpoint_sms_voice_v2(
        "DescribeAccountAttributes"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_account_attributes(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "DescribeAccountAttributes",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_account_limits()
    describe_account_limits(params::Dict{String,<:Any})

Describes the current Amazon Pinpoint SMS Voice V2 resource quotas for your account. The
description for a quota includes the quota name, current usage toward that quota, and the
quota's maximum value. When you establish an Amazon Web Services account, the account has
initial quotas on the maximum number of configuration sets, opt-out lists, phone numbers,
and pools that you can create in a given Region. For more information see  Amazon Pinpoint
quotas  in the Amazon Pinpoint Developer Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to return per each request.
- `"NextToken"`: The token to be used for the next set of paginated results. You don't need
  to supply a value for this field in the initial request.
"""
function describe_account_limits(; aws_config::AbstractAWSConfig=current_aws_config())
    return pinpoint_sms_voice_v2(
        "DescribeAccountLimits"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_account_limits(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "DescribeAccountLimits",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_configuration_sets()
    describe_configuration_sets(params::Dict{String,<:Any})

Describes the specified configuration sets or all in your account. If you specify
configuration set names, the output includes information for only the specified
configuration sets. If you specify filters, the output includes information for only those
configuration sets that meet the filter criteria. If you don't specify configuration set
names or filters, the output includes information for all configuration sets. If you
specify a configuration set name that isn't valid, an error is returned.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConfigurationSetNames"`: An array of strings. Each element can be either a
  ConfigurationSetName or ConfigurationSetArn.
- `"Filters"`: An array of filters to apply to the results that are returned.
- `"MaxResults"`: The maximum number of results to return per each request.
- `"NextToken"`: The token to be used for the next set of paginated results. You don't need
  to supply a value for this field in the initial request.
"""
function describe_configuration_sets(; aws_config::AbstractAWSConfig=current_aws_config())
    return pinpoint_sms_voice_v2(
        "DescribeConfigurationSets"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_configuration_sets(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "DescribeConfigurationSets",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_keywords(origination_identity)
    describe_keywords(origination_identity, params::Dict{String,<:Any})

Describes the specified keywords or all keywords on your origination phone number or pool.
A keyword is a word that you can search for on a particular phone number or pool. It is
also a specific word or phrase that an end user can send to your number to elicit a
response, such as an informational message or a special offer. When your number receives a
message that begins with a keyword, Amazon Pinpoint responds with a customizable message.
If you specify a keyword that isn't valid, an error is returned.

# Arguments
- `origination_identity`: The origination identity to use such as a PhoneNumberId,
  PhoneNumberArn, SenderId or SenderIdArn. You can use DescribePhoneNumbers to find the
  values for PhoneNumberId and PhoneNumberArn while DescribeSenderIds can be used to get the
  values for SenderId and SenderIdArn.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: An array of keyword filters to filter the results.
- `"Keywords"`: An array of keywords to search for.
- `"MaxResults"`: The maximum number of results to return per each request.
- `"NextToken"`: The token to be used for the next set of paginated results. You don't need
  to supply a value for this field in the initial request.
"""
function describe_keywords(
    OriginationIdentity; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "DescribeKeywords",
        Dict{String,Any}("OriginationIdentity" => OriginationIdentity);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_keywords(
    OriginationIdentity,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "DescribeKeywords",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("OriginationIdentity" => OriginationIdentity),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_opt_out_lists()
    describe_opt_out_lists(params::Dict{String,<:Any})

Describes the specified opt-out list or all opt-out lists in your account. If you specify
opt-out list names, the output includes information for only the specified opt-out lists.
Opt-out lists include only those that meet the filter criteria. If you don't specify
opt-out list names or filters, the output includes information for all opt-out lists. If
you specify an opt-out list name that isn't valid, an error is returned.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to return per each request.
- `"NextToken"`: The token to be used for the next set of paginated results. You don't need
  to supply a value for this field in the initial request.
- `"OptOutListNames"`: The OptOutLists to show the details of. This is an array of strings
  that can be either the OptOutListName or OptOutListArn.
"""
function describe_opt_out_lists(; aws_config::AbstractAWSConfig=current_aws_config())
    return pinpoint_sms_voice_v2(
        "DescribeOptOutLists"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_opt_out_lists(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "DescribeOptOutLists",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_opted_out_numbers(opt_out_list_name)
    describe_opted_out_numbers(opt_out_list_name, params::Dict{String,<:Any})

Describes the specified opted out destination numbers or all opted out destination numbers
in an opt-out list. If you specify opted out numbers, the output includes information for
only the specified opted out numbers. If you specify filters, the output includes
information for only those opted out numbers that meet the filter criteria. If you don't
specify opted out numbers or filters, the output includes information for all opted out
destination numbers in your opt-out list. If you specify an opted out number that isn't
valid, an error is returned.

# Arguments
- `opt_out_list_name`: The OptOutListName or OptOutListArn of the OptOutList. You can use
  DescribeOptOutLists to find the values for OptOutListName and OptOutListArn.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: An array of OptedOutFilter objects to filter the results on.
- `"MaxResults"`: The maximum number of results to return per each request.
- `"NextToken"`: The token to be used for the next set of paginated results. You don't need
  to supply a value for this field in the initial request.
- `"OptedOutNumbers"`: An array of phone numbers to search for in the OptOutList.
"""
function describe_opted_out_numbers(
    OptOutListName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "DescribeOptedOutNumbers",
        Dict{String,Any}("OptOutListName" => OptOutListName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_opted_out_numbers(
    OptOutListName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "DescribeOptedOutNumbers",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("OptOutListName" => OptOutListName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_phone_numbers()
    describe_phone_numbers(params::Dict{String,<:Any})

Describes the specified origination phone number, or all the phone numbers in your account.
If you specify phone number IDs, the output includes information for only the specified
phone numbers. If you specify filters, the output includes information for only those phone
numbers that meet the filter criteria. If you don't specify phone number IDs or filters,
the output includes information for all phone numbers. If you specify a phone number ID
that isn't valid, an error is returned.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: An array of PhoneNumberFilter objects to filter the results.
- `"MaxResults"`: The maximum number of results to return per each request.
- `"NextToken"`: The token to be used for the next set of paginated results. You don't need
  to supply a value for this field in the initial request.
- `"PhoneNumberIds"`: The unique identifier of phone numbers to find information about.
  This is an array of strings that can be either the PhoneNumberId or PhoneNumberArn.
"""
function describe_phone_numbers(; aws_config::AbstractAWSConfig=current_aws_config())
    return pinpoint_sms_voice_v2(
        "DescribePhoneNumbers"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_phone_numbers(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "DescribePhoneNumbers",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_pools()
    describe_pools(params::Dict{String,<:Any})

Retrieves the specified pools or all pools associated with your Amazon Web Services
account. If you specify pool IDs, the output includes information for only the specified
pools. If you specify filters, the output includes information for only those pools that
meet the filter criteria. If you don't specify pool IDs or filters, the output includes
information for all pools. If you specify a pool ID that isn't valid, an error is returned.
A pool is a collection of phone numbers and SenderIds. A pool can include one or more phone
numbers and SenderIds that are associated with your Amazon Web Services account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: An array of PoolFilter objects to filter the results.
- `"MaxResults"`: The maximum number of results to return per each request.
- `"NextToken"`: The token to be used for the next set of paginated results. You don't need
  to supply a value for this field in the initial request.
- `"PoolIds"`: The unique identifier of pools to find. This is an array of strings that can
  be either the PoolId or PoolArn.
"""
function describe_pools(; aws_config::AbstractAWSConfig=current_aws_config())
    return pinpoint_sms_voice_v2(
        "DescribePools"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_pools(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "DescribePools", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_protect_configurations()
    describe_protect_configurations(params::Dict{String,<:Any})

Retrieves the protect configurations that match any of filters. If a filter isn’t
provided then all protect configurations are returned.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: An array of ProtectConfigurationFilter objects to filter the results.
- `"MaxResults"`: The maximum number of results to return per each request.
- `"NextToken"`: The token to be used for the next set of paginated results. You don't need
  to supply a value for this field in the initial request.
- `"ProtectConfigurationIds"`: An array of protect configuration identifiers to search for.
"""
function describe_protect_configurations(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "DescribeProtectConfigurations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_protect_configurations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "DescribeProtectConfigurations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_registration_attachments()
    describe_registration_attachments(params::Dict{String,<:Any})

Retrieves the specified registration attachments or all registration attachments associated
with your Amazon Web Services account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: An array of RegistrationAttachmentFilter objects to filter the results.
- `"MaxResults"`: The maximum number of results to return per each request.
- `"NextToken"`: The token to be used for the next set of paginated results. You don't need
  to supply a value for this field in the initial request.
- `"RegistrationAttachmentIds"`: The unique identifier of registration attachments to find.
  This is an array of RegistrationAttachmentId.
"""
function describe_registration_attachments(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "DescribeRegistrationAttachments";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_registration_attachments(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "DescribeRegistrationAttachments",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_registration_field_definitions(registration_type)
    describe_registration_field_definitions(registration_type, params::Dict{String,<:Any})

Retrieves the specified registration type field definitions. You can use
DescribeRegistrationFieldDefinitions to view the requirements for creating, filling out,
and submitting each registration type.

# Arguments
- `registration_type`: The type of registration form. The list of RegistrationTypes can be
  found using the DescribeRegistrationTypeDefinitions action.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FieldPaths"`: An array of paths to the registration form field.
- `"MaxResults"`: The maximum number of results to return per each request.
- `"NextToken"`: The token to be used for the next set of paginated results. You don't need
  to supply a value for this field in the initial request.
- `"SectionPath"`: The path to the section of the registration.
"""
function describe_registration_field_definitions(
    RegistrationType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "DescribeRegistrationFieldDefinitions",
        Dict{String,Any}("RegistrationType" => RegistrationType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_registration_field_definitions(
    RegistrationType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "DescribeRegistrationFieldDefinitions",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("RegistrationType" => RegistrationType), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_registration_field_values(registration_id)
    describe_registration_field_values(registration_id, params::Dict{String,<:Any})

Retrieves the specified registration field values.

# Arguments
- `registration_id`: The unique identifier for the registration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FieldPaths"`: An array of paths to the registration form field.
- `"MaxResults"`: The maximum number of results to return per each request.
- `"NextToken"`: The token to be used for the next set of paginated results. You don't need
  to supply a value for this field in the initial request.
- `"SectionPath"`: The path to the section of the registration.
- `"VersionNumber"`: The version number of the registration.
"""
function describe_registration_field_values(
    RegistrationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "DescribeRegistrationFieldValues",
        Dict{String,Any}("RegistrationId" => RegistrationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_registration_field_values(
    RegistrationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "DescribeRegistrationFieldValues",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("RegistrationId" => RegistrationId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_registration_section_definitions(registration_type)
    describe_registration_section_definitions(registration_type, params::Dict{String,<:Any})

Retrieves the specified registration section definitions. You can use
DescribeRegistrationSectionDefinitions to view the requirements for creating, filling out,
and submitting each registration type.

# Arguments
- `registration_type`: The type of registration form. The list of RegistrationTypes can be
  found using the DescribeRegistrationTypeDefinitions action.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to return per each request.
- `"NextToken"`: The token to be used for the next set of paginated results. You don't need
  to supply a value for this field in the initial request.
- `"SectionPaths"`: An array of paths for the registration form section.
"""
function describe_registration_section_definitions(
    RegistrationType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "DescribeRegistrationSectionDefinitions",
        Dict{String,Any}("RegistrationType" => RegistrationType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_registration_section_definitions(
    RegistrationType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "DescribeRegistrationSectionDefinitions",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("RegistrationType" => RegistrationType), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_registration_type_definitions()
    describe_registration_type_definitions(params::Dict{String,<:Any})

Retrieves the specified registration type definitions. You can use
DescribeRegistrationTypeDefinitions to view the requirements for creating, filling out, and
submitting each registration type.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: An array of RegistrationFilter objects to filter the results.
- `"MaxResults"`: The maximum number of results to return per each request.
- `"NextToken"`: The token to be used for the next set of paginated results. You don't need
  to supply a value for this field in the initial request.
- `"RegistrationTypes"`: The type of registration form. The list of RegistrationTypes can
  be found using the DescribeRegistrationTypeDefinitions action.
"""
function describe_registration_type_definitions(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "DescribeRegistrationTypeDefinitions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_registration_type_definitions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "DescribeRegistrationTypeDefinitions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_registration_versions(registration_id)
    describe_registration_versions(registration_id, params::Dict{String,<:Any})

Retrieves the specified registration version.

# Arguments
- `registration_id`: The unique identifier for the registration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: An array of RegistrationVersionFilter objects to filter the results.
- `"MaxResults"`: The maximum number of results to return per each request.
- `"NextToken"`: The token to be used for the next set of paginated results. You don't need
  to supply a value for this field in the initial request.
- `"VersionNumbers"`: An array of registration version numbers.
"""
function describe_registration_versions(
    RegistrationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "DescribeRegistrationVersions",
        Dict{String,Any}("RegistrationId" => RegistrationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_registration_versions(
    RegistrationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "DescribeRegistrationVersions",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("RegistrationId" => RegistrationId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_registrations()
    describe_registrations(params::Dict{String,<:Any})

Retrieves the specified registrations.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: An array of RegistrationFilter objects to filter the results.
- `"MaxResults"`: The maximum number of results to return per each request.
- `"NextToken"`: The token to be used for the next set of paginated results. You don't need
  to supply a value for this field in the initial request.
- `"RegistrationIds"`: An array of unique identifiers for each registration.
"""
function describe_registrations(; aws_config::AbstractAWSConfig=current_aws_config())
    return pinpoint_sms_voice_v2(
        "DescribeRegistrations"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_registrations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "DescribeRegistrations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_sender_ids()
    describe_sender_ids(params::Dict{String,<:Any})

Describes the specified SenderIds or all SenderIds associated with your Amazon Web Services
account. If you specify SenderIds, the output includes information for only the specified
SenderIds. If you specify filters, the output includes information for only those SenderIds
that meet the filter criteria. If you don't specify SenderIds or filters, the output
includes information for all SenderIds. f you specify a sender ID that isn't valid, an
error is returned.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: An array of SenderIdFilter objects to filter the results.
- `"MaxResults"`: The maximum number of results to return per each request.
- `"NextToken"`: The token to be used for the next set of paginated results. You don't need
  to supply a value for this field in the initial request.
- `"SenderIds"`: An array of SenderIdAndCountry objects to search for.
"""
function describe_sender_ids(; aws_config::AbstractAWSConfig=current_aws_config())
    return pinpoint_sms_voice_v2(
        "DescribeSenderIds"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_sender_ids(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "DescribeSenderIds", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_spend_limits()
    describe_spend_limits(params::Dict{String,<:Any})

Describes the current Amazon Pinpoint monthly spend limits for sending voice and text
messages. When you establish an Amazon Web Services account, the account has initial
monthly spend limit in a given Region. For more information on increasing your monthly
spend limit, see  Requesting increases to your monthly SMS spending quota for Amazon
Pinpoint  in the Amazon Pinpoint User Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to return per each request.
- `"NextToken"`: The token to be used for the next set of paginated results. You don't need
  to supply a value for this field in the initial request.
"""
function describe_spend_limits(; aws_config::AbstractAWSConfig=current_aws_config())
    return pinpoint_sms_voice_v2(
        "DescribeSpendLimits"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_spend_limits(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "DescribeSpendLimits",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_verified_destination_numbers()
    describe_verified_destination_numbers(params::Dict{String,<:Any})

Retrieves the specified verified destiona numbers.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DestinationPhoneNumbers"`: An array of verified destination phone number, in E.164
  format.
- `"Filters"`: An array of VerifiedDestinationNumberFilter objects to filter the results.
- `"MaxResults"`: The maximum number of results to return per each request.
- `"NextToken"`: The token to be used for the next set of paginated results. You don't need
  to supply a value for this field in the initial request.
- `"VerifiedDestinationNumberIds"`: An array of VerifiedDestinationNumberid to retreive.
"""
function describe_verified_destination_numbers(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "DescribeVerifiedDestinationNumbers";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_verified_destination_numbers(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "DescribeVerifiedDestinationNumbers",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_origination_identity(iso_country_code, origination_identity, pool_id)
    disassociate_origination_identity(iso_country_code, origination_identity, pool_id, params::Dict{String,<:Any})

Removes the specified origination identity from an existing pool. If the origination
identity isn't associated with the specified pool, an error is returned.

# Arguments
- `iso_country_code`: The two-character code, in ISO 3166-1 alpha-2 format, for the country
  or region.
- `origination_identity`: The origination identity to use such as a PhoneNumberId,
  PhoneNumberArn, SenderId or SenderIdArn. You can use DescribePhoneNumbers find the values
  for PhoneNumberId and PhoneNumberArn, or use DescribeSenderIds to get the values for
  SenderId and SenderIdArn.
- `pool_id`: The unique identifier for the pool to disassociate with the origination
  identity. This value can be either the PoolId or PoolArn.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: Unique, case-sensitive identifier you provide to ensure the idempotency
  of the request. If you don't specify a client token, a randomly generated token is used for
  the request to ensure idempotency.
"""
function disassociate_origination_identity(
    IsoCountryCode,
    OriginationIdentity,
    PoolId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "DisassociateOriginationIdentity",
        Dict{String,Any}(
            "IsoCountryCode" => IsoCountryCode,
            "OriginationIdentity" => OriginationIdentity,
            "PoolId" => PoolId,
            "ClientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_origination_identity(
    IsoCountryCode,
    OriginationIdentity,
    PoolId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "DisassociateOriginationIdentity",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "IsoCountryCode" => IsoCountryCode,
                    "OriginationIdentity" => OriginationIdentity,
                    "PoolId" => PoolId,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_protect_configuration(configuration_set_name, protect_configuration_id)
    disassociate_protect_configuration(configuration_set_name, protect_configuration_id, params::Dict{String,<:Any})

Disassociate a protect configuration from a configuration set.

# Arguments
- `configuration_set_name`: The name of the ConfigurationSet.
- `protect_configuration_id`: The unique identifier for the protect configuration.

"""
function disassociate_protect_configuration(
    ConfigurationSetName,
    ProtectConfigurationId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "DisassociateProtectConfiguration",
        Dict{String,Any}(
            "ConfigurationSetName" => ConfigurationSetName,
            "ProtectConfigurationId" => ProtectConfigurationId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_protect_configuration(
    ConfigurationSetName,
    ProtectConfigurationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "DisassociateProtectConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ConfigurationSetName" => ConfigurationSetName,
                    "ProtectConfigurationId" => ProtectConfigurationId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    discard_registration_version(registration_id)
    discard_registration_version(registration_id, params::Dict{String,<:Any})

Discard the current version of the registration.

# Arguments
- `registration_id`: The unique identifier for the registration.

"""
function discard_registration_version(
    RegistrationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "DiscardRegistrationVersion",
        Dict{String,Any}("RegistrationId" => RegistrationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function discard_registration_version(
    RegistrationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "DiscardRegistrationVersion",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("RegistrationId" => RegistrationId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_protect_configuration_country_rule_set(number_capability, protect_configuration_id)
    get_protect_configuration_country_rule_set(number_capability, protect_configuration_id, params::Dict{String,<:Any})

Retrieve the CountryRuleSet for the specified NumberCapability from a protect configuration.

# Arguments
- `number_capability`: The capability type to return the CountryRuleSet for. Valid values
  are SMS, VOICE, or MMS.
- `protect_configuration_id`: The unique identifier for the protect configuration.

"""
function get_protect_configuration_country_rule_set(
    NumberCapability,
    ProtectConfigurationId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "GetProtectConfigurationCountryRuleSet",
        Dict{String,Any}(
            "NumberCapability" => NumberCapability,
            "ProtectConfigurationId" => ProtectConfigurationId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_protect_configuration_country_rule_set(
    NumberCapability,
    ProtectConfigurationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "GetProtectConfigurationCountryRuleSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "NumberCapability" => NumberCapability,
                    "ProtectConfigurationId" => ProtectConfigurationId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_pool_origination_identities(pool_id)
    list_pool_origination_identities(pool_id, params::Dict{String,<:Any})

Lists all associated origination identities in your pool. If you specify filters, the
output includes information for only those origination identities that meet the filter
criteria.

# Arguments
- `pool_id`: The unique identifier for the pool. This value can be either the PoolId or
  PoolArn.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: An array of PoolOriginationIdentitiesFilter objects to filter the results..
- `"MaxResults"`: The maximum number of results to return per each request.
- `"NextToken"`: The token to be used for the next set of paginated results. You don't need
  to supply a value for this field in the initial request.
"""
function list_pool_origination_identities(
    PoolId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "ListPoolOriginationIdentities",
        Dict{String,Any}("PoolId" => PoolId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_pool_origination_identities(
    PoolId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "ListPoolOriginationIdentities",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("PoolId" => PoolId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_registration_associations(registration_id)
    list_registration_associations(registration_id, params::Dict{String,<:Any})

Retreive all of the origination identies that are associated with a registration.

# Arguments
- `registration_id`: The unique identifier for the registration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: An array of RegistrationAssociationFilter to apply to the results that are
  returned.
- `"MaxResults"`: The maximum number of results to return per each request.
- `"NextToken"`: The token to be used for the next set of paginated results. You don't need
  to supply a value for this field in the initial request.
"""
function list_registration_associations(
    RegistrationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "ListRegistrationAssociations",
        Dict{String,Any}("RegistrationId" => RegistrationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_registration_associations(
    RegistrationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "ListRegistrationAssociations",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("RegistrationId" => RegistrationId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

List all tags associated with a resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource to query for.

"""
function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "ListTagsForResource",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_keyword(keyword, keyword_message, origination_identity)
    put_keyword(keyword, keyword_message, origination_identity, params::Dict{String,<:Any})

Creates or updates a keyword configuration on an origination phone number or pool.  A
keyword is a word that you can search for on a particular phone number or pool. It is also
a specific word or phrase that an end user can send to your number to elicit a response,
such as an informational message or a special offer. When your number receives a message
that begins with a keyword, Amazon Pinpoint responds with a customizable message. If you
specify a keyword that isn't valid, an error is returned.

# Arguments
- `keyword`: The new keyword to add.
- `keyword_message`: The message associated with the keyword.
- `origination_identity`: The origination identity to use such as a PhoneNumberId,
  PhoneNumberArn, SenderId or SenderIdArn. You can use DescribePhoneNumbers get the values
  for PhoneNumberId and PhoneNumberArn while DescribeSenderIds can be used to get the values
  for SenderId and SenderIdArn.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"KeywordAction"`: The action to perform for the new keyword when it is received.
  AUTOMATIC_RESPONSE: A message is sent to the recipient.   OPT_OUT: Keeps the recipient from
  receiving future messages.   OPT_IN: The recipient wants to receive future messages.
"""
function put_keyword(
    Keyword,
    KeywordMessage,
    OriginationIdentity;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "PutKeyword",
        Dict{String,Any}(
            "Keyword" => Keyword,
            "KeywordMessage" => KeywordMessage,
            "OriginationIdentity" => OriginationIdentity,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_keyword(
    Keyword,
    KeywordMessage,
    OriginationIdentity,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "PutKeyword",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Keyword" => Keyword,
                    "KeywordMessage" => KeywordMessage,
                    "OriginationIdentity" => OriginationIdentity,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_opted_out_number(opt_out_list_name, opted_out_number)
    put_opted_out_number(opt_out_list_name, opted_out_number, params::Dict{String,<:Any})

Creates an opted out destination phone number in the opt-out list. If the destination phone
number isn't valid or if the specified opt-out list doesn't exist, an error is returned.

# Arguments
- `opt_out_list_name`: The OptOutListName or OptOutListArn to add the phone number to.
- `opted_out_number`: The phone number to add to the OptOutList in E.164 format.

"""
function put_opted_out_number(
    OptOutListName, OptedOutNumber; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "PutOptedOutNumber",
        Dict{String,Any}(
            "OptOutListName" => OptOutListName, "OptedOutNumber" => OptedOutNumber
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_opted_out_number(
    OptOutListName,
    OptedOutNumber,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "PutOptedOutNumber",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "OptOutListName" => OptOutListName, "OptedOutNumber" => OptedOutNumber
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_registration_field_value(field_path, registration_id)
    put_registration_field_value(field_path, registration_id, params::Dict{String,<:Any})

Creates or updates a field value for a registration.

# Arguments
- `field_path`: The path to the registration form field. You can use
  DescribeRegistrationFieldDefinitions for a list of FieldPaths.
- `registration_id`: The unique identifier for the registration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"RegistrationAttachmentId"`: The unique identifier for the registration attachment.
- `"SelectChoices"`: An array of values for the form field.
- `"TextValue"`: The text data for a free form field.
"""
function put_registration_field_value(
    FieldPath, RegistrationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "PutRegistrationFieldValue",
        Dict{String,Any}("FieldPath" => FieldPath, "RegistrationId" => RegistrationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_registration_field_value(
    FieldPath,
    RegistrationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "PutRegistrationFieldValue",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "FieldPath" => FieldPath, "RegistrationId" => RegistrationId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    release_phone_number(phone_number_id)
    release_phone_number(phone_number_id, params::Dict{String,<:Any})

Releases an existing origination phone number in your account. Once released, a phone
number is no longer available for sending messages. If the origination phone number has
deletion protection enabled or is associated with a pool, an error is returned.

# Arguments
- `phone_number_id`: The PhoneNumberId or PhoneNumberArn of the phone number to release.
  You can use DescribePhoneNumbers to get the values for PhoneNumberId and PhoneNumberArn.

"""
function release_phone_number(
    PhoneNumberId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "ReleasePhoneNumber",
        Dict{String,Any}("PhoneNumberId" => PhoneNumberId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function release_phone_number(
    PhoneNumberId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "ReleasePhoneNumber",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("PhoneNumberId" => PhoneNumberId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    release_sender_id(iso_country_code, sender_id)
    release_sender_id(iso_country_code, sender_id, params::Dict{String,<:Any})

Releases an existing sender ID in your account.

# Arguments
- `iso_country_code`: The two-character code, in ISO 3166-1 alpha-2 format, for the country
  or region.
- `sender_id`: The sender ID to release.

"""
function release_sender_id(
    IsoCountryCode, SenderId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "ReleaseSenderId",
        Dict{String,Any}("IsoCountryCode" => IsoCountryCode, "SenderId" => SenderId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function release_sender_id(
    IsoCountryCode,
    SenderId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "ReleaseSenderId",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "IsoCountryCode" => IsoCountryCode, "SenderId" => SenderId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    request_phone_number(iso_country_code, message_type, number_capabilities, number_type)
    request_phone_number(iso_country_code, message_type, number_capabilities, number_type, params::Dict{String,<:Any})

Request an origination phone number for use in your account. For more information on phone
number request see  Requesting a number  in the Amazon Pinpoint User Guide.

# Arguments
- `iso_country_code`: The two-character code, in ISO 3166-1 alpha-2 format, for the country
  or region.
- `message_type`: The type of message. Valid values are TRANSACTIONAL for messages that are
  critical or time-sensitive and PROMOTIONAL for messages that aren't critical or
  time-sensitive.
- `number_capabilities`: Indicates if the phone number will be used for text messages,
  voice messages, or both.
- `number_type`: The type of phone number to request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If you don't specify a client token, a randomly generated token
  is used for the request to ensure idempotency.
- `"DeletionProtectionEnabled"`: By default this is set to false. When set to true the
  phone number can't be deleted.
- `"OptOutListName"`: The name of the OptOutList to associate with the phone number. You
  can use the OptOutListName or OptOutListArn.
- `"PoolId"`: The pool to associated with the phone number. You can use the PoolId or
  PoolArn.
- `"RegistrationId"`: Use this field to attach your phone number for an external
  registration process.
- `"Tags"`: An array of tags (key and value pairs) associate with the requested phone
  number.
"""
function request_phone_number(
    IsoCountryCode,
    MessageType,
    NumberCapabilities,
    NumberType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "RequestPhoneNumber",
        Dict{String,Any}(
            "IsoCountryCode" => IsoCountryCode,
            "MessageType" => MessageType,
            "NumberCapabilities" => NumberCapabilities,
            "NumberType" => NumberType,
            "ClientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function request_phone_number(
    IsoCountryCode,
    MessageType,
    NumberCapabilities,
    NumberType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "RequestPhoneNumber",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "IsoCountryCode" => IsoCountryCode,
                    "MessageType" => MessageType,
                    "NumberCapabilities" => NumberCapabilities,
                    "NumberType" => NumberType,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    request_sender_id(iso_country_code, sender_id)
    request_sender_id(iso_country_code, sender_id, params::Dict{String,<:Any})

Request a new sender ID that doesn't require registration.

# Arguments
- `iso_country_code`: The two-character code, in ISO 3166-1 alpha-2 format, for the country
  or region.
- `sender_id`: The sender ID string to request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If you don't specify a client token, a randomly generated token
  is used for the request to ensure idempotency.
- `"DeletionProtectionEnabled"`: By default this is set to false. When set to true the
  sender ID can't be deleted.
- `"MessageTypes"`: The type of message. Valid values are TRANSACTIONAL for messages that
  are critical or time-sensitive and PROMOTIONAL for messages that aren't critical or
  time-sensitive.
- `"Tags"`: An array of tags (key and value pairs) to associate with the sender ID.
"""
function request_sender_id(
    IsoCountryCode, SenderId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "RequestSenderId",
        Dict{String,Any}(
            "IsoCountryCode" => IsoCountryCode,
            "SenderId" => SenderId,
            "ClientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function request_sender_id(
    IsoCountryCode,
    SenderId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "RequestSenderId",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "IsoCountryCode" => IsoCountryCode,
                    "SenderId" => SenderId,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    send_destination_number_verification_code(verification_channel, verified_destination_number_id)
    send_destination_number_verification_code(verification_channel, verified_destination_number_id, params::Dict{String,<:Any})

Before you can send test messages to a verified destination phone number you need to opt-in
the verified destination phone number. Creates a new text message with a verification code
and send it to a verified destination phone number. Once you have the verification code use
VerifyDestinationNumber to opt-in the verified destination phone number to receive messages.

# Arguments
- `verification_channel`: Choose to send the verification code as an SMS or voice message.
- `verified_destination_number_id`: The unique identifier for the verified destination
  phone number.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConfigurationSetName"`: The name of the configuration set to use. This can be either
  the ConfigurationSetName or ConfigurationSetArn.
- `"Context"`: You can specify custom data in this field. If you do, that data is logged to
  the event destination.
- `"DestinationCountryParameters"`: This field is used for any country-specific
  registration requirements. Currently, this setting is only used when you send messages to
  recipients in India using a sender ID. For more information see Special requirements for
  sending SMS messages to recipients in India.
- `"LanguageCode"`: Choose the language to use for the message.
- `"OriginationIdentity"`: The origination identity of the message. This can be either the
  PhoneNumber, PhoneNumberId, PhoneNumberArn, SenderId, SenderIdArn, PoolId, or PoolArn.
"""
function send_destination_number_verification_code(
    VerificationChannel,
    VerifiedDestinationNumberId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "SendDestinationNumberVerificationCode",
        Dict{String,Any}(
            "VerificationChannel" => VerificationChannel,
            "VerifiedDestinationNumberId" => VerifiedDestinationNumberId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function send_destination_number_verification_code(
    VerificationChannel,
    VerifiedDestinationNumberId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "SendDestinationNumberVerificationCode",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "VerificationChannel" => VerificationChannel,
                    "VerifiedDestinationNumberId" => VerifiedDestinationNumberId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    send_media_message(destination_phone_number, origination_identity)
    send_media_message(destination_phone_number, origination_identity, params::Dict{String,<:Any})

Creates a new multimedia message (MMS) and sends it to a recipient's phone number.

# Arguments
- `destination_phone_number`: The destination phone number in E.164 format.
- `origination_identity`: The origination identity of the message. This can be either the
  PhoneNumber, PhoneNumberId, PhoneNumberArn, SenderId, SenderIdArn, PoolId, or PoolArn.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConfigurationSetName"`: The name of the configuration set to use. This can be either
  the ConfigurationSetName or ConfigurationSetArn.
- `"Context"`: You can specify custom data in this field. If you do, that data is logged to
  the event destination.
- `"DryRun"`: When set to true, the message is checked and validated, but isn't sent to the
  end recipient.
- `"MaxPrice"`: The maximum amount that you want to spend, in US dollars, per each MMS
  message.
- `"MediaUrls"`: An array of URLs to each media file to send.  The media files have to be
  stored in a publicly available S3 bucket. Supported media file formats are listed in MMS
  file types, size and character limits. For more information on creating an S3 bucket and
  managing objects, see Creating a bucket and Uploading objects in the S3 user guide.
- `"MessageBody"`: The text body of the message.
- `"ProtectConfigurationId"`: The unique identifier of the protect configuration to use.
- `"TimeToLive"`: How long the text message is valid for. By default this is 72 hours.
"""
function send_media_message(
    DestinationPhoneNumber,
    OriginationIdentity;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "SendMediaMessage",
        Dict{String,Any}(
            "DestinationPhoneNumber" => DestinationPhoneNumber,
            "OriginationIdentity" => OriginationIdentity,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function send_media_message(
    DestinationPhoneNumber,
    OriginationIdentity,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "SendMediaMessage",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DestinationPhoneNumber" => DestinationPhoneNumber,
                    "OriginationIdentity" => OriginationIdentity,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    send_text_message(destination_phone_number)
    send_text_message(destination_phone_number, params::Dict{String,<:Any})

Creates a new text message and sends it to a recipient's phone number. SMS throughput
limits are measured in Message Parts per Second (MPS). Your MPS limit depends on the
destination country of your messages, as well as the type of phone number (origination
number) that you use to send the message. For more information, see Message Parts per
Second (MPS) limits in the Amazon Pinpoint User Guide.

# Arguments
- `destination_phone_number`: The destination phone number in E.164 format.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConfigurationSetName"`: The name of the configuration set to use. This can be either
  the ConfigurationSetName or ConfigurationSetArn.
- `"Context"`: You can specify custom data in this field. If you do, that data is logged to
  the event destination.
- `"DestinationCountryParameters"`: This field is used for any country-specific
  registration requirements. Currently, this setting is only used when you send messages to
  recipients in India using a sender ID. For more information see Special requirements for
  sending SMS messages to recipients in India.
- `"DryRun"`: When set to true, the message is checked and validated, but isn't sent to the
  end recipient.
- `"Keyword"`: When you register a short code in the US, you must specify a program name.
  If you don’t have a US short code, omit this attribute.
- `"MaxPrice"`: The maximum amount that you want to spend, in US dollars, per each text
  message part. A text message can contain multiple parts.
- `"MessageBody"`: The body of the text message.
- `"MessageType"`: The type of message. Valid values are for messages that are critical or
  time-sensitive and PROMOTIONAL for messages that aren't critical or time-sensitive.
- `"OriginationIdentity"`: The origination identity of the message. This can be either the
  PhoneNumber, PhoneNumberId, PhoneNumberArn, SenderId, SenderIdArn, PoolId, or PoolArn.
- `"ProtectConfigurationId"`: The unique identifier for the protect configuration.
- `"TimeToLive"`: How long the text message is valid for. By default this is 72 hours.
"""
function send_text_message(
    DestinationPhoneNumber; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "SendTextMessage",
        Dict{String,Any}("DestinationPhoneNumber" => DestinationPhoneNumber);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function send_text_message(
    DestinationPhoneNumber,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "SendTextMessage",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DestinationPhoneNumber" => DestinationPhoneNumber),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    send_voice_message(destination_phone_number, origination_identity)
    send_voice_message(destination_phone_number, origination_identity, params::Dict{String,<:Any})

Allows you to send a request that sends a voice message through Amazon Pinpoint. This
operation uses Amazon Polly to convert a text script into a voice message.

# Arguments
- `destination_phone_number`: The destination phone number in E.164 format.
- `origination_identity`: The origination identity to use for the voice call. This can be
  the PhoneNumber, PhoneNumberId, PhoneNumberArn, PoolId, or PoolArn.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConfigurationSetName"`: The name of the configuration set to use. This can be either
  the ConfigurationSetName or ConfigurationSetArn.
- `"Context"`: You can specify custom data in this field. If you do, that data is logged to
  the event destination.
- `"DryRun"`: When set to true, the message is checked and validated, but isn't sent to the
  end recipient.
- `"MaxPricePerMinute"`: The maximum amount to spend per voice message, in US dollars.
- `"MessageBody"`: The text to convert to a voice message.
- `"MessageBodyTextType"`: Specifies if the MessageBody field contains text or speech
  synthesis markup language (SSML).   TEXT: This is the default value. When used the maximum
  character limit is 3000.   SSML: When used the maximum character limit is 6000 including
  SSML tagging.
- `"ProtectConfigurationId"`: The unique identifier for the protect configuration.
- `"TimeToLive"`: How long the voice message is valid for. By default this is 72 hours.
- `"VoiceId"`: The voice for the Amazon Polly service to use. By default this is set to
  \"MATTHEW\".
"""
function send_voice_message(
    DestinationPhoneNumber,
    OriginationIdentity;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "SendVoiceMessage",
        Dict{String,Any}(
            "DestinationPhoneNumber" => DestinationPhoneNumber,
            "OriginationIdentity" => OriginationIdentity,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function send_voice_message(
    DestinationPhoneNumber,
    OriginationIdentity,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "SendVoiceMessage",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DestinationPhoneNumber" => DestinationPhoneNumber,
                    "OriginationIdentity" => OriginationIdentity,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    set_account_default_protect_configuration(protect_configuration_id)
    set_account_default_protect_configuration(protect_configuration_id, params::Dict{String,<:Any})

Set a protect configuration as your account default. You can only have one account default
protect configuration at a time. The current account default protect configuration is
replaced with the provided protect configuration.

# Arguments
- `protect_configuration_id`: The unique identifier for the protect configuration.

"""
function set_account_default_protect_configuration(
    ProtectConfigurationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "SetAccountDefaultProtectConfiguration",
        Dict{String,Any}("ProtectConfigurationId" => ProtectConfigurationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function set_account_default_protect_configuration(
    ProtectConfigurationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "SetAccountDefaultProtectConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ProtectConfigurationId" => ProtectConfigurationId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    set_default_message_type(configuration_set_name, message_type)
    set_default_message_type(configuration_set_name, message_type, params::Dict{String,<:Any})

Sets the default message type on a configuration set. Choose the category of SMS messages
that you plan to send from this account. If you send account-related messages or
time-sensitive messages such as one-time passcodes, choose Transactional. If you plan to
send messages that contain marketing material or other promotional content, choose
Promotional. This setting applies to your entire Amazon Web Services account.

# Arguments
- `configuration_set_name`: The configuration set to update with a new default message
  type. This field can be the ConsigurationSetName or ConfigurationSetArn.
- `message_type`: The type of message. Valid values are TRANSACTIONAL for messages that are
  critical or time-sensitive and PROMOTIONAL for messages that aren't critical or
  time-sensitive.

"""
function set_default_message_type(
    ConfigurationSetName, MessageType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "SetDefaultMessageType",
        Dict{String,Any}(
            "ConfigurationSetName" => ConfigurationSetName, "MessageType" => MessageType
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function set_default_message_type(
    ConfigurationSetName,
    MessageType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "SetDefaultMessageType",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ConfigurationSetName" => ConfigurationSetName,
                    "MessageType" => MessageType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    set_default_sender_id(configuration_set_name, sender_id)
    set_default_sender_id(configuration_set_name, sender_id, params::Dict{String,<:Any})

Sets default sender ID on a configuration set. When sending a text message to a destination
country that supports sender IDs, the default sender ID on the configuration set specified
will be used if no dedicated origination phone numbers or registered sender IDs are
available in your account.

# Arguments
- `configuration_set_name`: The configuration set to updated with a new default SenderId.
  This field can be the ConsigurationSetName or ConfigurationSetArn.
- `sender_id`: The current sender ID for the configuration set. When sending a text message
  to a destination country which supports SenderIds, the default sender ID on the
  configuration set specified on SendTextMessage will be used if no dedicated origination
  phone numbers or registered SenderIds are available in your account, instead of a generic
  sender ID, such as 'NOTICE'.

"""
function set_default_sender_id(
    ConfigurationSetName, SenderId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "SetDefaultSenderId",
        Dict{String,Any}(
            "ConfigurationSetName" => ConfigurationSetName, "SenderId" => SenderId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function set_default_sender_id(
    ConfigurationSetName,
    SenderId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "SetDefaultSenderId",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ConfigurationSetName" => ConfigurationSetName, "SenderId" => SenderId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    set_media_message_spend_limit_override(monthly_limit)
    set_media_message_spend_limit_override(monthly_limit, params::Dict{String,<:Any})

Sets an account level monthly spend limit override for sending MMS messages. The requested
spend limit must be less than or equal to the MaxLimit, which is set by Amazon Web
Services.

# Arguments
- `monthly_limit`: The new monthly limit to enforce on text messages.

"""
function set_media_message_spend_limit_override(
    MonthlyLimit; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "SetMediaMessageSpendLimitOverride",
        Dict{String,Any}("MonthlyLimit" => MonthlyLimit);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function set_media_message_spend_limit_override(
    MonthlyLimit,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "SetMediaMessageSpendLimitOverride",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("MonthlyLimit" => MonthlyLimit), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    set_text_message_spend_limit_override(monthly_limit)
    set_text_message_spend_limit_override(monthly_limit, params::Dict{String,<:Any})

Sets an account level monthly spend limit override for sending text messages. The requested
spend limit must be less than or equal to the MaxLimit, which is set by Amazon Web
Services.

# Arguments
- `monthly_limit`: The new monthly limit to enforce on text messages.

"""
function set_text_message_spend_limit_override(
    MonthlyLimit; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "SetTextMessageSpendLimitOverride",
        Dict{String,Any}("MonthlyLimit" => MonthlyLimit);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function set_text_message_spend_limit_override(
    MonthlyLimit,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "SetTextMessageSpendLimitOverride",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("MonthlyLimit" => MonthlyLimit), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    set_voice_message_spend_limit_override(monthly_limit)
    set_voice_message_spend_limit_override(monthly_limit, params::Dict{String,<:Any})

Sets an account level monthly spend limit override for sending voice messages. The
requested spend limit must be less than or equal to the MaxLimit, which is set by Amazon
Web Services.

# Arguments
- `monthly_limit`: The new monthly limit to enforce on voice messages.

"""
function set_voice_message_spend_limit_override(
    MonthlyLimit; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "SetVoiceMessageSpendLimitOverride",
        Dict{String,Any}("MonthlyLimit" => MonthlyLimit);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function set_voice_message_spend_limit_override(
    MonthlyLimit,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "SetVoiceMessageSpendLimitOverride",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("MonthlyLimit" => MonthlyLimit), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    submit_registration_version(registration_id)
    submit_registration_version(registration_id, params::Dict{String,<:Any})

Submit the specified registration for review and approval.

# Arguments
- `registration_id`: The unique identifier for the registration.

"""
function submit_registration_version(
    RegistrationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "SubmitRegistrationVersion",
        Dict{String,Any}("RegistrationId" => RegistrationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function submit_registration_version(
    RegistrationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "SubmitRegistrationVersion",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("RegistrationId" => RegistrationId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds or overwrites only the specified tags for the specified Amazon Pinpoint SMS Voice,
version 2 resource. When you specify an existing tag key, the value is overwritten with the
new value. Each resource can have a maximum of 50 tags. Each tag consists of a key and an
optional value. Tag keys must be unique per resource. For more information about tags, see
Tagging Amazon Pinpoint resources in the Amazon Pinpoint Developer Guide.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.
- `tags`: An array of key and value pair tags that are associated with the resource.

"""
function tag_resource(ResourceArn, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return pinpoint_sms_voice_v2(
        "TagResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceArn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes the association of the specified tags from an Amazon Pinpoint SMS Voice V2
resource. For more information on tags see  Tagging Amazon Pinpoint resources in the Amazon
Pinpoint Developer Guide.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.
- `tag_keys`: An array of tag key values to unassociate with the resource.

"""
function untag_resource(
    ResourceArn, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "UntagResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceArn,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_event_destination(configuration_set_name, event_destination_name)
    update_event_destination(configuration_set_name, event_destination_name, params::Dict{String,<:Any})

Updates an existing event destination in a configuration set. You can update the IAM role
ARN for CloudWatch Logs and Kinesis Data Firehose. You can also enable or disable the event
destination. You may want to update an event destination to change its matching event types
or updating the destination resource ARN. You can't change an event destination's type
between CloudWatch Logs, Kinesis Data Firehose, and Amazon SNS.

# Arguments
- `configuration_set_name`: The configuration set to update with the new event destination.
  Valid values for this can be the ConfigurationSetName or ConfigurationSetArn.
- `event_destination_name`: The name to use for the event destination.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CloudWatchLogsDestination"`: An object that contains information about an event
  destination that sends data to CloudWatch Logs.
- `"Enabled"`: When set to true logging is enabled.
- `"KinesisFirehoseDestination"`: An object that contains information about an event
  destination for logging to Kinesis Data Firehose.
- `"MatchingEventTypes"`: An array of event types that determine which events to log.  The
  TEXT_SENT event type is not supported.
- `"SnsDestination"`: An object that contains information about an event destination that
  sends data to Amazon SNS.
"""
function update_event_destination(
    ConfigurationSetName,
    EventDestinationName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "UpdateEventDestination",
        Dict{String,Any}(
            "ConfigurationSetName" => ConfigurationSetName,
            "EventDestinationName" => EventDestinationName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_event_destination(
    ConfigurationSetName,
    EventDestinationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "UpdateEventDestination",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ConfigurationSetName" => ConfigurationSetName,
                    "EventDestinationName" => EventDestinationName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_phone_number(phone_number_id)
    update_phone_number(phone_number_id, params::Dict{String,<:Any})

Updates the configuration of an existing origination phone number. You can update the
opt-out list, enable or disable two-way messaging, change the TwoWayChannelArn, enable or
disable self-managed opt-outs, and enable or disable deletion protection. If the
origination phone number is associated with a pool, an error is returned.

# Arguments
- `phone_number_id`: The unique identifier of the phone number. Valid values for this field
  can be either the PhoneNumberId or PhoneNumberArn.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DeletionProtectionEnabled"`: By default this is set to false. When set to true the
  phone number can't be deleted.
- `"OptOutListName"`: The OptOutList to add the phone number to. Valid values for this
  field can be either the OutOutListName or OutOutListArn.
- `"SelfManagedOptOutsEnabled"`: By default this is set to false. When an end recipient
  sends a message that begins with HELP or STOP to one of your dedicated numbers, Amazon
  Pinpoint automatically replies with a customizable message and adds the end recipient to
  the OptOutList. When set to true you're responsible for responding to HELP and STOP
  requests. You're also responsible for tracking and honoring opt-out requests.
- `"TwoWayChannelArn"`: The Amazon Resource Name (ARN) of the two way channel.
- `"TwoWayChannelRole"`: An optional IAM Role Arn for a service to assume, to be able to
  post inbound SMS messages.
- `"TwoWayEnabled"`: By default this is set to false. When set to true you can receive
  incoming text messages from your end recipients.
"""
function update_phone_number(
    PhoneNumberId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "UpdatePhoneNumber",
        Dict{String,Any}("PhoneNumberId" => PhoneNumberId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_phone_number(
    PhoneNumberId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "UpdatePhoneNumber",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("PhoneNumberId" => PhoneNumberId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_pool(pool_id)
    update_pool(pool_id, params::Dict{String,<:Any})

Updates the configuration of an existing pool. You can update the opt-out list, enable or
disable two-way messaging, change the TwoWayChannelArn, enable or disable self-managed
opt-outs, enable or disable deletion protection, and enable or disable shared routes.

# Arguments
- `pool_id`: The unique identifier of the pool to update. Valid values are either the
  PoolId or PoolArn.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DeletionProtectionEnabled"`: When set to true the pool can't be deleted.
- `"OptOutListName"`: The OptOutList to associate with the pool. Valid values are either
  OptOutListName or OptOutListArn.
- `"SelfManagedOptOutsEnabled"`: By default this is set to false. When an end recipient
  sends a message that begins with HELP or STOP to one of your dedicated numbers, Amazon
  Pinpoint automatically replies with a customizable message and adds the end recipient to
  the OptOutList. When set to true you're responsible for responding to HELP and STOP
  requests. You're also responsible for tracking and honoring opt-out requests.
- `"SharedRoutesEnabled"`: Indicates whether shared routes are enabled for the pool.
- `"TwoWayChannelArn"`: The Amazon Resource Name (ARN) of the two way channel.
- `"TwoWayChannelRole"`: An optional IAM Role Arn for a service to assume, to be able to
  post inbound SMS messages.
- `"TwoWayEnabled"`: By default this is set to false. When set to true you can receive
  incoming text messages from your end recipients.
"""
function update_pool(PoolId; aws_config::AbstractAWSConfig=current_aws_config())
    return pinpoint_sms_voice_v2(
        "UpdatePool",
        Dict{String,Any}("PoolId" => PoolId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_pool(
    PoolId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "UpdatePool",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("PoolId" => PoolId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_protect_configuration(protect_configuration_id)
    update_protect_configuration(protect_configuration_id, params::Dict{String,<:Any})

Update the setting for an existing protect configuration.

# Arguments
- `protect_configuration_id`: The unique identifier for the protect configuration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DeletionProtectionEnabled"`: When set to true deletion protection is enabled. By
  default this is set to false.
"""
function update_protect_configuration(
    ProtectConfigurationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "UpdateProtectConfiguration",
        Dict{String,Any}("ProtectConfigurationId" => ProtectConfigurationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_protect_configuration(
    ProtectConfigurationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "UpdateProtectConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ProtectConfigurationId" => ProtectConfigurationId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_protect_configuration_country_rule_set(country_rule_set_updates, number_capability, protect_configuration_id)
    update_protect_configuration_country_rule_set(country_rule_set_updates, number_capability, protect_configuration_id, params::Dict{String,<:Any})

Update a country rule set to ALLOW or BLOCK messages to be sent to the specified
destination counties. You can update one or multiple countries at a time. The updates are
only applied to the specified NumberCapability type.

# Arguments
- `country_rule_set_updates`: A map of ProtectConfigurationCountryRuleSetInformation
  objects that contain the details for the requested NumberCapability. The Key is the
  two-letter ISO country code. For a list of supported ISO country codes, see Supported
  countries and regions (SMS channel) in the Amazon Pinpoint SMS user guide.
- `number_capability`: The number capability to apply the CountryRuleSetUpdates updates to.
- `protect_configuration_id`: The unique identifier for the protect configuration.

"""
function update_protect_configuration_country_rule_set(
    CountryRuleSetUpdates,
    NumberCapability,
    ProtectConfigurationId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "UpdateProtectConfigurationCountryRuleSet",
        Dict{String,Any}(
            "CountryRuleSetUpdates" => CountryRuleSetUpdates,
            "NumberCapability" => NumberCapability,
            "ProtectConfigurationId" => ProtectConfigurationId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_protect_configuration_country_rule_set(
    CountryRuleSetUpdates,
    NumberCapability,
    ProtectConfigurationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "UpdateProtectConfigurationCountryRuleSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CountryRuleSetUpdates" => CountryRuleSetUpdates,
                    "NumberCapability" => NumberCapability,
                    "ProtectConfigurationId" => ProtectConfigurationId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_sender_id(iso_country_code, sender_id)
    update_sender_id(iso_country_code, sender_id, params::Dict{String,<:Any})

Updates the configuration of an existing sender ID.

# Arguments
- `iso_country_code`: The two-character code, in ISO 3166-1 alpha-2 format, for the country
  or region.
- `sender_id`: The sender ID to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DeletionProtectionEnabled"`: By default this is set to false. When set to true the
  sender ID can't be deleted.
"""
function update_sender_id(
    IsoCountryCode, SenderId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice_v2(
        "UpdateSenderId",
        Dict{String,Any}("IsoCountryCode" => IsoCountryCode, "SenderId" => SenderId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_sender_id(
    IsoCountryCode,
    SenderId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "UpdateSenderId",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "IsoCountryCode" => IsoCountryCode, "SenderId" => SenderId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    verify_destination_number(verification_code, verified_destination_number_id)
    verify_destination_number(verification_code, verified_destination_number_id, params::Dict{String,<:Any})

Use the verification code that was received by the verified destination phone number to
opt-in the verified destination phone number to receive more messages.

# Arguments
- `verification_code`: The verification code that was received by the verified destination
  phone number.
- `verified_destination_number_id`: The unique identifier for the verififed destination
  phone number.

"""
function verify_destination_number(
    VerificationCode,
    VerifiedDestinationNumberId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "VerifyDestinationNumber",
        Dict{String,Any}(
            "VerificationCode" => VerificationCode,
            "VerifiedDestinationNumberId" => VerifiedDestinationNumberId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function verify_destination_number(
    VerificationCode,
    VerifiedDestinationNumberId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice_v2(
        "VerifyDestinationNumber",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "VerificationCode" => VerificationCode,
                    "VerifiedDestinationNumberId" => VerifiedDestinationNumberId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

using AWS
using AWS: AWSCredentials, AWSServices, assume_role_creds
using AWS.AWSExceptions:
    AWSException, IMDSUnavailable, InvalidFileName, NoCredentials, ProtocolNotDefined
using AWS.AWSMetadata:
    ServiceFile,
    _clean_documentation,
    _filter_latest_service_version,
    _generate_low_level_definition,
    _generate_high_level_definition,
    _generate_high_level_definitions,
    _get_service_files,
    _get_service_and_version,
    _get_function_parameters,
    _clean_uri,
    _format_name,
    _splitline,
    _wraplines,
    _validindex
using Base64
using Compat: mergewith, pkgversion
using Dates
using Downloads
using GitHub
using HTTP
using IniFile: Inifile, sections
using JSON
using OrderedCollections: LittleDict, OrderedDict
using MbedTLS: digest, MD_SHA256, MD_MD5
using Mocking
using Pkg
using Random
using Suppressor
using Test
using UUIDs
using XMLDict
using StableRNGs

Mocking.activate()

# Load all services once to avoid "replacing module" warnings
@service Glacier
@service IAM
@service S3
@service SQS
@service STS
@service Secrets_Manager

include("utils.jl")
include("patch.jl")
include("resource/totp.jl")

const RUN_UNIT_TESTS = get(ENV, "RUN_UNIT_TESTS", "true") == "true"
const RUN_INTEGRATION_TESTS = get(ENV, "RUN_INTEGRATION_TESTS", "false") == "true"
const RUN_MINIO_INTEGRATION_TESTS = begin
    all(k -> haskey(ENV, k), ("MINIO_ACCESS_KEY", "MINIO_SECRET_KEY", "MINIO_REGION_NAME"))
end

# Avoid the situation where we all tests are silently skipped. Most likely due to the wrong
# environmental variables being used.
if !RUN_UNIT_TESTS && !RUN_INTEGRATION_TESTS
    error("All tests have been disabled")
end

@testset "AWS.jl" begin
    # Unit tests do not requires access to an AWS account
    @testset "Unit Tests" begin
        if RUN_UNIT_TESTS
            # Force unit tests to run without a valid AWS configuration being present
            withenv(
                [k => nothing for k in filter(startswith("AWS_"), keys(ENV))]...,
                "AWS_CONFIG_FILE" => "/dev/null",
                "AWS_SHARED_CREDENTIALS_FILE" => "/dev/null",
            ) do
                include("unit/AWS.jl")
                include("unit/AWSExceptions.jl")
                include("unit/AWSMetadataUtilities.jl")
                include("unit/test_pkg.jl")
                include("unit/utilities.jl")
                include("unit/AWSConfig.jl")
                include("unit/IMDS.jl")
                include("unit/AWSCredentials.jl")
                include("unit/issues.jl")
            end
        else
            @warn "Skipping unit tests"
        end
    end

    # Integration tests require access to an AWS account
    @testset "Integration Tests" begin
        if RUN_INTEGRATION_TESTS
            with_aws_config(AWSConfig()) do
                backends = [AWS.HTTPBackend, AWS.DownloadsBackend]

                @testset "Backend: $(nameof(backend))" for backend in backends
                    AWS.DEFAULT_BACKEND[] = backend()
                    include("integration/AWS.jl")
                    include("integration/AWSCredentials.jl")
                    include("integration/role.jl")
                    include("integration/issues.jl")

                    if RUN_MINIO_INTEGRATION_TESTS
                        include("integration/minio.jl")
                    else
                        @warn "Skipping MinIO integration tests"
                    end
                end
            end
        else
            @warn "Skipping integration tests"
        end
    end
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: sesv2
using AWS.Compat
using AWS.UUIDs

"""
    batch_get_metric_data(queries)
    batch_get_metric_data(queries, params::Dict{String,<:Any})

Retrieves batches of metric data collected based on your sending activity. You can execute
this operation no more than 16 times per second, and with at most 160 queries from the
batches per second (cumulative).

# Arguments
- `queries`: A list of queries for metrics to be retrieved.

"""
function batch_get_metric_data(Queries; aws_config::AbstractAWSConfig=current_aws_config())
    return sesv2(
        "POST",
        "/v2/email/metrics/batch",
        Dict{String,Any}("Queries" => Queries);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_metric_data(
    Queries,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "POST",
        "/v2/email/metrics/batch",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Queries" => Queries), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_export_job(job_id)
    cancel_export_job(job_id, params::Dict{String,<:Any})

Cancels an export job.

# Arguments
- `job_id`: The export job ID.

"""
function cancel_export_job(JobId; aws_config::AbstractAWSConfig=current_aws_config())
    return sesv2(
        "PUT",
        "/v2/email/export-jobs/$(JobId)/cancel";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_export_job(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "PUT",
        "/v2/email/export-jobs/$(JobId)/cancel",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_configuration_set(configuration_set_name)
    create_configuration_set(configuration_set_name, params::Dict{String,<:Any})

Create a configuration set. Configuration sets are groups of rules that you can apply to
the emails that you send. You apply a configuration set to an email by specifying the name
of the configuration set when you call the Amazon SES API v2. When you apply a
configuration set to an email, all of the rules in that configuration set are applied to
the email.

# Arguments
- `configuration_set_name`: The name of the configuration set. The name can contain up to
  64 alphanumeric characters, including letters, numbers, hyphens (-) and underscores (_)
  only.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DeliveryOptions"`: An object that defines the dedicated IP pool that is used to send
  emails that you send using the configuration set.
- `"ReputationOptions"`: An object that defines whether or not Amazon SES collects
  reputation metrics for the emails that you send that use the configuration set.
- `"SendingOptions"`: An object that defines whether or not Amazon SES can send email that
  you send using the configuration set.
- `"SuppressionOptions"`:
- `"Tags"`: An array of objects that define the tags (keys and values) to associate with
  the configuration set.
- `"TrackingOptions"`: An object that defines the open and click tracking options for
  emails that you send using the configuration set.
- `"VdmOptions"`: An object that defines the VDM options for emails that you send using the
  configuration set.
"""
function create_configuration_set(
    ConfigurationSetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "POST",
        "/v2/email/configuration-sets",
        Dict{String,Any}("ConfigurationSetName" => ConfigurationSetName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_configuration_set(
    ConfigurationSetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "POST",
        "/v2/email/configuration-sets",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ConfigurationSetName" => ConfigurationSetName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_configuration_set_event_destination(configuration_set_name, event_destination, event_destination_name)
    create_configuration_set_event_destination(configuration_set_name, event_destination, event_destination_name, params::Dict{String,<:Any})

Create an event destination. Events include message sends, deliveries, opens, clicks,
bounces, and complaints. Event destinations are places that you can send information about
these events to. For example, you can send event data to Amazon EventBridge and associate a
rule to send the event to the specified target. A single configuration set can include more
than one event destination.

# Arguments
- `configuration_set_name`: The name of the configuration set .
- `event_destination`: An object that defines the event destination.
- `event_destination_name`: A name that identifies the event destination within the
  configuration set.

"""
function create_configuration_set_event_destination(
    ConfigurationSetName,
    EventDestination,
    EventDestinationName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "POST",
        "/v2/email/configuration-sets/$(ConfigurationSetName)/event-destinations",
        Dict{String,Any}(
            "EventDestination" => EventDestination,
            "EventDestinationName" => EventDestinationName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_configuration_set_event_destination(
    ConfigurationSetName,
    EventDestination,
    EventDestinationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "POST",
        "/v2/email/configuration-sets/$(ConfigurationSetName)/event-destinations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EventDestination" => EventDestination,
                    "EventDestinationName" => EventDestinationName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_contact(contact_list_name, email_address)
    create_contact(contact_list_name, email_address, params::Dict{String,<:Any})

Creates a contact, which is an end-user who is receiving the email, and adds them to a
contact list.

# Arguments
- `contact_list_name`: The name of the contact list to which the contact should be added.
- `email_address`: The contact's email address.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AttributesData"`: The attribute data attached to a contact.
- `"TopicPreferences"`: The contact's preferences for being opted-in to or opted-out of
  topics.
- `"UnsubscribeAll"`: A boolean value status noting if the contact is unsubscribed from all
  contact list topics.
"""
function create_contact(
    ContactListName, EmailAddress; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "POST",
        "/v2/email/contact-lists/$(ContactListName)/contacts",
        Dict{String,Any}("EmailAddress" => EmailAddress);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_contact(
    ContactListName,
    EmailAddress,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "POST",
        "/v2/email/contact-lists/$(ContactListName)/contacts",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("EmailAddress" => EmailAddress), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_contact_list(contact_list_name)
    create_contact_list(contact_list_name, params::Dict{String,<:Any})

Creates a contact list.

# Arguments
- `contact_list_name`: The name of the contact list.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description of what the contact list is about.
- `"Tags"`: The tags associated with a contact list.
- `"Topics"`: An interest group, theme, or label within a list. A contact list can have
  multiple topics.
"""
function create_contact_list(
    ContactListName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "POST",
        "/v2/email/contact-lists",
        Dict{String,Any}("ContactListName" => ContactListName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_contact_list(
    ContactListName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "POST",
        "/v2/email/contact-lists",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ContactListName" => ContactListName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_custom_verification_email_template(failure_redirection_url, from_email_address, success_redirection_url, template_content, template_name, template_subject)
    create_custom_verification_email_template(failure_redirection_url, from_email_address, success_redirection_url, template_content, template_name, template_subject, params::Dict{String,<:Any})

Creates a new custom verification email template. For more information about custom
verification email templates, see Using custom verification email templates in the Amazon
SES Developer Guide. You can execute this operation no more than once per second.

# Arguments
- `failure_redirection_url`: The URL that the recipient of the verification email is sent
  to if his or her address is not successfully verified.
- `from_email_address`: The email address that the custom verification email is sent from.
- `success_redirection_url`: The URL that the recipient of the verification email is sent
  to if his or her address is successfully verified.
- `template_content`: The content of the custom verification email. The total size of the
  email must be less than 10 MB. The message body may contain HTML, with some limitations.
  For more information, see Custom verification email frequently asked questions in the
  Amazon SES Developer Guide.
- `template_name`: The name of the custom verification email template.
- `template_subject`: The subject line of the custom verification email.

"""
function create_custom_verification_email_template(
    FailureRedirectionURL,
    FromEmailAddress,
    SuccessRedirectionURL,
    TemplateContent,
    TemplateName,
    TemplateSubject;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "POST",
        "/v2/email/custom-verification-email-templates",
        Dict{String,Any}(
            "FailureRedirectionURL" => FailureRedirectionURL,
            "FromEmailAddress" => FromEmailAddress,
            "SuccessRedirectionURL" => SuccessRedirectionURL,
            "TemplateContent" => TemplateContent,
            "TemplateName" => TemplateName,
            "TemplateSubject" => TemplateSubject,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_custom_verification_email_template(
    FailureRedirectionURL,
    FromEmailAddress,
    SuccessRedirectionURL,
    TemplateContent,
    TemplateName,
    TemplateSubject,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "POST",
        "/v2/email/custom-verification-email-templates",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "FailureRedirectionURL" => FailureRedirectionURL,
                    "FromEmailAddress" => FromEmailAddress,
                    "SuccessRedirectionURL" => SuccessRedirectionURL,
                    "TemplateContent" => TemplateContent,
                    "TemplateName" => TemplateName,
                    "TemplateSubject" => TemplateSubject,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_dedicated_ip_pool(pool_name)
    create_dedicated_ip_pool(pool_name, params::Dict{String,<:Any})

Create a new pool of dedicated IP addresses. A pool can include one or more dedicated IP
addresses that are associated with your Amazon Web Services account. You can associate a
pool with a configuration set. When you send an email that uses that configuration set, the
message is sent from one of the addresses in the associated pool.

# Arguments
- `pool_name`: The name of the dedicated IP pool.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ScalingMode"`: The type of scaling mode.
- `"Tags"`: An object that defines the tags (keys and values) that you want to associate
  with the pool.
"""
function create_dedicated_ip_pool(
    PoolName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "POST",
        "/v2/email/dedicated-ip-pools",
        Dict{String,Any}("PoolName" => PoolName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_dedicated_ip_pool(
    PoolName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "POST",
        "/v2/email/dedicated-ip-pools",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("PoolName" => PoolName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_deliverability_test_report(content, from_email_address)
    create_deliverability_test_report(content, from_email_address, params::Dict{String,<:Any})

Create a new predictive inbox placement test. Predictive inbox placement tests can help you
predict how your messages will be handled by various email providers around the world. When
you perform a predictive inbox placement test, you provide a sample message that contains
the content that you plan to send to your customers. Amazon SES then sends that message to
special email addresses spread across several major email providers. After about 24 hours,
the test is complete, and you can use the GetDeliverabilityTestReport operation to view the
results of the test.

# Arguments
- `content`: The HTML body of the message that you sent when you performed the predictive
  inbox placement test.
- `from_email_address`: The email address that the predictive inbox placement test email
  was sent from.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ReportName"`: A unique name that helps you to identify the predictive inbox placement
  test when you retrieve the results.
- `"Tags"`: An array of objects that define the tags (keys and values) that you want to
  associate with the predictive inbox placement test.
"""
function create_deliverability_test_report(
    Content, FromEmailAddress; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "POST",
        "/v2/email/deliverability-dashboard/test",
        Dict{String,Any}("Content" => Content, "FromEmailAddress" => FromEmailAddress);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_deliverability_test_report(
    Content,
    FromEmailAddress,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "POST",
        "/v2/email/deliverability-dashboard/test",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Content" => Content, "FromEmailAddress" => FromEmailAddress
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_email_identity(email_identity)
    create_email_identity(email_identity, params::Dict{String,<:Any})

Starts the process of verifying an email identity. An identity is an email address or
domain that you use when you send email. Before you can use an identity to send email, you
first have to verify it. By verifying an identity, you demonstrate that you're the owner of
the identity, and that you've given Amazon SES API v2 permission to send email from the
identity. When you verify an email address, Amazon SES sends an email to the address. Your
email address is verified as soon as you follow the link in the verification email.  When
you verify a domain without specifying the DkimSigningAttributes object, this operation
provides a set of DKIM tokens. You can convert these tokens into CNAME records, which you
then add to the DNS configuration for your domain. Your domain is verified when Amazon SES
detects these records in the DNS configuration for your domain. This verification method is
known as Easy DKIM. Alternatively, you can perform the verification process by providing
your own public-private key pair. This verification method is known as Bring Your Own DKIM
(BYODKIM). To use BYODKIM, your call to the CreateEmailIdentity operation has to include
the DkimSigningAttributes object. When you specify this object, you provide a selector (a
component of the DNS record name that identifies the public key to use for DKIM
authentication) and a private key. When you verify a domain, this operation provides a set
of DKIM tokens, which you can convert into CNAME tokens. You add these CNAME tokens to the
DNS configuration for your domain. Your domain is verified when Amazon SES detects these
records in the DNS configuration for your domain. For some DNS providers, it can take 72
hours or more to complete the domain verification process. Additionally, you can associate
an existing configuration set with the email identity that you're verifying.

# Arguments
- `email_identity`: The email address or domain to verify.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConfigurationSetName"`: The configuration set to use by default when sending from this
  identity. Note that any configuration set defined in the email sending request takes
  precedence.
- `"DkimSigningAttributes"`: If your request includes this object, Amazon SES configures
  the identity to use Bring Your Own DKIM (BYODKIM) for DKIM authentication purposes, or,
  configures the key length to be used for Easy DKIM. You can only specify this object if the
  email identity is a domain, as opposed to an address.
- `"Tags"`: An array of objects that define the tags (keys and values) to associate with
  the email identity.
"""
function create_email_identity(
    EmailIdentity; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "POST",
        "/v2/email/identities",
        Dict{String,Any}("EmailIdentity" => EmailIdentity);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_email_identity(
    EmailIdentity,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "POST",
        "/v2/email/identities",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("EmailIdentity" => EmailIdentity), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_email_identity_policy(email_identity, policy, policy_name)
    create_email_identity_policy(email_identity, policy, policy_name, params::Dict{String,<:Any})

Creates the specified sending authorization policy for the given identity (an email address
or a domain).  This API is for the identity owner only. If you have not verified the
identity, this API will return an error.  Sending authorization is a feature that enables
an identity owner to authorize other senders to use its identities. For information about
using sending authorization, see the Amazon SES Developer Guide. You can execute this
operation no more than once per second.

# Arguments
- `email_identity`: The email identity.
- `policy`: The text of the policy in JSON format. The policy cannot exceed 4 KB. For
  information about the syntax of sending authorization policies, see the Amazon SES
  Developer Guide.
- `policy_name`: The name of the policy. The policy name cannot exceed 64 characters and
  can only include alphanumeric characters, dashes, and underscores.

"""
function create_email_identity_policy(
    EmailIdentity, Policy, PolicyName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "POST",
        "/v2/email/identities/$(EmailIdentity)/policies/$(PolicyName)",
        Dict{String,Any}("Policy" => Policy);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_email_identity_policy(
    EmailIdentity,
    Policy,
    PolicyName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "POST",
        "/v2/email/identities/$(EmailIdentity)/policies/$(PolicyName)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Policy" => Policy), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_email_template(template_content, template_name)
    create_email_template(template_content, template_name, params::Dict{String,<:Any})

Creates an email template. Email templates enable you to send personalized email to one or
more destinations in a single API operation. For more information, see the Amazon SES
Developer Guide. You can execute this operation no more than once per second.

# Arguments
- `template_content`: The content of the email template, composed of a subject line, an
  HTML part, and a text-only part.
- `template_name`: The name of the template.

"""
function create_email_template(
    TemplateContent, TemplateName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "POST",
        "/v2/email/templates",
        Dict{String,Any}(
            "TemplateContent" => TemplateContent, "TemplateName" => TemplateName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_email_template(
    TemplateContent,
    TemplateName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "POST",
        "/v2/email/templates",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "TemplateContent" => TemplateContent, "TemplateName" => TemplateName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_export_job(export_data_source, export_destination)
    create_export_job(export_data_source, export_destination, params::Dict{String,<:Any})

Creates an export job for a data source and destination. You can execute this operation no
more than once per second.

# Arguments
- `export_data_source`: The data source for the export job.
- `export_destination`: The destination for the export job.

"""
function create_export_job(
    ExportDataSource, ExportDestination; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "POST",
        "/v2/email/export-jobs",
        Dict{String,Any}(
            "ExportDataSource" => ExportDataSource, "ExportDestination" => ExportDestination
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_export_job(
    ExportDataSource,
    ExportDestination,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "POST",
        "/v2/email/export-jobs",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ExportDataSource" => ExportDataSource,
                    "ExportDestination" => ExportDestination,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_import_job(import_data_source, import_destination)
    create_import_job(import_data_source, import_destination, params::Dict{String,<:Any})

Creates an import job for a data destination.

# Arguments
- `import_data_source`: The data source for the import job.
- `import_destination`: The destination for the import job.

"""
function create_import_job(
    ImportDataSource, ImportDestination; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "POST",
        "/v2/email/import-jobs",
        Dict{String,Any}(
            "ImportDataSource" => ImportDataSource, "ImportDestination" => ImportDestination
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_import_job(
    ImportDataSource,
    ImportDestination,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "POST",
        "/v2/email/import-jobs",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ImportDataSource" => ImportDataSource,
                    "ImportDestination" => ImportDestination,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_configuration_set(configuration_set_name)
    delete_configuration_set(configuration_set_name, params::Dict{String,<:Any})

Delete an existing configuration set.  Configuration sets are groups of rules that you can
apply to the emails you send. You apply a configuration set to an email by including a
reference to the configuration set in the headers of the email. When you apply a
configuration set to an email, all of the rules in that configuration set are applied to
the email.

# Arguments
- `configuration_set_name`: The name of the configuration set.

"""
function delete_configuration_set(
    ConfigurationSetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "DELETE",
        "/v2/email/configuration-sets/$(ConfigurationSetName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_configuration_set(
    ConfigurationSetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "DELETE",
        "/v2/email/configuration-sets/$(ConfigurationSetName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_configuration_set_event_destination(configuration_set_name, event_destination_name)
    delete_configuration_set_event_destination(configuration_set_name, event_destination_name, params::Dict{String,<:Any})

Delete an event destination.  Events include message sends, deliveries, opens, clicks,
bounces, and complaints. Event destinations are places that you can send information about
these events to. For example, you can send event data to Amazon EventBridge and associate a
rule to send the event to the specified target.

# Arguments
- `configuration_set_name`: The name of the configuration set that contains the event
  destination to delete.
- `event_destination_name`: The name of the event destination to delete.

"""
function delete_configuration_set_event_destination(
    ConfigurationSetName,
    EventDestinationName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "DELETE",
        "/v2/email/configuration-sets/$(ConfigurationSetName)/event-destinations/$(EventDestinationName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_configuration_set_event_destination(
    ConfigurationSetName,
    EventDestinationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "DELETE",
        "/v2/email/configuration-sets/$(ConfigurationSetName)/event-destinations/$(EventDestinationName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_contact(contact_list_name, email_address)
    delete_contact(contact_list_name, email_address, params::Dict{String,<:Any})

Removes a contact from a contact list.

# Arguments
- `contact_list_name`: The name of the contact list from which the contact should be
  removed.
- `email_address`: The contact's email address.

"""
function delete_contact(
    ContactListName, EmailAddress; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "DELETE",
        "/v2/email/contact-lists/$(ContactListName)/contacts/$(EmailAddress)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_contact(
    ContactListName,
    EmailAddress,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "DELETE",
        "/v2/email/contact-lists/$(ContactListName)/contacts/$(EmailAddress)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_contact_list(contact_list_name)
    delete_contact_list(contact_list_name, params::Dict{String,<:Any})

Deletes a contact list and all of the contacts on that list.

# Arguments
- `contact_list_name`: The name of the contact list.

"""
function delete_contact_list(
    ContactListName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "DELETE",
        "/v2/email/contact-lists/$(ContactListName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_contact_list(
    ContactListName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "DELETE",
        "/v2/email/contact-lists/$(ContactListName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_custom_verification_email_template(template_name)
    delete_custom_verification_email_template(template_name, params::Dict{String,<:Any})

Deletes an existing custom verification email template. For more information about custom
verification email templates, see Using custom verification email templates in the Amazon
SES Developer Guide. You can execute this operation no more than once per second.

# Arguments
- `template_name`: The name of the custom verification email template that you want to
  delete.

"""
function delete_custom_verification_email_template(
    TemplateName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "DELETE",
        "/v2/email/custom-verification-email-templates/$(TemplateName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_custom_verification_email_template(
    TemplateName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "DELETE",
        "/v2/email/custom-verification-email-templates/$(TemplateName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_dedicated_ip_pool(pool_name)
    delete_dedicated_ip_pool(pool_name, params::Dict{String,<:Any})

Delete a dedicated IP pool.

# Arguments
- `pool_name`: The name of the dedicated IP pool that you want to delete.

"""
function delete_dedicated_ip_pool(
    PoolName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "DELETE",
        "/v2/email/dedicated-ip-pools/$(PoolName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_dedicated_ip_pool(
    PoolName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "DELETE",
        "/v2/email/dedicated-ip-pools/$(PoolName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_email_identity(email_identity)
    delete_email_identity(email_identity, params::Dict{String,<:Any})

Deletes an email identity. An identity can be either an email address or a domain name.

# Arguments
- `email_identity`: The identity (that is, the email address or domain) to delete.

"""
function delete_email_identity(
    EmailIdentity; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "DELETE",
        "/v2/email/identities/$(EmailIdentity)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_email_identity(
    EmailIdentity,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "DELETE",
        "/v2/email/identities/$(EmailIdentity)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_email_identity_policy(email_identity, policy_name)
    delete_email_identity_policy(email_identity, policy_name, params::Dict{String,<:Any})

Deletes the specified sending authorization policy for the given identity (an email address
or a domain). This API returns successfully even if a policy with the specified name does
not exist.  This API is for the identity owner only. If you have not verified the identity,
this API will return an error.  Sending authorization is a feature that enables an identity
owner to authorize other senders to use its identities. For information about using sending
authorization, see the Amazon SES Developer Guide. You can execute this operation no more
than once per second.

# Arguments
- `email_identity`: The email identity.
- `policy_name`: The name of the policy. The policy name cannot exceed 64 characters and
  can only include alphanumeric characters, dashes, and underscores.

"""
function delete_email_identity_policy(
    EmailIdentity, PolicyName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "DELETE",
        "/v2/email/identities/$(EmailIdentity)/policies/$(PolicyName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_email_identity_policy(
    EmailIdentity,
    PolicyName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "DELETE",
        "/v2/email/identities/$(EmailIdentity)/policies/$(PolicyName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_email_template(template_name)
    delete_email_template(template_name, params::Dict{String,<:Any})

Deletes an email template. You can execute this operation no more than once per second.

# Arguments
- `template_name`: The name of the template to be deleted.

"""
function delete_email_template(
    TemplateName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "DELETE",
        "/v2/email/templates/$(TemplateName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_email_template(
    TemplateName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "DELETE",
        "/v2/email/templates/$(TemplateName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_suppressed_destination(email_address)
    delete_suppressed_destination(email_address, params::Dict{String,<:Any})

Removes an email address from the suppression list for your account.

# Arguments
- `email_address`: The suppressed email destination to remove from the account suppression
  list.

"""
function delete_suppressed_destination(
    EmailAddress; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "DELETE",
        "/v2/email/suppression/addresses/$(EmailAddress)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_suppressed_destination(
    EmailAddress,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "DELETE",
        "/v2/email/suppression/addresses/$(EmailAddress)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_account()
    get_account(params::Dict{String,<:Any})

Obtain information about the email-sending status and capabilities of your Amazon SES
account in the current Amazon Web Services Region.

"""
function get_account(; aws_config::AbstractAWSConfig=current_aws_config())
    return sesv2(
        "GET", "/v2/email/account"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_account(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "GET",
        "/v2/email/account",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_blacklist_reports(blacklist_item_names)
    get_blacklist_reports(blacklist_item_names, params::Dict{String,<:Any})

Retrieve a list of the blacklists that your dedicated IP addresses appear on.

# Arguments
- `blacklist_item_names`: A list of IP addresses that you want to retrieve blacklist
  information about. You can only specify the dedicated IP addresses that you use to send
  email using Amazon SES or Amazon Pinpoint.

"""
function get_blacklist_reports(
    BlacklistItemNames; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "GET",
        "/v2/email/deliverability-dashboard/blacklist-report",
        Dict{String,Any}("BlacklistItemNames" => BlacklistItemNames);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_blacklist_reports(
    BlacklistItemNames,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "GET",
        "/v2/email/deliverability-dashboard/blacklist-report",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("BlacklistItemNames" => BlacklistItemNames), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_configuration_set(configuration_set_name)
    get_configuration_set(configuration_set_name, params::Dict{String,<:Any})

Get information about an existing configuration set, including the dedicated IP pool that
it's associated with, whether or not it's enabled for sending email, and more.
Configuration sets are groups of rules that you can apply to the emails you send. You apply
a configuration set to an email by including a reference to the configuration set in the
headers of the email. When you apply a configuration set to an email, all of the rules in
that configuration set are applied to the email.

# Arguments
- `configuration_set_name`: The name of the configuration set.

"""
function get_configuration_set(
    ConfigurationSetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "GET",
        "/v2/email/configuration-sets/$(ConfigurationSetName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_configuration_set(
    ConfigurationSetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "GET",
        "/v2/email/configuration-sets/$(ConfigurationSetName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_configuration_set_event_destinations(configuration_set_name)
    get_configuration_set_event_destinations(configuration_set_name, params::Dict{String,<:Any})

Retrieve a list of event destinations that are associated with a configuration set.  Events
include message sends, deliveries, opens, clicks, bounces, and complaints. Event
destinations are places that you can send information about these events to. For example,
you can send event data to Amazon EventBridge and associate a rule to send the event to the
specified target.

# Arguments
- `configuration_set_name`: The name of the configuration set that contains the event
  destination.

"""
function get_configuration_set_event_destinations(
    ConfigurationSetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "GET",
        "/v2/email/configuration-sets/$(ConfigurationSetName)/event-destinations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_configuration_set_event_destinations(
    ConfigurationSetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "GET",
        "/v2/email/configuration-sets/$(ConfigurationSetName)/event-destinations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_contact(contact_list_name, email_address)
    get_contact(contact_list_name, email_address, params::Dict{String,<:Any})

Returns a contact from a contact list.

# Arguments
- `contact_list_name`: The name of the contact list to which the contact belongs.
- `email_address`: The contact's email address.

"""
function get_contact(
    ContactListName, EmailAddress; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "GET",
        "/v2/email/contact-lists/$(ContactListName)/contacts/$(EmailAddress)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_contact(
    ContactListName,
    EmailAddress,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "GET",
        "/v2/email/contact-lists/$(ContactListName)/contacts/$(EmailAddress)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_contact_list(contact_list_name)
    get_contact_list(contact_list_name, params::Dict{String,<:Any})

Returns contact list metadata. It does not return any information about the contacts
present in the list.

# Arguments
- `contact_list_name`: The name of the contact list.

"""
function get_contact_list(
    ContactListName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "GET",
        "/v2/email/contact-lists/$(ContactListName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_contact_list(
    ContactListName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "GET",
        "/v2/email/contact-lists/$(ContactListName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_custom_verification_email_template(template_name)
    get_custom_verification_email_template(template_name, params::Dict{String,<:Any})

Returns the custom email verification template for the template name you specify. For more
information about custom verification email templates, see Using custom verification email
templates in the Amazon SES Developer Guide. You can execute this operation no more than
once per second.

# Arguments
- `template_name`: The name of the custom verification email template that you want to
  retrieve.

"""
function get_custom_verification_email_template(
    TemplateName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "GET",
        "/v2/email/custom-verification-email-templates/$(TemplateName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_custom_verification_email_template(
    TemplateName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "GET",
        "/v2/email/custom-verification-email-templates/$(TemplateName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_dedicated_ip(ip)
    get_dedicated_ip(ip, params::Dict{String,<:Any})

Get information about a dedicated IP address, including the name of the dedicated IP pool
that it's associated with, as well information about the automatic warm-up process for the
address.

# Arguments
- `ip`: The IP address that you want to obtain more information about. The value you
  specify has to be a dedicated IP address that's assocaited with your Amazon Web Services
  account.

"""
function get_dedicated_ip(IP; aws_config::AbstractAWSConfig=current_aws_config())
    return sesv2(
        "GET",
        "/v2/email/dedicated-ips/$(IP)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_dedicated_ip(
    IP, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "GET",
        "/v2/email/dedicated-ips/$(IP)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_dedicated_ip_pool(pool_name)
    get_dedicated_ip_pool(pool_name, params::Dict{String,<:Any})

Retrieve information about the dedicated pool.

# Arguments
- `pool_name`: The name of the dedicated IP pool to retrieve.

"""
function get_dedicated_ip_pool(PoolName; aws_config::AbstractAWSConfig=current_aws_config())
    return sesv2(
        "GET",
        "/v2/email/dedicated-ip-pools/$(PoolName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_dedicated_ip_pool(
    PoolName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "GET",
        "/v2/email/dedicated-ip-pools/$(PoolName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_dedicated_ips()
    get_dedicated_ips(params::Dict{String,<:Any})

List the dedicated IP addresses that are associated with your Amazon Web Services account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: A token returned from a previous call to GetDedicatedIps to indicate the
  position of the dedicated IP pool in the list of IP pools.
- `"PageSize"`: The number of results to show in a single call to GetDedicatedIpsRequest.
  If the number of results is larger than the number you specified in this parameter, then
  the response includes a NextToken element, which you can use to obtain additional results.
- `"PoolName"`: The name of the IP pool that the dedicated IP address is associated with.
"""
function get_dedicated_ips(; aws_config::AbstractAWSConfig=current_aws_config())
    return sesv2(
        "GET",
        "/v2/email/dedicated-ips";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_dedicated_ips(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "GET",
        "/v2/email/dedicated-ips",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_deliverability_dashboard_options()
    get_deliverability_dashboard_options(params::Dict{String,<:Any})

Retrieve information about the status of the Deliverability dashboard for your account.
When the Deliverability dashboard is enabled, you gain access to reputation,
deliverability, and other metrics for the domains that you use to send email. You also gain
the ability to perform predictive inbox placement tests. When you use the Deliverability
dashboard, you pay a monthly subscription charge, in addition to any other fees that you
accrue by using Amazon SES and other Amazon Web Services services. For more information
about the features and cost of a Deliverability dashboard subscription, see Amazon SES
Pricing.

"""
function get_deliverability_dashboard_options(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "GET",
        "/v2/email/deliverability-dashboard";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_deliverability_dashboard_options(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "GET",
        "/v2/email/deliverability-dashboard",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_deliverability_test_report(report_id)
    get_deliverability_test_report(report_id, params::Dict{String,<:Any})

Retrieve the results of a predictive inbox placement test.

# Arguments
- `report_id`: A unique string that identifies the predictive inbox placement test.

"""
function get_deliverability_test_report(
    ReportId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "GET",
        "/v2/email/deliverability-dashboard/test-reports/$(ReportId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_deliverability_test_report(
    ReportId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "GET",
        "/v2/email/deliverability-dashboard/test-reports/$(ReportId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_domain_deliverability_campaign(campaign_id)
    get_domain_deliverability_campaign(campaign_id, params::Dict{String,<:Any})

Retrieve all the deliverability data for a specific campaign. This data is available for a
campaign only if the campaign sent email by using a domain that the Deliverability
dashboard is enabled for.

# Arguments
- `campaign_id`: The unique identifier for the campaign. The Deliverability dashboard
  automatically generates and assigns this identifier to a campaign.

"""
function get_domain_deliverability_campaign(
    CampaignId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "GET",
        "/v2/email/deliverability-dashboard/campaigns/$(CampaignId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_domain_deliverability_campaign(
    CampaignId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "GET",
        "/v2/email/deliverability-dashboard/campaigns/$(CampaignId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_domain_statistics_report(domain, end_date, start_date)
    get_domain_statistics_report(domain, end_date, start_date, params::Dict{String,<:Any})

Retrieve inbox placement and engagement rates for the domains that you use to send email.

# Arguments
- `domain`: The domain that you want to obtain deliverability metrics for.
- `end_date`: The last day (in Unix time) that you want to obtain domain deliverability
  metrics for. The EndDate that you specify has to be less than or equal to 30 days after the
  StartDate.
- `start_date`: The first day (in Unix time) that you want to obtain domain deliverability
  metrics for.

"""
function get_domain_statistics_report(
    Domain, EndDate, StartDate; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "GET",
        "/v2/email/deliverability-dashboard/statistics-report/$(Domain)",
        Dict{String,Any}("EndDate" => EndDate, "StartDate" => StartDate);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_domain_statistics_report(
    Domain,
    EndDate,
    StartDate,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "GET",
        "/v2/email/deliverability-dashboard/statistics-report/$(Domain)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("EndDate" => EndDate, "StartDate" => StartDate),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_email_identity(email_identity)
    get_email_identity(email_identity, params::Dict{String,<:Any})

Provides information about a specific identity, including the identity's verification
status, sending authorization policies, its DKIM authentication status, and its custom
Mail-From settings.

# Arguments
- `email_identity`: The email identity.

"""
function get_email_identity(
    EmailIdentity; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "GET",
        "/v2/email/identities/$(EmailIdentity)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_email_identity(
    EmailIdentity,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "GET",
        "/v2/email/identities/$(EmailIdentity)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_email_identity_policies(email_identity)
    get_email_identity_policies(email_identity, params::Dict{String,<:Any})

Returns the requested sending authorization policies for the given identity (an email
address or a domain). The policies are returned as a map of policy names to policy
contents. You can retrieve a maximum of 20 policies at a time.  This API is for the
identity owner only. If you have not verified the identity, this API will return an error.
Sending authorization is a feature that enables an identity owner to authorize other
senders to use its identities. For information about using sending authorization, see the
Amazon SES Developer Guide. You can execute this operation no more than once per second.

# Arguments
- `email_identity`: The email identity.

"""
function get_email_identity_policies(
    EmailIdentity; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "GET",
        "/v2/email/identities/$(EmailIdentity)/policies";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_email_identity_policies(
    EmailIdentity,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "GET",
        "/v2/email/identities/$(EmailIdentity)/policies",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_email_template(template_name)
    get_email_template(template_name, params::Dict{String,<:Any})

Displays the template object (which includes the subject line, HTML part and text part) for
the template you specify. You can execute this operation no more than once per second.

# Arguments
- `template_name`: The name of the template.

"""
function get_email_template(
    TemplateName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "GET",
        "/v2/email/templates/$(TemplateName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_email_template(
    TemplateName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "GET",
        "/v2/email/templates/$(TemplateName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_export_job(job_id)
    get_export_job(job_id, params::Dict{String,<:Any})

Provides information about an export job.

# Arguments
- `job_id`: The export job ID.

"""
function get_export_job(JobId; aws_config::AbstractAWSConfig=current_aws_config())
    return sesv2(
        "GET",
        "/v2/email/export-jobs/$(JobId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_export_job(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "GET",
        "/v2/email/export-jobs/$(JobId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_import_job(job_id)
    get_import_job(job_id, params::Dict{String,<:Any})

Provides information about an import job.

# Arguments
- `job_id`: The ID of the import job.

"""
function get_import_job(JobId; aws_config::AbstractAWSConfig=current_aws_config())
    return sesv2(
        "GET",
        "/v2/email/import-jobs/$(JobId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_import_job(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "GET",
        "/v2/email/import-jobs/$(JobId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_message_insights(message_id)
    get_message_insights(message_id, params::Dict{String,<:Any})

Provides information about a specific message, including the from address, the subject, the
recipient address, email tags, as well as events associated with the message. You can
execute this operation no more than once per second.

# Arguments
- `message_id`:  A MessageId is a unique identifier for a message, and is returned when
  sending emails through Amazon SES.

"""
function get_message_insights(MessageId; aws_config::AbstractAWSConfig=current_aws_config())
    return sesv2(
        "GET",
        "/v2/email/insights/$(MessageId)/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_message_insights(
    MessageId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "GET",
        "/v2/email/insights/$(MessageId)/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_suppressed_destination(email_address)
    get_suppressed_destination(email_address, params::Dict{String,<:Any})

Retrieves information about a specific email address that's on the suppression list for
your account.

# Arguments
- `email_address`: The email address that's on the account suppression list.

"""
function get_suppressed_destination(
    EmailAddress; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "GET",
        "/v2/email/suppression/addresses/$(EmailAddress)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_suppressed_destination(
    EmailAddress,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "GET",
        "/v2/email/suppression/addresses/$(EmailAddress)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_configuration_sets()
    list_configuration_sets(params::Dict{String,<:Any})

List all of the configuration sets associated with your account in the current region.
Configuration sets are groups of rules that you can apply to the emails you send. You apply
a configuration set to an email by including a reference to the configuration set in the
headers of the email. When you apply a configuration set to an email, all of the rules in
that configuration set are applied to the email.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: A token returned from a previous call to ListConfigurationSets to indicate
  the position in the list of configuration sets.
- `"PageSize"`: The number of results to show in a single call to ListConfigurationSets. If
  the number of results is larger than the number you specified in this parameter, then the
  response includes a NextToken element, which you can use to obtain additional results.
"""
function list_configuration_sets(; aws_config::AbstractAWSConfig=current_aws_config())
    return sesv2(
        "GET",
        "/v2/email/configuration-sets";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_configuration_sets(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "GET",
        "/v2/email/configuration-sets",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_contact_lists()
    list_contact_lists(params::Dict{String,<:Any})

Lists all of the contact lists available.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: A string token indicating that there might be additional contact lists
  available to be listed. Use the token provided in the Response to use in the subsequent
  call to ListContactLists with the same parameters to retrieve the next page of contact
  lists.
- `"PageSize"`: Maximum number of contact lists to return at once. Use this parameter to
  paginate results. If additional contact lists exist beyond the specified limit, the
  NextToken element is sent in the response. Use the NextToken value in subsequent requests
  to retrieve additional lists.
"""
function list_contact_lists(; aws_config::AbstractAWSConfig=current_aws_config())
    return sesv2(
        "GET",
        "/v2/email/contact-lists";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_contact_lists(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "GET",
        "/v2/email/contact-lists",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_contacts(contact_list_name)
    list_contacts(contact_list_name, params::Dict{String,<:Any})

Lists the contacts present in a specific contact list.

# Arguments
- `contact_list_name`: The name of the contact list.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filter"`: A filter that can be applied to a list of contacts.
- `"NextToken"`: A string token indicating that there might be additional contacts
  available to be listed. Use the token provided in the Response to use in the subsequent
  call to ListContacts with the same parameters to retrieve the next page of contacts.
- `"PageSize"`: The number of contacts that may be returned at once, which is dependent on
  if there are more or less contacts than the value of the PageSize. Use this parameter to
  paginate results. If additional contacts exist beyond the specified limit, the NextToken
  element is sent in the response. Use the NextToken value in subsequent requests to retrieve
  additional contacts.
"""
function list_contacts(ContactListName; aws_config::AbstractAWSConfig=current_aws_config())
    return sesv2(
        "POST",
        "/v2/email/contact-lists/$(ContactListName)/contacts/list";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_contacts(
    ContactListName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "POST",
        "/v2/email/contact-lists/$(ContactListName)/contacts/list",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_custom_verification_email_templates()
    list_custom_verification_email_templates(params::Dict{String,<:Any})

Lists the existing custom verification email templates for your account in the current
Amazon Web Services Region. For more information about custom verification email templates,
see Using custom verification email templates in the Amazon SES Developer Guide. You can
execute this operation no more than once per second.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: A token returned from a previous call to
  ListCustomVerificationEmailTemplates to indicate the position in the list of custom
  verification email templates.
- `"PageSize"`: The number of results to show in a single call to
  ListCustomVerificationEmailTemplates. If the number of results is larger than the number
  you specified in this parameter, then the response includes a NextToken element, which you
  can use to obtain additional results. The value you specify has to be at least 1, and can
  be no more than 50.
"""
function list_custom_verification_email_templates(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "GET",
        "/v2/email/custom-verification-email-templates";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_custom_verification_email_templates(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "GET",
        "/v2/email/custom-verification-email-templates",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_dedicated_ip_pools()
    list_dedicated_ip_pools(params::Dict{String,<:Any})

List all of the dedicated IP pools that exist in your Amazon Web Services account in the
current Region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: A token returned from a previous call to ListDedicatedIpPools to indicate
  the position in the list of dedicated IP pools.
- `"PageSize"`: The number of results to show in a single call to ListDedicatedIpPools. If
  the number of results is larger than the number you specified in this parameter, then the
  response includes a NextToken element, which you can use to obtain additional results.
"""
function list_dedicated_ip_pools(; aws_config::AbstractAWSConfig=current_aws_config())
    return sesv2(
        "GET",
        "/v2/email/dedicated-ip-pools";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_dedicated_ip_pools(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "GET",
        "/v2/email/dedicated-ip-pools",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_deliverability_test_reports()
    list_deliverability_test_reports(params::Dict{String,<:Any})

Show a list of the predictive inbox placement tests that you've performed, regardless of
their statuses. For predictive inbox placement tests that are complete, you can use the
GetDeliverabilityTestReport operation to view the results.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: A token returned from a previous call to ListDeliverabilityTestReports to
  indicate the position in the list of predictive inbox placement tests.
- `"PageSize"`: The number of results to show in a single call to
  ListDeliverabilityTestReports. If the number of results is larger than the number you
  specified in this parameter, then the response includes a NextToken element, which you can
  use to obtain additional results. The value you specify has to be at least 0, and can be no
  more than 1000.
"""
function list_deliverability_test_reports(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "GET",
        "/v2/email/deliverability-dashboard/test-reports";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_deliverability_test_reports(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "GET",
        "/v2/email/deliverability-dashboard/test-reports",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_domain_deliverability_campaigns(end_date, start_date, subscribed_domain)
    list_domain_deliverability_campaigns(end_date, start_date, subscribed_domain, params::Dict{String,<:Any})

Retrieve deliverability data for all the campaigns that used a specific domain to send
email during a specified time range. This data is available for a domain only if you
enabled the Deliverability dashboard for the domain.

# Arguments
- `end_date`: The last day that you want to obtain deliverability data for. This value has
  to be less than or equal to 30 days after the value of the StartDate parameter.
- `start_date`: The first day that you want to obtain deliverability data for.
- `subscribed_domain`: The domain to obtain deliverability data for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: A token that’s returned from a previous call to the
  ListDomainDeliverabilityCampaigns operation. This token indicates the position of a
  campaign in the list of campaigns.
- `"PageSize"`: The maximum number of results to include in response to a single call to
  the ListDomainDeliverabilityCampaigns operation. If the number of results is larger than
  the number that you specify in this parameter, the response includes a NextToken element,
  which you can use to obtain additional results.
"""
function list_domain_deliverability_campaigns(
    EndDate, StartDate, SubscribedDomain; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "GET",
        "/v2/email/deliverability-dashboard/domains/$(SubscribedDomain)/campaigns",
        Dict{String,Any}("EndDate" => EndDate, "StartDate" => StartDate);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_domain_deliverability_campaigns(
    EndDate,
    StartDate,
    SubscribedDomain,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "GET",
        "/v2/email/deliverability-dashboard/domains/$(SubscribedDomain)/campaigns",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("EndDate" => EndDate, "StartDate" => StartDate),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_email_identities()
    list_email_identities(params::Dict{String,<:Any})

Returns a list of all of the email identities that are associated with your Amazon Web
Services account. An identity can be either an email address or a domain. This operation
returns identities that are verified as well as those that aren't. This operation returns
identities that are associated with Amazon SES and Amazon Pinpoint.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: A token returned from a previous call to ListEmailIdentities to indicate
  the position in the list of identities.
- `"PageSize"`: The number of results to show in a single call to ListEmailIdentities. If
  the number of results is larger than the number you specified in this parameter, then the
  response includes a NextToken element, which you can use to obtain additional results. The
  value you specify has to be at least 0, and can be no more than 1000.
"""
function list_email_identities(; aws_config::AbstractAWSConfig=current_aws_config())
    return sesv2(
        "GET",
        "/v2/email/identities";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_email_identities(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "GET",
        "/v2/email/identities",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_email_templates()
    list_email_templates(params::Dict{String,<:Any})

Lists the email templates present in your Amazon SES account in the current Amazon Web
Services Region. You can execute this operation no more than once per second.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: A token returned from a previous call to ListEmailTemplates to indicate
  the position in the list of email templates.
- `"PageSize"`: The number of results to show in a single call to ListEmailTemplates. If
  the number of results is larger than the number you specified in this parameter, then the
  response includes a NextToken element, which you can use to obtain additional results. The
  value you specify has to be at least 1, and can be no more than 100.
"""
function list_email_templates(; aws_config::AbstractAWSConfig=current_aws_config())
    return sesv2(
        "GET", "/v2/email/templates"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_email_templates(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "GET",
        "/v2/email/templates",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_export_jobs()
    list_export_jobs(params::Dict{String,<:Any})

Lists all of the export jobs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ExportSourceType"`: A value used to list export jobs that have a certain
  ExportSourceType.
- `"JobStatus"`: A value used to list export jobs that have a certain JobStatus.
- `"NextToken"`: The pagination token returned from a previous call to ListExportJobs to
  indicate the position in the list of export jobs.
- `"PageSize"`: Maximum number of export jobs to return at once. Use this parameter to
  paginate results. If additional export jobs exist beyond the specified limit, the NextToken
  element is sent in the response. Use the NextToken value in subsequent calls to
  ListExportJobs to retrieve additional export jobs.
"""
function list_export_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return sesv2(
        "POST",
        "/v2/email/list-export-jobs";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_export_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "POST",
        "/v2/email/list-export-jobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_import_jobs()
    list_import_jobs(params::Dict{String,<:Any})

Lists all of the import jobs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ImportDestinationType"`: The destination of the import job, which can be used to list
  import jobs that have a certain ImportDestinationType.
- `"NextToken"`: A string token indicating that there might be additional import jobs
  available to be listed. Copy this token to a subsequent call to ListImportJobs with the
  same parameters to retrieve the next page of import jobs.
- `"PageSize"`: Maximum number of import jobs to return at once. Use this parameter to
  paginate results. If additional import jobs exist beyond the specified limit, the NextToken
  element is sent in the response. Use the NextToken value in subsequent requests to retrieve
  additional addresses.
"""
function list_import_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return sesv2(
        "POST",
        "/v2/email/import-jobs/list";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_import_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "POST",
        "/v2/email/import-jobs/list",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_recommendations()
    list_recommendations(params::Dict{String,<:Any})

Lists the recommendations present in your Amazon SES account in the current Amazon Web
Services Region. You can execute this operation no more than once per second.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filter"`: Filters applied when retrieving recommendations. Can eiter be an individual
  filter, or combinations of STATUS and IMPACT or STATUS and TYPE
- `"NextToken"`: A token returned from a previous call to ListRecommendations to indicate
  the position in the list of recommendations.
- `"PageSize"`: The number of results to show in a single call to ListRecommendations. If
  the number of results is larger than the number you specified in this parameter, then the
  response includes a NextToken element, which you can use to obtain additional results. The
  value you specify has to be at least 1, and can be no more than 100.
"""
function list_recommendations(; aws_config::AbstractAWSConfig=current_aws_config())
    return sesv2(
        "POST",
        "/v2/email/vdm/recommendations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_recommendations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "POST",
        "/v2/email/vdm/recommendations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_suppressed_destinations()
    list_suppressed_destinations(params::Dict{String,<:Any})

Retrieves a list of email addresses that are on the suppression list for your account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EndDate"`: Used to filter the list of suppressed email destinations so that it only
  includes addresses that were added to the list before a specific date.
- `"NextToken"`: A token returned from a previous call to ListSuppressedDestinations to
  indicate the position in the list of suppressed email addresses.
- `"PageSize"`: The number of results to show in a single call to
  ListSuppressedDestinations. If the number of results is larger than the number you
  specified in this parameter, then the response includes a NextToken element, which you can
  use to obtain additional results.
- `"Reason"`: The factors that caused the email address to be added to .
- `"StartDate"`: Used to filter the list of suppressed email destinations so that it only
  includes addresses that were added to the list after a specific date.
"""
function list_suppressed_destinations(; aws_config::AbstractAWSConfig=current_aws_config())
    return sesv2(
        "GET",
        "/v2/email/suppression/addresses";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_suppressed_destinations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "GET",
        "/v2/email/suppression/addresses",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Retrieve a list of the tags (keys and values) that are associated with a specified
resource. A tag is a label that you optionally define and associate with a resource. Each
tag consists of a required tag key and an optional associated tag value. A tag key is a
general label that acts as a category for more specific tag values. A tag value acts as a
descriptor within a tag key.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource that you want to retrieve
  tag information for.

"""
function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "GET",
        "/v2/email/tags",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "GET",
        "/v2/email/tags",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_account_dedicated_ip_warmup_attributes()
    put_account_dedicated_ip_warmup_attributes(params::Dict{String,<:Any})

Enable or disable the automatic warm-up feature for dedicated IP addresses.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AutoWarmupEnabled"`: Enables or disables the automatic warm-up feature for dedicated IP
  addresses that are associated with your Amazon SES account in the current Amazon Web
  Services Region. Set to true to enable the automatic warm-up feature, or set to false to
  disable it.
"""
function put_account_dedicated_ip_warmup_attributes(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "PUT",
        "/v2/email/account/dedicated-ips/warmup";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_account_dedicated_ip_warmup_attributes(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "PUT",
        "/v2/email/account/dedicated-ips/warmup",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_account_details(mail_type, use_case_description, website_url)
    put_account_details(mail_type, use_case_description, website_url, params::Dict{String,<:Any})

Update your Amazon SES account details.

# Arguments
- `mail_type`: The type of email your account will send.
- `use_case_description`: A description of the types of email that you plan to send.
- `website_url`: The URL of your website. This information helps us better understand the
  type of content that you plan to send.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AdditionalContactEmailAddresses"`: Additional email addresses that you would like to be
  notified regarding Amazon SES matters.
- `"ContactLanguage"`: The language you would prefer to be contacted with.
- `"ProductionAccessEnabled"`: Indicates whether or not your account should have production
  access in the current Amazon Web Services Region. If the value is false, then your account
  is in the sandbox. When your account is in the sandbox, you can only send email to verified
  identities.  If the value is true, then your account has production access. When your
  account has production access, you can send email to any address. The sending quota and
  maximum sending rate for your account vary based on your specific use case.
"""
function put_account_details(
    MailType,
    UseCaseDescription,
    WebsiteURL;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "POST",
        "/v2/email/account/details",
        Dict{String,Any}(
            "MailType" => MailType,
            "UseCaseDescription" => UseCaseDescription,
            "WebsiteURL" => WebsiteURL,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_account_details(
    MailType,
    UseCaseDescription,
    WebsiteURL,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "POST",
        "/v2/email/account/details",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "MailType" => MailType,
                    "UseCaseDescription" => UseCaseDescription,
                    "WebsiteURL" => WebsiteURL,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_account_sending_attributes()
    put_account_sending_attributes(params::Dict{String,<:Any})

Enable or disable the ability of your account to send email.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"SendingEnabled"`: Enables or disables your account's ability to send email. Set to true
  to enable email sending, or set to false to disable email sending.  If Amazon Web Services
  paused your account's ability to send email, you can't use this operation to resume your
  account's ability to send email.
"""
function put_account_sending_attributes(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "PUT",
        "/v2/email/account/sending";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_account_sending_attributes(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "PUT",
        "/v2/email/account/sending",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_account_suppression_attributes()
    put_account_suppression_attributes(params::Dict{String,<:Any})

Change the settings for the account-level suppression list.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"SuppressedReasons"`: A list that contains the reasons that email addresses will be
  automatically added to the suppression list for your account. This list can contain any or
  all of the following:    COMPLAINT – Amazon SES adds an email address to the suppression
  list for your account when a message sent to that address results in a complaint.    BOUNCE
  – Amazon SES adds an email address to the suppression list for your account when a
  message sent to that address results in a hard bounce.
"""
function put_account_suppression_attributes(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "PUT",
        "/v2/email/account/suppression";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_account_suppression_attributes(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "PUT",
        "/v2/email/account/suppression",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_account_vdm_attributes(vdm_attributes)
    put_account_vdm_attributes(vdm_attributes, params::Dict{String,<:Any})

Update your Amazon SES account VDM attributes. You can execute this operation no more than
once per second.

# Arguments
- `vdm_attributes`: The VDM attributes that you wish to apply to your Amazon SES account.

"""
function put_account_vdm_attributes(
    VdmAttributes; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "PUT",
        "/v2/email/account/vdm",
        Dict{String,Any}("VdmAttributes" => VdmAttributes);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_account_vdm_attributes(
    VdmAttributes,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "PUT",
        "/v2/email/account/vdm",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("VdmAttributes" => VdmAttributes), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_configuration_set_delivery_options(configuration_set_name)
    put_configuration_set_delivery_options(configuration_set_name, params::Dict{String,<:Any})

Associate a configuration set with a dedicated IP pool. You can use dedicated IP pools to
create groups of dedicated IP addresses for sending specific types of email.

# Arguments
- `configuration_set_name`: The name of the configuration set to associate with a dedicated
  IP pool.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"SendingPoolName"`: The name of the dedicated IP pool to associate with the
  configuration set.
- `"TlsPolicy"`: Specifies whether messages that use the configuration set are required to
  use Transport Layer Security (TLS). If the value is Require, messages are only delivered if
  a TLS connection can be established. If the value is Optional, messages can be delivered in
  plain text if a TLS connection can't be established.
"""
function put_configuration_set_delivery_options(
    ConfigurationSetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "PUT",
        "/v2/email/configuration-sets/$(ConfigurationSetName)/delivery-options";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_configuration_set_delivery_options(
    ConfigurationSetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "PUT",
        "/v2/email/configuration-sets/$(ConfigurationSetName)/delivery-options",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_configuration_set_reputation_options(configuration_set_name)
    put_configuration_set_reputation_options(configuration_set_name, params::Dict{String,<:Any})

Enable or disable collection of reputation metrics for emails that you send using a
particular configuration set in a specific Amazon Web Services Region.

# Arguments
- `configuration_set_name`: The name of the configuration set.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ReputationMetricsEnabled"`: If true, tracking of reputation metrics is enabled for the
  configuration set. If false, tracking of reputation metrics is disabled for the
  configuration set.
"""
function put_configuration_set_reputation_options(
    ConfigurationSetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "PUT",
        "/v2/email/configuration-sets/$(ConfigurationSetName)/reputation-options";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_configuration_set_reputation_options(
    ConfigurationSetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "PUT",
        "/v2/email/configuration-sets/$(ConfigurationSetName)/reputation-options",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_configuration_set_sending_options(configuration_set_name)
    put_configuration_set_sending_options(configuration_set_name, params::Dict{String,<:Any})

Enable or disable email sending for messages that use a particular configuration set in a
specific Amazon Web Services Region.

# Arguments
- `configuration_set_name`: The name of the configuration set to enable or disable email
  sending for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"SendingEnabled"`: If true, email sending is enabled for the configuration set. If
  false, email sending is disabled for the configuration set.
"""
function put_configuration_set_sending_options(
    ConfigurationSetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "PUT",
        "/v2/email/configuration-sets/$(ConfigurationSetName)/sending";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_configuration_set_sending_options(
    ConfigurationSetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "PUT",
        "/v2/email/configuration-sets/$(ConfigurationSetName)/sending",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_configuration_set_suppression_options(configuration_set_name)
    put_configuration_set_suppression_options(configuration_set_name, params::Dict{String,<:Any})

Specify the account suppression list preferences for a configuration set.

# Arguments
- `configuration_set_name`: The name of the configuration set to change the suppression
  list preferences for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"SuppressedReasons"`: A list that contains the reasons that email addresses are
  automatically added to the suppression list for your account. This list can contain any or
  all of the following:    COMPLAINT – Amazon SES adds an email address to the suppression
  list for your account when a message sent to that address results in a complaint.    BOUNCE
  – Amazon SES adds an email address to the suppression list for your account when a
  message sent to that address results in a hard bounce.
"""
function put_configuration_set_suppression_options(
    ConfigurationSetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "PUT",
        "/v2/email/configuration-sets/$(ConfigurationSetName)/suppression-options";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_configuration_set_suppression_options(
    ConfigurationSetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "PUT",
        "/v2/email/configuration-sets/$(ConfigurationSetName)/suppression-options",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_configuration_set_tracking_options(configuration_set_name)
    put_configuration_set_tracking_options(configuration_set_name, params::Dict{String,<:Any})

Specify a custom domain to use for open and click tracking elements in email that you send.

# Arguments
- `configuration_set_name`: The name of the configuration set.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CustomRedirectDomain"`: The domain to use to track open and click events.
"""
function put_configuration_set_tracking_options(
    ConfigurationSetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "PUT",
        "/v2/email/configuration-sets/$(ConfigurationSetName)/tracking-options";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_configuration_set_tracking_options(
    ConfigurationSetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "PUT",
        "/v2/email/configuration-sets/$(ConfigurationSetName)/tracking-options",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_configuration_set_vdm_options(configuration_set_name)
    put_configuration_set_vdm_options(configuration_set_name, params::Dict{String,<:Any})

Specify VDM preferences for email that you send using the configuration set. You can
execute this operation no more than once per second.

# Arguments
- `configuration_set_name`: The name of the configuration set.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"VdmOptions"`: The VDM options to apply to the configuration set.
"""
function put_configuration_set_vdm_options(
    ConfigurationSetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "PUT",
        "/v2/email/configuration-sets/$(ConfigurationSetName)/vdm-options";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_configuration_set_vdm_options(
    ConfigurationSetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "PUT",
        "/v2/email/configuration-sets/$(ConfigurationSetName)/vdm-options",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_dedicated_ip_in_pool(destination_pool_name, ip)
    put_dedicated_ip_in_pool(destination_pool_name, ip, params::Dict{String,<:Any})

Move a dedicated IP address to an existing dedicated IP pool.  The dedicated IP address
that you specify must already exist, and must be associated with your Amazon Web Services
account.  The dedicated IP pool you specify must already exist. You can create a new pool
by using the CreateDedicatedIpPool operation.

# Arguments
- `destination_pool_name`: The name of the IP pool that you want to add the dedicated IP
  address to. You have to specify an IP pool that already exists.
- `ip`: The IP address that you want to move to the dedicated IP pool. The value you
  specify has to be a dedicated IP address that's associated with your Amazon Web Services
  account.

"""
function put_dedicated_ip_in_pool(
    DestinationPoolName, IP; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "PUT",
        "/v2/email/dedicated-ips/$(IP)/pool",
        Dict{String,Any}("DestinationPoolName" => DestinationPoolName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_dedicated_ip_in_pool(
    DestinationPoolName,
    IP,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "PUT",
        "/v2/email/dedicated-ips/$(IP)/pool",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DestinationPoolName" => DestinationPoolName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_dedicated_ip_pool_scaling_attributes(pool_name, scaling_mode)
    put_dedicated_ip_pool_scaling_attributes(pool_name, scaling_mode, params::Dict{String,<:Any})

Used to convert a dedicated IP pool to a different scaling mode.   MANAGED pools cannot be
converted to STANDARD scaling mode.

# Arguments
- `pool_name`: The name of the dedicated IP pool.
- `scaling_mode`: The scaling mode to apply to the dedicated IP pool.  Changing the scaling
  mode from MANAGED to STANDARD is not supported.

"""
function put_dedicated_ip_pool_scaling_attributes(
    PoolName, ScalingMode; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "PUT",
        "/v2/email/dedicated-ip-pools/$(PoolName)/scaling",
        Dict{String,Any}("ScalingMode" => ScalingMode);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_dedicated_ip_pool_scaling_attributes(
    PoolName,
    ScalingMode,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "PUT",
        "/v2/email/dedicated-ip-pools/$(PoolName)/scaling",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ScalingMode" => ScalingMode), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_dedicated_ip_warmup_attributes(ip, warmup_percentage)
    put_dedicated_ip_warmup_attributes(ip, warmup_percentage, params::Dict{String,<:Any})



# Arguments
- `ip`: The dedicated IP address that you want to update the warm-up attributes for.
- `warmup_percentage`: The warm-up percentage that you want to associate with the dedicated
  IP address.

"""
function put_dedicated_ip_warmup_attributes(
    IP, WarmupPercentage; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "PUT",
        "/v2/email/dedicated-ips/$(IP)/warmup",
        Dict{String,Any}("WarmupPercentage" => WarmupPercentage);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_dedicated_ip_warmup_attributes(
    IP,
    WarmupPercentage,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "PUT",
        "/v2/email/dedicated-ips/$(IP)/warmup",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("WarmupPercentage" => WarmupPercentage), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_deliverability_dashboard_option(dashboard_enabled)
    put_deliverability_dashboard_option(dashboard_enabled, params::Dict{String,<:Any})

Enable or disable the Deliverability dashboard. When you enable the Deliverability
dashboard, you gain access to reputation, deliverability, and other metrics for the domains
that you use to send email. You also gain the ability to perform predictive inbox placement
tests. When you use the Deliverability dashboard, you pay a monthly subscription charge, in
addition to any other fees that you accrue by using Amazon SES and other Amazon Web
Services services. For more information about the features and cost of a Deliverability
dashboard subscription, see Amazon SES Pricing.

# Arguments
- `dashboard_enabled`: Specifies whether to enable the Deliverability dashboard. To enable
  the dashboard, set this value to true.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"SubscribedDomains"`: An array of objects, one for each verified domain that you use to
  send email and enabled the Deliverability dashboard for.
"""
function put_deliverability_dashboard_option(
    DashboardEnabled; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "PUT",
        "/v2/email/deliverability-dashboard",
        Dict{String,Any}("DashboardEnabled" => DashboardEnabled);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_deliverability_dashboard_option(
    DashboardEnabled,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "PUT",
        "/v2/email/deliverability-dashboard",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("DashboardEnabled" => DashboardEnabled), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_email_identity_configuration_set_attributes(email_identity)
    put_email_identity_configuration_set_attributes(email_identity, params::Dict{String,<:Any})

Used to associate a configuration set with an email identity.

# Arguments
- `email_identity`: The email address or domain to associate with a configuration set.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConfigurationSetName"`: The configuration set to associate with an email identity.
"""
function put_email_identity_configuration_set_attributes(
    EmailIdentity; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "PUT",
        "/v2/email/identities/$(EmailIdentity)/configuration-set";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_email_identity_configuration_set_attributes(
    EmailIdentity,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "PUT",
        "/v2/email/identities/$(EmailIdentity)/configuration-set",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_email_identity_dkim_attributes(email_identity)
    put_email_identity_dkim_attributes(email_identity, params::Dict{String,<:Any})

Used to enable or disable DKIM authentication for an email identity.

# Arguments
- `email_identity`: The email identity.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"SigningEnabled"`: Sets the DKIM signing configuration for the identity. When you set
  this value true, then the messages that are sent from the identity are signed using DKIM.
  If you set this value to false, your messages are sent without DKIM signing.
"""
function put_email_identity_dkim_attributes(
    EmailIdentity; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "PUT",
        "/v2/email/identities/$(EmailIdentity)/dkim";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_email_identity_dkim_attributes(
    EmailIdentity,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "PUT",
        "/v2/email/identities/$(EmailIdentity)/dkim",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_email_identity_dkim_signing_attributes(email_identity, signing_attributes_origin)
    put_email_identity_dkim_signing_attributes(email_identity, signing_attributes_origin, params::Dict{String,<:Any})

Used to configure or change the DKIM authentication settings for an email domain identity.
You can use this operation to do any of the following:   Update the signing attributes for
an identity that uses Bring Your Own DKIM (BYODKIM).   Update the key length that should be
used for Easy DKIM.   Change from using no DKIM authentication to using Easy DKIM.   Change
from using no DKIM authentication to using BYODKIM.   Change from using Easy DKIM to using
BYODKIM.   Change from using BYODKIM to using Easy DKIM.

# Arguments
- `email_identity`: The email identity.
- `signing_attributes_origin`: The method to use to configure DKIM for the identity. There
  are the following possible values:    AWS_SES – Configure DKIM for the identity by using
  Easy DKIM.    EXTERNAL – Configure DKIM for the identity by using Bring Your Own DKIM
  (BYODKIM).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"SigningAttributes"`: An object that contains information about the private key and
  selector that you want to use to configure DKIM for the identity for Bring Your Own DKIM
  (BYODKIM) for the identity, or, configures the key length to be used for Easy DKIM.
"""
function put_email_identity_dkim_signing_attributes(
    EmailIdentity,
    SigningAttributesOrigin;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "PUT",
        "/v1/email/identities/$(EmailIdentity)/dkim/signing",
        Dict{String,Any}("SigningAttributesOrigin" => SigningAttributesOrigin);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_email_identity_dkim_signing_attributes(
    EmailIdentity,
    SigningAttributesOrigin,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "PUT",
        "/v1/email/identities/$(EmailIdentity)/dkim/signing",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("SigningAttributesOrigin" => SigningAttributesOrigin),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_email_identity_feedback_attributes(email_identity)
    put_email_identity_feedback_attributes(email_identity, params::Dict{String,<:Any})

Used to enable or disable feedback forwarding for an identity. This setting determines what
happens when an identity is used to send an email that results in a bounce or complaint
event. If the value is true, you receive email notifications when bounce or complaint
events occur. These notifications are sent to the address that you specified in the
Return-Path header of the original email. You're required to have a method of tracking
bounces and complaints. If you haven't set up another mechanism for receiving bounce or
complaint notifications (for example, by setting up an event destination), you receive an
email notification when these events occur (even if this setting is disabled).

# Arguments
- `email_identity`: The email identity.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EmailForwardingEnabled"`: Sets the feedback forwarding configuration for the identity.
  If the value is true, you receive email notifications when bounce or complaint events
  occur. These notifications are sent to the address that you specified in the Return-Path
  header of the original email. You're required to have a method of tracking bounces and
  complaints. If you haven't set up another mechanism for receiving bounce or complaint
  notifications (for example, by setting up an event destination), you receive an email
  notification when these events occur (even if this setting is disabled).
"""
function put_email_identity_feedback_attributes(
    EmailIdentity; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "PUT",
        "/v2/email/identities/$(EmailIdentity)/feedback";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_email_identity_feedback_attributes(
    EmailIdentity,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "PUT",
        "/v2/email/identities/$(EmailIdentity)/feedback",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_email_identity_mail_from_attributes(email_identity)
    put_email_identity_mail_from_attributes(email_identity, params::Dict{String,<:Any})

Used to enable or disable the custom Mail-From domain configuration for an email identity.

# Arguments
- `email_identity`: The verified email identity.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"BehaviorOnMxFailure"`: The action to take if the required MX record isn't found when
  you send an email. When you set this value to UseDefaultValue, the mail is sent using
  amazonses.com as the MAIL FROM domain. When you set this value to RejectMessage, the Amazon
  SES API v2 returns a MailFromDomainNotVerified error, and doesn't attempt to deliver the
  email. These behaviors are taken when the custom MAIL FROM domain configuration is in the
  Pending, Failed, and TemporaryFailure states.
- `"MailFromDomain"`:  The custom MAIL FROM domain that you want the verified identity to
  use. The MAIL FROM domain must meet the following criteria:   It has to be a subdomain of
  the verified identity.   It can't be used to receive email.   It can't be used in a
  \"From\" address if the MAIL FROM domain is a destination for feedback forwarding emails.
"""
function put_email_identity_mail_from_attributes(
    EmailIdentity; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "PUT",
        "/v2/email/identities/$(EmailIdentity)/mail-from";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_email_identity_mail_from_attributes(
    EmailIdentity,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "PUT",
        "/v2/email/identities/$(EmailIdentity)/mail-from",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_suppressed_destination(email_address, reason)
    put_suppressed_destination(email_address, reason, params::Dict{String,<:Any})

Adds an email address to the suppression list for your account.

# Arguments
- `email_address`: The email address that should be added to the suppression list for your
  account.
- `reason`: The factors that should cause the email address to be added to the suppression
  list for your account.

"""
function put_suppressed_destination(
    EmailAddress, Reason; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "PUT",
        "/v2/email/suppression/addresses",
        Dict{String,Any}("EmailAddress" => EmailAddress, "Reason" => Reason);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_suppressed_destination(
    EmailAddress,
    Reason,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "PUT",
        "/v2/email/suppression/addresses",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("EmailAddress" => EmailAddress, "Reason" => Reason),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    send_bulk_email(bulk_email_entries, default_content)
    send_bulk_email(bulk_email_entries, default_content, params::Dict{String,<:Any})

Composes an email message to multiple destinations.

# Arguments
- `bulk_email_entries`: The list of bulk email entry objects.
- `default_content`: An object that contains the body of the message. You can specify a
  template message.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConfigurationSetName"`: The name of the configuration set to use when sending the email.
- `"DefaultEmailTags"`: A list of tags, in the form of name/value pairs, to apply to an
  email that you send using the SendEmail operation. Tags correspond to characteristics of
  the email that you define, so that you can publish email sending events.
- `"FeedbackForwardingEmailAddress"`: The address that you want bounce and complaint
  notifications to be sent to.
- `"FeedbackForwardingEmailAddressIdentityArn"`: This parameter is used only for sending
  authorization. It is the ARN of the identity that is associated with the sending
  authorization policy that permits you to use the email address specified in the
  FeedbackForwardingEmailAddress parameter. For example, if the owner of example.com (which
  has ARN arn:aws:ses:us-east-1:123456789012:identity/example.com) attaches a policy to it
  that authorizes you to use feedback@example.com, then you would specify the
  FeedbackForwardingEmailAddressIdentityArn to be
  arn:aws:ses:us-east-1:123456789012:identity/example.com, and the
  FeedbackForwardingEmailAddress to be feedback@example.com. For more information about
  sending authorization, see the Amazon SES Developer Guide.
- `"FromEmailAddress"`: The email address to use as the \"From\" address for the email. The
  address that you specify has to be verified.
- `"FromEmailAddressIdentityArn"`: This parameter is used only for sending authorization.
  It is the ARN of the identity that is associated with the sending authorization policy that
  permits you to use the email address specified in the FromEmailAddress parameter. For
  example, if the owner of example.com (which has ARN
  arn:aws:ses:us-east-1:123456789012:identity/example.com) attaches a policy to it that
  authorizes you to use sender@example.com, then you would specify the
  FromEmailAddressIdentityArn to be arn:aws:ses:us-east-1:123456789012:identity/example.com,
  and the FromEmailAddress to be sender@example.com. For more information about sending
  authorization, see the Amazon SES Developer Guide.
- `"ReplyToAddresses"`: The \"Reply-to\" email addresses for the message. When the
  recipient replies to the message, each Reply-to address receives the reply.
"""
function send_bulk_email(
    BulkEmailEntries, DefaultContent; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "POST",
        "/v2/email/outbound-bulk-emails",
        Dict{String,Any}(
            "BulkEmailEntries" => BulkEmailEntries, "DefaultContent" => DefaultContent
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function send_bulk_email(
    BulkEmailEntries,
    DefaultContent,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "POST",
        "/v2/email/outbound-bulk-emails",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "BulkEmailEntries" => BulkEmailEntries,
                    "DefaultContent" => DefaultContent,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    send_custom_verification_email(email_address, template_name)
    send_custom_verification_email(email_address, template_name, params::Dict{String,<:Any})

Adds an email address to the list of identities for your Amazon SES account in the current
Amazon Web Services Region and attempts to verify it. As a result of executing this
operation, a customized verification email is sent to the specified address. To use this
operation, you must first create a custom verification email template. For more information
about creating and using custom verification email templates, see Using custom verification
email templates in the Amazon SES Developer Guide. You can execute this operation no more
than once per second.

# Arguments
- `email_address`: The email address to verify.
- `template_name`: The name of the custom verification email template to use when sending
  the verification email.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConfigurationSetName"`: Name of a configuration set to use when sending the
  verification email.
"""
function send_custom_verification_email(
    EmailAddress, TemplateName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "POST",
        "/v2/email/outbound-custom-verification-emails",
        Dict{String,Any}("EmailAddress" => EmailAddress, "TemplateName" => TemplateName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function send_custom_verification_email(
    EmailAddress,
    TemplateName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "POST",
        "/v2/email/outbound-custom-verification-emails",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EmailAddress" => EmailAddress, "TemplateName" => TemplateName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    send_email(content)
    send_email(content, params::Dict{String,<:Any})

Sends an email message. You can use the Amazon SES API v2 to send the following types of
messages:    Simple – A standard email message. When you create this type of message, you
specify the sender, the recipient, and the message body, and Amazon SES assembles the
message for you.    Raw – A raw, MIME-formatted email message. When you send this type of
email, you have to specify all of the message headers, as well as the message body. You can
use this message type to send messages that contain attachments. The message that you
specify has to be a valid MIME message.    Templated – A message that contains
personalization tags. When you send this type of email, Amazon SES API v2 automatically
replaces the tags with values that you specify.

# Arguments
- `content`: An object that contains the body of the message. You can send either a Simple
  message, Raw message, or a Templated message.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConfigurationSetName"`: The name of the configuration set to use when sending the email.
- `"Destination"`: An object that contains the recipients of the email message.
- `"EmailTags"`: A list of tags, in the form of name/value pairs, to apply to an email that
  you send using the SendEmail operation. Tags correspond to characteristics of the email
  that you define, so that you can publish email sending events.
- `"FeedbackForwardingEmailAddress"`: The address that you want bounce and complaint
  notifications to be sent to.
- `"FeedbackForwardingEmailAddressIdentityArn"`: This parameter is used only for sending
  authorization. It is the ARN of the identity that is associated with the sending
  authorization policy that permits you to use the email address specified in the
  FeedbackForwardingEmailAddress parameter. For example, if the owner of example.com (which
  has ARN arn:aws:ses:us-east-1:123456789012:identity/example.com) attaches a policy to it
  that authorizes you to use feedback@example.com, then you would specify the
  FeedbackForwardingEmailAddressIdentityArn to be
  arn:aws:ses:us-east-1:123456789012:identity/example.com, and the
  FeedbackForwardingEmailAddress to be feedback@example.com. For more information about
  sending authorization, see the Amazon SES Developer Guide.
- `"FromEmailAddress"`: The email address to use as the \"From\" address for the email. The
  address that you specify has to be verified.
- `"FromEmailAddressIdentityArn"`: This parameter is used only for sending authorization.
  It is the ARN of the identity that is associated with the sending authorization policy that
  permits you to use the email address specified in the FromEmailAddress parameter. For
  example, if the owner of example.com (which has ARN
  arn:aws:ses:us-east-1:123456789012:identity/example.com) attaches a policy to it that
  authorizes you to use sender@example.com, then you would specify the
  FromEmailAddressIdentityArn to be arn:aws:ses:us-east-1:123456789012:identity/example.com,
  and the FromEmailAddress to be sender@example.com. For more information about sending
  authorization, see the Amazon SES Developer Guide. For Raw emails, the
  FromEmailAddressIdentityArn value overrides the X-SES-SOURCE-ARN and X-SES-FROM-ARN headers
  specified in raw email message content.
- `"ListManagementOptions"`: An object used to specify a list or topic to which an email
  belongs, which will be used when a contact chooses to unsubscribe.
- `"ReplyToAddresses"`: The \"Reply-to\" email addresses for the message. When the
  recipient replies to the message, each Reply-to address receives the reply.
"""
function send_email(Content; aws_config::AbstractAWSConfig=current_aws_config())
    return sesv2(
        "POST",
        "/v2/email/outbound-emails",
        Dict{String,Any}("Content" => Content);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function send_email(
    Content,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "POST",
        "/v2/email/outbound-emails",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Content" => Content), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Add one or more tags (keys and values) to a specified resource. A tag is a label that you
optionally define and associate with a resource. Tags can help you categorize and manage
resources in different ways, such as by purpose, owner, environment, or other criteria. A
resource can have as many as 50 tags. Each tag consists of a required tag key and an
associated tag value, both of which you define. A tag key is a general label that acts as
a category for more specific tag values. A tag value acts as a descriptor within a tag key.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource that you want to add one
  or more tags to.
- `tags`: A list of the tags that you want to add to the resource. A tag consists of a
  required tag key (Key) and an associated tag value (Value). The maximum length of a tag key
  is 128 characters. The maximum length of a tag value is 256 characters.

"""
function tag_resource(ResourceArn, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return sesv2(
        "POST",
        "/v2/email/tags",
        Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceArn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "POST",
        "/v2/email/tags",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    test_render_email_template(template_data, template_name)
    test_render_email_template(template_data, template_name, params::Dict{String,<:Any})

Creates a preview of the MIME content of an email when provided with a template and a set
of replacement data. You can execute this operation no more than once per second.

# Arguments
- `template_data`: A list of replacement values to apply to the template. This parameter is
  a JSON object, typically consisting of key-value pairs in which the keys correspond to
  replacement tags in the email template.
- `template_name`: The name of the template.

"""
function test_render_email_template(
    TemplateData, TemplateName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "POST",
        "/v2/email/templates/$(TemplateName)/render",
        Dict{String,Any}("TemplateData" => TemplateData);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function test_render_email_template(
    TemplateData,
    TemplateName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "POST",
        "/v2/email/templates/$(TemplateName)/render",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TemplateData" => TemplateData), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Remove one or more tags (keys and values) from a specified resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource that you want to remove
  one or more tags from.
- `tag_keys`: The tags (tag keys) that you want to remove from the resource. When you
  specify a tag key, the action removes both that key and its associated tag value. To remove
  more than one tag from the resource, append the TagKeys parameter and argument for each
  additional tag to remove, separated by an ampersand. For example:
  /v2/email/tags?ResourceArn=ResourceArn&amp;TagKeys=Key1&amp;TagKeys=Key2

"""
function untag_resource(
    ResourceArn, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "DELETE",
        "/v2/email/tags",
        Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceArn,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "DELETE",
        "/v2/email/tags",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_configuration_set_event_destination(configuration_set_name, event_destination, event_destination_name)
    update_configuration_set_event_destination(configuration_set_name, event_destination, event_destination_name, params::Dict{String,<:Any})

Update the configuration of an event destination for a configuration set.  Events include
message sends, deliveries, opens, clicks, bounces, and complaints. Event destinations are
places that you can send information about these events to. For example, you can send event
data to Amazon EventBridge and associate a rule to send the event to the specified target.

# Arguments
- `configuration_set_name`: The name of the configuration set that contains the event
  destination to modify.
- `event_destination`: An object that defines the event destination.
- `event_destination_name`: The name of the event destination.

"""
function update_configuration_set_event_destination(
    ConfigurationSetName,
    EventDestination,
    EventDestinationName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "PUT",
        "/v2/email/configuration-sets/$(ConfigurationSetName)/event-destinations/$(EventDestinationName)",
        Dict{String,Any}("EventDestination" => EventDestination);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_configuration_set_event_destination(
    ConfigurationSetName,
    EventDestination,
    EventDestinationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "PUT",
        "/v2/email/configuration-sets/$(ConfigurationSetName)/event-destinations/$(EventDestinationName)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("EventDestination" => EventDestination), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_contact(contact_list_name, email_address)
    update_contact(contact_list_name, email_address, params::Dict{String,<:Any})

Updates a contact's preferences for a list.  You must specify all existing topic
preferences in the TopicPreferences object, not just the ones that need updating;
otherwise, all your existing preferences will be removed.

# Arguments
- `contact_list_name`: The name of the contact list.
- `email_address`: The contact's email address.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AttributesData"`: The attribute data attached to a contact.
- `"TopicPreferences"`: The contact's preference for being opted-in to or opted-out of a
  topic.
- `"UnsubscribeAll"`: A boolean value status noting if the contact is unsubscribed from all
  contact list topics.
"""
function update_contact(
    ContactListName, EmailAddress; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "PUT",
        "/v2/email/contact-lists/$(ContactListName)/contacts/$(EmailAddress)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_contact(
    ContactListName,
    EmailAddress,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "PUT",
        "/v2/email/contact-lists/$(ContactListName)/contacts/$(EmailAddress)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_contact_list(contact_list_name)
    update_contact_list(contact_list_name, params::Dict{String,<:Any})

Updates contact list metadata. This operation does a complete replacement.

# Arguments
- `contact_list_name`: The name of the contact list.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description of what the contact list is about.
- `"Topics"`: An interest group, theme, or label within a list. A contact list can have
  multiple topics.
"""
function update_contact_list(
    ContactListName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "PUT",
        "/v2/email/contact-lists/$(ContactListName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_contact_list(
    ContactListName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "PUT",
        "/v2/email/contact-lists/$(ContactListName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_custom_verification_email_template(failure_redirection_url, from_email_address, success_redirection_url, template_content, template_name, template_subject)
    update_custom_verification_email_template(failure_redirection_url, from_email_address, success_redirection_url, template_content, template_name, template_subject, params::Dict{String,<:Any})

Updates an existing custom verification email template. For more information about custom
verification email templates, see Using custom verification email templates in the Amazon
SES Developer Guide. You can execute this operation no more than once per second.

# Arguments
- `failure_redirection_url`: The URL that the recipient of the verification email is sent
  to if his or her address is not successfully verified.
- `from_email_address`: The email address that the custom verification email is sent from.
- `success_redirection_url`: The URL that the recipient of the verification email is sent
  to if his or her address is successfully verified.
- `template_content`: The content of the custom verification email. The total size of the
  email must be less than 10 MB. The message body may contain HTML, with some limitations.
  For more information, see Custom verification email frequently asked questions in the
  Amazon SES Developer Guide.
- `template_name`: The name of the custom verification email template that you want to
  update.
- `template_subject`: The subject line of the custom verification email.

"""
function update_custom_verification_email_template(
    FailureRedirectionURL,
    FromEmailAddress,
    SuccessRedirectionURL,
    TemplateContent,
    TemplateName,
    TemplateSubject;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "PUT",
        "/v2/email/custom-verification-email-templates/$(TemplateName)",
        Dict{String,Any}(
            "FailureRedirectionURL" => FailureRedirectionURL,
            "FromEmailAddress" => FromEmailAddress,
            "SuccessRedirectionURL" => SuccessRedirectionURL,
            "TemplateContent" => TemplateContent,
            "TemplateSubject" => TemplateSubject,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_custom_verification_email_template(
    FailureRedirectionURL,
    FromEmailAddress,
    SuccessRedirectionURL,
    TemplateContent,
    TemplateName,
    TemplateSubject,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "PUT",
        "/v2/email/custom-verification-email-templates/$(TemplateName)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "FailureRedirectionURL" => FailureRedirectionURL,
                    "FromEmailAddress" => FromEmailAddress,
                    "SuccessRedirectionURL" => SuccessRedirectionURL,
                    "TemplateContent" => TemplateContent,
                    "TemplateSubject" => TemplateSubject,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_email_identity_policy(email_identity, policy, policy_name)
    update_email_identity_policy(email_identity, policy, policy_name, params::Dict{String,<:Any})

Updates the specified sending authorization policy for the given identity (an email address
or a domain). This API returns successfully even if a policy with the specified name does
not exist.  This API is for the identity owner only. If you have not verified the identity,
this API will return an error.  Sending authorization is a feature that enables an identity
owner to authorize other senders to use its identities. For information about using sending
authorization, see the Amazon SES Developer Guide. You can execute this operation no more
than once per second.

# Arguments
- `email_identity`: The email identity.
- `policy`: The text of the policy in JSON format. The policy cannot exceed 4 KB.  For
  information about the syntax of sending authorization policies, see the Amazon SES
  Developer Guide.
- `policy_name`: The name of the policy. The policy name cannot exceed 64 characters and
  can only include alphanumeric characters, dashes, and underscores.

"""
function update_email_identity_policy(
    EmailIdentity, Policy, PolicyName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "PUT",
        "/v2/email/identities/$(EmailIdentity)/policies/$(PolicyName)",
        Dict{String,Any}("Policy" => Policy);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_email_identity_policy(
    EmailIdentity,
    Policy,
    PolicyName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "PUT",
        "/v2/email/identities/$(EmailIdentity)/policies/$(PolicyName)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Policy" => Policy), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_email_template(template_content, template_name)
    update_email_template(template_content, template_name, params::Dict{String,<:Any})

Updates an email template. Email templates enable you to send personalized email to one or
more destinations in a single API operation. For more information, see the Amazon SES
Developer Guide. You can execute this operation no more than once per second.

# Arguments
- `template_content`: The content of the email template, composed of a subject line, an
  HTML part, and a text-only part.
- `template_name`: The name of the template.

"""
function update_email_template(
    TemplateContent, TemplateName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sesv2(
        "PUT",
        "/v2/email/templates/$(TemplateName)",
        Dict{String,Any}("TemplateContent" => TemplateContent);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_email_template(
    TemplateContent,
    TemplateName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sesv2(
        "PUT",
        "/v2/email/templates/$(TemplateName)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("TemplateContent" => TemplateContent), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: personalize
using AWS.Compat
using AWS.UUIDs

"""
    create_batch_inference_job(job_input, job_name, job_output, role_arn, solution_version_arn)
    create_batch_inference_job(job_input, job_name, job_output, role_arn, solution_version_arn, params::Dict{String,<:Any})

Generates batch recommendations based on a list of items or users stored in Amazon S3 and
exports the recommendations to an Amazon S3 bucket. To generate batch recommendations,
specify the ARN of a solution version and an Amazon S3 URI for the input and output data.
For user personalization, popular items, and personalized ranking solutions, the batch
inference job generates a list of recommended items for each user ID in the input file. For
related items solutions, the job generates a list of recommended items for each item ID in
the input file. For more information, see Creating a batch inference job .  If you use the
Similar-Items recipe, Amazon Personalize can add descriptive themes to batch
recommendations. To generate themes, set the job's mode to THEME_GENERATION and specify the
name of the field that contains item names in the input data.  For more information about
generating themes, see Batch recommendations with themes from Content Generator .  You
can't get batch recommendations with the Trending-Now or Next-Best-Action recipes.

# Arguments
- `job_input`: The Amazon S3 path that leads to the input file to base your recommendations
  on. The input material must be in JSON format.
- `job_name`: The name of the batch inference job to create.
- `job_output`: The path to the Amazon S3 bucket where the job's output will be stored.
- `role_arn`: The ARN of the Amazon Identity and Access Management role that has
  permissions to read and write to your input and output Amazon S3 buckets respectively.
- `solution_version_arn`: The Amazon Resource Name (ARN) of the solution version that will
  be used to generate the batch inference recommendations.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"batchInferenceJobConfig"`: The configuration details of a batch inference job.
- `"batchInferenceJobMode"`: The mode of the batch inference job. To generate descriptive
  themes for groups of similar items, set the job mode to THEME_GENERATION. If you don't want
  to generate themes, use the default BATCH_INFERENCE.  When you get batch recommendations
  with themes, you will incur additional costs. For more information, see Amazon Personalize
  pricing.
- `"filterArn"`: The ARN of the filter to apply to the batch inference job. For more
  information on using filters, see Filtering batch recommendations.
- `"numResults"`: The number of recommendations to retrieve.
- `"tags"`: A list of tags to apply to the batch inference job.
- `"themeGenerationConfig"`: For theme generation jobs, specify the name of the column in
  your Items dataset that contains each item's name.
"""
function create_batch_inference_job(
    jobInput,
    jobName,
    jobOutput,
    roleArn,
    solutionVersionArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize(
        "CreateBatchInferenceJob",
        Dict{String,Any}(
            "jobInput" => jobInput,
            "jobName" => jobName,
            "jobOutput" => jobOutput,
            "roleArn" => roleArn,
            "solutionVersionArn" => solutionVersionArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_batch_inference_job(
    jobInput,
    jobName,
    jobOutput,
    roleArn,
    solutionVersionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize(
        "CreateBatchInferenceJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "jobInput" => jobInput,
                    "jobName" => jobName,
                    "jobOutput" => jobOutput,
                    "roleArn" => roleArn,
                    "solutionVersionArn" => solutionVersionArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_batch_segment_job(job_input, job_name, job_output, role_arn, solution_version_arn)
    create_batch_segment_job(job_input, job_name, job_output, role_arn, solution_version_arn, params::Dict{String,<:Any})

Creates a batch segment job. The operation can handle up to 50 million records and the
input file must be in JSON format. For more information, see Getting batch recommendations
and user segments.

# Arguments
- `job_input`: The Amazon S3 path for the input data used to generate the batch segment job.
- `job_name`: The name of the batch segment job to create.
- `job_output`: The Amazon S3 path for the bucket where the job's output will be stored.
- `role_arn`: The ARN of the Amazon Identity and Access Management role that has
  permissions to read and write to your input and output Amazon S3 buckets respectively.
- `solution_version_arn`: The Amazon Resource Name (ARN) of the solution version you want
  the batch segment job to use to generate batch segments.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filterArn"`: The ARN of the filter to apply to the batch segment job. For more
  information on using filters, see Filtering batch recommendations.
- `"numResults"`: The number of predicted users generated by the batch segment job for each
  line of input data. The maximum number of users per segment is 5 million.
- `"tags"`: A list of tags to apply to the batch segment job.
"""
function create_batch_segment_job(
    jobInput,
    jobName,
    jobOutput,
    roleArn,
    solutionVersionArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize(
        "CreateBatchSegmentJob",
        Dict{String,Any}(
            "jobInput" => jobInput,
            "jobName" => jobName,
            "jobOutput" => jobOutput,
            "roleArn" => roleArn,
            "solutionVersionArn" => solutionVersionArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_batch_segment_job(
    jobInput,
    jobName,
    jobOutput,
    roleArn,
    solutionVersionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize(
        "CreateBatchSegmentJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "jobInput" => jobInput,
                    "jobName" => jobName,
                    "jobOutput" => jobOutput,
                    "roleArn" => roleArn,
                    "solutionVersionArn" => solutionVersionArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_campaign(name, solution_version_arn)
    create_campaign(name, solution_version_arn, params::Dict{String,<:Any})

  You incur campaign costs while it is active. To avoid unnecessary costs, make sure to
delete the campaign when you are finished. For information about campaign costs, see Amazon
Personalize pricing.  Creates a campaign that deploys a solution version. When a client
calls the GetRecommendations and GetPersonalizedRanking APIs, a campaign is specified in
the request.  Minimum Provisioned TPS and Auto-Scaling    A high minProvisionedTPS will
increase your cost. We recommend starting with 1 for minProvisionedTPS (the default). Track
your usage using Amazon CloudWatch metrics, and increase the minProvisionedTPS as
necessary.   When you create an Amazon Personalize campaign, you can specify the minimum
provisioned transactions per second (minProvisionedTPS) for the campaign. This is the
baseline transaction throughput for the campaign provisioned by Amazon Personalize. It sets
the minimum billing charge for the campaign while it is active. A transaction is a single
GetRecommendations or GetPersonalizedRanking request. The default minProvisionedTPS is 1.
If your TPS increases beyond the minProvisionedTPS, Amazon Personalize auto-scales the
provisioned capacity up and down, but never below minProvisionedTPS. There's a short time
delay while the capacity is increased that might cause loss of transactions. When your
traffic reduces, capacity returns to the minProvisionedTPS.  You are charged for the the
minimum provisioned TPS or, if your requests exceed the minProvisionedTPS, the actual TPS.
The actual TPS is the total number of recommendation requests you make. We recommend
starting with a low minProvisionedTPS, track your usage using Amazon CloudWatch metrics,
and then increase the minProvisionedTPS as necessary. For more information about campaign
costs, see Amazon Personalize pricing.  Status  A campaign can be in one of the following
states:   CREATE PENDING &gt; CREATE IN_PROGRESS &gt; ACTIVE -or- CREATE FAILED   DELETE
PENDING &gt; DELETE IN_PROGRESS   To get the campaign status, call DescribeCampaign.  Wait
until the status of the campaign is ACTIVE before asking the campaign for recommendations.
 Related APIs     ListCampaigns     DescribeCampaign     UpdateCampaign     DeleteCampaign


# Arguments
- `name`: A name for the new campaign. The campaign name must be unique within your account.
- `solution_version_arn`: The Amazon Resource Name (ARN) of the trained model to deploy
  with the campaign. To specify the latest solution version of your solution, specify the ARN
  of your solution in SolutionArn/LATEST format. You must use this format if you set
  syncWithLatestSolutionVersion to True in the CampaignConfig.   To deploy a model that isn't
  the latest solution version of your solution, specify the ARN of the solution version.
  For more information about automatic campaign updates, see Enabling automatic campaign
  updates.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"campaignConfig"`: The configuration details of a campaign.
- `"minProvisionedTPS"`: Specifies the requested minimum provisioned transactions
  (recommendations) per second that Amazon Personalize will support. A high minProvisionedTPS
  will increase your bill. We recommend starting with 1 for minProvisionedTPS (the default).
  Track your usage using Amazon CloudWatch metrics, and increase the minProvisionedTPS as
  necessary.
- `"tags"`: A list of tags to apply to the campaign.
"""
function create_campaign(
    name, solutionVersionArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return personalize(
        "CreateCampaign",
        Dict{String,Any}("name" => name, "solutionVersionArn" => solutionVersionArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_campaign(
    name,
    solutionVersionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize(
        "CreateCampaign",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "name" => name, "solutionVersionArn" => solutionVersionArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_data_deletion_job(data_source, dataset_group_arn, job_name, role_arn)
    create_data_deletion_job(data_source, dataset_group_arn, job_name, role_arn, params::Dict{String,<:Any})

Creates a batch job that deletes all references to specific users from an Amazon
Personalize dataset group in batches. You specify the users to delete in a CSV file of
userIds in an Amazon S3 bucket. After a job completes, Amazon Personalize no longer trains
on the users’ data and no longer considers the users when generating user segments. For
more information about creating a data deletion job, see Deleting users.   Your input file
must be a CSV file with a single USER_ID column that lists the users IDs. For more
information about preparing the CSV file, see Preparing your data deletion file and
uploading it to Amazon S3.   To give Amazon Personalize permission to access your input CSV
file of userIds, you must specify an IAM service role that has permission to read from the
data source. This role needs GetObject and ListBucket permissions for the bucket and its
content. These permissions are the same as importing data. For information on granting
access to your Amazon S3 bucket, see Giving Amazon Personalize Access to Amazon S3
Resources.     After you create a job, it can take up to a day to delete all references to
the users from datasets and models. Until the job completes, Amazon Personalize continues
to use the data when training. And if you use a User Segmentation recipe, the users might
appear in user segments.   Status  A data deletion job can have one of the following
statuses:   PENDING &gt; IN_PROGRESS &gt; COMPLETED -or- FAILED   To get the status of the
data deletion job, call DescribeDataDeletionJob API operation and specify the Amazon
Resource Name (ARN) of the job. If the status is FAILED, the response includes a
failureReason key, which describes why the job failed.  Related APIs
ListDataDeletionJobs     DescribeDataDeletionJob

# Arguments
- `data_source`: The Amazon S3 bucket that contains the list of userIds of the users to
  delete.
- `dataset_group_arn`: The Amazon Resource Name (ARN) of the dataset group that has the
  datasets you want to delete records from.
- `job_name`: The name for the data deletion job.
- `role_arn`: The Amazon Resource Name (ARN) of the IAM role that has permissions to read
  from the Amazon S3 data source.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tags"`: A list of tags to apply to the data deletion job.
"""
function create_data_deletion_job(
    dataSource,
    datasetGroupArn,
    jobName,
    roleArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize(
        "CreateDataDeletionJob",
        Dict{String,Any}(
            "dataSource" => dataSource,
            "datasetGroupArn" => datasetGroupArn,
            "jobName" => jobName,
            "roleArn" => roleArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_data_deletion_job(
    dataSource,
    datasetGroupArn,
    jobName,
    roleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize(
        "CreateDataDeletionJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "dataSource" => dataSource,
                    "datasetGroupArn" => datasetGroupArn,
                    "jobName" => jobName,
                    "roleArn" => roleArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_dataset(dataset_group_arn, dataset_type, name, schema_arn)
    create_dataset(dataset_group_arn, dataset_type, name, schema_arn, params::Dict{String,<:Any})

Creates an empty dataset and adds it to the specified dataset group. Use
CreateDatasetImportJob to import your training data to a dataset. There are 5 types of
datasets:   Item interactions   Items   Users   Action interactions   Actions   Each
dataset type has an associated schema with required field types. Only the Item interactions
dataset is required in order to train a model (also referred to as creating a solution). A
dataset can be in one of the following states:   CREATE PENDING &gt; CREATE IN_PROGRESS
&gt; ACTIVE -or- CREATE FAILED   DELETE PENDING &gt; DELETE IN_PROGRESS   To get the status
of the dataset, call DescribeDataset.  Related APIs     CreateDatasetGroup     ListDatasets
    DescribeDataset     DeleteDataset

# Arguments
- `dataset_group_arn`: The Amazon Resource Name (ARN) of the dataset group to add the
  dataset to.
- `dataset_type`: The type of dataset. One of the following (case insensitive) values:
  Interactions   Items   Users   Actions   Action_Interactions
- `name`: The name for the dataset.
- `schema_arn`: The ARN of the schema to associate with the dataset. The schema defines the
  dataset fields.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tags"`: A list of tags to apply to the dataset.
"""
function create_dataset(
    datasetGroupArn,
    datasetType,
    name,
    schemaArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize(
        "CreateDataset",
        Dict{String,Any}(
            "datasetGroupArn" => datasetGroupArn,
            "datasetType" => datasetType,
            "name" => name,
            "schemaArn" => schemaArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_dataset(
    datasetGroupArn,
    datasetType,
    name,
    schemaArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize(
        "CreateDataset",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "datasetGroupArn" => datasetGroupArn,
                    "datasetType" => datasetType,
                    "name" => name,
                    "schemaArn" => schemaArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_dataset_export_job(dataset_arn, job_name, job_output, role_arn)
    create_dataset_export_job(dataset_arn, job_name, job_output, role_arn, params::Dict{String,<:Any})

 Creates a job that exports data from your dataset to an Amazon S3 bucket. To allow Amazon
Personalize to export the training data, you must specify an service-linked IAM role that
gives Amazon Personalize PutObject permissions for your Amazon S3 bucket. For information,
see Exporting a dataset in the Amazon Personalize developer guide.   Status  A dataset
export job can be in one of the following states:   CREATE PENDING &gt; CREATE IN_PROGRESS
&gt; ACTIVE -or- CREATE FAILED    To get the status of the export job, call
DescribeDatasetExportJob, and specify the Amazon Resource Name (ARN) of the dataset export
job. The dataset export is complete when the status shows as ACTIVE. If the status shows as
CREATE FAILED, the response includes a failureReason key, which describes why the job
failed.

# Arguments
- `dataset_arn`: The Amazon Resource Name (ARN) of the dataset that contains the data to
  export.
- `job_name`: The name for the dataset export job.
- `job_output`: The path to the Amazon S3 bucket where the job's output is stored.
- `role_arn`: The Amazon Resource Name (ARN) of the IAM service role that has permissions
  to add data to your output Amazon S3 bucket.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ingestionMode"`: The data to export, based on how you imported the data. You can choose
  to export only BULK data that you imported using a dataset import job, only PUT data that
  you imported incrementally (using the console, PutEvents, PutUsers and PutItems
  operations), or ALL for both types. The default value is PUT.
- `"tags"`: A list of tags to apply to the dataset export job.
"""
function create_dataset_export_job(
    datasetArn,
    jobName,
    jobOutput,
    roleArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize(
        "CreateDatasetExportJob",
        Dict{String,Any}(
            "datasetArn" => datasetArn,
            "jobName" => jobName,
            "jobOutput" => jobOutput,
            "roleArn" => roleArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_dataset_export_job(
    datasetArn,
    jobName,
    jobOutput,
    roleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize(
        "CreateDatasetExportJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "datasetArn" => datasetArn,
                    "jobName" => jobName,
                    "jobOutput" => jobOutput,
                    "roleArn" => roleArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_dataset_group(name)
    create_dataset_group(name, params::Dict{String,<:Any})

Creates an empty dataset group. A dataset group is a container for Amazon Personalize
resources. A dataset group can contain at most three datasets, one for each type of
dataset:   Item interactions   Items   Users   Actions   Action interactions    A dataset
group can be a Domain dataset group, where you specify a domain and use pre-configured
resources like recommenders, or a Custom dataset group, where you use custom resources,
such as a solution with a solution version, that you deploy with a campaign. If you start
with a Domain dataset group, you can still add custom resources such as solutions and
solution versions trained with recipes for custom use cases and deployed with campaigns.  A
dataset group can be in one of the following states:   CREATE PENDING &gt; CREATE
IN_PROGRESS &gt; ACTIVE -or- CREATE FAILED   DELETE PENDING   To get the status of the
dataset group, call DescribeDatasetGroup. If the status shows as CREATE FAILED, the
response includes a failureReason key, which describes why the creation failed.  You must
wait until the status of the dataset group is ACTIVE before adding a dataset to the group.
You can specify an Key Management Service (KMS) key to encrypt the datasets in the group.
If you specify a KMS key, you must also include an Identity and Access Management (IAM)
role that has permission to access the key.  APIs that require a dataset group ARN in the
request     CreateDataset     CreateEventTracker     CreateSolution     Related APIs
ListDatasetGroups     DescribeDatasetGroup     DeleteDatasetGroup

# Arguments
- `name`: The name for the new dataset group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"domain"`: The domain of the dataset group. Specify a domain to create a Domain dataset
  group. The domain you specify determines the default schemas for datasets and the use cases
  available for recommenders. If you don't specify a domain, you create a Custom dataset
  group with solution versions that you deploy with a campaign.
- `"kmsKeyArn"`: The Amazon Resource Name (ARN) of a Key Management Service (KMS) key used
  to encrypt the datasets.
- `"roleArn"`: The ARN of the Identity and Access Management (IAM) role that has
  permissions to access the Key Management Service (KMS) key. Supplying an IAM role is only
  valid when also specifying a KMS key.
- `"tags"`: A list of tags to apply to the dataset group.
"""
function create_dataset_group(name; aws_config::AbstractAWSConfig=current_aws_config())
    return personalize(
        "CreateDatasetGroup",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_dataset_group(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return personalize(
        "CreateDatasetGroup",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_dataset_import_job(data_source, dataset_arn, job_name, role_arn)
    create_dataset_import_job(data_source, dataset_arn, job_name, role_arn, params::Dict{String,<:Any})

Creates a job that imports training data from your data source (an Amazon S3 bucket) to an
Amazon Personalize dataset. To allow Amazon Personalize to import the training data, you
must specify an IAM service role that has permission to read from the data source, as
Amazon Personalize makes a copy of your data and processes it internally. For information
on granting access to your Amazon S3 bucket, see Giving Amazon Personalize Access to Amazon
S3 Resources.  If you already created a recommender or deployed a custom solution version
with a campaign, how new bulk records influence recommendations depends on the domain use
case or recipe that you use. For more information, see How new data influences real-time
recommendations.  By default, a dataset import job replaces any existing data in the
dataset that you imported in bulk. To add new records without replacing existing data,
specify INCREMENTAL for the import mode in the CreateDatasetImportJob operation.   Status
A dataset import job can be in one of the following states:   CREATE PENDING &gt; CREATE
IN_PROGRESS &gt; ACTIVE -or- CREATE FAILED   To get the status of the import job, call
DescribeDatasetImportJob, providing the Amazon Resource Name (ARN) of the dataset import
job. The dataset import is complete when the status shows as ACTIVE. If the status shows as
CREATE FAILED, the response includes a failureReason key, which describes why the job
failed.  Importing takes time. You must wait until the status shows as ACTIVE before
training a model using the dataset.   Related APIs     ListDatasetImportJobs
DescribeDatasetImportJob

# Arguments
- `data_source`: The Amazon S3 bucket that contains the training data to import.
- `dataset_arn`: The ARN of the dataset that receives the imported data.
- `job_name`: The name for the dataset import job.
- `role_arn`: The ARN of the IAM role that has permissions to read from the Amazon S3 data
  source.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"importMode"`: Specify how to add the new records to an existing dataset. The default
  import mode is FULL. If you haven't imported bulk records into the dataset previously, you
  can only specify FULL.   Specify FULL to overwrite all existing bulk data in your dataset.
  Data you imported individually is not replaced.   Specify INCREMENTAL to append the new
  records to the existing data in your dataset. Amazon Personalize replaces any record with
  the same ID with the new one.
- `"publishAttributionMetricsToS3"`: If you created a metric attribution, specify whether
  to publish metrics for this import job to Amazon S3
- `"tags"`: A list of tags to apply to the dataset import job.
"""
function create_dataset_import_job(
    dataSource,
    datasetArn,
    jobName,
    roleArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize(
        "CreateDatasetImportJob",
        Dict{String,Any}(
            "dataSource" => dataSource,
            "datasetArn" => datasetArn,
            "jobName" => jobName,
            "roleArn" => roleArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_dataset_import_job(
    dataSource,
    datasetArn,
    jobName,
    roleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize(
        "CreateDatasetImportJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "dataSource" => dataSource,
                    "datasetArn" => datasetArn,
                    "jobName" => jobName,
                    "roleArn" => roleArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_event_tracker(dataset_group_arn, name)
    create_event_tracker(dataset_group_arn, name, params::Dict{String,<:Any})

Creates an event tracker that you use when adding event data to a specified dataset group
using the PutEvents API.  Only one event tracker can be associated with a dataset group.
You will get an error if you call CreateEventTracker using the same dataset group as an
existing event tracker.  When you create an event tracker, the response includes a tracking
ID, which you pass as a parameter when you use the PutEvents operation. Amazon Personalize
then appends the event data to the Item interactions dataset of the dataset group you
specify in your event tracker.  The event tracker can be in one of the following states:
CREATE PENDING &gt; CREATE IN_PROGRESS &gt; ACTIVE -or- CREATE FAILED   DELETE PENDING &gt;
DELETE IN_PROGRESS   To get the status of the event tracker, call DescribeEventTracker.
The event tracker must be in the ACTIVE state before using the tracking ID.   Related APIs
   ListEventTrackers     DescribeEventTracker     DeleteEventTracker

# Arguments
- `dataset_group_arn`: The Amazon Resource Name (ARN) of the dataset group that receives
  the event data.
- `name`: The name for the event tracker.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tags"`: A list of tags to apply to the event tracker.
"""
function create_event_tracker(
    datasetGroupArn, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return personalize(
        "CreateEventTracker",
        Dict{String,Any}("datasetGroupArn" => datasetGroupArn, "name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_event_tracker(
    datasetGroupArn,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize(
        "CreateEventTracker",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("datasetGroupArn" => datasetGroupArn, "name" => name),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_filter(dataset_group_arn, filter_expression, name)
    create_filter(dataset_group_arn, filter_expression, name, params::Dict{String,<:Any})

Creates a recommendation filter. For more information, see Filtering recommendations and
user segments.

# Arguments
- `dataset_group_arn`: The ARN of the dataset group that the filter will belong to.
- `filter_expression`: The filter expression defines which items are included or excluded
  from recommendations. Filter expression must follow specific format rules. For information
  about filter expression structure and syntax, see Filter expressions.
- `name`: The name of the filter to create.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tags"`: A list of tags to apply to the filter.
"""
function create_filter(
    datasetGroupArn,
    filterExpression,
    name;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize(
        "CreateFilter",
        Dict{String,Any}(
            "datasetGroupArn" => datasetGroupArn,
            "filterExpression" => filterExpression,
            "name" => name,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_filter(
    datasetGroupArn,
    filterExpression,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize(
        "CreateFilter",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "datasetGroupArn" => datasetGroupArn,
                    "filterExpression" => filterExpression,
                    "name" => name,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_metric_attribution(dataset_group_arn, metrics, metrics_output_config, name)
    create_metric_attribution(dataset_group_arn, metrics, metrics_output_config, name, params::Dict{String,<:Any})

Creates a metric attribution. A metric attribution creates reports on the data that you
import into Amazon Personalize. Depending on how you imported the data, you can view
reports in Amazon CloudWatch or Amazon S3. For more information, see Measuring impact of
recommendations.

# Arguments
- `dataset_group_arn`: The Amazon Resource Name (ARN) of the destination dataset group for
  the metric attribution.
- `metrics`: A list of metric attributes for the metric attribution. Each metric attribute
  specifies an event type to track and a function. Available functions are SUM() or
  SAMPLECOUNT(). For SUM() functions, provide the dataset type (either Interactions or Items)
  and column to sum as a parameter. For example SUM(Items.PRICE).
- `metrics_output_config`: The output configuration details for the metric attribution.
- `name`: A name for the metric attribution.

"""
function create_metric_attribution(
    datasetGroupArn,
    metrics,
    metricsOutputConfig,
    name;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize(
        "CreateMetricAttribution",
        Dict{String,Any}(
            "datasetGroupArn" => datasetGroupArn,
            "metrics" => metrics,
            "metricsOutputConfig" => metricsOutputConfig,
            "name" => name,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_metric_attribution(
    datasetGroupArn,
    metrics,
    metricsOutputConfig,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize(
        "CreateMetricAttribution",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "datasetGroupArn" => datasetGroupArn,
                    "metrics" => metrics,
                    "metricsOutputConfig" => metricsOutputConfig,
                    "name" => name,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_recommender(dataset_group_arn, name, recipe_arn)
    create_recommender(dataset_group_arn, name, recipe_arn, params::Dict{String,<:Any})

Creates a recommender with the recipe (a Domain dataset group use case) you specify. You
create recommenders for a Domain dataset group and specify the recommender's Amazon
Resource Name (ARN) when you make a GetRecommendations request.   Minimum recommendation
requests per second   A high minRecommendationRequestsPerSecond will increase your bill. We
recommend starting with 1 for minRecommendationRequestsPerSecond (the default). Track your
usage using Amazon CloudWatch metrics, and increase the minRecommendationRequestsPerSecond
as necessary.  When you create a recommender, you can configure the recommender's minimum
recommendation requests per second. The minimum recommendation requests per second
(minRecommendationRequestsPerSecond) specifies the baseline recommendation request
throughput provisioned by Amazon Personalize. The default
minRecommendationRequestsPerSecond is 1. A recommendation request is a single
GetRecommendations operation. Request throughput is measured in requests per second and
Amazon Personalize uses your requests per second to derive your requests per hour and the
price of your recommender usage.   If your requests per second increases beyond
minRecommendationRequestsPerSecond, Amazon Personalize auto-scales the provisioned capacity
up and down, but never below minRecommendationRequestsPerSecond. There's a short time delay
while the capacity is increased that might cause loss of requests.  Your bill is the
greater of either the minimum requests per hour (based on
minRecommendationRequestsPerSecond) or the actual number of requests. The actual request
throughput used is calculated as the average requests/second within a one-hour window. We
recommend starting with the default minRecommendationRequestsPerSecond, track your usage
using Amazon CloudWatch metrics, and then increase the minRecommendationRequestsPerSecond
as necessary.   Status  A recommender can be in one of the following states:   CREATE
PENDING &gt; CREATE IN_PROGRESS &gt; ACTIVE -or- CREATE FAILED   STOP PENDING &gt; STOP
IN_PROGRESS &gt; INACTIVE &gt; START PENDING &gt; START IN_PROGRESS &gt; ACTIVE   DELETE
PENDING &gt; DELETE IN_PROGRESS   To get the recommender status, call DescribeRecommender.
Wait until the status of the recommender is ACTIVE before asking the recommender for
recommendations.   Related APIs     ListRecommenders     DescribeRecommender
UpdateRecommender     DeleteRecommender

# Arguments
- `dataset_group_arn`: The Amazon Resource Name (ARN) of the destination domain dataset
  group for the recommender.
- `name`: The name of the recommender.
- `recipe_arn`: The Amazon Resource Name (ARN) of the recipe that the recommender will use.
  For a recommender, a recipe is a Domain dataset group use case. Only Domain dataset group
  use cases can be used to create a recommender. For information about use cases see Choosing
  recommender use cases.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"recommenderConfig"`: The configuration details of the recommender.
- `"tags"`: A list of tags to apply to the recommender.
"""
function create_recommender(
    datasetGroupArn, name, recipeArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return personalize(
        "CreateRecommender",
        Dict{String,Any}(
            "datasetGroupArn" => datasetGroupArn, "name" => name, "recipeArn" => recipeArn
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_recommender(
    datasetGroupArn,
    name,
    recipeArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize(
        "CreateRecommender",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "datasetGroupArn" => datasetGroupArn,
                    "name" => name,
                    "recipeArn" => recipeArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_schema(name, schema)
    create_schema(name, schema, params::Dict{String,<:Any})

Creates an Amazon Personalize schema from the specified schema string. The schema you
create must be in Avro JSON format. Amazon Personalize recognizes three schema variants.
Each schema is associated with a dataset type and has a set of required field and keywords.
If you are creating a schema for a dataset in a Domain dataset group, you provide the
domain of the Domain dataset group. You specify a schema when you call CreateDataset.
Related APIs     ListSchemas     DescribeSchema     DeleteSchema

# Arguments
- `name`: The name for the schema.
- `schema`: A schema in Avro JSON format.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"domain"`: The domain for the schema. If you are creating a schema for a dataset in a
  Domain dataset group, specify the domain you chose when you created the Domain dataset
  group.
"""
function create_schema(name, schema; aws_config::AbstractAWSConfig=current_aws_config())
    return personalize(
        "CreateSchema",
        Dict{String,Any}("name" => name, "schema" => schema);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_schema(
    name,
    schema,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize(
        "CreateSchema",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("name" => name, "schema" => schema), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_solution(dataset_group_arn, name)
    create_solution(dataset_group_arn, name, params::Dict{String,<:Any})

 After you create a solution, you can’t change its configuration. By default, all new
solutions use automatic training. With automatic training, you incur training costs while
your solution is active. You can't stop automatic training for a solution. To avoid
unnecessary costs, make sure to delete the solution when you are finished. For information
about training costs, see Amazon Personalize pricing.  Creates the configuration for
training a model (creating a solution version). This configuration includes the recipe to
use for model training and optional training configuration, such as columns to use in
training and feature transformation parameters. For more information about configuring a
solution, see Creating and configuring a solution.   By default, new solutions use
automatic training to create solution versions every 7 days. You can change the training
frequency. Automatic solution version creation starts one hour after the solution is
ACTIVE. If you manually create a solution version within the hour, the solution skips the
first automatic training. For more information, see Configuring automatic training.  To
turn off automatic training, set performAutoTraining to false. If you turn off automatic
training, you must manually create a solution version by calling the CreateSolutionVersion
operation. After training starts, you can get the solution version's Amazon Resource Name
(ARN) with the ListSolutionVersions API operation. To get its status, use the
DescribeSolutionVersion.  After training completes you can evaluate model accuracy by
calling GetSolutionMetrics. When you are satisfied with the solution version, you deploy it
using CreateCampaign. The campaign provides recommendations to a client through the
GetRecommendations API.  Amazon Personalize doesn't support configuring the hpoObjective
for solution hyperparameter optimization at this time.   Status  A solution can be in one
of the following states:   CREATE PENDING &gt; CREATE IN_PROGRESS &gt; ACTIVE -or- CREATE
FAILED   DELETE PENDING &gt; DELETE IN_PROGRESS   To get the status of the solution, call
DescribeSolution. If you use manual training, the status must be ACTIVE before you call
CreateSolutionVersion.  Related APIs     ListSolutions     CreateSolutionVersion
DescribeSolution     DeleteSolution       ListSolutionVersions     DescribeSolutionVersion


# Arguments
- `dataset_group_arn`: The Amazon Resource Name (ARN) of the dataset group that provides
  the training data.
- `name`: The name for the solution.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"eventType"`: When your have multiple event types (using an EVENT_TYPE schema field),
  this parameter specifies which event type (for example, 'click' or 'like') is used for
  training the model. If you do not provide an eventType, Amazon Personalize will use all
  interactions for training with equal weight regardless of type.
- `"performAutoML"`:  We don't recommend enabling automated machine learning. Instead,
  match your use case to the available Amazon Personalize recipes. For more information, see
  Choosing a recipe.  Whether to perform automated machine learning (AutoML). The default is
  false. For this case, you must specify recipeArn. When set to true, Amazon Personalize
  analyzes your training data and selects the optimal USER_PERSONALIZATION recipe and
  hyperparameters. In this case, you must omit recipeArn. Amazon Personalize determines the
  optimal recipe by running tests with different values for the hyperparameters. AutoML
  lengthens the training process as compared to selecting a specific recipe.
- `"performAutoTraining"`: Whether the solution uses automatic training to create new
  solution versions (trained models). The default is True and the solution automatically
  creates new solution versions every 7 days. You can change the training frequency by
  specifying a schedulingExpression in the AutoTrainingConfig as part of solution
  configuration. For more information about automatic training, see Configuring automatic
  training.  Automatic solution version creation starts one hour after the solution is
  ACTIVE. If you manually create a solution version within the hour, the solution skips the
  first automatic training.   After training starts, you can get the solution version's
  Amazon Resource Name (ARN) with the ListSolutionVersions API operation. To get its status,
  use the DescribeSolutionVersion.
- `"performHPO"`: Whether to perform hyperparameter optimization (HPO) on the specified or
  selected recipe. The default is false. When performing AutoML, this parameter is always
  true and you should not set it to false.
- `"recipeArn"`: The Amazon Resource Name (ARN) of the recipe to use for model training.
  This is required when performAutoML is false. For information about different Amazon
  Personalize recipes and their ARNs, see Choosing a recipe.
- `"solutionConfig"`: The configuration to use with the solution. When performAutoML is set
  to true, Amazon Personalize only evaluates the autoMLConfig section of the solution
  configuration.  Amazon Personalize doesn't support configuring the hpoObjective at this
  time.
- `"tags"`: A list of tags to apply to the solution.
"""
function create_solution(
    datasetGroupArn, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return personalize(
        "CreateSolution",
        Dict{String,Any}("datasetGroupArn" => datasetGroupArn, "name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_solution(
    datasetGroupArn,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize(
        "CreateSolution",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("datasetGroupArn" => datasetGroupArn, "name" => name),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_solution_version(solution_arn)
    create_solution_version(solution_arn, params::Dict{String,<:Any})

Trains or retrains an active solution in a Custom dataset group. A solution is created
using the CreateSolution operation and must be in the ACTIVE state before calling
CreateSolutionVersion. A new version of the solution is created every time you call this
operation.  Status  A solution version can be in one of the following states:   CREATE
PENDING   CREATE IN_PROGRESS   ACTIVE   CREATE FAILED   CREATE STOPPING   CREATE STOPPED
To get the status of the version, call DescribeSolutionVersion. Wait until the status shows
as ACTIVE before calling CreateCampaign. If the status shows as CREATE FAILED, the response
includes a failureReason key, which describes why the job failed.  Related APIs
ListSolutionVersions     DescribeSolutionVersion     ListSolutions     CreateSolution
DescribeSolution     DeleteSolution

# Arguments
- `solution_arn`: The Amazon Resource Name (ARN) of the solution containing the training
  configuration information.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"name"`: The name of the solution version.
- `"tags"`: A list of tags to apply to the solution version.
- `"trainingMode"`: The scope of training to be performed when creating the solution
  version. The default is FULL. This creates a completely new model based on the entirety of
  the training data from the datasets in your dataset group.  If you use
  User-Personalization, you can specify a training mode of UPDATE. This updates the model to
  consider new items for recommendations. It is not a full retraining. You should still
  complete a full retraining weekly. If you specify UPDATE, Amazon Personalize will stop
  automatic updates for the solution version. To resume updates, create a new solution with
  training mode set to FULL and deploy it in a campaign. For more information about automatic
  updates, see Automatic updates.  The UPDATE option can only be used when you already have
  an active solution version created from the input solution using the FULL option and the
  input solution was trained with the User-Personalization recipe or the legacy
  HRNN-Coldstart recipe.
"""
function create_solution_version(
    solutionArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return personalize(
        "CreateSolutionVersion",
        Dict{String,Any}("solutionArn" => solutionArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_solution_version(
    solutionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize(
        "CreateSolutionVersion",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("solutionArn" => solutionArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_campaign(campaign_arn)
    delete_campaign(campaign_arn, params::Dict{String,<:Any})

Removes a campaign by deleting the solution deployment. The solution that the campaign is
based on is not deleted and can be redeployed when needed. A deleted campaign can no longer
be specified in a GetRecommendations request. For information on creating campaigns, see
CreateCampaign.

# Arguments
- `campaign_arn`: The Amazon Resource Name (ARN) of the campaign to delete.

"""
function delete_campaign(campaignArn; aws_config::AbstractAWSConfig=current_aws_config())
    return personalize(
        "DeleteCampaign",
        Dict{String,Any}("campaignArn" => campaignArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_campaign(
    campaignArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize(
        "DeleteCampaign",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("campaignArn" => campaignArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_dataset(dataset_arn)
    delete_dataset(dataset_arn, params::Dict{String,<:Any})

Deletes a dataset. You can't delete a dataset if an associated DatasetImportJob or
SolutionVersion is in the CREATE PENDING or IN PROGRESS state. For more information on
datasets, see CreateDataset.

# Arguments
- `dataset_arn`: The Amazon Resource Name (ARN) of the dataset to delete.

"""
function delete_dataset(datasetArn; aws_config::AbstractAWSConfig=current_aws_config())
    return personalize(
        "DeleteDataset",
        Dict{String,Any}("datasetArn" => datasetArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_dataset(
    datasetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize(
        "DeleteDataset",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("datasetArn" => datasetArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_dataset_group(dataset_group_arn)
    delete_dataset_group(dataset_group_arn, params::Dict{String,<:Any})

Deletes a dataset group. Before you delete a dataset group, you must delete the following:
 All associated event trackers.   All associated solutions.   All datasets in the dataset
group.

# Arguments
- `dataset_group_arn`: The ARN of the dataset group to delete.

"""
function delete_dataset_group(
    datasetGroupArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return personalize(
        "DeleteDatasetGroup",
        Dict{String,Any}("datasetGroupArn" => datasetGroupArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_dataset_group(
    datasetGroupArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize(
        "DeleteDatasetGroup",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("datasetGroupArn" => datasetGroupArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_event_tracker(event_tracker_arn)
    delete_event_tracker(event_tracker_arn, params::Dict{String,<:Any})

Deletes the event tracker. Does not delete the dataset from the dataset group. For more
information on event trackers, see CreateEventTracker.

# Arguments
- `event_tracker_arn`: The Amazon Resource Name (ARN) of the event tracker to delete.

"""
function delete_event_tracker(
    eventTrackerArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return personalize(
        "DeleteEventTracker",
        Dict{String,Any}("eventTrackerArn" => eventTrackerArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_event_tracker(
    eventTrackerArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize(
        "DeleteEventTracker",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("eventTrackerArn" => eventTrackerArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_filter(filter_arn)
    delete_filter(filter_arn, params::Dict{String,<:Any})

Deletes a filter.

# Arguments
- `filter_arn`: The ARN of the filter to delete.

"""
function delete_filter(filterArn; aws_config::AbstractAWSConfig=current_aws_config())
    return personalize(
        "DeleteFilter",
        Dict{String,Any}("filterArn" => filterArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_filter(
    filterArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize(
        "DeleteFilter",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("filterArn" => filterArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_metric_attribution(metric_attribution_arn)
    delete_metric_attribution(metric_attribution_arn, params::Dict{String,<:Any})

Deletes a metric attribution.

# Arguments
- `metric_attribution_arn`: The metric attribution's Amazon Resource Name (ARN).

"""
function delete_metric_attribution(
    metricAttributionArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return personalize(
        "DeleteMetricAttribution",
        Dict{String,Any}("metricAttributionArn" => metricAttributionArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_metric_attribution(
    metricAttributionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize(
        "DeleteMetricAttribution",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("metricAttributionArn" => metricAttributionArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_recommender(recommender_arn)
    delete_recommender(recommender_arn, params::Dict{String,<:Any})

Deactivates and removes a recommender. A deleted recommender can no longer be specified in
a GetRecommendations request.

# Arguments
- `recommender_arn`: The Amazon Resource Name (ARN) of the recommender to delete.

"""
function delete_recommender(
    recommenderArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return personalize(
        "DeleteRecommender",
        Dict{String,Any}("recommenderArn" => recommenderArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_recommender(
    recommenderArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize(
        "DeleteRecommender",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("recommenderArn" => recommenderArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_schema(schema_arn)
    delete_schema(schema_arn, params::Dict{String,<:Any})

Deletes a schema. Before deleting a schema, you must delete all datasets referencing the
schema. For more information on schemas, see CreateSchema.

# Arguments
- `schema_arn`: The Amazon Resource Name (ARN) of the schema to delete.

"""
function delete_schema(schemaArn; aws_config::AbstractAWSConfig=current_aws_config())
    return personalize(
        "DeleteSchema",
        Dict{String,Any}("schemaArn" => schemaArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_schema(
    schemaArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize(
        "DeleteSchema",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("schemaArn" => schemaArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_solution(solution_arn)
    delete_solution(solution_arn, params::Dict{String,<:Any})

Deletes all versions of a solution and the Solution object itself. Before deleting a
solution, you must delete all campaigns based on the solution. To determine what campaigns
are using the solution, call ListCampaigns and supply the Amazon Resource Name (ARN) of the
solution. You can't delete a solution if an associated SolutionVersion is in the CREATE
PENDING or IN PROGRESS state. For more information on solutions, see CreateSolution.

# Arguments
- `solution_arn`: The ARN of the solution to delete.

"""
function delete_solution(solutionArn; aws_config::AbstractAWSConfig=current_aws_config())
    return personalize(
        "DeleteSolution",
        Dict{String,Any}("solutionArn" => solutionArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_solution(
    solutionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize(
        "DeleteSolution",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("solutionArn" => solutionArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_algorithm(algorithm_arn)
    describe_algorithm(algorithm_arn, params::Dict{String,<:Any})

Describes the given algorithm.

# Arguments
- `algorithm_arn`: The Amazon Resource Name (ARN) of the algorithm to describe.

"""
function describe_algorithm(
    algorithmArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return personalize(
        "DescribeAlgorithm",
        Dict{String,Any}("algorithmArn" => algorithmArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_algorithm(
    algorithmArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize(
        "DescribeAlgorithm",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("algorithmArn" => algorithmArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_batch_inference_job(batch_inference_job_arn)
    describe_batch_inference_job(batch_inference_job_arn, params::Dict{String,<:Any})

Gets the properties of a batch inference job including name, Amazon Resource Name (ARN),
status, input and output configurations, and the ARN of the solution version used to
generate the recommendations.

# Arguments
- `batch_inference_job_arn`: The ARN of the batch inference job to describe.

"""
function describe_batch_inference_job(
    batchInferenceJobArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return personalize(
        "DescribeBatchInferenceJob",
        Dict{String,Any}("batchInferenceJobArn" => batchInferenceJobArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_batch_inference_job(
    batchInferenceJobArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize(
        "DescribeBatchInferenceJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("batchInferenceJobArn" => batchInferenceJobArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_batch_segment_job(batch_segment_job_arn)
    describe_batch_segment_job(batch_segment_job_arn, params::Dict{String,<:Any})

Gets the properties of a batch segment job including name, Amazon Resource Name (ARN),
status, input and output configurations, and the ARN of the solution version used to
generate segments.

# Arguments
- `batch_segment_job_arn`: The ARN of the batch segment job to describe.

"""
function describe_batch_segment_job(
    batchSegmentJobArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return personalize(
        "DescribeBatchSegmentJob",
        Dict{String,Any}("batchSegmentJobArn" => batchSegmentJobArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_batch_segment_job(
    batchSegmentJobArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize(
        "DescribeBatchSegmentJob",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("batchSegmentJobArn" => batchSegmentJobArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_campaign(campaign_arn)
    describe_campaign(campaign_arn, params::Dict{String,<:Any})

Describes the given campaign, including its status. A campaign can be in one of the
following states:   CREATE PENDING &gt; CREATE IN_PROGRESS &gt; ACTIVE -or- CREATE FAILED
DELETE PENDING &gt; DELETE IN_PROGRESS   When the status is CREATE FAILED, the response
includes the failureReason key, which describes why. For more information on campaigns, see
CreateCampaign.

# Arguments
- `campaign_arn`: The Amazon Resource Name (ARN) of the campaign.

"""
function describe_campaign(campaignArn; aws_config::AbstractAWSConfig=current_aws_config())
    return personalize(
        "DescribeCampaign",
        Dict{String,Any}("campaignArn" => campaignArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_campaign(
    campaignArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize(
        "DescribeCampaign",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("campaignArn" => campaignArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_data_deletion_job(data_deletion_job_arn)
    describe_data_deletion_job(data_deletion_job_arn, params::Dict{String,<:Any})

Describes the data deletion job created by CreateDataDeletionJob, including the job status.

# Arguments
- `data_deletion_job_arn`: The Amazon Resource Name (ARN) of the data deletion job.

"""
function describe_data_deletion_job(
    dataDeletionJobArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return personalize(
        "DescribeDataDeletionJob",
        Dict{String,Any}("dataDeletionJobArn" => dataDeletionJobArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_data_deletion_job(
    dataDeletionJobArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize(
        "DescribeDataDeletionJob",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("dataDeletionJobArn" => dataDeletionJobArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_dataset(dataset_arn)
    describe_dataset(dataset_arn, params::Dict{String,<:Any})

Describes the given dataset. For more information on datasets, see CreateDataset.

# Arguments
- `dataset_arn`: The Amazon Resource Name (ARN) of the dataset to describe.

"""
function describe_dataset(datasetArn; aws_config::AbstractAWSConfig=current_aws_config())
    return personalize(
        "DescribeDataset",
        Dict{String,Any}("datasetArn" => datasetArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_dataset(
    datasetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize(
        "DescribeDataset",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("datasetArn" => datasetArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_dataset_export_job(dataset_export_job_arn)
    describe_dataset_export_job(dataset_export_job_arn, params::Dict{String,<:Any})

Describes the dataset export job created by CreateDatasetExportJob, including the export
job status.

# Arguments
- `dataset_export_job_arn`: The Amazon Resource Name (ARN) of the dataset export job to
  describe.

"""
function describe_dataset_export_job(
    datasetExportJobArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return personalize(
        "DescribeDatasetExportJob",
        Dict{String,Any}("datasetExportJobArn" => datasetExportJobArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_dataset_export_job(
    datasetExportJobArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize(
        "DescribeDatasetExportJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("datasetExportJobArn" => datasetExportJobArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_dataset_group(dataset_group_arn)
    describe_dataset_group(dataset_group_arn, params::Dict{String,<:Any})

Describes the given dataset group. For more information on dataset groups, see
CreateDatasetGroup.

# Arguments
- `dataset_group_arn`: The Amazon Resource Name (ARN) of the dataset group to describe.

"""
function describe_dataset_group(
    datasetGroupArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return personalize(
        "DescribeDatasetGroup",
        Dict{String,Any}("datasetGroupArn" => datasetGroupArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_dataset_group(
    datasetGroupArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize(
        "DescribeDatasetGroup",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("datasetGroupArn" => datasetGroupArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_dataset_import_job(dataset_import_job_arn)
    describe_dataset_import_job(dataset_import_job_arn, params::Dict{String,<:Any})

Describes the dataset import job created by CreateDatasetImportJob, including the import
job status.

# Arguments
- `dataset_import_job_arn`: The Amazon Resource Name (ARN) of the dataset import job to
  describe.

"""
function describe_dataset_import_job(
    datasetImportJobArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return personalize(
        "DescribeDatasetImportJob",
        Dict{String,Any}("datasetImportJobArn" => datasetImportJobArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_dataset_import_job(
    datasetImportJobArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize(
        "DescribeDatasetImportJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("datasetImportJobArn" => datasetImportJobArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_event_tracker(event_tracker_arn)
    describe_event_tracker(event_tracker_arn, params::Dict{String,<:Any})

Describes an event tracker. The response includes the trackingId and status of the event
tracker. For more information on event trackers, see CreateEventTracker.

# Arguments
- `event_tracker_arn`: The Amazon Resource Name (ARN) of the event tracker to describe.

"""
function describe_event_tracker(
    eventTrackerArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return personalize(
        "DescribeEventTracker",
        Dict{String,Any}("eventTrackerArn" => eventTrackerArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_event_tracker(
    eventTrackerArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize(
        "DescribeEventTracker",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("eventTrackerArn" => eventTrackerArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_feature_transformation(feature_transformation_arn)
    describe_feature_transformation(feature_transformation_arn, params::Dict{String,<:Any})

Describes the given feature transformation.

# Arguments
- `feature_transformation_arn`: The Amazon Resource Name (ARN) of the feature
  transformation to describe.

"""
function describe_feature_transformation(
    featureTransformationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return personalize(
        "DescribeFeatureTransformation",
        Dict{String,Any}("featureTransformationArn" => featureTransformationArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_feature_transformation(
    featureTransformationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize(
        "DescribeFeatureTransformation",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("featureTransformationArn" => featureTransformationArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_filter(filter_arn)
    describe_filter(filter_arn, params::Dict{String,<:Any})

Describes a filter's properties.

# Arguments
- `filter_arn`: The ARN of the filter to describe.

"""
function describe_filter(filterArn; aws_config::AbstractAWSConfig=current_aws_config())
    return personalize(
        "DescribeFilter",
        Dict{String,Any}("filterArn" => filterArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_filter(
    filterArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize(
        "DescribeFilter",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("filterArn" => filterArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_metric_attribution(metric_attribution_arn)
    describe_metric_attribution(metric_attribution_arn, params::Dict{String,<:Any})

Describes a metric attribution.

# Arguments
- `metric_attribution_arn`: The metric attribution's Amazon Resource Name (ARN).

"""
function describe_metric_attribution(
    metricAttributionArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return personalize(
        "DescribeMetricAttribution",
        Dict{String,Any}("metricAttributionArn" => metricAttributionArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_metric_attribution(
    metricAttributionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize(
        "DescribeMetricAttribution",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("metricAttributionArn" => metricAttributionArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_recipe(recipe_arn)
    describe_recipe(recipe_arn, params::Dict{String,<:Any})

Describes a recipe. A recipe contains three items:   An algorithm that trains a model.
Hyperparameters that govern the training.   Feature transformation information for
modifying the input data before training.   Amazon Personalize provides a set of predefined
recipes. You specify a recipe when you create a solution with the CreateSolution API.
CreateSolution trains a model by using the algorithm in the specified recipe and a training
dataset. The solution, when deployed as a campaign, can provide recommendations using the
GetRecommendations API.

# Arguments
- `recipe_arn`: The Amazon Resource Name (ARN) of the recipe to describe.

"""
function describe_recipe(recipeArn; aws_config::AbstractAWSConfig=current_aws_config())
    return personalize(
        "DescribeRecipe",
        Dict{String,Any}("recipeArn" => recipeArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_recipe(
    recipeArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize(
        "DescribeRecipe",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("recipeArn" => recipeArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_recommender(recommender_arn)
    describe_recommender(recommender_arn, params::Dict{String,<:Any})

Describes the given recommender, including its status. A recommender can be in one of the
following states:   CREATE PENDING &gt; CREATE IN_PROGRESS &gt; ACTIVE -or- CREATE FAILED
STOP PENDING &gt; STOP IN_PROGRESS &gt; INACTIVE &gt; START PENDING &gt; START IN_PROGRESS
&gt; ACTIVE   DELETE PENDING &gt; DELETE IN_PROGRESS   When the status is CREATE FAILED,
the response includes the failureReason key, which describes why. The modelMetrics key is
null when the recommender is being created or deleted. For more information on
recommenders, see CreateRecommender.

# Arguments
- `recommender_arn`: The Amazon Resource Name (ARN) of the recommender to describe.

"""
function describe_recommender(
    recommenderArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return personalize(
        "DescribeRecommender",
        Dict{String,Any}("recommenderArn" => recommenderArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_recommender(
    recommenderArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize(
        "DescribeRecommender",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("recommenderArn" => recommenderArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_schema(schema_arn)
    describe_schema(schema_arn, params::Dict{String,<:Any})

Describes a schema. For more information on schemas, see CreateSchema.

# Arguments
- `schema_arn`: The Amazon Resource Name (ARN) of the schema to retrieve.

"""
function describe_schema(schemaArn; aws_config::AbstractAWSConfig=current_aws_config())
    return personalize(
        "DescribeSchema",
        Dict{String,Any}("schemaArn" => schemaArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_schema(
    schemaArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize(
        "DescribeSchema",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("schemaArn" => schemaArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_solution(solution_arn)
    describe_solution(solution_arn, params::Dict{String,<:Any})

Describes a solution. For more information on solutions, see CreateSolution.

# Arguments
- `solution_arn`: The Amazon Resource Name (ARN) of the solution to describe.

"""
function describe_solution(solutionArn; aws_config::AbstractAWSConfig=current_aws_config())
    return personalize(
        "DescribeSolution",
        Dict{String,Any}("solutionArn" => solutionArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_solution(
    solutionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize(
        "DescribeSolution",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("solutionArn" => solutionArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_solution_version(solution_version_arn)
    describe_solution_version(solution_version_arn, params::Dict{String,<:Any})

Describes a specific version of a solution. For more information on solutions, see
CreateSolution

# Arguments
- `solution_version_arn`: The Amazon Resource Name (ARN) of the solution version.

"""
function describe_solution_version(
    solutionVersionArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return personalize(
        "DescribeSolutionVersion",
        Dict{String,Any}("solutionVersionArn" => solutionVersionArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_solution_version(
    solutionVersionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize(
        "DescribeSolutionVersion",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("solutionVersionArn" => solutionVersionArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_solution_metrics(solution_version_arn)
    get_solution_metrics(solution_version_arn, params::Dict{String,<:Any})

Gets the metrics for the specified solution version.

# Arguments
- `solution_version_arn`: The Amazon Resource Name (ARN) of the solution version for which
  to get metrics.

"""
function get_solution_metrics(
    solutionVersionArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return personalize(
        "GetSolutionMetrics",
        Dict{String,Any}("solutionVersionArn" => solutionVersionArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_solution_metrics(
    solutionVersionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize(
        "GetSolutionMetrics",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("solutionVersionArn" => solutionVersionArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_batch_inference_jobs()
    list_batch_inference_jobs(params::Dict{String,<:Any})

Gets a list of the batch inference jobs that have been performed off of a solution version.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of batch inference job results to return in each page.
  The default value is 100.
- `"nextToken"`: The token to request the next page of results.
- `"solutionVersionArn"`: The Amazon Resource Name (ARN) of the solution version from which
  the batch inference jobs were created.
"""
function list_batch_inference_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return personalize(
        "ListBatchInferenceJobs"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_batch_inference_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return personalize(
        "ListBatchInferenceJobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_batch_segment_jobs()
    list_batch_segment_jobs(params::Dict{String,<:Any})

Gets a list of the batch segment jobs that have been performed off of a solution version
that you specify.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of batch segment job results to return in each page.
  The default value is 100.
- `"nextToken"`: The token to request the next page of results.
- `"solutionVersionArn"`: The Amazon Resource Name (ARN) of the solution version that the
  batch segment jobs used to generate batch segments.
"""
function list_batch_segment_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return personalize(
        "ListBatchSegmentJobs"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_batch_segment_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return personalize(
        "ListBatchSegmentJobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_campaigns()
    list_campaigns(params::Dict{String,<:Any})

Returns a list of campaigns that use the given solution. When a solution is not specified,
all the campaigns associated with the account are listed. The response provides the
properties for each campaign, including the Amazon Resource Name (ARN). For more
information on campaigns, see CreateCampaign.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of campaigns to return.
- `"nextToken"`: A token returned from the previous call to ListCampaigns for getting the
  next set of campaigns (if they exist).
- `"solutionArn"`: The Amazon Resource Name (ARN) of the solution to list the campaigns
  for. When a solution is not specified, all the campaigns associated with the account are
  listed.
"""
function list_campaigns(; aws_config::AbstractAWSConfig=current_aws_config())
    return personalize(
        "ListCampaigns"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_campaigns(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return personalize(
        "ListCampaigns", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_data_deletion_jobs()
    list_data_deletion_jobs(params::Dict{String,<:Any})

Returns a list of data deletion jobs for a dataset group ordered by creation time, with the
most recent first. When a dataset group is not specified, all the data deletion jobs
associated with the account are listed. The response provides the properties for each job,
including the Amazon Resource Name (ARN). For more information on data deletion jobs, see
Deleting users.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"datasetGroupArn"`: The Amazon Resource Name (ARN) of the dataset group to list data
  deletion jobs for.
- `"maxResults"`: The maximum number of data deletion jobs to return.
- `"nextToken"`: A token returned from the previous call to ListDataDeletionJobs for
  getting the next set of jobs (if they exist).
"""
function list_data_deletion_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return personalize(
        "ListDataDeletionJobs"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_data_deletion_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return personalize(
        "ListDataDeletionJobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_dataset_export_jobs()
    list_dataset_export_jobs(params::Dict{String,<:Any})

Returns a list of dataset export jobs that use the given dataset. When a dataset is not
specified, all the dataset export jobs associated with the account are listed. The response
provides the properties for each dataset export job, including the Amazon Resource Name
(ARN). For more information on dataset export jobs, see CreateDatasetExportJob. For more
information on datasets, see CreateDataset.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"datasetArn"`: The Amazon Resource Name (ARN) of the dataset to list the dataset export
  jobs for.
- `"maxResults"`: The maximum number of dataset export jobs to return.
- `"nextToken"`: A token returned from the previous call to ListDatasetExportJobs for
  getting the next set of dataset export jobs (if they exist).
"""
function list_dataset_export_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return personalize(
        "ListDatasetExportJobs"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_dataset_export_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return personalize(
        "ListDatasetExportJobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_dataset_groups()
    list_dataset_groups(params::Dict{String,<:Any})

Returns a list of dataset groups. The response provides the properties for each dataset
group, including the Amazon Resource Name (ARN). For more information on dataset groups,
see CreateDatasetGroup.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of dataset groups to return.
- `"nextToken"`: A token returned from the previous call to ListDatasetGroups for getting
  the next set of dataset groups (if they exist).
"""
function list_dataset_groups(; aws_config::AbstractAWSConfig=current_aws_config())
    return personalize(
        "ListDatasetGroups"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_dataset_groups(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return personalize(
        "ListDatasetGroups", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_dataset_import_jobs()
    list_dataset_import_jobs(params::Dict{String,<:Any})

Returns a list of dataset import jobs that use the given dataset. When a dataset is not
specified, all the dataset import jobs associated with the account are listed. The response
provides the properties for each dataset import job, including the Amazon Resource Name
(ARN). For more information on dataset import jobs, see CreateDatasetImportJob. For more
information on datasets, see CreateDataset.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"datasetArn"`: The Amazon Resource Name (ARN) of the dataset to list the dataset import
  jobs for.
- `"maxResults"`: The maximum number of dataset import jobs to return.
- `"nextToken"`: A token returned from the previous call to ListDatasetImportJobs for
  getting the next set of dataset import jobs (if they exist).
"""
function list_dataset_import_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return personalize(
        "ListDatasetImportJobs"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_dataset_import_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return personalize(
        "ListDatasetImportJobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_datasets()
    list_datasets(params::Dict{String,<:Any})

Returns the list of datasets contained in the given dataset group. The response provides
the properties for each dataset, including the Amazon Resource Name (ARN). For more
information on datasets, see CreateDataset.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"datasetGroupArn"`: The Amazon Resource Name (ARN) of the dataset group that contains
  the datasets to list.
- `"maxResults"`: The maximum number of datasets to return.
- `"nextToken"`: A token returned from the previous call to ListDatasets for getting the
  next set of dataset import jobs (if they exist).
"""
function list_datasets(; aws_config::AbstractAWSConfig=current_aws_config())
    return personalize(
        "ListDatasets"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_datasets(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return personalize(
        "ListDatasets", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_event_trackers()
    list_event_trackers(params::Dict{String,<:Any})

Returns the list of event trackers associated with the account. The response provides the
properties for each event tracker, including the Amazon Resource Name (ARN) and tracking
ID. For more information on event trackers, see CreateEventTracker.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"datasetGroupArn"`: The ARN of a dataset group used to filter the response.
- `"maxResults"`: The maximum number of event trackers to return.
- `"nextToken"`: A token returned from the previous call to ListEventTrackers for getting
  the next set of event trackers (if they exist).
"""
function list_event_trackers(; aws_config::AbstractAWSConfig=current_aws_config())
    return personalize(
        "ListEventTrackers"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_event_trackers(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return personalize(
        "ListEventTrackers", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_filters()
    list_filters(params::Dict{String,<:Any})

Lists all filters that belong to a given dataset group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"datasetGroupArn"`: The ARN of the dataset group that contains the filters.
- `"maxResults"`: The maximum number of filters to return.
- `"nextToken"`: A token returned from the previous call to ListFilters for getting the
  next set of filters (if they exist).
"""
function list_filters(; aws_config::AbstractAWSConfig=current_aws_config())
    return personalize(
        "ListFilters"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_filters(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return personalize(
        "ListFilters", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_metric_attribution_metrics()
    list_metric_attribution_metrics(params::Dict{String,<:Any})

Lists the metrics for the metric attribution.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of metrics to return in one page of results.
- `"metricAttributionArn"`: The Amazon Resource Name (ARN) of the metric attribution to
  retrieve attributes for.
- `"nextToken"`: Specify the pagination token from a previous request to retrieve the next
  page of results.
"""
function list_metric_attribution_metrics(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return personalize(
        "ListMetricAttributionMetrics";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_metric_attribution_metrics(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return personalize(
        "ListMetricAttributionMetrics",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_metric_attributions()
    list_metric_attributions(params::Dict{String,<:Any})

Lists metric attributions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"datasetGroupArn"`: The metric attributions' dataset group Amazon Resource Name (ARN).
- `"maxResults"`: The maximum number of metric attributions to return in one page of
  results.
- `"nextToken"`: Specify the pagination token from a previous request to retrieve the next
  page of results.
"""
function list_metric_attributions(; aws_config::AbstractAWSConfig=current_aws_config())
    return personalize(
        "ListMetricAttributions"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_metric_attributions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return personalize(
        "ListMetricAttributions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_recipes()
    list_recipes(params::Dict{String,<:Any})

Returns a list of available recipes. The response provides the properties for each recipe,
including the recipe's Amazon Resource Name (ARN).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"domain"`:  Filters returned recipes by domain for a Domain dataset group. Only recipes
  (Domain dataset group use cases) for this domain are included in the response. If you don't
  specify a domain, all recipes are returned.
- `"maxResults"`: The maximum number of recipes to return.
- `"nextToken"`: A token returned from the previous call to ListRecipes for getting the
  next set of recipes (if they exist).
- `"recipeProvider"`: The default is SERVICE.
"""
function list_recipes(; aws_config::AbstractAWSConfig=current_aws_config())
    return personalize(
        "ListRecipes"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_recipes(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return personalize(
        "ListRecipes", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_recommenders()
    list_recommenders(params::Dict{String,<:Any})

Returns a list of recommenders in a given Domain dataset group. When a Domain dataset group
is not specified, all the recommenders associated with the account are listed. The response
provides the properties for each recommender, including the Amazon Resource Name (ARN). For
more information on recommenders, see CreateRecommender.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"datasetGroupArn"`: The Amazon Resource Name (ARN) of the Domain dataset group to list
  the recommenders for. When a Domain dataset group is not specified, all the recommenders
  associated with the account are listed.
- `"maxResults"`: The maximum number of recommenders to return.
- `"nextToken"`: A token returned from the previous call to ListRecommenders for getting
  the next set of recommenders (if they exist).
"""
function list_recommenders(; aws_config::AbstractAWSConfig=current_aws_config())
    return personalize(
        "ListRecommenders"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_recommenders(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return personalize(
        "ListRecommenders", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_schemas()
    list_schemas(params::Dict{String,<:Any})

Returns the list of schemas associated with the account. The response provides the
properties for each schema, including the Amazon Resource Name (ARN). For more information
on schemas, see CreateSchema.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of schemas to return.
- `"nextToken"`: A token returned from the previous call to ListSchemas for getting the
  next set of schemas (if they exist).
"""
function list_schemas(; aws_config::AbstractAWSConfig=current_aws_config())
    return personalize(
        "ListSchemas"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_schemas(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return personalize(
        "ListSchemas", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_solution_versions()
    list_solution_versions(params::Dict{String,<:Any})

Returns a list of solution versions for the given solution. When a solution is not
specified, all the solution versions associated with the account are listed. The response
provides the properties for each solution version, including the Amazon Resource Name (ARN).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of solution versions to return.
- `"nextToken"`: A token returned from the previous call to ListSolutionVersions for
  getting the next set of solution versions (if they exist).
- `"solutionArn"`: The Amazon Resource Name (ARN) of the solution.
"""
function list_solution_versions(; aws_config::AbstractAWSConfig=current_aws_config())
    return personalize(
        "ListSolutionVersions"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_solution_versions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return personalize(
        "ListSolutionVersions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_solutions()
    list_solutions(params::Dict{String,<:Any})

Returns a list of solutions in a given dataset group. When a dataset group is not
specified, all the solutions associated with the account are listed. The response provides
the properties for each solution, including the Amazon Resource Name (ARN). For more
information on solutions, see CreateSolution.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"datasetGroupArn"`: The Amazon Resource Name (ARN) of the dataset group.
- `"maxResults"`: The maximum number of solutions to return.
- `"nextToken"`: A token returned from the previous call to ListSolutions for getting the
  next set of solutions (if they exist).
"""
function list_solutions(; aws_config::AbstractAWSConfig=current_aws_config())
    return personalize(
        "ListSolutions"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_solutions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return personalize(
        "ListSolutions", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Get a list of tags attached to a resource.

# Arguments
- `resource_arn`: The resource's Amazon Resource Name (ARN).

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return personalize(
        "ListTagsForResource",
        Dict{String,Any}("resourceArn" => resourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceArn" => resourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_recommender(recommender_arn)
    start_recommender(recommender_arn, params::Dict{String,<:Any})

Starts a recommender that is INACTIVE. Starting a recommender does not create any new
models, but resumes billing and automatic retraining for the recommender.

# Arguments
- `recommender_arn`: The Amazon Resource Name (ARN) of the recommender to start.

"""
function start_recommender(
    recommenderArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return personalize(
        "StartRecommender",
        Dict{String,Any}("recommenderArn" => recommenderArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_recommender(
    recommenderArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize(
        "StartRecommender",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("recommenderArn" => recommenderArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_recommender(recommender_arn)
    stop_recommender(recommender_arn, params::Dict{String,<:Any})

Stops a recommender that is ACTIVE. Stopping a recommender halts billing and automatic
retraining for the recommender.

# Arguments
- `recommender_arn`: The Amazon Resource Name (ARN) of the recommender to stop.

"""
function stop_recommender(
    recommenderArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return personalize(
        "StopRecommender",
        Dict{String,Any}("recommenderArn" => recommenderArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_recommender(
    recommenderArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize(
        "StopRecommender",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("recommenderArn" => recommenderArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_solution_version_creation(solution_version_arn)
    stop_solution_version_creation(solution_version_arn, params::Dict{String,<:Any})

Stops creating a solution version that is in a state of CREATE_PENDING or CREATE
IN_PROGRESS.  Depending on the current state of the solution version, the solution version
state changes as follows:   CREATE_PENDING &gt; CREATE_STOPPED or   CREATE_IN_PROGRESS &gt;
CREATE_STOPPING &gt; CREATE_STOPPED   You are billed for all of the training completed up
until you stop the solution version creation. You cannot resume creating a solution version
once it has been stopped.

# Arguments
- `solution_version_arn`: The Amazon Resource Name (ARN) of the solution version you want
  to stop creating.

"""
function stop_solution_version_creation(
    solutionVersionArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return personalize(
        "StopSolutionVersionCreation",
        Dict{String,Any}("solutionVersionArn" => solutionVersionArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_solution_version_creation(
    solutionVersionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize(
        "StopSolutionVersionCreation",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("solutionVersionArn" => solutionVersionArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Add a list of tags to a resource.

# Arguments
- `resource_arn`: The resource's Amazon Resource Name (ARN).
- `tags`: Tags to apply to the resource. For more information see Tagging Amazon
  Personalize resources.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return personalize(
        "TagResource",
        Dict{String,Any}("resourceArn" => resourceArn, "tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceArn" => resourceArn, "tags" => tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes the specified tags that are attached to a resource. For more information, see
Removing tags from Amazon Personalize resources.

# Arguments
- `resource_arn`: The resource's Amazon Resource Name (ARN).
- `tag_keys`: The keys of the tags to be removed.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return personalize(
        "UntagResource",
        Dict{String,Any}("resourceArn" => resourceArn, "tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceArn" => resourceArn, "tagKeys" => tagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_campaign(campaign_arn)
    update_campaign(campaign_arn, params::Dict{String,<:Any})

 Updates a campaign to deploy a retrained solution version with an existing campaign,
change your campaign's minProvisionedTPS, or modify your campaign's configuration. For
example, you can set enableMetadataWithRecommendations to true for an existing campaign.
To update a campaign to start automatically using the latest solution version, specify the
following:   For the SolutionVersionArn parameter, specify the Amazon Resource Name (ARN)
of your solution in SolutionArn/LATEST format.     In the campaignConfig, set
syncWithLatestSolutionVersion to true.    To update a campaign, the campaign status must be
ACTIVE or CREATE FAILED. Check the campaign status using the DescribeCampaign operation.
You can still get recommendations from a campaign while an update is in progress. The
campaign will use the previous solution version and campaign configuration to generate
recommendations until the latest campaign update status is Active.   For more information
about updating a campaign, including code samples, see Updating a campaign. For more
information about campaigns, see Creating a campaign.

# Arguments
- `campaign_arn`: The Amazon Resource Name (ARN) of the campaign.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"campaignConfig"`: The configuration details of a campaign.
- `"minProvisionedTPS"`: Specifies the requested minimum provisioned transactions
  (recommendations) per second that Amazon Personalize will support. A high minProvisionedTPS
  will increase your bill. We recommend starting with 1 for minProvisionedTPS (the default).
  Track your usage using Amazon CloudWatch metrics, and increase the minProvisionedTPS as
  necessary.
- `"solutionVersionArn"`: The Amazon Resource Name (ARN) of a new model to deploy. To
  specify the latest solution version of your solution, specify the ARN of your solution in
  SolutionArn/LATEST format. You must use this format if you set
  syncWithLatestSolutionVersion to True in the CampaignConfig.   To deploy a model that isn't
  the latest solution version of your solution, specify the ARN of the solution version.
  For more information about automatic campaign updates, see Enabling automatic campaign
  updates.
"""
function update_campaign(campaignArn; aws_config::AbstractAWSConfig=current_aws_config())
    return personalize(
        "UpdateCampaign",
        Dict{String,Any}("campaignArn" => campaignArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_campaign(
    campaignArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize(
        "UpdateCampaign",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("campaignArn" => campaignArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_dataset(dataset_arn, schema_arn)
    update_dataset(dataset_arn, schema_arn, params::Dict{String,<:Any})

Update a dataset to replace its schema with a new or existing one. For more information,
see Replacing a dataset's schema.

# Arguments
- `dataset_arn`: The Amazon Resource Name (ARN) of the dataset that you want to update.
- `schema_arn`: The Amazon Resource Name (ARN) of the new schema you want use.

"""
function update_dataset(
    datasetArn, schemaArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return personalize(
        "UpdateDataset",
        Dict{String,Any}("datasetArn" => datasetArn, "schemaArn" => schemaArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_dataset(
    datasetArn,
    schemaArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize(
        "UpdateDataset",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("datasetArn" => datasetArn, "schemaArn" => schemaArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_metric_attribution()
    update_metric_attribution(params::Dict{String,<:Any})

Updates a metric attribution.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"addMetrics"`: Add new metric attributes to the metric attribution.
- `"metricAttributionArn"`: The Amazon Resource Name (ARN) for the metric attribution to
  update.
- `"metricsOutputConfig"`: An output config for the metric attribution.
- `"removeMetrics"`: Remove metric attributes from the metric attribution.
"""
function update_metric_attribution(; aws_config::AbstractAWSConfig=current_aws_config())
    return personalize(
        "UpdateMetricAttribution"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function update_metric_attribution(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return personalize(
        "UpdateMetricAttribution",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_recommender(recommender_arn, recommender_config)
    update_recommender(recommender_arn, recommender_config, params::Dict{String,<:Any})

Updates the recommender to modify the recommender configuration. If you update the
recommender to modify the columns used in training, Amazon Personalize automatically starts
a full retraining of the models backing your recommender. While the update completes, you
can still get recommendations from the recommender. The recommender uses the previous
configuration until the update completes. To track the status of this update, use the
latestRecommenderUpdate returned in the DescribeRecommender operation.

# Arguments
- `recommender_arn`: The Amazon Resource Name (ARN) of the recommender to modify.
- `recommender_config`: The configuration details of the recommender.

"""
function update_recommender(
    recommenderArn, recommenderConfig; aws_config::AbstractAWSConfig=current_aws_config()
)
    return personalize(
        "UpdateRecommender",
        Dict{String,Any}(
            "recommenderArn" => recommenderArn, "recommenderConfig" => recommenderConfig
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_recommender(
    recommenderArn,
    recommenderConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize(
        "UpdateRecommender",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "recommenderArn" => recommenderArn,
                    "recommenderConfig" => recommenderConfig,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: connectparticipant
using AWS.Compat
using AWS.UUIDs

"""
    complete_attachment_upload(attachment_ids, client_token, x-_amz-_bearer)
    complete_attachment_upload(attachment_ids, client_token, x-_amz-_bearer, params::Dict{String,<:Any})

Allows you to confirm that the attachment has been uploaded using the pre-signed URL
provided in StartAttachmentUpload API. A conflict exception is thrown when an attachment
with that identifier is already being uploaded.   ConnectionToken is used for invoking this
API instead of ParticipantToken.  The Amazon Connect Participant Service APIs do not use
Signature Version 4 authentication.

# Arguments
- `attachment_ids`: A list of unique identifiers for the attachments.
- `client_token`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If not provided, the Amazon Web Services SDK populates this
  field. For more information about idempotency, see Making retries safe with idempotent APIs.
- `x-_amz-_bearer`: The authentication token associated with the participant's connection.

"""
function complete_attachment_upload(
    AttachmentIds,
    ClientToken,
    X_Amz_Bearer;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return connectparticipant(
        "POST",
        "/participant/complete-attachment-upload",
        Dict{String,Any}(
            "AttachmentIds" => AttachmentIds,
            "ClientToken" => ClientToken,
            "headers" => Dict{String,Any}("X-Amz-Bearer" => X_Amz_Bearer),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function complete_attachment_upload(
    AttachmentIds,
    ClientToken,
    X_Amz_Bearer,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return connectparticipant(
        "POST",
        "/participant/complete-attachment-upload",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AttachmentIds" => AttachmentIds,
                    "ClientToken" => ClientToken,
                    "headers" => Dict{String,Any}("X-Amz-Bearer" => X_Amz_Bearer),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_participant_connection(x-_amz-_bearer)
    create_participant_connection(x-_amz-_bearer, params::Dict{String,<:Any})

Creates the participant's connection.    ParticipantToken is used for invoking this API
instead of ConnectionToken.  The participant token is valid for the lifetime of the
participant – until they are part of a contact. The response URL for WEBSOCKET Type has a
connect expiry timeout of 100s. Clients must manually connect to the returned websocket URL
and subscribe to the desired topic.  For chat, you need to publish the following on the
established websocket connection:
{\"topic\":\"aws/subscribe\",\"content\":{\"topics\":[\"aws/chat\"]}}  Upon websocket URL
expiry, as specified in the response ConnectionExpiry parameter, clients need to call this
API again to obtain a new websocket URL and perform the same steps as before.  Message
streaming support: This API can also be used together with the StartContactStreaming API to
create a participant connection for chat contacts that are not using a websocket. For more
information about message streaming, Enable real-time chat message streaming in the Amazon
Connect Administrator Guide.  Feature specifications: For information about feature
specifications, such as the allowed number of open websocket connections per participant,
see Feature specifications in the Amazon Connect Administrator Guide.   The Amazon Connect
Participant Service APIs do not use Signature Version 4 authentication.

# Arguments
- `x-_amz-_bearer`: This is a header parameter. The ParticipantToken as obtained from
  StartChatContact API response.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConnectParticipant"`: Amazon Connect Participant is used to mark the participant as
  connected for customer participant in message streaming, as well as for agent or manager
  participant in non-streaming chats.
- `"Type"`: Type of connection information required. If you need CONNECTION_CREDENTIALS
  along with marking participant as connected, pass CONNECTION_CREDENTIALS in Type.
"""
function create_participant_connection(
    X_Amz_Bearer; aws_config::AbstractAWSConfig=current_aws_config()
)
    return connectparticipant(
        "POST",
        "/participant/connection",
        Dict{String,Any}("headers" => Dict{String,Any}("X-Amz-Bearer" => X_Amz_Bearer));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_participant_connection(
    X_Amz_Bearer,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return connectparticipant(
        "POST",
        "/participant/connection",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "headers" => Dict{String,Any}("X-Amz-Bearer" => X_Amz_Bearer)
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_view(view_token, x-_amz-_bearer)
    describe_view(view_token, x-_amz-_bearer, params::Dict{String,<:Any})

Retrieves the view for the specified view token.

# Arguments
- `view_token`: An encrypted token originating from the interactive message of a ShowView
  block operation. Represents the desired view.
- `x-_amz-_bearer`: The connection token.

"""
function describe_view(
    ViewToken, X_Amz_Bearer; aws_config::AbstractAWSConfig=current_aws_config()
)
    return connectparticipant(
        "GET",
        "/participant/views/$(ViewToken)",
        Dict{String,Any}("headers" => Dict{String,Any}("X-Amz-Bearer" => X_Amz_Bearer));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_view(
    ViewToken,
    X_Amz_Bearer,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return connectparticipant(
        "GET",
        "/participant/views/$(ViewToken)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "headers" => Dict{String,Any}("X-Amz-Bearer" => X_Amz_Bearer)
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disconnect_participant(x-_amz-_bearer)
    disconnect_participant(x-_amz-_bearer, params::Dict{String,<:Any})

Disconnects a participant.    ConnectionToken is used for invoking this API instead of
ParticipantToken.  The Amazon Connect Participant Service APIs do not use Signature Version
4 authentication.

# Arguments
- `x-_amz-_bearer`: The authentication token associated with the participant's connection.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If not provided, the Amazon Web Services SDK populates this
  field. For more information about idempotency, see Making retries safe with idempotent APIs.
"""
function disconnect_participant(
    X_Amz_Bearer; aws_config::AbstractAWSConfig=current_aws_config()
)
    return connectparticipant(
        "POST",
        "/participant/disconnect",
        Dict{String,Any}(
            "ClientToken" => string(uuid4()),
            "headers" => Dict{String,Any}("X-Amz-Bearer" => X_Amz_Bearer),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disconnect_participant(
    X_Amz_Bearer,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return connectparticipant(
        "POST",
        "/participant/disconnect",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClientToken" => string(uuid4()),
                    "headers" => Dict{String,Any}("X-Amz-Bearer" => X_Amz_Bearer),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_attachment(attachment_id, x-_amz-_bearer)
    get_attachment(attachment_id, x-_amz-_bearer, params::Dict{String,<:Any})

Provides a pre-signed URL for download of a completed attachment. This is an asynchronous
API for use with active contacts.   ConnectionToken is used for invoking this API instead
of ParticipantToken.  The Amazon Connect Participant Service APIs do not use Signature
Version 4 authentication.

# Arguments
- `attachment_id`: A unique identifier for the attachment.
- `x-_amz-_bearer`: The authentication token associated with the participant's connection.

"""
function get_attachment(
    AttachmentId, X_Amz_Bearer; aws_config::AbstractAWSConfig=current_aws_config()
)
    return connectparticipant(
        "POST",
        "/participant/attachment",
        Dict{String,Any}(
            "AttachmentId" => AttachmentId,
            "headers" => Dict{String,Any}("X-Amz-Bearer" => X_Amz_Bearer),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_attachment(
    AttachmentId,
    X_Amz_Bearer,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return connectparticipant(
        "POST",
        "/participant/attachment",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AttachmentId" => AttachmentId,
                    "headers" => Dict{String,Any}("X-Amz-Bearer" => X_Amz_Bearer),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_transcript(x-_amz-_bearer)
    get_transcript(x-_amz-_bearer, params::Dict{String,<:Any})

Retrieves a transcript of the session, including details about any attachments. For
information about accessing past chat contact transcripts for a persistent chat, see Enable
persistent chat.  If you have a process that consumes events in the transcript of an chat
that has ended, note that chat transcripts contain the following event content types if the
event has occurred during the chat session:
application/vnd.amazonaws.connect.event.participant.left
application/vnd.amazonaws.connect.event.participant.joined
application/vnd.amazonaws.connect.event.chat.ended
application/vnd.amazonaws.connect.event.transfer.succeeded
application/vnd.amazonaws.connect.event.transfer.failed      ConnectionToken is used for
invoking this API instead of ParticipantToken.  The Amazon Connect Participant Service APIs
do not use Signature Version 4 authentication.

# Arguments
- `x-_amz-_bearer`: The authentication token associated with the participant's connection.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ContactId"`: The contactId from the current contact chain for which transcript is
  needed.
- `"MaxResults"`: The maximum number of results to return in the page. Default: 10.
- `"NextToken"`: The pagination token. Use the value returned previously in the next
  subsequent request to retrieve the next set of results.
- `"ScanDirection"`: The direction from StartPosition from which to retrieve message.
  Default: BACKWARD when no StartPosition is provided, FORWARD with StartPosition.
- `"SortOrder"`: The sort order for the records. Default: DESCENDING.
- `"StartPosition"`: A filtering option for where to start.
"""
function get_transcript(X_Amz_Bearer; aws_config::AbstractAWSConfig=current_aws_config())
    return connectparticipant(
        "POST",
        "/participant/transcript",
        Dict{String,Any}("headers" => Dict{String,Any}("X-Amz-Bearer" => X_Amz_Bearer));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_transcript(
    X_Amz_Bearer,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return connectparticipant(
        "POST",
        "/participant/transcript",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "headers" => Dict{String,Any}("X-Amz-Bearer" => X_Amz_Bearer)
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    send_event(content_type, x-_amz-_bearer)
    send_event(content_type, x-_amz-_bearer, params::Dict{String,<:Any})

 The application/vnd.amazonaws.connect.event.connection.acknowledged ContentType will no
longer be supported starting December 31, 2024. This event has been migrated to the
CreateParticipantConnection API using the ConnectParticipant field.  Sends an event.
Message receipts are not supported when there are more than two active participants in the
chat. Using the SendEvent API for message receipts when a supervisor is barged-in will
result in a conflict exception.   ConnectionToken is used for invoking this API instead of
ParticipantToken.  The Amazon Connect Participant Service APIs do not use Signature Version
4 authentication.

# Arguments
- `content_type`: The content type of the request. Supported types are:
  application/vnd.amazonaws.connect.event.typing
  application/vnd.amazonaws.connect.event.connection.acknowledged (will be deprecated on
  December 31, 2024)    application/vnd.amazonaws.connect.event.message.delivered
  application/vnd.amazonaws.connect.event.message.read
- `x-_amz-_bearer`: The authentication token associated with the participant's connection.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If not provided, the Amazon Web Services SDK populates this
  field. For more information about idempotency, see Making retries safe with idempotent APIs.
- `"Content"`: The content of the event to be sent (for example, message text). For content
  related to message receipts, this is supported in the form of a JSON string. Sample
  Content: \"{\"messageId\":\"11111111-aaaa-bbbb-cccc-EXAMPLE01234\"}\"
"""
function send_event(
    ContentType, X_Amz_Bearer; aws_config::AbstractAWSConfig=current_aws_config()
)
    return connectparticipant(
        "POST",
        "/participant/event",
        Dict{String,Any}(
            "ContentType" => ContentType,
            "ClientToken" => string(uuid4()),
            "headers" => Dict{String,Any}("X-Amz-Bearer" => X_Amz_Bearer),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function send_event(
    ContentType,
    X_Amz_Bearer,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return connectparticipant(
        "POST",
        "/participant/event",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ContentType" => ContentType,
                    "ClientToken" => string(uuid4()),
                    "headers" => Dict{String,Any}("X-Amz-Bearer" => X_Amz_Bearer),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    send_message(content, content_type, x-_amz-_bearer)
    send_message(content, content_type, x-_amz-_bearer, params::Dict{String,<:Any})

Sends a message.   ConnectionToken is used for invoking this API instead of
ParticipantToken.  The Amazon Connect Participant Service APIs do not use Signature Version
4 authentication.

# Arguments
- `content`: The content of the message.    For text/plain and text/markdown, the Length
  Constraints are Minimum of 1, Maximum of 1024.    For application/json, the Length
  Constraints are Minimum of 1, Maximum of 12000.    For
  application/vnd.amazonaws.connect.message.interactive.response, the Length Constraints are
  Minimum of 1, Maximum of 12288.
- `content_type`: The type of the content. Supported types are text/plain, text/markdown,
  application/json, and application/vnd.amazonaws.connect.message.interactive.response.
- `x-_amz-_bearer`: The authentication token associated with the connection.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If not provided, the Amazon Web Services SDK populates this
  field. For more information about idempotency, see Making retries safe with idempotent APIs.
"""
function send_message(
    Content, ContentType, X_Amz_Bearer; aws_config::AbstractAWSConfig=current_aws_config()
)
    return connectparticipant(
        "POST",
        "/participant/message",
        Dict{String,Any}(
            "Content" => Content,
            "ContentType" => ContentType,
            "ClientToken" => string(uuid4()),
            "headers" => Dict{String,Any}("X-Amz-Bearer" => X_Amz_Bearer),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function send_message(
    Content,
    ContentType,
    X_Amz_Bearer,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return connectparticipant(
        "POST",
        "/participant/message",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Content" => Content,
                    "ContentType" => ContentType,
                    "ClientToken" => string(uuid4()),
                    "headers" => Dict{String,Any}("X-Amz-Bearer" => X_Amz_Bearer),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_attachment_upload(attachment_name, attachment_size_in_bytes, client_token, content_type, x-_amz-_bearer)
    start_attachment_upload(attachment_name, attachment_size_in_bytes, client_token, content_type, x-_amz-_bearer, params::Dict{String,<:Any})

Provides a pre-signed Amazon S3 URL in response for uploading the file directly to S3.
ConnectionToken is used for invoking this API instead of ParticipantToken.  The Amazon
Connect Participant Service APIs do not use Signature Version 4 authentication.

# Arguments
- `attachment_name`: A case-sensitive name of the attachment being uploaded.
- `attachment_size_in_bytes`: The size of the attachment in bytes.
- `client_token`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If not provided, the Amazon Web Services SDK populates this
  field. For more information about idempotency, see Making retries safe with idempotent APIs.
- `content_type`: Describes the MIME file type of the attachment. For a list of supported
  file types, see Feature specifications in the Amazon Connect Administrator Guide.
- `x-_amz-_bearer`: The authentication token associated with the participant's connection.

"""
function start_attachment_upload(
    AttachmentName,
    AttachmentSizeInBytes,
    ClientToken,
    ContentType,
    X_Amz_Bearer;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return connectparticipant(
        "POST",
        "/participant/start-attachment-upload",
        Dict{String,Any}(
            "AttachmentName" => AttachmentName,
            "AttachmentSizeInBytes" => AttachmentSizeInBytes,
            "ClientToken" => ClientToken,
            "ContentType" => ContentType,
            "headers" => Dict{String,Any}("X-Amz-Bearer" => X_Amz_Bearer),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_attachment_upload(
    AttachmentName,
    AttachmentSizeInBytes,
    ClientToken,
    ContentType,
    X_Amz_Bearer,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return connectparticipant(
        "POST",
        "/participant/start-attachment-upload",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AttachmentName" => AttachmentName,
                    "AttachmentSizeInBytes" => AttachmentSizeInBytes,
                    "ClientToken" => ClientToken,
                    "ContentType" => ContentType,
                    "headers" => Dict{String,Any}("X-Amz-Bearer" => X_Amz_Bearer),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: codepipeline
using AWS.Compat
using AWS.UUIDs

"""
    acknowledge_job(job_id, nonce)
    acknowledge_job(job_id, nonce, params::Dict{String,<:Any})

Returns information about a specified job and whether that job has been received by the job
worker. Used for custom actions only.

# Arguments
- `job_id`: The unique system-generated ID of the job for which you want to confirm receipt.
- `nonce`: A system-generated random number that CodePipeline uses to ensure that the job
  is being worked on by only one job worker. Get this number from the response of the
  PollForJobs request that returned this job.

"""
function acknowledge_job(jobId, nonce; aws_config::AbstractAWSConfig=current_aws_config())
    return codepipeline(
        "AcknowledgeJob",
        Dict{String,Any}("jobId" => jobId, "nonce" => nonce);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function acknowledge_job(
    jobId,
    nonce,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codepipeline(
        "AcknowledgeJob",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("jobId" => jobId, "nonce" => nonce), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    acknowledge_third_party_job(client_token, job_id, nonce)
    acknowledge_third_party_job(client_token, job_id, nonce, params::Dict{String,<:Any})

Confirms a job worker has received the specified job. Used for partner actions only.

# Arguments
- `client_token`: The clientToken portion of the clientId and clientToken pair used to
  verify that the calling entity is allowed access to the job and its details.
- `job_id`: The unique system-generated ID of the job.
- `nonce`: A system-generated random number that CodePipeline uses to ensure that the job
  is being worked on by only one job worker. Get this number from the response to a
  GetThirdPartyJobDetails request.

"""
function acknowledge_third_party_job(
    clientToken, jobId, nonce; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codepipeline(
        "AcknowledgeThirdPartyJob",
        Dict{String,Any}("clientToken" => clientToken, "jobId" => jobId, "nonce" => nonce);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function acknowledge_third_party_job(
    clientToken,
    jobId,
    nonce,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codepipeline(
        "AcknowledgeThirdPartyJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "clientToken" => clientToken, "jobId" => jobId, "nonce" => nonce
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_custom_action_type(category, input_artifact_details, output_artifact_details, provider, version)
    create_custom_action_type(category, input_artifact_details, output_artifact_details, provider, version, params::Dict{String,<:Any})

Creates a new custom action that can be used in all pipelines associated with the Amazon
Web Services account. Only used for custom actions.

# Arguments
- `category`: The category of the custom action, such as a build action or a test action.
- `input_artifact_details`: The details of the input artifact for the action, such as its
  commit ID.
- `output_artifact_details`: The details of the output artifact of the action, such as its
  commit ID.
- `provider`: The provider of the service used in the custom action, such as CodeDeploy.
- `version`: The version identifier of the custom action.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"configurationProperties"`: The configuration properties for the custom action.  You can
  refer to a name in the configuration properties of the custom action within the URL
  templates by following the format of {Config:name}, as long as the configuration property
  is both required and not secret. For more information, see Create a Custom Action for a
  Pipeline.
- `"settings"`: URLs that provide users information about this custom action.
- `"tags"`: The tags for the custom action.
"""
function create_custom_action_type(
    category,
    inputArtifactDetails,
    outputArtifactDetails,
    provider,
    version;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codepipeline(
        "CreateCustomActionType",
        Dict{String,Any}(
            "category" => category,
            "inputArtifactDetails" => inputArtifactDetails,
            "outputArtifactDetails" => outputArtifactDetails,
            "provider" => provider,
            "version" => version,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_custom_action_type(
    category,
    inputArtifactDetails,
    outputArtifactDetails,
    provider,
    version,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codepipeline(
        "CreateCustomActionType",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "category" => category,
                    "inputArtifactDetails" => inputArtifactDetails,
                    "outputArtifactDetails" => outputArtifactDetails,
                    "provider" => provider,
                    "version" => version,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_pipeline(pipeline)
    create_pipeline(pipeline, params::Dict{String,<:Any})

Creates a pipeline.  In the pipeline structure, you must include either artifactStore or
artifactStores in your pipeline, but you cannot use both. If you create a cross-region
action in your pipeline, you must use artifactStores.

# Arguments
- `pipeline`: Represents the structure of actions and stages to be performed in the
  pipeline.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tags"`: The tags for the pipeline.
"""
function create_pipeline(pipeline; aws_config::AbstractAWSConfig=current_aws_config())
    return codepipeline(
        "CreatePipeline",
        Dict{String,Any}("pipeline" => pipeline);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_pipeline(
    pipeline,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codepipeline(
        "CreatePipeline",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("pipeline" => pipeline), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_custom_action_type(category, provider, version)
    delete_custom_action_type(category, provider, version, params::Dict{String,<:Any})

Marks a custom action as deleted. PollForJobs for the custom action fails after the action
is marked for deletion. Used for custom actions only.  To re-create a custom action after
it has been deleted you must use a string in the version field that has never been used
before. This string can be an incremented version number, for example. To restore a deleted
custom action, use a JSON file that is identical to the deleted action, including the
original string in the version field.

# Arguments
- `category`: The category of the custom action that you want to delete, such as source or
  deploy.
- `provider`: The provider of the service used in the custom action, such as CodeDeploy.
- `version`: The version of the custom action to delete.

"""
function delete_custom_action_type(
    category, provider, version; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codepipeline(
        "DeleteCustomActionType",
        Dict{String,Any}(
            "category" => category, "provider" => provider, "version" => version
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_custom_action_type(
    category,
    provider,
    version,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codepipeline(
        "DeleteCustomActionType",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "category" => category, "provider" => provider, "version" => version
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_pipeline(name)
    delete_pipeline(name, params::Dict{String,<:Any})

Deletes the specified pipeline.

# Arguments
- `name`: The name of the pipeline to be deleted.

"""
function delete_pipeline(name; aws_config::AbstractAWSConfig=current_aws_config())
    return codepipeline(
        "DeletePipeline",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_pipeline(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codepipeline(
        "DeletePipeline",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_webhook(name)
    delete_webhook(name, params::Dict{String,<:Any})

Deletes a previously created webhook by name. Deleting the webhook stops CodePipeline from
starting a pipeline every time an external event occurs. The API returns successfully when
trying to delete a webhook that is already deleted. If a deleted webhook is re-created by
calling PutWebhook with the same name, it will have a different URL.

# Arguments
- `name`: The name of the webhook you want to delete.

"""
function delete_webhook(name; aws_config::AbstractAWSConfig=current_aws_config())
    return codepipeline(
        "DeleteWebhook",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_webhook(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codepipeline(
        "DeleteWebhook",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    deregister_webhook_with_third_party()
    deregister_webhook_with_third_party(params::Dict{String,<:Any})

Removes the connection between the webhook that was created by CodePipeline and the
external tool with events to be detected. Currently supported only for webhooks that target
an action type of GitHub.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"webhookName"`: The name of the webhook you want to deregister.
"""
function deregister_webhook_with_third_party(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return codepipeline(
        "DeregisterWebhookWithThirdParty";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function deregister_webhook_with_third_party(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codepipeline(
        "DeregisterWebhookWithThirdParty",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disable_stage_transition(pipeline_name, reason, stage_name, transition_type)
    disable_stage_transition(pipeline_name, reason, stage_name, transition_type, params::Dict{String,<:Any})

Prevents artifacts in a pipeline from transitioning to the next stage in the pipeline.

# Arguments
- `pipeline_name`: The name of the pipeline in which you want to disable the flow of
  artifacts from one stage to another.
- `reason`: The reason given to the user that a stage is disabled, such as waiting for
  manual approval or manual tests. This message is displayed in the pipeline console UI.
- `stage_name`: The name of the stage where you want to disable the inbound or outbound
  transition of artifacts.
- `transition_type`: Specifies whether artifacts are prevented from transitioning into the
  stage and being processed by the actions in that stage (inbound), or prevented from
  transitioning from the stage after they have been processed by the actions in that stage
  (outbound).

"""
function disable_stage_transition(
    pipelineName,
    reason,
    stageName,
    transitionType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codepipeline(
        "DisableStageTransition",
        Dict{String,Any}(
            "pipelineName" => pipelineName,
            "reason" => reason,
            "stageName" => stageName,
            "transitionType" => transitionType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disable_stage_transition(
    pipelineName,
    reason,
    stageName,
    transitionType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codepipeline(
        "DisableStageTransition",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "pipelineName" => pipelineName,
                    "reason" => reason,
                    "stageName" => stageName,
                    "transitionType" => transitionType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    enable_stage_transition(pipeline_name, stage_name, transition_type)
    enable_stage_transition(pipeline_name, stage_name, transition_type, params::Dict{String,<:Any})

Enables artifacts in a pipeline to transition to a stage in a pipeline.

# Arguments
- `pipeline_name`: The name of the pipeline in which you want to enable the flow of
  artifacts from one stage to another.
- `stage_name`: The name of the stage where you want to enable the transition of artifacts,
  either into the stage (inbound) or from that stage to the next stage (outbound).
- `transition_type`: Specifies whether artifacts are allowed to enter the stage and be
  processed by the actions in that stage (inbound) or whether already processed artifacts are
  allowed to transition to the next stage (outbound).

"""
function enable_stage_transition(
    pipelineName,
    stageName,
    transitionType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codepipeline(
        "EnableStageTransition",
        Dict{String,Any}(
            "pipelineName" => pipelineName,
            "stageName" => stageName,
            "transitionType" => transitionType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function enable_stage_transition(
    pipelineName,
    stageName,
    transitionType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codepipeline(
        "EnableStageTransition",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "pipelineName" => pipelineName,
                    "stageName" => stageName,
                    "transitionType" => transitionType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_action_type(category, owner, provider, version)
    get_action_type(category, owner, provider, version, params::Dict{String,<:Any})

Returns information about an action type created for an external provider, where the action
is to be used by customers of the external provider. The action can be created with any
supported integration model.

# Arguments
- `category`: Defines what kind of action can be taken in the stage. The following are the
  valid values:    Source     Build     Test     Deploy     Approval     Invoke
- `owner`: The creator of an action type that was created with any supported integration
  model. There are two valid values: AWS and ThirdParty.
- `provider`: The provider of the action type being called. The provider name is specified
  when the action type is created.
- `version`: A string that describes the action type version.

"""
function get_action_type(
    category, owner, provider, version; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codepipeline(
        "GetActionType",
        Dict{String,Any}(
            "category" => category,
            "owner" => owner,
            "provider" => provider,
            "version" => version,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_action_type(
    category,
    owner,
    provider,
    version,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codepipeline(
        "GetActionType",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "category" => category,
                    "owner" => owner,
                    "provider" => provider,
                    "version" => version,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_job_details(job_id)
    get_job_details(job_id, params::Dict{String,<:Any})

Returns information about a job. Used for custom actions only.  When this API is called,
CodePipeline returns temporary credentials for the S3 bucket used to store artifacts for
the pipeline, if the action requires access to that S3 bucket for input or output
artifacts. This API also returns any secret values defined for the action.

# Arguments
- `job_id`: The unique system-generated ID for the job.

"""
function get_job_details(jobId; aws_config::AbstractAWSConfig=current_aws_config())
    return codepipeline(
        "GetJobDetails",
        Dict{String,Any}("jobId" => jobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_job_details(
    jobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codepipeline(
        "GetJobDetails",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("jobId" => jobId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_pipeline(name)
    get_pipeline(name, params::Dict{String,<:Any})

Returns the metadata, structure, stages, and actions of a pipeline. Can be used to return
the entire structure of a pipeline in JSON format, which can then be modified and used to
update the pipeline structure with UpdatePipeline.

# Arguments
- `name`: The name of the pipeline for which you want to get information. Pipeline names
  must be unique in an Amazon Web Services account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"version"`: The version number of the pipeline. If you do not specify a version,
  defaults to the current version.
"""
function get_pipeline(name; aws_config::AbstractAWSConfig=current_aws_config())
    return codepipeline(
        "GetPipeline",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_pipeline(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codepipeline(
        "GetPipeline",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_pipeline_execution(pipeline_execution_id, pipeline_name)
    get_pipeline_execution(pipeline_execution_id, pipeline_name, params::Dict{String,<:Any})

Returns information about an execution of a pipeline, including details about artifacts,
the pipeline execution ID, and the name, version, and status of the pipeline.

# Arguments
- `pipeline_execution_id`: The ID of the pipeline execution about which you want to get
  execution details.
- `pipeline_name`: The name of the pipeline about which you want to get execution details.

"""
function get_pipeline_execution(
    pipelineExecutionId, pipelineName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codepipeline(
        "GetPipelineExecution",
        Dict{String,Any}(
            "pipelineExecutionId" => pipelineExecutionId, "pipelineName" => pipelineName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_pipeline_execution(
    pipelineExecutionId,
    pipelineName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codepipeline(
        "GetPipelineExecution",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "pipelineExecutionId" => pipelineExecutionId,
                    "pipelineName" => pipelineName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_pipeline_state(name)
    get_pipeline_state(name, params::Dict{String,<:Any})

Returns information about the state of a pipeline, including the stages and actions.
Values returned in the revisionId and revisionUrl fields indicate the source revision
information, such as the commit ID, for the current state.

# Arguments
- `name`: The name of the pipeline about which you want to get information.

"""
function get_pipeline_state(name; aws_config::AbstractAWSConfig=current_aws_config())
    return codepipeline(
        "GetPipelineState",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_pipeline_state(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codepipeline(
        "GetPipelineState",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_third_party_job_details(client_token, job_id)
    get_third_party_job_details(client_token, job_id, params::Dict{String,<:Any})

Requests the details of a job for a third party action. Used for partner actions only.
When this API is called, CodePipeline returns temporary credentials for the S3 bucket used
to store artifacts for the pipeline, if the action requires access to that S3 bucket for
input or output artifacts. This API also returns any secret values defined for the action.

# Arguments
- `client_token`: The clientToken portion of the clientId and clientToken pair used to
  verify that the calling entity is allowed access to the job and its details.
- `job_id`: The unique system-generated ID used for identifying the job.

"""
function get_third_party_job_details(
    clientToken, jobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codepipeline(
        "GetThirdPartyJobDetails",
        Dict{String,Any}("clientToken" => clientToken, "jobId" => jobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_third_party_job_details(
    clientToken,
    jobId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codepipeline(
        "GetThirdPartyJobDetails",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("clientToken" => clientToken, "jobId" => jobId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_action_executions(pipeline_name)
    list_action_executions(pipeline_name, params::Dict{String,<:Any})

Lists the action executions that have occurred in a pipeline.

# Arguments
- `pipeline_name`:  The name of the pipeline for which you want to list action execution
  history.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filter"`: Input information used to filter action execution history.
- `"maxResults"`: The maximum number of results to return in a single call. To retrieve the
  remaining results, make another call with the returned nextToken value. Action execution
  history is retained for up to 12 months, based on action execution start times. Default
  value is 100.
- `"nextToken"`: The token that was returned from the previous ListActionExecutions call,
  which can be used to return the next set of action executions in the list.
"""
function list_action_executions(
    pipelineName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codepipeline(
        "ListActionExecutions",
        Dict{String,Any}("pipelineName" => pipelineName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_action_executions(
    pipelineName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codepipeline(
        "ListActionExecutions",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("pipelineName" => pipelineName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_action_types()
    list_action_types(params::Dict{String,<:Any})

Gets a summary of all CodePipeline action types associated with your account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"actionOwnerFilter"`: Filters the list of action types to those created by a specified
  entity.
- `"nextToken"`: An identifier that was returned from the previous list action types call,
  which can be used to return the next set of action types in the list.
- `"regionFilter"`: The Region to filter on for the list of action types.
"""
function list_action_types(; aws_config::AbstractAWSConfig=current_aws_config())
    return codepipeline(
        "ListActionTypes"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_action_types(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codepipeline(
        "ListActionTypes", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_pipeline_executions(pipeline_name)
    list_pipeline_executions(pipeline_name, params::Dict{String,<:Any})

Gets a summary of the most recent executions for a pipeline.  When applying the filter for
pipeline executions that have succeeded in the stage, the operation returns all executions
in the current pipeline version beginning on February 1, 2024.

# Arguments
- `pipeline_name`: The name of the pipeline for which you want to get execution summary
  information.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filter"`: The pipeline execution to filter on.
- `"maxResults"`: The maximum number of results to return in a single call. To retrieve the
  remaining results, make another call with the returned nextToken value. Pipeline history is
  limited to the most recent 12 months, based on pipeline execution start times. Default
  value is 100.
- `"nextToken"`: The token that was returned from the previous ListPipelineExecutions call,
  which can be used to return the next set of pipeline executions in the list.
"""
function list_pipeline_executions(
    pipelineName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codepipeline(
        "ListPipelineExecutions",
        Dict{String,Any}("pipelineName" => pipelineName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_pipeline_executions(
    pipelineName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codepipeline(
        "ListPipelineExecutions",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("pipelineName" => pipelineName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_pipelines()
    list_pipelines(params::Dict{String,<:Any})

Gets a summary of all of the pipelines associated with your account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of pipelines to return in a single call. To retrieve
  the remaining pipelines, make another call with the returned nextToken value. The minimum
  value you can specify is 1. The maximum accepted value is 1000.
- `"nextToken"`: An identifier that was returned from the previous list pipelines call. It
  can be used to return the next set of pipelines in the list.
"""
function list_pipelines(; aws_config::AbstractAWSConfig=current_aws_config())
    return codepipeline(
        "ListPipelines"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_pipelines(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codepipeline(
        "ListPipelines", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Gets the set of key-value pairs (metadata) that are used to manage the resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource to get tags for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in a single call.
- `"nextToken"`: The token that was returned from the previous API call, which would be
  used to return the next page of the list. The ListTagsforResource call lists all available
  tags in one call and does not use pagination.
"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codepipeline(
        "ListTagsForResource",
        Dict{String,Any}("resourceArn" => resourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codepipeline(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceArn" => resourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_webhooks()
    list_webhooks(params::Dict{String,<:Any})

Gets a listing of all the webhooks in this Amazon Web Services Region for this account. The
output lists all webhooks and includes the webhook URL and ARN and the configuration for
each webhook.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to return in a single call. To retrieve the
  remaining results, make another call with the returned nextToken value.
- `"NextToken"`: The token that was returned from the previous ListWebhooks call, which can
  be used to return the next set of webhooks in the list.
"""
function list_webhooks(; aws_config::AbstractAWSConfig=current_aws_config())
    return codepipeline(
        "ListWebhooks"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_webhooks(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codepipeline(
        "ListWebhooks", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    poll_for_jobs(action_type_id)
    poll_for_jobs(action_type_id, params::Dict{String,<:Any})

Returns information about any jobs for CodePipeline to act on. PollForJobs is valid only
for action types with \"Custom\" in the owner field. If the action type contains AWS or
ThirdParty in the owner field, the PollForJobs action returns an error.  When this API is
called, CodePipeline returns temporary credentials for the S3 bucket used to store
artifacts for the pipeline, if the action requires access to that S3 bucket for input or
output artifacts. This API also returns any secret values defined for the action.

# Arguments
- `action_type_id`: Represents information about an action type.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxBatchSize"`: The maximum number of jobs to return in a poll for jobs call.
- `"queryParam"`: A map of property names and values. For an action type with no queryable
  properties, this value must be null or an empty map. For an action type with a queryable
  property, you must supply that property as a key in the map. Only jobs whose action
  configuration matches the mapped value are returned.
"""
function poll_for_jobs(actionTypeId; aws_config::AbstractAWSConfig=current_aws_config())
    return codepipeline(
        "PollForJobs",
        Dict{String,Any}("actionTypeId" => actionTypeId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function poll_for_jobs(
    actionTypeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codepipeline(
        "PollForJobs",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("actionTypeId" => actionTypeId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    poll_for_third_party_jobs(action_type_id)
    poll_for_third_party_jobs(action_type_id, params::Dict{String,<:Any})

Determines whether there are any third party jobs for a job worker to act on. Used for
partner actions only.  When this API is called, CodePipeline returns temporary credentials
for the S3 bucket used to store artifacts for the pipeline, if the action requires access
to that S3 bucket for input or output artifacts.

# Arguments
- `action_type_id`: Represents information about an action type.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxBatchSize"`: The maximum number of jobs to return in a poll for jobs call.
"""
function poll_for_third_party_jobs(
    actionTypeId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codepipeline(
        "PollForThirdPartyJobs",
        Dict{String,Any}("actionTypeId" => actionTypeId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function poll_for_third_party_jobs(
    actionTypeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codepipeline(
        "PollForThirdPartyJobs",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("actionTypeId" => actionTypeId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_action_revision(action_name, action_revision, pipeline_name, stage_name)
    put_action_revision(action_name, action_revision, pipeline_name, stage_name, params::Dict{String,<:Any})

Provides information to CodePipeline about new revisions to a source.

# Arguments
- `action_name`: The name of the action that processes the revision.
- `action_revision`: Represents information about the version (or revision) of an action.
- `pipeline_name`: The name of the pipeline that starts processing the revision to the
  source.
- `stage_name`: The name of the stage that contains the action that acts on the revision.

"""
function put_action_revision(
    actionName,
    actionRevision,
    pipelineName,
    stageName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codepipeline(
        "PutActionRevision",
        Dict{String,Any}(
            "actionName" => actionName,
            "actionRevision" => actionRevision,
            "pipelineName" => pipelineName,
            "stageName" => stageName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_action_revision(
    actionName,
    actionRevision,
    pipelineName,
    stageName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codepipeline(
        "PutActionRevision",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "actionName" => actionName,
                    "actionRevision" => actionRevision,
                    "pipelineName" => pipelineName,
                    "stageName" => stageName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_approval_result(action_name, pipeline_name, result, stage_name, token)
    put_approval_result(action_name, pipeline_name, result, stage_name, token, params::Dict{String,<:Any})

Provides the response to a manual approval request to CodePipeline. Valid responses include
Approved and Rejected.

# Arguments
- `action_name`: The name of the action for which approval is requested.
- `pipeline_name`: The name of the pipeline that contains the action.
- `result`: Represents information about the result of the approval request.
- `stage_name`: The name of the stage that contains the action.
- `token`: The system-generated token used to identify a unique approval request. The token
  for each open approval request can be obtained using the GetPipelineState action. It is
  used to validate that the approval request corresponding to this token is still valid.

"""
function put_approval_result(
    actionName,
    pipelineName,
    result,
    stageName,
    token;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codepipeline(
        "PutApprovalResult",
        Dict{String,Any}(
            "actionName" => actionName,
            "pipelineName" => pipelineName,
            "result" => result,
            "stageName" => stageName,
            "token" => token,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_approval_result(
    actionName,
    pipelineName,
    result,
    stageName,
    token,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codepipeline(
        "PutApprovalResult",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "actionName" => actionName,
                    "pipelineName" => pipelineName,
                    "result" => result,
                    "stageName" => stageName,
                    "token" => token,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_job_failure_result(failure_details, job_id)
    put_job_failure_result(failure_details, job_id, params::Dict{String,<:Any})

Represents the failure of a job as returned to the pipeline by a job worker. Used for
custom actions only.

# Arguments
- `failure_details`: The details about the failure of a job.
- `job_id`: The unique system-generated ID of the job that failed. This is the same ID
  returned from PollForJobs.

"""
function put_job_failure_result(
    failureDetails, jobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codepipeline(
        "PutJobFailureResult",
        Dict{String,Any}("failureDetails" => failureDetails, "jobId" => jobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_job_failure_result(
    failureDetails,
    jobId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codepipeline(
        "PutJobFailureResult",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("failureDetails" => failureDetails, "jobId" => jobId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_job_success_result(job_id)
    put_job_success_result(job_id, params::Dict{String,<:Any})

Represents the success of a job as returned to the pipeline by a job worker. Used for
custom actions only.

# Arguments
- `job_id`: The unique system-generated ID of the job that succeeded. This is the same ID
  returned from PollForJobs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"continuationToken"`: A token generated by a job worker, such as a CodeDeploy deployment
  ID, that a successful job provides to identify a custom action in progress. Future jobs use
  this token to identify the running instance of the action. It can be reused to return more
  information about the progress of the custom action. When the action is complete, no
  continuation token should be supplied.
- `"currentRevision"`: The ID of the current revision of the artifact successfully worked
  on by the job.
- `"executionDetails"`: The execution details of the successful job, such as the actions
  taken by the job worker.
- `"outputVariables"`: Key-value pairs produced as output by a job worker that can be made
  available to a downstream action configuration. outputVariables can be included only when
  there is no continuation token on the request.
"""
function put_job_success_result(jobId; aws_config::AbstractAWSConfig=current_aws_config())
    return codepipeline(
        "PutJobSuccessResult",
        Dict{String,Any}("jobId" => jobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_job_success_result(
    jobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codepipeline(
        "PutJobSuccessResult",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("jobId" => jobId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_third_party_job_failure_result(client_token, failure_details, job_id)
    put_third_party_job_failure_result(client_token, failure_details, job_id, params::Dict{String,<:Any})

Represents the failure of a third party job as returned to the pipeline by a job worker.
Used for partner actions only.

# Arguments
- `client_token`: The clientToken portion of the clientId and clientToken pair used to
  verify that the calling entity is allowed access to the job and its details.
- `failure_details`: Represents information about failure details.
- `job_id`: The ID of the job that failed. This is the same ID returned from
  PollForThirdPartyJobs.

"""
function put_third_party_job_failure_result(
    clientToken, failureDetails, jobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codepipeline(
        "PutThirdPartyJobFailureResult",
        Dict{String,Any}(
            "clientToken" => clientToken,
            "failureDetails" => failureDetails,
            "jobId" => jobId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_third_party_job_failure_result(
    clientToken,
    failureDetails,
    jobId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codepipeline(
        "PutThirdPartyJobFailureResult",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "clientToken" => clientToken,
                    "failureDetails" => failureDetails,
                    "jobId" => jobId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_third_party_job_success_result(client_token, job_id)
    put_third_party_job_success_result(client_token, job_id, params::Dict{String,<:Any})

Represents the success of a third party job as returned to the pipeline by a job worker.
Used for partner actions only.

# Arguments
- `client_token`: The clientToken portion of the clientId and clientToken pair used to
  verify that the calling entity is allowed access to the job and its details.
- `job_id`: The ID of the job that successfully completed. This is the same ID returned
  from PollForThirdPartyJobs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"continuationToken"`: A token generated by a job worker, such as a CodeDeploy deployment
  ID, that a successful job provides to identify a partner action in progress. Future jobs
  use this token to identify the running instance of the action. It can be reused to return
  more information about the progress of the partner action. When the action is complete, no
  continuation token should be supplied.
- `"currentRevision"`: Represents information about a current revision.
- `"executionDetails"`: The details of the actions taken and results produced on an
  artifact as it passes through stages in the pipeline.
"""
function put_third_party_job_success_result(
    clientToken, jobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codepipeline(
        "PutThirdPartyJobSuccessResult",
        Dict{String,Any}("clientToken" => clientToken, "jobId" => jobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_third_party_job_success_result(
    clientToken,
    jobId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codepipeline(
        "PutThirdPartyJobSuccessResult",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("clientToken" => clientToken, "jobId" => jobId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_webhook(webhook)
    put_webhook(webhook, params::Dict{String,<:Any})

Defines a webhook and returns a unique webhook URL generated by CodePipeline. This URL can
be supplied to third party source hosting providers to call every time there's a code
change. When CodePipeline receives a POST request on this URL, the pipeline defined in the
webhook is started as long as the POST request satisfied the authentication and filtering
requirements supplied when defining the webhook. RegisterWebhookWithThirdParty and
DeregisterWebhookWithThirdParty APIs can be used to automatically configure supported third
parties to call the generated webhook URL.

# Arguments
- `webhook`: The detail provided in an input file to create the webhook, such as the
  webhook name, the pipeline name, and the action name. Give the webhook a unique name that
  helps you identify it. You might name the webhook after the pipeline and action it targets
  so that you can easily recognize what it's used for later.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tags"`: The tags for the webhook.
"""
function put_webhook(webhook; aws_config::AbstractAWSConfig=current_aws_config())
    return codepipeline(
        "PutWebhook",
        Dict{String,Any}("webhook" => webhook);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_webhook(
    webhook,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codepipeline(
        "PutWebhook",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("webhook" => webhook), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    register_webhook_with_third_party()
    register_webhook_with_third_party(params::Dict{String,<:Any})

Configures a connection between the webhook that was created and the external tool with
events to be detected.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"webhookName"`: The name of an existing webhook created with PutWebhook to register with
  a supported third party.
"""
function register_webhook_with_third_party(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return codepipeline(
        "RegisterWebhookWithThirdParty";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function register_webhook_with_third_party(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codepipeline(
        "RegisterWebhookWithThirdParty",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    retry_stage_execution(pipeline_execution_id, pipeline_name, retry_mode, stage_name)
    retry_stage_execution(pipeline_execution_id, pipeline_name, retry_mode, stage_name, params::Dict{String,<:Any})

You can retry a stage that has failed without having to run a pipeline again from the
beginning. You do this by either retrying the failed actions in a stage or by retrying all
actions in the stage starting from the first action in the stage. When you retry the failed
actions in a stage, all actions that are still in progress continue working, and failed
actions are triggered again. When you retry a failed stage from the first action in the
stage, the stage cannot have any actions in progress. Before a stage can be retried, it
must either have all actions failed or some actions failed and some succeeded.

# Arguments
- `pipeline_execution_id`: The ID of the pipeline execution in the failed stage to be
  retried. Use the GetPipelineState action to retrieve the current pipelineExecutionId of the
  failed stage
- `pipeline_name`: The name of the pipeline that contains the failed stage.
- `retry_mode`: The scope of the retry attempt.
- `stage_name`: The name of the failed stage to be retried.

"""
function retry_stage_execution(
    pipelineExecutionId,
    pipelineName,
    retryMode,
    stageName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codepipeline(
        "RetryStageExecution",
        Dict{String,Any}(
            "pipelineExecutionId" => pipelineExecutionId,
            "pipelineName" => pipelineName,
            "retryMode" => retryMode,
            "stageName" => stageName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function retry_stage_execution(
    pipelineExecutionId,
    pipelineName,
    retryMode,
    stageName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codepipeline(
        "RetryStageExecution",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "pipelineExecutionId" => pipelineExecutionId,
                    "pipelineName" => pipelineName,
                    "retryMode" => retryMode,
                    "stageName" => stageName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    rollback_stage(pipeline_name, stage_name, target_pipeline_execution_id)
    rollback_stage(pipeline_name, stage_name, target_pipeline_execution_id, params::Dict{String,<:Any})

Rolls back a stage execution.

# Arguments
- `pipeline_name`: The name of the pipeline for which the stage will be rolled back.
- `stage_name`: The name of the stage in the pipeline to be rolled back.
- `target_pipeline_execution_id`: The pipeline execution ID for the stage to be rolled back
  to.

"""
function rollback_stage(
    pipelineName,
    stageName,
    targetPipelineExecutionId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codepipeline(
        "RollbackStage",
        Dict{String,Any}(
            "pipelineName" => pipelineName,
            "stageName" => stageName,
            "targetPipelineExecutionId" => targetPipelineExecutionId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function rollback_stage(
    pipelineName,
    stageName,
    targetPipelineExecutionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codepipeline(
        "RollbackStage",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "pipelineName" => pipelineName,
                    "stageName" => stageName,
                    "targetPipelineExecutionId" => targetPipelineExecutionId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_pipeline_execution(name)
    start_pipeline_execution(name, params::Dict{String,<:Any})

Starts the specified pipeline. Specifically, it begins processing the latest commit to the
source location specified as part of the pipeline.

# Arguments
- `name`: The name of the pipeline to start.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientRequestToken"`: The system-generated unique ID used to identify a unique
  execution request.
- `"sourceRevisions"`: A list that allows you to specify, or override, the source revision
  for a pipeline execution that's being started. A source revision is the version with all
  the changes to your application code, or source artifact, for the pipeline execution.
- `"variables"`: A list that overrides pipeline variables for a pipeline execution that's
  being started. Variable names must match [A-Za-z0-9@-_]+, and the values can be anything
  except an empty string.
"""
function start_pipeline_execution(name; aws_config::AbstractAWSConfig=current_aws_config())
    return codepipeline(
        "StartPipelineExecution",
        Dict{String,Any}("name" => name, "clientRequestToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_pipeline_execution(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codepipeline(
        "StartPipelineExecution",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("name" => name, "clientRequestToken" => string(uuid4())),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_pipeline_execution(pipeline_execution_id, pipeline_name)
    stop_pipeline_execution(pipeline_execution_id, pipeline_name, params::Dict{String,<:Any})

Stops the specified pipeline execution. You choose to either stop the pipeline execution by
completing in-progress actions without starting subsequent actions, or by abandoning
in-progress actions. While completing or abandoning in-progress actions, the pipeline
execution is in a Stopping state. After all in-progress actions are completed or abandoned,
the pipeline execution is in a Stopped state.

# Arguments
- `pipeline_execution_id`: The ID of the pipeline execution to be stopped in the current
  stage. Use the GetPipelineState action to retrieve the current pipelineExecutionId.
- `pipeline_name`: The name of the pipeline to stop.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"abandon"`: Use this option to stop the pipeline execution by abandoning, rather than
  finishing, in-progress actions.  This option can lead to failed or out-of-sequence tasks.
- `"reason"`: Use this option to enter comments, such as the reason the pipeline was
  stopped.
"""
function stop_pipeline_execution(
    pipelineExecutionId, pipelineName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codepipeline(
        "StopPipelineExecution",
        Dict{String,Any}(
            "pipelineExecutionId" => pipelineExecutionId, "pipelineName" => pipelineName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_pipeline_execution(
    pipelineExecutionId,
    pipelineName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codepipeline(
        "StopPipelineExecution",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "pipelineExecutionId" => pipelineExecutionId,
                    "pipelineName" => pipelineName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds to or modifies the tags of the given resource. Tags are metadata that can be used to
manage a resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource you want to add tags to.
- `tags`: The tags you want to modify or add to the resource.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return codepipeline(
        "TagResource",
        Dict{String,Any}("resourceArn" => resourceArn, "tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codepipeline(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceArn" => resourceArn, "tags" => tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes tags from an Amazon Web Services resource.

# Arguments
- `resource_arn`:  The Amazon Resource Name (ARN) of the resource to remove tags from.
- `tag_keys`: The list of keys for the tags to be removed from the resource.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codepipeline(
        "UntagResource",
        Dict{String,Any}("resourceArn" => resourceArn, "tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codepipeline(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceArn" => resourceArn, "tagKeys" => tagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_action_type(action_type)
    update_action_type(action_type, params::Dict{String,<:Any})

Updates an action type that was created with any supported integration model, where the
action type is to be used by customers of the action type provider. Use a JSON file with
the action definition and UpdateActionType to provide the full structure.

# Arguments
- `action_type`: The action type definition for the action type to be updated.

"""
function update_action_type(actionType; aws_config::AbstractAWSConfig=current_aws_config())
    return codepipeline(
        "UpdateActionType",
        Dict{String,Any}("actionType" => actionType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_action_type(
    actionType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codepipeline(
        "UpdateActionType",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("actionType" => actionType), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_pipeline(pipeline)
    update_pipeline(pipeline, params::Dict{String,<:Any})

Updates a specified pipeline with edits or changes to its structure. Use a JSON file with
the pipeline structure and UpdatePipeline to provide the full structure of the pipeline.
Updating the pipeline increases the version number of the pipeline by 1.

# Arguments
- `pipeline`: The name of the pipeline to be updated.

"""
function update_pipeline(pipeline; aws_config::AbstractAWSConfig=current_aws_config())
    return codepipeline(
        "UpdatePipeline",
        Dict{String,Any}("pipeline" => pipeline);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_pipeline(
    pipeline,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codepipeline(
        "UpdatePipeline",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("pipeline" => pipeline), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: cloudsearch
using AWS.Compat
using AWS.UUIDs

"""
    build_suggesters(domain_name)
    build_suggesters(domain_name, params::Dict{String,<:Any})

Indexes the search suggestions. For more information, see Configuring Suggesters in the
Amazon CloudSearch Developer Guide.

# Arguments
- `domain_name`:

"""
function build_suggesters(DomainName; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudsearch(
        "BuildSuggesters",
        Dict{String,Any}("DomainName" => DomainName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function build_suggesters(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudsearch(
        "BuildSuggesters",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DomainName" => DomainName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_domain(domain_name)
    create_domain(domain_name, params::Dict{String,<:Any})

Creates a new search domain. For more information, see Creating a Search Domain in the
Amazon CloudSearch Developer Guide.

# Arguments
- `domain_name`: A name for the domain you are creating. Allowed characters are a-z
  (lower-case letters), 0-9, and hyphen (-). Domain names must start with a letter or number
  and be at least 3 and no more than 28 characters long.

"""
function create_domain(DomainName; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudsearch(
        "CreateDomain",
        Dict{String,Any}("DomainName" => DomainName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_domain(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudsearch(
        "CreateDomain",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DomainName" => DomainName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    define_analysis_scheme(analysis_scheme, domain_name)
    define_analysis_scheme(analysis_scheme, domain_name, params::Dict{String,<:Any})

Configures an analysis scheme that can be applied to a text or text-array field to define
language-specific text processing options. For more information, see Configuring Analysis
Schemes in the Amazon CloudSearch Developer Guide.

# Arguments
- `analysis_scheme`:
- `domain_name`:

"""
function define_analysis_scheme(
    AnalysisScheme, DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudsearch(
        "DefineAnalysisScheme",
        Dict{String,Any}("AnalysisScheme" => AnalysisScheme, "DomainName" => DomainName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function define_analysis_scheme(
    AnalysisScheme,
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudsearch(
        "DefineAnalysisScheme",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AnalysisScheme" => AnalysisScheme, "DomainName" => DomainName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    define_expression(domain_name, expression)
    define_expression(domain_name, expression, params::Dict{String,<:Any})

Configures an Expression for the search domain. Used to create new expressions and modify
existing ones. If the expression exists, the new configuration replaces the old one. For
more information, see Configuring Expressions in the Amazon CloudSearch Developer Guide.

# Arguments
- `domain_name`:
- `expression`:

"""
function define_expression(
    DomainName, Expression; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudsearch(
        "DefineExpression",
        Dict{String,Any}("DomainName" => DomainName, "Expression" => Expression);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function define_expression(
    DomainName,
    Expression,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudsearch(
        "DefineExpression",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DomainName" => DomainName, "Expression" => Expression),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    define_index_field(domain_name, index_field)
    define_index_field(domain_name, index_field, params::Dict{String,<:Any})

Configures an IndexField for the search domain. Used to create new fields and modify
existing ones. You must specify the name of the domain you are configuring and an index
field configuration. The index field configuration specifies a unique name, the index field
type, and the options you want to configure for the field. The options you can specify
depend on the IndexFieldType. If the field exists, the new configuration replaces the old
one. For more information, see Configuring Index Fields in the Amazon CloudSearch Developer
Guide.

# Arguments
- `domain_name`:
- `index_field`: The index field and field options you want to configure.

"""
function define_index_field(
    DomainName, IndexField; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudsearch(
        "DefineIndexField",
        Dict{String,Any}("DomainName" => DomainName, "IndexField" => IndexField);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function define_index_field(
    DomainName,
    IndexField,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudsearch(
        "DefineIndexField",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DomainName" => DomainName, "IndexField" => IndexField),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    define_suggester(domain_name, suggester)
    define_suggester(domain_name, suggester, params::Dict{String,<:Any})

Configures a suggester for a domain. A suggester enables you to display possible matches
before users finish typing their queries. When you configure a suggester, you must specify
the name of the text field you want to search for possible matches and a unique name for
the suggester. For more information, see Getting Search Suggestions in the Amazon
CloudSearch Developer Guide.

# Arguments
- `domain_name`:
- `suggester`:

"""
function define_suggester(
    DomainName, Suggester; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudsearch(
        "DefineSuggester",
        Dict{String,Any}("DomainName" => DomainName, "Suggester" => Suggester);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function define_suggester(
    DomainName,
    Suggester,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudsearch(
        "DefineSuggester",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DomainName" => DomainName, "Suggester" => Suggester),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_analysis_scheme(analysis_scheme_name, domain_name)
    delete_analysis_scheme(analysis_scheme_name, domain_name, params::Dict{String,<:Any})

Deletes an analysis scheme. For more information, see Configuring Analysis Schemes in the
Amazon CloudSearch Developer Guide.

# Arguments
- `analysis_scheme_name`: The name of the analysis scheme you want to delete.
- `domain_name`:

"""
function delete_analysis_scheme(
    AnalysisSchemeName, DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudsearch(
        "DeleteAnalysisScheme",
        Dict{String,Any}(
            "AnalysisSchemeName" => AnalysisSchemeName, "DomainName" => DomainName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_analysis_scheme(
    AnalysisSchemeName,
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudsearch(
        "DeleteAnalysisScheme",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AnalysisSchemeName" => AnalysisSchemeName, "DomainName" => DomainName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_domain(domain_name)
    delete_domain(domain_name, params::Dict{String,<:Any})

Permanently deletes a search domain and all of its data. Once a domain has been deleted, it
cannot be recovered. For more information, see Deleting a Search Domain in the Amazon
CloudSearch Developer Guide.

# Arguments
- `domain_name`: The name of the domain you want to permanently delete.

"""
function delete_domain(DomainName; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudsearch(
        "DeleteDomain",
        Dict{String,Any}("DomainName" => DomainName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_domain(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudsearch(
        "DeleteDomain",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DomainName" => DomainName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_expression(domain_name, expression_name)
    delete_expression(domain_name, expression_name, params::Dict{String,<:Any})

Removes an Expression from the search domain. For more information, see Configuring
Expressions in the Amazon CloudSearch Developer Guide.

# Arguments
- `domain_name`:
- `expression_name`: The name of the Expression to delete.

"""
function delete_expression(
    DomainName, ExpressionName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudsearch(
        "DeleteExpression",
        Dict{String,Any}("DomainName" => DomainName, "ExpressionName" => ExpressionName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_expression(
    DomainName,
    ExpressionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudsearch(
        "DeleteExpression",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DomainName" => DomainName, "ExpressionName" => ExpressionName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_index_field(domain_name, index_field_name)
    delete_index_field(domain_name, index_field_name, params::Dict{String,<:Any})

Removes an IndexField from the search domain. For more information, see Configuring Index
Fields in the Amazon CloudSearch Developer Guide.

# Arguments
- `domain_name`:
- `index_field_name`: The name of the index field your want to remove from the domain's
  indexing options.

"""
function delete_index_field(
    DomainName, IndexFieldName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudsearch(
        "DeleteIndexField",
        Dict{String,Any}("DomainName" => DomainName, "IndexFieldName" => IndexFieldName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_index_field(
    DomainName,
    IndexFieldName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudsearch(
        "DeleteIndexField",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DomainName" => DomainName, "IndexFieldName" => IndexFieldName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_suggester(domain_name, suggester_name)
    delete_suggester(domain_name, suggester_name, params::Dict{String,<:Any})

Deletes a suggester. For more information, see Getting Search Suggestions in the Amazon
CloudSearch Developer Guide.

# Arguments
- `domain_name`:
- `suggester_name`: Specifies the name of the suggester you want to delete.

"""
function delete_suggester(
    DomainName, SuggesterName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudsearch(
        "DeleteSuggester",
        Dict{String,Any}("DomainName" => DomainName, "SuggesterName" => SuggesterName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_suggester(
    DomainName,
    SuggesterName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudsearch(
        "DeleteSuggester",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DomainName" => DomainName, "SuggesterName" => SuggesterName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_analysis_schemes(domain_name)
    describe_analysis_schemes(domain_name, params::Dict{String,<:Any})

Gets the analysis schemes configured for a domain. An analysis scheme defines
language-specific text processing options for a text field. Can be limited to specific
analysis schemes by name. By default, shows all analysis schemes and includes any pending
changes to the configuration. Set the Deployed option to true to show the active
configuration and exclude pending changes. For more information, see Configuring Analysis
Schemes in the Amazon CloudSearch Developer Guide.

# Arguments
- `domain_name`: The name of the domain you want to describe.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AnalysisSchemeNames"`: The analysis schemes you want to describe.
- `"Deployed"`: Whether to display the deployed configuration (true) or include any pending
  changes (false). Defaults to false.
"""
function describe_analysis_schemes(
    DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudsearch(
        "DescribeAnalysisSchemes",
        Dict{String,Any}("DomainName" => DomainName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_analysis_schemes(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudsearch(
        "DescribeAnalysisSchemes",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DomainName" => DomainName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_availability_options(domain_name)
    describe_availability_options(domain_name, params::Dict{String,<:Any})

Gets the availability options configured for a domain. By default, shows the configuration
with any pending changes. Set the Deployed option to true to show the active configuration
and exclude pending changes. For more information, see Configuring Availability Options in
the Amazon CloudSearch Developer Guide.

# Arguments
- `domain_name`: The name of the domain you want to describe.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Deployed"`: Whether to display the deployed configuration (true) or include any pending
  changes (false). Defaults to false.
"""
function describe_availability_options(
    DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudsearch(
        "DescribeAvailabilityOptions",
        Dict{String,Any}("DomainName" => DomainName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_availability_options(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudsearch(
        "DescribeAvailabilityOptions",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DomainName" => DomainName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_domain_endpoint_options(domain_name)
    describe_domain_endpoint_options(domain_name, params::Dict{String,<:Any})

Returns the domain's endpoint options, specifically whether all requests to the domain must
arrive over HTTPS. For more information, see Configuring Domain Endpoint Options in the
Amazon CloudSearch Developer Guide.

# Arguments
- `domain_name`: A string that represents the name of a domain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Deployed"`: Whether to retrieve the latest configuration (which might be in a
  Processing state) or the current, active configuration. Defaults to false.
"""
function describe_domain_endpoint_options(
    DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudsearch(
        "DescribeDomainEndpointOptions",
        Dict{String,Any}("DomainName" => DomainName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_domain_endpoint_options(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudsearch(
        "DescribeDomainEndpointOptions",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DomainName" => DomainName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_domains()
    describe_domains(params::Dict{String,<:Any})

Gets information about the search domains owned by this account. Can be limited to specific
domains. Shows all domains by default. To get the number of searchable documents in a
domain, use the console or submit a matchall request to your domain's search endpoint:
q=matchall&amp;amp;q.parser=structured&amp;amp;size=0. For more information, see Getting
Information about a Search Domain in the Amazon CloudSearch Developer Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DomainNames"`: The names of the domains you want to include in the response.
"""
function describe_domains(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudsearch(
        "DescribeDomains"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_domains(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudsearch(
        "DescribeDomains", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_expressions(domain_name)
    describe_expressions(domain_name, params::Dict{String,<:Any})

Gets the expressions configured for the search domain. Can be limited to specific
expressions by name. By default, shows all expressions and includes any pending changes to
the configuration. Set the Deployed option to true to show the active configuration and
exclude pending changes. For more information, see Configuring Expressions in the Amazon
CloudSearch Developer Guide.

# Arguments
- `domain_name`: The name of the domain you want to describe.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Deployed"`: Whether to display the deployed configuration (true) or include any pending
  changes (false). Defaults to false.
- `"ExpressionNames"`: Limits the DescribeExpressions response to the specified
  expressions. If not specified, all expressions are shown.
"""
function describe_expressions(
    DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudsearch(
        "DescribeExpressions",
        Dict{String,Any}("DomainName" => DomainName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_expressions(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudsearch(
        "DescribeExpressions",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DomainName" => DomainName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_index_fields(domain_name)
    describe_index_fields(domain_name, params::Dict{String,<:Any})

Gets information about the index fields configured for the search domain. Can be limited to
specific fields by name. By default, shows all fields and includes any pending changes to
the configuration. Set the Deployed option to true to show the active configuration and
exclude pending changes. For more information, see Getting Domain Information in the Amazon
CloudSearch Developer Guide.

# Arguments
- `domain_name`: The name of the domain you want to describe.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Deployed"`: Whether to display the deployed configuration (true) or include any pending
  changes (false). Defaults to false.
- `"FieldNames"`: A list of the index fields you want to describe. If not specified,
  information is returned for all configured index fields.
"""
function describe_index_fields(
    DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudsearch(
        "DescribeIndexFields",
        Dict{String,Any}("DomainName" => DomainName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_index_fields(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudsearch(
        "DescribeIndexFields",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DomainName" => DomainName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_scaling_parameters(domain_name)
    describe_scaling_parameters(domain_name, params::Dict{String,<:Any})

Gets the scaling parameters configured for a domain. A domain's scaling parameters specify
the desired search instance type and replication count. For more information, see
Configuring Scaling Options in the Amazon CloudSearch Developer Guide.

# Arguments
- `domain_name`:

"""
function describe_scaling_parameters(
    DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudsearch(
        "DescribeScalingParameters",
        Dict{String,Any}("DomainName" => DomainName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_scaling_parameters(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudsearch(
        "DescribeScalingParameters",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DomainName" => DomainName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_service_access_policies(domain_name)
    describe_service_access_policies(domain_name, params::Dict{String,<:Any})

Gets information about the access policies that control access to the domain's document and
search endpoints. By default, shows the configuration with any pending changes. Set the
Deployed option to true to show the active configuration and exclude pending changes. For
more information, see Configuring Access for a Search Domain in the Amazon CloudSearch
Developer Guide.

# Arguments
- `domain_name`: The name of the domain you want to describe.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Deployed"`: Whether to display the deployed configuration (true) or include any pending
  changes (false). Defaults to false.
"""
function describe_service_access_policies(
    DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudsearch(
        "DescribeServiceAccessPolicies",
        Dict{String,Any}("DomainName" => DomainName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_service_access_policies(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudsearch(
        "DescribeServiceAccessPolicies",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DomainName" => DomainName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_suggesters(domain_name)
    describe_suggesters(domain_name, params::Dict{String,<:Any})

Gets the suggesters configured for a domain. A suggester enables you to display possible
matches before users finish typing their queries. Can be limited to specific suggesters by
name. By default, shows all suggesters and includes any pending changes to the
configuration. Set the Deployed option to true to show the active configuration and exclude
pending changes. For more information, see Getting Search Suggestions in the Amazon
CloudSearch Developer Guide.

# Arguments
- `domain_name`: The name of the domain you want to describe.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Deployed"`: Whether to display the deployed configuration (true) or include any pending
  changes (false). Defaults to false.
- `"SuggesterNames"`: The suggesters you want to describe.
"""
function describe_suggesters(DomainName; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudsearch(
        "DescribeSuggesters",
        Dict{String,Any}("DomainName" => DomainName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_suggesters(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudsearch(
        "DescribeSuggesters",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DomainName" => DomainName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    index_documents(domain_name)
    index_documents(domain_name, params::Dict{String,<:Any})

Tells the search domain to start indexing its documents using the latest indexing options.
This operation must be invoked to activate options whose OptionStatus is
RequiresIndexDocuments.

# Arguments
- `domain_name`:

"""
function index_documents(DomainName; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudsearch(
        "IndexDocuments",
        Dict{String,Any}("DomainName" => DomainName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function index_documents(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudsearch(
        "IndexDocuments",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DomainName" => DomainName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_domain_names()
    list_domain_names(params::Dict{String,<:Any})

Lists all search domains owned by an account.

"""
function list_domain_names(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudsearch(
        "ListDomainNames"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_domain_names(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudsearch(
        "ListDomainNames", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    update_availability_options(domain_name, multi_az)
    update_availability_options(domain_name, multi_az, params::Dict{String,<:Any})

Configures the availability options for a domain. Enabling the Multi-AZ option expands an
Amazon CloudSearch domain to an additional Availability Zone in the same Region to increase
fault tolerance in the event of a service disruption. Changes to the Multi-AZ option can
take about half an hour to become active. For more information, see Configuring
Availability Options in the Amazon CloudSearch Developer Guide.

# Arguments
- `domain_name`:
- `multi_az`: You expand an existing search domain to a second Availability Zone by setting
  the Multi-AZ option to true. Similarly, you can turn off the Multi-AZ option to downgrade
  the domain to a single Availability Zone by setting the Multi-AZ option to false.

"""
function update_availability_options(
    DomainName, MultiAZ; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudsearch(
        "UpdateAvailabilityOptions",
        Dict{String,Any}("DomainName" => DomainName, "MultiAZ" => MultiAZ);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_availability_options(
    DomainName,
    MultiAZ,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudsearch(
        "UpdateAvailabilityOptions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DomainName" => DomainName, "MultiAZ" => MultiAZ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_domain_endpoint_options(domain_endpoint_options, domain_name)
    update_domain_endpoint_options(domain_endpoint_options, domain_name, params::Dict{String,<:Any})

Updates the domain's endpoint options, specifically whether all requests to the domain must
arrive over HTTPS. For more information, see Configuring Domain Endpoint Options in the
Amazon CloudSearch Developer Guide.

# Arguments
- `domain_endpoint_options`: Whether to require that all requests to the domain arrive over
  HTTPS. We recommend Policy-Min-TLS-1-2-2019-07 for TLSSecurityPolicy. For compatibility
  with older clients, the default is Policy-Min-TLS-1-0-2019-07.
- `domain_name`: A string that represents the name of a domain.

"""
function update_domain_endpoint_options(
    DomainEndpointOptions, DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudsearch(
        "UpdateDomainEndpointOptions",
        Dict{String,Any}(
            "DomainEndpointOptions" => DomainEndpointOptions, "DomainName" => DomainName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_domain_endpoint_options(
    DomainEndpointOptions,
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudsearch(
        "UpdateDomainEndpointOptions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DomainEndpointOptions" => DomainEndpointOptions,
                    "DomainName" => DomainName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_scaling_parameters(domain_name, scaling_parameters)
    update_scaling_parameters(domain_name, scaling_parameters, params::Dict{String,<:Any})

Configures scaling parameters for a domain. A domain's scaling parameters specify the
desired search instance type and replication count. Amazon CloudSearch will still
automatically scale your domain based on the volume of data and traffic, but not below the
desired instance type and replication count. If the Multi-AZ option is enabled, these
values control the resources used per Availability Zone. For more information, see
Configuring Scaling Options in the Amazon CloudSearch Developer Guide.

# Arguments
- `domain_name`:
- `scaling_parameters`:

"""
function update_scaling_parameters(
    DomainName, ScalingParameters; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudsearch(
        "UpdateScalingParameters",
        Dict{String,Any}(
            "DomainName" => DomainName, "ScalingParameters" => ScalingParameters
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_scaling_parameters(
    DomainName,
    ScalingParameters,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudsearch(
        "UpdateScalingParameters",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DomainName" => DomainName, "ScalingParameters" => ScalingParameters
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_service_access_policies(access_policies, domain_name)
    update_service_access_policies(access_policies, domain_name, params::Dict{String,<:Any})

Configures the access rules that control access to the domain's document and search
endpoints. For more information, see  Configuring Access for an Amazon CloudSearch Domain.

# Arguments
- `access_policies`: The access rules you want to configure. These rules replace any
  existing rules.
- `domain_name`:

"""
function update_service_access_policies(
    AccessPolicies, DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudsearch(
        "UpdateServiceAccessPolicies",
        Dict{String,Any}("AccessPolicies" => AccessPolicies, "DomainName" => DomainName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_service_access_policies(
    AccessPolicies,
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudsearch(
        "UpdateServiceAccessPolicies",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AccessPolicies" => AccessPolicies, "DomainName" => DomainName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

module APIGeneration

using Base64
using ..AWSExceptions
using GitHub
using HTTP
using JSON: JSON
using Mocking
using OrderedCollections: LittleDict, OrderedDict

const AUTO_GENERATED_SIGNATURE = "This file is auto-generated by AWS.jl"
const PKG_DIR = abspath(joinpath(@__DIR__, "..", ".."))
const HIGH_LEVEL_SERVICES_DIR = joinpath(PKG_DIR, "src", "services")
const LOW_LEVEL_SERVICES_FILE = joinpath(PKG_DIR, "src", "AWSServices.jl")

include("utilities.jl")
include("high_level.jl")
include("low_level.jl")

"""
    parse_aws_metadata()

Generate low-level and high-level Julia wrappers for each AWS service definition found in
[`aws-sdk-js` GitHub Repository](https://github.com/aws/aws-sdk-js/tree/master/apis).

Low-level API wrappers are defined in `$(relpath(LOW_LEVEL_SERVICES_FILE, PKG_DIR))` and
high-level API wrappers are each defined separate files within the directory
`$(relpath(HIGH_LEVEL_SERVICES_DIR, PKG_DIR))`.
"""
function parse_aws_metadata()
    auth = GitHub.authenticate(ENV["GITHUB_AUTH"])

    service_files = _get_service_files(auth)

    _generate_low_level_wrappers(service_files, auth)
    _generate_high_level_wrapper(service_files, auth)

    return nothing
end

end

with_aws_config(
    MinioConfig(
        "http://127.0.0.1:9000",
        ENV["MINIO_REGION_NAME"],
        SimpleCredentials(ENV["MINIO_ACCESS_KEY"], ENV["MINIO_SECRET_KEY"], ""),
    ),
) do
    datadir = joinpath(dirname(pathof(AWS)), "..", "data")

    # Create bucket and place objects in it
    S3.create_bucket("anewbucket")
    try
        S3.put_object("anewbucket", "myobject", Dict("body" => "Hi from Minio"))
        S3.put_object("anewbucket", "empty")
        S3.put_object("anewbucket", "foo/bar", Dict("body" => "a nested object"))
        S3.put_object("anewbucket", "foo/baz", Dict("body" => "a secondnested object"))

        # Test retrieving an object
        @test String(S3.get_object("anewbucket", "myobject")) == "Hi from Minio"

        # Test retrieving an object into a stream target
        mktemp() do f, io
            S3.get_object("anewbucket", "myobject", Dict("response_stream" => io))
            flush(io)
            @test read(f, String) == "Hi from Minio"
        end

        # Test listing
        objs = S3.list_objects_v2("anewbucket")
        @test length(objs["Contents"]) == 4

        # Test api version 2 of list-objects
        objs_truncated = S3.list_objects_v2("anewbucket", Dict("max-keys" => 2))
        @test length(objs_truncated["Contents"]) == 2
        @test objs_truncated["IsTruncated"] == "true"
        @test haskey(objs_truncated, "NextContinuationToken")

        # Test listing with prefixes
        objs_prefix = S3.list_objects_v2(
            "anewbucket", Dict("prefix" => "", "delimiter" => "/")
        )
        @test length(objs_prefix["Contents"]) == 2
        @test sort(getindex.(objs_prefix["Contents"], "Key")) == ["empty", "myobject"]
        @test objs_prefix["CommonPrefixes"]["Prefix"] == "foo/"

        # Duplicated testset from "test/issues.jl". Useful for testing outside the CI. Ideally,
        # the tests should be revised such that local testing works without having to duplicate
        # testsets.

        @testset "issue 466" begin
            file_name = "hang.txt"

            try
                S3.put_object("anewbucket", file_name)

                # Note: Using `eof` for these tests can hang when using an unclosed `Base.BufferStream`

                stream = S3.get_object(
                    "anewbucket", file_name, Dict("return_stream" => true)
                )
                if AWS.DEFAULT_BACKEND[] isa AWS.HTTPBackend
                    @test !isopen(stream)
                else
                    @test isopen(stream)
                end

                stream = Base.BufferStream()
                S3.get_object("anewbucket", file_name, Dict("response_stream" => stream))
                if AWS.DEFAULT_BACKEND[] isa AWS.HTTPBackend
                    @test !isopen(stream)
                else
                    @test_broken isopen(stream)
                end

                stream = Base.BufferStream()
                S3.get_object(
                    "anewbucket",
                    file_name,
                    Dict("response_stream" => stream, "return_stream" => true),
                )
                if AWS.DEFAULT_BACKEND[] isa AWS.HTTPBackend
                    @test !isopen(stream)
                else
                    @test isopen(stream)
                end
            finally
                S3.delete_object("anewbucket", file_name)
            end
        end

        @testset "issue 474" begin
            body = "foo\0bar"
            expected = Vector{UInt8}(body)
            file_name = "null.txt"
            bucket_name = "anewbucket"

            try
                S3.put_object(bucket_name, file_name, Dict("body" => body))

                raw = S3.get_object(bucket_name, file_name, Dict("return_raw" => true))
                @test raw isa Vector{UInt8}
                @test raw == expected

                stream = S3.get_object(
                    bucket_name, file_name, Dict("return_stream" => true)
                )
                if AWS.DEFAULT_BACKEND[] isa AWS.HTTPBackend
                    @test stream isa Base.BufferStream
                    @test !isopen(stream)

                    if !isopen(stream)
                        @test read(stream) == expected
                    end
                else
                    @test stream isa IOBuffer
                    @test isopen(stream)
                    seekstart(stream)
                    @test read(stream) == expected
                end
            finally
                S3.delete_object(bucket_name, file_name)
            end
        end

    finally
        # Delete all objects and the bucket
        objs = S3.list_objects_v2("anewbucket")

        for obj in objs["Contents"]
            S3.delete_object("anewbucket", obj["Key"])
        end

        S3.delete_bucket("anewbucket")
    end

    @test isempty(filter(!isequal(".minio.sys"), readdir(datadir)))
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: sns
using AWS.Compat
using AWS.UUIDs

"""
    add_permission(awsaccount_id, action_name, label, topic_arn)
    add_permission(awsaccount_id, action_name, label, topic_arn, params::Dict{String,<:Any})

Adds a statement to a topic's access control policy, granting access for the specified
Amazon Web Services accounts to the specified actions.  To remove the ability to change
topic permissions, you must deny permissions to the AddPermission, RemovePermission, and
SetTopicAttributes actions in your IAM policy.

# Arguments
- `awsaccount_id`: The Amazon Web Services account IDs of the users (principals) who will
  be given access to the specified actions. The users must have Amazon Web Services account,
  but do not need to be signed up for this service.
- `action_name`: The action you want to allow for the specified principal(s). Valid values:
  Any Amazon SNS action name, for example Publish.
- `label`: A unique identifier for the new policy statement.
- `topic_arn`: The ARN of the topic whose access control policy you wish to modify.

"""
function add_permission(
    AWSAccountId,
    ActionName,
    Label,
    TopicArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sns(
        "AddPermission",
        Dict{String,Any}(
            "AWSAccountId" => AWSAccountId,
            "ActionName" => ActionName,
            "Label" => Label,
            "TopicArn" => TopicArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_permission(
    AWSAccountId,
    ActionName,
    Label,
    TopicArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sns(
        "AddPermission",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AWSAccountId" => AWSAccountId,
                    "ActionName" => ActionName,
                    "Label" => Label,
                    "TopicArn" => TopicArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    check_if_phone_number_is_opted_out(phone_number)
    check_if_phone_number_is_opted_out(phone_number, params::Dict{String,<:Any})

Accepts a phone number and indicates whether the phone holder has opted out of receiving
SMS messages from your Amazon Web Services account. You cannot send SMS messages to a
number that is opted out. To resume sending messages, you can opt in the number by using
the OptInPhoneNumber action.

# Arguments
- `phone_number`: The phone number for which you want to check the opt out status.

"""
function check_if_phone_number_is_opted_out(
    phoneNumber; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sns(
        "CheckIfPhoneNumberIsOptedOut",
        Dict{String,Any}("phoneNumber" => phoneNumber);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function check_if_phone_number_is_opted_out(
    phoneNumber,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sns(
        "CheckIfPhoneNumberIsOptedOut",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("phoneNumber" => phoneNumber), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    confirm_subscription(token, topic_arn)
    confirm_subscription(token, topic_arn, params::Dict{String,<:Any})

Verifies an endpoint owner's intent to receive messages by validating the token sent to the
endpoint by an earlier Subscribe action. If the token is valid, the action creates a new
subscription and returns its Amazon Resource Name (ARN). This call requires an AWS
signature only when the AuthenticateOnUnsubscribe flag is set to \"true\".

# Arguments
- `token`: Short-lived token sent to an endpoint during the Subscribe action.
- `topic_arn`: The ARN of the topic for which you wish to confirm a subscription.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AuthenticateOnUnsubscribe"`: Disallows unauthenticated unsubscribes of the
  subscription. If the value of this parameter is true and the request has an Amazon Web
  Services signature, then only the topic owner and the subscription owner can unsubscribe
  the endpoint. The unsubscribe action requires Amazon Web Services authentication.
"""
function confirm_subscription(
    Token, TopicArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sns(
        "ConfirmSubscription",
        Dict{String,Any}("Token" => Token, "TopicArn" => TopicArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function confirm_subscription(
    Token,
    TopicArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sns(
        "ConfirmSubscription",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("Token" => Token, "TopicArn" => TopicArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_platform_application(attributes, name, platform)
    create_platform_application(attributes, name, platform, params::Dict{String,<:Any})

Creates a platform application object for one of the supported push notification services,
such as APNS and GCM (Firebase Cloud Messaging), to which devices and mobile apps may
register. You must specify PlatformPrincipal and PlatformCredential attributes when using
the CreatePlatformApplication action.  PlatformPrincipal and PlatformCredential are
received from the notification service.   For ADM, PlatformPrincipal is client id and
PlatformCredential is client secret.   For APNS and APNS_SANDBOX using certificate
credentials, PlatformPrincipal is SSL certificate and PlatformCredential is private key.
For APNS and APNS_SANDBOX using token credentials, PlatformPrincipal is signing key ID and
PlatformCredential is signing key.   For Baidu, PlatformPrincipal is API key and
PlatformCredential is secret key.   For GCM (Firebase Cloud Messaging) using key
credentials, there is no PlatformPrincipal. The PlatformCredential is API key.   For GCM
(Firebase Cloud Messaging) using token credentials, there is no PlatformPrincipal. The
PlatformCredential is a JSON formatted private key file. When using the Amazon Web Services
CLI, the file must be in string format and special characters must be ignored. To format
the file correctly, Amazon SNS recommends using the following command: SERVICE_JSON=`jq
@json &lt;&lt;&lt; cat service.json`.   For MPNS, PlatformPrincipal is TLS certificate and
PlatformCredential is private key.   For WNS, PlatformPrincipal is Package Security
Identifier and PlatformCredential is secret key.   You can use the returned
PlatformApplicationArn as an attribute for the CreatePlatformEndpoint action.

# Arguments
- `attributes`: For a list of attributes, see  SetPlatformApplicationAttributes .
- `name`: Application names must be made up of only uppercase and lowercase ASCII letters,
  numbers, underscores, hyphens, and periods, and must be between 1 and 256 characters long.
- `platform`: The following platforms are supported: ADM (Amazon Device Messaging), APNS
  (Apple Push Notification Service), APNS_SANDBOX, and GCM (Firebase Cloud Messaging).

"""
function create_platform_application(
    Attributes, Name, Platform; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sns(
        "CreatePlatformApplication",
        Dict{String,Any}(
            "Attributes" => Attributes, "Name" => Name, "Platform" => Platform
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_platform_application(
    Attributes,
    Name,
    Platform,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sns(
        "CreatePlatformApplication",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Attributes" => Attributes, "Name" => Name, "Platform" => Platform
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_platform_endpoint(platform_application_arn, token)
    create_platform_endpoint(platform_application_arn, token, params::Dict{String,<:Any})

Creates an endpoint for a device and mobile app on one of the supported push notification
services, such as GCM (Firebase Cloud Messaging) and APNS. CreatePlatformEndpoint requires
the PlatformApplicationArn that is returned from CreatePlatformApplication. You can use the
returned EndpointArn to send a message to a mobile app or by the Subscribe action for
subscription to a topic. The CreatePlatformEndpoint action is idempotent, so if the
requester already owns an endpoint with the same device token and attributes, that
endpoint's ARN is returned without creating a new endpoint. For more information, see Using
Amazon SNS Mobile Push Notifications.  When using CreatePlatformEndpoint with Baidu, two
attributes must be provided: ChannelId and UserId. The token field must also contain the
ChannelId. For more information, see Creating an Amazon SNS Endpoint for Baidu.

# Arguments
- `platform_application_arn`:  PlatformApplicationArn returned from
  CreatePlatformApplication is used to create a an endpoint.
- `token`: Unique identifier created by the notification service for an app on a device.
  The specific name for Token will vary, depending on which notification service is being
  used. For example, when using APNS as the notification service, you need the device token.
  Alternatively, when using GCM (Firebase Cloud Messaging) or ADM, the device token
  equivalent is called the registration ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Attributes"`: For a list of attributes, see  SetEndpointAttributes .
- `"CustomUserData"`: Arbitrary user data to associate with the endpoint. Amazon SNS does
  not use this data. The data must be in UTF-8 format and less than 2KB.
"""
function create_platform_endpoint(
    PlatformApplicationArn, Token; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sns(
        "CreatePlatformEndpoint",
        Dict{String,Any}(
            "PlatformApplicationArn" => PlatformApplicationArn, "Token" => Token
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_platform_endpoint(
    PlatformApplicationArn,
    Token,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sns(
        "CreatePlatformEndpoint",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "PlatformApplicationArn" => PlatformApplicationArn, "Token" => Token
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_smssandbox_phone_number(phone_number)
    create_smssandbox_phone_number(phone_number, params::Dict{String,<:Any})

Adds a destination phone number to an Amazon Web Services account in the SMS sandbox and
sends a one-time password (OTP) to that phone number. When you start using Amazon SNS to
send SMS messages, your Amazon Web Services account is in the SMS sandbox. The SMS sandbox
provides a safe environment for you to try Amazon SNS features without risking your
reputation as an SMS sender. While your Amazon Web Services account is in the SMS sandbox,
you can use all of the features of Amazon SNS. However, you can send SMS messages only to
verified destination phone numbers. For more information, including how to move out of the
sandbox to send messages without restrictions, see SMS sandbox in the Amazon SNS Developer
Guide.

# Arguments
- `phone_number`: The destination phone number to verify. On verification, Amazon SNS adds
  this phone number to the list of verified phone numbers that you can send SMS messages to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"LanguageCode"`: The language to use for sending the OTP. The default value is en-US.
"""
function create_smssandbox_phone_number(
    PhoneNumber; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sns(
        "CreateSMSSandboxPhoneNumber",
        Dict{String,Any}("PhoneNumber" => PhoneNumber);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_smssandbox_phone_number(
    PhoneNumber,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sns(
        "CreateSMSSandboxPhoneNumber",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("PhoneNumber" => PhoneNumber), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_topic(name)
    create_topic(name, params::Dict{String,<:Any})

Creates a topic to which notifications can be published. Users can create at most 100,000
standard topics (at most 1,000 FIFO topics). For more information, see Creating an Amazon
SNS topic in the Amazon SNS Developer Guide. This action is idempotent, so if the requester
already owns a topic with the specified name, that topic's ARN is returned without creating
a new topic.

# Arguments
- `name`: The name of the topic you want to create. Constraints: Topic names must be made
  up of only uppercase and lowercase ASCII letters, numbers, underscores, and hyphens, and
  must be between 1 and 256 characters long. For a FIFO (first-in-first-out) topic, the name
  must end with the .fifo suffix.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Attributes"`: A map of attributes with their corresponding values. The following lists
  names, descriptions, and values of the special request parameters that the CreateTopic
  action uses:    DeliveryPolicy – The policy that defines how Amazon SNS retries failed
  deliveries to HTTP/S endpoints.    DisplayName – The display name to use for a topic with
  SMS subscriptions.    FifoTopic – Set to true to create a FIFO topic.    Policy – The
  policy that defines who can access your topic. By default, only the topic owner can publish
  or subscribe to the topic.    SignatureVersion – The signature version corresponds to the
  hashing algorithm used while creating the signature of the notifications, subscription
  confirmations, or unsubscribe confirmation messages sent by Amazon SNS. By default,
  SignatureVersion is set to 1.    TracingConfig – Tracing mode of an Amazon SNS topic. By
  default TracingConfig is set to PassThrough, and the topic passes through the tracing
  header it receives from an Amazon SNS publisher to its subscriptions. If set to Active,
  Amazon SNS will vend X-Ray segment data to topic owner account if the sampled flag in the
  tracing header is true. This is only supported on standard topics.   The following
  attribute applies only to server-side encryption:    KmsMasterKeyId – The ID of an Amazon
  Web Services managed customer master key (CMK) for Amazon SNS or a custom CMK. For more
  information, see Key Terms. For more examples, see KeyId in the Key Management Service API
  Reference.    The following attributes apply only to FIFO topics:    ArchivePolicy – Adds
  or updates an inline policy document to archive messages stored in the specified Amazon SNS
  topic.    BeginningArchiveTime – The earliest starting point at which a message in the
  topic’s archive can be replayed from. This point in time is based on the configured
  message retention period set by the topic’s message archiving policy.
  ContentBasedDeduplication – Enables content-based deduplication for FIFO topics.   By
  default, ContentBasedDeduplication is set to false. If you create a FIFO topic and this
  attribute is false, you must specify a value for the MessageDeduplicationId parameter for
  the Publish action.    When you set ContentBasedDeduplication to true, Amazon SNS uses a
  SHA-256 hash to generate the MessageDeduplicationId using the body of the message (but not
  the attributes of the message). (Optional) To override the generated value, you can specify
  a value for the MessageDeduplicationId parameter for the Publish action.
- `"DataProtectionPolicy"`: The body of the policy document you want to use for this topic.
  You can only add one policy per topic. The policy must be in JSON string format. Length
  Constraints: Maximum length of 30,720.
- `"Tags"`: The list of tags to add to a new topic.  To be able to tag a topic on creation,
  you must have the sns:CreateTopic and sns:TagResource permissions.
"""
function create_topic(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return sns(
        "CreateTopic",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_topic(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sns(
        "CreateTopic",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_endpoint(endpoint_arn)
    delete_endpoint(endpoint_arn, params::Dict{String,<:Any})

Deletes the endpoint for a device and mobile app from Amazon SNS. This action is
idempotent. For more information, see Using Amazon SNS Mobile Push Notifications.  When you
delete an endpoint that is also subscribed to a topic, then you must also unsubscribe the
endpoint from the topic.

# Arguments
- `endpoint_arn`:  EndpointArn of endpoint to delete.

"""
function delete_endpoint(EndpointArn; aws_config::AbstractAWSConfig=current_aws_config())
    return sns(
        "DeleteEndpoint",
        Dict{String,Any}("EndpointArn" => EndpointArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_endpoint(
    EndpointArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sns(
        "DeleteEndpoint",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("EndpointArn" => EndpointArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_platform_application(platform_application_arn)
    delete_platform_application(platform_application_arn, params::Dict{String,<:Any})

Deletes a platform application object for one of the supported push notification services,
such as APNS and GCM (Firebase Cloud Messaging). For more information, see Using Amazon SNS
Mobile Push Notifications.

# Arguments
- `platform_application_arn`:  PlatformApplicationArn of platform application object to
  delete.

"""
function delete_platform_application(
    PlatformApplicationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sns(
        "DeletePlatformApplication",
        Dict{String,Any}("PlatformApplicationArn" => PlatformApplicationArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_platform_application(
    PlatformApplicationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sns(
        "DeletePlatformApplication",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("PlatformApplicationArn" => PlatformApplicationArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_smssandbox_phone_number(phone_number)
    delete_smssandbox_phone_number(phone_number, params::Dict{String,<:Any})

Deletes an Amazon Web Services account's verified or pending phone number from the SMS
sandbox. When you start using Amazon SNS to send SMS messages, your Amazon Web Services
account is in the SMS sandbox. The SMS sandbox provides a safe environment for you to try
Amazon SNS features without risking your reputation as an SMS sender. While your Amazon Web
Services account is in the SMS sandbox, you can use all of the features of Amazon SNS.
However, you can send SMS messages only to verified destination phone numbers. For more
information, including how to move out of the sandbox to send messages without
restrictions, see SMS sandbox in the Amazon SNS Developer Guide.

# Arguments
- `phone_number`: The destination phone number to delete.

"""
function delete_smssandbox_phone_number(
    PhoneNumber; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sns(
        "DeleteSMSSandboxPhoneNumber",
        Dict{String,Any}("PhoneNumber" => PhoneNumber);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_smssandbox_phone_number(
    PhoneNumber,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sns(
        "DeleteSMSSandboxPhoneNumber",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("PhoneNumber" => PhoneNumber), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_topic(topic_arn)
    delete_topic(topic_arn, params::Dict{String,<:Any})

Deletes a topic and all its subscriptions. Deleting a topic might prevent some messages
previously sent to the topic from being delivered to subscribers. This action is
idempotent, so deleting a topic that does not exist does not result in an error.

# Arguments
- `topic_arn`: The ARN of the topic you want to delete.

"""
function delete_topic(TopicArn; aws_config::AbstractAWSConfig=current_aws_config())
    return sns(
        "DeleteTopic",
        Dict{String,Any}("TopicArn" => TopicArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_topic(
    TopicArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sns(
        "DeleteTopic",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TopicArn" => TopicArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_data_protection_policy(resource_arn)
    get_data_protection_policy(resource_arn, params::Dict{String,<:Any})

Retrieves the specified inline DataProtectionPolicy document that is stored in the
specified Amazon SNS topic.

# Arguments
- `resource_arn`: The ARN of the topic whose DataProtectionPolicy you want to get. For more
  information about ARNs, see Amazon Resource Names (ARNs) in the Amazon Web Services General
  Reference.

"""
function get_data_protection_policy(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sns(
        "GetDataProtectionPolicy",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_data_protection_policy(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sns(
        "GetDataProtectionPolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_endpoint_attributes(endpoint_arn)
    get_endpoint_attributes(endpoint_arn, params::Dict{String,<:Any})

Retrieves the endpoint attributes for a device on one of the supported push notification
services, such as GCM (Firebase Cloud Messaging) and APNS. For more information, see Using
Amazon SNS Mobile Push Notifications.

# Arguments
- `endpoint_arn`:  EndpointArn for GetEndpointAttributes input.

"""
function get_endpoint_attributes(
    EndpointArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sns(
        "GetEndpointAttributes",
        Dict{String,Any}("EndpointArn" => EndpointArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_endpoint_attributes(
    EndpointArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sns(
        "GetEndpointAttributes",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("EndpointArn" => EndpointArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_platform_application_attributes(platform_application_arn)
    get_platform_application_attributes(platform_application_arn, params::Dict{String,<:Any})

Retrieves the attributes of the platform application object for the supported push
notification services, such as APNS and GCM (Firebase Cloud Messaging). For more
information, see Using Amazon SNS Mobile Push Notifications.

# Arguments
- `platform_application_arn`:  PlatformApplicationArn for
  GetPlatformApplicationAttributesInput.

"""
function get_platform_application_attributes(
    PlatformApplicationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sns(
        "GetPlatformApplicationAttributes",
        Dict{String,Any}("PlatformApplicationArn" => PlatformApplicationArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_platform_application_attributes(
    PlatformApplicationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sns(
        "GetPlatformApplicationAttributes",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("PlatformApplicationArn" => PlatformApplicationArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_smsattributes()
    get_smsattributes(params::Dict{String,<:Any})

Returns the settings for sending SMS messages from your Amazon Web Services account. These
settings are set with the SetSMSAttributes action.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"attributes"`: A list of the individual attribute names, such as MonthlySpendLimit, for
  which you want values. For all attribute names, see SetSMSAttributes. If you don't use this
  parameter, Amazon SNS returns all SMS attributes.
"""
function get_smsattributes(; aws_config::AbstractAWSConfig=current_aws_config())
    return sns("GetSMSAttributes"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function get_smsattributes(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sns(
        "GetSMSAttributes", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_smssandbox_account_status()
    get_smssandbox_account_status(params::Dict{String,<:Any})

Retrieves the SMS sandbox status for the calling Amazon Web Services account in the target
Amazon Web Services Region. When you start using Amazon SNS to send SMS messages, your
Amazon Web Services account is in the SMS sandbox. The SMS sandbox provides a safe
environment for you to try Amazon SNS features without risking your reputation as an SMS
sender. While your Amazon Web Services account is in the SMS sandbox, you can use all of
the features of Amazon SNS. However, you can send SMS messages only to verified destination
phone numbers. For more information, including how to move out of the sandbox to send
messages without restrictions, see SMS sandbox in the Amazon SNS Developer Guide.

"""
function get_smssandbox_account_status(; aws_config::AbstractAWSConfig=current_aws_config())
    return sns(
        "GetSMSSandboxAccountStatus"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_smssandbox_account_status(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sns(
        "GetSMSSandboxAccountStatus",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_subscription_attributes(subscription_arn)
    get_subscription_attributes(subscription_arn, params::Dict{String,<:Any})

Returns all of the properties of a subscription.

# Arguments
- `subscription_arn`: The ARN of the subscription whose properties you want to get.

"""
function get_subscription_attributes(
    SubscriptionArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sns(
        "GetSubscriptionAttributes",
        Dict{String,Any}("SubscriptionArn" => SubscriptionArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_subscription_attributes(
    SubscriptionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sns(
        "GetSubscriptionAttributes",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("SubscriptionArn" => SubscriptionArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_topic_attributes(topic_arn)
    get_topic_attributes(topic_arn, params::Dict{String,<:Any})

Returns all of the properties of a topic. Topic properties returned might differ based on
the authorization of the user.

# Arguments
- `topic_arn`: The ARN of the topic whose properties you want to get.

"""
function get_topic_attributes(TopicArn; aws_config::AbstractAWSConfig=current_aws_config())
    return sns(
        "GetTopicAttributes",
        Dict{String,Any}("TopicArn" => TopicArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_topic_attributes(
    TopicArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sns(
        "GetTopicAttributes",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TopicArn" => TopicArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_endpoints_by_platform_application(platform_application_arn)
    list_endpoints_by_platform_application(platform_application_arn, params::Dict{String,<:Any})

Lists the endpoints and endpoint attributes for devices in a supported push notification
service, such as GCM (Firebase Cloud Messaging) and APNS. The results for
ListEndpointsByPlatformApplication are paginated and return a limited list of endpoints, up
to 100. If additional records are available after the first page results, then a NextToken
string will be returned. To receive the next page, you call
ListEndpointsByPlatformApplication again using the NextToken string received from the
previous call. When there are no more records to return, NextToken will be null. For more
information, see Using Amazon SNS Mobile Push Notifications.  This action is throttled at
30 transactions per second (TPS).

# Arguments
- `platform_application_arn`:  PlatformApplicationArn for
  ListEndpointsByPlatformApplicationInput action.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`:  NextToken string is used when calling ListEndpointsByPlatformApplication
  action to retrieve additional records that are available after the first page results.
"""
function list_endpoints_by_platform_application(
    PlatformApplicationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sns(
        "ListEndpointsByPlatformApplication",
        Dict{String,Any}("PlatformApplicationArn" => PlatformApplicationArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_endpoints_by_platform_application(
    PlatformApplicationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sns(
        "ListEndpointsByPlatformApplication",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("PlatformApplicationArn" => PlatformApplicationArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_origination_numbers()
    list_origination_numbers(params::Dict{String,<:Any})

Lists the calling Amazon Web Services account's dedicated origination numbers and their
metadata. For more information about origination numbers, see Origination numbers in the
Amazon SNS Developer Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of origination numbers to return.
- `"NextToken"`: Token that the previous ListOriginationNumbers request returns.
"""
function list_origination_numbers(; aws_config::AbstractAWSConfig=current_aws_config())
    return sns(
        "ListOriginationNumbers"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_origination_numbers(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sns(
        "ListOriginationNumbers",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_phone_numbers_opted_out()
    list_phone_numbers_opted_out(params::Dict{String,<:Any})

Returns a list of phone numbers that are opted out, meaning you cannot send SMS messages to
them. The results for ListPhoneNumbersOptedOut are paginated, and each page returns up to
100 phone numbers. If additional phone numbers are available after the first page of
results, then a NextToken string will be returned. To receive the next page, you call
ListPhoneNumbersOptedOut again using the NextToken string received from the previous call.
When there are no more records to return, NextToken will be null.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: A NextToken string is used when you call the ListPhoneNumbersOptedOut
  action to retrieve additional records that are available after the first page of results.
"""
function list_phone_numbers_opted_out(; aws_config::AbstractAWSConfig=current_aws_config())
    return sns(
        "ListPhoneNumbersOptedOut"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_phone_numbers_opted_out(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sns(
        "ListPhoneNumbersOptedOut",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_platform_applications()
    list_platform_applications(params::Dict{String,<:Any})

Lists the platform application objects for the supported push notification services, such
as APNS and GCM (Firebase Cloud Messaging). The results for ListPlatformApplications are
paginated and return a limited list of applications, up to 100. If additional records are
available after the first page results, then a NextToken string will be returned. To
receive the next page, you call ListPlatformApplications using the NextToken string
received from the previous call. When there are no more records to return, NextToken will
be null. For more information, see Using Amazon SNS Mobile Push Notifications.  This action
is throttled at 15 transactions per second (TPS).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`:  NextToken string is used when calling ListPlatformApplications action to
  retrieve additional records that are available after the first page results.
"""
function list_platform_applications(; aws_config::AbstractAWSConfig=current_aws_config())
    return sns(
        "ListPlatformApplications"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_platform_applications(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sns(
        "ListPlatformApplications",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_smssandbox_phone_numbers()
    list_smssandbox_phone_numbers(params::Dict{String,<:Any})

Lists the calling Amazon Web Services account's current verified and pending destination
phone numbers in the SMS sandbox. When you start using Amazon SNS to send SMS messages,
your Amazon Web Services account is in the SMS sandbox. The SMS sandbox provides a safe
environment for you to try Amazon SNS features without risking your reputation as an SMS
sender. While your Amazon Web Services account is in the SMS sandbox, you can use all of
the features of Amazon SNS. However, you can send SMS messages only to verified destination
phone numbers. For more information, including how to move out of the sandbox to send
messages without restrictions, see SMS sandbox in the Amazon SNS Developer Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of phone numbers to return.
- `"NextToken"`: Token that the previous ListSMSSandboxPhoneNumbersInput request returns.
"""
function list_smssandbox_phone_numbers(; aws_config::AbstractAWSConfig=current_aws_config())
    return sns(
        "ListSMSSandboxPhoneNumbers"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_smssandbox_phone_numbers(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sns(
        "ListSMSSandboxPhoneNumbers",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_subscriptions()
    list_subscriptions(params::Dict{String,<:Any})

Returns a list of the requester's subscriptions. Each call returns a limited list of
subscriptions, up to 100. If there are more subscriptions, a NextToken is also returned.
Use the NextToken parameter in a new ListSubscriptions call to get further results. This
action is throttled at 30 transactions per second (TPS).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: Token returned by the previous ListSubscriptions request.
"""
function list_subscriptions(; aws_config::AbstractAWSConfig=current_aws_config())
    return sns("ListSubscriptions"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_subscriptions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sns(
        "ListSubscriptions", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_subscriptions_by_topic(topic_arn)
    list_subscriptions_by_topic(topic_arn, params::Dict{String,<:Any})

Returns a list of the subscriptions to a specific topic. Each call returns a limited list
of subscriptions, up to 100. If there are more subscriptions, a NextToken is also returned.
Use the NextToken parameter in a new ListSubscriptionsByTopic call to get further results.
This action is throttled at 30 transactions per second (TPS).

# Arguments
- `topic_arn`: The ARN of the topic for which you wish to find subscriptions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: Token returned by the previous ListSubscriptionsByTopic request.
"""
function list_subscriptions_by_topic(
    TopicArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sns(
        "ListSubscriptionsByTopic",
        Dict{String,Any}("TopicArn" => TopicArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_subscriptions_by_topic(
    TopicArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sns(
        "ListSubscriptionsByTopic",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TopicArn" => TopicArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

List all tags added to the specified Amazon SNS topic. For an overview, see Amazon SNS Tags
in the Amazon Simple Notification Service Developer Guide.

# Arguments
- `resource_arn`: The ARN of the topic for which to list tags.

"""
function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sns(
        "ListTagsForResource",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sns(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_topics()
    list_topics(params::Dict{String,<:Any})

Returns a list of the requester's topics. Each call returns a limited list of topics, up to
100. If there are more topics, a NextToken is also returned. Use the NextToken parameter in
a new ListTopics call to get further results. This action is throttled at 30 transactions
per second (TPS).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: Token returned by the previous ListTopics request.
"""
function list_topics(; aws_config::AbstractAWSConfig=current_aws_config())
    return sns("ListTopics"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_topics(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sns("ListTopics", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end

"""
    opt_in_phone_number(phone_number)
    opt_in_phone_number(phone_number, params::Dict{String,<:Any})

Use this request to opt in a phone number that is opted out, which enables you to resume
sending SMS messages to the number. You can opt in a phone number only once every 30 days.

# Arguments
- `phone_number`: The phone number to opt in. Use E.164 format.

"""
function opt_in_phone_number(
    phoneNumber; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sns(
        "OptInPhoneNumber",
        Dict{String,Any}("phoneNumber" => phoneNumber);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function opt_in_phone_number(
    phoneNumber,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sns(
        "OptInPhoneNumber",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("phoneNumber" => phoneNumber), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    publish(message)
    publish(message, params::Dict{String,<:Any})

Sends a message to an Amazon SNS topic, a text message (SMS message) directly to a phone
number, or a message to a mobile platform endpoint (when you specify the TargetArn). If you
send a message to a topic, Amazon SNS delivers the message to each endpoint that is
subscribed to the topic. The format of the message depends on the notification protocol for
each subscribed endpoint. When a messageId is returned, the message is saved and Amazon SNS
immediately delivers it to subscribers. To use the Publish action for publishing a message
to a mobile endpoint, such as an app on a Kindle device or mobile phone, you must specify
the EndpointArn for the TargetArn parameter. The EndpointArn is returned when making a call
with the CreatePlatformEndpoint action.  For more information about formatting messages,
see Send Custom Platform-Specific Payloads in Messages to Mobile Devices.   You can publish
messages only to topics and endpoints in the same Amazon Web Services Region.

# Arguments
- `message`: The message you want to send. If you are publishing to a topic and you want to
  send the same message to all transport protocols, include the text of the message as a
  String value. If you want to send different messages for each transport protocol, set the
  value of the MessageStructure parameter to json and use a JSON object for the Message
  parameter.   Constraints:   With the exception of SMS, messages must be UTF-8 encoded
  strings and at most 256 KB in size (262,144 bytes, not 262,144 characters).   For SMS, each
  message can contain up to 140 characters. This character limit depends on the encoding
  schema. For example, an SMS message can contain 160 GSM characters, 140 ASCII characters,
  or 70 UCS-2 characters. If you publish a message that exceeds this size limit, Amazon SNS
  sends the message as multiple messages, each fitting within the size limit. Messages aren't
  truncated mid-word but are cut off at whole-word boundaries. The total size limit for a
  single SMS Publish action is 1,600 characters.   JSON-specific constraints:   Keys in the
  JSON object that correspond to supported transport protocols must have simple JSON string
  values.   The values will be parsed (unescaped) before they are used in outgoing messages.
   Outbound notifications are JSON encoded (meaning that the characters will be reescaped for
  sending).   Values have a minimum length of 0 (the empty string, \"\", is allowed).
  Values have a maximum length bounded by the overall message size (so, including multiple
  protocols may limit message sizes).   Non-string values will cause the key to be ignored.
  Keys that do not correspond to supported transport protocols are ignored.   Duplicate keys
  are not allowed.   Failure to parse or validate any key or value in the message will cause
  the Publish call to return an error (no partial delivery).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MessageAttributes"`: Message attributes for Publish action.
- `"MessageDeduplicationId"`: This parameter applies only to FIFO (first-in-first-out)
  topics. The MessageDeduplicationId can contain up to 128 alphanumeric characters (a-z, A-Z,
  0-9) and punctuation (!\"#%&amp;'()*+,-./:;&lt;=&gt;?@[]^_`{|}~). Every message must have a
  unique MessageDeduplicationId, which is a token used for deduplication of sent messages. If
  a message with a particular MessageDeduplicationId is sent successfully, any message sent
  with the same MessageDeduplicationId during the 5-minute deduplication interval is treated
  as a duplicate.  If the topic has ContentBasedDeduplication set, the system generates a
  MessageDeduplicationId based on the contents of the message. Your MessageDeduplicationId
  overrides the generated one.
- `"MessageGroupId"`: This parameter applies only to FIFO (first-in-first-out) topics. The
  MessageGroupId can contain up to 128 alphanumeric characters (a-z, A-Z, 0-9) and
  punctuation (!\"#%&amp;'()*+,-./:;&lt;=&gt;?@[]^_`{|}~). The MessageGroupId is a tag that
  specifies that a message belongs to a specific message group. Messages that belong to the
  same message group are processed in a FIFO manner (however, messages in different message
  groups might be processed out of order). Every message must include a MessageGroupId.
- `"MessageStructure"`: Set MessageStructure to json if you want to send a different
  message for each protocol. For example, using one publish action, you can send a short
  message to your SMS subscribers and a longer message to your email subscribers. If you set
  MessageStructure to json, the value of the Message parameter must:    be a syntactically
  valid JSON object; and   contain at least a top-level JSON key of \"default\" with a value
  that is a string.   You can define other top-level keys that define the message you want to
  send to a specific transport protocol (e.g., \"http\"). Valid value: json
- `"PhoneNumber"`: The phone number to which you want to deliver an SMS message. Use E.164
  format. If you don't specify a value for the PhoneNumber parameter, you must specify a
  value for the TargetArn or TopicArn parameters.
- `"Subject"`: Optional parameter to be used as the \"Subject\" line when the message is
  delivered to email endpoints. This field will also be included, if present, in the standard
  JSON messages delivered to other endpoints. Constraints: Subjects must be UTF-8 text with
  no line breaks or control characters, and less than 100 characters long.
- `"TargetArn"`: If you don't specify a value for the TargetArn parameter, you must specify
  a value for the PhoneNumber or TopicArn parameters.
- `"TopicArn"`: The topic you want to publish to. If you don't specify a value for the
  TopicArn parameter, you must specify a value for the PhoneNumber or TargetArn parameters.
"""
function publish(Message; aws_config::AbstractAWSConfig=current_aws_config())
    return sns(
        "Publish",
        Dict{String,Any}("Message" => Message);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function publish(
    Message,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sns(
        "Publish",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Message" => Message), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    publish_batch(publish_batch_request_entries, topic_arn)
    publish_batch(publish_batch_request_entries, topic_arn, params::Dict{String,<:Any})

Publishes up to ten messages to the specified topic. This is a batch version of Publish.
For FIFO topics, multiple messages within a single batch are published in the order they
are sent, and messages are deduplicated within the batch and across batches for 5 minutes.
The result of publishing each message is reported individually in the response. Because the
batch request can result in a combination of successful and unsuccessful actions, you
should check for batch errors even when the call returns an HTTP status code of 200. The
maximum allowed individual message size and the maximum total payload size (the sum of the
individual lengths of all of the batched messages) are both 256 KB (262,144 bytes).  Some
actions take lists of parameters. These lists are specified using the param.n notation.
Values of n are integers starting from 1. For example, a parameter list with two elements
looks like this:  &amp;AttributeName.1=first &amp;AttributeName.2=second If you send a
batch message to a topic, Amazon SNS publishes the batch message to each endpoint that is
subscribed to the topic. The format of the batch message depends on the notification
protocol for each subscribed endpoint. When a messageId is returned, the batch message is
saved and Amazon SNS immediately delivers the message to subscribers.

# Arguments
- `publish_batch_request_entries`: A list of PublishBatch request entries to be sent to the
  SNS topic.
- `topic_arn`: The Amazon resource name (ARN) of the topic you want to batch publish to.

"""
function publish_batch(
    PublishBatchRequestEntries, TopicArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sns(
        "PublishBatch",
        Dict{String,Any}(
            "PublishBatchRequestEntries" => PublishBatchRequestEntries,
            "TopicArn" => TopicArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function publish_batch(
    PublishBatchRequestEntries,
    TopicArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sns(
        "PublishBatch",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "PublishBatchRequestEntries" => PublishBatchRequestEntries,
                    "TopicArn" => TopicArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_data_protection_policy(data_protection_policy, resource_arn)
    put_data_protection_policy(data_protection_policy, resource_arn, params::Dict{String,<:Any})

Adds or updates an inline policy document that is stored in the specified Amazon SNS topic.

# Arguments
- `data_protection_policy`: The JSON serialization of the topic's DataProtectionPolicy. The
  DataProtectionPolicy must be in JSON string format. Length Constraints: Maximum length of
  30,720.
- `resource_arn`: The ARN of the topic whose DataProtectionPolicy you want to add or
  update. For more information about ARNs, see Amazon Resource Names (ARNs) in the Amazon Web
  Services General Reference.

"""
function put_data_protection_policy(
    DataProtectionPolicy, ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sns(
        "PutDataProtectionPolicy",
        Dict{String,Any}(
            "DataProtectionPolicy" => DataProtectionPolicy, "ResourceArn" => ResourceArn
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_data_protection_policy(
    DataProtectionPolicy,
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sns(
        "PutDataProtectionPolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DataProtectionPolicy" => DataProtectionPolicy,
                    "ResourceArn" => ResourceArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_permission(label, topic_arn)
    remove_permission(label, topic_arn, params::Dict{String,<:Any})

Removes a statement from a topic's access control policy.  To remove the ability to change
topic permissions, you must deny permissions to the AddPermission, RemovePermission, and
SetTopicAttributes actions in your IAM policy.

# Arguments
- `label`: The unique label of the statement you want to remove.
- `topic_arn`: The ARN of the topic whose access control policy you wish to modify.

"""
function remove_permission(
    Label, TopicArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sns(
        "RemovePermission",
        Dict{String,Any}("Label" => Label, "TopicArn" => TopicArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_permission(
    Label,
    TopicArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sns(
        "RemovePermission",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("Label" => Label, "TopicArn" => TopicArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    set_endpoint_attributes(attributes, endpoint_arn)
    set_endpoint_attributes(attributes, endpoint_arn, params::Dict{String,<:Any})

Sets the attributes for an endpoint for a device on one of the supported push notification
services, such as GCM (Firebase Cloud Messaging) and APNS. For more information, see Using
Amazon SNS Mobile Push Notifications.

# Arguments
- `attributes`: A map of the endpoint attributes. Attributes in this map include the
  following:    CustomUserData – arbitrary user data to associate with the endpoint. Amazon
  SNS does not use this data. The data must be in UTF-8 format and less than 2KB.    Enabled
  – flag that enables/disables delivery to the endpoint. Amazon SNS will set this to false
  when a notification service indicates to Amazon SNS that the endpoint is invalid. Users can
  set it back to true, typically after updating Token.    Token – device token, also
  referred to as a registration id, for an app and mobile device. This is returned from the
  notification service when an app and mobile device are registered with the notification
  service.
- `endpoint_arn`: EndpointArn used for SetEndpointAttributes action.

"""
function set_endpoint_attributes(
    Attributes, EndpointArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sns(
        "SetEndpointAttributes",
        Dict{String,Any}("Attributes" => Attributes, "EndpointArn" => EndpointArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function set_endpoint_attributes(
    Attributes,
    EndpointArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sns(
        "SetEndpointAttributes",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Attributes" => Attributes, "EndpointArn" => EndpointArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    set_platform_application_attributes(attributes, platform_application_arn)
    set_platform_application_attributes(attributes, platform_application_arn, params::Dict{String,<:Any})

Sets the attributes of the platform application object for the supported push notification
services, such as APNS and GCM (Firebase Cloud Messaging). For more information, see Using
Amazon SNS Mobile Push Notifications. For information on configuring attributes for message
delivery status, see Using Amazon SNS Application Attributes for Message Delivery Status.

# Arguments
- `attributes`: A map of the platform application attributes. Attributes in this map
  include the following:    PlatformCredential – The credential received from the
  notification service.   For ADM, PlatformCredentialis client secret.   For Apple Services
  using certificate credentials, PlatformCredential is private key.   For Apple Services
  using token credentials, PlatformCredential is signing key.   For GCM (Firebase Cloud
  Messaging) using key credentials, there is no PlatformPrincipal. The PlatformCredential is
  API key.   For GCM (Firebase Cloud Messaging) using token credentials, there is no
  PlatformPrincipal. The PlatformCredential is a JSON formatted private key file. When using
  the Amazon Web Services CLI, the file must be in string format and special characters must
  be ignored. To format the file correctly, Amazon SNS recommends using the following
  command: SERVICE_JSON=`jq @json &lt;&lt;&lt; cat service.json`.        PlatformPrincipal
  – The principal received from the notification service.   For ADM, PlatformPrincipalis
  client id.   For Apple Services using certificate credentials, PlatformPrincipal is SSL
  certificate.   For Apple Services using token credentials, PlatformPrincipal is signing key
  ID.   For GCM (Firebase Cloud Messaging), there is no PlatformPrincipal.
  EventEndpointCreated – Topic ARN to which EndpointCreated event notifications are sent.
   EventEndpointDeleted – Topic ARN to which EndpointDeleted event notifications are sent.
    EventEndpointUpdated – Topic ARN to which EndpointUpdate event notifications are sent.
    EventDeliveryFailure – Topic ARN to which DeliveryFailure event notifications are sent
  upon Direct Publish delivery failure (permanent) to one of the application's endpoints.
  SuccessFeedbackRoleArn – IAM role ARN used to give Amazon SNS write access to use
  CloudWatch Logs on your behalf.    FailureFeedbackRoleArn – IAM role ARN used to give
  Amazon SNS write access to use CloudWatch Logs on your behalf.    SuccessFeedbackSampleRate
  – Sample rate percentage (0-100) of successfully delivered messages.   The following
  attributes only apply to APNs token-based authentication:    ApplePlatformTeamID – The
  identifier that's assigned to your Apple developer account team.    ApplePlatformBundleID
  – The bundle identifier that's assigned to your iOS app.
- `platform_application_arn`:  PlatformApplicationArn for SetPlatformApplicationAttributes
  action.

"""
function set_platform_application_attributes(
    Attributes, PlatformApplicationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sns(
        "SetPlatformApplicationAttributes",
        Dict{String,Any}(
            "Attributes" => Attributes, "PlatformApplicationArn" => PlatformApplicationArn
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function set_platform_application_attributes(
    Attributes,
    PlatformApplicationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sns(
        "SetPlatformApplicationAttributes",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Attributes" => Attributes,
                    "PlatformApplicationArn" => PlatformApplicationArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    set_smsattributes(attributes)
    set_smsattributes(attributes, params::Dict{String,<:Any})

Use this request to set the default settings for sending SMS messages and receiving daily
SMS usage reports. You can override some of these settings for a single message when you
use the Publish action with the MessageAttributes.entry.N parameter. For more information,
see Publishing to a mobile phone in the Amazon SNS Developer Guide.  To use this operation,
you must grant the Amazon SNS service principal (sns.amazonaws.com) permission to perform
the s3:ListBucket action.

# Arguments
- `attributes`: The default settings for sending SMS messages from your Amazon Web Services
  account. You can set values for the following attribute names:  MonthlySpendLimit – The
  maximum amount in USD that you are willing to spend each month to send SMS messages. When
  Amazon SNS determines that sending an SMS message would incur a cost that exceeds this
  limit, it stops sending SMS messages within minutes.  Amazon SNS stops sending SMS messages
  within minutes of the limit being crossed. During that interval, if you continue to send
  SMS messages, you will incur costs that exceed your limit.  By default, the spend limit is
  set to the maximum allowed by Amazon SNS. If you want to raise the limit, submit an SNS
  Limit Increase case. For New limit value, enter your desired monthly spend limit. In the
  Use Case Description field, explain that you are requesting an SMS monthly spend limit
  increase.  DeliveryStatusIAMRole – The ARN of the IAM role that allows Amazon SNS to
  write logs about SMS deliveries in CloudWatch Logs. For each SMS message that you send,
  Amazon SNS writes a log that includes the message price, the success or failure status, the
  reason for failure (if the message failed), the message dwell time, and other information.
  DeliveryStatusSuccessSamplingRate – The percentage of successful SMS deliveries for which
  Amazon SNS will write logs in CloudWatch Logs. The value can be an integer from 0 - 100.
  For example, to write logs only for failed deliveries, set this value to 0. To write logs
  for 10% of your successful deliveries, set it to 10.  DefaultSenderID – A string, such as
  your business brand, that is displayed as the sender on the receiving device. Support for
  sender IDs varies by country. The sender ID can be 1 - 11 alphanumeric characters, and it
  must contain at least one letter.  DefaultSMSType – The type of SMS message that you will
  send by default. You can assign the following values:    Promotional – (Default)
  Noncritical messages, such as marketing messages. Amazon SNS optimizes the message delivery
  to incur the lowest cost.    Transactional – Critical messages that support customer
  transactions, such as one-time passcodes for multi-factor authentication. Amazon SNS
  optimizes the message delivery to achieve the highest reliability.    UsageReportS3Bucket
  – The name of the Amazon S3 bucket to receive daily SMS usage reports from Amazon SNS.
  Each day, Amazon SNS will deliver a usage report as a CSV file to the bucket. The report
  includes the following information for each SMS message that was successfully delivered by
  your Amazon Web Services account:   Time that the message was published (in UTC)   Message
  ID   Destination phone number   Message type   Delivery status   Message price (in USD)
  Part number (a message is split into multiple parts if it is too long for a single message)
    Total number of parts   To receive the report, the bucket must have a policy that allows
  the Amazon SNS service principal to perform the s3:PutObject and s3:GetBucketLocation
  actions. For an example bucket policy and usage report, see Monitoring SMS Activity in the
  Amazon SNS Developer Guide.

"""
function set_smsattributes(attributes; aws_config::AbstractAWSConfig=current_aws_config())
    return sns(
        "SetSMSAttributes",
        Dict{String,Any}("attributes" => attributes);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function set_smsattributes(
    attributes,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sns(
        "SetSMSAttributes",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("attributes" => attributes), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    set_subscription_attributes(attribute_name, subscription_arn)
    set_subscription_attributes(attribute_name, subscription_arn, params::Dict{String,<:Any})

Allows a subscription owner to set an attribute of the subscription to a new value.

# Arguments
- `attribute_name`: A map of attributes with their corresponding values. The following
  lists the names, descriptions, and values of the special request parameters that this
  action uses:    DeliveryPolicy – The policy that defines how Amazon SNS retries failed
  deliveries to HTTP/S endpoints.    FilterPolicy – The simple JSON object that lets your
  subscriber receive only a subset of messages, rather than receiving every message published
  to the topic.    FilterPolicyScope – This attribute lets you choose the filtering scope
  by using one of the following string value types:    MessageAttributes (default) – The
  filter is applied on the message attributes.    MessageBody – The filter is applied on
  the message body.      RawMessageDelivery – When set to true, enables raw message
  delivery to Amazon SQS or HTTP/S endpoints. This eliminates the need for the endpoints to
  process JSON formatting, which is otherwise created for Amazon SNS metadata.
  RedrivePolicy – When specified, sends undeliverable messages to the specified Amazon SQS
  dead-letter queue. Messages that can't be delivered due to client errors (for example, when
  the subscribed endpoint is unreachable) or server errors (for example, when the service
  that powers the subscribed endpoint becomes unavailable) are held in the dead-letter queue
  for further analysis or reprocessing.   The following attribute applies only to Amazon Data
  Firehose delivery stream subscriptions:    SubscriptionRoleArn – The ARN of the IAM role
  that has the following:   Permission to write to the Firehose delivery stream   Amazon SNS
  listed as a trusted entity   Specifying a valid ARN for this attribute is required for
  Firehose delivery stream subscriptions. For more information, see Fanout to Firehose
  delivery streams in the Amazon SNS Developer Guide.
- `subscription_arn`: The ARN of the subscription to modify.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AttributeValue"`: The new value for the attribute in JSON format.
"""
function set_subscription_attributes(
    AttributeName, SubscriptionArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sns(
        "SetSubscriptionAttributes",
        Dict{String,Any}(
            "AttributeName" => AttributeName, "SubscriptionArn" => SubscriptionArn
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function set_subscription_attributes(
    AttributeName,
    SubscriptionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sns(
        "SetSubscriptionAttributes",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AttributeName" => AttributeName, "SubscriptionArn" => SubscriptionArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    set_topic_attributes(attribute_name, topic_arn)
    set_topic_attributes(attribute_name, topic_arn, params::Dict{String,<:Any})

Allows a topic owner to set an attribute of the topic to a new value.  To remove the
ability to change topic permissions, you must deny permissions to the AddPermission,
RemovePermission, and SetTopicAttributes actions in your IAM policy.

# Arguments
- `attribute_name`: A map of attributes with their corresponding values. The following
  lists the names, descriptions, and values of the special request parameters that the
  SetTopicAttributes action uses:    ApplicationSuccessFeedbackRoleArn – Indicates failed
  message delivery status for an Amazon SNS topic that is subscribed to a platform
  application endpoint.    DeliveryPolicy – The policy that defines how Amazon SNS retries
  failed deliveries to HTTP/S endpoints.    DisplayName – The display name to use for a
  topic with SMS subscriptions.    Policy – The policy that defines who can access your
  topic. By default, only the topic owner can publish or subscribe to the topic.
  TracingConfig – Tracing mode of an Amazon SNS topic. By default TracingConfig is set to
  PassThrough, and the topic passes through the tracing header it receives from an Amazon SNS
  publisher to its subscriptions. If set to Active, Amazon SNS will vend X-Ray segment data
  to topic owner account if the sampled flag in the tracing header is true. This is only
  supported on standard topics.   HTTP    HTTPSuccessFeedbackRoleArn – Indicates successful
  message delivery status for an Amazon SNS topic that is subscribed to an HTTP endpoint.
  HTTPSuccessFeedbackSampleRate – Indicates percentage of successful messages to sample for
  an Amazon SNS topic that is subscribed to an HTTP endpoint.    HTTPFailureFeedbackRoleArn
  – Indicates failed message delivery status for an Amazon SNS topic that is subscribed to
  an HTTP endpoint.     Amazon Kinesis Data Firehose    FirehoseSuccessFeedbackRoleArn –
  Indicates successful message delivery status for an Amazon SNS topic that is subscribed to
  an Amazon Kinesis Data Firehose endpoint.    FirehoseSuccessFeedbackSampleRate –
  Indicates percentage of successful messages to sample for an Amazon SNS topic that is
  subscribed to an Amazon Kinesis Data Firehose endpoint.    FirehoseFailureFeedbackRoleArn
  – Indicates failed message delivery status for an Amazon SNS topic that is subscribed to
  an Amazon Kinesis Data Firehose endpoint.      Lambda    LambdaSuccessFeedbackRoleArn –
  Indicates successful message delivery status for an Amazon SNS topic that is subscribed to
  an Lambda endpoint.    LambdaSuccessFeedbackSampleRate – Indicates percentage of
  successful messages to sample for an Amazon SNS topic that is subscribed to an Lambda
  endpoint.    LambdaFailureFeedbackRoleArn – Indicates failed message delivery status for
  an Amazon SNS topic that is subscribed to an Lambda endpoint.      Platform application
  endpoint    ApplicationSuccessFeedbackRoleArn – Indicates successful message delivery
  status for an Amazon SNS topic that is subscribed to an Amazon Web Services application
  endpoint.    ApplicationSuccessFeedbackSampleRate – Indicates percentage of successful
  messages to sample for an Amazon SNS topic that is subscribed to an Amazon Web Services
  application endpoint.    ApplicationFailureFeedbackRoleArn – Indicates failed message
  delivery status for an Amazon SNS topic that is subscribed to an Amazon Web Services
  application endpoint.    In addition to being able to configure topic attributes for
  message delivery status of notification messages sent to Amazon SNS application endpoints,
  you can also configure application attributes for the delivery status of push notification
  messages sent to push notification services. For example, For more information, see Using
  Amazon SNS Application Attributes for Message Delivery Status.     Amazon SQS
  SQSSuccessFeedbackRoleArn – Indicates successful message delivery status for an Amazon
  SNS topic that is subscribed to an Amazon SQS endpoint.     SQSSuccessFeedbackSampleRate
  – Indicates percentage of successful messages to sample for an Amazon SNS topic that is
  subscribed to an Amazon SQS endpoint.     SQSFailureFeedbackRoleArn – Indicates failed
  message delivery status for an Amazon SNS topic that is subscribed to an Amazon SQS
  endpoint.       The &lt;ENDPOINT&gt;SuccessFeedbackRoleArn and
  &lt;ENDPOINT&gt;FailureFeedbackRoleArn attributes are used to give Amazon SNS write access
  to use CloudWatch Logs on your behalf. The &lt;ENDPOINT&gt;SuccessFeedbackSampleRate
  attribute is for specifying the sample rate percentage (0-100) of successfully delivered
  messages. After you configure the &lt;ENDPOINT&gt;FailureFeedbackRoleArn attribute, then
  all failed message deliveries generate CloudWatch Logs.   The following attribute applies
  only to server-side-encryption:    KmsMasterKeyId – The ID of an Amazon Web Services
  managed customer master key (CMK) for Amazon SNS or a custom CMK. For more information, see
  Key Terms. For more examples, see KeyId in the Key Management Service API Reference.
  SignatureVersion – The signature version corresponds to the hashing algorithm used while
  creating the signature of the notifications, subscription confirmations, or unsubscribe
  confirmation messages sent by Amazon SNS. By default, SignatureVersion is set to 1.   The
  following attribute applies only to FIFO topics:    ContentBasedDeduplication – Enables
  content-based deduplication for FIFO topics.   By default, ContentBasedDeduplication is set
  to false. If you create a FIFO topic and this attribute is false, you must specify a value
  for the MessageDeduplicationId parameter for the Publish action.    When you set
  ContentBasedDeduplication to true, Amazon SNS uses a SHA-256 hash to generate the
  MessageDeduplicationId using the body of the message (but not the attributes of the
  message). (Optional) To override the generated value, you can specify a value for the
  MessageDeduplicationId parameter for the Publish action.
- `topic_arn`: The ARN of the topic to modify.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AttributeValue"`: The new value for the attribute.
"""
function set_topic_attributes(
    AttributeName, TopicArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sns(
        "SetTopicAttributes",
        Dict{String,Any}("AttributeName" => AttributeName, "TopicArn" => TopicArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function set_topic_attributes(
    AttributeName,
    TopicArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sns(
        "SetTopicAttributes",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("AttributeName" => AttributeName, "TopicArn" => TopicArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    subscribe(protocol, topic_arn)
    subscribe(protocol, topic_arn, params::Dict{String,<:Any})

Subscribes an endpoint to an Amazon SNS topic. If the endpoint type is HTTP/S or email, or
if the endpoint and the topic are not in the same Amazon Web Services account, the endpoint
owner must run the ConfirmSubscription action to confirm the subscription. You call the
ConfirmSubscription action with the token from the subscription response. Confirmation
tokens are valid for two days. This action is throttled at 100 transactions per second
(TPS).

# Arguments
- `protocol`: The protocol that you want to use. Supported protocols include:    http –
  delivery of JSON-encoded message via HTTP POST    https – delivery of JSON-encoded
  message via HTTPS POST    email – delivery of message via SMTP    email-json – delivery
  of JSON-encoded message via SMTP    sms – delivery of message via SMS    sqs – delivery
  of JSON-encoded message to an Amazon SQS queue    application – delivery of JSON-encoded
  message to an EndpointArn for a mobile app and device    lambda – delivery of
  JSON-encoded message to an Lambda function    firehose – delivery of JSON-encoded message
  to an Amazon Kinesis Data Firehose delivery stream.
- `topic_arn`: The ARN of the topic you want to subscribe to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Attributes"`: A map of attributes with their corresponding values. The following lists
  the names, descriptions, and values of the special request parameters that the Subscribe
  action uses:    DeliveryPolicy – The policy that defines how Amazon SNS retries failed
  deliveries to HTTP/S endpoints.    FilterPolicy – The simple JSON object that lets your
  subscriber receive only a subset of messages, rather than receiving every message published
  to the topic.    FilterPolicyScope – This attribute lets you choose the filtering scope
  by using one of the following string value types:    MessageAttributes (default) – The
  filter is applied on the message attributes.    MessageBody – The filter is applied on
  the message body.      RawMessageDelivery – When set to true, enables raw message
  delivery to Amazon SQS or HTTP/S endpoints. This eliminates the need for the endpoints to
  process JSON formatting, which is otherwise created for Amazon SNS metadata.
  RedrivePolicy – When specified, sends undeliverable messages to the specified Amazon SQS
  dead-letter queue. Messages that can't be delivered due to client errors (for example, when
  the subscribed endpoint is unreachable) or server errors (for example, when the service
  that powers the subscribed endpoint becomes unavailable) are held in the dead-letter queue
  for further analysis or reprocessing.   The following attribute applies only to Amazon Data
  Firehose delivery stream subscriptions:    SubscriptionRoleArn – The ARN of the IAM role
  that has the following:   Permission to write to the Firehose delivery stream   Amazon SNS
  listed as a trusted entity   Specifying a valid ARN for this attribute is required for
  Firehose delivery stream subscriptions. For more information, see Fanout to Firehose
  delivery streams in the Amazon SNS Developer Guide.   The following attributes apply only
  to FIFO topics:    ReplayPolicy – Adds or updates an inline policy document for a
  subscription to replay messages stored in the specified Amazon SNS topic.    ReplayStatus
  – Retrieves the status of the subscription message replay, which can be one of the
  following:    Completed – The replay has successfully redelivered all messages, and is
  now delivering newly published messages. If an ending point was specified in the
  ReplayPolicy then the subscription will no longer receive newly published messages.    In
  progress – The replay is currently replaying the selected messages.    Failed – The
  replay was unable to complete.    Pending – The default state while the replay initiates.
  
- `"Endpoint"`: The endpoint that you want to receive notifications. Endpoints vary by
  protocol:   For the http protocol, the (public) endpoint is a URL beginning with http://.
  For the https protocol, the (public) endpoint is a URL beginning with https://.   For the
  email protocol, the endpoint is an email address.   For the email-json protocol, the
  endpoint is an email address.   For the sms protocol, the endpoint is a phone number of an
  SMS-enabled device.   For the sqs protocol, the endpoint is the ARN of an Amazon SQS queue.
    For the application protocol, the endpoint is the EndpointArn of a mobile app and device.
    For the lambda protocol, the endpoint is the ARN of an Lambda function.   For the
  firehose protocol, the endpoint is the ARN of an Amazon Kinesis Data Firehose delivery
  stream.
- `"ReturnSubscriptionArn"`: Sets whether the response from the Subscribe request includes
  the subscription ARN, even if the subscription is not yet confirmed. If you set this
  parameter to true, the response includes the ARN in all cases, even if the subscription is
  not yet confirmed. In addition to the ARN for confirmed subscriptions, the response also
  includes the pending subscription ARN value for subscriptions that aren't yet confirmed. A
  subscription becomes confirmed when the subscriber calls the ConfirmSubscription action
  with a confirmation token.  The default value is false.
"""
function subscribe(Protocol, TopicArn; aws_config::AbstractAWSConfig=current_aws_config())
    return sns(
        "Subscribe",
        Dict{String,Any}("Protocol" => Protocol, "TopicArn" => TopicArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function subscribe(
    Protocol,
    TopicArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sns(
        "Subscribe",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Protocol" => Protocol, "TopicArn" => TopicArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Add tags to the specified Amazon SNS topic. For an overview, see Amazon SNS Tags in the
Amazon SNS Developer Guide. When you use topic tags, keep the following guidelines in mind:
  Adding more than 50 tags to a topic isn't recommended.   Tags don't have any semantic
meaning. Amazon SNS interprets tags as character strings.   Tags are case-sensitive.   A
new tag with a key identical to that of an existing tag overwrites the existing tag.
Tagging actions are limited to 10 TPS per Amazon Web Services account, per Amazon Web
Services Region. If your application requires a higher throughput, file a technical support
request.

# Arguments
- `resource_arn`: The ARN of the topic to which to add tags.
- `tags`: The tags to be added to the specified topic. A tag consists of a required key and
  an optional value.

"""
function tag_resource(ResourceArn, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return sns(
        "TagResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceArn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sns(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    unsubscribe(subscription_arn)
    unsubscribe(subscription_arn, params::Dict{String,<:Any})

Deletes a subscription. If the subscription requires authentication for deletion, only the
owner of the subscription or the topic's owner can unsubscribe, and an Amazon Web Services
signature is required. If the Unsubscribe call does not require authentication and the
requester is not the subscription owner, a final cancellation message is delivered to the
endpoint, so that the endpoint owner can easily resubscribe to the topic if the Unsubscribe
request was unintended.  Amazon SQS queue subscriptions require authentication for
deletion. Only the owner of the subscription, or the owner of the topic can unsubscribe
using the required Amazon Web Services signature.  This action is throttled at 100
transactions per second (TPS).

# Arguments
- `subscription_arn`: The ARN of the subscription to be deleted.

"""
function unsubscribe(SubscriptionArn; aws_config::AbstractAWSConfig=current_aws_config())
    return sns(
        "Unsubscribe",
        Dict{String,Any}("SubscriptionArn" => SubscriptionArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function unsubscribe(
    SubscriptionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sns(
        "Unsubscribe",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("SubscriptionArn" => SubscriptionArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Remove tags from the specified Amazon SNS topic. For an overview, see Amazon SNS Tags in
the Amazon SNS Developer Guide.

# Arguments
- `resource_arn`: The ARN of the topic from which to remove tags.
- `tag_keys`: The list of tag keys to remove from the specified topic.

"""
function untag_resource(
    ResourceArn, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sns(
        "UntagResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceArn,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sns(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    verify_smssandbox_phone_number(one_time_password, phone_number)
    verify_smssandbox_phone_number(one_time_password, phone_number, params::Dict{String,<:Any})

Verifies a destination phone number with a one-time password (OTP) for the calling Amazon
Web Services account. When you start using Amazon SNS to send SMS messages, your Amazon Web
Services account is in the SMS sandbox. The SMS sandbox provides a safe environment for you
to try Amazon SNS features without risking your reputation as an SMS sender. While your
Amazon Web Services account is in the SMS sandbox, you can use all of the features of
Amazon SNS. However, you can send SMS messages only to verified destination phone numbers.
For more information, including how to move out of the sandbox to send messages without
restrictions, see SMS sandbox in the Amazon SNS Developer Guide.

# Arguments
- `one_time_password`: The OTP sent to the destination number from the
  CreateSMSSandBoxPhoneNumber call.
- `phone_number`: The destination phone number to verify.

"""
function verify_smssandbox_phone_number(
    OneTimePassword, PhoneNumber; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sns(
        "VerifySMSSandboxPhoneNumber",
        Dict{String,Any}(
            "OneTimePassword" => OneTimePassword, "PhoneNumber" => PhoneNumber
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function verify_smssandbox_phone_number(
    OneTimePassword,
    PhoneNumber,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sns(
        "VerifySMSSandboxPhoneNumber",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "OneTimePassword" => OneTimePassword, "PhoneNumber" => PhoneNumber
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    IMDS

Front-end for retrieving AWS instance metadata via the Instance Metadata Service (IMDS). For
details on available metadata see the official AWS documentation on:
["Instance metadata and user data"](https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/ec2-instance-metadata.html).

The IMDS module supports instances using either IMDSv1 or IMDSv2 (preferring IMDSv2 for
security reasons).
"""
module IMDS

using ..AWSExceptions: IMDSUnavailable

using HTTP: HTTP
using HTTP.Exceptions: ConnectError, StatusError
using Mocking
using URIs: URI

# Local-link address (https://en.wikipedia.org/wiki/Link-local_address)
const IPv4_ADDRESS = "169.254.169.254"
const DEFAULT_DURATION = 600  # 5 minutes, in seconds

mutable struct Session
    token::String
    duration::Int16
    expiration::Int64
end

const _SESSION = Ref{Session}()

function __init__()
    _SESSION[] = Session()
    return nothing
end

"""
    Session(; duration=$DEFAULT_DURATION)

An IMDS `Session` which retains the IMDSv2 token over multiple requests. When IMDSv2 is
unavailable the session switches to IMDSv1 mode and avoids future requests for IMDSv2
tokens.

# Keywords
- `duration` (optional): Requested session duration, in seconds, for the IMDSv2 token. Can
  be a minimum of one second and a maximum of six hours (21600).
"""
Session(; duration=DEFAULT_DURATION) = Session("", duration, 0)

token_expired(session::Session; drift=10) = time() - session.expiration - drift > 0

function refresh_token!(session::Session, duration::Integer=session.duration)
    t = floor(Int64, time())
    headers = ["X-aws-ec2-metadata-token-ttl-seconds" => string(duration)]

    # For IMDSv2, you must use `/latest/api/token` when retrieving the token instead of a
    # version specific path.
    # https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instancedata-data-retrieval.html#imds-considerations
    uri = URI(; scheme="http", host=IPv4_ADDRESS, path="/latest/api/token")
    r = try
        _http_request("PUT", uri, headers; status_exception=false, retry=false)
    catch e
        # The IMDSv2 uses a default Time To Live (TTL) of 1 (also known as the hop limit) at
        # the IP layer to ensure token requests occur on the instance. When this occurs we
        # need to fall back to using IMDSv1. Users may wish to increase the hop limit to
        # allow for IMDSv2 use in container based environments:
        # https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instancedata-data-retrieval.html#imds-considerations
        if is_ttl_expired_exception(e)
            @warn "IMDSv2 token request rejected due to reaching hop limit. Consider " *
                "increasing the hop limit to avoid delays upon initial use:\n" *
                "https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/" *
                "instancedata-data-retrieval.html#imds-considerations"

            session.token = ""
            session.duration = 0
            session.expiration = typemax(Int64)  # Use IMDSv1 indefinitely
            return session
        else
            rethrow()
        end
    end

    # Store the session token when we receive an HTTP 200. If we receive an HTTP 404 assume
    # that the server is only supports IMDSv1. Otherwise "rethrow" the `StatusError`.
    if r.status == 200
        session.token = String(r.body)
        session.duration = duration
        session.expiration = t + duration
    elseif r.status == 404
        session.token = ""
        session.duration = 0
        session.expiration = typemax(Int64)  # Use IMDSv1 indefinitely
    else
        # Could also populate the `StatusError` via `r.request.method` and
        # `r.request.target` however `r.request` may not be populated under test scenarios.
        throw(StatusError(r.status, "PUT", uri.path, r))
    end

    return session
end

function request(
    session::Session, method::AbstractString, path::AbstractString; status_exception=true
)
    # Only allow the token to be refreshed once per call to `IMDS.request`.
    allow_refresh = true

    # Attempt to generate token for use with IMDSv2. If we're unable to generate a token
    # we'll fall back on using IMDSv1. We prefer using IMDSv2 as instances can be configured
    # to disable IMDSv1 access: https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/configuring-IMDS-new-instances.html#configure-IMDS-new-instances
    if token_expired(session)
        refresh_token!(session)
        allow_refresh = false
    end
    headers = HTTP.Header[]
    if !isempty(session.token)
        HTTP.setheader(headers, "X-aws-ec2-metadata-token" => session.token)
    end

    # Only using the IPv4 endpoint as the IPv6 endpoint has to be explicitly enabled and
    # does not disable IPv4 support.
    # https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/configuring-IMDS-new-instances.html#configure-IMDS-new-instances-ipv4-ipv6-endpoints
    uri = URI(; scheme="http", host=IPv4_ADDRESS, path)

    # Refresh the token and immediately retry if we encounter "HTTP 401 Unauthorized".
    #
    # > When token usage is set to `required` (IMDSv2), requests without a valid token or
    # > with an expired token receive a `401 - Unauthorized` HTTP error code.
    # https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/configuring-instance-metadata-service.html#instance-metadata-v2-how-it-works
    retry_delays = [0]
    function retry_check(s, e, request, response, response_body)
        if allow_refresh && e isa StatusError && e.status == 401 && !isempty(session.token)
            refresh_token!(session)
            allow_refresh = false
            HTTP.setheader(request.headers, "X-aws-ec2-metadata-token" => session.token)
            return true
        else
            return false
        end
    end

    return _http_request(method, uri, headers; retry_delays, retry_check, status_exception)
end

function _http_request(args...; status_exception=true, kwargs...)
    response = try
        # Override the user's `status_exception` so we can consistently handle status
        # exceptions. Additionally, by forcing `status_exception=true` this allows retries
        # to work.
        #
        # Additionally, we set a low connect timeout to have faster responses when
        # attempting to connect to IMDS outside of EC2.
        @mock HTTP.request(args...; connect_timeout=1, kwargs..., status_exception=true)
    catch e
        # When running outside of an EC2 instance the link-local address will be unavailable
        # and connections will fail. On EC2 instances where IMDS is disabled a HTTP 403 is
        # returned.
        # https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instancedata-data-retrieval.html#instance-metadata-returns
        if is_connection_exception(e) || e isa StatusError && e.status == 403
            throw(IMDSUnavailable())

        #! format: off
        # Return the status exception when `status_exception=false`. We must always cause
        # `HTTP.request` to throw status errors for our `IMDSUnavailable` check.
        #! format: on
        elseif !status_exception && e isa StatusError
            e.response
        else
            rethrow()
        end
    end

    return response
end

is_connection_exception(e::ConnectError) = true
is_connection_exception(e::Exception) = false

# https://github.com/JuliaCloud/AWS.jl/issues/654
# https://github.com/JuliaCloud/AWS.jl/issues/649
function is_ttl_expired_exception(e::HTTP.Exceptions.RequestError)
    return e.error == Base.IOError("read: connection timed out (ETIMEDOUT)", -110)
end
is_ttl_expired_exception(e::Exception) = false

"""
    get([session::Session], path::AbstractString) -> Union{String, Nothing}

Retrieve the AWS instance metadata from the provided HTTP `path`. If the specific metadata
resource is unavailable or the instance metadata is unavailable (due to the instance metadata
service being disabled or not being run from within an EC2 instance) then `nothing` will be
returned. For details on available metadata see the official AWS documentation on:
["Instance metadata and user data"](https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/ec2-instance-metadata.html).

# Arguments
- `session` (optional): The IMDS `Session` used to store the IMDSv2 token.
- `path`: The HTTP path to used to specify the metadata to return.
"""
function get(session::Session, path::AbstractString)
    response = try
        request(session, "GET", path)
    catch e
        if e isa IMDSUnavailable || e isa StatusError && e.status == 404
            nothing
        else
            rethrow()
        end
    end

    return !isnothing(response) ? String(response.body) : nothing
end

get(path::AbstractString) = get(_SESSION[], path)

"""
    region([session::Session]) -> Union{String, Nothing}

Determine the AWS region of the machine executing this code if running inside of an EC2
instance, otherwise `nothing` is returned.

# Arguments
- `session` (optional): The IMDS `Session` used to store the IMDSv2 token.
"""
region(session::Session) = get(session, "/latest/meta-data/placement/region")
region() = region(_SESSION[])

end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: wafv2
using AWS.Compat
using AWS.UUIDs

"""
    associate_web_acl(resource_arn, web_aclarn)
    associate_web_acl(resource_arn, web_aclarn, params::Dict{String,<:Any})

Associates a web ACL with a regional application resource, to protect the resource. A
regional application can be an Application Load Balancer (ALB), an Amazon API Gateway REST
API, an AppSync GraphQL API, an Amazon Cognito user pool, an App Runner service, or an
Amazon Web Services Verified Access instance.  For Amazon CloudFront, don't use this call.
Instead, use your CloudFront distribution configuration. To associate a web ACL, in the
CloudFront call UpdateDistribution, set the web ACL ID to the Amazon Resource Name (ARN) of
the web ACL. For information, see UpdateDistribution in the Amazon CloudFront Developer
Guide.   Required permissions for customer-managed IAM policies  This call requires
permissions that are specific to the protected resource type. For details, see Permissions
for AssociateWebACL in the WAF Developer Guide.   Temporary inconsistencies during updates
When you create or change a web ACL or other WAF resources, the changes take a small amount
of time to propagate to all areas where the resources are stored. The propagation time can
be from a few seconds to a number of minutes.  The following are examples of the temporary
inconsistencies that you might notice during change propagation:    After you create a web
ACL, if you try to associate it with a resource, you might get an exception indicating that
the web ACL is unavailable.    After you add a rule group to a web ACL, the new rule group
rules might be in effect in one area where the web ACL is used and not in another.   After
you change a rule action setting, you might see the old action in some places and the new
action in others.    After you add an IP address to an IP set that is in use in a blocking
rule, the new address might be blocked in one area while still allowed in another.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource to associate with the web
  ACL.  The ARN must be in one of the following formats:   For an Application Load Balancer:
  arn:partition:elasticloadbalancing:region:account-id:loadbalancer/app/load-balancer-name/loa
  d-balancer-id     For an Amazon API Gateway REST API:
  arn:partition:apigateway:region::/restapis/api-id/stages/stage-name     For an AppSync
  GraphQL API: arn:partition:appsync:region:account-id:apis/GraphQLApiId     For an Amazon
  Cognito user pool: arn:partition:cognito-idp:region:account-id:userpool/user-pool-id
  For an App Runner service:
  arn:partition:apprunner:region:account-id:service/apprunner-service-name/apprunner-service-i
  d     For an Amazon Web Services Verified Access instance:
  arn:partition:ec2:region:account-id:verified-access-instance/instance-id
- `web_aclarn`: The Amazon Resource Name (ARN) of the web ACL that you want to associate
  with the resource.

"""
function associate_web_acl(
    ResourceArn, WebACLArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wafv2(
        "AssociateWebACL",
        Dict{String,Any}("ResourceArn" => ResourceArn, "WebACLArn" => WebACLArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_web_acl(
    ResourceArn,
    WebACLArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wafv2(
        "AssociateWebACL",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "WebACLArn" => WebACLArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    check_capacity(rules, scope)
    check_capacity(rules, scope, params::Dict{String,<:Any})

Returns the web ACL capacity unit (WCU) requirements for a specified scope and set of
rules. You can use this to check the capacity requirements for the rules you want to use in
a RuleGroup or WebACL.  WAF uses WCUs to calculate and control the operating resources that
are used to run your rules, rule groups, and web ACLs. WAF calculates capacity differently
for each rule type, to reflect the relative cost of each rule. Simple rules that cost
little to run use fewer WCUs than more complex rules that use more processing power. Rule
group capacity is fixed at creation, which helps users plan their web ACL WCU usage when
they use a rule group. For more information, see WAF web ACL capacity units (WCU) in the
WAF Developer Guide.

# Arguments
- `rules`: An array of Rule that you're configuring to use in a rule group or web ACL.
- `scope`: Specifies whether this is for an Amazon CloudFront distribution or for a
  regional application. A regional application can be an Application Load Balancer (ALB), an
  Amazon API Gateway REST API, an AppSync GraphQL API, an Amazon Cognito user pool, an App
  Runner service, or an Amazon Web Services Verified Access instance.  To work with
  CloudFront, you must also specify the Region US East (N. Virginia) as follows:    CLI -
  Specify the Region when you use the CloudFront scope: --scope=CLOUDFRONT
  --region=us-east-1.    API and SDKs - For all calls, use the Region endpoint us-east-1.

"""
function check_capacity(Rules, Scope; aws_config::AbstractAWSConfig=current_aws_config())
    return wafv2(
        "CheckCapacity",
        Dict{String,Any}("Rules" => Rules, "Scope" => Scope);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function check_capacity(
    Rules,
    Scope,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wafv2(
        "CheckCapacity",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Rules" => Rules, "Scope" => Scope), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_apikey(scope, token_domains)
    create_apikey(scope, token_domains, params::Dict{String,<:Any})

Creates an API key that contains a set of token domains. API keys are required for the
integration of the CAPTCHA API in your JavaScript client applications. The API lets you
customize the placement and characteristics of the CAPTCHA puzzle for your end users. For
more information about the CAPTCHA JavaScript integration, see WAF client application
integration in the WAF Developer Guide. You can use a single key for up to 5 domains. After
you generate a key, you can copy it for use in your JavaScript integration.

# Arguments
- `scope`: Specifies whether this is for an Amazon CloudFront distribution or for a
  regional application. A regional application can be an Application Load Balancer (ALB), an
  Amazon API Gateway REST API, an AppSync GraphQL API, an Amazon Cognito user pool, an App
  Runner service, or an Amazon Web Services Verified Access instance.  To work with
  CloudFront, you must also specify the Region US East (N. Virginia) as follows:    CLI -
  Specify the Region when you use the CloudFront scope: --scope=CLOUDFRONT
  --region=us-east-1.    API and SDKs - For all calls, use the Region endpoint us-east-1.
- `token_domains`: The client application domains that you want to use this API key for.
  Example JSON: \"TokenDomains\": [\"abc.com\", \"store.abc.com\"]  Public suffixes aren't
  allowed. For example, you can't use gov.au or co.uk as token domains.

"""
function create_apikey(
    Scope, TokenDomains; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wafv2(
        "CreateAPIKey",
        Dict{String,Any}("Scope" => Scope, "TokenDomains" => TokenDomains);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_apikey(
    Scope,
    TokenDomains,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wafv2(
        "CreateAPIKey",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Scope" => Scope, "TokenDomains" => TokenDomains),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_ipset(addresses, ipaddress_version, name, scope)
    create_ipset(addresses, ipaddress_version, name, scope, params::Dict{String,<:Any})

Creates an IPSet, which you use to identify web requests that originate from specific IP
addresses or ranges of IP addresses. For example, if you're receiving a lot of requests
from a ranges of IP addresses, you can configure WAF to block them using an IPSet that
lists those IP addresses.

# Arguments
- `addresses`: Contains an array of strings that specifies zero or more IP addresses or
  blocks of IP addresses that you want WAF to inspect for in incoming requests. All addresses
  must be specified using Classless Inter-Domain Routing (CIDR) notation. WAF supports all
  IPv4 and IPv6 CIDR ranges except for /0.  Example address strings:    For requests that
  originated from the IP address 192.0.2.44, specify 192.0.2.44/32.   For requests that
  originated from IP addresses from 192.0.2.0 to 192.0.2.255, specify 192.0.2.0/24.   For
  requests that originated from the IP address 1111:0000:0000:0000:0000:0000:0000:0111,
  specify 1111:0000:0000:0000:0000:0000:0000:0111/128.   For requests that originated from IP
  addresses 1111:0000:0000:0000:0000:0000:0000:0000 to
  1111:0000:0000:0000:ffff:ffff:ffff:ffff, specify
  1111:0000:0000:0000:0000:0000:0000:0000/64.   For more information about CIDR notation, see
  the Wikipedia entry Classless Inter-Domain Routing. Example JSON Addresses specifications:
    Empty array: \"Addresses\": []    Array with one address: \"Addresses\":
  [\"192.0.2.44/32\"]    Array with three addresses: \"Addresses\": [\"192.0.2.44/32\",
  \"192.0.2.0/24\", \"192.0.0.0/16\"]    INVALID specification: \"Addresses\": [\"\"] INVALID
  
- `ipaddress_version`: The version of the IP addresses, either IPV4 or IPV6.
- `name`: The name of the IP set. You cannot change the name of an IPSet after you create
  it.
- `scope`: Specifies whether this is for an Amazon CloudFront distribution or for a
  regional application. A regional application can be an Application Load Balancer (ALB), an
  Amazon API Gateway REST API, an AppSync GraphQL API, an Amazon Cognito user pool, an App
  Runner service, or an Amazon Web Services Verified Access instance.  To work with
  CloudFront, you must also specify the Region US East (N. Virginia) as follows:    CLI -
  Specify the Region when you use the CloudFront scope: --scope=CLOUDFRONT
  --region=us-east-1.    API and SDKs - For all calls, use the Region endpoint us-east-1.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description of the IP set that helps with identification.
- `"Tags"`: An array of key:value pairs to associate with the resource.
"""
function create_ipset(
    Addresses,
    IPAddressVersion,
    Name,
    Scope;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wafv2(
        "CreateIPSet",
        Dict{String,Any}(
            "Addresses" => Addresses,
            "IPAddressVersion" => IPAddressVersion,
            "Name" => Name,
            "Scope" => Scope,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_ipset(
    Addresses,
    IPAddressVersion,
    Name,
    Scope,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wafv2(
        "CreateIPSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Addresses" => Addresses,
                    "IPAddressVersion" => IPAddressVersion,
                    "Name" => Name,
                    "Scope" => Scope,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_regex_pattern_set(name, regular_expression_list, scope)
    create_regex_pattern_set(name, regular_expression_list, scope, params::Dict{String,<:Any})

Creates a RegexPatternSet, which you reference in a RegexPatternSetReferenceStatement, to
have WAF inspect a web request component for the specified patterns.

# Arguments
- `name`: The name of the set. You cannot change the name after you create the set.
- `regular_expression_list`: Array of regular expression strings.
- `scope`: Specifies whether this is for an Amazon CloudFront distribution or for a
  regional application. A regional application can be an Application Load Balancer (ALB), an
  Amazon API Gateway REST API, an AppSync GraphQL API, an Amazon Cognito user pool, an App
  Runner service, or an Amazon Web Services Verified Access instance.  To work with
  CloudFront, you must also specify the Region US East (N. Virginia) as follows:    CLI -
  Specify the Region when you use the CloudFront scope: --scope=CLOUDFRONT
  --region=us-east-1.    API and SDKs - For all calls, use the Region endpoint us-east-1.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description of the set that helps with identification.
- `"Tags"`: An array of key:value pairs to associate with the resource.
"""
function create_regex_pattern_set(
    Name, RegularExpressionList, Scope; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wafv2(
        "CreateRegexPatternSet",
        Dict{String,Any}(
            "Name" => Name,
            "RegularExpressionList" => RegularExpressionList,
            "Scope" => Scope,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_regex_pattern_set(
    Name,
    RegularExpressionList,
    Scope,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wafv2(
        "CreateRegexPatternSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Name" => Name,
                    "RegularExpressionList" => RegularExpressionList,
                    "Scope" => Scope,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_rule_group(capacity, name, scope, visibility_config)
    create_rule_group(capacity, name, scope, visibility_config, params::Dict{String,<:Any})

Creates a RuleGroup per the specifications provided.   A rule group defines a collection of
rules to inspect and control web requests that you can use in a WebACL. When you create a
rule group, you define an immutable capacity limit. If you update a rule group, you must
stay within the capacity. This allows others to reuse the rule group with confidence in its
capacity requirements.

# Arguments
- `capacity`: The web ACL capacity units (WCUs) required for this rule group. When you
  create your own rule group, you define this, and you cannot change it after creation. When
  you add or modify the rules in a rule group, WAF enforces this limit. You can check the
  capacity for a set of rules using CheckCapacity. WAF uses WCUs to calculate and control the
  operating resources that are used to run your rules, rule groups, and web ACLs. WAF
  calculates capacity differently for each rule type, to reflect the relative cost of each
  rule. Simple rules that cost little to run use fewer WCUs than more complex rules that use
  more processing power. Rule group capacity is fixed at creation, which helps users plan
  their web ACL WCU usage when they use a rule group. For more information, see WAF web ACL
  capacity units (WCU) in the WAF Developer Guide.
- `name`: The name of the rule group. You cannot change the name of a rule group after you
  create it.
- `scope`: Specifies whether this is for an Amazon CloudFront distribution or for a
  regional application. A regional application can be an Application Load Balancer (ALB), an
  Amazon API Gateway REST API, an AppSync GraphQL API, an Amazon Cognito user pool, an App
  Runner service, or an Amazon Web Services Verified Access instance.  To work with
  CloudFront, you must also specify the Region US East (N. Virginia) as follows:    CLI -
  Specify the Region when you use the CloudFront scope: --scope=CLOUDFRONT
  --region=us-east-1.    API and SDKs - For all calls, use the Region endpoint us-east-1.
- `visibility_config`: Defines and enables Amazon CloudWatch metrics and web request sample
  collection.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CustomResponseBodies"`: A map of custom response keys and content bodies. When you
  create a rule with a block action, you can send a custom response to the web request. You
  define these for the rule group, and then use them in the rules that you define in the rule
  group.  For information about customizing web requests and responses, see Customizing web
  requests and responses in WAF in the WAF Developer Guide.  For information about the limits
  on count and size for custom request and response settings, see WAF quotas in the WAF
  Developer Guide.
- `"Description"`: A description of the rule group that helps with identification.
- `"Rules"`: The Rule statements used to identify the web requests that you want to manage.
  Each rule includes one top-level statement that WAF uses to identify matching web requests,
  and parameters that govern how WAF handles them.
- `"Tags"`: An array of key:value pairs to associate with the resource.
"""
function create_rule_group(
    Capacity,
    Name,
    Scope,
    VisibilityConfig;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wafv2(
        "CreateRuleGroup",
        Dict{String,Any}(
            "Capacity" => Capacity,
            "Name" => Name,
            "Scope" => Scope,
            "VisibilityConfig" => VisibilityConfig,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_rule_group(
    Capacity,
    Name,
    Scope,
    VisibilityConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wafv2(
        "CreateRuleGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Capacity" => Capacity,
                    "Name" => Name,
                    "Scope" => Scope,
                    "VisibilityConfig" => VisibilityConfig,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_web_acl(default_action, name, scope, visibility_config)
    create_web_acl(default_action, name, scope, visibility_config, params::Dict{String,<:Any})

Creates a WebACL per the specifications provided.  A web ACL defines a collection of rules
to use to inspect and control web requests. Each rule has a statement that defines what to
look for in web requests and an action that WAF applies to requests that match the
statement. In the web ACL, you assign a default action to take (allow, block) for any
request that does not match any of the rules. The rules in a web ACL can be a combination
of the types Rule, RuleGroup, and managed rule group. You can associate a web ACL with one
or more Amazon Web Services resources to protect. The resources can be an Amazon CloudFront
distribution, an Amazon API Gateway REST API, an Application Load Balancer, an AppSync
GraphQL API, an Amazon Cognito user pool, an App Runner service, or an Amazon Web Services
Verified Access instance.

# Arguments
- `default_action`: The action to perform if none of the Rules contained in the WebACL
  match.
- `name`: The name of the web ACL. You cannot change the name of a web ACL after you create
  it.
- `scope`: Specifies whether this is for an Amazon CloudFront distribution or for a
  regional application. A regional application can be an Application Load Balancer (ALB), an
  Amazon API Gateway REST API, an AppSync GraphQL API, an Amazon Cognito user pool, an App
  Runner service, or an Amazon Web Services Verified Access instance.  To work with
  CloudFront, you must also specify the Region US East (N. Virginia) as follows:    CLI -
  Specify the Region when you use the CloudFront scope: --scope=CLOUDFRONT
  --region=us-east-1.    API and SDKs - For all calls, use the Region endpoint us-east-1.
- `visibility_config`: Defines and enables Amazon CloudWatch metrics and web request sample
  collection.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AssociationConfig"`: Specifies custom configurations for the associations between the
  web ACL and protected resources.  Use this to customize the maximum size of the request
  body that your protected resources forward to WAF for inspection. You can customize this
  setting for CloudFront, API Gateway, Amazon Cognito, App Runner, or Verified Access
  resources. The default setting is 16 KB (16,384 bytes).   You are charged additional fees
  when your protected resources forward body sizes that are larger than the default. For more
  information, see WAF Pricing.  For Application Load Balancer and AppSync, the limit is
  fixed at 8 KB (8,192 bytes).
- `"CaptchaConfig"`: Specifies how WAF should handle CAPTCHA evaluations for rules that
  don't have their own CaptchaConfig settings. If you don't specify this, WAF uses its
  default settings for CaptchaConfig.
- `"ChallengeConfig"`: Specifies how WAF should handle challenge evaluations for rules that
  don't have their own ChallengeConfig settings. If you don't specify this, WAF uses its
  default settings for ChallengeConfig.
- `"CustomResponseBodies"`: A map of custom response keys and content bodies. When you
  create a rule with a block action, you can send a custom response to the web request. You
  define these for the web ACL, and then use them in the rules and default actions that you
  define in the web ACL.  For information about customizing web requests and responses, see
  Customizing web requests and responses in WAF in the WAF Developer Guide.  For information
  about the limits on count and size for custom request and response settings, see WAF quotas
  in the WAF Developer Guide.
- `"Description"`: A description of the web ACL that helps with identification.
- `"Rules"`: The Rule statements used to identify the web requests that you want to manage.
  Each rule includes one top-level statement that WAF uses to identify matching web requests,
  and parameters that govern how WAF handles them.
- `"Tags"`: An array of key:value pairs to associate with the resource.
- `"TokenDomains"`: Specifies the domains that WAF should accept in a web request token.
  This enables the use of tokens across multiple protected websites. When WAF provides a
  token, it uses the domain of the Amazon Web Services resource that the web ACL is
  protecting. If you don't specify a list of token domains, WAF accepts tokens only for the
  domain of the protected resource. With a token domain list, WAF accepts the resource's host
  domain plus all domains in the token domain list, including their prefixed subdomains.
  Example JSON: \"TokenDomains\": { \"mywebsite.com\", \"myotherwebsite.com\" }  Public
  suffixes aren't allowed. For example, you can't use gov.au or co.uk as token domains.
"""
function create_web_acl(
    DefaultAction,
    Name,
    Scope,
    VisibilityConfig;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wafv2(
        "CreateWebACL",
        Dict{String,Any}(
            "DefaultAction" => DefaultAction,
            "Name" => Name,
            "Scope" => Scope,
            "VisibilityConfig" => VisibilityConfig,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_web_acl(
    DefaultAction,
    Name,
    Scope,
    VisibilityConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wafv2(
        "CreateWebACL",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DefaultAction" => DefaultAction,
                    "Name" => Name,
                    "Scope" => Scope,
                    "VisibilityConfig" => VisibilityConfig,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_apikey(apikey, scope)
    delete_apikey(apikey, scope, params::Dict{String,<:Any})

Deletes the specified API key.  After you delete a key, it can take up to 24 hours for WAF
to disallow use of the key in all regions.

# Arguments
- `apikey`: The encrypted API key that you want to delete.
- `scope`: Specifies whether this is for an Amazon CloudFront distribution or for a
  regional application. A regional application can be an Application Load Balancer (ALB), an
  Amazon API Gateway REST API, an AppSync GraphQL API, an Amazon Cognito user pool, an App
  Runner service, or an Amazon Web Services Verified Access instance.  To work with
  CloudFront, you must also specify the Region US East (N. Virginia) as follows:    CLI -
  Specify the Region when you use the CloudFront scope: --scope=CLOUDFRONT
  --region=us-east-1.    API and SDKs - For all calls, use the Region endpoint us-east-1.

"""
function delete_apikey(APIKey, Scope; aws_config::AbstractAWSConfig=current_aws_config())
    return wafv2(
        "DeleteAPIKey",
        Dict{String,Any}("APIKey" => APIKey, "Scope" => Scope);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_apikey(
    APIKey,
    Scope,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wafv2(
        "DeleteAPIKey",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("APIKey" => APIKey, "Scope" => Scope), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_firewall_manager_rule_groups(web_aclarn, web_acllock_token)
    delete_firewall_manager_rule_groups(web_aclarn, web_acllock_token, params::Dict{String,<:Any})

Deletes all rule groups that are managed by Firewall Manager for the specified web ACL.
You can only use this if ManagedByFirewallManager is false in the specified WebACL.

# Arguments
- `web_aclarn`: The Amazon Resource Name (ARN) of the web ACL.
- `web_acllock_token`: A token used for optimistic locking. WAF returns a token to your get
  and list requests, to mark the state of the entity at the time of the request. To make
  changes to the entity associated with the token, you provide the token to operations like
  update and delete. WAF uses the token to ensure that no changes have been made to the
  entity since you last retrieved it. If a change has been made, the update fails with a
  WAFOptimisticLockException. If this happens, perform another get, and use the new token
  returned by that operation.

"""
function delete_firewall_manager_rule_groups(
    WebACLArn, WebACLLockToken; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wafv2(
        "DeleteFirewallManagerRuleGroups",
        Dict{String,Any}("WebACLArn" => WebACLArn, "WebACLLockToken" => WebACLLockToken);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_firewall_manager_rule_groups(
    WebACLArn,
    WebACLLockToken,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wafv2(
        "DeleteFirewallManagerRuleGroups",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "WebACLArn" => WebACLArn, "WebACLLockToken" => WebACLLockToken
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_ipset(id, lock_token, name, scope)
    delete_ipset(id, lock_token, name, scope, params::Dict{String,<:Any})

Deletes the specified IPSet.

# Arguments
- `id`: A unique identifier for the set. This ID is returned in the responses to create and
  list commands. You provide it to operations like update and delete.
- `lock_token`: A token used for optimistic locking. WAF returns a token to your get and
  list requests, to mark the state of the entity at the time of the request. To make changes
  to the entity associated with the token, you provide the token to operations like update
  and delete. WAF uses the token to ensure that no changes have been made to the entity since
  you last retrieved it. If a change has been made, the update fails with a
  WAFOptimisticLockException. If this happens, perform another get, and use the new token
  returned by that operation.
- `name`: The name of the IP set. You cannot change the name of an IPSet after you create
  it.
- `scope`: Specifies whether this is for an Amazon CloudFront distribution or for a
  regional application. A regional application can be an Application Load Balancer (ALB), an
  Amazon API Gateway REST API, an AppSync GraphQL API, an Amazon Cognito user pool, an App
  Runner service, or an Amazon Web Services Verified Access instance.  To work with
  CloudFront, you must also specify the Region US East (N. Virginia) as follows:    CLI -
  Specify the Region when you use the CloudFront scope: --scope=CLOUDFRONT
  --region=us-east-1.    API and SDKs - For all calls, use the Region endpoint us-east-1.

"""
function delete_ipset(
    Id, LockToken, Name, Scope; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wafv2(
        "DeleteIPSet",
        Dict{String,Any}(
            "Id" => Id, "LockToken" => LockToken, "Name" => Name, "Scope" => Scope
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_ipset(
    Id,
    LockToken,
    Name,
    Scope,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wafv2(
        "DeleteIPSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Id" => Id, "LockToken" => LockToken, "Name" => Name, "Scope" => Scope
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_logging_configuration(resource_arn)
    delete_logging_configuration(resource_arn, params::Dict{String,<:Any})

Deletes the LoggingConfiguration from the specified web ACL.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the web ACL from which you want to
  delete the LoggingConfiguration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"LogScope"`: The owner of the logging configuration, which must be set to CUSTOMER for
  the configurations that you manage.  The log scope SECURITY_LAKE indicates a configuration
  that is managed through Amazon Security Lake. You can use Security Lake to collect log and
  event data from various sources for normalization, analysis, and management. For
  information, see Collecting data from Amazon Web Services services in the Amazon Security
  Lake user guide.  Default: CUSTOMER
- `"LogType"`: Used to distinguish between various logging options. Currently, there is one
  option. Default: WAF_LOGS
"""
function delete_logging_configuration(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wafv2(
        "DeleteLoggingConfiguration",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_logging_configuration(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wafv2(
        "DeleteLoggingConfiguration",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_permission_policy(resource_arn)
    delete_permission_policy(resource_arn, params::Dict{String,<:Any})

Permanently deletes an IAM policy from the specified rule group. You must be the owner of
the rule group to perform this operation.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the rule group from which you want to
  delete the policy. You must be the owner of the rule group to perform this operation.

"""
function delete_permission_policy(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wafv2(
        "DeletePermissionPolicy",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_permission_policy(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wafv2(
        "DeletePermissionPolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_regex_pattern_set(id, lock_token, name, scope)
    delete_regex_pattern_set(id, lock_token, name, scope, params::Dict{String,<:Any})

Deletes the specified RegexPatternSet.

# Arguments
- `id`: A unique identifier for the set. This ID is returned in the responses to create and
  list commands. You provide it to operations like update and delete.
- `lock_token`: A token used for optimistic locking. WAF returns a token to your get and
  list requests, to mark the state of the entity at the time of the request. To make changes
  to the entity associated with the token, you provide the token to operations like update
  and delete. WAF uses the token to ensure that no changes have been made to the entity since
  you last retrieved it. If a change has been made, the update fails with a
  WAFOptimisticLockException. If this happens, perform another get, and use the new token
  returned by that operation.
- `name`: The name of the set. You cannot change the name after you create the set.
- `scope`: Specifies whether this is for an Amazon CloudFront distribution or for a
  regional application. A regional application can be an Application Load Balancer (ALB), an
  Amazon API Gateway REST API, an AppSync GraphQL API, an Amazon Cognito user pool, an App
  Runner service, or an Amazon Web Services Verified Access instance.  To work with
  CloudFront, you must also specify the Region US East (N. Virginia) as follows:    CLI -
  Specify the Region when you use the CloudFront scope: --scope=CLOUDFRONT
  --region=us-east-1.    API and SDKs - For all calls, use the Region endpoint us-east-1.

"""
function delete_regex_pattern_set(
    Id, LockToken, Name, Scope; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wafv2(
        "DeleteRegexPatternSet",
        Dict{String,Any}(
            "Id" => Id, "LockToken" => LockToken, "Name" => Name, "Scope" => Scope
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_regex_pattern_set(
    Id,
    LockToken,
    Name,
    Scope,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wafv2(
        "DeleteRegexPatternSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Id" => Id, "LockToken" => LockToken, "Name" => Name, "Scope" => Scope
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_rule_group(id, lock_token, name, scope)
    delete_rule_group(id, lock_token, name, scope, params::Dict{String,<:Any})

Deletes the specified RuleGroup.

# Arguments
- `id`: A unique identifier for the rule group. This ID is returned in the responses to
  create and list commands. You provide it to operations like update and delete.
- `lock_token`: A token used for optimistic locking. WAF returns a token to your get and
  list requests, to mark the state of the entity at the time of the request. To make changes
  to the entity associated with the token, you provide the token to operations like update
  and delete. WAF uses the token to ensure that no changes have been made to the entity since
  you last retrieved it. If a change has been made, the update fails with a
  WAFOptimisticLockException. If this happens, perform another get, and use the new token
  returned by that operation.
- `name`: The name of the rule group. You cannot change the name of a rule group after you
  create it.
- `scope`: Specifies whether this is for an Amazon CloudFront distribution or for a
  regional application. A regional application can be an Application Load Balancer (ALB), an
  Amazon API Gateway REST API, an AppSync GraphQL API, an Amazon Cognito user pool, an App
  Runner service, or an Amazon Web Services Verified Access instance.  To work with
  CloudFront, you must also specify the Region US East (N. Virginia) as follows:    CLI -
  Specify the Region when you use the CloudFront scope: --scope=CLOUDFRONT
  --region=us-east-1.    API and SDKs - For all calls, use the Region endpoint us-east-1.

"""
function delete_rule_group(
    Id, LockToken, Name, Scope; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wafv2(
        "DeleteRuleGroup",
        Dict{String,Any}(
            "Id" => Id, "LockToken" => LockToken, "Name" => Name, "Scope" => Scope
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_rule_group(
    Id,
    LockToken,
    Name,
    Scope,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wafv2(
        "DeleteRuleGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Id" => Id, "LockToken" => LockToken, "Name" => Name, "Scope" => Scope
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_web_acl(id, lock_token, name, scope)
    delete_web_acl(id, lock_token, name, scope, params::Dict{String,<:Any})

Deletes the specified WebACL.  You can only use this if ManagedByFirewallManager is false
in the specified WebACL.   Before deleting any web ACL, first disassociate it from all
resources.   To retrieve a list of the resources that are associated with a web ACL, use
the following calls:   For regional resources, call ListResourcesForWebACL.   For Amazon
CloudFront distributions, use the CloudFront call ListDistributionsByWebACLId. For
information, see ListDistributionsByWebACLId in the Amazon CloudFront API Reference.
To disassociate a resource from a web ACL, use the following calls:   For regional
resources, call DisassociateWebACL.   For Amazon CloudFront distributions, provide an empty
web ACL ID in the CloudFront call UpdateDistribution. For information, see
UpdateDistribution in the Amazon CloudFront API Reference.

# Arguments
- `id`: The unique identifier for the web ACL. This ID is returned in the responses to
  create and list commands. You provide it to operations like update and delete.
- `lock_token`: A token used for optimistic locking. WAF returns a token to your get and
  list requests, to mark the state of the entity at the time of the request. To make changes
  to the entity associated with the token, you provide the token to operations like update
  and delete. WAF uses the token to ensure that no changes have been made to the entity since
  you last retrieved it. If a change has been made, the update fails with a
  WAFOptimisticLockException. If this happens, perform another get, and use the new token
  returned by that operation.
- `name`: The name of the web ACL. You cannot change the name of a web ACL after you create
  it.
- `scope`: Specifies whether this is for an Amazon CloudFront distribution or for a
  regional application. A regional application can be an Application Load Balancer (ALB), an
  Amazon API Gateway REST API, an AppSync GraphQL API, an Amazon Cognito user pool, an App
  Runner service, or an Amazon Web Services Verified Access instance.  To work with
  CloudFront, you must also specify the Region US East (N. Virginia) as follows:    CLI -
  Specify the Region when you use the CloudFront scope: --scope=CLOUDFRONT
  --region=us-east-1.    API and SDKs - For all calls, use the Region endpoint us-east-1.

"""
function delete_web_acl(
    Id, LockToken, Name, Scope; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wafv2(
        "DeleteWebACL",
        Dict{String,Any}(
            "Id" => Id, "LockToken" => LockToken, "Name" => Name, "Scope" => Scope
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_web_acl(
    Id,
    LockToken,
    Name,
    Scope,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wafv2(
        "DeleteWebACL",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Id" => Id, "LockToken" => LockToken, "Name" => Name, "Scope" => Scope
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_all_managed_products(scope)
    describe_all_managed_products(scope, params::Dict{String,<:Any})

Provides high-level information for the Amazon Web Services Managed Rules rule groups and
Amazon Web Services Marketplace managed rule groups.

# Arguments
- `scope`: Specifies whether this is for an Amazon CloudFront distribution or for a
  regional application. A regional application can be an Application Load Balancer (ALB), an
  Amazon API Gateway REST API, an AppSync GraphQL API, an Amazon Cognito user pool, an App
  Runner service, or an Amazon Web Services Verified Access instance.  To work with
  CloudFront, you must also specify the Region US East (N. Virginia) as follows:    CLI -
  Specify the Region when you use the CloudFront scope: --scope=CLOUDFRONT
  --region=us-east-1.    API and SDKs - For all calls, use the Region endpoint us-east-1.

"""
function describe_all_managed_products(
    Scope; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wafv2(
        "DescribeAllManagedProducts",
        Dict{String,Any}("Scope" => Scope);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_all_managed_products(
    Scope, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wafv2(
        "DescribeAllManagedProducts",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Scope" => Scope), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_managed_products_by_vendor(scope, vendor_name)
    describe_managed_products_by_vendor(scope, vendor_name, params::Dict{String,<:Any})

Provides high-level information for the managed rule groups owned by a specific vendor.

# Arguments
- `scope`: Specifies whether this is for an Amazon CloudFront distribution or for a
  regional application. A regional application can be an Application Load Balancer (ALB), an
  Amazon API Gateway REST API, an AppSync GraphQL API, an Amazon Cognito user pool, an App
  Runner service, or an Amazon Web Services Verified Access instance.  To work with
  CloudFront, you must also specify the Region US East (N. Virginia) as follows:    CLI -
  Specify the Region when you use the CloudFront scope: --scope=CLOUDFRONT
  --region=us-east-1.    API and SDKs - For all calls, use the Region endpoint us-east-1.
- `vendor_name`: The name of the managed rule group vendor. You use this, along with the
  rule group name, to identify a rule group.

"""
function describe_managed_products_by_vendor(
    Scope, VendorName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wafv2(
        "DescribeManagedProductsByVendor",
        Dict{String,Any}("Scope" => Scope, "VendorName" => VendorName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_managed_products_by_vendor(
    Scope,
    VendorName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wafv2(
        "DescribeManagedProductsByVendor",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Scope" => Scope, "VendorName" => VendorName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_managed_rule_group(name, scope, vendor_name)
    describe_managed_rule_group(name, scope, vendor_name, params::Dict{String,<:Any})

Provides high-level information for a managed rule group, including descriptions of the
rules.

# Arguments
- `name`: The name of the managed rule group. You use this, along with the vendor name, to
  identify the rule group.
- `scope`: Specifies whether this is for an Amazon CloudFront distribution or for a
  regional application. A regional application can be an Application Load Balancer (ALB), an
  Amazon API Gateway REST API, an AppSync GraphQL API, an Amazon Cognito user pool, an App
  Runner service, or an Amazon Web Services Verified Access instance.  To work with
  CloudFront, you must also specify the Region US East (N. Virginia) as follows:    CLI -
  Specify the Region when you use the CloudFront scope: --scope=CLOUDFRONT
  --region=us-east-1.    API and SDKs - For all calls, use the Region endpoint us-east-1.
- `vendor_name`: The name of the managed rule group vendor. You use this, along with the
  rule group name, to identify a rule group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"VersionName"`: The version of the rule group. You can only use a version that is not
  scheduled for expiration. If you don't provide this, WAF uses the vendor's default version.
"""
function describe_managed_rule_group(
    Name, Scope, VendorName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wafv2(
        "DescribeManagedRuleGroup",
        Dict{String,Any}("Name" => Name, "Scope" => Scope, "VendorName" => VendorName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_managed_rule_group(
    Name,
    Scope,
    VendorName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wafv2(
        "DescribeManagedRuleGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Name" => Name, "Scope" => Scope, "VendorName" => VendorName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_web_acl(resource_arn)
    disassociate_web_acl(resource_arn, params::Dict{String,<:Any})

Disassociates the specified regional application resource from any existing web ACL
association. A resource can have at most one web ACL association. A regional application
can be an Application Load Balancer (ALB), an Amazon API Gateway REST API, an AppSync
GraphQL API, an Amazon Cognito user pool, an App Runner service, or an Amazon Web Services
Verified Access instance.  For Amazon CloudFront, don't use this call. Instead, use your
CloudFront distribution configuration. To disassociate a web ACL, provide an empty web ACL
ID in the CloudFront call UpdateDistribution. For information, see UpdateDistribution in
the Amazon CloudFront API Reference.   Required permissions for customer-managed IAM
policies  This call requires permissions that are specific to the protected resource type.
For details, see Permissions for DisassociateWebACL in the WAF Developer Guide.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource to disassociate from the
  web ACL.  The ARN must be in one of the following formats:   For an Application Load
  Balancer:
  arn:partition:elasticloadbalancing:region:account-id:loadbalancer/app/load-balancer-name/loa
  d-balancer-id     For an Amazon API Gateway REST API:
  arn:partition:apigateway:region::/restapis/api-id/stages/stage-name     For an AppSync
  GraphQL API: arn:partition:appsync:region:account-id:apis/GraphQLApiId     For an Amazon
  Cognito user pool: arn:partition:cognito-idp:region:account-id:userpool/user-pool-id
  For an App Runner service:
  arn:partition:apprunner:region:account-id:service/apprunner-service-name/apprunner-service-i
  d     For an Amazon Web Services Verified Access instance:
  arn:partition:ec2:region:account-id:verified-access-instance/instance-id

"""
function disassociate_web_acl(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wafv2(
        "DisassociateWebACL",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_web_acl(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wafv2(
        "DisassociateWebACL",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    generate_mobile_sdk_release_url(platform, release_version)
    generate_mobile_sdk_release_url(platform, release_version, params::Dict{String,<:Any})

Generates a presigned download URL for the specified release of the mobile SDK. The mobile
SDK is not generally available. Customers who have access to the mobile SDK can use it to
establish and manage WAF tokens for use in HTTP(S) requests from a mobile device to WAF.
For more information, see WAF client application integration in the WAF Developer Guide.

# Arguments
- `platform`: The device platform.
- `release_version`: The release version. For the latest available version, specify LATEST.

"""
function generate_mobile_sdk_release_url(
    Platform, ReleaseVersion; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wafv2(
        "GenerateMobileSdkReleaseUrl",
        Dict{String,Any}("Platform" => Platform, "ReleaseVersion" => ReleaseVersion);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function generate_mobile_sdk_release_url(
    Platform,
    ReleaseVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wafv2(
        "GenerateMobileSdkReleaseUrl",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Platform" => Platform, "ReleaseVersion" => ReleaseVersion
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_decrypted_apikey(apikey, scope)
    get_decrypted_apikey(apikey, scope, params::Dict{String,<:Any})

Returns your API key in decrypted form. Use this to check the token domains that you have
defined for the key.  API keys are required for the integration of the CAPTCHA API in your
JavaScript client applications. The API lets you customize the placement and
characteristics of the CAPTCHA puzzle for your end users. For more information about the
CAPTCHA JavaScript integration, see WAF client application integration in the WAF Developer
Guide.

# Arguments
- `apikey`: The encrypted API key.
- `scope`: Specifies whether this is for an Amazon CloudFront distribution or for a
  regional application. A regional application can be an Application Load Balancer (ALB), an
  Amazon API Gateway REST API, an AppSync GraphQL API, an Amazon Cognito user pool, an App
  Runner service, or an Amazon Web Services Verified Access instance.  To work with
  CloudFront, you must also specify the Region US East (N. Virginia) as follows:    CLI -
  Specify the Region when you use the CloudFront scope: --scope=CLOUDFRONT
  --region=us-east-1.    API and SDKs - For all calls, use the Region endpoint us-east-1.

"""
function get_decrypted_apikey(
    APIKey, Scope; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wafv2(
        "GetDecryptedAPIKey",
        Dict{String,Any}("APIKey" => APIKey, "Scope" => Scope);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_decrypted_apikey(
    APIKey,
    Scope,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wafv2(
        "GetDecryptedAPIKey",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("APIKey" => APIKey, "Scope" => Scope), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_ipset(id, name, scope)
    get_ipset(id, name, scope, params::Dict{String,<:Any})

Retrieves the specified IPSet.

# Arguments
- `id`: A unique identifier for the set. This ID is returned in the responses to create and
  list commands. You provide it to operations like update and delete.
- `name`: The name of the IP set. You cannot change the name of an IPSet after you create
  it.
- `scope`: Specifies whether this is for an Amazon CloudFront distribution or for a
  regional application. A regional application can be an Application Load Balancer (ALB), an
  Amazon API Gateway REST API, an AppSync GraphQL API, an Amazon Cognito user pool, an App
  Runner service, or an Amazon Web Services Verified Access instance.  To work with
  CloudFront, you must also specify the Region US East (N. Virginia) as follows:    CLI -
  Specify the Region when you use the CloudFront scope: --scope=CLOUDFRONT
  --region=us-east-1.    API and SDKs - For all calls, use the Region endpoint us-east-1.

"""
function get_ipset(Id, Name, Scope; aws_config::AbstractAWSConfig=current_aws_config())
    return wafv2(
        "GetIPSet",
        Dict{String,Any}("Id" => Id, "Name" => Name, "Scope" => Scope);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_ipset(
    Id,
    Name,
    Scope,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wafv2(
        "GetIPSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Id" => Id, "Name" => Name, "Scope" => Scope),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_logging_configuration(resource_arn)
    get_logging_configuration(resource_arn, params::Dict{String,<:Any})

Returns the LoggingConfiguration for the specified web ACL.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the web ACL for which you want to get
  the LoggingConfiguration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"LogScope"`: The owner of the logging configuration, which must be set to CUSTOMER for
  the configurations that you manage.  The log scope SECURITY_LAKE indicates a configuration
  that is managed through Amazon Security Lake. You can use Security Lake to collect log and
  event data from various sources for normalization, analysis, and management. For
  information, see Collecting data from Amazon Web Services services in the Amazon Security
  Lake user guide.  Default: CUSTOMER
- `"LogType"`: Used to distinguish between various logging options. Currently, there is one
  option. Default: WAF_LOGS
"""
function get_logging_configuration(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wafv2(
        "GetLoggingConfiguration",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_logging_configuration(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wafv2(
        "GetLoggingConfiguration",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_managed_rule_set(id, name, scope)
    get_managed_rule_set(id, name, scope, params::Dict{String,<:Any})

Retrieves the specified managed rule set.   This is intended for use only by vendors of
managed rule sets. Vendors are Amazon Web Services and Amazon Web Services Marketplace
sellers.  Vendors, you can use the managed rule set APIs to provide controlled rollout of
your versioned managed rule group offerings for your customers. The APIs are
ListManagedRuleSets, GetManagedRuleSet, PutManagedRuleSetVersions, and
UpdateManagedRuleSetVersionExpiryDate.

# Arguments
- `id`: A unique identifier for the managed rule set. The ID is returned in the responses
  to commands like list. You provide it to operations like get and update.
- `name`: The name of the managed rule set. You use this, along with the rule set ID, to
  identify the rule set. This name is assigned to the corresponding managed rule group, which
  your customers can access and use.
- `scope`: Specifies whether this is for an Amazon CloudFront distribution or for a
  regional application. A regional application can be an Application Load Balancer (ALB), an
  Amazon API Gateway REST API, an AppSync GraphQL API, an Amazon Cognito user pool, an App
  Runner service, or an Amazon Web Services Verified Access instance.  To work with
  CloudFront, you must also specify the Region US East (N. Virginia) as follows:    CLI -
  Specify the Region when you use the CloudFront scope: --scope=CLOUDFRONT
  --region=us-east-1.    API and SDKs - For all calls, use the Region endpoint us-east-1.

"""
function get_managed_rule_set(
    Id, Name, Scope; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wafv2(
        "GetManagedRuleSet",
        Dict{String,Any}("Id" => Id, "Name" => Name, "Scope" => Scope);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_managed_rule_set(
    Id,
    Name,
    Scope,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wafv2(
        "GetManagedRuleSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Id" => Id, "Name" => Name, "Scope" => Scope),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_mobile_sdk_release(platform, release_version)
    get_mobile_sdk_release(platform, release_version, params::Dict{String,<:Any})

Retrieves information for the specified mobile SDK release, including release notes and
tags. The mobile SDK is not generally available. Customers who have access to the mobile
SDK can use it to establish and manage WAF tokens for use in HTTP(S) requests from a mobile
device to WAF. For more information, see WAF client application integration in the WAF
Developer Guide.

# Arguments
- `platform`: The device platform.
- `release_version`: The release version. For the latest available version, specify LATEST.

"""
function get_mobile_sdk_release(
    Platform, ReleaseVersion; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wafv2(
        "GetMobileSdkRelease",
        Dict{String,Any}("Platform" => Platform, "ReleaseVersion" => ReleaseVersion);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_mobile_sdk_release(
    Platform,
    ReleaseVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wafv2(
        "GetMobileSdkRelease",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Platform" => Platform, "ReleaseVersion" => ReleaseVersion
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_permission_policy(resource_arn)
    get_permission_policy(resource_arn, params::Dict{String,<:Any})

Returns the IAM policy that is attached to the specified rule group. You must be the owner
of the rule group to perform this operation.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the rule group for which you want to
  get the policy.

"""
function get_permission_policy(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wafv2(
        "GetPermissionPolicy",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_permission_policy(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wafv2(
        "GetPermissionPolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_rate_based_statement_managed_keys(rule_name, scope, web_aclid, web_aclname)
    get_rate_based_statement_managed_keys(rule_name, scope, web_aclid, web_aclname, params::Dict{String,<:Any})

Retrieves the IP addresses that are currently blocked by a rate-based rule instance. This
is only available for rate-based rules that aggregate solely on the IP address or on the
forwarded IP address.  The maximum number of addresses that can be blocked for a single
rate-based rule instance is 10,000. If more than 10,000 addresses exceed the rate limit,
those with the highest rates are blocked. For a rate-based rule that you've defined inside
a rule group, provide the name of the rule group reference statement in your request, in
addition to the rate-based rule name and the web ACL name.  WAF monitors web requests and
manages keys independently for each unique combination of web ACL, optional rule group, and
rate-based rule. For example, if you define a rate-based rule inside a rule group, and then
use the rule group in a web ACL, WAF monitors web requests and manages keys for that web
ACL, rule group reference statement, and rate-based rule instance. If you use the same rule
group in a second web ACL, WAF monitors web requests and manages keys for this second usage
completely independent of your first.

# Arguments
- `rule_name`: The name of the rate-based rule to get the keys for. If you have the rule
  defined inside a rule group that you're using in your web ACL, also provide the name of the
  rule group reference statement in the request parameter RuleGroupRuleName.
- `scope`: Specifies whether this is for an Amazon CloudFront distribution or for a
  regional application. A regional application can be an Application Load Balancer (ALB), an
  Amazon API Gateway REST API, an AppSync GraphQL API, an Amazon Cognito user pool, an App
  Runner service, or an Amazon Web Services Verified Access instance.  To work with
  CloudFront, you must also specify the Region US East (N. Virginia) as follows:    CLI -
  Specify the Region when you use the CloudFront scope: --scope=CLOUDFRONT
  --region=us-east-1.    API and SDKs - For all calls, use the Region endpoint us-east-1.
- `web_aclid`: The unique identifier for the web ACL. This ID is returned in the responses
  to create and list commands. You provide it to operations like update and delete.
- `web_aclname`: The name of the web ACL. You cannot change the name of a web ACL after you
  create it.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"RuleGroupRuleName"`: The name of the rule group reference statement in your web ACL.
  This is required only when you have the rate-based rule nested inside a rule group.
"""
function get_rate_based_statement_managed_keys(
    RuleName,
    Scope,
    WebACLId,
    WebACLName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wafv2(
        "GetRateBasedStatementManagedKeys",
        Dict{String,Any}(
            "RuleName" => RuleName,
            "Scope" => Scope,
            "WebACLId" => WebACLId,
            "WebACLName" => WebACLName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_rate_based_statement_managed_keys(
    RuleName,
    Scope,
    WebACLId,
    WebACLName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wafv2(
        "GetRateBasedStatementManagedKeys",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "RuleName" => RuleName,
                    "Scope" => Scope,
                    "WebACLId" => WebACLId,
                    "WebACLName" => WebACLName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_regex_pattern_set(id, name, scope)
    get_regex_pattern_set(id, name, scope, params::Dict{String,<:Any})

Retrieves the specified RegexPatternSet.

# Arguments
- `id`: A unique identifier for the set. This ID is returned in the responses to create and
  list commands. You provide it to operations like update and delete.
- `name`: The name of the set. You cannot change the name after you create the set.
- `scope`: Specifies whether this is for an Amazon CloudFront distribution or for a
  regional application. A regional application can be an Application Load Balancer (ALB), an
  Amazon API Gateway REST API, an AppSync GraphQL API, an Amazon Cognito user pool, an App
  Runner service, or an Amazon Web Services Verified Access instance.  To work with
  CloudFront, you must also specify the Region US East (N. Virginia) as follows:    CLI -
  Specify the Region when you use the CloudFront scope: --scope=CLOUDFRONT
  --region=us-east-1.    API and SDKs - For all calls, use the Region endpoint us-east-1.

"""
function get_regex_pattern_set(
    Id, Name, Scope; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wafv2(
        "GetRegexPatternSet",
        Dict{String,Any}("Id" => Id, "Name" => Name, "Scope" => Scope);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_regex_pattern_set(
    Id,
    Name,
    Scope,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wafv2(
        "GetRegexPatternSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Id" => Id, "Name" => Name, "Scope" => Scope),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_rule_group()
    get_rule_group(params::Dict{String,<:Any})

Retrieves the specified RuleGroup.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ARN"`: The Amazon Resource Name (ARN) of the entity.
- `"Id"`: A unique identifier for the rule group. This ID is returned in the responses to
  create and list commands. You provide it to operations like update and delete.
- `"Name"`: The name of the rule group. You cannot change the name of a rule group after
  you create it.
- `"Scope"`: Specifies whether this is for an Amazon CloudFront distribution or for a
  regional application. A regional application can be an Application Load Balancer (ALB), an
  Amazon API Gateway REST API, an AppSync GraphQL API, an Amazon Cognito user pool, an App
  Runner service, or an Amazon Web Services Verified Access instance.  To work with
  CloudFront, you must also specify the Region US East (N. Virginia) as follows:    CLI -
  Specify the Region when you use the CloudFront scope: --scope=CLOUDFRONT
  --region=us-east-1.    API and SDKs - For all calls, use the Region endpoint us-east-1.
"""
function get_rule_group(; aws_config::AbstractAWSConfig=current_aws_config())
    return wafv2("GetRuleGroup"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function get_rule_group(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wafv2(
        "GetRuleGroup", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_sampled_requests(max_items, rule_metric_name, scope, time_window, web_acl_arn)
    get_sampled_requests(max_items, rule_metric_name, scope, time_window, web_acl_arn, params::Dict{String,<:Any})

Gets detailed information about a specified number of requests--a sample--that WAF randomly
selects from among the first 5,000 requests that your Amazon Web Services resource received
during a time range that you choose. You can specify a sample size of up to 500 requests,
and you can specify any time range in the previous three hours.  GetSampledRequests returns
a time range, which is usually the time range that you specified. However, if your resource
(such as a CloudFront distribution) received 5,000 requests before the specified time range
elapsed, GetSampledRequests returns an updated time range. This new time range indicates
the actual period during which WAF selected the requests in the sample.

# Arguments
- `max_items`: The number of requests that you want WAF to return from among the first
  5,000 requests that your Amazon Web Services resource received during the time range. If
  your resource received fewer requests than the value of MaxItems, GetSampledRequests
  returns information about all of them.
- `rule_metric_name`: The metric name assigned to the Rule or RuleGroup dimension for which
  you want a sample of requests.
- `scope`: Specifies whether this is for an Amazon CloudFront distribution or for a
  regional application. A regional application can be an Application Load Balancer (ALB), an
  Amazon API Gateway REST API, an AppSync GraphQL API, an Amazon Cognito user pool, an App
  Runner service, or an Amazon Web Services Verified Access instance.  To work with
  CloudFront, you must also specify the Region US East (N. Virginia) as follows:    CLI -
  Specify the Region when you use the CloudFront scope: --scope=CLOUDFRONT
  --region=us-east-1.    API and SDKs - For all calls, use the Region endpoint us-east-1.
- `time_window`: The start date and time and the end date and time of the range for which
  you want GetSampledRequests to return a sample of requests. You must specify the times in
  Coordinated Universal Time (UTC) format. UTC format includes the special designator, Z. For
  example, \"2016-09-27T14:50Z\". You can specify any time range in the previous three hours.
  If you specify a start time that's earlier than three hours ago, WAF sets it to three hours
  ago.
- `web_acl_arn`: The Amazon resource name (ARN) of the WebACL for which you want a sample
  of requests.

"""
function get_sampled_requests(
    MaxItems,
    RuleMetricName,
    Scope,
    TimeWindow,
    WebAclArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wafv2(
        "GetSampledRequests",
        Dict{String,Any}(
            "MaxItems" => MaxItems,
            "RuleMetricName" => RuleMetricName,
            "Scope" => Scope,
            "TimeWindow" => TimeWindow,
            "WebAclArn" => WebAclArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_sampled_requests(
    MaxItems,
    RuleMetricName,
    Scope,
    TimeWindow,
    WebAclArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wafv2(
        "GetSampledRequests",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "MaxItems" => MaxItems,
                    "RuleMetricName" => RuleMetricName,
                    "Scope" => Scope,
                    "TimeWindow" => TimeWindow,
                    "WebAclArn" => WebAclArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_web_acl(id, name, scope)
    get_web_acl(id, name, scope, params::Dict{String,<:Any})

Retrieves the specified WebACL.

# Arguments
- `id`: The unique identifier for the web ACL. This ID is returned in the responses to
  create and list commands. You provide it to operations like update and delete.
- `name`: The name of the web ACL. You cannot change the name of a web ACL after you create
  it.
- `scope`: Specifies whether this is for an Amazon CloudFront distribution or for a
  regional application. A regional application can be an Application Load Balancer (ALB), an
  Amazon API Gateway REST API, an AppSync GraphQL API, an Amazon Cognito user pool, an App
  Runner service, or an Amazon Web Services Verified Access instance.  To work with
  CloudFront, you must also specify the Region US East (N. Virginia) as follows:    CLI -
  Specify the Region when you use the CloudFront scope: --scope=CLOUDFRONT
  --region=us-east-1.    API and SDKs - For all calls, use the Region endpoint us-east-1.

"""
function get_web_acl(Id, Name, Scope; aws_config::AbstractAWSConfig=current_aws_config())
    return wafv2(
        "GetWebACL",
        Dict{String,Any}("Id" => Id, "Name" => Name, "Scope" => Scope);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_web_acl(
    Id,
    Name,
    Scope,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wafv2(
        "GetWebACL",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Id" => Id, "Name" => Name, "Scope" => Scope),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_web_aclfor_resource(resource_arn)
    get_web_aclfor_resource(resource_arn, params::Dict{String,<:Any})

Retrieves the WebACL for the specified resource.  This call uses GetWebACL, to verify that
your account has permission to access the retrieved web ACL. If you get an error that
indicates that your account isn't authorized to perform wafv2:GetWebACL on the resource,
that error won't be included in your CloudTrail event history.  For Amazon CloudFront,
don't use this call. Instead, call the CloudFront action GetDistributionConfig. For
information, see GetDistributionConfig in the Amazon CloudFront API Reference.   Required
permissions for customer-managed IAM policies  This call requires permissions that are
specific to the protected resource type. For details, see Permissions for
GetWebACLForResource in the WAF Developer Guide.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource whose web ACL you want to
  retrieve.  The ARN must be in one of the following formats:   For an Application Load
  Balancer:
  arn:partition:elasticloadbalancing:region:account-id:loadbalancer/app/load-balancer-name/loa
  d-balancer-id     For an Amazon API Gateway REST API:
  arn:partition:apigateway:region::/restapis/api-id/stages/stage-name     For an AppSync
  GraphQL API: arn:partition:appsync:region:account-id:apis/GraphQLApiId     For an Amazon
  Cognito user pool: arn:partition:cognito-idp:region:account-id:userpool/user-pool-id
  For an App Runner service:
  arn:partition:apprunner:region:account-id:service/apprunner-service-name/apprunner-service-i
  d     For an Amazon Web Services Verified Access instance:
  arn:partition:ec2:region:account-id:verified-access-instance/instance-id

"""
function get_web_aclfor_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wafv2(
        "GetWebACLForResource",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_web_aclfor_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wafv2(
        "GetWebACLForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_apikeys(scope)
    list_apikeys(scope, params::Dict{String,<:Any})

Retrieves a list of the API keys that you've defined for the specified scope.  API keys are
required for the integration of the CAPTCHA API in your JavaScript client applications. The
API lets you customize the placement and characteristics of the CAPTCHA puzzle for your end
users. For more information about the CAPTCHA JavaScript integration, see WAF client
application integration in the WAF Developer Guide.

# Arguments
- `scope`: Specifies whether this is for an Amazon CloudFront distribution or for a
  regional application. A regional application can be an Application Load Balancer (ALB), an
  Amazon API Gateway REST API, an AppSync GraphQL API, an Amazon Cognito user pool, an App
  Runner service, or an Amazon Web Services Verified Access instance.  To work with
  CloudFront, you must also specify the Region US East (N. Virginia) as follows:    CLI -
  Specify the Region when you use the CloudFront scope: --scope=CLOUDFRONT
  --region=us-east-1.    API and SDKs - For all calls, use the Region endpoint us-east-1.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: The maximum number of objects that you want WAF to return for this request. If
  more objects are available, in the response, WAF provides a NextMarker value that you can
  use in a subsequent call to get the next batch of objects.
- `"NextMarker"`: When you request a list of objects with a Limit setting, if the number of
  objects that are still available for retrieval exceeds the limit, WAF returns a NextMarker
  value in the response. To retrieve the next batch of objects, provide the marker from the
  prior call in your next request.
"""
function list_apikeys(Scope; aws_config::AbstractAWSConfig=current_aws_config())
    return wafv2(
        "ListAPIKeys",
        Dict{String,Any}("Scope" => Scope);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_apikeys(
    Scope, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wafv2(
        "ListAPIKeys",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Scope" => Scope), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_available_managed_rule_group_versions(name, scope, vendor_name)
    list_available_managed_rule_group_versions(name, scope, vendor_name, params::Dict{String,<:Any})

Returns a list of the available versions for the specified managed rule group.

# Arguments
- `name`: The name of the managed rule group. You use this, along with the vendor name, to
  identify the rule group.
- `scope`: Specifies whether this is for an Amazon CloudFront distribution or for a
  regional application. A regional application can be an Application Load Balancer (ALB), an
  Amazon API Gateway REST API, an AppSync GraphQL API, an Amazon Cognito user pool, an App
  Runner service, or an Amazon Web Services Verified Access instance.  To work with
  CloudFront, you must also specify the Region US East (N. Virginia) as follows:    CLI -
  Specify the Region when you use the CloudFront scope: --scope=CLOUDFRONT
  --region=us-east-1.    API and SDKs - For all calls, use the Region endpoint us-east-1.
- `vendor_name`: The name of the managed rule group vendor. You use this, along with the
  rule group name, to identify a rule group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: The maximum number of objects that you want WAF to return for this request. If
  more objects are available, in the response, WAF provides a NextMarker value that you can
  use in a subsequent call to get the next batch of objects.
- `"NextMarker"`: When you request a list of objects with a Limit setting, if the number of
  objects that are still available for retrieval exceeds the limit, WAF returns a NextMarker
  value in the response. To retrieve the next batch of objects, provide the marker from the
  prior call in your next request.
"""
function list_available_managed_rule_group_versions(
    Name, Scope, VendorName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wafv2(
        "ListAvailableManagedRuleGroupVersions",
        Dict{String,Any}("Name" => Name, "Scope" => Scope, "VendorName" => VendorName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_available_managed_rule_group_versions(
    Name,
    Scope,
    VendorName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wafv2(
        "ListAvailableManagedRuleGroupVersions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Name" => Name, "Scope" => Scope, "VendorName" => VendorName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_available_managed_rule_groups(scope)
    list_available_managed_rule_groups(scope, params::Dict{String,<:Any})

Retrieves an array of managed rule groups that are available for you to use. This list
includes all Amazon Web Services Managed Rules rule groups and all of the Amazon Web
Services Marketplace managed rule groups that you're subscribed to.

# Arguments
- `scope`: Specifies whether this is for an Amazon CloudFront distribution or for a
  regional application. A regional application can be an Application Load Balancer (ALB), an
  Amazon API Gateway REST API, an AppSync GraphQL API, an Amazon Cognito user pool, an App
  Runner service, or an Amazon Web Services Verified Access instance.  To work with
  CloudFront, you must also specify the Region US East (N. Virginia) as follows:    CLI -
  Specify the Region when you use the CloudFront scope: --scope=CLOUDFRONT
  --region=us-east-1.    API and SDKs - For all calls, use the Region endpoint us-east-1.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: The maximum number of objects that you want WAF to return for this request. If
  more objects are available, in the response, WAF provides a NextMarker value that you can
  use in a subsequent call to get the next batch of objects.
- `"NextMarker"`: When you request a list of objects with a Limit setting, if the number of
  objects that are still available for retrieval exceeds the limit, WAF returns a NextMarker
  value in the response. To retrieve the next batch of objects, provide the marker from the
  prior call in your next request.
"""
function list_available_managed_rule_groups(
    Scope; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wafv2(
        "ListAvailableManagedRuleGroups",
        Dict{String,Any}("Scope" => Scope);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_available_managed_rule_groups(
    Scope, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wafv2(
        "ListAvailableManagedRuleGroups",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Scope" => Scope), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_ipsets(scope)
    list_ipsets(scope, params::Dict{String,<:Any})

Retrieves an array of IPSetSummary objects for the IP sets that you manage.

# Arguments
- `scope`: Specifies whether this is for an Amazon CloudFront distribution or for a
  regional application. A regional application can be an Application Load Balancer (ALB), an
  Amazon API Gateway REST API, an AppSync GraphQL API, an Amazon Cognito user pool, an App
  Runner service, or an Amazon Web Services Verified Access instance.  To work with
  CloudFront, you must also specify the Region US East (N. Virginia) as follows:    CLI -
  Specify the Region when you use the CloudFront scope: --scope=CLOUDFRONT
  --region=us-east-1.    API and SDKs - For all calls, use the Region endpoint us-east-1.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: The maximum number of objects that you want WAF to return for this request. If
  more objects are available, in the response, WAF provides a NextMarker value that you can
  use in a subsequent call to get the next batch of objects.
- `"NextMarker"`: When you request a list of objects with a Limit setting, if the number of
  objects that are still available for retrieval exceeds the limit, WAF returns a NextMarker
  value in the response. To retrieve the next batch of objects, provide the marker from the
  prior call in your next request.
"""
function list_ipsets(Scope; aws_config::AbstractAWSConfig=current_aws_config())
    return wafv2(
        "ListIPSets",
        Dict{String,Any}("Scope" => Scope);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_ipsets(
    Scope, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wafv2(
        "ListIPSets",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Scope" => Scope), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_logging_configurations(scope)
    list_logging_configurations(scope, params::Dict{String,<:Any})

Retrieves an array of your LoggingConfiguration objects.

# Arguments
- `scope`: Specifies whether this is for an Amazon CloudFront distribution or for a
  regional application. A regional application can be an Application Load Balancer (ALB), an
  Amazon API Gateway REST API, an AppSync GraphQL API, an Amazon Cognito user pool, an App
  Runner service, or an Amazon Web Services Verified Access instance.  To work with
  CloudFront, you must also specify the Region US East (N. Virginia) as follows:    CLI -
  Specify the Region when you use the CloudFront scope: --scope=CLOUDFRONT
  --region=us-east-1.    API and SDKs - For all calls, use the Region endpoint us-east-1.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: The maximum number of objects that you want WAF to return for this request. If
  more objects are available, in the response, WAF provides a NextMarker value that you can
  use in a subsequent call to get the next batch of objects.
- `"LogScope"`: The owner of the logging configuration, which must be set to CUSTOMER for
  the configurations that you manage.  The log scope SECURITY_LAKE indicates a configuration
  that is managed through Amazon Security Lake. You can use Security Lake to collect log and
  event data from various sources for normalization, analysis, and management. For
  information, see Collecting data from Amazon Web Services services in the Amazon Security
  Lake user guide.  Default: CUSTOMER
- `"NextMarker"`: When you request a list of objects with a Limit setting, if the number of
  objects that are still available for retrieval exceeds the limit, WAF returns a NextMarker
  value in the response. To retrieve the next batch of objects, provide the marker from the
  prior call in your next request.
"""
function list_logging_configurations(
    Scope; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wafv2(
        "ListLoggingConfigurations",
        Dict{String,Any}("Scope" => Scope);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_logging_configurations(
    Scope, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wafv2(
        "ListLoggingConfigurations",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Scope" => Scope), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_managed_rule_sets(scope)
    list_managed_rule_sets(scope, params::Dict{String,<:Any})

Retrieves the managed rule sets that you own.   This is intended for use only by vendors of
managed rule sets. Vendors are Amazon Web Services and Amazon Web Services Marketplace
sellers.  Vendors, you can use the managed rule set APIs to provide controlled rollout of
your versioned managed rule group offerings for your customers. The APIs are
ListManagedRuleSets, GetManagedRuleSet, PutManagedRuleSetVersions, and
UpdateManagedRuleSetVersionExpiryDate.

# Arguments
- `scope`: Specifies whether this is for an Amazon CloudFront distribution or for a
  regional application. A regional application can be an Application Load Balancer (ALB), an
  Amazon API Gateway REST API, an AppSync GraphQL API, an Amazon Cognito user pool, an App
  Runner service, or an Amazon Web Services Verified Access instance.  To work with
  CloudFront, you must also specify the Region US East (N. Virginia) as follows:    CLI -
  Specify the Region when you use the CloudFront scope: --scope=CLOUDFRONT
  --region=us-east-1.    API and SDKs - For all calls, use the Region endpoint us-east-1.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: The maximum number of objects that you want WAF to return for this request. If
  more objects are available, in the response, WAF provides a NextMarker value that you can
  use in a subsequent call to get the next batch of objects.
- `"NextMarker"`: When you request a list of objects with a Limit setting, if the number of
  objects that are still available for retrieval exceeds the limit, WAF returns a NextMarker
  value in the response. To retrieve the next batch of objects, provide the marker from the
  prior call in your next request.
"""
function list_managed_rule_sets(Scope; aws_config::AbstractAWSConfig=current_aws_config())
    return wafv2(
        "ListManagedRuleSets",
        Dict{String,Any}("Scope" => Scope);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_managed_rule_sets(
    Scope, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wafv2(
        "ListManagedRuleSets",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Scope" => Scope), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_mobile_sdk_releases(platform)
    list_mobile_sdk_releases(platform, params::Dict{String,<:Any})

Retrieves a list of the available releases for the mobile SDK and the specified device
platform.  The mobile SDK is not generally available. Customers who have access to the
mobile SDK can use it to establish and manage WAF tokens for use in HTTP(S) requests from a
mobile device to WAF. For more information, see WAF client application integration in the
WAF Developer Guide.

# Arguments
- `platform`: The device platform to retrieve the list for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: The maximum number of objects that you want WAF to return for this request. If
  more objects are available, in the response, WAF provides a NextMarker value that you can
  use in a subsequent call to get the next batch of objects.
- `"NextMarker"`: When you request a list of objects with a Limit setting, if the number of
  objects that are still available for retrieval exceeds the limit, WAF returns a NextMarker
  value in the response. To retrieve the next batch of objects, provide the marker from the
  prior call in your next request.
"""
function list_mobile_sdk_releases(
    Platform; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wafv2(
        "ListMobileSdkReleases",
        Dict{String,Any}("Platform" => Platform);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_mobile_sdk_releases(
    Platform,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wafv2(
        "ListMobileSdkReleases",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Platform" => Platform), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_regex_pattern_sets(scope)
    list_regex_pattern_sets(scope, params::Dict{String,<:Any})

Retrieves an array of RegexPatternSetSummary objects for the regex pattern sets that you
manage.

# Arguments
- `scope`: Specifies whether this is for an Amazon CloudFront distribution or for a
  regional application. A regional application can be an Application Load Balancer (ALB), an
  Amazon API Gateway REST API, an AppSync GraphQL API, an Amazon Cognito user pool, an App
  Runner service, or an Amazon Web Services Verified Access instance.  To work with
  CloudFront, you must also specify the Region US East (N. Virginia) as follows:    CLI -
  Specify the Region when you use the CloudFront scope: --scope=CLOUDFRONT
  --region=us-east-1.    API and SDKs - For all calls, use the Region endpoint us-east-1.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: The maximum number of objects that you want WAF to return for this request. If
  more objects are available, in the response, WAF provides a NextMarker value that you can
  use in a subsequent call to get the next batch of objects.
- `"NextMarker"`: When you request a list of objects with a Limit setting, if the number of
  objects that are still available for retrieval exceeds the limit, WAF returns a NextMarker
  value in the response. To retrieve the next batch of objects, provide the marker from the
  prior call in your next request.
"""
function list_regex_pattern_sets(Scope; aws_config::AbstractAWSConfig=current_aws_config())
    return wafv2(
        "ListRegexPatternSets",
        Dict{String,Any}("Scope" => Scope);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_regex_pattern_sets(
    Scope, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wafv2(
        "ListRegexPatternSets",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Scope" => Scope), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_resources_for_web_acl(web_aclarn)
    list_resources_for_web_acl(web_aclarn, params::Dict{String,<:Any})

Retrieves an array of the Amazon Resource Names (ARNs) for the regional resources that are
associated with the specified web ACL.  For Amazon CloudFront, don't use this call.
Instead, use the CloudFront call ListDistributionsByWebACLId. For information, see
ListDistributionsByWebACLId in the Amazon CloudFront API Reference.   Required permissions
for customer-managed IAM policies  This call requires permissions that are specific to the
protected resource type. For details, see Permissions for ListResourcesForWebACL in the WAF
Developer Guide.

# Arguments
- `web_aclarn`: The Amazon Resource Name (ARN) of the web ACL.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ResourceType"`: Used for web ACLs that are scoped for regional applications. A regional
  application can be an Application Load Balancer (ALB), an Amazon API Gateway REST API, an
  AppSync GraphQL API, an Amazon Cognito user pool, an App Runner service, or an Amazon Web
  Services Verified Access instance.   If you don't provide a resource type, the call uses
  the resource type APPLICATION_LOAD_BALANCER.   Default: APPLICATION_LOAD_BALANCER
"""
function list_resources_for_web_acl(
    WebACLArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wafv2(
        "ListResourcesForWebACL",
        Dict{String,Any}("WebACLArn" => WebACLArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_resources_for_web_acl(
    WebACLArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wafv2(
        "ListResourcesForWebACL",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("WebACLArn" => WebACLArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_rule_groups(scope)
    list_rule_groups(scope, params::Dict{String,<:Any})

Retrieves an array of RuleGroupSummary objects for the rule groups that you manage.

# Arguments
- `scope`: Specifies whether this is for an Amazon CloudFront distribution or for a
  regional application. A regional application can be an Application Load Balancer (ALB), an
  Amazon API Gateway REST API, an AppSync GraphQL API, an Amazon Cognito user pool, an App
  Runner service, or an Amazon Web Services Verified Access instance.  To work with
  CloudFront, you must also specify the Region US East (N. Virginia) as follows:    CLI -
  Specify the Region when you use the CloudFront scope: --scope=CLOUDFRONT
  --region=us-east-1.    API and SDKs - For all calls, use the Region endpoint us-east-1.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: The maximum number of objects that you want WAF to return for this request. If
  more objects are available, in the response, WAF provides a NextMarker value that you can
  use in a subsequent call to get the next batch of objects.
- `"NextMarker"`: When you request a list of objects with a Limit setting, if the number of
  objects that are still available for retrieval exceeds the limit, WAF returns a NextMarker
  value in the response. To retrieve the next batch of objects, provide the marker from the
  prior call in your next request.
"""
function list_rule_groups(Scope; aws_config::AbstractAWSConfig=current_aws_config())
    return wafv2(
        "ListRuleGroups",
        Dict{String,Any}("Scope" => Scope);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_rule_groups(
    Scope, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wafv2(
        "ListRuleGroups",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Scope" => Scope), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Retrieves the TagInfoForResource for the specified resource. Tags are key:value pairs that
you can use to categorize and manage your resources, for purposes like billing. For
example, you might set the tag key to \"customer\" and the value to the customer name or
ID. You can specify one or more tags to add to each Amazon Web Services resource, up to 50
tags for a resource. You can tag the Amazon Web Services resources that you manage through
WAF: web ACLs, rule groups, IP sets, and regex pattern sets. You can't manage or view tags
through the WAF console.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: The maximum number of objects that you want WAF to return for this request. If
  more objects are available, in the response, WAF provides a NextMarker value that you can
  use in a subsequent call to get the next batch of objects.
- `"NextMarker"`: When you request a list of objects with a Limit setting, if the number of
  objects that are still available for retrieval exceeds the limit, WAF returns a NextMarker
  value in the response. To retrieve the next batch of objects, provide the marker from the
  prior call in your next request.
"""
function list_tags_for_resource(
    ResourceARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wafv2(
        "ListTagsForResource",
        Dict{String,Any}("ResourceARN" => ResourceARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wafv2(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceARN" => ResourceARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_web_acls(scope)
    list_web_acls(scope, params::Dict{String,<:Any})

Retrieves an array of WebACLSummary objects for the web ACLs that you manage.

# Arguments
- `scope`: Specifies whether this is for an Amazon CloudFront distribution or for a
  regional application. A regional application can be an Application Load Balancer (ALB), an
  Amazon API Gateway REST API, an AppSync GraphQL API, an Amazon Cognito user pool, an App
  Runner service, or an Amazon Web Services Verified Access instance.  To work with
  CloudFront, you must also specify the Region US East (N. Virginia) as follows:    CLI -
  Specify the Region when you use the CloudFront scope: --scope=CLOUDFRONT
  --region=us-east-1.    API and SDKs - For all calls, use the Region endpoint us-east-1.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: The maximum number of objects that you want WAF to return for this request. If
  more objects are available, in the response, WAF provides a NextMarker value that you can
  use in a subsequent call to get the next batch of objects.
- `"NextMarker"`: When you request a list of objects with a Limit setting, if the number of
  objects that are still available for retrieval exceeds the limit, WAF returns a NextMarker
  value in the response. To retrieve the next batch of objects, provide the marker from the
  prior call in your next request.
"""
function list_web_acls(Scope; aws_config::AbstractAWSConfig=current_aws_config())
    return wafv2(
        "ListWebACLs",
        Dict{String,Any}("Scope" => Scope);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_web_acls(
    Scope, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wafv2(
        "ListWebACLs",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Scope" => Scope), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_logging_configuration(logging_configuration)
    put_logging_configuration(logging_configuration, params::Dict{String,<:Any})

Enables the specified LoggingConfiguration, to start logging from a web ACL, according to
the configuration provided.   This operation completely replaces any mutable specifications
that you already have for a logging configuration with the ones that you provide to this
call.  To modify an existing logging configuration, do the following:    Retrieve it by
calling GetLoggingConfiguration    Update its settings as needed   Provide the complete
logging configuration specification to this call     You can define one logging destination
per web ACL.  You can access information about the traffic that WAF inspects using the
following steps:   Create your logging destination. You can use an Amazon CloudWatch Logs
log group, an Amazon Simple Storage Service (Amazon S3) bucket, or an Amazon Kinesis Data
Firehose.  The name that you give the destination must start with aws-waf-logs-. Depending
on the type of destination, you might need to configure additional settings or permissions.
 For configuration requirements and pricing information for each destination type, see
Logging web ACL traffic in the WAF Developer Guide.   Associate your logging destination to
your web ACL using a PutLoggingConfiguration request.   When you successfully enable
logging using a PutLoggingConfiguration request, WAF creates an additional role or policy
that is required to write logs to the logging destination. For an Amazon CloudWatch Logs
log group, WAF creates a resource policy on the log group. For an Amazon S3 bucket, WAF
creates a bucket policy. For an Amazon Kinesis Data Firehose, WAF creates a service-linked
role. For additional information about web ACL logging, see Logging web ACL traffic
information in the WAF Developer Guide.

# Arguments
- `logging_configuration`:

"""
function put_logging_configuration(
    LoggingConfiguration; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wafv2(
        "PutLoggingConfiguration",
        Dict{String,Any}("LoggingConfiguration" => LoggingConfiguration);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_logging_configuration(
    LoggingConfiguration,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wafv2(
        "PutLoggingConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("LoggingConfiguration" => LoggingConfiguration),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_managed_rule_set_versions(id, lock_token, name, scope)
    put_managed_rule_set_versions(id, lock_token, name, scope, params::Dict{String,<:Any})

Defines the versions of your managed rule set that you are offering to the customers.
Customers see your offerings as managed rule groups with versioning.  This is intended for
use only by vendors of managed rule sets. Vendors are Amazon Web Services and Amazon Web
Services Marketplace sellers.  Vendors, you can use the managed rule set APIs to provide
controlled rollout of your versioned managed rule group offerings for your customers. The
APIs are ListManagedRuleSets, GetManagedRuleSet, PutManagedRuleSetVersions, and
UpdateManagedRuleSetVersionExpiryDate.  Customers retrieve their managed rule group list by
calling ListAvailableManagedRuleGroups. The name that you provide here for your managed
rule set is the name the customer sees for the corresponding managed rule group. Customers
can retrieve the available versions for a managed rule group by calling
ListAvailableManagedRuleGroupVersions. You provide a rule group specification for each
version. For each managed rule set, you must specify a version that you recommend using.
To initiate the expiration of a managed rule group version, use
UpdateManagedRuleSetVersionExpiryDate.

# Arguments
- `id`: A unique identifier for the managed rule set. The ID is returned in the responses
  to commands like list. You provide it to operations like get and update.
- `lock_token`: A token used for optimistic locking. WAF returns a token to your get and
  list requests, to mark the state of the entity at the time of the request. To make changes
  to the entity associated with the token, you provide the token to operations like update
  and delete. WAF uses the token to ensure that no changes have been made to the entity since
  you last retrieved it. If a change has been made, the update fails with a
  WAFOptimisticLockException. If this happens, perform another get, and use the new token
  returned by that operation.
- `name`: The name of the managed rule set. You use this, along with the rule set ID, to
  identify the rule set. This name is assigned to the corresponding managed rule group, which
  your customers can access and use.
- `scope`: Specifies whether this is for an Amazon CloudFront distribution or for a
  regional application. A regional application can be an Application Load Balancer (ALB), an
  Amazon API Gateway REST API, an AppSync GraphQL API, an Amazon Cognito user pool, an App
  Runner service, or an Amazon Web Services Verified Access instance.  To work with
  CloudFront, you must also specify the Region US East (N. Virginia) as follows:    CLI -
  Specify the Region when you use the CloudFront scope: --scope=CLOUDFRONT
  --region=us-east-1.    API and SDKs - For all calls, use the Region endpoint us-east-1.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"RecommendedVersion"`: The version of the named managed rule group that you'd like your
  customers to choose, from among your version offerings.
- `"VersionsToPublish"`: The versions of the named managed rule group that you want to
  offer to your customers.
"""
function put_managed_rule_set_versions(
    Id, LockToken, Name, Scope; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wafv2(
        "PutManagedRuleSetVersions",
        Dict{String,Any}(
            "Id" => Id, "LockToken" => LockToken, "Name" => Name, "Scope" => Scope
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_managed_rule_set_versions(
    Id,
    LockToken,
    Name,
    Scope,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wafv2(
        "PutManagedRuleSetVersions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Id" => Id, "LockToken" => LockToken, "Name" => Name, "Scope" => Scope
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_permission_policy(policy, resource_arn)
    put_permission_policy(policy, resource_arn, params::Dict{String,<:Any})

Attaches an IAM policy to the specified resource. Use this to share a rule group across
accounts. You must be the owner of the rule group to perform this operation. This action is
subject to the following restrictions:   You can attach only one policy with each
PutPermissionPolicy request.   The ARN in the request must be a valid WAF RuleGroup ARN and
the rule group must exist in the same Region.   The user making the request must be the
owner of the rule group.

# Arguments
- `policy`: The policy to attach to the specified rule group.  The policy specifications
  must conform to the following:   The policy must be composed using IAM Policy version
  2012-10-17.   The policy must include specifications for Effect, Action, and Principal.
  Effect must specify Allow.    Action must specify wafv2:CreateWebACL, wafv2:UpdateWebACL,
  and wafv2:PutFirewallManagerRuleGroups and may optionally specify wafv2:GetRuleGroup. WAF
  rejects any extra actions or wildcard actions in the policy.   The policy must not include
  a Resource parameter.   For more information, see IAM Policies.
- `resource_arn`: The Amazon Resource Name (ARN) of the RuleGroup to which you want to
  attach the policy.

"""
function put_permission_policy(
    Policy, ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wafv2(
        "PutPermissionPolicy",
        Dict{String,Any}("Policy" => Policy, "ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_permission_policy(
    Policy,
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wafv2(
        "PutPermissionPolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Policy" => Policy, "ResourceArn" => ResourceArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Associates tags with the specified Amazon Web Services resource. Tags are key:value pairs
that you can use to categorize and manage your resources, for purposes like billing. For
example, you might set the tag key to \"customer\" and the value to the customer name or
ID. You can specify one or more tags to add to each Amazon Web Services resource, up to 50
tags for a resource. You can tag the Amazon Web Services resources that you manage through
WAF: web ACLs, rule groups, IP sets, and regex pattern sets. You can't manage or view tags
through the WAF console.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.
- `tags`: An array of key:value pairs to associate with the resource.

"""
function tag_resource(ResourceARN, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return wafv2(
        "TagResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceARN,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wafv2(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Disassociates tags from an Amazon Web Services resource. Tags are key:value pairs that you
can associate with Amazon Web Services resources. For example, the tag key might be
\"customer\" and the tag value might be \"companyA.\" You can specify one or more tags to
add to each container. You can add up to 50 tags to each Amazon Web Services resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.
- `tag_keys`: An array of keys identifying the tags to disassociate from the resource.

"""
function untag_resource(
    ResourceARN, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wafv2(
        "UntagResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceARN,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wafv2(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_ipset(addresses, id, lock_token, name, scope)
    update_ipset(addresses, id, lock_token, name, scope, params::Dict{String,<:Any})

Updates the specified IPSet.   This operation completely replaces the mutable
specifications that you already have for the IP set with the ones that you provide to this
call.  To modify an IP set, do the following:    Retrieve it by calling GetIPSet    Update
its settings as needed   Provide the complete IP set specification to this call
Temporary inconsistencies during updates  When you create or change a web ACL or other WAF
resources, the changes take a small amount of time to propagate to all areas where the
resources are stored. The propagation time can be from a few seconds to a number of
minutes.  The following are examples of the temporary inconsistencies that you might notice
during change propagation:    After you create a web ACL, if you try to associate it with a
resource, you might get an exception indicating that the web ACL is unavailable.    After
you add a rule group to a web ACL, the new rule group rules might be in effect in one area
where the web ACL is used and not in another.   After you change a rule action setting, you
might see the old action in some places and the new action in others.    After you add an
IP address to an IP set that is in use in a blocking rule, the new address might be blocked
in one area while still allowed in another.

# Arguments
- `addresses`: Contains an array of strings that specifies zero or more IP addresses or
  blocks of IP addresses that you want WAF to inspect for in incoming requests. All addresses
  must be specified using Classless Inter-Domain Routing (CIDR) notation. WAF supports all
  IPv4 and IPv6 CIDR ranges except for /0.  Example address strings:    For requests that
  originated from the IP address 192.0.2.44, specify 192.0.2.44/32.   For requests that
  originated from IP addresses from 192.0.2.0 to 192.0.2.255, specify 192.0.2.0/24.   For
  requests that originated from the IP address 1111:0000:0000:0000:0000:0000:0000:0111,
  specify 1111:0000:0000:0000:0000:0000:0000:0111/128.   For requests that originated from IP
  addresses 1111:0000:0000:0000:0000:0000:0000:0000 to
  1111:0000:0000:0000:ffff:ffff:ffff:ffff, specify
  1111:0000:0000:0000:0000:0000:0000:0000/64.   For more information about CIDR notation, see
  the Wikipedia entry Classless Inter-Domain Routing. Example JSON Addresses specifications:
    Empty array: \"Addresses\": []    Array with one address: \"Addresses\":
  [\"192.0.2.44/32\"]    Array with three addresses: \"Addresses\": [\"192.0.2.44/32\",
  \"192.0.2.0/24\", \"192.0.0.0/16\"]    INVALID specification: \"Addresses\": [\"\"] INVALID
  
- `id`: A unique identifier for the set. This ID is returned in the responses to create and
  list commands. You provide it to operations like update and delete.
- `lock_token`: A token used for optimistic locking. WAF returns a token to your get and
  list requests, to mark the state of the entity at the time of the request. To make changes
  to the entity associated with the token, you provide the token to operations like update
  and delete. WAF uses the token to ensure that no changes have been made to the entity since
  you last retrieved it. If a change has been made, the update fails with a
  WAFOptimisticLockException. If this happens, perform another get, and use the new token
  returned by that operation.
- `name`: The name of the IP set. You cannot change the name of an IPSet after you create
  it.
- `scope`: Specifies whether this is for an Amazon CloudFront distribution or for a
  regional application. A regional application can be an Application Load Balancer (ALB), an
  Amazon API Gateway REST API, an AppSync GraphQL API, an Amazon Cognito user pool, an App
  Runner service, or an Amazon Web Services Verified Access instance.  To work with
  CloudFront, you must also specify the Region US East (N. Virginia) as follows:    CLI -
  Specify the Region when you use the CloudFront scope: --scope=CLOUDFRONT
  --region=us-east-1.    API and SDKs - For all calls, use the Region endpoint us-east-1.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description of the IP set that helps with identification.
"""
function update_ipset(
    Addresses,
    Id,
    LockToken,
    Name,
    Scope;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wafv2(
        "UpdateIPSet",
        Dict{String,Any}(
            "Addresses" => Addresses,
            "Id" => Id,
            "LockToken" => LockToken,
            "Name" => Name,
            "Scope" => Scope,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_ipset(
    Addresses,
    Id,
    LockToken,
    Name,
    Scope,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wafv2(
        "UpdateIPSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Addresses" => Addresses,
                    "Id" => Id,
                    "LockToken" => LockToken,
                    "Name" => Name,
                    "Scope" => Scope,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_managed_rule_set_version_expiry_date(expiry_timestamp, id, lock_token, name, scope, version_to_expire)
    update_managed_rule_set_version_expiry_date(expiry_timestamp, id, lock_token, name, scope, version_to_expire, params::Dict{String,<:Any})

Updates the expiration information for your managed rule set. Use this to initiate the
expiration of a managed rule group version. After you initiate expiration for a version,
WAF excludes it from the response to ListAvailableManagedRuleGroupVersions for the managed
rule group.   This is intended for use only by vendors of managed rule sets. Vendors are
Amazon Web Services and Amazon Web Services Marketplace sellers.  Vendors, you can use the
managed rule set APIs to provide controlled rollout of your versioned managed rule group
offerings for your customers. The APIs are ListManagedRuleSets, GetManagedRuleSet,
PutManagedRuleSetVersions, and UpdateManagedRuleSetVersionExpiryDate.

# Arguments
- `expiry_timestamp`: The time that you want the version to expire. Times are in
  Coordinated Universal Time (UTC) format. UTC format includes the special designator, Z. For
  example, \"2016-09-27T14:50Z\".
- `id`: A unique identifier for the managed rule set. The ID is returned in the responses
  to commands like list. You provide it to operations like get and update.
- `lock_token`: A token used for optimistic locking. WAF returns a token to your get and
  list requests, to mark the state of the entity at the time of the request. To make changes
  to the entity associated with the token, you provide the token to operations like update
  and delete. WAF uses the token to ensure that no changes have been made to the entity since
  you last retrieved it. If a change has been made, the update fails with a
  WAFOptimisticLockException. If this happens, perform another get, and use the new token
  returned by that operation.
- `name`: The name of the managed rule set. You use this, along with the rule set ID, to
  identify the rule set. This name is assigned to the corresponding managed rule group, which
  your customers can access and use.
- `scope`: Specifies whether this is for an Amazon CloudFront distribution or for a
  regional application. A regional application can be an Application Load Balancer (ALB), an
  Amazon API Gateway REST API, an AppSync GraphQL API, an Amazon Cognito user pool, an App
  Runner service, or an Amazon Web Services Verified Access instance.  To work with
  CloudFront, you must also specify the Region US East (N. Virginia) as follows:    CLI -
  Specify the Region when you use the CloudFront scope: --scope=CLOUDFRONT
  --region=us-east-1.    API and SDKs - For all calls, use the Region endpoint us-east-1.
- `version_to_expire`: The version that you want to remove from your list of offerings for
  the named managed rule group.

"""
function update_managed_rule_set_version_expiry_date(
    ExpiryTimestamp,
    Id,
    LockToken,
    Name,
    Scope,
    VersionToExpire;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wafv2(
        "UpdateManagedRuleSetVersionExpiryDate",
        Dict{String,Any}(
            "ExpiryTimestamp" => ExpiryTimestamp,
            "Id" => Id,
            "LockToken" => LockToken,
            "Name" => Name,
            "Scope" => Scope,
            "VersionToExpire" => VersionToExpire,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_managed_rule_set_version_expiry_date(
    ExpiryTimestamp,
    Id,
    LockToken,
    Name,
    Scope,
    VersionToExpire,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wafv2(
        "UpdateManagedRuleSetVersionExpiryDate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ExpiryTimestamp" => ExpiryTimestamp,
                    "Id" => Id,
                    "LockToken" => LockToken,
                    "Name" => Name,
                    "Scope" => Scope,
                    "VersionToExpire" => VersionToExpire,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_regex_pattern_set(id, lock_token, name, regular_expression_list, scope)
    update_regex_pattern_set(id, lock_token, name, regular_expression_list, scope, params::Dict{String,<:Any})

Updates the specified RegexPatternSet.  This operation completely replaces the mutable
specifications that you already have for the regex pattern set with the ones that you
provide to this call.  To modify a regex pattern set, do the following:    Retrieve it by
calling GetRegexPatternSet    Update its settings as needed   Provide the complete regex
pattern set specification to this call     Temporary inconsistencies during updates  When
you create or change a web ACL or other WAF resources, the changes take a small amount of
time to propagate to all areas where the resources are stored. The propagation time can be
from a few seconds to a number of minutes.  The following are examples of the temporary
inconsistencies that you might notice during change propagation:    After you create a web
ACL, if you try to associate it with a resource, you might get an exception indicating that
the web ACL is unavailable.    After you add a rule group to a web ACL, the new rule group
rules might be in effect in one area where the web ACL is used and not in another.   After
you change a rule action setting, you might see the old action in some places and the new
action in others.    After you add an IP address to an IP set that is in use in a blocking
rule, the new address might be blocked in one area while still allowed in another.

# Arguments
- `id`: A unique identifier for the set. This ID is returned in the responses to create and
  list commands. You provide it to operations like update and delete.
- `lock_token`: A token used for optimistic locking. WAF returns a token to your get and
  list requests, to mark the state of the entity at the time of the request. To make changes
  to the entity associated with the token, you provide the token to operations like update
  and delete. WAF uses the token to ensure that no changes have been made to the entity since
  you last retrieved it. If a change has been made, the update fails with a
  WAFOptimisticLockException. If this happens, perform another get, and use the new token
  returned by that operation.
- `name`: The name of the set. You cannot change the name after you create the set.
- `regular_expression_list`:
- `scope`: Specifies whether this is for an Amazon CloudFront distribution or for a
  regional application. A regional application can be an Application Load Balancer (ALB), an
  Amazon API Gateway REST API, an AppSync GraphQL API, an Amazon Cognito user pool, an App
  Runner service, or an Amazon Web Services Verified Access instance.  To work with
  CloudFront, you must also specify the Region US East (N. Virginia) as follows:    CLI -
  Specify the Region when you use the CloudFront scope: --scope=CLOUDFRONT
  --region=us-east-1.    API and SDKs - For all calls, use the Region endpoint us-east-1.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description of the set that helps with identification.
"""
function update_regex_pattern_set(
    Id,
    LockToken,
    Name,
    RegularExpressionList,
    Scope;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wafv2(
        "UpdateRegexPatternSet",
        Dict{String,Any}(
            "Id" => Id,
            "LockToken" => LockToken,
            "Name" => Name,
            "RegularExpressionList" => RegularExpressionList,
            "Scope" => Scope,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_regex_pattern_set(
    Id,
    LockToken,
    Name,
    RegularExpressionList,
    Scope,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wafv2(
        "UpdateRegexPatternSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Id" => Id,
                    "LockToken" => LockToken,
                    "Name" => Name,
                    "RegularExpressionList" => RegularExpressionList,
                    "Scope" => Scope,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_rule_group(id, lock_token, name, scope, visibility_config)
    update_rule_group(id, lock_token, name, scope, visibility_config, params::Dict{String,<:Any})

Updates the specified RuleGroup.  This operation completely replaces the mutable
specifications that you already have for the rule group with the ones that you provide to
this call.  To modify a rule group, do the following:    Retrieve it by calling
GetRuleGroup    Update its settings as needed   Provide the complete rule group
specification to this call     A rule group defines a collection of rules to inspect and
control web requests that you can use in a WebACL. When you create a rule group, you define
an immutable capacity limit. If you update a rule group, you must stay within the capacity.
This allows others to reuse the rule group with confidence in its capacity requirements.
Temporary inconsistencies during updates  When you create or change a web ACL or other WAF
resources, the changes take a small amount of time to propagate to all areas where the
resources are stored. The propagation time can be from a few seconds to a number of
minutes.  The following are examples of the temporary inconsistencies that you might notice
during change propagation:    After you create a web ACL, if you try to associate it with a
resource, you might get an exception indicating that the web ACL is unavailable.    After
you add a rule group to a web ACL, the new rule group rules might be in effect in one area
where the web ACL is used and not in another.   After you change a rule action setting, you
might see the old action in some places and the new action in others.    After you add an
IP address to an IP set that is in use in a blocking rule, the new address might be blocked
in one area while still allowed in another.

# Arguments
- `id`: A unique identifier for the rule group. This ID is returned in the responses to
  create and list commands. You provide it to operations like update and delete.
- `lock_token`: A token used for optimistic locking. WAF returns a token to your get and
  list requests, to mark the state of the entity at the time of the request. To make changes
  to the entity associated with the token, you provide the token to operations like update
  and delete. WAF uses the token to ensure that no changes have been made to the entity since
  you last retrieved it. If a change has been made, the update fails with a
  WAFOptimisticLockException. If this happens, perform another get, and use the new token
  returned by that operation.
- `name`: The name of the rule group. You cannot change the name of a rule group after you
  create it.
- `scope`: Specifies whether this is for an Amazon CloudFront distribution or for a
  regional application. A regional application can be an Application Load Balancer (ALB), an
  Amazon API Gateway REST API, an AppSync GraphQL API, an Amazon Cognito user pool, an App
  Runner service, or an Amazon Web Services Verified Access instance.  To work with
  CloudFront, you must also specify the Region US East (N. Virginia) as follows:    CLI -
  Specify the Region when you use the CloudFront scope: --scope=CLOUDFRONT
  --region=us-east-1.    API and SDKs - For all calls, use the Region endpoint us-east-1.
- `visibility_config`: Defines and enables Amazon CloudWatch metrics and web request sample
  collection.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CustomResponseBodies"`: A map of custom response keys and content bodies. When you
  create a rule with a block action, you can send a custom response to the web request. You
  define these for the rule group, and then use them in the rules that you define in the rule
  group.  For information about customizing web requests and responses, see Customizing web
  requests and responses in WAF in the WAF Developer Guide.  For information about the limits
  on count and size for custom request and response settings, see WAF quotas in the WAF
  Developer Guide.
- `"Description"`: A description of the rule group that helps with identification.
- `"Rules"`: The Rule statements used to identify the web requests that you want to manage.
  Each rule includes one top-level statement that WAF uses to identify matching web requests,
  and parameters that govern how WAF handles them.
"""
function update_rule_group(
    Id,
    LockToken,
    Name,
    Scope,
    VisibilityConfig;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wafv2(
        "UpdateRuleGroup",
        Dict{String,Any}(
            "Id" => Id,
            "LockToken" => LockToken,
            "Name" => Name,
            "Scope" => Scope,
            "VisibilityConfig" => VisibilityConfig,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_rule_group(
    Id,
    LockToken,
    Name,
    Scope,
    VisibilityConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wafv2(
        "UpdateRuleGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Id" => Id,
                    "LockToken" => LockToken,
                    "Name" => Name,
                    "Scope" => Scope,
                    "VisibilityConfig" => VisibilityConfig,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_web_acl(default_action, id, lock_token, name, scope, visibility_config)
    update_web_acl(default_action, id, lock_token, name, scope, visibility_config, params::Dict{String,<:Any})

Updates the specified WebACL. While updating a web ACL, WAF provides continuous coverage to
the resources that you have associated with the web ACL.   This operation completely
replaces the mutable specifications that you already have for the web ACL with the ones
that you provide to this call.  To modify a web ACL, do the following:    Retrieve it by
calling GetWebACL    Update its settings as needed   Provide the complete web ACL
specification to this call     A web ACL defines a collection of rules to use to inspect
and control web requests. Each rule has a statement that defines what to look for in web
requests and an action that WAF applies to requests that match the statement. In the web
ACL, you assign a default action to take (allow, block) for any request that does not match
any of the rules. The rules in a web ACL can be a combination of the types Rule, RuleGroup,
and managed rule group. You can associate a web ACL with one or more Amazon Web Services
resources to protect. The resources can be an Amazon CloudFront distribution, an Amazon API
Gateway REST API, an Application Load Balancer, an AppSync GraphQL API, an Amazon Cognito
user pool, an App Runner service, or an Amazon Web Services Verified Access instance.
Temporary inconsistencies during updates  When you create or change a web ACL or other WAF
resources, the changes take a small amount of time to propagate to all areas where the
resources are stored. The propagation time can be from a few seconds to a number of
minutes.  The following are examples of the temporary inconsistencies that you might notice
during change propagation:    After you create a web ACL, if you try to associate it with a
resource, you might get an exception indicating that the web ACL is unavailable.    After
you add a rule group to a web ACL, the new rule group rules might be in effect in one area
where the web ACL is used and not in another.   After you change a rule action setting, you
might see the old action in some places and the new action in others.    After you add an
IP address to an IP set that is in use in a blocking rule, the new address might be blocked
in one area while still allowed in another.

# Arguments
- `default_action`: The action to perform if none of the Rules contained in the WebACL
  match.
- `id`: The unique identifier for the web ACL. This ID is returned in the responses to
  create and list commands. You provide it to operations like update and delete.
- `lock_token`: A token used for optimistic locking. WAF returns a token to your get and
  list requests, to mark the state of the entity at the time of the request. To make changes
  to the entity associated with the token, you provide the token to operations like update
  and delete. WAF uses the token to ensure that no changes have been made to the entity since
  you last retrieved it. If a change has been made, the update fails with a
  WAFOptimisticLockException. If this happens, perform another get, and use the new token
  returned by that operation.
- `name`: The name of the web ACL. You cannot change the name of a web ACL after you create
  it.
- `scope`: Specifies whether this is for an Amazon CloudFront distribution or for a
  regional application. A regional application can be an Application Load Balancer (ALB), an
  Amazon API Gateway REST API, an AppSync GraphQL API, an Amazon Cognito user pool, an App
  Runner service, or an Amazon Web Services Verified Access instance.  To work with
  CloudFront, you must also specify the Region US East (N. Virginia) as follows:    CLI -
  Specify the Region when you use the CloudFront scope: --scope=CLOUDFRONT
  --region=us-east-1.    API and SDKs - For all calls, use the Region endpoint us-east-1.
- `visibility_config`: Defines and enables Amazon CloudWatch metrics and web request sample
  collection.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AssociationConfig"`: Specifies custom configurations for the associations between the
  web ACL and protected resources.  Use this to customize the maximum size of the request
  body that your protected resources forward to WAF for inspection. You can customize this
  setting for CloudFront, API Gateway, Amazon Cognito, App Runner, or Verified Access
  resources. The default setting is 16 KB (16,384 bytes).   You are charged additional fees
  when your protected resources forward body sizes that are larger than the default. For more
  information, see WAF Pricing.  For Application Load Balancer and AppSync, the limit is
  fixed at 8 KB (8,192 bytes).
- `"CaptchaConfig"`: Specifies how WAF should handle CAPTCHA evaluations for rules that
  don't have their own CaptchaConfig settings. If you don't specify this, WAF uses its
  default settings for CaptchaConfig.
- `"ChallengeConfig"`: Specifies how WAF should handle challenge evaluations for rules that
  don't have their own ChallengeConfig settings. If you don't specify this, WAF uses its
  default settings for ChallengeConfig.
- `"CustomResponseBodies"`: A map of custom response keys and content bodies. When you
  create a rule with a block action, you can send a custom response to the web request. You
  define these for the web ACL, and then use them in the rules and default actions that you
  define in the web ACL.  For information about customizing web requests and responses, see
  Customizing web requests and responses in WAF in the WAF Developer Guide.  For information
  about the limits on count and size for custom request and response settings, see WAF quotas
  in the WAF Developer Guide.
- `"Description"`: A description of the web ACL that helps with identification.
- `"Rules"`: The Rule statements used to identify the web requests that you want to manage.
  Each rule includes one top-level statement that WAF uses to identify matching web requests,
  and parameters that govern how WAF handles them.
- `"TokenDomains"`: Specifies the domains that WAF should accept in a web request token.
  This enables the use of tokens across multiple protected websites. When WAF provides a
  token, it uses the domain of the Amazon Web Services resource that the web ACL is
  protecting. If you don't specify a list of token domains, WAF accepts tokens only for the
  domain of the protected resource. With a token domain list, WAF accepts the resource's host
  domain plus all domains in the token domain list, including their prefixed subdomains.
  Example JSON: \"TokenDomains\": { \"mywebsite.com\", \"myotherwebsite.com\" }  Public
  suffixes aren't allowed. For example, you can't use gov.au or co.uk as token domains.
"""
function update_web_acl(
    DefaultAction,
    Id,
    LockToken,
    Name,
    Scope,
    VisibilityConfig;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wafv2(
        "UpdateWebACL",
        Dict{String,Any}(
            "DefaultAction" => DefaultAction,
            "Id" => Id,
            "LockToken" => LockToken,
            "Name" => Name,
            "Scope" => Scope,
            "VisibilityConfig" => VisibilityConfig,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_web_acl(
    DefaultAction,
    Id,
    LockToken,
    Name,
    Scope,
    VisibilityConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wafv2(
        "UpdateWebACL",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DefaultAction" => DefaultAction,
                    "Id" => Id,
                    "LockToken" => LockToken,
                    "Name" => Name,
                    "Scope" => Scope,
                    "VisibilityConfig" => VisibilityConfig,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: application_insights
using AWS.Compat
using AWS.UUIDs

"""
    add_workload(component_name, resource_group_name, workload_configuration)
    add_workload(component_name, resource_group_name, workload_configuration, params::Dict{String,<:Any})

Adds a workload to a component. Each component can have at most five workloads.

# Arguments
- `component_name`: The name of the component.
- `resource_group_name`: The name of the resource group.
- `workload_configuration`: The configuration settings of the workload. The value is the
  escaped JSON of the configuration.

"""
function add_workload(
    ComponentName,
    ResourceGroupName,
    WorkloadConfiguration;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_insights(
        "AddWorkload",
        Dict{String,Any}(
            "ComponentName" => ComponentName,
            "ResourceGroupName" => ResourceGroupName,
            "WorkloadConfiguration" => WorkloadConfiguration,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_workload(
    ComponentName,
    ResourceGroupName,
    WorkloadConfiguration,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_insights(
        "AddWorkload",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ComponentName" => ComponentName,
                    "ResourceGroupName" => ResourceGroupName,
                    "WorkloadConfiguration" => WorkloadConfiguration,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_application()
    create_application(params::Dict{String,<:Any})

Adds an application that is created from a resource group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AttachMissingPermission"`: If set to true, the managed policies for SSM and CW will be
  attached to the instance roles if they are missing.
- `"AutoConfigEnabled"`:  Indicates whether Application Insights automatically configures
  unmonitored resources in the resource group.
- `"AutoCreate"`:  Configures all of the resources in the resource group by applying the
  recommended configurations.
- `"CWEMonitorEnabled"`:  Indicates whether Application Insights can listen to CloudWatch
  events for the application resources, such as instance terminated, failed deployment, and
  others.
- `"GroupingType"`: Application Insights can create applications based on a resource group
  or on an account. To create an account-based application using all of the resources in the
  account, set this parameter to ACCOUNT_BASED.
- `"OpsCenterEnabled"`:  When set to true, creates opsItems for any problems detected on an
  application.
- `"OpsItemSNSTopicArn"`:  The SNS topic provided to Application Insights that is
  associated to the created opsItem. Allows you to receive notifications for updates to the
  opsItem.
- `"ResourceGroupName"`: The name of the resource group.
- `"Tags"`: List of tags to add to the application. tag key (Key) and an associated tag
  value (Value). The maximum length of a tag key is 128 characters. The maximum length of a
  tag value is 256 characters.
"""
function create_application(; aws_config::AbstractAWSConfig=current_aws_config())
    return application_insights(
        "CreateApplication"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function create_application(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_insights(
        "CreateApplication", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    create_component(component_name, resource_group_name, resource_list)
    create_component(component_name, resource_group_name, resource_list, params::Dict{String,<:Any})

Creates a custom component by grouping similar standalone instances to monitor.

# Arguments
- `component_name`: The name of the component.
- `resource_group_name`: The name of the resource group.
- `resource_list`: The list of resource ARNs that belong to the component.

"""
function create_component(
    ComponentName,
    ResourceGroupName,
    ResourceList;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_insights(
        "CreateComponent",
        Dict{String,Any}(
            "ComponentName" => ComponentName,
            "ResourceGroupName" => ResourceGroupName,
            "ResourceList" => ResourceList,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_component(
    ComponentName,
    ResourceGroupName,
    ResourceList,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_insights(
        "CreateComponent",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ComponentName" => ComponentName,
                    "ResourceGroupName" => ResourceGroupName,
                    "ResourceList" => ResourceList,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_log_pattern(pattern, pattern_name, pattern_set_name, rank, resource_group_name)
    create_log_pattern(pattern, pattern_name, pattern_set_name, rank, resource_group_name, params::Dict{String,<:Any})

Adds an log pattern to a LogPatternSet.

# Arguments
- `pattern`: The log pattern. The pattern must be DFA compatible. Patterns that utilize
  forward lookahead or backreference constructions are not supported.
- `pattern_name`: The name of the log pattern.
- `pattern_set_name`: The name of the log pattern set.
- `rank`: Rank of the log pattern. Must be a value between 1 and 1,000,000. The patterns
  are sorted by rank, so we recommend that you set your highest priority patterns with the
  lowest rank. A pattern of rank 1 will be the first to get matched to a log line. A pattern
  of rank 1,000,000 will be last to get matched. When you configure custom log patterns from
  the console, a Low severity pattern translates to a 750,000 rank. A Medium severity pattern
  translates to a 500,000 rank. And a High severity pattern translates to a 250,000 rank.
  Rank values less than 1 or greater than 1,000,000 are reserved for AWS-provided patterns.
- `resource_group_name`: The name of the resource group.

"""
function create_log_pattern(
    Pattern,
    PatternName,
    PatternSetName,
    Rank,
    ResourceGroupName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_insights(
        "CreateLogPattern",
        Dict{String,Any}(
            "Pattern" => Pattern,
            "PatternName" => PatternName,
            "PatternSetName" => PatternSetName,
            "Rank" => Rank,
            "ResourceGroupName" => ResourceGroupName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_log_pattern(
    Pattern,
    PatternName,
    PatternSetName,
    Rank,
    ResourceGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_insights(
        "CreateLogPattern",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Pattern" => Pattern,
                    "PatternName" => PatternName,
                    "PatternSetName" => PatternSetName,
                    "Rank" => Rank,
                    "ResourceGroupName" => ResourceGroupName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_application(resource_group_name)
    delete_application(resource_group_name, params::Dict{String,<:Any})

Removes the specified application from monitoring. Does not delete the application.

# Arguments
- `resource_group_name`: The name of the resource group.

"""
function delete_application(
    ResourceGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_insights(
        "DeleteApplication",
        Dict{String,Any}("ResourceGroupName" => ResourceGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_application(
    ResourceGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_insights(
        "DeleteApplication",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ResourceGroupName" => ResourceGroupName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_component(component_name, resource_group_name)
    delete_component(component_name, resource_group_name, params::Dict{String,<:Any})

Ungroups a custom component. When you ungroup custom components, all applicable monitors
that are set up for the component are removed and the instances revert to their standalone
status.

# Arguments
- `component_name`: The name of the component.
- `resource_group_name`: The name of the resource group.

"""
function delete_component(
    ComponentName, ResourceGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_insights(
        "DeleteComponent",
        Dict{String,Any}(
            "ComponentName" => ComponentName, "ResourceGroupName" => ResourceGroupName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_component(
    ComponentName,
    ResourceGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_insights(
        "DeleteComponent",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ComponentName" => ComponentName,
                    "ResourceGroupName" => ResourceGroupName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_log_pattern(pattern_name, pattern_set_name, resource_group_name)
    delete_log_pattern(pattern_name, pattern_set_name, resource_group_name, params::Dict{String,<:Any})

Removes the specified log pattern from a LogPatternSet.

# Arguments
- `pattern_name`: The name of the log pattern.
- `pattern_set_name`: The name of the log pattern set.
- `resource_group_name`: The name of the resource group.

"""
function delete_log_pattern(
    PatternName,
    PatternSetName,
    ResourceGroupName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_insights(
        "DeleteLogPattern",
        Dict{String,Any}(
            "PatternName" => PatternName,
            "PatternSetName" => PatternSetName,
            "ResourceGroupName" => ResourceGroupName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_log_pattern(
    PatternName,
    PatternSetName,
    ResourceGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_insights(
        "DeleteLogPattern",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "PatternName" => PatternName,
                    "PatternSetName" => PatternSetName,
                    "ResourceGroupName" => ResourceGroupName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_application(resource_group_name)
    describe_application(resource_group_name, params::Dict{String,<:Any})

Describes the application.

# Arguments
- `resource_group_name`: The name of the resource group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccountId"`: The AWS account ID for the resource group owner.
"""
function describe_application(
    ResourceGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_insights(
        "DescribeApplication",
        Dict{String,Any}("ResourceGroupName" => ResourceGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_application(
    ResourceGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_insights(
        "DescribeApplication",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ResourceGroupName" => ResourceGroupName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_component(component_name, resource_group_name)
    describe_component(component_name, resource_group_name, params::Dict{String,<:Any})

Describes a component and lists the resources that are grouped together in a component.

# Arguments
- `component_name`: The name of the component.
- `resource_group_name`: The name of the resource group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccountId"`: The AWS account ID for the resource group owner.
"""
function describe_component(
    ComponentName, ResourceGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_insights(
        "DescribeComponent",
        Dict{String,Any}(
            "ComponentName" => ComponentName, "ResourceGroupName" => ResourceGroupName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_component(
    ComponentName,
    ResourceGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_insights(
        "DescribeComponent",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ComponentName" => ComponentName,
                    "ResourceGroupName" => ResourceGroupName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_component_configuration(component_name, resource_group_name)
    describe_component_configuration(component_name, resource_group_name, params::Dict{String,<:Any})

Describes the monitoring configuration of the component.

# Arguments
- `component_name`: The name of the component.
- `resource_group_name`: The name of the resource group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccountId"`: The AWS account ID for the resource group owner.
"""
function describe_component_configuration(
    ComponentName, ResourceGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_insights(
        "DescribeComponentConfiguration",
        Dict{String,Any}(
            "ComponentName" => ComponentName, "ResourceGroupName" => ResourceGroupName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_component_configuration(
    ComponentName,
    ResourceGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_insights(
        "DescribeComponentConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ComponentName" => ComponentName,
                    "ResourceGroupName" => ResourceGroupName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_component_configuration_recommendation(component_name, resource_group_name, tier)
    describe_component_configuration_recommendation(component_name, resource_group_name, tier, params::Dict{String,<:Any})

Describes the recommended monitoring configuration of the component.

# Arguments
- `component_name`: The name of the component.
- `resource_group_name`: The name of the resource group.
- `tier`: The tier of the application component.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"RecommendationType"`: The recommended configuration type.
- `"WorkloadName"`: The name of the workload.
"""
function describe_component_configuration_recommendation(
    ComponentName,
    ResourceGroupName,
    Tier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_insights(
        "DescribeComponentConfigurationRecommendation",
        Dict{String,Any}(
            "ComponentName" => ComponentName,
            "ResourceGroupName" => ResourceGroupName,
            "Tier" => Tier,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_component_configuration_recommendation(
    ComponentName,
    ResourceGroupName,
    Tier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_insights(
        "DescribeComponentConfigurationRecommendation",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ComponentName" => ComponentName,
                    "ResourceGroupName" => ResourceGroupName,
                    "Tier" => Tier,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_log_pattern(pattern_name, pattern_set_name, resource_group_name)
    describe_log_pattern(pattern_name, pattern_set_name, resource_group_name, params::Dict{String,<:Any})

Describe a specific log pattern from a LogPatternSet.

# Arguments
- `pattern_name`: The name of the log pattern.
- `pattern_set_name`: The name of the log pattern set.
- `resource_group_name`: The name of the resource group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccountId"`: The AWS account ID for the resource group owner.
"""
function describe_log_pattern(
    PatternName,
    PatternSetName,
    ResourceGroupName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_insights(
        "DescribeLogPattern",
        Dict{String,Any}(
            "PatternName" => PatternName,
            "PatternSetName" => PatternSetName,
            "ResourceGroupName" => ResourceGroupName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_log_pattern(
    PatternName,
    PatternSetName,
    ResourceGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_insights(
        "DescribeLogPattern",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "PatternName" => PatternName,
                    "PatternSetName" => PatternSetName,
                    "ResourceGroupName" => ResourceGroupName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_observation(observation_id)
    describe_observation(observation_id, params::Dict{String,<:Any})

Describes an anomaly or error with the application.

# Arguments
- `observation_id`: The ID of the observation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccountId"`: The AWS account ID for the resource group owner.
"""
function describe_observation(
    ObservationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_insights(
        "DescribeObservation",
        Dict{String,Any}("ObservationId" => ObservationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_observation(
    ObservationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_insights(
        "DescribeObservation",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ObservationId" => ObservationId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_problem(problem_id)
    describe_problem(problem_id, params::Dict{String,<:Any})

Describes an application problem.

# Arguments
- `problem_id`: The ID of the problem.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccountId"`: The AWS account ID for the owner of the resource group affected by the
  problem.
"""
function describe_problem(ProblemId; aws_config::AbstractAWSConfig=current_aws_config())
    return application_insights(
        "DescribeProblem",
        Dict{String,Any}("ProblemId" => ProblemId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_problem(
    ProblemId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_insights(
        "DescribeProblem",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ProblemId" => ProblemId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_problem_observations(problem_id)
    describe_problem_observations(problem_id, params::Dict{String,<:Any})

Describes the anomalies or errors associated with the problem.

# Arguments
- `problem_id`: The ID of the problem.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccountId"`: The AWS account ID for the resource group owner.
"""
function describe_problem_observations(
    ProblemId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_insights(
        "DescribeProblemObservations",
        Dict{String,Any}("ProblemId" => ProblemId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_problem_observations(
    ProblemId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_insights(
        "DescribeProblemObservations",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ProblemId" => ProblemId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_workload(component_name, resource_group_name, workload_id)
    describe_workload(component_name, resource_group_name, workload_id, params::Dict{String,<:Any})

Describes a workload and its configuration.

# Arguments
- `component_name`: The name of the component.
- `resource_group_name`: The name of the resource group.
- `workload_id`: The ID of the workload.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccountId"`: The AWS account ID for the workload owner.
"""
function describe_workload(
    ComponentName,
    ResourceGroupName,
    WorkloadId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_insights(
        "DescribeWorkload",
        Dict{String,Any}(
            "ComponentName" => ComponentName,
            "ResourceGroupName" => ResourceGroupName,
            "WorkloadId" => WorkloadId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_workload(
    ComponentName,
    ResourceGroupName,
    WorkloadId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_insights(
        "DescribeWorkload",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ComponentName" => ComponentName,
                    "ResourceGroupName" => ResourceGroupName,
                    "WorkloadId" => WorkloadId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_applications()
    list_applications(params::Dict{String,<:Any})

Lists the IDs of the applications that you are monitoring.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccountId"`: The AWS account ID for the resource group owner.
- `"MaxResults"`: The maximum number of results to return in a single call. To retrieve the
  remaining results, make another call with the returned NextToken value.
- `"NextToken"`: The token to request the next page of results.
"""
function list_applications(; aws_config::AbstractAWSConfig=current_aws_config())
    return application_insights(
        "ListApplications"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_applications(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_insights(
        "ListApplications", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_components(resource_group_name)
    list_components(resource_group_name, params::Dict{String,<:Any})

Lists the auto-grouped, standalone, and custom components of the application.

# Arguments
- `resource_group_name`: The name of the resource group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccountId"`: The AWS account ID for the resource group owner.
- `"MaxResults"`: The maximum number of results to return in a single call. To retrieve the
  remaining results, make another call with the returned NextToken value.
- `"NextToken"`: The token to request the next page of results.
"""
function list_components(
    ResourceGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_insights(
        "ListComponents",
        Dict{String,Any}("ResourceGroupName" => ResourceGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_components(
    ResourceGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_insights(
        "ListComponents",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ResourceGroupName" => ResourceGroupName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_configuration_history()
    list_configuration_history(params::Dict{String,<:Any})

 Lists the INFO, WARN, and ERROR events for periodic configuration updates performed by
Application Insights. Examples of events represented are:    INFO: creating a new alarm or
updating an alarm threshold.   WARN: alarm not created due to insufficient data points used
to predict thresholds.   ERROR: alarm not created due to permission errors or exceeding
quotas.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccountId"`: The AWS account ID for the resource group owner.
- `"EndTime"`: The end time of the event.
- `"EventStatus"`: The status of the configuration update event. Possible values include
  INFO, WARN, and ERROR.
- `"MaxResults"`:  The maximum number of results returned by ListConfigurationHistory in
  paginated output. When this parameter is used, ListConfigurationHistory returns only
  MaxResults in a single page along with a NextToken response element. The remaining results
  of the initial request can be seen by sending another ListConfigurationHistory request with
  the returned NextToken value. If this parameter is not used, then ListConfigurationHistory
  returns all results.
- `"NextToken"`: The NextToken value returned from a previous paginated
  ListConfigurationHistory request where MaxResults was used and the results exceeded the
  value of that parameter. Pagination continues from the end of the previous results that
  returned the NextToken value. This value is null when there are no more results to return.
- `"ResourceGroupName"`: Resource group to which the application belongs.
- `"StartTime"`: The start time of the event.
"""
function list_configuration_history(; aws_config::AbstractAWSConfig=current_aws_config())
    return application_insights(
        "ListConfigurationHistory"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_configuration_history(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_insights(
        "ListConfigurationHistory",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_log_pattern_sets(resource_group_name)
    list_log_pattern_sets(resource_group_name, params::Dict{String,<:Any})

Lists the log pattern sets in the specific application.

# Arguments
- `resource_group_name`: The name of the resource group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccountId"`: The AWS account ID for the resource group owner.
- `"MaxResults"`: The maximum number of results to return in a single call. To retrieve the
  remaining results, make another call with the returned NextToken value.
- `"NextToken"`: The token to request the next page of results.
"""
function list_log_pattern_sets(
    ResourceGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_insights(
        "ListLogPatternSets",
        Dict{String,Any}("ResourceGroupName" => ResourceGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_log_pattern_sets(
    ResourceGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_insights(
        "ListLogPatternSets",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ResourceGroupName" => ResourceGroupName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_log_patterns(resource_group_name)
    list_log_patterns(resource_group_name, params::Dict{String,<:Any})

Lists the log patterns in the specific log LogPatternSet.

# Arguments
- `resource_group_name`: The name of the resource group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccountId"`: The AWS account ID for the resource group owner.
- `"MaxResults"`: The maximum number of results to return in a single call. To retrieve the
  remaining results, make another call with the returned NextToken value.
- `"NextToken"`: The token to request the next page of results.
- `"PatternSetName"`: The name of the log pattern set.
"""
function list_log_patterns(
    ResourceGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_insights(
        "ListLogPatterns",
        Dict{String,Any}("ResourceGroupName" => ResourceGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_log_patterns(
    ResourceGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_insights(
        "ListLogPatterns",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ResourceGroupName" => ResourceGroupName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_problems()
    list_problems(params::Dict{String,<:Any})

Lists the problems with your application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccountId"`: The AWS account ID for the resource group owner.
- `"ComponentName"`:  The name of the component.
- `"EndTime"`: The time when the problem ended, in epoch seconds. If not specified,
  problems within the past seven days are returned.
- `"MaxResults"`: The maximum number of results to return in a single call. To retrieve the
  remaining results, make another call with the returned NextToken value.
- `"NextToken"`: The token to request the next page of results.
- `"ResourceGroupName"`: The name of the resource group.
- `"StartTime"`: The time when the problem was detected, in epoch seconds. If you don't
  specify a time frame for the request, problems within the past seven days are returned.
- `"Visibility"`: Specifies whether or not you can view the problem. If not specified,
  visible and ignored problems are returned.
"""
function list_problems(; aws_config::AbstractAWSConfig=current_aws_config())
    return application_insights(
        "ListProblems"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_problems(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_insights(
        "ListProblems", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Retrieve a list of the tags (keys and values) that are associated with a specified
application. A tag is a label that you optionally define and associate with an application.
Each tag consists of a required tag key and an optional associated tag value. A tag key is
a general label that acts as a category for more specific tag values. A tag value acts as a
descriptor within a tag key.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the application that you want to
  retrieve tag information for.

"""
function list_tags_for_resource(
    ResourceARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_insights(
        "ListTagsForResource",
        Dict{String,Any}("ResourceARN" => ResourceARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_insights(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceARN" => ResourceARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_workloads(component_name, resource_group_name)
    list_workloads(component_name, resource_group_name, params::Dict{String,<:Any})

Lists the workloads that are configured on a given component.

# Arguments
- `component_name`: The name of the component.
- `resource_group_name`: The name of the resource group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccountId"`: The AWS account ID of the owner of the workload.
- `"MaxResults"`: The maximum number of results to return in a single call. To retrieve the
  remaining results, make another call with the returned NextToken value.
- `"NextToken"`: The token to request the next page of results.
"""
function list_workloads(
    ComponentName, ResourceGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_insights(
        "ListWorkloads",
        Dict{String,Any}(
            "ComponentName" => ComponentName, "ResourceGroupName" => ResourceGroupName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_workloads(
    ComponentName,
    ResourceGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_insights(
        "ListWorkloads",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ComponentName" => ComponentName,
                    "ResourceGroupName" => ResourceGroupName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_workload(component_name, resource_group_name, workload_id)
    remove_workload(component_name, resource_group_name, workload_id, params::Dict{String,<:Any})

Remove workload from a component.

# Arguments
- `component_name`: The name of the component.
- `resource_group_name`: The name of the resource group.
- `workload_id`: The ID of the workload.

"""
function remove_workload(
    ComponentName,
    ResourceGroupName,
    WorkloadId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_insights(
        "RemoveWorkload",
        Dict{String,Any}(
            "ComponentName" => ComponentName,
            "ResourceGroupName" => ResourceGroupName,
            "WorkloadId" => WorkloadId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_workload(
    ComponentName,
    ResourceGroupName,
    WorkloadId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_insights(
        "RemoveWorkload",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ComponentName" => ComponentName,
                    "ResourceGroupName" => ResourceGroupName,
                    "WorkloadId" => WorkloadId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Add one or more tags (keys and values) to a specified application. A tag is a label that
you optionally define and associate with an application. Tags can help you categorize and
manage application in different ways, such as by purpose, owner, environment, or other
criteria.  Each tag consists of a required tag key and an associated tag value, both of
which you define. A tag key is a general label that acts as a category for more specific
tag values. A tag value acts as a descriptor within a tag key.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the application that you want to add
  one or more tags to.
- `tags`: A list of tags that to add to the application. A tag consists of a required tag
  key (Key) and an associated tag value (Value). The maximum length of a tag key is 128
  characters. The maximum length of a tag value is 256 characters.

"""
function tag_resource(ResourceARN, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return application_insights(
        "TagResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceARN,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_insights(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Remove one or more tags (keys and values) from a specified application.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the application that you want to remove
  one or more tags from.
- `tag_keys`: The tags (tag keys) that you want to remove from the resource. When you
  specify a tag key, the action removes both that key and its associated tag value. To remove
  more than one tag from the application, append the TagKeys parameter and argument for each
  additional tag to remove, separated by an ampersand.

"""
function untag_resource(
    ResourceARN, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_insights(
        "UntagResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceARN,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_insights(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_application(resource_group_name)
    update_application(resource_group_name, params::Dict{String,<:Any})

Updates the application.

# Arguments
- `resource_group_name`: The name of the resource group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AttachMissingPermission"`: If set to true, the managed policies for SSM and CW will be
  attached to the instance roles if they are missing.
- `"AutoConfigEnabled"`:  Turns auto-configuration on or off.
- `"CWEMonitorEnabled"`:  Indicates whether Application Insights can listen to CloudWatch
  events for the application resources, such as instance terminated, failed deployment, and
  others.
- `"OpsCenterEnabled"`:  When set to true, creates opsItems for any problems detected on an
  application.
- `"OpsItemSNSTopicArn"`:  The SNS topic provided to Application Insights that is
  associated to the created opsItem. Allows you to receive notifications for updates to the
  opsItem.
- `"RemoveSNSTopic"`:  Disassociates the SNS topic from the opsItem created for detected
  problems.
"""
function update_application(
    ResourceGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_insights(
        "UpdateApplication",
        Dict{String,Any}("ResourceGroupName" => ResourceGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_application(
    ResourceGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_insights(
        "UpdateApplication",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ResourceGroupName" => ResourceGroupName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_component(component_name, resource_group_name)
    update_component(component_name, resource_group_name, params::Dict{String,<:Any})

Updates the custom component name and/or the list of resources that make up the component.

# Arguments
- `component_name`: The name of the component.
- `resource_group_name`: The name of the resource group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NewComponentName"`: The new name of the component.
- `"ResourceList"`: The list of resource ARNs that belong to the component.
"""
function update_component(
    ComponentName, ResourceGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_insights(
        "UpdateComponent",
        Dict{String,Any}(
            "ComponentName" => ComponentName, "ResourceGroupName" => ResourceGroupName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_component(
    ComponentName,
    ResourceGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_insights(
        "UpdateComponent",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ComponentName" => ComponentName,
                    "ResourceGroupName" => ResourceGroupName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_component_configuration(component_name, resource_group_name)
    update_component_configuration(component_name, resource_group_name, params::Dict{String,<:Any})

Updates the monitoring configurations for the component. The configuration input parameter
is an escaped JSON of the configuration and should match the schema of what is returned by
DescribeComponentConfigurationRecommendation.

# Arguments
- `component_name`: The name of the component.
- `resource_group_name`: The name of the resource group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AutoConfigEnabled"`:  Automatically configures the component by applying the
  recommended configurations.
- `"ComponentConfiguration"`: The configuration settings of the component. The value is the
  escaped JSON of the configuration. For more information about the JSON format, see Working
  with JSON. You can send a request to DescribeComponentConfigurationRecommendation to see
  the recommended configuration for a component. For the complete format of the component
  configuration file, see Component Configuration.
- `"Monitor"`: Indicates whether the application component is monitored.
- `"Tier"`: The tier of the application component.
"""
function update_component_configuration(
    ComponentName, ResourceGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_insights(
        "UpdateComponentConfiguration",
        Dict{String,Any}(
            "ComponentName" => ComponentName, "ResourceGroupName" => ResourceGroupName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_component_configuration(
    ComponentName,
    ResourceGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_insights(
        "UpdateComponentConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ComponentName" => ComponentName,
                    "ResourceGroupName" => ResourceGroupName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_log_pattern(pattern_name, pattern_set_name, resource_group_name)
    update_log_pattern(pattern_name, pattern_set_name, resource_group_name, params::Dict{String,<:Any})

Adds a log pattern to a LogPatternSet.

# Arguments
- `pattern_name`: The name of the log pattern.
- `pattern_set_name`: The name of the log pattern set.
- `resource_group_name`: The name of the resource group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Pattern"`: The log pattern. The pattern must be DFA compatible. Patterns that utilize
  forward lookahead or backreference constructions are not supported.
- `"Rank"`: Rank of the log pattern. Must be a value between 1 and 1,000,000. The patterns
  are sorted by rank, so we recommend that you set your highest priority patterns with the
  lowest rank. A pattern of rank 1 will be the first to get matched to a log line. A pattern
  of rank 1,000,000 will be last to get matched. When you configure custom log patterns from
  the console, a Low severity pattern translates to a 750,000 rank. A Medium severity pattern
  translates to a 500,000 rank. And a High severity pattern translates to a 250,000 rank.
  Rank values less than 1 or greater than 1,000,000 are reserved for AWS-provided patterns.
"""
function update_log_pattern(
    PatternName,
    PatternSetName,
    ResourceGroupName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_insights(
        "UpdateLogPattern",
        Dict{String,Any}(
            "PatternName" => PatternName,
            "PatternSetName" => PatternSetName,
            "ResourceGroupName" => ResourceGroupName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_log_pattern(
    PatternName,
    PatternSetName,
    ResourceGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_insights(
        "UpdateLogPattern",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "PatternName" => PatternName,
                    "PatternSetName" => PatternSetName,
                    "ResourceGroupName" => ResourceGroupName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_problem(problem_id)
    update_problem(problem_id, params::Dict{String,<:Any})

Updates the visibility of the problem or specifies the problem as RESOLVED.

# Arguments
- `problem_id`: The ID of the problem.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"UpdateStatus"`: The status of the problem. Arguments can be passed for only problems
  that show a status of RECOVERING.
- `"Visibility"`: The visibility of a problem. When you pass a value of IGNORED, the
  problem is removed from the default view, and all notifications for the problem are
  suspended. When VISIBLE is passed, the IGNORED action is reversed.
"""
function update_problem(ProblemId; aws_config::AbstractAWSConfig=current_aws_config())
    return application_insights(
        "UpdateProblem",
        Dict{String,Any}("ProblemId" => ProblemId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_problem(
    ProblemId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_insights(
        "UpdateProblem",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ProblemId" => ProblemId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_workload(component_name, resource_group_name, workload_configuration)
    update_workload(component_name, resource_group_name, workload_configuration, params::Dict{String,<:Any})

Adds a workload to a component. Each component can have at most five workloads.

# Arguments
- `component_name`:  The name of the component.
- `resource_group_name`: The name of the resource group.
- `workload_configuration`: The configuration settings of the workload. The value is the
  escaped JSON of the configuration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"WorkloadId"`: The ID of the workload.
"""
function update_workload(
    ComponentName,
    ResourceGroupName,
    WorkloadConfiguration;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_insights(
        "UpdateWorkload",
        Dict{String,Any}(
            "ComponentName" => ComponentName,
            "ResourceGroupName" => ResourceGroupName,
            "WorkloadConfiguration" => WorkloadConfiguration,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_workload(
    ComponentName,
    ResourceGroupName,
    WorkloadConfiguration,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_insights(
        "UpdateWorkload",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ComponentName" => ComponentName,
                    "ResourceGroupName" => ResourceGroupName,
                    "WorkloadConfiguration" => WorkloadConfiguration,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: connect_contact_lens
using AWS.Compat
using AWS.UUIDs

"""
    list_realtime_contact_analysis_segments(contact_id, instance_id)
    list_realtime_contact_analysis_segments(contact_id, instance_id, params::Dict{String,<:Any})

Provides a list of analysis segments for a real-time analysis session.

# Arguments
- `contact_id`: The identifier of the contact.
- `instance_id`: The identifier of the Amazon Connect instance.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximimum number of results to return per page.
- `"NextToken"`: The token for the next set of results. Use the value returned in the
  previous response in the next request to retrieve the next set of results.
"""
function list_realtime_contact_analysis_segments(
    ContactId, InstanceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return connect_contact_lens(
        "POST",
        "/realtime-contact-analysis/analysis-segments",
        Dict{String,Any}("ContactId" => ContactId, "InstanceId" => InstanceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_realtime_contact_analysis_segments(
    ContactId,
    InstanceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return connect_contact_lens(
        "POST",
        "/realtime-contact-analysis/analysis-segments",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ContactId" => ContactId, "InstanceId" => InstanceId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: detective
using AWS.Compat
using AWS.UUIDs

"""
    accept_invitation(graph_arn)
    accept_invitation(graph_arn, params::Dict{String,<:Any})

Accepts an invitation for the member account to contribute data to a behavior graph. This
operation can only be called by an invited member account.  The request provides the ARN of
behavior graph. The member account status in the graph must be INVITED.

# Arguments
- `graph_arn`: The ARN of the behavior graph that the member account is accepting the
  invitation for. The member account status in the behavior graph must be INVITED.

"""
function accept_invitation(GraphArn; aws_config::AbstractAWSConfig=current_aws_config())
    return detective(
        "PUT",
        "/invitation",
        Dict{String,Any}("GraphArn" => GraphArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function accept_invitation(
    GraphArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return detective(
        "PUT",
        "/invitation",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("GraphArn" => GraphArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_get_graph_member_datasources(account_ids, graph_arn)
    batch_get_graph_member_datasources(account_ids, graph_arn, params::Dict{String,<:Any})

Gets data source package information for the behavior graph.

# Arguments
- `account_ids`: The list of Amazon Web Services accounts to get data source package
  information on.
- `graph_arn`: The ARN of the behavior graph.

"""
function batch_get_graph_member_datasources(
    AccountIds, GraphArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return detective(
        "POST",
        "/graph/datasources/get",
        Dict{String,Any}("AccountIds" => AccountIds, "GraphArn" => GraphArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_graph_member_datasources(
    AccountIds,
    GraphArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return detective(
        "POST",
        "/graph/datasources/get",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("AccountIds" => AccountIds, "GraphArn" => GraphArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_get_membership_datasources(graph_arns)
    batch_get_membership_datasources(graph_arns, params::Dict{String,<:Any})

Gets information on the data source package history for an account.

# Arguments
- `graph_arns`: The ARN of the behavior graph.

"""
function batch_get_membership_datasources(
    GraphArns; aws_config::AbstractAWSConfig=current_aws_config()
)
    return detective(
        "POST",
        "/membership/datasources/get",
        Dict{String,Any}("GraphArns" => GraphArns);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_membership_datasources(
    GraphArns,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return detective(
        "POST",
        "/membership/datasources/get",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("GraphArns" => GraphArns), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_graph()
    create_graph(params::Dict{String,<:Any})

Creates a new behavior graph for the calling account, and sets that account as the
administrator account. This operation is called by the account that is enabling Detective.
The operation also enables Detective for the calling account in the currently selected
Region. It returns the ARN of the new behavior graph.  CreateGraph triggers a process to
create the corresponding data tables for the new behavior graph. An account can only be the
administrator account for one behavior graph within a Region. If the same account calls
CreateGraph with the same administrator account, it always returns the same behavior graph
ARN. It does not create a new behavior graph.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: The tags to assign to the new behavior graph. You can add up to 50 tags. For
  each tag, you provide the tag key and the tag value. Each tag key can contain up to 128
  characters. Each tag value can contain up to 256 characters.
"""
function create_graph(; aws_config::AbstractAWSConfig=current_aws_config())
    return detective(
        "POST", "/graph"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function create_graph(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return detective(
        "POST", "/graph", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    create_members(accounts, graph_arn)
    create_members(accounts, graph_arn, params::Dict{String,<:Any})

 CreateMembers is used to send invitations to accounts. For the organization behavior
graph, the Detective administrator account uses CreateMembers to enable organization
accounts as member accounts. For invited accounts, CreateMembers sends a request to invite
the specified Amazon Web Services accounts to be member accounts in the behavior graph.
This operation can only be called by the administrator account for a behavior graph.
CreateMembers verifies the accounts and then invites the verified accounts. The
administrator can optionally specify to not send invitation emails to the member accounts.
This would be used when the administrator manages their member accounts centrally. For
organization accounts in the organization behavior graph, CreateMembers attempts to enable
the accounts. The organization accounts do not receive invitations. The request provides
the behavior graph ARN and the list of accounts to invite or to enable. The response
separates the requested accounts into two lists:   The accounts that CreateMembers was able
to process. For invited accounts, includes member accounts that are being verified, that
have passed verification and are to be invited, and that have failed verification. For
organization accounts in the organization behavior graph, includes accounts that can be
enabled and that cannot be enabled.   The accounts that CreateMembers was unable to
process. This list includes accounts that were already invited to be member accounts in the
behavior graph.

# Arguments
- `accounts`: The list of Amazon Web Services accounts to invite or to enable. You can
  invite or enable up to 50 accounts at a time. For each invited account, the account list
  contains the account identifier and the Amazon Web Services account root user email
  address. For organization accounts in the organization behavior graph, the email address is
  not required.
- `graph_arn`: The ARN of the behavior graph.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DisableEmailNotification"`: if set to true, then the invited accounts do not receive
  email notifications. By default, this is set to false, and the invited accounts receive
  email notifications. Organization accounts in the organization behavior graph do not
  receive email notifications.
- `"Message"`: Customized message text to include in the invitation email message to the
  invited member accounts.
"""
function create_members(
    Accounts, GraphArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return detective(
        "POST",
        "/graph/members",
        Dict{String,Any}("Accounts" => Accounts, "GraphArn" => GraphArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_members(
    Accounts,
    GraphArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return detective(
        "POST",
        "/graph/members",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Accounts" => Accounts, "GraphArn" => GraphArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_graph(graph_arn)
    delete_graph(graph_arn, params::Dict{String,<:Any})

Disables the specified behavior graph and queues it to be deleted. This operation removes
the behavior graph from each member account's list of behavior graphs.  DeleteGraph can
only be called by the administrator account for a behavior graph.

# Arguments
- `graph_arn`: The ARN of the behavior graph to disable.

"""
function delete_graph(GraphArn; aws_config::AbstractAWSConfig=current_aws_config())
    return detective(
        "POST",
        "/graph/removal",
        Dict{String,Any}("GraphArn" => GraphArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_graph(
    GraphArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return detective(
        "POST",
        "/graph/removal",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("GraphArn" => GraphArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_members(account_ids, graph_arn)
    delete_members(account_ids, graph_arn, params::Dict{String,<:Any})

Removes the specified member accounts from the behavior graph. The removed accounts no
longer contribute data to the behavior graph. This operation can only be called by the
administrator account for the behavior graph. For invited accounts, the removed accounts
are deleted from the list of accounts in the behavior graph. To restore the account, the
administrator account must send another invitation. For organization accounts in the
organization behavior graph, the Detective administrator account can always enable the
organization account again. Organization accounts that are not enabled as member accounts
are not included in the ListMembers results for the organization behavior graph. An
administrator account cannot use DeleteMembers to remove their own account from the
behavior graph. To disable a behavior graph, the administrator account uses the DeleteGraph
API method.

# Arguments
- `account_ids`: The list of Amazon Web Services account identifiers for the member
  accounts to remove from the behavior graph. You can remove up to 50 member accounts at a
  time.
- `graph_arn`: The ARN of the behavior graph to remove members from.

"""
function delete_members(
    AccountIds, GraphArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return detective(
        "POST",
        "/graph/members/removal",
        Dict{String,Any}("AccountIds" => AccountIds, "GraphArn" => GraphArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_members(
    AccountIds,
    GraphArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return detective(
        "POST",
        "/graph/members/removal",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("AccountIds" => AccountIds, "GraphArn" => GraphArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_organization_configuration(graph_arn)
    describe_organization_configuration(graph_arn, params::Dict{String,<:Any})

Returns information about the configuration for the organization behavior graph. Currently
indicates whether to automatically enable new organization accounts as member accounts. Can
only be called by the Detective administrator account for the organization.

# Arguments
- `graph_arn`: The ARN of the organization behavior graph.

"""
function describe_organization_configuration(
    GraphArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return detective(
        "POST",
        "/orgs/describeOrganizationConfiguration",
        Dict{String,Any}("GraphArn" => GraphArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_organization_configuration(
    GraphArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return detective(
        "POST",
        "/orgs/describeOrganizationConfiguration",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("GraphArn" => GraphArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disable_organization_admin_account()
    disable_organization_admin_account(params::Dict{String,<:Any})

Removes the Detective administrator account in the current Region. Deletes the organization
behavior graph. Can only be called by the organization management account. Removing the
Detective administrator account does not affect the delegated administrator account for
Detective in Organizations. To remove the delegated administrator account in Organizations,
use the Organizations API. Removing the delegated administrator account also removes the
Detective administrator account in all Regions, except for Regions where the Detective
administrator account is the organization management account.

"""
function disable_organization_admin_account(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return detective(
        "POST",
        "/orgs/disableAdminAccount";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disable_organization_admin_account(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return detective(
        "POST",
        "/orgs/disableAdminAccount",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_membership(graph_arn)
    disassociate_membership(graph_arn, params::Dict{String,<:Any})

Removes the member account from the specified behavior graph. This operation can only be
called by an invited member account that has the ENABLED status.  DisassociateMembership
cannot be called by an organization account in the organization behavior graph. For the
organization behavior graph, the Detective administrator account determines which
organization accounts to enable or disable as member accounts.

# Arguments
- `graph_arn`: The ARN of the behavior graph to remove the member account from. The member
  account's member status in the behavior graph must be ENABLED.

"""
function disassociate_membership(
    GraphArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return detective(
        "POST",
        "/membership/removal",
        Dict{String,Any}("GraphArn" => GraphArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_membership(
    GraphArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return detective(
        "POST",
        "/membership/removal",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("GraphArn" => GraphArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    enable_organization_admin_account(account_id)
    enable_organization_admin_account(account_id, params::Dict{String,<:Any})

Designates the Detective administrator account for the organization in the current Region.
If the account does not have Detective enabled, then enables Detective for that account and
creates a new behavior graph. Can only be called by the organization management account. If
the organization has a delegated administrator account in Organizations, then the Detective
administrator account must be either the delegated administrator account or the
organization management account. If the organization does not have a delegated
administrator account in Organizations, then you can choose any account in the
organization. If you choose an account other than the organization management account,
Detective calls Organizations to make that account the delegated administrator account for
Detective. The organization management account cannot be the delegated administrator
account.

# Arguments
- `account_id`: The Amazon Web Services account identifier of the account to designate as
  the Detective administrator account for the organization.

"""
function enable_organization_admin_account(
    AccountId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return detective(
        "POST",
        "/orgs/enableAdminAccount",
        Dict{String,Any}("AccountId" => AccountId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function enable_organization_admin_account(
    AccountId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return detective(
        "POST",
        "/orgs/enableAdminAccount",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AccountId" => AccountId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_investigation(graph_arn, investigation_id)
    get_investigation(graph_arn, investigation_id, params::Dict{String,<:Any})

Detective investigations lets you investigate IAM users and IAM roles using indicators of
compromise. An indicator of compromise (IOC) is an artifact observed in or on a network,
system, or environment that can (with a high level of confidence) identify malicious
activity or a security incident. GetInvestigation returns the investigation results of an
investigation for a behavior graph.

# Arguments
- `graph_arn`: The Amazon Resource Name (ARN) of the behavior graph.
- `investigation_id`: The investigation ID of the investigation report.

"""
function get_investigation(
    GraphArn, InvestigationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return detective(
        "POST",
        "/investigations/getInvestigation",
        Dict{String,Any}("GraphArn" => GraphArn, "InvestigationId" => InvestigationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_investigation(
    GraphArn,
    InvestigationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return detective(
        "POST",
        "/investigations/getInvestigation",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "GraphArn" => GraphArn, "InvestigationId" => InvestigationId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_members(account_ids, graph_arn)
    get_members(account_ids, graph_arn, params::Dict{String,<:Any})

Returns the membership details for specified member accounts for a behavior graph.

# Arguments
- `account_ids`: The list of Amazon Web Services account identifiers for the member account
  for which to return member details. You can request details for up to 50 member accounts at
  a time. You cannot use GetMembers to retrieve information about member accounts that were
  removed from the behavior graph.
- `graph_arn`: The ARN of the behavior graph for which to request the member details.

"""
function get_members(
    AccountIds, GraphArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return detective(
        "POST",
        "/graph/members/get",
        Dict{String,Any}("AccountIds" => AccountIds, "GraphArn" => GraphArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_members(
    AccountIds,
    GraphArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return detective(
        "POST",
        "/graph/members/get",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("AccountIds" => AccountIds, "GraphArn" => GraphArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_datasource_packages(graph_arn)
    list_datasource_packages(graph_arn, params::Dict{String,<:Any})

Lists data source packages in the behavior graph.

# Arguments
- `graph_arn`: The ARN of the behavior graph.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to return.
- `"NextToken"`: For requests to get the next page of results, the pagination token that
  was returned with the previous set of results. The initial request does not include a
  pagination token.
"""
function list_datasource_packages(
    GraphArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return detective(
        "POST",
        "/graph/datasources/list",
        Dict{String,Any}("GraphArn" => GraphArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_datasource_packages(
    GraphArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return detective(
        "POST",
        "/graph/datasources/list",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("GraphArn" => GraphArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_graphs()
    list_graphs(params::Dict{String,<:Any})

Returns the list of behavior graphs that the calling account is an administrator account
of. This operation can only be called by an administrator account. Because an account can
currently only be the administrator of one behavior graph within a Region, the results
always contain a single behavior graph.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of graphs to return at a time. The total must be less
  than the overall limit on the number of results to return, which is currently 200.
- `"NextToken"`: For requests to get the next page of results, the pagination token that
  was returned with the previous set of results. The initial request does not include a
  pagination token.
"""
function list_graphs(; aws_config::AbstractAWSConfig=current_aws_config())
    return detective(
        "POST", "/graphs/list"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_graphs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return detective(
        "POST",
        "/graphs/list",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_indicators(graph_arn, investigation_id)
    list_indicators(graph_arn, investigation_id, params::Dict{String,<:Any})

Gets the indicators from an investigation. You can use the information from the indicators
to determine if an IAM user and/or IAM role is involved in an unusual activity that could
indicate malicious behavior and its impact.

# Arguments
- `graph_arn`: The Amazon Resource Name (ARN) of the behavior graph.
- `investigation_id`: The investigation ID of the investigation report.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"IndicatorType"`: For the list of indicators of compromise that are generated by
  Detective investigations, see Detective investigations.
- `"MaxResults"`: Lists the maximum number of indicators in a page.
- `"NextToken"`: Lists if there are more results available. The value of nextToken is a
  unique pagination token for each page. Repeat the call using the returned token to retrieve
  the next page. Keep all other arguments unchanged. Each pagination token expires after 24
  hours. Using an expired pagination token will return a Validation Exception error.
"""
function list_indicators(
    GraphArn, InvestigationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return detective(
        "POST",
        "/investigations/listIndicators",
        Dict{String,Any}("GraphArn" => GraphArn, "InvestigationId" => InvestigationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_indicators(
    GraphArn,
    InvestigationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return detective(
        "POST",
        "/investigations/listIndicators",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "GraphArn" => GraphArn, "InvestigationId" => InvestigationId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_investigations(graph_arn)
    list_investigations(graph_arn, params::Dict{String,<:Any})

Detective investigations lets you investigate IAM users and IAM roles using indicators of
compromise. An indicator of compromise (IOC) is an artifact observed in or on a network,
system, or environment that can (with a high level of confidence) identify malicious
activity or a security incident. ListInvestigations lists all active Detective
investigations.

# Arguments
- `graph_arn`: The Amazon Resource Name (ARN) of the behavior graph.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FilterCriteria"`: Filters the investigation results based on a criteria.
- `"MaxResults"`: Lists the maximum number of investigations in a page.
- `"NextToken"`: Lists if there are more results available. The value of nextToken is a
  unique pagination token for each page. Repeat the call using the returned token to retrieve
  the next page. Keep all other arguments unchanged. Each pagination token expires after 24
  hours. Using an expired pagination token will return a Validation Exception error.
- `"SortCriteria"`: Sorts the investigation results based on a criteria.
"""
function list_investigations(GraphArn; aws_config::AbstractAWSConfig=current_aws_config())
    return detective(
        "POST",
        "/investigations/listInvestigations",
        Dict{String,Any}("GraphArn" => GraphArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_investigations(
    GraphArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return detective(
        "POST",
        "/investigations/listInvestigations",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("GraphArn" => GraphArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_invitations()
    list_invitations(params::Dict{String,<:Any})

Retrieves the list of open and accepted behavior graph invitations for the member account.
This operation can only be called by an invited member account. Open invitations are
invitations that the member account has not responded to. The results do not include
behavior graphs for which the member account declined the invitation. The results also do
not include behavior graphs that the member account resigned from or was removed from.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of behavior graph invitations to return in the
  response. The total must be less than the overall limit on the number of results to return,
  which is currently 200.
- `"NextToken"`: For requests to retrieve the next page of results, the pagination token
  that was returned with the previous page of results. The initial request does not include a
  pagination token.
"""
function list_invitations(; aws_config::AbstractAWSConfig=current_aws_config())
    return detective(
        "POST", "/invitations/list"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_invitations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return detective(
        "POST",
        "/invitations/list",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_members(graph_arn)
    list_members(graph_arn, params::Dict{String,<:Any})

Retrieves the list of member accounts for a behavior graph. For invited accounts, the
results do not include member accounts that were removed from the behavior graph. For the
organization behavior graph, the results do not include organization accounts that the
Detective administrator account has not enabled as member accounts.

# Arguments
- `graph_arn`: The ARN of the behavior graph for which to retrieve the list of member
  accounts.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of member accounts to include in the response. The
  total must be less than the overall limit on the number of results to return, which is
  currently 200.
- `"NextToken"`: For requests to retrieve the next page of member account results, the
  pagination token that was returned with the previous page of results. The initial request
  does not include a pagination token.
"""
function list_members(GraphArn; aws_config::AbstractAWSConfig=current_aws_config())
    return detective(
        "POST",
        "/graph/members/list",
        Dict{String,Any}("GraphArn" => GraphArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_members(
    GraphArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return detective(
        "POST",
        "/graph/members/list",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("GraphArn" => GraphArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_organization_admin_accounts()
    list_organization_admin_accounts(params::Dict{String,<:Any})

Returns information about the Detective administrator account for an organization. Can only
be called by the organization management account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to return.
- `"NextToken"`: For requests to get the next page of results, the pagination token that
  was returned with the previous set of results. The initial request does not include a
  pagination token.
"""
function list_organization_admin_accounts(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return detective(
        "POST",
        "/orgs/adminAccountslist";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_organization_admin_accounts(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return detective(
        "POST",
        "/orgs/adminAccountslist",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Returns the tag values that are assigned to a behavior graph.

# Arguments
- `resource_arn`: The ARN of the behavior graph for which to retrieve the tag values.

"""
function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return detective(
        "GET",
        "/tags/$(ResourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return detective(
        "GET",
        "/tags/$(ResourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    reject_invitation(graph_arn)
    reject_invitation(graph_arn, params::Dict{String,<:Any})

Rejects an invitation to contribute the account data to a behavior graph. This operation
must be called by an invited member account that has the INVITED status.  RejectInvitation
cannot be called by an organization account in the organization behavior graph. In the
organization behavior graph, organization accounts do not receive an invitation.

# Arguments
- `graph_arn`: The ARN of the behavior graph to reject the invitation to. The member
  account's current member status in the behavior graph must be INVITED.

"""
function reject_invitation(GraphArn; aws_config::AbstractAWSConfig=current_aws_config())
    return detective(
        "POST",
        "/invitation/removal",
        Dict{String,Any}("GraphArn" => GraphArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function reject_invitation(
    GraphArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return detective(
        "POST",
        "/invitation/removal",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("GraphArn" => GraphArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_investigation(entity_arn, graph_arn, scope_end_time, scope_start_time)
    start_investigation(entity_arn, graph_arn, scope_end_time, scope_start_time, params::Dict{String,<:Any})

Detective investigations lets you investigate IAM users and IAM roles using indicators of
compromise. An indicator of compromise (IOC) is an artifact observed in or on a network,
system, or environment that can (with a high level of confidence) identify malicious
activity or a security incident. StartInvestigation initiates an investigation on an entity
in a behavior graph.

# Arguments
- `entity_arn`: The unique Amazon Resource Name (ARN) of the IAM user and IAM role.
- `graph_arn`: The Amazon Resource Name (ARN) of the behavior graph.
- `scope_end_time`: The data and time when the investigation ended. The value is an UTC
  ISO8601 formatted string. For example, 2021-08-18T16:35:56.284Z.
- `scope_start_time`: The data and time when the investigation began. The value is an UTC
  ISO8601 formatted string. For example, 2021-08-18T16:35:56.284Z.

"""
function start_investigation(
    EntityArn,
    GraphArn,
    ScopeEndTime,
    ScopeStartTime;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return detective(
        "POST",
        "/investigations/startInvestigation",
        Dict{String,Any}(
            "EntityArn" => EntityArn,
            "GraphArn" => GraphArn,
            "ScopeEndTime" => ScopeEndTime,
            "ScopeStartTime" => ScopeStartTime,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_investigation(
    EntityArn,
    GraphArn,
    ScopeEndTime,
    ScopeStartTime,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return detective(
        "POST",
        "/investigations/startInvestigation",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EntityArn" => EntityArn,
                    "GraphArn" => GraphArn,
                    "ScopeEndTime" => ScopeEndTime,
                    "ScopeStartTime" => ScopeStartTime,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_monitoring_member(account_id, graph_arn)
    start_monitoring_member(account_id, graph_arn, params::Dict{String,<:Any})

Sends a request to enable data ingest for a member account that has a status of
ACCEPTED_BUT_DISABLED. For valid member accounts, the status is updated as follows.   If
Detective enabled the member account, then the new status is ENABLED.   If Detective cannot
enable the member account, the status remains ACCEPTED_BUT_DISABLED.

# Arguments
- `account_id`: The account ID of the member account to try to enable. The account must be
  an invited member account with a status of ACCEPTED_BUT_DISABLED.
- `graph_arn`: The ARN of the behavior graph.

"""
function start_monitoring_member(
    AccountId, GraphArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return detective(
        "POST",
        "/graph/member/monitoringstate",
        Dict{String,Any}("AccountId" => AccountId, "GraphArn" => GraphArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_monitoring_member(
    AccountId,
    GraphArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return detective(
        "POST",
        "/graph/member/monitoringstate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("AccountId" => AccountId, "GraphArn" => GraphArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Applies tag values to a behavior graph.

# Arguments
- `resource_arn`: The ARN of the behavior graph to assign the tags to.
- `tags`: The tags to assign to the behavior graph. You can add up to 50 tags. For each
  tag, you provide the tag key and the tag value. Each tag key can contain up to 128
  characters. Each tag value can contain up to 256 characters.

"""
function tag_resource(ResourceArn, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return detective(
        "POST",
        "/tags/$(ResourceArn)",
        Dict{String,Any}("Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceArn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return detective(
        "POST",
        "/tags/$(ResourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Tags" => Tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes tags from a behavior graph.

# Arguments
- `resource_arn`: The ARN of the behavior graph to remove the tags from.
- `tag_keys`: The tag keys of the tags to remove from the behavior graph. You can remove up
  to 50 tags at a time.

"""
function untag_resource(
    ResourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return detective(
        "DELETE",
        "/tags/$(ResourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return detective(
        "DELETE",
        "/tags/$(ResourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_datasource_packages(datasource_packages, graph_arn)
    update_datasource_packages(datasource_packages, graph_arn, params::Dict{String,<:Any})

Starts a data source packages for the behavior graph.

# Arguments
- `datasource_packages`: The data source package start for the behavior graph.
- `graph_arn`: The ARN of the behavior graph.

"""
function update_datasource_packages(
    DatasourcePackages, GraphArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return detective(
        "POST",
        "/graph/datasources/update",
        Dict{String,Any}(
            "DatasourcePackages" => DatasourcePackages, "GraphArn" => GraphArn
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_datasource_packages(
    DatasourcePackages,
    GraphArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return detective(
        "POST",
        "/graph/datasources/update",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DatasourcePackages" => DatasourcePackages, "GraphArn" => GraphArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_investigation_state(graph_arn, investigation_id, state)
    update_investigation_state(graph_arn, investigation_id, state, params::Dict{String,<:Any})

Updates the state of an investigation.

# Arguments
- `graph_arn`: The Amazon Resource Name (ARN) of the behavior graph.
- `investigation_id`: The investigation ID of the investigation report.
- `state`: The current state of the investigation. An archived investigation indicates you
  have completed reviewing the investigation.

"""
function update_investigation_state(
    GraphArn, InvestigationId, State; aws_config::AbstractAWSConfig=current_aws_config()
)
    return detective(
        "POST",
        "/investigations/updateInvestigationState",
        Dict{String,Any}(
            "GraphArn" => GraphArn, "InvestigationId" => InvestigationId, "State" => State
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_investigation_state(
    GraphArn,
    InvestigationId,
    State,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return detective(
        "POST",
        "/investigations/updateInvestigationState",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "GraphArn" => GraphArn,
                    "InvestigationId" => InvestigationId,
                    "State" => State,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_organization_configuration(graph_arn)
    update_organization_configuration(graph_arn, params::Dict{String,<:Any})

Updates the configuration for the Organizations integration in the current Region. Can only
be called by the Detective administrator account for the organization.

# Arguments
- `graph_arn`: The ARN of the organization behavior graph.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AutoEnable"`: Indicates whether to automatically enable new organization accounts as
  member accounts in the organization behavior graph.
"""
function update_organization_configuration(
    GraphArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return detective(
        "POST",
        "/orgs/updateOrganizationConfiguration",
        Dict{String,Any}("GraphArn" => GraphArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_organization_configuration(
    GraphArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return detective(
        "POST",
        "/orgs/updateOrganizationConfiguration",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("GraphArn" => GraphArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: service_catalog_appregistry
using AWS.Compat
using AWS.UUIDs

"""
    associate_attribute_group(application, attribute_group)
    associate_attribute_group(application, attribute_group, params::Dict{String,<:Any})

Associates an attribute group with an application to augment the application's metadata
with the group's attributes. This feature enables applications to be described with
user-defined details that are machine-readable, such as third-party integrations.

# Arguments
- `application`:  The name, ID, or ARN of the application.
- `attribute_group`:  The name, ID, or ARN of the attribute group that holds the attributes
  to describe the application.

"""
function associate_attribute_group(
    application, attributeGroup; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog_appregistry(
        "PUT",
        "/applications/$(application)/attribute-groups/$(attributeGroup)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_attribute_group(
    application,
    attributeGroup,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog_appregistry(
        "PUT",
        "/applications/$(application)/attribute-groups/$(attributeGroup)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_resource(application, resource, resource_type)
    associate_resource(application, resource, resource_type, params::Dict{String,<:Any})

 Associates a resource with an application. The resource can be specified by its ARN or
name. The application can be specified by ARN, ID, or name.   Minimum permissions   You
must have the following permissions to associate a resource using the OPTIONS parameter set
to APPLY_APPLICATION_TAG.     tag:GetResources     tag:TagResources     You must also have
these additional permissions if you don't use the AWSServiceCatalogAppRegistryFullAccess
policy. For more information, see AWSServiceCatalogAppRegistryFullAccess in the AppRegistry
Administrator Guide.     resource-groups:AssociateResource     cloudformation:UpdateStack
  cloudformation:DescribeStacks      In addition, you must have the tagging permission
defined by the Amazon Web Services service that creates the resource. For more information,
see TagResources in the Resource Groups Tagging API Reference.

# Arguments
- `application`:  The name, ID, or ARN of the application.
- `resource`: The name or ID of the resource of which the application will be associated.
- `resource_type`: The type of resource of which the application will be associated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"options"`:  Determines whether an application tag is applied or skipped.
"""
function associate_resource(
    application, resource, resourceType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog_appregistry(
        "PUT",
        "/applications/$(application)/resources/$(resourceType)/$(resource)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_resource(
    application,
    resource,
    resourceType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog_appregistry(
        "PUT",
        "/applications/$(application)/resources/$(resourceType)/$(resource)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_application(client_token, name)
    create_application(client_token, name, params::Dict{String,<:Any})

Creates a new application that is the top-level node in a hierarchy of related cloud
resource abstractions.

# Arguments
- `client_token`: A unique identifier that you provide to ensure idempotency. If you retry
  a request that completed successfully using the same client token and the same parameters,
  the retry succeeds without performing any further actions. If you retry a successful
  request using the same client token, but one or more of the parameters are different, the
  retry fails.
- `name`: The name of the application. The name must be unique in the region in which you
  are creating the application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description of the application.
- `"tags"`: Key-value pairs you can use to associate with the application.
"""
function create_application(
    clientToken, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog_appregistry(
        "POST",
        "/applications",
        Dict{String,Any}("clientToken" => clientToken, "name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_application(
    clientToken,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog_appregistry(
        "POST",
        "/applications",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("clientToken" => clientToken, "name" => name),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_attribute_group(attributes, client_token, name)
    create_attribute_group(attributes, client_token, name, params::Dict{String,<:Any})

Creates a new attribute group as a container for user-defined attributes. This feature
enables users to have full control over their cloud application's metadata in a rich
machine-readable format to facilitate integration with automated workflows and third-party
tools.

# Arguments
- `attributes`: A JSON string in the form of nested key-value pairs that represent the
  attributes in the group and describes an application and its components.
- `client_token`: A unique identifier that you provide to ensure idempotency. If you retry
  a request that completed successfully using the same client token and the same parameters,
  the retry succeeds without performing any further actions. If you retry a successful
  request using the same client token, but one or more of the parameters are different, the
  retry fails.
- `name`: The name of the attribute group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description of the attribute group that the user provides.
- `"tags"`: Key-value pairs you can use to associate with the attribute group.
"""
function create_attribute_group(
    attributes, clientToken, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog_appregistry(
        "POST",
        "/attribute-groups",
        Dict{String,Any}(
            "attributes" => attributes, "clientToken" => clientToken, "name" => name
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_attribute_group(
    attributes,
    clientToken,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog_appregistry(
        "POST",
        "/attribute-groups",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "attributes" => attributes, "clientToken" => clientToken, "name" => name
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_application(application)
    delete_application(application, params::Dict{String,<:Any})

Deletes an application that is specified either by its application ID, name, or ARN. All
associated attribute groups and resources must be disassociated from it before deleting an
application.

# Arguments
- `application`:  The name, ID, or ARN of the application.

"""
function delete_application(application; aws_config::AbstractAWSConfig=current_aws_config())
    return service_catalog_appregistry(
        "DELETE",
        "/applications/$(application)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_application(
    application,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog_appregistry(
        "DELETE",
        "/applications/$(application)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_attribute_group(attribute_group)
    delete_attribute_group(attribute_group, params::Dict{String,<:Any})

Deletes an attribute group, specified either by its attribute group ID, name, or ARN.

# Arguments
- `attribute_group`:  The name, ID, or ARN of the attribute group that holds the attributes
  to describe the application.

"""
function delete_attribute_group(
    attributeGroup; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog_appregistry(
        "DELETE",
        "/attribute-groups/$(attributeGroup)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_attribute_group(
    attributeGroup,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog_appregistry(
        "DELETE",
        "/attribute-groups/$(attributeGroup)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_attribute_group(application, attribute_group)
    disassociate_attribute_group(application, attribute_group, params::Dict{String,<:Any})

Disassociates an attribute group from an application to remove the extra attributes
contained in the attribute group from the application's metadata. This operation reverts
AssociateAttributeGroup.

# Arguments
- `application`:  The name, ID, or ARN of the application.
- `attribute_group`:  The name, ID, or ARN of the attribute group that holds the attributes
  to describe the application.

"""
function disassociate_attribute_group(
    application, attributeGroup; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog_appregistry(
        "DELETE",
        "/applications/$(application)/attribute-groups/$(attributeGroup)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_attribute_group(
    application,
    attributeGroup,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog_appregistry(
        "DELETE",
        "/applications/$(application)/attribute-groups/$(attributeGroup)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_resource(application, resource, resource_type)
    disassociate_resource(application, resource, resource_type, params::Dict{String,<:Any})

 Disassociates a resource from application. Both the resource and the application can be
specified either by ID or name.   Minimum permissions   You must have the following
permissions to remove a resource that's been associated with an application using the
APPLY_APPLICATION_TAG option for AssociateResource.     tag:GetResources
tag:UntagResources     You must also have the following permissions if you don't use the
AWSServiceCatalogAppRegistryFullAccess policy. For more information, see
AWSServiceCatalogAppRegistryFullAccess in the AppRegistry Administrator Guide.
resource-groups:DisassociateResource     cloudformation:UpdateStack
cloudformation:DescribeStacks      In addition, you must have the tagging permission
defined by the Amazon Web Services service that creates the resource. For more information,
see UntagResources in the Resource Groups Tagging API Reference.

# Arguments
- `application`: The name or ID of the application.
- `resource`: The name or ID of the resource.
- `resource_type`: The type of the resource that is being disassociated.

"""
function disassociate_resource(
    application, resource, resourceType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog_appregistry(
        "DELETE",
        "/applications/$(application)/resources/$(resourceType)/$(resource)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_resource(
    application,
    resource,
    resourceType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog_appregistry(
        "DELETE",
        "/applications/$(application)/resources/$(resourceType)/$(resource)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_application(application)
    get_application(application, params::Dict{String,<:Any})

 Retrieves metadata information about one of your applications. The application can be
specified by its ARN, ID, or name (which is unique within one account in one region at a
given point in time). Specify by ARN or ID in automated workflows if you want to make sure
that the exact same application is returned or a ResourceNotFoundException is thrown,
avoiding the ABA addressing problem.

# Arguments
- `application`:  The name, ID, or ARN of the application.

"""
function get_application(application; aws_config::AbstractAWSConfig=current_aws_config())
    return service_catalog_appregistry(
        "GET",
        "/applications/$(application)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_application(
    application,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog_appregistry(
        "GET",
        "/applications/$(application)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_associated_resource(application, resource, resource_type)
    get_associated_resource(application, resource, resource_type, params::Dict{String,<:Any})

Gets the resource associated with the application.

# Arguments
- `application`:  The name, ID, or ARN of the application.
- `resource`: The name or ID of the resource associated with the application.
- `resource_type`: The type of resource associated with the application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:  The maximum number of results to return. If the parameter is omitted, it
  defaults to 25. The value is optional.
- `"nextToken"`:  A unique pagination token for each page of results. Make the call again
  with the returned token to retrieve the next page of results.
- `"resourceTagStatus"`:  States whether an application tag is applied, not applied, in the
  process of being applied, or skipped.
"""
function get_associated_resource(
    application, resource, resourceType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog_appregistry(
        "GET",
        "/applications/$(application)/resources/$(resourceType)/$(resource)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_associated_resource(
    application,
    resource,
    resourceType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog_appregistry(
        "GET",
        "/applications/$(application)/resources/$(resourceType)/$(resource)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_attribute_group(attribute_group)
    get_attribute_group(attribute_group, params::Dict{String,<:Any})

 Retrieves an attribute group by its ARN, ID, or name. The attribute group can be specified
by its ARN, ID, or name.

# Arguments
- `attribute_group`:  The name, ID, or ARN of the attribute group that holds the attributes
  to describe the application.

"""
function get_attribute_group(
    attributeGroup; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog_appregistry(
        "GET",
        "/attribute-groups/$(attributeGroup)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_attribute_group(
    attributeGroup,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog_appregistry(
        "GET",
        "/attribute-groups/$(attributeGroup)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_configuration()
    get_configuration(params::Dict{String,<:Any})

 Retrieves a TagKey configuration from an account.

"""
function get_configuration(; aws_config::AbstractAWSConfig=current_aws_config())
    return service_catalog_appregistry(
        "GET", "/configuration"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog_appregistry(
        "GET",
        "/configuration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_applications()
    list_applications(params::Dict{String,<:Any})

Retrieves a list of all of your applications. Results are paginated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The upper bound of the number of results to return (cannot exceed 25). If
  this parameter is omitted, it defaults to 25. This value is optional.
- `"nextToken"`: The token to use to get the next page of results after a previous API
  call.
"""
function list_applications(; aws_config::AbstractAWSConfig=current_aws_config())
    return service_catalog_appregistry(
        "GET", "/applications"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_applications(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog_appregistry(
        "GET",
        "/applications",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_associated_attribute_groups(application)
    list_associated_attribute_groups(application, params::Dict{String,<:Any})

Lists all attribute groups that are associated with specified application. Results are
paginated.

# Arguments
- `application`: The name or ID of the application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The upper bound of the number of results to return (cannot exceed 25). If
  this parameter is omitted, it defaults to 25. This value is optional.
- `"nextToken"`: The token to use to get the next page of results after a previous API
  call.
"""
function list_associated_attribute_groups(
    application; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog_appregistry(
        "GET",
        "/applications/$(application)/attribute-groups";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_associated_attribute_groups(
    application,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog_appregistry(
        "GET",
        "/applications/$(application)/attribute-groups",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_associated_resources(application)
    list_associated_resources(application, params::Dict{String,<:Any})

 Lists all of the resources that are associated with the specified application. Results are
paginated.    If you share an application, and a consumer account associates a tag query to
the application, all of the users who can access the application can also view the tag
values in all accounts that are associated with it using this API.

# Arguments
- `application`:  The name, ID, or ARN of the application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The upper bound of the number of results to return (cannot exceed 25). If
  this parameter is omitted, it defaults to 25. This value is optional.
- `"nextToken"`: The token to use to get the next page of results after a previous API
  call.
"""
function list_associated_resources(
    application; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog_appregistry(
        "GET",
        "/applications/$(application)/resources";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_associated_resources(
    application,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog_appregistry(
        "GET",
        "/applications/$(application)/resources",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_attribute_groups()
    list_attribute_groups(params::Dict{String,<:Any})

Lists all attribute groups which you have access to. Results are paginated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The upper bound of the number of results to return (cannot exceed 25). If
  this parameter is omitted, it defaults to 25. This value is optional.
- `"nextToken"`: The token to use to get the next page of results after a previous API
  call.
"""
function list_attribute_groups(; aws_config::AbstractAWSConfig=current_aws_config())
    return service_catalog_appregistry(
        "GET", "/attribute-groups"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_attribute_groups(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog_appregistry(
        "GET",
        "/attribute-groups",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_attribute_groups_for_application(application)
    list_attribute_groups_for_application(application, params::Dict{String,<:Any})

Lists the details of all attribute groups associated with a specific application. The
results display in pages.

# Arguments
- `application`: The name or ID of the application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The upper bound of the number of results to return. The value cannot
  exceed 25. If you omit this parameter, it defaults to 25. This value is optional.
- `"nextToken"`: This token retrieves the next page of results after a previous API call.
"""
function list_attribute_groups_for_application(
    application; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog_appregistry(
        "GET",
        "/applications/$(application)/attribute-group-details";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_attribute_groups_for_application(
    application,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog_appregistry(
        "GET",
        "/applications/$(application)/attribute-group-details",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists all of the tags on the resource.

# Arguments
- `resource_arn`: The Amazon resource name (ARN) that specifies the resource.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog_appregistry(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog_appregistry(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_configuration(configuration)
    put_configuration(configuration, params::Dict{String,<:Any})

 Associates a TagKey configuration to an account.

# Arguments
- `configuration`:  Associates a TagKey configuration to an account.

"""
function put_configuration(
    configuration; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog_appregistry(
        "PUT",
        "/configuration",
        Dict{String,Any}("configuration" => configuration);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_configuration(
    configuration,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog_appregistry(
        "PUT",
        "/configuration",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("configuration" => configuration), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    sync_resource(resource, resource_type)
    sync_resource(resource, resource_type, params::Dict{String,<:Any})

Syncs the resource with current AppRegistry records. Specifically, the resource’s
AppRegistry system tags sync with its associated application. We remove the resource's
AppRegistry system tags if it does not associate with the application. The caller must have
permissions to read and update the resource.

# Arguments
- `resource`: An entity you can work with and specify with a name or ID. Examples include
  an Amazon EC2 instance, an Amazon Web Services CloudFormation stack, or an Amazon S3 bucket.
- `resource_type`: The type of resource of which the application will be associated.

"""
function sync_resource(
    resource, resourceType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog_appregistry(
        "POST",
        "/sync/$(resourceType)/$(resource)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function sync_resource(
    resource,
    resourceType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog_appregistry(
        "POST",
        "/sync/$(resourceType)/$(resource)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Assigns one or more tags (key-value pairs) to the specified resource. Each tag consists of
a key and an optional value. If a tag with the same key is already associated with the
resource, this action updates its value. This operation returns an empty response if the
call was successful.

# Arguments
- `resource_arn`: The Amazon resource name (ARN) that specifies the resource.
- `tags`: The new or modified tags for the resource.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return service_catalog_appregistry(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog_appregistry(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes tags from a resource. This operation returns an empty response if the call was
successful.

# Arguments
- `resource_arn`: The Amazon resource name (ARN) that specifies the resource.
- `tag_keys`: A list of the tag keys to remove from the specified resource.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog_appregistry(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog_appregistry(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_application(application)
    update_application(application, params::Dict{String,<:Any})

Updates an existing application with new attributes.

# Arguments
- `application`:  The name, ID, or ARN of the application that will be updated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The new description of the application.
- `"name"`: Deprecated: The new name of the application. The name must be unique in the
  region in which you are updating the application. Please do not use this field as we have
  stopped supporting name updates.
"""
function update_application(application; aws_config::AbstractAWSConfig=current_aws_config())
    return service_catalog_appregistry(
        "PATCH",
        "/applications/$(application)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_application(
    application,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog_appregistry(
        "PATCH",
        "/applications/$(application)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_attribute_group(attribute_group)
    update_attribute_group(attribute_group, params::Dict{String,<:Any})

Updates an existing attribute group with new details.

# Arguments
- `attribute_group`:  The name, ID, or ARN of the attribute group that holds the attributes
  to describe the application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"attributes"`: A JSON string in the form of nested key-value pairs that represent the
  attributes in the group and describes an application and its components.
- `"description"`: The description of the attribute group that the user provides.
- `"name"`: Deprecated: The new name of the attribute group. The name must be unique in the
  region in which you are updating the attribute group. Please do not use this field as we
  have stopped supporting name updates.
"""
function update_attribute_group(
    attributeGroup; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog_appregistry(
        "PATCH",
        "/attribute-groups/$(attributeGroup)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_attribute_group(
    attributeGroup,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog_appregistry(
        "PATCH",
        "/attribute-groups/$(attributeGroup)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: drs
using AWS.Compat
using AWS.UUIDs

"""
    associate_source_network_stack(cfn_stack_name, source_network_id)
    associate_source_network_stack(cfn_stack_name, source_network_id, params::Dict{String,<:Any})

Associate a Source Network to an existing CloudFormation Stack and modify launch templates
to use this network. Can be used for reverting to previously deployed CloudFormation stacks.

# Arguments
- `cfn_stack_name`: CloudFormation template to associate with a Source Network.
- `source_network_id`: The Source Network ID to associate with CloudFormation template.

"""
function associate_source_network_stack(
    cfnStackName, sourceNetworkID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return drs(
        "POST",
        "/AssociateSourceNetworkStack",
        Dict{String,Any}(
            "cfnStackName" => cfnStackName, "sourceNetworkID" => sourceNetworkID
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_source_network_stack(
    cfnStackName,
    sourceNetworkID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return drs(
        "POST",
        "/AssociateSourceNetworkStack",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "cfnStackName" => cfnStackName, "sourceNetworkID" => sourceNetworkID
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_extended_source_server(source_server_arn)
    create_extended_source_server(source_server_arn, params::Dict{String,<:Any})

Create an extended source server in the target Account based on the source server in
staging account.

# Arguments
- `source_server_arn`: This defines the ARN of the source server in staging Account based
  on which you want to create an extended source server.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tags"`: A list of tags associated with the extended source server.
"""
function create_extended_source_server(
    sourceServerArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return drs(
        "POST",
        "/CreateExtendedSourceServer",
        Dict{String,Any}("sourceServerArn" => sourceServerArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_extended_source_server(
    sourceServerArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return drs(
        "POST",
        "/CreateExtendedSourceServer",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("sourceServerArn" => sourceServerArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_launch_configuration_template()
    create_launch_configuration_template(params::Dict{String,<:Any})

Creates a new Launch Configuration Template.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"copyPrivateIp"`: Copy private IP.
- `"copyTags"`: Copy tags.
- `"exportBucketArn"`: S3 bucket ARN to export Source Network templates.
- `"launchDisposition"`: Launch disposition.
- `"launchIntoSourceInstance"`: DRS will set the 'launch into instance ID' of any source
  server when performing a drill, recovery or failback to the previous region or availability
  zone, using the instance ID of the source instance.
- `"licensing"`: Licensing.
- `"postLaunchEnabled"`: Whether we want to activate post-launch actions.
- `"tags"`: Request to associate tags during creation of a Launch Configuration Template.
- `"targetInstanceTypeRightSizingMethod"`: Target instance type right-sizing method.
"""
function create_launch_configuration_template(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return drs(
        "POST",
        "/CreateLaunchConfigurationTemplate";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_launch_configuration_template(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return drs(
        "POST",
        "/CreateLaunchConfigurationTemplate",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_replication_configuration_template(associate_default_security_group, bandwidth_throttling, create_public_ip, data_plane_routing, default_large_staging_disk_type, ebs_encryption, pit_policy, replication_server_instance_type, replication_servers_security_groups_ids, staging_area_subnet_id, staging_area_tags, use_dedicated_replication_server)
    create_replication_configuration_template(associate_default_security_group, bandwidth_throttling, create_public_ip, data_plane_routing, default_large_staging_disk_type, ebs_encryption, pit_policy, replication_server_instance_type, replication_servers_security_groups_ids, staging_area_subnet_id, staging_area_tags, use_dedicated_replication_server, params::Dict{String,<:Any})

Creates a new ReplicationConfigurationTemplate.

# Arguments
- `associate_default_security_group`: Whether to associate the default Elastic Disaster
  Recovery Security group with the Replication Configuration Template.
- `bandwidth_throttling`: Configure bandwidth throttling for the outbound data transfer
  rate of the Source Server in Mbps.
- `create_public_ip`: Whether to create a Public IP for the Recovery Instance by default.
- `data_plane_routing`: The data plane routing mechanism that will be used for replication.
- `default_large_staging_disk_type`: The Staging Disk EBS volume type to be used during
  replication.
- `ebs_encryption`: The type of EBS encryption to be used during replication.
- `pit_policy`: The Point in time (PIT) policy to manage snapshots taken during replication.
- `replication_server_instance_type`: The instance type to be used for the replication
  server.
- `replication_servers_security_groups_ids`: The security group IDs that will be used by
  the replication server.
- `staging_area_subnet_id`: The subnet to be used by the replication staging area.
- `staging_area_tags`: A set of tags to be associated with all resources created in the
  replication staging area: EC2 replication server, EBS volumes, EBS snapshots, etc.
- `use_dedicated_replication_server`: Whether to use a dedicated Replication Server in the
  replication staging area.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"autoReplicateNewDisks"`: Whether to allow the AWS replication agent to automatically
  replicate newly added disks.
- `"ebsEncryptionKeyArn"`: The ARN of the EBS encryption key to be used during replication.
- `"tags"`: A set of tags to be associated with the Replication Configuration Template
  resource.
"""
function create_replication_configuration_template(
    associateDefaultSecurityGroup,
    bandwidthThrottling,
    createPublicIP,
    dataPlaneRouting,
    defaultLargeStagingDiskType,
    ebsEncryption,
    pitPolicy,
    replicationServerInstanceType,
    replicationServersSecurityGroupsIDs,
    stagingAreaSubnetId,
    stagingAreaTags,
    useDedicatedReplicationServer;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return drs(
        "POST",
        "/CreateReplicationConfigurationTemplate",
        Dict{String,Any}(
            "associateDefaultSecurityGroup" => associateDefaultSecurityGroup,
            "bandwidthThrottling" => bandwidthThrottling,
            "createPublicIP" => createPublicIP,
            "dataPlaneRouting" => dataPlaneRouting,
            "defaultLargeStagingDiskType" => defaultLargeStagingDiskType,
            "ebsEncryption" => ebsEncryption,
            "pitPolicy" => pitPolicy,
            "replicationServerInstanceType" => replicationServerInstanceType,
            "replicationServersSecurityGroupsIDs" => replicationServersSecurityGroupsIDs,
            "stagingAreaSubnetId" => stagingAreaSubnetId,
            "stagingAreaTags" => stagingAreaTags,
            "useDedicatedReplicationServer" => useDedicatedReplicationServer,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_replication_configuration_template(
    associateDefaultSecurityGroup,
    bandwidthThrottling,
    createPublicIP,
    dataPlaneRouting,
    defaultLargeStagingDiskType,
    ebsEncryption,
    pitPolicy,
    replicationServerInstanceType,
    replicationServersSecurityGroupsIDs,
    stagingAreaSubnetId,
    stagingAreaTags,
    useDedicatedReplicationServer,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return drs(
        "POST",
        "/CreateReplicationConfigurationTemplate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "associateDefaultSecurityGroup" => associateDefaultSecurityGroup,
                    "bandwidthThrottling" => bandwidthThrottling,
                    "createPublicIP" => createPublicIP,
                    "dataPlaneRouting" => dataPlaneRouting,
                    "defaultLargeStagingDiskType" => defaultLargeStagingDiskType,
                    "ebsEncryption" => ebsEncryption,
                    "pitPolicy" => pitPolicy,
                    "replicationServerInstanceType" => replicationServerInstanceType,
                    "replicationServersSecurityGroupsIDs" =>
                        replicationServersSecurityGroupsIDs,
                    "stagingAreaSubnetId" => stagingAreaSubnetId,
                    "stagingAreaTags" => stagingAreaTags,
                    "useDedicatedReplicationServer" => useDedicatedReplicationServer,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_source_network(origin_account_id, origin_region, vpc_id)
    create_source_network(origin_account_id, origin_region, vpc_id, params::Dict{String,<:Any})

Create a new Source Network resource for a provided VPC ID.

# Arguments
- `origin_account_id`: Account containing the VPC to protect.
- `origin_region`: Region containing the VPC to protect.
- `vpc_id`: Which VPC ID to protect.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tags"`: A set of tags to be associated with the Source Network resource.
"""
function create_source_network(
    originAccountID, originRegion, vpcID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return drs(
        "POST",
        "/CreateSourceNetwork",
        Dict{String,Any}(
            "originAccountID" => originAccountID,
            "originRegion" => originRegion,
            "vpcID" => vpcID,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_source_network(
    originAccountID,
    originRegion,
    vpcID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return drs(
        "POST",
        "/CreateSourceNetwork",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "originAccountID" => originAccountID,
                    "originRegion" => originRegion,
                    "vpcID" => vpcID,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_job(job_id)
    delete_job(job_id, params::Dict{String,<:Any})

Deletes a single Job by ID.

# Arguments
- `job_id`: The ID of the Job to be deleted.

"""
function delete_job(jobID; aws_config::AbstractAWSConfig=current_aws_config())
    return drs(
        "POST",
        "/DeleteJob",
        Dict{String,Any}("jobID" => jobID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_job(
    jobID, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return drs(
        "POST",
        "/DeleteJob",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("jobID" => jobID), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_launch_action(action_id, resource_id)
    delete_launch_action(action_id, resource_id, params::Dict{String,<:Any})

Deletes a resource launch action.

# Arguments
- `action_id`:
- `resource_id`:

"""
function delete_launch_action(
    actionId, resourceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return drs(
        "POST",
        "/DeleteLaunchAction",
        Dict{String,Any}("actionId" => actionId, "resourceId" => resourceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_launch_action(
    actionId,
    resourceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return drs(
        "POST",
        "/DeleteLaunchAction",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("actionId" => actionId, "resourceId" => resourceId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_launch_configuration_template(launch_configuration_template_id)
    delete_launch_configuration_template(launch_configuration_template_id, params::Dict{String,<:Any})

Deletes a single Launch Configuration Template by ID.

# Arguments
- `launch_configuration_template_id`: The ID of the Launch Configuration Template to be
  deleted.

"""
function delete_launch_configuration_template(
    launchConfigurationTemplateID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return drs(
        "POST",
        "/DeleteLaunchConfigurationTemplate",
        Dict{String,Any}("launchConfigurationTemplateID" => launchConfigurationTemplateID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_launch_configuration_template(
    launchConfigurationTemplateID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return drs(
        "POST",
        "/DeleteLaunchConfigurationTemplate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "launchConfigurationTemplateID" => launchConfigurationTemplateID
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_recovery_instance(recovery_instance_id)
    delete_recovery_instance(recovery_instance_id, params::Dict{String,<:Any})

Deletes a single Recovery Instance by ID. This deletes the Recovery Instance resource from
Elastic Disaster Recovery. The Recovery Instance must be disconnected first in order to
delete it.

# Arguments
- `recovery_instance_id`: The ID of the Recovery Instance to be deleted.

"""
function delete_recovery_instance(
    recoveryInstanceID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return drs(
        "POST",
        "/DeleteRecoveryInstance",
        Dict{String,Any}("recoveryInstanceID" => recoveryInstanceID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_recovery_instance(
    recoveryInstanceID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return drs(
        "POST",
        "/DeleteRecoveryInstance",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("recoveryInstanceID" => recoveryInstanceID), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_replication_configuration_template(replication_configuration_template_id)
    delete_replication_configuration_template(replication_configuration_template_id, params::Dict{String,<:Any})

Deletes a single Replication Configuration Template by ID

# Arguments
- `replication_configuration_template_id`: The ID of the Replication Configuration Template
  to be deleted.

"""
function delete_replication_configuration_template(
    replicationConfigurationTemplateID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return drs(
        "POST",
        "/DeleteReplicationConfigurationTemplate",
        Dict{String,Any}(
            "replicationConfigurationTemplateID" => replicationConfigurationTemplateID
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_replication_configuration_template(
    replicationConfigurationTemplateID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return drs(
        "POST",
        "/DeleteReplicationConfigurationTemplate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "replicationConfigurationTemplateID" =>
                        replicationConfigurationTemplateID,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_source_network(source_network_id)
    delete_source_network(source_network_id, params::Dict{String,<:Any})

Delete Source Network resource.

# Arguments
- `source_network_id`: ID of the Source Network to delete.

"""
function delete_source_network(
    sourceNetworkID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return drs(
        "POST",
        "/DeleteSourceNetwork",
        Dict{String,Any}("sourceNetworkID" => sourceNetworkID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_source_network(
    sourceNetworkID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return drs(
        "POST",
        "/DeleteSourceNetwork",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("sourceNetworkID" => sourceNetworkID), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_source_server(source_server_id)
    delete_source_server(source_server_id, params::Dict{String,<:Any})

Deletes a single Source Server by ID. The Source Server must be disconnected first.

# Arguments
- `source_server_id`: The ID of the Source Server to be deleted.

"""
function delete_source_server(
    sourceServerID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return drs(
        "POST",
        "/DeleteSourceServer",
        Dict{String,Any}("sourceServerID" => sourceServerID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_source_server(
    sourceServerID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return drs(
        "POST",
        "/DeleteSourceServer",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("sourceServerID" => sourceServerID), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_job_log_items(job_id)
    describe_job_log_items(job_id, params::Dict{String,<:Any})

Retrieves a detailed Job log with pagination.

# Arguments
- `job_id`: The ID of the Job for which Job log items will be retrieved.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Maximum number of Job log items to retrieve.
- `"nextToken"`: The token of the next Job log items to retrieve.
"""
function describe_job_log_items(jobID; aws_config::AbstractAWSConfig=current_aws_config())
    return drs(
        "POST",
        "/DescribeJobLogItems",
        Dict{String,Any}("jobID" => jobID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_job_log_items(
    jobID, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return drs(
        "POST",
        "/DescribeJobLogItems",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("jobID" => jobID), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_jobs()
    describe_jobs(params::Dict{String,<:Any})

Returns a list of Jobs. Use the JobsID and fromDate and toDate filters to limit which jobs
are returned. The response is sorted by creationDataTime - latest date first. Jobs are
created by the StartRecovery, TerminateRecoveryInstances and StartFailbackLaunch APIs. Jobs
are also created by DiagnosticLaunch and TerminateDiagnosticInstances, which are APIs
available only to *Support* and only used in response to relevant support tickets.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: A set of filters by which to return Jobs.
- `"maxResults"`: Maximum number of Jobs to retrieve.
- `"nextToken"`: The token of the next Job to retrieve.
"""
function describe_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return drs(
        "POST", "/DescribeJobs"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return drs(
        "POST",
        "/DescribeJobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_launch_configuration_templates()
    describe_launch_configuration_templates(params::Dict{String,<:Any})

Lists all Launch Configuration Templates, filtered by Launch Configuration Template IDs

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"launchConfigurationTemplateIDs"`: Request to filter Launch Configuration Templates list
  by Launch Configuration Template ID.
- `"maxResults"`: Maximum results to be returned in DescribeLaunchConfigurationTemplates.
- `"nextToken"`: The token of the next Launch Configuration Template to retrieve.
"""
function describe_launch_configuration_templates(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return drs(
        "POST",
        "/DescribeLaunchConfigurationTemplates";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_launch_configuration_templates(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return drs(
        "POST",
        "/DescribeLaunchConfigurationTemplates",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_recovery_instances()
    describe_recovery_instances(params::Dict{String,<:Any})

Lists all Recovery Instances or multiple Recovery Instances by ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: A set of filters by which to return Recovery Instances.
- `"maxResults"`: Maximum number of Recovery Instances to retrieve.
- `"nextToken"`: The token of the next Recovery Instance to retrieve.
"""
function describe_recovery_instances(; aws_config::AbstractAWSConfig=current_aws_config())
    return drs(
        "POST",
        "/DescribeRecoveryInstances";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_recovery_instances(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return drs(
        "POST",
        "/DescribeRecoveryInstances",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_recovery_snapshots(source_server_id)
    describe_recovery_snapshots(source_server_id, params::Dict{String,<:Any})

Lists all Recovery Snapshots for a single Source Server.

# Arguments
- `source_server_id`: Filter Recovery Snapshots by Source Server ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: A set of filters by which to return Recovery Snapshots.
- `"maxResults"`: Maximum number of Recovery Snapshots to retrieve.
- `"nextToken"`: The token of the next Recovery Snapshot to retrieve.
- `"order"`: The sorted ordering by which to return Recovery Snapshots.
"""
function describe_recovery_snapshots(
    sourceServerID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return drs(
        "POST",
        "/DescribeRecoverySnapshots",
        Dict{String,Any}("sourceServerID" => sourceServerID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_recovery_snapshots(
    sourceServerID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return drs(
        "POST",
        "/DescribeRecoverySnapshots",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("sourceServerID" => sourceServerID), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_replication_configuration_templates()
    describe_replication_configuration_templates(params::Dict{String,<:Any})

Lists all ReplicationConfigurationTemplates, filtered by Source Server IDs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Maximum number of Replication Configuration Templates to retrieve.
- `"nextToken"`: The token of the next Replication Configuration Template to retrieve.
- `"replicationConfigurationTemplateIDs"`: The IDs of the Replication Configuration
  Templates to retrieve. An empty list means all Replication Configuration Templates.
"""
function describe_replication_configuration_templates(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return drs(
        "POST",
        "/DescribeReplicationConfigurationTemplates";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_replication_configuration_templates(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return drs(
        "POST",
        "/DescribeReplicationConfigurationTemplates",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_source_networks()
    describe_source_networks(params::Dict{String,<:Any})

Lists all Source Networks or multiple Source Networks filtered by ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: A set of filters by which to return Source Networks.
- `"maxResults"`: Maximum number of Source Networks to retrieve.
- `"nextToken"`: The token of the next Source Networks to retrieve.
"""
function describe_source_networks(; aws_config::AbstractAWSConfig=current_aws_config())
    return drs(
        "POST",
        "/DescribeSourceNetworks";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_source_networks(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return drs(
        "POST",
        "/DescribeSourceNetworks",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_source_servers()
    describe_source_servers(params::Dict{String,<:Any})

Lists all Source Servers or multiple Source Servers filtered by ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: A set of filters by which to return Source Servers.
- `"maxResults"`: Maximum number of Source Servers to retrieve.
- `"nextToken"`: The token of the next Source Server to retrieve.
"""
function describe_source_servers(; aws_config::AbstractAWSConfig=current_aws_config())
    return drs(
        "POST",
        "/DescribeSourceServers";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_source_servers(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return drs(
        "POST",
        "/DescribeSourceServers",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disconnect_recovery_instance(recovery_instance_id)
    disconnect_recovery_instance(recovery_instance_id, params::Dict{String,<:Any})

Disconnect a Recovery Instance from Elastic Disaster Recovery. Data replication is stopped
immediately. All AWS resources created by Elastic Disaster Recovery for enabling the
replication of the Recovery Instance will be terminated / deleted within 90 minutes. If the
agent on the Recovery Instance has not been prevented from communicating with the Elastic
Disaster Recovery service, then it will receive a command to uninstall itself (within
approximately 10 minutes). The following properties of the Recovery Instance will be
changed immediately: dataReplicationInfo.dataReplicationState will be set to DISCONNECTED;
The totalStorageBytes property for each of dataReplicationInfo.replicatedDisks will be set
to zero; dataReplicationInfo.lagDuration and dataReplicationInfo.lagDuration will be
nullified.

# Arguments
- `recovery_instance_id`: The ID of the Recovery Instance to disconnect.

"""
function disconnect_recovery_instance(
    recoveryInstanceID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return drs(
        "POST",
        "/DisconnectRecoveryInstance",
        Dict{String,Any}("recoveryInstanceID" => recoveryInstanceID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disconnect_recovery_instance(
    recoveryInstanceID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return drs(
        "POST",
        "/DisconnectRecoveryInstance",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("recoveryInstanceID" => recoveryInstanceID), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disconnect_source_server(source_server_id)
    disconnect_source_server(source_server_id, params::Dict{String,<:Any})

Disconnects a specific Source Server from Elastic Disaster Recovery. Data replication is
stopped immediately. All AWS resources created by Elastic Disaster Recovery for enabling
the replication of the Source Server will be terminated / deleted within 90 minutes. You
cannot disconnect a Source Server if it has a Recovery Instance. If the agent on the Source
Server has not been prevented from communicating with the Elastic Disaster Recovery
service, then it will receive a command to uninstall itself (within approximately 10
minutes). The following properties of the SourceServer will be changed immediately:
dataReplicationInfo.dataReplicationState will be set to DISCONNECTED; The totalStorageBytes
property for each of dataReplicationInfo.replicatedDisks will be set to zero;
dataReplicationInfo.lagDuration and dataReplicationInfo.lagDuration will be nullified.

# Arguments
- `source_server_id`: The ID of the Source Server to disconnect.

"""
function disconnect_source_server(
    sourceServerID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return drs(
        "POST",
        "/DisconnectSourceServer",
        Dict{String,Any}("sourceServerID" => sourceServerID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disconnect_source_server(
    sourceServerID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return drs(
        "POST",
        "/DisconnectSourceServer",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("sourceServerID" => sourceServerID), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    export_source_network_cfn_template(source_network_id)
    export_source_network_cfn_template(source_network_id, params::Dict{String,<:Any})

Export the Source Network CloudFormation template to an S3 bucket.

# Arguments
- `source_network_id`: The Source Network ID to export its CloudFormation template to an S3
  bucket.

"""
function export_source_network_cfn_template(
    sourceNetworkID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return drs(
        "POST",
        "/ExportSourceNetworkCfnTemplate",
        Dict{String,Any}("sourceNetworkID" => sourceNetworkID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function export_source_network_cfn_template(
    sourceNetworkID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return drs(
        "POST",
        "/ExportSourceNetworkCfnTemplate",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("sourceNetworkID" => sourceNetworkID), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_failback_replication_configuration(recovery_instance_id)
    get_failback_replication_configuration(recovery_instance_id, params::Dict{String,<:Any})

Lists all Failback ReplicationConfigurations, filtered by Recovery Instance ID.

# Arguments
- `recovery_instance_id`: The ID of the Recovery Instance whose failback replication
  configuration should be returned.

"""
function get_failback_replication_configuration(
    recoveryInstanceID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return drs(
        "POST",
        "/GetFailbackReplicationConfiguration",
        Dict{String,Any}("recoveryInstanceID" => recoveryInstanceID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_failback_replication_configuration(
    recoveryInstanceID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return drs(
        "POST",
        "/GetFailbackReplicationConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("recoveryInstanceID" => recoveryInstanceID), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_launch_configuration(source_server_id)
    get_launch_configuration(source_server_id, params::Dict{String,<:Any})

Gets a LaunchConfiguration, filtered by Source Server IDs.

# Arguments
- `source_server_id`: The ID of the Source Server that we want to retrieve a Launch
  Configuration for.

"""
function get_launch_configuration(
    sourceServerID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return drs(
        "POST",
        "/GetLaunchConfiguration",
        Dict{String,Any}("sourceServerID" => sourceServerID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_launch_configuration(
    sourceServerID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return drs(
        "POST",
        "/GetLaunchConfiguration",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("sourceServerID" => sourceServerID), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_replication_configuration(source_server_id)
    get_replication_configuration(source_server_id, params::Dict{String,<:Any})

Gets a ReplicationConfiguration, filtered by Source Server ID.

# Arguments
- `source_server_id`: The ID of the Source Serve for this Replication Configuration.r

"""
function get_replication_configuration(
    sourceServerID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return drs(
        "POST",
        "/GetReplicationConfiguration",
        Dict{String,Any}("sourceServerID" => sourceServerID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_replication_configuration(
    sourceServerID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return drs(
        "POST",
        "/GetReplicationConfiguration",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("sourceServerID" => sourceServerID), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    initialize_service()
    initialize_service(params::Dict{String,<:Any})

Initialize Elastic Disaster Recovery.

"""
function initialize_service(; aws_config::AbstractAWSConfig=current_aws_config())
    return drs(
        "POST", "/InitializeService"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function initialize_service(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return drs(
        "POST",
        "/InitializeService",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_extensible_source_servers(staging_account_id)
    list_extensible_source_servers(staging_account_id, params::Dict{String,<:Any})

Returns a list of source servers on a staging account that are extensible, which means
that: a. The source server is not already extended into this Account. b. The source server
on the Account we’re reading from is not an extension of another source server.

# Arguments
- `staging_account_id`: The Id of the staging Account to retrieve extensible source servers
  from.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of extensible source servers to retrieve.
- `"nextToken"`: The token of the next extensible source server to retrieve.
"""
function list_extensible_source_servers(
    stagingAccountID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return drs(
        "POST",
        "/ListExtensibleSourceServers",
        Dict{String,Any}("stagingAccountID" => stagingAccountID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_extensible_source_servers(
    stagingAccountID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return drs(
        "POST",
        "/ListExtensibleSourceServers",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("stagingAccountID" => stagingAccountID), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_launch_actions(resource_id)
    list_launch_actions(resource_id, params::Dict{String,<:Any})

Lists resource launch actions.

# Arguments
- `resource_id`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: Filters to apply when listing resource launch actions.
- `"maxResults"`: Maximum amount of items to return when listing resource launch actions.
- `"nextToken"`: Next token to use when listing resource launch actions.
"""
function list_launch_actions(resourceId; aws_config::AbstractAWSConfig=current_aws_config())
    return drs(
        "POST",
        "/ListLaunchActions",
        Dict{String,Any}("resourceId" => resourceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_launch_actions(
    resourceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return drs(
        "POST",
        "/ListLaunchActions",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceId" => resourceId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_staging_accounts()
    list_staging_accounts(params::Dict{String,<:Any})

Returns an array of staging accounts for existing extended source servers.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of staging Accounts to retrieve.
- `"nextToken"`: The token of the next staging Account to retrieve.
"""
function list_staging_accounts(; aws_config::AbstractAWSConfig=current_aws_config())
    return drs(
        "GET",
        "/ListStagingAccounts";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_staging_accounts(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return drs(
        "GET",
        "/ListStagingAccounts",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

List all tags for your Elastic Disaster Recovery resources.

# Arguments
- `resource_arn`: The ARN of the resource whose tags should be returned.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return drs(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return drs(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_launch_action(action_code, action_id, action_version, active, category, description, name, optional, order, resource_id)
    put_launch_action(action_code, action_id, action_version, active, category, description, name, optional, order, resource_id, params::Dict{String,<:Any})

Puts a resource launch action.

# Arguments
- `action_code`: Launch action code.
- `action_id`:
- `action_version`:
- `active`: Whether the launch action is active.
- `category`:
- `description`:
- `name`:
- `optional`: Whether the launch will not be marked as failed if this action fails.
- `order`:
- `resource_id`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"parameters"`:
"""
function put_launch_action(
    actionCode,
    actionId,
    actionVersion,
    active,
    category,
    description,
    name,
    optional,
    order,
    resourceId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return drs(
        "POST",
        "/PutLaunchAction",
        Dict{String,Any}(
            "actionCode" => actionCode,
            "actionId" => actionId,
            "actionVersion" => actionVersion,
            "active" => active,
            "category" => category,
            "description" => description,
            "name" => name,
            "optional" => optional,
            "order" => order,
            "resourceId" => resourceId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_launch_action(
    actionCode,
    actionId,
    actionVersion,
    active,
    category,
    description,
    name,
    optional,
    order,
    resourceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return drs(
        "POST",
        "/PutLaunchAction",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "actionCode" => actionCode,
                    "actionId" => actionId,
                    "actionVersion" => actionVersion,
                    "active" => active,
                    "category" => category,
                    "description" => description,
                    "name" => name,
                    "optional" => optional,
                    "order" => order,
                    "resourceId" => resourceId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    retry_data_replication(source_server_id)
    retry_data_replication(source_server_id, params::Dict{String,<:Any})

WARNING: RetryDataReplication is deprecated. Causes the data replication initiation
sequence to begin immediately upon next Handshake for the specified Source Server ID,
regardless of when the previous initiation started. This command will work only if the
Source Server is stalled or is in a DISCONNECTED or STOPPED state.

# Arguments
- `source_server_id`: The ID of the Source Server whose data replication should be retried.

"""
function retry_data_replication(
    sourceServerID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return drs(
        "POST",
        "/RetryDataReplication",
        Dict{String,Any}("sourceServerID" => sourceServerID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function retry_data_replication(
    sourceServerID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return drs(
        "POST",
        "/RetryDataReplication",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("sourceServerID" => sourceServerID), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    reverse_replication(recovery_instance_id)
    reverse_replication(recovery_instance_id, params::Dict{String,<:Any})

Start replication to origin / target region - applies only to protected instances that
originated in EC2. For recovery instances on target region - starts replication back to
origin region. For failback instances on origin region - starts replication to target
region to re-protect them.

# Arguments
- `recovery_instance_id`: The ID of the Recovery Instance that we want to reverse the
  replication for.

"""
function reverse_replication(
    recoveryInstanceID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return drs(
        "POST",
        "/ReverseReplication",
        Dict{String,Any}("recoveryInstanceID" => recoveryInstanceID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function reverse_replication(
    recoveryInstanceID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return drs(
        "POST",
        "/ReverseReplication",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("recoveryInstanceID" => recoveryInstanceID), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_failback_launch(recovery_instance_ids)
    start_failback_launch(recovery_instance_ids, params::Dict{String,<:Any})

Initiates a Job for launching the machine that is being failed back to from the specified
Recovery Instance. This will run conversion on the failback client and will reboot your
machine, thus completing the failback process.

# Arguments
- `recovery_instance_ids`: The IDs of the Recovery Instance whose failback launch we want
  to request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tags"`: The tags to be associated with the failback launch Job.
"""
function start_failback_launch(
    recoveryInstanceIDs; aws_config::AbstractAWSConfig=current_aws_config()
)
    return drs(
        "POST",
        "/StartFailbackLaunch",
        Dict{String,Any}("recoveryInstanceIDs" => recoveryInstanceIDs);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_failback_launch(
    recoveryInstanceIDs,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return drs(
        "POST",
        "/StartFailbackLaunch",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("recoveryInstanceIDs" => recoveryInstanceIDs),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_recovery(source_servers)
    start_recovery(source_servers, params::Dict{String,<:Any})

Launches Recovery Instances for the specified Source Servers. For each Source Server you
may choose a point in time snapshot to launch from, or use an on demand snapshot.

# Arguments
- `source_servers`: The Source Servers that we want to start a Recovery Job for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"isDrill"`: Whether this Source Server Recovery operation is a drill or not.
- `"tags"`: The tags to be associated with the Recovery Job.
"""
function start_recovery(sourceServers; aws_config::AbstractAWSConfig=current_aws_config())
    return drs(
        "POST",
        "/StartRecovery",
        Dict{String,Any}("sourceServers" => sourceServers);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_recovery(
    sourceServers,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return drs(
        "POST",
        "/StartRecovery",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("sourceServers" => sourceServers), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_replication(source_server_id)
    start_replication(source_server_id, params::Dict{String,<:Any})

Starts replication for a stopped Source Server. This action would make the Source Server
protected again and restart billing for it.

# Arguments
- `source_server_id`: The ID of the Source Server to start replication for.

"""
function start_replication(
    sourceServerID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return drs(
        "POST",
        "/StartReplication",
        Dict{String,Any}("sourceServerID" => sourceServerID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_replication(
    sourceServerID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return drs(
        "POST",
        "/StartReplication",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("sourceServerID" => sourceServerID), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_source_network_recovery(source_networks)
    start_source_network_recovery(source_networks, params::Dict{String,<:Any})

Deploy VPC for the specified Source Network and modify launch templates to use this
network. The VPC will be deployed using a dedicated CloudFormation stack.

# Arguments
- `source_networks`: The Source Networks that we want to start a Recovery Job for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"deployAsNew"`: Don't update existing CloudFormation Stack, recover the network using a
  new stack.
- `"tags"`: The tags to be associated with the Source Network recovery Job.
"""
function start_source_network_recovery(
    sourceNetworks; aws_config::AbstractAWSConfig=current_aws_config()
)
    return drs(
        "POST",
        "/StartSourceNetworkRecovery",
        Dict{String,Any}("sourceNetworks" => sourceNetworks);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_source_network_recovery(
    sourceNetworks,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return drs(
        "POST",
        "/StartSourceNetworkRecovery",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("sourceNetworks" => sourceNetworks), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_source_network_replication(source_network_id)
    start_source_network_replication(source_network_id, params::Dict{String,<:Any})

Starts replication for a Source Network. This action would make the Source Network
protected.

# Arguments
- `source_network_id`: ID of the Source Network to replicate.

"""
function start_source_network_replication(
    sourceNetworkID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return drs(
        "POST",
        "/StartSourceNetworkReplication",
        Dict{String,Any}("sourceNetworkID" => sourceNetworkID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_source_network_replication(
    sourceNetworkID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return drs(
        "POST",
        "/StartSourceNetworkReplication",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("sourceNetworkID" => sourceNetworkID), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_failback(recovery_instance_id)
    stop_failback(recovery_instance_id, params::Dict{String,<:Any})

Stops the failback process for a specified Recovery Instance. This changes the Failback
State of the Recovery Instance back to FAILBACK_NOT_STARTED.

# Arguments
- `recovery_instance_id`: The ID of the Recovery Instance we want to stop failback for.

"""
function stop_failback(
    recoveryInstanceID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return drs(
        "POST",
        "/StopFailback",
        Dict{String,Any}("recoveryInstanceID" => recoveryInstanceID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_failback(
    recoveryInstanceID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return drs(
        "POST",
        "/StopFailback",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("recoveryInstanceID" => recoveryInstanceID), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_replication(source_server_id)
    stop_replication(source_server_id, params::Dict{String,<:Any})

Stops replication for a Source Server. This action would make the Source Server
unprotected, delete its existing snapshots and stop billing for it.

# Arguments
- `source_server_id`: The ID of the Source Server to stop replication for.

"""
function stop_replication(
    sourceServerID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return drs(
        "POST",
        "/StopReplication",
        Dict{String,Any}("sourceServerID" => sourceServerID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_replication(
    sourceServerID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return drs(
        "POST",
        "/StopReplication",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("sourceServerID" => sourceServerID), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_source_network_replication(source_network_id)
    stop_source_network_replication(source_network_id, params::Dict{String,<:Any})

Stops replication for a Source Network. This action would make the Source Network
unprotected.

# Arguments
- `source_network_id`: ID of the Source Network to stop replication.

"""
function stop_source_network_replication(
    sourceNetworkID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return drs(
        "POST",
        "/StopSourceNetworkReplication",
        Dict{String,Any}("sourceNetworkID" => sourceNetworkID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_source_network_replication(
    sourceNetworkID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return drs(
        "POST",
        "/StopSourceNetworkReplication",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("sourceNetworkID" => sourceNetworkID), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds or overwrites only the specified tags for the specified Elastic Disaster Recovery
resource or resources. When you specify an existing tag key, the value is overwritten with
the new value. Each resource can have a maximum of 50 tags. Each tag consists of a key and
optional value.

# Arguments
- `resource_arn`: ARN of the resource for which tags are to be added or updated.
- `tags`: Array of tags to be added or updated.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return drs(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return drs(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    terminate_recovery_instances(recovery_instance_ids)
    terminate_recovery_instances(recovery_instance_ids, params::Dict{String,<:Any})

Initiates a Job for terminating the EC2 resources associated with the specified Recovery
Instances, and then will delete the Recovery Instances from the Elastic Disaster Recovery
service.

# Arguments
- `recovery_instance_ids`: The IDs of the Recovery Instances that should be terminated.

"""
function terminate_recovery_instances(
    recoveryInstanceIDs; aws_config::AbstractAWSConfig=current_aws_config()
)
    return drs(
        "POST",
        "/TerminateRecoveryInstances",
        Dict{String,Any}("recoveryInstanceIDs" => recoveryInstanceIDs);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function terminate_recovery_instances(
    recoveryInstanceIDs,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return drs(
        "POST",
        "/TerminateRecoveryInstances",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("recoveryInstanceIDs" => recoveryInstanceIDs),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Deletes the specified set of tags from the specified set of Elastic Disaster Recovery
resources.

# Arguments
- `resource_arn`: ARN of the resource for which tags are to be removed.
- `tag_keys`: Array of tags to be removed.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return drs(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return drs(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_failback_replication_configuration(recovery_instance_id)
    update_failback_replication_configuration(recovery_instance_id, params::Dict{String,<:Any})

Allows you to update the failback replication configuration of a Recovery Instance by ID.

# Arguments
- `recovery_instance_id`: The ID of the Recovery Instance.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"bandwidthThrottling"`: Configure bandwidth throttling for the outbound data transfer
  rate of the Recovery Instance in Mbps.
- `"name"`: The name of the Failback Replication Configuration.
- `"usePrivateIP"`: Whether to use Private IP for the failback replication of the Recovery
  Instance.
"""
function update_failback_replication_configuration(
    recoveryInstanceID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return drs(
        "POST",
        "/UpdateFailbackReplicationConfiguration",
        Dict{String,Any}("recoveryInstanceID" => recoveryInstanceID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_failback_replication_configuration(
    recoveryInstanceID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return drs(
        "POST",
        "/UpdateFailbackReplicationConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("recoveryInstanceID" => recoveryInstanceID), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_launch_configuration(source_server_id)
    update_launch_configuration(source_server_id, params::Dict{String,<:Any})

Updates a LaunchConfiguration by Source Server ID.

# Arguments
- `source_server_id`: The ID of the Source Server that we want to retrieve a Launch
  Configuration for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"copyPrivateIp"`: Whether we should copy the Private IP of the Source Server to the
  Recovery Instance.
- `"copyTags"`: Whether we want to copy the tags of the Source Server to the EC2 machine of
  the Recovery Instance.
- `"launchDisposition"`: The state of the Recovery Instance in EC2 after the recovery
  operation.
- `"launchIntoInstanceProperties"`: Launch into existing instance properties.
- `"licensing"`: The licensing configuration to be used for this launch configuration.
- `"name"`: The name of the launch configuration.
- `"postLaunchEnabled"`: Whether we want to enable post-launch actions for the Source
  Server.
- `"targetInstanceTypeRightSizingMethod"`: Whether Elastic Disaster Recovery should try to
  automatically choose the instance type that best matches the OS, CPU, and RAM of your
  Source Server.
"""
function update_launch_configuration(
    sourceServerID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return drs(
        "POST",
        "/UpdateLaunchConfiguration",
        Dict{String,Any}("sourceServerID" => sourceServerID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_launch_configuration(
    sourceServerID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return drs(
        "POST",
        "/UpdateLaunchConfiguration",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("sourceServerID" => sourceServerID), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_launch_configuration_template(launch_configuration_template_id)
    update_launch_configuration_template(launch_configuration_template_id, params::Dict{String,<:Any})

Updates an existing Launch Configuration Template by ID.

# Arguments
- `launch_configuration_template_id`: Launch Configuration Template ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"copyPrivateIp"`: Copy private IP.
- `"copyTags"`: Copy tags.
- `"exportBucketArn"`: S3 bucket ARN to export Source Network templates.
- `"launchDisposition"`: Launch disposition.
- `"launchIntoSourceInstance"`: DRS will set the 'launch into instance ID' of any source
  server when performing a drill, recovery or failback to the previous region or availability
  zone, using the instance ID of the source instance.
- `"licensing"`: Licensing.
- `"postLaunchEnabled"`: Whether we want to activate post-launch actions.
- `"targetInstanceTypeRightSizingMethod"`: Target instance type right-sizing method.
"""
function update_launch_configuration_template(
    launchConfigurationTemplateID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return drs(
        "POST",
        "/UpdateLaunchConfigurationTemplate",
        Dict{String,Any}("launchConfigurationTemplateID" => launchConfigurationTemplateID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_launch_configuration_template(
    launchConfigurationTemplateID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return drs(
        "POST",
        "/UpdateLaunchConfigurationTemplate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "launchConfigurationTemplateID" => launchConfigurationTemplateID
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_replication_configuration(source_server_id)
    update_replication_configuration(source_server_id, params::Dict{String,<:Any})

Allows you to update a ReplicationConfiguration by Source Server ID.

# Arguments
- `source_server_id`: The ID of the Source Server for this Replication Configuration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"associateDefaultSecurityGroup"`: Whether to associate the default Elastic Disaster
  Recovery Security group with the Replication Configuration.
- `"autoReplicateNewDisks"`: Whether to allow the AWS replication agent to automatically
  replicate newly added disks.
- `"bandwidthThrottling"`: Configure bandwidth throttling for the outbound data transfer
  rate of the Source Server in Mbps.
- `"createPublicIP"`: Whether to create a Public IP for the Recovery Instance by default.
- `"dataPlaneRouting"`: The data plane routing mechanism that will be used for replication.
- `"defaultLargeStagingDiskType"`: The Staging Disk EBS volume type to be used during
  replication.
- `"ebsEncryption"`: The type of EBS encryption to be used during replication.
- `"ebsEncryptionKeyArn"`: The ARN of the EBS encryption key to be used during replication.
- `"name"`: The name of the Replication Configuration.
- `"pitPolicy"`: The Point in time (PIT) policy to manage snapshots taken during
  replication.
- `"replicatedDisks"`: The configuration of the disks of the Source Server to be replicated.
- `"replicationServerInstanceType"`: The instance type to be used for the replication
  server.
- `"replicationServersSecurityGroupsIDs"`: The security group IDs that will be used by the
  replication server.
- `"stagingAreaSubnetId"`: The subnet to be used by the replication staging area.
- `"stagingAreaTags"`: A set of tags to be associated with all resources created in the
  replication staging area: EC2 replication server, EBS volumes, EBS snapshots, etc.
- `"useDedicatedReplicationServer"`: Whether to use a dedicated Replication Server in the
  replication staging area.
"""
function update_replication_configuration(
    sourceServerID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return drs(
        "POST",
        "/UpdateReplicationConfiguration",
        Dict{String,Any}("sourceServerID" => sourceServerID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_replication_configuration(
    sourceServerID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return drs(
        "POST",
        "/UpdateReplicationConfiguration",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("sourceServerID" => sourceServerID), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_replication_configuration_template(replication_configuration_template_id)
    update_replication_configuration_template(replication_configuration_template_id, params::Dict{String,<:Any})

Updates a ReplicationConfigurationTemplate by ID.

# Arguments
- `replication_configuration_template_id`: The Replication Configuration Template ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"arn"`: The Replication Configuration Template ARN.
- `"associateDefaultSecurityGroup"`: Whether to associate the default Elastic Disaster
  Recovery Security group with the Replication Configuration Template.
- `"autoReplicateNewDisks"`: Whether to allow the AWS replication agent to automatically
  replicate newly added disks.
- `"bandwidthThrottling"`: Configure bandwidth throttling for the outbound data transfer
  rate of the Source Server in Mbps.
- `"createPublicIP"`: Whether to create a Public IP for the Recovery Instance by default.
- `"dataPlaneRouting"`: The data plane routing mechanism that will be used for replication.
- `"defaultLargeStagingDiskType"`: The Staging Disk EBS volume type to be used during
  replication.
- `"ebsEncryption"`: The type of EBS encryption to be used during replication.
- `"ebsEncryptionKeyArn"`: The ARN of the EBS encryption key to be used during replication.
- `"pitPolicy"`: The Point in time (PIT) policy to manage snapshots taken during
  replication.
- `"replicationServerInstanceType"`: The instance type to be used for the replication
  server.
- `"replicationServersSecurityGroupsIDs"`: The security group IDs that will be used by the
  replication server.
- `"stagingAreaSubnetId"`: The subnet to be used by the replication staging area.
- `"stagingAreaTags"`: A set of tags to be associated with all resources created in the
  replication staging area: EC2 replication server, EBS volumes, EBS snapshots, etc.
- `"useDedicatedReplicationServer"`: Whether to use a dedicated Replication Server in the
  replication staging area.
"""
function update_replication_configuration_template(
    replicationConfigurationTemplateID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return drs(
        "POST",
        "/UpdateReplicationConfigurationTemplate",
        Dict{String,Any}(
            "replicationConfigurationTemplateID" => replicationConfigurationTemplateID
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_replication_configuration_template(
    replicationConfigurationTemplateID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return drs(
        "POST",
        "/UpdateReplicationConfigurationTemplate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "replicationConfigurationTemplateID" =>
                        replicationConfigurationTemplateID,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: accessanalyzer
using AWS.Compat
using AWS.UUIDs

"""
    apply_archive_rule(analyzer_arn, rule_name)
    apply_archive_rule(analyzer_arn, rule_name, params::Dict{String,<:Any})

Retroactively applies the archive rule to existing findings that meet the archive rule
criteria.

# Arguments
- `analyzer_arn`: The Amazon resource name (ARN) of the analyzer.
- `rule_name`: The name of the rule to apply.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A client token.
"""
function apply_archive_rule(
    analyzerArn, ruleName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return accessanalyzer(
        "PUT",
        "/archive-rule",
        Dict{String,Any}(
            "analyzerArn" => analyzerArn,
            "ruleName" => ruleName,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function apply_archive_rule(
    analyzerArn,
    ruleName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return accessanalyzer(
        "PUT",
        "/archive-rule",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "analyzerArn" => analyzerArn,
                    "ruleName" => ruleName,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_policy_generation(job_id)
    cancel_policy_generation(job_id, params::Dict{String,<:Any})

Cancels the requested policy generation.

# Arguments
- `job_id`: The JobId that is returned by the StartPolicyGeneration operation. The JobId
  can be used with GetGeneratedPolicy to retrieve the generated policies or used with
  CancelPolicyGeneration to cancel the policy generation request.

"""
function cancel_policy_generation(jobId; aws_config::AbstractAWSConfig=current_aws_config())
    return accessanalyzer(
        "PUT",
        "/policy/generation/$(jobId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_policy_generation(
    jobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return accessanalyzer(
        "PUT",
        "/policy/generation/$(jobId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    check_access_not_granted(access, policy_document, policy_type)
    check_access_not_granted(access, policy_document, policy_type, params::Dict{String,<:Any})

Checks whether the specified access isn't allowed by a policy.

# Arguments
- `access`: An access object containing the permissions that shouldn't be granted by the
  specified policy. If only actions are specified, IAM Access Analyzer checks for access of
  the actions on all resources in the policy. If only resources are specified, then IAM
  Access Analyzer checks which actions have access to the specified resources. If both
  actions and resources are specified, then IAM Access Analyzer checks which of the specified
  actions have access to the specified resources.
- `policy_document`: The JSON policy document to use as the content for the policy.
- `policy_type`: The type of policy. Identity policies grant permissions to IAM principals.
  Identity policies include managed and inline policies for IAM roles, users, and groups.
  Resource policies grant permissions on Amazon Web Services resources. Resource policies
  include trust policies for IAM roles and bucket policies for Amazon S3 buckets. You can
  provide a generic input such as identity policy or resource policy or a specific input such
  as managed policy or Amazon S3 bucket policy.

"""
function check_access_not_granted(
    access, policyDocument, policyType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return accessanalyzer(
        "POST",
        "/policy/check-access-not-granted",
        Dict{String,Any}(
            "access" => access,
            "policyDocument" => policyDocument,
            "policyType" => policyType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function check_access_not_granted(
    access,
    policyDocument,
    policyType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return accessanalyzer(
        "POST",
        "/policy/check-access-not-granted",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "access" => access,
                    "policyDocument" => policyDocument,
                    "policyType" => policyType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    check_no_new_access(existing_policy_document, new_policy_document, policy_type)
    check_no_new_access(existing_policy_document, new_policy_document, policy_type, params::Dict{String,<:Any})

Checks whether new access is allowed for an updated policy when compared to the existing
policy. You can find examples for reference policies and learn how to set up and run a
custom policy check for new access in the IAM Access Analyzer custom policy checks samples
repository on GitHub. The reference policies in this repository are meant to be passed to
the existingPolicyDocument request parameter.

# Arguments
- `existing_policy_document`: The JSON policy document to use as the content for the
  existing policy.
- `new_policy_document`: The JSON policy document to use as the content for the updated
  policy.
- `policy_type`: The type of policy to compare. Identity policies grant permissions to IAM
  principals. Identity policies include managed and inline policies for IAM roles, users, and
  groups. Resource policies grant permissions on Amazon Web Services resources. Resource
  policies include trust policies for IAM roles and bucket policies for Amazon S3 buckets.
  You can provide a generic input such as identity policy or resource policy or a specific
  input such as managed policy or Amazon S3 bucket policy.

"""
function check_no_new_access(
    existingPolicyDocument,
    newPolicyDocument,
    policyType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return accessanalyzer(
        "POST",
        "/policy/check-no-new-access",
        Dict{String,Any}(
            "existingPolicyDocument" => existingPolicyDocument,
            "newPolicyDocument" => newPolicyDocument,
            "policyType" => policyType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function check_no_new_access(
    existingPolicyDocument,
    newPolicyDocument,
    policyType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return accessanalyzer(
        "POST",
        "/policy/check-no-new-access",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "existingPolicyDocument" => existingPolicyDocument,
                    "newPolicyDocument" => newPolicyDocument,
                    "policyType" => policyType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    check_no_public_access(policy_document, resource_type)
    check_no_public_access(policy_document, resource_type, params::Dict{String,<:Any})

Checks whether a resource policy can grant public access to the specified resource type.

# Arguments
- `policy_document`: The JSON policy document to evaluate for public access.
- `resource_type`: The type of resource to evaluate for public access. For example, to
  check for public access to Amazon S3 buckets, you can choose AWS::S3::Bucket for the
  resource type. For resource types not supported as valid values, IAM Access Analyzer will
  return an error.

"""
function check_no_public_access(
    policyDocument, resourceType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return accessanalyzer(
        "POST",
        "/policy/check-no-public-access",
        Dict{String,Any}(
            "policyDocument" => policyDocument, "resourceType" => resourceType
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function check_no_public_access(
    policyDocument,
    resourceType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return accessanalyzer(
        "POST",
        "/policy/check-no-public-access",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "policyDocument" => policyDocument, "resourceType" => resourceType
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_access_preview(analyzer_arn, configurations)
    create_access_preview(analyzer_arn, configurations, params::Dict{String,<:Any})

Creates an access preview that allows you to preview IAM Access Analyzer findings for your
resource before deploying resource permissions.

# Arguments
- `analyzer_arn`: The ARN of the account analyzer used to generate the access preview. You
  can only create an access preview for analyzers with an Account type and Active status.
- `configurations`: Access control configuration for your resource that is used to generate
  the access preview. The access preview includes findings for external access allowed to the
  resource with the proposed access control configuration. The configuration must contain
  exactly one element.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A client token.
"""
function create_access_preview(
    analyzerArn, configurations; aws_config::AbstractAWSConfig=current_aws_config()
)
    return accessanalyzer(
        "PUT",
        "/access-preview",
        Dict{String,Any}(
            "analyzerArn" => analyzerArn,
            "configurations" => configurations,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_access_preview(
    analyzerArn,
    configurations,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return accessanalyzer(
        "PUT",
        "/access-preview",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "analyzerArn" => analyzerArn,
                    "configurations" => configurations,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_analyzer(analyzer_name, type)
    create_analyzer(analyzer_name, type, params::Dict{String,<:Any})

Creates an analyzer for your account.

# Arguments
- `analyzer_name`: The name of the analyzer to create.
- `type`: The type of analyzer to create. Only ACCOUNT, ORGANIZATION,
  ACCOUNT_UNUSED_ACCESS, and ORGANIZATION_UNUSED_ACCESS analyzers are supported. You can
  create only one analyzer per account per Region. You can create up to 5 analyzers per
  organization per Region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"archiveRules"`: Specifies the archive rules to add for the analyzer. Archive rules
  automatically archive findings that meet the criteria you define for the rule.
- `"clientToken"`: A client token.
- `"configuration"`: Specifies the configuration of the analyzer. If the analyzer is an
  unused access analyzer, the specified scope of unused access is used for the configuration.
  If the analyzer is an external access analyzer, this field is not used.
- `"tags"`: An array of key-value pairs to apply to the analyzer.
"""
function create_analyzer(
    analyzerName, type; aws_config::AbstractAWSConfig=current_aws_config()
)
    return accessanalyzer(
        "PUT",
        "/analyzer",
        Dict{String,Any}(
            "analyzerName" => analyzerName, "type" => type, "clientToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_analyzer(
    analyzerName,
    type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return accessanalyzer(
        "PUT",
        "/analyzer",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "analyzerName" => analyzerName,
                    "type" => type,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_archive_rule(analyzer_name, filter, rule_name)
    create_archive_rule(analyzer_name, filter, rule_name, params::Dict{String,<:Any})

Creates an archive rule for the specified analyzer. Archive rules automatically archive new
findings that meet the criteria you define when you create the rule. To learn about filter
keys that you can use to create an archive rule, see IAM Access Analyzer filter keys in the
IAM User Guide.

# Arguments
- `analyzer_name`: The name of the created analyzer.
- `filter`: The criteria for the rule.
- `rule_name`: The name of the rule to create.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A client token.
"""
function create_archive_rule(
    analyzerName, filter, ruleName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return accessanalyzer(
        "PUT",
        "/analyzer/$(analyzerName)/archive-rule",
        Dict{String,Any}(
            "filter" => filter, "ruleName" => ruleName, "clientToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_archive_rule(
    analyzerName,
    filter,
    ruleName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return accessanalyzer(
        "PUT",
        "/analyzer/$(analyzerName)/archive-rule",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "filter" => filter,
                    "ruleName" => ruleName,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_analyzer(analyzer_name)
    delete_analyzer(analyzer_name, params::Dict{String,<:Any})

Deletes the specified analyzer. When you delete an analyzer, IAM Access Analyzer is
disabled for the account or organization in the current or specific Region. All findings
that were generated by the analyzer are deleted. You cannot undo this action.

# Arguments
- `analyzer_name`: The name of the analyzer to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A client token.
"""
function delete_analyzer(analyzerName; aws_config::AbstractAWSConfig=current_aws_config())
    return accessanalyzer(
        "DELETE",
        "/analyzer/$(analyzerName)",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_analyzer(
    analyzerName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return accessanalyzer(
        "DELETE",
        "/analyzer/$(analyzerName)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_archive_rule(analyzer_name, rule_name)
    delete_archive_rule(analyzer_name, rule_name, params::Dict{String,<:Any})

Deletes the specified archive rule.

# Arguments
- `analyzer_name`: The name of the analyzer that associated with the archive rule to delete.
- `rule_name`: The name of the rule to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A client token.
"""
function delete_archive_rule(
    analyzerName, ruleName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return accessanalyzer(
        "DELETE",
        "/analyzer/$(analyzerName)/archive-rule/$(ruleName)",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_archive_rule(
    analyzerName,
    ruleName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return accessanalyzer(
        "DELETE",
        "/analyzer/$(analyzerName)/archive-rule/$(ruleName)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    generate_finding_recommendation(analyzer_arn, id)
    generate_finding_recommendation(analyzer_arn, id, params::Dict{String,<:Any})

Creates a recommendation for an unused permissions finding.

# Arguments
- `analyzer_arn`: The ARN of the analyzer used to generate the finding recommendation.
- `id`: The unique ID for the finding recommendation.

"""
function generate_finding_recommendation(
    analyzerArn, id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return accessanalyzer(
        "POST",
        "/recommendation/$(id)",
        Dict{String,Any}("analyzerArn" => analyzerArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function generate_finding_recommendation(
    analyzerArn,
    id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return accessanalyzer(
        "POST",
        "/recommendation/$(id)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("analyzerArn" => analyzerArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_access_preview(access_preview_id, analyzer_arn)
    get_access_preview(access_preview_id, analyzer_arn, params::Dict{String,<:Any})

Retrieves information about an access preview for the specified analyzer.

# Arguments
- `access_preview_id`: The unique ID for the access preview.
- `analyzer_arn`: The ARN of the analyzer used to generate the access preview.

"""
function get_access_preview(
    accessPreviewId, analyzerArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return accessanalyzer(
        "GET",
        "/access-preview/$(accessPreviewId)",
        Dict{String,Any}("analyzerArn" => analyzerArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_access_preview(
    accessPreviewId,
    analyzerArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return accessanalyzer(
        "GET",
        "/access-preview/$(accessPreviewId)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("analyzerArn" => analyzerArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_analyzed_resource(analyzer_arn, resource_arn)
    get_analyzed_resource(analyzer_arn, resource_arn, params::Dict{String,<:Any})

Retrieves information about a resource that was analyzed.

# Arguments
- `analyzer_arn`: The ARN of the analyzer to retrieve information from.
- `resource_arn`: The ARN of the resource to retrieve information about.

"""
function get_analyzed_resource(
    analyzerArn, resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return accessanalyzer(
        "GET",
        "/analyzed-resource",
        Dict{String,Any}("analyzerArn" => analyzerArn, "resourceArn" => resourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_analyzed_resource(
    analyzerArn,
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return accessanalyzer(
        "GET",
        "/analyzed-resource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "analyzerArn" => analyzerArn, "resourceArn" => resourceArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_analyzer(analyzer_name)
    get_analyzer(analyzer_name, params::Dict{String,<:Any})

Retrieves information about the specified analyzer.

# Arguments
- `analyzer_name`: The name of the analyzer retrieved.

"""
function get_analyzer(analyzerName; aws_config::AbstractAWSConfig=current_aws_config())
    return accessanalyzer(
        "GET",
        "/analyzer/$(analyzerName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_analyzer(
    analyzerName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return accessanalyzer(
        "GET",
        "/analyzer/$(analyzerName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_archive_rule(analyzer_name, rule_name)
    get_archive_rule(analyzer_name, rule_name, params::Dict{String,<:Any})

Retrieves information about an archive rule. To learn about filter keys that you can use to
create an archive rule, see IAM Access Analyzer filter keys in the IAM User Guide.

# Arguments
- `analyzer_name`: The name of the analyzer to retrieve rules from.
- `rule_name`: The name of the rule to retrieve.

"""
function get_archive_rule(
    analyzerName, ruleName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return accessanalyzer(
        "GET",
        "/analyzer/$(analyzerName)/archive-rule/$(ruleName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_archive_rule(
    analyzerName,
    ruleName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return accessanalyzer(
        "GET",
        "/analyzer/$(analyzerName)/archive-rule/$(ruleName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_finding(analyzer_arn, id)
    get_finding(analyzer_arn, id, params::Dict{String,<:Any})

Retrieves information about the specified finding. GetFinding and GetFindingV2 both use
access-analyzer:GetFinding in the Action element of an IAM policy statement. You must have
permission to perform the access-analyzer:GetFinding action.

# Arguments
- `analyzer_arn`: The ARN of the analyzer that generated the finding.
- `id`: The ID of the finding to retrieve.

"""
function get_finding(analyzerArn, id; aws_config::AbstractAWSConfig=current_aws_config())
    return accessanalyzer(
        "GET",
        "/finding/$(id)",
        Dict{String,Any}("analyzerArn" => analyzerArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_finding(
    analyzerArn,
    id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return accessanalyzer(
        "GET",
        "/finding/$(id)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("analyzerArn" => analyzerArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_finding_recommendation(analyzer_arn, id)
    get_finding_recommendation(analyzer_arn, id, params::Dict{String,<:Any})

Retrieves information about a finding recommendation for the specified analyzer.

# Arguments
- `analyzer_arn`: The ARN of the analyzer used to generate the finding recommendation.
- `id`: The unique ID for the finding recommendation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in the response.
- `"nextToken"`: A token used for pagination of results returned.
"""
function get_finding_recommendation(
    analyzerArn, id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return accessanalyzer(
        "GET",
        "/recommendation/$(id)",
        Dict{String,Any}("analyzerArn" => analyzerArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_finding_recommendation(
    analyzerArn,
    id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return accessanalyzer(
        "GET",
        "/recommendation/$(id)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("analyzerArn" => analyzerArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_finding_v2(analyzer_arn, id)
    get_finding_v2(analyzer_arn, id, params::Dict{String,<:Any})

Retrieves information about the specified finding. GetFinding and GetFindingV2 both use
access-analyzer:GetFinding in the Action element of an IAM policy statement. You must have
permission to perform the access-analyzer:GetFinding action.

# Arguments
- `analyzer_arn`: The ARN of the analyzer that generated the finding.
- `id`: The ID of the finding to retrieve.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in the response.
- `"nextToken"`: A token used for pagination of results returned.
"""
function get_finding_v2(analyzerArn, id; aws_config::AbstractAWSConfig=current_aws_config())
    return accessanalyzer(
        "GET",
        "/findingv2/$(id)",
        Dict{String,Any}("analyzerArn" => analyzerArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_finding_v2(
    analyzerArn,
    id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return accessanalyzer(
        "GET",
        "/findingv2/$(id)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("analyzerArn" => analyzerArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_generated_policy(job_id)
    get_generated_policy(job_id, params::Dict{String,<:Any})

Retrieves the policy that was generated using StartPolicyGeneration.

# Arguments
- `job_id`: The JobId that is returned by the StartPolicyGeneration operation. The JobId
  can be used with GetGeneratedPolicy to retrieve the generated policies or used with
  CancelPolicyGeneration to cancel the policy generation request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"includeResourcePlaceholders"`: The level of detail that you want to generate. You can
  specify whether to generate policies with placeholders for resource ARNs for actions that
  support resource level granularity in policies. For example, in the resource section of a
  policy, you can receive a placeholder such as \"Resource\":\"arn:aws:s3:::{BucketName}\"
  instead of \"*\".
- `"includeServiceLevelTemplate"`: The level of detail that you want to generate. You can
  specify whether to generate service-level policies.  IAM Access Analyzer uses
  iam:servicelastaccessed to identify services that have been used recently to create this
  service-level template.
"""
function get_generated_policy(jobId; aws_config::AbstractAWSConfig=current_aws_config())
    return accessanalyzer(
        "GET",
        "/policy/generation/$(jobId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_generated_policy(
    jobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return accessanalyzer(
        "GET",
        "/policy/generation/$(jobId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_access_preview_findings(access_preview_id, analyzer_arn)
    list_access_preview_findings(access_preview_id, analyzer_arn, params::Dict{String,<:Any})

Retrieves a list of access preview findings generated by the specified access preview.

# Arguments
- `access_preview_id`: The unique ID for the access preview.
- `analyzer_arn`: The ARN of the analyzer used to generate the access.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filter"`: Criteria to filter the returned findings.
- `"maxResults"`: The maximum number of results to return in the response.
- `"nextToken"`: A token used for pagination of results returned.
"""
function list_access_preview_findings(
    accessPreviewId, analyzerArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return accessanalyzer(
        "POST",
        "/access-preview/$(accessPreviewId)",
        Dict{String,Any}("analyzerArn" => analyzerArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_access_preview_findings(
    accessPreviewId,
    analyzerArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return accessanalyzer(
        "POST",
        "/access-preview/$(accessPreviewId)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("analyzerArn" => analyzerArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_access_previews(analyzer_arn)
    list_access_previews(analyzer_arn, params::Dict{String,<:Any})

Retrieves a list of access previews for the specified analyzer.

# Arguments
- `analyzer_arn`: The ARN of the analyzer used to generate the access preview.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in the response.
- `"nextToken"`: A token used for pagination of results returned.
"""
function list_access_previews(
    analyzerArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return accessanalyzer(
        "GET",
        "/access-preview",
        Dict{String,Any}("analyzerArn" => analyzerArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_access_previews(
    analyzerArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return accessanalyzer(
        "GET",
        "/access-preview",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("analyzerArn" => analyzerArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_analyzed_resources(analyzer_arn)
    list_analyzed_resources(analyzer_arn, params::Dict{String,<:Any})

Retrieves a list of resources of the specified type that have been analyzed by the
specified external access analyzer. This action is not supported for unused access
analyzers.

# Arguments
- `analyzer_arn`: The ARN of the analyzer to retrieve a list of analyzed resources from.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in the response.
- `"nextToken"`: A token used for pagination of results returned.
- `"resourceType"`: The type of resource.
"""
function list_analyzed_resources(
    analyzerArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return accessanalyzer(
        "POST",
        "/analyzed-resource",
        Dict{String,Any}("analyzerArn" => analyzerArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_analyzed_resources(
    analyzerArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return accessanalyzer(
        "POST",
        "/analyzed-resource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("analyzerArn" => analyzerArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_analyzers()
    list_analyzers(params::Dict{String,<:Any})

Retrieves a list of analyzers.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in the response.
- `"nextToken"`: A token used for pagination of results returned.
- `"type"`: The type of analyzer.
"""
function list_analyzers(; aws_config::AbstractAWSConfig=current_aws_config())
    return accessanalyzer(
        "GET", "/analyzer"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_analyzers(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return accessanalyzer(
        "GET", "/analyzer", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_archive_rules(analyzer_name)
    list_archive_rules(analyzer_name, params::Dict{String,<:Any})

Retrieves a list of archive rules created for the specified analyzer.

# Arguments
- `analyzer_name`: The name of the analyzer to retrieve rules from.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in the request.
- `"nextToken"`: A token used for pagination of results returned.
"""
function list_archive_rules(
    analyzerName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return accessanalyzer(
        "GET",
        "/analyzer/$(analyzerName)/archive-rule";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_archive_rules(
    analyzerName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return accessanalyzer(
        "GET",
        "/analyzer/$(analyzerName)/archive-rule",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_findings(analyzer_arn)
    list_findings(analyzer_arn, params::Dict{String,<:Any})

Retrieves a list of findings generated by the specified analyzer. ListFindings and
ListFindingsV2 both use access-analyzer:ListFindings in the Action element of an IAM policy
statement. You must have permission to perform the access-analyzer:ListFindings action. To
learn about filter keys that you can use to retrieve a list of findings, see IAM Access
Analyzer filter keys in the IAM User Guide.

# Arguments
- `analyzer_arn`: The ARN of the analyzer to retrieve findings from.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filter"`: A filter to match for the findings to return.
- `"maxResults"`: The maximum number of results to return in the response.
- `"nextToken"`: A token used for pagination of results returned.
- `"sort"`: The sort order for the findings returned.
"""
function list_findings(analyzerArn; aws_config::AbstractAWSConfig=current_aws_config())
    return accessanalyzer(
        "POST",
        "/finding",
        Dict{String,Any}("analyzerArn" => analyzerArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_findings(
    analyzerArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return accessanalyzer(
        "POST",
        "/finding",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("analyzerArn" => analyzerArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_findings_v2(analyzer_arn)
    list_findings_v2(analyzer_arn, params::Dict{String,<:Any})

Retrieves a list of findings generated by the specified analyzer. ListFindings and
ListFindingsV2 both use access-analyzer:ListFindings in the Action element of an IAM policy
statement. You must have permission to perform the access-analyzer:ListFindings action. To
learn about filter keys that you can use to retrieve a list of findings, see IAM Access
Analyzer filter keys in the IAM User Guide.

# Arguments
- `analyzer_arn`: The ARN of the analyzer to retrieve findings from.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filter"`: A filter to match for the findings to return.
- `"maxResults"`: The maximum number of results to return in the response.
- `"nextToken"`: A token used for pagination of results returned.
- `"sort"`:
"""
function list_findings_v2(analyzerArn; aws_config::AbstractAWSConfig=current_aws_config())
    return accessanalyzer(
        "POST",
        "/findingv2",
        Dict{String,Any}("analyzerArn" => analyzerArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_findings_v2(
    analyzerArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return accessanalyzer(
        "POST",
        "/findingv2",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("analyzerArn" => analyzerArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_policy_generations()
    list_policy_generations(params::Dict{String,<:Any})

Lists all of the policy generations requested in the last seven days.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in the response.
- `"nextToken"`: A token used for pagination of results returned.
- `"principalArn"`: The ARN of the IAM entity (user or role) for which you are generating a
  policy. Use this with ListGeneratedPolicies to filter the results to only include results
  for a specific principal.
"""
function list_policy_generations(; aws_config::AbstractAWSConfig=current_aws_config())
    return accessanalyzer(
        "GET", "/policy/generation"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_policy_generations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return accessanalyzer(
        "GET",
        "/policy/generation",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Retrieves a list of tags applied to the specified resource.

# Arguments
- `resource_arn`: The ARN of the resource to retrieve tags from.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return accessanalyzer(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return accessanalyzer(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_policy_generation(policy_generation_details)
    start_policy_generation(policy_generation_details, params::Dict{String,<:Any})

Starts the policy generation request.

# Arguments
- `policy_generation_details`: Contains the ARN of the IAM entity (user or role) for which
  you are generating a policy.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. Idempotency ensures that an API request completes only once.
  With an idempotent request, if the original request completes successfully, the subsequent
  retries with the same client token return the result from the original successful request
  and they have no additional effect. If you do not specify a client token, one is
  automatically generated by the Amazon Web Services SDK.
- `"cloudTrailDetails"`: A CloudTrailDetails object that contains details about a Trail
  that you want to analyze to generate policies.
"""
function start_policy_generation(
    policyGenerationDetails; aws_config::AbstractAWSConfig=current_aws_config()
)
    return accessanalyzer(
        "PUT",
        "/policy/generation",
        Dict{String,Any}(
            "policyGenerationDetails" => policyGenerationDetails,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_policy_generation(
    policyGenerationDetails,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return accessanalyzer(
        "PUT",
        "/policy/generation",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "policyGenerationDetails" => policyGenerationDetails,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_resource_scan(analyzer_arn, resource_arn)
    start_resource_scan(analyzer_arn, resource_arn, params::Dict{String,<:Any})

Immediately starts a scan of the policies applied to the specified resource.

# Arguments
- `analyzer_arn`: The ARN of the analyzer to use to scan the policies applied to the
  specified resource.
- `resource_arn`: The ARN of the resource to scan.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"resourceOwnerAccount"`: The Amazon Web Services account ID that owns the resource. For
  most Amazon Web Services resources, the owning account is the account in which the resource
  was created.
"""
function start_resource_scan(
    analyzerArn, resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return accessanalyzer(
        "POST",
        "/resource/scan",
        Dict{String,Any}("analyzerArn" => analyzerArn, "resourceArn" => resourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_resource_scan(
    analyzerArn,
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return accessanalyzer(
        "POST",
        "/resource/scan",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "analyzerArn" => analyzerArn, "resourceArn" => resourceArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds a tag to the specified resource.

# Arguments
- `resource_arn`: The ARN of the resource to add the tag to.
- `tags`: The tags to add to the resource.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return accessanalyzer(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return accessanalyzer(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes a tag from the specified resource.

# Arguments
- `resource_arn`: The ARN of the resource to remove the tag from.
- `tag_keys`: The key for the tag to add.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return accessanalyzer(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return accessanalyzer(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_archive_rule(analyzer_name, filter, rule_name)
    update_archive_rule(analyzer_name, filter, rule_name, params::Dict{String,<:Any})

Updates the criteria and values for the specified archive rule.

# Arguments
- `analyzer_name`: The name of the analyzer to update the archive rules for.
- `filter`: A filter to match for the rules to update. Only rules that match the filter are
  updated.
- `rule_name`: The name of the rule to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A client token.
"""
function update_archive_rule(
    analyzerName, filter, ruleName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return accessanalyzer(
        "PUT",
        "/analyzer/$(analyzerName)/archive-rule/$(ruleName)",
        Dict{String,Any}("filter" => filter, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_archive_rule(
    analyzerName,
    filter,
    ruleName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return accessanalyzer(
        "PUT",
        "/analyzer/$(analyzerName)/archive-rule/$(ruleName)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("filter" => filter, "clientToken" => string(uuid4())),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_findings(analyzer_arn, status)
    update_findings(analyzer_arn, status, params::Dict{String,<:Any})

Updates the status for the specified findings.

# Arguments
- `analyzer_arn`: The ARN of the analyzer that generated the findings to update.
- `status`: The state represents the action to take to update the finding Status. Use
  ARCHIVE to change an Active finding to an Archived finding. Use ACTIVE to change an
  Archived finding to an Active finding.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A client token.
- `"ids"`: The IDs of the findings to update.
- `"resourceArn"`: The ARN of the resource identified in the finding.
"""
function update_findings(
    analyzerArn, status; aws_config::AbstractAWSConfig=current_aws_config()
)
    return accessanalyzer(
        "PUT",
        "/finding",
        Dict{String,Any}(
            "analyzerArn" => analyzerArn,
            "status" => status,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_findings(
    analyzerArn,
    status,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return accessanalyzer(
        "PUT",
        "/finding",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "analyzerArn" => analyzerArn,
                    "status" => status,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    validate_policy(policy_document, policy_type)
    validate_policy(policy_document, policy_type, params::Dict{String,<:Any})

Requests the validation of a policy and returns a list of findings. The findings help you
identify issues and provide actionable recommendations to resolve the issue and enable you
to author functional policies that meet security best practices.

# Arguments
- `policy_document`: The JSON policy document to use as the content for the policy.
- `policy_type`: The type of policy to validate. Identity policies grant permissions to IAM
  principals. Identity policies include managed and inline policies for IAM roles, users, and
  groups. Resource policies grant permissions on Amazon Web Services resources. Resource
  policies include trust policies for IAM roles and bucket policies for Amazon S3 buckets.
  You can provide a generic input such as identity policy or resource policy or a specific
  input such as managed policy or Amazon S3 bucket policy.  Service control policies (SCPs)
  are a type of organization policy attached to an Amazon Web Services organization,
  organizational unit (OU), or an account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"locale"`: The locale to use for localizing the findings.
- `"maxResults"`: The maximum number of results to return in the response.
- `"nextToken"`: A token used for pagination of results returned.
- `"validatePolicyResourceType"`: The type of resource to attach to your resource policy.
  Specify a value for the policy validation resource type only if the policy type is
  RESOURCE_POLICY. For example, to validate a resource policy to attach to an Amazon S3
  bucket, you can choose AWS::S3::Bucket for the policy validation resource type. For
  resource types not supported as valid values, IAM Access Analyzer runs policy checks that
  apply to all resource policies. For example, to validate a resource policy to attach to a
  KMS key, do not specify a value for the policy validation resource type and IAM Access
  Analyzer will run policy checks that apply to all resource policies.
"""
function validate_policy(
    policyDocument, policyType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return accessanalyzer(
        "POST",
        "/policy/validation",
        Dict{String,Any}("policyDocument" => policyDocument, "policyType" => policyType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function validate_policy(
    policyDocument,
    policyType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return accessanalyzer(
        "POST",
        "/policy/validation",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "policyDocument" => policyDocument, "policyType" => policyType
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: m2
using AWS.Compat
using AWS.UUIDs

"""
    cancel_batch_job_execution(application_id, execution_id)
    cancel_batch_job_execution(application_id, execution_id, params::Dict{String,<:Any})

Cancels the running of a specific batch job execution.

# Arguments
- `application_id`: The unique identifier of the application.
- `execution_id`: The unique identifier of the batch job execution.

"""
function cancel_batch_job_execution(
    applicationId, executionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return m2(
        "POST",
        "/applications/$(applicationId)/batch-job-executions/$(executionId)/cancel";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_batch_job_execution(
    applicationId,
    executionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return m2(
        "POST",
        "/applications/$(applicationId)/batch-job-executions/$(executionId)/cancel",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_application(definition, engine_type, name)
    create_application(definition, engine_type, name, params::Dict{String,<:Any})

Creates a new application with given parameters. Requires an existing runtime environment
and application definition file.

# Arguments
- `definition`: The application definition for this application. You can specify either
  inline JSON or an S3 bucket location.
- `engine_type`: The type of the target platform for this application.
- `name`: The unique identifier of the application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Unique, case-sensitive identifier the service generates to ensure the
  idempotency of the request to create an application. The service generates the clientToken
  when the API call is triggered. The token expires after one hour, so if you retry the API
  within this timeframe with the same clientToken, you will get the same response. The
  service also handles deleting the clientToken after it expires.
- `"description"`: The description of the application.
- `"kmsKeyId"`: The identifier of a customer managed key.
- `"roleArn"`: The Amazon Resource Name (ARN) that identifies a role that the application
  uses to access Amazon Web Services resources that are not part of the application or are in
  a different Amazon Web Services account.
- `"tags"`: A list of tags to apply to the application.
"""
function create_application(
    definition, engineType, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return m2(
        "POST",
        "/applications",
        Dict{String,Any}(
            "definition" => definition,
            "engineType" => engineType,
            "name" => name,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_application(
    definition,
    engineType,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return m2(
        "POST",
        "/applications",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "definition" => definition,
                    "engineType" => engineType,
                    "name" => name,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_data_set_import_task(application_id, import_config)
    create_data_set_import_task(application_id, import_config, params::Dict{String,<:Any})

Starts a data set import task for a specific application.

# Arguments
- `application_id`: The unique identifier of the application for which you want to import
  data sets.
- `import_config`: The data set import task configuration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`:  Unique, case-sensitive identifier you provide to ensure the idempotency
  of the request to create a data set import. The service generates the clientToken when the
  API call is triggered. The token expires after one hour, so if you retry the API within
  this timeframe with the same clientToken, you will get the same response. The service also
  handles deleting the clientToken after it expires.
"""
function create_data_set_import_task(
    applicationId, importConfig; aws_config::AbstractAWSConfig=current_aws_config()
)
    return m2(
        "POST",
        "/applications/$(applicationId)/dataset-import-task",
        Dict{String,Any}("importConfig" => importConfig, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_data_set_import_task(
    applicationId,
    importConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return m2(
        "POST",
        "/applications/$(applicationId)/dataset-import-task",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "importConfig" => importConfig, "clientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_deployment(application_id, application_version, environment_id)
    create_deployment(application_id, application_version, environment_id, params::Dict{String,<:Any})

Creates and starts a deployment to deploy an application into a runtime environment.

# Arguments
- `application_id`: The application identifier.
- `application_version`: The version of the application to deploy.
- `environment_id`: The identifier of the runtime environment where you want to deploy this
  application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Unique, case-sensitive identifier you provide to ensure the idempotency
  of the request to create a deployment. The service generates the clientToken when the API
  call is triggered. The token expires after one hour, so if you retry the API within this
  timeframe with the same clientToken, you will get the same response. The service also
  handles deleting the clientToken after it expires.
"""
function create_deployment(
    applicationId,
    applicationVersion,
    environmentId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return m2(
        "POST",
        "/applications/$(applicationId)/deployments",
        Dict{String,Any}(
            "applicationVersion" => applicationVersion,
            "environmentId" => environmentId,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_deployment(
    applicationId,
    applicationVersion,
    environmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return m2(
        "POST",
        "/applications/$(applicationId)/deployments",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "applicationVersion" => applicationVersion,
                    "environmentId" => environmentId,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_environment(engine_type, instance_type, name)
    create_environment(engine_type, instance_type, name, params::Dict{String,<:Any})

Creates a runtime environment for a given runtime engine.

# Arguments
- `engine_type`: The engine type for the runtime environment.
- `instance_type`: The type of instance for the runtime environment.
- `name`: The name of the runtime environment. Must be unique within the account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Unique, case-sensitive identifier you provide to ensure the idempotency
  of the request to create an environment. The service generates the clientToken when the API
  call is triggered. The token expires after one hour, so if you retry the API within this
  timeframe with the same clientToken, you will get the same response. The service also
  handles deleting the clientToken after it expires.
- `"description"`: The description of the runtime environment.
- `"engineVersion"`: The version of the engine type for the runtime environment.
- `"highAvailabilityConfig"`: The details of a high availability configuration for this
  runtime environment.
- `"kmsKeyId"`: The identifier of a customer managed key.
- `"preferredMaintenanceWindow"`: Configures the maintenance window that you want for the
  runtime environment. The maintenance window must have the format ddd:hh24:mi-ddd:hh24:mi
  and must be less than 24 hours. The following two examples are valid maintenance windows:
  sun:23:45-mon:00:15 or sat:01:00-sat:03:00.  If you do not provide a value, a random
  system-generated value will be assigned.
- `"publiclyAccessible"`: Specifies whether the runtime environment is publicly accessible.
- `"securityGroupIds"`: The list of security groups for the VPC associated with this
  runtime environment.
- `"storageConfigurations"`: Optional. The storage configurations for this runtime
  environment.
- `"subnetIds"`: The list of subnets associated with the VPC for this runtime environment.
- `"tags"`: The tags for the runtime environment.
"""
function create_environment(
    engineType, instanceType, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return m2(
        "POST",
        "/environments",
        Dict{String,Any}(
            "engineType" => engineType,
            "instanceType" => instanceType,
            "name" => name,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_environment(
    engineType,
    instanceType,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return m2(
        "POST",
        "/environments",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "engineType" => engineType,
                    "instanceType" => instanceType,
                    "name" => name,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_application(application_id)
    delete_application(application_id, params::Dict{String,<:Any})

Deletes a specific application. You cannot delete a running application.

# Arguments
- `application_id`: The unique identifier of the application you want to delete.

"""
function delete_application(
    applicationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return m2(
        "DELETE",
        "/applications/$(applicationId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_application(
    applicationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return m2(
        "DELETE",
        "/applications/$(applicationId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_application_from_environment(application_id, environment_id)
    delete_application_from_environment(application_id, environment_id, params::Dict{String,<:Any})

Deletes a specific application from the specific runtime environment where it was
previously deployed. You cannot delete a runtime environment using DeleteEnvironment if any
application has ever been deployed to it. This API removes the association of the
application with the runtime environment so you can delete the environment smoothly.

# Arguments
- `application_id`: The unique identifier of the application you want to delete.
- `environment_id`: The unique identifier of the runtime environment where the application
  was previously deployed.

"""
function delete_application_from_environment(
    applicationId, environmentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return m2(
        "DELETE",
        "/applications/$(applicationId)/environment/$(environmentId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_application_from_environment(
    applicationId,
    environmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return m2(
        "DELETE",
        "/applications/$(applicationId)/environment/$(environmentId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_environment(environment_id)
    delete_environment(environment_id, params::Dict{String,<:Any})

Deletes a specific runtime environment. The environment cannot contain deployed
applications. If it does, you must delete those applications before you delete the
environment.

# Arguments
- `environment_id`: The unique identifier of the runtime environment you want to delete.

"""
function delete_environment(
    environmentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return m2(
        "DELETE",
        "/environments/$(environmentId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_environment(
    environmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return m2(
        "DELETE",
        "/environments/$(environmentId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_application(application_id)
    get_application(application_id, params::Dict{String,<:Any})

Describes the details of a specific application.

# Arguments
- `application_id`: The identifier of the application.

"""
function get_application(applicationId; aws_config::AbstractAWSConfig=current_aws_config())
    return m2(
        "GET",
        "/applications/$(applicationId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_application(
    applicationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return m2(
        "GET",
        "/applications/$(applicationId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_application_version(application_id, application_version)
    get_application_version(application_id, application_version, params::Dict{String,<:Any})

Returns details about a specific version of a specific application.

# Arguments
- `application_id`: The unique identifier of the application.
- `application_version`: The specific version of the application.

"""
function get_application_version(
    applicationId, applicationVersion; aws_config::AbstractAWSConfig=current_aws_config()
)
    return m2(
        "GET",
        "/applications/$(applicationId)/versions/$(applicationVersion)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_application_version(
    applicationId,
    applicationVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return m2(
        "GET",
        "/applications/$(applicationId)/versions/$(applicationVersion)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_batch_job_execution(application_id, execution_id)
    get_batch_job_execution(application_id, execution_id, params::Dict{String,<:Any})

Gets the details of a specific batch job execution for a specific application.

# Arguments
- `application_id`: The identifier of the application.
- `execution_id`: The unique identifier of the batch job execution.

"""
function get_batch_job_execution(
    applicationId, executionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return m2(
        "GET",
        "/applications/$(applicationId)/batch-job-executions/$(executionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_batch_job_execution(
    applicationId,
    executionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return m2(
        "GET",
        "/applications/$(applicationId)/batch-job-executions/$(executionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_data_set_details(application_id, data_set_name)
    get_data_set_details(application_id, data_set_name, params::Dict{String,<:Any})

Gets the details of a specific data set.

# Arguments
- `application_id`: The unique identifier of the application that this data set is
  associated with.
- `data_set_name`: The name of the data set.

"""
function get_data_set_details(
    applicationId, dataSetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return m2(
        "GET",
        "/applications/$(applicationId)/datasets/$(dataSetName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_data_set_details(
    applicationId,
    dataSetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return m2(
        "GET",
        "/applications/$(applicationId)/datasets/$(dataSetName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_data_set_import_task(application_id, task_id)
    get_data_set_import_task(application_id, task_id, params::Dict{String,<:Any})

Gets the status of a data set import task initiated with the CreateDataSetImportTask
operation.

# Arguments
- `application_id`: The application identifier.
- `task_id`: The task identifier returned by the CreateDataSetImportTask operation.

"""
function get_data_set_import_task(
    applicationId, taskId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return m2(
        "GET",
        "/applications/$(applicationId)/dataset-import-tasks/$(taskId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_data_set_import_task(
    applicationId,
    taskId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return m2(
        "GET",
        "/applications/$(applicationId)/dataset-import-tasks/$(taskId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_deployment(application_id, deployment_id)
    get_deployment(application_id, deployment_id, params::Dict{String,<:Any})

Gets details of a specific deployment with a given deployment identifier.

# Arguments
- `application_id`: The unique identifier of the application.
- `deployment_id`: The unique identifier for the deployment.

"""
function get_deployment(
    applicationId, deploymentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return m2(
        "GET",
        "/applications/$(applicationId)/deployments/$(deploymentId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_deployment(
    applicationId,
    deploymentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return m2(
        "GET",
        "/applications/$(applicationId)/deployments/$(deploymentId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_environment(environment_id)
    get_environment(environment_id, params::Dict{String,<:Any})

Describes a specific runtime environment.

# Arguments
- `environment_id`: The unique identifier of the runtime environment.

"""
function get_environment(environmentId; aws_config::AbstractAWSConfig=current_aws_config())
    return m2(
        "GET",
        "/environments/$(environmentId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_environment(
    environmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return m2(
        "GET",
        "/environments/$(environmentId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_signed_bluinsights_url()
    get_signed_bluinsights_url(params::Dict{String,<:Any})

Gets a single sign-on URL that can be used to connect to AWS Blu Insights.

"""
function get_signed_bluinsights_url(; aws_config::AbstractAWSConfig=current_aws_config())
    return m2(
        "GET", "/signed-bi-url"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_signed_bluinsights_url(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return m2(
        "GET",
        "/signed-bi-url",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_application_versions(application_id)
    list_application_versions(application_id, params::Dict{String,<:Any})

Returns a list of the application versions for a specific application.

# Arguments
- `application_id`: The unique identifier of the application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of application versions to return.
- `"nextToken"`: A pagination token returned from a previous call to this operation. This
  specifies the next item to return. To return to the beginning of the list, exclude this
  parameter.
"""
function list_application_versions(
    applicationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return m2(
        "GET",
        "/applications/$(applicationId)/versions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_application_versions(
    applicationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return m2(
        "GET",
        "/applications/$(applicationId)/versions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_applications()
    list_applications(params::Dict{String,<:Any})

Lists the applications associated with a specific Amazon Web Services account. You can
provide the unique identifier of a specific runtime environment in a query parameter to see
all applications associated with that environment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"environmentId"`: The unique identifier of the runtime environment where the
  applications are deployed.
- `"maxResults"`: The maximum number of applications to return.
- `"names"`: The names of the applications.
- `"nextToken"`: A pagination token to control the number of applications displayed in the
  list.
"""
function list_applications(; aws_config::AbstractAWSConfig=current_aws_config())
    return m2(
        "GET", "/applications"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_applications(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return m2(
        "GET",
        "/applications",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_batch_job_definitions(application_id)
    list_batch_job_definitions(application_id, params::Dict{String,<:Any})

Lists all the available batch job definitions based on the batch job resources uploaded
during the application creation. You can use the batch job definitions in the list to start
a batch job.

# Arguments
- `application_id`: The identifier of the application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of batch job definitions to return.
- `"nextToken"`: A pagination token returned from a previous call to this operation. This
  specifies the next item to return. To return to the beginning of the list, exclude this
  parameter.
- `"prefix"`: If the batch job definition is a FileBatchJobDefinition, the prefix allows
  you to search on the file names of FileBatchJobDefinitions.
"""
function list_batch_job_definitions(
    applicationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return m2(
        "GET",
        "/applications/$(applicationId)/batch-job-definitions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_batch_job_definitions(
    applicationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return m2(
        "GET",
        "/applications/$(applicationId)/batch-job-definitions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_batch_job_executions(application_id)
    list_batch_job_executions(application_id, params::Dict{String,<:Any})

Lists historical, current, and scheduled batch job executions for a specific application.

# Arguments
- `application_id`: The unique identifier of the application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"executionIds"`: The unique identifier of each batch job execution.
- `"jobName"`: The name of each batch job execution.
- `"maxResults"`: The maximum number of batch job executions to return.
- `"nextToken"`: A pagination token to control the number of batch job executions displayed
  in the list.
- `"startedAfter"`: The time after which the batch job executions started.
- `"startedBefore"`: The time before the batch job executions started.
- `"status"`: The status of the batch job executions.
"""
function list_batch_job_executions(
    applicationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return m2(
        "GET",
        "/applications/$(applicationId)/batch-job-executions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_batch_job_executions(
    applicationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return m2(
        "GET",
        "/applications/$(applicationId)/batch-job-executions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_batch_job_restart_points(application_id, execution_id)
    list_batch_job_restart_points(application_id, execution_id, params::Dict{String,<:Any})

Lists all the job steps for JCL files to restart a batch job. This is only applicable for
Micro Focus engine with versions 8.0.6 and above.

# Arguments
- `application_id`: The unique identifier of the application.
- `execution_id`: The unique identifier of each batch job execution.

"""
function list_batch_job_restart_points(
    applicationId, executionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return m2(
        "GET",
        "/applications/$(applicationId)/batch-job-executions/$(executionId)/steps";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_batch_job_restart_points(
    applicationId,
    executionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return m2(
        "GET",
        "/applications/$(applicationId)/batch-job-executions/$(executionId)/steps",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_data_set_import_history(application_id)
    list_data_set_import_history(application_id, params::Dict{String,<:Any})

Lists the data set imports for the specified application.

# Arguments
- `application_id`: The unique identifier of the application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of objects to return.
- `"nextToken"`: A pagination token returned from a previous call to this operation. This
  specifies the next item to return. To return to the beginning of the list, exclude this
  parameter.
"""
function list_data_set_import_history(
    applicationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return m2(
        "GET",
        "/applications/$(applicationId)/dataset-import-tasks";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_data_set_import_history(
    applicationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return m2(
        "GET",
        "/applications/$(applicationId)/dataset-import-tasks",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_data_sets(application_id)
    list_data_sets(application_id, params::Dict{String,<:Any})

Lists the data sets imported for a specific application. In Amazon Web Services Mainframe
Modernization, data sets are associated with applications deployed on runtime environments.
This is known as importing data sets. Currently, Amazon Web Services Mainframe
Modernization can import data sets into catalogs using CreateDataSetImportTask.

# Arguments
- `application_id`: The unique identifier of the application for which you want to list the
  associated data sets.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of objects to return.
- `"nameFilter"`: Filter dataset name matching the specified pattern. Can use * and % as
  wild cards.
- `"nextToken"`: A pagination token returned from a previous call to this operation. This
  specifies the next item to return. To return to the beginning of the list, exclude this
  parameter.
- `"prefix"`: The prefix of the data set name, which you can use to filter the list of data
  sets.
"""
function list_data_sets(applicationId; aws_config::AbstractAWSConfig=current_aws_config())
    return m2(
        "GET",
        "/applications/$(applicationId)/datasets";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_data_sets(
    applicationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return m2(
        "GET",
        "/applications/$(applicationId)/datasets",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_deployments(application_id)
    list_deployments(application_id, params::Dict{String,<:Any})

Returns a list of all deployments of a specific application. A deployment is a combination
of a specific application and a specific version of that application. Each deployment is
mapped to a particular application version.

# Arguments
- `application_id`: The application identifier.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of objects to return.
- `"nextToken"`: A pagination token returned from a previous call to this operation. This
  specifies the next item to return. To return to the beginning of the list, exclude this
  parameter.
"""
function list_deployments(applicationId; aws_config::AbstractAWSConfig=current_aws_config())
    return m2(
        "GET",
        "/applications/$(applicationId)/deployments";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_deployments(
    applicationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return m2(
        "GET",
        "/applications/$(applicationId)/deployments",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_engine_versions()
    list_engine_versions(params::Dict{String,<:Any})

Lists the available engine versions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"engineType"`: The type of target platform.
- `"maxResults"`: The maximum number of objects to return.
- `"nextToken"`: A pagination token returned from a previous call to this operation. This
  specifies the next item to return. To return to the beginning of the list, exclude this
  parameter.
"""
function list_engine_versions(; aws_config::AbstractAWSConfig=current_aws_config())
    return m2(
        "GET", "/engine-versions"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_engine_versions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return m2(
        "GET",
        "/engine-versions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_environments()
    list_environments(params::Dict{String,<:Any})

Lists the runtime environments.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"engineType"`: The engine type for the runtime environment.
- `"maxResults"`: The maximum number of runtime environments to return.
- `"names"`: The names of the runtime environments. Must be unique within the account.
- `"nextToken"`: A pagination token to control the number of runtime environments displayed
  in the list.
"""
function list_environments(; aws_config::AbstractAWSConfig=current_aws_config())
    return m2(
        "GET", "/environments"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_environments(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return m2(
        "GET",
        "/environments",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists the tags for the specified resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return m2(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return m2(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_application(application_id)
    start_application(application_id, params::Dict{String,<:Any})

Starts an application that is currently stopped.

# Arguments
- `application_id`: The unique identifier of the application you want to start.

"""
function start_application(
    applicationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return m2(
        "POST",
        "/applications/$(applicationId)/start";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_application(
    applicationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return m2(
        "POST",
        "/applications/$(applicationId)/start",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_batch_job(application_id, batch_job_identifier)
    start_batch_job(application_id, batch_job_identifier, params::Dict{String,<:Any})

Starts a batch job and returns the unique identifier of this execution of the batch job.
The associated application must be running in order to start the batch job.

# Arguments
- `application_id`: The unique identifier of the application associated with this batch job.
- `batch_job_identifier`: The unique identifier of the batch job.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"jobParams"`: The collection of batch job parameters. For details about limits for keys
  and values, see Coding variables in JCL.
"""
function start_batch_job(
    applicationId, batchJobIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return m2(
        "POST",
        "/applications/$(applicationId)/batch-job",
        Dict{String,Any}("batchJobIdentifier" => batchJobIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_batch_job(
    applicationId,
    batchJobIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return m2(
        "POST",
        "/applications/$(applicationId)/batch-job",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("batchJobIdentifier" => batchJobIdentifier), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_application(application_id)
    stop_application(application_id, params::Dict{String,<:Any})

Stops a running application.

# Arguments
- `application_id`: The unique identifier of the application you want to stop.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"forceStop"`: Stopping an application process can take a long time. Setting this
  parameter to true lets you force stop the application so you don't need to wait until the
  process finishes to apply another action on the application. The default value is false.
"""
function stop_application(applicationId; aws_config::AbstractAWSConfig=current_aws_config())
    return m2(
        "POST",
        "/applications/$(applicationId)/stop";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_application(
    applicationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return m2(
        "POST",
        "/applications/$(applicationId)/stop",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds one or more tags to the specified resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.
- `tags`: The tags to add to the resource.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return m2(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return m2(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes one or more tags from the specified resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.
- `tag_keys`: The keys of the tags to remove.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return m2(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return m2(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_application(application_id, current_application_version)
    update_application(application_id, current_application_version, params::Dict{String,<:Any})

Updates an application and creates a new version.

# Arguments
- `application_id`: The unique identifier of the application you want to update.
- `current_application_version`: The current version of the application to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"definition"`: The application definition for this application. You can specify either
  inline JSON or an S3 bucket location.
- `"description"`: The description of the application to update.
"""
function update_application(
    applicationId,
    currentApplicationVersion;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return m2(
        "PATCH",
        "/applications/$(applicationId)",
        Dict{String,Any}("currentApplicationVersion" => currentApplicationVersion);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_application(
    applicationId,
    currentApplicationVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return m2(
        "PATCH",
        "/applications/$(applicationId)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("currentApplicationVersion" => currentApplicationVersion),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_environment(environment_id)
    update_environment(environment_id, params::Dict{String,<:Any})

Updates the configuration details for a specific runtime environment.

# Arguments
- `environment_id`: The unique identifier of the runtime environment that you want to
  update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"applyDuringMaintenanceWindow"`: Indicates whether to update the runtime environment
  during the maintenance window. The default is false. Currently, Amazon Web Services
  Mainframe Modernization accepts the engineVersion parameter only if
  applyDuringMaintenanceWindow is true. If any parameter other than engineVersion is provided
  in UpdateEnvironmentRequest, it will fail if applyDuringMaintenanceWindow is set to true.
- `"desiredCapacity"`: The desired capacity for the runtime environment to update. The
  minimum possible value is 0 and the maximum is 100.
- `"engineVersion"`: The version of the runtime engine for the runtime environment.
- `"forceUpdate"`: Forces the updates on the environment. This option is needed if the
  applications in the environment are not stopped or if there are ongoing application-related
  activities in the environment. If you use this option, be aware that it could lead to data
  corruption in the applications, and that you might need to perform repair and recovery
  procedures for the applications. This option is not needed if the attribute being updated
  is preferredMaintenanceWindow.
- `"instanceType"`: The instance type for the runtime environment to update.
- `"preferredMaintenanceWindow"`: Configures the maintenance window that you want for the
  runtime environment. The maintenance window must have the format ddd:hh24:mi-ddd:hh24:mi
  and must be less than 24 hours. The following two examples are valid maintenance windows:
  sun:23:45-mon:00:15 or sat:01:00-sat:03:00.  If you do not provide a value, a random
  system-generated value will be assigned.
"""
function update_environment(
    environmentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return m2(
        "PATCH",
        "/environments/$(environmentId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_environment(
    environmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return m2(
        "PATCH",
        "/environments/$(environmentId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: lookoutvision
using AWS.Compat
using AWS.UUIDs

"""
    create_dataset(dataset_type, project_name)
    create_dataset(dataset_type, project_name, params::Dict{String,<:Any})

Creates a new dataset in an Amazon Lookout for Vision project. CreateDataset can create a
training or a test dataset from a valid dataset source (DatasetSource). If you want a
single dataset project, specify train for the value of DatasetType. To have a project with
separate training and test datasets, call CreateDataset twice. On the first call, specify
train for the value of DatasetType. On the second call, specify test for the value of
DatasetType.  This operation requires permissions to perform the
lookoutvision:CreateDataset operation.

# Arguments
- `dataset_type`: The type of the dataset. Specify train for a training dataset. Specify
  test for a test dataset.
- `project_name`: The name of the project in which you want to create a dataset.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DatasetSource"`: The location of the manifest file that Amazon Lookout for Vision uses
  to create the dataset. If you don't specify DatasetSource, an empty dataset is created and
  the operation synchronously returns. Later, you can add JSON Lines by calling
  UpdateDatasetEntries.  If you specify a value for DataSource, the manifest at the S3
  location is validated and used to create the dataset. The call to CreateDataset is
  asynchronous and might take a while to complete. To find out the current status, Check the
  value of Status returned in a call to DescribeDataset.
- `"X-Amzn-Client-Token"`: ClientToken is an idempotency token that ensures a call to
  CreateDataset completes only once. You choose the value to pass. For example, An issue
  might prevent you from getting a response from CreateDataset. In this case, safely retry
  your call to CreateDataset by using the same ClientToken parameter value. If you don't
  supply a value for ClientToken, the AWS SDK you are using inserts a value for you. This
  prevents retries after a network error from making multiple dataset creation requests.
  You'll need to provide your own value for other use cases.  An error occurs if the other
  input parameters are not the same as in the first request. Using a different value for
  ClientToken is considered a new call to CreateDataset. An idempotency token is active for 8
  hours.
"""
function create_dataset(
    DatasetType, projectName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutvision(
        "POST",
        "/2020-11-20/projects/$(projectName)/datasets",
        Dict{String,Any}(
            "DatasetType" => DatasetType, "X-Amzn-Client-Token" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_dataset(
    DatasetType,
    projectName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutvision(
        "POST",
        "/2020-11-20/projects/$(projectName)/datasets",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DatasetType" => DatasetType, "X-Amzn-Client-Token" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_model(output_config, project_name)
    create_model(output_config, project_name, params::Dict{String,<:Any})

Creates a new version of a model within an an Amazon Lookout for Vision project.
CreateModel is an asynchronous operation in which Amazon Lookout for Vision trains, tests,
and evaluates a new version of a model.  To get the current status, check the Status field
returned in the response from DescribeModel. If the project has a single dataset, Amazon
Lookout for Vision internally splits the dataset to create a training and a test dataset.
If the project has a training and a test dataset, Lookout for Vision uses the respective
datasets to train and test the model.  After training completes, the evaluation metrics are
stored at the location specified in OutputConfig.  This operation requires permissions to
perform the lookoutvision:CreateModel operation. If you want to tag your model, you also
require permission to the lookoutvision:TagResource operation.

# Arguments
- `output_config`: The location where Amazon Lookout for Vision saves the training results.
- `project_name`: The name of the project in which you want to create a model version.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description for the version of the model.
- `"KmsKeyId"`: The identifier for your AWS KMS key. The key is used to encrypt training
  and test images copied into the service for model training. Your source images are
  unaffected. If this parameter is not specified, the copied images are encrypted by a key
  that AWS owns and manages.
- `"Tags"`: A set of tags (key-value pairs) that you want to attach to the model.
- `"X-Amzn-Client-Token"`: ClientToken is an idempotency token that ensures a call to
  CreateModel completes only once. You choose the value to pass. For example, An issue might
  prevent you from getting a response from CreateModel. In this case, safely retry your call
  to CreateModel by using the same ClientToken parameter value.  If you don't supply a value
  for ClientToken, the AWS SDK you are using inserts a value for you. This prevents retries
  after a network error from starting multiple training jobs. You'll need to provide your own
  value for other use cases.  An error occurs if the other input parameters are not the same
  as in the first request. Using a different value for ClientToken is considered a new call
  to CreateModel. An idempotency token is active for 8 hours.
"""
function create_model(
    OutputConfig, projectName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutvision(
        "POST",
        "/2020-11-20/projects/$(projectName)/models",
        Dict{String,Any}(
            "OutputConfig" => OutputConfig, "X-Amzn-Client-Token" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_model(
    OutputConfig,
    projectName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutvision(
        "POST",
        "/2020-11-20/projects/$(projectName)/models",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "OutputConfig" => OutputConfig, "X-Amzn-Client-Token" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_project(project_name)
    create_project(project_name, params::Dict{String,<:Any})

Creates an empty Amazon Lookout for Vision project. After you create the project, add a
dataset by calling CreateDataset. This operation requires permissions to perform the
lookoutvision:CreateProject operation.

# Arguments
- `project_name`: The name for the project.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"X-Amzn-Client-Token"`: ClientToken is an idempotency token that ensures a call to
  CreateProject completes only once. You choose the value to pass. For example, An issue
  might prevent you from getting a response from CreateProject. In this case, safely retry
  your call to CreateProject by using the same ClientToken parameter value.  If you don't
  supply a value for ClientToken, the AWS SDK you are using inserts a value for you. This
  prevents retries after a network error from making multiple project creation requests.
  You'll need to provide your own value for other use cases.  An error occurs if the other
  input parameters are not the same as in the first request. Using a different value for
  ClientToken is considered a new call to CreateProject. An idempotency token is active for 8
  hours.
"""
function create_project(ProjectName; aws_config::AbstractAWSConfig=current_aws_config())
    return lookoutvision(
        "POST",
        "/2020-11-20/projects",
        Dict{String,Any}(
            "ProjectName" => ProjectName, "X-Amzn-Client-Token" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_project(
    ProjectName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutvision(
        "POST",
        "/2020-11-20/projects",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ProjectName" => ProjectName, "X-Amzn-Client-Token" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_dataset(dataset_type, project_name)
    delete_dataset(dataset_type, project_name, params::Dict{String,<:Any})

Deletes an existing Amazon Lookout for Vision dataset.  If your the project has a single
dataset, you must create a new dataset before you can create a model. If you project has a
training dataset and a test dataset consider the following.    If you delete the test
dataset, your project reverts to a single dataset project. If you then train the model,
Amazon Lookout for Vision internally splits the remaining dataset into a training and test
dataset.   If you delete the training dataset, you must create a training dataset before
you can create a model.   This operation requires permissions to perform the
lookoutvision:DeleteDataset operation.

# Arguments
- `dataset_type`: The type of the dataset to delete. Specify train to delete the training
  dataset. Specify test to delete the test dataset. To delete the dataset in a single dataset
  project, specify train.
- `project_name`: The name of the project that contains the dataset that you want to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"X-Amzn-Client-Token"`: ClientToken is an idempotency token that ensures a call to
  DeleteDataset completes only once. You choose the value to pass. For example, An issue
  might prevent you from getting a response from DeleteDataset. In this case, safely retry
  your call to DeleteDataset by using the same ClientToken parameter value.  If you don't
  supply a value for ClientToken, the AWS SDK you are using inserts a value for you. This
  prevents retries after a network error from making multiple deletetion requests. You'll
  need to provide your own value for other use cases.  An error occurs if the other input
  parameters are not the same as in the first request. Using a different value for
  ClientToken is considered a new call to DeleteDataset. An idempotency token is active for 8
  hours.
"""
function delete_dataset(
    datasetType, projectName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutvision(
        "DELETE",
        "/2020-11-20/projects/$(projectName)/datasets/$(datasetType)",
        Dict{String,Any}("X-Amzn-Client-Token" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_dataset(
    datasetType,
    projectName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutvision(
        "DELETE",
        "/2020-11-20/projects/$(projectName)/datasets/$(datasetType)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("X-Amzn-Client-Token" => string(uuid4())), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_model(model_version, project_name)
    delete_model(model_version, project_name, params::Dict{String,<:Any})

Deletes an Amazon Lookout for Vision model. You can't delete a running model. To stop a
running model, use the StopModel operation. It might take a few seconds to delete a model.
To determine if a model has been deleted, call ListModels and check if the version of the
model (ModelVersion) is in the Models array.   This operation requires permissions to
perform the lookoutvision:DeleteModel operation.

# Arguments
- `model_version`: The version of the model that you want to delete.
- `project_name`: The name of the project that contains the model that you want to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"X-Amzn-Client-Token"`: ClientToken is an idempotency token that ensures a call to
  DeleteModel completes only once. You choose the value to pass. For example, an issue might
  prevent you from getting a response from DeleteModel. In this case, safely retry your call
  to DeleteModel by using the same ClientToken parameter value. If you don't supply a value
  for ClientToken, the AWS SDK you are using inserts a value for you. This prevents retries
  after a network error from making multiple model deletion requests. You'll need to provide
  your own value for other use cases.  An error occurs if the other input parameters are not
  the same as in the first request. Using a different value for ClientToken is considered a
  new call to DeleteModel. An idempotency token is active for 8 hours.
"""
function delete_model(
    modelVersion, projectName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutvision(
        "DELETE",
        "/2020-11-20/projects/$(projectName)/models/$(modelVersion)",
        Dict{String,Any}("X-Amzn-Client-Token" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_model(
    modelVersion,
    projectName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutvision(
        "DELETE",
        "/2020-11-20/projects/$(projectName)/models/$(modelVersion)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("X-Amzn-Client-Token" => string(uuid4())), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_project(project_name)
    delete_project(project_name, params::Dict{String,<:Any})

Deletes an Amazon Lookout for Vision project. To delete a project, you must first delete
each version of the model associated with the project. To delete a model use the
DeleteModel operation. You also have to delete the dataset(s) associated with the model.
For more information, see DeleteDataset. The images referenced by the training and test
datasets aren't deleted.  This operation requires permissions to perform the
lookoutvision:DeleteProject operation.

# Arguments
- `project_name`: The name of the project to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"X-Amzn-Client-Token"`: ClientToken is an idempotency token that ensures a call to
  DeleteProject completes only once. You choose the value to pass. For example, An issue
  might prevent you from getting a response from DeleteProject. In this case, safely retry
  your call to DeleteProject by using the same ClientToken parameter value.  If you don't
  supply a value for ClientToken, the AWS SDK you are using inserts a value for you. This
  prevents retries after a network error from making multiple project deletion requests.
  You'll need to provide your own value for other use cases.  An error occurs if the other
  input parameters are not the same as in the first request. Using a different value for
  ClientToken is considered a new call to DeleteProject. An idempotency token is active for 8
  hours.
"""
function delete_project(projectName; aws_config::AbstractAWSConfig=current_aws_config())
    return lookoutvision(
        "DELETE",
        "/2020-11-20/projects/$(projectName)",
        Dict{String,Any}("X-Amzn-Client-Token" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_project(
    projectName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutvision(
        "DELETE",
        "/2020-11-20/projects/$(projectName)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("X-Amzn-Client-Token" => string(uuid4())), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_dataset(dataset_type, project_name)
    describe_dataset(dataset_type, project_name, params::Dict{String,<:Any})

Describe an Amazon Lookout for Vision dataset. This operation requires permissions to
perform the lookoutvision:DescribeDataset operation.

# Arguments
- `dataset_type`: The type of the dataset to describe. Specify train to describe the
  training dataset. Specify test to describe the test dataset. If you have a single dataset
  project, specify train
- `project_name`: The name of the project that contains the dataset that you want to
  describe.

"""
function describe_dataset(
    datasetType, projectName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutvision(
        "GET",
        "/2020-11-20/projects/$(projectName)/datasets/$(datasetType)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_dataset(
    datasetType,
    projectName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutvision(
        "GET",
        "/2020-11-20/projects/$(projectName)/datasets/$(datasetType)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_model(model_version, project_name)
    describe_model(model_version, project_name, params::Dict{String,<:Any})

Describes a version of an Amazon Lookout for Vision model. This operation requires
permissions to perform the lookoutvision:DescribeModel operation.

# Arguments
- `model_version`: The version of the model that you want to describe.
- `project_name`: The project that contains the version of a model that you want to
  describe.

"""
function describe_model(
    modelVersion, projectName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutvision(
        "GET",
        "/2020-11-20/projects/$(projectName)/models/$(modelVersion)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_model(
    modelVersion,
    projectName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutvision(
        "GET",
        "/2020-11-20/projects/$(projectName)/models/$(modelVersion)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_model_packaging_job(job_name, project_name)
    describe_model_packaging_job(job_name, project_name, params::Dict{String,<:Any})

Describes an Amazon Lookout for Vision model packaging job.  This operation requires
permissions to perform the lookoutvision:DescribeModelPackagingJob operation. For more
information, see Using your Amazon Lookout for Vision model on an edge device in the Amazon
Lookout for Vision Developer Guide.

# Arguments
- `job_name`: The job name for the model packaging job.
- `project_name`: The name of the project that contains the model packaging job that you
  want to describe.

"""
function describe_model_packaging_job(
    jobName, projectName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutvision(
        "GET",
        "/2020-11-20/projects/$(projectName)/modelpackagingjobs/$(jobName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_model_packaging_job(
    jobName,
    projectName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutvision(
        "GET",
        "/2020-11-20/projects/$(projectName)/modelpackagingjobs/$(jobName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_project(project_name)
    describe_project(project_name, params::Dict{String,<:Any})

Describes an Amazon Lookout for Vision project. This operation requires permissions to
perform the lookoutvision:DescribeProject operation.

# Arguments
- `project_name`: The name of the project that you want to describe.

"""
function describe_project(projectName; aws_config::AbstractAWSConfig=current_aws_config())
    return lookoutvision(
        "GET",
        "/2020-11-20/projects/$(projectName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_project(
    projectName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutvision(
        "GET",
        "/2020-11-20/projects/$(projectName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    detect_anomalies(body, content-_type, model_version, project_name)
    detect_anomalies(body, content-_type, model_version, project_name, params::Dict{String,<:Any})

Detects anomalies in an image that you supply.  The response from DetectAnomalies includes
a boolean prediction that the image contains one or more anomalies and a confidence value
for the prediction. If the model is an image segmentation model, the response also includes
segmentation information for each type of anomaly found in the image.  Before calling
DetectAnomalies, you must first start your model with the StartModel operation. You are
charged for the amount of time, in minutes, that a model runs and for the number of anomaly
detection units that your model uses. If you are not using a model, use the StopModel
operation to stop your model.   For more information, see Detecting anomalies in an image
in the Amazon Lookout for Vision developer guide. This operation requires permissions to
perform the lookoutvision:DetectAnomalies operation.

# Arguments
- `body`: The unencrypted image bytes that you want to analyze.
- `content-_type`: The type of the image passed in Body. Valid values are image/png (PNG
  format images) and image/jpeg (JPG format images).
- `model_version`: The version of the model that you want to use.
- `project_name`: The name of the project that contains the model version that you want to
  use.

"""
function detect_anomalies(
    Body,
    Content_Type,
    modelVersion,
    projectName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutvision(
        "POST",
        "/2020-11-20/projects/$(projectName)/models/$(modelVersion)/detect",
        Dict{String,Any}(
            "Body" => Body, "headers" => Dict{String,Any}("Content-Type" => Content_Type)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function detect_anomalies(
    Body,
    Content_Type,
    modelVersion,
    projectName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutvision(
        "POST",
        "/2020-11-20/projects/$(projectName)/models/$(modelVersion)/detect",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Body" => Body,
                    "headers" => Dict{String,Any}("Content-Type" => Content_Type),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_dataset_entries(dataset_type, project_name)
    list_dataset_entries(dataset_type, project_name, params::Dict{String,<:Any})

Lists the JSON Lines within a dataset. An Amazon Lookout for Vision JSON Line contains the
anomaly information for a single image, including the image location and the assigned
label. This operation requires permissions to perform the lookoutvision:ListDatasetEntries
operation.

# Arguments
- `dataset_type`: The type of the dataset that you want to list. Specify train to list the
  training dataset. Specify test to list the test dataset. If you have a single dataset
  project, specify train.
- `project_name`: The name of the project that contains the dataset that you want to list.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"anomalyClass"`: Specify normal to include only normal images. Specify anomaly to only
  include anomalous entries. If you don't specify a value, Amazon Lookout for Vision returns
  normal and anomalous images.
- `"createdAfter"`: Only includes entries after the specified date in the response. For
  example, 2020-06-23T00:00:00.
- `"createdBefore"`: Only includes entries before the specified date in the response. For
  example, 2020-06-23T00:00:00.
- `"labeled"`: Specify true to include labeled entries, otherwise specify false. If you
  don't specify a value, Lookout for Vision returns all entries.
- `"maxResults"`: The maximum number of results to return per paginated call. The largest
  value you can specify is 100. If you specify a value greater than 100, a
  ValidationException error occurs. The default value is 100.
- `"nextToken"`: If the previous response was incomplete (because there is more data to
  retrieve), Amazon Lookout for Vision returns a pagination token in the response. You can
  use this pagination token to retrieve the next set of dataset entries.
- `"sourceRefContains"`: Perform a \"contains\" search on the values of the source-ref key
  within the dataset. For example a value of \"IMG_17\" returns all JSON Lines where the
  source-ref key value matches *IMG_17*.
"""
function list_dataset_entries(
    datasetType, projectName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutvision(
        "GET",
        "/2020-11-20/projects/$(projectName)/datasets/$(datasetType)/entries";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_dataset_entries(
    datasetType,
    projectName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutvision(
        "GET",
        "/2020-11-20/projects/$(projectName)/datasets/$(datasetType)/entries",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_model_packaging_jobs(project_name)
    list_model_packaging_jobs(project_name, params::Dict{String,<:Any})

 Lists the model packaging jobs created for an Amazon Lookout for Vision project.  This
operation requires permissions to perform the lookoutvision:ListModelPackagingJobs
operation.  For more information, see Using your Amazon Lookout for Vision model on an edge
device in the Amazon Lookout for Vision Developer Guide.

# Arguments
- `project_name`:  The name of the project for which you want to list the model packaging
  jobs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return per paginated call. The largest
  value you can specify is 100. If you specify a value greater than 100, a
  ValidationException error occurs. The default value is 100.
- `"nextToken"`: If the previous response was incomplete (because there is more results to
  retrieve), Amazon Lookout for Vision returns a pagination token in the response. You can
  use this pagination token to retrieve the next set of results.
"""
function list_model_packaging_jobs(
    projectName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutvision(
        "GET",
        "/2020-11-20/projects/$(projectName)/modelpackagingjobs";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_model_packaging_jobs(
    projectName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutvision(
        "GET",
        "/2020-11-20/projects/$(projectName)/modelpackagingjobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_models(project_name)
    list_models(project_name, params::Dict{String,<:Any})

Lists the versions of a model in an Amazon Lookout for Vision project. The ListModels
operation is eventually consistent. Recent calls to CreateModel might take a while to
appear in the response from ListProjects. This operation requires permissions to perform
the lookoutvision:ListModels operation.

# Arguments
- `project_name`: The name of the project that contains the model versions that you want to
  list.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return per paginated call. The largest
  value you can specify is 100. If you specify a value greater than 100, a
  ValidationException error occurs. The default value is 100.
- `"nextToken"`: If the previous response was incomplete (because there is more data to
  retrieve), Amazon Lookout for Vision returns a pagination token in the response. You can
  use this pagination token to retrieve the next set of models.
"""
function list_models(projectName; aws_config::AbstractAWSConfig=current_aws_config())
    return lookoutvision(
        "GET",
        "/2020-11-20/projects/$(projectName)/models";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_models(
    projectName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutvision(
        "GET",
        "/2020-11-20/projects/$(projectName)/models",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_projects()
    list_projects(params::Dict{String,<:Any})

Lists the Amazon Lookout for Vision projects in your AWS account that are in the AWS Region
in which you call ListProjects. The ListProjects operation is eventually consistent. Recent
calls to CreateProject and DeleteProject might take a while to appear in the response from
ListProjects. This operation requires permissions to perform the lookoutvision:ListProjects
operation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return per paginated call. The largest
  value you can specify is 100. If you specify a value greater than 100, a
  ValidationException error occurs. The default value is 100.
- `"nextToken"`: If the previous response was incomplete (because there is more data to
  retrieve), Amazon Lookout for Vision returns a pagination token in the response. You can
  use this pagination token to retrieve the next set of projects.
"""
function list_projects(; aws_config::AbstractAWSConfig=current_aws_config())
    return lookoutvision(
        "GET",
        "/2020-11-20/projects";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_projects(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutvision(
        "GET",
        "/2020-11-20/projects",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Returns a list of tags attached to the specified Amazon Lookout for Vision model. This
operation requires permissions to perform the lookoutvision:ListTagsForResource operation.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the model for which you want to list
  tags.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutvision(
        "GET",
        "/2020-11-20/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutvision(
        "GET",
        "/2020-11-20/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_model(min_inference_units, model_version, project_name)
    start_model(min_inference_units, model_version, project_name, params::Dict{String,<:Any})

Starts the running of the version of an Amazon Lookout for Vision model. Starting a model
takes a while to complete. To check the current state of the model, use DescribeModel. A
model is ready to use when its status is HOSTED. Once the model is running, you can detect
custom labels in new images by calling DetectAnomalies.  You are charged for the amount of
time that the model is running. To stop a running model, call StopModel.  This operation
requires permissions to perform the lookoutvision:StartModel operation.

# Arguments
- `min_inference_units`: The minimum number of inference units to use. A single inference
  unit represents 1 hour of processing. Use a higher number to increase the TPS throughput of
  your model. You are charged for the number of inference units that you use.
- `model_version`: The version of the model that you want to start.
- `project_name`: The name of the project that contains the model that you want to start.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxInferenceUnits"`: The maximum number of inference units to use for auto-scaling the
  model. If you don't specify a value, Amazon Lookout for Vision doesn't auto-scale the model.
- `"X-Amzn-Client-Token"`: ClientToken is an idempotency token that ensures a call to
  StartModel completes only once. You choose the value to pass. For example, An issue might
  prevent you from getting a response from StartModel. In this case, safely retry your call
  to StartModel by using the same ClientToken parameter value.  If you don't supply a value
  for ClientToken, the AWS SDK you are using inserts a value for you. This prevents retries
  after a network error from making multiple start requests. You'll need to provide your own
  value for other use cases.  An error occurs if the other input parameters are not the same
  as in the first request. Using a different value for ClientToken is considered a new call
  to StartModel. An idempotency token is active for 8 hours.
"""
function start_model(
    MinInferenceUnits,
    modelVersion,
    projectName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutvision(
        "POST",
        "/2020-11-20/projects/$(projectName)/models/$(modelVersion)/start",
        Dict{String,Any}(
            "MinInferenceUnits" => MinInferenceUnits,
            "X-Amzn-Client-Token" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_model(
    MinInferenceUnits,
    modelVersion,
    projectName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutvision(
        "POST",
        "/2020-11-20/projects/$(projectName)/models/$(modelVersion)/start",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "MinInferenceUnits" => MinInferenceUnits,
                    "X-Amzn-Client-Token" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_model_packaging_job(configuration, model_version, project_name)
    start_model_packaging_job(configuration, model_version, project_name, params::Dict{String,<:Any})

Starts an Amazon Lookout for Vision model packaging job. A model packaging job creates an
AWS IoT Greengrass component for a Lookout for Vision model. You can use the component to
deploy your model to an edge device managed by Greengrass.  Use the
DescribeModelPackagingJob API to determine the current status of the job. The model
packaging job is complete if the value of Status is SUCCEEDED. To deploy the component to
the target device, use the component name and component version with the AWS IoT Greengrass
CreateDeployment API. This operation requires the following permissions:
lookoutvision:StartModelPackagingJob     s3:PutObject     s3:GetBucketLocation
kms:GenerateDataKey     greengrass:CreateComponentVersion     greengrass:DescribeComponent
  (Optional) greengrass:TagResource. Only required if you want to tag the component.   For
more information, see Using your Amazon Lookout for Vision model on an edge device in the
Amazon Lookout for Vision Developer Guide.

# Arguments
- `configuration`: The configuration for the model packaging job.
- `model_version`:  The version of the model within the project that you want to package.
- `project_name`:  The name of the project which contains the version of the model that you
  want to package.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description for the model packaging job.
- `"JobName"`: A name for the model packaging job. If you don't supply a value, the service
  creates a job name for you.
- `"X-Amzn-Client-Token"`: ClientToken is an idempotency token that ensures a call to
  StartModelPackagingJob completes only once. You choose the value to pass. For example, An
  issue might prevent you from getting a response from StartModelPackagingJob. In this case,
  safely retry your call to StartModelPackagingJob by using the same ClientToken parameter
  value. If you don't supply a value for ClientToken, the AWS SDK you are using inserts a
  value for you. This prevents retries after a network error from making multiple dataset
  creation requests. You'll need to provide your own value for other use cases.  An error
  occurs if the other input parameters are not the same as in the first request. Using a
  different value for ClientToken is considered a new call to StartModelPackagingJob. An
  idempotency token is active for 8 hours.
"""
function start_model_packaging_job(
    Configuration,
    ModelVersion,
    projectName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutvision(
        "POST",
        "/2020-11-20/projects/$(projectName)/modelpackagingjobs",
        Dict{String,Any}(
            "Configuration" => Configuration,
            "ModelVersion" => ModelVersion,
            "X-Amzn-Client-Token" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_model_packaging_job(
    Configuration,
    ModelVersion,
    projectName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutvision(
        "POST",
        "/2020-11-20/projects/$(projectName)/modelpackagingjobs",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Configuration" => Configuration,
                    "ModelVersion" => ModelVersion,
                    "X-Amzn-Client-Token" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_model(model_version, project_name)
    stop_model(model_version, project_name, params::Dict{String,<:Any})

Stops the hosting of a running model. The operation might take a while to complete. To
check the current status, call DescribeModel.  After the model hosting stops, the Status of
the model is TRAINED. This operation requires permissions to perform the
lookoutvision:StopModel operation.

# Arguments
- `model_version`: The version of the model that you want to stop.
- `project_name`: The name of the project that contains the model that you want to stop.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"X-Amzn-Client-Token"`: ClientToken is an idempotency token that ensures a call to
  StopModel completes only once. You choose the value to pass. For example, An issue might
  prevent you from getting a response from StopModel. In this case, safely retry your call to
  StopModel by using the same ClientToken parameter value. If you don't supply a value for
  ClientToken, the AWS SDK you are using inserts a value for you. This prevents retries after
  a network error from making multiple stop requests. You'll need to provide your own value
  for other use cases.  An error occurs if the other input parameters are not the same as in
  the first request. Using a different value for ClientToken is considered a new call to
  StopModel. An idempotency token is active for 8 hours.
"""
function stop_model(
    modelVersion, projectName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutvision(
        "POST",
        "/2020-11-20/projects/$(projectName)/models/$(modelVersion)/stop",
        Dict{String,Any}("X-Amzn-Client-Token" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_model(
    modelVersion,
    projectName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutvision(
        "POST",
        "/2020-11-20/projects/$(projectName)/models/$(modelVersion)/stop",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("X-Amzn-Client-Token" => string(uuid4())), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(tags, resource_arn)
    tag_resource(tags, resource_arn, params::Dict{String,<:Any})

Adds one or more key-value tags to an Amazon Lookout for Vision model. For more
information, see Tagging a model in the Amazon Lookout for Vision Developer Guide.  This
operation requires permissions to perform the lookoutvision:TagResource operation.

# Arguments
- `tags`: The key-value tags to assign to the model.
- `resource_arn`: The Amazon Resource Name (ARN) of the model to assign the tags.

"""
function tag_resource(Tags, resourceArn; aws_config::AbstractAWSConfig=current_aws_config())
    return lookoutvision(
        "POST",
        "/2020-11-20/tags/$(resourceArn)",
        Dict{String,Any}("Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    Tags,
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutvision(
        "POST",
        "/2020-11-20/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Tags" => Tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes one or more tags from an Amazon Lookout for Vision model. For more information, see
Tagging a model in the Amazon Lookout for Vision Developer Guide.  This operation requires
permissions to perform the lookoutvision:UntagResource operation.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the model from which you want to remove
  tags.
- `tag_keys`: A list of the keys of the tags that you want to remove.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutvision(
        "DELETE",
        "/2020-11-20/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutvision(
        "DELETE",
        "/2020-11-20/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_dataset_entries(changes, dataset_type, project_name)
    update_dataset_entries(changes, dataset_type, project_name, params::Dict{String,<:Any})

Adds or updates one or more JSON Line entries in a dataset. A JSON Line includes
information about an image used for training or testing an Amazon Lookout for Vision model.
To update an existing JSON Line, use the source-ref field to identify the JSON Line. The
JSON line that you supply replaces the existing JSON line. Any existing annotations that
are not in the new JSON line are removed from the dataset.  For more information, see
Defining JSON lines for anomaly classification in the Amazon Lookout for Vision Developer
Guide.   The images you reference in the source-ref field of a JSON line, must be in the
same S3 bucket as the existing images in the dataset.   Updating a dataset might take a
while to complete. To check the current status, call DescribeDataset and check the Status
field in the response. This operation requires permissions to perform the
lookoutvision:UpdateDatasetEntries operation.

# Arguments
- `changes`: The entries to add to the dataset.
- `dataset_type`: The type of the dataset that you want to update. Specify train to update
  the training dataset. Specify test to update the test dataset. If you have a single dataset
  project, specify train.
- `project_name`: The name of the project that contains the dataset that you want to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"X-Amzn-Client-Token"`: ClientToken is an idempotency token that ensures a call to
  UpdateDatasetEntries completes only once. You choose the value to pass. For example, An
  issue might prevent you from getting a response from UpdateDatasetEntries. In this case,
  safely retry your call to UpdateDatasetEntries by using the same ClientToken parameter
  value. If you don't supply a value for ClientToken, the AWS SDK you are using inserts a
  value for you. This prevents retries after a network error from making multiple updates
  with the same dataset entries. You'll need to provide your own value for other use cases.
  An error occurs if the other input parameters are not the same as in the first request.
  Using a different value for ClientToken is considered a new call to UpdateDatasetEntries.
  An idempotency token is active for 8 hours.
"""
function update_dataset_entries(
    Changes, datasetType, projectName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutvision(
        "PATCH",
        "/2020-11-20/projects/$(projectName)/datasets/$(datasetType)/entries",
        Dict{String,Any}("Changes" => Changes, "X-Amzn-Client-Token" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_dataset_entries(
    Changes,
    datasetType,
    projectName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutvision(
        "PATCH",
        "/2020-11-20/projects/$(projectName)/datasets/$(datasetType)/entries",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Changes" => Changes, "X-Amzn-Client-Token" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: healthlake
using AWS.Compat
using AWS.UUIDs

"""
    create_fhirdatastore(datastore_type_version)
    create_fhirdatastore(datastore_type_version, params::Dict{String,<:Any})

Creates a data store that can ingest and export FHIR formatted data.

# Arguments
- `datastore_type_version`: The FHIR version of the data store. The only supported version
  is R4.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: Optional user provided token used for ensuring idempotency.
- `"DatastoreName"`: The user generated name for the data store.
- `"IdentityProviderConfiguration"`: The configuration of the identity provider that you
  want to use for your data store.
- `"PreloadDataConfig"`: Optional parameter to preload data upon creation of the data
  store. Currently, the only supported preloaded data is synthetic data generated from
  Synthea.
- `"SseConfiguration"`:  The server-side encryption key configuration for a customer
  provided encryption key specified for creating a data store.
- `"Tags"`:  Resource tags that are applied to a data store when it is created.
"""
function create_fhirdatastore(
    DatastoreTypeVersion; aws_config::AbstractAWSConfig=current_aws_config()
)
    return healthlake(
        "CreateFHIRDatastore",
        Dict{String,Any}(
            "DatastoreTypeVersion" => DatastoreTypeVersion, "ClientToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_fhirdatastore(
    DatastoreTypeVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return healthlake(
        "CreateFHIRDatastore",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DatastoreTypeVersion" => DatastoreTypeVersion,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_fhirdatastore(datastore_id)
    delete_fhirdatastore(datastore_id, params::Dict{String,<:Any})

Deletes a data store.

# Arguments
- `datastore_id`:  The AWS-generated ID for the data store to be deleted.

"""
function delete_fhirdatastore(
    DatastoreId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return healthlake(
        "DeleteFHIRDatastore",
        Dict{String,Any}("DatastoreId" => DatastoreId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_fhirdatastore(
    DatastoreId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return healthlake(
        "DeleteFHIRDatastore",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DatastoreId" => DatastoreId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_fhirdatastore(datastore_id)
    describe_fhirdatastore(datastore_id, params::Dict{String,<:Any})

Gets the properties associated with the FHIR data store, including the data store ID, data
store ARN, data store name, data store status, when the data store was created, data store
type version, and the data store's endpoint.

# Arguments
- `datastore_id`: The AWS-generated data store ID.

"""
function describe_fhirdatastore(
    DatastoreId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return healthlake(
        "DescribeFHIRDatastore",
        Dict{String,Any}("DatastoreId" => DatastoreId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_fhirdatastore(
    DatastoreId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return healthlake(
        "DescribeFHIRDatastore",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DatastoreId" => DatastoreId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_fhirexport_job(datastore_id, job_id)
    describe_fhirexport_job(datastore_id, job_id, params::Dict{String,<:Any})

Displays the properties of a FHIR export job, including the ID, ARN, name, and the status
of the job.

# Arguments
- `datastore_id`: The AWS generated ID for the data store from which files are being
  exported from for an export job.
- `job_id`: The AWS generated ID for an export job.

"""
function describe_fhirexport_job(
    DatastoreId, JobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return healthlake(
        "DescribeFHIRExportJob",
        Dict{String,Any}("DatastoreId" => DatastoreId, "JobId" => JobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_fhirexport_job(
    DatastoreId,
    JobId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return healthlake(
        "DescribeFHIRExportJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DatastoreId" => DatastoreId, "JobId" => JobId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_fhirimport_job(datastore_id, job_id)
    describe_fhirimport_job(datastore_id, job_id, params::Dict{String,<:Any})

Displays the properties of a FHIR import job, including the ID, ARN, name, and the status
of the job.

# Arguments
- `datastore_id`: The AWS-generated ID of the data store.
- `job_id`: The AWS-generated job ID.

"""
function describe_fhirimport_job(
    DatastoreId, JobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return healthlake(
        "DescribeFHIRImportJob",
        Dict{String,Any}("DatastoreId" => DatastoreId, "JobId" => JobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_fhirimport_job(
    DatastoreId,
    JobId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return healthlake(
        "DescribeFHIRImportJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DatastoreId" => DatastoreId, "JobId" => JobId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_fhirdatastores()
    list_fhirdatastores(params::Dict{String,<:Any})

Lists all FHIR data stores that are in the user’s account, regardless of data store
status.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filter"`: Lists all filters associated with a FHIR data store request.
- `"MaxResults"`: The maximum number of data stores returned in a single page of a
  ListFHIRDatastoresRequest call.
- `"NextToken"`: Fetches the next page of data stores when results are paginated.
"""
function list_fhirdatastores(; aws_config::AbstractAWSConfig=current_aws_config())
    return healthlake(
        "ListFHIRDatastores"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_fhirdatastores(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return healthlake(
        "ListFHIRDatastores", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_fhirexport_jobs(datastore_id)
    list_fhirexport_jobs(datastore_id, params::Dict{String,<:Any})

 Lists all FHIR export jobs associated with an account and their statuses.

# Arguments
- `datastore_id`:  This parameter limits the response to the export job with the specified
  data store ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"JobName"`:  This parameter limits the response to the export job with the specified job
  name.
- `"JobStatus"`:  This parameter limits the response to the export jobs with the specified
  job status.
- `"MaxResults"`:  This parameter limits the number of results returned for a
  ListFHIRExportJobs to a maximum quantity specified by the user.
- `"NextToken"`:  A pagination token used to identify the next page of results to return
  for a ListFHIRExportJobs query.
- `"SubmittedAfter"`:  This parameter limits the response to FHIR export jobs submitted
  after a user specified date.
- `"SubmittedBefore"`:  This parameter limits the response to FHIR export jobs submitted
  before a user specified date.
"""
function list_fhirexport_jobs(
    DatastoreId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return healthlake(
        "ListFHIRExportJobs",
        Dict{String,Any}("DatastoreId" => DatastoreId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_fhirexport_jobs(
    DatastoreId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return healthlake(
        "ListFHIRExportJobs",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DatastoreId" => DatastoreId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_fhirimport_jobs(datastore_id)
    list_fhirimport_jobs(datastore_id, params::Dict{String,<:Any})

 Lists all FHIR import jobs associated with an account and their statuses.

# Arguments
- `datastore_id`:  This parameter limits the response to the import job with the specified
  data store ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"JobName"`:  This parameter limits the response to the import job with the specified job
  name.
- `"JobStatus"`:  This parameter limits the response to the import job with the specified
  job status.
- `"MaxResults"`:  This parameter limits the number of results returned for a
  ListFHIRImportJobs to a maximum quantity specified by the user.
- `"NextToken"`:  A pagination token used to identify the next page of results to return
  for a ListFHIRImportJobs query.
- `"SubmittedAfter"`:  This parameter limits the response to FHIR import jobs submitted
  after a user specified date.
- `"SubmittedBefore"`:  This parameter limits the response to FHIR import jobs submitted
  before a user specified date.
"""
function list_fhirimport_jobs(
    DatastoreId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return healthlake(
        "ListFHIRImportJobs",
        Dict{String,Any}("DatastoreId" => DatastoreId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_fhirimport_jobs(
    DatastoreId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return healthlake(
        "ListFHIRImportJobs",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DatastoreId" => DatastoreId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

 Returns a list of all existing tags associated with a data store.

# Arguments
- `resource_arn`:  The Amazon Resource Name(ARN) of the data store for which tags are being
  added.

"""
function list_tags_for_resource(
    ResourceARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return healthlake(
        "ListTagsForResource",
        Dict{String,Any}("ResourceARN" => ResourceARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return healthlake(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceARN" => ResourceARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_fhirexport_job(client_token, data_access_role_arn, datastore_id, output_data_config)
    start_fhirexport_job(client_token, data_access_role_arn, datastore_id, output_data_config, params::Dict{String,<:Any})

Begins a FHIR export job.

# Arguments
- `client_token`: An optional user provided token used for ensuring idempotency.
- `data_access_role_arn`: The Amazon Resource Name used during the initiation of the job.
- `datastore_id`: The AWS generated ID for the data store from which files are being
  exported for an export job.
- `output_data_config`: The output data configuration that was supplied when the export job
  was created.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"JobName"`: The user generated name for an export job.
"""
function start_fhirexport_job(
    ClientToken,
    DataAccessRoleArn,
    DatastoreId,
    OutputDataConfig;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return healthlake(
        "StartFHIRExportJob",
        Dict{String,Any}(
            "ClientToken" => ClientToken,
            "DataAccessRoleArn" => DataAccessRoleArn,
            "DatastoreId" => DatastoreId,
            "OutputDataConfig" => OutputDataConfig,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_fhirexport_job(
    ClientToken,
    DataAccessRoleArn,
    DatastoreId,
    OutputDataConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return healthlake(
        "StartFHIRExportJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClientToken" => ClientToken,
                    "DataAccessRoleArn" => DataAccessRoleArn,
                    "DatastoreId" => DatastoreId,
                    "OutputDataConfig" => OutputDataConfig,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_fhirimport_job(client_token, data_access_role_arn, datastore_id, input_data_config, job_output_data_config)
    start_fhirimport_job(client_token, data_access_role_arn, datastore_id, input_data_config, job_output_data_config, params::Dict{String,<:Any})

Begins a FHIR Import job.

# Arguments
- `client_token`: Optional user provided token used for ensuring idempotency.
- `data_access_role_arn`: The Amazon Resource Name (ARN) that gives AWS HealthLake access
  permission.
- `datastore_id`: The AWS-generated data store ID.
- `input_data_config`: The input properties of the FHIR Import job in the StartFHIRImport
  job request.
- `job_output_data_config`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"JobName"`: The name of the FHIR Import job in the StartFHIRImport job request.
"""
function start_fhirimport_job(
    ClientToken,
    DataAccessRoleArn,
    DatastoreId,
    InputDataConfig,
    JobOutputDataConfig;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return healthlake(
        "StartFHIRImportJob",
        Dict{String,Any}(
            "ClientToken" => ClientToken,
            "DataAccessRoleArn" => DataAccessRoleArn,
            "DatastoreId" => DatastoreId,
            "InputDataConfig" => InputDataConfig,
            "JobOutputDataConfig" => JobOutputDataConfig,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_fhirimport_job(
    ClientToken,
    DataAccessRoleArn,
    DatastoreId,
    InputDataConfig,
    JobOutputDataConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return healthlake(
        "StartFHIRImportJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClientToken" => ClientToken,
                    "DataAccessRoleArn" => DataAccessRoleArn,
                    "DatastoreId" => DatastoreId,
                    "InputDataConfig" => InputDataConfig,
                    "JobOutputDataConfig" => JobOutputDataConfig,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

 Adds a user specified key and value tag to a data store.

# Arguments
- `resource_arn`:  The Amazon Resource Name(ARN)that gives AWS HealthLake access to the
  data store which tags are being added to.
- `tags`:  The user specified key and value pair tags being added to a data store.

"""
function tag_resource(ResourceARN, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return healthlake(
        "TagResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceARN,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return healthlake(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

 Removes tags from a data store.

# Arguments
- `resource_arn`: The Amazon Resource Name(ARN) of the data store for which tags are being
  removed.
- `tag_keys`:  The keys for the tags to be removed from the HealthLake data store.

"""
function untag_resource(
    ResourceARN, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return healthlake(
        "UntagResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceARN,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return healthlake(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: pinpoint_email
using AWS.Compat
using AWS.UUIDs

"""
    create_configuration_set(configuration_set_name)
    create_configuration_set(configuration_set_name, params::Dict{String,<:Any})

Create a configuration set. Configuration sets are groups of rules that you can apply to
the emails you send using Amazon Pinpoint. You apply a configuration set to an email by
including a reference to the configuration set in the headers of the email. When you apply
a configuration set to an email, all of the rules in that configuration set are applied to
the email.

# Arguments
- `configuration_set_name`: The name of the configuration set.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DeliveryOptions"`: An object that defines the dedicated IP pool that is used to send
  emails that you send using the configuration set.
- `"ReputationOptions"`: An object that defines whether or not Amazon Pinpoint collects
  reputation metrics for the emails that you send that use the configuration set.
- `"SendingOptions"`: An object that defines whether or not Amazon Pinpoint can send email
  that you send using the configuration set.
- `"Tags"`: An array of objects that define the tags (keys and values) that you want to
  associate with the configuration set.
- `"TrackingOptions"`: An object that defines the open and click tracking options for
  emails that you send using the configuration set.
"""
function create_configuration_set(
    ConfigurationSetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_email(
        "POST",
        "/v1/email/configuration-sets",
        Dict{String,Any}("ConfigurationSetName" => ConfigurationSetName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_configuration_set(
    ConfigurationSetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_email(
        "POST",
        "/v1/email/configuration-sets",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ConfigurationSetName" => ConfigurationSetName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_configuration_set_event_destination(configuration_set_name, event_destination, event_destination_name)
    create_configuration_set_event_destination(configuration_set_name, event_destination, event_destination_name, params::Dict{String,<:Any})

Create an event destination. In Amazon Pinpoint, events include message sends, deliveries,
opens, clicks, bounces, and complaints. Event destinations are places that you can send
information about these events to. For example, you can send event data to Amazon SNS to
receive notifications when you receive bounces or complaints, or you can use Amazon Kinesis
Data Firehose to stream data to Amazon S3 for long-term storage. A single configuration set
can include more than one event destination.

# Arguments
- `configuration_set_name`: The name of the configuration set that you want to add an event
  destination to.
- `event_destination`: An object that defines the event destination.
- `event_destination_name`: A name that identifies the event destination within the
  configuration set.

"""
function create_configuration_set_event_destination(
    ConfigurationSetName,
    EventDestination,
    EventDestinationName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_email(
        "POST",
        "/v1/email/configuration-sets/$(ConfigurationSetName)/event-destinations",
        Dict{String,Any}(
            "EventDestination" => EventDestination,
            "EventDestinationName" => EventDestinationName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_configuration_set_event_destination(
    ConfigurationSetName,
    EventDestination,
    EventDestinationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_email(
        "POST",
        "/v1/email/configuration-sets/$(ConfigurationSetName)/event-destinations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EventDestination" => EventDestination,
                    "EventDestinationName" => EventDestinationName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_dedicated_ip_pool(pool_name)
    create_dedicated_ip_pool(pool_name, params::Dict{String,<:Any})

Create a new pool of dedicated IP addresses. A pool can include one or more dedicated IP
addresses that are associated with your Amazon Pinpoint account. You can associate a pool
with a configuration set. When you send an email that uses that configuration set, Amazon
Pinpoint sends it using only the IP addresses in the associated pool.

# Arguments
- `pool_name`: The name of the dedicated IP pool.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: An object that defines the tags (keys and values) that you want to associate
  with the pool.
"""
function create_dedicated_ip_pool(
    PoolName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_email(
        "POST",
        "/v1/email/dedicated-ip-pools",
        Dict{String,Any}("PoolName" => PoolName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_dedicated_ip_pool(
    PoolName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_email(
        "POST",
        "/v1/email/dedicated-ip-pools",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("PoolName" => PoolName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_deliverability_test_report(content, from_email_address)
    create_deliverability_test_report(content, from_email_address, params::Dict{String,<:Any})

Create a new predictive inbox placement test. Predictive inbox placement tests can help you
predict how your messages will be handled by various email providers around the world. When
you perform a predictive inbox placement test, you provide a sample message that contains
the content that you plan to send to your customers. Amazon Pinpoint then sends that
message to special email addresses spread across several major email providers. After about
24 hours, the test is complete, and you can use the GetDeliverabilityTestReport operation
to view the results of the test.

# Arguments
- `content`: The HTML body of the message that you sent when you performed the predictive
  inbox placement test.
- `from_email_address`: The email address that the predictive inbox placement test email
  was sent from.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ReportName"`: A unique name that helps you to identify the predictive inbox placement
  test when you retrieve the results.
- `"Tags"`: An array of objects that define the tags (keys and values) that you want to
  associate with the predictive inbox placement test.
"""
function create_deliverability_test_report(
    Content, FromEmailAddress; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_email(
        "POST",
        "/v1/email/deliverability-dashboard/test",
        Dict{String,Any}("Content" => Content, "FromEmailAddress" => FromEmailAddress);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_deliverability_test_report(
    Content,
    FromEmailAddress,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_email(
        "POST",
        "/v1/email/deliverability-dashboard/test",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Content" => Content, "FromEmailAddress" => FromEmailAddress
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_email_identity(email_identity)
    create_email_identity(email_identity, params::Dict{String,<:Any})

Verifies an email identity for use with Amazon Pinpoint. In Amazon Pinpoint, an identity is
an email address or domain that you use when you send email. Before you can use an identity
to send email with Amazon Pinpoint, you first have to verify it. By verifying an address,
you demonstrate that you're the owner of the address, and that you've given Amazon Pinpoint
permission to send email from the address. When you verify an email address, Amazon
Pinpoint sends an email to the address. Your email address is verified as soon as you
follow the link in the verification email.  When you verify a domain, this operation
provides a set of DKIM tokens, which you can convert into CNAME tokens. You add these CNAME
tokens to the DNS configuration for your domain. Your domain is verified when Amazon
Pinpoint detects these records in the DNS configuration for your domain. It usually takes
around 72 hours to complete the domain verification process.

# Arguments
- `email_identity`: The email address or domain that you want to verify.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: An array of objects that define the tags (keys and values) that you want to
  associate with the email identity.
"""
function create_email_identity(
    EmailIdentity; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_email(
        "POST",
        "/v1/email/identities",
        Dict{String,Any}("EmailIdentity" => EmailIdentity);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_email_identity(
    EmailIdentity,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_email(
        "POST",
        "/v1/email/identities",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("EmailIdentity" => EmailIdentity), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_configuration_set(configuration_set_name)
    delete_configuration_set(configuration_set_name, params::Dict{String,<:Any})

Delete an existing configuration set. In Amazon Pinpoint, configuration sets are groups of
rules that you can apply to the emails you send. You apply a configuration set to an email
by including a reference to the configuration set in the headers of the email. When you
apply a configuration set to an email, all of the rules in that configuration set are
applied to the email.

# Arguments
- `configuration_set_name`: The name of the configuration set that you want to delete.

"""
function delete_configuration_set(
    ConfigurationSetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_email(
        "DELETE",
        "/v1/email/configuration-sets/$(ConfigurationSetName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_configuration_set(
    ConfigurationSetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_email(
        "DELETE",
        "/v1/email/configuration-sets/$(ConfigurationSetName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_configuration_set_event_destination(configuration_set_name, event_destination_name)
    delete_configuration_set_event_destination(configuration_set_name, event_destination_name, params::Dict{String,<:Any})

Delete an event destination. In Amazon Pinpoint, events include message sends, deliveries,
opens, clicks, bounces, and complaints. Event destinations are places that you can send
information about these events to. For example, you can send event data to Amazon SNS to
receive notifications when you receive bounces or complaints, or you can use Amazon Kinesis
Data Firehose to stream data to Amazon S3 for long-term storage.

# Arguments
- `configuration_set_name`: The name of the configuration set that contains the event
  destination that you want to delete.
- `event_destination_name`: The name of the event destination that you want to delete.

"""
function delete_configuration_set_event_destination(
    ConfigurationSetName,
    EventDestinationName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_email(
        "DELETE",
        "/v1/email/configuration-sets/$(ConfigurationSetName)/event-destinations/$(EventDestinationName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_configuration_set_event_destination(
    ConfigurationSetName,
    EventDestinationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_email(
        "DELETE",
        "/v1/email/configuration-sets/$(ConfigurationSetName)/event-destinations/$(EventDestinationName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_dedicated_ip_pool(pool_name)
    delete_dedicated_ip_pool(pool_name, params::Dict{String,<:Any})

Delete a dedicated IP pool.

# Arguments
- `pool_name`: The name of the dedicated IP pool that you want to delete.

"""
function delete_dedicated_ip_pool(
    PoolName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_email(
        "DELETE",
        "/v1/email/dedicated-ip-pools/$(PoolName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_dedicated_ip_pool(
    PoolName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_email(
        "DELETE",
        "/v1/email/dedicated-ip-pools/$(PoolName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_email_identity(email_identity)
    delete_email_identity(email_identity, params::Dict{String,<:Any})

Deletes an email identity that you previously verified for use with Amazon Pinpoint. An
identity can be either an email address or a domain name.

# Arguments
- `email_identity`: The identity (that is, the email address or domain) that you want to
  delete from your Amazon Pinpoint account.

"""
function delete_email_identity(
    EmailIdentity; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_email(
        "DELETE",
        "/v1/email/identities/$(EmailIdentity)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_email_identity(
    EmailIdentity,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_email(
        "DELETE",
        "/v1/email/identities/$(EmailIdentity)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_account()
    get_account(params::Dict{String,<:Any})

Obtain information about the email-sending status and capabilities of your Amazon Pinpoint
account in the current AWS Region.

"""
function get_account(; aws_config::AbstractAWSConfig=current_aws_config())
    return pinpoint_email(
        "GET", "/v1/email/account"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_account(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_email(
        "GET",
        "/v1/email/account",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_blacklist_reports(blacklist_item_names)
    get_blacklist_reports(blacklist_item_names, params::Dict{String,<:Any})

Retrieve a list of the blacklists that your dedicated IP addresses appear on.

# Arguments
- `blacklist_item_names`: A list of IP addresses that you want to retrieve blacklist
  information about. You can only specify the dedicated IP addresses that you use to send
  email using Amazon Pinpoint or Amazon SES.

"""
function get_blacklist_reports(
    BlacklistItemNames; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_email(
        "GET",
        "/v1/email/deliverability-dashboard/blacklist-report",
        Dict{String,Any}("BlacklistItemNames" => BlacklistItemNames);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_blacklist_reports(
    BlacklistItemNames,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_email(
        "GET",
        "/v1/email/deliverability-dashboard/blacklist-report",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("BlacklistItemNames" => BlacklistItemNames), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_configuration_set(configuration_set_name)
    get_configuration_set(configuration_set_name, params::Dict{String,<:Any})

Get information about an existing configuration set, including the dedicated IP pool that
it's associated with, whether or not it's enabled for sending email, and more. In Amazon
Pinpoint, configuration sets are groups of rules that you can apply to the emails you send.
You apply a configuration set to an email by including a reference to the configuration set
in the headers of the email. When you apply a configuration set to an email, all of the
rules in that configuration set are applied to the email.

# Arguments
- `configuration_set_name`: The name of the configuration set that you want to obtain more
  information about.

"""
function get_configuration_set(
    ConfigurationSetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_email(
        "GET",
        "/v1/email/configuration-sets/$(ConfigurationSetName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_configuration_set(
    ConfigurationSetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_email(
        "GET",
        "/v1/email/configuration-sets/$(ConfigurationSetName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_configuration_set_event_destinations(configuration_set_name)
    get_configuration_set_event_destinations(configuration_set_name, params::Dict{String,<:Any})

Retrieve a list of event destinations that are associated with a configuration set. In
Amazon Pinpoint, events include message sends, deliveries, opens, clicks, bounces, and
complaints. Event destinations are places that you can send information about these events
to. For example, you can send event data to Amazon SNS to receive notifications when you
receive bounces or complaints, or you can use Amazon Kinesis Data Firehose to stream data
to Amazon S3 for long-term storage.

# Arguments
- `configuration_set_name`: The name of the configuration set that contains the event
  destination.

"""
function get_configuration_set_event_destinations(
    ConfigurationSetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_email(
        "GET",
        "/v1/email/configuration-sets/$(ConfigurationSetName)/event-destinations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_configuration_set_event_destinations(
    ConfigurationSetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_email(
        "GET",
        "/v1/email/configuration-sets/$(ConfigurationSetName)/event-destinations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_dedicated_ip(ip)
    get_dedicated_ip(ip, params::Dict{String,<:Any})

Get information about a dedicated IP address, including the name of the dedicated IP pool
that it's associated with, as well information about the automatic warm-up process for the
address.

# Arguments
- `ip`: The IP address that you want to obtain more information about. The value you
  specify has to be a dedicated IP address that's assocaited with your Amazon Pinpoint
  account.

"""
function get_dedicated_ip(IP; aws_config::AbstractAWSConfig=current_aws_config())
    return pinpoint_email(
        "GET",
        "/v1/email/dedicated-ips/$(IP)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_dedicated_ip(
    IP, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_email(
        "GET",
        "/v1/email/dedicated-ips/$(IP)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_dedicated_ips()
    get_dedicated_ips(params::Dict{String,<:Any})

List the dedicated IP addresses that are associated with your Amazon Pinpoint account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: A token returned from a previous call to GetDedicatedIps to indicate the
  position of the dedicated IP pool in the list of IP pools.
- `"PageSize"`: The number of results to show in a single call to GetDedicatedIpsRequest.
  If the number of results is larger than the number you specified in this parameter, then
  the response includes a NextToken element, which you can use to obtain additional results.
- `"PoolName"`: The name of the IP pool that the dedicated IP address is associated with.
"""
function get_dedicated_ips(; aws_config::AbstractAWSConfig=current_aws_config())
    return pinpoint_email(
        "GET",
        "/v1/email/dedicated-ips";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_dedicated_ips(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_email(
        "GET",
        "/v1/email/dedicated-ips",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_deliverability_dashboard_options()
    get_deliverability_dashboard_options(params::Dict{String,<:Any})

Retrieve information about the status of the Deliverability dashboard for your Amazon
Pinpoint account. When the Deliverability dashboard is enabled, you gain access to
reputation, deliverability, and other metrics for the domains that you use to send email
using Amazon Pinpoint. You also gain the ability to perform predictive inbox placement
tests. When you use the Deliverability dashboard, you pay a monthly subscription charge, in
addition to any other fees that you accrue by using Amazon Pinpoint. For more information
about the features and cost of a Deliverability dashboard subscription, see Amazon Pinpoint
Pricing.

"""
function get_deliverability_dashboard_options(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_email(
        "GET",
        "/v1/email/deliverability-dashboard";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_deliverability_dashboard_options(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_email(
        "GET",
        "/v1/email/deliverability-dashboard",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_deliverability_test_report(report_id)
    get_deliverability_test_report(report_id, params::Dict{String,<:Any})

Retrieve the results of a predictive inbox placement test.

# Arguments
- `report_id`: A unique string that identifies the predictive inbox placement test.

"""
function get_deliverability_test_report(
    ReportId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_email(
        "GET",
        "/v1/email/deliverability-dashboard/test-reports/$(ReportId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_deliverability_test_report(
    ReportId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_email(
        "GET",
        "/v1/email/deliverability-dashboard/test-reports/$(ReportId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_domain_deliverability_campaign(campaign_id)
    get_domain_deliverability_campaign(campaign_id, params::Dict{String,<:Any})

Retrieve all the deliverability data for a specific campaign. This data is available for a
campaign only if the campaign sent email by using a domain that the Deliverability
dashboard is enabled for (PutDeliverabilityDashboardOption operation).

# Arguments
- `campaign_id`: The unique identifier for the campaign. Amazon Pinpoint automatically
  generates and assigns this identifier to a campaign. This value is not the same as the
  campaign identifier that Amazon Pinpoint assigns to campaigns that you create and manage by
  using the Amazon Pinpoint API or the Amazon Pinpoint console.

"""
function get_domain_deliverability_campaign(
    CampaignId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_email(
        "GET",
        "/v1/email/deliverability-dashboard/campaigns/$(CampaignId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_domain_deliverability_campaign(
    CampaignId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_email(
        "GET",
        "/v1/email/deliverability-dashboard/campaigns/$(CampaignId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_domain_statistics_report(domain, end_date, start_date)
    get_domain_statistics_report(domain, end_date, start_date, params::Dict{String,<:Any})

Retrieve inbox placement and engagement rates for the domains that you use to send email.

# Arguments
- `domain`: The domain that you want to obtain deliverability metrics for.
- `end_date`: The last day (in Unix time) that you want to obtain domain deliverability
  metrics for. The EndDate that you specify has to be less than or equal to 30 days after the
  StartDate.
- `start_date`: The first day (in Unix time) that you want to obtain domain deliverability
  metrics for.

"""
function get_domain_statistics_report(
    Domain, EndDate, StartDate; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_email(
        "GET",
        "/v1/email/deliverability-dashboard/statistics-report/$(Domain)",
        Dict{String,Any}("EndDate" => EndDate, "StartDate" => StartDate);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_domain_statistics_report(
    Domain,
    EndDate,
    StartDate,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_email(
        "GET",
        "/v1/email/deliverability-dashboard/statistics-report/$(Domain)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("EndDate" => EndDate, "StartDate" => StartDate),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_email_identity(email_identity)
    get_email_identity(email_identity, params::Dict{String,<:Any})

Provides information about a specific identity associated with your Amazon Pinpoint
account, including the identity's verification status, its DKIM authentication status, and
its custom Mail-From settings.

# Arguments
- `email_identity`: The email identity that you want to retrieve details for.

"""
function get_email_identity(
    EmailIdentity; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_email(
        "GET",
        "/v1/email/identities/$(EmailIdentity)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_email_identity(
    EmailIdentity,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_email(
        "GET",
        "/v1/email/identities/$(EmailIdentity)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_configuration_sets()
    list_configuration_sets(params::Dict{String,<:Any})

List all of the configuration sets associated with your Amazon Pinpoint account in the
current region. In Amazon Pinpoint, configuration sets are groups of rules that you can
apply to the emails you send. You apply a configuration set to an email by including a
reference to the configuration set in the headers of the email. When you apply a
configuration set to an email, all of the rules in that configuration set are applied to
the email.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: A token returned from a previous call to ListConfigurationSets to indicate
  the position in the list of configuration sets.
- `"PageSize"`: The number of results to show in a single call to ListConfigurationSets. If
  the number of results is larger than the number you specified in this parameter, then the
  response includes a NextToken element, which you can use to obtain additional results.
"""
function list_configuration_sets(; aws_config::AbstractAWSConfig=current_aws_config())
    return pinpoint_email(
        "GET",
        "/v1/email/configuration-sets";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_configuration_sets(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_email(
        "GET",
        "/v1/email/configuration-sets",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_dedicated_ip_pools()
    list_dedicated_ip_pools(params::Dict{String,<:Any})

List all of the dedicated IP pools that exist in your Amazon Pinpoint account in the
current AWS Region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: A token returned from a previous call to ListDedicatedIpPools to indicate
  the position in the list of dedicated IP pools.
- `"PageSize"`: The number of results to show in a single call to ListDedicatedIpPools. If
  the number of results is larger than the number you specified in this parameter, then the
  response includes a NextToken element, which you can use to obtain additional results.
"""
function list_dedicated_ip_pools(; aws_config::AbstractAWSConfig=current_aws_config())
    return pinpoint_email(
        "GET",
        "/v1/email/dedicated-ip-pools";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_dedicated_ip_pools(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_email(
        "GET",
        "/v1/email/dedicated-ip-pools",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_deliverability_test_reports()
    list_deliverability_test_reports(params::Dict{String,<:Any})

Show a list of the predictive inbox placement tests that you've performed, regardless of
their statuses. For predictive inbox placement tests that are complete, you can use the
GetDeliverabilityTestReport operation to view the results.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: A token returned from a previous call to ListDeliverabilityTestReports to
  indicate the position in the list of predictive inbox placement tests.
- `"PageSize"`: The number of results to show in a single call to
  ListDeliverabilityTestReports. If the number of results is larger than the number you
  specified in this parameter, then the response includes a NextToken element, which you can
  use to obtain additional results. The value you specify has to be at least 0, and can be no
  more than 1000.
"""
function list_deliverability_test_reports(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_email(
        "GET",
        "/v1/email/deliverability-dashboard/test-reports";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_deliverability_test_reports(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_email(
        "GET",
        "/v1/email/deliverability-dashboard/test-reports",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_domain_deliverability_campaigns(end_date, start_date, subscribed_domain)
    list_domain_deliverability_campaigns(end_date, start_date, subscribed_domain, params::Dict{String,<:Any})

Retrieve deliverability data for all the campaigns that used a specific domain to send
email during a specified time range. This data is available for a domain only if you
enabled the Deliverability dashboard (PutDeliverabilityDashboardOption operation) for the
domain.

# Arguments
- `end_date`: The last day, in Unix time format, that you want to obtain deliverability
  data for. This value has to be less than or equal to 30 days after the value of the
  StartDate parameter.
- `start_date`: The first day, in Unix time format, that you want to obtain deliverability
  data for.
- `subscribed_domain`: The domain to obtain deliverability data for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: A token that’s returned from a previous call to the
  ListDomainDeliverabilityCampaigns operation. This token indicates the position of a
  campaign in the list of campaigns.
- `"PageSize"`: The maximum number of results to include in response to a single call to
  the ListDomainDeliverabilityCampaigns operation. If the number of results is larger than
  the number that you specify in this parameter, the response includes a NextToken element,
  which you can use to obtain additional results.
"""
function list_domain_deliverability_campaigns(
    EndDate, StartDate, SubscribedDomain; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_email(
        "GET",
        "/v1/email/deliverability-dashboard/domains/$(SubscribedDomain)/campaigns",
        Dict{String,Any}("EndDate" => EndDate, "StartDate" => StartDate);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_domain_deliverability_campaigns(
    EndDate,
    StartDate,
    SubscribedDomain,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_email(
        "GET",
        "/v1/email/deliverability-dashboard/domains/$(SubscribedDomain)/campaigns",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("EndDate" => EndDate, "StartDate" => StartDate),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_email_identities()
    list_email_identities(params::Dict{String,<:Any})

Returns a list of all of the email identities that are associated with your Amazon Pinpoint
account. An identity can be either an email address or a domain. This operation returns
identities that are verified as well as those that aren't.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: A token returned from a previous call to ListEmailIdentities to indicate
  the position in the list of identities.
- `"PageSize"`: The number of results to show in a single call to ListEmailIdentities. If
  the number of results is larger than the number you specified in this parameter, then the
  response includes a NextToken element, which you can use to obtain additional results. The
  value you specify has to be at least 0, and can be no more than 1000.
"""
function list_email_identities(; aws_config::AbstractAWSConfig=current_aws_config())
    return pinpoint_email(
        "GET",
        "/v1/email/identities";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_email_identities(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_email(
        "GET",
        "/v1/email/identities",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Retrieve a list of the tags (keys and values) that are associated with a specified
resource. A tag is a label that you optionally define and associate with a resource in
Amazon Pinpoint. Each tag consists of a required tag key and an optional associated tag
value. A tag key is a general label that acts as a category for more specific tag values. A
tag value acts as a descriptor within a tag key.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource that you want to retrieve
  tag information for.

"""
function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_email(
        "GET",
        "/v1/email/tags",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_email(
        "GET",
        "/v1/email/tags",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_account_dedicated_ip_warmup_attributes()
    put_account_dedicated_ip_warmup_attributes(params::Dict{String,<:Any})

Enable or disable the automatic warm-up feature for dedicated IP addresses.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AutoWarmupEnabled"`: Enables or disables the automatic warm-up feature for dedicated IP
  addresses that are associated with your Amazon Pinpoint account in the current AWS Region.
  Set to true to enable the automatic warm-up feature, or set to false to disable it.
"""
function put_account_dedicated_ip_warmup_attributes(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_email(
        "PUT",
        "/v1/email/account/dedicated-ips/warmup";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_account_dedicated_ip_warmup_attributes(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_email(
        "PUT",
        "/v1/email/account/dedicated-ips/warmup",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_account_sending_attributes()
    put_account_sending_attributes(params::Dict{String,<:Any})

Enable or disable the ability of your account to send email.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"SendingEnabled"`: Enables or disables your account's ability to send email. Set to true
  to enable email sending, or set to false to disable email sending.  If AWS paused your
  account's ability to send email, you can't use this operation to resume your account's
  ability to send email.
"""
function put_account_sending_attributes(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_email(
        "PUT",
        "/v1/email/account/sending";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_account_sending_attributes(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_email(
        "PUT",
        "/v1/email/account/sending",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_configuration_set_delivery_options(configuration_set_name)
    put_configuration_set_delivery_options(configuration_set_name, params::Dict{String,<:Any})

Associate a configuration set with a dedicated IP pool. You can use dedicated IP pools to
create groups of dedicated IP addresses for sending specific types of email.

# Arguments
- `configuration_set_name`: The name of the configuration set that you want to associate
  with a dedicated IP pool.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"SendingPoolName"`: The name of the dedicated IP pool that you want to associate with
  the configuration set.
- `"TlsPolicy"`: Specifies whether messages that use the configuration set are required to
  use Transport Layer Security (TLS). If the value is Require, messages are only delivered if
  a TLS connection can be established. If the value is Optional, messages can be delivered in
  plain text if a TLS connection can't be established.
"""
function put_configuration_set_delivery_options(
    ConfigurationSetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_email(
        "PUT",
        "/v1/email/configuration-sets/$(ConfigurationSetName)/delivery-options";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_configuration_set_delivery_options(
    ConfigurationSetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_email(
        "PUT",
        "/v1/email/configuration-sets/$(ConfigurationSetName)/delivery-options",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_configuration_set_reputation_options(configuration_set_name)
    put_configuration_set_reputation_options(configuration_set_name, params::Dict{String,<:Any})

Enable or disable collection of reputation metrics for emails that you send using a
particular configuration set in a specific AWS Region.

# Arguments
- `configuration_set_name`: The name of the configuration set that you want to enable or
  disable reputation metric tracking for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ReputationMetricsEnabled"`: If true, tracking of reputation metrics is enabled for the
  configuration set. If false, tracking of reputation metrics is disabled for the
  configuration set.
"""
function put_configuration_set_reputation_options(
    ConfigurationSetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_email(
        "PUT",
        "/v1/email/configuration-sets/$(ConfigurationSetName)/reputation-options";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_configuration_set_reputation_options(
    ConfigurationSetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_email(
        "PUT",
        "/v1/email/configuration-sets/$(ConfigurationSetName)/reputation-options",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_configuration_set_sending_options(configuration_set_name)
    put_configuration_set_sending_options(configuration_set_name, params::Dict{String,<:Any})

Enable or disable email sending for messages that use a particular configuration set in a
specific AWS Region.

# Arguments
- `configuration_set_name`: The name of the configuration set that you want to enable or
  disable email sending for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"SendingEnabled"`: If true, email sending is enabled for the configuration set. If
  false, email sending is disabled for the configuration set.
"""
function put_configuration_set_sending_options(
    ConfigurationSetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_email(
        "PUT",
        "/v1/email/configuration-sets/$(ConfigurationSetName)/sending";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_configuration_set_sending_options(
    ConfigurationSetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_email(
        "PUT",
        "/v1/email/configuration-sets/$(ConfigurationSetName)/sending",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_configuration_set_tracking_options(configuration_set_name)
    put_configuration_set_tracking_options(configuration_set_name, params::Dict{String,<:Any})

Specify a custom domain to use for open and click tracking elements in email that you send
using Amazon Pinpoint.

# Arguments
- `configuration_set_name`: The name of the configuration set that you want to add a custom
  tracking domain to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CustomRedirectDomain"`: The domain that you want to use to track open and click events.
"""
function put_configuration_set_tracking_options(
    ConfigurationSetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_email(
        "PUT",
        "/v1/email/configuration-sets/$(ConfigurationSetName)/tracking-options";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_configuration_set_tracking_options(
    ConfigurationSetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_email(
        "PUT",
        "/v1/email/configuration-sets/$(ConfigurationSetName)/tracking-options",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_dedicated_ip_in_pool(destination_pool_name, ip)
    put_dedicated_ip_in_pool(destination_pool_name, ip, params::Dict{String,<:Any})

Move a dedicated IP address to an existing dedicated IP pool.  The dedicated IP address
that you specify must already exist, and must be associated with your Amazon Pinpoint
account.  The dedicated IP pool you specify must already exist. You can create a new pool
by using the CreateDedicatedIpPool operation.

# Arguments
- `destination_pool_name`: The name of the IP pool that you want to add the dedicated IP
  address to. You have to specify an IP pool that already exists.
- `ip`: The IP address that you want to move to the dedicated IP pool. The value you
  specify has to be a dedicated IP address that's associated with your Amazon Pinpoint
  account.

"""
function put_dedicated_ip_in_pool(
    DestinationPoolName, IP; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_email(
        "PUT",
        "/v1/email/dedicated-ips/$(IP)/pool",
        Dict{String,Any}("DestinationPoolName" => DestinationPoolName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_dedicated_ip_in_pool(
    DestinationPoolName,
    IP,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_email(
        "PUT",
        "/v1/email/dedicated-ips/$(IP)/pool",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DestinationPoolName" => DestinationPoolName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_dedicated_ip_warmup_attributes(ip, warmup_percentage)
    put_dedicated_ip_warmup_attributes(ip, warmup_percentage, params::Dict{String,<:Any})



# Arguments
- `ip`: The dedicated IP address that you want to update the warm-up attributes for.
- `warmup_percentage`: The warm-up percentage that you want to associate with the dedicated
  IP address.

"""
function put_dedicated_ip_warmup_attributes(
    IP, WarmupPercentage; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_email(
        "PUT",
        "/v1/email/dedicated-ips/$(IP)/warmup",
        Dict{String,Any}("WarmupPercentage" => WarmupPercentage);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_dedicated_ip_warmup_attributes(
    IP,
    WarmupPercentage,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_email(
        "PUT",
        "/v1/email/dedicated-ips/$(IP)/warmup",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("WarmupPercentage" => WarmupPercentage), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_deliverability_dashboard_option(dashboard_enabled)
    put_deliverability_dashboard_option(dashboard_enabled, params::Dict{String,<:Any})

Enable or disable the Deliverability dashboard for your Amazon Pinpoint account. When you
enable the Deliverability dashboard, you gain access to reputation, deliverability, and
other metrics for the domains that you use to send email using Amazon Pinpoint. You also
gain the ability to perform predictive inbox placement tests. When you use the
Deliverability dashboard, you pay a monthly subscription charge, in addition to any other
fees that you accrue by using Amazon Pinpoint. For more information about the features and
cost of a Deliverability dashboard subscription, see Amazon Pinpoint Pricing.

# Arguments
- `dashboard_enabled`: Specifies whether to enable the Deliverability dashboard for your
  Amazon Pinpoint account. To enable the dashboard, set this value to true.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"SubscribedDomains"`: An array of objects, one for each verified domain that you use to
  send email and enabled the Deliverability dashboard for.
"""
function put_deliverability_dashboard_option(
    DashboardEnabled; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_email(
        "PUT",
        "/v1/email/deliverability-dashboard",
        Dict{String,Any}("DashboardEnabled" => DashboardEnabled);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_deliverability_dashboard_option(
    DashboardEnabled,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_email(
        "PUT",
        "/v1/email/deliverability-dashboard",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("DashboardEnabled" => DashboardEnabled), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_email_identity_dkim_attributes(email_identity)
    put_email_identity_dkim_attributes(email_identity, params::Dict{String,<:Any})

Used to enable or disable DKIM authentication for an email identity.

# Arguments
- `email_identity`: The email identity that you want to change the DKIM settings for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"SigningEnabled"`: Sets the DKIM signing configuration for the identity. When you set
  this value true, then the messages that Amazon Pinpoint sends from the identity are
  DKIM-signed. When you set this value to false, then the messages that Amazon Pinpoint sends
  from the identity aren't DKIM-signed.
"""
function put_email_identity_dkim_attributes(
    EmailIdentity; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_email(
        "PUT",
        "/v1/email/identities/$(EmailIdentity)/dkim";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_email_identity_dkim_attributes(
    EmailIdentity,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_email(
        "PUT",
        "/v1/email/identities/$(EmailIdentity)/dkim",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_email_identity_feedback_attributes(email_identity)
    put_email_identity_feedback_attributes(email_identity, params::Dict{String,<:Any})

Used to enable or disable feedback forwarding for an identity. This setting determines what
happens when an identity is used to send an email that results in a bounce or complaint
event. When you enable feedback forwarding, Amazon Pinpoint sends you email notifications
when bounce or complaint events occur. Amazon Pinpoint sends this notification to the
address that you specified in the Return-Path header of the original email. When you
disable feedback forwarding, Amazon Pinpoint sends notifications through other mechanisms,
such as by notifying an Amazon SNS topic. You're required to have a method of tracking
bounces and complaints. If you haven't set up another mechanism for receiving bounce or
complaint notifications, Amazon Pinpoint sends an email notification when these events
occur (even if this setting is disabled).

# Arguments
- `email_identity`: The email identity that you want to configure bounce and complaint
  feedback forwarding for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EmailForwardingEnabled"`: Sets the feedback forwarding configuration for the identity.
  If the value is true, Amazon Pinpoint sends you email notifications when bounce or
  complaint events occur. Amazon Pinpoint sends this notification to the address that you
  specified in the Return-Path header of the original email. When you set this value to
  false, Amazon Pinpoint sends notifications through other mechanisms, such as by notifying
  an Amazon SNS topic or another event destination. You're required to have a method of
  tracking bounces and complaints. If you haven't set up another mechanism for receiving
  bounce or complaint notifications, Amazon Pinpoint sends an email notification when these
  events occur (even if this setting is disabled).
"""
function put_email_identity_feedback_attributes(
    EmailIdentity; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_email(
        "PUT",
        "/v1/email/identities/$(EmailIdentity)/feedback";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_email_identity_feedback_attributes(
    EmailIdentity,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_email(
        "PUT",
        "/v1/email/identities/$(EmailIdentity)/feedback",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_email_identity_mail_from_attributes(email_identity)
    put_email_identity_mail_from_attributes(email_identity, params::Dict{String,<:Any})

Used to enable or disable the custom Mail-From domain configuration for an email identity.

# Arguments
- `email_identity`: The verified email identity that you want to set up the custom MAIL
  FROM domain for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"BehaviorOnMxFailure"`: The action that you want Amazon Pinpoint to take if it can't
  read the required MX record when you send an email. When you set this value to
  UseDefaultValue, Amazon Pinpoint uses amazonses.com as the MAIL FROM domain. When you set
  this value to RejectMessage, Amazon Pinpoint returns a MailFromDomainNotVerified error, and
  doesn't attempt to deliver the email. These behaviors are taken when the custom MAIL FROM
  domain configuration is in the Pending, Failed, and TemporaryFailure states.
- `"MailFromDomain"`:  The custom MAIL FROM domain that you want the verified identity to
  use. The MAIL FROM domain must meet the following criteria:   It has to be a subdomain of
  the verified identity.   It can't be used to receive email.   It can't be used in a
  \"From\" address if the MAIL FROM domain is a destination for feedback forwarding emails.
"""
function put_email_identity_mail_from_attributes(
    EmailIdentity; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_email(
        "PUT",
        "/v1/email/identities/$(EmailIdentity)/mail-from";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_email_identity_mail_from_attributes(
    EmailIdentity,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_email(
        "PUT",
        "/v1/email/identities/$(EmailIdentity)/mail-from",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    send_email(content, destination)
    send_email(content, destination, params::Dict{String,<:Any})

Sends an email message. You can use the Amazon Pinpoint Email API to send two types of
messages:    Simple – A standard email message. When you create this type of message, you
specify the sender, the recipient, and the message body, and Amazon Pinpoint assembles the
message for you.    Raw – A raw, MIME-formatted email message. When you send this type of
email, you have to specify all of the message headers, as well as the message body. You can
use this message type to send messages that contain attachments. The message that you
specify has to be a valid MIME message.

# Arguments
- `content`: An object that contains the body of the message. You can send either a Simple
  message or a Raw message.
- `destination`: An object that contains the recipients of the email message.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConfigurationSetName"`: The name of the configuration set that you want to use when
  sending the email.
- `"EmailTags"`: A list of tags, in the form of name/value pairs, to apply to an email that
  you send using the SendEmail operation. Tags correspond to characteristics of the email
  that you define, so that you can publish email sending events.
- `"FeedbackForwardingEmailAddress"`: The address that Amazon Pinpoint should send bounce
  and complaint notifications to.
- `"FromEmailAddress"`: The email address that you want to use as the \"From\" address for
  the email. The address that you specify has to be verified.
- `"ReplyToAddresses"`: The \"Reply-to\" email addresses for the message. When the
  recipient replies to the message, each Reply-to address receives the reply.
"""
function send_email(
    Content, Destination; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_email(
        "POST",
        "/v1/email/outbound-emails",
        Dict{String,Any}("Content" => Content, "Destination" => Destination);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function send_email(
    Content,
    Destination,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_email(
        "POST",
        "/v1/email/outbound-emails",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Content" => Content, "Destination" => Destination),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Add one or more tags (keys and values) to a specified resource. A tag is a label that you
optionally define and associate with a resource in Amazon Pinpoint. Tags can help you
categorize and manage resources in different ways, such as by purpose, owner, environment,
or other criteria. A resource can have as many as 50 tags. Each tag consists of a
required tag key and an associated tag value, both of which you define. A tag key is a
general label that acts as a category for more specific tag values. A tag value acts as a
descriptor within a tag key.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource that you want to add one
  or more tags to.
- `tags`: A list of the tags that you want to add to the resource. A tag consists of a
  required tag key (Key) and an associated tag value (Value). The maximum length of a tag key
  is 128 characters. The maximum length of a tag value is 256 characters.

"""
function tag_resource(ResourceArn, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return pinpoint_email(
        "POST",
        "/v1/email/tags",
        Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceArn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_email(
        "POST",
        "/v1/email/tags",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Remove one or more tags (keys and values) from a specified resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource that you want to remove
  one or more tags from.
- `tag_keys`: The tags (tag keys) that you want to remove from the resource. When you
  specify a tag key, the action removes both that key and its associated tag value. To remove
  more than one tag from the resource, append the TagKeys parameter and argument for each
  additional tag to remove, separated by an ampersand. For example:
  /v1/email/tags?ResourceArn=ResourceArn&amp;TagKeys=Key1&amp;TagKeys=Key2

"""
function untag_resource(
    ResourceArn, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_email(
        "DELETE",
        "/v1/email/tags",
        Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceArn,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_email(
        "DELETE",
        "/v1/email/tags",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_configuration_set_event_destination(configuration_set_name, event_destination, event_destination_name)
    update_configuration_set_event_destination(configuration_set_name, event_destination, event_destination_name, params::Dict{String,<:Any})

Update the configuration of an event destination for a configuration set. In Amazon
Pinpoint, events include message sends, deliveries, opens, clicks, bounces, and complaints.
Event destinations are places that you can send information about these events to. For
example, you can send event data to Amazon SNS to receive notifications when you receive
bounces or complaints, or you can use Amazon Kinesis Data Firehose to stream data to Amazon
S3 for long-term storage.

# Arguments
- `configuration_set_name`: The name of the configuration set that contains the event
  destination that you want to modify.
- `event_destination`: An object that defines the event destination.
- `event_destination_name`: The name of the event destination that you want to modify.

"""
function update_configuration_set_event_destination(
    ConfigurationSetName,
    EventDestination,
    EventDestinationName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_email(
        "PUT",
        "/v1/email/configuration-sets/$(ConfigurationSetName)/event-destinations/$(EventDestinationName)",
        Dict{String,Any}("EventDestination" => EventDestination);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_configuration_set_event_destination(
    ConfigurationSetName,
    EventDestination,
    EventDestinationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_email(
        "PUT",
        "/v1/email/configuration-sets/$(ConfigurationSetName)/event-destinations/$(EventDestinationName)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("EventDestination" => EventDestination), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: sagemaker_featurestore_runtime
using AWS.Compat
using AWS.UUIDs

"""
    batch_get_record(identifiers)
    batch_get_record(identifiers, params::Dict{String,<:Any})

Retrieves a batch of Records from a FeatureGroup.

# Arguments
- `identifiers`: A list containing the name or Amazon Resource Name (ARN) of the
  FeatureGroup, the list of names of Features to be retrieved, and the corresponding
  RecordIdentifier values as strings.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ExpirationTimeResponse"`: Parameter to request ExpiresAt in response. If Enabled,
  BatchGetRecord will return the value of ExpiresAt, if it is not null. If Disabled and null,
  BatchGetRecord will return null.
"""
function batch_get_record(Identifiers; aws_config::AbstractAWSConfig=current_aws_config())
    return sagemaker_featurestore_runtime(
        "POST",
        "/BatchGetRecord",
        Dict{String,Any}("Identifiers" => Identifiers);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_record(
    Identifiers,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sagemaker_featurestore_runtime(
        "POST",
        "/BatchGetRecord",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Identifiers" => Identifiers), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_record(event_time, feature_group_name, record_identifier_value_as_string)
    delete_record(event_time, feature_group_name, record_identifier_value_as_string, params::Dict{String,<:Any})

Deletes a Record from a FeatureGroup in the OnlineStore. Feature Store supports both
SoftDelete and HardDelete. For SoftDelete (default), feature columns are set to null and
the record is no longer retrievable by GetRecord or BatchGetRecord. For HardDelete, the
complete Record is removed from the OnlineStore. In both cases, Feature Store appends the
deleted record marker to the OfflineStore. The deleted record marker is a record with the
same RecordIdentifer as the original, but with is_deleted value set to True, EventTime set
to the delete input EventTime, and other feature values set to null. Note that the
EventTime specified in DeleteRecord should be set later than the EventTime of the existing
record in the OnlineStore for that RecordIdentifer. If it is not, the deletion does not
occur:   For SoftDelete, the existing (not deleted) record remains in the OnlineStore,
though the delete record marker is still written to the OfflineStore.    HardDelete returns
EventTime: 400 ValidationException to indicate that the delete operation failed. No delete
record marker is written to the OfflineStore.   When a record is deleted from the
OnlineStore, the deleted record marker is appended to the OfflineStore. If you have the
Iceberg table format enabled for your OfflineStore, you can remove all history of a record
from the OfflineStore using Amazon Athena or Apache Spark. For information on how to hard
delete a record from the OfflineStore with the Iceberg table format enabled, see Delete
records from the offline store.

# Arguments
- `event_time`: Timestamp indicating when the deletion event occurred. EventTime can be
  used to query data at a certain point in time.
- `feature_group_name`: The name or Amazon Resource Name (ARN) of the feature group to
  delete the record from.
- `record_identifier_value_as_string`: The value for the RecordIdentifier that uniquely
  identifies the record, in string format.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DeletionMode"`: The name of the deletion mode for deleting the record. By default, the
  deletion mode is set to SoftDelete.
- `"TargetStores"`: A list of stores from which you're deleting the record. By default,
  Feature Store deletes the record from all of the stores that you're using for the
  FeatureGroup.
"""
function delete_record(
    EventTime,
    FeatureGroupName,
    RecordIdentifierValueAsString;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sagemaker_featurestore_runtime(
        "DELETE",
        "/FeatureGroup/$(FeatureGroupName)",
        Dict{String,Any}(
            "EventTime" => EventTime,
            "RecordIdentifierValueAsString" => RecordIdentifierValueAsString,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_record(
    EventTime,
    FeatureGroupName,
    RecordIdentifierValueAsString,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sagemaker_featurestore_runtime(
        "DELETE",
        "/FeatureGroup/$(FeatureGroupName)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EventTime" => EventTime,
                    "RecordIdentifierValueAsString" => RecordIdentifierValueAsString,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_record(feature_group_name, record_identifier_value_as_string)
    get_record(feature_group_name, record_identifier_value_as_string, params::Dict{String,<:Any})

Use for OnlineStore serving from a FeatureStore. Only the latest records stored in the
OnlineStore can be retrieved. If no Record with RecordIdentifierValue is found, then an
empty result is returned.

# Arguments
- `feature_group_name`: The name or Amazon Resource Name (ARN) of the feature group from
  which you want to retrieve a record.
- `record_identifier_value_as_string`: The value that corresponds to RecordIdentifier type
  and uniquely identifies the record in the FeatureGroup.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ExpirationTimeResponse"`: Parameter to request ExpiresAt in response. If Enabled,
  GetRecord will return the value of ExpiresAt, if it is not null. If Disabled and null,
  GetRecord will return null.
- `"FeatureName"`: List of names of Features to be retrieved. If not specified, the latest
  value for all the Features are returned.
"""
function get_record(
    FeatureGroupName,
    RecordIdentifierValueAsString;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sagemaker_featurestore_runtime(
        "GET",
        "/FeatureGroup/$(FeatureGroupName)",
        Dict{String,Any}("RecordIdentifierValueAsString" => RecordIdentifierValueAsString);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_record(
    FeatureGroupName,
    RecordIdentifierValueAsString,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sagemaker_featurestore_runtime(
        "GET",
        "/FeatureGroup/$(FeatureGroupName)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "RecordIdentifierValueAsString" => RecordIdentifierValueAsString
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_record(feature_group_name, record)
    put_record(feature_group_name, record, params::Dict{String,<:Any})

The PutRecord API is used to ingest a list of Records into your feature group.  If a new
record’s EventTime is greater, the new record is written to both the OnlineStore and
OfflineStore. Otherwise, the record is a historic record and it is written only to the
OfflineStore.  You can specify the ingestion to be applied to the OnlineStore,
OfflineStore, or both by using the TargetStores request parameter.  You can set the
ingested record to expire at a given time to live (TTL) duration after the record’s event
time, ExpiresAt = EventTime + TtlDuration, by specifying the TtlDuration parameter. A
record level TtlDuration is set when specifying the TtlDuration parameter using the
PutRecord API call. If the input TtlDuration is null or unspecified, TtlDuration is set to
the default feature group level TtlDuration. A record level TtlDuration supersedes the
group level TtlDuration.

# Arguments
- `feature_group_name`: The name or Amazon Resource Name (ARN) of the feature group that
  you want to insert the record into.
- `record`: List of FeatureValues to be inserted. This will be a full over-write. If you
  only want to update few of the feature values, do the following:   Use GetRecord to
  retrieve the latest record.   Update the record returned from GetRecord.    Use PutRecord
  to update feature values.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"TargetStores"`: A list of stores to which you're adding the record. By default, Feature
  Store adds the record to all of the stores that you're using for the FeatureGroup.
- `"TtlDuration"`: Time to live duration, where the record is hard deleted after the
  expiration time is reached; ExpiresAt = EventTime + TtlDuration. For information on
  HardDelete, see the DeleteRecord API in the Amazon SageMaker API Reference guide.
"""
function put_record(
    FeatureGroupName, Record; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sagemaker_featurestore_runtime(
        "PUT",
        "/FeatureGroup/$(FeatureGroupName)",
        Dict{String,Any}("Record" => Record);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_record(
    FeatureGroupName,
    Record,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sagemaker_featurestore_runtime(
        "PUT",
        "/FeatureGroup/$(FeatureGroupName)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Record" => Record), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: route53_recovery_cluster
using AWS.Compat
using AWS.UUIDs

"""
    get_routing_control_state(routing_control_arn)
    get_routing_control_state(routing_control_arn, params::Dict{String,<:Any})

Get the state for a routing control. A routing control is a simple on/off switch that you
can use to route traffic to cells. When a routing control state is set to ON, traffic flows
to a cell. When the state is set to OFF, traffic does not flow.  Before you can create a
routing control, you must first create a cluster, and then host the control in a control
panel on the cluster. For more information, see  Create routing control structures in the
Amazon Route 53 Application Recovery Controller Developer Guide. You access one of the
endpoints for the cluster to get or update the routing control state to redirect traffic
for your application.   You must specify Regional endpoints when you work with API cluster
operations to get or update routing control states in Route 53 ARC.  To see a code example
for getting a routing control state, including accessing Regional cluster endpoints in
sequence, see API examples in the Amazon Route 53 Application Recovery Controller Developer
Guide. Learn more about working with routing controls in the following topics in the Amazon
Route 53 Application Recovery Controller Developer Guide:     Viewing and updating routing
control states     Working with routing controls in Route 53 ARC

# Arguments
- `routing_control_arn`: The Amazon Resource Name (ARN) for the routing control that you
  want to get the state for.

"""
function get_routing_control_state(
    RoutingControlArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53_recovery_cluster(
        "GetRoutingControlState",
        Dict{String,Any}("RoutingControlArn" => RoutingControlArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_routing_control_state(
    RoutingControlArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53_recovery_cluster(
        "GetRoutingControlState",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("RoutingControlArn" => RoutingControlArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_routing_controls()
    list_routing_controls(params::Dict{String,<:Any})

List routing control names and Amazon Resource Names (ARNs), as well as the routing control
state for each routing control, along with the control panel name and control panel ARN for
the routing controls. If you specify a control panel ARN, this call lists the routing
controls in the control panel. Otherwise, it lists all the routing controls in the cluster.
A routing control is a simple on/off switch in Route 53 ARC that you can use to route
traffic to cells. When a routing control state is set to ON, traffic flows to a cell. When
the state is set to OFF, traffic does not flow. Before you can create a routing control,
you must first create a cluster, and then host the control in a control panel on the
cluster. For more information, see  Create routing control structures in the Amazon Route
53 Application Recovery Controller Developer Guide. You access one of the endpoints for the
cluster to get or update the routing control state to redirect traffic for your
application.   You must specify Regional endpoints when you work with API cluster
operations to use this API operation to list routing controls in Route 53 ARC.  Learn more
about working with routing controls in the following topics in the Amazon Route 53
Application Recovery Controller Developer Guide:     Viewing and updating routing control
states     Working with routing controls in Route 53 ARC

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ControlPanelArn"`: The Amazon Resource Name (ARN) of the control panel of the routing
  controls to list.
- `"MaxResults"`: The number of routing controls objects that you want to return with this
  call. The default value is 500.
- `"NextToken"`: The token for the next set of results. You receive this token from a
  previous call.
"""
function list_routing_controls(; aws_config::AbstractAWSConfig=current_aws_config())
    return route53_recovery_cluster(
        "ListRoutingControls"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_routing_controls(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53_recovery_cluster(
        "ListRoutingControls",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_routing_control_state(routing_control_arn, routing_control_state)
    update_routing_control_state(routing_control_arn, routing_control_state, params::Dict{String,<:Any})

Set the state of the routing control to reroute traffic. You can set the value to ON or
OFF. When the state is ON, traffic flows to a cell. When the state is OFF, traffic does not
flow. With Route 53 ARC, you can add safety rules for routing controls, which are
safeguards for routing control state updates that help prevent unexpected outcomes, like
fail open traffic routing. However, there are scenarios when you might want to bypass the
routing control safeguards that are enforced with safety rules that you've configured. For
example, you might want to fail over quickly for disaster recovery, and one or more safety
rules might be unexpectedly preventing you from updating a routing control state to reroute
traffic. In a \"break glass\" scenario like this, you can override one or more safety rules
to change a routing control state and fail over your application. The SafetyRulesToOverride
property enables you override one or more safety rules and update routing control states.
For more information, see  Override safety rules to reroute traffic in the Amazon Route 53
Application Recovery Controller Developer Guide.  You must specify Regional endpoints when
you work with API cluster operations to get or update routing control states in Route 53
ARC.  To see a code example for getting a routing control state, including accessing
Regional cluster endpoints in sequence, see API examples in the Amazon Route 53 Application
Recovery Controller Developer Guide.     Viewing and updating routing control states
Working with routing controls overall

# Arguments
- `routing_control_arn`: The Amazon Resource Name (ARN) for the routing control that you
  want to update the state for.
- `routing_control_state`: The state of the routing control. You can set the value to ON or
  OFF.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"SafetyRulesToOverride"`: The Amazon Resource Names (ARNs) for the safety rules that you
  want to override when you're updating the state of a routing control. You can override one
  safety rule or multiple safety rules by including one or more ARNs, separated by commas.
  For more information, see  Override safety rules to reroute traffic in the Amazon Route 53
  Application Recovery Controller Developer Guide.
"""
function update_routing_control_state(
    RoutingControlArn,
    RoutingControlState;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53_recovery_cluster(
        "UpdateRoutingControlState",
        Dict{String,Any}(
            "RoutingControlArn" => RoutingControlArn,
            "RoutingControlState" => RoutingControlState,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_routing_control_state(
    RoutingControlArn,
    RoutingControlState,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53_recovery_cluster(
        "UpdateRoutingControlState",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "RoutingControlArn" => RoutingControlArn,
                    "RoutingControlState" => RoutingControlState,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_routing_control_states(update_routing_control_state_entries)
    update_routing_control_states(update_routing_control_state_entries, params::Dict{String,<:Any})

Set multiple routing control states. You can set the value for each state to be ON or OFF.
When the state is ON, traffic flows to a cell. When it's OFF, traffic does not flow. With
Route 53 ARC, you can add safety rules for routing controls, which are safeguards for
routing control state updates that help prevent unexpected outcomes, like fail open traffic
routing. However, there are scenarios when you might want to bypass the routing control
safeguards that are enforced with safety rules that you've configured. For example, you
might want to fail over quickly for disaster recovery, and one or more safety rules might
be unexpectedly preventing you from updating a routing control state to reroute traffic. In
a \"break glass\" scenario like this, you can override one or more safety rules to change a
routing control state and fail over your application. The SafetyRulesToOverride property
enables you override one or more safety rules and update routing control states. For more
information, see  Override safety rules to reroute traffic in the Amazon Route 53
Application Recovery Controller Developer Guide.  You must specify Regional endpoints when
you work with API cluster operations to get or update routing control states in Route 53
ARC.  To see a code example for getting a routing control state, including accessing
Regional cluster endpoints in sequence, see API examples in the Amazon Route 53 Application
Recovery Controller Developer Guide.     Viewing and updating routing control states
Working with routing controls overall

# Arguments
- `update_routing_control_state_entries`: A set of routing control entries that you want to
  update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"SafetyRulesToOverride"`: The Amazon Resource Names (ARNs) for the safety rules that you
  want to override when you're updating routing control states. You can override one safety
  rule or multiple safety rules by including one or more ARNs, separated by commas. For more
  information, see  Override safety rules to reroute traffic in the Amazon Route 53
  Application Recovery Controller Developer Guide.
"""
function update_routing_control_states(
    UpdateRoutingControlStateEntries; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53_recovery_cluster(
        "UpdateRoutingControlStates",
        Dict{String,Any}(
            "UpdateRoutingControlStateEntries" => UpdateRoutingControlStateEntries
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_routing_control_states(
    UpdateRoutingControlStateEntries,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53_recovery_cluster(
        "UpdateRoutingControlStates",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "UpdateRoutingControlStateEntries" => UpdateRoutingControlStateEntries
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: ivs
using AWS.Compat
using AWS.UUIDs

"""
    batch_get_channel(arns)
    batch_get_channel(arns, params::Dict{String,<:Any})

Performs GetChannel on multiple ARNs simultaneously.

# Arguments
- `arns`: Array of ARNs, one per channel.

"""
function batch_get_channel(arns; aws_config::AbstractAWSConfig=current_aws_config())
    return ivs(
        "POST",
        "/BatchGetChannel",
        Dict{String,Any}("arns" => arns);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_channel(
    arns, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs(
        "POST",
        "/BatchGetChannel",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arns" => arns), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_get_stream_key(arns)
    batch_get_stream_key(arns, params::Dict{String,<:Any})

Performs GetStreamKey on multiple ARNs simultaneously.

# Arguments
- `arns`: Array of ARNs, one per stream key.

"""
function batch_get_stream_key(arns; aws_config::AbstractAWSConfig=current_aws_config())
    return ivs(
        "POST",
        "/BatchGetStreamKey",
        Dict{String,Any}("arns" => arns);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_stream_key(
    arns, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs(
        "POST",
        "/BatchGetStreamKey",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arns" => arns), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_start_viewer_session_revocation(viewer_sessions)
    batch_start_viewer_session_revocation(viewer_sessions, params::Dict{String,<:Any})

Performs StartViewerSessionRevocation on multiple channel ARN and viewer ID pairs
simultaneously.

# Arguments
- `viewer_sessions`: Array of viewer sessions, one per channel-ARN and viewer-ID pair.

"""
function batch_start_viewer_session_revocation(
    viewerSessions; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs(
        "POST",
        "/BatchStartViewerSessionRevocation",
        Dict{String,Any}("viewerSessions" => viewerSessions);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_start_viewer_session_revocation(
    viewerSessions,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ivs(
        "POST",
        "/BatchStartViewerSessionRevocation",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("viewerSessions" => viewerSessions), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_channel()
    create_channel(params::Dict{String,<:Any})

Creates a new channel and an associated stream key to start streaming.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"authorized"`: Whether the channel is private (enabled for playback authorization).
  Default: false.
- `"insecureIngest"`: Whether the channel allows insecure RTMP and SRT ingest. Default:
  false.
- `"latencyMode"`: Channel latency mode. Use NORMAL to broadcast and deliver live video up
  to Full HD. Use LOW for near-real-time interaction with viewers. Default: LOW.
- `"name"`: Channel name.
- `"playbackRestrictionPolicyArn"`: Playback-restriction-policy ARN. A valid ARN value here
  both specifies the ARN and enables playback restriction. Default: \"\" (empty string, no
  playback restriction policy is applied).
- `"preset"`: Optional transcode preset for the channel. This is selectable only for
  ADVANCED_HD and ADVANCED_SD channel types. For those channel types, the default preset is
  HIGHER_BANDWIDTH_DELIVERY. For other channel types (BASIC and STANDARD), preset is the
  empty string (\"\").
- `"recordingConfigurationArn"`: Recording-configuration ARN. A valid ARN value here both
  specifies the ARN and enables recording. Default: \"\" (empty string, recording is
  disabled).
- `"tags"`: Array of 1-50 maps, each of the form string:string (key:value). See Tagging
  Amazon Web Services Resources for more information, including restrictions that apply to
  tags and \"Tag naming limits and requirements\"; Amazon IVS has no service-specific
  constraints beyond what is documented there.
- `"type"`: Channel type, which determines the allowable resolution and bitrate. If you
  exceed the allowable input resolution or bitrate, the stream probably will disconnect
  immediately. Default: STANDARD. For details, see Channel Types.
"""
function create_channel(; aws_config::AbstractAWSConfig=current_aws_config())
    return ivs(
        "POST", "/CreateChannel"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function create_channel(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs(
        "POST",
        "/CreateChannel",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_playback_restriction_policy()
    create_playback_restriction_policy(params::Dict{String,<:Any})

Creates a new playback restriction policy, for constraining playback by countries and/or
origins.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"allowedCountries"`: A list of country codes that control geoblocking restriction.
  Allowed values are the officially assigned ISO 3166-1 alpha-2 codes. Default: All countries
  (an empty array).
- `"allowedOrigins"`: A list of origin sites that control CORS restriction. Allowed values
  are the same as valid values of the Origin header defined at
  https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Origin. Default: All origins (an
  empty array).
- `"enableStrictOriginEnforcement"`: Whether channel playback is constrained by origin
  site. Default: false.
- `"name"`: Playback-restriction-policy name. The value does not need to be unique.
- `"tags"`: Array of 1-50 maps, each of the form string:string (key:value). See Tagging
  Amazon Web Services Resources for more information, including restrictions that apply to
  tags and \"Tag naming limits and requirements\"; Amazon IVS has no service-specific
  constraints beyond what is documented there.
"""
function create_playback_restriction_policy(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs(
        "POST",
        "/CreatePlaybackRestrictionPolicy";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_playback_restriction_policy(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs(
        "POST",
        "/CreatePlaybackRestrictionPolicy",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_recording_configuration(destination_configuration)
    create_recording_configuration(destination_configuration, params::Dict{String,<:Any})

Creates a new recording configuration, used to enable recording to Amazon S3.  Known issue:
In the us-east-1 region, if you use the Amazon Web Services CLI to create a recording
configuration, it returns success even if the S3 bucket is in a different region. In this
case, the state of the recording configuration is CREATE_FAILED (instead of ACTIVE). (In
other regions, the CLI correctly returns failure if the bucket is in a different region.)
Workaround: Ensure that your S3 bucket is in the same region as the recording
configuration. If you create a recording configuration in a different region as your S3
bucket, delete that recording configuration and create a new one with an S3 bucket from the
correct region.

# Arguments
- `destination_configuration`: A complex type that contains a destination configuration for
  where recorded video will be stored.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"name"`: Recording-configuration name. The value does not need to be unique.
- `"recordingReconnectWindowSeconds"`: If a broadcast disconnects and then reconnects
  within the specified interval, the multiple streams will be considered a single broadcast
  and merged together. Default: 0.
- `"renditionConfiguration"`: Object that describes which renditions should be recorded for
  a stream.
- `"tags"`: Array of 1-50 maps, each of the form string:string (key:value). See Tagging
  Amazon Web Services Resources for more information, including restrictions that apply to
  tags and \"Tag naming limits and requirements\"; Amazon IVS has no service-specific
  constraints beyond what is documented there.
- `"thumbnailConfiguration"`: A complex type that allows you to enable/disable the
  recording of thumbnails for a live session and modify the interval at which thumbnails are
  generated for the live session.
"""
function create_recording_configuration(
    destinationConfiguration; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs(
        "POST",
        "/CreateRecordingConfiguration",
        Dict{String,Any}("destinationConfiguration" => destinationConfiguration);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_recording_configuration(
    destinationConfiguration,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ivs(
        "POST",
        "/CreateRecordingConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("destinationConfiguration" => destinationConfiguration),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_stream_key(channel_arn)
    create_stream_key(channel_arn, params::Dict{String,<:Any})

Creates a stream key, used to initiate a stream, for the specified channel ARN. Note that
CreateChannel creates a stream key. If you subsequently use CreateStreamKey on the same
channel, it will fail because a stream key already exists and there is a limit of 1 stream
key per channel. To reset the stream key on a channel, use DeleteStreamKey and then
CreateStreamKey.

# Arguments
- `channel_arn`: ARN of the channel for which to create the stream key.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tags"`: Array of 1-50 maps, each of the form string:string (key:value). See Tagging
  Amazon Web Services Resources for more information, including restrictions that apply to
  tags and \"Tag naming limits and requirements\"; Amazon IVS has no service-specific
  constraints beyond what is documented there.
"""
function create_stream_key(channelArn; aws_config::AbstractAWSConfig=current_aws_config())
    return ivs(
        "POST",
        "/CreateStreamKey",
        Dict{String,Any}("channelArn" => channelArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_stream_key(
    channelArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ivs(
        "POST",
        "/CreateStreamKey",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("channelArn" => channelArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_channel(arn)
    delete_channel(arn, params::Dict{String,<:Any})

Deletes the specified channel and its associated stream keys. If you try to delete a live
channel, you will get an error (409 ConflictException). To delete a channel that is live,
call StopStream, wait for the Amazon EventBridge \"Stream End\" event (to verify that the
stream's state is no longer Live), then call DeleteChannel. (See  Using EventBridge with
Amazon IVS.)

# Arguments
- `arn`: ARN of the channel to be deleted.

"""
function delete_channel(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return ivs(
        "POST",
        "/DeleteChannel",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_channel(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs(
        "POST",
        "/DeleteChannel",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_playback_key_pair(arn)
    delete_playback_key_pair(arn, params::Dict{String,<:Any})

Deletes a specified authorization key pair. This invalidates future viewer tokens generated
using the key pair’s privateKey. For more information, see Setting Up Private Channels in
the Amazon IVS User Guide.

# Arguments
- `arn`: ARN of the key pair to be deleted.

"""
function delete_playback_key_pair(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return ivs(
        "POST",
        "/DeletePlaybackKeyPair",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_playback_key_pair(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs(
        "POST",
        "/DeletePlaybackKeyPair",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_playback_restriction_policy(arn)
    delete_playback_restriction_policy(arn, params::Dict{String,<:Any})

Deletes the specified playback restriction policy.

# Arguments
- `arn`: ARN of the playback restriction policy to be deleted.

"""
function delete_playback_restriction_policy(
    arn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs(
        "POST",
        "/DeletePlaybackRestrictionPolicy",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_playback_restriction_policy(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs(
        "POST",
        "/DeletePlaybackRestrictionPolicy",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_recording_configuration(arn)
    delete_recording_configuration(arn, params::Dict{String,<:Any})

Deletes the recording configuration for the specified ARN. If you try to delete a recording
configuration that is associated with a channel, you will get an error (409
ConflictException). To avoid this, for all channels that reference the recording
configuration, first use UpdateChannel to set the recordingConfigurationArn field to an
empty string, then use DeleteRecordingConfiguration.

# Arguments
- `arn`: ARN of the recording configuration to be deleted.

"""
function delete_recording_configuration(
    arn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs(
        "POST",
        "/DeleteRecordingConfiguration",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_recording_configuration(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs(
        "POST",
        "/DeleteRecordingConfiguration",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_stream_key(arn)
    delete_stream_key(arn, params::Dict{String,<:Any})

Deletes the stream key for the specified ARN, so it can no longer be used to stream.

# Arguments
- `arn`: ARN of the stream key to be deleted.

"""
function delete_stream_key(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return ivs(
        "POST",
        "/DeleteStreamKey",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_stream_key(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs(
        "POST",
        "/DeleteStreamKey",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_channel(arn)
    get_channel(arn, params::Dict{String,<:Any})

Gets the channel configuration for the specified channel ARN. See also BatchGetChannel.

# Arguments
- `arn`: ARN of the channel for which the configuration is to be retrieved.

"""
function get_channel(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return ivs(
        "POST",
        "/GetChannel",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_channel(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs(
        "POST",
        "/GetChannel",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_playback_key_pair(arn)
    get_playback_key_pair(arn, params::Dict{String,<:Any})

Gets a specified playback authorization key pair and returns the arn and fingerprint. The
privateKey held by the caller can be used to generate viewer authorization tokens, to grant
viewers access to private channels. For more information, see Setting Up Private Channels
in the Amazon IVS User Guide.

# Arguments
- `arn`: ARN of the key pair to be returned.

"""
function get_playback_key_pair(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return ivs(
        "POST",
        "/GetPlaybackKeyPair",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_playback_key_pair(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs(
        "POST",
        "/GetPlaybackKeyPair",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_playback_restriction_policy(arn)
    get_playback_restriction_policy(arn, params::Dict{String,<:Any})

Gets the specified playback restriction policy.

# Arguments
- `arn`: ARN of the playback restriction policy to be returned.

"""
function get_playback_restriction_policy(
    arn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs(
        "POST",
        "/GetPlaybackRestrictionPolicy",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_playback_restriction_policy(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs(
        "POST",
        "/GetPlaybackRestrictionPolicy",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_recording_configuration(arn)
    get_recording_configuration(arn, params::Dict{String,<:Any})

Gets the recording configuration for the specified ARN.

# Arguments
- `arn`: ARN of the recording configuration to be retrieved.

"""
function get_recording_configuration(
    arn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs(
        "POST",
        "/GetRecordingConfiguration",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_recording_configuration(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs(
        "POST",
        "/GetRecordingConfiguration",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_stream(channel_arn)
    get_stream(channel_arn, params::Dict{String,<:Any})

Gets information about the active (live) stream on a specified channel.

# Arguments
- `channel_arn`: Channel ARN for stream to be accessed.

"""
function get_stream(channelArn; aws_config::AbstractAWSConfig=current_aws_config())
    return ivs(
        "POST",
        "/GetStream",
        Dict{String,Any}("channelArn" => channelArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_stream(
    channelArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ivs(
        "POST",
        "/GetStream",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("channelArn" => channelArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_stream_key(arn)
    get_stream_key(arn, params::Dict{String,<:Any})

Gets stream-key information for a specified ARN.

# Arguments
- `arn`: ARN for the stream key to be retrieved.

"""
function get_stream_key(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return ivs(
        "POST",
        "/GetStreamKey",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_stream_key(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs(
        "POST",
        "/GetStreamKey",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_stream_session(channel_arn)
    get_stream_session(channel_arn, params::Dict{String,<:Any})

Gets metadata on a specified stream.

# Arguments
- `channel_arn`: ARN of the channel resource

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"streamId"`: Unique identifier for a live or previously live stream in the specified
  channel. If no streamId is provided, this returns the most recent stream session for the
  channel, if it exists.
"""
function get_stream_session(channelArn; aws_config::AbstractAWSConfig=current_aws_config())
    return ivs(
        "POST",
        "/GetStreamSession",
        Dict{String,Any}("channelArn" => channelArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_stream_session(
    channelArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ivs(
        "POST",
        "/GetStreamSession",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("channelArn" => channelArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    import_playback_key_pair(public_key_material)
    import_playback_key_pair(public_key_material, params::Dict{String,<:Any})

Imports the public portion of a new key pair and returns its arn and fingerprint. The
privateKey can then be used to generate viewer authorization tokens, to grant viewers
access to private channels. For more information, see Setting Up Private Channels in the
Amazon IVS User Guide.

# Arguments
- `public_key_material`: The public portion of a customer-generated key pair.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"name"`: Playback-key-pair name. The value does not need to be unique.
- `"tags"`: Any tags provided with the request are added to the playback key pair tags. See
  Tagging Amazon Web Services Resources for more information, including restrictions that
  apply to tags and \"Tag naming limits and requirements\"; Amazon IVS has no
  service-specific constraints beyond what is documented there.
"""
function import_playback_key_pair(
    publicKeyMaterial; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs(
        "POST",
        "/ImportPlaybackKeyPair",
        Dict{String,Any}("publicKeyMaterial" => publicKeyMaterial);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function import_playback_key_pair(
    publicKeyMaterial,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ivs(
        "POST",
        "/ImportPlaybackKeyPair",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("publicKeyMaterial" => publicKeyMaterial), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_channels()
    list_channels(params::Dict{String,<:Any})

Gets summary information about all channels in your account, in the Amazon Web Services
region where the API request is processed. This list can be filtered to match a specified
name or recording-configuration ARN. Filters are mutually exclusive and cannot be used
together. If you try to use both filters, you will get an error (409 ConflictException).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filterByName"`: Filters the channel list to match the specified name.
- `"filterByPlaybackRestrictionPolicyArn"`: Filters the channel list to match the specified
  policy.
- `"filterByRecordingConfigurationArn"`: Filters the channel list to match the specified
  recording-configuration ARN.
- `"maxResults"`: Maximum number of channels to return. Default: 100.
- `"nextToken"`: The first channel to retrieve. This is used for pagination; see the
  nextToken response field.
"""
function list_channels(; aws_config::AbstractAWSConfig=current_aws_config())
    return ivs(
        "POST", "/ListChannels"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_channels(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs(
        "POST",
        "/ListChannels",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_playback_key_pairs()
    list_playback_key_pairs(params::Dict{String,<:Any})

Gets summary information about playback key pairs. For more information, see Setting Up
Private Channels in the Amazon IVS User Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Maximum number of key pairs to return. Default: your service quota or
  100, whichever is smaller.
- `"nextToken"`: The first key pair to retrieve. This is used for pagination; see the
  nextToken response field.
"""
function list_playback_key_pairs(; aws_config::AbstractAWSConfig=current_aws_config())
    return ivs(
        "POST",
        "/ListPlaybackKeyPairs";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_playback_key_pairs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs(
        "POST",
        "/ListPlaybackKeyPairs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_playback_restriction_policies()
    list_playback_restriction_policies(params::Dict{String,<:Any})

Gets summary information about playback restriction policies.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Maximum number of policies to return. Default: 1.
- `"nextToken"`: The first policy to retrieve. This is used for pagination; see the
  nextToken response field.
"""
function list_playback_restriction_policies(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs(
        "POST",
        "/ListPlaybackRestrictionPolicies";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_playback_restriction_policies(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs(
        "POST",
        "/ListPlaybackRestrictionPolicies",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_recording_configurations()
    list_recording_configurations(params::Dict{String,<:Any})

Gets summary information about all recording configurations in your account, in the Amazon
Web Services region where the API request is processed.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Maximum number of recording configurations to return. Default: your
  service quota or 100, whichever is smaller.
- `"nextToken"`: The first recording configuration to retrieve. This is used for
  pagination; see the nextToken response field.
"""
function list_recording_configurations(; aws_config::AbstractAWSConfig=current_aws_config())
    return ivs(
        "POST",
        "/ListRecordingConfigurations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_recording_configurations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs(
        "POST",
        "/ListRecordingConfigurations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_stream_keys(channel_arn)
    list_stream_keys(channel_arn, params::Dict{String,<:Any})

Gets summary information about stream keys for the specified channel.

# Arguments
- `channel_arn`: Channel ARN used to filter the list.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Maximum number of streamKeys to return. Default: 1.
- `"nextToken"`: The first stream key to retrieve. This is used for pagination; see the
  nextToken response field.
"""
function list_stream_keys(channelArn; aws_config::AbstractAWSConfig=current_aws_config())
    return ivs(
        "POST",
        "/ListStreamKeys",
        Dict{String,Any}("channelArn" => channelArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_stream_keys(
    channelArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ivs(
        "POST",
        "/ListStreamKeys",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("channelArn" => channelArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_stream_sessions(channel_arn)
    list_stream_sessions(channel_arn, params::Dict{String,<:Any})

Gets a summary of current and previous streams for a specified channel in your account, in
the AWS region where the API request is processed.

# Arguments
- `channel_arn`: Channel ARN used to filter the list.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Maximum number of streams to return. Default: 100.
- `"nextToken"`: The first stream to retrieve. This is used for pagination; see the
  nextToken response field.
"""
function list_stream_sessions(
    channelArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs(
        "POST",
        "/ListStreamSessions",
        Dict{String,Any}("channelArn" => channelArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_stream_sessions(
    channelArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ivs(
        "POST",
        "/ListStreamSessions",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("channelArn" => channelArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_streams()
    list_streams(params::Dict{String,<:Any})

Gets summary information about live streams in your account, in the Amazon Web Services
region where the API request is processed.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filterBy"`: Filters the stream list to match the specified criterion.
- `"maxResults"`: Maximum number of streams to return. Default: 100.
- `"nextToken"`: The first stream to retrieve. This is used for pagination; see the
  nextToken response field.
"""
function list_streams(; aws_config::AbstractAWSConfig=current_aws_config())
    return ivs(
        "POST", "/ListStreams"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_streams(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs(
        "POST",
        "/ListStreams",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Gets information about Amazon Web Services tags for the specified ARN.

# Arguments
- `resource_arn`: The ARN of the resource to be retrieved. The ARN must be URL-encoded.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ivs(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_metadata(channel_arn, metadata)
    put_metadata(channel_arn, metadata, params::Dict{String,<:Any})

Inserts metadata into the active stream of the specified channel. At most 5 requests per
second per channel are allowed, each with a maximum 1 KB payload. (If 5 TPS is not
sufficient for your needs, we recommend batching your data into a single PutMetadata call.)
At most 155 requests per second per account are allowed. Also see Embedding Metadata within
a Video Stream in the Amazon IVS User Guide.

# Arguments
- `channel_arn`: ARN of the channel into which metadata is inserted. This channel must have
  an active stream.
- `metadata`: Metadata to insert into the stream. Maximum: 1 KB per request.

"""
function put_metadata(
    channelArn, metadata; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs(
        "POST",
        "/PutMetadata",
        Dict{String,Any}("channelArn" => channelArn, "metadata" => metadata);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_metadata(
    channelArn,
    metadata,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ivs(
        "POST",
        "/PutMetadata",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("channelArn" => channelArn, "metadata" => metadata),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_viewer_session_revocation(channel_arn, viewer_id)
    start_viewer_session_revocation(channel_arn, viewer_id, params::Dict{String,<:Any})

Starts the process of revoking the viewer session associated with a specified channel ARN
and viewer ID. Optionally, you can provide a version to revoke viewer sessions less than
and including that version. For instructions on associating a viewer ID with a viewer
session, see Setting Up Private Channels.

# Arguments
- `channel_arn`: The ARN of the channel associated with the viewer session to revoke.
- `viewer_id`: The ID of the viewer associated with the viewer session to revoke. Do not
  use this field for personally identifying, confidential, or sensitive information.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"viewerSessionVersionsLessThanOrEqualTo"`: An optional filter on which versions of the
  viewer session to revoke. All versions less than or equal to the specified version will be
  revoked. Default: 0.
"""
function start_viewer_session_revocation(
    channelArn, viewerId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs(
        "POST",
        "/StartViewerSessionRevocation",
        Dict{String,Any}("channelArn" => channelArn, "viewerId" => viewerId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_viewer_session_revocation(
    channelArn,
    viewerId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ivs(
        "POST",
        "/StartViewerSessionRevocation",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("channelArn" => channelArn, "viewerId" => viewerId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_stream(channel_arn)
    stop_stream(channel_arn, params::Dict{String,<:Any})

Disconnects the incoming RTMPS stream for the specified channel. Can be used in conjunction
with DeleteStreamKey to prevent further streaming to a channel.  Many streaming
client-software libraries automatically reconnect a dropped RTMPS session, so to stop the
stream permanently, you may want to first revoke the streamKey attached to the channel.

# Arguments
- `channel_arn`: ARN of the channel for which the stream is to be stopped.

"""
function stop_stream(channelArn; aws_config::AbstractAWSConfig=current_aws_config())
    return ivs(
        "POST",
        "/StopStream",
        Dict{String,Any}("channelArn" => channelArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_stream(
    channelArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ivs(
        "POST",
        "/StopStream",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("channelArn" => channelArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds or updates tags for the Amazon Web Services resource with the specified ARN.

# Arguments
- `resource_arn`: ARN of the resource for which tags are to be added or updated. The ARN
  must be URL-encoded.
- `tags`: Array of tags to be added or updated. Array of maps, each of the form
  string:string (key:value). See Tagging Amazon Web Services Resources for more information,
  including restrictions that apply to tags and \"Tag naming limits and requirements\";
  Amazon IVS has no service-specific constraints beyond what is documented there.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return ivs(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ivs(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes tags from the resource with the specified ARN.

# Arguments
- `resource_arn`: ARN of the resource for which tags are to be removed. The ARN must be
  URL-encoded.
- `tag_keys`: Array of tags to be removed. Array of maps, each of the form string:string
  (key:value). See Tagging Amazon Web Services Resources for more information, including
  restrictions that apply to tags and \"Tag naming limits and requirements\"; Amazon IVS has
  no service-specific constraints beyond what is documented there.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ivs(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_channel(arn)
    update_channel(arn, params::Dict{String,<:Any})

Updates a channel's configuration. Live channels cannot be updated. You must stop the
ongoing stream, update the channel, and restart the stream for the changes to take effect.

# Arguments
- `arn`: ARN of the channel to be updated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"authorized"`: Whether the channel is private (enabled for playback authorization).
- `"insecureIngest"`: Whether the channel allows insecure RTMP and SRT ingest. Default:
  false.
- `"latencyMode"`: Channel latency mode. Use NORMAL to broadcast and deliver live video up
  to Full HD. Use LOW for near-real-time interaction with viewers.
- `"name"`: Channel name.
- `"playbackRestrictionPolicyArn"`: Playback-restriction-policy ARN. A valid ARN value here
  both specifies the ARN and enables playback restriction. If this is set to an empty string,
  playback restriction policy is disabled.
- `"preset"`: Optional transcode preset for the channel. This is selectable only for
  ADVANCED_HD and ADVANCED_SD channel types. For those channel types, the default preset is
  HIGHER_BANDWIDTH_DELIVERY. For other channel types (BASIC and STANDARD), preset is the
  empty string (\"\").
- `"recordingConfigurationArn"`: Recording-configuration ARN. A valid ARN value here both
  specifies the ARN and enables recording. If this is set to an empty string, recording is
  disabled.
- `"type"`: Channel type, which determines the allowable resolution and bitrate. If you
  exceed the allowable input resolution or bitrate, the stream probably will disconnect
  immediately. Default: STANDARD. For details, see Channel Types.
"""
function update_channel(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return ivs(
        "POST",
        "/UpdateChannel",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_channel(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs(
        "POST",
        "/UpdateChannel",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_playback_restriction_policy(arn)
    update_playback_restriction_policy(arn, params::Dict{String,<:Any})

Updates a specified playback restriction policy.

# Arguments
- `arn`: ARN of the playback-restriction-policy to be updated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"allowedCountries"`: A list of country codes that control geoblocking restriction.
  Allowed values are the officially assigned ISO 3166-1 alpha-2 codes. Default: All countries
  (an empty array).
- `"allowedOrigins"`: A list of origin sites that control CORS restriction. Allowed values
  are the same as valid values of the Origin header defined at
  https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Origin. Default: All origins (an
  empty array).
- `"enableStrictOriginEnforcement"`: Whether channel playback is constrained by origin
  site. Default: false.
- `"name"`: Playback-restriction-policy name. The value does not need to be unique.
"""
function update_playback_restriction_policy(
    arn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs(
        "POST",
        "/UpdatePlaybackRestrictionPolicy",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_playback_restriction_policy(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs(
        "POST",
        "/UpdatePlaybackRestrictionPolicy",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: waf
using AWS.Compat
using AWS.UUIDs

"""
    create_byte_match_set(change_token, name)
    create_byte_match_set(change_token, name, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Creates a ByteMatchSet. You then use UpdateByteMatchSet to
identify the part of a web request that you want AWS WAF to inspect, such as the values of
the User-Agent header or the query string. For example, you can create a ByteMatchSet that
matches any requests with User-Agent headers that contain the string BadBot. You can then
configure AWS WAF to reject those requests. To create and configure a ByteMatchSet, perform
the following steps:   Use GetChangeToken to get the change token that you provide in the
ChangeToken parameter of a CreateByteMatchSet request.   Submit a CreateByteMatchSet
request.   Use GetChangeToken to get the change token that you provide in the ChangeToken
parameter of an UpdateByteMatchSet request.   Submit an UpdateByteMatchSet request to
specify the part of the request that you want AWS WAF to inspect (for example, the header
or the URI) and the value that you want AWS WAF to watch for.   For more information about
how to use the AWS WAF API to allow or block HTTP requests, see the AWS WAF Developer Guide.

# Arguments
- `change_token`: The value returned by the most recent call to GetChangeToken.
- `name`: A friendly name or description of the ByteMatchSet. You can't change Name after
  you create a ByteMatchSet.

"""
function create_byte_match_set(
    ChangeToken, Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "CreateByteMatchSet",
        Dict{String,Any}("ChangeToken" => ChangeToken, "Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_byte_match_set(
    ChangeToken,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "CreateByteMatchSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ChangeToken" => ChangeToken, "Name" => Name),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_geo_match_set(change_token, name)
    create_geo_match_set(change_token, name, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Creates an GeoMatchSet, which you use to specify which web
requests you want to allow or block based on the country that the requests originate from.
For example, if you're receiving a lot of requests from one or more countries and you want
to block the requests, you can create an GeoMatchSet that contains those countries and then
configure AWS WAF to block the requests.  To create and configure a GeoMatchSet, perform
the following steps:   Use GetChangeToken to get the change token that you provide in the
ChangeToken parameter of a CreateGeoMatchSet request.   Submit a CreateGeoMatchSet request.
  Use GetChangeToken to get the change token that you provide in the ChangeToken parameter
of an UpdateGeoMatchSet request.   Submit an UpdateGeoMatchSetSet request to specify the
countries that you want AWS WAF to watch for.   For more information about how to use the
AWS WAF API to allow or block HTTP requests, see the AWS WAF Developer Guide.

# Arguments
- `change_token`: The value returned by the most recent call to GetChangeToken.
- `name`: A friendly name or description of the GeoMatchSet. You can't change Name after
  you create the GeoMatchSet.

"""
function create_geo_match_set(
    ChangeToken, Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "CreateGeoMatchSet",
        Dict{String,Any}("ChangeToken" => ChangeToken, "Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_geo_match_set(
    ChangeToken,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "CreateGeoMatchSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ChangeToken" => ChangeToken, "Name" => Name),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_ipset(change_token, name)
    create_ipset(change_token, name, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Creates an IPSet, which you use to specify which web requests
that you want to allow or block based on the IP addresses that the requests originate from.
For example, if you're receiving a lot of requests from one or more individual IP addresses
or one or more ranges of IP addresses and you want to block the requests, you can create an
IPSet that contains those IP addresses and then configure AWS WAF to block the requests.
To create and configure an IPSet, perform the following steps:   Use GetChangeToken to get
the change token that you provide in the ChangeToken parameter of a CreateIPSet request.
Submit a CreateIPSet request.   Use GetChangeToken to get the change token that you provide
in the ChangeToken parameter of an UpdateIPSet request.   Submit an UpdateIPSet request to
specify the IP addresses that you want AWS WAF to watch for.   For more information about
how to use the AWS WAF API to allow or block HTTP requests, see the AWS WAF Developer Guide.

# Arguments
- `change_token`: The value returned by the most recent call to GetChangeToken.
- `name`: A friendly name or description of the IPSet. You can't change Name after you
  create the IPSet.

"""
function create_ipset(ChangeToken, Name; aws_config::AbstractAWSConfig=current_aws_config())
    return waf(
        "CreateIPSet",
        Dict{String,Any}("ChangeToken" => ChangeToken, "Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_ipset(
    ChangeToken,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "CreateIPSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ChangeToken" => ChangeToken, "Name" => Name),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_rate_based_rule(change_token, metric_name, name, rate_key, rate_limit)
    create_rate_based_rule(change_token, metric_name, name, rate_key, rate_limit, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Creates a RateBasedRule. The RateBasedRule contains a RateLimit,
which specifies the maximum number of requests that AWS WAF allows from a specified IP
address in a five-minute period. The RateBasedRule also contains the IPSet objects,
ByteMatchSet objects, and other predicates that identify the requests that you want to
count or block if these requests exceed the RateLimit. If you add more than one predicate
to a RateBasedRule, a request not only must exceed the RateLimit, but it also must match
all the conditions to be counted or blocked. For example, suppose you add the following to
a RateBasedRule:   An IPSet that matches the IP address 192.0.2.44/32    A ByteMatchSet
that matches BadBot in the User-Agent header   Further, you specify a RateLimit of 1,000.
You then add the RateBasedRule to a WebACL and specify that you want to block requests that
meet the conditions in the rule. For a request to be blocked, it must come from the IP
address 192.0.2.44 and the User-Agent header in the request must contain the value BadBot.
Further, requests that match these two conditions must be received at a rate of more than
1,000 requests every five minutes. If both conditions are met and the rate is exceeded, AWS
WAF blocks the requests. If the rate drops below 1,000 for a five-minute period, AWS WAF no
longer blocks the requests. As a second example, suppose you want to limit requests to a
particular page on your site. To do this, you could add the following to a RateBasedRule:
A ByteMatchSet with FieldToMatch of URI    A PositionalConstraint of STARTS_WITH    A
TargetString of login    Further, you specify a RateLimit of 1,000. By adding this
RateBasedRule to a WebACL, you could limit requests to your login page without affecting
the rest of your site. To create and configure a RateBasedRule, perform the following
steps:   Create and update the predicates that you want to include in the rule. For more
information, see CreateByteMatchSet, CreateIPSet, and CreateSqlInjectionMatchSet.   Use
GetChangeToken to get the change token that you provide in the ChangeToken parameter of a
CreateRule request.   Submit a CreateRateBasedRule request.   Use GetChangeToken to get the
change token that you provide in the ChangeToken parameter of an UpdateRule request.
Submit an UpdateRateBasedRule request to specify the predicates that you want to include in
the rule.   Create and update a WebACL that contains the RateBasedRule. For more
information, see CreateWebACL.   For more information about how to use the AWS WAF API to
allow or block HTTP requests, see the AWS WAF Developer Guide.

# Arguments
- `change_token`: The ChangeToken that you used to submit the CreateRateBasedRule request.
  You can also use this value to query the status of the request. For more information, see
  GetChangeTokenStatus.
- `metric_name`: A friendly name or description for the metrics for this RateBasedRule. The
  name can contain only alphanumeric characters (A-Z, a-z, 0-9), with maximum length 128 and
  minimum length one. It can't contain whitespace or metric names reserved for AWS WAF,
  including \"All\" and \"Default_Action.\" You can't change the name of the metric after you
  create the RateBasedRule.
- `name`: A friendly name or description of the RateBasedRule. You can't change the name of
  a RateBasedRule after you create it.
- `rate_key`: The field that AWS WAF uses to determine if requests are likely arriving from
  a single source and thus subject to rate monitoring. The only valid value for RateKey is
  IP. IP indicates that requests that arrive from the same IP address are subject to the
  RateLimit that is specified in the RateBasedRule.
- `rate_limit`: The maximum number of requests, which have an identical value in the field
  that is specified by RateKey, allowed in a five-minute period. If the number of requests
  exceeds the RateLimit and the other predicates specified in the rule are also met, AWS WAF
  triggers the action that is specified for this rule.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`:
"""
function create_rate_based_rule(
    ChangeToken,
    MetricName,
    Name,
    RateKey,
    RateLimit;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "CreateRateBasedRule",
        Dict{String,Any}(
            "ChangeToken" => ChangeToken,
            "MetricName" => MetricName,
            "Name" => Name,
            "RateKey" => RateKey,
            "RateLimit" => RateLimit,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_rate_based_rule(
    ChangeToken,
    MetricName,
    Name,
    RateKey,
    RateLimit,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "CreateRateBasedRule",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ChangeToken" => ChangeToken,
                    "MetricName" => MetricName,
                    "Name" => Name,
                    "RateKey" => RateKey,
                    "RateLimit" => RateLimit,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_regex_match_set(change_token, name)
    create_regex_match_set(change_token, name, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Creates a RegexMatchSet. You then use UpdateRegexMatchSet to
identify the part of a web request that you want AWS WAF to inspect, such as the values of
the User-Agent header or the query string. For example, you can create a RegexMatchSet that
contains a RegexMatchTuple that looks for any requests with User-Agent headers that match a
RegexPatternSet with pattern B[a@]dB[o0]t. You can then configure AWS WAF to reject those
requests. To create and configure a RegexMatchSet, perform the following steps:   Use
GetChangeToken to get the change token that you provide in the ChangeToken parameter of a
CreateRegexMatchSet request.   Submit a CreateRegexMatchSet request.   Use GetChangeToken
to get the change token that you provide in the ChangeToken parameter of an
UpdateRegexMatchSet request.   Submit an UpdateRegexMatchSet request to specify the part of
the request that you want AWS WAF to inspect (for example, the header or the URI) and the
value, using a RegexPatternSet, that you want AWS WAF to watch for.   For more information
about how to use the AWS WAF API to allow or block HTTP requests, see the AWS WAF Developer
Guide.

# Arguments
- `change_token`: The value returned by the most recent call to GetChangeToken.
- `name`: A friendly name or description of the RegexMatchSet. You can't change Name after
  you create a RegexMatchSet.

"""
function create_regex_match_set(
    ChangeToken, Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "CreateRegexMatchSet",
        Dict{String,Any}("ChangeToken" => ChangeToken, "Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_regex_match_set(
    ChangeToken,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "CreateRegexMatchSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ChangeToken" => ChangeToken, "Name" => Name),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_regex_pattern_set(change_token, name)
    create_regex_pattern_set(change_token, name, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Creates a RegexPatternSet. You then use UpdateRegexPatternSet to
specify the regular expression (regex) pattern that you want AWS WAF to search for, such as
B[a@]dB[o0]t. You can then configure AWS WAF to reject those requests. To create and
configure a RegexPatternSet, perform the following steps:   Use GetChangeToken to get the
change token that you provide in the ChangeToken parameter of a CreateRegexPatternSet
request.   Submit a CreateRegexPatternSet request.   Use GetChangeToken to get the change
token that you provide in the ChangeToken parameter of an UpdateRegexPatternSet request.
Submit an UpdateRegexPatternSet request to specify the string that you want AWS WAF to
watch for.   For more information about how to use the AWS WAF API to allow or block HTTP
requests, see the AWS WAF Developer Guide.

# Arguments
- `change_token`: The value returned by the most recent call to GetChangeToken.
- `name`: A friendly name or description of the RegexPatternSet. You can't change Name
  after you create a RegexPatternSet.

"""
function create_regex_pattern_set(
    ChangeToken, Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "CreateRegexPatternSet",
        Dict{String,Any}("ChangeToken" => ChangeToken, "Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_regex_pattern_set(
    ChangeToken,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "CreateRegexPatternSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ChangeToken" => ChangeToken, "Name" => Name),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_rule(change_token, metric_name, name)
    create_rule(change_token, metric_name, name, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Creates a Rule, which contains the IPSet objects, ByteMatchSet
objects, and other predicates that identify the requests that you want to block. If you add
more than one predicate to a Rule, a request must match all of the specifications to be
allowed or blocked. For example, suppose that you add the following to a Rule:   An IPSet
that matches the IP address 192.0.2.44/32    A ByteMatchSet that matches BadBot in the
User-Agent header   You then add the Rule to a WebACL and specify that you want to blocks
requests that satisfy the Rule. For a request to be blocked, it must come from the IP
address 192.0.2.44 and the User-Agent header in the request must contain the value BadBot.
To create and configure a Rule, perform the following steps:   Create and update the
predicates that you want to include in the Rule. For more information, see
CreateByteMatchSet, CreateIPSet, and CreateSqlInjectionMatchSet.   Use GetChangeToken to
get the change token that you provide in the ChangeToken parameter of a CreateRule request.
  Submit a CreateRule request.   Use GetChangeToken to get the change token that you
provide in the ChangeToken parameter of an UpdateRule request.   Submit an UpdateRule
request to specify the predicates that you want to include in the Rule.   Create and update
a WebACL that contains the Rule. For more information, see CreateWebACL.   For more
information about how to use the AWS WAF API to allow or block HTTP requests, see the AWS
WAF Developer Guide.

# Arguments
- `change_token`: The value returned by the most recent call to GetChangeToken.
- `metric_name`: A friendly name or description for the metrics for this Rule. The name can
  contain only alphanumeric characters (A-Z, a-z, 0-9), with maximum length 128 and minimum
  length one. It can't contain whitespace or metric names reserved for AWS WAF, including
  \"All\" and \"Default_Action.\" You can't change the name of the metric after you create
  the Rule.
- `name`: A friendly name or description of the Rule. You can't change the name of a Rule
  after you create it.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`:
"""
function create_rule(
    ChangeToken, MetricName, Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "CreateRule",
        Dict{String,Any}(
            "ChangeToken" => ChangeToken, "MetricName" => MetricName, "Name" => Name
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_rule(
    ChangeToken,
    MetricName,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "CreateRule",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ChangeToken" => ChangeToken, "MetricName" => MetricName, "Name" => Name
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_rule_group(change_token, metric_name, name)
    create_rule_group(change_token, metric_name, name, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Creates a RuleGroup. A rule group is a collection of predefined
rules that you add to a web ACL. You use UpdateRuleGroup to add rules to the rule group.
Rule groups are subject to the following limits:   Three rule groups per account. You can
request an increase to this limit by contacting customer support.   One rule group per web
ACL.   Ten rules per rule group.   For more information about how to use the AWS WAF API to
allow or block HTTP requests, see the AWS WAF Developer Guide.

# Arguments
- `change_token`: The value returned by the most recent call to GetChangeToken.
- `metric_name`: A friendly name or description for the metrics for this RuleGroup. The
  name can contain only alphanumeric characters (A-Z, a-z, 0-9), with maximum length 128 and
  minimum length one. It can't contain whitespace or metric names reserved for AWS WAF,
  including \"All\" and \"Default_Action.\" You can't change the name of the metric after you
  create the RuleGroup.
- `name`: A friendly name or description of the RuleGroup. You can't change Name after you
  create a RuleGroup.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`:
"""
function create_rule_group(
    ChangeToken, MetricName, Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "CreateRuleGroup",
        Dict{String,Any}(
            "ChangeToken" => ChangeToken, "MetricName" => MetricName, "Name" => Name
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_rule_group(
    ChangeToken,
    MetricName,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "CreateRuleGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ChangeToken" => ChangeToken, "MetricName" => MetricName, "Name" => Name
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_size_constraint_set(change_token, name)
    create_size_constraint_set(change_token, name, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Creates a SizeConstraintSet. You then use
UpdateSizeConstraintSet to identify the part of a web request that you want AWS WAF to
check for length, such as the length of the User-Agent header or the length of the query
string. For example, you can create a SizeConstraintSet that matches any requests that have
a query string that is longer than 100 bytes. You can then configure AWS WAF to reject
those requests. To create and configure a SizeConstraintSet, perform the following steps:
Use GetChangeToken to get the change token that you provide in the ChangeToken parameter of
a CreateSizeConstraintSet request.   Submit a CreateSizeConstraintSet request.   Use
GetChangeToken to get the change token that you provide in the ChangeToken parameter of an
UpdateSizeConstraintSet request.   Submit an UpdateSizeConstraintSet request to specify the
part of the request that you want AWS WAF to inspect (for example, the header or the URI)
and the value that you want AWS WAF to watch for.   For more information about how to use
the AWS WAF API to allow or block HTTP requests, see the AWS WAF Developer Guide.

# Arguments
- `change_token`: The value returned by the most recent call to GetChangeToken.
- `name`: A friendly name or description of the SizeConstraintSet. You can't change Name
  after you create a SizeConstraintSet.

"""
function create_size_constraint_set(
    ChangeToken, Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "CreateSizeConstraintSet",
        Dict{String,Any}("ChangeToken" => ChangeToken, "Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_size_constraint_set(
    ChangeToken,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "CreateSizeConstraintSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ChangeToken" => ChangeToken, "Name" => Name),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_sql_injection_match_set(change_token, name)
    create_sql_injection_match_set(change_token, name, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Creates a SqlInjectionMatchSet, which you use to allow, block,
or count requests that contain snippets of SQL code in a specified part of web requests.
AWS WAF searches for character sequences that are likely to be malicious strings. To create
and configure a SqlInjectionMatchSet, perform the following steps:   Use GetChangeToken to
get the change token that you provide in the ChangeToken parameter of a
CreateSqlInjectionMatchSet request.   Submit a CreateSqlInjectionMatchSet request.   Use
GetChangeToken to get the change token that you provide in the ChangeToken parameter of an
UpdateSqlInjectionMatchSet request.   Submit an UpdateSqlInjectionMatchSet request to
specify the parts of web requests in which you want to allow, block, or count malicious SQL
code.   For more information about how to use the AWS WAF API to allow or block HTTP
requests, see the AWS WAF Developer Guide.

# Arguments
- `change_token`: The value returned by the most recent call to GetChangeToken.
- `name`: A friendly name or description for the SqlInjectionMatchSet that you're creating.
  You can't change Name after you create the SqlInjectionMatchSet.

"""
function create_sql_injection_match_set(
    ChangeToken, Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "CreateSqlInjectionMatchSet",
        Dict{String,Any}("ChangeToken" => ChangeToken, "Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_sql_injection_match_set(
    ChangeToken,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "CreateSqlInjectionMatchSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ChangeToken" => ChangeToken, "Name" => Name),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_web_acl(change_token, default_action, metric_name, name)
    create_web_acl(change_token, default_action, metric_name, name, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Creates a WebACL, which contains the Rules that identify the
CloudFront web requests that you want to allow, block, or count. AWS WAF evaluates Rules in
order based on the value of Priority for each Rule. You also specify a default action,
either ALLOW or BLOCK. If a web request doesn't match any of the Rules in a WebACL, AWS WAF
responds to the request with the default action.  To create and configure a WebACL, perform
the following steps:   Create and update the ByteMatchSet objects and other predicates that
you want to include in Rules. For more information, see CreateByteMatchSet,
UpdateByteMatchSet, CreateIPSet, UpdateIPSet, CreateSqlInjectionMatchSet, and
UpdateSqlInjectionMatchSet.   Create and update the Rules that you want to include in the
WebACL. For more information, see CreateRule and UpdateRule.   Use GetChangeToken to get
the change token that you provide in the ChangeToken parameter of a CreateWebACL request.
Submit a CreateWebACL request.   Use GetChangeToken to get the change token that you
provide in the ChangeToken parameter of an UpdateWebACL request.   Submit an UpdateWebACL
request to specify the Rules that you want to include in the WebACL, to specify the default
action, and to associate the WebACL with a CloudFront distribution.   For more information
about how to use the AWS WAF API, see the AWS WAF Developer Guide.

# Arguments
- `change_token`: The value returned by the most recent call to GetChangeToken.
- `default_action`: The action that you want AWS WAF to take when a request doesn't match
  the criteria specified in any of the Rule objects that are associated with the WebACL.
- `metric_name`: A friendly name or description for the metrics for this WebACL.The name
  can contain only alphanumeric characters (A-Z, a-z, 0-9), with maximum length 128 and
  minimum length one. It can't contain whitespace or metric names reserved for AWS WAF,
  including \"All\" and \"Default_Action.\" You can't change MetricName after you create the
  WebACL.
- `name`: A friendly name or description of the WebACL. You can't change Name after you
  create the WebACL.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`:
"""
function create_web_acl(
    ChangeToken,
    DefaultAction,
    MetricName,
    Name;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "CreateWebACL",
        Dict{String,Any}(
            "ChangeToken" => ChangeToken,
            "DefaultAction" => DefaultAction,
            "MetricName" => MetricName,
            "Name" => Name,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_web_acl(
    ChangeToken,
    DefaultAction,
    MetricName,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "CreateWebACL",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ChangeToken" => ChangeToken,
                    "DefaultAction" => DefaultAction,
                    "MetricName" => MetricName,
                    "Name" => Name,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_web_aclmigration_stack(ignore_unsupported_type, s3_bucket_name, web_aclid)
    create_web_aclmigration_stack(ignore_unsupported_type, s3_bucket_name, web_aclid, params::Dict{String,<:Any})

Creates an AWS CloudFormation WAFV2 template for the specified web ACL in the specified
Amazon S3 bucket. Then, in CloudFormation, you create a stack from the template, to create
the web ACL and its resources in AWS WAFV2. Use this to migrate your AWS WAF Classic web
ACL to the latest version of AWS WAF. This is part of a larger migration procedure for web
ACLs from AWS WAF Classic to the latest version of AWS WAF. For the full procedure,
including caveats and manual steps to complete the migration and switch over to the new web
ACL, see Migrating your AWS WAF Classic resources to AWS WAF in the AWS WAF Developer
Guide.

# Arguments
- `ignore_unsupported_type`: Indicates whether to exclude entities that can't be migrated
  or to stop the migration. Set this to true to ignore unsupported entities in the web ACL
  during the migration. Otherwise, if AWS WAF encounters unsupported entities, it stops the
  process and throws an exception.
- `s3_bucket_name`: The name of the Amazon S3 bucket to store the CloudFormation template
  in. The S3 bucket must be configured as follows for the migration:    The bucket name must
  start with aws-waf-migration-. For example, aws-waf-migration-my-web-acl.   The bucket must
  be in the Region where you are deploying the template. For example, for a web ACL in
  us-west-2, you must use an Amazon S3 bucket in us-west-2 and you must deploy the template
  stack to us-west-2.    The bucket policies must permit the migration process to write data.
  For listings of the bucket policies, see the Examples section.
- `web_aclid`: The UUID of the WAF Classic web ACL that you want to migrate to WAF v2.

"""
function create_web_aclmigration_stack(
    IgnoreUnsupportedType,
    S3BucketName,
    WebACLId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "CreateWebACLMigrationStack",
        Dict{String,Any}(
            "IgnoreUnsupportedType" => IgnoreUnsupportedType,
            "S3BucketName" => S3BucketName,
            "WebACLId" => WebACLId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_web_aclmigration_stack(
    IgnoreUnsupportedType,
    S3BucketName,
    WebACLId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "CreateWebACLMigrationStack",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "IgnoreUnsupportedType" => IgnoreUnsupportedType,
                    "S3BucketName" => S3BucketName,
                    "WebACLId" => WebACLId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_xss_match_set(change_token, name)
    create_xss_match_set(change_token, name, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Creates an XssMatchSet, which you use to allow, block, or count
requests that contain cross-site scripting attacks in the specified part of web requests.
AWS WAF searches for character sequences that are likely to be malicious strings. To create
and configure an XssMatchSet, perform the following steps:   Use GetChangeToken to get the
change token that you provide in the ChangeToken parameter of a CreateXssMatchSet request.
 Submit a CreateXssMatchSet request.   Use GetChangeToken to get the change token that you
provide in the ChangeToken parameter of an UpdateXssMatchSet request.   Submit an
UpdateXssMatchSet request to specify the parts of web requests in which you want to allow,
block, or count cross-site scripting attacks.   For more information about how to use the
AWS WAF API to allow or block HTTP requests, see the AWS WAF Developer Guide.

# Arguments
- `change_token`: The value returned by the most recent call to GetChangeToken.
- `name`: A friendly name or description for the XssMatchSet that you're creating. You
  can't change Name after you create the XssMatchSet.

"""
function create_xss_match_set(
    ChangeToken, Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "CreateXssMatchSet",
        Dict{String,Any}("ChangeToken" => ChangeToken, "Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_xss_match_set(
    ChangeToken,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "CreateXssMatchSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ChangeToken" => ChangeToken, "Name" => Name),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_byte_match_set(byte_match_set_id, change_token)
    delete_byte_match_set(byte_match_set_id, change_token, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Permanently deletes a ByteMatchSet. You can't delete a
ByteMatchSet if it's still used in any Rules or if it still includes any ByteMatchTuple
objects (any filters). If you just want to remove a ByteMatchSet from a Rule, use
UpdateRule. To permanently delete a ByteMatchSet, perform the following steps:   Update the
ByteMatchSet to remove filters, if any. For more information, see UpdateByteMatchSet.   Use
GetChangeToken to get the change token that you provide in the ChangeToken parameter of a
DeleteByteMatchSet request.   Submit a DeleteByteMatchSet request.

# Arguments
- `byte_match_set_id`: The ByteMatchSetId of the ByteMatchSet that you want to delete.
  ByteMatchSetId is returned by CreateByteMatchSet and by ListByteMatchSets.
- `change_token`: The value returned by the most recent call to GetChangeToken.

"""
function delete_byte_match_set(
    ByteMatchSetId, ChangeToken; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "DeleteByteMatchSet",
        Dict{String,Any}("ByteMatchSetId" => ByteMatchSetId, "ChangeToken" => ChangeToken);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_byte_match_set(
    ByteMatchSetId,
    ChangeToken,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "DeleteByteMatchSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ByteMatchSetId" => ByteMatchSetId, "ChangeToken" => ChangeToken
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_geo_match_set(change_token, geo_match_set_id)
    delete_geo_match_set(change_token, geo_match_set_id, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Permanently deletes a GeoMatchSet. You can't delete a
GeoMatchSet if it's still used in any Rules or if it still includes any countries. If you
just want to remove a GeoMatchSet from a Rule, use UpdateRule. To permanently delete a
GeoMatchSet from AWS WAF, perform the following steps:   Update the GeoMatchSet to remove
any countries. For more information, see UpdateGeoMatchSet.   Use GetChangeToken to get the
change token that you provide in the ChangeToken parameter of a DeleteGeoMatchSet request.
 Submit a DeleteGeoMatchSet request.

# Arguments
- `change_token`: The value returned by the most recent call to GetChangeToken.
- `geo_match_set_id`: The GeoMatchSetID of the GeoMatchSet that you want to delete.
  GeoMatchSetId is returned by CreateGeoMatchSet and by ListGeoMatchSets.

"""
function delete_geo_match_set(
    ChangeToken, GeoMatchSetId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "DeleteGeoMatchSet",
        Dict{String,Any}("ChangeToken" => ChangeToken, "GeoMatchSetId" => GeoMatchSetId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_geo_match_set(
    ChangeToken,
    GeoMatchSetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "DeleteGeoMatchSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ChangeToken" => ChangeToken, "GeoMatchSetId" => GeoMatchSetId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_ipset(change_token, ipset_id)
    delete_ipset(change_token, ipset_id, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Permanently deletes an IPSet. You can't delete an IPSet if it's
still used in any Rules or if it still includes any IP addresses. If you just want to
remove an IPSet from a Rule, use UpdateRule. To permanently delete an IPSet from AWS WAF,
perform the following steps:   Update the IPSet to remove IP address ranges, if any. For
more information, see UpdateIPSet.   Use GetChangeToken to get the change token that you
provide in the ChangeToken parameter of a DeleteIPSet request.   Submit a DeleteIPSet
request.

# Arguments
- `change_token`: The value returned by the most recent call to GetChangeToken.
- `ipset_id`: The IPSetId of the IPSet that you want to delete. IPSetId is returned by
  CreateIPSet and by ListIPSets.

"""
function delete_ipset(
    ChangeToken, IPSetId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "DeleteIPSet",
        Dict{String,Any}("ChangeToken" => ChangeToken, "IPSetId" => IPSetId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_ipset(
    ChangeToken,
    IPSetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "DeleteIPSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ChangeToken" => ChangeToken, "IPSetId" => IPSetId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_logging_configuration(resource_arn)
    delete_logging_configuration(resource_arn, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Permanently deletes the LoggingConfiguration from the specified
web ACL.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the web ACL from which you want to
  delete the LoggingConfiguration.

"""
function delete_logging_configuration(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "DeleteLoggingConfiguration",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_logging_configuration(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "DeleteLoggingConfiguration",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_permission_policy(resource_arn)
    delete_permission_policy(resource_arn, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Permanently deletes an IAM policy from the specified RuleGroup.
The user making the request must be the owner of the RuleGroup.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the RuleGroup from which you want to
  delete the policy. The user making the request must be the owner of the RuleGroup.

"""
function delete_permission_policy(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "DeletePermissionPolicy",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_permission_policy(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "DeletePermissionPolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_rate_based_rule(change_token, rule_id)
    delete_rate_based_rule(change_token, rule_id, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Permanently deletes a RateBasedRule. You can't delete a rule if
it's still used in any WebACL objects or if it still includes any predicates, such as
ByteMatchSet objects. If you just want to remove a rule from a WebACL, use UpdateWebACL. To
permanently delete a RateBasedRule from AWS WAF, perform the following steps:   Update the
RateBasedRule to remove predicates, if any. For more information, see UpdateRateBasedRule.
 Use GetChangeToken to get the change token that you provide in the ChangeToken parameter
of a DeleteRateBasedRule request.   Submit a DeleteRateBasedRule request.

# Arguments
- `change_token`: The value returned by the most recent call to GetChangeToken.
- `rule_id`: The RuleId of the RateBasedRule that you want to delete. RuleId is returned by
  CreateRateBasedRule and by ListRateBasedRules.

"""
function delete_rate_based_rule(
    ChangeToken, RuleId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "DeleteRateBasedRule",
        Dict{String,Any}("ChangeToken" => ChangeToken, "RuleId" => RuleId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_rate_based_rule(
    ChangeToken,
    RuleId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "DeleteRateBasedRule",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ChangeToken" => ChangeToken, "RuleId" => RuleId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_regex_match_set(change_token, regex_match_set_id)
    delete_regex_match_set(change_token, regex_match_set_id, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Permanently deletes a RegexMatchSet. You can't delete a
RegexMatchSet if it's still used in any Rules or if it still includes any RegexMatchTuples
objects (any filters). If you just want to remove a RegexMatchSet from a Rule, use
UpdateRule. To permanently delete a RegexMatchSet, perform the following steps:   Update
the RegexMatchSet to remove filters, if any. For more information, see UpdateRegexMatchSet.
  Use GetChangeToken to get the change token that you provide in the ChangeToken parameter
of a DeleteRegexMatchSet request.   Submit a DeleteRegexMatchSet request.

# Arguments
- `change_token`: The value returned by the most recent call to GetChangeToken.
- `regex_match_set_id`: The RegexMatchSetId of the RegexMatchSet that you want to delete.
  RegexMatchSetId is returned by CreateRegexMatchSet and by ListRegexMatchSets.

"""
function delete_regex_match_set(
    ChangeToken, RegexMatchSetId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "DeleteRegexMatchSet",
        Dict{String,Any}(
            "ChangeToken" => ChangeToken, "RegexMatchSetId" => RegexMatchSetId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_regex_match_set(
    ChangeToken,
    RegexMatchSetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "DeleteRegexMatchSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ChangeToken" => ChangeToken, "RegexMatchSetId" => RegexMatchSetId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_regex_pattern_set(change_token, regex_pattern_set_id)
    delete_regex_pattern_set(change_token, regex_pattern_set_id, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Permanently deletes a RegexPatternSet. You can't delete a
RegexPatternSet if it's still used in any RegexMatchSet or if the RegexPatternSet is not
empty.

# Arguments
- `change_token`: The value returned by the most recent call to GetChangeToken.
- `regex_pattern_set_id`: The RegexPatternSetId of the RegexPatternSet that you want to
  delete. RegexPatternSetId is returned by CreateRegexPatternSet and by ListRegexPatternSets.

"""
function delete_regex_pattern_set(
    ChangeToken, RegexPatternSetId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "DeleteRegexPatternSet",
        Dict{String,Any}(
            "ChangeToken" => ChangeToken, "RegexPatternSetId" => RegexPatternSetId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_regex_pattern_set(
    ChangeToken,
    RegexPatternSetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "DeleteRegexPatternSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ChangeToken" => ChangeToken, "RegexPatternSetId" => RegexPatternSetId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_rule(change_token, rule_id)
    delete_rule(change_token, rule_id, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Permanently deletes a Rule. You can't delete a Rule if it's
still used in any WebACL objects or if it still includes any predicates, such as
ByteMatchSet objects. If you just want to remove a Rule from a WebACL, use UpdateWebACL. To
permanently delete a Rule from AWS WAF, perform the following steps:   Update the Rule to
remove predicates, if any. For more information, see UpdateRule.   Use GetChangeToken to
get the change token that you provide in the ChangeToken parameter of a DeleteRule request.
  Submit a DeleteRule request.

# Arguments
- `change_token`: The value returned by the most recent call to GetChangeToken.
- `rule_id`: The RuleId of the Rule that you want to delete. RuleId is returned by
  CreateRule and by ListRules.

"""
function delete_rule(
    ChangeToken, RuleId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "DeleteRule",
        Dict{String,Any}("ChangeToken" => ChangeToken, "RuleId" => RuleId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_rule(
    ChangeToken,
    RuleId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "DeleteRule",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ChangeToken" => ChangeToken, "RuleId" => RuleId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_rule_group(change_token, rule_group_id)
    delete_rule_group(change_token, rule_group_id, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Permanently deletes a RuleGroup. You can't delete a RuleGroup if
it's still used in any WebACL objects or if it still includes any rules. If you just want
to remove a RuleGroup from a WebACL, use UpdateWebACL. To permanently delete a RuleGroup
from AWS WAF, perform the following steps:   Update the RuleGroup to remove rules, if any.
For more information, see UpdateRuleGroup.   Use GetChangeToken to get the change token
that you provide in the ChangeToken parameter of a DeleteRuleGroup request.   Submit a
DeleteRuleGroup request.

# Arguments
- `change_token`: The value returned by the most recent call to GetChangeToken.
- `rule_group_id`: The RuleGroupId of the RuleGroup that you want to delete. RuleGroupId is
  returned by CreateRuleGroup and by ListRuleGroups.

"""
function delete_rule_group(
    ChangeToken, RuleGroupId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "DeleteRuleGroup",
        Dict{String,Any}("ChangeToken" => ChangeToken, "RuleGroupId" => RuleGroupId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_rule_group(
    ChangeToken,
    RuleGroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "DeleteRuleGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ChangeToken" => ChangeToken, "RuleGroupId" => RuleGroupId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_size_constraint_set(change_token, size_constraint_set_id)
    delete_size_constraint_set(change_token, size_constraint_set_id, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Permanently deletes a SizeConstraintSet. You can't delete a
SizeConstraintSet if it's still used in any Rules or if it still includes any
SizeConstraint objects (any filters). If you just want to remove a SizeConstraintSet from a
Rule, use UpdateRule. To permanently delete a SizeConstraintSet, perform the following
steps:   Update the SizeConstraintSet to remove filters, if any. For more information, see
UpdateSizeConstraintSet.   Use GetChangeToken to get the change token that you provide in
the ChangeToken parameter of a DeleteSizeConstraintSet request.   Submit a
DeleteSizeConstraintSet request.

# Arguments
- `change_token`: The value returned by the most recent call to GetChangeToken.
- `size_constraint_set_id`: The SizeConstraintSetId of the SizeConstraintSet that you want
  to delete. SizeConstraintSetId is returned by CreateSizeConstraintSet and by
  ListSizeConstraintSets.

"""
function delete_size_constraint_set(
    ChangeToken, SizeConstraintSetId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "DeleteSizeConstraintSet",
        Dict{String,Any}(
            "ChangeToken" => ChangeToken, "SizeConstraintSetId" => SizeConstraintSetId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_size_constraint_set(
    ChangeToken,
    SizeConstraintSetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "DeleteSizeConstraintSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ChangeToken" => ChangeToken,
                    "SizeConstraintSetId" => SizeConstraintSetId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_sql_injection_match_set(change_token, sql_injection_match_set_id)
    delete_sql_injection_match_set(change_token, sql_injection_match_set_id, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Permanently deletes a SqlInjectionMatchSet. You can't delete a
SqlInjectionMatchSet if it's still used in any Rules or if it still contains any
SqlInjectionMatchTuple objects. If you just want to remove a SqlInjectionMatchSet from a
Rule, use UpdateRule. To permanently delete a SqlInjectionMatchSet from AWS WAF, perform
the following steps:   Update the SqlInjectionMatchSet to remove filters, if any. For more
information, see UpdateSqlInjectionMatchSet.   Use GetChangeToken to get the change token
that you provide in the ChangeToken parameter of a DeleteSqlInjectionMatchSet request.
Submit a DeleteSqlInjectionMatchSet request.

# Arguments
- `change_token`: The value returned by the most recent call to GetChangeToken.
- `sql_injection_match_set_id`: The SqlInjectionMatchSetId of the SqlInjectionMatchSet that
  you want to delete. SqlInjectionMatchSetId is returned by CreateSqlInjectionMatchSet and by
  ListSqlInjectionMatchSets.

"""
function delete_sql_injection_match_set(
    ChangeToken, SqlInjectionMatchSetId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "DeleteSqlInjectionMatchSet",
        Dict{String,Any}(
            "ChangeToken" => ChangeToken, "SqlInjectionMatchSetId" => SqlInjectionMatchSetId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_sql_injection_match_set(
    ChangeToken,
    SqlInjectionMatchSetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "DeleteSqlInjectionMatchSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ChangeToken" => ChangeToken,
                    "SqlInjectionMatchSetId" => SqlInjectionMatchSetId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_web_acl(change_token, web_aclid)
    delete_web_acl(change_token, web_aclid, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Permanently deletes a WebACL. You can't delete a WebACL if it
still contains any Rules. To delete a WebACL, perform the following steps:   Update the
WebACL to remove Rules, if any. For more information, see UpdateWebACL.   Use
GetChangeToken to get the change token that you provide in the ChangeToken parameter of a
DeleteWebACL request.   Submit a DeleteWebACL request.

# Arguments
- `change_token`: The value returned by the most recent call to GetChangeToken.
- `web_aclid`: The WebACLId of the WebACL that you want to delete. WebACLId is returned by
  CreateWebACL and by ListWebACLs.

"""
function delete_web_acl(
    ChangeToken, WebACLId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "DeleteWebACL",
        Dict{String,Any}("ChangeToken" => ChangeToken, "WebACLId" => WebACLId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_web_acl(
    ChangeToken,
    WebACLId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "DeleteWebACL",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ChangeToken" => ChangeToken, "WebACLId" => WebACLId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_xss_match_set(change_token, xss_match_set_id)
    delete_xss_match_set(change_token, xss_match_set_id, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Permanently deletes an XssMatchSet. You can't delete an
XssMatchSet if it's still used in any Rules or if it still contains any XssMatchTuple
objects. If you just want to remove an XssMatchSet from a Rule, use UpdateRule. To
permanently delete an XssMatchSet from AWS WAF, perform the following steps:   Update the
XssMatchSet to remove filters, if any. For more information, see UpdateXssMatchSet.   Use
GetChangeToken to get the change token that you provide in the ChangeToken parameter of a
DeleteXssMatchSet request.   Submit a DeleteXssMatchSet request.

# Arguments
- `change_token`: The value returned by the most recent call to GetChangeToken.
- `xss_match_set_id`: The XssMatchSetId of the XssMatchSet that you want to delete.
  XssMatchSetId is returned by CreateXssMatchSet and by ListXssMatchSets.

"""
function delete_xss_match_set(
    ChangeToken, XssMatchSetId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "DeleteXssMatchSet",
        Dict{String,Any}("ChangeToken" => ChangeToken, "XssMatchSetId" => XssMatchSetId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_xss_match_set(
    ChangeToken,
    XssMatchSetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "DeleteXssMatchSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ChangeToken" => ChangeToken, "XssMatchSetId" => XssMatchSetId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_byte_match_set(byte_match_set_id)
    get_byte_match_set(byte_match_set_id, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Returns the ByteMatchSet specified by ByteMatchSetId.

# Arguments
- `byte_match_set_id`: The ByteMatchSetId of the ByteMatchSet that you want to get.
  ByteMatchSetId is returned by CreateByteMatchSet and by ListByteMatchSets.

"""
function get_byte_match_set(
    ByteMatchSetId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "GetByteMatchSet",
        Dict{String,Any}("ByteMatchSetId" => ByteMatchSetId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_byte_match_set(
    ByteMatchSetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "GetByteMatchSet",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ByteMatchSetId" => ByteMatchSetId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_change_token()
    get_change_token(params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   When you want to create, update, or delete AWS WAF objects, get
a change token and include the change token in the create, update, or delete request.
Change tokens ensure that your application doesn't submit conflicting requests to AWS WAF.
Each create, update, or delete request must use a unique change token. If your application
submits a GetChangeToken request and then submits a second GetChangeToken request before
submitting a create, update, or delete request, the second GetChangeToken request returns
the same value as the first GetChangeToken request. When you use a change token in a
create, update, or delete request, the status of the change token changes to PENDING, which
indicates that AWS WAF is propagating the change to all AWS WAF servers. Use
GetChangeTokenStatus to determine the status of your change token.

"""
function get_change_token(; aws_config::AbstractAWSConfig=current_aws_config())
    return waf("GetChangeToken"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function get_change_token(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "GetChangeToken", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_change_token_status(change_token)
    get_change_token_status(change_token, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Returns the status of a ChangeToken that you got by calling
GetChangeToken. ChangeTokenStatus is one of the following values:    PROVISIONED: You
requested the change token by calling GetChangeToken, but you haven't used it yet in a call
to create, update, or delete an AWS WAF object.    PENDING: AWS WAF is propagating the
create, update, or delete request to all AWS WAF servers.    INSYNC: Propagation is
complete.

# Arguments
- `change_token`: The change token for which you want to get the status. This change token
  was previously returned in the GetChangeToken response.

"""
function get_change_token_status(
    ChangeToken; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "GetChangeTokenStatus",
        Dict{String,Any}("ChangeToken" => ChangeToken);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_change_token_status(
    ChangeToken,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "GetChangeTokenStatus",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ChangeToken" => ChangeToken), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_geo_match_set(geo_match_set_id)
    get_geo_match_set(geo_match_set_id, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Returns the GeoMatchSet that is specified by GeoMatchSetId.

# Arguments
- `geo_match_set_id`: The GeoMatchSetId of the GeoMatchSet that you want to get.
  GeoMatchSetId is returned by CreateGeoMatchSet and by ListGeoMatchSets.

"""
function get_geo_match_set(
    GeoMatchSetId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "GetGeoMatchSet",
        Dict{String,Any}("GeoMatchSetId" => GeoMatchSetId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_geo_match_set(
    GeoMatchSetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "GetGeoMatchSet",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("GeoMatchSetId" => GeoMatchSetId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_ipset(ipset_id)
    get_ipset(ipset_id, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Returns the IPSet that is specified by IPSetId.

# Arguments
- `ipset_id`: The IPSetId of the IPSet that you want to get. IPSetId is returned by
  CreateIPSet and by ListIPSets.

"""
function get_ipset(IPSetId; aws_config::AbstractAWSConfig=current_aws_config())
    return waf(
        "GetIPSet",
        Dict{String,Any}("IPSetId" => IPSetId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_ipset(
    IPSetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "GetIPSet",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("IPSetId" => IPSetId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_logging_configuration(resource_arn)
    get_logging_configuration(resource_arn, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Returns the LoggingConfiguration for the specified web ACL.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the web ACL for which you want to get
  the LoggingConfiguration.

"""
function get_logging_configuration(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "GetLoggingConfiguration",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_logging_configuration(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "GetLoggingConfiguration",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_permission_policy(resource_arn)
    get_permission_policy(resource_arn, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Returns the IAM policy attached to the RuleGroup.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the RuleGroup for which you want to get
  the policy.

"""
function get_permission_policy(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "GetPermissionPolicy",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_permission_policy(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "GetPermissionPolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_rate_based_rule(rule_id)
    get_rate_based_rule(rule_id, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Returns the RateBasedRule that is specified by the RuleId that
you included in the GetRateBasedRule request.

# Arguments
- `rule_id`: The RuleId of the RateBasedRule that you want to get. RuleId is returned by
  CreateRateBasedRule and by ListRateBasedRules.

"""
function get_rate_based_rule(RuleId; aws_config::AbstractAWSConfig=current_aws_config())
    return waf(
        "GetRateBasedRule",
        Dict{String,Any}("RuleId" => RuleId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_rate_based_rule(
    RuleId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "GetRateBasedRule",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("RuleId" => RuleId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_rate_based_rule_managed_keys(rule_id)
    get_rate_based_rule_managed_keys(rule_id, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Returns an array of IP addresses currently being blocked by the
RateBasedRule that is specified by the RuleId. The maximum number of managed keys that will
be blocked is 10,000. If more than 10,000 addresses exceed the rate limit, the 10,000
addresses with the highest rates will be blocked.

# Arguments
- `rule_id`: The RuleId of the RateBasedRule for which you want to get a list of
  ManagedKeys. RuleId is returned by CreateRateBasedRule and by ListRateBasedRules.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextMarker"`: A null value and not currently used. Do not include this in your request.
"""
function get_rate_based_rule_managed_keys(
    RuleId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "GetRateBasedRuleManagedKeys",
        Dict{String,Any}("RuleId" => RuleId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_rate_based_rule_managed_keys(
    RuleId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "GetRateBasedRuleManagedKeys",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("RuleId" => RuleId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_regex_match_set(regex_match_set_id)
    get_regex_match_set(regex_match_set_id, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Returns the RegexMatchSet specified by RegexMatchSetId.

# Arguments
- `regex_match_set_id`: The RegexMatchSetId of the RegexMatchSet that you want to get.
  RegexMatchSetId is returned by CreateRegexMatchSet and by ListRegexMatchSets.

"""
function get_regex_match_set(
    RegexMatchSetId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "GetRegexMatchSet",
        Dict{String,Any}("RegexMatchSetId" => RegexMatchSetId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_regex_match_set(
    RegexMatchSetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "GetRegexMatchSet",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("RegexMatchSetId" => RegexMatchSetId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_regex_pattern_set(regex_pattern_set_id)
    get_regex_pattern_set(regex_pattern_set_id, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Returns the RegexPatternSet specified by RegexPatternSetId.

# Arguments
- `regex_pattern_set_id`: The RegexPatternSetId of the RegexPatternSet that you want to
  get. RegexPatternSetId is returned by CreateRegexPatternSet and by ListRegexPatternSets.

"""
function get_regex_pattern_set(
    RegexPatternSetId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "GetRegexPatternSet",
        Dict{String,Any}("RegexPatternSetId" => RegexPatternSetId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_regex_pattern_set(
    RegexPatternSetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "GetRegexPatternSet",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("RegexPatternSetId" => RegexPatternSetId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_rule(rule_id)
    get_rule(rule_id, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Returns the Rule that is specified by the RuleId that you
included in the GetRule request.

# Arguments
- `rule_id`: The RuleId of the Rule that you want to get. RuleId is returned by CreateRule
  and by ListRules.

"""
function get_rule(RuleId; aws_config::AbstractAWSConfig=current_aws_config())
    return waf(
        "GetRule",
        Dict{String,Any}("RuleId" => RuleId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_rule(
    RuleId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "GetRule",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("RuleId" => RuleId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_rule_group(rule_group_id)
    get_rule_group(rule_group_id, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Returns the RuleGroup that is specified by the RuleGroupId that
you included in the GetRuleGroup request. To view the rules in a rule group, use
ListActivatedRulesInRuleGroup.

# Arguments
- `rule_group_id`: The RuleGroupId of the RuleGroup that you want to get. RuleGroupId is
  returned by CreateRuleGroup and by ListRuleGroups.

"""
function get_rule_group(RuleGroupId; aws_config::AbstractAWSConfig=current_aws_config())
    return waf(
        "GetRuleGroup",
        Dict{String,Any}("RuleGroupId" => RuleGroupId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_rule_group(
    RuleGroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "GetRuleGroup",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("RuleGroupId" => RuleGroupId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_sampled_requests(max_items, rule_id, time_window, web_acl_id)
    get_sampled_requests(max_items, rule_id, time_window, web_acl_id, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Gets detailed information about a specified number of
requests--a sample--that AWS WAF randomly selects from among the first 5,000 requests that
your AWS resource received during a time range that you choose. You can specify a sample
size of up to 500 requests, and you can specify any time range in the previous three hours.
 GetSampledRequests returns a time range, which is usually the time range that you
specified. However, if your resource (such as a CloudFront distribution) received 5,000
requests before the specified time range elapsed, GetSampledRequests returns an updated
time range. This new time range indicates the actual period during which AWS WAF selected
the requests in the sample.

# Arguments
- `max_items`: The number of requests that you want AWS WAF to return from among the first
  5,000 requests that your AWS resource received during the time range. If your resource
  received fewer requests than the value of MaxItems, GetSampledRequests returns information
  about all of them.
- `rule_id`:  RuleId is one of three values:   The RuleId of the Rule or the RuleGroupId of
  the RuleGroup for which you want GetSampledRequests to return a sample of requests.
  Default_Action, which causes GetSampledRequests to return a sample of the requests that
  didn't match any of the rules in the specified WebACL.
- `time_window`: The start date and time and the end date and time of the range for which
  you want GetSampledRequests to return a sample of requests. You must specify the times in
  Coordinated Universal Time (UTC) format. UTC format includes the special designator, Z. For
  example, \"2016-09-27T14:50Z\". You can specify any time range in the previous three hours.
- `web_acl_id`: The WebACLId of the WebACL for which you want GetSampledRequests to return
  a sample of requests.

"""
function get_sampled_requests(
    MaxItems,
    RuleId,
    TimeWindow,
    WebAclId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "GetSampledRequests",
        Dict{String,Any}(
            "MaxItems" => MaxItems,
            "RuleId" => RuleId,
            "TimeWindow" => TimeWindow,
            "WebAclId" => WebAclId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_sampled_requests(
    MaxItems,
    RuleId,
    TimeWindow,
    WebAclId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "GetSampledRequests",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "MaxItems" => MaxItems,
                    "RuleId" => RuleId,
                    "TimeWindow" => TimeWindow,
                    "WebAclId" => WebAclId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_size_constraint_set(size_constraint_set_id)
    get_size_constraint_set(size_constraint_set_id, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Returns the SizeConstraintSet specified by SizeConstraintSetId.

# Arguments
- `size_constraint_set_id`: The SizeConstraintSetId of the SizeConstraintSet that you want
  to get. SizeConstraintSetId is returned by CreateSizeConstraintSet and by
  ListSizeConstraintSets.

"""
function get_size_constraint_set(
    SizeConstraintSetId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "GetSizeConstraintSet",
        Dict{String,Any}("SizeConstraintSetId" => SizeConstraintSetId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_size_constraint_set(
    SizeConstraintSetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "GetSizeConstraintSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("SizeConstraintSetId" => SizeConstraintSetId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_sql_injection_match_set(sql_injection_match_set_id)
    get_sql_injection_match_set(sql_injection_match_set_id, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Returns the SqlInjectionMatchSet that is specified by
SqlInjectionMatchSetId.

# Arguments
- `sql_injection_match_set_id`: The SqlInjectionMatchSetId of the SqlInjectionMatchSet that
  you want to get. SqlInjectionMatchSetId is returned by CreateSqlInjectionMatchSet and by
  ListSqlInjectionMatchSets.

"""
function get_sql_injection_match_set(
    SqlInjectionMatchSetId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "GetSqlInjectionMatchSet",
        Dict{String,Any}("SqlInjectionMatchSetId" => SqlInjectionMatchSetId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_sql_injection_match_set(
    SqlInjectionMatchSetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "GetSqlInjectionMatchSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("SqlInjectionMatchSetId" => SqlInjectionMatchSetId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_web_acl(web_aclid)
    get_web_acl(web_aclid, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Returns the WebACL that is specified by WebACLId.

# Arguments
- `web_aclid`: The WebACLId of the WebACL that you want to get. WebACLId is returned by
  CreateWebACL and by ListWebACLs.

"""
function get_web_acl(WebACLId; aws_config::AbstractAWSConfig=current_aws_config())
    return waf(
        "GetWebACL",
        Dict{String,Any}("WebACLId" => WebACLId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_web_acl(
    WebACLId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "GetWebACL",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("WebACLId" => WebACLId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_xss_match_set(xss_match_set_id)
    get_xss_match_set(xss_match_set_id, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Returns the XssMatchSet that is specified by XssMatchSetId.

# Arguments
- `xss_match_set_id`: The XssMatchSetId of the XssMatchSet that you want to get.
  XssMatchSetId is returned by CreateXssMatchSet and by ListXssMatchSets.

"""
function get_xss_match_set(
    XssMatchSetId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "GetXssMatchSet",
        Dict{String,Any}("XssMatchSetId" => XssMatchSetId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_xss_match_set(
    XssMatchSetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "GetXssMatchSet",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("XssMatchSetId" => XssMatchSetId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_activated_rules_in_rule_group()
    list_activated_rules_in_rule_group(params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Returns an array of ActivatedRule objects.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: Specifies the number of ActivatedRules that you want AWS WAF to return for
  this request. If you have more ActivatedRules than the number that you specify for Limit,
  the response includes a NextMarker value that you can use to get another batch of
  ActivatedRules.
- `"NextMarker"`: If you specify a value for Limit and you have more ActivatedRules than
  the value of Limit, AWS WAF returns a NextMarker value in the response that allows you to
  list another group of ActivatedRules. For the second and subsequent
  ListActivatedRulesInRuleGroup requests, specify the value of NextMarker from the previous
  response to get information about another batch of ActivatedRules.
- `"RuleGroupId"`: The RuleGroupId of the RuleGroup for which you want to get a list of
  ActivatedRule objects.
"""
function list_activated_rules_in_rule_group(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "ListActivatedRulesInRuleGroup";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_activated_rules_in_rule_group(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "ListActivatedRulesInRuleGroup",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_byte_match_sets()
    list_byte_match_sets(params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Returns an array of ByteMatchSetSummary objects.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: Specifies the number of ByteMatchSet objects that you want AWS WAF to return
  for this request. If you have more ByteMatchSets objects than the number you specify for
  Limit, the response includes a NextMarker value that you can use to get another batch of
  ByteMatchSet objects.
- `"NextMarker"`: If you specify a value for Limit and you have more ByteMatchSets than the
  value of Limit, AWS WAF returns a NextMarker value in the response that allows you to list
  another group of ByteMatchSets. For the second and subsequent ListByteMatchSets requests,
  specify the value of NextMarker from the previous response to get information about another
  batch of ByteMatchSets.
"""
function list_byte_match_sets(; aws_config::AbstractAWSConfig=current_aws_config())
    return waf("ListByteMatchSets"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_byte_match_sets(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "ListByteMatchSets", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_geo_match_sets()
    list_geo_match_sets(params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Returns an array of GeoMatchSetSummary objects in the response.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: Specifies the number of GeoMatchSet objects that you want AWS WAF to return
  for this request. If you have more GeoMatchSet objects than the number you specify for
  Limit, the response includes a NextMarker value that you can use to get another batch of
  GeoMatchSet objects.
- `"NextMarker"`: If you specify a value for Limit and you have more GeoMatchSets than the
  value of Limit, AWS WAF returns a NextMarker value in the response that allows you to list
  another group of GeoMatchSet objects. For the second and subsequent ListGeoMatchSets
  requests, specify the value of NextMarker from the previous response to get information
  about another batch of GeoMatchSet objects.
"""
function list_geo_match_sets(; aws_config::AbstractAWSConfig=current_aws_config())
    return waf("ListGeoMatchSets"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_geo_match_sets(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "ListGeoMatchSets", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_ipsets()
    list_ipsets(params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Returns an array of IPSetSummary objects in the response.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: Specifies the number of IPSet objects that you want AWS WAF to return for this
  request. If you have more IPSet objects than the number you specify for Limit, the response
  includes a NextMarker value that you can use to get another batch of IPSet objects.
- `"NextMarker"`: AWS WAF returns a NextMarker value in the response that allows you to
  list another group of IPSets. For the second and subsequent ListIPSets requests, specify
  the value of NextMarker from the previous response to get information about another batch
  of IPSets.
"""
function list_ipsets(; aws_config::AbstractAWSConfig=current_aws_config())
    return waf("ListIPSets"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_ipsets(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf("ListIPSets", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end

"""
    list_logging_configurations()
    list_logging_configurations(params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Returns an array of LoggingConfiguration objects.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: Specifies the number of LoggingConfigurations that you want AWS WAF to return
  for this request. If you have more LoggingConfigurations than the number that you specify
  for Limit, the response includes a NextMarker value that you can use to get another batch
  of LoggingConfigurations.
- `"NextMarker"`: If you specify a value for Limit and you have more LoggingConfigurations
  than the value of Limit, AWS WAF returns a NextMarker value in the response that allows you
  to list another group of LoggingConfigurations. For the second and subsequent
  ListLoggingConfigurations requests, specify the value of NextMarker from the previous
  response to get information about another batch of ListLoggingConfigurations.
"""
function list_logging_configurations(; aws_config::AbstractAWSConfig=current_aws_config())
    return waf(
        "ListLoggingConfigurations"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_logging_configurations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "ListLoggingConfigurations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_rate_based_rules()
    list_rate_based_rules(params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Returns an array of RuleSummary objects.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: Specifies the number of Rules that you want AWS WAF to return for this
  request. If you have more Rules than the number that you specify for Limit, the response
  includes a NextMarker value that you can use to get another batch of Rules.
- `"NextMarker"`: If you specify a value for Limit and you have more Rules than the value
  of Limit, AWS WAF returns a NextMarker value in the response that allows you to list
  another group of Rules. For the second and subsequent ListRateBasedRules requests, specify
  the value of NextMarker from the previous response to get information about another batch
  of Rules.
"""
function list_rate_based_rules(; aws_config::AbstractAWSConfig=current_aws_config())
    return waf("ListRateBasedRules"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_rate_based_rules(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "ListRateBasedRules", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_regex_match_sets()
    list_regex_match_sets(params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Returns an array of RegexMatchSetSummary objects.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: Specifies the number of RegexMatchSet objects that you want AWS WAF to return
  for this request. If you have more RegexMatchSet objects than the number you specify for
  Limit, the response includes a NextMarker value that you can use to get another batch of
  RegexMatchSet objects.
- `"NextMarker"`: If you specify a value for Limit and you have more RegexMatchSet objects
  than the value of Limit, AWS WAF returns a NextMarker value in the response that allows you
  to list another group of ByteMatchSets. For the second and subsequent ListRegexMatchSets
  requests, specify the value of NextMarker from the previous response to get information
  about another batch of RegexMatchSet objects.
"""
function list_regex_match_sets(; aws_config::AbstractAWSConfig=current_aws_config())
    return waf("ListRegexMatchSets"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_regex_match_sets(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "ListRegexMatchSets", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_regex_pattern_sets()
    list_regex_pattern_sets(params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Returns an array of RegexPatternSetSummary objects.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: Specifies the number of RegexPatternSet objects that you want AWS WAF to
  return for this request. If you have more RegexPatternSet objects than the number you
  specify for Limit, the response includes a NextMarker value that you can use to get another
  batch of RegexPatternSet objects.
- `"NextMarker"`: If you specify a value for Limit and you have more RegexPatternSet
  objects than the value of Limit, AWS WAF returns a NextMarker value in the response that
  allows you to list another group of RegexPatternSet objects. For the second and subsequent
  ListRegexPatternSets requests, specify the value of NextMarker from the previous response
  to get information about another batch of RegexPatternSet objects.
"""
function list_regex_pattern_sets(; aws_config::AbstractAWSConfig=current_aws_config())
    return waf(
        "ListRegexPatternSets"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_regex_pattern_sets(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "ListRegexPatternSets",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_rule_groups()
    list_rule_groups(params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Returns an array of RuleGroup objects.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: Specifies the number of RuleGroups that you want AWS WAF to return for this
  request. If you have more RuleGroups than the number that you specify for Limit, the
  response includes a NextMarker value that you can use to get another batch of RuleGroups.
- `"NextMarker"`: If you specify a value for Limit and you have more RuleGroups than the
  value of Limit, AWS WAF returns a NextMarker value in the response that allows you to list
  another group of RuleGroups. For the second and subsequent ListRuleGroups requests, specify
  the value of NextMarker from the previous response to get information about another batch
  of RuleGroups.
"""
function list_rule_groups(; aws_config::AbstractAWSConfig=current_aws_config())
    return waf("ListRuleGroups"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_rule_groups(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "ListRuleGroups", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_rules()
    list_rules(params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Returns an array of RuleSummary objects.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: Specifies the number of Rules that you want AWS WAF to return for this
  request. If you have more Rules than the number that you specify for Limit, the response
  includes a NextMarker value that you can use to get another batch of Rules.
- `"NextMarker"`: If you specify a value for Limit and you have more Rules than the value
  of Limit, AWS WAF returns a NextMarker value in the response that allows you to list
  another group of Rules. For the second and subsequent ListRules requests, specify the value
  of NextMarker from the previous response to get information about another batch of Rules.
"""
function list_rules(; aws_config::AbstractAWSConfig=current_aws_config())
    return waf("ListRules"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_rules(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf("ListRules", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end

"""
    list_size_constraint_sets()
    list_size_constraint_sets(params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Returns an array of SizeConstraintSetSummary objects.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: Specifies the number of SizeConstraintSet objects that you want AWS WAF to
  return for this request. If you have more SizeConstraintSets objects than the number you
  specify for Limit, the response includes a NextMarker value that you can use to get another
  batch of SizeConstraintSet objects.
- `"NextMarker"`: If you specify a value for Limit and you have more SizeConstraintSets
  than the value of Limit, AWS WAF returns a NextMarker value in the response that allows you
  to list another group of SizeConstraintSets. For the second and subsequent
  ListSizeConstraintSets requests, specify the value of NextMarker from the previous response
  to get information about another batch of SizeConstraintSets.
"""
function list_size_constraint_sets(; aws_config::AbstractAWSConfig=current_aws_config())
    return waf(
        "ListSizeConstraintSets"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_size_constraint_sets(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "ListSizeConstraintSets",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_sql_injection_match_sets()
    list_sql_injection_match_sets(params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Returns an array of SqlInjectionMatchSet objects.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: Specifies the number of SqlInjectionMatchSet objects that you want AWS WAF to
  return for this request. If you have more SqlInjectionMatchSet objects than the number you
  specify for Limit, the response includes a NextMarker value that you can use to get another
  batch of Rules.
- `"NextMarker"`: If you specify a value for Limit and you have more SqlInjectionMatchSet
  objects than the value of Limit, AWS WAF returns a NextMarker value in the response that
  allows you to list another group of SqlInjectionMatchSets. For the second and subsequent
  ListSqlInjectionMatchSets requests, specify the value of NextMarker from the previous
  response to get information about another batch of SqlInjectionMatchSets.
"""
function list_sql_injection_match_sets(; aws_config::AbstractAWSConfig=current_aws_config())
    return waf(
        "ListSqlInjectionMatchSets"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_sql_injection_match_sets(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "ListSqlInjectionMatchSets",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_subscribed_rule_groups()
    list_subscribed_rule_groups(params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Returns an array of RuleGroup objects that you are subscribed to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: Specifies the number of subscribed rule groups that you want AWS WAF to return
  for this request. If you have more objects than the number you specify for Limit, the
  response includes a NextMarker value that you can use to get another batch of objects.
- `"NextMarker"`: If you specify a value for Limit and you have more
  ByteMatchSetssubscribed rule groups than the value of Limit, AWS WAF returns a NextMarker
  value in the response that allows you to list another group of subscribed rule groups. For
  the second and subsequent ListSubscribedRuleGroupsRequest requests, specify the value of
  NextMarker from the previous response to get information about another batch of subscribed
  rule groups.
"""
function list_subscribed_rule_groups(; aws_config::AbstractAWSConfig=current_aws_config())
    return waf(
        "ListSubscribedRuleGroups"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_subscribed_rule_groups(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "ListSubscribedRuleGroups",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Retrieves the tags associated with the specified AWS resource.
Tags are key:value pairs that you can use to categorize and manage your resources, for
purposes like billing. For example, you might set the tag key to \"customer\" and the value
to the customer name or ID. You can specify one or more tags to add to each AWS resource,
up to 50 tags for a resource. Tagging is only available through the API, SDKs, and CLI. You
can't manage or view tags through the AWS WAF Classic console. You can tag the AWS
resources that you manage through AWS WAF Classic: web ACLs, rule groups, and rules.

# Arguments
- `resource_arn`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`:
- `"NextMarker"`:
"""
function list_tags_for_resource(
    ResourceARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "ListTagsForResource",
        Dict{String,Any}("ResourceARN" => ResourceARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceARN" => ResourceARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_web_acls()
    list_web_acls(params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Returns an array of WebACLSummary objects in the response.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: Specifies the number of WebACL objects that you want AWS WAF to return for
  this request. If you have more WebACL objects than the number that you specify for Limit,
  the response includes a NextMarker value that you can use to get another batch of WebACL
  objects.
- `"NextMarker"`: If you specify a value for Limit and you have more WebACL objects than
  the number that you specify for Limit, AWS WAF returns a NextMarker value in the response
  that allows you to list another group of WebACL objects. For the second and subsequent
  ListWebACLs requests, specify the value of NextMarker from the previous response to get
  information about another batch of WebACL objects.
"""
function list_web_acls(; aws_config::AbstractAWSConfig=current_aws_config())
    return waf("ListWebACLs"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_web_acls(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "ListWebACLs", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_xss_match_sets()
    list_xss_match_sets(params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Returns an array of XssMatchSet objects.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: Specifies the number of XssMatchSet objects that you want AWS WAF to return
  for this request. If you have more XssMatchSet objects than the number you specify for
  Limit, the response includes a NextMarker value that you can use to get another batch of
  Rules.
- `"NextMarker"`: If you specify a value for Limit and you have more XssMatchSet objects
  than the value of Limit, AWS WAF returns a NextMarker value in the response that allows you
  to list another group of XssMatchSets. For the second and subsequent ListXssMatchSets
  requests, specify the value of NextMarker from the previous response to get information
  about another batch of XssMatchSets.
"""
function list_xss_match_sets(; aws_config::AbstractAWSConfig=current_aws_config())
    return waf("ListXssMatchSets"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_xss_match_sets(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "ListXssMatchSets", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    put_logging_configuration(logging_configuration)
    put_logging_configuration(logging_configuration, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Associates a LoggingConfiguration with a specified web ACL. You
can access information about all traffic that AWS WAF inspects using the following steps:
Create an Amazon Kinesis Data Firehose.  Create the data firehose with a PUT source and in
the region that you are operating. However, if you are capturing logs for Amazon
CloudFront, always create the firehose in US East (N. Virginia).   Do not create the data
firehose using a Kinesis stream as your source.    Associate that firehose to your web ACL
using a PutLoggingConfiguration request.   When you successfully enable logging using a
PutLoggingConfiguration request, AWS WAF will create a service linked role with the
necessary permissions to write logs to the Amazon Kinesis Data Firehose. For more
information, see Logging Web ACL Traffic Information in the AWS WAF Developer Guide.

# Arguments
- `logging_configuration`: The Amazon Kinesis Data Firehose that contains the inspected
  traffic information, the redacted fields details, and the Amazon Resource Name (ARN) of the
  web ACL to monitor.  When specifying Type in RedactedFields, you must use one of the
  following values: URI, QUERY_STRING, HEADER, or METHOD.

"""
function put_logging_configuration(
    LoggingConfiguration; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "PutLoggingConfiguration",
        Dict{String,Any}("LoggingConfiguration" => LoggingConfiguration);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_logging_configuration(
    LoggingConfiguration,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "PutLoggingConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("LoggingConfiguration" => LoggingConfiguration),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_permission_policy(policy, resource_arn)
    put_permission_policy(policy, resource_arn, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Attaches an IAM policy to the specified resource. The only
supported use for this action is to share a RuleGroup across accounts. The
PutPermissionPolicy is subject to the following restrictions:   You can attach only one
policy with each PutPermissionPolicy request.   The policy must include an Effect, Action
and Principal.     Effect must specify Allow.   The Action in the policy must be
waf:UpdateWebACL, waf-regional:UpdateWebACL, waf:GetRuleGroup and waf-regional:GetRuleGroup
. Any extra or wildcard actions in the policy will be rejected.   The policy cannot include
a Resource parameter.   The ARN in the request must be a valid WAF RuleGroup ARN and the
RuleGroup must exist in the same region.   The user making the request must be the owner of
the RuleGroup.   Your policy must be composed using IAM Policy version 2012-10-17.   For
more information, see IAM Policies.  An example of a valid policy parameter is shown in the
Examples section below.

# Arguments
- `policy`: The policy to attach to the specified RuleGroup.
- `resource_arn`: The Amazon Resource Name (ARN) of the RuleGroup to which you want to
  attach the policy.

"""
function put_permission_policy(
    Policy, ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "PutPermissionPolicy",
        Dict{String,Any}("Policy" => Policy, "ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_permission_policy(
    Policy,
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "PutPermissionPolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Policy" => Policy, "ResourceArn" => ResourceArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Associates tags with the specified AWS resource. Tags are
key:value pairs that you can use to categorize and manage your resources, for purposes like
billing. For example, you might set the tag key to \"customer\" and the value to the
customer name or ID. You can specify one or more tags to add to each AWS resource, up to 50
tags for a resource. Tagging is only available through the API, SDKs, and CLI. You can't
manage or view tags through the AWS WAF Classic console. You can use this action to tag the
AWS resources that you manage through AWS WAF Classic: web ACLs, rule groups, and rules.

# Arguments
- `resource_arn`:
- `tags`:

"""
function tag_resource(ResourceARN, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return waf(
        "TagResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceARN,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.

# Arguments
- `resource_arn`:
- `tag_keys`:

"""
function untag_resource(
    ResourceARN, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "UntagResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceARN,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_byte_match_set(byte_match_set_id, change_token, updates)
    update_byte_match_set(byte_match_set_id, change_token, updates, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Inserts or deletes ByteMatchTuple objects (filters) in a
ByteMatchSet. For each ByteMatchTuple object, you specify the following values:    Whether
to insert or delete the object from the array. If you want to change a ByteMatchSetUpdate
object, you delete the existing object and add a new one.   The part of a web request that
you want AWS WAF to inspect, such as a query string or the value of the User-Agent header.
  The bytes (typically a string that corresponds with ASCII characters) that you want AWS
WAF to look for. For more information, including how you specify the values for the AWS WAF
API and the AWS CLI or SDKs, see TargetString in the ByteMatchTuple data type.    Where to
look, such as at the beginning or the end of a query string.   Whether to perform any
conversions on the request, such as converting it to lowercase, before inspecting it for
the specified string.   For example, you can add a ByteMatchSetUpdate object that matches
web requests in which User-Agent headers contain the string BadBot. You can then configure
AWS WAF to block those requests. To create and configure a ByteMatchSet, perform the
following steps:   Create a ByteMatchSet. For more information, see CreateByteMatchSet.
Use GetChangeToken to get the change token that you provide in the ChangeToken parameter of
an UpdateByteMatchSet request.   Submit an UpdateByteMatchSet request to specify the part
of the request that you want AWS WAF to inspect (for example, the header or the URI) and
the value that you want AWS WAF to watch for.   For more information about how to use the
AWS WAF API to allow or block HTTP requests, see the AWS WAF Developer Guide.

# Arguments
- `byte_match_set_id`: The ByteMatchSetId of the ByteMatchSet that you want to update.
  ByteMatchSetId is returned by CreateByteMatchSet and by ListByteMatchSets.
- `change_token`: The value returned by the most recent call to GetChangeToken.
- `updates`: An array of ByteMatchSetUpdate objects that you want to insert into or delete
  from a ByteMatchSet. For more information, see the applicable data types:
  ByteMatchSetUpdate: Contains Action and ByteMatchTuple     ByteMatchTuple: Contains
  FieldToMatch, PositionalConstraint, TargetString, and TextTransformation     FieldToMatch:
  Contains Data and Type

"""
function update_byte_match_set(
    ByteMatchSetId, ChangeToken, Updates; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "UpdateByteMatchSet",
        Dict{String,Any}(
            "ByteMatchSetId" => ByteMatchSetId,
            "ChangeToken" => ChangeToken,
            "Updates" => Updates,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_byte_match_set(
    ByteMatchSetId,
    ChangeToken,
    Updates,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "UpdateByteMatchSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ByteMatchSetId" => ByteMatchSetId,
                    "ChangeToken" => ChangeToken,
                    "Updates" => Updates,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_geo_match_set(change_token, geo_match_set_id, updates)
    update_geo_match_set(change_token, geo_match_set_id, updates, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Inserts or deletes GeoMatchConstraint objects in an GeoMatchSet.
For each GeoMatchConstraint object, you specify the following values:    Whether to insert
or delete the object from the array. If you want to change an GeoMatchConstraint object,
you delete the existing object and add a new one.   The Type. The only valid value for Type
is Country.   The Value, which is a two character code for the country to add to the
GeoMatchConstraint object. Valid codes are listed in GeoMatchConstraintValue.   To create
and configure an GeoMatchSet, perform the following steps:   Submit a CreateGeoMatchSet
request.   Use GetChangeToken to get the change token that you provide in the ChangeToken
parameter of an UpdateGeoMatchSet request.   Submit an UpdateGeoMatchSet request to specify
the country that you want AWS WAF to watch for.   When you update an GeoMatchSet, you
specify the country that you want to add and/or the country that you want to delete. If you
want to change a country, you delete the existing country and add the new one. For more
information about how to use the AWS WAF API to allow or block HTTP requests, see the AWS
WAF Developer Guide.

# Arguments
- `change_token`: The value returned by the most recent call to GetChangeToken.
- `geo_match_set_id`: The GeoMatchSetId of the GeoMatchSet that you want to update.
  GeoMatchSetId is returned by CreateGeoMatchSet and by ListGeoMatchSets.
- `updates`: An array of GeoMatchSetUpdate objects that you want to insert into or delete
  from an GeoMatchSet. For more information, see the applicable data types:
  GeoMatchSetUpdate: Contains Action and GeoMatchConstraint     GeoMatchConstraint: Contains
  Type and Value  You can have only one Type and Value per GeoMatchConstraint. To add
  multiple countries, include multiple GeoMatchSetUpdate objects in your request.

"""
function update_geo_match_set(
    ChangeToken, GeoMatchSetId, Updates; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "UpdateGeoMatchSet",
        Dict{String,Any}(
            "ChangeToken" => ChangeToken,
            "GeoMatchSetId" => GeoMatchSetId,
            "Updates" => Updates,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_geo_match_set(
    ChangeToken,
    GeoMatchSetId,
    Updates,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "UpdateGeoMatchSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ChangeToken" => ChangeToken,
                    "GeoMatchSetId" => GeoMatchSetId,
                    "Updates" => Updates,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_ipset(change_token, ipset_id, updates)
    update_ipset(change_token, ipset_id, updates, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Inserts or deletes IPSetDescriptor objects in an IPSet. For each
IPSetDescriptor object, you specify the following values:    Whether to insert or delete
the object from the array. If you want to change an IPSetDescriptor object, you delete the
existing object and add a new one.   The IP address version, IPv4 or IPv6.    The IP
address in CIDR notation, for example, 192.0.2.0/24 (for the range of IP addresses from
192.0.2.0 to 192.0.2.255) or 192.0.2.44/32 (for the individual IP address 192.0.2.44).
AWS WAF supports IPv4 address ranges: /8 and any range between /16 through /32. AWS WAF
supports IPv6 address ranges: /24, /32, /48, /56, /64, and /128. For more information about
CIDR notation, see the Wikipedia entry Classless Inter-Domain Routing. IPv6 addresses can
be represented using any of the following formats:
1111:0000:0000:0000:0000:0000:0000:0111/128   1111:0:0:0:0:0:0:0111/128   1111::0111/128
1111::111/128   You use an IPSet to specify which web requests you want to allow or block
based on the IP addresses that the requests originated from. For example, if you're
receiving a lot of requests from one or a small number of IP addresses and you want to
block the requests, you can create an IPSet that specifies those IP addresses, and then
configure AWS WAF to block the requests.  To create and configure an IPSet, perform the
following steps:   Submit a CreateIPSet request.   Use GetChangeToken to get the change
token that you provide in the ChangeToken parameter of an UpdateIPSet request.   Submit an
UpdateIPSet request to specify the IP addresses that you want AWS WAF to watch for.   When
you update an IPSet, you specify the IP addresses that you want to add and/or the IP
addresses that you want to delete. If you want to change an IP address, you delete the
existing IP address and add the new one. You can insert a maximum of 1000 addresses in a
single request. For more information about how to use the AWS WAF API to allow or block
HTTP requests, see the AWS WAF Developer Guide.

# Arguments
- `change_token`: The value returned by the most recent call to GetChangeToken.
- `ipset_id`: The IPSetId of the IPSet that you want to update. IPSetId is returned by
  CreateIPSet and by ListIPSets.
- `updates`: An array of IPSetUpdate objects that you want to insert into or delete from an
  IPSet. For more information, see the applicable data types:    IPSetUpdate: Contains Action
  and IPSetDescriptor     IPSetDescriptor: Contains Type and Value    You can insert a
  maximum of 1000 addresses in a single request.

"""
function update_ipset(
    ChangeToken, IPSetId, Updates; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "UpdateIPSet",
        Dict{String,Any}(
            "ChangeToken" => ChangeToken, "IPSetId" => IPSetId, "Updates" => Updates
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_ipset(
    ChangeToken,
    IPSetId,
    Updates,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "UpdateIPSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ChangeToken" => ChangeToken, "IPSetId" => IPSetId, "Updates" => Updates
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_rate_based_rule(change_token, rate_limit, rule_id, updates)
    update_rate_based_rule(change_token, rate_limit, rule_id, updates, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Inserts or deletes Predicate objects in a rule and updates the
RateLimit in the rule.  Each Predicate object identifies a predicate, such as a
ByteMatchSet or an IPSet, that specifies the web requests that you want to block or count.
The RateLimit specifies the number of requests every five minutes that triggers the rule.
If you add more than one predicate to a RateBasedRule, a request must match all the
predicates and exceed the RateLimit to be counted or blocked. For example, suppose you add
the following to a RateBasedRule:   An IPSet that matches the IP address 192.0.2.44/32    A
ByteMatchSet that matches BadBot in the User-Agent header   Further, you specify a
RateLimit of 1,000. You then add the RateBasedRule to a WebACL and specify that you want to
block requests that satisfy the rule. For a request to be blocked, it must come from the IP
address 192.0.2.44 and the User-Agent header in the request must contain the value BadBot.
Further, requests that match these two conditions much be received at a rate of more than
1,000 every five minutes. If the rate drops below this limit, AWS WAF no longer blocks the
requests. As a second example, suppose you want to limit requests to a particular page on
your site. To do this, you could add the following to a RateBasedRule:   A ByteMatchSet
with FieldToMatch of URI    A PositionalConstraint of STARTS_WITH    A TargetString of
login    Further, you specify a RateLimit of 1,000. By adding this RateBasedRule to a
WebACL, you could limit requests to your login page without affecting the rest of your site.

# Arguments
- `change_token`: The value returned by the most recent call to GetChangeToken.
- `rate_limit`: The maximum number of requests, which have an identical value in the field
  specified by the RateKey, allowed in a five-minute period. If the number of requests
  exceeds the RateLimit and the other predicates specified in the rule are also met, AWS WAF
  triggers the action that is specified for this rule.
- `rule_id`: The RuleId of the RateBasedRule that you want to update. RuleId is returned by
  CreateRateBasedRule and by ListRateBasedRules.
- `updates`: An array of RuleUpdate objects that you want to insert into or delete from a
  RateBasedRule.

"""
function update_rate_based_rule(
    ChangeToken,
    RateLimit,
    RuleId,
    Updates;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "UpdateRateBasedRule",
        Dict{String,Any}(
            "ChangeToken" => ChangeToken,
            "RateLimit" => RateLimit,
            "RuleId" => RuleId,
            "Updates" => Updates,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_rate_based_rule(
    ChangeToken,
    RateLimit,
    RuleId,
    Updates,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "UpdateRateBasedRule",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ChangeToken" => ChangeToken,
                    "RateLimit" => RateLimit,
                    "RuleId" => RuleId,
                    "Updates" => Updates,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_regex_match_set(change_token, regex_match_set_id, updates)
    update_regex_match_set(change_token, regex_match_set_id, updates, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Inserts or deletes RegexMatchTuple objects (filters) in a
RegexMatchSet. For each RegexMatchSetUpdate object, you specify the following values:
Whether to insert or delete the object from the array. If you want to change a
RegexMatchSetUpdate object, you delete the existing object and add a new one.   The part of
a web request that you want AWS WAF to inspectupdate, such as a query string or the value
of the User-Agent header.    The identifier of the pattern (a regular expression) that you
want AWS WAF to look for. For more information, see RegexPatternSet.    Whether to perform
any conversions on the request, such as converting it to lowercase, before inspecting it
for the specified string.    For example, you can create a RegexPatternSet that matches any
requests with User-Agent headers that contain the string B[a@]dB[o0]t. You can then
configure AWS WAF to reject those requests. To create and configure a RegexMatchSet,
perform the following steps:   Create a RegexMatchSet. For more information, see
CreateRegexMatchSet.   Use GetChangeToken to get the change token that you provide in the
ChangeToken parameter of an UpdateRegexMatchSet request.   Submit an UpdateRegexMatchSet
request to specify the part of the request that you want AWS WAF to inspect (for example,
the header or the URI) and the identifier of the RegexPatternSet that contain the regular
expression patters you want AWS WAF to watch for.   For more information about how to use
the AWS WAF API to allow or block HTTP requests, see the AWS WAF Developer Guide.

# Arguments
- `change_token`: The value returned by the most recent call to GetChangeToken.
- `regex_match_set_id`: The RegexMatchSetId of the RegexMatchSet that you want to update.
  RegexMatchSetId is returned by CreateRegexMatchSet and by ListRegexMatchSets.
- `updates`: An array of RegexMatchSetUpdate objects that you want to insert into or delete
  from a RegexMatchSet. For more information, see RegexMatchTuple.

"""
function update_regex_match_set(
    ChangeToken,
    RegexMatchSetId,
    Updates;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "UpdateRegexMatchSet",
        Dict{String,Any}(
            "ChangeToken" => ChangeToken,
            "RegexMatchSetId" => RegexMatchSetId,
            "Updates" => Updates,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_regex_match_set(
    ChangeToken,
    RegexMatchSetId,
    Updates,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "UpdateRegexMatchSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ChangeToken" => ChangeToken,
                    "RegexMatchSetId" => RegexMatchSetId,
                    "Updates" => Updates,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_regex_pattern_set(change_token, regex_pattern_set_id, updates)
    update_regex_pattern_set(change_token, regex_pattern_set_id, updates, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Inserts or deletes RegexPatternString objects in a
RegexPatternSet. For each RegexPatternString object, you specify the following values:
Whether to insert or delete the RegexPatternString.   The regular expression pattern that
you want to insert or delete. For more information, see RegexPatternSet.     For example,
you can create a RegexPatternString such as B[a@]dB[o0]t. AWS WAF will match this
RegexPatternString to:   BadBot   BadB0t   B@dBot   B@dB0t   To create and configure a
RegexPatternSet, perform the following steps:   Create a RegexPatternSet. For more
information, see CreateRegexPatternSet.   Use GetChangeToken to get the change token that
you provide in the ChangeToken parameter of an UpdateRegexPatternSet request.   Submit an
UpdateRegexPatternSet request to specify the regular expression pattern that you want AWS
WAF to watch for.   For more information about how to use the AWS WAF API to allow or block
HTTP requests, see the AWS WAF Developer Guide.

# Arguments
- `change_token`: The value returned by the most recent call to GetChangeToken.
- `regex_pattern_set_id`: The RegexPatternSetId of the RegexPatternSet that you want to
  update. RegexPatternSetId is returned by CreateRegexPatternSet and by ListRegexPatternSets.
- `updates`: An array of RegexPatternSetUpdate objects that you want to insert into or
  delete from a RegexPatternSet.

"""
function update_regex_pattern_set(
    ChangeToken,
    RegexPatternSetId,
    Updates;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "UpdateRegexPatternSet",
        Dict{String,Any}(
            "ChangeToken" => ChangeToken,
            "RegexPatternSetId" => RegexPatternSetId,
            "Updates" => Updates,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_regex_pattern_set(
    ChangeToken,
    RegexPatternSetId,
    Updates,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "UpdateRegexPatternSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ChangeToken" => ChangeToken,
                    "RegexPatternSetId" => RegexPatternSetId,
                    "Updates" => Updates,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_rule(change_token, rule_id, updates)
    update_rule(change_token, rule_id, updates, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Inserts or deletes Predicate objects in a Rule. Each Predicate
object identifies a predicate, such as a ByteMatchSet or an IPSet, that specifies the web
requests that you want to allow, block, or count. If you add more than one predicate to a
Rule, a request must match all of the specifications to be allowed, blocked, or counted.
For example, suppose that you add the following to a Rule:    A ByteMatchSet that matches
the value BadBot in the User-Agent header   An IPSet that matches the IP address 192.0.2.44
   You then add the Rule to a WebACL and specify that you want to block requests that
satisfy the Rule. For a request to be blocked, the User-Agent header in the request must
contain the value BadBot and the request must originate from the IP address 192.0.2.44. To
create and configure a Rule, perform the following steps:   Create and update the
predicates that you want to include in the Rule.   Create the Rule. See CreateRule.   Use
GetChangeToken to get the change token that you provide in the ChangeToken parameter of an
UpdateRule request.   Submit an UpdateRule request to add predicates to the Rule.   Create
and update a WebACL that contains the Rule. See CreateWebACL.   If you want to replace one
ByteMatchSet or IPSet with another, you delete the existing one and add the new one. For
more information about how to use the AWS WAF API to allow or block HTTP requests, see the
AWS WAF Developer Guide.

# Arguments
- `change_token`: The value returned by the most recent call to GetChangeToken.
- `rule_id`: The RuleId of the Rule that you want to update. RuleId is returned by
  CreateRule and by ListRules.
- `updates`: An array of RuleUpdate objects that you want to insert into or delete from a
  Rule. For more information, see the applicable data types:    RuleUpdate: Contains Action
  and Predicate     Predicate: Contains DataId, Negated, and Type     FieldToMatch: Contains
  Data and Type

"""
function update_rule(
    ChangeToken, RuleId, Updates; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "UpdateRule",
        Dict{String,Any}(
            "ChangeToken" => ChangeToken, "RuleId" => RuleId, "Updates" => Updates
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_rule(
    ChangeToken,
    RuleId,
    Updates,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "UpdateRule",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ChangeToken" => ChangeToken, "RuleId" => RuleId, "Updates" => Updates
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_rule_group(change_token, rule_group_id, updates)
    update_rule_group(change_token, rule_group_id, updates, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Inserts or deletes ActivatedRule objects in a RuleGroup. You can
only insert REGULAR rules into a rule group. You can have a maximum of ten rules per rule
group. To create and configure a RuleGroup, perform the following steps:   Create and
update the Rules that you want to include in the RuleGroup. See CreateRule.   Use
GetChangeToken to get the change token that you provide in the ChangeToken parameter of an
UpdateRuleGroup request.   Submit an UpdateRuleGroup request to add Rules to the RuleGroup.
  Create and update a WebACL that contains the RuleGroup. See CreateWebACL.   If you want
to replace one Rule with another, you delete the existing one and add the new one. For more
information about how to use the AWS WAF API to allow or block HTTP requests, see the AWS
WAF Developer Guide.

# Arguments
- `change_token`: The value returned by the most recent call to GetChangeToken.
- `rule_group_id`: The RuleGroupId of the RuleGroup that you want to update. RuleGroupId is
  returned by CreateRuleGroup and by ListRuleGroups.
- `updates`: An array of RuleGroupUpdate objects that you want to insert into or delete
  from a RuleGroup. You can only insert REGULAR rules into a rule group.
  ActivatedRule|OverrideAction applies only when updating or adding a RuleGroup to a WebACL.
  In this case you do not use ActivatedRule|Action. For all other update requests,
  ActivatedRule|Action is used instead of ActivatedRule|OverrideAction.

"""
function update_rule_group(
    ChangeToken, RuleGroupId, Updates; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "UpdateRuleGroup",
        Dict{String,Any}(
            "ChangeToken" => ChangeToken, "RuleGroupId" => RuleGroupId, "Updates" => Updates
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_rule_group(
    ChangeToken,
    RuleGroupId,
    Updates,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "UpdateRuleGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ChangeToken" => ChangeToken,
                    "RuleGroupId" => RuleGroupId,
                    "Updates" => Updates,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_size_constraint_set(change_token, size_constraint_set_id, updates)
    update_size_constraint_set(change_token, size_constraint_set_id, updates, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Inserts or deletes SizeConstraint objects (filters) in a
SizeConstraintSet. For each SizeConstraint object, you specify the following values:
Whether to insert or delete the object from the array. If you want to change a
SizeConstraintSetUpdate object, you delete the existing object and add a new one.   The
part of a web request that you want AWS WAF to evaluate, such as the length of a query
string or the length of the User-Agent header.   Whether to perform any transformations on
the request, such as converting it to lowercase, before checking its length. Note that
transformations of the request body are not supported because the AWS resource forwards
only the first 8192 bytes of your request to AWS WAF. You can only specify a single type of
TextTransformation.   A ComparisonOperator used for evaluating the selected part of the
request against the specified Size, such as equals, greater than, less than, and so on.
The length, in bytes, that you want AWS WAF to watch for in selected part of the request.
The length is computed after applying the transformation.   For example, you can add a
SizeConstraintSetUpdate object that matches web requests in which the length of the
User-Agent header is greater than 100 bytes. You can then configure AWS WAF to block those
requests. To create and configure a SizeConstraintSet, perform the following steps:
Create a SizeConstraintSet. For more information, see CreateSizeConstraintSet.   Use
GetChangeToken to get the change token that you provide in the ChangeToken parameter of an
UpdateSizeConstraintSet request.   Submit an UpdateSizeConstraintSet request to specify the
part of the request that you want AWS WAF to inspect (for example, the header or the URI)
and the value that you want AWS WAF to watch for.   For more information about how to use
the AWS WAF API to allow or block HTTP requests, see the AWS WAF Developer Guide.

# Arguments
- `change_token`: The value returned by the most recent call to GetChangeToken.
- `size_constraint_set_id`: The SizeConstraintSetId of the SizeConstraintSet that you want
  to update. SizeConstraintSetId is returned by CreateSizeConstraintSet and by
  ListSizeConstraintSets.
- `updates`: An array of SizeConstraintSetUpdate objects that you want to insert into or
  delete from a SizeConstraintSet. For more information, see the applicable data types:
  SizeConstraintSetUpdate: Contains Action and SizeConstraint     SizeConstraint: Contains
  FieldToMatch, TextTransformation, ComparisonOperator, and Size     FieldToMatch: Contains
  Data and Type

"""
function update_size_constraint_set(
    ChangeToken,
    SizeConstraintSetId,
    Updates;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "UpdateSizeConstraintSet",
        Dict{String,Any}(
            "ChangeToken" => ChangeToken,
            "SizeConstraintSetId" => SizeConstraintSetId,
            "Updates" => Updates,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_size_constraint_set(
    ChangeToken,
    SizeConstraintSetId,
    Updates,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "UpdateSizeConstraintSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ChangeToken" => ChangeToken,
                    "SizeConstraintSetId" => SizeConstraintSetId,
                    "Updates" => Updates,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_sql_injection_match_set(change_token, sql_injection_match_set_id, updates)
    update_sql_injection_match_set(change_token, sql_injection_match_set_id, updates, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Inserts or deletes SqlInjectionMatchTuple objects (filters) in a
SqlInjectionMatchSet. For each SqlInjectionMatchTuple object, you specify the following
values:    Action: Whether to insert the object into or delete the object from the array.
To change a SqlInjectionMatchTuple, you delete the existing object and add a new one.
FieldToMatch: The part of web requests that you want AWS WAF to inspect and, if you want
AWS WAF to inspect a header or custom query parameter, the name of the header or parameter.
   TextTransformation: Which text transformation, if any, to perform on the web request
before inspecting the request for snippets of malicious SQL code. You can only specify a
single type of TextTransformation.   You use SqlInjectionMatchSet objects to specify which
CloudFront requests that you want to allow, block, or count. For example, if you're
receiving requests that contain snippets of SQL code in the query string and you want to
block the requests, you can create a SqlInjectionMatchSet with the applicable settings, and
then configure AWS WAF to block the requests.  To create and configure a
SqlInjectionMatchSet, perform the following steps:   Submit a CreateSqlInjectionMatchSet
request.   Use GetChangeToken to get the change token that you provide in the ChangeToken
parameter of an UpdateIPSet request.   Submit an UpdateSqlInjectionMatchSet request to
specify the parts of web requests that you want AWS WAF to inspect for snippets of SQL
code.   For more information about how to use the AWS WAF API to allow or block HTTP
requests, see the AWS WAF Developer Guide.

# Arguments
- `change_token`: The value returned by the most recent call to GetChangeToken.
- `sql_injection_match_set_id`: The SqlInjectionMatchSetId of the SqlInjectionMatchSet that
  you want to update. SqlInjectionMatchSetId is returned by CreateSqlInjectionMatchSet and by
  ListSqlInjectionMatchSets.
- `updates`: An array of SqlInjectionMatchSetUpdate objects that you want to insert into or
  delete from a SqlInjectionMatchSet. For more information, see the applicable data types:
  SqlInjectionMatchSetUpdate: Contains Action and SqlInjectionMatchTuple
  SqlInjectionMatchTuple: Contains FieldToMatch and TextTransformation     FieldToMatch:
  Contains Data and Type

"""
function update_sql_injection_match_set(
    ChangeToken,
    SqlInjectionMatchSetId,
    Updates;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "UpdateSqlInjectionMatchSet",
        Dict{String,Any}(
            "ChangeToken" => ChangeToken,
            "SqlInjectionMatchSetId" => SqlInjectionMatchSetId,
            "Updates" => Updates,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_sql_injection_match_set(
    ChangeToken,
    SqlInjectionMatchSetId,
    Updates,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "UpdateSqlInjectionMatchSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ChangeToken" => ChangeToken,
                    "SqlInjectionMatchSetId" => SqlInjectionMatchSetId,
                    "Updates" => Updates,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_web_acl(change_token, web_aclid)
    update_web_acl(change_token, web_aclid, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Inserts or deletes ActivatedRule objects in a WebACL. Each Rule
identifies web requests that you want to allow, block, or count. When you update a WebACL,
you specify the following values:   A default action for the WebACL, either ALLOW or BLOCK.
AWS WAF performs the default action if a request doesn't match the criteria in any of the
Rules in a WebACL.   The Rules that you want to add or delete. If you want to replace one
Rule with another, you delete the existing Rule and add the new one.   For each Rule,
whether you want AWS WAF to allow requests, block requests, or count requests that match
the conditions in the Rule.   The order in which you want AWS WAF to evaluate the Rules in
a WebACL. If you add more than one Rule to a WebACL, AWS WAF evaluates each request against
the Rules in order based on the value of Priority. (The Rule that has the lowest value for
Priority is evaluated first.) When a web request matches all the predicates (such as
ByteMatchSets and IPSets) in a Rule, AWS WAF immediately takes the corresponding action,
allow or block, and doesn't evaluate the request against the remaining Rules in the WebACL,
if any.    To create and configure a WebACL, perform the following steps:   Create and
update the predicates that you want to include in Rules. For more information, see
CreateByteMatchSet, UpdateByteMatchSet, CreateIPSet, UpdateIPSet,
CreateSqlInjectionMatchSet, and UpdateSqlInjectionMatchSet.   Create and update the Rules
that you want to include in the WebACL. For more information, see CreateRule and
UpdateRule.   Create a WebACL. See CreateWebACL.   Use GetChangeToken to get the change
token that you provide in the ChangeToken parameter of an UpdateWebACL request.   Submit an
UpdateWebACL request to specify the Rules that you want to include in the WebACL, to
specify the default action, and to associate the WebACL with a CloudFront distribution.
The ActivatedRule can be a rule group. If you specify a rule group as your ActivatedRule ,
you can exclude specific rules from that rule group. If you already have a rule group
associated with a web ACL and want to submit an UpdateWebACL request to exclude certain
rules from that rule group, you must first remove the rule group from the web ACL, the
re-insert it again, specifying the excluded rules. For details, see
ActivatedRuleExcludedRules .    Be aware that if you try to add a RATE_BASED rule to a web
ACL without setting the rule type when first creating the rule, the UpdateWebACL request
will fail because the request tries to add a REGULAR rule (the default rule type) with the
specified ID, which does not exist.  For more information about how to use the AWS WAF API
to allow or block HTTP requests, see the AWS WAF Developer Guide.

# Arguments
- `change_token`: The value returned by the most recent call to GetChangeToken.
- `web_aclid`: The WebACLId of the WebACL that you want to update. WebACLId is returned by
  CreateWebACL and by ListWebACLs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DefaultAction"`: A default action for the web ACL, either ALLOW or BLOCK. AWS WAF
  performs the default action if a request doesn't match the criteria in any of the rules in
  a web ACL.
- `"Updates"`: An array of updates to make to the WebACL. An array of WebACLUpdate objects
  that you want to insert into or delete from a WebACL. For more information, see the
  applicable data types:    WebACLUpdate: Contains Action and ActivatedRule
  ActivatedRule: Contains Action, OverrideAction, Priority, RuleId, and Type.
  ActivatedRule|OverrideAction applies only when updating or adding a RuleGroup to a WebACL.
  In this case, you do not use ActivatedRule|Action. For all other update requests,
  ActivatedRule|Action is used instead of ActivatedRule|OverrideAction.     WafAction:
  Contains Type
"""
function update_web_acl(
    ChangeToken, WebACLId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "UpdateWebACL",
        Dict{String,Any}("ChangeToken" => ChangeToken, "WebACLId" => WebACLId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_web_acl(
    ChangeToken,
    WebACLId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "UpdateWebACL",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ChangeToken" => ChangeToken, "WebACLId" => WebACLId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_xss_match_set(change_token, updates, xss_match_set_id)
    update_xss_match_set(change_token, updates, xss_match_set_id, params::Dict{String,<:Any})

 This is AWS WAF Classic documentation. For more information, see AWS WAF Classic in the
developer guide.  For the latest version of AWS WAF, use the AWS WAFV2 API and see the AWS
WAF Developer Guide. With the latest version, AWS WAF has a single set of endpoints for
regional and global use.   Inserts or deletes XssMatchTuple objects (filters) in an
XssMatchSet. For each XssMatchTuple object, you specify the following values:    Action:
Whether to insert the object into or delete the object from the array. To change an
XssMatchTuple, you delete the existing object and add a new one.    FieldToMatch: The part
of web requests that you want AWS WAF to inspect and, if you want AWS WAF to inspect a
header or custom query parameter, the name of the header or parameter.
TextTransformation: Which text transformation, if any, to perform on the web request before
inspecting the request for cross-site scripting attacks. You can only specify a single type
of TextTransformation.   You use XssMatchSet objects to specify which CloudFront requests
that you want to allow, block, or count. For example, if you're receiving requests that
contain cross-site scripting attacks in the request body and you want to block the
requests, you can create an XssMatchSet with the applicable settings, and then configure
AWS WAF to block the requests.  To create and configure an XssMatchSet, perform the
following steps:   Submit a CreateXssMatchSet request.   Use GetChangeToken to get the
change token that you provide in the ChangeToken parameter of an UpdateIPSet request.
Submit an UpdateXssMatchSet request to specify the parts of web requests that you want AWS
WAF to inspect for cross-site scripting attacks.   For more information about how to use
the AWS WAF API to allow or block HTTP requests, see the AWS WAF Developer Guide.

# Arguments
- `change_token`: The value returned by the most recent call to GetChangeToken.
- `updates`: An array of XssMatchSetUpdate objects that you want to insert into or delete
  from an XssMatchSet. For more information, see the applicable data types:
  XssMatchSetUpdate: Contains Action and XssMatchTuple     XssMatchTuple: Contains
  FieldToMatch and TextTransformation     FieldToMatch: Contains Data and Type
- `xss_match_set_id`: The XssMatchSetId of the XssMatchSet that you want to update.
  XssMatchSetId is returned by CreateXssMatchSet and by ListXssMatchSets.

"""
function update_xss_match_set(
    ChangeToken, Updates, XssMatchSetId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return waf(
        "UpdateXssMatchSet",
        Dict{String,Any}(
            "ChangeToken" => ChangeToken,
            "Updates" => Updates,
            "XssMatchSetId" => XssMatchSetId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_xss_match_set(
    ChangeToken,
    Updates,
    XssMatchSetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return waf(
        "UpdateXssMatchSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ChangeToken" => ChangeToken,
                    "Updates" => Updates,
                    "XssMatchSetId" => XssMatchSetId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: cost_and_usage_report_service
using AWS.Compat
using AWS.UUIDs

"""
    delete_report_definition(report_name)
    delete_report_definition(report_name, params::Dict{String,<:Any})

Deletes the specified report. Any tags associated with the report are also deleted.

# Arguments
- `report_name`: The name of the report that you want to delete. The name must be unique,
  is case sensitive, and can't include spaces.

"""
function delete_report_definition(
    ReportName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cost_and_usage_report_service(
        "DeleteReportDefinition",
        Dict{String,Any}("ReportName" => ReportName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_report_definition(
    ReportName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cost_and_usage_report_service(
        "DeleteReportDefinition",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ReportName" => ReportName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_report_definitions()
    describe_report_definitions(params::Dict{String,<:Any})

Lists the Amazon Web Services Cost and Usage Report available to this account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`:
- `"NextToken"`:
"""
function describe_report_definitions(; aws_config::AbstractAWSConfig=current_aws_config())
    return cost_and_usage_report_service(
        "DescribeReportDefinitions"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_report_definitions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cost_and_usage_report_service(
        "DescribeReportDefinitions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(report_name)
    list_tags_for_resource(report_name, params::Dict{String,<:Any})

Lists the tags associated with the specified report definition.

# Arguments
- `report_name`: The report name of the report definition that tags are to be returned for.

"""
function list_tags_for_resource(
    ReportName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cost_and_usage_report_service(
        "ListTagsForResource",
        Dict{String,Any}("ReportName" => ReportName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ReportName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cost_and_usage_report_service(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ReportName" => ReportName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    modify_report_definition(report_definition, report_name)
    modify_report_definition(report_definition, report_name, params::Dict{String,<:Any})

Allows you to programmatically update your report preferences.

# Arguments
- `report_definition`:
- `report_name`:

"""
function modify_report_definition(
    ReportDefinition, ReportName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cost_and_usage_report_service(
        "ModifyReportDefinition",
        Dict{String,Any}(
            "ReportDefinition" => ReportDefinition, "ReportName" => ReportName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function modify_report_definition(
    ReportDefinition,
    ReportName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cost_and_usage_report_service(
        "ModifyReportDefinition",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ReportDefinition" => ReportDefinition, "ReportName" => ReportName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_report_definition(report_definition)
    put_report_definition(report_definition, params::Dict{String,<:Any})

Creates a new report using the description that you provide.

# Arguments
- `report_definition`: Represents the output of the PutReportDefinition operation. The
  content consists of the detailed metadata and data file information.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: The tags to be assigned to the report definition resource.
"""
function put_report_definition(
    ReportDefinition; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cost_and_usage_report_service(
        "PutReportDefinition",
        Dict{String,Any}("ReportDefinition" => ReportDefinition);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_report_definition(
    ReportDefinition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cost_and_usage_report_service(
        "PutReportDefinition",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ReportDefinition" => ReportDefinition), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(report_name, tags)
    tag_resource(report_name, tags, params::Dict{String,<:Any})

Associates a set of tags with a report definition.

# Arguments
- `report_name`: The report name of the report definition that tags are to be associated
  with.
- `tags`: The tags to be assigned to the report definition resource.

"""
function tag_resource(ReportName, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return cost_and_usage_report_service(
        "TagResource",
        Dict{String,Any}("ReportName" => ReportName, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ReportName,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cost_and_usage_report_service(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ReportName" => ReportName, "Tags" => Tags), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(report_name, tag_keys)
    untag_resource(report_name, tag_keys, params::Dict{String,<:Any})

Disassociates a set of tags from a report definition.

# Arguments
- `report_name`: The report name of the report definition that tags are to be disassociated
  from.
- `tag_keys`: The tags to be disassociated from the report definition resource.

"""
function untag_resource(
    ReportName, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cost_and_usage_report_service(
        "UntagResource",
        Dict{String,Any}("ReportName" => ReportName, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ReportName,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cost_and_usage_report_service(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ReportName" => ReportName, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: elasticsearch_service
using AWS.Compat
using AWS.UUIDs

"""
    accept_inbound_cross_cluster_search_connection(connection_id)
    accept_inbound_cross_cluster_search_connection(connection_id, params::Dict{String,<:Any})

Allows the destination domain owner to accept an inbound cross-cluster search connection
request.

# Arguments
- `connection_id`: The id of the inbound connection that you want to accept.

"""
function accept_inbound_cross_cluster_search_connection(
    ConnectionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticsearch_service(
        "PUT",
        "/2015-01-01/es/ccs/inboundConnection/$(ConnectionId)/accept";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function accept_inbound_cross_cluster_search_connection(
    ConnectionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticsearch_service(
        "PUT",
        "/2015-01-01/es/ccs/inboundConnection/$(ConnectionId)/accept",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    add_tags(arn, tag_list)
    add_tags(arn, tag_list, params::Dict{String,<:Any})

Attaches tags to an existing Elasticsearch domain. Tags are a set of case-sensitive key
value pairs. An Elasticsearch domain may have up to 10 tags. See  Tagging Amazon
Elasticsearch Service Domains for more information.

# Arguments
- `arn`:  Specify the ARN for which you want to add the tags.
- `tag_list`:  List of Tag that need to be added for the Elasticsearch domain.

"""
function add_tags(ARN, TagList; aws_config::AbstractAWSConfig=current_aws_config())
    return elasticsearch_service(
        "POST",
        "/2015-01-01/tags",
        Dict{String,Any}("ARN" => ARN, "TagList" => TagList);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_tags(
    ARN,
    TagList,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticsearch_service(
        "POST",
        "/2015-01-01/tags",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ARN" => ARN, "TagList" => TagList), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_package(domain_name, package_id)
    associate_package(domain_name, package_id, params::Dict{String,<:Any})

Associates a package with an Amazon ES domain.

# Arguments
- `domain_name`: Name of the domain that you want to associate the package with.
- `package_id`: Internal ID of the package that you want to associate with a domain. Use
  DescribePackages to find this value.

"""
function associate_package(
    DomainName, PackageID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticsearch_service(
        "POST",
        "/2015-01-01/packages/associate/$(PackageID)/$(DomainName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_package(
    DomainName,
    PackageID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticsearch_service(
        "POST",
        "/2015-01-01/packages/associate/$(PackageID)/$(DomainName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    authorize_vpc_endpoint_access(account, domain_name)
    authorize_vpc_endpoint_access(account, domain_name, params::Dict{String,<:Any})

Provides access to an Amazon OpenSearch Service domain through the use of an interface VPC
endpoint.

# Arguments
- `account`: The account ID to grant access to.
- `domain_name`: The name of the OpenSearch Service domain to provide access to.

"""
function authorize_vpc_endpoint_access(
    Account, DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticsearch_service(
        "POST",
        "/2015-01-01/es/domain/$(DomainName)/authorizeVpcEndpointAccess",
        Dict{String,Any}("Account" => Account);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function authorize_vpc_endpoint_access(
    Account,
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticsearch_service(
        "POST",
        "/2015-01-01/es/domain/$(DomainName)/authorizeVpcEndpointAccess",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Account" => Account), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_domain_config_change(domain_name)
    cancel_domain_config_change(domain_name, params::Dict{String,<:Any})

Cancels a pending configuration change on an Amazon OpenSearch Service domain.

# Arguments
- `domain_name`: Name of the OpenSearch Service domain configuration request to cancel.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DryRun"`: When set to True, returns the list of change IDs and properties that will be
  cancelled without actually cancelling the change.
"""
function cancel_domain_config_change(
    DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticsearch_service(
        "POST",
        "/2015-01-01/es/domain/$(DomainName)/config/cancel";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_domain_config_change(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticsearch_service(
        "POST",
        "/2015-01-01/es/domain/$(DomainName)/config/cancel",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_elasticsearch_service_software_update(domain_name)
    cancel_elasticsearch_service_software_update(domain_name, params::Dict{String,<:Any})

Cancels a scheduled service software update for an Amazon ES domain. You can only perform
this operation before the AutomatedUpdateDate and when the UpdateStatus is in the
PENDING_UPDATE state.

# Arguments
- `domain_name`: The name of the domain that you want to stop the latest service software
  update on.

"""
function cancel_elasticsearch_service_software_update(
    DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticsearch_service(
        "POST",
        "/2015-01-01/es/serviceSoftwareUpdate/cancel",
        Dict{String,Any}("DomainName" => DomainName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_elasticsearch_service_software_update(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticsearch_service(
        "POST",
        "/2015-01-01/es/serviceSoftwareUpdate/cancel",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DomainName" => DomainName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_elasticsearch_domain(domain_name)
    create_elasticsearch_domain(domain_name, params::Dict{String,<:Any})

Creates a new Elasticsearch domain. For more information, see Creating Elasticsearch
Domains in the Amazon Elasticsearch Service Developer Guide.

# Arguments
- `domain_name`: The name of the Elasticsearch domain that you are creating. Domain names
  are unique across the domains owned by an account within an AWS region. Domain names must
  start with a lowercase letter and can contain the following characters: a-z (lowercase),
  0-9, and - (hyphen).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccessPolicies"`:  IAM access policy as a JSON-formatted string.
- `"AdvancedOptions"`:  Option to allow references to indices in an HTTP request body. Must
  be false when configuring access to individual sub-resources. By default, the value is
  true. See Configuration Advanced Options for more information.
- `"AdvancedSecurityOptions"`: Specifies advanced security options.
- `"AutoTuneOptions"`: Specifies Auto-Tune options.
- `"CognitoOptions"`: Options to specify the Cognito user and identity pools for Kibana
  authentication. For more information, see Amazon Cognito Authentication for Kibana.
- `"DomainEndpointOptions"`: Options to specify configuration that will be applied to the
  domain endpoint.
- `"EBSOptions"`: Options to enable, disable and specify the type and size of EBS storage
  volumes.
- `"ElasticsearchClusterConfig"`: Configuration options for an Elasticsearch domain.
  Specifies the instance type and number of instances in the domain cluster.
- `"ElasticsearchVersion"`: String of format X.Y to specify version for the Elasticsearch
  domain eg. \"1.5\" or \"2.3\". For more information, see Creating Elasticsearch Domains in
  the Amazon Elasticsearch Service Developer Guide.
- `"EncryptionAtRestOptions"`: Specifies the Encryption At Rest Options.
- `"LogPublishingOptions"`: Map of LogType and LogPublishingOption, each containing options
  to publish a given type of Elasticsearch log.
- `"NodeToNodeEncryptionOptions"`: Specifies the NodeToNodeEncryptionOptions.
- `"SnapshotOptions"`: Option to set time, in UTC format, of the daily automated snapshot.
  Default value is 0 hours.
- `"TagList"`: A list of Tag added during domain creation.
- `"VPCOptions"`: Options to specify the subnets and security groups for VPC endpoint. For
  more information, see Creating a VPC in VPC Endpoints for Amazon Elasticsearch Service
  Domains
"""
function create_elasticsearch_domain(
    DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticsearch_service(
        "POST",
        "/2015-01-01/es/domain",
        Dict{String,Any}("DomainName" => DomainName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_elasticsearch_domain(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticsearch_service(
        "POST",
        "/2015-01-01/es/domain",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DomainName" => DomainName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_outbound_cross_cluster_search_connection(connection_alias, destination_domain_info, source_domain_info)
    create_outbound_cross_cluster_search_connection(connection_alias, destination_domain_info, source_domain_info, params::Dict{String,<:Any})

Creates a new cross-cluster search connection from a source domain to a destination domain.

# Arguments
- `connection_alias`: Specifies the connection alias that will be used by the customer for
  this connection.
- `destination_domain_info`: Specifies the DomainInformation for the destination
  Elasticsearch domain.
- `source_domain_info`: Specifies the DomainInformation for the source Elasticsearch domain.

"""
function create_outbound_cross_cluster_search_connection(
    ConnectionAlias,
    DestinationDomainInfo,
    SourceDomainInfo;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticsearch_service(
        "POST",
        "/2015-01-01/es/ccs/outboundConnection",
        Dict{String,Any}(
            "ConnectionAlias" => ConnectionAlias,
            "DestinationDomainInfo" => DestinationDomainInfo,
            "SourceDomainInfo" => SourceDomainInfo,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_outbound_cross_cluster_search_connection(
    ConnectionAlias,
    DestinationDomainInfo,
    SourceDomainInfo,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticsearch_service(
        "POST",
        "/2015-01-01/es/ccs/outboundConnection",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ConnectionAlias" => ConnectionAlias,
                    "DestinationDomainInfo" => DestinationDomainInfo,
                    "SourceDomainInfo" => SourceDomainInfo,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_package(package_name, package_source, package_type)
    create_package(package_name, package_source, package_type, params::Dict{String,<:Any})

Create a package for use with Amazon ES domains.

# Arguments
- `package_name`: Unique identifier for the package.
- `package_source`: The customer S3 location PackageSource for importing the package.
- `package_type`: Type of package. Currently supports only TXT-DICTIONARY.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"PackageDescription"`: Description of the package.
"""
function create_package(
    PackageName,
    PackageSource,
    PackageType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticsearch_service(
        "POST",
        "/2015-01-01/packages",
        Dict{String,Any}(
            "PackageName" => PackageName,
            "PackageSource" => PackageSource,
            "PackageType" => PackageType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_package(
    PackageName,
    PackageSource,
    PackageType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticsearch_service(
        "POST",
        "/2015-01-01/packages",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "PackageName" => PackageName,
                    "PackageSource" => PackageSource,
                    "PackageType" => PackageType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_vpc_endpoint(domain_arn, vpc_options)
    create_vpc_endpoint(domain_arn, vpc_options, params::Dict{String,<:Any})

Creates an Amazon OpenSearch Service-managed VPC endpoint.

# Arguments
- `domain_arn`: The Amazon Resource Name (ARN) of the domain to grant access to.
- `vpc_options`: Options to specify the subnets and security groups for the endpoint.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: Unique, case-sensitive identifier to ensure idempotency of the request.
"""
function create_vpc_endpoint(
    DomainArn, VpcOptions; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticsearch_service(
        "POST",
        "/2015-01-01/es/vpcEndpoints",
        Dict{String,Any}("DomainArn" => DomainArn, "VpcOptions" => VpcOptions);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_vpc_endpoint(
    DomainArn,
    VpcOptions,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticsearch_service(
        "POST",
        "/2015-01-01/es/vpcEndpoints",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DomainArn" => DomainArn, "VpcOptions" => VpcOptions),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_elasticsearch_domain(domain_name)
    delete_elasticsearch_domain(domain_name, params::Dict{String,<:Any})

Permanently deletes the specified Elasticsearch domain and all of its data. Once a domain
is deleted, it cannot be recovered.

# Arguments
- `domain_name`: The name of the Elasticsearch domain that you want to permanently delete.

"""
function delete_elasticsearch_domain(
    DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticsearch_service(
        "DELETE",
        "/2015-01-01/es/domain/$(DomainName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_elasticsearch_domain(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticsearch_service(
        "DELETE",
        "/2015-01-01/es/domain/$(DomainName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_elasticsearch_service_role()
    delete_elasticsearch_service_role(params::Dict{String,<:Any})

Deletes the service-linked role that Elasticsearch Service uses to manage and maintain VPC
domains. Role deletion will fail if any existing VPC domains use the role. You must delete
any such Elasticsearch domains before deleting the role. See Deleting Elasticsearch Service
Role in VPC Endpoints for Amazon Elasticsearch Service Domains.

"""
function delete_elasticsearch_service_role(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticsearch_service(
        "DELETE",
        "/2015-01-01/es/role";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_elasticsearch_service_role(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticsearch_service(
        "DELETE",
        "/2015-01-01/es/role",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_inbound_cross_cluster_search_connection(connection_id)
    delete_inbound_cross_cluster_search_connection(connection_id, params::Dict{String,<:Any})

Allows the destination domain owner to delete an existing inbound cross-cluster search
connection.

# Arguments
- `connection_id`: The id of the inbound connection that you want to permanently delete.

"""
function delete_inbound_cross_cluster_search_connection(
    ConnectionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticsearch_service(
        "DELETE",
        "/2015-01-01/es/ccs/inboundConnection/$(ConnectionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_inbound_cross_cluster_search_connection(
    ConnectionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticsearch_service(
        "DELETE",
        "/2015-01-01/es/ccs/inboundConnection/$(ConnectionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_outbound_cross_cluster_search_connection(connection_id)
    delete_outbound_cross_cluster_search_connection(connection_id, params::Dict{String,<:Any})

Allows the source domain owner to delete an existing outbound cross-cluster search
connection.

# Arguments
- `connection_id`: The id of the outbound connection that you want to permanently delete.

"""
function delete_outbound_cross_cluster_search_connection(
    ConnectionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticsearch_service(
        "DELETE",
        "/2015-01-01/es/ccs/outboundConnection/$(ConnectionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_outbound_cross_cluster_search_connection(
    ConnectionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticsearch_service(
        "DELETE",
        "/2015-01-01/es/ccs/outboundConnection/$(ConnectionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_package(package_id)
    delete_package(package_id, params::Dict{String,<:Any})

Delete the package.

# Arguments
- `package_id`: Internal ID of the package that you want to delete. Use DescribePackages to
  find this value.

"""
function delete_package(PackageID; aws_config::AbstractAWSConfig=current_aws_config())
    return elasticsearch_service(
        "DELETE",
        "/2015-01-01/packages/$(PackageID)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_package(
    PackageID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticsearch_service(
        "DELETE",
        "/2015-01-01/packages/$(PackageID)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_vpc_endpoint(vpc_endpoint_id)
    delete_vpc_endpoint(vpc_endpoint_id, params::Dict{String,<:Any})

Deletes an Amazon OpenSearch Service-managed interface VPC endpoint.

# Arguments
- `vpc_endpoint_id`: The unique identifier of the endpoint to be deleted.

"""
function delete_vpc_endpoint(
    VpcEndpointId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticsearch_service(
        "DELETE",
        "/2015-01-01/es/vpcEndpoints/$(VpcEndpointId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_vpc_endpoint(
    VpcEndpointId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticsearch_service(
        "DELETE",
        "/2015-01-01/es/vpcEndpoints/$(VpcEndpointId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_domain_auto_tunes(domain_name)
    describe_domain_auto_tunes(domain_name, params::Dict{String,<:Any})

Provides scheduled Auto-Tune action details for the Elasticsearch domain, such as Auto-Tune
action type, description, severity, and scheduled date.

# Arguments
- `domain_name`: Specifies the domain name for which you want Auto-Tune action details.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Set this value to limit the number of results returned. If not specified,
  defaults to 100.
- `"NextToken"`: NextToken is sent in case the earlier API call results contain the
  NextToken. It is used for pagination.
"""
function describe_domain_auto_tunes(
    DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticsearch_service(
        "GET",
        "/2015-01-01/es/domain/$(DomainName)/autoTunes";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_domain_auto_tunes(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticsearch_service(
        "GET",
        "/2015-01-01/es/domain/$(DomainName)/autoTunes",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_domain_change_progress(domain_name)
    describe_domain_change_progress(domain_name, params::Dict{String,<:Any})

Returns information about the current blue/green deployment happening on a domain,
including a change ID, status, and progress stages.

# Arguments
- `domain_name`: The domain you want to get the progress information about.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"changeid"`: The specific change ID for which you want to get progress information. This
  is an optional parameter. If omitted, the service returns information about the most recent
  configuration change.
"""
function describe_domain_change_progress(
    DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticsearch_service(
        "GET",
        "/2015-01-01/es/domain/$(DomainName)/progress";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_domain_change_progress(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticsearch_service(
        "GET",
        "/2015-01-01/es/domain/$(DomainName)/progress",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_elasticsearch_domain(domain_name)
    describe_elasticsearch_domain(domain_name, params::Dict{String,<:Any})

Returns domain configuration information about the specified Elasticsearch domain,
including the domain ID, domain endpoint, and domain ARN.

# Arguments
- `domain_name`: The name of the Elasticsearch domain for which you want information.

"""
function describe_elasticsearch_domain(
    DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticsearch_service(
        "GET",
        "/2015-01-01/es/domain/$(DomainName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_elasticsearch_domain(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticsearch_service(
        "GET",
        "/2015-01-01/es/domain/$(DomainName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_elasticsearch_domain_config(domain_name)
    describe_elasticsearch_domain_config(domain_name, params::Dict{String,<:Any})

Provides cluster configuration information about the specified Elasticsearch domain, such
as the state, creation date, update version, and update date for cluster options.

# Arguments
- `domain_name`: The Elasticsearch domain that you want to get information about.

"""
function describe_elasticsearch_domain_config(
    DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticsearch_service(
        "GET",
        "/2015-01-01/es/domain/$(DomainName)/config";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_elasticsearch_domain_config(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticsearch_service(
        "GET",
        "/2015-01-01/es/domain/$(DomainName)/config",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_elasticsearch_domains(domain_names)
    describe_elasticsearch_domains(domain_names, params::Dict{String,<:Any})

Returns domain configuration information about the specified Elasticsearch domains,
including the domain ID, domain endpoint, and domain ARN.

# Arguments
- `domain_names`: The Elasticsearch domains for which you want information.

"""
function describe_elasticsearch_domains(
    DomainNames; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticsearch_service(
        "POST",
        "/2015-01-01/es/domain-info",
        Dict{String,Any}("DomainNames" => DomainNames);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_elasticsearch_domains(
    DomainNames,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticsearch_service(
        "POST",
        "/2015-01-01/es/domain-info",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DomainNames" => DomainNames), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_elasticsearch_instance_type_limits(elasticsearch_version, instance_type)
    describe_elasticsearch_instance_type_limits(elasticsearch_version, instance_type, params::Dict{String,<:Any})

 Describe Elasticsearch Limits for a given InstanceType and ElasticsearchVersion. When
modifying existing Domain, specify the  DomainName  to know what Limits are supported for
modifying.

# Arguments
- `elasticsearch_version`:  Version of Elasticsearch for which  Limits  are needed.
- `instance_type`:  The instance type for an Elasticsearch cluster for which Elasticsearch
  Limits  are needed.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"domainName"`:  DomainName represents the name of the Domain that we are trying to
  modify. This should be present only if we are querying for Elasticsearch  Limits  for
  existing domain.
"""
function describe_elasticsearch_instance_type_limits(
    ElasticsearchVersion, InstanceType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticsearch_service(
        "GET",
        "/2015-01-01/es/instanceTypeLimits/$(ElasticsearchVersion)/$(InstanceType)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_elasticsearch_instance_type_limits(
    ElasticsearchVersion,
    InstanceType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticsearch_service(
        "GET",
        "/2015-01-01/es/instanceTypeLimits/$(ElasticsearchVersion)/$(InstanceType)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_inbound_cross_cluster_search_connections()
    describe_inbound_cross_cluster_search_connections(params::Dict{String,<:Any})

Lists all the inbound cross-cluster search connections for a destination domain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`:  A list of filters used to match properties for inbound cross-cluster search
  connection. Available Filter names for this operation are:
  cross-cluster-search-connection-id source-domain-info.domain-name
  source-domain-info.owner-id source-domain-info.region destination-domain-info.domain-name
- `"MaxResults"`: Set this value to limit the number of results returned. If not specified,
  defaults to 100.
- `"NextToken"`:  NextToken is sent in case the earlier API call results contain the
  NextToken. It is used for pagination.
"""
function describe_inbound_cross_cluster_search_connections(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticsearch_service(
        "POST",
        "/2015-01-01/es/ccs/inboundConnection/search";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_inbound_cross_cluster_search_connections(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticsearch_service(
        "POST",
        "/2015-01-01/es/ccs/inboundConnection/search",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_outbound_cross_cluster_search_connections()
    describe_outbound_cross_cluster_search_connections(params::Dict{String,<:Any})

Lists all the outbound cross-cluster search connections for a source domain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`:  A list of filters used to match properties for outbound cross-cluster
  search connection. Available Filter names for this operation are:
  cross-cluster-search-connection-id destination-domain-info.domain-name
  destination-domain-info.owner-id destination-domain-info.region
  source-domain-info.domain-name
- `"MaxResults"`: Set this value to limit the number of results returned. If not specified,
  defaults to 100.
- `"NextToken"`:  NextToken is sent in case the earlier API call results contain the
  NextToken. It is used for pagination.
"""
function describe_outbound_cross_cluster_search_connections(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticsearch_service(
        "POST",
        "/2015-01-01/es/ccs/outboundConnection/search";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_outbound_cross_cluster_search_connections(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticsearch_service(
        "POST",
        "/2015-01-01/es/ccs/outboundConnection/search",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_packages()
    describe_packages(params::Dict{String,<:Any})

Describes all packages available to Amazon ES. Includes options for filtering, limiting the
number of results, and pagination.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: Only returns packages that match the DescribePackagesFilterList values.
- `"MaxResults"`: Limits results to a maximum number of packages.
- `"NextToken"`: Used for pagination. Only necessary if a previous API call includes a
  non-null NextToken value. If provided, returns results for the next page.
"""
function describe_packages(; aws_config::AbstractAWSConfig=current_aws_config())
    return elasticsearch_service(
        "POST",
        "/2015-01-01/packages/describe";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_packages(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticsearch_service(
        "POST",
        "/2015-01-01/packages/describe",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_reserved_elasticsearch_instance_offerings()
    describe_reserved_elasticsearch_instance_offerings(params::Dict{String,<:Any})

Lists available reserved Elasticsearch instance offerings.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Set this value to limit the number of results returned. If not specified,
  defaults to 100.
- `"nextToken"`: NextToken should be sent in case if earlier API call produced result
  containing NextToken. It is used for pagination.
- `"offeringId"`: The offering identifier filter value. Use this parameter to show only the
  available offering that matches the specified reservation identifier.
"""
function describe_reserved_elasticsearch_instance_offerings(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticsearch_service(
        "GET",
        "/2015-01-01/es/reservedInstanceOfferings";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_reserved_elasticsearch_instance_offerings(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticsearch_service(
        "GET",
        "/2015-01-01/es/reservedInstanceOfferings",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_reserved_elasticsearch_instances()
    describe_reserved_elasticsearch_instances(params::Dict{String,<:Any})

Returns information about reserved Elasticsearch instances for this account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Set this value to limit the number of results returned. If not specified,
  defaults to 100.
- `"nextToken"`: NextToken should be sent in case if earlier API call produced result
  containing NextToken. It is used for pagination.
- `"reservationId"`: The reserved instance identifier filter value. Use this parameter to
  show only the reservation that matches the specified reserved Elasticsearch instance ID.
"""
function describe_reserved_elasticsearch_instances(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticsearch_service(
        "GET",
        "/2015-01-01/es/reservedInstances";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_reserved_elasticsearch_instances(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticsearch_service(
        "GET",
        "/2015-01-01/es/reservedInstances",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_vpc_endpoints(vpc_endpoint_ids)
    describe_vpc_endpoints(vpc_endpoint_ids, params::Dict{String,<:Any})

Describes one or more Amazon OpenSearch Service-managed VPC endpoints.

# Arguments
- `vpc_endpoint_ids`: The unique identifiers of the endpoints to get information about.

"""
function describe_vpc_endpoints(
    VpcEndpointIds; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticsearch_service(
        "POST",
        "/2015-01-01/es/vpcEndpoints/describe",
        Dict{String,Any}("VpcEndpointIds" => VpcEndpointIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_vpc_endpoints(
    VpcEndpointIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticsearch_service(
        "POST",
        "/2015-01-01/es/vpcEndpoints/describe",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("VpcEndpointIds" => VpcEndpointIds), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    dissociate_package(domain_name, package_id)
    dissociate_package(domain_name, package_id, params::Dict{String,<:Any})

Dissociates a package from the Amazon ES domain.

# Arguments
- `domain_name`: Name of the domain that you want to associate the package with.
- `package_id`: Internal ID of the package that you want to associate with a domain. Use
  DescribePackages to find this value.

"""
function dissociate_package(
    DomainName, PackageID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticsearch_service(
        "POST",
        "/2015-01-01/packages/dissociate/$(PackageID)/$(DomainName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function dissociate_package(
    DomainName,
    PackageID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticsearch_service(
        "POST",
        "/2015-01-01/packages/dissociate/$(PackageID)/$(DomainName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_compatible_elasticsearch_versions()
    get_compatible_elasticsearch_versions(params::Dict{String,<:Any})

 Returns a list of upgrade compatible Elastisearch versions. You can optionally pass a
DomainName  to get all upgrade compatible Elasticsearch versions for that specific domain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"domainName"`:
"""
function get_compatible_elasticsearch_versions(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticsearch_service(
        "GET",
        "/2015-01-01/es/compatibleVersions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_compatible_elasticsearch_versions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticsearch_service(
        "GET",
        "/2015-01-01/es/compatibleVersions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_package_version_history(package_id)
    get_package_version_history(package_id, params::Dict{String,<:Any})

Returns a list of versions of the package, along with their creation time and commit
message.

# Arguments
- `package_id`: Returns an audit history of versions of the package.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Limits results to a maximum number of versions.
- `"nextToken"`: Used for pagination. Only necessary if a previous API call includes a
  non-null NextToken value. If provided, returns results for the next page.
"""
function get_package_version_history(
    PackageID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticsearch_service(
        "GET",
        "/2015-01-01/packages/$(PackageID)/history";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_package_version_history(
    PackageID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticsearch_service(
        "GET",
        "/2015-01-01/packages/$(PackageID)/history",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_upgrade_history(domain_name)
    get_upgrade_history(domain_name, params::Dict{String,<:Any})

Retrieves the complete history of the last 10 upgrades that were performed on the domain.

# Arguments
- `domain_name`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:
- `"nextToken"`:
"""
function get_upgrade_history(DomainName; aws_config::AbstractAWSConfig=current_aws_config())
    return elasticsearch_service(
        "GET",
        "/2015-01-01/es/upgradeDomain/$(DomainName)/history";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_upgrade_history(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticsearch_service(
        "GET",
        "/2015-01-01/es/upgradeDomain/$(DomainName)/history",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_upgrade_status(domain_name)
    get_upgrade_status(domain_name, params::Dict{String,<:Any})

Retrieves the latest status of the last upgrade or upgrade eligibility check that was
performed on the domain.

# Arguments
- `domain_name`:

"""
function get_upgrade_status(DomainName; aws_config::AbstractAWSConfig=current_aws_config())
    return elasticsearch_service(
        "GET",
        "/2015-01-01/es/upgradeDomain/$(DomainName)/status";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_upgrade_status(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticsearch_service(
        "GET",
        "/2015-01-01/es/upgradeDomain/$(DomainName)/status",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_domain_names()
    list_domain_names(params::Dict{String,<:Any})

Returns the name of all Elasticsearch domains owned by the current user's account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"engineType"`:  Optional parameter to filter the output by domain engine type.
  Acceptable values are 'Elasticsearch' and 'OpenSearch'.
"""
function list_domain_names(; aws_config::AbstractAWSConfig=current_aws_config())
    return elasticsearch_service(
        "GET", "/2015-01-01/domain"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_domain_names(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticsearch_service(
        "GET",
        "/2015-01-01/domain",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_domains_for_package(package_id)
    list_domains_for_package(package_id, params::Dict{String,<:Any})

Lists all Amazon ES domains associated with the package.

# Arguments
- `package_id`: The package for which to list domains.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Limits results to a maximum number of domains.
- `"nextToken"`: Used for pagination. Only necessary if a previous API call includes a
  non-null NextToken value. If provided, returns results for the next page.
"""
function list_domains_for_package(
    PackageID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticsearch_service(
        "GET",
        "/2015-01-01/packages/$(PackageID)/domains";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_domains_for_package(
    PackageID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticsearch_service(
        "GET",
        "/2015-01-01/packages/$(PackageID)/domains",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_elasticsearch_instance_types(elasticsearch_version)
    list_elasticsearch_instance_types(elasticsearch_version, params::Dict{String,<:Any})

List all Elasticsearch instance types that are supported for given ElasticsearchVersion

# Arguments
- `elasticsearch_version`: Version of Elasticsearch for which list of supported
  elasticsearch instance types are needed.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"domainName"`: DomainName represents the name of the Domain that we are trying to
  modify. This should be present only if we are querying for list of available Elasticsearch
  instance types when modifying existing domain.
- `"maxResults"`:  Set this value to limit the number of results returned. Value provided
  must be greater than 30 else it wont be honored.
- `"nextToken"`: NextToken should be sent in case if earlier API call produced result
  containing NextToken. It is used for pagination.
"""
function list_elasticsearch_instance_types(
    ElasticsearchVersion; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticsearch_service(
        "GET",
        "/2015-01-01/es/instanceTypes/$(ElasticsearchVersion)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_elasticsearch_instance_types(
    ElasticsearchVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticsearch_service(
        "GET",
        "/2015-01-01/es/instanceTypes/$(ElasticsearchVersion)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_elasticsearch_versions()
    list_elasticsearch_versions(params::Dict{String,<:Any})

List all supported Elasticsearch versions

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:  Set this value to limit the number of results returned. Value provided
  must be greater than 10 else it wont be honored.
- `"nextToken"`:
"""
function list_elasticsearch_versions(; aws_config::AbstractAWSConfig=current_aws_config())
    return elasticsearch_service(
        "GET",
        "/2015-01-01/es/versions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_elasticsearch_versions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticsearch_service(
        "GET",
        "/2015-01-01/es/versions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_packages_for_domain(domain_name)
    list_packages_for_domain(domain_name, params::Dict{String,<:Any})

Lists all packages associated with the Amazon ES domain.

# Arguments
- `domain_name`: The name of the domain for which you want to list associated packages.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Limits results to a maximum number of packages.
- `"nextToken"`: Used for pagination. Only necessary if a previous API call includes a
  non-null NextToken value. If provided, returns results for the next page.
"""
function list_packages_for_domain(
    DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticsearch_service(
        "GET",
        "/2015-01-01/domain/$(DomainName)/packages";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_packages_for_domain(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticsearch_service(
        "GET",
        "/2015-01-01/domain/$(DomainName)/packages",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags(arn)
    list_tags(arn, params::Dict{String,<:Any})

Returns all tags for the given Elasticsearch domain.

# Arguments
- `arn`:  Specify the ARN for the Elasticsearch domain to which the tags are attached that
  you want to view.

"""
function list_tags(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return elasticsearch_service(
        "GET",
        "/2015-01-01/tags/",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticsearch_service(
        "GET",
        "/2015-01-01/tags/",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_vpc_endpoint_access(domain_name)
    list_vpc_endpoint_access(domain_name, params::Dict{String,<:Any})

Retrieves information about each principal that is allowed to access a given Amazon
OpenSearch Service domain through the use of an interface VPC endpoint.

# Arguments
- `domain_name`: The name of the OpenSearch Service domain to retrieve access information
  for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: Provides an identifier to allow retrieval of paginated results.
"""
function list_vpc_endpoint_access(
    DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticsearch_service(
        "GET",
        "/2015-01-01/es/domain/$(DomainName)/listVpcEndpointAccess";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_vpc_endpoint_access(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticsearch_service(
        "GET",
        "/2015-01-01/es/domain/$(DomainName)/listVpcEndpointAccess",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_vpc_endpoints()
    list_vpc_endpoints(params::Dict{String,<:Any})

Retrieves all Amazon OpenSearch Service-managed VPC endpoints in the current account and
Region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: Identifier to allow retrieval of paginated results.
"""
function list_vpc_endpoints(; aws_config::AbstractAWSConfig=current_aws_config())
    return elasticsearch_service(
        "GET",
        "/2015-01-01/es/vpcEndpoints";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_vpc_endpoints(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticsearch_service(
        "GET",
        "/2015-01-01/es/vpcEndpoints",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_vpc_endpoints_for_domain(domain_name)
    list_vpc_endpoints_for_domain(domain_name, params::Dict{String,<:Any})

Retrieves all Amazon OpenSearch Service-managed VPC endpoints associated with a particular
domain.

# Arguments
- `domain_name`: Name of the ElasticSearch domain whose VPC endpoints are to be listed.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: Provides an identifier to allow retrieval of paginated results.
"""
function list_vpc_endpoints_for_domain(
    DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticsearch_service(
        "GET",
        "/2015-01-01/es/domain/$(DomainName)/vpcEndpoints";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_vpc_endpoints_for_domain(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticsearch_service(
        "GET",
        "/2015-01-01/es/domain/$(DomainName)/vpcEndpoints",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    purchase_reserved_elasticsearch_instance_offering(reservation_name, reserved_elasticsearch_instance_offering_id)
    purchase_reserved_elasticsearch_instance_offering(reservation_name, reserved_elasticsearch_instance_offering_id, params::Dict{String,<:Any})

Allows you to purchase reserved Elasticsearch instances.

# Arguments
- `reservation_name`: A customer-specified identifier to track this reservation.
- `reserved_elasticsearch_instance_offering_id`: The ID of the reserved Elasticsearch
  instance offering to purchase.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"InstanceCount"`: The number of Elasticsearch instances to reserve.
"""
function purchase_reserved_elasticsearch_instance_offering(
    ReservationName,
    ReservedElasticsearchInstanceOfferingId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticsearch_service(
        "POST",
        "/2015-01-01/es/purchaseReservedInstanceOffering",
        Dict{String,Any}(
            "ReservationName" => ReservationName,
            "ReservedElasticsearchInstanceOfferingId" =>
                ReservedElasticsearchInstanceOfferingId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function purchase_reserved_elasticsearch_instance_offering(
    ReservationName,
    ReservedElasticsearchInstanceOfferingId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticsearch_service(
        "POST",
        "/2015-01-01/es/purchaseReservedInstanceOffering",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ReservationName" => ReservationName,
                    "ReservedElasticsearchInstanceOfferingId" =>
                        ReservedElasticsearchInstanceOfferingId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    reject_inbound_cross_cluster_search_connection(connection_id)
    reject_inbound_cross_cluster_search_connection(connection_id, params::Dict{String,<:Any})

Allows the destination domain owner to reject an inbound cross-cluster search connection
request.

# Arguments
- `connection_id`: The id of the inbound connection that you want to reject.

"""
function reject_inbound_cross_cluster_search_connection(
    ConnectionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticsearch_service(
        "PUT",
        "/2015-01-01/es/ccs/inboundConnection/$(ConnectionId)/reject";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function reject_inbound_cross_cluster_search_connection(
    ConnectionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticsearch_service(
        "PUT",
        "/2015-01-01/es/ccs/inboundConnection/$(ConnectionId)/reject",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_tags(arn, tag_keys)
    remove_tags(arn, tag_keys, params::Dict{String,<:Any})

Removes the specified set of tags from the specified Elasticsearch domain.

# Arguments
- `arn`: Specifies the ARN for the Elasticsearch domain from which you want to delete the
  specified tags.
- `tag_keys`: Specifies the TagKey list which you want to remove from the Elasticsearch
  domain.

"""
function remove_tags(ARN, TagKeys; aws_config::AbstractAWSConfig=current_aws_config())
    return elasticsearch_service(
        "POST",
        "/2015-01-01/tags-removal",
        Dict{String,Any}("ARN" => ARN, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_tags(
    ARN,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticsearch_service(
        "POST",
        "/2015-01-01/tags-removal",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ARN" => ARN, "TagKeys" => TagKeys), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    revoke_vpc_endpoint_access(account, domain_name)
    revoke_vpc_endpoint_access(account, domain_name, params::Dict{String,<:Any})

Revokes access to an Amazon OpenSearch Service domain that was provided through an
interface VPC endpoint.

# Arguments
- `account`: The account ID to revoke access from.
- `domain_name`: The name of the OpenSearch Service domain.

"""
function revoke_vpc_endpoint_access(
    Account, DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticsearch_service(
        "POST",
        "/2015-01-01/es/domain/$(DomainName)/revokeVpcEndpointAccess",
        Dict{String,Any}("Account" => Account);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function revoke_vpc_endpoint_access(
    Account,
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticsearch_service(
        "POST",
        "/2015-01-01/es/domain/$(DomainName)/revokeVpcEndpointAccess",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Account" => Account), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_elasticsearch_service_software_update(domain_name)
    start_elasticsearch_service_software_update(domain_name, params::Dict{String,<:Any})

Schedules a service software update for an Amazon ES domain.

# Arguments
- `domain_name`: The name of the domain that you want to update to the latest service
  software.

"""
function start_elasticsearch_service_software_update(
    DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticsearch_service(
        "POST",
        "/2015-01-01/es/serviceSoftwareUpdate/start",
        Dict{String,Any}("DomainName" => DomainName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_elasticsearch_service_software_update(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticsearch_service(
        "POST",
        "/2015-01-01/es/serviceSoftwareUpdate/start",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DomainName" => DomainName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_elasticsearch_domain_config(domain_name)
    update_elasticsearch_domain_config(domain_name, params::Dict{String,<:Any})

Modifies the cluster configuration of the specified Elasticsearch domain, setting as
setting the instance type and the number of instances.

# Arguments
- `domain_name`: The name of the Elasticsearch domain that you are updating.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccessPolicies"`: IAM access policy as a JSON-formatted string.
- `"AdvancedOptions"`: Modifies the advanced option to allow references to indices in an
  HTTP request body. Must be false when configuring access to individual sub-resources. By
  default, the value is true. See Configuration Advanced Options for more information.
- `"AdvancedSecurityOptions"`: Specifies advanced security options.
- `"AutoTuneOptions"`: Specifies Auto-Tune options.
- `"CognitoOptions"`: Options to specify the Cognito user and identity pools for Kibana
  authentication. For more information, see Amazon Cognito Authentication for Kibana.
- `"DomainEndpointOptions"`: Options to specify configuration that will be applied to the
  domain endpoint.
- `"DryRun"`:  This flag, when set to True, specifies whether the UpdateElasticsearchDomain
  request should return the results of validation checks without actually applying the
  change. This flag, when set to True, specifies the deployment mechanism through which the
  update shall be applied on the domain. This will not actually perform the Update.
- `"EBSOptions"`: Specify the type and size of the EBS volume that you want to use.
- `"ElasticsearchClusterConfig"`: The type and number of instances to instantiate for the
  domain cluster.
- `"EncryptionAtRestOptions"`: Specifies the Encryption At Rest Options.
- `"LogPublishingOptions"`: Map of LogType and LogPublishingOption, each containing options
  to publish a given type of Elasticsearch log.
- `"NodeToNodeEncryptionOptions"`: Specifies the NodeToNodeEncryptionOptions.
- `"SnapshotOptions"`: Option to set the time, in UTC format, for the daily automated
  snapshot. Default value is 0 hours.
- `"VPCOptions"`: Options to specify the subnets and security groups for VPC endpoint. For
  more information, see Creating a VPC in VPC Endpoints for Amazon Elasticsearch Service
  Domains
"""
function update_elasticsearch_domain_config(
    DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticsearch_service(
        "POST",
        "/2015-01-01/es/domain/$(DomainName)/config";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_elasticsearch_domain_config(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticsearch_service(
        "POST",
        "/2015-01-01/es/domain/$(DomainName)/config",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_package(package_id, package_source)
    update_package(package_id, package_source, params::Dict{String,<:Any})

Updates a package for use with Amazon ES domains.

# Arguments
- `package_id`: Unique identifier for the package.
- `package_source`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CommitMessage"`: An info message for the new version which will be shown as part of
  GetPackageVersionHistoryResponse.
- `"PackageDescription"`: New description of the package.
"""
function update_package(
    PackageID, PackageSource; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticsearch_service(
        "POST",
        "/2015-01-01/packages/update",
        Dict{String,Any}("PackageID" => PackageID, "PackageSource" => PackageSource);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_package(
    PackageID,
    PackageSource,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticsearch_service(
        "POST",
        "/2015-01-01/packages/update",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "PackageID" => PackageID, "PackageSource" => PackageSource
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_vpc_endpoint(vpc_endpoint_id, vpc_options)
    update_vpc_endpoint(vpc_endpoint_id, vpc_options, params::Dict{String,<:Any})

Modifies an Amazon OpenSearch Service-managed interface VPC endpoint.

# Arguments
- `vpc_endpoint_id`: Unique identifier of the VPC endpoint to be updated.
- `vpc_options`: The security groups and/or subnets to add, remove, or modify.

"""
function update_vpc_endpoint(
    VpcEndpointId, VpcOptions; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticsearch_service(
        "POST",
        "/2015-01-01/es/vpcEndpoints/update",
        Dict{String,Any}("VpcEndpointId" => VpcEndpointId, "VpcOptions" => VpcOptions);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_vpc_endpoint(
    VpcEndpointId,
    VpcOptions,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticsearch_service(
        "POST",
        "/2015-01-01/es/vpcEndpoints/update",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "VpcEndpointId" => VpcEndpointId, "VpcOptions" => VpcOptions
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    upgrade_elasticsearch_domain(domain_name, target_version)
    upgrade_elasticsearch_domain(domain_name, target_version, params::Dict{String,<:Any})

Allows you to either upgrade your domain or perform an Upgrade eligibility check to a
compatible Elasticsearch version.

# Arguments
- `domain_name`:
- `target_version`: The version of Elasticsearch that you intend to upgrade the domain to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"PerformCheckOnly"`:  This flag, when set to True, indicates that an Upgrade Eligibility
  Check needs to be performed. This will not actually perform the Upgrade.
"""
function upgrade_elasticsearch_domain(
    DomainName, TargetVersion; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticsearch_service(
        "POST",
        "/2015-01-01/es/upgradeDomain",
        Dict{String,Any}("DomainName" => DomainName, "TargetVersion" => TargetVersion);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function upgrade_elasticsearch_domain(
    DomainName,
    TargetVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticsearch_service(
        "POST",
        "/2015-01-01/es/upgradeDomain",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DomainName" => DomainName, "TargetVersion" => TargetVersion
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: dataexchange
using AWS.Compat
using AWS.UUIDs

"""
    cancel_job(job_id)
    cancel_job(job_id, params::Dict{String,<:Any})

This operation cancels a job. Jobs can be cancelled only when they are in the WAITING state.

# Arguments
- `job_id`: The unique identifier for a job.

"""
function cancel_job(JobId; aws_config::AbstractAWSConfig=current_aws_config())
    return dataexchange(
        "DELETE",
        "/v1/jobs/$(JobId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_job(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dataexchange(
        "DELETE",
        "/v1/jobs/$(JobId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_data_set(asset_type, description, name)
    create_data_set(asset_type, description, name, params::Dict{String,<:Any})

This operation creates a data set.

# Arguments
- `asset_type`: The type of asset that is added to a data set.
- `description`: A description for the data set. This value can be up to 16,348 characters
  long.
- `name`: The name of the data set.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: A data set tag is an optional label that you can assign to a data set when you
  create it. Each tag consists of a key and an optional value, both of which you define. When
  you use tagging, you can also use tag-based access control in IAM policies to control
  access to these data sets and revisions.
"""
function create_data_set(
    AssetType, Description, Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dataexchange(
        "POST",
        "/v1/data-sets",
        Dict{String,Any}(
            "AssetType" => AssetType, "Description" => Description, "Name" => Name
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_data_set(
    AssetType,
    Description,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dataexchange(
        "POST",
        "/v1/data-sets",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AssetType" => AssetType, "Description" => Description, "Name" => Name
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_event_action(action, event)
    create_event_action(action, event, params::Dict{String,<:Any})

This operation creates an event action.

# Arguments
- `action`: What occurs after a certain event.
- `event`: What occurs to start an action.

"""
function create_event_action(
    Action, Event; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dataexchange(
        "POST",
        "/v1/event-actions",
        Dict{String,Any}("Action" => Action, "Event" => Event);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_event_action(
    Action,
    Event,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dataexchange(
        "POST",
        "/v1/event-actions",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("Action" => Action, "Event" => Event), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_job(details, type)
    create_job(details, type, params::Dict{String,<:Any})

This operation creates a job.

# Arguments
- `details`: The details for the CreateJob request.
- `type`: The type of job to be created.

"""
function create_job(Details, Type; aws_config::AbstractAWSConfig=current_aws_config())
    return dataexchange(
        "POST",
        "/v1/jobs",
        Dict{String,Any}("Details" => Details, "Type" => Type);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_job(
    Details,
    Type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dataexchange(
        "POST",
        "/v1/jobs",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("Details" => Details, "Type" => Type), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_revision(data_set_id)
    create_revision(data_set_id, params::Dict{String,<:Any})

This operation creates a revision for a data set.

# Arguments
- `data_set_id`: The unique identifier for a data set.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Comment"`: An optional comment about the revision.
- `"Tags"`: A revision tag is an optional label that you can assign to a revision when you
  create it. Each tag consists of a key and an optional value, both of which you define. When
  you use tagging, you can also use tag-based access control in IAM policies to control
  access to these data sets and revisions.
"""
function create_revision(DataSetId; aws_config::AbstractAWSConfig=current_aws_config())
    return dataexchange(
        "POST",
        "/v1/data-sets/$(DataSetId)/revisions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_revision(
    DataSetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dataexchange(
        "POST",
        "/v1/data-sets/$(DataSetId)/revisions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_asset(asset_id, data_set_id, revision_id)
    delete_asset(asset_id, data_set_id, revision_id, params::Dict{String,<:Any})

This operation deletes an asset.

# Arguments
- `asset_id`: The unique identifier for an asset.
- `data_set_id`: The unique identifier for a data set.
- `revision_id`: The unique identifier for a revision.

"""
function delete_asset(
    AssetId, DataSetId, RevisionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dataexchange(
        "DELETE",
        "/v1/data-sets/$(DataSetId)/revisions/$(RevisionId)/assets/$(AssetId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_asset(
    AssetId,
    DataSetId,
    RevisionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dataexchange(
        "DELETE",
        "/v1/data-sets/$(DataSetId)/revisions/$(RevisionId)/assets/$(AssetId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_data_set(data_set_id)
    delete_data_set(data_set_id, params::Dict{String,<:Any})

This operation deletes a data set.

# Arguments
- `data_set_id`: The unique identifier for a data set.

"""
function delete_data_set(DataSetId; aws_config::AbstractAWSConfig=current_aws_config())
    return dataexchange(
        "DELETE",
        "/v1/data-sets/$(DataSetId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_data_set(
    DataSetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dataexchange(
        "DELETE",
        "/v1/data-sets/$(DataSetId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_event_action(event_action_id)
    delete_event_action(event_action_id, params::Dict{String,<:Any})

This operation deletes the event action.

# Arguments
- `event_action_id`: The unique identifier for the event action.

"""
function delete_event_action(
    EventActionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dataexchange(
        "DELETE",
        "/v1/event-actions/$(EventActionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_event_action(
    EventActionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dataexchange(
        "DELETE",
        "/v1/event-actions/$(EventActionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_revision(data_set_id, revision_id)
    delete_revision(data_set_id, revision_id, params::Dict{String,<:Any})

This operation deletes a revision.

# Arguments
- `data_set_id`: The unique identifier for a data set.
- `revision_id`: The unique identifier for a revision.

"""
function delete_revision(
    DataSetId, RevisionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dataexchange(
        "DELETE",
        "/v1/data-sets/$(DataSetId)/revisions/$(RevisionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_revision(
    DataSetId,
    RevisionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dataexchange(
        "DELETE",
        "/v1/data-sets/$(DataSetId)/revisions/$(RevisionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_asset(asset_id, data_set_id, revision_id)
    get_asset(asset_id, data_set_id, revision_id, params::Dict{String,<:Any})

This operation returns information about an asset.

# Arguments
- `asset_id`: The unique identifier for an asset.
- `data_set_id`: The unique identifier for a data set.
- `revision_id`: The unique identifier for a revision.

"""
function get_asset(
    AssetId, DataSetId, RevisionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dataexchange(
        "GET",
        "/v1/data-sets/$(DataSetId)/revisions/$(RevisionId)/assets/$(AssetId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_asset(
    AssetId,
    DataSetId,
    RevisionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dataexchange(
        "GET",
        "/v1/data-sets/$(DataSetId)/revisions/$(RevisionId)/assets/$(AssetId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_data_set(data_set_id)
    get_data_set(data_set_id, params::Dict{String,<:Any})

This operation returns information about a data set.

# Arguments
- `data_set_id`: The unique identifier for a data set.

"""
function get_data_set(DataSetId; aws_config::AbstractAWSConfig=current_aws_config())
    return dataexchange(
        "GET",
        "/v1/data-sets/$(DataSetId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_data_set(
    DataSetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dataexchange(
        "GET",
        "/v1/data-sets/$(DataSetId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_event_action(event_action_id)
    get_event_action(event_action_id, params::Dict{String,<:Any})

This operation retrieves information about an event action.

# Arguments
- `event_action_id`: The unique identifier for the event action.

"""
function get_event_action(EventActionId; aws_config::AbstractAWSConfig=current_aws_config())
    return dataexchange(
        "GET",
        "/v1/event-actions/$(EventActionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_event_action(
    EventActionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dataexchange(
        "GET",
        "/v1/event-actions/$(EventActionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_job(job_id)
    get_job(job_id, params::Dict{String,<:Any})

This operation returns information about a job.

# Arguments
- `job_id`: The unique identifier for a job.

"""
function get_job(JobId; aws_config::AbstractAWSConfig=current_aws_config())
    return dataexchange(
        "GET", "/v1/jobs/$(JobId)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_job(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dataexchange(
        "GET",
        "/v1/jobs/$(JobId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_revision(data_set_id, revision_id)
    get_revision(data_set_id, revision_id, params::Dict{String,<:Any})

This operation returns information about a revision.

# Arguments
- `data_set_id`: The unique identifier for a data set.
- `revision_id`: The unique identifier for a revision.

"""
function get_revision(
    DataSetId, RevisionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dataexchange(
        "GET",
        "/v1/data-sets/$(DataSetId)/revisions/$(RevisionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_revision(
    DataSetId,
    RevisionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dataexchange(
        "GET",
        "/v1/data-sets/$(DataSetId)/revisions/$(RevisionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_data_set_revisions(data_set_id)
    list_data_set_revisions(data_set_id, params::Dict{String,<:Any})

This operation lists a data set's revisions sorted by CreatedAt in descending order.

# Arguments
- `data_set_id`: The unique identifier for a data set.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results returned by a single call.
- `"nextToken"`: The token value retrieved from a previous call to access the next page of
  results.
"""
function list_data_set_revisions(
    DataSetId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dataexchange(
        "GET",
        "/v1/data-sets/$(DataSetId)/revisions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_data_set_revisions(
    DataSetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dataexchange(
        "GET",
        "/v1/data-sets/$(DataSetId)/revisions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_data_sets()
    list_data_sets(params::Dict{String,<:Any})

This operation lists your data sets. When listing by origin OWNED, results are sorted by
CreatedAt in descending order. When listing by origin ENTITLED, there is no order and the
maxResults parameter is ignored.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results returned by a single call.
- `"nextToken"`: The token value retrieved from a previous call to access the next page of
  results.
- `"origin"`: A property that defines the data set as OWNED by the account (for providers)
  or ENTITLED to the account (for subscribers).
"""
function list_data_sets(; aws_config::AbstractAWSConfig=current_aws_config())
    return dataexchange(
        "GET", "/v1/data-sets"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_data_sets(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dataexchange(
        "GET",
        "/v1/data-sets",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_event_actions()
    list_event_actions(params::Dict{String,<:Any})

This operation lists your event actions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"eventSourceId"`: The unique identifier for the event source.
- `"maxResults"`: The maximum number of results returned by a single call.
- `"nextToken"`: The token value retrieved from a previous call to access the next page of
  results.
"""
function list_event_actions(; aws_config::AbstractAWSConfig=current_aws_config())
    return dataexchange(
        "GET", "/v1/event-actions"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_event_actions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dataexchange(
        "GET",
        "/v1/event-actions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_jobs()
    list_jobs(params::Dict{String,<:Any})

This operation lists your jobs sorted by CreatedAt in descending order.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"dataSetId"`: The unique identifier for a data set.
- `"maxResults"`: The maximum number of results returned by a single call.
- `"nextToken"`: The token value retrieved from a previous call to access the next page of
  results.
- `"revisionId"`: The unique identifier for a revision.
"""
function list_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return dataexchange(
        "GET", "/v1/jobs"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dataexchange(
        "GET", "/v1/jobs", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_revision_assets(data_set_id, revision_id)
    list_revision_assets(data_set_id, revision_id, params::Dict{String,<:Any})

This operation lists a revision's assets sorted alphabetically in descending order.

# Arguments
- `data_set_id`: The unique identifier for a data set.
- `revision_id`: The unique identifier for a revision.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results returned by a single call.
- `"nextToken"`: The token value retrieved from a previous call to access the next page of
  results.
"""
function list_revision_assets(
    DataSetId, RevisionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dataexchange(
        "GET",
        "/v1/data-sets/$(DataSetId)/revisions/$(RevisionId)/assets";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_revision_assets(
    DataSetId,
    RevisionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dataexchange(
        "GET",
        "/v1/data-sets/$(DataSetId)/revisions/$(RevisionId)/assets",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

This operation lists the tags on the resource.

# Arguments
- `resource_arn`: An Amazon Resource Name (ARN) that uniquely identifies an AWS resource.

"""
function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dataexchange(
        "GET",
        "/tags/$(ResourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dataexchange(
        "GET",
        "/tags/$(ResourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    revoke_revision(data_set_id, revision_id, revocation_comment)
    revoke_revision(data_set_id, revision_id, revocation_comment, params::Dict{String,<:Any})

This operation revokes subscribers' access to a revision.

# Arguments
- `data_set_id`: The unique identifier for a data set.
- `revision_id`: The unique identifier for a revision.
- `revocation_comment`: A required comment to inform subscribers of the reason their access
  to the revision was revoked.

"""
function revoke_revision(
    DataSetId,
    RevisionId,
    RevocationComment;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dataexchange(
        "POST",
        "/v1/data-sets/$(DataSetId)/revisions/$(RevisionId)/revoke",
        Dict{String,Any}("RevocationComment" => RevocationComment);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function revoke_revision(
    DataSetId,
    RevisionId,
    RevocationComment,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dataexchange(
        "POST",
        "/v1/data-sets/$(DataSetId)/revisions/$(RevisionId)/revoke",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("RevocationComment" => RevocationComment), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    send_api_asset(x-amzn-dataexchange-asset-id, x-amzn-dataexchange-data-set-id, x-amzn-dataexchange-revision-id)
    send_api_asset(x-amzn-dataexchange-asset-id, x-amzn-dataexchange-data-set-id, x-amzn-dataexchange-revision-id, params::Dict{String,<:Any})

This operation invokes an API Gateway API asset. The request is proxied to the provider’s
API Gateway API.

# Arguments
- `x-amzn-dataexchange-asset-id`: Asset ID value for the API request.
- `x-amzn-dataexchange-data-set-id`: Data set ID value for the API request.
- `x-amzn-dataexchange-revision-id`: Revision ID value for the API request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Body"`: The request body.
- `"QueryStringParameters"`: Attach query string parameters to the end of the URI (for
  example, /v1/examplePath?exampleParam=exampleValue).
- `"x-amzn-dataexchange-header-"`: Any header value prefixed with
  x-amzn-dataexchange-header- will have that stripped before sending the Asset API request.
  Use this when you want to override a header that AWS Data Exchange uses. Alternatively, you
  can use the header without a prefix to the HTTP request.
- `"x-amzn-dataexchange-http-method"`: HTTP method value for the API request.
  Alternatively, you can use the appropriate verb in your request.
- `"x-amzn-dataexchange-path"`: URI path value for the API request. Alternatively, you can
  set the URI path directly by invoking /v1/{pathValue}.
"""
function send_api_asset(
    x_amzn_dataexchange_asset_id,
    x_amzn_dataexchange_data_set_id,
    x_amzn_dataexchange_revision_id;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dataexchange(
        "POST",
        "/v1",
        Dict{String,Any}(
            "headers" => Dict{String,Any}(
                "x-amzn-dataexchange-asset-id" => x_amzn_dataexchange_asset_id,
                "x-amzn-dataexchange-data-set-id" => x_amzn_dataexchange_data_set_id,
                "x-amzn-dataexchange-revision-id" => x_amzn_dataexchange_revision_id,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function send_api_asset(
    x_amzn_dataexchange_asset_id,
    x_amzn_dataexchange_data_set_id,
    x_amzn_dataexchange_revision_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dataexchange(
        "POST",
        "/v1",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "headers" => Dict{String,Any}(
                        "x-amzn-dataexchange-asset-id" => x_amzn_dataexchange_asset_id,
                        "x-amzn-dataexchange-data-set-id" =>
                            x_amzn_dataexchange_data_set_id,
                        "x-amzn-dataexchange-revision-id" =>
                            x_amzn_dataexchange_revision_id,
                    ),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    send_data_set_notification(data_set_id, type)
    send_data_set_notification(data_set_id, type, params::Dict{String,<:Any})

The type of event associated with the data set.

# Arguments
- `data_set_id`: Affected data set of the notification.
- `type`: The type of the notification. Describing the kind of event the notification is
  alerting you to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: Idempotency key for the notification, this key allows us to deduplicate
  notifications that are sent in quick succession erroneously.
- `"Comment"`: Free-form text field for providers to add information about their
  notifications.
- `"Details"`: Extra details specific to this notification type.
- `"Scope"`: Affected scope of this notification such as the underlying resources affected
  by the notification event.
"""
function send_data_set_notification(
    DataSetId, Type; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dataexchange(
        "POST",
        "/v1/data-sets/$(DataSetId)/notification",
        Dict{String,Any}("Type" => Type, "ClientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function send_data_set_notification(
    DataSetId,
    Type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dataexchange(
        "POST",
        "/v1/data-sets/$(DataSetId)/notification",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Type" => Type, "ClientToken" => string(uuid4())),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_job(job_id)
    start_job(job_id, params::Dict{String,<:Any})

This operation starts a job.

# Arguments
- `job_id`: The unique identifier for a job.

"""
function start_job(JobId; aws_config::AbstractAWSConfig=current_aws_config())
    return dataexchange(
        "PATCH", "/v1/jobs/$(JobId)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function start_job(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dataexchange(
        "PATCH",
        "/v1/jobs/$(JobId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

This operation tags a resource.

# Arguments
- `resource_arn`: An Amazon Resource Name (ARN) that uniquely identifies an AWS resource.
- `tags`: A label that consists of a customer-defined key and an optional value.

"""
function tag_resource(ResourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return dataexchange(
        "POST",
        "/tags/$(ResourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dataexchange(
        "POST",
        "/tags/$(ResourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

This operation removes one or more tags from a resource.

# Arguments
- `resource_arn`: An Amazon Resource Name (ARN) that uniquely identifies an AWS resource.
- `tag_keys`: The key tags.

"""
function untag_resource(
    ResourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dataexchange(
        "DELETE",
        "/tags/$(ResourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dataexchange(
        "DELETE",
        "/tags/$(ResourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_asset(asset_id, data_set_id, name, revision_id)
    update_asset(asset_id, data_set_id, name, revision_id, params::Dict{String,<:Any})

This operation updates an asset.

# Arguments
- `asset_id`: The unique identifier for an asset.
- `data_set_id`: The unique identifier for a data set.
- `name`: The name of the asset. When importing from Amazon S3, the Amazon S3 object key is
  used as the asset name. When exporting to Amazon S3, the asset name is used as default
  target Amazon S3 object key. When importing from Amazon API Gateway API, the API name is
  used as the asset name. When importing from Amazon Redshift, the datashare name is used as
  the asset name. When importing from AWS Lake Formation, the static values of \"Database(s)
  included in the LF-tag policy\" or \"Table(s) included in LF-tag policy\" are used as the
  name.
- `revision_id`: The unique identifier for a revision.

"""
function update_asset(
    AssetId, DataSetId, Name, RevisionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dataexchange(
        "PATCH",
        "/v1/data-sets/$(DataSetId)/revisions/$(RevisionId)/assets/$(AssetId)",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_asset(
    AssetId,
    DataSetId,
    Name,
    RevisionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dataexchange(
        "PATCH",
        "/v1/data-sets/$(DataSetId)/revisions/$(RevisionId)/assets/$(AssetId)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_data_set(data_set_id)
    update_data_set(data_set_id, params::Dict{String,<:Any})

This operation updates a data set.

# Arguments
- `data_set_id`: The unique identifier for a data set.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: The description for the data set.
- `"Name"`: The name of the data set.
"""
function update_data_set(DataSetId; aws_config::AbstractAWSConfig=current_aws_config())
    return dataexchange(
        "PATCH",
        "/v1/data-sets/$(DataSetId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_data_set(
    DataSetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dataexchange(
        "PATCH",
        "/v1/data-sets/$(DataSetId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_event_action(event_action_id)
    update_event_action(event_action_id, params::Dict{String,<:Any})

This operation updates the event action.

# Arguments
- `event_action_id`: The unique identifier for the event action.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Action"`: What occurs after a certain event.
"""
function update_event_action(
    EventActionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dataexchange(
        "PATCH",
        "/v1/event-actions/$(EventActionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_event_action(
    EventActionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dataexchange(
        "PATCH",
        "/v1/event-actions/$(EventActionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_revision(data_set_id, revision_id)
    update_revision(data_set_id, revision_id, params::Dict{String,<:Any})

This operation updates a revision.

# Arguments
- `data_set_id`: The unique identifier for a data set.
- `revision_id`: The unique identifier for a revision.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Comment"`: An optional comment about the revision.
- `"Finalized"`: Finalizing a revision tells AWS Data Exchange that your changes to the
  assets in the revision are complete. After it's in this read-only state, you can publish
  the revision to your products.
"""
function update_revision(
    DataSetId, RevisionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dataexchange(
        "PATCH",
        "/v1/data-sets/$(DataSetId)/revisions/$(RevisionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_revision(
    DataSetId,
    RevisionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dataexchange(
        "PATCH",
        "/v1/data-sets/$(DataSetId)/revisions/$(RevisionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: marketplace_commerce_analytics
using AWS.Compat
using AWS.UUIDs

"""
    generate_data_set(data_set_publication_date, data_set_type, destination_s3_bucket_name, role_name_arn, sns_topic_arn)
    generate_data_set(data_set_publication_date, data_set_type, destination_s3_bucket_name, role_name_arn, sns_topic_arn, params::Dict{String,<:Any})

Given a data set type and data set publication date, asynchronously publishes the requested
data set to the specified S3 bucket and notifies the specified SNS topic once the data is
available. Returns a unique request identifier that can be used to correlate requests with
notifications from the SNS topic. Data sets will be published in comma-separated values
(CSV) format with the file name {data_set_type}_YYYY-MM-DD.csv. If a file with the same
name already exists (e.g. if the same data set is requested twice), the original file will
be overwritten by the new file. Requires a Role with an attached permissions policy
providing Allow permissions for the following actions: s3:PutObject, s3:GetBucketLocation,
sns:GetTopicAttributes, sns:Publish, iam:GetRolePolicy.

# Arguments
- `data_set_publication_date`: The date a data set was published. For daily data sets,
  provide a date with day-level granularity for the desired day. For monthly data sets except
  those with prefix disbursed_amount, provide a date with month-level granularity for the
  desired month (the day value will be ignored). For data sets with prefix disbursed_amount,
  provide a date with day-level granularity for the desired day. For these data sets we will
  look backwards in time over the range of 31 days until the first data set is found (the
  latest one).
- `data_set_type`: The desired data set type.
  customer_subscriber_hourly_monthly_subscriptions From 2017-09-15 to present: Available
  daily by 24:00 UTC.   customer_subscriber_annual_subscriptions From 2017-09-15 to present:
  Available daily by 24:00 UTC.   daily_business_usage_by_instance_type From 2017-09-15 to
  present: Available daily by 24:00 UTC.   daily_business_fees From 2017-09-15 to present:
  Available daily by 24:00 UTC.   daily_business_free_trial_conversions From 2017-09-15 to
  present: Available daily by 24:00 UTC.   daily_business_new_instances From 2017-09-15 to
  present: Available daily by 24:00 UTC.   daily_business_new_product_subscribers From
  2017-09-15 to present: Available daily by 24:00 UTC.
  daily_business_canceled_product_subscribers From 2017-09-15 to present: Available daily by
  24:00 UTC.   monthly_revenue_billing_and_revenue_data From 2017-09-15 to present: Available
  monthly on the 15th day of the month by 24:00 UTC. Data includes metered transactions (e.g.
  hourly) from one month prior.   monthly_revenue_annual_subscriptions From 2017-09-15 to
  present: Available monthly on the 15th day of the month by 24:00 UTC. Data includes
  up-front software charges (e.g. annual) from one month prior.
  monthly_revenue_field_demonstration_usage From 2018-03-15 to present: Available monthly on
  the 15th day of the month by 24:00 UTC.   monthly_revenue_flexible_payment_schedule From
  2018-11-15 to present: Available monthly on the 15th day of the month by 24:00 UTC.
  disbursed_amount_by_product From 2017-09-15 to present: Available every 30 days by 24:00
  UTC.   disbursed_amount_by_instance_hours From 2017-09-15 to present: Available every 30
  days by 24:00 UTC.   disbursed_amount_by_customer_geo From 2017-09-15 to present: Available
  every 30 days by 24:00 UTC.   disbursed_amount_by_age_of_uncollected_funds From 2017-09-15
  to present: Available every 30 days by 24:00 UTC.
  disbursed_amount_by_age_of_disbursed_funds From 2017-09-15 to present: Available every 30
  days by 24:00 UTC.   disbursed_amount_by_age_of_past_due_funds From 2018-04-07 to present:
  Available every 30 days by 24:00 UTC.   disbursed_amount_by_uncollected_funds_breakdown
  From 2019-10-04 to present: Available every 30 days by 24:00 UTC.
  sales_compensation_billed_revenue From 2017-09-15 to present: Available monthly on the 15th
  day of the month by 24:00 UTC. Data includes metered transactions (e.g. hourly) from one
  month prior, and up-front software charges (e.g. annual) from one month prior.
  us_sales_and_use_tax_records From 2017-09-15 to present: Available monthly on the 15th day
  of the month by 24:00 UTC.   disbursed_amount_by_product_with_uncollected_funds This data
  set is deprecated. Download related reports from AMMP instead!
  customer_profile_by_industry This data set is deprecated. Download related reports from
  AMMP instead!   customer_profile_by_revenue This data set is deprecated. Download related
  reports from AMMP instead!   customer_profile_by_geography This data set is deprecated.
  Download related reports from AMMP instead!
- `destination_s3_bucket_name`: The name (friendly name, not ARN) of the destination S3
  bucket.
- `role_name_arn`: The Amazon Resource Name (ARN) of the Role with an attached permissions
  policy to interact with the provided AWS services.
- `sns_topic_arn`: Amazon Resource Name (ARN) for the SNS Topic that will be notified when
  the data set has been published or if an error has occurred.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"customerDefinedValues"`: (Optional) Key-value pairs which will be returned, unmodified,
  in the Amazon SNS notification message and the data set metadata file. These key-value
  pairs can be used to correlated responses with tracking information from other systems.
- `"destinationS3Prefix"`: (Optional) The desired S3 prefix for the published data set,
  similar to a directory path in standard file systems. For example, if given the bucket name
  \"mybucket\" and the prefix \"myprefix/mydatasets\", the output file \"outputfile\" would
  be published to \"s3://mybucket/myprefix/mydatasets/outputfile\". If the prefix directory
  structure does not exist, it will be created. If no prefix is provided, the data set will
  be published to the S3 bucket root.
"""
function generate_data_set(
    dataSetPublicationDate,
    dataSetType,
    destinationS3BucketName,
    roleNameArn,
    snsTopicArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return marketplace_commerce_analytics(
        "GenerateDataSet",
        Dict{String,Any}(
            "dataSetPublicationDate" => dataSetPublicationDate,
            "dataSetType" => dataSetType,
            "destinationS3BucketName" => destinationS3BucketName,
            "roleNameArn" => roleNameArn,
            "snsTopicArn" => snsTopicArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function generate_data_set(
    dataSetPublicationDate,
    dataSetType,
    destinationS3BucketName,
    roleNameArn,
    snsTopicArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return marketplace_commerce_analytics(
        "GenerateDataSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "dataSetPublicationDate" => dataSetPublicationDate,
                    "dataSetType" => dataSetType,
                    "destinationS3BucketName" => destinationS3BucketName,
                    "roleNameArn" => roleNameArn,
                    "snsTopicArn" => snsTopicArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_support_data_export(data_set_type, destination_s3_bucket_name, from_date, role_name_arn, sns_topic_arn)
    start_support_data_export(data_set_type, destination_s3_bucket_name, from_date, role_name_arn, sns_topic_arn, params::Dict{String,<:Any})

This target has been deprecated. Given a data set type and a from date, asynchronously
publishes the requested customer support data to the specified S3 bucket and notifies the
specified SNS topic once the data is available. Returns a unique request identifier that
can be used to correlate requests with notifications from the SNS topic. Data sets will be
published in comma-separated values (CSV) format with the file name
{data_set_type}_YYYY-MM-DD'T'HH-mm-ss'Z'.csv. If a file with the same name already exists
(e.g. if the same data set is requested twice), the original file will be overwritten by
the new file. Requires a Role with an attached permissions policy providing Allow
permissions for the following actions: s3:PutObject, s3:GetBucketLocation,
sns:GetTopicAttributes, sns:Publish, iam:GetRolePolicy.

# Arguments
- `data_set_type`:  This target has been deprecated. Specifies the data set type to be
  written to the output csv file. The data set types customer_support_contacts_data and
  test_customer_support_contacts_data both result in a csv file containing the following
  fields: Product Id, Product Code, Customer Guid, Subscription Guid, Subscription Start
  Date, Organization, AWS Account Id, Given Name, Surname, Telephone Number, Email, Title,
  Country Code, ZIP Code, Operation Type, and Operation Time.
  customer_support_contacts_data Customer support contact data. The data set will contain all
  changes (Creates, Updates, and Deletes) to customer support contact data from the date
  specified in the from_date parameter. test_customer_support_contacts_data An example data
  set containing static test data in the same format as customer_support_contacts_data
- `destination_s3_bucket_name`: This target has been deprecated. The name (friendly name,
  not ARN) of the destination S3 bucket.
- `from_date`: This target has been deprecated. The start date from which to retrieve the
  data set in UTC. This parameter only affects the customer_support_contacts_data data set
  type.
- `role_name_arn`: This target has been deprecated. The Amazon Resource Name (ARN) of the
  Role with an attached permissions policy to interact with the provided AWS services.
- `sns_topic_arn`: This target has been deprecated. Amazon Resource Name (ARN) for the SNS
  Topic that will be notified when the data set has been published or if an error has
  occurred.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"customerDefinedValues"`: This target has been deprecated. (Optional) Key-value pairs
  which will be returned, unmodified, in the Amazon SNS notification message and the data set
  metadata file.
- `"destinationS3Prefix"`: This target has been deprecated. (Optional) The desired S3
  prefix for the published data set, similar to a directory path in standard file systems.
  For example, if given the bucket name \"mybucket\" and the prefix \"myprefix/mydatasets\",
  the output file \"outputfile\" would be published to
  \"s3://mybucket/myprefix/mydatasets/outputfile\". If the prefix directory structure does
  not exist, it will be created. If no prefix is provided, the data set will be published to
  the S3 bucket root.
"""
function start_support_data_export(
    dataSetType,
    destinationS3BucketName,
    fromDate,
    roleNameArn,
    snsTopicArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return marketplace_commerce_analytics(
        "StartSupportDataExport",
        Dict{String,Any}(
            "dataSetType" => dataSetType,
            "destinationS3BucketName" => destinationS3BucketName,
            "fromDate" => fromDate,
            "roleNameArn" => roleNameArn,
            "snsTopicArn" => snsTopicArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_support_data_export(
    dataSetType,
    destinationS3BucketName,
    fromDate,
    roleNameArn,
    snsTopicArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return marketplace_commerce_analytics(
        "StartSupportDataExport",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "dataSetType" => dataSetType,
                    "destinationS3BucketName" => destinationS3BucketName,
                    "fromDate" => fromDate,
                    "roleNameArn" => roleNameArn,
                    "snsTopicArn" => snsTopicArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: sqs
using AWS.Compat
using AWS.UUIDs

"""
    add_permission(awsaccount_ids, actions, label, queue_url)
    add_permission(awsaccount_ids, actions, label, queue_url, params::Dict{String,<:Any})

Adds a permission to a queue for a specific principal. This allows sharing access to the
queue. When you create a queue, you have full control access rights for the queue. Only
you, the owner of the queue, can grant or deny permissions to the queue. For more
information about these permissions, see Allow Developers to Write Messages to a Shared
Queue in the Amazon SQS Developer Guide.     AddPermission generates a policy for you. You
can use  SetQueueAttributes  to upload your policy. For more information, see Using Custom
Policies with the Amazon SQS Access Policy Language in the Amazon SQS Developer Guide.   An
Amazon SQS policy can have a maximum of seven actions per statement.   To remove the
ability to change queue permissions, you must deny permission to the AddPermission,
RemovePermission, and SetQueueAttributes actions in your IAM policy.   Amazon SQS
AddPermission does not support adding a non-account principal.     Cross-account
permissions don't apply to this action. For more information, see Grant cross-account
permissions to a role and a username in the Amazon SQS Developer Guide.

# Arguments
- `awsaccount_ids`: The Amazon Web Services account numbers of the principals who are to
  receive permission. For information about locating the Amazon Web Services account
  identification, see Your Amazon Web Services Identifiers in the Amazon SQS Developer Guide.
- `actions`: The action the client wants to allow for the specified principal. Valid
  values: the name of any action or *. For more information about these actions, see Overview
  of Managing Access Permissions to Your Amazon Simple Queue Service Resource in the Amazon
  SQS Developer Guide. Specifying SendMessage, DeleteMessage, or ChangeMessageVisibility for
  ActionName.n also grants permissions for the corresponding batch versions of those actions:
  SendMessageBatch, DeleteMessageBatch, and ChangeMessageVisibilityBatch.
- `label`: The unique identification of the permission you're setting (for example,
  AliceSendMessage). Maximum 80 characters. Allowed characters include alphanumeric
  characters, hyphens (-), and underscores (_).
- `queue_url`: The URL of the Amazon SQS queue to which permissions are added. Queue URLs
  and names are case-sensitive.

"""
function add_permission(
    AWSAccountIds,
    Actions,
    Label,
    QueueUrl;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sqs(
        "AddPermission",
        Dict{String,Any}(
            "AWSAccountIds" => AWSAccountIds,
            "Actions" => Actions,
            "Label" => Label,
            "QueueUrl" => QueueUrl,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_permission(
    AWSAccountIds,
    Actions,
    Label,
    QueueUrl,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sqs(
        "AddPermission",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AWSAccountIds" => AWSAccountIds,
                    "Actions" => Actions,
                    "Label" => Label,
                    "QueueUrl" => QueueUrl,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_message_move_task(task_handle)
    cancel_message_move_task(task_handle, params::Dict{String,<:Any})

Cancels a specified message movement task. A message movement can only be cancelled when
the current status is RUNNING. Cancelling a message movement task does not revert the
messages that have already been moved. It can only stop the messages that have not been
moved yet.    This action is currently limited to supporting message redrive from
dead-letter queues (DLQs) only. In this context, the source queue is the dead-letter queue
(DLQ), while the destination queue can be the original source queue (from which the
messages were driven to the dead-letter-queue), or a custom destination queue.    Only one
active message movement task is supported per queue at any given time.

# Arguments
- `task_handle`: An identifier associated with a message movement task.

"""
function cancel_message_move_task(
    TaskHandle; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sqs(
        "CancelMessageMoveTask",
        Dict{String,Any}("TaskHandle" => TaskHandle);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_message_move_task(
    TaskHandle,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sqs(
        "CancelMessageMoveTask",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TaskHandle" => TaskHandle), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    change_message_visibility(queue_url, receipt_handle, visibility_timeout)
    change_message_visibility(queue_url, receipt_handle, visibility_timeout, params::Dict{String,<:Any})

Changes the visibility timeout of a specified message in a queue to a new value. The
default visibility timeout for a message is 30 seconds. The minimum is 0 seconds. The
maximum is 12 hours. For more information, see Visibility Timeout in the Amazon SQS
Developer Guide. For example, if the default timeout for a queue is 60 seconds, 15 seconds
have elapsed since you received the message, and you send a ChangeMessageVisibility call
with VisibilityTimeout set to 10 seconds, the 10 seconds begin to count from the time that
you make the ChangeMessageVisibility call. Thus, any attempt to change the visibility
timeout or to delete that message 10 seconds after you initially change the visibility
timeout (a total of 25 seconds) might result in an error. An Amazon SQS message has three
basic states:   Sent to a queue by a producer.   Received from the queue by a consumer.
Deleted from the queue.   A message is considered to be stored after it is sent to a queue
by a producer, but not yet received from the queue by a consumer (that is, between states 1
and 2). There is no limit to the number of stored messages. A message is considered to be
in flight after it is received from a queue by a consumer, but not yet deleted from the
queue (that is, between states 2 and 3). There is a limit to the number of in flight
messages. Limits that apply to in flight messages are unrelated to the unlimited number of
stored messages. For most standard queues (depending on queue traffic and message backlog),
there can be a maximum of approximately 120,000 in flight messages (received from a queue
by a consumer, but not yet deleted from the queue). If you reach this limit, Amazon SQS
returns the OverLimit error message. To avoid reaching the limit, you should delete
messages from the queue after they're processed. You can also increase the number of queues
you use to process your messages. To request a limit increase, file a support request. For
FIFO queues, there can be a maximum of 20,000 in flight messages (received from a queue by
a consumer, but not yet deleted from the queue). If you reach this limit, Amazon SQS
returns no error messages.  If you attempt to set the VisibilityTimeout to a value greater
than the maximum time left, Amazon SQS returns an error. Amazon SQS doesn't automatically
recalculate and increase the timeout to the maximum remaining time. Unlike with a queue,
when you change the visibility timeout for a specific message the timeout value is applied
immediately but isn't saved in memory for that message. If you don't delete a message after
it is received, the visibility timeout for the message reverts to the original timeout
value (not to the value you set using the ChangeMessageVisibility action) the next time the
message is received.

# Arguments
- `queue_url`: The URL of the Amazon SQS queue whose message's visibility is changed. Queue
  URLs and names are case-sensitive.
- `receipt_handle`: The receipt handle associated with the message, whose visibility
  timeout is changed. This parameter is returned by the  ReceiveMessage  action.
- `visibility_timeout`: The new value for the message's visibility timeout (in seconds).
  Values range: 0 to 43200. Maximum: 12 hours.

"""
function change_message_visibility(
    QueueUrl,
    ReceiptHandle,
    VisibilityTimeout;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sqs(
        "ChangeMessageVisibility",
        Dict{String,Any}(
            "QueueUrl" => QueueUrl,
            "ReceiptHandle" => ReceiptHandle,
            "VisibilityTimeout" => VisibilityTimeout,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function change_message_visibility(
    QueueUrl,
    ReceiptHandle,
    VisibilityTimeout,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sqs(
        "ChangeMessageVisibility",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "QueueUrl" => QueueUrl,
                    "ReceiptHandle" => ReceiptHandle,
                    "VisibilityTimeout" => VisibilityTimeout,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    change_message_visibility_batch(entries, queue_url)
    change_message_visibility_batch(entries, queue_url, params::Dict{String,<:Any})

Changes the visibility timeout of multiple messages. This is a batch version of
ChangeMessageVisibility. The result of the action on each message is reported individually
in the response. You can send up to 10  ChangeMessageVisibility  requests with each
ChangeMessageVisibilityBatch action.  Because the batch request can result in a combination
of successful and unsuccessful actions, you should check for batch errors even when the
call returns an HTTP status code of 200.

# Arguments
- `entries`: Lists the receipt handles of the messages for which the visibility timeout
  must be changed.
- `queue_url`: The URL of the Amazon SQS queue whose messages' visibility is changed. Queue
  URLs and names are case-sensitive.

"""
function change_message_visibility_batch(
    Entries, QueueUrl; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sqs(
        "ChangeMessageVisibilityBatch",
        Dict{String,Any}("Entries" => Entries, "QueueUrl" => QueueUrl);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function change_message_visibility_batch(
    Entries,
    QueueUrl,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sqs(
        "ChangeMessageVisibilityBatch",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Entries" => Entries, "QueueUrl" => QueueUrl),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_queue(queue_name)
    create_queue(queue_name, params::Dict{String,<:Any})

Creates a new standard or FIFO queue. You can pass one or more attributes in the request.
Keep the following in mind:   If you don't specify the FifoQueue attribute, Amazon SQS
creates a standard queue.  You can't change the queue type after you create it and you
can't convert an existing standard queue into a FIFO queue. You must either create a new
FIFO queue for your application or delete your existing standard queue and recreate it as a
FIFO queue. For more information, see Moving From a Standard Queue to a FIFO Queue in the
Amazon SQS Developer Guide.     If you don't provide a value for an attribute, the queue is
created with the default value for the attribute.   If you delete a queue, you must wait at
least 60 seconds before creating a queue with the same name.   To successfully create a new
queue, you must provide a queue name that adheres to the limits related to queues and is
unique within the scope of your queues.  After you create a queue, you must wait at least
one second after the queue is created to be able to use the queue.  To get the queue URL,
use the  GetQueueUrl  action.  GetQueueUrl  requires only the QueueName parameter. be aware
of existing queue names:   If you provide the name of an existing queue along with the
exact names and values of all the queue's attributes, CreateQueue returns the queue URL for
the existing queue.   If the queue name, attribute names, or attribute values don't match
an existing queue, CreateQueue returns an error.    Cross-account permissions don't apply
to this action. For more information, see Grant cross-account permissions to a role and a
username in the Amazon SQS Developer Guide.

# Arguments
- `queue_name`: The name of the new queue. The following limits apply to this name:   A
  queue name can have up to 80 characters.   Valid values: alphanumeric characters, hyphens
  (-), and underscores (_).   A FIFO queue name must end with the .fifo suffix.   Queue URLs
  and names are case-sensitive.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Attributes"`: A map of attributes with their corresponding values. The following lists
  the names, descriptions, and values of the special request parameters that the CreateQueue
  action uses:    DelaySeconds – The length of time, in seconds, for which the delivery of
  all messages in the queue is delayed. Valid values: An integer from 0 to 900 seconds (15
  minutes). Default: 0.     MaximumMessageSize – The limit of how many bytes a message can
  contain before Amazon SQS rejects it. Valid values: An integer from 1,024 bytes (1 KiB) to
  262,144 bytes (256 KiB). Default: 262,144 (256 KiB).     MessageRetentionPeriod – The
  length of time, in seconds, for which Amazon SQS retains a message. Valid values: An
  integer from 60 seconds (1 minute) to 1,209,600 seconds (14 days). Default: 345,600 (4
  days). When you change a queue's attributes, the change can take up to 60 seconds for most
  of the attributes to propagate throughout the Amazon SQS system. Changes made to the
  MessageRetentionPeriod attribute can take up to 15 minutes and will impact existing
  messages in the queue potentially causing them to be expired and deleted if the
  MessageRetentionPeriod is reduced below the age of existing messages.    Policy – The
  queue's policy. A valid Amazon Web Services policy. For more information about policy
  structure, see Overview of Amazon Web Services IAM Policies in the IAM User Guide.
  ReceiveMessageWaitTimeSeconds – The length of time, in seconds, for which a
  ReceiveMessage  action waits for a message to arrive. Valid values: An integer from 0 to 20
  (seconds). Default: 0.     VisibilityTimeout – The visibility timeout for the queue, in
  seconds. Valid values: An integer from 0 to 43,200 (12 hours). Default: 30. For more
  information about the visibility timeout, see Visibility Timeout in the Amazon SQS
  Developer Guide.   The following attributes apply only to dead-letter queues:
  RedrivePolicy – The string that includes the parameters for the dead-letter queue
  functionality of the source queue as a JSON object. The parameters are as follows:
  deadLetterTargetArn – The Amazon Resource Name (ARN) of the dead-letter queue to which
  Amazon SQS moves messages after the value of maxReceiveCount is exceeded.
  maxReceiveCount – The number of times a message is delivered to the source queue before
  being moved to the dead-letter queue. Default: 10. When the ReceiveCount for a message
  exceeds the maxReceiveCount for a queue, Amazon SQS moves the message to the
  dead-letter-queue.      RedriveAllowPolicy – The string that includes the parameters for
  the permissions for the dead-letter queue redrive permission and which source queues can
  specify dead-letter queues as a JSON object. The parameters are as follows:
  redrivePermission – The permission type that defines which source queues can specify the
  current queue as the dead-letter queue. Valid values are:    allowAll – (Default) Any
  source queues in this Amazon Web Services account in the same Region can specify this queue
  as the dead-letter queue.    denyAll – No source queues can specify this queue as the
  dead-letter queue.    byQueue – Only queues specified by the sourceQueueArns parameter
  can specify this queue as the dead-letter queue.      sourceQueueArns – The Amazon
  Resource Names (ARN)s of the source queues that can specify this queue as the dead-letter
  queue and redrive messages. You can specify this parameter only when the redrivePermission
  parameter is set to byQueue. You can specify up to 10 source queue ARNs. To allow more than
  10 source queues to specify dead-letter queues, set the redrivePermission parameter to
  allowAll.      The dead-letter queue of a FIFO queue must also be a FIFO queue. Similarly,
  the dead-letter queue of a standard queue must also be a standard queue.  The following
  attributes apply only to server-side-encryption:    KmsMasterKeyId – The ID of an Amazon
  Web Services managed customer master key (CMK) for Amazon SQS or a custom CMK. For more
  information, see Key Terms. While the alias of the Amazon Web Services managed CMK for
  Amazon SQS is always alias/aws/sqs, the alias of a custom CMK can, for example, be
  alias/MyAlias . For more examples, see KeyId in the Key Management Service API Reference.
    KmsDataKeyReusePeriodSeconds – The length of time, in seconds, for which Amazon SQS can
  reuse a data key to encrypt or decrypt messages before calling KMS again. An integer
  representing seconds, between 60 seconds (1 minute) and 86,400 seconds (24 hours). Default:
  300 (5 minutes). A shorter time period provides better security but results in more calls
  to KMS which might incur charges after Free Tier. For more information, see How Does the
  Data Key Reuse Period Work?     SqsManagedSseEnabled – Enables server-side queue
  encryption using SQS owned encryption keys. Only one server-side encryption option is
  supported per queue (for example, SSE-KMS or SSE-SQS).   The following attributes apply
  only to FIFO (first-in-first-out) queues:    FifoQueue – Designates a queue as FIFO.
  Valid values are true and false. If you don't specify the FifoQueue attribute, Amazon SQS
  creates a standard queue. You can provide this attribute only during queue creation. You
  can't change it for an existing queue. When you set this attribute, you must also provide
  the MessageGroupId for your messages explicitly. For more information, see FIFO queue logic
  in the Amazon SQS Developer Guide.    ContentBasedDeduplication – Enables content-based
  deduplication. Valid values are true and false. For more information, see Exactly-once
  processing in the Amazon SQS Developer Guide. Note the following:    Every message must
  have a unique MessageDeduplicationId.   You may provide a MessageDeduplicationId
  explicitly.   If you aren't able to provide a MessageDeduplicationId and you enable
  ContentBasedDeduplication for your queue, Amazon SQS uses a SHA-256 hash to generate the
  MessageDeduplicationId using the body of the message (but not the attributes of the
  message).    If you don't provide a MessageDeduplicationId and the queue doesn't have
  ContentBasedDeduplication set, the action fails with an error.   If the queue has
  ContentBasedDeduplication set, your MessageDeduplicationId overrides the generated one.
  When ContentBasedDeduplication is in effect, messages with identical content sent within
  the deduplication interval are treated as duplicates and only one copy of the message is
  delivered.   If you send one message with ContentBasedDeduplication enabled and then
  another message with a MessageDeduplicationId that is the same as the one generated for the
  first MessageDeduplicationId, the two messages are treated as duplicates and only one copy
  of the message is delivered.      The following attributes apply only to high throughput
  for FIFO queues:    DeduplicationScope – Specifies whether message deduplication occurs
  at the message group or queue level. Valid values are messageGroup and queue.
  FifoThroughputLimit – Specifies whether the FIFO queue throughput quota applies to the
  entire queue or per message group. Valid values are perQueue and perMessageGroupId. The
  perMessageGroupId value is allowed only when the value for DeduplicationScope is
  messageGroup.   To enable high throughput for FIFO queues, do the following:   Set
  DeduplicationScope to messageGroup.   Set FifoThroughputLimit to perMessageGroupId.   If
  you set these attributes to anything other than the values shown for enabling high
  throughput, normal throughput is in effect and deduplication occurs as specified. For
  information on throughput quotas, see Quotas related to messages in the Amazon SQS
  Developer Guide.
- `"tags"`: Add cost allocation tags to the specified Amazon SQS queue. For an overview,
  see Tagging Your Amazon SQS Queues in the Amazon SQS Developer Guide. When you use queue
  tags, keep the following guidelines in mind:   Adding more than 50 tags to a queue isn't
  recommended.   Tags don't have any semantic meaning. Amazon SQS interprets tags as
  character strings.   Tags are case-sensitive.   A new tag with a key identical to that of
  an existing tag overwrites the existing tag.   For a full list of tag restrictions, see
  Quotas related to queues in the Amazon SQS Developer Guide.  To be able to tag a queue on
  creation, you must have the sqs:CreateQueue and sqs:TagQueue permissions. Cross-account
  permissions don't apply to this action. For more information, see Grant cross-account
  permissions to a role and a username in the Amazon SQS Developer Guide.
"""
function create_queue(QueueName; aws_config::AbstractAWSConfig=current_aws_config())
    return sqs(
        "CreateQueue",
        Dict{String,Any}("QueueName" => QueueName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_queue(
    QueueName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sqs(
        "CreateQueue",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("QueueName" => QueueName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_message(queue_url, receipt_handle)
    delete_message(queue_url, receipt_handle, params::Dict{String,<:Any})

Deletes the specified message from the specified queue. To select the message to delete,
use the ReceiptHandle of the message (not the MessageId which you receive when you send the
message). Amazon SQS can delete a message from a queue even if a visibility timeout setting
causes the message to be locked by another consumer. Amazon SQS automatically deletes
messages left in a queue longer than the retention period configured for the queue.   The
ReceiptHandle is associated with a specific instance of receiving a message. If you receive
a message more than once, the ReceiptHandle is different each time you receive a message.
When you use the DeleteMessage action, you must provide the most recently received
ReceiptHandle for the message (otherwise, the request succeeds, but the message will not be
deleted). For standard queues, it is possible to receive a message even after you delete
it. This might happen on rare occasions if one of the servers which stores a copy of the
message is unavailable when you send the request to delete the message. The copy remains on
the server and might be returned to you during a subsequent receive request. You should
ensure that your application is idempotent, so that receiving a message more than once does
not cause issues.

# Arguments
- `queue_url`: The URL of the Amazon SQS queue from which messages are deleted. Queue URLs
  and names are case-sensitive.
- `receipt_handle`: The receipt handle associated with the message to delete.

"""
function delete_message(
    QueueUrl, ReceiptHandle; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sqs(
        "DeleteMessage",
        Dict{String,Any}("QueueUrl" => QueueUrl, "ReceiptHandle" => ReceiptHandle);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_message(
    QueueUrl,
    ReceiptHandle,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sqs(
        "DeleteMessage",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("QueueUrl" => QueueUrl, "ReceiptHandle" => ReceiptHandle),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_message_batch(entries, queue_url)
    delete_message_batch(entries, queue_url, params::Dict{String,<:Any})

Deletes up to ten messages from the specified queue. This is a batch version of
DeleteMessage. The result of the action on each message is reported individually in the
response.  Because the batch request can result in a combination of successful and
unsuccessful actions, you should check for batch errors even when the call returns an HTTP
status code of 200.

# Arguments
- `entries`: Lists the receipt handles for the messages to be deleted.
- `queue_url`: The URL of the Amazon SQS queue from which messages are deleted. Queue URLs
  and names are case-sensitive.

"""
function delete_message_batch(
    Entries, QueueUrl; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sqs(
        "DeleteMessageBatch",
        Dict{String,Any}("Entries" => Entries, "QueueUrl" => QueueUrl);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_message_batch(
    Entries,
    QueueUrl,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sqs(
        "DeleteMessageBatch",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Entries" => Entries, "QueueUrl" => QueueUrl),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_queue(queue_url)
    delete_queue(queue_url, params::Dict{String,<:Any})

Deletes the queue specified by the QueueUrl, regardless of the queue's contents.  Be
careful with the DeleteQueue action: When you delete a queue, any messages in the queue are
no longer available.   When you delete a queue, the deletion process takes up to 60
seconds. Requests you send involving that queue during the 60 seconds might succeed. For
example, a  SendMessage  request might succeed, but after 60 seconds the queue and the
message you sent no longer exist. When you delete a queue, you must wait at least 60
seconds before creating a queue with the same name.  Cross-account permissions don't apply
to this action. For more information, see Grant cross-account permissions to a role and a
username in the Amazon SQS Developer Guide. The delete operation uses the HTTP GET verb.

# Arguments
- `queue_url`: The URL of the Amazon SQS queue to delete. Queue URLs and names are
  case-sensitive.

"""
function delete_queue(QueueUrl; aws_config::AbstractAWSConfig=current_aws_config())
    return sqs(
        "DeleteQueue",
        Dict{String,Any}("QueueUrl" => QueueUrl);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_queue(
    QueueUrl,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sqs(
        "DeleteQueue",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("QueueUrl" => QueueUrl), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_queue_attributes(queue_url)
    get_queue_attributes(queue_url, params::Dict{String,<:Any})

Gets attributes for the specified queue.  To determine whether a queue is FIFO, you can
check whether QueueName ends with the .fifo suffix.

# Arguments
- `queue_url`: The URL of the Amazon SQS queue whose attribute information is retrieved.
  Queue URLs and names are case-sensitive.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AttributeNames"`: A list of attributes for which to retrieve information. The
  AttributeNames parameter is optional, but if you don't specify values for this parameter,
  the request returns empty results.  In the future, new attributes might be added. If you
  write code that calls this action, we recommend that you structure your code so that it can
  handle new attributes gracefully.  The following attributes are supported:  The
  ApproximateNumberOfMessagesDelayed, ApproximateNumberOfMessagesNotVisible, and
  ApproximateNumberOfMessages metrics may not achieve consistency until at least 1 minute
  after the producers stop sending messages. This period is required for the queue metadata
  to reach eventual consistency.      All – Returns all values.
  ApproximateNumberOfMessages – Returns the approximate number of messages available for
  retrieval from the queue.    ApproximateNumberOfMessagesDelayed – Returns the approximate
  number of messages in the queue that are delayed and not available for reading immediately.
  This can happen when the queue is configured as a delay queue or when a message has been
  sent with a delay parameter.    ApproximateNumberOfMessagesNotVisible – Returns the
  approximate number of messages that are in flight. Messages are considered to be in flight
  if they have been sent to a client but have not yet been deleted or have not yet reached
  the end of their visibility window.     CreatedTimestamp – Returns the time when the
  queue was created in seconds (epoch time).    DelaySeconds – Returns the default delay on
  the queue in seconds.    LastModifiedTimestamp – Returns the time when the queue was last
  changed in seconds (epoch time).    MaximumMessageSize – Returns the limit of how many
  bytes a message can contain before Amazon SQS rejects it.    MessageRetentionPeriod –
  Returns the length of time, in seconds, for which Amazon SQS retains a message. When you
  change a queue's attributes, the change can take up to 60 seconds for most of the
  attributes to propagate throughout the Amazon SQS system. Changes made to the
  MessageRetentionPeriod attribute can take up to 15 minutes and will impact existing
  messages in the queue potentially causing them to be expired and deleted if the
  MessageRetentionPeriod is reduced below the age of existing messages.    Policy – Returns
  the policy of the queue.    QueueArn – Returns the Amazon resource name (ARN) of the
  queue.    ReceiveMessageWaitTimeSeconds – Returns the length of time, in seconds, for
  which the ReceiveMessage action waits for a message to arrive.     VisibilityTimeout –
  Returns the visibility timeout for the queue. For more information about the visibility
  timeout, see Visibility Timeout in the Amazon SQS Developer Guide.    The following
  attributes apply only to dead-letter queues:     RedrivePolicy – The string that includes
  the parameters for the dead-letter queue functionality of the source queue as a JSON
  object. The parameters are as follows:    deadLetterTargetArn – The Amazon Resource Name
  (ARN) of the dead-letter queue to which Amazon SQS moves messages after the value of
  maxReceiveCount is exceeded.    maxReceiveCount – The number of times a message is
  delivered to the source queue before being moved to the dead-letter queue. Default: 10.
  When the ReceiveCount for a message exceeds the maxReceiveCount for a queue, Amazon SQS
  moves the message to the dead-letter-queue.      RedriveAllowPolicy – The string that
  includes the parameters for the permissions for the dead-letter queue redrive permission
  and which source queues can specify dead-letter queues as a JSON object. The parameters are
  as follows:    redrivePermission – The permission type that defines which source queues
  can specify the current queue as the dead-letter queue. Valid values are:    allowAll –
  (Default) Any source queues in this Amazon Web Services account in the same Region can
  specify this queue as the dead-letter queue.    denyAll – No source queues can specify
  this queue as the dead-letter queue.    byQueue – Only queues specified by the
  sourceQueueArns parameter can specify this queue as the dead-letter queue.
  sourceQueueArns – The Amazon Resource Names (ARN)s of the source queues that can specify
  this queue as the dead-letter queue and redrive messages. You can specify this parameter
  only when the redrivePermission parameter is set to byQueue. You can specify up to 10
  source queue ARNs. To allow more than 10 source queues to specify dead-letter queues, set
  the redrivePermission parameter to allowAll.      The dead-letter queue of a FIFO queue
  must also be a FIFO queue. Similarly, the dead-letter queue of a standard queue must also
  be a standard queue.  The following attributes apply only to server-side-encryption:
  KmsMasterKeyId – Returns the ID of an Amazon Web Services managed customer master key
  (CMK) for Amazon SQS or a custom CMK. For more information, see Key Terms.
  KmsDataKeyReusePeriodSeconds – Returns the length of time, in seconds, for which Amazon
  SQS can reuse a data key to encrypt or decrypt messages before calling KMS again. For more
  information, see How Does the Data Key Reuse Period Work?.     SqsManagedSseEnabled –
  Returns information about whether the queue is using SSE-SQS encryption using SQS owned
  encryption keys. Only one server-side encryption option is supported per queue (for
  example, SSE-KMS or SSE-SQS).   The following attributes apply only to FIFO
  (first-in-first-out) queues:    FifoQueue – Returns information about whether the queue
  is FIFO. For more information, see FIFO queue logic in the Amazon SQS Developer Guide.  To
  determine whether a queue is FIFO, you can check whether QueueName ends with the .fifo
  suffix.     ContentBasedDeduplication – Returns whether content-based deduplication is
  enabled for the queue. For more information, see Exactly-once processing in the Amazon SQS
  Developer Guide.    The following attributes apply only to high throughput for FIFO queues:
     DeduplicationScope – Specifies whether message deduplication occurs at the message
  group or queue level. Valid values are messageGroup and queue.    FifoThroughputLimit –
  Specifies whether the FIFO queue throughput quota applies to the entire queue or per
  message group. Valid values are perQueue and perMessageGroupId. The perMessageGroupId value
  is allowed only when the value for DeduplicationScope is messageGroup.   To enable high
  throughput for FIFO queues, do the following:   Set DeduplicationScope to messageGroup.
  Set FifoThroughputLimit to perMessageGroupId.   If you set these attributes to anything
  other than the values shown for enabling high throughput, normal throughput is in effect
  and deduplication occurs as specified. For information on throughput quotas, see Quotas
  related to messages in the Amazon SQS Developer Guide.
"""
function get_queue_attributes(QueueUrl; aws_config::AbstractAWSConfig=current_aws_config())
    return sqs(
        "GetQueueAttributes",
        Dict{String,Any}("QueueUrl" => QueueUrl);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_queue_attributes(
    QueueUrl,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sqs(
        "GetQueueAttributes",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("QueueUrl" => QueueUrl), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_queue_url(queue_name)
    get_queue_url(queue_name, params::Dict{String,<:Any})

Returns the URL of an existing Amazon SQS queue. To access a queue that belongs to another
AWS account, use the QueueOwnerAWSAccountId parameter to specify the account ID of the
queue's owner. The queue's owner must grant you permission to access the queue. For more
information about shared queue access, see  AddPermission  or see Allow Developers to Write
Messages to a Shared Queue in the Amazon SQS Developer Guide.

# Arguments
- `queue_name`: The name of the queue whose URL must be fetched. Maximum 80 characters.
  Valid values: alphanumeric characters, hyphens (-), and underscores (_). Queue URLs and
  names are case-sensitive.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"QueueOwnerAWSAccountId"`: The Amazon Web Services account ID of the account that
  created the queue.
"""
function get_queue_url(QueueName; aws_config::AbstractAWSConfig=current_aws_config())
    return sqs(
        "GetQueueUrl",
        Dict{String,Any}("QueueName" => QueueName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_queue_url(
    QueueName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sqs(
        "GetQueueUrl",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("QueueName" => QueueName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_dead_letter_source_queues(queue_url)
    list_dead_letter_source_queues(queue_url, params::Dict{String,<:Any})

Returns a list of your queues that have the RedrivePolicy queue attribute configured with a
dead-letter queue.  The ListDeadLetterSourceQueues methods supports pagination. Set
parameter MaxResults in the request to specify the maximum number of results to be returned
in the response. If you do not set MaxResults, the response includes a maximum of 1,000
results. If you set MaxResults and there are additional results to display, the response
includes a value for NextToken. Use NextToken as a parameter in your next request to
ListDeadLetterSourceQueues to receive the next page of results.  For more information about
using dead-letter queues, see Using Amazon SQS Dead-Letter Queues in the Amazon SQS
Developer Guide.

# Arguments
- `queue_url`: The URL of a dead-letter queue. Queue URLs and names are case-sensitive.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Maximum number of results to include in the response. Value range is 1 to
  1000. You must set MaxResults to receive a value for NextToken in the response.
- `"NextToken"`: Pagination token to request the next set of results.
"""
function list_dead_letter_source_queues(
    QueueUrl; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sqs(
        "ListDeadLetterSourceQueues",
        Dict{String,Any}("QueueUrl" => QueueUrl);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_dead_letter_source_queues(
    QueueUrl,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sqs(
        "ListDeadLetterSourceQueues",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("QueueUrl" => QueueUrl), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_message_move_tasks(source_arn)
    list_message_move_tasks(source_arn, params::Dict{String,<:Any})

Gets the most recent message movement tasks (up to 10) under a specific source queue.
This action is currently limited to supporting message redrive from dead-letter queues
(DLQs) only. In this context, the source queue is the dead-letter queue (DLQ), while the
destination queue can be the original source queue (from which the messages were driven to
the dead-letter-queue), or a custom destination queue.    Only one active message movement
task is supported per queue at any given time.

# Arguments
- `source_arn`: The ARN of the queue whose message movement tasks are to be listed.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to include in the response. The default is
  1, which provides the most recent message movement task. The upper limit is 10.
"""
function list_message_move_tasks(
    SourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sqs(
        "ListMessageMoveTasks",
        Dict{String,Any}("SourceArn" => SourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_message_move_tasks(
    SourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sqs(
        "ListMessageMoveTasks",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("SourceArn" => SourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_queue_tags(queue_url)
    list_queue_tags(queue_url, params::Dict{String,<:Any})

List all cost allocation tags added to the specified Amazon SQS queue. For an overview, see
Tagging Your Amazon SQS Queues in the Amazon SQS Developer Guide.  Cross-account
permissions don't apply to this action. For more information, see Grant cross-account
permissions to a role and a username in the Amazon SQS Developer Guide.

# Arguments
- `queue_url`: The URL of the queue.

"""
function list_queue_tags(QueueUrl; aws_config::AbstractAWSConfig=current_aws_config())
    return sqs(
        "ListQueueTags",
        Dict{String,Any}("QueueUrl" => QueueUrl);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_queue_tags(
    QueueUrl,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sqs(
        "ListQueueTags",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("QueueUrl" => QueueUrl), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_queues()
    list_queues(params::Dict{String,<:Any})

Returns a list of your queues in the current region. The response includes a maximum of
1,000 results. If you specify a value for the optional QueueNamePrefix parameter, only
queues with a name that begins with the specified value are returned.  The listQueues
methods supports pagination. Set parameter MaxResults in the request to specify the maximum
number of results to be returned in the response. If you do not set MaxResults, the
response includes a maximum of 1,000 results. If you set MaxResults and there are
additional results to display, the response includes a value for NextToken. Use NextToken
as a parameter in your next request to listQueues to receive the next page of results.
Cross-account permissions don't apply to this action. For more information, see Grant
cross-account permissions to a role and a username in the Amazon SQS Developer Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Maximum number of results to include in the response. Value range is 1 to
  1000. You must set MaxResults to receive a value for NextToken in the response.
- `"NextToken"`: Pagination token to request the next set of results.
- `"QueueNamePrefix"`: A string to use for filtering the list results. Only those queues
  whose name begins with the specified string are returned. Queue URLs and names are
  case-sensitive.
"""
function list_queues(; aws_config::AbstractAWSConfig=current_aws_config())
    return sqs("ListQueues"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_queues(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sqs("ListQueues", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end

"""
    purge_queue(queue_url)
    purge_queue(queue_url, params::Dict{String,<:Any})

Deletes available messages in a queue (including in-flight messages) specified by the
QueueURL parameter.  When you use the PurgeQueue action, you can't retrieve any messages
deleted from a queue. The message deletion process takes up to 60 seconds. We recommend
waiting for 60 seconds regardless of your queue's size.   Messages sent to the queue before
you call PurgeQueue might be received but are deleted within the next minute. Messages sent
to the queue after you call PurgeQueue might be deleted while the queue is being purged.

# Arguments
- `queue_url`: The URL of the queue from which the PurgeQueue action deletes messages.
  Queue URLs and names are case-sensitive.

"""
function purge_queue(QueueUrl; aws_config::AbstractAWSConfig=current_aws_config())
    return sqs(
        "PurgeQueue",
        Dict{String,Any}("QueueUrl" => QueueUrl);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function purge_queue(
    QueueUrl,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sqs(
        "PurgeQueue",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("QueueUrl" => QueueUrl), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    receive_message(queue_url)
    receive_message(queue_url, params::Dict{String,<:Any})

Retrieves one or more messages (up to 10), from the specified queue. Using the
WaitTimeSeconds parameter enables long-poll support. For more information, see Amazon SQS
Long Polling in the Amazon SQS Developer Guide.  Short poll is the default behavior where a
weighted random set of machines is sampled on a ReceiveMessage call. Thus, only the
messages on the sampled machines are returned. If the number of messages in the queue is
small (fewer than 1,000), you most likely get fewer messages than you requested per
ReceiveMessage call. If the number of messages in the queue is extremely small, you might
not receive any messages in a particular ReceiveMessage response. If this happens, repeat
the request.  For each message returned, the response includes the following:   The message
body.   An MD5 digest of the message body. For information about MD5, see RFC1321.   The
MessageId you received when you sent the message to the queue.   The receipt handle.   The
message attributes.   An MD5 digest of the message attributes.   The receipt handle is the
identifier you must provide when deleting the message. For more information, see Queue and
Message Identifiers in the Amazon SQS Developer Guide. You can provide the
VisibilityTimeout parameter in your request. The parameter is applied to the messages that
Amazon SQS returns in the response. If you don't include the parameter, the overall
visibility timeout for the queue is used for the returned messages. For more information,
see Visibility Timeout in the Amazon SQS Developer Guide. A message that isn't deleted or a
message whose visibility isn't extended before the visibility timeout expires counts as a
failed receive. Depending on the configuration of the queue, the message might be sent to
the dead-letter queue.  In the future, new attributes might be added. If you write code
that calls this action, we recommend that you structure your code so that it can handle new
attributes gracefully.

# Arguments
- `queue_url`: The URL of the Amazon SQS queue from which messages are received. Queue URLs
  and names are case-sensitive.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AttributeNames"`:   This parameter has been deprecated but will be supported for
  backward compatibility. To provide attribute names, you are encouraged to use
  MessageSystemAttributeNames.   A list of attributes that need to be returned along with
  each message. These attributes include:    All – Returns all values.
  ApproximateFirstReceiveTimestamp – Returns the time the message was first received from
  the queue (epoch time in milliseconds).    ApproximateReceiveCount – Returns the number
  of times a message has been received across all queues but not deleted.    AWSTraceHeader
  – Returns the X-Ray trace header string.     SenderId    For a user, returns the user ID,
  for example ABCDEFGHI1JKLMNOPQ23R.   For an IAM role, returns the IAM role ID, for example
  ABCDE1F2GH3I4JK5LMNOP:i-a123b456.      SentTimestamp – Returns the time the message was
  sent to the queue (epoch time in milliseconds).    SqsManagedSseEnabled – Enables
  server-side queue encryption using SQS owned encryption keys. Only one server-side
  encryption option is supported per queue (for example, SSE-KMS or SSE-SQS).
  MessageDeduplicationId – Returns the value provided by the producer that calls the
  SendMessage  action.    MessageGroupId – Returns the value provided by the producer that
  calls the  SendMessage  action. Messages with the same MessageGroupId are returned in
  sequence.    SequenceNumber – Returns the value provided by Amazon SQS.
- `"MaxNumberOfMessages"`: The maximum number of messages to return. Amazon SQS never
  returns more messages than this value (however, fewer messages might be returned). Valid
  values: 1 to 10. Default: 1.
- `"MessageAttributeNames"`: The name of the message attribute, where N is the index.   The
  name can contain alphanumeric characters and the underscore (_), hyphen (-), and period
  (.).   The name is case-sensitive and must be unique among all attribute names for the
  message.   The name must not start with AWS-reserved prefixes such as AWS. or Amazon. (or
  any casing variants).   The name must not start or end with a period (.), and it should not
  have periods in succession (..).   The name can be up to 256 characters long.   When using
  ReceiveMessage, you can send a list of attribute names to receive, or you can return all of
  the attributes by specifying All or .* in your request. You can also use all message
  attributes starting with a prefix, for example bar.*.
- `"MessageSystemAttributeNames"`: A list of attributes that need to be returned along with
  each message. These attributes include:    All – Returns all values.
  ApproximateFirstReceiveTimestamp – Returns the time the message was first received from
  the queue (epoch time in milliseconds).    ApproximateReceiveCount – Returns the number
  of times a message has been received across all queues but not deleted.    AWSTraceHeader
  – Returns the X-Ray trace header string.     SenderId    For a user, returns the user ID,
  for example ABCDEFGHI1JKLMNOPQ23R.   For an IAM role, returns the IAM role ID, for example
  ABCDE1F2GH3I4JK5LMNOP:i-a123b456.      SentTimestamp – Returns the time the message was
  sent to the queue (epoch time in milliseconds).    SqsManagedSseEnabled – Enables
  server-side queue encryption using SQS owned encryption keys. Only one server-side
  encryption option is supported per queue (for example, SSE-KMS or SSE-SQS).
  MessageDeduplicationId – Returns the value provided by the producer that calls the
  SendMessage  action.    MessageGroupId – Returns the value provided by the producer that
  calls the  SendMessage  action. Messages with the same MessageGroupId are returned in
  sequence.    SequenceNumber – Returns the value provided by Amazon SQS.
- `"ReceiveRequestAttemptId"`: This parameter applies only to FIFO (first-in-first-out)
  queues. The token used for deduplication of ReceiveMessage calls. If a networking issue
  occurs after a ReceiveMessage action, and instead of a response you receive a generic
  error, it is possible to retry the same action with an identical ReceiveRequestAttemptId to
  retrieve the same set of messages, even if their visibility timeout has not yet expired.
  You can use ReceiveRequestAttemptId only for 5 minutes after a ReceiveMessage action.
  When you set FifoQueue, a caller of the ReceiveMessage action can provide a
  ReceiveRequestAttemptId explicitly.   It is possible to retry the ReceiveMessage action
  with the same ReceiveRequestAttemptId if none of the messages have been modified (deleted
  or had their visibility changes).   During a visibility timeout, subsequent calls with the
  same ReceiveRequestAttemptId return the same messages and receipt handles. If a retry
  occurs within the deduplication interval, it resets the visibility timeout. For more
  information, see Visibility Timeout in the Amazon SQS Developer Guide.  If a caller of the
  ReceiveMessage action still processes messages when the visibility timeout expires and
  messages become visible, another worker consuming from the same queue can receive the same
  messages and therefore process duplicates. Also, if a consumer whose message processing
  time is longer than the visibility timeout tries to delete the processed messages, the
  action fails with an error. To mitigate this effect, ensure that your application observes
  a safe threshold before the visibility timeout expires and extend the visibility timeout as
  necessary.    While messages with a particular MessageGroupId are invisible, no more
  messages belonging to the same MessageGroupId are returned until the visibility timeout
  expires. You can still receive messages with another MessageGroupId as long as it is also
  visible.   If a caller of ReceiveMessage can't track the ReceiveRequestAttemptId, no
  retries work until the original visibility timeout expires. As a result, delays might occur
  but the messages in the queue remain in a strict order.   The maximum length of
  ReceiveRequestAttemptId is 128 characters. ReceiveRequestAttemptId can contain alphanumeric
  characters (a-z, A-Z, 0-9) and punctuation (!\"#%&amp;'()*+,-./:;&lt;=&gt;?@[]^_`{|}~). For
  best practices of using ReceiveRequestAttemptId, see Using the ReceiveRequestAttemptId
  Request Parameter in the Amazon SQS Developer Guide.
- `"VisibilityTimeout"`: The duration (in seconds) that the received messages are hidden
  from subsequent retrieve requests after being retrieved by a ReceiveMessage request.
- `"WaitTimeSeconds"`: The duration (in seconds) for which the call waits for a message to
  arrive in the queue before returning. If a message is available, the call returns sooner
  than WaitTimeSeconds. If no messages are available and the wait time expires, the call does
  not return a message list.  To avoid HTTP errors, ensure that the HTTP response timeout for
  ReceiveMessage requests is longer than the WaitTimeSeconds parameter. For example, with the
  Java SDK, you can set HTTP transport settings using the  NettyNioAsyncHttpClient for
  asynchronous clients, or the  ApacheHttpClient for synchronous clients.
"""
function receive_message(QueueUrl; aws_config::AbstractAWSConfig=current_aws_config())
    return sqs(
        "ReceiveMessage",
        Dict{String,Any}("QueueUrl" => QueueUrl);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function receive_message(
    QueueUrl,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sqs(
        "ReceiveMessage",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("QueueUrl" => QueueUrl), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_permission(label, queue_url)
    remove_permission(label, queue_url, params::Dict{String,<:Any})

Revokes any permissions in the queue policy that matches the specified Label parameter.
Only the owner of a queue can remove permissions from it.   Cross-account permissions don't
apply to this action. For more information, see Grant cross-account permissions to a role
and a username in the Amazon SQS Developer Guide.   To remove the ability to change queue
permissions, you must deny permission to the AddPermission, RemovePermission, and
SetQueueAttributes actions in your IAM policy.

# Arguments
- `label`: The identification of the permission to remove. This is the label added using
  the  AddPermission  action.
- `queue_url`: The URL of the Amazon SQS queue from which permissions are removed. Queue
  URLs and names are case-sensitive.

"""
function remove_permission(
    Label, QueueUrl; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sqs(
        "RemovePermission",
        Dict{String,Any}("Label" => Label, "QueueUrl" => QueueUrl);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_permission(
    Label,
    QueueUrl,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sqs(
        "RemovePermission",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("Label" => Label, "QueueUrl" => QueueUrl), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    send_message(message_body, queue_url)
    send_message(message_body, queue_url, params::Dict{String,<:Any})

Delivers a message to the specified queue.  A message can include only XML, JSON, and
unformatted text. The following Unicode characters are allowed. For more information, see
the W3C specification for characters.  #x9 | #xA | #xD | #x20 to #xD7FF | #xE000 to #xFFFD
| #x10000 to #x10FFFF  Amazon SQS does not throw an exception or completely reject the
message if it contains invalid characters. Instead, it replaces those invalid characters
with U+FFFD before storing the message in the queue, as long as the message body contains
at least one valid character.

# Arguments
- `message_body`: The message to send. The minimum size is one character. The maximum size
  is 256 KiB.  A message can include only XML, JSON, and unformatted text. The following
  Unicode characters are allowed. For more information, see the W3C specification for
  characters.  #x9 | #xA | #xD | #x20 to #xD7FF | #xE000 to #xFFFD | #x10000 to #x10FFFF
  Amazon SQS does not throw an exception or completely reject the message if it contains
  invalid characters. Instead, it replaces those invalid characters with U+FFFD before
  storing the message in the queue, as long as the message body contains at least one valid
  character.
- `queue_url`: The URL of the Amazon SQS queue to which a message is sent. Queue URLs and
  names are case-sensitive.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DelaySeconds"`:  The length of time, in seconds, for which to delay a specific message.
  Valid values: 0 to 900. Maximum: 15 minutes. Messages with a positive DelaySeconds value
  become available for processing after the delay period is finished. If you don't specify a
  value, the default value for the queue applies.   When you set FifoQueue, you can't set
  DelaySeconds per message. You can set this parameter only on a queue level.
- `"MessageAttributes"`: Each message attribute consists of a Name, Type, and Value. For
  more information, see Amazon SQS message attributes in the Amazon SQS Developer Guide.
- `"MessageDeduplicationId"`: This parameter applies only to FIFO (first-in-first-out)
  queues. The token used for deduplication of sent messages. If a message with a particular
  MessageDeduplicationId is sent successfully, any messages sent with the same
  MessageDeduplicationId are accepted successfully but aren't delivered during the 5-minute
  deduplication interval. For more information, see  Exactly-once processing in the Amazon
  SQS Developer Guide.   Every message must have a unique MessageDeduplicationId,   You may
  provide a MessageDeduplicationId explicitly.   If you aren't able to provide a
  MessageDeduplicationId and you enable ContentBasedDeduplication for your queue, Amazon SQS
  uses a SHA-256 hash to generate the MessageDeduplicationId using the body of the message
  (but not the attributes of the message).    If you don't provide a MessageDeduplicationId
  and the queue doesn't have ContentBasedDeduplication set, the action fails with an error.
  If the queue has ContentBasedDeduplication set, your MessageDeduplicationId overrides the
  generated one.     When ContentBasedDeduplication is in effect, messages with identical
  content sent within the deduplication interval are treated as duplicates and only one copy
  of the message is delivered.   If you send one message with ContentBasedDeduplication
  enabled and then another message with a MessageDeduplicationId that is the same as the one
  generated for the first MessageDeduplicationId, the two messages are treated as duplicates
  and only one copy of the message is delivered.     The MessageDeduplicationId is available
  to the consumer of the message (this can be useful for troubleshooting delivery issues). If
  a message is sent successfully but the acknowledgement is lost and the message is resent
  with the same MessageDeduplicationId after the deduplication interval, Amazon SQS can't
  detect duplicate messages. Amazon SQS continues to keep track of the message deduplication
  ID even after the message is received and deleted.  The maximum length of
  MessageDeduplicationId is 128 characters. MessageDeduplicationId can contain alphanumeric
  characters (a-z, A-Z, 0-9) and punctuation (!\"#%&amp;'()*+,-./:;&lt;=&gt;?@[]^_`{|}~). For
  best practices of using MessageDeduplicationId, see Using the MessageDeduplicationId
  Property in the Amazon SQS Developer Guide.
- `"MessageGroupId"`: This parameter applies only to FIFO (first-in-first-out) queues. The
  tag that specifies that a message belongs to a specific message group. Messages that belong
  to the same message group are processed in a FIFO manner (however, messages in different
  message groups might be processed out of order). To interleave multiple ordered streams
  within a single queue, use MessageGroupId values (for example, session data for multiple
  users). In this scenario, multiple consumers can process the queue, but the session data of
  each user is processed in a FIFO fashion.   You must associate a non-empty MessageGroupId
  with a message. If you don't provide a MessageGroupId, the action fails.    ReceiveMessage
  might return messages with multiple MessageGroupId values. For each MessageGroupId, the
  messages are sorted by time sent. The caller can't specify a MessageGroupId.   The maximum
  length of MessageGroupId is 128 characters. Valid values: alphanumeric characters and
  punctuation (!\"#%&amp;'()*+,-./:;&lt;=&gt;?@[]^_`{|}~). For best practices of using
  MessageGroupId, see Using the MessageGroupId Property in the Amazon SQS Developer Guide.
  MessageGroupId is required for FIFO queues. You can't use it for Standard queues.
- `"MessageSystemAttributes"`: The message system attribute to send. Each message system
  attribute consists of a Name, Type, and Value.    Currently, the only supported message
  system attribute is AWSTraceHeader. Its type must be String and its value must be a
  correctly formatted X-Ray trace header string.   The size of a message system attribute
  doesn't count towards the total size of a message.
"""
function send_message(
    MessageBody, QueueUrl; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sqs(
        "SendMessage",
        Dict{String,Any}("MessageBody" => MessageBody, "QueueUrl" => QueueUrl);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function send_message(
    MessageBody,
    QueueUrl,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sqs(
        "SendMessage",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("MessageBody" => MessageBody, "QueueUrl" => QueueUrl),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    send_message_batch(entries, queue_url)
    send_message_batch(entries, queue_url, params::Dict{String,<:Any})

You can use SendMessageBatch to send up to 10 messages to the specified queue by assigning
either identical or different values to each message (or by not assigning values at all).
This is a batch version of  SendMessage. For a FIFO queue, multiple messages within a
single batch are enqueued in the order they are sent. The result of sending each message is
reported individually in the response. Because the batch request can result in a
combination of successful and unsuccessful actions, you should check for batch errors even
when the call returns an HTTP status code of 200. The maximum allowed individual message
size and the maximum total payload size (the sum of the individual lengths of all of the
batched messages) are both 256 KiB (262,144 bytes).  A message can include only XML, JSON,
and unformatted text. The following Unicode characters are allowed. For more information,
see the W3C specification for characters.  #x9 | #xA | #xD | #x20 to #xD7FF | #xE000 to
#xFFFD | #x10000 to #x10FFFF  Amazon SQS does not throw an exception or completely reject
the message if it contains invalid characters. Instead, it replaces those invalid
characters with U+FFFD before storing the message in the queue, as long as the message body
contains at least one valid character.  If you don't specify the DelaySeconds parameter for
an entry, Amazon SQS uses the default value for the queue.

# Arguments
- `entries`: A list of  SendMessageBatchRequestEntry  items.
- `queue_url`: The URL of the Amazon SQS queue to which batched messages are sent. Queue
  URLs and names are case-sensitive.

"""
function send_message_batch(
    Entries, QueueUrl; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sqs(
        "SendMessageBatch",
        Dict{String,Any}("Entries" => Entries, "QueueUrl" => QueueUrl);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function send_message_batch(
    Entries,
    QueueUrl,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sqs(
        "SendMessageBatch",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Entries" => Entries, "QueueUrl" => QueueUrl),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    set_queue_attributes(attributes, queue_url)
    set_queue_attributes(attributes, queue_url, params::Dict{String,<:Any})

Sets the value of one or more queue attributes, like a policy. When you change a queue's
attributes, the change can take up to 60 seconds for most of the attributes to propagate
throughout the Amazon SQS system. Changes made to the MessageRetentionPeriod attribute can
take up to 15 minutes and will impact existing messages in the queue potentially causing
them to be expired and deleted if the MessageRetentionPeriod is reduced below the age of
existing messages.    In the future, new attributes might be added. If you write code that
calls this action, we recommend that you structure your code so that it can handle new
attributes gracefully.   Cross-account permissions don't apply to this action. For more
information, see Grant cross-account permissions to a role and a username in the Amazon SQS
Developer Guide.   To remove the ability to change queue permissions, you must deny
permission to the AddPermission, RemovePermission, and SetQueueAttributes actions in your
IAM policy.

# Arguments
- `attributes`: A map of attributes to set. The following lists the names, descriptions,
  and values of the special request parameters that the SetQueueAttributes action uses:
  DelaySeconds – The length of time, in seconds, for which the delivery of all messages in
  the queue is delayed. Valid values: An integer from 0 to 900 (15 minutes). Default: 0.
  MaximumMessageSize – The limit of how many bytes a message can contain before Amazon SQS
  rejects it. Valid values: An integer from 1,024 bytes (1 KiB) up to 262,144 bytes (256
  KiB). Default: 262,144 (256 KiB).     MessageRetentionPeriod – The length of time, in
  seconds, for which Amazon SQS retains a message. Valid values: An integer representing
  seconds, from 60 (1 minute) to 1,209,600 (14 days). Default: 345,600 (4 days). When you
  change a queue's attributes, the change can take up to 60 seconds for most of the
  attributes to propagate throughout the Amazon SQS system. Changes made to the
  MessageRetentionPeriod attribute can take up to 15 minutes and will impact existing
  messages in the queue potentially causing them to be expired and deleted if the
  MessageRetentionPeriod is reduced below the age of existing messages.    Policy – The
  queue's policy. A valid Amazon Web Services policy. For more information about policy
  structure, see Overview of Amazon Web Services IAM Policies in the Identity and Access
  Management User Guide.     ReceiveMessageWaitTimeSeconds – The length of time, in
  seconds, for which a  ReceiveMessage  action waits for a message to arrive. Valid values:
  An integer from 0 to 20 (seconds). Default: 0.     VisibilityTimeout – The visibility
  timeout for the queue, in seconds. Valid values: An integer from 0 to 43,200 (12 hours).
  Default: 30. For more information about the visibility timeout, see Visibility Timeout in
  the Amazon SQS Developer Guide.   The following attributes apply only to dead-letter
  queues:     RedrivePolicy – The string that includes the parameters for the dead-letter
  queue functionality of the source queue as a JSON object. The parameters are as follows:
  deadLetterTargetArn – The Amazon Resource Name (ARN) of the dead-letter queue to which
  Amazon SQS moves messages after the value of maxReceiveCount is exceeded.
  maxReceiveCount – The number of times a message is delivered to the source queue before
  being moved to the dead-letter queue. Default: 10. When the ReceiveCount for a message
  exceeds the maxReceiveCount for a queue, Amazon SQS moves the message to the
  dead-letter-queue.      RedriveAllowPolicy – The string that includes the parameters for
  the permissions for the dead-letter queue redrive permission and which source queues can
  specify dead-letter queues as a JSON object. The parameters are as follows:
  redrivePermission – The permission type that defines which source queues can specify the
  current queue as the dead-letter queue. Valid values are:    allowAll – (Default) Any
  source queues in this Amazon Web Services account in the same Region can specify this queue
  as the dead-letter queue.    denyAll – No source queues can specify this queue as the
  dead-letter queue.    byQueue – Only queues specified by the sourceQueueArns parameter
  can specify this queue as the dead-letter queue.      sourceQueueArns – The Amazon
  Resource Names (ARN)s of the source queues that can specify this queue as the dead-letter
  queue and redrive messages. You can specify this parameter only when the redrivePermission
  parameter is set to byQueue. You can specify up to 10 source queue ARNs. To allow more than
  10 source queues to specify dead-letter queues, set the redrivePermission parameter to
  allowAll.      The dead-letter queue of a FIFO queue must also be a FIFO queue. Similarly,
  the dead-letter queue of a standard queue must also be a standard queue.  The following
  attributes apply only to server-side-encryption:    KmsMasterKeyId – The ID of an Amazon
  Web Services managed customer master key (CMK) for Amazon SQS or a custom CMK. For more
  information, see Key Terms. While the alias of the AWS-managed CMK for Amazon SQS is always
  alias/aws/sqs, the alias of a custom CMK can, for example, be alias/MyAlias . For more
  examples, see KeyId in the Key Management Service API Reference.
  KmsDataKeyReusePeriodSeconds – The length of time, in seconds, for which Amazon SQS can
  reuse a data key to encrypt or decrypt messages before calling KMS again. An integer
  representing seconds, between 60 seconds (1 minute) and 86,400 seconds (24 hours). Default:
  300 (5 minutes). A shorter time period provides better security but results in more calls
  to KMS which might incur charges after Free Tier. For more information, see How Does the
  Data Key Reuse Period Work?.     SqsManagedSseEnabled – Enables server-side queue
  encryption using SQS owned encryption keys. Only one server-side encryption option is
  supported per queue (for example, SSE-KMS or SSE-SQS).   The following attribute applies
  only to FIFO (first-in-first-out) queues:    ContentBasedDeduplication – Enables
  content-based deduplication. For more information, see Exactly-once processing in the
  Amazon SQS Developer Guide. Note the following:    Every message must have a unique
  MessageDeduplicationId.   You may provide a MessageDeduplicationId explicitly.   If you
  aren't able to provide a MessageDeduplicationId and you enable ContentBasedDeduplication
  for your queue, Amazon SQS uses a SHA-256 hash to generate the MessageDeduplicationId using
  the body of the message (but not the attributes of the message).    If you don't provide a
  MessageDeduplicationId and the queue doesn't have ContentBasedDeduplication set, the action
  fails with an error.   If the queue has ContentBasedDeduplication set, your
  MessageDeduplicationId overrides the generated one.     When ContentBasedDeduplication is
  in effect, messages with identical content sent within the deduplication interval are
  treated as duplicates and only one copy of the message is delivered.   If you send one
  message with ContentBasedDeduplication enabled and then another message with a
  MessageDeduplicationId that is the same as the one generated for the first
  MessageDeduplicationId, the two messages are treated as duplicates and only one copy of the
  message is delivered.      The following attributes apply only to high throughput for FIFO
  queues:    DeduplicationScope – Specifies whether message deduplication occurs at the
  message group or queue level. Valid values are messageGroup and queue.
  FifoThroughputLimit – Specifies whether the FIFO queue throughput quota applies to the
  entire queue or per message group. Valid values are perQueue and perMessageGroupId. The
  perMessageGroupId value is allowed only when the value for DeduplicationScope is
  messageGroup.   To enable high throughput for FIFO queues, do the following:   Set
  DeduplicationScope to messageGroup.   Set FifoThroughputLimit to perMessageGroupId.   If
  you set these attributes to anything other than the values shown for enabling high
  throughput, normal throughput is in effect and deduplication occurs as specified. For
  information on throughput quotas, see Quotas related to messages in the Amazon SQS
  Developer Guide.
- `queue_url`: The URL of the Amazon SQS queue whose attributes are set. Queue URLs and
  names are case-sensitive.

"""
function set_queue_attributes(
    Attributes, QueueUrl; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sqs(
        "SetQueueAttributes",
        Dict{String,Any}("Attributes" => Attributes, "QueueUrl" => QueueUrl);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function set_queue_attributes(
    Attributes,
    QueueUrl,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sqs(
        "SetQueueAttributes",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Attributes" => Attributes, "QueueUrl" => QueueUrl),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_message_move_task(source_arn)
    start_message_move_task(source_arn, params::Dict{String,<:Any})

Starts an asynchronous task to move messages from a specified source queue to a specified
destination queue.    This action is currently limited to supporting message redrive from
queues that are configured as dead-letter queues (DLQs) of other Amazon SQS queues only.
Non-SQS queue sources of dead-letter queues, such as Lambda or Amazon SNS topics, are
currently not supported.   In dead-letter queues redrive context, the StartMessageMoveTask
the source queue is the DLQ, while the destination queue can be the original source queue
(from which the messages were driven to the dead-letter-queue), or a custom destination
queue.   Only one active message movement task is supported per queue at any given time.

# Arguments
- `source_arn`: The ARN of the queue that contains the messages to be moved to another
  queue. Currently, only ARNs of dead-letter queues (DLQs) whose sources are other Amazon SQS
  queues are accepted. DLQs whose sources are non-SQS queues, such as Lambda or Amazon SNS
  topics, are not currently supported.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DestinationArn"`: The ARN of the queue that receives the moved messages. You can use
  this field to specify the destination queue where you would like to redrive messages. If
  this field is left blank, the messages will be redriven back to their respective original
  source queues.
- `"MaxNumberOfMessagesPerSecond"`: The number of messages to be moved per second (the
  message movement rate). You can use this field to define a fixed message movement rate. The
  maximum value for messages per second is 500. If this field is left blank, the system will
  optimize the rate based on the queue message backlog size, which may vary throughout the
  duration of the message movement task.
"""
function start_message_move_task(
    SourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sqs(
        "StartMessageMoveTask",
        Dict{String,Any}("SourceArn" => SourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_message_move_task(
    SourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sqs(
        "StartMessageMoveTask",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("SourceArn" => SourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_queue(queue_url, tags)
    tag_queue(queue_url, tags, params::Dict{String,<:Any})

Add cost allocation tags to the specified Amazon SQS queue. For an overview, see Tagging
Your Amazon SQS Queues in the Amazon SQS Developer Guide. When you use queue tags, keep the
following guidelines in mind:   Adding more than 50 tags to a queue isn't recommended.
Tags don't have any semantic meaning. Amazon SQS interprets tags as character strings.
Tags are case-sensitive.   A new tag with a key identical to that of an existing tag
overwrites the existing tag.   For a full list of tag restrictions, see Quotas related to
queues in the Amazon SQS Developer Guide.  Cross-account permissions don't apply to this
action. For more information, see Grant cross-account permissions to a role and a username
in the Amazon SQS Developer Guide.

# Arguments
- `queue_url`: The URL of the queue.
- `tags`: The list of tags to be added to the specified queue.

"""
function tag_queue(QueueUrl, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return sqs(
        "TagQueue",
        Dict{String,Any}("QueueUrl" => QueueUrl, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_queue(
    QueueUrl,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sqs(
        "TagQueue",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("QueueUrl" => QueueUrl, "Tags" => Tags), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_queue(queue_url, tag_keys)
    untag_queue(queue_url, tag_keys, params::Dict{String,<:Any})

Remove cost allocation tags from the specified Amazon SQS queue. For an overview, see
Tagging Your Amazon SQS Queues in the Amazon SQS Developer Guide.  Cross-account
permissions don't apply to this action. For more information, see Grant cross-account
permissions to a role and a username in the Amazon SQS Developer Guide.

# Arguments
- `queue_url`: The URL of the queue.
- `tag_keys`: The list of tags to be removed from the specified queue.

"""
function untag_queue(QueueUrl, TagKeys; aws_config::AbstractAWSConfig=current_aws_config())
    return sqs(
        "UntagQueue",
        Dict{String,Any}("QueueUrl" => QueueUrl, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_queue(
    QueueUrl,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sqs(
        "UntagQueue",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("QueueUrl" => QueueUrl, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: voice_id
using AWS.Compat
using AWS.UUIDs

"""
    associate_fraudster(domain_id, fraudster_id, watchlist_id)
    associate_fraudster(domain_id, fraudster_id, watchlist_id, params::Dict{String,<:Any})

Associates the fraudsters with the watchlist specified in the same domain.

# Arguments
- `domain_id`: The identifier of the domain that contains the fraudster.
- `fraudster_id`: The identifier of the fraudster to be associated with the watchlist.
- `watchlist_id`: The identifier of the watchlist you want to associate with the fraudster.

"""
function associate_fraudster(
    DomainId, FraudsterId, WatchlistId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return voice_id(
        "AssociateFraudster",
        Dict{String,Any}(
            "DomainId" => DomainId,
            "FraudsterId" => FraudsterId,
            "WatchlistId" => WatchlistId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_fraudster(
    DomainId,
    FraudsterId,
    WatchlistId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return voice_id(
        "AssociateFraudster",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DomainId" => DomainId,
                    "FraudsterId" => FraudsterId,
                    "WatchlistId" => WatchlistId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_domain(name, server_side_encryption_configuration)
    create_domain(name, server_side_encryption_configuration, params::Dict{String,<:Any})

Creates a domain that contains all Amazon Connect Voice ID data, such as speakers,
fraudsters, customer audio, and voiceprints. Every domain is created with a default
watchlist that fraudsters can be a part of.

# Arguments
- `name`: The name of the domain.
- `server_side_encryption_configuration`: The configuration, containing the KMS key
  identifier, to be used by Voice ID for the server-side encryption of your data. Refer to
  Amazon Connect Voice ID encryption at rest for more details on how the KMS key is used.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If not provided, the Amazon Web Services SDK populates this
  field. For more information about idempotency, see Making retries safe with idempotent APIs.
- `"Description"`: A brief description of this domain.
- `"Tags"`: A list of tags you want added to the domain.
"""
function create_domain(
    Name,
    ServerSideEncryptionConfiguration;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return voice_id(
        "CreateDomain",
        Dict{String,Any}(
            "Name" => Name,
            "ServerSideEncryptionConfiguration" => ServerSideEncryptionConfiguration,
            "ClientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_domain(
    Name,
    ServerSideEncryptionConfiguration,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return voice_id(
        "CreateDomain",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Name" => Name,
                    "ServerSideEncryptionConfiguration" =>
                        ServerSideEncryptionConfiguration,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_watchlist(domain_id, name)
    create_watchlist(domain_id, name, params::Dict{String,<:Any})

Creates a watchlist that fraudsters can be a part of.

# Arguments
- `domain_id`: The identifier of the domain that contains the watchlist.
- `name`: The name of the watchlist.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If not provided, the Amazon Web Services SDK populates this
  field. For more information about idempotency, see Making retries safe with idempotent APIs.
- `"Description"`: A brief description of this watchlist.
"""
function create_watchlist(
    DomainId, Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return voice_id(
        "CreateWatchlist",
        Dict{String,Any}(
            "DomainId" => DomainId, "Name" => Name, "ClientToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_watchlist(
    DomainId,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return voice_id(
        "CreateWatchlist",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DomainId" => DomainId, "Name" => Name, "ClientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_domain(domain_id)
    delete_domain(domain_id, params::Dict{String,<:Any})

Deletes the specified domain from Voice ID.

# Arguments
- `domain_id`: The identifier of the domain you want to delete.

"""
function delete_domain(DomainId; aws_config::AbstractAWSConfig=current_aws_config())
    return voice_id(
        "DeleteDomain",
        Dict{String,Any}("DomainId" => DomainId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_domain(
    DomainId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return voice_id(
        "DeleteDomain",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DomainId" => DomainId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_fraudster(domain_id, fraudster_id)
    delete_fraudster(domain_id, fraudster_id, params::Dict{String,<:Any})

Deletes the specified fraudster from Voice ID. This action disassociates the fraudster from
any watchlists it is a part of.

# Arguments
- `domain_id`: The identifier of the domain that contains the fraudster.
- `fraudster_id`: The identifier of the fraudster you want to delete.

"""
function delete_fraudster(
    DomainId, FraudsterId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return voice_id(
        "DeleteFraudster",
        Dict{String,Any}("DomainId" => DomainId, "FraudsterId" => FraudsterId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_fraudster(
    DomainId,
    FraudsterId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return voice_id(
        "DeleteFraudster",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DomainId" => DomainId, "FraudsterId" => FraudsterId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_speaker(domain_id, speaker_id)
    delete_speaker(domain_id, speaker_id, params::Dict{String,<:Any})

Deletes the specified speaker from Voice ID.

# Arguments
- `domain_id`: The identifier of the domain that contains the speaker.
- `speaker_id`: The identifier of the speaker you want to delete.

"""
function delete_speaker(
    DomainId, SpeakerId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return voice_id(
        "DeleteSpeaker",
        Dict{String,Any}("DomainId" => DomainId, "SpeakerId" => SpeakerId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_speaker(
    DomainId,
    SpeakerId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return voice_id(
        "DeleteSpeaker",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DomainId" => DomainId, "SpeakerId" => SpeakerId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_watchlist(domain_id, watchlist_id)
    delete_watchlist(domain_id, watchlist_id, params::Dict{String,<:Any})

Deletes the specified watchlist from Voice ID. This API throws an exception when there are
fraudsters in the watchlist that you are trying to delete. You must delete the fraudsters,
and then delete the watchlist. Every domain has a default watchlist which cannot be
deleted.

# Arguments
- `domain_id`: The identifier of the domain that contains the watchlist.
- `watchlist_id`: The identifier of the watchlist to be deleted.

"""
function delete_watchlist(
    DomainId, WatchlistId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return voice_id(
        "DeleteWatchlist",
        Dict{String,Any}("DomainId" => DomainId, "WatchlistId" => WatchlistId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_watchlist(
    DomainId,
    WatchlistId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return voice_id(
        "DeleteWatchlist",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DomainId" => DomainId, "WatchlistId" => WatchlistId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_domain(domain_id)
    describe_domain(domain_id, params::Dict{String,<:Any})

Describes the specified domain.

# Arguments
- `domain_id`: The identifier of the domain that you are describing.

"""
function describe_domain(DomainId; aws_config::AbstractAWSConfig=current_aws_config())
    return voice_id(
        "DescribeDomain",
        Dict{String,Any}("DomainId" => DomainId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_domain(
    DomainId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return voice_id(
        "DescribeDomain",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DomainId" => DomainId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_fraudster(domain_id, fraudster_id)
    describe_fraudster(domain_id, fraudster_id, params::Dict{String,<:Any})

Describes the specified fraudster.

# Arguments
- `domain_id`: The identifier of the domain that contains the fraudster.
- `fraudster_id`: The identifier of the fraudster you are describing.

"""
function describe_fraudster(
    DomainId, FraudsterId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return voice_id(
        "DescribeFraudster",
        Dict{String,Any}("DomainId" => DomainId, "FraudsterId" => FraudsterId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_fraudster(
    DomainId,
    FraudsterId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return voice_id(
        "DescribeFraudster",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DomainId" => DomainId, "FraudsterId" => FraudsterId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_fraudster_registration_job(domain_id, job_id)
    describe_fraudster_registration_job(domain_id, job_id, params::Dict{String,<:Any})

Describes the specified fraudster registration job.

# Arguments
- `domain_id`: The identifier of the domain that contains the fraudster registration job.
- `job_id`: The identifier of the fraudster registration job you are describing.

"""
function describe_fraudster_registration_job(
    DomainId, JobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return voice_id(
        "DescribeFraudsterRegistrationJob",
        Dict{String,Any}("DomainId" => DomainId, "JobId" => JobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_fraudster_registration_job(
    DomainId,
    JobId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return voice_id(
        "DescribeFraudsterRegistrationJob",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("DomainId" => DomainId, "JobId" => JobId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_speaker(domain_id, speaker_id)
    describe_speaker(domain_id, speaker_id, params::Dict{String,<:Any})

Describes the specified speaker.

# Arguments
- `domain_id`: The identifier of the domain that contains the speaker.
- `speaker_id`: The identifier of the speaker you are describing.

"""
function describe_speaker(
    DomainId, SpeakerId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return voice_id(
        "DescribeSpeaker",
        Dict{String,Any}("DomainId" => DomainId, "SpeakerId" => SpeakerId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_speaker(
    DomainId,
    SpeakerId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return voice_id(
        "DescribeSpeaker",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DomainId" => DomainId, "SpeakerId" => SpeakerId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_speaker_enrollment_job(domain_id, job_id)
    describe_speaker_enrollment_job(domain_id, job_id, params::Dict{String,<:Any})

Describes the specified speaker enrollment job.

# Arguments
- `domain_id`: The identifier of the domain that contains the speaker enrollment job.
- `job_id`: The identifier of the speaker enrollment job you are describing.

"""
function describe_speaker_enrollment_job(
    DomainId, JobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return voice_id(
        "DescribeSpeakerEnrollmentJob",
        Dict{String,Any}("DomainId" => DomainId, "JobId" => JobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_speaker_enrollment_job(
    DomainId,
    JobId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return voice_id(
        "DescribeSpeakerEnrollmentJob",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("DomainId" => DomainId, "JobId" => JobId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_watchlist(domain_id, watchlist_id)
    describe_watchlist(domain_id, watchlist_id, params::Dict{String,<:Any})

Describes the specified watchlist.

# Arguments
- `domain_id`: The identifier of the domain that contains the watchlist.
- `watchlist_id`: The identifier of the watchlist that you are describing.

"""
function describe_watchlist(
    DomainId, WatchlistId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return voice_id(
        "DescribeWatchlist",
        Dict{String,Any}("DomainId" => DomainId, "WatchlistId" => WatchlistId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_watchlist(
    DomainId,
    WatchlistId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return voice_id(
        "DescribeWatchlist",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DomainId" => DomainId, "WatchlistId" => WatchlistId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_fraudster(domain_id, fraudster_id, watchlist_id)
    disassociate_fraudster(domain_id, fraudster_id, watchlist_id, params::Dict{String,<:Any})

Disassociates the fraudsters from the watchlist specified. Voice ID always expects a
fraudster to be a part of at least one watchlist. If you try to disassociate a fraudster
from its only watchlist, a ValidationException is thrown.

# Arguments
- `domain_id`: The identifier of the domain that contains the fraudster.
- `fraudster_id`: The identifier of the fraudster to be disassociated from the watchlist.
- `watchlist_id`: The identifier of the watchlist that you want to disassociate from the
  fraudster.

"""
function disassociate_fraudster(
    DomainId, FraudsterId, WatchlistId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return voice_id(
        "DisassociateFraudster",
        Dict{String,Any}(
            "DomainId" => DomainId,
            "FraudsterId" => FraudsterId,
            "WatchlistId" => WatchlistId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_fraudster(
    DomainId,
    FraudsterId,
    WatchlistId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return voice_id(
        "DisassociateFraudster",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DomainId" => DomainId,
                    "FraudsterId" => FraudsterId,
                    "WatchlistId" => WatchlistId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    evaluate_session(domain_id, session_name_or_id)
    evaluate_session(domain_id, session_name_or_id, params::Dict{String,<:Any})

Evaluates a specified session based on audio data accumulated during a streaming Amazon
Connect Voice ID call.

# Arguments
- `domain_id`: The identifier of the domain where the session started.
- `session_name_or_id`: The session identifier, or name of the session, that you want to
  evaluate. In Voice ID integration, this is the Contact-Id.

"""
function evaluate_session(
    DomainId, SessionNameOrId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return voice_id(
        "EvaluateSession",
        Dict{String,Any}("DomainId" => DomainId, "SessionNameOrId" => SessionNameOrId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function evaluate_session(
    DomainId,
    SessionNameOrId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return voice_id(
        "EvaluateSession",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DomainId" => DomainId, "SessionNameOrId" => SessionNameOrId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_domains()
    list_domains(params::Dict{String,<:Any})

Lists all the domains in the Amazon Web Services account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results that are returned per call. You can use
  NextToken to obtain more pages of results. The default is 100; the maximum allowed page
  size is also 100.
- `"NextToken"`: If NextToken is returned, there are more results available. The value of
  NextToken is a unique pagination token for each page. Make the call again using the
  returned token to retrieve the next page. Keep all other arguments unchanged. Each
  pagination token expires after 24 hours.
"""
function list_domains(; aws_config::AbstractAWSConfig=current_aws_config())
    return voice_id("ListDomains"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_domains(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return voice_id(
        "ListDomains", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_fraudster_registration_jobs(domain_id)
    list_fraudster_registration_jobs(domain_id, params::Dict{String,<:Any})

Lists all the fraudster registration jobs in the domain with the given JobStatus. If
JobStatus is not provided, this lists all fraudster registration jobs in the given domain.

# Arguments
- `domain_id`: The identifier of the domain that contains the fraudster registration Jobs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"JobStatus"`: Provides the status of your fraudster registration job.
- `"MaxResults"`: The maximum number of results that are returned per call. You can use
  NextToken to obtain more pages of results. The default is 100; the maximum allowed page
  size is also 100.
- `"NextToken"`: If NextToken is returned, there are more results available. The value of
  NextToken is a unique pagination token for each page. Make the call again using the
  returned token to retrieve the next page. Keep all other arguments unchanged. Each
  pagination token expires after 24 hours.
"""
function list_fraudster_registration_jobs(
    DomainId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return voice_id(
        "ListFraudsterRegistrationJobs",
        Dict{String,Any}("DomainId" => DomainId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_fraudster_registration_jobs(
    DomainId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return voice_id(
        "ListFraudsterRegistrationJobs",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DomainId" => DomainId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_fraudsters(domain_id)
    list_fraudsters(domain_id, params::Dict{String,<:Any})

Lists all fraudsters in a specified watchlist or domain.

# Arguments
- `domain_id`: The identifier of the domain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results that are returned per call. You can use
  NextToken to obtain more pages of results. The default is 100; the maximum allowed page
  size is also 100.
- `"NextToken"`: If NextToken is returned, there are more results available. The value of
  NextToken is a unique pagination token for each page. Make the call again using the
  returned token to retrieve the next page. Keep all other arguments unchanged. Each
  pagination token expires after 24 hours.
- `"WatchlistId"`: The identifier of the watchlist. If provided, all fraudsters in the
  watchlist are listed. If not provided, all fraudsters in the domain are listed.
"""
function list_fraudsters(DomainId; aws_config::AbstractAWSConfig=current_aws_config())
    return voice_id(
        "ListFraudsters",
        Dict{String,Any}("DomainId" => DomainId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_fraudsters(
    DomainId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return voice_id(
        "ListFraudsters",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DomainId" => DomainId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_speaker_enrollment_jobs(domain_id)
    list_speaker_enrollment_jobs(domain_id, params::Dict{String,<:Any})

Lists all the speaker enrollment jobs in the domain with the specified JobStatus. If
JobStatus is not provided, this lists all jobs with all possible speaker enrollment job
statuses.

# Arguments
- `domain_id`: The identifier of the domain that contains the speaker enrollment jobs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"JobStatus"`: Provides the status of your speaker enrollment Job.
- `"MaxResults"`: The maximum number of results that are returned per call. You can use
  NextToken to obtain more pages of results. The default is 100; the maximum allowed page
  size is also 100.
- `"NextToken"`: If NextToken is returned, there are more results available. The value of
  NextToken is a unique pagination token for each page. Make the call again using the
  returned token to retrieve the next page. Keep all other arguments unchanged. Each
  pagination token expires after 24 hours.
"""
function list_speaker_enrollment_jobs(
    DomainId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return voice_id(
        "ListSpeakerEnrollmentJobs",
        Dict{String,Any}("DomainId" => DomainId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_speaker_enrollment_jobs(
    DomainId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return voice_id(
        "ListSpeakerEnrollmentJobs",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DomainId" => DomainId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_speakers(domain_id)
    list_speakers(domain_id, params::Dict{String,<:Any})

Lists all speakers in a specified domain.

# Arguments
- `domain_id`: The identifier of the domain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results that are returned per call. You can use
  NextToken to obtain more pages of results. The default is 100; the maximum allowed page
  size is also 100.
- `"NextToken"`: If NextToken is returned, there are more results available. The value of
  NextToken is a unique pagination token for each page. Make the call again using the
  returned token to retrieve the next page. Keep all other arguments unchanged. Each
  pagination token expires after 24 hours.
"""
function list_speakers(DomainId; aws_config::AbstractAWSConfig=current_aws_config())
    return voice_id(
        "ListSpeakers",
        Dict{String,Any}("DomainId" => DomainId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_speakers(
    DomainId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return voice_id(
        "ListSpeakers",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DomainId" => DomainId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists all tags associated with a specified Voice ID resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the Voice ID resource for which you
  want to list the tags.

"""
function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return voice_id(
        "ListTagsForResource",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return voice_id(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_watchlists(domain_id)
    list_watchlists(domain_id, params::Dict{String,<:Any})

Lists all watchlists in a specified domain.

# Arguments
- `domain_id`: The identifier of the domain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results that are returned per call. You can use
  NextToken to obtain more pages of results. The default is 100; the maximum allowed page
  size is also 100.
- `"NextToken"`: If NextToken is returned, there are more results available. The value of
  NextToken is a unique pagination token for each page. Make the call again using the
  returned token to retrieve the next page. Keep all other arguments unchanged. Each
  pagination token expires after 24 hours.
"""
function list_watchlists(DomainId; aws_config::AbstractAWSConfig=current_aws_config())
    return voice_id(
        "ListWatchlists",
        Dict{String,Any}("DomainId" => DomainId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_watchlists(
    DomainId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return voice_id(
        "ListWatchlists",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DomainId" => DomainId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    opt_out_speaker(domain_id, speaker_id)
    opt_out_speaker(domain_id, speaker_id, params::Dict{String,<:Any})

Opts out a speaker from Voice ID. A speaker can be opted out regardless of whether or not
they already exist in Voice ID. If they don't yet exist, a new speaker is created in an
opted out state. If they already exist, their existing status is overridden and they are
opted out. Enrollment and evaluation authentication requests are rejected for opted out
speakers, and opted out speakers have no voice embeddings stored in Voice ID.

# Arguments
- `domain_id`: The identifier of the domain that contains the speaker.
- `speaker_id`: The identifier of the speaker you want opted-out.

"""
function opt_out_speaker(
    DomainId, SpeakerId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return voice_id(
        "OptOutSpeaker",
        Dict{String,Any}("DomainId" => DomainId, "SpeakerId" => SpeakerId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function opt_out_speaker(
    DomainId,
    SpeakerId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return voice_id(
        "OptOutSpeaker",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DomainId" => DomainId, "SpeakerId" => SpeakerId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_fraudster_registration_job(data_access_role_arn, domain_id, input_data_config, output_data_config)
    start_fraudster_registration_job(data_access_role_arn, domain_id, input_data_config, output_data_config, params::Dict{String,<:Any})

Starts a new batch fraudster registration job using provided details.

# Arguments
- `data_access_role_arn`: The IAM role Amazon Resource Name (ARN) that grants Voice ID
  permissions to access customer's buckets to read the input manifest file and write the Job
  output file. Refer to the Create and edit a fraudster watchlist documentation for the
  permissions needed in this role.
- `domain_id`: The identifier of the domain that contains the fraudster registration job
  and in which the fraudsters are registered.
- `input_data_config`: The input data config containing an S3 URI for the input manifest
  file that contains the list of fraudster registration requests.
- `output_data_config`: The output data config containing the S3 location where Voice ID
  writes the job output file; you must also include a KMS key ID to encrypt the file.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If not provided, the Amazon Web Services SDK populates this
  field. For more information about idempotency, see Making retries safe with idempotent APIs.
- `"JobName"`: The name of the new fraudster registration job.
- `"RegistrationConfig"`: The registration config containing details such as the action to
  take when a duplicate fraudster is detected, and the similarity threshold to use for
  detecting a duplicate fraudster.
"""
function start_fraudster_registration_job(
    DataAccessRoleArn,
    DomainId,
    InputDataConfig,
    OutputDataConfig;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return voice_id(
        "StartFraudsterRegistrationJob",
        Dict{String,Any}(
            "DataAccessRoleArn" => DataAccessRoleArn,
            "DomainId" => DomainId,
            "InputDataConfig" => InputDataConfig,
            "OutputDataConfig" => OutputDataConfig,
            "ClientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_fraudster_registration_job(
    DataAccessRoleArn,
    DomainId,
    InputDataConfig,
    OutputDataConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return voice_id(
        "StartFraudsterRegistrationJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DataAccessRoleArn" => DataAccessRoleArn,
                    "DomainId" => DomainId,
                    "InputDataConfig" => InputDataConfig,
                    "OutputDataConfig" => OutputDataConfig,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_speaker_enrollment_job(data_access_role_arn, domain_id, input_data_config, output_data_config)
    start_speaker_enrollment_job(data_access_role_arn, domain_id, input_data_config, output_data_config, params::Dict{String,<:Any})

Starts a new batch speaker enrollment job using specified details.

# Arguments
- `data_access_role_arn`: The IAM role Amazon Resource Name (ARN) that grants Voice ID
  permissions to access customer's buckets to read the input manifest file and write the job
  output file. Refer to Batch enrollment using audio data from prior calls for the
  permissions needed in this role.
- `domain_id`: The identifier of the domain that contains the speaker enrollment job and in
  which the speakers are enrolled.
- `input_data_config`: The input data config containing the S3 location for the input
  manifest file that contains the list of speaker enrollment requests.
- `output_data_config`: The output data config containing the S3 location where Voice ID
  writes the job output file; you must also include a KMS key ID to encrypt the file.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If not provided, the Amazon Web Services SDK populates this
  field. For more information about idempotency, see Making retries safe with idempotent APIs.
- `"EnrollmentConfig"`: The enrollment config that contains details such as the action to
  take when a speaker is already enrolled in Voice ID or when a speaker is identified as a
  fraudster.
- `"JobName"`: A name for your speaker enrollment job.
"""
function start_speaker_enrollment_job(
    DataAccessRoleArn,
    DomainId,
    InputDataConfig,
    OutputDataConfig;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return voice_id(
        "StartSpeakerEnrollmentJob",
        Dict{String,Any}(
            "DataAccessRoleArn" => DataAccessRoleArn,
            "DomainId" => DomainId,
            "InputDataConfig" => InputDataConfig,
            "OutputDataConfig" => OutputDataConfig,
            "ClientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_speaker_enrollment_job(
    DataAccessRoleArn,
    DomainId,
    InputDataConfig,
    OutputDataConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return voice_id(
        "StartSpeakerEnrollmentJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DataAccessRoleArn" => DataAccessRoleArn,
                    "DomainId" => DomainId,
                    "InputDataConfig" => InputDataConfig,
                    "OutputDataConfig" => OutputDataConfig,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Tags a Voice ID resource with the provided list of tags.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the Voice ID resource you want to tag.
- `tags`: The list of tags to assign to the specified resource.

"""
function tag_resource(ResourceArn, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return voice_id(
        "TagResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceArn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return voice_id(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes specified tags from a specified Amazon Connect Voice ID resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the Voice ID resource you want to
  remove tags from.
- `tag_keys`: The list of tag keys you want to remove from the specified resource.

"""
function untag_resource(
    ResourceArn, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return voice_id(
        "UntagResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceArn,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return voice_id(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_domain(domain_id, name, server_side_encryption_configuration)
    update_domain(domain_id, name, server_side_encryption_configuration, params::Dict{String,<:Any})

Updates the specified domain. This API has clobber behavior, and clears and replaces all
attributes. If an optional field, such as 'Description' is not provided, it is removed from
the domain.

# Arguments
- `domain_id`: The identifier of the domain to be updated.
- `name`: The name of the domain.
- `server_side_encryption_configuration`: The configuration, containing the KMS key
  identifier, to be used by Voice ID for the server-side encryption of your data. Changing
  the domain's associated KMS key immediately triggers an asynchronous process to remove
  dependency on the old KMS key, such that the domain's data can only be accessed using the
  new KMS key. The domain's ServerSideEncryptionUpdateDetails contains the details for this
  process.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A brief description about this domain.
"""
function update_domain(
    DomainId,
    Name,
    ServerSideEncryptionConfiguration;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return voice_id(
        "UpdateDomain",
        Dict{String,Any}(
            "DomainId" => DomainId,
            "Name" => Name,
            "ServerSideEncryptionConfiguration" => ServerSideEncryptionConfiguration,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_domain(
    DomainId,
    Name,
    ServerSideEncryptionConfiguration,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return voice_id(
        "UpdateDomain",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DomainId" => DomainId,
                    "Name" => Name,
                    "ServerSideEncryptionConfiguration" =>
                        ServerSideEncryptionConfiguration,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_watchlist(domain_id, watchlist_id)
    update_watchlist(domain_id, watchlist_id, params::Dict{String,<:Any})

Updates the specified watchlist. Every domain has a default watchlist which cannot be
updated.

# Arguments
- `domain_id`: The identifier of the domain that contains the watchlist.
- `watchlist_id`: The identifier of the watchlist to be updated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A brief description about this watchlist.
- `"Name"`: The name of the watchlist.
"""
function update_watchlist(
    DomainId, WatchlistId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return voice_id(
        "UpdateWatchlist",
        Dict{String,Any}("DomainId" => DomainId, "WatchlistId" => WatchlistId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_watchlist(
    DomainId,
    WatchlistId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return voice_id(
        "UpdateWatchlist",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DomainId" => DomainId, "WatchlistId" => WatchlistId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: taxsettings
using AWS.Compat
using AWS.UUIDs

"""
    batch_delete_tax_registration(account_ids)
    batch_delete_tax_registration(account_ids, params::Dict{String,<:Any})

Deletes tax registration for multiple accounts in batch. This can be used to delete tax
registrations for up to five accounts in one batch.   This API operation can't be used to
delete your tax registration in Brazil. Use the Payment preferences page in the Billing and
Cost Management console instead.

# Arguments
- `account_ids`: List of unique account identifiers.

"""
function batch_delete_tax_registration(
    accountIds; aws_config::AbstractAWSConfig=current_aws_config()
)
    return taxsettings(
        "POST",
        "/BatchDeleteTaxRegistration",
        Dict{String,Any}("accountIds" => accountIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_delete_tax_registration(
    accountIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return taxsettings(
        "POST",
        "/BatchDeleteTaxRegistration",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("accountIds" => accountIds), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_put_tax_registration(account_ids, tax_registration_entry)
    batch_put_tax_registration(account_ids, tax_registration_entry, params::Dict{String,<:Any})

Adds or updates tax registration for multiple accounts in batch. This can be used to add or
update tax registrations for up to five accounts in one batch. You can't set a TRN if
there's a pending TRN. You'll need to delete the pending TRN first. To call this API
operation for specific countries, see the following country-specific requirements.
Bangladesh    You must specify the tax registration certificate document in the
taxRegistrationDocuments field of the VerificationDetails object.    Brazil    You must
complete the tax registration process in the Payment preferences page in the Billing and
Cost Management console. After your TRN and billing address are verified, you can call this
API operation.   For Amazon Web Services accounts created through Organizations, you can
call this API operation when you don't have a billing address.    Georgia    The valid
personType values are Physical Person and Business.    Kenya    You must specify the
personType in the kenyaAdditionalInfo field of the additionalTaxInformation object.   If
the personType is Physical Person, you must specify the tax registration certificate
document in the taxRegistrationDocuments field of the VerificationDetails object.
Malaysia    If you use this operation to set a tax registration number (TRN) in Malaysia,
only resellers with a valid sales and service tax (SST) number are required to provide tax
registration information.   By using this API operation to set a TRN in Malaysia, Amazon
Web Services will regard you as self-declaring that you're an authorized business reseller
registered with the Royal Malaysia Customs Department (RMCD) and have a valid SST number.
Amazon Web Services reserves the right to seek additional information and/or take other
actions to support your self-declaration as appropriate.   If you're not a reseller of
Amazon Web Services, we don't recommend that you use this operation to set the TRN in
Malaysia.   Only use this API operation to upload the TRNs for accounts through which
you're reselling Amazon Web Services.   Amazon Web Services is currently registered under
the following service tax codes. You must include at least one of the service tax codes in
the service tax code strings to declare yourself as an authorized registered business
reseller. Taxable service and service tax codes: Consultancy - 9907061674 Training or
coaching service - 9907071685 IT service - 9907101676 Digital services and electronic
medium - 9907121690    Nepal    The sector valid values are Business and Individual.
Saudi Arabia    For address, you must specify addressLine3.    South Korea    You must
specify the certifiedEmailId and legalName in the TaxRegistrationEntry object. Use Korean
characters for legalName.   You must specify the businessRepresentativeName,
itemOfBusiness, and lineOfBusiness in the southKoreaAdditionalInfo field of the
additionalTaxInformation object. Use Korean characters for these fields.   You must specify
the tax registration certificate document in the taxRegistrationDocuments field of the
VerificationDetails object.   For the address object, use Korean characters for
addressLine1, addressLine2 city, postalCode, and stateOrRegion.    Spain    You must
specify the registrationType in the spainAdditionalInfo field of the
additionalTaxInformation object.   If the registrationType is Local, you must specify the
tax registration certificate document in the taxRegistrationDocuments field of the
VerificationDetails object.    Turkey    You must specify the sector in the
taxRegistrationEntry object.   If your sector is Business, Individual, or Government:
Specify the taxOffice. If your sector is Individual, don't enter this value.   (Optional)
Specify the kepEmailId. If your sector is Individual, don't enter this value.    Note: In
the Tax Settings page of the Billing console, Government appears as Public institutions
 If your sector is Business and you're subject to KDV tax, you must specify your industry
in the industries field.   For address, you must specify districtOrCounty.    Ukraine
The sector valid values are Business and Individual.

# Arguments
- `account_ids`:  List of unique account identifiers.
- `tax_registration_entry`: Your TRN information that will be stored to the accounts
  mentioned in putEntries.

"""
function batch_put_tax_registration(
    accountIds, taxRegistrationEntry; aws_config::AbstractAWSConfig=current_aws_config()
)
    return taxsettings(
        "POST",
        "/BatchPutTaxRegistration",
        Dict{String,Any}(
            "accountIds" => accountIds, "taxRegistrationEntry" => taxRegistrationEntry
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_put_tax_registration(
    accountIds,
    taxRegistrationEntry,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return taxsettings(
        "POST",
        "/BatchPutTaxRegistration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "accountIds" => accountIds,
                    "taxRegistrationEntry" => taxRegistrationEntry,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_tax_registration()
    delete_tax_registration(params::Dict{String,<:Any})

Deletes tax registration for a single account.   This API operation can't be used to delete
your tax registration in Brazil. Use the Payment preferences page in the Billing and Cost
Management console instead.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountId"`: Unique account identifier for the TRN information that needs to be
  deleted. If this isn't passed, the account ID corresponding to the credentials of the API
  caller will be used for this parameter.
"""
function delete_tax_registration(; aws_config::AbstractAWSConfig=current_aws_config())
    return taxsettings(
        "POST",
        "/DeleteTaxRegistration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_tax_registration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return taxsettings(
        "POST",
        "/DeleteTaxRegistration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_tax_registration()
    get_tax_registration(params::Dict{String,<:Any})

Retrieves tax registration for a single account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountId"`: Your unique account identifier.
"""
function get_tax_registration(; aws_config::AbstractAWSConfig=current_aws_config())
    return taxsettings(
        "POST",
        "/GetTaxRegistration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_tax_registration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return taxsettings(
        "POST",
        "/GetTaxRegistration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_tax_registration_document(destination_s3_location, tax_document_metadata)
    get_tax_registration_document(destination_s3_location, tax_document_metadata, params::Dict{String,<:Any})

Downloads your tax documents to the Amazon S3 bucket that you specify in your request.

# Arguments
- `destination_s3_location`: The Amazon S3 bucket that you specify to download your tax
  documents to.
- `tax_document_metadata`: The metadata for your tax document.

"""
function get_tax_registration_document(
    destinationS3Location,
    taxDocumentMetadata;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return taxsettings(
        "POST",
        "/GetTaxRegistrationDocument",
        Dict{String,Any}(
            "destinationS3Location" => destinationS3Location,
            "taxDocumentMetadata" => taxDocumentMetadata,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_tax_registration_document(
    destinationS3Location,
    taxDocumentMetadata,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return taxsettings(
        "POST",
        "/GetTaxRegistrationDocument",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "destinationS3Location" => destinationS3Location,
                    "taxDocumentMetadata" => taxDocumentMetadata,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tax_registrations()
    list_tax_registrations(params::Dict{String,<:Any})

Retrieves the tax registration of accounts listed in a consolidated billing family. This
can be used to retrieve up to 100 accounts' tax registrations in one call (default 50).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Number of accountDetails results you want in one response.
- `"nextToken"`: The token to retrieve the next set of results.
"""
function list_tax_registrations(; aws_config::AbstractAWSConfig=current_aws_config())
    return taxsettings(
        "POST",
        "/ListTaxRegistrations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tax_registrations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return taxsettings(
        "POST",
        "/ListTaxRegistrations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_tax_registration(tax_registration_entry)
    put_tax_registration(tax_registration_entry, params::Dict{String,<:Any})

Adds or updates tax registration for a single account. You can't set a TRN if there's a
pending TRN. You'll need to delete the pending TRN first. To call this API operation for
specific countries, see the following country-specific requirements.  Bangladesh    You
must specify the tax registration certificate document in the taxRegistrationDocuments
field of the VerificationDetails object.    Brazil    You must complete the tax
registration process in the Payment preferences page in the Billing and Cost Management
console. After your TRN and billing address are verified, you can call this API operation.
 For Amazon Web Services accounts created through Organizations, you can call this API
operation when you don't have a billing address.    Georgia    The valid personType values
are Physical Person and Business.    Kenya    You must specify the personType in the
kenyaAdditionalInfo field of the additionalTaxInformation object.   If the personType is
Physical Person, you must specify the tax registration certificate document in the
taxRegistrationDocuments field of the VerificationDetails object.    Malaysia    If you use
this operation to set a tax registration number (TRN) in Malaysia, only resellers with a
valid sales and service tax (SST) number are required to provide tax registration
information.   By using this API operation to set a TRN in Malaysia, Amazon Web Services
will regard you as self-declaring that you're an authorized business reseller registered
with the Royal Malaysia Customs Department (RMCD) and have a valid SST number.   Amazon Web
Services reserves the right to seek additional information and/or take other actions to
support your self-declaration as appropriate.   If you're not a reseller of Amazon Web
Services, we don't recommend that you use this operation to set the TRN in Malaysia.   Only
use this API operation to upload the TRNs for accounts through which you're reselling
Amazon Web Services.   Amazon Web Services is currently registered under the following
service tax codes. You must include at least one of the service tax codes in the service
tax code strings to declare yourself as an authorized registered business reseller. Taxable
service and service tax codes: Consultancy - 9907061674 Training or coaching service -
9907071685 IT service - 9907101676 Digital services and electronic medium - 9907121690
Nepal    The sector valid values are Business and Individual.    Saudi Arabia    For
address, you must specify addressLine3.    South Korea    You must specify the
certifiedEmailId and legalName in the TaxRegistrationEntry object. Use Korean characters
for legalName.   You must specify the businessRepresentativeName, itemOfBusiness, and
lineOfBusiness in the southKoreaAdditionalInfo field of the additionalTaxInformation
object. Use Korean characters for these fields.   You must specify the tax registration
certificate document in the taxRegistrationDocuments field of the VerificationDetails
object.   For the address object, use Korean characters for addressLine1, addressLine2
city, postalCode, and stateOrRegion.    Spain    You must specify the registrationType in
the spainAdditionalInfo field of the additionalTaxInformation object.   If the
registrationType is Local, you must specify the tax registration certificate document in
the taxRegistrationDocuments field of the VerificationDetails object.    Turkey    You must
specify the sector in the taxRegistrationEntry object.   If your sector is Business,
Individual, or Government:   Specify the taxOffice. If your sector is Individual, don't
enter this value.   (Optional) Specify the kepEmailId. If your sector is Individual, don't
enter this value.    Note: In the Tax Settings page of the Billing console, Government
appears as Public institutions      If your sector is Business and you're subject to KDV
tax, you must specify your industry in the industries field.   For address, you must
specify districtOrCounty.    Ukraine    The sector valid values are Business and
Individual.

# Arguments
- `tax_registration_entry`:  Your TRN information that will be stored to the account
  mentioned in accountId.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountId"`: Your unique account identifier.
"""
function put_tax_registration(
    taxRegistrationEntry; aws_config::AbstractAWSConfig=current_aws_config()
)
    return taxsettings(
        "POST",
        "/PutTaxRegistration",
        Dict{String,Any}("taxRegistrationEntry" => taxRegistrationEntry);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_tax_registration(
    taxRegistrationEntry,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return taxsettings(
        "POST",
        "/PutTaxRegistration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("taxRegistrationEntry" => taxRegistrationEntry),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: sagemaker_edge
using AWS.Compat
using AWS.UUIDs

"""
    get_deployments(device_fleet_name, device_name)
    get_deployments(device_fleet_name, device_name, params::Dict{String,<:Any})

Use to get the active deployments from a device.

# Arguments
- `device_fleet_name`: The name of the fleet that the device belongs to.
- `device_name`: The unique name of the device you want to get the configuration of active
  deployments from.

"""
function get_deployments(
    DeviceFleetName, DeviceName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sagemaker_edge(
        "POST",
        "/GetDeployments",
        Dict{String,Any}("DeviceFleetName" => DeviceFleetName, "DeviceName" => DeviceName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_deployments(
    DeviceFleetName,
    DeviceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sagemaker_edge(
        "POST",
        "/GetDeployments",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DeviceFleetName" => DeviceFleetName, "DeviceName" => DeviceName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_device_registration(device_fleet_name, device_name)
    get_device_registration(device_fleet_name, device_name, params::Dict{String,<:Any})

Use to check if a device is registered with SageMaker Edge Manager.

# Arguments
- `device_fleet_name`: The name of the fleet that the device belongs to.
- `device_name`: The unique name of the device you want to get the registration status from.

"""
function get_device_registration(
    DeviceFleetName, DeviceName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sagemaker_edge(
        "POST",
        "/GetDeviceRegistration",
        Dict{String,Any}("DeviceFleetName" => DeviceFleetName, "DeviceName" => DeviceName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_device_registration(
    DeviceFleetName,
    DeviceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sagemaker_edge(
        "POST",
        "/GetDeviceRegistration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DeviceFleetName" => DeviceFleetName, "DeviceName" => DeviceName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    send_heartbeat(agent_version, device_fleet_name, device_name)
    send_heartbeat(agent_version, device_fleet_name, device_name, params::Dict{String,<:Any})

Use to get the current status of devices registered on SageMaker Edge Manager.

# Arguments
- `agent_version`: Returns the version of the agent.
- `device_fleet_name`: The name of the fleet that the device belongs to.
- `device_name`: The unique name of the device.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AgentMetrics"`: For internal use. Returns a list of SageMaker Edge Manager agent
  operating metrics.
- `"DeploymentResult"`: Returns the result of a deployment on the device.
- `"Models"`: Returns a list of models deployed on the the device.
"""
function send_heartbeat(
    AgentVersion,
    DeviceFleetName,
    DeviceName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sagemaker_edge(
        "POST",
        "/SendHeartbeat",
        Dict{String,Any}(
            "AgentVersion" => AgentVersion,
            "DeviceFleetName" => DeviceFleetName,
            "DeviceName" => DeviceName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function send_heartbeat(
    AgentVersion,
    DeviceFleetName,
    DeviceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sagemaker_edge(
        "POST",
        "/SendHeartbeat",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AgentVersion" => AgentVersion,
                    "DeviceFleetName" => DeviceFleetName,
                    "DeviceName" => DeviceName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: snow_device_management
using AWS.Compat
using AWS.UUIDs

"""
    cancel_task(task_id)
    cancel_task(task_id, params::Dict{String,<:Any})

Sends a cancel request for a specified task. You can cancel a task only if it's still in a
QUEUED state. Tasks that are already running can't be cancelled.  A task might still run if
it's processed from the queue before the CancelTask operation changes the task's state.

# Arguments
- `task_id`: The ID of the task that you are attempting to cancel. You can retrieve a task
  ID by using the ListTasks operation.

"""
function cancel_task(taskId; aws_config::AbstractAWSConfig=current_aws_config())
    return snow_device_management(
        "POST",
        "/task/$(taskId)/cancel";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_task(
    taskId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return snow_device_management(
        "POST",
        "/task/$(taskId)/cancel",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_task(command, targets)
    create_task(command, targets, params::Dict{String,<:Any})

Instructs one or more devices to start a task, such as unlocking or rebooting.

# Arguments
- `command`: The task to be performed. Only one task is executed on a device at a time.
- `targets`: A list of managed device IDs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A token ensuring that the action is called only once with the specified
  details.
- `"description"`: A description of the task and its targets.
- `"tags"`: Optional metadata that you assign to a resource. You can use tags to categorize
  a resource in different ways, such as by purpose, owner, or environment.
"""
function create_task(command, targets; aws_config::AbstractAWSConfig=current_aws_config())
    return snow_device_management(
        "POST",
        "/task",
        Dict{String,Any}(
            "command" => command, "targets" => targets, "clientToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_task(
    command,
    targets,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return snow_device_management(
        "POST",
        "/task",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "command" => command,
                    "targets" => targets,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_device(managed_device_id)
    describe_device(managed_device_id, params::Dict{String,<:Any})

Checks device-specific information, such as the device type, software version, IP
addresses, and lock status.

# Arguments
- `managed_device_id`: The ID of the device that you are checking the information of.

"""
function describe_device(
    managedDeviceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return snow_device_management(
        "POST",
        "/managed-device/$(managedDeviceId)/describe";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_device(
    managedDeviceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return snow_device_management(
        "POST",
        "/managed-device/$(managedDeviceId)/describe",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_device_ec2_instances(instance_ids, managed_device_id)
    describe_device_ec2_instances(instance_ids, managed_device_id, params::Dict{String,<:Any})

Checks the current state of the Amazon EC2 instances. The output is similar to
describeDevice, but the results are sourced from the device cache in the Amazon Web
Services Cloud and include a subset of the available fields.

# Arguments
- `instance_ids`: A list of instance IDs associated with the managed device.
- `managed_device_id`: The ID of the managed device.

"""
function describe_device_ec2_instances(
    instanceIds, managedDeviceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return snow_device_management(
        "POST",
        "/managed-device/$(managedDeviceId)/resources/ec2/describe",
        Dict{String,Any}("instanceIds" => instanceIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_device_ec2_instances(
    instanceIds,
    managedDeviceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return snow_device_management(
        "POST",
        "/managed-device/$(managedDeviceId)/resources/ec2/describe",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("instanceIds" => instanceIds), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_execution(managed_device_id, task_id)
    describe_execution(managed_device_id, task_id, params::Dict{String,<:Any})

Checks the status of a remote task running on one or more target devices.

# Arguments
- `managed_device_id`: The ID of the managed device.
- `task_id`: The ID of the task that the action is describing.

"""
function describe_execution(
    managedDeviceId, taskId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return snow_device_management(
        "POST",
        "/task/$(taskId)/execution/$(managedDeviceId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_execution(
    managedDeviceId,
    taskId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return snow_device_management(
        "POST",
        "/task/$(taskId)/execution/$(managedDeviceId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_task(task_id)
    describe_task(task_id, params::Dict{String,<:Any})

Checks the metadata for a given task on a device.

# Arguments
- `task_id`: The ID of the task to be described.

"""
function describe_task(taskId; aws_config::AbstractAWSConfig=current_aws_config())
    return snow_device_management(
        "POST", "/task/$(taskId)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_task(
    taskId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return snow_device_management(
        "POST",
        "/task/$(taskId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_device_resources(managed_device_id)
    list_device_resources(managed_device_id, params::Dict{String,<:Any})

Returns a list of the Amazon Web Services resources available for a device. Currently,
Amazon EC2 instances are the only supported resource type.

# Arguments
- `managed_device_id`: The ID of the managed device that you are listing the resources of.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of resources per page.
- `"nextToken"`: A pagination token to continue to the next page of results.
- `"type"`: A structure used to filter the results by type of resource.
"""
function list_device_resources(
    managedDeviceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return snow_device_management(
        "GET",
        "/managed-device/$(managedDeviceId)/resources";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_device_resources(
    managedDeviceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return snow_device_management(
        "GET",
        "/managed-device/$(managedDeviceId)/resources",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_devices()
    list_devices(params::Dict{String,<:Any})

Returns a list of all devices on your Amazon Web Services account that have Amazon Web
Services Snow Device Management enabled in the Amazon Web Services Region where the command
is run.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"jobId"`: The ID of the job used to order the device.
- `"maxResults"`: The maximum number of devices to list per page.
- `"nextToken"`: A pagination token to continue to the next page of results.
"""
function list_devices(; aws_config::AbstractAWSConfig=current_aws_config())
    return snow_device_management(
        "GET", "/managed-devices"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_devices(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return snow_device_management(
        "GET",
        "/managed-devices",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_executions(task_id)
    list_executions(task_id, params::Dict{String,<:Any})

Returns the status of tasks for one or more target devices.

# Arguments
- `task_id`: The ID of the task.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of tasks to list per page.
- `"nextToken"`: A pagination token to continue to the next page of tasks.
- `"state"`: A structure used to filter the tasks by their current state.
"""
function list_executions(taskId; aws_config::AbstractAWSConfig=current_aws_config())
    return snow_device_management(
        "GET",
        "/executions",
        Dict{String,Any}("taskId" => taskId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_executions(
    taskId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return snow_device_management(
        "GET",
        "/executions",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("taskId" => taskId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Returns a list of tags for a managed device or task.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the device or task.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return snow_device_management(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return snow_device_management(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tasks()
    list_tasks(params::Dict{String,<:Any})

Returns a list of tasks that can be filtered by state.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of tasks per page.
- `"nextToken"`: A pagination token to continue to the next page of tasks.
- `"state"`: A structure used to filter the list of tasks.
"""
function list_tasks(; aws_config::AbstractAWSConfig=current_aws_config())
    return snow_device_management(
        "GET", "/tasks"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_tasks(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return snow_device_management(
        "GET", "/tasks", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds or replaces tags on a device or task.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the device or task.
- `tags`: Optional metadata that you assign to a resource. You can use tags to categorize a
  resource in different ways, such as by purpose, owner, or environment.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return snow_device_management(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return snow_device_management(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes a tag from a device or task.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the device or task.
- `tag_keys`: Optional metadata that you assign to a resource. You can use tags to
  categorize a resource in different ways, such as by purpose, owner, or environment.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return snow_device_management(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return snow_device_management(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: shield
using AWS.Compat
using AWS.UUIDs

"""
    associate_drtlog_bucket(log_bucket)
    associate_drtlog_bucket(log_bucket, params::Dict{String,<:Any})

Authorizes the Shield Response Team (SRT) to access the specified Amazon S3 bucket
containing log data such as Application Load Balancer access logs, CloudFront logs, or logs
from third party sources. You can associate up to 10 Amazon S3 buckets with your
subscription. To use the services of the SRT and make an AssociateDRTLogBucket request, you
must be subscribed to the Business Support plan or the Enterprise Support plan.

# Arguments
- `log_bucket`: The Amazon S3 bucket that contains the logs that you want to share.

"""
function associate_drtlog_bucket(
    LogBucket; aws_config::AbstractAWSConfig=current_aws_config()
)
    return shield(
        "AssociateDRTLogBucket",
        Dict{String,Any}("LogBucket" => LogBucket);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_drtlog_bucket(
    LogBucket,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return shield(
        "AssociateDRTLogBucket",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("LogBucket" => LogBucket), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_drtrole(role_arn)
    associate_drtrole(role_arn, params::Dict{String,<:Any})

Authorizes the Shield Response Team (SRT) using the specified role, to access your Amazon
Web Services account to assist with DDoS attack mitigation during potential attacks. This
enables the SRT to inspect your WAF configuration and create or update WAF rules and web
ACLs. You can associate only one RoleArn with your subscription. If you submit an
AssociateDRTRole request for an account that already has an associated role, the new
RoleArn will replace the existing RoleArn.  Prior to making the AssociateDRTRole request,
you must attach the AWSShieldDRTAccessPolicy managed policy to the role that you'll specify
in the request. You can access this policy in the IAM console at AWSShieldDRTAccessPolicy.
For more information see Adding and removing IAM identity permissions. The role must also
trust the service principal drt.shield.amazonaws.com. For more information, see IAM JSON
policy elements: Principal. The SRT will have access only to your WAF and Shield resources.
By submitting this request, you authorize the SRT to inspect your WAF and Shield
configuration and create and update WAF rules and web ACLs on your behalf. The SRT takes
these actions only if explicitly authorized by you. You must have the iam:PassRole
permission to make an AssociateDRTRole request. For more information, see Granting a user
permissions to pass a role to an Amazon Web Services service.  To use the services of the
SRT and make an AssociateDRTRole request, you must be subscribed to the Business Support
plan or the Enterprise Support plan.

# Arguments
- `role_arn`: The Amazon Resource Name (ARN) of the role the SRT will use to access your
  Amazon Web Services account. Prior to making the AssociateDRTRole request, you must attach
  the AWSShieldDRTAccessPolicy managed policy to this role. For more information see
  Attaching and Detaching IAM Policies.

"""
function associate_drtrole(RoleArn; aws_config::AbstractAWSConfig=current_aws_config())
    return shield(
        "AssociateDRTRole",
        Dict{String,Any}("RoleArn" => RoleArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_drtrole(
    RoleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return shield(
        "AssociateDRTRole",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("RoleArn" => RoleArn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_health_check(health_check_arn, protection_id)
    associate_health_check(health_check_arn, protection_id, params::Dict{String,<:Any})

Adds health-based detection to the Shield Advanced protection for a resource. Shield
Advanced health-based detection uses the health of your Amazon Web Services resource to
improve responsiveness and accuracy in attack detection and response.  You define the
health check in Route 53 and then associate it with your Shield Advanced protection. For
more information, see Shield Advanced Health-Based Detection in the WAF Developer Guide.

# Arguments
- `health_check_arn`: The Amazon Resource Name (ARN) of the health check to associate with
  the protection.
- `protection_id`: The unique identifier (ID) for the Protection object to add the health
  check association to.

"""
function associate_health_check(
    HealthCheckArn, ProtectionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return shield(
        "AssociateHealthCheck",
        Dict{String,Any}(
            "HealthCheckArn" => HealthCheckArn, "ProtectionId" => ProtectionId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_health_check(
    HealthCheckArn,
    ProtectionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return shield(
        "AssociateHealthCheck",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "HealthCheckArn" => HealthCheckArn, "ProtectionId" => ProtectionId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_proactive_engagement_details(emergency_contact_list)
    associate_proactive_engagement_details(emergency_contact_list, params::Dict{String,<:Any})

Initializes proactive engagement and sets the list of contacts for the Shield Response Team
(SRT) to use. You must provide at least one phone number in the emergency contact list.
After you have initialized proactive engagement using this call, to disable or enable
proactive engagement, use the calls DisableProactiveEngagement and
EnableProactiveEngagement.   This call defines the list of email addresses and phone
numbers that the SRT can use to contact you for escalations to the SRT and to initiate
proactive customer support. The contacts that you provide in the request replace any
contacts that were already defined. If you already have contacts defined and want to use
them, retrieve the list using DescribeEmergencyContactSettings and then provide it to this
call.

# Arguments
- `emergency_contact_list`: A list of email addresses and phone numbers that the Shield
  Response Team (SRT) can use to contact you for escalations to the SRT and to initiate
  proactive customer support.  To enable proactive engagement, the contact list must include
  at least one phone number.  The contacts that you provide here replace any contacts that
  were already defined. If you already have contacts defined and want to use them, retrieve
  the list using DescribeEmergencyContactSettings and then provide it here.

"""
function associate_proactive_engagement_details(
    EmergencyContactList; aws_config::AbstractAWSConfig=current_aws_config()
)
    return shield(
        "AssociateProactiveEngagementDetails",
        Dict{String,Any}("EmergencyContactList" => EmergencyContactList);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_proactive_engagement_details(
    EmergencyContactList,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return shield(
        "AssociateProactiveEngagementDetails",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("EmergencyContactList" => EmergencyContactList),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_protection(name, resource_arn)
    create_protection(name, resource_arn, params::Dict{String,<:Any})

Enables Shield Advanced for a specific Amazon Web Services resource. The resource can be an
Amazon CloudFront distribution, Amazon Route 53 hosted zone, Global Accelerator standard
accelerator, Elastic IP Address, Application Load Balancer, or a Classic Load Balancer. You
can protect Amazon EC2 instances and Network Load Balancers by association with protected
Amazon EC2 Elastic IP addresses. You can add protection to only a single resource with each
CreateProtection request. You can add protection to multiple resources at once through the
Shield Advanced console at https://console.aws.amazon.com/wafv2/shieldv2#/. For more
information see Getting Started with Shield Advanced and Adding Shield Advanced protection
to Amazon Web Services resources.

# Arguments
- `name`: Friendly name for the Protection you are creating.
- `resource_arn`: The ARN (Amazon Resource Name) of the resource to be protected. The ARN
  should be in one of the following formats:   For an Application Load Balancer:
  arn:aws:elasticloadbalancing:region:account-id:loadbalancer/app/load-balancer-name/load-bala
  ncer-id     For an Elastic Load Balancer (Classic Load Balancer):
  arn:aws:elasticloadbalancing:region:account-id:loadbalancer/load-balancer-name     For an
  Amazon CloudFront distribution: arn:aws:cloudfront::account-id:distribution/distribution-id
      For an Global Accelerator standard accelerator:
  arn:aws:globalaccelerator::account-id:accelerator/accelerator-id     For Amazon Route 53:
  arn:aws:route53:::hostedzone/hosted-zone-id     For an Elastic IP address:
  arn:aws:ec2:region:account-id:eip-allocation/allocation-id

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: One or more tag key-value pairs for the Protection object that is created.
"""
function create_protection(
    Name, ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return shield(
        "CreateProtection",
        Dict{String,Any}("Name" => Name, "ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_protection(
    Name,
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return shield(
        "CreateProtection",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Name" => Name, "ResourceArn" => ResourceArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_protection_group(aggregation, pattern, protection_group_id)
    create_protection_group(aggregation, pattern, protection_group_id, params::Dict{String,<:Any})

Creates a grouping of protected resources so they can be handled as a collective. This
resource grouping improves the accuracy of detection and reduces false positives.

# Arguments
- `aggregation`: Defines how Shield combines resource data for the group in order to
  detect, mitigate, and report events.   Sum - Use the total traffic across the group. This
  is a good choice for most cases. Examples include Elastic IP addresses for EC2 instances
  that scale manually or automatically.   Mean - Use the average of the traffic across the
  group. This is a good choice for resources that share traffic uniformly. Examples include
  accelerators and load balancers.   Max - Use the highest traffic from each resource. This
  is useful for resources that don't share traffic and for resources that share that traffic
  in a non-uniform way. Examples include Amazon CloudFront and origin resources for
  CloudFront distributions.
- `pattern`: The criteria to use to choose the protected resources for inclusion in the
  group. You can include all resources that have protections, provide a list of resource
  Amazon Resource Names (ARNs), or include all resources of a specified resource type.
- `protection_group_id`: The name of the protection group. You use this to identify the
  protection group in lists and to manage the protection group, for example to update,
  delete, or describe it.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Members"`: The Amazon Resource Names (ARNs) of the resources to include in the
  protection group. You must set this when you set Pattern to ARBITRARY and you must not set
  it for any other Pattern setting.
- `"ResourceType"`: The resource type to include in the protection group. All protected
  resources of this type are included in the protection group. Newly protected resources of
  this type are automatically added to the group. You must set this when you set Pattern to
  BY_RESOURCE_TYPE and you must not set it for any other Pattern setting.
- `"Tags"`: One or more tag key-value pairs for the protection group.
"""
function create_protection_group(
    Aggregation,
    Pattern,
    ProtectionGroupId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return shield(
        "CreateProtectionGroup",
        Dict{String,Any}(
            "Aggregation" => Aggregation,
            "Pattern" => Pattern,
            "ProtectionGroupId" => ProtectionGroupId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_protection_group(
    Aggregation,
    Pattern,
    ProtectionGroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return shield(
        "CreateProtectionGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Aggregation" => Aggregation,
                    "Pattern" => Pattern,
                    "ProtectionGroupId" => ProtectionGroupId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_subscription()
    create_subscription(params::Dict{String,<:Any})

Activates Shield Advanced for an account.  For accounts that are members of an
Organizations organization, Shield Advanced subscriptions are billed against the
organization's payer account, regardless of whether the payer account itself is subscribed.
  When you initially create a subscription, your subscription is set to be automatically
renewed at the end of the existing subscription period. You can change this by submitting
an UpdateSubscription request.

"""
function create_subscription(; aws_config::AbstractAWSConfig=current_aws_config())
    return shield(
        "CreateSubscription"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function create_subscription(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return shield(
        "CreateSubscription", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    delete_protection(protection_id)
    delete_protection(protection_id, params::Dict{String,<:Any})

Deletes an Shield Advanced Protection.

# Arguments
- `protection_id`: The unique identifier (ID) for the Protection object to be deleted.

"""
function delete_protection(ProtectionId; aws_config::AbstractAWSConfig=current_aws_config())
    return shield(
        "DeleteProtection",
        Dict{String,Any}("ProtectionId" => ProtectionId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_protection(
    ProtectionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return shield(
        "DeleteProtection",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ProtectionId" => ProtectionId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_protection_group(protection_group_id)
    delete_protection_group(protection_group_id, params::Dict{String,<:Any})

Removes the specified protection group.

# Arguments
- `protection_group_id`: The name of the protection group. You use this to identify the
  protection group in lists and to manage the protection group, for example to update,
  delete, or describe it.

"""
function delete_protection_group(
    ProtectionGroupId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return shield(
        "DeleteProtectionGroup",
        Dict{String,Any}("ProtectionGroupId" => ProtectionGroupId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_protection_group(
    ProtectionGroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return shield(
        "DeleteProtectionGroup",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ProtectionGroupId" => ProtectionGroupId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_subscription()
    delete_subscription(params::Dict{String,<:Any})

Removes Shield Advanced from an account. Shield Advanced requires a 1-year subscription
commitment. You cannot delete a subscription prior to the completion of that commitment.

"""
function delete_subscription(; aws_config::AbstractAWSConfig=current_aws_config())
    return shield(
        "DeleteSubscription"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function delete_subscription(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return shield(
        "DeleteSubscription", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_attack(attack_id)
    describe_attack(attack_id, params::Dict{String,<:Any})

Describes the details of a DDoS attack.

# Arguments
- `attack_id`: The unique identifier (ID) for the attack.

"""
function describe_attack(AttackId; aws_config::AbstractAWSConfig=current_aws_config())
    return shield(
        "DescribeAttack",
        Dict{String,Any}("AttackId" => AttackId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_attack(
    AttackId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return shield(
        "DescribeAttack",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AttackId" => AttackId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_attack_statistics()
    describe_attack_statistics(params::Dict{String,<:Any})

Provides information about the number and type of attacks Shield has detected in the last
year for all resources that belong to your account, regardless of whether you've defined
Shield protections for them. This operation is available to Shield customers as well as to
Shield Advanced customers. The operation returns data for the time range of midnight UTC,
one year ago, to midnight UTC, today. For example, if the current time is 2020-10-26
15:39:32 PDT, equal to 2020-10-26 22:39:32 UTC, then the time range for the attack data
returned is from 2019-10-26 00:00:00 UTC to 2020-10-26 00:00:00 UTC.  The time range
indicates the period covered by the attack statistics data items.

"""
function describe_attack_statistics(; aws_config::AbstractAWSConfig=current_aws_config())
    return shield(
        "DescribeAttackStatistics"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_attack_statistics(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return shield(
        "DescribeAttackStatistics",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_drtaccess()
    describe_drtaccess(params::Dict{String,<:Any})

Returns the current role and list of Amazon S3 log buckets used by the Shield Response Team
(SRT) to access your Amazon Web Services account while assisting with attack mitigation.

"""
function describe_drtaccess(; aws_config::AbstractAWSConfig=current_aws_config())
    return shield(
        "DescribeDRTAccess"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_drtaccess(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return shield(
        "DescribeDRTAccess", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_emergency_contact_settings()
    describe_emergency_contact_settings(params::Dict{String,<:Any})

A list of email addresses and phone numbers that the Shield Response Team (SRT) can use to
contact you if you have proactive engagement enabled, for escalations to the SRT and to
initiate proactive customer support.

"""
function describe_emergency_contact_settings(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return shield(
        "DescribeEmergencyContactSettings";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_emergency_contact_settings(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return shield(
        "DescribeEmergencyContactSettings",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_protection()
    describe_protection(params::Dict{String,<:Any})

Lists the details of a Protection object.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ProtectionId"`: The unique identifier (ID) for the Protection object to describe. You
  must provide either the ResourceArn of the protected resource or the ProtectionID of the
  protection, but not both.
- `"ResourceArn"`: The ARN (Amazon Resource Name) of the protected Amazon Web Services
  resource. You must provide either the ResourceArn of the protected resource or the
  ProtectionID of the protection, but not both.
"""
function describe_protection(; aws_config::AbstractAWSConfig=current_aws_config())
    return shield(
        "DescribeProtection"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_protection(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return shield(
        "DescribeProtection", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_protection_group(protection_group_id)
    describe_protection_group(protection_group_id, params::Dict{String,<:Any})

Returns the specification for the specified protection group.

# Arguments
- `protection_group_id`: The name of the protection group. You use this to identify the
  protection group in lists and to manage the protection group, for example to update,
  delete, or describe it.

"""
function describe_protection_group(
    ProtectionGroupId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return shield(
        "DescribeProtectionGroup",
        Dict{String,Any}("ProtectionGroupId" => ProtectionGroupId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_protection_group(
    ProtectionGroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return shield(
        "DescribeProtectionGroup",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ProtectionGroupId" => ProtectionGroupId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_subscription()
    describe_subscription(params::Dict{String,<:Any})

Provides details about the Shield Advanced subscription for an account.

"""
function describe_subscription(; aws_config::AbstractAWSConfig=current_aws_config())
    return shield(
        "DescribeSubscription"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_subscription(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return shield(
        "DescribeSubscription",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disable_application_layer_automatic_response(resource_arn)
    disable_application_layer_automatic_response(resource_arn, params::Dict{String,<:Any})

Disable the Shield Advanced automatic application layer DDoS mitigation feature for the
protected resource. This stops Shield Advanced from creating, verifying, and applying WAF
rules for attacks that it detects for the resource.

# Arguments
- `resource_arn`: The ARN (Amazon Resource Name) of the protected resource.

"""
function disable_application_layer_automatic_response(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return shield(
        "DisableApplicationLayerAutomaticResponse",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disable_application_layer_automatic_response(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return shield(
        "DisableApplicationLayerAutomaticResponse",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disable_proactive_engagement()
    disable_proactive_engagement(params::Dict{String,<:Any})

Removes authorization from the Shield Response Team (SRT) to notify contacts about
escalations to the SRT and to initiate proactive customer support.

"""
function disable_proactive_engagement(; aws_config::AbstractAWSConfig=current_aws_config())
    return shield(
        "DisableProactiveEngagement"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function disable_proactive_engagement(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return shield(
        "DisableProactiveEngagement",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_drtlog_bucket(log_bucket)
    disassociate_drtlog_bucket(log_bucket, params::Dict{String,<:Any})

Removes the Shield Response Team's (SRT) access to the specified Amazon S3 bucket
containing the logs that you shared previously.

# Arguments
- `log_bucket`: The Amazon S3 bucket that contains the logs that you want to share.

"""
function disassociate_drtlog_bucket(
    LogBucket; aws_config::AbstractAWSConfig=current_aws_config()
)
    return shield(
        "DisassociateDRTLogBucket",
        Dict{String,Any}("LogBucket" => LogBucket);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_drtlog_bucket(
    LogBucket,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return shield(
        "DisassociateDRTLogBucket",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("LogBucket" => LogBucket), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_drtrole()
    disassociate_drtrole(params::Dict{String,<:Any})

Removes the Shield Response Team's (SRT) access to your Amazon Web Services account.

"""
function disassociate_drtrole(; aws_config::AbstractAWSConfig=current_aws_config())
    return shield(
        "DisassociateDRTRole"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function disassociate_drtrole(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return shield(
        "DisassociateDRTRole",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_health_check(health_check_arn, protection_id)
    disassociate_health_check(health_check_arn, protection_id, params::Dict{String,<:Any})

Removes health-based detection from the Shield Advanced protection for a resource. Shield
Advanced health-based detection uses the health of your Amazon Web Services resource to
improve responsiveness and accuracy in attack detection and response.  You define the
health check in Route 53 and then associate or disassociate it with your Shield Advanced
protection. For more information, see Shield Advanced Health-Based Detection in the WAF
Developer Guide.

# Arguments
- `health_check_arn`: The Amazon Resource Name (ARN) of the health check that is associated
  with the protection.
- `protection_id`: The unique identifier (ID) for the Protection object to remove the
  health check association from.

"""
function disassociate_health_check(
    HealthCheckArn, ProtectionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return shield(
        "DisassociateHealthCheck",
        Dict{String,Any}(
            "HealthCheckArn" => HealthCheckArn, "ProtectionId" => ProtectionId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_health_check(
    HealthCheckArn,
    ProtectionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return shield(
        "DisassociateHealthCheck",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "HealthCheckArn" => HealthCheckArn, "ProtectionId" => ProtectionId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    enable_application_layer_automatic_response(action, resource_arn)
    enable_application_layer_automatic_response(action, resource_arn, params::Dict{String,<:Any})

Enable the Shield Advanced automatic application layer DDoS mitigation for the protected
resource.   This feature is available for Amazon CloudFront distributions and Application
Load Balancers only.  This causes Shield Advanced to create, verify, and apply WAF rules
for DDoS attacks that it detects for the resource. Shield Advanced applies the rules in a
Shield rule group inside the web ACL that you've associated with the resource. For
information about how automatic mitigation works and the requirements for using it, see
Shield Advanced automatic application layer DDoS mitigation.  Don't use this action to make
changes to automatic mitigation settings when it's already enabled for a resource. Instead,
use UpdateApplicationLayerAutomaticResponse.  To use this feature, you must associate a web
ACL with the protected resource. The web ACL must be created using the latest version of
WAF (v2). You can associate the web ACL through the Shield Advanced console at
https://console.aws.amazon.com/wafv2/shieldv2#/. For more information, see Getting Started
with Shield Advanced. You can also associate the web ACL to the resource through the WAF
console or the WAF API, but you must manage Shield Advanced automatic mitigation through
Shield Advanced. For information about WAF, see WAF Developer Guide.

# Arguments
- `action`: Specifies the action setting that Shield Advanced should use in the WAF rules
  that it creates on behalf of the protected resource in response to DDoS attacks. You
  specify this as part of the configuration for the automatic application layer DDoS
  mitigation feature, when you enable or update automatic mitigation. Shield Advanced creates
  the WAF rules in a Shield Advanced-managed rule group, inside the web ACL that you have
  associated with the resource.
- `resource_arn`: The ARN (Amazon Resource Name) of the protected resource.

"""
function enable_application_layer_automatic_response(
    Action, ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return shield(
        "EnableApplicationLayerAutomaticResponse",
        Dict{String,Any}("Action" => Action, "ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function enable_application_layer_automatic_response(
    Action,
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return shield(
        "EnableApplicationLayerAutomaticResponse",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Action" => Action, "ResourceArn" => ResourceArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    enable_proactive_engagement()
    enable_proactive_engagement(params::Dict{String,<:Any})

Authorizes the Shield Response Team (SRT) to use email and phone to notify contacts about
escalations to the SRT and to initiate proactive customer support.

"""
function enable_proactive_engagement(; aws_config::AbstractAWSConfig=current_aws_config())
    return shield(
        "EnableProactiveEngagement"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function enable_proactive_engagement(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return shield(
        "EnableProactiveEngagement",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_subscription_state()
    get_subscription_state(params::Dict{String,<:Any})

Returns the SubscriptionState, either Active or Inactive.

"""
function get_subscription_state(; aws_config::AbstractAWSConfig=current_aws_config())
    return shield(
        "GetSubscriptionState"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_subscription_state(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return shield(
        "GetSubscriptionState",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_attacks()
    list_attacks(params::Dict{String,<:Any})

Returns all ongoing DDoS attacks or all DDoS attacks during a specified time period.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EndTime"`: The end of the time period for the attacks. This is a timestamp type. The
  request syntax listing for this call indicates a number type, but you can provide the time
  in any valid timestamp format setting.
- `"MaxResults"`: The greatest number of objects that you want Shield Advanced to return to
  the list request. Shield Advanced might return fewer objects than you indicate in this
  setting, even if more objects are available. If there are more objects remaining, Shield
  Advanced will always also return a NextToken value in the response. The default setting is
  20.
- `"NextToken"`: When you request a list of objects from Shield Advanced, if the response
  does not include all of the remaining available objects, Shield Advanced includes a
  NextToken value in the response. You can retrieve the next batch of objects by requesting
  the list again and providing the token that was returned by the prior call in your request.
   You can indicate the maximum number of objects that you want Shield Advanced to return for
  a single call with the MaxResults setting. Shield Advanced will not return more than
  MaxResults objects, but may return fewer, even if more objects are still available.
  Whenever more objects remain that Shield Advanced has not yet returned to you, the response
  will include a NextToken value. On your first call to a list operation, leave this setting
  empty.
- `"ResourceArns"`: The ARNs (Amazon Resource Names) of the resources that were attacked.
  If you leave this blank, all applicable resources for this account will be included.
- `"StartTime"`: The start of the time period for the attacks. This is a timestamp type.
  The request syntax listing for this call indicates a number type, but you can provide the
  time in any valid timestamp format setting.
"""
function list_attacks(; aws_config::AbstractAWSConfig=current_aws_config())
    return shield("ListAttacks"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_attacks(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return shield(
        "ListAttacks", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_protection_groups()
    list_protection_groups(params::Dict{String,<:Any})

Retrieves ProtectionGroup objects for the account. You can retrieve all protection groups
or you can provide filtering criteria and retrieve just the subset of protection groups
that match the criteria.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"InclusionFilters"`: Narrows the set of protection groups that the call retrieves. You
  can retrieve a single protection group by its name and you can retrieve all protection
  groups that are configured with specific pattern or aggregation settings. You can provide
  up to one criteria per filter type. Shield Advanced returns the protection groups that
  exactly match all of the search criteria that you provide.
- `"MaxResults"`: The greatest number of objects that you want Shield Advanced to return to
  the list request. Shield Advanced might return fewer objects than you indicate in this
  setting, even if more objects are available. If there are more objects remaining, Shield
  Advanced will always also return a NextToken value in the response. The default setting is
  20.
- `"NextToken"`: When you request a list of objects from Shield Advanced, if the response
  does not include all of the remaining available objects, Shield Advanced includes a
  NextToken value in the response. You can retrieve the next batch of objects by requesting
  the list again and providing the token that was returned by the prior call in your request.
   You can indicate the maximum number of objects that you want Shield Advanced to return for
  a single call with the MaxResults setting. Shield Advanced will not return more than
  MaxResults objects, but may return fewer, even if more objects are still available.
  Whenever more objects remain that Shield Advanced has not yet returned to you, the response
  will include a NextToken value. On your first call to a list operation, leave this setting
  empty.
"""
function list_protection_groups(; aws_config::AbstractAWSConfig=current_aws_config())
    return shield(
        "ListProtectionGroups"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_protection_groups(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return shield(
        "ListProtectionGroups",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_protections()
    list_protections(params::Dict{String,<:Any})

Retrieves Protection objects for the account. You can retrieve all protections or you can
provide filtering criteria and retrieve just the subset of protections that match the
criteria.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"InclusionFilters"`: Narrows the set of protections that the call retrieves. You can
  retrieve a single protection by providing its name or the ARN (Amazon Resource Name) of its
  protected resource. You can also retrieve all protections for a specific resource type. You
  can provide up to one criteria per filter type. Shield Advanced returns protections that
  exactly match all of the filter criteria that you provide.
- `"MaxResults"`: The greatest number of objects that you want Shield Advanced to return to
  the list request. Shield Advanced might return fewer objects than you indicate in this
  setting, even if more objects are available. If there are more objects remaining, Shield
  Advanced will always also return a NextToken value in the response. The default setting is
  20.
- `"NextToken"`: When you request a list of objects from Shield Advanced, if the response
  does not include all of the remaining available objects, Shield Advanced includes a
  NextToken value in the response. You can retrieve the next batch of objects by requesting
  the list again and providing the token that was returned by the prior call in your request.
   You can indicate the maximum number of objects that you want Shield Advanced to return for
  a single call with the MaxResults setting. Shield Advanced will not return more than
  MaxResults objects, but may return fewer, even if more objects are still available.
  Whenever more objects remain that Shield Advanced has not yet returned to you, the response
  will include a NextToken value. On your first call to a list operation, leave this setting
  empty.
"""
function list_protections(; aws_config::AbstractAWSConfig=current_aws_config())
    return shield("ListProtections"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_protections(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return shield(
        "ListProtections", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_resources_in_protection_group(protection_group_id)
    list_resources_in_protection_group(protection_group_id, params::Dict{String,<:Any})

Retrieves the resources that are included in the protection group.

# Arguments
- `protection_group_id`: The name of the protection group. You use this to identify the
  protection group in lists and to manage the protection group, for example to update,
  delete, or describe it.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The greatest number of objects that you want Shield Advanced to return to
  the list request. Shield Advanced might return fewer objects than you indicate in this
  setting, even if more objects are available. If there are more objects remaining, Shield
  Advanced will always also return a NextToken value in the response. The default setting is
  20.
- `"NextToken"`: When you request a list of objects from Shield Advanced, if the response
  does not include all of the remaining available objects, Shield Advanced includes a
  NextToken value in the response. You can retrieve the next batch of objects by requesting
  the list again and providing the token that was returned by the prior call in your request.
   You can indicate the maximum number of objects that you want Shield Advanced to return for
  a single call with the MaxResults setting. Shield Advanced will not return more than
  MaxResults objects, but may return fewer, even if more objects are still available.
  Whenever more objects remain that Shield Advanced has not yet returned to you, the response
  will include a NextToken value. On your first call to a list operation, leave this setting
  empty.
"""
function list_resources_in_protection_group(
    ProtectionGroupId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return shield(
        "ListResourcesInProtectionGroup",
        Dict{String,Any}("ProtectionGroupId" => ProtectionGroupId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_resources_in_protection_group(
    ProtectionGroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return shield(
        "ListResourcesInProtectionGroup",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ProtectionGroupId" => ProtectionGroupId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Gets information about Amazon Web Services tags for a specified Amazon Resource Name (ARN)
in Shield.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource to get tags for.

"""
function list_tags_for_resource(
    ResourceARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return shield(
        "ListTagsForResource",
        Dict{String,Any}("ResourceARN" => ResourceARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return shield(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceARN" => ResourceARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds or updates tags for a resource in Shield.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource that you want to add or
  update tags for.
- `tags`: The tags that you want to modify or add to the resource.

"""
function tag_resource(ResourceARN, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return shield(
        "TagResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceARN,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return shield(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes tags from a resource in Shield.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource that you want to remove
  tags from.
- `tag_keys`: The tag key for each tag that you want to remove from the resource.

"""
function untag_resource(
    ResourceARN, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return shield(
        "UntagResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceARN,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return shield(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_application_layer_automatic_response(action, resource_arn)
    update_application_layer_automatic_response(action, resource_arn, params::Dict{String,<:Any})

Updates an existing Shield Advanced automatic application layer DDoS mitigation
configuration for the specified resource.

# Arguments
- `action`: Specifies the action setting that Shield Advanced should use in the WAF rules
  that it creates on behalf of the protected resource in response to DDoS attacks. You
  specify this as part of the configuration for the automatic application layer DDoS
  mitigation feature, when you enable or update automatic mitigation. Shield Advanced creates
  the WAF rules in a Shield Advanced-managed rule group, inside the web ACL that you have
  associated with the resource.
- `resource_arn`: The ARN (Amazon Resource Name) of the resource.

"""
function update_application_layer_automatic_response(
    Action, ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return shield(
        "UpdateApplicationLayerAutomaticResponse",
        Dict{String,Any}("Action" => Action, "ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_application_layer_automatic_response(
    Action,
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return shield(
        "UpdateApplicationLayerAutomaticResponse",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Action" => Action, "ResourceArn" => ResourceArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_emergency_contact_settings()
    update_emergency_contact_settings(params::Dict{String,<:Any})

Updates the details of the list of email addresses and phone numbers that the Shield
Response Team (SRT) can use to contact you if you have proactive engagement enabled, for
escalations to the SRT and to initiate proactive customer support.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EmergencyContactList"`: A list of email addresses and phone numbers that the Shield
  Response Team (SRT) can use to contact you if you have proactive engagement enabled, for
  escalations to the SRT and to initiate proactive customer support. If you have proactive
  engagement enabled, the contact list must include at least one phone number.
"""
function update_emergency_contact_settings(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return shield(
        "UpdateEmergencyContactSettings";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_emergency_contact_settings(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return shield(
        "UpdateEmergencyContactSettings",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_protection_group(aggregation, pattern, protection_group_id)
    update_protection_group(aggregation, pattern, protection_group_id, params::Dict{String,<:Any})

Updates an existing protection group. A protection group is a grouping of protected
resources so they can be handled as a collective. This resource grouping improves the
accuracy of detection and reduces false positives.

# Arguments
- `aggregation`: Defines how Shield combines resource data for the group in order to
  detect, mitigate, and report events.   Sum - Use the total traffic across the group. This
  is a good choice for most cases. Examples include Elastic IP addresses for EC2 instances
  that scale manually or automatically.   Mean - Use the average of the traffic across the
  group. This is a good choice for resources that share traffic uniformly. Examples include
  accelerators and load balancers.   Max - Use the highest traffic from each resource. This
  is useful for resources that don't share traffic and for resources that share that traffic
  in a non-uniform way. Examples include Amazon CloudFront distributions and origin resources
  for CloudFront distributions.
- `pattern`: The criteria to use to choose the protected resources for inclusion in the
  group. You can include all resources that have protections, provide a list of resource
  Amazon Resource Names (ARNs), or include all resources of a specified resource type.
- `protection_group_id`: The name of the protection group. You use this to identify the
  protection group in lists and to manage the protection group, for example to update,
  delete, or describe it.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Members"`: The Amazon Resource Names (ARNs) of the resources to include in the
  protection group. You must set this when you set Pattern to ARBITRARY and you must not set
  it for any other Pattern setting.
- `"ResourceType"`: The resource type to include in the protection group. All protected
  resources of this type are included in the protection group. You must set this when you set
  Pattern to BY_RESOURCE_TYPE and you must not set it for any other Pattern setting.
"""
function update_protection_group(
    Aggregation,
    Pattern,
    ProtectionGroupId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return shield(
        "UpdateProtectionGroup",
        Dict{String,Any}(
            "Aggregation" => Aggregation,
            "Pattern" => Pattern,
            "ProtectionGroupId" => ProtectionGroupId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_protection_group(
    Aggregation,
    Pattern,
    ProtectionGroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return shield(
        "UpdateProtectionGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Aggregation" => Aggregation,
                    "Pattern" => Pattern,
                    "ProtectionGroupId" => ProtectionGroupId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_subscription()
    update_subscription(params::Dict{String,<:Any})

Updates the details of an existing subscription. Only enter values for parameters you want
to change. Empty parameters are not updated.  For accounts that are members of an
Organizations organization, Shield Advanced subscriptions are billed against the
organization's payer account, regardless of whether the payer account itself is subscribed.


# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AutoRenew"`: When you initally create a subscription, AutoRenew is set to ENABLED. If
  ENABLED, the subscription will be automatically renewed at the end of the existing
  subscription period. You can change this by submitting an UpdateSubscription request. If
  the UpdateSubscription request does not included a value for AutoRenew, the existing value
  for AutoRenew remains unchanged.
"""
function update_subscription(; aws_config::AbstractAWSConfig=current_aws_config())
    return shield(
        "UpdateSubscription"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function update_subscription(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return shield(
        "UpdateSubscription", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: schemas
using AWS.Compat
using AWS.UUIDs

"""
    create_discoverer(source_arn)
    create_discoverer(source_arn, params::Dict{String,<:Any})

Creates a discoverer.

# Arguments
- `source_arn`: The ARN of the event bus.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CrossAccount"`: Support discovery of schemas in events sent to the bus from another
  account. (default: true).
- `"Description"`: A description for the discoverer.
- `"tags"`: Tags associated with the resource.
"""
function create_discoverer(SourceArn; aws_config::AbstractAWSConfig=current_aws_config())
    return schemas(
        "POST",
        "/v1/discoverers",
        Dict{String,Any}("SourceArn" => SourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_discoverer(
    SourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return schemas(
        "POST",
        "/v1/discoverers",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("SourceArn" => SourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_registry(registry_name)
    create_registry(registry_name, params::Dict{String,<:Any})

Creates a registry.

# Arguments
- `registry_name`: The name of the registry.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description of the registry to be created.
- `"tags"`: Tags to associate with the registry.
"""
function create_registry(registryName; aws_config::AbstractAWSConfig=current_aws_config())
    return schemas(
        "POST",
        "/v1/registries/name/$(registryName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_registry(
    registryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return schemas(
        "POST",
        "/v1/registries/name/$(registryName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_schema(content, type, registry_name, schema_name)
    create_schema(content, type, registry_name, schema_name, params::Dict{String,<:Any})

Creates a schema definition. Inactive schemas will be deleted after two years.

# Arguments
- `content`: The source of the schema definition.
- `type`: The type of schema.
- `registry_name`: The name of the registry.
- `schema_name`: The name of the schema.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description of the schema.
- `"tags"`: Tags associated with the schema.
"""
function create_schema(
    Content,
    Type,
    registryName,
    schemaName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return schemas(
        "POST",
        "/v1/registries/name/$(registryName)/schemas/name/$(schemaName)",
        Dict{String,Any}("Content" => Content, "Type" => Type);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_schema(
    Content,
    Type,
    registryName,
    schemaName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return schemas(
        "POST",
        "/v1/registries/name/$(registryName)/schemas/name/$(schemaName)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("Content" => Content, "Type" => Type), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_discoverer(discoverer_id)
    delete_discoverer(discoverer_id, params::Dict{String,<:Any})

Deletes a discoverer.

# Arguments
- `discoverer_id`: The ID of the discoverer.

"""
function delete_discoverer(discovererId; aws_config::AbstractAWSConfig=current_aws_config())
    return schemas(
        "DELETE",
        "/v1/discoverers/id/$(discovererId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_discoverer(
    discovererId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return schemas(
        "DELETE",
        "/v1/discoverers/id/$(discovererId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_registry(registry_name)
    delete_registry(registry_name, params::Dict{String,<:Any})

Deletes a Registry.

# Arguments
- `registry_name`: The name of the registry.

"""
function delete_registry(registryName; aws_config::AbstractAWSConfig=current_aws_config())
    return schemas(
        "DELETE",
        "/v1/registries/name/$(registryName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_registry(
    registryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return schemas(
        "DELETE",
        "/v1/registries/name/$(registryName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_resource_policy()
    delete_resource_policy(params::Dict{String,<:Any})

Delete the resource-based policy attached to the specified registry.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"registryName"`: The name of the registry.
"""
function delete_resource_policy(; aws_config::AbstractAWSConfig=current_aws_config())
    return schemas(
        "DELETE", "/v1/policy"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function delete_resource_policy(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return schemas(
        "DELETE",
        "/v1/policy",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_schema(registry_name, schema_name)
    delete_schema(registry_name, schema_name, params::Dict{String,<:Any})

Delete a schema definition.

# Arguments
- `registry_name`: The name of the registry.
- `schema_name`: The name of the schema.

"""
function delete_schema(
    registryName, schemaName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return schemas(
        "DELETE",
        "/v1/registries/name/$(registryName)/schemas/name/$(schemaName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_schema(
    registryName,
    schemaName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return schemas(
        "DELETE",
        "/v1/registries/name/$(registryName)/schemas/name/$(schemaName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_schema_version(registry_name, schema_name, schema_version)
    delete_schema_version(registry_name, schema_name, schema_version, params::Dict{String,<:Any})

Delete the schema version definition

# Arguments
- `registry_name`: The name of the registry.
- `schema_name`: The name of the schema.
- `schema_version`: The version number of the schema

"""
function delete_schema_version(
    registryName,
    schemaName,
    schemaVersion;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return schemas(
        "DELETE",
        "/v1/registries/name/$(registryName)/schemas/name/$(schemaName)/version/$(schemaVersion)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_schema_version(
    registryName,
    schemaName,
    schemaVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return schemas(
        "DELETE",
        "/v1/registries/name/$(registryName)/schemas/name/$(schemaName)/version/$(schemaVersion)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_code_binding(language, registry_name, schema_name)
    describe_code_binding(language, registry_name, schema_name, params::Dict{String,<:Any})

Describe the code binding URI.

# Arguments
- `language`: The language of the code binding.
- `registry_name`: The name of the registry.
- `schema_name`: The name of the schema.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"schemaVersion"`: Specifying this limits the results to only this schema version.
"""
function describe_code_binding(
    language, registryName, schemaName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return schemas(
        "GET",
        "/v1/registries/name/$(registryName)/schemas/name/$(schemaName)/language/$(language)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_code_binding(
    language,
    registryName,
    schemaName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return schemas(
        "GET",
        "/v1/registries/name/$(registryName)/schemas/name/$(schemaName)/language/$(language)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_discoverer(discoverer_id)
    describe_discoverer(discoverer_id, params::Dict{String,<:Any})

Describes the discoverer.

# Arguments
- `discoverer_id`: The ID of the discoverer.

"""
function describe_discoverer(
    discovererId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return schemas(
        "GET",
        "/v1/discoverers/id/$(discovererId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_discoverer(
    discovererId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return schemas(
        "GET",
        "/v1/discoverers/id/$(discovererId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_registry(registry_name)
    describe_registry(registry_name, params::Dict{String,<:Any})

Describes the registry.

# Arguments
- `registry_name`: The name of the registry.

"""
function describe_registry(registryName; aws_config::AbstractAWSConfig=current_aws_config())
    return schemas(
        "GET",
        "/v1/registries/name/$(registryName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_registry(
    registryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return schemas(
        "GET",
        "/v1/registries/name/$(registryName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_schema(registry_name, schema_name)
    describe_schema(registry_name, schema_name, params::Dict{String,<:Any})

Retrieve the schema definition.

# Arguments
- `registry_name`: The name of the registry.
- `schema_name`: The name of the schema.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"schemaVersion"`: Specifying this limits the results to only this schema version.
"""
function describe_schema(
    registryName, schemaName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return schemas(
        "GET",
        "/v1/registries/name/$(registryName)/schemas/name/$(schemaName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_schema(
    registryName,
    schemaName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return schemas(
        "GET",
        "/v1/registries/name/$(registryName)/schemas/name/$(schemaName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    export_schema(registry_name, schema_name, type)
    export_schema(registry_name, schema_name, type, params::Dict{String,<:Any})



# Arguments
- `registry_name`: The name of the registry.
- `schema_name`: The name of the schema.
- `type`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"schemaVersion"`: Specifying this limits the results to only this schema version.
"""
function export_schema(
    registryName, schemaName, type; aws_config::AbstractAWSConfig=current_aws_config()
)
    return schemas(
        "GET",
        "/v1/registries/name/$(registryName)/schemas/name/$(schemaName)/export",
        Dict{String,Any}("type" => type);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function export_schema(
    registryName,
    schemaName,
    type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return schemas(
        "GET",
        "/v1/registries/name/$(registryName)/schemas/name/$(schemaName)/export",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("type" => type), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_code_binding_source(language, registry_name, schema_name)
    get_code_binding_source(language, registry_name, schema_name, params::Dict{String,<:Any})

Get the code binding source URI.

# Arguments
- `language`: The language of the code binding.
- `registry_name`: The name of the registry.
- `schema_name`: The name of the schema.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"schemaVersion"`: Specifying this limits the results to only this schema version.
"""
function get_code_binding_source(
    language, registryName, schemaName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return schemas(
        "GET",
        "/v1/registries/name/$(registryName)/schemas/name/$(schemaName)/language/$(language)/source";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_code_binding_source(
    language,
    registryName,
    schemaName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return schemas(
        "GET",
        "/v1/registries/name/$(registryName)/schemas/name/$(schemaName)/language/$(language)/source",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_discovered_schema(events, type)
    get_discovered_schema(events, type, params::Dict{String,<:Any})

Get the discovered schema that was generated based on sampled events.

# Arguments
- `events`: An array of strings where each string is a JSON event. These are the events
  that were used to generate the schema. The array includes a single type of event and has a
  maximum size of 10 events.
- `type`: The type of event.

"""
function get_discovered_schema(
    Events, Type; aws_config::AbstractAWSConfig=current_aws_config()
)
    return schemas(
        "POST",
        "/v1/discover",
        Dict{String,Any}("Events" => Events, "Type" => Type);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_discovered_schema(
    Events,
    Type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return schemas(
        "POST",
        "/v1/discover",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Events" => Events, "Type" => Type), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_resource_policy()
    get_resource_policy(params::Dict{String,<:Any})

Retrieves the resource-based policy attached to a given registry.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"registryName"`: The name of the registry.
"""
function get_resource_policy(; aws_config::AbstractAWSConfig=current_aws_config())
    return schemas(
        "GET", "/v1/policy"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_resource_policy(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return schemas(
        "GET", "/v1/policy", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_discoverers()
    list_discoverers(params::Dict{String,<:Any})

List the discoverers.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"discovererIdPrefix"`: Specifying this limits the results to only those discoverer IDs
  that start with the specified prefix.
- `"limit"`:
- `"nextToken"`: The token that specifies the next page of results to return. To request
  the first page, leave NextToken empty. The token will expire in 24 hours, and cannot be
  shared with other accounts.
- `"sourceArnPrefix"`: Specifying this limits the results to only those ARNs that start
  with the specified prefix.
"""
function list_discoverers(; aws_config::AbstractAWSConfig=current_aws_config())
    return schemas(
        "GET", "/v1/discoverers"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_discoverers(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return schemas(
        "GET",
        "/v1/discoverers",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_registries()
    list_registries(params::Dict{String,<:Any})

List the registries.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"limit"`:
- `"nextToken"`: The token that specifies the next page of results to return. To request
  the first page, leave NextToken empty. The token will expire in 24 hours, and cannot be
  shared with other accounts.
- `"registryNamePrefix"`: Specifying this limits the results to only those registry names
  that start with the specified prefix.
- `"scope"`: Can be set to Local or AWS to limit responses to your custom registries, or
  the ones provided by AWS.
"""
function list_registries(; aws_config::AbstractAWSConfig=current_aws_config())
    return schemas(
        "GET", "/v1/registries"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_registries(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return schemas(
        "GET",
        "/v1/registries",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_schema_versions(registry_name, schema_name)
    list_schema_versions(registry_name, schema_name, params::Dict{String,<:Any})

Provides a list of the schema versions and related information.

# Arguments
- `registry_name`: The name of the registry.
- `schema_name`: The name of the schema.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"limit"`:
- `"nextToken"`: The token that specifies the next page of results to return. To request
  the first page, leave NextToken empty. The token will expire in 24 hours, and cannot be
  shared with other accounts.
"""
function list_schema_versions(
    registryName, schemaName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return schemas(
        "GET",
        "/v1/registries/name/$(registryName)/schemas/name/$(schemaName)/versions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_schema_versions(
    registryName,
    schemaName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return schemas(
        "GET",
        "/v1/registries/name/$(registryName)/schemas/name/$(schemaName)/versions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_schemas(registry_name)
    list_schemas(registry_name, params::Dict{String,<:Any})

List the schemas.

# Arguments
- `registry_name`: The name of the registry.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"limit"`:
- `"nextToken"`: The token that specifies the next page of results to return. To request
  the first page, leave NextToken empty. The token will expire in 24 hours, and cannot be
  shared with other accounts.
- `"schemaNamePrefix"`: Specifying this limits the results to only those schema names that
  start with the specified prefix.
"""
function list_schemas(registryName; aws_config::AbstractAWSConfig=current_aws_config())
    return schemas(
        "GET",
        "/v1/registries/name/$(registryName)/schemas";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_schemas(
    registryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return schemas(
        "GET",
        "/v1/registries/name/$(registryName)/schemas",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource-arn)
    list_tags_for_resource(resource-arn, params::Dict{String,<:Any})

Get tags for resource.

# Arguments
- `resource-arn`: The ARN of the resource.

"""
function list_tags_for_resource(
    resource_arn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return schemas(
        "GET",
        "/tags/$(resource-arn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resource_arn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return schemas(
        "GET",
        "/tags/$(resource-arn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_code_binding(language, registry_name, schema_name)
    put_code_binding(language, registry_name, schema_name, params::Dict{String,<:Any})

Put code binding URI

# Arguments
- `language`: The language of the code binding.
- `registry_name`: The name of the registry.
- `schema_name`: The name of the schema.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"schemaVersion"`: Specifying this limits the results to only this schema version.
"""
function put_code_binding(
    language, registryName, schemaName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return schemas(
        "POST",
        "/v1/registries/name/$(registryName)/schemas/name/$(schemaName)/language/$(language)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_code_binding(
    language,
    registryName,
    schemaName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return schemas(
        "POST",
        "/v1/registries/name/$(registryName)/schemas/name/$(schemaName)/language/$(language)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_resource_policy(policy)
    put_resource_policy(policy, params::Dict{String,<:Any})

The name of the policy.

# Arguments
- `policy`: The resource-based policy.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"RevisionId"`: The revision ID of the policy.
- `"registryName"`: The name of the registry.
"""
function put_resource_policy(Policy; aws_config::AbstractAWSConfig=current_aws_config())
    return schemas(
        "PUT",
        "/v1/policy",
        Dict{String,Any}("Policy" => Policy);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_resource_policy(
    Policy, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return schemas(
        "PUT",
        "/v1/policy",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Policy" => Policy), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    search_schemas(keywords, registry_name)
    search_schemas(keywords, registry_name, params::Dict{String,<:Any})

Search the schemas

# Arguments
- `keywords`: Specifying this limits the results to only schemas that include the provided
  keywords.
- `registry_name`: The name of the registry.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"limit"`:
- `"nextToken"`: The token that specifies the next page of results to return. To request
  the first page, leave NextToken empty. The token will expire in 24 hours, and cannot be
  shared with other accounts.
"""
function search_schemas(
    keywords, registryName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return schemas(
        "GET",
        "/v1/registries/name/$(registryName)/schemas/search",
        Dict{String,Any}("keywords" => keywords);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function search_schemas(
    keywords,
    registryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return schemas(
        "GET",
        "/v1/registries/name/$(registryName)/schemas/search",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("keywords" => keywords), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_discoverer(discoverer_id)
    start_discoverer(discoverer_id, params::Dict{String,<:Any})

Starts the discoverer

# Arguments
- `discoverer_id`: The ID of the discoverer.

"""
function start_discoverer(discovererId; aws_config::AbstractAWSConfig=current_aws_config())
    return schemas(
        "POST",
        "/v1/discoverers/id/$(discovererId)/start";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_discoverer(
    discovererId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return schemas(
        "POST",
        "/v1/discoverers/id/$(discovererId)/start",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_discoverer(discoverer_id)
    stop_discoverer(discoverer_id, params::Dict{String,<:Any})

Stops the discoverer

# Arguments
- `discoverer_id`: The ID of the discoverer.

"""
function stop_discoverer(discovererId; aws_config::AbstractAWSConfig=current_aws_config())
    return schemas(
        "POST",
        "/v1/discoverers/id/$(discovererId)/stop";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_discoverer(
    discovererId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return schemas(
        "POST",
        "/v1/discoverers/id/$(discovererId)/stop",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource-arn, tags)
    tag_resource(resource-arn, tags, params::Dict{String,<:Any})

Add tags to a resource.

# Arguments
- `resource-arn`: The ARN of the resource.
- `tags`: Tags associated with the resource.

"""
function tag_resource(
    resource_arn, tags; aws_config::AbstractAWSConfig=current_aws_config()
)
    return schemas(
        "POST",
        "/tags/$(resource-arn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resource_arn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return schemas(
        "POST",
        "/tags/$(resource-arn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource-arn, tag_keys)
    untag_resource(resource-arn, tag_keys, params::Dict{String,<:Any})

Removes tags from a resource.

# Arguments
- `resource-arn`: The ARN of the resource.
- `tag_keys`: Keys of key-value pairs.

"""
function untag_resource(
    resource_arn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return schemas(
        "DELETE",
        "/tags/$(resource-arn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resource_arn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return schemas(
        "DELETE",
        "/tags/$(resource-arn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_discoverer(discoverer_id)
    update_discoverer(discoverer_id, params::Dict{String,<:Any})

Updates the discoverer

# Arguments
- `discoverer_id`: The ID of the discoverer.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CrossAccount"`: Support discovery of schemas in events sent to the bus from another
  account. (default: true)
- `"Description"`: The description of the discoverer to update.
"""
function update_discoverer(discovererId; aws_config::AbstractAWSConfig=current_aws_config())
    return schemas(
        "PUT",
        "/v1/discoverers/id/$(discovererId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_discoverer(
    discovererId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return schemas(
        "PUT",
        "/v1/discoverers/id/$(discovererId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_registry(registry_name)
    update_registry(registry_name, params::Dict{String,<:Any})

Updates a registry.

# Arguments
- `registry_name`: The name of the registry.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: The description of the registry to update.
"""
function update_registry(registryName; aws_config::AbstractAWSConfig=current_aws_config())
    return schemas(
        "PUT",
        "/v1/registries/name/$(registryName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_registry(
    registryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return schemas(
        "PUT",
        "/v1/registries/name/$(registryName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_schema(registry_name, schema_name)
    update_schema(registry_name, schema_name, params::Dict{String,<:Any})

Updates the schema definition Inactive schemas will be deleted after two years.

# Arguments
- `registry_name`: The name of the registry.
- `schema_name`: The name of the schema.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientTokenId"`: The ID of the client token.
- `"Content"`: The source of the schema definition.
- `"Description"`: The description of the schema.
- `"Type"`: The schema type for the events schema.
"""
function update_schema(
    registryName, schemaName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return schemas(
        "PUT",
        "/v1/registries/name/$(registryName)/schemas/name/$(schemaName)",
        Dict{String,Any}("ClientTokenId" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_schema(
    registryName,
    schemaName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return schemas(
        "PUT",
        "/v1/registries/name/$(registryName)/schemas/name/$(schemaName)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ClientTokenId" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: eks_auth
using AWS.Compat
using AWS.UUIDs

"""
    assume_role_for_pod_identity(cluster_name, token)
    assume_role_for_pod_identity(cluster_name, token, params::Dict{String,<:Any})

The Amazon EKS Auth API and the AssumeRoleForPodIdentity action are only used by the EKS
Pod Identity Agent. We recommend that applications use the Amazon Web Services SDKs to
connect to Amazon Web Services services; if credentials from an EKS Pod Identity
association are available in the pod, the latest versions of the SDKs use them
automatically.

# Arguments
- `cluster_name`: The name of the cluster for the request.
- `token`: The token of the Kubernetes service account for the pod.

"""
function assume_role_for_pod_identity(
    clusterName, token; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eks_auth(
        "POST",
        "/clusters/$(clusterName)/assume-role-for-pod-identity",
        Dict{String,Any}("token" => token);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function assume_role_for_pod_identity(
    clusterName,
    token,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eks_auth(
        "POST",
        "/clusters/$(clusterName)/assume-role-for-pod-identity",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("token" => token), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: mobile_analytics
using AWS.Compat
using AWS.UUIDs

"""
    put_events(events, x-amz-_client-_context)
    put_events(events, x-amz-_client-_context, params::Dict{String,<:Any})

The PutEvents operation records one or more events. You can have up to 1,500 unique custom
events per app, any combination of up to 40 attributes and metrics per custom event, and
any number of attribute or metric values.

# Arguments
- `events`: An array of Event JSON objects
- `x-amz-_client-_context`: The client context including the client ID, app title, app
  version and package name.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"x-amz-Client-Context-Encoding"`: The encoding used for the client context.
"""
function put_events(
    events, x_amz_Client_Context; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mobile_analytics(
        "POST",
        "/2014-06-05/events",
        Dict{String,Any}(
            "events" => events,
            "headers" => Dict{String,Any}("x-amz-Client-Context" => x_amz_Client_Context),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_events(
    events,
    x_amz_Client_Context,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mobile_analytics(
        "POST",
        "/2014-06-05/events",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "events" => events,
                    "headers" =>
                        Dict{String,Any}("x-amz-Client-Context" => x_amz_Client_Context),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: lex_runtime_v2
using AWS.Compat
using AWS.UUIDs

"""
    delete_session(bot_alias_id, bot_id, locale_id, session_id)
    delete_session(bot_alias_id, bot_id, locale_id, session_id, params::Dict{String,<:Any})

Removes session information for a specified bot, alias, and user ID.  You can use this
operation to restart a conversation with a bot. When you remove a session, the entire
history of the session is removed so that you can start again. You don't need to delete a
session. Sessions have a time limit and will expire. Set the session time limit when you
create the bot. The default is 5 minutes, but you can specify anything between 1 minute and
24 hours. If you specify a bot or alias ID that doesn't exist, you receive a
BadRequestException.  If the locale doesn't exist in the bot, or if the locale hasn't been
enables for the alias, you receive a BadRequestException.

# Arguments
- `bot_alias_id`: The alias identifier in use for the bot that contains the session data.
- `bot_id`: The identifier of the bot that contains the session data.
- `locale_id`: The locale where the session is in use.
- `session_id`: The identifier of the session to delete.

"""
function delete_session(
    botAliasId,
    botId,
    localeId,
    sessionId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_runtime_v2(
        "DELETE",
        "/bots/$(botId)/botAliases/$(botAliasId)/botLocales/$(localeId)/sessions/$(sessionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_session(
    botAliasId,
    botId,
    localeId,
    sessionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_runtime_v2(
        "DELETE",
        "/bots/$(botId)/botAliases/$(botAliasId)/botLocales/$(localeId)/sessions/$(sessionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_session(bot_alias_id, bot_id, locale_id, session_id)
    get_session(bot_alias_id, bot_id, locale_id, session_id, params::Dict{String,<:Any})

Returns session information for a specified bot, alias, and user. For example, you can use
this operation to retrieve session information for a user that has left a long-running
session in use. If the bot, alias, or session identifier doesn't exist, Amazon Lex V2
returns a BadRequestException. If the locale doesn't exist or is not enabled for the alias,
you receive a BadRequestException.

# Arguments
- `bot_alias_id`: The alias identifier in use for the bot that contains the session data.
- `bot_id`: The identifier of the bot that contains the session data.
- `locale_id`: The locale where the session is in use.
- `session_id`: The identifier of the session to return.

"""
function get_session(
    botAliasId,
    botId,
    localeId,
    sessionId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_runtime_v2(
        "GET",
        "/bots/$(botId)/botAliases/$(botAliasId)/botLocales/$(localeId)/sessions/$(sessionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_session(
    botAliasId,
    botId,
    localeId,
    sessionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_runtime_v2(
        "GET",
        "/bots/$(botId)/botAliases/$(botAliasId)/botLocales/$(localeId)/sessions/$(sessionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_session(bot_alias_id, bot_id, locale_id, session_id, session_state)
    put_session(bot_alias_id, bot_id, locale_id, session_id, session_state, params::Dict{String,<:Any})

Creates a new session or modifies an existing session with an Amazon Lex V2 bot. Use this
operation to enable your application to set the state of the bot.

# Arguments
- `bot_alias_id`: The alias identifier of the bot that receives the session data.
- `bot_id`: The identifier of the bot that receives the session data.
- `locale_id`: The locale where the session is in use.
- `session_id`: The identifier of the session that receives the session data.
- `session_state`: Sets the state of the session with the user. You can use this to set the
  current intent, attributes, context, and dialog action. Use the dialog action to determine
  the next step that Amazon Lex V2 should use in the conversation with the user.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ResponseContentType"`: The message that Amazon Lex V2 returns in the response can be
  either text or speech depending on the value of this parameter.    If the value is
  text/plain; charset=utf-8, Amazon Lex V2 returns text in the response.
- `"messages"`: A list of messages to send to the user. Messages are sent in the order that
  they are defined in the list.
- `"requestAttributes"`: Request-specific information passed between Amazon Lex V2 and the
  client application. The namespace x-amz-lex: is reserved for special attributes. Don't
  create any request attributes with the prefix x-amz-lex:.
"""
function put_session(
    botAliasId,
    botId,
    localeId,
    sessionId,
    sessionState;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_runtime_v2(
        "POST",
        "/bots/$(botId)/botAliases/$(botAliasId)/botLocales/$(localeId)/sessions/$(sessionId)",
        Dict{String,Any}("sessionState" => sessionState);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_session(
    botAliasId,
    botId,
    localeId,
    sessionId,
    sessionState,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_runtime_v2(
        "POST",
        "/bots/$(botId)/botAliases/$(botAliasId)/botLocales/$(localeId)/sessions/$(sessionId)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("sessionState" => sessionState), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    recognize_text(bot_alias_id, bot_id, locale_id, session_id, text)
    recognize_text(bot_alias_id, bot_id, locale_id, session_id, text, params::Dict{String,<:Any})

Sends user input to Amazon Lex V2. Client applications use this API to send requests to
Amazon Lex V2 at runtime. Amazon Lex V2 then interprets the user input using the machine
learning model that it build for the bot. In response, Amazon Lex V2 returns the next
message to convey to the user and an optional response card to display. If the optional
post-fulfillment response is specified, the messages are returned as follows. For more
information, see PostFulfillmentStatusSpecification.    Success message - Returned if the
Lambda function completes successfully and the intent state is fulfilled or ready
fulfillment if the message is present.    Failed message - The failed message is returned
if the Lambda function throws an exception or if the Lambda function returns a failed
intent state without a message.    Timeout message - If you don't configure a timeout
message and a timeout, and the Lambda function doesn't return within 30 seconds, the
timeout message is returned. If you configure a timeout, the timeout message is returned
when the period times out.    For more information, see Completion message.

# Arguments
- `bot_alias_id`: The alias identifier in use for the bot that processes the request.
- `bot_id`: The identifier of the bot that processes the request.
- `locale_id`: The locale where the session is in use.
- `session_id`: The identifier of the user session that is having the conversation.
- `text`: The text that the user entered. Amazon Lex V2 interprets this text.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"requestAttributes"`: Request-specific information passed between the client application
  and Amazon Lex V2  The namespace x-amz-lex: is reserved for special attributes. Don't
  create any request attributes with the prefix x-amz-lex:.
- `"sessionState"`: The current state of the dialog between the user and the bot.
"""
function recognize_text(
    botAliasId,
    botId,
    localeId,
    sessionId,
    text;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_runtime_v2(
        "POST",
        "/bots/$(botId)/botAliases/$(botAliasId)/botLocales/$(localeId)/sessions/$(sessionId)/text",
        Dict{String,Any}("text" => text);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function recognize_text(
    botAliasId,
    botId,
    localeId,
    sessionId,
    text,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_runtime_v2(
        "POST",
        "/bots/$(botId)/botAliases/$(botAliasId)/botLocales/$(localeId)/sessions/$(sessionId)/text",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("text" => text), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    recognize_utterance(content-_type, bot_alias_id, bot_id, locale_id, session_id)
    recognize_utterance(content-_type, bot_alias_id, bot_id, locale_id, session_id, params::Dict{String,<:Any})

Sends user input to Amazon Lex V2. You can send text or speech. Clients use this API to
send text and audio requests to Amazon Lex V2 at runtime. Amazon Lex V2 interprets the user
input using the machine learning model built for the bot. The following request fields must
be compressed with gzip and then base64 encoded before you send them to Amazon Lex V2.
requestAttributes   sessionState   The following response fields are compressed using gzip
and then base64 encoded by Amazon Lex V2. Before you can use these fields, you must decode
and decompress them.    inputTranscript   interpretations   messages   requestAttributes
sessionState   The example contains a Java application that compresses and encodes a Java
object to send to Amazon Lex V2, and a second that decodes and decompresses a response from
Amazon Lex V2. If the optional post-fulfillment response is specified, the messages are
returned as follows. For more information, see PostFulfillmentStatusSpecification.
Success message - Returned if the Lambda function completes successfully and the intent
state is fulfilled or ready fulfillment if the message is present.    Failed message - The
failed message is returned if the Lambda function throws an exception or if the Lambda
function returns a failed intent state without a message.    Timeout message - If you don't
configure a timeout message and a timeout, and the Lambda function doesn't return within 30
seconds, the timeout message is returned. If you configure a timeout, the timeout message
is returned when the period times out.    For more information, see Completion message.

# Arguments
- `content-_type`: Indicates the format for audio input or that the content is text. The
  header must start with one of the following prefixes:   PCM format, audio data must be in
  little-endian byte order.   audio/l16; rate=16000; channels=1   audio/x-l16;
  sample-rate=16000; channel-count=1   audio/lpcm; sample-rate=8000; sample-size-bits=16;
  channel-count=1; is-big-endian=false     Opus format
  audio/x-cbr-opus-with-preamble;preamble-size=0;bit-rate=256000;frame-size-milliseconds=4
   Text format   text/plain; charset=utf-8
- `bot_alias_id`: The alias identifier in use for the bot that should receive the request.
- `bot_id`: The identifier of the bot that should receive the request.
- `locale_id`: The locale where the session is in use.
- `session_id`: The identifier of the session in use.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Response-Content-Type"`: The message that Amazon Lex V2 returns in the response can be
  either text or speech based on the responseContentType value.   If the value is
  text/plain;charset=utf-8, Amazon Lex V2 returns text in the response.   If the value begins
  with audio/, Amazon Lex V2 returns speech in the response. Amazon Lex V2 uses Amazon Polly
  to generate the speech using the configuration that you specified in the
  responseContentType parameter. For example, if you specify audio/mpeg as the value, Amazon
  Lex V2 returns speech in the MPEG format.   If the value is audio/pcm, the speech returned
  is audio/pcm at 16 KHz in 16-bit, little-endian format.   The following are the accepted
  values:   audio/mpeg   audio/ogg   audio/pcm (16 KHz)   audio/* (defaults to mpeg)
  text/plain; charset=utf-8
- `"inputStream"`: User input in PCM or Opus audio format or text format as described in
  the requestContentType parameter.
- `"x-amz-lex-request-attributes"`: Request-specific information passed between the client
  application and Amazon Lex V2  The namespace x-amz-lex: is reserved for special attributes.
  Don't create any request attributes for prefix x-amz-lex:. The requestAttributes field must
  be compressed using gzip and then base64 encoded before sending to Amazon Lex V2.
- `"x-amz-lex-session-state"`: Sets the state of the session with the user. You can use
  this to set the current intent, attributes, context, and dialog action. Use the dialog
  action to determine the next step that Amazon Lex V2 should use in the conversation with
  the user. The sessionState field must be compressed using gzip and then base64 encoded
  before sending to Amazon Lex V2.
"""
function recognize_utterance(
    Content_Type,
    botAliasId,
    botId,
    localeId,
    sessionId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_runtime_v2(
        "POST",
        "/bots/$(botId)/botAliases/$(botAliasId)/botLocales/$(localeId)/sessions/$(sessionId)/utterance",
        Dict{String,Any}("headers" => Dict{String,Any}("Content-Type" => Content_Type));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function recognize_utterance(
    Content_Type,
    botAliasId,
    botId,
    localeId,
    sessionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_runtime_v2(
        "POST",
        "/bots/$(botId)/botAliases/$(botAliasId)/botLocales/$(localeId)/sessions/$(sessionId)/utterance",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "headers" => Dict{String,Any}("Content-Type" => Content_Type)
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: iot_1click_projects
using AWS.Compat
using AWS.UUIDs

"""
    associate_device_with_placement(device_id, device_template_name, placement_name, project_name)
    associate_device_with_placement(device_id, device_template_name, placement_name, project_name, params::Dict{String,<:Any})

Associates a physical device with a placement.

# Arguments
- `device_id`: The ID of the physical device to be associated with the given placement in
  the project. Note that a mandatory 4 character prefix is required for all deviceId values.
- `device_template_name`: The device template name to associate with the device ID.
- `placement_name`: The name of the placement in which to associate the device.
- `project_name`: The name of the project containing the placement in which to associate
  the device.

"""
function associate_device_with_placement(
    deviceId,
    deviceTemplateName,
    placementName,
    projectName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_1click_projects(
        "PUT",
        "/projects/$(projectName)/placements/$(placementName)/devices/$(deviceTemplateName)",
        Dict{String,Any}("deviceId" => deviceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_device_with_placement(
    deviceId,
    deviceTemplateName,
    placementName,
    projectName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_1click_projects(
        "PUT",
        "/projects/$(projectName)/placements/$(placementName)/devices/$(deviceTemplateName)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("deviceId" => deviceId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_placement(placement_name, project_name)
    create_placement(placement_name, project_name, params::Dict{String,<:Any})

Creates an empty placement.

# Arguments
- `placement_name`: The name of the placement to be created.
- `project_name`: The name of the project in which to create the placement.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"attributes"`: Optional user-defined key/value pairs providing contextual data (such as
  location or function) for the placement.
"""
function create_placement(
    placementName, projectName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_1click_projects(
        "POST",
        "/projects/$(projectName)/placements",
        Dict{String,Any}("placementName" => placementName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_placement(
    placementName,
    projectName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_1click_projects(
        "POST",
        "/projects/$(projectName)/placements",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("placementName" => placementName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_project(project_name)
    create_project(project_name, params::Dict{String,<:Any})

Creates an empty project with a placement template. A project contains zero or more
placements that adhere to the placement template defined in the project.

# Arguments
- `project_name`: The name of the project to create.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: An optional description for the project.
- `"placementTemplate"`: The schema defining the placement to be created. A placement
  template defines placement default attributes and device templates. You cannot add or
  remove device templates after the project has been created. However, you can update
  callbackOverrides for the device templates using the UpdateProject API.
- `"tags"`: Optional tags (metadata key/value pairs) to be associated with the project. For
  example, { {\"key1\": \"value1\", \"key2\": \"value2\"} }. For more information, see AWS
  Tagging Strategies.
"""
function create_project(projectName; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_1click_projects(
        "POST",
        "/projects",
        Dict{String,Any}("projectName" => projectName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_project(
    projectName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_1click_projects(
        "POST",
        "/projects",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("projectName" => projectName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_placement(placement_name, project_name)
    delete_placement(placement_name, project_name, params::Dict{String,<:Any})

Deletes a placement. To delete a placement, it must not have any devices associated with
it.  When you delete a placement, all associated data becomes irretrievable.

# Arguments
- `placement_name`: The name of the empty placement to delete.
- `project_name`: The project containing the empty placement to delete.

"""
function delete_placement(
    placementName, projectName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_1click_projects(
        "DELETE",
        "/projects/$(projectName)/placements/$(placementName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_placement(
    placementName,
    projectName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_1click_projects(
        "DELETE",
        "/projects/$(projectName)/placements/$(placementName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_project(project_name)
    delete_project(project_name, params::Dict{String,<:Any})

Deletes a project. To delete a project, it must not have any placements associated with it.
 When you delete a project, all associated data becomes irretrievable.

# Arguments
- `project_name`: The name of the empty project to delete.

"""
function delete_project(projectName; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_1click_projects(
        "DELETE",
        "/projects/$(projectName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_project(
    projectName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_1click_projects(
        "DELETE",
        "/projects/$(projectName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_placement(placement_name, project_name)
    describe_placement(placement_name, project_name, params::Dict{String,<:Any})

Describes a placement in a project.

# Arguments
- `placement_name`: The name of the placement within a project.
- `project_name`: The project containing the placement to be described.

"""
function describe_placement(
    placementName, projectName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_1click_projects(
        "GET",
        "/projects/$(projectName)/placements/$(placementName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_placement(
    placementName,
    projectName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_1click_projects(
        "GET",
        "/projects/$(projectName)/placements/$(placementName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_project(project_name)
    describe_project(project_name, params::Dict{String,<:Any})

Returns an object describing a project.

# Arguments
- `project_name`: The name of the project to be described.

"""
function describe_project(projectName; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_1click_projects(
        "GET",
        "/projects/$(projectName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_project(
    projectName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_1click_projects(
        "GET",
        "/projects/$(projectName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_device_from_placement(device_template_name, placement_name, project_name)
    disassociate_device_from_placement(device_template_name, placement_name, project_name, params::Dict{String,<:Any})

Removes a physical device from a placement.

# Arguments
- `device_template_name`: The device ID that should be removed from the placement.
- `placement_name`: The name of the placement that the device should be removed from.
- `project_name`: The name of the project that contains the placement.

"""
function disassociate_device_from_placement(
    deviceTemplateName,
    placementName,
    projectName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_1click_projects(
        "DELETE",
        "/projects/$(projectName)/placements/$(placementName)/devices/$(deviceTemplateName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_device_from_placement(
    deviceTemplateName,
    placementName,
    projectName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_1click_projects(
        "DELETE",
        "/projects/$(projectName)/placements/$(placementName)/devices/$(deviceTemplateName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_devices_in_placement(placement_name, project_name)
    get_devices_in_placement(placement_name, project_name, params::Dict{String,<:Any})

Returns an object enumerating the devices in a placement.

# Arguments
- `placement_name`: The name of the placement to get the devices from.
- `project_name`: The name of the project containing the placement.

"""
function get_devices_in_placement(
    placementName, projectName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_1click_projects(
        "GET",
        "/projects/$(projectName)/placements/$(placementName)/devices";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_devices_in_placement(
    placementName,
    projectName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_1click_projects(
        "GET",
        "/projects/$(projectName)/placements/$(placementName)/devices",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_placements(project_name)
    list_placements(project_name, params::Dict{String,<:Any})

Lists the placement(s) of a project.

# Arguments
- `project_name`: The project containing the placements to be listed.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return per request. If not set, a
  default value of 100 is used.
- `"nextToken"`: The token to retrieve the next set of results.
"""
function list_placements(projectName; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_1click_projects(
        "GET",
        "/projects/$(projectName)/placements";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_placements(
    projectName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_1click_projects(
        "GET",
        "/projects/$(projectName)/placements",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_projects()
    list_projects(params::Dict{String,<:Any})

Lists the AWS IoT 1-Click project(s) associated with your AWS account and region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return per request. If not set, a
  default value of 100 is used.
- `"nextToken"`: The token to retrieve the next set of results.
"""
function list_projects(; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_1click_projects(
        "GET", "/projects"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_projects(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_1click_projects(
        "GET", "/projects", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists the tags (metadata key/value pairs) which you have assigned to the resource.

# Arguments
- `resource_arn`: The ARN of the resource whose tags you want to list.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_1click_projects(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_1click_projects(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Creates or modifies tags for a resource. Tags are key/value pairs (metadata) that can be
used to manage a resource. For more information, see AWS Tagging Strategies.

# Arguments
- `resource_arn`: The ARN of the resouce for which tag(s) should be added or modified.
- `tags`: The new or modifying tag(s) for the resource. See AWS IoT 1-Click Service Limits
  for the maximum number of tags allowed per resource.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_1click_projects(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_1click_projects(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes one or more tags (metadata key/value pairs) from a resource.

# Arguments
- `resource_arn`: The ARN of the resource whose tag you want to remove.
- `tag_keys`: The keys of those tags which you want to remove.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_1click_projects(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_1click_projects(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_placement(placement_name, project_name)
    update_placement(placement_name, project_name, params::Dict{String,<:Any})

Updates a placement with the given attributes. To clear an attribute, pass an empty value
(i.e., \"\").

# Arguments
- `placement_name`: The name of the placement to update.
- `project_name`: The name of the project containing the placement to be updated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"attributes"`: The user-defined object of attributes used to update the placement. The
  maximum number of key/value pairs is 50.
"""
function update_placement(
    placementName, projectName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_1click_projects(
        "PUT",
        "/projects/$(projectName)/placements/$(placementName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_placement(
    placementName,
    projectName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_1click_projects(
        "PUT",
        "/projects/$(projectName)/placements/$(placementName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_project(project_name)
    update_project(project_name, params::Dict{String,<:Any})

Updates a project associated with your AWS account and region. With the exception of device
template names, you can pass just the values that need to be updated because the update
request will change only the values that are provided. To clear a value, pass the empty
string (i.e., \"\").

# Arguments
- `project_name`: The name of the project to be updated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: An optional user-defined description for the project.
- `"placementTemplate"`: An object defining the project update. Once a project has been
  created, you cannot add device template names to the project. However, for a given
  placementTemplate, you can update the associated callbackOverrides for the device
  definition using this API.
"""
function update_project(projectName; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_1click_projects(
        "PUT",
        "/projects/$(projectName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_project(
    projectName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_1click_projects(
        "PUT",
        "/projects/$(projectName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: cloudwatch_events
using AWS.Compat
using AWS.UUIDs

"""
    activate_event_source(name)
    activate_event_source(name, params::Dict{String,<:Any})

Activates a partner event source that has been deactivated. Once activated, your matching
event bus will start receiving events from the event source.

# Arguments
- `name`: The name of the partner event source to activate.

"""
function activate_event_source(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_events(
        "ActivateEventSource",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function activate_event_source(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_events(
        "ActivateEventSource",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_replay(replay_name)
    cancel_replay(replay_name, params::Dict{String,<:Any})

Cancels the specified replay.

# Arguments
- `replay_name`: The name of the replay to cancel.

"""
function cancel_replay(ReplayName; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_events(
        "CancelReplay",
        Dict{String,Any}("ReplayName" => ReplayName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_replay(
    ReplayName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_events(
        "CancelReplay",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ReplayName" => ReplayName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_api_destination(connection_arn, http_method, invocation_endpoint, name)
    create_api_destination(connection_arn, http_method, invocation_endpoint, name, params::Dict{String,<:Any})

Creates an API destination, which is an HTTP invocation endpoint configured as a target for
events.

# Arguments
- `connection_arn`: The ARN of the connection to use for the API destination. The
  destination endpoint must support the authorization type specified for the connection.
- `http_method`: The method to use for the request to the HTTP invocation endpoint.
- `invocation_endpoint`: The URL to the HTTP invocation endpoint for the API destination.
- `name`: The name for the API destination to create.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description for the API destination to create.
- `"InvocationRateLimitPerSecond"`: The maximum number of requests per second to send to
  the HTTP invocation endpoint.
"""
function create_api_destination(
    ConnectionArn,
    HttpMethod,
    InvocationEndpoint,
    Name;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_events(
        "CreateApiDestination",
        Dict{String,Any}(
            "ConnectionArn" => ConnectionArn,
            "HttpMethod" => HttpMethod,
            "InvocationEndpoint" => InvocationEndpoint,
            "Name" => Name,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_api_destination(
    ConnectionArn,
    HttpMethod,
    InvocationEndpoint,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_events(
        "CreateApiDestination",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ConnectionArn" => ConnectionArn,
                    "HttpMethod" => HttpMethod,
                    "InvocationEndpoint" => InvocationEndpoint,
                    "Name" => Name,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_archive(archive_name, event_source_arn)
    create_archive(archive_name, event_source_arn, params::Dict{String,<:Any})

Creates an archive of events with the specified settings. When you create an archive,
incoming events might not immediately start being sent to the archive. Allow a short period
of time for changes to take effect. If you do not specify a pattern to filter events sent
to the archive, all events are sent to the archive except replayed events. Replayed events
are not sent to an archive.

# Arguments
- `archive_name`: The name for the archive to create.
- `event_source_arn`: The ARN of the event bus that sends events to the archive.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description for the archive.
- `"EventPattern"`: An event pattern to use to filter events sent to the archive.
- `"RetentionDays"`: The number of days to retain events for. Default value is 0. If set to
  0, events are retained indefinitely
"""
function create_archive(
    ArchiveName, EventSourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_events(
        "CreateArchive",
        Dict{String,Any}("ArchiveName" => ArchiveName, "EventSourceArn" => EventSourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_archive(
    ArchiveName,
    EventSourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_events(
        "CreateArchive",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ArchiveName" => ArchiveName, "EventSourceArn" => EventSourceArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_connection(auth_parameters, authorization_type, name)
    create_connection(auth_parameters, authorization_type, name, params::Dict{String,<:Any})

Creates a connection. A connection defines the authorization type and credentials to use
for authorization with an API destination HTTP endpoint.

# Arguments
- `auth_parameters`: A CreateConnectionAuthRequestParameters object that contains the
  authorization parameters to use to authorize with the endpoint.
- `authorization_type`: The type of authorization to use for the connection.
- `name`: The name for the connection to create.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description for the connection to create.
"""
function create_connection(
    AuthParameters,
    AuthorizationType,
    Name;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_events(
        "CreateConnection",
        Dict{String,Any}(
            "AuthParameters" => AuthParameters,
            "AuthorizationType" => AuthorizationType,
            "Name" => Name,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_connection(
    AuthParameters,
    AuthorizationType,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_events(
        "CreateConnection",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AuthParameters" => AuthParameters,
                    "AuthorizationType" => AuthorizationType,
                    "Name" => Name,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_event_bus(name)
    create_event_bus(name, params::Dict{String,<:Any})

Creates a new event bus within your account. This can be a custom event bus which you can
use to receive events from your custom applications and services, or it can be a partner
event bus which can be matched to a partner event source.

# Arguments
- `name`: The name of the new event bus.  Event bus names cannot contain the / character.
  You can't use the name default for a custom event bus, as this name is already used for
  your account's default event bus. If this is a partner event bus, the name must exactly
  match the name of the partner event source that this event bus is matched to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EventSourceName"`: If you are creating a partner event bus, this specifies the partner
  event source that the new event bus will be matched with.
- `"Tags"`: Tags to associate with the event bus.
"""
function create_event_bus(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_events(
        "CreateEventBus",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_event_bus(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_events(
        "CreateEventBus",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_partner_event_source(account, name)
    create_partner_event_source(account, name, params::Dict{String,<:Any})

Called by an SaaS partner to create a partner event source. This operation is not used by
Amazon Web Services customers. Each partner event source can be used by one Amazon Web
Services account to create a matching partner event bus in that Amazon Web Services
account. A SaaS partner must create one partner event source for each Amazon Web Services
account that wants to receive those event types.  A partner event source creates events
based on resources within the SaaS partner's service or application. An Amazon Web Services
account that creates a partner event bus that matches the partner event source can use that
event bus to receive events from the partner, and then process them using Amazon Web
Services Events rules and targets. Partner event source names follow this format:
partner_name/event_namespace/event_name    partner_name is determined during partner
registration and identifies the partner to Amazon Web Services customers. event_namespace
is determined by the partner and is a way for the partner to categorize their events.
event_name is determined by the partner, and should uniquely identify an event-generating
resource within the partner system. The combination of event_namespace and event_name
should help Amazon Web Services customers decide whether to create an event bus to receive
these events.

# Arguments
- `account`: The Amazon Web Services account ID that is permitted to create a matching
  partner event bus for this partner event source.
- `name`: The name of the partner event source. This name must be unique and must be in the
  format  partner_name/event_namespace/event_name . The Amazon Web Services account that
  wants to use this partner event source must create a partner event bus with a name that
  matches the name of the partner event source.

"""
function create_partner_event_source(
    Account, Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_events(
        "CreatePartnerEventSource",
        Dict{String,Any}("Account" => Account, "Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_partner_event_source(
    Account,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_events(
        "CreatePartnerEventSource",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("Account" => Account, "Name" => Name), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    deactivate_event_source(name)
    deactivate_event_source(name, params::Dict{String,<:Any})

You can use this operation to temporarily stop receiving events from the specified partner
event source. The matching event bus is not deleted.  When you deactivate a partner event
source, the source goes into PENDING state. If it remains in PENDING state for more than
two weeks, it is deleted. To activate a deactivated partner event source, use
ActivateEventSource.

# Arguments
- `name`: The name of the partner event source to deactivate.

"""
function deactivate_event_source(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_events(
        "DeactivateEventSource",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function deactivate_event_source(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_events(
        "DeactivateEventSource",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    deauthorize_connection(name)
    deauthorize_connection(name, params::Dict{String,<:Any})

Removes all authorization parameters from the connection. This lets you remove the secret
from the connection so you can reuse it without having to create a new connection.

# Arguments
- `name`: The name of the connection to remove authorization from.

"""
function deauthorize_connection(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_events(
        "DeauthorizeConnection",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function deauthorize_connection(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_events(
        "DeauthorizeConnection",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_api_destination(name)
    delete_api_destination(name, params::Dict{String,<:Any})

Deletes the specified API destination.

# Arguments
- `name`: The name of the destination to delete.

"""
function delete_api_destination(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_events(
        "DeleteApiDestination",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_api_destination(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_events(
        "DeleteApiDestination",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_archive(archive_name)
    delete_archive(archive_name, params::Dict{String,<:Any})

Deletes the specified archive.

# Arguments
- `archive_name`: The name of the archive to delete.

"""
function delete_archive(ArchiveName; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_events(
        "DeleteArchive",
        Dict{String,Any}("ArchiveName" => ArchiveName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_archive(
    ArchiveName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_events(
        "DeleteArchive",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ArchiveName" => ArchiveName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_connection(name)
    delete_connection(name, params::Dict{String,<:Any})

Deletes a connection.

# Arguments
- `name`: The name of the connection to delete.

"""
function delete_connection(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_events(
        "DeleteConnection",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_connection(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_events(
        "DeleteConnection",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_event_bus(name)
    delete_event_bus(name, params::Dict{String,<:Any})

Deletes the specified custom event bus or partner event bus. All rules associated with this
event bus need to be deleted. You can't delete your account's default event bus.

# Arguments
- `name`: The name of the event bus to delete.

"""
function delete_event_bus(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_events(
        "DeleteEventBus",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_event_bus(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_events(
        "DeleteEventBus",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_partner_event_source(account, name)
    delete_partner_event_source(account, name, params::Dict{String,<:Any})

This operation is used by SaaS partners to delete a partner event source. This operation is
not used by Amazon Web Services customers. When you delete an event source, the status of
the corresponding partner event bus in the Amazon Web Services customer account becomes
DELETED.

# Arguments
- `account`: The Amazon Web Services account ID of the Amazon Web Services customer that
  the event source was created for.
- `name`: The name of the event source to delete.

"""
function delete_partner_event_source(
    Account, Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_events(
        "DeletePartnerEventSource",
        Dict{String,Any}("Account" => Account, "Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_partner_event_source(
    Account,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_events(
        "DeletePartnerEventSource",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("Account" => Account, "Name" => Name), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_rule(name)
    delete_rule(name, params::Dict{String,<:Any})

Deletes the specified rule. Before you can delete the rule, you must remove all targets,
using RemoveTargets. When you delete a rule, incoming events might continue to match to the
deleted rule. Allow a short period of time for changes to take effect. If you call delete
rule multiple times for the same rule, all calls will succeed. When you call delete rule
for a non-existent custom eventbus, ResourceNotFoundException is returned. Managed rules
are rules created and managed by another Amazon Web Services service on your behalf. These
rules are created by those other Amazon Web Services services to support functionality in
those services. You can delete these rules using the Force option, but you should do so
only if you are sure the other service is not still using that rule.

# Arguments
- `name`: The name of the rule.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EventBusName"`: The name or ARN of the event bus associated with the rule. If you omit
  this, the default event bus is used.
- `"Force"`: If this is a managed rule, created by an Amazon Web Services service on your
  behalf, you must specify Force as True to delete the rule. This parameter is ignored for
  rules that are not managed rules. You can check whether a rule is a managed rule by using
  DescribeRule or ListRules and checking the ManagedBy field of the response.
"""
function delete_rule(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_events(
        "DeleteRule",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_rule(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_events(
        "DeleteRule",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_api_destination(name)
    describe_api_destination(name, params::Dict{String,<:Any})

Retrieves details about an API destination.

# Arguments
- `name`: The name of the API destination to retrieve.

"""
function describe_api_destination(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_events(
        "DescribeApiDestination",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_api_destination(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_events(
        "DescribeApiDestination",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_archive(archive_name)
    describe_archive(archive_name, params::Dict{String,<:Any})

Retrieves details about an archive.

# Arguments
- `archive_name`: The name of the archive to retrieve.

"""
function describe_archive(ArchiveName; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_events(
        "DescribeArchive",
        Dict{String,Any}("ArchiveName" => ArchiveName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_archive(
    ArchiveName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_events(
        "DescribeArchive",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ArchiveName" => ArchiveName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_connection(name)
    describe_connection(name, params::Dict{String,<:Any})

Retrieves details about a connection.

# Arguments
- `name`: The name of the connection to retrieve.

"""
function describe_connection(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_events(
        "DescribeConnection",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_connection(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_events(
        "DescribeConnection",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_event_bus()
    describe_event_bus(params::Dict{String,<:Any})

Displays details about an event bus in your account. This can include the external Amazon
Web Services accounts that are permitted to write events to your default event bus, and the
associated policy. For custom event buses and partner event buses, it displays the name,
ARN, policy, state, and creation time.  To enable your account to receive events from other
accounts on its default event bus, use PutPermission. For more information about partner
event buses, see CreateEventBus.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Name"`: The name or ARN of the event bus to show details for. If you omit this, the
  default event bus is displayed.
"""
function describe_event_bus(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_events(
        "DescribeEventBus"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_event_bus(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_events(
        "DescribeEventBus", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_event_source(name)
    describe_event_source(name, params::Dict{String,<:Any})

This operation lists details about a partner event source that is shared with your account.

# Arguments
- `name`: The name of the partner event source to display the details of.

"""
function describe_event_source(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_events(
        "DescribeEventSource",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_event_source(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_events(
        "DescribeEventSource",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_partner_event_source(name)
    describe_partner_event_source(name, params::Dict{String,<:Any})

An SaaS partner can use this operation to list details about a partner event source that
they have created. Amazon Web Services customers do not use this operation. Instead, Amazon
Web Services customers can use DescribeEventSource to see details about a partner event
source that is shared with them.

# Arguments
- `name`: The name of the event source to display.

"""
function describe_partner_event_source(
    Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_events(
        "DescribePartnerEventSource",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_partner_event_source(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_events(
        "DescribePartnerEventSource",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_replay(replay_name)
    describe_replay(replay_name, params::Dict{String,<:Any})

Retrieves details about a replay. Use DescribeReplay to determine the progress of a running
replay. A replay processes events to replay based on the time in the event, and replays
them using 1 minute intervals. If you use StartReplay and specify an EventStartTime and an
EventEndTime that covers a 20 minute time range, the events are replayed from the first
minute of that 20 minute range first. Then the events from the second minute are replayed.
You can use DescribeReplay to determine the progress of a replay. The value returned for
EventLastReplayedTime indicates the time within the specified time range associated with
the last event replayed.

# Arguments
- `replay_name`: The name of the replay to retrieve.

"""
function describe_replay(ReplayName; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_events(
        "DescribeReplay",
        Dict{String,Any}("ReplayName" => ReplayName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_replay(
    ReplayName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_events(
        "DescribeReplay",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ReplayName" => ReplayName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_rule(name)
    describe_rule(name, params::Dict{String,<:Any})

Describes the specified rule. DescribeRule does not list the targets of a rule. To see the
targets associated with a rule, use ListTargetsByRule.

# Arguments
- `name`: The name of the rule.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EventBusName"`: The name or ARN of the event bus associated with the rule. If you omit
  this, the default event bus is used.
"""
function describe_rule(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_events(
        "DescribeRule",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_rule(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_events(
        "DescribeRule",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disable_rule(name)
    disable_rule(name, params::Dict{String,<:Any})

Disables the specified rule. A disabled rule won't match any events, and won't self-trigger
if it has a schedule expression. When you disable a rule, incoming events might continue to
match to the disabled rule. Allow a short period of time for changes to take effect.

# Arguments
- `name`: The name of the rule.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EventBusName"`: The name or ARN of the event bus associated with the rule. If you omit
  this, the default event bus is used.
"""
function disable_rule(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_events(
        "DisableRule",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disable_rule(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_events(
        "DisableRule",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    enable_rule(name)
    enable_rule(name, params::Dict{String,<:Any})

Enables the specified rule. If the rule does not exist, the operation fails. When you
enable a rule, incoming events might not immediately start matching to a newly enabled
rule. Allow a short period of time for changes to take effect.

# Arguments
- `name`: The name of the rule.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EventBusName"`: The name or ARN of the event bus associated with the rule. If you omit
  this, the default event bus is used.
"""
function enable_rule(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_events(
        "EnableRule",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function enable_rule(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_events(
        "EnableRule",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_api_destinations()
    list_api_destinations(params::Dict{String,<:Any})

Retrieves a list of API destination in the account in the current Region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConnectionArn"`: The ARN of the connection specified for the API destination.
- `"Limit"`: The maximum number of API destinations to include in the response.
- `"NamePrefix"`: A name prefix to filter results returned. Only API destinations with a
  name that starts with the prefix are returned.
- `"NextToken"`: The token returned by a previous call to retrieve the next set of results.
"""
function list_api_destinations(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_events(
        "ListApiDestinations"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_api_destinations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_events(
        "ListApiDestinations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_archives()
    list_archives(params::Dict{String,<:Any})

Lists your archives. You can either list all the archives or you can provide a prefix to
match to the archive names. Filter parameters are exclusive.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EventSourceArn"`: The ARN of the event source associated with the archive.
- `"Limit"`: The maximum number of results to return.
- `"NamePrefix"`: A name prefix to filter the archives returned. Only archives with name
  that match the prefix are returned.
- `"NextToken"`: The token returned by a previous call to retrieve the next set of results.
- `"State"`: The state of the archive.
"""
function list_archives(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_events(
        "ListArchives"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_archives(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_events(
        "ListArchives", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_connections()
    list_connections(params::Dict{String,<:Any})

Retrieves a list of connections from the account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConnectionState"`: The state of the connection.
- `"Limit"`: The maximum number of connections to return.
- `"NamePrefix"`: A name prefix to filter results returned. Only connections with a name
  that starts with the prefix are returned.
- `"NextToken"`: The token returned by a previous call to retrieve the next set of results.
"""
function list_connections(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_events(
        "ListConnections"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_connections(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_events(
        "ListConnections", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_event_buses()
    list_event_buses(params::Dict{String,<:Any})

Lists all the event buses in your account, including the default event bus, custom event
buses, and partner event buses.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: Specifying this limits the number of results returned by this operation. The
  operation also returns a NextToken which you can use in a subsequent operation to retrieve
  the next set of results.
- `"NamePrefix"`: Specifying this limits the results to only those event buses with names
  that start with the specified prefix.
- `"NextToken"`: The token returned by a previous call to retrieve the next set of results.
"""
function list_event_buses(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_events(
        "ListEventBuses"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_event_buses(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_events(
        "ListEventBuses", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_event_sources()
    list_event_sources(params::Dict{String,<:Any})

You can use this to see all the partner event sources that have been shared with your
Amazon Web Services account. For more information about partner event sources, see
CreateEventBus.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: Specifying this limits the number of results returned by this operation. The
  operation also returns a NextToken which you can use in a subsequent operation to retrieve
  the next set of results.
- `"NamePrefix"`: Specifying this limits the results to only those partner event sources
  with names that start with the specified prefix.
- `"NextToken"`: The token returned by a previous call to retrieve the next set of results.
"""
function list_event_sources(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_events(
        "ListEventSources"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_event_sources(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_events(
        "ListEventSources", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_partner_event_source_accounts(event_source_name)
    list_partner_event_source_accounts(event_source_name, params::Dict{String,<:Any})

An SaaS partner can use this operation to display the Amazon Web Services account ID that a
particular partner event source name is associated with. This operation is not used by
Amazon Web Services customers.

# Arguments
- `event_source_name`: The name of the partner event source to display account information
  about.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: Specifying this limits the number of results returned by this operation. The
  operation also returns a NextToken which you can use in a subsequent operation to retrieve
  the next set of results.
- `"NextToken"`: The token returned by a previous call to this operation. Specifying this
  retrieves the next set of results.
"""
function list_partner_event_source_accounts(
    EventSourceName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_events(
        "ListPartnerEventSourceAccounts",
        Dict{String,Any}("EventSourceName" => EventSourceName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_partner_event_source_accounts(
    EventSourceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_events(
        "ListPartnerEventSourceAccounts",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("EventSourceName" => EventSourceName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_partner_event_sources(name_prefix)
    list_partner_event_sources(name_prefix, params::Dict{String,<:Any})

An SaaS partner can use this operation to list all the partner event source names that they
have created. This operation is not used by Amazon Web Services customers.

# Arguments
- `name_prefix`: If you specify this, the results are limited to only those partner event
  sources that start with the string you specify.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: pecifying this limits the number of results returned by this operation. The
  operation also returns a NextToken which you can use in a subsequent operation to retrieve
  the next set of results.
- `"NextToken"`: The token returned by a previous call to this operation. Specifying this
  retrieves the next set of results.
"""
function list_partner_event_sources(
    NamePrefix; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_events(
        "ListPartnerEventSources",
        Dict{String,Any}("NamePrefix" => NamePrefix);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_partner_event_sources(
    NamePrefix,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_events(
        "ListPartnerEventSources",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("NamePrefix" => NamePrefix), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_replays()
    list_replays(params::Dict{String,<:Any})

Lists your replays. You can either list all the replays or you can provide a prefix to
match to the replay names. Filter parameters are exclusive.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EventSourceArn"`: The ARN of the archive from which the events are replayed.
- `"Limit"`: The maximum number of replays to retrieve.
- `"NamePrefix"`: A name prefix to filter the replays returned. Only replays with name that
  match the prefix are returned.
- `"NextToken"`: The token returned by a previous call to retrieve the next set of results.
- `"State"`: The state of the replay.
"""
function list_replays(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_events(
        "ListReplays"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_replays(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_events(
        "ListReplays", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_rule_names_by_target(target_arn)
    list_rule_names_by_target(target_arn, params::Dict{String,<:Any})

Lists the rules for the specified target. You can see which of the rules in Amazon
EventBridge can invoke a specific target in your account.

# Arguments
- `target_arn`: The Amazon Resource Name (ARN) of the target resource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EventBusName"`: The name or ARN of the event bus to list rules for. If you omit this,
  the default event bus is used.
- `"Limit"`: The maximum number of results to return.
- `"NextToken"`: The token returned by a previous call to retrieve the next set of results.
"""
function list_rule_names_by_target(
    TargetArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_events(
        "ListRuleNamesByTarget",
        Dict{String,Any}("TargetArn" => TargetArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_rule_names_by_target(
    TargetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_events(
        "ListRuleNamesByTarget",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TargetArn" => TargetArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_rules()
    list_rules(params::Dict{String,<:Any})

Lists your Amazon EventBridge rules. You can either list all the rules or you can provide a
prefix to match to the rule names. ListRules does not list the targets of a rule. To see
the targets associated with a rule, use ListTargetsByRule.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EventBusName"`: The name or ARN of the event bus to list the rules for. If you omit
  this, the default event bus is used.
- `"Limit"`: The maximum number of results to return.
- `"NamePrefix"`: The prefix matching the rule name.
- `"NextToken"`: The token returned by a previous call to retrieve the next set of results.
"""
function list_rules(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_events(
        "ListRules"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_rules(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_events(
        "ListRules", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Displays the tags associated with an EventBridge resource. In EventBridge, rules and event
buses can be tagged.

# Arguments
- `resource_arn`: The ARN of the EventBridge resource for which you want to view tags.

"""
function list_tags_for_resource(
    ResourceARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_events(
        "ListTagsForResource",
        Dict{String,Any}("ResourceARN" => ResourceARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_events(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceARN" => ResourceARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_targets_by_rule(rule)
    list_targets_by_rule(rule, params::Dict{String,<:Any})

Lists the targets assigned to the specified rule.

# Arguments
- `rule`: The name of the rule.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EventBusName"`: The name or ARN of the event bus associated with the rule. If you omit
  this, the default event bus is used.
- `"Limit"`: The maximum number of results to return.
- `"NextToken"`: The token returned by a previous call to retrieve the next set of results.
"""
function list_targets_by_rule(Rule; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_events(
        "ListTargetsByRule",
        Dict{String,Any}("Rule" => Rule);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_targets_by_rule(
    Rule, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_events(
        "ListTargetsByRule",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Rule" => Rule), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_events(entries)
    put_events(entries, params::Dict{String,<:Any})

Sends custom events to Amazon EventBridge so that they can be matched to rules.

# Arguments
- `entries`: The entry that defines an event in your system. You can specify several
  parameters for the entry such as the source and type of the event, resources associated
  with the event, and so on.

"""
function put_events(Entries; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_events(
        "PutEvents",
        Dict{String,Any}("Entries" => Entries);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_events(
    Entries,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_events(
        "PutEvents",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Entries" => Entries), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_partner_events(entries)
    put_partner_events(entries, params::Dict{String,<:Any})

This is used by SaaS partners to write events to a customer's partner event bus. Amazon Web
Services customers do not use this operation.

# Arguments
- `entries`: The list of events to write to the event bus.

"""
function put_partner_events(Entries; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_events(
        "PutPartnerEvents",
        Dict{String,Any}("Entries" => Entries);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_partner_events(
    Entries,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_events(
        "PutPartnerEvents",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Entries" => Entries), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_permission()
    put_permission(params::Dict{String,<:Any})

Running PutPermission permits the specified Amazon Web Services account or Amazon Web
Services organization to put events to the specified event bus. Amazon EventBridge
(CloudWatch Events) rules in your account are triggered by these events arriving to an
event bus in your account.  For another account to send events to your account, that
external account must have an EventBridge rule with your account's event bus as a target.
To enable multiple Amazon Web Services accounts to put events to your event bus, run
PutPermission once for each of these accounts. Or, if all the accounts are members of the
same Amazon Web Services organization, you can run PutPermission once specifying Principal
as \"*\" and specifying the Amazon Web Services organization ID in Condition, to grant
permissions to all accounts in that organization. If you grant permissions using an
organization, then accounts in that organization must specify a RoleArn with proper
permissions when they use PutTarget to add your account's event bus as a target. For more
information, see Sending and Receiving Events Between Amazon Web Services Accounts in the
Amazon EventBridge User Guide. The permission policy on the event bus cannot exceed 10 KB
in size.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Action"`: The action that you are enabling the other account to perform.
- `"Condition"`: This parameter enables you to limit the permission to accounts that
  fulfill a certain condition, such as being a member of a certain Amazon Web Services
  organization. For more information about Amazon Web Services Organizations, see What Is
  Amazon Web Services Organizations in the Amazon Web Services Organizations User Guide. If
  you specify Condition with an Amazon Web Services organization ID, and specify \"*\" as the
  value for Principal, you grant permission to all the accounts in the named organization.
  The Condition is a JSON string which must contain Type, Key, and Value fields.
- `"EventBusName"`: The name of the event bus associated with the rule. If you omit this,
  the default event bus is used.
- `"Policy"`: A JSON string that describes the permission policy statement. You can include
  a Policy parameter in the request instead of using the StatementId, Action, Principal, or
  Condition parameters.
- `"Principal"`: The 12-digit Amazon Web Services account ID that you are permitting to put
  events to your default event bus. Specify \"*\" to permit any account to put events to your
  default event bus. If you specify \"*\" without specifying Condition, avoid creating rules
  that may match undesirable events. To create more secure rules, make sure that the event
  pattern for each rule contains an account field with a specific account ID from which to
  receive events. Rules with an account field do not match any events sent from other
  accounts.
- `"StatementId"`: An identifier string for the external account that you are granting
  permissions to. If you later want to revoke the permission for this external account,
  specify this StatementId when you run RemovePermission.
"""
function put_permission(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_events(
        "PutPermission"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function put_permission(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_events(
        "PutPermission", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    put_rule(name)
    put_rule(name, params::Dict{String,<:Any})

Creates or updates the specified rule. Rules are enabled by default, or based on value of
the state. You can disable a rule using DisableRule. A single rule watches for events from
a single event bus. Events generated by Amazon Web Services services go to your account's
default event bus. Events generated by SaaS partner services or applications go to the
matching partner event bus. If you have custom applications or services, you can specify
whether their events go to your default event bus or a custom event bus that you have
created. For more information, see CreateEventBus. If you are updating an existing rule,
the rule is replaced with what you specify in this PutRule command. If you omit arguments
in PutRule, the old values for those arguments are not kept. Instead, they are replaced
with null values. When you create or update a rule, incoming events might not immediately
start matching to new or updated rules. Allow a short period of time for changes to take
effect. A rule must contain at least an EventPattern or ScheduleExpression. Rules with
EventPatterns are triggered when a matching event is observed. Rules with
ScheduleExpressions self-trigger based on the given schedule. A rule can have both an
EventPattern and a ScheduleExpression, in which case the rule triggers on matching events
as well as on a schedule. When you initially create a rule, you can optionally assign one
or more tags to the rule. Tags can help you organize and categorize your resources. You can
also use them to scope user permissions, by granting a user permission to access or change
only rules with certain tag values. To use the PutRule operation and assign tags, you must
have both the events:PutRule and events:TagResource permissions. If you are updating an
existing rule, any tags you specify in the PutRule operation are ignored. To update the
tags of an existing rule, use TagResource and UntagResource. Most services in Amazon Web
Services treat : or / as the same character in Amazon Resource Names (ARNs). However,
EventBridge uses an exact match in event patterns and rules. Be sure to use the correct ARN
characters when creating event patterns so that they match the ARN syntax in the event you
want to match. In EventBridge, it is possible to create rules that lead to infinite loops,
where a rule is fired repeatedly. For example, a rule might detect that ACLs have changed
on an S3 bucket, and trigger software to change them to the desired state. If the rule is
not written carefully, the subsequent change to the ACLs fires the rule again, creating an
infinite loop. To prevent this, write the rules so that the triggered actions do not
re-fire the same rule. For example, your rule could fire only if ACLs are found to be in a
bad state, instead of after any change.  An infinite loop can quickly cause higher than
expected charges. We recommend that you use budgeting, which alerts you when charges exceed
your specified limit. For more information, see Managing Your Costs with Budgets.

# Arguments
- `name`: The name of the rule that you are creating or updating.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description of the rule.
- `"EventBusName"`: The name or ARN of the event bus to associate with this rule. If you
  omit this, the default event bus is used.
- `"EventPattern"`: The event pattern. For more information, see Events and Event Patterns
  in the Amazon EventBridge User Guide.
- `"RoleArn"`: The Amazon Resource Name (ARN) of the IAM role associated with the rule. If
  you're setting an event bus in another account as the target and that account granted
  permission to your account through an organization instead of directly by the account ID,
  you must specify a RoleArn with proper permissions in the Target structure, instead of here
  in this parameter.
- `"ScheduleExpression"`: The scheduling expression. For example, \"cron(0 20 * * ? *)\" or
  \"rate(5 minutes)\".
- `"State"`: Indicates whether the rule is enabled or disabled.
- `"Tags"`: The list of key-value pairs to associate with the rule.
"""
function put_rule(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_events(
        "PutRule",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_rule(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_events(
        "PutRule",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_targets(rule, targets)
    put_targets(rule, targets, params::Dict{String,<:Any})

Adds the specified targets to the specified rule, or updates the targets if they are
already associated with the rule. Targets are the resources that are invoked when a rule is
triggered. You can configure the following as targets for Events:    API destination
Amazon API Gateway REST API endpoints   API Gateway   Batch job queue   CloudWatch Logs
group   CodeBuild project   CodePipeline   Amazon EC2 CreateSnapshot API call   Amazon EC2
RebootInstances API call   Amazon EC2 StopInstances API call   Amazon EC2
TerminateInstances API call   Amazon ECS tasks   Event bus in a different Amazon Web
Services account or Region. You can use an event bus in the US East (N. Virginia)
us-east-1, US West (Oregon) us-west-2, or Europe (Ireland) eu-west-1 Regions as a target
for a rule.   Firehose delivery stream (Kinesis Data Firehose)   Inspector assessment
template (Amazon Inspector)   Kinesis stream (Kinesis Data Stream)   Lambda function
Redshift clusters (Data API statement execution)   Amazon SNS topic   Amazon SQS queues
(includes FIFO queues   SSM Automation   SSM OpsItem   SSM Run Command   Step Functions
state machines   Creating rules with built-in targets is supported only in the Amazon Web
Services Management Console. The built-in targets are EC2 CreateSnapshot API call, EC2
RebootInstances API call, EC2 StopInstances API call, and EC2 TerminateInstances API call.
For some target types, PutTargets provides target-specific parameters. If the target is a
Kinesis data stream, you can optionally specify which shard the event goes to by using the
KinesisParameters argument. To invoke a command on multiple EC2 instances with one rule,
you can use the RunCommandParameters field. To be able to make API calls against the
resources that you own, Amazon EventBridge needs the appropriate permissions. For Lambda
and Amazon SNS resources, EventBridge relies on resource-based policies. For EC2 instances,
Kinesis Data Streams, Step Functions state machines and API Gateway REST APIs, EventBridge
relies on IAM roles that you specify in the RoleARN argument in PutTargets. For more
information, see Authentication and Access Control in the Amazon EventBridge User Guide. If
another Amazon Web Services account is in the same region and has granted you permission
(using PutPermission), you can send events to that account. Set that account's event bus as
a target of the rules in your account. To send the matched events to the other account,
specify that account's event bus as the Arn value when you run PutTargets. If your account
sends events to another account, your account is charged for each sent event. Each event
sent to another account is charged as a custom event. The account receiving the event is
not charged. For more information, see Amazon EventBridge Pricing.   Input, InputPath, and
InputTransformer are not available with PutTarget if the target is an event bus of a
different Amazon Web Services account.  If you are setting the event bus of another account
as the target, and that account granted permission to your account through an organization
instead of directly by the account ID, then you must specify a RoleArn with proper
permissions in the Target structure. For more information, see Sending and Receiving Events
Between Amazon Web Services Accounts in the Amazon EventBridge User Guide. For more
information about enabling cross-account events, see PutPermission.  Input, InputPath, and
InputTransformer are mutually exclusive and optional parameters of a target. When a rule is
triggered due to a matched event:   If none of the following arguments are specified for a
target, then the entire event is passed to the target in JSON format (unless the target is
Amazon EC2 Run Command or Amazon ECS task, in which case nothing from the event is passed
to the target).   If Input is specified in the form of valid JSON, then the matched event
is overridden with this constant.   If InputPath is specified in the form of JSONPath (for
example, .detail), then only the part of the event specified in the path is passed to the
target (for example, only the detail part of the event is passed).   If InputTransformer is
specified, then one or more specified JSONPaths are extracted from the event and used as
values in a template that you specify as the input to the target.   When you specify
InputPath or InputTransformer, you must use JSON dot notation, not bracket notation. When
you add targets to a rule and the associated rule triggers soon after, new or updated
targets might not be immediately invoked. Allow a short period of time for changes to take
effect. This action can partially fail if too many requests are made at the same time. If
that happens, FailedEntryCount is non-zero in the response and each entry in FailedEntries
provides the ID of the failed target and the error code.

# Arguments
- `rule`: The name of the rule.
- `targets`: The targets to update or add to the rule.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EventBusName"`: The name or ARN of the event bus associated with the rule. If you omit
  this, the default event bus is used.
"""
function put_targets(Rule, Targets; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_events(
        "PutTargets",
        Dict{String,Any}("Rule" => Rule, "Targets" => Targets);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_targets(
    Rule,
    Targets,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_events(
        "PutTargets",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("Rule" => Rule, "Targets" => Targets), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_permission()
    remove_permission(params::Dict{String,<:Any})

Revokes the permission of another Amazon Web Services account to be able to put events to
the specified event bus. Specify the account to revoke by the StatementId value that you
associated with the account when you granted it permission with PutPermission. You can find
the StatementId by using DescribeEventBus.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EventBusName"`: The name of the event bus to revoke permissions for. If you omit this,
  the default event bus is used.
- `"RemoveAllPermissions"`: Specifies whether to remove all permissions.
- `"StatementId"`: The statement ID corresponding to the account that is no longer allowed
  to put events to the default event bus.
"""
function remove_permission(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_events(
        "RemovePermission"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function remove_permission(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_events(
        "RemovePermission", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    remove_targets(ids, rule)
    remove_targets(ids, rule, params::Dict{String,<:Any})

Removes the specified targets from the specified rule. When the rule is triggered, those
targets are no longer be invoked. When you remove a target, when the associated rule
triggers, removed targets might continue to be invoked. Allow a short period of time for
changes to take effect. This action can partially fail if too many requests are made at the
same time. If that happens, FailedEntryCount is non-zero in the response and each entry in
FailedEntries provides the ID of the failed target and the error code.

# Arguments
- `ids`: The IDs of the targets to remove from the rule.
- `rule`: The name of the rule.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EventBusName"`: The name or ARN of the event bus associated with the rule. If you omit
  this, the default event bus is used.
- `"Force"`: If this is a managed rule, created by an Amazon Web Services service on your
  behalf, you must specify Force as True to remove targets. This parameter is ignored for
  rules that are not managed rules. You can check whether a rule is a managed rule by using
  DescribeRule or ListRules and checking the ManagedBy field of the response.
"""
function remove_targets(Ids, Rule; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_events(
        "RemoveTargets",
        Dict{String,Any}("Ids" => Ids, "Rule" => Rule);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_targets(
    Ids,
    Rule,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_events(
        "RemoveTargets",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Ids" => Ids, "Rule" => Rule), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_replay(destination, event_end_time, event_source_arn, event_start_time, replay_name)
    start_replay(destination, event_end_time, event_source_arn, event_start_time, replay_name, params::Dict{String,<:Any})

Starts the specified replay. Events are not necessarily replayed in the exact same order
that they were added to the archive. A replay processes events to replay based on the time
in the event, and replays them using 1 minute intervals. If you specify an EventStartTime
and an EventEndTime that covers a 20 minute time range, the events are replayed from the
first minute of that 20 minute range first. Then the events from the second minute are
replayed. You can use DescribeReplay to determine the progress of a replay. The value
returned for EventLastReplayedTime indicates the time within the specified time range
associated with the last event replayed.

# Arguments
- `destination`: A ReplayDestination object that includes details about the destination for
  the replay.
- `event_end_time`: A time stamp for the time to stop replaying events. Only events that
  occurred between the EventStartTime and EventEndTime are replayed.
- `event_source_arn`: The ARN of the archive to replay events from.
- `event_start_time`: A time stamp for the time to start replaying events. Only events that
  occurred between the EventStartTime and EventEndTime are replayed.
- `replay_name`: The name of the replay to start.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description for the replay to start.
"""
function start_replay(
    Destination,
    EventEndTime,
    EventSourceArn,
    EventStartTime,
    ReplayName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_events(
        "StartReplay",
        Dict{String,Any}(
            "Destination" => Destination,
            "EventEndTime" => EventEndTime,
            "EventSourceArn" => EventSourceArn,
            "EventStartTime" => EventStartTime,
            "ReplayName" => ReplayName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_replay(
    Destination,
    EventEndTime,
    EventSourceArn,
    EventStartTime,
    ReplayName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_events(
        "StartReplay",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Destination" => Destination,
                    "EventEndTime" => EventEndTime,
                    "EventSourceArn" => EventSourceArn,
                    "EventStartTime" => EventStartTime,
                    "ReplayName" => ReplayName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Assigns one or more tags (key-value pairs) to the specified EventBridge resource. Tags can
help you organize and categorize your resources. You can also use them to scope user
permissions by granting a user permission to access or change only resources with certain
tag values. In EventBridge, rules and event buses can be tagged. Tags don't have any
semantic meaning to Amazon Web Services and are interpreted strictly as strings of
characters. You can use the TagResource action with a resource that already has tags. If
you specify a new tag key, this tag is appended to the list of tags associated with the
resource. If you specify a tag key that is already associated with the resource, the new
tag value that you specify replaces the previous value for that tag. You can associate as
many as 50 tags with a resource.

# Arguments
- `resource_arn`: The ARN of the EventBridge resource that you're adding tags to.
- `tags`: The list of key-value pairs to associate with the resource.

"""
function tag_resource(ResourceARN, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_events(
        "TagResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceARN,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_events(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    test_event_pattern(event, event_pattern)
    test_event_pattern(event, event_pattern, params::Dict{String,<:Any})

Tests whether the specified event pattern matches the provided event. Most services in
Amazon Web Services treat : or / as the same character in Amazon Resource Names (ARNs).
However, EventBridge uses an exact match in event patterns and rules. Be sure to use the
correct ARN characters when creating event patterns so that they match the ARN syntax in
the event you want to match.

# Arguments
- `event`: The event, in JSON format, to test against the event pattern. The JSON must
  follow the format specified in Amazon Web Services Events, and the following fields are
  mandatory:    id     account     source     time     region     resources     detail-type
- `event_pattern`: The event pattern. For more information, see Events and Event Patterns
  in the Amazon EventBridge User Guide.

"""
function test_event_pattern(
    Event, EventPattern; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_events(
        "TestEventPattern",
        Dict{String,Any}("Event" => Event, "EventPattern" => EventPattern);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function test_event_pattern(
    Event,
    EventPattern,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_events(
        "TestEventPattern",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Event" => Event, "EventPattern" => EventPattern),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes one or more tags from the specified EventBridge resource. In Amazon EventBridge
(CloudWatch Events), rules and event buses can be tagged.

# Arguments
- `resource_arn`: The ARN of the EventBridge resource from which you are removing tags.
- `tag_keys`: The list of tag keys to remove from the resource.

"""
function untag_resource(
    ResourceARN, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_events(
        "UntagResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceARN,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_events(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_api_destination(name)
    update_api_destination(name, params::Dict{String,<:Any})

Updates an API destination.

# Arguments
- `name`: The name of the API destination to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConnectionArn"`: The ARN of the connection to use for the API destination.
- `"Description"`: The name of the API destination to update.
- `"HttpMethod"`: The method to use for the API destination.
- `"InvocationEndpoint"`: The URL to the endpoint to use for the API destination.
- `"InvocationRateLimitPerSecond"`: The maximum number of invocations per second to send to
  the API destination.
"""
function update_api_destination(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_events(
        "UpdateApiDestination",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_api_destination(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_events(
        "UpdateApiDestination",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_archive(archive_name)
    update_archive(archive_name, params::Dict{String,<:Any})

Updates the specified archive.

# Arguments
- `archive_name`: The name of the archive to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: The description for the archive.
- `"EventPattern"`: The event pattern to use to filter events sent to the archive.
- `"RetentionDays"`: The number of days to retain events in the archive.
"""
function update_archive(ArchiveName; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_events(
        "UpdateArchive",
        Dict{String,Any}("ArchiveName" => ArchiveName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_archive(
    ArchiveName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_events(
        "UpdateArchive",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ArchiveName" => ArchiveName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_connection(name)
    update_connection(name, params::Dict{String,<:Any})

Updates settings for a connection.

# Arguments
- `name`: The name of the connection to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AuthParameters"`: The authorization parameters to use for the connection.
- `"AuthorizationType"`: The type of authorization to use for the connection.
- `"Description"`: A description for the connection.
"""
function update_connection(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_events(
        "UpdateConnection",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_connection(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_events(
        "UpdateConnection",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: timestream_query
using AWS.Compat
using AWS.UUIDs

"""
    cancel_query(query_id)
    cancel_query(query_id, params::Dict{String,<:Any})

 Cancels a query that has been issued. Cancellation is provided only if the query has not
completed running before the cancellation request was issued. Because cancellation is an
idempotent operation, subsequent cancellation requests will return a CancellationMessage,
indicating that the query has already been canceled. See code sample for details.

# Arguments
- `query_id`:  The ID of the query that needs to be cancelled. QueryID is returned as part
  of the query result.

"""
function cancel_query(QueryId; aws_config::AbstractAWSConfig=current_aws_config())
    return timestream_query(
        "CancelQuery",
        Dict{String,Any}("QueryId" => QueryId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_query(
    QueryId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return timestream_query(
        "CancelQuery",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("QueryId" => QueryId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_scheduled_query(error_report_configuration, name, notification_configuration, query_string, schedule_configuration, scheduled_query_execution_role_arn)
    create_scheduled_query(error_report_configuration, name, notification_configuration, query_string, schedule_configuration, scheduled_query_execution_role_arn, params::Dict{String,<:Any})

 Create a scheduled query that will be run on your behalf at the configured schedule.
Timestream assumes the execution role provided as part of the
ScheduledQueryExecutionRoleArn parameter to run the query. You can use the
NotificationConfiguration parameter to configure notification for your scheduled query
operations.

# Arguments
- `error_report_configuration`: Configuration for error reporting. Error reports will be
  generated when a problem is encountered when writing the query results.
- `name`: Name of the scheduled query.
- `notification_configuration`: Notification configuration for the scheduled query. A
  notification is sent by Timestream when a query run finishes, when the state is updated or
  when you delete it.
- `query_string`: The query string to run. Parameter names can be specified in the query
  string @ character followed by an identifier. The named Parameter @scheduled_runtime is
  reserved and can be used in the query to get the time at which the query is scheduled to
  run. The timestamp calculated according to the ScheduleConfiguration parameter, will be the
  value of @scheduled_runtime paramater for each query run. For example, consider an instance
  of a scheduled query executing on 2021-12-01 00:00:00. For this instance, the
  @scheduled_runtime parameter is initialized to the timestamp 2021-12-01 00:00:00 when
  invoking the query.
- `schedule_configuration`: The schedule configuration for the query.
- `scheduled_query_execution_role_arn`: The ARN for the IAM role that Timestream will
  assume when running the scheduled query.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: Using a ClientToken makes the call to CreateScheduledQuery idempotent,
  in other words, making the same request repeatedly will produce the same result. Making
  multiple identical CreateScheduledQuery requests has the same effect as making a single
  request.     If CreateScheduledQuery is called without a ClientToken, the Query SDK
  generates a ClientToken on your behalf.    After 8 hours, any request with the same
  ClientToken is treated as a new request.
- `"KmsKeyId"`: The Amazon KMS key used to encrypt the scheduled query resource, at-rest.
  If the Amazon KMS key is not specified, the scheduled query resource will be encrypted with
  a Timestream owned Amazon KMS key. To specify a KMS key, use the key ID, key ARN, alias
  name, or alias ARN. When using an alias name, prefix the name with alias/  If
  ErrorReportConfiguration uses SSE_KMS as encryption type, the same KmsKeyId is used to
  encrypt the error report at rest.
- `"Tags"`: A list of key-value pairs to label the scheduled query.
- `"TargetConfiguration"`: Configuration used for writing the result of a query.
"""
function create_scheduled_query(
    ErrorReportConfiguration,
    Name,
    NotificationConfiguration,
    QueryString,
    ScheduleConfiguration,
    ScheduledQueryExecutionRoleArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return timestream_query(
        "CreateScheduledQuery",
        Dict{String,Any}(
            "ErrorReportConfiguration" => ErrorReportConfiguration,
            "Name" => Name,
            "NotificationConfiguration" => NotificationConfiguration,
            "QueryString" => QueryString,
            "ScheduleConfiguration" => ScheduleConfiguration,
            "ScheduledQueryExecutionRoleArn" => ScheduledQueryExecutionRoleArn,
            "ClientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_scheduled_query(
    ErrorReportConfiguration,
    Name,
    NotificationConfiguration,
    QueryString,
    ScheduleConfiguration,
    ScheduledQueryExecutionRoleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return timestream_query(
        "CreateScheduledQuery",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ErrorReportConfiguration" => ErrorReportConfiguration,
                    "Name" => Name,
                    "NotificationConfiguration" => NotificationConfiguration,
                    "QueryString" => QueryString,
                    "ScheduleConfiguration" => ScheduleConfiguration,
                    "ScheduledQueryExecutionRoleArn" => ScheduledQueryExecutionRoleArn,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_scheduled_query(scheduled_query_arn)
    delete_scheduled_query(scheduled_query_arn, params::Dict{String,<:Any})

Deletes a given scheduled query. This is an irreversible operation.

# Arguments
- `scheduled_query_arn`: The ARN of the scheduled query.

"""
function delete_scheduled_query(
    ScheduledQueryArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return timestream_query(
        "DeleteScheduledQuery",
        Dict{String,Any}("ScheduledQueryArn" => ScheduledQueryArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_scheduled_query(
    ScheduledQueryArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return timestream_query(
        "DeleteScheduledQuery",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ScheduledQueryArn" => ScheduledQueryArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_account_settings()
    describe_account_settings(params::Dict{String,<:Any})

Describes the settings for your account that include the query pricing model and the
configured maximum TCUs the service can use for your query workload. You're charged only
for the duration of compute units used for your workloads.

"""
function describe_account_settings(; aws_config::AbstractAWSConfig=current_aws_config())
    return timestream_query(
        "DescribeAccountSettings"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_account_settings(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return timestream_query(
        "DescribeAccountSettings",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_endpoints()
    describe_endpoints(params::Dict{String,<:Any})

DescribeEndpoints returns a list of available endpoints to make Timestream API calls
against. This API is available through both Write and Query. Because the Timestream SDKs
are designed to transparently work with the service’s architecture, including the
management and mapping of the service endpoints, it is not recommended that you use this
API unless:   You are using VPC endpoints (Amazon Web Services PrivateLink) with Timestream
    Your application uses a programming language that does not yet have SDK support   You
require better control over the client-side implementation   For detailed information on
how and when to use and implement DescribeEndpoints, see The Endpoint Discovery Pattern.

"""
function describe_endpoints(; aws_config::AbstractAWSConfig=current_aws_config())
    return timestream_query(
        "DescribeEndpoints"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_endpoints(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return timestream_query(
        "DescribeEndpoints", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_scheduled_query(scheduled_query_arn)
    describe_scheduled_query(scheduled_query_arn, params::Dict{String,<:Any})

Provides detailed information about a scheduled query.

# Arguments
- `scheduled_query_arn`: The ARN of the scheduled query.

"""
function describe_scheduled_query(
    ScheduledQueryArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return timestream_query(
        "DescribeScheduledQuery",
        Dict{String,Any}("ScheduledQueryArn" => ScheduledQueryArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_scheduled_query(
    ScheduledQueryArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return timestream_query(
        "DescribeScheduledQuery",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ScheduledQueryArn" => ScheduledQueryArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    execute_scheduled_query(invocation_time, scheduled_query_arn)
    execute_scheduled_query(invocation_time, scheduled_query_arn, params::Dict{String,<:Any})

 You can use this API to run a scheduled query manually.

# Arguments
- `invocation_time`: The timestamp in UTC. Query will be run as if it was invoked at this
  timestamp.
- `scheduled_query_arn`: ARN of the scheduled query.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: Not used.
"""
function execute_scheduled_query(
    InvocationTime, ScheduledQueryArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return timestream_query(
        "ExecuteScheduledQuery",
        Dict{String,Any}(
            "InvocationTime" => InvocationTime,
            "ScheduledQueryArn" => ScheduledQueryArn,
            "ClientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function execute_scheduled_query(
    InvocationTime,
    ScheduledQueryArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return timestream_query(
        "ExecuteScheduledQuery",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "InvocationTime" => InvocationTime,
                    "ScheduledQueryArn" => ScheduledQueryArn,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_scheduled_queries()
    list_scheduled_queries(params::Dict{String,<:Any})

Gets a list of all scheduled queries in the caller's Amazon account and Region.
ListScheduledQueries is eventually consistent.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of items to return in the output. If the total number
  of items available is more than the value specified, a NextToken is provided in the output.
  To resume pagination, provide the NextToken value as the argument to the subsequent call to
  ListScheduledQueriesRequest.
- `"NextToken"`:  A pagination token to resume pagination.
"""
function list_scheduled_queries(; aws_config::AbstractAWSConfig=current_aws_config())
    return timestream_query(
        "ListScheduledQueries"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_scheduled_queries(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return timestream_query(
        "ListScheduledQueries",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

List all tags on a Timestream query resource.

# Arguments
- `resource_arn`: The Timestream resource with tags to be listed. This value is an Amazon
  Resource Name (ARN).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of tags to return.
- `"NextToken"`: A pagination token to resume pagination.
"""
function list_tags_for_resource(
    ResourceARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return timestream_query(
        "ListTagsForResource",
        Dict{String,Any}("ResourceARN" => ResourceARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return timestream_query(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceARN" => ResourceARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    prepare_query(query_string)
    prepare_query(query_string, params::Dict{String,<:Any})

A synchronous operation that allows you to submit a query with parameters to be stored by
Timestream for later running. Timestream only supports using this operation with
ValidateOnly set to true.

# Arguments
- `query_string`: The Timestream query string that you want to use as a prepared statement.
  Parameter names can be specified in the query string @ character followed by an identifier.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ValidateOnly"`: By setting this value to true, Timestream will only validate that the
  query string is a valid Timestream query, and not store the prepared query for later use.
"""
function prepare_query(QueryString; aws_config::AbstractAWSConfig=current_aws_config())
    return timestream_query(
        "PrepareQuery",
        Dict{String,Any}("QueryString" => QueryString);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function prepare_query(
    QueryString,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return timestream_query(
        "PrepareQuery",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("QueryString" => QueryString), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    query(query_string)
    query(query_string, params::Dict{String,<:Any})

 Query is a synchronous operation that enables you to run a query against your Amazon
Timestream data. Query will time out after 60 seconds. You must update the default timeout
in the SDK to support a timeout of 60 seconds. See the code sample for details.  Your query
request will fail in the following cases:    If you submit a Query request with the same
client token outside of the 5-minute idempotency window.     If you submit a Query request
with the same client token, but change other parameters, within the 5-minute idempotency
window.     If the size of the row (including the query metadata) exceeds 1 MB, then the
query will fail with the following error message:   Query aborted as max page response size
has been exceeded by the output result row     If the IAM principal of the query initiator
and the result reader are not the same and/or the query initiator and the result reader do
not have the same query string in the query requests, the query will fail with an Invalid
pagination token error.

# Arguments
- `query_string`:  The query to be run by Timestream.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`:  Unique, case-sensitive string of up to 64 ASCII characters specified
  when a Query request is made. Providing a ClientToken makes the call to Query idempotent.
  This means that running the same query repeatedly will produce the same result. In other
  words, making multiple identical Query requests has the same effect as making a single
  request. When using ClientToken in a query, note the following:     If the Query API is
  instantiated without a ClientToken, the Query SDK generates a ClientToken on your behalf.
  If the Query invocation only contains the ClientToken but does not include a NextToken,
  that invocation of Query is assumed to be a new query run.   If the invocation contains
  NextToken, that particular invocation is assumed to be a subsequent invocation of a prior
  call to the Query API, and a result set is returned.    After 4 hours, any request with the
  same ClientToken is treated as a new request.
- `"MaxRows"`:  The total number of rows to be returned in the Query output. The initial
  run of Query with a MaxRows value specified will return the result set of the query in two
  cases:    The size of the result is less than 1MB.   The number of rows in the result set
  is less than the value of maxRows.   Otherwise, the initial invocation of Query only
  returns a NextToken, which can then be used in subsequent calls to fetch the result set. To
  resume pagination, provide the NextToken value in the subsequent command. If the row size
  is large (e.g. a row has many columns), Timestream may return fewer rows to keep the
  response size from exceeding the 1 MB limit. If MaxRows is not provided, Timestream will
  send the necessary number of rows to meet the 1 MB limit.
- `"NextToken"`:  A pagination token used to return a set of results. When the Query API is
  invoked using NextToken, that particular invocation is assumed to be a subsequent
  invocation of a prior call to Query, and a result set is returned. However, if the Query
  invocation only contains the ClientToken, that invocation of Query is assumed to be a new
  query run.  Note the following when using NextToken in a query:   A pagination token can be
  used for up to five Query invocations, OR for a duration of up to 1 hour – whichever
  comes first.   Using the same NextToken will return the same set of records. To keep
  paginating through the result set, you must to use the most recent nextToken.   Suppose a
  Query invocation returns two NextToken values, TokenA and TokenB. If TokenB is used in a
  subsequent Query invocation, then TokenA is invalidated and cannot be reused.   To request
  a previous result set from a query after pagination has begun, you must re-invoke the Query
  API.   The latest NextToken should be used to paginate until null is returned, at which
  point a new NextToken should be used.    If the IAM principal of the query initiator and
  the result reader are not the same and/or the query initiator and the result reader do not
  have the same query string in the query requests, the query will fail with an Invalid
  pagination token error.
"""
function query(QueryString; aws_config::AbstractAWSConfig=current_aws_config())
    return timestream_query(
        "Query",
        Dict{String,Any}("QueryString" => QueryString, "ClientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function query(
    QueryString,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return timestream_query(
        "Query",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "QueryString" => QueryString, "ClientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Associate a set of tags with a Timestream resource. You can then activate these
user-defined tags so that they appear on the Billing and Cost Management console for cost
allocation tracking.

# Arguments
- `resource_arn`: Identifies the Timestream resource to which tags should be added. This
  value is an Amazon Resource Name (ARN).
- `tags`: The tags to be assigned to the Timestream resource.

"""
function tag_resource(ResourceARN, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return timestream_query(
        "TagResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceARN,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return timestream_query(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes the association of tags from a Timestream query resource.

# Arguments
- `resource_arn`: The Timestream resource that the tags will be removed from. This value is
  an Amazon Resource Name (ARN).
- `tag_keys`: A list of tags keys. Existing tags of the resource whose keys are members of
  this list will be removed from the Timestream resource.

"""
function untag_resource(
    ResourceARN, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return timestream_query(
        "UntagResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceARN,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return timestream_query(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_account_settings()
    update_account_settings(params::Dict{String,<:Any})

Transitions your account to use TCUs for query pricing and modifies the maximum query
compute units that you've configured. If you reduce the value of MaxQueryTCU to a desired
configuration, the new value can take up to 24 hours to be effective.  After you've
transitioned your account to use TCUs for query pricing, you can't transition to using
bytes scanned for query pricing.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxQueryTCU"`: The maximum number of compute units the service will use at any point in
  time to serve your queries. To run queries, you must set a minimum capacity of 4 TCU. You
  can set the maximum number of TCU in multiples of 4, for example, 4, 8, 16, 32, and so on.
  The maximum value supported for MaxQueryTCU is 1000. To request an increase to this soft
  limit, contact Amazon Web Services Support. For information about the default quota for
  maxQueryTCU, see Default quotas.
- `"QueryPricingModel"`: The pricing model for queries in an account.
"""
function update_account_settings(; aws_config::AbstractAWSConfig=current_aws_config())
    return timestream_query(
        "UpdateAccountSettings"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function update_account_settings(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return timestream_query(
        "UpdateAccountSettings",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_scheduled_query(scheduled_query_arn, state)
    update_scheduled_query(scheduled_query_arn, state, params::Dict{String,<:Any})

Update a scheduled query.

# Arguments
- `scheduled_query_arn`: ARN of the scheuled query.
- `state`: State of the scheduled query.

"""
function update_scheduled_query(
    ScheduledQueryArn, State; aws_config::AbstractAWSConfig=current_aws_config()
)
    return timestream_query(
        "UpdateScheduledQuery",
        Dict{String,Any}("ScheduledQueryArn" => ScheduledQueryArn, "State" => State);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_scheduled_query(
    ScheduledQueryArn,
    State,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return timestream_query(
        "UpdateScheduledQuery",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ScheduledQueryArn" => ScheduledQueryArn, "State" => State
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: glacier
using AWS.Compat
using AWS.UUIDs

"""
    abort_multipart_upload(account_id, upload_id, vault_name)
    abort_multipart_upload(account_id, upload_id, vault_name, params::Dict{String,<:Any})

This operation aborts a multipart upload identified by the upload ID. After the Abort
Multipart Upload request succeeds, you cannot upload any more parts to the multipart upload
or complete the multipart upload. Aborting a completed upload fails. However, aborting an
already-aborted upload will succeed, for a short time. For more information about uploading
a part and completing a multipart upload, see UploadMultipartPart and
CompleteMultipartUpload. This operation is idempotent. An AWS account has full permission
to perform all operations (actions). However, AWS Identity and Access Management (IAM)
users don't have any permissions by default. You must grant them explicit permission to
perform specific actions. For more information, see Access Control Using AWS Identity and
Access Management (IAM).  For conceptual information and underlying REST API, see Working
with Archives in Amazon S3 Glacier and Abort Multipart Upload in the Amazon Glacier
Developer Guide.

# Arguments
- `account_id`: The AccountId value is the AWS account ID of the account that owns the
  vault. You can either specify an AWS account ID or optionally a single '-' (hyphen), in
  which case Amazon S3 Glacier uses the AWS account ID associated with the credentials used
  to sign the request. If you use an account ID, do not include any hyphens ('-') in the ID.
- `upload_id`: The upload ID of the multipart upload to delete.
- `vault_name`: The name of the vault.

"""
function abort_multipart_upload(
    accountId, uploadId, vaultName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return glacier(
        "DELETE",
        "/$(accountId)/vaults/$(vaultName)/multipart-uploads/$(uploadId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function abort_multipart_upload(
    accountId,
    uploadId,
    vaultName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return glacier(
        "DELETE",
        "/$(accountId)/vaults/$(vaultName)/multipart-uploads/$(uploadId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    abort_vault_lock(account_id, vault_name)
    abort_vault_lock(account_id, vault_name, params::Dict{String,<:Any})

This operation aborts the vault locking process if the vault lock is not in the Locked
state. If the vault lock is in the Locked state when this operation is requested, the
operation returns an AccessDeniedException error. Aborting the vault locking process
removes the vault lock policy from the specified vault.  A vault lock is put into the
InProgress state by calling InitiateVaultLock. A vault lock is put into the Locked state by
calling CompleteVaultLock. You can get the state of a vault lock by calling GetVaultLock.
For more information about the vault locking process, see Amazon Glacier Vault Lock. For
more information about vault lock policies, see Amazon Glacier Access Control with Vault
Lock Policies.  This operation is idempotent. You can successfully invoke this operation
multiple times, if the vault lock is in the InProgress state or if there is no policy
associated with the vault.

# Arguments
- `account_id`: The AccountId value is the AWS account ID. This value must match the AWS
  account ID associated with the credentials used to sign the request. You can either specify
  an AWS account ID or optionally a single '-' (hyphen), in which case Amazon Glacier uses
  the AWS account ID associated with the credentials used to sign the request. If you specify
  your account ID, do not include any hyphens ('-') in the ID.
- `vault_name`: The name of the vault.

"""
function abort_vault_lock(
    accountId, vaultName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return glacier(
        "DELETE",
        "/$(accountId)/vaults/$(vaultName)/lock-policy";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function abort_vault_lock(
    accountId,
    vaultName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return glacier(
        "DELETE",
        "/$(accountId)/vaults/$(vaultName)/lock-policy",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    add_tags_to_vault(account_id, vault_name)
    add_tags_to_vault(account_id, vault_name, params::Dict{String,<:Any})

This operation adds the specified tags to a vault. Each tag is composed of a key and a
value. Each vault can have up to 10 tags. If your request would cause the tag limit for the
vault to be exceeded, the operation throws the LimitExceededException error. If a tag
already exists on the vault under a specified key, the existing key value will be
overwritten. For more information about tags, see Tagging Amazon S3 Glacier Resources.

# Arguments
- `account_id`: The AccountId value is the AWS account ID of the account that owns the
  vault. You can either specify an AWS account ID or optionally a single '-' (hyphen), in
  which case Amazon S3 Glacier uses the AWS account ID associated with the credentials used
  to sign the request. If you use an account ID, do not include any hyphens ('-') in the ID.
- `vault_name`: The name of the vault.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: The tags to add to the vault. Each tag is composed of a key and a value. The
  value can be an empty string.
"""
function add_tags_to_vault(
    accountId, vaultName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return glacier(
        "POST",
        "/$(accountId)/vaults/$(vaultName)/tags?operation=add";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_tags_to_vault(
    accountId,
    vaultName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return glacier(
        "POST",
        "/$(accountId)/vaults/$(vaultName)/tags?operation=add",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    complete_multipart_upload(account_id, upload_id, vault_name)
    complete_multipart_upload(account_id, upload_id, vault_name, params::Dict{String,<:Any})

You call this operation to inform Amazon S3 Glacier (Glacier) that all the archive parts
have been uploaded and that Glacier can now assemble the archive from the uploaded parts.
After assembling and saving the archive to the vault, Glacier returns the URI path of the
newly created archive resource. Using the URI path, you can then access the archive. After
you upload an archive, you should save the archive ID returned to retrieve the archive at a
later point. You can also get the vault inventory to obtain a list of archive IDs in a
vault. For more information, see InitiateJob. In the request, you must include the computed
SHA256 tree hash of the entire archive you have uploaded. For information about computing a
SHA256 tree hash, see Computing Checksums. On the server side, Glacier also constructs the
SHA256 tree hash of the assembled archive. If the values match, Glacier saves the archive
to the vault; otherwise, it returns an error, and the operation fails. The ListParts
operation returns a list of parts uploaded for a specific multipart upload. It includes
checksum information for each uploaded part that can be used to debug a bad checksum issue.
Additionally, Glacier also checks for any missing content ranges when assembling the
archive, if missing content ranges are found, Glacier returns an error and the operation
fails. Complete Multipart Upload is an idempotent operation. After your first successful
complete multipart upload, if you call the operation again within a short period, the
operation will succeed and return the same archive ID. This is useful in the event you
experience a network issue that causes an aborted connection or receive a 500 server error,
in which case you can repeat your Complete Multipart Upload request and get the same
archive ID without creating duplicate archives. Note, however, that after the multipart
upload completes, you cannot call the List Parts operation and the multipart upload will
not appear in List Multipart Uploads response, even if idempotent complete is possible. An
AWS account has full permission to perform all operations (actions). However, AWS Identity
and Access Management (IAM) users don't have any permissions by default. You must grant
them explicit permission to perform specific actions. For more information, see Access
Control Using AWS Identity and Access Management (IAM).  For conceptual information and
underlying REST API, see Uploading Large Archives in Parts (Multipart Upload) and Complete
Multipart Upload in the Amazon Glacier Developer Guide.

# Arguments
- `account_id`: The AccountId value is the AWS account ID of the account that owns the
  vault. You can either specify an AWS account ID or optionally a single '-' (hyphen), in
  which case Amazon S3 Glacier uses the AWS account ID associated with the credentials used
  to sign the request. If you use an account ID, do not include any hyphens ('-') in the ID.
- `upload_id`: The upload ID of the multipart upload.
- `vault_name`: The name of the vault.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"x-amz-archive-size"`: The total size, in bytes, of the entire archive. This value
  should be the sum of all the sizes of the individual parts that you uploaded.
- `"x-amz-sha256-tree-hash"`: The SHA256 tree hash of the entire archive. It is the tree
  hash of SHA256 tree hash of the individual parts. If the value you specify in the request
  does not match the SHA256 tree hash of the final assembled archive as computed by Amazon S3
  Glacier (Glacier), Glacier returns an error and the request fails.
"""
function complete_multipart_upload(
    accountId, uploadId, vaultName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return glacier(
        "POST",
        "/$(accountId)/vaults/$(vaultName)/multipart-uploads/$(uploadId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function complete_multipart_upload(
    accountId,
    uploadId,
    vaultName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return glacier(
        "POST",
        "/$(accountId)/vaults/$(vaultName)/multipart-uploads/$(uploadId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    complete_vault_lock(account_id, lock_id, vault_name)
    complete_vault_lock(account_id, lock_id, vault_name, params::Dict{String,<:Any})

This operation completes the vault locking process by transitioning the vault lock from the
InProgress state to the Locked state, which causes the vault lock policy to become
unchangeable. A vault lock is put into the InProgress state by calling InitiateVaultLock.
You can obtain the state of the vault lock by calling GetVaultLock. For more information
about the vault locking process, Amazon Glacier Vault Lock.  This operation is idempotent.
This request is always successful if the vault lock is in the Locked state and the provided
lock ID matches the lock ID originally used to lock the vault. If an invalid lock ID is
passed in the request when the vault lock is in the Locked state, the operation returns an
AccessDeniedException error. If an invalid lock ID is passed in the request when the vault
lock is in the InProgress state, the operation throws an InvalidParameter error.

# Arguments
- `account_id`: The AccountId value is the AWS account ID. This value must match the AWS
  account ID associated with the credentials used to sign the request. You can either specify
  an AWS account ID or optionally a single '-' (hyphen), in which case Amazon Glacier uses
  the AWS account ID associated with the credentials used to sign the request. If you specify
  your account ID, do not include any hyphens ('-') in the ID.
- `lock_id`: The lockId value is the lock ID obtained from a InitiateVaultLock request.
- `vault_name`: The name of the vault.

"""
function complete_vault_lock(
    accountId, lockId, vaultName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return glacier(
        "POST",
        "/$(accountId)/vaults/$(vaultName)/lock-policy/$(lockId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function complete_vault_lock(
    accountId,
    lockId,
    vaultName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return glacier(
        "POST",
        "/$(accountId)/vaults/$(vaultName)/lock-policy/$(lockId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_vault(account_id, vault_name)
    create_vault(account_id, vault_name, params::Dict{String,<:Any})

This operation creates a new vault with the specified name. The name of the vault must be
unique within a region for an AWS account. You can create up to 1,000 vaults per account.
If you need to create more vaults, contact Amazon S3 Glacier. You must use the following
guidelines when naming a vault.   Names can be between 1 and 255 characters long.   Allowed
characters are a-z, A-Z, 0-9, '_' (underscore), '-' (hyphen), and '.' (period).   This
operation is idempotent. An AWS account has full permission to perform all operations
(actions). However, AWS Identity and Access Management (IAM) users don't have any
permissions by default. You must grant them explicit permission to perform specific
actions. For more information, see Access Control Using AWS Identity and Access Management
(IAM).  For conceptual information and underlying REST API, see Creating a Vault in Amazon
Glacier and Create Vault  in the Amazon Glacier Developer Guide.

# Arguments
- `account_id`: The AccountId value is the AWS account ID. This value must match the AWS
  account ID associated with the credentials used to sign the request. You can either specify
  an AWS account ID or optionally a single '-' (hyphen), in which case Amazon S3 Glacier uses
  the AWS account ID associated with the credentials used to sign the request. If you specify
  your account ID, do not include any hyphens ('-') in the ID.
- `vault_name`: The name of the vault.

"""
function create_vault(
    accountId, vaultName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return glacier(
        "PUT",
        "/$(accountId)/vaults/$(vaultName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_vault(
    accountId,
    vaultName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return glacier(
        "PUT",
        "/$(accountId)/vaults/$(vaultName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_archive(account_id, archive_id, vault_name)
    delete_archive(account_id, archive_id, vault_name, params::Dict{String,<:Any})

This operation deletes an archive from a vault. Subsequent requests to initiate a retrieval
of this archive will fail. Archive retrievals that are in progress for this archive ID may
or may not succeed according to the following scenarios:   If the archive retrieval job is
actively preparing the data for download when Amazon S3 Glacier receives the delete archive
request, the archival retrieval operation might fail.   If the archive retrieval job has
successfully prepared the archive for download when Amazon S3 Glacier receives the delete
archive request, you will be able to download the output.   This operation is idempotent.
Attempting to delete an already-deleted archive does not result in an error. An AWS account
has full permission to perform all operations (actions). However, AWS Identity and Access
Management (IAM) users don't have any permissions by default. You must grant them explicit
permission to perform specific actions. For more information, see Access Control Using AWS
Identity and Access Management (IAM).  For conceptual information and underlying REST API,
see Deleting an Archive in Amazon Glacier and Delete Archive in the Amazon Glacier
Developer Guide.

# Arguments
- `account_id`: The AccountId value is the AWS account ID of the account that owns the
  vault. You can either specify an AWS account ID or optionally a single '-' (hyphen), in
  which case Amazon S3 Glacier uses the AWS account ID associated with the credentials used
  to sign the request. If you use an account ID, do not include any hyphens ('-') in the ID.
- `archive_id`: The ID of the archive to delete.
- `vault_name`: The name of the vault.

"""
function delete_archive(
    accountId, archiveId, vaultName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return glacier(
        "DELETE",
        "/$(accountId)/vaults/$(vaultName)/archives/$(archiveId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_archive(
    accountId,
    archiveId,
    vaultName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return glacier(
        "DELETE",
        "/$(accountId)/vaults/$(vaultName)/archives/$(archiveId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_vault(account_id, vault_name)
    delete_vault(account_id, vault_name, params::Dict{String,<:Any})

This operation deletes a vault. Amazon S3 Glacier will delete a vault only if there are no
archives in the vault as of the last inventory and there have been no writes to the vault
since the last inventory. If either of these conditions is not satisfied, the vault
deletion fails (that is, the vault is not removed) and Amazon S3 Glacier returns an error.
You can use DescribeVault to return the number of archives in a vault, and you can use
Initiate a Job (POST jobs) to initiate a new inventory retrieval for a vault. The inventory
contains the archive IDs you use to delete archives using Delete Archive (DELETE archive).
This operation is idempotent. An AWS account has full permission to perform all operations
(actions). However, AWS Identity and Access Management (IAM) users don't have any
permissions by default. You must grant them explicit permission to perform specific
actions. For more information, see Access Control Using AWS Identity and Access Management
(IAM).  For conceptual information and underlying REST API, see Deleting a Vault in Amazon
Glacier and Delete Vault  in the Amazon S3 Glacier Developer Guide.

# Arguments
- `account_id`: The AccountId value is the AWS account ID of the account that owns the
  vault. You can either specify an AWS account ID or optionally a single '-' (hyphen), in
  which case Amazon S3 Glacier uses the AWS account ID associated with the credentials used
  to sign the request. If you use an account ID, do not include any hyphens ('-') in the ID.
- `vault_name`: The name of the vault.

"""
function delete_vault(
    accountId, vaultName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return glacier(
        "DELETE",
        "/$(accountId)/vaults/$(vaultName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_vault(
    accountId,
    vaultName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return glacier(
        "DELETE",
        "/$(accountId)/vaults/$(vaultName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_vault_access_policy(account_id, vault_name)
    delete_vault_access_policy(account_id, vault_name, params::Dict{String,<:Any})

This operation deletes the access policy associated with the specified vault. The operation
is eventually consistent; that is, it might take some time for Amazon S3 Glacier to
completely remove the access policy, and you might still see the effect of the policy for a
short time after you send the delete request. This operation is idempotent. You can invoke
delete multiple times, even if there is no policy associated with the vault. For more
information about vault access policies, see Amazon Glacier Access Control with Vault
Access Policies.

# Arguments
- `account_id`: The AccountId value is the AWS account ID of the account that owns the
  vault. You can either specify an AWS account ID or optionally a single '-' (hyphen), in
  which case Amazon S3 Glacier uses the AWS account ID associated with the credentials used
  to sign the request. If you use an account ID, do not include any hyphens ('-') in the ID.
- `vault_name`: The name of the vault.

"""
function delete_vault_access_policy(
    accountId, vaultName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return glacier(
        "DELETE",
        "/$(accountId)/vaults/$(vaultName)/access-policy";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_vault_access_policy(
    accountId,
    vaultName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return glacier(
        "DELETE",
        "/$(accountId)/vaults/$(vaultName)/access-policy",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_vault_notifications(account_id, vault_name)
    delete_vault_notifications(account_id, vault_name, params::Dict{String,<:Any})

This operation deletes the notification configuration set for a vault. The operation is
eventually consistent; that is, it might take some time for Amazon S3 Glacier to completely
disable the notifications and you might still receive some notifications for a short time
after you send the delete request. An AWS account has full permission to perform all
operations (actions). However, AWS Identity and Access Management (IAM) users don't have
any permissions by default. You must grant them explicit permission to perform specific
actions. For more information, see Access Control Using AWS Identity and Access Management
(IAM).  For conceptual information and underlying REST API, see Configuring Vault
Notifications in Amazon S3 Glacier and Delete Vault Notification Configuration  in the
Amazon S3 Glacier Developer Guide.

# Arguments
- `account_id`: The AccountId value is the AWS account ID of the account that owns the
  vault. You can either specify an AWS account ID or optionally a single '-' (hyphen), in
  which case Amazon S3 Glacier uses the AWS account ID associated with the credentials used
  to sign the request. If you use an account ID, do not include any hyphens ('-') in the ID.
- `vault_name`: The name of the vault.

"""
function delete_vault_notifications(
    accountId, vaultName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return glacier(
        "DELETE",
        "/$(accountId)/vaults/$(vaultName)/notification-configuration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_vault_notifications(
    accountId,
    vaultName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return glacier(
        "DELETE",
        "/$(accountId)/vaults/$(vaultName)/notification-configuration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_job(account_id, job_id, vault_name)
    describe_job(account_id, job_id, vault_name, params::Dict{String,<:Any})

This operation returns information about a job you previously initiated, including the job
initiation date, the user who initiated the job, the job status code/message and the Amazon
SNS topic to notify after Amazon S3 Glacier (Glacier) completes the job. For more
information about initiating a job, see InitiateJob.   This operation enables you to check
the status of your job. However, it is strongly recommended that you set up an Amazon SNS
topic and specify it in your initiate job request so that Glacier can notify the topic
after it completes the job.  A job ID will not expire for at least 24 hours after Glacier
completes the job. An AWS account has full permission to perform all operations (actions).
However, AWS Identity and Access Management (IAM) users don't have any permissions by
default. You must grant them explicit permission to perform specific actions. For more
information, see Access Control Using AWS Identity and Access Management (IAM).  For more
information about using this operation, see the documentation for the underlying REST API
Describe Job in the Amazon Glacier Developer Guide.

# Arguments
- `account_id`: The AccountId value is the AWS account ID of the account that owns the
  vault. You can either specify an AWS account ID or optionally a single '-' (hyphen), in
  which case Amazon S3 Glacier uses the AWS account ID associated with the credentials used
  to sign the request. If you use an account ID, do not include any hyphens ('-') in the ID.
- `job_id`: The ID of the job to describe.
- `vault_name`: The name of the vault.

"""
function describe_job(
    accountId, jobId, vaultName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return glacier(
        "GET",
        "/$(accountId)/vaults/$(vaultName)/jobs/$(jobId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_job(
    accountId,
    jobId,
    vaultName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return glacier(
        "GET",
        "/$(accountId)/vaults/$(vaultName)/jobs/$(jobId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_vault(account_id, vault_name)
    describe_vault(account_id, vault_name, params::Dict{String,<:Any})

This operation returns information about a vault, including the vault's Amazon Resource
Name (ARN), the date the vault was created, the number of archives it contains, and the
total size of all the archives in the vault. The number of archives and their total size
are as of the last inventory generation. This means that if you add or remove an archive
from a vault, and then immediately use Describe Vault, the change in contents will not be
immediately reflected. If you want to retrieve the latest inventory of the vault, use
InitiateJob. Amazon S3 Glacier generates vault inventories approximately daily. For more
information, see Downloading a Vault Inventory in Amazon S3 Glacier.  An AWS account has
full permission to perform all operations (actions). However, AWS Identity and Access
Management (IAM) users don't have any permissions by default. You must grant them explicit
permission to perform specific actions. For more information, see Access Control Using AWS
Identity and Access Management (IAM). For conceptual information and underlying REST API,
see Retrieving Vault Metadata in Amazon S3 Glacier and Describe Vault  in the Amazon
Glacier Developer Guide.

# Arguments
- `account_id`: The AccountId value is the AWS account ID of the account that owns the
  vault. You can either specify an AWS account ID or optionally a single '-' (hyphen), in
  which case Amazon S3 Glacier uses the AWS account ID associated with the credentials used
  to sign the request. If you use an account ID, do not include any hyphens ('-') in the ID.
- `vault_name`: The name of the vault.

"""
function describe_vault(
    accountId, vaultName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return glacier(
        "GET",
        "/$(accountId)/vaults/$(vaultName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_vault(
    accountId,
    vaultName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return glacier(
        "GET",
        "/$(accountId)/vaults/$(vaultName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_data_retrieval_policy(account_id)
    get_data_retrieval_policy(account_id, params::Dict{String,<:Any})

This operation returns the current data retrieval policy for the account and region
specified in the GET request. For more information about data retrieval policies, see
Amazon Glacier Data Retrieval Policies.

# Arguments
- `account_id`: The AccountId value is the AWS account ID. This value must match the AWS
  account ID associated with the credentials used to sign the request. You can either specify
  an AWS account ID or optionally a single '-' (hyphen), in which case Amazon Glacier uses
  the AWS account ID associated with the credentials used to sign the request. If you specify
  your account ID, do not include any hyphens ('-') in the ID.

"""
function get_data_retrieval_policy(
    accountId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return glacier(
        "GET",
        "/$(accountId)/policies/data-retrieval";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_data_retrieval_policy(
    accountId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return glacier(
        "GET",
        "/$(accountId)/policies/data-retrieval",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_job_output(account_id, job_id, vault_name)
    get_job_output(account_id, job_id, vault_name, params::Dict{String,<:Any})

This operation downloads the output of the job you initiated using InitiateJob. Depending
on the job type you specified when you initiated the job, the output will be either the
content of an archive or a vault inventory. You can download all the job output or download
a portion of the output by specifying a byte range. In the case of an archive retrieval
job, depending on the byte range you specify, Amazon S3 Glacier (Glacier) returns the
checksum for the portion of the data. You can compute the checksum on the client and verify
that the values match to ensure the portion you downloaded is the correct data. A job ID
will not expire for at least 24 hours after Glacier completes the job. That a byte range.
For both archive and inventory retrieval jobs, you should verify the downloaded size
against the size returned in the headers from the Get Job Output response. For archive
retrieval jobs, you should also verify that the size is what you expected. If you download
a portion of the output, the expected size is based on the range of bytes you specified.
For example, if you specify a range of bytes=0-1048575, you should verify your download
size is 1,048,576 bytes. If you download an entire archive, the expected size is the size
of the archive when you uploaded it to Amazon S3 Glacier The expected size is also returned
in the headers from the Get Job Output response. In the case of an archive retrieval job,
depending on the byte range you specify, Glacier returns the checksum for the portion of
the data. To ensure the portion you downloaded is the correct data, compute the checksum on
the client, verify that the values match, and verify that the size is what you expected. A
job ID does not expire for at least 24 hours after Glacier completes the job. That is, you
can download the job output within the 24 hours period after Amazon Glacier completes the
job. An AWS account has full permission to perform all operations (actions). However, AWS
Identity and Access Management (IAM) users don't have any permissions by default. You must
grant them explicit permission to perform specific actions. For more information, see
Access Control Using AWS Identity and Access Management (IAM). For conceptual information
and the underlying REST API, see Downloading a Vault Inventory, Downloading an Archive, and
Get Job Output

# Arguments
- `account_id`: The AccountId value is the AWS account ID of the account that owns the
  vault. You can either specify an AWS account ID or optionally a single '-' (hyphen), in
  which case Amazon S3 Glacier uses the AWS account ID associated with the credentials used
  to sign the request. If you use an account ID, do not include any hyphens ('-') in the ID.
- `job_id`: The job ID whose data is downloaded.
- `vault_name`: The name of the vault.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Range"`: The range of bytes to retrieve from the output. For example, if you want to
  download the first 1,048,576 bytes, specify the range as bytes=0-1048575. By default, this
  operation downloads the entire output. If the job output is large, then you can use a range
  to retrieve a portion of the output. This allows you to download the entire output in
  smaller chunks of bytes. For example, suppose you have 1 GB of job output you want to
  download and you decide to download 128 MB chunks of data at a time, which is a total of
  eight Get Job Output requests. You use the following process to download the job output:
  Download a 128 MB chunk of output by specifying the appropriate byte range. Verify that all
  128 MB of data was received.   Along with the data, the response includes a SHA256 tree
  hash of the payload. You compute the checksum of the payload on the client and compare it
  with the checksum you received in the response to ensure you received all the expected
  data.   Repeat steps 1 and 2 for all the eight 128 MB chunks of output data, each time
  specifying the appropriate byte range.   After downloading all the parts of the job output,
  you have a list of eight checksum values. Compute the tree hash of these values to find the
  checksum of the entire output. Using the DescribeJob API, obtain job information of the job
  that provided you the output. The response includes the checksum of the entire archive
  stored in Amazon S3 Glacier. You compare this value with the checksum you computed to
  ensure you have downloaded the entire archive content with no errors.
"""
function get_job_output(
    accountId, jobId, vaultName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return glacier(
        "GET",
        "/$(accountId)/vaults/$(vaultName)/jobs/$(jobId)/output";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_job_output(
    accountId,
    jobId,
    vaultName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return glacier(
        "GET",
        "/$(accountId)/vaults/$(vaultName)/jobs/$(jobId)/output",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_vault_access_policy(account_id, vault_name)
    get_vault_access_policy(account_id, vault_name, params::Dict{String,<:Any})

This operation retrieves the access-policy subresource set on the vault; for more
information on setting this subresource, see Set Vault Access Policy (PUT access-policy).
If there is no access policy set on the vault, the operation returns a 404 Not found error.
For more information about vault access policies, see Amazon Glacier Access Control with
Vault Access Policies.

# Arguments
- `account_id`: The AccountId value is the AWS account ID of the account that owns the
  vault. You can either specify an AWS account ID or optionally a single '-' (hyphen), in
  which case Amazon S3 Glacier uses the AWS account ID associated with the credentials used
  to sign the request. If you use an account ID, do not include any hyphens ('-') in the ID.
- `vault_name`: The name of the vault.

"""
function get_vault_access_policy(
    accountId, vaultName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return glacier(
        "GET",
        "/$(accountId)/vaults/$(vaultName)/access-policy";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_vault_access_policy(
    accountId,
    vaultName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return glacier(
        "GET",
        "/$(accountId)/vaults/$(vaultName)/access-policy",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_vault_lock(account_id, vault_name)
    get_vault_lock(account_id, vault_name, params::Dict{String,<:Any})

This operation retrieves the following attributes from the lock-policy subresource set on
the specified vault:    The vault lock policy set on the vault.   The state of the vault
lock, which is either InProgess or Locked.   When the lock ID expires. The lock ID is used
to complete the vault locking process.   When the vault lock was initiated and put into the
InProgress state.   A vault lock is put into the InProgress state by calling
InitiateVaultLock. A vault lock is put into the Locked state by calling CompleteVaultLock.
You can abort the vault locking process by calling AbortVaultLock. For more information
about the vault locking process, Amazon Glacier Vault Lock.  If there is no vault lock
policy set on the vault, the operation returns a 404 Not found error. For more information
about vault lock policies, Amazon Glacier Access Control with Vault Lock Policies.

# Arguments
- `account_id`: The AccountId value is the AWS account ID of the account that owns the
  vault. You can either specify an AWS account ID or optionally a single '-' (hyphen), in
  which case Amazon S3 Glacier uses the AWS account ID associated with the credentials used
  to sign the request. If you use an account ID, do not include any hyphens ('-') in the ID.
- `vault_name`: The name of the vault.

"""
function get_vault_lock(
    accountId, vaultName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return glacier(
        "GET",
        "/$(accountId)/vaults/$(vaultName)/lock-policy";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_vault_lock(
    accountId,
    vaultName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return glacier(
        "GET",
        "/$(accountId)/vaults/$(vaultName)/lock-policy",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_vault_notifications(account_id, vault_name)
    get_vault_notifications(account_id, vault_name, params::Dict{String,<:Any})

This operation retrieves the notification-configuration subresource of the specified vault.
For information about setting a notification configuration on a vault, see
SetVaultNotifications. If a notification configuration for a vault is not set, the
operation returns a 404 Not Found error. For more information about vault notifications,
see Configuring Vault Notifications in Amazon S3 Glacier.  An AWS account has full
permission to perform all operations (actions). However, AWS Identity and Access Management
(IAM) users don't have any permissions by default. You must grant them explicit permission
to perform specific actions. For more information, see Access Control Using AWS Identity
and Access Management (IAM). For conceptual information and underlying REST API, see
Configuring Vault Notifications in Amazon S3 Glacier and Get Vault Notification
Configuration  in the Amazon Glacier Developer Guide.

# Arguments
- `account_id`: The AccountId value is the AWS account ID of the account that owns the
  vault. You can either specify an AWS account ID or optionally a single '-' (hyphen), in
  which case Amazon S3 Glacier uses the AWS account ID associated with the credentials used
  to sign the request. If you use an account ID, do not include any hyphens ('-') in the ID.
- `vault_name`: The name of the vault.

"""
function get_vault_notifications(
    accountId, vaultName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return glacier(
        "GET",
        "/$(accountId)/vaults/$(vaultName)/notification-configuration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_vault_notifications(
    accountId,
    vaultName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return glacier(
        "GET",
        "/$(accountId)/vaults/$(vaultName)/notification-configuration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    initiate_job(account_id, vault_name)
    initiate_job(account_id, vault_name, params::Dict{String,<:Any})

This operation initiates a job of the specified type, which can be a select, an archival
retrieval, or a vault retrieval. For more information about using this operation, see the
documentation for the underlying REST API Initiate a Job.

# Arguments
- `account_id`: The AccountId value is the AWS account ID of the account that owns the
  vault. You can either specify an AWS account ID or optionally a single '-' (hyphen), in
  which case Amazon S3 Glacier uses the AWS account ID associated with the credentials used
  to sign the request. If you use an account ID, do not include any hyphens ('-') in the ID.
- `vault_name`: The name of the vault.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"jobParameters"`: Provides options for specifying job information.
"""
function initiate_job(
    accountId, vaultName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return glacier(
        "POST",
        "/$(accountId)/vaults/$(vaultName)/jobs";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function initiate_job(
    accountId,
    vaultName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return glacier(
        "POST",
        "/$(accountId)/vaults/$(vaultName)/jobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    initiate_multipart_upload(account_id, vault_name)
    initiate_multipart_upload(account_id, vault_name, params::Dict{String,<:Any})

This operation initiates a multipart upload. Amazon S3 Glacier creates a multipart upload
resource and returns its ID in the response. The multipart upload ID is used in subsequent
requests to upload parts of an archive (see UploadMultipartPart). When you initiate a
multipart upload, you specify the part size in number of bytes. The part size must be a
megabyte (1024 KB) multiplied by a power of 2-for example, 1048576 (1 MB), 2097152 (2 MB),
4194304 (4 MB), 8388608 (8 MB), and so on. The minimum allowable part size is 1 MB, and the
maximum is 4 GB. Every part you upload to this resource (see UploadMultipartPart), except
the last one, must have the same size. The last one can be the same size or smaller. For
example, suppose you want to upload a 16.2 MB file. If you initiate the multipart upload
with a part size of 4 MB, you will upload four parts of 4 MB each and one part of 0.2 MB.
You don't need to know the size of the archive when you start a multipart upload because
Amazon S3 Glacier does not require you to specify the overall archive size.  After you
complete the multipart upload, Amazon S3 Glacier (Glacier) removes the multipart upload
resource referenced by the ID. Glacier also removes the multipart upload resource if you
cancel the multipart upload or it may be removed if there is no activity for a period of 24
hours. An AWS account has full permission to perform all operations (actions). However, AWS
Identity and Access Management (IAM) users don't have any permissions by default. You must
grant them explicit permission to perform specific actions. For more information, see
Access Control Using AWS Identity and Access Management (IAM). For conceptual information
and underlying REST API, see Uploading Large Archives in Parts (Multipart Upload) and
Initiate Multipart Upload in the Amazon Glacier Developer Guide.

# Arguments
- `account_id`: The AccountId value is the AWS account ID of the account that owns the
  vault. You can either specify an AWS account ID or optionally a single '-' (hyphen), in
  which case Amazon S3 Glacier uses the AWS account ID associated with the credentials used
  to sign the request. If you use an account ID, do not include any hyphens ('-') in the ID.
- `vault_name`: The name of the vault.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"x-amz-archive-description"`: The archive description that you are uploading in parts.
  The part size must be a megabyte (1024 KB) multiplied by a power of 2, for example 1048576
  (1 MB), 2097152 (2 MB), 4194304 (4 MB), 8388608 (8 MB), and so on. The minimum allowable
  part size is 1 MB, and the maximum is 4 GB (4096 MB).
- `"x-amz-part-size"`: The size of each part except the last, in bytes. The last part can
  be smaller than this part size.
"""
function initiate_multipart_upload(
    accountId, vaultName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return glacier(
        "POST",
        "/$(accountId)/vaults/$(vaultName)/multipart-uploads";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function initiate_multipart_upload(
    accountId,
    vaultName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return glacier(
        "POST",
        "/$(accountId)/vaults/$(vaultName)/multipart-uploads",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    initiate_vault_lock(account_id, vault_name)
    initiate_vault_lock(account_id, vault_name, params::Dict{String,<:Any})

This operation initiates the vault locking process by doing the following:   Installing a
vault lock policy on the specified vault.   Setting the lock state of vault lock to
InProgress.   Returning a lock ID, which is used to complete the vault locking process.
You can set one vault lock policy for each vault and this policy can be up to 20 KB in
size. For more information about vault lock policies, see Amazon Glacier Access Control
with Vault Lock Policies.  You must complete the vault locking process within 24 hours
after the vault lock enters the InProgress state. After the 24 hour window ends, the lock
ID expires, the vault automatically exits the InProgress state, and the vault lock policy
is removed from the vault. You call CompleteVaultLock to complete the vault locking process
by setting the state of the vault lock to Locked.  After a vault lock is in the Locked
state, you cannot initiate a new vault lock for the vault. You can abort the vault locking
process by calling AbortVaultLock. You can get the state of the vault lock by calling
GetVaultLock. For more information about the vault locking process, Amazon Glacier Vault
Lock. If this operation is called when the vault lock is in the InProgress state, the
operation returns an AccessDeniedException error. When the vault lock is in the InProgress
state you must call AbortVaultLock before you can initiate a new vault lock policy.

# Arguments
- `account_id`: The AccountId value is the AWS account ID. This value must match the AWS
  account ID associated with the credentials used to sign the request. You can either specify
  an AWS account ID or optionally a single '-' (hyphen), in which case Amazon Glacier uses
  the AWS account ID associated with the credentials used to sign the request. If you specify
  your account ID, do not include any hyphens ('-') in the ID.
- `vault_name`: The name of the vault.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"policy"`: The vault lock policy as a JSON string, which uses \"\" as an escape
  character.
"""
function initiate_vault_lock(
    accountId, vaultName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return glacier(
        "POST",
        "/$(accountId)/vaults/$(vaultName)/lock-policy";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function initiate_vault_lock(
    accountId,
    vaultName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return glacier(
        "POST",
        "/$(accountId)/vaults/$(vaultName)/lock-policy",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_jobs(account_id, vault_name)
    list_jobs(account_id, vault_name, params::Dict{String,<:Any})

This operation lists jobs for a vault, including jobs that are in-progress and jobs that
have recently finished. The List Job operation returns a list of these jobs sorted by job
initiation time.  Amazon Glacier retains recently completed jobs for a period before
deleting them; however, it eventually removes completed jobs. The output of completed jobs
can be retrieved. Retaining completed jobs for a period of time after they have completed
enables you to get a job output in the event you miss the job completion notification or
your first attempt to download it fails. For example, suppose you start an archive
retrieval job to download an archive. After the job completes, you start to download the
archive but encounter a network error. In this scenario, you can retry and download the
archive while the job exists.  The List Jobs operation supports pagination. You should
always check the response Marker field. If there are no more jobs to list, the Marker field
is set to null. If there are more jobs to list, the Marker field is set to a non-null
value, which you can use to continue the pagination of the list. To return a list of jobs
that begins at a specific job, set the marker request parameter to the Marker value for
that job that you obtained from a previous List Jobs request. You can set a maximum limit
for the number of jobs returned in the response by specifying the limit parameter in the
request. The default limit is 50. The number of jobs returned might be fewer than the
limit, but the number of returned jobs never exceeds the limit. Additionally, you can
filter the jobs list returned by specifying the optional statuscode parameter or completed
parameter, or both. Using the statuscode parameter, you can specify to return only jobs
that match either the InProgress, Succeeded, or Failed status. Using the completed
parameter, you can specify to return only jobs that were completed (true) or jobs that were
not completed (false). For more information about using this operation, see the
documentation for the underlying REST API List Jobs.

# Arguments
- `account_id`: The AccountId value is the AWS account ID of the account that owns the
  vault. You can either specify an AWS account ID or optionally a single '-' (hyphen), in
  which case Amazon S3 Glacier uses the AWS account ID associated with the credentials used
  to sign the request. If you use an account ID, do not include any hyphens ('-') in the ID.
- `vault_name`: The name of the vault.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"completed"`: The state of the jobs to return. You can specify true or false.
- `"limit"`: The maximum number of jobs to be returned. The default limit is 50. The number
  of jobs returned might be fewer than the specified limit, but the number of returned jobs
  never exceeds the limit.
- `"marker"`: An opaque string used for pagination. This value specifies the job at which
  the listing of jobs should begin. Get the marker value from a previous List Jobs response.
  You only need to include the marker if you are continuing the pagination of results started
  in a previous List Jobs request.
- `"statuscode"`: The type of job status to return. You can specify the following values:
  InProgress, Succeeded, or Failed.
"""
function list_jobs(accountId, vaultName; aws_config::AbstractAWSConfig=current_aws_config())
    return glacier(
        "GET",
        "/$(accountId)/vaults/$(vaultName)/jobs";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_jobs(
    accountId,
    vaultName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return glacier(
        "GET",
        "/$(accountId)/vaults/$(vaultName)/jobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_multipart_uploads(account_id, vault_name)
    list_multipart_uploads(account_id, vault_name, params::Dict{String,<:Any})

This operation lists in-progress multipart uploads for the specified vault. An in-progress
multipart upload is a multipart upload that has been initiated by an
InitiateMultipartUpload request, but has not yet been completed or aborted. The list
returned in the List Multipart Upload response has no guaranteed order.  The List Multipart
Uploads operation supports pagination. By default, this operation returns up to 50
multipart uploads in the response. You should always check the response for a marker at
which to continue the list; if there are no more items the marker is null. To return a list
of multipart uploads that begins at a specific upload, set the marker request parameter to
the value you obtained from a previous List Multipart Upload request. You can also limit
the number of uploads returned in the response by specifying the limit parameter in the
request. Note the difference between this operation and listing parts (ListParts). The List
Multipart Uploads operation lists all multipart uploads for a vault and does not require a
multipart upload ID. The List Parts operation requires a multipart upload ID since parts
are associated with a single upload. An AWS account has full permission to perform all
operations (actions). However, AWS Identity and Access Management (IAM) users don't have
any permissions by default. You must grant them explicit permission to perform specific
actions. For more information, see Access Control Using AWS Identity and Access Management
(IAM). For conceptual information and the underlying REST API, see Working with Archives in
Amazon S3 Glacier and List Multipart Uploads  in the Amazon Glacier Developer Guide.

# Arguments
- `account_id`: The AccountId value is the AWS account ID of the account that owns the
  vault. You can either specify an AWS account ID or optionally a single '-' (hyphen), in
  which case Amazon S3 Glacier uses the AWS account ID associated with the credentials used
  to sign the request. If you use an account ID, do not include any hyphens ('-') in the ID.
- `vault_name`: The name of the vault.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"limit"`: Specifies the maximum number of uploads returned in the response body. If this
  value is not specified, the List Uploads operation returns up to 50 uploads.
- `"marker"`: An opaque string used for pagination. This value specifies the upload at
  which the listing of uploads should begin. Get the marker value from a previous List
  Uploads response. You need only include the marker if you are continuing the pagination of
  results started in a previous List Uploads request.
"""
function list_multipart_uploads(
    accountId, vaultName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return glacier(
        "GET",
        "/$(accountId)/vaults/$(vaultName)/multipart-uploads";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_multipart_uploads(
    accountId,
    vaultName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return glacier(
        "GET",
        "/$(accountId)/vaults/$(vaultName)/multipart-uploads",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_parts(account_id, upload_id, vault_name)
    list_parts(account_id, upload_id, vault_name, params::Dict{String,<:Any})

This operation lists the parts of an archive that have been uploaded in a specific
multipart upload. You can make this request at any time during an in-progress multipart
upload before you complete the upload (see CompleteMultipartUpload. List Parts returns an
error for completed uploads. The list returned in the List Parts response is sorted by part
range.  The List Parts operation supports pagination. By default, this operation returns up
to 50 uploaded parts in the response. You should always check the response for a marker at
which to continue the list; if there are no more items the marker is null. To return a list
of parts that begins at a specific part, set the marker request parameter to the value you
obtained from a previous List Parts request. You can also limit the number of parts
returned in the response by specifying the limit parameter in the request.  An AWS account
has full permission to perform all operations (actions). However, AWS Identity and Access
Management (IAM) users don't have any permissions by default. You must grant them explicit
permission to perform specific actions. For more information, see Access Control Using AWS
Identity and Access Management (IAM). For conceptual information and the underlying REST
API, see Working with Archives in Amazon S3 Glacier and List Parts in the Amazon Glacier
Developer Guide.

# Arguments
- `account_id`: The AccountId value is the AWS account ID of the account that owns the
  vault. You can either specify an AWS account ID or optionally a single '-' (hyphen), in
  which case Amazon S3 Glacier uses the AWS account ID associated with the credentials used
  to sign the request. If you use an account ID, do not include any hyphens ('-') in the ID.
- `upload_id`: The upload ID of the multipart upload.
- `vault_name`: The name of the vault.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"limit"`: The maximum number of parts to be returned. The default limit is 50. The
  number of parts returned might be fewer than the specified limit, but the number of
  returned parts never exceeds the limit.
- `"marker"`: An opaque string used for pagination. This value specifies the part at which
  the listing of parts should begin. Get the marker value from the response of a previous
  List Parts response. You need only include the marker if you are continuing the pagination
  of results started in a previous List Parts request.
"""
function list_parts(
    accountId, uploadId, vaultName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return glacier(
        "GET",
        "/$(accountId)/vaults/$(vaultName)/multipart-uploads/$(uploadId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_parts(
    accountId,
    uploadId,
    vaultName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return glacier(
        "GET",
        "/$(accountId)/vaults/$(vaultName)/multipart-uploads/$(uploadId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_provisioned_capacity(account_id)
    list_provisioned_capacity(account_id, params::Dict{String,<:Any})

This operation lists the provisioned capacity units for the specified AWS account.

# Arguments
- `account_id`: The AWS account ID of the account that owns the vault. You can either
  specify an AWS account ID or optionally a single '-' (hyphen), in which case Amazon S3
  Glacier uses the AWS account ID associated with the credentials used to sign the request.
  If you use an account ID, don't include any hyphens ('-') in the ID.

"""
function list_provisioned_capacity(
    accountId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return glacier(
        "GET",
        "/$(accountId)/provisioned-capacity";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_provisioned_capacity(
    accountId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return glacier(
        "GET",
        "/$(accountId)/provisioned-capacity",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_vault(account_id, vault_name)
    list_tags_for_vault(account_id, vault_name, params::Dict{String,<:Any})

This operation lists all the tags attached to a vault. The operation returns an empty map
if there are no tags. For more information about tags, see Tagging Amazon S3 Glacier
Resources.

# Arguments
- `account_id`: The AccountId value is the AWS account ID of the account that owns the
  vault. You can either specify an AWS account ID or optionally a single '-' (hyphen), in
  which case Amazon S3 Glacier uses the AWS account ID associated with the credentials used
  to sign the request. If you use an account ID, do not include any hyphens ('-') in the ID.
- `vault_name`: The name of the vault.

"""
function list_tags_for_vault(
    accountId, vaultName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return glacier(
        "GET",
        "/$(accountId)/vaults/$(vaultName)/tags";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_vault(
    accountId,
    vaultName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return glacier(
        "GET",
        "/$(accountId)/vaults/$(vaultName)/tags",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_vaults(account_id)
    list_vaults(account_id, params::Dict{String,<:Any})

This operation lists all vaults owned by the calling user's account. The list returned in
the response is ASCII-sorted by vault name. By default, this operation returns up to 10
items. If there are more vaults to list, the response marker field contains the vault
Amazon Resource Name (ARN) at which to continue the list with a new List Vaults request;
otherwise, the marker field is null. To return a list of vaults that begins at a specific
vault, set the marker request parameter to the vault ARN you obtained from a previous List
Vaults request. You can also limit the number of vaults returned in the response by
specifying the limit parameter in the request.  An AWS account has full permission to
perform all operations (actions). However, AWS Identity and Access Management (IAM) users
don't have any permissions by default. You must grant them explicit permission to perform
specific actions. For more information, see Access Control Using AWS Identity and Access
Management (IAM). For conceptual information and underlying REST API, see Retrieving Vault
Metadata in Amazon S3 Glacier and List Vaults  in the Amazon Glacier Developer Guide.

# Arguments
- `account_id`: The AccountId value is the AWS account ID. This value must match the AWS
  account ID associated with the credentials used to sign the request. You can either specify
  an AWS account ID or optionally a single '-' (hyphen), in which case Amazon Glacier uses
  the AWS account ID associated with the credentials used to sign the request. If you specify
  your account ID, do not include any hyphens ('-') in the ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"limit"`: The maximum number of vaults to be returned. The default limit is 10. The
  number of vaults returned might be fewer than the specified limit, but the number of
  returned vaults never exceeds the limit.
- `"marker"`: A string used for pagination. The marker specifies the vault ARN after which
  the listing of vaults should begin.
"""
function list_vaults(accountId; aws_config::AbstractAWSConfig=current_aws_config())
    return glacier(
        "GET",
        "/$(accountId)/vaults";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_vaults(
    accountId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return glacier(
        "GET",
        "/$(accountId)/vaults",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    purchase_provisioned_capacity(account_id)
    purchase_provisioned_capacity(account_id, params::Dict{String,<:Any})

This operation purchases a provisioned capacity unit for an AWS account.

# Arguments
- `account_id`: The AWS account ID of the account that owns the vault. You can either
  specify an AWS account ID or optionally a single '-' (hyphen), in which case Amazon S3
  Glacier uses the AWS account ID associated with the credentials used to sign the request.
  If you use an account ID, don't include any hyphens ('-') in the ID.

"""
function purchase_provisioned_capacity(
    accountId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return glacier(
        "POST",
        "/$(accountId)/provisioned-capacity";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function purchase_provisioned_capacity(
    accountId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return glacier(
        "POST",
        "/$(accountId)/provisioned-capacity",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_tags_from_vault(account_id, vault_name)
    remove_tags_from_vault(account_id, vault_name, params::Dict{String,<:Any})

This operation removes one or more tags from the set of tags attached to a vault. For more
information about tags, see Tagging Amazon S3 Glacier Resources. This operation is
idempotent. The operation will be successful, even if there are no tags attached to the
vault.

# Arguments
- `account_id`: The AccountId value is the AWS account ID of the account that owns the
  vault. You can either specify an AWS account ID or optionally a single '-' (hyphen), in
  which case Amazon S3 Glacier uses the AWS account ID associated with the credentials used
  to sign the request. If you use an account ID, do not include any hyphens ('-') in the ID.
- `vault_name`: The name of the vault.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"TagKeys"`: A list of tag keys. Each corresponding tag is removed from the vault.
"""
function remove_tags_from_vault(
    accountId, vaultName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return glacier(
        "POST",
        "/$(accountId)/vaults/$(vaultName)/tags?operation=remove";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_tags_from_vault(
    accountId,
    vaultName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return glacier(
        "POST",
        "/$(accountId)/vaults/$(vaultName)/tags?operation=remove",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    set_data_retrieval_policy(account_id)
    set_data_retrieval_policy(account_id, params::Dict{String,<:Any})

This operation sets and then enacts a data retrieval policy in the region specified in the
PUT request. You can set one policy per region for an AWS account. The policy is enacted
within a few minutes of a successful PUT operation. The set policy operation does not
affect retrieval jobs that were in progress before the policy was enacted. For more
information about data retrieval policies, see Amazon Glacier Data Retrieval Policies.

# Arguments
- `account_id`: The AccountId value is the AWS account ID. This value must match the AWS
  account ID associated with the credentials used to sign the request. You can either specify
  an AWS account ID or optionally a single '-' (hyphen), in which case Amazon Glacier uses
  the AWS account ID associated with the credentials used to sign the request. If you specify
  your account ID, do not include any hyphens ('-') in the ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Policy"`: The data retrieval policy in JSON format.
"""
function set_data_retrieval_policy(
    accountId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return glacier(
        "PUT",
        "/$(accountId)/policies/data-retrieval";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function set_data_retrieval_policy(
    accountId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return glacier(
        "PUT",
        "/$(accountId)/policies/data-retrieval",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    set_vault_access_policy(account_id, vault_name)
    set_vault_access_policy(account_id, vault_name, params::Dict{String,<:Any})

This operation configures an access policy for a vault and will overwrite an existing
policy. To configure a vault access policy, send a PUT request to the access-policy
subresource of the vault. An access policy is specific to a vault and is also called a
vault subresource. You can set one access policy per vault and the policy can be up to 20
KB in size. For more information about vault access policies, see Amazon Glacier Access
Control with Vault Access Policies.

# Arguments
- `account_id`: The AccountId value is the AWS account ID of the account that owns the
  vault. You can either specify an AWS account ID or optionally a single '-' (hyphen), in
  which case Amazon S3 Glacier uses the AWS account ID associated with the credentials used
  to sign the request. If you use an account ID, do not include any hyphens ('-') in the ID.
- `vault_name`: The name of the vault.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"policy"`: The vault access policy as a JSON string.
"""
function set_vault_access_policy(
    accountId, vaultName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return glacier(
        "PUT",
        "/$(accountId)/vaults/$(vaultName)/access-policy";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function set_vault_access_policy(
    accountId,
    vaultName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return glacier(
        "PUT",
        "/$(accountId)/vaults/$(vaultName)/access-policy",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    set_vault_notifications(account_id, vault_name)
    set_vault_notifications(account_id, vault_name, params::Dict{String,<:Any})

This operation configures notifications that will be sent when specific events happen to a
vault. By default, you don't get any notifications. To configure vault notifications, send
a PUT request to the notification-configuration subresource of the vault. The request
should include a JSON document that provides an Amazon SNS topic and specific events for
which you want Amazon S3 Glacier to send notifications to the topic. Amazon SNS topics must
grant permission to the vault to be allowed to publish notifications to the topic. You can
configure a vault to publish a notification for the following vault events:
ArchiveRetrievalCompleted This event occurs when a job that was initiated for an archive
retrieval is completed (InitiateJob). The status of the completed job can be \"Succeeded\"
or \"Failed\". The notification sent to the SNS topic is the same output as returned from
DescribeJob.     InventoryRetrievalCompleted This event occurs when a job that was
initiated for an inventory retrieval is completed (InitiateJob). The status of the
completed job can be \"Succeeded\" or \"Failed\". The notification sent to the SNS topic is
the same output as returned from DescribeJob.    An AWS account has full permission to
perform all operations (actions). However, AWS Identity and Access Management (IAM) users
don't have any permissions by default. You must grant them explicit permission to perform
specific actions. For more information, see Access Control Using AWS Identity and Access
Management (IAM). For conceptual information and underlying REST API, see Configuring Vault
Notifications in Amazon S3 Glacier and Set Vault Notification Configuration  in the Amazon
Glacier Developer Guide.

# Arguments
- `account_id`: The AccountId value is the AWS account ID of the account that owns the
  vault. You can either specify an AWS account ID or optionally a single '-' (hyphen), in
  which case Amazon S3 Glacier uses the AWS account ID associated with the credentials used
  to sign the request. If you use an account ID, do not include any hyphens ('-') in the ID.
- `vault_name`: The name of the vault.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"vaultNotificationConfig"`: Provides options for specifying notification configuration.
"""
function set_vault_notifications(
    accountId, vaultName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return glacier(
        "PUT",
        "/$(accountId)/vaults/$(vaultName)/notification-configuration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function set_vault_notifications(
    accountId,
    vaultName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return glacier(
        "PUT",
        "/$(accountId)/vaults/$(vaultName)/notification-configuration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    upload_archive(account_id, vault_name)
    upload_archive(account_id, vault_name, params::Dict{String,<:Any})

This operation adds an archive to a vault. This is a synchronous operation, and for a
successful upload, your data is durably persisted. Amazon S3 Glacier returns the archive ID
in the x-amz-archive-id header of the response.  You must use the archive ID to access your
data in Amazon S3 Glacier. After you upload an archive, you should save the archive ID
returned so that you can retrieve or delete the archive later. Besides saving the archive
ID, you can also index it and give it a friendly name to allow for better searching. You
can also use the optional archive description field to specify how the archive is referred
to in an external index of archives, such as you might create in Amazon DynamoDB. You can
also get the vault inventory to obtain a list of archive IDs in a vault. For more
information, see InitiateJob.  You must provide a SHA256 tree hash of the data you are
uploading. For information about computing a SHA256 tree hash, see Computing Checksums.
You can optionally specify an archive description of up to 1,024 printable ASCII
characters. You can get the archive description when you either retrieve the archive or get
the vault inventory. For more information, see InitiateJob. Amazon Glacier does not
interpret the description in any way. An archive description does not need to be unique.
You cannot use the description to retrieve or sort the archive list.  Archives are
immutable. After you upload an archive, you cannot edit the archive or its description. An
AWS account has full permission to perform all operations (actions). However, AWS Identity
and Access Management (IAM) users don't have any permissions by default. You must grant
them explicit permission to perform specific actions. For more information, see Access
Control Using AWS Identity and Access Management (IAM).  For conceptual information and
underlying REST API, see Uploading an Archive in Amazon Glacier and Upload Archive in the
Amazon Glacier Developer Guide.

# Arguments
- `account_id`: The AccountId value is the AWS account ID of the account that owns the
  vault. You can either specify an AWS account ID or optionally a single '-' (hyphen), in
  which case Amazon S3 Glacier uses the AWS account ID associated with the credentials used
  to sign the request. If you use an account ID, do not include any hyphens ('-') in the ID.
- `vault_name`: The name of the vault.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"body"`: The data to upload.
- `"x-amz-archive-description"`: The optional description of the archive you are uploading.
- `"x-amz-sha256-tree-hash"`: The SHA256 tree hash of the data being uploaded.
"""
function upload_archive(
    accountId, vaultName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return glacier(
        "POST",
        "/$(accountId)/vaults/$(vaultName)/archives";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function upload_archive(
    accountId,
    vaultName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return glacier(
        "POST",
        "/$(accountId)/vaults/$(vaultName)/archives",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    upload_multipart_part(account_id, upload_id, vault_name)
    upload_multipart_part(account_id, upload_id, vault_name, params::Dict{String,<:Any})

This operation uploads a part of an archive. You can upload archive parts in any order. You
can also upload them in parallel. You can upload up to 10,000 parts for a multipart upload.
Amazon Glacier rejects your upload part request if any of the following conditions is true:
   SHA256 tree hash does not matchTo ensure that part data is not corrupted in
transmission, you compute a SHA256 tree hash of the part and include it in your request.
Upon receiving the part data, Amazon S3 Glacier also computes a SHA256 tree hash. If these
hash values don't match, the operation fails. For information about computing a SHA256 tree
hash, see Computing Checksums.    Part size does not matchThe size of each part except the
last must match the size specified in the corresponding InitiateMultipartUpload request.
The size of the last part must be the same size as, or smaller than, the specified size.
If you upload a part whose size is smaller than the part size you specified in your
initiate multipart upload request and that part is not the last part, then the upload part
request will succeed. However, the subsequent Complete Multipart Upload request will fail.
   Range does not alignThe byte range value in the request does not align with the part
size specified in the corresponding initiate request. For example, if you specify a part
size of 4194304 bytes (4 MB), then 0 to 4194303 bytes (4 MB - 1) and 4194304 (4 MB) to
8388607 (8 MB - 1) are valid part ranges. However, if you set a range value of 2 MB to 6
MB, the range does not align with the part size and the upload will fail.    This operation
is idempotent. If you upload the same part multiple times, the data included in the most
recent request overwrites the previously uploaded data. An AWS account has full permission
to perform all operations (actions). However, AWS Identity and Access Management (IAM)
users don't have any permissions by default. You must grant them explicit permission to
perform specific actions. For more information, see Access Control Using AWS Identity and
Access Management (IAM).  For conceptual information and underlying REST API, see Uploading
Large Archives in Parts (Multipart Upload) and Upload Part  in the Amazon Glacier Developer
Guide.

# Arguments
- `account_id`: The AccountId value is the AWS account ID of the account that owns the
  vault. You can either specify an AWS account ID or optionally a single '-' (hyphen), in
  which case Amazon S3 Glacier uses the AWS account ID associated with the credentials used
  to sign the request. If you use an account ID, do not include any hyphens ('-') in the ID.
- `upload_id`: The upload ID of the multipart upload.
- `vault_name`: The name of the vault.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Content-Range"`: Identifies the range of bytes in the assembled archive that will be
  uploaded in this part. Amazon S3 Glacier uses this information to assemble the archive in
  the proper sequence. The format of this header follows RFC 2616. An example header is
  Content-Range:bytes 0-4194303/*.
- `"body"`: The data to upload.
- `"x-amz-sha256-tree-hash"`: The SHA256 tree hash of the data being uploaded.
"""
function upload_multipart_part(
    accountId, uploadId, vaultName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return glacier(
        "PUT",
        "/$(accountId)/vaults/$(vaultName)/multipart-uploads/$(uploadId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function upload_multipart_part(
    accountId,
    uploadId,
    vaultName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return glacier(
        "PUT",
        "/$(accountId)/vaults/$(vaultName)/multipart-uploads/$(uploadId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: omics
using AWS.Compat
using AWS.UUIDs

"""
    abort_multipart_read_set_upload(sequence_store_id, upload_id)
    abort_multipart_read_set_upload(sequence_store_id, upload_id, params::Dict{String,<:Any})

Stops a multipart upload.

# Arguments
- `sequence_store_id`: The sequence store ID for the store involved in the multipart upload.
- `upload_id`: The ID for the multipart upload.

"""
function abort_multipart_read_set_upload(
    sequenceStoreId, uploadId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "DELETE",
        "/sequencestore/$(sequenceStoreId)/upload/$(uploadId)/abort";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function abort_multipart_read_set_upload(
    sequenceStoreId,
    uploadId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return omics(
        "DELETE",
        "/sequencestore/$(sequenceStoreId)/upload/$(uploadId)/abort",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    accept_share(share_id)
    accept_share(share_id, params::Dict{String,<:Any})

Accept a resource share request.

# Arguments
- `share_id`: The ID of the resource share.

"""
function accept_share(shareId; aws_config::AbstractAWSConfig=current_aws_config())
    return omics(
        "POST", "/share/$(shareId)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function accept_share(
    shareId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return omics(
        "POST",
        "/share/$(shareId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_delete_read_set(ids, sequence_store_id)
    batch_delete_read_set(ids, sequence_store_id, params::Dict{String,<:Any})

Deletes one or more read sets.

# Arguments
- `ids`: The read sets' IDs.
- `sequence_store_id`: The read sets' sequence store ID.

"""
function batch_delete_read_set(
    ids, sequenceStoreId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "POST",
        "/sequencestore/$(sequenceStoreId)/readset/batch/delete",
        Dict{String,Any}("ids" => ids);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_delete_read_set(
    ids,
    sequenceStoreId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return omics(
        "POST",
        "/sequencestore/$(sequenceStoreId)/readset/batch/delete",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("ids" => ids), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_annotation_import_job(job_id)
    cancel_annotation_import_job(job_id, params::Dict{String,<:Any})

Cancels an annotation import job.

# Arguments
- `job_id`: The job's ID.

"""
function cancel_annotation_import_job(
    jobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "DELETE",
        "/import/annotation/$(jobId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_annotation_import_job(
    jobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "DELETE",
        "/import/annotation/$(jobId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_run(id)
    cancel_run(id, params::Dict{String,<:Any})

Cancels a run.

# Arguments
- `id`: The run's ID.

"""
function cancel_run(id; aws_config::AbstractAWSConfig=current_aws_config())
    return omics(
        "POST", "/run/$(id)/cancel"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function cancel_run(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "POST",
        "/run/$(id)/cancel",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_variant_import_job(job_id)
    cancel_variant_import_job(job_id, params::Dict{String,<:Any})

Cancels a variant import job.

# Arguments
- `job_id`: The job's ID.

"""
function cancel_variant_import_job(
    jobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "DELETE",
        "/import/variant/$(jobId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_variant_import_job(
    jobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "DELETE",
        "/import/variant/$(jobId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    complete_multipart_read_set_upload(parts, sequence_store_id, upload_id)
    complete_multipart_read_set_upload(parts, sequence_store_id, upload_id, params::Dict{String,<:Any})

Concludes a multipart upload once you have uploaded all the components.

# Arguments
- `parts`: The individual uploads or parts of a multipart upload.
- `sequence_store_id`: The sequence store ID for the store involved in the multipart upload.
- `upload_id`: The ID for the multipart upload.

"""
function complete_multipart_read_set_upload(
    parts, sequenceStoreId, uploadId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "POST",
        "/sequencestore/$(sequenceStoreId)/upload/$(uploadId)/complete",
        Dict{String,Any}("parts" => parts);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function complete_multipart_read_set_upload(
    parts,
    sequenceStoreId,
    uploadId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return omics(
        "POST",
        "/sequencestore/$(sequenceStoreId)/upload/$(uploadId)/complete",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("parts" => parts), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_annotation_store(store_format)
    create_annotation_store(store_format, params::Dict{String,<:Any})

Creates an annotation store.

# Arguments
- `store_format`: The annotation file format of the store.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A description for the store.
- `"name"`: A name for the store.
- `"reference"`: The genome reference for the store's annotations.
- `"sseConfig"`: Server-side encryption (SSE) settings for the store.
- `"storeOptions"`: File parsing options for the annotation store.
- `"tags"`: Tags for the store.
- `"versionName"`:  The name given to an annotation store version to distinguish it from
  other versions.
"""
function create_annotation_store(
    storeFormat; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "POST",
        "/annotationStore",
        Dict{String,Any}("storeFormat" => storeFormat);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_annotation_store(
    storeFormat,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return omics(
        "POST",
        "/annotationStore",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("storeFormat" => storeFormat), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_annotation_store_version(name, version_name)
    create_annotation_store_version(name, version_name, params::Dict{String,<:Any})

 Creates a new version of an annotation store.

# Arguments
- `name`:  The name of an annotation store version from which versions are being created.
- `version_name`:  The name given to an annotation store version to distinguish it from
  other versions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`:  The description of an annotation store version.
- `"tags"`:  Any tags added to annotation store version.
- `"versionOptions"`:  The options for an annotation store version.
"""
function create_annotation_store_version(
    name, versionName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "POST",
        "/annotationStore/$(name)/version",
        Dict{String,Any}("versionName" => versionName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_annotation_store_version(
    name,
    versionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return omics(
        "POST",
        "/annotationStore/$(name)/version",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("versionName" => versionName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_multipart_read_set_upload(name, sample_id, sequence_store_id, source_file_type, subject_id)
    create_multipart_read_set_upload(name, sample_id, sequence_store_id, source_file_type, subject_id, params::Dict{String,<:Any})

Begins a multipart read set upload.

# Arguments
- `name`: The name of the read set.
- `sample_id`: The source's sample ID.
- `sequence_store_id`: The sequence store ID for the store that is the destination of the
  multipart uploads.
- `source_file_type`: The type of file being uploaded.
- `subject_id`: The source's subject ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: An idempotency token that can be used to avoid triggering multiple
  multipart uploads.
- `"description"`: The description of the read set.
- `"generatedFrom"`: Where the source originated.
- `"referenceArn"`: The ARN of the reference.
- `"tags"`: Any tags to add to the read set.
"""
function create_multipart_read_set_upload(
    name,
    sampleId,
    sequenceStoreId,
    sourceFileType,
    subjectId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return omics(
        "POST",
        "/sequencestore/$(sequenceStoreId)/upload",
        Dict{String,Any}(
            "name" => name,
            "sampleId" => sampleId,
            "sourceFileType" => sourceFileType,
            "subjectId" => subjectId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_multipart_read_set_upload(
    name,
    sampleId,
    sequenceStoreId,
    sourceFileType,
    subjectId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return omics(
        "POST",
        "/sequencestore/$(sequenceStoreId)/upload",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "name" => name,
                    "sampleId" => sampleId,
                    "sourceFileType" => sourceFileType,
                    "subjectId" => subjectId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_reference_store(name)
    create_reference_store(name, params::Dict{String,<:Any})

Creates a reference store.

# Arguments
- `name`: A name for the store.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: To ensure that requests don't run multiple times, specify a unique token
  for each request.
- `"description"`: A description for the store.
- `"sseConfig"`: Server-side encryption (SSE) settings for the store.
- `"tags"`: Tags for the store.
"""
function create_reference_store(name; aws_config::AbstractAWSConfig=current_aws_config())
    return omics(
        "POST",
        "/referencestore",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_reference_store(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "POST",
        "/referencestore",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_run_group(request_id)
    create_run_group(request_id, params::Dict{String,<:Any})

Creates a run group.

# Arguments
- `request_id`: To ensure that requests don't run multiple times, specify a unique ID for
  each request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxCpus"`: The maximum number of CPUs to use in the group.
- `"maxDuration"`: A maximum run time for the group in minutes.
- `"maxGpus"`: The maximum GPUs that can be used by a run group.
- `"maxRuns"`: The maximum number of concurrent runs for the group.
- `"name"`: A name for the group.
- `"tags"`: Tags for the group.
"""
function create_run_group(requestId; aws_config::AbstractAWSConfig=current_aws_config())
    return omics(
        "POST",
        "/runGroup",
        Dict{String,Any}("requestId" => requestId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_run_group(
    requestId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return omics(
        "POST",
        "/runGroup",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("requestId" => requestId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_sequence_store(name)
    create_sequence_store(name, params::Dict{String,<:Any})

Creates a sequence store.

# Arguments
- `name`: A name for the store.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: To ensure that requests don't run multiple times, specify a unique token
  for each request.
- `"description"`: A description for the store.
- `"eTagAlgorithmFamily"`: The ETag algorithm family to use for ingested read sets.
- `"fallbackLocation"`: An S3 location that is used to store files that have failed a
  direct upload.
- `"sseConfig"`: Server-side encryption (SSE) settings for the store.
- `"tags"`: Tags for the store.
"""
function create_sequence_store(name; aws_config::AbstractAWSConfig=current_aws_config())
    return omics(
        "POST",
        "/sequencestore",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_sequence_store(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "POST",
        "/sequencestore",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_share(principal_subscriber, resource_arn)
    create_share(principal_subscriber, resource_arn, params::Dict{String,<:Any})

Creates a cross-account shared resource. The resource owner makes an offer to share the
resource with the principal subscriber (an AWS user with a different account than the
resource owner). The following resources support cross-account sharing:   Healthomics
variant stores   Healthomics annotation stores   Private workflows

# Arguments
- `principal_subscriber`: The principal subscriber is the account being offered shared
  access to the resource.
- `resource_arn`: The ARN of the resource to be shared.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"shareName"`: A name that the owner defines for the share.
"""
function create_share(
    principalSubscriber, resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "POST",
        "/share",
        Dict{String,Any}(
            "principalSubscriber" => principalSubscriber, "resourceArn" => resourceArn
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_share(
    principalSubscriber,
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return omics(
        "POST",
        "/share",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "principalSubscriber" => principalSubscriber,
                    "resourceArn" => resourceArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_variant_store(reference)
    create_variant_store(reference, params::Dict{String,<:Any})

Creates a variant store.

# Arguments
- `reference`: The genome reference for the store's variants.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A description for the store.
- `"name"`: A name for the store.
- `"sseConfig"`: Server-side encryption (SSE) settings for the store.
- `"tags"`: Tags for the store.
"""
function create_variant_store(reference; aws_config::AbstractAWSConfig=current_aws_config())
    return omics(
        "POST",
        "/variantStore",
        Dict{String,Any}("reference" => reference);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_variant_store(
    reference,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return omics(
        "POST",
        "/variantStore",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("reference" => reference), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_workflow(request_id)
    create_workflow(request_id, params::Dict{String,<:Any})

Creates a workflow.

# Arguments
- `request_id`: To ensure that requests don't run multiple times, specify a unique ID for
  each request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accelerators"`: The computational accelerator specified to run the workflow.
- `"definitionUri"`: The URI of a definition for the workflow.
- `"definitionZip"`: A ZIP archive for the workflow.
- `"description"`: A description for the workflow.
- `"engine"`: An engine for the workflow.
- `"main"`: The path of the main definition file for the workflow.
- `"name"`: A name for the workflow.
- `"parameterTemplate"`: A parameter template for the workflow.
- `"storageCapacity"`: The storage capacity for the workflow in gibibytes.
- `"tags"`: Tags for the workflow.
"""
function create_workflow(requestId; aws_config::AbstractAWSConfig=current_aws_config())
    return omics(
        "POST",
        "/workflow",
        Dict{String,Any}("requestId" => requestId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_workflow(
    requestId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return omics(
        "POST",
        "/workflow",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("requestId" => requestId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_annotation_store(name)
    delete_annotation_store(name, params::Dict{String,<:Any})

Deletes an annotation store.

# Arguments
- `name`: The store's name.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"force"`: Whether to force deletion.
"""
function delete_annotation_store(name; aws_config::AbstractAWSConfig=current_aws_config())
    return omics(
        "DELETE",
        "/annotationStore/$(name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_annotation_store(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "DELETE",
        "/annotationStore/$(name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_annotation_store_versions(name, versions)
    delete_annotation_store_versions(name, versions, params::Dict{String,<:Any})

 Deletes one or multiple versions of an annotation store.

# Arguments
- `name`:  The name of the annotation store from which versions are being deleted.
- `versions`:  The versions of an annotation store to be deleted.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"force"`:  Forces the deletion of an annotation store version when imports are
  in-progress..
"""
function delete_annotation_store_versions(
    name, versions; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "POST",
        "/annotationStore/$(name)/versions/delete",
        Dict{String,Any}("versions" => versions);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_annotation_store_versions(
    name,
    versions,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return omics(
        "POST",
        "/annotationStore/$(name)/versions/delete",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("versions" => versions), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_reference(id, reference_store_id)
    delete_reference(id, reference_store_id, params::Dict{String,<:Any})

Deletes a genome reference.

# Arguments
- `id`: The reference's ID.
- `reference_store_id`: The reference's store ID.

"""
function delete_reference(
    id, referenceStoreId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "DELETE",
        "/referencestore/$(referenceStoreId)/reference/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_reference(
    id,
    referenceStoreId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return omics(
        "DELETE",
        "/referencestore/$(referenceStoreId)/reference/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_reference_store(id)
    delete_reference_store(id, params::Dict{String,<:Any})

Deletes a genome reference store.

# Arguments
- `id`: The store's ID.

"""
function delete_reference_store(id; aws_config::AbstractAWSConfig=current_aws_config())
    return omics(
        "DELETE",
        "/referencestore/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_reference_store(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "DELETE",
        "/referencestore/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_run(id)
    delete_run(id, params::Dict{String,<:Any})

Deletes a workflow run.

# Arguments
- `id`: The run's ID.

"""
function delete_run(id; aws_config::AbstractAWSConfig=current_aws_config())
    return omics(
        "DELETE", "/run/$(id)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function delete_run(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "DELETE",
        "/run/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_run_group(id)
    delete_run_group(id, params::Dict{String,<:Any})

Deletes a workflow run group.

# Arguments
- `id`: The run group's ID.

"""
function delete_run_group(id; aws_config::AbstractAWSConfig=current_aws_config())
    return omics(
        "DELETE", "/runGroup/$(id)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function delete_run_group(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "DELETE",
        "/runGroup/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_sequence_store(id)
    delete_sequence_store(id, params::Dict{String,<:Any})

Deletes a sequence store.

# Arguments
- `id`: The sequence store's ID.

"""
function delete_sequence_store(id; aws_config::AbstractAWSConfig=current_aws_config())
    return omics(
        "DELETE",
        "/sequencestore/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_sequence_store(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "DELETE",
        "/sequencestore/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_share(share_id)
    delete_share(share_id, params::Dict{String,<:Any})

Deletes a resource share. If you are the resource owner, the subscriber will no longer have
access to the shared resource. If you are the subscriber, this operation deletes your
access to the share.

# Arguments
- `share_id`: The ID for the resource share to be deleted.

"""
function delete_share(shareId; aws_config::AbstractAWSConfig=current_aws_config())
    return omics(
        "DELETE",
        "/share/$(shareId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_share(
    shareId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return omics(
        "DELETE",
        "/share/$(shareId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_variant_store(name)
    delete_variant_store(name, params::Dict{String,<:Any})

Deletes a variant store.

# Arguments
- `name`: The store's name.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"force"`: Whether to force deletion.
"""
function delete_variant_store(name; aws_config::AbstractAWSConfig=current_aws_config())
    return omics(
        "DELETE",
        "/variantStore/$(name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_variant_store(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "DELETE",
        "/variantStore/$(name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_workflow(id)
    delete_workflow(id, params::Dict{String,<:Any})

Deletes a workflow.

# Arguments
- `id`: The workflow's ID.

"""
function delete_workflow(id; aws_config::AbstractAWSConfig=current_aws_config())
    return omics(
        "DELETE", "/workflow/$(id)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function delete_workflow(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "DELETE",
        "/workflow/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_annotation_import_job(job_id)
    get_annotation_import_job(job_id, params::Dict{String,<:Any})

Gets information about an annotation import job.

# Arguments
- `job_id`: The job's ID.

"""
function get_annotation_import_job(
    jobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "GET",
        "/import/annotation/$(jobId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_annotation_import_job(
    jobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "GET",
        "/import/annotation/$(jobId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_annotation_store(name)
    get_annotation_store(name, params::Dict{String,<:Any})

Gets information about an annotation store.

# Arguments
- `name`: The store's name.

"""
function get_annotation_store(name; aws_config::AbstractAWSConfig=current_aws_config())
    return omics(
        "GET",
        "/annotationStore/$(name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_annotation_store(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "GET",
        "/annotationStore/$(name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_annotation_store_version(name, version_name)
    get_annotation_store_version(name, version_name, params::Dict{String,<:Any})

 Retrieves the metadata for an annotation store version.

# Arguments
- `name`:  The name given to an annotation store version to distinguish it from others.
- `version_name`:  The name given to an annotation store version to distinguish it from
  others.

"""
function get_annotation_store_version(
    name, versionName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "GET",
        "/annotationStore/$(name)/version/$(versionName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_annotation_store_version(
    name,
    versionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return omics(
        "GET",
        "/annotationStore/$(name)/version/$(versionName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_read_set(id, part_number, sequence_store_id)
    get_read_set(id, part_number, sequence_store_id, params::Dict{String,<:Any})

Gets a file from a read set.

# Arguments
- `id`: The read set's ID.
- `part_number`: The part number to retrieve.
- `sequence_store_id`: The read set's sequence store ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"file"`: The file to retrieve.
"""
function get_read_set(
    id, partNumber, sequenceStoreId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "GET",
        "/sequencestore/$(sequenceStoreId)/readset/$(id)",
        Dict{String,Any}("partNumber" => partNumber);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_read_set(
    id,
    partNumber,
    sequenceStoreId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return omics(
        "GET",
        "/sequencestore/$(sequenceStoreId)/readset/$(id)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("partNumber" => partNumber), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_read_set_activation_job(id, sequence_store_id)
    get_read_set_activation_job(id, sequence_store_id, params::Dict{String,<:Any})

Gets information about a read set activation job.

# Arguments
- `id`: The job's ID.
- `sequence_store_id`: The job's sequence store ID.

"""
function get_read_set_activation_job(
    id, sequenceStoreId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "GET",
        "/sequencestore/$(sequenceStoreId)/activationjob/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_read_set_activation_job(
    id,
    sequenceStoreId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return omics(
        "GET",
        "/sequencestore/$(sequenceStoreId)/activationjob/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_read_set_export_job(id, sequence_store_id)
    get_read_set_export_job(id, sequence_store_id, params::Dict{String,<:Any})

Gets information about a read set export job.

# Arguments
- `id`: The job's ID.
- `sequence_store_id`: The job's sequence store ID.

"""
function get_read_set_export_job(
    id, sequenceStoreId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "GET",
        "/sequencestore/$(sequenceStoreId)/exportjob/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_read_set_export_job(
    id,
    sequenceStoreId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return omics(
        "GET",
        "/sequencestore/$(sequenceStoreId)/exportjob/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_read_set_import_job(id, sequence_store_id)
    get_read_set_import_job(id, sequence_store_id, params::Dict{String,<:Any})

Gets information about a read set import job.

# Arguments
- `id`: The job's ID.
- `sequence_store_id`: The job's sequence store ID.

"""
function get_read_set_import_job(
    id, sequenceStoreId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "GET",
        "/sequencestore/$(sequenceStoreId)/importjob/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_read_set_import_job(
    id,
    sequenceStoreId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return omics(
        "GET",
        "/sequencestore/$(sequenceStoreId)/importjob/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_read_set_metadata(id, sequence_store_id)
    get_read_set_metadata(id, sequence_store_id, params::Dict{String,<:Any})

Gets details about a read set.

# Arguments
- `id`: The read set's ID.
- `sequence_store_id`: The read set's sequence store ID.

"""
function get_read_set_metadata(
    id, sequenceStoreId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "GET",
        "/sequencestore/$(sequenceStoreId)/readset/$(id)/metadata";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_read_set_metadata(
    id,
    sequenceStoreId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return omics(
        "GET",
        "/sequencestore/$(sequenceStoreId)/readset/$(id)/metadata",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_reference(id, part_number, reference_store_id)
    get_reference(id, part_number, reference_store_id, params::Dict{String,<:Any})

Gets a reference file.

# Arguments
- `id`: The reference's ID.
- `part_number`: The part number to retrieve.
- `reference_store_id`: The reference's store ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Range"`: The range to retrieve.
- `"file"`: The file to retrieve.
"""
function get_reference(
    id, partNumber, referenceStoreId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "GET",
        "/referencestore/$(referenceStoreId)/reference/$(id)",
        Dict{String,Any}("partNumber" => partNumber);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_reference(
    id,
    partNumber,
    referenceStoreId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return omics(
        "GET",
        "/referencestore/$(referenceStoreId)/reference/$(id)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("partNumber" => partNumber), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_reference_import_job(id, reference_store_id)
    get_reference_import_job(id, reference_store_id, params::Dict{String,<:Any})

Gets information about a reference import job.

# Arguments
- `id`: The job's ID.
- `reference_store_id`: The job's reference store ID.

"""
function get_reference_import_job(
    id, referenceStoreId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "GET",
        "/referencestore/$(referenceStoreId)/importjob/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_reference_import_job(
    id,
    referenceStoreId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return omics(
        "GET",
        "/referencestore/$(referenceStoreId)/importjob/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_reference_metadata(id, reference_store_id)
    get_reference_metadata(id, reference_store_id, params::Dict{String,<:Any})

Gets information about a genome reference's metadata.

# Arguments
- `id`: The reference's ID.
- `reference_store_id`: The reference's reference store ID.

"""
function get_reference_metadata(
    id, referenceStoreId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "GET",
        "/referencestore/$(referenceStoreId)/reference/$(id)/metadata";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_reference_metadata(
    id,
    referenceStoreId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return omics(
        "GET",
        "/referencestore/$(referenceStoreId)/reference/$(id)/metadata",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_reference_store(id)
    get_reference_store(id, params::Dict{String,<:Any})

Gets information about a reference store.

# Arguments
- `id`: The store's ID.

"""
function get_reference_store(id; aws_config::AbstractAWSConfig=current_aws_config())
    return omics(
        "GET",
        "/referencestore/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_reference_store(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "GET",
        "/referencestore/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_run(id)
    get_run(id, params::Dict{String,<:Any})

Gets information about a workflow run. If a workflow is shared with you, you cannot export
information about the run.

# Arguments
- `id`: The run's ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"export"`: The run's export format.
"""
function get_run(id; aws_config::AbstractAWSConfig=current_aws_config())
    return omics(
        "GET", "/run/$(id)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_run(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "GET", "/run/$(id)", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_run_group(id)
    get_run_group(id, params::Dict{String,<:Any})

Gets information about a workflow run group.

# Arguments
- `id`: The group's ID.

"""
function get_run_group(id; aws_config::AbstractAWSConfig=current_aws_config())
    return omics(
        "GET", "/runGroup/$(id)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_run_group(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "GET",
        "/runGroup/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_run_task(id, task_id)
    get_run_task(id, task_id, params::Dict{String,<:Any})

Gets information about a workflow run task.

# Arguments
- `id`: The workflow run ID.
- `task_id`: The task's ID.

"""
function get_run_task(id, taskId; aws_config::AbstractAWSConfig=current_aws_config())
    return omics(
        "GET",
        "/run/$(id)/task/$(taskId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_run_task(
    id,
    taskId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return omics(
        "GET",
        "/run/$(id)/task/$(taskId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_sequence_store(id)
    get_sequence_store(id, params::Dict{String,<:Any})

Gets information about a sequence store.

# Arguments
- `id`: The store's ID.

"""
function get_sequence_store(id; aws_config::AbstractAWSConfig=current_aws_config())
    return omics(
        "GET",
        "/sequencestore/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_sequence_store(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "GET",
        "/sequencestore/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_share(share_id)
    get_share(share_id, params::Dict{String,<:Any})

Retrieves the metadata for the specified resource share.

# Arguments
- `share_id`: The ID of the share.

"""
function get_share(shareId; aws_config::AbstractAWSConfig=current_aws_config())
    return omics(
        "GET", "/share/$(shareId)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_share(
    shareId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return omics(
        "GET",
        "/share/$(shareId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_variant_import_job(job_id)
    get_variant_import_job(job_id, params::Dict{String,<:Any})

Gets information about a variant import job.

# Arguments
- `job_id`: The job's ID.

"""
function get_variant_import_job(jobId; aws_config::AbstractAWSConfig=current_aws_config())
    return omics(
        "GET",
        "/import/variant/$(jobId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_variant_import_job(
    jobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "GET",
        "/import/variant/$(jobId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_variant_store(name)
    get_variant_store(name, params::Dict{String,<:Any})

Gets information about a variant store.

# Arguments
- `name`: The store's name.

"""
function get_variant_store(name; aws_config::AbstractAWSConfig=current_aws_config())
    return omics(
        "GET",
        "/variantStore/$(name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_variant_store(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "GET",
        "/variantStore/$(name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_workflow(id)
    get_workflow(id, params::Dict{String,<:Any})

Gets information about a workflow. If a workflow is shared with you, you cannot export the
workflow.

# Arguments
- `id`: The workflow's ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"export"`: The export format for the workflow.
- `"type"`: The workflow's type.
- `"workflowOwnerId"`: The ID of the workflow owner.
"""
function get_workflow(id; aws_config::AbstractAWSConfig=current_aws_config())
    return omics(
        "GET", "/workflow/$(id)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_workflow(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "GET",
        "/workflow/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_annotation_import_jobs()
    list_annotation_import_jobs(params::Dict{String,<:Any})

Retrieves a list of annotation import jobs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filter"`: A filter to apply to the list.
- `"ids"`: IDs of annotation import jobs to retrieve.
- `"maxResults"`: The maximum number of jobs to return in one page of results.
- `"nextToken"`: Specifies the pagination token from a previous request to retrieve the
  next page of results.
"""
function list_annotation_import_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return omics(
        "POST",
        "/import/annotations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_annotation_import_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "POST",
        "/import/annotations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_annotation_store_versions(name)
    list_annotation_store_versions(name, params::Dict{String,<:Any})

 Lists the versions of an annotation store.

# Arguments
- `name`:  The name of an annotation store.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filter"`:  A filter to apply to the list of annotation store versions.
- `"maxResults"`:  The maximum number of annotation store versions to return in one page of
  results.
- `"nextToken"`:  Specifies the pagination token from a previous request to retrieve the
  next page of results.
"""
function list_annotation_store_versions(
    name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "POST",
        "/annotationStore/$(name)/versions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_annotation_store_versions(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "POST",
        "/annotationStore/$(name)/versions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_annotation_stores()
    list_annotation_stores(params::Dict{String,<:Any})

Retrieves a list of annotation stores.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filter"`: A filter to apply to the list.
- `"ids"`: IDs of stores to list.
- `"maxResults"`: The maximum number of stores to return in one page of results.
- `"nextToken"`: Specify the pagination token from a previous request to retrieve the next
  page of results.
"""
function list_annotation_stores(; aws_config::AbstractAWSConfig=current_aws_config())
    return omics(
        "POST", "/annotationStores"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_annotation_stores(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "POST",
        "/annotationStores",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_multipart_read_set_uploads(sequence_store_id)
    list_multipart_read_set_uploads(sequence_store_id, params::Dict{String,<:Any})

Lists multipart read set uploads and for in progress uploads. Once the upload is completed,
a read set is created and the upload will no longer be returned in the response.

# Arguments
- `sequence_store_id`: The Sequence Store ID used for the multipart uploads.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of multipart uploads returned in a page.
- `"nextToken"`: Next token returned in the response of a previous
  ListMultipartReadSetUploads call. Used to get the next page of results.
"""
function list_multipart_read_set_uploads(
    sequenceStoreId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "POST",
        "/sequencestore/$(sequenceStoreId)/uploads";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_multipart_read_set_uploads(
    sequenceStoreId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return omics(
        "POST",
        "/sequencestore/$(sequenceStoreId)/uploads",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_read_set_activation_jobs(sequence_store_id)
    list_read_set_activation_jobs(sequence_store_id, params::Dict{String,<:Any})

Retrieves a list of read set activation jobs.

# Arguments
- `sequence_store_id`: The read set's sequence store ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filter"`: A filter to apply to the list.
- `"maxResults"`: The maximum number of read set activation jobs to return in one page of
  results.
- `"nextToken"`: Specify the pagination token from a previous request to retrieve the next
  page of results.
"""
function list_read_set_activation_jobs(
    sequenceStoreId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "POST",
        "/sequencestore/$(sequenceStoreId)/activationjobs";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_read_set_activation_jobs(
    sequenceStoreId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return omics(
        "POST",
        "/sequencestore/$(sequenceStoreId)/activationjobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_read_set_export_jobs(sequence_store_id)
    list_read_set_export_jobs(sequence_store_id, params::Dict{String,<:Any})

Retrieves a list of read set export jobs.

# Arguments
- `sequence_store_id`: The jobs' sequence store ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filter"`: A filter to apply to the list.
- `"maxResults"`: The maximum number of jobs to return in one page of results.
- `"nextToken"`: Specify the pagination token from a previous request to retrieve the next
  page of results.
"""
function list_read_set_export_jobs(
    sequenceStoreId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "POST",
        "/sequencestore/$(sequenceStoreId)/exportjobs";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_read_set_export_jobs(
    sequenceStoreId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return omics(
        "POST",
        "/sequencestore/$(sequenceStoreId)/exportjobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_read_set_import_jobs(sequence_store_id)
    list_read_set_import_jobs(sequence_store_id, params::Dict{String,<:Any})

Retrieves a list of read set import jobs.

# Arguments
- `sequence_store_id`: The jobs' sequence store ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filter"`: A filter to apply to the list.
- `"maxResults"`: The maximum number of jobs to return in one page of results.
- `"nextToken"`: Specify the pagination token from a previous request to retrieve the next
  page of results.
"""
function list_read_set_import_jobs(
    sequenceStoreId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "POST",
        "/sequencestore/$(sequenceStoreId)/importjobs";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_read_set_import_jobs(
    sequenceStoreId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return omics(
        "POST",
        "/sequencestore/$(sequenceStoreId)/importjobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_read_set_upload_parts(part_source, sequence_store_id, upload_id)
    list_read_set_upload_parts(part_source, sequence_store_id, upload_id, params::Dict{String,<:Any})

This operation will list all parts in a requested multipart upload for a sequence store.

# Arguments
- `part_source`: The source file for the upload part.
- `sequence_store_id`: The Sequence Store ID used for the multipart uploads.
- `upload_id`: The ID for the initiated multipart upload.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filter"`: Attributes used to filter for a specific subset of read set part uploads.
- `"maxResults"`: The maximum number of read set upload parts returned in a page.
- `"nextToken"`: Next token returned in the response of a previous
  ListReadSetUploadPartsRequest call. Used to get the next page of results.
"""
function list_read_set_upload_parts(
    partSource,
    sequenceStoreId,
    uploadId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return omics(
        "POST",
        "/sequencestore/$(sequenceStoreId)/upload/$(uploadId)/parts",
        Dict{String,Any}("partSource" => partSource);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_read_set_upload_parts(
    partSource,
    sequenceStoreId,
    uploadId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return omics(
        "POST",
        "/sequencestore/$(sequenceStoreId)/upload/$(uploadId)/parts",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("partSource" => partSource), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_read_sets(sequence_store_id)
    list_read_sets(sequence_store_id, params::Dict{String,<:Any})

Retrieves a list of read sets.

# Arguments
- `sequence_store_id`: The jobs' sequence store ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filter"`: A filter to apply to the list.
- `"maxResults"`: The maximum number of read sets to return in one page of results.
- `"nextToken"`: Specify the pagination token from a previous request to retrieve the next
  page of results.
"""
function list_read_sets(sequenceStoreId; aws_config::AbstractAWSConfig=current_aws_config())
    return omics(
        "POST",
        "/sequencestore/$(sequenceStoreId)/readsets";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_read_sets(
    sequenceStoreId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return omics(
        "POST",
        "/sequencestore/$(sequenceStoreId)/readsets",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_reference_import_jobs(reference_store_id)
    list_reference_import_jobs(reference_store_id, params::Dict{String,<:Any})

Retrieves a list of reference import jobs.

# Arguments
- `reference_store_id`: The job's reference store ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filter"`: A filter to apply to the list.
- `"maxResults"`: The maximum number of jobs to return in one page of results.
- `"nextToken"`: Specify the pagination token from a previous request to retrieve the next
  page of results.
"""
function list_reference_import_jobs(
    referenceStoreId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "POST",
        "/referencestore/$(referenceStoreId)/importjobs";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_reference_import_jobs(
    referenceStoreId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return omics(
        "POST",
        "/referencestore/$(referenceStoreId)/importjobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_reference_stores()
    list_reference_stores(params::Dict{String,<:Any})

Retrieves a list of reference stores.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filter"`: A filter to apply to the list.
- `"maxResults"`: The maximum number of stores to return in one page of results.
- `"nextToken"`: Specify the pagination token from a previous request to retrieve the next
  page of results.
"""
function list_reference_stores(; aws_config::AbstractAWSConfig=current_aws_config())
    return omics(
        "POST", "/referencestores"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_reference_stores(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "POST",
        "/referencestores",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_references(reference_store_id)
    list_references(reference_store_id, params::Dict{String,<:Any})

Retrieves a list of references.

# Arguments
- `reference_store_id`: The references' reference store ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filter"`: A filter to apply to the list.
- `"maxResults"`: The maximum number of references to return in one page of results.
- `"nextToken"`: Specify the pagination token from a previous request to retrieve the next
  page of results.
"""
function list_references(
    referenceStoreId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "POST",
        "/referencestore/$(referenceStoreId)/references";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_references(
    referenceStoreId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return omics(
        "POST",
        "/referencestore/$(referenceStoreId)/references",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_run_groups()
    list_run_groups(params::Dict{String,<:Any})

Retrieves a list of run groups.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of run groups to return in one page of results.
- `"name"`: The run groups' name.
- `"startingToken"`: Specify the pagination token from a previous request to retrieve the
  next page of results.
"""
function list_run_groups(; aws_config::AbstractAWSConfig=current_aws_config())
    return omics("GET", "/runGroup"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_run_groups(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "GET", "/runGroup", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_run_tasks(id)
    list_run_tasks(id, params::Dict{String,<:Any})

Retrieves a list of tasks for a run.

# Arguments
- `id`: The run's ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of run tasks to return in one page of results.
- `"startingToken"`: Specify the pagination token from a previous request to retrieve the
  next page of results.
- `"status"`: Filter the list by status.
"""
function list_run_tasks(id; aws_config::AbstractAWSConfig=current_aws_config())
    return omics(
        "GET", "/run/$(id)/task"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_run_tasks(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "GET",
        "/run/$(id)/task",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_runs()
    list_runs(params::Dict{String,<:Any})

Retrieves a list of runs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of runs to return in one page of results.
- `"name"`: Filter the list by run name.
- `"runGroupId"`: Filter the list by run group ID.
- `"startingToken"`: Specify the pagination token from a previous request to retrieve the
  next page of results.
- `"status"`: The status of a run.
"""
function list_runs(; aws_config::AbstractAWSConfig=current_aws_config())
    return omics("GET", "/run"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_runs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "GET", "/run", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_sequence_stores()
    list_sequence_stores(params::Dict{String,<:Any})

Retrieves a list of sequence stores.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filter"`: A filter to apply to the list.
- `"maxResults"`: The maximum number of stores to return in one page of results.
- `"nextToken"`: Specify the pagination token from a previous request to retrieve the next
  page of results.
"""
function list_sequence_stores(; aws_config::AbstractAWSConfig=current_aws_config())
    return omics(
        "POST", "/sequencestores"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_sequence_stores(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "POST",
        "/sequencestores",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_shares(resource_owner)
    list_shares(resource_owner, params::Dict{String,<:Any})

Retrieves the resource shares associated with an account. Use the filter parameter to
retrieve a specific subset of the shares.

# Arguments
- `resource_owner`: The account that owns the resource shares.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filter"`: Attributes that you use to filter for a specific subset of resource shares.
- `"maxResults"`: The maximum number of shares to return in one page of results.
- `"nextToken"`: Next token returned in the response of a previous
  ListReadSetUploadPartsRequest call. Used to get the next page of results.
"""
function list_shares(resourceOwner; aws_config::AbstractAWSConfig=current_aws_config())
    return omics(
        "POST",
        "/shares",
        Dict{String,Any}("resourceOwner" => resourceOwner);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_shares(
    resourceOwner,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return omics(
        "POST",
        "/shares",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceOwner" => resourceOwner), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Retrieves a list of tags for a resource.

# Arguments
- `resource_arn`: The resource's ARN.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return omics(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_variant_import_jobs()
    list_variant_import_jobs(params::Dict{String,<:Any})

Retrieves a list of variant import jobs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filter"`: A filter to apply to the list.
- `"ids"`: A list of job IDs.
- `"maxResults"`: The maximum number of import jobs to return in one page of results.
- `"nextToken"`: Specify the pagination token from a previous request to retrieve the next
  page of results.
"""
function list_variant_import_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return omics(
        "POST", "/import/variants"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_variant_import_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "POST",
        "/import/variants",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_variant_stores()
    list_variant_stores(params::Dict{String,<:Any})

Retrieves a list of variant stores.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filter"`: A filter to apply to the list.
- `"ids"`: A list of store IDs.
- `"maxResults"`: The maximum number of stores to return in one page of results.
- `"nextToken"`: Specify the pagination token from a previous request to retrieve the next
  page of results.
"""
function list_variant_stores(; aws_config::AbstractAWSConfig=current_aws_config())
    return omics(
        "POST", "/variantStores"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_variant_stores(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "POST",
        "/variantStores",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_workflows()
    list_workflows(params::Dict{String,<:Any})

Retrieves a list of workflows.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of workflows to return in one page of results.
- `"name"`: Filter the list by workflow name.
- `"startingToken"`: Specify the pagination token from a previous request to retrieve the
  next page of results.
- `"type"`: Filter the list by workflow type.
"""
function list_workflows(; aws_config::AbstractAWSConfig=current_aws_config())
    return omics("GET", "/workflow"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_workflows(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "GET", "/workflow", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    start_annotation_import_job(destination_name, items, role_arn)
    start_annotation_import_job(destination_name, items, role_arn, params::Dict{String,<:Any})

Starts an annotation import job.

# Arguments
- `destination_name`: A destination annotation store for the job.
- `items`: Items to import.
- `role_arn`: A service role for the job.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"annotationFields"`: The annotation schema generated by the parsed annotation data.
- `"formatOptions"`: Formatting options for the annotation file.
- `"runLeftNormalization"`: The job's left normalization setting.
- `"versionName"`:  The name of the annotation store version.
"""
function start_annotation_import_job(
    destinationName, items, roleArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "POST",
        "/import/annotation",
        Dict{String,Any}(
            "destinationName" => destinationName, "items" => items, "roleArn" => roleArn
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_annotation_import_job(
    destinationName,
    items,
    roleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return omics(
        "POST",
        "/import/annotation",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "destinationName" => destinationName,
                    "items" => items,
                    "roleArn" => roleArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_read_set_activation_job(sequence_store_id, sources)
    start_read_set_activation_job(sequence_store_id, sources, params::Dict{String,<:Any})

Activates an archived read set. To reduce storage charges, Amazon Omics archives unused
read sets after 30 days.

# Arguments
- `sequence_store_id`: The read set's sequence store ID.
- `sources`: The job's source files.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: To ensure that jobs don't run multiple times, specify a unique token for
  each job.
"""
function start_read_set_activation_job(
    sequenceStoreId, sources; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "POST",
        "/sequencestore/$(sequenceStoreId)/activationjob",
        Dict{String,Any}("sources" => sources);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_read_set_activation_job(
    sequenceStoreId,
    sources,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return omics(
        "POST",
        "/sequencestore/$(sequenceStoreId)/activationjob",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("sources" => sources), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_read_set_export_job(destination, role_arn, sequence_store_id, sources)
    start_read_set_export_job(destination, role_arn, sequence_store_id, sources, params::Dict{String,<:Any})

Exports a read set to Amazon S3.

# Arguments
- `destination`: A location for exported files in Amazon S3.
- `role_arn`: A service role for the job.
- `sequence_store_id`: The read set's sequence store ID.
- `sources`: The job's source files.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: To ensure that jobs don't run multiple times, specify a unique token for
  each job.
"""
function start_read_set_export_job(
    destination,
    roleArn,
    sequenceStoreId,
    sources;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return omics(
        "POST",
        "/sequencestore/$(sequenceStoreId)/exportjob",
        Dict{String,Any}(
            "destination" => destination, "roleArn" => roleArn, "sources" => sources
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_read_set_export_job(
    destination,
    roleArn,
    sequenceStoreId,
    sources,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return omics(
        "POST",
        "/sequencestore/$(sequenceStoreId)/exportjob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "destination" => destination, "roleArn" => roleArn, "sources" => sources
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_read_set_import_job(role_arn, sequence_store_id, sources)
    start_read_set_import_job(role_arn, sequence_store_id, sources, params::Dict{String,<:Any})

Starts a read set import job.

# Arguments
- `role_arn`: A service role for the job.
- `sequence_store_id`: The read set's sequence store ID.
- `sources`: The job's source files.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: To ensure that jobs don't run multiple times, specify a unique token for
  each job.
"""
function start_read_set_import_job(
    roleArn, sequenceStoreId, sources; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "POST",
        "/sequencestore/$(sequenceStoreId)/importjob",
        Dict{String,Any}("roleArn" => roleArn, "sources" => sources);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_read_set_import_job(
    roleArn,
    sequenceStoreId,
    sources,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return omics(
        "POST",
        "/sequencestore/$(sequenceStoreId)/importjob",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("roleArn" => roleArn, "sources" => sources), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_reference_import_job(reference_store_id, role_arn, sources)
    start_reference_import_job(reference_store_id, role_arn, sources, params::Dict{String,<:Any})

Starts a reference import job.

# Arguments
- `reference_store_id`: The job's reference store ID.
- `role_arn`: A service role for the job.
- `sources`: The job's source files.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: To ensure that jobs don't run multiple times, specify a unique token for
  each job.
"""
function start_reference_import_job(
    referenceStoreId, roleArn, sources; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "POST",
        "/referencestore/$(referenceStoreId)/importjob",
        Dict{String,Any}("roleArn" => roleArn, "sources" => sources);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_reference_import_job(
    referenceStoreId,
    roleArn,
    sources,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return omics(
        "POST",
        "/referencestore/$(referenceStoreId)/importjob",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("roleArn" => roleArn, "sources" => sources), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_run(request_id, role_arn)
    start_run(request_id, role_arn, params::Dict{String,<:Any})

Starts a workflow run. To duplicate a run, specify the run's ID and a role ARN. The
remaining parameters are copied from the previous run. StartRun will not support re-run for
a workflow that is shared with you. The total number of runs in your account is subject to
a quota per Region. To avoid needing to delete runs manually, you can set the retention
mode to REMOVE. Runs with this setting are deleted automatically when the run quoata is
exceeded. By default, the run uses STATIC storage. For STATIC storage, set the
storageCapacity field. You can set the storage type to DYNAMIC. You do not set
storageCapacity, because HealthOmics dynamically scales the storage up or down as required.
For more information about static and dynamic storage, see Running workflows in the AWS
HealthOmics User Guide.

# Arguments
- `request_id`: To ensure that requests don't run multiple times, specify a unique ID for
  each request.
- `role_arn`: A service role for the run.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"logLevel"`: A log level for the run.
- `"name"`: A name for the run.
- `"outputUri"`: An output URI for the run.
- `"parameters"`: Parameters for the run.
- `"priority"`: A priority for the run.
- `"retentionMode"`: The retention mode for the run.
- `"runGroupId"`: The run's group ID.
- `"runId"`: The ID of a run to duplicate.
- `"storageCapacity"`: A storage capacity for the run in gibibytes. This field is not
  required if the storage type is dynamic (the system ignores any value that you enter).
- `"storageType"`: The run's storage type. By default, the run uses STATIC storage type,
  which allocates a fixed amount of storage. If you set the storage type to DYNAMIC,
  HealthOmics dynamically scales the storage up or down, based on file system utilization.
- `"tags"`: Tags for the run.
- `"workflowId"`: The run's workflow ID.
- `"workflowOwnerId"`: The ID of the workflow owner.
- `"workflowType"`: The run's workflow type.
"""
function start_run(requestId, roleArn; aws_config::AbstractAWSConfig=current_aws_config())
    return omics(
        "POST",
        "/run",
        Dict{String,Any}("requestId" => requestId, "roleArn" => roleArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_run(
    requestId,
    roleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return omics(
        "POST",
        "/run",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("requestId" => requestId, "roleArn" => roleArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_variant_import_job(destination_name, items, role_arn)
    start_variant_import_job(destination_name, items, role_arn, params::Dict{String,<:Any})

Starts a variant import job.

# Arguments
- `destination_name`: The destination variant store for the job.
- `items`: Items to import.
- `role_arn`: A service role for the job.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"annotationFields"`: The annotation schema generated by the parsed annotation data.
- `"runLeftNormalization"`: The job's left normalization setting.
"""
function start_variant_import_job(
    destinationName, items, roleArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "POST",
        "/import/variant",
        Dict{String,Any}(
            "destinationName" => destinationName, "items" => items, "roleArn" => roleArn
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_variant_import_job(
    destinationName,
    items,
    roleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return omics(
        "POST",
        "/import/variant",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "destinationName" => destinationName,
                    "items" => items,
                    "roleArn" => roleArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Tags a resource.

# Arguments
- `resource_arn`: The resource's ARN.
- `tags`: Tags for the resource.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return omics(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return omics(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes tags from a resource.

# Arguments
- `resource_arn`: The resource's ARN.
- `tag_keys`: Keys of tags to remove.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return omics(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_annotation_store(name)
    update_annotation_store(name, params::Dict{String,<:Any})

Updates an annotation store.

# Arguments
- `name`: A name for the store.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A description for the store.
"""
function update_annotation_store(name; aws_config::AbstractAWSConfig=current_aws_config())
    return omics(
        "POST",
        "/annotationStore/$(name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_annotation_store(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "POST",
        "/annotationStore/$(name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_annotation_store_version(name, version_name)
    update_annotation_store_version(name, version_name, params::Dict{String,<:Any})

 Updates the description of an annotation store version.

# Arguments
- `name`:  The name of an annotation store.
- `version_name`:  The name of an annotation store version.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`:  The description of an annotation store.
"""
function update_annotation_store_version(
    name, versionName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "POST",
        "/annotationStore/$(name)/version/$(versionName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_annotation_store_version(
    name,
    versionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return omics(
        "POST",
        "/annotationStore/$(name)/version/$(versionName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_run_group(id)
    update_run_group(id, params::Dict{String,<:Any})

Updates a run group.

# Arguments
- `id`: The group's ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxCpus"`: The maximum number of CPUs to use.
- `"maxDuration"`: A maximum run time for the group in minutes.
- `"maxGpus"`: The maximum GPUs that can be used by a run group.
- `"maxRuns"`: The maximum number of concurrent runs for the group.
- `"name"`: A name for the group.
"""
function update_run_group(id; aws_config::AbstractAWSConfig=current_aws_config())
    return omics(
        "POST", "/runGroup/$(id)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function update_run_group(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "POST",
        "/runGroup/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_variant_store(name)
    update_variant_store(name, params::Dict{String,<:Any})

Updates a variant store.

# Arguments
- `name`: A name for the store.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A description for the store.
"""
function update_variant_store(name; aws_config::AbstractAWSConfig=current_aws_config())
    return omics(
        "POST",
        "/variantStore/$(name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_variant_store(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "POST",
        "/variantStore/$(name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_workflow(id)
    update_workflow(id, params::Dict{String,<:Any})

Updates a workflow.

# Arguments
- `id`: The workflow's ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A description for the workflow.
- `"name"`: A name for the workflow.
"""
function update_workflow(id; aws_config::AbstractAWSConfig=current_aws_config())
    return omics(
        "POST", "/workflow/$(id)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function update_workflow(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return omics(
        "POST",
        "/workflow/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    upload_read_set_part(part_number, part_source, payload, sequence_store_id, upload_id)
    upload_read_set_part(part_number, part_source, payload, sequence_store_id, upload_id, params::Dict{String,<:Any})

This operation uploads a specific part of a read set. If you upload a new part using a
previously used part number, the previously uploaded part will be overwritten.

# Arguments
- `part_number`: The number of the part being uploaded.
- `part_source`: The source file for an upload part.
- `payload`: The read set data to upload for a part.
- `sequence_store_id`: The Sequence Store ID used for the multipart upload.
- `upload_id`: The ID for the initiated multipart upload.

"""
function upload_read_set_part(
    partNumber,
    partSource,
    payload,
    sequenceStoreId,
    uploadId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return omics(
        "PUT",
        "/sequencestore/$(sequenceStoreId)/upload/$(uploadId)/part",
        Dict{String,Any}(
            "partNumber" => partNumber, "partSource" => partSource, "payload" => payload
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function upload_read_set_part(
    partNumber,
    partSource,
    payload,
    sequenceStoreId,
    uploadId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return omics(
        "PUT",
        "/sequencestore/$(sequenceStoreId)/upload/$(uploadId)/part",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "partNumber" => partNumber,
                    "partSource" => partSource,
                    "payload" => payload,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: managedblockchain_query
using AWS.Compat
using AWS.UUIDs

"""
    batch_get_token_balance()
    batch_get_token_balance(params::Dict{String,<:Any})

Gets the token balance for a batch of tokens by using the BatchGetTokenBalance action for
every token in the request.  Only the native tokens BTC and ETH, and the ERC-20, ERC-721,
and ERC 1155 token standards are supported.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"getTokenBalanceInputs"`: An array of BatchGetTokenBalanceInputItem objects whose
  balance is being requested.
"""
function batch_get_token_balance(; aws_config::AbstractAWSConfig=current_aws_config())
    return managedblockchain_query(
        "POST",
        "/batch-get-token-balance";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_token_balance(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return managedblockchain_query(
        "POST",
        "/batch-get-token-balance",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_asset_contract(contract_identifier)
    get_asset_contract(contract_identifier, params::Dict{String,<:Any})

Gets the information about a specific contract deployed on the blockchain.    The Bitcoin
blockchain networks do not support this operation.   Metadata is currently only available
for some ERC-20 contracts. Metadata will be available for additional contracts in the
future.

# Arguments
- `contract_identifier`: Contains the blockchain address and network information about the
  contract.

"""
function get_asset_contract(
    contractIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return managedblockchain_query(
        "POST",
        "/get-asset-contract",
        Dict{String,Any}("contractIdentifier" => contractIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_asset_contract(
    contractIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return managedblockchain_query(
        "POST",
        "/get-asset-contract",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("contractIdentifier" => contractIdentifier), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_token_balance(owner_identifier, token_identifier)
    get_token_balance(owner_identifier, token_identifier, params::Dict{String,<:Any})

Gets the balance of a specific token, including native tokens, for a given address (wallet
or contract) on the blockchain.  Only the native tokens BTC and ETH, and the ERC-20,
ERC-721, and ERC 1155 token standards are supported.

# Arguments
- `owner_identifier`: The container for the identifier for the owner.
- `token_identifier`: The container for the identifier for the token, including the unique
  token ID and its blockchain network.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"atBlockchainInstant"`: The time for when the TokenBalance is requested or the current
  time if a time is not provided in the request.  This time will only be recorded up to the
  second.
"""
function get_token_balance(
    ownerIdentifier, tokenIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return managedblockchain_query(
        "POST",
        "/get-token-balance",
        Dict{String,Any}(
            "ownerIdentifier" => ownerIdentifier, "tokenIdentifier" => tokenIdentifier
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_token_balance(
    ownerIdentifier,
    tokenIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return managedblockchain_query(
        "POST",
        "/get-token-balance",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ownerIdentifier" => ownerIdentifier,
                    "tokenIdentifier" => tokenIdentifier,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_transaction(network)
    get_transaction(network, params::Dict{String,<:Any})

Gets the details of a transaction.  This action will return transaction details for all
transactions that are confirmed on the blockchain, even if they have not reached finality.

# Arguments
- `network`: The blockchain network where the transaction occurred.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"transactionHash"`: The hash of a transaction. It is generated when a transaction is
  created.
- `"transactionId"`: The identifier of a Bitcoin transaction. It is generated when a
  transaction is created.   transactionId is only supported on the Bitcoin networks.
"""
function get_transaction(network; aws_config::AbstractAWSConfig=current_aws_config())
    return managedblockchain_query(
        "POST",
        "/get-transaction",
        Dict{String,Any}("network" => network);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_transaction(
    network,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return managedblockchain_query(
        "POST",
        "/get-transaction",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("network" => network), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_asset_contracts(contract_filter)
    list_asset_contracts(contract_filter, params::Dict{String,<:Any})

Lists all the contracts for a given contract type deployed by an address (either a contract
address or a wallet address). The Bitcoin blockchain networks do not support this operation.

# Arguments
- `contract_filter`: Contains the filter parameter for the request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of contracts to list. Default: 100   Even if
  additional results can be retrieved, the request can return less results than maxResults or
  an empty array of results. To retrieve the next set of results, make another request with
  the returned nextToken value. The value of nextToken is null when there are no more results
  to return
- `"nextToken"`:  The pagination token that indicates the next set of results to retrieve.
"""
function list_asset_contracts(
    contractFilter; aws_config::AbstractAWSConfig=current_aws_config()
)
    return managedblockchain_query(
        "POST",
        "/list-asset-contracts",
        Dict{String,Any}("contractFilter" => contractFilter);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_asset_contracts(
    contractFilter,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return managedblockchain_query(
        "POST",
        "/list-asset-contracts",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("contractFilter" => contractFilter), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_filtered_transaction_events(address_identifier_filter, network)
    list_filtered_transaction_events(address_identifier_filter, network, params::Dict{String,<:Any})

Lists all the transaction events for an address on the blockchain.  This operation is only
supported on the Bitcoin networks.

# Arguments
- `address_identifier_filter`: This is the unique public address on the blockchain for
  which the transaction events are being requested.
- `network`: The blockchain network where the transaction occurred. Valid Values:
  BITCOIN_MAINNET | BITCOIN_TESTNET

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"confirmationStatusFilter"`:
- `"maxResults"`: The maximum number of transaction events to list. Default: 100   Even if
  additional results can be retrieved, the request can return less results than maxResults or
  an empty array of results. To retrieve the next set of results, make another request with
  the returned nextToken value. The value of nextToken is null when there are no more results
  to return
- `"nextToken"`: The pagination token that indicates the next set of results to retrieve.
- `"sort"`: The order by which the results will be sorted.
- `"timeFilter"`: This container specifies the time frame for the transaction events
  returned in the response.
- `"voutFilter"`: This container specifies filtering attributes related to BITCOIN_VOUT
  event types
"""
function list_filtered_transaction_events(
    addressIdentifierFilter, network; aws_config::AbstractAWSConfig=current_aws_config()
)
    return managedblockchain_query(
        "POST",
        "/list-filtered-transaction-events",
        Dict{String,Any}(
            "addressIdentifierFilter" => addressIdentifierFilter, "network" => network
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_filtered_transaction_events(
    addressIdentifierFilter,
    network,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return managedblockchain_query(
        "POST",
        "/list-filtered-transaction-events",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "addressIdentifierFilter" => addressIdentifierFilter,
                    "network" => network,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_token_balances(token_filter)
    list_token_balances(token_filter, params::Dict{String,<:Any})

This action returns the following for a given blockchain network:   Lists all token
balances owned by an address (either a contract address or a wallet address).   Lists all
token balances for all tokens created by a contract.   Lists all token balances for a given
token.    You must always specify the network property of the tokenFilter when using this
operation.

# Arguments
- `token_filter`: The contract address or a token identifier on the blockchain network by
  which to filter the request. You must specify the contractAddress property of this
  container when listing tokens minted by a contract.  You must always specify the network
  property of this container when using this operation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of token balances to return. Default: 100   Even if
  additional results can be retrieved, the request can return less results than maxResults or
  an empty array of results. To retrieve the next set of results, make another request with
  the returned nextToken value. The value of nextToken is null when there are no more results
  to return
- `"nextToken"`: The pagination token that indicates the next set of results to retrieve.
- `"ownerFilter"`: The contract or wallet address on the blockchain network by which to
  filter the request. You must specify the address property of the ownerFilter when listing
  balances of tokens owned by the address.
"""
function list_token_balances(
    tokenFilter; aws_config::AbstractAWSConfig=current_aws_config()
)
    return managedblockchain_query(
        "POST",
        "/list-token-balances",
        Dict{String,Any}("tokenFilter" => tokenFilter);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_token_balances(
    tokenFilter,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return managedblockchain_query(
        "POST",
        "/list-token-balances",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("tokenFilter" => tokenFilter), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_transaction_events(network)
    list_transaction_events(network, params::Dict{String,<:Any})

Lists all the transaction events for a transaction   This action will return transaction
details for all transactions that are confirmed on the blockchain, even if they have not
reached finality.

# Arguments
- `network`: The blockchain network where the transaction events occurred.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of transaction events to list. Default: 100   Even if
  additional results can be retrieved, the request can return less results than maxResults or
  an empty array of results. To retrieve the next set of results, make another request with
  the returned nextToken value. The value of nextToken is null when there are no more results
  to return
- `"nextToken"`: The pagination token that indicates the next set of results to retrieve.
- `"transactionHash"`: The hash of a transaction. It is generated when a transaction is
  created.
- `"transactionId"`: The identifier of a Bitcoin transaction. It is generated when a
  transaction is created.   transactionId is only supported on the Bitcoin networks.
"""
function list_transaction_events(
    network; aws_config::AbstractAWSConfig=current_aws_config()
)
    return managedblockchain_query(
        "POST",
        "/list-transaction-events",
        Dict{String,Any}("network" => network);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_transaction_events(
    network,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return managedblockchain_query(
        "POST",
        "/list-transaction-events",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("network" => network), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_transactions(address, network)
    list_transactions(address, network, params::Dict{String,<:Any})

Lists all the transaction events for a transaction.

# Arguments
- `address`: The address (either a contract or wallet), whose transactions are being
  requested.
- `network`: The blockchain network where the transactions occurred.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"confirmationStatusFilter"`: This filter is used to include transactions in the response
  that haven't reached  finality . Transactions that have reached finality are always part of
  the response.
- `"fromBlockchainInstant"`:
- `"maxResults"`: The maximum number of transactions to list. Default: 100   Even if
  additional results can be retrieved, the request can return less results than maxResults or
  an empty array of results. To retrieve the next set of results, make another request with
  the returned nextToken value. The value of nextToken is null when there are no more results
  to return
- `"nextToken"`: The pagination token that indicates the next set of results to retrieve.
- `"sort"`: The order by which the results will be sorted.
- `"toBlockchainInstant"`:
"""
function list_transactions(
    address, network; aws_config::AbstractAWSConfig=current_aws_config()
)
    return managedblockchain_query(
        "POST",
        "/list-transactions",
        Dict{String,Any}("address" => address, "network" => network);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_transactions(
    address,
    network,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return managedblockchain_query(
        "POST",
        "/list-transactions",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("address" => address, "network" => network), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: migration_hub
using AWS.Compat
using AWS.UUIDs

"""
    associate_created_artifact(created_artifact, migration_task_name, progress_update_stream)
    associate_created_artifact(created_artifact, migration_task_name, progress_update_stream, params::Dict{String,<:Any})

Associates a created artifact of an AWS cloud resource, the target receiving the migration,
with the migration task performed by a migration tool. This API has the following traits:
Migration tools can call the AssociateCreatedArtifact operation to indicate which AWS
artifact is associated with a migration task.   The created artifact name must be provided
in ARN (Amazon Resource Name) format which will contain information about type and region;
for example: arn:aws:ec2:us-east-1:488216288981:image/ami-6d0ba87b.   Examples of the AWS
resource behind the created artifact are, AMI's, EC2 instance, or DMS endpoint, etc.

# Arguments
- `created_artifact`: An ARN of the AWS resource related to the migration (e.g., AMI, EC2
  instance, RDS instance, etc.)
- `migration_task_name`: Unique identifier that references the migration task. Do not store
  personal data in this field.
- `progress_update_stream`: The name of the ProgressUpdateStream.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DryRun"`: Optional boolean flag to indicate whether any effect should take place. Used
  to test if the caller has permission to make the call.
"""
function associate_created_artifact(
    CreatedArtifact,
    MigrationTaskName,
    ProgressUpdateStream;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migration_hub(
        "AssociateCreatedArtifact",
        Dict{String,Any}(
            "CreatedArtifact" => CreatedArtifact,
            "MigrationTaskName" => MigrationTaskName,
            "ProgressUpdateStream" => ProgressUpdateStream,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_created_artifact(
    CreatedArtifact,
    MigrationTaskName,
    ProgressUpdateStream,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migration_hub(
        "AssociateCreatedArtifact",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CreatedArtifact" => CreatedArtifact,
                    "MigrationTaskName" => MigrationTaskName,
                    "ProgressUpdateStream" => ProgressUpdateStream,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_discovered_resource(discovered_resource, migration_task_name, progress_update_stream)
    associate_discovered_resource(discovered_resource, migration_task_name, progress_update_stream, params::Dict{String,<:Any})

Associates a discovered resource ID from Application Discovery Service with a migration
task.

# Arguments
- `discovered_resource`: Object representing a Resource.
- `migration_task_name`: The identifier given to the MigrationTask. Do not store personal
  data in this field.
- `progress_update_stream`: The name of the ProgressUpdateStream.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DryRun"`: Optional boolean flag to indicate whether any effect should take place. Used
  to test if the caller has permission to make the call.
"""
function associate_discovered_resource(
    DiscoveredResource,
    MigrationTaskName,
    ProgressUpdateStream;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migration_hub(
        "AssociateDiscoveredResource",
        Dict{String,Any}(
            "DiscoveredResource" => DiscoveredResource,
            "MigrationTaskName" => MigrationTaskName,
            "ProgressUpdateStream" => ProgressUpdateStream,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_discovered_resource(
    DiscoveredResource,
    MigrationTaskName,
    ProgressUpdateStream,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migration_hub(
        "AssociateDiscoveredResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DiscoveredResource" => DiscoveredResource,
                    "MigrationTaskName" => MigrationTaskName,
                    "ProgressUpdateStream" => ProgressUpdateStream,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_progress_update_stream(progress_update_stream_name)
    create_progress_update_stream(progress_update_stream_name, params::Dict{String,<:Any})

Creates a progress update stream which is an AWS resource used for access control as well
as a namespace for migration task names that is implicitly linked to your AWS account. It
must uniquely identify the migration tool as it is used for all updates made by the tool;
however, it does not need to be unique for each AWS account because it is scoped to the AWS
account.

# Arguments
- `progress_update_stream_name`: The name of the ProgressUpdateStream. Do not store
  personal data in this field.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DryRun"`: Optional boolean flag to indicate whether any effect should take place. Used
  to test if the caller has permission to make the call.
"""
function create_progress_update_stream(
    ProgressUpdateStreamName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migration_hub(
        "CreateProgressUpdateStream",
        Dict{String,Any}("ProgressUpdateStreamName" => ProgressUpdateStreamName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_progress_update_stream(
    ProgressUpdateStreamName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migration_hub(
        "CreateProgressUpdateStream",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ProgressUpdateStreamName" => ProgressUpdateStreamName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_progress_update_stream(progress_update_stream_name)
    delete_progress_update_stream(progress_update_stream_name, params::Dict{String,<:Any})

Deletes a progress update stream, including all of its tasks, which was previously created
as an AWS resource used for access control. This API has the following traits:   The only
parameter needed for DeleteProgressUpdateStream is the stream name (same as a
CreateProgressUpdateStream call).   The call will return, and a background process will
asynchronously delete the stream and all of its resources (tasks, associated resources,
resource attributes, created artifacts).   If the stream takes time to be deleted, it might
still show up on a ListProgressUpdateStreams call.    CreateProgressUpdateStream,
ImportMigrationTask, NotifyMigrationTaskState, and all Associate[*] APIs related to the
tasks belonging to the stream will throw \"InvalidInputException\" if the stream of the
same name is in the process of being deleted.   Once the stream and all of its resources
are deleted, CreateProgressUpdateStream for a stream of the same name will succeed, and
that stream will be an entirely new logical resource (without any resources associated with
the old stream).

# Arguments
- `progress_update_stream_name`: The name of the ProgressUpdateStream. Do not store
  personal data in this field.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DryRun"`: Optional boolean flag to indicate whether any effect should take place. Used
  to test if the caller has permission to make the call.
"""
function delete_progress_update_stream(
    ProgressUpdateStreamName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migration_hub(
        "DeleteProgressUpdateStream",
        Dict{String,Any}("ProgressUpdateStreamName" => ProgressUpdateStreamName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_progress_update_stream(
    ProgressUpdateStreamName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migration_hub(
        "DeleteProgressUpdateStream",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ProgressUpdateStreamName" => ProgressUpdateStreamName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_application_state(application_id)
    describe_application_state(application_id, params::Dict{String,<:Any})

Gets the migration status of an application.

# Arguments
- `application_id`: The configurationId in Application Discovery Service that uniquely
  identifies the grouped application.

"""
function describe_application_state(
    ApplicationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migration_hub(
        "DescribeApplicationState",
        Dict{String,Any}("ApplicationId" => ApplicationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_application_state(
    ApplicationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migration_hub(
        "DescribeApplicationState",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ApplicationId" => ApplicationId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_migration_task(migration_task_name, progress_update_stream)
    describe_migration_task(migration_task_name, progress_update_stream, params::Dict{String,<:Any})

Retrieves a list of all attributes associated with a specific migration task.

# Arguments
- `migration_task_name`: The identifier given to the MigrationTask. Do not store personal
  data in this field.
- `progress_update_stream`: The name of the ProgressUpdateStream.

"""
function describe_migration_task(
    MigrationTaskName,
    ProgressUpdateStream;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migration_hub(
        "DescribeMigrationTask",
        Dict{String,Any}(
            "MigrationTaskName" => MigrationTaskName,
            "ProgressUpdateStream" => ProgressUpdateStream,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_migration_task(
    MigrationTaskName,
    ProgressUpdateStream,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migration_hub(
        "DescribeMigrationTask",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "MigrationTaskName" => MigrationTaskName,
                    "ProgressUpdateStream" => ProgressUpdateStream,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_created_artifact(created_artifact_name, migration_task_name, progress_update_stream)
    disassociate_created_artifact(created_artifact_name, migration_task_name, progress_update_stream, params::Dict{String,<:Any})

Disassociates a created artifact of an AWS resource with a migration task performed by a
migration tool that was previously associated. This API has the following traits:   A
migration user can call the DisassociateCreatedArtifacts operation to disassociate a
created AWS Artifact from a migration task.   The created artifact name must be provided in
ARN (Amazon Resource Name) format which will contain information about type and region; for
example: arn:aws:ec2:us-east-1:488216288981:image/ami-6d0ba87b.   Examples of the AWS
resource behind the created artifact are, AMI's, EC2 instance, or RDS instance, etc.

# Arguments
- `created_artifact_name`: An ARN of the AWS resource related to the migration (e.g., AMI,
  EC2 instance, RDS instance, etc.)
- `migration_task_name`: Unique identifier that references the migration task to be
  disassociated with the artifact. Do not store personal data in this field.
- `progress_update_stream`: The name of the ProgressUpdateStream.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DryRun"`: Optional boolean flag to indicate whether any effect should take place. Used
  to test if the caller has permission to make the call.
"""
function disassociate_created_artifact(
    CreatedArtifactName,
    MigrationTaskName,
    ProgressUpdateStream;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migration_hub(
        "DisassociateCreatedArtifact",
        Dict{String,Any}(
            "CreatedArtifactName" => CreatedArtifactName,
            "MigrationTaskName" => MigrationTaskName,
            "ProgressUpdateStream" => ProgressUpdateStream,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_created_artifact(
    CreatedArtifactName,
    MigrationTaskName,
    ProgressUpdateStream,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migration_hub(
        "DisassociateCreatedArtifact",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CreatedArtifactName" => CreatedArtifactName,
                    "MigrationTaskName" => MigrationTaskName,
                    "ProgressUpdateStream" => ProgressUpdateStream,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_discovered_resource(configuration_id, migration_task_name, progress_update_stream)
    disassociate_discovered_resource(configuration_id, migration_task_name, progress_update_stream, params::Dict{String,<:Any})

Disassociate an Application Discovery Service discovered resource from a migration task.

# Arguments
- `configuration_id`: ConfigurationId of the Application Discovery Service resource to be
  disassociated.
- `migration_task_name`: The identifier given to the MigrationTask. Do not store personal
  data in this field.
- `progress_update_stream`: The name of the ProgressUpdateStream.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DryRun"`: Optional boolean flag to indicate whether any effect should take place. Used
  to test if the caller has permission to make the call.
"""
function disassociate_discovered_resource(
    ConfigurationId,
    MigrationTaskName,
    ProgressUpdateStream;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migration_hub(
        "DisassociateDiscoveredResource",
        Dict{String,Any}(
            "ConfigurationId" => ConfigurationId,
            "MigrationTaskName" => MigrationTaskName,
            "ProgressUpdateStream" => ProgressUpdateStream,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_discovered_resource(
    ConfigurationId,
    MigrationTaskName,
    ProgressUpdateStream,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migration_hub(
        "DisassociateDiscoveredResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ConfigurationId" => ConfigurationId,
                    "MigrationTaskName" => MigrationTaskName,
                    "ProgressUpdateStream" => ProgressUpdateStream,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    import_migration_task(migration_task_name, progress_update_stream)
    import_migration_task(migration_task_name, progress_update_stream, params::Dict{String,<:Any})

Registers a new migration task which represents a server, database, etc., being migrated to
AWS by a migration tool. This API is a prerequisite to calling the NotifyMigrationTaskState
API as the migration tool must first register the migration task with Migration Hub.

# Arguments
- `migration_task_name`: Unique identifier that references the migration task. Do not store
  personal data in this field.
- `progress_update_stream`: The name of the ProgressUpdateStream. &gt;

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DryRun"`: Optional boolean flag to indicate whether any effect should take place. Used
  to test if the caller has permission to make the call.
"""
function import_migration_task(
    MigrationTaskName,
    ProgressUpdateStream;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migration_hub(
        "ImportMigrationTask",
        Dict{String,Any}(
            "MigrationTaskName" => MigrationTaskName,
            "ProgressUpdateStream" => ProgressUpdateStream,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function import_migration_task(
    MigrationTaskName,
    ProgressUpdateStream,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migration_hub(
        "ImportMigrationTask",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "MigrationTaskName" => MigrationTaskName,
                    "ProgressUpdateStream" => ProgressUpdateStream,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_application_states()
    list_application_states(params::Dict{String,<:Any})

Lists all the migration statuses for your applications. If you use the optional
ApplicationIds parameter, only the migration statuses for those applications will be
returned.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ApplicationIds"`: The configurationIds from the Application Discovery Service that
  uniquely identifies your applications.
- `"MaxResults"`: Maximum number of results to be returned per page.
- `"NextToken"`: If a NextToken was returned by a previous call, there are more results
  available. To retrieve the next page of results, make the call again using the returned
  token in NextToken.
"""
function list_application_states(; aws_config::AbstractAWSConfig=current_aws_config())
    return migration_hub(
        "ListApplicationStates"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_application_states(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migration_hub(
        "ListApplicationStates",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_created_artifacts(migration_task_name, progress_update_stream)
    list_created_artifacts(migration_task_name, progress_update_stream, params::Dict{String,<:Any})

Lists the created artifacts attached to a given migration task in an update stream. This
API has the following traits:   Gets the list of the created artifacts while migration is
taking place.   Shows the artifacts created by the migration tool that was associated by
the AssociateCreatedArtifact API.    Lists created artifacts in a paginated interface.

# Arguments
- `migration_task_name`: Unique identifier that references the migration task. Do not store
  personal data in this field.
- `progress_update_stream`: The name of the ProgressUpdateStream.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Maximum number of results to be returned per page.
- `"NextToken"`: If a NextToken was returned by a previous call, there are more results
  available. To retrieve the next page of results, make the call again using the returned
  token in NextToken.
"""
function list_created_artifacts(
    MigrationTaskName,
    ProgressUpdateStream;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migration_hub(
        "ListCreatedArtifacts",
        Dict{String,Any}(
            "MigrationTaskName" => MigrationTaskName,
            "ProgressUpdateStream" => ProgressUpdateStream,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_created_artifacts(
    MigrationTaskName,
    ProgressUpdateStream,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migration_hub(
        "ListCreatedArtifacts",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "MigrationTaskName" => MigrationTaskName,
                    "ProgressUpdateStream" => ProgressUpdateStream,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_discovered_resources(migration_task_name, progress_update_stream)
    list_discovered_resources(migration_task_name, progress_update_stream, params::Dict{String,<:Any})

Lists discovered resources associated with the given MigrationTask.

# Arguments
- `migration_task_name`: The name of the MigrationTask. Do not store personal data in this
  field.
- `progress_update_stream`: The name of the ProgressUpdateStream.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results returned per page.
- `"NextToken"`: If a NextToken was returned by a previous call, there are more results
  available. To retrieve the next page of results, make the call again using the returned
  token in NextToken.
"""
function list_discovered_resources(
    MigrationTaskName,
    ProgressUpdateStream;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migration_hub(
        "ListDiscoveredResources",
        Dict{String,Any}(
            "MigrationTaskName" => MigrationTaskName,
            "ProgressUpdateStream" => ProgressUpdateStream,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_discovered_resources(
    MigrationTaskName,
    ProgressUpdateStream,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migration_hub(
        "ListDiscoveredResources",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "MigrationTaskName" => MigrationTaskName,
                    "ProgressUpdateStream" => ProgressUpdateStream,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_migration_tasks()
    list_migration_tasks(params::Dict{String,<:Any})

Lists all, or filtered by resource name, migration tasks associated with the user account
making this call. This API has the following traits:   Can show a summary list of the most
recent migration tasks.   Can show a summary list of migration tasks associated with a
given discovered resource.   Lists migration tasks in a paginated interface.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Value to specify how many results are returned per page.
- `"NextToken"`: If a NextToken was returned by a previous call, there are more results
  available. To retrieve the next page of results, make the call again using the returned
  token in NextToken.
- `"ResourceName"`: Filter migration tasks by discovered resource name.
"""
function list_migration_tasks(; aws_config::AbstractAWSConfig=current_aws_config())
    return migration_hub(
        "ListMigrationTasks"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_migration_tasks(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migration_hub(
        "ListMigrationTasks", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_progress_update_streams()
    list_progress_update_streams(params::Dict{String,<:Any})

Lists progress update streams associated with the user account making this call.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Filter to limit the maximum number of results to list per page.
- `"NextToken"`: If a NextToken was returned by a previous call, there are more results
  available. To retrieve the next page of results, make the call again using the returned
  token in NextToken.
"""
function list_progress_update_streams(; aws_config::AbstractAWSConfig=current_aws_config())
    return migration_hub(
        "ListProgressUpdateStreams"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_progress_update_streams(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migration_hub(
        "ListProgressUpdateStreams",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    notify_application_state(application_id, status)
    notify_application_state(application_id, status, params::Dict{String,<:Any})

Sets the migration state of an application. For a given application identified by the value
passed to ApplicationId, its status is set or updated by passing one of three values to
Status: NOT_STARTED | IN_PROGRESS | COMPLETED.

# Arguments
- `application_id`: The configurationId in Application Discovery Service that uniquely
  identifies the grouped application.
- `status`: Status of the application - Not Started, In-Progress, Complete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DryRun"`: Optional boolean flag to indicate whether any effect should take place. Used
  to test if the caller has permission to make the call.
- `"UpdateDateTime"`: The timestamp when the application state changed.
"""
function notify_application_state(
    ApplicationId, Status; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migration_hub(
        "NotifyApplicationState",
        Dict{String,Any}("ApplicationId" => ApplicationId, "Status" => Status);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function notify_application_state(
    ApplicationId,
    Status,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migration_hub(
        "NotifyApplicationState",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ApplicationId" => ApplicationId, "Status" => Status),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    notify_migration_task_state(migration_task_name, next_update_seconds, progress_update_stream, task, update_date_time)
    notify_migration_task_state(migration_task_name, next_update_seconds, progress_update_stream, task, update_date_time, params::Dict{String,<:Any})

Notifies Migration Hub of the current status, progress, or other detail regarding a
migration task. This API has the following traits:   Migration tools will call the
NotifyMigrationTaskState API to share the latest progress and status.    MigrationTaskName
is used for addressing updates to the correct target.    ProgressUpdateStream is used for
access control and to provide a namespace for each migration tool.

# Arguments
- `migration_task_name`: Unique identifier that references the migration task. Do not store
  personal data in this field.
- `next_update_seconds`: Number of seconds after the UpdateDateTime within which the
  Migration Hub can expect an update. If Migration Hub does not receive an update within the
  specified interval, then the migration task will be considered stale.
- `progress_update_stream`: The name of the ProgressUpdateStream.
- `task`: Information about the task's progress and status.
- `update_date_time`: The timestamp when the task was gathered.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DryRun"`: Optional boolean flag to indicate whether any effect should take place. Used
  to test if the caller has permission to make the call.
"""
function notify_migration_task_state(
    MigrationTaskName,
    NextUpdateSeconds,
    ProgressUpdateStream,
    Task,
    UpdateDateTime;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migration_hub(
        "NotifyMigrationTaskState",
        Dict{String,Any}(
            "MigrationTaskName" => MigrationTaskName,
            "NextUpdateSeconds" => NextUpdateSeconds,
            "ProgressUpdateStream" => ProgressUpdateStream,
            "Task" => Task,
            "UpdateDateTime" => UpdateDateTime,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function notify_migration_task_state(
    MigrationTaskName,
    NextUpdateSeconds,
    ProgressUpdateStream,
    Task,
    UpdateDateTime,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migration_hub(
        "NotifyMigrationTaskState",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "MigrationTaskName" => MigrationTaskName,
                    "NextUpdateSeconds" => NextUpdateSeconds,
                    "ProgressUpdateStream" => ProgressUpdateStream,
                    "Task" => Task,
                    "UpdateDateTime" => UpdateDateTime,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_resource_attributes(migration_task_name, progress_update_stream, resource_attribute_list)
    put_resource_attributes(migration_task_name, progress_update_stream, resource_attribute_list, params::Dict{String,<:Any})

Provides identifying details of the resource being migrated so that it can be associated in
the Application Discovery Service repository. This association occurs asynchronously after
PutResourceAttributes returns.    Keep in mind that subsequent calls to
PutResourceAttributes will override previously stored attributes. For example, if it is
first called with a MAC address, but later, it is desired to add an IP address, it will
then be required to call it with both the IP and MAC addresses to prevent overriding the
MAC address.   Note the instructions regarding the special use case of the
ResourceAttributeList  parameter when specifying any \"VM\" related value.     Because this
is an asynchronous call, it will always return 200, whether an association occurs or not.
To confirm if an association was found based on the provided details, call
ListDiscoveredResources.

# Arguments
- `migration_task_name`: Unique identifier that references the migration task. Do not store
  personal data in this field.
- `progress_update_stream`: The name of the ProgressUpdateStream.
- `resource_attribute_list`: Information about the resource that is being migrated. This
  data will be used to map the task to a resource in the Application Discovery Service
  repository.  Takes the object array of ResourceAttribute where the Type field is reserved
  for the following values: IPV4_ADDRESS | IPV6_ADDRESS | MAC_ADDRESS | FQDN | VM_MANAGER_ID
  | VM_MANAGED_OBJECT_REFERENCE | VM_NAME | VM_PATH | BIOS_ID | MOTHERBOARD_SERIAL_NUMBER
  where the identifying value can be a string up to 256 characters.     If any \"VM\" related
  value is set for a ResourceAttribute object, it is required that VM_MANAGER_ID, as a
  minimum, is always set. If VM_MANAGER_ID is not set, then all \"VM\" fields will be
  discarded and \"VM\" fields will not be used for matching the migration task to a server in
  Application Discovery Service repository. See the Example section below for a use case of
  specifying \"VM\" related values.    If a server you are trying to match has multiple IP or
  MAC addresses, you should provide as many as you know in separate type/value pairs passed
  to the ResourceAttributeList parameter to maximize the chances of matching.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DryRun"`: Optional boolean flag to indicate whether any effect should take place. Used
  to test if the caller has permission to make the call.
"""
function put_resource_attributes(
    MigrationTaskName,
    ProgressUpdateStream,
    ResourceAttributeList;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migration_hub(
        "PutResourceAttributes",
        Dict{String,Any}(
            "MigrationTaskName" => MigrationTaskName,
            "ProgressUpdateStream" => ProgressUpdateStream,
            "ResourceAttributeList" => ResourceAttributeList,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_resource_attributes(
    MigrationTaskName,
    ProgressUpdateStream,
    ResourceAttributeList,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migration_hub(
        "PutResourceAttributes",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "MigrationTaskName" => MigrationTaskName,
                    "ProgressUpdateStream" => ProgressUpdateStream,
                    "ResourceAttributeList" => ResourceAttributeList,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: inspector
using AWS.Compat
using AWS.UUIDs

"""
    add_attributes_to_findings(attributes, finding_arns)
    add_attributes_to_findings(attributes, finding_arns, params::Dict{String,<:Any})

Assigns attributes (key and value pairs) to the findings that are specified by the ARNs of
the findings.

# Arguments
- `attributes`: The array of attributes that you want to assign to specified findings.
- `finding_arns`: The ARNs that specify the findings that you want to assign attributes to.

"""
function add_attributes_to_findings(
    attributes, findingArns; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector(
        "AddAttributesToFindings",
        Dict{String,Any}("attributes" => attributes, "findingArns" => findingArns);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_attributes_to_findings(
    attributes,
    findingArns,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector(
        "AddAttributesToFindings",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("attributes" => attributes, "findingArns" => findingArns),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_assessment_target(assessment_target_name)
    create_assessment_target(assessment_target_name, params::Dict{String,<:Any})

Creates a new assessment target using the ARN of the resource group that is generated by
CreateResourceGroup. If resourceGroupArn is not specified, all EC2 instances in the current
AWS account and region are included in the assessment target. If the service-linked role
isn’t already registered, this action also creates and registers a service-linked role to
grant Amazon Inspector access to AWS Services needed to perform security assessments. You
can create up to 50 assessment targets per AWS account. You can run up to 500 concurrent
agents per AWS account. For more information, see  Amazon Inspector Assessment Targets.

# Arguments
- `assessment_target_name`: The user-defined name that identifies the assessment target
  that you want to create. The name must be unique within the AWS account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"resourceGroupArn"`: The ARN that specifies the resource group that is used to create
  the assessment target. If resourceGroupArn is not specified, all EC2 instances in the
  current AWS account and region are included in the assessment target.
"""
function create_assessment_target(
    assessmentTargetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector(
        "CreateAssessmentTarget",
        Dict{String,Any}("assessmentTargetName" => assessmentTargetName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_assessment_target(
    assessmentTargetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector(
        "CreateAssessmentTarget",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("assessmentTargetName" => assessmentTargetName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_assessment_template(assessment_target_arn, assessment_template_name, duration_in_seconds, rules_package_arns)
    create_assessment_template(assessment_target_arn, assessment_template_name, duration_in_seconds, rules_package_arns, params::Dict{String,<:Any})

Creates an assessment template for the assessment target that is specified by the ARN of
the assessment target. If the service-linked role isn’t already registered, this action
also creates and registers a service-linked role to grant Amazon Inspector access to AWS
Services needed to perform security assessments.

# Arguments
- `assessment_target_arn`: The ARN that specifies the assessment target for which you want
  to create the assessment template.
- `assessment_template_name`: The user-defined name that identifies the assessment template
  that you want to create. You can create several assessment templates for an assessment
  target. The names of the assessment templates that correspond to a particular assessment
  target must be unique.
- `duration_in_seconds`: The duration of the assessment run in seconds.
- `rules_package_arns`: The ARNs that specify the rules packages that you want to attach to
  the assessment template.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"userAttributesForFindings"`: The user-defined attributes that are assigned to every
  finding that is generated by the assessment run that uses this assessment template. An
  attribute is a key and value pair (an Attribute object). Within an assessment template,
  each key must be unique.
"""
function create_assessment_template(
    assessmentTargetArn,
    assessmentTemplateName,
    durationInSeconds,
    rulesPackageArns;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector(
        "CreateAssessmentTemplate",
        Dict{String,Any}(
            "assessmentTargetArn" => assessmentTargetArn,
            "assessmentTemplateName" => assessmentTemplateName,
            "durationInSeconds" => durationInSeconds,
            "rulesPackageArns" => rulesPackageArns,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_assessment_template(
    assessmentTargetArn,
    assessmentTemplateName,
    durationInSeconds,
    rulesPackageArns,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector(
        "CreateAssessmentTemplate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "assessmentTargetArn" => assessmentTargetArn,
                    "assessmentTemplateName" => assessmentTemplateName,
                    "durationInSeconds" => durationInSeconds,
                    "rulesPackageArns" => rulesPackageArns,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_exclusions_preview(assessment_template_arn)
    create_exclusions_preview(assessment_template_arn, params::Dict{String,<:Any})

Starts the generation of an exclusions preview for the specified assessment template. The
exclusions preview lists the potential exclusions (ExclusionPreview) that Inspector can
detect before it runs the assessment.

# Arguments
- `assessment_template_arn`: The ARN that specifies the assessment template for which you
  want to create an exclusions preview.

"""
function create_exclusions_preview(
    assessmentTemplateArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector(
        "CreateExclusionsPreview",
        Dict{String,Any}("assessmentTemplateArn" => assessmentTemplateArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_exclusions_preview(
    assessmentTemplateArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector(
        "CreateExclusionsPreview",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("assessmentTemplateArn" => assessmentTemplateArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_resource_group(resource_group_tags)
    create_resource_group(resource_group_tags, params::Dict{String,<:Any})

Creates a resource group using the specified set of tags (key and value pairs) that are
used to select the EC2 instances to be included in an Amazon Inspector assessment target.
The created resource group is then used to create an Amazon Inspector assessment target.
For more information, see CreateAssessmentTarget.

# Arguments
- `resource_group_tags`: A collection of keys and an array of possible values,
  '[{\"key\":\"key1\",\"values\":[\"Value1\",\"Value2\"]},{\"key\":\"Key2\",\"values\":[\"Valu
  e3\"]}]'. For example,'[{\"key\":\"Name\",\"values\":[\"TestEC2Instance\"]}]'.

"""
function create_resource_group(
    resourceGroupTags; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector(
        "CreateResourceGroup",
        Dict{String,Any}("resourceGroupTags" => resourceGroupTags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_resource_group(
    resourceGroupTags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector(
        "CreateResourceGroup",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("resourceGroupTags" => resourceGroupTags), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_assessment_run(assessment_run_arn)
    delete_assessment_run(assessment_run_arn, params::Dict{String,<:Any})

Deletes the assessment run that is specified by the ARN of the assessment run.

# Arguments
- `assessment_run_arn`: The ARN that specifies the assessment run that you want to delete.

"""
function delete_assessment_run(
    assessmentRunArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector(
        "DeleteAssessmentRun",
        Dict{String,Any}("assessmentRunArn" => assessmentRunArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_assessment_run(
    assessmentRunArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector(
        "DeleteAssessmentRun",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("assessmentRunArn" => assessmentRunArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_assessment_target(assessment_target_arn)
    delete_assessment_target(assessment_target_arn, params::Dict{String,<:Any})

Deletes the assessment target that is specified by the ARN of the assessment target.

# Arguments
- `assessment_target_arn`: The ARN that specifies the assessment target that you want to
  delete.

"""
function delete_assessment_target(
    assessmentTargetArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector(
        "DeleteAssessmentTarget",
        Dict{String,Any}("assessmentTargetArn" => assessmentTargetArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_assessment_target(
    assessmentTargetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector(
        "DeleteAssessmentTarget",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("assessmentTargetArn" => assessmentTargetArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_assessment_template(assessment_template_arn)
    delete_assessment_template(assessment_template_arn, params::Dict{String,<:Any})

Deletes the assessment template that is specified by the ARN of the assessment template.

# Arguments
- `assessment_template_arn`: The ARN that specifies the assessment template that you want
  to delete.

"""
function delete_assessment_template(
    assessmentTemplateArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector(
        "DeleteAssessmentTemplate",
        Dict{String,Any}("assessmentTemplateArn" => assessmentTemplateArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_assessment_template(
    assessmentTemplateArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector(
        "DeleteAssessmentTemplate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("assessmentTemplateArn" => assessmentTemplateArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_assessment_runs(assessment_run_arns)
    describe_assessment_runs(assessment_run_arns, params::Dict{String,<:Any})

Describes the assessment runs that are specified by the ARNs of the assessment runs.

# Arguments
- `assessment_run_arns`: The ARN that specifies the assessment run that you want to
  describe.

"""
function describe_assessment_runs(
    assessmentRunArns; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector(
        "DescribeAssessmentRuns",
        Dict{String,Any}("assessmentRunArns" => assessmentRunArns);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_assessment_runs(
    assessmentRunArns,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector(
        "DescribeAssessmentRuns",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("assessmentRunArns" => assessmentRunArns), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_assessment_targets(assessment_target_arns)
    describe_assessment_targets(assessment_target_arns, params::Dict{String,<:Any})

Describes the assessment targets that are specified by the ARNs of the assessment targets.

# Arguments
- `assessment_target_arns`: The ARNs that specifies the assessment targets that you want to
  describe.

"""
function describe_assessment_targets(
    assessmentTargetArns; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector(
        "DescribeAssessmentTargets",
        Dict{String,Any}("assessmentTargetArns" => assessmentTargetArns);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_assessment_targets(
    assessmentTargetArns,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector(
        "DescribeAssessmentTargets",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("assessmentTargetArns" => assessmentTargetArns),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_assessment_templates(assessment_template_arns)
    describe_assessment_templates(assessment_template_arns, params::Dict{String,<:Any})

Describes the assessment templates that are specified by the ARNs of the assessment
templates.

# Arguments
- `assessment_template_arns`:

"""
function describe_assessment_templates(
    assessmentTemplateArns; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector(
        "DescribeAssessmentTemplates",
        Dict{String,Any}("assessmentTemplateArns" => assessmentTemplateArns);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_assessment_templates(
    assessmentTemplateArns,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector(
        "DescribeAssessmentTemplates",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("assessmentTemplateArns" => assessmentTemplateArns),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_cross_account_access_role()
    describe_cross_account_access_role(params::Dict{String,<:Any})

Describes the IAM role that enables Amazon Inspector to access your AWS account.

"""
function describe_cross_account_access_role(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector(
        "DescribeCrossAccountAccessRole";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_cross_account_access_role(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector(
        "DescribeCrossAccountAccessRole",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_exclusions(exclusion_arns)
    describe_exclusions(exclusion_arns, params::Dict{String,<:Any})

Describes the exclusions that are specified by the exclusions' ARNs.

# Arguments
- `exclusion_arns`: The list of ARNs that specify the exclusions that you want to describe.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"locale"`: The locale into which you want to translate the exclusion's title,
  description, and recommendation.
"""
function describe_exclusions(
    exclusionArns; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector(
        "DescribeExclusions",
        Dict{String,Any}("exclusionArns" => exclusionArns);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_exclusions(
    exclusionArns,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector(
        "DescribeExclusions",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("exclusionArns" => exclusionArns), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_findings(finding_arns)
    describe_findings(finding_arns, params::Dict{String,<:Any})

Describes the findings that are specified by the ARNs of the findings.

# Arguments
- `finding_arns`: The ARN that specifies the finding that you want to describe.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"locale"`: The locale into which you want to translate a finding description,
  recommendation, and the short description that identifies the finding.
"""
function describe_findings(findingArns; aws_config::AbstractAWSConfig=current_aws_config())
    return inspector(
        "DescribeFindings",
        Dict{String,Any}("findingArns" => findingArns);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_findings(
    findingArns,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector(
        "DescribeFindings",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("findingArns" => findingArns), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_resource_groups(resource_group_arns)
    describe_resource_groups(resource_group_arns, params::Dict{String,<:Any})

Describes the resource groups that are specified by the ARNs of the resource groups.

# Arguments
- `resource_group_arns`: The ARN that specifies the resource group that you want to
  describe.

"""
function describe_resource_groups(
    resourceGroupArns; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector(
        "DescribeResourceGroups",
        Dict{String,Any}("resourceGroupArns" => resourceGroupArns);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_resource_groups(
    resourceGroupArns,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector(
        "DescribeResourceGroups",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("resourceGroupArns" => resourceGroupArns), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_rules_packages(rules_package_arns)
    describe_rules_packages(rules_package_arns, params::Dict{String,<:Any})

Describes the rules packages that are specified by the ARNs of the rules packages.

# Arguments
- `rules_package_arns`: The ARN that specifies the rules package that you want to describe.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"locale"`: The locale that you want to translate a rules package description into.
"""
function describe_rules_packages(
    rulesPackageArns; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector(
        "DescribeRulesPackages",
        Dict{String,Any}("rulesPackageArns" => rulesPackageArns);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_rules_packages(
    rulesPackageArns,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector(
        "DescribeRulesPackages",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("rulesPackageArns" => rulesPackageArns), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_assessment_report(assessment_run_arn, report_file_format, report_type)
    get_assessment_report(assessment_run_arn, report_file_format, report_type, params::Dict{String,<:Any})

Produces an assessment report that includes detailed and comprehensive results of a
specified assessment run.

# Arguments
- `assessment_run_arn`: The ARN that specifies the assessment run for which you want to
  generate a report.
- `report_file_format`: Specifies the file format (html or pdf) of the assessment report
  that you want to generate.
- `report_type`: Specifies the type of the assessment report that you want to generate.
  There are two types of assessment reports: a finding report and a full report. For more
  information, see Assessment Reports.

"""
function get_assessment_report(
    assessmentRunArn,
    reportFileFormat,
    reportType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector(
        "GetAssessmentReport",
        Dict{String,Any}(
            "assessmentRunArn" => assessmentRunArn,
            "reportFileFormat" => reportFileFormat,
            "reportType" => reportType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_assessment_report(
    assessmentRunArn,
    reportFileFormat,
    reportType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector(
        "GetAssessmentReport",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "assessmentRunArn" => assessmentRunArn,
                    "reportFileFormat" => reportFileFormat,
                    "reportType" => reportType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_exclusions_preview(assessment_template_arn, preview_token)
    get_exclusions_preview(assessment_template_arn, preview_token, params::Dict{String,<:Any})

Retrieves the exclusions preview (a list of ExclusionPreview objects) specified by the
preview token. You can obtain the preview token by running the CreateExclusionsPreview API.

# Arguments
- `assessment_template_arn`: The ARN that specifies the assessment template for which the
  exclusions preview was requested.
- `preview_token`: The unique identifier associated of the exclusions preview.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"locale"`: The locale into which you want to translate the exclusion's title,
  description, and recommendation.
- `"maxResults"`: You can use this parameter to indicate the maximum number of items you
  want in the response. The default value is 100. The maximum value is 500.
- `"nextToken"`: You can use this parameter when paginating results. Set the value of this
  parameter to null on your first call to the GetExclusionsPreviewRequest action. Subsequent
  calls to the action fill nextToken in the request with the value of nextToken from the
  previous response to continue listing data.
"""
function get_exclusions_preview(
    assessmentTemplateArn, previewToken; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector(
        "GetExclusionsPreview",
        Dict{String,Any}(
            "assessmentTemplateArn" => assessmentTemplateArn, "previewToken" => previewToken
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_exclusions_preview(
    assessmentTemplateArn,
    previewToken,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector(
        "GetExclusionsPreview",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "assessmentTemplateArn" => assessmentTemplateArn,
                    "previewToken" => previewToken,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_telemetry_metadata(assessment_run_arn)
    get_telemetry_metadata(assessment_run_arn, params::Dict{String,<:Any})

Information about the data that is collected for the specified assessment run.

# Arguments
- `assessment_run_arn`: The ARN that specifies the assessment run that has the telemetry
  data that you want to obtain.

"""
function get_telemetry_metadata(
    assessmentRunArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector(
        "GetTelemetryMetadata",
        Dict{String,Any}("assessmentRunArn" => assessmentRunArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_telemetry_metadata(
    assessmentRunArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector(
        "GetTelemetryMetadata",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("assessmentRunArn" => assessmentRunArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_assessment_run_agents(assessment_run_arn)
    list_assessment_run_agents(assessment_run_arn, params::Dict{String,<:Any})

Lists the agents of the assessment runs that are specified by the ARNs of the assessment
runs.

# Arguments
- `assessment_run_arn`: The ARN that specifies the assessment run whose agents you want to
  list.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filter"`: You can use this parameter to specify a subset of data to be included in the
  action's response. For a record to match a filter, all specified filter attributes must
  match. When multiple values are specified for a filter attribute, any of the values can
  match.
- `"maxResults"`: You can use this parameter to indicate the maximum number of items that
  you want in the response. The default value is 10. The maximum value is 500.
- `"nextToken"`: You can use this parameter when paginating results. Set the value of this
  parameter to null on your first call to the ListAssessmentRunAgents action. Subsequent
  calls to the action fill nextToken in the request with the value of NextToken from the
  previous response to continue listing data.
"""
function list_assessment_run_agents(
    assessmentRunArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector(
        "ListAssessmentRunAgents",
        Dict{String,Any}("assessmentRunArn" => assessmentRunArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_assessment_run_agents(
    assessmentRunArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector(
        "ListAssessmentRunAgents",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("assessmentRunArn" => assessmentRunArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_assessment_runs()
    list_assessment_runs(params::Dict{String,<:Any})

Lists the assessment runs that correspond to the assessment templates that are specified by
the ARNs of the assessment templates.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"assessmentTemplateArns"`: The ARNs that specify the assessment templates whose
  assessment runs you want to list.
- `"filter"`: You can use this parameter to specify a subset of data to be included in the
  action's response. For a record to match a filter, all specified filter attributes must
  match. When multiple values are specified for a filter attribute, any of the values can
  match.
- `"maxResults"`: You can use this parameter to indicate the maximum number of items that
  you want in the response. The default value is 10. The maximum value is 500.
- `"nextToken"`: You can use this parameter when paginating results. Set the value of this
  parameter to null on your first call to the ListAssessmentRuns action. Subsequent calls to
  the action fill nextToken in the request with the value of NextToken from the previous
  response to continue listing data.
"""
function list_assessment_runs(; aws_config::AbstractAWSConfig=current_aws_config())
    return inspector(
        "ListAssessmentRuns"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_assessment_runs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector(
        "ListAssessmentRuns", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_assessment_targets()
    list_assessment_targets(params::Dict{String,<:Any})

Lists the ARNs of the assessment targets within this AWS account. For more information
about assessment targets, see Amazon Inspector Assessment Targets.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filter"`: You can use this parameter to specify a subset of data to be included in the
  action's response. For a record to match a filter, all specified filter attributes must
  match. When multiple values are specified for a filter attribute, any of the values can
  match.
- `"maxResults"`: You can use this parameter to indicate the maximum number of items you
  want in the response. The default value is 10. The maximum value is 500.
- `"nextToken"`: You can use this parameter when paginating results. Set the value of this
  parameter to null on your first call to the ListAssessmentTargets action. Subsequent calls
  to the action fill nextToken in the request with the value of NextToken from the previous
  response to continue listing data.
"""
function list_assessment_targets(; aws_config::AbstractAWSConfig=current_aws_config())
    return inspector(
        "ListAssessmentTargets"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_assessment_targets(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector(
        "ListAssessmentTargets",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_assessment_templates()
    list_assessment_templates(params::Dict{String,<:Any})

Lists the assessment templates that correspond to the assessment targets that are specified
by the ARNs of the assessment targets.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"assessmentTargetArns"`: A list of ARNs that specifies the assessment targets whose
  assessment templates you want to list.
- `"filter"`: You can use this parameter to specify a subset of data to be included in the
  action's response. For a record to match a filter, all specified filter attributes must
  match. When multiple values are specified for a filter attribute, any of the values can
  match.
- `"maxResults"`: You can use this parameter to indicate the maximum number of items you
  want in the response. The default value is 10. The maximum value is 500.
- `"nextToken"`: You can use this parameter when paginating results. Set the value of this
  parameter to null on your first call to the ListAssessmentTemplates action. Subsequent
  calls to the action fill nextToken in the request with the value of NextToken from the
  previous response to continue listing data.
"""
function list_assessment_templates(; aws_config::AbstractAWSConfig=current_aws_config())
    return inspector(
        "ListAssessmentTemplates"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_assessment_templates(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector(
        "ListAssessmentTemplates",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_event_subscriptions()
    list_event_subscriptions(params::Dict{String,<:Any})

Lists all the event subscriptions for the assessment template that is specified by the ARN
of the assessment template. For more information, see SubscribeToEvent and
UnsubscribeFromEvent.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: You can use this parameter to indicate the maximum number of items you
  want in the response. The default value is 10. The maximum value is 500.
- `"nextToken"`: You can use this parameter when paginating results. Set the value of this
  parameter to null on your first call to the ListEventSubscriptions action. Subsequent calls
  to the action fill nextToken in the request with the value of NextToken from the previous
  response to continue listing data.
- `"resourceArn"`: The ARN of the assessment template for which you want to list the
  existing event subscriptions.
"""
function list_event_subscriptions(; aws_config::AbstractAWSConfig=current_aws_config())
    return inspector(
        "ListEventSubscriptions"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_event_subscriptions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector(
        "ListEventSubscriptions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_exclusions(assessment_run_arn)
    list_exclusions(assessment_run_arn, params::Dict{String,<:Any})

List exclusions that are generated by the assessment run.

# Arguments
- `assessment_run_arn`: The ARN of the assessment run that generated the exclusions that
  you want to list.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: You can use this parameter to indicate the maximum number of items you
  want in the response. The default value is 100. The maximum value is 500.
- `"nextToken"`: You can use this parameter when paginating results. Set the value of this
  parameter to null on your first call to the ListExclusionsRequest action. Subsequent calls
  to the action fill nextToken in the request with the value of nextToken from the previous
  response to continue listing data.
"""
function list_exclusions(
    assessmentRunArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector(
        "ListExclusions",
        Dict{String,Any}("assessmentRunArn" => assessmentRunArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_exclusions(
    assessmentRunArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector(
        "ListExclusions",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("assessmentRunArn" => assessmentRunArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_findings()
    list_findings(params::Dict{String,<:Any})

Lists findings that are generated by the assessment runs that are specified by the ARNs of
the assessment runs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"assessmentRunArns"`: The ARNs of the assessment runs that generate the findings that
  you want to list.
- `"filter"`: You can use this parameter to specify a subset of data to be included in the
  action's response. For a record to match a filter, all specified filter attributes must
  match. When multiple values are specified for a filter attribute, any of the values can
  match.
- `"maxResults"`: You can use this parameter to indicate the maximum number of items you
  want in the response. The default value is 10. The maximum value is 500.
- `"nextToken"`: You can use this parameter when paginating results. Set the value of this
  parameter to null on your first call to the ListFindings action. Subsequent calls to the
  action fill nextToken in the request with the value of NextToken from the previous response
  to continue listing data.
"""
function list_findings(; aws_config::AbstractAWSConfig=current_aws_config())
    return inspector("ListFindings"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_findings(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector(
        "ListFindings", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_rules_packages()
    list_rules_packages(params::Dict{String,<:Any})

Lists all available Amazon Inspector rules packages.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: You can use this parameter to indicate the maximum number of items you
  want in the response. The default value is 10. The maximum value is 500.
- `"nextToken"`: You can use this parameter when paginating results. Set the value of this
  parameter to null on your first call to the ListRulesPackages action. Subsequent calls to
  the action fill nextToken in the request with the value of NextToken from the previous
  response to continue listing data.
"""
function list_rules_packages(; aws_config::AbstractAWSConfig=current_aws_config())
    return inspector(
        "ListRulesPackages"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_rules_packages(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector(
        "ListRulesPackages", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists all tags associated with an assessment template.

# Arguments
- `resource_arn`: The ARN that specifies the assessment template whose tags you want to
  list.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector(
        "ListTagsForResource",
        Dict{String,Any}("resourceArn" => resourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceArn" => resourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    preview_agents(preview_agents_arn)
    preview_agents(preview_agents_arn, params::Dict{String,<:Any})

Previews the agents installed on the EC2 instances that are part of the specified
assessment target.

# Arguments
- `preview_agents_arn`: The ARN of the assessment target whose agents you want to preview.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: You can use this parameter to indicate the maximum number of items you
  want in the response. The default value is 10. The maximum value is 500.
- `"nextToken"`: You can use this parameter when paginating results. Set the value of this
  parameter to null on your first call to the PreviewAgents action. Subsequent calls to the
  action fill nextToken in the request with the value of NextToken from the previous response
  to continue listing data.
"""
function preview_agents(
    previewAgentsArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector(
        "PreviewAgents",
        Dict{String,Any}("previewAgentsArn" => previewAgentsArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function preview_agents(
    previewAgentsArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector(
        "PreviewAgents",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("previewAgentsArn" => previewAgentsArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    register_cross_account_access_role(role_arn)
    register_cross_account_access_role(role_arn, params::Dict{String,<:Any})

Registers the IAM role that grants Amazon Inspector access to AWS Services needed to
perform security assessments.

# Arguments
- `role_arn`: The ARN of the IAM role that grants Amazon Inspector access to AWS Services
  needed to perform security assessments.

"""
function register_cross_account_access_role(
    roleArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector(
        "RegisterCrossAccountAccessRole",
        Dict{String,Any}("roleArn" => roleArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function register_cross_account_access_role(
    roleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector(
        "RegisterCrossAccountAccessRole",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("roleArn" => roleArn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_attributes_from_findings(attribute_keys, finding_arns)
    remove_attributes_from_findings(attribute_keys, finding_arns, params::Dict{String,<:Any})

Removes entire attributes (key and value pairs) from the findings that are specified by the
ARNs of the findings where an attribute with the specified key exists.

# Arguments
- `attribute_keys`: The array of attribute keys that you want to remove from specified
  findings.
- `finding_arns`: The ARNs that specify the findings that you want to remove attributes
  from.

"""
function remove_attributes_from_findings(
    attributeKeys, findingArns; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector(
        "RemoveAttributesFromFindings",
        Dict{String,Any}("attributeKeys" => attributeKeys, "findingArns" => findingArns);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_attributes_from_findings(
    attributeKeys,
    findingArns,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector(
        "RemoveAttributesFromFindings",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "attributeKeys" => attributeKeys, "findingArns" => findingArns
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    set_tags_for_resource(resource_arn)
    set_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Sets tags (key and value pairs) to the assessment template that is specified by the ARN of
the assessment template.

# Arguments
- `resource_arn`: The ARN of the assessment template that you want to set tags to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tags"`: A collection of key and value pairs that you want to set to the assessment
  template.
"""
function set_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector(
        "SetTagsForResource",
        Dict{String,Any}("resourceArn" => resourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function set_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector(
        "SetTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceArn" => resourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_assessment_run(assessment_template_arn)
    start_assessment_run(assessment_template_arn, params::Dict{String,<:Any})

Starts the assessment run specified by the ARN of the assessment template. For this API to
function properly, you must not exceed the limit of running up to 500 concurrent agents per
AWS account.

# Arguments
- `assessment_template_arn`: The ARN of the assessment template of the assessment run that
  you want to start.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"assessmentRunName"`: You can specify the name for the assessment run. The name must be
  unique for the assessment template whose ARN is used to start the assessment run.
"""
function start_assessment_run(
    assessmentTemplateArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector(
        "StartAssessmentRun",
        Dict{String,Any}("assessmentTemplateArn" => assessmentTemplateArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_assessment_run(
    assessmentTemplateArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector(
        "StartAssessmentRun",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("assessmentTemplateArn" => assessmentTemplateArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_assessment_run(assessment_run_arn)
    stop_assessment_run(assessment_run_arn, params::Dict{String,<:Any})

Stops the assessment run that is specified by the ARN of the assessment run.

# Arguments
- `assessment_run_arn`: The ARN of the assessment run that you want to stop.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"stopAction"`: An input option that can be set to either START_EVALUATION or
  SKIP_EVALUATION. START_EVALUATION (the default value), stops the AWS agent from collecting
  data and begins the results evaluation and the findings generation process. SKIP_EVALUATION
  cancels the assessment run immediately, after which no findings are generated.
"""
function stop_assessment_run(
    assessmentRunArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector(
        "StopAssessmentRun",
        Dict{String,Any}("assessmentRunArn" => assessmentRunArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_assessment_run(
    assessmentRunArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector(
        "StopAssessmentRun",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("assessmentRunArn" => assessmentRunArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    subscribe_to_event(event, resource_arn, topic_arn)
    subscribe_to_event(event, resource_arn, topic_arn, params::Dict{String,<:Any})

Enables the process of sending Amazon Simple Notification Service (SNS) notifications about
a specified event to a specified SNS topic.

# Arguments
- `event`: The event for which you want to receive SNS notifications.
- `resource_arn`: The ARN of the assessment template that is used during the event for
  which you want to receive SNS notifications.
- `topic_arn`: The ARN of the SNS topic to which the SNS notifications are sent.

"""
function subscribe_to_event(
    event, resourceArn, topicArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector(
        "SubscribeToEvent",
        Dict{String,Any}(
            "event" => event, "resourceArn" => resourceArn, "topicArn" => topicArn
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function subscribe_to_event(
    event,
    resourceArn,
    topicArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector(
        "SubscribeToEvent",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "event" => event, "resourceArn" => resourceArn, "topicArn" => topicArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    unsubscribe_from_event(event, resource_arn, topic_arn)
    unsubscribe_from_event(event, resource_arn, topic_arn, params::Dict{String,<:Any})

Disables the process of sending Amazon Simple Notification Service (SNS) notifications
about a specified event to a specified SNS topic.

# Arguments
- `event`: The event for which you want to stop receiving SNS notifications.
- `resource_arn`: The ARN of the assessment template that is used during the event for
  which you want to stop receiving SNS notifications.
- `topic_arn`: The ARN of the SNS topic to which SNS notifications are sent.

"""
function unsubscribe_from_event(
    event, resourceArn, topicArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector(
        "UnsubscribeFromEvent",
        Dict{String,Any}(
            "event" => event, "resourceArn" => resourceArn, "topicArn" => topicArn
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function unsubscribe_from_event(
    event,
    resourceArn,
    topicArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector(
        "UnsubscribeFromEvent",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "event" => event, "resourceArn" => resourceArn, "topicArn" => topicArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_assessment_target(assessment_target_arn, assessment_target_name)
    update_assessment_target(assessment_target_arn, assessment_target_name, params::Dict{String,<:Any})

Updates the assessment target that is specified by the ARN of the assessment target. If
resourceGroupArn is not specified, all EC2 instances in the current AWS account and region
are included in the assessment target.

# Arguments
- `assessment_target_arn`: The ARN of the assessment target that you want to update.
- `assessment_target_name`: The name of the assessment target that you want to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"resourceGroupArn"`: The ARN of the resource group that is used to specify the new
  resource group to associate with the assessment target.
"""
function update_assessment_target(
    assessmentTargetArn,
    assessmentTargetName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector(
        "UpdateAssessmentTarget",
        Dict{String,Any}(
            "assessmentTargetArn" => assessmentTargetArn,
            "assessmentTargetName" => assessmentTargetName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_assessment_target(
    assessmentTargetArn,
    assessmentTargetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector(
        "UpdateAssessmentTarget",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "assessmentTargetArn" => assessmentTargetArn,
                    "assessmentTargetName" => assessmentTargetName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: elastic_load_balancing
using AWS.Compat
using AWS.UUIDs

"""
    add_tags(load_balancer_names, tags)
    add_tags(load_balancer_names, tags, params::Dict{String,<:Any})

Adds the specified tags to the specified load balancer. Each load balancer can have a
maximum of 10 tags. Each tag consists of a key and an optional value. If a tag with the
same key is already associated with the load balancer, AddTags updates its value. For more
information, see Tag Your Classic Load Balancer in the Classic Load Balancers Guide.

# Arguments
- `load_balancer_names`: The name of the load balancer. You can specify one load balancer
  only.
- `tags`: The tags.

"""
function add_tags(
    LoadBalancerNames, Tags; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_load_balancing(
        "AddTags",
        Dict{String,Any}("LoadBalancerNames" => LoadBalancerNames, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_tags(
    LoadBalancerNames,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing(
        "AddTags",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("LoadBalancerNames" => LoadBalancerNames, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    apply_security_groups_to_load_balancer(load_balancer_name, security_groups)
    apply_security_groups_to_load_balancer(load_balancer_name, security_groups, params::Dict{String,<:Any})

Associates one or more security groups with your load balancer in a virtual private cloud
(VPC). The specified security groups override the previously associated security groups.
For more information, see Security Groups for Load Balancers in a VPC in the Classic Load
Balancers Guide.

# Arguments
- `load_balancer_name`: The name of the load balancer.
- `security_groups`: The IDs of the security groups to associate with the load balancer.
  Note that you cannot specify the name of the security group.

"""
function apply_security_groups_to_load_balancer(
    LoadBalancerName, SecurityGroups; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_load_balancing(
        "ApplySecurityGroupsToLoadBalancer",
        Dict{String,Any}(
            "LoadBalancerName" => LoadBalancerName, "SecurityGroups" => SecurityGroups
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function apply_security_groups_to_load_balancer(
    LoadBalancerName,
    SecurityGroups,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing(
        "ApplySecurityGroupsToLoadBalancer",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "LoadBalancerName" => LoadBalancerName,
                    "SecurityGroups" => SecurityGroups,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    attach_load_balancer_to_subnets(load_balancer_name, subnets)
    attach_load_balancer_to_subnets(load_balancer_name, subnets, params::Dict{String,<:Any})

Adds one or more subnets to the set of configured subnets for the specified load balancer.
The load balancer evenly distributes requests across all registered subnets. For more
information, see Add or Remove Subnets for Your Load Balancer in a VPC in the Classic Load
Balancers Guide.

# Arguments
- `load_balancer_name`: The name of the load balancer.
- `subnets`: The IDs of the subnets to add. You can add only one subnet per Availability
  Zone.

"""
function attach_load_balancer_to_subnets(
    LoadBalancerName, Subnets; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_load_balancing(
        "AttachLoadBalancerToSubnets",
        Dict{String,Any}("LoadBalancerName" => LoadBalancerName, "Subnets" => Subnets);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function attach_load_balancer_to_subnets(
    LoadBalancerName,
    Subnets,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing(
        "AttachLoadBalancerToSubnets",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "LoadBalancerName" => LoadBalancerName, "Subnets" => Subnets
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    configure_health_check(health_check, load_balancer_name)
    configure_health_check(health_check, load_balancer_name, params::Dict{String,<:Any})

Specifies the health check settings to use when evaluating the health state of your EC2
instances. For more information, see Configure Health Checks for Your Load Balancer in the
Classic Load Balancers Guide.

# Arguments
- `health_check`: The configuration information.
- `load_balancer_name`: The name of the load balancer.

"""
function configure_health_check(
    HealthCheck, LoadBalancerName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_load_balancing(
        "ConfigureHealthCheck",
        Dict{String,Any}(
            "HealthCheck" => HealthCheck, "LoadBalancerName" => LoadBalancerName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function configure_health_check(
    HealthCheck,
    LoadBalancerName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing(
        "ConfigureHealthCheck",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "HealthCheck" => HealthCheck, "LoadBalancerName" => LoadBalancerName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_app_cookie_stickiness_policy(cookie_name, load_balancer_name, policy_name)
    create_app_cookie_stickiness_policy(cookie_name, load_balancer_name, policy_name, params::Dict{String,<:Any})

Generates a stickiness policy with sticky session lifetimes that follow that of an
application-generated cookie. This policy can be associated only with HTTP/HTTPS listeners.
This policy is similar to the policy created by CreateLBCookieStickinessPolicy, except that
the lifetime of the special Elastic Load Balancing cookie, AWSELB, follows the lifetime of
the application-generated cookie specified in the policy configuration. The load balancer
only inserts a new stickiness cookie when the application response includes a new
application cookie. If the application cookie is explicitly removed or expires, the session
stops being sticky until a new application cookie is issued. For more information, see
Application-Controlled Session Stickiness in the Classic Load Balancers Guide.

# Arguments
- `cookie_name`: The name of the application cookie used for stickiness.
- `load_balancer_name`: The name of the load balancer.
- `policy_name`: The name of the policy being created. Policy names must consist of
  alphanumeric characters and dashes (-). This name must be unique within the set of policies
  for this load balancer.

"""
function create_app_cookie_stickiness_policy(
    CookieName,
    LoadBalancerName,
    PolicyName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing(
        "CreateAppCookieStickinessPolicy",
        Dict{String,Any}(
            "CookieName" => CookieName,
            "LoadBalancerName" => LoadBalancerName,
            "PolicyName" => PolicyName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_app_cookie_stickiness_policy(
    CookieName,
    LoadBalancerName,
    PolicyName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing(
        "CreateAppCookieStickinessPolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CookieName" => CookieName,
                    "LoadBalancerName" => LoadBalancerName,
                    "PolicyName" => PolicyName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_lbcookie_stickiness_policy(load_balancer_name, policy_name)
    create_lbcookie_stickiness_policy(load_balancer_name, policy_name, params::Dict{String,<:Any})

Generates a stickiness policy with sticky session lifetimes controlled by the lifetime of
the browser (user-agent) or a specified expiration period. This policy can be associated
only with HTTP/HTTPS listeners. When a load balancer implements this policy, the load
balancer uses a special cookie to track the instance for each request. When the load
balancer receives a request, it first checks to see if this cookie is present in the
request. If so, the load balancer sends the request to the application server specified in
the cookie. If not, the load balancer sends the request to a server that is chosen based on
the existing load-balancing algorithm. A cookie is inserted into the response for binding
subsequent requests from the same user to that server. The validity of the cookie is based
on the cookie expiration time, which is specified in the policy configuration. For more
information, see Duration-Based Session Stickiness in the Classic Load Balancers Guide.

# Arguments
- `load_balancer_name`: The name of the load balancer.
- `policy_name`: The name of the policy being created. Policy names must consist of
  alphanumeric characters and dashes (-). This name must be unique within the set of policies
  for this load balancer.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CookieExpirationPeriod"`: The time period, in seconds, after which the cookie should be
  considered stale. If you do not specify this parameter, the default value is 0, which
  indicates that the sticky session should last for the duration of the browser session.
"""
function create_lbcookie_stickiness_policy(
    LoadBalancerName, PolicyName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_load_balancing(
        "CreateLBCookieStickinessPolicy",
        Dict{String,Any}(
            "LoadBalancerName" => LoadBalancerName, "PolicyName" => PolicyName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_lbcookie_stickiness_policy(
    LoadBalancerName,
    PolicyName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing(
        "CreateLBCookieStickinessPolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "LoadBalancerName" => LoadBalancerName, "PolicyName" => PolicyName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_load_balancer(listeners, load_balancer_name)
    create_load_balancer(listeners, load_balancer_name, params::Dict{String,<:Any})

Creates a Classic Load Balancer. You can add listeners, security groups, subnets, and tags
when you create your load balancer, or you can add them later using
CreateLoadBalancerListeners, ApplySecurityGroupsToLoadBalancer,
AttachLoadBalancerToSubnets, and AddTags. To describe your current load balancers, see
DescribeLoadBalancers. When you are finished with a load balancer, you can delete it using
DeleteLoadBalancer. You can create up to 20 load balancers per region per account. You can
request an increase for the number of load balancers for your account. For more
information, see Limits for Your Classic Load Balancer in the Classic Load Balancers Guide.

# Arguments
- `listeners`: The listeners. For more information, see Listeners for Your Classic Load
  Balancer in the Classic Load Balancers Guide.
- `load_balancer_name`: The name of the load balancer. This name must be unique within your
  set of load balancers for the region, must have a maximum of 32 characters, must contain
  only alphanumeric characters or hyphens, and cannot begin or end with a hyphen.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AvailabilityZones"`: One or more Availability Zones from the same region as the load
  balancer. You must specify at least one Availability Zone. You can add more Availability
  Zones after you create the load balancer using EnableAvailabilityZonesForLoadBalancer.
- `"Scheme"`: The type of a load balancer. Valid only for load balancers in a VPC. By
  default, Elastic Load Balancing creates an Internet-facing load balancer with a DNS name
  that resolves to public IP addresses. For more information about Internet-facing and
  Internal load balancers, see Load Balancer Scheme in the Elastic Load Balancing User Guide.
  Specify internal to create a load balancer with a DNS name that resolves to private IP
  addresses.
- `"SecurityGroups"`: The IDs of the security groups to assign to the load balancer.
- `"Subnets"`: The IDs of the subnets in your VPC to attach to the load balancer. Specify
  one subnet per Availability Zone specified in AvailabilityZones.
- `"Tags"`: A list of tags to assign to the load balancer. For more information about
  tagging your load balancer, see Tag Your Classic Load Balancer in the Classic Load
  Balancers Guide.
"""
function create_load_balancer(
    Listeners, LoadBalancerName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_load_balancing(
        "CreateLoadBalancer",
        Dict{String,Any}("Listeners" => Listeners, "LoadBalancerName" => LoadBalancerName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_load_balancer(
    Listeners,
    LoadBalancerName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing(
        "CreateLoadBalancer",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Listeners" => Listeners, "LoadBalancerName" => LoadBalancerName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_load_balancer_listeners(listeners, load_balancer_name)
    create_load_balancer_listeners(listeners, load_balancer_name, params::Dict{String,<:Any})

Creates one or more listeners for the specified load balancer. If a listener with the
specified port does not already exist, it is created; otherwise, the properties of the new
listener must match the properties of the existing listener. For more information, see
Listeners for Your Classic Load Balancer in the Classic Load Balancers Guide.

# Arguments
- `listeners`: The listeners.
- `load_balancer_name`: The name of the load balancer.

"""
function create_load_balancer_listeners(
    Listeners, LoadBalancerName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_load_balancing(
        "CreateLoadBalancerListeners",
        Dict{String,Any}("Listeners" => Listeners, "LoadBalancerName" => LoadBalancerName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_load_balancer_listeners(
    Listeners,
    LoadBalancerName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing(
        "CreateLoadBalancerListeners",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Listeners" => Listeners, "LoadBalancerName" => LoadBalancerName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_load_balancer_policy(load_balancer_name, policy_name, policy_type_name)
    create_load_balancer_policy(load_balancer_name, policy_name, policy_type_name, params::Dict{String,<:Any})

Creates a policy with the specified attributes for the specified load balancer. Policies
are settings that are saved for your load balancer and that can be applied to the listener
or the application server, depending on the policy type.

# Arguments
- `load_balancer_name`: The name of the load balancer.
- `policy_name`: The name of the load balancer policy to be created. This name must be
  unique within the set of policies for this load balancer.
- `policy_type_name`: The name of the base policy type. To get the list of policy types,
  use DescribeLoadBalancerPolicyTypes.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"PolicyAttributes"`: The policy attributes.
"""
function create_load_balancer_policy(
    LoadBalancerName,
    PolicyName,
    PolicyTypeName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing(
        "CreateLoadBalancerPolicy",
        Dict{String,Any}(
            "LoadBalancerName" => LoadBalancerName,
            "PolicyName" => PolicyName,
            "PolicyTypeName" => PolicyTypeName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_load_balancer_policy(
    LoadBalancerName,
    PolicyName,
    PolicyTypeName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing(
        "CreateLoadBalancerPolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "LoadBalancerName" => LoadBalancerName,
                    "PolicyName" => PolicyName,
                    "PolicyTypeName" => PolicyTypeName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_load_balancer(load_balancer_name)
    delete_load_balancer(load_balancer_name, params::Dict{String,<:Any})

Deletes the specified load balancer. If you are attempting to recreate a load balancer, you
must reconfigure all settings. The DNS name associated with a deleted load balancer are no
longer usable. The name and associated DNS record of the deleted load balancer no longer
exist and traffic sent to any of its IP addresses is no longer delivered to your instances.
If the load balancer does not exist or has already been deleted, the call to
DeleteLoadBalancer still succeeds.

# Arguments
- `load_balancer_name`: The name of the load balancer.

"""
function delete_load_balancer(
    LoadBalancerName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_load_balancing(
        "DeleteLoadBalancer",
        Dict{String,Any}("LoadBalancerName" => LoadBalancerName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_load_balancer(
    LoadBalancerName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing(
        "DeleteLoadBalancer",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("LoadBalancerName" => LoadBalancerName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_load_balancer_listeners(load_balancer_name, load_balancer_ports)
    delete_load_balancer_listeners(load_balancer_name, load_balancer_ports, params::Dict{String,<:Any})

Deletes the specified listeners from the specified load balancer.

# Arguments
- `load_balancer_name`: The name of the load balancer.
- `load_balancer_ports`: The client port numbers of the listeners.

"""
function delete_load_balancer_listeners(
    LoadBalancerName, LoadBalancerPorts; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_load_balancing(
        "DeleteLoadBalancerListeners",
        Dict{String,Any}(
            "LoadBalancerName" => LoadBalancerName, "LoadBalancerPorts" => LoadBalancerPorts
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_load_balancer_listeners(
    LoadBalancerName,
    LoadBalancerPorts,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing(
        "DeleteLoadBalancerListeners",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "LoadBalancerName" => LoadBalancerName,
                    "LoadBalancerPorts" => LoadBalancerPorts,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_load_balancer_policy(load_balancer_name, policy_name)
    delete_load_balancer_policy(load_balancer_name, policy_name, params::Dict{String,<:Any})

Deletes the specified policy from the specified load balancer. This policy must not be
enabled for any listeners.

# Arguments
- `load_balancer_name`: The name of the load balancer.
- `policy_name`: The name of the policy.

"""
function delete_load_balancer_policy(
    LoadBalancerName, PolicyName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_load_balancing(
        "DeleteLoadBalancerPolicy",
        Dict{String,Any}(
            "LoadBalancerName" => LoadBalancerName, "PolicyName" => PolicyName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_load_balancer_policy(
    LoadBalancerName,
    PolicyName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing(
        "DeleteLoadBalancerPolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "LoadBalancerName" => LoadBalancerName, "PolicyName" => PolicyName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    deregister_instances_from_load_balancer(instances, load_balancer_name)
    deregister_instances_from_load_balancer(instances, load_balancer_name, params::Dict{String,<:Any})

Deregisters the specified instances from the specified load balancer. After the instance is
deregistered, it no longer receives traffic from the load balancer. You can use
DescribeLoadBalancers to verify that the instance is deregistered from the load balancer.
For more information, see Register or De-Register EC2 Instances in the Classic Load
Balancers Guide.

# Arguments
- `instances`: The IDs of the instances.
- `load_balancer_name`: The name of the load balancer.

"""
function deregister_instances_from_load_balancer(
    Instances, LoadBalancerName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_load_balancing(
        "DeregisterInstancesFromLoadBalancer",
        Dict{String,Any}("Instances" => Instances, "LoadBalancerName" => LoadBalancerName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function deregister_instances_from_load_balancer(
    Instances,
    LoadBalancerName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing(
        "DeregisterInstancesFromLoadBalancer",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Instances" => Instances, "LoadBalancerName" => LoadBalancerName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_account_limits()
    describe_account_limits(params::Dict{String,<:Any})

Describes the current Elastic Load Balancing resource limits for your AWS account. For more
information, see Limits for Your Classic Load Balancer in the Classic Load Balancers Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Marker"`: The marker for the next set of results. (You received this marker from a
  previous call.)
- `"PageSize"`: The maximum number of results to return with this call.
"""
function describe_account_limits(; aws_config::AbstractAWSConfig=current_aws_config())
    return elastic_load_balancing(
        "DescribeAccountLimits"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_account_limits(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_load_balancing(
        "DescribeAccountLimits",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_instance_health(load_balancer_name)
    describe_instance_health(load_balancer_name, params::Dict{String,<:Any})

Describes the state of the specified instances with respect to the specified load balancer.
If no instances are specified, the call describes the state of all instances that are
currently registered with the load balancer. If instances are specified, their state is
returned even if they are no longer registered with the load balancer. The state of
terminated instances is not returned.

# Arguments
- `load_balancer_name`: The name of the load balancer.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Instances"`: The IDs of the instances.
"""
function describe_instance_health(
    LoadBalancerName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_load_balancing(
        "DescribeInstanceHealth",
        Dict{String,Any}("LoadBalancerName" => LoadBalancerName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_instance_health(
    LoadBalancerName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing(
        "DescribeInstanceHealth",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("LoadBalancerName" => LoadBalancerName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_load_balancer_attributes(load_balancer_name)
    describe_load_balancer_attributes(load_balancer_name, params::Dict{String,<:Any})

Describes the attributes for the specified load balancer.

# Arguments
- `load_balancer_name`: The name of the load balancer.

"""
function describe_load_balancer_attributes(
    LoadBalancerName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_load_balancing(
        "DescribeLoadBalancerAttributes",
        Dict{String,Any}("LoadBalancerName" => LoadBalancerName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_load_balancer_attributes(
    LoadBalancerName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing(
        "DescribeLoadBalancerAttributes",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("LoadBalancerName" => LoadBalancerName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_load_balancer_policies()
    describe_load_balancer_policies(params::Dict{String,<:Any})

Describes the specified policies. If you specify a load balancer name, the action returns
the descriptions of all policies created for the load balancer. If you specify a policy
name associated with your load balancer, the action returns the description of that policy.
If you don't specify a load balancer name, the action returns descriptions of the specified
sample policies, or descriptions of all sample policies. The names of the sample policies
have the ELBSample- prefix.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"LoadBalancerName"`: The name of the load balancer.
- `"PolicyNames"`: The names of the policies.
"""
function describe_load_balancer_policies(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_load_balancing(
        "DescribeLoadBalancerPolicies";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_load_balancer_policies(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_load_balancing(
        "DescribeLoadBalancerPolicies",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_load_balancer_policy_types()
    describe_load_balancer_policy_types(params::Dict{String,<:Any})

Describes the specified load balancer policy types or all load balancer policy types. The
description of each type indicates how it can be used. For example, some policies can be
used only with layer 7 listeners, some policies can be used only with layer 4 listeners,
and some policies can be used only with your EC2 instances. You can use
CreateLoadBalancerPolicy to create a policy configuration for any of these policy types.
Then, depending on the policy type, use either SetLoadBalancerPoliciesOfListener or
SetLoadBalancerPoliciesForBackendServer to set the policy.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"PolicyTypeNames"`: The names of the policy types. If no names are specified, describes
  all policy types defined by Elastic Load Balancing.
"""
function describe_load_balancer_policy_types(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_load_balancing(
        "DescribeLoadBalancerPolicyTypes";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_load_balancer_policy_types(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_load_balancing(
        "DescribeLoadBalancerPolicyTypes",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_load_balancers()
    describe_load_balancers(params::Dict{String,<:Any})

Describes the specified the load balancers. If no load balancers are specified, the call
describes all of your load balancers.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"LoadBalancerNames"`: The names of the load balancers.
- `"Marker"`: The marker for the next set of results. (You received this marker from a
  previous call.)
- `"PageSize"`: The maximum number of results to return with this call (a number from 1 to
  400). The default is 400.
"""
function describe_load_balancers(; aws_config::AbstractAWSConfig=current_aws_config())
    return elastic_load_balancing(
        "DescribeLoadBalancers"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_load_balancers(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_load_balancing(
        "DescribeLoadBalancers",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_tags(load_balancer_names)
    describe_tags(load_balancer_names, params::Dict{String,<:Any})

Describes the tags associated with the specified load balancers.

# Arguments
- `load_balancer_names`: The names of the load balancers.

"""
function describe_tags(
    LoadBalancerNames; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_load_balancing(
        "DescribeTags",
        Dict{String,Any}("LoadBalancerNames" => LoadBalancerNames);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_tags(
    LoadBalancerNames,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing(
        "DescribeTags",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("LoadBalancerNames" => LoadBalancerNames), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    detach_load_balancer_from_subnets(load_balancer_name, subnets)
    detach_load_balancer_from_subnets(load_balancer_name, subnets, params::Dict{String,<:Any})

Removes the specified subnets from the set of configured subnets for the load balancer.
After a subnet is removed, all EC2 instances registered with the load balancer in the
removed subnet go into the OutOfService state. Then, the load balancer balances the traffic
among the remaining routable subnets.

# Arguments
- `load_balancer_name`: The name of the load balancer.
- `subnets`: The IDs of the subnets.

"""
function detach_load_balancer_from_subnets(
    LoadBalancerName, Subnets; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_load_balancing(
        "DetachLoadBalancerFromSubnets",
        Dict{String,Any}("LoadBalancerName" => LoadBalancerName, "Subnets" => Subnets);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function detach_load_balancer_from_subnets(
    LoadBalancerName,
    Subnets,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing(
        "DetachLoadBalancerFromSubnets",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "LoadBalancerName" => LoadBalancerName, "Subnets" => Subnets
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disable_availability_zones_for_load_balancer(availability_zones, load_balancer_name)
    disable_availability_zones_for_load_balancer(availability_zones, load_balancer_name, params::Dict{String,<:Any})

Removes the specified Availability Zones from the set of Availability Zones for the
specified load balancer in EC2-Classic or a default VPC. For load balancers in a
non-default VPC, use DetachLoadBalancerFromSubnets. There must be at least one Availability
Zone registered with a load balancer at all times. After an Availability Zone is removed,
all instances registered with the load balancer that are in the removed Availability Zone
go into the OutOfService state. Then, the load balancer attempts to equally balance the
traffic among its remaining Availability Zones. For more information, see Add or Remove
Availability Zones in the Classic Load Balancers Guide.

# Arguments
- `availability_zones`: The Availability Zones.
- `load_balancer_name`: The name of the load balancer.

"""
function disable_availability_zones_for_load_balancer(
    AvailabilityZones, LoadBalancerName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_load_balancing(
        "DisableAvailabilityZonesForLoadBalancer",
        Dict{String,Any}(
            "AvailabilityZones" => AvailabilityZones, "LoadBalancerName" => LoadBalancerName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disable_availability_zones_for_load_balancer(
    AvailabilityZones,
    LoadBalancerName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing(
        "DisableAvailabilityZonesForLoadBalancer",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AvailabilityZones" => AvailabilityZones,
                    "LoadBalancerName" => LoadBalancerName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    enable_availability_zones_for_load_balancer(availability_zones, load_balancer_name)
    enable_availability_zones_for_load_balancer(availability_zones, load_balancer_name, params::Dict{String,<:Any})

Adds the specified Availability Zones to the set of Availability Zones for the specified
load balancer in EC2-Classic or a default VPC. For load balancers in a non-default VPC, use
AttachLoadBalancerToSubnets. The load balancer evenly distributes requests across all its
registered Availability Zones that contain instances. For more information, see Add or
Remove Availability Zones in the Classic Load Balancers Guide.

# Arguments
- `availability_zones`: The Availability Zones. These must be in the same region as the
  load balancer.
- `load_balancer_name`: The name of the load balancer.

"""
function enable_availability_zones_for_load_balancer(
    AvailabilityZones, LoadBalancerName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_load_balancing(
        "EnableAvailabilityZonesForLoadBalancer",
        Dict{String,Any}(
            "AvailabilityZones" => AvailabilityZones, "LoadBalancerName" => LoadBalancerName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function enable_availability_zones_for_load_balancer(
    AvailabilityZones,
    LoadBalancerName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing(
        "EnableAvailabilityZonesForLoadBalancer",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AvailabilityZones" => AvailabilityZones,
                    "LoadBalancerName" => LoadBalancerName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    modify_load_balancer_attributes(load_balancer_attributes, load_balancer_name)
    modify_load_balancer_attributes(load_balancer_attributes, load_balancer_name, params::Dict{String,<:Any})

Modifies the attributes of the specified load balancer. You can modify the load balancer
attributes, such as AccessLogs, ConnectionDraining, and CrossZoneLoadBalancing by either
enabling or disabling them. Or, you can modify the load balancer attribute
ConnectionSettings by specifying an idle connection timeout value for your load balancer.
For more information, see the following in the Classic Load Balancers Guide:    Cross-Zone
Load Balancing     Connection Draining     Access Logs     Idle Connection Timeout

# Arguments
- `load_balancer_attributes`: The attributes for the load balancer.
- `load_balancer_name`: The name of the load balancer.

"""
function modify_load_balancer_attributes(
    LoadBalancerAttributes,
    LoadBalancerName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing(
        "ModifyLoadBalancerAttributes",
        Dict{String,Any}(
            "LoadBalancerAttributes" => LoadBalancerAttributes,
            "LoadBalancerName" => LoadBalancerName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function modify_load_balancer_attributes(
    LoadBalancerAttributes,
    LoadBalancerName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing(
        "ModifyLoadBalancerAttributes",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "LoadBalancerAttributes" => LoadBalancerAttributes,
                    "LoadBalancerName" => LoadBalancerName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    register_instances_with_load_balancer(instances, load_balancer_name)
    register_instances_with_load_balancer(instances, load_balancer_name, params::Dict{String,<:Any})

Adds the specified instances to the specified load balancer. The instance must be a running
instance in the same network as the load balancer (EC2-Classic or the same VPC). If you
have EC2-Classic instances and a load balancer in a VPC with ClassicLink enabled, you can
link the EC2-Classic instances to that VPC and then register the linked EC2-Classic
instances with the load balancer in the VPC. Note that RegisterInstanceWithLoadBalancer
completes when the request has been registered. Instance registration takes a little time
to complete. To check the state of the registered instances, use DescribeLoadBalancers or
DescribeInstanceHealth. After the instance is registered, it starts receiving traffic and
requests from the load balancer. Any instance that is not in one of the Availability Zones
registered for the load balancer is moved to the OutOfService state. If an Availability
Zone is added to the load balancer later, any instances registered with the load balancer
move to the InService state. To deregister instances from a load balancer, use
DeregisterInstancesFromLoadBalancer. For more information, see Register or De-Register EC2
Instances in the Classic Load Balancers Guide.

# Arguments
- `instances`: The IDs of the instances.
- `load_balancer_name`: The name of the load balancer.

"""
function register_instances_with_load_balancer(
    Instances, LoadBalancerName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_load_balancing(
        "RegisterInstancesWithLoadBalancer",
        Dict{String,Any}("Instances" => Instances, "LoadBalancerName" => LoadBalancerName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function register_instances_with_load_balancer(
    Instances,
    LoadBalancerName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing(
        "RegisterInstancesWithLoadBalancer",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Instances" => Instances, "LoadBalancerName" => LoadBalancerName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_tags(load_balancer_names, tags)
    remove_tags(load_balancer_names, tags, params::Dict{String,<:Any})

Removes one or more tags from the specified load balancer.

# Arguments
- `load_balancer_names`: The name of the load balancer. You can specify a maximum of one
  load balancer name.
- `tags`: The list of tag keys to remove.

"""
function remove_tags(
    LoadBalancerNames, Tags; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_load_balancing(
        "RemoveTags",
        Dict{String,Any}("LoadBalancerNames" => LoadBalancerNames, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_tags(
    LoadBalancerNames,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing(
        "RemoveTags",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("LoadBalancerNames" => LoadBalancerNames, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    set_load_balancer_listener_sslcertificate(load_balancer_name, load_balancer_port, sslcertificate_id)
    set_load_balancer_listener_sslcertificate(load_balancer_name, load_balancer_port, sslcertificate_id, params::Dict{String,<:Any})

Sets the certificate that terminates the specified listener's SSL connections. The
specified certificate replaces any prior certificate that was used on the same load
balancer and port. For more information about updating your SSL certificate, see Replace
the SSL Certificate for Your Load Balancer in the Classic Load Balancers Guide.

# Arguments
- `load_balancer_name`: The name of the load balancer.
- `load_balancer_port`: The port that uses the specified SSL certificate.
- `sslcertificate_id`: The Amazon Resource Name (ARN) of the SSL certificate.

"""
function set_load_balancer_listener_sslcertificate(
    LoadBalancerName,
    LoadBalancerPort,
    SSLCertificateId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing(
        "SetLoadBalancerListenerSSLCertificate",
        Dict{String,Any}(
            "LoadBalancerName" => LoadBalancerName,
            "LoadBalancerPort" => LoadBalancerPort,
            "SSLCertificateId" => SSLCertificateId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function set_load_balancer_listener_sslcertificate(
    LoadBalancerName,
    LoadBalancerPort,
    SSLCertificateId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing(
        "SetLoadBalancerListenerSSLCertificate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "LoadBalancerName" => LoadBalancerName,
                    "LoadBalancerPort" => LoadBalancerPort,
                    "SSLCertificateId" => SSLCertificateId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    set_load_balancer_policies_for_backend_server(instance_port, load_balancer_name, policy_names)
    set_load_balancer_policies_for_backend_server(instance_port, load_balancer_name, policy_names, params::Dict{String,<:Any})

Replaces the set of policies associated with the specified port on which the EC2 instance
is listening with a new set of policies. At this time, only the back-end server
authentication policy type can be applied to the instance ports; this policy type is
composed of multiple public key policies. Each time you use
SetLoadBalancerPoliciesForBackendServer to enable the policies, use the PolicyNames
parameter to list the policies that you want to enable. You can use DescribeLoadBalancers
or DescribeLoadBalancerPolicies to verify that the policy is associated with the EC2
instance. For more information about enabling back-end instance authentication, see
Configure Back-end Instance Authentication in the Classic Load Balancers Guide. For more
information about Proxy Protocol, see Configure Proxy Protocol Support in the Classic Load
Balancers Guide.

# Arguments
- `instance_port`: The port number associated with the EC2 instance.
- `load_balancer_name`: The name of the load balancer.
- `policy_names`: The names of the policies. If the list is empty, then all current polices
  are removed from the EC2 instance.

"""
function set_load_balancer_policies_for_backend_server(
    InstancePort,
    LoadBalancerName,
    PolicyNames;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing(
        "SetLoadBalancerPoliciesForBackendServer",
        Dict{String,Any}(
            "InstancePort" => InstancePort,
            "LoadBalancerName" => LoadBalancerName,
            "PolicyNames" => PolicyNames,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function set_load_balancer_policies_for_backend_server(
    InstancePort,
    LoadBalancerName,
    PolicyNames,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing(
        "SetLoadBalancerPoliciesForBackendServer",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "InstancePort" => InstancePort,
                    "LoadBalancerName" => LoadBalancerName,
                    "PolicyNames" => PolicyNames,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    set_load_balancer_policies_of_listener(load_balancer_name, load_balancer_port, policy_names)
    set_load_balancer_policies_of_listener(load_balancer_name, load_balancer_port, policy_names, params::Dict{String,<:Any})

Replaces the current set of policies for the specified load balancer port with the
specified set of policies. To enable back-end server authentication, use
SetLoadBalancerPoliciesForBackendServer. For more information about setting policies, see
Update the SSL Negotiation Configuration, Duration-Based Session Stickiness, and
Application-Controlled Session Stickiness in the Classic Load Balancers Guide.

# Arguments
- `load_balancer_name`: The name of the load balancer.
- `load_balancer_port`: The external port of the load balancer.
- `policy_names`: The names of the policies. This list must include all policies to be
  enabled. If you omit a policy that is currently enabled, it is disabled. If the list is
  empty, all current policies are disabled.

"""
function set_load_balancer_policies_of_listener(
    LoadBalancerName,
    LoadBalancerPort,
    PolicyNames;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing(
        "SetLoadBalancerPoliciesOfListener",
        Dict{String,Any}(
            "LoadBalancerName" => LoadBalancerName,
            "LoadBalancerPort" => LoadBalancerPort,
            "PolicyNames" => PolicyNames,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function set_load_balancer_policies_of_listener(
    LoadBalancerName,
    LoadBalancerPort,
    PolicyNames,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing(
        "SetLoadBalancerPoliciesOfListener",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "LoadBalancerName" => LoadBalancerName,
                    "LoadBalancerPort" => LoadBalancerPort,
                    "PolicyNames" => PolicyNames,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: auto_scaling_plans
using AWS.Compat
using AWS.UUIDs

"""
    create_scaling_plan(application_source, scaling_instructions, scaling_plan_name)
    create_scaling_plan(application_source, scaling_instructions, scaling_plan_name, params::Dict{String,<:Any})

Creates a scaling plan.

# Arguments
- `application_source`: A CloudFormation stack or set of tags. You can create one scaling
  plan per application source. For more information, see ApplicationSource in the AWS Auto
  Scaling API Reference.
- `scaling_instructions`: The scaling instructions. For more information, see
  ScalingInstruction in the AWS Auto Scaling API Reference.
- `scaling_plan_name`: The name of the scaling plan. Names cannot contain vertical bars,
  colons, or forward slashes.

"""
function create_scaling_plan(
    ApplicationSource,
    ScalingInstructions,
    ScalingPlanName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling_plans(
        "CreateScalingPlan",
        Dict{String,Any}(
            "ApplicationSource" => ApplicationSource,
            "ScalingInstructions" => ScalingInstructions,
            "ScalingPlanName" => ScalingPlanName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_scaling_plan(
    ApplicationSource,
    ScalingInstructions,
    ScalingPlanName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling_plans(
        "CreateScalingPlan",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationSource" => ApplicationSource,
                    "ScalingInstructions" => ScalingInstructions,
                    "ScalingPlanName" => ScalingPlanName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_scaling_plan(scaling_plan_name, scaling_plan_version)
    delete_scaling_plan(scaling_plan_name, scaling_plan_version, params::Dict{String,<:Any})

Deletes the specified scaling plan. Deleting a scaling plan deletes the underlying
ScalingInstruction for all of the scalable resources that are covered by the plan. If the
plan has launched resources or has scaling activities in progress, you must delete those
resources separately.

# Arguments
- `scaling_plan_name`: The name of the scaling plan.
- `scaling_plan_version`: The version number of the scaling plan. Currently, the only valid
  value is 1.

"""
function delete_scaling_plan(
    ScalingPlanName, ScalingPlanVersion; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auto_scaling_plans(
        "DeleteScalingPlan",
        Dict{String,Any}(
            "ScalingPlanName" => ScalingPlanName, "ScalingPlanVersion" => ScalingPlanVersion
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_scaling_plan(
    ScalingPlanName,
    ScalingPlanVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling_plans(
        "DeleteScalingPlan",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ScalingPlanName" => ScalingPlanName,
                    "ScalingPlanVersion" => ScalingPlanVersion,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_scaling_plan_resources(scaling_plan_name, scaling_plan_version)
    describe_scaling_plan_resources(scaling_plan_name, scaling_plan_version, params::Dict{String,<:Any})

Describes the scalable resources in the specified scaling plan.

# Arguments
- `scaling_plan_name`: The name of the scaling plan.
- `scaling_plan_version`: The version number of the scaling plan. Currently, the only valid
  value is 1.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of scalable resources to return. The value must be
  between 1 and 50. The default value is 50.
- `"NextToken"`: The token for the next set of results.
"""
function describe_scaling_plan_resources(
    ScalingPlanName, ScalingPlanVersion; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auto_scaling_plans(
        "DescribeScalingPlanResources",
        Dict{String,Any}(
            "ScalingPlanName" => ScalingPlanName, "ScalingPlanVersion" => ScalingPlanVersion
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_scaling_plan_resources(
    ScalingPlanName,
    ScalingPlanVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling_plans(
        "DescribeScalingPlanResources",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ScalingPlanName" => ScalingPlanName,
                    "ScalingPlanVersion" => ScalingPlanVersion,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_scaling_plans()
    describe_scaling_plans(params::Dict{String,<:Any})

Describes one or more of your scaling plans.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ApplicationSources"`: The sources for the applications (up to 10). If you specify
  scaling plan names, you cannot specify application sources.
- `"MaxResults"`: The maximum number of scalable resources to return. This value can be
  between 1 and 50. The default value is 50.
- `"NextToken"`: The token for the next set of results.
- `"ScalingPlanNames"`: The names of the scaling plans (up to 10). If you specify
  application sources, you cannot specify scaling plan names.
- `"ScalingPlanVersion"`: The version number of the scaling plan. Currently, the only valid
  value is 1.  If you specify a scaling plan version, you must also specify a scaling plan
  name.
"""
function describe_scaling_plans(; aws_config::AbstractAWSConfig=current_aws_config())
    return auto_scaling_plans(
        "DescribeScalingPlans"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_scaling_plans(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auto_scaling_plans(
        "DescribeScalingPlans",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_scaling_plan_resource_forecast_data(end_time, forecast_data_type, resource_id, scalable_dimension, scaling_plan_name, scaling_plan_version, service_namespace, start_time)
    get_scaling_plan_resource_forecast_data(end_time, forecast_data_type, resource_id, scalable_dimension, scaling_plan_name, scaling_plan_version, service_namespace, start_time, params::Dict{String,<:Any})

Retrieves the forecast data for a scalable resource. Capacity forecasts are represented as
predicted values, or data points, that are calculated using historical data points from a
specified CloudWatch load metric. Data points are available for up to 56 days.

# Arguments
- `end_time`: The exclusive end time of the time range for the forecast data to get. The
  maximum time duration between the start and end time is seven days.  Although this
  parameter can accept a date and time that is more than two days in the future, the
  availability of forecast data has limits. AWS Auto Scaling only issues forecasts for
  periods of two days in advance.
- `forecast_data_type`: The type of forecast data to get.    LoadForecast: The load metric
  forecast.     CapacityForecast: The capacity forecast.     ScheduledActionMinCapacity: The
  minimum capacity for each scheduled scaling action. This data is calculated as the larger
  of two values: the capacity forecast or the minimum capacity in the scaling instruction.
  ScheduledActionMaxCapacity: The maximum capacity for each scheduled scaling action. The
  calculation used is determined by the predictive scaling maximum capacity behavior setting
  in the scaling instruction.
- `resource_id`: The ID of the resource. This string consists of a prefix
  (autoScalingGroup) followed by the name of a specified Auto Scaling group (my-asg).
  Example: autoScalingGroup/my-asg.
- `scalable_dimension`: The scalable dimension for the resource. The only valid value is
  autoscaling:autoScalingGroup:DesiredCapacity.
- `scaling_plan_name`: The name of the scaling plan.
- `scaling_plan_version`: The version number of the scaling plan. Currently, the only valid
  value is 1.
- `service_namespace`: The namespace of the AWS service. The only valid value is
  autoscaling.
- `start_time`: The inclusive start time of the time range for the forecast data to get.
  The date and time can be at most 56 days before the current date and time.

"""
function get_scaling_plan_resource_forecast_data(
    EndTime,
    ForecastDataType,
    ResourceId,
    ScalableDimension,
    ScalingPlanName,
    ScalingPlanVersion,
    ServiceNamespace,
    StartTime;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling_plans(
        "GetScalingPlanResourceForecastData",
        Dict{String,Any}(
            "EndTime" => EndTime,
            "ForecastDataType" => ForecastDataType,
            "ResourceId" => ResourceId,
            "ScalableDimension" => ScalableDimension,
            "ScalingPlanName" => ScalingPlanName,
            "ScalingPlanVersion" => ScalingPlanVersion,
            "ServiceNamespace" => ServiceNamespace,
            "StartTime" => StartTime,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_scaling_plan_resource_forecast_data(
    EndTime,
    ForecastDataType,
    ResourceId,
    ScalableDimension,
    ScalingPlanName,
    ScalingPlanVersion,
    ServiceNamespace,
    StartTime,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling_plans(
        "GetScalingPlanResourceForecastData",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EndTime" => EndTime,
                    "ForecastDataType" => ForecastDataType,
                    "ResourceId" => ResourceId,
                    "ScalableDimension" => ScalableDimension,
                    "ScalingPlanName" => ScalingPlanName,
                    "ScalingPlanVersion" => ScalingPlanVersion,
                    "ServiceNamespace" => ServiceNamespace,
                    "StartTime" => StartTime,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_scaling_plan(scaling_plan_name, scaling_plan_version)
    update_scaling_plan(scaling_plan_name, scaling_plan_version, params::Dict{String,<:Any})

Updates the specified scaling plan. You cannot update a scaling plan if it is in the
process of being created, updated, or deleted.

# Arguments
- `scaling_plan_name`: The name of the scaling plan.
- `scaling_plan_version`: The version number of the scaling plan. The only valid value is
  1. Currently, you cannot have multiple scaling plan versions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ApplicationSource"`: A CloudFormation stack or set of tags. For more information, see
  ApplicationSource in the AWS Auto Scaling API Reference.
- `"ScalingInstructions"`: The scaling instructions. For more information, see
  ScalingInstruction in the AWS Auto Scaling API Reference.
"""
function update_scaling_plan(
    ScalingPlanName, ScalingPlanVersion; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auto_scaling_plans(
        "UpdateScalingPlan",
        Dict{String,Any}(
            "ScalingPlanName" => ScalingPlanName, "ScalingPlanVersion" => ScalingPlanVersion
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_scaling_plan(
    ScalingPlanName,
    ScalingPlanVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling_plans(
        "UpdateScalingPlan",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ScalingPlanName" => ScalingPlanName,
                    "ScalingPlanVersion" => ScalingPlanVersion,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: elastic_beanstalk
using AWS.Compat
using AWS.UUIDs

"""
    abort_environment_update()
    abort_environment_update(params::Dict{String,<:Any})

Cancels in-progress environment configuration update or application version deployment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EnvironmentId"`: This specifies the ID of the environment with the in-progress update
  that you want to cancel.
- `"EnvironmentName"`: This specifies the name of the environment with the in-progress
  update that you want to cancel.
"""
function abort_environment_update(; aws_config::AbstractAWSConfig=current_aws_config())
    return elastic_beanstalk(
        "AbortEnvironmentUpdate"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function abort_environment_update(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_beanstalk(
        "AbortEnvironmentUpdate",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    apply_environment_managed_action(action_id)
    apply_environment_managed_action(action_id, params::Dict{String,<:Any})

Applies a scheduled managed action immediately. A managed action can be applied only if its
status is Scheduled. Get the status and action ID of a managed action with
DescribeEnvironmentManagedActions.

# Arguments
- `action_id`: The action ID of the scheduled managed action to execute.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EnvironmentId"`: The environment ID of the target environment.
- `"EnvironmentName"`: The name of the target environment.
"""
function apply_environment_managed_action(
    ActionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_beanstalk(
        "ApplyEnvironmentManagedAction",
        Dict{String,Any}("ActionId" => ActionId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function apply_environment_managed_action(
    ActionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_beanstalk(
        "ApplyEnvironmentManagedAction",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ActionId" => ActionId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_environment_operations_role(environment_name, operations_role)
    associate_environment_operations_role(environment_name, operations_role, params::Dict{String,<:Any})

Add or change the operations role used by an environment. After this call is made, Elastic
Beanstalk uses the associated operations role for permissions to downstream services during
subsequent calls acting on this environment. For more information, see Operations roles in
the AWS Elastic Beanstalk Developer Guide.

# Arguments
- `environment_name`: The name of the environment to which to set the operations role.
- `operations_role`: The Amazon Resource Name (ARN) of an existing IAM role to be used as
  the environment's operations role.

"""
function associate_environment_operations_role(
    EnvironmentName, OperationsRole; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_beanstalk(
        "AssociateEnvironmentOperationsRole",
        Dict{String,Any}(
            "EnvironmentName" => EnvironmentName, "OperationsRole" => OperationsRole
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_environment_operations_role(
    EnvironmentName,
    OperationsRole,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_beanstalk(
        "AssociateEnvironmentOperationsRole",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EnvironmentName" => EnvironmentName, "OperationsRole" => OperationsRole
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    check_dnsavailability(cnameprefix)
    check_dnsavailability(cnameprefix, params::Dict{String,<:Any})

Checks if the specified CNAME is available.

# Arguments
- `cnameprefix`: The prefix used when this CNAME is reserved.

"""
function check_dnsavailability(
    CNAMEPrefix; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_beanstalk(
        "CheckDNSAvailability",
        Dict{String,Any}("CNAMEPrefix" => CNAMEPrefix);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function check_dnsavailability(
    CNAMEPrefix,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_beanstalk(
        "CheckDNSAvailability",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("CNAMEPrefix" => CNAMEPrefix), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    compose_environments()
    compose_environments(params::Dict{String,<:Any})

Create or update a group of environments that each run a separate component of a single
application. Takes a list of version labels that specify application source bundles for
each of the environments to create or update. The name of each environment and other
required information must be included in the source bundles in an environment manifest
named env.yaml. See Compose Environments for details.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ApplicationName"`: The name of the application to which the specified source bundles
  belong.
- `"GroupName"`: The name of the group to which the target environments belong. Specify a
  group name only if the environment name defined in each target environment's manifest ends
  with a + (plus) character. See Environment Manifest (env.yaml) for details.
- `"VersionLabels"`: A list of version labels, specifying one or more application source
  bundles that belong to the target application. Each source bundle must include an
  environment manifest that specifies the name of the environment and the name of the
  solution stack to use, and optionally can specify environment links to create.
"""
function compose_environments(; aws_config::AbstractAWSConfig=current_aws_config())
    return elastic_beanstalk(
        "ComposeEnvironments"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function compose_environments(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_beanstalk(
        "ComposeEnvironments",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_application(application_name)
    create_application(application_name, params::Dict{String,<:Any})

Creates an application that has one configuration template named default and no application
versions.

# Arguments
- `application_name`: The name of the application. Must be unique within your account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: Your description of the application.
- `"ResourceLifecycleConfig"`: Specifies an application resource lifecycle configuration to
  prevent your application from accumulating too many versions.
- `"Tags"`: Specifies the tags applied to the application. Elastic Beanstalk applies these
  tags only to the application. Environments that you create in the application don't inherit
  the tags.
"""
function create_application(
    ApplicationName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_beanstalk(
        "CreateApplication",
        Dict{String,Any}("ApplicationName" => ApplicationName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_application(
    ApplicationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_beanstalk(
        "CreateApplication",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ApplicationName" => ApplicationName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_application_version(application_name, version_label)
    create_application_version(application_name, version_label, params::Dict{String,<:Any})

Creates an application version for the specified application. You can create an application
version from a source bundle in Amazon S3, a commit in AWS CodeCommit, or the output of an
AWS CodeBuild build as follows: Specify a commit in an AWS CodeCommit repository with
SourceBuildInformation. Specify a build in an AWS CodeBuild with SourceBuildInformation and
BuildConfiguration. Specify a source bundle in S3 with SourceBundle  Omit both
SourceBuildInformation and SourceBundle to use the default sample application.  After you
create an application version with a specified Amazon S3 bucket and key location, you can't
change that Amazon S3 location. If you change the Amazon S3 location, you receive an
exception when you attempt to launch an environment from the application version.

# Arguments
- `application_name`:  The name of the application. If no application is found with this
  name, and AutoCreateApplication is false, returns an InvalidParameterValue error.
- `version_label`: A label identifying this version. Constraint: Must be unique per
  application. If an application version already exists with this label for the specified
  application, AWS Elastic Beanstalk returns an InvalidParameterValue error.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AutoCreateApplication"`: Set to true to create an application with the specified name
  if it doesn't already exist.
- `"BuildConfiguration"`: Settings for an AWS CodeBuild build.
- `"Description"`: A description of this application version.
- `"Process"`: Pre-processes and validates the environment manifest (env.yaml) and
  configuration files (*.config files in the .ebextensions folder) in the source bundle.
  Validating configuration files can identify issues prior to deploying the application
  version to an environment. You must turn processing on for application versions that you
  create using AWS CodeBuild or AWS CodeCommit. For application versions built from a source
  bundle in Amazon S3, processing is optional.  The Process option validates Elastic
  Beanstalk configuration files. It doesn't validate your application's configuration files,
  like proxy server or Docker configuration.
- `"SourceBuildInformation"`: Specify a commit in an AWS CodeCommit Git repository to use
  as the source code for the application version.
- `"SourceBundle"`: The Amazon S3 bucket and key that identify the location of the source
  bundle for this version.  The Amazon S3 bucket must be in the same region as the
  environment.  Specify a source bundle in S3 or a commit in an AWS CodeCommit repository
  (with SourceBuildInformation), but not both. If neither SourceBundle nor
  SourceBuildInformation are provided, Elastic Beanstalk uses a sample application.
- `"Tags"`: Specifies the tags applied to the application version. Elastic Beanstalk
  applies these tags only to the application version. Environments that use the application
  version don't inherit the tags.
"""
function create_application_version(
    ApplicationName, VersionLabel; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_beanstalk(
        "CreateApplicationVersion",
        Dict{String,Any}(
            "ApplicationName" => ApplicationName, "VersionLabel" => VersionLabel
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_application_version(
    ApplicationName,
    VersionLabel,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_beanstalk(
        "CreateApplicationVersion",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationName" => ApplicationName, "VersionLabel" => VersionLabel
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_configuration_template(application_name, template_name)
    create_configuration_template(application_name, template_name, params::Dict{String,<:Any})

Creates an AWS Elastic Beanstalk configuration template, associated with a specific Elastic
Beanstalk application. You define application configuration settings in a configuration
template. You can then use the configuration template to deploy different versions of the
application with the same configuration settings. Templates aren't associated with any
environment. The EnvironmentName response element is always null. Related Topics
DescribeConfigurationOptions     DescribeConfigurationSettings
ListAvailableSolutionStacks

# Arguments
- `application_name`: The name of the Elastic Beanstalk application to associate with this
  configuration template.
- `template_name`: The name of the configuration template. Constraint: This name must be
  unique per application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: An optional description for this configuration.
- `"EnvironmentId"`: The ID of an environment whose settings you want to use to create the
  configuration template. You must specify EnvironmentId if you don't specify PlatformArn,
  SolutionStackName, or SourceConfiguration.
- `"OptionSettings"`: Option values for the Elastic Beanstalk configuration, such as the
  instance type. If specified, these values override the values obtained from the solution
  stack or the source configuration template. For a complete list of Elastic Beanstalk
  configuration options, see Option Values in the AWS Elastic Beanstalk Developer Guide.
- `"PlatformArn"`: The Amazon Resource Name (ARN) of the custom platform. For more
  information, see  Custom Platforms in the AWS Elastic Beanstalk Developer Guide.  If you
  specify PlatformArn, then don't specify SolutionStackName.
- `"SolutionStackName"`: The name of an Elastic Beanstalk solution stack (platform version)
  that this configuration uses. For example, 64bit Amazon Linux 2013.09 running Tomcat 7 Java
  7. A solution stack specifies the operating system, runtime, and application server for a
  configuration template. It also determines the set of configuration options as well as the
  possible and default values. For more information, see Supported Platforms in the AWS
  Elastic Beanstalk Developer Guide. You must specify SolutionStackName if you don't specify
  PlatformArn, EnvironmentId, or SourceConfiguration. Use the  ListAvailableSolutionStacks
  API to obtain a list of available solution stacks.
- `"SourceConfiguration"`: An Elastic Beanstalk configuration template to base this one on.
  If specified, Elastic Beanstalk uses the configuration values from the specified
  configuration template to create a new configuration. Values specified in OptionSettings
  override any values obtained from the SourceConfiguration. You must specify
  SourceConfiguration if you don't specify PlatformArn, EnvironmentId, or SolutionStackName.
  Constraint: If both solution stack name and source configuration are specified, the
  solution stack of the source configuration template must match the specified solution stack
  name.
- `"Tags"`: Specifies the tags applied to the configuration template.
"""
function create_configuration_template(
    ApplicationName, TemplateName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_beanstalk(
        "CreateConfigurationTemplate",
        Dict{String,Any}(
            "ApplicationName" => ApplicationName, "TemplateName" => TemplateName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_configuration_template(
    ApplicationName,
    TemplateName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_beanstalk(
        "CreateConfigurationTemplate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationName" => ApplicationName, "TemplateName" => TemplateName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_environment(application_name)
    create_environment(application_name, params::Dict{String,<:Any})

Launches an AWS Elastic Beanstalk environment for the specified application using the
specified configuration.

# Arguments
- `application_name`: The name of the application that is associated with this environment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CNAMEPrefix"`: If specified, the environment attempts to use this value as the prefix
  for the CNAME in your Elastic Beanstalk environment URL. If not specified, the CNAME is
  generated automatically by appending a random alphanumeric string to the environment name.
- `"Description"`: Your description for this environment.
- `"EnvironmentName"`: A unique name for the environment. Constraint: Must be from 4 to 40
  characters in length. The name can contain only letters, numbers, and hyphens. It can't
  start or end with a hyphen. This name must be unique within a region in your account. If
  the specified name already exists in the region, Elastic Beanstalk returns an
  InvalidParameterValue error.  If you don't specify the CNAMEPrefix parameter, the
  environment name becomes part of the CNAME, and therefore part of the visible URL for your
  application.
- `"GroupName"`: The name of the group to which the target environment belongs. Specify a
  group name only if the environment's name is specified in an environment manifest and not
  with the environment name parameter. See Environment Manifest (env.yaml) for details.
- `"OperationsRole"`: The Amazon Resource Name (ARN) of an existing IAM role to be used as
  the environment's operations role. If specified, Elastic Beanstalk uses the operations role
  for permissions to downstream services during this call and during subsequent calls acting
  on this environment. To specify an operations role, you must have the iam:PassRole
  permission for the role. For more information, see Operations roles in the AWS Elastic
  Beanstalk Developer Guide.
- `"OptionSettings"`: If specified, AWS Elastic Beanstalk sets the specified configuration
  options to the requested value in the configuration set for the new environment. These
  override the values obtained from the solution stack or the configuration template.
- `"OptionsToRemove"`: A list of custom user-defined configuration options to remove from
  the configuration set for this new environment.
- `"PlatformArn"`: The Amazon Resource Name (ARN) of the custom platform to use with the
  environment. For more information, see Custom Platforms in the AWS Elastic Beanstalk
  Developer Guide.  If you specify PlatformArn, don't specify SolutionStackName.
- `"SolutionStackName"`: The name of an Elastic Beanstalk solution stack (platform version)
  to use with the environment. If specified, Elastic Beanstalk sets the configuration values
  to the default values associated with the specified solution stack. For a list of current
  solution stacks, see Elastic Beanstalk Supported Platforms in the AWS Elastic Beanstalk
  Platforms guide.  If you specify SolutionStackName, don't specify PlatformArn or
  TemplateName.
- `"Tags"`: Specifies the tags applied to resources in the environment.
- `"TemplateName"`: The name of the Elastic Beanstalk configuration template to use with
  the environment.  If you specify TemplateName, then don't specify SolutionStackName.
- `"Tier"`: Specifies the tier to use in creating this environment. The environment tier
  that you choose determines whether Elastic Beanstalk provisions resources to support a web
  application that handles HTTP(S) requests or a web application that handles
  background-processing tasks.
- `"VersionLabel"`: The name of the application version to deploy. Default: If not
  specified, Elastic Beanstalk attempts to deploy the sample application.
"""
function create_environment(
    ApplicationName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_beanstalk(
        "CreateEnvironment",
        Dict{String,Any}("ApplicationName" => ApplicationName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_environment(
    ApplicationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_beanstalk(
        "CreateEnvironment",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ApplicationName" => ApplicationName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_platform_version(platform_definition_bundle, platform_name, platform_version)
    create_platform_version(platform_definition_bundle, platform_name, platform_version, params::Dict{String,<:Any})

Create a new version of your custom platform.

# Arguments
- `platform_definition_bundle`: The location of the platform definition archive in Amazon
  S3.
- `platform_name`: The name of your custom platform.
- `platform_version`: The number, such as 1.0.2, for the new platform version.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EnvironmentName"`: The name of the builder environment.
- `"OptionSettings"`: The configuration option settings to apply to the builder environment.
- `"Tags"`: Specifies the tags applied to the new platform version. Elastic Beanstalk
  applies these tags only to the platform version. Environments that you create using the
  platform version don't inherit the tags.
"""
function create_platform_version(
    PlatformDefinitionBundle,
    PlatformName,
    PlatformVersion;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_beanstalk(
        "CreatePlatformVersion",
        Dict{String,Any}(
            "PlatformDefinitionBundle" => PlatformDefinitionBundle,
            "PlatformName" => PlatformName,
            "PlatformVersion" => PlatformVersion,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_platform_version(
    PlatformDefinitionBundle,
    PlatformName,
    PlatformVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_beanstalk(
        "CreatePlatformVersion",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "PlatformDefinitionBundle" => PlatformDefinitionBundle,
                    "PlatformName" => PlatformName,
                    "PlatformVersion" => PlatformVersion,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_storage_location()
    create_storage_location(params::Dict{String,<:Any})

Creates a bucket in Amazon S3 to store application versions, logs, and other files used by
Elastic Beanstalk environments. The Elastic Beanstalk console and EB CLI call this API the
first time you create an environment in a region. If the storage location already exists,
CreateStorageLocation still returns the bucket name but does not create a new bucket.

"""
function create_storage_location(; aws_config::AbstractAWSConfig=current_aws_config())
    return elastic_beanstalk(
        "CreateStorageLocation"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function create_storage_location(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_beanstalk(
        "CreateStorageLocation",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_application(application_name)
    delete_application(application_name, params::Dict{String,<:Any})

Deletes the specified application along with all associated versions and configurations.
The application versions will not be deleted from your Amazon S3 bucket.  You cannot delete
an application that has a running environment.

# Arguments
- `application_name`: The name of the application to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"TerminateEnvByForce"`: When set to true, running environments will be terminated before
  deleting the application.
"""
function delete_application(
    ApplicationName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_beanstalk(
        "DeleteApplication",
        Dict{String,Any}("ApplicationName" => ApplicationName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_application(
    ApplicationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_beanstalk(
        "DeleteApplication",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ApplicationName" => ApplicationName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_application_version(application_name, version_label)
    delete_application_version(application_name, version_label, params::Dict{String,<:Any})

Deletes the specified version from the specified application.  You cannot delete an
application version that is associated with a running environment.

# Arguments
- `application_name`: The name of the application to which the version belongs.
- `version_label`: The label of the version to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DeleteSourceBundle"`: Set to true to delete the source bundle from your storage bucket.
  Otherwise, the application version is deleted only from Elastic Beanstalk and the source
  bundle remains in Amazon S3.
"""
function delete_application_version(
    ApplicationName, VersionLabel; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_beanstalk(
        "DeleteApplicationVersion",
        Dict{String,Any}(
            "ApplicationName" => ApplicationName, "VersionLabel" => VersionLabel
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_application_version(
    ApplicationName,
    VersionLabel,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_beanstalk(
        "DeleteApplicationVersion",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationName" => ApplicationName, "VersionLabel" => VersionLabel
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_configuration_template(application_name, template_name)
    delete_configuration_template(application_name, template_name, params::Dict{String,<:Any})

Deletes the specified configuration template.  When you launch an environment using a
configuration template, the environment gets a copy of the template. You can delete or
modify the environment's copy of the template without affecting the running environment.

# Arguments
- `application_name`: The name of the application to delete the configuration template from.
- `template_name`: The name of the configuration template to delete.

"""
function delete_configuration_template(
    ApplicationName, TemplateName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_beanstalk(
        "DeleteConfigurationTemplate",
        Dict{String,Any}(
            "ApplicationName" => ApplicationName, "TemplateName" => TemplateName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_configuration_template(
    ApplicationName,
    TemplateName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_beanstalk(
        "DeleteConfigurationTemplate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationName" => ApplicationName, "TemplateName" => TemplateName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_environment_configuration(application_name, environment_name)
    delete_environment_configuration(application_name, environment_name, params::Dict{String,<:Any})

Deletes the draft configuration associated with the running environment. Updating a running
environment with any configuration changes creates a draft configuration set. You can get
the draft configuration using DescribeConfigurationSettings while the update is in progress
or if the update fails. The DeploymentStatus for the draft configuration indicates whether
the deployment is in process or has failed. The draft configuration remains in existence
until it is deleted with this action.

# Arguments
- `application_name`: The name of the application the environment is associated with.
- `environment_name`: The name of the environment to delete the draft configuration from.

"""
function delete_environment_configuration(
    ApplicationName, EnvironmentName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_beanstalk(
        "DeleteEnvironmentConfiguration",
        Dict{String,Any}(
            "ApplicationName" => ApplicationName, "EnvironmentName" => EnvironmentName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_environment_configuration(
    ApplicationName,
    EnvironmentName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_beanstalk(
        "DeleteEnvironmentConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationName" => ApplicationName,
                    "EnvironmentName" => EnvironmentName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_platform_version()
    delete_platform_version(params::Dict{String,<:Any})

Deletes the specified version of a custom platform.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"PlatformArn"`: The ARN of the version of the custom platform.
"""
function delete_platform_version(; aws_config::AbstractAWSConfig=current_aws_config())
    return elastic_beanstalk(
        "DeletePlatformVersion"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function delete_platform_version(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_beanstalk(
        "DeletePlatformVersion",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_account_attributes()
    describe_account_attributes(params::Dict{String,<:Any})

Returns attributes related to AWS Elastic Beanstalk that are associated with the calling
AWS account. The result currently has one set of attributes—resource quotas.

"""
function describe_account_attributes(; aws_config::AbstractAWSConfig=current_aws_config())
    return elastic_beanstalk(
        "DescribeAccountAttributes"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_account_attributes(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_beanstalk(
        "DescribeAccountAttributes",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_application_versions()
    describe_application_versions(params::Dict{String,<:Any})

Retrieve a list of application versions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ApplicationName"`: Specify an application name to show only application versions for
  that application.
- `"MaxRecords"`: For a paginated request. Specify a maximum number of application versions
  to include in each response. If no MaxRecords is specified, all available application
  versions are retrieved in a single response.
- `"NextToken"`: For a paginated request. Specify a token from a previous response page to
  retrieve the next response page. All other parameter values must be identical to the ones
  specified in the initial request. If no NextToken is specified, the first page is retrieved.
- `"VersionLabels"`: Specify a version label to show a specific application version.
"""
function describe_application_versions(; aws_config::AbstractAWSConfig=current_aws_config())
    return elastic_beanstalk(
        "DescribeApplicationVersions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_application_versions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_beanstalk(
        "DescribeApplicationVersions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_applications()
    describe_applications(params::Dict{String,<:Any})

Returns the descriptions of existing applications.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ApplicationNames"`: If specified, AWS Elastic Beanstalk restricts the returned
  descriptions to only include those with the specified names.
"""
function describe_applications(; aws_config::AbstractAWSConfig=current_aws_config())
    return elastic_beanstalk(
        "DescribeApplications"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_applications(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_beanstalk(
        "DescribeApplications",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_configuration_options()
    describe_configuration_options(params::Dict{String,<:Any})

Describes the configuration options that are used in a particular configuration template or
environment, or that a specified solution stack defines. The description includes the
values the options, their default values, and an indication of the required action on a
running environment if an option value is changed.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ApplicationName"`: The name of the application associated with the configuration
  template or environment. Only needed if you want to describe the configuration options
  associated with either the configuration template or environment.
- `"EnvironmentName"`: The name of the environment whose configuration options you want to
  describe.
- `"Options"`: If specified, restricts the descriptions to only the specified options.
- `"PlatformArn"`: The ARN of the custom platform.
- `"SolutionStackName"`: The name of the solution stack whose configuration options you
  want to describe.
- `"TemplateName"`: The name of the configuration template whose configuration options you
  want to describe.
"""
function describe_configuration_options(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_beanstalk(
        "DescribeConfigurationOptions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_configuration_options(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_beanstalk(
        "DescribeConfigurationOptions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_configuration_settings(application_name)
    describe_configuration_settings(application_name, params::Dict{String,<:Any})

Returns a description of the settings for the specified configuration set, that is, either
a configuration template or the configuration set associated with a running environment.
When describing the settings for the configuration set associated with a running
environment, it is possible to receive two sets of setting descriptions. One is the
deployed configuration set, and the other is a draft configuration of an environment that
is either in the process of deployment or that failed to deploy. Related Topics
DeleteEnvironmentConfiguration

# Arguments
- `application_name`: The application for the environment or configuration template.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EnvironmentName"`: The name of the environment to describe.  Condition: You must
  specify either this or a TemplateName, but not both. If you specify both, AWS Elastic
  Beanstalk returns an InvalidParameterCombination error. If you do not specify either, AWS
  Elastic Beanstalk returns MissingRequiredParameter error.
- `"TemplateName"`: The name of the configuration template to describe.  Conditional: You
  must specify either this parameter or an EnvironmentName, but not both. If you specify
  both, AWS Elastic Beanstalk returns an InvalidParameterCombination error. If you do not
  specify either, AWS Elastic Beanstalk returns a MissingRequiredParameter error.
"""
function describe_configuration_settings(
    ApplicationName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_beanstalk(
        "DescribeConfigurationSettings",
        Dict{String,Any}("ApplicationName" => ApplicationName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_configuration_settings(
    ApplicationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_beanstalk(
        "DescribeConfigurationSettings",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ApplicationName" => ApplicationName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_environment_health()
    describe_environment_health(params::Dict{String,<:Any})

Returns information about the overall health of the specified environment. The
DescribeEnvironmentHealth operation is only available with AWS Elastic Beanstalk Enhanced
Health.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AttributeNames"`: Specify the response elements to return. To retrieve all attributes,
  set to All. If no attribute names are specified, returns the name of the environment.
- `"EnvironmentId"`: Specify the environment by ID. You must specify either this or an
  EnvironmentName, or both.
- `"EnvironmentName"`: Specify the environment by name. You must specify either this or an
  EnvironmentName, or both.
"""
function describe_environment_health(; aws_config::AbstractAWSConfig=current_aws_config())
    return elastic_beanstalk(
        "DescribeEnvironmentHealth"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_environment_health(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_beanstalk(
        "DescribeEnvironmentHealth",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_environment_managed_action_history()
    describe_environment_managed_action_history(params::Dict{String,<:Any})

Lists an environment's completed and failed managed actions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EnvironmentId"`: The environment ID of the target environment.
- `"EnvironmentName"`: The name of the target environment.
- `"MaxItems"`: The maximum number of items to return for a single request.
- `"NextToken"`: The pagination token returned by a previous request.
"""
function describe_environment_managed_action_history(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_beanstalk(
        "DescribeEnvironmentManagedActionHistory";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_environment_managed_action_history(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_beanstalk(
        "DescribeEnvironmentManagedActionHistory",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_environment_managed_actions()
    describe_environment_managed_actions(params::Dict{String,<:Any})

Lists an environment's upcoming and in-progress managed actions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EnvironmentId"`: The environment ID of the target environment.
- `"EnvironmentName"`: The name of the target environment.
- `"Status"`: To show only actions with a particular status, specify a status.
"""
function describe_environment_managed_actions(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_beanstalk(
        "DescribeEnvironmentManagedActions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_environment_managed_actions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_beanstalk(
        "DescribeEnvironmentManagedActions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_environment_resources()
    describe_environment_resources(params::Dict{String,<:Any})

Returns AWS resources for this environment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EnvironmentId"`: The ID of the environment to retrieve AWS resource usage data.
  Condition: You must specify either this or an EnvironmentName, or both. If you do not
  specify either, AWS Elastic Beanstalk returns MissingRequiredParameter error.
- `"EnvironmentName"`: The name of the environment to retrieve AWS resource usage data.
  Condition: You must specify either this or an EnvironmentId, or both. If you do not specify
  either, AWS Elastic Beanstalk returns MissingRequiredParameter error.
"""
function describe_environment_resources(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_beanstalk(
        "DescribeEnvironmentResources";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_environment_resources(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_beanstalk(
        "DescribeEnvironmentResources",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_environments()
    describe_environments(params::Dict{String,<:Any})

Returns descriptions for existing environments.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ApplicationName"`: If specified, AWS Elastic Beanstalk restricts the returned
  descriptions to include only those that are associated with this application.
- `"EnvironmentIds"`: If specified, AWS Elastic Beanstalk restricts the returned
  descriptions to include only those that have the specified IDs.
- `"EnvironmentNames"`: If specified, AWS Elastic Beanstalk restricts the returned
  descriptions to include only those that have the specified names.
- `"IncludeDeleted"`: Indicates whether to include deleted environments:  true:
  Environments that have been deleted after IncludedDeletedBackTo are displayed.  false: Do
  not include deleted environments.
- `"IncludedDeletedBackTo"`:  If specified when IncludeDeleted is set to true, then
  environments deleted after this date are displayed.
- `"MaxRecords"`: For a paginated request. Specify a maximum number of environments to
  include in each response. If no MaxRecords is specified, all available environments are
  retrieved in a single response.
- `"NextToken"`: For a paginated request. Specify a token from a previous response page to
  retrieve the next response page. All other parameter values must be identical to the ones
  specified in the initial request. If no NextToken is specified, the first page is retrieved.
- `"VersionLabel"`: If specified, AWS Elastic Beanstalk restricts the returned descriptions
  to include only those that are associated with this application version.
"""
function describe_environments(; aws_config::AbstractAWSConfig=current_aws_config())
    return elastic_beanstalk(
        "DescribeEnvironments"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_environments(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_beanstalk(
        "DescribeEnvironments",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_events()
    describe_events(params::Dict{String,<:Any})

Returns list of event descriptions matching criteria up to the last 6 weeks.  This action
returns the most recent 1,000 events from the specified NextToken.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ApplicationName"`: If specified, AWS Elastic Beanstalk restricts the returned
  descriptions to include only those associated with this application.
- `"EndTime"`:  If specified, AWS Elastic Beanstalk restricts the returned descriptions to
  those that occur up to, but not including, the EndTime.
- `"EnvironmentId"`: If specified, AWS Elastic Beanstalk restricts the returned
  descriptions to those associated with this environment.
- `"EnvironmentName"`: If specified, AWS Elastic Beanstalk restricts the returned
  descriptions to those associated with this environment.
- `"MaxRecords"`: Specifies the maximum number of events that can be returned, beginning
  with the most recent event.
- `"NextToken"`: Pagination token. If specified, the events return the next batch of
  results.
- `"PlatformArn"`: The ARN of a custom platform version. If specified, AWS Elastic
  Beanstalk restricts the returned descriptions to those associated with this custom platform
  version.
- `"RequestId"`: If specified, AWS Elastic Beanstalk restricts the described events to
  include only those associated with this request ID.
- `"Severity"`: If specified, limits the events returned from this call to include only
  those with the specified severity or higher.
- `"StartTime"`: If specified, AWS Elastic Beanstalk restricts the returned descriptions to
  those that occur on or after this time.
- `"TemplateName"`: If specified, AWS Elastic Beanstalk restricts the returned descriptions
  to those that are associated with this environment configuration.
- `"VersionLabel"`: If specified, AWS Elastic Beanstalk restricts the returned descriptions
  to those associated with this application version.
"""
function describe_events(; aws_config::AbstractAWSConfig=current_aws_config())
    return elastic_beanstalk(
        "DescribeEvents"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_events(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_beanstalk(
        "DescribeEvents", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_instances_health()
    describe_instances_health(params::Dict{String,<:Any})

Retrieves detailed information about the health of instances in your AWS Elastic Beanstalk.
This operation requires enhanced health reporting.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AttributeNames"`: Specifies the response elements you wish to receive. To retrieve all
  attributes, set to All. If no attribute names are specified, returns a list of instances.
- `"EnvironmentId"`: Specify the AWS Elastic Beanstalk environment by ID.
- `"EnvironmentName"`: Specify the AWS Elastic Beanstalk environment by name.
- `"NextToken"`: Specify the pagination token returned by a previous call.
"""
function describe_instances_health(; aws_config::AbstractAWSConfig=current_aws_config())
    return elastic_beanstalk(
        "DescribeInstancesHealth"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_instances_health(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_beanstalk(
        "DescribeInstancesHealth",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_platform_version()
    describe_platform_version(params::Dict{String,<:Any})

Describes a platform version. Provides full details. Compare to ListPlatformVersions, which
provides summary information about a list of platform versions. For definitions of platform
version and other platform-related terms, see AWS Elastic Beanstalk Platforms Glossary.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"PlatformArn"`: The ARN of the platform version.
"""
function describe_platform_version(; aws_config::AbstractAWSConfig=current_aws_config())
    return elastic_beanstalk(
        "DescribePlatformVersion"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_platform_version(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_beanstalk(
        "DescribePlatformVersion",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_environment_operations_role(environment_name)
    disassociate_environment_operations_role(environment_name, params::Dict{String,<:Any})

Disassociate the operations role from an environment. After this call is made, Elastic
Beanstalk uses the caller's permissions for permissions to downstream services during
subsequent calls acting on this environment. For more information, see Operations roles in
the AWS Elastic Beanstalk Developer Guide.

# Arguments
- `environment_name`: The name of the environment from which to disassociate the operations
  role.

"""
function disassociate_environment_operations_role(
    EnvironmentName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_beanstalk(
        "DisassociateEnvironmentOperationsRole",
        Dict{String,Any}("EnvironmentName" => EnvironmentName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_environment_operations_role(
    EnvironmentName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_beanstalk(
        "DisassociateEnvironmentOperationsRole",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("EnvironmentName" => EnvironmentName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_available_solution_stacks()
    list_available_solution_stacks(params::Dict{String,<:Any})

Returns a list of the available solution stack names, with the public version first and
then in reverse chronological order.

"""
function list_available_solution_stacks(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_beanstalk(
        "ListAvailableSolutionStacks";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_available_solution_stacks(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_beanstalk(
        "ListAvailableSolutionStacks",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_platform_branches()
    list_platform_branches(params::Dict{String,<:Any})

Lists the platform branches available for your account in an AWS Region. Provides summary
information about each platform branch. For definitions of platform branch and other
platform-related terms, see AWS Elastic Beanstalk Platforms Glossary.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: Criteria for restricting the resulting list of platform branches. The filter
  is evaluated as a logical conjunction (AND) of the separate SearchFilter terms. The
  following list shows valid attribute values for each of the SearchFilter terms. Most
  operators take a single value. The in and not_in operators can take multiple values.
  Attribute = BranchName:    Operator: = | != | begins_with | ends_with | contains | in |
  not_in       Attribute = LifecycleState:    Operator: = | != | in | not_in     Values: beta
  | supported | deprecated | retired       Attribute = PlatformName:    Operator: = | != |
  begins_with | ends_with | contains | in | not_in       Attribute = TierType:    Operator: =
  | !=     Values: WebServer/Standard | Worker/SQS/HTTP      Array size: limited to 10
  SearchFilter objects. Within each SearchFilter item, the Values array is limited to 10
  items.
- `"MaxRecords"`: The maximum number of platform branch values returned in one call.
- `"NextToken"`: For a paginated request. Specify a token from a previous response page to
  retrieve the next response page. All other parameter values must be identical to the ones
  specified in the initial request. If no NextToken is specified, the first page is retrieved.
"""
function list_platform_branches(; aws_config::AbstractAWSConfig=current_aws_config())
    return elastic_beanstalk(
        "ListPlatformBranches"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_platform_branches(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_beanstalk(
        "ListPlatformBranches",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_platform_versions()
    list_platform_versions(params::Dict{String,<:Any})

Lists the platform versions available for your account in an AWS Region. Provides summary
information about each platform version. Compare to DescribePlatformVersion, which provides
full details about a single platform version. For definitions of platform version and other
platform-related terms, see AWS Elastic Beanstalk Platforms Glossary.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: Criteria for restricting the resulting list of platform versions. The filter
  is interpreted as a logical conjunction (AND) of the separate PlatformFilter terms.
- `"MaxRecords"`: The maximum number of platform version values returned in one call.
- `"NextToken"`: For a paginated request. Specify a token from a previous response page to
  retrieve the next response page. All other parameter values must be identical to the ones
  specified in the initial request. If no NextToken is specified, the first page is retrieved.
"""
function list_platform_versions(; aws_config::AbstractAWSConfig=current_aws_config())
    return elastic_beanstalk(
        "ListPlatformVersions"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_platform_versions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_beanstalk(
        "ListPlatformVersions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Return the tags applied to an AWS Elastic Beanstalk resource. The response contains a list
of tag key-value pairs. Elastic Beanstalk supports tagging of all of its resources. For
details about resource tagging, see Tagging Application Resources.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resouce for which a tag list is
  requested. Must be the ARN of an Elastic Beanstalk resource.

"""
function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_beanstalk(
        "ListTagsForResource",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_beanstalk(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    rebuild_environment()
    rebuild_environment(params::Dict{String,<:Any})

Deletes and recreates all of the AWS resources (for example: the Auto Scaling group, load
balancer, etc.) for a specified environment and forces a restart.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EnvironmentId"`: The ID of the environment to rebuild.  Condition: You must specify
  either this or an EnvironmentName, or both. If you do not specify either, AWS Elastic
  Beanstalk returns MissingRequiredParameter error.
- `"EnvironmentName"`: The name of the environment to rebuild.  Condition: You must specify
  either this or an EnvironmentId, or both. If you do not specify either, AWS Elastic
  Beanstalk returns MissingRequiredParameter error.
"""
function rebuild_environment(; aws_config::AbstractAWSConfig=current_aws_config())
    return elastic_beanstalk(
        "RebuildEnvironment"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function rebuild_environment(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_beanstalk(
        "RebuildEnvironment", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    request_environment_info(info_type)
    request_environment_info(info_type, params::Dict{String,<:Any})

Initiates a request to compile the specified type of information of the deployed
environment.  Setting the InfoType to tail compiles the last lines from the application
server log files of every Amazon EC2 instance in your environment.   Setting the InfoType
to bundle compresses the application server log files for every Amazon EC2 instance into a
.zip file. Legacy and .NET containers do not support bundle logs.   Use
RetrieveEnvironmentInfo to obtain the set of logs.  Related Topics
RetrieveEnvironmentInfo

# Arguments
- `info_type`: The type of information to request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EnvironmentId"`: The ID of the environment of the requested data. If no such
  environment is found, RequestEnvironmentInfo returns an InvalidParameterValue error.
  Condition: You must specify either this or an EnvironmentName, or both. If you do not
  specify either, AWS Elastic Beanstalk returns MissingRequiredParameter error.
- `"EnvironmentName"`: The name of the environment of the requested data. If no such
  environment is found, RequestEnvironmentInfo returns an InvalidParameterValue error.
  Condition: You must specify either this or an EnvironmentId, or both. If you do not specify
  either, AWS Elastic Beanstalk returns MissingRequiredParameter error.
"""
function request_environment_info(
    InfoType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_beanstalk(
        "RequestEnvironmentInfo",
        Dict{String,Any}("InfoType" => InfoType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function request_environment_info(
    InfoType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_beanstalk(
        "RequestEnvironmentInfo",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("InfoType" => InfoType), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    restart_app_server()
    restart_app_server(params::Dict{String,<:Any})

Causes the environment to restart the application container server running on each Amazon
EC2 instance.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EnvironmentId"`: The ID of the environment to restart the server for.  Condition: You
  must specify either this or an EnvironmentName, or both. If you do not specify either, AWS
  Elastic Beanstalk returns MissingRequiredParameter error.
- `"EnvironmentName"`: The name of the environment to restart the server for.  Condition:
  You must specify either this or an EnvironmentId, or both. If you do not specify either,
  AWS Elastic Beanstalk returns MissingRequiredParameter error.
"""
function restart_app_server(; aws_config::AbstractAWSConfig=current_aws_config())
    return elastic_beanstalk(
        "RestartAppServer"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function restart_app_server(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_beanstalk(
        "RestartAppServer", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    retrieve_environment_info(info_type)
    retrieve_environment_info(info_type, params::Dict{String,<:Any})

Retrieves the compiled information from a RequestEnvironmentInfo request. Related Topics
RequestEnvironmentInfo

# Arguments
- `info_type`: The type of information to retrieve.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EnvironmentId"`: The ID of the data's environment. If no such environment is found,
  returns an InvalidParameterValue error. Condition: You must specify either this or an
  EnvironmentName, or both. If you do not specify either, AWS Elastic Beanstalk returns
  MissingRequiredParameter error.
- `"EnvironmentName"`: The name of the data's environment.  If no such environment is
  found, returns an InvalidParameterValue error.   Condition: You must specify either this or
  an EnvironmentId, or both. If you do not specify either, AWS Elastic Beanstalk returns
  MissingRequiredParameter error.
"""
function retrieve_environment_info(
    InfoType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_beanstalk(
        "RetrieveEnvironmentInfo",
        Dict{String,Any}("InfoType" => InfoType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function retrieve_environment_info(
    InfoType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_beanstalk(
        "RetrieveEnvironmentInfo",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("InfoType" => InfoType), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    swap_environment_cnames()
    swap_environment_cnames(params::Dict{String,<:Any})

Swaps the CNAMEs of two environments.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DestinationEnvironmentId"`: The ID of the destination environment.  Condition: You must
  specify at least the DestinationEnvironmentID or the DestinationEnvironmentName. You may
  also specify both. You must specify the SourceEnvironmentId with the
  DestinationEnvironmentId.
- `"DestinationEnvironmentName"`: The name of the destination environment.  Condition: You
  must specify at least the DestinationEnvironmentID or the DestinationEnvironmentName. You
  may also specify both. You must specify the SourceEnvironmentName with the
  DestinationEnvironmentName.
- `"SourceEnvironmentId"`: The ID of the source environment.  Condition: You must specify
  at least the SourceEnvironmentID or the SourceEnvironmentName. You may also specify both.
  If you specify the SourceEnvironmentId, you must specify the DestinationEnvironmentId.
- `"SourceEnvironmentName"`: The name of the source environment.  Condition: You must
  specify at least the SourceEnvironmentID or the SourceEnvironmentName. You may also specify
  both. If you specify the SourceEnvironmentName, you must specify the
  DestinationEnvironmentName.
"""
function swap_environment_cnames(; aws_config::AbstractAWSConfig=current_aws_config())
    return elastic_beanstalk(
        "SwapEnvironmentCNAMEs"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function swap_environment_cnames(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_beanstalk(
        "SwapEnvironmentCNAMEs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    terminate_environment()
    terminate_environment(params::Dict{String,<:Any})

Terminates the specified environment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EnvironmentId"`: The ID of the environment to terminate.  Condition: You must specify
  either this or an EnvironmentName, or both. If you do not specify either, AWS Elastic
  Beanstalk returns MissingRequiredParameter error.
- `"EnvironmentName"`: The name of the environment to terminate.  Condition: You must
  specify either this or an EnvironmentId, or both. If you do not specify either, AWS Elastic
  Beanstalk returns MissingRequiredParameter error.
- `"ForceTerminate"`: Terminates the target environment even if another environment in the
  same group is dependent on it.
- `"TerminateResources"`: Indicates whether the associated AWS resources should shut down
  when the environment is terminated:    true: The specified environment as well as the
  associated AWS resources, such as Auto Scaling group and LoadBalancer, are terminated.
  false: AWS Elastic Beanstalk resource management is removed from the environment, but the
  AWS resources continue to operate.    For more information, see the  AWS Elastic Beanstalk
  User Guide.    Default: true   Valid Values: true | false
"""
function terminate_environment(; aws_config::AbstractAWSConfig=current_aws_config())
    return elastic_beanstalk(
        "TerminateEnvironment"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function terminate_environment(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_beanstalk(
        "TerminateEnvironment",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_application(application_name)
    update_application(application_name, params::Dict{String,<:Any})

Updates the specified application to have the specified properties.  If a property (for
example, description) is not provided, the value remains unchanged. To clear these
properties, specify an empty string.

# Arguments
- `application_name`: The name of the application to update. If no such application is
  found, UpdateApplication returns an InvalidParameterValue error.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A new description for the application. Default: If not specified, AWS
  Elastic Beanstalk does not update the description.
"""
function update_application(
    ApplicationName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_beanstalk(
        "UpdateApplication",
        Dict{String,Any}("ApplicationName" => ApplicationName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_application(
    ApplicationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_beanstalk(
        "UpdateApplication",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ApplicationName" => ApplicationName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_application_resource_lifecycle(application_name, resource_lifecycle_config)
    update_application_resource_lifecycle(application_name, resource_lifecycle_config, params::Dict{String,<:Any})

Modifies lifecycle settings for an application.

# Arguments
- `application_name`: The name of the application.
- `resource_lifecycle_config`: The lifecycle configuration.

"""
function update_application_resource_lifecycle(
    ApplicationName,
    ResourceLifecycleConfig;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_beanstalk(
        "UpdateApplicationResourceLifecycle",
        Dict{String,Any}(
            "ApplicationName" => ApplicationName,
            "ResourceLifecycleConfig" => ResourceLifecycleConfig,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_application_resource_lifecycle(
    ApplicationName,
    ResourceLifecycleConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_beanstalk(
        "UpdateApplicationResourceLifecycle",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationName" => ApplicationName,
                    "ResourceLifecycleConfig" => ResourceLifecycleConfig,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_application_version(application_name, version_label)
    update_application_version(application_name, version_label, params::Dict{String,<:Any})

Updates the specified application version to have the specified properties.  If a property
(for example, description) is not provided, the value remains unchanged. To clear
properties, specify an empty string.

# Arguments
- `application_name`: The name of the application associated with this version.  If no
  application is found with this name, UpdateApplication returns an InvalidParameterValue
  error.
- `version_label`: The name of the version to update. If no application version is found
  with this label, UpdateApplication returns an InvalidParameterValue error.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A new description for this version.
"""
function update_application_version(
    ApplicationName, VersionLabel; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_beanstalk(
        "UpdateApplicationVersion",
        Dict{String,Any}(
            "ApplicationName" => ApplicationName, "VersionLabel" => VersionLabel
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_application_version(
    ApplicationName,
    VersionLabel,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_beanstalk(
        "UpdateApplicationVersion",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationName" => ApplicationName, "VersionLabel" => VersionLabel
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_configuration_template(application_name, template_name)
    update_configuration_template(application_name, template_name, params::Dict{String,<:Any})

Updates the specified configuration template to have the specified properties or
configuration option values.  If a property (for example, ApplicationName) is not provided,
its value remains unchanged. To clear such properties, specify an empty string.  Related
Topics    DescribeConfigurationOptions

# Arguments
- `application_name`: The name of the application associated with the configuration
  template to update.  If no application is found with this name, UpdateConfigurationTemplate
  returns an InvalidParameterValue error.
- `template_name`: The name of the configuration template to update.  If no configuration
  template is found with this name, UpdateConfigurationTemplate returns an
  InvalidParameterValue error.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A new description for the configuration.
- `"OptionSettings"`: A list of configuration option settings to update with the new
  specified option value.
- `"OptionsToRemove"`: A list of configuration options to remove from the configuration
  set.  Constraint: You can remove only UserDefined configuration options.
"""
function update_configuration_template(
    ApplicationName, TemplateName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_beanstalk(
        "UpdateConfigurationTemplate",
        Dict{String,Any}(
            "ApplicationName" => ApplicationName, "TemplateName" => TemplateName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_configuration_template(
    ApplicationName,
    TemplateName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_beanstalk(
        "UpdateConfigurationTemplate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationName" => ApplicationName, "TemplateName" => TemplateName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_environment()
    update_environment(params::Dict{String,<:Any})

Updates the environment description, deploys a new application version, updates the
configuration settings to an entirely new configuration template, or updates select
configuration option values in the running environment.  Attempting to update both the
release and configuration is not allowed and AWS Elastic Beanstalk returns an
InvalidParameterCombination error.   When updating the configuration settings to a new
template or individual settings, a draft configuration is created and
DescribeConfigurationSettings for this environment returns two setting descriptions with
different DeploymentStatus values.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ApplicationName"`: The name of the application with which the environment is associated.
- `"Description"`: If this parameter is specified, AWS Elastic Beanstalk updates the
  description of this environment.
- `"EnvironmentId"`: The ID of the environment to update. If no environment with this ID
  exists, AWS Elastic Beanstalk returns an InvalidParameterValue error. Condition: You must
  specify either this or an EnvironmentName, or both. If you do not specify either, AWS
  Elastic Beanstalk returns MissingRequiredParameter error.
- `"EnvironmentName"`: The name of the environment to update. If no environment with this
  name exists, AWS Elastic Beanstalk returns an InvalidParameterValue error.  Condition: You
  must specify either this or an EnvironmentId, or both. If you do not specify either, AWS
  Elastic Beanstalk returns MissingRequiredParameter error.
- `"GroupName"`: The name of the group to which the target environment belongs. Specify a
  group name only if the environment's name is specified in an environment manifest and not
  with the environment name or environment ID parameters. See Environment Manifest (env.yaml)
  for details.
- `"OptionSettings"`: If specified, AWS Elastic Beanstalk updates the configuration set
  associated with the running environment and sets the specified configuration options to the
  requested value.
- `"OptionsToRemove"`: A list of custom user-defined configuration options to remove from
  the configuration set for this environment.
- `"PlatformArn"`: The ARN of the platform, if used.
- `"SolutionStackName"`: This specifies the platform version that the environment will run
  after the environment is updated.
- `"TemplateName"`: If this parameter is specified, AWS Elastic Beanstalk deploys this
  configuration template to the environment. If no such configuration template is found, AWS
  Elastic Beanstalk returns an InvalidParameterValue error.
- `"Tier"`: This specifies the tier to use to update the environment. Condition: At this
  time, if you change the tier version, name, or type, AWS Elastic Beanstalk returns
  InvalidParameterValue error.
- `"VersionLabel"`: If this parameter is specified, AWS Elastic Beanstalk deploys the named
  application version to the environment. If no such application version is found, returns an
  InvalidParameterValue error.
"""
function update_environment(; aws_config::AbstractAWSConfig=current_aws_config())
    return elastic_beanstalk(
        "UpdateEnvironment"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function update_environment(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_beanstalk(
        "UpdateEnvironment", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    update_tags_for_resource(resource_arn)
    update_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Update the list of tags applied to an AWS Elastic Beanstalk resource. Two lists can be
passed: TagsToAdd for tags to add or update, and TagsToRemove. Elastic Beanstalk supports
tagging of all of its resources. For details about resource tagging, see Tagging
Application Resources. If you create a custom IAM user policy to control permission to this
operation, specify one of the following two virtual actions (or both) instead of the API
operation name:  elasticbeanstalk:AddTags  Controls permission to call
UpdateTagsForResource and pass a list of tags to add in the TagsToAdd parameter.
elasticbeanstalk:RemoveTags  Controls permission to call UpdateTagsForResource and pass a
list of tag keys to remove in the TagsToRemove parameter.   For details about creating a
custom user policy, see Creating a Custom User Policy.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resouce to be updated. Must be the
  ARN of an Elastic Beanstalk resource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"TagsToAdd"`: A list of tags to add or update. If a key of an existing tag is added, the
  tag's value is updated. Specify at least one of these parameters: TagsToAdd, TagsToRemove.
- `"TagsToRemove"`: A list of tag keys to remove. If a tag key doesn't exist, it is
  silently ignored. Specify at least one of these parameters: TagsToAdd, TagsToRemove.
"""
function update_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_beanstalk(
        "UpdateTagsForResource",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_beanstalk(
        "UpdateTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    validate_configuration_settings(application_name, option_settings)
    validate_configuration_settings(application_name, option_settings, params::Dict{String,<:Any})

Takes a set of configuration settings and either a configuration template or environment,
and determines whether those values are valid. This action returns a list of messages
indicating any errors or warnings associated with the selection of option values.

# Arguments
- `application_name`: The name of the application that the configuration template or
  environment belongs to.
- `option_settings`: A list of the options and desired values to evaluate.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EnvironmentName"`: The name of the environment to validate the settings against.
  Condition: You cannot specify both this and a configuration template name.
- `"TemplateName"`: The name of the configuration template to validate the settings
  against. Condition: You cannot specify both this and an environment name.
"""
function validate_configuration_settings(
    ApplicationName, OptionSettings; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_beanstalk(
        "ValidateConfigurationSettings",
        Dict{String,Any}(
            "ApplicationName" => ApplicationName, "OptionSettings" => OptionSettings
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function validate_configuration_settings(
    ApplicationName,
    OptionSettings,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_beanstalk(
        "ValidateConfigurationSettings",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationName" => ApplicationName, "OptionSettings" => OptionSettings
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: kinesis_video_media
using AWS.Compat
using AWS.UUIDs

"""
    get_media(start_selector)
    get_media(start_selector, params::Dict{String,<:Any})

 Use this API to retrieve media content from a Kinesis video stream. In the request, you
identify the stream name or stream Amazon Resource Name (ARN), and the starting chunk.
Kinesis Video Streams then returns a stream of chunks in order by fragment number.  You
must first call the GetDataEndpoint API to get an endpoint. Then send the GetMedia requests
to this endpoint using the --endpoint-url parameter.   When you put media data (fragments)
on a stream, Kinesis Video Streams stores each incoming fragment and related metadata in
what is called a \"chunk.\" For more information, see PutMedia. The GetMedia API returns a
stream of these chunks starting from the chunk that you specify in the request.  The
following limits apply when using the GetMedia API:   A client can call GetMedia up to five
times per second per stream.    Kinesis Video Streams sends media data at a rate of up to
25 megabytes per second (or 200 megabits per second) during a GetMedia session.     If an
error is thrown after invoking a Kinesis Video Streams media API, in addition to the HTTP
status code and the response body, it includes the following pieces of information:
x-amz-ErrorType HTTP header – contains a more specific error type in addition to what the
HTTP status code provides.     x-amz-RequestId HTTP header – if you want to report an
issue to AWS, the support team can better diagnose the problem if given the Request Id.
Both the HTTP status code and the ErrorType header can be utilized to make programmatic
decisions about whether errors are retry-able and under what conditions, as well as provide
information on what actions the client programmer might need to take in order to
successfully try again. For more information, see the Errors section at the bottom of this
topic, as well as Common Errors.

# Arguments
- `start_selector`: Identifies the starting chunk to get from the specified stream.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"StreamARN"`: The ARN of the stream from where you want to get the media content. If you
  don't specify the streamARN, you must specify the streamName.
- `"StreamName"`: The Kinesis video stream name from where you want to get the media
  content. If you don't specify the streamName, you must specify the streamARN.
"""
function get_media(StartSelector; aws_config::AbstractAWSConfig=current_aws_config())
    return kinesis_video_media(
        "POST",
        "/getMedia",
        Dict{String,Any}("StartSelector" => StartSelector);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_media(
    StartSelector,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_video_media(
        "POST",
        "/getMedia",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("StartSelector" => StartSelector), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: kinesis_analytics
using AWS.Compat
using AWS.UUIDs

"""
    add_application_cloud_watch_logging_option(application_name, cloud_watch_logging_option, current_application_version_id)
    add_application_cloud_watch_logging_option(application_name, cloud_watch_logging_option, current_application_version_id, params::Dict{String,<:Any})

 This documentation is for version 1 of the Amazon Kinesis Data Analytics API, which only
supports SQL applications. Version 2 of the API supports SQL and Java applications. For
more information about version 2, see Amazon Kinesis Data Analytics API V2 Documentation.
Adds a CloudWatch log stream to monitor application configuration errors. For more
information about using CloudWatch log streams with Amazon Kinesis Analytics applications,
see Working with Amazon CloudWatch Logs.

# Arguments
- `application_name`: The Kinesis Analytics application name.
- `cloud_watch_logging_option`: Provides the CloudWatch log stream Amazon Resource Name
  (ARN) and the IAM role ARN. Note: To write application messages to CloudWatch, the IAM role
  that is used must have the PutLogEvents policy action enabled.
- `current_application_version_id`: The version ID of the Kinesis Analytics application.

"""
function add_application_cloud_watch_logging_option(
    ApplicationName,
    CloudWatchLoggingOption,
    CurrentApplicationVersionId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics(
        "AddApplicationCloudWatchLoggingOption",
        Dict{String,Any}(
            "ApplicationName" => ApplicationName,
            "CloudWatchLoggingOption" => CloudWatchLoggingOption,
            "CurrentApplicationVersionId" => CurrentApplicationVersionId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_application_cloud_watch_logging_option(
    ApplicationName,
    CloudWatchLoggingOption,
    CurrentApplicationVersionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics(
        "AddApplicationCloudWatchLoggingOption",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationName" => ApplicationName,
                    "CloudWatchLoggingOption" => CloudWatchLoggingOption,
                    "CurrentApplicationVersionId" => CurrentApplicationVersionId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    add_application_input(application_name, current_application_version_id, input)
    add_application_input(application_name, current_application_version_id, input, params::Dict{String,<:Any})

 This documentation is for version 1 of the Amazon Kinesis Data Analytics API, which only
supports SQL applications. Version 2 of the API supports SQL and Java applications. For
more information about version 2, see Amazon Kinesis Data Analytics API V2 Documentation.
Adds a streaming source to your Amazon Kinesis application. For conceptual information, see
Configuring Application Input.  You can add a streaming source either when you create an
application or you can use this operation to add a streaming source after you create an
application. For more information, see CreateApplication. Any configuration update,
including adding a streaming source using this operation, results in a new version of the
application. You can use the DescribeApplication operation to find the current application
version.  This operation requires permissions to perform the
kinesisanalytics:AddApplicationInput action.

# Arguments
- `application_name`: Name of your existing Amazon Kinesis Analytics application to which
  you want to add the streaming source.
- `current_application_version_id`: Current version of your Amazon Kinesis Analytics
  application. You can use the DescribeApplication operation to find the current application
  version.
- `input`: The Input to add.

"""
function add_application_input(
    ApplicationName,
    CurrentApplicationVersionId,
    Input;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics(
        "AddApplicationInput",
        Dict{String,Any}(
            "ApplicationName" => ApplicationName,
            "CurrentApplicationVersionId" => CurrentApplicationVersionId,
            "Input" => Input,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_application_input(
    ApplicationName,
    CurrentApplicationVersionId,
    Input,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics(
        "AddApplicationInput",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationName" => ApplicationName,
                    "CurrentApplicationVersionId" => CurrentApplicationVersionId,
                    "Input" => Input,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    add_application_input_processing_configuration(application_name, current_application_version_id, input_id, input_processing_configuration)
    add_application_input_processing_configuration(application_name, current_application_version_id, input_id, input_processing_configuration, params::Dict{String,<:Any})

 This documentation is for version 1 of the Amazon Kinesis Data Analytics API, which only
supports SQL applications. Version 2 of the API supports SQL and Java applications. For
more information about version 2, see Amazon Kinesis Data Analytics API V2 Documentation.
Adds an InputProcessingConfiguration to an application. An input processor preprocesses
records on the input stream before the application's SQL code executes. Currently, the only
input processor available is AWS Lambda.

# Arguments
- `application_name`: Name of the application to which you want to add the input processing
  configuration.
- `current_application_version_id`: Version of the application to which you want to add the
  input processing configuration. You can use the DescribeApplication operation to get the
  current application version. If the version specified is not the current version, the
  ConcurrentModificationException is returned.
- `input_id`: The ID of the input configuration to add the input processing configuration
  to. You can get a list of the input IDs for an application using the DescribeApplication
  operation.
- `input_processing_configuration`: The InputProcessingConfiguration to add to the
  application.

"""
function add_application_input_processing_configuration(
    ApplicationName,
    CurrentApplicationVersionId,
    InputId,
    InputProcessingConfiguration;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics(
        "AddApplicationInputProcessingConfiguration",
        Dict{String,Any}(
            "ApplicationName" => ApplicationName,
            "CurrentApplicationVersionId" => CurrentApplicationVersionId,
            "InputId" => InputId,
            "InputProcessingConfiguration" => InputProcessingConfiguration,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_application_input_processing_configuration(
    ApplicationName,
    CurrentApplicationVersionId,
    InputId,
    InputProcessingConfiguration,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics(
        "AddApplicationInputProcessingConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationName" => ApplicationName,
                    "CurrentApplicationVersionId" => CurrentApplicationVersionId,
                    "InputId" => InputId,
                    "InputProcessingConfiguration" => InputProcessingConfiguration,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    add_application_output(application_name, current_application_version_id, output)
    add_application_output(application_name, current_application_version_id, output, params::Dict{String,<:Any})

 This documentation is for version 1 of the Amazon Kinesis Data Analytics API, which only
supports SQL applications. Version 2 of the API supports SQL and Java applications. For
more information about version 2, see Amazon Kinesis Data Analytics API V2 Documentation.
Adds an external destination to your Amazon Kinesis Analytics application. If you want
Amazon Kinesis Analytics to deliver data from an in-application stream within your
application to an external destination (such as an Amazon Kinesis stream, an Amazon Kinesis
Firehose delivery stream, or an AWS Lambda function), you add the relevant configuration to
your application using this operation. You can configure one or more outputs for your
application. Each output configuration maps an in-application stream and an external
destination.  You can use one of the output configurations to deliver data from your
in-application error stream to an external destination so that you can analyze the errors.
For more information, see Understanding Application Output (Destination).   Any
configuration update, including adding a streaming source using this operation, results in
a new version of the application. You can use the DescribeApplication operation to find the
current application version. For the limits on the number of application inputs and outputs
you can configure, see Limits. This operation requires permissions to perform the
kinesisanalytics:AddApplicationOutput action.

# Arguments
- `application_name`: Name of the application to which you want to add the output
  configuration.
- `current_application_version_id`: Version of the application to which you want to add the
  output configuration. You can use the DescribeApplication operation to get the current
  application version. If the version specified is not the current version, the
  ConcurrentModificationException is returned.
- `output`: An array of objects, each describing one output configuration. In the output
  configuration, you specify the name of an in-application stream, a destination (that is, an
  Amazon Kinesis stream, an Amazon Kinesis Firehose delivery stream, or an AWS Lambda
  function), and record the formation to use when writing to the destination.

"""
function add_application_output(
    ApplicationName,
    CurrentApplicationVersionId,
    Output;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics(
        "AddApplicationOutput",
        Dict{String,Any}(
            "ApplicationName" => ApplicationName,
            "CurrentApplicationVersionId" => CurrentApplicationVersionId,
            "Output" => Output,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_application_output(
    ApplicationName,
    CurrentApplicationVersionId,
    Output,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics(
        "AddApplicationOutput",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationName" => ApplicationName,
                    "CurrentApplicationVersionId" => CurrentApplicationVersionId,
                    "Output" => Output,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    add_application_reference_data_source(application_name, current_application_version_id, reference_data_source)
    add_application_reference_data_source(application_name, current_application_version_id, reference_data_source, params::Dict{String,<:Any})

 This documentation is for version 1 of the Amazon Kinesis Data Analytics API, which only
supports SQL applications. Version 2 of the API supports SQL and Java applications. For
more information about version 2, see Amazon Kinesis Data Analytics API V2 Documentation.
Adds a reference data source to an existing application. Amazon Kinesis Analytics reads
reference data (that is, an Amazon S3 object) and creates an in-application table within
your application. In the request, you provide the source (S3 bucket name and object key
name), name of the in-application table to create, and the necessary mapping information
that describes how data in Amazon S3 object maps to columns in the resulting in-application
table.  For conceptual information, see Configuring Application Input. For the limits on
data sources you can add to your application, see Limits.   This operation requires
permissions to perform the kinesisanalytics:AddApplicationOutput action.

# Arguments
- `application_name`: Name of an existing application.
- `current_application_version_id`: Version of the application for which you are adding the
  reference data source. You can use the DescribeApplication operation to get the current
  application version. If the version specified is not the current version, the
  ConcurrentModificationException is returned.
- `reference_data_source`: The reference data source can be an object in your Amazon S3
  bucket. Amazon Kinesis Analytics reads the object and copies the data into the
  in-application table that is created. You provide an S3 bucket, object key name, and the
  resulting in-application table that is created. You must also provide an IAM role with the
  necessary permissions that Amazon Kinesis Analytics can assume to read the object from your
  S3 bucket on your behalf.

"""
function add_application_reference_data_source(
    ApplicationName,
    CurrentApplicationVersionId,
    ReferenceDataSource;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics(
        "AddApplicationReferenceDataSource",
        Dict{String,Any}(
            "ApplicationName" => ApplicationName,
            "CurrentApplicationVersionId" => CurrentApplicationVersionId,
            "ReferenceDataSource" => ReferenceDataSource,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_application_reference_data_source(
    ApplicationName,
    CurrentApplicationVersionId,
    ReferenceDataSource,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics(
        "AddApplicationReferenceDataSource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationName" => ApplicationName,
                    "CurrentApplicationVersionId" => CurrentApplicationVersionId,
                    "ReferenceDataSource" => ReferenceDataSource,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_application(application_name)
    create_application(application_name, params::Dict{String,<:Any})

 This documentation is for version 1 of the Amazon Kinesis Data Analytics API, which only
supports SQL applications. Version 2 of the API supports SQL and Java applications. For
more information about version 2, see Amazon Kinesis Data Analytics API V2 Documentation.
Creates an Amazon Kinesis Analytics application. You can configure each application with
one streaming source as input, application code to process the input, and up to three
destinations where you want Amazon Kinesis Analytics to write the output data from your
application. For an overview, see How it Works.  In the input configuration, you map the
streaming source to an in-application stream, which you can think of as a constantly
updating table. In the mapping, you must provide a schema for the in-application stream and
map each data column in the in-application stream to a data element in the streaming
source. Your application code is one or more SQL statements that read input data, transform
it, and generate output. Your application code can create one or more SQL artifacts like
SQL streams or pumps. In the output configuration, you can configure the application to
write data from in-application streams created in your applications to up to three
destinations.  To read data from your source stream or write data to destination streams,
Amazon Kinesis Analytics needs your permissions. You grant these permissions by creating
IAM roles. This operation requires permissions to perform the
kinesisanalytics:CreateApplication action.   For introductory exercises to create an Amazon
Kinesis Analytics application, see Getting Started.

# Arguments
- `application_name`: Name of your Amazon Kinesis Analytics application (for example,
  sample-app).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ApplicationCode"`: One or more SQL statements that read input data, transform it, and
  generate output. For example, you can write a SQL statement that reads data from one
  in-application stream, generates a running average of the number of advertisement clicks by
  vendor, and insert resulting rows in another in-application stream using pumps. For more
  information about the typical pattern, see Application Code.  You can provide such series
  of SQL statements, where output of one statement can be used as the input for the next
  statement. You store intermediate results by creating in-application streams and pumps.
  Note that the application code must create the streams with names specified in the Outputs.
  For example, if your Outputs defines output streams named ExampleOutputStream1 and
  ExampleOutputStream2, then your application code must create these streams.
- `"ApplicationDescription"`: Summary description of the application.
- `"CloudWatchLoggingOptions"`: Use this parameter to configure a CloudWatch log stream to
  monitor application configuration errors. For more information, see Working with Amazon
  CloudWatch Logs.
- `"Inputs"`: Use this parameter to configure the application input. You can configure your
  application to receive input from a single streaming source. In this configuration, you map
  this streaming source to an in-application stream that is created. Your application code
  can then query the in-application stream like a table (you can think of it as a constantly
  updating table). For the streaming source, you provide its Amazon Resource Name (ARN) and
  format of data on the stream (for example, JSON, CSV, etc.). You also must provide an IAM
  role that Amazon Kinesis Analytics can assume to read this stream on your behalf. To create
  the in-application stream, you need to specify a schema to transform your data into a
  schematized version used in SQL. In the schema, you provide the necessary mapping of the
  data elements in the streaming source to record columns in the in-app stream.
- `"Outputs"`: You can configure application output to write data from any of the
  in-application streams to up to three destinations. These destinations can be Amazon
  Kinesis streams, Amazon Kinesis Firehose delivery streams, AWS Lambda destinations, or any
  combination of the three. In the configuration, you specify the in-application stream name,
  the destination stream or Lambda function Amazon Resource Name (ARN), and the format to use
  when writing data. You must also provide an IAM role that Amazon Kinesis Analytics can
  assume to write to the destination stream or Lambda function on your behalf. In the output
  configuration, you also provide the output stream or Lambda function ARN. For stream
  destinations, you provide the format of data in the stream (for example, JSON, CSV). You
  also must provide an IAM role that Amazon Kinesis Analytics can assume to write to the
  stream or Lambda function on your behalf.
- `"Tags"`: A list of one or more tags to assign to the application. A tag is a key-value
  pair that identifies an application. Note that the maximum number of application tags
  includes system tags. The maximum number of user-defined application tags is 50. For more
  information, see Using Tagging.
"""
function create_application(
    ApplicationName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_analytics(
        "CreateApplication",
        Dict{String,Any}("ApplicationName" => ApplicationName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_application(
    ApplicationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics(
        "CreateApplication",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ApplicationName" => ApplicationName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_application(application_name, create_timestamp)
    delete_application(application_name, create_timestamp, params::Dict{String,<:Any})

 This documentation is for version 1 of the Amazon Kinesis Data Analytics API, which only
supports SQL applications. Version 2 of the API supports SQL and Java applications. For
more information about version 2, see Amazon Kinesis Data Analytics API V2 Documentation.
Deletes the specified application. Amazon Kinesis Analytics halts application execution and
deletes the application, including any application artifacts (such as in-application
streams, reference table, and application code). This operation requires permissions to
perform the kinesisanalytics:DeleteApplication action.

# Arguments
- `application_name`: Name of the Amazon Kinesis Analytics application to delete.
- `create_timestamp`:  You can use the DescribeApplication operation to get this value.

"""
function delete_application(
    ApplicationName, CreateTimestamp; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_analytics(
        "DeleteApplication",
        Dict{String,Any}(
            "ApplicationName" => ApplicationName, "CreateTimestamp" => CreateTimestamp
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_application(
    ApplicationName,
    CreateTimestamp,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics(
        "DeleteApplication",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationName" => ApplicationName,
                    "CreateTimestamp" => CreateTimestamp,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_application_cloud_watch_logging_option(application_name, cloud_watch_logging_option_id, current_application_version_id)
    delete_application_cloud_watch_logging_option(application_name, cloud_watch_logging_option_id, current_application_version_id, params::Dict{String,<:Any})

 This documentation is for version 1 of the Amazon Kinesis Data Analytics API, which only
supports SQL applications. Version 2 of the API supports SQL and Java applications. For
more information about version 2, see Amazon Kinesis Data Analytics API V2 Documentation.
Deletes a CloudWatch log stream from an application. For more information about using
CloudWatch log streams with Amazon Kinesis Analytics applications, see Working with Amazon
CloudWatch Logs.

# Arguments
- `application_name`: The Kinesis Analytics application name.
- `cloud_watch_logging_option_id`: The CloudWatchLoggingOptionId of the CloudWatch logging
  option to delete. You can get the CloudWatchLoggingOptionId by using the
  DescribeApplication operation.
- `current_application_version_id`: The version ID of the Kinesis Analytics application.

"""
function delete_application_cloud_watch_logging_option(
    ApplicationName,
    CloudWatchLoggingOptionId,
    CurrentApplicationVersionId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics(
        "DeleteApplicationCloudWatchLoggingOption",
        Dict{String,Any}(
            "ApplicationName" => ApplicationName,
            "CloudWatchLoggingOptionId" => CloudWatchLoggingOptionId,
            "CurrentApplicationVersionId" => CurrentApplicationVersionId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_application_cloud_watch_logging_option(
    ApplicationName,
    CloudWatchLoggingOptionId,
    CurrentApplicationVersionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics(
        "DeleteApplicationCloudWatchLoggingOption",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationName" => ApplicationName,
                    "CloudWatchLoggingOptionId" => CloudWatchLoggingOptionId,
                    "CurrentApplicationVersionId" => CurrentApplicationVersionId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_application_input_processing_configuration(application_name, current_application_version_id, input_id)
    delete_application_input_processing_configuration(application_name, current_application_version_id, input_id, params::Dict{String,<:Any})

 This documentation is for version 1 of the Amazon Kinesis Data Analytics API, which only
supports SQL applications. Version 2 of the API supports SQL and Java applications. For
more information about version 2, see Amazon Kinesis Data Analytics API V2 Documentation.
Deletes an InputProcessingConfiguration from an input.

# Arguments
- `application_name`: The Kinesis Analytics application name.
- `current_application_version_id`: The version ID of the Kinesis Analytics application.
- `input_id`: The ID of the input configuration from which to delete the input processing
  configuration. You can get a list of the input IDs for an application by using the
  DescribeApplication operation.

"""
function delete_application_input_processing_configuration(
    ApplicationName,
    CurrentApplicationVersionId,
    InputId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics(
        "DeleteApplicationInputProcessingConfiguration",
        Dict{String,Any}(
            "ApplicationName" => ApplicationName,
            "CurrentApplicationVersionId" => CurrentApplicationVersionId,
            "InputId" => InputId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_application_input_processing_configuration(
    ApplicationName,
    CurrentApplicationVersionId,
    InputId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics(
        "DeleteApplicationInputProcessingConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationName" => ApplicationName,
                    "CurrentApplicationVersionId" => CurrentApplicationVersionId,
                    "InputId" => InputId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_application_output(application_name, current_application_version_id, output_id)
    delete_application_output(application_name, current_application_version_id, output_id, params::Dict{String,<:Any})

 This documentation is for version 1 of the Amazon Kinesis Data Analytics API, which only
supports SQL applications. Version 2 of the API supports SQL and Java applications. For
more information about version 2, see Amazon Kinesis Data Analytics API V2 Documentation.
Deletes output destination configuration from your application configuration. Amazon
Kinesis Analytics will no longer write data from the corresponding in-application stream to
the external output destination. This operation requires permissions to perform the
kinesisanalytics:DeleteApplicationOutput action.

# Arguments
- `application_name`: Amazon Kinesis Analytics application name.
- `current_application_version_id`: Amazon Kinesis Analytics application version. You can
  use the DescribeApplication operation to get the current application version. If the
  version specified is not the current version, the ConcurrentModificationException is
  returned.
- `output_id`: The ID of the configuration to delete. Each output configuration that is
  added to the application, either when the application is created or later using the
  AddApplicationOutput operation, has a unique ID. You need to provide the ID to uniquely
  identify the output configuration that you want to delete from the application
  configuration. You can use the DescribeApplication operation to get the specific OutputId.

"""
function delete_application_output(
    ApplicationName,
    CurrentApplicationVersionId,
    OutputId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics(
        "DeleteApplicationOutput",
        Dict{String,Any}(
            "ApplicationName" => ApplicationName,
            "CurrentApplicationVersionId" => CurrentApplicationVersionId,
            "OutputId" => OutputId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_application_output(
    ApplicationName,
    CurrentApplicationVersionId,
    OutputId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics(
        "DeleteApplicationOutput",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationName" => ApplicationName,
                    "CurrentApplicationVersionId" => CurrentApplicationVersionId,
                    "OutputId" => OutputId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_application_reference_data_source(application_name, current_application_version_id, reference_id)
    delete_application_reference_data_source(application_name, current_application_version_id, reference_id, params::Dict{String,<:Any})

 This documentation is for version 1 of the Amazon Kinesis Data Analytics API, which only
supports SQL applications. Version 2 of the API supports SQL and Java applications. For
more information about version 2, see Amazon Kinesis Data Analytics API V2 Documentation.
Deletes a reference data source configuration from the specified application configuration.
If the application is running, Amazon Kinesis Analytics immediately removes the
in-application table that you created using the AddApplicationReferenceDataSource
operation.  This operation requires permissions to perform the
kinesisanalytics.DeleteApplicationReferenceDataSource action.

# Arguments
- `application_name`: Name of an existing application.
- `current_application_version_id`: Version of the application. You can use the
  DescribeApplication operation to get the current application version. If the version
  specified is not the current version, the ConcurrentModificationException is returned.
- `reference_id`: ID of the reference data source. When you add a reference data source to
  your application using the AddApplicationReferenceDataSource, Amazon Kinesis Analytics
  assigns an ID. You can use the DescribeApplication operation to get the reference ID.

"""
function delete_application_reference_data_source(
    ApplicationName,
    CurrentApplicationVersionId,
    ReferenceId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics(
        "DeleteApplicationReferenceDataSource",
        Dict{String,Any}(
            "ApplicationName" => ApplicationName,
            "CurrentApplicationVersionId" => CurrentApplicationVersionId,
            "ReferenceId" => ReferenceId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_application_reference_data_source(
    ApplicationName,
    CurrentApplicationVersionId,
    ReferenceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics(
        "DeleteApplicationReferenceDataSource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationName" => ApplicationName,
                    "CurrentApplicationVersionId" => CurrentApplicationVersionId,
                    "ReferenceId" => ReferenceId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_application(application_name)
    describe_application(application_name, params::Dict{String,<:Any})

 This documentation is for version 1 of the Amazon Kinesis Data Analytics API, which only
supports SQL applications. Version 2 of the API supports SQL and Java applications. For
more information about version 2, see Amazon Kinesis Data Analytics API V2 Documentation.
Returns information about a specific Amazon Kinesis Analytics application. If you want to
retrieve a list of all applications in your account, use the ListApplications operation.
This operation requires permissions to perform the kinesisanalytics:DescribeApplication
action. You can use DescribeApplication to get the current application versionId, which you
need to call other operations such as Update.

# Arguments
- `application_name`: Name of the application.

"""
function describe_application(
    ApplicationName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_analytics(
        "DescribeApplication",
        Dict{String,Any}("ApplicationName" => ApplicationName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_application(
    ApplicationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics(
        "DescribeApplication",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ApplicationName" => ApplicationName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    discover_input_schema()
    discover_input_schema(params::Dict{String,<:Any})

 This documentation is for version 1 of the Amazon Kinesis Data Analytics API, which only
supports SQL applications. Version 2 of the API supports SQL and Java applications. For
more information about version 2, see Amazon Kinesis Data Analytics API V2 Documentation.
Infers a schema by evaluating sample records on the specified streaming source (Amazon
Kinesis stream or Amazon Kinesis Firehose delivery stream) or S3 object. In the response,
the operation returns the inferred schema and also the sample records that the operation
used to infer the schema.  You can use the inferred schema when configuring a streaming
source for your application. For conceptual information, see Configuring Application Input.
Note that when you create an application using the Amazon Kinesis Analytics console, the
console uses this operation to infer a schema and show it in the console user interface.
This operation requires permissions to perform the kinesisanalytics:DiscoverInputSchema
action.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"InputProcessingConfiguration"`: The InputProcessingConfiguration to use to preprocess
  the records before discovering the schema of the records.
- `"InputStartingPositionConfiguration"`: Point at which you want Amazon Kinesis Analytics
  to start reading records from the specified streaming source discovery purposes.
- `"ResourceARN"`: Amazon Resource Name (ARN) of the streaming source.
- `"RoleARN"`: ARN of the IAM role that Amazon Kinesis Analytics can assume to access the
  stream on your behalf.
- `"S3Configuration"`: Specify this parameter to discover a schema from data in an Amazon
  S3 object.
"""
function discover_input_schema(; aws_config::AbstractAWSConfig=current_aws_config())
    return kinesis_analytics(
        "DiscoverInputSchema"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function discover_input_schema(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_analytics(
        "DiscoverInputSchema",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_applications()
    list_applications(params::Dict{String,<:Any})

 This documentation is for version 1 of the Amazon Kinesis Data Analytics API, which only
supports SQL applications. Version 2 of the API supports SQL and Java applications. For
more information about version 2, see Amazon Kinesis Data Analytics API V2 Documentation.
Returns a list of Amazon Kinesis Analytics applications in your account. For each
application, the response includes the application name, Amazon Resource Name (ARN), and
status. If the response returns the HasMoreApplications value as true, you can send another
request by adding the ExclusiveStartApplicationName in the request body, and set the value
of this to the last application name from the previous response.  If you want detailed
information about a specific application, use DescribeApplication. This operation requires
permissions to perform the kinesisanalytics:ListApplications action.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ExclusiveStartApplicationName"`: Name of the application to start the list with. When
  using pagination to retrieve the list, you don't need to specify this parameter in the
  first request. However, in subsequent requests, you add the last application name from the
  previous response to get the next page of applications.
- `"Limit"`: Maximum number of applications to list.
"""
function list_applications(; aws_config::AbstractAWSConfig=current_aws_config())
    return kinesis_analytics(
        "ListApplications"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_applications(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_analytics(
        "ListApplications", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Retrieves the list of key-value tags assigned to the application. For more information, see
Using Tagging.

# Arguments
- `resource_arn`: The ARN of the application for which to retrieve tags.

"""
function list_tags_for_resource(
    ResourceARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_analytics(
        "ListTagsForResource",
        Dict{String,Any}("ResourceARN" => ResourceARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceARN" => ResourceARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_application(application_name, input_configurations)
    start_application(application_name, input_configurations, params::Dict{String,<:Any})

 This documentation is for version 1 of the Amazon Kinesis Data Analytics API, which only
supports SQL applications. Version 2 of the API supports SQL and Java applications. For
more information about version 2, see Amazon Kinesis Data Analytics API V2 Documentation.
Starts the specified Amazon Kinesis Analytics application. After creating an application,
you must exclusively call this operation to start your application. After the application
starts, it begins consuming the input data, processes it, and writes the output to the
configured destination.  The application status must be READY for you to start an
application. You can get the application status in the console or using the
DescribeApplication operation. After you start the application, you can stop the
application from processing the input by calling the StopApplication operation. This
operation requires permissions to perform the kinesisanalytics:StartApplication action.

# Arguments
- `application_name`: Name of the application.
- `input_configurations`: Identifies the specific input, by ID, that the application starts
  consuming. Amazon Kinesis Analytics starts reading the streaming source associated with the
  input. You can also specify where in the streaming source you want Amazon Kinesis Analytics
  to start reading.

"""
function start_application(
    ApplicationName, InputConfigurations; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_analytics(
        "StartApplication",
        Dict{String,Any}(
            "ApplicationName" => ApplicationName,
            "InputConfigurations" => InputConfigurations,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_application(
    ApplicationName,
    InputConfigurations,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics(
        "StartApplication",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationName" => ApplicationName,
                    "InputConfigurations" => InputConfigurations,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_application(application_name)
    stop_application(application_name, params::Dict{String,<:Any})

 This documentation is for version 1 of the Amazon Kinesis Data Analytics API, which only
supports SQL applications. Version 2 of the API supports SQL and Java applications. For
more information about version 2, see Amazon Kinesis Data Analytics API V2 Documentation.
Stops the application from processing input data. You can stop an application only if it is
in the running state. You can use the DescribeApplication operation to find the application
state. After the application is stopped, Amazon Kinesis Analytics stops reading data from
the input, the application stops processing data, and there is no output written to the
destination.  This operation requires permissions to perform the
kinesisanalytics:StopApplication action.

# Arguments
- `application_name`: Name of the running application to stop.

"""
function stop_application(
    ApplicationName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_analytics(
        "StopApplication",
        Dict{String,Any}("ApplicationName" => ApplicationName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_application(
    ApplicationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics(
        "StopApplication",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ApplicationName" => ApplicationName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds one or more key-value tags to a Kinesis Analytics application. Note that the maximum
number of application tags includes system tags. The maximum number of user-defined
application tags is 50. For more information, see Using Tagging.

# Arguments
- `resource_arn`: The ARN of the application to assign the tags.
- `tags`: The key-value tags to assign to the application.

"""
function tag_resource(ResourceARN, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return kinesis_analytics(
        "TagResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceARN,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes one or more tags from a Kinesis Analytics application. For more information, see
Using Tagging.

# Arguments
- `resource_arn`: The ARN of the Kinesis Analytics application from which to remove the
  tags.
- `tag_keys`: A list of keys of tags to remove from the specified application.

"""
function untag_resource(
    ResourceARN, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_analytics(
        "UntagResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceARN,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_application(application_name, application_update, current_application_version_id)
    update_application(application_name, application_update, current_application_version_id, params::Dict{String,<:Any})

 This documentation is for version 1 of the Amazon Kinesis Data Analytics API, which only
supports SQL applications. Version 2 of the API supports SQL and Java applications. For
more information about version 2, see Amazon Kinesis Data Analytics API V2 Documentation.
Updates an existing Amazon Kinesis Analytics application. Using this API, you can update
application code, input configuration, and output configuration.  Note that Amazon Kinesis
Analytics updates the CurrentApplicationVersionId each time you update your application.
This operation requires permission for the kinesisanalytics:UpdateApplication action.

# Arguments
- `application_name`: Name of the Amazon Kinesis Analytics application to update.
- `application_update`: Describes application updates.
- `current_application_version_id`: The current application version ID. You can use the
  DescribeApplication operation to get this value.

"""
function update_application(
    ApplicationName,
    ApplicationUpdate,
    CurrentApplicationVersionId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics(
        "UpdateApplication",
        Dict{String,Any}(
            "ApplicationName" => ApplicationName,
            "ApplicationUpdate" => ApplicationUpdate,
            "CurrentApplicationVersionId" => CurrentApplicationVersionId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_application(
    ApplicationName,
    ApplicationUpdate,
    CurrentApplicationVersionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics(
        "UpdateApplication",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationName" => ApplicationName,
                    "ApplicationUpdate" => ApplicationUpdate,
                    "CurrentApplicationVersionId" => CurrentApplicationVersionId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: resource_explorer_2
using AWS.Compat
using AWS.UUIDs

"""
    associate_default_view(view_arn)
    associate_default_view(view_arn, params::Dict{String,<:Any})

Sets the specified view as the default for the Amazon Web Services Region in which you call
this operation. When a user performs a Search that doesn't explicitly specify which view to
use, then Amazon Web Services Resource Explorer automatically chooses this default view for
searches performed in this Amazon Web Services Region. If an Amazon Web Services Region
doesn't have a default view configured, then users must explicitly specify a view with
every Search operation performed in that Region.

# Arguments
- `view_arn`: The Amazon resource name (ARN) of the view to set as the default for the
  Amazon Web Services Region and Amazon Web Services account in which you call this
  operation. The specified view must already exist in the called Region.

"""
function associate_default_view(ViewArn; aws_config::AbstractAWSConfig=current_aws_config())
    return resource_explorer_2(
        "POST",
        "/AssociateDefaultView",
        Dict{String,Any}("ViewArn" => ViewArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_default_view(
    ViewArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return resource_explorer_2(
        "POST",
        "/AssociateDefaultView",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("ViewArn" => ViewArn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_get_view()
    batch_get_view(params::Dict{String,<:Any})

Retrieves details about a list of views.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ViewArns"`: A list of Amazon resource names (ARNs) that identify the views you want
  details for.
"""
function batch_get_view(; aws_config::AbstractAWSConfig=current_aws_config())
    return resource_explorer_2(
        "POST", "/BatchGetView"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function batch_get_view(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resource_explorer_2(
        "POST",
        "/BatchGetView",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_index()
    create_index(params::Dict{String,<:Any})

Turns on Amazon Web Services Resource Explorer in the Amazon Web Services Region in which
you called this operation by creating an index. Resource Explorer begins discovering the
resources in this Region and stores the details about the resources in the index so that
they can be queried by using the Search operation. You can create only one index in a
Region.  This operation creates only a local index. To promote the local index in one
Amazon Web Services Region into the aggregator index for the Amazon Web Services account,
use the UpdateIndexType operation. For more information, see Turning on cross-Region search
by creating an aggregator index in the Amazon Web Services Resource Explorer User Guide.
For more details about what happens when you turn on Resource Explorer in an Amazon Web
Services Region, see Turn on Resource Explorer to index your resources in an Amazon Web
Services Region in the Amazon Web Services Resource Explorer User Guide. If this is the
first Amazon Web Services Region in which you've created an index for Resource Explorer,
then this operation also creates a service-linked role in your Amazon Web Services account
that allows Resource Explorer to enumerate your resources to populate the index.    Action:
resource-explorer-2:CreateIndex   Resource: The ARN of the index (as it will exist after
the operation completes) in the Amazon Web Services Region and account in which you're
trying to create the index. Use the wildcard character (*) at the end of the string to
match the eventual UUID. For example, the following Resource element restricts the role or
user to creating an index in only the us-east-2 Region of the specified account.
\"Resource\": \"arn:aws:resource-explorer-2:us-west-2:&lt;account-id&gt;:index/*\"
Alternatively, you can use \"Resource\": \"*\" to allow the role or user to create an index
in any Region.    Action: iam:CreateServiceLinkedRole   Resource: No specific resource (*).
 This permission is required only the first time you create an index to turn on Resource
Explorer in the account. Resource Explorer uses this to create the service-linked role
needed to index the resources in your account. Resource Explorer uses the same
service-linked role for all additional indexes you create afterwards.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: This value helps ensure idempotency. Resource Explorer uses this value
  to prevent the accidental creation of duplicate versions. We recommend that you generate a
  UUID-type value to ensure the uniqueness of your index.
- `"Tags"`: The specified tags are attached only to the index created in this Amazon Web
  Services Region. The tags aren't attached to any of the resources listed in the index.
"""
function create_index(; aws_config::AbstractAWSConfig=current_aws_config())
    return resource_explorer_2(
        "POST",
        "/CreateIndex",
        Dict{String,Any}("ClientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_index(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resource_explorer_2(
        "POST",
        "/CreateIndex",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ClientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_view(view_name)
    create_view(view_name, params::Dict{String,<:Any})

Creates a view that users can query by using the Search operation. Results from queries
that you make using this view include only resources that match the view's Filters. For
more information about Amazon Web Services Resource Explorer views, see Managing views in
the Amazon Web Services Resource Explorer User Guide. Only the principals with an IAM
identity-based policy that grants Allow to the Search action on a Resource with the Amazon
resource name (ARN) of this view can Search using views you create with this operation.

# Arguments
- `view_name`: The name of the new view. This name appears in the list of views in Resource
  Explorer. The name must be no more than 64 characters long, and can include letters,
  digits, and the dash (-) character. The name must be unique within its Amazon Web Services
  Region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: This value helps ensure idempotency. Resource Explorer uses this value
  to prevent the accidental creation of duplicate versions. We recommend that you generate a
  UUID-type value to ensure the uniqueness of your views.
- `"Filters"`: An array of strings that specify which resources are included in the results
  of queries made using this view. When you use this view in a Search operation, the filter
  string is combined with the search's QueryString parameter using a logical AND operator.
  For information about the supported syntax, see Search query reference for Resource
  Explorer in the Amazon Web Services Resource Explorer User Guide.  This query string in the
  context of this operation supports only filter prefixes with optional operators. It doesn't
  support free-form text. For example, the string region:us* service:ec2 -tag:stage=prod
  includes all Amazon EC2 resources in any Amazon Web Services Region that begins with the
  letters us and is not tagged with a key Stage that has the value prod.
- `"IncludedProperties"`: Specifies optional fields that you want included in search
  results from this view. It is a list of objects that each describe a field to include. The
  default is an empty list, with no optional fields included in the results.
- `"Scope"`: The root ARN of the account, an organizational unit (OU), or an organization
  ARN. If left empty, the default is account.
- `"Tags"`: Tag key and value pairs that are attached to the view.
"""
function create_view(ViewName; aws_config::AbstractAWSConfig=current_aws_config())
    return resource_explorer_2(
        "POST",
        "/CreateView",
        Dict{String,Any}("ViewName" => ViewName, "ClientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_view(
    ViewName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return resource_explorer_2(
        "POST",
        "/CreateView",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ViewName" => ViewName, "ClientToken" => string(uuid4())),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_index(arn)
    delete_index(arn, params::Dict{String,<:Any})

Deletes the specified index and turns off Amazon Web Services Resource Explorer in the
specified Amazon Web Services Region. When you delete an index, Resource Explorer stops
discovering and indexing resources in that Region. Resource Explorer also deletes all views
in that Region. These actions occur as asynchronous background tasks. You can check to see
when the actions are complete by using the GetIndex operation and checking the Status
response value.  If the index you delete is the aggregator index for the Amazon Web
Services account, you must wait 24 hours before you can promote another local index to be
the aggregator index for the account. Users can't perform account-wide searches using
Resource Explorer until another aggregator index is configured.

# Arguments
- `arn`: The Amazon resource name (ARN) of the index that you want to delete.

"""
function delete_index(Arn; aws_config::AbstractAWSConfig=current_aws_config())
    return resource_explorer_2(
        "POST",
        "/DeleteIndex",
        Dict{String,Any}("Arn" => Arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_index(
    Arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resource_explorer_2(
        "POST",
        "/DeleteIndex",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Arn" => Arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_view(view_arn)
    delete_view(view_arn, params::Dict{String,<:Any})

Deletes the specified view. If the specified view is the default view for its Amazon Web
Services Region, then all Search operations in that Region must explicitly specify the view
to use until you configure a new default by calling the AssociateDefaultView operation.

# Arguments
- `view_arn`: The Amazon resource name (ARN) of the view that you want to delete.

"""
function delete_view(ViewArn; aws_config::AbstractAWSConfig=current_aws_config())
    return resource_explorer_2(
        "POST",
        "/DeleteView",
        Dict{String,Any}("ViewArn" => ViewArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_view(
    ViewArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return resource_explorer_2(
        "POST",
        "/DeleteView",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("ViewArn" => ViewArn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_default_view()
    disassociate_default_view(params::Dict{String,<:Any})

After you call this operation, the affected Amazon Web Services Region no longer has a
default view. All Search operations in that Region must explicitly specify a view or the
operation fails. You can configure a new default by calling the AssociateDefaultView
operation. If an Amazon Web Services Region doesn't have a default view configured, then
users must explicitly specify a view with every Search operation performed in that Region.

"""
function disassociate_default_view(; aws_config::AbstractAWSConfig=current_aws_config())
    return resource_explorer_2(
        "POST",
        "/DisassociateDefaultView";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_default_view(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resource_explorer_2(
        "POST",
        "/DisassociateDefaultView",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_account_level_service_configuration()
    get_account_level_service_configuration(params::Dict{String,<:Any})

Retrieves the status of your account's Amazon Web Services service access, and validates
the service linked role required to access the multi-account search feature. Only the
management account or a delegated administrator with service access enabled can invoke this
API call.

"""
function get_account_level_service_configuration(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return resource_explorer_2(
        "POST",
        "/GetAccountLevelServiceConfiguration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_account_level_service_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resource_explorer_2(
        "POST",
        "/GetAccountLevelServiceConfiguration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_default_view()
    get_default_view(params::Dict{String,<:Any})

Retrieves the Amazon Resource Name (ARN) of the view that is the default for the Amazon Web
Services Region in which you call this operation. You can then call GetView to retrieve the
details of that view.

"""
function get_default_view(; aws_config::AbstractAWSConfig=current_aws_config())
    return resource_explorer_2(
        "POST", "/GetDefaultView"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_default_view(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resource_explorer_2(
        "POST",
        "/GetDefaultView",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_index()
    get_index(params::Dict{String,<:Any})

Retrieves details about the Amazon Web Services Resource Explorer index in the Amazon Web
Services Region in which you invoked the operation.

"""
function get_index(; aws_config::AbstractAWSConfig=current_aws_config())
    return resource_explorer_2(
        "POST", "/GetIndex"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_index(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resource_explorer_2(
        "POST", "/GetIndex", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_view(view_arn)
    get_view(view_arn, params::Dict{String,<:Any})

Retrieves details of the specified view.

# Arguments
- `view_arn`: The Amazon resource name (ARN) of the view that you want information about.

"""
function get_view(ViewArn; aws_config::AbstractAWSConfig=current_aws_config())
    return resource_explorer_2(
        "POST",
        "/GetView",
        Dict{String,Any}("ViewArn" => ViewArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_view(
    ViewArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return resource_explorer_2(
        "POST",
        "/GetView",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("ViewArn" => ViewArn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_indexes()
    list_indexes(params::Dict{String,<:Any})

Retrieves a list of all of the indexes in Amazon Web Services Regions that are currently
collecting resource information for Amazon Web Services Resource Explorer.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results that you want included on each page of the
  response. If you do not include this parameter, it defaults to a value appropriate to the
  operation. If additional items exist beyond those included in the current response, the
  NextToken response element is present and has a value (is not null). Include that value as
  the NextToken request parameter in the next call to the operation to get the next part of
  the results.  An API operation can return fewer results than the maximum even when there
  are more results available. You should check NextToken after every operation to ensure that
  you receive all of the results.
- `"NextToken"`: The parameter for receiving additional results if you receive a NextToken
  response in a previous request. A NextToken response indicates that more output is
  available. Set this parameter to the value of the previous call's NextToken response to
  indicate where the output should continue from. The pagination tokens expire after 24 hours.
- `"Regions"`: If specified, limits the response to only information about the index in the
  specified list of Amazon Web Services Regions.
- `"Type"`: If specified, limits the output to only indexes of the specified Type, either
  LOCAL or AGGREGATOR. Use this option to discover the aggregator index for your account.
"""
function list_indexes(; aws_config::AbstractAWSConfig=current_aws_config())
    return resource_explorer_2(
        "POST", "/ListIndexes"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_indexes(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resource_explorer_2(
        "POST",
        "/ListIndexes",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_indexes_for_members(account_id_list)
    list_indexes_for_members(account_id_list, params::Dict{String,<:Any})

Retrieves a list of a member's indexes in all Amazon Web Services Regions that are
currently collecting resource information for Amazon Web Services Resource Explorer. Only
the management account or a delegated administrator with service access enabled can invoke
this API call.

# Arguments
- `account_id_list`: The account IDs will limit the output to only indexes from these
  accounts.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results that you want included on each page of the
  response. If you do not include this parameter, it defaults to a value appropriate to the
  operation. If additional items exist beyond those included in the current response, the
  NextToken response element is present and has a value (is not null). Include that value as
  the NextToken request parameter in the next call to the operation to get the next part of
  the results.  An API operation can return fewer results than the maximum even when there
  are more results available. You should check NextToken after every operation to ensure that
  you receive all of the results.
- `"NextToken"`: The parameter for receiving additional results if you receive a NextToken
  response in a previous request. A NextToken response indicates that more output is
  available. Set this parameter to the value of the previous call's NextToken response to
  indicate where the output should continue from. The pagination tokens expire after 24 hours.
"""
function list_indexes_for_members(
    AccountIdList; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resource_explorer_2(
        "POST",
        "/ListIndexesForMembers",
        Dict{String,Any}("AccountIdList" => AccountIdList);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_indexes_for_members(
    AccountIdList,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return resource_explorer_2(
        "POST",
        "/ListIndexesForMembers",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AccountIdList" => AccountIdList), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_supported_resource_types()
    list_supported_resource_types(params::Dict{String,<:Any})

Retrieves a list of all resource types currently supported by Amazon Web Services Resource
Explorer.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results that you want included on each page of the
  response. If you do not include this parameter, it defaults to a value appropriate to the
  operation. If additional items exist beyond those included in the current response, the
  NextToken response element is present and has a value (is not null). Include that value as
  the NextToken request parameter in the next call to the operation to get the next part of
  the results.  An API operation can return fewer results than the maximum even when there
  are more results available. You should check NextToken after every operation to ensure that
  you receive all of the results.
- `"NextToken"`: The parameter for receiving additional results if you receive a NextToken
  response in a previous request. A NextToken response indicates that more output is
  available. Set this parameter to the value of the previous call's NextToken response to
  indicate where the output should continue from. The pagination tokens expire after 24 hours.
"""
function list_supported_resource_types(; aws_config::AbstractAWSConfig=current_aws_config())
    return resource_explorer_2(
        "POST",
        "/ListSupportedResourceTypes";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_supported_resource_types(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resource_explorer_2(
        "POST",
        "/ListSupportedResourceTypes",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists the tags that are attached to the specified resource.

# Arguments
- `resource_arn`: The Amazon resource name (ARN) of the view or index that you want to
  attach tags to.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resource_explorer_2(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return resource_explorer_2(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_views()
    list_views(params::Dict{String,<:Any})

Lists the Amazon resource names (ARNs) of the views available in the Amazon Web Services
Region in which you call this operation.  Always check the NextToken response parameter for
a null value when calling a paginated operation. These operations can occasionally return
an empty set of results even when there are more results available. The NextToken response
parameter value is null only when there are no more results to display.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results that you want included on each page of the
  response. If you do not include this parameter, it defaults to a value appropriate to the
  operation. If additional items exist beyond those included in the current response, the
  NextToken response element is present and has a value (is not null). Include that value as
  the NextToken request parameter in the next call to the operation to get the next part of
  the results.  An API operation can return fewer results than the maximum even when there
  are more results available. You should check NextToken after every operation to ensure that
  you receive all of the results.
- `"NextToken"`: The parameter for receiving additional results if you receive a NextToken
  response in a previous request. A NextToken response indicates that more output is
  available. Set this parameter to the value of the previous call's NextToken response to
  indicate where the output should continue from. The pagination tokens expire after 24 hours.
"""
function list_views(; aws_config::AbstractAWSConfig=current_aws_config())
    return resource_explorer_2(
        "POST", "/ListViews"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_views(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resource_explorer_2(
        "POST", "/ListViews", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    search(query_string)
    search(query_string, params::Dict{String,<:Any})

Searches for resources and displays details about all resources that match the specified
criteria. You must specify a query string. All search queries must use a view. If you don't
explicitly specify a view, then Amazon Web Services Resource Explorer uses the default view
for the Amazon Web Services Region in which you call this operation. The results are the
logical intersection of the results that match both the QueryString parameter supplied to
this operation and the SearchFilter parameter attached to the view. For the complete syntax
supported by the QueryString parameter, see Search query syntax reference for Resource
Explorer. If your search results are empty, or are missing results that you think should be
there, see Troubleshooting Resource Explorer search.

# Arguments
- `query_string`: A string that includes keywords and filters that specify the resources
  that you want to include in the results. For the complete syntax supported by the
  QueryString parameter, see Search query syntax reference for Resource Explorer. The search
  is completely case insensitive. You can specify an empty string to return all results up to
  the limit of 1,000 total results.  The operation can return only the first 1,000 results.
  If the resource you want is not included, then use a different value for QueryString to
  refine the results.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results that you want included on each page of the
  response. If you do not include this parameter, it defaults to a value appropriate to the
  operation. If additional items exist beyond those included in the current response, the
  NextToken response element is present and has a value (is not null). Include that value as
  the NextToken request parameter in the next call to the operation to get the next part of
  the results.  An API operation can return fewer results than the maximum even when there
  are more results available. You should check NextToken after every operation to ensure that
  you receive all of the results.
- `"NextToken"`: The parameter for receiving additional results if you receive a NextToken
  response in a previous request. A NextToken response indicates that more output is
  available. Set this parameter to the value of the previous call's NextToken response to
  indicate where the output should continue from. The pagination tokens expire after 24 hours.
- `"ViewArn"`: Specifies the Amazon resource name (ARN) of the view to use for the query.
  If you don't specify a value for this parameter, then the operation automatically uses the
  default view for the Amazon Web Services Region in which you called this operation. If the
  Region either doesn't have a default view or if you don't have permission to use the
  default view, then the operation fails with a 401 Unauthorized exception.
"""
function search(QueryString; aws_config::AbstractAWSConfig=current_aws_config())
    return resource_explorer_2(
        "POST",
        "/Search",
        Dict{String,Any}("QueryString" => QueryString);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function search(
    QueryString,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return resource_explorer_2(
        "POST",
        "/Search",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("QueryString" => QueryString), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn)
    tag_resource(resource_arn, params::Dict{String,<:Any})

Adds one or more tag key and value pairs to an Amazon Web Services Resource Explorer view
or index.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the view or index that you want to
  attach tags to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: A list of tag key and value pairs that you want to attach to the specified view
  or index.
"""
function tag_resource(resourceArn; aws_config::AbstractAWSConfig=current_aws_config())
    return resource_explorer_2(
        "POST",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return resource_explorer_2(
        "POST",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes one or more tag key and value pairs from an Amazon Web Services Resource Explorer
view or index.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the view or index that you want to
  remove tags from.
- `tag_keys`: A list of the keys for the tags that you want to remove from the specified
  view or index.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resource_explorer_2(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return resource_explorer_2(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_index_type(arn, type)
    update_index_type(arn, type, params::Dict{String,<:Any})

Changes the type of the index from one of the following types to the other. For more
information about indexes and the role they perform in Amazon Web Services Resource
Explorer, see Turning on cross-Region search by creating an aggregator index in the Amazon
Web Services Resource Explorer User Guide.     AGGREGATOR index type  The index contains
information about resources from all Amazon Web Services Regions in the Amazon Web Services
account in which you've created a Resource Explorer index. Resource information from all
other Regions is replicated to this Region's index. When you change the index type to
AGGREGATOR, Resource Explorer turns on replication of all discovered resource information
from the other Amazon Web Services Regions in your account to this index. You can then,
from this Region only, perform resource search queries that span all Amazon Web Services
Regions in the Amazon Web Services account. Turning on replication from all other Regions
is performed by asynchronous background tasks. You can check the status of the asynchronous
tasks by using the GetIndex operation. When the asynchronous tasks complete, the Status
response of that operation changes from UPDATING to ACTIVE. After that, you can start to
see results from other Amazon Web Services Regions in query results. However, it can take
several hours for replication from all other Regions to complete.  You can have only one
aggregator index per Amazon Web Services account. Before you can promote a different index
to be the aggregator index for the account, you must first demote the existing aggregator
index to type LOCAL.      LOCAL index type  The index contains information about resources
in only the Amazon Web Services Region in which the index exists. If an aggregator index in
another Region exists, then information in this local index is replicated to the aggregator
index. When you change the index type to LOCAL, Resource Explorer turns off the replication
of resource information from all other Amazon Web Services Regions in the Amazon Web
Services account to this Region. The aggregator index remains in the UPDATING state until
all replication with other Regions successfully stops. You can check the status of the
asynchronous task by using the GetIndex operation. When Resource Explorer successfully
stops all replication with other Regions, the Status response of that operation changes
from UPDATING to ACTIVE. Separately, the resource information from other Regions that was
previously stored in the index is deleted within 30 days by another background task. Until
that asynchronous task completes, some results from other Regions can continue to appear in
search results.  After you demote an aggregator index to a local index, you must wait 24
hours before you can promote another index to be the new aggregator index for the account.


# Arguments
- `arn`: The Amazon resource name (ARN) of the index that you want to update.
- `type`: The type of the index. To understand the difference between LOCAL and AGGREGATOR,
  see Turning on cross-Region search in the Amazon Web Services Resource Explorer User Guide.

"""
function update_index_type(Arn, Type; aws_config::AbstractAWSConfig=current_aws_config())
    return resource_explorer_2(
        "POST",
        "/UpdateIndexType",
        Dict{String,Any}("Arn" => Arn, "Type" => Type);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_index_type(
    Arn,
    Type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return resource_explorer_2(
        "POST",
        "/UpdateIndexType",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Arn" => Arn, "Type" => Type), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_view(view_arn)
    update_view(view_arn, params::Dict{String,<:Any})

Modifies some of the details of a view. You can change the filter string and the list of
included properties. You can't change the name of the view.

# Arguments
- `view_arn`: The Amazon resource name (ARN) of the view that you want to modify.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: An array of strings that specify which resources are included in the results
  of queries made using this view. When you use this view in a Search operation, the filter
  string is combined with the search's QueryString parameter using a logical AND operator.
  For information about the supported syntax, see Search query reference for Resource
  Explorer in the Amazon Web Services Resource Explorer User Guide.  This query string in the
  context of this operation supports only filter prefixes with optional operators. It doesn't
  support free-form text. For example, the string region:us* service:ec2 -tag:stage=prod
  includes all Amazon EC2 resources in any Amazon Web Services Region that begins with the
  letters us and is not tagged with a key Stage that has the value prod.
- `"IncludedProperties"`: Specifies optional fields that you want included in search
  results from this view. It is a list of objects that each describe a field to include. The
  default is an empty list, with no optional fields included in the results.
"""
function update_view(ViewArn; aws_config::AbstractAWSConfig=current_aws_config())
    return resource_explorer_2(
        "POST",
        "/UpdateView",
        Dict{String,Any}("ViewArn" => ViewArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_view(
    ViewArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return resource_explorer_2(
        "POST",
        "/UpdateView",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("ViewArn" => ViewArn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: dlm
using AWS.Compat
using AWS.UUIDs

"""
    create_lifecycle_policy(description, execution_role_arn, state)
    create_lifecycle_policy(description, execution_role_arn, state, params::Dict{String,<:Any})

Creates an Amazon Data Lifecycle Manager lifecycle policy. Amazon Data Lifecycle Manager
supports the following policy types:   Custom EBS snapshot policy   Custom EBS-backed AMI
policy   Cross-account copy event policy   Default policy for EBS snapshots   Default
policy for EBS-backed AMIs   For more information, see  Default policies vs custom
policies.  If you create a default policy, you can specify the request parameters either in
the request body, or in the PolicyDetails request structure, but not both.

# Arguments
- `description`: A description of the lifecycle policy. The characters ^[0-9A-Za-z _-]+ are
  supported.
- `execution_role_arn`: The Amazon Resource Name (ARN) of the IAM role used to run the
  operations specified by the lifecycle policy.
- `state`: The activation state of the lifecycle policy after creation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CopyTags"`:  [Default policies only] Indicates whether the policy should copy tags from
  the source resource to the snapshot or AMI. If you do not specify a value, the default is
  false. Default: false
- `"CreateInterval"`:  [Default policies only] Specifies how often the policy should run
  and create snapshots or AMIs. The creation frequency can range from 1 to 7 days. If you do
  not specify a value, the default is 1. Default: 1
- `"CrossRegionCopyTargets"`:  [Default policies only] Specifies destination Regions for
  snapshot or AMI copies. You can specify up to 3 destination Regions. If you do not want to
  create cross-Region copies, omit this parameter.
- `"DefaultPolicy"`:  [Default policies only] Specify the type of default policy to create.
    To create a default policy for EBS snapshots, that creates snapshots of all volumes in
  the Region that do not have recent backups, specify VOLUME.   To create a default policy
  for EBS-backed AMIs, that creates EBS-backed AMIs from all instances in the Region that do
  not have recent backups, specify INSTANCE.
- `"Exclusions"`:  [Default policies only] Specifies exclusion parameters for volumes or
  instances for which you do not want to create snapshots or AMIs. The policy will not create
  snapshots or AMIs for target resources that match any of the specified exclusion parameters.
- `"ExtendDeletion"`:  [Default policies only] Defines the snapshot or AMI retention
  behavior for the policy if the source volume or instance is deleted, or if the policy
  enters the error, disabled, or deleted state. By default (ExtendDeletion=false):   If a
  source resource is deleted, Amazon Data Lifecycle Manager will continue to delete
  previously created snapshots or AMIs, up to but not including the last one, based on the
  specified retention period. If you want Amazon Data Lifecycle Manager to delete all
  snapshots or AMIs, including the last one, specify true.   If a policy enters the error,
  disabled, or deleted state, Amazon Data Lifecycle Manager stops deleting snapshots and
  AMIs. If you want Amazon Data Lifecycle Manager to continue deleting snapshots or AMIs,
  including the last one, if the policy enters one of these states, specify true.   If you
  enable extended deletion (ExtendDeletion=true), you override both default behaviors
  simultaneously. If you do not specify a value, the default is false. Default: false
- `"PolicyDetails"`: The configuration details of the lifecycle policy.  If you create a
  default policy, you can specify the request parameters either in the request body, or in
  the PolicyDetails request structure, but not both.
- `"RetainInterval"`:  [Default policies only] Specifies how long the policy should retain
  snapshots or AMIs before deleting them. The retention period can range from 2 to 14 days,
  but it must be greater than the creation frequency to ensure that the policy retains at
  least 1 snapshot or AMI at any given time. If you do not specify a value, the default is 7.
  Default: 7
- `"Tags"`: The tags to apply to the lifecycle policy during creation.
"""
function create_lifecycle_policy(
    Description, ExecutionRoleArn, State; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dlm(
        "POST",
        "/policies",
        Dict{String,Any}(
            "Description" => Description,
            "ExecutionRoleArn" => ExecutionRoleArn,
            "State" => State,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_lifecycle_policy(
    Description,
    ExecutionRoleArn,
    State,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dlm(
        "POST",
        "/policies",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Description" => Description,
                    "ExecutionRoleArn" => ExecutionRoleArn,
                    "State" => State,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_lifecycle_policy(policy_id)
    delete_lifecycle_policy(policy_id, params::Dict{String,<:Any})

Deletes the specified lifecycle policy and halts the automated operations that the policy
specified. For more information about deleting a policy, see Delete lifecycle policies.

# Arguments
- `policy_id`: The identifier of the lifecycle policy.

"""
function delete_lifecycle_policy(
    policyId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dlm(
        "DELETE",
        "/policies/$(policyId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_lifecycle_policy(
    policyId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dlm(
        "DELETE",
        "/policies/$(policyId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_lifecycle_policies()
    get_lifecycle_policies(params::Dict{String,<:Any})

Gets summary information about all or the specified data lifecycle policies. To get
complete information about a policy, use GetLifecyclePolicy.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"defaultPolicyType"`:  [Default policies only] Specifies the type of default policy to
  get. Specify one of the following:    VOLUME - To get only the default policy for EBS
  snapshots    INSTANCE - To get only the default policy for EBS-backed AMIs    ALL - To get
  all default policies
- `"policyIds"`: The identifiers of the data lifecycle policies.
- `"resourceTypes"`: The resource type.
- `"state"`: The activation state.
- `"tagsToAdd"`: The tags to add to objects created by the policy. Tags are strings in the
  format key=value. These user-defined tags are added in addition to the Amazon Web
  Services-added lifecycle tags.
- `"targetTags"`: The target tag for a policy. Tags are strings in the format key=value.
"""
function get_lifecycle_policies(; aws_config::AbstractAWSConfig=current_aws_config())
    return dlm("GET", "/policies"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function get_lifecycle_policies(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dlm(
        "GET", "/policies", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_lifecycle_policy(policy_id)
    get_lifecycle_policy(policy_id, params::Dict{String,<:Any})

Gets detailed information about the specified lifecycle policy.

# Arguments
- `policy_id`: The identifier of the lifecycle policy.

"""
function get_lifecycle_policy(policyId; aws_config::AbstractAWSConfig=current_aws_config())
    return dlm(
        "GET",
        "/policies/$(policyId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_lifecycle_policy(
    policyId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dlm(
        "GET",
        "/policies/$(policyId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists the tags for the specified resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dlm(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dlm(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(tags, resource_arn)
    tag_resource(tags, resource_arn, params::Dict{String,<:Any})

Adds the specified tags to the specified resource.

# Arguments
- `tags`: One or more tags.
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.

"""
function tag_resource(Tags, resourceArn; aws_config::AbstractAWSConfig=current_aws_config())
    return dlm(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    Tags,
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dlm(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Tags" => Tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes the specified tags from the specified resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.
- `tag_keys`: The tag keys.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dlm(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dlm(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_lifecycle_policy(policy_id)
    update_lifecycle_policy(policy_id, params::Dict{String,<:Any})

Updates the specified lifecycle policy. For more information about updating a policy, see
Modify lifecycle policies.

# Arguments
- `policy_id`: The identifier of the lifecycle policy.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CopyTags"`:  [Default policies only] Indicates whether the policy should copy tags from
  the source resource to the snapshot or AMI.
- `"CreateInterval"`:  [Default policies only] Specifies how often the policy should run
  and create snapshots or AMIs. The creation frequency can range from 1 to 7 days.
- `"CrossRegionCopyTargets"`:  [Default policies only] Specifies destination Regions for
  snapshot or AMI copies. You can specify up to 3 destination Regions. If you do not want to
  create cross-Region copies, omit this parameter.
- `"Description"`: A description of the lifecycle policy.
- `"Exclusions"`:  [Default policies only] Specifies exclusion parameters for volumes or
  instances for which you do not want to create snapshots or AMIs. The policy will not create
  snapshots or AMIs for target resources that match any of the specified exclusion parameters.
- `"ExecutionRoleArn"`: The Amazon Resource Name (ARN) of the IAM role used to run the
  operations specified by the lifecycle policy.
- `"ExtendDeletion"`:  [Default policies only] Defines the snapshot or AMI retention
  behavior for the policy if the source volume or instance is deleted, or if the policy
  enters the error, disabled, or deleted state. By default (ExtendDeletion=false):   If a
  source resource is deleted, Amazon Data Lifecycle Manager will continue to delete
  previously created snapshots or AMIs, up to but not including the last one, based on the
  specified retention period. If you want Amazon Data Lifecycle Manager to delete all
  snapshots or AMIs, including the last one, specify true.   If a policy enters the error,
  disabled, or deleted state, Amazon Data Lifecycle Manager stops deleting snapshots and
  AMIs. If you want Amazon Data Lifecycle Manager to continue deleting snapshots or AMIs,
  including the last one, if the policy enters one of these states, specify true.   If you
  enable extended deletion (ExtendDeletion=true), you override both default behaviors
  simultaneously. Default: false
- `"PolicyDetails"`: The configuration of the lifecycle policy. You cannot update the
  policy type or the resource type.
- `"RetainInterval"`:  [Default policies only] Specifies how long the policy should retain
  snapshots or AMIs before deleting them. The retention period can range from 2 to 14 days,
  but it must be greater than the creation frequency to ensure that the policy retains at
  least 1 snapshot or AMI at any given time.
- `"State"`: The desired activation state of the lifecycle policy after creation.
"""
function update_lifecycle_policy(
    policyId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dlm(
        "PATCH",
        "/policies/$(policyId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_lifecycle_policy(
    policyId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dlm(
        "PATCH",
        "/policies/$(policyId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: rolesanywhere
using AWS.Compat
using AWS.UUIDs

"""
    create_profile(name, role_arns)
    create_profile(name, role_arns, params::Dict{String,<:Any})

Creates a profile, a list of the roles that Roles Anywhere service is trusted to assume.
You use profiles to intersect permissions with IAM managed policies.  Required permissions:
 rolesanywhere:CreateProfile.

# Arguments
- `name`: The name of the profile.
- `role_arns`: A list of IAM roles that this profile can assume in a temporary credential
  request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"durationSeconds"`:  Used to determine how long sessions vended using this profile are
  valid for. See the Expiration section of the CreateSession API documentation page for more
  details. In requests, if this value is not provided, the default value will be 3600.
- `"enabled"`: Specifies whether the profile is enabled.
- `"managedPolicyArns"`: A list of managed policy ARNs that apply to the vended session
  credentials.
- `"requireInstanceProperties"`: Specifies whether instance properties are required in
  temporary credential requests with this profile.
- `"sessionPolicy"`: A session policy that applies to the trust boundary of the vended
  session credentials.
- `"tags"`: The tags to attach to the profile.
"""
function create_profile(name, roleArns; aws_config::AbstractAWSConfig=current_aws_config())
    return rolesanywhere(
        "POST",
        "/profiles",
        Dict{String,Any}("name" => name, "roleArns" => roleArns);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_profile(
    name,
    roleArns,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rolesanywhere(
        "POST",
        "/profiles",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("name" => name, "roleArns" => roleArns), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_trust_anchor(name, source)
    create_trust_anchor(name, source, params::Dict{String,<:Any})

Creates a trust anchor to establish trust between IAM Roles Anywhere and your certificate
authority (CA). You can define a trust anchor as a reference to an Private Certificate
Authority (Private CA) or by uploading a CA certificate. Your Amazon Web Services workloads
can authenticate with the trust anchor using certificates issued by the CA in exchange for
temporary Amazon Web Services credentials.  Required permissions:
rolesanywhere:CreateTrustAnchor.

# Arguments
- `name`: The name of the trust anchor.
- `source`: The trust anchor type and its related certificate data.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"enabled"`: Specifies whether the trust anchor is enabled.
- `"notificationSettings"`: A list of notification settings to be associated to the trust
  anchor.
- `"tags"`: The tags to attach to the trust anchor.
"""
function create_trust_anchor(
    name, source; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rolesanywhere(
        "POST",
        "/trustanchors",
        Dict{String,Any}("name" => name, "source" => source);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_trust_anchor(
    name,
    source,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rolesanywhere(
        "POST",
        "/trustanchors",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("name" => name, "source" => source), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_attribute_mapping(certificate_field, profile_id)
    delete_attribute_mapping(certificate_field, profile_id, params::Dict{String,<:Any})

Delete an entry from the attribute mapping rules enforced by a given profile.

# Arguments
- `certificate_field`: Fields (x509Subject, x509Issuer and x509SAN) within X.509
  certificates.
- `profile_id`: The unique identifier of the profile.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"specifiers"`: A list of specifiers of a certificate field; for example, CN, OU, UID
  from a Subject.
"""
function delete_attribute_mapping(
    certificateField, profileId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rolesanywhere(
        "DELETE",
        "/profiles/$(profileId)/mappings",
        Dict{String,Any}("certificateField" => certificateField);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_attribute_mapping(
    certificateField,
    profileId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rolesanywhere(
        "DELETE",
        "/profiles/$(profileId)/mappings",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("certificateField" => certificateField), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_crl(crl_id)
    delete_crl(crl_id, params::Dict{String,<:Any})

Deletes a certificate revocation list (CRL).  Required permissions:
rolesanywhere:DeleteCrl.

# Arguments
- `crl_id`: The unique identifier of the certificate revocation list (CRL).

"""
function delete_crl(crlId; aws_config::AbstractAWSConfig=current_aws_config())
    return rolesanywhere(
        "DELETE", "/crl/$(crlId)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function delete_crl(
    crlId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rolesanywhere(
        "DELETE",
        "/crl/$(crlId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_profile(profile_id)
    delete_profile(profile_id, params::Dict{String,<:Any})

Deletes a profile.  Required permissions:  rolesanywhere:DeleteProfile.

# Arguments
- `profile_id`: The unique identifier of the profile.

"""
function delete_profile(profileId; aws_config::AbstractAWSConfig=current_aws_config())
    return rolesanywhere(
        "DELETE",
        "/profile/$(profileId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_profile(
    profileId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rolesanywhere(
        "DELETE",
        "/profile/$(profileId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_trust_anchor(trust_anchor_id)
    delete_trust_anchor(trust_anchor_id, params::Dict{String,<:Any})

Deletes a trust anchor.  Required permissions:  rolesanywhere:DeleteTrustAnchor.

# Arguments
- `trust_anchor_id`: The unique identifier of the trust anchor.

"""
function delete_trust_anchor(
    trustAnchorId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rolesanywhere(
        "DELETE",
        "/trustanchor/$(trustAnchorId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_trust_anchor(
    trustAnchorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rolesanywhere(
        "DELETE",
        "/trustanchor/$(trustAnchorId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disable_crl(crl_id)
    disable_crl(crl_id, params::Dict{String,<:Any})

Disables a certificate revocation list (CRL).  Required permissions:
rolesanywhere:DisableCrl.

# Arguments
- `crl_id`: The unique identifier of the certificate revocation list (CRL).

"""
function disable_crl(crlId; aws_config::AbstractAWSConfig=current_aws_config())
    return rolesanywhere(
        "POST",
        "/crl/$(crlId)/disable";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disable_crl(
    crlId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rolesanywhere(
        "POST",
        "/crl/$(crlId)/disable",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disable_profile(profile_id)
    disable_profile(profile_id, params::Dict{String,<:Any})

Disables a profile. When disabled, temporary credential requests with this profile fail.
Required permissions:  rolesanywhere:DisableProfile.

# Arguments
- `profile_id`: The unique identifier of the profile.

"""
function disable_profile(profileId; aws_config::AbstractAWSConfig=current_aws_config())
    return rolesanywhere(
        "POST",
        "/profile/$(profileId)/disable";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disable_profile(
    profileId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rolesanywhere(
        "POST",
        "/profile/$(profileId)/disable",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disable_trust_anchor(trust_anchor_id)
    disable_trust_anchor(trust_anchor_id, params::Dict{String,<:Any})

Disables a trust anchor. When disabled, temporary credential requests specifying this trust
anchor are unauthorized.  Required permissions:  rolesanywhere:DisableTrustAnchor.

# Arguments
- `trust_anchor_id`: The unique identifier of the trust anchor.

"""
function disable_trust_anchor(
    trustAnchorId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rolesanywhere(
        "POST",
        "/trustanchor/$(trustAnchorId)/disable";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disable_trust_anchor(
    trustAnchorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rolesanywhere(
        "POST",
        "/trustanchor/$(trustAnchorId)/disable",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    enable_crl(crl_id)
    enable_crl(crl_id, params::Dict{String,<:Any})

Enables a certificate revocation list (CRL). When enabled, certificates stored in the CRL
are unauthorized to receive session credentials.  Required permissions:
rolesanywhere:EnableCrl.

# Arguments
- `crl_id`: The unique identifier of the certificate revocation list (CRL).

"""
function enable_crl(crlId; aws_config::AbstractAWSConfig=current_aws_config())
    return rolesanywhere(
        "POST",
        "/crl/$(crlId)/enable";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function enable_crl(
    crlId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rolesanywhere(
        "POST",
        "/crl/$(crlId)/enable",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    enable_profile(profile_id)
    enable_profile(profile_id, params::Dict{String,<:Any})

Enables temporary credential requests for a profile.   Required permissions:
rolesanywhere:EnableProfile.

# Arguments
- `profile_id`: The unique identifier of the profile.

"""
function enable_profile(profileId; aws_config::AbstractAWSConfig=current_aws_config())
    return rolesanywhere(
        "POST",
        "/profile/$(profileId)/enable";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function enable_profile(
    profileId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rolesanywhere(
        "POST",
        "/profile/$(profileId)/enable",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    enable_trust_anchor(trust_anchor_id)
    enable_trust_anchor(trust_anchor_id, params::Dict{String,<:Any})

Enables a trust anchor. When enabled, certificates in the trust anchor chain are authorized
for trust validation.   Required permissions:  rolesanywhere:EnableTrustAnchor.

# Arguments
- `trust_anchor_id`: The unique identifier of the trust anchor.

"""
function enable_trust_anchor(
    trustAnchorId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rolesanywhere(
        "POST",
        "/trustanchor/$(trustAnchorId)/enable";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function enable_trust_anchor(
    trustAnchorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rolesanywhere(
        "POST",
        "/trustanchor/$(trustAnchorId)/enable",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_crl(crl_id)
    get_crl(crl_id, params::Dict{String,<:Any})

Gets a certificate revocation list (CRL).  Required permissions:  rolesanywhere:GetCrl.

# Arguments
- `crl_id`: The unique identifier of the certificate revocation list (CRL).

"""
function get_crl(crlId; aws_config::AbstractAWSConfig=current_aws_config())
    return rolesanywhere(
        "GET", "/crl/$(crlId)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_crl(
    crlId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rolesanywhere(
        "GET",
        "/crl/$(crlId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_profile(profile_id)
    get_profile(profile_id, params::Dict{String,<:Any})

Gets a profile.  Required permissions:  rolesanywhere:GetProfile.

# Arguments
- `profile_id`: The unique identifier of the profile.

"""
function get_profile(profileId; aws_config::AbstractAWSConfig=current_aws_config())
    return rolesanywhere(
        "GET",
        "/profile/$(profileId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_profile(
    profileId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rolesanywhere(
        "GET",
        "/profile/$(profileId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_subject(subject_id)
    get_subject(subject_id, params::Dict{String,<:Any})

Gets a subject, which associates a certificate identity with authentication attempts. The
subject stores auditing information such as the status of the last authentication attempt,
the certificate data used in the attempt, and the last time the associated identity
attempted authentication.   Required permissions:  rolesanywhere:GetSubject.

# Arguments
- `subject_id`: The unique identifier of the subject.

"""
function get_subject(subjectId; aws_config::AbstractAWSConfig=current_aws_config())
    return rolesanywhere(
        "GET",
        "/subject/$(subjectId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_subject(
    subjectId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rolesanywhere(
        "GET",
        "/subject/$(subjectId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_trust_anchor(trust_anchor_id)
    get_trust_anchor(trust_anchor_id, params::Dict{String,<:Any})

Gets a trust anchor.  Required permissions:  rolesanywhere:GetTrustAnchor.

# Arguments
- `trust_anchor_id`: The unique identifier of the trust anchor.

"""
function get_trust_anchor(trustAnchorId; aws_config::AbstractAWSConfig=current_aws_config())
    return rolesanywhere(
        "GET",
        "/trustanchor/$(trustAnchorId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_trust_anchor(
    trustAnchorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rolesanywhere(
        "GET",
        "/trustanchor/$(trustAnchorId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    import_crl(crl_data, name, trust_anchor_arn)
    import_crl(crl_data, name, trust_anchor_arn, params::Dict{String,<:Any})

Imports the certificate revocation list (CRL). A CRL is a list of certificates that have
been revoked by the issuing certificate Authority (CA).In order to be properly imported, a
CRL must be in PEM format. IAM Roles Anywhere validates against the CRL before issuing
credentials.   Required permissions:  rolesanywhere:ImportCrl.

# Arguments
- `crl_data`: The x509 v3 specified certificate revocation list (CRL).
- `name`: The name of the certificate revocation list (CRL).
- `trust_anchor_arn`: The ARN of the TrustAnchor the certificate revocation list (CRL) will
  provide revocation for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"enabled"`: Specifies whether the certificate revocation list (CRL) is enabled.
- `"tags"`: A list of tags to attach to the certificate revocation list (CRL).
"""
function import_crl(
    crlData, name, trustAnchorArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rolesanywhere(
        "POST",
        "/crls",
        Dict{String,Any}(
            "crlData" => crlData, "name" => name, "trustAnchorArn" => trustAnchorArn
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function import_crl(
    crlData,
    name,
    trustAnchorArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rolesanywhere(
        "POST",
        "/crls",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "crlData" => crlData, "name" => name, "trustAnchorArn" => trustAnchorArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_crls()
    list_crls(params::Dict{String,<:Any})

Lists all certificate revocation lists (CRL) in the authenticated account and Amazon Web
Services Region.  Required permissions:  rolesanywhere:ListCrls.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: A token that indicates where the output should continue from, if a
  previous request did not show all results. To get the next results, make the request again
  with this value.
- `"pageSize"`: The number of resources in the paginated list.
"""
function list_crls(; aws_config::AbstractAWSConfig=current_aws_config())
    return rolesanywhere(
        "GET", "/crls"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_crls(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rolesanywhere(
        "GET", "/crls", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_profiles()
    list_profiles(params::Dict{String,<:Any})

Lists all profiles in the authenticated account and Amazon Web Services Region.  Required
permissions:  rolesanywhere:ListProfiles.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: A token that indicates where the output should continue from, if a
  previous request did not show all results. To get the next results, make the request again
  with this value.
- `"pageSize"`: The number of resources in the paginated list.
"""
function list_profiles(; aws_config::AbstractAWSConfig=current_aws_config())
    return rolesanywhere(
        "GET", "/profiles"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_profiles(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rolesanywhere(
        "GET", "/profiles", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_subjects()
    list_subjects(params::Dict{String,<:Any})

Lists the subjects in the authenticated account and Amazon Web Services Region.  Required
permissions:  rolesanywhere:ListSubjects.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: A token that indicates where the output should continue from, if a
  previous request did not show all results. To get the next results, make the request again
  with this value.
- `"pageSize"`: The number of resources in the paginated list.
"""
function list_subjects(; aws_config::AbstractAWSConfig=current_aws_config())
    return rolesanywhere(
        "GET", "/subjects"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_subjects(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rolesanywhere(
        "GET", "/subjects", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists the tags attached to the resource.  Required permissions:
rolesanywhere:ListTagsForResource.

# Arguments
- `resource_arn`: The ARN of the resource.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rolesanywhere(
        "GET",
        "/ListTagsForResource",
        Dict{String,Any}("resourceArn" => resourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rolesanywhere(
        "GET",
        "/ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceArn" => resourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_trust_anchors()
    list_trust_anchors(params::Dict{String,<:Any})

Lists the trust anchors in the authenticated account and Amazon Web Services Region.
Required permissions:  rolesanywhere:ListTrustAnchors.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: A token that indicates where the output should continue from, if a
  previous request did not show all results. To get the next results, make the request again
  with this value.
- `"pageSize"`: The number of resources in the paginated list.
"""
function list_trust_anchors(; aws_config::AbstractAWSConfig=current_aws_config())
    return rolesanywhere(
        "GET", "/trustanchors"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_trust_anchors(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rolesanywhere(
        "GET",
        "/trustanchors",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_attribute_mapping(certificate_field, mapping_rules, profile_id)
    put_attribute_mapping(certificate_field, mapping_rules, profile_id, params::Dict{String,<:Any})

Put an entry in the attribute mapping rules that will be enforced by a given profile. A
mapping specifies a certificate field and one or more specifiers that have contextual
meanings.

# Arguments
- `certificate_field`: Fields (x509Subject, x509Issuer and x509SAN) within X.509
  certificates.
- `mapping_rules`: A list of mapping entries for every supported specifier or sub-field.
- `profile_id`: The unique identifier of the profile.

"""
function put_attribute_mapping(
    certificateField,
    mappingRules,
    profileId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rolesanywhere(
        "PUT",
        "/profiles/$(profileId)/mappings",
        Dict{String,Any}(
            "certificateField" => certificateField, "mappingRules" => mappingRules
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_attribute_mapping(
    certificateField,
    mappingRules,
    profileId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rolesanywhere(
        "PUT",
        "/profiles/$(profileId)/mappings",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "certificateField" => certificateField, "mappingRules" => mappingRules
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_notification_settings(notification_settings, trust_anchor_id)
    put_notification_settings(notification_settings, trust_anchor_id, params::Dict{String,<:Any})

Attaches a list of notification settings to a trust anchor. A notification setting includes
information such as event name, threshold, status of the notification setting, and the
channel to notify.  Required permissions:  rolesanywhere:PutNotificationSettings.

# Arguments
- `notification_settings`: A list of notification settings to be associated to the trust
  anchor.
- `trust_anchor_id`: The unique identifier of the trust anchor.

"""
function put_notification_settings(
    notificationSettings, trustAnchorId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rolesanywhere(
        "PATCH",
        "/put-notifications-settings",
        Dict{String,Any}(
            "notificationSettings" => notificationSettings, "trustAnchorId" => trustAnchorId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_notification_settings(
    notificationSettings,
    trustAnchorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rolesanywhere(
        "PATCH",
        "/put-notifications-settings",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "notificationSettings" => notificationSettings,
                    "trustAnchorId" => trustAnchorId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    reset_notification_settings(notification_setting_keys, trust_anchor_id)
    reset_notification_settings(notification_setting_keys, trust_anchor_id, params::Dict{String,<:Any})

Resets the custom notification setting to IAM Roles Anywhere default setting.   Required
permissions:  rolesanywhere:ResetNotificationSettings.

# Arguments
- `notification_setting_keys`: A list of notification setting keys to reset. A notification
  setting key includes the event and the channel.
- `trust_anchor_id`: The unique identifier of the trust anchor.

"""
function reset_notification_settings(
    notificationSettingKeys,
    trustAnchorId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rolesanywhere(
        "PATCH",
        "/reset-notifications-settings",
        Dict{String,Any}(
            "notificationSettingKeys" => notificationSettingKeys,
            "trustAnchorId" => trustAnchorId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function reset_notification_settings(
    notificationSettingKeys,
    trustAnchorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rolesanywhere(
        "PATCH",
        "/reset-notifications-settings",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "notificationSettingKeys" => notificationSettingKeys,
                    "trustAnchorId" => trustAnchorId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Attaches tags to a resource.  Required permissions:  rolesanywhere:TagResource.

# Arguments
- `resource_arn`: The ARN of the resource.
- `tags`: The tags to attach to the resource.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return rolesanywhere(
        "POST",
        "/TagResource",
        Dict{String,Any}("resourceArn" => resourceArn, "tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rolesanywhere(
        "POST",
        "/TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceArn" => resourceArn, "tags" => tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes tags from the resource.  Required permissions:  rolesanywhere:UntagResource.

# Arguments
- `resource_arn`: The ARN of the resource.
- `tag_keys`: A list of keys. Tag keys are the unique identifiers of tags.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rolesanywhere(
        "POST",
        "/UntagResource",
        Dict{String,Any}("resourceArn" => resourceArn, "tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rolesanywhere(
        "POST",
        "/UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceArn" => resourceArn, "tagKeys" => tagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_crl(crl_id)
    update_crl(crl_id, params::Dict{String,<:Any})

Updates the certificate revocation list (CRL). A CRL is a list of certificates that have
been revoked by the issuing certificate authority (CA). IAM Roles Anywhere validates
against the CRL before issuing credentials.  Required permissions:
rolesanywhere:UpdateCrl.

# Arguments
- `crl_id`: The unique identifier of the certificate revocation list (CRL).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"crlData"`: The x509 v3 specified certificate revocation list (CRL).
- `"name"`: The name of the Crl.
"""
function update_crl(crlId; aws_config::AbstractAWSConfig=current_aws_config())
    return rolesanywhere(
        "PATCH", "/crl/$(crlId)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function update_crl(
    crlId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rolesanywhere(
        "PATCH",
        "/crl/$(crlId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_profile(profile_id)
    update_profile(profile_id, params::Dict{String,<:Any})

Updates a profile, a list of the roles that IAM Roles Anywhere service is trusted to
assume. You use profiles to intersect permissions with IAM managed policies.  Required
permissions:  rolesanywhere:UpdateProfile.

# Arguments
- `profile_id`: The unique identifier of the profile.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"durationSeconds"`:  Used to determine how long sessions vended using this profile are
  valid for. See the Expiration section of the CreateSession API documentation page for more
  details. In requests, if this value is not provided, the default value will be 3600.
- `"managedPolicyArns"`: A list of managed policy ARNs that apply to the vended session
  credentials.
- `"name"`: The name of the profile.
- `"roleArns"`: A list of IAM roles that this profile can assume in a temporary credential
  request.
- `"sessionPolicy"`: A session policy that applies to the trust boundary of the vended
  session credentials.
"""
function update_profile(profileId; aws_config::AbstractAWSConfig=current_aws_config())
    return rolesanywhere(
        "PATCH",
        "/profile/$(profileId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_profile(
    profileId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rolesanywhere(
        "PATCH",
        "/profile/$(profileId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_trust_anchor(trust_anchor_id)
    update_trust_anchor(trust_anchor_id, params::Dict{String,<:Any})

Updates a trust anchor. You establish trust between IAM Roles Anywhere and your certificate
authority (CA) by configuring a trust anchor. You can define a trust anchor as a reference
to an Private Certificate Authority (Private CA) or by uploading a CA certificate. Your
Amazon Web Services workloads can authenticate with the trust anchor using certificates
issued by the CA in exchange for temporary Amazon Web Services credentials.  Required
permissions:  rolesanywhere:UpdateTrustAnchor.

# Arguments
- `trust_anchor_id`: The unique identifier of the trust anchor.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"name"`: The name of the trust anchor.
- `"source"`: The trust anchor type and its related certificate data.
"""
function update_trust_anchor(
    trustAnchorId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rolesanywhere(
        "PATCH",
        "/trustanchor/$(trustAnchorId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_trust_anchor(
    trustAnchorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rolesanywhere(
        "PATCH",
        "/trustanchor/$(trustAnchorId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function _now_formatted()
    return lowercase(Dates.format(now(Dates.UTC), dateformat"yyyymmdd\THHMMSSsss\Z"))
end

testset_role(role_name) = "AWS.jl-$role_name"

http_header(h::Dict, k, d="") = get(h, k, d)
http_header(h::Vector, k, d="") = http_header(Dict(h), k, d)
http_header(args...) = HTTP.header(args...)

macro test_ecode(error_codes, expr)
    quote
        try
            $expr
            @test false
        catch e
            if e isa AWSException
                @test e.code in [$error_codes;]
            else
                rethrow(e)
            end
        end
    end
end

function get_assumed_role(aws_config::AbstractAWSConfig=current_aws_config())
    r = AWSServices.sts(
        "GetCallerIdentity";
        aws_config,
        feature_set=AWS.FeatureSet(; use_response_type=true),
    )
    result = parse(r)
    arn = result["GetCallerIdentityResult"]["Arn"]
    m = match(r":assumed-role/(?<role>[^/]+)", arn)
    if m !== nothing
        return m["role"]
    else
        error("Caller Identity ARN is not an assumed role: $arn")
    end
end

get_assumed_role(creds::AWSCredentials) = get_assumed_role(AWSConfig(; creds))

function mfa_user_credentials(config::AbstractAWSConfig)
    r = AWSServices.secrets_manager(
        "GetSecretValue",
        Dict("SecretId" => "AWS.jl-mfa-user-credentials");
        aws_config=config,
        feature_set=AWS.FeatureSet(; use_response_type=true),
    )
    json = JSON.parse(parse(r)["SecretString"])
    mfa_user_creds = AWSCredentials(json["access_key_id"], json["secret_access_key"])
    mfa_user_cfg = AWSConfig(; creds=mfa_user_creds)

    r = AWSServices.secrets_manager(
        "GetSecretValue",
        Dict("SecretId" => "AWS.jl-mfa-user-virtual-mfa-devices");
        aws_config=config,
        feature_set=AWS.FeatureSet(; use_response_type=true),
    )
    json = JSON.parse(parse(r)["SecretString"])
    mfa_devices = [(; mfa_serial=d["mfa_serial"], seed=d["seed"]) for d in json]

    return mfa_user_cfg, mfa_devices
end

struct MinioConfig <: AbstractAWSConfig
    endpoint::String
    region::String
    creds
end
struct SimpleCredentials
    access_key_id::String
    secret_key::String
    token::String
end

AWS.region(c::MinioConfig) = c.region
AWS.credentials(c::MinioConfig) = c.creds
AWS.check_credentials(c::SimpleCredentials) = c

function AWS.generate_service_url(aws::MinioConfig, service::String, resource::String)
    service == "s3" || throw(ArgumentError("Can only handle s3 requests to Minio"))
    return string(aws.endpoint, resource)
end

function gen_ini(content)
    buffer = IOBuffer(content)
    ini = Inifile()
    read(ini, buffer)
    return ini
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: cloudhsm_v2
using AWS.Compat
using AWS.UUIDs

"""
    copy_backup_to_region(backup_id, destination_region)
    copy_backup_to_region(backup_id, destination_region, params::Dict{String,<:Any})

Copy an AWS CloudHSM cluster backup to a different region.

# Arguments
- `backup_id`: The ID of the backup that will be copied to the destination region.
- `destination_region`: The AWS region that will contain your copied CloudHSM cluster
  backup.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"TagList"`: Tags to apply to the destination backup during creation. If you specify
  tags, only these tags will be applied to the destination backup. If you do not specify
  tags, the service copies tags from the source backup to the destination backup.
"""
function copy_backup_to_region(
    BackupId, DestinationRegion; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudhsm_v2(
        "CopyBackupToRegion",
        Dict{String,Any}("BackupId" => BackupId, "DestinationRegion" => DestinationRegion);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function copy_backup_to_region(
    BackupId,
    DestinationRegion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudhsm_v2(
        "CopyBackupToRegion",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "BackupId" => BackupId, "DestinationRegion" => DestinationRegion
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_cluster(hsm_type, subnet_ids)
    create_cluster(hsm_type, subnet_ids, params::Dict{String,<:Any})

Creates a new AWS CloudHSM cluster.

# Arguments
- `hsm_type`: The type of HSM to use in the cluster. The allowed values are hsm1.medium and
  hsm2m.medium.
- `subnet_ids`: The identifiers (IDs) of the subnets where you are creating the cluster.
  You must specify at least one subnet. If you specify multiple subnets, they must meet the
  following criteria:   All subnets must be in the same virtual private cloud (VPC).   You
  can specify only one subnet per Availability Zone.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"BackupRetentionPolicy"`: A policy that defines how the service retains backups.
- `"Mode"`: The mode to use in the cluster. The allowed values are FIPS and NON_FIPS.
- `"SourceBackupId"`: The identifier (ID) of the cluster backup to restore. Use this value
  to restore the cluster from a backup instead of creating a new cluster. To find the backup
  ID, use DescribeBackups.
- `"TagList"`: Tags to apply to the CloudHSM cluster during creation.
"""
function create_cluster(
    HsmType, SubnetIds; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudhsm_v2(
        "CreateCluster",
        Dict{String,Any}("HsmType" => HsmType, "SubnetIds" => SubnetIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_cluster(
    HsmType,
    SubnetIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudhsm_v2(
        "CreateCluster",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("HsmType" => HsmType, "SubnetIds" => SubnetIds),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_hsm(availability_zone, cluster_id)
    create_hsm(availability_zone, cluster_id, params::Dict{String,<:Any})

Creates a new hardware security module (HSM) in the specified AWS CloudHSM cluster.

# Arguments
- `availability_zone`: The Availability Zone where you are creating the HSM. To find the
  cluster's Availability Zones, use DescribeClusters.
- `cluster_id`: The identifier (ID) of the HSM's cluster. To find the cluster ID, use
  DescribeClusters.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"IpAddress"`: The HSM's IP address. If you specify an IP address, use an available
  address from the subnet that maps to the Availability Zone where you are creating the HSM.
  If you don't specify an IP address, one is chosen for you from that subnet.
"""
function create_hsm(
    AvailabilityZone, ClusterId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudhsm_v2(
        "CreateHsm",
        Dict{String,Any}("AvailabilityZone" => AvailabilityZone, "ClusterId" => ClusterId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_hsm(
    AvailabilityZone,
    ClusterId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudhsm_v2(
        "CreateHsm",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AvailabilityZone" => AvailabilityZone, "ClusterId" => ClusterId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_backup(backup_id)
    delete_backup(backup_id, params::Dict{String,<:Any})

Deletes a specified AWS CloudHSM backup. A backup can be restored up to 7 days after the
DeleteBackup request is made. For more information on restoring a backup, see RestoreBackup.

# Arguments
- `backup_id`: The ID of the backup to be deleted. To find the ID of a backup, use the
  DescribeBackups operation.

"""
function delete_backup(BackupId; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudhsm_v2(
        "DeleteBackup",
        Dict{String,Any}("BackupId" => BackupId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_backup(
    BackupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudhsm_v2(
        "DeleteBackup",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("BackupId" => BackupId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_cluster(cluster_id)
    delete_cluster(cluster_id, params::Dict{String,<:Any})

Deletes the specified AWS CloudHSM cluster. Before you can delete a cluster, you must
delete all HSMs in the cluster. To see if the cluster contains any HSMs, use
DescribeClusters. To delete an HSM, use DeleteHsm.

# Arguments
- `cluster_id`: The identifier (ID) of the cluster that you are deleting. To find the
  cluster ID, use DescribeClusters.

"""
function delete_cluster(ClusterId; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudhsm_v2(
        "DeleteCluster",
        Dict{String,Any}("ClusterId" => ClusterId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_cluster(
    ClusterId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudhsm_v2(
        "DeleteCluster",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ClusterId" => ClusterId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_hsm(cluster_id)
    delete_hsm(cluster_id, params::Dict{String,<:Any})

Deletes the specified HSM. To specify an HSM, you can use its identifier (ID), the IP
address of the HSM's elastic network interface (ENI), or the ID of the HSM's ENI. You need
to specify only one of these values. To find these values, use DescribeClusters.

# Arguments
- `cluster_id`: The identifier (ID) of the cluster that contains the HSM that you are
  deleting.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EniId"`: The identifier (ID) of the elastic network interface (ENI) of the HSM that you
  are deleting.
- `"EniIp"`: The IP address of the elastic network interface (ENI) of the HSM that you are
  deleting.
- `"HsmId"`: The identifier (ID) of the HSM that you are deleting.
"""
function delete_hsm(ClusterId; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudhsm_v2(
        "DeleteHsm",
        Dict{String,Any}("ClusterId" => ClusterId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_hsm(
    ClusterId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudhsm_v2(
        "DeleteHsm",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ClusterId" => ClusterId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_backups()
    describe_backups(params::Dict{String,<:Any})

Gets information about backups of AWS CloudHSM clusters. This is a paginated operation,
which means that each response might contain only a subset of all the backups. When the
response contains only a subset of backups, it includes a NextToken value. Use this value
in a subsequent DescribeBackups request to get more backups. When you receive a response
with no NextToken (or an empty or null value), that means there are no more backups to get.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: One or more filters to limit the items returned in the response. Use the
  backupIds filter to return only the specified backups. Specify backups by their backup
  identifier (ID). Use the sourceBackupIds filter to return only the backups created from a
  source backup. The sourceBackupID of a source backup is returned by the CopyBackupToRegion
  operation. Use the clusterIds filter to return only the backups for the specified clusters.
  Specify clusters by their cluster identifier (ID). Use the states filter to return only
  backups that match the specified state. Use the neverExpires filter to return backups
  filtered by the value in the neverExpires parameter. True returns all backups exempt from
  the backup retention policy. False returns all backups with a backup retention policy
  defined at the cluster.
- `"MaxResults"`: The maximum number of backups to return in the response. When there are
  more backups than the number you specify, the response contains a NextToken value.
- `"NextToken"`: The NextToken value that you received in the previous response. Use this
  value to get more backups.
- `"SortAscending"`: Designates whether or not to sort the return backups by ascending
  chronological order of generation.
"""
function describe_backups(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudhsm_v2(
        "DescribeBackups"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_backups(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudhsm_v2(
        "DescribeBackups", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_clusters()
    describe_clusters(params::Dict{String,<:Any})

Gets information about AWS CloudHSM clusters. This is a paginated operation, which means
that each response might contain only a subset of all the clusters. When the response
contains only a subset of clusters, it includes a NextToken value. Use this value in a
subsequent DescribeClusters request to get more clusters. When you receive a response with
no NextToken (or an empty or null value), that means there are no more clusters to get.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: One or more filters to limit the items returned in the response. Use the
  clusterIds filter to return only the specified clusters. Specify clusters by their cluster
  identifier (ID). Use the vpcIds filter to return only the clusters in the specified virtual
  private clouds (VPCs). Specify VPCs by their VPC identifier (ID). Use the states filter to
  return only clusters that match the specified state.
- `"MaxResults"`: The maximum number of clusters to return in the response. When there are
  more clusters than the number you specify, the response contains a NextToken value.
- `"NextToken"`: The NextToken value that you received in the previous response. Use this
  value to get more clusters.
"""
function describe_clusters(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudhsm_v2(
        "DescribeClusters"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_clusters(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudhsm_v2(
        "DescribeClusters", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    initialize_cluster(cluster_id, signed_cert, trust_anchor)
    initialize_cluster(cluster_id, signed_cert, trust_anchor, params::Dict{String,<:Any})

Claims an AWS CloudHSM cluster by submitting the cluster certificate issued by your issuing
certificate authority (CA) and the CA's root certificate. Before you can claim a cluster,
you must sign the cluster's certificate signing request (CSR) with your issuing CA. To get
the cluster's CSR, use DescribeClusters.

# Arguments
- `cluster_id`: The identifier (ID) of the cluster that you are claiming. To find the
  cluster ID, use DescribeClusters.
- `signed_cert`: The cluster certificate issued (signed) by your issuing certificate
  authority (CA). The certificate must be in PEM format and can contain a maximum of 5000
  characters.
- `trust_anchor`: The issuing certificate of the issuing certificate authority (CA) that
  issued (signed) the cluster certificate. You must use a self-signed certificate. The
  certificate used to sign the HSM CSR must be directly available, and thus must be the root
  certificate. The certificate must be in PEM format and can contain a maximum of 5000
  characters.

"""
function initialize_cluster(
    ClusterId, SignedCert, TrustAnchor; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudhsm_v2(
        "InitializeCluster",
        Dict{String,Any}(
            "ClusterId" => ClusterId,
            "SignedCert" => SignedCert,
            "TrustAnchor" => TrustAnchor,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function initialize_cluster(
    ClusterId,
    SignedCert,
    TrustAnchor,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudhsm_v2(
        "InitializeCluster",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClusterId" => ClusterId,
                    "SignedCert" => SignedCert,
                    "TrustAnchor" => TrustAnchor,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags(resource_id)
    list_tags(resource_id, params::Dict{String,<:Any})

Gets a list of tags for the specified AWS CloudHSM cluster. This is a paginated operation,
which means that each response might contain only a subset of all the tags. When the
response contains only a subset of tags, it includes a NextToken value. Use this value in a
subsequent ListTags request to get more tags. When you receive a response with no NextToken
(or an empty or null value), that means there are no more tags to get.

# Arguments
- `resource_id`: The cluster identifier (ID) for the cluster whose tags you are getting. To
  find the cluster ID, use DescribeClusters.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of tags to return in the response. When there are more
  tags than the number you specify, the response contains a NextToken value.
- `"NextToken"`: The NextToken value that you received in the previous response. Use this
  value to get more tags.
"""
function list_tags(ResourceId; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudhsm_v2(
        "ListTags",
        Dict{String,Any}("ResourceId" => ResourceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags(
    ResourceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudhsm_v2(
        "ListTags",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceId" => ResourceId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    modify_backup_attributes(backup_id, never_expires)
    modify_backup_attributes(backup_id, never_expires, params::Dict{String,<:Any})

Modifies attributes for AWS CloudHSM backup.

# Arguments
- `backup_id`: The identifier (ID) of the backup to modify. To find the ID of a backup, use
  the DescribeBackups operation.
- `never_expires`: Specifies whether the service should exempt a backup from the retention
  policy for the cluster. True exempts a backup from the retention policy. False means the
  service applies the backup retention policy defined at the cluster.

"""
function modify_backup_attributes(
    BackupId, NeverExpires; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudhsm_v2(
        "ModifyBackupAttributes",
        Dict{String,Any}("BackupId" => BackupId, "NeverExpires" => NeverExpires);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function modify_backup_attributes(
    BackupId,
    NeverExpires,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudhsm_v2(
        "ModifyBackupAttributes",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("BackupId" => BackupId, "NeverExpires" => NeverExpires),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    modify_cluster(backup_retention_policy, cluster_id)
    modify_cluster(backup_retention_policy, cluster_id, params::Dict{String,<:Any})

Modifies AWS CloudHSM cluster.

# Arguments
- `backup_retention_policy`: A policy that defines how the service retains backups.
- `cluster_id`: The identifier (ID) of the cluster that you want to modify. To find the
  cluster ID, use DescribeClusters.

"""
function modify_cluster(
    BackupRetentionPolicy, ClusterId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudhsm_v2(
        "ModifyCluster",
        Dict{String,Any}(
            "BackupRetentionPolicy" => BackupRetentionPolicy, "ClusterId" => ClusterId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function modify_cluster(
    BackupRetentionPolicy,
    ClusterId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudhsm_v2(
        "ModifyCluster",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "BackupRetentionPolicy" => BackupRetentionPolicy,
                    "ClusterId" => ClusterId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    restore_backup(backup_id)
    restore_backup(backup_id, params::Dict{String,<:Any})

Restores a specified AWS CloudHSM backup that is in the PENDING_DELETION state. For mor
information on deleting a backup, see DeleteBackup.

# Arguments
- `backup_id`: The ID of the backup to be restored. To find the ID of a backup, use the
  DescribeBackups operation.

"""
function restore_backup(BackupId; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudhsm_v2(
        "RestoreBackup",
        Dict{String,Any}("BackupId" => BackupId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function restore_backup(
    BackupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudhsm_v2(
        "RestoreBackup",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("BackupId" => BackupId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_id, tag_list)
    tag_resource(resource_id, tag_list, params::Dict{String,<:Any})

Adds or overwrites one or more tags for the specified AWS CloudHSM cluster.

# Arguments
- `resource_id`: The cluster identifier (ID) for the cluster that you are tagging. To find
  the cluster ID, use DescribeClusters.
- `tag_list`: A list of one or more tags.

"""
function tag_resource(
    ResourceId, TagList; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudhsm_v2(
        "TagResource",
        Dict{String,Any}("ResourceId" => ResourceId, "TagList" => TagList);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceId,
    TagList,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudhsm_v2(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceId" => ResourceId, "TagList" => TagList),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_id, tag_key_list)
    untag_resource(resource_id, tag_key_list, params::Dict{String,<:Any})

Removes the specified tag or tags from the specified AWS CloudHSM cluster.

# Arguments
- `resource_id`: The cluster identifier (ID) for the cluster whose tags you are removing.
  To find the cluster ID, use DescribeClusters.
- `tag_key_list`: A list of one or more tag keys for the tags that you are removing.
  Specify only the tag keys, not the tag values.

"""
function untag_resource(
    ResourceId, TagKeyList; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudhsm_v2(
        "UntagResource",
        Dict{String,Any}("ResourceId" => ResourceId, "TagKeyList" => TagKeyList);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceId,
    TagKeyList,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudhsm_v2(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceId" => ResourceId, "TagKeyList" => TagKeyList),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: kinesis
using AWS.Compat
using AWS.UUIDs

"""
    add_tags_to_stream(tags)
    add_tags_to_stream(tags, params::Dict{String,<:Any})

Adds or updates tags for the specified Kinesis data stream. You can assign up to 50 tags to
a data stream.  When invoking this API, you must use either the StreamARN or the StreamName
parameter, or both. It is recommended that you use the StreamARN input parameter when you
invoke this API.  If tags have already been assigned to the stream, AddTagsToStream
overwrites any existing tags that correspond to the specified tag keys.  AddTagsToStream
has a limit of five transactions per second per account.

# Arguments
- `tags`: A set of up to 10 key-value pairs to use to create the tags.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"StreamARN"`: The ARN of the stream.
- `"StreamName"`: The name of the stream.
"""
function add_tags_to_stream(Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return kinesis(
        "AddTagsToStream",
        Dict{String,Any}("Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_tags_to_stream(
    Tags, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis(
        "AddTagsToStream",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Tags" => Tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_stream(stream_name)
    create_stream(stream_name, params::Dict{String,<:Any})

Creates a Kinesis data stream. A stream captures and transports data records that are
continuously emitted from different data sources or producers. Scale-out within a stream is
explicitly supported by means of shards, which are uniquely identified groups of data
records in a stream. You can create your data stream using either on-demand or provisioned
capacity mode. Data streams with an on-demand mode require no capacity planning and
automatically scale to handle gigabytes of write and read throughput per minute. With the
on-demand mode, Kinesis Data Streams automatically manages the shards in order to provide
the necessary throughput. For the data streams with a provisioned mode, you must specify
the number of shards for the data stream. Each shard can support reads up to five
transactions per second, up to a maximum data read total of 2 MiB per second. Each shard
can support writes up to 1,000 records per second, up to a maximum data write total of 1
MiB per second. If the amount of data input increases or decreases, you can add or remove
shards. The stream name identifies the stream. The name is scoped to the Amazon Web
Services account used by the application. It is also scoped by Amazon Web Services Region.
That is, two streams in two different accounts can have the same name, and two streams in
the same account, but in two different Regions, can have the same name.  CreateStream is an
asynchronous operation. Upon receiving a CreateStream request, Kinesis Data Streams
immediately returns and sets the stream status to CREATING. After the stream is created,
Kinesis Data Streams sets the stream status to ACTIVE. You should perform read and write
operations only on an ACTIVE stream.  You receive a LimitExceededException when making a
CreateStream request when you try to do one of the following:   Have more than five streams
in the CREATING state at any point in time.   Create more shards than are authorized for
your account.   For the default shard limit for an Amazon Web Services account, see Amazon
Kinesis Data Streams Limits in the Amazon Kinesis Data Streams Developer Guide. To increase
this limit, contact Amazon Web Services Support. You can use DescribeStreamSummary to check
the stream status, which is returned in StreamStatus.  CreateStream has a limit of five
transactions per second per account.

# Arguments
- `stream_name`: A name to identify the stream. The stream name is scoped to the Amazon Web
  Services account used by the application that creates the stream. It is also scoped by
  Amazon Web Services Region. That is, two streams in two different Amazon Web Services
  accounts can have the same name. Two streams in the same Amazon Web Services account but in
  two different Regions can also have the same name.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ShardCount"`: The number of shards that the stream will use. The throughput of the
  stream is a function of the number of shards; more shards are required for greater
  provisioned throughput.
- `"StreamModeDetails"`:  Indicates the capacity mode of the data stream. Currently, in
  Kinesis Data Streams, you can choose between an on-demand capacity mode and a provisioned
  capacity mode for your data streams.
"""
function create_stream(StreamName; aws_config::AbstractAWSConfig=current_aws_config())
    return kinesis(
        "CreateStream",
        Dict{String,Any}("StreamName" => StreamName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_stream(
    StreamName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis(
        "CreateStream",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("StreamName" => StreamName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    decrease_stream_retention_period(retention_period_hours)
    decrease_stream_retention_period(retention_period_hours, params::Dict{String,<:Any})

Decreases the Kinesis data stream's retention period, which is the length of time data
records are accessible after they are added to the stream. The minimum value of a stream's
retention period is 24 hours.  When invoking this API, you must use either the StreamARN or
the StreamName parameter, or both. It is recommended that you use the StreamARN input
parameter when you invoke this API.  This operation may result in lost data. For example,
if the stream's retention period is 48 hours and is decreased to 24 hours, any data already
in the stream that is older than 24 hours is inaccessible.

# Arguments
- `retention_period_hours`: The new retention period of the stream, in hours. Must be less
  than the current retention period.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"StreamARN"`: The ARN of the stream.
- `"StreamName"`: The name of the stream to modify.
"""
function decrease_stream_retention_period(
    RetentionPeriodHours; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis(
        "DecreaseStreamRetentionPeriod",
        Dict{String,Any}("RetentionPeriodHours" => RetentionPeriodHours);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function decrease_stream_retention_period(
    RetentionPeriodHours,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis(
        "DecreaseStreamRetentionPeriod",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("RetentionPeriodHours" => RetentionPeriodHours),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_resource_policy(resource_arn)
    delete_resource_policy(resource_arn, params::Dict{String,<:Any})

Delete a policy for the specified data stream or consumer. Request patterns can be one of
the following:   Data stream pattern: arn:aws.*:kinesis:.*:d{12}:.*stream/S+    Consumer
pattern:
^(arn):aws.*:kinesis:.*:d{12}:.*stream/[a-zA-Z0-9_.-]+/consumer/[a-zA-Z0-9_.-]+:[0-9]+

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the data stream or consumer.

"""
function delete_resource_policy(
    ResourceARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis(
        "DeleteResourcePolicy",
        Dict{String,Any}("ResourceARN" => ResourceARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_resource_policy(
    ResourceARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis(
        "DeleteResourcePolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceARN" => ResourceARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_stream()
    delete_stream(params::Dict{String,<:Any})

Deletes a Kinesis data stream and all its shards and data. You must shut down any
applications that are operating on the stream before you delete the stream. If an
application attempts to operate on a deleted stream, it receives the exception
ResourceNotFoundException.  When invoking this API, you must use either the StreamARN or
the StreamName parameter, or both. It is recommended that you use the StreamARN input
parameter when you invoke this API.  If the stream is in the ACTIVE state, you can delete
it. After a DeleteStream request, the specified stream is in the DELETING state until
Kinesis Data Streams completes the deletion.  Note: Kinesis Data Streams might continue to
accept data read and write operations, such as PutRecord, PutRecords, and GetRecords, on a
stream in the DELETING state until the stream deletion is complete. When you delete a
stream, any shards in that stream are also deleted, and any tags are dissociated from the
stream. You can use the DescribeStreamSummary operation to check the state of the stream,
which is returned in StreamStatus.  DeleteStream has a limit of five transactions per
second per account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EnforceConsumerDeletion"`: If this parameter is unset (null) or if you set it to false,
  and the stream has registered consumers, the call to DeleteStream fails with a
  ResourceInUseException.
- `"StreamARN"`: The ARN of the stream.
- `"StreamName"`: The name of the stream to delete.
"""
function delete_stream(; aws_config::AbstractAWSConfig=current_aws_config())
    return kinesis("DeleteStream"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function delete_stream(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis(
        "DeleteStream", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    deregister_stream_consumer()
    deregister_stream_consumer(params::Dict{String,<:Any})

To deregister a consumer, provide its ARN. Alternatively, you can provide the ARN of the
data stream and the name you gave the consumer when you registered it. You may also provide
all three parameters, as long as they don't conflict with each other. If you don't know the
name or ARN of the consumer that you want to deregister, you can use the
ListStreamConsumers operation to get a list of the descriptions of all the consumers that
are currently registered with a given data stream. The description of a consumer contains
its name and ARN. This operation has a limit of five transactions per second per stream.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConsumerARN"`: The ARN returned by Kinesis Data Streams when you registered the
  consumer. If you don't know the ARN of the consumer that you want to deregister, you can
  use the ListStreamConsumers operation to get a list of the descriptions of all the
  consumers that are currently registered with a given data stream. The description of a
  consumer contains its ARN.
- `"ConsumerName"`: The name that you gave to the consumer.
- `"StreamARN"`: The ARN of the Kinesis data stream that the consumer is registered with.
  For more information, see Amazon Resource Names (ARNs) and Amazon Web Services Service
  Namespaces.
"""
function deregister_stream_consumer(; aws_config::AbstractAWSConfig=current_aws_config())
    return kinesis(
        "DeregisterStreamConsumer"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function deregister_stream_consumer(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis(
        "DeregisterStreamConsumer",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_limits()
    describe_limits(params::Dict{String,<:Any})

Describes the shard limits and usage for the account. If you update your account limits,
the old limits might be returned for a few minutes. This operation has a limit of one
transaction per second per account.

"""
function describe_limits(; aws_config::AbstractAWSConfig=current_aws_config())
    return kinesis("DescribeLimits"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function describe_limits(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis(
        "DescribeLimits", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_stream()
    describe_stream(params::Dict{String,<:Any})

Describes the specified Kinesis data stream.  This API has been revised. It's highly
recommended that you use the DescribeStreamSummary API to get a summarized description of
the specified Kinesis data stream and the ListShards API to list the shards in a specified
data stream and obtain information about each shard.    When invoking this API, you must
use either the StreamARN or the StreamName parameter, or both. It is recommended that you
use the StreamARN input parameter when you invoke this API.  The information returned
includes the stream name, Amazon Resource Name (ARN), creation time, enhanced metric
configuration, and shard map. The shard map is an array of shard objects. For each shard
object, there is the hash key and sequence number ranges that the shard spans, and the IDs
of any earlier shards that played in a role in creating the shard. Every record ingested in
the stream is identified by a sequence number, which is assigned when the record is put
into the stream. You can limit the number of shards returned by each call. For more
information, see Retrieving Shards from a Stream in the Amazon Kinesis Data Streams
Developer Guide. There are no guarantees about the chronological order shards returned. To
process shards in chronological order, use the ID of the parent shard to track the lineage
to the oldest shard. This operation has a limit of 10 transactions per second per account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ExclusiveStartShardId"`: The shard ID of the shard to start with. Specify this
  parameter to indicate that you want to describe the stream starting with the shard whose ID
  immediately follows ExclusiveStartShardId. If you don't specify this parameter, the default
  behavior for DescribeStream is to describe the stream starting with the first shard in the
  stream.
- `"Limit"`: The maximum number of shards to return in a single call. The default value is
  100. If you specify a value greater than 100, at most 100 results are returned.
- `"StreamARN"`: The ARN of the stream.
- `"StreamName"`: The name of the stream to describe.
"""
function describe_stream(; aws_config::AbstractAWSConfig=current_aws_config())
    return kinesis("DescribeStream"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function describe_stream(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis(
        "DescribeStream", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_stream_consumer()
    describe_stream_consumer(params::Dict{String,<:Any})

To get the description of a registered consumer, provide the ARN of the consumer.
Alternatively, you can provide the ARN of the data stream and the name you gave the
consumer when you registered it. You may also provide all three parameters, as long as they
don't conflict with each other. If you don't know the name or ARN of the consumer that you
want to describe, you can use the ListStreamConsumers operation to get a list of the
descriptions of all the consumers that are currently registered with a given data stream.
This operation has a limit of 20 transactions per second per stream.  When making a
cross-account call with DescribeStreamConsumer, make sure to provide the ARN of the
consumer.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConsumerARN"`: The ARN returned by Kinesis Data Streams when you registered the
  consumer.
- `"ConsumerName"`: The name that you gave to the consumer.
- `"StreamARN"`: The ARN of the Kinesis data stream that the consumer is registered with.
  For more information, see Amazon Resource Names (ARNs) and Amazon Web Services Service
  Namespaces.
"""
function describe_stream_consumer(; aws_config::AbstractAWSConfig=current_aws_config())
    return kinesis(
        "DescribeStreamConsumer"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_stream_consumer(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis(
        "DescribeStreamConsumer",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_stream_summary()
    describe_stream_summary(params::Dict{String,<:Any})

Provides a summarized description of the specified Kinesis data stream without the shard
list.  When invoking this API, you must use either the StreamARN or the StreamName
parameter, or both. It is recommended that you use the StreamARN input parameter when you
invoke this API.  The information returned includes the stream name, Amazon Resource Name
(ARN), status, record retention period, approximate creation time, monitoring, encryption
details, and open shard count.   DescribeStreamSummary has a limit of 20 transactions per
second per account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"StreamARN"`: The ARN of the stream.
- `"StreamName"`: The name of the stream to describe.
"""
function describe_stream_summary(; aws_config::AbstractAWSConfig=current_aws_config())
    return kinesis(
        "DescribeStreamSummary"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_stream_summary(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis(
        "DescribeStreamSummary",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disable_enhanced_monitoring(shard_level_metrics)
    disable_enhanced_monitoring(shard_level_metrics, params::Dict{String,<:Any})

Disables enhanced monitoring.  When invoking this API, you must use either the StreamARN or
the StreamName parameter, or both. It is recommended that you use the StreamARN input
parameter when you invoke this API.

# Arguments
- `shard_level_metrics`: List of shard-level metrics to disable. The following are the
  valid shard-level metrics. The value \"ALL\" disables every metric.    IncomingBytes
  IncomingRecords     OutgoingBytes     OutgoingRecords
  WriteProvisionedThroughputExceeded     ReadProvisionedThroughputExceeded
  IteratorAgeMilliseconds     ALL    For more information, see Monitoring the Amazon Kinesis
  Data Streams Service with Amazon CloudWatch in the Amazon Kinesis Data Streams Developer
  Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"StreamARN"`: The ARN of the stream.
- `"StreamName"`: The name of the Kinesis data stream for which to disable enhanced
  monitoring.
"""
function disable_enhanced_monitoring(
    ShardLevelMetrics; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis(
        "DisableEnhancedMonitoring",
        Dict{String,Any}("ShardLevelMetrics" => ShardLevelMetrics);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disable_enhanced_monitoring(
    ShardLevelMetrics,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis(
        "DisableEnhancedMonitoring",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ShardLevelMetrics" => ShardLevelMetrics), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    enable_enhanced_monitoring(shard_level_metrics)
    enable_enhanced_monitoring(shard_level_metrics, params::Dict{String,<:Any})

Enables enhanced Kinesis data stream monitoring for shard-level metrics.  When invoking
this API, you must use either the StreamARN or the StreamName parameter, or both. It is
recommended that you use the StreamARN input parameter when you invoke this API.

# Arguments
- `shard_level_metrics`: List of shard-level metrics to enable. The following are the valid
  shard-level metrics. The value \"ALL\" enables every metric.    IncomingBytes
  IncomingRecords     OutgoingBytes     OutgoingRecords
  WriteProvisionedThroughputExceeded     ReadProvisionedThroughputExceeded
  IteratorAgeMilliseconds     ALL    For more information, see Monitoring the Amazon Kinesis
  Data Streams Service with Amazon CloudWatch in the Amazon Kinesis Data Streams Developer
  Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"StreamARN"`: The ARN of the stream.
- `"StreamName"`: The name of the stream for which to enable enhanced monitoring.
"""
function enable_enhanced_monitoring(
    ShardLevelMetrics; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis(
        "EnableEnhancedMonitoring",
        Dict{String,Any}("ShardLevelMetrics" => ShardLevelMetrics);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function enable_enhanced_monitoring(
    ShardLevelMetrics,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis(
        "EnableEnhancedMonitoring",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ShardLevelMetrics" => ShardLevelMetrics), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_records(shard_iterator)
    get_records(shard_iterator, params::Dict{String,<:Any})

Gets data records from a Kinesis data stream's shard.  When invoking this API, you must use
either the StreamARN or the StreamName parameter, or both. It is recommended that you use
the StreamARN input parameter when you invoke this API.  Specify a shard iterator using the
ShardIterator parameter. The shard iterator specifies the position in the shard from which
you want to start reading data records sequentially. If there are no records available in
the portion of the shard that the iterator points to, GetRecords returns an empty list. It
might take multiple calls to get to a portion of the shard that contains records. You can
scale by provisioning multiple shards per stream while considering service limits (for more
information, see Amazon Kinesis Data Streams Limits in the Amazon Kinesis Data Streams
Developer Guide). Your application should have one thread per shard, each reading
continuously from its stream. To read from a stream continually, call GetRecords in a loop.
Use GetShardIterator to get the shard iterator to specify in the first GetRecords call.
GetRecords returns a new shard iterator in NextShardIterator. Specify the shard iterator
returned in NextShardIterator in subsequent calls to GetRecords. If the shard has been
closed, the shard iterator can't return more data and GetRecords returns null in
NextShardIterator. You can terminate the loop when the shard is closed, or when the shard
iterator reaches the record with the sequence number or other attribute that marks it as
the last record to process. Each data record can be up to 1 MiB in size, and each shard can
read up to 2 MiB per second. You can ensure that your calls don't exceed the maximum
supported size or throughput by using the Limit parameter to specify the maximum number of
records that GetRecords can return. Consider your average record size when determining this
limit. The maximum number of records that can be returned per call is 10,000. The size of
the data returned by GetRecords varies depending on the utilization of the shard. It is
recommended that consumer applications retrieve records via the GetRecords command using
the 5 TPS limit to remain caught up. Retrieving records less frequently can lead to
consumer applications falling behind. The maximum size of data that GetRecords can return
is 10 MiB. If a call returns this amount of data, subsequent calls made within the next 5
seconds throw ProvisionedThroughputExceededException. If there is insufficient provisioned
throughput on the stream, subsequent calls made within the next 1 second throw
ProvisionedThroughputExceededException. GetRecords doesn't return any data when it throws
an exception. For this reason, we recommend that you wait 1 second between calls to
GetRecords. However, it's possible that the application will get exceptions for longer than
1 second. To detect whether the application is falling behind in processing, you can use
the MillisBehindLatest response attribute. You can also monitor the stream using CloudWatch
metrics and other mechanisms (see Monitoring in the Amazon Kinesis Data Streams Developer
Guide). Each Amazon Kinesis record includes a value, ApproximateArrivalTimestamp, that is
set when a stream successfully receives and stores a record. This is commonly referred to
as a server-side time stamp, whereas a client-side time stamp is set when a data producer
creates or sends the record to a stream (a data producer is any data source putting data
records into a stream, for example with PutRecords). The time stamp has millisecond
precision. There are no guarantees about the time stamp accuracy, or that the time stamp is
always increasing. For example, records in a shard or across a stream might have time
stamps that are out of order. This operation has a limit of five transactions per second
per shard.

# Arguments
- `shard_iterator`: The position in the shard from which you want to start sequentially
  reading data records. A shard iterator specifies this position using the sequence number of
  a data record in the shard.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: The maximum number of records to return. Specify a value of up to 10,000. If
  you specify a value that is greater than 10,000, GetRecords throws
  InvalidArgumentException. The default value is 10,000.
- `"StreamARN"`: The ARN of the stream.
"""
function get_records(ShardIterator; aws_config::AbstractAWSConfig=current_aws_config())
    return kinesis(
        "GetRecords",
        Dict{String,Any}("ShardIterator" => ShardIterator);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_records(
    ShardIterator,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis(
        "GetRecords",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ShardIterator" => ShardIterator), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_resource_policy(resource_arn)
    get_resource_policy(resource_arn, params::Dict{String,<:Any})

Returns a policy attached to the specified data stream or consumer. Request patterns can be
one of the following:   Data stream pattern: arn:aws.*:kinesis:.*:d{12}:.*stream/S+
Consumer pattern:
^(arn):aws.*:kinesis:.*:d{12}:.*stream/[a-zA-Z0-9_.-]+/consumer/[a-zA-Z0-9_.-]+:[0-9]+

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the data stream or consumer.

"""
function get_resource_policy(
    ResourceARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis(
        "GetResourcePolicy",
        Dict{String,Any}("ResourceARN" => ResourceARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_resource_policy(
    ResourceARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis(
        "GetResourcePolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceARN" => ResourceARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_shard_iterator(shard_id, shard_iterator_type)
    get_shard_iterator(shard_id, shard_iterator_type, params::Dict{String,<:Any})

Gets an Amazon Kinesis shard iterator. A shard iterator expires 5 minutes after it is
returned to the requester.  When invoking this API, you must use either the StreamARN or
the StreamName parameter, or both. It is recommended that you use the StreamARN input
parameter when you invoke this API.  A shard iterator specifies the shard position from
which to start reading data records sequentially. The position is specified using the
sequence number of a data record in a shard. A sequence number is the identifier associated
with every record ingested in the stream, and is assigned when a record is put into the
stream. Each stream has one or more shards. You must specify the shard iterator type. For
example, you can set the ShardIteratorType parameter to read exactly from the position
denoted by a specific sequence number by using the AT_SEQUENCE_NUMBER shard iterator type.
Alternatively, the parameter can read right after the sequence number by using the
AFTER_SEQUENCE_NUMBER shard iterator type, using sequence numbers returned by earlier calls
to PutRecord, PutRecords, GetRecords, or DescribeStream. In the request, you can specify
the shard iterator type AT_TIMESTAMP to read records from an arbitrary point in time,
TRIM_HORIZON to cause ShardIterator to point to the last untrimmed record in the shard in
the system (the oldest data record in the shard), or LATEST so that you always read the
most recent data in the shard.  When you read repeatedly from a stream, use a
GetShardIterator request to get the first shard iterator for use in your first GetRecords
request and for subsequent reads use the shard iterator returned by the GetRecords request
in NextShardIterator. A new shard iterator is returned by every GetRecords request in
NextShardIterator, which you use in the ShardIterator parameter of the next GetRecords
request.  If a GetShardIterator request is made too often, you receive a
ProvisionedThroughputExceededException. For more information about throughput limits, see
GetRecords, and Streams Limits in the Amazon Kinesis Data Streams Developer Guide. If the
shard is closed, GetShardIterator returns a valid iterator for the last sequence number of
the shard. A shard can be closed as a result of using SplitShard or MergeShards.
GetShardIterator has a limit of five transactions per second per account per open shard.

# Arguments
- `shard_id`: The shard ID of the Kinesis Data Streams shard to get the iterator for.
- `shard_iterator_type`: Determines how the shard iterator is used to start reading data
  records from the shard. The following are the valid Amazon Kinesis shard iterator types:
  AT_SEQUENCE_NUMBER - Start reading from the position denoted by a specific sequence number,
  provided in the value StartingSequenceNumber.   AFTER_SEQUENCE_NUMBER - Start reading right
  after the position denoted by a specific sequence number, provided in the value
  StartingSequenceNumber.   AT_TIMESTAMP - Start reading from the position denoted by a
  specific time stamp, provided in the value Timestamp.   TRIM_HORIZON - Start reading at the
  last untrimmed record in the shard in the system, which is the oldest data record in the
  shard.   LATEST - Start reading just after the most recent record in the shard, so that you
  always read the most recent data in the shard.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"StartingSequenceNumber"`: The sequence number of the data record in the shard from
  which to start reading. Used with shard iterator type AT_SEQUENCE_NUMBER and
  AFTER_SEQUENCE_NUMBER.
- `"StreamARN"`: The ARN of the stream.
- `"StreamName"`: The name of the Amazon Kinesis data stream.
- `"Timestamp"`: The time stamp of the data record from which to start reading. Used with
  shard iterator type AT_TIMESTAMP. A time stamp is the Unix epoch date with precision in
  milliseconds. For example, 2016-04-04T19:58:46.480-00:00 or 1459799926.480. If a record
  with this exact time stamp does not exist, the iterator returned is for the next (later)
  record. If the time stamp is older than the current trim horizon, the iterator returned is
  for the oldest untrimmed data record (TRIM_HORIZON).
"""
function get_shard_iterator(
    ShardId, ShardIteratorType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis(
        "GetShardIterator",
        Dict{String,Any}("ShardId" => ShardId, "ShardIteratorType" => ShardIteratorType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_shard_iterator(
    ShardId,
    ShardIteratorType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis(
        "GetShardIterator",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ShardId" => ShardId, "ShardIteratorType" => ShardIteratorType
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    increase_stream_retention_period(retention_period_hours)
    increase_stream_retention_period(retention_period_hours, params::Dict{String,<:Any})

Increases the Kinesis data stream's retention period, which is the length of time data
records are accessible after they are added to the stream. The maximum value of a stream's
retention period is 8760 hours (365 days).  When invoking this API, you must use either the
StreamARN or the StreamName parameter, or both. It is recommended that you use the
StreamARN input parameter when you invoke this API.  If you choose a longer stream
retention period, this operation increases the time period during which records that have
not yet expired are accessible. However, it does not make previous, expired data (older
than the stream's previous retention period) accessible after the operation has been
called. For example, if a stream's retention period is set to 24 hours and is increased to
168 hours, any data that is older than 24 hours remains inaccessible to consumer
applications.

# Arguments
- `retention_period_hours`: The new retention period of the stream, in hours. Must be more
  than the current retention period.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"StreamARN"`: The ARN of the stream.
- `"StreamName"`: The name of the stream to modify.
"""
function increase_stream_retention_period(
    RetentionPeriodHours; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis(
        "IncreaseStreamRetentionPeriod",
        Dict{String,Any}("RetentionPeriodHours" => RetentionPeriodHours);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function increase_stream_retention_period(
    RetentionPeriodHours,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis(
        "IncreaseStreamRetentionPeriod",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("RetentionPeriodHours" => RetentionPeriodHours),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_shards()
    list_shards(params::Dict{String,<:Any})

Lists the shards in a stream and provides information about each shard. This operation has
a limit of 1000 transactions per second per data stream.  When invoking this API, you must
use either the StreamARN or the StreamName parameter, or both. It is recommended that you
use the StreamARN input parameter when you invoke this API.  This action does not list
expired shards. For information about expired shards, see Data Routing, Data Persistence,
and Shard State after a Reshard.   This API is a new operation that is used by the Amazon
Kinesis Client Library (KCL). If you have a fine-grained IAM policy that only allows
specific operations, you must update your policy to allow calls to this API. For more
information, see Controlling Access to Amazon Kinesis Data Streams Resources Using IAM.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ExclusiveStartShardId"`: Specify this parameter to indicate that you want to list the
  shards starting with the shard whose ID immediately follows ExclusiveStartShardId. If you
  don't specify this parameter, the default behavior is for ListShards to list the shards
  starting with the first one in the stream. You cannot specify this parameter if you specify
  NextToken.
- `"MaxResults"`: The maximum number of shards to return in a single call to ListShards.
  The maximum number of shards to return in a single call. The default value is 1000. If you
  specify a value greater than 1000, at most 1000 results are returned.  When the number of
  shards to be listed is greater than the value of MaxResults, the response contains a
  NextToken value that you can use in a subsequent call to ListShards to list the next set of
  shards.
- `"NextToken"`: When the number of shards in the data stream is greater than the default
  value for the MaxResults parameter, or if you explicitly specify a value for MaxResults
  that is less than the number of shards in the data stream, the response includes a
  pagination token named NextToken. You can specify this NextToken value in a subsequent call
  to ListShards to list the next set of shards. Don't specify StreamName or
  StreamCreationTimestamp if you specify NextToken because the latter unambiguously
  identifies the stream. You can optionally specify a value for the MaxResults parameter when
  you specify NextToken. If you specify a MaxResults value that is less than the number of
  shards that the operation returns if you don't specify MaxResults, the response will
  contain a new NextToken value. You can use the new NextToken value in a subsequent call to
  the ListShards operation.  Tokens expire after 300 seconds. When you obtain a value for
  NextToken in the response to a call to ListShards, you have 300 seconds to use that value.
  If you specify an expired token in a call to ListShards, you get ExpiredNextTokenException.
- `"ShardFilter"`: Enables you to filter out the response of the ListShards API. You can
  only specify one filter at a time.  If you use the ShardFilter parameter when invoking the
  ListShards API, the Type is the required property and must be specified. If you specify the
  AT_TRIM_HORIZON, FROM_TRIM_HORIZON, or AT_LATEST types, you do not need to specify either
  the ShardId or the Timestamp optional properties.  If you specify the AFTER_SHARD_ID type,
  you must also provide the value for the optional ShardId property. The ShardId property is
  identical in fuctionality to the ExclusiveStartShardId parameter of the ListShards API.
  When ShardId property is specified, the response includes the shards starting with the
  shard whose ID immediately follows the ShardId that you provided.  If you specify the
  AT_TIMESTAMP or FROM_TIMESTAMP_ID type, you must also provide the value for the optional
  Timestamp property. If you specify the AT_TIMESTAMP type, then all shards that were open at
  the provided timestamp are returned. If you specify the FROM_TIMESTAMP type, then all
  shards starting from the provided timestamp to TIP are returned.
- `"StreamARN"`: The ARN of the stream.
- `"StreamCreationTimestamp"`: Specify this input parameter to distinguish data streams
  that have the same name. For example, if you create a data stream and then delete it, and
  you later create another data stream with the same name, you can use this input parameter
  to specify which of the two streams you want to list the shards for. You cannot specify
  this parameter if you specify the NextToken parameter.
- `"StreamName"`: The name of the data stream whose shards you want to list.  You cannot
  specify this parameter if you specify the NextToken parameter.
"""
function list_shards(; aws_config::AbstractAWSConfig=current_aws_config())
    return kinesis("ListShards"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_shards(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis(
        "ListShards", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_stream_consumers(stream_arn)
    list_stream_consumers(stream_arn, params::Dict{String,<:Any})

Lists the consumers registered to receive data from a stream using enhanced fan-out, and
provides information about each consumer. This operation has a limit of 5 transactions per
second per stream.

# Arguments
- `stream_arn`: The ARN of the Kinesis data stream for which you want to list the
  registered consumers. For more information, see Amazon Resource Names (ARNs) and Amazon Web
  Services Service Namespaces.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of consumers that you want a single call of
  ListStreamConsumers to return. The default value is 100. If you specify a value greater
  than 100, at most 100 results are returned.
- `"NextToken"`: When the number of consumers that are registered with the data stream is
  greater than the default value for the MaxResults parameter, or if you explicitly specify a
  value for MaxResults that is less than the number of consumers that are registered with the
  data stream, the response includes a pagination token named NextToken. You can specify this
  NextToken value in a subsequent call to ListStreamConsumers to list the next set of
  registered consumers. Don't specify StreamName or StreamCreationTimestamp if you specify
  NextToken because the latter unambiguously identifies the stream. You can optionally
  specify a value for the MaxResults parameter when you specify NextToken. If you specify a
  MaxResults value that is less than the number of consumers that the operation returns if
  you don't specify MaxResults, the response will contain a new NextToken value. You can use
  the new NextToken value in a subsequent call to the ListStreamConsumers operation to list
  the next set of consumers.  Tokens expire after 300 seconds. When you obtain a value for
  NextToken in the response to a call to ListStreamConsumers, you have 300 seconds to use
  that value. If you specify an expired token in a call to ListStreamConsumers, you get
  ExpiredNextTokenException.
- `"StreamCreationTimestamp"`: Specify this input parameter to distinguish data streams
  that have the same name. For example, if you create a data stream and then delete it, and
  you later create another data stream with the same name, you can use this input parameter
  to specify which of the two streams you want to list the consumers for.  You can't specify
  this parameter if you specify the NextToken parameter.
"""
function list_stream_consumers(
    StreamARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis(
        "ListStreamConsumers",
        Dict{String,Any}("StreamARN" => StreamARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_stream_consumers(
    StreamARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis(
        "ListStreamConsumers",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("StreamARN" => StreamARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_streams()
    list_streams(params::Dict{String,<:Any})

Lists your Kinesis data streams. The number of streams may be too large to return from a
single call to ListStreams. You can limit the number of returned streams using the Limit
parameter. If you do not specify a value for the Limit parameter, Kinesis Data Streams uses
the default limit, which is currently 100. You can detect if there are more streams
available to list by using the HasMoreStreams flag from the returned output. If there are
more streams available, you can request more streams by using the name of the last stream
returned by the ListStreams request in the ExclusiveStartStreamName parameter in a
subsequent request to ListStreams. The group of stream names returned by the subsequent
request is then added to the list. You can continue this process until all the stream names
have been collected in the list.   ListStreams has a limit of five transactions per second
per account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ExclusiveStartStreamName"`: The name of the stream to start the list with.
- `"Limit"`: The maximum number of streams to list. The default value is 100. If you
  specify a value greater than 100, at most 100 results are returned.
- `"NextToken"`:
"""
function list_streams(; aws_config::AbstractAWSConfig=current_aws_config())
    return kinesis("ListStreams"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_streams(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis(
        "ListStreams", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_stream()
    list_tags_for_stream(params::Dict{String,<:Any})

Lists the tags for the specified Kinesis data stream. This operation has a limit of five
transactions per second per account.  When invoking this API, you must use either the
StreamARN or the StreamName parameter, or both. It is recommended that you use the
StreamARN input parameter when you invoke this API.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ExclusiveStartTagKey"`: The key to use as the starting point for the list of tags. If
  this parameter is set, ListTagsForStream gets all tags that occur after
  ExclusiveStartTagKey.
- `"Limit"`: The number of tags to return. If this number is less than the total number of
  tags associated with the stream, HasMoreTags is set to true. To list additional tags, set
  ExclusiveStartTagKey to the last key in the response.
- `"StreamARN"`: The ARN of the stream.
- `"StreamName"`: The name of the stream.
"""
function list_tags_for_stream(; aws_config::AbstractAWSConfig=current_aws_config())
    return kinesis(
        "ListTagsForStream"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_tags_for_stream(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis(
        "ListTagsForStream", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    merge_shards(adjacent_shard_to_merge, shard_to_merge)
    merge_shards(adjacent_shard_to_merge, shard_to_merge, params::Dict{String,<:Any})

Merges two adjacent shards in a Kinesis data stream and combines them into a single shard
to reduce the stream's capacity to ingest and transport data. This API is only supported
for the data streams with the provisioned capacity mode. Two shards are considered adjacent
if the union of the hash key ranges for the two shards form a contiguous set with no gaps.
For example, if you have two shards, one with a hash key range of 276...381 and the other
with a hash key range of 382...454, then you could merge these two shards into a single
shard that would have a hash key range of 276...454. After the merge, the single child
shard receives data for all hash key values covered by the two parent shards.  When
invoking this API, you must use either the StreamARN or the StreamName parameter, or both.
It is recommended that you use the StreamARN input parameter when you invoke this API.
MergeShards is called when there is a need to reduce the overall capacity of a stream
because of excess capacity that is not being used. You must specify the shard to be merged
and the adjacent shard for a stream. For more information about merging shards, see Merge
Two Shards in the Amazon Kinesis Data Streams Developer Guide. If the stream is in the
ACTIVE state, you can call MergeShards. If a stream is in the CREATING, UPDATING, or
DELETING state, MergeShards returns a ResourceInUseException. If the specified stream does
not exist, MergeShards returns a ResourceNotFoundException.  You can use
DescribeStreamSummary to check the state of the stream, which is returned in StreamStatus.
MergeShards is an asynchronous operation. Upon receiving a MergeShards request, Amazon
Kinesis Data Streams immediately returns a response and sets the StreamStatus to UPDATING.
After the operation is completed, Kinesis Data Streams sets the StreamStatus to ACTIVE.
Read and write operations continue to work while the stream is in the UPDATING state.  You
use DescribeStreamSummary and the ListShards APIs to determine the shard IDs that are
specified in the MergeShards request.  If you try to operate on too many streams in
parallel using CreateStream, DeleteStream, MergeShards, or SplitShard, you receive a
LimitExceededException.   MergeShards has a limit of five transactions per second per
account.

# Arguments
- `adjacent_shard_to_merge`: The shard ID of the adjacent shard for the merge.
- `shard_to_merge`: The shard ID of the shard to combine with the adjacent shard for the
  merge.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"StreamARN"`: The ARN of the stream.
- `"StreamName"`: The name of the stream for the merge.
"""
function merge_shards(
    AdjacentShardToMerge, ShardToMerge; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis(
        "MergeShards",
        Dict{String,Any}(
            "AdjacentShardToMerge" => AdjacentShardToMerge, "ShardToMerge" => ShardToMerge
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function merge_shards(
    AdjacentShardToMerge,
    ShardToMerge,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis(
        "MergeShards",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AdjacentShardToMerge" => AdjacentShardToMerge,
                    "ShardToMerge" => ShardToMerge,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_record(data, partition_key)
    put_record(data, partition_key, params::Dict{String,<:Any})

Writes a single data record into an Amazon Kinesis data stream. Call PutRecord to send data
into the stream for real-time ingestion and subsequent processing, one record at a time.
Each shard can support writes up to 1,000 records per second, up to a maximum data write
total of 1 MiB per second.  When invoking this API, you must use either the StreamARN or
the StreamName parameter, or both. It is recommended that you use the StreamARN input
parameter when you invoke this API.  You must specify the name of the stream that captures,
stores, and transports the data; a partition key; and the data blob itself. The data blob
can be any type of data; for example, a segment from a log file, geographic/location data,
website clickstream data, and so on. The partition key is used by Kinesis Data Streams to
distribute data across shards. Kinesis Data Streams segregates the data records that belong
to a stream into multiple shards, using the partition key associated with each data record
to determine the shard to which a given data record belongs. Partition keys are Unicode
strings, with a maximum length limit of 256 characters for each key. An MD5 hash function
is used to map partition keys to 128-bit integer values and to map associated data records
to shards using the hash key ranges of the shards. You can override hashing the partition
key to determine the shard by explicitly specifying a hash value using the ExplicitHashKey
parameter. For more information, see Adding Data to a Stream in the Amazon Kinesis Data
Streams Developer Guide.  PutRecord returns the shard ID of where the data record was
placed and the sequence number that was assigned to the data record. Sequence numbers
increase over time and are specific to a shard within a stream, not across all shards
within a stream. To guarantee strictly increasing ordering, write serially to a shard and
use the SequenceNumberForOrdering parameter. For more information, see Adding Data to a
Stream in the Amazon Kinesis Data Streams Developer Guide.  After you write a record to a
stream, you cannot modify that record or its order within the stream.  If a PutRecord
request cannot be processed because of insufficient provisioned throughput on the shard
involved in the request, PutRecord throws ProvisionedThroughputExceededException.  By
default, data records are accessible for 24 hours from the time that they are added to a
stream. You can use IncreaseStreamRetentionPeriod or DecreaseStreamRetentionPeriod to
modify this retention period.

# Arguments
- `data`: The data blob to put into the record, which is base64-encoded when the blob is
  serialized. When the data blob (the payload before base64-encoding) is added to the
  partition key size, the total size must not exceed the maximum record size (1 MiB).
- `partition_key`: Determines which shard in the stream the data record is assigned to.
  Partition keys are Unicode strings with a maximum length limit of 256 characters for each
  key. Amazon Kinesis Data Streams uses the partition key as input to a hash function that
  maps the partition key and associated data to a specific shard. Specifically, an MD5 hash
  function is used to map partition keys to 128-bit integer values and to map associated data
  records to shards. As a result of this hashing mechanism, all data records with the same
  partition key map to the same shard within the stream.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ExplicitHashKey"`: The hash value used to explicitly determine the shard the data
  record is assigned to by overriding the partition key hash.
- `"SequenceNumberForOrdering"`: Guarantees strictly increasing sequence numbers, for puts
  from the same client and to the same partition key. Usage: set the
  SequenceNumberForOrdering of record n to the sequence number of record n-1 (as returned in
  the result when putting record n-1). If this parameter is not set, records are coarsely
  ordered based on arrival time.
- `"StreamARN"`: The ARN of the stream.
- `"StreamName"`: The name of the stream to put the data record into.
"""
function put_record(Data, PartitionKey; aws_config::AbstractAWSConfig=current_aws_config())
    return kinesis(
        "PutRecord",
        Dict{String,Any}("Data" => Data, "PartitionKey" => PartitionKey);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_record(
    Data,
    PartitionKey,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis(
        "PutRecord",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Data" => Data, "PartitionKey" => PartitionKey),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_records(records)
    put_records(records, params::Dict{String,<:Any})

Writes multiple data records into a Kinesis data stream in a single call (also referred to
as a PutRecords request). Use this operation to send data into the stream for data
ingestion and processing.   When invoking this API, you must use either the StreamARN or
the StreamName parameter, or both. It is recommended that you use the StreamARN input
parameter when you invoke this API.  Each PutRecords request can support up to 500 records.
Each record in the request can be as large as 1 MiB, up to a limit of 5 MiB for the entire
request, including partition keys. Each shard can support writes up to 1,000 records per
second, up to a maximum data write total of 1 MiB per second. You must specify the name of
the stream that captures, stores, and transports the data; and an array of request Records,
with each record in the array requiring a partition key and data blob. The record size
limit applies to the total size of the partition key and data blob. The data blob can be
any type of data; for example, a segment from a log file, geographic/location data, website
clickstream data, and so on. The partition key is used by Kinesis Data Streams as input to
a hash function that maps the partition key and associated data to a specific shard. An MD5
hash function is used to map partition keys to 128-bit integer values and to map associated
data records to shards. As a result of this hashing mechanism, all data records with the
same partition key map to the same shard within the stream. For more information, see
Adding Data to a Stream in the Amazon Kinesis Data Streams Developer Guide. Each record in
the Records array may include an optional parameter, ExplicitHashKey, which overrides the
partition key to shard mapping. This parameter allows a data producer to determine
explicitly the shard where the record is stored. For more information, see Adding Multiple
Records with PutRecords in the Amazon Kinesis Data Streams Developer Guide. The PutRecords
response includes an array of response Records. Each record in the response array directly
correlates with a record in the request array using natural ordering, from the top to the
bottom of the request and response. The response Records array always includes the same
number of records as the request array. The response Records array includes both
successfully and unsuccessfully processed records. Kinesis Data Streams attempts to process
all records in each PutRecords request. A single record failure does not stop the
processing of subsequent records. As a result, PutRecords doesn't guarantee the ordering of
records. If you need to read records in the same order they are written to the stream, use
PutRecord instead of PutRecords, and write to the same shard. A successfully processed
record includes ShardId and SequenceNumber values. The ShardId parameter identifies the
shard in the stream where the record is stored. The SequenceNumber parameter is an
identifier assigned to the put record, unique to all records in the stream. An
unsuccessfully processed record includes ErrorCode and ErrorMessage values. ErrorCode
reflects the type of error and can be one of the following values:
ProvisionedThroughputExceededException or InternalFailure. ErrorMessage provides more
detailed information about the ProvisionedThroughputExceededException exception including
the account ID, stream name, and shard ID of the record that was throttled. For more
information about partially successful responses, see Adding Multiple Records with
PutRecords in the Amazon Kinesis Data Streams Developer Guide.  After you write a record to
a stream, you cannot modify that record or its order within the stream.  By default, data
records are accessible for 24 hours from the time that they are added to a stream. You can
use IncreaseStreamRetentionPeriod or DecreaseStreamRetentionPeriod to modify this retention
period.

# Arguments
- `records`: The records associated with the request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"StreamARN"`: The ARN of the stream.
- `"StreamName"`: The stream name associated with the request.
"""
function put_records(Records; aws_config::AbstractAWSConfig=current_aws_config())
    return kinesis(
        "PutRecords",
        Dict{String,Any}("Records" => Records);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_records(
    Records,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis(
        "PutRecords",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Records" => Records), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_resource_policy(policy, resource_arn)
    put_resource_policy(policy, resource_arn, params::Dict{String,<:Any})

Attaches a resource-based policy to a data stream or registered consumer. If you are using
an identity other than the root user of the Amazon Web Services account that owns the
resource, the calling identity must have the PutResourcePolicy permissions on the specified
Kinesis Data Streams resource and belong to the owner's account in order to use this
operation. If you don't have PutResourcePolicy permissions, Amazon Kinesis Data Streams
returns a 403 Access Denied error. If you receive a ResourceNotFoundException, check to see
if you passed a valid stream or consumer resource.   Request patterns can be one of the
following:   Data stream pattern: arn:aws.*:kinesis:.*:d{12}:.*stream/S+    Consumer
pattern:
^(arn):aws.*:kinesis:.*:d{12}:.*stream/[a-zA-Z0-9_.-]+/consumer/[a-zA-Z0-9_.-]+:[0-9]+
For more information, see Controlling Access to Amazon Kinesis Data Streams Resources Using
IAM.

# Arguments
- `policy`: Details of the resource policy. It must include the identity of the principal
  and the actions allowed on this resource. This is formatted as a JSON string.
- `resource_arn`: The Amazon Resource Name (ARN) of the data stream or consumer.

"""
function put_resource_policy(
    Policy, ResourceARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis(
        "PutResourcePolicy",
        Dict{String,Any}("Policy" => Policy, "ResourceARN" => ResourceARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_resource_policy(
    Policy,
    ResourceARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis(
        "PutResourcePolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Policy" => Policy, "ResourceARN" => ResourceARN),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    register_stream_consumer(consumer_name, stream_arn)
    register_stream_consumer(consumer_name, stream_arn, params::Dict{String,<:Any})

Registers a consumer with a Kinesis data stream. When you use this operation, the consumer
you register can then call SubscribeToShard to receive data from the stream using enhanced
fan-out, at a rate of up to 2 MiB per second for every shard you subscribe to. This rate is
unaffected by the total number of consumers that read from the same stream. You can
register up to 20 consumers per stream. A given consumer can only be registered with one
stream at a time. For an example of how to use this operations, see Enhanced Fan-Out Using
the Kinesis Data Streams API. The use of this operation has a limit of five transactions
per second per account. Also, only 5 consumers can be created simultaneously. In other
words, you cannot have more than 5 consumers in a CREATING status at the same time.
Registering a 6th consumer while there are 5 in a CREATING status results in a
LimitExceededException.

# Arguments
- `consumer_name`: For a given Kinesis data stream, each consumer must have a unique name.
  However, consumer names don't have to be unique across data streams.
- `stream_arn`: The ARN of the Kinesis data stream that you want to register the consumer
  with. For more info, see Amazon Resource Names (ARNs) and Amazon Web Services Service
  Namespaces.

"""
function register_stream_consumer(
    ConsumerName, StreamARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis(
        "RegisterStreamConsumer",
        Dict{String,Any}("ConsumerName" => ConsumerName, "StreamARN" => StreamARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function register_stream_consumer(
    ConsumerName,
    StreamARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis(
        "RegisterStreamConsumer",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ConsumerName" => ConsumerName, "StreamARN" => StreamARN),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_tags_from_stream(tag_keys)
    remove_tags_from_stream(tag_keys, params::Dict{String,<:Any})

Removes tags from the specified Kinesis data stream. Removed tags are deleted and cannot be
recovered after this operation successfully completes.  When invoking this API, you must
use either the StreamARN or the StreamName parameter, or both. It is recommended that you
use the StreamARN input parameter when you invoke this API.  If you specify a tag that does
not exist, it is ignored.  RemoveTagsFromStream has a limit of five transactions per second
per account.

# Arguments
- `tag_keys`: A list of tag keys. Each corresponding tag is removed from the stream.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"StreamARN"`: The ARN of the stream.
- `"StreamName"`: The name of the stream.
"""
function remove_tags_from_stream(
    TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis(
        "RemoveTagsFromStream",
        Dict{String,Any}("TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_tags_from_stream(
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis(
        "RemoveTagsFromStream",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("TagKeys" => TagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    split_shard(new_starting_hash_key, shard_to_split)
    split_shard(new_starting_hash_key, shard_to_split, params::Dict{String,<:Any})

Splits a shard into two new shards in the Kinesis data stream, to increase the stream's
capacity to ingest and transport data. SplitShard is called when there is a need to
increase the overall capacity of a stream because of an expected increase in the volume of
data records being ingested. This API is only supported for the data streams with the
provisioned capacity mode.  When invoking this API, you must use either the StreamARN or
the StreamName parameter, or both. It is recommended that you use the StreamARN input
parameter when you invoke this API.  You can also use SplitShard when a shard appears to be
approaching its maximum utilization; for example, the producers sending data into the
specific shard are suddenly sending more than previously anticipated. You can also call
SplitShard to increase stream capacity, so that more Kinesis Data Streams applications can
simultaneously read data from the stream for real-time processing.  You must specify the
shard to be split and the new hash key, which is the position in the shard where the shard
gets split in two. In many cases, the new hash key might be the average of the beginning
and ending hash key, but it can be any hash key value in the range being mapped into the
shard. For more information, see Split a Shard in the Amazon Kinesis Data Streams Developer
Guide. You can use DescribeStreamSummary and the ListShards APIs to determine the shard ID
and hash key values for the ShardToSplit and NewStartingHashKey parameters that are
specified in the SplitShard request.  SplitShard is an asynchronous operation. Upon
receiving a SplitShard request, Kinesis Data Streams immediately returns a response and
sets the stream status to UPDATING. After the operation is completed, Kinesis Data Streams
sets the stream status to ACTIVE. Read and write operations continue to work while the
stream is in the UPDATING state.  You can use DescribeStreamSummary to check the status of
the stream, which is returned in StreamStatus. If the stream is in the ACTIVE state, you
can call SplitShard.  If the specified stream does not exist, DescribeStreamSummary returns
a ResourceNotFoundException. If you try to create more shards than are authorized for your
account, you receive a LimitExceededException.  For the default shard limit for an Amazon
Web Services account, see Kinesis Data Streams Limits in the Amazon Kinesis Data Streams
Developer Guide. To increase this limit, contact Amazon Web Services Support. If you try to
operate on too many streams simultaneously using CreateStream, DeleteStream, MergeShards,
and/or SplitShard, you receive a LimitExceededException.   SplitShard has a limit of five
transactions per second per account.

# Arguments
- `new_starting_hash_key`: A hash key value for the starting hash key of one of the child
  shards created by the split. The hash key range for a given shard constitutes a set of
  ordered contiguous positive integers. The value for NewStartingHashKey must be in the range
  of hash keys being mapped into the shard. The NewStartingHashKey hash key value and all
  higher hash key values in hash key range are distributed to one of the child shards. All
  the lower hash key values in the range are distributed to the other child shard.
- `shard_to_split`: The shard ID of the shard to split.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"StreamARN"`: The ARN of the stream.
- `"StreamName"`: The name of the stream for the shard split.
"""
function split_shard(
    NewStartingHashKey, ShardToSplit; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis(
        "SplitShard",
        Dict{String,Any}(
            "NewStartingHashKey" => NewStartingHashKey, "ShardToSplit" => ShardToSplit
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function split_shard(
    NewStartingHashKey,
    ShardToSplit,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis(
        "SplitShard",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "NewStartingHashKey" => NewStartingHashKey,
                    "ShardToSplit" => ShardToSplit,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_stream_encryption(encryption_type, key_id)
    start_stream_encryption(encryption_type, key_id, params::Dict{String,<:Any})

Enables or updates server-side encryption using an Amazon Web Services KMS key for a
specified stream.   When invoking this API, you must use either the StreamARN or the
StreamName parameter, or both. It is recommended that you use the StreamARN input parameter
when you invoke this API.  Starting encryption is an asynchronous operation. Upon receiving
the request, Kinesis Data Streams returns immediately and sets the status of the stream to
UPDATING. After the update is complete, Kinesis Data Streams sets the status of the stream
back to ACTIVE. Updating or applying encryption normally takes a few seconds to complete,
but it can take minutes. You can continue to read and write data to your stream while its
status is UPDATING. Once the status of the stream is ACTIVE, encryption begins for records
written to the stream.  API Limits: You can successfully apply a new Amazon Web Services
KMS key for server-side encryption 25 times in a rolling 24-hour period. Note: It can take
up to 5 seconds after the stream is in an ACTIVE status before all records written to the
stream are encrypted. After you enable encryption, you can verify that encryption is
applied by inspecting the API response from PutRecord or PutRecords.

# Arguments
- `encryption_type`: The encryption type to use. The only valid value is KMS.
- `key_id`: The GUID for the customer-managed Amazon Web Services KMS key to use for
  encryption. This value can be a globally unique identifier, a fully specified Amazon
  Resource Name (ARN) to either an alias or a key, or an alias name prefixed by
  \"alias/\".You can also use a master key owned by Kinesis Data Streams by specifying the
  alias aws/kinesis.   Key ARN example:
  arn:aws:kms:us-east-1:123456789012:key/12345678-1234-1234-1234-123456789012    Alias ARN
  example: arn:aws:kms:us-east-1:123456789012:alias/MyAliasName    Globally unique key ID
  example: 12345678-1234-1234-1234-123456789012    Alias name example: alias/MyAliasName
  Master key owned by Kinesis Data Streams: alias/aws/kinesis

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"StreamARN"`: The ARN of the stream.
- `"StreamName"`: The name of the stream for which to start encrypting records.
"""
function start_stream_encryption(
    EncryptionType, KeyId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis(
        "StartStreamEncryption",
        Dict{String,Any}("EncryptionType" => EncryptionType, "KeyId" => KeyId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_stream_encryption(
    EncryptionType,
    KeyId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis(
        "StartStreamEncryption",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("EncryptionType" => EncryptionType, "KeyId" => KeyId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_stream_encryption(encryption_type, key_id)
    stop_stream_encryption(encryption_type, key_id, params::Dict{String,<:Any})

Disables server-side encryption for a specified stream.   When invoking this API, you must
use either the StreamARN or the StreamName parameter, or both. It is recommended that you
use the StreamARN input parameter when you invoke this API.  Stopping encryption is an
asynchronous operation. Upon receiving the request, Kinesis Data Streams returns
immediately and sets the status of the stream to UPDATING. After the update is complete,
Kinesis Data Streams sets the status of the stream back to ACTIVE. Stopping encryption
normally takes a few seconds to complete, but it can take minutes. You can continue to read
and write data to your stream while its status is UPDATING. Once the status of the stream
is ACTIVE, records written to the stream are no longer encrypted by Kinesis Data Streams.
API Limits: You can successfully disable server-side encryption 25 times in a rolling
24-hour period.  Note: It can take up to 5 seconds after the stream is in an ACTIVE status
before all records written to the stream are no longer subject to encryption. After you
disabled encryption, you can verify that encryption is not applied by inspecting the API
response from PutRecord or PutRecords.

# Arguments
- `encryption_type`: The encryption type. The only valid value is KMS.
- `key_id`: The GUID for the customer-managed Amazon Web Services KMS key to use for
  encryption. This value can be a globally unique identifier, a fully specified Amazon
  Resource Name (ARN) to either an alias or a key, or an alias name prefixed by
  \"alias/\".You can also use a master key owned by Kinesis Data Streams by specifying the
  alias aws/kinesis.   Key ARN example:
  arn:aws:kms:us-east-1:123456789012:key/12345678-1234-1234-1234-123456789012    Alias ARN
  example: arn:aws:kms:us-east-1:123456789012:alias/MyAliasName    Globally unique key ID
  example: 12345678-1234-1234-1234-123456789012    Alias name example: alias/MyAliasName
  Master key owned by Kinesis Data Streams: alias/aws/kinesis

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"StreamARN"`: The ARN of the stream.
- `"StreamName"`: The name of the stream on which to stop encrypting records.
"""
function stop_stream_encryption(
    EncryptionType, KeyId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis(
        "StopStreamEncryption",
        Dict{String,Any}("EncryptionType" => EncryptionType, "KeyId" => KeyId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_stream_encryption(
    EncryptionType,
    KeyId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis(
        "StopStreamEncryption",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("EncryptionType" => EncryptionType, "KeyId" => KeyId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_shard_count(scaling_type, target_shard_count)
    update_shard_count(scaling_type, target_shard_count, params::Dict{String,<:Any})

Updates the shard count of the specified stream to the specified number of shards. This API
is only supported for the data streams with the provisioned capacity mode.  When invoking
this API, you must use either the StreamARN or the StreamName parameter, or both. It is
recommended that you use the StreamARN input parameter when you invoke this API.  Updating
the shard count is an asynchronous operation. Upon receiving the request, Kinesis Data
Streams returns immediately and sets the status of the stream to UPDATING. After the update
is complete, Kinesis Data Streams sets the status of the stream back to ACTIVE. Depending
on the size of the stream, the scaling action could take a few minutes to complete. You can
continue to read and write data to your stream while its status is UPDATING. To update the
shard count, Kinesis Data Streams performs splits or merges on individual shards. This can
cause short-lived shards to be created, in addition to the final shards. These short-lived
shards count towards your total shard limit for your account in the Region. When using this
operation, we recommend that you specify a target shard count that is a multiple of 25%
(25%, 50%, 75%, 100%). You can specify any target value within your shard limit. However,
if you specify a target that isn't a multiple of 25%, the scaling action might take longer
to complete.  This operation has the following default limits. By default, you cannot do
the following:   Scale more than ten times per rolling 24-hour period per stream   Scale up
to more than double your current shard count for a stream   Scale down below half your
current shard count for a stream   Scale up to more than 10000 shards in a stream   Scale a
stream with more than 10000 shards down unless the result is less than 10000 shards   Scale
up to more than the shard limit for your account   Make over 10 TPS. TPS over 10 will
trigger the LimitExceededException   For the default limits for an Amazon Web Services
account, see Streams Limits in the Amazon Kinesis Data Streams Developer Guide. To request
an increase in the call rate limit, the shard limit for this API, or your overall shard
limit, use the limits form.

# Arguments
- `scaling_type`: The scaling type. Uniform scaling creates shards of equal size.
- `target_shard_count`: The new number of shards. This value has the following default
  limits. By default, you cannot do the following:    Set this value to more than double your
  current shard count for a stream.   Set this value below half your current shard count for
  a stream.   Set this value to more than 10000 shards in a stream (the default limit for
  shard count per stream is 10000 per account per region), unless you request a limit
  increase.   Scale a stream with more than 10000 shards down unless you set this value to
  less than 10000 shards.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"StreamARN"`: The ARN of the stream.
- `"StreamName"`: The name of the stream.
"""
function update_shard_count(
    ScalingType, TargetShardCount; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis(
        "UpdateShardCount",
        Dict{String,Any}(
            "ScalingType" => ScalingType, "TargetShardCount" => TargetShardCount
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_shard_count(
    ScalingType,
    TargetShardCount,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis(
        "UpdateShardCount",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ScalingType" => ScalingType, "TargetShardCount" => TargetShardCount
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_stream_mode(stream_arn, stream_mode_details)
    update_stream_mode(stream_arn, stream_mode_details, params::Dict{String,<:Any})

 Updates the capacity mode of the data stream. Currently, in Kinesis Data Streams, you can
choose between an on-demand capacity mode and a provisioned capacity mode for your data
stream.

# Arguments
- `stream_arn`:  Specifies the ARN of the data stream whose capacity mode you want to
  update.
- `stream_mode_details`:  Specifies the capacity mode to which you want to set your data
  stream. Currently, in Kinesis Data Streams, you can choose between an on-demand capacity
  mode and a provisioned capacity mode for your data streams.

"""
function update_stream_mode(
    StreamARN, StreamModeDetails; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis(
        "UpdateStreamMode",
        Dict{String,Any}(
            "StreamARN" => StreamARN, "StreamModeDetails" => StreamModeDetails
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_stream_mode(
    StreamARN,
    StreamModeDetails,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis(
        "UpdateStreamMode",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "StreamARN" => StreamARN, "StreamModeDetails" => StreamModeDetails
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: kendra_ranking
using AWS.Compat
using AWS.UUIDs

"""
    create_rescore_execution_plan(name)
    create_rescore_execution_plan(name, params::Dict{String,<:Any})

Creates a rescore execution plan. A rescore execution plan is an Amazon Kendra Intelligent
Ranking resource used for provisioning the Rescore API. You set the number of capacity
units that you require for Amazon Kendra Intelligent Ranking to rescore or re-rank a search
service's results. For an example of using the CreateRescoreExecutionPlan API, including
using the Python and Java SDKs, see Semantically ranking a search service's results.

# Arguments
- `name`: A name for the rescore execution plan.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CapacityUnits"`: You can set additional capacity units to meet the needs of your
  rescore execution plan. You are given a single capacity unit by default. If you want to use
  the default capacity, you don't set additional capacity units. For more information on the
  default capacity and additional capacity units, see Adjusting capacity.
- `"ClientToken"`: A token that you provide to identify the request to create a rescore
  execution plan. Multiple calls to the CreateRescoreExecutionPlanRequest API with the same
  client token will create only one rescore execution plan.
- `"Description"`: A description for the rescore execution plan.
- `"Tags"`: A list of key-value pairs that identify or categorize your rescore execution
  plan. You can also use tags to help control access to the rescore execution plan. Tag keys
  and values can consist of Unicode letters, digits, white space, and any of the following
  symbols: _ . : / = + - @.
"""
function create_rescore_execution_plan(
    Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra_ranking(
        "CreateRescoreExecutionPlan",
        Dict{String,Any}("Name" => Name, "ClientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_rescore_execution_plan(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra_ranking(
        "CreateRescoreExecutionPlan",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Name" => Name, "ClientToken" => string(uuid4())),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_rescore_execution_plan(id)
    delete_rescore_execution_plan(id, params::Dict{String,<:Any})

Deletes a rescore execution plan. A rescore execution plan is an Amazon Kendra Intelligent
Ranking resource used for provisioning the Rescore API.

# Arguments
- `id`: The identifier of the rescore execution plan that you want to delete.

"""
function delete_rescore_execution_plan(
    Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra_ranking(
        "DeleteRescoreExecutionPlan",
        Dict{String,Any}("Id" => Id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_rescore_execution_plan(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra_ranking(
        "DeleteRescoreExecutionPlan",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Id" => Id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_rescore_execution_plan(id)
    describe_rescore_execution_plan(id, params::Dict{String,<:Any})

Gets information about a rescore execution plan. A rescore execution plan is an Amazon
Kendra Intelligent Ranking resource used for provisioning the Rescore API.

# Arguments
- `id`: The identifier of the rescore execution plan that you want to get information on.

"""
function describe_rescore_execution_plan(
    Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra_ranking(
        "DescribeRescoreExecutionPlan",
        Dict{String,Any}("Id" => Id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_rescore_execution_plan(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra_ranking(
        "DescribeRescoreExecutionPlan",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Id" => Id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_rescore_execution_plans()
    list_rescore_execution_plans(params::Dict{String,<:Any})

Lists your rescore execution plans. A rescore execution plan is an Amazon Kendra
Intelligent Ranking resource used for provisioning the Rescore API.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of rescore execution plans to return.
- `"NextToken"`: If the response is truncated, Amazon Kendra Intelligent Ranking returns a
  pagination token in the response. You can use this pagination token to retrieve the next
  set of rescore execution plans.
"""
function list_rescore_execution_plans(; aws_config::AbstractAWSConfig=current_aws_config())
    return kendra_ranking(
        "ListRescoreExecutionPlans"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_rescore_execution_plans(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra_ranking(
        "ListRescoreExecutionPlans",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Gets a list of tags associated with a specified resource. A rescore execution plan is an
example of a resource that can have tags associated with it.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the rescore execution plan to get a
  list of tags for.

"""
function list_tags_for_resource(
    ResourceARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra_ranking(
        "ListTagsForResource",
        Dict{String,Any}("ResourceARN" => ResourceARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra_ranking(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceARN" => ResourceARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    rescore(documents, rescore_execution_plan_id, search_query)
    rescore(documents, rescore_execution_plan_id, search_query, params::Dict{String,<:Any})

Rescores or re-ranks search results from a search service such as OpenSearch (self
managed). You use the semantic search capabilities of Amazon Kendra Intelligent Ranking to
improve the search service's results.

# Arguments
- `documents`: The list of documents for Amazon Kendra Intelligent Ranking to rescore or
  rank on.
- `rescore_execution_plan_id`: The identifier of the rescore execution plan. A rescore
  execution plan is an Amazon Kendra Intelligent Ranking resource used for provisioning the
  Rescore API.
- `search_query`: The input query from the search service.

"""
function rescore(
    Documents,
    RescoreExecutionPlanId,
    SearchQuery;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra_ranking(
        "Rescore",
        Dict{String,Any}(
            "Documents" => Documents,
            "RescoreExecutionPlanId" => RescoreExecutionPlanId,
            "SearchQuery" => SearchQuery,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function rescore(
    Documents,
    RescoreExecutionPlanId,
    SearchQuery,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra_ranking(
        "Rescore",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Documents" => Documents,
                    "RescoreExecutionPlanId" => RescoreExecutionPlanId,
                    "SearchQuery" => SearchQuery,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds a specified tag to a specified rescore execution plan. A rescore execution plan is an
Amazon Kendra Intelligent Ranking resource used for provisioning the Rescore API. If the
tag already exists, the existing value is replaced with the new value.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the rescore execution plan to tag.
- `tags`: A list of tag keys to add to a rescore execution plan. If a tag already exists,
  the existing value is replaced with the new value.

"""
function tag_resource(ResourceARN, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return kendra_ranking(
        "TagResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceARN,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra_ranking(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes a tag from a rescore execution plan. A rescore execution plan is an Amazon Kendra
Intelligent Ranking resource used for provisioning the Rescore operation.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the rescore execution plan to remove
  the tag.
- `tag_keys`: A list of tag keys to remove from the rescore execution plan. If a tag key
  does not exist on the resource, it is ignored.

"""
function untag_resource(
    ResourceARN, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra_ranking(
        "UntagResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceARN,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra_ranking(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_rescore_execution_plan(id)
    update_rescore_execution_plan(id, params::Dict{String,<:Any})

Updates a rescore execution plan. A rescore execution plan is an Amazon Kendra Intelligent
Ranking resource used for provisioning the Rescore API. You can update the number of
capacity units you require for Amazon Kendra Intelligent Ranking to rescore or re-rank a
search service's results.

# Arguments
- `id`: The identifier of the rescore execution plan that you want to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CapacityUnits"`: You can set additional capacity units to meet the needs of your
  rescore execution plan. You are given a single capacity unit by default. If you want to use
  the default capacity, you don't set additional capacity units. For more information on the
  default capacity and additional capacity units, see Adjusting capacity.
- `"Description"`: A new description for the rescore execution plan.
- `"Name"`: A new name for the rescore execution plan.
"""
function update_rescore_execution_plan(
    Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra_ranking(
        "UpdateRescoreExecutionPlan",
        Dict{String,Any}("Id" => Id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_rescore_execution_plan(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra_ranking(
        "UpdateRescoreExecutionPlan",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Id" => Id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: pinpoint
using AWS.Compat
using AWS.UUIDs

"""
    create_app(create_application_request)
    create_app(create_application_request, params::Dict{String,<:Any})

 Creates an application.

# Arguments
- `create_application_request`:

"""
function create_app(
    CreateApplicationRequest; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "POST",
        "/v1/apps",
        Dict{String,Any}("CreateApplicationRequest" => CreateApplicationRequest);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_app(
    CreateApplicationRequest,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "POST",
        "/v1/apps",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("CreateApplicationRequest" => CreateApplicationRequest),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_campaign(write_campaign_request, application-id)
    create_campaign(write_campaign_request, application-id, params::Dict{String,<:Any})

Creates a new campaign for an application or updates the settings of an existing campaign
for an application.

# Arguments
- `write_campaign_request`:
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.

"""
function create_campaign(
    WriteCampaignRequest, application_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "POST",
        "/v1/apps/$(application-id)/campaigns",
        Dict{String,Any}("WriteCampaignRequest" => WriteCampaignRequest);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_campaign(
    WriteCampaignRequest,
    application_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "POST",
        "/v1/apps/$(application-id)/campaigns",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("WriteCampaignRequest" => WriteCampaignRequest),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_email_template(email_template_request, template-name)
    create_email_template(email_template_request, template-name, params::Dict{String,<:Any})

Creates a message template for messages that are sent through the email channel.

# Arguments
- `email_template_request`:
- `template-name`: The name of the message template. A template name must start with an
  alphanumeric character and can contain a maximum of 128 characters. The characters can be
  alphanumeric characters, underscores (_), or hyphens (-). Template names are case sensitive.

"""
function create_email_template(
    EmailTemplateRequest, template_name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "POST",
        "/v1/templates/$(template-name)/email",
        Dict{String,Any}("EmailTemplateRequest" => EmailTemplateRequest);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_email_template(
    EmailTemplateRequest,
    template_name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "POST",
        "/v1/templates/$(template-name)/email",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("EmailTemplateRequest" => EmailTemplateRequest),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_export_job(export_job_request, application-id)
    create_export_job(export_job_request, application-id, params::Dict{String,<:Any})

Creates an export job for an application.

# Arguments
- `export_job_request`:
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.

"""
function create_export_job(
    ExportJobRequest, application_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "POST",
        "/v1/apps/$(application-id)/jobs/export",
        Dict{String,Any}("ExportJobRequest" => ExportJobRequest);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_export_job(
    ExportJobRequest,
    application_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "POST",
        "/v1/apps/$(application-id)/jobs/export",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ExportJobRequest" => ExportJobRequest), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_import_job(import_job_request, application-id)
    create_import_job(import_job_request, application-id, params::Dict{String,<:Any})

Creates an import job for an application.

# Arguments
- `import_job_request`:
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.

"""
function create_import_job(
    ImportJobRequest, application_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "POST",
        "/v1/apps/$(application-id)/jobs/import",
        Dict{String,Any}("ImportJobRequest" => ImportJobRequest);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_import_job(
    ImportJobRequest,
    application_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "POST",
        "/v1/apps/$(application-id)/jobs/import",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ImportJobRequest" => ImportJobRequest), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_in_app_template(in_app_template_request, template-name)
    create_in_app_template(in_app_template_request, template-name, params::Dict{String,<:Any})

Creates a new message template for messages using the in-app message channel.

# Arguments
- `in_app_template_request`:
- `template-name`: The name of the message template. A template name must start with an
  alphanumeric character and can contain a maximum of 128 characters. The characters can be
  alphanumeric characters, underscores (_), or hyphens (-). Template names are case sensitive.

"""
function create_in_app_template(
    InAppTemplateRequest, template_name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "POST",
        "/v1/templates/$(template-name)/inapp",
        Dict{String,Any}("InAppTemplateRequest" => InAppTemplateRequest);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_in_app_template(
    InAppTemplateRequest,
    template_name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "POST",
        "/v1/templates/$(template-name)/inapp",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("InAppTemplateRequest" => InAppTemplateRequest),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_journey(write_journey_request, application-id)
    create_journey(write_journey_request, application-id, params::Dict{String,<:Any})

Creates a journey for an application.

# Arguments
- `write_journey_request`:
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.

"""
function create_journey(
    WriteJourneyRequest, application_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "POST",
        "/v1/apps/$(application-id)/journeys",
        Dict{String,Any}("WriteJourneyRequest" => WriteJourneyRequest);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_journey(
    WriteJourneyRequest,
    application_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "POST",
        "/v1/apps/$(application-id)/journeys",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("WriteJourneyRequest" => WriteJourneyRequest),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_push_template(push_notification_template_request, template-name)
    create_push_template(push_notification_template_request, template-name, params::Dict{String,<:Any})

Creates a message template for messages that are sent through a push notification channel.

# Arguments
- `push_notification_template_request`:
- `template-name`: The name of the message template. A template name must start with an
  alphanumeric character and can contain a maximum of 128 characters. The characters can be
  alphanumeric characters, underscores (_), or hyphens (-). Template names are case sensitive.

"""
function create_push_template(
    PushNotificationTemplateRequest,
    template_name;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "POST",
        "/v1/templates/$(template-name)/push",
        Dict{String,Any}(
            "PushNotificationTemplateRequest" => PushNotificationTemplateRequest
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_push_template(
    PushNotificationTemplateRequest,
    template_name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "POST",
        "/v1/templates/$(template-name)/push",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "PushNotificationTemplateRequest" => PushNotificationTemplateRequest
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_recommender_configuration(create_recommender_configuration)
    create_recommender_configuration(create_recommender_configuration, params::Dict{String,<:Any})

Creates an Amazon Pinpoint configuration for a recommender model.

# Arguments
- `create_recommender_configuration`:

"""
function create_recommender_configuration(
    CreateRecommenderConfiguration; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "POST",
        "/v1/recommenders",
        Dict{String,Any}(
            "CreateRecommenderConfiguration" => CreateRecommenderConfiguration
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_recommender_configuration(
    CreateRecommenderConfiguration,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "POST",
        "/v1/recommenders",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CreateRecommenderConfiguration" => CreateRecommenderConfiguration
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_segment(write_segment_request, application-id)
    create_segment(write_segment_request, application-id, params::Dict{String,<:Any})

Creates a new segment for an application or updates the configuration, dimension, and other
settings for an existing segment that's associated with an application.

# Arguments
- `write_segment_request`:
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.

"""
function create_segment(
    WriteSegmentRequest, application_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "POST",
        "/v1/apps/$(application-id)/segments",
        Dict{String,Any}("WriteSegmentRequest" => WriteSegmentRequest);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_segment(
    WriteSegmentRequest,
    application_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "POST",
        "/v1/apps/$(application-id)/segments",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("WriteSegmentRequest" => WriteSegmentRequest),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_sms_template(smstemplate_request, template-name)
    create_sms_template(smstemplate_request, template-name, params::Dict{String,<:Any})

Creates a message template for messages that are sent through the SMS channel.

# Arguments
- `smstemplate_request`:
- `template-name`: The name of the message template. A template name must start with an
  alphanumeric character and can contain a maximum of 128 characters. The characters can be
  alphanumeric characters, underscores (_), or hyphens (-). Template names are case sensitive.

"""
function create_sms_template(
    SMSTemplateRequest, template_name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "POST",
        "/v1/templates/$(template-name)/sms",
        Dict{String,Any}("SMSTemplateRequest" => SMSTemplateRequest);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_sms_template(
    SMSTemplateRequest,
    template_name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "POST",
        "/v1/templates/$(template-name)/sms",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("SMSTemplateRequest" => SMSTemplateRequest), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_voice_template(voice_template_request, template-name)
    create_voice_template(voice_template_request, template-name, params::Dict{String,<:Any})

Creates a message template for messages that are sent through the voice channel.

# Arguments
- `voice_template_request`:
- `template-name`: The name of the message template. A template name must start with an
  alphanumeric character and can contain a maximum of 128 characters. The characters can be
  alphanumeric characters, underscores (_), or hyphens (-). Template names are case sensitive.

"""
function create_voice_template(
    VoiceTemplateRequest, template_name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "POST",
        "/v1/templates/$(template-name)/voice",
        Dict{String,Any}("VoiceTemplateRequest" => VoiceTemplateRequest);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_voice_template(
    VoiceTemplateRequest,
    template_name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "POST",
        "/v1/templates/$(template-name)/voice",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("VoiceTemplateRequest" => VoiceTemplateRequest),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_adm_channel(application-id)
    delete_adm_channel(application-id, params::Dict{String,<:Any})

Disables the ADM channel for an application and deletes any existing settings for the
channel.

# Arguments
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.

"""
function delete_adm_channel(
    application_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "DELETE",
        "/v1/apps/$(application-id)/channels/adm";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_adm_channel(
    application_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "DELETE",
        "/v1/apps/$(application-id)/channels/adm",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_apns_channel(application-id)
    delete_apns_channel(application-id, params::Dict{String,<:Any})

Disables the APNs channel for an application and deletes any existing settings for the
channel.

# Arguments
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.

"""
function delete_apns_channel(
    application_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "DELETE",
        "/v1/apps/$(application-id)/channels/apns";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_apns_channel(
    application_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "DELETE",
        "/v1/apps/$(application-id)/channels/apns",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_apns_sandbox_channel(application-id)
    delete_apns_sandbox_channel(application-id, params::Dict{String,<:Any})

Disables the APNs sandbox channel for an application and deletes any existing settings for
the channel.

# Arguments
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.

"""
function delete_apns_sandbox_channel(
    application_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "DELETE",
        "/v1/apps/$(application-id)/channels/apns_sandbox";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_apns_sandbox_channel(
    application_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "DELETE",
        "/v1/apps/$(application-id)/channels/apns_sandbox",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_apns_voip_channel(application-id)
    delete_apns_voip_channel(application-id, params::Dict{String,<:Any})

Disables the APNs VoIP channel for an application and deletes any existing settings for the
channel.

# Arguments
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.

"""
function delete_apns_voip_channel(
    application_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "DELETE",
        "/v1/apps/$(application-id)/channels/apns_voip";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_apns_voip_channel(
    application_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "DELETE",
        "/v1/apps/$(application-id)/channels/apns_voip",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_apns_voip_sandbox_channel(application-id)
    delete_apns_voip_sandbox_channel(application-id, params::Dict{String,<:Any})

Disables the APNs VoIP sandbox channel for an application and deletes any existing settings
for the channel.

# Arguments
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.

"""
function delete_apns_voip_sandbox_channel(
    application_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "DELETE",
        "/v1/apps/$(application-id)/channels/apns_voip_sandbox";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_apns_voip_sandbox_channel(
    application_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "DELETE",
        "/v1/apps/$(application-id)/channels/apns_voip_sandbox",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_app(application-id)
    delete_app(application-id, params::Dict{String,<:Any})

Deletes an application.

# Arguments
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.

"""
function delete_app(application_id; aws_config::AbstractAWSConfig=current_aws_config())
    return pinpoint(
        "DELETE",
        "/v1/apps/$(application-id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_app(
    application_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "DELETE",
        "/v1/apps/$(application-id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_baidu_channel(application-id)
    delete_baidu_channel(application-id, params::Dict{String,<:Any})

Disables the Baidu channel for an application and deletes any existing settings for the
channel.

# Arguments
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.

"""
function delete_baidu_channel(
    application_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "DELETE",
        "/v1/apps/$(application-id)/channels/baidu";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_baidu_channel(
    application_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "DELETE",
        "/v1/apps/$(application-id)/channels/baidu",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_campaign(application-id, campaign-id)
    delete_campaign(application-id, campaign-id, params::Dict{String,<:Any})

Deletes a campaign from an application.

# Arguments
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.
- `campaign-id`: The unique identifier for the campaign.

"""
function delete_campaign(
    application_id, campaign_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "DELETE",
        "/v1/apps/$(application-id)/campaigns/$(campaign-id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_campaign(
    application_id,
    campaign_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "DELETE",
        "/v1/apps/$(application-id)/campaigns/$(campaign-id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_email_channel(application-id)
    delete_email_channel(application-id, params::Dict{String,<:Any})

Disables the email channel for an application and deletes any existing settings for the
channel.

# Arguments
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.

"""
function delete_email_channel(
    application_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "DELETE",
        "/v1/apps/$(application-id)/channels/email";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_email_channel(
    application_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "DELETE",
        "/v1/apps/$(application-id)/channels/email",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_email_template(template-name)
    delete_email_template(template-name, params::Dict{String,<:Any})

Deletes a message template for messages that were sent through the email channel.

# Arguments
- `template-name`: The name of the message template. A template name must start with an
  alphanumeric character and can contain a maximum of 128 characters. The characters can be
  alphanumeric characters, underscores (_), or hyphens (-). Template names are case sensitive.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"version"`: The unique identifier for the version of the message template to update,
  retrieve information about, or delete. To retrieve identifiers and other information for
  all the versions of a template, use the Template Versions resource. If specified, this
  value must match the identifier for an existing template version. If specified for an
  update operation, this value must match the identifier for the latest existing version of
  the template. This restriction helps ensure that race conditions don't occur. If you don't
  specify a value for this parameter, Amazon Pinpoint does the following: For a get
  operation, retrieves information about the active version of the template. For an update
  operation, saves the updates to (overwrites) the latest existing version of the template,
  if the create-new-version parameter isn't used or is set to false. For a delete operation,
  deletes the template, including all versions of the template.
"""
function delete_email_template(
    template_name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "DELETE",
        "/v1/templates/$(template-name)/email";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_email_template(
    template_name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "DELETE",
        "/v1/templates/$(template-name)/email",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_endpoint(application-id, endpoint-id)
    delete_endpoint(application-id, endpoint-id, params::Dict{String,<:Any})

Deletes an endpoint from an application.

# Arguments
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.
- `endpoint-id`: The case insensitive unique identifier for the endpoint. The identifier
  can't contain , { or }.

"""
function delete_endpoint(
    application_id, endpoint_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "DELETE",
        "/v1/apps/$(application-id)/endpoints/$(endpoint-id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_endpoint(
    application_id,
    endpoint_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "DELETE",
        "/v1/apps/$(application-id)/endpoints/$(endpoint-id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_event_stream(application-id)
    delete_event_stream(application-id, params::Dict{String,<:Any})

Deletes the event stream for an application.

# Arguments
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.

"""
function delete_event_stream(
    application_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "DELETE",
        "/v1/apps/$(application-id)/eventstream";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_event_stream(
    application_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "DELETE",
        "/v1/apps/$(application-id)/eventstream",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_gcm_channel(application-id)
    delete_gcm_channel(application-id, params::Dict{String,<:Any})

Disables the GCM channel for an application and deletes any existing settings for the
channel.

# Arguments
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.

"""
function delete_gcm_channel(
    application_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "DELETE",
        "/v1/apps/$(application-id)/channels/gcm";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_gcm_channel(
    application_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "DELETE",
        "/v1/apps/$(application-id)/channels/gcm",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_in_app_template(template-name)
    delete_in_app_template(template-name, params::Dict{String,<:Any})

Deletes a message template for messages sent using the in-app message channel.

# Arguments
- `template-name`: The name of the message template. A template name must start with an
  alphanumeric character and can contain a maximum of 128 characters. The characters can be
  alphanumeric characters, underscores (_), or hyphens (-). Template names are case sensitive.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"version"`: The unique identifier for the version of the message template to update,
  retrieve information about, or delete. To retrieve identifiers and other information for
  all the versions of a template, use the Template Versions resource. If specified, this
  value must match the identifier for an existing template version. If specified for an
  update operation, this value must match the identifier for the latest existing version of
  the template. This restriction helps ensure that race conditions don't occur. If you don't
  specify a value for this parameter, Amazon Pinpoint does the following: For a get
  operation, retrieves information about the active version of the template. For an update
  operation, saves the updates to (overwrites) the latest existing version of the template,
  if the create-new-version parameter isn't used or is set to false. For a delete operation,
  deletes the template, including all versions of the template.
"""
function delete_in_app_template(
    template_name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "DELETE",
        "/v1/templates/$(template-name)/inapp";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_in_app_template(
    template_name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "DELETE",
        "/v1/templates/$(template-name)/inapp",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_journey(application-id, journey-id)
    delete_journey(application-id, journey-id, params::Dict{String,<:Any})

Deletes a journey from an application.

# Arguments
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.
- `journey-id`: The unique identifier for the journey.

"""
function delete_journey(
    application_id, journey_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "DELETE",
        "/v1/apps/$(application-id)/journeys/$(journey-id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_journey(
    application_id,
    journey_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "DELETE",
        "/v1/apps/$(application-id)/journeys/$(journey-id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_push_template(template-name)
    delete_push_template(template-name, params::Dict{String,<:Any})

Deletes a message template for messages that were sent through a push notification channel.

# Arguments
- `template-name`: The name of the message template. A template name must start with an
  alphanumeric character and can contain a maximum of 128 characters. The characters can be
  alphanumeric characters, underscores (_), or hyphens (-). Template names are case sensitive.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"version"`: The unique identifier for the version of the message template to update,
  retrieve information about, or delete. To retrieve identifiers and other information for
  all the versions of a template, use the Template Versions resource. If specified, this
  value must match the identifier for an existing template version. If specified for an
  update operation, this value must match the identifier for the latest existing version of
  the template. This restriction helps ensure that race conditions don't occur. If you don't
  specify a value for this parameter, Amazon Pinpoint does the following: For a get
  operation, retrieves information about the active version of the template. For an update
  operation, saves the updates to (overwrites) the latest existing version of the template,
  if the create-new-version parameter isn't used or is set to false. For a delete operation,
  deletes the template, including all versions of the template.
"""
function delete_push_template(
    template_name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "DELETE",
        "/v1/templates/$(template-name)/push";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_push_template(
    template_name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "DELETE",
        "/v1/templates/$(template-name)/push",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_recommender_configuration(recommender-id)
    delete_recommender_configuration(recommender-id, params::Dict{String,<:Any})

Deletes an Amazon Pinpoint configuration for a recommender model.

# Arguments
- `recommender-id`: The unique identifier for the recommender model configuration. This
  identifier is displayed as the Recommender ID on the Amazon Pinpoint console.

"""
function delete_recommender_configuration(
    recommender_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "DELETE",
        "/v1/recommenders/$(recommender-id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_recommender_configuration(
    recommender_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "DELETE",
        "/v1/recommenders/$(recommender-id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_segment(application-id, segment-id)
    delete_segment(application-id, segment-id, params::Dict{String,<:Any})

Deletes a segment from an application.

# Arguments
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.
- `segment-id`: The unique identifier for the segment.

"""
function delete_segment(
    application_id, segment_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "DELETE",
        "/v1/apps/$(application-id)/segments/$(segment-id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_segment(
    application_id,
    segment_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "DELETE",
        "/v1/apps/$(application-id)/segments/$(segment-id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_sms_channel(application-id)
    delete_sms_channel(application-id, params::Dict{String,<:Any})

Disables the SMS channel for an application and deletes any existing settings for the
channel.

# Arguments
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.

"""
function delete_sms_channel(
    application_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "DELETE",
        "/v1/apps/$(application-id)/channels/sms";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_sms_channel(
    application_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "DELETE",
        "/v1/apps/$(application-id)/channels/sms",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_sms_template(template-name)
    delete_sms_template(template-name, params::Dict{String,<:Any})

Deletes a message template for messages that were sent through the SMS channel.

# Arguments
- `template-name`: The name of the message template. A template name must start with an
  alphanumeric character and can contain a maximum of 128 characters. The characters can be
  alphanumeric characters, underscores (_), or hyphens (-). Template names are case sensitive.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"version"`: The unique identifier for the version of the message template to update,
  retrieve information about, or delete. To retrieve identifiers and other information for
  all the versions of a template, use the Template Versions resource. If specified, this
  value must match the identifier for an existing template version. If specified for an
  update operation, this value must match the identifier for the latest existing version of
  the template. This restriction helps ensure that race conditions don't occur. If you don't
  specify a value for this parameter, Amazon Pinpoint does the following: For a get
  operation, retrieves information about the active version of the template. For an update
  operation, saves the updates to (overwrites) the latest existing version of the template,
  if the create-new-version parameter isn't used or is set to false. For a delete operation,
  deletes the template, including all versions of the template.
"""
function delete_sms_template(
    template_name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "DELETE",
        "/v1/templates/$(template-name)/sms";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_sms_template(
    template_name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "DELETE",
        "/v1/templates/$(template-name)/sms",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_user_endpoints(application-id, user-id)
    delete_user_endpoints(application-id, user-id, params::Dict{String,<:Any})

Deletes all the endpoints that are associated with a specific user ID.

# Arguments
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.
- `user-id`: The unique identifier for the user.

"""
function delete_user_endpoints(
    application_id, user_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "DELETE",
        "/v1/apps/$(application-id)/users/$(user-id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_user_endpoints(
    application_id,
    user_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "DELETE",
        "/v1/apps/$(application-id)/users/$(user-id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_voice_channel(application-id)
    delete_voice_channel(application-id, params::Dict{String,<:Any})

Disables the voice channel for an application and deletes any existing settings for the
channel.

# Arguments
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.

"""
function delete_voice_channel(
    application_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "DELETE",
        "/v1/apps/$(application-id)/channels/voice";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_voice_channel(
    application_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "DELETE",
        "/v1/apps/$(application-id)/channels/voice",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_voice_template(template-name)
    delete_voice_template(template-name, params::Dict{String,<:Any})

Deletes a message template for messages that were sent through the voice channel.

# Arguments
- `template-name`: The name of the message template. A template name must start with an
  alphanumeric character and can contain a maximum of 128 characters. The characters can be
  alphanumeric characters, underscores (_), or hyphens (-). Template names are case sensitive.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"version"`: The unique identifier for the version of the message template to update,
  retrieve information about, or delete. To retrieve identifiers and other information for
  all the versions of a template, use the Template Versions resource. If specified, this
  value must match the identifier for an existing template version. If specified for an
  update operation, this value must match the identifier for the latest existing version of
  the template. This restriction helps ensure that race conditions don't occur. If you don't
  specify a value for this parameter, Amazon Pinpoint does the following: For a get
  operation, retrieves information about the active version of the template. For an update
  operation, saves the updates to (overwrites) the latest existing version of the template,
  if the create-new-version parameter isn't used or is set to false. For a delete operation,
  deletes the template, including all versions of the template.
"""
function delete_voice_template(
    template_name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "DELETE",
        "/v1/templates/$(template-name)/voice";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_voice_template(
    template_name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "DELETE",
        "/v1/templates/$(template-name)/voice",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_adm_channel(application-id)
    get_adm_channel(application-id, params::Dict{String,<:Any})

Retrieves information about the status and settings of the ADM channel for an application.

# Arguments
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.

"""
function get_adm_channel(application_id; aws_config::AbstractAWSConfig=current_aws_config())
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/channels/adm";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_adm_channel(
    application_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/channels/adm",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_apns_channel(application-id)
    get_apns_channel(application-id, params::Dict{String,<:Any})

Retrieves information about the status and settings of the APNs channel for an application.

# Arguments
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.

"""
function get_apns_channel(
    application_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/channels/apns";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_apns_channel(
    application_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/channels/apns",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_apns_sandbox_channel(application-id)
    get_apns_sandbox_channel(application-id, params::Dict{String,<:Any})

Retrieves information about the status and settings of the APNs sandbox channel for an
application.

# Arguments
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.

"""
function get_apns_sandbox_channel(
    application_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/channels/apns_sandbox";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_apns_sandbox_channel(
    application_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/channels/apns_sandbox",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_apns_voip_channel(application-id)
    get_apns_voip_channel(application-id, params::Dict{String,<:Any})

Retrieves information about the status and settings of the APNs VoIP channel for an
application.

# Arguments
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.

"""
function get_apns_voip_channel(
    application_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/channels/apns_voip";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_apns_voip_channel(
    application_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/channels/apns_voip",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_apns_voip_sandbox_channel(application-id)
    get_apns_voip_sandbox_channel(application-id, params::Dict{String,<:Any})

Retrieves information about the status and settings of the APNs VoIP sandbox channel for an
application.

# Arguments
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.

"""
function get_apns_voip_sandbox_channel(
    application_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/channels/apns_voip_sandbox";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_apns_voip_sandbox_channel(
    application_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/channels/apns_voip_sandbox",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_app(application-id)
    get_app(application-id, params::Dict{String,<:Any})

Retrieves information about an application.

# Arguments
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.

"""
function get_app(application_id; aws_config::AbstractAWSConfig=current_aws_config())
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_app(
    application_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_application_date_range_kpi(application-id, kpi-name)
    get_application_date_range_kpi(application-id, kpi-name, params::Dict{String,<:Any})

Retrieves (queries) pre-aggregated data for a standard metric that applies to an
application.

# Arguments
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.
- `kpi-name`: The name of the metric, also referred to as a key performance indicator
  (KPI), to retrieve data for. This value describes the associated metric and consists of two
  or more terms, which are comprised of lowercase alphanumeric characters, separated by a
  hyphen. Examples are email-open-rate and successful-delivery-rate. For a list of valid
  values, see the Amazon Pinpoint Developer Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"end-time"`: The last date and time to retrieve data for, as part of an inclusive date
  range that filters the query results. This value should be in extended ISO 8601 format and
  use Coordinated Universal Time (UTC), for example: 2019-07-26T20:00:00Z for 8:00 PM UTC
  July 26, 2019.
- `"next-token"`: The  string that specifies which page of results to return in a paginated
  response. This parameter is not supported for application, campaign, and journey metrics.
- `"page-size"`: The maximum number of items to include in each page of a paginated
  response. This parameter is not supported for application, campaign, and journey metrics.
- `"start-time"`: The first date and time to retrieve data for, as part of an inclusive
  date range that filters the query results. This value should be in extended ISO 8601 format
  and use Coordinated Universal Time (UTC), for example: 2019-07-19T20:00:00Z for 8:00 PM UTC
  July 19, 2019. This value should also be fewer than 90 days from the current day.
"""
function get_application_date_range_kpi(
    application_id, kpi_name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/kpis/daterange/$(kpi-name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_application_date_range_kpi(
    application_id,
    kpi_name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/kpis/daterange/$(kpi-name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_application_settings(application-id)
    get_application_settings(application-id, params::Dict{String,<:Any})

Retrieves information about the settings for an application.

# Arguments
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.

"""
function get_application_settings(
    application_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/settings";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_application_settings(
    application_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/settings",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_apps()
    get_apps(params::Dict{String,<:Any})

Retrieves information about all the applications that are associated with your Amazon
Pinpoint account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"page-size"`: The maximum number of items to include in each page of a paginated
  response. This parameter is not supported for application, campaign, and journey metrics.
- `"token"`: The NextToken string that specifies which page of results to return in a
  paginated response.
"""
function get_apps(; aws_config::AbstractAWSConfig=current_aws_config())
    return pinpoint(
        "GET", "/v1/apps"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_apps(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "GET", "/v1/apps", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_baidu_channel(application-id)
    get_baidu_channel(application-id, params::Dict{String,<:Any})

Retrieves information about the status and settings of the Baidu channel for an application.

# Arguments
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.

"""
function get_baidu_channel(
    application_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/channels/baidu";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_baidu_channel(
    application_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/channels/baidu",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_campaign(application-id, campaign-id)
    get_campaign(application-id, campaign-id, params::Dict{String,<:Any})

Retrieves information about the status, configuration, and other settings for a campaign.

# Arguments
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.
- `campaign-id`: The unique identifier for the campaign.

"""
function get_campaign(
    application_id, campaign_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/campaigns/$(campaign-id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_campaign(
    application_id,
    campaign_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/campaigns/$(campaign-id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_campaign_activities(application-id, campaign-id)
    get_campaign_activities(application-id, campaign-id, params::Dict{String,<:Any})

Retrieves information about all the activities for a campaign.

# Arguments
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.
- `campaign-id`: The unique identifier for the campaign.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"page-size"`: The maximum number of items to include in each page of a paginated
  response. This parameter is not supported for application, campaign, and journey metrics.
- `"token"`: The NextToken string that specifies which page of results to return in a
  paginated response.
"""
function get_campaign_activities(
    application_id, campaign_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/campaigns/$(campaign-id)/activities";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_campaign_activities(
    application_id,
    campaign_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/campaigns/$(campaign-id)/activities",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_campaign_date_range_kpi(application-id, campaign-id, kpi-name)
    get_campaign_date_range_kpi(application-id, campaign-id, kpi-name, params::Dict{String,<:Any})

Retrieves (queries) pre-aggregated data for a standard metric that applies to a campaign.

# Arguments
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.
- `campaign-id`: The unique identifier for the campaign.
- `kpi-name`: The name of the metric, also referred to as a key performance indicator
  (KPI), to retrieve data for. This value describes the associated metric and consists of two
  or more terms, which are comprised of lowercase alphanumeric characters, separated by a
  hyphen. Examples are email-open-rate and successful-delivery-rate. For a list of valid
  values, see the Amazon Pinpoint Developer Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"end-time"`: The last date and time to retrieve data for, as part of an inclusive date
  range that filters the query results. This value should be in extended ISO 8601 format and
  use Coordinated Universal Time (UTC), for example: 2019-07-26T20:00:00Z for 8:00 PM UTC
  July 26, 2019.
- `"next-token"`: The  string that specifies which page of results to return in a paginated
  response. This parameter is not supported for application, campaign, and journey metrics.
- `"page-size"`: The maximum number of items to include in each page of a paginated
  response. This parameter is not supported for application, campaign, and journey metrics.
- `"start-time"`: The first date and time to retrieve data for, as part of an inclusive
  date range that filters the query results. This value should be in extended ISO 8601 format
  and use Coordinated Universal Time (UTC), for example: 2019-07-19T20:00:00Z for 8:00 PM UTC
  July 19, 2019. This value should also be fewer than 90 days from the current day.
"""
function get_campaign_date_range_kpi(
    application_id,
    campaign_id,
    kpi_name;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/campaigns/$(campaign-id)/kpis/daterange/$(kpi-name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_campaign_date_range_kpi(
    application_id,
    campaign_id,
    kpi_name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/campaigns/$(campaign-id)/kpis/daterange/$(kpi-name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_campaign_version(application-id, campaign-id, version)
    get_campaign_version(application-id, campaign-id, version, params::Dict{String,<:Any})

Retrieves information about the status, configuration, and other settings for a specific
version of a campaign.

# Arguments
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.
- `campaign-id`: The unique identifier for the campaign.
- `version`: The unique version number (Version property) for the campaign version.

"""
function get_campaign_version(
    application_id, campaign_id, version; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/campaigns/$(campaign-id)/versions/$(version)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_campaign_version(
    application_id,
    campaign_id,
    version,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/campaigns/$(campaign-id)/versions/$(version)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_campaign_versions(application-id, campaign-id)
    get_campaign_versions(application-id, campaign-id, params::Dict{String,<:Any})

Retrieves information about the status, configuration, and other settings for all versions
of a campaign.

# Arguments
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.
- `campaign-id`: The unique identifier for the campaign.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"page-size"`: The maximum number of items to include in each page of a paginated
  response. This parameter is not supported for application, campaign, and journey metrics.
- `"token"`: The NextToken string that specifies which page of results to return in a
  paginated response.
"""
function get_campaign_versions(
    application_id, campaign_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/campaigns/$(campaign-id)/versions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_campaign_versions(
    application_id,
    campaign_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/campaigns/$(campaign-id)/versions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_campaigns(application-id)
    get_campaigns(application-id, params::Dict{String,<:Any})

Retrieves information about the status, configuration, and other settings for all the
campaigns that are associated with an application.

# Arguments
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"page-size"`: The maximum number of items to include in each page of a paginated
  response. This parameter is not supported for application, campaign, and journey metrics.
- `"token"`: The NextToken string that specifies which page of results to return in a
  paginated response.
"""
function get_campaigns(application_id; aws_config::AbstractAWSConfig=current_aws_config())
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/campaigns";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_campaigns(
    application_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/campaigns",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_channels(application-id)
    get_channels(application-id, params::Dict{String,<:Any})

Retrieves information about the history and status of each channel for an application.

# Arguments
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.

"""
function get_channels(application_id; aws_config::AbstractAWSConfig=current_aws_config())
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/channels";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_channels(
    application_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/channels",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_email_channel(application-id)
    get_email_channel(application-id, params::Dict{String,<:Any})

Retrieves information about the status and settings of the email channel for an application.

# Arguments
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.

"""
function get_email_channel(
    application_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/channels/email";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_email_channel(
    application_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/channels/email",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_email_template(template-name)
    get_email_template(template-name, params::Dict{String,<:Any})

Retrieves the content and settings of a message template for messages that are sent through
the email channel.

# Arguments
- `template-name`: The name of the message template. A template name must start with an
  alphanumeric character and can contain a maximum of 128 characters. The characters can be
  alphanumeric characters, underscores (_), or hyphens (-). Template names are case sensitive.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"version"`: The unique identifier for the version of the message template to update,
  retrieve information about, or delete. To retrieve identifiers and other information for
  all the versions of a template, use the Template Versions resource. If specified, this
  value must match the identifier for an existing template version. If specified for an
  update operation, this value must match the identifier for the latest existing version of
  the template. This restriction helps ensure that race conditions don't occur. If you don't
  specify a value for this parameter, Amazon Pinpoint does the following: For a get
  operation, retrieves information about the active version of the template. For an update
  operation, saves the updates to (overwrites) the latest existing version of the template,
  if the create-new-version parameter isn't used or is set to false. For a delete operation,
  deletes the template, including all versions of the template.
"""
function get_email_template(
    template_name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "GET",
        "/v1/templates/$(template-name)/email";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_email_template(
    template_name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "GET",
        "/v1/templates/$(template-name)/email",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_endpoint(application-id, endpoint-id)
    get_endpoint(application-id, endpoint-id, params::Dict{String,<:Any})

Retrieves information about the settings and attributes of a specific endpoint for an
application.

# Arguments
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.
- `endpoint-id`: The case insensitive unique identifier for the endpoint. The identifier
  can't contain , { or }.

"""
function get_endpoint(
    application_id, endpoint_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/endpoints/$(endpoint-id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_endpoint(
    application_id,
    endpoint_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/endpoints/$(endpoint-id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_event_stream(application-id)
    get_event_stream(application-id, params::Dict{String,<:Any})

Retrieves information about the event stream settings for an application.

# Arguments
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.

"""
function get_event_stream(
    application_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/eventstream";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_event_stream(
    application_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/eventstream",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_export_job(application-id, job-id)
    get_export_job(application-id, job-id, params::Dict{String,<:Any})

Retrieves information about the status and settings of a specific export job for an
application.

# Arguments
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.
- `job-id`: The unique identifier for the job.

"""
function get_export_job(
    application_id, job_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/jobs/export/$(job-id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_export_job(
    application_id,
    job_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/jobs/export/$(job-id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_export_jobs(application-id)
    get_export_jobs(application-id, params::Dict{String,<:Any})

Retrieves information about the status and settings of all the export jobs for an
application.

# Arguments
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"page-size"`: The maximum number of items to include in each page of a paginated
  response. This parameter is not supported for application, campaign, and journey metrics.
- `"token"`: The NextToken string that specifies which page of results to return in a
  paginated response.
"""
function get_export_jobs(application_id; aws_config::AbstractAWSConfig=current_aws_config())
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/jobs/export";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_export_jobs(
    application_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/jobs/export",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_gcm_channel(application-id)
    get_gcm_channel(application-id, params::Dict{String,<:Any})

Retrieves information about the status and settings of the GCM channel for an application.

# Arguments
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.

"""
function get_gcm_channel(application_id; aws_config::AbstractAWSConfig=current_aws_config())
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/channels/gcm";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_gcm_channel(
    application_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/channels/gcm",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_import_job(application-id, job-id)
    get_import_job(application-id, job-id, params::Dict{String,<:Any})

Retrieves information about the status and settings of a specific import job for an
application.

# Arguments
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.
- `job-id`: The unique identifier for the job.

"""
function get_import_job(
    application_id, job_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/jobs/import/$(job-id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_import_job(
    application_id,
    job_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/jobs/import/$(job-id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_import_jobs(application-id)
    get_import_jobs(application-id, params::Dict{String,<:Any})

Retrieves information about the status and settings of all the import jobs for an
application.

# Arguments
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"page-size"`: The maximum number of items to include in each page of a paginated
  response. This parameter is not supported for application, campaign, and journey metrics.
- `"token"`: The NextToken string that specifies which page of results to return in a
  paginated response.
"""
function get_import_jobs(application_id; aws_config::AbstractAWSConfig=current_aws_config())
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/jobs/import";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_import_jobs(
    application_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/jobs/import",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_in_app_messages(application-id, endpoint-id)
    get_in_app_messages(application-id, endpoint-id, params::Dict{String,<:Any})

Retrieves the in-app messages targeted for the provided endpoint ID.

# Arguments
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.
- `endpoint-id`: The unique identifier for the endpoint.

"""
function get_in_app_messages(
    application_id, endpoint_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/endpoints/$(endpoint-id)/inappmessages";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_in_app_messages(
    application_id,
    endpoint_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/endpoints/$(endpoint-id)/inappmessages",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_in_app_template(template-name)
    get_in_app_template(template-name, params::Dict{String,<:Any})

Retrieves the content and settings of a message template for messages sent through the
in-app channel.

# Arguments
- `template-name`: The name of the message template. A template name must start with an
  alphanumeric character and can contain a maximum of 128 characters. The characters can be
  alphanumeric characters, underscores (_), or hyphens (-). Template names are case sensitive.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"version"`: The unique identifier for the version of the message template to update,
  retrieve information about, or delete. To retrieve identifiers and other information for
  all the versions of a template, use the Template Versions resource. If specified, this
  value must match the identifier for an existing template version. If specified for an
  update operation, this value must match the identifier for the latest existing version of
  the template. This restriction helps ensure that race conditions don't occur. If you don't
  specify a value for this parameter, Amazon Pinpoint does the following: For a get
  operation, retrieves information about the active version of the template. For an update
  operation, saves the updates to (overwrites) the latest existing version of the template,
  if the create-new-version parameter isn't used or is set to false. For a delete operation,
  deletes the template, including all versions of the template.
"""
function get_in_app_template(
    template_name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "GET",
        "/v1/templates/$(template-name)/inapp";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_in_app_template(
    template_name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "GET",
        "/v1/templates/$(template-name)/inapp",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_journey(application-id, journey-id)
    get_journey(application-id, journey-id, params::Dict{String,<:Any})

Retrieves information about the status, configuration, and other settings for a journey.

# Arguments
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.
- `journey-id`: The unique identifier for the journey.

"""
function get_journey(
    application_id, journey_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/journeys/$(journey-id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_journey(
    application_id,
    journey_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/journeys/$(journey-id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_journey_date_range_kpi(application-id, journey-id, kpi-name)
    get_journey_date_range_kpi(application-id, journey-id, kpi-name, params::Dict{String,<:Any})

Retrieves (queries) pre-aggregated data for a standard engagement metric that applies to a
journey.

# Arguments
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.
- `journey-id`: The unique identifier for the journey.
- `kpi-name`: The name of the metric, also referred to as a key performance indicator
  (KPI), to retrieve data for. This value describes the associated metric and consists of two
  or more terms, which are comprised of lowercase alphanumeric characters, separated by a
  hyphen. Examples are email-open-rate and successful-delivery-rate. For a list of valid
  values, see the Amazon Pinpoint Developer Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"end-time"`: The last date and time to retrieve data for, as part of an inclusive date
  range that filters the query results. This value should be in extended ISO 8601 format and
  use Coordinated Universal Time (UTC), for example: 2019-07-26T20:00:00Z for 8:00 PM UTC
  July 26, 2019.
- `"next-token"`: The  string that specifies which page of results to return in a paginated
  response. This parameter is not supported for application, campaign, and journey metrics.
- `"page-size"`: The maximum number of items to include in each page of a paginated
  response. This parameter is not supported for application, campaign, and journey metrics.
- `"start-time"`: The first date and time to retrieve data for, as part of an inclusive
  date range that filters the query results. This value should be in extended ISO 8601 format
  and use Coordinated Universal Time (UTC), for example: 2019-07-19T20:00:00Z for 8:00 PM UTC
  July 19, 2019. This value should also be fewer than 90 days from the current day.
"""
function get_journey_date_range_kpi(
    application_id, journey_id, kpi_name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/journeys/$(journey-id)/kpis/daterange/$(kpi-name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_journey_date_range_kpi(
    application_id,
    journey_id,
    kpi_name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/journeys/$(journey-id)/kpis/daterange/$(kpi-name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_journey_execution_activity_metrics(application-id, journey-activity-id, journey-id)
    get_journey_execution_activity_metrics(application-id, journey-activity-id, journey-id, params::Dict{String,<:Any})

Retrieves (queries) pre-aggregated data for a standard execution metric that applies to a
journey activity.

# Arguments
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.
- `journey-activity-id`: The unique identifier for the journey activity.
- `journey-id`: The unique identifier for the journey.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"next-token"`: The  string that specifies which page of results to return in a paginated
  response. This parameter is not supported for application, campaign, and journey metrics.
- `"page-size"`: The maximum number of items to include in each page of a paginated
  response. This parameter is not supported for application, campaign, and journey metrics.
"""
function get_journey_execution_activity_metrics(
    application_id,
    journey_activity_id,
    journey_id;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/journeys/$(journey-id)/activities/$(journey-activity-id)/execution-metrics";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_journey_execution_activity_metrics(
    application_id,
    journey_activity_id,
    journey_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/journeys/$(journey-id)/activities/$(journey-activity-id)/execution-metrics",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_journey_execution_metrics(application-id, journey-id)
    get_journey_execution_metrics(application-id, journey-id, params::Dict{String,<:Any})

Retrieves (queries) pre-aggregated data for a standard execution metric that applies to a
journey.

# Arguments
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.
- `journey-id`: The unique identifier for the journey.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"next-token"`: The  string that specifies which page of results to return in a paginated
  response. This parameter is not supported for application, campaign, and journey metrics.
- `"page-size"`: The maximum number of items to include in each page of a paginated
  response. This parameter is not supported for application, campaign, and journey metrics.
"""
function get_journey_execution_metrics(
    application_id, journey_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/journeys/$(journey-id)/execution-metrics";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_journey_execution_metrics(
    application_id,
    journey_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/journeys/$(journey-id)/execution-metrics",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_journey_run_execution_activity_metrics(application-id, journey-activity-id, journey-id, run-id)
    get_journey_run_execution_activity_metrics(application-id, journey-activity-id, journey-id, run-id, params::Dict{String,<:Any})

Retrieves (queries) pre-aggregated data for a standard run execution metric that applies to
a journey activity.

# Arguments
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.
- `journey-activity-id`: The unique identifier for the journey activity.
- `journey-id`: The unique identifier for the journey.
- `run-id`: The unique identifier for the journey run.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"next-token"`: The  string that specifies which page of results to return in a paginated
  response. This parameter is not supported for application, campaign, and journey metrics.
- `"page-size"`: The maximum number of items to include in each page of a paginated
  response. This parameter is not supported for application, campaign, and journey metrics.
"""
function get_journey_run_execution_activity_metrics(
    application_id,
    journey_activity_id,
    journey_id,
    run_id;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/journeys/$(journey-id)/runs/$(run-id)/activities/$(journey-activity-id)/execution-metrics";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_journey_run_execution_activity_metrics(
    application_id,
    journey_activity_id,
    journey_id,
    run_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/journeys/$(journey-id)/runs/$(run-id)/activities/$(journey-activity-id)/execution-metrics",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_journey_run_execution_metrics(application-id, journey-id, run-id)
    get_journey_run_execution_metrics(application-id, journey-id, run-id, params::Dict{String,<:Any})

Retrieves (queries) pre-aggregated data for a standard run execution metric that applies to
a journey.

# Arguments
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.
- `journey-id`: The unique identifier for the journey.
- `run-id`: The unique identifier for the journey run.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"next-token"`: The  string that specifies which page of results to return in a paginated
  response. This parameter is not supported for application, campaign, and journey metrics.
- `"page-size"`: The maximum number of items to include in each page of a paginated
  response. This parameter is not supported for application, campaign, and journey metrics.
"""
function get_journey_run_execution_metrics(
    application_id, journey_id, run_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/journeys/$(journey-id)/runs/$(run-id)/execution-metrics";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_journey_run_execution_metrics(
    application_id,
    journey_id,
    run_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/journeys/$(journey-id)/runs/$(run-id)/execution-metrics",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_journey_runs(application-id, journey-id)
    get_journey_runs(application-id, journey-id, params::Dict{String,<:Any})

Provides information about the runs of a journey.

# Arguments
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.
- `journey-id`: The unique identifier for the journey.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"page-size"`: The maximum number of items to include in each page of a paginated
  response. This parameter is not supported for application, campaign, and journey metrics.
- `"token"`: The NextToken string that specifies which page of results to return in a
  paginated response.
"""
function get_journey_runs(
    application_id, journey_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/journeys/$(journey-id)/runs";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_journey_runs(
    application_id,
    journey_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/journeys/$(journey-id)/runs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_push_template(template-name)
    get_push_template(template-name, params::Dict{String,<:Any})

Retrieves the content and settings of a message template for messages that are sent through
a push notification channel.

# Arguments
- `template-name`: The name of the message template. A template name must start with an
  alphanumeric character and can contain a maximum of 128 characters. The characters can be
  alphanumeric characters, underscores (_), or hyphens (-). Template names are case sensitive.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"version"`: The unique identifier for the version of the message template to update,
  retrieve information about, or delete. To retrieve identifiers and other information for
  all the versions of a template, use the Template Versions resource. If specified, this
  value must match the identifier for an existing template version. If specified for an
  update operation, this value must match the identifier for the latest existing version of
  the template. This restriction helps ensure that race conditions don't occur. If you don't
  specify a value for this parameter, Amazon Pinpoint does the following: For a get
  operation, retrieves information about the active version of the template. For an update
  operation, saves the updates to (overwrites) the latest existing version of the template,
  if the create-new-version parameter isn't used or is set to false. For a delete operation,
  deletes the template, including all versions of the template.
"""
function get_push_template(
    template_name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "GET",
        "/v1/templates/$(template-name)/push";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_push_template(
    template_name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "GET",
        "/v1/templates/$(template-name)/push",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_recommender_configuration(recommender-id)
    get_recommender_configuration(recommender-id, params::Dict{String,<:Any})

Retrieves information about an Amazon Pinpoint configuration for a recommender model.

# Arguments
- `recommender-id`: The unique identifier for the recommender model configuration. This
  identifier is displayed as the Recommender ID on the Amazon Pinpoint console.

"""
function get_recommender_configuration(
    recommender_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "GET",
        "/v1/recommenders/$(recommender-id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_recommender_configuration(
    recommender_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "GET",
        "/v1/recommenders/$(recommender-id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_recommender_configurations()
    get_recommender_configurations(params::Dict{String,<:Any})

Retrieves information about all the recommender model configurations that are associated
with your Amazon Pinpoint account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"page-size"`: The maximum number of items to include in each page of a paginated
  response. This parameter is not supported for application, campaign, and journey metrics.
- `"token"`: The NextToken string that specifies which page of results to return in a
  paginated response.
"""
function get_recommender_configurations(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "GET", "/v1/recommenders"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_recommender_configurations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "GET",
        "/v1/recommenders",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_segment(application-id, segment-id)
    get_segment(application-id, segment-id, params::Dict{String,<:Any})

Retrieves information about the configuration, dimension, and other settings for a specific
segment that's associated with an application.

# Arguments
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.
- `segment-id`: The unique identifier for the segment.

"""
function get_segment(
    application_id, segment_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/segments/$(segment-id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_segment(
    application_id,
    segment_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/segments/$(segment-id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_segment_export_jobs(application-id, segment-id)
    get_segment_export_jobs(application-id, segment-id, params::Dict{String,<:Any})

Retrieves information about the status and settings of the export jobs for a segment.

# Arguments
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.
- `segment-id`: The unique identifier for the segment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"page-size"`: The maximum number of items to include in each page of a paginated
  response. This parameter is not supported for application, campaign, and journey metrics.
- `"token"`: The NextToken string that specifies which page of results to return in a
  paginated response.
"""
function get_segment_export_jobs(
    application_id, segment_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/segments/$(segment-id)/jobs/export";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_segment_export_jobs(
    application_id,
    segment_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/segments/$(segment-id)/jobs/export",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_segment_import_jobs(application-id, segment-id)
    get_segment_import_jobs(application-id, segment-id, params::Dict{String,<:Any})

Retrieves information about the status and settings of the import jobs for a segment.

# Arguments
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.
- `segment-id`: The unique identifier for the segment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"page-size"`: The maximum number of items to include in each page of a paginated
  response. This parameter is not supported for application, campaign, and journey metrics.
- `"token"`: The NextToken string that specifies which page of results to return in a
  paginated response.
"""
function get_segment_import_jobs(
    application_id, segment_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/segments/$(segment-id)/jobs/import";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_segment_import_jobs(
    application_id,
    segment_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/segments/$(segment-id)/jobs/import",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_segment_version(application-id, segment-id, version)
    get_segment_version(application-id, segment-id, version, params::Dict{String,<:Any})

Retrieves information about the configuration, dimension, and other settings for a specific
version of a segment that's associated with an application.

# Arguments
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.
- `segment-id`: The unique identifier for the segment.
- `version`: The unique version number (Version property) for the campaign version.

"""
function get_segment_version(
    application_id, segment_id, version; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/segments/$(segment-id)/versions/$(version)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_segment_version(
    application_id,
    segment_id,
    version,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/segments/$(segment-id)/versions/$(version)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_segment_versions(application-id, segment-id)
    get_segment_versions(application-id, segment-id, params::Dict{String,<:Any})

Retrieves information about the configuration, dimension, and other settings for all the
versions of a specific segment that's associated with an application.

# Arguments
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.
- `segment-id`: The unique identifier for the segment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"page-size"`: The maximum number of items to include in each page of a paginated
  response. This parameter is not supported for application, campaign, and journey metrics.
- `"token"`: The NextToken string that specifies which page of results to return in a
  paginated response.
"""
function get_segment_versions(
    application_id, segment_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/segments/$(segment-id)/versions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_segment_versions(
    application_id,
    segment_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/segments/$(segment-id)/versions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_segments(application-id)
    get_segments(application-id, params::Dict{String,<:Any})

Retrieves information about the configuration, dimension, and other settings for all the
segments that are associated with an application.

# Arguments
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"page-size"`: The maximum number of items to include in each page of a paginated
  response. This parameter is not supported for application, campaign, and journey metrics.
- `"token"`: The NextToken string that specifies which page of results to return in a
  paginated response.
"""
function get_segments(application_id; aws_config::AbstractAWSConfig=current_aws_config())
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/segments";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_segments(
    application_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/segments",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_sms_channel(application-id)
    get_sms_channel(application-id, params::Dict{String,<:Any})

Retrieves information about the status and settings of the SMS channel for an application.

# Arguments
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.

"""
function get_sms_channel(application_id; aws_config::AbstractAWSConfig=current_aws_config())
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/channels/sms";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_sms_channel(
    application_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/channels/sms",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_sms_template(template-name)
    get_sms_template(template-name, params::Dict{String,<:Any})

Retrieves the content and settings of a message template for messages that are sent through
the SMS channel.

# Arguments
- `template-name`: The name of the message template. A template name must start with an
  alphanumeric character and can contain a maximum of 128 characters. The characters can be
  alphanumeric characters, underscores (_), or hyphens (-). Template names are case sensitive.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"version"`: The unique identifier for the version of the message template to update,
  retrieve information about, or delete. To retrieve identifiers and other information for
  all the versions of a template, use the Template Versions resource. If specified, this
  value must match the identifier for an existing template version. If specified for an
  update operation, this value must match the identifier for the latest existing version of
  the template. This restriction helps ensure that race conditions don't occur. If you don't
  specify a value for this parameter, Amazon Pinpoint does the following: For a get
  operation, retrieves information about the active version of the template. For an update
  operation, saves the updates to (overwrites) the latest existing version of the template,
  if the create-new-version parameter isn't used or is set to false. For a delete operation,
  deletes the template, including all versions of the template.
"""
function get_sms_template(template_name; aws_config::AbstractAWSConfig=current_aws_config())
    return pinpoint(
        "GET",
        "/v1/templates/$(template-name)/sms";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_sms_template(
    template_name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "GET",
        "/v1/templates/$(template-name)/sms",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_user_endpoints(application-id, user-id)
    get_user_endpoints(application-id, user-id, params::Dict{String,<:Any})

Retrieves information about all the endpoints that are associated with a specific user ID.

# Arguments
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.
- `user-id`: The unique identifier for the user.

"""
function get_user_endpoints(
    application_id, user_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/users/$(user-id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_user_endpoints(
    application_id,
    user_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/users/$(user-id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_voice_channel(application-id)
    get_voice_channel(application-id, params::Dict{String,<:Any})

Retrieves information about the status and settings of the voice channel for an application.

# Arguments
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.

"""
function get_voice_channel(
    application_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/channels/voice";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_voice_channel(
    application_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/channels/voice",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_voice_template(template-name)
    get_voice_template(template-name, params::Dict{String,<:Any})

Retrieves the content and settings of a message template for messages that are sent through
the voice channel.

# Arguments
- `template-name`: The name of the message template. A template name must start with an
  alphanumeric character and can contain a maximum of 128 characters. The characters can be
  alphanumeric characters, underscores (_), or hyphens (-). Template names are case sensitive.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"version"`: The unique identifier for the version of the message template to update,
  retrieve information about, or delete. To retrieve identifiers and other information for
  all the versions of a template, use the Template Versions resource. If specified, this
  value must match the identifier for an existing template version. If specified for an
  update operation, this value must match the identifier for the latest existing version of
  the template. This restriction helps ensure that race conditions don't occur. If you don't
  specify a value for this parameter, Amazon Pinpoint does the following: For a get
  operation, retrieves information about the active version of the template. For an update
  operation, saves the updates to (overwrites) the latest existing version of the template,
  if the create-new-version parameter isn't used or is set to false. For a delete operation,
  deletes the template, including all versions of the template.
"""
function get_voice_template(
    template_name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "GET",
        "/v1/templates/$(template-name)/voice";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_voice_template(
    template_name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "GET",
        "/v1/templates/$(template-name)/voice",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_journeys(application-id)
    list_journeys(application-id, params::Dict{String,<:Any})

Retrieves information about the status, configuration, and other settings for all the
journeys that are associated with an application.

# Arguments
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"page-size"`: The maximum number of items to include in each page of a paginated
  response. This parameter is not supported for application, campaign, and journey metrics.
- `"token"`: The NextToken string that specifies which page of results to return in a
  paginated response.
"""
function list_journeys(application_id; aws_config::AbstractAWSConfig=current_aws_config())
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/journeys";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_journeys(
    application_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "GET",
        "/v1/apps/$(application-id)/journeys",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource-arn)
    list_tags_for_resource(resource-arn, params::Dict{String,<:Any})

Retrieves all the tags (keys and values) that are associated with an application, campaign,
message template, or segment.

# Arguments
- `resource-arn`: The Amazon Resource Name (ARN) of the resource.

"""
function list_tags_for_resource(
    resource_arn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "GET",
        "/v1/tags/$(resource-arn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resource_arn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "GET",
        "/v1/tags/$(resource-arn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_template_versions(template-name, template-type)
    list_template_versions(template-name, template-type, params::Dict{String,<:Any})

Retrieves information about all the versions of a specific message template.

# Arguments
- `template-name`: The name of the message template. A template name must start with an
  alphanumeric character and can contain a maximum of 128 characters. The characters can be
  alphanumeric characters, underscores (_), or hyphens (-). Template names are case sensitive.
- `template-type`: The type of channel that the message template is designed for. Valid
  values are: EMAIL, PUSH, SMS, and VOICE.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"next-token"`: The  string that specifies which page of results to return in a paginated
  response. This parameter is not supported for application, campaign, and journey metrics.
- `"page-size"`: The maximum number of items to include in each page of a paginated
  response. This parameter is not supported for application, campaign, and journey metrics.
"""
function list_template_versions(
    template_name, template_type; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "GET",
        "/v1/templates/$(template-name)/$(template-type)/versions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_template_versions(
    template_name,
    template_type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "GET",
        "/v1/templates/$(template-name)/$(template-type)/versions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_templates()
    list_templates(params::Dict{String,<:Any})

Retrieves information about all the message templates that are associated with your Amazon
Pinpoint account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"next-token"`: The  string that specifies which page of results to return in a paginated
  response. This parameter is not supported for application, campaign, and journey metrics.
- `"page-size"`: The maximum number of items to include in each page of a paginated
  response. This parameter is not supported for application, campaign, and journey metrics.
- `"prefix"`: The substring to match in the names of the message templates to include in
  the results. If you specify this value, Amazon Pinpoint returns only those templates whose
  names begin with the value that you specify.
- `"template-type"`: The type of message template to include in the results. Valid values
  are: EMAIL, PUSH, SMS, and VOICE. To include all types of templates in the results, don't
  include this parameter in your request.
"""
function list_templates(; aws_config::AbstractAWSConfig=current_aws_config())
    return pinpoint(
        "GET", "/v1/templates"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_templates(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "GET",
        "/v1/templates",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    phone_number_validate(number_validate_request)
    phone_number_validate(number_validate_request, params::Dict{String,<:Any})

Retrieves information about a phone number.

# Arguments
- `number_validate_request`:

"""
function phone_number_validate(
    NumberValidateRequest; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "POST",
        "/v1/phone/number/validate",
        Dict{String,Any}("NumberValidateRequest" => NumberValidateRequest);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function phone_number_validate(
    NumberValidateRequest,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "POST",
        "/v1/phone/number/validate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("NumberValidateRequest" => NumberValidateRequest),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_event_stream(write_event_stream, application-id)
    put_event_stream(write_event_stream, application-id, params::Dict{String,<:Any})

Creates a new event stream for an application or updates the settings of an existing event
stream for an application.

# Arguments
- `write_event_stream`:
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.

"""
function put_event_stream(
    WriteEventStream, application_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "POST",
        "/v1/apps/$(application-id)/eventstream",
        Dict{String,Any}("WriteEventStream" => WriteEventStream);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_event_stream(
    WriteEventStream,
    application_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "POST",
        "/v1/apps/$(application-id)/eventstream",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("WriteEventStream" => WriteEventStream), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_events(events_request, application-id)
    put_events(events_request, application-id, params::Dict{String,<:Any})

Creates a new event to record for endpoints, or creates or updates endpoint data that
existing events are associated with.

# Arguments
- `events_request`:
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.

"""
function put_events(
    EventsRequest, application_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "POST",
        "/v1/apps/$(application-id)/events",
        Dict{String,Any}("EventsRequest" => EventsRequest);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_events(
    EventsRequest,
    application_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "POST",
        "/v1/apps/$(application-id)/events",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("EventsRequest" => EventsRequest), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_attributes(update_attributes_request, application-id, attribute-type)
    remove_attributes(update_attributes_request, application-id, attribute-type, params::Dict{String,<:Any})

Removes one or more custom attributes, of the same attribute type, from the application.
Existing endpoints still have the attributes but Amazon Pinpoint will stop capturing new or
changed values for these attributes.

# Arguments
- `update_attributes_request`:
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.
- `attribute-type`:  The type of attribute or attributes to remove. Valid values are:
  endpoint-custom-attributes - Custom attributes that describe endpoints, such as the date
  when an associated user opted in or out of receiving communications from you through a
  specific type of channel. endpoint-metric-attributes - Custom metrics that your app reports
  to Amazon Pinpoint for endpoints, such as the number of app sessions or the number of items
  left in a cart. endpoint-user-attributes - Custom attributes that describe users, such as
  first name, last name, and age.

"""
function remove_attributes(
    UpdateAttributesRequest,
    application_id,
    attribute_type;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "PUT",
        "/v1/apps/$(application-id)/attributes/$(attribute-type)",
        Dict{String,Any}("UpdateAttributesRequest" => UpdateAttributesRequest);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_attributes(
    UpdateAttributesRequest,
    application_id,
    attribute_type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "PUT",
        "/v1/apps/$(application-id)/attributes/$(attribute-type)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("UpdateAttributesRequest" => UpdateAttributesRequest),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    send_messages(message_request, application-id)
    send_messages(message_request, application-id, params::Dict{String,<:Any})

Creates and sends a direct message.

# Arguments
- `message_request`:
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.

"""
function send_messages(
    MessageRequest, application_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "POST",
        "/v1/apps/$(application-id)/messages",
        Dict{String,Any}("MessageRequest" => MessageRequest);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function send_messages(
    MessageRequest,
    application_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "POST",
        "/v1/apps/$(application-id)/messages",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("MessageRequest" => MessageRequest), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    send_otpmessage(send_otpmessage_request_parameters, application-id)
    send_otpmessage(send_otpmessage_request_parameters, application-id, params::Dict{String,<:Any})

Send an OTP message

# Arguments
- `send_otpmessage_request_parameters`:
- `application-id`: The unique ID of your Amazon Pinpoint application.

"""
function send_otpmessage(
    SendOTPMessageRequestParameters,
    application_id;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "POST",
        "/v1/apps/$(application-id)/otp",
        Dict{String,Any}(
            "SendOTPMessageRequestParameters" => SendOTPMessageRequestParameters
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function send_otpmessage(
    SendOTPMessageRequestParameters,
    application_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "POST",
        "/v1/apps/$(application-id)/otp",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "SendOTPMessageRequestParameters" => SendOTPMessageRequestParameters
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    send_users_messages(send_users_message_request, application-id)
    send_users_messages(send_users_message_request, application-id, params::Dict{String,<:Any})

Creates and sends a message to a list of users.

# Arguments
- `send_users_message_request`:
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.

"""
function send_users_messages(
    SendUsersMessageRequest,
    application_id;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "POST",
        "/v1/apps/$(application-id)/users-messages",
        Dict{String,Any}("SendUsersMessageRequest" => SendUsersMessageRequest);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function send_users_messages(
    SendUsersMessageRequest,
    application_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "POST",
        "/v1/apps/$(application-id)/users-messages",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("SendUsersMessageRequest" => SendUsersMessageRequest),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(tags_model, resource-arn)
    tag_resource(tags_model, resource-arn, params::Dict{String,<:Any})

Adds one or more tags (keys and values) to an application, campaign, message template, or
segment.

# Arguments
- `tags_model`:
- `resource-arn`: The Amazon Resource Name (ARN) of the resource.

"""
function tag_resource(
    TagsModel, resource_arn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "POST",
        "/v1/tags/$(resource-arn)",
        Dict{String,Any}("TagsModel" => TagsModel);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    TagsModel,
    resource_arn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "POST",
        "/v1/tags/$(resource-arn)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TagsModel" => TagsModel), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource-arn, tag_keys)
    untag_resource(resource-arn, tag_keys, params::Dict{String,<:Any})

Removes one or more tags (keys and values) from an application, campaign, message template,
or segment.

# Arguments
- `resource-arn`: The Amazon Resource Name (ARN) of the resource.
- `tag_keys`: The key of the tag to remove from the resource. To remove multiple tags,
  append the tagKeys parameter and argument for each additional tag to remove, separated by
  an ampersand (&amp;).

"""
function untag_resource(
    resource_arn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "DELETE",
        "/v1/tags/$(resource-arn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resource_arn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "DELETE",
        "/v1/tags/$(resource-arn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_adm_channel(admchannel_request, application-id)
    update_adm_channel(admchannel_request, application-id, params::Dict{String,<:Any})

Enables the ADM channel for an application or updates the status and settings of the ADM
channel for an application.

# Arguments
- `admchannel_request`:
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.

"""
function update_adm_channel(
    ADMChannelRequest, application_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "PUT",
        "/v1/apps/$(application-id)/channels/adm",
        Dict{String,Any}("ADMChannelRequest" => ADMChannelRequest);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_adm_channel(
    ADMChannelRequest,
    application_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "PUT",
        "/v1/apps/$(application-id)/channels/adm",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ADMChannelRequest" => ADMChannelRequest), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_apns_channel(apnschannel_request, application-id)
    update_apns_channel(apnschannel_request, application-id, params::Dict{String,<:Any})

Enables the APNs channel for an application or updates the status and settings of the APNs
channel for an application.

# Arguments
- `apnschannel_request`:
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.

"""
function update_apns_channel(
    APNSChannelRequest, application_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "PUT",
        "/v1/apps/$(application-id)/channels/apns",
        Dict{String,Any}("APNSChannelRequest" => APNSChannelRequest);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_apns_channel(
    APNSChannelRequest,
    application_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "PUT",
        "/v1/apps/$(application-id)/channels/apns",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("APNSChannelRequest" => APNSChannelRequest), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_apns_sandbox_channel(apnssandbox_channel_request, application-id)
    update_apns_sandbox_channel(apnssandbox_channel_request, application-id, params::Dict{String,<:Any})

Enables the APNs sandbox channel for an application or updates the status and settings of
the APNs sandbox channel for an application.

# Arguments
- `apnssandbox_channel_request`:
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.

"""
function update_apns_sandbox_channel(
    APNSSandboxChannelRequest,
    application_id;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "PUT",
        "/v1/apps/$(application-id)/channels/apns_sandbox",
        Dict{String,Any}("APNSSandboxChannelRequest" => APNSSandboxChannelRequest);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_apns_sandbox_channel(
    APNSSandboxChannelRequest,
    application_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "PUT",
        "/v1/apps/$(application-id)/channels/apns_sandbox",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("APNSSandboxChannelRequest" => APNSSandboxChannelRequest),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_apns_voip_channel(apnsvoip_channel_request, application-id)
    update_apns_voip_channel(apnsvoip_channel_request, application-id, params::Dict{String,<:Any})

Enables the APNs VoIP channel for an application or updates the status and settings of the
APNs VoIP channel for an application.

# Arguments
- `apnsvoip_channel_request`:
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.

"""
function update_apns_voip_channel(
    APNSVoipChannelRequest,
    application_id;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "PUT",
        "/v1/apps/$(application-id)/channels/apns_voip",
        Dict{String,Any}("APNSVoipChannelRequest" => APNSVoipChannelRequest);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_apns_voip_channel(
    APNSVoipChannelRequest,
    application_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "PUT",
        "/v1/apps/$(application-id)/channels/apns_voip",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("APNSVoipChannelRequest" => APNSVoipChannelRequest),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_apns_voip_sandbox_channel(apnsvoip_sandbox_channel_request, application-id)
    update_apns_voip_sandbox_channel(apnsvoip_sandbox_channel_request, application-id, params::Dict{String,<:Any})

Enables the APNs VoIP sandbox channel for an application or updates the status and settings
of the APNs VoIP sandbox channel for an application.

# Arguments
- `apnsvoip_sandbox_channel_request`:
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.

"""
function update_apns_voip_sandbox_channel(
    APNSVoipSandboxChannelRequest,
    application_id;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "PUT",
        "/v1/apps/$(application-id)/channels/apns_voip_sandbox",
        Dict{String,Any}("APNSVoipSandboxChannelRequest" => APNSVoipSandboxChannelRequest);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_apns_voip_sandbox_channel(
    APNSVoipSandboxChannelRequest,
    application_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "PUT",
        "/v1/apps/$(application-id)/channels/apns_voip_sandbox",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "APNSVoipSandboxChannelRequest" => APNSVoipSandboxChannelRequest
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_application_settings(write_application_settings_request, application-id)
    update_application_settings(write_application_settings_request, application-id, params::Dict{String,<:Any})

Updates the settings for an application.

# Arguments
- `write_application_settings_request`:
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.

"""
function update_application_settings(
    WriteApplicationSettingsRequest,
    application_id;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "PUT",
        "/v1/apps/$(application-id)/settings",
        Dict{String,Any}(
            "WriteApplicationSettingsRequest" => WriteApplicationSettingsRequest
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_application_settings(
    WriteApplicationSettingsRequest,
    application_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "PUT",
        "/v1/apps/$(application-id)/settings",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "WriteApplicationSettingsRequest" => WriteApplicationSettingsRequest
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_baidu_channel(baidu_channel_request, application-id)
    update_baidu_channel(baidu_channel_request, application-id, params::Dict{String,<:Any})

Enables the Baidu channel for an application or updates the status and settings of the
Baidu channel for an application.

# Arguments
- `baidu_channel_request`:
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.

"""
function update_baidu_channel(
    BaiduChannelRequest, application_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "PUT",
        "/v1/apps/$(application-id)/channels/baidu",
        Dict{String,Any}("BaiduChannelRequest" => BaiduChannelRequest);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_baidu_channel(
    BaiduChannelRequest,
    application_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "PUT",
        "/v1/apps/$(application-id)/channels/baidu",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("BaiduChannelRequest" => BaiduChannelRequest),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_campaign(write_campaign_request, application-id, campaign-id)
    update_campaign(write_campaign_request, application-id, campaign-id, params::Dict{String,<:Any})

Updates the configuration and other settings for a campaign.

# Arguments
- `write_campaign_request`:
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.
- `campaign-id`: The unique identifier for the campaign.

"""
function update_campaign(
    WriteCampaignRequest,
    application_id,
    campaign_id;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "PUT",
        "/v1/apps/$(application-id)/campaigns/$(campaign-id)",
        Dict{String,Any}("WriteCampaignRequest" => WriteCampaignRequest);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_campaign(
    WriteCampaignRequest,
    application_id,
    campaign_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "PUT",
        "/v1/apps/$(application-id)/campaigns/$(campaign-id)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("WriteCampaignRequest" => WriteCampaignRequest),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_email_channel(email_channel_request, application-id)
    update_email_channel(email_channel_request, application-id, params::Dict{String,<:Any})

Enables the email channel for an application or updates the status and settings of the
email channel for an application.

# Arguments
- `email_channel_request`:
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.

"""
function update_email_channel(
    EmailChannelRequest, application_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "PUT",
        "/v1/apps/$(application-id)/channels/email",
        Dict{String,Any}("EmailChannelRequest" => EmailChannelRequest);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_email_channel(
    EmailChannelRequest,
    application_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "PUT",
        "/v1/apps/$(application-id)/channels/email",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("EmailChannelRequest" => EmailChannelRequest),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_email_template(email_template_request, template-name)
    update_email_template(email_template_request, template-name, params::Dict{String,<:Any})

Updates an existing message template for messages that are sent through the email channel.

# Arguments
- `email_template_request`:
- `template-name`: The name of the message template. A template name must start with an
  alphanumeric character and can contain a maximum of 128 characters. The characters can be
  alphanumeric characters, underscores (_), or hyphens (-). Template names are case sensitive.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"create-new-version"`: Specifies whether to save the updates as a new version of the
  message template. Valid values are: true, save the updates as a new version; and, false,
  save the updates to (overwrite) the latest existing version of the template. If you don't
  specify a value for this parameter, Amazon Pinpoint saves the updates to (overwrites) the
  latest existing version of the template. If you specify a value of true for this parameter,
  don't specify a value for the version parameter. Otherwise, an error will occur.
- `"version"`: The unique identifier for the version of the message template to update,
  retrieve information about, or delete. To retrieve identifiers and other information for
  all the versions of a template, use the Template Versions resource. If specified, this
  value must match the identifier for an existing template version. If specified for an
  update operation, this value must match the identifier for the latest existing version of
  the template. This restriction helps ensure that race conditions don't occur. If you don't
  specify a value for this parameter, Amazon Pinpoint does the following: For a get
  operation, retrieves information about the active version of the template. For an update
  operation, saves the updates to (overwrites) the latest existing version of the template,
  if the create-new-version parameter isn't used or is set to false. For a delete operation,
  deletes the template, including all versions of the template.
"""
function update_email_template(
    EmailTemplateRequest, template_name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "PUT",
        "/v1/templates/$(template-name)/email",
        Dict{String,Any}("EmailTemplateRequest" => EmailTemplateRequest);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_email_template(
    EmailTemplateRequest,
    template_name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "PUT",
        "/v1/templates/$(template-name)/email",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("EmailTemplateRequest" => EmailTemplateRequest),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_endpoint(endpoint_request, application-id, endpoint-id)
    update_endpoint(endpoint_request, application-id, endpoint-id, params::Dict{String,<:Any})

Creates a new endpoint for an application or updates the settings and attributes of an
existing endpoint for an application. You can also use this operation to define custom
attributes for an endpoint. If an update includes one or more values for a custom
attribute, Amazon Pinpoint replaces (overwrites) any existing values with the new values.

# Arguments
- `endpoint_request`:
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.
- `endpoint-id`: The case insensitive unique identifier for the endpoint. The identifier
  can't contain , { or }.

"""
function update_endpoint(
    EndpointRequest,
    application_id,
    endpoint_id;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "PUT",
        "/v1/apps/$(application-id)/endpoints/$(endpoint-id)",
        Dict{String,Any}("EndpointRequest" => EndpointRequest);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_endpoint(
    EndpointRequest,
    application_id,
    endpoint_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "PUT",
        "/v1/apps/$(application-id)/endpoints/$(endpoint-id)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("EndpointRequest" => EndpointRequest), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_endpoints_batch(endpoint_batch_request, application-id)
    update_endpoints_batch(endpoint_batch_request, application-id, params::Dict{String,<:Any})

Creates a new batch of endpoints for an application or updates the settings and attributes
of a batch of existing endpoints for an application. You can also use this operation to
define custom attributes for a batch of endpoints. If an update includes one or more values
for a custom attribute, Amazon Pinpoint replaces (overwrites) any existing values with the
new values.

# Arguments
- `endpoint_batch_request`:
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.

"""
function update_endpoints_batch(
    EndpointBatchRequest, application_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "PUT",
        "/v1/apps/$(application-id)/endpoints",
        Dict{String,Any}("EndpointBatchRequest" => EndpointBatchRequest);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_endpoints_batch(
    EndpointBatchRequest,
    application_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "PUT",
        "/v1/apps/$(application-id)/endpoints",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("EndpointBatchRequest" => EndpointBatchRequest),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_gcm_channel(gcmchannel_request, application-id)
    update_gcm_channel(gcmchannel_request, application-id, params::Dict{String,<:Any})

Enables the GCM channel for an application or updates the status and settings of the GCM
channel for an application.

# Arguments
- `gcmchannel_request`:
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.

"""
function update_gcm_channel(
    GCMChannelRequest, application_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "PUT",
        "/v1/apps/$(application-id)/channels/gcm",
        Dict{String,Any}("GCMChannelRequest" => GCMChannelRequest);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_gcm_channel(
    GCMChannelRequest,
    application_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "PUT",
        "/v1/apps/$(application-id)/channels/gcm",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("GCMChannelRequest" => GCMChannelRequest), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_in_app_template(in_app_template_request, template-name)
    update_in_app_template(in_app_template_request, template-name, params::Dict{String,<:Any})

Updates an existing message template for messages sent through the in-app message channel.

# Arguments
- `in_app_template_request`:
- `template-name`: The name of the message template. A template name must start with an
  alphanumeric character and can contain a maximum of 128 characters. The characters can be
  alphanumeric characters, underscores (_), or hyphens (-). Template names are case sensitive.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"create-new-version"`: Specifies whether to save the updates as a new version of the
  message template. Valid values are: true, save the updates as a new version; and, false,
  save the updates to (overwrite) the latest existing version of the template. If you don't
  specify a value for this parameter, Amazon Pinpoint saves the updates to (overwrites) the
  latest existing version of the template. If you specify a value of true for this parameter,
  don't specify a value for the version parameter. Otherwise, an error will occur.
- `"version"`: The unique identifier for the version of the message template to update,
  retrieve information about, or delete. To retrieve identifiers and other information for
  all the versions of a template, use the Template Versions resource. If specified, this
  value must match the identifier for an existing template version. If specified for an
  update operation, this value must match the identifier for the latest existing version of
  the template. This restriction helps ensure that race conditions don't occur. If you don't
  specify a value for this parameter, Amazon Pinpoint does the following: For a get
  operation, retrieves information about the active version of the template. For an update
  operation, saves the updates to (overwrites) the latest existing version of the template,
  if the create-new-version parameter isn't used or is set to false. For a delete operation,
  deletes the template, including all versions of the template.
"""
function update_in_app_template(
    InAppTemplateRequest, template_name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "PUT",
        "/v1/templates/$(template-name)/inapp",
        Dict{String,Any}("InAppTemplateRequest" => InAppTemplateRequest);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_in_app_template(
    InAppTemplateRequest,
    template_name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "PUT",
        "/v1/templates/$(template-name)/inapp",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("InAppTemplateRequest" => InAppTemplateRequest),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_journey(write_journey_request, application-id, journey-id)
    update_journey(write_journey_request, application-id, journey-id, params::Dict{String,<:Any})

Updates the configuration and other settings for a journey.

# Arguments
- `write_journey_request`:
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.
- `journey-id`: The unique identifier for the journey.

"""
function update_journey(
    WriteJourneyRequest,
    application_id,
    journey_id;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "PUT",
        "/v1/apps/$(application-id)/journeys/$(journey-id)",
        Dict{String,Any}("WriteJourneyRequest" => WriteJourneyRequest);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_journey(
    WriteJourneyRequest,
    application_id,
    journey_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "PUT",
        "/v1/apps/$(application-id)/journeys/$(journey-id)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("WriteJourneyRequest" => WriteJourneyRequest),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_journey_state(journey_state_request, application-id, journey-id)
    update_journey_state(journey_state_request, application-id, journey-id, params::Dict{String,<:Any})

Cancels (stops) an active journey.

# Arguments
- `journey_state_request`:
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.
- `journey-id`: The unique identifier for the journey.

"""
function update_journey_state(
    JourneyStateRequest,
    application_id,
    journey_id;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "PUT",
        "/v1/apps/$(application-id)/journeys/$(journey-id)/state",
        Dict{String,Any}("JourneyStateRequest" => JourneyStateRequest);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_journey_state(
    JourneyStateRequest,
    application_id,
    journey_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "PUT",
        "/v1/apps/$(application-id)/journeys/$(journey-id)/state",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("JourneyStateRequest" => JourneyStateRequest),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_push_template(push_notification_template_request, template-name)
    update_push_template(push_notification_template_request, template-name, params::Dict{String,<:Any})

Updates an existing message template for messages that are sent through a push notification
channel.

# Arguments
- `push_notification_template_request`:
- `template-name`: The name of the message template. A template name must start with an
  alphanumeric character and can contain a maximum of 128 characters. The characters can be
  alphanumeric characters, underscores (_), or hyphens (-). Template names are case sensitive.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"create-new-version"`: Specifies whether to save the updates as a new version of the
  message template. Valid values are: true, save the updates as a new version; and, false,
  save the updates to (overwrite) the latest existing version of the template. If you don't
  specify a value for this parameter, Amazon Pinpoint saves the updates to (overwrites) the
  latest existing version of the template. If you specify a value of true for this parameter,
  don't specify a value for the version parameter. Otherwise, an error will occur.
- `"version"`: The unique identifier for the version of the message template to update,
  retrieve information about, or delete. To retrieve identifiers and other information for
  all the versions of a template, use the Template Versions resource. If specified, this
  value must match the identifier for an existing template version. If specified for an
  update operation, this value must match the identifier for the latest existing version of
  the template. This restriction helps ensure that race conditions don't occur. If you don't
  specify a value for this parameter, Amazon Pinpoint does the following: For a get
  operation, retrieves information about the active version of the template. For an update
  operation, saves the updates to (overwrites) the latest existing version of the template,
  if the create-new-version parameter isn't used or is set to false. For a delete operation,
  deletes the template, including all versions of the template.
"""
function update_push_template(
    PushNotificationTemplateRequest,
    template_name;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "PUT",
        "/v1/templates/$(template-name)/push",
        Dict{String,Any}(
            "PushNotificationTemplateRequest" => PushNotificationTemplateRequest
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_push_template(
    PushNotificationTemplateRequest,
    template_name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "PUT",
        "/v1/templates/$(template-name)/push",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "PushNotificationTemplateRequest" => PushNotificationTemplateRequest
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_recommender_configuration(update_recommender_configuration, recommender-id)
    update_recommender_configuration(update_recommender_configuration, recommender-id, params::Dict{String,<:Any})

Updates an Amazon Pinpoint configuration for a recommender model.

# Arguments
- `update_recommender_configuration`:
- `recommender-id`: The unique identifier for the recommender model configuration. This
  identifier is displayed as the Recommender ID on the Amazon Pinpoint console.

"""
function update_recommender_configuration(
    UpdateRecommenderConfiguration,
    recommender_id;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "PUT",
        "/v1/recommenders/$(recommender-id)",
        Dict{String,Any}(
            "UpdateRecommenderConfiguration" => UpdateRecommenderConfiguration
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_recommender_configuration(
    UpdateRecommenderConfiguration,
    recommender_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "PUT",
        "/v1/recommenders/$(recommender-id)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "UpdateRecommenderConfiguration" => UpdateRecommenderConfiguration
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_segment(write_segment_request, application-id, segment-id)
    update_segment(write_segment_request, application-id, segment-id, params::Dict{String,<:Any})

Creates a new segment for an application or updates the configuration, dimension, and other
settings for an existing segment that's associated with an application.

# Arguments
- `write_segment_request`:
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.
- `segment-id`: The unique identifier for the segment.

"""
function update_segment(
    WriteSegmentRequest,
    application_id,
    segment_id;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "PUT",
        "/v1/apps/$(application-id)/segments/$(segment-id)",
        Dict{String,Any}("WriteSegmentRequest" => WriteSegmentRequest);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_segment(
    WriteSegmentRequest,
    application_id,
    segment_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "PUT",
        "/v1/apps/$(application-id)/segments/$(segment-id)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("WriteSegmentRequest" => WriteSegmentRequest),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_sms_channel(smschannel_request, application-id)
    update_sms_channel(smschannel_request, application-id, params::Dict{String,<:Any})

Enables the SMS channel for an application or updates the status and settings of the SMS
channel for an application.

# Arguments
- `smschannel_request`:
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.

"""
function update_sms_channel(
    SMSChannelRequest, application_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "PUT",
        "/v1/apps/$(application-id)/channels/sms",
        Dict{String,Any}("SMSChannelRequest" => SMSChannelRequest);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_sms_channel(
    SMSChannelRequest,
    application_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "PUT",
        "/v1/apps/$(application-id)/channels/sms",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("SMSChannelRequest" => SMSChannelRequest), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_sms_template(smstemplate_request, template-name)
    update_sms_template(smstemplate_request, template-name, params::Dict{String,<:Any})

Updates an existing message template for messages that are sent through the SMS channel.

# Arguments
- `smstemplate_request`:
- `template-name`: The name of the message template. A template name must start with an
  alphanumeric character and can contain a maximum of 128 characters. The characters can be
  alphanumeric characters, underscores (_), or hyphens (-). Template names are case sensitive.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"create-new-version"`: Specifies whether to save the updates as a new version of the
  message template. Valid values are: true, save the updates as a new version; and, false,
  save the updates to (overwrite) the latest existing version of the template. If you don't
  specify a value for this parameter, Amazon Pinpoint saves the updates to (overwrites) the
  latest existing version of the template. If you specify a value of true for this parameter,
  don't specify a value for the version parameter. Otherwise, an error will occur.
- `"version"`: The unique identifier for the version of the message template to update,
  retrieve information about, or delete. To retrieve identifiers and other information for
  all the versions of a template, use the Template Versions resource. If specified, this
  value must match the identifier for an existing template version. If specified for an
  update operation, this value must match the identifier for the latest existing version of
  the template. This restriction helps ensure that race conditions don't occur. If you don't
  specify a value for this parameter, Amazon Pinpoint does the following: For a get
  operation, retrieves information about the active version of the template. For an update
  operation, saves the updates to (overwrites) the latest existing version of the template,
  if the create-new-version parameter isn't used or is set to false. For a delete operation,
  deletes the template, including all versions of the template.
"""
function update_sms_template(
    SMSTemplateRequest, template_name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "PUT",
        "/v1/templates/$(template-name)/sms",
        Dict{String,Any}("SMSTemplateRequest" => SMSTemplateRequest);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_sms_template(
    SMSTemplateRequest,
    template_name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "PUT",
        "/v1/templates/$(template-name)/sms",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("SMSTemplateRequest" => SMSTemplateRequest), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_template_active_version(template_active_version_request, template-name, template-type)
    update_template_active_version(template_active_version_request, template-name, template-type, params::Dict{String,<:Any})

Changes the status of a specific version of a message template to active.

# Arguments
- `template_active_version_request`:
- `template-name`: The name of the message template. A template name must start with an
  alphanumeric character and can contain a maximum of 128 characters. The characters can be
  alphanumeric characters, underscores (_), or hyphens (-). Template names are case sensitive.
- `template-type`: The type of channel that the message template is designed for. Valid
  values are: EMAIL, PUSH, SMS, and VOICE.

"""
function update_template_active_version(
    TemplateActiveVersionRequest,
    template_name,
    template_type;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "PUT",
        "/v1/templates/$(template-name)/$(template-type)/active-version",
        Dict{String,Any}("TemplateActiveVersionRequest" => TemplateActiveVersionRequest);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_template_active_version(
    TemplateActiveVersionRequest,
    template_name,
    template_type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "PUT",
        "/v1/templates/$(template-name)/$(template-type)/active-version",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "TemplateActiveVersionRequest" => TemplateActiveVersionRequest
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_voice_channel(voice_channel_request, application-id)
    update_voice_channel(voice_channel_request, application-id, params::Dict{String,<:Any})

Enables the voice channel for an application or updates the status and settings of the
voice channel for an application.

# Arguments
- `voice_channel_request`:
- `application-id`: The unique identifier for the application. This identifier is displayed
  as the Project ID on the Amazon Pinpoint console.

"""
function update_voice_channel(
    VoiceChannelRequest, application_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "PUT",
        "/v1/apps/$(application-id)/channels/voice",
        Dict{String,Any}("VoiceChannelRequest" => VoiceChannelRequest);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_voice_channel(
    VoiceChannelRequest,
    application_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "PUT",
        "/v1/apps/$(application-id)/channels/voice",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("VoiceChannelRequest" => VoiceChannelRequest),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_voice_template(voice_template_request, template-name)
    update_voice_template(voice_template_request, template-name, params::Dict{String,<:Any})

Updates an existing message template for messages that are sent through the voice channel.

# Arguments
- `voice_template_request`:
- `template-name`: The name of the message template. A template name must start with an
  alphanumeric character and can contain a maximum of 128 characters. The characters can be
  alphanumeric characters, underscores (_), or hyphens (-). Template names are case sensitive.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"create-new-version"`: Specifies whether to save the updates as a new version of the
  message template. Valid values are: true, save the updates as a new version; and, false,
  save the updates to (overwrite) the latest existing version of the template. If you don't
  specify a value for this parameter, Amazon Pinpoint saves the updates to (overwrites) the
  latest existing version of the template. If you specify a value of true for this parameter,
  don't specify a value for the version parameter. Otherwise, an error will occur.
- `"version"`: The unique identifier for the version of the message template to update,
  retrieve information about, or delete. To retrieve identifiers and other information for
  all the versions of a template, use the Template Versions resource. If specified, this
  value must match the identifier for an existing template version. If specified for an
  update operation, this value must match the identifier for the latest existing version of
  the template. This restriction helps ensure that race conditions don't occur. If you don't
  specify a value for this parameter, Amazon Pinpoint does the following: For a get
  operation, retrieves information about the active version of the template. For an update
  operation, saves the updates to (overwrites) the latest existing version of the template,
  if the create-new-version parameter isn't used or is set to false. For a delete operation,
  deletes the template, including all versions of the template.
"""
function update_voice_template(
    VoiceTemplateRequest, template_name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint(
        "PUT",
        "/v1/templates/$(template-name)/voice",
        Dict{String,Any}("VoiceTemplateRequest" => VoiceTemplateRequest);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_voice_template(
    VoiceTemplateRequest,
    template_name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "PUT",
        "/v1/templates/$(template-name)/voice",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("VoiceTemplateRequest" => VoiceTemplateRequest),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    verify_otpmessage(verify_otpmessage_request_parameters, application-id)
    verify_otpmessage(verify_otpmessage_request_parameters, application-id, params::Dict{String,<:Any})

Verify an OTP

# Arguments
- `verify_otpmessage_request_parameters`:
- `application-id`: The unique ID of your Amazon Pinpoint application.

"""
function verify_otpmessage(
    VerifyOTPMessageRequestParameters,
    application_id;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "POST",
        "/v1/apps/$(application-id)/verify-otp",
        Dict{String,Any}(
            "VerifyOTPMessageRequestParameters" => VerifyOTPMessageRequestParameters
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function verify_otpmessage(
    VerifyOTPMessageRequestParameters,
    application_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint(
        "POST",
        "/v1/apps/$(application-id)/verify-otp",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "VerifyOTPMessageRequestParameters" => VerifyOTPMessageRequestParameters
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    assume_role(principal::AbstractAWSConfig, role; kwargs...) -> AbstractAWSConfig

Assumes the IAM `role` via temporary credentials via the `principal` entity. The `principal`
entity must be included in the trust policy of the `role`.

[Role chaining](https://docs.aws.amazon.com/IAM/latest/UserGuide/id_roles_terms-and-concepts.html#iam-term-role-chaining)
must be manually specified by multiple `assume_role` calls (e.g. "role-a" has permissions to
assume "role-b": `assume_role(assume_role(AWSConfig(), "role-a"), "role-b")`).

# Arguments
- `principal::AbstractAWSConfig`: The AWS configuration and credentials of the principal
  entity (user or role) performing the `sts:AssumeRole` action.
- `role::AbstractString`: The AWS IAM role to assume. Either a full role ARN or just the
  role name. If only the role name is specified the role will be assumed to reside in the
  same account used in the `principal` argument.

# Keywords
- `duration::Integer` (optional): Role session duration in seconds.
- `mfa_serial::AbstractString` (optional): The identification number of the MFA device that
  is associated with the user making the `AssumeRole` API call. Either a serial number for a
  hardware device ("GAHT12345678") or an ARN for a virtual device
  ("arn:aws:iam::123456789012:mfa/user"). When specified a MFA token must be provided via
  `token` or an interactive prompt.
- `token::AbstractString` (optional): The value provided by the MFA device. Only can be
  specified when `mfa_serial` is set.
- `session_name::AbstractString` (optional): The unique role session name associated with
  this API request.
"""
function assume_role(principal::AWSConfig, role; kwargs...)
    creds = assume_role_creds(principal, role; kwargs...)
    return AWSConfig(creds, principal.region, principal.output, principal.max_attempts)
end

"""
    assume_role(role; kwargs...) -> Function

Create a function that assumes the IAM `role` via a deferred principal entity, i.e. a
function equivalent to `principal -> assume_role(principal, role; kwargs...)`. Useful for
[role chaining](https://docs.aws.amazon.com/IAM/latest/UserGuide/id_roles_terms-and-concepts.html#iam-term-role-chaining).

# Examples

Assume "role-a" which in turn assumes "role-b":

```julia
AWSConfig() |> assume_role("role-a") |> assume_role("role-b")
```
"""
assume_role(role; kwargs...) = principal -> assume_role(principal, role; kwargs...)

"""
    assume_role_creds(principal, role; kwargs...) -> AWSCredentials

Assumes the IAM `role` via temporary credentials via the `principal` entity and returns
`AWSCredentials`. Typically, end-users should use [`assume_role`](@ref) instead.

Details on the arguments and keywords for `assume_role_creds` can be found in the docstring
for [`assume_role`](@ref).
"""
function assume_role_creds(
    principal::AbstractAWSConfig,
    role::AbstractString;
    duration::Union{Integer,Nothing}=nothing,
    mfa_serial::Union{AbstractString,Nothing}=nothing,
    token::Union{AbstractString,Nothing}=nothing,
    session_name::Union{AbstractString,Nothing}=nothing,
)
    if startswith(role, "arn:aws:iam")
        # Avoiding unnecessary parsing the role ARN or performing an expensive API call
        account_id = ""
        role_arn = role
    else
        account_id = aws_account_number(principal)
        role_arn = "arn:aws:iam::$account_id:role/$role"
    end

    params = Dict{String,Any}("RoleArn" => role_arn)
    if session_name !== nothing
        params["RoleSessionName"] = session_name
    else
        params["RoleSessionName"] = _role_session_name(
            "AWS.jl-",
            _whoami(),
            "-" * Dates.format(now(UTC), dateformat"yyyymmdd\THHMMSS\Z"),
        )
    end

    if duration !== nothing
        params["DurationSeconds"] = duration
    end

    if mfa_serial !== nothing && token !== nothing
        params["SerialNumber"] = mfa_serial
        params["TokenCode"] = token
    elseif mfa_serial !== nothing && token === nothing
        params["SerialNumber"] = mfa_serial
        token = Base.getpass("Enter MFA code for $mfa_serial")
        params["TokenCode"] = Base.shred!(token) do t
            read(t, String)
        end
    elseif mfa_serial === nothing && token !== nothing
        msg = "Keyword `token` cannot be be specified when `mfa_serial` is not set"
        throw(ArgumentError(msg))
    end

    response = AWSServices.sts(
        "AssumeRole",
        params;
        aws_config=principal,
        feature_set=AWS.FeatureSet(; use_response_type=true),
    )
    body = parse(response)
    role_creds = body["AssumeRoleResult"]["Credentials"]
    role_user = body["AssumeRoleResult"]["AssumedRoleUser"]
    renew = function ()
        # Avoid passing the `token` into the credential renew function as it will be expired
        return assume_role_creds(principal, role_arn; duration, mfa_serial, session_name)
    end

    return AWSCredentials(
        role_creds["AccessKeyId"],
        role_creds["SecretAccessKey"],
        role_creds["SessionToken"],
        role_user["Arn"],
        account_id;  # May as well populate "account_number" field when we have it
        expiry=DateTime(rstrip(role_creds["Expiration"], 'Z')),
        renew,
    )
end

"""
    _whoami() -> AbstractString

The identity of the current user (i.e. effective user name). May differ from the
logged in user if the current user has been assumed, perhaps by means of `su`.

Note that the environmental variables `USER` or `USERNAME` are
[not Bash built-in variables](https://tldp.org/LDP/abs/html/internalvariables.html#AMIROOT)
and by default are not present in containers.
"""
_whoami() = readchomp(`id -un`)  # The `whoami` utility is marked as obsolete

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: serverlessapplicationrepository
using AWS.Compat
using AWS.UUIDs

"""
    create_application(author, description, name)
    create_application(author, description, name, params::Dict{String,<:Any})

Creates an application, optionally including an AWS SAM file to create the first
application version in the same call.

# Arguments
- `author`: The name of the author publishing the app.Minimum length=1. Maximum
  length=127.Pattern \"^\\[a-z0-9](([a-z0-9]|-(?!-))*[a-z0-9])?\";
- `description`: The description of the application.Minimum length=1. Maximum length=256
- `name`: The name of the application that you want to publish.Minimum length=1. Maximum
  length=140Pattern: \"[a-zA-Z0-9-]+\";

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"homePageUrl"`: A URL with more information about the application, for example the
  location of your GitHub repository for the application.
- `"labels"`: Labels to improve discovery of apps in search results.Minimum length=1.
  Maximum length=127. Maximum number of labels: 10Pattern: \"^[a-zA-Z0-9+-_:/@]+\";
- `"licenseBody"`: A local text file that contains the license of the app that matches the
  spdxLicenseID value of your application.
 The file has the format
  file://&lt;path>/&lt;filename>.Maximum size 5 MBYou can specify only one of licenseBody and
  licenseUrl; otherwise, an error results.
- `"licenseUrl"`: A link to the S3 object that contains the license of the app that matches
  the spdxLicenseID value of your application.Maximum size 5 MBYou can specify only one of
  licenseBody and licenseUrl; otherwise, an error results.
- `"readmeBody"`: A local text readme file in Markdown language that contains a more
  detailed description of the application and how it works.
 The file has the format
  file://&lt;path>/&lt;filename>.Maximum size 5 MBYou can specify only one of readmeBody and
  readmeUrl; otherwise, an error results.
- `"readmeUrl"`: A link to the S3 object in Markdown language that contains a more detailed
  description of the application and how it works.Maximum size 5 MBYou can specify only one
  of readmeBody and readmeUrl; otherwise, an error results.
- `"semanticVersion"`: The semantic version of the application:
 https://semver.org/
- `"sourceCodeArchiveUrl"`: A link to the S3 object that contains the ZIP archive of the
  source code for this version of your application.Maximum size 50 MB
- `"sourceCodeUrl"`: A link to a public repository for the source code of your application,
  for example the URL of a specific GitHub commit.
- `"spdxLicenseId"`: A valid identifier from https://spdx.org/licenses/.
- `"templateBody"`: The local raw packaged AWS SAM template file of your application.
 The
  file has the format file://&lt;path>/&lt;filename>.You can specify only one of templateBody
  and templateUrl; otherwise an error results.
- `"templateUrl"`: A link to the S3 object containing the packaged AWS SAM template of your
  application.You can specify only one of templateBody and templateUrl; otherwise an error
  results.
"""
function create_application(
    author, description, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return serverlessapplicationrepository(
        "POST",
        "/applications",
        Dict{String,Any}("author" => author, "description" => description, "name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_application(
    author,
    description,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return serverlessapplicationrepository(
        "POST",
        "/applications",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "author" => author, "description" => description, "name" => name
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_application_version(application_id, semantic_version)
    create_application_version(application_id, semantic_version, params::Dict{String,<:Any})

Creates an application version.

# Arguments
- `application_id`: The Amazon Resource Name (ARN) of the application.
- `semantic_version`: The semantic version of the new version.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"sourceCodeArchiveUrl"`: A link to the S3 object that contains the ZIP archive of the
  source code for this version of your application.Maximum size 50 MB
- `"sourceCodeUrl"`: A link to a public repository for the source code of your application,
  for example the URL of a specific GitHub commit.
- `"templateBody"`: The raw packaged AWS SAM template of your application.
- `"templateUrl"`: A link to the packaged AWS SAM template of your application.
"""
function create_application_version(
    applicationId, semanticVersion; aws_config::AbstractAWSConfig=current_aws_config()
)
    return serverlessapplicationrepository(
        "PUT",
        "/applications/$(applicationId)/versions/$(semanticVersion)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_application_version(
    applicationId,
    semanticVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return serverlessapplicationrepository(
        "PUT",
        "/applications/$(applicationId)/versions/$(semanticVersion)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_cloud_formation_change_set(application_id, stack_name)
    create_cloud_formation_change_set(application_id, stack_name, params::Dict{String,<:Any})

Creates an AWS CloudFormation change set for the given application.

# Arguments
- `application_id`: The Amazon Resource Name (ARN) of the application.
- `stack_name`: This property corresponds to the parameter of the same name for the AWS
  CloudFormation CreateChangeSet
  API.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"capabilities"`: A list of values that you must specify before you can deploy certain
  applications.
 Some applications might include resources that can affect permissions in
  your AWS
 account, for example, by creating new AWS Identity and Access Management (IAM)
  users.
 For those applications, you must explicitly acknowledge their capabilities by
  specifying this parameter.The only valid values are CAPABILITY_IAM, CAPABILITY_NAMED_IAM,
  CAPABILITY_RESOURCE_POLICY, and CAPABILITY_AUTO_EXPAND.The following resources require you
  to specify CAPABILITY_IAM or
 CAPABILITY_NAMED_IAM:
 AWS::IAM::Group,
  AWS::IAM::InstanceProfile,
 AWS::IAM::Policy, and
 AWS::IAM::Role.
 If the application
  contains IAM resources, you can specify either CAPABILITY_IAM
 or CAPABILITY_NAMED_IAM. If
  the application contains IAM resources
 with custom names, you must specify
  CAPABILITY_NAMED_IAM.The following resources require you to specify
  CAPABILITY_RESOURCE_POLICY:
 AWS::Lambda::Permission,
 AWS::IAM:Policy,
  AWS::ApplicationAutoScaling::ScalingPolicy,
 AWS::S3::BucketPolicy,
 AWS::SQS::QueuePolicy,
  and
 AWS::SNS:TopicPolicy.Applications that contain one or more nested applications require
  you to specify
 CAPABILITY_AUTO_EXPAND.If your application template contains any of the
  above resources, we recommend that you review
 all permissions associated with the
  application before deploying. If you don't specify
 this parameter for an application that
  requires capabilities, the call will fail.
- `"changeSetName"`: This property corresponds to the parameter of the same name for the
  AWS CloudFormation CreateChangeSet
  API.
- `"clientToken"`: This property corresponds to the parameter of the same name for the AWS
  CloudFormation CreateChangeSet
  API.
- `"description"`: This property corresponds to the parameter of the same name for the AWS
  CloudFormation CreateChangeSet
  API.
- `"notificationArns"`: This property corresponds to the parameter of the same name for the
  AWS CloudFormation CreateChangeSet
  API.
- `"parameterOverrides"`: A list of parameter values for the parameters of the application.
- `"resourceTypes"`: This property corresponds to the parameter of the same name for the
  AWS CloudFormation CreateChangeSet
  API.
- `"rollbackConfiguration"`: This property corresponds to the parameter of the same name
  for the AWS CloudFormation CreateChangeSet
  API.
- `"semanticVersion"`: The semantic version of the application:
 https://semver.org/
- `"tags"`: This property corresponds to the parameter of the same name for the AWS
  CloudFormation CreateChangeSet
  API.
- `"templateId"`: The UUID returned by CreateCloudFormationTemplate.Pattern:
  [0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{12}
"""
function create_cloud_formation_change_set(
    applicationId, stackName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return serverlessapplicationrepository(
        "POST",
        "/applications/$(applicationId)/changesets",
        Dict{String,Any}("stackName" => stackName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_cloud_formation_change_set(
    applicationId,
    stackName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return serverlessapplicationrepository(
        "POST",
        "/applications/$(applicationId)/changesets",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("stackName" => stackName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_cloud_formation_template(application_id)
    create_cloud_formation_template(application_id, params::Dict{String,<:Any})

Creates an AWS CloudFormation template.

# Arguments
- `application_id`: The Amazon Resource Name (ARN) of the application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"semanticVersion"`: The semantic version of the application:
 https://semver.org/
"""
function create_cloud_formation_template(
    applicationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return serverlessapplicationrepository(
        "POST",
        "/applications/$(applicationId)/templates";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_cloud_formation_template(
    applicationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return serverlessapplicationrepository(
        "POST",
        "/applications/$(applicationId)/templates",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_application(application_id)
    delete_application(application_id, params::Dict{String,<:Any})

Deletes the specified application.

# Arguments
- `application_id`: The Amazon Resource Name (ARN) of the application.

"""
function delete_application(
    applicationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return serverlessapplicationrepository(
        "DELETE",
        "/applications/$(applicationId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_application(
    applicationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return serverlessapplicationrepository(
        "DELETE",
        "/applications/$(applicationId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_application(application_id)
    get_application(application_id, params::Dict{String,<:Any})

Gets the specified application.

# Arguments
- `application_id`: The Amazon Resource Name (ARN) of the application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"semanticVersion"`: The semantic version of the application to get.
"""
function get_application(applicationId; aws_config::AbstractAWSConfig=current_aws_config())
    return serverlessapplicationrepository(
        "GET",
        "/applications/$(applicationId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_application(
    applicationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return serverlessapplicationrepository(
        "GET",
        "/applications/$(applicationId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_application_policy(application_id)
    get_application_policy(application_id, params::Dict{String,<:Any})

Retrieves the policy for the application.

# Arguments
- `application_id`: The Amazon Resource Name (ARN) of the application.

"""
function get_application_policy(
    applicationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return serverlessapplicationrepository(
        "GET",
        "/applications/$(applicationId)/policy";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_application_policy(
    applicationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return serverlessapplicationrepository(
        "GET",
        "/applications/$(applicationId)/policy",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_cloud_formation_template(application_id, template_id)
    get_cloud_formation_template(application_id, template_id, params::Dict{String,<:Any})

Gets the specified AWS CloudFormation template.

# Arguments
- `application_id`: The Amazon Resource Name (ARN) of the application.
- `template_id`: The UUID returned by CreateCloudFormationTemplate.Pattern:
  [0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{12}

"""
function get_cloud_formation_template(
    applicationId, templateId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return serverlessapplicationrepository(
        "GET",
        "/applications/$(applicationId)/templates/$(templateId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_cloud_formation_template(
    applicationId,
    templateId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return serverlessapplicationrepository(
        "GET",
        "/applications/$(applicationId)/templates/$(templateId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_application_dependencies(application_id)
    list_application_dependencies(application_id, params::Dict{String,<:Any})

Retrieves the list of applications nested in the containing application.

# Arguments
- `application_id`: The Amazon Resource Name (ARN) of the application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxItems"`: The total number of items to return.
- `"nextToken"`: A token to specify where to start paginating.
- `"semanticVersion"`: The semantic version of the application to get.
"""
function list_application_dependencies(
    applicationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return serverlessapplicationrepository(
        "GET",
        "/applications/$(applicationId)/dependencies";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_application_dependencies(
    applicationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return serverlessapplicationrepository(
        "GET",
        "/applications/$(applicationId)/dependencies",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_application_versions(application_id)
    list_application_versions(application_id, params::Dict{String,<:Any})

Lists versions for the specified application.

# Arguments
- `application_id`: The Amazon Resource Name (ARN) of the application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxItems"`: The total number of items to return.
- `"nextToken"`: A token to specify where to start paginating.
"""
function list_application_versions(
    applicationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return serverlessapplicationrepository(
        "GET",
        "/applications/$(applicationId)/versions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_application_versions(
    applicationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return serverlessapplicationrepository(
        "GET",
        "/applications/$(applicationId)/versions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_applications()
    list_applications(params::Dict{String,<:Any})

Lists applications owned by the requester.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxItems"`: The total number of items to return.
- `"nextToken"`: A token to specify where to start paginating.
"""
function list_applications(; aws_config::AbstractAWSConfig=current_aws_config())
    return serverlessapplicationrepository(
        "GET", "/applications"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_applications(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return serverlessapplicationrepository(
        "GET",
        "/applications",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_application_policy(application_id, statements)
    put_application_policy(application_id, statements, params::Dict{String,<:Any})

Sets the permission policy for an application. For the list of actions supported for this
operation, see
 Application 
 Permissions
 .

# Arguments
- `application_id`: The Amazon Resource Name (ARN) of the application.
- `statements`: An array of policy statements applied to the application.

"""
function put_application_policy(
    applicationId, statements; aws_config::AbstractAWSConfig=current_aws_config()
)
    return serverlessapplicationrepository(
        "PUT",
        "/applications/$(applicationId)/policy",
        Dict{String,Any}("statements" => statements);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_application_policy(
    applicationId,
    statements,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return serverlessapplicationrepository(
        "PUT",
        "/applications/$(applicationId)/policy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("statements" => statements), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    unshare_application(application_id, organization_id)
    unshare_application(application_id, organization_id, params::Dict{String,<:Any})

Unshares an application from an AWS Organization.This operation can be called only from the
organization's master account.

# Arguments
- `application_id`: The Amazon Resource Name (ARN) of the application.
- `organization_id`: The AWS Organization ID to unshare the application from.

"""
function unshare_application(
    applicationId, organizationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return serverlessapplicationrepository(
        "POST",
        "/applications/$(applicationId)/unshare",
        Dict{String,Any}("organizationId" => organizationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function unshare_application(
    applicationId,
    organizationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return serverlessapplicationrepository(
        "POST",
        "/applications/$(applicationId)/unshare",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("organizationId" => organizationId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_application(application_id)
    update_application(application_id, params::Dict{String,<:Any})

Updates the specified application.

# Arguments
- `application_id`: The Amazon Resource Name (ARN) of the application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"author"`: The name of the author publishing the app.Minimum length=1. Maximum
  length=127.Pattern \"^\\[a-z0-9](([a-z0-9]|-(?!-))*[a-z0-9])?\";
- `"description"`: The description of the application.Minimum length=1. Maximum length=256
- `"homePageUrl"`: A URL with more information about the application, for example the
  location of your GitHub repository for the application.
- `"labels"`: Labels to improve discovery of apps in search results.Minimum length=1.
  Maximum length=127. Maximum number of labels: 10Pattern: \"^[a-zA-Z0-9+-_:/@]+\";
- `"readmeBody"`: A text readme file in Markdown language that contains a more detailed
  description of the application and how it works.Maximum size 5 MB
- `"readmeUrl"`: A link to the readme file in Markdown language that contains a more
  detailed description of the application and how it works.Maximum size 5 MB
"""
function update_application(
    applicationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return serverlessapplicationrepository(
        "PATCH",
        "/applications/$(applicationId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_application(
    applicationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return serverlessapplicationrepository(
        "PATCH",
        "/applications/$(applicationId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: auditmanager
using AWS.Compat
using AWS.UUIDs

"""
    associate_assessment_report_evidence_folder(assessment_id, evidence_folder_id)
    associate_assessment_report_evidence_folder(assessment_id, evidence_folder_id, params::Dict{String,<:Any})

 Associates an evidence folder to an assessment report in an Audit Manager assessment.

# Arguments
- `assessment_id`:  The identifier for the assessment.
- `evidence_folder_id`:  The identifier for the folder that the evidence is stored in.

"""
function associate_assessment_report_evidence_folder(
    assessmentId, evidenceFolderId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auditmanager(
        "PUT",
        "/assessments/$(assessmentId)/associateToAssessmentReport",
        Dict{String,Any}("evidenceFolderId" => evidenceFolderId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_assessment_report_evidence_folder(
    assessmentId,
    evidenceFolderId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "PUT",
        "/assessments/$(assessmentId)/associateToAssessmentReport",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("evidenceFolderId" => evidenceFolderId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_associate_assessment_report_evidence(assessment_id, evidence_folder_id, evidence_ids)
    batch_associate_assessment_report_evidence(assessment_id, evidence_folder_id, evidence_ids, params::Dict{String,<:Any})

 Associates a list of evidence to an assessment report in an Audit Manager assessment.

# Arguments
- `assessment_id`:  The identifier for the assessment.
- `evidence_folder_id`:  The identifier for the folder that the evidence is stored in.
- `evidence_ids`:  The list of evidence identifiers.

"""
function batch_associate_assessment_report_evidence(
    assessmentId,
    evidenceFolderId,
    evidenceIds;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "PUT",
        "/assessments/$(assessmentId)/batchAssociateToAssessmentReport",
        Dict{String,Any}(
            "evidenceFolderId" => evidenceFolderId, "evidenceIds" => evidenceIds
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_associate_assessment_report_evidence(
    assessmentId,
    evidenceFolderId,
    evidenceIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "PUT",
        "/assessments/$(assessmentId)/batchAssociateToAssessmentReport",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "evidenceFolderId" => evidenceFolderId, "evidenceIds" => evidenceIds
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_create_delegation_by_assessment(assessment_id, create_delegation_requests)
    batch_create_delegation_by_assessment(assessment_id, create_delegation_requests, params::Dict{String,<:Any})

 Creates a batch of delegations for an assessment in Audit Manager.

# Arguments
- `assessment_id`:  The identifier for the assessment.
- `create_delegation_requests`:  The API request to batch create delegations in Audit
  Manager.

"""
function batch_create_delegation_by_assessment(
    assessmentId,
    createDelegationRequests;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "POST",
        "/assessments/$(assessmentId)/delegations",
        Dict{String,Any}("createDelegationRequests" => createDelegationRequests);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_create_delegation_by_assessment(
    assessmentId,
    createDelegationRequests,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "POST",
        "/assessments/$(assessmentId)/delegations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("createDelegationRequests" => createDelegationRequests),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_delete_delegation_by_assessment(assessment_id, delegation_ids)
    batch_delete_delegation_by_assessment(assessment_id, delegation_ids, params::Dict{String,<:Any})

 Deletes a batch of delegations for an assessment in Audit Manager.

# Arguments
- `assessment_id`:  The identifier for the assessment.
- `delegation_ids`:  The identifiers for the delegations.

"""
function batch_delete_delegation_by_assessment(
    assessmentId, delegationIds; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auditmanager(
        "PUT",
        "/assessments/$(assessmentId)/delegations",
        Dict{String,Any}("delegationIds" => delegationIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_delete_delegation_by_assessment(
    assessmentId,
    delegationIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "PUT",
        "/assessments/$(assessmentId)/delegations",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("delegationIds" => delegationIds), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_disassociate_assessment_report_evidence(assessment_id, evidence_folder_id, evidence_ids)
    batch_disassociate_assessment_report_evidence(assessment_id, evidence_folder_id, evidence_ids, params::Dict{String,<:Any})

 Disassociates a list of evidence from an assessment report in Audit Manager.

# Arguments
- `assessment_id`:  The identifier for the assessment.
- `evidence_folder_id`:  The identifier for the folder that the evidence is stored in.
- `evidence_ids`:  The list of evidence identifiers.

"""
function batch_disassociate_assessment_report_evidence(
    assessmentId,
    evidenceFolderId,
    evidenceIds;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "PUT",
        "/assessments/$(assessmentId)/batchDisassociateFromAssessmentReport",
        Dict{String,Any}(
            "evidenceFolderId" => evidenceFolderId, "evidenceIds" => evidenceIds
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_disassociate_assessment_report_evidence(
    assessmentId,
    evidenceFolderId,
    evidenceIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "PUT",
        "/assessments/$(assessmentId)/batchDisassociateFromAssessmentReport",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "evidenceFolderId" => evidenceFolderId, "evidenceIds" => evidenceIds
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_import_evidence_to_assessment_control(assessment_id, control_id, control_set_id, manual_evidence)
    batch_import_evidence_to_assessment_control(assessment_id, control_id, control_set_id, manual_evidence, params::Dict{String,<:Any})

Adds one or more pieces of evidence to a control in an Audit Manager assessment.  You can
import manual evidence from any S3 bucket by specifying the S3 URI of the object. You can
also upload a file from your browser, or enter plain text in response to a risk assessment
question.  The following restrictions apply to this action:    manualEvidence can be only
one of the following: evidenceFileName, s3ResourcePath, or textResponse    Maximum size of
an individual evidence file: 100 MB   Number of daily manual evidence uploads per control:
100   Supported file formats: See Supported file types for manual evidence in the Audit
Manager User Guide    For more information about Audit Manager service restrictions, see
Quotas and restrictions for Audit Manager.

# Arguments
- `assessment_id`:  The identifier for the assessment.
- `control_id`:  The identifier for the control.
- `control_set_id`:  The identifier for the control set.
- `manual_evidence`:  The list of manual evidence objects.

"""
function batch_import_evidence_to_assessment_control(
    assessmentId,
    controlId,
    controlSetId,
    manualEvidence;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "POST",
        "/assessments/$(assessmentId)/controlSets/$(controlSetId)/controls/$(controlId)/evidence",
        Dict{String,Any}("manualEvidence" => manualEvidence);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_import_evidence_to_assessment_control(
    assessmentId,
    controlId,
    controlSetId,
    manualEvidence,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "POST",
        "/assessments/$(assessmentId)/controlSets/$(controlSetId)/controls/$(controlId)/evidence",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("manualEvidence" => manualEvidence), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_assessment(assessment_reports_destination, framework_id, name, roles, scope)
    create_assessment(assessment_reports_destination, framework_id, name, roles, scope, params::Dict{String,<:Any})

 Creates an assessment in Audit Manager.

# Arguments
- `assessment_reports_destination`:  The assessment report storage destination for the
  assessment that's being created.
- `framework_id`:  The identifier for the framework that the assessment will be created
  from.
- `name`:  The name of the assessment to be created.
- `roles`:  The list of roles for the assessment.
- `scope`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`:  The optional description of the assessment to be created.
- `"tags"`:  The tags that are associated with the assessment.
"""
function create_assessment(
    assessmentReportsDestination,
    frameworkId,
    name,
    roles,
    scope;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "POST",
        "/assessments",
        Dict{String,Any}(
            "assessmentReportsDestination" => assessmentReportsDestination,
            "frameworkId" => frameworkId,
            "name" => name,
            "roles" => roles,
            "scope" => scope,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_assessment(
    assessmentReportsDestination,
    frameworkId,
    name,
    roles,
    scope,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "POST",
        "/assessments",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "assessmentReportsDestination" => assessmentReportsDestination,
                    "frameworkId" => frameworkId,
                    "name" => name,
                    "roles" => roles,
                    "scope" => scope,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_assessment_framework(control_sets, name)
    create_assessment_framework(control_sets, name, params::Dict{String,<:Any})

 Creates a custom framework in Audit Manager.

# Arguments
- `control_sets`:  The control sets that are associated with the framework.
- `name`:  The name of the new custom framework.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"complianceType"`:  The compliance type that the new custom framework supports, such as
  CIS or HIPAA.
- `"description"`:  An optional description for the new custom framework.
- `"tags"`:  The tags that are associated with the framework.
"""
function create_assessment_framework(
    controlSets, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auditmanager(
        "POST",
        "/assessmentFrameworks",
        Dict{String,Any}("controlSets" => controlSets, "name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_assessment_framework(
    controlSets,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "POST",
        "/assessmentFrameworks",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("controlSets" => controlSets, "name" => name),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_assessment_report(assessment_id, name)
    create_assessment_report(assessment_id, name, params::Dict{String,<:Any})

 Creates an assessment report for the specified assessment.

# Arguments
- `assessment_id`:  The identifier for the assessment.
- `name`:  The name of the new assessment report.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`:  The description of the assessment report.
- `"queryStatement"`: A SQL statement that represents an evidence finder query. Provide
  this parameter when you want to generate an assessment report from the results of an
  evidence finder search query. When you use this parameter, Audit Manager generates a
  one-time report using only the evidence from the query output. This report does not include
  any assessment evidence that was manually added to a report using the console, or
  associated with a report using the API.  To use this parameter, the enablementStatus of
  evidence finder must be ENABLED.   For examples and help resolving queryStatement
  validation exceptions, see Troubleshooting evidence finder issues in the Audit Manager User
  Guide.
"""
function create_assessment_report(
    assessmentId, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auditmanager(
        "POST",
        "/assessments/$(assessmentId)/reports",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_assessment_report(
    assessmentId,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "POST",
        "/assessments/$(assessmentId)/reports",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_control(control_mapping_sources, name)
    create_control(control_mapping_sources, name, params::Dict{String,<:Any})

 Creates a new custom control in Audit Manager.

# Arguments
- `control_mapping_sources`:  The data mapping sources for the control.
- `name`:  The name of the control.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"actionPlanInstructions"`:  The recommended actions to carry out if the control isn't
  fulfilled.
- `"actionPlanTitle"`:  The title of the action plan for remediating the control.
- `"description"`:  The description of the control.
- `"tags"`:  The tags that are associated with the control.
- `"testingInformation"`:  The steps to follow to determine if the control is satisfied.
"""
function create_control(
    controlMappingSources, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auditmanager(
        "POST",
        "/controls",
        Dict{String,Any}("controlMappingSources" => controlMappingSources, "name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_control(
    controlMappingSources,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "POST",
        "/controls",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "controlMappingSources" => controlMappingSources, "name" => name
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_assessment(assessment_id)
    delete_assessment(assessment_id, params::Dict{String,<:Any})

 Deletes an assessment in Audit Manager.

# Arguments
- `assessment_id`:  The identifier for the assessment.

"""
function delete_assessment(assessmentId; aws_config::AbstractAWSConfig=current_aws_config())
    return auditmanager(
        "DELETE",
        "/assessments/$(assessmentId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_assessment(
    assessmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "DELETE",
        "/assessments/$(assessmentId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_assessment_framework(framework_id)
    delete_assessment_framework(framework_id, params::Dict{String,<:Any})

 Deletes a custom framework in Audit Manager.

# Arguments
- `framework_id`:  The identifier for the custom framework.

"""
function delete_assessment_framework(
    frameworkId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auditmanager(
        "DELETE",
        "/assessmentFrameworks/$(frameworkId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_assessment_framework(
    frameworkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "DELETE",
        "/assessmentFrameworks/$(frameworkId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_assessment_framework_share(request_id, request_type)
    delete_assessment_framework_share(request_id, request_type, params::Dict{String,<:Any})

 Deletes a share request for a custom framework in Audit Manager.

# Arguments
- `request_id`: The unique identifier for the share request to be deleted.
- `request_type`: Specifies whether the share request is a sent request or a received
  request.

"""
function delete_assessment_framework_share(
    requestId, requestType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auditmanager(
        "DELETE",
        "/assessmentFrameworkShareRequests/$(requestId)",
        Dict{String,Any}("requestType" => requestType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_assessment_framework_share(
    requestId,
    requestType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "DELETE",
        "/assessmentFrameworkShareRequests/$(requestId)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("requestType" => requestType), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_assessment_report(assessment_id, assessment_report_id)
    delete_assessment_report(assessment_id, assessment_report_id, params::Dict{String,<:Any})

Deletes an assessment report in Audit Manager.  When you run the DeleteAssessmentReport
operation, Audit Manager attempts to delete the following data:   The specified assessment
report that’s stored in your S3 bucket   The associated metadata that’s stored in Audit
Manager   If Audit Manager can’t access the assessment report in your S3 bucket, the
report isn’t deleted. In this event, the DeleteAssessmentReport operation doesn’t fail.
Instead, it proceeds to delete the associated metadata only. You must then delete the
assessment report from the S3 bucket yourself.  This scenario happens when Audit Manager
receives a 403 (Forbidden) or 404 (Not Found) error from Amazon S3. To avoid this, make
sure that your S3 bucket is available, and that you configured the correct permissions for
Audit Manager to delete resources in your S3 bucket. For an example permissions policy that
you can use, see Assessment report destination permissions in the Audit Manager User Guide.
For information about the issues that could cause a 403 (Forbidden) or 404 (Not Found)
error from Amazon S3, see List of Error Codes in the Amazon Simple Storage Service API
Reference.

# Arguments
- `assessment_id`:  The unique identifier for the assessment.
- `assessment_report_id`:  The unique identifier for the assessment report.

"""
function delete_assessment_report(
    assessmentId, assessmentReportId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auditmanager(
        "DELETE",
        "/assessments/$(assessmentId)/reports/$(assessmentReportId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_assessment_report(
    assessmentId,
    assessmentReportId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "DELETE",
        "/assessments/$(assessmentId)/reports/$(assessmentReportId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_control(control_id)
    delete_control(control_id, params::Dict{String,<:Any})

 Deletes a custom control in Audit Manager.   When you invoke this operation, the custom
control is deleted from any frameworks or assessments that it’s currently part of. As a
result, Audit Manager will stop collecting evidence for that custom control in all of your
assessments. This includes assessments that you previously created before you deleted the
custom control.

# Arguments
- `control_id`:  The unique identifier for the control.

"""
function delete_control(controlId; aws_config::AbstractAWSConfig=current_aws_config())
    return auditmanager(
        "DELETE",
        "/controls/$(controlId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_control(
    controlId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "DELETE",
        "/controls/$(controlId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    deregister_account()
    deregister_account(params::Dict{String,<:Any})

 Deregisters an account in Audit Manager.   Before you deregister, you can use the
UpdateSettings API operation to set your preferred data retention policy. By default, Audit
Manager retains your data. If you want to delete your data, you can use the
DeregistrationPolicy attribute to request the deletion of your data.  For more information
about data retention, see Data Protection in the Audit Manager User Guide.

"""
function deregister_account(; aws_config::AbstractAWSConfig=current_aws_config())
    return auditmanager(
        "POST",
        "/account/deregisterAccount";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function deregister_account(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auditmanager(
        "POST",
        "/account/deregisterAccount",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    deregister_organization_admin_account()
    deregister_organization_admin_account(params::Dict{String,<:Any})

Removes the specified Amazon Web Services account as a delegated administrator for Audit
Manager.  When you remove a delegated administrator from your Audit Manager settings, you
continue to have access to the evidence that you previously collected under that account.
This is also the case when you deregister a delegated administrator from Organizations.
However, Audit Manager stops collecting and attaching evidence to that delegated
administrator account moving forward.  Keep in mind the following cleanup task if you use
evidence finder: Before you use your management account to remove a delegated
administrator, make sure that the current delegated administrator account signs in to Audit
Manager and disables evidence finder first. Disabling evidence finder automatically deletes
the event data store that was created in their account when they enabled evidence finder.
If this task isn’t completed, the event data store remains in their account. In this
case, we recommend that the original delegated administrator goes to CloudTrail Lake and
manually deletes the event data store. This cleanup task is necessary to ensure that you
don't end up with multiple event data stores. Audit Manager ignores an unused event data
store after you remove or change a delegated administrator account. However, the unused
event data store continues to incur storage costs from CloudTrail Lake if you don't delete
it.  When you deregister a delegated administrator account for Audit Manager, the data for
that account isn’t deleted. If you want to delete resource data for a delegated
administrator account, you must perform that task separately before you deregister the
account. Either, you can do this in the Audit Manager console. Or, you can use one of the
delete API operations that are provided by Audit Manager.  To delete your Audit Manager
resource data, see the following instructions:     DeleteAssessment (see also: Deleting an
assessment in the Audit Manager User Guide)    DeleteAssessmentFramework (see also:
Deleting a custom framework in the Audit Manager User Guide)
DeleteAssessmentFrameworkShare (see also: Deleting a share request in the Audit Manager
User Guide)    DeleteAssessmentReport (see also: Deleting an assessment report in the Audit
Manager User Guide)    DeleteControl (see also: Deleting a custom control in the Audit
Manager User Guide)   At this time, Audit Manager doesn't provide an option to delete
evidence for a specific delegated administrator. Instead, when your management account
deregisters Audit Manager, we perform a cleanup for the current delegated administrator
account at the time of deregistration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"adminAccountId"`:  The identifier for the administrator account.
"""
function deregister_organization_admin_account(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return auditmanager(
        "POST",
        "/account/deregisterOrganizationAdminAccount";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function deregister_organization_admin_account(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auditmanager(
        "POST",
        "/account/deregisterOrganizationAdminAccount",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_assessment_report_evidence_folder(assessment_id, evidence_folder_id)
    disassociate_assessment_report_evidence_folder(assessment_id, evidence_folder_id, params::Dict{String,<:Any})

 Disassociates an evidence folder from the specified assessment report in Audit Manager.

# Arguments
- `assessment_id`:  The unique identifier for the assessment.
- `evidence_folder_id`:  The unique identifier for the folder that the evidence is stored
  in.

"""
function disassociate_assessment_report_evidence_folder(
    assessmentId, evidenceFolderId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auditmanager(
        "PUT",
        "/assessments/$(assessmentId)/disassociateFromAssessmentReport",
        Dict{String,Any}("evidenceFolderId" => evidenceFolderId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_assessment_report_evidence_folder(
    assessmentId,
    evidenceFolderId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "PUT",
        "/assessments/$(assessmentId)/disassociateFromAssessmentReport",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("evidenceFolderId" => evidenceFolderId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_account_status()
    get_account_status(params::Dict{String,<:Any})

 Gets the registration status of an account in Audit Manager.

"""
function get_account_status(; aws_config::AbstractAWSConfig=current_aws_config())
    return auditmanager(
        "GET", "/account/status"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_account_status(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auditmanager(
        "GET",
        "/account/status",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_assessment(assessment_id)
    get_assessment(assessment_id, params::Dict{String,<:Any})

Gets information about a specified assessment.

# Arguments
- `assessment_id`: The unique identifier for the assessment.

"""
function get_assessment(assessmentId; aws_config::AbstractAWSConfig=current_aws_config())
    return auditmanager(
        "GET",
        "/assessments/$(assessmentId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_assessment(
    assessmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "GET",
        "/assessments/$(assessmentId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_assessment_framework(framework_id)
    get_assessment_framework(framework_id, params::Dict{String,<:Any})

Gets information about a specified framework.

# Arguments
- `framework_id`:  The identifier for the framework.

"""
function get_assessment_framework(
    frameworkId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auditmanager(
        "GET",
        "/assessmentFrameworks/$(frameworkId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_assessment_framework(
    frameworkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "GET",
        "/assessmentFrameworks/$(frameworkId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_assessment_report_url(assessment_id, assessment_report_id)
    get_assessment_report_url(assessment_id, assessment_report_id, params::Dict{String,<:Any})

 Gets the URL of an assessment report in Audit Manager.

# Arguments
- `assessment_id`:  The unique identifier for the assessment.
- `assessment_report_id`:  The unique identifier for the assessment report.

"""
function get_assessment_report_url(
    assessmentId, assessmentReportId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auditmanager(
        "GET",
        "/assessments/$(assessmentId)/reports/$(assessmentReportId)/url";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_assessment_report_url(
    assessmentId,
    assessmentReportId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "GET",
        "/assessments/$(assessmentId)/reports/$(assessmentReportId)/url",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_change_logs(assessment_id)
    get_change_logs(assessment_id, params::Dict{String,<:Any})

 Gets a list of changelogs from Audit Manager.

# Arguments
- `assessment_id`: The unique identifier for the assessment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"controlId"`:  The unique identifier for the control.
- `"controlSetId"`:  The unique identifier for the control set.
- `"maxResults"`: Represents the maximum number of results on a page or for an API request
  call.
- `"nextToken"`:  The pagination token that's used to fetch the next set of results.
"""
function get_change_logs(assessmentId; aws_config::AbstractAWSConfig=current_aws_config())
    return auditmanager(
        "GET",
        "/assessments/$(assessmentId)/changelogs";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_change_logs(
    assessmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "GET",
        "/assessments/$(assessmentId)/changelogs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_control(control_id)
    get_control(control_id, params::Dict{String,<:Any})

 Gets information about a specified control.

# Arguments
- `control_id`:  The identifier for the control.

"""
function get_control(controlId; aws_config::AbstractAWSConfig=current_aws_config())
    return auditmanager(
        "GET",
        "/controls/$(controlId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_control(
    controlId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "GET",
        "/controls/$(controlId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_delegations()
    get_delegations(params::Dict{String,<:Any})

 Gets a list of delegations from an audit owner to a delegate.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:  Represents the maximum number of results on a page or for an API request
  call.
- `"nextToken"`:  The pagination token that's used to fetch the next set of results.
"""
function get_delegations(; aws_config::AbstractAWSConfig=current_aws_config())
    return auditmanager(
        "GET", "/delegations"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_delegations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auditmanager(
        "GET",
        "/delegations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_evidence(assessment_id, control_set_id, evidence_folder_id, evidence_id)
    get_evidence(assessment_id, control_set_id, evidence_folder_id, evidence_id, params::Dict{String,<:Any})

 Gets information about a specified evidence item.

# Arguments
- `assessment_id`:  The unique identifier for the assessment.
- `control_set_id`:  The unique identifier for the control set.
- `evidence_folder_id`:  The unique identifier for the folder that the evidence is stored
  in.
- `evidence_id`:  The unique identifier for the evidence.

"""
function get_evidence(
    assessmentId,
    controlSetId,
    evidenceFolderId,
    evidenceId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "GET",
        "/assessments/$(assessmentId)/controlSets/$(controlSetId)/evidenceFolders/$(evidenceFolderId)/evidence/$(evidenceId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_evidence(
    assessmentId,
    controlSetId,
    evidenceFolderId,
    evidenceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "GET",
        "/assessments/$(assessmentId)/controlSets/$(controlSetId)/evidenceFolders/$(evidenceFolderId)/evidence/$(evidenceId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_evidence_by_evidence_folder(assessment_id, control_set_id, evidence_folder_id)
    get_evidence_by_evidence_folder(assessment_id, control_set_id, evidence_folder_id, params::Dict{String,<:Any})

 Gets all evidence from a specified evidence folder in Audit Manager.

# Arguments
- `assessment_id`:  The identifier for the assessment.
- `control_set_id`:  The identifier for the control set.
- `evidence_folder_id`:  The unique identifier for the folder that the evidence is stored
  in.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:  Represents the maximum number of results on a page or for an API request
  call.
- `"nextToken"`:  The pagination token that's used to fetch the next set of results.
"""
function get_evidence_by_evidence_folder(
    assessmentId,
    controlSetId,
    evidenceFolderId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "GET",
        "/assessments/$(assessmentId)/controlSets/$(controlSetId)/evidenceFolders/$(evidenceFolderId)/evidence";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_evidence_by_evidence_folder(
    assessmentId,
    controlSetId,
    evidenceFolderId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "GET",
        "/assessments/$(assessmentId)/controlSets/$(controlSetId)/evidenceFolders/$(evidenceFolderId)/evidence",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_evidence_file_upload_url(file_name)
    get_evidence_file_upload_url(file_name, params::Dict{String,<:Any})

Creates a presigned Amazon S3 URL that can be used to upload a file as manual evidence. For
instructions on how to use this operation, see Upload a file from your browser  in the
Audit Manager User Guide. The following restrictions apply to this operation:   Maximum
size of an individual evidence file: 100 MB   Number of daily manual evidence uploads per
control: 100   Supported file formats: See Supported file types for manual evidence in the
Audit Manager User Guide    For more information about Audit Manager service restrictions,
see Quotas and restrictions for Audit Manager.

# Arguments
- `file_name`: The file that you want to upload. For a list of supported file formats, see
  Supported file types for manual evidence in the Audit Manager User Guide.

"""
function get_evidence_file_upload_url(
    fileName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auditmanager(
        "GET",
        "/evidenceFileUploadUrl",
        Dict{String,Any}("fileName" => fileName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_evidence_file_upload_url(
    fileName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "GET",
        "/evidenceFileUploadUrl",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("fileName" => fileName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_evidence_folder(assessment_id, control_set_id, evidence_folder_id)
    get_evidence_folder(assessment_id, control_set_id, evidence_folder_id, params::Dict{String,<:Any})

 Gets an evidence folder from a specified assessment in Audit Manager.

# Arguments
- `assessment_id`:  The unique identifier for the assessment.
- `control_set_id`:  The unique identifier for the control set.
- `evidence_folder_id`:  The unique identifier for the folder that the evidence is stored
  in.

"""
function get_evidence_folder(
    assessmentId,
    controlSetId,
    evidenceFolderId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "GET",
        "/assessments/$(assessmentId)/controlSets/$(controlSetId)/evidenceFolders/$(evidenceFolderId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_evidence_folder(
    assessmentId,
    controlSetId,
    evidenceFolderId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "GET",
        "/assessments/$(assessmentId)/controlSets/$(controlSetId)/evidenceFolders/$(evidenceFolderId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_evidence_folders_by_assessment(assessment_id)
    get_evidence_folders_by_assessment(assessment_id, params::Dict{String,<:Any})

 Gets the evidence folders from a specified assessment in Audit Manager.

# Arguments
- `assessment_id`:  The unique identifier for the assessment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:  Represents the maximum number of results on a page or for an API request
  call.
- `"nextToken"`:  The pagination token that's used to fetch the next set of results.
"""
function get_evidence_folders_by_assessment(
    assessmentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auditmanager(
        "GET",
        "/assessments/$(assessmentId)/evidenceFolders";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_evidence_folders_by_assessment(
    assessmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "GET",
        "/assessments/$(assessmentId)/evidenceFolders",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_evidence_folders_by_assessment_control(assessment_id, control_id, control_set_id)
    get_evidence_folders_by_assessment_control(assessment_id, control_id, control_set_id, params::Dict{String,<:Any})

 Gets a list of evidence folders that are associated with a specified control in an Audit
Manager assessment.

# Arguments
- `assessment_id`:  The identifier for the assessment.
- `control_id`:  The identifier for the control.
- `control_set_id`:  The identifier for the control set.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:  Represents the maximum number of results on a page or for an API request
  call.
- `"nextToken"`:  The pagination token that's used to fetch the next set of results.
"""
function get_evidence_folders_by_assessment_control(
    assessmentId,
    controlId,
    controlSetId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "GET",
        "/assessments/$(assessmentId)/evidenceFolders-by-assessment-control/$(controlSetId)/$(controlId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_evidence_folders_by_assessment_control(
    assessmentId,
    controlId,
    controlSetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "GET",
        "/assessments/$(assessmentId)/evidenceFolders-by-assessment-control/$(controlSetId)/$(controlId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_insights()
    get_insights(params::Dict{String,<:Any})

Gets the latest analytics data for all your current active assessments.

"""
function get_insights(; aws_config::AbstractAWSConfig=current_aws_config())
    return auditmanager(
        "GET", "/insights"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_insights(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auditmanager(
        "GET", "/insights", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_insights_by_assessment(assessment_id)
    get_insights_by_assessment(assessment_id, params::Dict{String,<:Any})

Gets the latest analytics data for a specific active assessment.

# Arguments
- `assessment_id`: The unique identifier for the assessment.

"""
function get_insights_by_assessment(
    assessmentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auditmanager(
        "GET",
        "/insights/assessments/$(assessmentId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_insights_by_assessment(
    assessmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "GET",
        "/insights/assessments/$(assessmentId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_organization_admin_account()
    get_organization_admin_account(params::Dict{String,<:Any})

 Gets the name of the delegated Amazon Web Services administrator account for a specified
organization.

"""
function get_organization_admin_account(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return auditmanager(
        "GET",
        "/account/organizationAdminAccount";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_organization_admin_account(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auditmanager(
        "GET",
        "/account/organizationAdminAccount",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_services_in_scope()
    get_services_in_scope(params::Dict{String,<:Any})

Gets a list of the Amazon Web Services from which Audit Manager can collect evidence.
Audit Manager defines which Amazon Web Services are in scope for an assessment. Audit
Manager infers this scope by examining the assessment’s controls and their data sources,
and then mapping this information to one or more of the corresponding Amazon Web Services
that are in this list.  For information about why it's no longer possible to specify
services in scope manually, see I can't edit the services in scope for my assessment in the
Troubleshooting section of the Audit Manager user guide.

"""
function get_services_in_scope(; aws_config::AbstractAWSConfig=current_aws_config())
    return auditmanager(
        "GET", "/services"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_services_in_scope(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auditmanager(
        "GET", "/services", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_settings(attribute)
    get_settings(attribute, params::Dict{String,<:Any})

 Gets the settings for a specified Amazon Web Services account.

# Arguments
- `attribute`:  The list of setting attribute enum values.

"""
function get_settings(attribute; aws_config::AbstractAWSConfig=current_aws_config())
    return auditmanager(
        "GET",
        "/settings/$(attribute)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_settings(
    attribute,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "GET",
        "/settings/$(attribute)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_assessment_control_insights_by_control_domain(assessment_id, control_domain_id)
    list_assessment_control_insights_by_control_domain(assessment_id, control_domain_id, params::Dict{String,<:Any})

Lists the latest analytics data for controls within a specific control domain and a
specific active assessment.  Control insights are listed only if the control belongs to the
control domain and assessment that was specified. Moreover, the control must have collected
evidence on the lastUpdated date of controlInsightsByAssessment. If neither of these
conditions are met, no data is listed for that control.

# Arguments
- `assessment_id`: The unique identifier for the active assessment.
- `control_domain_id`: The unique identifier for the control domain.  Audit Manager
  supports the control domains that are provided by Amazon Web Services Control Catalog. For
  information about how to find a list of available control domains, see  ListDomains  in the
  Amazon Web Services Control Catalog API Reference.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Represents the maximum number of results on a page or for an API request
  call.
- `"nextToken"`: The pagination token that's used to fetch the next set of results.
"""
function list_assessment_control_insights_by_control_domain(
    assessmentId, controlDomainId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auditmanager(
        "GET",
        "/insights/controls-by-assessment",
        Dict{String,Any}(
            "assessmentId" => assessmentId, "controlDomainId" => controlDomainId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_assessment_control_insights_by_control_domain(
    assessmentId,
    controlDomainId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "GET",
        "/insights/controls-by-assessment",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "assessmentId" => assessmentId, "controlDomainId" => controlDomainId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_assessment_framework_share_requests(request_type)
    list_assessment_framework_share_requests(request_type, params::Dict{String,<:Any})

 Returns a list of sent or received share requests for custom frameworks in Audit Manager.

# Arguments
- `request_type`:  Specifies whether the share request is a sent request or a received
  request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:  Represents the maximum number of results on a page or for an API request
  call.
- `"nextToken"`:  The pagination token that's used to fetch the next set of results.
"""
function list_assessment_framework_share_requests(
    requestType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auditmanager(
        "GET",
        "/assessmentFrameworkShareRequests",
        Dict{String,Any}("requestType" => requestType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_assessment_framework_share_requests(
    requestType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "GET",
        "/assessmentFrameworkShareRequests",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("requestType" => requestType), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_assessment_frameworks(framework_type)
    list_assessment_frameworks(framework_type, params::Dict{String,<:Any})

 Returns a list of the frameworks that are available in the Audit Manager framework
library.

# Arguments
- `framework_type`:  The type of framework, such as a standard framework or a custom
  framework.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:  Represents the maximum number of results on a page or for an API request
  call.
- `"nextToken"`:  The pagination token that's used to fetch the next set of results.
"""
function list_assessment_frameworks(
    frameworkType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auditmanager(
        "GET",
        "/assessmentFrameworks",
        Dict{String,Any}("frameworkType" => frameworkType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_assessment_frameworks(
    frameworkType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "GET",
        "/assessmentFrameworks",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("frameworkType" => frameworkType), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_assessment_reports()
    list_assessment_reports(params::Dict{String,<:Any})

 Returns a list of assessment reports created in Audit Manager.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:  Represents the maximum number of results on a page or for an API request
  call.
- `"nextToken"`:  The pagination token that's used to fetch the next set of results.
"""
function list_assessment_reports(; aws_config::AbstractAWSConfig=current_aws_config())
    return auditmanager(
        "GET", "/assessmentReports"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_assessment_reports(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auditmanager(
        "GET",
        "/assessmentReports",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_assessments()
    list_assessments(params::Dict{String,<:Any})

 Returns a list of current and past assessments from Audit Manager.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:  Represents the maximum number of results on a page or for an API request
  call.
- `"nextToken"`:  The pagination token that's used to fetch the next set of results.
- `"status"`:  The current status of the assessment.
"""
function list_assessments(; aws_config::AbstractAWSConfig=current_aws_config())
    return auditmanager(
        "GET", "/assessments"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_assessments(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auditmanager(
        "GET",
        "/assessments",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_control_domain_insights()
    list_control_domain_insights(params::Dict{String,<:Any})

Lists the latest analytics data for control domains across all of your active assessments.
Audit Manager supports the control domains that are provided by Amazon Web Services Control
Catalog. For information about how to find a list of available control domains, see
ListDomains  in the Amazon Web Services Control Catalog API Reference.  A control domain is
listed only if at least one of the controls within that domain collected evidence on the
lastUpdated date of controlDomainInsights. If this condition isn’t met, no data is listed
for that control domain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Represents the maximum number of results on a page or for an API request
  call.
- `"nextToken"`: The pagination token that's used to fetch the next set of results.
"""
function list_control_domain_insights(; aws_config::AbstractAWSConfig=current_aws_config())
    return auditmanager(
        "GET",
        "/insights/control-domains";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_control_domain_insights(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auditmanager(
        "GET",
        "/insights/control-domains",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_control_domain_insights_by_assessment(assessment_id)
    list_control_domain_insights_by_assessment(assessment_id, params::Dict{String,<:Any})

Lists analytics data for control domains within a specified active assessment. Audit
Manager supports the control domains that are provided by Amazon Web Services Control
Catalog. For information about how to find a list of available control domains, see
ListDomains  in the Amazon Web Services Control Catalog API Reference.  A control domain is
listed only if at least one of the controls within that domain collected evidence on the
lastUpdated date of controlDomainInsights. If this condition isn’t met, no data is listed
for that domain.

# Arguments
- `assessment_id`: The unique identifier for the active assessment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Represents the maximum number of results on a page or for an API request
  call.
- `"nextToken"`: The pagination token that's used to fetch the next set of results.
"""
function list_control_domain_insights_by_assessment(
    assessmentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auditmanager(
        "GET",
        "/insights/control-domains-by-assessment",
        Dict{String,Any}("assessmentId" => assessmentId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_control_domain_insights_by_assessment(
    assessmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "GET",
        "/insights/control-domains-by-assessment",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("assessmentId" => assessmentId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_control_insights_by_control_domain(control_domain_id)
    list_control_insights_by_control_domain(control_domain_id, params::Dict{String,<:Any})

Lists the latest analytics data for controls within a specific control domain across all
active assessments.  Control insights are listed only if the control belongs to the control
domain that was specified and the control collected evidence on the lastUpdated date of
controlInsightsMetadata. If neither of these conditions are met, no data is listed for that
control.

# Arguments
- `control_domain_id`: The unique identifier for the control domain.  Audit Manager
  supports the control domains that are provided by Amazon Web Services Control Catalog. For
  information about how to find a list of available control domains, see  ListDomains  in the
  Amazon Web Services Control Catalog API Reference.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Represents the maximum number of results on a page or for an API request
  call.
- `"nextToken"`: The pagination token that's used to fetch the next set of results.
"""
function list_control_insights_by_control_domain(
    controlDomainId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auditmanager(
        "GET",
        "/insights/controls",
        Dict{String,Any}("controlDomainId" => controlDomainId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_control_insights_by_control_domain(
    controlDomainId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "GET",
        "/insights/controls",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("controlDomainId" => controlDomainId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_controls(control_type)
    list_controls(control_type, params::Dict{String,<:Any})

 Returns a list of controls from Audit Manager.

# Arguments
- `control_type`: A filter that narrows the list of controls to a specific type.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"controlCatalogId"`: A filter that narrows the list of controls to a specific resource
  from the Amazon Web Services Control Catalog.  To use this parameter, specify the ARN of
  the Control Catalog resource. You can specify either a control domain, a control objective,
  or a common control. For information about how to find the ARNs for these resources, see
  ListDomains ,  ListObjectives , and  ListCommonControls .  You can only filter by one
  Control Catalog resource at a time. Specifying multiple resource ARNs isn’t currently
  supported. If you want to filter by more than one ARN, we recommend that you run the
  ListControls operation separately for each ARN.   Alternatively, specify UNCATEGORIZED to
  list controls that aren't mapped to a Control Catalog resource. For example, this operation
  might return a list of custom controls that don't belong to any control domain or control
  objective.
- `"maxResults"`: The maximum number of results on a page or for an API request call.
- `"nextToken"`: The pagination token that's used to fetch the next set of results.
"""
function list_controls(controlType; aws_config::AbstractAWSConfig=current_aws_config())
    return auditmanager(
        "GET",
        "/controls",
        Dict{String,Any}("controlType" => controlType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_controls(
    controlType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "GET",
        "/controls",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("controlType" => controlType), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_keywords_for_data_source(source)
    list_keywords_for_data_source(source, params::Dict{String,<:Any})

Returns a list of keywords that are pre-mapped to the specified control data source.

# Arguments
- `source`: The control mapping data source that the keywords apply to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:  Represents the maximum number of results on a page or for an API request
  call.
- `"nextToken"`:  The pagination token that's used to fetch the next set of results.
"""
function list_keywords_for_data_source(
    source; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auditmanager(
        "GET",
        "/dataSourceKeywords",
        Dict{String,Any}("source" => source);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_keywords_for_data_source(
    source, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auditmanager(
        "GET",
        "/dataSourceKeywords",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("source" => source), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_notifications()
    list_notifications(params::Dict{String,<:Any})

 Returns a list of all Audit Manager notifications.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:  Represents the maximum number of results on a page or for an API request
  call.
- `"nextToken"`:  The pagination token that's used to fetch the next set of results.
"""
function list_notifications(; aws_config::AbstractAWSConfig=current_aws_config())
    return auditmanager(
        "GET", "/notifications"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_notifications(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auditmanager(
        "GET",
        "/notifications",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

 Returns a list of tags for the specified resource in Audit Manager.

# Arguments
- `resource_arn`:  The Amazon Resource Name (ARN) of the resource.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auditmanager(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    register_account()
    register_account(params::Dict{String,<:Any})

 Enables Audit Manager for the specified Amazon Web Services account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"delegatedAdminAccount"`:  The delegated administrator account for Audit Manager.
- `"kmsKey"`:  The KMS key details.
"""
function register_account(; aws_config::AbstractAWSConfig=current_aws_config())
    return auditmanager(
        "POST",
        "/account/registerAccount";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function register_account(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auditmanager(
        "POST",
        "/account/registerAccount",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    register_organization_admin_account(admin_account_id)
    register_organization_admin_account(admin_account_id, params::Dict{String,<:Any})

 Enables an Amazon Web Services account within the organization as the delegated
administrator for Audit Manager.

# Arguments
- `admin_account_id`:  The identifier for the delegated administrator account.

"""
function register_organization_admin_account(
    adminAccountId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auditmanager(
        "POST",
        "/account/registerOrganizationAdminAccount",
        Dict{String,Any}("adminAccountId" => adminAccountId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function register_organization_admin_account(
    adminAccountId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "POST",
        "/account/registerOrganizationAdminAccount",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("adminAccountId" => adminAccountId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_assessment_framework_share(destination_account, destination_region, framework_id)
    start_assessment_framework_share(destination_account, destination_region, framework_id, params::Dict{String,<:Any})

 Creates a share request for a custom framework in Audit Manager.  The share request
specifies a recipient and notifies them that a custom framework is available. Recipients
have 120 days to accept or decline the request. If no action is taken, the share request
expires. When you create a share request, Audit Manager stores a snapshot of your custom
framework in the US East (N. Virginia) Amazon Web Services Region. Audit Manager also
stores a backup of the same snapshot in the US West (Oregon) Amazon Web Services Region.
Audit Manager deletes the snapshot and the backup snapshot when one of the following events
occurs:   The sender revokes the share request.   The recipient declines the share request.
  The recipient encounters an error and doesn't successfully accept the share request.
The share request expires before the recipient responds to the request.   When a sender
resends a share request, the snapshot is replaced with an updated version that corresponds
with the latest version of the custom framework.  When a recipient accepts a share request,
the snapshot is replicated into their Amazon Web Services account under the Amazon Web
Services Region that was specified in the share request.   When you invoke the
StartAssessmentFrameworkShare API, you are about to share a custom framework with another
Amazon Web Services account. You may not share a custom framework that is derived from a
standard framework if the standard framework is designated as not eligible for sharing by
Amazon Web Services, unless you have obtained permission to do so from the owner of the
standard framework. To learn more about which standard frameworks are eligible for sharing,
see Framework sharing eligibility in the Audit Manager User Guide.

# Arguments
- `destination_account`:  The Amazon Web Services account of the recipient.
- `destination_region`:  The Amazon Web Services Region of the recipient.
- `framework_id`:  The unique identifier for the custom framework to be shared.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"comment"`:  An optional comment from the sender about the share request.
"""
function start_assessment_framework_share(
    destinationAccount,
    destinationRegion,
    frameworkId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "POST",
        "/assessmentFrameworks/$(frameworkId)/shareRequests",
        Dict{String,Any}(
            "destinationAccount" => destinationAccount,
            "destinationRegion" => destinationRegion,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_assessment_framework_share(
    destinationAccount,
    destinationRegion,
    frameworkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "POST",
        "/assessmentFrameworks/$(frameworkId)/shareRequests",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "destinationAccount" => destinationAccount,
                    "destinationRegion" => destinationRegion,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

 Tags the specified resource in Audit Manager.

# Arguments
- `resource_arn`:  The Amazon Resource Name (ARN) of the resource.
- `tags`:  The tags that are associated with the resource.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return auditmanager(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

 Removes a tag from a resource in Audit Manager.

# Arguments
- `resource_arn`:  The Amazon Resource Name (ARN) of the specified resource.
- `tag_keys`:  The name or key of the tag.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auditmanager(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_assessment(assessment_id, scope)
    update_assessment(assessment_id, scope, params::Dict{String,<:Any})

 Edits an Audit Manager assessment.

# Arguments
- `assessment_id`:  The unique identifier for the assessment.
- `scope`:  The scope of the assessment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"assessmentDescription"`:  The description of the assessment.
- `"assessmentName"`:  The name of the assessment to be updated.
- `"assessmentReportsDestination"`:  The assessment report storage destination for the
  assessment that's being updated.
- `"roles"`:  The list of roles for the assessment.
"""
function update_assessment(
    assessmentId, scope; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auditmanager(
        "PUT",
        "/assessments/$(assessmentId)",
        Dict{String,Any}("scope" => scope);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_assessment(
    assessmentId,
    scope,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "PUT",
        "/assessments/$(assessmentId)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("scope" => scope), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_assessment_control(assessment_id, control_id, control_set_id)
    update_assessment_control(assessment_id, control_id, control_set_id, params::Dict{String,<:Any})

 Updates a control within an assessment in Audit Manager.

# Arguments
- `assessment_id`:  The unique identifier for the assessment.
- `control_id`:  The unique identifier for the control.
- `control_set_id`:  The unique identifier for the control set.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"commentBody"`:  The comment body text for the control.
- `"controlStatus"`:  The status of the control.
"""
function update_assessment_control(
    assessmentId,
    controlId,
    controlSetId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "PUT",
        "/assessments/$(assessmentId)/controlSets/$(controlSetId)/controls/$(controlId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_assessment_control(
    assessmentId,
    controlId,
    controlSetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "PUT",
        "/assessments/$(assessmentId)/controlSets/$(controlSetId)/controls/$(controlId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_assessment_control_set_status(assessment_id, comment, control_set_id, status)
    update_assessment_control_set_status(assessment_id, comment, control_set_id, status, params::Dict{String,<:Any})

 Updates the status of a control set in an Audit Manager assessment.

# Arguments
- `assessment_id`:  The unique identifier for the assessment.
- `comment`:  The comment that's related to the status update.
- `control_set_id`:  The unique identifier for the control set.
- `status`:  The status of the control set that's being updated.

"""
function update_assessment_control_set_status(
    assessmentId,
    comment,
    controlSetId,
    status;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "PUT",
        "/assessments/$(assessmentId)/controlSets/$(controlSetId)/status",
        Dict{String,Any}("comment" => comment, "status" => status);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_assessment_control_set_status(
    assessmentId,
    comment,
    controlSetId,
    status,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "PUT",
        "/assessments/$(assessmentId)/controlSets/$(controlSetId)/status",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("comment" => comment, "status" => status), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_assessment_framework(control_sets, framework_id, name)
    update_assessment_framework(control_sets, framework_id, name, params::Dict{String,<:Any})

 Updates a custom framework in Audit Manager.

# Arguments
- `control_sets`:  The control sets that are associated with the framework.
- `framework_id`:  The unique identifier for the framework.
- `name`:  The name of the framework to be updated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"complianceType"`:  The compliance type that the new custom framework supports, such as
  CIS or HIPAA.
- `"description"`:  The description of the updated framework.
"""
function update_assessment_framework(
    controlSets, frameworkId, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auditmanager(
        "PUT",
        "/assessmentFrameworks/$(frameworkId)",
        Dict{String,Any}("controlSets" => controlSets, "name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_assessment_framework(
    controlSets,
    frameworkId,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "PUT",
        "/assessmentFrameworks/$(frameworkId)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("controlSets" => controlSets, "name" => name),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_assessment_framework_share(action, request_id, request_type)
    update_assessment_framework_share(action, request_id, request_type, params::Dict{String,<:Any})

 Updates a share request for a custom framework in Audit Manager.

# Arguments
- `action`: Specifies the update action for the share request.
- `request_id`:  The unique identifier for the share request.
- `request_type`: Specifies whether the share request is a sent request or a received
  request.

"""
function update_assessment_framework_share(
    action, requestId, requestType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auditmanager(
        "PUT",
        "/assessmentFrameworkShareRequests/$(requestId)",
        Dict{String,Any}("action" => action, "requestType" => requestType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_assessment_framework_share(
    action,
    requestId,
    requestType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "PUT",
        "/assessmentFrameworkShareRequests/$(requestId)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("action" => action, "requestType" => requestType),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_assessment_status(assessment_id, status)
    update_assessment_status(assessment_id, status, params::Dict{String,<:Any})

 Updates the status of an assessment in Audit Manager.

# Arguments
- `assessment_id`:  The unique identifier for the assessment.
- `status`:  The current status of the assessment.

"""
function update_assessment_status(
    assessmentId, status; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auditmanager(
        "PUT",
        "/assessments/$(assessmentId)/status",
        Dict{String,Any}("status" => status);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_assessment_status(
    assessmentId,
    status,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "PUT",
        "/assessments/$(assessmentId)/status",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("status" => status), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_control(control_id, control_mapping_sources, name)
    update_control(control_id, control_mapping_sources, name, params::Dict{String,<:Any})

 Updates a custom control in Audit Manager.

# Arguments
- `control_id`:  The identifier for the control.
- `control_mapping_sources`:  The data mapping sources for the control.
- `name`:  The name of the updated control.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"actionPlanInstructions"`:  The recommended actions to carry out if the control isn't
  fulfilled.
- `"actionPlanTitle"`:  The title of the action plan for remediating the control.
- `"description"`:  The optional description of the control.
- `"testingInformation"`:  The steps that you should follow to determine if the control is
  met.
"""
function update_control(
    controlId,
    controlMappingSources,
    name;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "PUT",
        "/controls/$(controlId)",
        Dict{String,Any}("controlMappingSources" => controlMappingSources, "name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_control(
    controlId,
    controlMappingSources,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "PUT",
        "/controls/$(controlId)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "controlMappingSources" => controlMappingSources, "name" => name
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_settings()
    update_settings(params::Dict{String,<:Any})

 Updates Audit Manager settings for the current account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"defaultAssessmentReportsDestination"`:  The default S3 destination bucket for storing
  assessment reports.
- `"defaultExportDestination"`:  The default S3 destination bucket for storing evidence
  finder exports.
- `"defaultProcessOwners"`:  A list of the default audit owners.
- `"deregistrationPolicy"`: The deregistration policy for your Audit Manager data. You can
  use this attribute to determine how your data is handled when you deregister Audit Manager.
- `"evidenceFinderEnabled"`: Specifies whether the evidence finder feature is enabled.
  Change this attribute to enable or disable evidence finder.  When you use this attribute to
  disable evidence finder, Audit Manager deletes the event data store that’s used to query
  your evidence data. As a result, you can’t re-enable evidence finder and use the feature
  again. Your only alternative is to deregister and then re-register Audit Manager.
- `"kmsKey"`:  The KMS key details.
- `"snsTopic"`:  The Amazon Simple Notification Service (Amazon SNS) topic that Audit
  Manager sends notifications to.
"""
function update_settings(; aws_config::AbstractAWSConfig=current_aws_config())
    return auditmanager(
        "PUT", "/settings"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function update_settings(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auditmanager(
        "PUT", "/settings", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    validate_assessment_report_integrity(s3_relative_path)
    validate_assessment_report_integrity(s3_relative_path, params::Dict{String,<:Any})

 Validates the integrity of an assessment report in Audit Manager.

# Arguments
- `s3_relative_path`:  The relative path of the Amazon S3 bucket that the assessment report
  is stored in.

"""
function validate_assessment_report_integrity(
    s3RelativePath; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auditmanager(
        "POST",
        "/assessmentReports/integrity",
        Dict{String,Any}("s3RelativePath" => s3RelativePath);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function validate_assessment_report_integrity(
    s3RelativePath,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auditmanager(
        "POST",
        "/assessmentReports/integrity",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("s3RelativePath" => s3RelativePath), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

struct Route
    method::String
    path::String
    handler
end

function register!(router::HTTP.Router, route::Route)
    return HTTP.register!(router, route.method, route.path, route.handler)
end

function Router(routes)
    router = HTTP.Router()
    for route in routes
        register!(router, route)
    end
    return router
end

function token_handler(token)
    handler = function (req::HTTP.Request)
        ttl_secs = HTTP.header(req, "X-aws-ec2-metadata-token-ttl-seconds", nothing)
        if !isnothing(ttl_secs)
            HTTP.Response(200, token)
        else
            HTTP.Response(400)  # Behavior when required header is missing
        end
    end
    return handler
end

function token_route(token)
    return Route("PUT", "/latest/api/token", token_handler(token))
end

function secure_route(route::Route, token)
    wrapper = function (req::HTTP.Request)
        if HTTP.header(req, "X-aws-ec2-metadata-token", nothing) == token
            route.handler(req)
        else
            HTTP.Response(401)  # Behavior when IMDSv2 is required
        end
    end

    return Route(route.method, route.path, wrapper)
end

function response_route(method, path, response::HTTP.Response)
    handler = function (req::HTTP.Request)
        return HTTP.Response(
            response.version, response.status, response.headers, response.body, req
        )
    end
    return Route(method, path, handler)
end

# Use Mocking to re-route requests to 169.254.169.254 without having to actually start an
# HTTP.jl server. Should result in faster running tests.
function _imds_patch(
    router::HTTP.Router=HTTP.Router();
    listening=true,
    enabled=true,
    num_requests::Threads.Atomic{Int}=Threads.Atomic{Int}(),
)
    num_requests[] = 0

    patch = @patch function HTTP.request(
        method,
        url,
        headers=[],
        body=HTTP.nobody;
        status_exception=true,
        retry::Bool=true,
        retries::Int=4,
        retry_delays=ExponentialBackOff(; n=retries, factor=3),
        retry_check=(args...) -> false,
        kwargs...,
    )
        uri = HTTP.URI(url)
        if uri.host != "169.254.169.254"
            error("Internal error: Unexpected HTTP call to non-IMDS service: $url")
        end

        req = HTTP.Request(method, uri.path, headers, body)

        function handler(req::HTTP.Request)
            num_requests[] += 1

            resp = if listening && enabled
                router(req)
            elseif listening && !enabled
                HTTP.Response(403)
            else
                connect_timeout = HTTP.ConnectionPool.ConnectTimeout(uri.host, uri.port)
                throw(HTTP.Exceptions.ConnectError(string(uri), connect_timeout))
            end

            # When `status_exception=false` retries do not occur as an exception needs to
            # be raised for them to work. This replicates how `HTTP.request` works.
            if status_exception && resp.status >= 300
                ex = HTTP.Exceptions.StatusError(resp.status, req.method, req.target, resp)
                throw(ex)
            end
            return resp
        end

        retry_request = Base.retry(
            handler;
            delays=retry_delays,
            check=(s, ex) -> begin
                resp_body = get(req.context, :response_body, nothing)
                resp = !isnothing(resp_body) ? req.response : nothing
                retry = (
                    (HTTP.RetryRequest.isrecoverable(ex) && HTTP.retryable(req)) || (
                        HTTP.retryablebody(req) && retry_check(s, ex, req, resp, resp_body)
                    )
                )
                return retry
            end,
        )

        return retry_request(req)
    end
end

@testset "IMDS" begin
    @testset "is_connection_exception / is_ttl_expired_exception" begin
        url = "http://169.254.169.254/latest/api/token"
        connect_timeout = HTTP.ConnectionPool.ConnectTimeout("169.254.169.254", 80)
        e = HTTP.Exceptions.ConnectError(url, connect_timeout)
        @test IMDS.is_connection_exception(e)
        @test !IMDS.is_ttl_expired_exception(e)

        request = HTTP.Request("PUT", "/latest/api/token", [], HTTP.nobody)
        io_error = Base.IOError("read: connection timed out (ETIMEDOUT)", -110)
        e = HTTP.Exceptions.RequestError(request, io_error)
        @test !IMDS.is_connection_exception(e)
        @test IMDS.is_ttl_expired_exception(e)

        e = ErrorException("non-connection error")
        @test !IMDS.is_connection_exception(e)
        @test !IMDS.is_ttl_expired_exception(e)
    end

    @testset "refresh_token!" begin
        # Running outside of an EC2 instance
        apply(_imds_patch(; listening=false)) do
            session = IMDS.Session()
            @test isempty(session.token)
            @test session.duration == IMDS.DEFAULT_DURATION
            @test IMDS.token_expired(session)

            @test_throws IMDSUnavailable IMDS.refresh_token!(session)
        end

        # Running on an EC2 instance where IMDS is disabled
        apply(_imds_patch(; enabled=false)) do
            session = IMDS.Session()
            @test_throws IMDSUnavailable IMDS.refresh_token!(session)
        end

        # IMDS is non-functional
        router = Router([response_route("PUT", "/latest/api/token", HTTP.Response(500))])
        apply(_imds_patch(router)) do
            session = IMDS.Session()
            @test_throws HTTP.Exceptions.StatusError IMDS.refresh_token!(session)
        end

        # IMDSv1 is available
        router = Router([response_route("PUT", "/latest/api/token", HTTP.Response(404))])
        apply(_imds_patch(router)) do
            session = IMDS.Session()
            @test IMDS.refresh_token!(session) === session
            @test isempty(session.token)
            @test session.duration == 0
            @test session.expiration == typemax(Int64)
        end

        # IMDSv2 is available
        token = "foo"
        router = Router([token_route(token)])
        apply(_imds_patch(router)) do
            session = IMDS.Session(; duration=60)
            t = floor(Int64, time())
            @test IMDS.refresh_token!(session) === session
            @test session.token == token
            @test session.duration == 60
            @test 0 <= session.expiration - (t + session.duration) <= 5
        end

        # Ensure that the session token is reset on a refresh. This is a theoretical corner
        # case that has not been observed in the wild.
        @testset "invalidate session token" begin
            # IMDSv2 hop limit is too low such that the TTL has expired
            connection_timeout = function (req::HTTP.Request)
                io_error = Base.IOError("read: connection timed out (ETIMEDOUT)", -110)
                throw(HTTP.Exceptions.RequestError(request, io_error))
            end
            router = Router([Route("PUT", "/latest/api/token", connection_timeout)])
            apply(_imds_patch(router)) do
                # Set some initial values so we can tell what gets modified
                session = IMDS.Session("bar", -1, -1)
                msg_regex = r"IMDSv2 token request rejected due to reaching hop limit"
                @test_logs (:warn, msg_regex) begin
                    @test IMDS.refresh_token!(session) === session
                end
                @test isempty(session.token)
                @test session.duration == 0
                @test session.expiration == typemax(Int64)
            end

            # IMDSv1 is available
            router = Router([
                response_route("PUT", "/latest/api/token", HTTP.Response(404))
            ])
            apply(_imds_patch(router)) do
                # Set some initial values so we can tell what gets modified
                session = IMDS.Session("bar", -1, -1)
                @test IMDS.refresh_token!(session) === session
                @test isempty(session.token)
                @test session.duration == 0
                @test session.expiration == typemax(Int64)
            end
        end
    end

    @testset "request" begin
        instance_id = "123"
        path = "/latest/meta-data/instance-id"
        num_requests = Threads.Atomic{Int}()

        # Running outside of an EC2 instance
        apply(_imds_patch(; listening=false, num_requests)) do
            session = IMDS.Session()
            @test_throws IMDSUnavailable IMDS.request(session, "GET", path)
            @test num_requests[] == 1
        end

        # Running on an EC2 instance where IMDS is disabled
        apply(_imds_patch(; enabled=false, num_requests)) do
            session = IMDS.Session()
            @test_throws IMDSUnavailable IMDS.request(session, "GET", path)
            @test num_requests[] == 1
        end

        # Requested metadata is missing
        router = Router([response_route("GET", path, HTTP.Response(500))])
        apply(_imds_patch(router; num_requests)) do
            session = IMDS.Session()
            @test_throws HTTP.Exceptions.StatusError IMDS.request(session, "GET", path)
            @test num_requests[] == 2
        end

        # Requested metadata available via IMDSv1
        router = Router([response_route("GET", path, HTTP.Response(instance_id))])
        apply(_imds_patch(router; num_requests)) do
            session = IMDS.Session()
            r = IMDS.request(session, "GET", path)
            @test num_requests[] == 2
            @test r isa HTTP.Response
            @test r.status == 200
            @test String(r.body) == instance_id
            @test isempty(session.token)
        end

        # Requested metadata available via IMDSv2
        token = "token"
        router = Router([
            token_route(token),
            secure_route(response_route("GET", path, HTTP.Response(instance_id)), token),
        ])
        apply(_imds_patch(router; num_requests)) do
            session = IMDS.Session()
            r = IMDS.request(session, "GET", path)
            @test num_requests[] == 2
            @test r isa HTTP.Response
            @test r.status == 200
            @test String(r.body) == instance_id
            @test session.token == token
        end

        # Invalid token used with IMDSv2
        router = Router([
            token_route("good"),
            secure_route(response_route("GET", path, HTTP.Response(instance_id)), "bad"),
        ])
        apply(_imds_patch(router; num_requests)) do
            session = IMDS.Session()
            r = IMDS.request(session, "GET", path; status_exception=false)
            @test num_requests[] == 2
            @test r isa HTTP.Response
            @test r.status == 401
        end

        # Unlikely scenario where the instance metadata services has switched over from
        # IMDSv2 being optional to required while a long running Julia service on that
        # instance has session which is set to use IMDSv1 indefinitely.
        # TODO: We may want to have the code automatically attempt a token refresh when this
        # occurs but I doubt this scenario will occur in scenario will occur in reality as
        # instances cannot be configured to use IMDSv1 only.
        token = "token"
        router = Router([
            token_route(token),
            secure_route(response_route("GET", path, HTTP.Response(instance_id)), token),
        ])
        apply(_imds_patch(router; num_requests)) do
            # Emulate a pre-existing session where IMDSv2 was not available.
            session = IMDS.Session("", 60, typemax(Int64))

            # Request attempts to use IMDSv1 but now only IMDSv2 is enabled
            r = IMDS.request(session, "GET", path; status_exception=false)
            @test num_requests[] == 1
            @test r isa HTTP.Response
            @test r.status == 401
        end

        # When running in a container running on an EC2 instance and the hop limit is 1 the
        # IMDSv2 token retrieval will fail so we should fall back to using IMDSv1.
        # https://github.com/JuliaCloud/AWS.jl/issues/654
        # https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instancedata-data-retrieval.html#imds-considerations
        connection_timeout = function (req::HTTP.Request)
            io_error = Base.IOError("read: connection timed out (ETIMEDOUT)", -110)
            throw(HTTP.Exceptions.RequestError(request, io_error))
        end
        router = Router([
            Route("PUT", "/latest/api/token", connection_timeout),
            response_route("GET", path, HTTP.Response(instance_id)),
        ])
        apply(_imds_patch(router; num_requests)) do
            session = IMDS.Session()
            msg_regex = r"IMDSv2 token request rejected due to reaching hop limit"
            r = @test_logs (:warn, msg_regex) begin
                IMDS.request(session, "GET", path; status_exception=false)
            end
            @test num_requests[] == 2
            @test r isa HTTP.Response
            @test r.status == 200
            @test String(r.body) == instance_id
            @test isempty(session.token)
        end

        # IMDSv2 token is has expired but the local `expiration` states the token is still
        # valid. Could happen on an EC2 instance where the clock drift exceeds the value
        # used in `token_expired`.
        router = Router([
            token_route("new"),
            secure_route(response_route("GET", path, HTTP.Response(instance_id)), "new"),
        ])
        apply(_imds_patch(router; num_requests)) do
            # Simulate a token which doesn't appear to be expired but is
            t = floor(Int64, time())
            duration = IMDS.DEFAULT_DURATION
            session = IMDS.Session("old", duration, t + duration)

            r = IMDS.request(session, "GET", path; status_exception=false)
            @test num_requests[] == 3
            @test r isa HTTP.Response
            @test r.status == 200
            @test String(r.body) == instance_id
            @test session.token == "new"
        end

        # Validate that we only refresh the token once during a call to `IMDS.request`
        dynamic_token_route = function ()
            num_calls = Threads.Atomic{Int}(0)
            handler = function (req::HTTP.Request)
                num_calls[] += 1
                token = if num_calls[] == 1
                    "old"
                elseif num_calls[] == 2
                    "new"
                else
                    "too many calls"
                end
                return token_handler(token)(req)
            end
            return Route("PUT", "/latest/api/token", handler)
        end
        router = Router([
            dynamic_token_route(),
            secure_route(response_route("GET", path, HTTP.Response(instance_id)), "valid"),
        ])
        apply(_imds_patch(router; num_requests)) do
            t = floor(Int64, time())
            duration = IMDS.DEFAULT_DURATION
            session = IMDS.Session()

            # Fetch a token and attempt to fetch the metadata. The fetched token is invalid
            # so the request fails with "401 Unauthorized" but we do not refresh the token
            # as we've already refreshed the token during this call.
            r = IMDS.request(session, "GET", path; status_exception=false)
            @test num_requests[] == 2
            @test r isa HTTP.Response
            @test r.status == 401
            @test session.token == "old"

            # Use existing token to fetch metadata which fails with "401 Unauthorized".
            # Since we haven't fetched a token during this call we retry the request with
            # a new token once.
            r = IMDS.request(session, "GET", path; status_exception=false)
            @test num_requests[] == 5
            @test r isa HTTP.Response
            @test r.status == 401
            @test session.token == "new"
        end
    end

    @testset "get" begin
        instance_id = "123"
        path = "/latest/meta-data/instance-id"

        # Running outside of an EC2 instancee
        apply(_imds_patch(; listening=false)) do
            session = IMDS.Session()
            @test IMDS.get(session, path) === nothing
        end

        # Requested metadata available via IMDSv1
        router = Router([response_route("GET", path, HTTP.Response(instance_id))])
        apply(_imds_patch(router)) do
            session = IMDS.Session()
            @test IMDS.get(session, path) == instance_id
        end

        # When using GitHub Action CI a non-IMDS service uses the same local-link address
        # and returns HTTP 404.
        # https://github.com/JuliaCloud/AWS.jl/issues/652
        iam_path = "/latest/meta-data/iam/info"
        router = Router([
            response_route("PUT", "/**", HTTP.Response(404)),
            response_route("GET", "/**", HTTP.Response(404)),
        ])
        apply(_imds_patch(router)) do
            session = IMDS.Session()
            response = IMDS.request(session, "GET", iam_path; status_exception=false)
            @test response.status == 404
            @test IMDS.get(session, iam_path) === nothing
        end
    end

    @testset "region" begin
        region = "ap-atlantis-1"  # Made up region
        path = "/latest/meta-data/placement/region"

        # Running outside of an EC2 instance
        apply(_imds_patch(; listening=false)) do
            session = IMDS.Session()
            @test IMDS.region(session) === nothing
        end

        # Running on a webserver which doesn't understand our requests and returns HTTP 404.
        # This exact scenario occurs in GHA CI and can be reproduced locally with the
        # `aws-vault exec --ec2-server` which provides a very limited implementation of
        # IMDSv1.
        router = Router([
            response_route("PUT", "/**", HTTP.Response(404)),
            response_route("GET", "/**", HTTP.Response(404)),
        ])
        apply(_imds_patch(router)) do
            session = IMDS.Session()
            response = IMDS.request(session, "GET", path; status_exception=false)
            @test response.status == 404
            @test IMDS.region(session) === nothing
        end

        # Requested metadata available via IMDSv1
        router = Router([response_route("GET", path, HTTP.Response(region))])
        apply(_imds_patch(router)) do
            session = IMDS.Session()
            @test IMDS.region(session) == region
        end
    end
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: worklink
using AWS.Compat
using AWS.UUIDs

"""
    associate_domain(acm_certificate_arn, domain_name, fleet_arn)
    associate_domain(acm_certificate_arn, domain_name, fleet_arn, params::Dict{String,<:Any})

Specifies a domain to be associated to Amazon WorkLink.

# Arguments
- `acm_certificate_arn`: The ARN of an issued ACM certificate that is valid for the domain
  being associated.
- `domain_name`: The fully qualified domain name (FQDN).
- `fleet_arn`: The Amazon Resource Name (ARN) of the fleet.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DisplayName"`: The name to display.
"""
function associate_domain(
    AcmCertificateArn,
    DomainName,
    FleetArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return worklink(
        "POST",
        "/associateDomain",
        Dict{String,Any}(
            "AcmCertificateArn" => AcmCertificateArn,
            "DomainName" => DomainName,
            "FleetArn" => FleetArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_domain(
    AcmCertificateArn,
    DomainName,
    FleetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return worklink(
        "POST",
        "/associateDomain",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AcmCertificateArn" => AcmCertificateArn,
                    "DomainName" => DomainName,
                    "FleetArn" => FleetArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_website_authorization_provider(authorization_provider_type, fleet_arn)
    associate_website_authorization_provider(authorization_provider_type, fleet_arn, params::Dict{String,<:Any})

Associates a website authorization provider with a specified fleet. This is used to
authorize users against associated websites in the company network.

# Arguments
- `authorization_provider_type`: The authorization provider type.
- `fleet_arn`: The ARN of the fleet.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DomainName"`: The domain name of the authorization provider. This applies only to
  SAML-based authorization providers.
"""
function associate_website_authorization_provider(
    AuthorizationProviderType, FleetArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return worklink(
        "POST",
        "/associateWebsiteAuthorizationProvider",
        Dict{String,Any}(
            "AuthorizationProviderType" => AuthorizationProviderType, "FleetArn" => FleetArn
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_website_authorization_provider(
    AuthorizationProviderType,
    FleetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return worklink(
        "POST",
        "/associateWebsiteAuthorizationProvider",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AuthorizationProviderType" => AuthorizationProviderType,
                    "FleetArn" => FleetArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_website_certificate_authority(certificate, fleet_arn)
    associate_website_certificate_authority(certificate, fleet_arn, params::Dict{String,<:Any})

Imports the root certificate of a certificate authority (CA) used to obtain TLS
certificates used by associated websites within the company network.

# Arguments
- `certificate`: The root certificate of the CA.
- `fleet_arn`: The ARN of the fleet.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DisplayName"`: The certificate name to display.
"""
function associate_website_certificate_authority(
    Certificate, FleetArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return worklink(
        "POST",
        "/associateWebsiteCertificateAuthority",
        Dict{String,Any}("Certificate" => Certificate, "FleetArn" => FleetArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_website_certificate_authority(
    Certificate,
    FleetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return worklink(
        "POST",
        "/associateWebsiteCertificateAuthority",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Certificate" => Certificate, "FleetArn" => FleetArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_fleet(fleet_name)
    create_fleet(fleet_name, params::Dict{String,<:Any})

Creates a fleet. A fleet consists of resources and the configuration that delivers
associated websites to authorized users who download and set up the Amazon WorkLink app.

# Arguments
- `fleet_name`: A unique name for the fleet.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DisplayName"`: The fleet name to display.
- `"OptimizeForEndUserLocation"`: The option to optimize for better performance by routing
  traffic through the closest AWS Region to users, which may be outside of your home Region.
- `"Tags"`:  The tags to add to the resource. A tag is a key-value pair.
"""
function create_fleet(FleetName; aws_config::AbstractAWSConfig=current_aws_config())
    return worklink(
        "POST",
        "/createFleet",
        Dict{String,Any}("FleetName" => FleetName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_fleet(
    FleetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return worklink(
        "POST",
        "/createFleet",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("FleetName" => FleetName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_fleet(fleet_arn)
    delete_fleet(fleet_arn, params::Dict{String,<:Any})

Deletes a fleet. Prevents users from accessing previously associated websites.

# Arguments
- `fleet_arn`: The ARN of the fleet.

"""
function delete_fleet(FleetArn; aws_config::AbstractAWSConfig=current_aws_config())
    return worklink(
        "POST",
        "/deleteFleet",
        Dict{String,Any}("FleetArn" => FleetArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_fleet(
    FleetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return worklink(
        "POST",
        "/deleteFleet",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("FleetArn" => FleetArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_audit_stream_configuration(fleet_arn)
    describe_audit_stream_configuration(fleet_arn, params::Dict{String,<:Any})

Describes the configuration for delivering audit streams to the customer account.

# Arguments
- `fleet_arn`: The ARN of the fleet.

"""
function describe_audit_stream_configuration(
    FleetArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return worklink(
        "POST",
        "/describeAuditStreamConfiguration",
        Dict{String,Any}("FleetArn" => FleetArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_audit_stream_configuration(
    FleetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return worklink(
        "POST",
        "/describeAuditStreamConfiguration",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("FleetArn" => FleetArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_company_network_configuration(fleet_arn)
    describe_company_network_configuration(fleet_arn, params::Dict{String,<:Any})

Describes the networking configuration to access the internal websites associated with the
specified fleet.

# Arguments
- `fleet_arn`: The ARN of the fleet.

"""
function describe_company_network_configuration(
    FleetArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return worklink(
        "POST",
        "/describeCompanyNetworkConfiguration",
        Dict{String,Any}("FleetArn" => FleetArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_company_network_configuration(
    FleetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return worklink(
        "POST",
        "/describeCompanyNetworkConfiguration",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("FleetArn" => FleetArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_device(device_id, fleet_arn)
    describe_device(device_id, fleet_arn, params::Dict{String,<:Any})

Provides information about a user's device.

# Arguments
- `device_id`: A unique identifier for a registered user's device.
- `fleet_arn`: The ARN of the fleet.

"""
function describe_device(
    DeviceId, FleetArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return worklink(
        "POST",
        "/describeDevice",
        Dict{String,Any}("DeviceId" => DeviceId, "FleetArn" => FleetArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_device(
    DeviceId,
    FleetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return worklink(
        "POST",
        "/describeDevice",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DeviceId" => DeviceId, "FleetArn" => FleetArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_device_policy_configuration(fleet_arn)
    describe_device_policy_configuration(fleet_arn, params::Dict{String,<:Any})

Describes the device policy configuration for the specified fleet.

# Arguments
- `fleet_arn`: The ARN of the fleet.

"""
function describe_device_policy_configuration(
    FleetArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return worklink(
        "POST",
        "/describeDevicePolicyConfiguration",
        Dict{String,Any}("FleetArn" => FleetArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_device_policy_configuration(
    FleetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return worklink(
        "POST",
        "/describeDevicePolicyConfiguration",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("FleetArn" => FleetArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_domain(domain_name, fleet_arn)
    describe_domain(domain_name, fleet_arn, params::Dict{String,<:Any})

Provides information about the domain.

# Arguments
- `domain_name`: The name of the domain.
- `fleet_arn`: The ARN of the fleet.

"""
function describe_domain(
    DomainName, FleetArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return worklink(
        "POST",
        "/describeDomain",
        Dict{String,Any}("DomainName" => DomainName, "FleetArn" => FleetArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_domain(
    DomainName,
    FleetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return worklink(
        "POST",
        "/describeDomain",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DomainName" => DomainName, "FleetArn" => FleetArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_fleet_metadata(fleet_arn)
    describe_fleet_metadata(fleet_arn, params::Dict{String,<:Any})

Provides basic information for the specified fleet, excluding identity provider,
networking, and device configuration details.

# Arguments
- `fleet_arn`: The Amazon Resource Name (ARN) of the fleet.

"""
function describe_fleet_metadata(
    FleetArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return worklink(
        "POST",
        "/describeFleetMetadata",
        Dict{String,Any}("FleetArn" => FleetArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_fleet_metadata(
    FleetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return worklink(
        "POST",
        "/describeFleetMetadata",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("FleetArn" => FleetArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_identity_provider_configuration(fleet_arn)
    describe_identity_provider_configuration(fleet_arn, params::Dict{String,<:Any})

Describes the identity provider configuration of the specified fleet.

# Arguments
- `fleet_arn`: The ARN of the fleet.

"""
function describe_identity_provider_configuration(
    FleetArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return worklink(
        "POST",
        "/describeIdentityProviderConfiguration",
        Dict{String,Any}("FleetArn" => FleetArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_identity_provider_configuration(
    FleetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return worklink(
        "POST",
        "/describeIdentityProviderConfiguration",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("FleetArn" => FleetArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_website_certificate_authority(fleet_arn, website_ca_id)
    describe_website_certificate_authority(fleet_arn, website_ca_id, params::Dict{String,<:Any})

Provides information about the certificate authority.

# Arguments
- `fleet_arn`: The ARN of the fleet.
- `website_ca_id`: A unique identifier for the certificate authority.

"""
function describe_website_certificate_authority(
    FleetArn, WebsiteCaId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return worklink(
        "POST",
        "/describeWebsiteCertificateAuthority",
        Dict{String,Any}("FleetArn" => FleetArn, "WebsiteCaId" => WebsiteCaId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_website_certificate_authority(
    FleetArn,
    WebsiteCaId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return worklink(
        "POST",
        "/describeWebsiteCertificateAuthority",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("FleetArn" => FleetArn, "WebsiteCaId" => WebsiteCaId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_domain(domain_name, fleet_arn)
    disassociate_domain(domain_name, fleet_arn, params::Dict{String,<:Any})

Disassociates a domain from Amazon WorkLink. End users lose the ability to access the
domain with Amazon WorkLink.

# Arguments
- `domain_name`: The name of the domain.
- `fleet_arn`: The ARN of the fleet.

"""
function disassociate_domain(
    DomainName, FleetArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return worklink(
        "POST",
        "/disassociateDomain",
        Dict{String,Any}("DomainName" => DomainName, "FleetArn" => FleetArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_domain(
    DomainName,
    FleetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return worklink(
        "POST",
        "/disassociateDomain",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DomainName" => DomainName, "FleetArn" => FleetArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_website_authorization_provider(authorization_provider_id, fleet_arn)
    disassociate_website_authorization_provider(authorization_provider_id, fleet_arn, params::Dict{String,<:Any})

Disassociates a website authorization provider from a specified fleet. After the
disassociation, users can't load any associated websites that require this authorization
provider.

# Arguments
- `authorization_provider_id`: A unique identifier for the authorization provider.
- `fleet_arn`: The ARN of the fleet.

"""
function disassociate_website_authorization_provider(
    AuthorizationProviderId, FleetArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return worklink(
        "POST",
        "/disassociateWebsiteAuthorizationProvider",
        Dict{String,Any}(
            "AuthorizationProviderId" => AuthorizationProviderId, "FleetArn" => FleetArn
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_website_authorization_provider(
    AuthorizationProviderId,
    FleetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return worklink(
        "POST",
        "/disassociateWebsiteAuthorizationProvider",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AuthorizationProviderId" => AuthorizationProviderId,
                    "FleetArn" => FleetArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_website_certificate_authority(fleet_arn, website_ca_id)
    disassociate_website_certificate_authority(fleet_arn, website_ca_id, params::Dict{String,<:Any})

Removes a certificate authority (CA).

# Arguments
- `fleet_arn`: The ARN of the fleet.
- `website_ca_id`: A unique identifier for the CA.

"""
function disassociate_website_certificate_authority(
    FleetArn, WebsiteCaId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return worklink(
        "POST",
        "/disassociateWebsiteCertificateAuthority",
        Dict{String,Any}("FleetArn" => FleetArn, "WebsiteCaId" => WebsiteCaId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_website_certificate_authority(
    FleetArn,
    WebsiteCaId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return worklink(
        "POST",
        "/disassociateWebsiteCertificateAuthority",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("FleetArn" => FleetArn, "WebsiteCaId" => WebsiteCaId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_devices(fleet_arn)
    list_devices(fleet_arn, params::Dict{String,<:Any})

Retrieves a list of devices registered with the specified fleet.

# Arguments
- `fleet_arn`: The ARN of the fleet.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to be included in the next page.
- `"NextToken"`: The pagination token used to retrieve the next page of results for this
  operation. If this value is null, it retrieves the first page.
"""
function list_devices(FleetArn; aws_config::AbstractAWSConfig=current_aws_config())
    return worklink(
        "POST",
        "/listDevices",
        Dict{String,Any}("FleetArn" => FleetArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_devices(
    FleetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return worklink(
        "POST",
        "/listDevices",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("FleetArn" => FleetArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_domains(fleet_arn)
    list_domains(fleet_arn, params::Dict{String,<:Any})

Retrieves a list of domains associated to a specified fleet.

# Arguments
- `fleet_arn`: The ARN of the fleet.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to be included in the next page.
- `"NextToken"`: The pagination token used to retrieve the next page of results for this
  operation. If this value is null, it retrieves the first page.
"""
function list_domains(FleetArn; aws_config::AbstractAWSConfig=current_aws_config())
    return worklink(
        "POST",
        "/listDomains",
        Dict{String,Any}("FleetArn" => FleetArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_domains(
    FleetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return worklink(
        "POST",
        "/listDomains",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("FleetArn" => FleetArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_fleets()
    list_fleets(params::Dict{String,<:Any})

Retrieves a list of fleets for the current account and Region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to be included in the next page.
- `"NextToken"`: The pagination token used to retrieve the next page of results for this
  operation. If this value is null, it retrieves the first page.
"""
function list_fleets(; aws_config::AbstractAWSConfig=current_aws_config())
    return worklink(
        "POST", "/listFleets"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_fleets(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return worklink(
        "POST",
        "/listFleets",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Retrieves a list of tags for the specified resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the fleet.

"""
function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return worklink(
        "GET",
        "/tags/$(ResourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return worklink(
        "GET",
        "/tags/$(ResourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_website_authorization_providers(fleet_arn)
    list_website_authorization_providers(fleet_arn, params::Dict{String,<:Any})

Retrieves a list of website authorization providers associated with a specified fleet.

# Arguments
- `fleet_arn`: The ARN of the fleet.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to be included in the next page.
- `"NextToken"`: The pagination token to use to retrieve the next page of results for this
  operation. If this value is null, it retrieves the first page.
"""
function list_website_authorization_providers(
    FleetArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return worklink(
        "POST",
        "/listWebsiteAuthorizationProviders",
        Dict{String,Any}("FleetArn" => FleetArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_website_authorization_providers(
    FleetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return worklink(
        "POST",
        "/listWebsiteAuthorizationProviders",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("FleetArn" => FleetArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_website_certificate_authorities(fleet_arn)
    list_website_certificate_authorities(fleet_arn, params::Dict{String,<:Any})

Retrieves a list of certificate authorities added for the current account and Region.

# Arguments
- `fleet_arn`: The ARN of the fleet.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to be included in the next page.
- `"NextToken"`: The pagination token used to retrieve the next page of results for this
  operation. If this value is null, it retrieves the first page.
"""
function list_website_certificate_authorities(
    FleetArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return worklink(
        "POST",
        "/listWebsiteCertificateAuthorities",
        Dict{String,Any}("FleetArn" => FleetArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_website_certificate_authorities(
    FleetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return worklink(
        "POST",
        "/listWebsiteCertificateAuthorities",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("FleetArn" => FleetArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    restore_domain_access(domain_name, fleet_arn)
    restore_domain_access(domain_name, fleet_arn, params::Dict{String,<:Any})

Moves a domain to ACTIVE status if it was in the INACTIVE status.

# Arguments
- `domain_name`: The name of the domain.
- `fleet_arn`: The ARN of the fleet.

"""
function restore_domain_access(
    DomainName, FleetArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return worklink(
        "POST",
        "/restoreDomainAccess",
        Dict{String,Any}("DomainName" => DomainName, "FleetArn" => FleetArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function restore_domain_access(
    DomainName,
    FleetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return worklink(
        "POST",
        "/restoreDomainAccess",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DomainName" => DomainName, "FleetArn" => FleetArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    revoke_domain_access(domain_name, fleet_arn)
    revoke_domain_access(domain_name, fleet_arn, params::Dict{String,<:Any})

Moves a domain to INACTIVE status if it was in the ACTIVE status.

# Arguments
- `domain_name`: The name of the domain.
- `fleet_arn`: The ARN of the fleet.

"""
function revoke_domain_access(
    DomainName, FleetArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return worklink(
        "POST",
        "/revokeDomainAccess",
        Dict{String,Any}("DomainName" => DomainName, "FleetArn" => FleetArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function revoke_domain_access(
    DomainName,
    FleetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return worklink(
        "POST",
        "/revokeDomainAccess",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DomainName" => DomainName, "FleetArn" => FleetArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    sign_out_user(fleet_arn, username)
    sign_out_user(fleet_arn, username, params::Dict{String,<:Any})

Signs the user out from all of their devices. The user can sign in again if they have valid
credentials.

# Arguments
- `fleet_arn`: The ARN of the fleet.
- `username`: The name of the user.

"""
function sign_out_user(
    FleetArn, Username; aws_config::AbstractAWSConfig=current_aws_config()
)
    return worklink(
        "POST",
        "/signOutUser",
        Dict{String,Any}("FleetArn" => FleetArn, "Username" => Username);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function sign_out_user(
    FleetArn,
    Username,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return worklink(
        "POST",
        "/signOutUser",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("FleetArn" => FleetArn, "Username" => Username),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds or overwrites one or more tags for the specified resource, such as a fleet. Each tag
consists of a key and an optional value. If a resource already has a tag with the same key,
this operation updates its value.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the fleet.
- `tags`: The tags to add to the resource. A tag is a key-value pair.

"""
function tag_resource(ResourceArn, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return worklink(
        "POST",
        "/tags/$(ResourceArn)",
        Dict{String,Any}("Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceArn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return worklink(
        "POST",
        "/tags/$(ResourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Tags" => Tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes one or more tags from the specified resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the fleet.
- `tag_keys`: The list of tag keys to remove from the resource.

"""
function untag_resource(
    ResourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return worklink(
        "DELETE",
        "/tags/$(ResourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return worklink(
        "DELETE",
        "/tags/$(ResourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_audit_stream_configuration(fleet_arn)
    update_audit_stream_configuration(fleet_arn, params::Dict{String,<:Any})

Updates the audit stream configuration for the fleet.

# Arguments
- `fleet_arn`: The ARN of the fleet.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AuditStreamArn"`: The ARN of the Amazon Kinesis data stream that receives the audit
  events.
"""
function update_audit_stream_configuration(
    FleetArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return worklink(
        "POST",
        "/updateAuditStreamConfiguration",
        Dict{String,Any}("FleetArn" => FleetArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_audit_stream_configuration(
    FleetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return worklink(
        "POST",
        "/updateAuditStreamConfiguration",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("FleetArn" => FleetArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_company_network_configuration(fleet_arn, security_group_ids, subnet_ids, vpc_id)
    update_company_network_configuration(fleet_arn, security_group_ids, subnet_ids, vpc_id, params::Dict{String,<:Any})

Updates the company network configuration for the fleet.

# Arguments
- `fleet_arn`: The ARN of the fleet.
- `security_group_ids`: The security groups associated with access to the provided subnets.
- `subnet_ids`: The subnets used for X-ENI connections from Amazon WorkLink rendering
  containers.
- `vpc_id`: The VPC with connectivity to associated websites.

"""
function update_company_network_configuration(
    FleetArn,
    SecurityGroupIds,
    SubnetIds,
    VpcId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return worklink(
        "POST",
        "/updateCompanyNetworkConfiguration",
        Dict{String,Any}(
            "FleetArn" => FleetArn,
            "SecurityGroupIds" => SecurityGroupIds,
            "SubnetIds" => SubnetIds,
            "VpcId" => VpcId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_company_network_configuration(
    FleetArn,
    SecurityGroupIds,
    SubnetIds,
    VpcId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return worklink(
        "POST",
        "/updateCompanyNetworkConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "FleetArn" => FleetArn,
                    "SecurityGroupIds" => SecurityGroupIds,
                    "SubnetIds" => SubnetIds,
                    "VpcId" => VpcId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_device_policy_configuration(fleet_arn)
    update_device_policy_configuration(fleet_arn, params::Dict{String,<:Any})

Updates the device policy configuration for the fleet.

# Arguments
- `fleet_arn`: The ARN of the fleet.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DeviceCaCertificate"`: The certificate chain, including intermediate certificates and
  the root certificate authority certificate used to issue device certificates.
"""
function update_device_policy_configuration(
    FleetArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return worklink(
        "POST",
        "/updateDevicePolicyConfiguration",
        Dict{String,Any}("FleetArn" => FleetArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_device_policy_configuration(
    FleetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return worklink(
        "POST",
        "/updateDevicePolicyConfiguration",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("FleetArn" => FleetArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_domain_metadata(domain_name, fleet_arn)
    update_domain_metadata(domain_name, fleet_arn, params::Dict{String,<:Any})

Updates domain metadata, such as DisplayName.

# Arguments
- `domain_name`: The name of the domain.
- `fleet_arn`: The ARN of the fleet.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DisplayName"`: The name to display.
"""
function update_domain_metadata(
    DomainName, FleetArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return worklink(
        "POST",
        "/updateDomainMetadata",
        Dict{String,Any}("DomainName" => DomainName, "FleetArn" => FleetArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_domain_metadata(
    DomainName,
    FleetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return worklink(
        "POST",
        "/updateDomainMetadata",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DomainName" => DomainName, "FleetArn" => FleetArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_fleet_metadata(fleet_arn)
    update_fleet_metadata(fleet_arn, params::Dict{String,<:Any})

Updates fleet metadata, such as DisplayName.

# Arguments
- `fleet_arn`: The ARN of the fleet.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DisplayName"`: The fleet name to display. The existing DisplayName is unset if null is
  passed.
- `"OptimizeForEndUserLocation"`: The option to optimize for better performance by routing
  traffic through the closest AWS Region to users, which may be outside of your home Region.
"""
function update_fleet_metadata(FleetArn; aws_config::AbstractAWSConfig=current_aws_config())
    return worklink(
        "POST",
        "/UpdateFleetMetadata",
        Dict{String,Any}("FleetArn" => FleetArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_fleet_metadata(
    FleetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return worklink(
        "POST",
        "/UpdateFleetMetadata",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("FleetArn" => FleetArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_identity_provider_configuration(fleet_arn, identity_provider_type)
    update_identity_provider_configuration(fleet_arn, identity_provider_type, params::Dict{String,<:Any})

Updates the identity provider configuration for the fleet.

# Arguments
- `fleet_arn`: The ARN of the fleet.
- `identity_provider_type`: The type of identity provider.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"IdentityProviderSamlMetadata"`: The SAML metadata document provided by the customer’s
  identity provider. The existing IdentityProviderSamlMetadata is unset if null is passed.
"""
function update_identity_provider_configuration(
    FleetArn, IdentityProviderType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return worklink(
        "POST",
        "/updateIdentityProviderConfiguration",
        Dict{String,Any}(
            "FleetArn" => FleetArn, "IdentityProviderType" => IdentityProviderType
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_identity_provider_configuration(
    FleetArn,
    IdentityProviderType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return worklink(
        "POST",
        "/updateIdentityProviderConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "FleetArn" => FleetArn, "IdentityProviderType" => IdentityProviderType
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: iot_events_data
using AWS.Compat
using AWS.UUIDs

"""
    batch_acknowledge_alarm(acknowledge_action_requests)
    batch_acknowledge_alarm(acknowledge_action_requests, params::Dict{String,<:Any})

Acknowledges one or more alarms. The alarms change to the ACKNOWLEDGED state after you
acknowledge them.

# Arguments
- `acknowledge_action_requests`: The list of acknowledge action requests. You can specify
  up to 10 requests per operation.

"""
function batch_acknowledge_alarm(
    acknowledgeActionRequests; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_events_data(
        "POST",
        "/alarms/acknowledge",
        Dict{String,Any}("acknowledgeActionRequests" => acknowledgeActionRequests);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_acknowledge_alarm(
    acknowledgeActionRequests,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_events_data(
        "POST",
        "/alarms/acknowledge",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("acknowledgeActionRequests" => acknowledgeActionRequests),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_delete_detector(detectors)
    batch_delete_detector(detectors, params::Dict{String,<:Any})

Deletes one or more detectors that were created. When a detector is deleted, its state will
be cleared and the detector will be removed from the list of detectors. The deleted
detector will no longer appear if referenced in the ListDetectors API call.

# Arguments
- `detectors`: The list of one or more detectors to be deleted.

"""
function batch_delete_detector(
    detectors; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_events_data(
        "POST",
        "/detectors/delete",
        Dict{String,Any}("detectors" => detectors);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_delete_detector(
    detectors,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_events_data(
        "POST",
        "/detectors/delete",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("detectors" => detectors), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_disable_alarm(disable_action_requests)
    batch_disable_alarm(disable_action_requests, params::Dict{String,<:Any})

Disables one or more alarms. The alarms change to the DISABLED state after you disable them.

# Arguments
- `disable_action_requests`: The list of disable action requests. You can specify up to 10
  requests per operation.

"""
function batch_disable_alarm(
    disableActionRequests; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_events_data(
        "POST",
        "/alarms/disable",
        Dict{String,Any}("disableActionRequests" => disableActionRequests);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_disable_alarm(
    disableActionRequests,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_events_data(
        "POST",
        "/alarms/disable",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("disableActionRequests" => disableActionRequests),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_enable_alarm(enable_action_requests)
    batch_enable_alarm(enable_action_requests, params::Dict{String,<:Any})

Enables one or more alarms. The alarms change to the NORMAL state after you enable them.

# Arguments
- `enable_action_requests`: The list of enable action requests. You can specify up to 10
  requests per operation.

"""
function batch_enable_alarm(
    enableActionRequests; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_events_data(
        "POST",
        "/alarms/enable",
        Dict{String,Any}("enableActionRequests" => enableActionRequests);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_enable_alarm(
    enableActionRequests,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_events_data(
        "POST",
        "/alarms/enable",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("enableActionRequests" => enableActionRequests),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_put_message(messages)
    batch_put_message(messages, params::Dict{String,<:Any})

Sends a set of messages to the IoT Events system. Each message payload is transformed into
the input you specify (\"inputName\") and ingested into any detectors that monitor that
input. If multiple messages are sent, the order in which the messages are processed isn't
guaranteed. To guarantee ordering, you must send messages one at a time and wait for a
successful response.

# Arguments
- `messages`: The list of messages to send. Each message has the following format: '{
  \"messageId\": \"string\", \"inputName\": \"string\", \"payload\": \"string\"}'

"""
function batch_put_message(messages; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_events_data(
        "POST",
        "/inputs/messages",
        Dict{String,Any}("messages" => messages);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_put_message(
    messages,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_events_data(
        "POST",
        "/inputs/messages",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("messages" => messages), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_reset_alarm(reset_action_requests)
    batch_reset_alarm(reset_action_requests, params::Dict{String,<:Any})

Resets one or more alarms. The alarms return to the NORMAL state after you reset them.

# Arguments
- `reset_action_requests`: The list of reset action requests. You can specify up to 10
  requests per operation.

"""
function batch_reset_alarm(
    resetActionRequests; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_events_data(
        "POST",
        "/alarms/reset",
        Dict{String,Any}("resetActionRequests" => resetActionRequests);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_reset_alarm(
    resetActionRequests,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_events_data(
        "POST",
        "/alarms/reset",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resetActionRequests" => resetActionRequests),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_snooze_alarm(snooze_action_requests)
    batch_snooze_alarm(snooze_action_requests, params::Dict{String,<:Any})

Changes one or more alarms to the snooze mode. The alarms change to the SNOOZE_DISABLED
state after you set them to the snooze mode.

# Arguments
- `snooze_action_requests`: The list of snooze action requests. You can specify up to 10
  requests per operation.

"""
function batch_snooze_alarm(
    snoozeActionRequests; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_events_data(
        "POST",
        "/alarms/snooze",
        Dict{String,Any}("snoozeActionRequests" => snoozeActionRequests);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_snooze_alarm(
    snoozeActionRequests,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_events_data(
        "POST",
        "/alarms/snooze",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("snoozeActionRequests" => snoozeActionRequests),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_update_detector(detectors)
    batch_update_detector(detectors, params::Dict{String,<:Any})

Updates the state, variable values, and timer settings of one or more detectors (instances)
of a specified detector model.

# Arguments
- `detectors`: The list of detectors (instances) to update, along with the values to update.

"""
function batch_update_detector(
    detectors; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_events_data(
        "POST",
        "/detectors",
        Dict{String,Any}("detectors" => detectors);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_update_detector(
    detectors,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_events_data(
        "POST",
        "/detectors",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("detectors" => detectors), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_alarm(alarm_model_name)
    describe_alarm(alarm_model_name, params::Dict{String,<:Any})

Retrieves information about an alarm.

# Arguments
- `alarm_model_name`: The name of the alarm model.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"keyValue"`: The value of the key used as a filter to select only the alarms associated
  with the key.
"""
function describe_alarm(alarmModelName; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_events_data(
        "GET",
        "/alarms/$(alarmModelName)/keyValues/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_alarm(
    alarmModelName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_events_data(
        "GET",
        "/alarms/$(alarmModelName)/keyValues/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_detector(detector_model_name)
    describe_detector(detector_model_name, params::Dict{String,<:Any})

Returns information about the specified detector (instance).

# Arguments
- `detector_model_name`: The name of the detector model whose detectors (instances) you
  want information about.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"keyValue"`: A filter used to limit results to detectors (instances) created because of
  the given key ID.
"""
function describe_detector(
    detectorModelName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_events_data(
        "GET",
        "/detectors/$(detectorModelName)/keyValues/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_detector(
    detectorModelName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_events_data(
        "GET",
        "/detectors/$(detectorModelName)/keyValues/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_alarms(alarm_model_name)
    list_alarms(alarm_model_name, params::Dict{String,<:Any})

Lists one or more alarms. The operation returns only the metadata associated with each
alarm.

# Arguments
- `alarm_model_name`: The name of the alarm model.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to be returned per request.
- `"nextToken"`: The token that you can use to return the next set of results.
"""
function list_alarms(alarmModelName; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_events_data(
        "GET",
        "/alarms/$(alarmModelName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_alarms(
    alarmModelName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_events_data(
        "GET",
        "/alarms/$(alarmModelName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_detectors(detector_model_name)
    list_detectors(detector_model_name, params::Dict{String,<:Any})

Lists detectors (the instances of a detector model).

# Arguments
- `detector_model_name`: The name of the detector model whose detectors (instances) are
  listed.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to be returned per request.
- `"nextToken"`: The token that you can use to return the next set of results.
- `"stateName"`: A filter that limits results to those detectors (instances) in the given
  state.
"""
function list_detectors(
    detectorModelName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_events_data(
        "GET",
        "/detectors/$(detectorModelName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_detectors(
    detectorModelName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_events_data(
        "GET",
        "/detectors/$(detectorModelName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: bedrock_runtime
using AWS.Compat
using AWS.UUIDs

"""
    converse(messages, model_id)
    converse(messages, model_id, params::Dict{String,<:Any})

Sends messages to the specified Amazon Bedrock model. Converse provides a consistent
interface that works with all models that support messages. This allows you to write code
once and use it with different models. Should a model have unique inference parameters, you
can also pass those unique parameters to the model. For information about the Converse API,
see Use the Converse API in the Amazon Bedrock User Guide. To use a guardrail, see Use a
guardrail with the Converse API in the Amazon Bedrock User Guide. To use a tool with a
model, see Tool use (Function calling) in the Amazon Bedrock User Guide  For example code,
see Converse API examples in the Amazon Bedrock User Guide.  This operation requires
permission for the bedrock:InvokeModel action.

# Arguments
- `messages`: The messages that you want to send to the model.
- `model_id`: The identifier for the model that you want to call. The modelId to provide
  depends on the type of model that you use:   If you use a base model, specify the model ID
  or its ARN. For a list of model IDs for base models, see Amazon Bedrock base model IDs
  (on-demand throughput) in the Amazon Bedrock User Guide.   If you use a provisioned model,
  specify the ARN of the Provisioned Throughput. For more information, see Run inference
  using a Provisioned Throughput in the Amazon Bedrock User Guide.   If you use a custom
  model, first purchase Provisioned Throughput for it. Then specify the ARN of the resulting
  provisioned model. For more information, see Use a custom model in Amazon Bedrock in the
  Amazon Bedrock User Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"additionalModelRequestFields"`: Additional inference parameters that the model
  supports, beyond the base set of inference parameters that Converse supports in the
  inferenceConfig field. For more information, see Model parameters.
- `"additionalModelResponseFieldPaths"`: Additional model parameters field paths to return
  in the response. Converse returns the requested fields as a JSON Pointer object in the
  additionalModelResponseFields field. The following is example JSON for
  additionalModelResponseFieldPaths.  [ \"/stop_sequence\" ]  For information about the JSON
  Pointer syntax, see the Internet Engineering Task Force (IETF) documentation.  Converse
  rejects an empty JSON Pointer or incorrectly structured JSON Pointer with a 400 error code.
  if the JSON Pointer is valid, but the requested field is not in the model response, it is
  ignored by Converse.
- `"guardrailConfig"`: Configuration information for a guardrail that you want to use in
  the request.
- `"inferenceConfig"`: Inference parameters to pass to the model. Converse supports a base
  set of inference parameters. If you need to pass additional parameters that the model
  supports, use the additionalModelRequestFields request field.
- `"system"`: A system prompt to pass to the model.
- `"toolConfig"`: Configuration information for the tools that the model can use when
  generating a response.   This field is only supported by Anthropic Claude 3, Cohere Command
  R, Cohere Command R+, and Mistral Large models.
"""
function converse(messages, modelId; aws_config::AbstractAWSConfig=current_aws_config())
    return bedrock_runtime(
        "POST",
        "/model/$(modelId)/converse",
        Dict{String,Any}("messages" => messages);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function converse(
    messages,
    modelId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_runtime(
        "POST",
        "/model/$(modelId)/converse",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("messages" => messages), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    converse_stream(messages, model_id)
    converse_stream(messages, model_id, params::Dict{String,<:Any})

Sends messages to the specified Amazon Bedrock model and returns the response in a stream.
ConverseStream provides a consistent API that works with all Amazon Bedrock models that
support messages. This allows you to write code once and use it with different models.
Should a model have unique inference parameters, you can also pass those unique parameters
to the model.  To find out if a model supports streaming, call GetFoundationModel and check
the responseStreamingSupported field in the response. For information about the Converse
API, see Use the Converse API in the Amazon Bedrock User Guide. To use a guardrail, see Use
a guardrail with the Converse API in the Amazon Bedrock User Guide. To use a tool with a
model, see Tool use (Function calling) in the Amazon Bedrock User Guide  For example code,
see Conversation streaming example in the Amazon Bedrock User Guide.  This operation
requires permission for the bedrock:InvokeModelWithResponseStream action.

# Arguments
- `messages`: The messages that you want to send to the model.
- `model_id`: The ID for the model. The modelId to provide depends on the type of model
  that you use:   If you use a base model, specify the model ID or its ARN. For a list of
  model IDs for base models, see Amazon Bedrock base model IDs (on-demand throughput) in the
  Amazon Bedrock User Guide.   If you use a provisioned model, specify the ARN of the
  Provisioned Throughput. For more information, see Run inference using a Provisioned
  Throughput in the Amazon Bedrock User Guide.   If you use a custom model, first purchase
  Provisioned Throughput for it. Then specify the ARN of the resulting provisioned model. For
  more information, see Use a custom model in Amazon Bedrock in the Amazon Bedrock User
  Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"additionalModelRequestFields"`: Additional inference parameters that the model
  supports, beyond the base set of inference parameters that ConverseStream supports in the
  inferenceConfig field.
- `"additionalModelResponseFieldPaths"`: Additional model parameters field paths to return
  in the response. ConverseStream returns the requested fields as a JSON Pointer object in
  the additionalModelResponseFields field. The following is example JSON for
  additionalModelResponseFieldPaths.  [ \"/stop_sequence\" ]  For information about the JSON
  Pointer syntax, see the Internet Engineering Task Force (IETF) documentation.
  ConverseStream rejects an empty JSON Pointer or incorrectly structured JSON Pointer with a
  400 error code. if the JSON Pointer is valid, but the requested field is not in the model
  response, it is ignored by ConverseStream.
- `"guardrailConfig"`: Configuration information for a guardrail that you want to use in
  the request.
- `"inferenceConfig"`: Inference parameters to pass to the model. ConverseStream supports a
  base set of inference parameters. If you need to pass additional parameters that the model
  supports, use the additionalModelRequestFields request field.
- `"system"`: A system prompt to send to the model.
- `"toolConfig"`: Configuration information for the tools that the model can use when
  generating a response.  This field is only supported by Anthropic Claude 3 models.
"""
function converse_stream(
    messages, modelId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock_runtime(
        "POST",
        "/model/$(modelId)/converse-stream",
        Dict{String,Any}("messages" => messages);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function converse_stream(
    messages,
    modelId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_runtime(
        "POST",
        "/model/$(modelId)/converse-stream",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("messages" => messages), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    invoke_model(body, model_id)
    invoke_model(body, model_id, params::Dict{String,<:Any})

Invokes the specified Amazon Bedrock model to run inference using the prompt and inference
parameters provided in the request body. You use model inference to generate text, images,
and embeddings. For example code, see Invoke model code examples in the Amazon Bedrock User
Guide.  This operation requires permission for the bedrock:InvokeModel action.

# Arguments
- `body`: The prompt and inference parameters in the format specified in the contentType in
  the header. You must provide the body in JSON format. To see the format and content of the
  request and response bodies for different models, refer to Inference parameters. For more
  information, see Run inference in the Bedrock User Guide.
- `model_id`: The unique identifier of the model to invoke to run inference. The modelId to
  provide depends on the type of model that you use:   If you use a base model, specify the
  model ID or its ARN. For a list of model IDs for base models, see Amazon Bedrock base model
  IDs (on-demand throughput) in the Amazon Bedrock User Guide.   If you use a provisioned
  model, specify the ARN of the Provisioned Throughput. For more information, see Run
  inference using a Provisioned Throughput in the Amazon Bedrock User Guide.   If you use a
  custom model, first purchase Provisioned Throughput for it. Then specify the ARN of the
  resulting provisioned model. For more information, see Use a custom model in Amazon Bedrock
  in the Amazon Bedrock User Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Accept"`: The desired MIME type of the inference body in the response. The default
  value is application/json.
- `"Content-Type"`: The MIME type of the input data in the request. You must specify
  application/json.
- `"X-Amzn-Bedrock-GuardrailIdentifier"`: The unique identifier of the guardrail that you
  want to use. If you don't provide a value, no guardrail is applied to the invocation. An
  error will be thrown in the following situations.   You don't provide a guardrail
  identifier but you specify the amazon-bedrock-guardrailConfig field in the request body.
  You enable the guardrail but the contentType isn't application/json.   You provide a
  guardrail identifier, but guardrailVersion isn't specified.
- `"X-Amzn-Bedrock-GuardrailVersion"`: The version number for the guardrail. The value can
  also be DRAFT.
- `"X-Amzn-Bedrock-Trace"`: Specifies whether to enable or disable the Bedrock trace. If
  enabled, you can see the full Bedrock trace.
"""
function invoke_model(body, modelId; aws_config::AbstractAWSConfig=current_aws_config())
    return bedrock_runtime(
        "POST",
        "/model/$(modelId)/invoke",
        Dict{String,Any}("body" => body);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function invoke_model(
    body,
    modelId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_runtime(
        "POST",
        "/model/$(modelId)/invoke",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("body" => body), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    invoke_model_with_response_stream(body, model_id)
    invoke_model_with_response_stream(body, model_id, params::Dict{String,<:Any})

Invoke the specified Amazon Bedrock model to run inference using the prompt and inference
parameters provided in the request body. The response is returned in a stream. To see if a
model supports streaming, call GetFoundationModel and check the responseStreamingSupported
field in the response.  The CLI doesn't support InvokeModelWithResponseStream.  For example
code, see Invoke model with streaming code example in the Amazon Bedrock User Guide.  This
operation requires permissions to perform the bedrock:InvokeModelWithResponseStream action.

# Arguments
- `body`: The prompt and inference parameters in the format specified in the contentType in
  the header. You must provide the body in JSON format. To see the format and content of the
  request and response bodies for different models, refer to Inference parameters. For more
  information, see Run inference in the Bedrock User Guide.
- `model_id`: The unique identifier of the model to invoke to run inference. The modelId to
  provide depends on the type of model that you use:   If you use a base model, specify the
  model ID or its ARN. For a list of model IDs for base models, see Amazon Bedrock base model
  IDs (on-demand throughput) in the Amazon Bedrock User Guide.   If you use a provisioned
  model, specify the ARN of the Provisioned Throughput. For more information, see Run
  inference using a Provisioned Throughput in the Amazon Bedrock User Guide.   If you use a
  custom model, first purchase Provisioned Throughput for it. Then specify the ARN of the
  resulting provisioned model. For more information, see Use a custom model in Amazon Bedrock
  in the Amazon Bedrock User Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Content-Type"`: The MIME type of the input data in the request. You must specify
  application/json.
- `"X-Amzn-Bedrock-Accept"`: The desired MIME type of the inference body in the response.
  The default value is application/json.
- `"X-Amzn-Bedrock-GuardrailIdentifier"`: The unique identifier of the guardrail that you
  want to use. If you don't provide a value, no guardrail is applied to the invocation. An
  error is thrown in the following situations.   You don't provide a guardrail identifier but
  you specify the amazon-bedrock-guardrailConfig field in the request body.   You enable the
  guardrail but the contentType isn't application/json.   You provide a guardrail identifier,
  but guardrailVersion isn't specified.
- `"X-Amzn-Bedrock-GuardrailVersion"`: The version number for the guardrail. The value can
  also be DRAFT.
- `"X-Amzn-Bedrock-Trace"`: Specifies whether to enable or disable the Bedrock trace. If
  enabled, you can see the full Bedrock trace.
"""
function invoke_model_with_response_stream(
    body, modelId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock_runtime(
        "POST",
        "/model/$(modelId)/invoke-with-response-stream",
        Dict{String,Any}("body" => body);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function invoke_model_with_response_stream(
    body,
    modelId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_runtime(
        "POST",
        "/model/$(modelId)/invoke-with-response-stream",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("body" => body), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: workspaces_thin_client
using AWS.Compat
using AWS.UUIDs

"""
    create_environment(desktop_arn)
    create_environment(desktop_arn, params::Dict{String,<:Any})

Creates an environment for your thin client devices.

# Arguments
- `desktop_arn`: The Amazon Resource Name (ARN) of the desktop to stream from Amazon
  WorkSpaces, WorkSpaces Web, or AppStream 2.0.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Specifies a unique, case-sensitive identifier that you provide to ensure
  the idempotency of the request. This lets you safely retry the request without accidentally
  performing the same operation a second time. Passing the same value to a later call to an
  operation requires that you also pass the same value for all other parameters. We recommend
  that you use a UUID type of value. If you don't provide this value, then Amazon Web
  Services generates a random one for you. If you retry the operation with the same
  ClientToken, but with different parameters, the retry fails with an
  IdempotentParameterMismatch error.
- `"desiredSoftwareSetId"`: The ID of the software set to apply.
- `"desktopEndpoint"`: The URL for the identity provider login (only for environments that
  use AppStream 2.0).
- `"deviceCreationTags"`: A map of the key-value pairs of the tag or tags to assign to the
  newly created devices for this environment.
- `"kmsKeyArn"`: The Amazon Resource Name (ARN) of the Key Management Service key to use to
  encrypt the environment.
- `"maintenanceWindow"`: A specification for a time window to apply software updates.
- `"name"`: The name for the environment.
- `"softwareSetUpdateMode"`: An option to define which software updates to apply.
- `"softwareSetUpdateSchedule"`: An option to define if software updates should be applied
  within a maintenance window.
- `"tags"`: A map of the key-value pairs of the tag or tags to assign to the resource.
"""
function create_environment(desktopArn; aws_config::AbstractAWSConfig=current_aws_config())
    return workspaces_thin_client(
        "POST",
        "/environments",
        Dict{String,Any}("desktopArn" => desktopArn, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_environment(
    desktopArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces_thin_client(
        "POST",
        "/environments",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "desktopArn" => desktopArn, "clientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_device(id)
    delete_device(id, params::Dict{String,<:Any})

Deletes a thin client device.

# Arguments
- `id`: The ID of the device to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Specifies a unique, case-sensitive identifier that you provide to ensure
  the idempotency of the request. This lets you safely retry the request without accidentally
  performing the same operation a second time. Passing the same value to a later call to an
  operation requires that you also pass the same value for all other parameters. We recommend
  that you use a UUID type of value. If you don't provide this value, then Amazon Web
  Services generates a random one for you. If you retry the operation with the same
  ClientToken, but with different parameters, the retry fails with an
  IdempotentParameterMismatch error.
"""
function delete_device(id; aws_config::AbstractAWSConfig=current_aws_config())
    return workspaces_thin_client(
        "DELETE",
        "/devices/$(id)",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_device(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_thin_client(
        "DELETE",
        "/devices/$(id)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_environment(id)
    delete_environment(id, params::Dict{String,<:Any})

Deletes an environment.

# Arguments
- `id`: The ID of the environment to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Specifies a unique, case-sensitive identifier that you provide to ensure
  the idempotency of the request. This lets you safely retry the request without accidentally
  performing the same operation a second time. Passing the same value to a later call to an
  operation requires that you also pass the same value for all other parameters. We recommend
  that you use a UUID type of value. If you don't provide this value, then Amazon Web
  Services generates a random one for you. If you retry the operation with the same
  ClientToken, but with different parameters, the retry fails with an
  IdempotentParameterMismatch error.
"""
function delete_environment(id; aws_config::AbstractAWSConfig=current_aws_config())
    return workspaces_thin_client(
        "DELETE",
        "/environments/$(id)",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_environment(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_thin_client(
        "DELETE",
        "/environments/$(id)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    deregister_device(id)
    deregister_device(id, params::Dict{String,<:Any})

Deregisters a thin client device.

# Arguments
- `id`: The ID of the device to deregister.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Specifies a unique, case-sensitive identifier that you provide to ensure
  the idempotency of the request. This lets you safely retry the request without accidentally
  performing the same operation a second time. Passing the same value to a later call to an
  operation requires that you also pass the same value for all other parameters. We recommend
  that you use a UUID type of value. If you don't provide this value, then Amazon Web
  Services generates a random one for you. If you retry the operation with the same
  ClientToken, but with different parameters, the retry fails with an
  IdempotentParameterMismatch error.
- `"targetDeviceStatus"`: The desired new status for the device.
"""
function deregister_device(id; aws_config::AbstractAWSConfig=current_aws_config())
    return workspaces_thin_client(
        "POST",
        "/deregister-device/$(id)",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function deregister_device(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_thin_client(
        "POST",
        "/deregister-device/$(id)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_device(id)
    get_device(id, params::Dict{String,<:Any})

Returns information for a thin client device.

# Arguments
- `id`: The ID of the device for which to return information.

"""
function get_device(id; aws_config::AbstractAWSConfig=current_aws_config())
    return workspaces_thin_client(
        "GET", "/devices/$(id)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_device(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_thin_client(
        "GET",
        "/devices/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_environment(id)
    get_environment(id, params::Dict{String,<:Any})

Returns information for an environment.

# Arguments
- `id`: The ID of the environment for which to return information.

"""
function get_environment(id; aws_config::AbstractAWSConfig=current_aws_config())
    return workspaces_thin_client(
        "GET", "/environments/$(id)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_environment(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_thin_client(
        "GET",
        "/environments/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_software_set(id)
    get_software_set(id, params::Dict{String,<:Any})

Returns information for a software set.

# Arguments
- `id`: The ID of the software set for which to return information.

"""
function get_software_set(id; aws_config::AbstractAWSConfig=current_aws_config())
    return workspaces_thin_client(
        "GET", "/softwaresets/$(id)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_software_set(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_thin_client(
        "GET",
        "/softwaresets/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_devices()
    list_devices(params::Dict{String,<:Any})

Returns a list of thin client devices.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results that are returned per call. You can use
  nextToken to obtain further pages of results. This is only an upper limit. The actual
  number of results returned per call might be fewer than the specified maximum.
- `"nextToken"`: If nextToken is returned, there are more results available. The value of
  nextToken is a unique pagination token for each page. Make the call again using the
  returned token to retrieve the next page. Keep all other arguments unchanged. Each
  pagination token expires after 24 hours. Using an expired pagination token will return an
  HTTP 400 InvalidToken error.
"""
function list_devices(; aws_config::AbstractAWSConfig=current_aws_config())
    return workspaces_thin_client(
        "GET", "/devices"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_devices(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_thin_client(
        "GET", "/devices", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_environments()
    list_environments(params::Dict{String,<:Any})

Returns a list of environments.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results that are returned per call. You can use
  nextToken to obtain further pages of results. This is only an upper limit. The actual
  number of results returned per call might be fewer than the specified maximum.
- `"nextToken"`: If nextToken is returned, there are more results available. The value of
  nextToken is a unique pagination token for each page. Make the call again using the
  returned token to retrieve the next page. Keep all other arguments unchanged. Each
  pagination token expires after 24 hours. Using an expired pagination token will return an
  HTTP 400 InvalidToken error.
"""
function list_environments(; aws_config::AbstractAWSConfig=current_aws_config())
    return workspaces_thin_client(
        "GET", "/environments"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_environments(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_thin_client(
        "GET",
        "/environments",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_software_sets()
    list_software_sets(params::Dict{String,<:Any})

Returns a list of software sets.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results that are returned per call. You can use
  nextToken to obtain further pages of results. This is only an upper limit. The actual
  number of results returned per call might be fewer than the specified maximum.
- `"nextToken"`: If nextToken is returned, there are more results available. The value of
  nextToken is a unique pagination token for each page. Make the call again using the
  returned token to retrieve the next page. Keep all other arguments unchanged. Each
  pagination token expires after 24 hours. Using an expired pagination token will return an
  HTTP 400 InvalidToken error.
"""
function list_software_sets(; aws_config::AbstractAWSConfig=current_aws_config())
    return workspaces_thin_client(
        "GET", "/softwaresets"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_software_sets(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_thin_client(
        "GET",
        "/softwaresets",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Returns a list of tags for a resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource for which you want to
  retrieve tags.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_thin_client(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces_thin_client(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Assigns one or more tags (key-value pairs) to the specified resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource that you want to tag.
- `tags`: A map of the key-value pairs of the tag or tags to assign to the resource.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return workspaces_thin_client(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces_thin_client(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes a tag or tags from a resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource that you want to untag.
- `tag_keys`: The keys of the key-value pairs for the tag or tags you want to remove from
  the specified resource.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_thin_client(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces_thin_client(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_device(id)
    update_device(id, params::Dict{String,<:Any})

Updates a thin client device.

# Arguments
- `id`: The ID of the device to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"desiredSoftwareSetId"`: The ID of the software set to apply.
- `"name"`: The name of the device to update.
- `"softwareSetUpdateSchedule"`: An option to define if software updates should be applied
  within a maintenance window.
"""
function update_device(id; aws_config::AbstractAWSConfig=current_aws_config())
    return workspaces_thin_client(
        "PATCH", "/devices/$(id)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function update_device(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_thin_client(
        "PATCH",
        "/devices/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_environment(id)
    update_environment(id, params::Dict{String,<:Any})

Updates an environment.

# Arguments
- `id`: The ID of the environment to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"desiredSoftwareSetId"`: The ID of the software set to apply.
- `"desktopArn"`: The Amazon Resource Name (ARN) of the desktop to stream from Amazon
  WorkSpaces, WorkSpaces Web, or AppStream 2.0.
- `"desktopEndpoint"`: The URL for the identity provider login (only for environments that
  use AppStream 2.0).
- `"deviceCreationTags"`: A map of the key-value pairs of the tag or tags to assign to the
  newly created devices for this environment.
- `"maintenanceWindow"`: A specification for a time window to apply software updates.
- `"name"`: The name of the environment to update.
- `"softwareSetUpdateMode"`: An option to define which software updates to apply.
- `"softwareSetUpdateSchedule"`: An option to define if software updates should be applied
  within a maintenance window.
"""
function update_environment(id; aws_config::AbstractAWSConfig=current_aws_config())
    return workspaces_thin_client(
        "PATCH",
        "/environments/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_environment(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_thin_client(
        "PATCH",
        "/environments/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_software_set(id, validation_status)
    update_software_set(id, validation_status, params::Dict{String,<:Any})

Updates a software set.

# Arguments
- `id`: The ID of the software set to update.
- `validation_status`: An option to define if the software set has been validated.

"""
function update_software_set(
    id, validationStatus; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_thin_client(
        "PATCH",
        "/softwaresets/$(id)",
        Dict{String,Any}("validationStatus" => validationStatus);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_software_set(
    id,
    validationStatus,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces_thin_client(
        "PATCH",
        "/softwaresets/$(id)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("validationStatus" => validationStatus), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: kafka
using AWS.Compat
using AWS.UUIDs

"""
    batch_associate_scram_secret(cluster_arn, secret_arn_list)
    batch_associate_scram_secret(cluster_arn, secret_arn_list, params::Dict{String,<:Any})


            Associates one or more Scram Secrets with an Amazon MSK cluster.

# Arguments
- `cluster_arn`: 
            The Amazon Resource Name (ARN) of the cluster to be updated.
  
- `secret_arn_list`: 
            List of AWS Secrets Manager secret ARNs.

"""
function batch_associate_scram_secret(
    clusterArn, secretArnList; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kafka(
        "POST",
        "/v1/clusters/$(clusterArn)/scram-secrets",
        Dict{String,Any}("secretArnList" => secretArnList);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_associate_scram_secret(
    clusterArn,
    secretArnList,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafka(
        "POST",
        "/v1/clusters/$(clusterArn)/scram-secrets",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("secretArnList" => secretArnList), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_disassociate_scram_secret(cluster_arn, secret_arn_list)
    batch_disassociate_scram_secret(cluster_arn, secret_arn_list, params::Dict{String,<:Any})


            Disassociates one or more Scram Secrets from an Amazon MSK cluster.

# Arguments
- `cluster_arn`: 
            The Amazon Resource Name (ARN) of the cluster to be updated.
  
- `secret_arn_list`: 
            List of AWS Secrets Manager secret ARNs.

"""
function batch_disassociate_scram_secret(
    clusterArn, secretArnList; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kafka(
        "PATCH",
        "/v1/clusters/$(clusterArn)/scram-secrets",
        Dict{String,Any}("secretArnList" => secretArnList);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_disassociate_scram_secret(
    clusterArn,
    secretArnList,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafka(
        "PATCH",
        "/v1/clusters/$(clusterArn)/scram-secrets",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("secretArnList" => secretArnList), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_cluster(broker_node_group_info, cluster_name, kafka_version, number_of_broker_nodes)
    create_cluster(broker_node_group_info, cluster_name, kafka_version, number_of_broker_nodes, params::Dict{String,<:Any})


            Creates a new MSK cluster.

# Arguments
- `broker_node_group_info`: 
            Information about the broker nodes in the
  cluster.
- `cluster_name`: 
            The name of the cluster.
- `kafka_version`: 
            The version of Apache Kafka.
- `number_of_broker_nodes`: 
            The number of broker nodes in the cluster.
  

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientAuthentication"`: 
            Includes all client authentication related
  information.
- `"configurationInfo"`: 
            Represents the configuration that you want MSK to use
  for the brokers in a cluster.
- `"encryptionInfo"`: 
            Includes all encryption-related information.
- `"enhancedMonitoring"`: 
            Specifies the level of monitoring for the MSK
  cluster. The possible values are DEFAULT, PER_BROKER, PER_TOPIC_PER_BROKER, and
  PER_TOPIC_PER_PARTITION.
- `"loggingInfo"`:
- `"openMonitoring"`: 
            The settings for open monitoring.
- `"storageMode"`: 
            This controls storage mode for supported storage tiers.
  
- `"tags"`: 
            Create tags when creating the cluster.
"""
function create_cluster(
    brokerNodeGroupInfo,
    clusterName,
    kafkaVersion,
    numberOfBrokerNodes;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafka(
        "POST",
        "/v1/clusters",
        Dict{String,Any}(
            "brokerNodeGroupInfo" => brokerNodeGroupInfo,
            "clusterName" => clusterName,
            "kafkaVersion" => kafkaVersion,
            "numberOfBrokerNodes" => numberOfBrokerNodes,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_cluster(
    brokerNodeGroupInfo,
    clusterName,
    kafkaVersion,
    numberOfBrokerNodes,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafka(
        "POST",
        "/v1/clusters",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "brokerNodeGroupInfo" => brokerNodeGroupInfo,
                    "clusterName" => clusterName,
                    "kafkaVersion" => kafkaVersion,
                    "numberOfBrokerNodes" => numberOfBrokerNodes,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_cluster_v2(cluster_name)
    create_cluster_v2(cluster_name, params::Dict{String,<:Any})


            Creates a new MSK cluster.

# Arguments
- `cluster_name`: 
            The name of the cluster.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"provisioned"`: 
            Information about the provisioned cluster.
- `"serverless"`: 
            Information about the serverless cluster.
- `"tags"`: 
            A map of tags that you want the cluster to have.
"""
function create_cluster_v2(clusterName; aws_config::AbstractAWSConfig=current_aws_config())
    return kafka(
        "POST",
        "/api/v2/clusters",
        Dict{String,Any}("clusterName" => clusterName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_cluster_v2(
    clusterName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafka(
        "POST",
        "/api/v2/clusters",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clusterName" => clusterName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_configuration(name, server_properties)
    create_configuration(name, server_properties, params::Dict{String,<:Any})


            Creates a new MSK configuration.

# Arguments
- `name`: 
            The name of the configuration.
- `server_properties`: 
            Contents of the server.properties file. When using the
  API, you must ensure that the contents of the file are base64 encoded. 
               When
  using the AWS Management Console, the SDK, or the AWS CLI, the contents of
  server.properties can be in plaintext.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: 
            The description of the configuration.
- `"kafkaVersions"`: 
            The versions of Apache Kafka with which you can use this
  MSK configuration.
"""
function create_configuration(
    name, serverProperties; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kafka(
        "POST",
        "/v1/configurations",
        Dict{String,Any}("name" => name, "serverProperties" => serverProperties);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_configuration(
    name,
    serverProperties,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafka(
        "POST",
        "/v1/configurations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("name" => name, "serverProperties" => serverProperties),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_replicator(kafka_clusters, replication_info_list, replicator_name, service_execution_role_arn)
    create_replicator(kafka_clusters, replication_info_list, replicator_name, service_execution_role_arn, params::Dict{String,<:Any})

Creates the replicator.

# Arguments
- `kafka_clusters`: Kafka Clusters to use in setting up sources / targets for replication.
- `replication_info_list`: A list of replication configurations, where each configuration
  targets a given source cluster to target cluster replication flow.
- `replicator_name`: The name of the replicator. Alpha-numeric characters with '-' are
  allowed.
- `service_execution_role_arn`: The ARN of the IAM role used by the replicator to access
  resources in the customer's account (e.g source and target clusters)

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A summary description of the replicator.
- `"tags"`: List of tags to attach to created Replicator.
"""
function create_replicator(
    kafkaClusters,
    replicationInfoList,
    replicatorName,
    serviceExecutionRoleArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafka(
        "POST",
        "/replication/v1/replicators",
        Dict{String,Any}(
            "kafkaClusters" => kafkaClusters,
            "replicationInfoList" => replicationInfoList,
            "replicatorName" => replicatorName,
            "serviceExecutionRoleArn" => serviceExecutionRoleArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_replicator(
    kafkaClusters,
    replicationInfoList,
    replicatorName,
    serviceExecutionRoleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafka(
        "POST",
        "/replication/v1/replicators",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "kafkaClusters" => kafkaClusters,
                    "replicationInfoList" => replicationInfoList,
                    "replicatorName" => replicatorName,
                    "serviceExecutionRoleArn" => serviceExecutionRoleArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_vpc_connection(authentication, client_subnets, security_groups, target_cluster_arn, vpc_id)
    create_vpc_connection(authentication, client_subnets, security_groups, target_cluster_arn, vpc_id, params::Dict{String,<:Any})


            Creates a new MSK VPC connection.

# Arguments
- `authentication`: 
            The authentication type of VPC connection.
- `client_subnets`: 
            The list of client subnets.
- `security_groups`: 
            The list of security groups.
- `target_cluster_arn`: 
            The cluster Amazon Resource Name (ARN) for the VPC
  connection.
- `vpc_id`: 
            The VPC ID of VPC connection.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tags"`: 
            A map of tags for the VPC connection.
"""
function create_vpc_connection(
    authentication,
    clientSubnets,
    securityGroups,
    targetClusterArn,
    vpcId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafka(
        "POST",
        "/v1/vpc-connection",
        Dict{String,Any}(
            "authentication" => authentication,
            "clientSubnets" => clientSubnets,
            "securityGroups" => securityGroups,
            "targetClusterArn" => targetClusterArn,
            "vpcId" => vpcId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_vpc_connection(
    authentication,
    clientSubnets,
    securityGroups,
    targetClusterArn,
    vpcId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafka(
        "POST",
        "/v1/vpc-connection",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "authentication" => authentication,
                    "clientSubnets" => clientSubnets,
                    "securityGroups" => securityGroups,
                    "targetClusterArn" => targetClusterArn,
                    "vpcId" => vpcId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_cluster(cluster_arn)
    delete_cluster(cluster_arn, params::Dict{String,<:Any})


            Deletes the MSK cluster specified by the Amazon Resource Name (ARN) in the
request.

# Arguments
- `cluster_arn`: 
            The Amazon Resource Name (ARN) that uniquely identifies the
  cluster.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"currentVersion"`: 
            The current version of the MSK cluster.
"""
function delete_cluster(clusterArn; aws_config::AbstractAWSConfig=current_aws_config())
    return kafka(
        "DELETE",
        "/v1/clusters/$(clusterArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_cluster(
    clusterArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafka(
        "DELETE",
        "/v1/clusters/$(clusterArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_cluster_policy(cluster_arn)
    delete_cluster_policy(cluster_arn, params::Dict{String,<:Any})


            Deletes the MSK cluster policy specified by the Amazon Resource Name (ARN) in
the request.

# Arguments
- `cluster_arn`: 
            The Amazon Resource Name (ARN) of the cluster.

"""
function delete_cluster_policy(
    clusterArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kafka(
        "DELETE",
        "/v1/clusters/$(clusterArn)/policy";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_cluster_policy(
    clusterArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafka(
        "DELETE",
        "/v1/clusters/$(clusterArn)/policy",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_configuration(arn)
    delete_configuration(arn, params::Dict{String,<:Any})


            Deletes an MSK Configuration.

# Arguments
- `arn`: 
            The Amazon Resource Name (ARN) that uniquely identifies an MSK
  configuration.

"""
function delete_configuration(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return kafka(
        "DELETE",
        "/v1/configurations/$(arn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_configuration(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kafka(
        "DELETE",
        "/v1/configurations/$(arn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_replicator(replicator_arn)
    delete_replicator(replicator_arn, params::Dict{String,<:Any})

Deletes a replicator.

# Arguments
- `replicator_arn`: The Amazon Resource Name (ARN) of the replicator to be deleted.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"currentVersion"`: The current version of the replicator.
"""
function delete_replicator(
    replicatorArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kafka(
        "DELETE",
        "/replication/v1/replicators/$(replicatorArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_replicator(
    replicatorArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafka(
        "DELETE",
        "/replication/v1/replicators/$(replicatorArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_vpc_connection(arn)
    delete_vpc_connection(arn, params::Dict{String,<:Any})


            Deletes a MSK VPC connection.

# Arguments
- `arn`: 
            The Amazon Resource Name (ARN) that uniquely identifies an MSK VPC
  connection.

"""
function delete_vpc_connection(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return kafka(
        "DELETE",
        "/v1/vpc-connection/$(arn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_vpc_connection(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kafka(
        "DELETE",
        "/v1/vpc-connection/$(arn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_cluster(cluster_arn)
    describe_cluster(cluster_arn, params::Dict{String,<:Any})


            Returns a description of the MSK cluster whose Amazon Resource Name (ARN) is
specified in the request.

# Arguments
- `cluster_arn`: 
            The Amazon Resource Name (ARN) that uniquely identifies the
  cluster.

"""
function describe_cluster(clusterArn; aws_config::AbstractAWSConfig=current_aws_config())
    return kafka(
        "GET",
        "/v1/clusters/$(clusterArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_cluster(
    clusterArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafka(
        "GET",
        "/v1/clusters/$(clusterArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_cluster_operation(cluster_operation_arn)
    describe_cluster_operation(cluster_operation_arn, params::Dict{String,<:Any})


            Returns a description of the cluster operation specified by the ARN.

# Arguments
- `cluster_operation_arn`: 
            The Amazon Resource Name (ARN) that uniquely
  identifies the MSK cluster operation.

"""
function describe_cluster_operation(
    clusterOperationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kafka(
        "GET",
        "/v1/operations/$(clusterOperationArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_cluster_operation(
    clusterOperationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafka(
        "GET",
        "/v1/operations/$(clusterOperationArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_cluster_operation_v2(cluster_operation_arn)
    describe_cluster_operation_v2(cluster_operation_arn, params::Dict{String,<:Any})


            Returns a description of the cluster operation specified by the ARN.

# Arguments
- `cluster_operation_arn`: ARN of the cluster operation to describe.

"""
function describe_cluster_operation_v2(
    clusterOperationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kafka(
        "GET",
        "/api/v2/operations/$(clusterOperationArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_cluster_operation_v2(
    clusterOperationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafka(
        "GET",
        "/api/v2/operations/$(clusterOperationArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_cluster_v2(cluster_arn)
    describe_cluster_v2(cluster_arn, params::Dict{String,<:Any})


            Returns a description of the MSK cluster whose Amazon Resource Name (ARN) is
specified in the request.

# Arguments
- `cluster_arn`: 
            The Amazon Resource Name (ARN) that uniquely identifies the
  cluster.

"""
function describe_cluster_v2(clusterArn; aws_config::AbstractAWSConfig=current_aws_config())
    return kafka(
        "GET",
        "/api/v2/clusters/$(clusterArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_cluster_v2(
    clusterArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafka(
        "GET",
        "/api/v2/clusters/$(clusterArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_configuration(arn)
    describe_configuration(arn, params::Dict{String,<:Any})


            Returns a description of this MSK configuration.

# Arguments
- `arn`: 
            The Amazon Resource Name (ARN) that uniquely identifies an MSK
  configuration and all of its revisions.

"""
function describe_configuration(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return kafka(
        "GET",
        "/v1/configurations/$(arn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_configuration(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kafka(
        "GET",
        "/v1/configurations/$(arn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_configuration_revision(arn, revision)
    describe_configuration_revision(arn, revision, params::Dict{String,<:Any})


            Returns a description of this revision of the configuration.

# Arguments
- `arn`: 
            The Amazon Resource Name (ARN) that uniquely identifies an MSK
  configuration and all of its revisions.
- `revision`: 
            A string that uniquely identifies a revision of an MSK
  configuration.

"""
function describe_configuration_revision(
    arn, revision; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kafka(
        "GET",
        "/v1/configurations/$(arn)/revisions/$(revision)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_configuration_revision(
    arn,
    revision,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafka(
        "GET",
        "/v1/configurations/$(arn)/revisions/$(revision)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_replicator(replicator_arn)
    describe_replicator(replicator_arn, params::Dict{String,<:Any})

Describes a replicator.

# Arguments
- `replicator_arn`: The Amazon Resource Name (ARN) of the replicator to be described.

"""
function describe_replicator(
    replicatorArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kafka(
        "GET",
        "/replication/v1/replicators/$(replicatorArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_replicator(
    replicatorArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafka(
        "GET",
        "/replication/v1/replicators/$(replicatorArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_vpc_connection(arn)
    describe_vpc_connection(arn, params::Dict{String,<:Any})


            Returns a description of this MSK VPC connection.

# Arguments
- `arn`: 
            The Amazon Resource Name (ARN) that uniquely identifies a MSK VPC
  connection.

"""
function describe_vpc_connection(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return kafka(
        "GET",
        "/v1/vpc-connection/$(arn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_vpc_connection(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kafka(
        "GET",
        "/v1/vpc-connection/$(arn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_bootstrap_brokers(cluster_arn)
    get_bootstrap_brokers(cluster_arn, params::Dict{String,<:Any})


            A list of brokers that a client application can use to bootstrap.

# Arguments
- `cluster_arn`: 
            The Amazon Resource Name (ARN) that uniquely identifies the
  cluster.

"""
function get_bootstrap_brokers(
    clusterArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kafka(
        "GET",
        "/v1/clusters/$(clusterArn)/bootstrap-brokers";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_bootstrap_brokers(
    clusterArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafka(
        "GET",
        "/v1/clusters/$(clusterArn)/bootstrap-brokers",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_cluster_policy(cluster_arn)
    get_cluster_policy(cluster_arn, params::Dict{String,<:Any})


            Get the MSK cluster policy specified by the Amazon Resource Name (ARN) in the
request.

# Arguments
- `cluster_arn`: 
            The Amazon Resource Name (ARN) of the cluster.

"""
function get_cluster_policy(clusterArn; aws_config::AbstractAWSConfig=current_aws_config())
    return kafka(
        "GET",
        "/v1/clusters/$(clusterArn)/policy";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_cluster_policy(
    clusterArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafka(
        "GET",
        "/v1/clusters/$(clusterArn)/policy",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_compatible_kafka_versions()
    get_compatible_kafka_versions(params::Dict{String,<:Any})


            Gets the Apache Kafka versions to which you can update the MSK cluster.


# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clusterArn"`: 
            The Amazon Resource Name (ARN) of the cluster check.
  
"""
function get_compatible_kafka_versions(; aws_config::AbstractAWSConfig=current_aws_config())
    return kafka(
        "GET",
        "/v1/compatible-kafka-versions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_compatible_kafka_versions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kafka(
        "GET",
        "/v1/compatible-kafka-versions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_client_vpc_connections(cluster_arn)
    list_client_vpc_connections(cluster_arn, params::Dict{String,<:Any})


            Returns a list of all the VPC connections in this Region.

# Arguments
- `cluster_arn`: 
            The Amazon Resource Name (ARN) of the cluster.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: 
            The maximum number of results to return in the response. If
  there are more results, the response includes a NextToken parameter.
- `"nextToken"`: 
            The paginated results marker. When the result of the
  operation is truncated, the call returns NextToken in the response. 
            To get the
  next batch, provide this token in your next request.
"""
function list_client_vpc_connections(
    clusterArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kafka(
        "GET",
        "/v1/clusters/$(clusterArn)/client-vpc-connections";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_client_vpc_connections(
    clusterArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafka(
        "GET",
        "/v1/clusters/$(clusterArn)/client-vpc-connections",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_cluster_operations(cluster_arn)
    list_cluster_operations(cluster_arn, params::Dict{String,<:Any})


            Returns a list of all the operations that have been performed on the specified
MSK cluster.

# Arguments
- `cluster_arn`: 
            The Amazon Resource Name (ARN) that uniquely identifies the
  cluster.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: 
            The maximum number of results to return in the response. If
  there are more results, the response includes a NextToken parameter.
- `"nextToken"`: 
            The paginated results marker. When the result of the
  operation is truncated, the call returns NextToken in the response. 
            To get the
  next batch, provide this token in your next request.
"""
function list_cluster_operations(
    clusterArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kafka(
        "GET",
        "/v1/clusters/$(clusterArn)/operations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_cluster_operations(
    clusterArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafka(
        "GET",
        "/v1/clusters/$(clusterArn)/operations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_cluster_operations_v2(cluster_arn)
    list_cluster_operations_v2(cluster_arn, params::Dict{String,<:Any})


            Returns a list of all the operations that have been performed on the specified
MSK cluster.

# Arguments
- `cluster_arn`: The arn of the cluster whose operations are being requested.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maxResults of the query.
- `"nextToken"`: The nextToken of the query.
"""
function list_cluster_operations_v2(
    clusterArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kafka(
        "GET",
        "/api/v2/clusters/$(clusterArn)/operations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_cluster_operations_v2(
    clusterArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafka(
        "GET",
        "/api/v2/clusters/$(clusterArn)/operations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_clusters()
    list_clusters(params::Dict{String,<:Any})


            Returns a list of all the MSK clusters in the current Region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clusterNameFilter"`: 
            Specify a prefix of the name of the clusters that you
  want to list. The service lists all the clusters whose names start with this prefix.
  
- `"maxResults"`: 
            The maximum number of results to return in the response. If
  there are more results, the response includes a NextToken parameter.
- `"nextToken"`: 
            The paginated results marker. When the result of the
  operation is truncated, the call returns NextToken in the response. 
            To get the
  next batch, provide this token in your next request.
"""
function list_clusters(; aws_config::AbstractAWSConfig=current_aws_config())
    return kafka(
        "GET", "/v1/clusters"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_clusters(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kafka(
        "GET",
        "/v1/clusters",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_clusters_v2()
    list_clusters_v2(params::Dict{String,<:Any})


            Returns a list of all the MSK clusters in the current Region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clusterNameFilter"`: 
            Specify a prefix of the names of the clusters that
  you want to list. The service lists all the clusters whose names start with this prefix.
  
- `"clusterTypeFilter"`: 
            Specify either PROVISIONED or SERVERLESS.
- `"maxResults"`: 
            The maximum number of results to return in the response. If
  there are more results, the response includes a NextToken parameter.
- `"nextToken"`: 
            The paginated results marker. When the result of the
  operation is truncated, the call returns NextToken in the response. 
            To get the
  next batch, provide this token in your next request.
"""
function list_clusters_v2(; aws_config::AbstractAWSConfig=current_aws_config())
    return kafka(
        "GET", "/api/v2/clusters"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_clusters_v2(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kafka(
        "GET",
        "/api/v2/clusters",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_configuration_revisions(arn)
    list_configuration_revisions(arn, params::Dict{String,<:Any})


            Returns a list of all the MSK configurations in this Region.

# Arguments
- `arn`: 
            The Amazon Resource Name (ARN) that uniquely identifies an MSK
  configuration and all of its revisions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: 
            The maximum number of results to return in the response. If
  there are more results, the response includes a NextToken parameter.
- `"nextToken"`: 
            The paginated results marker. When the result of the
  operation is truncated, the call returns NextToken in the response. 
            To get the
  next batch, provide this token in your next request.
"""
function list_configuration_revisions(
    arn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kafka(
        "GET",
        "/v1/configurations/$(arn)/revisions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_configuration_revisions(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kafka(
        "GET",
        "/v1/configurations/$(arn)/revisions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_configurations()
    list_configurations(params::Dict{String,<:Any})


            Returns a list of all the MSK configurations in this Region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: 
            The maximum number of results to return in the response. If
  there are more results, the response includes a NextToken parameter.
- `"nextToken"`: 
            The paginated results marker. When the result of the
  operation is truncated, the call returns NextToken in the response. 
            To get the
  next batch, provide this token in your next request.
"""
function list_configurations(; aws_config::AbstractAWSConfig=current_aws_config())
    return kafka(
        "GET", "/v1/configurations"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_configurations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kafka(
        "GET",
        "/v1/configurations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_kafka_versions()
    list_kafka_versions(params::Dict{String,<:Any})


            Returns a list of Apache Kafka versions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: 
            The maximum number of results to return in the response. If
  there are more results, the response includes a NextToken parameter.
- `"nextToken"`: 
            The paginated results marker. When the result of the
  operation is truncated, the call returns NextToken in the response. To get the next batch,
  provide this token in your next request.
"""
function list_kafka_versions(; aws_config::AbstractAWSConfig=current_aws_config())
    return kafka(
        "GET", "/v1/kafka-versions"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_kafka_versions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kafka(
        "GET",
        "/v1/kafka-versions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_nodes(cluster_arn)
    list_nodes(cluster_arn, params::Dict{String,<:Any})


            Returns a list of the broker nodes in the cluster.

# Arguments
- `cluster_arn`: 
            The Amazon Resource Name (ARN) that uniquely identifies the
  cluster.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: 
            The maximum number of results to return in the response. If
  there are more results, the response includes a NextToken parameter.
- `"nextToken"`: 
            The paginated results marker. When the result of the
  operation is truncated, the call returns NextToken in the response. 
            To get the
  next batch, provide this token in your next request.
"""
function list_nodes(clusterArn; aws_config::AbstractAWSConfig=current_aws_config())
    return kafka(
        "GET",
        "/v1/clusters/$(clusterArn)/nodes";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_nodes(
    clusterArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafka(
        "GET",
        "/v1/clusters/$(clusterArn)/nodes",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_replicators()
    list_replicators(params::Dict{String,<:Any})

Lists the replicators.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in the response. If there are
  more results, the response includes a NextToken parameter.
- `"nextToken"`: If the response of ListReplicators is truncated, it returns a NextToken in
  the response. This NextToken should be sent in the subsequent request to ListReplicators.
- `"replicatorNameFilter"`: Returns replicators starting with given name.
"""
function list_replicators(; aws_config::AbstractAWSConfig=current_aws_config())
    return kafka(
        "GET",
        "/replication/v1/replicators";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_replicators(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kafka(
        "GET",
        "/replication/v1/replicators",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_scram_secrets(cluster_arn)
    list_scram_secrets(cluster_arn, params::Dict{String,<:Any})


            Returns a list of the Scram Secrets associated with an Amazon MSK cluster.


# Arguments
- `cluster_arn`: 
            The arn of the cluster.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: 
            The maxResults of the query.
- `"nextToken"`: 
            The nextToken of the query.
"""
function list_scram_secrets(clusterArn; aws_config::AbstractAWSConfig=current_aws_config())
    return kafka(
        "GET",
        "/v1/clusters/$(clusterArn)/scram-secrets";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_scram_secrets(
    clusterArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafka(
        "GET",
        "/v1/clusters/$(clusterArn)/scram-secrets",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})


            Returns a list of the tags associated with the specified resource.

# Arguments
- `resource_arn`: 
            The Amazon Resource Name (ARN) that uniquely identifies the
  resource that's associated with the tags.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kafka(
        "GET",
        "/v1/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafka(
        "GET",
        "/v1/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_vpc_connections()
    list_vpc_connections(params::Dict{String,<:Any})


            Returns a list of all the VPC connections in this Region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: 
            The maximum number of results to return in the response. If
  there are more results, the response includes a NextToken parameter.
- `"nextToken"`: 
            The paginated results marker. When the result of the
  operation is truncated, the call returns NextToken in the response. 
            To get the
  next batch, provide this token in your next request.
"""
function list_vpc_connections(; aws_config::AbstractAWSConfig=current_aws_config())
    return kafka(
        "GET", "/v1/vpc-connections"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_vpc_connections(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kafka(
        "GET",
        "/v1/vpc-connections",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_cluster_policy(cluster_arn, policy)
    put_cluster_policy(cluster_arn, policy, params::Dict{String,<:Any})


            Creates or updates the MSK cluster policy specified by the cluster Amazon
Resource Name (ARN) in the request.

# Arguments
- `cluster_arn`: 
            The Amazon Resource Name (ARN) of the cluster.
- `policy`: 
            The policy.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"currentVersion"`: 
            The policy version.
"""
function put_cluster_policy(
    clusterArn, policy; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kafka(
        "PUT",
        "/v1/clusters/$(clusterArn)/policy",
        Dict{String,Any}("policy" => policy);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_cluster_policy(
    clusterArn,
    policy,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafka(
        "PUT",
        "/v1/clusters/$(clusterArn)/policy",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("policy" => policy), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    reboot_broker(broker_ids, cluster_arn)
    reboot_broker(broker_ids, cluster_arn, params::Dict{String,<:Any})

Reboots brokers.

# Arguments
- `broker_ids`: 
            The list of broker IDs to be rebooted. The reboot-broker
  operation supports rebooting one broker at a time.
- `cluster_arn`: 
            The Amazon Resource Name (ARN) of the cluster to be updated.
  

"""
function reboot_broker(
    brokerIds, clusterArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kafka(
        "PUT",
        "/v1/clusters/$(clusterArn)/reboot-broker",
        Dict{String,Any}("brokerIds" => brokerIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function reboot_broker(
    brokerIds,
    clusterArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafka(
        "PUT",
        "/v1/clusters/$(clusterArn)/reboot-broker",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("brokerIds" => brokerIds), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    reject_client_vpc_connection(cluster_arn, vpc_connection_arn)
    reject_client_vpc_connection(cluster_arn, vpc_connection_arn, params::Dict{String,<:Any})


            Returns empty response.

# Arguments
- `cluster_arn`: 
            The Amazon Resource Name (ARN) of the cluster.
- `vpc_connection_arn`: 
            The VPC connection ARN.

"""
function reject_client_vpc_connection(
    clusterArn, vpcConnectionArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kafka(
        "PUT",
        "/v1/clusters/$(clusterArn)/client-vpc-connection",
        Dict{String,Any}("vpcConnectionArn" => vpcConnectionArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function reject_client_vpc_connection(
    clusterArn,
    vpcConnectionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafka(
        "PUT",
        "/v1/clusters/$(clusterArn)/client-vpc-connection",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("vpcConnectionArn" => vpcConnectionArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})


            Adds tags to the specified MSK resource.

# Arguments
- `resource_arn`: 
            The Amazon Resource Name (ARN) that uniquely identifies the
  resource that's associated with the tags.
- `tags`: 
            The key-value pair for the resource tag.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return kafka(
        "POST",
        "/v1/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafka(
        "POST",
        "/v1/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})


            Removes the tags associated with the keys that are provided in the query.


# Arguments
- `resource_arn`: 
            The Amazon Resource Name (ARN) that uniquely identifies the
  resource that's associated with the tags.
- `tag_keys`: 
            Tag keys must be unique for a given cluster. In addition, the
  following restrictions apply:
            
               
                  Each tag key
  must be unique. If you add a tag with a key that's already in
                  use, your
  new tag overwrites the existing key-value pair.
         You can't start a tag key with aws: because this prefix is reserved for use
           by  AWS.  AWS creates tags that begin with this prefix on your behalf, but
            you can't edit or delete them.
  Tag keys must be between 1 and 128 Unicode characters in length.
      
                  Tag keys must consist of the following characters: Unicode letters,
  digits,
                  white space, and the following special characters: _ . / = + -
                    @.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kafka(
        "DELETE",
        "/v1/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafka(
        "DELETE",
        "/v1/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_broker_count(cluster_arn, current_version, target_number_of_broker_nodes)
    update_broker_count(cluster_arn, current_version, target_number_of_broker_nodes, params::Dict{String,<:Any})


            Updates the number of broker nodes in the cluster.

# Arguments
- `cluster_arn`: 
            The Amazon Resource Name (ARN) that uniquely identifies the
  cluster.
- `current_version`: 
            The version of cluster to update from. A successful
  operation will then generate a new version.
- `target_number_of_broker_nodes`: 
            The number of broker nodes that you want
  the cluster to have after this operation completes successfully.

"""
function update_broker_count(
    clusterArn,
    currentVersion,
    targetNumberOfBrokerNodes;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafka(
        "PUT",
        "/v1/clusters/$(clusterArn)/nodes/count",
        Dict{String,Any}(
            "currentVersion" => currentVersion,
            "targetNumberOfBrokerNodes" => targetNumberOfBrokerNodes,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_broker_count(
    clusterArn,
    currentVersion,
    targetNumberOfBrokerNodes,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafka(
        "PUT",
        "/v1/clusters/$(clusterArn)/nodes/count",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "currentVersion" => currentVersion,
                    "targetNumberOfBrokerNodes" => targetNumberOfBrokerNodes,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_broker_storage(cluster_arn, current_version, target_broker_ebsvolume_info)
    update_broker_storage(cluster_arn, current_version, target_broker_ebsvolume_info, params::Dict{String,<:Any})


            Updates the EBS storage associated with MSK brokers.

# Arguments
- `cluster_arn`: 
            The Amazon Resource Name (ARN) that uniquely identifies the
  cluster.
- `current_version`: 
            The version of cluster to update from. A successful
  operation will then generate a new version.
- `target_broker_ebsvolume_info`: 
            Describes the target volume size and the ID
  of the broker to apply the update to.

"""
function update_broker_storage(
    clusterArn,
    currentVersion,
    targetBrokerEBSVolumeInfo;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafka(
        "PUT",
        "/v1/clusters/$(clusterArn)/nodes/storage",
        Dict{String,Any}(
            "currentVersion" => currentVersion,
            "targetBrokerEBSVolumeInfo" => targetBrokerEBSVolumeInfo,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_broker_storage(
    clusterArn,
    currentVersion,
    targetBrokerEBSVolumeInfo,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafka(
        "PUT",
        "/v1/clusters/$(clusterArn)/nodes/storage",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "currentVersion" => currentVersion,
                    "targetBrokerEBSVolumeInfo" => targetBrokerEBSVolumeInfo,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_broker_type(cluster_arn, current_version, target_instance_type)
    update_broker_type(cluster_arn, current_version, target_instance_type, params::Dict{String,<:Any})


            Updates EC2 instance type.

# Arguments
- `cluster_arn`: 
            The Amazon Resource Name (ARN) that uniquely identifies the
  cluster.
- `current_version`: 
            The cluster version that you want to change. After this
  operation completes successfully, the cluster will have a new version.
- `target_instance_type`: 
            The Amazon MSK broker type that you want all of the
  brokers in this cluster to be.

"""
function update_broker_type(
    clusterArn,
    currentVersion,
    targetInstanceType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafka(
        "PUT",
        "/v1/clusters/$(clusterArn)/nodes/type",
        Dict{String,Any}(
            "currentVersion" => currentVersion, "targetInstanceType" => targetInstanceType
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_broker_type(
    clusterArn,
    currentVersion,
    targetInstanceType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafka(
        "PUT",
        "/v1/clusters/$(clusterArn)/nodes/type",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "currentVersion" => currentVersion,
                    "targetInstanceType" => targetInstanceType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_cluster_configuration(cluster_arn, configuration_info, current_version)
    update_cluster_configuration(cluster_arn, configuration_info, current_version, params::Dict{String,<:Any})


            Updates the cluster with the configuration that is specified in the request
body.

# Arguments
- `cluster_arn`: 
            The Amazon Resource Name (ARN) that uniquely identifies the
  cluster.
- `configuration_info`: 
            Represents the configuration that you want MSK to use
  for the brokers in a cluster.
- `current_version`: 
            The version of the cluster that needs to be updated.
  

"""
function update_cluster_configuration(
    clusterArn,
    configurationInfo,
    currentVersion;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafka(
        "PUT",
        "/v1/clusters/$(clusterArn)/configuration",
        Dict{String,Any}(
            "configurationInfo" => configurationInfo, "currentVersion" => currentVersion
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_cluster_configuration(
    clusterArn,
    configurationInfo,
    currentVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafka(
        "PUT",
        "/v1/clusters/$(clusterArn)/configuration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "configurationInfo" => configurationInfo,
                    "currentVersion" => currentVersion,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_cluster_kafka_version(cluster_arn, current_version, target_kafka_version)
    update_cluster_kafka_version(cluster_arn, current_version, target_kafka_version, params::Dict{String,<:Any})


            Updates the Apache Kafka version for the cluster.

# Arguments
- `cluster_arn`: 
            The Amazon Resource Name (ARN) of the cluster to be updated.
  
- `current_version`: 
            Current cluster version.
- `target_kafka_version`: 
            Target Kafka version.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"configurationInfo"`: 
            The custom configuration that should be applied on
  the new version of cluster.
"""
function update_cluster_kafka_version(
    clusterArn,
    currentVersion,
    targetKafkaVersion;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafka(
        "PUT",
        "/v1/clusters/$(clusterArn)/version",
        Dict{String,Any}(
            "currentVersion" => currentVersion, "targetKafkaVersion" => targetKafkaVersion
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_cluster_kafka_version(
    clusterArn,
    currentVersion,
    targetKafkaVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafka(
        "PUT",
        "/v1/clusters/$(clusterArn)/version",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "currentVersion" => currentVersion,
                    "targetKafkaVersion" => targetKafkaVersion,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_configuration(arn, server_properties)
    update_configuration(arn, server_properties, params::Dict{String,<:Any})


            Updates an MSK configuration.

# Arguments
- `arn`: 
            The Amazon Resource Name (ARN) of the configuration.
- `server_properties`: 
            Contents of the server.properties file. When using the
  API, you must ensure that the contents of the file are base64 encoded. 
               When
  using the AWS Management Console, the SDK, or the AWS CLI, the contents of
  server.properties can be in plaintext.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: 
            The description of the configuration revision.
"""
function update_configuration(
    arn, serverProperties; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kafka(
        "PUT",
        "/v1/configurations/$(arn)",
        Dict{String,Any}("serverProperties" => serverProperties);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_configuration(
    arn,
    serverProperties,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafka(
        "PUT",
        "/v1/configurations/$(arn)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("serverProperties" => serverProperties), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_connectivity(cluster_arn, connectivity_info, current_version)
    update_connectivity(cluster_arn, connectivity_info, current_version, params::Dict{String,<:Any})


            Updates the cluster's connectivity configuration.

# Arguments
- `cluster_arn`: 
            The Amazon Resource Name (ARN) of the configuration.
- `connectivity_info`: 
            Information about the broker access configuration.
  
- `current_version`: 
            The version of the MSK cluster to update. Cluster
  versions aren't simple numbers. You can describe an MSK cluster to find its version. When
  this update operation is successful, it generates a new cluster version.

"""
function update_connectivity(
    clusterArn,
    connectivityInfo,
    currentVersion;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafka(
        "PUT",
        "/v1/clusters/$(clusterArn)/connectivity",
        Dict{String,Any}(
            "connectivityInfo" => connectivityInfo, "currentVersion" => currentVersion
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_connectivity(
    clusterArn,
    connectivityInfo,
    currentVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafka(
        "PUT",
        "/v1/clusters/$(clusterArn)/connectivity",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "connectivityInfo" => connectivityInfo,
                    "currentVersion" => currentVersion,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_monitoring(cluster_arn, current_version)
    update_monitoring(cluster_arn, current_version, params::Dict{String,<:Any})


            Updates the monitoring settings for the cluster. You can use this operation to
specify which Apache Kafka metrics you want Amazon MSK to send to Amazon CloudWatch. You
can also specify settings for open monitoring with Prometheus.

# Arguments
- `cluster_arn`: 
            The Amazon Resource Name (ARN) that uniquely identifies the
  cluster.
- `current_version`: 
            The version of the MSK cluster to update. Cluster
  versions aren't simple numbers. You can describe an MSK cluster to find its version. When
  this update operation is successful, it generates a new cluster version.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"enhancedMonitoring"`: 
            Specifies which Apache Kafka metrics Amazon MSK
  gathers and sends to Amazon CloudWatch for this cluster.
- `"loggingInfo"`:
- `"openMonitoring"`: 
            The settings for open monitoring.
"""
function update_monitoring(
    clusterArn, currentVersion; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kafka(
        "PUT",
        "/v1/clusters/$(clusterArn)/monitoring",
        Dict{String,Any}("currentVersion" => currentVersion);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_monitoring(
    clusterArn,
    currentVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafka(
        "PUT",
        "/v1/clusters/$(clusterArn)/monitoring",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("currentVersion" => currentVersion), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_replication_info(current_version, replicator_arn, source_kafka_cluster_arn, target_kafka_cluster_arn)
    update_replication_info(current_version, replicator_arn, source_kafka_cluster_arn, target_kafka_cluster_arn, params::Dict{String,<:Any})

Updates replication info of a replicator.

# Arguments
- `current_version`: Current replicator version.
- `replicator_arn`: The Amazon Resource Name (ARN) of the replicator to be updated.
- `source_kafka_cluster_arn`: The ARN of the source Kafka cluster.
- `target_kafka_cluster_arn`: The ARN of the target Kafka cluster.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"consumerGroupReplication"`: Updated consumer group replication information.
- `"topicReplication"`: Updated topic replication information.
"""
function update_replication_info(
    currentVersion,
    replicatorArn,
    sourceKafkaClusterArn,
    targetKafkaClusterArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafka(
        "PUT",
        "/replication/v1/replicators/$(replicatorArn)/replication-info",
        Dict{String,Any}(
            "currentVersion" => currentVersion,
            "sourceKafkaClusterArn" => sourceKafkaClusterArn,
            "targetKafkaClusterArn" => targetKafkaClusterArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_replication_info(
    currentVersion,
    replicatorArn,
    sourceKafkaClusterArn,
    targetKafkaClusterArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafka(
        "PUT",
        "/replication/v1/replicators/$(replicatorArn)/replication-info",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "currentVersion" => currentVersion,
                    "sourceKafkaClusterArn" => sourceKafkaClusterArn,
                    "targetKafkaClusterArn" => targetKafkaClusterArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_security(cluster_arn, current_version)
    update_security(cluster_arn, current_version, params::Dict{String,<:Any})


            Updates the security settings for the cluster. You can use this operation to
specify encryption and authentication on existing clusters.

# Arguments
- `cluster_arn`: 
            The Amazon Resource Name (ARN) that uniquely identifies the
  cluster.
- `current_version`: 
            The version of the MSK cluster to update. Cluster
  versions aren't simple numbers. You can describe an MSK cluster to find its version. When
  this update operation is successful, it generates a new cluster version.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientAuthentication"`: 
            Includes all client authentication related
  information.
- `"encryptionInfo"`: 
            Includes all encryption-related information.
"""
function update_security(
    clusterArn, currentVersion; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kafka(
        "PATCH",
        "/v1/clusters/$(clusterArn)/security",
        Dict{String,Any}("currentVersion" => currentVersion);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_security(
    clusterArn,
    currentVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafka(
        "PATCH",
        "/v1/clusters/$(clusterArn)/security",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("currentVersion" => currentVersion), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_storage(cluster_arn, current_version)
    update_storage(cluster_arn, current_version, params::Dict{String,<:Any})

Updates cluster broker volume size (or) sets cluster storage mode to TIERED.

# Arguments
- `cluster_arn`: 
            The Amazon Resource Name (ARN) of the cluster to be updated.
  
- `current_version`: 
            The version of cluster to update from. A successful
  operation will then generate a new version.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"provisionedThroughput"`: 
            EBS volume provisioned throughput information.
  
- `"storageMode"`: 
            Controls storage mode for supported storage tiers.
- `"volumeSizeGB"`: 
            size of the EBS volume to update.
"""
function update_storage(
    clusterArn, currentVersion; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kafka(
        "PUT",
        "/v1/clusters/$(clusterArn)/storage",
        Dict{String,Any}("currentVersion" => currentVersion);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_storage(
    clusterArn,
    currentVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafka(
        "PUT",
        "/v1/clusters/$(clusterArn)/storage",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("currentVersion" => currentVersion), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: imagebuilder
using AWS.Compat
using AWS.UUIDs

"""
    cancel_image_creation(client_token, image_build_version_arn)
    cancel_image_creation(client_token, image_build_version_arn, params::Dict{String,<:Any})

CancelImageCreation cancels the creation of Image. This operation can only be used on
images in a non-terminal state.

# Arguments
- `client_token`: Unique, case-sensitive identifier you provide to ensure idempotency of
  the request. For more information, see Ensuring idempotency in the Amazon EC2 API Reference.
- `image_build_version_arn`: The Amazon Resource Name (ARN) of the image that you want to
  cancel creation for.

"""
function cancel_image_creation(
    clientToken, imageBuildVersionArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return imagebuilder(
        "PUT",
        "/CancelImageCreation",
        Dict{String,Any}(
            "clientToken" => clientToken, "imageBuildVersionArn" => imageBuildVersionArn
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_image_creation(
    clientToken,
    imageBuildVersionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "PUT",
        "/CancelImageCreation",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "clientToken" => clientToken,
                    "imageBuildVersionArn" => imageBuildVersionArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_lifecycle_execution(client_token, lifecycle_execution_id)
    cancel_lifecycle_execution(client_token, lifecycle_execution_id, params::Dict{String,<:Any})

Cancel a specific image lifecycle policy runtime instance.

# Arguments
- `client_token`: Unique, case-sensitive identifier you provide to ensure idempotency of
  the request. For more information, see Ensuring idempotency in the Amazon EC2 API Reference.
- `lifecycle_execution_id`: Identifies the specific runtime instance of the image lifecycle
  to cancel.

"""
function cancel_lifecycle_execution(
    clientToken, lifecycleExecutionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return imagebuilder(
        "PUT",
        "/CancelLifecycleExecution",
        Dict{String,Any}(
            "clientToken" => clientToken, "lifecycleExecutionId" => lifecycleExecutionId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_lifecycle_execution(
    clientToken,
    lifecycleExecutionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "PUT",
        "/CancelLifecycleExecution",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "clientToken" => clientToken,
                    "lifecycleExecutionId" => lifecycleExecutionId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_component(client_token, name, platform, semantic_version)
    create_component(client_token, name, platform, semantic_version, params::Dict{String,<:Any})

Creates a new component that can be used to build, validate, test, and assess your image.
The component is based on a YAML document that you specify using exactly one of the
following methods:   Inline, using the data property in the request body.   A URL that
points to a YAML document file stored in Amazon S3, using the uri property in the request
body.

# Arguments
- `client_token`: Unique, case-sensitive identifier you provide to ensure idempotency of
  the request. For more information, see Ensuring idempotency in the Amazon EC2 API Reference.
- `name`: The name of the component.
- `platform`: The operating system platform of the component.
- `semantic_version`: The semantic version of the component. This version follows the
  semantic version syntax.  The semantic version has four nodes:
  &lt;major&gt;.&lt;minor&gt;.&lt;patch&gt;/&lt;build&gt;. You can assign values for the
  first three, and can filter on all of them.  Assignment: For the first three nodes you can
  assign any positive integer value, including zero, with an upper limit of 2^30-1, or
  1073741823 for each node. Image Builder automatically assigns the build number to the
  fourth node.  Patterns: You can use any numeric pattern that adheres to the assignment
  requirements for the nodes that you can assign. For example, you might choose a software
  version pattern, such as 1.0.0, or a date, such as 2021.01.01.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"changeDescription"`: The change description of the component. Describes what change has
  been made in this version, or what makes this version different from other versions of the
  component.
- `"data"`: Component data contains inline YAML document content for the component.
  Alternatively, you can specify the uri of a YAML document file stored in Amazon S3.
  However, you cannot specify both properties.
- `"description"`: Describes the contents of the component.
- `"kmsKeyId"`: The ID of the KMS key that is used to encrypt this component.
- `"supportedOsVersions"`: The operating system (OS) version supported by the component. If
  the OS information is available, a prefix match is performed against the base image OS
  version during image recipe creation.
- `"tags"`: The tags that apply to the component.
- `"uri"`: The uri of a YAML component document file. This must be an S3 URL
  (s3://bucket/key), and the requester must have permission to access the S3 bucket it points
  to. If you use Amazon S3, you can specify component content up to your service quota.
  Alternatively, you can specify the YAML document inline, using the component data property.
  You cannot specify both properties.
"""
function create_component(
    clientToken,
    name,
    platform,
    semanticVersion;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "PUT",
        "/CreateComponent",
        Dict{String,Any}(
            "clientToken" => clientToken,
            "name" => name,
            "platform" => platform,
            "semanticVersion" => semanticVersion,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_component(
    clientToken,
    name,
    platform,
    semanticVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "PUT",
        "/CreateComponent",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "clientToken" => clientToken,
                    "name" => name,
                    "platform" => platform,
                    "semanticVersion" => semanticVersion,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_container_recipe(client_token, components, container_type, name, parent_image, semantic_version, target_repository)
    create_container_recipe(client_token, components, container_type, name, parent_image, semantic_version, target_repository, params::Dict{String,<:Any})

Creates a new container recipe. Container recipes define how images are configured, tested,
and assessed.

# Arguments
- `client_token`: Unique, case-sensitive identifier you provide to ensure idempotency of
  the request. For more information, see Ensuring idempotency in the Amazon EC2 API Reference.
- `components`: Components for build and test that are included in the container recipe.
  Recipes require a minimum of one build component, and can have a maximum of 20 build and
  test components in any combination.
- `container_type`: The type of container to create.
- `name`: The name of the container recipe.
- `parent_image`: The base image for the container recipe.
- `semantic_version`: The semantic version of the container recipe. This version follows
  the semantic version syntax.  The semantic version has four nodes:
  &lt;major&gt;.&lt;minor&gt;.&lt;patch&gt;/&lt;build&gt;. You can assign values for the
  first three, and can filter on all of them.  Assignment: For the first three nodes you can
  assign any positive integer value, including zero, with an upper limit of 2^30-1, or
  1073741823 for each node. Image Builder automatically assigns the build number to the
  fourth node.  Patterns: You can use any numeric pattern that adheres to the assignment
  requirements for the nodes that you can assign. For example, you might choose a software
  version pattern, such as 1.0.0, or a date, such as 2021.01.01.
- `target_repository`: The destination repository for the container image.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description of the container recipe.
- `"dockerfileTemplateData"`: The Dockerfile template used to build your image as an inline
  data blob.
- `"dockerfileTemplateUri"`: The Amazon S3 URI for the Dockerfile that will be used to
  build your container image.
- `"imageOsVersionOverride"`: Specifies the operating system version for the base image.
- `"instanceConfiguration"`: A group of options that can be used to configure an instance
  for building and testing container images.
- `"kmsKeyId"`: Identifies which KMS key is used to encrypt the container image.
- `"platformOverride"`: Specifies the operating system platform when you use a custom base
  image.
- `"tags"`: Tags that are attached to the container recipe.
- `"workingDirectory"`: The working directory for use during build and test workflows.
"""
function create_container_recipe(
    clientToken,
    components,
    containerType,
    name,
    parentImage,
    semanticVersion,
    targetRepository;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "PUT",
        "/CreateContainerRecipe",
        Dict{String,Any}(
            "clientToken" => clientToken,
            "components" => components,
            "containerType" => containerType,
            "name" => name,
            "parentImage" => parentImage,
            "semanticVersion" => semanticVersion,
            "targetRepository" => targetRepository,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_container_recipe(
    clientToken,
    components,
    containerType,
    name,
    parentImage,
    semanticVersion,
    targetRepository,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "PUT",
        "/CreateContainerRecipe",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "clientToken" => clientToken,
                    "components" => components,
                    "containerType" => containerType,
                    "name" => name,
                    "parentImage" => parentImage,
                    "semanticVersion" => semanticVersion,
                    "targetRepository" => targetRepository,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_distribution_configuration(client_token, distributions, name)
    create_distribution_configuration(client_token, distributions, name, params::Dict{String,<:Any})

Creates a new distribution configuration. Distribution configurations define and configure
the outputs of your pipeline.

# Arguments
- `client_token`: Unique, case-sensitive identifier you provide to ensure idempotency of
  the request. For more information, see Ensuring idempotency in the Amazon EC2 API Reference.
- `distributions`: The distributions of the distribution configuration.
- `name`: The name of the distribution configuration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description of the distribution configuration.
- `"tags"`: The tags of the distribution configuration.
"""
function create_distribution_configuration(
    clientToken, distributions, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return imagebuilder(
        "PUT",
        "/CreateDistributionConfiguration",
        Dict{String,Any}(
            "clientToken" => clientToken, "distributions" => distributions, "name" => name
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_distribution_configuration(
    clientToken,
    distributions,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "PUT",
        "/CreateDistributionConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "clientToken" => clientToken,
                    "distributions" => distributions,
                    "name" => name,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_image(client_token, infrastructure_configuration_arn)
    create_image(client_token, infrastructure_configuration_arn, params::Dict{String,<:Any})

Creates a new image. This request will create a new image along with all of the configured
output resources defined in the distribution configuration. You must specify exactly one
recipe for your image, using either a ContainerRecipeArn or an ImageRecipeArn.

# Arguments
- `client_token`: Unique, case-sensitive identifier you provide to ensure idempotency of
  the request. For more information, see Ensuring idempotency in the Amazon EC2 API Reference.
- `infrastructure_configuration_arn`: The Amazon Resource Name (ARN) of the infrastructure
  configuration that defines the environment in which your image will be built and tested.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"containerRecipeArn"`: The Amazon Resource Name (ARN) of the container recipe that
  defines how images are configured and tested.
- `"distributionConfigurationArn"`: The Amazon Resource Name (ARN) of the distribution
  configuration that defines and configures the outputs of your pipeline.
- `"enhancedImageMetadataEnabled"`: Collects additional information about the image being
  created, including the operating system (OS) version and package list. This information is
  used to enhance the overall experience of using EC2 Image Builder. Enabled by default.
- `"executionRole"`: The name or Amazon Resource Name (ARN) for the IAM role you create
  that grants Image Builder access to perform workflow actions.
- `"imageRecipeArn"`: The Amazon Resource Name (ARN) of the image recipe that defines how
  images are configured, tested, and assessed.
- `"imageScanningConfiguration"`: Contains settings for vulnerability scans.
- `"imageTestsConfiguration"`: The image tests configuration of the image.
- `"tags"`: The tags of the image.
- `"workflows"`: Contains an array of workflow configuration objects.
"""
function create_image(
    clientToken,
    infrastructureConfigurationArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "PUT",
        "/CreateImage",
        Dict{String,Any}(
            "clientToken" => clientToken,
            "infrastructureConfigurationArn" => infrastructureConfigurationArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_image(
    clientToken,
    infrastructureConfigurationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "PUT",
        "/CreateImage",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "clientToken" => clientToken,
                    "infrastructureConfigurationArn" => infrastructureConfigurationArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_image_pipeline(client_token, infrastructure_configuration_arn, name)
    create_image_pipeline(client_token, infrastructure_configuration_arn, name, params::Dict{String,<:Any})

Creates a new image pipeline. Image pipelines enable you to automate the creation and
distribution of images.

# Arguments
- `client_token`: Unique, case-sensitive identifier you provide to ensure idempotency of
  the request. For more information, see Ensuring idempotency in the Amazon EC2 API Reference.
- `infrastructure_configuration_arn`: The Amazon Resource Name (ARN) of the infrastructure
  configuration that will be used to build images created by this image pipeline.
- `name`: The name of the image pipeline.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"containerRecipeArn"`: The Amazon Resource Name (ARN) of the container recipe that is
  used to configure images created by this container pipeline.
- `"description"`: The description of the image pipeline.
- `"distributionConfigurationArn"`: The Amazon Resource Name (ARN) of the distribution
  configuration that will be used to configure and distribute images created by this image
  pipeline.
- `"enhancedImageMetadataEnabled"`: Collects additional information about the image being
  created, including the operating system (OS) version and package list. This information is
  used to enhance the overall experience of using EC2 Image Builder. Enabled by default.
- `"executionRole"`: The name or Amazon Resource Name (ARN) for the IAM role you create
  that grants Image Builder access to perform workflow actions.
- `"imageRecipeArn"`: The Amazon Resource Name (ARN) of the image recipe that will be used
  to configure images created by this image pipeline.
- `"imageScanningConfiguration"`: Contains settings for vulnerability scans.
- `"imageTestsConfiguration"`: The image test configuration of the image pipeline.
- `"schedule"`: The schedule of the image pipeline.
- `"status"`: The status of the image pipeline.
- `"tags"`: The tags of the image pipeline.
- `"workflows"`: Contains an array of workflow configuration objects.
"""
function create_image_pipeline(
    clientToken,
    infrastructureConfigurationArn,
    name;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "PUT",
        "/CreateImagePipeline",
        Dict{String,Any}(
            "clientToken" => clientToken,
            "infrastructureConfigurationArn" => infrastructureConfigurationArn,
            "name" => name,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_image_pipeline(
    clientToken,
    infrastructureConfigurationArn,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "PUT",
        "/CreateImagePipeline",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "clientToken" => clientToken,
                    "infrastructureConfigurationArn" => infrastructureConfigurationArn,
                    "name" => name,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_image_recipe(client_token, components, name, parent_image, semantic_version)
    create_image_recipe(client_token, components, name, parent_image, semantic_version, params::Dict{String,<:Any})

Creates a new image recipe. Image recipes define how images are configured, tested, and
assessed.

# Arguments
- `client_token`: Unique, case-sensitive identifier you provide to ensure idempotency of
  the request. For more information, see Ensuring idempotency in the Amazon EC2 API Reference.
- `components`: The components included in the image recipe.
- `name`: The name of the image recipe.
- `parent_image`: The base image of the image recipe. The value of the string can be the
  ARN of the base image or an AMI ID. The format for the ARN follows this example:
  arn:aws:imagebuilder:us-west-2:aws:image/windows-server-2016-english-full-base-x86/x.x.x.
  You can provide the specific version that you want to use, or you can use a wildcard in all
  of the fields. If you enter an AMI ID for the string value, you must have access to the
  AMI, and the AMI must be in the same Region in which you are using Image Builder.
- `semantic_version`: The semantic version of the image recipe. This version follows the
  semantic version syntax.  The semantic version has four nodes:
  &lt;major&gt;.&lt;minor&gt;.&lt;patch&gt;/&lt;build&gt;. You can assign values for the
  first three, and can filter on all of them.  Assignment: For the first three nodes you can
  assign any positive integer value, including zero, with an upper limit of 2^30-1, or
  1073741823 for each node. Image Builder automatically assigns the build number to the
  fourth node.  Patterns: You can use any numeric pattern that adheres to the assignment
  requirements for the nodes that you can assign. For example, you might choose a software
  version pattern, such as 1.0.0, or a date, such as 2021.01.01.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"additionalInstanceConfiguration"`: Specify additional settings and launch scripts for
  your build instances.
- `"blockDeviceMappings"`: The block device mappings of the image recipe.
- `"description"`: The description of the image recipe.
- `"tags"`: The tags of the image recipe.
- `"workingDirectory"`: The working directory used during build and test workflows.
"""
function create_image_recipe(
    clientToken,
    components,
    name,
    parentImage,
    semanticVersion;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "PUT",
        "/CreateImageRecipe",
        Dict{String,Any}(
            "clientToken" => clientToken,
            "components" => components,
            "name" => name,
            "parentImage" => parentImage,
            "semanticVersion" => semanticVersion,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_image_recipe(
    clientToken,
    components,
    name,
    parentImage,
    semanticVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "PUT",
        "/CreateImageRecipe",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "clientToken" => clientToken,
                    "components" => components,
                    "name" => name,
                    "parentImage" => parentImage,
                    "semanticVersion" => semanticVersion,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_infrastructure_configuration(client_token, instance_profile_name, name)
    create_infrastructure_configuration(client_token, instance_profile_name, name, params::Dict{String,<:Any})

Creates a new infrastructure configuration. An infrastructure configuration defines the
environment in which your image will be built and tested.

# Arguments
- `client_token`: Unique, case-sensitive identifier you provide to ensure idempotency of
  the request. For more information, see Ensuring idempotency in the Amazon EC2 API Reference.
- `instance_profile_name`: The instance profile to associate with the instance used to
  customize your Amazon EC2 AMI.
- `name`: The name of the infrastructure configuration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description of the infrastructure configuration.
- `"instanceMetadataOptions"`: The instance metadata options that you can set for the HTTP
  requests that pipeline builds use to launch EC2 build and test instances.
- `"instanceTypes"`: The instance types of the infrastructure configuration. You can
  specify one or more instance types to use for this build. The service will pick one of
  these instance types based on availability.
- `"keyPair"`: The key pair of the infrastructure configuration. You can use this to log on
  to and debug the instance used to create your image.
- `"logging"`: The logging configuration of the infrastructure configuration.
- `"resourceTags"`: The tags attached to the resource created by Image Builder.
- `"securityGroupIds"`: The security group IDs to associate with the instance used to
  customize your Amazon EC2 AMI.
- `"snsTopicArn"`: The Amazon Resource Name (ARN) for the SNS topic to which we send image
  build event notifications.  EC2 Image Builder is unable to send notifications to SNS topics
  that are encrypted using keys from other accounts. The key that is used to encrypt the SNS
  topic must reside in the account that the Image Builder service runs under.
- `"subnetId"`: The subnet ID in which to place the instance used to customize your Amazon
  EC2 AMI.
- `"tags"`: The tags of the infrastructure configuration.
- `"terminateInstanceOnFailure"`: The terminate instance on failure setting of the
  infrastructure configuration. Set to false if you want Image Builder to retain the instance
  used to configure your AMI if the build or test phase of your workflow fails.
"""
function create_infrastructure_configuration(
    clientToken,
    instanceProfileName,
    name;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "PUT",
        "/CreateInfrastructureConfiguration",
        Dict{String,Any}(
            "clientToken" => clientToken,
            "instanceProfileName" => instanceProfileName,
            "name" => name,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_infrastructure_configuration(
    clientToken,
    instanceProfileName,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "PUT",
        "/CreateInfrastructureConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "clientToken" => clientToken,
                    "instanceProfileName" => instanceProfileName,
                    "name" => name,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_lifecycle_policy(client_token, execution_role, name, policy_details, resource_selection, resource_type)
    create_lifecycle_policy(client_token, execution_role, name, policy_details, resource_selection, resource_type, params::Dict{String,<:Any})

Create a lifecycle policy resource.

# Arguments
- `client_token`: Unique, case-sensitive identifier you provide to ensure idempotency of
  the request. For more information, see Ensuring idempotency in the Amazon EC2 API Reference.
- `execution_role`: The name or Amazon Resource Name (ARN) for the IAM role you create that
  grants Image Builder access to run lifecycle actions.
- `name`: The name of the lifecycle policy to create.
- `policy_details`: Configuration details for the lifecycle policy rules.
- `resource_selection`: Selection criteria for the resources that the lifecycle policy
  applies to.
- `resource_type`: The type of Image Builder resource that the lifecycle policy applies to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: Optional description for the lifecycle policy.
- `"status"`: Indicates whether the lifecycle policy resource is enabled.
- `"tags"`: Tags to apply to the lifecycle policy resource.
"""
function create_lifecycle_policy(
    clientToken,
    executionRole,
    name,
    policyDetails,
    resourceSelection,
    resourceType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "PUT",
        "/CreateLifecyclePolicy",
        Dict{String,Any}(
            "clientToken" => clientToken,
            "executionRole" => executionRole,
            "name" => name,
            "policyDetails" => policyDetails,
            "resourceSelection" => resourceSelection,
            "resourceType" => resourceType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_lifecycle_policy(
    clientToken,
    executionRole,
    name,
    policyDetails,
    resourceSelection,
    resourceType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "PUT",
        "/CreateLifecyclePolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "clientToken" => clientToken,
                    "executionRole" => executionRole,
                    "name" => name,
                    "policyDetails" => policyDetails,
                    "resourceSelection" => resourceSelection,
                    "resourceType" => resourceType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_workflow(client_token, name, semantic_version, type)
    create_workflow(client_token, name, semantic_version, type, params::Dict{String,<:Any})

Create a new workflow or a new version of an existing workflow.

# Arguments
- `client_token`: Unique, case-sensitive identifier you provide to ensure idempotency of
  the request. For more information, see Ensuring idempotency in the Amazon EC2 API Reference.
- `name`: The name of the workflow to create.
- `semantic_version`: The semantic version of this workflow resource. The semantic version
  syntax adheres to the following rules.  The semantic version has four nodes:
  &lt;major&gt;.&lt;minor&gt;.&lt;patch&gt;/&lt;build&gt;. You can assign values for the
  first three, and can filter on all of them.  Assignment: For the first three nodes you can
  assign any positive integer value, including zero, with an upper limit of 2^30-1, or
  1073741823 for each node. Image Builder automatically assigns the build number to the
  fourth node.  Patterns: You can use any numeric pattern that adheres to the assignment
  requirements for the nodes that you can assign. For example, you might choose a software
  version pattern, such as 1.0.0, or a date, such as 2021.01.01.
- `type`: The phase in the image build process for which the workflow resource is
  responsible.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"changeDescription"`: Describes what change has been made in this version of the
  workflow, or what makes this version different from other versions of the workflow.
- `"data"`: Contains the UTF-8 encoded YAML document content for the workflow.
  Alternatively, you can specify the uri of a YAML document file stored in Amazon S3.
  However, you cannot specify both properties.
- `"description"`: Describes the workflow.
- `"kmsKeyId"`: The ID of the KMS key that is used to encrypt this workflow resource.
- `"tags"`: Tags that apply to the workflow resource.
- `"uri"`: The uri of a YAML component document file. This must be an S3 URL
  (s3://bucket/key), and the requester must have permission to access the S3 bucket it points
  to. If you use Amazon S3, you can specify component content up to your service quota.
  Alternatively, you can specify the YAML document inline, using the component data property.
  You cannot specify both properties.
"""
function create_workflow(
    clientToken,
    name,
    semanticVersion,
    type;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "PUT",
        "/CreateWorkflow",
        Dict{String,Any}(
            "clientToken" => clientToken,
            "name" => name,
            "semanticVersion" => semanticVersion,
            "type" => type,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_workflow(
    clientToken,
    name,
    semanticVersion,
    type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "PUT",
        "/CreateWorkflow",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "clientToken" => clientToken,
                    "name" => name,
                    "semanticVersion" => semanticVersion,
                    "type" => type,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_component(component_build_version_arn)
    delete_component(component_build_version_arn, params::Dict{String,<:Any})

Deletes a component build version.

# Arguments
- `component_build_version_arn`: The Amazon Resource Name (ARN) of the component build
  version to delete.

"""
function delete_component(
    componentBuildVersionArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return imagebuilder(
        "DELETE",
        "/DeleteComponent",
        Dict{String,Any}("componentBuildVersionArn" => componentBuildVersionArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_component(
    componentBuildVersionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "DELETE",
        "/DeleteComponent",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("componentBuildVersionArn" => componentBuildVersionArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_container_recipe(container_recipe_arn)
    delete_container_recipe(container_recipe_arn, params::Dict{String,<:Any})

Deletes a container recipe.

# Arguments
- `container_recipe_arn`: The Amazon Resource Name (ARN) of the container recipe to delete.

"""
function delete_container_recipe(
    containerRecipeArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return imagebuilder(
        "DELETE",
        "/DeleteContainerRecipe",
        Dict{String,Any}("containerRecipeArn" => containerRecipeArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_container_recipe(
    containerRecipeArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "DELETE",
        "/DeleteContainerRecipe",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("containerRecipeArn" => containerRecipeArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_distribution_configuration(distribution_configuration_arn)
    delete_distribution_configuration(distribution_configuration_arn, params::Dict{String,<:Any})

Deletes a distribution configuration.

# Arguments
- `distribution_configuration_arn`: The Amazon Resource Name (ARN) of the distribution
  configuration to delete.

"""
function delete_distribution_configuration(
    distributionConfigurationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return imagebuilder(
        "DELETE",
        "/DeleteDistributionConfiguration",
        Dict{String,Any}("distributionConfigurationArn" => distributionConfigurationArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_distribution_configuration(
    distributionConfigurationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "DELETE",
        "/DeleteDistributionConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "distributionConfigurationArn" => distributionConfigurationArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_image(image_build_version_arn)
    delete_image(image_build_version_arn, params::Dict{String,<:Any})

Deletes an Image Builder image resource. This does not delete any EC2 AMIs or ECR container
images that are created during the image build process. You must clean those up separately,
using the appropriate Amazon EC2 or Amazon ECR console actions, or API or CLI commands.
To deregister an EC2 Linux AMI, see Deregister your Linux AMI in the  Amazon EC2 User Guide
.   To deregister an EC2 Windows AMI, see Deregister your Windows AMI in the  Amazon EC2
Windows Guide .   To delete a container image from Amazon ECR, see Deleting an image in the
Amazon ECR User Guide.

# Arguments
- `image_build_version_arn`: The Amazon Resource Name (ARN) of the Image Builder image
  resource to delete.

"""
function delete_image(
    imageBuildVersionArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return imagebuilder(
        "DELETE",
        "/DeleteImage",
        Dict{String,Any}("imageBuildVersionArn" => imageBuildVersionArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_image(
    imageBuildVersionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "DELETE",
        "/DeleteImage",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("imageBuildVersionArn" => imageBuildVersionArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_image_pipeline(image_pipeline_arn)
    delete_image_pipeline(image_pipeline_arn, params::Dict{String,<:Any})

Deletes an image pipeline.

# Arguments
- `image_pipeline_arn`: The Amazon Resource Name (ARN) of the image pipeline to delete.

"""
function delete_image_pipeline(
    imagePipelineArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return imagebuilder(
        "DELETE",
        "/DeleteImagePipeline",
        Dict{String,Any}("imagePipelineArn" => imagePipelineArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_image_pipeline(
    imagePipelineArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "DELETE",
        "/DeleteImagePipeline",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("imagePipelineArn" => imagePipelineArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_image_recipe(image_recipe_arn)
    delete_image_recipe(image_recipe_arn, params::Dict{String,<:Any})

Deletes an image recipe.

# Arguments
- `image_recipe_arn`: The Amazon Resource Name (ARN) of the image recipe to delete.

"""
function delete_image_recipe(
    imageRecipeArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return imagebuilder(
        "DELETE",
        "/DeleteImageRecipe",
        Dict{String,Any}("imageRecipeArn" => imageRecipeArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_image_recipe(
    imageRecipeArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "DELETE",
        "/DeleteImageRecipe",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("imageRecipeArn" => imageRecipeArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_infrastructure_configuration(infrastructure_configuration_arn)
    delete_infrastructure_configuration(infrastructure_configuration_arn, params::Dict{String,<:Any})

Deletes an infrastructure configuration.

# Arguments
- `infrastructure_configuration_arn`: The Amazon Resource Name (ARN) of the infrastructure
  configuration to delete.

"""
function delete_infrastructure_configuration(
    infrastructureConfigurationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return imagebuilder(
        "DELETE",
        "/DeleteInfrastructureConfiguration",
        Dict{String,Any}(
            "infrastructureConfigurationArn" => infrastructureConfigurationArn
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_infrastructure_configuration(
    infrastructureConfigurationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "DELETE",
        "/DeleteInfrastructureConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "infrastructureConfigurationArn" => infrastructureConfigurationArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_lifecycle_policy(lifecycle_policy_arn)
    delete_lifecycle_policy(lifecycle_policy_arn, params::Dict{String,<:Any})

Delete the specified lifecycle policy resource.

# Arguments
- `lifecycle_policy_arn`: The Amazon Resource Name (ARN) of the lifecycle policy resource
  to delete.

"""
function delete_lifecycle_policy(
    lifecyclePolicyArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return imagebuilder(
        "DELETE",
        "/DeleteLifecyclePolicy",
        Dict{String,Any}("lifecyclePolicyArn" => lifecyclePolicyArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_lifecycle_policy(
    lifecyclePolicyArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "DELETE",
        "/DeleteLifecyclePolicy",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("lifecyclePolicyArn" => lifecyclePolicyArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_workflow(workflow_build_version_arn)
    delete_workflow(workflow_build_version_arn, params::Dict{String,<:Any})

Deletes a specific workflow resource.

# Arguments
- `workflow_build_version_arn`: The Amazon Resource Name (ARN) of the workflow resource to
  delete.

"""
function delete_workflow(
    workflowBuildVersionArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return imagebuilder(
        "DELETE",
        "/DeleteWorkflow",
        Dict{String,Any}("workflowBuildVersionArn" => workflowBuildVersionArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_workflow(
    workflowBuildVersionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "DELETE",
        "/DeleteWorkflow",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("workflowBuildVersionArn" => workflowBuildVersionArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_component(component_build_version_arn)
    get_component(component_build_version_arn, params::Dict{String,<:Any})

Gets a component object.

# Arguments
- `component_build_version_arn`: The Amazon Resource Name (ARN) of the component that you
  want to get. Regex requires the suffix /d+.

"""
function get_component(
    componentBuildVersionArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return imagebuilder(
        "GET",
        "/GetComponent",
        Dict{String,Any}("componentBuildVersionArn" => componentBuildVersionArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_component(
    componentBuildVersionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "GET",
        "/GetComponent",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("componentBuildVersionArn" => componentBuildVersionArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_component_policy(component_arn)
    get_component_policy(component_arn, params::Dict{String,<:Any})

Gets a component policy.

# Arguments
- `component_arn`: The Amazon Resource Name (ARN) of the component whose policy you want to
  retrieve.

"""
function get_component_policy(
    componentArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return imagebuilder(
        "GET",
        "/GetComponentPolicy",
        Dict{String,Any}("componentArn" => componentArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_component_policy(
    componentArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "GET",
        "/GetComponentPolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("componentArn" => componentArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_container_recipe(container_recipe_arn)
    get_container_recipe(container_recipe_arn, params::Dict{String,<:Any})

Retrieves a container recipe.

# Arguments
- `container_recipe_arn`: The Amazon Resource Name (ARN) of the container recipe to
  retrieve.

"""
function get_container_recipe(
    containerRecipeArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return imagebuilder(
        "GET",
        "/GetContainerRecipe",
        Dict{String,Any}("containerRecipeArn" => containerRecipeArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_container_recipe(
    containerRecipeArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "GET",
        "/GetContainerRecipe",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("containerRecipeArn" => containerRecipeArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_container_recipe_policy(container_recipe_arn)
    get_container_recipe_policy(container_recipe_arn, params::Dict{String,<:Any})

Retrieves the policy for a container recipe.

# Arguments
- `container_recipe_arn`: The Amazon Resource Name (ARN) of the container recipe for the
  policy being requested.

"""
function get_container_recipe_policy(
    containerRecipeArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return imagebuilder(
        "GET",
        "/GetContainerRecipePolicy",
        Dict{String,Any}("containerRecipeArn" => containerRecipeArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_container_recipe_policy(
    containerRecipeArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "GET",
        "/GetContainerRecipePolicy",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("containerRecipeArn" => containerRecipeArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_distribution_configuration(distribution_configuration_arn)
    get_distribution_configuration(distribution_configuration_arn, params::Dict{String,<:Any})

Gets a distribution configuration.

# Arguments
- `distribution_configuration_arn`: The Amazon Resource Name (ARN) of the distribution
  configuration that you want to retrieve.

"""
function get_distribution_configuration(
    distributionConfigurationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return imagebuilder(
        "GET",
        "/GetDistributionConfiguration",
        Dict{String,Any}("distributionConfigurationArn" => distributionConfigurationArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_distribution_configuration(
    distributionConfigurationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "GET",
        "/GetDistributionConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "distributionConfigurationArn" => distributionConfigurationArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_image(image_build_version_arn)
    get_image(image_build_version_arn, params::Dict{String,<:Any})

Gets an image.

# Arguments
- `image_build_version_arn`: The Amazon Resource Name (ARN) of the image that you want to
  get.

"""
function get_image(imageBuildVersionArn; aws_config::AbstractAWSConfig=current_aws_config())
    return imagebuilder(
        "GET",
        "/GetImage",
        Dict{String,Any}("imageBuildVersionArn" => imageBuildVersionArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_image(
    imageBuildVersionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "GET",
        "/GetImage",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("imageBuildVersionArn" => imageBuildVersionArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_image_pipeline(image_pipeline_arn)
    get_image_pipeline(image_pipeline_arn, params::Dict{String,<:Any})

Gets an image pipeline.

# Arguments
- `image_pipeline_arn`: The Amazon Resource Name (ARN) of the image pipeline that you want
  to retrieve.

"""
function get_image_pipeline(
    imagePipelineArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return imagebuilder(
        "GET",
        "/GetImagePipeline",
        Dict{String,Any}("imagePipelineArn" => imagePipelineArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_image_pipeline(
    imagePipelineArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "GET",
        "/GetImagePipeline",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("imagePipelineArn" => imagePipelineArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_image_policy(image_arn)
    get_image_policy(image_arn, params::Dict{String,<:Any})

Gets an image policy.

# Arguments
- `image_arn`: The Amazon Resource Name (ARN) of the image whose policy you want to
  retrieve.

"""
function get_image_policy(imageArn; aws_config::AbstractAWSConfig=current_aws_config())
    return imagebuilder(
        "GET",
        "/GetImagePolicy",
        Dict{String,Any}("imageArn" => imageArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_image_policy(
    imageArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "GET",
        "/GetImagePolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("imageArn" => imageArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_image_recipe(image_recipe_arn)
    get_image_recipe(image_recipe_arn, params::Dict{String,<:Any})

Gets an image recipe.

# Arguments
- `image_recipe_arn`: The Amazon Resource Name (ARN) of the image recipe that you want to
  retrieve.

"""
function get_image_recipe(
    imageRecipeArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return imagebuilder(
        "GET",
        "/GetImageRecipe",
        Dict{String,Any}("imageRecipeArn" => imageRecipeArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_image_recipe(
    imageRecipeArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "GET",
        "/GetImageRecipe",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("imageRecipeArn" => imageRecipeArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_image_recipe_policy(image_recipe_arn)
    get_image_recipe_policy(image_recipe_arn, params::Dict{String,<:Any})

Gets an image recipe policy.

# Arguments
- `image_recipe_arn`: The Amazon Resource Name (ARN) of the image recipe whose policy you
  want to retrieve.

"""
function get_image_recipe_policy(
    imageRecipeArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return imagebuilder(
        "GET",
        "/GetImageRecipePolicy",
        Dict{String,Any}("imageRecipeArn" => imageRecipeArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_image_recipe_policy(
    imageRecipeArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "GET",
        "/GetImageRecipePolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("imageRecipeArn" => imageRecipeArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_infrastructure_configuration(infrastructure_configuration_arn)
    get_infrastructure_configuration(infrastructure_configuration_arn, params::Dict{String,<:Any})

Gets an infrastructure configuration.

# Arguments
- `infrastructure_configuration_arn`: The Amazon Resource Name (ARN) of the infrastructure
  configuration that you want to retrieve.

"""
function get_infrastructure_configuration(
    infrastructureConfigurationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return imagebuilder(
        "GET",
        "/GetInfrastructureConfiguration",
        Dict{String,Any}(
            "infrastructureConfigurationArn" => infrastructureConfigurationArn
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_infrastructure_configuration(
    infrastructureConfigurationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "GET",
        "/GetInfrastructureConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "infrastructureConfigurationArn" => infrastructureConfigurationArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_lifecycle_execution(lifecycle_execution_id)
    get_lifecycle_execution(lifecycle_execution_id, params::Dict{String,<:Any})

Get the runtime information that was logged for a specific runtime instance of the
lifecycle policy.

# Arguments
- `lifecycle_execution_id`: Use the unique identifier for a runtime instance of the
  lifecycle policy to get runtime details.

"""
function get_lifecycle_execution(
    lifecycleExecutionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return imagebuilder(
        "GET",
        "/GetLifecycleExecution",
        Dict{String,Any}("lifecycleExecutionId" => lifecycleExecutionId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_lifecycle_execution(
    lifecycleExecutionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "GET",
        "/GetLifecycleExecution",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("lifecycleExecutionId" => lifecycleExecutionId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_lifecycle_policy(lifecycle_policy_arn)
    get_lifecycle_policy(lifecycle_policy_arn, params::Dict{String,<:Any})

Get details for the specified image lifecycle policy.

# Arguments
- `lifecycle_policy_arn`: Specifies the Amazon Resource Name (ARN) of the image lifecycle
  policy resource to get.

"""
function get_lifecycle_policy(
    lifecyclePolicyArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return imagebuilder(
        "GET",
        "/GetLifecyclePolicy",
        Dict{String,Any}("lifecyclePolicyArn" => lifecyclePolicyArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_lifecycle_policy(
    lifecyclePolicyArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "GET",
        "/GetLifecyclePolicy",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("lifecyclePolicyArn" => lifecyclePolicyArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_workflow(workflow_build_version_arn)
    get_workflow(workflow_build_version_arn, params::Dict{String,<:Any})

Get a workflow resource object.

# Arguments
- `workflow_build_version_arn`: The Amazon Resource Name (ARN) of the workflow resource
  that you want to get.

"""
function get_workflow(
    workflowBuildVersionArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return imagebuilder(
        "GET",
        "/GetWorkflow",
        Dict{String,Any}("workflowBuildVersionArn" => workflowBuildVersionArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_workflow(
    workflowBuildVersionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "GET",
        "/GetWorkflow",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("workflowBuildVersionArn" => workflowBuildVersionArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_workflow_execution(workflow_execution_id)
    get_workflow_execution(workflow_execution_id, params::Dict{String,<:Any})

Get the runtime information that was logged for a specific runtime instance of the workflow.

# Arguments
- `workflow_execution_id`: Use the unique identifier for a runtime instance of the workflow
  to get runtime details.

"""
function get_workflow_execution(
    workflowExecutionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return imagebuilder(
        "GET",
        "/GetWorkflowExecution",
        Dict{String,Any}("workflowExecutionId" => workflowExecutionId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_workflow_execution(
    workflowExecutionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "GET",
        "/GetWorkflowExecution",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("workflowExecutionId" => workflowExecutionId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_workflow_step_execution(step_execution_id)
    get_workflow_step_execution(step_execution_id, params::Dict{String,<:Any})

Get the runtime information that was logged for a specific runtime instance of the workflow
step.

# Arguments
- `step_execution_id`: Use the unique identifier for a specific runtime instance of the
  workflow step to get runtime details for that step.

"""
function get_workflow_step_execution(
    stepExecutionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return imagebuilder(
        "GET",
        "/GetWorkflowStepExecution",
        Dict{String,Any}("stepExecutionId" => stepExecutionId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_workflow_step_execution(
    stepExecutionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "GET",
        "/GetWorkflowStepExecution",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("stepExecutionId" => stepExecutionId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    import_component(client_token, format, name, platform, semantic_version, type)
    import_component(client_token, format, name, platform, semantic_version, type, params::Dict{String,<:Any})

Imports a component and transforms its data into a component document.

# Arguments
- `client_token`: Unique, case-sensitive identifier you provide to ensure idempotency of
  the request. For more information, see Ensuring idempotency in the Amazon EC2 API Reference.
- `format`: The format of the resource that you want to import as a component.
- `name`: The name of the component.
- `platform`: The platform of the component.
- `semantic_version`: The semantic version of the component. This version follows the
  semantic version syntax.  The semantic version has four nodes:
  &lt;major&gt;.&lt;minor&gt;.&lt;patch&gt;/&lt;build&gt;. You can assign values for the
  first three, and can filter on all of them.  Filtering: With semantic versioning, you have
  the flexibility to use wildcards (x) to specify the most recent versions or nodes when
  selecting the base image or components for your recipe. When you use a wildcard in any
  node, all nodes to the right of the first wildcard must also be wildcards.
- `type`: The type of the component denotes whether the component is used to build the
  image, or only to test it.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"changeDescription"`: The change description of the component. This description
  indicates the change that has been made in this version, or what makes this version
  different from other versions of the component.
- `"data"`: The data of the component. Used to specify the data inline. Either data or uri
  can be used to specify the data within the component.
- `"description"`: The description of the component. Describes the contents of the
  component.
- `"kmsKeyId"`: The ID of the KMS key that should be used to encrypt this component.
- `"tags"`: The tags of the component.
- `"uri"`: The uri of the component. Must be an Amazon S3 URL and the requester must have
  permission to access the Amazon S3 bucket. If you use Amazon S3, you can specify component
  content up to your service quota. Either data or uri can be used to specify the data within
  the component.
"""
function import_component(
    clientToken,
    format,
    name,
    platform,
    semanticVersion,
    type;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "PUT",
        "/ImportComponent",
        Dict{String,Any}(
            "clientToken" => clientToken,
            "format" => format,
            "name" => name,
            "platform" => platform,
            "semanticVersion" => semanticVersion,
            "type" => type,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function import_component(
    clientToken,
    format,
    name,
    platform,
    semanticVersion,
    type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "PUT",
        "/ImportComponent",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "clientToken" => clientToken,
                    "format" => format,
                    "name" => name,
                    "platform" => platform,
                    "semanticVersion" => semanticVersion,
                    "type" => type,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    import_vm_image(client_token, name, platform, semantic_version, vm_import_task_id)
    import_vm_image(client_token, name, platform, semantic_version, vm_import_task_id, params::Dict{String,<:Any})

When you export your virtual machine (VM) from its virtualization environment, that process
creates a set of one or more disk container files that act as snapshots of your VM’s
environment, settings, and data. The Amazon EC2 API ImportImage action uses those files to
import your VM and create an AMI. To import using the CLI command, see import-image  You
can reference the task ID from the VM import to pull in the AMI that the import created as
the base image for your Image Builder recipe.

# Arguments
- `client_token`: Unique, case-sensitive identifier you provide to ensure idempotency of
  the request. For more information, see Ensuring idempotency in the Amazon EC2 API Reference.
- `name`: The name of the base image that is created by the import process.
- `platform`: The operating system platform for the imported VM.
- `semantic_version`: The semantic version to attach to the base image that was created
  during the import process. This version follows the semantic version syntax.  The semantic
  version has four nodes: &lt;major&gt;.&lt;minor&gt;.&lt;patch&gt;/&lt;build&gt;. You can
  assign values for the first three, and can filter on all of them.  Assignment: For the
  first three nodes you can assign any positive integer value, including zero, with an upper
  limit of 2^30-1, or 1073741823 for each node. Image Builder automatically assigns the build
  number to the fourth node.  Patterns: You can use any numeric pattern that adheres to the
  assignment requirements for the nodes that you can assign. For example, you might choose a
  software version pattern, such as 1.0.0, or a date, such as 2021.01.01.
- `vm_import_task_id`: The importTaskId (API) or ImportTaskId (CLI) from the Amazon EC2 VM
  import process. Image Builder retrieves information from the import process to pull in the
  AMI that is created from the VM source as the base image for your recipe.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description for the base image that is created by the import process.
- `"osVersion"`: The operating system version for the imported VM.
- `"tags"`: Tags that are attached to the import resources.
"""
function import_vm_image(
    clientToken,
    name,
    platform,
    semanticVersion,
    vmImportTaskId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "PUT",
        "/ImportVmImage",
        Dict{String,Any}(
            "clientToken" => clientToken,
            "name" => name,
            "platform" => platform,
            "semanticVersion" => semanticVersion,
            "vmImportTaskId" => vmImportTaskId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function import_vm_image(
    clientToken,
    name,
    platform,
    semanticVersion,
    vmImportTaskId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "PUT",
        "/ImportVmImage",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "clientToken" => clientToken,
                    "name" => name,
                    "platform" => platform,
                    "semanticVersion" => semanticVersion,
                    "vmImportTaskId" => vmImportTaskId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_component_build_versions(component_version_arn)
    list_component_build_versions(component_version_arn, params::Dict{String,<:Any})

Returns the list of component build versions for the specified semantic version.  The
semantic version has four nodes: &lt;major&gt;.&lt;minor&gt;.&lt;patch&gt;/&lt;build&gt;.
You can assign values for the first three, and can filter on all of them.  Filtering: With
semantic versioning, you have the flexibility to use wildcards (x) to specify the most
recent versions or nodes when selecting the base image or components for your recipe. When
you use a wildcard in any node, all nodes to the right of the first wildcard must also be
wildcards.

# Arguments
- `component_version_arn`: The component version Amazon Resource Name (ARN) whose versions
  you want to list.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum items to return in a request.
- `"nextToken"`: A token to specify where to start paginating. This is the nextToken from a
  previously truncated response.
"""
function list_component_build_versions(
    componentVersionArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return imagebuilder(
        "POST",
        "/ListComponentBuildVersions",
        Dict{String,Any}("componentVersionArn" => componentVersionArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_component_build_versions(
    componentVersionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "POST",
        "/ListComponentBuildVersions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("componentVersionArn" => componentVersionArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_components()
    list_components(params::Dict{String,<:Any})

Returns the list of components that can be filtered by name, or by using the listed filters
to streamline results. Newly created components can take up to two minutes to appear in the
ListComponents API Results.  The semantic version has four nodes:
&lt;major&gt;.&lt;minor&gt;.&lt;patch&gt;/&lt;build&gt;. You can assign values for the
first three, and can filter on all of them.  Filtering: With semantic versioning, you have
the flexibility to use wildcards (x) to specify the most recent versions or nodes when
selecting the base image or components for your recipe. When you use a wildcard in any
node, all nodes to the right of the first wildcard must also be wildcards.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"byName"`: Returns the list of components for the specified name.
- `"filters"`: Use the following filters to streamline results:    description     name
  platform     supportedOsVersion     type     version
- `"maxResults"`: The maximum items to return in a request.
- `"nextToken"`: A token to specify where to start paginating. This is the nextToken from a
  previously truncated response.
- `"owner"`: Filters results based on the type of owner for the component. By default, this
  request returns a list of components that your account owns. To see results for other types
  of owners, you can specify components that Amazon manages, third party components, or
  components that other accounts have shared with you.
"""
function list_components(; aws_config::AbstractAWSConfig=current_aws_config())
    return imagebuilder(
        "POST", "/ListComponents"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_components(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return imagebuilder(
        "POST",
        "/ListComponents",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_container_recipes()
    list_container_recipes(params::Dict{String,<:Any})

Returns a list of container recipes.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: Use the following filters to streamline results:    containerType     name
    parentImage     platform
- `"maxResults"`: The maximum items to return in a request.
- `"nextToken"`: A token to specify where to start paginating. This is the nextToken from a
  previously truncated response.
- `"owner"`: Returns container recipes belonging to the specified owner, that have been
  shared with you. You can omit this field to return container recipes belonging to your
  account.
"""
function list_container_recipes(; aws_config::AbstractAWSConfig=current_aws_config())
    return imagebuilder(
        "POST",
        "/ListContainerRecipes";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_container_recipes(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return imagebuilder(
        "POST",
        "/ListContainerRecipes",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_distribution_configurations()
    list_distribution_configurations(params::Dict{String,<:Any})

Returns a list of distribution configurations.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: You can filter on name to streamline results.
- `"maxResults"`: The maximum items to return in a request.
- `"nextToken"`: A token to specify where to start paginating. This is the nextToken from a
  previously truncated response.
"""
function list_distribution_configurations(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return imagebuilder(
        "POST",
        "/ListDistributionConfigurations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_distribution_configurations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return imagebuilder(
        "POST",
        "/ListDistributionConfigurations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_image_build_versions(image_version_arn)
    list_image_build_versions(image_version_arn, params::Dict{String,<:Any})

Returns a list of image build versions.

# Arguments
- `image_version_arn`: The Amazon Resource Name (ARN) of the image whose build versions you
  want to retrieve.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: Use the following filters to streamline results:    name     osVersion
  platform     type     version
- `"maxResults"`: The maximum items to return in a request.
- `"nextToken"`: A token to specify where to start paginating. This is the nextToken from a
  previously truncated response.
"""
function list_image_build_versions(
    imageVersionArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return imagebuilder(
        "POST",
        "/ListImageBuildVersions",
        Dict{String,Any}("imageVersionArn" => imageVersionArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_image_build_versions(
    imageVersionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "POST",
        "/ListImageBuildVersions",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("imageVersionArn" => imageVersionArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_image_packages(image_build_version_arn)
    list_image_packages(image_build_version_arn, params::Dict{String,<:Any})

List the Packages that are associated with an Image Build Version, as determined by Amazon
Web Services Systems Manager Inventory at build time.

# Arguments
- `image_build_version_arn`: Filter results for the ListImagePackages request by the Image
  Build Version ARN

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum items to return in a request.
- `"nextToken"`: A token to specify where to start paginating. This is the nextToken from a
  previously truncated response.
"""
function list_image_packages(
    imageBuildVersionArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return imagebuilder(
        "POST",
        "/ListImagePackages",
        Dict{String,Any}("imageBuildVersionArn" => imageBuildVersionArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_image_packages(
    imageBuildVersionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "POST",
        "/ListImagePackages",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("imageBuildVersionArn" => imageBuildVersionArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_image_pipeline_images(image_pipeline_arn)
    list_image_pipeline_images(image_pipeline_arn, params::Dict{String,<:Any})

Returns a list of images created by the specified pipeline.

# Arguments
- `image_pipeline_arn`: The Amazon Resource Name (ARN) of the image pipeline whose images
  you want to view.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: Use the following filters to streamline results:    name     version
- `"maxResults"`: The maximum items to return in a request.
- `"nextToken"`: A token to specify where to start paginating. This is the nextToken from a
  previously truncated response.
"""
function list_image_pipeline_images(
    imagePipelineArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return imagebuilder(
        "POST",
        "/ListImagePipelineImages",
        Dict{String,Any}("imagePipelineArn" => imagePipelineArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_image_pipeline_images(
    imagePipelineArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "POST",
        "/ListImagePipelineImages",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("imagePipelineArn" => imagePipelineArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_image_pipelines()
    list_image_pipelines(params::Dict{String,<:Any})

Returns a list of image pipelines.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: Use the following filters to streamline results:    description
  distributionConfigurationArn     imageRecipeArn     infrastructureConfigurationArn     name
      status
- `"maxResults"`: The maximum items to return in a request.
- `"nextToken"`: A token to specify where to start paginating. This is the nextToken from a
  previously truncated response.
"""
function list_image_pipelines(; aws_config::AbstractAWSConfig=current_aws_config())
    return imagebuilder(
        "POST",
        "/ListImagePipelines";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_image_pipelines(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return imagebuilder(
        "POST",
        "/ListImagePipelines",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_image_recipes()
    list_image_recipes(params::Dict{String,<:Any})

Returns a list of image recipes.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: Use the following filters to streamline results:    name     parentImage
  platform
- `"maxResults"`: The maximum items to return in a request.
- `"nextToken"`: A token to specify where to start paginating. This is the nextToken from a
  previously truncated response.
- `"owner"`: The owner defines which image recipes you want to list. By default, this
  request will only show image recipes owned by your account. You can use this field to
  specify if you want to view image recipes owned by yourself, by Amazon, or those image
  recipes that have been shared with you by other customers.
"""
function list_image_recipes(; aws_config::AbstractAWSConfig=current_aws_config())
    return imagebuilder(
        "POST", "/ListImageRecipes"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_image_recipes(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return imagebuilder(
        "POST",
        "/ListImageRecipes",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_image_scan_finding_aggregations()
    list_image_scan_finding_aggregations(params::Dict{String,<:Any})

Returns a list of image scan aggregations for your account. You can filter by the type of
key that Image Builder uses to group results. For example, if you want to get a list of
findings by severity level for one of your pipelines, you might specify your pipeline with
the imagePipelineArn filter. If you don't specify a filter, Image Builder returns an
aggregation for your account. To streamline results, you can use the following filters in
your request:    accountId     imageBuildVersionArn     imagePipelineArn
vulnerabilityId

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filter"`:
- `"nextToken"`: A token to specify where to start paginating. This is the nextToken from a
  previously truncated response.
"""
function list_image_scan_finding_aggregations(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return imagebuilder(
        "POST",
        "/ListImageScanFindingAggregations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_image_scan_finding_aggregations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return imagebuilder(
        "POST",
        "/ListImageScanFindingAggregations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_image_scan_findings()
    list_image_scan_findings(params::Dict{String,<:Any})

Returns a list of image scan findings for your account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: An array of name value pairs that you can use to filter your results. You
  can use the following filters to streamline results:    imageBuildVersionArn
  imagePipelineArn     vulnerabilityId     severity    If you don't request a filter, then
  all findings in your account are listed.
- `"maxResults"`: The maximum items to return in a request.
- `"nextToken"`: A token to specify where to start paginating. This is the nextToken from a
  previously truncated response.
"""
function list_image_scan_findings(; aws_config::AbstractAWSConfig=current_aws_config())
    return imagebuilder(
        "POST",
        "/ListImageScanFindings";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_image_scan_findings(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return imagebuilder(
        "POST",
        "/ListImageScanFindings",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_images()
    list_images(params::Dict{String,<:Any})

Returns the list of images that you have access to. Newly created images can take up to two
minutes to appear in the ListImages API Results.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"byName"`: Requests a list of images with a specific recipe name.
- `"filters"`: Use the following filters to streamline results:    name     osVersion
  platform     type     version
- `"includeDeprecated"`: Includes deprecated images in the response list.
- `"maxResults"`: The maximum items to return in a request.
- `"nextToken"`: A token to specify where to start paginating. This is the nextToken from a
  previously truncated response.
- `"owner"`: The owner defines which images you want to list. By default, this request will
  only show images owned by your account. You can use this field to specify if you want to
  view images owned by yourself, by Amazon, or those images that have been shared with you by
  other customers.
"""
function list_images(; aws_config::AbstractAWSConfig=current_aws_config())
    return imagebuilder(
        "POST", "/ListImages"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_images(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return imagebuilder(
        "POST",
        "/ListImages",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_infrastructure_configurations()
    list_infrastructure_configurations(params::Dict{String,<:Any})

Returns a list of infrastructure configurations.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: You can filter on name to streamline results.
- `"maxResults"`: The maximum items to return in a request.
- `"nextToken"`: A token to specify where to start paginating. This is the nextToken from a
  previously truncated response.
"""
function list_infrastructure_configurations(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return imagebuilder(
        "POST",
        "/ListInfrastructureConfigurations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_infrastructure_configurations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return imagebuilder(
        "POST",
        "/ListInfrastructureConfigurations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_lifecycle_execution_resources(lifecycle_execution_id)
    list_lifecycle_execution_resources(lifecycle_execution_id, params::Dict{String,<:Any})

List resources that the runtime instance of the image lifecycle identified for lifecycle
actions.

# Arguments
- `lifecycle_execution_id`: Use the unique identifier for a runtime instance of the
  lifecycle policy to get runtime details.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum items to return in a request.
- `"nextToken"`: A token to specify where to start paginating. This is the nextToken from a
  previously truncated response.
- `"parentResourceId"`: You can leave this empty to get a list of Image Builder resources
  that were identified for lifecycle actions. To get a list of associated resources that are
  impacted for an individual resource (the parent), specify its Amazon Resource Name (ARN).
  Associated resources are produced from your image and distributed when you run a build,
  such as AMIs or container images stored in ECR repositories.
"""
function list_lifecycle_execution_resources(
    lifecycleExecutionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return imagebuilder(
        "POST",
        "/ListLifecycleExecutionResources",
        Dict{String,Any}("lifecycleExecutionId" => lifecycleExecutionId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_lifecycle_execution_resources(
    lifecycleExecutionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "POST",
        "/ListLifecycleExecutionResources",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("lifecycleExecutionId" => lifecycleExecutionId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_lifecycle_executions(resource_arn)
    list_lifecycle_executions(resource_arn, params::Dict{String,<:Any})

Get the lifecycle runtime history for the specified resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource for which to get a list of
  lifecycle runtime instances.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum items to return in a request.
- `"nextToken"`: A token to specify where to start paginating. This is the nextToken from a
  previously truncated response.
"""
function list_lifecycle_executions(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return imagebuilder(
        "POST",
        "/ListLifecycleExecutions",
        Dict{String,Any}("resourceArn" => resourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_lifecycle_executions(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "POST",
        "/ListLifecycleExecutions",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceArn" => resourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_lifecycle_policies()
    list_lifecycle_policies(params::Dict{String,<:Any})

Get a list of lifecycle policies in your Amazon Web Services account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: Streamline results based on one of the following values: Name, Status.
- `"maxResults"`: The maximum items to return in a request.
- `"nextToken"`: A token to specify where to start paginating. This is the nextToken from a
  previously truncated response.
"""
function list_lifecycle_policies(; aws_config::AbstractAWSConfig=current_aws_config())
    return imagebuilder(
        "POST",
        "/ListLifecyclePolicies";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_lifecycle_policies(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return imagebuilder(
        "POST",
        "/ListLifecyclePolicies",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Returns the list of tags for the specified resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource whose tags you want to
  retrieve.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return imagebuilder(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_waiting_workflow_steps()
    list_waiting_workflow_steps(params::Dict{String,<:Any})

Get a list of workflow steps that are waiting for action for workflows in your Amazon Web
Services account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum items to return in a request.
- `"nextToken"`: A token to specify where to start paginating. This is the nextToken from a
  previously truncated response.
"""
function list_waiting_workflow_steps(; aws_config::AbstractAWSConfig=current_aws_config())
    return imagebuilder(
        "POST",
        "/ListWaitingWorkflowSteps";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_waiting_workflow_steps(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return imagebuilder(
        "POST",
        "/ListWaitingWorkflowSteps",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_workflow_build_versions(workflow_version_arn)
    list_workflow_build_versions(workflow_version_arn, params::Dict{String,<:Any})

Returns a list of build versions for a specific workflow resource.

# Arguments
- `workflow_version_arn`: The Amazon Resource Name (ARN) of the workflow resource for which
  to get a list of build versions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum items to return in a request.
- `"nextToken"`: A token to specify where to start paginating. This is the nextToken from a
  previously truncated response.
"""
function list_workflow_build_versions(
    workflowVersionArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return imagebuilder(
        "POST",
        "/ListWorkflowBuildVersions",
        Dict{String,Any}("workflowVersionArn" => workflowVersionArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_workflow_build_versions(
    workflowVersionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "POST",
        "/ListWorkflowBuildVersions",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("workflowVersionArn" => workflowVersionArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_workflow_executions(image_build_version_arn)
    list_workflow_executions(image_build_version_arn, params::Dict{String,<:Any})

Returns a list of workflow runtime instance metadata objects for a specific image build
version.

# Arguments
- `image_build_version_arn`: List all workflow runtime instances for the specified image
  build version resource ARN.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum items to return in a request.
- `"nextToken"`: A token to specify where to start paginating. This is the nextToken from a
  previously truncated response.
"""
function list_workflow_executions(
    imageBuildVersionArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return imagebuilder(
        "POST",
        "/ListWorkflowExecutions",
        Dict{String,Any}("imageBuildVersionArn" => imageBuildVersionArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_workflow_executions(
    imageBuildVersionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "POST",
        "/ListWorkflowExecutions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("imageBuildVersionArn" => imageBuildVersionArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_workflow_step_executions(workflow_execution_id)
    list_workflow_step_executions(workflow_execution_id, params::Dict{String,<:Any})

Returns runtime data for each step in a runtime instance of the workflow that you specify
in the request.

# Arguments
- `workflow_execution_id`: The unique identifier that Image Builder assigned to keep track
  of runtime details when it ran the workflow.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum items to return in a request.
- `"nextToken"`: A token to specify where to start paginating. This is the nextToken from a
  previously truncated response.
"""
function list_workflow_step_executions(
    workflowExecutionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return imagebuilder(
        "POST",
        "/ListWorkflowStepExecutions",
        Dict{String,Any}("workflowExecutionId" => workflowExecutionId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_workflow_step_executions(
    workflowExecutionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "POST",
        "/ListWorkflowStepExecutions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("workflowExecutionId" => workflowExecutionId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_workflows()
    list_workflows(params::Dict{String,<:Any})

Lists workflow build versions based on filtering parameters.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"byName"`: Specify all or part of the workflow name to streamline results.
- `"filters"`: Used to streamline search results.
- `"maxResults"`: The maximum items to return in a request.
- `"nextToken"`: A token to specify where to start paginating. This is the nextToken from a
  previously truncated response.
- `"owner"`: Used to get a list of workflow build version filtered by the identity of the
  creator.
"""
function list_workflows(; aws_config::AbstractAWSConfig=current_aws_config())
    return imagebuilder(
        "POST", "/ListWorkflows"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_workflows(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return imagebuilder(
        "POST",
        "/ListWorkflows",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_component_policy(component_arn, policy)
    put_component_policy(component_arn, policy, params::Dict{String,<:Any})

Applies a policy to a component. We recommend that you call the RAM API CreateResourceShare
to share resources. If you call the Image Builder API PutComponentPolicy, you must also
call the RAM API PromoteResourceShareCreatedFromPolicy in order for the resource to be
visible to all principals with whom the resource is shared.

# Arguments
- `component_arn`: The Amazon Resource Name (ARN) of the component that this policy should
  be applied to.
- `policy`: The policy to apply.

"""
function put_component_policy(
    componentArn, policy; aws_config::AbstractAWSConfig=current_aws_config()
)
    return imagebuilder(
        "PUT",
        "/PutComponentPolicy",
        Dict{String,Any}("componentArn" => componentArn, "policy" => policy);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_component_policy(
    componentArn,
    policy,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "PUT",
        "/PutComponentPolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("componentArn" => componentArn, "policy" => policy),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_container_recipe_policy(container_recipe_arn, policy)
    put_container_recipe_policy(container_recipe_arn, policy, params::Dict{String,<:Any})

Applies a policy to a container image. We recommend that you call the RAM API
CreateResourceShare
(https://docs.aws.amazon.com//ram/latest/APIReference/API_CreateResourceShare.html) to
share resources. If you call the Image Builder API PutContainerImagePolicy, you must also
call the RAM API PromoteResourceShareCreatedFromPolicy
(https://docs.aws.amazon.com//ram/latest/APIReference/API_PromoteResourceShareCreatedFromPol
icy.html) in order for the resource to be visible to all principals with whom the resource
is shared.

# Arguments
- `container_recipe_arn`: The Amazon Resource Name (ARN) of the container recipe that this
  policy should be applied to.
- `policy`: The policy to apply to the container recipe.

"""
function put_container_recipe_policy(
    containerRecipeArn, policy; aws_config::AbstractAWSConfig=current_aws_config()
)
    return imagebuilder(
        "PUT",
        "/PutContainerRecipePolicy",
        Dict{String,Any}("containerRecipeArn" => containerRecipeArn, "policy" => policy);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_container_recipe_policy(
    containerRecipeArn,
    policy,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "PUT",
        "/PutContainerRecipePolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "containerRecipeArn" => containerRecipeArn, "policy" => policy
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_image_policy(image_arn, policy)
    put_image_policy(image_arn, policy, params::Dict{String,<:Any})

Applies a policy to an image. We recommend that you call the RAM API CreateResourceShare to
share resources. If you call the Image Builder API PutImagePolicy, you must also call the
RAM API PromoteResourceShareCreatedFromPolicy in order for the resource to be visible to
all principals with whom the resource is shared.

# Arguments
- `image_arn`: The Amazon Resource Name (ARN) of the image that this policy should be
  applied to.
- `policy`: The policy to apply.

"""
function put_image_policy(
    imageArn, policy; aws_config::AbstractAWSConfig=current_aws_config()
)
    return imagebuilder(
        "PUT",
        "/PutImagePolicy",
        Dict{String,Any}("imageArn" => imageArn, "policy" => policy);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_image_policy(
    imageArn,
    policy,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "PUT",
        "/PutImagePolicy",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("imageArn" => imageArn, "policy" => policy), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_image_recipe_policy(image_recipe_arn, policy)
    put_image_recipe_policy(image_recipe_arn, policy, params::Dict{String,<:Any})

Applies a policy to an image recipe. We recommend that you call the RAM API
CreateResourceShare to share resources. If you call the Image Builder API
PutImageRecipePolicy, you must also call the RAM API PromoteResourceShareCreatedFromPolicy
in order for the resource to be visible to all principals with whom the resource is shared.

# Arguments
- `image_recipe_arn`: The Amazon Resource Name (ARN) of the image recipe that this policy
  should be applied to.
- `policy`: The policy to apply.

"""
function put_image_recipe_policy(
    imageRecipeArn, policy; aws_config::AbstractAWSConfig=current_aws_config()
)
    return imagebuilder(
        "PUT",
        "/PutImageRecipePolicy",
        Dict{String,Any}("imageRecipeArn" => imageRecipeArn, "policy" => policy);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_image_recipe_policy(
    imageRecipeArn,
    policy,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "PUT",
        "/PutImageRecipePolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("imageRecipeArn" => imageRecipeArn, "policy" => policy),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    send_workflow_step_action(action, client_token, image_build_version_arn, step_execution_id)
    send_workflow_step_action(action, client_token, image_build_version_arn, step_execution_id, params::Dict{String,<:Any})

Pauses or resumes image creation when the associated workflow runs a WaitForAction step.

# Arguments
- `action`: The action for the image creation process to take while a workflow
  WaitForAction step waits for an asynchronous action to complete.
- `client_token`: Unique, case-sensitive identifier you provide to ensure idempotency of
  the request. For more information, see Ensuring idempotency in the Amazon EC2 API Reference.
- `image_build_version_arn`: The Amazon Resource Name (ARN) of the image build version to
  send action for.
- `step_execution_id`: Uniquely identifies the workflow step that sent the step action.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"reason"`: The reason why this action is sent.
"""
function send_workflow_step_action(
    action,
    clientToken,
    imageBuildVersionArn,
    stepExecutionId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "PUT",
        "/SendWorkflowStepAction",
        Dict{String,Any}(
            "action" => action,
            "clientToken" => clientToken,
            "imageBuildVersionArn" => imageBuildVersionArn,
            "stepExecutionId" => stepExecutionId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function send_workflow_step_action(
    action,
    clientToken,
    imageBuildVersionArn,
    stepExecutionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "PUT",
        "/SendWorkflowStepAction",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "action" => action,
                    "clientToken" => clientToken,
                    "imageBuildVersionArn" => imageBuildVersionArn,
                    "stepExecutionId" => stepExecutionId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_image_pipeline_execution(client_token, image_pipeline_arn)
    start_image_pipeline_execution(client_token, image_pipeline_arn, params::Dict{String,<:Any})

Manually triggers a pipeline to create an image.

# Arguments
- `client_token`: Unique, case-sensitive identifier you provide to ensure idempotency of
  the request. For more information, see Ensuring idempotency in the Amazon EC2 API Reference.
- `image_pipeline_arn`: The Amazon Resource Name (ARN) of the image pipeline that you want
  to manually invoke.

"""
function start_image_pipeline_execution(
    clientToken, imagePipelineArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return imagebuilder(
        "PUT",
        "/StartImagePipelineExecution",
        Dict{String,Any}(
            "clientToken" => clientToken, "imagePipelineArn" => imagePipelineArn
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_image_pipeline_execution(
    clientToken,
    imagePipelineArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "PUT",
        "/StartImagePipelineExecution",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "clientToken" => clientToken, "imagePipelineArn" => imagePipelineArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_resource_state_update(client_token, resource_arn, state)
    start_resource_state_update(client_token, resource_arn, state, params::Dict{String,<:Any})

Begin asynchronous resource state update for lifecycle changes to the specified image
resources.

# Arguments
- `client_token`: Unique, case-sensitive identifier you provide to ensure idempotency of
  the request. For more information, see Ensuring idempotency in the Amazon EC2 API Reference.
- `resource_arn`: The ARN of the Image Builder resource that is updated. The state update
  might also impact associated resources.
- `state`: Indicates the lifecycle action to take for this request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"exclusionRules"`: Skip action on the image resource and associated resources if
  specified exclusion rules are met.
- `"executionRole"`: The name or Amazon Resource Name (ARN) of the IAM role that’s used
  to update image state.
- `"includeResources"`: A list of image resources to update state for.
- `"updateAt"`: The timestamp that indicates when resources are updated by a lifecycle
  action.
"""
function start_resource_state_update(
    clientToken, resourceArn, state; aws_config::AbstractAWSConfig=current_aws_config()
)
    return imagebuilder(
        "PUT",
        "/StartResourceStateUpdate",
        Dict{String,Any}(
            "clientToken" => clientToken, "resourceArn" => resourceArn, "state" => state
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_resource_state_update(
    clientToken,
    resourceArn,
    state,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "PUT",
        "/StartResourceStateUpdate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "clientToken" => clientToken,
                    "resourceArn" => resourceArn,
                    "state" => state,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds a tag to a resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource that you want to tag.
- `tags`: The tags to apply to the resource.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return imagebuilder(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes a tag from a resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource that you want to untag.
- `tag_keys`: The tag keys to remove from the resource.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return imagebuilder(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_distribution_configuration(client_token, distribution_configuration_arn, distributions)
    update_distribution_configuration(client_token, distribution_configuration_arn, distributions, params::Dict{String,<:Any})

Updates a new distribution configuration. Distribution configurations define and configure
the outputs of your pipeline.

# Arguments
- `client_token`: Unique, case-sensitive identifier you provide to ensure idempotency of
  the request. For more information, see Ensuring idempotency in the Amazon EC2 API Reference.
- `distribution_configuration_arn`: The Amazon Resource Name (ARN) of the distribution
  configuration that you want to update.
- `distributions`: The distributions of the distribution configuration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description of the distribution configuration.
"""
function update_distribution_configuration(
    clientToken,
    distributionConfigurationArn,
    distributions;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "PUT",
        "/UpdateDistributionConfiguration",
        Dict{String,Any}(
            "clientToken" => clientToken,
            "distributionConfigurationArn" => distributionConfigurationArn,
            "distributions" => distributions,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_distribution_configuration(
    clientToken,
    distributionConfigurationArn,
    distributions,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "PUT",
        "/UpdateDistributionConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "clientToken" => clientToken,
                    "distributionConfigurationArn" => distributionConfigurationArn,
                    "distributions" => distributions,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_image_pipeline(client_token, image_pipeline_arn, infrastructure_configuration_arn)
    update_image_pipeline(client_token, image_pipeline_arn, infrastructure_configuration_arn, params::Dict{String,<:Any})

Updates an image pipeline. Image pipelines enable you to automate the creation and
distribution of images. You must specify exactly one recipe for your image, using either a
containerRecipeArn or an imageRecipeArn.  UpdateImagePipeline does not support selective
updates for the pipeline. You must specify all of the required properties in the update
request, not just the properties that have changed.

# Arguments
- `client_token`: Unique, case-sensitive identifier you provide to ensure idempotency of
  the request. For more information, see Ensuring idempotency in the Amazon EC2 API Reference.
- `image_pipeline_arn`: The Amazon Resource Name (ARN) of the image pipeline that you want
  to update.
- `infrastructure_configuration_arn`: The Amazon Resource Name (ARN) of the infrastructure
  configuration that Image Builder uses to build images that this image pipeline has updated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"containerRecipeArn"`: The Amazon Resource Name (ARN) of the container pipeline to
  update.
- `"description"`: The description of the image pipeline.
- `"distributionConfigurationArn"`: The Amazon Resource Name (ARN) of the distribution
  configuration that Image Builder uses to configure and distribute images that this image
  pipeline has updated.
- `"enhancedImageMetadataEnabled"`: Collects additional information about the image being
  created, including the operating system (OS) version and package list. This information is
  used to enhance the overall experience of using EC2 Image Builder. Enabled by default.
- `"executionRole"`: The name or Amazon Resource Name (ARN) for the IAM role you create
  that grants Image Builder access to perform workflow actions.
- `"imageRecipeArn"`: The Amazon Resource Name (ARN) of the image recipe that will be used
  to configure images updated by this image pipeline.
- `"imageScanningConfiguration"`: Contains settings for vulnerability scans.
- `"imageTestsConfiguration"`: The image test configuration of the image pipeline.
- `"schedule"`: The schedule of the image pipeline.
- `"status"`: The status of the image pipeline.
- `"workflows"`: Contains the workflows to run for the pipeline.
"""
function update_image_pipeline(
    clientToken,
    imagePipelineArn,
    infrastructureConfigurationArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "PUT",
        "/UpdateImagePipeline",
        Dict{String,Any}(
            "clientToken" => clientToken,
            "imagePipelineArn" => imagePipelineArn,
            "infrastructureConfigurationArn" => infrastructureConfigurationArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_image_pipeline(
    clientToken,
    imagePipelineArn,
    infrastructureConfigurationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "PUT",
        "/UpdateImagePipeline",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "clientToken" => clientToken,
                    "imagePipelineArn" => imagePipelineArn,
                    "infrastructureConfigurationArn" => infrastructureConfigurationArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_infrastructure_configuration(client_token, infrastructure_configuration_arn, instance_profile_name)
    update_infrastructure_configuration(client_token, infrastructure_configuration_arn, instance_profile_name, params::Dict{String,<:Any})

Updates a new infrastructure configuration. An infrastructure configuration defines the
environment in which your image will be built and tested.

# Arguments
- `client_token`: Unique, case-sensitive identifier you provide to ensure idempotency of
  the request. For more information, see Ensuring idempotency in the Amazon EC2 API Reference.
- `infrastructure_configuration_arn`: The Amazon Resource Name (ARN) of the infrastructure
  configuration that you want to update.
- `instance_profile_name`: The instance profile to associate with the instance used to
  customize your Amazon EC2 AMI.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description of the infrastructure configuration.
- `"instanceMetadataOptions"`: The instance metadata options that you can set for the HTTP
  requests that pipeline builds use to launch EC2 build and test instances. For more
  information about instance metadata options, see one of the following links:    Configure
  the instance metadata options in the  Amazon EC2 User Guide  for Linux instances.
  Configure the instance metadata options in the  Amazon EC2 Windows Guide  for Windows
  instances.
- `"instanceTypes"`: The instance types of the infrastructure configuration. You can
  specify one or more instance types to use for this build. The service will pick one of
  these instance types based on availability.
- `"keyPair"`: The key pair of the infrastructure configuration. You can use this to log on
  to and debug the instance used to create your image.
- `"logging"`: The logging configuration of the infrastructure configuration.
- `"resourceTags"`: The tags attached to the resource created by Image Builder.
- `"securityGroupIds"`: The security group IDs to associate with the instance used to
  customize your Amazon EC2 AMI.
- `"snsTopicArn"`: The Amazon Resource Name (ARN) for the SNS topic to which we send image
  build event notifications.  EC2 Image Builder is unable to send notifications to SNS topics
  that are encrypted using keys from other accounts. The key that is used to encrypt the SNS
  topic must reside in the account that the Image Builder service runs under.
- `"subnetId"`: The subnet ID to place the instance used to customize your Amazon EC2 AMI
  in.
- `"terminateInstanceOnFailure"`: The terminate instance on failure setting of the
  infrastructure configuration. Set to false if you want Image Builder to retain the instance
  used to configure your AMI if the build or test phase of your workflow fails.
"""
function update_infrastructure_configuration(
    clientToken,
    infrastructureConfigurationArn,
    instanceProfileName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "PUT",
        "/UpdateInfrastructureConfiguration",
        Dict{String,Any}(
            "clientToken" => clientToken,
            "infrastructureConfigurationArn" => infrastructureConfigurationArn,
            "instanceProfileName" => instanceProfileName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_infrastructure_configuration(
    clientToken,
    infrastructureConfigurationArn,
    instanceProfileName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "PUT",
        "/UpdateInfrastructureConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "clientToken" => clientToken,
                    "infrastructureConfigurationArn" => infrastructureConfigurationArn,
                    "instanceProfileName" => instanceProfileName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_lifecycle_policy(client_token, execution_role, lifecycle_policy_arn, policy_details, resource_selection, resource_type)
    update_lifecycle_policy(client_token, execution_role, lifecycle_policy_arn, policy_details, resource_selection, resource_type, params::Dict{String,<:Any})

Update the specified lifecycle policy.

# Arguments
- `client_token`: Unique, case-sensitive identifier you provide to ensure idempotency of
  the request. For more information, see Ensuring idempotency in the Amazon EC2 API Reference.
- `execution_role`: The name or Amazon Resource Name (ARN) of the IAM role that Image
  Builder uses to update the lifecycle policy.
- `lifecycle_policy_arn`: The Amazon Resource Name (ARN) of the lifecycle policy resource.
- `policy_details`: The configuration details for a lifecycle policy resource.
- `resource_selection`: Selection criteria for resources that the lifecycle policy applies
  to.
- `resource_type`: The type of image resource that the lifecycle policy applies to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: Optional description for the lifecycle policy.
- `"status"`: Indicates whether the lifecycle policy resource is enabled.
"""
function update_lifecycle_policy(
    clientToken,
    executionRole,
    lifecyclePolicyArn,
    policyDetails,
    resourceSelection,
    resourceType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "PUT",
        "/UpdateLifecyclePolicy",
        Dict{String,Any}(
            "clientToken" => clientToken,
            "executionRole" => executionRole,
            "lifecyclePolicyArn" => lifecyclePolicyArn,
            "policyDetails" => policyDetails,
            "resourceSelection" => resourceSelection,
            "resourceType" => resourceType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_lifecycle_policy(
    clientToken,
    executionRole,
    lifecyclePolicyArn,
    policyDetails,
    resourceSelection,
    resourceType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return imagebuilder(
        "PUT",
        "/UpdateLifecyclePolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "clientToken" => clientToken,
                    "executionRole" => executionRole,
                    "lifecyclePolicyArn" => lifecyclePolicyArn,
                    "policyDetails" => policyDetails,
                    "resourceSelection" => resourceSelection,
                    "resourceType" => resourceType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: dax
using AWS.Compat
using AWS.UUIDs

"""
    create_cluster(cluster_name, iam_role_arn, node_type, replication_factor)
    create_cluster(cluster_name, iam_role_arn, node_type, replication_factor, params::Dict{String,<:Any})

Creates a DAX cluster. All nodes in the cluster run the same DAX caching software.

# Arguments
- `cluster_name`: The cluster identifier. This parameter is stored as a lowercase string.
  Constraints:    A name must contain from 1 to 20 alphanumeric characters or hyphens.   The
  first character must be a letter.   A name cannot end with a hyphen or contain two
  consecutive hyphens.
- `iam_role_arn`: A valid Amazon Resource Name (ARN) that identifies an IAM role. At
  runtime, DAX will assume this role and use the role's permissions to access DynamoDB on
  your behalf.
- `node_type`: The compute and memory capacity of the nodes in the cluster.
- `replication_factor`: The number of nodes in the DAX cluster. A replication factor of 1
  will create a single-node cluster, without any read replicas. For additional fault
  tolerance, you can create a multiple node cluster with one or more read replicas. To do
  this, set ReplicationFactor to a number between 3 (one primary and two read replicas) and
  10 (one primary and nine read replicas). If the AvailabilityZones parameter is provided,
  its length must equal the ReplicationFactor.  AWS recommends that you have at least two
  read replicas per cluster.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AvailabilityZones"`: The Availability Zones (AZs) in which the cluster nodes will
  reside after the cluster has been created or updated. If provided, the length of this list
  must equal the ReplicationFactor parameter. If you omit this parameter, DAX will spread the
  nodes across Availability Zones for the highest availability.
- `"ClusterEndpointEncryptionType"`: The type of encryption the cluster's endpoint should
  support. Values are:    NONE for no encryption    TLS for Transport Layer Security
- `"Description"`: A description of the cluster.
- `"NotificationTopicArn"`: The Amazon Resource Name (ARN) of the Amazon SNS topic to which
  notifications will be sent.  The Amazon SNS topic owner must be same as the DAX cluster
  owner.
- `"ParameterGroupName"`: The parameter group to be associated with the DAX cluster.
- `"PreferredMaintenanceWindow"`: Specifies the weekly time range during which maintenance
  on the DAX cluster is performed. It is specified as a range in the format
  ddd:hh24:mi-ddd:hh24:mi (24H Clock UTC). The minimum maintenance window is a 60 minute
  period. Valid values for ddd are:    sun     mon     tue     wed     thu     fri     sat
  Example: sun:05:00-sun:09:00   If you don't specify a preferred maintenance window when you
  create or modify a cache cluster, DAX assigns a 60-minute maintenance window on a randomly
  selected day of the week.
- `"SSESpecification"`: Represents the settings used to enable server-side encryption on
  the cluster.
- `"SecurityGroupIds"`: A list of security group IDs to be assigned to each node in the DAX
  cluster. (Each of the security group ID is system-generated.) If this parameter is not
  specified, DAX assigns the default VPC security group to each node.
- `"SubnetGroupName"`: The name of the subnet group to be used for the replication group.
  DAX clusters can only run in an Amazon VPC environment. All of the subnets that you specify
  in a subnet group must exist in the same VPC.
- `"Tags"`: A set of tags to associate with the DAX cluster.
"""
function create_cluster(
    ClusterName,
    IamRoleArn,
    NodeType,
    ReplicationFactor;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dax(
        "CreateCluster",
        Dict{String,Any}(
            "ClusterName" => ClusterName,
            "IamRoleArn" => IamRoleArn,
            "NodeType" => NodeType,
            "ReplicationFactor" => ReplicationFactor,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_cluster(
    ClusterName,
    IamRoleArn,
    NodeType,
    ReplicationFactor,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dax(
        "CreateCluster",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClusterName" => ClusterName,
                    "IamRoleArn" => IamRoleArn,
                    "NodeType" => NodeType,
                    "ReplicationFactor" => ReplicationFactor,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_parameter_group(parameter_group_name)
    create_parameter_group(parameter_group_name, params::Dict{String,<:Any})

Creates a new parameter group. A parameter group is a collection of parameters that you
apply to all of the nodes in a DAX cluster.

# Arguments
- `parameter_group_name`: The name of the parameter group to apply to all of the clusters
  in this replication group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description of the parameter group.
"""
function create_parameter_group(
    ParameterGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dax(
        "CreateParameterGroup",
        Dict{String,Any}("ParameterGroupName" => ParameterGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_parameter_group(
    ParameterGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dax(
        "CreateParameterGroup",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ParameterGroupName" => ParameterGroupName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_subnet_group(subnet_group_name, subnet_ids)
    create_subnet_group(subnet_group_name, subnet_ids, params::Dict{String,<:Any})

Creates a new subnet group.

# Arguments
- `subnet_group_name`: A name for the subnet group. This value is stored as a lowercase
  string.
- `subnet_ids`: A list of VPC subnet IDs for the subnet group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description for the subnet group
"""
function create_subnet_group(
    SubnetGroupName, SubnetIds; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dax(
        "CreateSubnetGroup",
        Dict{String,Any}("SubnetGroupName" => SubnetGroupName, "SubnetIds" => SubnetIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_subnet_group(
    SubnetGroupName,
    SubnetIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dax(
        "CreateSubnetGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "SubnetGroupName" => SubnetGroupName, "SubnetIds" => SubnetIds
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    decrease_replication_factor(cluster_name, new_replication_factor)
    decrease_replication_factor(cluster_name, new_replication_factor, params::Dict{String,<:Any})

Removes one or more nodes from a DAX cluster.  You cannot use DecreaseReplicationFactor to
remove the last node in a DAX cluster. If you need to do this, use DeleteCluster instead.

# Arguments
- `cluster_name`: The name of the DAX cluster from which you want to remove nodes.
- `new_replication_factor`: The new number of nodes for the DAX cluster.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AvailabilityZones"`: The Availability Zone(s) from which to remove nodes.
- `"NodeIdsToRemove"`: The unique identifiers of the nodes to be removed from the cluster.
"""
function decrease_replication_factor(
    ClusterName, NewReplicationFactor; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dax(
        "DecreaseReplicationFactor",
        Dict{String,Any}(
            "ClusterName" => ClusterName, "NewReplicationFactor" => NewReplicationFactor
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function decrease_replication_factor(
    ClusterName,
    NewReplicationFactor,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dax(
        "DecreaseReplicationFactor",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClusterName" => ClusterName,
                    "NewReplicationFactor" => NewReplicationFactor,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_cluster(cluster_name)
    delete_cluster(cluster_name, params::Dict{String,<:Any})

Deletes a previously provisioned DAX cluster. DeleteCluster deletes all associated nodes,
node endpoints and the DAX cluster itself. When you receive a successful response from this
action, DAX immediately begins deleting the cluster; you cannot cancel or revert this
action.

# Arguments
- `cluster_name`: The name of the cluster to be deleted.

"""
function delete_cluster(ClusterName; aws_config::AbstractAWSConfig=current_aws_config())
    return dax(
        "DeleteCluster",
        Dict{String,Any}("ClusterName" => ClusterName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_cluster(
    ClusterName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dax(
        "DeleteCluster",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ClusterName" => ClusterName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_parameter_group(parameter_group_name)
    delete_parameter_group(parameter_group_name, params::Dict{String,<:Any})

Deletes the specified parameter group. You cannot delete a parameter group if it is
associated with any DAX clusters.

# Arguments
- `parameter_group_name`: The name of the parameter group to delete.

"""
function delete_parameter_group(
    ParameterGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dax(
        "DeleteParameterGroup",
        Dict{String,Any}("ParameterGroupName" => ParameterGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_parameter_group(
    ParameterGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dax(
        "DeleteParameterGroup",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ParameterGroupName" => ParameterGroupName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_subnet_group(subnet_group_name)
    delete_subnet_group(subnet_group_name, params::Dict{String,<:Any})

Deletes a subnet group.  You cannot delete a subnet group if it is associated with any DAX
clusters.

# Arguments
- `subnet_group_name`: The name of the subnet group to delete.

"""
function delete_subnet_group(
    SubnetGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dax(
        "DeleteSubnetGroup",
        Dict{String,Any}("SubnetGroupName" => SubnetGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_subnet_group(
    SubnetGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dax(
        "DeleteSubnetGroup",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("SubnetGroupName" => SubnetGroupName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_clusters()
    describe_clusters(params::Dict{String,<:Any})

Returns information about all provisioned DAX clusters if no cluster identifier is
specified, or about a specific DAX cluster if a cluster identifier is supplied. If the
cluster is in the CREATING state, only cluster level information will be displayed until
all of the nodes are successfully provisioned. If the cluster is in the DELETING state,
only cluster level information will be displayed. If nodes are currently being added to the
DAX cluster, node endpoint information and creation time for the additional nodes will not
be displayed until they are completely provisioned. When the DAX cluster state is
available, the cluster is ready for use. If nodes are currently being removed from the DAX
cluster, no endpoint information for the removed nodes is displayed.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClusterNames"`: The names of the DAX clusters being described.
- `"MaxResults"`: The maximum number of results to include in the response. If more results
  exist than the specified MaxResults value, a token is included in the response so that the
  remaining results can be retrieved. The value for MaxResults must be between 20 and 100.
- `"NextToken"`: An optional token returned from a prior request. Use this token for
  pagination of results from this action. If this parameter is specified, the response
  includes only results beyond the token, up to the value specified by MaxResults.
"""
function describe_clusters(; aws_config::AbstractAWSConfig=current_aws_config())
    return dax("DescribeClusters"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function describe_clusters(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dax(
        "DescribeClusters", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_default_parameters()
    describe_default_parameters(params::Dict{String,<:Any})

Returns the default system parameter information for the DAX caching software.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to include in the response. If more results
  exist than the specified MaxResults value, a token is included in the response so that the
  remaining results can be retrieved. The value for MaxResults must be between 20 and 100.
- `"NextToken"`: An optional token returned from a prior request. Use this token for
  pagination of results from this action. If this parameter is specified, the response
  includes only results beyond the token, up to the value specified by MaxResults.
"""
function describe_default_parameters(; aws_config::AbstractAWSConfig=current_aws_config())
    return dax(
        "DescribeDefaultParameters"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_default_parameters(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dax(
        "DescribeDefaultParameters",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_events()
    describe_events(params::Dict{String,<:Any})

Returns events related to DAX clusters and parameter groups. You can obtain events specific
to a particular DAX cluster or parameter group by providing the name as a parameter. By
default, only the events occurring within the last 24 hours are returned; however, you can
retrieve up to 14 days' worth of events if necessary.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Duration"`: The number of minutes' worth of events to retrieve.
- `"EndTime"`: The end of the time interval for which to retrieve events, specified in ISO
  8601 format.
- `"MaxResults"`: The maximum number of results to include in the response. If more results
  exist than the specified MaxResults value, a token is included in the response so that the
  remaining results can be retrieved. The value for MaxResults must be between 20 and 100.
- `"NextToken"`: An optional token returned from a prior request. Use this token for
  pagination of results from this action. If this parameter is specified, the response
  includes only results beyond the token, up to the value specified by MaxResults.
- `"SourceName"`: The identifier of the event source for which events will be returned. If
  not specified, then all sources are included in the response.
- `"SourceType"`: The event source to retrieve events for. If no value is specified, all
  events are returned.
- `"StartTime"`: The beginning of the time interval to retrieve events for, specified in
  ISO 8601 format.
"""
function describe_events(; aws_config::AbstractAWSConfig=current_aws_config())
    return dax("DescribeEvents"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function describe_events(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dax(
        "DescribeEvents", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_parameter_groups()
    describe_parameter_groups(params::Dict{String,<:Any})

Returns a list of parameter group descriptions. If a parameter group name is specified, the
list will contain only the descriptions for that group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to include in the response. If more results
  exist than the specified MaxResults value, a token is included in the response so that the
  remaining results can be retrieved. The value for MaxResults must be between 20 and 100.
- `"NextToken"`: An optional token returned from a prior request. Use this token for
  pagination of results from this action. If this parameter is specified, the response
  includes only results beyond the token, up to the value specified by MaxResults.
- `"ParameterGroupNames"`: The names of the parameter groups.
"""
function describe_parameter_groups(; aws_config::AbstractAWSConfig=current_aws_config())
    return dax(
        "DescribeParameterGroups"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_parameter_groups(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dax(
        "DescribeParameterGroups",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_parameters(parameter_group_name)
    describe_parameters(parameter_group_name, params::Dict{String,<:Any})

Returns the detailed parameter list for a particular parameter group.

# Arguments
- `parameter_group_name`: The name of the parameter group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to include in the response. If more results
  exist than the specified MaxResults value, a token is included in the response so that the
  remaining results can be retrieved. The value for MaxResults must be between 20 and 100.
- `"NextToken"`: An optional token returned from a prior request. Use this token for
  pagination of results from this action. If this parameter is specified, the response
  includes only results beyond the token, up to the value specified by MaxResults.
- `"Source"`: How the parameter is defined. For example, system denotes a system-defined
  parameter.
"""
function describe_parameters(
    ParameterGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dax(
        "DescribeParameters",
        Dict{String,Any}("ParameterGroupName" => ParameterGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_parameters(
    ParameterGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dax(
        "DescribeParameters",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ParameterGroupName" => ParameterGroupName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_subnet_groups()
    describe_subnet_groups(params::Dict{String,<:Any})

Returns a list of subnet group descriptions. If a subnet group name is specified, the list
will contain only the description of that group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to include in the response. If more results
  exist than the specified MaxResults value, a token is included in the response so that the
  remaining results can be retrieved. The value for MaxResults must be between 20 and 100.
- `"NextToken"`: An optional token returned from a prior request. Use this token for
  pagination of results from this action. If this parameter is specified, the response
  includes only results beyond the token, up to the value specified by MaxResults.
- `"SubnetGroupNames"`: The name of the subnet group.
"""
function describe_subnet_groups(; aws_config::AbstractAWSConfig=current_aws_config())
    return dax(
        "DescribeSubnetGroups"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_subnet_groups(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dax(
        "DescribeSubnetGroups",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    increase_replication_factor(cluster_name, new_replication_factor)
    increase_replication_factor(cluster_name, new_replication_factor, params::Dict{String,<:Any})

Adds one or more nodes to a DAX cluster.

# Arguments
- `cluster_name`: The name of the DAX cluster that will receive additional nodes.
- `new_replication_factor`: The new number of nodes for the DAX cluster.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AvailabilityZones"`: The Availability Zones (AZs) in which the cluster nodes will be
  created. All nodes belonging to the cluster are placed in these Availability Zones. Use
  this parameter if you want to distribute the nodes across multiple AZs.
"""
function increase_replication_factor(
    ClusterName, NewReplicationFactor; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dax(
        "IncreaseReplicationFactor",
        Dict{String,Any}(
            "ClusterName" => ClusterName, "NewReplicationFactor" => NewReplicationFactor
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function increase_replication_factor(
    ClusterName,
    NewReplicationFactor,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dax(
        "IncreaseReplicationFactor",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClusterName" => ClusterName,
                    "NewReplicationFactor" => NewReplicationFactor,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags(resource_name)
    list_tags(resource_name, params::Dict{String,<:Any})

List all of the tags for a DAX cluster. You can call ListTags up to 10 times per second,
per account.

# Arguments
- `resource_name`: The name of the DAX resource to which the tags belong.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: An optional token returned from a prior request. Use this token for
  pagination of results from this action. If this parameter is specified, the response
  includes only results beyond the token.
"""
function list_tags(ResourceName; aws_config::AbstractAWSConfig=current_aws_config())
    return dax(
        "ListTags",
        Dict{String,Any}("ResourceName" => ResourceName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags(
    ResourceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dax(
        "ListTags",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceName" => ResourceName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    reboot_node(cluster_name, node_id)
    reboot_node(cluster_name, node_id, params::Dict{String,<:Any})

Reboots a single node of a DAX cluster. The reboot action takes place as soon as possible.
During the reboot, the node status is set to REBOOTING.   RebootNode restarts the DAX
engine process and does not remove the contents of the cache.

# Arguments
- `cluster_name`: The name of the DAX cluster containing the node to be rebooted.
- `node_id`: The system-assigned ID of the node to be rebooted.

"""
function reboot_node(
    ClusterName, NodeId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dax(
        "RebootNode",
        Dict{String,Any}("ClusterName" => ClusterName, "NodeId" => NodeId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function reboot_node(
    ClusterName,
    NodeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dax(
        "RebootNode",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ClusterName" => ClusterName, "NodeId" => NodeId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_name, tags)
    tag_resource(resource_name, tags, params::Dict{String,<:Any})

Associates a set of tags with a DAX resource. You can call TagResource up to 5 times per
second, per account.

# Arguments
- `resource_name`: The name of the DAX resource to which tags should be added.
- `tags`: The tags to be assigned to the DAX resource.

"""
function tag_resource(
    ResourceName, Tags; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dax(
        "TagResource",
        Dict{String,Any}("ResourceName" => ResourceName, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceName,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dax(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceName" => ResourceName, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_name, tag_keys)
    untag_resource(resource_name, tag_keys, params::Dict{String,<:Any})

Removes the association of tags from a DAX resource. You can call UntagResource up to 5
times per second, per account.

# Arguments
- `resource_name`: The name of the DAX resource from which the tags should be removed.
- `tag_keys`: A list of tag keys. If the DAX cluster has any tags with these keys, then the
  tags are removed from the cluster.

"""
function untag_resource(
    ResourceName, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dax(
        "UntagResource",
        Dict{String,Any}("ResourceName" => ResourceName, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceName,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dax(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceName" => ResourceName, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_cluster(cluster_name)
    update_cluster(cluster_name, params::Dict{String,<:Any})

Modifies the settings for a DAX cluster. You can use this action to change one or more
cluster configuration parameters by specifying the parameters and the new values.

# Arguments
- `cluster_name`: The name of the DAX cluster to be modified.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description of the changes being made to the cluster.
- `"NotificationTopicArn"`: The Amazon Resource Name (ARN) that identifies the topic.
- `"NotificationTopicStatus"`: The current state of the topic. A value of “active”
  means that notifications will be sent to the topic. A value of “inactive” means that
  notifications will not be sent to the topic.
- `"ParameterGroupName"`: The name of a parameter group for this cluster.
- `"PreferredMaintenanceWindow"`: A range of time when maintenance of DAX cluster software
  will be performed. For example: sun:01:00-sun:09:00. Cluster maintenance normally takes
  less than 30 minutes, and is performed automatically within the maintenance window.
- `"SecurityGroupIds"`: A list of user-specified security group IDs to be assigned to each
  node in the DAX cluster. If this parameter is not specified, DAX assigns the default VPC
  security group to each node.
"""
function update_cluster(ClusterName; aws_config::AbstractAWSConfig=current_aws_config())
    return dax(
        "UpdateCluster",
        Dict{String,Any}("ClusterName" => ClusterName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_cluster(
    ClusterName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dax(
        "UpdateCluster",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ClusterName" => ClusterName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_parameter_group(parameter_group_name, parameter_name_values)
    update_parameter_group(parameter_group_name, parameter_name_values, params::Dict{String,<:Any})

Modifies the parameters of a parameter group. You can modify up to 20 parameters in a
single request by submitting a list parameter name and value pairs.

# Arguments
- `parameter_group_name`: The name of the parameter group.
- `parameter_name_values`: An array of name-value pairs for the parameters in the group.
  Each element in the array represents a single parameter.   record-ttl-millis and
  query-ttl-millis are the only supported parameter names. For more details, see Configuring
  TTL Settings.

"""
function update_parameter_group(
    ParameterGroupName,
    ParameterNameValues;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dax(
        "UpdateParameterGroup",
        Dict{String,Any}(
            "ParameterGroupName" => ParameterGroupName,
            "ParameterNameValues" => ParameterNameValues,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_parameter_group(
    ParameterGroupName,
    ParameterNameValues,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dax(
        "UpdateParameterGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ParameterGroupName" => ParameterGroupName,
                    "ParameterNameValues" => ParameterNameValues,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_subnet_group(subnet_group_name)
    update_subnet_group(subnet_group_name, params::Dict{String,<:Any})

Modifies an existing subnet group.

# Arguments
- `subnet_group_name`: The name of the subnet group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description of the subnet group.
- `"SubnetIds"`: A list of subnet IDs in the subnet group.
"""
function update_subnet_group(
    SubnetGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dax(
        "UpdateSubnetGroup",
        Dict{String,Any}("SubnetGroupName" => SubnetGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_subnet_group(
    SubnetGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dax(
        "UpdateSubnetGroup",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("SubnetGroupName" => SubnetGroupName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: workspaces_web
using AWS.Compat
using AWS.UUIDs

"""
    associate_browser_settings(browser_settings_arn, portal_arn)
    associate_browser_settings(browser_settings_arn, portal_arn, params::Dict{String,<:Any})

Associates a browser settings resource with a web portal.

# Arguments
- `browser_settings_arn`: The ARN of the browser settings.
- `portal_arn`: The ARN of the web portal.

"""
function associate_browser_settings(
    browserSettingsArn, portalArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_web(
        "PUT",
        "/portals/$(portalArn)/browserSettings",
        Dict{String,Any}("browserSettingsArn" => browserSettingsArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_browser_settings(
    browserSettingsArn,
    portalArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces_web(
        "PUT",
        "/portals/$(portalArn)/browserSettings",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("browserSettingsArn" => browserSettingsArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_ip_access_settings(ip_access_settings_arn, portal_arn)
    associate_ip_access_settings(ip_access_settings_arn, portal_arn, params::Dict{String,<:Any})

Associates an IP access settings resource with a web portal.

# Arguments
- `ip_access_settings_arn`: The ARN of the IP access settings.
- `portal_arn`: The ARN of the web portal.

"""
function associate_ip_access_settings(
    ipAccessSettingsArn, portalArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_web(
        "PUT",
        "/portals/$(portalArn)/ipAccessSettings",
        Dict{String,Any}("ipAccessSettingsArn" => ipAccessSettingsArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_ip_access_settings(
    ipAccessSettingsArn,
    portalArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces_web(
        "PUT",
        "/portals/$(portalArn)/ipAccessSettings",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ipAccessSettingsArn" => ipAccessSettingsArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_network_settings(network_settings_arn, portal_arn)
    associate_network_settings(network_settings_arn, portal_arn, params::Dict{String,<:Any})

Associates a network settings resource with a web portal.

# Arguments
- `network_settings_arn`: The ARN of the network settings.
- `portal_arn`: The ARN of the web portal.

"""
function associate_network_settings(
    networkSettingsArn, portalArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_web(
        "PUT",
        "/portals/$(portalArn)/networkSettings",
        Dict{String,Any}("networkSettingsArn" => networkSettingsArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_network_settings(
    networkSettingsArn,
    portalArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces_web(
        "PUT",
        "/portals/$(portalArn)/networkSettings",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("networkSettingsArn" => networkSettingsArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_trust_store(portal_arn, trust_store_arn)
    associate_trust_store(portal_arn, trust_store_arn, params::Dict{String,<:Any})

Associates a trust store with a web portal.

# Arguments
- `portal_arn`: The ARN of the web portal.
- `trust_store_arn`: The ARN of the trust store.

"""
function associate_trust_store(
    portalArn, trustStoreArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_web(
        "PUT",
        "/portals/$(portalArn)/trustStores",
        Dict{String,Any}("trustStoreArn" => trustStoreArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_trust_store(
    portalArn,
    trustStoreArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces_web(
        "PUT",
        "/portals/$(portalArn)/trustStores",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("trustStoreArn" => trustStoreArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_user_access_logging_settings(portal_arn, user_access_logging_settings_arn)
    associate_user_access_logging_settings(portal_arn, user_access_logging_settings_arn, params::Dict{String,<:Any})

Associates a user access logging settings resource with a web portal.

# Arguments
- `portal_arn`: The ARN of the web portal.
- `user_access_logging_settings_arn`: The ARN of the user access logging settings.

"""
function associate_user_access_logging_settings(
    portalArn,
    userAccessLoggingSettingsArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces_web(
        "PUT",
        "/portals/$(portalArn)/userAccessLoggingSettings",
        Dict{String,Any}("userAccessLoggingSettingsArn" => userAccessLoggingSettingsArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_user_access_logging_settings(
    portalArn,
    userAccessLoggingSettingsArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces_web(
        "PUT",
        "/portals/$(portalArn)/userAccessLoggingSettings",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "userAccessLoggingSettingsArn" => userAccessLoggingSettingsArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_user_settings(portal_arn, user_settings_arn)
    associate_user_settings(portal_arn, user_settings_arn, params::Dict{String,<:Any})

Associates a user settings resource with a web portal.

# Arguments
- `portal_arn`: The ARN of the web portal.
- `user_settings_arn`: The ARN of the user settings.

"""
function associate_user_settings(
    portalArn, userSettingsArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_web(
        "PUT",
        "/portals/$(portalArn)/userSettings",
        Dict{String,Any}("userSettingsArn" => userSettingsArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_user_settings(
    portalArn,
    userSettingsArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces_web(
        "PUT",
        "/portals/$(portalArn)/userSettings",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("userSettingsArn" => userSettingsArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_browser_settings(browser_policy)
    create_browser_settings(browser_policy, params::Dict{String,<:Any})

Creates a browser settings resource that can be associated with a web portal. Once
associated with a web portal, browser settings control how the browser will behave once a
user starts a streaming session for the web portal.

# Arguments
- `browser_policy`: A JSON string containing Chrome Enterprise policies that will be
  applied to all streaming sessions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"additionalEncryptionContext"`: Additional encryption context of the browser settings.
- `"clientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. Idempotency ensures that an API request completes only once.
  With an idempotent request, if the original request completes successfully, subsequent
  retries with the same client token returns the result from the original successful request.
  If you do not specify a client token, one is automatically generated by the Amazon Web
  Services SDK.
- `"customerManagedKey"`: The custom managed key of the browser settings.
- `"tags"`: The tags to add to the browser settings resource. A tag is a key-value pair.
"""
function create_browser_settings(
    browserPolicy; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_web(
        "POST",
        "/browserSettings",
        Dict{String,Any}(
            "browserPolicy" => browserPolicy, "clientToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_browser_settings(
    browserPolicy,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces_web(
        "POST",
        "/browserSettings",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "browserPolicy" => browserPolicy, "clientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_identity_provider(identity_provider_details, identity_provider_name, identity_provider_type, portal_arn)
    create_identity_provider(identity_provider_details, identity_provider_name, identity_provider_type, portal_arn, params::Dict{String,<:Any})

Creates an identity provider resource that is then associated with a web portal.

# Arguments
- `identity_provider_details`: The identity provider details. The following list describes
  the provider detail keys for each identity provider type.    For Google and Login with
  Amazon:    client_id     client_secret     authorize_scopes      For Facebook:    client_id
      client_secret     authorize_scopes     api_version      For Sign in with Apple:
  client_id     team_id     key_id     private_key     authorize_scopes      For OIDC
  providers:    client_id     client_secret     attributes_request_method     oidc_issuer
  authorize_scopes     authorize_url if not available from discovery URL specified by
  oidc_issuer key     token_url if not available from discovery URL specified by oidc_issuer
  key     attributes_url if not available from discovery URL specified by oidc_issuer key
  jwks_uri if not available from discovery URL specified by oidc_issuer key      For SAML
  providers:    MetadataFile OR MetadataURL     IDPSignout (boolean) optional     IDPInit
  (boolean) optional     RequestSigningAlgorithm (string) optional - Only accepts rsa-sha256
     EncryptedResponses (boolean) optional
- `identity_provider_name`: The identity provider name.
- `identity_provider_type`: The identity provider type.
- `portal_arn`: The ARN of the web portal.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. Idempotency ensures that an API request completes only once.
  With an idempotent request, if the original request completes successfully, subsequent
  retries with the same client token returns the result from the original successful request.
  If you do not specify a client token, one is automatically generated by the Amazon Web
  Services SDK.
- `"tags"`: The tags to add to the identity provider resource. A tag is a key-value pair.
"""
function create_identity_provider(
    identityProviderDetails,
    identityProviderName,
    identityProviderType,
    portalArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces_web(
        "POST",
        "/identityProviders",
        Dict{String,Any}(
            "identityProviderDetails" => identityProviderDetails,
            "identityProviderName" => identityProviderName,
            "identityProviderType" => identityProviderType,
            "portalArn" => portalArn,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_identity_provider(
    identityProviderDetails,
    identityProviderName,
    identityProviderType,
    portalArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces_web(
        "POST",
        "/identityProviders",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "identityProviderDetails" => identityProviderDetails,
                    "identityProviderName" => identityProviderName,
                    "identityProviderType" => identityProviderType,
                    "portalArn" => portalArn,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_ip_access_settings(ip_rules)
    create_ip_access_settings(ip_rules, params::Dict{String,<:Any})

Creates an IP access settings resource that can be associated with a web portal.

# Arguments
- `ip_rules`: The IP rules of the IP access settings.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"additionalEncryptionContext"`: Additional encryption context of the IP access settings.
- `"clientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. Idempotency ensures that an API request completes only once.
  With an idempotent request, if the original request completes successfully, subsequent
  retries with the same client token returns the result from the original successful request.
   If you do not specify a client token, one is automatically generated by the Amazon Web
  Services SDK.
- `"customerManagedKey"`: The custom managed key of the IP access settings.
- `"description"`: The description of the IP access settings.
- `"displayName"`: The display name of the IP access settings.
- `"tags"`: The tags to add to the IP access settings resource. A tag is a key-value pair.
"""
function create_ip_access_settings(
    ipRules; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_web(
        "POST",
        "/ipAccessSettings",
        Dict{String,Any}("ipRules" => ipRules, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_ip_access_settings(
    ipRules,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces_web(
        "POST",
        "/ipAccessSettings",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ipRules" => ipRules, "clientToken" => string(uuid4())),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_network_settings(security_group_ids, subnet_ids, vpc_id)
    create_network_settings(security_group_ids, subnet_ids, vpc_id, params::Dict{String,<:Any})

Creates a network settings resource that can be associated with a web portal. Once
associated with a web portal, network settings define how streaming instances will connect
with your specified VPC.

# Arguments
- `security_group_ids`: One or more security groups used to control access from streaming
  instances to your VPC.
- `subnet_ids`: The subnets in which network interfaces are created to connect streaming
  instances to your VPC. At least two of these subnets must be in different availability
  zones.
- `vpc_id`: The VPC that streaming instances will connect to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. Idempotency ensures that an API request completes only once.
  With an idempotent request, if the original request completes successfully, subsequent
  retries with the same client token returns the result from the original successful request.
   If you do not specify a client token, one is automatically generated by the Amazon Web
  Services SDK.
- `"tags"`: The tags to add to the network settings resource. A tag is a key-value pair.
"""
function create_network_settings(
    securityGroupIds, subnetIds, vpcId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_web(
        "POST",
        "/networkSettings",
        Dict{String,Any}(
            "securityGroupIds" => securityGroupIds,
            "subnetIds" => subnetIds,
            "vpcId" => vpcId,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_network_settings(
    securityGroupIds,
    subnetIds,
    vpcId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces_web(
        "POST",
        "/networkSettings",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "securityGroupIds" => securityGroupIds,
                    "subnetIds" => subnetIds,
                    "vpcId" => vpcId,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_portal()
    create_portal(params::Dict{String,<:Any})

Creates a web portal.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"additionalEncryptionContext"`: The additional encryption context of the portal.
- `"authenticationType"`: The type of authentication integration points used when signing
  into the web portal. Defaults to Standard.  Standard web portals are authenticated directly
  through your identity provider. You need to call CreateIdentityProvider to integrate your
  identity provider with your web portal. User and group access to your web portal is
  controlled through your identity provider.  IAM Identity Center web portals are
  authenticated through IAM Identity Center (successor to Single Sign-On). Identity sources
  (including external identity provider integration), plus user and group access to your web
  portal, can be configured in the IAM Identity Center.
- `"clientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. Idempotency ensures that an API request completes only once.
  With an idempotent request, if the original request completes successfully, subsequent
  retries with the same client token returns the result from the original successful request.
   If you do not specify a client token, one is automatically generated by the Amazon Web
  Services SDK.
- `"customerManagedKey"`: The customer managed key of the web portal.
- `"displayName"`: The name of the web portal. This is not visible to users who log into
  the web portal.
- `"instanceType"`: The type and resources of the underlying instance.
- `"maxConcurrentSessions"`: The maximum number of concurrent sessions for the portal.
- `"tags"`: The tags to add to the web portal. A tag is a key-value pair.
"""
function create_portal(; aws_config::AbstractAWSConfig=current_aws_config())
    return workspaces_web(
        "POST",
        "/portals",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_portal(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_web(
        "POST",
        "/portals",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_trust_store(certificate_list)
    create_trust_store(certificate_list, params::Dict{String,<:Any})

Creates a trust store that can be associated with a web portal. A trust store contains
certificate authority (CA) certificates. Once associated with a web portal, the browser in
a streaming session will recognize certificates that have been issued using any of the CAs
in the trust store. If your organization has internal websites that use certificates issued
by private CAs, you should add the private CA certificate to the trust store.

# Arguments
- `certificate_list`: A list of CA certificates to be added to the trust store.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. Idempotency ensures that an API request completes only once.
  With an idempotent request, if the original request completes successfully, subsequent
  retries with the same client token returns the result from the original successful request.
   If you do not specify a client token, one is automatically generated by the Amazon Web
  Services SDK.
- `"tags"`: The tags to add to the trust store. A tag is a key-value pair.
"""
function create_trust_store(
    certificateList; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_web(
        "POST",
        "/trustStores",
        Dict{String,Any}(
            "certificateList" => certificateList, "clientToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_trust_store(
    certificateList,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces_web(
        "POST",
        "/trustStores",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "certificateList" => certificateList, "clientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_user_access_logging_settings(kinesis_stream_arn)
    create_user_access_logging_settings(kinesis_stream_arn, params::Dict{String,<:Any})

Creates a user access logging settings resource that can be associated with a web portal.

# Arguments
- `kinesis_stream_arn`: The ARN of the Kinesis stream.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. Idempotency ensures that an API request completes only once.
  With an idempotent request, if the original request completes successfully, subsequent
  retries with the same client token returns the result from the original successful request.
   If you do not specify a client token, one is automatically generated by the Amazon Web
  Services SDK.
- `"tags"`: The tags to add to the user settings resource. A tag is a key-value pair.
"""
function create_user_access_logging_settings(
    kinesisStreamArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_web(
        "POST",
        "/userAccessLoggingSettings",
        Dict{String,Any}(
            "kinesisStreamArn" => kinesisStreamArn, "clientToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_user_access_logging_settings(
    kinesisStreamArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces_web(
        "POST",
        "/userAccessLoggingSettings",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "kinesisStreamArn" => kinesisStreamArn, "clientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_user_settings(copy_allowed, download_allowed, paste_allowed, print_allowed, upload_allowed)
    create_user_settings(copy_allowed, download_allowed, paste_allowed, print_allowed, upload_allowed, params::Dict{String,<:Any})

Creates a user settings resource that can be associated with a web portal. Once associated
with a web portal, user settings control how users can transfer data between a streaming
session and the their local devices.

# Arguments
- `copy_allowed`: Specifies whether the user can copy text from the streaming session to
  the local device.
- `download_allowed`: Specifies whether the user can download files from the streaming
  session to the local device.
- `paste_allowed`: Specifies whether the user can paste text from the local device to the
  streaming session.
- `print_allowed`: Specifies whether the user can print to the local device.
- `upload_allowed`: Specifies whether the user can upload files from the local device to
  the streaming session.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"additionalEncryptionContext"`: The additional encryption context of the user settings.
- `"clientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. Idempotency ensures that an API request completes only once.
  With an idempotent request, if the original request completes successfully, subsequent
  retries with the same client token returns the result from the original successful request.
   If you do not specify a client token, one is automatically generated by the Amazon Web
  Services SDK.
- `"cookieSynchronizationConfiguration"`: The configuration that specifies which cookies
  should be synchronized from the end user's local browser to the remote browser.
- `"customerManagedKey"`: The customer managed key used to encrypt sensitive information in
  the user settings.
- `"deepLinkAllowed"`: Specifies whether the user can use deep links that open
  automatically when connecting to a session.
- `"disconnectTimeoutInMinutes"`: The amount of time that a streaming session remains
  active after users disconnect.
- `"idleDisconnectTimeoutInMinutes"`: The amount of time that users can be idle (inactive)
  before they are disconnected from their streaming session and the disconnect timeout
  interval begins.
- `"tags"`: The tags to add to the user settings resource. A tag is a key-value pair.
"""
function create_user_settings(
    copyAllowed,
    downloadAllowed,
    pasteAllowed,
    printAllowed,
    uploadAllowed;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces_web(
        "POST",
        "/userSettings",
        Dict{String,Any}(
            "copyAllowed" => copyAllowed,
            "downloadAllowed" => downloadAllowed,
            "pasteAllowed" => pasteAllowed,
            "printAllowed" => printAllowed,
            "uploadAllowed" => uploadAllowed,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_user_settings(
    copyAllowed,
    downloadAllowed,
    pasteAllowed,
    printAllowed,
    uploadAllowed,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces_web(
        "POST",
        "/userSettings",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "copyAllowed" => copyAllowed,
                    "downloadAllowed" => downloadAllowed,
                    "pasteAllowed" => pasteAllowed,
                    "printAllowed" => printAllowed,
                    "uploadAllowed" => uploadAllowed,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_browser_settings(browser_settings_arn)
    delete_browser_settings(browser_settings_arn, params::Dict{String,<:Any})

Deletes browser settings.

# Arguments
- `browser_settings_arn`: The ARN of the browser settings.

"""
function delete_browser_settings(
    browserSettingsArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_web(
        "DELETE",
        "/browserSettings/$(browserSettingsArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_browser_settings(
    browserSettingsArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces_web(
        "DELETE",
        "/browserSettings/$(browserSettingsArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_identity_provider(identity_provider_arn)
    delete_identity_provider(identity_provider_arn, params::Dict{String,<:Any})

Deletes the identity provider.

# Arguments
- `identity_provider_arn`: The ARN of the identity provider.

"""
function delete_identity_provider(
    identityProviderArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_web(
        "DELETE",
        "/identityProviders/$(identityProviderArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_identity_provider(
    identityProviderArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces_web(
        "DELETE",
        "/identityProviders/$(identityProviderArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_ip_access_settings(ip_access_settings_arn)
    delete_ip_access_settings(ip_access_settings_arn, params::Dict{String,<:Any})

Deletes IP access settings.

# Arguments
- `ip_access_settings_arn`: The ARN of the IP access settings.

"""
function delete_ip_access_settings(
    ipAccessSettingsArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_web(
        "DELETE",
        "/ipAccessSettings/$(ipAccessSettingsArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_ip_access_settings(
    ipAccessSettingsArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces_web(
        "DELETE",
        "/ipAccessSettings/$(ipAccessSettingsArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_network_settings(network_settings_arn)
    delete_network_settings(network_settings_arn, params::Dict{String,<:Any})

Deletes network settings.

# Arguments
- `network_settings_arn`: The ARN of the network settings.

"""
function delete_network_settings(
    networkSettingsArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_web(
        "DELETE",
        "/networkSettings/$(networkSettingsArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_network_settings(
    networkSettingsArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces_web(
        "DELETE",
        "/networkSettings/$(networkSettingsArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_portal(portal_arn)
    delete_portal(portal_arn, params::Dict{String,<:Any})

Deletes a web portal.

# Arguments
- `portal_arn`: The ARN of the web portal.

"""
function delete_portal(portalArn; aws_config::AbstractAWSConfig=current_aws_config())
    return workspaces_web(
        "DELETE",
        "/portals/$(portalArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_portal(
    portalArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces_web(
        "DELETE",
        "/portals/$(portalArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_trust_store(trust_store_arn)
    delete_trust_store(trust_store_arn, params::Dict{String,<:Any})

Deletes the trust store.

# Arguments
- `trust_store_arn`: The ARN of the trust store.

"""
function delete_trust_store(
    trustStoreArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_web(
        "DELETE",
        "/trustStores/$(trustStoreArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_trust_store(
    trustStoreArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces_web(
        "DELETE",
        "/trustStores/$(trustStoreArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_user_access_logging_settings(user_access_logging_settings_arn)
    delete_user_access_logging_settings(user_access_logging_settings_arn, params::Dict{String,<:Any})

Deletes user access logging settings.

# Arguments
- `user_access_logging_settings_arn`: The ARN of the user access logging settings.

"""
function delete_user_access_logging_settings(
    userAccessLoggingSettingsArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_web(
        "DELETE",
        "/userAccessLoggingSettings/$(userAccessLoggingSettingsArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_user_access_logging_settings(
    userAccessLoggingSettingsArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces_web(
        "DELETE",
        "/userAccessLoggingSettings/$(userAccessLoggingSettingsArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_user_settings(user_settings_arn)
    delete_user_settings(user_settings_arn, params::Dict{String,<:Any})

Deletes user settings.

# Arguments
- `user_settings_arn`: The ARN of the user settings.

"""
function delete_user_settings(
    userSettingsArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_web(
        "DELETE",
        "/userSettings/$(userSettingsArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_user_settings(
    userSettingsArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces_web(
        "DELETE",
        "/userSettings/$(userSettingsArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_browser_settings(portal_arn)
    disassociate_browser_settings(portal_arn, params::Dict{String,<:Any})

Disassociates browser settings from a web portal.

# Arguments
- `portal_arn`: The ARN of the web portal.

"""
function disassociate_browser_settings(
    portalArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_web(
        "DELETE",
        "/portals/$(portalArn)/browserSettings";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_browser_settings(
    portalArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces_web(
        "DELETE",
        "/portals/$(portalArn)/browserSettings",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_ip_access_settings(portal_arn)
    disassociate_ip_access_settings(portal_arn, params::Dict{String,<:Any})

Disassociates IP access settings from a web portal.

# Arguments
- `portal_arn`: The ARN of the web portal.

"""
function disassociate_ip_access_settings(
    portalArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_web(
        "DELETE",
        "/portals/$(portalArn)/ipAccessSettings";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_ip_access_settings(
    portalArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces_web(
        "DELETE",
        "/portals/$(portalArn)/ipAccessSettings",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_network_settings(portal_arn)
    disassociate_network_settings(portal_arn, params::Dict{String,<:Any})

Disassociates network settings from a web portal.

# Arguments
- `portal_arn`: The ARN of the web portal.

"""
function disassociate_network_settings(
    portalArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_web(
        "DELETE",
        "/portals/$(portalArn)/networkSettings";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_network_settings(
    portalArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces_web(
        "DELETE",
        "/portals/$(portalArn)/networkSettings",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_trust_store(portal_arn)
    disassociate_trust_store(portal_arn, params::Dict{String,<:Any})

Disassociates a trust store from a web portal.

# Arguments
- `portal_arn`: The ARN of the web portal.

"""
function disassociate_trust_store(
    portalArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_web(
        "DELETE",
        "/portals/$(portalArn)/trustStores";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_trust_store(
    portalArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces_web(
        "DELETE",
        "/portals/$(portalArn)/trustStores",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_user_access_logging_settings(portal_arn)
    disassociate_user_access_logging_settings(portal_arn, params::Dict{String,<:Any})

Disassociates user access logging settings from a web portal.

# Arguments
- `portal_arn`: The ARN of the web portal.

"""
function disassociate_user_access_logging_settings(
    portalArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_web(
        "DELETE",
        "/portals/$(portalArn)/userAccessLoggingSettings";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_user_access_logging_settings(
    portalArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces_web(
        "DELETE",
        "/portals/$(portalArn)/userAccessLoggingSettings",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_user_settings(portal_arn)
    disassociate_user_settings(portal_arn, params::Dict{String,<:Any})

Disassociates user settings from a web portal.

# Arguments
- `portal_arn`: The ARN of the web portal.

"""
function disassociate_user_settings(
    portalArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_web(
        "DELETE",
        "/portals/$(portalArn)/userSettings";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_user_settings(
    portalArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces_web(
        "DELETE",
        "/portals/$(portalArn)/userSettings",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_browser_settings(browser_settings_arn)
    get_browser_settings(browser_settings_arn, params::Dict{String,<:Any})

Gets browser settings.

# Arguments
- `browser_settings_arn`: The ARN of the browser settings.

"""
function get_browser_settings(
    browserSettingsArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_web(
        "GET",
        "/browserSettings/$(browserSettingsArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_browser_settings(
    browserSettingsArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces_web(
        "GET",
        "/browserSettings/$(browserSettingsArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_identity_provider(identity_provider_arn)
    get_identity_provider(identity_provider_arn, params::Dict{String,<:Any})

Gets the identity provider.

# Arguments
- `identity_provider_arn`: The ARN of the identity provider.

"""
function get_identity_provider(
    identityProviderArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_web(
        "GET",
        "/identityProviders/$(identityProviderArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_identity_provider(
    identityProviderArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces_web(
        "GET",
        "/identityProviders/$(identityProviderArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_ip_access_settings(ip_access_settings_arn)
    get_ip_access_settings(ip_access_settings_arn, params::Dict{String,<:Any})

Gets the IP access settings.

# Arguments
- `ip_access_settings_arn`: The ARN of the IP access settings.

"""
function get_ip_access_settings(
    ipAccessSettingsArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_web(
        "GET",
        "/ipAccessSettings/$(ipAccessSettingsArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_ip_access_settings(
    ipAccessSettingsArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces_web(
        "GET",
        "/ipAccessSettings/$(ipAccessSettingsArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_network_settings(network_settings_arn)
    get_network_settings(network_settings_arn, params::Dict{String,<:Any})

Gets the network settings.

# Arguments
- `network_settings_arn`: The ARN of the network settings.

"""
function get_network_settings(
    networkSettingsArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_web(
        "GET",
        "/networkSettings/$(networkSettingsArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_network_settings(
    networkSettingsArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces_web(
        "GET",
        "/networkSettings/$(networkSettingsArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_portal(portal_arn)
    get_portal(portal_arn, params::Dict{String,<:Any})

Gets the web portal.

# Arguments
- `portal_arn`: The ARN of the web portal.

"""
function get_portal(portalArn; aws_config::AbstractAWSConfig=current_aws_config())
    return workspaces_web(
        "GET",
        "/portals/$(portalArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_portal(
    portalArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces_web(
        "GET",
        "/portals/$(portalArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_portal_service_provider_metadata(portal_arn)
    get_portal_service_provider_metadata(portal_arn, params::Dict{String,<:Any})

Gets the service provider metadata.

# Arguments
- `portal_arn`: The ARN of the web portal.

"""
function get_portal_service_provider_metadata(
    portalArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_web(
        "GET",
        "/portalIdp/$(portalArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_portal_service_provider_metadata(
    portalArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces_web(
        "GET",
        "/portalIdp/$(portalArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_trust_store(trust_store_arn)
    get_trust_store(trust_store_arn, params::Dict{String,<:Any})

Gets the trust store.

# Arguments
- `trust_store_arn`: The ARN of the trust store.

"""
function get_trust_store(trustStoreArn; aws_config::AbstractAWSConfig=current_aws_config())
    return workspaces_web(
        "GET",
        "/trustStores/$(trustStoreArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_trust_store(
    trustStoreArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces_web(
        "GET",
        "/trustStores/$(trustStoreArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_trust_store_certificate(thumbprint, trust_store_arn)
    get_trust_store_certificate(thumbprint, trust_store_arn, params::Dict{String,<:Any})

Gets the trust store certificate.

# Arguments
- `thumbprint`: The thumbprint of the trust store certificate.
- `trust_store_arn`: The ARN of the trust store certificate.

"""
function get_trust_store_certificate(
    thumbprint, trustStoreArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_web(
        "GET",
        "/trustStores/$(trustStoreArn)/certificate",
        Dict{String,Any}("thumbprint" => thumbprint);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_trust_store_certificate(
    thumbprint,
    trustStoreArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces_web(
        "GET",
        "/trustStores/$(trustStoreArn)/certificate",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("thumbprint" => thumbprint), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_user_access_logging_settings(user_access_logging_settings_arn)
    get_user_access_logging_settings(user_access_logging_settings_arn, params::Dict{String,<:Any})

Gets user access logging settings.

# Arguments
- `user_access_logging_settings_arn`: The ARN of the user access logging settings.

"""
function get_user_access_logging_settings(
    userAccessLoggingSettingsArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_web(
        "GET",
        "/userAccessLoggingSettings/$(userAccessLoggingSettingsArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_user_access_logging_settings(
    userAccessLoggingSettingsArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces_web(
        "GET",
        "/userAccessLoggingSettings/$(userAccessLoggingSettingsArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_user_settings(user_settings_arn)
    get_user_settings(user_settings_arn, params::Dict{String,<:Any})

Gets user settings.

# Arguments
- `user_settings_arn`: The ARN of the user settings.

"""
function get_user_settings(
    userSettingsArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_web(
        "GET",
        "/userSettings/$(userSettingsArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_user_settings(
    userSettingsArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces_web(
        "GET",
        "/userSettings/$(userSettingsArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_browser_settings()
    list_browser_settings(params::Dict{String,<:Any})

Retrieves a list of browser settings.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to be included in the next page.
- `"nextToken"`: The pagination token used to retrieve the next page of results for this
  operation.
"""
function list_browser_settings(; aws_config::AbstractAWSConfig=current_aws_config())
    return workspaces_web(
        "GET", "/browserSettings"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_browser_settings(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_web(
        "GET",
        "/browserSettings",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_identity_providers(portal_arn)
    list_identity_providers(portal_arn, params::Dict{String,<:Any})

Retrieves a list of identity providers for a specific web portal.

# Arguments
- `portal_arn`: The ARN of the web portal.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to be included in the next page.
- `"nextToken"`: The pagination token used to retrieve the next page of results for this
  operation.
"""
function list_identity_providers(
    portalArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_web(
        "GET",
        "/portals/$(portalArn)/identityProviders";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_identity_providers(
    portalArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces_web(
        "GET",
        "/portals/$(portalArn)/identityProviders",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_ip_access_settings()
    list_ip_access_settings(params::Dict{String,<:Any})

Retrieves a list of IP access settings.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to be included in the next page.
- `"nextToken"`: The pagination token used to retrieve the next page of results for this
  operation.
"""
function list_ip_access_settings(; aws_config::AbstractAWSConfig=current_aws_config())
    return workspaces_web(
        "GET", "/ipAccessSettings"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_ip_access_settings(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_web(
        "GET",
        "/ipAccessSettings",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_network_settings()
    list_network_settings(params::Dict{String,<:Any})

Retrieves a list of network settings.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to be included in the next page.
- `"nextToken"`: The pagination token used to retrieve the next page of results for this
  operation.
"""
function list_network_settings(; aws_config::AbstractAWSConfig=current_aws_config())
    return workspaces_web(
        "GET", "/networkSettings"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_network_settings(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_web(
        "GET",
        "/networkSettings",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_portals()
    list_portals(params::Dict{String,<:Any})

Retrieves a list or web portals.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to be included in the next page.
- `"nextToken"`: The pagination token used to retrieve the next page of results for this
  operation.
"""
function list_portals(; aws_config::AbstractAWSConfig=current_aws_config())
    return workspaces_web(
        "GET", "/portals"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_portals(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_web(
        "GET", "/portals", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Retrieves a list of tags for a resource.

# Arguments
- `resource_arn`: The ARN of the resource.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_web(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces_web(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_trust_store_certificates(trust_store_arn)
    list_trust_store_certificates(trust_store_arn, params::Dict{String,<:Any})

Retrieves a list of trust store certificates.

# Arguments
- `trust_store_arn`: The ARN of the trust store

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to be included in the next page.
- `"nextToken"`: The pagination token used to retrieve the next page of results for this
  operation.
"""
function list_trust_store_certificates(
    trustStoreArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_web(
        "GET",
        "/trustStores/$(trustStoreArn)/certificates";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_trust_store_certificates(
    trustStoreArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces_web(
        "GET",
        "/trustStores/$(trustStoreArn)/certificates",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_trust_stores()
    list_trust_stores(params::Dict{String,<:Any})

Retrieves a list of trust stores.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to be included in the next page.
- `"nextToken"`: The pagination token used to retrieve the next page of results for this
  operation.
"""
function list_trust_stores(; aws_config::AbstractAWSConfig=current_aws_config())
    return workspaces_web(
        "GET", "/trustStores"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_trust_stores(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_web(
        "GET",
        "/trustStores",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_user_access_logging_settings()
    list_user_access_logging_settings(params::Dict{String,<:Any})

Retrieves a list of user access logging settings.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to be included in the next page.
- `"nextToken"`: The pagination token used to retrieve the next page of results for this
  operation.
"""
function list_user_access_logging_settings(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_web(
        "GET",
        "/userAccessLoggingSettings";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_user_access_logging_settings(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_web(
        "GET",
        "/userAccessLoggingSettings",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_user_settings()
    list_user_settings(params::Dict{String,<:Any})

Retrieves a list of user settings.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to be included in the next page.
- `"nextToken"`: The pagination token used to retrieve the next page of results for this
  operation.
"""
function list_user_settings(; aws_config::AbstractAWSConfig=current_aws_config())
    return workspaces_web(
        "GET", "/userSettings"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_user_settings(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_web(
        "GET",
        "/userSettings",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds or overwrites one or more tags for the specified resource.

# Arguments
- `resource_arn`: The ARN of the resource.
- `tags`: The tags of the resource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. Idempotency ensures that an API request completes only once.
  With an idempotent request, if the original request completes successfully, subsequent
  retries with the same client token returns the result from the original successful request.
   If you do not specify a client token, one is automatically generated by the Amazon Web
  Services SDK.
"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return workspaces_web(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces_web(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("tags" => tags, "clientToken" => string(uuid4())),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes one or more tags from the specified resource.

# Arguments
- `resource_arn`: The ARN of the resource.
- `tag_keys`: The list of tag keys to remove from the resource.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_web(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces_web(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_browser_settings(browser_settings_arn)
    update_browser_settings(browser_settings_arn, params::Dict{String,<:Any})

Updates browser settings.

# Arguments
- `browser_settings_arn`: The ARN of the browser settings.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"browserPolicy"`: A JSON string containing Chrome Enterprise policies that will be
  applied to all streaming sessions.
- `"clientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. Idempotency ensures that an API request completes only once.
  With an idempotent request, if the original request completes successfully, subsequent
  retries with the same client token return the result from the original successful request.
  If you do not specify a client token, one is automatically generated by the Amazon Web
  Services SDK.
"""
function update_browser_settings(
    browserSettingsArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_web(
        "PATCH",
        "/browserSettings/$(browserSettingsArn)",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_browser_settings(
    browserSettingsArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces_web(
        "PATCH",
        "/browserSettings/$(browserSettingsArn)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_identity_provider(identity_provider_arn)
    update_identity_provider(identity_provider_arn, params::Dict{String,<:Any})

Updates the identity provider.

# Arguments
- `identity_provider_arn`: The ARN of the identity provider.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. Idempotency ensures that an API request completes only once.
  With an idempotent request, if the original request completes successfully, subsequent
  retries with the same client token return the result from the original successful request.
  If you do not specify a client token, one is automatically generated by the Amazon Web
  Services SDK.
- `"identityProviderDetails"`: The details of the identity provider. The following list
  describes the provider detail keys for each identity provider type.    For Google and Login
  with Amazon:    client_id     client_secret     authorize_scopes      For Facebook:
  client_id     client_secret     authorize_scopes     api_version      For Sign in with
  Apple:    client_id     team_id     key_id     private_key     authorize_scopes      For
  OIDC providers:    client_id     client_secret     attributes_request_method
  oidc_issuer     authorize_scopes     authorize_url if not available from discovery URL
  specified by oidc_issuer key     token_url if not available from discovery URL specified by
  oidc_issuer key     attributes_url if not available from discovery URL specified by
  oidc_issuer key     jwks_uri if not available from discovery URL specified by oidc_issuer
  key      For SAML providers:    MetadataFile OR MetadataURL     IDPSignout (boolean)
  optional     IDPInit (boolean) optional     RequestSigningAlgorithm (string) optional -
  Only accepts rsa-sha256     EncryptedResponses (boolean) optional
- `"identityProviderName"`: The name of the identity provider.
- `"identityProviderType"`: The type of the identity provider.
"""
function update_identity_provider(
    identityProviderArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_web(
        "PATCH",
        "/identityProviders/$(identityProviderArn)",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_identity_provider(
    identityProviderArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces_web(
        "PATCH",
        "/identityProviders/$(identityProviderArn)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_ip_access_settings(ip_access_settings_arn)
    update_ip_access_settings(ip_access_settings_arn, params::Dict{String,<:Any})

Updates IP access settings.

# Arguments
- `ip_access_settings_arn`: The ARN of the IP access settings.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. Idempotency ensures that an API request completes only once.
  With an idempotent request, if the original request completes successfully, subsequent
  retries with the same client token return the result from the original successful request.
  If you do not specify a client token, one is automatically generated by the Amazon Web
  Services SDK.
- `"description"`: The description of the IP access settings.
- `"displayName"`: The display name of the IP access settings.
- `"ipRules"`: The updated IP rules of the IP access settings.
"""
function update_ip_access_settings(
    ipAccessSettingsArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_web(
        "PATCH",
        "/ipAccessSettings/$(ipAccessSettingsArn)",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_ip_access_settings(
    ipAccessSettingsArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces_web(
        "PATCH",
        "/ipAccessSettings/$(ipAccessSettingsArn)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_network_settings(network_settings_arn)
    update_network_settings(network_settings_arn, params::Dict{String,<:Any})

Updates network settings.

# Arguments
- `network_settings_arn`: The ARN of the network settings.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. Idempotency ensures that an API request completes only once.
  With an idempotent request, if the original request completes successfully, subsequent
  retries with the same client token return the result from the original successful request.
  If you do not specify a client token, one is automatically generated by the Amazon Web
  Services SDK.
- `"securityGroupIds"`: One or more security groups used to control access from streaming
  instances to your VPC.
- `"subnetIds"`: The subnets in which network interfaces are created to connect streaming
  instances to your VPC. At least two of these subnets must be in different availability
  zones.
- `"vpcId"`: The VPC that streaming instances will connect to.
"""
function update_network_settings(
    networkSettingsArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_web(
        "PATCH",
        "/networkSettings/$(networkSettingsArn)",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_network_settings(
    networkSettingsArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces_web(
        "PATCH",
        "/networkSettings/$(networkSettingsArn)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_portal(portal_arn)
    update_portal(portal_arn, params::Dict{String,<:Any})

Updates a web portal.

# Arguments
- `portal_arn`: The ARN of the web portal.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"authenticationType"`: The type of authentication integration points used when signing
  into the web portal. Defaults to Standard.  Standard web portals are authenticated directly
  through your identity provider. You need to call CreateIdentityProvider to integrate your
  identity provider with your web portal. User and group access to your web portal is
  controlled through your identity provider.  IAM Identity Center web portals are
  authenticated through IAM Identity Center (successor to Single Sign-On). Identity sources
  (including external identity provider integration), plus user and group access to your web
  portal, can be configured in the IAM Identity Center.
- `"displayName"`: The name of the web portal. This is not visible to users who log into
  the web portal.
- `"instanceType"`: The type and resources of the underlying instance.
- `"maxConcurrentSessions"`: The maximum number of concurrent sessions for the portal.
"""
function update_portal(portalArn; aws_config::AbstractAWSConfig=current_aws_config())
    return workspaces_web(
        "PUT",
        "/portals/$(portalArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_portal(
    portalArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces_web(
        "PUT",
        "/portals/$(portalArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_trust_store(trust_store_arn)
    update_trust_store(trust_store_arn, params::Dict{String,<:Any})

Updates the trust store.

# Arguments
- `trust_store_arn`: The ARN of the trust store.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"certificatesToAdd"`: A list of CA certificates to add to the trust store.
- `"certificatesToDelete"`: A list of CA certificates to delete from a trust store.
- `"clientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. Idempotency ensures that an API request completes only once.
  With an idempotent request, if the original request completes successfully, subsequent
  retries with the same client token return the result from the original successful request.
  If you do not specify a client token, one is automatically generated by the Amazon Web
  Services SDK.
"""
function update_trust_store(
    trustStoreArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_web(
        "PATCH",
        "/trustStores/$(trustStoreArn)",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_trust_store(
    trustStoreArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces_web(
        "PATCH",
        "/trustStores/$(trustStoreArn)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_user_access_logging_settings(user_access_logging_settings_arn)
    update_user_access_logging_settings(user_access_logging_settings_arn, params::Dict{String,<:Any})

Updates the user access logging settings.

# Arguments
- `user_access_logging_settings_arn`: The ARN of the user access logging settings.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. Idempotency ensures that an API request completes only once.
  With an idempotent request, if the original request completes successfully, subsequent
  retries with the same client token return the result from the original successful request.
  If you do not specify a client token, one is automatically generated by the Amazon Web
  Services SDK.
- `"kinesisStreamArn"`: The ARN of the Kinesis stream.
"""
function update_user_access_logging_settings(
    userAccessLoggingSettingsArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_web(
        "PATCH",
        "/userAccessLoggingSettings/$(userAccessLoggingSettingsArn)",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_user_access_logging_settings(
    userAccessLoggingSettingsArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces_web(
        "PATCH",
        "/userAccessLoggingSettings/$(userAccessLoggingSettingsArn)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_user_settings(user_settings_arn)
    update_user_settings(user_settings_arn, params::Dict{String,<:Any})

Updates the user settings.

# Arguments
- `user_settings_arn`: The ARN of the user settings.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. Idempotency ensures that an API request completes only once.
  With an idempotent request, if the original request completes successfully, subsequent
  retries with the same client token return the result from the original successful request.
  If you do not specify a client token, one is automatically generated by the Amazon Web
  Services SDK.
- `"cookieSynchronizationConfiguration"`: The configuration that specifies which cookies
  should be synchronized from the end user's local browser to the remote browser. If the
  allowlist and blocklist are empty, the configuration becomes null.
- `"copyAllowed"`: Specifies whether the user can copy text from the streaming session to
  the local device.
- `"deepLinkAllowed"`: Specifies whether the user can use deep links that open
  automatically when connecting to a session.
- `"disconnectTimeoutInMinutes"`: The amount of time that a streaming session remains
  active after users disconnect.
- `"downloadAllowed"`: Specifies whether the user can download files from the streaming
  session to the local device.
- `"idleDisconnectTimeoutInMinutes"`: The amount of time that users can be idle (inactive)
  before they are disconnected from their streaming session and the disconnect timeout
  interval begins.
- `"pasteAllowed"`: Specifies whether the user can paste text from the local device to the
  streaming session.
- `"printAllowed"`: Specifies whether the user can print to the local device.
- `"uploadAllowed"`: Specifies whether the user can upload files from the local device to
  the streaming session.
"""
function update_user_settings(
    userSettingsArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces_web(
        "PATCH",
        "/userSettings/$(userSettingsArn)",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_user_settings(
    userSettingsArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces_web(
        "PATCH",
        "/userSettings/$(userSettingsArn)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: opensearch
using AWS.Compat
using AWS.UUIDs

"""
    accept_inbound_connection(connection_id)
    accept_inbound_connection(connection_id, params::Dict{String,<:Any})

Allows the destination Amazon OpenSearch Service domain owner to accept an inbound
cross-cluster search connection request. For more information, see Cross-cluster search for
Amazon OpenSearch Service.

# Arguments
- `connection_id`: The ID of the inbound connection to accept.

"""
function accept_inbound_connection(
    ConnectionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearch(
        "PUT",
        "/2021-01-01/opensearch/cc/inboundConnection/$(ConnectionId)/accept";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function accept_inbound_connection(
    ConnectionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearch(
        "PUT",
        "/2021-01-01/opensearch/cc/inboundConnection/$(ConnectionId)/accept",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    add_data_source(data_source_type, domain_name, name)
    add_data_source(data_source_type, domain_name, name, params::Dict{String,<:Any})

Creates a new direct-query data source to the specified domain. For more information, see
Creating Amazon OpenSearch Service data source integrations with Amazon S3.

# Arguments
- `data_source_type`: The type of data source.
- `domain_name`: The name of the domain to add the data source to.
- `name`: A name for the data source.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description of the data source.
"""
function add_data_source(
    DataSourceType, DomainName, Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearch(
        "POST",
        "/2021-01-01/opensearch/domain/$(DomainName)/dataSource",
        Dict{String,Any}("DataSourceType" => DataSourceType, "Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_data_source(
    DataSourceType,
    DomainName,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearch(
        "POST",
        "/2021-01-01/opensearch/domain/$(DomainName)/dataSource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DataSourceType" => DataSourceType, "Name" => Name),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    add_tags(arn, tag_list)
    add_tags(arn, tag_list, params::Dict{String,<:Any})

Attaches tags to an existing Amazon OpenSearch Service domain. Tags are a set of
case-sensitive key-value pairs. A domain can have up to 10 tags. For more information, see
Tagging Amazon OpenSearch Service domains.

# Arguments
- `arn`: Amazon Resource Name (ARN) for the OpenSearch Service domain to which you want to
  attach resource tags.
- `tag_list`: List of resource tags.

"""
function add_tags(ARN, TagList; aws_config::AbstractAWSConfig=current_aws_config())
    return opensearch(
        "POST",
        "/2021-01-01/tags",
        Dict{String,Any}("ARN" => ARN, "TagList" => TagList);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_tags(
    ARN,
    TagList,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearch(
        "POST",
        "/2021-01-01/tags",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ARN" => ARN, "TagList" => TagList), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_package(domain_name, package_id)
    associate_package(domain_name, package_id, params::Dict{String,<:Any})

Associates a package with an Amazon OpenSearch Service domain. For more information, see
Custom packages for Amazon OpenSearch Service.

# Arguments
- `domain_name`: Name of the domain to associate the package with.
- `package_id`: Internal ID of the package to associate with a domain. Use DescribePackages
  to find this value.

"""
function associate_package(
    DomainName, PackageID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearch(
        "POST",
        "/2021-01-01/packages/associate/$(PackageID)/$(DomainName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_package(
    DomainName,
    PackageID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearch(
        "POST",
        "/2021-01-01/packages/associate/$(PackageID)/$(DomainName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    authorize_vpc_endpoint_access(account, domain_name)
    authorize_vpc_endpoint_access(account, domain_name, params::Dict{String,<:Any})

Provides access to an Amazon OpenSearch Service domain through the use of an interface VPC
endpoint.

# Arguments
- `account`: The Amazon Web Services account ID to grant access to.
- `domain_name`: The name of the OpenSearch Service domain to provide access to.

"""
function authorize_vpc_endpoint_access(
    Account, DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearch(
        "POST",
        "/2021-01-01/opensearch/domain/$(DomainName)/authorizeVpcEndpointAccess",
        Dict{String,Any}("Account" => Account);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function authorize_vpc_endpoint_access(
    Account,
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearch(
        "POST",
        "/2021-01-01/opensearch/domain/$(DomainName)/authorizeVpcEndpointAccess",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Account" => Account), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_domain_config_change(domain_name)
    cancel_domain_config_change(domain_name, params::Dict{String,<:Any})

Cancels a pending configuration change on an Amazon OpenSearch Service domain.

# Arguments
- `domain_name`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DryRun"`: When set to True, returns the list of change IDs and properties that will be
  cancelled without actually cancelling the change.
"""
function cancel_domain_config_change(
    DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearch(
        "POST",
        "/2021-01-01/opensearch/domain/$(DomainName)/config/cancel";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_domain_config_change(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearch(
        "POST",
        "/2021-01-01/opensearch/domain/$(DomainName)/config/cancel",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_service_software_update(domain_name)
    cancel_service_software_update(domain_name, params::Dict{String,<:Any})

Cancels a scheduled service software update for an Amazon OpenSearch Service domain. You
can only perform this operation before the AutomatedUpdateDate and when the domain's
UpdateStatus is PENDING_UPDATE. For more information, see Service software updates in
Amazon OpenSearch Service.

# Arguments
- `domain_name`: Name of the OpenSearch Service domain that you want to cancel the service
  software update on.

"""
function cancel_service_software_update(
    DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearch(
        "POST",
        "/2021-01-01/opensearch/serviceSoftwareUpdate/cancel",
        Dict{String,Any}("DomainName" => DomainName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_service_software_update(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearch(
        "POST",
        "/2021-01-01/opensearch/serviceSoftwareUpdate/cancel",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DomainName" => DomainName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_domain(domain_name)
    create_domain(domain_name, params::Dict{String,<:Any})

Creates an Amazon OpenSearch Service domain. For more information, see Creating and
managing Amazon OpenSearch Service domains.

# Arguments
- `domain_name`: Name of the OpenSearch Service domain to create. Domain names are unique
  across the domains owned by an account within an Amazon Web Services Region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccessPolicies"`: Identity and Access Management (IAM) policy document specifying the
  access policies for the new domain.
- `"AdvancedOptions"`: Key-value pairs to specify advanced configuration options. The
  following key-value pairs are supported:    \"rest.action.multi.allow_explicit_index\":
  \"true\" | \"false\" - Note the use of a string rather than a boolean. Specifies whether
  explicit references to indexes are allowed inside the body of HTTP requests. If you want to
  configure access policies for domain sub-resources, such as specific indexes and domain
  APIs, you must disable this property. Default is true.    \"indices.fielddata.cache.size\":
  \"80\"  - Note the use of a string rather than a boolean. Specifies the percentage of heap
  space allocated to field data. Default is unbounded.
  \"indices.query.bool.max_clause_count\": \"1024\" - Note the use of a string rather than a
  boolean. Specifies the maximum number of clauses allowed in a Lucene boolean query. Default
  is 1,024. Queries with more than the permitted number of clauses result in a TooManyClauses
  error.    \"override_main_response_version\": \"true\" | \"false\" - Note the use of a
  string rather than a boolean. Specifies whether the domain reports its version as 7.10 to
  allow Elasticsearch OSS clients and plugins to continue working with it. Default is false
  when creating a domain and true when upgrading a domain.   For more information, see
  Advanced cluster parameters.
- `"AdvancedSecurityOptions"`: Options for fine-grained access control.
- `"AutoTuneOptions"`: Options for Auto-Tune.
- `"ClusterConfig"`: Container for the cluster configuration of a domain.
- `"CognitoOptions"`: Key-value pairs to configure Amazon Cognito authentication. For more
  information, see Configuring Amazon Cognito authentication for OpenSearch Dashboards.
- `"DomainEndpointOptions"`: Additional options for the domain endpoint, such as whether to
  require HTTPS for all traffic.
- `"EBSOptions"`: Container for the parameters required to enable EBS-based storage for an
  OpenSearch Service domain.
- `"EncryptionAtRestOptions"`: Key-value pairs to enable encryption at rest.
- `"EngineVersion"`: String of format Elasticsearch_X.Y or OpenSearch_X.Y to specify the
  engine version for the OpenSearch Service domain. For example, OpenSearch_1.0 or
  Elasticsearch_7.9. For more information, see Creating and managing Amazon OpenSearch
  Service domains.
- `"IPAddressType"`: Specify either dual stack or IPv4 as your IP address type. Dual stack
  allows you to share domain resources across IPv4 and IPv6 address types, and is the
  recommended option. If you set your IP address type to dual stack, you can't change your
  address type later.
- `"LogPublishingOptions"`: Key-value pairs to configure log publishing.
- `"NodeToNodeEncryptionOptions"`: Enables node-to-node encryption.
- `"OffPeakWindowOptions"`: Specifies a daily 10-hour time block during which OpenSearch
  Service can perform configuration changes on the domain, including service software updates
  and Auto-Tune enhancements that require a blue/green deployment. If no options are
  specified, the default start time of 10:00 P.M. local time (for the Region that the domain
  is created in) is used.
- `"SnapshotOptions"`: DEPRECATED. Container for the parameters required to configure
  automated snapshots of domain indexes.
- `"SoftwareUpdateOptions"`: Software update options for the domain.
- `"TagList"`: List of tags to add to the domain upon creation.
- `"VPCOptions"`: Container for the values required to configure VPC access domains. If you
  don't specify these values, OpenSearch Service creates the domain with a public endpoint.
  For more information, see Launching your Amazon OpenSearch Service domains using a VPC.
"""
function create_domain(DomainName; aws_config::AbstractAWSConfig=current_aws_config())
    return opensearch(
        "POST",
        "/2021-01-01/opensearch/domain",
        Dict{String,Any}("DomainName" => DomainName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_domain(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearch(
        "POST",
        "/2021-01-01/opensearch/domain",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DomainName" => DomainName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_outbound_connection(connection_alias, local_domain_info, remote_domain_info)
    create_outbound_connection(connection_alias, local_domain_info, remote_domain_info, params::Dict{String,<:Any})

Creates a new cross-cluster search connection from a source Amazon OpenSearch Service
domain to a destination domain. For more information, see Cross-cluster search for Amazon
OpenSearch Service.

# Arguments
- `connection_alias`: Name of the connection.
- `local_domain_info`: Name and Region of the source (local) domain.
- `remote_domain_info`: Name and Region of the destination (remote) domain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConnectionMode"`: The connection mode.
- `"ConnectionProperties"`: The ConnectionProperties for the outbound connection.
"""
function create_outbound_connection(
    ConnectionAlias,
    LocalDomainInfo,
    RemoteDomainInfo;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearch(
        "POST",
        "/2021-01-01/opensearch/cc/outboundConnection",
        Dict{String,Any}(
            "ConnectionAlias" => ConnectionAlias,
            "LocalDomainInfo" => LocalDomainInfo,
            "RemoteDomainInfo" => RemoteDomainInfo,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_outbound_connection(
    ConnectionAlias,
    LocalDomainInfo,
    RemoteDomainInfo,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearch(
        "POST",
        "/2021-01-01/opensearch/cc/outboundConnection",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ConnectionAlias" => ConnectionAlias,
                    "LocalDomainInfo" => LocalDomainInfo,
                    "RemoteDomainInfo" => RemoteDomainInfo,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_package(package_name, package_source, package_type)
    create_package(package_name, package_source, package_type, params::Dict{String,<:Any})

Creates a package for use with Amazon OpenSearch Service domains. For more information, see
Custom packages for Amazon OpenSearch Service.

# Arguments
- `package_name`: Unique name for the package.
- `package_source`: The Amazon S3 location from which to import the package.
- `package_type`: The type of package.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"PackageDescription"`: Description of the package.
"""
function create_package(
    PackageName,
    PackageSource,
    PackageType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearch(
        "POST",
        "/2021-01-01/packages",
        Dict{String,Any}(
            "PackageName" => PackageName,
            "PackageSource" => PackageSource,
            "PackageType" => PackageType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_package(
    PackageName,
    PackageSource,
    PackageType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearch(
        "POST",
        "/2021-01-01/packages",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "PackageName" => PackageName,
                    "PackageSource" => PackageSource,
                    "PackageType" => PackageType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_vpc_endpoint(domain_arn, vpc_options)
    create_vpc_endpoint(domain_arn, vpc_options, params::Dict{String,<:Any})

Creates an Amazon OpenSearch Service-managed VPC endpoint.

# Arguments
- `domain_arn`: The Amazon Resource Name (ARN) of the domain to create the endpoint for.
- `vpc_options`: Options to specify the subnets and security groups for the endpoint.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: Unique, case-sensitive identifier to ensure idempotency of the request.
"""
function create_vpc_endpoint(
    DomainArn, VpcOptions; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearch(
        "POST",
        "/2021-01-01/opensearch/vpcEndpoints",
        Dict{String,Any}("DomainArn" => DomainArn, "VpcOptions" => VpcOptions);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_vpc_endpoint(
    DomainArn,
    VpcOptions,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearch(
        "POST",
        "/2021-01-01/opensearch/vpcEndpoints",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DomainArn" => DomainArn, "VpcOptions" => VpcOptions),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_data_source(data_source_name, domain_name)
    delete_data_source(data_source_name, domain_name, params::Dict{String,<:Any})

Deletes a direct-query data source. For more information, see Deleting an Amazon OpenSearch
Service data source with Amazon S3.

# Arguments
- `data_source_name`: The name of the data source to delete.
- `domain_name`: The name of the domain.

"""
function delete_data_source(
    DataSourceName, DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearch(
        "DELETE",
        "/2021-01-01/opensearch/domain/$(DomainName)/dataSource/$(DataSourceName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_data_source(
    DataSourceName,
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearch(
        "DELETE",
        "/2021-01-01/opensearch/domain/$(DomainName)/dataSource/$(DataSourceName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_domain(domain_name)
    delete_domain(domain_name, params::Dict{String,<:Any})

Deletes an Amazon OpenSearch Service domain and all of its data. You can't recover a domain
after you delete it.

# Arguments
- `domain_name`: The name of the domain you want to permanently delete.

"""
function delete_domain(DomainName; aws_config::AbstractAWSConfig=current_aws_config())
    return opensearch(
        "DELETE",
        "/2021-01-01/opensearch/domain/$(DomainName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_domain(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearch(
        "DELETE",
        "/2021-01-01/opensearch/domain/$(DomainName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_inbound_connection(connection_id)
    delete_inbound_connection(connection_id, params::Dict{String,<:Any})

Allows the destination Amazon OpenSearch Service domain owner to delete an existing inbound
cross-cluster search connection. For more information, see Cross-cluster search for Amazon
OpenSearch Service.

# Arguments
- `connection_id`: The ID of the inbound connection to permanently delete.

"""
function delete_inbound_connection(
    ConnectionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearch(
        "DELETE",
        "/2021-01-01/opensearch/cc/inboundConnection/$(ConnectionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_inbound_connection(
    ConnectionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearch(
        "DELETE",
        "/2021-01-01/opensearch/cc/inboundConnection/$(ConnectionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_outbound_connection(connection_id)
    delete_outbound_connection(connection_id, params::Dict{String,<:Any})

Allows the source Amazon OpenSearch Service domain owner to delete an existing outbound
cross-cluster search connection. For more information, see Cross-cluster search for Amazon
OpenSearch Service.

# Arguments
- `connection_id`: The ID of the outbound connection you want to permanently delete.

"""
function delete_outbound_connection(
    ConnectionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearch(
        "DELETE",
        "/2021-01-01/opensearch/cc/outboundConnection/$(ConnectionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_outbound_connection(
    ConnectionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearch(
        "DELETE",
        "/2021-01-01/opensearch/cc/outboundConnection/$(ConnectionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_package(package_id)
    delete_package(package_id, params::Dict{String,<:Any})

Deletes an Amazon OpenSearch Service package. For more information, see Custom packages for
Amazon OpenSearch Service.

# Arguments
- `package_id`: The internal ID of the package you want to delete. Use DescribePackages to
  find this value.

"""
function delete_package(PackageID; aws_config::AbstractAWSConfig=current_aws_config())
    return opensearch(
        "DELETE",
        "/2021-01-01/packages/$(PackageID)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_package(
    PackageID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearch(
        "DELETE",
        "/2021-01-01/packages/$(PackageID)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_vpc_endpoint(vpc_endpoint_id)
    delete_vpc_endpoint(vpc_endpoint_id, params::Dict{String,<:Any})

Deletes an Amazon OpenSearch Service-managed interface VPC endpoint.

# Arguments
- `vpc_endpoint_id`: The unique identifier of the endpoint.

"""
function delete_vpc_endpoint(
    VpcEndpointId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearch(
        "DELETE",
        "/2021-01-01/opensearch/vpcEndpoints/$(VpcEndpointId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_vpc_endpoint(
    VpcEndpointId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearch(
        "DELETE",
        "/2021-01-01/opensearch/vpcEndpoints/$(VpcEndpointId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_domain(domain_name)
    describe_domain(domain_name, params::Dict{String,<:Any})

Describes the domain configuration for the specified Amazon OpenSearch Service domain,
including the domain ID, domain service endpoint, and domain ARN.

# Arguments
- `domain_name`: The name of the domain that you want information about.

"""
function describe_domain(DomainName; aws_config::AbstractAWSConfig=current_aws_config())
    return opensearch(
        "GET",
        "/2021-01-01/opensearch/domain/$(DomainName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_domain(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearch(
        "GET",
        "/2021-01-01/opensearch/domain/$(DomainName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_domain_auto_tunes(domain_name)
    describe_domain_auto_tunes(domain_name, params::Dict{String,<:Any})

Returns the list of optimizations that Auto-Tune has made to an Amazon OpenSearch Service
domain. For more information, see Auto-Tune for Amazon OpenSearch Service.

# Arguments
- `domain_name`: Name of the domain that you want Auto-Tune details about.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: An optional parameter that specifies the maximum number of results to
  return. You can use nextToken to get the next page of results.
- `"NextToken"`: If your initial DescribeDomainAutoTunes operation returns a nextToken, you
  can include the returned nextToken in subsequent DescribeDomainAutoTunes operations, which
  returns results in the next page.
"""
function describe_domain_auto_tunes(
    DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearch(
        "GET",
        "/2021-01-01/opensearch/domain/$(DomainName)/autoTunes";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_domain_auto_tunes(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearch(
        "GET",
        "/2021-01-01/opensearch/domain/$(DomainName)/autoTunes",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_domain_change_progress(domain_name)
    describe_domain_change_progress(domain_name, params::Dict{String,<:Any})

Returns information about the current blue/green deployment happening on an Amazon
OpenSearch Service domain. For more information, see Making configuration changes in Amazon
OpenSearch Service.

# Arguments
- `domain_name`: The name of the domain to get progress information for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"changeid"`: The specific change ID for which you want to get progress information. If
  omitted, the request returns information about the most recent configuration change.
"""
function describe_domain_change_progress(
    DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearch(
        "GET",
        "/2021-01-01/opensearch/domain/$(DomainName)/progress";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_domain_change_progress(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearch(
        "GET",
        "/2021-01-01/opensearch/domain/$(DomainName)/progress",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_domain_config(domain_name)
    describe_domain_config(domain_name, params::Dict{String,<:Any})

Returns the configuration of an Amazon OpenSearch Service domain.

# Arguments
- `domain_name`: Name of the OpenSearch Service domain configuration that you want to
  describe.

"""
function describe_domain_config(
    DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearch(
        "GET",
        "/2021-01-01/opensearch/domain/$(DomainName)/config";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_domain_config(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearch(
        "GET",
        "/2021-01-01/opensearch/domain/$(DomainName)/config",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_domain_health(domain_name)
    describe_domain_health(domain_name, params::Dict{String,<:Any})

Returns information about domain and node health, the standby Availability Zone, number of
nodes per Availability Zone, and shard count per node.

# Arguments
- `domain_name`: The name of the domain.

"""
function describe_domain_health(
    DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearch(
        "GET",
        "/2021-01-01/opensearch/domain/$(DomainName)/health";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_domain_health(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearch(
        "GET",
        "/2021-01-01/opensearch/domain/$(DomainName)/health",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_domain_nodes(domain_name)
    describe_domain_nodes(domain_name, params::Dict{String,<:Any})

Returns information about domain and nodes, including data nodes, master nodes, ultrawarm
nodes, Availability Zone(s), standby nodes, node configurations, and node states.

# Arguments
- `domain_name`: The name of the domain.

"""
function describe_domain_nodes(
    DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearch(
        "GET",
        "/2021-01-01/opensearch/domain/$(DomainName)/nodes";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_domain_nodes(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearch(
        "GET",
        "/2021-01-01/opensearch/domain/$(DomainName)/nodes",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_domains(domain_names)
    describe_domains(domain_names, params::Dict{String,<:Any})

Returns domain configuration information about the specified Amazon OpenSearch Service
domains.

# Arguments
- `domain_names`: Array of OpenSearch Service domain names that you want information about.
  You must specify at least one domain name.

"""
function describe_domains(DomainNames; aws_config::AbstractAWSConfig=current_aws_config())
    return opensearch(
        "POST",
        "/2021-01-01/opensearch/domain-info",
        Dict{String,Any}("DomainNames" => DomainNames);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_domains(
    DomainNames,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearch(
        "POST",
        "/2021-01-01/opensearch/domain-info",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DomainNames" => DomainNames), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_dry_run_progress(domain_name)
    describe_dry_run_progress(domain_name, params::Dict{String,<:Any})

Describes the progress of a pre-update dry run analysis on an Amazon OpenSearch Service
domain. For more information, see Determining whether a change will cause a blue/green
deployment.

# Arguments
- `domain_name`: The name of the domain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"dryRunId"`: The unique identifier of the dry run.
- `"loadDryRunConfig"`: Whether to include the configuration of the dry run in the
  response. The configuration specifies the updates that you're planning to make on the
  domain.
"""
function describe_dry_run_progress(
    DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearch(
        "GET",
        "/2021-01-01/opensearch/domain/$(DomainName)/dryRun";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_dry_run_progress(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearch(
        "GET",
        "/2021-01-01/opensearch/domain/$(DomainName)/dryRun",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_inbound_connections()
    describe_inbound_connections(params::Dict{String,<:Any})

Lists all the inbound cross-cluster search connections for a destination (remote) Amazon
OpenSearch Service domain. For more information, see Cross-cluster search for Amazon
OpenSearch Service.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`:  A list of filters used to match properties for inbound cross-cluster
  connections.
- `"MaxResults"`: An optional parameter that specifies the maximum number of results to
  return. You can use nextToken to get the next page of results.
- `"NextToken"`: If your initial DescribeInboundConnections operation returns a nextToken,
  you can include the returned nextToken in subsequent DescribeInboundConnections operations,
  which returns results in the next page.
"""
function describe_inbound_connections(; aws_config::AbstractAWSConfig=current_aws_config())
    return opensearch(
        "POST",
        "/2021-01-01/opensearch/cc/inboundConnection/search";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_inbound_connections(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearch(
        "POST",
        "/2021-01-01/opensearch/cc/inboundConnection/search",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_instance_type_limits(engine_version, instance_type)
    describe_instance_type_limits(engine_version, instance_type, params::Dict{String,<:Any})

Describes the instance count, storage, and master node limits for a given OpenSearch or
Elasticsearch version and instance type.

# Arguments
- `engine_version`: Version of OpenSearch or Elasticsearch, in the format Elasticsearch_X.Y
  or OpenSearch_X.Y. Defaults to the latest version of OpenSearch.
- `instance_type`: The OpenSearch Service instance type for which you need limit
  information.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"domainName"`: The name of the domain. Only specify if you need the limits for an
  existing domain.
"""
function describe_instance_type_limits(
    EngineVersion, InstanceType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearch(
        "GET",
        "/2021-01-01/opensearch/instanceTypeLimits/$(EngineVersion)/$(InstanceType)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_instance_type_limits(
    EngineVersion,
    InstanceType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearch(
        "GET",
        "/2021-01-01/opensearch/instanceTypeLimits/$(EngineVersion)/$(InstanceType)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_outbound_connections()
    describe_outbound_connections(params::Dict{String,<:Any})

Lists all the outbound cross-cluster connections for a local (source) Amazon OpenSearch
Service domain. For more information, see Cross-cluster search for Amazon OpenSearch
Service.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: List of filter names and values that you can use for requests.
- `"MaxResults"`: An optional parameter that specifies the maximum number of results to
  return. You can use nextToken to get the next page of results.
- `"NextToken"`: If your initial DescribeOutboundConnections operation returns a nextToken,
  you can include the returned nextToken in subsequent DescribeOutboundConnections
  operations, which returns results in the next page.
"""
function describe_outbound_connections(; aws_config::AbstractAWSConfig=current_aws_config())
    return opensearch(
        "POST",
        "/2021-01-01/opensearch/cc/outboundConnection/search";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_outbound_connections(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearch(
        "POST",
        "/2021-01-01/opensearch/cc/outboundConnection/search",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_packages()
    describe_packages(params::Dict{String,<:Any})

Describes all packages available to OpenSearch Service. For more information, see Custom
packages for Amazon OpenSearch Service.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: Only returns packages that match the DescribePackagesFilterList values.
- `"MaxResults"`: An optional parameter that specifies the maximum number of results to
  return. You can use nextToken to get the next page of results.
- `"NextToken"`: If your initial DescribePackageFilters operation returns a nextToken, you
  can include the returned nextToken in subsequent DescribePackageFilters operations, which
  returns results in the next page.
"""
function describe_packages(; aws_config::AbstractAWSConfig=current_aws_config())
    return opensearch(
        "POST",
        "/2021-01-01/packages/describe";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_packages(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearch(
        "POST",
        "/2021-01-01/packages/describe",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_reserved_instance_offerings()
    describe_reserved_instance_offerings(params::Dict{String,<:Any})

Describes the available Amazon OpenSearch Service Reserved Instance offerings for a given
Region. For more information, see Reserved Instances in Amazon OpenSearch Service.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: An optional parameter that specifies the maximum number of results to
  return. You can use nextToken to get the next page of results.
- `"nextToken"`: If your initial DescribeReservedInstanceOfferings operation returns a
  nextToken, you can include the returned nextToken in subsequent
  DescribeReservedInstanceOfferings operations, which returns results in the next page.
- `"offeringId"`: The Reserved Instance identifier filter value. Use this parameter to show
  only the available instance types that match the specified reservation identifier.
"""
function describe_reserved_instance_offerings(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearch(
        "GET",
        "/2021-01-01/opensearch/reservedInstanceOfferings";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_reserved_instance_offerings(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearch(
        "GET",
        "/2021-01-01/opensearch/reservedInstanceOfferings",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_reserved_instances()
    describe_reserved_instances(params::Dict{String,<:Any})

Describes the Amazon OpenSearch Service instances that you have reserved in a given Region.
For more information, see Reserved Instances in Amazon OpenSearch Service.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: An optional parameter that specifies the maximum number of results to
  return. You can use nextToken to get the next page of results.
- `"nextToken"`: If your initial DescribeReservedInstances operation returns a nextToken,
  you can include the returned nextToken in subsequent DescribeReservedInstances operations,
  which returns results in the next page.
- `"reservationId"`: The reserved instance identifier filter value. Use this parameter to
  show only the reservation that matches the specified reserved OpenSearch instance ID.
"""
function describe_reserved_instances(; aws_config::AbstractAWSConfig=current_aws_config())
    return opensearch(
        "GET",
        "/2021-01-01/opensearch/reservedInstances";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_reserved_instances(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearch(
        "GET",
        "/2021-01-01/opensearch/reservedInstances",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_vpc_endpoints(vpc_endpoint_ids)
    describe_vpc_endpoints(vpc_endpoint_ids, params::Dict{String,<:Any})

Describes one or more Amazon OpenSearch Service-managed VPC endpoints.

# Arguments
- `vpc_endpoint_ids`: The unique identifiers of the endpoints to get information about.

"""
function describe_vpc_endpoints(
    VpcEndpointIds; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearch(
        "POST",
        "/2021-01-01/opensearch/vpcEndpoints/describe",
        Dict{String,Any}("VpcEndpointIds" => VpcEndpointIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_vpc_endpoints(
    VpcEndpointIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearch(
        "POST",
        "/2021-01-01/opensearch/vpcEndpoints/describe",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("VpcEndpointIds" => VpcEndpointIds), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    dissociate_package(domain_name, package_id)
    dissociate_package(domain_name, package_id, params::Dict{String,<:Any})

Removes a package from the specified Amazon OpenSearch Service domain. The package can't be
in use with any OpenSearch index for the dissociation to succeed. The package is still
available in OpenSearch Service for association later. For more information, see Custom
packages for Amazon OpenSearch Service.

# Arguments
- `domain_name`: Name of the domain to dissociate the package from.
- `package_id`: Internal ID of the package to dissociate from the domain. Use
  ListPackagesForDomain to find this value.

"""
function dissociate_package(
    DomainName, PackageID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearch(
        "POST",
        "/2021-01-01/packages/dissociate/$(PackageID)/$(DomainName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function dissociate_package(
    DomainName,
    PackageID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearch(
        "POST",
        "/2021-01-01/packages/dissociate/$(PackageID)/$(DomainName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_compatible_versions()
    get_compatible_versions(params::Dict{String,<:Any})

Returns a map of OpenSearch or Elasticsearch versions and the versions you can upgrade them
to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"domainName"`: The name of an existing domain. Provide this parameter to limit the
  results to a single domain.
"""
function get_compatible_versions(; aws_config::AbstractAWSConfig=current_aws_config())
    return opensearch(
        "GET",
        "/2021-01-01/opensearch/compatibleVersions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_compatible_versions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearch(
        "GET",
        "/2021-01-01/opensearch/compatibleVersions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_data_source(data_source_name, domain_name)
    get_data_source(data_source_name, domain_name, params::Dict{String,<:Any})

Retrieves information about a direct query data source.

# Arguments
- `data_source_name`: The name of the data source to get information about.
- `domain_name`: The name of the domain.

"""
function get_data_source(
    DataSourceName, DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearch(
        "GET",
        "/2021-01-01/opensearch/domain/$(DomainName)/dataSource/$(DataSourceName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_data_source(
    DataSourceName,
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearch(
        "GET",
        "/2021-01-01/opensearch/domain/$(DomainName)/dataSource/$(DataSourceName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_domain_maintenance_status(domain_name, maintenance_id)
    get_domain_maintenance_status(domain_name, maintenance_id, params::Dict{String,<:Any})

The status of the maintenance action.

# Arguments
- `domain_name`: The name of the domain.
- `maintenance_id`: The request ID of the maintenance action.

"""
function get_domain_maintenance_status(
    DomainName, maintenanceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearch(
        "GET",
        "/2021-01-01/opensearch/domain/$(DomainName)/domainMaintenance",
        Dict{String,Any}("maintenanceId" => maintenanceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_domain_maintenance_status(
    DomainName,
    maintenanceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearch(
        "GET",
        "/2021-01-01/opensearch/domain/$(DomainName)/domainMaintenance",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("maintenanceId" => maintenanceId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_package_version_history(package_id)
    get_package_version_history(package_id, params::Dict{String,<:Any})

Returns a list of Amazon OpenSearch Service package versions, along with their creation
time, commit message, and plugin properties (if the package is a zip plugin package). For
more information, see Custom packages for Amazon OpenSearch Service.

# Arguments
- `package_id`: The unique identifier of the package.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: An optional parameter that specifies the maximum number of results to
  return. You can use nextToken to get the next page of results.
- `"nextToken"`: If your initial GetPackageVersionHistory operation returns a nextToken,
  you can include the returned nextToken in subsequent GetPackageVersionHistory operations,
  which returns results in the next page.
"""
function get_package_version_history(
    PackageID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearch(
        "GET",
        "/2021-01-01/packages/$(PackageID)/history";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_package_version_history(
    PackageID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearch(
        "GET",
        "/2021-01-01/packages/$(PackageID)/history",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_upgrade_history(domain_name)
    get_upgrade_history(domain_name, params::Dict{String,<:Any})

Retrieves the complete history of the last 10 upgrades performed on an Amazon OpenSearch
Service domain.

# Arguments
- `domain_name`: The name of an existing domain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: An optional parameter that specifies the maximum number of results to
  return. You can use nextToken to get the next page of results.
- `"nextToken"`: If your initial GetUpgradeHistory operation returns a nextToken, you can
  include the returned nextToken in subsequent GetUpgradeHistory operations, which returns
  results in the next page.
"""
function get_upgrade_history(DomainName; aws_config::AbstractAWSConfig=current_aws_config())
    return opensearch(
        "GET",
        "/2021-01-01/opensearch/upgradeDomain/$(DomainName)/history";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_upgrade_history(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearch(
        "GET",
        "/2021-01-01/opensearch/upgradeDomain/$(DomainName)/history",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_upgrade_status(domain_name)
    get_upgrade_status(domain_name, params::Dict{String,<:Any})

Returns the most recent status of the last upgrade or upgrade eligibility check performed
on an Amazon OpenSearch Service domain.

# Arguments
- `domain_name`: The domain of the domain to get upgrade status information for.

"""
function get_upgrade_status(DomainName; aws_config::AbstractAWSConfig=current_aws_config())
    return opensearch(
        "GET",
        "/2021-01-01/opensearch/upgradeDomain/$(DomainName)/status";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_upgrade_status(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearch(
        "GET",
        "/2021-01-01/opensearch/upgradeDomain/$(DomainName)/status",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_data_sources(domain_name)
    list_data_sources(domain_name, params::Dict{String,<:Any})

Lists direct-query data sources for a specific domain. For more information, see For more
information, see Working with Amazon OpenSearch Service direct queries with Amazon S3.

# Arguments
- `domain_name`: The name of the domain.

"""
function list_data_sources(DomainName; aws_config::AbstractAWSConfig=current_aws_config())
    return opensearch(
        "GET",
        "/2021-01-01/opensearch/domain/$(DomainName)/dataSource";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_data_sources(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearch(
        "GET",
        "/2021-01-01/opensearch/domain/$(DomainName)/dataSource",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_domain_maintenances(domain_name)
    list_domain_maintenances(domain_name, params::Dict{String,<:Any})

A list of maintenance actions for the domain.

# Arguments
- `domain_name`: The name of the domain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"action"`: The name of the action.
- `"maxResults"`: An optional parameter that specifies the maximum number of results to
  return. You can use nextToken to get the next page of results.
- `"nextToken"`: If your initial ListDomainMaintenances operation returns a nextToken,
  include the returned nextToken in subsequent ListDomainMaintenances operations, which
  returns results in the next page.
- `"status"`: The status of the action.
"""
function list_domain_maintenances(
    DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearch(
        "GET",
        "/2021-01-01/opensearch/domain/$(DomainName)/domainMaintenances";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_domain_maintenances(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearch(
        "GET",
        "/2021-01-01/opensearch/domain/$(DomainName)/domainMaintenances",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_domain_names()
    list_domain_names(params::Dict{String,<:Any})

Returns the names of all Amazon OpenSearch Service domains owned by the current user in the
active Region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"engineType"`: Filters the output by domain engine type.
"""
function list_domain_names(; aws_config::AbstractAWSConfig=current_aws_config())
    return opensearch(
        "GET", "/2021-01-01/domain"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_domain_names(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearch(
        "GET",
        "/2021-01-01/domain",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_domains_for_package(package_id)
    list_domains_for_package(package_id, params::Dict{String,<:Any})

Lists all Amazon OpenSearch Service domains associated with a given package. For more
information, see Custom packages for Amazon OpenSearch Service.

# Arguments
- `package_id`: The unique identifier of the package for which to list associated domains.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: An optional parameter that specifies the maximum number of results to
  return. You can use nextToken to get the next page of results.
- `"nextToken"`: If your initial ListDomainsForPackage operation returns a nextToken, you
  can include the returned nextToken in subsequent ListDomainsForPackage operations, which
  returns results in the next page.
"""
function list_domains_for_package(
    PackageID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearch(
        "GET",
        "/2021-01-01/packages/$(PackageID)/domains";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_domains_for_package(
    PackageID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearch(
        "GET",
        "/2021-01-01/packages/$(PackageID)/domains",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_instance_type_details(engine_version)
    list_instance_type_details(engine_version, params::Dict{String,<:Any})

Lists all instance types and available features for a given OpenSearch or Elasticsearch
version.

# Arguments
- `engine_version`: The version of OpenSearch or Elasticsearch, in the format
  Elasticsearch_X.Y or OpenSearch_X.Y. Defaults to the latest version of OpenSearch.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"domainName"`: The name of the domain.
- `"instanceType"`: An optional parameter that lists information for a given instance type.
- `"maxResults"`: An optional parameter that specifies the maximum number of results to
  return. You can use nextToken to get the next page of results.
- `"nextToken"`: If your initial ListInstanceTypeDetails operation returns a nextToken, you
  can include the returned nextToken in subsequent ListInstanceTypeDetails operations, which
  returns results in the next page.
- `"retrieveAZs"`: An optional parameter that specifies the Availability Zones for the
  domain.
"""
function list_instance_type_details(
    EngineVersion; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearch(
        "GET",
        "/2021-01-01/opensearch/instanceTypeDetails/$(EngineVersion)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_instance_type_details(
    EngineVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearch(
        "GET",
        "/2021-01-01/opensearch/instanceTypeDetails/$(EngineVersion)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_packages_for_domain(domain_name)
    list_packages_for_domain(domain_name, params::Dict{String,<:Any})

Lists all packages associated with an Amazon OpenSearch Service domain. For more
information, see Custom packages for Amazon OpenSearch Service.

# Arguments
- `domain_name`: The name of the domain for which you want to list associated packages.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: An optional parameter that specifies the maximum number of results to
  return. You can use nextToken to get the next page of results.
- `"nextToken"`: If your initial ListPackagesForDomain operation returns a nextToken, you
  can include the returned nextToken in subsequent ListPackagesForDomain operations, which
  returns results in the next page.
"""
function list_packages_for_domain(
    DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearch(
        "GET",
        "/2021-01-01/domain/$(DomainName)/packages";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_packages_for_domain(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearch(
        "GET",
        "/2021-01-01/domain/$(DomainName)/packages",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_scheduled_actions(domain_name)
    list_scheduled_actions(domain_name, params::Dict{String,<:Any})

Retrieves a list of configuration changes that are scheduled for a domain. These changes
can be service software updates or blue/green Auto-Tune enhancements.

# Arguments
- `domain_name`: The name of the domain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: An optional parameter that specifies the maximum number of results to
  return. You can use nextToken to get the next page of results.
- `"nextToken"`: If your initial ListScheduledActions operation returns a nextToken, you
  can include the returned nextToken in subsequent ListScheduledActions operations, which
  returns results in the next page.
"""
function list_scheduled_actions(
    DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearch(
        "GET",
        "/2021-01-01/opensearch/domain/$(DomainName)/scheduledActions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_scheduled_actions(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearch(
        "GET",
        "/2021-01-01/opensearch/domain/$(DomainName)/scheduledActions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags(arn)
    list_tags(arn, params::Dict{String,<:Any})

Returns all resource tags for an Amazon OpenSearch Service domain. For more information,
see Tagging Amazon OpenSearch Service domains.

# Arguments
- `arn`: Amazon Resource Name (ARN) for the domain to view tags for.

"""
function list_tags(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return opensearch(
        "GET",
        "/2021-01-01/tags/",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearch(
        "GET",
        "/2021-01-01/tags/",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_versions()
    list_versions(params::Dict{String,<:Any})

Lists all versions of OpenSearch and Elasticsearch that Amazon OpenSearch Service supports.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: An optional parameter that specifies the maximum number of results to
  return. You can use nextToken to get the next page of results.
- `"nextToken"`: If your initial ListVersions operation returns a nextToken, you can
  include the returned nextToken in subsequent ListVersions operations, which returns results
  in the next page.
"""
function list_versions(; aws_config::AbstractAWSConfig=current_aws_config())
    return opensearch(
        "GET",
        "/2021-01-01/opensearch/versions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_versions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearch(
        "GET",
        "/2021-01-01/opensearch/versions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_vpc_endpoint_access(domain_name)
    list_vpc_endpoint_access(domain_name, params::Dict{String,<:Any})

Retrieves information about each Amazon Web Services principal that is allowed to access a
given Amazon OpenSearch Service domain through the use of an interface VPC endpoint.

# Arguments
- `domain_name`: The name of the OpenSearch Service domain to retrieve access information
  for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: If your initial ListVpcEndpointAccess operation returns a nextToken, you
  can include the returned nextToken in subsequent ListVpcEndpointAccess operations, which
  returns results in the next page.
"""
function list_vpc_endpoint_access(
    DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearch(
        "GET",
        "/2021-01-01/opensearch/domain/$(DomainName)/listVpcEndpointAccess";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_vpc_endpoint_access(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearch(
        "GET",
        "/2021-01-01/opensearch/domain/$(DomainName)/listVpcEndpointAccess",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_vpc_endpoints()
    list_vpc_endpoints(params::Dict{String,<:Any})

Retrieves all Amazon OpenSearch Service-managed VPC endpoints in the current Amazon Web
Services account and Region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: If your initial ListVpcEndpoints operation returns a nextToken, you can
  include the returned nextToken in subsequent ListVpcEndpoints operations, which returns
  results in the next page.
"""
function list_vpc_endpoints(; aws_config::AbstractAWSConfig=current_aws_config())
    return opensearch(
        "GET",
        "/2021-01-01/opensearch/vpcEndpoints";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_vpc_endpoints(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearch(
        "GET",
        "/2021-01-01/opensearch/vpcEndpoints",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_vpc_endpoints_for_domain(domain_name)
    list_vpc_endpoints_for_domain(domain_name, params::Dict{String,<:Any})

Retrieves all Amazon OpenSearch Service-managed VPC endpoints associated with a particular
domain.

# Arguments
- `domain_name`: The name of the domain to list associated VPC endpoints for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: If your initial ListEndpointsForDomain operation returns a nextToken, you
  can include the returned nextToken in subsequent ListEndpointsForDomain operations, which
  returns results in the next page.
"""
function list_vpc_endpoints_for_domain(
    DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearch(
        "GET",
        "/2021-01-01/opensearch/domain/$(DomainName)/vpcEndpoints";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_vpc_endpoints_for_domain(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearch(
        "GET",
        "/2021-01-01/opensearch/domain/$(DomainName)/vpcEndpoints",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    purchase_reserved_instance_offering(reservation_name, reserved_instance_offering_id)
    purchase_reserved_instance_offering(reservation_name, reserved_instance_offering_id, params::Dict{String,<:Any})

Allows you to purchase Amazon OpenSearch Service Reserved Instances.

# Arguments
- `reservation_name`: A customer-specified identifier to track this reservation.
- `reserved_instance_offering_id`: The ID of the Reserved Instance offering to purchase.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"InstanceCount"`: The number of OpenSearch instances to reserve.
"""
function purchase_reserved_instance_offering(
    ReservationName,
    ReservedInstanceOfferingId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearch(
        "POST",
        "/2021-01-01/opensearch/purchaseReservedInstanceOffering",
        Dict{String,Any}(
            "ReservationName" => ReservationName,
            "ReservedInstanceOfferingId" => ReservedInstanceOfferingId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function purchase_reserved_instance_offering(
    ReservationName,
    ReservedInstanceOfferingId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearch(
        "POST",
        "/2021-01-01/opensearch/purchaseReservedInstanceOffering",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ReservationName" => ReservationName,
                    "ReservedInstanceOfferingId" => ReservedInstanceOfferingId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    reject_inbound_connection(connection_id)
    reject_inbound_connection(connection_id, params::Dict{String,<:Any})

Allows the remote Amazon OpenSearch Service domain owner to reject an inbound cross-cluster
connection request.

# Arguments
- `connection_id`: The unique identifier of the inbound connection to reject.

"""
function reject_inbound_connection(
    ConnectionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearch(
        "PUT",
        "/2021-01-01/opensearch/cc/inboundConnection/$(ConnectionId)/reject";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function reject_inbound_connection(
    ConnectionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearch(
        "PUT",
        "/2021-01-01/opensearch/cc/inboundConnection/$(ConnectionId)/reject",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_tags(arn, tag_keys)
    remove_tags(arn, tag_keys, params::Dict{String,<:Any})

Removes the specified set of tags from an Amazon OpenSearch Service domain. For more
information, see  Tagging Amazon OpenSearch Service domains.

# Arguments
- `arn`: The Amazon Resource Name (ARN) of the domain from which you want to delete the
  specified tags.
- `tag_keys`: The list of tag keys to remove from the domain.

"""
function remove_tags(ARN, TagKeys; aws_config::AbstractAWSConfig=current_aws_config())
    return opensearch(
        "POST",
        "/2021-01-01/tags-removal",
        Dict{String,Any}("ARN" => ARN, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_tags(
    ARN,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearch(
        "POST",
        "/2021-01-01/tags-removal",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ARN" => ARN, "TagKeys" => TagKeys), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    revoke_vpc_endpoint_access(account, domain_name)
    revoke_vpc_endpoint_access(account, domain_name, params::Dict{String,<:Any})

Revokes access to an Amazon OpenSearch Service domain that was provided through an
interface VPC endpoint.

# Arguments
- `account`: The account ID to revoke access from.
- `domain_name`: The name of the OpenSearch Service domain.

"""
function revoke_vpc_endpoint_access(
    Account, DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearch(
        "POST",
        "/2021-01-01/opensearch/domain/$(DomainName)/revokeVpcEndpointAccess",
        Dict{String,Any}("Account" => Account);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function revoke_vpc_endpoint_access(
    Account,
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearch(
        "POST",
        "/2021-01-01/opensearch/domain/$(DomainName)/revokeVpcEndpointAccess",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Account" => Account), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_domain_maintenance(action, domain_name)
    start_domain_maintenance(action, domain_name, params::Dict{String,<:Any})

Starts the node maintenance process on the data node. These processes can include a node
reboot, an Opensearch or Elasticsearch process restart, or a Dashboard or Kibana restart.

# Arguments
- `action`: The name of the action.
- `domain_name`: The name of the domain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NodeId"`: The ID of the data node.
"""
function start_domain_maintenance(
    Action, DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearch(
        "POST",
        "/2021-01-01/opensearch/domain/$(DomainName)/domainMaintenance",
        Dict{String,Any}("Action" => Action);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_domain_maintenance(
    Action,
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearch(
        "POST",
        "/2021-01-01/opensearch/domain/$(DomainName)/domainMaintenance",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Action" => Action), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_service_software_update(domain_name)
    start_service_software_update(domain_name, params::Dict{String,<:Any})

Schedules a service software update for an Amazon OpenSearch Service domain. For more
information, see Service software updates in Amazon OpenSearch Service.

# Arguments
- `domain_name`: The name of the domain that you want to update to the latest service
  software.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DesiredStartTime"`: The Epoch timestamp when you want the service software update to
  start. You only need to specify this parameter if you set ScheduleAt to TIMESTAMP.
- `"ScheduleAt"`: When to start the service software update.    NOW - Immediately schedules
  the update to happen in the current hour if there's capacity available.    TIMESTAMP - Lets
  you specify a custom date and time to apply the update. If you specify this value, you must
  also provide a value for DesiredStartTime.    OFF_PEAK_WINDOW - Marks the update to be
  picked up during an upcoming off-peak window. There's no guarantee that the update will
  happen during the next immediate window. Depending on capacity, it might happen in
  subsequent days.   Default: NOW if you don't specify a value for DesiredStartTime, and
  TIMESTAMP if you do.
"""
function start_service_software_update(
    DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearch(
        "POST",
        "/2021-01-01/opensearch/serviceSoftwareUpdate/start",
        Dict{String,Any}("DomainName" => DomainName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_service_software_update(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearch(
        "POST",
        "/2021-01-01/opensearch/serviceSoftwareUpdate/start",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DomainName" => DomainName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_data_source(data_source_name, data_source_type, domain_name)
    update_data_source(data_source_name, data_source_type, domain_name, params::Dict{String,<:Any})

Updates a direct-query data source. For more information, see Working with Amazon
OpenSearch Service data source integrations with Amazon S3.

# Arguments
- `data_source_name`: The name of the data source to modify.
- `data_source_type`: The type of data source.
- `domain_name`: The name of the domain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A new description of the data source.
- `"Status"`: The status of the data source update.
"""
function update_data_source(
    DataSourceName,
    DataSourceType,
    DomainName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearch(
        "PUT",
        "/2021-01-01/opensearch/domain/$(DomainName)/dataSource/$(DataSourceName)",
        Dict{String,Any}("DataSourceType" => DataSourceType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_data_source(
    DataSourceName,
    DataSourceType,
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearch(
        "PUT",
        "/2021-01-01/opensearch/domain/$(DomainName)/dataSource/$(DataSourceName)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DataSourceType" => DataSourceType), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_domain_config(domain_name)
    update_domain_config(domain_name, params::Dict{String,<:Any})

Modifies the cluster configuration of the specified Amazon OpenSearch Service domain.

# Arguments
- `domain_name`: The name of the domain that you're updating.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccessPolicies"`: Identity and Access Management (IAM) access policy as a
  JSON-formatted string.
- `"AdvancedOptions"`: Key-value pairs to specify advanced configuration options. The
  following key-value pairs are supported:    \"rest.action.multi.allow_explicit_index\":
  \"true\" | \"false\" - Note the use of a string rather than a boolean. Specifies whether
  explicit references to indexes are allowed inside the body of HTTP requests. If you want to
  configure access policies for domain sub-resources, such as specific indexes and domain
  APIs, you must disable this property. Default is true.    \"indices.fielddata.cache.size\":
  \"80\"  - Note the use of a string rather than a boolean. Specifies the percentage of heap
  space allocated to field data. Default is unbounded.
  \"indices.query.bool.max_clause_count\": \"1024\" - Note the use of a string rather than a
  boolean. Specifies the maximum number of clauses allowed in a Lucene boolean query. Default
  is 1,024. Queries with more than the permitted number of clauses result in a TooManyClauses
  error.   For more information, see Advanced cluster parameters.
- `"AdvancedSecurityOptions"`: Options for fine-grained access control.
- `"AutoTuneOptions"`: Options for Auto-Tune.
- `"ClusterConfig"`: Changes that you want to make to the cluster configuration, such as
  the instance type and number of EC2 instances.
- `"CognitoOptions"`: Key-value pairs to configure Amazon Cognito authentication for
  OpenSearch Dashboards.
- `"DomainEndpointOptions"`: Additional options for the domain endpoint, such as whether to
  require HTTPS for all traffic.
- `"DryRun"`: This flag, when set to True, specifies whether the UpdateDomain request
  should return the results of a dry run analysis without actually applying the change. A dry
  run determines what type of deployment the update will cause.
- `"DryRunMode"`: The type of dry run to perform.    Basic only returns the type of
  deployment (blue/green or dynamic) that the update will cause.    Verbose runs an
  additional check to validate the changes you're making. For more information, see
  Validating a domain update.
- `"EBSOptions"`: The type and size of the EBS volume to attach to instances in the domain.
- `"EncryptionAtRestOptions"`: Encryption at rest options for the domain.
- `"IPAddressType"`: Specify either dual stack or IPv4 as your IP address type. Dual stack
  allows you to share domain resources across IPv4 and IPv6 address types, and is the
  recommended option. If your IP address type is currently set to dual stack, you can't
  change it.
- `"LogPublishingOptions"`: Options to publish OpenSearch logs to Amazon CloudWatch Logs.
- `"NodeToNodeEncryptionOptions"`: Node-to-node encryption options for the domain.
- `"OffPeakWindowOptions"`: Off-peak window options for the domain.
- `"SnapshotOptions"`: Option to set the time, in UTC format, for the daily automated
  snapshot. Default value is 0 hours.
- `"SoftwareUpdateOptions"`: Service software update options for the domain.
- `"VPCOptions"`: Options to specify the subnets and security groups for a VPC endpoint.
  For more information, see Launching your Amazon OpenSearch Service domains using a VPC.
"""
function update_domain_config(
    DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearch(
        "POST",
        "/2021-01-01/opensearch/domain/$(DomainName)/config";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_domain_config(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearch(
        "POST",
        "/2021-01-01/opensearch/domain/$(DomainName)/config",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_package(package_id, package_source)
    update_package(package_id, package_source, params::Dict{String,<:Any})

Updates a package for use with Amazon OpenSearch Service domains. For more information, see
Custom packages for Amazon OpenSearch Service.

# Arguments
- `package_id`: The unique identifier for the package.
- `package_source`: Amazon S3 bucket and key for the package.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CommitMessage"`: Commit message for the updated file, which is shown as part of
  GetPackageVersionHistoryResponse.
- `"PackageDescription"`: A new description of the package.
"""
function update_package(
    PackageID, PackageSource; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearch(
        "POST",
        "/2021-01-01/packages/update",
        Dict{String,Any}("PackageID" => PackageID, "PackageSource" => PackageSource);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_package(
    PackageID,
    PackageSource,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearch(
        "POST",
        "/2021-01-01/packages/update",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "PackageID" => PackageID, "PackageSource" => PackageSource
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_scheduled_action(action_id, action_type, domain_name, schedule_at)
    update_scheduled_action(action_id, action_type, domain_name, schedule_at, params::Dict{String,<:Any})

Reschedules a planned domain configuration change for a later time. This change can be a
scheduled service software update or a blue/green Auto-Tune enhancement.

# Arguments
- `action_id`: The unique identifier of the action to reschedule. To retrieve this ID, send
  a ListScheduledActions request.
- `action_type`: The type of action to reschedule. Can be one of SERVICE_SOFTWARE_UPDATE,
  JVM_HEAP_SIZE_TUNING, or JVM_YOUNG_GEN_TUNING. To retrieve this value, send a
  ListScheduledActions request.
- `domain_name`: The name of the domain to reschedule an action for.
- `schedule_at`: When to schedule the action.    NOW - Immediately schedules the update to
  happen in the current hour if there's capacity available.    TIMESTAMP - Lets you specify a
  custom date and time to apply the update. If you specify this value, you must also provide
  a value for DesiredStartTime.    OFF_PEAK_WINDOW - Marks the action to be picked up during
  an upcoming off-peak window. There's no guarantee that the change will be implemented
  during the next immediate window. Depending on capacity, it might happen in subsequent
  days.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DesiredStartTime"`: The time to implement the change, in Coordinated Universal Time
  (UTC). Only specify this parameter if you set ScheduleAt to TIMESTAMP.
"""
function update_scheduled_action(
    ActionID,
    ActionType,
    DomainName,
    ScheduleAt;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearch(
        "PUT",
        "/2021-01-01/opensearch/domain/$(DomainName)/scheduledAction/update",
        Dict{String,Any}(
            "ActionID" => ActionID, "ActionType" => ActionType, "ScheduleAt" => ScheduleAt
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_scheduled_action(
    ActionID,
    ActionType,
    DomainName,
    ScheduleAt,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearch(
        "PUT",
        "/2021-01-01/opensearch/domain/$(DomainName)/scheduledAction/update",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ActionID" => ActionID,
                    "ActionType" => ActionType,
                    "ScheduleAt" => ScheduleAt,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_vpc_endpoint(vpc_endpoint_id, vpc_options)
    update_vpc_endpoint(vpc_endpoint_id, vpc_options, params::Dict{String,<:Any})

Modifies an Amazon OpenSearch Service-managed interface VPC endpoint.

# Arguments
- `vpc_endpoint_id`: The unique identifier of the endpoint.
- `vpc_options`: The security groups and/or subnets to add, remove, or modify.

"""
function update_vpc_endpoint(
    VpcEndpointId, VpcOptions; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearch(
        "POST",
        "/2021-01-01/opensearch/vpcEndpoints/update",
        Dict{String,Any}("VpcEndpointId" => VpcEndpointId, "VpcOptions" => VpcOptions);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_vpc_endpoint(
    VpcEndpointId,
    VpcOptions,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearch(
        "POST",
        "/2021-01-01/opensearch/vpcEndpoints/update",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "VpcEndpointId" => VpcEndpointId, "VpcOptions" => VpcOptions
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    upgrade_domain(domain_name, target_version)
    upgrade_domain(domain_name, target_version, params::Dict{String,<:Any})

Allows you to either upgrade your Amazon OpenSearch Service domain or perform an upgrade
eligibility check to a compatible version of OpenSearch or Elasticsearch.

# Arguments
- `domain_name`: Name of the OpenSearch Service domain that you want to upgrade.
- `target_version`: OpenSearch or Elasticsearch version to which you want to upgrade, in
  the format Opensearch_X.Y or Elasticsearch_X.Y.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AdvancedOptions"`: Only supports the override_main_response_version parameter and not
  other advanced options. You can only include this option when upgrading to an OpenSearch
  version. Specifies whether the domain reports its version as 7.10 so that it continues to
  work with Elasticsearch OSS clients and plugins.
- `"PerformCheckOnly"`: When true, indicates that an upgrade eligibility check needs to be
  performed. Does not actually perform the upgrade.
"""
function upgrade_domain(
    DomainName, TargetVersion; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearch(
        "POST",
        "/2021-01-01/opensearch/upgradeDomain",
        Dict{String,Any}("DomainName" => DomainName, "TargetVersion" => TargetVersion);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function upgrade_domain(
    DomainName,
    TargetVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearch(
        "POST",
        "/2021-01-01/opensearch/upgradeDomain",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DomainName" => DomainName, "TargetVersion" => TargetVersion
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: iot_events
using AWS.Compat
using AWS.UUIDs

"""
    create_alarm_model(alarm_model_name, alarm_rule, role_arn)
    create_alarm_model(alarm_model_name, alarm_rule, role_arn, params::Dict{String,<:Any})

Creates an alarm model to monitor an AWS IoT Events input attribute. You can use the alarm
to get notified when the value is outside a specified range. For more information, see
Create an alarm model in the AWS IoT Events Developer Guide.

# Arguments
- `alarm_model_name`: A unique name that helps you identify the alarm model. You can't
  change this name after you create the alarm model.
- `alarm_rule`: Defines when your alarm is invoked.
- `role_arn`: The ARN of the IAM role that allows the alarm to perform actions and access
  AWS resources. For more information, see Amazon Resource Names (ARNs) in the AWS General
  Reference.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"alarmCapabilities"`: Contains the configuration information of alarm state changes.
- `"alarmEventActions"`: Contains information about one or more alarm actions.
- `"alarmModelDescription"`: A description that tells you what the alarm model detects.
- `"alarmNotification"`: Contains information about one or more notification actions.
- `"key"`: An input attribute used as a key to create an alarm. AWS IoT Events routes
  inputs associated with this key to the alarm.
- `"severity"`: A non-negative integer that reflects the severity level of the alarm.
- `"tags"`: A list of key-value pairs that contain metadata for the alarm model. The tags
  help you manage the alarm model. For more information, see Tagging your AWS IoT Events
  resources in the AWS IoT Events Developer Guide. You can create up to 50 tags for one alarm
  model.
"""
function create_alarm_model(
    alarmModelName, alarmRule, roleArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_events(
        "POST",
        "/alarm-models",
        Dict{String,Any}(
            "alarmModelName" => alarmModelName,
            "alarmRule" => alarmRule,
            "roleArn" => roleArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_alarm_model(
    alarmModelName,
    alarmRule,
    roleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_events(
        "POST",
        "/alarm-models",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "alarmModelName" => alarmModelName,
                    "alarmRule" => alarmRule,
                    "roleArn" => roleArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_detector_model(detector_model_definition, detector_model_name, role_arn)
    create_detector_model(detector_model_definition, detector_model_name, role_arn, params::Dict{String,<:Any})

Creates a detector model.

# Arguments
- `detector_model_definition`: Information that defines how the detectors operate.
- `detector_model_name`: The name of the detector model.
- `role_arn`: The ARN of the role that grants permission to AWS IoT Events to perform its
  operations.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"detectorModelDescription"`: A brief description of the detector model.
- `"evaluationMethod"`: Information about the order in which events are evaluated and how
  actions are executed.
- `"key"`: The input attribute key used to identify a device or system to create a detector
  (an instance of the detector model) and then to route each input received to the
  appropriate detector (instance). This parameter uses a JSON-path expression in the message
  payload of each input to specify the attribute-value pair that is used to identify the
  device associated with the input.
- `"tags"`: Metadata that can be used to manage the detector model.
"""
function create_detector_model(
    detectorModelDefinition,
    detectorModelName,
    roleArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_events(
        "POST",
        "/detector-models",
        Dict{String,Any}(
            "detectorModelDefinition" => detectorModelDefinition,
            "detectorModelName" => detectorModelName,
            "roleArn" => roleArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_detector_model(
    detectorModelDefinition,
    detectorModelName,
    roleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_events(
        "POST",
        "/detector-models",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "detectorModelDefinition" => detectorModelDefinition,
                    "detectorModelName" => detectorModelName,
                    "roleArn" => roleArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_input(input_definition, input_name)
    create_input(input_definition, input_name, params::Dict{String,<:Any})

Creates an input.

# Arguments
- `input_definition`: The definition of the input.
- `input_name`: The name you want to give to the input.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"inputDescription"`: A brief description of the input.
- `"tags"`: Metadata that can be used to manage the input.
"""
function create_input(
    inputDefinition, inputName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_events(
        "POST",
        "/inputs",
        Dict{String,Any}("inputDefinition" => inputDefinition, "inputName" => inputName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_input(
    inputDefinition,
    inputName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_events(
        "POST",
        "/inputs",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "inputDefinition" => inputDefinition, "inputName" => inputName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_alarm_model(alarm_model_name)
    delete_alarm_model(alarm_model_name, params::Dict{String,<:Any})

Deletes an alarm model. Any alarm instances that were created based on this alarm model are
also deleted. This action can't be undone.

# Arguments
- `alarm_model_name`: The name of the alarm model.

"""
function delete_alarm_model(
    alarmModelName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_events(
        "DELETE",
        "/alarm-models/$(alarmModelName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_alarm_model(
    alarmModelName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_events(
        "DELETE",
        "/alarm-models/$(alarmModelName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_detector_model(detector_model_name)
    delete_detector_model(detector_model_name, params::Dict{String,<:Any})

Deletes a detector model. Any active instances of the detector model are also deleted.

# Arguments
- `detector_model_name`: The name of the detector model to be deleted.

"""
function delete_detector_model(
    detectorModelName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_events(
        "DELETE",
        "/detector-models/$(detectorModelName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_detector_model(
    detectorModelName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_events(
        "DELETE",
        "/detector-models/$(detectorModelName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_input(input_name)
    delete_input(input_name, params::Dict{String,<:Any})

Deletes an input.

# Arguments
- `input_name`: The name of the input to delete.

"""
function delete_input(inputName; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_events(
        "DELETE",
        "/inputs/$(inputName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_input(
    inputName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_events(
        "DELETE",
        "/inputs/$(inputName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_alarm_model(alarm_model_name)
    describe_alarm_model(alarm_model_name, params::Dict{String,<:Any})

Retrieves information about an alarm model. If you don't specify a value for the
alarmModelVersion parameter, the latest version is returned.

# Arguments
- `alarm_model_name`: The name of the alarm model.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"version"`: The version of the alarm model.
"""
function describe_alarm_model(
    alarmModelName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_events(
        "GET",
        "/alarm-models/$(alarmModelName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_alarm_model(
    alarmModelName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_events(
        "GET",
        "/alarm-models/$(alarmModelName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_detector_model(detector_model_name)
    describe_detector_model(detector_model_name, params::Dict{String,<:Any})

Describes a detector model. If the version parameter is not specified, information about
the latest version is returned.

# Arguments
- `detector_model_name`: The name of the detector model.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"version"`: The version of the detector model.
"""
function describe_detector_model(
    detectorModelName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_events(
        "GET",
        "/detector-models/$(detectorModelName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_detector_model(
    detectorModelName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_events(
        "GET",
        "/detector-models/$(detectorModelName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_detector_model_analysis(analysis_id)
    describe_detector_model_analysis(analysis_id, params::Dict{String,<:Any})

Retrieves runtime information about a detector model analysis.  After AWS IoT Events starts
analyzing your detector model, you have up to 24 hours to retrieve the analysis results.

# Arguments
- `analysis_id`: The ID of the analysis result that you want to retrieve.

"""
function describe_detector_model_analysis(
    analysisId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_events(
        "GET",
        "/analysis/detector-models/$(analysisId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_detector_model_analysis(
    analysisId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_events(
        "GET",
        "/analysis/detector-models/$(analysisId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_input(input_name)
    describe_input(input_name, params::Dict{String,<:Any})

Describes an input.

# Arguments
- `input_name`: The name of the input.

"""
function describe_input(inputName; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_events(
        "GET",
        "/inputs/$(inputName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_input(
    inputName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_events(
        "GET",
        "/inputs/$(inputName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_logging_options()
    describe_logging_options(params::Dict{String,<:Any})

Retrieves the current settings of the AWS IoT Events logging options.

"""
function describe_logging_options(; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_events(
        "GET", "/logging"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_logging_options(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_events(
        "GET", "/logging", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_detector_model_analysis_results(analysis_id)
    get_detector_model_analysis_results(analysis_id, params::Dict{String,<:Any})

Retrieves one or more analysis results of the detector model.  After AWS IoT Events starts
analyzing your detector model, you have up to 24 hours to retrieve the analysis results.

# Arguments
- `analysis_id`: The ID of the analysis result that you want to retrieve.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to be returned per request.
- `"nextToken"`: The token that you can use to return the next set of results.
"""
function get_detector_model_analysis_results(
    analysisId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_events(
        "GET",
        "/analysis/detector-models/$(analysisId)/results";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_detector_model_analysis_results(
    analysisId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_events(
        "GET",
        "/analysis/detector-models/$(analysisId)/results",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_alarm_model_versions(alarm_model_name)
    list_alarm_model_versions(alarm_model_name, params::Dict{String,<:Any})

Lists all the versions of an alarm model. The operation returns only the metadata
associated with each alarm model version.

# Arguments
- `alarm_model_name`: The name of the alarm model.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to be returned per request.
- `"nextToken"`: The token that you can use to return the next set of results.
"""
function list_alarm_model_versions(
    alarmModelName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_events(
        "GET",
        "/alarm-models/$(alarmModelName)/versions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_alarm_model_versions(
    alarmModelName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_events(
        "GET",
        "/alarm-models/$(alarmModelName)/versions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_alarm_models()
    list_alarm_models(params::Dict{String,<:Any})

Lists the alarm models that you created. The operation returns only the metadata associated
with each alarm model.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to be returned per request.
- `"nextToken"`: The token that you can use to return the next set of results.
"""
function list_alarm_models(; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_events(
        "GET", "/alarm-models"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_alarm_models(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_events(
        "GET",
        "/alarm-models",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_detector_model_versions(detector_model_name)
    list_detector_model_versions(detector_model_name, params::Dict{String,<:Any})

Lists all the versions of a detector model. Only the metadata associated with each detector
model version is returned.

# Arguments
- `detector_model_name`: The name of the detector model whose versions are returned.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to be returned per request.
- `"nextToken"`: The token that you can use to return the next set of results.
"""
function list_detector_model_versions(
    detectorModelName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_events(
        "GET",
        "/detector-models/$(detectorModelName)/versions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_detector_model_versions(
    detectorModelName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_events(
        "GET",
        "/detector-models/$(detectorModelName)/versions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_detector_models()
    list_detector_models(params::Dict{String,<:Any})

Lists the detector models you have created. Only the metadata associated with each detector
model is returned.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to be returned per request.
- `"nextToken"`: The token that you can use to return the next set of results.
"""
function list_detector_models(; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_events(
        "GET", "/detector-models"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_detector_models(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_events(
        "GET",
        "/detector-models",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_input_routings(input_identifier)
    list_input_routings(input_identifier, params::Dict{String,<:Any})

 Lists one or more input routings.

# Arguments
- `input_identifier`:  The identifer of the routed input.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:  The maximum number of results to be returned per request.
- `"nextToken"`:  The token that you can use to return the next set of results.
"""
function list_input_routings(
    inputIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_events(
        "POST",
        "/input-routings",
        Dict{String,Any}("inputIdentifier" => inputIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_input_routings(
    inputIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_events(
        "POST",
        "/input-routings",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("inputIdentifier" => inputIdentifier), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_inputs()
    list_inputs(params::Dict{String,<:Any})

Lists the inputs you have created.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to be returned per request.
- `"nextToken"`: The token that you can use to return the next set of results.
"""
function list_inputs(; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_events(
        "GET", "/inputs"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_inputs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_events(
        "GET", "/inputs", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists the tags (metadata) you have assigned to the resource.

# Arguments
- `resource_arn`: The ARN of the resource.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_events(
        "GET",
        "/tags",
        Dict{String,Any}("resourceArn" => resourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_events(
        "GET",
        "/tags",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceArn" => resourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_logging_options(logging_options)
    put_logging_options(logging_options, params::Dict{String,<:Any})

Sets or updates the AWS IoT Events logging options. If you update the value of any
loggingOptions field, it takes up to one minute for the change to take effect. If you
change the policy attached to the role you specified in the roleArn field (for example, to
correct an invalid policy), it takes up to five minutes for that change to take effect.

# Arguments
- `logging_options`: The new values of the AWS IoT Events logging options.

"""
function put_logging_options(
    loggingOptions; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_events(
        "PUT",
        "/logging",
        Dict{String,Any}("loggingOptions" => loggingOptions);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_logging_options(
    loggingOptions,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_events(
        "PUT",
        "/logging",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("loggingOptions" => loggingOptions), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_detector_model_analysis(detector_model_definition)
    start_detector_model_analysis(detector_model_definition, params::Dict{String,<:Any})

Performs an analysis of your detector model. For more information, see Troubleshooting a
detector model in the AWS IoT Events Developer Guide.

# Arguments
- `detector_model_definition`:

"""
function start_detector_model_analysis(
    detectorModelDefinition; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_events(
        "POST",
        "/analysis/detector-models/",
        Dict{String,Any}("detectorModelDefinition" => detectorModelDefinition);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_detector_model_analysis(
    detectorModelDefinition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_events(
        "POST",
        "/analysis/detector-models/",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("detectorModelDefinition" => detectorModelDefinition),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds to or modifies the tags of the given resource. Tags are metadata that can be used to
manage a resource.

# Arguments
- `resource_arn`: The ARN of the resource.
- `tags`: The new or modified tags for the resource.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_events(
        "POST",
        "/tags",
        Dict{String,Any}("resourceArn" => resourceArn, "tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_events(
        "POST",
        "/tags",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceArn" => resourceArn, "tags" => tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes the given tags (metadata) from the resource.

# Arguments
- `resource_arn`: The ARN of the resource.
- `tag_keys`: A list of the keys of the tags to be removed from the resource.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_events(
        "DELETE",
        "/tags",
        Dict{String,Any}("resourceArn" => resourceArn, "tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_events(
        "DELETE",
        "/tags",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceArn" => resourceArn, "tagKeys" => tagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_alarm_model(alarm_model_name, alarm_rule, role_arn)
    update_alarm_model(alarm_model_name, alarm_rule, role_arn, params::Dict{String,<:Any})

Updates an alarm model. Any alarms that were created based on the previous version are
deleted and then created again as new data arrives.

# Arguments
- `alarm_model_name`: The name of the alarm model.
- `alarm_rule`: Defines when your alarm is invoked.
- `role_arn`: The ARN of the IAM role that allows the alarm to perform actions and access
  AWS resources. For more information, see Amazon Resource Names (ARNs) in the AWS General
  Reference.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"alarmCapabilities"`: Contains the configuration information of alarm state changes.
- `"alarmEventActions"`: Contains information about one or more alarm actions.
- `"alarmModelDescription"`: The description of the alarm model.
- `"alarmNotification"`: Contains information about one or more notification actions.
- `"severity"`: A non-negative integer that reflects the severity level of the alarm.
"""
function update_alarm_model(
    alarmModelName, alarmRule, roleArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_events(
        "POST",
        "/alarm-models/$(alarmModelName)",
        Dict{String,Any}("alarmRule" => alarmRule, "roleArn" => roleArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_alarm_model(
    alarmModelName,
    alarmRule,
    roleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_events(
        "POST",
        "/alarm-models/$(alarmModelName)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("alarmRule" => alarmRule, "roleArn" => roleArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_detector_model(detector_model_definition, detector_model_name, role_arn)
    update_detector_model(detector_model_definition, detector_model_name, role_arn, params::Dict{String,<:Any})

Updates a detector model. Detectors (instances) spawned by the previous version are deleted
and then re-created as new inputs arrive.

# Arguments
- `detector_model_definition`: Information that defines how a detector operates.
- `detector_model_name`: The name of the detector model that is updated.
- `role_arn`: The ARN of the role that grants permission to AWS IoT Events to perform its
  operations.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"detectorModelDescription"`: A brief description of the detector model.
- `"evaluationMethod"`: Information about the order in which events are evaluated and how
  actions are executed.
"""
function update_detector_model(
    detectorModelDefinition,
    detectorModelName,
    roleArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_events(
        "POST",
        "/detector-models/$(detectorModelName)",
        Dict{String,Any}(
            "detectorModelDefinition" => detectorModelDefinition, "roleArn" => roleArn
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_detector_model(
    detectorModelDefinition,
    detectorModelName,
    roleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_events(
        "POST",
        "/detector-models/$(detectorModelName)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "detectorModelDefinition" => detectorModelDefinition,
                    "roleArn" => roleArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_input(input_definition, input_name)
    update_input(input_definition, input_name, params::Dict{String,<:Any})

Updates an input.

# Arguments
- `input_definition`: The definition of the input.
- `input_name`: The name of the input you want to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"inputDescription"`: A brief description of the input.
"""
function update_input(
    inputDefinition, inputName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_events(
        "PUT",
        "/inputs/$(inputName)",
        Dict{String,Any}("inputDefinition" => inputDefinition);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_input(
    inputDefinition,
    inputName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_events(
        "PUT",
        "/inputs/$(inputName)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("inputDefinition" => inputDefinition), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: appconfigdata
using AWS.Compat
using AWS.UUIDs

"""
    get_latest_configuration(configuration_token)
    get_latest_configuration(configuration_token, params::Dict{String,<:Any})

Retrieves the latest deployed configuration. This API may return empty configuration data
if the client already has the latest version. For more information about this API action
and to view example CLI commands that show how to use it with the StartConfigurationSession
API action, see Retrieving the configuration in the AppConfig User Guide.   Note the
following important information.   Each configuration token is only valid for one call to
GetLatestConfiguration. The GetLatestConfiguration response includes a
NextPollConfigurationToken that should always replace the token used for the just-completed
call in preparation for the next one.     GetLatestConfiguration is a priced call. For more
information, see Pricing.

# Arguments
- `configuration_token`: Token describing the current state of the configuration session.
  To obtain a token, first call the StartConfigurationSession API. Note that every call to
  GetLatestConfiguration will return a new ConfigurationToken (NextPollConfigurationToken in
  the response) and must be provided to subsequent GetLatestConfiguration API calls.  This
  token should only be used once. To support long poll use cases, the token is valid for up
  to 24 hours. If a GetLatestConfiguration call uses an expired token, the system returns
  BadRequestException.

"""
function get_latest_configuration(
    configuration_token; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appconfigdata(
        "GET",
        "/configuration",
        Dict{String,Any}("configuration_token" => configuration_token);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_latest_configuration(
    configuration_token,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appconfigdata(
        "GET",
        "/configuration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("configuration_token" => configuration_token),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_configuration_session(application_identifier, configuration_profile_identifier, environment_identifier)
    start_configuration_session(application_identifier, configuration_profile_identifier, environment_identifier, params::Dict{String,<:Any})

Starts a configuration session used to retrieve a deployed configuration. For more
information about this API action and to view example CLI commands that show how to use it
with the GetLatestConfiguration API action, see Retrieving the configuration in the
AppConfig User Guide.

# Arguments
- `application_identifier`: The application ID or the application name.
- `configuration_profile_identifier`: The configuration profile ID or the configuration
  profile name.
- `environment_identifier`: The environment ID or the environment name.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"RequiredMinimumPollIntervalInSeconds"`: Sets a constraint on a session. If you specify
  a value of, for example, 60 seconds, then the client that established the session can't
  call GetLatestConfiguration more frequently than every 60 seconds.
"""
function start_configuration_session(
    ApplicationIdentifier,
    ConfigurationProfileIdentifier,
    EnvironmentIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appconfigdata(
        "POST",
        "/configurationsessions",
        Dict{String,Any}(
            "ApplicationIdentifier" => ApplicationIdentifier,
            "ConfigurationProfileIdentifier" => ConfigurationProfileIdentifier,
            "EnvironmentIdentifier" => EnvironmentIdentifier,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_configuration_session(
    ApplicationIdentifier,
    ConfigurationProfileIdentifier,
    EnvironmentIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appconfigdata(
        "POST",
        "/configurationsessions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationIdentifier" => ApplicationIdentifier,
                    "ConfigurationProfileIdentifier" => ConfigurationProfileIdentifier,
                    "EnvironmentIdentifier" => EnvironmentIdentifier,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: sagemaker_geospatial
using AWS.Compat
using AWS.UUIDs

"""
    delete_earth_observation_job(arn)
    delete_earth_observation_job(arn, params::Dict{String,<:Any})

Use this operation to delete an Earth Observation job.

# Arguments
- `arn`: The Amazon Resource Name (ARN) of the Earth Observation job being deleted.

"""
function delete_earth_observation_job(
    Arn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sagemaker_geospatial(
        "DELETE",
        "/earth-observation-jobs/$(Arn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_earth_observation_job(
    Arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sagemaker_geospatial(
        "DELETE",
        "/earth-observation-jobs/$(Arn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_vector_enrichment_job(arn)
    delete_vector_enrichment_job(arn, params::Dict{String,<:Any})

Use this operation to delete a Vector Enrichment job.

# Arguments
- `arn`: The Amazon Resource Name (ARN) of the Vector Enrichment job being deleted.

"""
function delete_vector_enrichment_job(
    Arn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sagemaker_geospatial(
        "DELETE",
        "/vector-enrichment-jobs/$(Arn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_vector_enrichment_job(
    Arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sagemaker_geospatial(
        "DELETE",
        "/vector-enrichment-jobs/$(Arn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    export_earth_observation_job(arn, execution_role_arn, output_config)
    export_earth_observation_job(arn, execution_role_arn, output_config, params::Dict{String,<:Any})

Use this operation to export results of an Earth Observation job and optionally source
images used as input to the EOJ to an Amazon S3 location.

# Arguments
- `arn`: The input Amazon Resource Name (ARN) of the Earth Observation job being exported.
- `execution_role_arn`: The Amazon Resource Name (ARN) of the IAM role that you specified
  for the job.
- `output_config`: An object containing information about the output file.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: A unique token that guarantees that the call to this API is idempotent.
- `"ExportSourceImages"`: The source images provided to the Earth Observation job being
  exported.
"""
function export_earth_observation_job(
    Arn, ExecutionRoleArn, OutputConfig; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sagemaker_geospatial(
        "POST",
        "/export-earth-observation-job",
        Dict{String,Any}(
            "Arn" => Arn,
            "ExecutionRoleArn" => ExecutionRoleArn,
            "OutputConfig" => OutputConfig,
            "ClientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function export_earth_observation_job(
    Arn,
    ExecutionRoleArn,
    OutputConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sagemaker_geospatial(
        "POST",
        "/export-earth-observation-job",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Arn" => Arn,
                    "ExecutionRoleArn" => ExecutionRoleArn,
                    "OutputConfig" => OutputConfig,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    export_vector_enrichment_job(arn, execution_role_arn, output_config)
    export_vector_enrichment_job(arn, execution_role_arn, output_config, params::Dict{String,<:Any})

Use this operation to copy results of a Vector Enrichment job to an Amazon S3 location.

# Arguments
- `arn`: The Amazon Resource Name (ARN) of the Vector Enrichment job.
- `execution_role_arn`: The Amazon Resource Name (ARN) of the IAM rolewith permission to
  upload to the location in OutputConfig.
- `output_config`: Output location information for exporting Vector Enrichment Job results.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: A unique token that guarantees that the call to this API is idempotent.
"""
function export_vector_enrichment_job(
    Arn, ExecutionRoleArn, OutputConfig; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sagemaker_geospatial(
        "POST",
        "/export-vector-enrichment-jobs",
        Dict{String,Any}(
            "Arn" => Arn,
            "ExecutionRoleArn" => ExecutionRoleArn,
            "OutputConfig" => OutputConfig,
            "ClientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function export_vector_enrichment_job(
    Arn,
    ExecutionRoleArn,
    OutputConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sagemaker_geospatial(
        "POST",
        "/export-vector-enrichment-jobs",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Arn" => Arn,
                    "ExecutionRoleArn" => ExecutionRoleArn,
                    "OutputConfig" => OutputConfig,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_earth_observation_job(arn)
    get_earth_observation_job(arn, params::Dict{String,<:Any})

Get the details for a previously initiated Earth Observation job.

# Arguments
- `arn`: The Amazon Resource Name (ARN) of the Earth Observation job.

"""
function get_earth_observation_job(Arn; aws_config::AbstractAWSConfig=current_aws_config())
    return sagemaker_geospatial(
        "GET",
        "/earth-observation-jobs/$(Arn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_earth_observation_job(
    Arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sagemaker_geospatial(
        "GET",
        "/earth-observation-jobs/$(Arn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_raster_data_collection(arn)
    get_raster_data_collection(arn, params::Dict{String,<:Any})

Use this operation to get details of a specific raster data collection.

# Arguments
- `arn`: The Amazon Resource Name (ARN) of the raster data collection.

"""
function get_raster_data_collection(Arn; aws_config::AbstractAWSConfig=current_aws_config())
    return sagemaker_geospatial(
        "GET",
        "/raster-data-collection/$(Arn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_raster_data_collection(
    Arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sagemaker_geospatial(
        "GET",
        "/raster-data-collection/$(Arn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_tile(arn, image_assets, target, x, y, z)
    get_tile(arn, image_assets, target, x, y, z, params::Dict{String,<:Any})

Gets a web mercator tile for the given Earth Observation job.

# Arguments
- `arn`: The Amazon Resource Name (ARN) of the tile operation.
- `image_assets`: The particular assets or bands to tile.
- `target`: Determines what part of the Earth Observation job to tile. 'INPUT' or 'OUTPUT'
  are the valid options.
- `x`: The x coordinate of the tile input.
- `y`: The y coordinate of the tile input.
- `z`: The z coordinate of the tile input.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ExecutionRoleArn"`: The Amazon Resource Name (ARN) of the IAM role that you specify.
- `"ImageMask"`: Determines whether or not to return a valid data mask.
- `"OutputDataType"`: The output data type of the tile operation.
- `"OutputFormat"`: The data format of the output tile. The formats include .npy, .png and
  .jpg.
- `"PropertyFilters"`: Property filters for the imagery to tile.
- `"TimeRangeFilter"`: Time range filter applied to imagery to find the images to tile.
"""
function get_tile(
    Arn, ImageAssets, Target, x, y, z; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sagemaker_geospatial(
        "GET",
        "/tile/$(z)/$(x)/$(y)",
        Dict{String,Any}("Arn" => Arn, "ImageAssets" => ImageAssets, "Target" => Target);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_tile(
    Arn,
    ImageAssets,
    Target,
    x,
    y,
    z,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sagemaker_geospatial(
        "GET",
        "/tile/$(z)/$(x)/$(y)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Arn" => Arn, "ImageAssets" => ImageAssets, "Target" => Target
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_vector_enrichment_job(arn)
    get_vector_enrichment_job(arn, params::Dict{String,<:Any})

Retrieves details of a Vector Enrichment Job for a given job Amazon Resource Name (ARN).

# Arguments
- `arn`: The Amazon Resource Name (ARN) of the Vector Enrichment job.

"""
function get_vector_enrichment_job(Arn; aws_config::AbstractAWSConfig=current_aws_config())
    return sagemaker_geospatial(
        "GET",
        "/vector-enrichment-jobs/$(Arn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_vector_enrichment_job(
    Arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sagemaker_geospatial(
        "GET",
        "/vector-enrichment-jobs/$(Arn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_earth_observation_jobs()
    list_earth_observation_jobs(params::Dict{String,<:Any})

Use this operation to get a list of the Earth Observation jobs associated with the calling
Amazon Web Services account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The total number of items to return.
- `"NextToken"`: If the previous response was truncated, you receive this token. Use it in
  your next request to receive the next set of results.
- `"SortBy"`: The parameter by which to sort the results.
- `"SortOrder"`: An optional value that specifies whether you want the results sorted in
  Ascending or Descending order.
- `"StatusEquals"`: A filter that retrieves only jobs with a specific status.
"""
function list_earth_observation_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return sagemaker_geospatial(
        "POST",
        "/list-earth-observation-jobs";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_earth_observation_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sagemaker_geospatial(
        "POST",
        "/list-earth-observation-jobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_raster_data_collections()
    list_raster_data_collections(params::Dict{String,<:Any})

Use this operation to get raster data collections.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The total number of items to return.
- `"NextToken"`: If the previous response was truncated, you receive this token. Use it in
  your next request to receive the next set of results.
"""
function list_raster_data_collections(; aws_config::AbstractAWSConfig=current_aws_config())
    return sagemaker_geospatial(
        "GET",
        "/raster-data-collections";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_raster_data_collections(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sagemaker_geospatial(
        "GET",
        "/raster-data-collections",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists the tags attached to the resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource you want to tag.

"""
function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sagemaker_geospatial(
        "GET",
        "/tags/$(ResourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sagemaker_geospatial(
        "GET",
        "/tags/$(ResourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_vector_enrichment_jobs()
    list_vector_enrichment_jobs(params::Dict{String,<:Any})

Retrieves a list of vector enrichment jobs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of items to return.
- `"NextToken"`: If the previous response was truncated, you receive this token. Use it in
  your next request to receive the next set of results.
- `"SortBy"`: The parameter by which to sort the results.
- `"SortOrder"`: An optional value that specifies whether you want the results sorted in
  Ascending or Descending order.
- `"StatusEquals"`: A filter that retrieves only jobs with a specific status.
"""
function list_vector_enrichment_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return sagemaker_geospatial(
        "POST",
        "/list-vector-enrichment-jobs";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_vector_enrichment_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sagemaker_geospatial(
        "POST",
        "/list-vector-enrichment-jobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    search_raster_data_collection(arn, raster_data_collection_query)
    search_raster_data_collection(arn, raster_data_collection_query, params::Dict{String,<:Any})

Allows you run image query on a specific raster data collection to get a list of the
satellite imagery matching the selected filters.

# Arguments
- `arn`: The Amazon Resource Name (ARN) of the raster data collection.
- `raster_data_collection_query`: RasterDataCollectionQuery consisting of
  AreaOfInterest(AOI), PropertyFilters and TimeRangeFilterInput used in
  SearchRasterDataCollection.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: If the previous response was truncated, you receive this token. Use it in
  your next request to receive the next set of results.
"""
function search_raster_data_collection(
    Arn, RasterDataCollectionQuery; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sagemaker_geospatial(
        "POST",
        "/search-raster-data-collection",
        Dict{String,Any}(
            "Arn" => Arn, "RasterDataCollectionQuery" => RasterDataCollectionQuery
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function search_raster_data_collection(
    Arn,
    RasterDataCollectionQuery,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sagemaker_geospatial(
        "POST",
        "/search-raster-data-collection",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Arn" => Arn, "RasterDataCollectionQuery" => RasterDataCollectionQuery
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_earth_observation_job(execution_role_arn, input_config, job_config, name)
    start_earth_observation_job(execution_role_arn, input_config, job_config, name, params::Dict{String,<:Any})

Use this operation to create an Earth observation job.

# Arguments
- `execution_role_arn`: The Amazon Resource Name (ARN) of the IAM role that you specified
  for the job.
- `input_config`: Input configuration information for the Earth Observation job.
- `job_config`: An object containing information about the job configuration.
- `name`: The name of the Earth Observation job.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: A unique token that guarantees that the call to this API is idempotent.
- `"KmsKeyId"`: The Key Management Service key ID for server-side encryption.
- `"Tags"`: Each tag consists of a key and a value.
"""
function start_earth_observation_job(
    ExecutionRoleArn,
    InputConfig,
    JobConfig,
    Name;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sagemaker_geospatial(
        "POST",
        "/earth-observation-jobs",
        Dict{String,Any}(
            "ExecutionRoleArn" => ExecutionRoleArn,
            "InputConfig" => InputConfig,
            "JobConfig" => JobConfig,
            "Name" => Name,
            "ClientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_earth_observation_job(
    ExecutionRoleArn,
    InputConfig,
    JobConfig,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sagemaker_geospatial(
        "POST",
        "/earth-observation-jobs",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ExecutionRoleArn" => ExecutionRoleArn,
                    "InputConfig" => InputConfig,
                    "JobConfig" => JobConfig,
                    "Name" => Name,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_vector_enrichment_job(execution_role_arn, input_config, job_config, name)
    start_vector_enrichment_job(execution_role_arn, input_config, job_config, name, params::Dict{String,<:Any})

Creates a Vector Enrichment job for the supplied job type. Currently, there are two
supported job types: reverse geocoding and map matching.

# Arguments
- `execution_role_arn`: The Amazon Resource Name (ARN) of the IAM role that you specified
  for the job.
- `input_config`: Input configuration information for the Vector Enrichment job.
- `job_config`: An object containing information about the job configuration.
- `name`: The name of the Vector Enrichment job.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: A unique token that guarantees that the call to this API is idempotent.
- `"KmsKeyId"`: The Key Management Service key ID for server-side encryption.
- `"Tags"`: Each tag consists of a key and a value.
"""
function start_vector_enrichment_job(
    ExecutionRoleArn,
    InputConfig,
    JobConfig,
    Name;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sagemaker_geospatial(
        "POST",
        "/vector-enrichment-jobs",
        Dict{String,Any}(
            "ExecutionRoleArn" => ExecutionRoleArn,
            "InputConfig" => InputConfig,
            "JobConfig" => JobConfig,
            "Name" => Name,
            "ClientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_vector_enrichment_job(
    ExecutionRoleArn,
    InputConfig,
    JobConfig,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sagemaker_geospatial(
        "POST",
        "/vector-enrichment-jobs",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ExecutionRoleArn" => ExecutionRoleArn,
                    "InputConfig" => InputConfig,
                    "JobConfig" => JobConfig,
                    "Name" => Name,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_earth_observation_job(arn)
    stop_earth_observation_job(arn, params::Dict{String,<:Any})

Use this operation to stop an existing earth observation job.

# Arguments
- `arn`: The Amazon Resource Name (ARN) of the Earth Observation job being stopped.

"""
function stop_earth_observation_job(Arn; aws_config::AbstractAWSConfig=current_aws_config())
    return sagemaker_geospatial(
        "POST",
        "/earth-observation-jobs/stop",
        Dict{String,Any}("Arn" => Arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_earth_observation_job(
    Arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sagemaker_geospatial(
        "POST",
        "/earth-observation-jobs/stop",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Arn" => Arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_vector_enrichment_job(arn)
    stop_vector_enrichment_job(arn, params::Dict{String,<:Any})

Stops the Vector Enrichment job for a given job ARN.

# Arguments
- `arn`: The Amazon Resource Name (ARN) of the Vector Enrichment job.

"""
function stop_vector_enrichment_job(Arn; aws_config::AbstractAWSConfig=current_aws_config())
    return sagemaker_geospatial(
        "POST",
        "/vector-enrichment-jobs/stop",
        Dict{String,Any}("Arn" => Arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_vector_enrichment_job(
    Arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sagemaker_geospatial(
        "POST",
        "/vector-enrichment-jobs/stop",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Arn" => Arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

The resource you want to tag.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource you want to tag.
- `tags`: Each tag consists of a key and a value.

"""
function tag_resource(ResourceArn, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return sagemaker_geospatial(
        "PUT",
        "/tags/$(ResourceArn)",
        Dict{String,Any}("Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceArn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sagemaker_geospatial(
        "PUT",
        "/tags/$(ResourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Tags" => Tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

The resource you want to untag.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource you want to untag.
- `tag_keys`: Keys of the tags you want to remove.

"""
function untag_resource(
    ResourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sagemaker_geospatial(
        "DELETE",
        "/tags/$(ResourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sagemaker_geospatial(
        "DELETE",
        "/tags/$(ResourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: textract
using AWS.Compat
using AWS.UUIDs

"""
    analyze_document(document, feature_types)
    analyze_document(document, feature_types, params::Dict{String,<:Any})

Analyzes an input document for relationships between detected items.  The types of
information returned are as follows:    Form data (key-value pairs). The related
information is returned in two Block objects, each of type KEY_VALUE_SET: a KEY Block
object and a VALUE Block object. For example, Name: Ana Silva Carolina contains a key and
value. Name: is the key. Ana Silva Carolina is the value.   Table and table cell data. A
TABLE Block object contains information about a detected table. A CELL Block object is
returned for each cell in a table.   Lines and words of text. A LINE Block object contains
one or more WORD Block objects. All lines and words that are detected in the document are
returned (including text that doesn't have a relationship with the value of FeatureTypes).
  Signatures. A SIGNATURE Block object contains the location information of a signature in
a document. If used in conjunction with forms or tables, a signature can be given a
Key-Value pairing or be detected in the cell of a table.   Query. A QUERY Block object
contains the query text, alias and link to the associated Query results block object.
Query Result. A QUERY_RESULT Block object contains the answer to the query and an ID that
connects it to the query asked. This Block also contains a confidence score.   Selection
elements such as check boxes and option buttons (radio buttons) can be detected in form
data and in tables. A SELECTION_ELEMENT Block object contains information about a selection
element, including the selection status. You can choose which type of analysis to perform
by specifying the FeatureTypes list.  The output is returned in a list of Block objects.
AnalyzeDocument is a synchronous operation. To analyze documents asynchronously, use
StartDocumentAnalysis. For more information, see Document Text Analysis.

# Arguments
- `document`: The input document as base64-encoded bytes or an Amazon S3 object. If you use
  the AWS CLI to call Amazon Textract operations, you can't pass image bytes. The document
  must be an image in JPEG, PNG, PDF, or TIFF format. If you're using an AWS SDK to call
  Amazon Textract, you might not need to base64-encode image bytes that are passed using the
  Bytes field.
- `feature_types`: A list of the types of analysis to perform. Add TABLES to the list to
  return information about the tables that are detected in the input document. Add FORMS to
  return detected form data. Add SIGNATURES to return the locations of detected signatures.
  Add LAYOUT to the list to return information about the layout of the document. All lines
  and words detected in the document are included in the response (including text that isn't
  related to the value of FeatureTypes).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AdaptersConfig"`: Specifies the adapter to be used when analyzing a document.
- `"HumanLoopConfig"`: Sets the configuration for the human in the loop workflow for
  analyzing documents.
- `"QueriesConfig"`: Contains Queries and the alias for those Queries, as determined by the
  input.
"""
function analyze_document(
    Document, FeatureTypes; aws_config::AbstractAWSConfig=current_aws_config()
)
    return textract(
        "AnalyzeDocument",
        Dict{String,Any}("Document" => Document, "FeatureTypes" => FeatureTypes);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function analyze_document(
    Document,
    FeatureTypes,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return textract(
        "AnalyzeDocument",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Document" => Document, "FeatureTypes" => FeatureTypes),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    analyze_expense(document)
    analyze_expense(document, params::Dict{String,<:Any})

 AnalyzeExpense synchronously analyzes an input document for financially related
relationships between text. Information is returned as ExpenseDocuments and seperated as
follows:    LineItemGroups- A data set containing LineItems which store information about
the lines of text, such as an item purchased and its price on a receipt.    SummaryFields-
Contains all other information a receipt, such as header information or the vendors name.

# Arguments
- `document`:

"""
function analyze_expense(Document; aws_config::AbstractAWSConfig=current_aws_config())
    return textract(
        "AnalyzeExpense",
        Dict{String,Any}("Document" => Document);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function analyze_expense(
    Document,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return textract(
        "AnalyzeExpense",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Document" => Document), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    analyze_id(document_pages)
    analyze_id(document_pages, params::Dict{String,<:Any})

Analyzes identity documents for relevant information. This information is extracted and
returned as IdentityDocumentFields, which records both the normalized field and value of
the extracted text. Unlike other Amazon Textract operations, AnalyzeID doesn't return any
Geometry data.

# Arguments
- `document_pages`: The document being passed to AnalyzeID.

"""
function analyze_id(DocumentPages; aws_config::AbstractAWSConfig=current_aws_config())
    return textract(
        "AnalyzeID",
        Dict{String,Any}("DocumentPages" => DocumentPages);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function analyze_id(
    DocumentPages,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return textract(
        "AnalyzeID",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DocumentPages" => DocumentPages), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_adapter(adapter_name, feature_types)
    create_adapter(adapter_name, feature_types, params::Dict{String,<:Any})

Creates an adapter, which can be fine-tuned for enhanced performance on user provided
documents. Takes an AdapterName and FeatureType. Currently the only supported feature type
is QUERIES. You can also provide a Description, Tags, and a ClientRequestToken. You can
choose whether or not the adapter should be AutoUpdated with the AutoUpdate argument. By
default, AutoUpdate is set to DISABLED.

# Arguments
- `adapter_name`: The name to be assigned to the adapter being created.
- `feature_types`: The type of feature that the adapter is being trained on. Currrenly,
  supported feature types are: QUERIES

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AutoUpdate"`: Controls whether or not the adapter should automatically update.
- `"ClientRequestToken"`: Idempotent token is used to recognize the request. If the same
  token is used with multiple CreateAdapter requests, the same session is returned. This
  token is employed to avoid unintentionally creating the same session multiple times.
- `"Description"`: The description to be assigned to the adapter being created.
- `"Tags"`: A list of tags to be added to the adapter.
"""
function create_adapter(
    AdapterName, FeatureTypes; aws_config::AbstractAWSConfig=current_aws_config()
)
    return textract(
        "CreateAdapter",
        Dict{String,Any}(
            "AdapterName" => AdapterName,
            "FeatureTypes" => FeatureTypes,
            "ClientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_adapter(
    AdapterName,
    FeatureTypes,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return textract(
        "CreateAdapter",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AdapterName" => AdapterName,
                    "FeatureTypes" => FeatureTypes,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_adapter_version(adapter_id, dataset_config, output_config)
    create_adapter_version(adapter_id, dataset_config, output_config, params::Dict{String,<:Any})

Creates a new version of an adapter. Operates on a provided AdapterId and a specified
dataset provided via the DatasetConfig argument. Requires that you specify an Amazon S3
bucket with the OutputConfig argument. You can provide an optional KMSKeyId, an optional
ClientRequestToken, and optional tags.

# Arguments
- `adapter_id`: A string containing a unique ID for the adapter that will receive a new
  version.
- `dataset_config`: Specifies a dataset used to train a new adapter version. Takes a
  ManifestS3Object as the value.
- `output_config`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: Idempotent token is used to recognize the request. If the same
  token is used with multiple CreateAdapterVersion requests, the same session is returned.
  This token is employed to avoid unintentionally creating the same session multiple times.
- `"KMSKeyId"`: The identifier for your AWS Key Management Service key (AWS KMS key). Used
  to encrypt your documents.
- `"Tags"`: A set of tags (key-value pairs) that you want to attach to the adapter version.
"""
function create_adapter_version(
    AdapterId,
    DatasetConfig,
    OutputConfig;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return textract(
        "CreateAdapterVersion",
        Dict{String,Any}(
            "AdapterId" => AdapterId,
            "DatasetConfig" => DatasetConfig,
            "OutputConfig" => OutputConfig,
            "ClientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_adapter_version(
    AdapterId,
    DatasetConfig,
    OutputConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return textract(
        "CreateAdapterVersion",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AdapterId" => AdapterId,
                    "DatasetConfig" => DatasetConfig,
                    "OutputConfig" => OutputConfig,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_adapter(adapter_id)
    delete_adapter(adapter_id, params::Dict{String,<:Any})

Deletes an Amazon Textract adapter. Takes an AdapterId and deletes the adapter specified by
the ID.

# Arguments
- `adapter_id`: A string containing a unique ID for the adapter to be deleted.

"""
function delete_adapter(AdapterId; aws_config::AbstractAWSConfig=current_aws_config())
    return textract(
        "DeleteAdapter",
        Dict{String,Any}("AdapterId" => AdapterId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_adapter(
    AdapterId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return textract(
        "DeleteAdapter",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AdapterId" => AdapterId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_adapter_version(adapter_id, adapter_version)
    delete_adapter_version(adapter_id, adapter_version, params::Dict{String,<:Any})

Deletes an Amazon Textract adapter version. Requires that you specify both an AdapterId and
a AdapterVersion. Deletes the adapter version specified by the AdapterId and the
AdapterVersion.

# Arguments
- `adapter_id`: A string containing a unique ID for the adapter version that will be
  deleted.
- `adapter_version`: Specifies the adapter version to be deleted.

"""
function delete_adapter_version(
    AdapterId, AdapterVersion; aws_config::AbstractAWSConfig=current_aws_config()
)
    return textract(
        "DeleteAdapterVersion",
        Dict{String,Any}("AdapterId" => AdapterId, "AdapterVersion" => AdapterVersion);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_adapter_version(
    AdapterId,
    AdapterVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return textract(
        "DeleteAdapterVersion",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AdapterId" => AdapterId, "AdapterVersion" => AdapterVersion
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    detect_document_text(document)
    detect_document_text(document, params::Dict{String,<:Any})

Detects text in the input document. Amazon Textract can detect lines of text and the words
that make up a line of text. The input document must be in one of the following image
formats: JPEG, PNG, PDF, or TIFF. DetectDocumentText returns the detected text in an array
of Block objects.  Each document page has as an associated Block of type PAGE. Each PAGE
Block object is the parent of LINE Block objects that represent the lines of detected text
on a page. A LINE Block object is a parent for each word that makes up the line. Words are
represented by Block objects of type WORD.  DetectDocumentText is a synchronous operation.
To analyze documents asynchronously, use StartDocumentTextDetection. For more information,
see Document Text Detection.

# Arguments
- `document`: The input document as base64-encoded bytes or an Amazon S3 object. If you use
  the AWS CLI to call Amazon Textract operations, you can't pass image bytes. The document
  must be an image in JPEG or PNG format. If you're using an AWS SDK to call Amazon Textract,
  you might not need to base64-encode image bytes that are passed using the Bytes field.

"""
function detect_document_text(Document; aws_config::AbstractAWSConfig=current_aws_config())
    return textract(
        "DetectDocumentText",
        Dict{String,Any}("Document" => Document);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function detect_document_text(
    Document,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return textract(
        "DetectDocumentText",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Document" => Document), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_adapter(adapter_id)
    get_adapter(adapter_id, params::Dict{String,<:Any})

Gets configuration information for an adapter specified by an AdapterId, returning
information on AdapterName, Description, CreationTime, AutoUpdate status, and FeatureTypes.

# Arguments
- `adapter_id`: A string containing a unique ID for the adapter.

"""
function get_adapter(AdapterId; aws_config::AbstractAWSConfig=current_aws_config())
    return textract(
        "GetAdapter",
        Dict{String,Any}("AdapterId" => AdapterId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_adapter(
    AdapterId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return textract(
        "GetAdapter",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AdapterId" => AdapterId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_adapter_version(adapter_id, adapter_version)
    get_adapter_version(adapter_id, adapter_version, params::Dict{String,<:Any})

Gets configuration information for the specified adapter version, including: AdapterId,
AdapterVersion, FeatureTypes, Status, StatusMessage, DatasetConfig, KMSKeyId, OutputConfig,
Tags and EvaluationMetrics.

# Arguments
- `adapter_id`: A string specifying a unique ID for the adapter version you want to
  retrieve information for.
- `adapter_version`: A string specifying the adapter version you want to retrieve
  information for.

"""
function get_adapter_version(
    AdapterId, AdapterVersion; aws_config::AbstractAWSConfig=current_aws_config()
)
    return textract(
        "GetAdapterVersion",
        Dict{String,Any}("AdapterId" => AdapterId, "AdapterVersion" => AdapterVersion);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_adapter_version(
    AdapterId,
    AdapterVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return textract(
        "GetAdapterVersion",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AdapterId" => AdapterId, "AdapterVersion" => AdapterVersion
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_document_analysis(job_id)
    get_document_analysis(job_id, params::Dict{String,<:Any})

Gets the results for an Amazon Textract asynchronous operation that analyzes text in a
document. You start asynchronous text analysis by calling StartDocumentAnalysis, which
returns a job identifier (JobId). When the text analysis operation finishes, Amazon
Textract publishes a completion status to the Amazon Simple Notification Service (Amazon
SNS) topic that's registered in the initial call to StartDocumentAnalysis. To get the
results of the text-detection operation, first check that the status value published to the
Amazon SNS topic is SUCCEEDED. If so, call GetDocumentAnalysis, and pass the job identifier
(JobId) from the initial call to StartDocumentAnalysis.  GetDocumentAnalysis returns an
array of Block objects. The following types of information are returned:    Form data
(key-value pairs). The related information is returned in two Block objects, each of type
KEY_VALUE_SET: a KEY Block object and a VALUE Block object. For example, Name: Ana Silva
Carolina contains a key and value. Name: is the key. Ana Silva Carolina is the value.
Table and table cell data. A TABLE Block object contains information about a detected
table. A CELL Block object is returned for each cell in a table.   Lines and words of text.
A LINE Block object contains one or more WORD Block objects. All lines and words that are
detected in the document are returned (including text that doesn't have a relationship with
the value of the StartDocumentAnalysis FeatureTypes input parameter).    Query. A QUERY
Block object contains the query text, alias and link to the associated Query results block
object.   Query Results. A QUERY_RESULT Block object contains the answer to the query and
an ID that connects it to the query asked. This Block also contains a confidence score.
While processing a document with queries, look out for INVALID_REQUEST_PARAMETERS output.
This indicates that either the per page query limit has been exceeded or that the operation
is trying to query a page in the document which doesn’t exist.   Selection elements such
as check boxes and option buttons (radio buttons) can be detected in form data and in
tables. A SELECTION_ELEMENT Block object contains information about a selection element,
including the selection status. Use the MaxResults parameter to limit the number of blocks
that are returned. If there are more results than specified in MaxResults, the value of
NextToken in the operation response contains a pagination token for getting the next set of
results. To get the next page of results, call GetDocumentAnalysis, and populate the
NextToken request parameter with the token value that's returned from the previous call to
GetDocumentAnalysis. For more information, see Document Text Analysis.

# Arguments
- `job_id`: A unique identifier for the text-detection job. The JobId is returned from
  StartDocumentAnalysis. A JobId value is only valid for 7 days.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to return per paginated call. The largest
  value that you can specify is 1,000. If you specify a value greater than 1,000, a maximum
  of 1,000 results is returned. The default value is 1,000.
- `"NextToken"`: If the previous response was incomplete (because there are more blocks to
  retrieve), Amazon Textract returns a pagination token in the response. You can use this
  pagination token to retrieve the next set of blocks.
"""
function get_document_analysis(JobId; aws_config::AbstractAWSConfig=current_aws_config())
    return textract(
        "GetDocumentAnalysis",
        Dict{String,Any}("JobId" => JobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_document_analysis(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return textract(
        "GetDocumentAnalysis",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("JobId" => JobId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_document_text_detection(job_id)
    get_document_text_detection(job_id, params::Dict{String,<:Any})

Gets the results for an Amazon Textract asynchronous operation that detects text in a
document. Amazon Textract can detect lines of text and the words that make up a line of
text. You start asynchronous text detection by calling StartDocumentTextDetection, which
returns a job identifier (JobId). When the text detection operation finishes, Amazon
Textract publishes a completion status to the Amazon Simple Notification Service (Amazon
SNS) topic that's registered in the initial call to StartDocumentTextDetection. To get the
results of the text-detection operation, first check that the status value published to the
Amazon SNS topic is SUCCEEDED. If so, call GetDocumentTextDetection, and pass the job
identifier (JobId) from the initial call to StartDocumentTextDetection.
GetDocumentTextDetection returns an array of Block objects.  Each document page has as an
associated Block of type PAGE. Each PAGE Block object is the parent of LINE Block objects
that represent the lines of detected text on a page. A LINE Block object is a parent for
each word that makes up the line. Words are represented by Block objects of type WORD. Use
the MaxResults parameter to limit the number of blocks that are returned. If there are more
results than specified in MaxResults, the value of NextToken in the operation response
contains a pagination token for getting the next set of results. To get the next page of
results, call GetDocumentTextDetection, and populate the NextToken request parameter with
the token value that's returned from the previous call to GetDocumentTextDetection. For
more information, see Document Text Detection.

# Arguments
- `job_id`: A unique identifier for the text detection job. The JobId is returned from
  StartDocumentTextDetection. A JobId value is only valid for 7 days.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to return per paginated call. The largest
  value you can specify is 1,000. If you specify a value greater than 1,000, a maximum of
  1,000 results is returned. The default value is 1,000.
- `"NextToken"`: If the previous response was incomplete (because there are more blocks to
  retrieve), Amazon Textract returns a pagination token in the response. You can use this
  pagination token to retrieve the next set of blocks.
"""
function get_document_text_detection(
    JobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return textract(
        "GetDocumentTextDetection",
        Dict{String,Any}("JobId" => JobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_document_text_detection(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return textract(
        "GetDocumentTextDetection",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("JobId" => JobId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_expense_analysis(job_id)
    get_expense_analysis(job_id, params::Dict{String,<:Any})

Gets the results for an Amazon Textract asynchronous operation that analyzes invoices and
receipts. Amazon Textract finds contact information, items purchased, and vendor name, from
input invoices and receipts. You start asynchronous invoice/receipt analysis by calling
StartExpenseAnalysis, which returns a job identifier (JobId). Upon completion of the
invoice/receipt analysis, Amazon Textract publishes the completion status to the Amazon
Simple Notification Service (Amazon SNS) topic. This topic must be registered in the
initial call to StartExpenseAnalysis. To get the results of the invoice/receipt analysis
operation, first ensure that the status value published to the Amazon SNS topic is
SUCCEEDED. If so, call GetExpenseAnalysis, and pass the job identifier (JobId) from the
initial call to StartExpenseAnalysis. Use the MaxResults parameter to limit the number of
blocks that are returned. If there are more results than specified in MaxResults, the value
of NextToken in the operation response contains a pagination token for getting the next set
of results. To get the next page of results, call GetExpenseAnalysis, and populate the
NextToken request parameter with the token value that's returned from the previous call to
GetExpenseAnalysis. For more information, see Analyzing Invoices and Receipts.

# Arguments
- `job_id`: A unique identifier for the text detection job. The JobId is returned from
  StartExpenseAnalysis. A JobId value is only valid for 7 days.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to return per paginated call. The largest
  value you can specify is 20. If you specify a value greater than 20, a maximum of 20
  results is returned. The default value is 20.
- `"NextToken"`: If the previous response was incomplete (because there are more blocks to
  retrieve), Amazon Textract returns a pagination token in the response. You can use this
  pagination token to retrieve the next set of blocks.
"""
function get_expense_analysis(JobId; aws_config::AbstractAWSConfig=current_aws_config())
    return textract(
        "GetExpenseAnalysis",
        Dict{String,Any}("JobId" => JobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_expense_analysis(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return textract(
        "GetExpenseAnalysis",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("JobId" => JobId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_lending_analysis(job_id)
    get_lending_analysis(job_id, params::Dict{String,<:Any})

Gets the results for an Amazon Textract asynchronous operation that analyzes text in a
lending document.  You start asynchronous text analysis by calling StartLendingAnalysis,
which returns a job identifier (JobId). When the text analysis operation finishes, Amazon
Textract publishes a completion status to the Amazon Simple Notification Service (Amazon
SNS) topic that's registered in the initial call to StartLendingAnalysis.  To get the
results of the text analysis operation, first check that the status value published to the
Amazon SNS topic is SUCCEEDED. If so, call GetLendingAnalysis, and pass the job identifier
(JobId) from the initial call to StartLendingAnalysis.

# Arguments
- `job_id`: A unique identifier for the lending or text-detection job. The JobId is
  returned from StartLendingAnalysis. A JobId value is only valid for 7 days.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to return per paginated call. The largest
  value that you can specify is 30. If you specify a value greater than 30, a maximum of 30
  results is returned. The default value is 30.
- `"NextToken"`: If the previous response was incomplete, Amazon Textract returns a
  pagination token in the response. You can use this pagination token to retrieve the next
  set of lending results.
"""
function get_lending_analysis(JobId; aws_config::AbstractAWSConfig=current_aws_config())
    return textract(
        "GetLendingAnalysis",
        Dict{String,Any}("JobId" => JobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_lending_analysis(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return textract(
        "GetLendingAnalysis",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("JobId" => JobId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_lending_analysis_summary(job_id)
    get_lending_analysis_summary(job_id, params::Dict{String,<:Any})

Gets summarized results for the StartLendingAnalysis operation, which analyzes text in a
lending document. The returned summary consists of information about documents grouped
together by a common document type. Information like detected signatures, page numbers, and
split documents is returned with respect to the type of grouped document.  You start
asynchronous text analysis by calling StartLendingAnalysis, which returns a job identifier
(JobId). When the text analysis operation finishes, Amazon Textract publishes a completion
status to the Amazon Simple Notification Service (Amazon SNS) topic that's registered in
the initial call to StartLendingAnalysis.  To get the results of the text analysis
operation, first check that the status value published to the Amazon SNS topic is
SUCCEEDED. If so, call GetLendingAnalysisSummary, and pass the job identifier (JobId) from
the initial call to StartLendingAnalysis.

# Arguments
- `job_id`:  A unique identifier for the lending or text-detection job. The JobId is
  returned from StartLendingAnalysis. A JobId value is only valid for 7 days.

"""
function get_lending_analysis_summary(
    JobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return textract(
        "GetLendingAnalysisSummary",
        Dict{String,Any}("JobId" => JobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_lending_analysis_summary(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return textract(
        "GetLendingAnalysisSummary",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("JobId" => JobId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_adapter_versions()
    list_adapter_versions(params::Dict{String,<:Any})

List all version of an adapter that meet the specified filtration criteria.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AdapterId"`: A string containing a unique ID for the adapter to match for when listing
  adapter versions.
- `"AfterCreationTime"`: Specifies the lower bound for the ListAdapterVersions operation.
  Ensures ListAdapterVersions returns only adapter versions created after the specified
  creation time.
- `"BeforeCreationTime"`: Specifies the upper bound for the ListAdapterVersions operation.
  Ensures ListAdapterVersions returns only adapter versions created after the specified
  creation time.
- `"MaxResults"`: The maximum number of results to return when listing adapter versions.
- `"NextToken"`: Identifies the next page of results to return when listing adapter
  versions.
"""
function list_adapter_versions(; aws_config::AbstractAWSConfig=current_aws_config())
    return textract(
        "ListAdapterVersions"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_adapter_versions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return textract(
        "ListAdapterVersions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_adapters()
    list_adapters(params::Dict{String,<:Any})

Lists all adapters that match the specified filtration criteria.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AfterCreationTime"`: Specifies the lower bound for the ListAdapters operation. Ensures
  ListAdapters returns only adapters created after the specified creation time.
- `"BeforeCreationTime"`: Specifies the upper bound for the ListAdapters operation. Ensures
  ListAdapters returns only adapters created before the specified creation time.
- `"MaxResults"`: The maximum number of results to return when listing adapters.
- `"NextToken"`: Identifies the next page of results to return when listing adapters.
"""
function list_adapters(; aws_config::AbstractAWSConfig=current_aws_config())
    return textract("ListAdapters"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_adapters(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return textract(
        "ListAdapters", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists all tags for an Amazon Textract resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) that specifies the resource to list tags
  for.

"""
function list_tags_for_resource(
    ResourceARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return textract(
        "ListTagsForResource",
        Dict{String,Any}("ResourceARN" => ResourceARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return textract(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceARN" => ResourceARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_document_analysis(document_location, feature_types)
    start_document_analysis(document_location, feature_types, params::Dict{String,<:Any})

Starts the asynchronous analysis of an input document for relationships between detected
items such as key-value pairs, tables, and selection elements.  StartDocumentAnalysis can
analyze text in documents that are in JPEG, PNG, TIFF, and PDF format. The documents are
stored in an Amazon S3 bucket. Use DocumentLocation to specify the bucket name and file
name of the document.   StartDocumentAnalysis returns a job identifier (JobId) that you use
to get the results of the operation. When text analysis is finished, Amazon Textract
publishes a completion status to the Amazon Simple Notification Service (Amazon SNS) topic
that you specify in NotificationChannel. To get the results of the text analysis operation,
first check that the status value published to the Amazon SNS topic is SUCCEEDED. If so,
call GetDocumentAnalysis, and pass the job identifier (JobId) from the initial call to
StartDocumentAnalysis. For more information, see Document Text Analysis.

# Arguments
- `document_location`: The location of the document to be processed.
- `feature_types`: A list of the types of analysis to perform. Add TABLES to the list to
  return information about the tables that are detected in the input document. Add FORMS to
  return detected form data. To perform both types of analysis, add TABLES and FORMS to
  FeatureTypes. All lines and words detected in the document are included in the response
  (including text that isn't related to the value of FeatureTypes).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AdaptersConfig"`: Specifies the adapter to be used when analyzing a document.
- `"ClientRequestToken"`: The idempotent token that you use to identify the start request.
  If you use the same token with multiple StartDocumentAnalysis requests, the same JobId is
  returned. Use ClientRequestToken to prevent the same job from being accidentally started
  more than once. For more information, see Calling Amazon Textract Asynchronous Operations.
- `"JobTag"`: An identifier that you specify that's included in the completion notification
  published to the Amazon SNS topic. For example, you can use JobTag to identify the type of
  document that the completion notification corresponds to (such as a tax form or a receipt).
- `"KMSKeyId"`: The KMS key used to encrypt the inference results. This can be in either
  Key ID or Key Alias format. When a KMS key is provided, the KMS key will be used for
  server-side encryption of the objects in the customer bucket. When this parameter is not
  enabled, the result will be encrypted server side,using SSE-S3.
- `"NotificationChannel"`: The Amazon SNS topic ARN that you want Amazon Textract to
  publish the completion status of the operation to.
- `"OutputConfig"`: Sets if the output will go to a customer defined bucket. By default,
  Amazon Textract will save the results internally to be accessed by the GetDocumentAnalysis
  operation.
- `"QueriesConfig"`:
"""
function start_document_analysis(
    DocumentLocation, FeatureTypes; aws_config::AbstractAWSConfig=current_aws_config()
)
    return textract(
        "StartDocumentAnalysis",
        Dict{String,Any}(
            "DocumentLocation" => DocumentLocation, "FeatureTypes" => FeatureTypes
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_document_analysis(
    DocumentLocation,
    FeatureTypes,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return textract(
        "StartDocumentAnalysis",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DocumentLocation" => DocumentLocation, "FeatureTypes" => FeatureTypes
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_document_text_detection(document_location)
    start_document_text_detection(document_location, params::Dict{String,<:Any})

Starts the asynchronous detection of text in a document. Amazon Textract can detect lines
of text and the words that make up a line of text.  StartDocumentTextDetection can analyze
text in documents that are in JPEG, PNG, TIFF, and PDF format. The documents are stored in
an Amazon S3 bucket. Use DocumentLocation to specify the bucket name and file name of the
document.   StartTextDetection returns a job identifier (JobId) that you use to get the
results of the operation. When text detection is finished, Amazon Textract publishes a
completion status to the Amazon Simple Notification Service (Amazon SNS) topic that you
specify in NotificationChannel. To get the results of the text detection operation, first
check that the status value published to the Amazon SNS topic is SUCCEEDED. If so, call
GetDocumentTextDetection, and pass the job identifier (JobId) from the initial call to
StartDocumentTextDetection. For more information, see Document Text Detection.

# Arguments
- `document_location`: The location of the document to be processed.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: The idempotent token that's used to identify the start request.
  If you use the same token with multiple StartDocumentTextDetection requests, the same JobId
  is returned. Use ClientRequestToken to prevent the same job from being accidentally started
  more than once. For more information, see Calling Amazon Textract Asynchronous Operations.
- `"JobTag"`: An identifier that you specify that's included in the completion notification
  published to the Amazon SNS topic. For example, you can use JobTag to identify the type of
  document that the completion notification corresponds to (such as a tax form or a receipt).
- `"KMSKeyId"`: The KMS key used to encrypt the inference results. This can be in either
  Key ID or Key Alias format. When a KMS key is provided, the KMS key will be used for
  server-side encryption of the objects in the customer bucket. When this parameter is not
  enabled, the result will be encrypted server side,using SSE-S3.
- `"NotificationChannel"`: The Amazon SNS topic ARN that you want Amazon Textract to
  publish the completion status of the operation to.
- `"OutputConfig"`: Sets if the output will go to a customer defined bucket. By default
  Amazon Textract will save the results internally to be accessed with the
  GetDocumentTextDetection operation.
"""
function start_document_text_detection(
    DocumentLocation; aws_config::AbstractAWSConfig=current_aws_config()
)
    return textract(
        "StartDocumentTextDetection",
        Dict{String,Any}("DocumentLocation" => DocumentLocation);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_document_text_detection(
    DocumentLocation,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return textract(
        "StartDocumentTextDetection",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("DocumentLocation" => DocumentLocation), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_expense_analysis(document_location)
    start_expense_analysis(document_location, params::Dict{String,<:Any})

Starts the asynchronous analysis of invoices or receipts for data like contact information,
items purchased, and vendor names.  StartExpenseAnalysis can analyze text in documents that
are in JPEG, PNG, and PDF format. The documents must be stored in an Amazon S3 bucket. Use
the DocumentLocation parameter to specify the name of your S3 bucket and the name of the
document in that bucket.   StartExpenseAnalysis returns a job identifier (JobId) that you
will provide to GetExpenseAnalysis to retrieve the results of the operation. When the
analysis of the input invoices/receipts is finished, Amazon Textract publishes a completion
status to the Amazon Simple Notification Service (Amazon SNS) topic that you provide to the
NotificationChannel. To obtain the results of the invoice and receipt analysis operation,
ensure that the status value published to the Amazon SNS topic is SUCCEEDED. If so, call
GetExpenseAnalysis, and pass the job identifier (JobId) that was returned by your call to
StartExpenseAnalysis. For more information, see Analyzing Invoices and Receipts.

# Arguments
- `document_location`: The location of the document to be processed.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: The idempotent token that's used to identify the start request.
  If you use the same token with multiple StartDocumentTextDetection requests, the same JobId
  is returned. Use ClientRequestToken to prevent the same job from being accidentally started
  more than once. For more information, see Calling Amazon Textract Asynchronous Operations
- `"JobTag"`: An identifier you specify that's included in the completion notification
  published to the Amazon SNS topic. For example, you can use JobTag to identify the type of
  document that the completion notification corresponds to (such as a tax form or a receipt).
- `"KMSKeyId"`: The KMS key used to encrypt the inference results. This can be in either
  Key ID or Key Alias format. When a KMS key is provided, the KMS key will be used for
  server-side encryption of the objects in the customer bucket. When this parameter is not
  enabled, the result will be encrypted server side,using SSE-S3.
- `"NotificationChannel"`: The Amazon SNS topic ARN that you want Amazon Textract to
  publish the completion status of the operation to.
- `"OutputConfig"`: Sets if the output will go to a customer defined bucket. By default,
  Amazon Textract will save the results internally to be accessed by the GetExpenseAnalysis
  operation.
"""
function start_expense_analysis(
    DocumentLocation; aws_config::AbstractAWSConfig=current_aws_config()
)
    return textract(
        "StartExpenseAnalysis",
        Dict{String,Any}("DocumentLocation" => DocumentLocation);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_expense_analysis(
    DocumentLocation,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return textract(
        "StartExpenseAnalysis",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("DocumentLocation" => DocumentLocation), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_lending_analysis(document_location)
    start_lending_analysis(document_location, params::Dict{String,<:Any})

Starts the classification and analysis of an input document. StartLendingAnalysis initiates
the classification and analysis of a packet of lending documents. StartLendingAnalysis
operates on a document file located in an Amazon S3 bucket.  StartLendingAnalysis can
analyze text in documents that are in one of the following formats: JPEG, PNG, TIFF, PDF.
Use DocumentLocation to specify the bucket name and the file name of the document.
StartLendingAnalysis returns a job identifier (JobId) that you use to get the results of
the operation. When the text analysis is finished, Amazon Textract publishes a completion
status to the Amazon Simple Notification Service (Amazon SNS) topic that you specify in
NotificationChannel. To get the results of the text analysis operation, first check that
the status value published to the Amazon SNS topic is SUCCEEDED. If the status is SUCCEEDED
you can call either GetLendingAnalysis or GetLendingAnalysisSummary and provide the JobId
to obtain the results of the analysis. If using OutputConfig to specify an Amazon S3
bucket, the output will be contained within the specified prefix in a directory labeled
with the job-id. In the directory there are 3 sub-directories:    detailedResponse
(contains the GetLendingAnalysis response)   summaryResponse (for the
GetLendingAnalysisSummary response)   splitDocuments (documents split across logical
boundaries)

# Arguments
- `document_location`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: The idempotent token that you use to identify the start request.
  If you use the same token with multiple StartLendingAnalysis requests, the same JobId is
  returned. Use ClientRequestToken to prevent the same job from being accidentally started
  more than once. For more information, see Calling Amazon Textract Asynchronous Operations.
- `"JobTag"`: An identifier that you specify to be included in the completion notification
  published to the Amazon SNS topic. For example, you can use JobTag to identify the type of
  document that the completion notification corresponds to (such as a tax form or a receipt).
- `"KMSKeyId"`: The KMS key used to encrypt the inference results. This can be in either
  Key ID or Key Alias format. When a KMS key is provided, the KMS key will be used for
  server-side encryption of the objects in the customer bucket. When this parameter is not
  enabled, the result will be encrypted server side, using SSE-S3.
- `"NotificationChannel"`:
- `"OutputConfig"`:
"""
function start_lending_analysis(
    DocumentLocation; aws_config::AbstractAWSConfig=current_aws_config()
)
    return textract(
        "StartLendingAnalysis",
        Dict{String,Any}("DocumentLocation" => DocumentLocation);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_lending_analysis(
    DocumentLocation,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return textract(
        "StartLendingAnalysis",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("DocumentLocation" => DocumentLocation), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds one or more tags to the specified resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) that specifies the resource to be tagged.
- `tags`: A set of tags (key-value pairs) that you want to assign to the resource.

"""
function tag_resource(ResourceARN, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return textract(
        "TagResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceARN,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return textract(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes any tags with the specified keys from the specified resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) that specifies the resource to be untagged.
- `tag_keys`: Specifies the tags to be removed from the resource specified by the
  ResourceARN.

"""
function untag_resource(
    ResourceARN, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return textract(
        "UntagResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceARN,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return textract(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_adapter(adapter_id)
    update_adapter(adapter_id, params::Dict{String,<:Any})

Update the configuration for an adapter. FeatureTypes configurations cannot be updated. At
least one new parameter must be specified as an argument.

# Arguments
- `adapter_id`: A string containing a unique ID for the adapter that will be updated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AdapterName"`: The new name to be applied to the adapter.
- `"AutoUpdate"`: The new auto-update status to be applied to the adapter.
- `"Description"`: The new description to be applied to the adapter.
"""
function update_adapter(AdapterId; aws_config::AbstractAWSConfig=current_aws_config())
    return textract(
        "UpdateAdapter",
        Dict{String,Any}("AdapterId" => AdapterId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_adapter(
    AdapterId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return textract(
        "UpdateAdapter",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AdapterId" => AdapterId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: ram
using AWS.Compat
using AWS.UUIDs

"""
    accept_resource_share_invitation(resource_share_invitation_arn)
    accept_resource_share_invitation(resource_share_invitation_arn, params::Dict{String,<:Any})

Accepts an invitation to a resource share from another Amazon Web Services account. After
you accept the invitation, the resources included in the resource share are available to
interact with in the relevant Amazon Web Services Management Consoles and tools.

# Arguments
- `resource_share_invitation_arn`: The Amazon Resource Name (ARN) of the invitation that
  you want to accept.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Specifies a unique, case-sensitive identifier that you provide to ensure
  the idempotency of the request. This lets you safely retry the request without accidentally
  performing the same operation a second time. Passing the same value to a later call to an
  operation requires that you also pass the same value for all other parameters. We recommend
  that you use a UUID type of value.. If you don't provide this value, then Amazon Web
  Services generates a random one for you. If you retry the operation with the same
  ClientToken, but with different parameters, the retry fails with an
  IdempotentParameterMismatch error.
"""
function accept_resource_share_invitation(
    resourceShareInvitationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ram(
        "POST",
        "/acceptresourceshareinvitation",
        Dict{String,Any}("resourceShareInvitationArn" => resourceShareInvitationArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function accept_resource_share_invitation(
    resourceShareInvitationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ram(
        "POST",
        "/acceptresourceshareinvitation",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "resourceShareInvitationArn" => resourceShareInvitationArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_resource_share(resource_share_arn)
    associate_resource_share(resource_share_arn, params::Dict{String,<:Any})

Adds the specified list of principals and list of resources to a resource share. Principals
that already have access to this resource share immediately receive access to the added
resources. Newly added principals immediately receive access to the resources shared in
this resource share.

# Arguments
- `resource_share_arn`: Specifies the Amazon Resource Name (ARN) of the resource share that
  you want to add principals or resources to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Specifies a unique, case-sensitive identifier that you provide to ensure
  the idempotency of the request. This lets you safely retry the request without accidentally
  performing the same operation a second time. Passing the same value to a later call to an
  operation requires that you also pass the same value for all other parameters. We recommend
  that you use a UUID type of value.. If you don't provide this value, then Amazon Web
  Services generates a random one for you. If you retry the operation with the same
  ClientToken, but with different parameters, the retry fails with an
  IdempotentParameterMismatch error.
- `"principals"`: Specifies a list of principals to whom you want to the resource share.
  This can be null if you want to add only resources. What the principals can do with the
  resources in the share is determined by the RAM permissions that you associate with the
  resource share. See AssociateResourceSharePermission. You can include the following values:
    An Amazon Web Services account ID, for example: 123456789012    An Amazon Resource Name
  (ARN) of an organization in Organizations, for example:
  organizations::123456789012:organization/o-exampleorgid    An ARN of an organizational unit
  (OU) in Organizations, for example:
  organizations::123456789012:ou/o-exampleorgid/ou-examplerootid-exampleouid123    An ARN of
  an IAM role, for example: iam::123456789012:role/rolename    An ARN of an IAM user, for
  example: iam::123456789012user/username     Not all resource types can be shared with IAM
  roles and users. For more information, see Sharing with IAM roles and users in the Resource
  Access Manager User Guide.
- `"resourceArns"`: Specifies a list of Amazon Resource Names (ARNs) of the resources that
  you want to share. This can be null if you want to add only principals.
- `"sources"`: Specifies from which source accounts the service principal has access to the
  resources in this resource share.
"""
function associate_resource_share(
    resourceShareArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ram(
        "POST",
        "/associateresourceshare",
        Dict{String,Any}("resourceShareArn" => resourceShareArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_resource_share(
    resourceShareArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ram(
        "POST",
        "/associateresourceshare",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("resourceShareArn" => resourceShareArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_resource_share_permission(permission_arn, resource_share_arn)
    associate_resource_share_permission(permission_arn, resource_share_arn, params::Dict{String,<:Any})

Adds or replaces the RAM permission for a resource type included in a resource share. You
can have exactly one permission associated with each resource type in the resource share.
You can add a new RAM permission only if there are currently no resources of that resource
type currently in the resource share.

# Arguments
- `permission_arn`: Specifies the Amazon Resource Name (ARN) of the RAM permission to
  associate with the resource share. To find the ARN for a permission, use either the
  ListPermissions operation or go to the Permissions library page in the RAM console and then
  choose the name of the permission. The ARN is displayed on the detail page.
- `resource_share_arn`: Specifies the Amazon Resource Name (ARN) of the resource share to
  which you want to add or replace permissions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Specifies a unique, case-sensitive identifier that you provide to ensure
  the idempotency of the request. This lets you safely retry the request without accidentally
  performing the same operation a second time. Passing the same value to a later call to an
  operation requires that you also pass the same value for all other parameters. We recommend
  that you use a UUID type of value.. If you don't provide this value, then Amazon Web
  Services generates a random one for you. If you retry the operation with the same
  ClientToken, but with different parameters, the retry fails with an
  IdempotentParameterMismatch error.
- `"permissionVersion"`: Specifies the version of the RAM permission to associate with the
  resource share. You can specify only the version that is currently set as the default
  version for the permission. If you also set the replace pararameter to true, then this
  operation updates an outdated version of the permission to the current default version.
  You don't need to specify this parameter because the default behavior is to use the version
  that is currently set as the default version for the permission. This parameter is
  supported for backwards compatibility.
- `"replace"`: Specifies whether the specified permission should replace the existing
  permission associated with the resource share. Use true to replace the current permissions.
  Use false to add the permission to a resource share that currently doesn't have a
  permission. The default value is false.  A resource share can have only one permission per
  resource type. If a resource share already has a permission for the specified resource type
  and you don't set replace to true then the operation returns an error. This helps prevent
  accidental overwriting of a permission.
"""
function associate_resource_share_permission(
    permissionArn, resourceShareArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ram(
        "POST",
        "/associateresourcesharepermission",
        Dict{String,Any}(
            "permissionArn" => permissionArn, "resourceShareArn" => resourceShareArn
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_resource_share_permission(
    permissionArn,
    resourceShareArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ram(
        "POST",
        "/associateresourcesharepermission",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "permissionArn" => permissionArn, "resourceShareArn" => resourceShareArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_permission(name, policy_template, resource_type)
    create_permission(name, policy_template, resource_type, params::Dict{String,<:Any})

Creates a customer managed permission for a specified resource type that you can attach to
resource shares. It is created in the Amazon Web Services Region in which you call the
operation.

# Arguments
- `name`: Specifies the name of the customer managed permission. The name must be unique
  within the Amazon Web Services Region.
- `policy_template`: A string in JSON format string that contains the following elements of
  a resource-based policy:    Effect: must be set to ALLOW.    Action: specifies the actions
  that are allowed by this customer managed permission. The list must contain only actions
  that are supported by the specified resource type. For a list of all actions supported by
  each resource type, see Actions, resources, and condition keys for Amazon Web Services
  services in the Identity and Access Management User Guide.    Condition: (optional)
  specifies conditional parameters that must evaluate to true when a user attempts an action
  for that action to be allowed. For more information about the Condition element, see IAM
  policies: Condition element in the Identity and Access Management User Guide.   This
  template can't include either the Resource or Principal elements. Those are both filled in
  by RAM when it instantiates the resource-based policy on each resource shared using this
  managed permission. The Resource comes from the ARN of the specific resource that you are
  sharing. The Principal comes from the list of identities added to the resource share.
- `resource_type`: Specifies the name of the resource type that this customer managed
  permission applies to. The format is  &lt;service-code&gt;:&lt;resource-type&gt;  and is
  not case sensitive. For example, to specify an Amazon EC2 Subnet, you can use the string
  ec2:subnet. To see the list of valid values for this parameter, query the ListResourceTypes
  operation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Specifies a unique, case-sensitive identifier that you provide to ensure
  the idempotency of the request. This lets you safely retry the request without accidentally
  performing the same operation a second time. Passing the same value to a later call to an
  operation requires that you also pass the same value for all other parameters. We recommend
  that you use a UUID type of value.. If you don't provide this value, then Amazon Web
  Services generates a random one for you. If you retry the operation with the same
  ClientToken, but with different parameters, the retry fails with an
  IdempotentParameterMismatch error.
- `"tags"`: Specifies a list of one or more tag key and value pairs to attach to the
  permission.
"""
function create_permission(
    name, policyTemplate, resourceType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ram(
        "POST",
        "/createpermission",
        Dict{String,Any}(
            "name" => name,
            "policyTemplate" => policyTemplate,
            "resourceType" => resourceType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_permission(
    name,
    policyTemplate,
    resourceType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ram(
        "POST",
        "/createpermission",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "name" => name,
                    "policyTemplate" => policyTemplate,
                    "resourceType" => resourceType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_permission_version(permission_arn, policy_template)
    create_permission_version(permission_arn, policy_template, params::Dict{String,<:Any})

Creates a new version of the specified customer managed permission. The new version is
automatically set as the default version of the customer managed permission. New resource
shares automatically use the default permission. Existing resource shares continue to use
their original permission versions, but you can use ReplacePermissionAssociations to update
them. If the specified customer managed permission already has the maximum of 5 versions,
then you must delete one of the existing versions before you can create a new one.

# Arguments
- `permission_arn`: Specifies the Amazon Resource Name (ARN) of the customer managed
  permission you're creating a new version for.
- `policy_template`: A string in JSON format string that contains the following elements of
  a resource-based policy:    Effect: must be set to ALLOW.    Action: specifies the actions
  that are allowed by this customer managed permission. The list must contain only actions
  that are supported by the specified resource type. For a list of all actions supported by
  each resource type, see Actions, resources, and condition keys for Amazon Web Services
  services in the Identity and Access Management User Guide.    Condition: (optional)
  specifies conditional parameters that must evaluate to true when a user attempts an action
  for that action to be allowed. For more information about the Condition element, see IAM
  policies: Condition element in the Identity and Access Management User Guide.   This
  template can't include either the Resource or Principal elements. Those are both filled in
  by RAM when it instantiates the resource-based policy on each resource shared using this
  managed permission. The Resource comes from the ARN of the specific resource that you are
  sharing. The Principal comes from the list of identities added to the resource share.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Specifies a unique, case-sensitive identifier that you provide to ensure
  the idempotency of the request. This lets you safely retry the request without accidentally
  performing the same operation a second time. Passing the same value to a later call to an
  operation requires that you also pass the same value for all other parameters. We recommend
  that you use a UUID type of value.. If you don't provide this value, then Amazon Web
  Services generates a random one for you. If you retry the operation with the same
  ClientToken, but with different parameters, the retry fails with an
  IdempotentParameterMismatch error.
"""
function create_permission_version(
    permissionArn, policyTemplate; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ram(
        "POST",
        "/createpermissionversion",
        Dict{String,Any}(
            "permissionArn" => permissionArn, "policyTemplate" => policyTemplate
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_permission_version(
    permissionArn,
    policyTemplate,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ram(
        "POST",
        "/createpermissionversion",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "permissionArn" => permissionArn, "policyTemplate" => policyTemplate
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_resource_share(name)
    create_resource_share(name, params::Dict{String,<:Any})

Creates a resource share. You can provide a list of the Amazon Resource Names (ARNs) for
the resources that you want to share, a list of principals you want to share the resources
with, and the permissions to grant those principals.  Sharing a resource makes it available
for use by principals outside of the Amazon Web Services account that created the resource.
Sharing doesn't change any permissions or quotas that apply to the resource in the account
that created it.

# Arguments
- `name`: Specifies the name of the resource share.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"allowExternalPrincipals"`: Specifies whether principals outside your organization in
  Organizations can be associated with a resource share. A value of true lets you share with
  individual Amazon Web Services accounts that are not in your organization. A value of false
  only has meaning if your account is a member of an Amazon Web Services Organization. The
  default value is true.
- `"clientToken"`: Specifies a unique, case-sensitive identifier that you provide to ensure
  the idempotency of the request. This lets you safely retry the request without accidentally
  performing the same operation a second time. Passing the same value to a later call to an
  operation requires that you also pass the same value for all other parameters. We recommend
  that you use a UUID type of value.. If you don't provide this value, then Amazon Web
  Services generates a random one for you. If you retry the operation with the same
  ClientToken, but with different parameters, the retry fails with an
  IdempotentParameterMismatch error.
- `"permissionArns"`: Specifies the Amazon Resource Names (ARNs) of the RAM permission to
  associate with the resource share. If you do not specify an ARN for the permission, RAM
  automatically attaches the default version of the permission for each resource type. You
  can associate only one permission with each resource type included in the resource share.
- `"principals"`: Specifies a list of one or more principals to associate with the resource
  share. You can include the following values:   An Amazon Web Services account ID, for
  example: 123456789012    An Amazon Resource Name (ARN) of an organization in Organizations,
  for example: organizations::123456789012:organization/o-exampleorgid    An ARN of an
  organizational unit (OU) in Organizations, for example:
  organizations::123456789012:ou/o-exampleorgid/ou-examplerootid-exampleouid123    An ARN of
  an IAM role, for example: iam::123456789012:role/rolename    An ARN of an IAM user, for
  example: iam::123456789012user/username     Not all resource types can be shared with IAM
  roles and users. For more information, see Sharing with IAM roles and users in the Resource
  Access Manager User Guide.
- `"resourceArns"`: Specifies a list of one or more ARNs of the resources to associate with
  the resource share.
- `"sources"`: Specifies from which source accounts the service principal has access to the
  resources in this resource share.
- `"tags"`: Specifies one or more tags to attach to the resource share itself. It doesn't
  attach the tags to the resources associated with the resource share.
"""
function create_resource_share(name; aws_config::AbstractAWSConfig=current_aws_config())
    return ram(
        "POST",
        "/createresourceshare",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_resource_share(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ram(
        "POST",
        "/createresourceshare",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_permission(permission_arn)
    delete_permission(permission_arn, params::Dict{String,<:Any})

Deletes the specified customer managed permission in the Amazon Web Services Region in
which you call this operation. You can delete a customer managed permission only if it
isn't attached to any resource share. The operation deletes all versions associated with
the customer managed permission.

# Arguments
- `permission_arn`: Specifies the Amazon Resource Name (ARN) of the customer managed
  permission that you want to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Specifies a unique, case-sensitive identifier that you provide to ensure
  the idempotency of the request. This lets you safely retry the request without accidentally
  performing the same operation a second time. Passing the same value to a later call to an
  operation requires that you also pass the same value for all other parameters. We recommend
  that you use a UUID type of value.. If you don't provide this value, then Amazon Web
  Services generates a random one for you. If you retry the operation with the same
  ClientToken, but with different parameters, the retry fails with an
  IdempotentParameterMismatch error.
"""
function delete_permission(
    permissionArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ram(
        "DELETE",
        "/deletepermission",
        Dict{String,Any}("permissionArn" => permissionArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_permission(
    permissionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ram(
        "DELETE",
        "/deletepermission",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("permissionArn" => permissionArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_permission_version(permission_arn, permission_version)
    delete_permission_version(permission_arn, permission_version, params::Dict{String,<:Any})

Deletes one version of a customer managed permission. The version you specify must not be
attached to any resource share and must not be the default version for the permission. If a
customer managed permission has the maximum of 5 versions, then you must delete at least
one version before you can create another.

# Arguments
- `permission_arn`: Specifies the Amazon Resource Name (ARN) of the permission with the
  version you want to delete.
- `permission_version`: Specifies the version number to delete. You can't delete the
  default version for a customer managed permission. You can't delete a version if it's the
  only version of the permission. You must either first create another version, or delete the
  permission completely. You can't delete a version if it is attached to any resource shares.
  If the version is the default, you must first use SetDefaultPermissionVersion to set a
  different version as the default for the customer managed permission, and then use
  AssociateResourceSharePermission to update your resource shares to use the new default
  version.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Specifies a unique, case-sensitive identifier that you provide to ensure
  the idempotency of the request. This lets you safely retry the request without accidentally
  performing the same operation a second time. Passing the same value to a later call to an
  operation requires that you also pass the same value for all other parameters. We recommend
  that you use a UUID type of value.. If you don't provide this value, then Amazon Web
  Services generates a random one for you. If you retry the operation with the same
  ClientToken, but with different parameters, the retry fails with an
  IdempotentParameterMismatch error.
"""
function delete_permission_version(
    permissionArn, permissionVersion; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ram(
        "DELETE",
        "/deletepermissionversion",
        Dict{String,Any}(
            "permissionArn" => permissionArn, "permissionVersion" => permissionVersion
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_permission_version(
    permissionArn,
    permissionVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ram(
        "DELETE",
        "/deletepermissionversion",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "permissionArn" => permissionArn,
                    "permissionVersion" => permissionVersion,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_resource_share(resource_share_arn)
    delete_resource_share(resource_share_arn, params::Dict{String,<:Any})

Deletes the specified resource share.  This doesn't delete any of the resources that were
associated with the resource share; it only stops the sharing of those resources through
this resource share.

# Arguments
- `resource_share_arn`: Specifies the Amazon Resource Name (ARN) of the resource share to
  delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Specifies a unique, case-sensitive identifier that you provide to ensure
  the idempotency of the request. This lets you safely retry the request without accidentally
  performing the same operation a second time. Passing the same value to a later call to an
  operation requires that you also pass the same value for all other parameters. We recommend
  that you use a UUID type of value.. If you don't provide this value, then Amazon Web
  Services generates a random one for you. If you retry the operation with the same
  ClientToken, but with different parameters, the retry fails with an
  IdempotentParameterMismatch error.
"""
function delete_resource_share(
    resourceShareArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ram(
        "DELETE",
        "/deleteresourceshare",
        Dict{String,Any}("resourceShareArn" => resourceShareArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_resource_share(
    resourceShareArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ram(
        "DELETE",
        "/deleteresourceshare",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("resourceShareArn" => resourceShareArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_resource_share(resource_share_arn)
    disassociate_resource_share(resource_share_arn, params::Dict{String,<:Any})

Removes the specified principals or resources from participating in the specified resource
share.

# Arguments
- `resource_share_arn`: Specifies Amazon Resource Name (ARN) of the resource share that you
  want to remove resources or principals from.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Specifies a unique, case-sensitive identifier that you provide to ensure
  the idempotency of the request. This lets you safely retry the request without accidentally
  performing the same operation a second time. Passing the same value to a later call to an
  operation requires that you also pass the same value for all other parameters. We recommend
  that you use a UUID type of value.. If you don't provide this value, then Amazon Web
  Services generates a random one for you. If you retry the operation with the same
  ClientToken, but with different parameters, the retry fails with an
  IdempotentParameterMismatch error.
- `"principals"`: Specifies a list of one or more principals that no longer are to have
  access to the resources in this resource share. You can include the following values:   An
  Amazon Web Services account ID, for example: 123456789012    An Amazon Resource Name (ARN)
  of an organization in Organizations, for example:
  organizations::123456789012:organization/o-exampleorgid    An ARN of an organizational unit
  (OU) in Organizations, for example:
  organizations::123456789012:ou/o-exampleorgid/ou-examplerootid-exampleouid123    An ARN of
  an IAM role, for example: iam::123456789012:role/rolename    An ARN of an IAM user, for
  example: iam::123456789012user/username     Not all resource types can be shared with IAM
  roles and users. For more information, see Sharing with IAM roles and users in the Resource
  Access Manager User Guide.
- `"resourceArns"`: Specifies a list of Amazon Resource Names (ARNs) for one or more
  resources that you want to remove from the resource share. After the operation runs, these
  resources are no longer shared with principals associated with the resource share.
- `"sources"`: Specifies from which source accounts the service principal no longer has
  access to the resources in this resource share.
"""
function disassociate_resource_share(
    resourceShareArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ram(
        "POST",
        "/disassociateresourceshare",
        Dict{String,Any}("resourceShareArn" => resourceShareArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_resource_share(
    resourceShareArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ram(
        "POST",
        "/disassociateresourceshare",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("resourceShareArn" => resourceShareArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_resource_share_permission(permission_arn, resource_share_arn)
    disassociate_resource_share_permission(permission_arn, resource_share_arn, params::Dict{String,<:Any})

Removes a managed permission from a resource share. Permission changes take effect
immediately. You can remove a managed permission from a resource share only if there are
currently no resources of the relevant resource type currently attached to the resource
share.

# Arguments
- `permission_arn`: The Amazon Resource Name (ARN) of the managed permission to
  disassociate from the resource share. Changes to permissions take effect immediately.
- `resource_share_arn`: The Amazon Resource Name (ARN) of the resource share that you want
  to remove the managed permission from.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Specifies a unique, case-sensitive identifier that you provide to ensure
  the idempotency of the request. This lets you safely retry the request without accidentally
  performing the same operation a second time. Passing the same value to a later call to an
  operation requires that you also pass the same value for all other parameters. We recommend
  that you use a UUID type of value.. If you don't provide this value, then Amazon Web
  Services generates a random one for you. If you retry the operation with the same
  ClientToken, but with different parameters, the retry fails with an
  IdempotentParameterMismatch error.
"""
function disassociate_resource_share_permission(
    permissionArn, resourceShareArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ram(
        "POST",
        "/disassociateresourcesharepermission",
        Dict{String,Any}(
            "permissionArn" => permissionArn, "resourceShareArn" => resourceShareArn
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_resource_share_permission(
    permissionArn,
    resourceShareArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ram(
        "POST",
        "/disassociateresourcesharepermission",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "permissionArn" => permissionArn, "resourceShareArn" => resourceShareArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    enable_sharing_with_aws_organization()
    enable_sharing_with_aws_organization(params::Dict{String,<:Any})

Enables resource sharing within your organization in Organizations. This operation creates
a service-linked role called AWSServiceRoleForResourceAccessManager that has the IAM
managed policy named AWSResourceAccessManagerServiceRolePolicy attached. This role permits
RAM to retrieve information about the organization and its structure. This lets you share
resources with all of the accounts in the calling account's organization by specifying the
organization ID, or all of the accounts in an organizational unit (OU) by specifying the OU
ID. Until you enable sharing within the organization, you can specify only individual
Amazon Web Services accounts, or for supported resource types, IAM roles and users. You
must call this operation from an IAM role or user in the organization's management account.

"""
function enable_sharing_with_aws_organization(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return ram(
        "POST",
        "/enablesharingwithawsorganization";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function enable_sharing_with_aws_organization(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ram(
        "POST",
        "/enablesharingwithawsorganization",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_permission(permission_arn)
    get_permission(permission_arn, params::Dict{String,<:Any})

Retrieves the contents of a managed permission in JSON format.

# Arguments
- `permission_arn`: Specifies the Amazon Resource Name (ARN) of the permission whose
  contents you want to retrieve. To find the ARN for a permission, use either the
  ListPermissions operation or go to the Permissions library page in the RAM console and then
  choose the name of the permission. The ARN is displayed on the detail page.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"permissionVersion"`: Specifies the version number of the RAM permission to retrieve. If
  you don't specify this parameter, the operation retrieves the default version. To see the
  list of available versions, use ListPermissionVersions.
"""
function get_permission(permissionArn; aws_config::AbstractAWSConfig=current_aws_config())
    return ram(
        "POST",
        "/getpermission",
        Dict{String,Any}("permissionArn" => permissionArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_permission(
    permissionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ram(
        "POST",
        "/getpermission",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("permissionArn" => permissionArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_resource_policies(resource_arns)
    get_resource_policies(resource_arns, params::Dict{String,<:Any})

Retrieves the resource policies for the specified resources that you own and have shared.

# Arguments
- `resource_arns`: Specifies the Amazon Resource Names (ARNs) of the resources whose
  policies you want to retrieve.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Specifies the total number of results that you want included on each page
  of the response. If you do not include this parameter, it defaults to a value that is
  specific to the operation. If additional items exist beyond the number you specify, the
  NextToken response element is returned with a value (not null). Include the specified value
  as the NextToken request parameter in the next call to the operation to get the next part
  of the results. Note that the service might return fewer results than the maximum even when
  there are more results available. You should check NextToken after every operation to
  ensure that you receive all of the results.
- `"nextToken"`: Specifies that you want to receive the next page of results. Valid only if
  you received a NextToken response in the previous request. If you did, it indicates that
  more output is available. Set this parameter to the value provided by the previous call's
  NextToken response to request the next page of results.
- `"principal"`: Specifies the principal.
"""
function get_resource_policies(
    resourceArns; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ram(
        "POST",
        "/getresourcepolicies",
        Dict{String,Any}("resourceArns" => resourceArns);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_resource_policies(
    resourceArns,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ram(
        "POST",
        "/getresourcepolicies",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceArns" => resourceArns), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_resource_share_associations(association_type)
    get_resource_share_associations(association_type, params::Dict{String,<:Any})

Retrieves the lists of resources and principals that associated for resource shares that
you own.

# Arguments
- `association_type`: Specifies whether you want to retrieve the associations that involve
  a specified resource or principal.    PRINCIPAL – list the principals whose associations
  you want to see.    RESOURCE – list the resources whose associations you want to see.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"associationStatus"`: Specifies that you want to retrieve only associations that have
  this status.
- `"maxResults"`: Specifies the total number of results that you want included on each page
  of the response. If you do not include this parameter, it defaults to a value that is
  specific to the operation. If additional items exist beyond the number you specify, the
  NextToken response element is returned with a value (not null). Include the specified value
  as the NextToken request parameter in the next call to the operation to get the next part
  of the results. Note that the service might return fewer results than the maximum even when
  there are more results available. You should check NextToken after every operation to
  ensure that you receive all of the results.
- `"nextToken"`: Specifies that you want to receive the next page of results. Valid only if
  you received a NextToken response in the previous request. If you did, it indicates that
  more output is available. Set this parameter to the value provided by the previous call's
  NextToken response to request the next page of results.
- `"principal"`: Specifies the ID of the principal whose resource shares you want to
  retrieve. This can be an Amazon Web Services account ID, an organization ID, an
  organizational unit ID, or the Amazon Resource Name (ARN) of an individual IAM role or
  user. You cannot specify this parameter if the association type is RESOURCE.
- `"resourceArn"`: Specifies the Amazon Resource Name (ARN) of a resource whose resource
  shares you want to retrieve. You cannot specify this parameter if the association type is
  PRINCIPAL.
- `"resourceShareArns"`: Specifies a list of Amazon Resource Names (ARNs) of the resource
  share whose associations you want to retrieve.
"""
function get_resource_share_associations(
    associationType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ram(
        "POST",
        "/getresourceshareassociations",
        Dict{String,Any}("associationType" => associationType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_resource_share_associations(
    associationType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ram(
        "POST",
        "/getresourceshareassociations",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("associationType" => associationType), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_resource_share_invitations()
    get_resource_share_invitations(params::Dict{String,<:Any})

Retrieves details about invitations that you have received for resource shares.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Specifies the total number of results that you want included on each page
  of the response. If you do not include this parameter, it defaults to a value that is
  specific to the operation. If additional items exist beyond the number you specify, the
  NextToken response element is returned with a value (not null). Include the specified value
  as the NextToken request parameter in the next call to the operation to get the next part
  of the results. Note that the service might return fewer results than the maximum even when
  there are more results available. You should check NextToken after every operation to
  ensure that you receive all of the results.
- `"nextToken"`: Specifies that you want to receive the next page of results. Valid only if
  you received a NextToken response in the previous request. If you did, it indicates that
  more output is available. Set this parameter to the value provided by the previous call's
  NextToken response to request the next page of results.
- `"resourceShareArns"`: Specifies that you want details about invitations only for the
  resource shares described by this list of Amazon Resource Names (ARNs)
- `"resourceShareInvitationArns"`: Specifies the Amazon Resource Names (ARNs) of the
  resource share invitations you want information about.
"""
function get_resource_share_invitations(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return ram(
        "POST",
        "/getresourceshareinvitations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_resource_share_invitations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ram(
        "POST",
        "/getresourceshareinvitations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_resource_shares(resource_owner)
    get_resource_shares(resource_owner, params::Dict{String,<:Any})

Retrieves details about the resource shares that you own or that are shared with you.

# Arguments
- `resource_owner`: Specifies that you want to retrieve details of only those resource
  shares that match the following:     SELF  – resource shares that your account shares
  with other accounts     OTHER-ACCOUNTS  – resource shares that other accounts share with
  your account

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Specifies the total number of results that you want included on each page
  of the response. If you do not include this parameter, it defaults to a value that is
  specific to the operation. If additional items exist beyond the number you specify, the
  NextToken response element is returned with a value (not null). Include the specified value
  as the NextToken request parameter in the next call to the operation to get the next part
  of the results. Note that the service might return fewer results than the maximum even when
  there are more results available. You should check NextToken after every operation to
  ensure that you receive all of the results.
- `"name"`: Specifies the name of an individual resource share that you want to retrieve
  details about.
- `"nextToken"`: Specifies that you want to receive the next page of results. Valid only if
  you received a NextToken response in the previous request. If you did, it indicates that
  more output is available. Set this parameter to the value provided by the previous call's
  NextToken response to request the next page of results.
- `"permissionArn"`: Specifies that you want to retrieve details of only those resource
  shares that use the managed permission with this Amazon Resource Name (ARN).
- `"permissionVersion"`: Specifies that you want to retrieve details for only those
  resource shares that use the specified version of the managed permission.
- `"resourceShareArns"`: Specifies the Amazon Resource Names (ARNs) of individual resource
  shares that you want information about.
- `"resourceShareStatus"`: Specifies that you want to retrieve details of only those
  resource shares that have this status.
- `"tagFilters"`: Specifies that you want to retrieve details of only those resource shares
  that match the specified tag keys and values.
"""
function get_resource_shares(
    resourceOwner; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ram(
        "POST",
        "/getresourceshares",
        Dict{String,Any}("resourceOwner" => resourceOwner);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_resource_shares(
    resourceOwner,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ram(
        "POST",
        "/getresourceshares",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceOwner" => resourceOwner), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_pending_invitation_resources(resource_share_invitation_arn)
    list_pending_invitation_resources(resource_share_invitation_arn, params::Dict{String,<:Any})

Lists the resources in a resource share that is shared with you but for which the
invitation is still PENDING. That means that you haven't accepted or rejected the
invitation and the invitation hasn't expired.

# Arguments
- `resource_share_invitation_arn`: Specifies the Amazon Resource Name (ARN) of the
  invitation. You can use GetResourceShareInvitations to find the ARN of the invitation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Specifies the total number of results that you want included on each page
  of the response. If you do not include this parameter, it defaults to a value that is
  specific to the operation. If additional items exist beyond the number you specify, the
  NextToken response element is returned with a value (not null). Include the specified value
  as the NextToken request parameter in the next call to the operation to get the next part
  of the results. Note that the service might return fewer results than the maximum even when
  there are more results available. You should check NextToken after every operation to
  ensure that you receive all of the results.
- `"nextToken"`: Specifies that you want to receive the next page of results. Valid only if
  you received a NextToken response in the previous request. If you did, it indicates that
  more output is available. Set this parameter to the value provided by the previous call's
  NextToken response to request the next page of results.
- `"resourceRegionScope"`: Specifies that you want the results to include only resources
  that have the specified scope.    ALL – the results include both global and regional
  resources or resource types.    GLOBAL – the results include only global resources or
  resource types.    REGIONAL – the results include only regional resources or resource
  types.   The default value is ALL.
"""
function list_pending_invitation_resources(
    resourceShareInvitationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ram(
        "POST",
        "/listpendinginvitationresources",
        Dict{String,Any}("resourceShareInvitationArn" => resourceShareInvitationArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_pending_invitation_resources(
    resourceShareInvitationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ram(
        "POST",
        "/listpendinginvitationresources",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "resourceShareInvitationArn" => resourceShareInvitationArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_permission_associations()
    list_permission_associations(params::Dict{String,<:Any})

Lists information about the managed permission and its associations to any resource shares
that use this managed permission. This lets you see which resource shares use which
versions of the specified managed permission.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"associationStatus"`: Specifies that you want to list only those associations with
  resource shares that match this status.
- `"defaultVersion"`: When true, specifies that you want to list only those associations
  with resource shares that use the default version of the specified managed permission. When
  false (the default value), lists associations with resource shares that use any version of
  the specified managed permission.
- `"featureSet"`: Specifies that you want to list only those associations with resource
  shares that have a featureSet with this value.
- `"maxResults"`: Specifies the total number of results that you want included on each page
  of the response. If you do not include this parameter, it defaults to a value that is
  specific to the operation. If additional items exist beyond the number you specify, the
  NextToken response element is returned with a value (not null). Include the specified value
  as the NextToken request parameter in the next call to the operation to get the next part
  of the results. Note that the service might return fewer results than the maximum even when
  there are more results available. You should check NextToken after every operation to
  ensure that you receive all of the results.
- `"nextToken"`: Specifies that you want to receive the next page of results. Valid only if
  you received a NextToken response in the previous request. If you did, it indicates that
  more output is available. Set this parameter to the value provided by the previous call's
  NextToken response to request the next page of results.
- `"permissionArn"`: Specifies the Amazon Resource Name (ARN) of the managed permission.
- `"permissionVersion"`: Specifies that you want to list only those associations with
  resource shares that use this version of the managed permission. If you don't provide a
  value for this parameter, then the operation returns information about associations with
  resource shares that use any version of the managed permission.
- `"resourceType"`: Specifies that you want to list only those associations with resource
  shares that include at least one resource of this resource type.
"""
function list_permission_associations(; aws_config::AbstractAWSConfig=current_aws_config())
    return ram(
        "POST",
        "/listpermissionassociations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_permission_associations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ram(
        "POST",
        "/listpermissionassociations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_permission_versions(permission_arn)
    list_permission_versions(permission_arn, params::Dict{String,<:Any})

Lists the available versions of the specified RAM permission.

# Arguments
- `permission_arn`: Specifies the Amazon Resource Name (ARN) of the RAM permission whose
  versions you want to list. You can use the permissionVersion parameter on the
  AssociateResourceSharePermission operation to specify a non-default version to attach.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Specifies the total number of results that you want included on each page
  of the response. If you do not include this parameter, it defaults to a value that is
  specific to the operation. If additional items exist beyond the number you specify, the
  NextToken response element is returned with a value (not null). Include the specified value
  as the NextToken request parameter in the next call to the operation to get the next part
  of the results. Note that the service might return fewer results than the maximum even when
  there are more results available. You should check NextToken after every operation to
  ensure that you receive all of the results.
- `"nextToken"`: Specifies that you want to receive the next page of results. Valid only if
  you received a NextToken response in the previous request. If you did, it indicates that
  more output is available. Set this parameter to the value provided by the previous call's
  NextToken response to request the next page of results.
"""
function list_permission_versions(
    permissionArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ram(
        "POST",
        "/listpermissionversions",
        Dict{String,Any}("permissionArn" => permissionArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_permission_versions(
    permissionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ram(
        "POST",
        "/listpermissionversions",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("permissionArn" => permissionArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_permissions()
    list_permissions(params::Dict{String,<:Any})

Retrieves a list of available RAM permissions that you can use for the supported resource
types.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Specifies the total number of results that you want included on each page
  of the response. If you do not include this parameter, it defaults to a value that is
  specific to the operation. If additional items exist beyond the number you specify, the
  NextToken response element is returned with a value (not null). Include the specified value
  as the NextToken request parameter in the next call to the operation to get the next part
  of the results. Note that the service might return fewer results than the maximum even when
  there are more results available. You should check NextToken after every operation to
  ensure that you receive all of the results.
- `"nextToken"`: Specifies that you want to receive the next page of results. Valid only if
  you received a NextToken response in the previous request. If you did, it indicates that
  more output is available. Set this parameter to the value provided by the previous call's
  NextToken response to request the next page of results.
- `"permissionType"`: Specifies that you want to list only permissions of this type:    AWS
  – returns only Amazon Web Services managed permissions.    LOCAL – returns only
  customer managed permissions    ALL – returns both Amazon Web Services managed
  permissions and customer managed permissions.   If you don't specify this parameter, the
  default is All.
- `"resourceType"`: Specifies that you want to list only those permissions that apply to
  the specified resource type. This parameter is not case sensitive. For example, to list
  only permissions that apply to Amazon EC2 subnets, specify ec2:subnet. You can use the
  ListResourceTypes operation to get the specific string required.
"""
function list_permissions(; aws_config::AbstractAWSConfig=current_aws_config())
    return ram(
        "POST", "/listpermissions"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_permissions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ram(
        "POST",
        "/listpermissions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_principals(resource_owner)
    list_principals(resource_owner, params::Dict{String,<:Any})

Lists the principals that you are sharing resources with or that are sharing resources with
you.

# Arguments
- `resource_owner`: Specifies that you want to list information for only resource shares
  that match the following:     SELF  – principals that your account is sharing resources
  with     OTHER-ACCOUNTS  – principals that are sharing resources with your account

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Specifies the total number of results that you want included on each page
  of the response. If you do not include this parameter, it defaults to a value that is
  specific to the operation. If additional items exist beyond the number you specify, the
  NextToken response element is returned with a value (not null). Include the specified value
  as the NextToken request parameter in the next call to the operation to get the next part
  of the results. Note that the service might return fewer results than the maximum even when
  there are more results available. You should check NextToken after every operation to
  ensure that you receive all of the results.
- `"nextToken"`: Specifies that you want to receive the next page of results. Valid only if
  you received a NextToken response in the previous request. If you did, it indicates that
  more output is available. Set this parameter to the value provided by the previous call's
  NextToken response to request the next page of results.
- `"principals"`: Specifies that you want to list information for only the listed
  principals. You can include the following values:   An Amazon Web Services account ID, for
  example: 123456789012    An Amazon Resource Name (ARN) of an organization in Organizations,
  for example: organizations::123456789012:organization/o-exampleorgid    An ARN of an
  organizational unit (OU) in Organizations, for example:
  organizations::123456789012:ou/o-exampleorgid/ou-examplerootid-exampleouid123    An ARN of
  an IAM role, for example: iam::123456789012:role/rolename    An ARN of an IAM user, for
  example: iam::123456789012user/username     Not all resource types can be shared with IAM
  roles and users. For more information, see Sharing with IAM roles and users in the Resource
  Access Manager User Guide.
- `"resourceArn"`: Specifies that you want to list principal information for the resource
  share with the specified Amazon Resource Name (ARN).
- `"resourceShareArns"`: Specifies that you want to list information for only principals
  associated with the resource shares specified by a list the Amazon Resource Names (ARNs).
- `"resourceType"`: Specifies that you want to list information for only principals
  associated with resource shares that include the specified resource type. For a list of
  valid values, query the ListResourceTypes operation.
"""
function list_principals(resourceOwner; aws_config::AbstractAWSConfig=current_aws_config())
    return ram(
        "POST",
        "/listprincipals",
        Dict{String,Any}("resourceOwner" => resourceOwner);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_principals(
    resourceOwner,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ram(
        "POST",
        "/listprincipals",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceOwner" => resourceOwner), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_replace_permission_associations_work()
    list_replace_permission_associations_work(params::Dict{String,<:Any})

Retrieves the current status of the asynchronous tasks performed by RAM when you perform
the ReplacePermissionAssociationsWork operation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Specifies the total number of results that you want included on each page
  of the response. If you do not include this parameter, it defaults to a value that is
  specific to the operation. If additional items exist beyond the number you specify, the
  NextToken response element is returned with a value (not null). Include the specified value
  as the NextToken request parameter in the next call to the operation to get the next part
  of the results. Note that the service might return fewer results than the maximum even when
  there are more results available. You should check NextToken after every operation to
  ensure that you receive all of the results.
- `"nextToken"`: Specifies that you want to receive the next page of results. Valid only if
  you received a NextToken response in the previous request. If you did, it indicates that
  more output is available. Set this parameter to the value provided by the previous call's
  NextToken response to request the next page of results.
- `"status"`: Specifies that you want to see only the details about requests with a status
  that matches this value.
- `"workIds"`: A list of IDs. These values come from the idfield of the
  replacePermissionAssociationsWorkstructure returned by the ReplacePermissionAssociations
  operation.
"""
function list_replace_permission_associations_work(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return ram(
        "POST",
        "/listreplacepermissionassociationswork";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_replace_permission_associations_work(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ram(
        "POST",
        "/listreplacepermissionassociationswork",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_resource_share_permissions(resource_share_arn)
    list_resource_share_permissions(resource_share_arn, params::Dict{String,<:Any})

Lists the RAM permissions that are associated with a resource share.

# Arguments
- `resource_share_arn`: Specifies the Amazon Resource Name (ARN) of the resource share for
  which you want to retrieve the associated permissions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Specifies the total number of results that you want included on each page
  of the response. If you do not include this parameter, it defaults to a value that is
  specific to the operation. If additional items exist beyond the number you specify, the
  NextToken response element is returned with a value (not null). Include the specified value
  as the NextToken request parameter in the next call to the operation to get the next part
  of the results. Note that the service might return fewer results than the maximum even when
  there are more results available. You should check NextToken after every operation to
  ensure that you receive all of the results.
- `"nextToken"`: Specifies that you want to receive the next page of results. Valid only if
  you received a NextToken response in the previous request. If you did, it indicates that
  more output is available. Set this parameter to the value provided by the previous call's
  NextToken response to request the next page of results.
"""
function list_resource_share_permissions(
    resourceShareArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ram(
        "POST",
        "/listresourcesharepermissions",
        Dict{String,Any}("resourceShareArn" => resourceShareArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_resource_share_permissions(
    resourceShareArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ram(
        "POST",
        "/listresourcesharepermissions",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("resourceShareArn" => resourceShareArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_resource_types()
    list_resource_types(params::Dict{String,<:Any})

Lists the resource types that can be shared by RAM.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Specifies the total number of results that you want included on each page
  of the response. If you do not include this parameter, it defaults to a value that is
  specific to the operation. If additional items exist beyond the number you specify, the
  NextToken response element is returned with a value (not null). Include the specified value
  as the NextToken request parameter in the next call to the operation to get the next part
  of the results. Note that the service might return fewer results than the maximum even when
  there are more results available. You should check NextToken after every operation to
  ensure that you receive all of the results.
- `"nextToken"`: Specifies that you want to receive the next page of results. Valid only if
  you received a NextToken response in the previous request. If you did, it indicates that
  more output is available. Set this parameter to the value provided by the previous call's
  NextToken response to request the next page of results.
- `"resourceRegionScope"`: Specifies that you want the results to include only resources
  that have the specified scope.    ALL – the results include both global and regional
  resources or resource types.    GLOBAL – the results include only global resources or
  resource types.    REGIONAL – the results include only regional resources or resource
  types.   The default value is ALL.
"""
function list_resource_types(; aws_config::AbstractAWSConfig=current_aws_config())
    return ram(
        "POST", "/listresourcetypes"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_resource_types(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ram(
        "POST",
        "/listresourcetypes",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_resources(resource_owner)
    list_resources(resource_owner, params::Dict{String,<:Any})

Lists the resources that you added to a resource share or the resources that are shared
with you.

# Arguments
- `resource_owner`: Specifies that you want to list only the resource shares that match the
  following:     SELF  – resources that your account shares with other accounts
  OTHER-ACCOUNTS  – resources that other accounts share with your account

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Specifies the total number of results that you want included on each page
  of the response. If you do not include this parameter, it defaults to a value that is
  specific to the operation. If additional items exist beyond the number you specify, the
  NextToken response element is returned with a value (not null). Include the specified value
  as the NextToken request parameter in the next call to the operation to get the next part
  of the results. Note that the service might return fewer results than the maximum even when
  there are more results available. You should check NextToken after every operation to
  ensure that you receive all of the results.
- `"nextToken"`: Specifies that you want to receive the next page of results. Valid only if
  you received a NextToken response in the previous request. If you did, it indicates that
  more output is available. Set this parameter to the value provided by the previous call's
  NextToken response to request the next page of results.
- `"principal"`: Specifies that you want to list only the resource shares that are
  associated with the specified principal.
- `"resourceArns"`: Specifies that you want to list only the resource shares that include
  resources with the specified Amazon Resource Names (ARNs).
- `"resourceRegionScope"`: Specifies that you want the results to include only resources
  that have the specified scope.    ALL – the results include both global and regional
  resources or resource types.    GLOBAL – the results include only global resources or
  resource types.    REGIONAL – the results include only regional resources or resource
  types.   The default value is ALL.
- `"resourceShareArns"`: Specifies that you want to list only resources in the resource
  shares identified by the specified Amazon Resource Names (ARNs).
- `"resourceType"`: Specifies that you want to list only the resource shares that include
  resources of the specified resource type. For valid values, query the ListResourceTypes
  operation.
"""
function list_resources(resourceOwner; aws_config::AbstractAWSConfig=current_aws_config())
    return ram(
        "POST",
        "/listresources",
        Dict{String,Any}("resourceOwner" => resourceOwner);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_resources(
    resourceOwner,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ram(
        "POST",
        "/listresources",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceOwner" => resourceOwner), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    promote_permission_created_from_policy(name, permission_arn)
    promote_permission_created_from_policy(name, permission_arn, params::Dict{String,<:Any})

When you attach a resource-based policy to a resource, RAM automatically creates a resource
share of featureSet=CREATED_FROM_POLICY with a managed permission that has the same IAM
permissions as the original resource-based policy. However, this type of managed permission
is visible to only the resource share owner, and the associated resource share can't be
modified by using RAM. This operation creates a separate, fully manageable customer managed
permission that has the same IAM permissions as the original resource-based policy. You can
associate this customer managed permission to any resource shares. Before you use
PromoteResourceShareCreatedFromPolicy, you should first run this operation to ensure that
you have an appropriate customer managed permission that can be associated with the
promoted resource share.    The original CREATED_FROM_POLICY policy isn't deleted, and
resource shares using that original policy aren't automatically updated.   You can't modify
a CREATED_FROM_POLICY resource share so you can't associate the new customer managed
permission by using ReplacePermsissionAssociations. However, if you use
PromoteResourceShareCreatedFromPolicy, that operation automatically associates the fully
manageable customer managed permission to the newly promoted STANDARD resource share.
After you promote a resource share, if the original CREATED_FROM_POLICY managed permission
has no other associations to A resource share, then RAM automatically deletes it.

# Arguments
- `name`: Specifies a name for the promoted customer managed permission.
- `permission_arn`: Specifies the Amazon Resource Name (ARN) of the CREATED_FROM_POLICY
  permission that you want to promote. You can get this Amazon Resource Name (ARN) by calling
  the ListResourceSharePermissions operation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Specifies a unique, case-sensitive identifier that you provide to ensure
  the idempotency of the request. This lets you safely retry the request without accidentally
  performing the same operation a second time. Passing the same value to a later call to an
  operation requires that you also pass the same value for all other parameters. We recommend
  that you use a UUID type of value.. If you don't provide this value, then Amazon Web
  Services generates a random one for you. If you retry the operation with the same
  ClientToken, but with different parameters, the retry fails with an
  IdempotentParameterMismatch error.
"""
function promote_permission_created_from_policy(
    name, permissionArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ram(
        "POST",
        "/promotepermissioncreatedfrompolicy",
        Dict{String,Any}("name" => name, "permissionArn" => permissionArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function promote_permission_created_from_policy(
    name,
    permissionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ram(
        "POST",
        "/promotepermissioncreatedfrompolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("name" => name, "permissionArn" => permissionArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    promote_resource_share_created_from_policy(resource_share_arn)
    promote_resource_share_created_from_policy(resource_share_arn, params::Dict{String,<:Any})

When you attach a resource-based policy to a resource, RAM automatically creates a resource
share of featureSet=CREATED_FROM_POLICY with a managed permission that has the same IAM
permissions as the original resource-based policy. However, this type of managed permission
is visible to only the resource share owner, and the associated resource share can't be
modified by using RAM. This operation promotes the resource share to a STANDARD resource
share that is fully manageable in RAM. When you promote a resource share, you can then
manage the resource share in RAM and it becomes visible to all of the principals you shared
it with.  Before you perform this operation, you should first run
PromotePermissionCreatedFromPolicyto ensure that you have an appropriate customer managed
permission that can be associated with this resource share after its is promoted. If this
operation can't find a managed permission that exactly matches the existing
CREATED_FROM_POLICY permission, then this operation fails.

# Arguments
- `resource_share_arn`: Specifies the Amazon Resource Name (ARN) of the resource share to
  promote.

"""
function promote_resource_share_created_from_policy(
    resourceShareArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ram(
        "POST",
        "/promoteresourcesharecreatedfrompolicy",
        Dict{String,Any}("resourceShareArn" => resourceShareArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function promote_resource_share_created_from_policy(
    resourceShareArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ram(
        "POST",
        "/promoteresourcesharecreatedfrompolicy",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("resourceShareArn" => resourceShareArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    reject_resource_share_invitation(resource_share_invitation_arn)
    reject_resource_share_invitation(resource_share_invitation_arn, params::Dict{String,<:Any})

Rejects an invitation to a resource share from another Amazon Web Services account.

# Arguments
- `resource_share_invitation_arn`: Specifies the Amazon Resource Name (ARN) of the
  invitation that you want to reject.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Specifies a unique, case-sensitive identifier that you provide to ensure
  the idempotency of the request. This lets you safely retry the request without accidentally
  performing the same operation a second time. Passing the same value to a later call to an
  operation requires that you also pass the same value for all other parameters. We recommend
  that you use a UUID type of value.. If you don't provide this value, then Amazon Web
  Services generates a random one for you. If you retry the operation with the same
  ClientToken, but with different parameters, the retry fails with an
  IdempotentParameterMismatch error.
"""
function reject_resource_share_invitation(
    resourceShareInvitationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ram(
        "POST",
        "/rejectresourceshareinvitation",
        Dict{String,Any}("resourceShareInvitationArn" => resourceShareInvitationArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function reject_resource_share_invitation(
    resourceShareInvitationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ram(
        "POST",
        "/rejectresourceshareinvitation",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "resourceShareInvitationArn" => resourceShareInvitationArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    replace_permission_associations(from_permission_arn, to_permission_arn)
    replace_permission_associations(from_permission_arn, to_permission_arn, params::Dict{String,<:Any})

Updates all resource shares that use a managed permission to a different managed
permission. This operation always applies the default version of the target managed
permission. You can optionally specify that the update applies to only resource shares that
currently use a specified version. This enables you to update to the latest version,
without changing the which managed permission is used. You can use this operation to update
all of your resource shares to use the current default version of the permission by
specifying the same value for the fromPermissionArn and toPermissionArn parameters. You can
use the optional fromPermissionVersion parameter to update only those resources that use a
specified version of the managed permission to the new managed permission.  To successfully
perform this operation, you must have permission to update the resource-based policy on all
affected resource types.

# Arguments
- `from_permission_arn`: Specifies the Amazon Resource Name (ARN) of the managed permission
  that you want to replace.
- `to_permission_arn`: Specifies the ARN of the managed permission that you want to
  associate with resource shares in place of the one specified by fromPerssionArn and
  fromPermissionVersion. The operation always associates the version that is currently the
  default for the specified managed permission.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Specifies a unique, case-sensitive identifier that you provide to ensure
  the idempotency of the request. This lets you safely retry the request without accidentally
  performing the same operation a second time. Passing the same value to a later call to an
  operation requires that you also pass the same value for all other parameters. We recommend
  that you use a UUID type of value.. If you don't provide this value, then Amazon Web
  Services generates a random one for you. If you retry the operation with the same
  ClientToken, but with different parameters, the retry fails with an
  IdempotentParameterMismatch error.
- `"fromPermissionVersion"`: Specifies that you want to updated the permissions for only
  those resource shares that use the specified version of the managed permission.
"""
function replace_permission_associations(
    fromPermissionArn, toPermissionArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ram(
        "POST",
        "/replacepermissionassociations",
        Dict{String,Any}(
            "fromPermissionArn" => fromPermissionArn, "toPermissionArn" => toPermissionArn
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function replace_permission_associations(
    fromPermissionArn,
    toPermissionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ram(
        "POST",
        "/replacepermissionassociations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "fromPermissionArn" => fromPermissionArn,
                    "toPermissionArn" => toPermissionArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    set_default_permission_version(permission_arn, permission_version)
    set_default_permission_version(permission_arn, permission_version, params::Dict{String,<:Any})

Designates the specified version number as the default version for the specified customer
managed permission. New resource shares automatically use this new default permission.
Existing resource shares continue to use their original permission version, but you can use
ReplacePermissionAssociations to update them.

# Arguments
- `permission_arn`: Specifies the Amazon Resource Name (ARN) of the customer managed
  permission whose default version you want to change.
- `permission_version`: Specifies the version number that you want to designate as the
  default for customer managed permission. To see a list of all available version numbers,
  use ListPermissionVersions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Specifies a unique, case-sensitive identifier that you provide to ensure
  the idempotency of the request. This lets you safely retry the request without accidentally
  performing the same operation a second time. Passing the same value to a later call to an
  operation requires that you also pass the same value for all other parameters. We recommend
  that you use a UUID type of value.. If you don't provide this value, then Amazon Web
  Services generates a random one for you. If you retry the operation with the same
  ClientToken, but with different parameters, the retry fails with an
  IdempotentParameterMismatch error.
"""
function set_default_permission_version(
    permissionArn, permissionVersion; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ram(
        "POST",
        "/setdefaultpermissionversion",
        Dict{String,Any}(
            "permissionArn" => permissionArn, "permissionVersion" => permissionVersion
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function set_default_permission_version(
    permissionArn,
    permissionVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ram(
        "POST",
        "/setdefaultpermissionversion",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "permissionArn" => permissionArn,
                    "permissionVersion" => permissionVersion,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(tags)
    tag_resource(tags, params::Dict{String,<:Any})

Adds the specified tag keys and values to a resource share or managed permission. If you
choose a resource share, the tags are attached to only the resource share, not to the
resources that are in the resource share. The tags on a managed permission are the same for
all versions of the managed permission.

# Arguments
- `tags`: A list of one or more tag key and value pairs. The tag key must be present and
  not be an empty string. The tag value must be present but can be an empty string.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"resourceArn"`: Specifies the Amazon Resource Name (ARN) of the managed permission that
  you want to add tags to. You must specify either resourceArn, or resourceShareArn, but not
  both.
- `"resourceShareArn"`: Specifies the Amazon Resource Name (ARN) of the resource share that
  you want to add tags to. You must specify either resourceShareArn, or resourceArn, but not
  both.
"""
function tag_resource(tags; aws_config::AbstractAWSConfig=current_aws_config())
    return ram(
        "POST",
        "/tagresource",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    tags, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ram(
        "POST",
        "/tagresource",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(tag_keys)
    untag_resource(tag_keys, params::Dict{String,<:Any})

Removes the specified tag key and value pairs from the specified resource share or managed
permission.

# Arguments
- `tag_keys`: Specifies a list of one or more tag keys that you want to remove.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"resourceArn"`: Specifies the Amazon Resource Name (ARN) of the managed permission that
  you want to remove tags from. You must specify either resourceArn, or resourceShareArn, but
  not both.
- `"resourceShareArn"`: Specifies the Amazon Resource Name (ARN) of the resource share that
  you want to remove tags from. The tags are removed from the resource share, not the
  resources in the resource share. You must specify either resourceShareArn, or resourceArn,
  but not both.
"""
function untag_resource(tagKeys; aws_config::AbstractAWSConfig=current_aws_config())
    return ram(
        "POST",
        "/untagresource",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ram(
        "POST",
        "/untagresource",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_resource_share(resource_share_arn)
    update_resource_share(resource_share_arn, params::Dict{String,<:Any})

Modifies some of the properties of the specified resource share.

# Arguments
- `resource_share_arn`: Specifies the Amazon Resource Name (ARN) of the resource share that
  you want to modify.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"allowExternalPrincipals"`: Specifies whether principals outside your organization in
  Organizations can be associated with a resource share.
- `"clientToken"`: Specifies a unique, case-sensitive identifier that you provide to ensure
  the idempotency of the request. This lets you safely retry the request without accidentally
  performing the same operation a second time. Passing the same value to a later call to an
  operation requires that you also pass the same value for all other parameters. We recommend
  that you use a UUID type of value.. If you don't provide this value, then Amazon Web
  Services generates a random one for you. If you retry the operation with the same
  ClientToken, but with different parameters, the retry fails with an
  IdempotentParameterMismatch error.
- `"name"`: If specified, the new name that you want to attach to the resource share.
"""
function update_resource_share(
    resourceShareArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ram(
        "POST",
        "/updateresourceshare",
        Dict{String,Any}("resourceShareArn" => resourceShareArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_resource_share(
    resourceShareArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ram(
        "POST",
        "/updateresourceshare",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("resourceShareArn" => resourceShareArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

BUCKET_NAME = "aws-jl-test-issues---" * _now_formatted()

try
    S3.create_bucket(BUCKET_NAME)

    @testset "issue 223" begin
        # https://github.com/JuliaCloud/AWS.jl/issues/223
        body = "Hello World!"
        file_name = "contains spaces"

        try
            S3.put_object(BUCKET_NAME, file_name, Dict("body" => body))
            resp = S3.get_object(BUCKET_NAME, file_name)

            @test String(resp) == body
        finally
            S3.delete_object(BUCKET_NAME, file_name)
        end
    end

    @testset "issue 227" begin
        # https://github.com/JuliaCloud/AWS.jl/issues/227
        config = AWSConfig(; creds=nothing)

        @testset "s3 public bucket" begin
            resp = S3.get_object("julialang2", "bin/versions.json"; aws_config=config)
            @test !isempty(resp)
        end

        @testset "s3 private bucket" begin
            bucket_name = "aws-jl-test-issues---" * _now_formatted()
            file_name = "hello_world"

            try
                S3.create_bucket(bucket_name)
                S3.put_object(bucket_name, file_name)

                @test_throws AWSException S3.get_object(
                    bucket_name, file_name; aws_config=config
                )
            finally
                S3.delete_object(bucket_name, file_name)
                S3.delete_bucket(bucket_name)
            end
        end

        @testset "lambda" begin
            @service Lambda
            @test_throws NoCredentials Lambda.list_functions(; aws_config=config)
        end
    end

    @testset "issue 324" begin
        body = "Hello World!"
        file_name = "streaming.bin"

        try
            S3.put_object(BUCKET_NAME, file_name, Dict("body" => body))
            resp = S3.get_object(BUCKET_NAME, file_name)
            @test String(resp) == body

            # ERROR: MethodError: no method matching iterate(::Base.BufferStream)
            #   => BUG: header `response_stream` is pushed into the query...
            io = Base.BufferStream()
            S3.get_object(
                BUCKET_NAME,
                file_name,
                Dict("response_stream" => io, "return_stream" => true),
            )
            if bytesavailable(io) > 0
                @test String(readavailable(io)) == body
            else
                @test "no body data was available" == body
            end

        finally
            S3.delete_object(BUCKET_NAME, file_name)
        end
    end

    @testset "issue 466" begin
        file_name = "hang.txt"

        try
            S3.put_object(BUCKET_NAME, file_name)

            # The tests below validate the current behavior of how streams are handled.
            # Note: Avoid using `eof` for these tests can hang when using an unclosed `Base.BufferStream`

            stream = S3.get_object(BUCKET_NAME, file_name, Dict("return_stream" => true))
            if AWS.DEFAULT_BACKEND[] isa AWS.HTTPBackend
                @test !isopen(stream)
            else
                @test isopen(stream)
            end

            stream = Base.BufferStream()
            S3.get_object(BUCKET_NAME, file_name, Dict("response_stream" => stream))
            if AWS.DEFAULT_BACKEND[] isa AWS.HTTPBackend
                @test !isopen(stream)
            else
                # See: https://github.com/JuliaCloud/AWS.jl/issues/471
                @test_broken isopen(stream)
            end

            stream = Base.BufferStream()
            S3.get_object(
                BUCKET_NAME,
                file_name,
                Dict("response_stream" => stream, "return_stream" => true),
            )
            if AWS.DEFAULT_BACKEND[] isa AWS.HTTPBackend
                @test !isopen(stream)
            else
                @test isopen(stream)
            end
        finally
            S3.delete_object(BUCKET_NAME, file_name)
        end
    end

    @testset "issue 474" begin
        body = "foo\0bar"
        expected = Vector{UInt8}(body)
        file_name = "null.txt"

        try
            S3.put_object(BUCKET_NAME, file_name, Dict("body" => body))

            raw = S3.get_object(BUCKET_NAME, file_name, Dict("return_raw" => true))
            @test raw == expected

            stream = S3.get_object(BUCKET_NAME, file_name, Dict("return_stream" => true))
            if AWS.DEFAULT_BACKEND[] isa AWS.HTTPBackend
                @test stream isa Base.BufferStream
                @test !isopen(stream)

                if !isopen(stream)
                    @test read(stream) == expected
                end
            else
                @test stream isa IOBuffer
                @test isopen(stream)

                seekstart(stream)
                @test read(stream) == expected
            end
        finally
            S3.delete_object(BUCKET_NAME, file_name)
        end
    end
finally
    S3.delete_bucket(BUCKET_NAME)
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: forecast
using AWS.Compat
using AWS.UUIDs

"""
    create_auto_predictor(predictor_name)
    create_auto_predictor(predictor_name, params::Dict{String,<:Any})

Creates an Amazon Forecast predictor. Amazon Forecast creates predictors with
AutoPredictor, which involves applying the optimal combination of algorithms to each time
series in your datasets. You can use CreateAutoPredictor to create new predictors or
upgrade/retrain existing predictors.  Creating new predictors  The following parameters are
required when creating a new predictor:    PredictorName - A unique name for the predictor.
   DatasetGroupArn - The ARN of the dataset group used to train the predictor.
ForecastFrequency - The granularity of your forecasts (hourly, daily, weekly, etc).
ForecastHorizon - The number of time-steps that the model predicts. The forecast horizon is
also called the prediction length.   When creating a new predictor, do not specify a value
for ReferencePredictorArn.  Upgrading and retraining predictors  The following parameters
are required when retraining or upgrading a predictor:    PredictorName - A unique name for
the predictor.    ReferencePredictorArn - The ARN of the predictor to retrain or upgrade.
When upgrading or retraining a predictor, only specify values for the ReferencePredictorArn
and PredictorName.

# Arguments
- `predictor_name`: A unique name for the predictor

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DataConfig"`: The data configuration for your dataset group and any additional datasets.
- `"EncryptionConfig"`:
- `"ExplainPredictor"`: Create an Explainability resource for the predictor.
- `"ForecastDimensions"`: An array of dimension (field) names that specify how to group the
  generated forecast. For example, if you are generating forecasts for item sales across all
  your stores, and your dataset contains a store_id field, you would specify store_id as a
  dimension to group sales forecasts for each store.
- `"ForecastFrequency"`: The frequency of predictions in a forecast. Valid intervals are an
  integer followed by Y (Year), M (Month), W (Week), D (Day), H (Hour), and min (Minute). For
  example, \"1D\" indicates every day and \"15min\" indicates every 15 minutes. You cannot
  specify a value that would overlap with the next larger frequency. That means, for example,
  you cannot specify a frequency of 60 minutes, because that is equivalent to 1 hour. The
  valid values for each frequency are the following:   Minute - 1-59   Hour - 1-23   Day -
  1-6   Week - 1-4   Month - 1-11   Year - 1   Thus, if you want every other week forecasts,
  specify \"2W\". Or, if you want quarterly forecasts, you specify \"3M\". The frequency must
  be greater than or equal to the TARGET_TIME_SERIES dataset frequency. When a
  RELATED_TIME_SERIES dataset is provided, the frequency must be equal to the
  RELATED_TIME_SERIES dataset frequency.
- `"ForecastHorizon"`: The number of time-steps that the model predicts. The forecast
  horizon is also called the prediction length. The maximum forecast horizon is the lesser of
  500 time-steps or 1/4 of the TARGET_TIME_SERIES dataset length. If you are retraining an
  existing AutoPredictor, then the maximum forecast horizon is the lesser of 500 time-steps
  or 1/3 of the TARGET_TIME_SERIES dataset length. If you are upgrading to an AutoPredictor
  or retraining an existing AutoPredictor, you cannot update the forecast horizon parameter.
  You can meet this requirement by providing longer time-series in the dataset.
- `"ForecastTypes"`: The forecast types used to train a predictor. You can specify up to
  five forecast types. Forecast types can be quantiles from 0.01 to 0.99, by increments of
  0.01 or higher. You can also specify the mean forecast with mean.
- `"MonitorConfig"`: The configuration details for predictor monitoring. Provide a name for
  the monitor resource to enable predictor monitoring. Predictor monitoring allows you to see
  how your predictor's performance changes over time. For more information, see Predictor
  Monitoring.
- `"OptimizationMetric"`: The accuracy metric used to optimize the predictor.
- `"ReferencePredictorArn"`: The ARN of the predictor to retrain or upgrade. This parameter
  is only used when retraining or upgrading a predictor. When creating a new predictor, do
  not specify a value for this parameter. When upgrading or retraining a predictor, only
  specify values for the ReferencePredictorArn and PredictorName. The value for PredictorName
  must be a unique predictor name.
- `"Tags"`: Optional metadata to help you categorize and organize your predictors. Each tag
  consists of a key and an optional value, both of which you define. Tag keys and values are
  case sensitive. The following restrictions apply to tags:   For each resource, each tag key
  must be unique and each tag key must have one value.   Maximum number of tags per resource:
  50.   Maximum key length: 128 Unicode characters in UTF-8.   Maximum value length: 256
  Unicode characters in UTF-8.   Accepted characters: all letters and numbers, spaces
  representable in UTF-8, and + - = . _ : / @. If your tagging schema is used across other
  services and resources, the character restrictions of those services also apply.    Key
  prefixes cannot include any upper or lowercase combination of aws: or AWS:. Values can have
  this prefix. If a tag value has aws as its prefix but the key does not, Forecast considers
  it to be a user tag and will count against the limit of 50 tags. Tags with only the key
  prefix of aws do not count against your tags per resource limit. You cannot edit or delete
  tag keys with this prefix.
- `"TimeAlignmentBoundary"`: The time boundary Forecast uses to align and aggregate any
  data that doesn't align with your forecast frequency. Provide the unit of time and the time
  boundary as a key value pair. For more information on specifying a time boundary, see
  Specifying a Time Boundary. If you don't provide a time boundary, Forecast uses a set of
  Default Time Boundaries.
"""
function create_auto_predictor(
    PredictorName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return forecast(
        "CreateAutoPredictor",
        Dict{String,Any}("PredictorName" => PredictorName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_auto_predictor(
    PredictorName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecast(
        "CreateAutoPredictor",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("PredictorName" => PredictorName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_dataset(dataset_name, dataset_type, domain, schema)
    create_dataset(dataset_name, dataset_type, domain, schema, params::Dict{String,<:Any})

Creates an Amazon Forecast dataset. The information about the dataset that you provide
helps Forecast understand how to consume the data for model training. This includes the
following:     DataFrequency  - How frequently your historical time-series data is
collected.     Domain  and  DatasetType  - Each dataset has an associated dataset domain
and a type within the domain. Amazon Forecast provides a list of predefined domains and
types within each domain. For each unique dataset domain and type within the domain, Amazon
Forecast requires your data to include a minimum set of predefined fields.     Schema  - A
schema specifies the fields in the dataset, including the field name and data type.   After
creating a dataset, you import your training data into it and add the dataset to a dataset
group. You use the dataset group to create a predictor. For more information, see Importing
datasets. To get a list of all your datasets, use the ListDatasets operation. For example
Forecast datasets, see the Amazon Forecast Sample GitHub repository.  The Status of a
dataset must be ACTIVE before you can import training data. Use the DescribeDataset
operation to get the status.

# Arguments
- `dataset_name`: A name for the dataset.
- `dataset_type`: The dataset type. Valid values depend on the chosen Domain.
- `domain`: The domain associated with the dataset. When you add a dataset to a dataset
  group, this value and the value specified for the Domain parameter of the
  CreateDatasetGroup operation must match. The Domain and DatasetType that you choose
  determine the fields that must be present in the training data that you import to the
  dataset. For example, if you choose the RETAIL domain and TARGET_TIME_SERIES as the
  DatasetType, Amazon Forecast requires item_id, timestamp, and demand fields to be present
  in your data. For more information, see Importing datasets.
- `schema`: The schema for the dataset. The schema attributes and their order must match
  the fields in your data. The dataset Domain and DatasetType that you choose determine the
  minimum required fields in your training data. For information about the required fields
  for a specific dataset domain and type, see Dataset Domains and Dataset Types.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DataFrequency"`: The frequency of data collection. This parameter is required for
  RELATED_TIME_SERIES datasets. Valid intervals are an integer followed by Y (Year), M
  (Month), W (Week), D (Day), H (Hour), and min (Minute). For example, \"1D\" indicates every
  day and \"15min\" indicates every 15 minutes. You cannot specify a value that would overlap
  with the next larger frequency. That means, for example, you cannot specify a frequency of
  60 minutes, because that is equivalent to 1 hour. The valid values for each frequency are
  the following:   Minute - 1-59   Hour - 1-23   Day - 1-6   Week - 1-4   Month - 1-11   Year
  - 1   Thus, if you want every other week forecasts, specify \"2W\". Or, if you want
  quarterly forecasts, you specify \"3M\".
- `"EncryptionConfig"`: An Key Management Service (KMS) key and the Identity and Access
  Management (IAM) role that Amazon Forecast can assume to access the key.
- `"Tags"`: The optional metadata that you apply to the dataset to help you categorize and
  organize them. Each tag consists of a key and an optional value, both of which you define.
  The following basic restrictions apply to tags:   Maximum number of tags per resource - 50.
    For each resource, each tag key must be unique, and each tag key can have only one value.
    Maximum key length - 128 Unicode characters in UTF-8.   Maximum value length - 256
  Unicode characters in UTF-8.   If your tagging schema is used across multiple services and
  resources, remember that other services may have restrictions on allowed characters.
  Generally allowed characters are: letters, numbers, and spaces representable in UTF-8, and
  the following characters: + - = . _ : / @.   Tag keys and values are case sensitive.   Do
  not use aws:, AWS:, or any upper or lowercase combination of such as a prefix for keys as
  it is reserved for Amazon Web Services use. You cannot edit or delete tag keys with this
  prefix. Values can have this prefix. If a tag value has aws as its prefix but the key does
  not, then Forecast considers it to be a user tag and will count against the limit of 50
  tags. Tags with only the key prefix of aws do not count against your tags per resource
  limit.
"""
function create_dataset(
    DatasetName,
    DatasetType,
    Domain,
    Schema;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecast(
        "CreateDataset",
        Dict{String,Any}(
            "DatasetName" => DatasetName,
            "DatasetType" => DatasetType,
            "Domain" => Domain,
            "Schema" => Schema,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_dataset(
    DatasetName,
    DatasetType,
    Domain,
    Schema,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecast(
        "CreateDataset",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DatasetName" => DatasetName,
                    "DatasetType" => DatasetType,
                    "Domain" => Domain,
                    "Schema" => Schema,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_dataset_group(dataset_group_name, domain)
    create_dataset_group(dataset_group_name, domain, params::Dict{String,<:Any})

Creates a dataset group, which holds a collection of related datasets. You can add datasets
to the dataset group when you create the dataset group, or later by using the
UpdateDatasetGroup operation. After creating a dataset group and adding datasets, you use
the dataset group when you create a predictor. For more information, see Dataset groups. To
get a list of all your datasets groups, use the ListDatasetGroups operation.  The Status of
a dataset group must be ACTIVE before you can use the dataset group to create a predictor.
To get the status, use the DescribeDatasetGroup operation.

# Arguments
- `dataset_group_name`: A name for the dataset group.
- `domain`: The domain associated with the dataset group. When you add a dataset to a
  dataset group, this value and the value specified for the Domain parameter of the
  CreateDataset operation must match. The Domain and DatasetType that you choose determine
  the fields that must be present in training data that you import to a dataset. For example,
  if you choose the RETAIL domain and TARGET_TIME_SERIES as the DatasetType, Amazon Forecast
  requires that item_id, timestamp, and demand fields are present in your data. For more
  information, see Dataset groups.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DatasetArns"`: An array of Amazon Resource Names (ARNs) of the datasets that you want
  to include in the dataset group.
- `"Tags"`: The optional metadata that you apply to the dataset group to help you
  categorize and organize them. Each tag consists of a key and an optional value, both of
  which you define. The following basic restrictions apply to tags:   Maximum number of tags
  per resource - 50.   For each resource, each tag key must be unique, and each tag key can
  have only one value.   Maximum key length - 128 Unicode characters in UTF-8.   Maximum
  value length - 256 Unicode characters in UTF-8.   If your tagging schema is used across
  multiple services and resources, remember that other services may have restrictions on
  allowed characters. Generally allowed characters are: letters, numbers, and spaces
  representable in UTF-8, and the following characters: + - = . _ : / @.   Tag keys and
  values are case sensitive.   Do not use aws:, AWS:, or any upper or lowercase combination
  of such as a prefix for keys as it is reserved for Amazon Web Services use. You cannot edit
  or delete tag keys with this prefix. Values can have this prefix. If a tag value has aws as
  its prefix but the key does not, then Forecast considers it to be a user tag and will count
  against the limit of 50 tags. Tags with only the key prefix of aws do not count against
  your tags per resource limit.
"""
function create_dataset_group(
    DatasetGroupName, Domain; aws_config::AbstractAWSConfig=current_aws_config()
)
    return forecast(
        "CreateDatasetGroup",
        Dict{String,Any}("DatasetGroupName" => DatasetGroupName, "Domain" => Domain);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_dataset_group(
    DatasetGroupName,
    Domain,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecast(
        "CreateDatasetGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DatasetGroupName" => DatasetGroupName, "Domain" => Domain
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_dataset_import_job(data_source, dataset_arn, dataset_import_job_name)
    create_dataset_import_job(data_source, dataset_arn, dataset_import_job_name, params::Dict{String,<:Any})

Imports your training data to an Amazon Forecast dataset. You provide the location of your
training data in an Amazon Simple Storage Service (Amazon S3) bucket and the Amazon
Resource Name (ARN) of the dataset that you want to import the data to. You must specify a
DataSource object that includes an Identity and Access Management (IAM) role that Amazon
Forecast can assume to access the data, as Amazon Forecast makes a copy of your data and
processes it in an internal Amazon Web Services system. For more information, see Set up
permissions. The training data must be in CSV or Parquet format. The delimiter must be a
comma (,). You can specify the path to a specific file, the S3 bucket, or to a folder in
the S3 bucket. For the latter two cases, Amazon Forecast imports all files up to the limit
of 10,000 files. Because dataset imports are not aggregated, your most recent dataset
import is the one that is used when training a predictor or generating a forecast. Make
sure that your most recent dataset import contains all of the data you want to model off
of, and not just the new data collected since the previous import. To get a list of all
your dataset import jobs, filtered by specified criteria, use the ListDatasetImportJobs
operation.

# Arguments
- `data_source`: The location of the training data to import and an Identity and Access
  Management (IAM) role that Amazon Forecast can assume to access the data. The training data
  must be stored in an Amazon S3 bucket. If encryption is used, DataSource must include an
  Key Management Service (KMS) key and the IAM role must allow Amazon Forecast permission to
  access the key. The KMS key and IAM role must match those specified in the EncryptionConfig
  parameter of the CreateDataset operation.
- `dataset_arn`: The Amazon Resource Name (ARN) of the Amazon Forecast dataset that you
  want to import data to.
- `dataset_import_job_name`: The name for the dataset import job. We recommend including
  the current timestamp in the name, for example, 20190721DatasetImport. This can help you
  avoid getting a ResourceAlreadyExistsException exception.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Format"`: The format of the imported data, CSV or PARQUET. The default value is CSV.
- `"GeolocationFormat"`: The format of the geolocation attribute. The geolocation attribute
  can be formatted in one of two ways:    LAT_LONG - the latitude and longitude in decimal
  format (Example: 47.61_-122.33).    CC_POSTALCODE (US Only) - the country code (US),
  followed by the 5-digit ZIP code (Example: US_98121).
- `"ImportMode"`: Specifies whether the dataset import job is a FULL or INCREMENTAL import.
  A FULL dataset import replaces all of the existing data with the newly imported data. An
  INCREMENTAL import appends the imported data to the existing data.
- `"Tags"`: The optional metadata that you apply to the dataset import job to help you
  categorize and organize them. Each tag consists of a key and an optional value, both of
  which you define. The following basic restrictions apply to tags:   Maximum number of tags
  per resource - 50.   For each resource, each tag key must be unique, and each tag key can
  have only one value.   Maximum key length - 128 Unicode characters in UTF-8.   Maximum
  value length - 256 Unicode characters in UTF-8.   If your tagging schema is used across
  multiple services and resources, remember that other services may have restrictions on
  allowed characters. Generally allowed characters are: letters, numbers, and spaces
  representable in UTF-8, and the following characters: + - = . _ : / @.   Tag keys and
  values are case sensitive.   Do not use aws:, AWS:, or any upper or lowercase combination
  of such as a prefix for keys as it is reserved for Amazon Web Services use. You cannot edit
  or delete tag keys with this prefix. Values can have this prefix. If a tag value has aws as
  its prefix but the key does not, then Forecast considers it to be a user tag and will count
  against the limit of 50 tags. Tags with only the key prefix of aws do not count against
  your tags per resource limit.
- `"TimeZone"`: A single time zone for every item in your dataset. This option is ideal for
  datasets with all timestamps within a single time zone, or if all timestamps are normalized
  to a single time zone.  Refer to the Joda-Time API for a complete list of valid time zone
  names.
- `"TimestampFormat"`: The format of timestamps in the dataset. The format that you specify
  depends on the DataFrequency specified when the dataset was created. The following formats
  are supported   \"yyyy-MM-dd\" For the following data frequencies: Y, M, W, and D
  \"yyyy-MM-dd HH:mm:ss\" For the following data frequencies: H, 30min, 15min, and 1min; and
  optionally, for: Y, M, W, and D   If the format isn't specified, Amazon Forecast expects
  the format to be \"yyyy-MM-dd HH:mm:ss\".
- `"UseGeolocationForTimeZone"`: Automatically derive time zone information from the
  geolocation attribute. This option is ideal for datasets that contain timestamps in
  multiple time zones and those timestamps are expressed in local time.
"""
function create_dataset_import_job(
    DataSource,
    DatasetArn,
    DatasetImportJobName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecast(
        "CreateDatasetImportJob",
        Dict{String,Any}(
            "DataSource" => DataSource,
            "DatasetArn" => DatasetArn,
            "DatasetImportJobName" => DatasetImportJobName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_dataset_import_job(
    DataSource,
    DatasetArn,
    DatasetImportJobName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecast(
        "CreateDatasetImportJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DataSource" => DataSource,
                    "DatasetArn" => DatasetArn,
                    "DatasetImportJobName" => DatasetImportJobName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_explainability(explainability_config, explainability_name, resource_arn)
    create_explainability(explainability_config, explainability_name, resource_arn, params::Dict{String,<:Any})

 Explainability is only available for Forecasts and Predictors generated from an
AutoPredictor (CreateAutoPredictor)  Creates an Amazon Forecast Explainability.
Explainability helps you better understand how the attributes in your datasets impact
forecast. Amazon Forecast uses a metric called Impact scores to quantify the relative
impact of each attribute and determine whether they increase or decrease forecast values.
To enable Forecast Explainability, your predictor must include at least one of the
following: related time series, item metadata, or additional datasets like Holidays and the
Weather Index. CreateExplainability accepts either a Predictor ARN or Forecast ARN. To
receive aggregated Impact scores for all time series and time points in your datasets,
provide a Predictor ARN. To receive Impact scores for specific time series and time points,
provide a Forecast ARN.  CreateExplainability with a Predictor ARN   You can only have one
Explainability resource per predictor. If you already enabled ExplainPredictor in
CreateAutoPredictor, that predictor already has an Explainability resource.  The following
parameters are required when providing a Predictor ARN:    ExplainabilityName - A unique
name for the Explainability.    ResourceArn - The Arn of the predictor.
TimePointGranularity - Must be set to “ALL”.    TimeSeriesGranularity - Must be set to
“ALL”.   Do not specify a value for the following parameters:    DataSource - Only
valid when TimeSeriesGranularity is “SPECIFIC”.    Schema - Only valid when
TimeSeriesGranularity is “SPECIFIC”.    StartDateTime - Only valid when
TimePointGranularity is “SPECIFIC”.    EndDateTime - Only valid when
TimePointGranularity is “SPECIFIC”.    CreateExplainability with a Forecast ARN   You
can specify a maximum of 50 time series and 500 time points.  The following parameters are
required when providing a Predictor ARN:    ExplainabilityName - A unique name for the
Explainability.    ResourceArn - The Arn of the forecast.    TimePointGranularity - Either
“ALL” or “SPECIFIC”.    TimeSeriesGranularity - Either “ALL” or “SPECIFIC”.
  If you set TimeSeriesGranularity to “SPECIFIC”, you must also provide the following:
  DataSource - The S3 location of the CSV file specifying your time series.    Schema - The
Schema defines the attributes and attribute types listed in the Data Source.   If you set
TimePointGranularity to “SPECIFIC”, you must also provide the following:
StartDateTime - The first timestamp in the range of time points.    EndDateTime - The last
timestamp in the range of time points.

# Arguments
- `explainability_config`: The configuration settings that define the granularity of time
  series and time points for the Explainability.
- `explainability_name`: A unique name for the Explainability.
- `resource_arn`: The Amazon Resource Name (ARN) of the Predictor or Forecast used to
  create the Explainability.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DataSource"`:
- `"EnableVisualization"`: Create an Explainability visualization that is viewable within
  the Amazon Web Services console.
- `"EndDateTime"`: If TimePointGranularity is set to SPECIFIC, define the last time point
  for the Explainability. Use the following timestamp format: yyyy-MM-ddTHH:mm:ss (example:
  2015-01-01T20:00:00)
- `"Schema"`:
- `"StartDateTime"`: If TimePointGranularity is set to SPECIFIC, define the first point for
  the Explainability. Use the following timestamp format: yyyy-MM-ddTHH:mm:ss (example:
  2015-01-01T20:00:00)
- `"Tags"`: Optional metadata to help you categorize and organize your resources. Each tag
  consists of a key and an optional value, both of which you define. Tag keys and values are
  case sensitive. The following restrictions apply to tags:   For each resource, each tag key
  must be unique and each tag key must have one value.   Maximum number of tags per resource:
  50.   Maximum key length: 128 Unicode characters in UTF-8.   Maximum value length: 256
  Unicode characters in UTF-8.   Accepted characters: all letters and numbers, spaces
  representable in UTF-8, and + - = . _ : / @. If your tagging schema is used across other
  services and resources, the character restrictions of those services also apply.    Key
  prefixes cannot include any upper or lowercase combination of aws: or AWS:. Values can have
  this prefix. If a tag value has aws as its prefix but the key does not, Forecast considers
  it to be a user tag and will count against the limit of 50 tags. Tags with only the key
  prefix of aws do not count against your tags per resource limit. You cannot edit or delete
  tag keys with this prefix.
"""
function create_explainability(
    ExplainabilityConfig,
    ExplainabilityName,
    ResourceArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecast(
        "CreateExplainability",
        Dict{String,Any}(
            "ExplainabilityConfig" => ExplainabilityConfig,
            "ExplainabilityName" => ExplainabilityName,
            "ResourceArn" => ResourceArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_explainability(
    ExplainabilityConfig,
    ExplainabilityName,
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecast(
        "CreateExplainability",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ExplainabilityConfig" => ExplainabilityConfig,
                    "ExplainabilityName" => ExplainabilityName,
                    "ResourceArn" => ResourceArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_explainability_export(destination, explainability_arn, explainability_export_name)
    create_explainability_export(destination, explainability_arn, explainability_export_name, params::Dict{String,<:Any})

Exports an Explainability resource created by the CreateExplainability operation. Exported
files are exported to an Amazon Simple Storage Service (Amazon S3) bucket. You must specify
a DataDestination object that includes an Amazon S3 bucket and an Identity and Access
Management (IAM) role that Amazon Forecast can assume to access the Amazon S3 bucket. For
more information, see aws-forecast-iam-roles.  The Status of the export job must be ACTIVE
before you can access the export in your Amazon S3 bucket. To get the status, use the
DescribeExplainabilityExport operation.

# Arguments
- `destination`:
- `explainability_arn`: The Amazon Resource Name (ARN) of the Explainability to export.
- `explainability_export_name`: A unique name for the Explainability export.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Format"`: The format of the exported data, CSV or PARQUET.
- `"Tags"`: Optional metadata to help you categorize and organize your resources. Each tag
  consists of a key and an optional value, both of which you define. Tag keys and values are
  case sensitive. The following restrictions apply to tags:   For each resource, each tag key
  must be unique and each tag key must have one value.   Maximum number of tags per resource:
  50.   Maximum key length: 128 Unicode characters in UTF-8.   Maximum value length: 256
  Unicode characters in UTF-8.   Accepted characters: all letters and numbers, spaces
  representable in UTF-8, and + - = . _ : / @. If your tagging schema is used across other
  services and resources, the character restrictions of those services also apply.    Key
  prefixes cannot include any upper or lowercase combination of aws: or AWS:. Values can have
  this prefix. If a tag value has aws as its prefix but the key does not, Forecast considers
  it to be a user tag and will count against the limit of 50 tags. Tags with only the key
  prefix of aws do not count against your tags per resource limit. You cannot edit or delete
  tag keys with this prefix.
"""
function create_explainability_export(
    Destination,
    ExplainabilityArn,
    ExplainabilityExportName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecast(
        "CreateExplainabilityExport",
        Dict{String,Any}(
            "Destination" => Destination,
            "ExplainabilityArn" => ExplainabilityArn,
            "ExplainabilityExportName" => ExplainabilityExportName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_explainability_export(
    Destination,
    ExplainabilityArn,
    ExplainabilityExportName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecast(
        "CreateExplainabilityExport",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Destination" => Destination,
                    "ExplainabilityArn" => ExplainabilityArn,
                    "ExplainabilityExportName" => ExplainabilityExportName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_forecast(forecast_name, predictor_arn)
    create_forecast(forecast_name, predictor_arn, params::Dict{String,<:Any})

Creates a forecast for each item in the TARGET_TIME_SERIES dataset that was used to train
the predictor. This is known as inference. To retrieve the forecast for a single item at
low latency, use the operation. To export the complete forecast into your Amazon Simple
Storage Service (Amazon S3) bucket, use the CreateForecastExportJob operation. The range of
the forecast is determined by the ForecastHorizon value, which you specify in the
CreatePredictor request. When you query a forecast, you can request a specific date range
within the forecast. To get a list of all your forecasts, use the ListForecasts operation.
The forecasts generated by Amazon Forecast are in the same time zone as the dataset that
was used to create the predictor.  For more information, see howitworks-forecast.  The
Status of the forecast must be ACTIVE before you can query or export the forecast. Use the
DescribeForecast operation to get the status.  By default, a forecast includes predictions
for every item (item_id) in the dataset group that was used to train the predictor.
However, you can use the TimeSeriesSelector object to generate a forecast on a subset of
time series. Forecast creation is skipped for any time series that you specify that are not
in the input dataset. The forecast export file will not contain these time series or their
forecasted values.

# Arguments
- `forecast_name`: A name for the forecast.
- `predictor_arn`: The Amazon Resource Name (ARN) of the predictor to use to generate the
  forecast.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ForecastTypes"`: The quantiles at which probabilistic forecasts are generated. You can
  currently specify up to 5 quantiles per forecast. Accepted values include 0.01 to 0.99
  (increments of .01 only) and mean. The mean forecast is different from the median (0.50)
  when the distribution is not symmetric (for example, Beta and Negative Binomial).  The
  default quantiles are the quantiles you specified during predictor creation. If you didn't
  specify quantiles, the default values are [\"0.1\", \"0.5\", \"0.9\"].
- `"Tags"`: The optional metadata that you apply to the forecast to help you categorize and
  organize them. Each tag consists of a key and an optional value, both of which you define.
  The following basic restrictions apply to tags:   Maximum number of tags per resource - 50.
    For each resource, each tag key must be unique, and each tag key can have only one value.
    Maximum key length - 128 Unicode characters in UTF-8.   Maximum value length - 256
  Unicode characters in UTF-8.   If your tagging schema is used across multiple services and
  resources, remember that other services may have restrictions on allowed characters.
  Generally allowed characters are: letters, numbers, and spaces representable in UTF-8, and
  the following characters: + - = . _ : / @.   Tag keys and values are case sensitive.   Do
  not use aws:, AWS:, or any upper or lowercase combination of such as a prefix for keys as
  it is reserved for Amazon Web Services use. You cannot edit or delete tag keys with this
  prefix. Values can have this prefix. If a tag value has aws as its prefix but the key does
  not, then Forecast considers it to be a user tag and will count against the limit of 50
  tags. Tags with only the key prefix of aws do not count against your tags per resource
  limit.
- `"TimeSeriesSelector"`: Defines the set of time series that are used to create the
  forecasts in a TimeSeriesIdentifiers object. The TimeSeriesIdentifiers object needs the
  following information:    DataSource     Format     Schema
"""
function create_forecast(
    ForecastName, PredictorArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return forecast(
        "CreateForecast",
        Dict{String,Any}("ForecastName" => ForecastName, "PredictorArn" => PredictorArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_forecast(
    ForecastName,
    PredictorArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecast(
        "CreateForecast",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ForecastName" => ForecastName, "PredictorArn" => PredictorArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_forecast_export_job(destination, forecast_arn, forecast_export_job_name)
    create_forecast_export_job(destination, forecast_arn, forecast_export_job_name, params::Dict{String,<:Any})

Exports a forecast created by the CreateForecast operation to your Amazon Simple Storage
Service (Amazon S3) bucket. The forecast file name will match the following conventions:
&lt;ForecastExportJobName&gt;_&lt;ExportTimestamp&gt;_&lt;PartNumber&gt; where the
&lt;ExportTimestamp&gt; component is in Java SimpleDateFormat (yyyy-MM-ddTHH-mm-ssZ). You
must specify a DataDestination object that includes an Identity and Access Management (IAM)
role that Amazon Forecast can assume to access the Amazon S3 bucket. For more information,
see aws-forecast-iam-roles. For more information, see howitworks-forecast. To get a list of
all your forecast export jobs, use the ListForecastExportJobs operation.  The Status of the
forecast export job must be ACTIVE before you can access the forecast in your Amazon S3
bucket. To get the status, use the DescribeForecastExportJob operation.

# Arguments
- `destination`: The location where you want to save the forecast and an Identity and
  Access Management (IAM) role that Amazon Forecast can assume to access the location. The
  forecast must be exported to an Amazon S3 bucket. If encryption is used, Destination must
  include an Key Management Service (KMS) key. The IAM role must allow Amazon Forecast
  permission to access the key.
- `forecast_arn`: The Amazon Resource Name (ARN) of the forecast that you want to export.
- `forecast_export_job_name`: The name for the forecast export job.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Format"`: The format of the exported data, CSV or PARQUET. The default value is CSV.
- `"Tags"`: The optional metadata that you apply to the forecast export job to help you
  categorize and organize them. Each tag consists of a key and an optional value, both of
  which you define. The following basic restrictions apply to tags:   Maximum number of tags
  per resource - 50.   For each resource, each tag key must be unique, and each tag key can
  have only one value.   Maximum key length - 128 Unicode characters in UTF-8.   Maximum
  value length - 256 Unicode characters in UTF-8.   If your tagging schema is used across
  multiple services and resources, remember that other services may have restrictions on
  allowed characters. Generally allowed characters are: letters, numbers, and spaces
  representable in UTF-8, and the following characters: + - = . _ : / @.   Tag keys and
  values are case sensitive.   Do not use aws:, AWS:, or any upper or lowercase combination
  of such as a prefix for keys as it is reserved for Amazon Web Services use. You cannot edit
  or delete tag keys with this prefix. Values can have this prefix. If a tag value has aws as
  its prefix but the key does not, then Forecast considers it to be a user tag and will count
  against the limit of 50 tags. Tags with only the key prefix of aws do not count against
  your tags per resource limit.
"""
function create_forecast_export_job(
    Destination,
    ForecastArn,
    ForecastExportJobName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecast(
        "CreateForecastExportJob",
        Dict{String,Any}(
            "Destination" => Destination,
            "ForecastArn" => ForecastArn,
            "ForecastExportJobName" => ForecastExportJobName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_forecast_export_job(
    Destination,
    ForecastArn,
    ForecastExportJobName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecast(
        "CreateForecastExportJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Destination" => Destination,
                    "ForecastArn" => ForecastArn,
                    "ForecastExportJobName" => ForecastExportJobName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_monitor(monitor_name, resource_arn)
    create_monitor(monitor_name, resource_arn, params::Dict{String,<:Any})

Creates a predictor monitor resource for an existing auto predictor. Predictor monitoring
allows you to see how your predictor's performance changes over time. For more information,
see Predictor Monitoring.

# Arguments
- `monitor_name`: The name of the monitor resource.
- `resource_arn`: The Amazon Resource Name (ARN) of the predictor to monitor.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: A list of tags to apply to the monitor resource.
"""
function create_monitor(
    MonitorName, ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return forecast(
        "CreateMonitor",
        Dict{String,Any}("MonitorName" => MonitorName, "ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_monitor(
    MonitorName,
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecast(
        "CreateMonitor",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "MonitorName" => MonitorName, "ResourceArn" => ResourceArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_predictor(featurization_config, forecast_horizon, input_data_config, predictor_name)
    create_predictor(featurization_config, forecast_horizon, input_data_config, predictor_name, params::Dict{String,<:Any})

  This operation creates a legacy predictor that does not include all the predictor
functionalities provided by Amazon Forecast. To create a predictor that is compatible with
all aspects of Forecast, use CreateAutoPredictor.  Creates an Amazon Forecast predictor. In
the request, provide a dataset group and either specify an algorithm or let Amazon Forecast
choose an algorithm for you using AutoML. If you specify an algorithm, you also can
override algorithm-specific hyperparameters. Amazon Forecast uses the algorithm to train a
predictor using the latest version of the datasets in the specified dataset group. You can
then generate a forecast using the CreateForecast operation.  To see the evaluation
metrics, use the GetAccuracyMetrics operation.  You can specify a featurization
configuration to fill and aggregate the data fields in the TARGET_TIME_SERIES dataset to
improve model training. For more information, see FeaturizationConfig. For
RELATED_TIME_SERIES datasets, CreatePredictor verifies that the DataFrequency specified
when the dataset was created matches the ForecastFrequency. TARGET_TIME_SERIES datasets
don't have this restriction. Amazon Forecast also verifies the delimiter and timestamp
format. For more information, see howitworks-datasets-groups. By default, predictors are
trained and evaluated at the 0.1 (P10), 0.5 (P50), and 0.9 (P90) quantiles. You can choose
custom forecast types to train and evaluate your predictor by setting the ForecastTypes.
AutoML  If you want Amazon Forecast to evaluate each algorithm and choose the one that
minimizes the objective function, set PerformAutoML to true. The objective function is
defined as the mean of the weighted losses over the forecast types. By default, these are
the p10, p50, and p90 quantile losses. For more information, see EvaluationResult. When
AutoML is enabled, the following properties are disallowed:    AlgorithmArn     HPOConfig
  PerformHPO     TrainingParameters    To get a list of all of your predictors, use the
ListPredictors operation.  Before you can use the predictor to create a forecast, the
Status of the predictor must be ACTIVE, signifying that training has completed. To get the
status, use the DescribePredictor operation.

# Arguments
- `featurization_config`: The featurization configuration.
- `forecast_horizon`: Specifies the number of time-steps that the model is trained to
  predict. The forecast horizon is also called the prediction length. For example, if you
  configure a dataset for daily data collection (using the DataFrequency parameter of the
  CreateDataset operation) and set the forecast horizon to 10, the model returns predictions
  for 10 days. The maximum forecast horizon is the lesser of 500 time-steps or 1/3 of the
  TARGET_TIME_SERIES dataset length.
- `input_data_config`: Describes the dataset group that contains the data to use to train
  the predictor.
- `predictor_name`: A name for the predictor.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AlgorithmArn"`: The Amazon Resource Name (ARN) of the algorithm to use for model
  training. Required if PerformAutoML is not set to true.  Supported algorithms:
  arn:aws:forecast:::algorithm/ARIMA     arn:aws:forecast:::algorithm/CNN-QR
  arn:aws:forecast:::algorithm/Deep_AR_Plus     arn:aws:forecast:::algorithm/ETS
  arn:aws:forecast:::algorithm/NPTS     arn:aws:forecast:::algorithm/Prophet
- `"AutoMLOverrideStrategy"`:   The LatencyOptimized AutoML override strategy is only
  available in private beta. Contact Amazon Web Services Support or your account manager to
  learn more about access privileges.   Used to overide the default AutoML strategy, which is
  to optimize predictor accuracy. To apply an AutoML strategy that minimizes training time,
  use LatencyOptimized. This parameter is only valid for predictors trained using AutoML.
- `"EncryptionConfig"`: An Key Management Service (KMS) key and the Identity and Access
  Management (IAM) role that Amazon Forecast can assume to access the key.
- `"EvaluationParameters"`: Used to override the default evaluation parameters of the
  specified algorithm. Amazon Forecast evaluates a predictor by splitting a dataset into
  training data and testing data. The evaluation parameters define how to perform the split
  and the number of iterations.
- `"ForecastTypes"`: Specifies the forecast types used to train a predictor. You can
  specify up to five forecast types. Forecast types can be quantiles from 0.01 to 0.99, by
  increments of 0.01 or higher. You can also specify the mean forecast with mean.  The
  default value is [\"0.10\", \"0.50\", \"0.9\"].
- `"HPOConfig"`: Provides hyperparameter override values for the algorithm. If you don't
  provide this parameter, Amazon Forecast uses default values. The individual algorithms
  specify which hyperparameters support hyperparameter optimization (HPO). For more
  information, see aws-forecast-choosing-recipes. If you included the HPOConfig object, you
  must set PerformHPO to true.
- `"OptimizationMetric"`: The accuracy metric used to optimize the predictor.
- `"PerformAutoML"`: Whether to perform AutoML. When Amazon Forecast performs AutoML, it
  evaluates the algorithms it provides and chooses the best algorithm and configuration for
  your training dataset. The default value is false. In this case, you are required to
  specify an algorithm. Set PerformAutoML to true to have Amazon Forecast perform AutoML.
  This is a good option if you aren't sure which algorithm is suitable for your training
  data. In this case, PerformHPO must be false.
- `"PerformHPO"`: Whether to perform hyperparameter optimization (HPO). HPO finds optimal
  hyperparameter values for your training data. The process of performing HPO is known as
  running a hyperparameter tuning job. The default value is false. In this case, Amazon
  Forecast uses default hyperparameter values from the chosen algorithm. To override the
  default values, set PerformHPO to true and, optionally, supply the
  HyperParameterTuningJobConfig object. The tuning job specifies a metric to optimize, which
  hyperparameters participate in tuning, and the valid range for each tunable hyperparameter.
  In this case, you are required to specify an algorithm and PerformAutoML must be false. The
  following algorithms support HPO:   DeepAR+   CNN-QR
- `"Tags"`: The optional metadata that you apply to the predictor to help you categorize
  and organize them. Each tag consists of a key and an optional value, both of which you
  define. The following basic restrictions apply to tags:   Maximum number of tags per
  resource - 50.   For each resource, each tag key must be unique, and each tag key can have
  only one value.   Maximum key length - 128 Unicode characters in UTF-8.   Maximum value
  length - 256 Unicode characters in UTF-8.   If your tagging schema is used across multiple
  services and resources, remember that other services may have restrictions on allowed
  characters. Generally allowed characters are: letters, numbers, and spaces representable in
  UTF-8, and the following characters: + - = . _ : / @.   Tag keys and values are case
  sensitive.   Do not use aws:, AWS:, or any upper or lowercase combination of such as a
  prefix for keys as it is reserved for Amazon Web Services use. You cannot edit or delete
  tag keys with this prefix. Values can have this prefix. If a tag value has aws as its
  prefix but the key does not, then Forecast considers it to be a user tag and will count
  against the limit of 50 tags. Tags with only the key prefix of aws do not count against
  your tags per resource limit.
- `"TrainingParameters"`: The hyperparameters to override for model training. The
  hyperparameters that you can override are listed in the individual algorithms. For the list
  of supported algorithms, see aws-forecast-choosing-recipes.
"""
function create_predictor(
    FeaturizationConfig,
    ForecastHorizon,
    InputDataConfig,
    PredictorName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecast(
        "CreatePredictor",
        Dict{String,Any}(
            "FeaturizationConfig" => FeaturizationConfig,
            "ForecastHorizon" => ForecastHorizon,
            "InputDataConfig" => InputDataConfig,
            "PredictorName" => PredictorName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_predictor(
    FeaturizationConfig,
    ForecastHorizon,
    InputDataConfig,
    PredictorName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecast(
        "CreatePredictor",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "FeaturizationConfig" => FeaturizationConfig,
                    "ForecastHorizon" => ForecastHorizon,
                    "InputDataConfig" => InputDataConfig,
                    "PredictorName" => PredictorName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_predictor_backtest_export_job(destination, predictor_arn, predictor_backtest_export_job_name)
    create_predictor_backtest_export_job(destination, predictor_arn, predictor_backtest_export_job_name, params::Dict{String,<:Any})

Exports backtest forecasts and accuracy metrics generated by the CreateAutoPredictor or
CreatePredictor operations. Two folders containing CSV or Parquet files are exported to
your specified S3 bucket.  The export file names will match the following conventions:
&lt;ExportJobName&gt;_&lt;ExportTimestamp&gt;_&lt;PartNumber&gt;.csv  The
&lt;ExportTimestamp&gt; component is in Java SimpleDate format (yyyy-MM-ddTHH-mm-ssZ). You
must specify a DataDestination object that includes an Amazon S3 bucket and an Identity and
Access Management (IAM) role that Amazon Forecast can assume to access the Amazon S3
bucket. For more information, see aws-forecast-iam-roles.  The Status of the export job
must be ACTIVE before you can access the export in your Amazon S3 bucket. To get the
status, use the DescribePredictorBacktestExportJob operation.

# Arguments
- `destination`:
- `predictor_arn`: The Amazon Resource Name (ARN) of the predictor that you want to export.
- `predictor_backtest_export_job_name`: The name for the backtest export job.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Format"`: The format of the exported data, CSV or PARQUET. The default value is CSV.
- `"Tags"`: Optional metadata to help you categorize and organize your backtests. Each tag
  consists of a key and an optional value, both of which you define. Tag keys and values are
  case sensitive. The following restrictions apply to tags:   For each resource, each tag key
  must be unique and each tag key must have one value.   Maximum number of tags per resource:
  50.   Maximum key length: 128 Unicode characters in UTF-8.   Maximum value length: 256
  Unicode characters in UTF-8.   Accepted characters: all letters and numbers, spaces
  representable in UTF-8, and + - = . _ : / @. If your tagging schema is used across other
  services and resources, the character restrictions of those services also apply.    Key
  prefixes cannot include any upper or lowercase combination of aws: or AWS:. Values can have
  this prefix. If a tag value has aws as its prefix but the key does not, Forecast considers
  it to be a user tag and will count against the limit of 50 tags. Tags with only the key
  prefix of aws do not count against your tags per resource limit. You cannot edit or delete
  tag keys with this prefix.
"""
function create_predictor_backtest_export_job(
    Destination,
    PredictorArn,
    PredictorBacktestExportJobName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecast(
        "CreatePredictorBacktestExportJob",
        Dict{String,Any}(
            "Destination" => Destination,
            "PredictorArn" => PredictorArn,
            "PredictorBacktestExportJobName" => PredictorBacktestExportJobName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_predictor_backtest_export_job(
    Destination,
    PredictorArn,
    PredictorBacktestExportJobName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecast(
        "CreatePredictorBacktestExportJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Destination" => Destination,
                    "PredictorArn" => PredictorArn,
                    "PredictorBacktestExportJobName" => PredictorBacktestExportJobName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_what_if_analysis(forecast_arn, what_if_analysis_name)
    create_what_if_analysis(forecast_arn, what_if_analysis_name, params::Dict{String,<:Any})

What-if analysis is a scenario modeling technique where you make a hypothetical change to a
time series and compare the forecasts generated by these changes against the baseline,
unchanged time series. It is important to remember that the purpose of a what-if analysis
is to understand how a forecast can change given different modifications to the baseline
time series. For example, imagine you are a clothing retailer who is considering an end of
season sale to clear space for new styles. After creating a baseline forecast, you can use
a what-if analysis to investigate how different sales tactics might affect your goals. You
could create a scenario where everything is given a 25% markdown, and another where
everything is given a fixed dollar markdown. You could create a scenario where the sale
lasts for one week and another where the sale lasts for one month. With a what-if analysis,
you can compare many different scenarios against each other. Note that a what-if analysis
is meant to display what the forecasting model has learned and how it will behave in the
scenarios that you are evaluating. Do not blindly use the results of the what-if analysis
to make business decisions. For instance, forecasts might not be accurate for novel
scenarios where there is no reference available to determine whether a forecast is good.
The TimeSeriesSelector object defines the items that you want in the what-if analysis.

# Arguments
- `forecast_arn`: The Amazon Resource Name (ARN) of the baseline forecast.
- `what_if_analysis_name`: The name of the what-if analysis. Each name must be unique.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: A list of tags to apply to the what if forecast.
- `"TimeSeriesSelector"`: Defines the set of time series that are used in the what-if
  analysis with a TimeSeriesIdentifiers object. What-if analyses are performed only for the
  time series in this object. The TimeSeriesIdentifiers object needs the following
  information:    DataSource     Format     Schema
"""
function create_what_if_analysis(
    ForecastArn, WhatIfAnalysisName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return forecast(
        "CreateWhatIfAnalysis",
        Dict{String,Any}(
            "ForecastArn" => ForecastArn, "WhatIfAnalysisName" => WhatIfAnalysisName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_what_if_analysis(
    ForecastArn,
    WhatIfAnalysisName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecast(
        "CreateWhatIfAnalysis",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ForecastArn" => ForecastArn, "WhatIfAnalysisName" => WhatIfAnalysisName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_what_if_forecast(what_if_analysis_arn, what_if_forecast_name)
    create_what_if_forecast(what_if_analysis_arn, what_if_forecast_name, params::Dict{String,<:Any})

A what-if forecast is a forecast that is created from a modified version of the baseline
forecast. Each what-if forecast incorporates either a replacement dataset or a set of
transformations to the original dataset.

# Arguments
- `what_if_analysis_arn`: The Amazon Resource Name (ARN) of the what-if analysis.
- `what_if_forecast_name`: The name of the what-if forecast. Names must be unique within
  each what-if analysis.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: A list of tags to apply to the what if forecast.
- `"TimeSeriesReplacementsDataSource"`: The replacement time series dataset, which contains
  the rows that you want to change in the related time series dataset. A replacement time
  series does not need to contain all rows that are in the baseline related time series.
  Include only the rows (measure-dimension combinations) that you want to include in the
  what-if forecast. This dataset is merged with the original time series to create a
  transformed dataset that is used for the what-if analysis. This dataset should contain the
  items to modify (such as item_id or workforce_type), any relevant dimensions, the timestamp
  column, and at least one of the related time series columns. This file should not contain
  duplicate timestamps for the same time series. Timestamps and item_ids not included in this
  dataset are not included in the what-if analysis.
- `"TimeSeriesTransformations"`: The transformations that are applied to the baseline time
  series. Each transformation contains an action and a set of conditions. An action is
  applied only when all conditions are met. If no conditions are provided, the action is
  applied to all items.
"""
function create_what_if_forecast(
    WhatIfAnalysisArn,
    WhatIfForecastName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecast(
        "CreateWhatIfForecast",
        Dict{String,Any}(
            "WhatIfAnalysisArn" => WhatIfAnalysisArn,
            "WhatIfForecastName" => WhatIfForecastName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_what_if_forecast(
    WhatIfAnalysisArn,
    WhatIfForecastName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecast(
        "CreateWhatIfForecast",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "WhatIfAnalysisArn" => WhatIfAnalysisArn,
                    "WhatIfForecastName" => WhatIfForecastName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_what_if_forecast_export(destination, what_if_forecast_arns, what_if_forecast_export_name)
    create_what_if_forecast_export(destination, what_if_forecast_arns, what_if_forecast_export_name, params::Dict{String,<:Any})

Exports a forecast created by the CreateWhatIfForecast operation to your Amazon Simple
Storage Service (Amazon S3) bucket. The forecast file name will match the following
conventions:  ≈&lt;ForecastExportJobName&gt;_&lt;ExportTimestamp&gt;_&lt;PartNumber&gt;
The &lt;ExportTimestamp&gt; component is in Java SimpleDateFormat (yyyy-MM-ddTHH-mm-ssZ).
You must specify a DataDestination object that includes an Identity and Access Management
(IAM) role that Amazon Forecast can assume to access the Amazon S3 bucket. For more
information, see aws-forecast-iam-roles. For more information, see howitworks-forecast. To
get a list of all your what-if forecast export jobs, use the ListWhatIfForecastExports
operation.  The Status of the forecast export job must be ACTIVE before you can access the
forecast in your Amazon S3 bucket. To get the status, use the DescribeWhatIfForecastExport
operation.

# Arguments
- `destination`: The location where you want to save the forecast and an Identity and
  Access Management (IAM) role that Amazon Forecast can assume to access the location. The
  forecast must be exported to an Amazon S3 bucket. If encryption is used, Destination must
  include an Key Management Service (KMS) key. The IAM role must allow Amazon Forecast
  permission to access the key.
- `what_if_forecast_arns`: The list of what-if forecast Amazon Resource Names (ARNs) to
  export.
- `what_if_forecast_export_name`: The name of the what-if forecast to export.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Format"`: The format of the exported data, CSV or PARQUET.
- `"Tags"`: A list of tags to apply to the what if forecast.
"""
function create_what_if_forecast_export(
    Destination,
    WhatIfForecastArns,
    WhatIfForecastExportName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecast(
        "CreateWhatIfForecastExport",
        Dict{String,Any}(
            "Destination" => Destination,
            "WhatIfForecastArns" => WhatIfForecastArns,
            "WhatIfForecastExportName" => WhatIfForecastExportName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_what_if_forecast_export(
    Destination,
    WhatIfForecastArns,
    WhatIfForecastExportName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecast(
        "CreateWhatIfForecastExport",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Destination" => Destination,
                    "WhatIfForecastArns" => WhatIfForecastArns,
                    "WhatIfForecastExportName" => WhatIfForecastExportName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_dataset(dataset_arn)
    delete_dataset(dataset_arn, params::Dict{String,<:Any})

Deletes an Amazon Forecast dataset that was created using the CreateDataset operation. You
can only delete datasets that have a status of ACTIVE or CREATE_FAILED. To get the status
use the DescribeDataset operation.  Forecast does not automatically update any dataset
groups that contain the deleted dataset. In order to update the dataset group, use the
UpdateDatasetGroup operation, omitting the deleted dataset's ARN.

# Arguments
- `dataset_arn`: The Amazon Resource Name (ARN) of the dataset to delete.

"""
function delete_dataset(DatasetArn; aws_config::AbstractAWSConfig=current_aws_config())
    return forecast(
        "DeleteDataset",
        Dict{String,Any}("DatasetArn" => DatasetArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_dataset(
    DatasetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecast(
        "DeleteDataset",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DatasetArn" => DatasetArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_dataset_group(dataset_group_arn)
    delete_dataset_group(dataset_group_arn, params::Dict{String,<:Any})

Deletes a dataset group created using the CreateDatasetGroup operation. You can only delete
dataset groups that have a status of ACTIVE, CREATE_FAILED, or UPDATE_FAILED. To get the
status, use the DescribeDatasetGroup operation. This operation deletes only the dataset
group, not the datasets in the group.

# Arguments
- `dataset_group_arn`: The Amazon Resource Name (ARN) of the dataset group to delete.

"""
function delete_dataset_group(
    DatasetGroupArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return forecast(
        "DeleteDatasetGroup",
        Dict{String,Any}("DatasetGroupArn" => DatasetGroupArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_dataset_group(
    DatasetGroupArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecast(
        "DeleteDatasetGroup",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("DatasetGroupArn" => DatasetGroupArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_dataset_import_job(dataset_import_job_arn)
    delete_dataset_import_job(dataset_import_job_arn, params::Dict{String,<:Any})

Deletes a dataset import job created using the CreateDatasetImportJob operation. You can
delete only dataset import jobs that have a status of ACTIVE or CREATE_FAILED. To get the
status, use the DescribeDatasetImportJob operation.

# Arguments
- `dataset_import_job_arn`: The Amazon Resource Name (ARN) of the dataset import job to
  delete.

"""
function delete_dataset_import_job(
    DatasetImportJobArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return forecast(
        "DeleteDatasetImportJob",
        Dict{String,Any}("DatasetImportJobArn" => DatasetImportJobArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_dataset_import_job(
    DatasetImportJobArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecast(
        "DeleteDatasetImportJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DatasetImportJobArn" => DatasetImportJobArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_explainability(explainability_arn)
    delete_explainability(explainability_arn, params::Dict{String,<:Any})

Deletes an Explainability resource. You can delete only predictor that have a status of
ACTIVE or CREATE_FAILED. To get the status, use the DescribeExplainability operation.

# Arguments
- `explainability_arn`: The Amazon Resource Name (ARN) of the Explainability resource to
  delete.

"""
function delete_explainability(
    ExplainabilityArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return forecast(
        "DeleteExplainability",
        Dict{String,Any}("ExplainabilityArn" => ExplainabilityArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_explainability(
    ExplainabilityArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecast(
        "DeleteExplainability",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ExplainabilityArn" => ExplainabilityArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_explainability_export(explainability_export_arn)
    delete_explainability_export(explainability_export_arn, params::Dict{String,<:Any})

Deletes an Explainability export.

# Arguments
- `explainability_export_arn`: The Amazon Resource Name (ARN) of the Explainability export
  to delete.

"""
function delete_explainability_export(
    ExplainabilityExportArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return forecast(
        "DeleteExplainabilityExport",
        Dict{String,Any}("ExplainabilityExportArn" => ExplainabilityExportArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_explainability_export(
    ExplainabilityExportArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecast(
        "DeleteExplainabilityExport",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ExplainabilityExportArn" => ExplainabilityExportArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_forecast(forecast_arn)
    delete_forecast(forecast_arn, params::Dict{String,<:Any})

Deletes a forecast created using the CreateForecast operation. You can delete only
forecasts that have a status of ACTIVE or CREATE_FAILED. To get the status, use the
DescribeForecast operation. You can't delete a forecast while it is being exported. After a
forecast is deleted, you can no longer query the forecast.

# Arguments
- `forecast_arn`: The Amazon Resource Name (ARN) of the forecast to delete.

"""
function delete_forecast(ForecastArn; aws_config::AbstractAWSConfig=current_aws_config())
    return forecast(
        "DeleteForecast",
        Dict{String,Any}("ForecastArn" => ForecastArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_forecast(
    ForecastArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecast(
        "DeleteForecast",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ForecastArn" => ForecastArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_forecast_export_job(forecast_export_job_arn)
    delete_forecast_export_job(forecast_export_job_arn, params::Dict{String,<:Any})

Deletes a forecast export job created using the CreateForecastExportJob operation. You can
delete only export jobs that have a status of ACTIVE or CREATE_FAILED. To get the status,
use the DescribeForecastExportJob operation.

# Arguments
- `forecast_export_job_arn`: The Amazon Resource Name (ARN) of the forecast export job to
  delete.

"""
function delete_forecast_export_job(
    ForecastExportJobArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return forecast(
        "DeleteForecastExportJob",
        Dict{String,Any}("ForecastExportJobArn" => ForecastExportJobArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_forecast_export_job(
    ForecastExportJobArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecast(
        "DeleteForecastExportJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ForecastExportJobArn" => ForecastExportJobArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_monitor(monitor_arn)
    delete_monitor(monitor_arn, params::Dict{String,<:Any})

Deletes a monitor resource. You can only delete a monitor resource with a status of ACTIVE,
ACTIVE_STOPPED, CREATE_FAILED, or CREATE_STOPPED.

# Arguments
- `monitor_arn`: The Amazon Resource Name (ARN) of the monitor resource to delete.

"""
function delete_monitor(MonitorArn; aws_config::AbstractAWSConfig=current_aws_config())
    return forecast(
        "DeleteMonitor",
        Dict{String,Any}("MonitorArn" => MonitorArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_monitor(
    MonitorArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecast(
        "DeleteMonitor",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("MonitorArn" => MonitorArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_predictor(predictor_arn)
    delete_predictor(predictor_arn, params::Dict{String,<:Any})

Deletes a predictor created using the DescribePredictor or CreatePredictor operations. You
can delete only predictor that have a status of ACTIVE or CREATE_FAILED. To get the status,
use the DescribePredictor operation.

# Arguments
- `predictor_arn`: The Amazon Resource Name (ARN) of the predictor to delete.

"""
function delete_predictor(PredictorArn; aws_config::AbstractAWSConfig=current_aws_config())
    return forecast(
        "DeletePredictor",
        Dict{String,Any}("PredictorArn" => PredictorArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_predictor(
    PredictorArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecast(
        "DeletePredictor",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("PredictorArn" => PredictorArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_predictor_backtest_export_job(predictor_backtest_export_job_arn)
    delete_predictor_backtest_export_job(predictor_backtest_export_job_arn, params::Dict{String,<:Any})

Deletes a predictor backtest export job.

# Arguments
- `predictor_backtest_export_job_arn`: The Amazon Resource Name (ARN) of the predictor
  backtest export job to delete.

"""
function delete_predictor_backtest_export_job(
    PredictorBacktestExportJobArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return forecast(
        "DeletePredictorBacktestExportJob",
        Dict{String,Any}("PredictorBacktestExportJobArn" => PredictorBacktestExportJobArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_predictor_backtest_export_job(
    PredictorBacktestExportJobArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecast(
        "DeletePredictorBacktestExportJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "PredictorBacktestExportJobArn" => PredictorBacktestExportJobArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_resource_tree(resource_arn)
    delete_resource_tree(resource_arn, params::Dict{String,<:Any})

Deletes an entire resource tree. This operation will delete the parent resource and its
child resources. Child resources are resources that were created from another resource. For
example, when a forecast is generated from a predictor, the forecast is the child resource
and the predictor is the parent resource. Amazon Forecast resources possess the following
parent-child resource hierarchies:    Dataset: dataset import jobs    Dataset Group:
predictors, predictor backtest export jobs, forecasts, forecast export jobs    Predictor:
predictor backtest export jobs, forecasts, forecast export jobs    Forecast: forecast
export jobs     DeleteResourceTree will only delete Amazon Forecast resources, and will not
delete datasets or exported files stored in Amazon S3.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the parent resource to delete. All
  child resources of the parent resource will also be deleted.

"""
function delete_resource_tree(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return forecast(
        "DeleteResourceTree",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_resource_tree(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecast(
        "DeleteResourceTree",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_what_if_analysis(what_if_analysis_arn)
    delete_what_if_analysis(what_if_analysis_arn, params::Dict{String,<:Any})

Deletes a what-if analysis created using the CreateWhatIfAnalysis operation. You can delete
only what-if analyses that have a status of ACTIVE or CREATE_FAILED. To get the status, use
the DescribeWhatIfAnalysis operation.  You can't delete a what-if analysis while any of its
forecasts are being exported.

# Arguments
- `what_if_analysis_arn`: The Amazon Resource Name (ARN) of the what-if analysis that you
  want to delete.

"""
function delete_what_if_analysis(
    WhatIfAnalysisArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return forecast(
        "DeleteWhatIfAnalysis",
        Dict{String,Any}("WhatIfAnalysisArn" => WhatIfAnalysisArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_what_if_analysis(
    WhatIfAnalysisArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecast(
        "DeleteWhatIfAnalysis",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("WhatIfAnalysisArn" => WhatIfAnalysisArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_what_if_forecast(what_if_forecast_arn)
    delete_what_if_forecast(what_if_forecast_arn, params::Dict{String,<:Any})

Deletes a what-if forecast created using the CreateWhatIfForecast operation. You can delete
only what-if forecasts that have a status of ACTIVE or CREATE_FAILED. To get the status,
use the DescribeWhatIfForecast operation.  You can't delete a what-if forecast while it is
being exported. After a what-if forecast is deleted, you can no longer query the what-if
analysis.

# Arguments
- `what_if_forecast_arn`: The Amazon Resource Name (ARN) of the what-if forecast that you
  want to delete.

"""
function delete_what_if_forecast(
    WhatIfForecastArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return forecast(
        "DeleteWhatIfForecast",
        Dict{String,Any}("WhatIfForecastArn" => WhatIfForecastArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_what_if_forecast(
    WhatIfForecastArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecast(
        "DeleteWhatIfForecast",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("WhatIfForecastArn" => WhatIfForecastArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_what_if_forecast_export(what_if_forecast_export_arn)
    delete_what_if_forecast_export(what_if_forecast_export_arn, params::Dict{String,<:Any})

Deletes a what-if forecast export created using the CreateWhatIfForecastExport operation.
You can delete only what-if forecast exports that have a status of ACTIVE or CREATE_FAILED.
To get the status, use the DescribeWhatIfForecastExport operation.

# Arguments
- `what_if_forecast_export_arn`: The Amazon Resource Name (ARN) of the what-if forecast
  export that you want to delete.

"""
function delete_what_if_forecast_export(
    WhatIfForecastExportArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return forecast(
        "DeleteWhatIfForecastExport",
        Dict{String,Any}("WhatIfForecastExportArn" => WhatIfForecastExportArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_what_if_forecast_export(
    WhatIfForecastExportArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecast(
        "DeleteWhatIfForecastExport",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("WhatIfForecastExportArn" => WhatIfForecastExportArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_auto_predictor(predictor_arn)
    describe_auto_predictor(predictor_arn, params::Dict{String,<:Any})

Describes a predictor created using the CreateAutoPredictor operation.

# Arguments
- `predictor_arn`: The Amazon Resource Name (ARN) of the predictor.

"""
function describe_auto_predictor(
    PredictorArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return forecast(
        "DescribeAutoPredictor",
        Dict{String,Any}("PredictorArn" => PredictorArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_auto_predictor(
    PredictorArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecast(
        "DescribeAutoPredictor",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("PredictorArn" => PredictorArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_dataset(dataset_arn)
    describe_dataset(dataset_arn, params::Dict{String,<:Any})

Describes an Amazon Forecast dataset created using the CreateDataset operation. In addition
to listing the parameters specified in the CreateDataset request, this operation includes
the following dataset properties:    CreationTime     LastModificationTime     Status

# Arguments
- `dataset_arn`: The Amazon Resource Name (ARN) of the dataset.

"""
function describe_dataset(DatasetArn; aws_config::AbstractAWSConfig=current_aws_config())
    return forecast(
        "DescribeDataset",
        Dict{String,Any}("DatasetArn" => DatasetArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_dataset(
    DatasetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecast(
        "DescribeDataset",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DatasetArn" => DatasetArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_dataset_group(dataset_group_arn)
    describe_dataset_group(dataset_group_arn, params::Dict{String,<:Any})

Describes a dataset group created using the CreateDatasetGroup operation. In addition to
listing the parameters provided in the CreateDatasetGroup request, this operation includes
the following properties:    DatasetArns - The datasets belonging to the group.
CreationTime     LastModificationTime     Status

# Arguments
- `dataset_group_arn`: The Amazon Resource Name (ARN) of the dataset group.

"""
function describe_dataset_group(
    DatasetGroupArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return forecast(
        "DescribeDatasetGroup",
        Dict{String,Any}("DatasetGroupArn" => DatasetGroupArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_dataset_group(
    DatasetGroupArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecast(
        "DescribeDatasetGroup",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("DatasetGroupArn" => DatasetGroupArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_dataset_import_job(dataset_import_job_arn)
    describe_dataset_import_job(dataset_import_job_arn, params::Dict{String,<:Any})

Describes a dataset import job created using the CreateDatasetImportJob operation. In
addition to listing the parameters provided in the CreateDatasetImportJob request, this
operation includes the following properties:    CreationTime     LastModificationTime
DataSize     FieldStatistics     Status     Message - If an error occurred, information
about the error.

# Arguments
- `dataset_import_job_arn`: The Amazon Resource Name (ARN) of the dataset import job.

"""
function describe_dataset_import_job(
    DatasetImportJobArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return forecast(
        "DescribeDatasetImportJob",
        Dict{String,Any}("DatasetImportJobArn" => DatasetImportJobArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_dataset_import_job(
    DatasetImportJobArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecast(
        "DescribeDatasetImportJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DatasetImportJobArn" => DatasetImportJobArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_explainability(explainability_arn)
    describe_explainability(explainability_arn, params::Dict{String,<:Any})

Describes an Explainability resource created using the CreateExplainability operation.

# Arguments
- `explainability_arn`: The Amazon Resource Name (ARN) of the Explaianability to describe.

"""
function describe_explainability(
    ExplainabilityArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return forecast(
        "DescribeExplainability",
        Dict{String,Any}("ExplainabilityArn" => ExplainabilityArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_explainability(
    ExplainabilityArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecast(
        "DescribeExplainability",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ExplainabilityArn" => ExplainabilityArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_explainability_export(explainability_export_arn)
    describe_explainability_export(explainability_export_arn, params::Dict{String,<:Any})

Describes an Explainability export created using the CreateExplainabilityExport operation.

# Arguments
- `explainability_export_arn`: The Amazon Resource Name (ARN) of the Explainability export.

"""
function describe_explainability_export(
    ExplainabilityExportArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return forecast(
        "DescribeExplainabilityExport",
        Dict{String,Any}("ExplainabilityExportArn" => ExplainabilityExportArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_explainability_export(
    ExplainabilityExportArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecast(
        "DescribeExplainabilityExport",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ExplainabilityExportArn" => ExplainabilityExportArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_forecast(forecast_arn)
    describe_forecast(forecast_arn, params::Dict{String,<:Any})

Describes a forecast created using the CreateForecast operation. In addition to listing the
properties provided in the CreateForecast request, this operation lists the following
properties:    DatasetGroupArn - The dataset group that provided the training data.
CreationTime     LastModificationTime     Status     Message - If an error occurred,
information about the error.

# Arguments
- `forecast_arn`: The Amazon Resource Name (ARN) of the forecast.

"""
function describe_forecast(ForecastArn; aws_config::AbstractAWSConfig=current_aws_config())
    return forecast(
        "DescribeForecast",
        Dict{String,Any}("ForecastArn" => ForecastArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_forecast(
    ForecastArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecast(
        "DescribeForecast",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ForecastArn" => ForecastArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_forecast_export_job(forecast_export_job_arn)
    describe_forecast_export_job(forecast_export_job_arn, params::Dict{String,<:Any})

Describes a forecast export job created using the CreateForecastExportJob operation. In
addition to listing the properties provided by the user in the CreateForecastExportJob
request, this operation lists the following properties:    CreationTime
LastModificationTime     Status     Message - If an error occurred, information about the
error.

# Arguments
- `forecast_export_job_arn`: The Amazon Resource Name (ARN) of the forecast export job.

"""
function describe_forecast_export_job(
    ForecastExportJobArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return forecast(
        "DescribeForecastExportJob",
        Dict{String,Any}("ForecastExportJobArn" => ForecastExportJobArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_forecast_export_job(
    ForecastExportJobArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecast(
        "DescribeForecastExportJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ForecastExportJobArn" => ForecastExportJobArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_monitor(monitor_arn)
    describe_monitor(monitor_arn, params::Dict{String,<:Any})

Describes a monitor resource. In addition to listing the properties provided in the
CreateMonitor request, this operation lists the following properties:    Baseline
CreationTime     LastEvaluationTime     LastEvaluationState     LastModificationTime
Message     Status

# Arguments
- `monitor_arn`: The Amazon Resource Name (ARN) of the monitor resource to describe.

"""
function describe_monitor(MonitorArn; aws_config::AbstractAWSConfig=current_aws_config())
    return forecast(
        "DescribeMonitor",
        Dict{String,Any}("MonitorArn" => MonitorArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_monitor(
    MonitorArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecast(
        "DescribeMonitor",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("MonitorArn" => MonitorArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_predictor(predictor_arn)
    describe_predictor(predictor_arn, params::Dict{String,<:Any})

  This operation is only valid for legacy predictors created with CreatePredictor. If you
are not using a legacy predictor, use DescribeAutoPredictor.  Describes a predictor created
using the CreatePredictor operation. In addition to listing the properties provided in the
CreatePredictor request, this operation lists the following properties:
DatasetImportJobArns - The dataset import jobs used to import training data.
AutoMLAlgorithmArns - If AutoML is performed, the algorithms that were evaluated.
CreationTime     LastModificationTime     Status     Message - If an error occurred,
information about the error.

# Arguments
- `predictor_arn`: The Amazon Resource Name (ARN) of the predictor that you want
  information about.

"""
function describe_predictor(
    PredictorArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return forecast(
        "DescribePredictor",
        Dict{String,Any}("PredictorArn" => PredictorArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_predictor(
    PredictorArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecast(
        "DescribePredictor",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("PredictorArn" => PredictorArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_predictor_backtest_export_job(predictor_backtest_export_job_arn)
    describe_predictor_backtest_export_job(predictor_backtest_export_job_arn, params::Dict{String,<:Any})

Describes a predictor backtest export job created using the
CreatePredictorBacktestExportJob operation. In addition to listing the properties provided
by the user in the CreatePredictorBacktestExportJob request, this operation lists the
following properties:    CreationTime     LastModificationTime     Status     Message (if
an error occurred)

# Arguments
- `predictor_backtest_export_job_arn`: The Amazon Resource Name (ARN) of the predictor
  backtest export job.

"""
function describe_predictor_backtest_export_job(
    PredictorBacktestExportJobArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return forecast(
        "DescribePredictorBacktestExportJob",
        Dict{String,Any}("PredictorBacktestExportJobArn" => PredictorBacktestExportJobArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_predictor_backtest_export_job(
    PredictorBacktestExportJobArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecast(
        "DescribePredictorBacktestExportJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "PredictorBacktestExportJobArn" => PredictorBacktestExportJobArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_what_if_analysis(what_if_analysis_arn)
    describe_what_if_analysis(what_if_analysis_arn, params::Dict{String,<:Any})

Describes the what-if analysis created using the CreateWhatIfAnalysis operation. In
addition to listing the properties provided in the CreateWhatIfAnalysis request, this
operation lists the following properties:    CreationTime     LastModificationTime
Message - If an error occurred, information about the error.    Status

# Arguments
- `what_if_analysis_arn`: The Amazon Resource Name (ARN) of the what-if analysis that you
  are interested in.

"""
function describe_what_if_analysis(
    WhatIfAnalysisArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return forecast(
        "DescribeWhatIfAnalysis",
        Dict{String,Any}("WhatIfAnalysisArn" => WhatIfAnalysisArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_what_if_analysis(
    WhatIfAnalysisArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecast(
        "DescribeWhatIfAnalysis",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("WhatIfAnalysisArn" => WhatIfAnalysisArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_what_if_forecast(what_if_forecast_arn)
    describe_what_if_forecast(what_if_forecast_arn, params::Dict{String,<:Any})

Describes the what-if forecast created using the CreateWhatIfForecast operation. In
addition to listing the properties provided in the CreateWhatIfForecast request, this
operation lists the following properties:    CreationTime     LastModificationTime
Message - If an error occurred, information about the error.    Status

# Arguments
- `what_if_forecast_arn`: The Amazon Resource Name (ARN) of the what-if forecast that you
  are interested in.

"""
function describe_what_if_forecast(
    WhatIfForecastArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return forecast(
        "DescribeWhatIfForecast",
        Dict{String,Any}("WhatIfForecastArn" => WhatIfForecastArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_what_if_forecast(
    WhatIfForecastArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecast(
        "DescribeWhatIfForecast",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("WhatIfForecastArn" => WhatIfForecastArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_what_if_forecast_export(what_if_forecast_export_arn)
    describe_what_if_forecast_export(what_if_forecast_export_arn, params::Dict{String,<:Any})

Describes the what-if forecast export created using the CreateWhatIfForecastExport
operation. In addition to listing the properties provided in the CreateWhatIfForecastExport
request, this operation lists the following properties:    CreationTime
LastModificationTime     Message - If an error occurred, information about the error.
Status

# Arguments
- `what_if_forecast_export_arn`: The Amazon Resource Name (ARN) of the what-if forecast
  export that you are interested in.

"""
function describe_what_if_forecast_export(
    WhatIfForecastExportArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return forecast(
        "DescribeWhatIfForecastExport",
        Dict{String,Any}("WhatIfForecastExportArn" => WhatIfForecastExportArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_what_if_forecast_export(
    WhatIfForecastExportArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecast(
        "DescribeWhatIfForecastExport",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("WhatIfForecastExportArn" => WhatIfForecastExportArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_accuracy_metrics(predictor_arn)
    get_accuracy_metrics(predictor_arn, params::Dict{String,<:Any})

Provides metrics on the accuracy of the models that were trained by the CreatePredictor
operation. Use metrics to see how well the model performed and to decide whether to use the
predictor to generate a forecast. For more information, see Predictor Metrics. This
operation generates metrics for each backtest window that was evaluated. The number of
backtest windows (NumberOfBacktestWindows) is specified using the EvaluationParameters
object, which is optionally included in the CreatePredictor request. If
NumberOfBacktestWindows isn't specified, the number defaults to one. The parameters of the
filling method determine which items contribute to the metrics. If you want all items to
contribute, specify zero. If you want only those items that have complete data in the range
being evaluated to contribute, specify nan. For more information, see FeaturizationMethod.
Before you can get accuracy metrics, the Status of the predictor must be ACTIVE, signifying
that training has completed. To get the status, use the DescribePredictor operation.

# Arguments
- `predictor_arn`: The Amazon Resource Name (ARN) of the predictor to get metrics for.

"""
function get_accuracy_metrics(
    PredictorArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return forecast(
        "GetAccuracyMetrics",
        Dict{String,Any}("PredictorArn" => PredictorArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_accuracy_metrics(
    PredictorArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecast(
        "GetAccuracyMetrics",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("PredictorArn" => PredictorArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_dataset_groups()
    list_dataset_groups(params::Dict{String,<:Any})

Returns a list of dataset groups created using the CreateDatasetGroup operation. For each
dataset group, this operation returns a summary of its properties, including its Amazon
Resource Name (ARN). You can retrieve the complete set of properties by using the dataset
group ARN with the DescribeDatasetGroup operation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The number of items to return in the response.
- `"NextToken"`: If the result of the previous request was truncated, the response includes
  a NextToken. To retrieve the next set of results, use the token in the next request. Tokens
  expire after 24 hours.
"""
function list_dataset_groups(; aws_config::AbstractAWSConfig=current_aws_config())
    return forecast(
        "ListDatasetGroups"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_dataset_groups(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return forecast(
        "ListDatasetGroups", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_dataset_import_jobs()
    list_dataset_import_jobs(params::Dict{String,<:Any})

Returns a list of dataset import jobs created using the CreateDatasetImportJob operation.
For each import job, this operation returns a summary of its properties, including its
Amazon Resource Name (ARN). You can retrieve the complete set of properties by using the
ARN with the DescribeDatasetImportJob operation. You can filter the list by providing an
array of Filter objects.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: An array of filters. For each filter, you provide a condition and a match
  statement. The condition is either IS or IS_NOT, which specifies whether to include or
  exclude the datasets that match the statement from the list, respectively. The match
  statement consists of a key and a value.  Filter properties     Condition - The condition
  to apply. Valid values are IS and IS_NOT. To include the datasets that match the statement,
  specify IS. To exclude matching datasets, specify IS_NOT.    Key - The name of the
  parameter to filter on. Valid values are DatasetArn and Status.    Value - The value to
  match.   For example, to list all dataset import jobs whose status is ACTIVE, you specify
  the following filter:  \"Filters\": [ { \"Condition\": \"IS\", \"Key\": \"Status\",
  \"Value\": \"ACTIVE\" } ]
- `"MaxResults"`: The number of items to return in the response.
- `"NextToken"`: If the result of the previous request was truncated, the response includes
  a NextToken. To retrieve the next set of results, use the token in the next request. Tokens
  expire after 24 hours.
"""
function list_dataset_import_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return forecast(
        "ListDatasetImportJobs"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_dataset_import_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return forecast(
        "ListDatasetImportJobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_datasets()
    list_datasets(params::Dict{String,<:Any})

Returns a list of datasets created using the CreateDataset operation. For each dataset, a
summary of its properties, including its Amazon Resource Name (ARN), is returned. To
retrieve the complete set of properties, use the ARN with the DescribeDataset operation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The number of items to return in the response.
- `"NextToken"`: If the result of the previous request was truncated, the response includes
  a NextToken. To retrieve the next set of results, use the token in the next request. Tokens
  expire after 24 hours.
"""
function list_datasets(; aws_config::AbstractAWSConfig=current_aws_config())
    return forecast("ListDatasets"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_datasets(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return forecast(
        "ListDatasets", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_explainabilities()
    list_explainabilities(params::Dict{String,<:Any})

Returns a list of Explainability resources created using the CreateExplainability
operation. This operation returns a summary for each Explainability. You can filter the
list using an array of Filter objects. To retrieve the complete set of properties for a
particular Explainability resource, use the ARN with the DescribeExplainability operation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: An array of filters. For each filter, provide a condition and a match
  statement. The condition is either IS or IS_NOT, which specifies whether to include or
  exclude the resources that match the statement from the list. The match statement consists
  of a key and a value.  Filter properties     Condition - The condition to apply. Valid
  values are IS and IS_NOT.    Key - The name of the parameter to filter on. Valid values are
  ResourceArn and Status.    Value - The value to match.
- `"MaxResults"`: The number of items returned in the response.
- `"NextToken"`: If the result of the previous request was truncated, the response includes
  a NextToken. To retrieve the next set of results, use the token in the next request. Tokens
  expire after 24 hours.
"""
function list_explainabilities(; aws_config::AbstractAWSConfig=current_aws_config())
    return forecast(
        "ListExplainabilities"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_explainabilities(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return forecast(
        "ListExplainabilities",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_explainability_exports()
    list_explainability_exports(params::Dict{String,<:Any})

Returns a list of Explainability exports created using the CreateExplainabilityExport
operation. This operation returns a summary for each Explainability export. You can filter
the list using an array of Filter objects. To retrieve the complete set of properties for a
particular Explainability export, use the ARN with the DescribeExplainability operation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: An array of filters. For each filter, provide a condition and a match
  statement. The condition is either IS or IS_NOT, which specifies whether to include or
  exclude resources that match the statement from the list. The match statement consists of a
  key and a value.  Filter properties     Condition - The condition to apply. Valid values
  are IS and IS_NOT.    Key - The name of the parameter to filter on. Valid values are
  ResourceArn and Status.    Value - The value to match.
- `"MaxResults"`: The number of items to return in the response.
- `"NextToken"`: If the result of the previous request was truncated, the response includes
  a NextToken. To retrieve the next set of results, use the token in the next request. Tokens
  expire after 24 hours.
"""
function list_explainability_exports(; aws_config::AbstractAWSConfig=current_aws_config())
    return forecast(
        "ListExplainabilityExports"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_explainability_exports(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return forecast(
        "ListExplainabilityExports",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_forecast_export_jobs()
    list_forecast_export_jobs(params::Dict{String,<:Any})

Returns a list of forecast export jobs created using the CreateForecastExportJob operation.
For each forecast export job, this operation returns a summary of its properties, including
its Amazon Resource Name (ARN). To retrieve the complete set of properties, use the ARN
with the DescribeForecastExportJob operation. You can filter the list using an array of
Filter objects.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: An array of filters. For each filter, you provide a condition and a match
  statement. The condition is either IS or IS_NOT, which specifies whether to include or
  exclude the forecast export jobs that match the statement from the list, respectively. The
  match statement consists of a key and a value.  Filter properties     Condition - The
  condition to apply. Valid values are IS and IS_NOT. To include the forecast export jobs
  that match the statement, specify IS. To exclude matching forecast export jobs, specify
  IS_NOT.    Key - The name of the parameter to filter on. Valid values are ForecastArn and
  Status.    Value - The value to match.   For example, to list all jobs that export a
  forecast named electricityforecast, specify the following filter:  \"Filters\": [ {
  \"Condition\": \"IS\", \"Key\": \"ForecastArn\", \"Value\":
  \"arn:aws:forecast:us-west-2:&lt;acct-id&gt;:forecast/electricityforecast\" } ]
- `"MaxResults"`: The number of items to return in the response.
- `"NextToken"`: If the result of the previous request was truncated, the response includes
  a NextToken. To retrieve the next set of results, use the token in the next request. Tokens
  expire after 24 hours.
"""
function list_forecast_export_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return forecast(
        "ListForecastExportJobs"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_forecast_export_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return forecast(
        "ListForecastExportJobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_forecasts()
    list_forecasts(params::Dict{String,<:Any})

Returns a list of forecasts created using the CreateForecast operation. For each forecast,
this operation returns a summary of its properties, including its Amazon Resource Name
(ARN). To retrieve the complete set of properties, specify the ARN with the
DescribeForecast operation. You can filter the list using an array of Filter objects.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: An array of filters. For each filter, you provide a condition and a match
  statement. The condition is either IS or IS_NOT, which specifies whether to include or
  exclude the forecasts that match the statement from the list, respectively. The match
  statement consists of a key and a value.  Filter properties     Condition - The condition
  to apply. Valid values are IS and IS_NOT. To include the forecasts that match the
  statement, specify IS. To exclude matching forecasts, specify IS_NOT.    Key - The name of
  the parameter to filter on. Valid values are DatasetGroupArn, PredictorArn, and Status.
  Value - The value to match.   For example, to list all forecasts whose status is not
  ACTIVE, you would specify:  \"Filters\": [ { \"Condition\": \"IS_NOT\", \"Key\":
  \"Status\", \"Value\": \"ACTIVE\" } ]
- `"MaxResults"`: The number of items to return in the response.
- `"NextToken"`: If the result of the previous request was truncated, the response includes
  a NextToken. To retrieve the next set of results, use the token in the next request. Tokens
  expire after 24 hours.
"""
function list_forecasts(; aws_config::AbstractAWSConfig=current_aws_config())
    return forecast("ListForecasts"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_forecasts(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return forecast(
        "ListForecasts", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_monitor_evaluations(monitor_arn)
    list_monitor_evaluations(monitor_arn, params::Dict{String,<:Any})

Returns a list of the monitoring evaluation results and predictor events collected by the
monitor resource during different windows of time. For information about monitoring see
predictor-monitoring. For more information about retrieving monitoring results see Viewing
Monitoring Results.

# Arguments
- `monitor_arn`: The Amazon Resource Name (ARN) of the monitor resource to get results from.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: An array of filters. For each filter, provide a condition and a match
  statement. The condition is either IS or IS_NOT, which specifies whether to include or
  exclude the resources that match the statement from the list. The match statement consists
  of a key and a value.  Filter properties     Condition - The condition to apply. Valid
  values are IS and IS_NOT.    Key - The name of the parameter to filter on. The only valid
  value is EvaluationState.    Value - The value to match. Valid values are only SUCCESS or
  FAILURE.   For example, to list only successful monitor evaluations, you would specify:
  \"Filters\": [ { \"Condition\": \"IS\", \"Key\": \"EvaluationState\", \"Value\":
  \"SUCCESS\" } ]
- `"MaxResults"`: The maximum number of monitoring results to return.
- `"NextToken"`: If the result of the previous request was truncated, the response includes
  a NextToken. To retrieve the next set of results, use the token in the next request. Tokens
  expire after 24 hours.
"""
function list_monitor_evaluations(
    MonitorArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return forecast(
        "ListMonitorEvaluations",
        Dict{String,Any}("MonitorArn" => MonitorArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_monitor_evaluations(
    MonitorArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecast(
        "ListMonitorEvaluations",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("MonitorArn" => MonitorArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_monitors()
    list_monitors(params::Dict{String,<:Any})

Returns a list of monitors created with the CreateMonitor operation and CreateAutoPredictor
operation. For each monitor resource, this operation returns of a summary of its
properties, including its Amazon Resource Name (ARN). You can retrieve a complete set of
properties of a monitor resource by specify the monitor's ARN in the DescribeMonitor
operation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: An array of filters. For each filter, provide a condition and a match
  statement. The condition is either IS or IS_NOT, which specifies whether to include or
  exclude the resources that match the statement from the list. The match statement consists
  of a key and a value.  Filter properties     Condition - The condition to apply. Valid
  values are IS and IS_NOT.    Key - The name of the parameter to filter on. The only valid
  value is Status.    Value - The value to match.   For example, to list all monitors who's
  status is ACTIVE, you would specify:  \"Filters\": [ { \"Condition\": \"IS\", \"Key\":
  \"Status\", \"Value\": \"ACTIVE\" } ]
- `"MaxResults"`: The maximum number of monitors to include in the response.
- `"NextToken"`: If the result of the previous request was truncated, the response includes
  a NextToken. To retrieve the next set of results, use the token in the next request. Tokens
  expire after 24 hours.
"""
function list_monitors(; aws_config::AbstractAWSConfig=current_aws_config())
    return forecast("ListMonitors"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_monitors(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return forecast(
        "ListMonitors", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_predictor_backtest_export_jobs()
    list_predictor_backtest_export_jobs(params::Dict{String,<:Any})

Returns a list of predictor backtest export jobs created using the
CreatePredictorBacktestExportJob operation. This operation returns a summary for each
backtest export job. You can filter the list using an array of Filter objects. To retrieve
the complete set of properties for a particular backtest export job, use the ARN with the
DescribePredictorBacktestExportJob operation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: An array of filters. For each filter, provide a condition and a match
  statement. The condition is either IS or IS_NOT, which specifies whether to include or
  exclude the predictor backtest export jobs that match the statement from the list. The
  match statement consists of a key and a value.  Filter properties     Condition - The
  condition to apply. Valid values are IS and IS_NOT. To include the predictor backtest
  export jobs that match the statement, specify IS. To exclude matching predictor backtest
  export jobs, specify IS_NOT.    Key - The name of the parameter to filter on. Valid values
  are PredictorArn and Status.    Value - The value to match.
- `"MaxResults"`: The number of items to return in the response.
- `"NextToken"`: If the result of the previous request was truncated, the response includes
  a NextToken. To retrieve the next set of results, use the token in the next request. Tokens
  expire after 24 hours.
"""
function list_predictor_backtest_export_jobs(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return forecast(
        "ListPredictorBacktestExportJobs";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_predictor_backtest_export_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return forecast(
        "ListPredictorBacktestExportJobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_predictors()
    list_predictors(params::Dict{String,<:Any})

Returns a list of predictors created using the CreateAutoPredictor or CreatePredictor
operations. For each predictor, this operation returns a summary of its properties,
including its Amazon Resource Name (ARN).  You can retrieve the complete set of properties
by using the ARN with the DescribeAutoPredictor and DescribePredictor operations. You can
filter the list using an array of Filter objects.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: An array of filters. For each filter, you provide a condition and a match
  statement. The condition is either IS or IS_NOT, which specifies whether to include or
  exclude the predictors that match the statement from the list, respectively. The match
  statement consists of a key and a value.  Filter properties     Condition - The condition
  to apply. Valid values are IS and IS_NOT. To include the predictors that match the
  statement, specify IS. To exclude matching predictors, specify IS_NOT.    Key - The name of
  the parameter to filter on. Valid values are DatasetGroupArn and Status.    Value - The
  value to match.   For example, to list all predictors whose status is ACTIVE, you would
  specify:  \"Filters\": [ { \"Condition\": \"IS\", \"Key\": \"Status\", \"Value\":
  \"ACTIVE\" } ]
- `"MaxResults"`: The number of items to return in the response.
- `"NextToken"`: If the result of the previous request was truncated, the response includes
  a NextToken. To retrieve the next set of results, use the token in the next request. Tokens
  expire after 24 hours.
"""
function list_predictors(; aws_config::AbstractAWSConfig=current_aws_config())
    return forecast(
        "ListPredictors"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_predictors(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return forecast(
        "ListPredictors", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists the tags for an Amazon Forecast resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) that identifies the resource for which to
  list the tags.

"""
function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return forecast(
        "ListTagsForResource",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecast(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_what_if_analyses()
    list_what_if_analyses(params::Dict{String,<:Any})

Returns a list of what-if analyses created using the CreateWhatIfAnalysis operation. For
each what-if analysis, this operation returns a summary of its properties, including its
Amazon Resource Name (ARN). You can retrieve the complete set of properties by using the
what-if analysis ARN with the DescribeWhatIfAnalysis operation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: An array of filters. For each filter, you provide a condition and a match
  statement. The condition is either IS or IS_NOT, which specifies whether to include or
  exclude the what-if analysis jobs that match the statement from the list, respectively. The
  match statement consists of a key and a value.  Filter properties     Condition - The
  condition to apply. Valid values are IS and IS_NOT. To include the what-if analysis jobs
  that match the statement, specify IS. To exclude matching what-if analysis jobs, specify
  IS_NOT.    Key - The name of the parameter to filter on. Valid values are WhatIfAnalysisArn
  and Status.    Value - The value to match.   For example, to list all jobs that export a
  forecast named electricityWhatIf, specify the following filter:  \"Filters\": [ {
  \"Condition\": \"IS\", \"Key\": \"WhatIfAnalysisArn\", \"Value\":
  \"arn:aws:forecast:us-west-2:&lt;acct-id&gt;:forecast/electricityWhatIf\" } ]
- `"MaxResults"`: The number of items to return in the response.
- `"NextToken"`: If the result of the previous request was truncated, the response includes
  a NextToken. To retrieve the next set of results, use the token in the next request. Tokens
  expire after 24 hours.
"""
function list_what_if_analyses(; aws_config::AbstractAWSConfig=current_aws_config())
    return forecast(
        "ListWhatIfAnalyses"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_what_if_analyses(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return forecast(
        "ListWhatIfAnalyses", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_what_if_forecast_exports()
    list_what_if_forecast_exports(params::Dict{String,<:Any})

Returns a list of what-if forecast exports created using the CreateWhatIfForecastExport
operation. For each what-if forecast export, this operation returns a summary of its
properties, including its Amazon Resource Name (ARN). You can retrieve the complete set of
properties by using the what-if forecast export ARN with the DescribeWhatIfForecastExport
operation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: An array of filters. For each filter, you provide a condition and a match
  statement. The condition is either IS or IS_NOT, which specifies whether to include or
  exclude the what-if forecast export jobs that match the statement from the list,
  respectively. The match statement consists of a key and a value.  Filter properties
  Condition - The condition to apply. Valid values are IS and IS_NOT. To include the forecast
  export jobs that match the statement, specify IS. To exclude matching forecast export jobs,
  specify IS_NOT.    Key - The name of the parameter to filter on. Valid values are
  WhatIfForecastExportArn and Status.    Value - The value to match.   For example, to list
  all jobs that export a forecast named electricityWIFExport, specify the following filter:
  \"Filters\": [ { \"Condition\": \"IS\", \"Key\": \"WhatIfForecastExportArn\", \"Value\":
  \"arn:aws:forecast:us-west-2:&lt;acct-id&gt;:forecast/electricityWIFExport\" } ]
- `"MaxResults"`: The number of items to return in the response.
- `"NextToken"`: If the result of the previous request was truncated, the response includes
  a NextToken. To retrieve the next set of results, use the token in the next&#x2028;
  request. Tokens expire after 24 hours.
"""
function list_what_if_forecast_exports(; aws_config::AbstractAWSConfig=current_aws_config())
    return forecast(
        "ListWhatIfForecastExports"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_what_if_forecast_exports(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return forecast(
        "ListWhatIfForecastExports",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_what_if_forecasts()
    list_what_if_forecasts(params::Dict{String,<:Any})

Returns a list of what-if forecasts created using the CreateWhatIfForecast operation. For
each what-if forecast, this operation returns a summary of its properties, including its
Amazon Resource Name (ARN). You can retrieve the complete set of properties by using the
what-if forecast ARN with the DescribeWhatIfForecast operation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: An array of filters. For each filter, you provide a condition and a match
  statement. The condition is either IS or IS_NOT, which specifies whether to include or
  exclude the what-if forecast export jobs that match the statement from the list,
  respectively. The match statement consists of a key and a value.  Filter properties
  Condition - The condition to apply. Valid values are IS and IS_NOT. To include the forecast
  export jobs that match the statement, specify IS. To exclude matching forecast export jobs,
  specify IS_NOT.    Key - The name of the parameter to filter on. Valid values are
  WhatIfForecastArn and Status.    Value - The value to match.   For example, to list all
  jobs that export a forecast named electricityWhatIfForecast, specify the following filter:
  \"Filters\": [ { \"Condition\": \"IS\", \"Key\": \"WhatIfForecastArn\", \"Value\":
  \"arn:aws:forecast:us-west-2:&lt;acct-id&gt;:forecast/electricityWhatIfForecast\" } ]
- `"MaxResults"`: The number of items to return in the response.
- `"NextToken"`: If the result of the previous request was truncated, the response includes
  a NextToken. To retrieve the next set of results, use the token in the next&#x2028;
  request. Tokens expire after 24 hours.
"""
function list_what_if_forecasts(; aws_config::AbstractAWSConfig=current_aws_config())
    return forecast(
        "ListWhatIfForecasts"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_what_if_forecasts(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return forecast(
        "ListWhatIfForecasts",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    resume_resource(resource_arn)
    resume_resource(resource_arn, params::Dict{String,<:Any})

Resumes a stopped monitor resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the monitor resource to resume.

"""
function resume_resource(ResourceArn; aws_config::AbstractAWSConfig=current_aws_config())
    return forecast(
        "ResumeResource",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function resume_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecast(
        "ResumeResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_resource(resource_arn)
    stop_resource(resource_arn, params::Dict{String,<:Any})

Stops a resource. The resource undergoes the following states: CREATE_STOPPING and
CREATE_STOPPED. You cannot resume a resource once it has been stopped. This operation can
be applied to the following resources (and their corresponding child resources):   Dataset
Import Job   Predictor Job   Forecast Job   Forecast Export Job   Predictor Backtest Export
Job   Explainability Job   Explainability Export Job

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) that identifies the resource to stop. The
  supported ARNs are DatasetImportJobArn, PredictorArn, PredictorBacktestExportJobArn,
  ForecastArn, ForecastExportJobArn, ExplainabilityArn, and ExplainabilityExportArn.

"""
function stop_resource(ResourceArn; aws_config::AbstractAWSConfig=current_aws_config())
    return forecast(
        "StopResource",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecast(
        "StopResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Associates the specified tags to a resource with the specified resourceArn. If existing
tags on a resource are not specified in the request parameters, they are not changed. When
a resource is deleted, the tags associated with that resource are also deleted.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) that identifies the resource for which to
  list the tags.
- `tags`: The tags to add to the resource. A tag is an array of key-value pairs. The
  following basic restrictions apply to tags:   Maximum number of tags per resource - 50.
  For each resource, each tag key must be unique, and each tag key can have only one value.
  Maximum key length - 128 Unicode characters in UTF-8.   Maximum value length - 256 Unicode
  characters in UTF-8.   If your tagging schema is used across multiple services and
  resources, remember that other services may have restrictions on allowed characters.
  Generally allowed characters are: letters, numbers, and spaces representable in UTF-8, and
  the following characters: + - = . _ : / @.   Tag keys and values are case sensitive.   Do
  not use aws:, AWS:, or any upper or lowercase combination of such as a prefix for keys as
  it is reserved for Amazon Web Services use. You cannot edit or delete tag keys with this
  prefix. Values can have this prefix. If a tag value has aws as its prefix but the key does
  not, then Forecast considers it to be a user tag and will count against the limit of 50
  tags. Tags with only the key prefix of aws do not count against your tags per resource
  limit.

"""
function tag_resource(ResourceArn, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return forecast(
        "TagResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceArn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecast(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Deletes the specified tags from a resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) that identifies the resource for which to
  list the tags.
- `tag_keys`: The keys of the tags to be removed.

"""
function untag_resource(
    ResourceArn, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return forecast(
        "UntagResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceArn,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecast(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_dataset_group(dataset_arns, dataset_group_arn)
    update_dataset_group(dataset_arns, dataset_group_arn, params::Dict{String,<:Any})

Replaces the datasets in a dataset group with the specified datasets.  The Status of the
dataset group must be ACTIVE before you can use the dataset group to create a predictor.
Use the DescribeDatasetGroup operation to get the status.

# Arguments
- `dataset_arns`: An array of the Amazon Resource Names (ARNs) of the datasets to add to
  the dataset group.
- `dataset_group_arn`: The ARN of the dataset group.

"""
function update_dataset_group(
    DatasetArns, DatasetGroupArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return forecast(
        "UpdateDatasetGroup",
        Dict{String,Any}(
            "DatasetArns" => DatasetArns, "DatasetGroupArn" => DatasetGroupArn
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_dataset_group(
    DatasetArns,
    DatasetGroupArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecast(
        "UpdateDatasetGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DatasetArns" => DatasetArns, "DatasetGroupArn" => DatasetGroupArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: mediastore_data
using AWS.Compat
using AWS.UUIDs

"""
    delete_object(path)
    delete_object(path, params::Dict{String,<:Any})

Deletes an object at the specified path.

# Arguments
- `path`: The path (including the file name) where the object is stored in the container.
  Format: &lt;folder name&gt;/&lt;folder name&gt;/&lt;file name&gt;

"""
function delete_object(Path; aws_config::AbstractAWSConfig=current_aws_config())
    return mediastore_data(
        "DELETE", "/$(Path)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function delete_object(
    Path, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediastore_data(
        "DELETE", "/$(Path)", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_object(path)
    describe_object(path, params::Dict{String,<:Any})

Gets the headers for an object at the specified path.

# Arguments
- `path`: The path (including the file name) where the object is stored in the container.
  Format: &lt;folder name&gt;/&lt;folder name&gt;/&lt;file name&gt;

"""
function describe_object(Path; aws_config::AbstractAWSConfig=current_aws_config())
    return mediastore_data(
        "HEAD", "/$(Path)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_object(
    Path, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediastore_data(
        "HEAD", "/$(Path)", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_object(path)
    get_object(path, params::Dict{String,<:Any})

Downloads the object at the specified path. If the object’s upload availability is set to
streaming, AWS Elemental MediaStore downloads the object even if it’s still uploading the
object.

# Arguments
- `path`: The path (including the file name) where the object is stored in the container.
  Format: &lt;folder name&gt;/&lt;folder name&gt;/&lt;file name&gt; For example, to upload
  the file mlaw.avi to the folder path premiumcanada in the container movies, enter the path
  premium/canada/mlaw.avi. Do not include the container name in this path. If the path
  includes any folders that don't exist yet, the service creates them. For example, suppose
  you have an existing premium/usa subfolder. If you specify premium/canada, the service
  creates a canada subfolder in the premium folder. You then have two subfolders, usa and
  canada, in the premium folder.  There is no correlation between the path to the source and
  the path (folders) in the container in AWS Elemental MediaStore. For more information about
  folders and how they exist in a container, see the AWS Elemental MediaStore User Guide. The
  file name is the name that is assigned to the file that you upload. The file can have the
  same name inside and outside of AWS Elemental MediaStore, or it can have the same name. The
  file name can include or omit an extension.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Range"`: The range bytes of an object to retrieve. For more information about the Range
  header, see http://www.w3.org/Protocols/rfc2616/rfc2616-sec14.html#sec14.35. AWS Elemental
  MediaStore ignores this header for partially uploaded objects that have streaming upload
  availability.
"""
function get_object(Path; aws_config::AbstractAWSConfig=current_aws_config())
    return mediastore_data(
        "GET", "/$(Path)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_object(
    Path, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediastore_data(
        "GET", "/$(Path)", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_items()
    list_items(params::Dict{String,<:Any})

Provides a list of metadata entries about folders and objects in the specified folder.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to return per API request. For example, you
  submit a ListItems request with MaxResults set at 500. Although 2,000 items match your
  request, the service returns no more than the first 500 items. (The service also returns a
  NextToken value that you can use to fetch the next batch of results.) The service might
  return fewer results than the MaxResults value. If MaxResults is not included in the
  request, the service defaults to pagination with a maximum of 1,000 results per page.
- `"NextToken"`: The token that identifies which batch of results that you want to see. For
  example, you submit a ListItems request with MaxResults set at 500. The service returns the
  first batch of results (up to 500) and a NextToken value. To see the next batch of results,
  you can submit the ListItems request a second time and specify the NextToken value. Tokens
  expire after 15 minutes.
- `"Path"`: The path in the container from which to retrieve items. Format: &lt;folder
  name&gt;/&lt;folder name&gt;/&lt;file name&gt;
"""
function list_items(; aws_config::AbstractAWSConfig=current_aws_config())
    return mediastore_data(
        "GET", "/"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_items(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediastore_data(
        "GET", "/", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    put_object(body, path)
    put_object(body, path, params::Dict{String,<:Any})

Uploads an object to the specified path. Object sizes are limited to 25 MB for standard
upload availability and 10 MB for streaming upload availability.

# Arguments
- `body`: The bytes to be stored.
- `path`: The path (including the file name) where the object is stored in the container.
  Format: &lt;folder name&gt;/&lt;folder name&gt;/&lt;file name&gt; For example, to upload
  the file mlaw.avi to the folder path premiumcanada in the container movies, enter the path
  premium/canada/mlaw.avi. Do not include the container name in this path. If the path
  includes any folders that don't exist yet, the service creates them. For example, suppose
  you have an existing premium/usa subfolder. If you specify premium/canada, the service
  creates a canada subfolder in the premium folder. You then have two subfolders, usa and
  canada, in the premium folder.  There is no correlation between the path to the source and
  the path (folders) in the container in AWS Elemental MediaStore. For more information about
  folders and how they exist in a container, see the AWS Elemental MediaStore User Guide. The
  file name is the name that is assigned to the file that you upload. The file can have the
  same name inside and outside of AWS Elemental MediaStore, or it can have the same name. The
  file name can include or omit an extension.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Cache-Control"`: An optional CacheControl header that allows the caller to control the
  object's cache behavior. Headers can be passed in as specified in the HTTP at
  https://www.w3.org/Protocols/rfc2616/rfc2616-sec14.html#sec14.9. Headers with a custom
  user-defined value are also accepted.
- `"Content-Type"`: The content type of the object.
- `"x-amz-storage-class"`: Indicates the storage class of a Put request. Defaults to
  high-performance temporal storage class, and objects are persisted into durable storage
  shortly after being received.
- `"x-amz-upload-availability"`: Indicates the availability of an object while it is still
  uploading. If the value is set to streaming, the object is available for downloading after
  some initial buffering but before the object is uploaded completely. If the value is set to
  standard, the object is available for downloading only when it is uploaded completely. The
  default value for this header is standard. To use this header, you must also set the HTTP
  Transfer-Encoding header to chunked.
"""
function put_object(Body, Path; aws_config::AbstractAWSConfig=current_aws_config())
    return mediastore_data(
        "PUT",
        "/$(Path)",
        Dict{String,Any}("Body" => Body);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_object(
    Body,
    Path,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediastore_data(
        "PUT",
        "/$(Path)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Body" => Body), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

struct Response{S<:IO}
    response::HTTP.Response
    io::S  # I/O type must support `seek`
    dict::Ref{AbstractDict}  # Caches the parsed dict response
end

Response(response::HTTP.Response, io::IO) = Response(response, io, Ref{AbstractDict}())

function Base.getproperty(r::Response, f::Symbol)
    if f === :io || f === :response || f === :dict
        # Direct access to the fields stored in `Response`
        return getfield(r, f)
    elseif f === :body
        # As we're streaming the requests we'll fake the `HTTP.Response` body field
        return _rewind(read, r.io)::Vector{UInt8}
    else
        # Pretend like we're an `HTTP.Response` type for any other field access
        return getproperty(r.response, f)
    end
end

function mime_type(r::Response)
    # Parse response data according to mimetype...
    # Using "application/octet-stream" as the fallback MIME type as recommended by:
    # https://developer.mozilla.org/en-US/docs/Web/HTTP/Basics_of_HTTP/MIME_types/Common_types
    mime = HTTP.header(r.response, "Content-Type", "application/octet-stream")

    # When the MIME type is not specified attempt to determine type from first bytes of the
    # stream.
    magic_bytes = if isempty(HTTP.header(r.response, "Content-Type", ""))
        _rewind(r.io) do io
            read(io, 5)
        end
    else
        UInt8[]
    end

    T = if occursin(r"/xml", mime) || magic_bytes == b"<?xml"
        MIME"application/xml"
    elseif occursin(r"/x-amz-json-1\.[01]$", mime) || endswith(mime, "json")
        MIME"application/json"
    elseif startswith(mime, "text/")
        MIME"text/plain"
    else
        MIME{Symbol(mime)}  # Unhandled MIME type
    end

    return T
end

function Base.parse(f::Function, r::Response, mime::MIME=mime_type(r)())
    result = _rewind(r.io) do io
        f(io, mime)
    end
    return result
end

Base.parse(r::Response, mime::MIME=mime_type(r)()) = parse(_read, r, mime)

function _read(io::IO, ::MIME"application/xml")
    xml = parse_xml(read(io, String))
    root = XMLDict.root(xml.x)  # Drop XML declaration
    return xml_dict(root, LittleDict{Union{String,Symbol},Any})
end

function _read(io::IO, ::MIME"application/json")
    # Note: Using JSON instead of JSON3 since it does not support OrderedDict/LittleDict
    return JSON.parse(io; dicttype=LittleDict{String,Any})
end

_read(io::IO, ::MIME"text/plain") = read(io, String)
_read(io::IO, ::MIME) = read(io)

# Dict-like access
function _dict(r::Response)
    if !isassigned(r.dict)
        dict = parse(r)::AbstractDict
        r.dict[] = dict
    end

    return r.dict[]
end

Base.getindex(r::Response, key::Union{AbstractString,Symbol}) = getindex(_dict(r), key)
Base.haskey(r::Response, key::Union{AbstractString,Symbol}) = haskey(_dict(r), key)
Base.keys(r::Response) = keys(_dict(r))
Base.values(r::Response) = values(_dict(r))

function Base.iterate(r::Response)
    iter = parse(r)
    x = iterate(iter)
    x === nothing && return nothing
    el, s = x
    return (el, (iter, s))
end

function Base.iterate(r::Response, state)
    iter, s = state
    x = iterate(iter, s)
    x === nothing && return nothing
    el, s = x
    return (el, (iter, s))
end

Base.String(r::Response) = _rewind(io -> read(io, String), r.io)

function Base.show(io::IO, m::MIME"text/plain", r::Response)
    println(io, "$(Response): $(mime_type(r)()) interpreted as:")

    content = parse(r)
    show(io, m, content)

    return nothing
end

function _rewind(f::Function, io::IO)
    pos = position(io)
    seekstart(io)
    result = try
        f(io)
    finally
        seek(io, pos)
    end
    return result
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: personalize_events
using AWS.Compat
using AWS.UUIDs

"""
    put_action_interactions(action_interactions, tracking_id)
    put_action_interactions(action_interactions, tracking_id, params::Dict{String,<:Any})

Records action interaction event data. An action interaction event is an interaction
between a user and an action. For example, a user taking an action, such a enrolling in a
membership program or downloading your app.  For more information about recording action
interactions, see Recording action interaction events. For more information about actions
in an Actions dataset, see Actions dataset.

# Arguments
- `action_interactions`: A list of action interaction events from the session.
- `tracking_id`: The ID of your action interaction event tracker. When you create an Action
  interactions dataset, Amazon Personalize creates an action interaction event tracker for
  you. For more information, see Action interaction event tracker ID.

"""
function put_action_interactions(
    actionInteractions, trackingId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return personalize_events(
        "POST",
        "/action-interactions",
        Dict{String,Any}(
            "actionInteractions" => actionInteractions, "trackingId" => trackingId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_action_interactions(
    actionInteractions,
    trackingId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize_events(
        "POST",
        "/action-interactions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "actionInteractions" => actionInteractions, "trackingId" => trackingId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_actions(actions, dataset_arn)
    put_actions(actions, dataset_arn, params::Dict{String,<:Any})

Adds one or more actions to an Actions dataset. For more information see Importing actions
individually.

# Arguments
- `actions`: A list of action data.
- `dataset_arn`: The Amazon Resource Name (ARN) of the Actions dataset you are adding the
  action or actions to.

"""
function put_actions(
    actions, datasetArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return personalize_events(
        "POST",
        "/actions",
        Dict{String,Any}("actions" => actions, "datasetArn" => datasetArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_actions(
    actions,
    datasetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize_events(
        "POST",
        "/actions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("actions" => actions, "datasetArn" => datasetArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_events(event_list, session_id, tracking_id)
    put_events(event_list, session_id, tracking_id, params::Dict{String,<:Any})

Records item interaction event data. For more information see Recording item interaction
events.

# Arguments
- `event_list`: A list of event data from the session.
- `session_id`: The session ID associated with the user's visit. Your application generates
  the sessionId when a user first visits your website or uses your application. Amazon
  Personalize uses the sessionId to associate events with the user before they log in. For
  more information, see Recording item interaction events.
- `tracking_id`: The tracking ID for the event. The ID is generated by a call to the
  CreateEventTracker API.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"userId"`: The user associated with the event.
"""
function put_events(
    eventList, sessionId, trackingId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return personalize_events(
        "POST",
        "/events",
        Dict{String,Any}(
            "eventList" => eventList, "sessionId" => sessionId, "trackingId" => trackingId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_events(
    eventList,
    sessionId,
    trackingId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize_events(
        "POST",
        "/events",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "eventList" => eventList,
                    "sessionId" => sessionId,
                    "trackingId" => trackingId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_items(dataset_arn, items)
    put_items(dataset_arn, items, params::Dict{String,<:Any})

Adds one or more items to an Items dataset. For more information see Importing items
individually.

# Arguments
- `dataset_arn`: The Amazon Resource Name (ARN) of the Items dataset you are adding the
  item or items to.
- `items`: A list of item data.

"""
function put_items(datasetArn, items; aws_config::AbstractAWSConfig=current_aws_config())
    return personalize_events(
        "POST",
        "/items",
        Dict{String,Any}("datasetArn" => datasetArn, "items" => items);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_items(
    datasetArn,
    items,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize_events(
        "POST",
        "/items",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("datasetArn" => datasetArn, "items" => items),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_users(dataset_arn, users)
    put_users(dataset_arn, users, params::Dict{String,<:Any})

Adds one or more users to a Users dataset. For more information see Importing users
individually.

# Arguments
- `dataset_arn`: The Amazon Resource Name (ARN) of the Users dataset you are adding the
  user or users to.
- `users`: A list of user data.

"""
function put_users(datasetArn, users; aws_config::AbstractAWSConfig=current_aws_config())
    return personalize_events(
        "POST",
        "/users",
        Dict{String,Any}("datasetArn" => datasetArn, "users" => users);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_users(
    datasetArn,
    users,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize_events(
        "POST",
        "/users",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("datasetArn" => datasetArn, "users" => users),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: inspector2
using AWS.Compat
using AWS.UUIDs

"""
    associate_member(account_id)
    associate_member(account_id, params::Dict{String,<:Any})

Associates an Amazon Web Services account with an Amazon Inspector delegated administrator.
An HTTP 200 response indicates the association was successfully started, but doesn’t
indicate whether it was completed. You can check if the association completed by using
ListMembers for multiple accounts or GetMembers for a single account.

# Arguments
- `account_id`: The Amazon Web Services account ID of the member account to be associated.

"""
function associate_member(accountId; aws_config::AbstractAWSConfig=current_aws_config())
    return inspector2(
        "POST",
        "/members/associate",
        Dict{String,Any}("accountId" => accountId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_member(
    accountId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector2(
        "POST",
        "/members/associate",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("accountId" => accountId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_get_account_status()
    batch_get_account_status(params::Dict{String,<:Any})

Retrieves the Amazon Inspector status of multiple Amazon Web Services accounts within your
environment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountIds"`: The 12-digit Amazon Web Services account IDs of the accounts to retrieve
  Amazon Inspector status for.
"""
function batch_get_account_status(; aws_config::AbstractAWSConfig=current_aws_config())
    return inspector2(
        "POST", "/status/batch/get"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function batch_get_account_status(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector2(
        "POST",
        "/status/batch/get",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_get_code_snippet(finding_arns)
    batch_get_code_snippet(finding_arns, params::Dict{String,<:Any})

Retrieves code snippets from findings that Amazon Inspector detected code vulnerabilities
in.

# Arguments
- `finding_arns`: An array of finding ARNs for the findings you want to retrieve code
  snippets from.

"""
function batch_get_code_snippet(
    findingArns; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector2(
        "POST",
        "/codesnippet/batchget",
        Dict{String,Any}("findingArns" => findingArns);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_code_snippet(
    findingArns,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector2(
        "POST",
        "/codesnippet/batchget",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("findingArns" => findingArns), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_get_finding_details(finding_arns)
    batch_get_finding_details(finding_arns, params::Dict{String,<:Any})

Gets vulnerability details for findings.

# Arguments
- `finding_arns`: A list of finding ARNs.

"""
function batch_get_finding_details(
    findingArns; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector2(
        "POST",
        "/findings/details/batch/get",
        Dict{String,Any}("findingArns" => findingArns);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_finding_details(
    findingArns,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector2(
        "POST",
        "/findings/details/batch/get",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("findingArns" => findingArns), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_get_free_trial_info(account_ids)
    batch_get_free_trial_info(account_ids, params::Dict{String,<:Any})

Gets free trial status for multiple Amazon Web Services accounts.

# Arguments
- `account_ids`: The account IDs to get free trial status for.

"""
function batch_get_free_trial_info(
    accountIds; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector2(
        "POST",
        "/freetrialinfo/batchget",
        Dict{String,Any}("accountIds" => accountIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_free_trial_info(
    accountIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector2(
        "POST",
        "/freetrialinfo/batchget",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("accountIds" => accountIds), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_get_member_ec2_deep_inspection_status()
    batch_get_member_ec2_deep_inspection_status(params::Dict{String,<:Any})

Retrieves Amazon Inspector deep inspection activation status of multiple member accounts
within your organization. You must be the delegated administrator of an organization in
Amazon Inspector to use this API.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountIds"`: The unique identifiers for the Amazon Web Services accounts to retrieve
  Amazon Inspector deep inspection activation status for.  &lt;/p&gt;
"""
function batch_get_member_ec2_deep_inspection_status(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector2(
        "POST",
        "/ec2deepinspectionstatus/member/batch/get";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_member_ec2_deep_inspection_status(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector2(
        "POST",
        "/ec2deepinspectionstatus/member/batch/get",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_update_member_ec2_deep_inspection_status(account_ids)
    batch_update_member_ec2_deep_inspection_status(account_ids, params::Dict{String,<:Any})

Activates or deactivates Amazon Inspector deep inspection for the provided member accounts
in your organization. You must be the delegated administrator of an organization in Amazon
Inspector to use this API.

# Arguments
- `account_ids`: The unique identifiers for the Amazon Web Services accounts to change
  Amazon Inspector deep inspection status for.

"""
function batch_update_member_ec2_deep_inspection_status(
    accountIds; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector2(
        "POST",
        "/ec2deepinspectionstatus/member/batch/update",
        Dict{String,Any}("accountIds" => accountIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_update_member_ec2_deep_inspection_status(
    accountIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector2(
        "POST",
        "/ec2deepinspectionstatus/member/batch/update",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("accountIds" => accountIds), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_findings_report(report_id)
    cancel_findings_report(report_id, params::Dict{String,<:Any})

Cancels the given findings report.

# Arguments
- `report_id`: The ID of the report to be canceled.

"""
function cancel_findings_report(
    reportId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector2(
        "POST",
        "/reporting/cancel",
        Dict{String,Any}("reportId" => reportId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_findings_report(
    reportId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector2(
        "POST",
        "/reporting/cancel",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("reportId" => reportId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_sbom_export(report_id)
    cancel_sbom_export(report_id, params::Dict{String,<:Any})

Cancels a software bill of materials (SBOM) report.

# Arguments
- `report_id`: The report ID of the SBOM export to cancel.

"""
function cancel_sbom_export(reportId; aws_config::AbstractAWSConfig=current_aws_config())
    return inspector2(
        "POST",
        "/sbomexport/cancel",
        Dict{String,Any}("reportId" => reportId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_sbom_export(
    reportId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector2(
        "POST",
        "/sbomexport/cancel",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("reportId" => reportId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_cis_scan_configuration(scan_name, schedule, security_level, targets)
    create_cis_scan_configuration(scan_name, schedule, security_level, targets, params::Dict{String,<:Any})

Creates a CIS scan configuration.

# Arguments
- `scan_name`: The scan name for the CIS scan configuration.
- `schedule`: The schedule for the CIS scan configuration.
- `security_level`:  The security level for the CIS scan configuration. Security level
  refers to the Benchmark levels that CIS assigns to a profile.
- `targets`: The targets for the CIS scan configuration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tags"`: The tags for the CIS scan configuration.
"""
function create_cis_scan_configuration(
    scanName,
    schedule,
    securityLevel,
    targets;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector2(
        "POST",
        "/cis/scan-configuration/create",
        Dict{String,Any}(
            "scanName" => scanName,
            "schedule" => schedule,
            "securityLevel" => securityLevel,
            "targets" => targets,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_cis_scan_configuration(
    scanName,
    schedule,
    securityLevel,
    targets,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector2(
        "POST",
        "/cis/scan-configuration/create",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "scanName" => scanName,
                    "schedule" => schedule,
                    "securityLevel" => securityLevel,
                    "targets" => targets,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_filter(action, filter_criteria, name)
    create_filter(action, filter_criteria, name, params::Dict{String,<:Any})

Creates a filter resource using specified filter criteria. When the filter action is set to
SUPPRESS this action creates a suppression rule.

# Arguments
- `action`: Defines the action that is to be applied to the findings that match the filter.
- `filter_criteria`: Defines the criteria to be used in the filter for querying findings.
- `name`: The name of the filter. Minimum length of 3. Maximum length of 64. Valid
  characters include alphanumeric characters, dot (.), underscore (_), and dash (-). Spaces
  are not allowed.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A description of the filter.
- `"reason"`: The reason for creating the filter.
- `"tags"`: A list of tags for the filter.
"""
function create_filter(
    action, filterCriteria, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector2(
        "POST",
        "/filters/create",
        Dict{String,Any}(
            "action" => action, "filterCriteria" => filterCriteria, "name" => name
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_filter(
    action,
    filterCriteria,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector2(
        "POST",
        "/filters/create",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "action" => action, "filterCriteria" => filterCriteria, "name" => name
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_findings_report(report_format, s3_destination)
    create_findings_report(report_format, s3_destination, params::Dict{String,<:Any})

Creates a finding report. By default only ACTIVE findings are returned in the report. To
see SUPRESSED or CLOSED findings you must specify a value for the findingStatus filter
criteria.

# Arguments
- `report_format`: The format to generate the report in.
- `s3_destination`: The Amazon S3 export destination for the report.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filterCriteria"`: The filter criteria to apply to the results of the finding report.
"""
function create_findings_report(
    reportFormat, s3Destination; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector2(
        "POST",
        "/reporting/create",
        Dict{String,Any}("reportFormat" => reportFormat, "s3Destination" => s3Destination);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_findings_report(
    reportFormat,
    s3Destination,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector2(
        "POST",
        "/reporting/create",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "reportFormat" => reportFormat, "s3Destination" => s3Destination
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_sbom_export(report_format, s3_destination)
    create_sbom_export(report_format, s3_destination, params::Dict{String,<:Any})

Creates a software bill of materials (SBOM) report.

# Arguments
- `report_format`: The output format for the software bill of materials (SBOM) report.
- `s3_destination`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"resourceFilterCriteria"`: The resource filter criteria for the software bill of
  materials (SBOM) report.
"""
function create_sbom_export(
    reportFormat, s3Destination; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector2(
        "POST",
        "/sbomexport/create",
        Dict{String,Any}("reportFormat" => reportFormat, "s3Destination" => s3Destination);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_sbom_export(
    reportFormat,
    s3Destination,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector2(
        "POST",
        "/sbomexport/create",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "reportFormat" => reportFormat, "s3Destination" => s3Destination
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_cis_scan_configuration(scan_configuration_arn)
    delete_cis_scan_configuration(scan_configuration_arn, params::Dict{String,<:Any})

Deletes a CIS scan configuration.

# Arguments
- `scan_configuration_arn`: The ARN of the CIS scan configuration.

"""
function delete_cis_scan_configuration(
    scanConfigurationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector2(
        "POST",
        "/cis/scan-configuration/delete",
        Dict{String,Any}("scanConfigurationArn" => scanConfigurationArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_cis_scan_configuration(
    scanConfigurationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector2(
        "POST",
        "/cis/scan-configuration/delete",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("scanConfigurationArn" => scanConfigurationArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_filter(arn)
    delete_filter(arn, params::Dict{String,<:Any})

Deletes a filter resource.

# Arguments
- `arn`: The Amazon Resource Number (ARN) of the filter to be deleted.

"""
function delete_filter(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return inspector2(
        "POST",
        "/filters/delete",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_filter(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector2(
        "POST",
        "/filters/delete",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_organization_configuration()
    describe_organization_configuration(params::Dict{String,<:Any})

Describe Amazon Inspector configuration settings for an Amazon Web Services organization.

"""
function describe_organization_configuration(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector2(
        "POST",
        "/organizationconfiguration/describe";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_organization_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector2(
        "POST",
        "/organizationconfiguration/describe",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disable()
    disable(params::Dict{String,<:Any})

Disables Amazon Inspector scans for one or more Amazon Web Services accounts. Disabling all
scan types in an account disables the Amazon Inspector service.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountIds"`: An array of account IDs you want to disable Amazon Inspector scans for.
- `"resourceTypes"`: The resource scan types you want to disable.
"""
function disable(; aws_config::AbstractAWSConfig=current_aws_config())
    return inspector2(
        "POST", "/disable"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function disable(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector2(
        "POST", "/disable", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    disable_delegated_admin_account(delegated_admin_account_id)
    disable_delegated_admin_account(delegated_admin_account_id, params::Dict{String,<:Any})

Disables the Amazon Inspector delegated administrator for your organization.

# Arguments
- `delegated_admin_account_id`: The Amazon Web Services account ID of the current Amazon
  Inspector delegated administrator.

"""
function disable_delegated_admin_account(
    delegatedAdminAccountId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector2(
        "POST",
        "/delegatedadminaccounts/disable",
        Dict{String,Any}("delegatedAdminAccountId" => delegatedAdminAccountId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disable_delegated_admin_account(
    delegatedAdminAccountId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector2(
        "POST",
        "/delegatedadminaccounts/disable",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("delegatedAdminAccountId" => delegatedAdminAccountId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_member(account_id)
    disassociate_member(account_id, params::Dict{String,<:Any})

Disassociates a member account from an Amazon Inspector delegated administrator.

# Arguments
- `account_id`: The Amazon Web Services account ID of the member account to disassociate.

"""
function disassociate_member(accountId; aws_config::AbstractAWSConfig=current_aws_config())
    return inspector2(
        "POST",
        "/members/disassociate",
        Dict{String,Any}("accountId" => accountId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_member(
    accountId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector2(
        "POST",
        "/members/disassociate",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("accountId" => accountId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    enable(resource_types)
    enable(resource_types, params::Dict{String,<:Any})

Enables Amazon Inspector scans for one or more Amazon Web Services accounts.

# Arguments
- `resource_types`: The resource scan types you want to enable.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountIds"`: A list of account IDs you want to enable Amazon Inspector scans for.
- `"clientToken"`: The idempotency token for the request.
"""
function enable(resourceTypes; aws_config::AbstractAWSConfig=current_aws_config())
    return inspector2(
        "POST",
        "/enable",
        Dict{String,Any}(
            "resourceTypes" => resourceTypes, "clientToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function enable(
    resourceTypes,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector2(
        "POST",
        "/enable",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "resourceTypes" => resourceTypes, "clientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    enable_delegated_admin_account(delegated_admin_account_id)
    enable_delegated_admin_account(delegated_admin_account_id, params::Dict{String,<:Any})

Enables the Amazon Inspector delegated administrator for your Organizations organization.

# Arguments
- `delegated_admin_account_id`: The Amazon Web Services account ID of the Amazon Inspector
  delegated administrator.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: The idempotency token for the request.
"""
function enable_delegated_admin_account(
    delegatedAdminAccountId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector2(
        "POST",
        "/delegatedadminaccounts/enable",
        Dict{String,Any}(
            "delegatedAdminAccountId" => delegatedAdminAccountId,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function enable_delegated_admin_account(
    delegatedAdminAccountId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector2(
        "POST",
        "/delegatedadminaccounts/enable",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "delegatedAdminAccountId" => delegatedAdminAccountId,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_cis_scan_report(scan_arn)
    get_cis_scan_report(scan_arn, params::Dict{String,<:Any})

Retrieves a CIS scan report.

# Arguments
- `scan_arn`: The scan ARN.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"reportFormat"`:  The format of the report. Valid values are PDF and CSV. If no value is
  specified, the report format defaults to PDF.
- `"targetAccounts"`: The target accounts.
"""
function get_cis_scan_report(scanArn; aws_config::AbstractAWSConfig=current_aws_config())
    return inspector2(
        "POST",
        "/cis/scan/report/get",
        Dict{String,Any}("scanArn" => scanArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_cis_scan_report(
    scanArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector2(
        "POST",
        "/cis/scan/report/get",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("scanArn" => scanArn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_cis_scan_result_details(account_id, scan_arn, target_resource_id)
    get_cis_scan_result_details(account_id, scan_arn, target_resource_id, params::Dict{String,<:Any})

Retrieves CIS scan result details.

# Arguments
- `account_id`: The account ID.
- `scan_arn`: The scan ARN.
- `target_resource_id`: The target resource ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filterCriteria"`: The filter criteria.
- `"maxResults"`: The maximum number of CIS scan result details to be returned in a single
  page of results.
- `"nextToken"`: The pagination token from a previous request that's used to retrieve the
  next page of results.
- `"sortBy"`: The sort by order.
- `"sortOrder"`: The sort order.
"""
function get_cis_scan_result_details(
    accountId, scanArn, targetResourceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector2(
        "POST",
        "/cis/scan-result/details/get",
        Dict{String,Any}(
            "accountId" => accountId,
            "scanArn" => scanArn,
            "targetResourceId" => targetResourceId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_cis_scan_result_details(
    accountId,
    scanArn,
    targetResourceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector2(
        "POST",
        "/cis/scan-result/details/get",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "accountId" => accountId,
                    "scanArn" => scanArn,
                    "targetResourceId" => targetResourceId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_configuration()
    get_configuration(params::Dict{String,<:Any})

Retrieves setting configurations for Inspector scans.

"""
function get_configuration(; aws_config::AbstractAWSConfig=current_aws_config())
    return inspector2(
        "POST", "/configuration/get"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector2(
        "POST",
        "/configuration/get",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_delegated_admin_account()
    get_delegated_admin_account(params::Dict{String,<:Any})

Retrieves information about the Amazon Inspector delegated administrator for your
organization.

"""
function get_delegated_admin_account(; aws_config::AbstractAWSConfig=current_aws_config())
    return inspector2(
        "POST",
        "/delegatedadminaccounts/get";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_delegated_admin_account(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector2(
        "POST",
        "/delegatedadminaccounts/get",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_ec2_deep_inspection_configuration()
    get_ec2_deep_inspection_configuration(params::Dict{String,<:Any})

Retrieves the activation status of Amazon Inspector deep inspection and custom paths
associated with your account.

"""
function get_ec2_deep_inspection_configuration(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector2(
        "POST",
        "/ec2deepinspectionconfiguration/get";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_ec2_deep_inspection_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector2(
        "POST",
        "/ec2deepinspectionconfiguration/get",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_encryption_key(resource_type, scan_type)
    get_encryption_key(resource_type, scan_type, params::Dict{String,<:Any})

Gets an encryption key.

# Arguments
- `resource_type`: The resource type the key encrypts.
- `scan_type`: The scan type the key encrypts.

"""
function get_encryption_key(
    resourceType, scanType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector2(
        "GET",
        "/encryptionkey/get",
        Dict{String,Any}("resourceType" => resourceType, "scanType" => scanType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_encryption_key(
    resourceType,
    scanType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector2(
        "GET",
        "/encryptionkey/get",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceType" => resourceType, "scanType" => scanType),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_findings_report_status()
    get_findings_report_status(params::Dict{String,<:Any})

Gets the status of a findings report.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"reportId"`: The ID of the report to retrieve the status of.
"""
function get_findings_report_status(; aws_config::AbstractAWSConfig=current_aws_config())
    return inspector2(
        "POST",
        "/reporting/status/get";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_findings_report_status(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector2(
        "POST",
        "/reporting/status/get",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_member(account_id)
    get_member(account_id, params::Dict{String,<:Any})

Gets member information for your organization.

# Arguments
- `account_id`: The Amazon Web Services account ID of the member account to retrieve
  information on.

"""
function get_member(accountId; aws_config::AbstractAWSConfig=current_aws_config())
    return inspector2(
        "POST",
        "/members/get",
        Dict{String,Any}("accountId" => accountId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_member(
    accountId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector2(
        "POST",
        "/members/get",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("accountId" => accountId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_sbom_export(report_id)
    get_sbom_export(report_id, params::Dict{String,<:Any})

Gets details of a software bill of materials (SBOM) report.

# Arguments
- `report_id`: The report ID of the SBOM export to get details for.

"""
function get_sbom_export(reportId; aws_config::AbstractAWSConfig=current_aws_config())
    return inspector2(
        "POST",
        "/sbomexport/get",
        Dict{String,Any}("reportId" => reportId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_sbom_export(
    reportId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector2(
        "POST",
        "/sbomexport/get",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("reportId" => reportId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_account_permissions()
    list_account_permissions(params::Dict{String,<:Any})

Lists the permissions an account has to configure Amazon Inspector.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results the response can return. If your request
  would return more than the maximum the response will return a nextToken value, use this
  value when you call the action again to get the remaining results.
- `"nextToken"`: A token to use for paginating results that are returned in the response.
  Set the value of this parameter to null for the first request to a list action. If your
  response returns more than the maxResults maximum value it will also return a nextToken
  value. For subsequent calls, use the NextToken value returned from the previous request to
  continue listing results after the first page.
- `"service"`: The service scan type to check permissions for.
"""
function list_account_permissions(; aws_config::AbstractAWSConfig=current_aws_config())
    return inspector2(
        "POST",
        "/accountpermissions/list";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_account_permissions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector2(
        "POST",
        "/accountpermissions/list",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_cis_scan_configurations()
    list_cis_scan_configurations(params::Dict{String,<:Any})

Lists CIS scan configurations.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filterCriteria"`: The CIS scan configuration filter criteria.
- `"maxResults"`: The maximum number of CIS scan configurations to be returned in a single
  page of results.
- `"nextToken"`: The pagination token from a previous request that's used to retrieve the
  next page of results.
- `"sortBy"`: The CIS scan configuration sort by order.
- `"sortOrder"`: The CIS scan configuration sort order order.
"""
function list_cis_scan_configurations(; aws_config::AbstractAWSConfig=current_aws_config())
    return inspector2(
        "POST",
        "/cis/scan-configuration/list";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_cis_scan_configurations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector2(
        "POST",
        "/cis/scan-configuration/list",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_cis_scan_results_aggregated_by_checks(scan_arn)
    list_cis_scan_results_aggregated_by_checks(scan_arn, params::Dict{String,<:Any})

Lists scan results aggregated by checks.

# Arguments
- `scan_arn`: The scan ARN.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filterCriteria"`: The filter criteria.
- `"maxResults"`: The maximum number of scan results aggregated by checks to be returned in
  a single page of results.
- `"nextToken"`: The pagination token from a previous request that's used to retrieve the
  next page of results.
- `"sortBy"`: The sort by order.
- `"sortOrder"`: The sort order.
"""
function list_cis_scan_results_aggregated_by_checks(
    scanArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector2(
        "POST",
        "/cis/scan-result/check/list",
        Dict{String,Any}("scanArn" => scanArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_cis_scan_results_aggregated_by_checks(
    scanArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector2(
        "POST",
        "/cis/scan-result/check/list",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("scanArn" => scanArn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_cis_scan_results_aggregated_by_target_resource(scan_arn)
    list_cis_scan_results_aggregated_by_target_resource(scan_arn, params::Dict{String,<:Any})

Lists scan results aggregated by a target resource.

# Arguments
- `scan_arn`: The scan ARN.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filterCriteria"`: The filter criteria.
- `"maxResults"`: The maximum number of scan results aggregated by a target resource to be
  returned in a single page of results.
- `"nextToken"`: The pagination token from a previous request that's used to retrieve the
  next page of results.
- `"sortBy"`: The sort by order.
- `"sortOrder"`: The sort order.
"""
function list_cis_scan_results_aggregated_by_target_resource(
    scanArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector2(
        "POST",
        "/cis/scan-result/resource/list",
        Dict{String,Any}("scanArn" => scanArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_cis_scan_results_aggregated_by_target_resource(
    scanArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector2(
        "POST",
        "/cis/scan-result/resource/list",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("scanArn" => scanArn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_cis_scans()
    list_cis_scans(params::Dict{String,<:Any})

Returns a CIS scan list.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"detailLevel"`: The detail applied to the CIS scan.
- `"filterCriteria"`: The CIS scan filter criteria.
- `"maxResults"`: The maximum number of results to be returned.
- `"nextToken"`: The pagination token from a previous request that's used to retrieve the
  next page of results.
- `"sortBy"`: The CIS scans sort by order.
- `"sortOrder"`: The CIS scans sort order.
"""
function list_cis_scans(; aws_config::AbstractAWSConfig=current_aws_config())
    return inspector2(
        "POST", "/cis/scan/list"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_cis_scans(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector2(
        "POST",
        "/cis/scan/list",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_coverage()
    list_coverage(params::Dict{String,<:Any})

Lists coverage details for you environment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filterCriteria"`: An object that contains details on the filters to apply to the
  coverage data for your environment.
- `"maxResults"`: The maximum number of results the response can return. If your request
  would return more than the maximum the response will return a nextToken value, use this
  value when you call the action again to get the remaining results.
- `"nextToken"`: A token to use for paginating results that are returned in the response.
  Set the value of this parameter to null for the first request to a list action. If your
  response returns more than the maxResults maximum value it will also return a nextToken
  value. For subsequent calls, use the nextToken value returned from the previous request to
  continue listing results after the first page.
"""
function list_coverage(; aws_config::AbstractAWSConfig=current_aws_config())
    return inspector2(
        "POST", "/coverage/list"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_coverage(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector2(
        "POST",
        "/coverage/list",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_coverage_statistics()
    list_coverage_statistics(params::Dict{String,<:Any})

Lists Amazon Inspector coverage statistics for your environment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filterCriteria"`: An object that contains details on the filters to apply to the
  coverage data for your environment.
- `"groupBy"`: The value to group the results by.
- `"nextToken"`: A token to use for paginating results that are returned in the response.
  Set the value of this parameter to null for the first request to a list action. For
  subsequent calls, use the NextToken value returned from the previous request to continue
  listing results after the first page.
"""
function list_coverage_statistics(; aws_config::AbstractAWSConfig=current_aws_config())
    return inspector2(
        "POST",
        "/coverage/statistics/list";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_coverage_statistics(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector2(
        "POST",
        "/coverage/statistics/list",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_delegated_admin_accounts()
    list_delegated_admin_accounts(params::Dict{String,<:Any})

Lists information about the Amazon Inspector delegated administrator of your organization.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results the response can return. If your request
  would return more than the maximum the response will return a nextToken value, use this
  value when you call the action again to get the remaining results.
- `"nextToken"`: A token to use for paginating results that are returned in the response.
  Set the value of this parameter to null for the first request to a list action. If your
  response returns more than the maxResults maximum value it will also return a nextToken
  value. For subsequent calls, use the nextToken value returned from the previous request to
  continue listing results after the first page.
"""
function list_delegated_admin_accounts(; aws_config::AbstractAWSConfig=current_aws_config())
    return inspector2(
        "POST",
        "/delegatedadminaccounts/list";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_delegated_admin_accounts(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector2(
        "POST",
        "/delegatedadminaccounts/list",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_filters()
    list_filters(params::Dict{String,<:Any})

Lists the filters associated with your account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"action"`: The action the filter applies to matched findings.
- `"arns"`: The Amazon resource number (ARN) of the filter.
- `"maxResults"`: The maximum number of results the response can return. If your request
  would return more than the maximum the response will return a nextToken value, use this
  value when you call the action again to get the remaining results.
- `"nextToken"`: A token to use for paginating results that are returned in the response.
  Set the value of this parameter to null for the first request to a list action. If your
  response returns more than the maxResults maximum value it will also return a nextToken
  value. For subsequent calls, use the nextToken value returned from the previous request to
  continue listing results after the first page.
"""
function list_filters(; aws_config::AbstractAWSConfig=current_aws_config())
    return inspector2(
        "POST", "/filters/list"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_filters(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector2(
        "POST",
        "/filters/list",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_finding_aggregations(aggregation_type)
    list_finding_aggregations(aggregation_type, params::Dict{String,<:Any})

Lists aggregated finding data for your environment based on specific criteria.

# Arguments
- `aggregation_type`: The type of the aggregation request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountIds"`: The Amazon Web Services account IDs to retrieve finding aggregation data
  for.
- `"aggregationRequest"`: Details of the aggregation request that is used to filter your
  aggregation results.
- `"maxResults"`: The maximum number of results the response can return. If your request
  would return more than the maximum the response will return a nextToken value, use this
  value when you call the action again to get the remaining results.
- `"nextToken"`: A token to use for paginating results that are returned in the response.
  Set the value of this parameter to null for the first request to a list action. If your
  response returns more than the maxResults maximum value it will also return a nextToken
  value. For subsequent calls, use the nextToken value returned from the previous request to
  continue listing results after the first page.
"""
function list_finding_aggregations(
    aggregationType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector2(
        "POST",
        "/findings/aggregation/list",
        Dict{String,Any}("aggregationType" => aggregationType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_finding_aggregations(
    aggregationType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector2(
        "POST",
        "/findings/aggregation/list",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("aggregationType" => aggregationType), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_findings()
    list_findings(params::Dict{String,<:Any})

Lists findings for your environment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filterCriteria"`: Details on the filters to apply to your finding results.
- `"maxResults"`: The maximum number of results the response can return. If your request
  would return more than the maximum the response will return a nextToken value, use this
  value when you call the action again to get the remaining results.
- `"nextToken"`: A token to use for paginating results that are returned in the response.
  Set the value of this parameter to null for the first request to a list action. If your
  response returns more than the maxResults maximum value it will also return a nextToken
  value. For subsequent calls, use the nextToken value returned from the previous request to
  continue listing results after the first page.
- `"sortCriteria"`: Details on the sort criteria to apply to your finding results.
"""
function list_findings(; aws_config::AbstractAWSConfig=current_aws_config())
    return inspector2(
        "POST", "/findings/list"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_findings(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector2(
        "POST",
        "/findings/list",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_members()
    list_members(params::Dict{String,<:Any})

List members associated with the Amazon Inspector delegated administrator for your
organization.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results the response can return. If your request
  would return more than the maximum the response will return a nextToken value, use this
  value when you call the action again to get the remaining results.
- `"nextToken"`: A token to use for paginating results that are returned in the response.
  Set the value of this parameter to null for the first request to a list action. If your
  response returns more than the maxResults maximum value it will also return a nextToken
  value. For subsequent calls, use the nextToken value returned from the previous request to
  continue listing results after the first page.
- `"onlyAssociated"`: Specifies whether to list only currently associated members if True
  or to list all members within the organization if False.
"""
function list_members(; aws_config::AbstractAWSConfig=current_aws_config())
    return inspector2(
        "POST", "/members/list"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_members(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector2(
        "POST",
        "/members/list",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists all tags attached to a given resource.

# Arguments
- `resource_arn`: The Amazon resource number (ARN) of the resource to list tags of.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector2(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector2(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_usage_totals()
    list_usage_totals(params::Dict{String,<:Any})

Lists the Amazon Inspector usage totals over the last 30 days.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountIds"`: The Amazon Web Services account IDs to retrieve usage totals for.
- `"maxResults"`: The maximum number of results the response can return. If your request
  would return more than the maximum the response will return a nextToken value, use this
  value when you call the action again to get the remaining results.
- `"nextToken"`: A token to use for paginating results that are returned in the response.
  Set the value of this parameter to null for the first request to a list action. If your
  response returns more than the maxResults maximum value it will also return a nextToken
  value. For subsequent calls, use the nextToken value returned from the previous request to
  continue listing results after the first page.
"""
function list_usage_totals(; aws_config::AbstractAWSConfig=current_aws_config())
    return inspector2(
        "POST", "/usage/list"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_usage_totals(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector2(
        "POST",
        "/usage/list",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    reset_encryption_key(resource_type, scan_type)
    reset_encryption_key(resource_type, scan_type, params::Dict{String,<:Any})

Resets an encryption key. After the key is reset your resources will be encrypted by an
Amazon Web Services owned key.

# Arguments
- `resource_type`: The resource type the key encrypts.
- `scan_type`: The scan type the key encrypts.

"""
function reset_encryption_key(
    resourceType, scanType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector2(
        "PUT",
        "/encryptionkey/reset",
        Dict{String,Any}("resourceType" => resourceType, "scanType" => scanType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function reset_encryption_key(
    resourceType,
    scanType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector2(
        "PUT",
        "/encryptionkey/reset",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceType" => resourceType, "scanType" => scanType),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    search_vulnerabilities(filter_criteria)
    search_vulnerabilities(filter_criteria, params::Dict{String,<:Any})

Lists Amazon Inspector coverage details for a specific vulnerability.

# Arguments
- `filter_criteria`: The criteria used to filter the results of a vulnerability search.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: A token to use for paginating results that are returned in the response.
  Set the value of this parameter to null for the first request to a list action. For
  subsequent calls, use the NextToken value returned from the previous request to continue
  listing results after the first page.
"""
function search_vulnerabilities(
    filterCriteria; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector2(
        "POST",
        "/vulnerabilities/search",
        Dict{String,Any}("filterCriteria" => filterCriteria);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function search_vulnerabilities(
    filterCriteria,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector2(
        "POST",
        "/vulnerabilities/search",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("filterCriteria" => filterCriteria), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    send_cis_session_health(scan_job_id, session_token)
    send_cis_session_health(scan_job_id, session_token, params::Dict{String,<:Any})

 Sends a CIS session health. This API is used by the Amazon Inspector SSM plugin to
communicate with the Amazon Inspector service. The Amazon Inspector SSM plugin calls this
API to start a CIS scan session for the scan ID supplied by the service.

# Arguments
- `scan_job_id`: A unique identifier for the scan job.
- `session_token`: The unique token that identifies the CIS session.

"""
function send_cis_session_health(
    scanJobId, sessionToken; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector2(
        "PUT",
        "/cissession/health/send",
        Dict{String,Any}("scanJobId" => scanJobId, "sessionToken" => sessionToken);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function send_cis_session_health(
    scanJobId,
    sessionToken,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector2(
        "PUT",
        "/cissession/health/send",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("scanJobId" => scanJobId, "sessionToken" => sessionToken),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    send_cis_session_telemetry(messages, scan_job_id, session_token)
    send_cis_session_telemetry(messages, scan_job_id, session_token, params::Dict{String,<:Any})

 Sends a CIS session telemetry. This API is used by the Amazon Inspector SSM plugin to
communicate with the Amazon Inspector service. The Amazon Inspector SSM plugin calls this
API to start a CIS scan session for the scan ID supplied by the service.

# Arguments
- `messages`: The CIS session telemetry messages.
- `scan_job_id`: A unique identifier for the scan job.
- `session_token`: The unique token that identifies the CIS session.

"""
function send_cis_session_telemetry(
    messages, scanJobId, sessionToken; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector2(
        "PUT",
        "/cissession/telemetry/send",
        Dict{String,Any}(
            "messages" => messages, "scanJobId" => scanJobId, "sessionToken" => sessionToken
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function send_cis_session_telemetry(
    messages,
    scanJobId,
    sessionToken,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector2(
        "PUT",
        "/cissession/telemetry/send",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "messages" => messages,
                    "scanJobId" => scanJobId,
                    "sessionToken" => sessionToken,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_cis_session(message, scan_job_id)
    start_cis_session(message, scan_job_id, params::Dict{String,<:Any})

 Starts a CIS session. This API is used by the Amazon Inspector SSM plugin to communicate
with the Amazon Inspector service. The Amazon Inspector SSM plugin calls this API to start
a CIS scan session for the scan ID supplied by the service.

# Arguments
- `message`: The start CIS session message.
- `scan_job_id`: A unique identifier for the scan job.

"""
function start_cis_session(
    message, scanJobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector2(
        "PUT",
        "/cissession/start",
        Dict{String,Any}("message" => message, "scanJobId" => scanJobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_cis_session(
    message,
    scanJobId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector2(
        "PUT",
        "/cissession/start",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("message" => message, "scanJobId" => scanJobId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_cis_session(message, scan_job_id, session_token)
    stop_cis_session(message, scan_job_id, session_token, params::Dict{String,<:Any})

 Stops a CIS session. This API is used by the Amazon Inspector SSM plugin to communicate
with the Amazon Inspector service. The Amazon Inspector SSM plugin calls this API to start
a CIS scan session for the scan ID supplied by the service.

# Arguments
- `message`: The stop CIS session message.
- `scan_job_id`: A unique identifier for the scan job.
- `session_token`: The unique token that identifies the CIS session.

"""
function stop_cis_session(
    message, scanJobId, sessionToken; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector2(
        "PUT",
        "/cissession/stop",
        Dict{String,Any}(
            "message" => message, "scanJobId" => scanJobId, "sessionToken" => sessionToken
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_cis_session(
    message,
    scanJobId,
    sessionToken,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector2(
        "PUT",
        "/cissession/stop",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "message" => message,
                    "scanJobId" => scanJobId,
                    "sessionToken" => sessionToken,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds tags to a resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource to apply a tag to.
- `tags`: The tags to be added to a resource.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return inspector2(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector2(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes tags from a resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) for the resource to remove tags from.
- `tag_keys`: The tag keys to remove from the resource.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector2(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector2(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_cis_scan_configuration(scan_configuration_arn)
    update_cis_scan_configuration(scan_configuration_arn, params::Dict{String,<:Any})

Updates a CIS scan configuration.

# Arguments
- `scan_configuration_arn`: The CIS scan configuration ARN.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"scanName"`: The scan name for the CIS scan configuration.
- `"schedule"`: The schedule for the CIS scan configuration.
- `"securityLevel"`:  The security level for the CIS scan configuration. Security level
  refers to the Benchmark levels that CIS assigns to a profile.
- `"targets"`: The targets for the CIS scan configuration.
"""
function update_cis_scan_configuration(
    scanConfigurationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector2(
        "POST",
        "/cis/scan-configuration/update",
        Dict{String,Any}("scanConfigurationArn" => scanConfigurationArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_cis_scan_configuration(
    scanConfigurationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector2(
        "POST",
        "/cis/scan-configuration/update",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("scanConfigurationArn" => scanConfigurationArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_configuration()
    update_configuration(params::Dict{String,<:Any})

Updates setting configurations for your Amazon Inspector account. When you use this API as
an Amazon Inspector delegated administrator this updates the setting for all accounts you
manage. Member accounts in an organization cannot update this setting.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ec2Configuration"`: Specifies how the Amazon EC2 automated scan will be updated for
  your environment.
- `"ecrConfiguration"`: Specifies how the ECR automated re-scan will be updated for your
  environment.
"""
function update_configuration(; aws_config::AbstractAWSConfig=current_aws_config())
    return inspector2(
        "POST",
        "/configuration/update";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector2(
        "POST",
        "/configuration/update",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_ec2_deep_inspection_configuration()
    update_ec2_deep_inspection_configuration(params::Dict{String,<:Any})

Activates, deactivates Amazon Inspector deep inspection, or updates custom paths for your
account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"activateDeepInspection"`: Specify TRUE to activate Amazon Inspector deep inspection in
  your account, or FALSE to deactivate. Member accounts in an organization cannot deactivate
  deep inspection, instead the delegated administrator for the organization can deactivate a
  member account using BatchUpdateMemberEc2DeepInspectionStatus.
- `"packagePaths"`: The Amazon Inspector deep inspection custom paths you are adding for
  your account.
"""
function update_ec2_deep_inspection_configuration(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector2(
        "POST",
        "/ec2deepinspectionconfiguration/update";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_ec2_deep_inspection_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector2(
        "POST",
        "/ec2deepinspectionconfiguration/update",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_encryption_key(kms_key_id, resource_type, scan_type)
    update_encryption_key(kms_key_id, resource_type, scan_type, params::Dict{String,<:Any})

Updates an encryption key. A ResourceNotFoundException means that an Amazon Web Services
owned key is being used for encryption.

# Arguments
- `kms_key_id`: A KMS key ID for the encryption key.
- `resource_type`: The resource type for the encryption key.
- `scan_type`: The scan type for the encryption key.

"""
function update_encryption_key(
    kmsKeyId, resourceType, scanType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector2(
        "PUT",
        "/encryptionkey/update",
        Dict{String,Any}(
            "kmsKeyId" => kmsKeyId, "resourceType" => resourceType, "scanType" => scanType
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_encryption_key(
    kmsKeyId,
    resourceType,
    scanType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector2(
        "PUT",
        "/encryptionkey/update",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "kmsKeyId" => kmsKeyId,
                    "resourceType" => resourceType,
                    "scanType" => scanType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_filter(filter_arn)
    update_filter(filter_arn, params::Dict{String,<:Any})

Specifies the action that is to be applied to the findings that match the filter.

# Arguments
- `filter_arn`: The Amazon Resource Number (ARN) of the filter to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"action"`: Specifies the action that is to be applied to the findings that match the
  filter.
- `"description"`: A description of the filter.
- `"filterCriteria"`: Defines the criteria to be update in the filter.
- `"name"`: The name of the filter.
- `"reason"`: The reason the filter was updated.
"""
function update_filter(filterArn; aws_config::AbstractAWSConfig=current_aws_config())
    return inspector2(
        "POST",
        "/filters/update",
        Dict{String,Any}("filterArn" => filterArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_filter(
    filterArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector2(
        "POST",
        "/filters/update",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("filterArn" => filterArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_org_ec2_deep_inspection_configuration(org_package_paths)
    update_org_ec2_deep_inspection_configuration(org_package_paths, params::Dict{String,<:Any})

Updates the Amazon Inspector deep inspection custom paths for your organization. You must
be an Amazon Inspector delegated administrator to use this API.

# Arguments
- `org_package_paths`: The Amazon Inspector deep inspection custom paths you are adding for
  your organization.

"""
function update_org_ec2_deep_inspection_configuration(
    orgPackagePaths; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector2(
        "POST",
        "/ec2deepinspectionconfiguration/org/update",
        Dict{String,Any}("orgPackagePaths" => orgPackagePaths);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_org_ec2_deep_inspection_configuration(
    orgPackagePaths,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector2(
        "POST",
        "/ec2deepinspectionconfiguration/org/update",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("orgPackagePaths" => orgPackagePaths), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_organization_configuration(auto_enable)
    update_organization_configuration(auto_enable, params::Dict{String,<:Any})

Updates the configurations for your Amazon Inspector organization.

# Arguments
- `auto_enable`: Defines which scan types are enabled automatically for new members of your
  Amazon Inspector organization.

"""
function update_organization_configuration(
    autoEnable; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector2(
        "POST",
        "/organizationconfiguration/update",
        Dict{String,Any}("autoEnable" => autoEnable);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_organization_configuration(
    autoEnable,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return inspector2(
        "POST",
        "/organizationconfiguration/update",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("autoEnable" => autoEnable), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: cognito_identity
using AWS.Compat
using AWS.UUIDs

"""
    create_identity_pool(allow_unauthenticated_identities, identity_pool_name)
    create_identity_pool(allow_unauthenticated_identities, identity_pool_name, params::Dict{String,<:Any})

Creates a new identity pool. The identity pool is a store of user identity information that
is specific to your AWS account. The keys for SupportedLoginProviders are as follows:
Facebook: graph.facebook.com    Google: accounts.google.com    Amazon: www.amazon.com
Twitter: api.twitter.com    Digits: www.digits.com    You must use AWS Developer
credentials to call this API.

# Arguments
- `allow_unauthenticated_identities`: TRUE if the identity pool supports unauthenticated
  logins.
- `identity_pool_name`: A string that you provide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AllowClassicFlow"`: Enables or disables the Basic (Classic) authentication flow. For
  more information, see Identity Pools (Federated Identities) Authentication Flow in the
  Amazon Cognito Developer Guide.
- `"CognitoIdentityProviders"`: An array of Amazon Cognito user pools and their client IDs.
- `"DeveloperProviderName"`: The \"domain\" by which Cognito will refer to your users. This
  name acts as a placeholder that allows your backend and the Cognito service to communicate
  about the developer provider. For the DeveloperProviderName, you can use letters as well as
  period (.), underscore (_), and dash (-). Once you have set a developer provider name, you
  cannot change it. Please take care in setting this parameter.
- `"IdentityPoolTags"`: Tags to assign to the identity pool. A tag is a label that you can
  apply to identity pools to categorize and manage them in different ways, such as by
  purpose, owner, environment, or other criteria.
- `"OpenIdConnectProviderARNs"`: The Amazon Resource Names (ARN) of the OpenID Connect
  providers.
- `"SamlProviderARNs"`: An array of Amazon Resource Names (ARNs) of the SAML provider for
  your identity pool.
- `"SupportedLoginProviders"`: Optional key:value pairs mapping provider names to provider
  app IDs.
"""
function create_identity_pool(
    AllowUnauthenticatedIdentities,
    IdentityPoolName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cognito_identity(
        "CreateIdentityPool",
        Dict{String,Any}(
            "AllowUnauthenticatedIdentities" => AllowUnauthenticatedIdentities,
            "IdentityPoolName" => IdentityPoolName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_identity_pool(
    AllowUnauthenticatedIdentities,
    IdentityPoolName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cognito_identity(
        "CreateIdentityPool",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AllowUnauthenticatedIdentities" => AllowUnauthenticatedIdentities,
                    "IdentityPoolName" => IdentityPoolName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_identities(identity_ids_to_delete)
    delete_identities(identity_ids_to_delete, params::Dict{String,<:Any})

Deletes identities from an identity pool. You can specify a list of 1-60 identities that
you want to delete. You must use AWS Developer credentials to call this API.

# Arguments
- `identity_ids_to_delete`: A list of 1-60 identities that you want to delete.

"""
function delete_identities(
    IdentityIdsToDelete; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cognito_identity(
        "DeleteIdentities",
        Dict{String,Any}("IdentityIdsToDelete" => IdentityIdsToDelete);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_identities(
    IdentityIdsToDelete,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cognito_identity(
        "DeleteIdentities",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("IdentityIdsToDelete" => IdentityIdsToDelete),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_identity_pool(identity_pool_id)
    delete_identity_pool(identity_pool_id, params::Dict{String,<:Any})

Deletes an identity pool. Once a pool is deleted, users will not be able to authenticate
with the pool. You must use AWS Developer credentials to call this API.

# Arguments
- `identity_pool_id`: An identity pool ID in the format REGION:GUID.

"""
function delete_identity_pool(
    IdentityPoolId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cognito_identity(
        "DeleteIdentityPool",
        Dict{String,Any}("IdentityPoolId" => IdentityPoolId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_identity_pool(
    IdentityPoolId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cognito_identity(
        "DeleteIdentityPool",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("IdentityPoolId" => IdentityPoolId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_identity(identity_id)
    describe_identity(identity_id, params::Dict{String,<:Any})

Returns metadata related to the given identity, including when the identity was created and
any associated linked logins. You must use AWS Developer credentials to call this API.

# Arguments
- `identity_id`: A unique identifier in the format REGION:GUID.

"""
function describe_identity(IdentityId; aws_config::AbstractAWSConfig=current_aws_config())
    return cognito_identity(
        "DescribeIdentity",
        Dict{String,Any}("IdentityId" => IdentityId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_identity(
    IdentityId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cognito_identity(
        "DescribeIdentity",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("IdentityId" => IdentityId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_identity_pool(identity_pool_id)
    describe_identity_pool(identity_pool_id, params::Dict{String,<:Any})

Gets details about a particular identity pool, including the pool name, ID description,
creation date, and current number of users. You must use AWS Developer credentials to call
this API.

# Arguments
- `identity_pool_id`: An identity pool ID in the format REGION:GUID.

"""
function describe_identity_pool(
    IdentityPoolId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cognito_identity(
        "DescribeIdentityPool",
        Dict{String,Any}("IdentityPoolId" => IdentityPoolId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_identity_pool(
    IdentityPoolId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cognito_identity(
        "DescribeIdentityPool",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("IdentityPoolId" => IdentityPoolId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_credentials_for_identity(identity_id)
    get_credentials_for_identity(identity_id, params::Dict{String,<:Any})

Returns credentials for the provided identity ID. Any provided logins will be validated
against supported login providers. If the token is for cognito-identity.amazonaws.com, it
will be passed through to AWS Security Token Service with the appropriate role for the
token. This is a public API. You do not need any credentials to call this API.

# Arguments
- `identity_id`: A unique identifier in the format REGION:GUID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CustomRoleArn"`: The Amazon Resource Name (ARN) of the role to be assumed when multiple
  roles were received in the token from the identity provider. For example, a SAML-based
  identity provider. This parameter is optional for identity providers that do not support
  role customization.
- `"Logins"`: A set of optional name-value pairs that map provider names to provider
  tokens. The name-value pair will follow the syntax \"provider_name\":
  \"provider_user_identifier\". Logins should not be specified when trying to get credentials
  for an unauthenticated identity. The Logins parameter is required when using identities
  associated with external identity providers such as Facebook. For examples of Logins maps,
  see the code examples in the External Identity Providers section of the Amazon Cognito
  Developer Guide.
"""
function get_credentials_for_identity(
    IdentityId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cognito_identity(
        "GetCredentialsForIdentity",
        Dict{String,Any}("IdentityId" => IdentityId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_credentials_for_identity(
    IdentityId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cognito_identity(
        "GetCredentialsForIdentity",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("IdentityId" => IdentityId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_id(identity_pool_id)
    get_id(identity_pool_id, params::Dict{String,<:Any})

Generates (or retrieves) a Cognito ID. Supplying multiple logins will create an implicit
linked account. This is a public API. You do not need any credentials to call this API.

# Arguments
- `identity_pool_id`: An identity pool ID in the format REGION:GUID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccountId"`: A standard AWS account ID (9+ digits).
- `"Logins"`: A set of optional name-value pairs that map provider names to provider
  tokens. The available provider names for Logins are as follows:   Facebook:
  graph.facebook.com    Amazon Cognito user pool:
  cognito-idp.&lt;region&gt;.amazonaws.com/&lt;YOUR_USER_POOL_ID&gt;, for example,
  cognito-idp.us-east-1.amazonaws.com/us-east-1_123456789.    Google: accounts.google.com
  Amazon: www.amazon.com    Twitter: api.twitter.com    Digits: www.digits.com
"""
function get_id(IdentityPoolId; aws_config::AbstractAWSConfig=current_aws_config())
    return cognito_identity(
        "GetId",
        Dict{String,Any}("IdentityPoolId" => IdentityPoolId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_id(
    IdentityPoolId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cognito_identity(
        "GetId",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("IdentityPoolId" => IdentityPoolId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_identity_pool_roles(identity_pool_id)
    get_identity_pool_roles(identity_pool_id, params::Dict{String,<:Any})

Gets the roles for an identity pool. You must use AWS Developer credentials to call this
API.

# Arguments
- `identity_pool_id`: An identity pool ID in the format REGION:GUID.

"""
function get_identity_pool_roles(
    IdentityPoolId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cognito_identity(
        "GetIdentityPoolRoles",
        Dict{String,Any}("IdentityPoolId" => IdentityPoolId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_identity_pool_roles(
    IdentityPoolId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cognito_identity(
        "GetIdentityPoolRoles",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("IdentityPoolId" => IdentityPoolId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_open_id_token(identity_id)
    get_open_id_token(identity_id, params::Dict{String,<:Any})

Gets an OpenID token, using a known Cognito ID. This known Cognito ID is returned by GetId.
You can optionally add additional logins for the identity. Supplying multiple logins
creates an implicit link. The OpenID token is valid for 10 minutes. This is a public API.
You do not need any credentials to call this API.

# Arguments
- `identity_id`: A unique identifier in the format REGION:GUID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Logins"`: A set of optional name-value pairs that map provider names to provider
  tokens. When using graph.facebook.com and www.amazon.com, supply the access_token returned
  from the provider's authflow. For accounts.google.com, an Amazon Cognito user pool
  provider, or any other OpenID Connect provider, always include the id_token.
"""
function get_open_id_token(IdentityId; aws_config::AbstractAWSConfig=current_aws_config())
    return cognito_identity(
        "GetOpenIdToken",
        Dict{String,Any}("IdentityId" => IdentityId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_open_id_token(
    IdentityId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cognito_identity(
        "GetOpenIdToken",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("IdentityId" => IdentityId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_open_id_token_for_developer_identity(identity_pool_id, logins)
    get_open_id_token_for_developer_identity(identity_pool_id, logins, params::Dict{String,<:Any})

Registers (or retrieves) a Cognito IdentityId and an OpenID Connect token for a user
authenticated by your backend authentication process. Supplying multiple logins will create
an implicit linked account. You can only specify one developer provider as part of the
Logins map, which is linked to the identity pool. The developer provider is the \"domain\"
by which Cognito will refer to your users. You can use GetOpenIdTokenForDeveloperIdentity
to create a new identity and to link new logins (that is, user credentials issued by a
public provider or developer provider) to an existing identity. When you want to create a
new identity, the IdentityId should be null. When you want to associate a new login with an
existing authenticated/unauthenticated identity, you can do so by providing the existing
IdentityId. This API will create the identity in the specified IdentityPoolId. You must use
AWS Developer credentials to call this API.

# Arguments
- `identity_pool_id`: An identity pool ID in the format REGION:GUID.
- `logins`: A set of optional name-value pairs that map provider names to provider tokens.
  Each name-value pair represents a user from a public provider or developer provider. If the
  user is from a developer provider, the name-value pair will follow the syntax
  \"developer_provider_name\": \"developer_user_identifier\". The developer provider is the
  \"domain\" by which Cognito will refer to your users; you provided this domain while
  creating/updating the identity pool. The developer user identifier is an identifier from
  your backend that uniquely identifies a user. When you create an identity pool, you can
  specify the supported logins.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"IdentityId"`: A unique identifier in the format REGION:GUID.
- `"PrincipalTags"`: Use this operation to configure attribute mappings for custom
  providers.
- `"TokenDuration"`: The expiration time of the token, in seconds. You can specify a custom
  expiration time for the token so that you can cache it. If you don't provide an expiration
  time, the token is valid for 15 minutes. You can exchange the token with Amazon STS for
  temporary AWS credentials, which are valid for a maximum of one hour. The maximum token
  duration you can set is 24 hours. You should take care in setting the expiration time for a
  token, as there are significant security implications: an attacker could use a leaked token
  to access your AWS resources for the token's duration.  Please provide for a small grace
  period, usually no more than 5 minutes, to account for clock skew.
"""
function get_open_id_token_for_developer_identity(
    IdentityPoolId, Logins; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cognito_identity(
        "GetOpenIdTokenForDeveloperIdentity",
        Dict{String,Any}("IdentityPoolId" => IdentityPoolId, "Logins" => Logins);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_open_id_token_for_developer_identity(
    IdentityPoolId,
    Logins,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cognito_identity(
        "GetOpenIdTokenForDeveloperIdentity",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("IdentityPoolId" => IdentityPoolId, "Logins" => Logins),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_principal_tag_attribute_map(identity_pool_id, identity_provider_name)
    get_principal_tag_attribute_map(identity_pool_id, identity_provider_name, params::Dict{String,<:Any})

Use GetPrincipalTagAttributeMap to list all mappings between PrincipalTags and user
attributes.

# Arguments
- `identity_pool_id`: You can use this operation to get the ID of the Identity Pool you
  setup attribute mappings for.
- `identity_provider_name`: You can use this operation to get the provider name.

"""
function get_principal_tag_attribute_map(
    IdentityPoolId, IdentityProviderName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cognito_identity(
        "GetPrincipalTagAttributeMap",
        Dict{String,Any}(
            "IdentityPoolId" => IdentityPoolId,
            "IdentityProviderName" => IdentityProviderName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_principal_tag_attribute_map(
    IdentityPoolId,
    IdentityProviderName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cognito_identity(
        "GetPrincipalTagAttributeMap",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "IdentityPoolId" => IdentityPoolId,
                    "IdentityProviderName" => IdentityProviderName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_identities(identity_pool_id, max_results)
    list_identities(identity_pool_id, max_results, params::Dict{String,<:Any})

Lists the identities in an identity pool. You must use AWS Developer credentials to call
this API.

# Arguments
- `identity_pool_id`: An identity pool ID in the format REGION:GUID.
- `max_results`: The maximum number of identities to return.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"HideDisabled"`: An optional boolean parameter that allows you to hide disabled
  identities. If omitted, the ListIdentities API will include disabled identities in the
  response.
- `"NextToken"`: A pagination token.
"""
function list_identities(
    IdentityPoolId, MaxResults; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cognito_identity(
        "ListIdentities",
        Dict{String,Any}("IdentityPoolId" => IdentityPoolId, "MaxResults" => MaxResults);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_identities(
    IdentityPoolId,
    MaxResults,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cognito_identity(
        "ListIdentities",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "IdentityPoolId" => IdentityPoolId, "MaxResults" => MaxResults
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_identity_pools(max_results)
    list_identity_pools(max_results, params::Dict{String,<:Any})

Lists all of the Cognito identity pools registered for your account. You must use AWS
Developer credentials to call this API.

# Arguments
- `max_results`: The maximum number of identities to return.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: A pagination token.
"""
function list_identity_pools(MaxResults; aws_config::AbstractAWSConfig=current_aws_config())
    return cognito_identity(
        "ListIdentityPools",
        Dict{String,Any}("MaxResults" => MaxResults);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_identity_pools(
    MaxResults,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cognito_identity(
        "ListIdentityPools",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("MaxResults" => MaxResults), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists the tags that are assigned to an Amazon Cognito identity pool. A tag is a label that
you can apply to identity pools to categorize and manage them in different ways, such as by
purpose, owner, environment, or other criteria. You can use this action up to 10 times per
second, per account.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the identity pool that the tags are
  assigned to.

"""
function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cognito_identity(
        "ListTagsForResource",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cognito_identity(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    lookup_developer_identity(identity_pool_id)
    lookup_developer_identity(identity_pool_id, params::Dict{String,<:Any})

Retrieves the IdentityID associated with a DeveloperUserIdentifier or the list of
DeveloperUserIdentifier values associated with an IdentityId for an existing identity.
Either IdentityID or DeveloperUserIdentifier must not be null. If you supply only one of
these values, the other value will be searched in the database and returned as a part of
the response. If you supply both, DeveloperUserIdentifier will be matched against
IdentityID. If the values are verified against the database, the response returns both
values and is the same as the request. Otherwise a ResourceConflictException is thrown.
LookupDeveloperIdentity is intended for low-throughput control plane operations: for
example, to enable customer service to locate an identity ID by username. If you are using
it for higher-volume operations such as user authentication, your requests are likely to be
throttled. GetOpenIdTokenForDeveloperIdentity is a better option for higher-volume
operations for user authentication. You must use AWS Developer credentials to call this API.

# Arguments
- `identity_pool_id`: An identity pool ID in the format REGION:GUID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DeveloperUserIdentifier"`: A unique ID used by your backend authentication process to
  identify a user. Typically, a developer identity provider would issue many developer user
  identifiers, in keeping with the number of users.
- `"IdentityId"`: A unique identifier in the format REGION:GUID.
- `"MaxResults"`: The maximum number of identities to return.
- `"NextToken"`: A pagination token. The first call you make will have NextToken set to
  null. After that the service will return NextToken values as needed. For example, let's say
  you make a request with MaxResults set to 10, and there are 20 matches in the database. The
  service will return a pagination token as a part of the response. This token can be used to
  call the API again and get results starting from the 11th match.
"""
function lookup_developer_identity(
    IdentityPoolId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cognito_identity(
        "LookupDeveloperIdentity",
        Dict{String,Any}("IdentityPoolId" => IdentityPoolId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function lookup_developer_identity(
    IdentityPoolId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cognito_identity(
        "LookupDeveloperIdentity",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("IdentityPoolId" => IdentityPoolId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    merge_developer_identities(destination_user_identifier, developer_provider_name, identity_pool_id, source_user_identifier)
    merge_developer_identities(destination_user_identifier, developer_provider_name, identity_pool_id, source_user_identifier, params::Dict{String,<:Any})

Merges two users having different IdentityIds, existing in the same identity pool, and
identified by the same developer provider. You can use this action to request that discrete
users be merged and identified as a single user in the Cognito environment. Cognito
associates the given source user (SourceUserIdentifier) with the IdentityId of the
DestinationUserIdentifier. Only developer-authenticated users can be merged. If the users
to be merged are associated with the same public provider, but as two different users, an
exception will be thrown. The number of linked logins is limited to 20. So, the number of
linked logins for the source user, SourceUserIdentifier, and the destination user,
DestinationUserIdentifier, together should not be larger than 20. Otherwise, an exception
will be thrown. You must use AWS Developer credentials to call this API.

# Arguments
- `destination_user_identifier`: User identifier for the destination user. The value should
  be a DeveloperUserIdentifier.
- `developer_provider_name`: The \"domain\" by which Cognito will refer to your users. This
  is a (pseudo) domain name that you provide while creating an identity pool. This name acts
  as a placeholder that allows your backend and the Cognito service to communicate about the
  developer provider. For the DeveloperProviderName, you can use letters as well as period
  (.), underscore (_), and dash (-).
- `identity_pool_id`: An identity pool ID in the format REGION:GUID.
- `source_user_identifier`: User identifier for the source user. The value should be a
  DeveloperUserIdentifier.

"""
function merge_developer_identities(
    DestinationUserIdentifier,
    DeveloperProviderName,
    IdentityPoolId,
    SourceUserIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cognito_identity(
        "MergeDeveloperIdentities",
        Dict{String,Any}(
            "DestinationUserIdentifier" => DestinationUserIdentifier,
            "DeveloperProviderName" => DeveloperProviderName,
            "IdentityPoolId" => IdentityPoolId,
            "SourceUserIdentifier" => SourceUserIdentifier,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function merge_developer_identities(
    DestinationUserIdentifier,
    DeveloperProviderName,
    IdentityPoolId,
    SourceUserIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cognito_identity(
        "MergeDeveloperIdentities",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DestinationUserIdentifier" => DestinationUserIdentifier,
                    "DeveloperProviderName" => DeveloperProviderName,
                    "IdentityPoolId" => IdentityPoolId,
                    "SourceUserIdentifier" => SourceUserIdentifier,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    set_identity_pool_roles(identity_pool_id, roles)
    set_identity_pool_roles(identity_pool_id, roles, params::Dict{String,<:Any})

Sets the roles for an identity pool. These roles are used when making calls to
GetCredentialsForIdentity action. You must use AWS Developer credentials to call this API.

# Arguments
- `identity_pool_id`: An identity pool ID in the format REGION:GUID.
- `roles`: The map of roles associated with this pool. For a given role, the key will be
  either \"authenticated\" or \"unauthenticated\" and the value will be the Role ARN.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"RoleMappings"`: How users for a specific identity provider are to mapped to roles. This
  is a string to RoleMapping object map. The string identifies the identity provider, for
  example, \"graph.facebook.com\" or
  \"cognito-idp.us-east-1.amazonaws.com/us-east-1_abcdefghi:app_client_id\". Up to 25 rules
  can be specified per identity provider.
"""
function set_identity_pool_roles(
    IdentityPoolId, Roles; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cognito_identity(
        "SetIdentityPoolRoles",
        Dict{String,Any}("IdentityPoolId" => IdentityPoolId, "Roles" => Roles);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function set_identity_pool_roles(
    IdentityPoolId,
    Roles,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cognito_identity(
        "SetIdentityPoolRoles",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("IdentityPoolId" => IdentityPoolId, "Roles" => Roles),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    set_principal_tag_attribute_map(identity_pool_id, identity_provider_name)
    set_principal_tag_attribute_map(identity_pool_id, identity_provider_name, params::Dict{String,<:Any})

You can use this operation to use default (username and clientID) attribute or custom
attribute mappings.

# Arguments
- `identity_pool_id`: The ID of the Identity Pool you want to set attribute mappings for.
- `identity_provider_name`: The provider name you want to use for attribute mappings.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"PrincipalTags"`: You can use this operation to add principal tags.
- `"UseDefaults"`: You can use this operation to use default (username and clientID)
  attribute mappings.
"""
function set_principal_tag_attribute_map(
    IdentityPoolId, IdentityProviderName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cognito_identity(
        "SetPrincipalTagAttributeMap",
        Dict{String,Any}(
            "IdentityPoolId" => IdentityPoolId,
            "IdentityProviderName" => IdentityProviderName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function set_principal_tag_attribute_map(
    IdentityPoolId,
    IdentityProviderName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cognito_identity(
        "SetPrincipalTagAttributeMap",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "IdentityPoolId" => IdentityPoolId,
                    "IdentityProviderName" => IdentityProviderName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Assigns a set of tags to the specified Amazon Cognito identity pool. A tag is a label that
you can use to categorize and manage identity pools in different ways, such as by purpose,
owner, environment, or other criteria. Each tag consists of a key and value, both of which
you define. A key is a general category for more specific values. For example, if you have
two versions of an identity pool, one for testing and another for production, you might
assign an Environment tag key to both identity pools. The value of this key might be Test
for one identity pool and Production for the other. Tags are useful for cost tracking and
access control. You can activate your tags so that they appear on the Billing and Cost
Management console, where you can track the costs associated with your identity pools. In
an IAM policy, you can constrain permissions for identity pools based on specific tags or
tag values. You can use this action up to 5 times per second, per account. An identity pool
can have as many as 50 tags.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the identity pool.
- `tags`: The tags to assign to the identity pool.

"""
function tag_resource(ResourceArn, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return cognito_identity(
        "TagResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceArn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cognito_identity(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    unlink_developer_identity(developer_provider_name, developer_user_identifier, identity_id, identity_pool_id)
    unlink_developer_identity(developer_provider_name, developer_user_identifier, identity_id, identity_pool_id, params::Dict{String,<:Any})

Unlinks a DeveloperUserIdentifier from an existing identity. Unlinked developer users will
be considered new identities next time they are seen. If, for a given Cognito identity, you
remove all federated identities as well as the developer user identifier, the Cognito
identity becomes inaccessible. You must use AWS Developer credentials to call this API.

# Arguments
- `developer_provider_name`: The \"domain\" by which Cognito will refer to your users.
- `developer_user_identifier`: A unique ID used by your backend authentication process to
  identify a user.
- `identity_id`: A unique identifier in the format REGION:GUID.
- `identity_pool_id`: An identity pool ID in the format REGION:GUID.

"""
function unlink_developer_identity(
    DeveloperProviderName,
    DeveloperUserIdentifier,
    IdentityId,
    IdentityPoolId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cognito_identity(
        "UnlinkDeveloperIdentity",
        Dict{String,Any}(
            "DeveloperProviderName" => DeveloperProviderName,
            "DeveloperUserIdentifier" => DeveloperUserIdentifier,
            "IdentityId" => IdentityId,
            "IdentityPoolId" => IdentityPoolId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function unlink_developer_identity(
    DeveloperProviderName,
    DeveloperUserIdentifier,
    IdentityId,
    IdentityPoolId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cognito_identity(
        "UnlinkDeveloperIdentity",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DeveloperProviderName" => DeveloperProviderName,
                    "DeveloperUserIdentifier" => DeveloperUserIdentifier,
                    "IdentityId" => IdentityId,
                    "IdentityPoolId" => IdentityPoolId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    unlink_identity(identity_id, logins, logins_to_remove)
    unlink_identity(identity_id, logins, logins_to_remove, params::Dict{String,<:Any})

Unlinks a federated identity from an existing account. Unlinked logins will be considered
new identities next time they are seen. Removing the last linked login will make this
identity inaccessible. This is a public API. You do not need any credentials to call this
API.

# Arguments
- `identity_id`: A unique identifier in the format REGION:GUID.
- `logins`: A set of optional name-value pairs that map provider names to provider tokens.
- `logins_to_remove`: Provider names to unlink from this identity.

"""
function unlink_identity(
    IdentityId, Logins, LoginsToRemove; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cognito_identity(
        "UnlinkIdentity",
        Dict{String,Any}(
            "IdentityId" => IdentityId,
            "Logins" => Logins,
            "LoginsToRemove" => LoginsToRemove,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function unlink_identity(
    IdentityId,
    Logins,
    LoginsToRemove,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cognito_identity(
        "UnlinkIdentity",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "IdentityId" => IdentityId,
                    "Logins" => Logins,
                    "LoginsToRemove" => LoginsToRemove,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes the specified tags from the specified Amazon Cognito identity pool. You can use
this action up to 5 times per second, per account

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the identity pool.
- `tag_keys`: The keys of the tags to remove from the user pool.

"""
function untag_resource(
    ResourceArn, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cognito_identity(
        "UntagResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceArn,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cognito_identity(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_identity_pool(allow_unauthenticated_identities, identity_pool_id, identity_pool_name)
    update_identity_pool(allow_unauthenticated_identities, identity_pool_id, identity_pool_name, params::Dict{String,<:Any})

Updates an identity pool. You must use AWS Developer credentials to call this API.

# Arguments
- `allow_unauthenticated_identities`: TRUE if the identity pool supports unauthenticated
  logins.
- `identity_pool_id`: An identity pool ID in the format REGION:GUID.
- `identity_pool_name`: A string that you provide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AllowClassicFlow"`: Enables or disables the Basic (Classic) authentication flow. For
  more information, see Identity Pools (Federated Identities) Authentication Flow in the
  Amazon Cognito Developer Guide.
- `"CognitoIdentityProviders"`: A list representing an Amazon Cognito user pool and its
  client ID.
- `"DeveloperProviderName"`: The \"domain\" by which Cognito will refer to your users.
- `"IdentityPoolTags"`: The tags that are assigned to the identity pool. A tag is a label
  that you can apply to identity pools to categorize and manage them in different ways, such
  as by purpose, owner, environment, or other criteria.
- `"OpenIdConnectProviderARNs"`: The ARNs of the OpenID Connect providers.
- `"SamlProviderARNs"`: An array of Amazon Resource Names (ARNs) of the SAML provider for
  your identity pool.
- `"SupportedLoginProviders"`: Optional key:value pairs mapping provider names to provider
  app IDs.
"""
function update_identity_pool(
    AllowUnauthenticatedIdentities,
    IdentityPoolId,
    IdentityPoolName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cognito_identity(
        "UpdateIdentityPool",
        Dict{String,Any}(
            "AllowUnauthenticatedIdentities" => AllowUnauthenticatedIdentities,
            "IdentityPoolId" => IdentityPoolId,
            "IdentityPoolName" => IdentityPoolName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_identity_pool(
    AllowUnauthenticatedIdentities,
    IdentityPoolId,
    IdentityPoolName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cognito_identity(
        "UpdateIdentityPool",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AllowUnauthenticatedIdentities" => AllowUnauthenticatedIdentities,
                    "IdentityPoolId" => IdentityPoolId,
                    "IdentityPoolName" => IdentityPoolName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

@testset "AWSConfig" begin
    @testset "default profile assumes role" begin
        access_key_id = "assumed_access_key_id"
        config_dir = joinpath(@__DIR__, "..", "config", "default-role")

        # Avoid calling out to STS with invalid credentials
        patch = Patches._assume_role_patch("AssumeRole"; access_key=access_key_id)

        config = withenv(
            "AWS_CONFIG_FILE" => joinpath(config_dir, "config"),
            "AWS_SHARED_CREDENTIALS_FILE" => joinpath(config_dir, "credentials"),
        ) do
            apply(patch) do
                AWSConfig(; profile="default")
            end
        end

        @test config.credentials.access_key_id == access_key_id
    end

    @testset "default profile section names" begin
        allowed_default_sections = ["default", "profile default"]
        mktemp() do config_path, _
            for default_section_str in allowed_default_sections
                config = """
                [$default_section_str]
                region = xx-yy-1
                """
                write(config_path, config)
                region = aws_get_region(; profile="default", config=config_path)
                @test region == "xx-yy-1"
            end
        end
    end
end

@testset "with_aws_config / current_aws_config" begin
    no_fallback_patch = @patch AWS.default_aws_config() = Some(nothing)
    config1 = AWSConfig(; creds=nothing, region="us-example-1")
    config2 = AWSConfig(; creds=nothing, region="us-example-2")

    apply(no_fallback_patch) do
        @test current_aws_config() === nothing

        with_aws_config(config1) do
            @test current_aws_config() === config1

            with_aws_config(config2) do
                @test current_aws_config() === config2
            end

            @test current_aws_config() === config1
        end

        @test current_aws_config() === nothing
    end
end

@testset "default_aws_config" begin
    @testset "initial config" begin
        initial_config = AWSConfig(; creds=nothing, region="us-initial-1")
        call_count = Threads.Atomic{Int}(0)
        initial_config_patch = @patch function AWS.AWSConfig()
            call_count[] += 1
            return initial_config
        end

        # Test will only work if this variable is unassigned. This requires that no calls to
        # `default_aws_config()` have occurred yet.
        @test !isassigned(AWS._DEFAULT_AWS_CONFIG)

        apply(initial_config_patch) do
            config = default_aws_config()
            @test config === initial_config
            @test call_count[] == 1
            @test isassigned(AWS._DEFAULT_AWS_CONFIG)

            config = default_aws_config()
            @test config === initial_config
            @test call_count[] == 1
        end
    end

    @testset "set default" begin
        default_config = AWSConfig(; creds=nothing, region="us-default-1")

        # Ensure the current default differs
        config = default_aws_config()
        @test config !== default_config

        @test default_aws_config(default_config) === nothing
        @test default_aws_config() === default_config
    end

    @testset "scoped interaction" begin
        config1 = AWSConfig(; creds=nothing, region="us-default-scoped-1")
        config2 = AWSConfig(; creds=nothing, region="us-default-scoped-2")

        default_aws_config(config1)
        @test default_aws_config() === config1
        @test current_aws_config() === config1

        with_aws_config(config2) do
            @test default_aws_config() === config1
            @test current_aws_config() === config2
        end

        @test default_aws_config() === config1
        @test current_aws_config() === config1
    end
end

@testset "global_aws_config" begin
    @testset "kwargs" begin
        # Fake AWS credentials as shown in the AWS documentation:
        # https://docs.aws.amazon.com/IAM/latest/UserGuide/id_credentials_access-keys.html
        access_key_id = "AKIAIOSFODNN7EXAMPLE"
        secret_access_key = "wJalrXUtnFEMI/K7MDENG/bPxRfiCYEXAMPLEKEY"
        creds = AWS.AWSCredentials(access_key_id, secret_access_key)
        region = "us-global-kwargs-1"

        set_result = @test_deprecated global_aws_config(; creds, region)
        @test set_result.region == region
        @test set_result.credentials == creds

        get_result = @test_deprecated global_aws_config()
        @test get_result === set_result
    end

    @testset "config" begin
        config = AWSConfig(; creds=nothing, region="us-global-1")

        set_result = @test_deprecated global_aws_config(config)
        @test set_result === config

        get_result = @test_deprecated global_aws_config()
        @test get_result === config
    end

    @testset "scoped interaction" begin
        config1 = AWSConfig(; creds=nothing, region="us-global-scoped-1")
        config2 = AWSConfig(; creds=nothing, region="us-global-scoped-2")

        @test_deprecated global_aws_config(config1)
        @test (@test_deprecated global_aws_config()) === config1
        @test current_aws_config() === config1

        with_aws_config(config2) do
            @test (@test_deprecated global_aws_config()) === config1
            @test current_aws_config() === config2
        end

        @test (@test_deprecated global_aws_config()) === config1
        @test current_aws_config() === config1
    end
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: iotfleethub
using AWS.Compat
using AWS.UUIDs

"""
    create_application(application_name, role_arn)
    create_application(application_name, role_arn, params::Dict{String,<:Any})

Creates a Fleet Hub for IoT Device Management web application. When creating a Fleet Hub
application, you must create an organization instance of IAM Identity Center if you don't
already have one. The Fleet Hub application you create must also be in the same Amazon Web
Services Region of the organization instance of IAM Identity Center. For more information
see Enabling IAM Identity Center and Organization instances of IAM Identity Center.

# Arguments
- `application_name`: The name of the web application.
- `role_arn`: The ARN of the role that the web application assumes when it interacts with
  Amazon Web Services IoT Core.  The name of the role must be in the form
  AWSIotFleetHub_random_string .

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"applicationDescription"`: An optional description of the web application.
- `"clientToken"`: A unique case-sensitive identifier that you can provide to ensure the
  idempotency of the request. Don't reuse this client token if a new idempotent request is
  required.
- `"tags"`: A set of key/value pairs that you can use to manage the web application
  resource.
"""
function create_application(
    applicationName, roleArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotfleethub(
        "POST",
        "/applications",
        Dict{String,Any}(
            "applicationName" => applicationName,
            "roleArn" => roleArn,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_application(
    applicationName,
    roleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotfleethub(
        "POST",
        "/applications",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "applicationName" => applicationName,
                    "roleArn" => roleArn,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_application(application_id)
    delete_application(application_id, params::Dict{String,<:Any})

Deletes a Fleet Hub for IoT Device Management web application.

# Arguments
- `application_id`: The unique Id of the web application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique case-sensitive identifier that you can provide to ensure the
  idempotency of the request. Don't reuse this client token if a new idempotent request is
  required.
"""
function delete_application(
    applicationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotfleethub(
        "DELETE",
        "/applications/$(applicationId)",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_application(
    applicationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotfleethub(
        "DELETE",
        "/applications/$(applicationId)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_application(application_id)
    describe_application(application_id, params::Dict{String,<:Any})

Gets information about a Fleet Hub for IoT Device Management web application.

# Arguments
- `application_id`: The unique Id of the web application.

"""
function describe_application(
    applicationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotfleethub(
        "GET",
        "/applications/$(applicationId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_application(
    applicationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotfleethub(
        "GET",
        "/applications/$(applicationId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_applications()
    list_applications(params::Dict{String,<:Any})

Gets a list of Fleet Hub for IoT Device Management web applications for the current account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: A token used to get the next set of results.
"""
function list_applications(; aws_config::AbstractAWSConfig=current_aws_config())
    return iotfleethub(
        "GET", "/applications"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_applications(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotfleethub(
        "GET",
        "/applications",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists the tags for the specified resource.

# Arguments
- `resource_arn`: The ARN of the resource.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotfleethub(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotfleethub(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds to or modifies the tags of the specified resource. Tags are metadata which can be used
to manage a resource.

# Arguments
- `resource_arn`: The ARN of the resource.
- `tags`: The new or modified tags for the resource.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return iotfleethub(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotfleethub(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes the specified tags (metadata) from the resource.

# Arguments
- `resource_arn`: The ARN of the resource.
- `tag_keys`: A list of the keys of the tags to be removed from the resource.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotfleethub(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotfleethub(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_application(application_id)
    update_application(application_id, params::Dict{String,<:Any})

Updates information about a Fleet Hub for IoT Device Management web application.

# Arguments
- `application_id`: The unique Id of the web application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"applicationDescription"`: An optional description of the web application.
- `"applicationName"`: The name of the web application.
- `"clientToken"`: A unique case-sensitive identifier that you can provide to ensure the
  idempotency of the request. Don't reuse this client token if a new idempotent request is
  required.
"""
function update_application(
    applicationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotfleethub(
        "PATCH",
        "/applications/$(applicationId)",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_application(
    applicationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotfleethub(
        "PATCH",
        "/applications/$(applicationId)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: medical_imaging
using AWS.Compat
using AWS.UUIDs

"""
    copy_image_set(copy_image_set_information, datastore_id, source_image_set_id)
    copy_image_set(copy_image_set_information, datastore_id, source_image_set_id, params::Dict{String,<:Any})

Copy an image set.

# Arguments
- `copy_image_set_information`: Copy image set information.
- `datastore_id`: The data store identifier.
- `source_image_set_id`: The source image set identifier.

"""
function copy_image_set(
    copyImageSetInformation,
    datastoreId,
    sourceImageSetId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medical_imaging(
        "POST",
        "/datastore/$(datastoreId)/imageSet/$(sourceImageSetId)/copyImageSet",
        Dict{String,Any}("copyImageSetInformation" => copyImageSetInformation);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function copy_image_set(
    copyImageSetInformation,
    datastoreId,
    sourceImageSetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medical_imaging(
        "POST",
        "/datastore/$(datastoreId)/imageSet/$(sourceImageSetId)/copyImageSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("copyImageSetInformation" => copyImageSetInformation),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_datastore(client_token)
    create_datastore(client_token, params::Dict{String,<:Any})

Create a data store.

# Arguments
- `client_token`: A unique identifier for API idempotency.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"datastoreName"`: The data store name.
- `"kmsKeyArn"`: The Amazon Resource Name (ARN) assigned to the Key Management Service
  (KMS) key for accessing encrypted data.
- `"tags"`: The tags provided when creating a data store.
"""
function create_datastore(clientToken; aws_config::AbstractAWSConfig=current_aws_config())
    return medical_imaging(
        "POST",
        "/datastore",
        Dict{String,Any}("clientToken" => clientToken);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_datastore(
    clientToken,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medical_imaging(
        "POST",
        "/datastore",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => clientToken), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_datastore(datastore_id)
    delete_datastore(datastore_id, params::Dict{String,<:Any})

Delete a data store.  Before a data store can be deleted, you must first delete all image
sets within it.

# Arguments
- `datastore_id`: The data store identifier.

"""
function delete_datastore(datastoreId; aws_config::AbstractAWSConfig=current_aws_config())
    return medical_imaging(
        "DELETE",
        "/datastore/$(datastoreId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_datastore(
    datastoreId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medical_imaging(
        "DELETE",
        "/datastore/$(datastoreId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_image_set(datastore_id, image_set_id)
    delete_image_set(datastore_id, image_set_id, params::Dict{String,<:Any})

Delete an image set.

# Arguments
- `datastore_id`: The data store identifier.
- `image_set_id`: The image set identifier.

"""
function delete_image_set(
    datastoreId, imageSetId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medical_imaging(
        "POST",
        "/datastore/$(datastoreId)/imageSet/$(imageSetId)/deleteImageSet";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_image_set(
    datastoreId,
    imageSetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medical_imaging(
        "POST",
        "/datastore/$(datastoreId)/imageSet/$(imageSetId)/deleteImageSet",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_datastore(datastore_id)
    get_datastore(datastore_id, params::Dict{String,<:Any})

Get data store properties.

# Arguments
- `datastore_id`: The data store identifier.

"""
function get_datastore(datastoreId; aws_config::AbstractAWSConfig=current_aws_config())
    return medical_imaging(
        "GET",
        "/datastore/$(datastoreId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_datastore(
    datastoreId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medical_imaging(
        "GET",
        "/datastore/$(datastoreId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_dicomimport_job(datastore_id, job_id)
    get_dicomimport_job(datastore_id, job_id, params::Dict{String,<:Any})

Get the import job properties to learn more about the job or job progress.  The jobStatus
refers to the execution of the import job. Therefore, an import job can return a jobStatus
as COMPLETED even if validation issues are discovered during the import process. If a
jobStatus returns as COMPLETED, we still recommend you review the output manifests written
to S3, as they provide details on the success or failure of individual P10 object imports.

# Arguments
- `datastore_id`: The data store identifier.
- `job_id`: The import job identifier.

"""
function get_dicomimport_job(
    datastoreId, jobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medical_imaging(
        "GET",
        "/getDICOMImportJob/datastore/$(datastoreId)/job/$(jobId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_dicomimport_job(
    datastoreId,
    jobId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medical_imaging(
        "GET",
        "/getDICOMImportJob/datastore/$(datastoreId)/job/$(jobId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_image_frame(datastore_id, image_frame_information, image_set_id)
    get_image_frame(datastore_id, image_frame_information, image_set_id, params::Dict{String,<:Any})

Get an image frame (pixel data) for an image set.

# Arguments
- `datastore_id`: The data store identifier.
- `image_frame_information`: Information about the image frame (pixel data) identifier.
- `image_set_id`: The image set identifier.

"""
function get_image_frame(
    datastoreId,
    imageFrameInformation,
    imageSetId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medical_imaging(
        "POST",
        "/datastore/$(datastoreId)/imageSet/$(imageSetId)/getImageFrame",
        Dict{String,Any}("imageFrameInformation" => imageFrameInformation);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_image_frame(
    datastoreId,
    imageFrameInformation,
    imageSetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medical_imaging(
        "POST",
        "/datastore/$(datastoreId)/imageSet/$(imageSetId)/getImageFrame",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("imageFrameInformation" => imageFrameInformation),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_image_set(datastore_id, image_set_id)
    get_image_set(datastore_id, image_set_id, params::Dict{String,<:Any})

Get image set properties.

# Arguments
- `datastore_id`: The data store identifier.
- `image_set_id`: The image set identifier.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"version"`: The image set version identifier.
"""
function get_image_set(
    datastoreId, imageSetId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medical_imaging(
        "POST",
        "/datastore/$(datastoreId)/imageSet/$(imageSetId)/getImageSet";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_image_set(
    datastoreId,
    imageSetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medical_imaging(
        "POST",
        "/datastore/$(datastoreId)/imageSet/$(imageSetId)/getImageSet",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_image_set_metadata(datastore_id, image_set_id)
    get_image_set_metadata(datastore_id, image_set_id, params::Dict{String,<:Any})

Get metadata attributes for an image set.

# Arguments
- `datastore_id`: The data store identifier.
- `image_set_id`: The image set identifier.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"version"`: The image set version identifier.
"""
function get_image_set_metadata(
    datastoreId, imageSetId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medical_imaging(
        "POST",
        "/datastore/$(datastoreId)/imageSet/$(imageSetId)/getImageSetMetadata";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_image_set_metadata(
    datastoreId,
    imageSetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medical_imaging(
        "POST",
        "/datastore/$(datastoreId)/imageSet/$(imageSetId)/getImageSetMetadata",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_datastores()
    list_datastores(params::Dict{String,<:Any})

List data stores.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"datastoreStatus"`: The data store status.
- `"maxResults"`: Valid Range: Minimum value of 1. Maximum value of 50.
- `"nextToken"`: The pagination token used to request the list of data stores on the next
  page.
"""
function list_datastores(; aws_config::AbstractAWSConfig=current_aws_config())
    return medical_imaging(
        "GET", "/datastore"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_datastores(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medical_imaging(
        "GET", "/datastore", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_dicomimport_jobs(datastore_id)
    list_dicomimport_jobs(datastore_id, params::Dict{String,<:Any})

List import jobs created for a specific data store.

# Arguments
- `datastore_id`: The data store identifier.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"jobStatus"`: The filters for listing import jobs based on status.
- `"maxResults"`: The max results count. The upper bound is determined by load testing.
- `"nextToken"`: The pagination token used to request the list of import jobs on the next
  page.
"""
function list_dicomimport_jobs(
    datastoreId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medical_imaging(
        "GET",
        "/listDICOMImportJobs/datastore/$(datastoreId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_dicomimport_jobs(
    datastoreId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medical_imaging(
        "GET",
        "/listDICOMImportJobs/datastore/$(datastoreId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_image_set_versions(datastore_id, image_set_id)
    list_image_set_versions(datastore_id, image_set_id, params::Dict{String,<:Any})

List image set versions.

# Arguments
- `datastore_id`: The data store identifier.
- `image_set_id`: The image set identifier.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The max results count.
- `"nextToken"`: The pagination token used to request the list of image set versions on the
  next page.
"""
function list_image_set_versions(
    datastoreId, imageSetId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medical_imaging(
        "POST",
        "/datastore/$(datastoreId)/imageSet/$(imageSetId)/listImageSetVersions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_image_set_versions(
    datastoreId,
    imageSetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medical_imaging(
        "POST",
        "/datastore/$(datastoreId)/imageSet/$(imageSetId)/listImageSetVersions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists all tags associated with a medical imaging resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the medical imaging resource to list
  tags for.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medical_imaging(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medical_imaging(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    search_image_sets(datastore_id)
    search_image_sets(datastore_id, params::Dict{String,<:Any})

Search image sets based on defined input attributes.   SearchImageSets accepts a single
search query parameter and returns a paginated response of all image sets that have the
matching criteria. All date range queries must be input as (lowerBound, upperBound). By
default, SearchImageSets uses the updatedAt field for sorting in descending order from
newest to oldest.

# Arguments
- `datastore_id`: The identifier of the data store where the image sets reside.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results that can be returned in a search.
- `"nextToken"`: The token used for pagination of results returned in the response. Use the
  token returned from the previous request to continue results where the previous request
  ended.
- `"searchCriteria"`: The search criteria that filters by applying a maximum of 1 item to
  SearchByAttribute.
"""
function search_image_sets(datastoreId; aws_config::AbstractAWSConfig=current_aws_config())
    return medical_imaging(
        "POST",
        "/datastore/$(datastoreId)/searchImageSets";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function search_image_sets(
    datastoreId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medical_imaging(
        "POST",
        "/datastore/$(datastoreId)/searchImageSets",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_dicomimport_job(client_token, data_access_role_arn, datastore_id, input_s3_uri, output_s3_uri)
    start_dicomimport_job(client_token, data_access_role_arn, datastore_id, input_s3_uri, output_s3_uri, params::Dict{String,<:Any})

Start importing bulk data into an ACTIVE data store. The import job imports DICOM P10 files
found in the S3 prefix specified by the inputS3Uri parameter. The import job stores
processing results in the file specified by the outputS3Uri parameter.

# Arguments
- `client_token`: A unique identifier for API idempotency.
- `data_access_role_arn`: The Amazon Resource Name (ARN) of the IAM role that grants
  permission to access medical imaging resources.
- `datastore_id`: The data store identifier.
- `input_s3_uri`: The input prefix path for the S3 bucket that contains the DICOM files to
  be imported.
- `output_s3_uri`: The output prefix of the S3 bucket to upload the results of the DICOM
  import job.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"inputOwnerAccountId"`: The account ID of the source S3 bucket owner.
- `"jobName"`: The import job name.
"""
function start_dicomimport_job(
    clientToken,
    dataAccessRoleArn,
    datastoreId,
    inputS3Uri,
    outputS3Uri;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medical_imaging(
        "POST",
        "/startDICOMImportJob/datastore/$(datastoreId)",
        Dict{String,Any}(
            "clientToken" => clientToken,
            "dataAccessRoleArn" => dataAccessRoleArn,
            "inputS3Uri" => inputS3Uri,
            "outputS3Uri" => outputS3Uri,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_dicomimport_job(
    clientToken,
    dataAccessRoleArn,
    datastoreId,
    inputS3Uri,
    outputS3Uri,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medical_imaging(
        "POST",
        "/startDICOMImportJob/datastore/$(datastoreId)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "clientToken" => clientToken,
                    "dataAccessRoleArn" => dataAccessRoleArn,
                    "inputS3Uri" => inputS3Uri,
                    "outputS3Uri" => outputS3Uri,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds a user-specifed key and value tag to a medical imaging resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the medical imaging resource that tags
  are being added to.
- `tags`: The user-specified key and value tag pairs added to a medical imaging resource.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return medical_imaging(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medical_imaging(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes tags from a medical imaging resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the medical imaging resource that tags
  are being removed from.
- `tag_keys`: The keys for the tags to be removed from the medical imaging resource.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medical_imaging(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medical_imaging(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_image_set_metadata(datastore_id, image_set_id, latest_version, update_image_set_metadata_updates)
    update_image_set_metadata(datastore_id, image_set_id, latest_version, update_image_set_metadata_updates, params::Dict{String,<:Any})

Update image set metadata attributes.

# Arguments
- `datastore_id`: The data store identifier.
- `image_set_id`: The image set identifier.
- `latest_version`: The latest image set version identifier.
- `update_image_set_metadata_updates`: Update image set metadata updates.

"""
function update_image_set_metadata(
    datastoreId,
    imageSetId,
    latestVersion,
    updateImageSetMetadataUpdates;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medical_imaging(
        "POST",
        "/datastore/$(datastoreId)/imageSet/$(imageSetId)/updateImageSetMetadata",
        Dict{String,Any}(
            "latestVersion" => latestVersion,
            "updateImageSetMetadataUpdates" => updateImageSetMetadataUpdates,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_image_set_metadata(
    datastoreId,
    imageSetId,
    latestVersion,
    updateImageSetMetadataUpdates,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medical_imaging(
        "POST",
        "/datastore/$(datastoreId)/imageSet/$(imageSetId)/updateImageSetMetadata",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "latestVersion" => latestVersion,
                    "updateImageSetMetadataUpdates" => updateImageSetMetadataUpdates,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: iotdeviceadvisor
using AWS.Compat
using AWS.UUIDs

"""
    create_suite_definition(suite_definition_configuration)
    create_suite_definition(suite_definition_configuration, params::Dict{String,<:Any})

Creates a Device Advisor test suite. Requires permission to access the
CreateSuiteDefinition action.

# Arguments
- `suite_definition_configuration`: Creates a Device Advisor test suite with suite
  definition configuration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tags"`: The tags to be attached to the suite definition.
"""
function create_suite_definition(
    suiteDefinitionConfiguration; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotdeviceadvisor(
        "POST",
        "/suiteDefinitions",
        Dict{String,Any}("suiteDefinitionConfiguration" => suiteDefinitionConfiguration);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_suite_definition(
    suiteDefinitionConfiguration,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotdeviceadvisor(
        "POST",
        "/suiteDefinitions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "suiteDefinitionConfiguration" => suiteDefinitionConfiguration
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_suite_definition(suite_definition_id)
    delete_suite_definition(suite_definition_id, params::Dict{String,<:Any})

Deletes a Device Advisor test suite. Requires permission to access the
DeleteSuiteDefinition action.

# Arguments
- `suite_definition_id`: Suite definition ID of the test suite to be deleted.

"""
function delete_suite_definition(
    suiteDefinitionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotdeviceadvisor(
        "DELETE",
        "/suiteDefinitions/$(suiteDefinitionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_suite_definition(
    suiteDefinitionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotdeviceadvisor(
        "DELETE",
        "/suiteDefinitions/$(suiteDefinitionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_endpoint()
    get_endpoint(params::Dict{String,<:Any})

Gets information about an Device Advisor endpoint.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"authenticationMethod"`: The authentication method used during the device connection.
- `"certificateArn"`: The certificate ARN of the device. This is an optional parameter.
- `"deviceRoleArn"`: The device role ARN of the device. This is an optional parameter.
- `"thingArn"`: The thing ARN of the device. This is an optional parameter.
"""
function get_endpoint(; aws_config::AbstractAWSConfig=current_aws_config())
    return iotdeviceadvisor(
        "GET", "/endpoint"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_endpoint(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotdeviceadvisor(
        "GET", "/endpoint", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_suite_definition(suite_definition_id)
    get_suite_definition(suite_definition_id, params::Dict{String,<:Any})

Gets information about a Device Advisor test suite. Requires permission to access the
GetSuiteDefinition action.

# Arguments
- `suite_definition_id`: Suite definition ID of the test suite to get.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"suiteDefinitionVersion"`: Suite definition version of the test suite to get.
"""
function get_suite_definition(
    suiteDefinitionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotdeviceadvisor(
        "GET",
        "/suiteDefinitions/$(suiteDefinitionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_suite_definition(
    suiteDefinitionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotdeviceadvisor(
        "GET",
        "/suiteDefinitions/$(suiteDefinitionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_suite_run(suite_definition_id, suite_run_id)
    get_suite_run(suite_definition_id, suite_run_id, params::Dict{String,<:Any})

Gets information about a Device Advisor test suite run. Requires permission to access the
GetSuiteRun action.

# Arguments
- `suite_definition_id`: Suite definition ID for the test suite run.
- `suite_run_id`: Suite run ID for the test suite run.

"""
function get_suite_run(
    suiteDefinitionId, suiteRunId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotdeviceadvisor(
        "GET",
        "/suiteDefinitions/$(suiteDefinitionId)/suiteRuns/$(suiteRunId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_suite_run(
    suiteDefinitionId,
    suiteRunId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotdeviceadvisor(
        "GET",
        "/suiteDefinitions/$(suiteDefinitionId)/suiteRuns/$(suiteRunId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_suite_run_report(suite_definition_id, suite_run_id)
    get_suite_run_report(suite_definition_id, suite_run_id, params::Dict{String,<:Any})

Gets a report download link for a successful Device Advisor qualifying test suite run.
Requires permission to access the GetSuiteRunReport action.

# Arguments
- `suite_definition_id`: Suite definition ID of the test suite.
- `suite_run_id`: Suite run ID of the test suite run.

"""
function get_suite_run_report(
    suiteDefinitionId, suiteRunId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotdeviceadvisor(
        "GET",
        "/suiteDefinitions/$(suiteDefinitionId)/suiteRuns/$(suiteRunId)/report";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_suite_run_report(
    suiteDefinitionId,
    suiteRunId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotdeviceadvisor(
        "GET",
        "/suiteDefinitions/$(suiteDefinitionId)/suiteRuns/$(suiteRunId)/report",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_suite_definitions()
    list_suite_definitions(params::Dict{String,<:Any})

Lists the Device Advisor test suites you have created. Requires permission to access the
ListSuiteDefinitions action.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return at once.
- `"nextToken"`: A token used to get the next set of results.
"""
function list_suite_definitions(; aws_config::AbstractAWSConfig=current_aws_config())
    return iotdeviceadvisor(
        "GET", "/suiteDefinitions"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_suite_definitions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotdeviceadvisor(
        "GET",
        "/suiteDefinitions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_suite_runs()
    list_suite_runs(params::Dict{String,<:Any})

Lists runs of the specified Device Advisor test suite. You can list all runs of the test
suite, or the runs of a specific version of the test suite. Requires permission to access
the ListSuiteRuns action.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return at once.
- `"nextToken"`: A token to retrieve the next set of results.
- `"suiteDefinitionId"`: Lists the test suite runs of the specified test suite based on
  suite definition ID.
- `"suiteDefinitionVersion"`: Must be passed along with suiteDefinitionId. Lists the test
  suite runs of the specified test suite based on suite definition version.
"""
function list_suite_runs(; aws_config::AbstractAWSConfig=current_aws_config())
    return iotdeviceadvisor(
        "GET", "/suiteRuns"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_suite_runs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotdeviceadvisor(
        "GET", "/suiteRuns", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists the tags attached to an IoT Device Advisor resource. Requires permission to access
the ListTagsForResource action.

# Arguments
- `resource_arn`: The resource ARN of the IoT Device Advisor resource. This can be
  SuiteDefinition ARN or SuiteRun ARN.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotdeviceadvisor(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotdeviceadvisor(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_suite_run(suite_definition_id, suite_run_configuration)
    start_suite_run(suite_definition_id, suite_run_configuration, params::Dict{String,<:Any})

Starts a Device Advisor test suite run. Requires permission to access the StartSuiteRun
action.

# Arguments
- `suite_definition_id`: Suite definition ID of the test suite.
- `suite_run_configuration`: Suite run configuration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"suiteDefinitionVersion"`: Suite definition version of the test suite.
- `"tags"`: The tags to be attached to the suite run.
"""
function start_suite_run(
    suiteDefinitionId,
    suiteRunConfiguration;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotdeviceadvisor(
        "POST",
        "/suiteDefinitions/$(suiteDefinitionId)/suiteRuns",
        Dict{String,Any}("suiteRunConfiguration" => suiteRunConfiguration);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_suite_run(
    suiteDefinitionId,
    suiteRunConfiguration,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotdeviceadvisor(
        "POST",
        "/suiteDefinitions/$(suiteDefinitionId)/suiteRuns",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("suiteRunConfiguration" => suiteRunConfiguration),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_suite_run(suite_definition_id, suite_run_id)
    stop_suite_run(suite_definition_id, suite_run_id, params::Dict{String,<:Any})

Stops a Device Advisor test suite run that is currently running. Requires permission to
access the StopSuiteRun action.

# Arguments
- `suite_definition_id`: Suite definition ID of the test suite run to be stopped.
- `suite_run_id`: Suite run ID of the test suite run to be stopped.

"""
function stop_suite_run(
    suiteDefinitionId, suiteRunId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotdeviceadvisor(
        "POST",
        "/suiteDefinitions/$(suiteDefinitionId)/suiteRuns/$(suiteRunId)/stop";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_suite_run(
    suiteDefinitionId,
    suiteRunId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotdeviceadvisor(
        "POST",
        "/suiteDefinitions/$(suiteDefinitionId)/suiteRuns/$(suiteRunId)/stop",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds to and modifies existing tags of an IoT Device Advisor resource. Requires permission
to access the TagResource action.

# Arguments
- `resource_arn`: The resource ARN of an IoT Device Advisor resource. This can be
  SuiteDefinition ARN or SuiteRun ARN.
- `tags`: The tags to be attached to the IoT Device Advisor resource.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return iotdeviceadvisor(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotdeviceadvisor(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes tags from an IoT Device Advisor resource. Requires permission to access the
UntagResource action.

# Arguments
- `resource_arn`: The resource ARN of an IoT Device Advisor resource. This can be
  SuiteDefinition ARN or SuiteRun ARN.
- `tag_keys`: List of tag keys to remove from the IoT Device Advisor resource.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotdeviceadvisor(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotdeviceadvisor(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_suite_definition(suite_definition_configuration, suite_definition_id)
    update_suite_definition(suite_definition_configuration, suite_definition_id, params::Dict{String,<:Any})

Updates a Device Advisor test suite. Requires permission to access the
UpdateSuiteDefinition action.

# Arguments
- `suite_definition_configuration`: Updates a Device Advisor test suite with suite
  definition configuration.
- `suite_definition_id`: Suite definition ID of the test suite to be updated.

"""
function update_suite_definition(
    suiteDefinitionConfiguration,
    suiteDefinitionId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotdeviceadvisor(
        "PATCH",
        "/suiteDefinitions/$(suiteDefinitionId)",
        Dict{String,Any}("suiteDefinitionConfiguration" => suiteDefinitionConfiguration);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_suite_definition(
    suiteDefinitionConfiguration,
    suiteDefinitionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotdeviceadvisor(
        "PATCH",
        "/suiteDefinitions/$(suiteDefinitionId)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "suiteDefinitionConfiguration" => suiteDefinitionConfiguration
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: appstream
using AWS.Compat
using AWS.UUIDs

"""
    associate_app_block_builder_app_block(app_block_arn, app_block_builder_name)
    associate_app_block_builder_app_block(app_block_arn, app_block_builder_name, params::Dict{String,<:Any})

Associates the specified app block builder with the specified app block.

# Arguments
- `app_block_arn`: The ARN of the app block.
- `app_block_builder_name`: The name of the app block builder.

"""
function associate_app_block_builder_app_block(
    AppBlockArn, AppBlockBuilderName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "AssociateAppBlockBuilderAppBlock",
        Dict{String,Any}(
            "AppBlockArn" => AppBlockArn, "AppBlockBuilderName" => AppBlockBuilderName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_app_block_builder_app_block(
    AppBlockArn,
    AppBlockBuilderName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appstream(
        "AssociateAppBlockBuilderAppBlock",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AppBlockArn" => AppBlockArn,
                    "AppBlockBuilderName" => AppBlockBuilderName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_application_fleet(application_arn, fleet_name)
    associate_application_fleet(application_arn, fleet_name, params::Dict{String,<:Any})

Associates the specified application with the specified fleet. This is only supported for
Elastic fleets.

# Arguments
- `application_arn`: The ARN of the application.
- `fleet_name`: The name of the fleet.

"""
function associate_application_fleet(
    ApplicationArn, FleetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "AssociateApplicationFleet",
        Dict{String,Any}("ApplicationArn" => ApplicationArn, "FleetName" => FleetName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_application_fleet(
    ApplicationArn,
    FleetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appstream(
        "AssociateApplicationFleet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationArn" => ApplicationArn, "FleetName" => FleetName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_application_to_entitlement(application_identifier, entitlement_name, stack_name)
    associate_application_to_entitlement(application_identifier, entitlement_name, stack_name, params::Dict{String,<:Any})

Associates an application to entitle.

# Arguments
- `application_identifier`: The identifier of the application.
- `entitlement_name`: The name of the entitlement.
- `stack_name`: The name of the stack.

"""
function associate_application_to_entitlement(
    ApplicationIdentifier,
    EntitlementName,
    StackName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appstream(
        "AssociateApplicationToEntitlement",
        Dict{String,Any}(
            "ApplicationIdentifier" => ApplicationIdentifier,
            "EntitlementName" => EntitlementName,
            "StackName" => StackName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_application_to_entitlement(
    ApplicationIdentifier,
    EntitlementName,
    StackName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appstream(
        "AssociateApplicationToEntitlement",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationIdentifier" => ApplicationIdentifier,
                    "EntitlementName" => EntitlementName,
                    "StackName" => StackName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_fleet(fleet_name, stack_name)
    associate_fleet(fleet_name, stack_name, params::Dict{String,<:Any})

Associates the specified fleet with the specified stack.

# Arguments
- `fleet_name`: The name of the fleet.
- `stack_name`: The name of the stack.

"""
function associate_fleet(
    FleetName, StackName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "AssociateFleet",
        Dict{String,Any}("FleetName" => FleetName, "StackName" => StackName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_fleet(
    FleetName,
    StackName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appstream(
        "AssociateFleet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("FleetName" => FleetName, "StackName" => StackName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_associate_user_stack(user_stack_associations)
    batch_associate_user_stack(user_stack_associations, params::Dict{String,<:Any})

Associates the specified users with the specified stacks. Users in a user pool cannot be
assigned to stacks with fleets that are joined to an Active Directory domain.

# Arguments
- `user_stack_associations`: The list of UserStackAssociation objects.

"""
function batch_associate_user_stack(
    UserStackAssociations; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "BatchAssociateUserStack",
        Dict{String,Any}("UserStackAssociations" => UserStackAssociations);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_associate_user_stack(
    UserStackAssociations,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appstream(
        "BatchAssociateUserStack",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("UserStackAssociations" => UserStackAssociations),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_disassociate_user_stack(user_stack_associations)
    batch_disassociate_user_stack(user_stack_associations, params::Dict{String,<:Any})

Disassociates the specified users from the specified stacks.

# Arguments
- `user_stack_associations`: The list of UserStackAssociation objects.

"""
function batch_disassociate_user_stack(
    UserStackAssociations; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "BatchDisassociateUserStack",
        Dict{String,Any}("UserStackAssociations" => UserStackAssociations);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_disassociate_user_stack(
    UserStackAssociations,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appstream(
        "BatchDisassociateUserStack",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("UserStackAssociations" => UserStackAssociations),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    copy_image(destination_image_name, destination_region, source_image_name)
    copy_image(destination_image_name, destination_region, source_image_name, params::Dict{String,<:Any})

Copies the image within the same region or to a new region within the same AWS account.
Note that any tags you added to the image will not be copied.

# Arguments
- `destination_image_name`: The name that the image will have when it is copied to the
  destination.
- `destination_region`: The destination region to which the image will be copied. This
  parameter is required, even if you are copying an image within the same region.
- `source_image_name`: The name of the image to copy.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DestinationImageDescription"`: The description that the image will have when it is
  copied to the destination.
"""
function copy_image(
    DestinationImageName,
    DestinationRegion,
    SourceImageName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appstream(
        "CopyImage",
        Dict{String,Any}(
            "DestinationImageName" => DestinationImageName,
            "DestinationRegion" => DestinationRegion,
            "SourceImageName" => SourceImageName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function copy_image(
    DestinationImageName,
    DestinationRegion,
    SourceImageName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appstream(
        "CopyImage",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DestinationImageName" => DestinationImageName,
                    "DestinationRegion" => DestinationRegion,
                    "SourceImageName" => SourceImageName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_app_block(name, source_s3_location)
    create_app_block(name, source_s3_location, params::Dict{String,<:Any})

Creates an app block. App blocks are an Amazon AppStream 2.0 resource that stores the
details about the virtual hard disk in an S3 bucket. It also stores the setup script with
details about how to mount the virtual hard disk. The virtual hard disk includes the
application binaries and other files necessary to launch your applications. Multiple
applications can be assigned to a single app block. This is only supported for Elastic
fleets.

# Arguments
- `name`: The name of the app block.
- `source_s3_location`: The source S3 location of the app block.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: The description of the app block.
- `"DisplayName"`: The display name of the app block. This is not displayed to the user.
- `"PackagingType"`: The packaging type of the app block.
- `"PostSetupScriptDetails"`: The post setup script details of the app block. This can only
  be provided for the APPSTREAM2 PackagingType.
- `"SetupScriptDetails"`: The setup script details of the app block. This must be provided
  for the CUSTOM PackagingType.
- `"Tags"`: The tags assigned to the app block.
"""
function create_app_block(
    Name, SourceS3Location; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "CreateAppBlock",
        Dict{String,Any}("Name" => Name, "SourceS3Location" => SourceS3Location);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_app_block(
    Name,
    SourceS3Location,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appstream(
        "CreateAppBlock",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Name" => Name, "SourceS3Location" => SourceS3Location),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_app_block_builder(instance_type, name, platform, vpc_config)
    create_app_block_builder(instance_type, name, platform, vpc_config, params::Dict{String,<:Any})

Creates an app block builder.

# Arguments
- `instance_type`: The instance type to use when launching the app block builder. The
  following instance types are available:   stream.standard.small   stream.standard.medium
  stream.standard.large   stream.standard.xlarge   stream.standard.2xlarge
- `name`: The unique name for the app block builder.
- `platform`: The platform of the app block builder.  WINDOWS_SERVER_2019 is the only valid
  value.
- `vpc_config`: The VPC configuration for the app block builder. App block builders require
  that you specify at least two subnets in different availability zones.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccessEndpoints"`: The list of interface VPC endpoint (interface endpoint) objects.
  Administrators can connect to the app block builder only through the specified endpoints.
- `"Description"`: The description of the app block builder.
- `"DisplayName"`: The display name of the app block builder.
- `"EnableDefaultInternetAccess"`: Enables or disables default internet access for the app
  block builder.
- `"IamRoleArn"`: The Amazon Resource Name (ARN) of the IAM role to apply to the app block
  builder. To assume a role, the app block builder calls the AWS Security Token Service (STS)
  AssumeRole API operation and passes the ARN of the role to use. The operation creates a new
  session with temporary credentials. AppStream 2.0 retrieves the temporary credentials and
  creates the appstream_machine_role credential profile on the instance. For more
  information, see Using an IAM Role to Grant Permissions to Applications and Scripts Running
  on AppStream 2.0 Streaming Instances in the Amazon AppStream 2.0 Administration Guide.
- `"Tags"`: The tags to associate with the app block builder. A tag is a key-value pair,
  and the value is optional. For example, Environment=Test. If you do not specify a value,
  Environment=.  If you do not specify a value, the value is set to an empty string.
  Generally allowed characters are: letters, numbers, and spaces representable in UTF-8, and
  the following special characters:  _ . : / = +  - @ For more information, see Tagging Your
  Resources in the Amazon AppStream 2.0 Administration Guide.
"""
function create_app_block_builder(
    InstanceType,
    Name,
    Platform,
    VpcConfig;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appstream(
        "CreateAppBlockBuilder",
        Dict{String,Any}(
            "InstanceType" => InstanceType,
            "Name" => Name,
            "Platform" => Platform,
            "VpcConfig" => VpcConfig,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_app_block_builder(
    InstanceType,
    Name,
    Platform,
    VpcConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appstream(
        "CreateAppBlockBuilder",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "InstanceType" => InstanceType,
                    "Name" => Name,
                    "Platform" => Platform,
                    "VpcConfig" => VpcConfig,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_app_block_builder_streaming_url(app_block_builder_name)
    create_app_block_builder_streaming_url(app_block_builder_name, params::Dict{String,<:Any})

Creates a URL to start a create app block builder streaming session.

# Arguments
- `app_block_builder_name`: The name of the app block builder.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Validity"`: The time that the streaming URL will be valid, in seconds. Specify a value
  between 1 and 604800 seconds. The default is 3600 seconds.
"""
function create_app_block_builder_streaming_url(
    AppBlockBuilderName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "CreateAppBlockBuilderStreamingURL",
        Dict{String,Any}("AppBlockBuilderName" => AppBlockBuilderName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_app_block_builder_streaming_url(
    AppBlockBuilderName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appstream(
        "CreateAppBlockBuilderStreamingURL",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("AppBlockBuilderName" => AppBlockBuilderName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_application(app_block_arn, icon_s3_location, instance_families, launch_path, name, platforms)
    create_application(app_block_arn, icon_s3_location, instance_families, launch_path, name, platforms, params::Dict{String,<:Any})

Creates an application. Applications are an Amazon AppStream 2.0 resource that stores the
details about how to launch applications on Elastic fleet streaming instances. An
application consists of the launch details, icon, and display name. Applications are
associated with an app block that contains the application binaries and other files. The
applications assigned to an Elastic fleet are the applications users can launch.  This is
only supported for Elastic fleets.

# Arguments
- `app_block_arn`: The app block ARN to which the application should be associated
- `icon_s3_location`: The location in S3 of the application icon.
- `instance_families`: The instance families the application supports. Valid values are
  GENERAL_PURPOSE and GRAPHICS_G4.
- `launch_path`: The launch path of the application.
- `name`: The name of the application. This name is visible to users when display name is
  not specified.
- `platforms`: The platforms the application supports. WINDOWS_SERVER_2019 and
  AMAZON_LINUX2 are supported for Elastic fleets.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: The description of the application.
- `"DisplayName"`: The display name of the application. This name is visible to users in
  the application catalog.
- `"LaunchParameters"`: The launch parameters of the application.
- `"Tags"`: The tags assigned to the application.
- `"WorkingDirectory"`: The working directory of the application.
"""
function create_application(
    AppBlockArn,
    IconS3Location,
    InstanceFamilies,
    LaunchPath,
    Name,
    Platforms;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appstream(
        "CreateApplication",
        Dict{String,Any}(
            "AppBlockArn" => AppBlockArn,
            "IconS3Location" => IconS3Location,
            "InstanceFamilies" => InstanceFamilies,
            "LaunchPath" => LaunchPath,
            "Name" => Name,
            "Platforms" => Platforms,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_application(
    AppBlockArn,
    IconS3Location,
    InstanceFamilies,
    LaunchPath,
    Name,
    Platforms,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appstream(
        "CreateApplication",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AppBlockArn" => AppBlockArn,
                    "IconS3Location" => IconS3Location,
                    "InstanceFamilies" => InstanceFamilies,
                    "LaunchPath" => LaunchPath,
                    "Name" => Name,
                    "Platforms" => Platforms,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_directory_config(directory_name, organizational_unit_distinguished_names)
    create_directory_config(directory_name, organizational_unit_distinguished_names, params::Dict{String,<:Any})

Creates a Directory Config object in AppStream 2.0. This object includes the configuration
information required to join fleets and image builders to Microsoft Active Directory
domains.

# Arguments
- `directory_name`: The fully qualified name of the directory (for example,
  corp.example.com).
- `organizational_unit_distinguished_names`: The distinguished names of the organizational
  units for computer accounts.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CertificateBasedAuthProperties"`: The certificate-based authentication properties used
  to authenticate SAML 2.0 Identity Provider (IdP) user identities to Active Directory
  domain-joined streaming instances. Fallback is turned on by default when certificate-based
  authentication is Enabled . Fallback allows users to log in using their AD domain password
  if certificate-based authentication is unsuccessful, or to unlock a desktop lock screen.
  Enabled_no_directory_login_fallback enables certificate-based authentication, but does not
  allow users to log in using their AD domain password. Users will be disconnected to
  re-authenticate using certificates.
- `"ServiceAccountCredentials"`: The credentials for the service account used by the fleet
  or image builder to connect to the directory.
"""
function create_directory_config(
    DirectoryName,
    OrganizationalUnitDistinguishedNames;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appstream(
        "CreateDirectoryConfig",
        Dict{String,Any}(
            "DirectoryName" => DirectoryName,
            "OrganizationalUnitDistinguishedNames" => OrganizationalUnitDistinguishedNames,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_directory_config(
    DirectoryName,
    OrganizationalUnitDistinguishedNames,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appstream(
        "CreateDirectoryConfig",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DirectoryName" => DirectoryName,
                    "OrganizationalUnitDistinguishedNames" =>
                        OrganizationalUnitDistinguishedNames,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_entitlement(app_visibility, attributes, name, stack_name)
    create_entitlement(app_visibility, attributes, name, stack_name, params::Dict{String,<:Any})

Creates a new entitlement. Entitlements control access to specific applications within a
stack, based on user attributes. Entitlements apply to SAML 2.0 federated user identities.
Amazon AppStream 2.0 user pool and streaming URL users are entitled to all applications in
a stack. Entitlements don't apply to the desktop stream view application, or to
applications managed by a dynamic app provider using the Dynamic Application Framework.

# Arguments
- `app_visibility`: Specifies whether all or selected apps are entitled.
- `attributes`: The attributes of the entitlement.
- `name`: The name of the entitlement.
- `stack_name`: The name of the stack with which the entitlement is associated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: The description of the entitlement.
"""
function create_entitlement(
    AppVisibility,
    Attributes,
    Name,
    StackName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appstream(
        "CreateEntitlement",
        Dict{String,Any}(
            "AppVisibility" => AppVisibility,
            "Attributes" => Attributes,
            "Name" => Name,
            "StackName" => StackName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_entitlement(
    AppVisibility,
    Attributes,
    Name,
    StackName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appstream(
        "CreateEntitlement",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AppVisibility" => AppVisibility,
                    "Attributes" => Attributes,
                    "Name" => Name,
                    "StackName" => StackName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_fleet(instance_type, name)
    create_fleet(instance_type, name, params::Dict{String,<:Any})

Creates a fleet. A fleet consists of streaming instances that your users access for their
applications and desktops.

# Arguments
- `instance_type`: The instance type to use when launching fleet instances. The following
  instance types are available:   stream.standard.small   stream.standard.medium
  stream.standard.large   stream.standard.xlarge   stream.standard.2xlarge
  stream.compute.large   stream.compute.xlarge   stream.compute.2xlarge
  stream.compute.4xlarge   stream.compute.8xlarge   stream.memory.large
  stream.memory.xlarge   stream.memory.2xlarge   stream.memory.4xlarge
  stream.memory.8xlarge   stream.memory.z1d.large   stream.memory.z1d.xlarge
  stream.memory.z1d.2xlarge   stream.memory.z1d.3xlarge   stream.memory.z1d.6xlarge
  stream.memory.z1d.12xlarge   stream.graphics-design.large   stream.graphics-design.xlarge
  stream.graphics-design.2xlarge   stream.graphics-design.4xlarge
  stream.graphics-desktop.2xlarge   stream.graphics.g4dn.xlarge
  stream.graphics.g4dn.2xlarge   stream.graphics.g4dn.4xlarge   stream.graphics.g4dn.8xlarge
   stream.graphics.g4dn.12xlarge   stream.graphics.g4dn.16xlarge
  stream.graphics-pro.4xlarge   stream.graphics-pro.8xlarge   stream.graphics-pro.16xlarge
  The following instance types are available for Elastic fleets:   stream.standard.small
  stream.standard.medium   stream.standard.large   stream.standard.xlarge
  stream.standard.2xlarge
- `name`: A unique name for the fleet.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ComputeCapacity"`: The desired capacity for the fleet. This is not allowed for Elastic
  fleets. For Elastic fleets, specify MaxConcurrentSessions instead.
- `"Description"`: The description to display.
- `"DisconnectTimeoutInSeconds"`: The amount of time that a streaming session remains
  active after users disconnect. If users try to reconnect to the streaming session after a
  disconnection or network interruption within this time interval, they are connected to
  their previous session. Otherwise, they are connected to a new session with a new streaming
  instance.  Specify a value between 60 and 360000.
- `"DisplayName"`: The fleet name to display.
- `"DomainJoinInfo"`: The name of the directory and organizational unit (OU) to use to join
  the fleet to a Microsoft Active Directory domain. This is not allowed for Elastic fleets.
- `"EnableDefaultInternetAccess"`: Enables or disables default internet access for the
  fleet.
- `"FleetType"`: The fleet type.  ALWAYS_ON  Provides users with instant-on access to their
  apps. You are charged for all running instances in your fleet, even if no users are
  streaming apps.  ON_DEMAND  Provide users with access to applications after they connect,
  which takes one to two minutes. You are charged for instance streaming when users are
  connected and a small hourly fee for instances that are not streaming apps.
- `"IamRoleArn"`: The Amazon Resource Name (ARN) of the IAM role to apply to the fleet. To
  assume a role, a fleet instance calls the AWS Security Token Service (STS) AssumeRole API
  operation and passes the ARN of the role to use. The operation creates a new session with
  temporary credentials. AppStream 2.0 retrieves the temporary credentials and creates the
  appstream_machine_role credential profile on the instance. For more information, see Using
  an IAM Role to Grant Permissions to Applications and Scripts Running on AppStream 2.0
  Streaming Instances in the Amazon AppStream 2.0 Administration Guide.
- `"IdleDisconnectTimeoutInSeconds"`: The amount of time that users can be idle (inactive)
  before they are disconnected from their streaming session and the
  DisconnectTimeoutInSeconds time interval begins. Users are notified before they are
  disconnected due to inactivity. If they try to reconnect to the streaming session before
  the time interval specified in DisconnectTimeoutInSeconds elapses, they are connected to
  their previous session. Users are considered idle when they stop providing keyboard or
  mouse input during their streaming session. File uploads and downloads, audio in, audio
  out, and pixels changing do not qualify as user activity. If users continue to be idle
  after the time interval in IdleDisconnectTimeoutInSeconds elapses, they are disconnected.
  To prevent users from being disconnected due to inactivity, specify a value of 0.
  Otherwise, specify a value between 60 and 3600. The default value is 0.  If you enable this
  feature, we recommend that you specify a value that corresponds exactly to a whole number
  of minutes (for example, 60, 120, and 180). If you don't do this, the value is rounded to
  the nearest minute. For example, if you specify a value of 70, users are disconnected after
  1 minute of inactivity. If you specify a value that is at the midpoint between two
  different minutes, the value is rounded up. For example, if you specify a value of 90,
  users are disconnected after 2 minutes of inactivity.
- `"ImageArn"`: The ARN of the public, private, or shared image to use.
- `"ImageName"`: The name of the image used to create the fleet.
- `"MaxConcurrentSessions"`: The maximum concurrent sessions of the Elastic fleet. This is
  required for Elastic fleets, and not allowed for other fleet types.
- `"MaxSessionsPerInstance"`: The maximum number of user sessions on an instance. This only
  applies to multi-session fleets.
- `"MaxUserDurationInSeconds"`: The maximum amount of time that a streaming session can
  remain active, in seconds. If users are still connected to a streaming instance five
  minutes before this limit is reached, they are prompted to save any open documents before
  being disconnected. After this time elapses, the instance is terminated and replaced by a
  new instance. Specify a value between 600 and 432000.
- `"Platform"`: The fleet platform. WINDOWS_SERVER_2019 and AMAZON_LINUX2 are supported for
  Elastic fleets.
- `"SessionScriptS3Location"`: The S3 location of the session scripts configuration zip
  file. This only applies to Elastic fleets.
- `"StreamView"`: The AppStream 2.0 view that is displayed to your users when they stream
  from the fleet. When APP is specified, only the windows of applications opened by users
  display. When DESKTOP is specified, the standard desktop that is provided by the operating
  system displays. The default value is APP.
- `"Tags"`: The tags to associate with the fleet. A tag is a key-value pair, and the value
  is optional. For example, Environment=Test. If you do not specify a value, Environment=.
  If you do not specify a value, the value is set to an empty string. Generally allowed
  characters are: letters, numbers, and spaces representable in UTF-8, and the following
  special characters:  _ . : / = +  - @ For more information, see Tagging Your Resources in
  the Amazon AppStream 2.0 Administration Guide.
- `"UsbDeviceFilterStrings"`: The USB device filter strings that specify which USB devices
  a user can redirect to the fleet streaming session, when using the Windows native client.
  This is allowed but not required for Elastic fleets.
- `"VpcConfig"`: The VPC configuration for the fleet. This is required for Elastic fleets,
  but not required for other fleet types. Elastic fleets require that you specify at least
  two subnets in different availability zones.
"""
function create_fleet(
    InstanceType, Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "CreateFleet",
        Dict{String,Any}("InstanceType" => InstanceType, "Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_fleet(
    InstanceType,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appstream(
        "CreateFleet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("InstanceType" => InstanceType, "Name" => Name),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_image_builder(instance_type, name)
    create_image_builder(instance_type, name, params::Dict{String,<:Any})

Creates an image builder. An image builder is a virtual machine that is used to create an
image. The initial state of the builder is PENDING. When it is ready, the state is RUNNING.

# Arguments
- `instance_type`: The instance type to use when launching the image builder. The following
  instance types are available:   stream.standard.small   stream.standard.medium
  stream.standard.large   stream.compute.large   stream.compute.xlarge
  stream.compute.2xlarge   stream.compute.4xlarge   stream.compute.8xlarge
  stream.memory.large   stream.memory.xlarge   stream.memory.2xlarge   stream.memory.4xlarge
   stream.memory.8xlarge   stream.memory.z1d.large   stream.memory.z1d.xlarge
  stream.memory.z1d.2xlarge   stream.memory.z1d.3xlarge   stream.memory.z1d.6xlarge
  stream.memory.z1d.12xlarge   stream.graphics-design.large   stream.graphics-design.xlarge
  stream.graphics-design.2xlarge   stream.graphics-design.4xlarge
  stream.graphics-desktop.2xlarge   stream.graphics.g4dn.xlarge
  stream.graphics.g4dn.2xlarge   stream.graphics.g4dn.4xlarge   stream.graphics.g4dn.8xlarge
   stream.graphics.g4dn.12xlarge   stream.graphics.g4dn.16xlarge
  stream.graphics-pro.4xlarge   stream.graphics-pro.8xlarge   stream.graphics-pro.16xlarge
- `name`: A unique name for the image builder.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccessEndpoints"`: The list of interface VPC endpoint (interface endpoint) objects.
  Administrators can connect to the image builder only through the specified endpoints.
- `"AppstreamAgentVersion"`: The version of the AppStream 2.0 agent to use for this image
  builder. To use the latest version of the AppStream 2.0 agent, specify [LATEST].
- `"Description"`: The description to display.
- `"DisplayName"`: The image builder name to display.
- `"DomainJoinInfo"`: The name of the directory and organizational unit (OU) to use to join
  the image builder to a Microsoft Active Directory domain.
- `"EnableDefaultInternetAccess"`: Enables or disables default internet access for the
  image builder.
- `"IamRoleArn"`: The Amazon Resource Name (ARN) of the IAM role to apply to the image
  builder. To assume a role, the image builder calls the AWS Security Token Service (STS)
  AssumeRole API operation and passes the ARN of the role to use. The operation creates a new
  session with temporary credentials. AppStream 2.0 retrieves the temporary credentials and
  creates the appstream_machine_role credential profile on the instance. For more
  information, see Using an IAM Role to Grant Permissions to Applications and Scripts Running
  on AppStream 2.0 Streaming Instances in the Amazon AppStream 2.0 Administration Guide.
- `"ImageArn"`: The ARN of the public, private, or shared image to use.
- `"ImageName"`: The name of the image used to create the image builder.
- `"Tags"`: The tags to associate with the image builder. A tag is a key-value pair, and
  the value is optional. For example, Environment=Test. If you do not specify a value,
  Environment=.  Generally allowed characters are: letters, numbers, and spaces representable
  in UTF-8, and the following special characters:  _ . : / = +  - @ If you do not specify a
  value, the value is set to an empty string. For more information about tags, see Tagging
  Your Resources in the Amazon AppStream 2.0 Administration Guide.
- `"VpcConfig"`: The VPC configuration for the image builder. You can specify only one
  subnet.
"""
function create_image_builder(
    InstanceType, Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "CreateImageBuilder",
        Dict{String,Any}("InstanceType" => InstanceType, "Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_image_builder(
    InstanceType,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appstream(
        "CreateImageBuilder",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("InstanceType" => InstanceType, "Name" => Name),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_image_builder_streaming_url(name)
    create_image_builder_streaming_url(name, params::Dict{String,<:Any})

Creates a URL to start an image builder streaming session.

# Arguments
- `name`: The name of the image builder.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Validity"`: The time that the streaming URL will be valid, in seconds. Specify a value
  between 1 and 604800 seconds. The default is 3600 seconds.
"""
function create_image_builder_streaming_url(
    Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "CreateImageBuilderStreamingURL",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_image_builder_streaming_url(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "CreateImageBuilderStreamingURL",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_stack(name)
    create_stack(name, params::Dict{String,<:Any})

Creates a stack to start streaming applications to users. A stack consists of an associated
fleet, user access policies, and storage configurations.

# Arguments
- `name`: The name of the stack.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccessEndpoints"`: The list of interface VPC endpoint (interface endpoint) objects.
  Users of the stack can connect to AppStream 2.0 only through the specified endpoints.
- `"ApplicationSettings"`: The persistent application settings for users of a stack. When
  these settings are enabled, changes that users make to applications and Windows settings
  are automatically saved after each session and applied to the next session.
- `"Description"`: The description to display.
- `"DisplayName"`: The stack name to display.
- `"EmbedHostDomains"`: The domains where AppStream 2.0 streaming sessions can be embedded
  in an iframe. You must approve the domains that you want to host embedded AppStream 2.0
  streaming sessions.
- `"FeedbackURL"`: The URL that users are redirected to after they click the Send Feedback
  link. If no URL is specified, no Send Feedback link is displayed.
- `"RedirectURL"`: The URL that users are redirected to after their streaming session ends.
- `"StorageConnectors"`: The storage connectors to enable.
- `"StreamingExperienceSettings"`: The streaming protocol you want your stack to prefer.
  This can be UDP or TCP. Currently, UDP is only supported in the Windows native client.
- `"Tags"`: The tags to associate with the stack. A tag is a key-value pair, and the value
  is optional. For example, Environment=Test. If you do not specify a value, Environment=.
  If you do not specify a value, the value is set to an empty string. Generally allowed
  characters are: letters, numbers, and spaces representable in UTF-8, and the following
  special characters:  _ . : / = +  - @ For more information about tags, see Tagging Your
  Resources in the Amazon AppStream 2.0 Administration Guide.
- `"UserSettings"`: The actions that are enabled or disabled for users during their
  streaming sessions. By default, these actions are enabled.
"""
function create_stack(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return appstream(
        "CreateStack",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_stack(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "CreateStack",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_streaming_url(fleet_name, stack_name, user_id)
    create_streaming_url(fleet_name, stack_name, user_id, params::Dict{String,<:Any})

Creates a temporary URL to start an AppStream 2.0 streaming session for the specified user.
A streaming URL enables application streaming to be tested without user setup.

# Arguments
- `fleet_name`: The name of the fleet.
- `stack_name`: The name of the stack.
- `user_id`: The identifier of the user.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ApplicationId"`: The name of the application to launch after the session starts. This
  is the name that you specified as Name in the Image Assistant. If your fleet is enabled for
  the Desktop stream view, you can also choose to launch directly to the operating system
  desktop. To do so, specify Desktop.
- `"SessionContext"`: The session context. For more information, see Session Context in the
  Amazon AppStream 2.0 Administration Guide.
- `"Validity"`: The time that the streaming URL will be valid, in seconds. Specify a value
  between 1 and 604800 seconds. The default is 60 seconds.
"""
function create_streaming_url(
    FleetName, StackName, UserId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "CreateStreamingURL",
        Dict{String,Any}(
            "FleetName" => FleetName, "StackName" => StackName, "UserId" => UserId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_streaming_url(
    FleetName,
    StackName,
    UserId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appstream(
        "CreateStreamingURL",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "FleetName" => FleetName, "StackName" => StackName, "UserId" => UserId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_updated_image(existing_image_name, new_image_name)
    create_updated_image(existing_image_name, new_image_name, params::Dict{String,<:Any})

Creates a new image with the latest Windows operating system updates, driver updates, and
AppStream 2.0 agent software. For more information, see the \"Update an Image by Using
Managed AppStream 2.0 Image Updates\" section in Administer Your AppStream 2.0 Images, in
the Amazon AppStream 2.0 Administration Guide.

# Arguments
- `existing_image_name`: The name of the image to update.
- `new_image_name`: The name of the new image. The name must be unique within the AWS
  account and Region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"dryRun"`: Indicates whether to display the status of image update availability before
  AppStream 2.0 initiates the process of creating a new updated image. If this value is set
  to true, AppStream 2.0 displays whether image updates are available. If this value is set
  to false, AppStream 2.0 initiates the process of creating a new updated image without
  displaying whether image updates are available.
- `"newImageDescription"`: The description to display for the new image.
- `"newImageDisplayName"`: The name to display for the new image.
- `"newImageTags"`: The tags to associate with the new image. A tag is a key-value pair,
  and the value is optional. For example, Environment=Test. If you do not specify a value,
  Environment=.  Generally allowed characters are: letters, numbers, and spaces representable
  in UTF-8, and the following special characters:  _ . : / = +  - @ If you do not specify a
  value, the value is set to an empty string. For more information about tags, see Tagging
  Your Resources in the Amazon AppStream 2.0 Administration Guide.
"""
function create_updated_image(
    existingImageName, newImageName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "CreateUpdatedImage",
        Dict{String,Any}(
            "existingImageName" => existingImageName, "newImageName" => newImageName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_updated_image(
    existingImageName,
    newImageName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appstream(
        "CreateUpdatedImage",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "existingImageName" => existingImageName, "newImageName" => newImageName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_usage_report_subscription()
    create_usage_report_subscription(params::Dict{String,<:Any})

Creates a usage report subscription. Usage reports are generated daily.

"""
function create_usage_report_subscription(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "CreateUsageReportSubscription";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_usage_report_subscription(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "CreateUsageReportSubscription",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_user(authentication_type, user_name)
    create_user(authentication_type, user_name, params::Dict{String,<:Any})

Creates a new user in the user pool.

# Arguments
- `authentication_type`: The authentication type for the user. You must specify USERPOOL.
- `user_name`: The email address of the user.  Users' email addresses are case-sensitive.
  During login, if they specify an email address that doesn't use the same capitalization as
  the email address specified when their user pool account was created, a \"user does not
  exist\" error message displays.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FirstName"`: The first name, or given name, of the user.
- `"LastName"`: The last name, or surname, of the user.
- `"MessageAction"`: The action to take for the welcome email that is sent to a user after
  the user is created in the user pool. If you specify SUPPRESS, no email is sent. If you
  specify RESEND, do not specify the first name or last name of the user. If the value is
  null, the email is sent.   The temporary password in the welcome email is valid for only 7
  days. If users don’t set their passwords within 7 days, you must send them a new welcome
  email.
"""
function create_user(
    AuthenticationType, UserName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "CreateUser",
        Dict{String,Any}(
            "AuthenticationType" => AuthenticationType, "UserName" => UserName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_user(
    AuthenticationType,
    UserName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appstream(
        "CreateUser",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AuthenticationType" => AuthenticationType, "UserName" => UserName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_app_block(name)
    delete_app_block(name, params::Dict{String,<:Any})

Deletes an app block.

# Arguments
- `name`: The name of the app block.

"""
function delete_app_block(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return appstream(
        "DeleteAppBlock",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_app_block(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "DeleteAppBlock",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_app_block_builder(name)
    delete_app_block_builder(name, params::Dict{String,<:Any})

Deletes an app block builder. An app block builder can only be deleted when it has no
association with an app block.

# Arguments
- `name`: The name of the app block builder.

"""
function delete_app_block_builder(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return appstream(
        "DeleteAppBlockBuilder",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_app_block_builder(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "DeleteAppBlockBuilder",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_application(name)
    delete_application(name, params::Dict{String,<:Any})

Deletes an application.

# Arguments
- `name`: The name of the application.

"""
function delete_application(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return appstream(
        "DeleteApplication",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_application(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "DeleteApplication",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_directory_config(directory_name)
    delete_directory_config(directory_name, params::Dict{String,<:Any})

Deletes the specified Directory Config object from AppStream 2.0. This object includes the
information required to join streaming instances to an Active Directory domain.

# Arguments
- `directory_name`: The name of the directory configuration.

"""
function delete_directory_config(
    DirectoryName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "DeleteDirectoryConfig",
        Dict{String,Any}("DirectoryName" => DirectoryName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_directory_config(
    DirectoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appstream(
        "DeleteDirectoryConfig",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DirectoryName" => DirectoryName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_entitlement(name, stack_name)
    delete_entitlement(name, stack_name, params::Dict{String,<:Any})

Deletes the specified entitlement.

# Arguments
- `name`: The name of the entitlement.
- `stack_name`: The name of the stack with which the entitlement is associated.

"""
function delete_entitlement(
    Name, StackName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "DeleteEntitlement",
        Dict{String,Any}("Name" => Name, "StackName" => StackName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_entitlement(
    Name,
    StackName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appstream(
        "DeleteEntitlement",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("Name" => Name, "StackName" => StackName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_fleet(name)
    delete_fleet(name, params::Dict{String,<:Any})

Deletes the specified fleet.

# Arguments
- `name`: The name of the fleet.

"""
function delete_fleet(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return appstream(
        "DeleteFleet",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_fleet(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "DeleteFleet",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_image(name)
    delete_image(name, params::Dict{String,<:Any})

Deletes the specified image. You cannot delete an image when it is in use. After you delete
an image, you cannot provision new capacity using the image.

# Arguments
- `name`: The name of the image.

"""
function delete_image(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return appstream(
        "DeleteImage",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_image(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "DeleteImage",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_image_builder(name)
    delete_image_builder(name, params::Dict{String,<:Any})

Deletes the specified image builder and releases the capacity.

# Arguments
- `name`: The name of the image builder.

"""
function delete_image_builder(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return appstream(
        "DeleteImageBuilder",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_image_builder(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "DeleteImageBuilder",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_image_permissions(name, shared_account_id)
    delete_image_permissions(name, shared_account_id, params::Dict{String,<:Any})

Deletes permissions for the specified private image. After you delete permissions for an
image, AWS accounts to which you previously granted these permissions can no longer use the
image.

# Arguments
- `name`: The name of the private image.
- `shared_account_id`: The 12-digit identifier of the AWS account for which to delete image
  permissions.

"""
function delete_image_permissions(
    Name, SharedAccountId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "DeleteImagePermissions",
        Dict{String,Any}("Name" => Name, "SharedAccountId" => SharedAccountId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_image_permissions(
    Name,
    SharedAccountId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appstream(
        "DeleteImagePermissions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Name" => Name, "SharedAccountId" => SharedAccountId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_stack(name)
    delete_stack(name, params::Dict{String,<:Any})

Deletes the specified stack. After the stack is deleted, the application streaming
environment provided by the stack is no longer available to users. Also, any reservations
made for application streaming sessions for the stack are released.

# Arguments
- `name`: The name of the stack.

"""
function delete_stack(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return appstream(
        "DeleteStack",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_stack(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "DeleteStack",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_usage_report_subscription()
    delete_usage_report_subscription(params::Dict{String,<:Any})

Disables usage report generation.

"""
function delete_usage_report_subscription(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "DeleteUsageReportSubscription";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_usage_report_subscription(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "DeleteUsageReportSubscription",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_user(authentication_type, user_name)
    delete_user(authentication_type, user_name, params::Dict{String,<:Any})

Deletes a user from the user pool.

# Arguments
- `authentication_type`: The authentication type for the user. You must specify USERPOOL.
- `user_name`: The email address of the user.  Users' email addresses are case-sensitive.

"""
function delete_user(
    AuthenticationType, UserName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "DeleteUser",
        Dict{String,Any}(
            "AuthenticationType" => AuthenticationType, "UserName" => UserName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_user(
    AuthenticationType,
    UserName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appstream(
        "DeleteUser",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AuthenticationType" => AuthenticationType, "UserName" => UserName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_app_block_builder_app_block_associations()
    describe_app_block_builder_app_block_associations(params::Dict{String,<:Any})

Retrieves a list that describes one or more app block builder associations.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AppBlockArn"`: The ARN of the app block.
- `"AppBlockBuilderName"`: The name of the app block builder.
- `"MaxResults"`: The maximum size of each page of results.
- `"NextToken"`: The pagination token used to retrieve the next page of results for this
  operation.
"""
function describe_app_block_builder_app_block_associations(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "DescribeAppBlockBuilderAppBlockAssociations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_app_block_builder_app_block_associations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "DescribeAppBlockBuilderAppBlockAssociations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_app_block_builders()
    describe_app_block_builders(params::Dict{String,<:Any})

Retrieves a list that describes one or more app block builders.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum size of each page of results. The maximum value is 25.
- `"Names"`: The names of the app block builders.
- `"NextToken"`: The pagination token used to retrieve the next page of results for this
  operation.
"""
function describe_app_block_builders(; aws_config::AbstractAWSConfig=current_aws_config())
    return appstream(
        "DescribeAppBlockBuilders"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_app_block_builders(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "DescribeAppBlockBuilders",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_app_blocks()
    describe_app_blocks(params::Dict{String,<:Any})

Retrieves a list that describes one or more app blocks.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Arns"`: The ARNs of the app blocks.
- `"MaxResults"`: The maximum size of each page of results.
- `"NextToken"`: The pagination token used to retrieve the next page of results for this
  operation.
"""
function describe_app_blocks(; aws_config::AbstractAWSConfig=current_aws_config())
    return appstream(
        "DescribeAppBlocks"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_app_blocks(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "DescribeAppBlocks", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_application_fleet_associations()
    describe_application_fleet_associations(params::Dict{String,<:Any})

Retrieves a list that describes one or more application fleet associations. Either
ApplicationArn or FleetName must be specified.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ApplicationArn"`: The ARN of the application.
- `"FleetName"`: The name of the fleet.
- `"MaxResults"`: The maximum size of each page of results.
- `"NextToken"`: The pagination token used to retrieve the next page of results for this
  operation.
"""
function describe_application_fleet_associations(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "DescribeApplicationFleetAssociations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_application_fleet_associations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "DescribeApplicationFleetAssociations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_applications()
    describe_applications(params::Dict{String,<:Any})

Retrieves a list that describes one or more applications.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Arns"`: The ARNs for the applications.
- `"MaxResults"`: The maximum size of each page of results.
- `"NextToken"`: The pagination token used to retrieve the next page of results for this
  operation.
"""
function describe_applications(; aws_config::AbstractAWSConfig=current_aws_config())
    return appstream(
        "DescribeApplications"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_applications(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "DescribeApplications",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_directory_configs()
    describe_directory_configs(params::Dict{String,<:Any})

Retrieves a list that describes one or more specified Directory Config objects for
AppStream 2.0, if the names for these objects are provided. Otherwise, all Directory Config
objects in the account are described. These objects include the configuration information
required to join fleets and image builders to Microsoft Active Directory domains.  Although
the response syntax in this topic includes the account password, this password is not
returned in the actual response.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DirectoryNames"`: The directory names.
- `"MaxResults"`: The maximum size of each page of results.
- `"NextToken"`: The pagination token to use to retrieve the next page of results for this
  operation. If this value is null, it retrieves the first page.
"""
function describe_directory_configs(; aws_config::AbstractAWSConfig=current_aws_config())
    return appstream(
        "DescribeDirectoryConfigs"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_directory_configs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "DescribeDirectoryConfigs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_entitlements(stack_name)
    describe_entitlements(stack_name, params::Dict{String,<:Any})

Retrieves a list that describes one of more entitlements.

# Arguments
- `stack_name`: The name of the stack with which the entitlement is associated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum size of each page of results.
- `"Name"`: The name of the entitlement.
- `"NextToken"`: The pagination token used to retrieve the next page of results for this
  operation.
"""
function describe_entitlements(
    StackName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "DescribeEntitlements",
        Dict{String,Any}("StackName" => StackName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_entitlements(
    StackName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appstream(
        "DescribeEntitlements",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("StackName" => StackName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_fleets()
    describe_fleets(params::Dict{String,<:Any})

Retrieves a list that describes one or more specified fleets, if the fleet names are
provided. Otherwise, all fleets in the account are described.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Names"`: The names of the fleets to describe.
- `"NextToken"`: The pagination token to use to retrieve the next page of results for this
  operation. If this value is null, it retrieves the first page.
"""
function describe_fleets(; aws_config::AbstractAWSConfig=current_aws_config())
    return appstream(
        "DescribeFleets"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_fleets(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "DescribeFleets", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_image_builders()
    describe_image_builders(params::Dict{String,<:Any})

Retrieves a list that describes one or more specified image builders, if the image builder
names are provided. Otherwise, all image builders in the account are described.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum size of each page of results.
- `"Names"`: The names of the image builders to describe.
- `"NextToken"`: The pagination token to use to retrieve the next page of results for this
  operation. If this value is null, it retrieves the first page.
"""
function describe_image_builders(; aws_config::AbstractAWSConfig=current_aws_config())
    return appstream(
        "DescribeImageBuilders"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_image_builders(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "DescribeImageBuilders",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_image_permissions(name)
    describe_image_permissions(name, params::Dict{String,<:Any})

Retrieves a list that describes the permissions for shared AWS account IDs on a private
image that you own.

# Arguments
- `name`: The name of the private image for which to describe permissions. The image must
  be one that you own.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum size of each page of results.
- `"NextToken"`: The pagination token to use to retrieve the next page of results for this
  operation. If this value is null, it retrieves the first page.
- `"SharedAwsAccountIds"`: The 12-digit identifier of one or more AWS accounts with which
  the image is shared.
"""
function describe_image_permissions(
    Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "DescribeImagePermissions",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_image_permissions(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "DescribeImagePermissions",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_images()
    describe_images(params::Dict{String,<:Any})

Retrieves a list that describes one or more specified images, if the image names or image
ARNs are provided. Otherwise, all images in the account are described.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Arns"`: The ARNs of the public, private, and shared images to describe.
- `"MaxResults"`: The maximum size of each page of results.
- `"Names"`: The names of the public or private images to describe.
- `"NextToken"`: The pagination token to use to retrieve the next page of results for this
  operation. If this value is null, it retrieves the first page.
- `"Type"`: The type of image (public, private, or shared) to describe.
"""
function describe_images(; aws_config::AbstractAWSConfig=current_aws_config())
    return appstream(
        "DescribeImages"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_images(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "DescribeImages", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_sessions(fleet_name, stack_name)
    describe_sessions(fleet_name, stack_name, params::Dict{String,<:Any})

Retrieves a list that describes the streaming sessions for a specified stack and fleet. If
a UserId is provided for the stack and fleet, only streaming sessions for that user are
described. If an authentication type is not provided, the default is to authenticate users
using a streaming URL.

# Arguments
- `fleet_name`: The name of the fleet. This value is case-sensitive.
- `stack_name`: The name of the stack. This value is case-sensitive.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AuthenticationType"`: The authentication method. Specify API for a user authenticated
  using a streaming URL or SAML for a SAML federated user. The default is to authenticate
  users using a streaming URL.
- `"InstanceId"`: The identifier for the instance hosting the session.
- `"Limit"`: The size of each page of results. The default value is 20 and the maximum
  value is 50.
- `"NextToken"`: The pagination token to use to retrieve the next page of results for this
  operation. If this value is null, it retrieves the first page.
- `"UserId"`: The user identifier (ID). If you specify a user ID, you must also specify the
  authentication type.
"""
function describe_sessions(
    FleetName, StackName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "DescribeSessions",
        Dict{String,Any}("FleetName" => FleetName, "StackName" => StackName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_sessions(
    FleetName,
    StackName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appstream(
        "DescribeSessions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("FleetName" => FleetName, "StackName" => StackName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_stacks()
    describe_stacks(params::Dict{String,<:Any})

Retrieves a list that describes one or more specified stacks, if the stack names are
provided. Otherwise, all stacks in the account are described.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Names"`: The names of the stacks to describe.
- `"NextToken"`: The pagination token to use to retrieve the next page of results for this
  operation. If this value is null, it retrieves the first page.
"""
function describe_stacks(; aws_config::AbstractAWSConfig=current_aws_config())
    return appstream(
        "DescribeStacks"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_stacks(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "DescribeStacks", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_usage_report_subscriptions()
    describe_usage_report_subscriptions(params::Dict{String,<:Any})

Retrieves a list that describes one or more usage report subscriptions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum size of each page of results.
- `"NextToken"`: The pagination token to use to retrieve the next page of results for this
  operation. If this value is null, it retrieves the first page.
"""
function describe_usage_report_subscriptions(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "DescribeUsageReportSubscriptions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_usage_report_subscriptions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "DescribeUsageReportSubscriptions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_user_stack_associations()
    describe_user_stack_associations(params::Dict{String,<:Any})

Retrieves a list that describes the UserStackAssociation objects. You must specify either
or both of the following:   The stack name   The user name (email address of the user
associated with the stack) and the authentication type for the user

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AuthenticationType"`: The authentication type for the user who is associated with the
  stack. You must specify USERPOOL.
- `"MaxResults"`: The maximum size of each page of results.
- `"NextToken"`: The pagination token to use to retrieve the next page of results for this
  operation. If this value is null, it retrieves the first page.
- `"StackName"`: The name of the stack that is associated with the user.
- `"UserName"`: The email address of the user who is associated with the stack.  Users'
  email addresses are case-sensitive.
"""
function describe_user_stack_associations(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "DescribeUserStackAssociations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_user_stack_associations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "DescribeUserStackAssociations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_users(authentication_type)
    describe_users(authentication_type, params::Dict{String,<:Any})

Retrieves a list that describes one or more specified users in the user pool.

# Arguments
- `authentication_type`: The authentication type for the users in the user pool to
  describe. You must specify USERPOOL.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum size of each page of results.
- `"NextToken"`: The pagination token to use to retrieve the next page of results for this
  operation. If this value is null, it retrieves the first page.
"""
function describe_users(
    AuthenticationType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "DescribeUsers",
        Dict{String,Any}("AuthenticationType" => AuthenticationType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_users(
    AuthenticationType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appstream(
        "DescribeUsers",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("AuthenticationType" => AuthenticationType), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disable_user(authentication_type, user_name)
    disable_user(authentication_type, user_name, params::Dict{String,<:Any})

Disables the specified user in the user pool. Users can't sign in to AppStream 2.0 until
they are re-enabled. This action does not delete the user.

# Arguments
- `authentication_type`: The authentication type for the user. You must specify USERPOOL.
- `user_name`: The email address of the user.  Users' email addresses are case-sensitive.

"""
function disable_user(
    AuthenticationType, UserName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "DisableUser",
        Dict{String,Any}(
            "AuthenticationType" => AuthenticationType, "UserName" => UserName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disable_user(
    AuthenticationType,
    UserName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appstream(
        "DisableUser",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AuthenticationType" => AuthenticationType, "UserName" => UserName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_app_block_builder_app_block(app_block_arn, app_block_builder_name)
    disassociate_app_block_builder_app_block(app_block_arn, app_block_builder_name, params::Dict{String,<:Any})

Disassociates a specified app block builder from a specified app block.

# Arguments
- `app_block_arn`: The ARN of the app block.
- `app_block_builder_name`: The name of the app block builder.

"""
function disassociate_app_block_builder_app_block(
    AppBlockArn, AppBlockBuilderName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "DisassociateAppBlockBuilderAppBlock",
        Dict{String,Any}(
            "AppBlockArn" => AppBlockArn, "AppBlockBuilderName" => AppBlockBuilderName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_app_block_builder_app_block(
    AppBlockArn,
    AppBlockBuilderName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appstream(
        "DisassociateAppBlockBuilderAppBlock",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AppBlockArn" => AppBlockArn,
                    "AppBlockBuilderName" => AppBlockBuilderName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_application_fleet(application_arn, fleet_name)
    disassociate_application_fleet(application_arn, fleet_name, params::Dict{String,<:Any})

Disassociates the specified application from the fleet.

# Arguments
- `application_arn`: The ARN of the application.
- `fleet_name`: The name of the fleet.

"""
function disassociate_application_fleet(
    ApplicationArn, FleetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "DisassociateApplicationFleet",
        Dict{String,Any}("ApplicationArn" => ApplicationArn, "FleetName" => FleetName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_application_fleet(
    ApplicationArn,
    FleetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appstream(
        "DisassociateApplicationFleet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationArn" => ApplicationArn, "FleetName" => FleetName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_application_from_entitlement(application_identifier, entitlement_name, stack_name)
    disassociate_application_from_entitlement(application_identifier, entitlement_name, stack_name, params::Dict{String,<:Any})

Deletes the specified application from the specified entitlement.

# Arguments
- `application_identifier`: The identifier of the application to remove from the
  entitlement.
- `entitlement_name`: The name of the entitlement.
- `stack_name`: The name of the stack with which the entitlement is associated.

"""
function disassociate_application_from_entitlement(
    ApplicationIdentifier,
    EntitlementName,
    StackName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appstream(
        "DisassociateApplicationFromEntitlement",
        Dict{String,Any}(
            "ApplicationIdentifier" => ApplicationIdentifier,
            "EntitlementName" => EntitlementName,
            "StackName" => StackName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_application_from_entitlement(
    ApplicationIdentifier,
    EntitlementName,
    StackName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appstream(
        "DisassociateApplicationFromEntitlement",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationIdentifier" => ApplicationIdentifier,
                    "EntitlementName" => EntitlementName,
                    "StackName" => StackName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_fleet(fleet_name, stack_name)
    disassociate_fleet(fleet_name, stack_name, params::Dict{String,<:Any})

Disassociates the specified fleet from the specified stack.

# Arguments
- `fleet_name`: The name of the fleet.
- `stack_name`: The name of the stack.

"""
function disassociate_fleet(
    FleetName, StackName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "DisassociateFleet",
        Dict{String,Any}("FleetName" => FleetName, "StackName" => StackName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_fleet(
    FleetName,
    StackName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appstream(
        "DisassociateFleet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("FleetName" => FleetName, "StackName" => StackName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    enable_user(authentication_type, user_name)
    enable_user(authentication_type, user_name, params::Dict{String,<:Any})

Enables a user in the user pool. After being enabled, users can sign in to AppStream 2.0
and open applications from the stacks to which they are assigned.

# Arguments
- `authentication_type`: The authentication type for the user. You must specify USERPOOL.
- `user_name`: The email address of the user.  Users' email addresses are case-sensitive.
  During login, if they specify an email address that doesn't use the same capitalization as
  the email address specified when their user pool account was created, a \"user does not
  exist\" error message displays.

"""
function enable_user(
    AuthenticationType, UserName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "EnableUser",
        Dict{String,Any}(
            "AuthenticationType" => AuthenticationType, "UserName" => UserName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function enable_user(
    AuthenticationType,
    UserName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appstream(
        "EnableUser",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AuthenticationType" => AuthenticationType, "UserName" => UserName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    expire_session(session_id)
    expire_session(session_id, params::Dict{String,<:Any})

Immediately stops the specified streaming session.

# Arguments
- `session_id`: The identifier of the streaming session.

"""
function expire_session(SessionId; aws_config::AbstractAWSConfig=current_aws_config())
    return appstream(
        "ExpireSession",
        Dict{String,Any}("SessionId" => SessionId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function expire_session(
    SessionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appstream(
        "ExpireSession",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("SessionId" => SessionId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_associated_fleets(stack_name)
    list_associated_fleets(stack_name, params::Dict{String,<:Any})

Retrieves the name of the fleet that is associated with the specified stack.

# Arguments
- `stack_name`: The name of the stack.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: The pagination token to use to retrieve the next page of results for this
  operation. If this value is null, it retrieves the first page.
"""
function list_associated_fleets(
    StackName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "ListAssociatedFleets",
        Dict{String,Any}("StackName" => StackName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_associated_fleets(
    StackName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appstream(
        "ListAssociatedFleets",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("StackName" => StackName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_associated_stacks(fleet_name)
    list_associated_stacks(fleet_name, params::Dict{String,<:Any})

Retrieves the name of the stack with which the specified fleet is associated.

# Arguments
- `fleet_name`: The name of the fleet.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: The pagination token to use to retrieve the next page of results for this
  operation. If this value is null, it retrieves the first page.
"""
function list_associated_stacks(
    FleetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "ListAssociatedStacks",
        Dict{String,Any}("FleetName" => FleetName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_associated_stacks(
    FleetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appstream(
        "ListAssociatedStacks",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("FleetName" => FleetName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_entitled_applications(entitlement_name, stack_name)
    list_entitled_applications(entitlement_name, stack_name, params::Dict{String,<:Any})

Retrieves a list of entitled applications.

# Arguments
- `entitlement_name`: The name of the entitlement.
- `stack_name`: The name of the stack with which the entitlement is associated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum size of each page of results.
- `"NextToken"`: The pagination token used to retrieve the next page of results for this
  operation.
"""
function list_entitled_applications(
    EntitlementName, StackName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "ListEntitledApplications",
        Dict{String,Any}("EntitlementName" => EntitlementName, "StackName" => StackName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_entitled_applications(
    EntitlementName,
    StackName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appstream(
        "ListEntitledApplications",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EntitlementName" => EntitlementName, "StackName" => StackName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Retrieves a list of all tags for the specified AppStream 2.0 resource. You can tag
AppStream 2.0 image builders, images, fleets, and stacks. For more information about tags,
see Tagging Your Resources in the Amazon AppStream 2.0 Administration Guide.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.

"""
function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "ListTagsForResource",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appstream(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_app_block_builder(name)
    start_app_block_builder(name, params::Dict{String,<:Any})

Starts an app block builder. An app block builder can only be started when it's associated
with an app block. Starting an app block builder starts a new instance, which is equivalent
to an elastic fleet instance with application builder assistance functionality.

# Arguments
- `name`: The name of the app block builder.

"""
function start_app_block_builder(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return appstream(
        "StartAppBlockBuilder",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_app_block_builder(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "StartAppBlockBuilder",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_fleet(name)
    start_fleet(name, params::Dict{String,<:Any})

Starts the specified fleet.

# Arguments
- `name`: The name of the fleet.

"""
function start_fleet(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return appstream(
        "StartFleet",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_fleet(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "StartFleet",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_image_builder(name)
    start_image_builder(name, params::Dict{String,<:Any})

Starts the specified image builder.

# Arguments
- `name`: The name of the image builder.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AppstreamAgentVersion"`: The version of the AppStream 2.0 agent to use for this image
  builder. To use the latest version of the AppStream 2.0 agent, specify [LATEST].
"""
function start_image_builder(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return appstream(
        "StartImageBuilder",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_image_builder(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "StartImageBuilder",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_app_block_builder(name)
    stop_app_block_builder(name, params::Dict{String,<:Any})

Stops an app block builder. Stopping an app block builder terminates the instance, and the
instance state is not persisted.

# Arguments
- `name`: The name of the app block builder.

"""
function stop_app_block_builder(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return appstream(
        "StopAppBlockBuilder",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_app_block_builder(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "StopAppBlockBuilder",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_fleet(name)
    stop_fleet(name, params::Dict{String,<:Any})

Stops the specified fleet.

# Arguments
- `name`: The name of the fleet.

"""
function stop_fleet(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return appstream(
        "StopFleet",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_fleet(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "StopFleet",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_image_builder(name)
    stop_image_builder(name, params::Dict{String,<:Any})

Stops the specified image builder.

# Arguments
- `name`: The name of the image builder.

"""
function stop_image_builder(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return appstream(
        "StopImageBuilder",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_image_builder(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "StopImageBuilder",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds or overwrites one or more tags for the specified AppStream 2.0 resource. You can tag
AppStream 2.0 image builders, images, fleets, and stacks. Each tag consists of a key and an
optional value. If a resource already has a tag with the same key, this operation updates
its value. To list the current tags for your resources, use ListTagsForResource. To
disassociate tags from your resources, use UntagResource. For more information about tags,
see Tagging Your Resources in the Amazon AppStream 2.0 Administration Guide.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.
- `tags`: The tags to associate. A tag is a key-value pair, and the value is optional. For
  example, Environment=Test. If you do not specify a value, Environment=.  If you do not
  specify a value, the value is set to an empty string. Generally allowed characters are:
  letters, numbers, and spaces representable in UTF-8, and the following special characters:
  _ . : / = +  - @

"""
function tag_resource(ResourceArn, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return appstream(
        "TagResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceArn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appstream(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Disassociates one or more specified tags from the specified AppStream 2.0 resource. To list
the current tags for your resources, use ListTagsForResource. For more information about
tags, see Tagging Your Resources in the Amazon AppStream 2.0 Administration Guide.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.
- `tag_keys`: The tag keys for the tags to disassociate.

"""
function untag_resource(
    ResourceArn, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "UntagResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceArn,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appstream(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_app_block_builder(name)
    update_app_block_builder(name, params::Dict{String,<:Any})

Updates an app block builder. If the app block builder is in the STARTING or STOPPING
state, you can't update it. If the app block builder is in the RUNNING state, you can only
update the DisplayName and Description. If the app block builder is in the STOPPED state,
you can update any attribute except the Name.

# Arguments
- `name`: The unique name for the app block builder.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccessEndpoints"`: The list of interface VPC endpoint (interface endpoint) objects.
  Administrators can connect to the app block builder only through the specified endpoints.
- `"AttributesToDelete"`: The attributes to delete from the app block builder.
- `"Description"`: The description of the app block builder.
- `"DisplayName"`: The display name of the app block builder.
- `"EnableDefaultInternetAccess"`: Enables or disables default internet access for the app
  block builder.
- `"IamRoleArn"`: The Amazon Resource Name (ARN) of the IAM role to apply to the app block
  builder. To assume a role, the app block builder calls the AWS Security Token Service (STS)
  AssumeRole API operation and passes the ARN of the role to use. The operation creates a new
  session with temporary credentials. AppStream 2.0 retrieves the temporary credentials and
  creates the appstream_machine_role credential profile on the instance. For more
  information, see Using an IAM Role to Grant Permissions to Applications and Scripts Running
  on AppStream 2.0 Streaming Instances in the Amazon AppStream 2.0 Administration Guide.
- `"InstanceType"`: The instance type to use when launching the app block builder. The
  following instance types are available:   stream.standard.small   stream.standard.medium
  stream.standard.large   stream.standard.xlarge   stream.standard.2xlarge
- `"Platform"`: The platform of the app block builder.  WINDOWS_SERVER_2019 is the only
  valid value.
- `"VpcConfig"`: The VPC configuration for the app block builder. App block builders
  require that you specify at least two subnets in different availability zones.
"""
function update_app_block_builder(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return appstream(
        "UpdateAppBlockBuilder",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_app_block_builder(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "UpdateAppBlockBuilder",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_application(name)
    update_application(name, params::Dict{String,<:Any})

Updates the specified application.

# Arguments
- `name`: The name of the application. This name is visible to users when display name is
  not specified.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AppBlockArn"`: The ARN of the app block.
- `"AttributesToDelete"`: The attributes to delete for an application.
- `"Description"`: The description of the application.
- `"DisplayName"`: The display name of the application. This name is visible to users in
  the application catalog.
- `"IconS3Location"`: The icon S3 location of the application.
- `"LaunchParameters"`: The launch parameters of the application.
- `"LaunchPath"`: The launch path of the application.
- `"WorkingDirectory"`: The working directory of the application.
"""
function update_application(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return appstream(
        "UpdateApplication",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_application(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "UpdateApplication",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_directory_config(directory_name)
    update_directory_config(directory_name, params::Dict{String,<:Any})

Updates the specified Directory Config object in AppStream 2.0. This object includes the
configuration information required to join fleets and image builders to Microsoft Active
Directory domains.

# Arguments
- `directory_name`: The name of the Directory Config object.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CertificateBasedAuthProperties"`: The certificate-based authentication properties used
  to authenticate SAML 2.0 Identity Provider (IdP) user identities to Active Directory
  domain-joined streaming instances. Fallback is turned on by default when certificate-based
  authentication is Enabled . Fallback allows users to log in using their AD domain password
  if certificate-based authentication is unsuccessful, or to unlock a desktop lock screen.
  Enabled_no_directory_login_fallback enables certificate-based authentication, but does not
  allow users to log in using their AD domain password. Users will be disconnected to
  re-authenticate using certificates.
- `"OrganizationalUnitDistinguishedNames"`: The distinguished names of the organizational
  units for computer accounts.
- `"ServiceAccountCredentials"`: The credentials for the service account used by the fleet
  or image builder to connect to the directory.
"""
function update_directory_config(
    DirectoryName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "UpdateDirectoryConfig",
        Dict{String,Any}("DirectoryName" => DirectoryName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_directory_config(
    DirectoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appstream(
        "UpdateDirectoryConfig",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DirectoryName" => DirectoryName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_entitlement(name, stack_name)
    update_entitlement(name, stack_name, params::Dict{String,<:Any})

Updates the specified entitlement.

# Arguments
- `name`: The name of the entitlement.
- `stack_name`: The name of the stack with which the entitlement is associated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AppVisibility"`: Specifies whether all or only selected apps are entitled.
- `"Attributes"`: The attributes of the entitlement.
- `"Description"`: The description of the entitlement.
"""
function update_entitlement(
    Name, StackName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "UpdateEntitlement",
        Dict{String,Any}("Name" => Name, "StackName" => StackName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_entitlement(
    Name,
    StackName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appstream(
        "UpdateEntitlement",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("Name" => Name, "StackName" => StackName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_fleet()
    update_fleet(params::Dict{String,<:Any})

Updates the specified fleet. If the fleet is in the STOPPED state, you can update any
attribute except the fleet name. If the fleet is in the RUNNING state, you can update the
following based on the fleet type:   Always-On and On-Demand fleet types You can update the
DisplayName, ComputeCapacity, ImageARN, ImageName, IdleDisconnectTimeoutInSeconds, and
DisconnectTimeoutInSeconds attributes.   Elastic fleet type You can update the DisplayName,
IdleDisconnectTimeoutInSeconds, DisconnectTimeoutInSeconds, MaxConcurrentSessions,
SessionScriptS3Location and UsbDeviceFilterStrings attributes.   If the fleet is in the
STARTING or STOPPED state, you can't update it.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AttributesToDelete"`: The fleet attributes to delete.
- `"ComputeCapacity"`: The desired capacity for the fleet. This is not allowed for Elastic
  fleets.
- `"DeleteVpcConfig"`: Deletes the VPC association for the specified fleet.
- `"Description"`: The description to display.
- `"DisconnectTimeoutInSeconds"`: The amount of time that a streaming session remains
  active after users disconnect. If users try to reconnect to the streaming session after a
  disconnection or network interruption within this time interval, they are connected to
  their previous session. Otherwise, they are connected to a new session with a new streaming
  instance.  Specify a value between 60 and 360000.
- `"DisplayName"`: The fleet name to display.
- `"DomainJoinInfo"`: The name of the directory and organizational unit (OU) to use to join
  the fleet to a Microsoft Active Directory domain.
- `"EnableDefaultInternetAccess"`: Enables or disables default internet access for the
  fleet.
- `"IamRoleArn"`: The Amazon Resource Name (ARN) of the IAM role to apply to the fleet. To
  assume a role, a fleet instance calls the AWS Security Token Service (STS) AssumeRole API
  operation and passes the ARN of the role to use. The operation creates a new session with
  temporary credentials. AppStream 2.0 retrieves the temporary credentials and creates the
  appstream_machine_role credential profile on the instance. For more information, see Using
  an IAM Role to Grant Permissions to Applications and Scripts Running on AppStream 2.0
  Streaming Instances in the Amazon AppStream 2.0 Administration Guide.
- `"IdleDisconnectTimeoutInSeconds"`: The amount of time that users can be idle (inactive)
  before they are disconnected from their streaming session and the
  DisconnectTimeoutInSeconds time interval begins. Users are notified before they are
  disconnected due to inactivity. If users try to reconnect to the streaming session before
  the time interval specified in DisconnectTimeoutInSeconds elapses, they are connected to
  their previous session. Users are considered idle when they stop providing keyboard or
  mouse input during their streaming session. File uploads and downloads, audio in, audio
  out, and pixels changing do not qualify as user activity. If users continue to be idle
  after the time interval in IdleDisconnectTimeoutInSeconds elapses, they are disconnected.
  To prevent users from being disconnected due to inactivity, specify a value of 0.
  Otherwise, specify a value between 60 and 3600. The default value is 0.  If you enable this
  feature, we recommend that you specify a value that corresponds exactly to a whole number
  of minutes (for example, 60, 120, and 180). If you don't do this, the value is rounded to
  the nearest minute. For example, if you specify a value of 70, users are disconnected after
  1 minute of inactivity. If you specify a value that is at the midpoint between two
  different minutes, the value is rounded up. For example, if you specify a value of 90,
  users are disconnected after 2 minutes of inactivity.
- `"ImageArn"`: The ARN of the public, private, or shared image to use.
- `"ImageName"`: The name of the image used to create the fleet.
- `"InstanceType"`: The instance type to use when launching fleet instances. The following
  instance types are available:   stream.standard.small   stream.standard.medium
  stream.standard.large   stream.standard.xlarge   stream.standard.2xlarge
  stream.compute.large   stream.compute.xlarge   stream.compute.2xlarge
  stream.compute.4xlarge   stream.compute.8xlarge   stream.memory.large
  stream.memory.xlarge   stream.memory.2xlarge   stream.memory.4xlarge
  stream.memory.8xlarge   stream.memory.z1d.large   stream.memory.z1d.xlarge
  stream.memory.z1d.2xlarge   stream.memory.z1d.3xlarge   stream.memory.z1d.6xlarge
  stream.memory.z1d.12xlarge   stream.graphics-design.large   stream.graphics-design.xlarge
  stream.graphics-design.2xlarge   stream.graphics-design.4xlarge
  stream.graphics-desktop.2xlarge   stream.graphics.g4dn.xlarge
  stream.graphics.g4dn.2xlarge   stream.graphics.g4dn.4xlarge   stream.graphics.g4dn.8xlarge
   stream.graphics.g4dn.12xlarge   stream.graphics.g4dn.16xlarge
  stream.graphics-pro.4xlarge   stream.graphics-pro.8xlarge   stream.graphics-pro.16xlarge
  The following instance types are available for Elastic fleets:   stream.standard.small
  stream.standard.medium   stream.standard.large   stream.standard.xlarge
  stream.standard.2xlarge
- `"MaxConcurrentSessions"`: The maximum number of concurrent sessions for a fleet.
- `"MaxSessionsPerInstance"`: The maximum number of user sessions on an instance. This only
  applies to multi-session fleets.
- `"MaxUserDurationInSeconds"`: The maximum amount of time that a streaming session can
  remain active, in seconds. If users are still connected to a streaming instance five
  minutes before this limit is reached, they are prompted to save any open documents before
  being disconnected. After this time elapses, the instance is terminated and replaced by a
  new instance. Specify a value between 600 and 432000.
- `"Name"`: A unique name for the fleet.
- `"Platform"`: The platform of the fleet. WINDOWS_SERVER_2019 and AMAZON_LINUX2 are
  supported for Elastic fleets.
- `"SessionScriptS3Location"`: The S3 location of the session scripts configuration zip
  file. This only applies to Elastic fleets.
- `"StreamView"`: The AppStream 2.0 view that is displayed to your users when they stream
  from the fleet. When APP is specified, only the windows of applications opened by users
  display. When DESKTOP is specified, the standard desktop that is provided by the operating
  system displays. The default value is APP.
- `"UsbDeviceFilterStrings"`: The USB device filter strings that specify which USB devices
  a user can redirect to the fleet streaming session, when using the Windows native client.
  This is allowed but not required for Elastic fleets.
- `"VpcConfig"`: The VPC configuration for the fleet. This is required for Elastic fleets,
  but not required for other fleet types. Elastic fleets require that you specify at least
  two subnets in different availability zones.
"""
function update_fleet(; aws_config::AbstractAWSConfig=current_aws_config())
    return appstream("UpdateFleet"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function update_fleet(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "UpdateFleet", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    update_image_permissions(image_permissions, name, shared_account_id)
    update_image_permissions(image_permissions, name, shared_account_id, params::Dict{String,<:Any})

Adds or updates permissions for the specified private image.

# Arguments
- `image_permissions`: The permissions for the image.
- `name`: The name of the private image.
- `shared_account_id`: The 12-digit identifier of the AWS account for which you want add or
  update image permissions.

"""
function update_image_permissions(
    ImagePermissions,
    Name,
    SharedAccountId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appstream(
        "UpdateImagePermissions",
        Dict{String,Any}(
            "ImagePermissions" => ImagePermissions,
            "Name" => Name,
            "SharedAccountId" => SharedAccountId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_image_permissions(
    ImagePermissions,
    Name,
    SharedAccountId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appstream(
        "UpdateImagePermissions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ImagePermissions" => ImagePermissions,
                    "Name" => Name,
                    "SharedAccountId" => SharedAccountId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_stack(name)
    update_stack(name, params::Dict{String,<:Any})

Updates the specified fields for the specified stack.

# Arguments
- `name`: The name of the stack.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccessEndpoints"`: The list of interface VPC endpoint (interface endpoint) objects.
  Users of the stack can connect to AppStream 2.0 only through the specified endpoints.
- `"ApplicationSettings"`: The persistent application settings for users of a stack. When
  these settings are enabled, changes that users make to applications and Windows settings
  are automatically saved after each session and applied to the next session.
- `"AttributesToDelete"`: The stack attributes to delete.
- `"DeleteStorageConnectors"`: Deletes the storage connectors currently enabled for the
  stack.
- `"Description"`: The description to display.
- `"DisplayName"`: The stack name to display.
- `"EmbedHostDomains"`: The domains where AppStream 2.0 streaming sessions can be embedded
  in an iframe. You must approve the domains that you want to host embedded AppStream 2.0
  streaming sessions.
- `"FeedbackURL"`: The URL that users are redirected to after they choose the Send Feedback
  link. If no URL is specified, no Send Feedback link is displayed.
- `"RedirectURL"`: The URL that users are redirected to after their streaming session ends.
- `"StorageConnectors"`: The storage connectors to enable.
- `"StreamingExperienceSettings"`: The streaming protocol you want your stack to prefer.
  This can be UDP or TCP. Currently, UDP is only supported in the Windows native client.
- `"UserSettings"`: The actions that are enabled or disabled for users during their
  streaming sessions. By default, these actions are enabled.
"""
function update_stack(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return appstream(
        "UpdateStack",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_stack(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appstream(
        "UpdateStack",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: databrew
using AWS.Compat
using AWS.UUIDs

"""
    batch_delete_recipe_version(recipe_versions, name)
    batch_delete_recipe_version(recipe_versions, name, params::Dict{String,<:Any})

Deletes one or more versions of a recipe at a time. The entire request will be rejected if:
  The recipe does not exist.   There is an invalid version identifier in the list of
versions.   The version list is empty.   The version list size exceeds 50.   The version
list contains duplicate entries.   The request will complete successfully, but with partial
failures, if:   A version does not exist.   A version is being used by a job.   You specify
LATEST_WORKING, but it's being used by a project.   The version fails to be deleted.   The
LATEST_WORKING version will only be deleted if the recipe has no other versions. If you try
to delete LATEST_WORKING while other versions exist (or if they can't be deleted), then
LATEST_WORKING will be listed as partial failure in the response.

# Arguments
- `recipe_versions`: An array of version identifiers, for the recipe versions to be
  deleted. You can specify numeric versions (X.Y) or LATEST_WORKING. LATEST_PUBLISHED is not
  supported.
- `name`: The name of the recipe whose versions are to be deleted.

"""
function batch_delete_recipe_version(
    RecipeVersions, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return databrew(
        "POST",
        "/recipes/$(name)/batchDeleteRecipeVersion",
        Dict{String,Any}("RecipeVersions" => RecipeVersions);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_delete_recipe_version(
    RecipeVersions,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return databrew(
        "POST",
        "/recipes/$(name)/batchDeleteRecipeVersion",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("RecipeVersions" => RecipeVersions), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_dataset(input, name)
    create_dataset(input, name, params::Dict{String,<:Any})

Creates a new DataBrew dataset.

# Arguments
- `input`:
- `name`: The name of the dataset to be created. Valid characters are alphanumeric (A-Z,
  a-z, 0-9), hyphen (-), period (.), and space.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Format"`: The file format of a dataset that is created from an Amazon S3 file or folder.
- `"FormatOptions"`:
- `"PathOptions"`: A set of options that defines how DataBrew interprets an Amazon S3 path
  of the dataset.
- `"Tags"`: Metadata tags to apply to this dataset.
"""
function create_dataset(Input, Name; aws_config::AbstractAWSConfig=current_aws_config())
    return databrew(
        "POST",
        "/datasets",
        Dict{String,Any}("Input" => Input, "Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_dataset(
    Input,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return databrew(
        "POST",
        "/datasets",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Input" => Input, "Name" => Name), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_profile_job(dataset_name, name, output_location, role_arn)
    create_profile_job(dataset_name, name, output_location, role_arn, params::Dict{String,<:Any})

Creates a new job to analyze a dataset and create its data profile.

# Arguments
- `dataset_name`: The name of the dataset that this job is to act upon.
- `name`: The name of the job to be created. Valid characters are alphanumeric (A-Z, a-z,
  0-9), hyphen (-), period (.), and space.
- `output_location`:
- `role_arn`: The Amazon Resource Name (ARN) of the Identity and Access Management (IAM)
  role to be assumed when DataBrew runs the job.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Configuration"`: Configuration for profile jobs. Used to select columns, do
  evaluations, and override default parameters of evaluations. When configuration is null,
  the profile job will run with default settings.
- `"EncryptionKeyArn"`: The Amazon Resource Name (ARN) of an encryption key that is used to
  protect the job.
- `"EncryptionMode"`: The encryption mode for the job, which can be one of the following:
   SSE-KMS - SSE-KMS - Server-side encryption with KMS-managed keys.    SSE-S3 - Server-side
  encryption with keys managed by Amazon S3.
- `"JobSample"`: Sample configuration for profile jobs only. Determines the number of rows
  on which the profile job will be executed. If a JobSample value is not provided, the
  default value will be used. The default value is CUSTOM_ROWS for the mode parameter and
  20000 for the size parameter.
- `"LogSubscription"`: Enables or disables Amazon CloudWatch logging for the job. If
  logging is enabled, CloudWatch writes one log stream for each job run.
- `"MaxCapacity"`: The maximum number of nodes that DataBrew can use when the job processes
  data.
- `"MaxRetries"`: The maximum number of times to retry the job after a job run fails.
- `"Tags"`: Metadata tags to apply to this job.
- `"Timeout"`: The job's timeout in minutes. A job that attempts to run longer than this
  timeout period ends with a status of TIMEOUT.
- `"ValidationConfigurations"`: List of validation configurations that are applied to the
  profile job.
"""
function create_profile_job(
    DatasetName,
    Name,
    OutputLocation,
    RoleArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return databrew(
        "POST",
        "/profileJobs",
        Dict{String,Any}(
            "DatasetName" => DatasetName,
            "Name" => Name,
            "OutputLocation" => OutputLocation,
            "RoleArn" => RoleArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_profile_job(
    DatasetName,
    Name,
    OutputLocation,
    RoleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return databrew(
        "POST",
        "/profileJobs",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DatasetName" => DatasetName,
                    "Name" => Name,
                    "OutputLocation" => OutputLocation,
                    "RoleArn" => RoleArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_project(dataset_name, name, recipe_name, role_arn)
    create_project(dataset_name, name, recipe_name, role_arn, params::Dict{String,<:Any})

Creates a new DataBrew project.

# Arguments
- `dataset_name`: The name of an existing dataset to associate this project with.
- `name`: A unique name for the new project. Valid characters are alphanumeric (A-Z, a-z,
  0-9), hyphen (-), period (.), and space.
- `recipe_name`: The name of an existing recipe to associate with the project.
- `role_arn`: The Amazon Resource Name (ARN) of the Identity and Access Management (IAM)
  role to be assumed for this request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Sample"`:
- `"Tags"`: Metadata tags to apply to this project.
"""
function create_project(
    DatasetName,
    Name,
    RecipeName,
    RoleArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return databrew(
        "POST",
        "/projects",
        Dict{String,Any}(
            "DatasetName" => DatasetName,
            "Name" => Name,
            "RecipeName" => RecipeName,
            "RoleArn" => RoleArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_project(
    DatasetName,
    Name,
    RecipeName,
    RoleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return databrew(
        "POST",
        "/projects",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DatasetName" => DatasetName,
                    "Name" => Name,
                    "RecipeName" => RecipeName,
                    "RoleArn" => RoleArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_recipe(name, steps)
    create_recipe(name, steps, params::Dict{String,<:Any})

Creates a new DataBrew recipe.

# Arguments
- `name`: A unique name for the recipe. Valid characters are alphanumeric (A-Z, a-z, 0-9),
  hyphen (-), period (.), and space.
- `steps`: An array containing the steps to be performed by the recipe. Each recipe step
  consists of one recipe action and (optionally) an array of condition expressions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description for the recipe.
- `"Tags"`: Metadata tags to apply to this recipe.
"""
function create_recipe(Name, Steps; aws_config::AbstractAWSConfig=current_aws_config())
    return databrew(
        "POST",
        "/recipes",
        Dict{String,Any}("Name" => Name, "Steps" => Steps);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_recipe(
    Name,
    Steps,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return databrew(
        "POST",
        "/recipes",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Name" => Name, "Steps" => Steps), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_recipe_job(name, role_arn)
    create_recipe_job(name, role_arn, params::Dict{String,<:Any})

Creates a new job to transform input data, using steps defined in an existing Glue DataBrew
recipe

# Arguments
- `name`: A unique name for the job. Valid characters are alphanumeric (A-Z, a-z, 0-9),
  hyphen (-), period (.), and space.
- `role_arn`: The Amazon Resource Name (ARN) of the Identity and Access Management (IAM)
  role to be assumed when DataBrew runs the job.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DataCatalogOutputs"`: One or more artifacts that represent the Glue Data Catalog output
  from running the job.
- `"DatabaseOutputs"`: Represents a list of JDBC database output objects which defines the
  output destination for a DataBrew recipe job to write to.
- `"DatasetName"`: The name of the dataset that this job processes.
- `"EncryptionKeyArn"`: The Amazon Resource Name (ARN) of an encryption key that is used to
  protect the job.
- `"EncryptionMode"`: The encryption mode for the job, which can be one of the following:
   SSE-KMS - Server-side encryption with keys managed by KMS.    SSE-S3 - Server-side
  encryption with keys managed by Amazon S3.
- `"LogSubscription"`: Enables or disables Amazon CloudWatch logging for the job. If
  logging is enabled, CloudWatch writes one log stream for each job run.
- `"MaxCapacity"`: The maximum number of nodes that DataBrew can consume when the job
  processes data.
- `"MaxRetries"`: The maximum number of times to retry the job after a job run fails.
- `"Outputs"`: One or more artifacts that represent the output from running the job.
- `"ProjectName"`: Either the name of an existing project, or a combination of a recipe and
  a dataset to associate with the recipe.
- `"RecipeReference"`:
- `"Tags"`: Metadata tags to apply to this job.
- `"Timeout"`: The job's timeout in minutes. A job that attempts to run longer than this
  timeout period ends with a status of TIMEOUT.
"""
function create_recipe_job(
    Name, RoleArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return databrew(
        "POST",
        "/recipeJobs",
        Dict{String,Any}("Name" => Name, "RoleArn" => RoleArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_recipe_job(
    Name,
    RoleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return databrew(
        "POST",
        "/recipeJobs",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("Name" => Name, "RoleArn" => RoleArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_ruleset(name, rules, target_arn)
    create_ruleset(name, rules, target_arn, params::Dict{String,<:Any})

Creates a new ruleset that can be used in a profile job to validate the data quality of a
dataset.

# Arguments
- `name`: The name of the ruleset to be created. Valid characters are alphanumeric (A-Z,
  a-z, 0-9), hyphen (-), period (.), and space.
- `rules`: A list of rules that are defined with the ruleset. A rule includes one or more
  checks to be validated on a DataBrew dataset.
- `target_arn`: The Amazon Resource Name (ARN) of a resource (dataset) that the ruleset is
  associated with.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: The description of the ruleset.
- `"Tags"`: Metadata tags to apply to the ruleset.
"""
function create_ruleset(
    Name, Rules, TargetArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return databrew(
        "POST",
        "/rulesets",
        Dict{String,Any}("Name" => Name, "Rules" => Rules, "TargetArn" => TargetArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_ruleset(
    Name,
    Rules,
    TargetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return databrew(
        "POST",
        "/rulesets",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Name" => Name, "Rules" => Rules, "TargetArn" => TargetArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_schedule(cron_expression, name)
    create_schedule(cron_expression, name, params::Dict{String,<:Any})

Creates a new schedule for one or more DataBrew jobs. Jobs can be run at a specific date
and time, or at regular intervals.

# Arguments
- `cron_expression`: The date or dates and time or times when the jobs are to be run. For
  more information, see Cron expressions in the Glue DataBrew Developer Guide.
- `name`: A unique name for the schedule. Valid characters are alphanumeric (A-Z, a-z,
  0-9), hyphen (-), period (.), and space.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"JobNames"`: The name or names of one or more jobs to be run.
- `"Tags"`: Metadata tags to apply to this schedule.
"""
function create_schedule(
    CronExpression, Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return databrew(
        "POST",
        "/schedules",
        Dict{String,Any}("CronExpression" => CronExpression, "Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_schedule(
    CronExpression,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return databrew(
        "POST",
        "/schedules",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("CronExpression" => CronExpression, "Name" => Name),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_dataset(name)
    delete_dataset(name, params::Dict{String,<:Any})

Deletes a dataset from DataBrew.

# Arguments
- `name`: The name of the dataset to be deleted.

"""
function delete_dataset(name; aws_config::AbstractAWSConfig=current_aws_config())
    return databrew(
        "DELETE",
        "/datasets/$(name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_dataset(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return databrew(
        "DELETE",
        "/datasets/$(name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_job(name)
    delete_job(name, params::Dict{String,<:Any})

Deletes the specified DataBrew job.

# Arguments
- `name`: The name of the job to be deleted.

"""
function delete_job(name; aws_config::AbstractAWSConfig=current_aws_config())
    return databrew(
        "DELETE", "/jobs/$(name)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function delete_job(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return databrew(
        "DELETE",
        "/jobs/$(name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_project(name)
    delete_project(name, params::Dict{String,<:Any})

Deletes an existing DataBrew project.

# Arguments
- `name`: The name of the project to be deleted.

"""
function delete_project(name; aws_config::AbstractAWSConfig=current_aws_config())
    return databrew(
        "DELETE",
        "/projects/$(name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_project(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return databrew(
        "DELETE",
        "/projects/$(name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_recipe_version(name, recipe_version)
    delete_recipe_version(name, recipe_version, params::Dict{String,<:Any})

Deletes a single version of a DataBrew recipe.

# Arguments
- `name`: The name of the recipe.
- `recipe_version`: The version of the recipe to be deleted. You can specify a numeric
  versions (X.Y) or LATEST_WORKING. LATEST_PUBLISHED is not supported.

"""
function delete_recipe_version(
    name, recipeVersion; aws_config::AbstractAWSConfig=current_aws_config()
)
    return databrew(
        "DELETE",
        "/recipes/$(name)/recipeVersion/$(recipeVersion)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_recipe_version(
    name,
    recipeVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return databrew(
        "DELETE",
        "/recipes/$(name)/recipeVersion/$(recipeVersion)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_ruleset(name)
    delete_ruleset(name, params::Dict{String,<:Any})

Deletes a ruleset.

# Arguments
- `name`: The name of the ruleset to be deleted.

"""
function delete_ruleset(name; aws_config::AbstractAWSConfig=current_aws_config())
    return databrew(
        "DELETE",
        "/rulesets/$(name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_ruleset(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return databrew(
        "DELETE",
        "/rulesets/$(name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_schedule(name)
    delete_schedule(name, params::Dict{String,<:Any})

Deletes the specified DataBrew schedule.

# Arguments
- `name`: The name of the schedule to be deleted.

"""
function delete_schedule(name; aws_config::AbstractAWSConfig=current_aws_config())
    return databrew(
        "DELETE",
        "/schedules/$(name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_schedule(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return databrew(
        "DELETE",
        "/schedules/$(name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_dataset(name)
    describe_dataset(name, params::Dict{String,<:Any})

Returns the definition of a specific DataBrew dataset.

# Arguments
- `name`: The name of the dataset to be described.

"""
function describe_dataset(name; aws_config::AbstractAWSConfig=current_aws_config())
    return databrew(
        "GET", "/datasets/$(name)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_dataset(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return databrew(
        "GET",
        "/datasets/$(name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_job(name)
    describe_job(name, params::Dict{String,<:Any})

Returns the definition of a specific DataBrew job.

# Arguments
- `name`: The name of the job to be described.

"""
function describe_job(name; aws_config::AbstractAWSConfig=current_aws_config())
    return databrew(
        "GET", "/jobs/$(name)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_job(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return databrew(
        "GET",
        "/jobs/$(name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_job_run(name, run_id)
    describe_job_run(name, run_id, params::Dict{String,<:Any})

Represents one run of a DataBrew job.

# Arguments
- `name`: The name of the job being processed during this run.
- `run_id`: The unique identifier of the job run.

"""
function describe_job_run(name, runId; aws_config::AbstractAWSConfig=current_aws_config())
    return databrew(
        "GET",
        "/jobs/$(name)/jobRun/$(runId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_job_run(
    name,
    runId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return databrew(
        "GET",
        "/jobs/$(name)/jobRun/$(runId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_project(name)
    describe_project(name, params::Dict{String,<:Any})

Returns the definition of a specific DataBrew project.

# Arguments
- `name`: The name of the project to be described.

"""
function describe_project(name; aws_config::AbstractAWSConfig=current_aws_config())
    return databrew(
        "GET", "/projects/$(name)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_project(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return databrew(
        "GET",
        "/projects/$(name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_recipe(name)
    describe_recipe(name, params::Dict{String,<:Any})

Returns the definition of a specific DataBrew recipe corresponding to a particular version.

# Arguments
- `name`: The name of the recipe to be described.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"recipeVersion"`: The recipe version identifier. If this parameter isn't specified, then
  the latest published version is returned.
"""
function describe_recipe(name; aws_config::AbstractAWSConfig=current_aws_config())
    return databrew(
        "GET", "/recipes/$(name)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_recipe(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return databrew(
        "GET",
        "/recipes/$(name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_ruleset(name)
    describe_ruleset(name, params::Dict{String,<:Any})

Retrieves detailed information about the ruleset.

# Arguments
- `name`: The name of the ruleset to be described.

"""
function describe_ruleset(name; aws_config::AbstractAWSConfig=current_aws_config())
    return databrew(
        "GET", "/rulesets/$(name)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_ruleset(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return databrew(
        "GET",
        "/rulesets/$(name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_schedule(name)
    describe_schedule(name, params::Dict{String,<:Any})

Returns the definition of a specific DataBrew schedule.

# Arguments
- `name`: The name of the schedule to be described.

"""
function describe_schedule(name; aws_config::AbstractAWSConfig=current_aws_config())
    return databrew(
        "GET", "/schedules/$(name)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_schedule(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return databrew(
        "GET",
        "/schedules/$(name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_datasets()
    list_datasets(params::Dict{String,<:Any})

Lists all of the DataBrew datasets.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in this request.
- `"nextToken"`: The token returned by a previous call to retrieve the next set of results.
"""
function list_datasets(; aws_config::AbstractAWSConfig=current_aws_config())
    return databrew(
        "GET", "/datasets"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_datasets(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return databrew(
        "GET", "/datasets", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_job_runs(name)
    list_job_runs(name, params::Dict{String,<:Any})

Lists all of the previous runs of a particular DataBrew job.

# Arguments
- `name`: The name of the job.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in this request.
- `"nextToken"`: The token returned by a previous call to retrieve the next set of results.
"""
function list_job_runs(name; aws_config::AbstractAWSConfig=current_aws_config())
    return databrew(
        "GET",
        "/jobs/$(name)/jobRuns";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_job_runs(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return databrew(
        "GET",
        "/jobs/$(name)/jobRuns",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_jobs()
    list_jobs(params::Dict{String,<:Any})

Lists all of the DataBrew jobs that are defined.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"datasetName"`: The name of a dataset. Using this parameter indicates to return only
  those jobs that act on the specified dataset.
- `"maxResults"`: The maximum number of results to return in this request.
- `"nextToken"`: A token generated by DataBrew that specifies where to continue pagination
  if a previous request was truncated. To get the next set of pages, pass in the NextToken
  value from the response object of the previous page call.
- `"projectName"`: The name of a project. Using this parameter indicates to return only
  those jobs that are associated with the specified project.
"""
function list_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return databrew("GET", "/jobs"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return databrew(
        "GET", "/jobs", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_projects()
    list_projects(params::Dict{String,<:Any})

Lists all of the DataBrew projects that are defined.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in this request.
- `"nextToken"`: The token returned by a previous call to retrieve the next set of results.
"""
function list_projects(; aws_config::AbstractAWSConfig=current_aws_config())
    return databrew(
        "GET", "/projects"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_projects(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return databrew(
        "GET", "/projects", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_recipe_versions(name)
    list_recipe_versions(name, params::Dict{String,<:Any})

Lists the versions of a particular DataBrew recipe, except for LATEST_WORKING.

# Arguments
- `name`: The name of the recipe for which to return version information.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in this request.
- `"nextToken"`: The token returned by a previous call to retrieve the next set of results.
"""
function list_recipe_versions(name; aws_config::AbstractAWSConfig=current_aws_config())
    return databrew(
        "GET",
        "/recipeVersions",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_recipe_versions(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return databrew(
        "GET",
        "/recipeVersions",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_recipes()
    list_recipes(params::Dict{String,<:Any})

Lists all of the DataBrew recipes that are defined.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in this request.
- `"nextToken"`: The token returned by a previous call to retrieve the next set of results.
- `"recipeVersion"`: Return only those recipes with a version identifier of LATEST_WORKING
  or LATEST_PUBLISHED. If RecipeVersion is omitted, ListRecipes returns all of the
  LATEST_PUBLISHED recipe versions. Valid values: LATEST_WORKING | LATEST_PUBLISHED
"""
function list_recipes(; aws_config::AbstractAWSConfig=current_aws_config())
    return databrew(
        "GET", "/recipes"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_recipes(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return databrew(
        "GET", "/recipes", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_rulesets()
    list_rulesets(params::Dict{String,<:Any})

List all rulesets available in the current account or rulesets associated with a specific
resource (dataset).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in this request.
- `"nextToken"`: A token generated by DataBrew that specifies where to continue pagination
  if a previous request was truncated. To get the next set of pages, pass in the NextToken
  value from the response object of the previous page call.
- `"targetArn"`: The Amazon Resource Name (ARN) of a resource (dataset). Using this
  parameter indicates to return only those rulesets that are associated with the specified
  resource.
"""
function list_rulesets(; aws_config::AbstractAWSConfig=current_aws_config())
    return databrew(
        "GET", "/rulesets"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_rulesets(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return databrew(
        "GET", "/rulesets", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_schedules()
    list_schedules(params::Dict{String,<:Any})

Lists the DataBrew schedules that are defined.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"jobName"`: The name of the job that these schedules apply to.
- `"maxResults"`: The maximum number of results to return in this request.
- `"nextToken"`: The token returned by a previous call to retrieve the next set of results.
"""
function list_schedules(; aws_config::AbstractAWSConfig=current_aws_config())
    return databrew(
        "GET", "/schedules"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_schedules(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return databrew(
        "GET", "/schedules", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists all the tags for a DataBrew resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) string that uniquely identifies the
  DataBrew resource.

"""
function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return databrew(
        "GET",
        "/tags/$(ResourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return databrew(
        "GET",
        "/tags/$(ResourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    publish_recipe(name)
    publish_recipe(name, params::Dict{String,<:Any})

Publishes a new version of a DataBrew recipe.

# Arguments
- `name`: The name of the recipe to be published.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description of the recipe to be published, for this version of the
  recipe.
"""
function publish_recipe(name; aws_config::AbstractAWSConfig=current_aws_config())
    return databrew(
        "POST",
        "/recipes/$(name)/publishRecipe";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function publish_recipe(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return databrew(
        "POST",
        "/recipes/$(name)/publishRecipe",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    send_project_session_action(name)
    send_project_session_action(name, params::Dict{String,<:Any})

Performs a recipe step within an interactive DataBrew session that's currently open.

# Arguments
- `name`: The name of the project to apply the action to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientSessionId"`: A unique identifier for an interactive session that's currently open
  and ready for work. The action will be performed on this session.
- `"Preview"`: If true, the result of the recipe step will be returned, but not applied.
- `"RecipeStep"`:
- `"StepIndex"`: The index from which to preview a step. This index is used to preview the
  result of steps that have already been applied, so that the resulting view frame is from
  earlier in the view frame stack.
- `"ViewFrame"`:
"""
function send_project_session_action(
    name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return databrew(
        "PUT",
        "/projects/$(name)/sendProjectSessionAction";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function send_project_session_action(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return databrew(
        "PUT",
        "/projects/$(name)/sendProjectSessionAction",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_job_run(name)
    start_job_run(name, params::Dict{String,<:Any})

Runs a DataBrew job.

# Arguments
- `name`: The name of the job to be run.

"""
function start_job_run(name; aws_config::AbstractAWSConfig=current_aws_config())
    return databrew(
        "POST",
        "/jobs/$(name)/startJobRun";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_job_run(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return databrew(
        "POST",
        "/jobs/$(name)/startJobRun",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_project_session(name)
    start_project_session(name, params::Dict{String,<:Any})

Creates an interactive session, enabling you to manipulate data in a DataBrew project.

# Arguments
- `name`: The name of the project to act upon.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AssumeControl"`: A value that, if true, enables you to take control of a session, even
  if a different client is currently accessing the project.
"""
function start_project_session(name; aws_config::AbstractAWSConfig=current_aws_config())
    return databrew(
        "PUT",
        "/projects/$(name)/startProjectSession";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_project_session(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return databrew(
        "PUT",
        "/projects/$(name)/startProjectSession",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_job_run(name, run_id)
    stop_job_run(name, run_id, params::Dict{String,<:Any})

Stops a particular run of a job.

# Arguments
- `name`: The name of the job to be stopped.
- `run_id`: The ID of the job run to be stopped.

"""
function stop_job_run(name, runId; aws_config::AbstractAWSConfig=current_aws_config())
    return databrew(
        "POST",
        "/jobs/$(name)/jobRun/$(runId)/stopJobRun";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_job_run(
    name,
    runId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return databrew(
        "POST",
        "/jobs/$(name)/jobRun/$(runId)/stopJobRun",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds metadata tags to a DataBrew resource, such as a dataset, project, recipe, job, or
schedule.

# Arguments
- `resource_arn`: The DataBrew resource to which tags should be added. The value for this
  parameter is an Amazon Resource Name (ARN). For DataBrew, you can tag a dataset, a job, a
  project, or a recipe.
- `tags`: One or more tags to be assigned to the resource.

"""
function tag_resource(ResourceArn, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return databrew(
        "POST",
        "/tags/$(ResourceArn)",
        Dict{String,Any}("Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceArn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return databrew(
        "POST",
        "/tags/$(ResourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Tags" => Tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes metadata tags from a DataBrew resource.

# Arguments
- `resource_arn`: A DataBrew resource from which you want to remove a tag or tags. The
  value for this parameter is an Amazon Resource Name (ARN).
- `tag_keys`: The tag keys (names) of one or more tags to be removed.

"""
function untag_resource(
    ResourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return databrew(
        "DELETE",
        "/tags/$(ResourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return databrew(
        "DELETE",
        "/tags/$(ResourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_dataset(input, name)
    update_dataset(input, name, params::Dict{String,<:Any})

Modifies the definition of an existing DataBrew dataset.

# Arguments
- `input`:
- `name`: The name of the dataset to be updated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Format"`: The file format of a dataset that is created from an Amazon S3 file or folder.
- `"FormatOptions"`:
- `"PathOptions"`: A set of options that defines how DataBrew interprets an Amazon S3 path
  of the dataset.
"""
function update_dataset(Input, name; aws_config::AbstractAWSConfig=current_aws_config())
    return databrew(
        "PUT",
        "/datasets/$(name)",
        Dict{String,Any}("Input" => Input);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_dataset(
    Input,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return databrew(
        "PUT",
        "/datasets/$(name)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Input" => Input), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_profile_job(output_location, role_arn, name)
    update_profile_job(output_location, role_arn, name, params::Dict{String,<:Any})

Modifies the definition of an existing profile job.

# Arguments
- `output_location`:
- `role_arn`: The Amazon Resource Name (ARN) of the Identity and Access Management (IAM)
  role to be assumed when DataBrew runs the job.
- `name`: The name of the job to be updated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Configuration"`: Configuration for profile jobs. Used to select columns, do
  evaluations, and override default parameters of evaluations. When configuration is null,
  the profile job will run with default settings.
- `"EncryptionKeyArn"`: The Amazon Resource Name (ARN) of an encryption key that is used to
  protect the job.
- `"EncryptionMode"`: The encryption mode for the job, which can be one of the following:
   SSE-KMS - Server-side encryption with keys managed by KMS.    SSE-S3 - Server-side
  encryption with keys managed by Amazon S3.
- `"JobSample"`: Sample configuration for Profile Jobs only. Determines the number of rows
  on which the Profile job will be executed. If a JobSample value is not provided for profile
  jobs, the default value will be used. The default value is CUSTOM_ROWS for the mode
  parameter and 20000 for the size parameter.
- `"LogSubscription"`: Enables or disables Amazon CloudWatch logging for the job. If
  logging is enabled, CloudWatch writes one log stream for each job run.
- `"MaxCapacity"`: The maximum number of compute nodes that DataBrew can use when the job
  processes data.
- `"MaxRetries"`: The maximum number of times to retry the job after a job run fails.
- `"Timeout"`: The job's timeout in minutes. A job that attempts to run longer than this
  timeout period ends with a status of TIMEOUT.
- `"ValidationConfigurations"`: List of validation configurations that are applied to the
  profile job.
"""
function update_profile_job(
    OutputLocation, RoleArn, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return databrew(
        "PUT",
        "/profileJobs/$(name)",
        Dict{String,Any}("OutputLocation" => OutputLocation, "RoleArn" => RoleArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_profile_job(
    OutputLocation,
    RoleArn,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return databrew(
        "PUT",
        "/profileJobs/$(name)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("OutputLocation" => OutputLocation, "RoleArn" => RoleArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_project(role_arn, name)
    update_project(role_arn, name, params::Dict{String,<:Any})

Modifies the definition of an existing DataBrew project.

# Arguments
- `role_arn`: The Amazon Resource Name (ARN) of the IAM role to be assumed for this request.
- `name`: The name of the project to be updated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Sample"`:
"""
function update_project(RoleArn, name; aws_config::AbstractAWSConfig=current_aws_config())
    return databrew(
        "PUT",
        "/projects/$(name)",
        Dict{String,Any}("RoleArn" => RoleArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_project(
    RoleArn,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return databrew(
        "PUT",
        "/projects/$(name)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("RoleArn" => RoleArn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_recipe(name)
    update_recipe(name, params::Dict{String,<:Any})

Modifies the definition of the LATEST_WORKING version of a DataBrew recipe.

# Arguments
- `name`: The name of the recipe to be updated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description of the recipe.
- `"Steps"`: One or more steps to be performed by the recipe. Each step consists of an
  action, and the conditions under which the action should succeed.
"""
function update_recipe(name; aws_config::AbstractAWSConfig=current_aws_config())
    return databrew(
        "PUT", "/recipes/$(name)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function update_recipe(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return databrew(
        "PUT",
        "/recipes/$(name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_recipe_job(role_arn, name)
    update_recipe_job(role_arn, name, params::Dict{String,<:Any})

Modifies the definition of an existing DataBrew recipe job.

# Arguments
- `role_arn`: The Amazon Resource Name (ARN) of the Identity and Access Management (IAM)
  role to be assumed when DataBrew runs the job.
- `name`: The name of the job to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DataCatalogOutputs"`: One or more artifacts that represent the Glue Data Catalog output
  from running the job.
- `"DatabaseOutputs"`: Represents a list of JDBC database output objects which defines the
  output destination for a DataBrew recipe job to write into.
- `"EncryptionKeyArn"`: The Amazon Resource Name (ARN) of an encryption key that is used to
  protect the job.
- `"EncryptionMode"`: The encryption mode for the job, which can be one of the following:
   SSE-KMS - Server-side encryption with keys managed by KMS.    SSE-S3 - Server-side
  encryption with keys managed by Amazon S3.
- `"LogSubscription"`: Enables or disables Amazon CloudWatch logging for the job. If
  logging is enabled, CloudWatch writes one log stream for each job run.
- `"MaxCapacity"`: The maximum number of nodes that DataBrew can consume when the job
  processes data.
- `"MaxRetries"`: The maximum number of times to retry the job after a job run fails.
- `"Outputs"`: One or more artifacts that represent the output from running the job.
- `"Timeout"`: The job's timeout in minutes. A job that attempts to run longer than this
  timeout period ends with a status of TIMEOUT.
"""
function update_recipe_job(
    RoleArn, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return databrew(
        "PUT",
        "/recipeJobs/$(name)",
        Dict{String,Any}("RoleArn" => RoleArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_recipe_job(
    RoleArn,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return databrew(
        "PUT",
        "/recipeJobs/$(name)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("RoleArn" => RoleArn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_ruleset(rules, name)
    update_ruleset(rules, name, params::Dict{String,<:Any})

Updates specified ruleset.

# Arguments
- `rules`: A list of rules that are defined with the ruleset. A rule includes one or more
  checks to be validated on a DataBrew dataset.
- `name`: The name of the ruleset to be updated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: The description of the ruleset.
"""
function update_ruleset(Rules, name; aws_config::AbstractAWSConfig=current_aws_config())
    return databrew(
        "PUT",
        "/rulesets/$(name)",
        Dict{String,Any}("Rules" => Rules);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_ruleset(
    Rules,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return databrew(
        "PUT",
        "/rulesets/$(name)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Rules" => Rules), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_schedule(cron_expression, name)
    update_schedule(cron_expression, name, params::Dict{String,<:Any})

Modifies the definition of an existing DataBrew schedule.

# Arguments
- `cron_expression`: The date or dates and time or times when the jobs are to be run. For
  more information, see Cron expressions in the Glue DataBrew Developer Guide.
- `name`: The name of the schedule to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"JobNames"`: The name or names of one or more jobs to be run for this schedule.
"""
function update_schedule(
    CronExpression, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return databrew(
        "PUT",
        "/schedules/$(name)",
        Dict{String,Any}("CronExpression" => CronExpression);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_schedule(
    CronExpression,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return databrew(
        "PUT",
        "/schedules/$(name)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("CronExpression" => CronExpression), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: fms
using AWS.Compat
using AWS.UUIDs

"""
    associate_admin_account(admin_account)
    associate_admin_account(admin_account, params::Dict{String,<:Any})

Sets a Firewall Manager default administrator account. The Firewall Manager default
administrator account can manage third-party firewalls and has full administrative scope
that allows administration of all policy types, accounts, organizational units, and
Regions. This account must be a member account of the organization in Organizations whose
resources you want to protect. For information about working with Firewall Manager
administrator accounts, see Managing Firewall Manager administrators in the Firewall
Manager Developer Guide.

# Arguments
- `admin_account`: The Amazon Web Services account ID to associate with Firewall Manager as
  the Firewall Manager default administrator account. This account must be a member account
  of the organization in Organizations whose resources you want to protect. For more
  information about Organizations, see Managing the Amazon Web Services Accounts in Your
  Organization.

"""
function associate_admin_account(
    AdminAccount; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fms(
        "AssociateAdminAccount",
        Dict{String,Any}("AdminAccount" => AdminAccount);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_admin_account(
    AdminAccount,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fms(
        "AssociateAdminAccount",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AdminAccount" => AdminAccount), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_third_party_firewall(third_party_firewall)
    associate_third_party_firewall(third_party_firewall, params::Dict{String,<:Any})

Sets the Firewall Manager policy administrator as a tenant administrator of a third-party
firewall service. A tenant is an instance of the third-party firewall service that's
associated with your Amazon Web Services customer account.

# Arguments
- `third_party_firewall`: The name of the third-party firewall vendor.

"""
function associate_third_party_firewall(
    ThirdPartyFirewall; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fms(
        "AssociateThirdPartyFirewall",
        Dict{String,Any}("ThirdPartyFirewall" => ThirdPartyFirewall);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_third_party_firewall(
    ThirdPartyFirewall,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fms(
        "AssociateThirdPartyFirewall",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ThirdPartyFirewall" => ThirdPartyFirewall), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_associate_resource(items, resource_set_identifier)
    batch_associate_resource(items, resource_set_identifier, params::Dict{String,<:Any})

Associate resources to a Firewall Manager resource set.

# Arguments
- `items`: The uniform resource identifiers (URIs) of resources that should be associated
  to the resource set. The URIs must be Amazon Resource Names (ARNs).
- `resource_set_identifier`: A unique identifier for the resource set, used in a request to
  refer to the resource set.

"""
function batch_associate_resource(
    Items, ResourceSetIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fms(
        "BatchAssociateResource",
        Dict{String,Any}(
            "Items" => Items, "ResourceSetIdentifier" => ResourceSetIdentifier
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_associate_resource(
    Items,
    ResourceSetIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fms(
        "BatchAssociateResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Items" => Items, "ResourceSetIdentifier" => ResourceSetIdentifier
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_disassociate_resource(items, resource_set_identifier)
    batch_disassociate_resource(items, resource_set_identifier, params::Dict{String,<:Any})

Disassociates resources from a Firewall Manager resource set.

# Arguments
- `items`: The uniform resource identifiers (URI) of resources that should be disassociated
  from the resource set. The URIs must be Amazon Resource Names (ARNs).
- `resource_set_identifier`: A unique identifier for the resource set, used in a request to
  refer to the resource set.

"""
function batch_disassociate_resource(
    Items, ResourceSetIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fms(
        "BatchDisassociateResource",
        Dict{String,Any}(
            "Items" => Items, "ResourceSetIdentifier" => ResourceSetIdentifier
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_disassociate_resource(
    Items,
    ResourceSetIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fms(
        "BatchDisassociateResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Items" => Items, "ResourceSetIdentifier" => ResourceSetIdentifier
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_apps_list(list_id)
    delete_apps_list(list_id, params::Dict{String,<:Any})

Permanently deletes an Firewall Manager applications list.

# Arguments
- `list_id`: The ID of the applications list that you want to delete. You can retrieve this
  ID from PutAppsList, ListAppsLists, and GetAppsList.

"""
function delete_apps_list(ListId; aws_config::AbstractAWSConfig=current_aws_config())
    return fms(
        "DeleteAppsList",
        Dict{String,Any}("ListId" => ListId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_apps_list(
    ListId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fms(
        "DeleteAppsList",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("ListId" => ListId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_notification_channel()
    delete_notification_channel(params::Dict{String,<:Any})

Deletes an Firewall Manager association with the IAM role and the Amazon Simple
Notification Service (SNS) topic that is used to record Firewall Manager SNS logs.

"""
function delete_notification_channel(; aws_config::AbstractAWSConfig=current_aws_config())
    return fms(
        "DeleteNotificationChannel"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function delete_notification_channel(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fms(
        "DeleteNotificationChannel",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_policy(policy_id)
    delete_policy(policy_id, params::Dict{String,<:Any})

Permanently deletes an Firewall Manager policy.

# Arguments
- `policy_id`: The ID of the policy that you want to delete. You can retrieve this ID from
  PutPolicy and ListPolicies.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DeleteAllPolicyResources"`: If True, the request performs cleanup according to the
  policy type.  For WAF and Shield Advanced policies, the cleanup does the following:
  Deletes rule groups created by Firewall Manager   Removes web ACLs from in-scope resources
   Deletes web ACLs that contain no rules or rule groups   For security group policies, the
  cleanup does the following for each security group in the policy:   Disassociates the
  security group from in-scope resources    Deletes the security group if it was created
  through Firewall Manager and if it's no longer associated with any resources through
  another policy    For security group common policies, even if set to False, Firewall
  Manager deletes all security groups created by Firewall Manager that aren't associated with
  any other resources through another policy.  After the cleanup, in-scope resources are no
  longer protected by web ACLs in this policy. Protection of out-of-scope resources remains
  unchanged. Scope is determined by tags that you create and accounts that you associate with
  the policy. When creating the policy, if you specify that only resources in specific
  accounts or with specific tags are in scope of the policy, those accounts and resources are
  handled by the policy. All others are out of scope. If you don't specify tags or accounts,
  all resources are in scope.
"""
function delete_policy(PolicyId; aws_config::AbstractAWSConfig=current_aws_config())
    return fms(
        "DeletePolicy",
        Dict{String,Any}("PolicyId" => PolicyId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_policy(
    PolicyId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fms(
        "DeletePolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("PolicyId" => PolicyId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_protocols_list(list_id)
    delete_protocols_list(list_id, params::Dict{String,<:Any})

Permanently deletes an Firewall Manager protocols list.

# Arguments
- `list_id`: The ID of the protocols list that you want to delete. You can retrieve this ID
  from PutProtocolsList, ListProtocolsLists, and GetProtocolsLost.

"""
function delete_protocols_list(ListId; aws_config::AbstractAWSConfig=current_aws_config())
    return fms(
        "DeleteProtocolsList",
        Dict{String,Any}("ListId" => ListId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_protocols_list(
    ListId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fms(
        "DeleteProtocolsList",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("ListId" => ListId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_resource_set(identifier)
    delete_resource_set(identifier, params::Dict{String,<:Any})

Deletes the specified ResourceSet.

# Arguments
- `identifier`: A unique identifier for the resource set, used in a request to refer to the
  resource set.

"""
function delete_resource_set(Identifier; aws_config::AbstractAWSConfig=current_aws_config())
    return fms(
        "DeleteResourceSet",
        Dict{String,Any}("Identifier" => Identifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_resource_set(
    Identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fms(
        "DeleteResourceSet",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Identifier" => Identifier), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_admin_account()
    disassociate_admin_account(params::Dict{String,<:Any})

Disassociates an Firewall Manager administrator account. To set a different account as an
Firewall Manager administrator, submit a PutAdminAccount request. To set an account as a
default administrator account, you must submit an AssociateAdminAccount request.
Disassociation of the default administrator account follows the first in, last out
principle. If you are the default administrator, all Firewall Manager administrators within
the organization must first disassociate their accounts before you can disassociate your
account.

"""
function disassociate_admin_account(; aws_config::AbstractAWSConfig=current_aws_config())
    return fms(
        "DisassociateAdminAccount"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function disassociate_admin_account(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fms(
        "DisassociateAdminAccount",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_third_party_firewall(third_party_firewall)
    disassociate_third_party_firewall(third_party_firewall, params::Dict{String,<:Any})

Disassociates a Firewall Manager policy administrator from a third-party firewall tenant.
When you call DisassociateThirdPartyFirewall, the third-party firewall vendor deletes all
of the firewalls that are associated with the account.

# Arguments
- `third_party_firewall`: The name of the third-party firewall vendor.

"""
function disassociate_third_party_firewall(
    ThirdPartyFirewall; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fms(
        "DisassociateThirdPartyFirewall",
        Dict{String,Any}("ThirdPartyFirewall" => ThirdPartyFirewall);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_third_party_firewall(
    ThirdPartyFirewall,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fms(
        "DisassociateThirdPartyFirewall",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ThirdPartyFirewall" => ThirdPartyFirewall), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_admin_account()
    get_admin_account(params::Dict{String,<:Any})

Returns the Organizations account that is associated with Firewall Manager as the Firewall
Manager default administrator.

"""
function get_admin_account(; aws_config::AbstractAWSConfig=current_aws_config())
    return fms("GetAdminAccount"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function get_admin_account(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fms(
        "GetAdminAccount", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_admin_scope(admin_account)
    get_admin_scope(admin_account, params::Dict{String,<:Any})

Returns information about the specified account's administrative scope. The administrative
scope defines the resources that an Firewall Manager administrator can manage.

# Arguments
- `admin_account`: The administrator account that you want to get the details for.

"""
function get_admin_scope(AdminAccount; aws_config::AbstractAWSConfig=current_aws_config())
    return fms(
        "GetAdminScope",
        Dict{String,Any}("AdminAccount" => AdminAccount);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_admin_scope(
    AdminAccount,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fms(
        "GetAdminScope",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AdminAccount" => AdminAccount), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_apps_list(list_id)
    get_apps_list(list_id, params::Dict{String,<:Any})

Returns information about the specified Firewall Manager applications list.

# Arguments
- `list_id`: The ID of the Firewall Manager applications list that you want the details for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DefaultList"`: Specifies whether the list to retrieve is a default list owned by
  Firewall Manager.
"""
function get_apps_list(ListId; aws_config::AbstractAWSConfig=current_aws_config())
    return fms(
        "GetAppsList",
        Dict{String,Any}("ListId" => ListId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_apps_list(
    ListId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fms(
        "GetAppsList",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("ListId" => ListId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_compliance_detail(member_account, policy_id)
    get_compliance_detail(member_account, policy_id, params::Dict{String,<:Any})

Returns detailed compliance information about the specified member account. Details include
resources that are in and out of compliance with the specified policy.  The reasons for
resources being considered compliant depend on the Firewall Manager policy type.

# Arguments
- `member_account`: The Amazon Web Services account that owns the resources that you want
  to get the details for.
- `policy_id`: The ID of the policy that you want to get the details for. PolicyId is
  returned by PutPolicy and by ListPolicies.

"""
function get_compliance_detail(
    MemberAccount, PolicyId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fms(
        "GetComplianceDetail",
        Dict{String,Any}("MemberAccount" => MemberAccount, "PolicyId" => PolicyId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_compliance_detail(
    MemberAccount,
    PolicyId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fms(
        "GetComplianceDetail",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("MemberAccount" => MemberAccount, "PolicyId" => PolicyId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_notification_channel()
    get_notification_channel(params::Dict{String,<:Any})

Information about the Amazon Simple Notification Service (SNS) topic that is used to record
Firewall Manager SNS logs.

"""
function get_notification_channel(; aws_config::AbstractAWSConfig=current_aws_config())
    return fms(
        "GetNotificationChannel"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_notification_channel(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fms(
        "GetNotificationChannel",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_policy(policy_id)
    get_policy(policy_id, params::Dict{String,<:Any})

Returns information about the specified Firewall Manager policy.

# Arguments
- `policy_id`: The ID of the Firewall Manager policy that you want the details for.

"""
function get_policy(PolicyId; aws_config::AbstractAWSConfig=current_aws_config())
    return fms(
        "GetPolicy",
        Dict{String,Any}("PolicyId" => PolicyId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_policy(
    PolicyId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fms(
        "GetPolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("PolicyId" => PolicyId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_protection_status(policy_id)
    get_protection_status(policy_id, params::Dict{String,<:Any})

If you created a Shield Advanced policy, returns policy-level attack summary information in
the event of a potential DDoS attack. Other policy types are currently unsupported.

# Arguments
- `policy_id`: The ID of the policy for which you want to get the attack information.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EndTime"`: The end of the time period to query for the attacks. This is a timestamp
  type. The request syntax listing indicates a number type because the default used by
  Firewall Manager is Unix time in seconds. However, any valid timestamp format is allowed.
- `"MaxResults"`: Specifies the number of objects that you want Firewall Manager to return
  for this request. If you have more objects than the number that you specify for MaxResults,
  the response includes a NextToken value that you can use to get another batch of objects.
- `"MemberAccountId"`: The Amazon Web Services account that is in scope of the policy that
  you want to get the details for.
- `"NextToken"`: If you specify a value for MaxResults and you have more objects than the
  number that you specify for MaxResults, Firewall Manager returns a NextToken value in the
  response, which you can use to retrieve another group of objects. For the second and
  subsequent GetProtectionStatus requests, specify the value of NextToken from the previous
  response to get information about another batch of objects.
- `"StartTime"`: The start of the time period to query for the attacks. This is a timestamp
  type. The request syntax listing indicates a number type because the default used by
  Firewall Manager is Unix time in seconds. However, any valid timestamp format is allowed.
"""
function get_protection_status(PolicyId; aws_config::AbstractAWSConfig=current_aws_config())
    return fms(
        "GetProtectionStatus",
        Dict{String,Any}("PolicyId" => PolicyId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_protection_status(
    PolicyId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fms(
        "GetProtectionStatus",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("PolicyId" => PolicyId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_protocols_list(list_id)
    get_protocols_list(list_id, params::Dict{String,<:Any})

Returns information about the specified Firewall Manager protocols list.

# Arguments
- `list_id`: The ID of the Firewall Manager protocols list that you want the details for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DefaultList"`: Specifies whether the list to retrieve is a default list owned by
  Firewall Manager.
"""
function get_protocols_list(ListId; aws_config::AbstractAWSConfig=current_aws_config())
    return fms(
        "GetProtocolsList",
        Dict{String,Any}("ListId" => ListId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_protocols_list(
    ListId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fms(
        "GetProtocolsList",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("ListId" => ListId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_resource_set(identifier)
    get_resource_set(identifier, params::Dict{String,<:Any})

Gets information about a specific resource set.

# Arguments
- `identifier`: A unique identifier for the resource set, used in a request to refer to the
  resource set.

"""
function get_resource_set(Identifier; aws_config::AbstractAWSConfig=current_aws_config())
    return fms(
        "GetResourceSet",
        Dict{String,Any}("Identifier" => Identifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_resource_set(
    Identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fms(
        "GetResourceSet",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Identifier" => Identifier), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_third_party_firewall_association_status(third_party_firewall)
    get_third_party_firewall_association_status(third_party_firewall, params::Dict{String,<:Any})

The onboarding status of a Firewall Manager admin account to third-party firewall vendor
tenant.

# Arguments
- `third_party_firewall`: The name of the third-party firewall vendor.

"""
function get_third_party_firewall_association_status(
    ThirdPartyFirewall; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fms(
        "GetThirdPartyFirewallAssociationStatus",
        Dict{String,Any}("ThirdPartyFirewall" => ThirdPartyFirewall);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_third_party_firewall_association_status(
    ThirdPartyFirewall,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fms(
        "GetThirdPartyFirewallAssociationStatus",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ThirdPartyFirewall" => ThirdPartyFirewall), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_violation_details(member_account, policy_id, resource_id, resource_type)
    get_violation_details(member_account, policy_id, resource_id, resource_type, params::Dict{String,<:Any})

Retrieves violations for a resource based on the specified Firewall Manager policy and
Amazon Web Services account.

# Arguments
- `member_account`: The Amazon Web Services account ID that you want the details for.
- `policy_id`: The ID of the Firewall Manager policy that you want the details for. You can
  get violation details for the following policy types:   DNS Firewall   Imported Network
  Firewall   Network Firewall   Security group content audit   Network ACL   Third-party
  firewall
- `resource_id`: The ID of the resource that has violations.
- `resource_type`: The resource type. This is in the format shown in the Amazon Web
  Services Resource Types Reference. Supported resource types are: AWS::EC2::Instance,
  AWS::EC2::NetworkInterface, AWS::EC2::SecurityGroup, AWS::NetworkFirewall::FirewallPolicy,
  and AWS::EC2::Subnet.

"""
function get_violation_details(
    MemberAccount,
    PolicyId,
    ResourceId,
    ResourceType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fms(
        "GetViolationDetails",
        Dict{String,Any}(
            "MemberAccount" => MemberAccount,
            "PolicyId" => PolicyId,
            "ResourceId" => ResourceId,
            "ResourceType" => ResourceType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_violation_details(
    MemberAccount,
    PolicyId,
    ResourceId,
    ResourceType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fms(
        "GetViolationDetails",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "MemberAccount" => MemberAccount,
                    "PolicyId" => PolicyId,
                    "ResourceId" => ResourceId,
                    "ResourceType" => ResourceType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_admin_accounts_for_organization()
    list_admin_accounts_for_organization(params::Dict{String,<:Any})

Returns a AdminAccounts object that lists the Firewall Manager administrators within the
organization that are onboarded to Firewall Manager by AssociateAdminAccount. This
operation can be called only from the organization's management account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of objects that you want Firewall Manager to return
  for this request. If more objects are available, in the response, Firewall Manager provides
  a NextToken value that you can use in a subsequent call to get the next batch of objects.
- `"NextToken"`: When you request a list of objects with a MaxResults setting, if the
  number of objects that are still available for retrieval exceeds the maximum you requested,
  Firewall Manager returns a NextToken value in the response. To retrieve the next batch of
  objects, use the token returned from the prior request in your next request.
"""
function list_admin_accounts_for_organization(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return fms(
        "ListAdminAccountsForOrganization";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_admin_accounts_for_organization(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fms(
        "ListAdminAccountsForOrganization",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_admins_managing_account()
    list_admins_managing_account(params::Dict{String,<:Any})

Lists the accounts that are managing the specified Organizations member account. This is
useful for any member account so that they can view the accounts who are managing their
account. This operation only returns the managing administrators that have the requested
account within their AdminScope.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of objects that you want Firewall Manager to return
  for this request. If more objects are available, in the response, Firewall Manager provides
  a NextToken value that you can use in a subsequent call to get the next batch of objects.
- `"NextToken"`: When you request a list of objects with a MaxResults setting, if the
  number of objects that are still available for retrieval exceeds the maximum you requested,
  Firewall Manager returns a NextToken value in the response. To retrieve the next batch of
  objects, use the token returned from the prior request in your next request.
"""
function list_admins_managing_account(; aws_config::AbstractAWSConfig=current_aws_config())
    return fms(
        "ListAdminsManagingAccount"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_admins_managing_account(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fms(
        "ListAdminsManagingAccount",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_apps_lists(max_results)
    list_apps_lists(max_results, params::Dict{String,<:Any})

Returns an array of AppsListDataSummary objects.

# Arguments
- `max_results`: The maximum number of objects that you want Firewall Manager to return for
  this request. If more objects are available, in the response, Firewall Manager provides a
  NextToken value that you can use in a subsequent call to get the next batch of objects. If
  you don't specify this, Firewall Manager returns all available objects.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DefaultLists"`: Specifies whether the lists to retrieve are default lists owned by
  Firewall Manager.
- `"NextToken"`: If you specify a value for MaxResults in your list request, and you have
  more objects than the maximum, Firewall Manager returns this token in the response. For all
  but the first request, you provide the token returned by the prior request in the request
  parameters, to retrieve the next batch of objects.
"""
function list_apps_lists(MaxResults; aws_config::AbstractAWSConfig=current_aws_config())
    return fms(
        "ListAppsLists",
        Dict{String,Any}("MaxResults" => MaxResults);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_apps_lists(
    MaxResults,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fms(
        "ListAppsLists",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("MaxResults" => MaxResults), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_compliance_status(policy_id)
    list_compliance_status(policy_id, params::Dict{String,<:Any})

Returns an array of PolicyComplianceStatus objects. Use PolicyComplianceStatus to get a
summary of which member accounts are protected by the specified policy.

# Arguments
- `policy_id`: The ID of the Firewall Manager policy that you want the details for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Specifies the number of PolicyComplianceStatus objects that you want
  Firewall Manager to return for this request. If you have more PolicyComplianceStatus
  objects than the number that you specify for MaxResults, the response includes a NextToken
  value that you can use to get another batch of PolicyComplianceStatus objects.
- `"NextToken"`: If you specify a value for MaxResults and you have more
  PolicyComplianceStatus objects than the number that you specify for MaxResults, Firewall
  Manager returns a NextToken value in the response that allows you to list another group of
  PolicyComplianceStatus objects. For the second and subsequent ListComplianceStatus
  requests, specify the value of NextToken from the previous response to get information
  about another batch of PolicyComplianceStatus objects.
"""
function list_compliance_status(
    PolicyId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fms(
        "ListComplianceStatus",
        Dict{String,Any}("PolicyId" => PolicyId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_compliance_status(
    PolicyId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fms(
        "ListComplianceStatus",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("PolicyId" => PolicyId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_discovered_resources(member_account_ids, resource_type)
    list_discovered_resources(member_account_ids, resource_type, params::Dict{String,<:Any})

Returns an array of resources in the organization's accounts that are available to be
associated with a resource set.

# Arguments
- `member_account_ids`: The Amazon Web Services account IDs to discover resources in. Only
  one account is supported per request. The account must be a member of your organization.
- `resource_type`: The type of resources to discover.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of objects that you want Firewall Manager to return
  for this request. If more objects are available, in the response, Firewall Manager provides
  a NextToken value that you can use in a subsequent call to get the next batch of objects.
- `"NextToken"`: When you request a list of objects with a MaxResults setting, if the
  number of objects that are still available for retrieval exceeds the maximum you requested,
  Firewall Manager returns a NextToken value in the response. To retrieve the next batch of
  objects, use the token returned from the prior request in your next request.
"""
function list_discovered_resources(
    MemberAccountIds, ResourceType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fms(
        "ListDiscoveredResources",
        Dict{String,Any}(
            "MemberAccountIds" => MemberAccountIds, "ResourceType" => ResourceType
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_discovered_resources(
    MemberAccountIds,
    ResourceType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fms(
        "ListDiscoveredResources",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "MemberAccountIds" => MemberAccountIds, "ResourceType" => ResourceType
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_member_accounts()
    list_member_accounts(params::Dict{String,<:Any})

Returns a MemberAccounts object that lists the member accounts in the administrator's
Amazon Web Services organization. Either an Firewall Manager administrator or the
organization's management account can make this request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Specifies the number of member account IDs that you want Firewall Manager
  to return for this request. If you have more IDs than the number that you specify for
  MaxResults, the response includes a NextToken value that you can use to get another batch
  of member account IDs.
- `"NextToken"`: If you specify a value for MaxResults and you have more account IDs than
  the number that you specify for MaxResults, Firewall Manager returns a NextToken value in
  the response that allows you to list another group of IDs. For the second and subsequent
  ListMemberAccountsRequest requests, specify the value of NextToken from the previous
  response to get information about another batch of member account IDs.
"""
function list_member_accounts(; aws_config::AbstractAWSConfig=current_aws_config())
    return fms("ListMemberAccounts"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_member_accounts(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fms(
        "ListMemberAccounts", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_policies()
    list_policies(params::Dict{String,<:Any})

Returns an array of PolicySummary objects.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Specifies the number of PolicySummary objects that you want Firewall
  Manager to return for this request. If you have more PolicySummary objects than the number
  that you specify for MaxResults, the response includes a NextToken value that you can use
  to get another batch of PolicySummary objects.
- `"NextToken"`: If you specify a value for MaxResults and you have more PolicySummary
  objects than the number that you specify for MaxResults, Firewall Manager returns a
  NextToken value in the response that allows you to list another group of PolicySummary
  objects. For the second and subsequent ListPolicies requests, specify the value of
  NextToken from the previous response to get information about another batch of
  PolicySummary objects.
"""
function list_policies(; aws_config::AbstractAWSConfig=current_aws_config())
    return fms("ListPolicies"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_policies(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fms(
        "ListPolicies", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_protocols_lists(max_results)
    list_protocols_lists(max_results, params::Dict{String,<:Any})

Returns an array of ProtocolsListDataSummary objects.

# Arguments
- `max_results`: The maximum number of objects that you want Firewall Manager to return for
  this request. If more objects are available, in the response, Firewall Manager provides a
  NextToken value that you can use in a subsequent call to get the next batch of objects. If
  you don't specify this, Firewall Manager returns all available objects.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DefaultLists"`: Specifies whether the lists to retrieve are default lists owned by
  Firewall Manager.
- `"NextToken"`: If you specify a value for MaxResults in your list request, and you have
  more objects than the maximum, Firewall Manager returns this token in the response. For all
  but the first request, you provide the token returned by the prior request in the request
  parameters, to retrieve the next batch of objects.
"""
function list_protocols_lists(
    MaxResults; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fms(
        "ListProtocolsLists",
        Dict{String,Any}("MaxResults" => MaxResults);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_protocols_lists(
    MaxResults,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fms(
        "ListProtocolsLists",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("MaxResults" => MaxResults), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_resource_set_resources(identifier)
    list_resource_set_resources(identifier, params::Dict{String,<:Any})

Returns an array of resources that are currently associated to a resource set.

# Arguments
- `identifier`: A unique identifier for the resource set, used in a request to refer to the
  resource set.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of objects that you want Firewall Manager to return
  for this request. If more objects are available, in the response, Firewall Manager provides
  a NextToken value that you can use in a subsequent call to get the next batch of objects.
- `"NextToken"`: When you request a list of objects with a MaxResults setting, if the
  number of objects that are still available for retrieval exceeds the maximum you requested,
  Firewall Manager returns a NextToken value in the response. To retrieve the next batch of
  objects, use the token returned from the prior request in your next request.
"""
function list_resource_set_resources(
    Identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fms(
        "ListResourceSetResources",
        Dict{String,Any}("Identifier" => Identifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_resource_set_resources(
    Identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fms(
        "ListResourceSetResources",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Identifier" => Identifier), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_resource_sets()
    list_resource_sets(params::Dict{String,<:Any})

Returns an array of ResourceSetSummary objects.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of objects that you want Firewall Manager to return
  for this request. If more objects are available, in the response, Firewall Manager provides
  a NextToken value that you can use in a subsequent call to get the next batch of objects.
- `"NextToken"`: When you request a list of objects with a MaxResults setting, if the
  number of objects that are still available for retrieval exceeds the maximum you requested,
  Firewall Manager returns a NextToken value in the response. To retrieve the next batch of
  objects, use the token returned from the prior request in your next request.
"""
function list_resource_sets(; aws_config::AbstractAWSConfig=current_aws_config())
    return fms("ListResourceSets"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_resource_sets(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fms(
        "ListResourceSets", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Retrieves the list of tags for the specified Amazon Web Services resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource to return tags for. The
  Firewall Manager resources that support tagging are policies, applications lists, and
  protocols lists.

"""
function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fms(
        "ListTagsForResource",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fms(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_third_party_firewall_firewall_policies(max_results, third_party_firewall)
    list_third_party_firewall_firewall_policies(max_results, third_party_firewall, params::Dict{String,<:Any})

Retrieves a list of all of the third-party firewall policies that are associated with the
third-party firewall administrator's account.

# Arguments
- `max_results`: The maximum number of third-party firewall policies that you want Firewall
  Manager to return. If the specified third-party firewall vendor is associated with more
  than MaxResults firewall policies, the response includes a NextToken element. NextToken
  contains an encrypted token that identifies the first third-party firewall policies that
  Firewall Manager will return if you submit another request.
- `third_party_firewall`: The name of the third-party firewall vendor.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: If the previous response included a NextToken element, the specified
  third-party firewall vendor is associated with more third-party firewall policies. To get
  more third-party firewall policies, submit another
  ListThirdPartyFirewallFirewallPoliciesRequest request.  For the value of NextToken, specify
  the value of NextToken from the previous response. If the previous response didn't include
  a NextToken element, there are no more third-party firewall policies to get.
"""
function list_third_party_firewall_firewall_policies(
    MaxResults, ThirdPartyFirewall; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fms(
        "ListThirdPartyFirewallFirewallPolicies",
        Dict{String,Any}(
            "MaxResults" => MaxResults, "ThirdPartyFirewall" => ThirdPartyFirewall
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_third_party_firewall_firewall_policies(
    MaxResults,
    ThirdPartyFirewall,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fms(
        "ListThirdPartyFirewallFirewallPolicies",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "MaxResults" => MaxResults, "ThirdPartyFirewall" => ThirdPartyFirewall
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_admin_account(admin_account)
    put_admin_account(admin_account, params::Dict{String,<:Any})

Creates or updates an Firewall Manager administrator account. The account must be a member
of the organization that was onboarded to Firewall Manager by AssociateAdminAccount. Only
the organization's management account can create an Firewall Manager administrator account.
When you create an Firewall Manager administrator account, the service checks to see if the
account is already a delegated administrator within Organizations. If the account isn't a
delegated administrator, Firewall Manager calls Organizations to delegate the account
within Organizations. For more information about administrator accounts within
Organizations, see Managing the Amazon Web Services Accounts in Your Organization.

# Arguments
- `admin_account`: The Amazon Web Services account ID to add as an Firewall Manager
  administrator account. The account must be a member of the organization that was onboarded
  to Firewall Manager by AssociateAdminAccount. For more information about Organizations, see
  Managing the Amazon Web Services Accounts in Your Organization.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AdminScope"`: Configures the resources that the specified Firewall Manager
  administrator can manage. As a best practice, set the administrative scope according to the
  principles of least privilege. Only grant the administrator the specific resources or
  permissions that they need to perform the duties of their role.
"""
function put_admin_account(AdminAccount; aws_config::AbstractAWSConfig=current_aws_config())
    return fms(
        "PutAdminAccount",
        Dict{String,Any}("AdminAccount" => AdminAccount);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_admin_account(
    AdminAccount,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fms(
        "PutAdminAccount",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AdminAccount" => AdminAccount), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_apps_list(apps_list)
    put_apps_list(apps_list, params::Dict{String,<:Any})

Creates an Firewall Manager applications list.

# Arguments
- `apps_list`: The details of the Firewall Manager applications list to be created.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"TagList"`: The tags associated with the resource.
"""
function put_apps_list(AppsList; aws_config::AbstractAWSConfig=current_aws_config())
    return fms(
        "PutAppsList",
        Dict{String,Any}("AppsList" => AppsList);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_apps_list(
    AppsList,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fms(
        "PutAppsList",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AppsList" => AppsList), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_notification_channel(sns_role_name, sns_topic_arn)
    put_notification_channel(sns_role_name, sns_topic_arn, params::Dict{String,<:Any})

Designates the IAM role and Amazon Simple Notification Service (SNS) topic that Firewall
Manager uses to record SNS logs. To perform this action outside of the console, you must
first configure the SNS topic's access policy to allow the SnsRoleName to publish SNS logs.
If the SnsRoleName provided is a role other than the AWSServiceRoleForFMS service-linked
role, this role must have a trust relationship configured to allow the Firewall Manager
service principal fms.amazonaws.com to assume this role. For information about configuring
an SNS access policy, see Service roles for Firewall Manager in the Firewall Manager
Developer Guide.

# Arguments
- `sns_role_name`: The Amazon Resource Name (ARN) of the IAM role that allows Amazon SNS to
  record Firewall Manager activity.
- `sns_topic_arn`: The Amazon Resource Name (ARN) of the SNS topic that collects
  notifications from Firewall Manager.

"""
function put_notification_channel(
    SnsRoleName, SnsTopicArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fms(
        "PutNotificationChannel",
        Dict{String,Any}("SnsRoleName" => SnsRoleName, "SnsTopicArn" => SnsTopicArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_notification_channel(
    SnsRoleName,
    SnsTopicArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fms(
        "PutNotificationChannel",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "SnsRoleName" => SnsRoleName, "SnsTopicArn" => SnsTopicArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_policy(policy)
    put_policy(policy, params::Dict{String,<:Any})

Creates an Firewall Manager policy. A Firewall Manager policy is specific to the individual
policy type. If you want to enforce multiple policy types across accounts, you can create
multiple policies. You can create more than one policy for each type.  If you add a new
account to an organization that you created with Organizations, Firewall Manager
automatically applies the policy to the resources in that account that are within scope of
the policy.  Firewall Manager provides the following types of policies:     WAF policy -
This policy applies WAF web ACL protections to specified accounts and resources.     Shield
Advanced policy - This policy applies Shield Advanced protection to specified accounts and
resources.     Security Groups policy - This type of policy gives you control over security
groups that are in use throughout your organization in Organizations and lets you enforce a
baseline set of rules across your organization.     Network ACL policy - This type of
policy gives you control over the network ACLs that are in use throughout your organization
in Organizations and lets you enforce a baseline set of first and last network ACL rules
across your organization.     Network Firewall policy - This policy applies Network
Firewall protection to your organization's VPCs.     DNS Firewall policy - This policy
applies Amazon Route 53 Resolver DNS Firewall protections to your organization's VPCs.
Third-party firewall policy - This policy applies third-party firewall protections.
Third-party firewalls are available by subscription through the Amazon Web Services
Marketplace console at Amazon Web Services Marketplace.    Palo Alto Networks Cloud NGFW
policy - This policy applies Palo Alto Networks Cloud Next Generation Firewall (NGFW)
protections and Palo Alto Networks Cloud NGFW rulestacks to your organization's VPCs.
Fortigate CNF policy - This policy applies Fortigate Cloud Native Firewall (CNF)
protections. Fortigate CNF is a cloud-centered solution that blocks Zero-Day threats and
secures cloud infrastructures with industry-leading advanced threat prevention, smart web
application firewalls (WAF), and API protection.

# Arguments
- `policy`: The details of the Firewall Manager policy to be created.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"TagList"`: The tags to add to the Amazon Web Services resource.
"""
function put_policy(Policy; aws_config::AbstractAWSConfig=current_aws_config())
    return fms(
        "PutPolicy",
        Dict{String,Any}("Policy" => Policy);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_policy(
    Policy, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fms(
        "PutPolicy",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Policy" => Policy), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_protocols_list(protocols_list)
    put_protocols_list(protocols_list, params::Dict{String,<:Any})

Creates an Firewall Manager protocols list.

# Arguments
- `protocols_list`: The details of the Firewall Manager protocols list to be created.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"TagList"`: The tags associated with the resource.
"""
function put_protocols_list(
    ProtocolsList; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fms(
        "PutProtocolsList",
        Dict{String,Any}("ProtocolsList" => ProtocolsList);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_protocols_list(
    ProtocolsList,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fms(
        "PutProtocolsList",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ProtocolsList" => ProtocolsList), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_resource_set(resource_set)
    put_resource_set(resource_set, params::Dict{String,<:Any})

Creates the resource set. An Firewall Manager resource set defines the resources to import
into an Firewall Manager policy from another Amazon Web Services service.

# Arguments
- `resource_set`: Details about the resource set to be created or updated.&gt;

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"TagList"`: Retrieves the tags associated with the specified resource set. Tags are
  key:value pairs that you can use to categorize and manage your resources, for purposes like
  billing. For example, you might set the tag key to \"customer\" and the value to the
  customer name or ID. You can specify one or more tags to add to each Amazon Web Services
  resource, up to 50 tags for a resource.
"""
function put_resource_set(ResourceSet; aws_config::AbstractAWSConfig=current_aws_config())
    return fms(
        "PutResourceSet",
        Dict{String,Any}("ResourceSet" => ResourceSet);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_resource_set(
    ResourceSet,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fms(
        "PutResourceSet",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceSet" => ResourceSet), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tag_list)
    tag_resource(resource_arn, tag_list, params::Dict{String,<:Any})

Adds one or more tags to an Amazon Web Services resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource to return tags for. The
  Firewall Manager resources that support tagging are policies, applications lists, and
  protocols lists.
- `tag_list`: The tags to add to the resource.

"""
function tag_resource(
    ResourceArn, TagList; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fms(
        "TagResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "TagList" => TagList);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceArn,
    TagList,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fms(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "TagList" => TagList),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes one or more tags from an Amazon Web Services resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource to return tags for. The
  Firewall Manager resources that support tagging are policies, applications lists, and
  protocols lists.
- `tag_keys`: The keys of the tags to remove from the resource.

"""
function untag_resource(
    ResourceArn, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fms(
        "UntagResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceArn,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fms(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: pricing
using AWS.Compat
using AWS.UUIDs

"""
    describe_services()
    describe_services(params::Dict{String,<:Any})

Returns the metadata for one service or a list of the metadata for all services. Use this
without a service code to get the service codes for all services. Use it with a service
code, such as AmazonEC2, to get information specific to that service, such as the attribute
names available for that service. For example, some of the attribute names available for
EC2 are volumeType, maxIopsVolume, operation, locationType, and instanceCapacity10xlarge.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FormatVersion"`: The format version that you want the response to be in. Valid values
  are: aws_v1
- `"MaxResults"`: The maximum number of results that you want returned in the response.
- `"NextToken"`: The pagination token that indicates the next set of results that you want
  to retrieve.
- `"ServiceCode"`: The code for the service whose information you want to retrieve, such as
  AmazonEC2. You can use the ServiceCode to filter the results in a GetProducts call. To
  retrieve a list of all services, leave this blank.
"""
function describe_services(; aws_config::AbstractAWSConfig=current_aws_config())
    return pricing(
        "DescribeServices"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_services(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pricing(
        "DescribeServices", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_attribute_values(attribute_name, service_code)
    get_attribute_values(attribute_name, service_code, params::Dict{String,<:Any})

Returns a list of attribute values. Attributes are similar to the details in a Price List
API offer file. For a list of available attributes, see Offer File Definitions in the
Billing and Cost Management User Guide.

# Arguments
- `attribute_name`: The name of the attribute that you want to retrieve the values for,
  such as volumeType.
- `service_code`: The service code for the service whose attributes you want to retrieve.
  For example, if you want the retrieve an EC2 attribute, use AmazonEC2.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to return in response.
- `"NextToken"`: The pagination token that indicates the next set of results that you want
  to retrieve.
"""
function get_attribute_values(
    AttributeName, ServiceCode; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pricing(
        "GetAttributeValues",
        Dict{String,Any}("AttributeName" => AttributeName, "ServiceCode" => ServiceCode);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_attribute_values(
    AttributeName,
    ServiceCode,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pricing(
        "GetAttributeValues",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AttributeName" => AttributeName, "ServiceCode" => ServiceCode
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_price_list_file_url(file_format, price_list_arn)
    get_price_list_file_url(file_format, price_list_arn, params::Dict{String,<:Any})

  This feature is in preview release and is subject to change. Your use of Amazon Web
Services Price List API is subject to the Beta Service Participation terms of the Amazon
Web Services Service Terms (Section 1.10).   This returns the URL that you can retrieve
your Price List file from. This URL is based on the PriceListArn and FileFormat that you
retrieve from the ListPriceLists response.

# Arguments
- `file_format`: The format that you want to retrieve your Price List files in. The
  FileFormat can be obtained from the ListPriceLists response.
- `price_list_arn`: The unique identifier that maps to where your Price List files are
  located. PriceListArn can be obtained from the ListPriceLists response.

"""
function get_price_list_file_url(
    FileFormat, PriceListArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pricing(
        "GetPriceListFileUrl",
        Dict{String,Any}("FileFormat" => FileFormat, "PriceListArn" => PriceListArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_price_list_file_url(
    FileFormat,
    PriceListArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pricing(
        "GetPriceListFileUrl",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "FileFormat" => FileFormat, "PriceListArn" => PriceListArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_products(service_code)
    get_products(service_code, params::Dict{String,<:Any})

Returns a list of all products that match the filter criteria.

# Arguments
- `service_code`: The code for the service whose products you want to retrieve.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: The list of filters that limit the returned products. only products that
  match all filters are returned.
- `"FormatVersion"`: The format version that you want the response to be in. Valid values
  are: aws_v1
- `"MaxResults"`: The maximum number of results to return in the response.
- `"NextToken"`: The pagination token that indicates the next set of results that you want
  to retrieve.
"""
function get_products(ServiceCode; aws_config::AbstractAWSConfig=current_aws_config())
    return pricing(
        "GetProducts",
        Dict{String,Any}("ServiceCode" => ServiceCode);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_products(
    ServiceCode,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pricing(
        "GetProducts",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ServiceCode" => ServiceCode), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_price_lists(currency_code, effective_date, service_code)
    list_price_lists(currency_code, effective_date, service_code, params::Dict{String,<:Any})

  This feature is in preview release and is subject to change. Your use of Amazon Web
Services Price List API is subject to the Beta Service Participation terms of the Amazon
Web Services Service Terms (Section 1.10).   This returns a list of Price List references
that the requester if authorized to view, given a ServiceCode, CurrencyCode, and an
EffectiveDate. Use without a RegionCode filter to list Price List references from all
available Amazon Web Services Regions. Use with a RegionCode filter to get the Price List
reference that's specific to a specific Amazon Web Services Region. You can use the
PriceListArn from the response to get your preferred Price List files through the
GetPriceListFileUrl API.

# Arguments
- `currency_code`: The three alphabetical character ISO-4217 currency code that the Price
  List files are denominated in.
- `effective_date`: The date that the Price List file prices are effective from.
- `service_code`: The service code or the Savings Plan service code for the attributes that
  you want to retrieve. For example, to get the list of applicable Amazon EC2 price lists,
  use AmazonEC2. For a full list of service codes containing On-Demand and Reserved Instance
  (RI) pricing, use the DescribeServices API. To retrieve the Reserved Instance and Compute
  Savings Plan price lists, use ComputeSavingsPlans.  To retrieve Machine Learning Savings
  Plans price lists, use MachineLearningSavingsPlans.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to return in the response.
- `"NextToken"`: The pagination token that indicates the next set of results that you want
  to retrieve.
- `"RegionCode"`: This is used to filter the Price List by Amazon Web Services Region. For
  example, to get the price list only for the US East (N. Virginia) Region, use us-east-1. If
  nothing is specified, you retrieve price lists for all applicable Regions. The available
  RegionCode list can be retrieved from GetAttributeValues API.
"""
function list_price_lists(
    CurrencyCode,
    EffectiveDate,
    ServiceCode;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pricing(
        "ListPriceLists",
        Dict{String,Any}(
            "CurrencyCode" => CurrencyCode,
            "EffectiveDate" => EffectiveDate,
            "ServiceCode" => ServiceCode,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_price_lists(
    CurrencyCode,
    EffectiveDate,
    ServiceCode,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pricing(
        "ListPriceLists",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CurrencyCode" => CurrencyCode,
                    "EffectiveDate" => EffectiveDate,
                    "ServiceCode" => ServiceCode,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: cost_explorer
using AWS.Compat
using AWS.UUIDs

"""
    create_anomaly_monitor(anomaly_monitor)
    create_anomaly_monitor(anomaly_monitor, params::Dict{String,<:Any})

Creates a new cost anomaly detection monitor with the requested type and monitor
specification.

# Arguments
- `anomaly_monitor`: The cost anomaly detection monitor object that you want to create.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ResourceTags"`: An optional list of tags to associate with the specified
  AnomalyMonitor . You can use resource tags to control access to your monitor using IAM
  policies. Each tag consists of a key and a value, and each key must be unique for the
  resource. The following restrictions apply to resource tags:   Although the maximum number
  of array members is 200, you can assign a maximum of 50 user-tags to one resource. The
  remaining are reserved for Amazon Web Services use   The maximum length of a key is 128
  characters   The maximum length of a value is 256 characters   Keys and values can only
  contain alphanumeric characters, spaces, and any of the following: _.:/=+@-    Keys and
  values are case sensitive   Keys and values are trimmed for any leading or trailing
  whitespaces   Don’t use aws: as a prefix for your keys. This prefix is reserved for
  Amazon Web Services use
"""
function create_anomaly_monitor(
    AnomalyMonitor; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cost_explorer(
        "CreateAnomalyMonitor",
        Dict{String,Any}("AnomalyMonitor" => AnomalyMonitor);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_anomaly_monitor(
    AnomalyMonitor,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cost_explorer(
        "CreateAnomalyMonitor",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AnomalyMonitor" => AnomalyMonitor), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_anomaly_subscription(anomaly_subscription)
    create_anomaly_subscription(anomaly_subscription, params::Dict{String,<:Any})

Adds an alert subscription to a cost anomaly detection monitor. You can use each
subscription to define subscribers with email or SNS notifications. Email subscribers can
set an absolute or percentage threshold and a time frequency for receiving notifications.

# Arguments
- `anomaly_subscription`: The cost anomaly subscription object that you want to create.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ResourceTags"`: An optional list of tags to associate with the specified
  AnomalySubscription . You can use resource tags to control access to your subscription
  using IAM policies. Each tag consists of a key and a value, and each key must be unique for
  the resource. The following restrictions apply to resource tags:   Although the maximum
  number of array members is 200, you can assign a maximum of 50 user-tags to one resource.
  The remaining are reserved for Amazon Web Services use   The maximum length of a key is 128
  characters   The maximum length of a value is 256 characters   Keys and values can only
  contain alphanumeric characters, spaces, and any of the following: _.:/=+@-    Keys and
  values are case sensitive   Keys and values are trimmed for any leading or trailing
  whitespaces   Don’t use aws: as a prefix for your keys. This prefix is reserved for
  Amazon Web Services use
"""
function create_anomaly_subscription(
    AnomalySubscription; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cost_explorer(
        "CreateAnomalySubscription",
        Dict{String,Any}("AnomalySubscription" => AnomalySubscription);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_anomaly_subscription(
    AnomalySubscription,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cost_explorer(
        "CreateAnomalySubscription",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("AnomalySubscription" => AnomalySubscription),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_cost_category_definition(name, rule_version, rules)
    create_cost_category_definition(name, rule_version, rules, params::Dict{String,<:Any})

Creates a new Cost Category with the requested name and rules.

# Arguments
- `name`:
- `rule_version`:
- `rules`: The Cost Category rules used to categorize costs. For more information, see
  CostCategoryRule.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DefaultValue"`:
- `"EffectiveStart"`: The Cost Category's effective start date. It can only be a billing
  start date (first day of the month). If the date isn't provided, it's the first day of the
  current month. Dates can't be before the previous twelve months, or in the future.
- `"ResourceTags"`: An optional list of tags to associate with the specified  CostCategory
  . You can use resource tags to control access to your cost category using IAM policies.
  Each tag consists of a key and a value, and each key must be unique for the resource. The
  following restrictions apply to resource tags:   Although the maximum number of array
  members is 200, you can assign a maximum of 50 user-tags to one resource. The remaining are
  reserved for Amazon Web Services use   The maximum length of a key is 128 characters   The
  maximum length of a value is 256 characters   Keys and values can only contain alphanumeric
  characters, spaces, and any of the following: _.:/=+@-    Keys and values are case
  sensitive   Keys and values are trimmed for any leading or trailing whitespaces   Don’t
  use aws: as a prefix for your keys. This prefix is reserved for Amazon Web Services use
- `"SplitChargeRules"`:  The split charge rules used to allocate your charges between your
  Cost Category values.
"""
function create_cost_category_definition(
    Name, RuleVersion, Rules; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cost_explorer(
        "CreateCostCategoryDefinition",
        Dict{String,Any}("Name" => Name, "RuleVersion" => RuleVersion, "Rules" => Rules);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_cost_category_definition(
    Name,
    RuleVersion,
    Rules,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cost_explorer(
        "CreateCostCategoryDefinition",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Name" => Name, "RuleVersion" => RuleVersion, "Rules" => Rules
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_anomaly_monitor(monitor_arn)
    delete_anomaly_monitor(monitor_arn, params::Dict{String,<:Any})

Deletes a cost anomaly monitor.

# Arguments
- `monitor_arn`: The unique identifier of the cost anomaly monitor that you want to delete.

"""
function delete_anomaly_monitor(
    MonitorArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cost_explorer(
        "DeleteAnomalyMonitor",
        Dict{String,Any}("MonitorArn" => MonitorArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_anomaly_monitor(
    MonitorArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cost_explorer(
        "DeleteAnomalyMonitor",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("MonitorArn" => MonitorArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_anomaly_subscription(subscription_arn)
    delete_anomaly_subscription(subscription_arn, params::Dict{String,<:Any})

Deletes a cost anomaly subscription.

# Arguments
- `subscription_arn`: The unique identifier of the cost anomaly subscription that you want
  to delete.

"""
function delete_anomaly_subscription(
    SubscriptionArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cost_explorer(
        "DeleteAnomalySubscription",
        Dict{String,Any}("SubscriptionArn" => SubscriptionArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_anomaly_subscription(
    SubscriptionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cost_explorer(
        "DeleteAnomalySubscription",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("SubscriptionArn" => SubscriptionArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_cost_category_definition(cost_category_arn)
    delete_cost_category_definition(cost_category_arn, params::Dict{String,<:Any})

Deletes a Cost Category. Expenses from this month going forward will no longer be
categorized with this Cost Category.

# Arguments
- `cost_category_arn`: The unique identifier for your Cost Category.

"""
function delete_cost_category_definition(
    CostCategoryArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cost_explorer(
        "DeleteCostCategoryDefinition",
        Dict{String,Any}("CostCategoryArn" => CostCategoryArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_cost_category_definition(
    CostCategoryArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cost_explorer(
        "DeleteCostCategoryDefinition",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("CostCategoryArn" => CostCategoryArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_cost_category_definition(cost_category_arn)
    describe_cost_category_definition(cost_category_arn, params::Dict{String,<:Any})

Returns the name, Amazon Resource Name (ARN), rules, definition, and effective dates of a
Cost Category that's defined in the account. You have the option to use EffectiveOn to
return a Cost Category that's active on a specific date. If there's no EffectiveOn
specified, you see a Cost Category that's effective on the current date. If Cost Category
is still effective, EffectiveEnd is omitted in the response.

# Arguments
- `cost_category_arn`: The unique identifier for your Cost Category.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EffectiveOn"`: The date when the Cost Category was effective.
"""
function describe_cost_category_definition(
    CostCategoryArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cost_explorer(
        "DescribeCostCategoryDefinition",
        Dict{String,Any}("CostCategoryArn" => CostCategoryArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_cost_category_definition(
    CostCategoryArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cost_explorer(
        "DescribeCostCategoryDefinition",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("CostCategoryArn" => CostCategoryArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_anomalies(date_interval)
    get_anomalies(date_interval, params::Dict{String,<:Any})

Retrieves all of the cost anomalies detected on your account during the time period that's
specified by the DateInterval object. Anomalies are available for up to 90 days.

# Arguments
- `date_interval`: Assigns the start and end dates for retrieving cost anomalies. The
  returned anomaly object will have an AnomalyEndDate in the specified time range.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Feedback"`: Filters anomaly results by the feedback field on the anomaly object.
- `"MaxResults"`: The number of entries a paginated response contains.
- `"MonitorArn"`: Retrieves all of the cost anomalies detected for a specific cost anomaly
  monitor Amazon Resource Name (ARN).
- `"NextPageToken"`: The token to retrieve the next set of results. Amazon Web Services
  provides the token when the response from a previous call has more results than the maximum
  page size.
- `"TotalImpact"`: Filters anomaly results by the total impact field on the anomaly object.
  For example, you can filter anomalies GREATER_THAN 200.00 to retrieve anomalies, with an
  estimated dollar impact greater than 200.
"""
function get_anomalies(DateInterval; aws_config::AbstractAWSConfig=current_aws_config())
    return cost_explorer(
        "GetAnomalies",
        Dict{String,Any}("DateInterval" => DateInterval);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_anomalies(
    DateInterval,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cost_explorer(
        "GetAnomalies",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DateInterval" => DateInterval), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_anomaly_monitors()
    get_anomaly_monitors(params::Dict{String,<:Any})

Retrieves the cost anomaly monitor definitions for your account. You can filter using a
list of cost anomaly monitor Amazon Resource Names (ARNs).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The number of entries that a paginated response contains.
- `"MonitorArnList"`: A list of cost anomaly monitor ARNs.
- `"NextPageToken"`: The token to retrieve the next set of results. Amazon Web Services
  provides the token when the response from a previous call has more results than the maximum
  page size.
"""
function get_anomaly_monitors(; aws_config::AbstractAWSConfig=current_aws_config())
    return cost_explorer(
        "GetAnomalyMonitors"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_anomaly_monitors(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cost_explorer(
        "GetAnomalyMonitors", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_anomaly_subscriptions()
    get_anomaly_subscriptions(params::Dict{String,<:Any})

Retrieves the cost anomaly subscription objects for your account. You can filter using a
list of cost anomaly monitor Amazon Resource Names (ARNs).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The number of entries a paginated response contains.
- `"MonitorArn"`: Cost anomaly monitor ARNs.
- `"NextPageToken"`: The token to retrieve the next set of results. Amazon Web Services
  provides the token when the response from a previous call has more results than the maximum
  page size.
- `"SubscriptionArnList"`: A list of cost anomaly subscription ARNs.
"""
function get_anomaly_subscriptions(; aws_config::AbstractAWSConfig=current_aws_config())
    return cost_explorer(
        "GetAnomalySubscriptions"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_anomaly_subscriptions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cost_explorer(
        "GetAnomalySubscriptions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_approximate_usage_records(approximation_dimension, granularity)
    get_approximate_usage_records(approximation_dimension, granularity, params::Dict{String,<:Any})

Retrieves estimated usage records for hourly granularity or resource-level data at daily
granularity.

# Arguments
- `approximation_dimension`: The service to evaluate for the usage records. You can choose
  resource-level data at daily granularity, or hourly granularity with or without
  resource-level data.
- `granularity`: How granular you want the data to be. You can enable data at hourly or
  daily granularity.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Services"`: The service metadata for the service or services you want to query. If not
  specified, all elements are returned.
"""
function get_approximate_usage_records(
    ApproximationDimension, Granularity; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cost_explorer(
        "GetApproximateUsageRecords",
        Dict{String,Any}(
            "ApproximationDimension" => ApproximationDimension, "Granularity" => Granularity
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_approximate_usage_records(
    ApproximationDimension,
    Granularity,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cost_explorer(
        "GetApproximateUsageRecords",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApproximationDimension" => ApproximationDimension,
                    "Granularity" => Granularity,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_cost_and_usage(granularity, metrics, time_period)
    get_cost_and_usage(granularity, metrics, time_period, params::Dict{String,<:Any})

Retrieves cost and usage metrics for your account. You can specify which cost and
usage-related metric that you want the request to return. For example, you can specify
BlendedCosts or UsageQuantity. You can also filter and group your data by various
dimensions, such as SERVICE or AZ, in a specific time range. For a complete list of valid
dimensions, see the GetDimensionValues operation. Management account in an organization in
Organizations have access to all member accounts. For information about filter limitations,
see Quotas and restrictions in the Billing and Cost Management User Guide.

# Arguments
- `granularity`: Sets the Amazon Web Services cost granularity to MONTHLY or DAILY, or
  HOURLY. If Granularity isn't set, the response object doesn't include the Granularity,
  either MONTHLY or DAILY, or HOURLY.
- `metrics`: Which metrics are returned in the query. For more information about blended
  and unblended rates, see Why does the \"blended\" annotation appear on some line items in
  my bill?.  Valid values are AmortizedCost, BlendedCost, NetAmortizedCost, NetUnblendedCost,
  NormalizedUsageAmount, UnblendedCost, and UsageQuantity.   If you return the UsageQuantity
  metric, the service aggregates all usage numbers without taking into account the units. For
  example, if you aggregate usageQuantity across all of Amazon EC2, the results aren't
  meaningful because Amazon EC2 compute hours and data transfer are measured in different
  units (for example, hours and GB). To get more meaningful UsageQuantity metrics, filter by
  UsageType or UsageTypeGroups.    Metrics is required for GetCostAndUsage requests.
- `time_period`: Sets the start date and end date for retrieving Amazon Web Services costs.
  The start date is inclusive, but the end date is exclusive. For example, if start is
  2017-01-01 and end is 2017-05-01, then the cost and usage data is retrieved from 2017-01-01
  up to and including 2017-04-30 but not including 2017-05-01.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filter"`: Filters Amazon Web Services costs by different dimensions. For example, you
  can specify SERVICE and LINKED_ACCOUNT and get the costs that are associated with that
  account's usage of that service. You can nest Expression objects to define any combination
  of dimension filters. For more information, see Expression.  Valid values for MatchOptions
  for Dimensions are EQUALS and CASE_SENSITIVE. Valid values for MatchOptions for
  CostCategories and Tags are EQUALS, ABSENT, and CASE_SENSITIVE. Default values are EQUALS
  and CASE_SENSITIVE.
- `"GroupBy"`: You can group Amazon Web Services costs using up to two different groups,
  either dimensions, tag keys, cost categories, or any two group by types. Valid values for
  the DIMENSION type are AZ, INSTANCE_TYPE, LEGAL_ENTITY_NAME, INVOICING_ENTITY,
  LINKED_ACCOUNT, OPERATION, PLATFORM, PURCHASE_TYPE, SERVICE, TENANCY, RECORD_TYPE, and
  USAGE_TYPE. When you group by the TAG type and include a valid tag key, you get all tag
  values, including empty strings.
- `"NextPageToken"`: The token to retrieve the next set of results. Amazon Web Services
  provides the token when the response from a previous call has more results than the maximum
  page size.
"""
function get_cost_and_usage(
    Granularity, Metrics, TimePeriod; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cost_explorer(
        "GetCostAndUsage",
        Dict{String,Any}(
            "Granularity" => Granularity, "Metrics" => Metrics, "TimePeriod" => TimePeriod
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_cost_and_usage(
    Granularity,
    Metrics,
    TimePeriod,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cost_explorer(
        "GetCostAndUsage",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Granularity" => Granularity,
                    "Metrics" => Metrics,
                    "TimePeriod" => TimePeriod,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_cost_and_usage_with_resources(filter, granularity, time_period)
    get_cost_and_usage_with_resources(filter, granularity, time_period, params::Dict{String,<:Any})

Retrieves cost and usage metrics with resources for your account. You can specify which
cost and usage-related metric, such as BlendedCosts or UsageQuantity, that you want the
request to return. You can also filter and group your data by various dimensions, such as
SERVICE or AZ, in a specific time range. For a complete list of valid dimensions, see the
GetDimensionValues operation. Management account in an organization in Organizations have
access to all member accounts. Hourly granularity is only available for EC2-Instances
(Elastic Compute Cloud) resource-level data. All other resource-level data is available at
daily granularity.  This is an opt-in only feature. You can enable this feature from the
Cost Explorer Settings page. For information about how to access the Settings page, see
Controlling Access for Cost Explorer in the Billing and Cost Management User Guide.

# Arguments
- `filter`: Filters Amazon Web Services costs by different dimensions. For example, you can
  specify SERVICE and LINKED_ACCOUNT and get the costs that are associated with that
  account's usage of that service. You can nest Expression objects to define any combination
  of dimension filters. For more information, see Expression.  The
  GetCostAndUsageWithResources operation requires that you either group by or filter by a
  ResourceId. It requires the Expression \"SERVICE = Amazon Elastic Compute Cloud - Compute\"
  in the filter. Valid values for MatchOptions for Dimensions are EQUALS and CASE_SENSITIVE.
  Valid values for MatchOptions for CostCategories and Tags are EQUALS, ABSENT, and
  CASE_SENSITIVE. Default values are EQUALS and CASE_SENSITIVE.
- `granularity`: Sets the Amazon Web Services cost granularity to MONTHLY, DAILY, or
  HOURLY. If Granularity isn't set, the response object doesn't include the Granularity,
  MONTHLY, DAILY, or HOURLY.
- `time_period`: Sets the start and end dates for retrieving Amazon Web Services costs. The
  range must be within the last 14 days (the start date cannot be earlier than 14 days ago).
  The start date is inclusive, but the end date is exclusive. For example, if start is
  2017-01-01 and end is 2017-05-01, then the cost and usage data is retrieved from 2017-01-01
  up to and including 2017-04-30 but not including 2017-05-01.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"GroupBy"`: You can group Amazon Web Services costs using up to two different groups:
  DIMENSION, TAG, COST_CATEGORY.
- `"Metrics"`: Which metrics are returned in the query. For more information about blended
  and unblended rates, see Why does the \"blended\" annotation appear on some line items in
  my bill?.  Valid values are AmortizedCost, BlendedCost, NetAmortizedCost, NetUnblendedCost,
  NormalizedUsageAmount, UnblendedCost, and UsageQuantity.   If you return the UsageQuantity
  metric, the service aggregates all usage numbers without taking the units into account. For
  example, if you aggregate usageQuantity across all of Amazon EC2, the results aren't
  meaningful because Amazon EC2 compute hours and data transfer are measured in different
  units (for example, hour or GB). To get more meaningful UsageQuantity metrics, filter by
  UsageType or UsageTypeGroups.    Metrics is required for GetCostAndUsageWithResources
  requests.
- `"NextPageToken"`: The token to retrieve the next set of results. Amazon Web Services
  provides the token when the response from a previous call has more results than the maximum
  page size.
"""
function get_cost_and_usage_with_resources(
    Filter, Granularity, TimePeriod; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cost_explorer(
        "GetCostAndUsageWithResources",
        Dict{String,Any}(
            "Filter" => Filter, "Granularity" => Granularity, "TimePeriod" => TimePeriod
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_cost_and_usage_with_resources(
    Filter,
    Granularity,
    TimePeriod,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cost_explorer(
        "GetCostAndUsageWithResources",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Filter" => Filter,
                    "Granularity" => Granularity,
                    "TimePeriod" => TimePeriod,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_cost_categories(time_period)
    get_cost_categories(time_period, params::Dict{String,<:Any})

Retrieves an array of Cost Category names and values incurred cost.  If some Cost Category
names and values are not associated with any cost, they will not be returned by this API.

# Arguments
- `time_period`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CostCategoryName"`:
- `"Filter"`:
- `"MaxResults"`: This field is only used when the SortBy value is provided in the request.
  The maximum number of objects that are returned for this request. If MaxResults isn't
  specified with the SortBy value, the request returns 1000 results as the default value for
  this parameter. For GetCostCategories, MaxResults has an upper quota of 1000.
- `"NextPageToken"`: If the number of objects that are still available for retrieval
  exceeds the quota, Amazon Web Services returns a NextPageToken value in the response. To
  retrieve the next batch of objects, provide the NextPageToken from the previous call in
  your next request.
- `"SearchString"`: The value that you want to search the filter values for. If you don't
  specify a CostCategoryName, SearchString is used to filter Cost Category names that match
  the SearchString pattern. If you specify a CostCategoryName, SearchString is used to filter
  Cost Category values that match the SearchString pattern.
- `"SortBy"`: The value that you sort the data by. The key represents the cost and usage
  metrics. The following values are supported:    BlendedCost     UnblendedCost
  AmortizedCost     NetAmortizedCost     NetUnblendedCost     UsageQuantity
  NormalizedUsageAmount    The supported key values for the SortOrder value are ASCENDING and
  DESCENDING. When you use the SortBy value, the NextPageToken and SearchString key values
  aren't supported.
"""
function get_cost_categories(TimePeriod; aws_config::AbstractAWSConfig=current_aws_config())
    return cost_explorer(
        "GetCostCategories",
        Dict{String,Any}("TimePeriod" => TimePeriod);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_cost_categories(
    TimePeriod,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cost_explorer(
        "GetCostCategories",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TimePeriod" => TimePeriod), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_cost_forecast(granularity, metric, time_period)
    get_cost_forecast(granularity, metric, time_period, params::Dict{String,<:Any})

Retrieves a forecast for how much Amazon Web Services predicts that you will spend over the
forecast time period that you select, based on your past costs.

# Arguments
- `granularity`: How granular you want the forecast to be. You can get 3 months of DAILY
  forecasts or 12 months of MONTHLY forecasts. The GetCostForecast operation supports only
  DAILY and MONTHLY granularities.
- `metric`: Which metric Cost Explorer uses to create your forecast. For more information
  about blended and unblended rates, see Why does the \"blended\" annotation appear on some
  line items in my bill?.  Valid values for a GetCostForecast call are the following:
  AMORTIZED_COST   BLENDED_COST   NET_AMORTIZED_COST   NET_UNBLENDED_COST   UNBLENDED_COST
- `time_period`: The period of time that you want the forecast to cover. The start date
  must be equal to or no later than the current date to avoid a validation error.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filter"`: The filters that you want to use to filter your forecast. The GetCostForecast
  API supports filtering by the following dimensions:    AZ     INSTANCE_TYPE
  LINKED_ACCOUNT     LINKED_ACCOUNT_NAME     OPERATION     PURCHASE_TYPE     REGION
  SERVICE     USAGE_TYPE     USAGE_TYPE_GROUP     RECORD_TYPE     OPERATING_SYSTEM
  TENANCY     SCOPE     PLATFORM     SUBSCRIPTION_ID     LEGAL_ENTITY_NAME
  DEPLOYMENT_OPTION     DATABASE_ENGINE     INSTANCE_TYPE_FAMILY     BILLING_ENTITY
  RESERVATION_ID     SAVINGS_PLAN_ARN
- `"PredictionIntervalLevel"`: Cost Explorer always returns the mean forecast as a single
  point. You can request a prediction interval around the mean by specifying a confidence
  level. The higher the confidence level, the more confident Cost Explorer is about the
  actual value falling in the prediction interval. Higher confidence levels result in wider
  prediction intervals.
"""
function get_cost_forecast(
    Granularity, Metric, TimePeriod; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cost_explorer(
        "GetCostForecast",
        Dict{String,Any}(
            "Granularity" => Granularity, "Metric" => Metric, "TimePeriod" => TimePeriod
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_cost_forecast(
    Granularity,
    Metric,
    TimePeriod,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cost_explorer(
        "GetCostForecast",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Granularity" => Granularity,
                    "Metric" => Metric,
                    "TimePeriod" => TimePeriod,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_dimension_values(dimension, time_period)
    get_dimension_values(dimension, time_period, params::Dict{String,<:Any})

Retrieves all available filter values for a specified filter over a period of time. You can
search the dimension values for an arbitrary string.

# Arguments
- `dimension`: The name of the dimension. Each Dimension is available for a different
  Context. For more information, see Context. LINK_ACCOUNT_NAME and SERVICE_CODE can only be
  used in CostCategoryRule.
- `time_period`: The start date and end date for retrieving the dimension values. The start
  date is inclusive, but the end date is exclusive. For example, if start is 2017-01-01 and
  end is 2017-05-01, then the cost and usage data is retrieved from 2017-01-01 up to and
  including 2017-04-30 but not including 2017-05-01.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Context"`: The context for the call to GetDimensionValues. This can be RESERVATIONS or
  COST_AND_USAGE. The default value is COST_AND_USAGE. If the context is set to RESERVATIONS,
  the resulting dimension values can be used in the GetReservationUtilization operation. If
  the context is set to COST_AND_USAGE, the resulting dimension values can be used in the
  GetCostAndUsage operation. If you set the context to COST_AND_USAGE, you can use the
  following dimensions for searching:   AZ - The Availability Zone. An example is us-east-1a.
    BILLING_ENTITY - The Amazon Web Services seller that your account is with. Possible
  values are the following: - Amazon Web Services(Amazon Web Services): The entity that sells
  Amazon Web Services. - AISPL (Amazon Internet Services Pvt. Ltd.): The local Indian entity
  that's an acting reseller for Amazon Web Services in India. - Amazon Web Services
  Marketplace: The entity that supports the sale of solutions that are built on Amazon Web
  Services by third-party software providers.   CACHE_ENGINE - The Amazon ElastiCache
  operating system. Examples are Windows or Linux.   DEPLOYMENT_OPTION - The scope of Amazon
  Relational Database Service deployments. Valid values are SingleAZ and MultiAZ.
  DATABASE_ENGINE - The Amazon Relational Database Service database. Examples are Aurora or
  MySQL.   INSTANCE_TYPE - The type of Amazon EC2 instance. An example is m4.xlarge.
  INSTANCE_TYPE_FAMILY - A family of instance types optimized to fit different use cases.
  Examples are Compute Optimized (for example, C4, C5, C6g, and C7g), Memory Optimization
  (for example, R4, R5n, R5b, and R6g).   INVOICING_ENTITY - The name of the entity that
  issues the Amazon Web Services invoice.   LEGAL_ENTITY_NAME - The name of the organization
  that sells you Amazon Web Services services, such as Amazon Web Services.   LINKED_ACCOUNT
  - The description in the attribute map that includes the full name of the member account.
  The value field contains the Amazon Web Services ID of the member account.
  OPERATING_SYSTEM - The operating system. Examples are Windows or Linux.   OPERATION - The
  action performed. Examples include RunInstance and CreateBucket.   PLATFORM - The Amazon
  EC2 operating system. Examples are Windows or Linux.   PURCHASE_TYPE - The reservation type
  of the purchase that this usage is related to. Examples include On-Demand Instances and
  Standard Reserved Instances.   RESERVATION_ID - The unique identifier for an Amazon Web
  Services Reservation Instance.   SAVINGS_PLAN_ARN - The unique identifier for your Savings
  Plans.   SAVINGS_PLANS_TYPE - Type of Savings Plans (EC2 Instance or Compute).   SERVICE -
  The Amazon Web Services service such as Amazon DynamoDB.   TENANCY - The tenancy of a
  resource. Examples are shared or dedicated.   USAGE_TYPE - The type of usage. An example is
  DataTransfer-In-Bytes. The response for the GetDimensionValues operation includes a unit
  attribute. Examples include GB and Hrs.   USAGE_TYPE_GROUP - The grouping of common usage
  types. An example is Amazon EC2: CloudWatch – Alarms. The response for this operation
  includes a unit attribute.   REGION - The Amazon Web Services Region.   RECORD_TYPE - The
  different types of charges such as Reserved Instance (RI) fees, usage costs, tax refunds,
  and credits.   RESOURCE_ID - The unique identifier of the resource. ResourceId is an opt-in
  feature only available for last 14 days for EC2-Compute Service.   If you set the context
  to RESERVATIONS, you can use the following dimensions for searching:   AZ - The
  Availability Zone. An example is us-east-1a.   CACHE_ENGINE - The Amazon ElastiCache
  operating system. Examples are Windows or Linux.   DEPLOYMENT_OPTION - The scope of Amazon
  Relational Database Service deployments. Valid values are SingleAZ and MultiAZ.
  INSTANCE_TYPE - The type of Amazon EC2 instance. An example is m4.xlarge.   LINKED_ACCOUNT
  - The description in the attribute map that includes the full name of the member account.
  The value field contains the Amazon Web Services ID of the member account.   PLATFORM - The
  Amazon EC2 operating system. Examples are Windows or Linux.   REGION - The Amazon Web
  Services Region.   SCOPE (Utilization only) - The scope of a Reserved Instance (RI). Values
  are regional or a single Availability Zone.   TAG (Coverage only) - The tags that are
  associated with a Reserved Instance (RI).   TENANCY - The tenancy of a resource. Examples
  are shared or dedicated.   If you set the context to SAVINGS_PLANS, you can use the
  following dimensions for searching:   SAVINGS_PLANS_TYPE - Type of Savings Plans (EC2
  Instance or Compute)   PAYMENT_OPTION - The payment option for the given Savings Plans (for
  example, All Upfront)   REGION - The Amazon Web Services Region.   INSTANCE_TYPE_FAMILY -
  The family of instances (For example, m5)   LINKED_ACCOUNT - The description in the
  attribute map that includes the full name of the member account. The value field contains
  the Amazon Web Services ID of the member account.   SAVINGS_PLAN_ARN - The unique
  identifier for your Savings Plans.
- `"Filter"`:
- `"MaxResults"`: This field is only used when SortBy is provided in the request. The
  maximum number of objects that are returned for this request. If MaxResults isn't specified
  with SortBy, the request returns 1000 results as the default value for this parameter. For
  GetDimensionValues, MaxResults has an upper limit of 1000.
- `"NextPageToken"`: The token to retrieve the next set of results. Amazon Web Services
  provides the token when the response from a previous call has more results than the maximum
  page size.
- `"SearchString"`: The value that you want to search the filter values for.
- `"SortBy"`: The value that you want to sort the data by. The key represents cost and
  usage metrics. The following values are supported:    BlendedCost     UnblendedCost
  AmortizedCost     NetAmortizedCost     NetUnblendedCost     UsageQuantity
  NormalizedUsageAmount    The supported values for the SortOrder key are ASCENDING or
  DESCENDING. When you specify a SortBy paramater, the context must be COST_AND_USAGE.
  Further, when using SortBy, NextPageToken and SearchString aren't supported.
"""
function get_dimension_values(
    Dimension, TimePeriod; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cost_explorer(
        "GetDimensionValues",
        Dict{String,Any}("Dimension" => Dimension, "TimePeriod" => TimePeriod);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_dimension_values(
    Dimension,
    TimePeriod,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cost_explorer(
        "GetDimensionValues",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Dimension" => Dimension, "TimePeriod" => TimePeriod),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_reservation_coverage(time_period)
    get_reservation_coverage(time_period, params::Dict{String,<:Any})

Retrieves the reservation coverage for your account, which you can use to see how much of
your Amazon Elastic Compute Cloud, Amazon ElastiCache, Amazon Relational Database Service,
or Amazon Redshift usage is covered by a reservation. An organization's management account
can see the coverage of the associated member accounts. This supports dimensions, Cost
Categories, and nested expressions. For any time period, you can filter data about
reservation usage by the following dimensions:   AZ   CACHE_ENGINE   DATABASE_ENGINE
DEPLOYMENT_OPTION   INSTANCE_TYPE   LINKED_ACCOUNT   OPERATING_SYSTEM   PLATFORM   REGION
SERVICE   TAG   TENANCY   To determine valid values for a dimension, use the
GetDimensionValues operation.

# Arguments
- `time_period`: The start and end dates of the period that you want to retrieve data about
  reservation coverage for. You can retrieve data for a maximum of 13 months: the last 12
  months and the current month. The start date is inclusive, but the end date is exclusive.
  For example, if start is 2017-01-01 and end is 2017-05-01, then the cost and usage data is
  retrieved from 2017-01-01 up to and including 2017-04-30 but not including 2017-05-01.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filter"`: Filters utilization data by dimensions. You can filter by the following
  dimensions:   AZ   CACHE_ENGINE   DATABASE_ENGINE   DEPLOYMENT_OPTION   INSTANCE_TYPE
  LINKED_ACCOUNT   OPERATING_SYSTEM   PLATFORM   REGION   SERVICE   TAG   TENANCY
  GetReservationCoverage uses the same Expression object as the other operations, but only
  AND is supported among each dimension. You can nest only one level deep. If there are
  multiple values for a dimension, they are OR'd together. If you don't provide a SERVICE
  filter, Cost Explorer defaults to EC2. Cost category is also supported.
- `"Granularity"`: The granularity of the Amazon Web Services cost data for the
  reservation. Valid values are MONTHLY and DAILY. If GroupBy is set, Granularity can't be
  set. If Granularity isn't set, the response object doesn't include Granularity, either
  MONTHLY or DAILY. The GetReservationCoverage operation supports only DAILY and MONTHLY
  granularities.
- `"GroupBy"`: You can group the data by the following attributes:   AZ   CACHE_ENGINE
  DATABASE_ENGINE   DEPLOYMENT_OPTION   INSTANCE_TYPE   INVOICING_ENTITY   LINKED_ACCOUNT
  OPERATING_SYSTEM   PLATFORM   REGION   TENANCY
- `"MaxResults"`: The maximum number of objects that you returned for this request. If more
  objects are available, in the response, Amazon Web Services provides a NextPageToken value
  that you can use in a subsequent call to get the next batch of objects.
- `"Metrics"`: The measurement that you want your reservation coverage reported in. Valid
  values are Hour, Unit, and Cost. You can use multiple values in a request.
- `"NextPageToken"`: The token to retrieve the next set of results. Amazon Web Services
  provides the token when the response from a previous call has more results than the maximum
  page size.
- `"SortBy"`: The value by which you want to sort the data. The following values are
  supported for Key:    OnDemandCost     CoverageHoursPercentage     OnDemandHours
  ReservedHours     TotalRunningHours     CoverageNormalizedUnitsPercentage
  OnDemandNormalizedUnits     ReservedNormalizedUnits     TotalRunningNormalizedUnits
  Time    Supported values for SortOrder are ASCENDING or DESCENDING.
"""
function get_reservation_coverage(
    TimePeriod; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cost_explorer(
        "GetReservationCoverage",
        Dict{String,Any}("TimePeriod" => TimePeriod);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_reservation_coverage(
    TimePeriod,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cost_explorer(
        "GetReservationCoverage",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TimePeriod" => TimePeriod), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_reservation_purchase_recommendation(service)
    get_reservation_purchase_recommendation(service, params::Dict{String,<:Any})

Gets recommendations for reservation purchases. These recommendations might help you to
reduce your costs. Reservations provide a discounted hourly rate (up to 75%) compared to
On-Demand pricing. Amazon Web Services generates your recommendations by identifying your
On-Demand usage during a specific time period and collecting your usage into categories
that are eligible for a reservation. After Amazon Web Services has these categories, it
simulates every combination of reservations in each category of usage to identify the best
number of each type of Reserved Instance (RI) to purchase to maximize your estimated
savings.  For example, Amazon Web Services automatically aggregates your Amazon EC2 Linux,
shared tenancy, and c4 family usage in the US West (Oregon) Region and recommends that you
buy size-flexible regional reservations to apply to the c4 family usage. Amazon Web
Services recommends the smallest size instance in an instance family. This makes it easier
to purchase a size-flexible Reserved Instance (RI). Amazon Web Services also shows the
equal number of normalized units. This way, you can purchase any instance size that you
want. For this example, your RI recommendation is for c4.large because that is the smallest
size instance in the c4 instance family.

# Arguments
- `service`: The specific service that you want recommendations for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccountId"`: The account ID that's associated with the recommendation.
- `"AccountScope"`: The account scope that you want your recommendations for. Amazon Web
  Services calculates recommendations including the management account and member accounts if
  the value is set to PAYER. If the value is LINKED, recommendations are calculated for
  individual member accounts only.
- `"Filter"`:
- `"LookbackPeriodInDays"`: The number of previous days that you want Amazon Web Services
  to consider when it calculates your recommendations.
- `"NextPageToken"`: The pagination token that indicates the next set of results that you
  want to retrieve.
- `"PageSize"`: The number of recommendations that you want returned in a single response
  object.
- `"PaymentOption"`: The reservation purchase option that you want recommendations for.
- `"ServiceSpecification"`: The hardware specifications for the service instances that you
  want recommendations for, such as standard or convertible Amazon EC2 instances.
- `"TermInYears"`: The reservation term that you want recommendations for.
"""
function get_reservation_purchase_recommendation(
    Service; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cost_explorer(
        "GetReservationPurchaseRecommendation",
        Dict{String,Any}("Service" => Service);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_reservation_purchase_recommendation(
    Service,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cost_explorer(
        "GetReservationPurchaseRecommendation",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Service" => Service), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_reservation_utilization(time_period)
    get_reservation_utilization(time_period, params::Dict{String,<:Any})

Retrieves the reservation utilization for your account. Management account in an
organization have access to member accounts. You can filter data by dimensions in a time
period. You can use GetDimensionValues to determine the possible dimension values.
Currently, you can group only by SUBSCRIPTION_ID.

# Arguments
- `time_period`: Sets the start and end dates for retrieving Reserved Instance (RI)
  utilization. The start date is inclusive, but the end date is exclusive. For example, if
  start is 2017-01-01 and end is 2017-05-01, then the cost and usage data is retrieved from
  2017-01-01 up to and including 2017-04-30 but not including 2017-05-01.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filter"`: Filters utilization data by dimensions. You can filter by the following
  dimensions:   AZ   CACHE_ENGINE   DEPLOYMENT_OPTION   INSTANCE_TYPE   LINKED_ACCOUNT
  OPERATING_SYSTEM   PLATFORM   REGION   SERVICE   SCOPE   TENANCY
  GetReservationUtilization uses the same Expression object as the other operations, but only
  AND is supported among each dimension, and nesting is supported up to only one level deep.
  If there are multiple values for a dimension, they are OR'd together.
- `"Granularity"`: If GroupBy is set, Granularity can't be set. If Granularity isn't set,
  the response object doesn't include Granularity, either MONTHLY or DAILY. If both GroupBy
  and Granularity aren't set, GetReservationUtilization defaults to DAILY. The
  GetReservationUtilization operation supports only DAILY and MONTHLY granularities.
- `"GroupBy"`: Groups only by SUBSCRIPTION_ID. Metadata is included.
- `"MaxResults"`: The maximum number of objects that you returned for this request. If more
  objects are available, in the response, Amazon Web Services provides a NextPageToken value
  that you can use in a subsequent call to get the next batch of objects.
- `"NextPageToken"`: The token to retrieve the next set of results. Amazon Web Services
  provides the token when the response from a previous call has more results than the maximum
  page size.
- `"SortBy"`: The value that you want to sort the data by. The following values are
  supported for Key:    UtilizationPercentage     UtilizationPercentageInUnits
  PurchasedHours     PurchasedUnits     TotalActualHours     TotalActualUnits     UnusedHours
      UnusedUnits     OnDemandCostOfRIHoursUsed     NetRISavings     TotalPotentialRISavings
     AmortizedUpfrontFee     AmortizedRecurringFee     TotalAmortizedFee
  RICostForUnusedHours     RealizedSavings     UnrealizedSavings    The supported values for
  SortOrder are ASCENDING and DESCENDING.
"""
function get_reservation_utilization(
    TimePeriod; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cost_explorer(
        "GetReservationUtilization",
        Dict{String,Any}("TimePeriod" => TimePeriod);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_reservation_utilization(
    TimePeriod,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cost_explorer(
        "GetReservationUtilization",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TimePeriod" => TimePeriod), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_rightsizing_recommendation(service)
    get_rightsizing_recommendation(service, params::Dict{String,<:Any})

Creates recommendations that help you save cost by identifying idle and underutilized
Amazon EC2 instances. Recommendations are generated to either downsize or terminate
instances, along with providing savings detail and metrics. For more information about
calculation and function, see Optimizing Your Cost with Rightsizing Recommendations in the
Billing and Cost Management User Guide.

# Arguments
- `service`: The specific service that you want recommendations for. The only valid value
  for GetRightsizingRecommendation is \"AmazonEC2\".

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Configuration"`: You can use Configuration to customize recommendations across two
  attributes. You can choose to view recommendations for instances within the same instance
  families or across different instance families. You can also choose to view your estimated
  savings that are associated with recommendations with consideration of existing Savings
  Plans or RI benefits, or neither.
- `"Filter"`:
- `"NextPageToken"`: The pagination token that indicates the next set of results that you
  want to retrieve.
- `"PageSize"`: The number of recommendations that you want returned in a single response
  object.
"""
function get_rightsizing_recommendation(
    Service; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cost_explorer(
        "GetRightsizingRecommendation",
        Dict{String,Any}("Service" => Service);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_rightsizing_recommendation(
    Service,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cost_explorer(
        "GetRightsizingRecommendation",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Service" => Service), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_savings_plan_purchase_recommendation_details(recommendation_detail_id)
    get_savings_plan_purchase_recommendation_details(recommendation_detail_id, params::Dict{String,<:Any})

Retrieves the details for a Savings Plan recommendation. These details include the hourly
data-points that construct the cost, coverage, and utilization charts.

# Arguments
- `recommendation_detail_id`: The ID that is associated with the Savings Plan
  recommendation.

"""
function get_savings_plan_purchase_recommendation_details(
    RecommendationDetailId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cost_explorer(
        "GetSavingsPlanPurchaseRecommendationDetails",
        Dict{String,Any}("RecommendationDetailId" => RecommendationDetailId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_savings_plan_purchase_recommendation_details(
    RecommendationDetailId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cost_explorer(
        "GetSavingsPlanPurchaseRecommendationDetails",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("RecommendationDetailId" => RecommendationDetailId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_savings_plans_coverage(time_period)
    get_savings_plans_coverage(time_period, params::Dict{String,<:Any})

Retrieves the Savings Plans covered for your account. This enables you to see how much of
your cost is covered by a Savings Plan. An organization’s management account can see the
coverage of the associated member accounts. This supports dimensions, Cost Categories, and
nested expressions. For any time period, you can filter data for Savings Plans usage with
the following dimensions:    LINKED_ACCOUNT     REGION     SERVICE     INSTANCE_FAMILY
To determine valid values for a dimension, use the GetDimensionValues operation.

# Arguments
- `time_period`: The time period that you want the usage and costs for. The Start date must
  be within 13 months. The End date must be after the Start date, and before the current
  date. Future dates can't be used as an End date.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filter"`: Filters Savings Plans coverage data by dimensions. You can filter data for
  Savings Plans usage with the following dimensions:    LINKED_ACCOUNT     REGION     SERVICE
      INSTANCE_FAMILY     GetSavingsPlansCoverage uses the same Expression object as the
  other operations, but only AND is supported among each dimension. If there are multiple
  values for a dimension, they are OR'd together. Cost category is also supported.
- `"Granularity"`: The granularity of the Amazon Web Services cost data for your Savings
  Plans. Granularity can't be set if GroupBy is set. The GetSavingsPlansCoverage operation
  supports only DAILY and MONTHLY granularities.
- `"GroupBy"`: You can group the data using the attributes INSTANCE_FAMILY, REGION, or
  SERVICE.
- `"MaxResults"`: The number of items to be returned in a response. The default is 20, with
  a minimum value of 1.
- `"Metrics"`: The measurement that you want your Savings Plans coverage reported in. The
  only valid value is SpendCoveredBySavingsPlans.
- `"NextToken"`: The token to retrieve the next set of results. Amazon Web Services
  provides the token when the response from a previous call has more results than the maximum
  page size.
- `"SortBy"`: The value that you want to sort the data by. The following values are
  supported for Key:    SpendCoveredBySavingsPlan     OnDemandCost     CoveragePercentage
  TotalCost     InstanceFamily     Region     Service    The supported values for SortOrder
  are ASCENDING and DESCENDING.
"""
function get_savings_plans_coverage(
    TimePeriod; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cost_explorer(
        "GetSavingsPlansCoverage",
        Dict{String,Any}("TimePeriod" => TimePeriod);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_savings_plans_coverage(
    TimePeriod,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cost_explorer(
        "GetSavingsPlansCoverage",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TimePeriod" => TimePeriod), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_savings_plans_purchase_recommendation(lookback_period_in_days, payment_option, savings_plans_type, term_in_years)
    get_savings_plans_purchase_recommendation(lookback_period_in_days, payment_option, savings_plans_type, term_in_years, params::Dict{String,<:Any})

Retrieves the Savings Plans recommendations for your account. First use
StartSavingsPlansPurchaseRecommendationGeneration to generate a new set of recommendations,
and then use GetSavingsPlansPurchaseRecommendation to retrieve them.

# Arguments
- `lookback_period_in_days`: The lookback period that's used to generate the recommendation.
- `payment_option`: The payment option that's used to generate these recommendations.
- `savings_plans_type`: The Savings Plans recommendation type that's requested.
- `term_in_years`: The savings plan recommendation term that's used to generate these
  recommendations.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccountScope"`: The account scope that you want your recommendations for. Amazon Web
  Services calculates recommendations including the management account and member accounts if
  the value is set to PAYER. If the value is LINKED, recommendations are calculated for
  individual member accounts only.
- `"Filter"`: You can filter your recommendations by Account ID with the LINKED_ACCOUNT
  dimension. To filter your recommendations by Account ID, specify Key as LINKED_ACCOUNT and
  Value as the comma-separated Acount ID(s) that you want to see Savings Plans purchase
  recommendations for. For GetSavingsPlansPurchaseRecommendation, the Filter doesn't include
  CostCategories or Tags. It only includes Dimensions. With Dimensions, Key must be
  LINKED_ACCOUNT and Value can be a single Account ID or multiple comma-separated Account IDs
  that you want to see Savings Plans Purchase Recommendations for. AND and OR operators are
  not supported.
- `"NextPageToken"`: The token to retrieve the next set of results. Amazon Web Services
  provides the token when the response from a previous call has more results than the maximum
  page size.
- `"PageSize"`: The number of recommendations that you want returned in a single response
  object.
"""
function get_savings_plans_purchase_recommendation(
    LookbackPeriodInDays,
    PaymentOption,
    SavingsPlansType,
    TermInYears;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cost_explorer(
        "GetSavingsPlansPurchaseRecommendation",
        Dict{String,Any}(
            "LookbackPeriodInDays" => LookbackPeriodInDays,
            "PaymentOption" => PaymentOption,
            "SavingsPlansType" => SavingsPlansType,
            "TermInYears" => TermInYears,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_savings_plans_purchase_recommendation(
    LookbackPeriodInDays,
    PaymentOption,
    SavingsPlansType,
    TermInYears,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cost_explorer(
        "GetSavingsPlansPurchaseRecommendation",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "LookbackPeriodInDays" => LookbackPeriodInDays,
                    "PaymentOption" => PaymentOption,
                    "SavingsPlansType" => SavingsPlansType,
                    "TermInYears" => TermInYears,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_savings_plans_utilization(time_period)
    get_savings_plans_utilization(time_period, params::Dict{String,<:Any})

Retrieves the Savings Plans utilization for your account across date ranges with daily or
monthly granularity. Management account in an organization have access to member accounts.
You can use GetDimensionValues in SAVINGS_PLANS to determine the possible dimension values.
 You can't group by any dimension values for GetSavingsPlansUtilization.

# Arguments
- `time_period`: The time period that you want the usage and costs for. The Start date must
  be within 13 months. The End date must be after the Start date, and before the current
  date. Future dates can't be used as an End date.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filter"`: Filters Savings Plans utilization coverage data for active Savings Plans
  dimensions. You can filter data with the following dimensions:    LINKED_ACCOUNT
  SAVINGS_PLAN_ARN     SAVINGS_PLANS_TYPE     REGION     PAYMENT_OPTION
  INSTANCE_TYPE_FAMILY     GetSavingsPlansUtilization uses the same Expression object as the
  other operations, but only AND is supported among each dimension.
- `"Granularity"`: The granularity of the Amazon Web Services utillization data for your
  Savings Plans. The GetSavingsPlansUtilization operation supports only DAILY and MONTHLY
  granularities.
- `"SortBy"`: The value that you want to sort the data by. The following values are
  supported for Key:    UtilizationPercentage     TotalCommitment     UsedCommitment
  UnusedCommitment     NetSavings    The supported values for SortOrder are ASCENDING and
  DESCENDING.
"""
function get_savings_plans_utilization(
    TimePeriod; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cost_explorer(
        "GetSavingsPlansUtilization",
        Dict{String,Any}("TimePeriod" => TimePeriod);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_savings_plans_utilization(
    TimePeriod,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cost_explorer(
        "GetSavingsPlansUtilization",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TimePeriod" => TimePeriod), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_savings_plans_utilization_details(time_period)
    get_savings_plans_utilization_details(time_period, params::Dict{String,<:Any})

Retrieves attribute data along with aggregate utilization and savings data for a given time
period. This doesn't support granular or grouped data (daily/monthly) in response. You
can't retrieve data by dates in a single response similar to GetSavingsPlanUtilization, but
you have the option to make multiple calls to GetSavingsPlanUtilizationDetails by providing
individual dates. You can use GetDimensionValues in SAVINGS_PLANS to determine the possible
dimension values.   GetSavingsPlanUtilizationDetails internally groups data by
SavingsPlansArn.

# Arguments
- `time_period`: The time period that you want the usage and costs for. The Start date must
  be within 13 months. The End date must be after the Start date, and before the current
  date. Future dates can't be used as an End date.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DataType"`: The data type.
- `"Filter"`: Filters Savings Plans utilization coverage data for active Savings Plans
  dimensions. You can filter data with the following dimensions:    LINKED_ACCOUNT
  SAVINGS_PLAN_ARN     REGION     PAYMENT_OPTION     INSTANCE_TYPE_FAMILY
  GetSavingsPlansUtilizationDetails uses the same Expression object as the other operations,
  but only AND is supported among each dimension.
- `"MaxResults"`: The number of items to be returned in a response. The default is 20, with
  a minimum value of 1.
- `"NextToken"`: The token to retrieve the next set of results. Amazon Web Services
  provides the token when the response from a previous call has more results than the maximum
  page size.
- `"SortBy"`: The value that you want to sort the data by. The following values are
  supported for Key:    UtilizationPercentage     TotalCommitment     UsedCommitment
  UnusedCommitment     NetSavings     AmortizedRecurringCommitment
  AmortizedUpfrontCommitment    The supported values for SortOrder are ASCENDING and
  DESCENDING.
"""
function get_savings_plans_utilization_details(
    TimePeriod; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cost_explorer(
        "GetSavingsPlansUtilizationDetails",
        Dict{String,Any}("TimePeriod" => TimePeriod);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_savings_plans_utilization_details(
    TimePeriod,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cost_explorer(
        "GetSavingsPlansUtilizationDetails",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TimePeriod" => TimePeriod), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_tags(time_period)
    get_tags(time_period, params::Dict{String,<:Any})

Queries for available tag keys and tag values for a specified period. You can search the
tag values for an arbitrary string.

# Arguments
- `time_period`: The start and end dates for retrieving the dimension values. The start
  date is inclusive, but the end date is exclusive. For example, if start is 2017-01-01 and
  end is 2017-05-01, then the cost and usage data is retrieved from 2017-01-01 up to and
  including 2017-04-30 but not including 2017-05-01.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filter"`:
- `"MaxResults"`: This field is only used when SortBy is provided in the request. The
  maximum number of objects that are returned for this request. If MaxResults isn't specified
  with SortBy, the request returns 1000 results as the default value for this parameter. For
  GetTags, MaxResults has an upper quota of 1000.
- `"NextPageToken"`: The token to retrieve the next set of results. Amazon Web Services
  provides the token when the response from a previous call has more results than the maximum
  page size.
- `"SearchString"`: The value that you want to search for.
- `"SortBy"`: The value that you want to sort the data by. The key represents cost and
  usage metrics. The following values are supported:    BlendedCost     UnblendedCost
  AmortizedCost     NetAmortizedCost     NetUnblendedCost     UsageQuantity
  NormalizedUsageAmount    The supported values for SortOrder are ASCENDING and DESCENDING.
  When you use SortBy, NextPageToken and SearchString aren't supported.
- `"TagKey"`: The key of the tag that you want to return values for.
"""
function get_tags(TimePeriod; aws_config::AbstractAWSConfig=current_aws_config())
    return cost_explorer(
        "GetTags",
        Dict{String,Any}("TimePeriod" => TimePeriod);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_tags(
    TimePeriod,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cost_explorer(
        "GetTags",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TimePeriod" => TimePeriod), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_usage_forecast(granularity, metric, time_period)
    get_usage_forecast(granularity, metric, time_period, params::Dict{String,<:Any})

Retrieves a forecast for how much Amazon Web Services predicts that you will use over the
forecast time period that you select, based on your past usage.

# Arguments
- `granularity`: How granular you want the forecast to be. You can get 3 months of DAILY
  forecasts or 12 months of MONTHLY forecasts. The GetUsageForecast operation supports only
  DAILY and MONTHLY granularities.
- `metric`: Which metric Cost Explorer uses to create your forecast. Valid values for a
  GetUsageForecast call are the following:   USAGE_QUANTITY   NORMALIZED_USAGE_AMOUNT
- `time_period`: The start and end dates of the period that you want to retrieve usage
  forecast for. The start date is included in the period, but the end date isn't included in
  the period. For example, if start is 2017-01-01 and end is 2017-05-01, then the cost and
  usage data is retrieved from 2017-01-01 up to and including 2017-04-30 but not including
  2017-05-01. The start date must be equal to or later than the current date to avoid a
  validation error.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filter"`: The filters that you want to use to filter your forecast. The
  GetUsageForecast API supports filtering by the following dimensions:    AZ
  INSTANCE_TYPE     LINKED_ACCOUNT     LINKED_ACCOUNT_NAME     OPERATION     PURCHASE_TYPE
   REGION     SERVICE     USAGE_TYPE     USAGE_TYPE_GROUP     RECORD_TYPE
  OPERATING_SYSTEM     TENANCY     SCOPE     PLATFORM     SUBSCRIPTION_ID
  LEGAL_ENTITY_NAME     DEPLOYMENT_OPTION     DATABASE_ENGINE     INSTANCE_TYPE_FAMILY
  BILLING_ENTITY     RESERVATION_ID     SAVINGS_PLAN_ARN
- `"PredictionIntervalLevel"`: Amazon Web Services Cost Explorer always returns the mean
  forecast as a single point. You can request a prediction interval around the mean by
  specifying a confidence level. The higher the confidence level, the more confident Cost
  Explorer is about the actual value falling in the prediction interval. Higher confidence
  levels result in wider prediction intervals.
"""
function get_usage_forecast(
    Granularity, Metric, TimePeriod; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cost_explorer(
        "GetUsageForecast",
        Dict{String,Any}(
            "Granularity" => Granularity, "Metric" => Metric, "TimePeriod" => TimePeriod
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_usage_forecast(
    Granularity,
    Metric,
    TimePeriod,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cost_explorer(
        "GetUsageForecast",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Granularity" => Granularity,
                    "Metric" => Metric,
                    "TimePeriod" => TimePeriod,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_cost_allocation_tag_backfill_history()
    list_cost_allocation_tag_backfill_history(params::Dict{String,<:Any})

 Retrieves a list of your historical cost allocation tag backfill requests.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`:  The maximum number of objects that are returned for this request.
- `"NextToken"`:  The token to retrieve the next set of results. Amazon Web Services
  provides the token when the response from a previous call has more results than the maximum
  page size.
"""
function list_cost_allocation_tag_backfill_history(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return cost_explorer(
        "ListCostAllocationTagBackfillHistory";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_cost_allocation_tag_backfill_history(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cost_explorer(
        "ListCostAllocationTagBackfillHistory",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_cost_allocation_tags()
    list_cost_allocation_tags(params::Dict{String,<:Any})

Get a list of cost allocation tags. All inputs in the API are optional and serve as
filters. By default, all cost allocation tags are returned.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of objects that are returned for this request. By
  default, the request returns 100 results.
- `"NextToken"`: The token to retrieve the next set of results. Amazon Web Services
  provides the token when the response from a previous call has more results than the maximum
  page size.
- `"Status"`: The status of cost allocation tag keys that are returned for this request.
- `"TagKeys"`: The list of cost allocation tag keys that are returned for this request.
- `"Type"`: The type of CostAllocationTag object that are returned for this request. The
  AWSGenerated type tags are tags that Amazon Web Services defines and applies to support
  Amazon Web Services resources for cost allocation purposes. The UserDefined type tags are
  tags that you define, create, and apply to resources.
"""
function list_cost_allocation_tags(; aws_config::AbstractAWSConfig=current_aws_config())
    return cost_explorer(
        "ListCostAllocationTags"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_cost_allocation_tags(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cost_explorer(
        "ListCostAllocationTags",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_cost_category_definitions()
    list_cost_category_definitions(params::Dict{String,<:Any})

Returns the name, Amazon Resource Name (ARN), NumberOfRules and effective dates of all Cost
Categories defined in the account. You have the option to use EffectiveOn to return a list
of Cost Categories that were active on a specific date. If there is no EffectiveOn
specified, you’ll see Cost Categories that are effective on the current date. If Cost
Category is still effective, EffectiveEnd is omitted in the response.
ListCostCategoryDefinitions supports pagination. The request can have a MaxResults range up
to 100.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EffectiveOn"`: The date when the Cost Category was effective.
- `"MaxResults"`: The number of entries a paginated response contains.
- `"NextToken"`: The token to retrieve the next set of results. Amazon Web Services
  provides the token when the response from a previous call has more results than the maximum
  page size.
"""
function list_cost_category_definitions(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return cost_explorer(
        "ListCostCategoryDefinitions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_cost_category_definitions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cost_explorer(
        "ListCostCategoryDefinitions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_savings_plans_purchase_recommendation_generation()
    list_savings_plans_purchase_recommendation_generation(params::Dict{String,<:Any})

Retrieves a list of your historical recommendation generations within the past 30 days.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"GenerationStatus"`: The status of the recommendation generation.
- `"NextPageToken"`: The token to retrieve the next set of results.
- `"PageSize"`: The number of recommendations that you want returned in a single response
  object.
- `"RecommendationIds"`: The IDs for each specific recommendation.
"""
function list_savings_plans_purchase_recommendation_generation(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return cost_explorer(
        "ListSavingsPlansPurchaseRecommendationGeneration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_savings_plans_purchase_recommendation_generation(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cost_explorer(
        "ListSavingsPlansPurchaseRecommendationGeneration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Returns a list of resource tags associated with the resource specified by the Amazon
Resource Name (ARN).

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource. For a list of supported
  resources, see ResourceTag.

"""
function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cost_explorer(
        "ListTagsForResource",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cost_explorer(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    provide_anomaly_feedback(anomaly_id, feedback)
    provide_anomaly_feedback(anomaly_id, feedback, params::Dict{String,<:Any})

Modifies the feedback property of a given cost anomaly.

# Arguments
- `anomaly_id`: A cost anomaly ID.
- `feedback`: Describes whether the cost anomaly was a planned activity or you considered
  it an anomaly.

"""
function provide_anomaly_feedback(
    AnomalyId, Feedback; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cost_explorer(
        "ProvideAnomalyFeedback",
        Dict{String,Any}("AnomalyId" => AnomalyId, "Feedback" => Feedback);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function provide_anomaly_feedback(
    AnomalyId,
    Feedback,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cost_explorer(
        "ProvideAnomalyFeedback",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("AnomalyId" => AnomalyId, "Feedback" => Feedback),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_cost_allocation_tag_backfill(backfill_from)
    start_cost_allocation_tag_backfill(backfill_from, params::Dict{String,<:Any})

 Request a cost allocation tag backfill. This will backfill the activation status (either
active or inactive) for all tag keys from para:BackfillFrom up to the when this request is
made. You can request a backfill once every 24 hours.

# Arguments
- `backfill_from`:  The date you want the backfill to start from. The date can only be a
  first day of the month (a billing start date). Dates can't precede the previous twelve
  months, or in the future.

"""
function start_cost_allocation_tag_backfill(
    BackfillFrom; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cost_explorer(
        "StartCostAllocationTagBackfill",
        Dict{String,Any}("BackfillFrom" => BackfillFrom);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_cost_allocation_tag_backfill(
    BackfillFrom,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cost_explorer(
        "StartCostAllocationTagBackfill",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("BackfillFrom" => BackfillFrom), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_savings_plans_purchase_recommendation_generation()
    start_savings_plans_purchase_recommendation_generation(params::Dict{String,<:Any})

Requests a Savings Plans recommendation generation. This enables you to calculate a fresh
set of Savings Plans recommendations that takes your latest usage data and current Savings
Plans inventory into account. You can refresh Savings Plans recommendations up to three
times daily for a consolidated billing family.
StartSavingsPlansPurchaseRecommendationGeneration has no request syntax because no input
parameters are needed to support this operation.

"""
function start_savings_plans_purchase_recommendation_generation(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return cost_explorer(
        "StartSavingsPlansPurchaseRecommendationGeneration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_savings_plans_purchase_recommendation_generation(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cost_explorer(
        "StartSavingsPlansPurchaseRecommendationGeneration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, resource_tags)
    tag_resource(resource_arn, resource_tags, params::Dict{String,<:Any})

An API operation for adding one or more tags (key-value pairs) to a resource. You can use
the TagResource operation with a resource that already has tags. If you specify a new tag
key for the resource, this tag is appended to the list of tags associated with the
resource. If you specify a tag key that is already associated with the resource, the new
tag value you specify replaces the previous value for that tag. Although the maximum number
of array members is 200, user-tag maximum is 50. The remaining are reserved for Amazon Web
Services use.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource. For a list of supported
  resources, see ResourceTag.
- `resource_tags`:  A list of tag key-value pairs to be added to the resource. Each tag
  consists of a key and a value, and each key must be unique for the resource. The following
  restrictions apply to resource tags:   Although the maximum number of array members is 200,
  you can assign a maximum of 50 user-tags to one resource. The remaining are reserved for
  Amazon Web Services use   The maximum length of a key is 128 characters   The maximum
  length of a value is 256 characters   Keys and values can only contain alphanumeric
  characters, spaces, and any of the following: _.:/=+@-    Keys and values are case
  sensitive   Keys and values are trimmed for any leading or trailing whitespaces   Don’t
  use aws: as a prefix for your keys. This prefix is reserved for Amazon Web Services use

"""
function tag_resource(
    ResourceArn, ResourceTags; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cost_explorer(
        "TagResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "ResourceTags" => ResourceTags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceArn,
    ResourceTags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cost_explorer(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ResourceArn" => ResourceArn, "ResourceTags" => ResourceTags
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, resource_tag_keys)
    untag_resource(resource_arn, resource_tag_keys, params::Dict{String,<:Any})

Removes one or more tags from a resource. Specify only tag keys in your request. Don't
specify the value.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource. For a list of supported
  resources, see ResourceTag.
- `resource_tag_keys`: A list of tag keys associated with tags that need to be removed from
  the resource. If you specify a tag key that doesn't exist, it's ignored. Although the
  maximum number of array members is 200, user-tag maximum is 50. The remaining are reserved
  for Amazon Web Services use.

"""
function untag_resource(
    ResourceArn, ResourceTagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cost_explorer(
        "UntagResource",
        Dict{String,Any}(
            "ResourceArn" => ResourceArn, "ResourceTagKeys" => ResourceTagKeys
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceArn,
    ResourceTagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cost_explorer(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ResourceArn" => ResourceArn, "ResourceTagKeys" => ResourceTagKeys
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_anomaly_monitor(monitor_arn)
    update_anomaly_monitor(monitor_arn, params::Dict{String,<:Any})

Updates an existing cost anomaly monitor. The changes made are applied going forward, and
doesn't change anomalies detected in the past.

# Arguments
- `monitor_arn`: Cost anomaly monitor Amazon Resource Names (ARNs).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MonitorName"`: The new name for the cost anomaly monitor.
"""
function update_anomaly_monitor(
    MonitorArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cost_explorer(
        "UpdateAnomalyMonitor",
        Dict{String,Any}("MonitorArn" => MonitorArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_anomaly_monitor(
    MonitorArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cost_explorer(
        "UpdateAnomalyMonitor",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("MonitorArn" => MonitorArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_anomaly_subscription(subscription_arn)
    update_anomaly_subscription(subscription_arn, params::Dict{String,<:Any})

Updates an existing cost anomaly subscription. Specify the fields that you want to update.
Omitted fields are unchanged.  The JSON below describes the generic construct for each
type. See Request Parameters for possible values as they apply to AnomalySubscription.

# Arguments
- `subscription_arn`: A cost anomaly subscription Amazon Resource Name (ARN).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Frequency"`: The update to the frequency value that subscribers receive notifications.
- `"MonitorArnList"`: A list of cost anomaly monitor ARNs.
- `"Subscribers"`: The update to the subscriber list.
- `"SubscriptionName"`: The new name of the subscription.
- `"Threshold"`: (deprecated) The update to the threshold value for receiving
  notifications.  This field has been deprecated. To update a threshold, use
  ThresholdExpression. Continued use of Threshold will be treated as shorthand syntax for a
  ThresholdExpression. You can specify either Threshold or ThresholdExpression, but not both.
- `"ThresholdExpression"`: The update to the Expression object used to specify the
  anomalies that you want to generate alerts for. This supports dimensions and nested
  expressions. The supported dimensions are ANOMALY_TOTAL_IMPACT_ABSOLUTE and
  ANOMALY_TOTAL_IMPACT_PERCENTAGE, corresponding to an anomaly’s TotalImpact and
  TotalImpactPercentage, respectively (see Impact for more details). The supported nested
  expression types are AND and OR. The match option GREATER_THAN_OR_EQUAL is required. Values
  must be numbers between 0 and 10,000,000,000 in string format. You can specify either
  Threshold or ThresholdExpression, but not both. The following are examples of valid
  ThresholdExpressions:   Absolute threshold: { \"Dimensions\": { \"Key\":
  \"ANOMALY_TOTAL_IMPACT_ABSOLUTE\", \"MatchOptions\": [ \"GREATER_THAN_OR_EQUAL\" ],
  \"Values\": [ \"100\" ] } }    Percentage threshold: { \"Dimensions\": { \"Key\":
  \"ANOMALY_TOTAL_IMPACT_PERCENTAGE\", \"MatchOptions\": [ \"GREATER_THAN_OR_EQUAL\" ],
  \"Values\": [ \"100\" ] } }     AND two thresholds together: { \"And\": [ { \"Dimensions\":
  { \"Key\": \"ANOMALY_TOTAL_IMPACT_ABSOLUTE\", \"MatchOptions\": [ \"GREATER_THAN_OR_EQUAL\"
  ], \"Values\": [ \"100\" ] } }, { \"Dimensions\": { \"Key\":
  \"ANOMALY_TOTAL_IMPACT_PERCENTAGE\", \"MatchOptions\": [ \"GREATER_THAN_OR_EQUAL\" ],
  \"Values\": [ \"100\" ] } } ] }     OR two thresholds together: { \"Or\": [ {
  \"Dimensions\": { \"Key\": \"ANOMALY_TOTAL_IMPACT_ABSOLUTE\", \"MatchOptions\": [
  \"GREATER_THAN_OR_EQUAL\" ], \"Values\": [ \"100\" ] } }, { \"Dimensions\": { \"Key\":
  \"ANOMALY_TOTAL_IMPACT_PERCENTAGE\", \"MatchOptions\": [ \"GREATER_THAN_OR_EQUAL\" ],
  \"Values\": [ \"100\" ] } } ] }
"""
function update_anomaly_subscription(
    SubscriptionArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cost_explorer(
        "UpdateAnomalySubscription",
        Dict{String,Any}("SubscriptionArn" => SubscriptionArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_anomaly_subscription(
    SubscriptionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cost_explorer(
        "UpdateAnomalySubscription",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("SubscriptionArn" => SubscriptionArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_cost_allocation_tags_status(cost_allocation_tags_status)
    update_cost_allocation_tags_status(cost_allocation_tags_status, params::Dict{String,<:Any})

Updates status for cost allocation tags in bulk, with maximum batch size of 20. If the tag
status that's updated is the same as the existing tag status, the request doesn't fail.
Instead, it doesn't have any effect on the tag status (for example, activating the active
tag).

# Arguments
- `cost_allocation_tags_status`: The list of CostAllocationTagStatusEntry objects that are
  used to update cost allocation tags status for this request.

"""
function update_cost_allocation_tags_status(
    CostAllocationTagsStatus; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cost_explorer(
        "UpdateCostAllocationTagsStatus",
        Dict{String,Any}("CostAllocationTagsStatus" => CostAllocationTagsStatus);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_cost_allocation_tags_status(
    CostAllocationTagsStatus,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cost_explorer(
        "UpdateCostAllocationTagsStatus",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("CostAllocationTagsStatus" => CostAllocationTagsStatus),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_cost_category_definition(cost_category_arn, rule_version, rules)
    update_cost_category_definition(cost_category_arn, rule_version, rules, params::Dict{String,<:Any})

Updates an existing Cost Category. Changes made to the Cost Category rules will be used to
categorize the current month’s expenses and future expenses. This won’t change
categorization for the previous months.

# Arguments
- `cost_category_arn`: The unique identifier for your Cost Category.
- `rule_version`:
- `rules`: The Expression object used to categorize costs. For more information, see
  CostCategoryRule .

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DefaultValue"`:
- `"EffectiveStart"`: The Cost Category's effective start date. It can only be a billing
  start date (first day of the month). If the date isn't provided, it's the first day of the
  current month. Dates can't be before the previous twelve months, or in the future.
- `"SplitChargeRules"`:  The split charge rules used to allocate your charges between your
  Cost Category values.
"""
function update_cost_category_definition(
    CostCategoryArn, RuleVersion, Rules; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cost_explorer(
        "UpdateCostCategoryDefinition",
        Dict{String,Any}(
            "CostCategoryArn" => CostCategoryArn,
            "RuleVersion" => RuleVersion,
            "Rules" => Rules,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_cost_category_definition(
    CostCategoryArn,
    RuleVersion,
    Rules,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cost_explorer(
        "UpdateCostCategoryDefinition",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CostCategoryArn" => CostCategoryArn,
                    "RuleVersion" => RuleVersion,
                    "Rules" => Rules,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: ebs
using AWS.Compat
using AWS.UUIDs

"""
    complete_snapshot(snapshot_id, x-amz-_changed_blocks_count)
    complete_snapshot(snapshot_id, x-amz-_changed_blocks_count, params::Dict{String,<:Any})

Seals and completes the snapshot after all of the required blocks of data have been written
to it. Completing the snapshot changes the status to completed. You cannot write new blocks
to a snapshot after it has been completed.  You should always retry requests that receive
server (5xx) error responses, and ThrottlingException and RequestThrottledException client
error responses. For more information see Error retries in the Amazon Elastic Compute Cloud
User Guide.

# Arguments
- `snapshot_id`: The ID of the snapshot.
- `x-amz-_changed_blocks_count`: The number of blocks that were written to the snapshot.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"x-amz-Checksum"`: An aggregated Base-64 SHA256 checksum based on the checksums of each
  written block. To generate the aggregated checksum using the linear aggregation method,
  arrange the checksums for each written block in ascending order of their block index,
  concatenate them to form a single string, and then generate the checksum on the entire
  string using the SHA256 algorithm.
- `"x-amz-Checksum-Aggregation-Method"`: The aggregation method used to generate the
  checksum. Currently, the only supported aggregation method is LINEAR.
- `"x-amz-Checksum-Algorithm"`: The algorithm used to generate the checksum. Currently, the
  only supported algorithm is SHA256.
"""
function complete_snapshot(
    snapshotId, x_amz_ChangedBlocksCount; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ebs(
        "POST",
        "/snapshots/completion/$(snapshotId)",
        Dict{String,Any}(
            "headers" =>
                Dict{String,Any}("x-amz-ChangedBlocksCount" => x_amz_ChangedBlocksCount),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function complete_snapshot(
    snapshotId,
    x_amz_ChangedBlocksCount,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ebs(
        "POST",
        "/snapshots/completion/$(snapshotId)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "headers" => Dict{String,Any}(
                        "x-amz-ChangedBlocksCount" => x_amz_ChangedBlocksCount
                    ),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_snapshot_block(block_index, block_token, snapshot_id)
    get_snapshot_block(block_index, block_token, snapshot_id, params::Dict{String,<:Any})

Returns the data in a block in an Amazon Elastic Block Store snapshot.  You should always
retry requests that receive server (5xx) error responses, and ThrottlingException and
RequestThrottledException client error responses. For more information see Error retries in
the Amazon Elastic Compute Cloud User Guide.

# Arguments
- `block_index`: The block index of the block in which to read the data. A block index is a
  logical index in units of 512 KiB blocks. To identify the block index, divide the logical
  offset of the data in the logical volume by the block size (logical offset of data/524288).
  The logical offset of the data must be 512 KiB aligned.
- `block_token`: The block token of the block from which to get data. You can obtain the
  BlockToken by running the ListChangedBlocks or ListSnapshotBlocks operations.
- `snapshot_id`: The ID of the snapshot containing the block from which to get data.  If
  the specified snapshot is encrypted, you must have permission to use the KMS key that was
  used to encrypt the snapshot. For more information, see  Using encryption in the Amazon
  Elastic Compute Cloud User Guide.

"""
function get_snapshot_block(
    blockIndex, blockToken, snapshotId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ebs(
        "GET",
        "/snapshots/$(snapshotId)/blocks/$(blockIndex)",
        Dict{String,Any}("blockToken" => blockToken);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_snapshot_block(
    blockIndex,
    blockToken,
    snapshotId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ebs(
        "GET",
        "/snapshots/$(snapshotId)/blocks/$(blockIndex)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("blockToken" => blockToken), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_changed_blocks(second_snapshot_id)
    list_changed_blocks(second_snapshot_id, params::Dict{String,<:Any})

Returns information about the blocks that are different between two Amazon Elastic Block
Store snapshots of the same volume/snapshot lineage.  You should always retry requests that
receive server (5xx) error responses, and ThrottlingException and RequestThrottledException
client error responses. For more information see Error retries in the Amazon Elastic
Compute Cloud User Guide.

# Arguments
- `second_snapshot_id`: The ID of the second snapshot to use for the comparison.  The
  SecondSnapshotId parameter must be specified with a FirstSnapshotID parameter; otherwise,
  an error occurs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"firstSnapshotId"`: The ID of the first snapshot to use for the comparison.  The
  FirstSnapshotID parameter must be specified with a SecondSnapshotId parameter; otherwise,
  an error occurs.
- `"maxResults"`: The maximum number of blocks to be returned by the request. Even if
  additional blocks can be retrieved from the snapshot, the request can return less blocks
  than MaxResults or an empty array of blocks. To retrieve the next set of blocks from the
  snapshot, make another request with the returned NextToken value. The value of NextToken is
  null when there are no more blocks to return.
- `"pageToken"`: The token to request the next page of results. If you specify NextToken,
  then StartingBlockIndex is ignored.
- `"startingBlockIndex"`: The block index from which the comparison should start. The list
  in the response will start from this block index or the next valid block index in the
  snapshots. If you specify NextToken, then StartingBlockIndex is ignored.
"""
function list_changed_blocks(
    secondSnapshotId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ebs(
        "GET",
        "/snapshots/$(secondSnapshotId)/changedblocks";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_changed_blocks(
    secondSnapshotId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ebs(
        "GET",
        "/snapshots/$(secondSnapshotId)/changedblocks",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_snapshot_blocks(snapshot_id)
    list_snapshot_blocks(snapshot_id, params::Dict{String,<:Any})

Returns information about the blocks in an Amazon Elastic Block Store snapshot.  You should
always retry requests that receive server (5xx) error responses, and ThrottlingException
and RequestThrottledException client error responses. For more information see Error
retries in the Amazon Elastic Compute Cloud User Guide.

# Arguments
- `snapshot_id`: The ID of the snapshot from which to get block indexes and block tokens.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of blocks to be returned by the request. Even if
  additional blocks can be retrieved from the snapshot, the request can return less blocks
  than MaxResults or an empty array of blocks. To retrieve the next set of blocks from the
  snapshot, make another request with the returned NextToken value. The value of NextToken is
  null when there are no more blocks to return.
- `"pageToken"`: The token to request the next page of results. If you specify NextToken,
  then StartingBlockIndex is ignored.
- `"startingBlockIndex"`: The block index from which the list should start. The list in the
  response will start from this block index or the next valid block index in the snapshot. If
  you specify NextToken, then StartingBlockIndex is ignored.
"""
function list_snapshot_blocks(
    snapshotId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ebs(
        "GET",
        "/snapshots/$(snapshotId)/blocks";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_snapshot_blocks(
    snapshotId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ebs(
        "GET",
        "/snapshots/$(snapshotId)/blocks",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_snapshot_block(block_data, block_index, snapshot_id, x-amz-_checksum, x-amz-_checksum-_algorithm, x-amz-_data-_length)
    put_snapshot_block(block_data, block_index, snapshot_id, x-amz-_checksum, x-amz-_checksum-_algorithm, x-amz-_data-_length, params::Dict{String,<:Any})

Writes a block of data to a snapshot. If the specified block contains data, the existing
data is overwritten. The target snapshot must be in the pending state. Data written to a
snapshot must be aligned with 512-KiB sectors.  You should always retry requests that
receive server (5xx) error responses, and ThrottlingException and RequestThrottledException
client error responses. For more information see Error retries in the Amazon Elastic
Compute Cloud User Guide.

# Arguments
- `block_data`: The data to write to the block. The block data is not signed as part of the
  Signature Version 4 signing process. As a result, you must generate and provide a
  Base64-encoded SHA256 checksum for the block data using the x-amz-Checksum header. Also,
  you must specify the checksum algorithm using the x-amz-Checksum-Algorithm header. The
  checksum that you provide is part of the Signature Version 4 signing process. It is
  validated against a checksum generated by Amazon EBS to ensure the validity and
  authenticity of the data. If the checksums do not correspond, the request fails. For more
  information, see  Using checksums with the EBS direct APIs in the Amazon Elastic Compute
  Cloud User Guide.
- `block_index`: The block index of the block in which to write the data. A block index is
  a logical index in units of 512 KiB blocks. To identify the block index, divide the logical
  offset of the data in the logical volume by the block size (logical offset of data/524288).
  The logical offset of the data must be 512 KiB aligned.
- `snapshot_id`: The ID of the snapshot.  If the specified snapshot is encrypted, you must
  have permission to use the KMS key that was used to encrypt the snapshot. For more
  information, see  Using encryption in the Amazon Elastic Compute Cloud User Guide..
- `x-amz-_checksum`: A Base64-encoded SHA256 checksum of the data. Only SHA256 checksums
  are supported.
- `x-amz-_checksum-_algorithm`: The algorithm used to generate the checksum. Currently, the
  only supported algorithm is SHA256.
- `x-amz-_data-_length`: The size of the data to write to the block, in bytes. Currently,
  the only supported size is 524288 bytes. Valid values: 524288

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"x-amz-Progress"`: The progress of the write process, as a percentage.
"""
function put_snapshot_block(
    BlockData,
    blockIndex,
    snapshotId,
    x_amz_Checksum,
    x_amz_Checksum_Algorithm,
    x_amz_Data_Length;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ebs(
        "PUT",
        "/snapshots/$(snapshotId)/blocks/$(blockIndex)",
        Dict{String,Any}(
            "BlockData" => BlockData,
            "headers" => Dict{String,Any}(
                "x-amz-Checksum" => x_amz_Checksum,
                "x-amz-Checksum-Algorithm" => x_amz_Checksum_Algorithm,
                "x-amz-Data-Length" => x_amz_Data_Length,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_snapshot_block(
    BlockData,
    blockIndex,
    snapshotId,
    x_amz_Checksum,
    x_amz_Checksum_Algorithm,
    x_amz_Data_Length,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ebs(
        "PUT",
        "/snapshots/$(snapshotId)/blocks/$(blockIndex)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "BlockData" => BlockData,
                    "headers" => Dict{String,Any}(
                        "x-amz-Checksum" => x_amz_Checksum,
                        "x-amz-Checksum-Algorithm" => x_amz_Checksum_Algorithm,
                        "x-amz-Data-Length" => x_amz_Data_Length,
                    ),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_snapshot(volume_size)
    start_snapshot(volume_size, params::Dict{String,<:Any})

Creates a new Amazon EBS snapshot. The new snapshot enters the pending state after the
request completes.  After creating the snapshot, use  PutSnapshotBlock to write blocks of
data to the snapshot.  You should always retry requests that receive server (5xx) error
responses, and ThrottlingException and RequestThrottledException client error responses.
For more information see Error retries in the Amazon Elastic Compute Cloud User Guide.

# Arguments
- `volume_size`: The size of the volume, in GiB. The maximum size is 65536 GiB (64 TiB).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. Idempotency ensures that an API request completes only once.
  With an idempotent request, if the original request completes successfully. The subsequent
  retries with the same client token return the result from the original successful request
  and they have no additional effect. If you do not specify a client token, one is
  automatically generated by the Amazon Web Services SDK. For more information, see
  Idempotency for StartSnapshot API in the Amazon Elastic Compute Cloud User Guide.
- `"Description"`: A description for the snapshot.
- `"Encrypted"`: Indicates whether to encrypt the snapshot. You can't specify Encrypted and
   ParentSnapshotId in the same request. If you specify both parameters, the request fails
  with ValidationException. The encryption status of the snapshot depends on the values that
  you specify for Encrypted, KmsKeyArn, and ParentSnapshotId, and whether your Amazon Web
  Services account is enabled for  encryption by default. For more information, see  Using
  encryption in the Amazon Elastic Compute Cloud User Guide.  To create an encrypted
  snapshot, you must have permission to use the KMS key. For more information, see
  Permissions to use Key Management Service keys in the Amazon Elastic Compute Cloud User
  Guide.
- `"KmsKeyArn"`: The Amazon Resource Name (ARN) of the Key Management Service (KMS) key to
  be used to encrypt the snapshot. The encryption status of the snapshot depends on the
  values that you specify for Encrypted, KmsKeyArn, and ParentSnapshotId, and whether your
  Amazon Web Services account is enabled for  encryption by default. For more information,
  see  Using encryption in the Amazon Elastic Compute Cloud User Guide.  To create an
  encrypted snapshot, you must have permission to use the KMS key. For more information, see
  Permissions to use Key Management Service keys in the Amazon Elastic Compute Cloud User
  Guide.
- `"ParentSnapshotId"`: The ID of the parent snapshot. If there is no parent snapshot, or
  if you are creating the first snapshot for an on-premises volume, omit this parameter. You
  can't specify ParentSnapshotId and Encrypted in the same request. If you specify both
  parameters, the request fails with ValidationException. The encryption status of the
  snapshot depends on the values that you specify for Encrypted, KmsKeyArn, and
  ParentSnapshotId, and whether your Amazon Web Services account is enabled for  encryption
  by default. For more information, see  Using encryption in the Amazon Elastic Compute Cloud
  User Guide.  If you specify an encrypted parent snapshot, you must have permission to use
  the KMS key that was used to encrypt the parent snapshot. For more information, see
  Permissions to use Key Management Service keys in the Amazon Elastic Compute Cloud User
  Guide.
- `"Tags"`: The tags to apply to the snapshot.
- `"Timeout"`: The amount of time (in minutes) after which the snapshot is automatically
  cancelled if:   No blocks are written to the snapshot.   The snapshot is not completed
  after writing the last block of data.   If no value is specified, the timeout defaults to
  60 minutes.
"""
function start_snapshot(VolumeSize; aws_config::AbstractAWSConfig=current_aws_config())
    return ebs(
        "POST",
        "/snapshots",
        Dict{String,Any}("VolumeSize" => VolumeSize, "ClientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_snapshot(
    VolumeSize,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ebs(
        "POST",
        "/snapshots",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "VolumeSize" => VolumeSize, "ClientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: marketplace_catalog
using AWS.Compat
using AWS.UUIDs

"""
    batch_describe_entities(entity_request_list)
    batch_describe_entities(entity_request_list, params::Dict{String,<:Any})

Returns metadata and content for multiple entities. This is the Batch version of the
DescribeEntity API and uses the same IAM permission action as DescribeEntity API.

# Arguments
- `entity_request_list`: List of entity IDs and the catalogs the entities are present in.

"""
function batch_describe_entities(
    EntityRequestList; aws_config::AbstractAWSConfig=current_aws_config()
)
    return marketplace_catalog(
        "POST",
        "/BatchDescribeEntities",
        Dict{String,Any}("EntityRequestList" => EntityRequestList);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_describe_entities(
    EntityRequestList,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return marketplace_catalog(
        "POST",
        "/BatchDescribeEntities",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("EntityRequestList" => EntityRequestList), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_change_set(catalog, change_set_id)
    cancel_change_set(catalog, change_set_id, params::Dict{String,<:Any})

Used to cancel an open change request. Must be sent before the status of the request
changes to APPLYING, the final stage of completing your change request. You can describe a
change during the 60-day request history retention period for API calls.

# Arguments
- `catalog`: Required. The catalog related to the request. Fixed value: AWSMarketplace.
- `change_set_id`: Required. The unique identifier of the StartChangeSet request that you
  want to cancel.

"""
function cancel_change_set(
    catalog, changeSetId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return marketplace_catalog(
        "PATCH",
        "/CancelChangeSet",
        Dict{String,Any}("catalog" => catalog, "changeSetId" => changeSetId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_change_set(
    catalog,
    changeSetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return marketplace_catalog(
        "PATCH",
        "/CancelChangeSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("catalog" => catalog, "changeSetId" => changeSetId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_resource_policy(resource_arn)
    delete_resource_policy(resource_arn, params::Dict{String,<:Any})

Deletes a resource-based policy on an entity that is identified by its resource ARN.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the entity resource that is associated
  with the resource policy.

"""
function delete_resource_policy(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return marketplace_catalog(
        "DELETE",
        "/DeleteResourcePolicy",
        Dict{String,Any}("resourceArn" => resourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_resource_policy(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return marketplace_catalog(
        "DELETE",
        "/DeleteResourcePolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceArn" => resourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_change_set(catalog, change_set_id)
    describe_change_set(catalog, change_set_id, params::Dict{String,<:Any})

Provides information about a given change set.

# Arguments
- `catalog`: Required. The catalog related to the request. Fixed value: AWSMarketplace
- `change_set_id`: Required. The unique identifier for the StartChangeSet request that you
  want to describe the details for.

"""
function describe_change_set(
    catalog, changeSetId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return marketplace_catalog(
        "GET",
        "/DescribeChangeSet",
        Dict{String,Any}("catalog" => catalog, "changeSetId" => changeSetId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_change_set(
    catalog,
    changeSetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return marketplace_catalog(
        "GET",
        "/DescribeChangeSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("catalog" => catalog, "changeSetId" => changeSetId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_entity(catalog, entity_id)
    describe_entity(catalog, entity_id, params::Dict{String,<:Any})

Returns the metadata and content of the entity.

# Arguments
- `catalog`: Required. The catalog related to the request. Fixed value: AWSMarketplace
- `entity_id`: Required. The unique ID of the entity to describe.

"""
function describe_entity(
    catalog, entityId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return marketplace_catalog(
        "GET",
        "/DescribeEntity",
        Dict{String,Any}("catalog" => catalog, "entityId" => entityId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_entity(
    catalog,
    entityId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return marketplace_catalog(
        "GET",
        "/DescribeEntity",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("catalog" => catalog, "entityId" => entityId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_resource_policy(resource_arn)
    get_resource_policy(resource_arn, params::Dict{String,<:Any})

Gets a resource-based policy of an entity that is identified by its resource ARN.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the entity resource that is associated
  with the resource policy.

"""
function get_resource_policy(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return marketplace_catalog(
        "GET",
        "/GetResourcePolicy",
        Dict{String,Any}("resourceArn" => resourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_resource_policy(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return marketplace_catalog(
        "GET",
        "/GetResourcePolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceArn" => resourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_change_sets(catalog)
    list_change_sets(catalog, params::Dict{String,<:Any})

Returns the list of change sets owned by the account being used to make the call. You can
filter this list by providing any combination of entityId, ChangeSetName, and status. If
you provide more than one filter, the API operation applies a logical AND between the
filters. You can describe a change during the 60-day request history retention period for
API calls.

# Arguments
- `catalog`: The catalog related to the request. Fixed value: AWSMarketplace

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FilterList"`: An array of filter objects.
- `"MaxResults"`: The maximum number of results returned by a single call. This value must
  be provided in the next call to retrieve the next set of results. By default, this value is
  20.
- `"NextToken"`: The token value retrieved from a previous call to access the next page of
  results.
- `"Sort"`: An object that contains two attributes, SortBy and SortOrder.
"""
function list_change_sets(Catalog; aws_config::AbstractAWSConfig=current_aws_config())
    return marketplace_catalog(
        "POST",
        "/ListChangeSets",
        Dict{String,Any}("Catalog" => Catalog);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_change_sets(
    Catalog,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return marketplace_catalog(
        "POST",
        "/ListChangeSets",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Catalog" => Catalog), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_entities(catalog, entity_type)
    list_entities(catalog, entity_type, params::Dict{String,<:Any})

Provides the list of entities of a given type.

# Arguments
- `catalog`: The catalog related to the request. Fixed value: AWSMarketplace
- `entity_type`: The type of entities to retrieve. Valid values are: AmiProduct,
  ContainerProduct, DataProduct, SaaSProduct, ProcurementPolicy, Experience, Audience,
  BrandingSettings, Offer, Seller, ResaleAuthorization.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EntityTypeFilters"`: A Union object containing filter shapes for all EntityTypes. Each
  EntityTypeFilter shape will have filters applicable for that EntityType that can be used to
  search or filter entities.
- `"EntityTypeSort"`: A Union object containing Sort shapes for all EntityTypes. Each
  EntityTypeSort shape will have SortBy and SortOrder applicable for fields on that
  EntityType. This can be used to sort the results of the filter query.
- `"FilterList"`: An array of filter objects. Each filter object contains two attributes,
  filterName and filterValues.
- `"MaxResults"`: Specifies the upper limit of the elements on a single page. If a value
  isn't provided, the default value is 20.
- `"NextToken"`: The value of the next token, if it exists. Null if there are no more
  results.
- `"OwnershipType"`: Filters the returned set of entities based on their owner. The default
  is SELF. To list entities shared with you through AWS Resource Access Manager (AWS RAM),
  set to SHARED. Entities shared through the AWS Marketplace Catalog API PutResourcePolicy
  operation can't be discovered through the SHARED parameter.
- `"Sort"`: An object that contains two attributes, SortBy and SortOrder.
"""
function list_entities(
    Catalog, EntityType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return marketplace_catalog(
        "POST",
        "/ListEntities",
        Dict{String,Any}("Catalog" => Catalog, "EntityType" => EntityType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_entities(
    Catalog,
    EntityType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return marketplace_catalog(
        "POST",
        "/ListEntities",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Catalog" => Catalog, "EntityType" => EntityType),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists all tags that have been added to a resource (either an entity or change set).

# Arguments
- `resource_arn`: Required. The Amazon Resource Name (ARN) associated with the resource you
  want to list tags on.

"""
function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return marketplace_catalog(
        "POST",
        "/ListTagsForResource",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return marketplace_catalog(
        "POST",
        "/ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_resource_policy(policy, resource_arn)
    put_resource_policy(policy, resource_arn, params::Dict{String,<:Any})

Attaches a resource-based policy to an entity. Examples of an entity include: AmiProduct
and ContainerProduct.

# Arguments
- `policy`: The policy document to set; formatted in JSON.
- `resource_arn`: The Amazon Resource Name (ARN) of the entity resource you want to
  associate with a resource policy.

"""
function put_resource_policy(
    Policy, ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return marketplace_catalog(
        "POST",
        "/PutResourcePolicy",
        Dict{String,Any}("Policy" => Policy, "ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_resource_policy(
    Policy,
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return marketplace_catalog(
        "POST",
        "/PutResourcePolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Policy" => Policy, "ResourceArn" => ResourceArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_change_set(catalog, change_set)
    start_change_set(catalog, change_set, params::Dict{String,<:Any})

Allows you to request changes for your entities. Within a single ChangeSet, you can't start
the same change type against the same entity multiple times. Additionally, when a ChangeSet
is running, all the entities targeted by the different changes are locked until the change
set has completed (either succeeded, cancelled, or failed). If you try to start a change
set containing a change against an entity that is already locked, you will receive a
ResourceInUseException error. For example, you can't start the ChangeSet described in the
example later in this topic because it contains two changes to run the same change type
(AddRevisions) against the same entity (entity-id@1). For more information about working
with change sets, see  Working with change sets. For information about change types for
single-AMI products, see Working with single-AMI products. Also, for more information about
change types available for container-based products, see Working with container products.

# Arguments
- `catalog`: The catalog related to the request. Fixed value: AWSMarketplace
- `change_set`: Array of change object.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ChangeSetName"`: Optional case sensitive string of up to 100 ASCII characters. The
  change set name can be used to filter the list of change sets.
- `"ChangeSetTags"`: A list of objects specifying each key name and value for the
  ChangeSetTags property.
- `"ClientRequestToken"`: A unique token to identify the request to ensure idempotency.
- `"Intent"`: The intent related to the request. The default is APPLY. To test your request
  before applying changes to your entities, use VALIDATE. This feature is currently available
  for adding versions to single-AMI products. For more information, see Add a new version.
"""
function start_change_set(
    Catalog, ChangeSet; aws_config::AbstractAWSConfig=current_aws_config()
)
    return marketplace_catalog(
        "POST",
        "/StartChangeSet",
        Dict{String,Any}(
            "Catalog" => Catalog,
            "ChangeSet" => ChangeSet,
            "ClientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_change_set(
    Catalog,
    ChangeSet,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return marketplace_catalog(
        "POST",
        "/StartChangeSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Catalog" => Catalog,
                    "ChangeSet" => ChangeSet,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Tags a resource (either an entity or change set).

# Arguments
- `resource_arn`: Required. The Amazon Resource Name (ARN) associated with the resource you
  want to tag.
- `tags`: Required. A list of objects specifying each key name and value. Number of objects
  allowed: 1-50.

"""
function tag_resource(ResourceArn, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return marketplace_catalog(
        "POST",
        "/TagResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceArn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return marketplace_catalog(
        "POST",
        "/TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes a tag or list of tags from a resource (either an entity or change set).

# Arguments
- `resource_arn`: Required. The Amazon Resource Name (ARN) associated with the resource you
  want to remove the tag from.
- `tag_keys`: Required. A list of key names of tags to be removed. Number of strings
  allowed: 0-256.

"""
function untag_resource(
    ResourceArn, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return marketplace_catalog(
        "POST",
        "/UntagResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceArn,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return marketplace_catalog(
        "POST",
        "/UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: cloudhsm
using AWS.Compat
using AWS.UUIDs

"""
    add_tags_to_resource(resource_arn, tag_list)
    add_tags_to_resource(resource_arn, tag_list, params::Dict{String,<:Any})

This is documentation for AWS CloudHSM Classic. For more information, see AWS CloudHSM
Classic FAQs, the AWS CloudHSM Classic User Guide, and the AWS CloudHSM Classic API
Reference.  For information about the current version of AWS CloudHSM, see AWS CloudHSM,
the AWS CloudHSM User Guide, and the AWS CloudHSM API Reference. Adds or overwrites one or
more tags for the specified AWS CloudHSM resource. Each tag consists of a key and a value.
Tag keys must be unique to each resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the AWS CloudHSM resource to tag.
- `tag_list`: One or more tags.

"""
function add_tags_to_resource(
    ResourceArn, TagList; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudhsm(
        "AddTagsToResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "TagList" => TagList);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_tags_to_resource(
    ResourceArn,
    TagList,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudhsm(
        "AddTagsToResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "TagList" => TagList),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_hapg(label)
    create_hapg(label, params::Dict{String,<:Any})

This is documentation for AWS CloudHSM Classic. For more information, see AWS CloudHSM
Classic FAQs, the AWS CloudHSM Classic User Guide, and the AWS CloudHSM Classic API
Reference.  For information about the current version of AWS CloudHSM, see AWS CloudHSM,
the AWS CloudHSM User Guide, and the AWS CloudHSM API Reference. Creates a
high-availability partition group. A high-availability partition group is a group of
partitions that spans multiple physical HSMs.

# Arguments
- `label`: The label of the new high-availability partition group.

"""
function create_hapg(Label; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudhsm(
        "CreateHapg",
        Dict{String,Any}("Label" => Label);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_hapg(
    Label, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudhsm(
        "CreateHapg",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Label" => Label), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_hsm(iam_role_arn, ssh_key, subnet_id, subscription_type)
    create_hsm(iam_role_arn, ssh_key, subnet_id, subscription_type, params::Dict{String,<:Any})

This is documentation for AWS CloudHSM Classic. For more information, see AWS CloudHSM
Classic FAQs, the AWS CloudHSM Classic User Guide, and the AWS CloudHSM Classic API
Reference.  For information about the current version of AWS CloudHSM, see AWS CloudHSM,
the AWS CloudHSM User Guide, and the AWS CloudHSM API Reference. Creates an uninitialized
HSM instance. There is an upfront fee charged for each HSM instance that you create with
the CreateHsm operation. If you accidentally provision an HSM and want to request a refund,
delete the instance using the DeleteHsm operation, go to the AWS Support Center, create a
new case, and select Account and Billing Support.  It can take up to 20 minutes to create
and provision an HSM. You can monitor the status of the HSM with the DescribeHsm operation.
The HSM is ready to be initialized when the status changes to RUNNING.

# Arguments
- `iam_role_arn`: The ARN of an IAM role to enable the AWS CloudHSM service to allocate an
  ENI on your behalf.
- `ssh_key`: The SSH public key to install on the HSM.
- `subnet_id`: The identifier of the subnet in your VPC in which to place the HSM.
- `subscription_type`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: A user-defined token to ensure idempotence. Subsequent calls to this
  operation with the same token will be ignored.
- `"EniIp"`: The IP address to assign to the HSM's ENI. If an IP address is not specified,
  an IP address will be randomly chosen from the CIDR range of the subnet.
- `"ExternalId"`: The external ID from IamRoleArn, if present.
- `"SyslogIp"`: The IP address for the syslog monitoring server. The AWS CloudHSM service
  only supports one syslog monitoring server.
"""
function create_hsm(
    IamRoleArn,
    SshKey,
    SubnetId,
    SubscriptionType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudhsm(
        "CreateHsm",
        Dict{String,Any}(
            "IamRoleArn" => IamRoleArn,
            "SshKey" => SshKey,
            "SubnetId" => SubnetId,
            "SubscriptionType" => SubscriptionType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_hsm(
    IamRoleArn,
    SshKey,
    SubnetId,
    SubscriptionType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudhsm(
        "CreateHsm",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "IamRoleArn" => IamRoleArn,
                    "SshKey" => SshKey,
                    "SubnetId" => SubnetId,
                    "SubscriptionType" => SubscriptionType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_luna_client(certificate)
    create_luna_client(certificate, params::Dict{String,<:Any})

This is documentation for AWS CloudHSM Classic. For more information, see AWS CloudHSM
Classic FAQs, the AWS CloudHSM Classic User Guide, and the AWS CloudHSM Classic API
Reference.  For information about the current version of AWS CloudHSM, see AWS CloudHSM,
the AWS CloudHSM User Guide, and the AWS CloudHSM API Reference. Creates an HSM client.

# Arguments
- `certificate`: The contents of a Base64-Encoded X.509 v3 certificate to be installed on
  the HSMs used by this client.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Label"`: The label for the client.
"""
function create_luna_client(Certificate; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudhsm(
        "CreateLunaClient",
        Dict{String,Any}("Certificate" => Certificate);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_luna_client(
    Certificate,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudhsm(
        "CreateLunaClient",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Certificate" => Certificate), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_hapg(hapg_arn)
    delete_hapg(hapg_arn, params::Dict{String,<:Any})

This is documentation for AWS CloudHSM Classic. For more information, see AWS CloudHSM
Classic FAQs, the AWS CloudHSM Classic User Guide, and the AWS CloudHSM Classic API
Reference.  For information about the current version of AWS CloudHSM, see AWS CloudHSM,
the AWS CloudHSM User Guide, and the AWS CloudHSM API Reference. Deletes a
high-availability partition group.

# Arguments
- `hapg_arn`: The ARN of the high-availability partition group to delete.

"""
function delete_hapg(HapgArn; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudhsm(
        "DeleteHapg",
        Dict{String,Any}("HapgArn" => HapgArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_hapg(
    HapgArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudhsm(
        "DeleteHapg",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("HapgArn" => HapgArn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_hsm(hsm_arn)
    delete_hsm(hsm_arn, params::Dict{String,<:Any})

This is documentation for AWS CloudHSM Classic. For more information, see AWS CloudHSM
Classic FAQs, the AWS CloudHSM Classic User Guide, and the AWS CloudHSM Classic API
Reference.  For information about the current version of AWS CloudHSM, see AWS CloudHSM,
the AWS CloudHSM User Guide, and the AWS CloudHSM API Reference. Deletes an HSM. After
completion, this operation cannot be undone and your key material cannot be recovered.

# Arguments
- `hsm_arn`: The ARN of the HSM to delete.

"""
function delete_hsm(HsmArn; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudhsm(
        "DeleteHsm",
        Dict{String,Any}("HsmArn" => HsmArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_hsm(
    HsmArn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudhsm(
        "DeleteHsm",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("HsmArn" => HsmArn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_luna_client(client_arn)
    delete_luna_client(client_arn, params::Dict{String,<:Any})

This is documentation for AWS CloudHSM Classic. For more information, see AWS CloudHSM
Classic FAQs, the AWS CloudHSM Classic User Guide, and the AWS CloudHSM Classic API
Reference.  For information about the current version of AWS CloudHSM, see AWS CloudHSM,
the AWS CloudHSM User Guide, and the AWS CloudHSM API Reference. Deletes a client.

# Arguments
- `client_arn`: The ARN of the client to delete.

"""
function delete_luna_client(ClientArn; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudhsm(
        "DeleteLunaClient",
        Dict{String,Any}("ClientArn" => ClientArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_luna_client(
    ClientArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudhsm(
        "DeleteLunaClient",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ClientArn" => ClientArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_hapg(hapg_arn)
    describe_hapg(hapg_arn, params::Dict{String,<:Any})

This is documentation for AWS CloudHSM Classic. For more information, see AWS CloudHSM
Classic FAQs, the AWS CloudHSM Classic User Guide, and the AWS CloudHSM Classic API
Reference.  For information about the current version of AWS CloudHSM, see AWS CloudHSM,
the AWS CloudHSM User Guide, and the AWS CloudHSM API Reference. Retrieves information
about a high-availability partition group.

# Arguments
- `hapg_arn`: The ARN of the high-availability partition group to describe.

"""
function describe_hapg(HapgArn; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudhsm(
        "DescribeHapg",
        Dict{String,Any}("HapgArn" => HapgArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_hapg(
    HapgArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudhsm(
        "DescribeHapg",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("HapgArn" => HapgArn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_hsm()
    describe_hsm(params::Dict{String,<:Any})

This is documentation for AWS CloudHSM Classic. For more information, see AWS CloudHSM
Classic FAQs, the AWS CloudHSM Classic User Guide, and the AWS CloudHSM Classic API
Reference.  For information about the current version of AWS CloudHSM, see AWS CloudHSM,
the AWS CloudHSM User Guide, and the AWS CloudHSM API Reference. Retrieves information
about an HSM. You can identify the HSM by its ARN or its serial number.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"HsmArn"`: The ARN of the HSM. Either the HsmArn or the SerialNumber parameter must be
  specified.
- `"HsmSerialNumber"`: The serial number of the HSM. Either the HsmArn or the
  HsmSerialNumber parameter must be specified.
"""
function describe_hsm(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudhsm("DescribeHsm"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function describe_hsm(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudhsm(
        "DescribeHsm", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_luna_client()
    describe_luna_client(params::Dict{String,<:Any})

This is documentation for AWS CloudHSM Classic. For more information, see AWS CloudHSM
Classic FAQs, the AWS CloudHSM Classic User Guide, and the AWS CloudHSM Classic API
Reference.  For information about the current version of AWS CloudHSM, see AWS CloudHSM,
the AWS CloudHSM User Guide, and the AWS CloudHSM API Reference. Retrieves information
about an HSM client.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CertificateFingerprint"`: The certificate fingerprint.
- `"ClientArn"`: The ARN of the client.
"""
function describe_luna_client(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudhsm(
        "DescribeLunaClient"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_luna_client(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudhsm(
        "DescribeLunaClient", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_config(client_arn, client_version, hapg_list)
    get_config(client_arn, client_version, hapg_list, params::Dict{String,<:Any})

This is documentation for AWS CloudHSM Classic. For more information, see AWS CloudHSM
Classic FAQs, the AWS CloudHSM Classic User Guide, and the AWS CloudHSM Classic API
Reference.  For information about the current version of AWS CloudHSM, see AWS CloudHSM,
the AWS CloudHSM User Guide, and the AWS CloudHSM API Reference. Gets the configuration
files necessary to connect to all high availability partition groups the client is
associated with.

# Arguments
- `client_arn`: The ARN of the client.
- `client_version`: The client version.
- `hapg_list`: A list of ARNs that identify the high-availability partition groups that are
  associated with the client.

"""
function get_config(
    ClientArn, ClientVersion, HapgList; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudhsm(
        "GetConfig",
        Dict{String,Any}(
            "ClientArn" => ClientArn,
            "ClientVersion" => ClientVersion,
            "HapgList" => HapgList,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_config(
    ClientArn,
    ClientVersion,
    HapgList,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudhsm(
        "GetConfig",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClientArn" => ClientArn,
                    "ClientVersion" => ClientVersion,
                    "HapgList" => HapgList,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_available_zones()
    list_available_zones(params::Dict{String,<:Any})

This is documentation for AWS CloudHSM Classic. For more information, see AWS CloudHSM
Classic FAQs, the AWS CloudHSM Classic User Guide, and the AWS CloudHSM Classic API
Reference.  For information about the current version of AWS CloudHSM, see AWS CloudHSM,
the AWS CloudHSM User Guide, and the AWS CloudHSM API Reference. Lists the Availability
Zones that have available AWS CloudHSM capacity.

"""
function list_available_zones(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudhsm(
        "ListAvailableZones"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_available_zones(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudhsm(
        "ListAvailableZones", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_hapgs()
    list_hapgs(params::Dict{String,<:Any})

This is documentation for AWS CloudHSM Classic. For more information, see AWS CloudHSM
Classic FAQs, the AWS CloudHSM Classic User Guide, and the AWS CloudHSM Classic API
Reference.  For information about the current version of AWS CloudHSM, see AWS CloudHSM,
the AWS CloudHSM User Guide, and the AWS CloudHSM API Reference. Lists the
high-availability partition groups for the account. This operation supports pagination with
the use of the NextToken member. If more results are available, the NextToken member of the
response contains a token that you pass in the next call to ListHapgs to retrieve the next
set of items.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: The NextToken value from a previous call to ListHapgs. Pass null if this
  is the first call.
"""
function list_hapgs(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudhsm("ListHapgs"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_hapgs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudhsm(
        "ListHapgs", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_hsms()
    list_hsms(params::Dict{String,<:Any})

This is documentation for AWS CloudHSM Classic. For more information, see AWS CloudHSM
Classic FAQs, the AWS CloudHSM Classic User Guide, and the AWS CloudHSM Classic API
Reference.  For information about the current version of AWS CloudHSM, see AWS CloudHSM,
the AWS CloudHSM User Guide, and the AWS CloudHSM API Reference. Retrieves the identifiers
of all of the HSMs provisioned for the current customer. This operation supports pagination
with the use of the NextToken member. If more results are available, the NextToken member
of the response contains a token that you pass in the next call to ListHsms to retrieve the
next set of items.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: The NextToken value from a previous call to ListHsms. Pass null if this is
  the first call.
"""
function list_hsms(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudhsm("ListHsms"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_hsms(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudhsm(
        "ListHsms", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_luna_clients()
    list_luna_clients(params::Dict{String,<:Any})

This is documentation for AWS CloudHSM Classic. For more information, see AWS CloudHSM
Classic FAQs, the AWS CloudHSM Classic User Guide, and the AWS CloudHSM Classic API
Reference.  For information about the current version of AWS CloudHSM, see AWS CloudHSM,
the AWS CloudHSM User Guide, and the AWS CloudHSM API Reference. Lists all of the clients.
This operation supports pagination with the use of the NextToken member. If more results
are available, the NextToken member of the response contains a token that you pass in the
next call to ListLunaClients to retrieve the next set of items.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: The NextToken value from a previous call to ListLunaClients. Pass null if
  this is the first call.
"""
function list_luna_clients(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudhsm(
        "ListLunaClients"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_luna_clients(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudhsm(
        "ListLunaClients", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

This is documentation for AWS CloudHSM Classic. For more information, see AWS CloudHSM
Classic FAQs, the AWS CloudHSM Classic User Guide, and the AWS CloudHSM Classic API
Reference.  For information about the current version of AWS CloudHSM, see AWS CloudHSM,
the AWS CloudHSM User Guide, and the AWS CloudHSM API Reference. Returns a list of all tags
for the specified AWS CloudHSM resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the AWS CloudHSM resource.

"""
function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudhsm(
        "ListTagsForResource",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudhsm(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    modify_hapg(hapg_arn)
    modify_hapg(hapg_arn, params::Dict{String,<:Any})

This is documentation for AWS CloudHSM Classic. For more information, see AWS CloudHSM
Classic FAQs, the AWS CloudHSM Classic User Guide, and the AWS CloudHSM Classic API
Reference.  For information about the current version of AWS CloudHSM, see AWS CloudHSM,
the AWS CloudHSM User Guide, and the AWS CloudHSM API Reference. Modifies an existing
high-availability partition group.

# Arguments
- `hapg_arn`: The ARN of the high-availability partition group to modify.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Label"`: The new label for the high-availability partition group.
- `"PartitionSerialList"`: The list of partition serial numbers to make members of the
  high-availability partition group.
"""
function modify_hapg(HapgArn; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudhsm(
        "ModifyHapg",
        Dict{String,Any}("HapgArn" => HapgArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function modify_hapg(
    HapgArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudhsm(
        "ModifyHapg",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("HapgArn" => HapgArn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    modify_hsm(hsm_arn)
    modify_hsm(hsm_arn, params::Dict{String,<:Any})

This is documentation for AWS CloudHSM Classic. For more information, see AWS CloudHSM
Classic FAQs, the AWS CloudHSM Classic User Guide, and the AWS CloudHSM Classic API
Reference.  For information about the current version of AWS CloudHSM, see AWS CloudHSM,
the AWS CloudHSM User Guide, and the AWS CloudHSM API Reference. Modifies an HSM.  This
operation can result in the HSM being offline for up to 15 minutes while the AWS CloudHSM
service is reconfigured. If you are modifying a production HSM, you should ensure that your
AWS CloudHSM service is configured for high availability, and consider executing this
operation during a maintenance window.

# Arguments
- `hsm_arn`: The ARN of the HSM to modify.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EniIp"`: The new IP address for the elastic network interface (ENI) attached to the
  HSM. If the HSM is moved to a different subnet, and an IP address is not specified, an IP
  address will be randomly chosen from the CIDR range of the new subnet.
- `"ExternalId"`: The new external ID.
- `"IamRoleArn"`: The new IAM role ARN.
- `"SubnetId"`: The new identifier of the subnet that the HSM is in. The new subnet must be
  in the same Availability Zone as the current subnet.
- `"SyslogIp"`: The new IP address for the syslog monitoring server. The AWS CloudHSM
  service only supports one syslog monitoring server.
"""
function modify_hsm(HsmArn; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudhsm(
        "ModifyHsm",
        Dict{String,Any}("HsmArn" => HsmArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function modify_hsm(
    HsmArn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudhsm(
        "ModifyHsm",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("HsmArn" => HsmArn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    modify_luna_client(certificate, client_arn)
    modify_luna_client(certificate, client_arn, params::Dict{String,<:Any})

This is documentation for AWS CloudHSM Classic. For more information, see AWS CloudHSM
Classic FAQs, the AWS CloudHSM Classic User Guide, and the AWS CloudHSM Classic API
Reference.  For information about the current version of AWS CloudHSM, see AWS CloudHSM,
the AWS CloudHSM User Guide, and the AWS CloudHSM API Reference. Modifies the certificate
used by the client. This action can potentially start a workflow to install the new
certificate on the client's HSMs.

# Arguments
- `certificate`: The new certificate for the client.
- `client_arn`: The ARN of the client.

"""
function modify_luna_client(
    Certificate, ClientArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudhsm(
        "ModifyLunaClient",
        Dict{String,Any}("Certificate" => Certificate, "ClientArn" => ClientArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function modify_luna_client(
    Certificate,
    ClientArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudhsm(
        "ModifyLunaClient",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Certificate" => Certificate, "ClientArn" => ClientArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_tags_from_resource(resource_arn, tag_key_list)
    remove_tags_from_resource(resource_arn, tag_key_list, params::Dict{String,<:Any})

This is documentation for AWS CloudHSM Classic. For more information, see AWS CloudHSM
Classic FAQs, the AWS CloudHSM Classic User Guide, and the AWS CloudHSM Classic API
Reference.  For information about the current version of AWS CloudHSM, see AWS CloudHSM,
the AWS CloudHSM User Guide, and the AWS CloudHSM API Reference. Removes one or more tags
from the specified AWS CloudHSM resource. To remove a tag, specify only the tag key to
remove (not the value). To overwrite the value for an existing tag, use AddTagsToResource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the AWS CloudHSM resource.
- `tag_key_list`: The tag key or keys to remove. Specify only the tag key to remove (not
  the value). To overwrite the value for an existing tag, use AddTagsToResource.

"""
function remove_tags_from_resource(
    ResourceArn, TagKeyList; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudhsm(
        "RemoveTagsFromResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeyList" => TagKeyList);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_tags_from_resource(
    ResourceArn,
    TagKeyList,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudhsm(
        "RemoveTagsFromResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeyList" => TagKeyList),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: xray
using AWS.Compat
using AWS.UUIDs

"""
    batch_get_traces(trace_ids)
    batch_get_traces(trace_ids, params::Dict{String,<:Any})

Retrieves a list of traces specified by ID. Each trace is a collection of segment documents
that originates from a single request. Use GetTraceSummaries to get a list of trace IDs.

# Arguments
- `trace_ids`: Specify the trace IDs of requests for which to retrieve segments.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: Pagination token.
"""
function batch_get_traces(TraceIds; aws_config::AbstractAWSConfig=current_aws_config())
    return xray(
        "POST",
        "/Traces",
        Dict{String,Any}("TraceIds" => TraceIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_traces(
    TraceIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return xray(
        "POST",
        "/Traces",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TraceIds" => TraceIds), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_group(group_name)
    create_group(group_name, params::Dict{String,<:Any})

Creates a group resource with a name and a filter expression.

# Arguments
- `group_name`: The case-sensitive name of the new group. Default is a reserved name and
  names must be unique.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FilterExpression"`: The filter expression defining criteria by which to group traces.
- `"InsightsConfiguration"`: The structure containing configurations related to insights.
  The InsightsEnabled boolean can be set to true to enable insights for the new group or
  false to disable insights for the new group.   The NotificationsEnabled boolean can be set
  to true to enable insights notifications for the new group. Notifications may only be
  enabled on a group with InsightsEnabled set to true.
- `"Tags"`: A map that contains one or more tag keys and tag values to attach to an X-Ray
  group. For more information about ways to use tags, see Tagging Amazon Web Services
  resources in the Amazon Web Services General Reference. The following restrictions apply to
  tags:   Maximum number of user-applied tags per resource: 50   Maximum tag key length: 128
  Unicode characters   Maximum tag value length: 256 Unicode characters   Valid values for
  key and value: a-z, A-Z, 0-9, space, and the following characters: _ . : / = + - and @
  Tag keys and values are case sensitive.   Don't use aws: as a prefix for keys; it's
  reserved for Amazon Web Services use.
"""
function create_group(GroupName; aws_config::AbstractAWSConfig=current_aws_config())
    return xray(
        "POST",
        "/CreateGroup",
        Dict{String,Any}("GroupName" => GroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_group(
    GroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return xray(
        "POST",
        "/CreateGroup",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("GroupName" => GroupName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_sampling_rule(sampling_rule)
    create_sampling_rule(sampling_rule, params::Dict{String,<:Any})

Creates a rule to control sampling behavior for instrumented applications. Services
retrieve rules with GetSamplingRules, and evaluate each rule in ascending order of priority
for each request. If a rule matches, the service records a trace, borrowing it from the
reservoir size. After 10 seconds, the service reports back to X-Ray with GetSamplingTargets
to get updated versions of each in-use rule. The updated rule contains a trace quota that
the service can use instead of borrowing from the reservoir.

# Arguments
- `sampling_rule`: The rule definition.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: A map that contains one or more tag keys and tag values to attach to an X-Ray
  sampling rule. For more information about ways to use tags, see Tagging Amazon Web Services
  resources in the Amazon Web Services General Reference. The following restrictions apply to
  tags:   Maximum number of user-applied tags per resource: 50   Maximum tag key length: 128
  Unicode characters   Maximum tag value length: 256 Unicode characters   Valid values for
  key and value: a-z, A-Z, 0-9, space, and the following characters: _ . : / = + - and @
  Tag keys and values are case sensitive.   Don't use aws: as a prefix for keys; it's
  reserved for Amazon Web Services use.
"""
function create_sampling_rule(
    SamplingRule; aws_config::AbstractAWSConfig=current_aws_config()
)
    return xray(
        "POST",
        "/CreateSamplingRule",
        Dict{String,Any}("SamplingRule" => SamplingRule);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_sampling_rule(
    SamplingRule,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return xray(
        "POST",
        "/CreateSamplingRule",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("SamplingRule" => SamplingRule), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_group()
    delete_group(params::Dict{String,<:Any})

Deletes a group resource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"GroupARN"`: The ARN of the group that was generated on creation.
- `"GroupName"`: The case-sensitive name of the group.
"""
function delete_group(; aws_config::AbstractAWSConfig=current_aws_config())
    return xray(
        "POST", "/DeleteGroup"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function delete_group(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return xray(
        "POST",
        "/DeleteGroup",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_resource_policy(policy_name)
    delete_resource_policy(policy_name, params::Dict{String,<:Any})

Deletes a resource policy from the target Amazon Web Services account.

# Arguments
- `policy_name`: The name of the resource policy to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"PolicyRevisionId"`: Specifies a specific policy revision to delete. Provide a
  PolicyRevisionId to ensure an atomic delete operation. If the provided revision id does not
  match the latest policy revision id, an InvalidPolicyRevisionIdException exception is
  returned.
"""
function delete_resource_policy(
    PolicyName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return xray(
        "POST",
        "/DeleteResourcePolicy",
        Dict{String,Any}("PolicyName" => PolicyName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_resource_policy(
    PolicyName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return xray(
        "POST",
        "/DeleteResourcePolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("PolicyName" => PolicyName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_sampling_rule()
    delete_sampling_rule(params::Dict{String,<:Any})

Deletes a sampling rule.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"RuleARN"`: The ARN of the sampling rule. Specify a rule by either name or ARN, but not
  both.
- `"RuleName"`: The name of the sampling rule. Specify a rule by either name or ARN, but
  not both.
"""
function delete_sampling_rule(; aws_config::AbstractAWSConfig=current_aws_config())
    return xray(
        "POST",
        "/DeleteSamplingRule";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_sampling_rule(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return xray(
        "POST",
        "/DeleteSamplingRule",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_encryption_config()
    get_encryption_config(params::Dict{String,<:Any})

Retrieves the current encryption configuration for X-Ray data.

"""
function get_encryption_config(; aws_config::AbstractAWSConfig=current_aws_config())
    return xray(
        "POST", "/EncryptionConfig"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_encryption_config(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return xray(
        "POST",
        "/EncryptionConfig",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_group()
    get_group(params::Dict{String,<:Any})

Retrieves group resource details.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"GroupARN"`: The ARN of the group that was generated on creation.
- `"GroupName"`: The case-sensitive name of the group.
"""
function get_group(; aws_config::AbstractAWSConfig=current_aws_config())
    return xray("POST", "/GetGroup"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function get_group(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return xray(
        "POST", "/GetGroup", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_groups()
    get_groups(params::Dict{String,<:Any})

Retrieves all active group details.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: Pagination token.
"""
function get_groups(; aws_config::AbstractAWSConfig=current_aws_config())
    return xray("POST", "/Groups"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function get_groups(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return xray(
        "POST", "/Groups", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_insight(insight_id)
    get_insight(insight_id, params::Dict{String,<:Any})

Retrieves the summary information of an insight. This includes impact to clients and root
cause services, the top anomalous services, the category, the state of the insight, and the
start and end time of the insight.

# Arguments
- `insight_id`: The insight's unique identifier. Use the GetInsightSummaries action to
  retrieve an InsightId.

"""
function get_insight(InsightId; aws_config::AbstractAWSConfig=current_aws_config())
    return xray(
        "POST",
        "/Insight",
        Dict{String,Any}("InsightId" => InsightId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_insight(
    InsightId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return xray(
        "POST",
        "/Insight",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("InsightId" => InsightId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_insight_events(insight_id)
    get_insight_events(insight_id, params::Dict{String,<:Any})

X-Ray reevaluates insights periodically until they're resolved, and records each
intermediate state as an event. You can review an insight's events in the Impact Timeline
on the Inspect page in the X-Ray console.

# Arguments
- `insight_id`: The insight's unique identifier. Use the GetInsightSummaries action to
  retrieve an InsightId.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Used to retrieve at most the specified value of events.
- `"NextToken"`: Specify the pagination token returned by a previous request to retrieve
  the next page of events.
"""
function get_insight_events(InsightId; aws_config::AbstractAWSConfig=current_aws_config())
    return xray(
        "POST",
        "/InsightEvents",
        Dict{String,Any}("InsightId" => InsightId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_insight_events(
    InsightId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return xray(
        "POST",
        "/InsightEvents",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("InsightId" => InsightId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_insight_impact_graph(end_time, insight_id, start_time)
    get_insight_impact_graph(end_time, insight_id, start_time, params::Dict{String,<:Any})

Retrieves a service graph structure filtered by the specified insight. The service graph is
limited to only structural information. For a complete service graph, use this API with the
GetServiceGraph API.

# Arguments
- `end_time`: The estimated end time of the insight, in Unix time seconds. The EndTime is
  exclusive of the value provided. The time range between the start time and end time can't
  be more than six hours.
- `insight_id`: The insight's unique identifier. Use the GetInsightSummaries action to
  retrieve an InsightId.
- `start_time`: The estimated start time of the insight, in Unix time seconds. The
  StartTime is inclusive of the value provided and can't be more than 30 days old.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: Specify the pagination token returned by a previous request to retrieve
  the next page of results.
"""
function get_insight_impact_graph(
    EndTime, InsightId, StartTime; aws_config::AbstractAWSConfig=current_aws_config()
)
    return xray(
        "POST",
        "/InsightImpactGraph",
        Dict{String,Any}(
            "EndTime" => EndTime, "InsightId" => InsightId, "StartTime" => StartTime
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_insight_impact_graph(
    EndTime,
    InsightId,
    StartTime,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return xray(
        "POST",
        "/InsightImpactGraph",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EndTime" => EndTime, "InsightId" => InsightId, "StartTime" => StartTime
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_insight_summaries(end_time, start_time)
    get_insight_summaries(end_time, start_time, params::Dict{String,<:Any})

Retrieves the summaries of all insights in the specified group matching the provided filter
values.

# Arguments
- `end_time`: The end of the time frame in which the insights ended. The end time can't be
  more than 30 days old.
- `start_time`: The beginning of the time frame in which the insights started. The start
  time can't be more than 30 days old.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"GroupARN"`: The Amazon Resource Name (ARN) of the group. Required if the GroupName
  isn't provided.
- `"GroupName"`: The name of the group. Required if the GroupARN isn't provided.
- `"MaxResults"`: The maximum number of results to display.
- `"NextToken"`: Pagination token.
- `"States"`: The list of insight states.
"""
function get_insight_summaries(
    EndTime, StartTime; aws_config::AbstractAWSConfig=current_aws_config()
)
    return xray(
        "POST",
        "/InsightSummaries",
        Dict{String,Any}("EndTime" => EndTime, "StartTime" => StartTime);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_insight_summaries(
    EndTime,
    StartTime,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return xray(
        "POST",
        "/InsightSummaries",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("EndTime" => EndTime, "StartTime" => StartTime),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_sampling_rules()
    get_sampling_rules(params::Dict{String,<:Any})

Retrieves all sampling rules.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: Pagination token.
"""
function get_sampling_rules(; aws_config::AbstractAWSConfig=current_aws_config())
    return xray(
        "POST", "/GetSamplingRules"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_sampling_rules(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return xray(
        "POST",
        "/GetSamplingRules",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_sampling_statistic_summaries()
    get_sampling_statistic_summaries(params::Dict{String,<:Any})

Retrieves information about recent sampling results for all sampling rules.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: Pagination token.
"""
function get_sampling_statistic_summaries(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return xray(
        "POST",
        "/SamplingStatisticSummaries";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_sampling_statistic_summaries(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return xray(
        "POST",
        "/SamplingStatisticSummaries",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_sampling_targets(sampling_statistics_documents)
    get_sampling_targets(sampling_statistics_documents, params::Dict{String,<:Any})

Requests a sampling quota for rules that the service is using to sample requests.

# Arguments
- `sampling_statistics_documents`: Information about rules that the service is using to
  sample requests.

"""
function get_sampling_targets(
    SamplingStatisticsDocuments; aws_config::AbstractAWSConfig=current_aws_config()
)
    return xray(
        "POST",
        "/SamplingTargets",
        Dict{String,Any}("SamplingStatisticsDocuments" => SamplingStatisticsDocuments);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_sampling_targets(
    SamplingStatisticsDocuments,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return xray(
        "POST",
        "/SamplingTargets",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "SamplingStatisticsDocuments" => SamplingStatisticsDocuments
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_service_graph(end_time, start_time)
    get_service_graph(end_time, start_time, params::Dict{String,<:Any})

Retrieves a document that describes services that process incoming requests, and downstream
services that they call as a result. Root services process incoming requests and make calls
to downstream services. Root services are applications that use the Amazon Web Services
X-Ray SDK. Downstream services can be other applications, Amazon Web Services resources,
HTTP web APIs, or SQL databases.

# Arguments
- `end_time`: The end of the timeframe for which to generate a graph.
- `start_time`: The start of the time frame for which to generate a graph.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"GroupARN"`: The Amazon Resource Name (ARN) of a group based on which you want to
  generate a graph.
- `"GroupName"`: The name of a group based on which you want to generate a graph.
- `"NextToken"`: Pagination token.
"""
function get_service_graph(
    EndTime, StartTime; aws_config::AbstractAWSConfig=current_aws_config()
)
    return xray(
        "POST",
        "/ServiceGraph",
        Dict{String,Any}("EndTime" => EndTime, "StartTime" => StartTime);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_service_graph(
    EndTime,
    StartTime,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return xray(
        "POST",
        "/ServiceGraph",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("EndTime" => EndTime, "StartTime" => StartTime),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_time_series_service_statistics(end_time, start_time)
    get_time_series_service_statistics(end_time, start_time, params::Dict{String,<:Any})

Get an aggregation of service statistics defined by a specific time range.

# Arguments
- `end_time`: The end of the time frame for which to aggregate statistics.
- `start_time`: The start of the time frame for which to aggregate statistics.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EntitySelectorExpression"`: A filter expression defining entities that will be
  aggregated for statistics. Supports ID, service, and edge functions. If no selector
  expression is specified, edge statistics are returned.
- `"ForecastStatistics"`: The forecasted high and low fault count values. Forecast enabled
  requests require the EntitySelectorExpression ID be provided.
- `"GroupARN"`: The Amazon Resource Name (ARN) of the group for which to pull statistics
  from.
- `"GroupName"`: The case-sensitive name of the group for which to pull statistics from.
- `"NextToken"`: Pagination token.
- `"Period"`: Aggregation period in seconds.
"""
function get_time_series_service_statistics(
    EndTime, StartTime; aws_config::AbstractAWSConfig=current_aws_config()
)
    return xray(
        "POST",
        "/TimeSeriesServiceStatistics",
        Dict{String,Any}("EndTime" => EndTime, "StartTime" => StartTime);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_time_series_service_statistics(
    EndTime,
    StartTime,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return xray(
        "POST",
        "/TimeSeriesServiceStatistics",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("EndTime" => EndTime, "StartTime" => StartTime),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_trace_graph(trace_ids)
    get_trace_graph(trace_ids, params::Dict{String,<:Any})

Retrieves a service graph for one or more specific trace IDs.

# Arguments
- `trace_ids`: Trace IDs of requests for which to generate a service graph.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: Pagination token.
"""
function get_trace_graph(TraceIds; aws_config::AbstractAWSConfig=current_aws_config())
    return xray(
        "POST",
        "/TraceGraph",
        Dict{String,Any}("TraceIds" => TraceIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_trace_graph(
    TraceIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return xray(
        "POST",
        "/TraceGraph",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TraceIds" => TraceIds), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_trace_summaries(end_time, start_time)
    get_trace_summaries(end_time, start_time, params::Dict{String,<:Any})

Retrieves IDs and annotations for traces available for a specified time frame using an
optional filter. To get the full traces, pass the trace IDs to BatchGetTraces. A filter
expression can target traced requests that hit specific service nodes or edges, have
errors, or come from a known user. For example, the following filter expression targets
traces that pass through api.example.com:  service(\"api.example.com\")  This filter
expression finds traces that have an annotation named account with the value 12345:
annotation.account = \"12345\"  For a full list of indexed fields and keywords that you can
use in filter expressions, see Using Filter Expressions in the Amazon Web Services X-Ray
Developer Guide.

# Arguments
- `end_time`: The end of the time frame for which to retrieve traces.
- `start_time`: The start of the time frame for which to retrieve traces.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FilterExpression"`: Specify a filter expression to retrieve trace summaries for
  services or requests that meet certain requirements.
- `"NextToken"`: Specify the pagination token returned by a previous request to retrieve
  the next page of results.
- `"Sampling"`: Set to true to get summaries for only a subset of available traces.
- `"SamplingStrategy"`: A parameter to indicate whether to enable sampling on trace
  summaries. Input parameters are Name and Value.
- `"TimeRangeType"`: A parameter to indicate whether to query trace summaries by TraceId,
  Event (trace update time), or Service (segment end time).
"""
function get_trace_summaries(
    EndTime, StartTime; aws_config::AbstractAWSConfig=current_aws_config()
)
    return xray(
        "POST",
        "/TraceSummaries",
        Dict{String,Any}("EndTime" => EndTime, "StartTime" => StartTime);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_trace_summaries(
    EndTime,
    StartTime,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return xray(
        "POST",
        "/TraceSummaries",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("EndTime" => EndTime, "StartTime" => StartTime),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_resource_policies()
    list_resource_policies(params::Dict{String,<:Any})

Returns the list of resource policies in the target Amazon Web Services account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: Not currently supported.
"""
function list_resource_policies(; aws_config::AbstractAWSConfig=current_aws_config())
    return xray(
        "POST",
        "/ListResourcePolicies";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_resource_policies(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return xray(
        "POST",
        "/ListResourcePolicies",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Returns a list of tags that are applied to the specified Amazon Web Services X-Ray group or
sampling rule.

# Arguments
- `resource_arn`: The Amazon Resource Number (ARN) of an X-Ray group or sampling rule.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: A pagination token. If multiple pages of results are returned, use the
  NextToken value returned with the current page of results as the value of this parameter to
  get the next page of results.
"""
function list_tags_for_resource(
    ResourceARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return xray(
        "POST",
        "/ListTagsForResource",
        Dict{String,Any}("ResourceARN" => ResourceARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return xray(
        "POST",
        "/ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceARN" => ResourceARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_encryption_config(type)
    put_encryption_config(type, params::Dict{String,<:Any})

Updates the encryption configuration for X-Ray data.

# Arguments
- `type`: The type of encryption. Set to KMS to use your own key for encryption. Set to
  NONE for default encryption.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"KeyId"`: An Amazon Web Services KMS key in one of the following formats:    Alias - The
  name of the key. For example, alias/MyKey.    Key ID - The KMS key ID of the key. For
  example, ae4aa6d49-a4d8-9df9-a475-4ff6d7898456. Amazon Web Services X-Ray does not support
  asymmetric KMS keys.    ARN - The full Amazon Resource Name of the key ID or alias. For
  example, arn:aws:kms:us-east-2:123456789012:key/ae4aa6d49-a4d8-9df9-a475-4ff6d7898456. Use
  this format to specify a key in a different account.   Omit this key if you set Type to
  NONE.
"""
function put_encryption_config(Type; aws_config::AbstractAWSConfig=current_aws_config())
    return xray(
        "POST",
        "/PutEncryptionConfig",
        Dict{String,Any}("Type" => Type);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_encryption_config(
    Type, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return xray(
        "POST",
        "/PutEncryptionConfig",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Type" => Type), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_resource_policy(policy_document, policy_name)
    put_resource_policy(policy_document, policy_name, params::Dict{String,<:Any})

 Sets the resource policy to grant one or more Amazon Web Services services and accounts
permissions to access X-Ray. Each resource policy will be associated with a specific Amazon
Web Services account. Each Amazon Web Services account can have a maximum of 5 resource
policies, and each policy name must be unique within that account. The maximum size of each
resource policy is 5KB.

# Arguments
- `policy_document`: The resource policy document, which can be up to 5kb in size.
- `policy_name`: The name of the resource policy. Must be unique within a specific Amazon
  Web Services account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"BypassPolicyLockoutCheck"`: A flag to indicate whether to bypass the resource policy
  lockout safety check.  Setting this value to true increases the risk that the policy
  becomes unmanageable. Do not set this value to true indiscriminately.  Use this parameter
  only when you include a policy in the request and you intend to prevent the principal that
  is making the request from making a subsequent PutResourcePolicy request. The default value
  is false.
- `"PolicyRevisionId"`: Specifies a specific policy revision, to ensure an atomic create
  operation. By default the resource policy is created if it does not exist, or updated with
  an incremented revision id. The revision id is unique to each policy in the account. If the
  policy revision id does not match the latest revision id, the operation will fail with an
  InvalidPolicyRevisionIdException exception. You can also provide a PolicyRevisionId of 0.
  In this case, the operation will fail with an InvalidPolicyRevisionIdException exception if
  a resource policy with the same name already exists.
"""
function put_resource_policy(
    PolicyDocument, PolicyName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return xray(
        "POST",
        "/PutResourcePolicy",
        Dict{String,Any}("PolicyDocument" => PolicyDocument, "PolicyName" => PolicyName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_resource_policy(
    PolicyDocument,
    PolicyName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return xray(
        "POST",
        "/PutResourcePolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "PolicyDocument" => PolicyDocument, "PolicyName" => PolicyName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_telemetry_records(telemetry_records)
    put_telemetry_records(telemetry_records, params::Dict{String,<:Any})

Used by the Amazon Web Services X-Ray daemon to upload telemetry.

# Arguments
- `telemetry_records`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EC2InstanceId"`:
- `"Hostname"`:
- `"ResourceARN"`:
"""
function put_telemetry_records(
    TelemetryRecords; aws_config::AbstractAWSConfig=current_aws_config()
)
    return xray(
        "POST",
        "/TelemetryRecords",
        Dict{String,Any}("TelemetryRecords" => TelemetryRecords);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_telemetry_records(
    TelemetryRecords,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return xray(
        "POST",
        "/TelemetryRecords",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("TelemetryRecords" => TelemetryRecords), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_trace_segments(trace_segment_documents)
    put_trace_segments(trace_segment_documents, params::Dict{String,<:Any})

Uploads segment documents to Amazon Web Services X-Ray. The X-Ray SDK generates segment
documents and sends them to the X-Ray daemon, which uploads them in batches. A segment
document can be a completed segment, an in-progress segment, or an array of subsegments.
Segments must include the following fields. For the full segment document schema, see
Amazon Web Services X-Ray Segment Documents in the Amazon Web Services X-Ray Developer
Guide.  Required segment document fields     name - The name of the service that handled
the request.    id - A 64-bit identifier for the segment, unique among segments in the same
trace, in 16 hexadecimal digits.    trace_id - A unique identifier that connects all
segments and subsegments originating from a single client request.    start_time - Time the
segment or subsegment was created, in floating point seconds in epoch time, accurate to
milliseconds. For example, 1480615200.010 or 1.480615200010E9.    end_time - Time the
segment or subsegment was closed. For example, 1480615200.090 or 1.480615200090E9. Specify
either an end_time or in_progress.    in_progress - Set to true instead of specifying an
end_time to record that a segment has been started, but is not complete. Send an
in-progress segment when your application receives a request that will take a long time to
serve, to trace that the request was received. When the response is sent, send the complete
segment to overwrite the in-progress segment.   A trace_id consists of three numbers
separated by hyphens. For example, 1-58406520-a006649127e371903a2de979. This includes:
Trace ID Format    The version number, for instance, 1.   The time of the original request,
in Unix epoch time, in 8 hexadecimal digits. For example, 10:00AM December 2nd, 2016 PST in
epoch time is 1480615200 seconds, or 58406520 in hexadecimal.   A 96-bit identifier for the
trace, globally unique, in 24 hexadecimal digits.

# Arguments
- `trace_segment_documents`: A string containing a JSON document defining one or more
  segments or subsegments.

"""
function put_trace_segments(
    TraceSegmentDocuments; aws_config::AbstractAWSConfig=current_aws_config()
)
    return xray(
        "POST",
        "/TraceSegments",
        Dict{String,Any}("TraceSegmentDocuments" => TraceSegmentDocuments);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_trace_segments(
    TraceSegmentDocuments,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return xray(
        "POST",
        "/TraceSegments",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("TraceSegmentDocuments" => TraceSegmentDocuments),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Applies tags to an existing Amazon Web Services X-Ray group or sampling rule.

# Arguments
- `resource_arn`: The Amazon Resource Number (ARN) of an X-Ray group or sampling rule.
- `tags`: A map that contains one or more tag keys and tag values to attach to an X-Ray
  group or sampling rule. For more information about ways to use tags, see Tagging Amazon Web
  Services resources in the Amazon Web Services General Reference. The following restrictions
  apply to tags:   Maximum number of user-applied tags per resource: 50   Maximum tag key
  length: 128 Unicode characters   Maximum tag value length: 256 Unicode characters   Valid
  values for key and value: a-z, A-Z, 0-9, space, and the following characters: _ . : / = + -
  and @   Tag keys and values are case sensitive.   Don't use aws: as a prefix for keys; it's
  reserved for Amazon Web Services use. You cannot edit or delete system tags.

"""
function tag_resource(ResourceARN, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return xray(
        "POST",
        "/TagResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceARN,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return xray(
        "POST",
        "/TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes tags from an Amazon Web Services X-Ray group or sampling rule. You cannot edit or
delete system tags (those with an aws: prefix).

# Arguments
- `resource_arn`: The Amazon Resource Number (ARN) of an X-Ray group or sampling rule.
- `tag_keys`: Keys for one or more tags that you want to remove from an X-Ray group or
  sampling rule.

"""
function untag_resource(
    ResourceARN, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return xray(
        "POST",
        "/UntagResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceARN,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return xray(
        "POST",
        "/UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_group()
    update_group(params::Dict{String,<:Any})

Updates a group resource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FilterExpression"`: The updated filter expression defining criteria by which to group
  traces.
- `"GroupARN"`: The ARN that was generated upon creation.
- `"GroupName"`: The case-sensitive name of the group.
- `"InsightsConfiguration"`: The structure containing configurations related to insights.
  The InsightsEnabled boolean can be set to true to enable insights for the group or false to
  disable insights for the group.   The NotificationsEnabled boolean can be set to true to
  enable insights notifications for the group. Notifications can only be enabled on a group
  with InsightsEnabled set to true.
"""
function update_group(; aws_config::AbstractAWSConfig=current_aws_config())
    return xray(
        "POST", "/UpdateGroup"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function update_group(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return xray(
        "POST",
        "/UpdateGroup",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_sampling_rule(sampling_rule_update)
    update_sampling_rule(sampling_rule_update, params::Dict{String,<:Any})

Modifies a sampling rule's configuration.

# Arguments
- `sampling_rule_update`: The rule and fields to change.

"""
function update_sampling_rule(
    SamplingRuleUpdate; aws_config::AbstractAWSConfig=current_aws_config()
)
    return xray(
        "POST",
        "/UpdateSamplingRule",
        Dict{String,Any}("SamplingRuleUpdate" => SamplingRuleUpdate);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_sampling_rule(
    SamplingRuleUpdate,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return xray(
        "POST",
        "/UpdateSamplingRule",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("SamplingRuleUpdate" => SamplingRuleUpdate), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    DownloadsBackend <: AWS.AbstractBackend

This backend uses the Downloads.jl stdlib to use libcurl
as an HTTP client to connect to the AWS REST API.

It has one field,

- `downloader::Union{Nothing,Downloads.Downloader}`

which is the `Downloads.Downloader` to use. If set to `nothing`, the default,
then a global downloader object will be used.

Note that threading (e.g. `@spawn` or `@threads`) with Downloads.jl is broken on Julia releases prior to 1.8 (https://github.com/JuliaLang/Downloads.jl/issues/182#issuecomment-1069269944).
"""
struct DownloadsBackend <: AWS.AbstractBackend
    downloader::Union{Nothing,Downloads.Downloader}
end

DownloadsBackend() = DownloadsBackend(nothing)

const AWS_DOWNLOADER = Ref{Union{Nothing,Downloader}}(nothing)
const AWS_DOWNLOAD_LOCK = ReentrantLock()

# Here we mimic Download.jl's own setup for using a global downloader.
# We do this to have our own downloader (separate from Downloads.jl's global downloader)
# because we add a hook to avoid redirects in order to try to match the HTTPBackend's
# implementation, and we don't want to mutate the global downloader from Downloads.jl.
# https://github.com/JuliaLang/Downloads.jl/blob/84e948c02b8a0625552a764bf90f7d2ee97c949c/src/Downloads.jl#L293-L301
function get_downloader(downloader=nothing)
    lock(AWS_DOWNLOAD_LOCK) do
        yield() # let other downloads finish
        downloader isa Downloader && return nothing
        while true
            downloader = AWS_DOWNLOADER[]
            downloader isa Downloader && return nothing
            D = Downloader()
            D.easy_hook =
                (easy, info) -> Curl.setopt(easy, Curl.CURLOPT_FOLLOWLOCATION, false)
            AWS_DOWNLOADER[] = D
        end
    end
    return downloader
end

# https://github.com/JuliaWeb/HTTP.jl/blob/2a03ca76376162ffc3423ba7f15bd6d966edff9b/src/MessageRequest.jl#L84-L85
body_length(x::AbstractVector{UInt8}) = length(x)
body_length(x::AbstractString) = sizeof(x)

read_body(x::IOBuffer) = take!(x)
function read_body(x::IO)
    close(x)
    return read(x)
end

function _http_request(backend::DownloadsBackend, request::Request, response_stream::IO)
    # HTTP.jl sets this header automatically.
    request.headers["Content-Length"] = string(body_length(request.content))

    # We pass an `input` only when we have content we wish to send.
    input = !isempty(request.content) ? IOBuffer(request.content) : nothing

    downloader = @something(backend.downloader, get_downloader())

    # set the hook so that we don't follow redirects. Only
    # need to do this on per-request downloaders, because we
    # set our global one with this hook already.
    if backend.downloader !== nothing && downloader.easy_hook === nothing
        downloader.easy_hook =
            (easy, info) -> Curl.setopt(easy, Curl.CURLOPT_FOLLOWLOCATION, false)
    end

    local buffer
    local response

    check = function (s, e)
        return (isa(e, HTTP.StatusError) && AWS._http_status(e) >= 500) ||
               isa(e, Downloads.RequestError)
    end

    delays = AWSExponentialBackoff(; max_attempts=4)

    get_response = function ()
        # Use a sacrificial I/O stream so that we only write the `response_stream` once
        # even with multiple attempts.
        buffer = Base.BufferStream()

        # Rewind the input on each attempt otherwise every subsequent attempt will send an
        # empty payload.
        input !== nothing && seekstart(input)

        r = @mock Downloads.request(
            request.url;
            input=input,
            # Compatibility with Downloads.jl versions below v1.5.2
            # See: https://github.com/JuliaLang/Downloads.jl/issues/131
            output=request.request_method != "HEAD" ? buffer : nothing,
            method=request.request_method,
            headers=request.headers,
            verbose=false,
            throw=true,
            downloader=downloader,
        )

        response = _http_response(request, r; throw=true)
        # We'll rely on lexical scoping; `buffer` and `response`
        # are bindings in the outer scope, so we don't need to return here.
        return nothing
    end

    try
        retry(get_response; check=check, delays=delays)()
    finally
        close(buffer)

        # Transfer the contents of the `BufferStream` into `response_stream` variable.
        write(response_stream, buffer)
    end

    return AWS.Response(response, response_stream)
end

function _http_response(req::Request, res::Downloads.Response; throw::Bool=true)
    response = HTTP.Response(res.status, res.headers; body=IOBuffer(), request=nothing)

    if throw && HTTP.iserror(response)
        target = HTTP.resource(HTTP.URI(req.url))
        e = HTTP.StatusError(res.status, req.request_method, target, response)
        Base.throw(e)
    end

    return response
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: appfabric
using AWS.Compat
using AWS.UUIDs

"""
    batch_get_user_access_tasks(app_bundle_identifier, task_id_list)
    batch_get_user_access_tasks(app_bundle_identifier, task_id_list, params::Dict{String,<:Any})

Gets user access details in a batch request. This action polls data from the tasks that are
kicked off by the StartUserAccessTasks action.

# Arguments
- `app_bundle_identifier`: The Amazon Resource Name (ARN) or Universal Unique Identifier
  (UUID) of the app bundle to use for the request.
- `task_id_list`: The tasks IDs to use for the request.

"""
function batch_get_user_access_tasks(
    appBundleIdentifier, taskIdList; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appfabric(
        "POST",
        "/useraccess/batchget",
        Dict{String,Any}(
            "appBundleIdentifier" => appBundleIdentifier, "taskIdList" => taskIdList
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_user_access_tasks(
    appBundleIdentifier,
    taskIdList,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appfabric(
        "POST",
        "/useraccess/batchget",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "appBundleIdentifier" => appBundleIdentifier, "taskIdList" => taskIdList
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    connect_app_authorization(app_authorization_identifier, app_bundle_identifier)
    connect_app_authorization(app_authorization_identifier, app_bundle_identifier, params::Dict{String,<:Any})

Establishes a connection between Amazon Web Services AppFabric and an application, which
allows AppFabric to call the APIs of the application.

# Arguments
- `app_authorization_identifier`: The Amazon Resource Name (ARN) or Universal Unique
  Identifier (UUID) of the app authorization to use for the request.
- `app_bundle_identifier`: The Amazon Resource Name (ARN) or Universal Unique Identifier
  (UUID) of the app bundle that contains the app authorization to use for the request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"authRequest"`: Contains OAuth2 authorization information. This is required if the app
  authorization for the request is configured with an OAuth2 (oauth2) authorization type.
"""
function connect_app_authorization(
    appAuthorizationIdentifier,
    appBundleIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appfabric(
        "POST",
        "/appbundles/$(appBundleIdentifier)/appauthorizations/$(appAuthorizationIdentifier)/connect";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function connect_app_authorization(
    appAuthorizationIdentifier,
    appBundleIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appfabric(
        "POST",
        "/appbundles/$(appBundleIdentifier)/appauthorizations/$(appAuthorizationIdentifier)/connect",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_app_authorization(app, app_bundle_identifier, auth_type, credential, tenant)
    create_app_authorization(app, app_bundle_identifier, auth_type, credential, tenant, params::Dict{String,<:Any})

Creates an app authorization within an app bundle, which allows AppFabric to connect to an
application.

# Arguments
- `app`: The name of the application. Valid values are:    SLACK     ASANA     JIRA
  M365     M365AUDITLOGS     ZOOM     ZENDESK     OKTA     GOOGLE     DROPBOX     SMARTSHEET
     CISCO
- `app_bundle_identifier`: The Amazon Resource Name (ARN) or Universal Unique Identifier
  (UUID) of the app bundle to use for the request.
- `auth_type`: The authorization type for the app authorization.
- `credential`: Contains credentials for the application, such as an API key or OAuth2
  client ID and secret. Specify credentials that match the authorization type for your
  request. For example, if the authorization type for your request is OAuth2 (oauth2), then
  you should provide only the OAuth2 credentials.
- `tenant`: Contains information about an application tenant, such as the application
  display name and identifier.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Specifies a unique, case-sensitive identifier that you provide to ensure
  the idempotency of the request. This lets you safely retry the request without accidentally
  performing the same operation a second time. Passing the same value to a later call to an
  operation requires that you also pass the same value for all other parameters. We recommend
  that you use a UUID type of value. If you don't provide this value, then Amazon Web
  Services generates a random one for you. If you retry the operation with the same
  ClientToken, but with different parameters, the retry fails with an
  IdempotentParameterMismatch error.
- `"tags"`: A map of the key-value pairs of the tag or tags to assign to the resource.
"""
function create_app_authorization(
    app,
    appBundleIdentifier,
    authType,
    credential,
    tenant;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appfabric(
        "POST",
        "/appbundles/$(appBundleIdentifier)/appauthorizations",
        Dict{String,Any}(
            "app" => app,
            "authType" => authType,
            "credential" => credential,
            "tenant" => tenant,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_app_authorization(
    app,
    appBundleIdentifier,
    authType,
    credential,
    tenant,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appfabric(
        "POST",
        "/appbundles/$(appBundleIdentifier)/appauthorizations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "app" => app,
                    "authType" => authType,
                    "credential" => credential,
                    "tenant" => tenant,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_app_bundle()
    create_app_bundle(params::Dict{String,<:Any})

Creates an app bundle to collect data from an application using AppFabric.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Specifies a unique, case-sensitive identifier that you provide to ensure
  the idempotency of the request. This lets you safely retry the request without accidentally
  performing the same operation a second time. Passing the same value to a later call to an
  operation requires that you also pass the same value for all other parameters. We recommend
  that you use a UUID type of value. If you don't provide this value, then Amazon Web
  Services generates a random one for you. If you retry the operation with the same
  ClientToken, but with different parameters, the retry fails with an
  IdempotentParameterMismatch error.
- `"customerManagedKeyIdentifier"`: The Amazon Resource Name (ARN) of the Key Management
  Service (KMS) key to use to encrypt the application data. If this is not specified, an
  Amazon Web Services owned key is used for encryption.
- `"tags"`: A map of the key-value pairs of the tag or tags to assign to the resource.
"""
function create_app_bundle(; aws_config::AbstractAWSConfig=current_aws_config())
    return appfabric(
        "POST",
        "/appbundles",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_app_bundle(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appfabric(
        "POST",
        "/appbundles",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_ingestion(app, app_bundle_identifier, ingestion_type, tenant_id)
    create_ingestion(app, app_bundle_identifier, ingestion_type, tenant_id, params::Dict{String,<:Any})

Creates a data ingestion for an application.

# Arguments
- `app`: The name of the application. Valid values are:    SLACK     ASANA     JIRA
  M365     M365AUDITLOGS     ZOOM     ZENDESK     OKTA     GOOGLE     DROPBOX     SMARTSHEET
     CISCO
- `app_bundle_identifier`: The Amazon Resource Name (ARN) or Universal Unique Identifier
  (UUID) of the app bundle to use for the request.
- `ingestion_type`: The ingestion type.
- `tenant_id`: The ID of the application tenant.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Specifies a unique, case-sensitive identifier that you provide to ensure
  the idempotency of the request. This lets you safely retry the request without accidentally
  performing the same operation a second time. Passing the same value to a later call to an
  operation requires that you also pass the same value for all other parameters. We recommend
  that you use a UUID type of value. If you don't provide this value, then Amazon Web
  Services generates a random one for you. If you retry the operation with the same
  ClientToken, but with different parameters, the retry fails with an
  IdempotentParameterMismatch error.
- `"tags"`: A map of the key-value pairs of the tag or tags to assign to the resource.
"""
function create_ingestion(
    app,
    appBundleIdentifier,
    ingestionType,
    tenantId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appfabric(
        "POST",
        "/appbundles/$(appBundleIdentifier)/ingestions",
        Dict{String,Any}(
            "app" => app,
            "ingestionType" => ingestionType,
            "tenantId" => tenantId,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_ingestion(
    app,
    appBundleIdentifier,
    ingestionType,
    tenantId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appfabric(
        "POST",
        "/appbundles/$(appBundleIdentifier)/ingestions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "app" => app,
                    "ingestionType" => ingestionType,
                    "tenantId" => tenantId,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_ingestion_destination(app_bundle_identifier, destination_configuration, ingestion_identifier, processing_configuration)
    create_ingestion_destination(app_bundle_identifier, destination_configuration, ingestion_identifier, processing_configuration, params::Dict{String,<:Any})

Creates an ingestion destination, which specifies how an application's ingested data is
processed by Amazon Web Services AppFabric and where it's delivered.

# Arguments
- `app_bundle_identifier`: The Amazon Resource Name (ARN) or Universal Unique Identifier
  (UUID) of the app bundle to use for the request.
- `destination_configuration`: Contains information about the destination of ingested data.
- `ingestion_identifier`: The Amazon Resource Name (ARN) or Universal Unique Identifier
  (UUID) of the ingestion to use for the request.
- `processing_configuration`: Contains information about how ingested data is processed.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Specifies a unique, case-sensitive identifier that you provide to ensure
  the idempotency of the request. This lets you safely retry the request without accidentally
  performing the same operation a second time. Passing the same value to a later call to an
  operation requires that you also pass the same value for all other parameters. We recommend
  that you use a UUID type of value. If you don't provide this value, then Amazon Web
  Services generates a random one for you. If you retry the operation with the same
  ClientToken, but with different parameters, the retry fails with an
  IdempotentParameterMismatch error.
- `"tags"`: A map of the key-value pairs of the tag or tags to assign to the resource.
"""
function create_ingestion_destination(
    appBundleIdentifier,
    destinationConfiguration,
    ingestionIdentifier,
    processingConfiguration;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appfabric(
        "POST",
        "/appbundles/$(appBundleIdentifier)/ingestions/$(ingestionIdentifier)/ingestiondestinations",
        Dict{String,Any}(
            "destinationConfiguration" => destinationConfiguration,
            "processingConfiguration" => processingConfiguration,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_ingestion_destination(
    appBundleIdentifier,
    destinationConfiguration,
    ingestionIdentifier,
    processingConfiguration,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appfabric(
        "POST",
        "/appbundles/$(appBundleIdentifier)/ingestions/$(ingestionIdentifier)/ingestiondestinations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "destinationConfiguration" => destinationConfiguration,
                    "processingConfiguration" => processingConfiguration,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_app_authorization(app_authorization_identifier, app_bundle_identifier)
    delete_app_authorization(app_authorization_identifier, app_bundle_identifier, params::Dict{String,<:Any})

Deletes an app authorization. You must delete the associated ingestion before you can
delete an app authorization.

# Arguments
- `app_authorization_identifier`: The Amazon Resource Name (ARN) or Universal Unique
  Identifier (UUID) of the app authorization to use for the request.
- `app_bundle_identifier`: The Amazon Resource Name (ARN) or Universal Unique Identifier
  (UUID) of the app bundle to use for the request.

"""
function delete_app_authorization(
    appAuthorizationIdentifier,
    appBundleIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appfabric(
        "DELETE",
        "/appbundles/$(appBundleIdentifier)/appauthorizations/$(appAuthorizationIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_app_authorization(
    appAuthorizationIdentifier,
    appBundleIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appfabric(
        "DELETE",
        "/appbundles/$(appBundleIdentifier)/appauthorizations/$(appAuthorizationIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_app_bundle(app_bundle_identifier)
    delete_app_bundle(app_bundle_identifier, params::Dict{String,<:Any})

Deletes an app bundle. You must delete all associated app authorizations before you can
delete an app bundle.

# Arguments
- `app_bundle_identifier`: The ID or Amazon Resource Name (ARN) of the app bundle that
  needs to be deleted.

"""
function delete_app_bundle(
    appBundleIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appfabric(
        "DELETE",
        "/appbundles/$(appBundleIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_app_bundle(
    appBundleIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appfabric(
        "DELETE",
        "/appbundles/$(appBundleIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_ingestion(app_bundle_identifier, ingestion_identifier)
    delete_ingestion(app_bundle_identifier, ingestion_identifier, params::Dict{String,<:Any})

Deletes an ingestion. You must stop (disable) the ingestion and you must delete all
associated ingestion destinations before you can delete an app ingestion.

# Arguments
- `app_bundle_identifier`: The Amazon Resource Name (ARN) or Universal Unique Identifier
  (UUID) of the app bundle to use for the request.
- `ingestion_identifier`: The Amazon Resource Name (ARN) or Universal Unique Identifier
  (UUID) of the ingestion to use for the request.

"""
function delete_ingestion(
    appBundleIdentifier,
    ingestionIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appfabric(
        "DELETE",
        "/appbundles/$(appBundleIdentifier)/ingestions/$(ingestionIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_ingestion(
    appBundleIdentifier,
    ingestionIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appfabric(
        "DELETE",
        "/appbundles/$(appBundleIdentifier)/ingestions/$(ingestionIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_ingestion_destination(app_bundle_identifier, ingestion_destination_identifier, ingestion_identifier)
    delete_ingestion_destination(app_bundle_identifier, ingestion_destination_identifier, ingestion_identifier, params::Dict{String,<:Any})

Deletes an ingestion destination. This deletes the association between an ingestion and
it's destination. It doesn't delete previously ingested data or the storage destination,
such as the Amazon S3 bucket where the data is delivered. If the ingestion destination is
deleted while the associated ingestion is enabled, the ingestion will fail and is
eventually disabled.

# Arguments
- `app_bundle_identifier`: The Amazon Resource Name (ARN) or Universal Unique Identifier
  (UUID) of the app bundle to use for the request.
- `ingestion_destination_identifier`: The Amazon Resource Name (ARN) or Universal Unique
  Identifier (UUID) of the ingestion destination to use for the request.
- `ingestion_identifier`: The Amazon Resource Name (ARN) or Universal Unique Identifier
  (UUID) of the ingestion to use for the request.

"""
function delete_ingestion_destination(
    appBundleIdentifier,
    ingestionDestinationIdentifier,
    ingestionIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appfabric(
        "DELETE",
        "/appbundles/$(appBundleIdentifier)/ingestions/$(ingestionIdentifier)/ingestiondestinations/$(ingestionDestinationIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_ingestion_destination(
    appBundleIdentifier,
    ingestionDestinationIdentifier,
    ingestionIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appfabric(
        "DELETE",
        "/appbundles/$(appBundleIdentifier)/ingestions/$(ingestionIdentifier)/ingestiondestinations/$(ingestionDestinationIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_app_authorization(app_authorization_identifier, app_bundle_identifier)
    get_app_authorization(app_authorization_identifier, app_bundle_identifier, params::Dict{String,<:Any})

Returns information about an app authorization.

# Arguments
- `app_authorization_identifier`: The Amazon Resource Name (ARN) or Universal Unique
  Identifier (UUID) of the app authorization to use for the request.
- `app_bundle_identifier`: The Amazon Resource Name (ARN) or Universal Unique Identifier
  (UUID) of the app bundle to use for the request.

"""
function get_app_authorization(
    appAuthorizationIdentifier,
    appBundleIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appfabric(
        "GET",
        "/appbundles/$(appBundleIdentifier)/appauthorizations/$(appAuthorizationIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_app_authorization(
    appAuthorizationIdentifier,
    appBundleIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appfabric(
        "GET",
        "/appbundles/$(appBundleIdentifier)/appauthorizations/$(appAuthorizationIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_app_bundle(app_bundle_identifier)
    get_app_bundle(app_bundle_identifier, params::Dict{String,<:Any})

Returns information about an app bundle.

# Arguments
- `app_bundle_identifier`: The Amazon Resource Name (ARN) or Universal Unique Identifier
  (UUID) of the app bundle to use for the request.

"""
function get_app_bundle(
    appBundleIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appfabric(
        "GET",
        "/appbundles/$(appBundleIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_app_bundle(
    appBundleIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appfabric(
        "GET",
        "/appbundles/$(appBundleIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_ingestion(app_bundle_identifier, ingestion_identifier)
    get_ingestion(app_bundle_identifier, ingestion_identifier, params::Dict{String,<:Any})

Returns information about an ingestion.

# Arguments
- `app_bundle_identifier`: The Amazon Resource Name (ARN) or Universal Unique Identifier
  (UUID) of the app bundle to use for the request.
- `ingestion_identifier`: The Amazon Resource Name (ARN) or Universal Unique Identifier
  (UUID) of the ingestion to use for the request.

"""
function get_ingestion(
    appBundleIdentifier,
    ingestionIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appfabric(
        "GET",
        "/appbundles/$(appBundleIdentifier)/ingestions/$(ingestionIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_ingestion(
    appBundleIdentifier,
    ingestionIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appfabric(
        "GET",
        "/appbundles/$(appBundleIdentifier)/ingestions/$(ingestionIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_ingestion_destination(app_bundle_identifier, ingestion_destination_identifier, ingestion_identifier)
    get_ingestion_destination(app_bundle_identifier, ingestion_destination_identifier, ingestion_identifier, params::Dict{String,<:Any})

Returns information about an ingestion destination.

# Arguments
- `app_bundle_identifier`: The Amazon Resource Name (ARN) or Universal Unique Identifier
  (UUID) of the app bundle to use for the request.
- `ingestion_destination_identifier`: The Amazon Resource Name (ARN) or Universal Unique
  Identifier (UUID) of the ingestion destination to use for the request.
- `ingestion_identifier`: The Amazon Resource Name (ARN) or Universal Unique Identifier
  (UUID) of the ingestion to use for the request.

"""
function get_ingestion_destination(
    appBundleIdentifier,
    ingestionDestinationIdentifier,
    ingestionIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appfabric(
        "GET",
        "/appbundles/$(appBundleIdentifier)/ingestions/$(ingestionIdentifier)/ingestiondestinations/$(ingestionDestinationIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_ingestion_destination(
    appBundleIdentifier,
    ingestionDestinationIdentifier,
    ingestionIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appfabric(
        "GET",
        "/appbundles/$(appBundleIdentifier)/ingestions/$(ingestionIdentifier)/ingestiondestinations/$(ingestionDestinationIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_app_authorizations(app_bundle_identifier)
    list_app_authorizations(app_bundle_identifier, params::Dict{String,<:Any})

Returns a list of all app authorizations configured for an app bundle.

# Arguments
- `app_bundle_identifier`: The Amazon Resource Name (ARN) or Universal Unique Identifier
  (UUID) of the app bundle to use for the request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results that are returned per call. You can use
  nextToken to obtain further pages of results. This is only an upper limit. The actual
  number of results returned per call might be fewer than the specified maximum.
- `"nextToken"`: If nextToken is returned, there are more results available. The value of
  nextToken is a unique pagination token for each page. Make the call again using the
  returned token to retrieve the next page. Keep all other arguments unchanged. Each
  pagination token expires after 24 hours. Using an expired pagination token will return an
  HTTP 400 InvalidToken error.
"""
function list_app_authorizations(
    appBundleIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appfabric(
        "GET",
        "/appbundles/$(appBundleIdentifier)/appauthorizations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_app_authorizations(
    appBundleIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appfabric(
        "GET",
        "/appbundles/$(appBundleIdentifier)/appauthorizations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_app_bundles()
    list_app_bundles(params::Dict{String,<:Any})

Returns a list of app bundles.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results that are returned per call. You can use
  nextToken to obtain further pages of results. This is only an upper limit. The actual
  number of results returned per call might be fewer than the specified maximum.
- `"nextToken"`: If nextToken is returned, there are more results available. The value of
  nextToken is a unique pagination token for each page. Make the call again using the
  returned token to retrieve the next page. Keep all other arguments unchanged. Each
  pagination token expires after 24 hours. Using an expired pagination token will return an
  HTTP 400 InvalidToken error.
"""
function list_app_bundles(; aws_config::AbstractAWSConfig=current_aws_config())
    return appfabric(
        "GET", "/appbundles"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_app_bundles(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appfabric(
        "GET", "/appbundles", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_ingestion_destinations(app_bundle_identifier, ingestion_identifier)
    list_ingestion_destinations(app_bundle_identifier, ingestion_identifier, params::Dict{String,<:Any})

Returns a list of all ingestion destinations configured for an ingestion.

# Arguments
- `app_bundle_identifier`: The Amazon Resource Name (ARN) or Universal Unique Identifier
  (UUID) of the app bundle to use for the request.
- `ingestion_identifier`: The Amazon Resource Name (ARN) or Universal Unique Identifier
  (UUID) of the ingestion to use for the request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results that are returned per call. You can use
  nextToken to obtain further pages of results. This is only an upper limit. The actual
  number of results returned per call might be fewer than the specified maximum.
- `"nextToken"`: If nextToken is returned, there are more results available. The value of
  nextToken is a unique pagination token for each page. Make the call again using the
  returned token to retrieve the next page. Keep all other arguments unchanged. Each
  pagination token expires after 24 hours. Using an expired pagination token will return an
  HTTP 400 InvalidToken error.
"""
function list_ingestion_destinations(
    appBundleIdentifier,
    ingestionIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appfabric(
        "GET",
        "/appbundles/$(appBundleIdentifier)/ingestions/$(ingestionIdentifier)/ingestiondestinations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_ingestion_destinations(
    appBundleIdentifier,
    ingestionIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appfabric(
        "GET",
        "/appbundles/$(appBundleIdentifier)/ingestions/$(ingestionIdentifier)/ingestiondestinations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_ingestions(app_bundle_identifier)
    list_ingestions(app_bundle_identifier, params::Dict{String,<:Any})

Returns a list of all ingestions configured for an app bundle.

# Arguments
- `app_bundle_identifier`: The Amazon Resource Name (ARN) or Universal Unique Identifier
  (UUID) of the app bundle to use for the request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results that are returned per call. You can use
  nextToken to obtain further pages of results. This is only an upper limit. The actual
  number of results returned per call might be fewer than the specified maximum.
- `"nextToken"`: If nextToken is returned, there are more results available. The value of
  nextToken is a unique pagination token for each page. Make the call again using the
  returned token to retrieve the next page. Keep all other arguments unchanged. Each
  pagination token expires after 24 hours. Using an expired pagination token will return an
  HTTP 400 InvalidToken error.
"""
function list_ingestions(
    appBundleIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appfabric(
        "GET",
        "/appbundles/$(appBundleIdentifier)/ingestions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_ingestions(
    appBundleIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appfabric(
        "GET",
        "/appbundles/$(appBundleIdentifier)/ingestions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Returns a list of tags for a resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource for which you want to
  retrieve tags.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appfabric(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appfabric(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_ingestion(app_bundle_identifier, ingestion_identifier)
    start_ingestion(app_bundle_identifier, ingestion_identifier, params::Dict{String,<:Any})

Starts (enables) an ingestion, which collects data from an application.

# Arguments
- `app_bundle_identifier`: The Amazon Resource Name (ARN) or Universal Unique Identifier
  (UUID) of the app bundle to use for the request.
- `ingestion_identifier`: The Amazon Resource Name (ARN) or Universal Unique Identifier
  (UUID) of the ingestion to use for the request.

"""
function start_ingestion(
    appBundleIdentifier,
    ingestionIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appfabric(
        "POST",
        "/appbundles/$(appBundleIdentifier)/ingestions/$(ingestionIdentifier)/start";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_ingestion(
    appBundleIdentifier,
    ingestionIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appfabric(
        "POST",
        "/appbundles/$(appBundleIdentifier)/ingestions/$(ingestionIdentifier)/start",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_user_access_tasks(app_bundle_identifier, email)
    start_user_access_tasks(app_bundle_identifier, email, params::Dict{String,<:Any})

Starts the tasks to search user access status for a specific email address. The tasks are
stopped when the user access status data is found. The tasks are terminated when the API
calls to the application time out.

# Arguments
- `app_bundle_identifier`: The Amazon Resource Name (ARN) or Universal Unique Identifier
  (UUID) of the app bundle to use for the request.
- `email`: The email address of the target user.

"""
function start_user_access_tasks(
    appBundleIdentifier, email; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appfabric(
        "POST",
        "/useraccess/start",
        Dict{String,Any}("appBundleIdentifier" => appBundleIdentifier, "email" => email);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_user_access_tasks(
    appBundleIdentifier,
    email,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appfabric(
        "POST",
        "/useraccess/start",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "appBundleIdentifier" => appBundleIdentifier, "email" => email
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_ingestion(app_bundle_identifier, ingestion_identifier)
    stop_ingestion(app_bundle_identifier, ingestion_identifier, params::Dict{String,<:Any})

Stops (disables) an ingestion.

# Arguments
- `app_bundle_identifier`: The Amazon Resource Name (ARN) or Universal Unique Identifier
  (UUID) of the app bundle to use for the request.
- `ingestion_identifier`: The Amazon Resource Name (ARN) or Universal Unique Identifier
  (UUID) of the ingestion to use for the request.

"""
function stop_ingestion(
    appBundleIdentifier,
    ingestionIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appfabric(
        "POST",
        "/appbundles/$(appBundleIdentifier)/ingestions/$(ingestionIdentifier)/stop";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_ingestion(
    appBundleIdentifier,
    ingestionIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appfabric(
        "POST",
        "/appbundles/$(appBundleIdentifier)/ingestions/$(ingestionIdentifier)/stop",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Assigns one or more tags (key-value pairs) to the specified resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource that you want to tag.
- `tags`: A map of the key-value pairs of the tag or tags to assign to the resource.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return appfabric(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appfabric(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes a tag or tags from a resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource that you want to untag.
- `tag_keys`: The keys of the key-value pairs for the tag or tags you want to remove from
  the specified resource.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appfabric(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appfabric(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_app_authorization(app_authorization_identifier, app_bundle_identifier)
    update_app_authorization(app_authorization_identifier, app_bundle_identifier, params::Dict{String,<:Any})

Updates an app authorization within an app bundle, which allows AppFabric to connect to an
application. If the app authorization was in a connected state, updating the app
authorization will set it back to a PendingConnect state.

# Arguments
- `app_authorization_identifier`: The Amazon Resource Name (ARN) or Universal Unique
  Identifier (UUID) of the app authorization to use for the request.
- `app_bundle_identifier`: The Amazon Resource Name (ARN) or Universal Unique Identifier
  (UUID) of the app bundle to use for the request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"credential"`: Contains credentials for the application, such as an API key or OAuth2
  client ID and secret. Specify credentials that match the authorization type of the app
  authorization to update. For example, if the authorization type of the app authorization is
  OAuth2 (oauth2), then you should provide only the OAuth2 credentials.
- `"tenant"`: Contains information about an application tenant, such as the application
  display name and identifier.
"""
function update_app_authorization(
    appAuthorizationIdentifier,
    appBundleIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appfabric(
        "PATCH",
        "/appbundles/$(appBundleIdentifier)/appauthorizations/$(appAuthorizationIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_app_authorization(
    appAuthorizationIdentifier,
    appBundleIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appfabric(
        "PATCH",
        "/appbundles/$(appBundleIdentifier)/appauthorizations/$(appAuthorizationIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_ingestion_destination(app_bundle_identifier, destination_configuration, ingestion_destination_identifier, ingestion_identifier)
    update_ingestion_destination(app_bundle_identifier, destination_configuration, ingestion_destination_identifier, ingestion_identifier, params::Dict{String,<:Any})

Updates an ingestion destination, which specifies how an application's ingested data is
processed by Amazon Web Services AppFabric and where it's delivered.

# Arguments
- `app_bundle_identifier`: The Amazon Resource Name (ARN) or Universal Unique Identifier
  (UUID) of the app bundle to use for the request.
- `destination_configuration`: Contains information about the destination of ingested data.
- `ingestion_destination_identifier`: The Amazon Resource Name (ARN) or Universal Unique
  Identifier (UUID) of the ingestion destination to use for the request.
- `ingestion_identifier`: The Amazon Resource Name (ARN) or Universal Unique Identifier
  (UUID) of the ingestion to use for the request.

"""
function update_ingestion_destination(
    appBundleIdentifier,
    destinationConfiguration,
    ingestionDestinationIdentifier,
    ingestionIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appfabric(
        "PATCH",
        "/appbundles/$(appBundleIdentifier)/ingestions/$(ingestionIdentifier)/ingestiondestinations/$(ingestionDestinationIdentifier)",
        Dict{String,Any}("destinationConfiguration" => destinationConfiguration);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_ingestion_destination(
    appBundleIdentifier,
    destinationConfiguration,
    ingestionDestinationIdentifier,
    ingestionIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appfabric(
        "PATCH",
        "/appbundles/$(appBundleIdentifier)/ingestions/$(ingestionIdentifier)/ingestiondestinations/$(ingestionDestinationIdentifier)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("destinationConfiguration" => destinationConfiguration),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: ssm_sap
using AWS.Compat
using AWS.UUIDs

"""
    delete_resource_permission(resource_arn)
    delete_resource_permission(resource_arn, params::Dict{String,<:Any})

Removes permissions associated with the target database.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ActionType"`: Delete or restore the permissions on the target database.
- `"SourceResourceArn"`: The Amazon Resource Name (ARN) of the source resource.
"""
function delete_resource_permission(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_sap(
        "POST",
        "/delete-resource-permission",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_resource_permission(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_sap(
        "POST",
        "/delete-resource-permission",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    deregister_application(application_id)
    deregister_application(application_id, params::Dict{String,<:Any})

Deregister an SAP application with AWS Systems Manager for SAP. This action does not
aﬀect the existing setup of your SAP workloads on Amazon EC2.

# Arguments
- `application_id`: The ID of the application.

"""
function deregister_application(
    ApplicationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_sap(
        "POST",
        "/deregister-application",
        Dict{String,Any}("ApplicationId" => ApplicationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function deregister_application(
    ApplicationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_sap(
        "POST",
        "/deregister-application",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ApplicationId" => ApplicationId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_application()
    get_application(params::Dict{String,<:Any})

Gets an application registered with AWS Systems Manager for SAP. It also returns the
components of the application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AppRegistryArn"`: The Amazon Resource Name (ARN) of the application registry.
- `"ApplicationArn"`: The Amazon Resource Name (ARN) of the application.
- `"ApplicationId"`: The ID of the application.
"""
function get_application(; aws_config::AbstractAWSConfig=current_aws_config())
    return ssm_sap(
        "POST", "/get-application"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_application(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_sap(
        "POST",
        "/get-application",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_component(application_id, component_id)
    get_component(application_id, component_id, params::Dict{String,<:Any})

Gets the component of an application registered with AWS Systems Manager for SAP.

# Arguments
- `application_id`: The ID of the application.
- `component_id`: The ID of the component.

"""
function get_component(
    ApplicationId, ComponentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_sap(
        "POST",
        "/get-component",
        Dict{String,Any}("ApplicationId" => ApplicationId, "ComponentId" => ComponentId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_component(
    ApplicationId,
    ComponentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_sap(
        "POST",
        "/get-component",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationId" => ApplicationId, "ComponentId" => ComponentId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_database()
    get_database(params::Dict{String,<:Any})

Gets the SAP HANA database of an application registered with AWS Systems Manager for SAP.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ApplicationId"`: The ID of the application.
- `"ComponentId"`: The ID of the component.
- `"DatabaseArn"`: The Amazon Resource Name (ARN) of the database.
- `"DatabaseId"`: The ID of the database.
"""
function get_database(; aws_config::AbstractAWSConfig=current_aws_config())
    return ssm_sap(
        "POST", "/get-database"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_database(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_sap(
        "POST",
        "/get-database",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_operation(operation_id)
    get_operation(operation_id, params::Dict{String,<:Any})

Gets the details of an operation by specifying the operation ID.

# Arguments
- `operation_id`: The ID of the operation.

"""
function get_operation(OperationId; aws_config::AbstractAWSConfig=current_aws_config())
    return ssm_sap(
        "POST",
        "/get-operation",
        Dict{String,Any}("OperationId" => OperationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_operation(
    OperationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_sap(
        "POST",
        "/get-operation",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("OperationId" => OperationId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_resource_permission(resource_arn)
    get_resource_permission(resource_arn, params::Dict{String,<:Any})

Gets permissions associated with the target database.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ActionType"`:
"""
function get_resource_permission(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_sap(
        "POST",
        "/get-resource-permission",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_resource_permission(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_sap(
        "POST",
        "/get-resource-permission",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_applications()
    list_applications(params::Dict{String,<:Any})

Lists all the applications registered with AWS Systems Manager for SAP.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: The filter of name, value, and operator.
- `"MaxResults"`: The maximum number of results to return with a single call. To retrieve
  the remaining results, make another call with the returned nextToken value.
- `"NextToken"`: The token for the next page of results.
"""
function list_applications(; aws_config::AbstractAWSConfig=current_aws_config())
    return ssm_sap(
        "POST", "/list-applications"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_applications(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_sap(
        "POST",
        "/list-applications",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_components()
    list_components(params::Dict{String,<:Any})

Lists all the components registered with AWS Systems Manager for SAP.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ApplicationId"`: The ID of the application.
- `"MaxResults"`: The maximum number of results to return with a single call. To retrieve
  the remaining results, make another call with the returned nextToken value. If you do not
  specify a value for MaxResults, the request returns 50 items per page by default.
- `"NextToken"`: The token for the next page of results.
"""
function list_components(; aws_config::AbstractAWSConfig=current_aws_config())
    return ssm_sap(
        "POST", "/list-components"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_components(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_sap(
        "POST",
        "/list-components",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_databases()
    list_databases(params::Dict{String,<:Any})

Lists the SAP HANA databases of an application registered with AWS Systems Manager for SAP.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ApplicationId"`: The ID of the application.
- `"ComponentId"`: The ID of the component.
- `"MaxResults"`: The maximum number of results to return with a single call. To retrieve
  the remaining results, make another call with the returned nextToken value. If you do not
  specify a value for MaxResults, the request returns 50 items per page by default.
- `"NextToken"`: The token for the next page of results.
"""
function list_databases(; aws_config::AbstractAWSConfig=current_aws_config())
    return ssm_sap(
        "POST", "/list-databases"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_databases(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_sap(
        "POST",
        "/list-databases",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_operation_events(operation_id)
    list_operation_events(operation_id, params::Dict{String,<:Any})

Returns a list of operations events. Available parameters include OperationID, as well as
optional parameters MaxResults, NextToken, and Filters.

# Arguments
- `operation_id`: The ID of the operation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: Optionally specify filters to narrow the returned operation event items.
  Valid filter names include status, resourceID, and resourceType. The valid operator for all
  three filters is Equals.
- `"MaxResults"`: The maximum number of results to return with a single call. To retrieve
  the remaining results, make another call with the returned nextToken value. If you do not
  specify a value for MaxResults, the request returns 50 items per page by default.
- `"NextToken"`: The token to use to retrieve the next page of results. This value is null
  when there are no more results to return.
"""
function list_operation_events(
    OperationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_sap(
        "POST",
        "/list-operation-events",
        Dict{String,Any}("OperationId" => OperationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_operation_events(
    OperationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_sap(
        "POST",
        "/list-operation-events",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("OperationId" => OperationId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_operations(application_id)
    list_operations(application_id, params::Dict{String,<:Any})

Lists the operations performed by AWS Systems Manager for SAP.

# Arguments
- `application_id`: The ID of the application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: The filters of an operation.
- `"MaxResults"`: The maximum number of results to return with a single call. To retrieve
  the remaining results, make another call with the returned nextToken value. If you do not
  specify a value for MaxResults, the request returns 50 items per page by default.
- `"NextToken"`: The token for the next page of results.
"""
function list_operations(ApplicationId; aws_config::AbstractAWSConfig=current_aws_config())
    return ssm_sap(
        "POST",
        "/list-operations",
        Dict{String,Any}("ApplicationId" => ApplicationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_operations(
    ApplicationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_sap(
        "POST",
        "/list-operations",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ApplicationId" => ApplicationId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists all tags on an SAP HANA application and/or database registered with AWS Systems
Manager for SAP.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_sap(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_sap(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_resource_permission(action_type, resource_arn, source_resource_arn)
    put_resource_permission(action_type, resource_arn, source_resource_arn, params::Dict{String,<:Any})

Adds permissions to the target database.

# Arguments
- `action_type`:
- `resource_arn`:
- `source_resource_arn`:

"""
function put_resource_permission(
    ActionType,
    ResourceArn,
    SourceResourceArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_sap(
        "POST",
        "/put-resource-permission",
        Dict{String,Any}(
            "ActionType" => ActionType,
            "ResourceArn" => ResourceArn,
            "SourceResourceArn" => SourceResourceArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_resource_permission(
    ActionType,
    ResourceArn,
    SourceResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_sap(
        "POST",
        "/put-resource-permission",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ActionType" => ActionType,
                    "ResourceArn" => ResourceArn,
                    "SourceResourceArn" => SourceResourceArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    register_application(application_id, application_type, instances)
    register_application(application_id, application_type, instances, params::Dict{String,<:Any})

Register an SAP application with AWS Systems Manager for SAP. You must meet the following
requirements before registering.  The SAP application you want to register with AWS Systems
Manager for SAP is running on Amazon EC2. AWS Systems Manager Agent must be setup on an
Amazon EC2 instance along with the required IAM permissions. Amazon EC2 instance(s) must
have access to the secrets created in AWS Secrets Manager to manage SAP applications and
components.

# Arguments
- `application_id`: The ID of the application.
- `application_type`: The type of the application.
- `instances`: The Amazon EC2 instances on which your SAP application is running.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Credentials"`: The credentials of the SAP application.
- `"DatabaseArn"`: The Amazon Resource Name of the SAP HANA database.
- `"SapInstanceNumber"`: The SAP instance number of the application.
- `"Sid"`: The System ID of the application.
- `"Tags"`: The tags to be attached to the SAP application.
"""
function register_application(
    ApplicationId,
    ApplicationType,
    Instances;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_sap(
        "POST",
        "/register-application",
        Dict{String,Any}(
            "ApplicationId" => ApplicationId,
            "ApplicationType" => ApplicationType,
            "Instances" => Instances,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function register_application(
    ApplicationId,
    ApplicationType,
    Instances,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_sap(
        "POST",
        "/register-application",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationId" => ApplicationId,
                    "ApplicationType" => ApplicationType,
                    "Instances" => Instances,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_application(application_id)
    start_application(application_id, params::Dict{String,<:Any})

Request is an operation which starts an application. Parameter ApplicationId is required.

# Arguments
- `application_id`: The ID of the application.

"""
function start_application(
    ApplicationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_sap(
        "POST",
        "/start-application",
        Dict{String,Any}("ApplicationId" => ApplicationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_application(
    ApplicationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_sap(
        "POST",
        "/start-application",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ApplicationId" => ApplicationId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_application_refresh(application_id)
    start_application_refresh(application_id, params::Dict{String,<:Any})

Refreshes a registered application.

# Arguments
- `application_id`: The ID of the application.

"""
function start_application_refresh(
    ApplicationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_sap(
        "POST",
        "/start-application-refresh",
        Dict{String,Any}("ApplicationId" => ApplicationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_application_refresh(
    ApplicationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_sap(
        "POST",
        "/start-application-refresh",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ApplicationId" => ApplicationId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_application(application_id)
    stop_application(application_id, params::Dict{String,<:Any})

Request is an operation to stop an application. Parameter ApplicationId is required.
Parameters StopConnectedEntity and IncludeEc2InstanceShutdown are optional.

# Arguments
- `application_id`: The ID of the application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"IncludeEc2InstanceShutdown"`: Boolean. If included and if set to True, the
  StopApplication operation will shut down the associated Amazon EC2 instance in addition to
  the application.
- `"StopConnectedEntity"`: Specify the ConnectedEntityType. Accepted type is DBMS. If this
  parameter is included, the connected DBMS (Database Management System) will be stopped.
"""
function stop_application(ApplicationId; aws_config::AbstractAWSConfig=current_aws_config())
    return ssm_sap(
        "POST",
        "/stop-application",
        Dict{String,Any}("ApplicationId" => ApplicationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_application(
    ApplicationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_sap(
        "POST",
        "/stop-application",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ApplicationId" => ApplicationId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Creates tag for a resource by specifying the ARN.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.
- `tags`: The tags on a resource.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return ssm_sap(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_sap(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Delete the tags for a resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.
- `tag_keys`: Adds/updates or removes credentials for applications registered with AWS
  Systems Manager for SAP.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_sap(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_sap(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_application_settings(application_id)
    update_application_settings(application_id, params::Dict{String,<:Any})

Updates the settings of an application registered with AWS Systems Manager for SAP.

# Arguments
- `application_id`: The ID of the application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Backint"`: Installation of AWS Backint Agent for SAP HANA.
- `"CredentialsToAddOrUpdate"`: The credentials to be added or updated.
- `"CredentialsToRemove"`: The credentials to be removed.
- `"DatabaseArn"`: The Amazon Resource Name of the SAP HANA database that replaces the
  current SAP HANA connection with the SAP_ABAP application.
"""
function update_application_settings(
    ApplicationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_sap(
        "POST",
        "/update-application-settings",
        Dict{String,Any}("ApplicationId" => ApplicationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_application_settings(
    ApplicationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_sap(
        "POST",
        "/update-application-settings",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ApplicationId" => ApplicationId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: marketplace_deployment
using AWS.Compat
using AWS.UUIDs

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists all tags that have been added to a deployment parameter resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) associated with the deployment parameter
  resource you want to list tags on.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return marketplace_deployment(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return marketplace_deployment(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_deployment_parameter(agreement_id, catalog, deployment_parameter, product_id)
    put_deployment_parameter(agreement_id, catalog, deployment_parameter, product_id, params::Dict{String,<:Any})

Creates or updates a deployment parameter and is targeted by catalog and agreementId.

# Arguments
- `agreement_id`: The unique identifier of the agreement.
- `catalog`: The catalog related to the request. Fixed value: AWS Marketplace
- `deployment_parameter`: The deployment parameter targeted to the acceptor of an agreement
  for which to create the AWS Secret Manager resource.
- `product_id`: The product for which AWS Marketplace will save secrets for the buyer’s
  account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: The idempotency token for deployment parameters. A unique identifier for
  the new version.
- `"expirationDate"`: The date when deployment parameters expire and are scheduled for
  deletion.
- `"tags"`: A map of key-value pairs, where each pair represents a tag saved to the
  resource. Tags will only be applied for create operations, and they'll be ignored if the
  resource already exists.
"""
function put_deployment_parameter(
    agreementId,
    catalog,
    deploymentParameter,
    productId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return marketplace_deployment(
        "POST",
        "/catalogs/$(catalog)/products/$(productId)/deployment-parameters",
        Dict{String,Any}(
            "agreementId" => agreementId,
            "deploymentParameter" => deploymentParameter,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_deployment_parameter(
    agreementId,
    catalog,
    deploymentParameter,
    productId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return marketplace_deployment(
        "POST",
        "/catalogs/$(catalog)/products/$(productId)/deployment-parameters",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "agreementId" => agreementId,
                    "deploymentParameter" => deploymentParameter,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn)
    tag_resource(resource_arn, params::Dict{String,<:Any})

Tags a resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) associated with the resource you want to
  tag.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tags"`: A map of key-value pairs, where each pair represents a tag present on the
  resource.
"""
function tag_resource(resourceArn; aws_config::AbstractAWSConfig=current_aws_config())
    return marketplace_deployment(
        "POST",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return marketplace_deployment(
        "POST",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes a tag or list of tags from a resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) associated with the resource you want to
  remove the tag from.
- `tag_keys`: A list of key names of tags to be removed.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return marketplace_deployment(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return marketplace_deployment(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: frauddetector
using AWS.Compat
using AWS.UUIDs

"""
    batch_create_variable(variable_entries)
    batch_create_variable(variable_entries, params::Dict{String,<:Any})

Creates a batch of variables.

# Arguments
- `variable_entries`: The list of variables for the batch create variable request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tags"`: A collection of key and value pairs.
"""
function batch_create_variable(
    variableEntries; aws_config::AbstractAWSConfig=current_aws_config()
)
    return frauddetector(
        "BatchCreateVariable",
        Dict{String,Any}("variableEntries" => variableEntries);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_create_variable(
    variableEntries,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return frauddetector(
        "BatchCreateVariable",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("variableEntries" => variableEntries), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_get_variable(names)
    batch_get_variable(names, params::Dict{String,<:Any})

Gets a batch of variables.

# Arguments
- `names`: The list of variable names to get.

"""
function batch_get_variable(names; aws_config::AbstractAWSConfig=current_aws_config())
    return frauddetector(
        "BatchGetVariable",
        Dict{String,Any}("names" => names);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_variable(
    names, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return frauddetector(
        "BatchGetVariable",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("names" => names), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_batch_import_job(job_id)
    cancel_batch_import_job(job_id, params::Dict{String,<:Any})

 Cancels an in-progress batch import job.

# Arguments
- `job_id`:  The ID of an in-progress batch import job to cancel.  Amazon Fraud Detector
  will throw an error if the batch import job is in FAILED, CANCELED, or COMPLETED state.

"""
function cancel_batch_import_job(jobId; aws_config::AbstractAWSConfig=current_aws_config())
    return frauddetector(
        "CancelBatchImportJob",
        Dict{String,Any}("jobId" => jobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_batch_import_job(
    jobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return frauddetector(
        "CancelBatchImportJob",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("jobId" => jobId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_batch_prediction_job(job_id)
    cancel_batch_prediction_job(job_id, params::Dict{String,<:Any})

Cancels the specified batch prediction job.

# Arguments
- `job_id`: The ID of the batch prediction job to cancel.

"""
function cancel_batch_prediction_job(
    jobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return frauddetector(
        "CancelBatchPredictionJob",
        Dict{String,Any}("jobId" => jobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_batch_prediction_job(
    jobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return frauddetector(
        "CancelBatchPredictionJob",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("jobId" => jobId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_batch_import_job(event_type_name, iam_role_arn, input_path, job_id, output_path)
    create_batch_import_job(event_type_name, iam_role_arn, input_path, job_id, output_path, params::Dict{String,<:Any})

Creates a batch import job.

# Arguments
- `event_type_name`: The name of the event type.
- `iam_role_arn`: The ARN of the IAM role created for Amazon S3 bucket that holds your data
  file. The IAM role must have read permissions to your input S3 bucket and write permissions
  to your output S3 bucket. For more information about bucket permissions, see User policy
  examples in the Amazon S3 User Guide.
- `input_path`: The URI that points to the Amazon S3 location of your data file.
- `job_id`: The ID of the batch import job. The ID cannot be of a past job, unless the job
  exists in CREATE_FAILED state.
- `output_path`: The URI that points to the Amazon S3 location for storing your results.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tags"`: A collection of key-value pairs associated with this request.
"""
function create_batch_import_job(
    eventTypeName,
    iamRoleArn,
    inputPath,
    jobId,
    outputPath;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return frauddetector(
        "CreateBatchImportJob",
        Dict{String,Any}(
            "eventTypeName" => eventTypeName,
            "iamRoleArn" => iamRoleArn,
            "inputPath" => inputPath,
            "jobId" => jobId,
            "outputPath" => outputPath,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_batch_import_job(
    eventTypeName,
    iamRoleArn,
    inputPath,
    jobId,
    outputPath,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return frauddetector(
        "CreateBatchImportJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "eventTypeName" => eventTypeName,
                    "iamRoleArn" => iamRoleArn,
                    "inputPath" => inputPath,
                    "jobId" => jobId,
                    "outputPath" => outputPath,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_batch_prediction_job(detector_name, event_type_name, iam_role_arn, input_path, job_id, output_path)
    create_batch_prediction_job(detector_name, event_type_name, iam_role_arn, input_path, job_id, output_path, params::Dict{String,<:Any})

Creates a batch prediction job.

# Arguments
- `detector_name`: The name of the detector.
- `event_type_name`: The name of the event type.
- `iam_role_arn`: The ARN of the IAM role to use for this job request. The IAM Role must
  have read permissions to your input S3 bucket and write permissions to your output S3
  bucket. For more information about bucket permissions, see User policy examples in the
  Amazon S3 User Guide.
- `input_path`: The Amazon S3 location of your training file.
- `job_id`: The ID of the batch prediction job.
- `output_path`: The Amazon S3 location of your output file.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"detectorVersion"`: The detector version.
- `"tags"`: A collection of key and value pairs.
"""
function create_batch_prediction_job(
    detectorName,
    eventTypeName,
    iamRoleArn,
    inputPath,
    jobId,
    outputPath;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return frauddetector(
        "CreateBatchPredictionJob",
        Dict{String,Any}(
            "detectorName" => detectorName,
            "eventTypeName" => eventTypeName,
            "iamRoleArn" => iamRoleArn,
            "inputPath" => inputPath,
            "jobId" => jobId,
            "outputPath" => outputPath,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_batch_prediction_job(
    detectorName,
    eventTypeName,
    iamRoleArn,
    inputPath,
    jobId,
    outputPath,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return frauddetector(
        "CreateBatchPredictionJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "detectorName" => detectorName,
                    "eventTypeName" => eventTypeName,
                    "iamRoleArn" => iamRoleArn,
                    "inputPath" => inputPath,
                    "jobId" => jobId,
                    "outputPath" => outputPath,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_detector_version(detector_id, rules)
    create_detector_version(detector_id, rules, params::Dict{String,<:Any})

Creates a detector version. The detector version starts in a DRAFT status.

# Arguments
- `detector_id`: The ID of the detector under which you want to create a new version.
- `rules`: The rules to include in the detector version.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description of the detector version.
- `"externalModelEndpoints"`: The Amazon Sagemaker model endpoints to include in the
  detector version.
- `"modelVersions"`: The model versions to include in the detector version.
- `"ruleExecutionMode"`: The rule execution mode for the rules included in the detector
  version. You can define and edit the rule mode at the detector version level, when it is in
  draft status. If you specify FIRST_MATCHED, Amazon Fraud Detector evaluates rules
  sequentially, first to last, stopping at the first matched rule. Amazon Fraud dectector
  then provides the outcomes for that single rule. If you specifiy ALL_MATCHED, Amazon Fraud
  Detector evaluates all rules and returns the outcomes for all matched rules.  The default
  behavior is FIRST_MATCHED.
- `"tags"`: A collection of key and value pairs.
"""
function create_detector_version(
    detectorId, rules; aws_config::AbstractAWSConfig=current_aws_config()
)
    return frauddetector(
        "CreateDetectorVersion",
        Dict{String,Any}("detectorId" => detectorId, "rules" => rules);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_detector_version(
    detectorId,
    rules,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return frauddetector(
        "CreateDetectorVersion",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("detectorId" => detectorId, "rules" => rules),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_list(name)
    create_list(name, params::Dict{String,<:Any})

 Creates a list.  List is a set of input data for a variable in your event dataset. You use
the input data in a rule that's associated with your detector. For more information, see
Lists.

# Arguments
- `name`:  The name of the list.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`:  The description of the list.
- `"elements"`:  The names of the elements, if providing. You can also create an empty list
  and add elements later using the UpdateList API.
- `"tags"`:  A collection of the key and value pairs.
- `"variableType"`:  The variable type of the list. You can only assign the variable type
  with String data type. For more information, see Variable types.
"""
function create_list(name; aws_config::AbstractAWSConfig=current_aws_config())
    return frauddetector(
        "CreateList",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_list(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return frauddetector(
        "CreateList",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_model(event_type_name, model_id, model_type)
    create_model(event_type_name, model_id, model_type, params::Dict{String,<:Any})

Creates a model using the specified model type.

# Arguments
- `event_type_name`: The name of the event type.
- `model_id`: The model ID.
- `model_type`: The model type.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The model description.
- `"tags"`: A collection of key and value pairs.
"""
function create_model(
    eventTypeName, modelId, modelType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return frauddetector(
        "CreateModel",
        Dict{String,Any}(
            "eventTypeName" => eventTypeName, "modelId" => modelId, "modelType" => modelType
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_model(
    eventTypeName,
    modelId,
    modelType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return frauddetector(
        "CreateModel",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "eventTypeName" => eventTypeName,
                    "modelId" => modelId,
                    "modelType" => modelType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_model_version(model_id, model_type, training_data_schema, training_data_source)
    create_model_version(model_id, model_type, training_data_schema, training_data_source, params::Dict{String,<:Any})

Creates a version of the model using the specified model type and model id.

# Arguments
- `model_id`: The model ID.
- `model_type`: The model type.
- `training_data_schema`: The training data schema.
- `training_data_source`: The training data source location in Amazon S3.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"externalEventsDetail"`: Details of the external events data used for model version
  training. Required if trainingDataSource is EXTERNAL_EVENTS.
- `"ingestedEventsDetail"`: Details of the ingested events data used for model version
  training. Required if trainingDataSource is INGESTED_EVENTS.
- `"tags"`: A collection of key and value pairs.
"""
function create_model_version(
    modelId,
    modelType,
    trainingDataSchema,
    trainingDataSource;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return frauddetector(
        "CreateModelVersion",
        Dict{String,Any}(
            "modelId" => modelId,
            "modelType" => modelType,
            "trainingDataSchema" => trainingDataSchema,
            "trainingDataSource" => trainingDataSource,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_model_version(
    modelId,
    modelType,
    trainingDataSchema,
    trainingDataSource,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return frauddetector(
        "CreateModelVersion",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "modelId" => modelId,
                    "modelType" => modelType,
                    "trainingDataSchema" => trainingDataSchema,
                    "trainingDataSource" => trainingDataSource,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_rule(detector_id, expression, language, outcomes, rule_id)
    create_rule(detector_id, expression, language, outcomes, rule_id, params::Dict{String,<:Any})

Creates a rule for use with the specified detector.

# Arguments
- `detector_id`: The detector ID for the rule's parent detector.
- `expression`: The rule expression.
- `language`: The language of the rule.
- `outcomes`: The outcome or outcomes returned when the rule expression matches.
- `rule_id`: The rule ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The rule description.
- `"tags"`: A collection of key and value pairs.
"""
function create_rule(
    detectorId,
    expression,
    language,
    outcomes,
    ruleId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return frauddetector(
        "CreateRule",
        Dict{String,Any}(
            "detectorId" => detectorId,
            "expression" => expression,
            "language" => language,
            "outcomes" => outcomes,
            "ruleId" => ruleId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_rule(
    detectorId,
    expression,
    language,
    outcomes,
    ruleId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return frauddetector(
        "CreateRule",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "detectorId" => detectorId,
                    "expression" => expression,
                    "language" => language,
                    "outcomes" => outcomes,
                    "ruleId" => ruleId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_variable(data_source, data_type, default_value, name)
    create_variable(data_source, data_type, default_value, name, params::Dict{String,<:Any})

Creates a variable.

# Arguments
- `data_source`: The source of the data.
- `data_type`: The data type of the variable.
- `default_value`: The default value for the variable when no value is received.
- `name`: The name of the variable.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description.
- `"tags"`: A collection of key and value pairs.
- `"variableType"`: The variable type. For more information see Variable types.  Valid
  Values: AUTH_CODE | AVS | BILLING_ADDRESS_L1 | BILLING_ADDRESS_L2 | BILLING_CITY |
  BILLING_COUNTRY | BILLING_NAME | BILLING_PHONE | BILLING_STATE | BILLING_ZIP | CARD_BIN |
  CATEGORICAL | CURRENCY_CODE | EMAIL_ADDRESS | FINGERPRINT | FRAUD_LABEL | FREE_FORM_TEXT |
  IP_ADDRESS | NUMERIC | ORDER_ID | PAYMENT_TYPE | PHONE_NUMBER | PRICE | PRODUCT_CATEGORY |
  SHIPPING_ADDRESS_L1 | SHIPPING_ADDRESS_L2 | SHIPPING_CITY | SHIPPING_COUNTRY |
  SHIPPING_NAME | SHIPPING_PHONE | SHIPPING_STATE | SHIPPING_ZIP | USERAGENT
"""
function create_variable(
    dataSource,
    dataType,
    defaultValue,
    name;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return frauddetector(
        "CreateVariable",
        Dict{String,Any}(
            "dataSource" => dataSource,
            "dataType" => dataType,
            "defaultValue" => defaultValue,
            "name" => name,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_variable(
    dataSource,
    dataType,
    defaultValue,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return frauddetector(
        "CreateVariable",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "dataSource" => dataSource,
                    "dataType" => dataType,
                    "defaultValue" => defaultValue,
                    "name" => name,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_batch_import_job(job_id)
    delete_batch_import_job(job_id, params::Dict{String,<:Any})

Deletes the specified batch import job ID record. This action does not delete the data that
was batch imported.

# Arguments
- `job_id`: The ID of the batch import job to delete.

"""
function delete_batch_import_job(jobId; aws_config::AbstractAWSConfig=current_aws_config())
    return frauddetector(
        "DeleteBatchImportJob",
        Dict{String,Any}("jobId" => jobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_batch_import_job(
    jobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return frauddetector(
        "DeleteBatchImportJob",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("jobId" => jobId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_batch_prediction_job(job_id)
    delete_batch_prediction_job(job_id, params::Dict{String,<:Any})

Deletes a batch prediction job.

# Arguments
- `job_id`: The ID of the batch prediction job to delete.

"""
function delete_batch_prediction_job(
    jobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return frauddetector(
        "DeleteBatchPredictionJob",
        Dict{String,Any}("jobId" => jobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_batch_prediction_job(
    jobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return frauddetector(
        "DeleteBatchPredictionJob",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("jobId" => jobId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_detector(detector_id)
    delete_detector(detector_id, params::Dict{String,<:Any})

Deletes the detector. Before deleting a detector, you must first delete all detector
versions and rule versions associated with the detector. When you delete a detector, Amazon
Fraud Detector permanently deletes the detector and the data is no longer stored in Amazon
Fraud Detector.

# Arguments
- `detector_id`: The ID of the detector to delete.

"""
function delete_detector(detectorId; aws_config::AbstractAWSConfig=current_aws_config())
    return frauddetector(
        "DeleteDetector",
        Dict{String,Any}("detectorId" => detectorId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_detector(
    detectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return frauddetector(
        "DeleteDetector",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("detectorId" => detectorId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_detector_version(detector_id, detector_version_id)
    delete_detector_version(detector_id, detector_version_id, params::Dict{String,<:Any})

Deletes the detector version. You cannot delete detector versions that are in ACTIVE
status. When you delete a detector version, Amazon Fraud Detector permanently deletes the
detector and the data is no longer stored in Amazon Fraud Detector.

# Arguments
- `detector_id`: The ID of the parent detector for the detector version to delete.
- `detector_version_id`: The ID of the detector version to delete.

"""
function delete_detector_version(
    detectorId, detectorVersionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return frauddetector(
        "DeleteDetectorVersion",
        Dict{String,Any}(
            "detectorId" => detectorId, "detectorVersionId" => detectorVersionId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_detector_version(
    detectorId,
    detectorVersionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return frauddetector(
        "DeleteDetectorVersion",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "detectorId" => detectorId, "detectorVersionId" => detectorVersionId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_entity_type(name)
    delete_entity_type(name, params::Dict{String,<:Any})

Deletes an entity type. You cannot delete an entity type that is included in an event type.
When you delete an entity type, Amazon Fraud Detector permanently deletes that entity type
and the data is no longer stored in Amazon Fraud Detector.

# Arguments
- `name`: The name of the entity type to delete.

"""
function delete_entity_type(name; aws_config::AbstractAWSConfig=current_aws_config())
    return frauddetector(
        "DeleteEntityType",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_entity_type(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return frauddetector(
        "DeleteEntityType",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_event(event_id, event_type_name)
    delete_event(event_id, event_type_name, params::Dict{String,<:Any})

Deletes the specified event. When you delete an event, Amazon Fraud Detector permanently
deletes that event and the event data is no longer stored in Amazon Fraud Detector. If
deleteAuditHistory is True, event data is available through search for up to 30 seconds
after the delete operation is completed.

# Arguments
- `event_id`: The ID of the event to delete.
- `event_type_name`: The name of the event type.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"deleteAuditHistory"`: Specifies whether or not to delete any predictions associated
  with the event. If set to True,
"""
function delete_event(
    eventId, eventTypeName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return frauddetector(
        "DeleteEvent",
        Dict{String,Any}("eventId" => eventId, "eventTypeName" => eventTypeName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_event(
    eventId,
    eventTypeName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return frauddetector(
        "DeleteEvent",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("eventId" => eventId, "eventTypeName" => eventTypeName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_event_type(name)
    delete_event_type(name, params::Dict{String,<:Any})

Deletes an event type. You cannot delete an event type that is used in a detector or a
model. When you delete an event type, Amazon Fraud Detector permanently deletes that event
type and the data is no longer stored in Amazon Fraud Detector.

# Arguments
- `name`: The name of the event type to delete.

"""
function delete_event_type(name; aws_config::AbstractAWSConfig=current_aws_config())
    return frauddetector(
        "DeleteEventType",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_event_type(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return frauddetector(
        "DeleteEventType",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_events_by_event_type(event_type_name)
    delete_events_by_event_type(event_type_name, params::Dict{String,<:Any})

Deletes all events of a particular event type.

# Arguments
- `event_type_name`: The name of the event type.

"""
function delete_events_by_event_type(
    eventTypeName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return frauddetector(
        "DeleteEventsByEventType",
        Dict{String,Any}("eventTypeName" => eventTypeName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_events_by_event_type(
    eventTypeName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return frauddetector(
        "DeleteEventsByEventType",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("eventTypeName" => eventTypeName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_external_model(model_endpoint)
    delete_external_model(model_endpoint, params::Dict{String,<:Any})

Removes a SageMaker model from Amazon Fraud Detector. You can remove an Amazon SageMaker
model if it is not associated with a detector version. Removing a SageMaker model
disconnects it from Amazon Fraud Detector, but the model remains available in SageMaker.

# Arguments
- `model_endpoint`: The endpoint of the Amazon Sagemaker model to delete.

"""
function delete_external_model(
    modelEndpoint; aws_config::AbstractAWSConfig=current_aws_config()
)
    return frauddetector(
        "DeleteExternalModel",
        Dict{String,Any}("modelEndpoint" => modelEndpoint);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_external_model(
    modelEndpoint,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return frauddetector(
        "DeleteExternalModel",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("modelEndpoint" => modelEndpoint), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_label(name)
    delete_label(name, params::Dict{String,<:Any})

Deletes a label. You cannot delete labels that are included in an event type in Amazon
Fraud Detector. You cannot delete a label assigned to an event ID. You must first delete
the relevant event ID. When you delete a label, Amazon Fraud Detector permanently deletes
that label and the data is no longer stored in Amazon Fraud Detector.

# Arguments
- `name`: The name of the label to delete.

"""
function delete_label(name; aws_config::AbstractAWSConfig=current_aws_config())
    return frauddetector(
        "DeleteLabel",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_label(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return frauddetector(
        "DeleteLabel",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_list(name)
    delete_list(name, params::Dict{String,<:Any})

 Deletes the list, provided it is not used in a rule.   When you delete a list, Amazon
Fraud Detector permanently deletes that list and the elements in the list.

# Arguments
- `name`:  The name of the list to delete.

"""
function delete_list(name; aws_config::AbstractAWSConfig=current_aws_config())
    return frauddetector(
        "DeleteList",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_list(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return frauddetector(
        "DeleteList",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_model(model_id, model_type)
    delete_model(model_id, model_type, params::Dict{String,<:Any})

Deletes a model. You can delete models and model versions in Amazon Fraud Detector,
provided that they are not associated with a detector version.  When you delete a model,
Amazon Fraud Detector permanently deletes that model and the data is no longer stored in
Amazon Fraud Detector.

# Arguments
- `model_id`: The model ID of the model to delete.
- `model_type`: The model type of the model to delete.

"""
function delete_model(
    modelId, modelType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return frauddetector(
        "DeleteModel",
        Dict{String,Any}("modelId" => modelId, "modelType" => modelType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_model(
    modelId,
    modelType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return frauddetector(
        "DeleteModel",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("modelId" => modelId, "modelType" => modelType),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_model_version(model_id, model_type, model_version_number)
    delete_model_version(model_id, model_type, model_version_number, params::Dict{String,<:Any})

Deletes a model version. You can delete models and model versions in Amazon Fraud Detector,
provided that they are not associated with a detector version.  When you delete a model
version, Amazon Fraud Detector permanently deletes that model version and the data is no
longer stored in Amazon Fraud Detector.

# Arguments
- `model_id`: The model ID of the model version to delete.
- `model_type`: The model type of the model version to delete.
- `model_version_number`: The model version number of the model version to delete.

"""
function delete_model_version(
    modelId,
    modelType,
    modelVersionNumber;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return frauddetector(
        "DeleteModelVersion",
        Dict{String,Any}(
            "modelId" => modelId,
            "modelType" => modelType,
            "modelVersionNumber" => modelVersionNumber,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_model_version(
    modelId,
    modelType,
    modelVersionNumber,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return frauddetector(
        "DeleteModelVersion",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "modelId" => modelId,
                    "modelType" => modelType,
                    "modelVersionNumber" => modelVersionNumber,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_outcome(name)
    delete_outcome(name, params::Dict{String,<:Any})

Deletes an outcome. You cannot delete an outcome that is used in a rule version. When you
delete an outcome, Amazon Fraud Detector permanently deletes that outcome and the data is
no longer stored in Amazon Fraud Detector.

# Arguments
- `name`: The name of the outcome to delete.

"""
function delete_outcome(name; aws_config::AbstractAWSConfig=current_aws_config())
    return frauddetector(
        "DeleteOutcome",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_outcome(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return frauddetector(
        "DeleteOutcome",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_rule(rule)
    delete_rule(rule, params::Dict{String,<:Any})

Deletes the rule. You cannot delete a rule if it is used by an ACTIVE or INACTIVE detector
version. When you delete a rule, Amazon Fraud Detector permanently deletes that rule and
the data is no longer stored in Amazon Fraud Detector.

# Arguments
- `rule`:

"""
function delete_rule(rule; aws_config::AbstractAWSConfig=current_aws_config())
    return frauddetector(
        "DeleteRule",
        Dict{String,Any}("rule" => rule);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_rule(
    rule, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return frauddetector(
        "DeleteRule",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("rule" => rule), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_variable(name)
    delete_variable(name, params::Dict{String,<:Any})

Deletes a variable. You can't delete variables that are included in an event type in Amazon
Fraud Detector. Amazon Fraud Detector automatically deletes model output variables and
SageMaker model output variables when you delete the model. You can't delete these
variables manually. When you delete a variable, Amazon Fraud Detector permanently deletes
that variable and the data is no longer stored in Amazon Fraud Detector.

# Arguments
- `name`: The name of the variable to delete.

"""
function delete_variable(name; aws_config::AbstractAWSConfig=current_aws_config())
    return frauddetector(
        "DeleteVariable",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_variable(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return frauddetector(
        "DeleteVariable",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_detector(detector_id)
    describe_detector(detector_id, params::Dict{String,<:Any})

Gets all versions for a specified detector.

# Arguments
- `detector_id`: The detector ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return for the request.
- `"nextToken"`: The next token from the previous response.
"""
function describe_detector(detectorId; aws_config::AbstractAWSConfig=current_aws_config())
    return frauddetector(
        "DescribeDetector",
        Dict{String,Any}("detectorId" => detectorId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_detector(
    detectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return frauddetector(
        "DescribeDetector",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("detectorId" => detectorId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_model_versions()
    describe_model_versions(params::Dict{String,<:Any})

Gets all of the model versions for the specified model type or for the specified model type
and model ID. You can also get details for a single, specified model version.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return.
- `"modelId"`: The model ID.
- `"modelType"`: The model type.
- `"modelVersionNumber"`: The model version number.
- `"nextToken"`: The next token from the previous results.
"""
function describe_model_versions(; aws_config::AbstractAWSConfig=current_aws_config())
    return frauddetector(
        "DescribeModelVersions"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_model_versions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return frauddetector(
        "DescribeModelVersions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_batch_import_jobs()
    get_batch_import_jobs(params::Dict{String,<:Any})

Gets all batch import jobs or a specific job of the specified ID. This is a paginated API.
If you provide a null maxResults, this action retrieves a maximum of 50 records per page.
If you provide a maxResults, the value must be between 1 and 50. To get the next page
results, provide the pagination token from the GetBatchImportJobsResponse as part of your
request. A null pagination token fetches the records from the beginning.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"jobId"`: The ID of the batch import job to get.
- `"maxResults"`: The maximum number of objects to return for request.
- `"nextToken"`: The next token from the previous request.
"""
function get_batch_import_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return frauddetector(
        "GetBatchImportJobs"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_batch_import_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return frauddetector(
        "GetBatchImportJobs", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_batch_prediction_jobs()
    get_batch_prediction_jobs(params::Dict{String,<:Any})

Gets all batch prediction jobs or a specific job if you specify a job ID. This is a
paginated API. If you provide a null maxResults, this action retrieves a maximum of 50
records per page. If you provide a maxResults, the value must be between 1 and 50. To get
the next page results, provide the pagination token from the GetBatchPredictionJobsResponse
as part of your request. A null pagination token fetches the records from the beginning.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"jobId"`: The batch prediction job for which to get the details.
- `"maxResults"`: The maximum number of objects to return for the request.
- `"nextToken"`: The next token from the previous request.
"""
function get_batch_prediction_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return frauddetector(
        "GetBatchPredictionJobs"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_batch_prediction_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return frauddetector(
        "GetBatchPredictionJobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_delete_events_by_event_type_status(event_type_name)
    get_delete_events_by_event_type_status(event_type_name, params::Dict{String,<:Any})

Retrieves the status of a DeleteEventsByEventType action.

# Arguments
- `event_type_name`: Name of event type for which to get the deletion status.

"""
function get_delete_events_by_event_type_status(
    eventTypeName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return frauddetector(
        "GetDeleteEventsByEventTypeStatus",
        Dict{String,Any}("eventTypeName" => eventTypeName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_delete_events_by_event_type_status(
    eventTypeName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return frauddetector(
        "GetDeleteEventsByEventTypeStatus",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("eventTypeName" => eventTypeName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_detector_version(detector_id, detector_version_id)
    get_detector_version(detector_id, detector_version_id, params::Dict{String,<:Any})

Gets a particular detector version.

# Arguments
- `detector_id`: The detector ID.
- `detector_version_id`: The detector version ID.

"""
function get_detector_version(
    detectorId, detectorVersionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return frauddetector(
        "GetDetectorVersion",
        Dict{String,Any}(
            "detectorId" => detectorId, "detectorVersionId" => detectorVersionId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_detector_version(
    detectorId,
    detectorVersionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return frauddetector(
        "GetDetectorVersion",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "detectorId" => detectorId, "detectorVersionId" => detectorVersionId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_detectors()
    get_detectors(params::Dict{String,<:Any})

Gets all detectors or a single detector if a detectorId is specified. This is a paginated
API. If you provide a null maxResults, this action retrieves a maximum of 10 records per
page. If you provide a maxResults, the value must be between 5 and 10. To get the next page
results, provide the pagination token from the GetDetectorsResponse as part of your
request. A null pagination token fetches the records from the beginning.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"detectorId"`: The detector ID.
- `"maxResults"`: The maximum number of objects to return for the request.
- `"nextToken"`: The next token for the subsequent request.
"""
function get_detectors(; aws_config::AbstractAWSConfig=current_aws_config())
    return frauddetector(
        "GetDetectors"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_detectors(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return frauddetector(
        "GetDetectors", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_entity_types()
    get_entity_types(params::Dict{String,<:Any})

Gets all entity types or a specific entity type if a name is specified. This is a paginated
API. If you provide a null maxResults, this action retrieves a maximum of 10 records per
page. If you provide a maxResults, the value must be between 5 and 10. To get the next page
results, provide the pagination token from the GetEntityTypesResponse as part of your
request. A null pagination token fetches the records from the beginning.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of objects to return for the request.
- `"name"`: The name.
- `"nextToken"`: The next token for the subsequent request.
"""
function get_entity_types(; aws_config::AbstractAWSConfig=current_aws_config())
    return frauddetector(
        "GetEntityTypes"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_entity_types(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return frauddetector(
        "GetEntityTypes", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_event(event_id, event_type_name)
    get_event(event_id, event_type_name, params::Dict{String,<:Any})

Retrieves details of events stored with Amazon Fraud Detector. This action does not
retrieve prediction results.

# Arguments
- `event_id`: The ID of the event to retrieve.
- `event_type_name`: The event type of the event to retrieve.

"""
function get_event(
    eventId, eventTypeName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return frauddetector(
        "GetEvent",
        Dict{String,Any}("eventId" => eventId, "eventTypeName" => eventTypeName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_event(
    eventId,
    eventTypeName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return frauddetector(
        "GetEvent",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("eventId" => eventId, "eventTypeName" => eventTypeName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_event_prediction(detector_id, entities, event_id, event_timestamp, event_type_name, event_variables)
    get_event_prediction(detector_id, entities, event_id, event_timestamp, event_type_name, event_variables, params::Dict{String,<:Any})

Evaluates an event against a detector version. If a version ID is not provided, the
detector’s (ACTIVE) version is used.

# Arguments
- `detector_id`: The detector ID.
- `entities`: The entity type (associated with the detector's event type) and specific
  entity ID representing who performed the event. If an entity id is not available, use
  \"UNKNOWN.\"
- `event_id`: The unique ID used to identify the event.
- `event_timestamp`: Timestamp that defines when the event under evaluation occurred. The
  timestamp must be specified using ISO 8601 standard in UTC.
- `event_type_name`: The event type associated with the detector specified for the
  prediction.
- `event_variables`: Names of the event type's variables you defined in Amazon Fraud
  Detector to represent data elements and their corresponding values for the event you are
  sending for evaluation.  You must provide at least one eventVariable  To ensure most
  accurate fraud prediction and to simplify your data preparation, Amazon Fraud Detector will
  replace all missing variables or values as follows:  For Amazon Fraud Detector trained
  models:  If a null value is provided explicitly for a variable or if a variable is missing,
  model will replace the null value or the missing variable (no variable name in the
  eventVariables map) with calculated default mean/medians for numeric variables and with
  special values for categorical variables.  For imported SageMaker models:  If a null value
  is provided explicitly for a variable, the model and rules will use “null” as the
  value. If a variable is not provided (no variable name in the eventVariables map), model
  and rules will use the default value that is provided for the variable.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"detectorVersionId"`: The detector version ID.
- `"externalModelEndpointDataBlobs"`: The Amazon SageMaker model endpoint input data blobs.
"""
function get_event_prediction(
    detectorId,
    entities,
    eventId,
    eventTimestamp,
    eventTypeName,
    eventVariables;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return frauddetector(
        "GetEventPrediction",
        Dict{String,Any}(
            "detectorId" => detectorId,
            "entities" => entities,
            "eventId" => eventId,
            "eventTimestamp" => eventTimestamp,
            "eventTypeName" => eventTypeName,
            "eventVariables" => eventVariables,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_event_prediction(
    detectorId,
    entities,
    eventId,
    eventTimestamp,
    eventTypeName,
    eventVariables,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return frauddetector(
        "GetEventPrediction",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "detectorId" => detectorId,
                    "entities" => entities,
                    "eventId" => eventId,
                    "eventTimestamp" => eventTimestamp,
                    "eventTypeName" => eventTypeName,
                    "eventVariables" => eventVariables,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_event_prediction_metadata(detector_id, detector_version_id, event_id, event_type_name, prediction_timestamp)
    get_event_prediction_metadata(detector_id, detector_version_id, event_id, event_type_name, prediction_timestamp, params::Dict{String,<:Any})

 Gets details of the past fraud predictions for the specified event ID, event type,
detector ID, and detector version ID that was generated in the specified time period.

# Arguments
- `detector_id`:  The detector ID.
- `detector_version_id`:  The detector version ID.
- `event_id`:  The event ID.
- `event_type_name`:  The event type associated with the detector specified for the
  prediction.
- `prediction_timestamp`:  The timestamp that defines when the prediction was generated.
  The timestamp must be specified using ISO 8601 standard in UTC. We recommend calling
  ListEventPredictions first, and using the predictionTimestamp value in the response to
  provide an accurate prediction timestamp value.

"""
function get_event_prediction_metadata(
    detectorId,
    detectorVersionId,
    eventId,
    eventTypeName,
    predictionTimestamp;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return frauddetector(
        "GetEventPredictionMetadata",
        Dict{String,Any}(
            "detectorId" => detectorId,
            "detectorVersionId" => detectorVersionId,
            "eventId" => eventId,
            "eventTypeName" => eventTypeName,
            "predictionTimestamp" => predictionTimestamp,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_event_prediction_metadata(
    detectorId,
    detectorVersionId,
    eventId,
    eventTypeName,
    predictionTimestamp,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return frauddetector(
        "GetEventPredictionMetadata",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "detectorId" => detectorId,
                    "detectorVersionId" => detectorVersionId,
                    "eventId" => eventId,
                    "eventTypeName" => eventTypeName,
                    "predictionTimestamp" => predictionTimestamp,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_event_types()
    get_event_types(params::Dict{String,<:Any})

Gets all event types or a specific event type if name is provided. This is a paginated API.
If you provide a null maxResults, this action retrieves a maximum of 10 records per page.
If you provide a maxResults, the value must be between 5 and 10. To get the next page
results, provide the pagination token from the GetEventTypesResponse as part of your
request. A null pagination token fetches the records from the beginning.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of objects to return for the request.
- `"name"`: The name.
- `"nextToken"`: The next token for the subsequent request.
"""
function get_event_types(; aws_config::AbstractAWSConfig=current_aws_config())
    return frauddetector(
        "GetEventTypes"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_event_types(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return frauddetector(
        "GetEventTypes", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_external_models()
    get_external_models(params::Dict{String,<:Any})

Gets the details for one or more Amazon SageMaker models that have been imported into the
service. This is a paginated API. If you provide a null maxResults, this actions retrieves
a maximum of 10 records per page. If you provide a maxResults, the value must be between 5
and 10. To get the next page results, provide the pagination token from the
GetExternalModelsResult as part of your request. A null pagination token fetches the
records from the beginning.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of objects to return for the request.
- `"modelEndpoint"`: The Amazon SageMaker model endpoint.
- `"nextToken"`: The next page token for the request.
"""
function get_external_models(; aws_config::AbstractAWSConfig=current_aws_config())
    return frauddetector(
        "GetExternalModels"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_external_models(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return frauddetector(
        "GetExternalModels", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_kmsencryption_key()
    get_kmsencryption_key(params::Dict{String,<:Any})

Gets the encryption key if a KMS key has been specified to be used to encrypt content in
Amazon Fraud Detector.

"""
function get_kmsencryption_key(; aws_config::AbstractAWSConfig=current_aws_config())
    return frauddetector(
        "GetKMSEncryptionKey"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_kmsencryption_key(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return frauddetector(
        "GetKMSEncryptionKey",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_labels()
    get_labels(params::Dict{String,<:Any})

Gets all labels or a specific label if name is provided. This is a paginated API. If you
provide a null maxResults, this action retrieves a maximum of 50 records per page. If you
provide a maxResults, the value must be between 10 and 50. To get the next page results,
provide the pagination token from the GetGetLabelsResponse as part of your request. A null
pagination token fetches the records from the beginning.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of objects to return for the request.
- `"name"`: The name of the label or labels to get.
- `"nextToken"`: The next token for the subsequent request.
"""
function get_labels(; aws_config::AbstractAWSConfig=current_aws_config())
    return frauddetector(
        "GetLabels"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_labels(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return frauddetector(
        "GetLabels", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_list_elements(name)
    get_list_elements(name, params::Dict{String,<:Any})

 Gets all the elements in the specified list.

# Arguments
- `name`:  The name of the list.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:  The maximum number of objects to return for the request.
- `"nextToken"`:  The next token for the subsequent request.
"""
function get_list_elements(name; aws_config::AbstractAWSConfig=current_aws_config())
    return frauddetector(
        "GetListElements",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_list_elements(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return frauddetector(
        "GetListElements",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_lists_metadata()
    get_lists_metadata(params::Dict{String,<:Any})

 Gets the metadata of either all the lists under the account or the specified list.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:  The maximum number of objects to return for the request.
- `"name"`:  The name of the list.
- `"nextToken"`:  The next token for the subsequent request.
"""
function get_lists_metadata(; aws_config::AbstractAWSConfig=current_aws_config())
    return frauddetector(
        "GetListsMetadata"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_lists_metadata(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return frauddetector(
        "GetListsMetadata", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_model_version(model_id, model_type, model_version_number)
    get_model_version(model_id, model_type, model_version_number, params::Dict{String,<:Any})

Gets the details of the specified model version.

# Arguments
- `model_id`: The model ID.
- `model_type`: The model type.
- `model_version_number`: The model version number.

"""
function get_model_version(
    modelId,
    modelType,
    modelVersionNumber;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return frauddetector(
        "GetModelVersion",
        Dict{String,Any}(
            "modelId" => modelId,
            "modelType" => modelType,
            "modelVersionNumber" => modelVersionNumber,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_model_version(
    modelId,
    modelType,
    modelVersionNumber,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return frauddetector(
        "GetModelVersion",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "modelId" => modelId,
                    "modelType" => modelType,
                    "modelVersionNumber" => modelVersionNumber,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_models()
    get_models(params::Dict{String,<:Any})

Gets one or more models. Gets all models for the Amazon Web Services account if no model
type and no model id provided. Gets all models for the Amazon Web Services account and
model type, if the model type is specified but model id is not provided. Gets a specific
model if (model type, model id) tuple is specified.  This is a paginated API. If you
provide a null maxResults, this action retrieves a maximum of 10 records per page. If you
provide a maxResults, the value must be between 1 and 10. To get the next page results,
provide the pagination token from the response as part of your request. A null pagination
token fetches the records from the beginning.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of objects to return for the request.
- `"modelId"`: The model ID.
- `"modelType"`: The model type.
- `"nextToken"`: The next token for the subsequent request.
"""
function get_models(; aws_config::AbstractAWSConfig=current_aws_config())
    return frauddetector(
        "GetModels"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_models(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return frauddetector(
        "GetModels", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_outcomes()
    get_outcomes(params::Dict{String,<:Any})

Gets one or more outcomes. This is a paginated API. If you provide a null maxResults, this
actions retrieves a maximum of 100 records per page. If you provide a maxResults, the value
must be between 50 and 100. To get the next page results, provide the pagination token from
the GetOutcomesResult as part of your request. A null pagination token fetches the records
from the beginning.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of objects to return for the request.
- `"name"`: The name of the outcome or outcomes to get.
- `"nextToken"`: The next page token for the request.
"""
function get_outcomes(; aws_config::AbstractAWSConfig=current_aws_config())
    return frauddetector(
        "GetOutcomes"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_outcomes(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return frauddetector(
        "GetOutcomes", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_rules(detector_id)
    get_rules(detector_id, params::Dict{String,<:Any})

Get all rules for a detector (paginated) if ruleId and ruleVersion are not specified. Gets
all rules for the detector and the ruleId if present (paginated). Gets a specific rule if
both the ruleId and the ruleVersion are specified. This is a paginated API. Providing null
maxResults results in retrieving maximum of 100 records per page. If you provide maxResults
the value must be between 50 and 100. To get the next page result, a provide a pagination
token from GetRulesResult as part of your request. Null pagination token fetches the
records from the beginning.

# Arguments
- `detector_id`: The detector ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of rules to return for the request.
- `"nextToken"`: The next page token.
- `"ruleId"`: The rule ID.
- `"ruleVersion"`: The rule version.
"""
function get_rules(detectorId; aws_config::AbstractAWSConfig=current_aws_config())
    return frauddetector(
        "GetRules",
        Dict{String,Any}("detectorId" => detectorId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_rules(
    detectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return frauddetector(
        "GetRules",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("detectorId" => detectorId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_variables()
    get_variables(params::Dict{String,<:Any})

Gets all of the variables or the specific variable. This is a paginated API. Providing null
maxSizePerPage results in retrieving maximum of 100 records per page. If you provide
maxSizePerPage the value must be between 50 and 100. To get the next page result, a provide
a pagination token from GetVariablesResult as part of your request. Null pagination token
fetches the records from the beginning.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The max size per page determined for the get variable request.
- `"name"`: The name of the variable.
- `"nextToken"`: The next page token of the get variable request.
"""
function get_variables(; aws_config::AbstractAWSConfig=current_aws_config())
    return frauddetector(
        "GetVariables"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_variables(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return frauddetector(
        "GetVariables", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_event_predictions()
    list_event_predictions(params::Dict{String,<:Any})

Gets a list of past predictions. The list can be filtered by detector ID, detector version
ID, event ID, event type, or by specifying a time period. If filter is not specified, the
most recent prediction is returned. For example, the following filter lists all past
predictions for xyz event type - { \"eventType\":{ \"value\": \"xyz\" }” }   This is a
paginated API. If you provide a null maxResults, this action will retrieve a maximum of 10
records per page. If you provide a maxResults, the value must be between 50 and 100. To get
the next page results, provide the nextToken from the response as part of your request. A
null nextToken fetches the records from the beginning.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"detectorId"`:  The detector ID.
- `"detectorVersionId"`:  The detector version ID.
- `"eventId"`:  The event ID.
- `"eventType"`:  The event type associated with the detector.
- `"maxResults"`:  The maximum number of predictions to return for the request.
- `"nextToken"`:  Identifies the next page of results to return. Use the token to make the
  call again to retrieve the next page. Keep all other arguments unchanged. Each pagination
  token expires after 24 hours.
- `"predictionTimeRange"`:  The time period for when the predictions were generated.
"""
function list_event_predictions(; aws_config::AbstractAWSConfig=current_aws_config())
    return frauddetector(
        "ListEventPredictions"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_event_predictions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return frauddetector(
        "ListEventPredictions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists all tags associated with the resource. This is a paginated API. To get the next page
results, provide the pagination token from the response as part of your request. A null
pagination token fetches the records from the beginning.

# Arguments
- `resource_arn`: The ARN that specifies the resource whose tags you want to list.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of objects to return for the request.
- `"nextToken"`: The next token from the previous results.
"""
function list_tags_for_resource(
    resourceARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return frauddetector(
        "ListTagsForResource",
        Dict{String,Any}("resourceARN" => resourceARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return frauddetector(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceARN" => resourceARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_detector(detector_id, event_type_name)
    put_detector(detector_id, event_type_name, params::Dict{String,<:Any})

Creates or updates a detector.

# Arguments
- `detector_id`: The detector ID.
- `event_type_name`: The name of the event type.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description of the detector.
- `"tags"`: A collection of key and value pairs.
"""
function put_detector(
    detectorId, eventTypeName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return frauddetector(
        "PutDetector",
        Dict{String,Any}("detectorId" => detectorId, "eventTypeName" => eventTypeName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_detector(
    detectorId,
    eventTypeName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return frauddetector(
        "PutDetector",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "detectorId" => detectorId, "eventTypeName" => eventTypeName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_entity_type(name)
    put_entity_type(name, params::Dict{String,<:Any})

Creates or updates an entity type. An entity represents who is performing the event. As
part of a fraud prediction, you pass the entity ID to indicate the specific entity who
performed the event. An entity type classifies the entity. Example classifications include
customer, merchant, or account.

# Arguments
- `name`: The name of the entity type.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description.
- `"tags"`: A collection of key and value pairs.
"""
function put_entity_type(name; aws_config::AbstractAWSConfig=current_aws_config())
    return frauddetector(
        "PutEntityType",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_entity_type(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return frauddetector(
        "PutEntityType",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_event_type(entity_types, event_variables, name)
    put_event_type(entity_types, event_variables, name, params::Dict{String,<:Any})

Creates or updates an event type. An event is a business activity that is evaluated for
fraud risk. With Amazon Fraud Detector, you generate fraud predictions for events. An event
type defines the structure for an event sent to Amazon Fraud Detector. This includes the
variables sent as part of the event, the entity performing the event (such as a customer),
and the labels that classify the event. Example event types include online payment
transactions, account registrations, and authentications.

# Arguments
- `entity_types`: The entity type for the event type. Example entity types: customer,
  merchant, account.
- `event_variables`: The event type variables.
- `name`: The name.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description of the event type.
- `"eventIngestion"`: Specifies if ingestion is enabled or disabled.
- `"eventOrchestration"`: Enables or disables event orchestration. If enabled, you can send
  event predictions to select AWS services for downstream processing of the events.
- `"labels"`: The event type labels.
- `"tags"`: A collection of key and value pairs.
"""
function put_event_type(
    entityTypes, eventVariables, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return frauddetector(
        "PutEventType",
        Dict{String,Any}(
            "entityTypes" => entityTypes, "eventVariables" => eventVariables, "name" => name
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_event_type(
    entityTypes,
    eventVariables,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return frauddetector(
        "PutEventType",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "entityTypes" => entityTypes,
                    "eventVariables" => eventVariables,
                    "name" => name,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_external_model(input_configuration, invoke_model_endpoint_role_arn, model_endpoint, model_endpoint_status, model_source, output_configuration)
    put_external_model(input_configuration, invoke_model_endpoint_role_arn, model_endpoint, model_endpoint_status, model_source, output_configuration, params::Dict{String,<:Any})

Creates or updates an Amazon SageMaker model endpoint. You can also use this action to
update the configuration of the model endpoint, including the IAM role and/or the mapped
variables.

# Arguments
- `input_configuration`: The model endpoint input configuration.
- `invoke_model_endpoint_role_arn`: The IAM role used to invoke the model endpoint.
- `model_endpoint`: The model endpoints name.
- `model_endpoint_status`: The model endpoint’s status in Amazon Fraud Detector.
- `model_source`: The source of the model.
- `output_configuration`: The model endpoint output configuration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tags"`: A collection of key and value pairs.
"""
function put_external_model(
    inputConfiguration,
    invokeModelEndpointRoleArn,
    modelEndpoint,
    modelEndpointStatus,
    modelSource,
    outputConfiguration;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return frauddetector(
        "PutExternalModel",
        Dict{String,Any}(
            "inputConfiguration" => inputConfiguration,
            "invokeModelEndpointRoleArn" => invokeModelEndpointRoleArn,
            "modelEndpoint" => modelEndpoint,
            "modelEndpointStatus" => modelEndpointStatus,
            "modelSource" => modelSource,
            "outputConfiguration" => outputConfiguration,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_external_model(
    inputConfiguration,
    invokeModelEndpointRoleArn,
    modelEndpoint,
    modelEndpointStatus,
    modelSource,
    outputConfiguration,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return frauddetector(
        "PutExternalModel",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "inputConfiguration" => inputConfiguration,
                    "invokeModelEndpointRoleArn" => invokeModelEndpointRoleArn,
                    "modelEndpoint" => modelEndpoint,
                    "modelEndpointStatus" => modelEndpointStatus,
                    "modelSource" => modelSource,
                    "outputConfiguration" => outputConfiguration,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_kmsencryption_key(kms_encryption_key_arn)
    put_kmsencryption_key(kms_encryption_key_arn, params::Dict{String,<:Any})

Specifies the KMS key to be used to encrypt content in Amazon Fraud Detector.

# Arguments
- `kms_encryption_key_arn`: The KMS encryption key ARN. The KMS key must be single-Region
  key. Amazon Fraud Detector does not support multi-Region KMS key.

"""
function put_kmsencryption_key(
    kmsEncryptionKeyArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return frauddetector(
        "PutKMSEncryptionKey",
        Dict{String,Any}("kmsEncryptionKeyArn" => kmsEncryptionKeyArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_kmsencryption_key(
    kmsEncryptionKeyArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return frauddetector(
        "PutKMSEncryptionKey",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("kmsEncryptionKeyArn" => kmsEncryptionKeyArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_label(name)
    put_label(name, params::Dict{String,<:Any})

Creates or updates label. A label classifies an event as fraudulent or legitimate. Labels
are associated with event types and used to train supervised machine learning models in
Amazon Fraud Detector.

# Arguments
- `name`: The label name.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The label description.
- `"tags"`: A collection of key and value pairs.
"""
function put_label(name; aws_config::AbstractAWSConfig=current_aws_config())
    return frauddetector(
        "PutLabel",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_label(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return frauddetector(
        "PutLabel",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_outcome(name)
    put_outcome(name, params::Dict{String,<:Any})

Creates or updates an outcome.

# Arguments
- `name`: The name of the outcome.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The outcome description.
- `"tags"`: A collection of key and value pairs.
"""
function put_outcome(name; aws_config::AbstractAWSConfig=current_aws_config())
    return frauddetector(
        "PutOutcome",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_outcome(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return frauddetector(
        "PutOutcome",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    send_event(entities, event_id, event_timestamp, event_type_name, event_variables)
    send_event(entities, event_id, event_timestamp, event_type_name, event_variables, params::Dict{String,<:Any})

Stores events in Amazon Fraud Detector without generating fraud predictions for those
events. For example, you can use SendEvent to upload a historical dataset, which you can
then later use to train a model.

# Arguments
- `entities`: An array of entities.
- `event_id`: The event ID to upload.
- `event_timestamp`: The timestamp that defines when the event under evaluation occurred.
  The timestamp must be specified using ISO 8601 standard in UTC.
- `event_type_name`: The event type name of the event.
- `event_variables`: Names of the event type's variables you defined in Amazon Fraud
  Detector to represent data elements and their corresponding values for the event you are
  sending for evaluation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"assignedLabel"`: The label to associate with the event. Required if specifying
  labelTimestamp.
- `"labelTimestamp"`: The timestamp associated with the label. Required if specifying
  assignedLabel.
"""
function send_event(
    entities,
    eventId,
    eventTimestamp,
    eventTypeName,
    eventVariables;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return frauddetector(
        "SendEvent",
        Dict{String,Any}(
            "entities" => entities,
            "eventId" => eventId,
            "eventTimestamp" => eventTimestamp,
            "eventTypeName" => eventTypeName,
            "eventVariables" => eventVariables,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function send_event(
    entities,
    eventId,
    eventTimestamp,
    eventTypeName,
    eventVariables,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return frauddetector(
        "SendEvent",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "entities" => entities,
                    "eventId" => eventId,
                    "eventTimestamp" => eventTimestamp,
                    "eventTypeName" => eventTypeName,
                    "eventVariables" => eventVariables,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Assigns tags to a resource.

# Arguments
- `resource_arn`: The resource ARN.
- `tags`: The tags to assign to the resource.

"""
function tag_resource(resourceARN, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return frauddetector(
        "TagResource",
        Dict{String,Any}("resourceARN" => resourceARN, "tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceARN,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return frauddetector(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceARN" => resourceARN, "tags" => tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes tags from a resource.

# Arguments
- `resource_arn`: The ARN of the resource from which to remove the tag.
- `tag_keys`: The resource ARN.

"""
function untag_resource(
    resourceARN, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return frauddetector(
        "UntagResource",
        Dict{String,Any}("resourceARN" => resourceARN, "tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceARN,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return frauddetector(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceARN" => resourceARN, "tagKeys" => tagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_detector_version(detector_id, detector_version_id, external_model_endpoints, rules)
    update_detector_version(detector_id, detector_version_id, external_model_endpoints, rules, params::Dict{String,<:Any})

 Updates a detector version. The detector version attributes that you can update include
models, external model endpoints, rules, rule execution mode, and description. You can only
update a DRAFT detector version.

# Arguments
- `detector_id`: The parent detector ID for the detector version you want to update.
- `detector_version_id`: The detector version ID.
- `external_model_endpoints`: The Amazon SageMaker model endpoints to include in the
  detector version.
- `rules`: The rules to include in the detector version.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The detector version description.
- `"modelVersions"`: The model versions to include in the detector version.
- `"ruleExecutionMode"`: The rule execution mode to add to the detector. If you specify
  FIRST_MATCHED, Amazon Fraud Detector evaluates rules sequentially, first to last, stopping
  at the first matched rule. Amazon Fraud dectector then provides the outcomes for that
  single rule. If you specifiy ALL_MATCHED, Amazon Fraud Detector evaluates all rules and
  returns the outcomes for all matched rules. You can define and edit the rule mode at the
  detector version level, when it is in draft status. The default behavior is FIRST_MATCHED.
"""
function update_detector_version(
    detectorId,
    detectorVersionId,
    externalModelEndpoints,
    rules;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return frauddetector(
        "UpdateDetectorVersion",
        Dict{String,Any}(
            "detectorId" => detectorId,
            "detectorVersionId" => detectorVersionId,
            "externalModelEndpoints" => externalModelEndpoints,
            "rules" => rules,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_detector_version(
    detectorId,
    detectorVersionId,
    externalModelEndpoints,
    rules,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return frauddetector(
        "UpdateDetectorVersion",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "detectorId" => detectorId,
                    "detectorVersionId" => detectorVersionId,
                    "externalModelEndpoints" => externalModelEndpoints,
                    "rules" => rules,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_detector_version_metadata(description, detector_id, detector_version_id)
    update_detector_version_metadata(description, detector_id, detector_version_id, params::Dict{String,<:Any})

Updates the detector version's description. You can update the metadata for any detector
version (DRAFT, ACTIVE, or INACTIVE).

# Arguments
- `description`: The description.
- `detector_id`: The detector ID.
- `detector_version_id`: The detector version ID.

"""
function update_detector_version_metadata(
    description,
    detectorId,
    detectorVersionId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return frauddetector(
        "UpdateDetectorVersionMetadata",
        Dict{String,Any}(
            "description" => description,
            "detectorId" => detectorId,
            "detectorVersionId" => detectorVersionId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_detector_version_metadata(
    description,
    detectorId,
    detectorVersionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return frauddetector(
        "UpdateDetectorVersionMetadata",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "description" => description,
                    "detectorId" => detectorId,
                    "detectorVersionId" => detectorVersionId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_detector_version_status(detector_id, detector_version_id, status)
    update_detector_version_status(detector_id, detector_version_id, status, params::Dict{String,<:Any})

Updates the detector version’s status. You can perform the following promotions or
demotions using UpdateDetectorVersionStatus: DRAFT to ACTIVE, ACTIVE to INACTIVE, and
INACTIVE to ACTIVE.

# Arguments
- `detector_id`: The detector ID.
- `detector_version_id`: The detector version ID.
- `status`: The new status. The only supported values are ACTIVE and INACTIVE

"""
function update_detector_version_status(
    detectorId,
    detectorVersionId,
    status;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return frauddetector(
        "UpdateDetectorVersionStatus",
        Dict{String,Any}(
            "detectorId" => detectorId,
            "detectorVersionId" => detectorVersionId,
            "status" => status,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_detector_version_status(
    detectorId,
    detectorVersionId,
    status,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return frauddetector(
        "UpdateDetectorVersionStatus",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "detectorId" => detectorId,
                    "detectorVersionId" => detectorVersionId,
                    "status" => status,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_event_label(assigned_label, event_id, event_type_name, label_timestamp)
    update_event_label(assigned_label, event_id, event_type_name, label_timestamp, params::Dict{String,<:Any})

Updates the specified event with a new label.

# Arguments
- `assigned_label`: The new label to assign to the event.
- `event_id`: The ID of the event associated with the label to update.
- `event_type_name`: The event type of the event associated with the label to update.
- `label_timestamp`: The timestamp associated with the label. The timestamp must be
  specified using ISO 8601 standard in UTC.

"""
function update_event_label(
    assignedLabel,
    eventId,
    eventTypeName,
    labelTimestamp;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return frauddetector(
        "UpdateEventLabel",
        Dict{String,Any}(
            "assignedLabel" => assignedLabel,
            "eventId" => eventId,
            "eventTypeName" => eventTypeName,
            "labelTimestamp" => labelTimestamp,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_event_label(
    assignedLabel,
    eventId,
    eventTypeName,
    labelTimestamp,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return frauddetector(
        "UpdateEventLabel",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "assignedLabel" => assignedLabel,
                    "eventId" => eventId,
                    "eventTypeName" => eventTypeName,
                    "labelTimestamp" => labelTimestamp,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_list(name)
    update_list(name, params::Dict{String,<:Any})

 Updates a list.

# Arguments
- `name`:  The name of the list to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`:  The new description.
- `"elements"`:  One or more list elements to add or replace. If you are providing the
  elements, make sure to specify the updateMode to use.  If you are deleting all elements
  from the list, use REPLACE for the updateMode and provide an empty list (0 elements).
- `"updateMode"`:  The update mode (type).    Use APPEND if you are adding elements to the
  list.   Use REPLACE if you replacing existing elements in the list.   Use REMOVE if you are
  removing elements from the list.
- `"variableType"`:  The variable type you want to assign to the list.   You cannot update
  a variable type of a list that already has a variable type assigned to it. You can assign a
  variable type to a list only if the list does not already have a variable type.
"""
function update_list(name; aws_config::AbstractAWSConfig=current_aws_config())
    return frauddetector(
        "UpdateList",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_list(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return frauddetector(
        "UpdateList",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_model(model_id, model_type)
    update_model(model_id, model_type, params::Dict{String,<:Any})

Updates model description.

# Arguments
- `model_id`: The model ID.
- `model_type`: The model type.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The new model description.
"""
function update_model(
    modelId, modelType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return frauddetector(
        "UpdateModel",
        Dict{String,Any}("modelId" => modelId, "modelType" => modelType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_model(
    modelId,
    modelType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return frauddetector(
        "UpdateModel",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("modelId" => modelId, "modelType" => modelType),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_model_version(major_version_number, model_id, model_type)
    update_model_version(major_version_number, model_id, model_type, params::Dict{String,<:Any})

Updates a model version. Updating a model version retrains an existing model version using
updated training data and produces a new minor version of the model. You can update the
training data set location and data access role attributes using this action. This action
creates and trains a new minor version of the model, for example version 1.01, 1.02, 1.03.

# Arguments
- `major_version_number`: The major version number.
- `model_id`: The model ID.
- `model_type`: The model type.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"externalEventsDetail"`: The details of the external events data used for training the
  model version. Required if trainingDataSource is EXTERNAL_EVENTS.
- `"ingestedEventsDetail"`: The details of the ingested event used for training the model
  version. Required if your trainingDataSource is INGESTED_EVENTS.
- `"tags"`: A collection of key and value pairs.
"""
function update_model_version(
    majorVersionNumber,
    modelId,
    modelType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return frauddetector(
        "UpdateModelVersion",
        Dict{String,Any}(
            "majorVersionNumber" => majorVersionNumber,
            "modelId" => modelId,
            "modelType" => modelType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_model_version(
    majorVersionNumber,
    modelId,
    modelType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return frauddetector(
        "UpdateModelVersion",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "majorVersionNumber" => majorVersionNumber,
                    "modelId" => modelId,
                    "modelType" => modelType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_model_version_status(model_id, model_type, model_version_number, status)
    update_model_version_status(model_id, model_type, model_version_number, status, params::Dict{String,<:Any})

Updates the status of a model version. You can perform the following status updates:
Change the TRAINING_IN_PROGRESS status to TRAINING_CANCELLED.   Change the
TRAINING_COMPLETE status to ACTIVE.   Change ACTIVE to INACTIVE.

# Arguments
- `model_id`: The model ID of the model version to update.
- `model_type`: The model type.
- `model_version_number`: The model version number.
- `status`: The model version status.

"""
function update_model_version_status(
    modelId,
    modelType,
    modelVersionNumber,
    status;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return frauddetector(
        "UpdateModelVersionStatus",
        Dict{String,Any}(
            "modelId" => modelId,
            "modelType" => modelType,
            "modelVersionNumber" => modelVersionNumber,
            "status" => status,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_model_version_status(
    modelId,
    modelType,
    modelVersionNumber,
    status,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return frauddetector(
        "UpdateModelVersionStatus",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "modelId" => modelId,
                    "modelType" => modelType,
                    "modelVersionNumber" => modelVersionNumber,
                    "status" => status,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_rule_metadata(description, rule)
    update_rule_metadata(description, rule, params::Dict{String,<:Any})

Updates a rule's metadata. The description attribute can be updated.

# Arguments
- `description`: The rule description.
- `rule`: The rule to update.

"""
function update_rule_metadata(
    description, rule; aws_config::AbstractAWSConfig=current_aws_config()
)
    return frauddetector(
        "UpdateRuleMetadata",
        Dict{String,Any}("description" => description, "rule" => rule);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_rule_metadata(
    description,
    rule,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return frauddetector(
        "UpdateRuleMetadata",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("description" => description, "rule" => rule),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_rule_version(expression, language, outcomes, rule)
    update_rule_version(expression, language, outcomes, rule, params::Dict{String,<:Any})

Updates a rule version resulting in a new rule version. Updates a rule version resulting in
a new rule version (version 1, 2, 3 ...).

# Arguments
- `expression`: The rule expression.
- `language`: The language.
- `outcomes`: The outcomes.
- `rule`: The rule to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description.
- `"tags"`: The tags to assign to the rule version.
"""
function update_rule_version(
    expression, language, outcomes, rule; aws_config::AbstractAWSConfig=current_aws_config()
)
    return frauddetector(
        "UpdateRuleVersion",
        Dict{String,Any}(
            "expression" => expression,
            "language" => language,
            "outcomes" => outcomes,
            "rule" => rule,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_rule_version(
    expression,
    language,
    outcomes,
    rule,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return frauddetector(
        "UpdateRuleVersion",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "expression" => expression,
                    "language" => language,
                    "outcomes" => outcomes,
                    "rule" => rule,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_variable(name)
    update_variable(name, params::Dict{String,<:Any})

Updates a variable.

# Arguments
- `name`: The name of the variable.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"defaultValue"`: The new default value of the variable.
- `"description"`: The new description.
- `"variableType"`: The variable type. For more information see Variable types.
"""
function update_variable(name; aws_config::AbstractAWSConfig=current_aws_config())
    return frauddetector(
        "UpdateVariable",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_variable(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return frauddetector(
        "UpdateVariable",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file contains functions used in the high level service definitions
_merge(a::AbstractDict, b::AbstractDict) = merge(a, b)
_merge(a::AbstractString, b::AbstractString) = b

function _flatten_query(service::String, query::AbstractDict{String,<:Any})
    return _flatten_query!(Pair{String,String}[], service, query)
end

function _flatten_query!(
    result::Vector{Pair{String,String}},
    service::String,
    query::AbstractDict{String,<:Any},
    prefix::String="",
)
    for (k, v) in query
        if v isa AbstractDict
            _flatten_query!(result, service, v, string(prefix, k, "."))
        elseif v isa AbstractArray
            for (i, j) in enumerate(v)
                suffix = service in ("ec2", "sqs") ? "" : ".member"
                prefix_key = string(prefix, k, suffix, ".", i)

                if j isa AbstractDict
                    _flatten_query!(result, service, j, string(prefix_key, "."))
                else
                    push!(result, Pair(prefix_key, string(j)))
                end
            end
        else
            push!(result, Pair(string(prefix, k), string(v)))
        end
    end

    return result
end

"""
Escape special AWS S3 characters in the path of the uri properly.

AWS S3 allows for various special characters in file names, these characters are not being
properly escaped before we make the requests.

We cannot call `HTTP.escapeuri(request.uri)` because this will escape `/` characters which
are used in the filepathing for sub-directories.
"""
function _clean_s3_uri(uri::AbstractString)
    parsed_uri = URIs.URI(uri)
    cleaned_path = URIs.escapepath(parsed_uri.path)
    return string(URIs.URI(parsed_uri; path=cleaned_path))
end

function _extract_common_kw_args(service, args)
    return (
        service=service.signing_name,
        api_version=service.api_version,
        response_stream=_pop!(args, "response_stream", nothing),
        headers=LittleDict{String,String}(_pop!(args, "headers", [])),
        http_options=_pop!(args, "http_options", LittleDict{Symbol,String}()),
        backend=_pop!(args, "backend", DEFAULT_BACKEND[]),

        # Deprecated keywords
        return_stream=_pop!(args, "return_stream", nothing),
        return_raw=_pop!(args, "return_raw", nothing),
        response_dict_type=_pop!(args, "response_dict_type", nothing),
    )
end

function _delete_legacy_response_kw_args!(args)
    used_kw_args = intersect(
        keys(args), ("return_headers", "return_stream", "return_raw", "response_dict_type")
    )

    if !isempty(used_kw_args)
        Base.depwarn(
            "The parameter(s) \"$(join(used_kw_args, "\", \""))\" are no longer " *
            "supported when the feature `use_response_type` is enabled.",
            :_delete_legacy_response_kw_args!,
        )
    end

    delete!(args, "return_headers")
    delete!(args, "return_stream")
    delete!(args, "return_raw")
    delete!(args, "response_dict_type")
    return args
end

# Use this until the three arg pop! is available for LittleDict
# https://github.com/JuliaCollections/OrderedCollections.jl/pull/59
function _pop!(dict::AbstractDict{String,<:Any}, kw, default)
    if haskey(dict, kw)
        val = dict[kw]
        delete!(dict, kw)

        return val
    else
        return default
    end
end

function _generate_rest_resource(request_uri::String, args::AbstractDict{String,<:Any})
    # There maybe a time where both $k and $k+ are in the request_uri, in which case this needs to be updated
    # From looking around, I have not seen an example yet, however that doesn't mean it doesn't exist

    for (k, v) in args
        if occursin("{$k}", request_uri)
            request_uri = replace(request_uri, "{$k}" => v)
        elseif occursin("{$k+}", request_uri)
            request_uri = replace(request_uri, "{$k+}" => HTTP.escapepath(v))
        end
    end

    return request_uri
end

function _assignment_to_kw!(expr::Expr)
    if expr.head === :(=)
        expr.head = :kw
    else
        throw(ArgumentError("Expected assignment expression, instead found: `$expr`"))
    end

    return expr
end

function _assignment_to_kw!(x)
    return throw(ArgumentError("Expected assignment expression, instead found: `$x`"))
end

function _expected_symbol_exception(name::Symbol, expr)
    return ArgumentError("Expected `$name` to be a Symbol, instead found: `$expr`")
end

# https://docs.aws.amazon.com/sdkref/latest/guide/feature-retry-behavior.html
# Default values for AWS's `standard` retry mode. Note: these can be overridden elsewhere.
Base.@kwdef struct AWSExponentialBackoff
    max_attempts::Int = AWS_MAX_RETRY_ATTEMPTS
    max_backoff::Float64 = 20.0
    rng::AbstractRNG = Random.GLOBAL_RNG
end

# We make one more attempt than the number of delays
Base.length(exp::AWSExponentialBackoff) = exp.max_attempts - 1

function Base.iterate(exp::AWSExponentialBackoff, i=1)
    i >= exp.max_attempts && return nothing
    # rand() has values in [0, 1), so we use 1.0 - rand() which has values in (0, 1] required.
    b = 1.0 - rand(exp.rng)
    r = 2.0
    delay = min(b * r^i, exp.max_backoff)
    return delay, i + 1
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: lex_runtime_service
using AWS.Compat
using AWS.UUIDs

"""
    delete_session(bot_alias, bot_name, user_id)
    delete_session(bot_alias, bot_name, user_id, params::Dict{String,<:Any})

Removes session information for a specified bot, alias, and user ID.

# Arguments
- `bot_alias`: The alias in use for the bot that contains the session data.
- `bot_name`: The name of the bot that contains the session data.
- `user_id`: The identifier of the user associated with the session data.

"""
function delete_session(
    botAlias, botName, userId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_runtime_service(
        "DELETE",
        "/bot/$(botName)/alias/$(botAlias)/user/$(userId)/session";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_session(
    botAlias,
    botName,
    userId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_runtime_service(
        "DELETE",
        "/bot/$(botName)/alias/$(botAlias)/user/$(userId)/session",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_session(bot_alias, bot_name, user_id)
    get_session(bot_alias, bot_name, user_id, params::Dict{String,<:Any})

Returns session information for a specified bot, alias, and user ID.

# Arguments
- `bot_alias`: The alias in use for the bot that contains the session data.
- `bot_name`: The name of the bot that contains the session data.
- `user_id`: The ID of the client application user. Amazon Lex uses this to identify a
  user's conversation with your bot.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"checkpointLabelFilter"`: A string used to filter the intents returned in the
  recentIntentSummaryView structure.  When you specify a filter, only intents with their
  checkpointLabel field set to that string are returned.
"""
function get_session(
    botAlias, botName, userId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_runtime_service(
        "GET",
        "/bot/$(botName)/alias/$(botAlias)/user/$(userId)/session/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_session(
    botAlias,
    botName,
    userId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_runtime_service(
        "GET",
        "/bot/$(botName)/alias/$(botAlias)/user/$(userId)/session/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    post_content(content-_type, bot_alias, bot_name, input_stream, user_id)
    post_content(content-_type, bot_alias, bot_name, input_stream, user_id, params::Dict{String,<:Any})

 Sends user input (text or speech) to Amazon Lex. Clients use this API to send text and
audio requests to Amazon Lex at runtime. Amazon Lex interprets the user input using the
machine learning model that it built for the bot.  The PostContent operation supports audio
input at 8kHz and 16kHz. You can use 8kHz audio to achieve higher speech recognition
accuracy in telephone audio applications.   In response, Amazon Lex returns the next
message to convey to the user. Consider the following example messages:     For a user
input \"I would like a pizza,\" Amazon Lex might return a response with a message eliciting
slot data (for example, PizzaSize): \"What size pizza would you like?\".     After the user
provides all of the pizza order information, Amazon Lex might return a response with a
message to get user confirmation: \"Order the pizza?\".     After the user replies \"Yes\"
to the confirmation prompt, Amazon Lex might return a conclusion statement: \"Thank you,
your cheese pizza has been ordered.\".     Not all Amazon Lex messages require a response
from the user. For example, conclusion statements do not require a response. Some messages
require only a yes or no response. In addition to the message, Amazon Lex provides
additional context about the message in the response that you can use to enhance client
behavior, such as displaying the appropriate client user interface. Consider the following
examples:     If the message is to elicit slot data, Amazon Lex returns the following
context information:     x-amz-lex-dialog-state header set to ElicitSlot
x-amz-lex-intent-name header set to the intent name in the current context
x-amz-lex-slot-to-elicit header set to the slot name for which the message is eliciting
information     x-amz-lex-slots header set to a map of slots configured for the intent with
their current values       If the message is a confirmation prompt, the
x-amz-lex-dialog-state header is set to Confirmation and the x-amz-lex-slot-to-elicit
header is omitted.     If the message is a clarification prompt configured for the intent,
indicating that the user intent is not understood, the x-amz-dialog-state header is set to
ElicitIntent and the x-amz-slot-to-elicit header is omitted.     In addition, Amazon Lex
also returns your application-specific sessionAttributes. For more information, see
Managing Conversation Context.

# Arguments
- `content-_type`:  You pass this value as the Content-Type HTTP header.   Indicates the
  audio format or text. The header value must start with one of the following prefixes:
  PCM format, audio data must be in little-endian byte order.   audio/l16; rate=16000;
  channels=1   audio/x-l16; sample-rate=16000; channel-count=1   audio/lpcm;
  sample-rate=8000; sample-size-bits=16; channel-count=1; is-big-endian=false      Opus
  format   audio/x-cbr-opus-with-preamble; preamble-size=0; bit-rate=256000;
  frame-size-milliseconds=4     Text format   text/plain; charset=utf-8
- `bot_alias`: Alias of the Amazon Lex bot.
- `bot_name`: Name of the Amazon Lex bot.
- `input_stream`:  User input in PCM or Opus audio format or text format as described in
  the Content-Type HTTP header.  You can stream audio data to Amazon Lex or you can create a
  local buffer that captures all of the audio data before sending. In general, you get better
  performance if you stream audio data rather than buffering the data locally.
- `user_id`: The ID of the client application user. Amazon Lex uses this to identify a
  user's conversation with your bot. At runtime, each request must contain the userID field.
  To decide the user ID to use for your application, consider the following factors.   The
  userID field must not contain any personally identifiable information of the user, for
  example, name, personal identification numbers, or other end user personal information.
  If you want a user to start a conversation on one device and continue on another device,
  use a user-specific identifier.   If you want the same user to be able to have two
  independent conversations on two different devices, choose a device-specific identifier.
  A user can't have two independent conversations with two different versions of the same
  bot. For example, a user can't have a conversation with the PROD and BETA versions of the
  same bot. If you anticipate that a user will need to have conversation with two different
  versions, for example, while testing, include the bot alias in the user ID to separate the
  two conversations.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Accept"`:  You pass this value as the Accept HTTP header.   The message Amazon Lex
  returns in the response can be either text or speech based on the Accept HTTP header value
  in the request.     If the value is text/plain; charset=utf-8, Amazon Lex returns text in
  the response.     If the value begins with audio/, Amazon Lex returns speech in the
  response. Amazon Lex uses Amazon Polly to generate the speech (using the configuration you
  specified in the Accept header). For example, if you specify audio/mpeg as the value,
  Amazon Lex returns speech in the MPEG format.   If the value is audio/pcm, the speech
  returned is audio/pcm in 16-bit, little endian format.    The following are the accepted
  values:   audio/mpeg   audio/ogg   audio/pcm   text/plain; charset=utf-8   audio/*
  (defaults to mpeg)
- `"x-amz-lex-active-contexts"`: A list of contexts active for the request. A context can
  be activated when a previous intent is fulfilled, or by including the context in the
  request, If you don't specify a list of contexts, Amazon Lex will use the current list of
  contexts for the session. If you specify an empty list, all contexts for the session are
  cleared.
- `"x-amz-lex-request-attributes"`: You pass this value as the x-amz-lex-request-attributes
  HTTP header. Request-specific information passed between Amazon Lex and a client
  application. The value must be a JSON serialized and base64 encoded map with string keys
  and values. The total size of the requestAttributes and sessionAttributes headers is
  limited to 12 KB. The namespace x-amz-lex: is reserved for special attributes. Don't create
  any request attributes with the prefix x-amz-lex:. For more information, see Setting
  Request Attributes.
- `"x-amz-lex-session-attributes"`: You pass this value as the x-amz-lex-session-attributes
  HTTP header. Application-specific information passed between Amazon Lex and a client
  application. The value must be a JSON serialized and base64 encoded map with string keys
  and values. The total size of the sessionAttributes and requestAttributes headers is
  limited to 12 KB. For more information, see Setting Session Attributes.
"""
function post_content(
    Content_Type,
    botAlias,
    botName,
    inputStream,
    userId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_runtime_service(
        "POST",
        "/bot/$(botName)/alias/$(botAlias)/user/$(userId)/content",
        Dict{String,Any}(
            "inputStream" => inputStream,
            "headers" => Dict{String,Any}("Content-Type" => Content_Type),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function post_content(
    Content_Type,
    botAlias,
    botName,
    inputStream,
    userId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_runtime_service(
        "POST",
        "/bot/$(botName)/alias/$(botAlias)/user/$(userId)/content",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "inputStream" => inputStream,
                    "headers" => Dict{String,Any}("Content-Type" => Content_Type),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    post_text(bot_alias, bot_name, input_text, user_id)
    post_text(bot_alias, bot_name, input_text, user_id, params::Dict{String,<:Any})

Sends user input to Amazon Lex. Client applications can use this API to send requests to
Amazon Lex at runtime. Amazon Lex then interprets the user input using the machine learning
model it built for the bot.   In response, Amazon Lex returns the next message to convey to
the user an optional responseCard to display. Consider the following example messages:
For a user input \"I would like a pizza\", Amazon Lex might return a response with a
message eliciting slot data (for example, PizzaSize): \"What size pizza would you like?\"
  After the user provides all of the pizza order information, Amazon Lex might return a
response with a message to obtain user confirmation \"Proceed with the pizza order?\".
After the user replies to a confirmation prompt with a \"yes\", Amazon Lex might return a
conclusion statement: \"Thank you, your cheese pizza has been ordered.\".     Not all
Amazon Lex messages require a user response. For example, a conclusion statement does not
require a response. Some messages require only a \"yes\" or \"no\" user response. In
addition to the message, Amazon Lex provides additional context about the message in the
response that you might use to enhance client behavior, for example, to display the
appropriate client user interface. These are the slotToElicit, dialogState, intentName, and
slots fields in the response. Consider the following examples:    If the message is to
elicit slot data, Amazon Lex returns the following context information:    dialogState set
to ElicitSlot     intentName set to the intent name in the current context     slotToElicit
set to the slot name for which the message is eliciting information     slots set to a map
of slots, configured for the intent, with currently known values       If the message is a
confirmation prompt, the dialogState is set to ConfirmIntent and SlotToElicit is set to
null.    If the message is a clarification prompt (configured for the intent) that
indicates that user intent is not understood, the dialogState is set to ElicitIntent and
slotToElicit is set to null.     In addition, Amazon Lex also returns your
application-specific sessionAttributes. For more information, see Managing Conversation
Context.

# Arguments
- `bot_alias`: The alias of the Amazon Lex bot.
- `bot_name`: The name of the Amazon Lex bot.
- `input_text`: The text that the user entered (Amazon Lex interprets this text).
- `user_id`: The ID of the client application user. Amazon Lex uses this to identify a
  user's conversation with your bot. At runtime, each request must contain the userID field.
  To decide the user ID to use for your application, consider the following factors.   The
  userID field must not contain any personally identifiable information of the user, for
  example, name, personal identification numbers, or other end user personal information.
  If you want a user to start a conversation on one device and continue on another device,
  use a user-specific identifier.   If you want the same user to be able to have two
  independent conversations on two different devices, choose a device-specific identifier.
  A user can't have two independent conversations with two different versions of the same
  bot. For example, a user can't have a conversation with the PROD and BETA versions of the
  same bot. If you anticipate that a user will need to have conversation with two different
  versions, for example, while testing, include the bot alias in the user ID to separate the
  two conversations.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"activeContexts"`: A list of contexts active for the request. A context can be activated
  when a previous intent is fulfilled, or by including the context in the request, If you
  don't specify a list of contexts, Amazon Lex will use the current list of contexts for the
  session. If you specify an empty list, all contexts for the session are cleared.
- `"requestAttributes"`: Request-specific information passed between Amazon Lex and a
  client application. The namespace x-amz-lex: is reserved for special attributes. Don't
  create any request attributes with the prefix x-amz-lex:. For more information, see Setting
  Request Attributes.
- `"sessionAttributes"`: Application-specific information passed between Amazon Lex and a
  client application. For more information, see Setting Session Attributes.
"""
function post_text(
    botAlias, botName, inputText, userId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_runtime_service(
        "POST",
        "/bot/$(botName)/alias/$(botAlias)/user/$(userId)/text",
        Dict{String,Any}("inputText" => inputText);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function post_text(
    botAlias,
    botName,
    inputText,
    userId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_runtime_service(
        "POST",
        "/bot/$(botName)/alias/$(botAlias)/user/$(userId)/text",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("inputText" => inputText), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_session(bot_alias, bot_name, user_id)
    put_session(bot_alias, bot_name, user_id, params::Dict{String,<:Any})

Creates a new session or modifies an existing session with an Amazon Lex bot. Use this
operation to enable your application to set the state of the bot. For more information, see
Managing Sessions.

# Arguments
- `bot_alias`: The alias in use for the bot that contains the session data.
- `bot_name`: The name of the bot that contains the session data.
- `user_id`: The ID of the client application user. Amazon Lex uses this to identify a
  user's conversation with your bot.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Accept"`: The message that Amazon Lex returns in the response can be either text or
  speech based depending on the value of this field.   If the value is text/plain;
  charset=utf-8, Amazon Lex returns text in the response.   If the value begins with audio/,
  Amazon Lex returns speech in the response. Amazon Lex uses Amazon Polly to generate the
  speech in the configuration that you specify. For example, if you specify audio/mpeg as the
  value, Amazon Lex returns speech in the MPEG format.   If the value is audio/pcm, the
  speech is returned as audio/pcm in 16-bit, little endian format.   The following are the
  accepted values:    audio/mpeg     audio/ogg     audio/pcm     audio/* (defaults to mpeg)
   text/plain; charset=utf-8
- `"activeContexts"`: A list of contexts active for the request. A context can be activated
  when a previous intent is fulfilled, or by including the context in the request, If you
  don't specify a list of contexts, Amazon Lex will use the current list of contexts for the
  session. If you specify an empty list, all contexts for the session are cleared.
- `"dialogAction"`: Sets the next action that the bot should take to fulfill the
  conversation.
- `"recentIntentSummaryView"`: A summary of the recent intents for the bot. You can use the
  intent summary view to set a checkpoint label on an intent and modify attributes of
  intents. You can also use it to remove or add intent summary objects to the list. An intent
  that you modify or add to the list must make sense for the bot. For example, the intent
  name must be valid for the bot. You must provide valid values for:    intentName    slot
  names    slotToElict    If you send the recentIntentSummaryView parameter in a PutSession
  request, the contents of the new summary view replaces the old summary view. For example,
  if a GetSession request returns three intents in the summary view and you call PutSession
  with one intent in the summary view, the next call to GetSession will only return one
  intent.
- `"sessionAttributes"`: Map of key/value pairs representing the session-specific context
  information. It contains application information passed between Amazon Lex and a client
  application.
"""
function put_session(
    botAlias, botName, userId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_runtime_service(
        "POST",
        "/bot/$(botName)/alias/$(botAlias)/user/$(userId)/session";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_session(
    botAlias,
    botName,
    userId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_runtime_service(
        "POST",
        "/bot/$(botName)/alias/$(botAlias)/user/$(userId)/session",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: lookoutequipment
using AWS.Compat
using AWS.UUIDs

"""
    create_dataset(client_token, dataset_name)
    create_dataset(client_token, dataset_name, params::Dict{String,<:Any})

Creates a container for a collection of data being ingested for analysis. The dataset
contains the metadata describing where the data is and what the data actually looks like.
For example, it contains the location of the data source, the data schema, and other
information. A dataset also contains any tags associated with the ingested data.

# Arguments
- `client_token`:  A unique identifier for the request. If you do not set the client
  request token, Amazon Lookout for Equipment generates one.
- `dataset_name`: The name of the dataset being created.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DatasetSchema"`: A JSON description of the data that is in each time series dataset,
  including names, column names, and data types.
- `"ServerSideKmsKeyId"`: Provides the identifier of the KMS key used to encrypt dataset
  data by Amazon Lookout for Equipment.
- `"Tags"`: Any tags associated with the ingested data described in the dataset.
"""
function create_dataset(
    ClientToken, DatasetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutequipment(
        "CreateDataset",
        Dict{String,Any}("ClientToken" => ClientToken, "DatasetName" => DatasetName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_dataset(
    ClientToken,
    DatasetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutequipment(
        "CreateDataset",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClientToken" => ClientToken, "DatasetName" => DatasetName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_inference_scheduler(client_token, data_input_configuration, data_output_configuration, data_upload_frequency, inference_scheduler_name, model_name, role_arn)
    create_inference_scheduler(client_token, data_input_configuration, data_output_configuration, data_upload_frequency, inference_scheduler_name, model_name, role_arn, params::Dict{String,<:Any})

 Creates a scheduled inference. Scheduling an inference is setting up a continuous
real-time inference plan to analyze new measurement data. When setting up the schedule, you
provide an S3 bucket location for the input data, assign it a delimiter between separate
entries in the data, set an offset delay if desired, and set the frequency of inferencing.
You must also provide an S3 bucket location for the output data.

# Arguments
- `client_token`:  A unique identifier for the request. If you do not set the client
  request token, Amazon Lookout for Equipment generates one.
- `data_input_configuration`: Specifies configuration information for the input data for
  the inference scheduler, including delimiter, format, and dataset location.
- `data_output_configuration`: Specifies configuration information for the output results
  for the inference scheduler, including the S3 location for the output.
- `data_upload_frequency`:  How often data is uploaded to the source Amazon S3 bucket for
  the input data. The value chosen is the length of time between data uploads. For instance,
  if you select 5 minutes, Amazon Lookout for Equipment will upload the real-time data to the
  source bucket once every 5 minutes. This frequency also determines how often Amazon Lookout
  for Equipment runs inference on your data. For more information, see Understanding the
  inference process.
- `inference_scheduler_name`: The name of the inference scheduler being created.
- `model_name`: The name of the previously trained machine learning model being used to
  create the inference scheduler.
- `role_arn`: The Amazon Resource Name (ARN) of a role with permission to access the data
  source being used for the inference.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DataDelayOffsetInMinutes"`: The interval (in minutes) of planned delay at the start of
  each inference segment. For example, if inference is set to run every ten minutes, the
  delay is set to five minutes and the time is 09:08. The inference scheduler will wake up at
  the configured interval (which, without a delay configured, would be 09:10) plus the
  additional five minute delay time (so 09:15) to check your Amazon S3 bucket. The delay
  provides a buffer for you to upload data at the same frequency, so that you don't have to
  stop and restart the scheduler when uploading new data. For more information, see
  Understanding the inference process.
- `"ServerSideKmsKeyId"`: Provides the identifier of the KMS key used to encrypt inference
  scheduler data by Amazon Lookout for Equipment.
- `"Tags"`: Any tags associated with the inference scheduler.
"""
function create_inference_scheduler(
    ClientToken,
    DataInputConfiguration,
    DataOutputConfiguration,
    DataUploadFrequency,
    InferenceSchedulerName,
    ModelName,
    RoleArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutequipment(
        "CreateInferenceScheduler",
        Dict{String,Any}(
            "ClientToken" => ClientToken,
            "DataInputConfiguration" => DataInputConfiguration,
            "DataOutputConfiguration" => DataOutputConfiguration,
            "DataUploadFrequency" => DataUploadFrequency,
            "InferenceSchedulerName" => InferenceSchedulerName,
            "ModelName" => ModelName,
            "RoleArn" => RoleArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_inference_scheduler(
    ClientToken,
    DataInputConfiguration,
    DataOutputConfiguration,
    DataUploadFrequency,
    InferenceSchedulerName,
    ModelName,
    RoleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutequipment(
        "CreateInferenceScheduler",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClientToken" => ClientToken,
                    "DataInputConfiguration" => DataInputConfiguration,
                    "DataOutputConfiguration" => DataOutputConfiguration,
                    "DataUploadFrequency" => DataUploadFrequency,
                    "InferenceSchedulerName" => InferenceSchedulerName,
                    "ModelName" => ModelName,
                    "RoleArn" => RoleArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_label(client_token, end_time, label_group_name, rating, start_time)
    create_label(client_token, end_time, label_group_name, rating, start_time, params::Dict{String,<:Any})

 Creates a label for an event.

# Arguments
- `client_token`:  A unique identifier for the request to create a label. If you do not set
  the client request token, Lookout for Equipment generates one.
- `end_time`:  The end time of the labeled event.
- `label_group_name`:  The name of a group of labels.  Data in this field will be retained
  for service usage. Follow best practices for the security of your data.
- `rating`:  Indicates whether a labeled event represents an anomaly.
- `start_time`:  The start time of the labeled event.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Equipment"`:  Indicates that a label pertains to a particular piece of equipment.  Data
  in this field will be retained for service usage. Follow best practices for the security of
  your data.
- `"FaultCode"`:  Provides additional information about the label. The fault code must be
  defined in the FaultCodes attribute of the label group. Data in this field will be retained
  for service usage. Follow best practices for the security of your data.
- `"Notes"`:  Metadata providing additional information about the label.  Data in this
  field will be retained for service usage. Follow best practices for the security of your
  data.
"""
function create_label(
    ClientToken,
    EndTime,
    LabelGroupName,
    Rating,
    StartTime;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutequipment(
        "CreateLabel",
        Dict{String,Any}(
            "ClientToken" => ClientToken,
            "EndTime" => EndTime,
            "LabelGroupName" => LabelGroupName,
            "Rating" => Rating,
            "StartTime" => StartTime,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_label(
    ClientToken,
    EndTime,
    LabelGroupName,
    Rating,
    StartTime,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutequipment(
        "CreateLabel",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClientToken" => ClientToken,
                    "EndTime" => EndTime,
                    "LabelGroupName" => LabelGroupName,
                    "Rating" => Rating,
                    "StartTime" => StartTime,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_label_group(client_token, label_group_name)
    create_label_group(client_token, label_group_name, params::Dict{String,<:Any})

 Creates a group of labels.

# Arguments
- `client_token`:  A unique identifier for the request to create a label group. If you do
  not set the client request token, Lookout for Equipment generates one.
- `label_group_name`:  Names a group of labels. Data in this field will be retained for
  service usage. Follow best practices for the security of your data.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FaultCodes"`:  The acceptable fault codes (indicating the type of anomaly associated
  with the label) that can be used with this label group. Data in this field will be retained
  for service usage. Follow best practices for the security of your data.
- `"Tags"`:  Tags that provide metadata about the label group you are creating.  Data in
  this field will be retained for service usage. Follow best practices for the security of
  your data.
"""
function create_label_group(
    ClientToken, LabelGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutequipment(
        "CreateLabelGroup",
        Dict{String,Any}("ClientToken" => ClientToken, "LabelGroupName" => LabelGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_label_group(
    ClientToken,
    LabelGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutequipment(
        "CreateLabelGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClientToken" => ClientToken, "LabelGroupName" => LabelGroupName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_model(client_token, dataset_name, model_name)
    create_model(client_token, dataset_name, model_name, params::Dict{String,<:Any})

Creates a machine learning model for data inference.  A machine-learning (ML) model is a
mathematical model that finds patterns in your data. In Amazon Lookout for Equipment, the
model learns the patterns of normal behavior and detects abnormal behavior that could be
potential equipment failure (or maintenance events). The models are made by analyzing
normal data and abnormalities in machine behavior that have already occurred. Your model is
trained using a portion of the data from your dataset and uses that data to learn patterns
of normal behavior and abnormal patterns that lead to equipment failure. Another portion of
the data is used to evaluate the model's accuracy.

# Arguments
- `client_token`: A unique identifier for the request. If you do not set the client request
  token, Amazon Lookout for Equipment generates one.
- `dataset_name`: The name of the dataset for the machine learning model being created.
- `model_name`: The name for the machine learning model to be created.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DataPreProcessingConfiguration"`: The configuration is the TargetSamplingRate, which is
  the sampling rate of the data after post processing by Amazon Lookout for Equipment. For
  example, if you provide data that has been collected at a 1 second level and you want the
  system to resample the data at a 1 minute rate before training, the TargetSamplingRate is 1
  minute. When providing a value for the TargetSamplingRate, you must attach the prefix
  \"PT\" to the rate you want. The value for a 1 second rate is therefore PT1S, the value for
  a 15 minute rate is PT15M, and the value for a 1 hour rate is PT1H
- `"DatasetSchema"`: The data schema for the machine learning model being created.
- `"EvaluationDataEndTime"`:  Indicates the time reference in the dataset that should be
  used to end the subset of evaluation data for the machine learning model.
- `"EvaluationDataStartTime"`: Indicates the time reference in the dataset that should be
  used to begin the subset of evaluation data for the machine learning model.
- `"LabelsInputConfiguration"`: The input configuration for the labels being used for the
  machine learning model that's being created.
- `"ModelDiagnosticsOutputConfiguration"`: The Amazon S3 location where you want Amazon
  Lookout for Equipment to save the pointwise model diagnostics. You must also specify the
  RoleArn request parameter.
- `"OffCondition"`: Indicates that the asset associated with this sensor has been shut off.
  As long as this condition is met, Lookout for Equipment will not use data from this asset
  for training, evaluation, or inference.
- `"RoleArn"`:  The Amazon Resource Name (ARN) of a role with permission to access the data
  source being used to create the machine learning model.
- `"ServerSideKmsKeyId"`: Provides the identifier of the KMS key used to encrypt model data
  by Amazon Lookout for Equipment.
- `"Tags"`:  Any tags associated with the machine learning model being created.
- `"TrainingDataEndTime"`: Indicates the time reference in the dataset that should be used
  to end the subset of training data for the machine learning model.
- `"TrainingDataStartTime"`: Indicates the time reference in the dataset that should be
  used to begin the subset of training data for the machine learning model.
"""
function create_model(
    ClientToken, DatasetName, ModelName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutequipment(
        "CreateModel",
        Dict{String,Any}(
            "ClientToken" => ClientToken,
            "DatasetName" => DatasetName,
            "ModelName" => ModelName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_model(
    ClientToken,
    DatasetName,
    ModelName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutequipment(
        "CreateModel",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClientToken" => ClientToken,
                    "DatasetName" => DatasetName,
                    "ModelName" => ModelName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_retraining_scheduler(client_token, lookback_window, model_name, retraining_frequency)
    create_retraining_scheduler(client_token, lookback_window, model_name, retraining_frequency, params::Dict{String,<:Any})

Creates a retraining scheduler on the specified model.

# Arguments
- `client_token`: A unique identifier for the request. If you do not set the client request
  token, Amazon Lookout for Equipment generates one.
- `lookback_window`: The number of past days of data that will be used for retraining.
- `model_name`: The name of the model to add the retraining scheduler to.
- `retraining_frequency`: This parameter uses the ISO 8601 standard to set the frequency at
  which you want retraining to occur in terms of Years, Months, and/or Days (note: other
  parameters like Time are not currently supported). The minimum value is 30 days (P30D) and
  the maximum value is 1 year (P1Y). For example, the following values are valid:   P3M15D
  – Every 3 months and 15 days   P2M – Every 2 months   P150D – Every 150 days

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"PromoteMode"`: Indicates how the service will use new models. In MANAGED mode, new
  models will automatically be used for inference if they have better performance than the
  current model. In MANUAL mode, the new models will not be used until they are manually
  activated.
- `"RetrainingStartDate"`: The start date for the retraining scheduler. Lookout for
  Equipment truncates the time you provide to the nearest UTC day.
"""
function create_retraining_scheduler(
    ClientToken,
    LookbackWindow,
    ModelName,
    RetrainingFrequency;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutequipment(
        "CreateRetrainingScheduler",
        Dict{String,Any}(
            "ClientToken" => ClientToken,
            "LookbackWindow" => LookbackWindow,
            "ModelName" => ModelName,
            "RetrainingFrequency" => RetrainingFrequency,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_retraining_scheduler(
    ClientToken,
    LookbackWindow,
    ModelName,
    RetrainingFrequency,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutequipment(
        "CreateRetrainingScheduler",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClientToken" => ClientToken,
                    "LookbackWindow" => LookbackWindow,
                    "ModelName" => ModelName,
                    "RetrainingFrequency" => RetrainingFrequency,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_dataset(dataset_name)
    delete_dataset(dataset_name, params::Dict{String,<:Any})

 Deletes a dataset and associated artifacts. The operation will check to see if any
inference scheduler or data ingestion job is currently using the dataset, and if there
isn't, the dataset, its metadata, and any associated data stored in S3 will be deleted.
This does not affect any models that used this dataset for training and evaluation, but
does prevent it from being used in the future.

# Arguments
- `dataset_name`: The name of the dataset to be deleted.

"""
function delete_dataset(DatasetName; aws_config::AbstractAWSConfig=current_aws_config())
    return lookoutequipment(
        "DeleteDataset",
        Dict{String,Any}("DatasetName" => DatasetName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_dataset(
    DatasetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutequipment(
        "DeleteDataset",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DatasetName" => DatasetName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_inference_scheduler(inference_scheduler_name)
    delete_inference_scheduler(inference_scheduler_name, params::Dict{String,<:Any})

Deletes an inference scheduler that has been set up. Prior inference results will not be
deleted.

# Arguments
- `inference_scheduler_name`: The name of the inference scheduler to be deleted.

"""
function delete_inference_scheduler(
    InferenceSchedulerName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutequipment(
        "DeleteInferenceScheduler",
        Dict{String,Any}("InferenceSchedulerName" => InferenceSchedulerName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_inference_scheduler(
    InferenceSchedulerName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutequipment(
        "DeleteInferenceScheduler",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("InferenceSchedulerName" => InferenceSchedulerName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_label(label_group_name, label_id)
    delete_label(label_group_name, label_id, params::Dict{String,<:Any})

 Deletes a label.

# Arguments
- `label_group_name`:  The name of the label group that contains the label that you want to
  delete. Data in this field will be retained for service usage. Follow best practices for
  the security of your data.
- `label_id`:  The ID of the label that you want to delete.

"""
function delete_label(
    LabelGroupName, LabelId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutequipment(
        "DeleteLabel",
        Dict{String,Any}("LabelGroupName" => LabelGroupName, "LabelId" => LabelId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_label(
    LabelGroupName,
    LabelId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutequipment(
        "DeleteLabel",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("LabelGroupName" => LabelGroupName, "LabelId" => LabelId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_label_group(label_group_name)
    delete_label_group(label_group_name, params::Dict{String,<:Any})

 Deletes a group of labels.

# Arguments
- `label_group_name`:  The name of the label group that you want to delete. Data in this
  field will be retained for service usage. Follow best practices for the security of your
  data.

"""
function delete_label_group(
    LabelGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutequipment(
        "DeleteLabelGroup",
        Dict{String,Any}("LabelGroupName" => LabelGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_label_group(
    LabelGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutequipment(
        "DeleteLabelGroup",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("LabelGroupName" => LabelGroupName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_model(model_name)
    delete_model(model_name, params::Dict{String,<:Any})

Deletes a machine learning model currently available for Amazon Lookout for Equipment. This
will prevent it from being used with an inference scheduler, even one that is already set
up.

# Arguments
- `model_name`: The name of the machine learning model to be deleted.

"""
function delete_model(ModelName; aws_config::AbstractAWSConfig=current_aws_config())
    return lookoutequipment(
        "DeleteModel",
        Dict{String,Any}("ModelName" => ModelName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_model(
    ModelName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutequipment(
        "DeleteModel",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ModelName" => ModelName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_resource_policy(resource_arn)
    delete_resource_policy(resource_arn, params::Dict{String,<:Any})

Deletes the resource policy attached to the resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource for which the resource
  policy should be deleted.

"""
function delete_resource_policy(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutequipment(
        "DeleteResourcePolicy",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_resource_policy(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutequipment(
        "DeleteResourcePolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_retraining_scheduler(model_name)
    delete_retraining_scheduler(model_name, params::Dict{String,<:Any})

Deletes a retraining scheduler from a model. The retraining scheduler must be in the
STOPPED status.

# Arguments
- `model_name`: The name of the model whose retraining scheduler you want to delete.

"""
function delete_retraining_scheduler(
    ModelName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutequipment(
        "DeleteRetrainingScheduler",
        Dict{String,Any}("ModelName" => ModelName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_retraining_scheduler(
    ModelName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutequipment(
        "DeleteRetrainingScheduler",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ModelName" => ModelName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_data_ingestion_job(job_id)
    describe_data_ingestion_job(job_id, params::Dict{String,<:Any})

Provides information on a specific data ingestion job such as creation time, dataset ARN,
and status.

# Arguments
- `job_id`: The job ID of the data ingestion job.

"""
function describe_data_ingestion_job(
    JobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutequipment(
        "DescribeDataIngestionJob",
        Dict{String,Any}("JobId" => JobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_data_ingestion_job(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutequipment(
        "DescribeDataIngestionJob",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("JobId" => JobId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_dataset(dataset_name)
    describe_dataset(dataset_name, params::Dict{String,<:Any})

Provides a JSON description of the data in each time series dataset, including names,
column names, and data types.

# Arguments
- `dataset_name`: The name of the dataset to be described.

"""
function describe_dataset(DatasetName; aws_config::AbstractAWSConfig=current_aws_config())
    return lookoutequipment(
        "DescribeDataset",
        Dict{String,Any}("DatasetName" => DatasetName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_dataset(
    DatasetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutequipment(
        "DescribeDataset",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DatasetName" => DatasetName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_inference_scheduler(inference_scheduler_name)
    describe_inference_scheduler(inference_scheduler_name, params::Dict{String,<:Any})

 Specifies information about the inference scheduler being used, including name, model,
status, and associated metadata

# Arguments
- `inference_scheduler_name`: The name of the inference scheduler being described.

"""
function describe_inference_scheduler(
    InferenceSchedulerName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutequipment(
        "DescribeInferenceScheduler",
        Dict{String,Any}("InferenceSchedulerName" => InferenceSchedulerName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_inference_scheduler(
    InferenceSchedulerName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutequipment(
        "DescribeInferenceScheduler",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("InferenceSchedulerName" => InferenceSchedulerName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_label(label_group_name, label_id)
    describe_label(label_group_name, label_id, params::Dict{String,<:Any})

 Returns the name of the label.

# Arguments
- `label_group_name`:  Returns the name of the group containing the label.
- `label_id`:  Returns the ID of the label.

"""
function describe_label(
    LabelGroupName, LabelId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutequipment(
        "DescribeLabel",
        Dict{String,Any}("LabelGroupName" => LabelGroupName, "LabelId" => LabelId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_label(
    LabelGroupName,
    LabelId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutequipment(
        "DescribeLabel",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("LabelGroupName" => LabelGroupName, "LabelId" => LabelId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_label_group(label_group_name)
    describe_label_group(label_group_name, params::Dict{String,<:Any})

 Returns information about the label group.

# Arguments
- `label_group_name`:  Returns the name of the label group.

"""
function describe_label_group(
    LabelGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutequipment(
        "DescribeLabelGroup",
        Dict{String,Any}("LabelGroupName" => LabelGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_label_group(
    LabelGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutequipment(
        "DescribeLabelGroup",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("LabelGroupName" => LabelGroupName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_model(model_name)
    describe_model(model_name, params::Dict{String,<:Any})

Provides a JSON containing the overall information about a specific machine learning model,
including model name and ARN, dataset, training and evaluation information, status, and so
on.

# Arguments
- `model_name`: The name of the machine learning model to be described.

"""
function describe_model(ModelName; aws_config::AbstractAWSConfig=current_aws_config())
    return lookoutequipment(
        "DescribeModel",
        Dict{String,Any}("ModelName" => ModelName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_model(
    ModelName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutequipment(
        "DescribeModel",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ModelName" => ModelName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_model_version(model_name, model_version)
    describe_model_version(model_name, model_version, params::Dict{String,<:Any})

Retrieves information about a specific machine learning model version.

# Arguments
- `model_name`: The name of the machine learning model that this version belongs to.
- `model_version`: The version of the machine learning model.

"""
function describe_model_version(
    ModelName, ModelVersion; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutequipment(
        "DescribeModelVersion",
        Dict{String,Any}("ModelName" => ModelName, "ModelVersion" => ModelVersion);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_model_version(
    ModelName,
    ModelVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutequipment(
        "DescribeModelVersion",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ModelName" => ModelName, "ModelVersion" => ModelVersion),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_resource_policy(resource_arn)
    describe_resource_policy(resource_arn, params::Dict{String,<:Any})

Provides the details of a resource policy attached to a resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource that is associated with
  the resource policy.

"""
function describe_resource_policy(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutequipment(
        "DescribeResourcePolicy",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_resource_policy(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutequipment(
        "DescribeResourcePolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_retraining_scheduler(model_name)
    describe_retraining_scheduler(model_name, params::Dict{String,<:Any})

Provides a description of the retraining scheduler, including information such as the model
name and retraining parameters.

# Arguments
- `model_name`: The name of the model that the retraining scheduler is attached to.

"""
function describe_retraining_scheduler(
    ModelName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutequipment(
        "DescribeRetrainingScheduler",
        Dict{String,Any}("ModelName" => ModelName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_retraining_scheduler(
    ModelName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutequipment(
        "DescribeRetrainingScheduler",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ModelName" => ModelName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    import_dataset(client_token, source_dataset_arn)
    import_dataset(client_token, source_dataset_arn, params::Dict{String,<:Any})

Imports a dataset.

# Arguments
- `client_token`: A unique identifier for the request. If you do not set the client request
  token, Amazon Lookout for Equipment generates one.
- `source_dataset_arn`: The Amazon Resource Name (ARN) of the dataset to import.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DatasetName"`: The name of the machine learning dataset to be created. If the dataset
  already exists, Amazon Lookout for Equipment overwrites the existing dataset. If you don't
  specify this field, it is filled with the name of the source dataset.
- `"ServerSideKmsKeyId"`: Provides the identifier of the KMS key key used to encrypt model
  data by Amazon Lookout for Equipment.
- `"Tags"`: Any tags associated with the dataset to be created.
"""
function import_dataset(
    ClientToken, SourceDatasetArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutequipment(
        "ImportDataset",
        Dict{String,Any}(
            "ClientToken" => ClientToken, "SourceDatasetArn" => SourceDatasetArn
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function import_dataset(
    ClientToken,
    SourceDatasetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutequipment(
        "ImportDataset",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClientToken" => ClientToken, "SourceDatasetArn" => SourceDatasetArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    import_model_version(client_token, dataset_name, source_model_version_arn)
    import_model_version(client_token, dataset_name, source_model_version_arn, params::Dict{String,<:Any})

Imports a model that has been trained successfully.

# Arguments
- `client_token`: A unique identifier for the request. If you do not set the client request
  token, Amazon Lookout for Equipment generates one.
- `dataset_name`: The name of the dataset for the machine learning model being imported.
- `source_model_version_arn`: The Amazon Resource Name (ARN) of the model version to import.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"InferenceDataImportStrategy"`: Indicates how to import the accumulated inference data
  when a model version is imported. The possible values are as follows:   NO_IMPORT – Don't
  import the data.   ADD_WHEN_EMPTY – Only import the data from the source model if there
  is no existing data in the target model.   OVERWRITE – Import the data from the source
  model and overwrite the existing data in the target model.
- `"LabelsInputConfiguration"`:
- `"ModelName"`: The name for the machine learning model to be created. If the model
  already exists, Amazon Lookout for Equipment creates a new version. If you do not specify
  this field, it is filled with the name of the source model.
- `"RoleArn"`: The Amazon Resource Name (ARN) of a role with permission to access the data
  source being used to create the machine learning model.
- `"ServerSideKmsKeyId"`: Provides the identifier of the KMS key key used to encrypt model
  data by Amazon Lookout for Equipment.
- `"Tags"`: The tags associated with the machine learning model to be created.
"""
function import_model_version(
    ClientToken,
    DatasetName,
    SourceModelVersionArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutequipment(
        "ImportModelVersion",
        Dict{String,Any}(
            "ClientToken" => ClientToken,
            "DatasetName" => DatasetName,
            "SourceModelVersionArn" => SourceModelVersionArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function import_model_version(
    ClientToken,
    DatasetName,
    SourceModelVersionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutequipment(
        "ImportModelVersion",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClientToken" => ClientToken,
                    "DatasetName" => DatasetName,
                    "SourceModelVersionArn" => SourceModelVersionArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_data_ingestion_jobs()
    list_data_ingestion_jobs(params::Dict{String,<:Any})

Provides a list of all data ingestion jobs, including dataset name and ARN, S3 location of
the input data, status, and so on.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DatasetName"`: The name of the dataset being used for the data ingestion job.
- `"MaxResults"`:  Specifies the maximum number of data ingestion jobs to list.
- `"NextToken"`: An opaque pagination token indicating where to continue the listing of
  data ingestion jobs.
- `"Status"`: Indicates the status of the data ingestion job.
"""
function list_data_ingestion_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return lookoutequipment(
        "ListDataIngestionJobs"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_data_ingestion_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutequipment(
        "ListDataIngestionJobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_datasets()
    list_datasets(params::Dict{String,<:Any})

Lists all datasets currently available in your account, filtering on the dataset name.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DatasetNameBeginsWith"`: The beginning of the name of the datasets to be listed.
- `"MaxResults"`:  Specifies the maximum number of datasets to list.
- `"NextToken"`:  An opaque pagination token indicating where to continue the listing of
  datasets.
"""
function list_datasets(; aws_config::AbstractAWSConfig=current_aws_config())
    return lookoutequipment(
        "ListDatasets"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_datasets(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutequipment(
        "ListDatasets", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_inference_events(inference_scheduler_name, interval_end_time, interval_start_time)
    list_inference_events(inference_scheduler_name, interval_end_time, interval_start_time, params::Dict{String,<:Any})

 Lists all inference events that have been found for the specified inference scheduler.

# Arguments
- `inference_scheduler_name`: The name of the inference scheduler for the inference events
  listed.
- `interval_end_time`: Returns all the inference events with an end start time equal to or
  greater than less than the end time given.
- `interval_start_time`:  Lookout for Equipment will return all the inference events with
  an end time equal to or greater than the start time given.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Specifies the maximum number of inference events to list.
- `"NextToken"`: An opaque pagination token indicating where to continue the listing of
  inference events.
"""
function list_inference_events(
    InferenceSchedulerName,
    IntervalEndTime,
    IntervalStartTime;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutequipment(
        "ListInferenceEvents",
        Dict{String,Any}(
            "InferenceSchedulerName" => InferenceSchedulerName,
            "IntervalEndTime" => IntervalEndTime,
            "IntervalStartTime" => IntervalStartTime,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_inference_events(
    InferenceSchedulerName,
    IntervalEndTime,
    IntervalStartTime,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutequipment(
        "ListInferenceEvents",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "InferenceSchedulerName" => InferenceSchedulerName,
                    "IntervalEndTime" => IntervalEndTime,
                    "IntervalStartTime" => IntervalStartTime,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_inference_executions(inference_scheduler_name)
    list_inference_executions(inference_scheduler_name, params::Dict{String,<:Any})

 Lists all inference executions that have been performed by the specified inference
scheduler.

# Arguments
- `inference_scheduler_name`: The name of the inference scheduler for the inference
  execution listed.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DataEndTimeBefore"`: The time reference in the inferenced dataset before which Amazon
  Lookout for Equipment stopped the inference execution.
- `"DataStartTimeAfter"`: The time reference in the inferenced dataset after which Amazon
  Lookout for Equipment started the inference execution.
- `"MaxResults"`: Specifies the maximum number of inference executions to list.
- `"NextToken"`: An opaque pagination token indicating where to continue the listing of
  inference executions.
- `"Status"`: The status of the inference execution.
"""
function list_inference_executions(
    InferenceSchedulerName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutequipment(
        "ListInferenceExecutions",
        Dict{String,Any}("InferenceSchedulerName" => InferenceSchedulerName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_inference_executions(
    InferenceSchedulerName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutequipment(
        "ListInferenceExecutions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("InferenceSchedulerName" => InferenceSchedulerName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_inference_schedulers()
    list_inference_schedulers(params::Dict{String,<:Any})

Retrieves a list of all inference schedulers currently available for your account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"InferenceSchedulerNameBeginsWith"`: The beginning of the name of the inference
  schedulers to be listed.
- `"MaxResults"`:  Specifies the maximum number of inference schedulers to list.
- `"ModelName"`: The name of the machine learning model used by the inference scheduler to
  be listed.
- `"NextToken"`:  An opaque pagination token indicating where to continue the listing of
  inference schedulers.
- `"Status"`: Specifies the current status of the inference schedulers.
"""
function list_inference_schedulers(; aws_config::AbstractAWSConfig=current_aws_config())
    return lookoutequipment(
        "ListInferenceSchedulers"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_inference_schedulers(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutequipment(
        "ListInferenceSchedulers",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_label_groups()
    list_label_groups(params::Dict{String,<:Any})

 Returns a list of the label groups.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"LabelGroupNameBeginsWith"`:  The beginning of the name of the label groups to be
  listed.
- `"MaxResults"`:  Specifies the maximum number of label groups to list.
- `"NextToken"`:  An opaque pagination token indicating where to continue the listing of
  label groups.
"""
function list_label_groups(; aws_config::AbstractAWSConfig=current_aws_config())
    return lookoutequipment(
        "ListLabelGroups"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_label_groups(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutequipment(
        "ListLabelGroups", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_labels(label_group_name)
    list_labels(label_group_name, params::Dict{String,<:Any})

 Provides a list of labels.

# Arguments
- `label_group_name`:  Returns the name of the label group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Equipment"`:  Lists the labels that pertain to a particular piece of equipment.
- `"FaultCode"`:  Returns labels with a particular fault code.
- `"IntervalEndTime"`:  Returns all labels with a start time earlier than the end time
  given.
- `"IntervalStartTime"`:  Returns all the labels with a end time equal to or later than the
  start time given.
- `"MaxResults"`:  Specifies the maximum number of labels to list.
- `"NextToken"`:  An opaque pagination token indicating where to continue the listing of
  label groups.
"""
function list_labels(LabelGroupName; aws_config::AbstractAWSConfig=current_aws_config())
    return lookoutequipment(
        "ListLabels",
        Dict{String,Any}("LabelGroupName" => LabelGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_labels(
    LabelGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutequipment(
        "ListLabels",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("LabelGroupName" => LabelGroupName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_model_versions(model_name)
    list_model_versions(model_name, params::Dict{String,<:Any})

Generates a list of all model versions for a given model, including the model version,
model version ARN, and status. To list a subset of versions, use the MaxModelVersion and
MinModelVersion fields.

# Arguments
- `model_name`: Then name of the machine learning model for which the model versions are to
  be listed.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CreatedAtEndTime"`: Filter results to return all the model versions created before this
  time.
- `"CreatedAtStartTime"`: Filter results to return all the model versions created after
  this time.
- `"MaxModelVersion"`: Specifies the highest version of the model to return in the list.
- `"MaxResults"`: Specifies the maximum number of machine learning model versions to list.
- `"MinModelVersion"`: Specifies the lowest version of the model to return in the list.
- `"NextToken"`: If the total number of results exceeds the limit that the response can
  display, the response returns an opaque pagination token indicating where to continue the
  listing of machine learning model versions. Use this token in the NextToken field in the
  request to list the next page of results.
- `"SourceType"`: Filter the results based on the way the model version was generated.
- `"Status"`: Filter the results based on the current status of the model version.
"""
function list_model_versions(ModelName; aws_config::AbstractAWSConfig=current_aws_config())
    return lookoutequipment(
        "ListModelVersions",
        Dict{String,Any}("ModelName" => ModelName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_model_versions(
    ModelName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutequipment(
        "ListModelVersions",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ModelName" => ModelName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_models()
    list_models(params::Dict{String,<:Any})

Generates a list of all models in the account, including model name and ARN, dataset, and
status.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DatasetNameBeginsWith"`: The beginning of the name of the dataset of the machine
  learning models to be listed.
- `"MaxResults"`:  Specifies the maximum number of machine learning models to list.
- `"ModelNameBeginsWith"`: The beginning of the name of the machine learning models being
  listed.
- `"NextToken"`:  An opaque pagination token indicating where to continue the listing of
  machine learning models.
- `"Status"`: The status of the machine learning model.
"""
function list_models(; aws_config::AbstractAWSConfig=current_aws_config())
    return lookoutequipment(
        "ListModels"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_models(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutequipment(
        "ListModels", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_retraining_schedulers()
    list_retraining_schedulers(params::Dict{String,<:Any})

Lists all retraining schedulers in your account, filtering by model name prefix and status.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Specifies the maximum number of retraining schedulers to list.
- `"ModelNameBeginsWith"`: Specify this field to only list retraining schedulers whose
  machine learning models begin with the value you specify.
- `"NextToken"`: If the number of results exceeds the maximum, a pagination token is
  returned. Use the token in the request to show the next page of retraining schedulers.
- `"Status"`: Specify this field to only list retraining schedulers whose status matches
  the value you specify.
"""
function list_retraining_schedulers(; aws_config::AbstractAWSConfig=current_aws_config())
    return lookoutequipment(
        "ListRetrainingSchedulers"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_retraining_schedulers(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutequipment(
        "ListRetrainingSchedulers",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_sensor_statistics(dataset_name)
    list_sensor_statistics(dataset_name, params::Dict{String,<:Any})

 Lists statistics about the data collected for each of the sensors that have been
successfully ingested in the particular dataset. Can also be used to retreive Sensor
Statistics for a previous ingestion job.

# Arguments
- `dataset_name`:  The name of the dataset associated with the list of Sensor Statistics.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"IngestionJobId"`:  The ingestion job id associated with the list of Sensor Statistics.
  To get sensor statistics for a particular ingestion job id, both dataset name and ingestion
  job id must be submitted as inputs.
- `"MaxResults"`: Specifies the maximum number of sensors for which to retrieve statistics.
- `"NextToken"`: An opaque pagination token indicating where to continue the listing of
  sensor statistics.
"""
function list_sensor_statistics(
    DatasetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutequipment(
        "ListSensorStatistics",
        Dict{String,Any}("DatasetName" => DatasetName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_sensor_statistics(
    DatasetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutequipment(
        "ListSensorStatistics",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DatasetName" => DatasetName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists all the tags for a specified resource, including key and value.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource (such as the dataset or
  model) that is the focus of the ListTagsForResource operation.

"""
function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutequipment(
        "ListTagsForResource",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutequipment(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_resource_policy(client_token, resource_arn, resource_policy)
    put_resource_policy(client_token, resource_arn, resource_policy, params::Dict{String,<:Any})

Creates a resource control policy for a given resource.

# Arguments
- `client_token`: A unique identifier for the request. If you do not set the client request
  token, Amazon Lookout for Equipment generates one.
- `resource_arn`: The Amazon Resource Name (ARN) of the resource for which the policy is
  being created.
- `resource_policy`: The JSON-formatted resource policy to create.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"PolicyRevisionId"`: A unique identifier for a revision of the resource policy.
"""
function put_resource_policy(
    ClientToken,
    ResourceArn,
    ResourcePolicy;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutequipment(
        "PutResourcePolicy",
        Dict{String,Any}(
            "ClientToken" => ClientToken,
            "ResourceArn" => ResourceArn,
            "ResourcePolicy" => ResourcePolicy,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_resource_policy(
    ClientToken,
    ResourceArn,
    ResourcePolicy,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutequipment(
        "PutResourcePolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClientToken" => ClientToken,
                    "ResourceArn" => ResourceArn,
                    "ResourcePolicy" => ResourcePolicy,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_data_ingestion_job(client_token, dataset_name, ingestion_input_configuration, role_arn)
    start_data_ingestion_job(client_token, dataset_name, ingestion_input_configuration, role_arn, params::Dict{String,<:Any})

Starts a data ingestion job. Amazon Lookout for Equipment returns the job status.

# Arguments
- `client_token`:  A unique identifier for the request. If you do not set the client
  request token, Amazon Lookout for Equipment generates one.
- `dataset_name`: The name of the dataset being used by the data ingestion job.
- `ingestion_input_configuration`:  Specifies information for the input data for the data
  ingestion job, including dataset S3 location.
- `role_arn`:  The Amazon Resource Name (ARN) of a role with permission to access the data
  source for the data ingestion job.

"""
function start_data_ingestion_job(
    ClientToken,
    DatasetName,
    IngestionInputConfiguration,
    RoleArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutequipment(
        "StartDataIngestionJob",
        Dict{String,Any}(
            "ClientToken" => ClientToken,
            "DatasetName" => DatasetName,
            "IngestionInputConfiguration" => IngestionInputConfiguration,
            "RoleArn" => RoleArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_data_ingestion_job(
    ClientToken,
    DatasetName,
    IngestionInputConfiguration,
    RoleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutequipment(
        "StartDataIngestionJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClientToken" => ClientToken,
                    "DatasetName" => DatasetName,
                    "IngestionInputConfiguration" => IngestionInputConfiguration,
                    "RoleArn" => RoleArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_inference_scheduler(inference_scheduler_name)
    start_inference_scheduler(inference_scheduler_name, params::Dict{String,<:Any})

Starts an inference scheduler.

# Arguments
- `inference_scheduler_name`: The name of the inference scheduler to be started.

"""
function start_inference_scheduler(
    InferenceSchedulerName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutequipment(
        "StartInferenceScheduler",
        Dict{String,Any}("InferenceSchedulerName" => InferenceSchedulerName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_inference_scheduler(
    InferenceSchedulerName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutequipment(
        "StartInferenceScheduler",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("InferenceSchedulerName" => InferenceSchedulerName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_retraining_scheduler(model_name)
    start_retraining_scheduler(model_name, params::Dict{String,<:Any})

Starts a retraining scheduler.

# Arguments
- `model_name`: The name of the model whose retraining scheduler you want to start.

"""
function start_retraining_scheduler(
    ModelName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutequipment(
        "StartRetrainingScheduler",
        Dict{String,Any}("ModelName" => ModelName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_retraining_scheduler(
    ModelName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutequipment(
        "StartRetrainingScheduler",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ModelName" => ModelName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_inference_scheduler(inference_scheduler_name)
    stop_inference_scheduler(inference_scheduler_name, params::Dict{String,<:Any})

Stops an inference scheduler.

# Arguments
- `inference_scheduler_name`: The name of the inference scheduler to be stopped.

"""
function stop_inference_scheduler(
    InferenceSchedulerName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutequipment(
        "StopInferenceScheduler",
        Dict{String,Any}("InferenceSchedulerName" => InferenceSchedulerName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_inference_scheduler(
    InferenceSchedulerName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutequipment(
        "StopInferenceScheduler",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("InferenceSchedulerName" => InferenceSchedulerName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_retraining_scheduler(model_name)
    stop_retraining_scheduler(model_name, params::Dict{String,<:Any})

Stops a retraining scheduler.

# Arguments
- `model_name`: The name of the model whose retraining scheduler you want to stop.

"""
function stop_retraining_scheduler(
    ModelName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutequipment(
        "StopRetrainingScheduler",
        Dict{String,Any}("ModelName" => ModelName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_retraining_scheduler(
    ModelName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutequipment(
        "StopRetrainingScheduler",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ModelName" => ModelName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Associates a given tag to a resource in your account. A tag is a key-value pair which can
be added to an Amazon Lookout for Equipment resource as metadata. Tags can be used for
organizing your resources as well as helping you to search and filter by tag. Multiple tags
can be added to a resource, either when you create it, or later. Up to 50 tags can be
associated with each resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the specific resource to which the tag
  should be associated.
- `tags`: The tag or tags to be associated with a specific resource. Both the tag key and
  value are specified.

"""
function tag_resource(ResourceArn, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return lookoutequipment(
        "TagResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceArn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutequipment(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes a specific tag from a given resource. The tag is specified by its key.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource to which the tag is
  currently associated.
- `tag_keys`: Specifies the key of the tag to be removed from a specified resource.

"""
function untag_resource(
    ResourceArn, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutequipment(
        "UntagResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceArn,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutequipment(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_active_model_version(model_name, model_version)
    update_active_model_version(model_name, model_version, params::Dict{String,<:Any})

Sets the active model version for a given machine learning model.

# Arguments
- `model_name`: The name of the machine learning model for which the active model version
  is being set.
- `model_version`: The version of the machine learning model for which the active model
  version is being set.

"""
function update_active_model_version(
    ModelName, ModelVersion; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutequipment(
        "UpdateActiveModelVersion",
        Dict{String,Any}("ModelName" => ModelName, "ModelVersion" => ModelVersion);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_active_model_version(
    ModelName,
    ModelVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutequipment(
        "UpdateActiveModelVersion",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ModelName" => ModelName, "ModelVersion" => ModelVersion),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_inference_scheduler(inference_scheduler_name)
    update_inference_scheduler(inference_scheduler_name, params::Dict{String,<:Any})

Updates an inference scheduler.

# Arguments
- `inference_scheduler_name`: The name of the inference scheduler to be updated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DataDelayOffsetInMinutes"`:  A period of time (in minutes) by which inference on the
  data is delayed after the data starts. For instance, if you select an offset delay time of
  five minutes, inference will not begin on the data until the first data measurement after
  the five minute mark. For example, if five minutes is selected, the inference scheduler
  will wake up at the configured frequency with the additional five minute delay time to
  check the customer S3 bucket. The customer can upload data at the same frequency and they
  don't need to stop and restart the scheduler when uploading new data.
- `"DataInputConfiguration"`:  Specifies information for the input data for the inference
  scheduler, including delimiter, format, and dataset location.
- `"DataOutputConfiguration"`:  Specifies information for the output results from the
  inference scheduler, including the output S3 location.
- `"DataUploadFrequency"`: How often data is uploaded to the source S3 bucket for the input
  data. The value chosen is the length of time between data uploads. For instance, if you
  select 5 minutes, Amazon Lookout for Equipment will upload the real-time data to the source
  bucket once every 5 minutes. This frequency also determines how often Amazon Lookout for
  Equipment starts a scheduled inference on your data. In this example, it starts once every
  5 minutes.
- `"RoleArn"`:  The Amazon Resource Name (ARN) of a role with permission to access the data
  source for the inference scheduler.
"""
function update_inference_scheduler(
    InferenceSchedulerName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutequipment(
        "UpdateInferenceScheduler",
        Dict{String,Any}("InferenceSchedulerName" => InferenceSchedulerName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_inference_scheduler(
    InferenceSchedulerName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutequipment(
        "UpdateInferenceScheduler",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("InferenceSchedulerName" => InferenceSchedulerName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_label_group(label_group_name)
    update_label_group(label_group_name, params::Dict{String,<:Any})

 Updates the label group.

# Arguments
- `label_group_name`:  The name of the label group to be updated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FaultCodes"`:  Updates the code indicating the type of anomaly associated with the
  label.  Data in this field will be retained for service usage. Follow best practices for
  the security of your data.
"""
function update_label_group(
    LabelGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutequipment(
        "UpdateLabelGroup",
        Dict{String,Any}("LabelGroupName" => LabelGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_label_group(
    LabelGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutequipment(
        "UpdateLabelGroup",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("LabelGroupName" => LabelGroupName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_model(model_name)
    update_model(model_name, params::Dict{String,<:Any})

Updates a model in the account.

# Arguments
- `model_name`: The name of the model to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"LabelsInputConfiguration"`:
- `"ModelDiagnosticsOutputConfiguration"`: The Amazon S3 location where you want Amazon
  Lookout for Equipment to save the pointwise model diagnostics for the model. You must also
  specify the RoleArn request parameter.
- `"RoleArn"`: The ARN of the model to update.
"""
function update_model(ModelName; aws_config::AbstractAWSConfig=current_aws_config())
    return lookoutequipment(
        "UpdateModel",
        Dict{String,Any}("ModelName" => ModelName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_model(
    ModelName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutequipment(
        "UpdateModel",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ModelName" => ModelName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_retraining_scheduler(model_name)
    update_retraining_scheduler(model_name, params::Dict{String,<:Any})

Updates a retraining scheduler.

# Arguments
- `model_name`: The name of the model whose retraining scheduler you want to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"LookbackWindow"`: The number of past days of data that will be used for retraining.
- `"PromoteMode"`: Indicates how the service will use new models. In MANAGED mode, new
  models will automatically be used for inference if they have better performance than the
  current model. In MANUAL mode, the new models will not be used until they are manually
  activated.
- `"RetrainingFrequency"`: This parameter uses the ISO 8601 standard to set the frequency
  at which you want retraining to occur in terms of Years, Months, and/or Days (note: other
  parameters like Time are not currently supported). The minimum value is 30 days (P30D) and
  the maximum value is 1 year (P1Y). For example, the following values are valid:   P3M15D
  – Every 3 months and 15 days   P2M – Every 2 months   P150D – Every 150 days
- `"RetrainingStartDate"`: The start date for the retraining scheduler. Lookout for
  Equipment truncates the time you provide to the nearest UTC day.
"""
function update_retraining_scheduler(
    ModelName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutequipment(
        "UpdateRetrainingScheduler",
        Dict{String,Any}("ModelName" => ModelName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_retraining_scheduler(
    ModelName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutequipment(
        "UpdateRetrainingScheduler",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ModelName" => ModelName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: payment_cryptography_data
using AWS.Compat
using AWS.UUIDs

"""
    decrypt_data(cipher_text, decryption_attributes, key_identifier)
    decrypt_data(cipher_text, decryption_attributes, key_identifier, params::Dict{String,<:Any})

Decrypts ciphertext data to plaintext using a symmetric (TDES, AES), asymmetric (RSA), or
derived (DUKPT or EMV) encryption key scheme. For more information, see Decrypt data in the
Amazon Web Services Payment Cryptography User Guide. You can use an encryption key
generated within Amazon Web Services Payment Cryptography, or you can import your own
encryption key by calling ImportKey. For this operation, the key must have KeyModesOfUse
set to Decrypt. In asymmetric decryption, Amazon Web Services Payment Cryptography decrypts
the ciphertext using the private component of the asymmetric encryption key pair. For data
encryption outside of Amazon Web Services Payment Cryptography, you can export the public
component of the asymmetric key pair by calling GetPublicCertificate. For symmetric and
DUKPT decryption, Amazon Web Services Payment Cryptography supports TDES and AES
algorithms. For EMV decryption, Amazon Web Services Payment Cryptography supports TDES
algorithms. For asymmetric decryption, Amazon Web Services Payment Cryptography supports
RSA.  When you use TDES or TDES DUKPT, the ciphertext data length must be a multiple of 8
bytes. For AES or AES DUKPT, the ciphertext data length must be a multiple of 16 bytes. For
RSA, it sould be equal to the key size unless padding is enabled. For information about
valid keys for this operation, see Understanding key attributes and Key types for specific
data operations in the Amazon Web Services Payment Cryptography User Guide.   Cross-account
use: This operation can't be used across different Amazon Web Services accounts.  Related
operations:     EncryptData     GetPublicCertificate     ImportKey

# Arguments
- `cipher_text`: The ciphertext to decrypt.
- `decryption_attributes`: The encryption key type and attributes for ciphertext decryption.
- `key_identifier`: The keyARN of the encryption key that Amazon Web Services Payment
  Cryptography uses for ciphertext decryption.

"""
function decrypt_data(
    CipherText,
    DecryptionAttributes,
    KeyIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return payment_cryptography_data(
        "POST",
        "/keys/$(KeyIdentifier)/decrypt",
        Dict{String,Any}(
            "CipherText" => CipherText, "DecryptionAttributes" => DecryptionAttributes
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function decrypt_data(
    CipherText,
    DecryptionAttributes,
    KeyIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return payment_cryptography_data(
        "POST",
        "/keys/$(KeyIdentifier)/decrypt",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CipherText" => CipherText,
                    "DecryptionAttributes" => DecryptionAttributes,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    encrypt_data(encryption_attributes, key_identifier, plain_text)
    encrypt_data(encryption_attributes, key_identifier, plain_text, params::Dict{String,<:Any})

Encrypts plaintext data to ciphertext using a symmetric (TDES, AES), asymmetric (RSA), or
derived (DUKPT or EMV) encryption key scheme. For more information, see Encrypt data in the
Amazon Web Services Payment Cryptography User Guide. You can generate an encryption key
within Amazon Web Services Payment Cryptography by calling CreateKey. You can import your
own encryption key by calling ImportKey. For this operation, the key must have
KeyModesOfUse set to Encrypt. In asymmetric encryption, plaintext is encrypted using public
component. You can import the public component of an asymmetric key pair created outside
Amazon Web Services Payment Cryptography by calling ImportKey.  For symmetric and DUKPT
encryption, Amazon Web Services Payment Cryptography supports TDES and AES algorithms. For
EMV encryption, Amazon Web Services Payment Cryptography supports TDES algorithms.For
asymmetric encryption, Amazon Web Services Payment Cryptography supports RSA.  When you use
TDES or TDES DUKPT, the plaintext data length must be a multiple of 8 bytes. For AES or AES
DUKPT, the plaintext data length must be a multiple of 16 bytes. For RSA, it sould be equal
to the key size unless padding is enabled. To encrypt using DUKPT, you must already have a
BDK (Base Derivation Key) key in your account with KeyModesOfUse set to DeriveKey, or you
can generate a new DUKPT key by calling CreateKey. To encrypt using EMV, you must already
have an IMK (Issuer Master Key) key in your account with KeyModesOfUse set to DeriveKey.
For information about valid keys for this operation, see Understanding key attributes and
Key types for specific data operations in the Amazon Web Services Payment Cryptography User
Guide.  Cross-account use: This operation can't be used across different Amazon Web
Services accounts.  Related operations:     DecryptData     GetPublicCertificate
ImportKey     ReEncryptData

# Arguments
- `encryption_attributes`: The encryption key type and attributes for plaintext encryption.
- `key_identifier`: The keyARN of the encryption key that Amazon Web Services Payment
  Cryptography uses for plaintext encryption.
- `plain_text`: The plaintext to be encrypted.  For encryption using asymmetric keys,
  plaintext data length is constrained by encryption key strength that you define in
  KeyAlgorithm and padding type that you define in AsymmetricEncryptionAttributes. For more
  information, see Encrypt data in the Amazon Web Services Payment Cryptography User Guide.

"""
function encrypt_data(
    EncryptionAttributes,
    KeyIdentifier,
    PlainText;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return payment_cryptography_data(
        "POST",
        "/keys/$(KeyIdentifier)/encrypt",
        Dict{String,Any}(
            "EncryptionAttributes" => EncryptionAttributes, "PlainText" => PlainText
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function encrypt_data(
    EncryptionAttributes,
    KeyIdentifier,
    PlainText,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return payment_cryptography_data(
        "POST",
        "/keys/$(KeyIdentifier)/encrypt",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EncryptionAttributes" => EncryptionAttributes, "PlainText" => PlainText
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    generate_card_validation_data(generation_attributes, key_identifier, primary_account_number)
    generate_card_validation_data(generation_attributes, key_identifier, primary_account_number, params::Dict{String,<:Any})

Generates card-related validation data using algorithms such as Card Verification Values
(CVV/CVV2), Dynamic Card Verification Values (dCVV/dCVV2), or Card Security Codes (CSC).
For more information, see Generate card data in the Amazon Web Services Payment
Cryptography User Guide. This operation generates a CVV or CSC value that is printed on a
payment credit or debit card during card production. The CVV or CSC, PAN (Primary Account
Number) and expiration date of the card are required to check its validity during
transaction processing. To begin this operation, a CVK (Card Verification Key) encryption
key is required. You can use CreateKey or ImportKey to establish a CVK within Amazon Web
Services Payment Cryptography. The KeyModesOfUse should be set to Generate and Verify for a
CVK encryption key.  For information about valid keys for this operation, see Understanding
key attributes and Key types for specific data operations in the Amazon Web Services
Payment Cryptography User Guide.   Cross-account use: This operation can't be used across
different Amazon Web Services accounts.  Related operations:     ImportKey
VerifyCardValidationData

# Arguments
- `generation_attributes`: The algorithm for generating CVV or CSC values for the card
  within Amazon Web Services Payment Cryptography.
- `key_identifier`: The keyARN of the CVK encryption key that Amazon Web Services Payment
  Cryptography uses to generate card data.
- `primary_account_number`: The Primary Account Number (PAN), a unique identifier for a
  payment credit or debit card that associates the card with a specific account holder.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ValidationDataLength"`: The length of the CVV or CSC to be generated. The default value
  is 3.
"""
function generate_card_validation_data(
    GenerationAttributes,
    KeyIdentifier,
    PrimaryAccountNumber;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return payment_cryptography_data(
        "POST",
        "/cardvalidationdata/generate",
        Dict{String,Any}(
            "GenerationAttributes" => GenerationAttributes,
            "KeyIdentifier" => KeyIdentifier,
            "PrimaryAccountNumber" => PrimaryAccountNumber,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function generate_card_validation_data(
    GenerationAttributes,
    KeyIdentifier,
    PrimaryAccountNumber,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return payment_cryptography_data(
        "POST",
        "/cardvalidationdata/generate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "GenerationAttributes" => GenerationAttributes,
                    "KeyIdentifier" => KeyIdentifier,
                    "PrimaryAccountNumber" => PrimaryAccountNumber,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    generate_mac(generation_attributes, key_identifier, message_data)
    generate_mac(generation_attributes, key_identifier, message_data, params::Dict{String,<:Any})

Generates a Message Authentication Code (MAC) cryptogram within Amazon Web Services Payment
Cryptography.  You can use this operation to authenticate card-related data by using known
data values to generate MAC for data validation between the sending and receiving parties.
This operation uses message data, a secret encryption key and MAC algorithm to generate a
unique MAC value for transmission. The receiving party of the MAC must use the same message
data, secret encryption key and MAC algorithm to reproduce another MAC value for
comparision. You can use this operation to generate a DUPKT, CMAC, HMAC or EMV MAC by
setting generation attributes and algorithm to the associated values. The MAC generation
encryption key must have valid values for KeyUsage such as TR31_M7_HMAC_KEY for HMAC
generation, and they key must have KeyModesOfUse set to Generate and Verify. For
information about valid keys for this operation, see Understanding key attributes and Key
types for specific data operations in the Amazon Web Services Payment Cryptography User
Guide.   Cross-account use: This operation can't be used across different Amazon Web
Services accounts.  Related operations:     VerifyMac

# Arguments
- `generation_attributes`: The attributes and data values to use for MAC generation within
  Amazon Web Services Payment Cryptography.
- `key_identifier`: The keyARN of the MAC generation encryption key.
- `message_data`: The data for which a MAC is under generation. This value must be
  hexBinary.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MacLength"`: The length of a MAC under generation.
"""
function generate_mac(
    GenerationAttributes,
    KeyIdentifier,
    MessageData;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return payment_cryptography_data(
        "POST",
        "/mac/generate",
        Dict{String,Any}(
            "GenerationAttributes" => GenerationAttributes,
            "KeyIdentifier" => KeyIdentifier,
            "MessageData" => MessageData,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function generate_mac(
    GenerationAttributes,
    KeyIdentifier,
    MessageData,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return payment_cryptography_data(
        "POST",
        "/mac/generate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "GenerationAttributes" => GenerationAttributes,
                    "KeyIdentifier" => KeyIdentifier,
                    "MessageData" => MessageData,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    generate_pin_data(encryption_key_identifier, generation_attributes, generation_key_identifier, pin_block_format, primary_account_number)
    generate_pin_data(encryption_key_identifier, generation_attributes, generation_key_identifier, pin_block_format, primary_account_number, params::Dict{String,<:Any})

Generates pin-related data such as PIN, PIN Verification Value (PVV), PIN Block, and PIN
Offset during new card issuance or reissuance. For more information, see Generate PIN data
in the Amazon Web Services Payment Cryptography User Guide. PIN data is never transmitted
in clear to or from Amazon Web Services Payment Cryptography. This operation generates PIN,
PVV, or PIN Offset and then encrypts it using Pin Encryption Key (PEK) to create an
EncryptedPinBlock for transmission from Amazon Web Services Payment Cryptography. This
operation uses a separate Pin Verification Key (PVK) for VISA PVV generation.  For
information about valid keys for this operation, see Understanding key attributes and Key
types for specific data operations in the Amazon Web Services Payment Cryptography User
Guide.  Cross-account use: This operation can't be used across different Amazon Web
Services accounts.  Related operations:     GenerateCardValidationData     TranslatePinData
    VerifyPinData

# Arguments
- `encryption_key_identifier`: The keyARN of the PEK that Amazon Web Services Payment
  Cryptography uses to encrypt the PIN Block.
- `generation_attributes`: The attributes and values to use for PIN, PVV, or PIN Offset
  generation.
- `generation_key_identifier`: The keyARN of the PEK that Amazon Web Services Payment
  Cryptography uses for pin data generation.
- `pin_block_format`: The PIN encoding format for pin data generation as specified in ISO
  9564. Amazon Web Services Payment Cryptography supports ISO_Format_0 and ISO_Format_3. The
  ISO_Format_0 PIN block format is equivalent to the ANSI X9.8, VISA-1, and ECI-1 PIN block
  formats. It is similar to a VISA-4 PIN block format. It supports a PIN from 4 to 12 digits
  in length. The ISO_Format_3 PIN block format is the same as ISO_Format_0 except that the
  fill digits are random values from 10 to 15.
- `primary_account_number`: The Primary Account Number (PAN), a unique identifier for a
  payment credit or debit card that associates the card with a specific account holder.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"PinDataLength"`: The length of PIN under generation.
"""
function generate_pin_data(
    EncryptionKeyIdentifier,
    GenerationAttributes,
    GenerationKeyIdentifier,
    PinBlockFormat,
    PrimaryAccountNumber;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return payment_cryptography_data(
        "POST",
        "/pindata/generate",
        Dict{String,Any}(
            "EncryptionKeyIdentifier" => EncryptionKeyIdentifier,
            "GenerationAttributes" => GenerationAttributes,
            "GenerationKeyIdentifier" => GenerationKeyIdentifier,
            "PinBlockFormat" => PinBlockFormat,
            "PrimaryAccountNumber" => PrimaryAccountNumber,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function generate_pin_data(
    EncryptionKeyIdentifier,
    GenerationAttributes,
    GenerationKeyIdentifier,
    PinBlockFormat,
    PrimaryAccountNumber,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return payment_cryptography_data(
        "POST",
        "/pindata/generate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EncryptionKeyIdentifier" => EncryptionKeyIdentifier,
                    "GenerationAttributes" => GenerationAttributes,
                    "GenerationKeyIdentifier" => GenerationKeyIdentifier,
                    "PinBlockFormat" => PinBlockFormat,
                    "PrimaryAccountNumber" => PrimaryAccountNumber,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    re_encrypt_data(cipher_text, incoming_encryption_attributes, incoming_key_identifier, outgoing_encryption_attributes, outgoing_key_identifier)
    re_encrypt_data(cipher_text, incoming_encryption_attributes, incoming_key_identifier, outgoing_encryption_attributes, outgoing_key_identifier, params::Dict{String,<:Any})

Re-encrypt ciphertext using DUKPT, Symmetric and Asymmetric Data Encryption Keys.  You can
either generate an encryption key within Amazon Web Services Payment Cryptography by
calling CreateKey or import your own encryption key by calling ImportKey. The KeyArn for
use with this operation must be in a compatible key state with KeyModesOfUse set to
Encrypt. In asymmetric encryption, ciphertext is encrypted using public component (imported
by calling ImportKey) of the asymmetric key pair created outside of Amazon Web Services
Payment Cryptography.  For symmetric and DUKPT encryption, Amazon Web Services Payment
Cryptography supports TDES and AES algorithms. For asymmetric encryption, Amazon Web
Services Payment Cryptography supports RSA. To encrypt using DUKPT, a DUKPT key must
already exist within your account with KeyModesOfUse set to DeriveKey or a new DUKPT can be
generated by calling CreateKey. For information about valid keys for this operation, see
Understanding key attributes and Key types for specific data operations in the Amazon Web
Services Payment Cryptography User Guide.   Cross-account use: This operation can't be used
across different Amazon Web Services accounts.  Related operations:     DecryptData
EncryptData     GetPublicCertificate     ImportKey

# Arguments
- `cipher_text`: Ciphertext to be encrypted. The minimum allowed length is 16 bytes and
  maximum allowed length is 4096 bytes.
- `incoming_encryption_attributes`: The attributes and values for incoming ciphertext.
- `incoming_key_identifier`: The keyARN of the encryption key of incoming ciphertext data.
- `outgoing_encryption_attributes`: The attributes and values for outgoing ciphertext data
  after encryption by Amazon Web Services Payment Cryptography.
- `outgoing_key_identifier`: The keyARN of the encryption key of outgoing ciphertext data
  after encryption by Amazon Web Services Payment Cryptography.

"""
function re_encrypt_data(
    CipherText,
    IncomingEncryptionAttributes,
    IncomingKeyIdentifier,
    OutgoingEncryptionAttributes,
    OutgoingKeyIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return payment_cryptography_data(
        "POST",
        "/keys/$(IncomingKeyIdentifier)/reencrypt",
        Dict{String,Any}(
            "CipherText" => CipherText,
            "IncomingEncryptionAttributes" => IncomingEncryptionAttributes,
            "OutgoingEncryptionAttributes" => OutgoingEncryptionAttributes,
            "OutgoingKeyIdentifier" => OutgoingKeyIdentifier,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function re_encrypt_data(
    CipherText,
    IncomingEncryptionAttributes,
    IncomingKeyIdentifier,
    OutgoingEncryptionAttributes,
    OutgoingKeyIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return payment_cryptography_data(
        "POST",
        "/keys/$(IncomingKeyIdentifier)/reencrypt",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CipherText" => CipherText,
                    "IncomingEncryptionAttributes" => IncomingEncryptionAttributes,
                    "OutgoingEncryptionAttributes" => OutgoingEncryptionAttributes,
                    "OutgoingKeyIdentifier" => OutgoingKeyIdentifier,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    translate_pin_data(encrypted_pin_block, incoming_key_identifier, incoming_translation_attributes, outgoing_key_identifier, outgoing_translation_attributes)
    translate_pin_data(encrypted_pin_block, incoming_key_identifier, incoming_translation_attributes, outgoing_key_identifier, outgoing_translation_attributes, params::Dict{String,<:Any})

Translates encrypted PIN block from and to ISO 9564 formats 0,1,3,4. For more information,
see Translate PIN data in the Amazon Web Services Payment Cryptography User Guide. PIN
block translation involves changing the encrytion of PIN block from one encryption key to
another encryption key and changing PIN block format from one to another without PIN block
data leaving Amazon Web Services Payment Cryptography. The encryption key transformation
can be from PEK (Pin Encryption Key) to BDK (Base Derivation Key) for DUKPT or from BDK for
DUKPT to PEK. Amazon Web Services Payment Cryptography supports TDES and AES key derivation
type for DUKPT translations.  The allowed combinations of PIN block format translations are
guided by PCI. It is important to note that not all encrypted PIN block formats (example,
format 1) require PAN (Primary Account Number) as input. And as such, PIN block format that
requires PAN (example, formats 0,3,4) cannot be translated to a format (format 1) that does
not require a PAN for generation.  For information about valid keys for this operation, see
Understanding key attributes and Key types for specific data operations in the Amazon Web
Services Payment Cryptography User Guide.  Amazon Web Services Payment Cryptography
currently supports ISO PIN block 4 translation for PIN block built using legacy PAN length.
That is, PAN is the right most 12 digits excluding the check digits.   Cross-account use:
This operation can't be used across different Amazon Web Services accounts.  Related
operations:     GeneratePinData     VerifyPinData

# Arguments
- `encrypted_pin_block`: The encrypted PIN block data that Amazon Web Services Payment
  Cryptography translates.
- `incoming_key_identifier`: The keyARN of the encryption key under which incoming PIN
  block data is encrypted. This key type can be PEK or BDK.
- `incoming_translation_attributes`: The format of the incoming PIN block data for
  translation within Amazon Web Services Payment Cryptography.
- `outgoing_key_identifier`: The keyARN of the encryption key for encrypting outgoing PIN
  block data. This key type can be PEK or BDK.
- `outgoing_translation_attributes`: The format of the outgoing PIN block data after
  translation by Amazon Web Services Payment Cryptography.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"IncomingDukptAttributes"`: The attributes and values to use for incoming DUKPT
  encryption key for PIN block translation.
- `"OutgoingDukptAttributes"`: The attributes and values to use for outgoing DUKPT
  encryption key after PIN block translation.
"""
function translate_pin_data(
    EncryptedPinBlock,
    IncomingKeyIdentifier,
    IncomingTranslationAttributes,
    OutgoingKeyIdentifier,
    OutgoingTranslationAttributes;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return payment_cryptography_data(
        "POST",
        "/pindata/translate",
        Dict{String,Any}(
            "EncryptedPinBlock" => EncryptedPinBlock,
            "IncomingKeyIdentifier" => IncomingKeyIdentifier,
            "IncomingTranslationAttributes" => IncomingTranslationAttributes,
            "OutgoingKeyIdentifier" => OutgoingKeyIdentifier,
            "OutgoingTranslationAttributes" => OutgoingTranslationAttributes,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function translate_pin_data(
    EncryptedPinBlock,
    IncomingKeyIdentifier,
    IncomingTranslationAttributes,
    OutgoingKeyIdentifier,
    OutgoingTranslationAttributes,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return payment_cryptography_data(
        "POST",
        "/pindata/translate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EncryptedPinBlock" => EncryptedPinBlock,
                    "IncomingKeyIdentifier" => IncomingKeyIdentifier,
                    "IncomingTranslationAttributes" => IncomingTranslationAttributes,
                    "OutgoingKeyIdentifier" => OutgoingKeyIdentifier,
                    "OutgoingTranslationAttributes" => OutgoingTranslationAttributes,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    verify_auth_request_cryptogram(auth_request_cryptogram, key_identifier, major_key_derivation_mode, session_key_derivation_attributes, transaction_data)
    verify_auth_request_cryptogram(auth_request_cryptogram, key_identifier, major_key_derivation_mode, session_key_derivation_attributes, transaction_data, params::Dict{String,<:Any})

Verifies Authorization Request Cryptogram (ARQC) for a EMV chip payment card authorization.
For more information, see Verify auth request cryptogram in the Amazon Web Services Payment
Cryptography User Guide. ARQC generation is done outside of Amazon Web Services Payment
Cryptography and is typically generated on a point of sale terminal for an EMV chip card to
obtain payment authorization during transaction time. For ARQC verification, you must first
import the ARQC generated outside of Amazon Web Services Payment Cryptography by calling
ImportKey. This operation uses the imported ARQC and an major encryption key (DUKPT)
created by calling CreateKey to either provide a boolean ARQC verification result or
provide an APRC (Authorization Response Cryptogram) response using Method 1 or Method 2.
The ARPC_METHOD_1 uses AuthResponseCode to generate ARPC and ARPC_METHOD_2 uses
CardStatusUpdate to generate ARPC.  For information about valid keys for this operation,
see Understanding key attributes and Key types for specific data operations in the Amazon
Web Services Payment Cryptography User Guide.  Cross-account use: This operation can't be
used across different Amazon Web Services accounts.  Related operations:
VerifyCardValidationData     VerifyPinData

# Arguments
- `auth_request_cryptogram`: The auth request cryptogram imported into Amazon Web Services
  Payment Cryptography for ARQC verification using a major encryption key and transaction
  data.
- `key_identifier`: The keyARN of the major encryption key that Amazon Web Services Payment
  Cryptography uses for ARQC verification.
- `major_key_derivation_mode`: The method to use when deriving the major encryption key for
  ARQC verification within Amazon Web Services Payment Cryptography. The same key derivation
  mode was used for ARQC generation outside of Amazon Web Services Payment Cryptography.
- `session_key_derivation_attributes`: The attributes and values to use for deriving a
  session key for ARQC verification within Amazon Web Services Payment Cryptography. The same
  attributes were used for ARQC generation outside of Amazon Web Services Payment
  Cryptography.
- `transaction_data`: The transaction data that Amazon Web Services Payment Cryptography
  uses for ARQC verification. The same transaction is used for ARQC generation outside of
  Amazon Web Services Payment Cryptography.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AuthResponseAttributes"`: The attributes and values for auth request cryptogram
  verification. These parameters are required in case using ARPC Method 1 or Method 2 for
  ARQC verification.
"""
function verify_auth_request_cryptogram(
    AuthRequestCryptogram,
    KeyIdentifier,
    MajorKeyDerivationMode,
    SessionKeyDerivationAttributes,
    TransactionData;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return payment_cryptography_data(
        "POST",
        "/cryptogram/verify",
        Dict{String,Any}(
            "AuthRequestCryptogram" => AuthRequestCryptogram,
            "KeyIdentifier" => KeyIdentifier,
            "MajorKeyDerivationMode" => MajorKeyDerivationMode,
            "SessionKeyDerivationAttributes" => SessionKeyDerivationAttributes,
            "TransactionData" => TransactionData,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function verify_auth_request_cryptogram(
    AuthRequestCryptogram,
    KeyIdentifier,
    MajorKeyDerivationMode,
    SessionKeyDerivationAttributes,
    TransactionData,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return payment_cryptography_data(
        "POST",
        "/cryptogram/verify",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AuthRequestCryptogram" => AuthRequestCryptogram,
                    "KeyIdentifier" => KeyIdentifier,
                    "MajorKeyDerivationMode" => MajorKeyDerivationMode,
                    "SessionKeyDerivationAttributes" => SessionKeyDerivationAttributes,
                    "TransactionData" => TransactionData,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    verify_card_validation_data(key_identifier, primary_account_number, validation_data, verification_attributes)
    verify_card_validation_data(key_identifier, primary_account_number, validation_data, verification_attributes, params::Dict{String,<:Any})

Verifies card-related validation data using algorithms such as Card Verification Values
(CVV/CVV2), Dynamic Card Verification Values (dCVV/dCVV2) and Card Security Codes (CSC).
For more information, see Verify card data in the Amazon Web Services Payment Cryptography
User Guide. This operation validates the CVV or CSC codes that is printed on a payment
credit or debit card during card payment transaction. The input values are typically
provided as part of an inbound transaction to an issuer or supporting platform partner.
Amazon Web Services Payment Cryptography uses CVV or CSC, PAN (Primary Account Number) and
expiration date of the card to check its validity during transaction processing. In this
operation, the CVK (Card Verification Key) encryption key for use with card data
verification is same as the one in used for GenerateCardValidationData.  For information
about valid keys for this operation, see Understanding key attributes and Key types for
specific data operations in the Amazon Web Services Payment Cryptography User Guide.
Cross-account use: This operation can't be used across different Amazon Web Services
accounts.  Related operations:     GenerateCardValidationData
VerifyAuthRequestCryptogram     VerifyPinData

# Arguments
- `key_identifier`: The keyARN of the CVK encryption key that Amazon Web Services Payment
  Cryptography uses to verify card data.
- `primary_account_number`: The Primary Account Number (PAN), a unique identifier for a
  payment credit or debit card that associates the card with a specific account holder.
- `validation_data`: The CVV or CSC value for use for card data verification within Amazon
  Web Services Payment Cryptography.
- `verification_attributes`: The algorithm to use for verification of card data within
  Amazon Web Services Payment Cryptography.

"""
function verify_card_validation_data(
    KeyIdentifier,
    PrimaryAccountNumber,
    ValidationData,
    VerificationAttributes;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return payment_cryptography_data(
        "POST",
        "/cardvalidationdata/verify",
        Dict{String,Any}(
            "KeyIdentifier" => KeyIdentifier,
            "PrimaryAccountNumber" => PrimaryAccountNumber,
            "ValidationData" => ValidationData,
            "VerificationAttributes" => VerificationAttributes,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function verify_card_validation_data(
    KeyIdentifier,
    PrimaryAccountNumber,
    ValidationData,
    VerificationAttributes,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return payment_cryptography_data(
        "POST",
        "/cardvalidationdata/verify",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "KeyIdentifier" => KeyIdentifier,
                    "PrimaryAccountNumber" => PrimaryAccountNumber,
                    "ValidationData" => ValidationData,
                    "VerificationAttributes" => VerificationAttributes,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    verify_mac(key_identifier, mac, message_data, verification_attributes)
    verify_mac(key_identifier, mac, message_data, verification_attributes, params::Dict{String,<:Any})

Verifies a Message Authentication Code (MAC).  You can use this operation to verify MAC for
message data authentication such as . In this operation, you must use the same message
data, secret encryption key and MAC algorithm that was used to generate MAC. You can use
this operation to verify a DUPKT, CMAC, HMAC or EMV MAC by setting generation attributes
and algorithm to the associated values.  For information about valid keys for this
operation, see Understanding key attributes and Key types for specific data operations in
the Amazon Web Services Payment Cryptography User Guide.   Cross-account use: This
operation can't be used across different Amazon Web Services accounts.  Related operations:
    GenerateMac

# Arguments
- `key_identifier`: The keyARN of the encryption key that Amazon Web Services Payment
  Cryptography uses to verify MAC data.
- `mac`: The MAC being verified.
- `message_data`: The data on for which MAC is under verification. This value must be
  hexBinary.
- `verification_attributes`: The attributes and data values to use for MAC verification
  within Amazon Web Services Payment Cryptography.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MacLength"`: The length of the MAC.
"""
function verify_mac(
    KeyIdentifier,
    Mac,
    MessageData,
    VerificationAttributes;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return payment_cryptography_data(
        "POST",
        "/mac/verify",
        Dict{String,Any}(
            "KeyIdentifier" => KeyIdentifier,
            "Mac" => Mac,
            "MessageData" => MessageData,
            "VerificationAttributes" => VerificationAttributes,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function verify_mac(
    KeyIdentifier,
    Mac,
    MessageData,
    VerificationAttributes,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return payment_cryptography_data(
        "POST",
        "/mac/verify",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "KeyIdentifier" => KeyIdentifier,
                    "Mac" => Mac,
                    "MessageData" => MessageData,
                    "VerificationAttributes" => VerificationAttributes,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    verify_pin_data(encrypted_pin_block, encryption_key_identifier, pin_block_format, primary_account_number, verification_attributes, verification_key_identifier)
    verify_pin_data(encrypted_pin_block, encryption_key_identifier, pin_block_format, primary_account_number, verification_attributes, verification_key_identifier, params::Dict{String,<:Any})

Verifies pin-related data such as PIN and PIN Offset using algorithms including VISA PVV
and IBM3624. For more information, see Verify PIN data in the Amazon Web Services Payment
Cryptography User Guide. This operation verifies PIN data for user payment card. A card
holder PIN data is never transmitted in clear to or from Amazon Web Services Payment
Cryptography. This operation uses PIN Verification Key (PVK) for PIN or PIN Offset
generation and then encrypts it using PIN Encryption Key (PEK) to create an
EncryptedPinBlock for transmission from Amazon Web Services Payment Cryptography.  For
information about valid keys for this operation, see Understanding key attributes and Key
types for specific data operations in the Amazon Web Services Payment Cryptography User
Guide.   Cross-account use: This operation can't be used across different Amazon Web
Services accounts.  Related operations:     GeneratePinData     TranslatePinData

# Arguments
- `encrypted_pin_block`: The encrypted PIN block data that Amazon Web Services Payment
  Cryptography verifies.
- `encryption_key_identifier`: The keyARN of the encryption key under which the PIN block
  data is encrypted. This key type can be PEK or BDK.
- `pin_block_format`: The PIN encoding format for pin data generation as specified in ISO
  9564. Amazon Web Services Payment Cryptography supports ISO_Format_0 and ISO_Format_3. The
  ISO_Format_0 PIN block format is equivalent to the ANSI X9.8, VISA-1, and ECI-1 PIN block
  formats. It is similar to a VISA-4 PIN block format. It supports a PIN from 4 to 12 digits
  in length. The ISO_Format_3 PIN block format is the same as ISO_Format_0 except that the
  fill digits are random values from 10 to 15.
- `primary_account_number`: The Primary Account Number (PAN), a unique identifier for a
  payment credit or debit card that associates the card with a specific account holder.
- `verification_attributes`: The attributes and values for PIN data verification.
- `verification_key_identifier`: The keyARN of the PIN verification key.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DukptAttributes"`: The attributes and values for the DUKPT encrypted PIN block data.
- `"PinDataLength"`: The length of PIN being verified.
"""
function verify_pin_data(
    EncryptedPinBlock,
    EncryptionKeyIdentifier,
    PinBlockFormat,
    PrimaryAccountNumber,
    VerificationAttributes,
    VerificationKeyIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return payment_cryptography_data(
        "POST",
        "/pindata/verify",
        Dict{String,Any}(
            "EncryptedPinBlock" => EncryptedPinBlock,
            "EncryptionKeyIdentifier" => EncryptionKeyIdentifier,
            "PinBlockFormat" => PinBlockFormat,
            "PrimaryAccountNumber" => PrimaryAccountNumber,
            "VerificationAttributes" => VerificationAttributes,
            "VerificationKeyIdentifier" => VerificationKeyIdentifier,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function verify_pin_data(
    EncryptedPinBlock,
    EncryptionKeyIdentifier,
    PinBlockFormat,
    PrimaryAccountNumber,
    VerificationAttributes,
    VerificationKeyIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return payment_cryptography_data(
        "POST",
        "/pindata/verify",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EncryptedPinBlock" => EncryptedPinBlock,
                    "EncryptionKeyIdentifier" => EncryptionKeyIdentifier,
                    "PinBlockFormat" => PinBlockFormat,
                    "PrimaryAccountNumber" => PrimaryAccountNumber,
                    "VerificationAttributes" => VerificationAttributes,
                    "VerificationKeyIdentifier" => VerificationKeyIdentifier,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl

module AWSServices

using AWS
using OrderedCollections: LittleDict

const accessanalyzer = AWS.RestJSONService(
    "access-analyzer", "access-analyzer", "2019-11-01"
)
const account = AWS.RestJSONService("account", "account", "2021-02-01")
const acm = AWS.JSONService("acm", "acm", "2015-12-08", "1.1", "CertificateManager")
const acm_pca = AWS.JSONService("acm-pca", "acm-pca", "2017-08-22", "1.1", "ACMPrivateCA")
const amp = AWS.RestJSONService("aps", "aps", "2020-08-01")
const amplify = AWS.RestJSONService("amplify", "amplify", "2017-07-25")
const amplifybackend = AWS.RestJSONService("amplifybackend", "amplifybackend", "2020-08-11")
const amplifyuibuilder = AWS.RestJSONService(
    "amplifyuibuilder", "amplifyuibuilder", "2021-08-11"
)
const api_gateway = AWS.RestJSONService("apigateway", "apigateway", "2015-07-09")
const apigatewaymanagementapi = AWS.RestJSONService(
    "execute-api", "execute-api", "2018-11-29"
)
const apigatewayv2 = AWS.RestJSONService("apigateway", "apigateway", "2018-11-29")
const app_mesh = AWS.RestJSONService("appmesh", "appmesh", "2019-01-25")
const appconfig = AWS.RestJSONService("appconfig", "appconfig", "2019-10-09")
const appconfigdata = AWS.RestJSONService("appconfig", "appconfigdata", "2021-11-11")
const appfabric = AWS.RestJSONService("appfabric", "appfabric", "2023-05-19")
const appflow = AWS.RestJSONService("appflow", "appflow", "2020-08-23")
const appintegrations = AWS.RestJSONService(
    "app-integrations", "app-integrations", "2020-07-29"
)
const application_auto_scaling = AWS.JSONService(
    "application-autoscaling",
    "application-autoscaling",
    "2016-02-06",
    "1.1",
    "AnyScaleFrontendService",
)
const application_discovery_service = AWS.JSONService(
    "discovery", "discovery", "2015-11-01", "1.1", "AWSPoseidonService_V2015_11_01"
)
const application_insights = AWS.JSONService(
    "applicationinsights",
    "applicationinsights",
    "2018-11-25",
    "1.1",
    "EC2WindowsBarleyService",
)
const application_signals = AWS.RestJSONService(
    "application-signals", "application-signals", "2024-04-15"
)
const applicationcostprofiler = AWS.RestJSONService(
    "application-cost-profiler", "application-cost-profiler", "2020-09-10"
)
const apprunner = AWS.JSONService(
    "apprunner", "apprunner", "2020-05-15", "1.0", "AppRunner"
)
const appstream = AWS.JSONService(
    "appstream", "appstream2", "2016-12-01", "1.1", "PhotonAdminProxyService"
)
const appsync = AWS.RestJSONService("appsync", "appsync", "2017-07-25")
const apptest = AWS.RestJSONService("apptest", "apptest", "2022-12-06")
const arc_zonal_shift = AWS.RestJSONService(
    "arc-zonal-shift", "arc-zonal-shift", "2022-10-30"
)
const artifact = AWS.RestJSONService("artifact", "artifact", "2018-05-10")
const athena = AWS.JSONService("athena", "athena", "2017-05-18", "1.1", "AmazonAthena")
const auditmanager = AWS.RestJSONService("auditmanager", "auditmanager", "2017-07-25")
const auto_scaling = AWS.QueryService("autoscaling", "autoscaling", "2011-01-01")
const auto_scaling_plans = AWS.JSONService(
    "autoscaling-plans",
    "autoscaling-plans",
    "2018-01-06",
    "1.1",
    "AnyScaleScalingPlannerFrontendService",
)
const b2bi = AWS.JSONService("b2bi", "b2bi", "2022-06-23", "1.0", "B2BI")
const backup = AWS.RestJSONService("backup", "backup", "2018-11-15")
const backup_gateway = AWS.JSONService(
    "backup-gateway", "backup-gateway", "2021-01-01", "1.0", "BackupOnPremises_v20210101"
)
const batch = AWS.RestJSONService("batch", "batch", "2016-08-10")
const bcm_data_exports = AWS.JSONService(
    "bcm-data-exports",
    "bcm-data-exports",
    "2023-11-26",
    "1.1",
    "AWSBillingAndCostManagementDataExports",
)
const bedrock = AWS.RestJSONService("bedrock", "bedrock", "2023-04-20")
const bedrock_agent = AWS.RestJSONService("bedrock", "bedrock-agent", "2023-06-05")
const bedrock_agent_runtime = AWS.RestJSONService(
    "bedrock", "bedrock-agent-runtime", "2023-07-26"
)
const bedrock_runtime = AWS.RestJSONService("bedrock", "bedrock-runtime", "2023-09-30")
const billingconductor = AWS.RestJSONService(
    "billingconductor", "billingconductor", "2021-07-30"
)
const braket = AWS.RestJSONService("braket", "braket", "2019-09-01")
const budgets = AWS.JSONService(
    "budgets", "budgets", "2016-10-20", "1.1", "AWSBudgetServiceGateway"
)
const chatbot = AWS.RestJSONService("chatbot", "chatbot", "2017-10-11")
const chime = AWS.RestJSONService("chime", "chime", "2018-05-01")
const chime_sdk_identity = AWS.RestJSONService("chime", "identity-chime", "2021-04-20")
const chime_sdk_media_pipelines = AWS.RestJSONService(
    "chime", "media-pipelines-chime", "2021-07-15"
)
const chime_sdk_meetings = AWS.RestJSONService("chime", "meetings-chime", "2021-07-15")
const chime_sdk_messaging = AWS.RestJSONService("chime", "messaging-chime", "2021-05-15")
const chime_sdk_voice = AWS.RestJSONService("chime", "voice-chime", "2022-08-03")
const cleanrooms = AWS.RestJSONService("cleanrooms", "cleanrooms", "2022-02-17")
const cleanroomsml = AWS.RestJSONService("cleanrooms-ml", "cleanrooms-ml", "2023-09-06")
const cloud9 = AWS.JSONService(
    "cloud9", "cloud9", "2017-09-23", "1.1", "AWSCloud9WorkspaceManagementService"
)
const cloudcontrol = AWS.JSONService(
    "cloudcontrolapi", "cloudcontrolapi", "2021-09-30", "1.0", "CloudApiService"
)
const clouddirectory = AWS.RestJSONService("clouddirectory", "clouddirectory", "2017-01-11")
const cloudformation = AWS.QueryService("cloudformation", "cloudformation", "2010-05-15")
const cloudfront = AWS.RestXMLService("cloudfront", "cloudfront", "2020-05-31")
const cloudhsm = AWS.JSONService(
    "cloudhsm", "cloudhsm", "2014-05-30", "1.1", "CloudHsmFrontendService"
)
const cloudhsm_v2 = AWS.JSONService(
    "cloudhsm", "cloudhsmv2", "2017-04-28", "1.1", "BaldrApiService"
)
const cloudsearch = AWS.QueryService("cloudsearch", "cloudsearch", "2013-01-01")
const cloudsearch_domain = AWS.RestJSONService(
    "cloudsearch", "cloudsearchdomain", "2013-01-01"
)
const cloudtrail = AWS.JSONService(
    "cloudtrail",
    "cloudtrail",
    "2013-11-01",
    "1.1",
    "com.amazonaws.cloudtrail.v20131101.CloudTrail_20131101",
)
const cloudtrail_data = AWS.RestJSONService(
    "cloudtrail-data", "cloudtrail-data", "2021-08-11"
)
const cloudwatch = AWS.QueryService("monitoring", "monitoring", "2010-08-01")
const cloudwatch_events = AWS.JSONService(
    "events", "events", "2015-10-07", "1.1", "AWSEvents"
)
const cloudwatch_logs = AWS.JSONService(
    "logs", "logs", "2014-03-28", "1.1", "Logs_20140328"
)
const codeartifact = AWS.RestJSONService("codeartifact", "codeartifact", "2018-09-22")
const codebuild = AWS.JSONService(
    "codebuild", "codebuild", "2016-10-06", "1.1", "CodeBuild_20161006"
)
const codecatalyst = AWS.RestJSONService("codecatalyst", "codecatalyst", "2022-09-28")
const codecommit = AWS.JSONService(
    "codecommit", "codecommit", "2015-04-13", "1.1", "CodeCommit_20150413"
)
const codeconnections = AWS.JSONService(
    "codeconnections",
    "codeconnections",
    "2023-12-01",
    "1.0",
    "com.amazonaws.codeconnections.CodeConnections_20231201",
)
const codedeploy = AWS.JSONService(
    "codedeploy", "codedeploy", "2014-10-06", "1.1", "CodeDeploy_20141006"
)
const codeguru_reviewer = AWS.RestJSONService(
    "codeguru-reviewer", "codeguru-reviewer", "2019-09-19"
)
const codeguru_security = AWS.RestJSONService(
    "codeguru-security", "codeguru-security", "2018-05-10"
)
const codeguruprofiler = AWS.RestJSONService(
    "codeguru-profiler", "codeguru-profiler", "2019-07-18"
)
const codepipeline = AWS.JSONService(
    "codepipeline", "codepipeline", "2015-07-09", "1.1", "CodePipeline_20150709"
)
const codestar = AWS.JSONService(
    "codestar", "codestar", "2017-04-19", "1.1", "CodeStar_20170419"
)
const codestar_connections = AWS.JSONService(
    "codestar-connections",
    "codestar-connections",
    "2019-12-01",
    "1.0",
    "com.amazonaws.codestar.connections.CodeStar_connections_20191201",
)
const codestar_notifications = AWS.RestJSONService(
    "codestar-notifications", "codestar-notifications", "2019-10-15"
)
const cognito_identity = AWS.JSONService(
    "cognito-identity", "cognito-identity", "2014-06-30", "1.1", "AWSCognitoIdentityService"
)
const cognito_identity_provider = AWS.JSONService(
    "cognito-idp", "cognito-idp", "2016-04-18", "1.1", "AWSCognitoIdentityProviderService"
)
const cognito_sync = AWS.RestJSONService("cognito-sync", "cognito-sync", "2014-06-30")
const comprehend = AWS.JSONService(
    "comprehend", "comprehend", "2017-11-27", "1.1", "Comprehend_20171127"
)
const comprehendmedical = AWS.JSONService(
    "comprehendmedical",
    "comprehendmedical",
    "2018-10-30",
    "1.1",
    "ComprehendMedical_20181030",
)
const compute_optimizer = AWS.JSONService(
    "compute-optimizer", "compute-optimizer", "2019-11-01", "1.0", "ComputeOptimizerService"
)
const config_service = AWS.JSONService(
    "config", "config", "2014-11-12", "1.1", "StarlingDoveService"
)
const connect = AWS.RestJSONService("connect", "connect", "2017-08-08")
const connect_contact_lens = AWS.RestJSONService("connect", "contact-lens", "2020-08-21")
const connectcampaigns = AWS.RestJSONService(
    "connect-campaigns", "connect-campaigns", "2021-01-30"
)
const connectcases = AWS.RestJSONService("cases", "cases", "2022-10-03")
const connectparticipant = AWS.RestJSONService(
    "execute-api", "participant.connect", "2018-09-07"
)
const controlcatalog = AWS.RestJSONService("controlcatalog", "controlcatalog", "2018-05-10")
const controltower = AWS.RestJSONService("controltower", "controltower", "2018-05-10")
const cost_and_usage_report_service = AWS.JSONService(
    "cur", "cur", "2017-01-06", "1.1", "AWSOrigamiServiceGatewayService"
)
const cost_explorer = AWS.JSONService(
    "ce", "ce", "2017-10-25", "1.1", "AWSInsightsIndexService"
)
const cost_optimization_hub = AWS.JSONService(
    "cost-optimization-hub",
    "cost-optimization-hub",
    "2022-07-26",
    "1.0",
    "CostOptimizationHubService",
)
const customer_profiles = AWS.RestJSONService("profile", "profile", "2020-08-15")
const data_pipeline = AWS.JSONService(
    "datapipeline", "datapipeline", "2012-10-29", "1.1", "DataPipeline"
)
const database_migration_service = AWS.JSONService(
    "dms", "dms", "2016-01-01", "1.1", "AmazonDMSv20160101"
)
const databrew = AWS.RestJSONService("databrew", "databrew", "2017-07-25")
const dataexchange = AWS.RestJSONService("dataexchange", "dataexchange", "2017-07-25")
const datasync = AWS.JSONService("datasync", "datasync", "2018-11-09", "1.1", "FmrsService")
const datazone = AWS.RestJSONService("datazone", "datazone", "2018-05-10")
const dax = AWS.JSONService("dax", "dax", "2017-04-19", "1.1", "AmazonDAXV3")
const deadline = AWS.RestJSONService("deadline", "deadline", "2023-10-12")
const detective = AWS.RestJSONService("detective", "api.detective", "2018-10-26")
const device_farm = AWS.JSONService(
    "devicefarm", "devicefarm", "2015-06-23", "1.1", "DeviceFarm_20150623"
)
const devops_guru = AWS.RestJSONService("devops-guru", "devops-guru", "2020-12-01")
const direct_connect = AWS.JSONService(
    "directconnect", "directconnect", "2012-10-25", "1.1", "OvertureService"
)
const directory_service = AWS.JSONService(
    "ds", "ds", "2015-04-16", "1.1", "DirectoryService_20150416"
)
const dlm = AWS.RestJSONService("dlm", "dlm", "2018-01-12")
const docdb = AWS.QueryService("rds", "rds", "2014-10-31")
const docdb_elastic = AWS.RestJSONService("docdb-elastic", "docdb-elastic", "2022-11-28")
const drs = AWS.RestJSONService("drs", "drs", "2020-02-26")
const dynamodb = AWS.JSONService(
    "dynamodb", "dynamodb", "2012-08-10", "1.0", "DynamoDB_20120810"
)
const dynamodb_streams = AWS.JSONService(
    "dynamodb", "streams.dynamodb", "2012-08-10", "1.0", "DynamoDBStreams_20120810"
)
const ebs = AWS.RestJSONService("ebs", "ebs", "2019-11-02")
const ec2 = AWS.QueryService("ec2", "ec2", "2016-11-15")
const ec2_instance_connect = AWS.JSONService(
    "ec2-instance-connect",
    "ec2-instance-connect",
    "2018-04-02",
    "1.1",
    "AWSEC2InstanceConnectService",
)
const ecr = AWS.JSONService(
    "ecr", "api.ecr", "2015-09-21", "1.1", "AmazonEC2ContainerRegistry_V20150921"
)
const ecr_public = AWS.JSONService(
    "ecr-public", "api.ecr-public", "2020-10-30", "1.1", "SpencerFrontendService"
)
const ecs = AWS.JSONService(
    "ecs", "ecs", "2014-11-13", "1.1", "AmazonEC2ContainerServiceV20141113"
)
const efs = AWS.RestJSONService("elasticfilesystem", "elasticfilesystem", "2015-02-01")
const eks = AWS.RestJSONService("eks", "eks", "2017-11-01")
const eks_auth = AWS.RestJSONService("eks-auth", "eks-auth", "2023-11-26")
const elastic_beanstalk = AWS.QueryService(
    "elasticbeanstalk", "elasticbeanstalk", "2010-12-01"
)
const elastic_inference = AWS.RestJSONService(
    "elastic-inference", "api.elastic-inference", "2017-07-25"
)
const elastic_load_balancing = AWS.QueryService(
    "elasticloadbalancing", "elasticloadbalancing", "2012-06-01"
)
const elastic_load_balancing_v2 = AWS.QueryService(
    "elasticloadbalancing", "elasticloadbalancing", "2015-12-01"
)
const elastic_transcoder = AWS.RestJSONService(
    "elastictranscoder", "elastictranscoder", "2012-09-25"
)
const elasticache = AWS.QueryService("elasticache", "elasticache", "2015-02-02")
const elasticsearch_service = AWS.RestJSONService("es", "es", "2015-01-01")
const emr = AWS.JSONService(
    "elasticmapreduce", "elasticmapreduce", "2009-03-31", "1.1", "ElasticMapReduce"
)
const emr_containers = AWS.RestJSONService("emr-containers", "emr-containers", "2020-10-01")
const emr_serverless = AWS.RestJSONService("emr-serverless", "emr-serverless", "2021-07-13")
const entityresolution = AWS.RestJSONService(
    "entityresolution", "entityresolution", "2018-05-10"
)
const eventbridge = AWS.JSONService("events", "events", "2015-10-07", "1.1", "AWSEvents")
const evidently = AWS.RestJSONService("evidently", "evidently", "2021-02-01")
const finspace = AWS.RestJSONService("finspace", "finspace", "2021-03-12")
const finspace_data = AWS.RestJSONService("finspace-api", "finspace-api", "2020-07-13")
const firehose = AWS.JSONService(
    "firehose", "firehose", "2015-08-04", "1.1", "Firehose_20150804"
)
const fis = AWS.RestJSONService("fis", "fis", "2020-12-01")
const fms = AWS.JSONService("fms", "fms", "2018-01-01", "1.1", "AWSFMS_20180101")
const forecast = AWS.JSONService(
    "forecast", "forecast", "2018-06-26", "1.1", "AmazonForecast"
)
const forecastquery = AWS.JSONService(
    "forecast", "forecastquery", "2018-06-26", "1.1", "AmazonForecastRuntime"
)
const frauddetector = AWS.JSONService(
    "frauddetector", "frauddetector", "2019-11-15", "1.1", "AWSHawksNestServiceFacade"
)
const freetier = AWS.JSONService(
    "freetier", "freetier", "2023-09-07", "1.0", "AWSFreeTierService"
)
const fsx = AWS.JSONService(
    "fsx", "fsx", "2018-03-01", "1.1", "AWSSimbaAPIService_v20180301"
)
const gamelift = AWS.JSONService("gamelift", "gamelift", "2015-10-01", "1.1", "GameLift")
const glacier = AWS.RestJSONService(
    "glacier", "glacier", "2012-06-01", LittleDict("x-amz-glacier-version" => "2012-06-01")
)
const global_accelerator = AWS.JSONService(
    "globalaccelerator",
    "globalaccelerator",
    "2018-08-08",
    "1.1",
    "GlobalAccelerator_V20180706",
)
const glue = AWS.JSONService("glue", "glue", "2017-03-31", "1.1", "AWSGlue")
const grafana = AWS.RestJSONService("grafana", "grafana", "2020-08-18")
const greengrass = AWS.RestJSONService("greengrass", "greengrass", "2017-06-07")
const greengrassv2 = AWS.RestJSONService("greengrass", "greengrass", "2020-11-30")
const groundstation = AWS.RestJSONService("groundstation", "groundstation", "2019-05-23")
const guardduty = AWS.RestJSONService("guardduty", "guardduty", "2017-11-28")
const health = AWS.JSONService(
    "health", "health", "2016-08-04", "1.1", "AWSHealth_20160804"
)
const healthlake = AWS.JSONService(
    "healthlake", "healthlake", "2017-07-01", "1.0", "HealthLake"
)
const iam = AWS.QueryService("iam", "iam", "2010-05-08")
const identitystore = AWS.JSONService(
    "identitystore", "identitystore", "2020-06-15", "1.1", "AWSIdentityStore"
)
const imagebuilder = AWS.RestJSONService("imagebuilder", "imagebuilder", "2019-12-02")
const importexport = AWS.QueryService("importexport", "importexport", "2010-06-01")
const inspector = AWS.JSONService(
    "inspector", "inspector", "2016-02-16", "1.1", "InspectorService"
)
const inspector2 = AWS.RestJSONService("inspector2", "inspector2", "2020-06-08")
const inspector_scan = AWS.RestJSONService("inspector-scan", "inspector-scan", "2023-08-08")
const internetmonitor = AWS.RestJSONService(
    "internetmonitor", "internetmonitor", "2021-06-03"
)
const iot = AWS.RestJSONService("iot", "iot", "2015-05-28")
const iot_1click_devices_service = AWS.RestJSONService(
    "iot1click", "devices.iot1click", "2018-05-14"
)
const iot_1click_projects = AWS.RestJSONService(
    "iot1click", "projects.iot1click", "2018-05-14"
)
const iot_data_plane = AWS.RestJSONService("iotdata", "data-ats.iot", "2015-05-28")
const iot_events = AWS.RestJSONService("iotevents", "iotevents", "2018-07-27")
const iot_events_data = AWS.RestJSONService("ioteventsdata", "data.iotevents", "2018-10-23")
const iot_jobs_data_plane = AWS.RestJSONService(
    "iot-jobs-data", "data.jobs.iot", "2017-09-29"
)
const iot_wireless = AWS.RestJSONService("iotwireless", "api.iotwireless", "2020-11-22")
const iotanalytics = AWS.RestJSONService("iotanalytics", "iotanalytics", "2017-11-27")
const iotdeviceadvisor = AWS.RestJSONService(
    "iotdeviceadvisor", "api.iotdeviceadvisor", "2020-09-18"
)
const iotfleethub = AWS.RestJSONService("iotfleethub", "api.fleethub.iot", "2020-11-03")
const iotfleetwise = AWS.JSONService(
    "iotfleetwise", "iotfleetwise", "2021-06-17", "1.0", "IoTAutobahnControlPlane"
)
const iotsecuretunneling = AWS.JSONService(
    "IoTSecuredTunneling", "api.tunneling.iot", "2018-10-05", "1.1", "IoTSecuredTunneling"
)
const iotsitewise = AWS.RestJSONService("iotsitewise", "iotsitewise", "2019-12-02")
const iotthingsgraph = AWS.JSONService(
    "iotthingsgraph", "iotthingsgraph", "2018-09-06", "1.1", "IotThingsGraphFrontEndService"
)
const iottwinmaker = AWS.RestJSONService("iottwinmaker", "iottwinmaker", "2021-11-29")
const ivs = AWS.RestJSONService("ivs", "ivs", "2020-07-14")
const ivs_realtime = AWS.RestJSONService("ivs", "ivsrealtime", "2020-07-14")
const ivschat = AWS.RestJSONService("ivschat", "ivschat", "2020-07-14")
const kafka = AWS.RestJSONService("kafka", "kafka", "2018-11-14")
const kafkaconnect = AWS.RestJSONService("kafkaconnect", "kafkaconnect", "2021-09-14")
const kendra = AWS.JSONService(
    "kendra", "kendra", "2019-02-03", "1.1", "AWSKendraFrontendService"
)
const kendra_ranking = AWS.JSONService(
    "kendra-ranking",
    "kendra-ranking",
    "2022-10-19",
    "1.0",
    "AWSKendraRerankingFrontendService",
)
const keyspaces = AWS.JSONService(
    "cassandra", "cassandra", "2022-02-10", "1.0", "KeyspacesService"
)
const kinesis = AWS.JSONService(
    "kinesis", "kinesis", "2013-12-02", "1.1", "Kinesis_20131202"
)
const kinesis_analytics = AWS.JSONService(
    "kinesisanalytics", "kinesisanalytics", "2015-08-14", "1.1", "KinesisAnalytics_20150814"
)
const kinesis_analytics_v2 = AWS.JSONService(
    "kinesisanalytics", "kinesisanalytics", "2018-05-23", "1.1", "KinesisAnalytics_20180523"
)
const kinesis_video = AWS.RestJSONService("kinesisvideo", "kinesisvideo", "2017-09-30")
const kinesis_video_archived_media = AWS.RestJSONService(
    "kinesisvideo", "kinesisvideo", "2017-09-30"
)
const kinesis_video_media = AWS.RestJSONService(
    "kinesisvideo", "kinesisvideo", "2017-09-30"
)
const kinesis_video_signaling = AWS.RestJSONService(
    "kinesisvideo", "kinesisvideo", "2019-12-04"
)
const kinesis_video_webrtc_storage = AWS.RestJSONService(
    "kinesisvideo", "kinesisvideo", "2018-05-10"
)
const kms = AWS.JSONService("kms", "kms", "2014-11-01", "1.1", "TrentService")
const lakeformation = AWS.RestJSONService("lakeformation", "lakeformation", "2017-03-31")
const lambda = AWS.RestJSONService("lambda", "lambda", "2015-03-31")
const launch_wizard = AWS.RestJSONService("launchwizard", "launchwizard", "2018-05-10")
const lex_model_building_service = AWS.RestJSONService("lex", "models.lex", "2017-04-19")
const lex_models_v2 = AWS.RestJSONService("lex", "models-v2-lex", "2020-08-07")
const lex_runtime_service = AWS.RestJSONService("lex", "runtime.lex", "2016-11-28")
const lex_runtime_v2 = AWS.RestJSONService("lex", "runtime-v2-lex", "2020-08-07")
const license_manager = AWS.JSONService(
    "license-manager", "license-manager", "2018-08-01", "1.1", "AWSLicenseManager"
)
const license_manager_linux_subscriptions = AWS.RestJSONService(
    "license-manager-linux-subscriptions",
    "license-manager-linux-subscriptions",
    "2018-05-10",
)
const license_manager_user_subscriptions = AWS.RestJSONService(
    "license-manager-user-subscriptions", "license-manager-user-subscriptions", "2018-05-10"
)
const lightsail = AWS.JSONService(
    "lightsail", "lightsail", "2016-11-28", "1.1", "Lightsail_20161128"
)
const location = AWS.RestJSONService("geo", "geo", "2020-11-19")
const lookoutequipment = AWS.JSONService(
    "lookoutequipment",
    "lookoutequipment",
    "2020-12-15",
    "1.0",
    "AWSLookoutEquipmentFrontendService",
)
const lookoutmetrics = AWS.RestJSONService("lookoutmetrics", "lookoutmetrics", "2017-07-25")
const lookoutvision = AWS.RestJSONService("lookoutvision", "lookoutvision", "2020-11-20")
const m2 = AWS.RestJSONService("m2", "m2", "2021-04-28")
const machine_learning = AWS.JSONService(
    "machinelearning", "machinelearning", "2014-12-12", "1.1", "AmazonML_20141212"
)
const macie2 = AWS.RestJSONService("macie2", "macie2", "2020-01-01")
const mailmanager = AWS.JSONService(
    "ses", "mail-manager", "2023-10-17", "1.0", "MailManagerSvc"
)
const managedblockchain = AWS.RestJSONService(
    "managedblockchain", "managedblockchain", "2018-09-24"
)
const managedblockchain_query = AWS.RestJSONService(
    "managedblockchain-query", "managedblockchain-query", "2023-05-04"
)
const marketplace_agreement = AWS.JSONService(
    "aws-marketplace",
    "agreement-marketplace",
    "2020-03-01",
    "1.0",
    "AWSMPCommerceService_v20200301",
)
const marketplace_catalog = AWS.RestJSONService(
    "aws-marketplace", "catalog.marketplace", "2018-09-17"
)
const marketplace_commerce_analytics = AWS.JSONService(
    "marketplacecommerceanalytics",
    "marketplacecommerceanalytics",
    "2015-07-01",
    "1.1",
    "MarketplaceCommerceAnalytics20150701",
)
const marketplace_deployment = AWS.RestJSONService(
    "aws-marketplace", "deployment-marketplace", "2023-01-25"
)
const marketplace_entitlement_service = AWS.JSONService(
    "aws-marketplace",
    "entitlement.marketplace",
    "2017-01-11",
    "1.1",
    "AWSMPEntitlementService",
)
const marketplace_metering = AWS.JSONService(
    "aws-marketplace", "metering.marketplace", "2016-01-14", "1.1", "AWSMPMeteringService"
)
const mediaconnect = AWS.RestJSONService("mediaconnect", "mediaconnect", "2018-11-14")
const mediaconvert = AWS.RestJSONService("mediaconvert", "mediaconvert", "2017-08-29")
const medialive = AWS.RestJSONService("medialive", "medialive", "2017-10-14")
const mediapackage = AWS.RestJSONService("mediapackage", "mediapackage", "2017-10-12")
const mediapackage_vod = AWS.RestJSONService(
    "mediapackage-vod", "mediapackage-vod", "2018-11-07"
)
const mediapackagev2 = AWS.RestJSONService("mediapackagev2", "mediapackagev2", "2022-12-25")
const mediastore = AWS.JSONService(
    "mediastore", "mediastore", "2017-09-01", "1.1", "MediaStore_20170901"
)
const mediastore_data = AWS.RestJSONService("mediastore", "data.mediastore", "2017-09-01")
const mediatailor = AWS.RestJSONService("mediatailor", "api.mediatailor", "2018-04-23")
const medical_imaging = AWS.RestJSONService(
    "medical-imaging", "medical-imaging", "2023-07-19"
)
const memorydb = AWS.JSONService(
    "memorydb", "memory-db", "2021-01-01", "1.1", "AmazonMemoryDB"
)
const mgn = AWS.RestJSONService("mgn", "mgn", "2020-02-26")
const migration_hub = AWS.JSONService("mgh", "mgh", "2017-05-31", "1.1", "AWSMigrationHub")
const migration_hub_refactor_spaces = AWS.RestJSONService(
    "refactor-spaces", "refactor-spaces", "2021-10-26"
)
const migrationhub_config = AWS.JSONService(
    "mgh", "migrationhub-config", "2019-06-30", "1.1", "AWSMigrationHubMultiAccountService"
)
const migrationhuborchestrator = AWS.RestJSONService(
    "migrationhub-orchestrator", "migrationhub-orchestrator", "2021-08-28"
)
const migrationhubstrategy = AWS.RestJSONService(
    "migrationhub-strategy", "migrationhub-strategy", "2020-02-19"
)
const mobile = AWS.RestJSONService("AWSMobileHubService", "mobile", "2017-07-01")
const mobile_analytics = AWS.RestJSONService(
    "mobileanalytics", "mobileanalytics", "2014-06-05"
)
const mq = AWS.RestJSONService("mq", "mq", "2017-11-27")
const mturk = AWS.JSONService(
    "mturk-requester",
    "mturk-requester",
    "2017-01-17",
    "1.1",
    "MTurkRequesterServiceV20170117",
)
const mwaa = AWS.RestJSONService("airflow", "airflow", "2020-07-01")
const neptune = AWS.QueryService("rds", "rds", "2014-10-31")
const neptunedata = AWS.RestJSONService("neptune-db", "neptune-db", "2023-08-01")
const network_firewall = AWS.JSONService(
    "network-firewall", "network-firewall", "2020-11-12", "1.0", "NetworkFirewall_20201112"
)
const networkmanager = AWS.RestJSONService("networkmanager", "networkmanager", "2019-07-05")
const networkmonitor = AWS.RestJSONService("networkmonitor", "networkmonitor", "2023-08-01")
const nimble = AWS.RestJSONService("nimble", "nimble", "2020-08-01")
const oam = AWS.RestJSONService("oam", "oam", "2022-06-10")
const omics = AWS.RestJSONService("omics", "omics", "2022-11-28")
const opensearch = AWS.RestJSONService("es", "es", "2021-01-01")
const opensearchserverless = AWS.JSONService(
    "aoss", "aoss", "2021-11-01", "1.0", "OpenSearchServerless"
)
const opsworks = AWS.JSONService(
    "opsworks", "opsworks", "2013-02-18", "1.1", "OpsWorks_20130218"
)
const opsworkscm = AWS.JSONService(
    "opsworks-cm", "opsworks-cm", "2016-11-01", "1.1", "OpsWorksCM_V2016_11_01"
)
const organizations = AWS.JSONService(
    "organizations", "organizations", "2016-11-28", "1.1", "AWSOrganizationsV20161128"
)
const osis = AWS.RestJSONService("osis", "osis", "2022-01-01")
const outposts = AWS.RestJSONService("outposts", "outposts", "2019-12-03")
const panorama = AWS.RestJSONService("panorama", "panorama", "2019-07-24")
const payment_cryptography = AWS.JSONService(
    "payment-cryptography",
    "controlplane.payment-cryptography",
    "2021-09-14",
    "1.0",
    "PaymentCryptographyControlPlane",
)
const payment_cryptography_data = AWS.RestJSONService(
    "payment-cryptography", "dataplane.payment-cryptography", "2022-02-03"
)
const pca_connector_ad = AWS.RestJSONService(
    "pca-connector-ad", "pca-connector-ad", "2018-05-10"
)
const pca_connector_scep = AWS.RestJSONService(
    "pca-connector-scep", "pca-connector-scep", "2018-05-10"
)
const personalize = AWS.JSONService(
    "personalize", "personalize", "2018-05-22", "1.1", "AmazonPersonalize"
)
const personalize_events = AWS.RestJSONService(
    "personalize", "personalize-events", "2018-03-22"
)
const personalize_runtime = AWS.RestJSONService(
    "personalize", "personalize-runtime", "2018-05-22"
)
const pi = AWS.JSONService("pi", "pi", "2018-02-27", "1.1", "PerformanceInsightsv20180227")
const pinpoint = AWS.RestJSONService("mobiletargeting", "pinpoint", "2016-12-01")
const pinpoint_email = AWS.RestJSONService("ses", "email", "2018-07-26")
const pinpoint_sms_voice = AWS.RestJSONService(
    "sms-voice", "sms-voice.pinpoint", "2018-09-05"
)
const pinpoint_sms_voice_v2 = AWS.JSONService(
    "sms-voice", "sms-voice", "2022-03-31", "1.0", "PinpointSMSVoiceV2"
)
const pipes = AWS.RestJSONService("pipes", "pipes", "2015-10-07")
const polly = AWS.RestJSONService("polly", "polly", "2016-06-10")
const pricing = AWS.JSONService(
    "pricing", "api.pricing", "2017-10-15", "1.1", "AWSPriceListService"
)
const privatenetworks = AWS.RestJSONService(
    "private-networks", "private-networks", "2021-12-03"
)
const proton = AWS.JSONService("proton", "proton", "2020-07-20", "1.0", "AwsProton20200720")
const qbusiness = AWS.RestJSONService("qbusiness", "qbusiness", "2023-11-27")
const qconnect = AWS.RestJSONService("wisdom", "wisdom", "2020-10-19")
const qldb = AWS.RestJSONService("qldb", "qldb", "2019-01-02")
const qldb_session = AWS.JSONService(
    "qldb", "session.qldb", "2019-07-11", "1.0", "QLDBSession"
)
const quicksight = AWS.RestJSONService("quicksight", "quicksight", "2018-04-01")
const ram = AWS.RestJSONService("ram", "ram", "2018-01-04")
const rbin = AWS.RestJSONService("rbin", "rbin", "2021-06-15")
const rds = AWS.QueryService("rds", "rds", "2014-10-31")
const rds_data = AWS.RestJSONService("rds-data", "rds-data", "2018-08-01")
const redshift = AWS.QueryService("redshift", "redshift", "2012-12-01")
const redshift_data = AWS.JSONService(
    "redshift-data", "redshift-data", "2019-12-20", "1.1", "RedshiftData"
)
const redshift_serverless = AWS.JSONService(
    "redshift-serverless", "redshift-serverless", "2021-04-21", "1.1", "RedshiftServerless"
)
const rekognition = AWS.JSONService(
    "rekognition", "rekognition", "2016-06-27", "1.1", "RekognitionService"
)
const repostspace = AWS.RestJSONService("repostspace", "repostspace", "2022-05-13")
const resiliencehub = AWS.RestJSONService("resiliencehub", "resiliencehub", "2020-04-30")
const resource_explorer_2 = AWS.RestJSONService(
    "resource-explorer-2", "resource-explorer-2", "2022-07-28"
)
const resource_groups = AWS.RestJSONService(
    "resource-groups", "resource-groups", "2017-11-27"
)
const resource_groups_tagging_api = AWS.JSONService(
    "tagging", "tagging", "2017-01-26", "1.1", "ResourceGroupsTaggingAPI_20170126"
)
const robomaker = AWS.RestJSONService("robomaker", "robomaker", "2018-06-29")
const rolesanywhere = AWS.RestJSONService("rolesanywhere", "rolesanywhere", "2018-05-10")
const route53_recovery_cluster = AWS.JSONService(
    "route53-recovery-cluster",
    "route53-recovery-cluster",
    "2019-12-02",
    "1.0",
    "ToggleCustomerAPI",
)
const route53_recovery_control_config = AWS.RestJSONService(
    "route53-recovery-control-config", "route53-recovery-control-config", "2020-11-02"
)
const route53_recovery_readiness = AWS.RestJSONService(
    "route53-recovery-readiness", "route53-recovery-readiness", "2019-12-02"
)
const route53profiles = AWS.RestJSONService(
    "route53profiles", "route53profiles", "2018-05-10"
)
const route53resolver = AWS.JSONService(
    "route53resolver", "route53resolver", "2018-04-01", "1.1", "Route53Resolver"
)
const route_53 = AWS.RestXMLService("route53", "route53", "2013-04-01")
const route_53_domains = AWS.JSONService(
    "route53domains", "route53domains", "2014-05-15", "1.1", "Route53Domains_v20140515"
)
const rum = AWS.RestJSONService("rum", "rum", "2018-05-10")
const s3 = AWS.RestXMLService("s3", "s3", "2006-03-01")
const s3_control = AWS.RestXMLService("s3", "s3-control", "2018-08-20")
const s3outposts = AWS.RestJSONService("s3-outposts", "s3-outposts", "2017-07-25")
const sagemaker = AWS.JSONService(
    "sagemaker", "api.sagemaker", "2017-07-24", "1.1", "SageMaker"
)
const sagemaker_a2i_runtime = AWS.RestJSONService(
    "sagemaker", "a2i-runtime.sagemaker", "2019-11-07"
)
const sagemaker_edge = AWS.RestJSONService("sagemaker", "edge.sagemaker", "2020-09-23")
const sagemaker_featurestore_runtime = AWS.RestJSONService(
    "sagemaker", "featurestore-runtime.sagemaker", "2020-07-01"
)
const sagemaker_geospatial = AWS.RestJSONService(
    "sagemaker-geospatial", "sagemaker-geospatial", "2020-05-27"
)
const sagemaker_metrics = AWS.RestJSONService(
    "sagemaker", "metrics.sagemaker", "2022-09-30"
)
const sagemaker_runtime = AWS.RestJSONService(
    "sagemaker", "runtime.sagemaker", "2017-05-13"
)
const savingsplans = AWS.RestJSONService("savingsplans", "savingsplans", "2019-06-28")
const scheduler = AWS.RestJSONService("scheduler", "scheduler", "2021-06-30")
const schemas = AWS.RestJSONService("schemas", "schemas", "2019-12-02")
const secrets_manager = AWS.JSONService(
    "secretsmanager", "secretsmanager", "2017-10-17", "1.1", "secretsmanager"
)
const securityhub = AWS.RestJSONService("securityhub", "securityhub", "2018-10-26")
const securitylake = AWS.RestJSONService("securitylake", "securitylake", "2018-05-10")
const serverlessapplicationrepository = AWS.RestJSONService(
    "serverlessrepo", "serverlessrepo", "2017-09-08"
)
const service_catalog = AWS.JSONService(
    "servicecatalog", "servicecatalog", "2015-12-10", "1.1", "AWS242ServiceCatalogService"
)
const service_catalog_appregistry = AWS.RestJSONService(
    "servicecatalog", "servicecatalog-appregistry", "2020-06-24"
)
const service_quotas = AWS.JSONService(
    "servicequotas", "servicequotas", "2019-06-24", "1.1", "ServiceQuotasV20190624"
)
const servicediscovery = AWS.JSONService(
    "servicediscovery",
    "servicediscovery",
    "2017-03-14",
    "1.1",
    "Route53AutoNaming_v20170314",
)
const ses = AWS.QueryService("ses", "email", "2010-12-01")
const sesv2 = AWS.RestJSONService("ses", "email", "2019-09-27")
const sfn = AWS.JSONService("states", "states", "2016-11-23", "1.0", "AWSStepFunctions")
const shield = AWS.JSONService(
    "shield", "shield", "2016-06-02", "1.1", "AWSShield_20160616"
)
const signer = AWS.RestJSONService("signer", "signer", "2017-08-25")
const simpledb = AWS.QueryService("sdb", "sdb", "2009-04-15")
const simspaceweaver = AWS.RestJSONService("simspaceweaver", "simspaceweaver", "2022-10-28")
const sms = AWS.JSONService(
    "sms", "sms", "2016-10-24", "1.1", "AWSServerMigrationService_V2016_10_24"
)
const snow_device_management = AWS.RestJSONService(
    "snow-device-management", "snow-device-management", "2021-08-04"
)
const snowball = AWS.JSONService(
    "snowball", "snowball", "2016-06-30", "1.1", "AWSIESnowballJobManagementService"
)
const sns = AWS.QueryService("sns", "sns", "2010-03-31")
const sqs = AWS.JSONService("sqs", "sqs", "2012-11-05", "1.0", "AmazonSQS")
const ssm = AWS.JSONService("ssm", "ssm", "2014-11-06", "1.1", "AmazonSSM")
const ssm_contacts = AWS.JSONService(
    "ssm-contacts", "ssm-contacts", "2021-05-03", "1.1", "SSMContacts"
)
const ssm_incidents = AWS.RestJSONService("ssm-incidents", "ssm-incidents", "2018-05-10")
const ssm_sap = AWS.RestJSONService("ssm-sap", "ssm-sap", "2018-05-10")
const sso = AWS.RestJSONService("awsssoportal", "portal.sso", "2019-06-10")
const sso_admin = AWS.JSONService("sso", "sso", "2020-07-20", "1.1", "SWBExternalService")
const sso_oidc = AWS.RestJSONService("sso-oauth", "oidc", "2019-06-10")
const storage_gateway = AWS.JSONService(
    "storagegateway", "storagegateway", "2013-06-30", "1.1", "StorageGateway_20130630"
)
const sts = AWS.QueryService("sts", "sts", "2011-06-15")
const supplychain = AWS.RestJSONService("scn", "scn", "2024-01-01")
const support = AWS.JSONService(
    "support", "support", "2013-04-15", "1.1", "AWSSupport_20130415"
)
const support_app = AWS.RestJSONService("supportapp", "supportapp", "2021-08-20")
const swf = AWS.JSONService("swf", "swf", "2012-01-25", "1.0", "SimpleWorkflowService")
const synthetics = AWS.RestJSONService("synthetics", "synthetics", "2017-10-11")
const taxsettings = AWS.RestJSONService("tax", "tax", "2018-05-10")
const textract = AWS.JSONService("textract", "textract", "2018-06-27", "1.1", "Textract")
const timestream_influxdb = AWS.JSONService(
    "timestream-influxdb",
    "timestream-influxdb",
    "2023-01-27",
    "1.0",
    "AmazonTimestreamInfluxDB",
)
const timestream_query = AWS.JSONService(
    "timestream", "query.timestream", "2018-11-01", "1.0", "Timestream_20181101"
)
const timestream_write = AWS.JSONService(
    "timestream", "ingest.timestream", "2018-11-01", "1.0", "Timestream_20181101"
)
const tnb = AWS.RestJSONService("tnb", "tnb", "2008-10-21")
const transcribe = AWS.JSONService(
    "transcribe", "transcribe", "2017-10-26", "1.1", "Transcribe"
)
const transfer = AWS.JSONService(
    "transfer", "transfer", "2018-11-05", "1.1", "TransferService"
)
const translate = AWS.JSONService(
    "translate", "translate", "2017-07-01", "1.1", "AWSShineFrontendService_20170701"
)
const trustedadvisor = AWS.RestJSONService("trustedadvisor", "trustedadvisor", "2022-09-15")
const verifiedpermissions = AWS.JSONService(
    "verifiedpermissions", "verifiedpermissions", "2021-12-01", "1.0", "VerifiedPermissions"
)
const voice_id = AWS.JSONService("voiceid", "voiceid", "2021-09-27", "1.0", "VoiceID")
const vpc_lattice = AWS.RestJSONService("vpc-lattice", "vpc-lattice", "2022-11-30")
const waf = AWS.JSONService("waf", "waf", "2015-08-24", "1.1", "AWSWAF_20150824")
const waf_regional = AWS.JSONService(
    "waf-regional", "waf-regional", "2016-11-28", "1.1", "AWSWAF_Regional_20161128"
)
const wafv2 = AWS.JSONService("wafv2", "wafv2", "2019-07-29", "1.1", "AWSWAF_20190729")
const wellarchitected = AWS.RestJSONService(
    "wellarchitected", "wellarchitected", "2020-03-31"
)
const wisdom = AWS.RestJSONService("wisdom", "wisdom", "2020-10-19")
const workdocs = AWS.RestJSONService("workdocs", "workdocs", "2016-05-01")
const worklink = AWS.RestJSONService("worklink", "worklink", "2018-09-25")
const workmail = AWS.JSONService(
    "workmail", "workmail", "2017-10-01", "1.1", "WorkMailService"
)
const workmailmessageflow = AWS.RestJSONService(
    "workmailmessageflow", "workmailmessageflow", "2019-05-01"
)
const workspaces = AWS.JSONService(
    "workspaces", "workspaces", "2015-04-08", "1.1", "WorkspacesService"
)
const workspaces_thin_client = AWS.RestJSONService("thinclient", "thinclient", "2023-08-22")
const workspaces_web = AWS.RestJSONService("workspaces-web", "workspaces-web", "2020-07-08")
const xray = AWS.RestJSONService("xray", "xray", "2016-04-12")

end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: internetmonitor
using AWS.Compat
using AWS.UUIDs

"""
    create_monitor(monitor_name)
    create_monitor(monitor_name, params::Dict{String,<:Any})

Creates a monitor in Amazon CloudWatch Internet Monitor. A monitor is built based on
information from the application resources that you add: VPCs, Network Load Balancers
(NLBs), Amazon CloudFront distributions, and Amazon WorkSpaces directories. Internet
Monitor then publishes internet measurements from Amazon Web Services that are specific to
the city-networks. That is, the locations and ASNs (typically internet service providers or
ISPs), where clients access your application. For more information, see Using Amazon
CloudWatch Internet Monitor in the Amazon CloudWatch User Guide. When you create a monitor,
you choose the percentage of traffic that you want to monitor. You can also set a maximum
limit for the number of city-networks where client traffic is monitored, that caps the
total traffic that Internet Monitor monitors. A city-network maximum is the limit of
city-networks, but you only pay for the number of city-networks that are actually
monitored. You can update your monitor at any time to change the percentage of traffic to
monitor or the city-networks maximum. For more information, see Choosing a city-network
maximum value in the Amazon CloudWatch User Guide.

# Arguments
- `monitor_name`: The name of the monitor.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: A unique, case-sensitive string of up to 64 ASCII characters that you
  specify to make an idempotent API request. Don't reuse the same client token for other API
  requests.
- `"HealthEventsConfig"`: Defines the threshold percentages and other configuration
  information for when Amazon CloudWatch Internet Monitor creates a health event. Internet
  Monitor creates a health event when an internet issue that affects your application end
  users has a health score percentage that is at or below a specific threshold, and,
  sometimes, when other criteria are met. If you don't set a health event threshold, the
  default value is 95%. For more information, see  Change health event thresholds in the
  Internet Monitor section of the CloudWatch User Guide.
- `"InternetMeasurementsLogDelivery"`: Publish internet measurements for Internet Monitor
  to an Amazon S3 bucket in addition to CloudWatch Logs.
- `"MaxCityNetworksToMonitor"`: The maximum number of city-networks to monitor for your
  resources. A city-network is the location (city) where clients access your application
  resources from and the ASN or network provider, such as an internet service provider (ISP),
  that clients access the resources through. Setting this limit can help control billing
  costs. To learn more, see Choosing a city-network maximum value  in the Amazon CloudWatch
  Internet Monitor section of the CloudWatch User Guide.
- `"Resources"`: The resources to include in a monitor, which you provide as a set of
  Amazon Resource Names (ARNs). Resources can be VPCs, NLBs, Amazon CloudFront distributions,
  or Amazon WorkSpaces directories. You can add a combination of VPCs and CloudFront
  distributions, or you can add WorkSpaces directories, or you can add NLBs. You can't add
  NLBs or WorkSpaces directories together with any other resources.  If you add only Amazon
  VPC resources, at least one VPC must have an Internet Gateway attached to it, to make sure
  that it has internet connectivity.
- `"Tags"`: The tags for a monitor. You can add a maximum of 50 tags in Internet Monitor.
- `"TrafficPercentageToMonitor"`: The percentage of the internet-facing traffic for your
  application that you want to monitor with this monitor. If you set a city-networks maximum,
  that limit overrides the traffic percentage that you set. To learn more, see Choosing an
  application traffic percentage to monitor  in the Amazon CloudWatch Internet Monitor
  section of the CloudWatch User Guide.
"""
function create_monitor(MonitorName; aws_config::AbstractAWSConfig=current_aws_config())
    return internetmonitor(
        "POST",
        "/v20210603/Monitors",
        Dict{String,Any}("MonitorName" => MonitorName, "ClientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_monitor(
    MonitorName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return internetmonitor(
        "POST",
        "/v20210603/Monitors",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "MonitorName" => MonitorName, "ClientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_monitor(monitor_name)
    delete_monitor(monitor_name, params::Dict{String,<:Any})

Deletes a monitor in Amazon CloudWatch Internet Monitor.

# Arguments
- `monitor_name`: The name of the monitor to delete.

"""
function delete_monitor(MonitorName; aws_config::AbstractAWSConfig=current_aws_config())
    return internetmonitor(
        "DELETE",
        "/v20210603/Monitors/$(MonitorName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_monitor(
    MonitorName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return internetmonitor(
        "DELETE",
        "/v20210603/Monitors/$(MonitorName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_health_event(event_id, monitor_name)
    get_health_event(event_id, monitor_name, params::Dict{String,<:Any})

Gets information that Amazon CloudWatch Internet Monitor has created and stored about a
health event for a specified monitor. This information includes the impacted locations, and
all the information related to the event, by location. The information returned includes
the impact on performance, availability, and round-trip time, information about the network
providers (ASNs), the event type, and so on. Information rolled up at the global traffic
level is also returned, including the impact type and total traffic impact.

# Arguments
- `event_id`: The internally-generated identifier of a health event. Because EventID
  contains the forward slash (“/”) character, you must URL-encode the EventID field in
  the request URL.
- `monitor_name`: The name of the monitor.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"LinkedAccountId"`: The account ID for an account that you've set up cross-account
  sharing for in Amazon CloudWatch Internet Monitor. You configure cross-account sharing by
  using Amazon CloudWatch Observability Access Manager. For more information, see Internet
  Monitor cross-account observability in the Amazon CloudWatch Internet Monitor User Guide.
"""
function get_health_event(
    EventId, MonitorName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return internetmonitor(
        "GET",
        "/v20210603/Monitors/$(MonitorName)/HealthEvents/$(EventId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_health_event(
    EventId,
    MonitorName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return internetmonitor(
        "GET",
        "/v20210603/Monitors/$(MonitorName)/HealthEvents/$(EventId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_internet_event(event_id)
    get_internet_event(event_id, params::Dict{String,<:Any})

Gets information that Amazon CloudWatch Internet Monitor has generated about an internet
event. Internet Monitor displays information about recent global health events, called
internet events, on a global outages map that is available to all Amazon Web Services
customers.  The information returned here includes the impacted location, when the event
started and (if the event is over) ended, the type of event (PERFORMANCE or AVAILABILITY),
and the status (ACTIVE or RESOLVED).

# Arguments
- `event_id`: The EventId of the internet event to return information for.

"""
function get_internet_event(EventId; aws_config::AbstractAWSConfig=current_aws_config())
    return internetmonitor(
        "GET",
        "/v20210603/InternetEvents/$(EventId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_internet_event(
    EventId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return internetmonitor(
        "GET",
        "/v20210603/InternetEvents/$(EventId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_monitor(monitor_name)
    get_monitor(monitor_name, params::Dict{String,<:Any})

Gets information about a monitor in Amazon CloudWatch Internet Monitor based on a monitor
name. The information returned includes the Amazon Resource Name (ARN), create time,
modified time, resources included in the monitor, and status information.

# Arguments
- `monitor_name`: The name of the monitor.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"LinkedAccountId"`: The account ID for an account that you've set up cross-account
  sharing for in Amazon CloudWatch Internet Monitor. You configure cross-account sharing by
  using Amazon CloudWatch Observability Access Manager. For more information, see Internet
  Monitor cross-account observability in the Amazon CloudWatch Internet Monitor User Guide.
"""
function get_monitor(MonitorName; aws_config::AbstractAWSConfig=current_aws_config())
    return internetmonitor(
        "GET",
        "/v20210603/Monitors/$(MonitorName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_monitor(
    MonitorName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return internetmonitor(
        "GET",
        "/v20210603/Monitors/$(MonitorName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_query_results(monitor_name, query_id)
    get_query_results(monitor_name, query_id, params::Dict{String,<:Any})

Return the data for a query with the Amazon CloudWatch Internet Monitor query interface.
Specify the query that you want to return results for by providing a QueryId and a monitor
name. For more information about using the query interface, including examples, see Using
the Amazon CloudWatch Internet Monitor query interface in the Amazon CloudWatch Internet
Monitor User Guide.

# Arguments
- `monitor_name`: The name of the monitor to return data for.
- `query_id`: The ID of the query that you want to return data results for. A QueryId is an
  internally-generated identifier for a specific query.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The number of query results that you want to return with this call.
- `"NextToken"`: The token for the next set of results. You receive this token from a
  previous call.
"""
function get_query_results(
    MonitorName, QueryId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return internetmonitor(
        "GET",
        "/v20210603/Monitors/$(MonitorName)/Queries/$(QueryId)/Results";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_query_results(
    MonitorName,
    QueryId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return internetmonitor(
        "GET",
        "/v20210603/Monitors/$(MonitorName)/Queries/$(QueryId)/Results",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_query_status(monitor_name, query_id)
    get_query_status(monitor_name, query_id, params::Dict{String,<:Any})

Returns the current status of a query for the Amazon CloudWatch Internet Monitor query
interface, for a specified query ID and monitor. When you run a query, check the status to
make sure that the query has SUCCEEDED before you review the results.    QUEUED: The query
is scheduled to run.    RUNNING: The query is in progress but not complete.    SUCCEEDED:
The query completed sucessfully.    FAILED: The query failed due to an error.    CANCELED:
The query was canceled.

# Arguments
- `monitor_name`: The name of the monitor.
- `query_id`: The ID of the query that you want to return the status for. A QueryId is an
  internally-generated dentifier for a specific query.

"""
function get_query_status(
    MonitorName, QueryId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return internetmonitor(
        "GET",
        "/v20210603/Monitors/$(MonitorName)/Queries/$(QueryId)/Status";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_query_status(
    MonitorName,
    QueryId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return internetmonitor(
        "GET",
        "/v20210603/Monitors/$(MonitorName)/Queries/$(QueryId)/Status",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_health_events(monitor_name)
    list_health_events(monitor_name, params::Dict{String,<:Any})

Lists all health events for a monitor in Amazon CloudWatch Internet Monitor. Returns
information for health events including the event start and end times, and the status.
Health events that have start times during the time frame that is requested are not
included in the list of health events.

# Arguments
- `monitor_name`: The name of the monitor.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EndTime"`: The time when a health event ended. If the health event is still ongoing,
  then the end time is not set.
- `"EventStatus"`: The status of a health event.
- `"LinkedAccountId"`: The account ID for an account that you've set up cross-account
  sharing for in Amazon CloudWatch Internet Monitor. You configure cross-account sharing by
  using Amazon CloudWatch Observability Access Manager. For more information, see Internet
  Monitor cross-account observability in the Amazon CloudWatch Internet Monitor User Guide.
- `"MaxResults"`: The number of health event objects that you want to return with this
  call.
- `"NextToken"`: The token for the next set of results. You receive this token from a
  previous call.
- `"StartTime"`: The time when a health event started.
"""
function list_health_events(MonitorName; aws_config::AbstractAWSConfig=current_aws_config())
    return internetmonitor(
        "GET",
        "/v20210603/Monitors/$(MonitorName)/HealthEvents";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_health_events(
    MonitorName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return internetmonitor(
        "GET",
        "/v20210603/Monitors/$(MonitorName)/HealthEvents",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_internet_events()
    list_internet_events(params::Dict{String,<:Any})

Lists internet events that cause performance or availability issues for client locations.
Amazon CloudWatch Internet Monitor displays information about recent global health events,
called internet events, on a global outages map that is available to all Amazon Web
Services customers.  You can constrain the list of internet events returned by providing a
start time and end time to define a total time frame for events you want to list. Both
start time and end time specify the time when an event started. End time is optional. If
you don't include it, the default end time is the current time. You can also limit the
events returned to a specific status (ACTIVE or RESOLVED) or type (PERFORMANCE or
AVAILABILITY).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EndTime"`: The end time of the time window that you want to get a list of internet
  events for.
- `"EventStatus"`: The status of an internet event.
- `"EventType"`: The type of network impairment.
- `"InternetEventMaxResults"`: The number of query results that you want to return with
  this call.
- `"NextToken"`: The token for the next set of results. You receive this token from a
  previous call.
- `"StartTime"`: The start time of the time window that you want to get a list of internet
  events for.
"""
function list_internet_events(; aws_config::AbstractAWSConfig=current_aws_config())
    return internetmonitor(
        "GET",
        "/v20210603/InternetEvents";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_internet_events(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return internetmonitor(
        "GET",
        "/v20210603/InternetEvents",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_monitors()
    list_monitors(params::Dict{String,<:Any})

Lists all of your monitors for Amazon CloudWatch Internet Monitor and their statuses, along
with the Amazon Resource Name (ARN) and name of each monitor.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"IncludeLinkedAccounts"`: A boolean option that you can set to TRUE to include monitors
  for linked accounts in a list of monitors, when you've set up cross-account sharing in
  Amazon CloudWatch Internet Monitor. You configure cross-account sharing by using Amazon
  CloudWatch Observability Access Manager. For more information, see Internet Monitor
  cross-account observability in the Amazon CloudWatch Internet Monitor User Guide.
- `"MaxResults"`: The number of monitor objects that you want to return with this call.
- `"MonitorStatus"`: The status of a monitor. This includes the status of the data
  processing for the monitor and the status of the monitor itself. For information about the
  statuses for a monitor, see  Monitor.
- `"NextToken"`: The token for the next set of results. You receive this token from a
  previous call.
"""
function list_monitors(; aws_config::AbstractAWSConfig=current_aws_config())
    return internetmonitor(
        "GET", "/v20210603/Monitors"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_monitors(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return internetmonitor(
        "GET",
        "/v20210603/Monitors",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists the tags for a resource. Tags are supported only for monitors in Amazon CloudWatch
Internet Monitor.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) for a resource.

"""
function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return internetmonitor(
        "GET",
        "/tags/$(ResourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return internetmonitor(
        "GET",
        "/tags/$(ResourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_query(end_time, monitor_name, query_type, start_time)
    start_query(end_time, monitor_name, query_type, start_time, params::Dict{String,<:Any})

Start a query to return data for a specific query type for the Amazon CloudWatch Internet
Monitor query interface. Specify a time period for the data that you want returned by using
StartTime and EndTime. You filter the query results to return by providing parameters that
you specify with FilterParameters. For more information about using the query interface,
including examples, see Using the Amazon CloudWatch Internet Monitor query interface in the
Amazon CloudWatch Internet Monitor User Guide.

# Arguments
- `end_time`: The timestamp that is the end of the period that you want to retrieve data
  for with your query.
- `monitor_name`: The name of the monitor to query.
- `query_type`: The type of query to run. The following are the three types of queries that
  you can run using the Internet Monitor query interface:    MEASUREMENTS: Provides
  availability score, performance score, total traffic, and round-trip times, at 5 minute
  intervals.    TOP_LOCATIONS: Provides availability score, performance score, total traffic,
  and time to first byte (TTFB) information, for the top location and ASN combinations that
  you're monitoring, by traffic volume.    TOP_LOCATION_DETAILS: Provides TTFB for Amazon
  CloudFront, your current configuration, and the best performing EC2 configuration, at 1
  hour intervals.   For lists of the fields returned with each query type and more
  information about how each type of query is performed, see  Using the Amazon CloudWatch
  Internet Monitor query interface in the Amazon CloudWatch Internet Monitor User Guide.
- `start_time`: The timestamp that is the beginning of the period that you want to retrieve
  data for with your query.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FilterParameters"`: The FilterParameters field that you use with Amazon CloudWatch
  Internet Monitor queries is a string the defines how you want a query to be filtered. The
  filter parameters that you can specify depend on the query type, since each query type
  returns a different set of Internet Monitor data. For more information about specifying
  filter parameters, see Using the Amazon CloudWatch Internet Monitor query interface in the
  Amazon CloudWatch Internet Monitor User Guide.
- `"LinkedAccountId"`: The account ID for an account that you've set up cross-account
  sharing for in Amazon CloudWatch Internet Monitor. You configure cross-account sharing by
  using Amazon CloudWatch Observability Access Manager. For more information, see Internet
  Monitor cross-account observability in the Amazon CloudWatch Internet Monitor User Guide.
"""
function start_query(
    EndTime,
    MonitorName,
    QueryType,
    StartTime;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return internetmonitor(
        "POST",
        "/v20210603/Monitors/$(MonitorName)/Queries",
        Dict{String,Any}(
            "EndTime" => EndTime, "QueryType" => QueryType, "StartTime" => StartTime
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_query(
    EndTime,
    MonitorName,
    QueryType,
    StartTime,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return internetmonitor(
        "POST",
        "/v20210603/Monitors/$(MonitorName)/Queries",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EndTime" => EndTime, "QueryType" => QueryType, "StartTime" => StartTime
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_query(monitor_name, query_id)
    stop_query(monitor_name, query_id, params::Dict{String,<:Any})

Stop a query that is progress for a specific monitor.

# Arguments
- `monitor_name`: The name of the monitor.
- `query_id`: The ID of the query that you want to stop. A QueryId is an
  internally-generated identifier for a specific query.

"""
function stop_query(
    MonitorName, QueryId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return internetmonitor(
        "DELETE",
        "/v20210603/Monitors/$(MonitorName)/Queries/$(QueryId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_query(
    MonitorName,
    QueryId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return internetmonitor(
        "DELETE",
        "/v20210603/Monitors/$(MonitorName)/Queries/$(QueryId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds a tag to a resource. Tags are supported only for monitors in Amazon CloudWatch
Internet Monitor. You can add a maximum of 50 tags in Internet Monitor. A minimum of one
tag is required for this call. It returns an error if you use the TagResource request with
0 tags.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) for a tag that you add to a resource. Tags
  are supported only for monitors in Amazon CloudWatch Internet Monitor.
- `tags`: Tags that you add to a resource. You can add a maximum of 50 tags in Internet
  Monitor.

"""
function tag_resource(ResourceArn, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return internetmonitor(
        "POST",
        "/tags/$(ResourceArn)",
        Dict{String,Any}("Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceArn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return internetmonitor(
        "POST",
        "/tags/$(ResourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Tags" => Tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes a tag from a resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) for a tag you remove a resource from.
- `tag_keys`: Tag keys that you remove from a resource.

"""
function untag_resource(
    ResourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return internetmonitor(
        "DELETE",
        "/tags/$(ResourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return internetmonitor(
        "DELETE",
        "/tags/$(ResourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_monitor(monitor_name)
    update_monitor(monitor_name, params::Dict{String,<:Any})

Updates a monitor. You can update a monitor to change the percentage of traffic to monitor
or the maximum number of city-networks (locations and ASNs), to add or remove resources, or
to change the status of the monitor. Note that you can't change the name of a monitor. The
city-network maximum that you choose is the limit, but you only pay for the number of
city-networks that are actually monitored. For more information, see Choosing a
city-network maximum value in the Amazon CloudWatch User Guide.

# Arguments
- `monitor_name`: The name of the monitor.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: A unique, case-sensitive string of up to 64 ASCII characters that you
  specify to make an idempotent API request. You should not reuse the same client token for
  other API requests.
- `"HealthEventsConfig"`: The list of health score thresholds. A threshold percentage for
  health scores, along with other configuration information, determines when Internet Monitor
  creates a health event when there's an internet issue that affects your application end
  users. For more information, see  Change health event thresholds in the Internet Monitor
  section of the CloudWatch User Guide.
- `"InternetMeasurementsLogDelivery"`: Publish internet measurements for Internet Monitor
  to another location, such as an Amazon S3 bucket. The measurements are also published to
  Amazon CloudWatch Logs.
- `"MaxCityNetworksToMonitor"`: The maximum number of city-networks to monitor for your
  application. A city-network is the location (city) where clients access your application
  resources from and the ASN or network provider, such as an internet service provider (ISP),
  that clients access the resources through. Setting this limit can help control billing
  costs.
- `"ResourcesToAdd"`: The resources to include in a monitor, which you provide as a set of
  Amazon Resource Names (ARNs). Resources can be VPCs, NLBs, Amazon CloudFront distributions,
  or Amazon WorkSpaces directories. You can add a combination of VPCs and CloudFront
  distributions, or you can add WorkSpaces directories, or you can add NLBs. You can't add
  NLBs or WorkSpaces directories together with any other resources.  If you add only Amazon
  Virtual Private Clouds resources, at least one VPC must have an Internet Gateway attached
  to it, to make sure that it has internet connectivity.
- `"ResourcesToRemove"`: The resources to remove from a monitor, which you provide as a set
  of Amazon Resource Names (ARNs).
- `"Status"`: The status for a monitor. The accepted values for Status with the
  UpdateMonitor API call are the following: ACTIVE and INACTIVE. The following values are not
  accepted: PENDING, and ERROR.
- `"TrafficPercentageToMonitor"`: The percentage of the internet-facing traffic for your
  application that you want to monitor with this monitor. If you set a city-networks maximum,
  that limit overrides the traffic percentage that you set. To learn more, see Choosing an
  application traffic percentage to monitor  in the Amazon CloudWatch Internet Monitor
  section of the CloudWatch User Guide.
"""
function update_monitor(MonitorName; aws_config::AbstractAWSConfig=current_aws_config())
    return internetmonitor(
        "PATCH",
        "/v20210603/Monitors/$(MonitorName)",
        Dict{String,Any}("ClientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_monitor(
    MonitorName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return internetmonitor(
        "PATCH",
        "/v20210603/Monitors/$(MonitorName)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ClientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: iot_1click_devices_service
using AWS.Compat
using AWS.UUIDs

"""
    claim_devices_by_claim_code(claim_code)
    claim_devices_by_claim_code(claim_code, params::Dict{String,<:Any})

Adds device(s) to your account (i.e., claim one or more devices) if and only if you
received a claim code with the device(s).

# Arguments
- `claim_code`: The claim code, starting with \"C-\", as provided by the device
  manufacturer.

"""
function claim_devices_by_claim_code(
    claimCode; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_1click_devices_service(
        "PUT",
        "/claims/$(claimCode)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function claim_devices_by_claim_code(
    claimCode,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_1click_devices_service(
        "PUT",
        "/claims/$(claimCode)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_device(device_id)
    describe_device(device_id, params::Dict{String,<:Any})

Given a device ID, returns a DescribeDeviceResponse object describing the
 details of the
device.

# Arguments
- `device_id`: The unique identifier of the device.

"""
function describe_device(deviceId; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_1click_devices_service(
        "GET",
        "/devices/$(deviceId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_device(
    deviceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_1click_devices_service(
        "GET",
        "/devices/$(deviceId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    finalize_device_claim(device_id)
    finalize_device_claim(device_id, params::Dict{String,<:Any})

Given a device ID, finalizes the claim request for the associated device.
 Claiming a
device consists of initiating a claim, then publishing a device event,
 and finalizing the
claim. For a device of type button, a device event can
 be published by simply clicking the
device.

# Arguments
- `device_id`: The unique identifier of the device.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tags"`: A collection of key/value pairs defining the resource tags. For example, {
  \"tags\": {\"key1\": \"value1\", \"key2\": \"value2\"} }. For more information, see AWS
  Tagging Strategies.
"""
function finalize_device_claim(deviceId; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_1click_devices_service(
        "PUT",
        "/devices/$(deviceId)/finalize-claim";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function finalize_device_claim(
    deviceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_1click_devices_service(
        "PUT",
        "/devices/$(deviceId)/finalize-claim",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_device_methods(device_id)
    get_device_methods(device_id, params::Dict{String,<:Any})

Given a device ID, returns the invokable methods associated with the device.

# Arguments
- `device_id`: The unique identifier of the device.

"""
function get_device_methods(deviceId; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_1click_devices_service(
        "GET",
        "/devices/$(deviceId)/methods";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_device_methods(
    deviceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_1click_devices_service(
        "GET",
        "/devices/$(deviceId)/methods",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    initiate_device_claim(device_id)
    initiate_device_claim(device_id, params::Dict{String,<:Any})

Given a device ID, initiates a claim request for the associated device.
 Claiming a device
consists of initiating a claim, then publishing a device event,
 and finalizing the claim.
For a device of type button, a device event can
 be published by simply clicking the
device.

# Arguments
- `device_id`: The unique identifier of the device.

"""
function initiate_device_claim(deviceId; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_1click_devices_service(
        "PUT",
        "/devices/$(deviceId)/initiate-claim";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function initiate_device_claim(
    deviceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_1click_devices_service(
        "PUT",
        "/devices/$(deviceId)/initiate-claim",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    invoke_device_method(device_id)
    invoke_device_method(device_id, params::Dict{String,<:Any})

Given a device ID, issues a request to invoke a named device method (with possible
parameters). See the \"Example POST\" code snippet below.

# Arguments
- `device_id`: The unique identifier of the device.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"deviceMethod"`: The device method to invoke.
- `"deviceMethodParameters"`: A JSON encoded string containing the device method request
  parameters.
"""
function invoke_device_method(deviceId; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_1click_devices_service(
        "POST",
        "/devices/$(deviceId)/methods";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function invoke_device_method(
    deviceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_1click_devices_service(
        "POST",
        "/devices/$(deviceId)/methods",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_device_events(device_id, from_time_stamp, to_time_stamp)
    list_device_events(device_id, from_time_stamp, to_time_stamp, params::Dict{String,<:Any})

Using a device ID, returns a DeviceEventsResponse object containing an
 array of events for
the device.

# Arguments
- `device_id`: The unique identifier of the device.
- `from_time_stamp`: The start date for the device event query, in ISO8061 format. For
  example,
 2018-03-28T15:45:12.880Z
- `to_time_stamp`: The end date for the device event query, in ISO8061 format. For
  example,
 2018-03-28T15:45:12.880Z

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return per request. If not set, a
  default value of
 100 is used.
- `"nextToken"`: The token to retrieve the next set of results.
"""
function list_device_events(
    deviceId, fromTimeStamp, toTimeStamp; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_1click_devices_service(
        "GET",
        "/devices/$(deviceId)/events",
        Dict{String,Any}("fromTimeStamp" => fromTimeStamp, "toTimeStamp" => toTimeStamp);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_device_events(
    deviceId,
    fromTimeStamp,
    toTimeStamp,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_1click_devices_service(
        "GET",
        "/devices/$(deviceId)/events",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "fromTimeStamp" => fromTimeStamp, "toTimeStamp" => toTimeStamp
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_devices()
    list_devices(params::Dict{String,<:Any})

Lists the 1-Click compatible devices associated with your AWS account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"deviceType"`: The type of the device, such as \"button\".
- `"maxResults"`: The maximum number of results to return per request. If not set, a
  default value of
 100 is used.
- `"nextToken"`: The token to retrieve the next set of results.
"""
function list_devices(; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_1click_devices_service(
        "GET", "/devices"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_devices(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_1click_devices_service(
        "GET", "/devices", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource-arn)
    list_tags_for_resource(resource-arn, params::Dict{String,<:Any})

Lists the tags associated with the specified resource ARN.

# Arguments
- `resource-arn`: The ARN of the resource.

"""
function list_tags_for_resource(
    resource_arn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_1click_devices_service(
        "GET",
        "/tags/$(resource-arn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resource_arn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_1click_devices_service(
        "GET",
        "/tags/$(resource-arn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource-arn, tags)
    tag_resource(resource-arn, tags, params::Dict{String,<:Any})

Adds or updates the tags associated with the resource ARN. See AWS IoT 1-Click Service
Limits for the maximum number of tags allowed per
 resource.

# Arguments
- `resource-arn`: The ARN of the resource.
- `tags`: A collection of key/value pairs defining the resource tags. For example, {
  \"tags\": {\"key1\": \"value1\", \"key2\": \"value2\"} }. For more information, see AWS
  Tagging Strategies.

"""
function tag_resource(
    resource_arn, tags; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_1click_devices_service(
        "POST",
        "/tags/$(resource-arn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resource_arn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_1click_devices_service(
        "POST",
        "/tags/$(resource-arn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    unclaim_device(device_id)
    unclaim_device(device_id, params::Dict{String,<:Any})

Disassociates a device from your AWS account using its device ID.

# Arguments
- `device_id`: The unique identifier of the device.

"""
function unclaim_device(deviceId; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_1click_devices_service(
        "PUT",
        "/devices/$(deviceId)/unclaim";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function unclaim_device(
    deviceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_1click_devices_service(
        "PUT",
        "/devices/$(deviceId)/unclaim",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource-arn, tag_keys)
    untag_resource(resource-arn, tag_keys, params::Dict{String,<:Any})

Using tag keys, deletes the tags (key/value pairs) associated with the specified
 resource
ARN.

# Arguments
- `resource-arn`: The ARN of the resource.
- `tag_keys`: A collections of tag keys. For example, {\"key1\",\"key2\"}

"""
function untag_resource(
    resource_arn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_1click_devices_service(
        "DELETE",
        "/tags/$(resource-arn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resource_arn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_1click_devices_service(
        "DELETE",
        "/tags/$(resource-arn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_device_state(device_id)
    update_device_state(device_id, params::Dict{String,<:Any})

Using a Boolean value (true or false), this operation
 enables or disables the device given
a device ID.

# Arguments
- `device_id`: The unique identifier of the device.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"enabled"`: If true, the device is enabled. If false, the device is
 disabled.
"""
function update_device_state(deviceId; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_1click_devices_service(
        "PUT",
        "/devices/$(deviceId)/state";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_device_state(
    deviceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_1click_devices_service(
        "PUT",
        "/devices/$(deviceId)/state",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: codestar
using AWS.Compat
using AWS.UUIDs

"""
    associate_team_member(project_id, project_role, user_arn)
    associate_team_member(project_id, project_role, user_arn, params::Dict{String,<:Any})

Adds an IAM user to the team for an AWS CodeStar project.

# Arguments
- `project_id`: The ID of the project to which you will add the IAM user.
- `project_role`: The AWS CodeStar project role that will apply to this user. This role
  determines what actions a user can take in an AWS CodeStar project.
- `user_arn`: The Amazon Resource Name (ARN) for the IAM user you want to add to the AWS
  CodeStar project.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientRequestToken"`: A user- or system-generated token that identifies the entity that
  requested the team member association to the project. This token can be used to repeat the
  request.
- `"remoteAccessAllowed"`: Whether the team member is allowed to use an SSH public/private
  key pair to remotely access project resources, for example Amazon EC2 instances.
"""
function associate_team_member(
    projectId, projectRole, userArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codestar(
        "AssociateTeamMember",
        Dict{String,Any}(
            "projectId" => projectId, "projectRole" => projectRole, "userArn" => userArn
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_team_member(
    projectId,
    projectRole,
    userArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codestar(
        "AssociateTeamMember",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "projectId" => projectId,
                    "projectRole" => projectRole,
                    "userArn" => userArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_project(id, name)
    create_project(id, name, params::Dict{String,<:Any})

Creates a project, including project resources. This action creates a project based on a
submitted project request. A set of source code files and a toolchain template file can be
included with the project request. If these are not provided, an empty project is created.

# Arguments
- `id`: The ID of the project to be created in AWS CodeStar.
- `name`: The display name for the project to be created in AWS CodeStar.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientRequestToken"`: A user- or system-generated token that identifies the entity that
  requested project creation. This token can be used to repeat the request.
- `"description"`: The description of the project, if any.
- `"sourceCode"`: A list of the Code objects submitted with the project request. If this
  parameter is specified, the request must also include the toolchain parameter.
- `"tags"`: The tags created for the project.
- `"toolchain"`: The name of the toolchain template file submitted with the project
  request. If this parameter is specified, the request must also include the sourceCode
  parameter.
"""
function create_project(id, name; aws_config::AbstractAWSConfig=current_aws_config())
    return codestar(
        "CreateProject",
        Dict{String,Any}("id" => id, "name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_project(
    id,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codestar(
        "CreateProject",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("id" => id, "name" => name), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_user_profile(display_name, email_address, user_arn)
    create_user_profile(display_name, email_address, user_arn, params::Dict{String,<:Any})

Creates a profile for a user that includes user preferences, such as the display name and
email address assocciated with the user, in AWS CodeStar. The user profile is not
project-specific. Information in the user profile is displayed wherever the user's
information appears to other users in AWS CodeStar.

# Arguments
- `display_name`: The name that will be displayed as the friendly name for the user in AWS
  CodeStar.
- `email_address`: The email address that will be displayed as part of the user's profile
  in AWS CodeStar.
- `user_arn`: The Amazon Resource Name (ARN) of the user in IAM.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"sshPublicKey"`: The SSH public key associated with the user in AWS CodeStar. If a
  project owner allows the user remote access to project resources, this public key will be
  used along with the user's private key for SSH access.
"""
function create_user_profile(
    displayName, emailAddress, userArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codestar(
        "CreateUserProfile",
        Dict{String,Any}(
            "displayName" => displayName,
            "emailAddress" => emailAddress,
            "userArn" => userArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_user_profile(
    displayName,
    emailAddress,
    userArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codestar(
        "CreateUserProfile",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "displayName" => displayName,
                    "emailAddress" => emailAddress,
                    "userArn" => userArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_project(id)
    delete_project(id, params::Dict{String,<:Any})

Deletes a project, including project resources. Does not delete users associated with the
project, but does delete the IAM roles that allowed access to the project.

# Arguments
- `id`: The ID of the project to be deleted in AWS CodeStar.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientRequestToken"`: A user- or system-generated token that identifies the entity that
  requested project deletion. This token can be used to repeat the request.
- `"deleteStack"`: Whether to send a delete request for the primary stack in AWS
  CloudFormation originally used to generate the project and its resources. This option will
  delete all AWS resources for the project (except for any buckets in Amazon S3) as well as
  deleting the project itself. Recommended for most use cases.
"""
function delete_project(id; aws_config::AbstractAWSConfig=current_aws_config())
    return codestar(
        "DeleteProject",
        Dict{String,Any}("id" => id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_project(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codestar(
        "DeleteProject",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("id" => id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_user_profile(user_arn)
    delete_user_profile(user_arn, params::Dict{String,<:Any})

Deletes a user profile in AWS CodeStar, including all personal preference data associated
with that profile, such as display name and email address. It does not delete the history
of that user, for example the history of commits made by that user.

# Arguments
- `user_arn`: The Amazon Resource Name (ARN) of the user to delete from AWS CodeStar.

"""
function delete_user_profile(userArn; aws_config::AbstractAWSConfig=current_aws_config())
    return codestar(
        "DeleteUserProfile",
        Dict{String,Any}("userArn" => userArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_user_profile(
    userArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codestar(
        "DeleteUserProfile",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("userArn" => userArn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_project(id)
    describe_project(id, params::Dict{String,<:Any})

Describes a project and its resources.

# Arguments
- `id`: The ID of the project.

"""
function describe_project(id; aws_config::AbstractAWSConfig=current_aws_config())
    return codestar(
        "DescribeProject",
        Dict{String,Any}("id" => id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_project(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codestar(
        "DescribeProject",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("id" => id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_user_profile(user_arn)
    describe_user_profile(user_arn, params::Dict{String,<:Any})

Describes a user in AWS CodeStar and the user attributes across all projects.

# Arguments
- `user_arn`: The Amazon Resource Name (ARN) of the user.

"""
function describe_user_profile(userArn; aws_config::AbstractAWSConfig=current_aws_config())
    return codestar(
        "DescribeUserProfile",
        Dict{String,Any}("userArn" => userArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_user_profile(
    userArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codestar(
        "DescribeUserProfile",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("userArn" => userArn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_team_member(project_id, user_arn)
    disassociate_team_member(project_id, user_arn, params::Dict{String,<:Any})

Removes a user from a project. Removing a user from a project also removes the IAM policies
from that user that allowed access to the project and its resources. Disassociating a team
member does not remove that user's profile from AWS CodeStar. It does not remove the user
from IAM.

# Arguments
- `project_id`: The ID of the AWS CodeStar project from which you want to remove a team
  member.
- `user_arn`: The Amazon Resource Name (ARN) of the IAM user or group whom you want to
  remove from the project.

"""
function disassociate_team_member(
    projectId, userArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codestar(
        "DisassociateTeamMember",
        Dict{String,Any}("projectId" => projectId, "userArn" => userArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_team_member(
    projectId,
    userArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codestar(
        "DisassociateTeamMember",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("projectId" => projectId, "userArn" => userArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_projects()
    list_projects(params::Dict{String,<:Any})

Lists all projects in AWS CodeStar associated with your AWS account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum amount of data that can be contained in a single set of
  results.
- `"nextToken"`: The continuation token to be used to return the next set of results, if
  the results cannot be returned in one response.
"""
function list_projects(; aws_config::AbstractAWSConfig=current_aws_config())
    return codestar("ListProjects"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_projects(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codestar(
        "ListProjects", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_resources(project_id)
    list_resources(project_id, params::Dict{String,<:Any})

Lists resources associated with a project in AWS CodeStar.

# Arguments
- `project_id`: The ID of the project.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum amount of data that can be contained in a single set of
  results.
- `"nextToken"`: The continuation token for the next set of results, if the results cannot
  be returned in one response.
"""
function list_resources(projectId; aws_config::AbstractAWSConfig=current_aws_config())
    return codestar(
        "ListResources",
        Dict{String,Any}("projectId" => projectId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_resources(
    projectId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codestar(
        "ListResources",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("projectId" => projectId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_project(id)
    list_tags_for_project(id, params::Dict{String,<:Any})

Gets the tags for a project.

# Arguments
- `id`: The ID of the project to get tags for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Reserved for future use.
- `"nextToken"`: Reserved for future use.
"""
function list_tags_for_project(id; aws_config::AbstractAWSConfig=current_aws_config())
    return codestar(
        "ListTagsForProject",
        Dict{String,Any}("id" => id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_project(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codestar(
        "ListTagsForProject",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("id" => id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_team_members(project_id)
    list_team_members(project_id, params::Dict{String,<:Any})

Lists all team members associated with a project.

# Arguments
- `project_id`: The ID of the project for which you want to list team members.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of team members you want returned in a response.
- `"nextToken"`: The continuation token for the next set of results, if the results cannot
  be returned in one response.
"""
function list_team_members(projectId; aws_config::AbstractAWSConfig=current_aws_config())
    return codestar(
        "ListTeamMembers",
        Dict{String,Any}("projectId" => projectId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_team_members(
    projectId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codestar(
        "ListTeamMembers",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("projectId" => projectId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_user_profiles()
    list_user_profiles(params::Dict{String,<:Any})

Lists all the user profiles configured for your AWS account in AWS CodeStar.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in a response.
- `"nextToken"`: The continuation token for the next set of results, if the results cannot
  be returned in one response.
"""
function list_user_profiles(; aws_config::AbstractAWSConfig=current_aws_config())
    return codestar(
        "ListUserProfiles"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_user_profiles(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codestar(
        "ListUserProfiles", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    tag_project(id, tags)
    tag_project(id, tags, params::Dict{String,<:Any})

Adds tags to a project.

# Arguments
- `id`: The ID of the project you want to add a tag to.
- `tags`: The tags you want to add to the project.

"""
function tag_project(id, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return codestar(
        "TagProject",
        Dict{String,Any}("id" => id, "tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_project(
    id,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codestar(
        "TagProject",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("id" => id, "tags" => tags), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_project(id, tags)
    untag_project(id, tags, params::Dict{String,<:Any})

Removes tags from a project.

# Arguments
- `id`: The ID of the project to remove tags from.
- `tags`: The tags to remove from the project.

"""
function untag_project(id, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return codestar(
        "UntagProject",
        Dict{String,Any}("id" => id, "tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_project(
    id,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codestar(
        "UntagProject",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("id" => id, "tags" => tags), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_project(id)
    update_project(id, params::Dict{String,<:Any})

Updates a project in AWS CodeStar.

# Arguments
- `id`: The ID of the project you want to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description of the project, if any.
- `"name"`: The name of the project you want to update.
"""
function update_project(id; aws_config::AbstractAWSConfig=current_aws_config())
    return codestar(
        "UpdateProject",
        Dict{String,Any}("id" => id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_project(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codestar(
        "UpdateProject",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("id" => id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_team_member(project_id, user_arn)
    update_team_member(project_id, user_arn, params::Dict{String,<:Any})

Updates a team member's attributes in an AWS CodeStar project. For example, you can change
a team member's role in the project, or change whether they have remote access to project
resources.

# Arguments
- `project_id`: The ID of the project.
- `user_arn`: The Amazon Resource Name (ARN) of the user for whom you want to change team
  membership attributes.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"projectRole"`: The role assigned to the user in the project. Project roles have
  different levels of access. For more information, see Working with Teams in the AWS
  CodeStar User Guide.
- `"remoteAccessAllowed"`: Whether a team member is allowed to remotely access project
  resources using the SSH public key associated with the user's profile. Even if this is set
  to True, the user must associate a public key with their profile before the user can access
  resources.
"""
function update_team_member(
    projectId, userArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codestar(
        "UpdateTeamMember",
        Dict{String,Any}("projectId" => projectId, "userArn" => userArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_team_member(
    projectId,
    userArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codestar(
        "UpdateTeamMember",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("projectId" => projectId, "userArn" => userArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_user_profile(user_arn)
    update_user_profile(user_arn, params::Dict{String,<:Any})

Updates a user's profile in AWS CodeStar. The user profile is not project-specific.
Information in the user profile is displayed wherever the user's information appears to
other users in AWS CodeStar.

# Arguments
- `user_arn`: The name that will be displayed as the friendly name for the user in AWS
  CodeStar.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"displayName"`: The name that is displayed as the friendly name for the user in AWS
  CodeStar.
- `"emailAddress"`: The email address that is displayed as part of the user's profile in
  AWS CodeStar.
- `"sshPublicKey"`: The SSH public key associated with the user in AWS CodeStar. If a
  project owner allows the user remote access to project resources, this public key will be
  used along with the user's private key for SSH access.
"""
function update_user_profile(userArn; aws_config::AbstractAWSConfig=current_aws_config())
    return codestar(
        "UpdateUserProfile",
        Dict{String,Any}("userArn" => userArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_user_profile(
    userArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codestar(
        "UpdateUserProfile",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("userArn" => userArn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: pca_connector_scep
using AWS.Compat
using AWS.UUIDs

"""
    create_challenge(connector_arn)
    create_challenge(connector_arn, params::Dict{String,<:Any})

For general-purpose connectors. Creates a challenge password for the specified connector.
The SCEP protocol uses a challenge password to authenticate a request before issuing a
certificate from a certificate authority (CA). Your SCEP clients include the challenge
password as part of their certificate request to Connector for SCEP. To retrieve the
connector Amazon Resource Names (ARNs) for the connectors in your account, call
ListConnectors. To create additional challenge passwords for the connector, call
CreateChallenge again. We recommend frequently rotating your challenge passwords.

# Arguments
- `connector_arn`: The Amazon Resource Name (ARN) of the connector that you want to create
  a challenge for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: Custom string that can be used to distinguish between calls to the
  CreateChallenge action. Client tokens for CreateChallenge time out after five minutes.
  Therefore, if you call CreateChallenge multiple times with the same client token within
  five minutes, Connector for SCEP recognizes that you are requesting only one challenge and
  will only respond with one. If you change the client token for each call, Connector for
  SCEP recognizes that you are requesting multiple challenge passwords.
- `"Tags"`: The key-value pairs to associate with the resource.
"""
function create_challenge(ConnectorArn; aws_config::AbstractAWSConfig=current_aws_config())
    return pca_connector_scep(
        "POST",
        "/challenges",
        Dict{String,Any}("ConnectorArn" => ConnectorArn, "ClientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_challenge(
    ConnectorArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pca_connector_scep(
        "POST",
        "/challenges",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ConnectorArn" => ConnectorArn, "ClientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_connector(certificate_authority_arn)
    create_connector(certificate_authority_arn, params::Dict{String,<:Any})

Creates a SCEP connector. A SCEP connector links Amazon Web Services Private Certificate
Authority to your SCEP-compatible devices and mobile device management (MDM) systems.
Before you create a connector, you must complete a set of prerequisites, including creation
of a private certificate authority (CA) to use with this connector. For more information,
see Connector for SCEP prerequisites.

# Arguments
- `certificate_authority_arn`: The Amazon Resource Name (ARN) of the Amazon Web Services
  Private Certificate Authority certificate authority to use with this connector. Due to
  security vulnerabilities present in the SCEP protocol, we recommend using a private CA
  that's dedicated for use with the connector. To retrieve the private CAs associated with
  your account, you can call ListCertificateAuthorities using the Amazon Web Services Private
  CA API.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: Custom string that can be used to distinguish between calls to the
  CreateChallenge action. Client tokens for CreateChallenge time out after five minutes.
  Therefore, if you call CreateChallenge multiple times with the same client token within
  five minutes, Connector for SCEP recognizes that you are requesting only one challenge and
  will only respond with one. If you change the client token for each call, Connector for
  SCEP recognizes that you are requesting multiple challenge passwords.
- `"MobileDeviceManagement"`: If you don't supply a value, by default Connector for SCEP
  creates a connector for general-purpose use. A general-purpose connector is designed to
  work with clients or endpoints that support the SCEP protocol, except Connector for SCEP
  for Microsoft Intune. With connectors for general-purpose use, you manage SCEP challenge
  passwords using Connector for SCEP. For information about considerations and limitations
  with using Connector for SCEP, see Considerations and Limitations. If you provide an
  IntuneConfiguration, Connector for SCEP creates a connector for use with Microsoft Intune,
  and you manage the challenge passwords using Microsoft Intune. For more information, see
  Using Connector for SCEP for Microsoft Intune.
- `"Tags"`: The key-value pairs to associate with the resource.
"""
function create_connector(
    CertificateAuthorityArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pca_connector_scep(
        "POST",
        "/connectors",
        Dict{String,Any}(
            "CertificateAuthorityArn" => CertificateAuthorityArn,
            "ClientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_connector(
    CertificateAuthorityArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pca_connector_scep(
        "POST",
        "/connectors",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CertificateAuthorityArn" => CertificateAuthorityArn,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_challenge(challenge_arn)
    delete_challenge(challenge_arn, params::Dict{String,<:Any})

Deletes the specified Challenge.

# Arguments
- `challenge_arn`: The Amazon Resource Name (ARN) of the challenge password to delete.

"""
function delete_challenge(ChallengeArn; aws_config::AbstractAWSConfig=current_aws_config())
    return pca_connector_scep(
        "DELETE",
        "/challenges/$(ChallengeArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_challenge(
    ChallengeArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pca_connector_scep(
        "DELETE",
        "/challenges/$(ChallengeArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_connector(connector_arn)
    delete_connector(connector_arn, params::Dict{String,<:Any})

Deletes the specified Connector. This operation also deletes any challenges associated with
the connector.

# Arguments
- `connector_arn`: The Amazon Resource Name (ARN) of the connector to delete.

"""
function delete_connector(ConnectorArn; aws_config::AbstractAWSConfig=current_aws_config())
    return pca_connector_scep(
        "DELETE",
        "/connectors/$(ConnectorArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_connector(
    ConnectorArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pca_connector_scep(
        "DELETE",
        "/connectors/$(ConnectorArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_challenge_metadata(challenge_arn)
    get_challenge_metadata(challenge_arn, params::Dict{String,<:Any})

Retrieves the metadata for the specified Challenge.

# Arguments
- `challenge_arn`: The Amazon Resource Name (ARN) of the challenge.

"""
function get_challenge_metadata(
    ChallengeArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pca_connector_scep(
        "GET",
        "/challengeMetadata/$(ChallengeArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_challenge_metadata(
    ChallengeArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pca_connector_scep(
        "GET",
        "/challengeMetadata/$(ChallengeArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_challenge_password(challenge_arn)
    get_challenge_password(challenge_arn, params::Dict{String,<:Any})

Retrieves the challenge password for the specified Challenge.

# Arguments
- `challenge_arn`: The Amazon Resource Name (ARN) of the challenge.

"""
function get_challenge_password(
    ChallengeArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pca_connector_scep(
        "GET",
        "/challengePasswords/$(ChallengeArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_challenge_password(
    ChallengeArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pca_connector_scep(
        "GET",
        "/challengePasswords/$(ChallengeArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_connector(connector_arn)
    get_connector(connector_arn, params::Dict{String,<:Any})

Retrieves details about the specified Connector. Calling this action returns important
details about the connector, such as the public SCEP URL where your clients can request
certificates.

# Arguments
- `connector_arn`: The Amazon Resource Name (ARN) of the connector.

"""
function get_connector(ConnectorArn; aws_config::AbstractAWSConfig=current_aws_config())
    return pca_connector_scep(
        "GET",
        "/connectors/$(ConnectorArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_connector(
    ConnectorArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pca_connector_scep(
        "GET",
        "/connectors/$(ConnectorArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_challenge_metadata(connector_arn)
    list_challenge_metadata(connector_arn, params::Dict{String,<:Any})

Retrieves the challenge metadata for the specified ARN.

# Arguments
- `connector_arn`: The Amazon Resource Name (ARN) of the connector.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of objects that you want Connector for SCEP to return
  for this request. If more objects are available, in the response, Connector for SCEP
  provides a NextToken value that you can use in a subsequent call to get the next batch of
  objects.
- `"NextToken"`: When you request a list of objects with a MaxResults setting, if the
  number of objects that are still available for retrieval exceeds the maximum you requested,
  Connector for SCEP returns a NextToken value in the response. To retrieve the next batch of
  objects, use the token returned from the prior request in your next request.
"""
function list_challenge_metadata(
    ConnectorArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pca_connector_scep(
        "GET",
        "/challengeMetadata",
        Dict{String,Any}("ConnectorArn" => ConnectorArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_challenge_metadata(
    ConnectorArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pca_connector_scep(
        "GET",
        "/challengeMetadata",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ConnectorArn" => ConnectorArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_connectors()
    list_connectors(params::Dict{String,<:Any})

Lists the connectors belonging to your Amazon Web Services account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of objects that you want Connector for SCEP to return
  for this request. If more objects are available, in the response, Connector for SCEP
  provides a NextToken value that you can use in a subsequent call to get the next batch of
  objects.
- `"NextToken"`: When you request a list of objects with a MaxResults setting, if the
  number of objects that are still available for retrieval exceeds the maximum you requested,
  Connector for SCEP returns a NextToken value in the response. To retrieve the next batch of
  objects, use the token returned from the prior request in your next request.
"""
function list_connectors(; aws_config::AbstractAWSConfig=current_aws_config())
    return pca_connector_scep(
        "GET", "/connectors"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_connectors(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pca_connector_scep(
        "GET", "/connectors", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Retrieves the tags associated with the specified resource. Tags are key-value pairs that
you can use to categorize and manage your resources, for purposes like billing. For
example, you might set the tag key to \"customer\" and the value to the customer name or
ID. You can specify one or more tags to add to each Amazon Web Services resource, up to 50
tags for a resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.

"""
function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pca_connector_scep(
        "GET",
        "/tags/$(ResourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pca_connector_scep(
        "GET",
        "/tags/$(ResourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds one or more tags to your resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.
- `tags`: The key-value pairs to associate with the resource.

"""
function tag_resource(ResourceArn, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return pca_connector_scep(
        "POST",
        "/tags/$(ResourceArn)",
        Dict{String,Any}("Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceArn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pca_connector_scep(
        "POST",
        "/tags/$(ResourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Tags" => Tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes one or more tags from your resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.
- `tag_keys`: Specifies a list of tag keys that you want to remove from the specified
  resources.

"""
function untag_resource(
    ResourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pca_connector_scep(
        "DELETE",
        "/tags/$(ResourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pca_connector_scep(
        "DELETE",
        "/tags/$(ResourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: repostspace
using AWS.Compat
using AWS.UUIDs

"""
    create_space(name, subdomain, tier)
    create_space(name, subdomain, tier, params::Dict{String,<:Any})

Creates an AWS re:Post Private private re:Post.

# Arguments
- `name`: The name for the private re:Post. This must be unique in your account.
- `subdomain`: The subdomain that you use to access your AWS re:Post Private private
  re:Post. All custom subdomains must be approved by AWS before use. In addition to your
  custom subdomain, all private re:Posts are issued an AWS generated subdomain for immediate
  use.
- `tier`: The pricing tier for the private re:Post.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A description for the private re:Post. This is used only to help you
  identify this private re:Post.
- `"roleArn"`: The IAM role that grants permissions to the private re:Post to convert
  unanswered questions into AWS support tickets.
- `"tags"`: The list of tags associated with the private re:Post.
- `"userKMSKey"`: The AWS KMS key ARN that’s used for the AWS KMS encryption. If you
  don't provide a key, your data is encrypted by default with a key that AWS owns and manages
  for you.
"""
function create_space(
    name, subdomain, tier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return repostspace(
        "POST",
        "/spaces",
        Dict{String,Any}("name" => name, "subdomain" => subdomain, "tier" => tier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_space(
    name,
    subdomain,
    tier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return repostspace(
        "POST",
        "/spaces",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("name" => name, "subdomain" => subdomain, "tier" => tier),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_space(space_id)
    delete_space(space_id, params::Dict{String,<:Any})

Deletes an AWS re:Post Private private re:Post.

# Arguments
- `space_id`: The unique ID of the private re:Post.

"""
function delete_space(spaceId; aws_config::AbstractAWSConfig=current_aws_config())
    return repostspace(
        "DELETE",
        "/spaces/$(spaceId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_space(
    spaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return repostspace(
        "DELETE",
        "/spaces/$(spaceId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    deregister_admin(admin_id, space_id)
    deregister_admin(admin_id, space_id, params::Dict{String,<:Any})

Removes the user or group from the list of administrators of the private re:Post.

# Arguments
- `admin_id`: The ID of the admin to remove.
- `space_id`: The ID of the private re:Post to remove the admin from.

"""
function deregister_admin(
    adminId, spaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return repostspace(
        "DELETE",
        "/spaces/$(spaceId)/admins/$(adminId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function deregister_admin(
    adminId,
    spaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return repostspace(
        "DELETE",
        "/spaces/$(spaceId)/admins/$(adminId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_space(space_id)
    get_space(space_id, params::Dict{String,<:Any})

Displays information about the AWS re:Post Private private re:Post.

# Arguments
- `space_id`: The ID of the private re:Post.

"""
function get_space(spaceId; aws_config::AbstractAWSConfig=current_aws_config())
    return repostspace(
        "GET", "/spaces/$(spaceId)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_space(
    spaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return repostspace(
        "GET",
        "/spaces/$(spaceId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_spaces()
    list_spaces(params::Dict{String,<:Any})

Returns a list of AWS re:Post Private private re:Posts in the account with some information
about each private re:Post.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of private re:Posts to include in the results.
- `"nextToken"`: The token for the next set of private re:Posts to return. You receive this
  token from a previous ListSpaces operation.
"""
function list_spaces(; aws_config::AbstractAWSConfig=current_aws_config())
    return repostspace(
        "GET", "/spaces"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_spaces(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return repostspace(
        "GET", "/spaces", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Returns the tags that are associated with the AWS re:Post Private resource specified by the
resourceArn. The only resource that can be tagged is a private re:Post.

# Arguments
- `resource_arn`: The ARN of the resource that the tags are associated with.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return repostspace(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return repostspace(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    register_admin(admin_id, space_id)
    register_admin(admin_id, space_id, params::Dict{String,<:Any})

Adds a user or group to the list of administrators of the private re:Post.

# Arguments
- `admin_id`: The ID of the administrator.
- `space_id`: The ID of the private re:Post.

"""
function register_admin(
    adminId, spaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return repostspace(
        "POST",
        "/spaces/$(spaceId)/admins/$(adminId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function register_admin(
    adminId,
    spaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return repostspace(
        "POST",
        "/spaces/$(spaceId)/admins/$(adminId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    send_invites(accessor_ids, body, space_id, title)
    send_invites(accessor_ids, body, space_id, title, params::Dict{String,<:Any})

Sends an invitation email to selected users and groups.

# Arguments
- `accessor_ids`: The array of identifiers for the users and groups.
- `body`: The body of the invite.
- `space_id`: The ID of the private re:Post.
- `title`: The title of the invite.

"""
function send_invites(
    accessorIds, body, spaceId, title; aws_config::AbstractAWSConfig=current_aws_config()
)
    return repostspace(
        "POST",
        "/spaces/$(spaceId)/invite",
        Dict{String,Any}("accessorIds" => accessorIds, "body" => body, "title" => title);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function send_invites(
    accessorIds,
    body,
    spaceId,
    title,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return repostspace(
        "POST",
        "/spaces/$(spaceId)/invite",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "accessorIds" => accessorIds, "body" => body, "title" => title
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Associates tags with an AWS re:Post Private resource. Currently, the only resource that can
be tagged is the private re:Post. If you specify a new tag key for the resource, the tag is
appended to the list of tags that are associated with the resource. If you specify a tag
key that’s already associated with the resource, the new tag value that you specify
replaces the previous value for that tag.

# Arguments
- `resource_arn`: The ARN of the resource that the tag is associated with.
- `tags`: The list of tag keys and values that must be associated with the resource. You
  can associate tag keys only, tags (key and values) only, or a combination of tag keys and
  tags.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return repostspace(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return repostspace(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes the association of the tag with the AWS re:Post Private resource.

# Arguments
- `resource_arn`: The ARN of the resource.
- `tag_keys`: The key values of the tag.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return repostspace(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return repostspace(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_space(space_id)
    update_space(space_id, params::Dict{String,<:Any})

Modifies an existing AWS re:Post Private private re:Post.

# Arguments
- `space_id`: The unique ID of this private re:Post.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A description for the private re:Post. This is used only to help you
  identify this private re:Post.
- `"roleArn"`: The IAM role that grants permissions to the private re:Post to convert
  unanswered questions into AWS support tickets.
- `"tier"`: The pricing tier of this private re:Post.
"""
function update_space(spaceId; aws_config::AbstractAWSConfig=current_aws_config())
    return repostspace(
        "PUT", "/spaces/$(spaceId)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function update_space(
    spaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return repostspace(
        "PUT",
        "/spaces/$(spaceId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: budgets
using AWS.Compat
using AWS.UUIDs

"""
    create_budget(account_id, budget)
    create_budget(account_id, budget, params::Dict{String,<:Any})

Creates a budget and, if included, notifications and subscribers.   Only one of BudgetLimit
or PlannedBudgetLimits can be present in the syntax at one time. Use the syntax that
matches your case. The Request Syntax section shows the BudgetLimit syntax. For
PlannedBudgetLimits, see the Examples section.

# Arguments
- `account_id`: The accountId that is associated with the budget.
- `budget`: The budget object that you want to create.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NotificationsWithSubscribers"`: A notification that you want to associate with a
  budget. A budget can have up to five notifications, and each notification can have one SNS
  subscriber and up to 10 email subscribers. If you include notifications and subscribers in
  your CreateBudget call, Amazon Web Services creates the notifications and subscribers for
  you.
- `"ResourceTags"`: An optional list of tags to associate with the specified budget. Each
  tag consists of a key and a value, and each key must be unique for the resource.
"""
function create_budget(
    AccountId, Budget; aws_config::AbstractAWSConfig=current_aws_config()
)
    return budgets(
        "CreateBudget",
        Dict{String,Any}("AccountId" => AccountId, "Budget" => Budget);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_budget(
    AccountId,
    Budget,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return budgets(
        "CreateBudget",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("AccountId" => AccountId, "Budget" => Budget),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_budget_action(account_id, action_threshold, action_type, approval_model, budget_name, definition, execution_role_arn, notification_type, subscribers)
    create_budget_action(account_id, action_threshold, action_type, approval_model, budget_name, definition, execution_role_arn, notification_type, subscribers, params::Dict{String,<:Any})

 Creates a budget action.

# Arguments
- `account_id`:
- `action_threshold`:
- `action_type`:  The type of action. This defines the type of tasks that can be carried
  out by this action. This field also determines the format for definition.
- `approval_model`:  This specifies if the action needs manual or automatic approval.
- `budget_name`:
- `definition`:
- `execution_role_arn`:  The role passed for action execution and reversion. Roles and
  actions must be in the same account.
- `notification_type`:
- `subscribers`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ResourceTags"`: An optional list of tags to associate with the specified budget action.
  Each tag consists of a key and a value, and each key must be unique for the resource.
"""
function create_budget_action(
    AccountId,
    ActionThreshold,
    ActionType,
    ApprovalModel,
    BudgetName,
    Definition,
    ExecutionRoleArn,
    NotificationType,
    Subscribers;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return budgets(
        "CreateBudgetAction",
        Dict{String,Any}(
            "AccountId" => AccountId,
            "ActionThreshold" => ActionThreshold,
            "ActionType" => ActionType,
            "ApprovalModel" => ApprovalModel,
            "BudgetName" => BudgetName,
            "Definition" => Definition,
            "ExecutionRoleArn" => ExecutionRoleArn,
            "NotificationType" => NotificationType,
            "Subscribers" => Subscribers,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_budget_action(
    AccountId,
    ActionThreshold,
    ActionType,
    ApprovalModel,
    BudgetName,
    Definition,
    ExecutionRoleArn,
    NotificationType,
    Subscribers,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return budgets(
        "CreateBudgetAction",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AccountId" => AccountId,
                    "ActionThreshold" => ActionThreshold,
                    "ActionType" => ActionType,
                    "ApprovalModel" => ApprovalModel,
                    "BudgetName" => BudgetName,
                    "Definition" => Definition,
                    "ExecutionRoleArn" => ExecutionRoleArn,
                    "NotificationType" => NotificationType,
                    "Subscribers" => Subscribers,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_notification(account_id, budget_name, notification, subscribers)
    create_notification(account_id, budget_name, notification, subscribers, params::Dict{String,<:Any})

Creates a notification. You must create the budget before you create the associated
notification.

# Arguments
- `account_id`: The accountId that is associated with the budget that you want to create a
  notification for.
- `budget_name`: The name of the budget that you want Amazon Web Services to notify you
  about. Budget names must be unique within an account.
- `notification`: The notification that you want to create.
- `subscribers`: A list of subscribers that you want to associate with the notification.
  Each notification can have one SNS subscriber and up to 10 email subscribers.

"""
function create_notification(
    AccountId,
    BudgetName,
    Notification,
    Subscribers;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return budgets(
        "CreateNotification",
        Dict{String,Any}(
            "AccountId" => AccountId,
            "BudgetName" => BudgetName,
            "Notification" => Notification,
            "Subscribers" => Subscribers,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_notification(
    AccountId,
    BudgetName,
    Notification,
    Subscribers,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return budgets(
        "CreateNotification",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AccountId" => AccountId,
                    "BudgetName" => BudgetName,
                    "Notification" => Notification,
                    "Subscribers" => Subscribers,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_subscriber(account_id, budget_name, notification, subscriber)
    create_subscriber(account_id, budget_name, notification, subscriber, params::Dict{String,<:Any})

Creates a subscriber. You must create the associated budget and notification before you
create the subscriber.

# Arguments
- `account_id`: The accountId that is associated with the budget that you want to create a
  subscriber for.
- `budget_name`: The name of the budget that you want to subscribe to. Budget names must be
  unique within an account.
- `notification`: The notification that you want to create a subscriber for.
- `subscriber`: The subscriber that you want to associate with a budget notification.

"""
function create_subscriber(
    AccountId,
    BudgetName,
    Notification,
    Subscriber;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return budgets(
        "CreateSubscriber",
        Dict{String,Any}(
            "AccountId" => AccountId,
            "BudgetName" => BudgetName,
            "Notification" => Notification,
            "Subscriber" => Subscriber,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_subscriber(
    AccountId,
    BudgetName,
    Notification,
    Subscriber,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return budgets(
        "CreateSubscriber",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AccountId" => AccountId,
                    "BudgetName" => BudgetName,
                    "Notification" => Notification,
                    "Subscriber" => Subscriber,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_budget(account_id, budget_name)
    delete_budget(account_id, budget_name, params::Dict{String,<:Any})

Deletes a budget. You can delete your budget at any time.  Deleting a budget also deletes
the notifications and subscribers that are associated with that budget.

# Arguments
- `account_id`: The accountId that is associated with the budget that you want to delete.
- `budget_name`: The name of the budget that you want to delete.

"""
function delete_budget(
    AccountId, BudgetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return budgets(
        "DeleteBudget",
        Dict{String,Any}("AccountId" => AccountId, "BudgetName" => BudgetName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_budget(
    AccountId,
    BudgetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return budgets(
        "DeleteBudget",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("AccountId" => AccountId, "BudgetName" => BudgetName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_budget_action(account_id, action_id, budget_name)
    delete_budget_action(account_id, action_id, budget_name, params::Dict{String,<:Any})

 Deletes a budget action.

# Arguments
- `account_id`:
- `action_id`:  A system-generated universally unique identifier (UUID) for the action.
- `budget_name`:

"""
function delete_budget_action(
    AccountId, ActionId, BudgetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return budgets(
        "DeleteBudgetAction",
        Dict{String,Any}(
            "AccountId" => AccountId, "ActionId" => ActionId, "BudgetName" => BudgetName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_budget_action(
    AccountId,
    ActionId,
    BudgetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return budgets(
        "DeleteBudgetAction",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AccountId" => AccountId,
                    "ActionId" => ActionId,
                    "BudgetName" => BudgetName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_notification(account_id, budget_name, notification)
    delete_notification(account_id, budget_name, notification, params::Dict{String,<:Any})

Deletes a notification.  Deleting a notification also deletes the subscribers that are
associated with the notification.

# Arguments
- `account_id`: The accountId that is associated with the budget whose notification you
  want to delete.
- `budget_name`: The name of the budget whose notification you want to delete.
- `notification`: The notification that you want to delete.

"""
function delete_notification(
    AccountId, BudgetName, Notification; aws_config::AbstractAWSConfig=current_aws_config()
)
    return budgets(
        "DeleteNotification",
        Dict{String,Any}(
            "AccountId" => AccountId,
            "BudgetName" => BudgetName,
            "Notification" => Notification,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_notification(
    AccountId,
    BudgetName,
    Notification,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return budgets(
        "DeleteNotification",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AccountId" => AccountId,
                    "BudgetName" => BudgetName,
                    "Notification" => Notification,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_subscriber(account_id, budget_name, notification, subscriber)
    delete_subscriber(account_id, budget_name, notification, subscriber, params::Dict{String,<:Any})

Deletes a subscriber.  Deleting the last subscriber to a notification also deletes the
notification.

# Arguments
- `account_id`: The accountId that is associated with the budget whose subscriber you want
  to delete.
- `budget_name`: The name of the budget whose subscriber you want to delete.
- `notification`: The notification whose subscriber you want to delete.
- `subscriber`: The subscriber that you want to delete.

"""
function delete_subscriber(
    AccountId,
    BudgetName,
    Notification,
    Subscriber;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return budgets(
        "DeleteSubscriber",
        Dict{String,Any}(
            "AccountId" => AccountId,
            "BudgetName" => BudgetName,
            "Notification" => Notification,
            "Subscriber" => Subscriber,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_subscriber(
    AccountId,
    BudgetName,
    Notification,
    Subscriber,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return budgets(
        "DeleteSubscriber",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AccountId" => AccountId,
                    "BudgetName" => BudgetName,
                    "Notification" => Notification,
                    "Subscriber" => Subscriber,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_budget(account_id, budget_name)
    describe_budget(account_id, budget_name, params::Dict{String,<:Any})

Describes a budget.  The Request Syntax section shows the BudgetLimit syntax. For
PlannedBudgetLimits, see the Examples section.

# Arguments
- `account_id`: The accountId that is associated with the budget that you want a
  description of.
- `budget_name`: The name of the budget that you want a description of.

"""
function describe_budget(
    AccountId, BudgetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return budgets(
        "DescribeBudget",
        Dict{String,Any}("AccountId" => AccountId, "BudgetName" => BudgetName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_budget(
    AccountId,
    BudgetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return budgets(
        "DescribeBudget",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("AccountId" => AccountId, "BudgetName" => BudgetName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_budget_action(account_id, action_id, budget_name)
    describe_budget_action(account_id, action_id, budget_name, params::Dict{String,<:Any})

 Describes a budget action detail.

# Arguments
- `account_id`:
- `action_id`:  A system-generated universally unique identifier (UUID) for the action.
- `budget_name`:

"""
function describe_budget_action(
    AccountId, ActionId, BudgetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return budgets(
        "DescribeBudgetAction",
        Dict{String,Any}(
            "AccountId" => AccountId, "ActionId" => ActionId, "BudgetName" => BudgetName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_budget_action(
    AccountId,
    ActionId,
    BudgetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return budgets(
        "DescribeBudgetAction",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AccountId" => AccountId,
                    "ActionId" => ActionId,
                    "BudgetName" => BudgetName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_budget_action_histories(account_id, action_id, budget_name)
    describe_budget_action_histories(account_id, action_id, budget_name, params::Dict{String,<:Any})

 Describes a budget action history detail.

# Arguments
- `account_id`:
- `action_id`:  A system-generated universally unique identifier (UUID) for the action.
- `budget_name`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`:
- `"NextToken"`:
- `"TimePeriod"`:
"""
function describe_budget_action_histories(
    AccountId, ActionId, BudgetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return budgets(
        "DescribeBudgetActionHistories",
        Dict{String,Any}(
            "AccountId" => AccountId, "ActionId" => ActionId, "BudgetName" => BudgetName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_budget_action_histories(
    AccountId,
    ActionId,
    BudgetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return budgets(
        "DescribeBudgetActionHistories",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AccountId" => AccountId,
                    "ActionId" => ActionId,
                    "BudgetName" => BudgetName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_budget_actions_for_account(account_id)
    describe_budget_actions_for_account(account_id, params::Dict{String,<:Any})

 Describes all of the budget actions for an account.

# Arguments
- `account_id`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`:
- `"NextToken"`:
"""
function describe_budget_actions_for_account(
    AccountId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return budgets(
        "DescribeBudgetActionsForAccount",
        Dict{String,Any}("AccountId" => AccountId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_budget_actions_for_account(
    AccountId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return budgets(
        "DescribeBudgetActionsForAccount",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AccountId" => AccountId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_budget_actions_for_budget(account_id, budget_name)
    describe_budget_actions_for_budget(account_id, budget_name, params::Dict{String,<:Any})

 Describes all of the budget actions for a budget.

# Arguments
- `account_id`:
- `budget_name`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`:
- `"NextToken"`:
"""
function describe_budget_actions_for_budget(
    AccountId, BudgetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return budgets(
        "DescribeBudgetActionsForBudget",
        Dict{String,Any}("AccountId" => AccountId, "BudgetName" => BudgetName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_budget_actions_for_budget(
    AccountId,
    BudgetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return budgets(
        "DescribeBudgetActionsForBudget",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("AccountId" => AccountId, "BudgetName" => BudgetName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_budget_notifications_for_account(account_id)
    describe_budget_notifications_for_account(account_id, params::Dict{String,<:Any})

 Lists the budget names and notifications that are associated with an account.

# Arguments
- `account_id`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`:  An integer that represents how many budgets a paginated response
  contains. The default is 50.
- `"NextToken"`:
"""
function describe_budget_notifications_for_account(
    AccountId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return budgets(
        "DescribeBudgetNotificationsForAccount",
        Dict{String,Any}("AccountId" => AccountId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_budget_notifications_for_account(
    AccountId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return budgets(
        "DescribeBudgetNotificationsForAccount",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AccountId" => AccountId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_budget_performance_history(account_id, budget_name)
    describe_budget_performance_history(account_id, budget_name, params::Dict{String,<:Any})

Describes the history for DAILY, MONTHLY, and QUARTERLY budgets. Budget history isn't
available for ANNUAL budgets.

# Arguments
- `account_id`:
- `budget_name`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`:
- `"NextToken"`:
- `"TimePeriod"`: Retrieves how often the budget went into an ALARM state for the specified
  time period.
"""
function describe_budget_performance_history(
    AccountId, BudgetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return budgets(
        "DescribeBudgetPerformanceHistory",
        Dict{String,Any}("AccountId" => AccountId, "BudgetName" => BudgetName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_budget_performance_history(
    AccountId,
    BudgetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return budgets(
        "DescribeBudgetPerformanceHistory",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("AccountId" => AccountId, "BudgetName" => BudgetName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_budgets(account_id)
    describe_budgets(account_id, params::Dict{String,<:Any})

Lists the budgets that are associated with an account.  The Request Syntax section shows
the BudgetLimit syntax. For PlannedBudgetLimits, see the Examples section.

# Arguments
- `account_id`: The accountId that is associated with the budgets that you want to describe.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: An integer that represents how many budgets a paginated response
  contains. The default is 100.
- `"NextToken"`: The pagination token that you include in your request to indicate the next
  set of results that you want to retrieve.
"""
function describe_budgets(AccountId; aws_config::AbstractAWSConfig=current_aws_config())
    return budgets(
        "DescribeBudgets",
        Dict{String,Any}("AccountId" => AccountId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_budgets(
    AccountId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return budgets(
        "DescribeBudgets",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AccountId" => AccountId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_notifications_for_budget(account_id, budget_name)
    describe_notifications_for_budget(account_id, budget_name, params::Dict{String,<:Any})

Lists the notifications that are associated with a budget.

# Arguments
- `account_id`: The accountId that is associated with the budget whose notifications you
  want descriptions of.
- `budget_name`: The name of the budget whose notifications you want descriptions of.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: An optional integer that represents how many entries a paginated response
  contains.
- `"NextToken"`: The pagination token that you include in your request to indicate the next
  set of results that you want to retrieve.
"""
function describe_notifications_for_budget(
    AccountId, BudgetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return budgets(
        "DescribeNotificationsForBudget",
        Dict{String,Any}("AccountId" => AccountId, "BudgetName" => BudgetName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_notifications_for_budget(
    AccountId,
    BudgetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return budgets(
        "DescribeNotificationsForBudget",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("AccountId" => AccountId, "BudgetName" => BudgetName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_subscribers_for_notification(account_id, budget_name, notification)
    describe_subscribers_for_notification(account_id, budget_name, notification, params::Dict{String,<:Any})

Lists the subscribers that are associated with a notification.

# Arguments
- `account_id`: The accountId that is associated with the budget whose subscribers you want
  descriptions of.
- `budget_name`: The name of the budget whose subscribers you want descriptions of.
- `notification`: The notification whose subscribers you want to list.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: An optional integer that represents how many entries a paginated response
  contains.
- `"NextToken"`: The pagination token that you include in your request to indicate the next
  set of results that you want to retrieve.
"""
function describe_subscribers_for_notification(
    AccountId, BudgetName, Notification; aws_config::AbstractAWSConfig=current_aws_config()
)
    return budgets(
        "DescribeSubscribersForNotification",
        Dict{String,Any}(
            "AccountId" => AccountId,
            "BudgetName" => BudgetName,
            "Notification" => Notification,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_subscribers_for_notification(
    AccountId,
    BudgetName,
    Notification,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return budgets(
        "DescribeSubscribersForNotification",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AccountId" => AccountId,
                    "BudgetName" => BudgetName,
                    "Notification" => Notification,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    execute_budget_action(account_id, action_id, budget_name, execution_type)
    execute_budget_action(account_id, action_id, budget_name, execution_type, params::Dict{String,<:Any})

 Executes a budget action.

# Arguments
- `account_id`:
- `action_id`:  A system-generated universally unique identifier (UUID) for the action.
- `budget_name`:
- `execution_type`:  The type of execution.

"""
function execute_budget_action(
    AccountId,
    ActionId,
    BudgetName,
    ExecutionType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return budgets(
        "ExecuteBudgetAction",
        Dict{String,Any}(
            "AccountId" => AccountId,
            "ActionId" => ActionId,
            "BudgetName" => BudgetName,
            "ExecutionType" => ExecutionType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function execute_budget_action(
    AccountId,
    ActionId,
    BudgetName,
    ExecutionType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return budgets(
        "ExecuteBudgetAction",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AccountId" => AccountId,
                    "ActionId" => ActionId,
                    "BudgetName" => BudgetName,
                    "ExecutionType" => ExecutionType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists tags associated with a budget or budget action resource.

# Arguments
- `resource_arn`: The unique identifier for the resource.

"""
function list_tags_for_resource(
    ResourceARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return budgets(
        "ListTagsForResource",
        Dict{String,Any}("ResourceARN" => ResourceARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return budgets(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceARN" => ResourceARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, resource_tags)
    tag_resource(resource_arn, resource_tags, params::Dict{String,<:Any})

Creates tags for a budget or budget action resource.

# Arguments
- `resource_arn`: The unique identifier for the resource.
- `resource_tags`: The tags associated with the resource.

"""
function tag_resource(
    ResourceARN, ResourceTags; aws_config::AbstractAWSConfig=current_aws_config()
)
    return budgets(
        "TagResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "ResourceTags" => ResourceTags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceARN,
    ResourceTags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return budgets(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ResourceARN" => ResourceARN, "ResourceTags" => ResourceTags
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, resource_tag_keys)
    untag_resource(resource_arn, resource_tag_keys, params::Dict{String,<:Any})

Deletes tags associated with a budget or budget action resource.

# Arguments
- `resource_arn`: The unique identifier for the resource.
- `resource_tag_keys`: The key that's associated with the tag.

"""
function untag_resource(
    ResourceARN, ResourceTagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return budgets(
        "UntagResource",
        Dict{String,Any}(
            "ResourceARN" => ResourceARN, "ResourceTagKeys" => ResourceTagKeys
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceARN,
    ResourceTagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return budgets(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ResourceARN" => ResourceARN, "ResourceTagKeys" => ResourceTagKeys
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_budget(account_id, new_budget)
    update_budget(account_id, new_budget, params::Dict{String,<:Any})

Updates a budget. You can change every part of a budget except for the budgetName and the
calculatedSpend. When you modify a budget, the calculatedSpend drops to zero until Amazon
Web Services has new usage data to use for forecasting.  Only one of BudgetLimit or
PlannedBudgetLimits can be present in the syntax at one time. Use the syntax that matches
your case. The Request Syntax section shows the BudgetLimit syntax. For
PlannedBudgetLimits, see the Examples section.

# Arguments
- `account_id`: The accountId that is associated with the budget that you want to update.
- `new_budget`: The budget that you want to update your budget to.

"""
function update_budget(
    AccountId, NewBudget; aws_config::AbstractAWSConfig=current_aws_config()
)
    return budgets(
        "UpdateBudget",
        Dict{String,Any}("AccountId" => AccountId, "NewBudget" => NewBudget);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_budget(
    AccountId,
    NewBudget,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return budgets(
        "UpdateBudget",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("AccountId" => AccountId, "NewBudget" => NewBudget),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_budget_action(account_id, action_id, budget_name)
    update_budget_action(account_id, action_id, budget_name, params::Dict{String,<:Any})

 Updates a budget action.

# Arguments
- `account_id`:
- `action_id`:  A system-generated universally unique identifier (UUID) for the action.
- `budget_name`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ActionThreshold"`:
- `"ApprovalModel"`:  This specifies if the action needs manual or automatic approval.
- `"Definition"`:
- `"ExecutionRoleArn"`:  The role passed for action execution and reversion. Roles and
  actions must be in the same account.
- `"NotificationType"`:
- `"Subscribers"`:
"""
function update_budget_action(
    AccountId, ActionId, BudgetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return budgets(
        "UpdateBudgetAction",
        Dict{String,Any}(
            "AccountId" => AccountId, "ActionId" => ActionId, "BudgetName" => BudgetName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_budget_action(
    AccountId,
    ActionId,
    BudgetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return budgets(
        "UpdateBudgetAction",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AccountId" => AccountId,
                    "ActionId" => ActionId,
                    "BudgetName" => BudgetName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_notification(account_id, budget_name, new_notification, old_notification)
    update_notification(account_id, budget_name, new_notification, old_notification, params::Dict{String,<:Any})

Updates a notification.

# Arguments
- `account_id`: The accountId that is associated with the budget whose notification you
  want to update.
- `budget_name`: The name of the budget whose notification you want to update.
- `new_notification`: The updated notification to be associated with a budget.
- `old_notification`: The previous notification that is associated with a budget.

"""
function update_notification(
    AccountId,
    BudgetName,
    NewNotification,
    OldNotification;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return budgets(
        "UpdateNotification",
        Dict{String,Any}(
            "AccountId" => AccountId,
            "BudgetName" => BudgetName,
            "NewNotification" => NewNotification,
            "OldNotification" => OldNotification,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_notification(
    AccountId,
    BudgetName,
    NewNotification,
    OldNotification,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return budgets(
        "UpdateNotification",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AccountId" => AccountId,
                    "BudgetName" => BudgetName,
                    "NewNotification" => NewNotification,
                    "OldNotification" => OldNotification,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_subscriber(account_id, budget_name, new_subscriber, notification, old_subscriber)
    update_subscriber(account_id, budget_name, new_subscriber, notification, old_subscriber, params::Dict{String,<:Any})

Updates a subscriber.

# Arguments
- `account_id`: The accountId that is associated with the budget whose subscriber you want
  to update.
- `budget_name`: The name of the budget whose subscriber you want to update.
- `new_subscriber`: The updated subscriber that is associated with a budget notification.
- `notification`: The notification whose subscriber you want to update.
- `old_subscriber`: The previous subscriber that is associated with a budget notification.

"""
function update_subscriber(
    AccountId,
    BudgetName,
    NewSubscriber,
    Notification,
    OldSubscriber;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return budgets(
        "UpdateSubscriber",
        Dict{String,Any}(
            "AccountId" => AccountId,
            "BudgetName" => BudgetName,
            "NewSubscriber" => NewSubscriber,
            "Notification" => Notification,
            "OldSubscriber" => OldSubscriber,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_subscriber(
    AccountId,
    BudgetName,
    NewSubscriber,
    Notification,
    OldSubscriber,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return budgets(
        "UpdateSubscriber",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AccountId" => AccountId,
                    "BudgetName" => BudgetName,
                    "NewSubscriber" => NewSubscriber,
                    "Notification" => Notification,
                    "OldSubscriber" => OldSubscriber,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: support
using AWS.Compat
using AWS.UUIDs

"""
    add_attachments_to_set(attachments)
    add_attachments_to_set(attachments, params::Dict{String,<:Any})

Adds one or more attachments to an attachment set.  An attachment set is a temporary
container for attachments that you add to a case or case communication. The set is
available for 1 hour after it's created. The expiryTime returned in the response is when
the set expires.     You must have a Business, Enterprise On-Ramp, or Enterprise Support
plan to use the Amazon Web Services Support API.    If you call the Amazon Web Services
Support API from an account that doesn't have a Business, Enterprise On-Ramp, or Enterprise
Support plan, the SubscriptionRequiredException error message appears. For information
about changing your support plan, see Amazon Web Services Support.

# Arguments
- `attachments`: One or more attachments to add to the set. You can add up to three
  attachments per set. The size limit is 5 MB per attachment. In the Attachment object, use
  the data parameter to specify the contents of the attachment file. In the previous request
  syntax, the value for data appear as blob, which is represented as a base64-encoded string.
  The value for fileName is the name of the attachment, such as troubleshoot-screenshot.png.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"attachmentSetId"`: The ID of the attachment set. If an attachmentSetId is not
  specified, a new attachment set is created, and the ID of the set is returned in the
  response. If an attachmentSetId is specified, the attachments are added to the specified
  set, if it exists.
"""
function add_attachments_to_set(
    attachments; aws_config::AbstractAWSConfig=current_aws_config()
)
    return support(
        "AddAttachmentsToSet",
        Dict{String,Any}("attachments" => attachments);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_attachments_to_set(
    attachments,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return support(
        "AddAttachmentsToSet",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("attachments" => attachments), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    add_communication_to_case(communication_body)
    add_communication_to_case(communication_body, params::Dict{String,<:Any})

Adds additional customer communication to an Amazon Web Services Support case. Use the
caseId parameter to identify the case to which to add communication. You can list a set of
email addresses to copy on the communication by using the ccEmailAddresses parameter. The
communicationBody value contains the text of the communication.    You must have a
Business, Enterprise On-Ramp, or Enterprise Support plan to use the Amazon Web Services
Support API.    If you call the Amazon Web Services Support API from an account that
doesn't have a Business, Enterprise On-Ramp, or Enterprise Support plan, the
SubscriptionRequiredException error message appears. For information about changing your
support plan, see Amazon Web Services Support.

# Arguments
- `communication_body`: The body of an email communication to add to the support case.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"attachmentSetId"`: The ID of a set of one or more attachments for the communication to
  add to the case. Create the set by calling AddAttachmentsToSet
- `"caseId"`: The support case ID requested or returned in the call. The case ID is an
  alphanumeric string formatted as shown in this example:
  case-12345678910-2013-c4c1d2bf33c5cf47
- `"ccEmailAddresses"`: The email addresses in the CC line of an email to be added to the
  support case.
"""
function add_communication_to_case(
    communicationBody; aws_config::AbstractAWSConfig=current_aws_config()
)
    return support(
        "AddCommunicationToCase",
        Dict{String,Any}("communicationBody" => communicationBody);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_communication_to_case(
    communicationBody,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return support(
        "AddCommunicationToCase",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("communicationBody" => communicationBody), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_case(communication_body, subject)
    create_case(communication_body, subject, params::Dict{String,<:Any})

Creates a case in the Amazon Web Services Support Center. This operation is similar to how
you create a case in the Amazon Web Services Support Center Create Case page. The Amazon
Web Services Support API doesn't support requesting service limit increases. You can submit
a service limit increase in the following ways:    Submit a request from the Amazon Web
Services Support Center Create Case page.   Use the Service Quotas
RequestServiceQuotaIncrease operation.   A successful CreateCase request returns an Amazon
Web Services Support case number. You can use the DescribeCases operation and specify the
case number to get existing Amazon Web Services Support cases. After you create a case, use
the AddCommunicationToCase operation to add additional communication or attachments to an
existing case. The caseId is separate from the displayId that appears in the Amazon Web
Services Support Center. Use the DescribeCases operation to get the displayId.    You must
have a Business, Enterprise On-Ramp, or Enterprise Support plan to use the Amazon Web
Services Support API.    If you call the Amazon Web Services Support API from an account
that doesn't have a Business, Enterprise On-Ramp, or Enterprise Support plan, the
SubscriptionRequiredException error message appears. For information about changing your
support plan, see Amazon Web Services Support.

# Arguments
- `communication_body`: The communication body text that describes the issue. This text
  appears in the Description field on the Amazon Web Services Support Center Create Case page.
- `subject`: The title of the support case. The title appears in the Subject field on the
  Amazon Web Services Support Center Create Case page.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"attachmentSetId"`: The ID of a set of one or more attachments for the case. Create the
  set by using the AddAttachmentsToSet operation.
- `"categoryCode"`: The category of problem for the support case. You also use the
  DescribeServices operation to get the category code for a service. Each Amazon Web Services
  service defines its own set of category codes.
- `"ccEmailAddresses"`: A list of email addresses that Amazon Web Services Support copies
  on case correspondence. Amazon Web Services Support identifies the account that creates the
  case when you specify your Amazon Web Services credentials in an HTTP POST method or use
  the Amazon Web Services SDKs.
- `"issueType"`: The type of issue for the case. You can specify customer-service or
  technical. If you don't specify a value, the default is technical.
- `"language"`: The language in which Amazon Web Services Support handles the case. Amazon
  Web Services Support currently supports Chinese (“zh”), English (\"en\"), Japanese
  (\"ja\") and Korean (“ko”). You must specify the ISO 639-1 code for the language
  parameter if you want support in that language.
- `"serviceCode"`: The code for the Amazon Web Services service. You can use the
  DescribeServices operation to get the possible serviceCode values.
- `"severityCode"`: A value that indicates the urgency of the case. This value determines
  the response time according to your service level agreement with Amazon Web Services
  Support. You can use the DescribeSeverityLevels operation to get the possible values for
  severityCode.  For more information, see SeverityLevel and Choosing a Severity in the
  Amazon Web Services Support User Guide.  The availability of severity levels depends on the
  support plan for the Amazon Web Services account.
"""
function create_case(
    communicationBody, subject; aws_config::AbstractAWSConfig=current_aws_config()
)
    return support(
        "CreateCase",
        Dict{String,Any}("communicationBody" => communicationBody, "subject" => subject);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_case(
    communicationBody,
    subject,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return support(
        "CreateCase",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "communicationBody" => communicationBody, "subject" => subject
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_attachment(attachment_id)
    describe_attachment(attachment_id, params::Dict{String,<:Any})

Returns the attachment that has the specified ID. Attachments can include screenshots,
error logs, or other files that describe your issue. Attachment IDs are generated by the
case management system when you add an attachment to a case or case communication.
Attachment IDs are returned in the AttachmentDetails objects that are returned by the
DescribeCommunications operation.    You must have a Business, Enterprise On-Ramp, or
Enterprise Support plan to use the Amazon Web Services Support API.    If you call the
Amazon Web Services Support API from an account that doesn't have a Business, Enterprise
On-Ramp, or Enterprise Support plan, the SubscriptionRequiredException error message
appears. For information about changing your support plan, see Amazon Web Services Support.


# Arguments
- `attachment_id`: The ID of the attachment to return. Attachment IDs are returned by the
  DescribeCommunications operation.

"""
function describe_attachment(
    attachmentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return support(
        "DescribeAttachment",
        Dict{String,Any}("attachmentId" => attachmentId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_attachment(
    attachmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return support(
        "DescribeAttachment",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("attachmentId" => attachmentId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_cases()
    describe_cases(params::Dict{String,<:Any})

Returns a list of cases that you specify by passing one or more case IDs. You can use the
afterTime and beforeTime parameters to filter the cases by date. You can set values for the
includeResolvedCases and includeCommunications parameters to specify how much information
to return. The response returns the following in JSON format:   One or more CaseDetails
data types.   One or more nextToken values, which specify where to paginate the returned
records represented by the CaseDetails objects.   Case data is available for 12 months
after creation. If a case was created more than 12 months ago, a request might return an
error.    You must have a Business, Enterprise On-Ramp, or Enterprise Support plan to use
the Amazon Web Services Support API.    If you call the Amazon Web Services Support API
from an account that doesn't have a Business, Enterprise On-Ramp, or Enterprise Support
plan, the SubscriptionRequiredException error message appears. For information about
changing your support plan, see Amazon Web Services Support.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"afterTime"`: The start date for a filtered date search on support case communications.
  Case communications are available for 12 months after creation.
- `"beforeTime"`: The end date for a filtered date search on support case communications.
  Case communications are available for 12 months after creation.
- `"caseIdList"`: A list of ID numbers of the support cases you want returned. The maximum
  number of cases is 100.
- `"displayId"`: The ID displayed for a case in the Amazon Web Services Support Center user
  interface.
- `"includeCommunications"`: Specifies whether to include communications in the
  DescribeCases response. By default, communications are included.
- `"includeResolvedCases"`: Specifies whether to include resolved support cases in the
  DescribeCases response. By default, resolved cases aren't included.
- `"language"`: The language in which Amazon Web Services Support handles the case. Amazon
  Web Services Support currently supports Chinese (“zh”), English (\"en\"), Japanese
  (\"ja\") and Korean (“ko”). You must specify the ISO 639-1 code for the language
  parameter if you want support in that language.
- `"maxResults"`: The maximum number of results to return before paginating.
- `"nextToken"`: A resumption point for pagination.
"""
function describe_cases(; aws_config::AbstractAWSConfig=current_aws_config())
    return support("DescribeCases"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function describe_cases(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return support(
        "DescribeCases", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_communications(case_id)
    describe_communications(case_id, params::Dict{String,<:Any})

Returns communications and attachments for one or more support cases. Use the afterTime and
beforeTime parameters to filter by date. You can use the caseId parameter to restrict the
results to a specific case. Case data is available for 12 months after creation. If a case
was created more than 12 months ago, a request for data might cause an error. You can use
the maxResults and nextToken parameters to control the pagination of the results. Set
maxResults to the number of cases that you want to display on each page, and use nextToken
to specify the resumption of pagination.    You must have a Business, Enterprise On-Ramp,
or Enterprise Support plan to use the Amazon Web Services Support API.    If you call the
Amazon Web Services Support API from an account that doesn't have a Business, Enterprise
On-Ramp, or Enterprise Support plan, the SubscriptionRequiredException error message
appears. For information about changing your support plan, see Amazon Web Services Support.


# Arguments
- `case_id`: The support case ID requested or returned in the call. The case ID is an
  alphanumeric string formatted as shown in this example:
  case-12345678910-2013-c4c1d2bf33c5cf47

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"afterTime"`: The start date for a filtered date search on support case communications.
  Case communications are available for 12 months after creation.
- `"beforeTime"`: The end date for a filtered date search on support case communications.
  Case communications are available for 12 months after creation.
- `"maxResults"`: The maximum number of results to return before paginating.
- `"nextToken"`: A resumption point for pagination.
"""
function describe_communications(caseId; aws_config::AbstractAWSConfig=current_aws_config())
    return support(
        "DescribeCommunications",
        Dict{String,Any}("caseId" => caseId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_communications(
    caseId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return support(
        "DescribeCommunications",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("caseId" => caseId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_create_case_options(category_code, issue_type, language, service_code)
    describe_create_case_options(category_code, issue_type, language, service_code, params::Dict{String,<:Any})

Returns a list of CreateCaseOption types along with the corresponding supported hours and
language availability. You can specify the language categoryCode, issueType and serviceCode
used to retrieve the CreateCaseOptions.    You must have a Business, Enterprise On-Ramp, or
Enterprise Support plan to use the Amazon Web Services Support API.    If you call the
Amazon Web Services Support API from an account that doesn't have a Business, Enterprise
On-Ramp, or Enterprise Support plan, the SubscriptionRequiredException error message
appears. For information about changing your support plan, see Amazon Web Services Support.


# Arguments
- `category_code`: The category of problem for the support case. You also use the
  DescribeServices operation to get the category code for a service. Each Amazon Web Services
  service defines its own set of category codes.
- `issue_type`: The type of issue for the case. You can specify customer-service or
  technical. If you don't specify a value, the default is technical.
- `language`: The language in which Amazon Web Services Support handles the case. Amazon
  Web Services Support currently supports Chinese (“zh”), English (\"en\"), Japanese
  (\"ja\") and Korean (“ko”). You must specify the ISO 639-1 code for the language
  parameter if you want support in that language.
- `service_code`: The code for the Amazon Web Services service. You can use the
  DescribeServices operation to get the possible serviceCode values.

"""
function describe_create_case_options(
    categoryCode,
    issueType,
    language,
    serviceCode;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return support(
        "DescribeCreateCaseOptions",
        Dict{String,Any}(
            "categoryCode" => categoryCode,
            "issueType" => issueType,
            "language" => language,
            "serviceCode" => serviceCode,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_create_case_options(
    categoryCode,
    issueType,
    language,
    serviceCode,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return support(
        "DescribeCreateCaseOptions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "categoryCode" => categoryCode,
                    "issueType" => issueType,
                    "language" => language,
                    "serviceCode" => serviceCode,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_services()
    describe_services(params::Dict{String,<:Any})

Returns the current list of Amazon Web Services services and a list of service categories
for each service. You then use service names and categories in your CreateCase requests.
Each Amazon Web Services service has its own set of categories. The service codes and
category codes correspond to the values that appear in the Service and Category lists on
the Amazon Web Services Support Center Create Case page. The values in those fields don't
necessarily match the service codes and categories returned by the DescribeServices
operation. Always use the service codes and categories that the DescribeServices operation
returns, so that you have the most recent set of service and category codes.    You must
have a Business, Enterprise On-Ramp, or Enterprise Support plan to use the Amazon Web
Services Support API.    If you call the Amazon Web Services Support API from an account
that doesn't have a Business, Enterprise On-Ramp, or Enterprise Support plan, the
SubscriptionRequiredException error message appears. For information about changing your
support plan, see Amazon Web Services Support.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"language"`: The language in which Amazon Web Services Support handles the case. Amazon
  Web Services Support currently supports Chinese (“zh”), English (\"en\"), Japanese
  (\"ja\") and Korean (“ko”). You must specify the ISO 639-1 code for the language
  parameter if you want support in that language.
- `"serviceCodeList"`: A JSON-formatted list of service codes available for Amazon Web
  Services services.
"""
function describe_services(; aws_config::AbstractAWSConfig=current_aws_config())
    return support(
        "DescribeServices"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_services(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return support(
        "DescribeServices", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_severity_levels()
    describe_severity_levels(params::Dict{String,<:Any})

Returns the list of severity levels that you can assign to a support case. The severity
level for a case is also a field in the CaseDetails data type that you include for a
CreateCase request.    You must have a Business, Enterprise On-Ramp, or Enterprise Support
plan to use the Amazon Web Services Support API.    If you call the Amazon Web Services
Support API from an account that doesn't have a Business, Enterprise On-Ramp, or Enterprise
Support plan, the SubscriptionRequiredException error message appears. For information
about changing your support plan, see Amazon Web Services Support.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"language"`: The language in which Amazon Web Services Support handles the case. Amazon
  Web Services Support currently supports Chinese (“zh”), English (\"en\"), Japanese
  (\"ja\") and Korean (“ko”). You must specify the ISO 639-1 code for the language
  parameter if you want support in that language.
"""
function describe_severity_levels(; aws_config::AbstractAWSConfig=current_aws_config())
    return support(
        "DescribeSeverityLevels"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_severity_levels(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return support(
        "DescribeSeverityLevels",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_supported_languages(category_code, issue_type, service_code)
    describe_supported_languages(category_code, issue_type, service_code, params::Dict{String,<:Any})

Returns a list of supported languages for a specified categoryCode, issueType and
serviceCode. The returned supported languages will include a ISO 639-1 code for the
language, and the language display name.    You must have a Business, Enterprise On-Ramp,
or Enterprise Support plan to use the Amazon Web Services Support API.    If you call the
Amazon Web Services Support API from an account that doesn't have a Business, Enterprise
On-Ramp, or Enterprise Support plan, the SubscriptionRequiredException error message
appears. For information about changing your support plan, see Amazon Web Services Support.


# Arguments
- `category_code`: The category of problem for the support case. You also use the
  DescribeServices operation to get the category code for a service. Each Amazon Web Services
  service defines its own set of category codes.
- `issue_type`: The type of issue for the case. You can specify customer-service or
  technical.
- `service_code`: The code for the Amazon Web Services service. You can use the
  DescribeServices operation to get the possible serviceCode values.

"""
function describe_supported_languages(
    categoryCode, issueType, serviceCode; aws_config::AbstractAWSConfig=current_aws_config()
)
    return support(
        "DescribeSupportedLanguages",
        Dict{String,Any}(
            "categoryCode" => categoryCode,
            "issueType" => issueType,
            "serviceCode" => serviceCode,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_supported_languages(
    categoryCode,
    issueType,
    serviceCode,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return support(
        "DescribeSupportedLanguages",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "categoryCode" => categoryCode,
                    "issueType" => issueType,
                    "serviceCode" => serviceCode,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_trusted_advisor_check_refresh_statuses(check_ids)
    describe_trusted_advisor_check_refresh_statuses(check_ids, params::Dict{String,<:Any})

Returns the refresh status of the Trusted Advisor checks that have the specified check IDs.
You can get the check IDs by calling the DescribeTrustedAdvisorChecks operation. Some
checks are refreshed automatically, and you can't return their refresh statuses by using
the DescribeTrustedAdvisorCheckRefreshStatuses operation. If you call this operation for
these checks, you might see an InvalidParameterValue error.    You must have a Business,
Enterprise On-Ramp, or Enterprise Support plan to use the Amazon Web Services Support API.
  If you call the Amazon Web Services Support API from an account that doesn't have a
Business, Enterprise On-Ramp, or Enterprise Support plan, the SubscriptionRequiredException
error message appears. For information about changing your support plan, see Amazon Web
Services Support.    To call the Trusted Advisor operations in the Amazon Web Services
Support API, you must use the US East (N. Virginia) endpoint. Currently, the US West
(Oregon) and Europe (Ireland) endpoints don't support the Trusted Advisor operations. For
more information, see About the Amazon Web Services Support API in the Amazon Web Services
Support User Guide.

# Arguments
- `check_ids`: The IDs of the Trusted Advisor checks to get the status.  If you specify the
  check ID of a check that is automatically refreshed, you might see an InvalidParameterValue
  error.

"""
function describe_trusted_advisor_check_refresh_statuses(
    checkIds; aws_config::AbstractAWSConfig=current_aws_config()
)
    return support(
        "DescribeTrustedAdvisorCheckRefreshStatuses",
        Dict{String,Any}("checkIds" => checkIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_trusted_advisor_check_refresh_statuses(
    checkIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return support(
        "DescribeTrustedAdvisorCheckRefreshStatuses",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("checkIds" => checkIds), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_trusted_advisor_check_result(check_id)
    describe_trusted_advisor_check_result(check_id, params::Dict{String,<:Any})

Returns the results of the Trusted Advisor check that has the specified check ID. You can
get the check IDs by calling the DescribeTrustedAdvisorChecks operation. The response
contains a TrustedAdvisorCheckResult object, which contains these three objects:
TrustedAdvisorCategorySpecificSummary     TrustedAdvisorResourceDetail
TrustedAdvisorResourcesSummary    In addition, the response contains these fields:
status - The alert status of the check can be ok (green), warning (yellow), error (red), or
not_available.    timestamp - The time of the last refresh of the check.    checkId - The
unique identifier for the check.      You must have a Business, Enterprise On-Ramp, or
Enterprise Support plan to use the Amazon Web Services Support API.    If you call the
Amazon Web Services Support API from an account that doesn't have a Business, Enterprise
On-Ramp, or Enterprise Support plan, the SubscriptionRequiredException error message
appears. For information about changing your support plan, see Amazon Web Services Support.
   To call the Trusted Advisor operations in the Amazon Web Services Support API, you must
use the US East (N. Virginia) endpoint. Currently, the US West (Oregon) and Europe
(Ireland) endpoints don't support the Trusted Advisor operations. For more information, see
About the Amazon Web Services Support API in the Amazon Web Services Support User Guide.

# Arguments
- `check_id`: The unique identifier for the Trusted Advisor check.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"language"`: The ISO 639-1 code for the language that you want your check results to
  appear in. The Amazon Web Services Support API currently supports the following languages
  for Trusted Advisor:   Chinese, Simplified - zh    Chinese, Traditional - zh_TW    English
  - en    French - fr    German - de    Indonesian - id    Italian - it    Japanese - ja
  Korean - ko    Portuguese, Brazilian - pt_BR    Spanish - es
"""
function describe_trusted_advisor_check_result(
    checkId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return support(
        "DescribeTrustedAdvisorCheckResult",
        Dict{String,Any}("checkId" => checkId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_trusted_advisor_check_result(
    checkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return support(
        "DescribeTrustedAdvisorCheckResult",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("checkId" => checkId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_trusted_advisor_check_summaries(check_ids)
    describe_trusted_advisor_check_summaries(check_ids, params::Dict{String,<:Any})

Returns the results for the Trusted Advisor check summaries for the check IDs that you
specified. You can get the check IDs by calling the DescribeTrustedAdvisorChecks operation.
The response contains an array of TrustedAdvisorCheckSummary objects.    You must have a
Business, Enterprise On-Ramp, or Enterprise Support plan to use the Amazon Web Services
Support API.    If you call the Amazon Web Services Support API from an account that
doesn't have a Business, Enterprise On-Ramp, or Enterprise Support plan, the
SubscriptionRequiredException error message appears. For information about changing your
support plan, see Amazon Web Services Support.    To call the Trusted Advisor operations in
the Amazon Web Services Support API, you must use the US East (N. Virginia) endpoint.
Currently, the US West (Oregon) and Europe (Ireland) endpoints don't support the Trusted
Advisor operations. For more information, see About the Amazon Web Services Support API in
the Amazon Web Services Support User Guide.

# Arguments
- `check_ids`: The IDs of the Trusted Advisor checks.

"""
function describe_trusted_advisor_check_summaries(
    checkIds; aws_config::AbstractAWSConfig=current_aws_config()
)
    return support(
        "DescribeTrustedAdvisorCheckSummaries",
        Dict{String,Any}("checkIds" => checkIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_trusted_advisor_check_summaries(
    checkIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return support(
        "DescribeTrustedAdvisorCheckSummaries",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("checkIds" => checkIds), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_trusted_advisor_checks(language)
    describe_trusted_advisor_checks(language, params::Dict{String,<:Any})

Returns information about all available Trusted Advisor checks, including the name, ID,
category, description, and metadata. You must specify a language code. The response
contains a TrustedAdvisorCheckDescription object for each check. You must set the Amazon
Web Services Region to us-east-1.    You must have a Business, Enterprise On-Ramp, or
Enterprise Support plan to use the Amazon Web Services Support API.    If you call the
Amazon Web Services Support API from an account that doesn't have a Business, Enterprise
On-Ramp, or Enterprise Support plan, the SubscriptionRequiredException error message
appears. For information about changing your support plan, see Amazon Web Services Support.
  The names and descriptions for Trusted Advisor checks are subject to change. We recommend
that you specify the check ID in your code to uniquely identify a check.    To call the
Trusted Advisor operations in the Amazon Web Services Support API, you must use the US East
(N. Virginia) endpoint. Currently, the US West (Oregon) and Europe (Ireland) endpoints
don't support the Trusted Advisor operations. For more information, see About the Amazon
Web Services Support API in the Amazon Web Services Support User Guide.

# Arguments
- `language`: The ISO 639-1 code for the language that you want your checks to appear in.
  The Amazon Web Services Support API currently supports the following languages for Trusted
  Advisor:   Chinese, Simplified - zh    Chinese, Traditional - zh_TW    English - en
  French - fr    German - de    Indonesian - id    Italian - it    Japanese - ja    Korean -
  ko    Portuguese, Brazilian - pt_BR    Spanish - es

"""
function describe_trusted_advisor_checks(
    language; aws_config::AbstractAWSConfig=current_aws_config()
)
    return support(
        "DescribeTrustedAdvisorChecks",
        Dict{String,Any}("language" => language);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_trusted_advisor_checks(
    language,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return support(
        "DescribeTrustedAdvisorChecks",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("language" => language), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    refresh_trusted_advisor_check(check_id)
    refresh_trusted_advisor_check(check_id, params::Dict{String,<:Any})

Refreshes the Trusted Advisor check that you specify using the check ID. You can get the
check IDs by calling the DescribeTrustedAdvisorChecks operation. Some checks are refreshed
automatically. If you call the RefreshTrustedAdvisorCheck operation to refresh them, you
might see the InvalidParameterValue error. The response contains a
TrustedAdvisorCheckRefreshStatus object.    You must have a Business, Enterprise On-Ramp,
or Enterprise Support plan to use the Amazon Web Services Support API.    If you call the
Amazon Web Services Support API from an account that doesn't have a Business, Enterprise
On-Ramp, or Enterprise Support plan, the SubscriptionRequiredException error message
appears. For information about changing your support plan, see Amazon Web Services Support.
   To call the Trusted Advisor operations in the Amazon Web Services Support API, you must
use the US East (N. Virginia) endpoint. Currently, the US West (Oregon) and Europe
(Ireland) endpoints don't support the Trusted Advisor operations. For more information, see
About the Amazon Web Services Support API in the Amazon Web Services Support User Guide.

# Arguments
- `check_id`: The unique identifier for the Trusted Advisor check to refresh.  Specifying
  the check ID of a check that is automatically refreshed causes an InvalidParameterValue
  error.

"""
function refresh_trusted_advisor_check(
    checkId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return support(
        "RefreshTrustedAdvisorCheck",
        Dict{String,Any}("checkId" => checkId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function refresh_trusted_advisor_check(
    checkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return support(
        "RefreshTrustedAdvisorCheck",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("checkId" => checkId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    resolve_case()
    resolve_case(params::Dict{String,<:Any})

Resolves a support case. This operation takes a caseId and returns the initial and final
state of the case.    You must have a Business, Enterprise On-Ramp, or Enterprise Support
plan to use the Amazon Web Services Support API.    If you call the Amazon Web Services
Support API from an account that doesn't have a Business, Enterprise On-Ramp, or Enterprise
Support plan, the SubscriptionRequiredException error message appears. For information
about changing your support plan, see Amazon Web Services Support.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"caseId"`: The support case ID requested or returned in the call. The case ID is an
  alphanumeric string formatted as shown in this example:
  case-12345678910-2013-c4c1d2bf33c5cf47
"""
function resolve_case(; aws_config::AbstractAWSConfig=current_aws_config())
    return support("ResolveCase"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function resolve_case(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return support(
        "ResolveCase", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: ecr_public
using AWS.Compat
using AWS.UUIDs

"""
    batch_check_layer_availability(layer_digests, repository_name)
    batch_check_layer_availability(layer_digests, repository_name, params::Dict{String,<:Any})

Checks the availability of one or more image layers that are within a repository in a
public registry. When an image is pushed to a repository, each image layer is checked to
verify if it has been uploaded before. If it has been uploaded, then the image layer is
skipped.  This operation is used by the Amazon ECR proxy and is not generally used by
customers for pulling and pushing images. In most cases, you should use the docker CLI to
pull, tag, and push images.

# Arguments
- `layer_digests`: The digests of the image layers to check.
- `repository_name`: The name of the repository that's associated with the image layers to
  check.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"registryId"`: The Amazon Web Services account ID, or registry alias, associated with
  the public registry that contains the image layers to check. If you do not specify a
  registry, the default public registry is assumed.
"""
function batch_check_layer_availability(
    layerDigests, repositoryName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecr_public(
        "BatchCheckLayerAvailability",
        Dict{String,Any}(
            "layerDigests" => layerDigests, "repositoryName" => repositoryName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_check_layer_availability(
    layerDigests,
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecr_public(
        "BatchCheckLayerAvailability",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "layerDigests" => layerDigests, "repositoryName" => repositoryName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_delete_image(image_ids, repository_name)
    batch_delete_image(image_ids, repository_name, params::Dict{String,<:Any})

Deletes a list of specified images that are within a repository in a public registry.
Images are specified with either an imageTag or imageDigest. You can remove a tag from an
image by specifying the image's tag in your request. When you remove the last tag from an
image, the image is deleted from your repository. You can completely delete an image (and
all of its tags) by specifying the digest of the image in your request.

# Arguments
- `image_ids`: A list of image ID references that correspond to images to delete. The
  format of the imageIds reference is imageTag=tag or imageDigest=digest.
- `repository_name`: The repository in a public registry that contains the image to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"registryId"`: The Amazon Web Services account ID, or registry alias, that's associated
  with the registry that contains the image to delete. If you do not specify a registry, the
  default public registry is assumed.
"""
function batch_delete_image(
    imageIds, repositoryName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecr_public(
        "BatchDeleteImage",
        Dict{String,Any}("imageIds" => imageIds, "repositoryName" => repositoryName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_delete_image(
    imageIds,
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecr_public(
        "BatchDeleteImage",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "imageIds" => imageIds, "repositoryName" => repositoryName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    complete_layer_upload(layer_digests, repository_name, upload_id)
    complete_layer_upload(layer_digests, repository_name, upload_id, params::Dict{String,<:Any})

Informs Amazon ECR that the image layer upload is complete for a specified public registry,
repository name, and upload ID. You can optionally provide a sha256 digest of the image
layer for data validation purposes. When an image is pushed, the CompleteLayerUpload API is
called once for each new image layer to verify that the upload is complete.  This operation
is used by the Amazon ECR proxy and is not generally used by customers for pulling and
pushing images. In most cases, you should use the docker CLI to pull, tag, and push images.

# Arguments
- `layer_digests`: The sha256 digest of the image layer.
- `repository_name`: The name of the repository in a public registry to associate with the
  image layer.
- `upload_id`: The upload ID from a previous InitiateLayerUpload operation to associate
  with the image layer.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"registryId"`: The Amazon Web Services account ID, or registry alias, associated with
  the registry where layers are uploaded. If you do not specify a registry, the default
  public registry is assumed.
"""
function complete_layer_upload(
    layerDigests,
    repositoryName,
    uploadId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecr_public(
        "CompleteLayerUpload",
        Dict{String,Any}(
            "layerDigests" => layerDigests,
            "repositoryName" => repositoryName,
            "uploadId" => uploadId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function complete_layer_upload(
    layerDigests,
    repositoryName,
    uploadId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecr_public(
        "CompleteLayerUpload",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "layerDigests" => layerDigests,
                    "repositoryName" => repositoryName,
                    "uploadId" => uploadId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_repository(repository_name)
    create_repository(repository_name, params::Dict{String,<:Any})

Creates a repository in a public registry. For more information, see Amazon ECR
repositories in the Amazon Elastic Container Registry User Guide.

# Arguments
- `repository_name`: The name to use for the repository. This appears publicly in the
  Amazon ECR Public Gallery. The repository name can be specified on its own (for example
  nginx-web-app) or prepended with a namespace to group the repository into a category (for
  example project-a/nginx-web-app).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"catalogData"`: The details about the repository that are publicly visible in the Amazon
  ECR Public Gallery.
- `"tags"`: The metadata that you apply to each repository to help categorize and organize
  your repositories. Each tag consists of a key and an optional value. You define both of
  them. Tag keys can have a maximum character length of 128 characters, and tag values can
  have a maximum length of 256 characters.
"""
function create_repository(
    repositoryName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecr_public(
        "CreateRepository",
        Dict{String,Any}("repositoryName" => repositoryName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_repository(
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecr_public(
        "CreateRepository",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("repositoryName" => repositoryName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_repository(repository_name)
    delete_repository(repository_name, params::Dict{String,<:Any})

Deletes a repository in a public registry. If the repository contains images, you must
either manually delete all images in the repository or use the force option. This option
deletes all images on your behalf before deleting the repository.

# Arguments
- `repository_name`: The name of the repository to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"force"`:  The force option can be used to delete a repository that contains images. If
  the force option is not used, the repository must be empty prior to deletion.
- `"registryId"`: The Amazon Web Services account ID that's associated with the public
  registry that contains the repository to delete. If you do not specify a registry, the
  default public registry is assumed.
"""
function delete_repository(
    repositoryName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecr_public(
        "DeleteRepository",
        Dict{String,Any}("repositoryName" => repositoryName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_repository(
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecr_public(
        "DeleteRepository",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("repositoryName" => repositoryName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_repository_policy(repository_name)
    delete_repository_policy(repository_name, params::Dict{String,<:Any})

Deletes the repository policy that's associated with the specified repository.

# Arguments
- `repository_name`: The name of the repository that's associated with the repository
  policy to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"registryId"`: The Amazon Web Services account ID that's associated with the public
  registry that contains the repository policy to delete. If you do not specify a registry,
  the default public registry is assumed.
"""
function delete_repository_policy(
    repositoryName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecr_public(
        "DeleteRepositoryPolicy",
        Dict{String,Any}("repositoryName" => repositoryName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_repository_policy(
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecr_public(
        "DeleteRepositoryPolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("repositoryName" => repositoryName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_image_tags(repository_name)
    describe_image_tags(repository_name, params::Dict{String,<:Any})

Returns the image tag details for a repository in a public registry.

# Arguments
- `repository_name`: The name of the repository that contains the image tag details to
  describe.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of repository results that's returned by
  DescribeImageTags in paginated output. When this parameter is used, DescribeImageTags only
  returns maxResults results in a single page along with a nextToken response element. You
  can see the remaining results of the initial request by sending another DescribeImageTags
  request with the returned nextToken value. This value can be between 1 and 1000. If this
  parameter isn't used, then DescribeImageTags returns up to 100 results and a nextToken
  value, if applicable. If you specify images with imageIds, you can't use this option.
- `"nextToken"`: The nextToken value that's returned from a previous paginated
  DescribeImageTags request where maxResults was used and the results exceeded the value of
  that parameter. Pagination continues from the end of the previous results that returned the
  nextToken value. If there are no more results to return, this value is null. If you specify
  images with imageIds, you can't use this option.
- `"registryId"`: The Amazon Web Services account ID that's associated with the public
  registry that contains the repository where images are described. If you do not specify a
  registry, the default public registry is assumed.
"""
function describe_image_tags(
    repositoryName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecr_public(
        "DescribeImageTags",
        Dict{String,Any}("repositoryName" => repositoryName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_image_tags(
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecr_public(
        "DescribeImageTags",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("repositoryName" => repositoryName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_images(repository_name)
    describe_images(repository_name, params::Dict{String,<:Any})

Returns metadata that's related to the images in a repository in a public registry.
Beginning with Docker version 1.9, the Docker client compresses image layers before pushing
them to a V2 Docker registry. The output of the docker images command shows the
uncompressed image size. Therefore, it might return a larger image size than the image
sizes that are returned by DescribeImages.

# Arguments
- `repository_name`: The repository that contains the images to describe.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"imageIds"`: The list of image IDs for the requested repository.
- `"maxResults"`: The maximum number of repository results that's returned by
  DescribeImages in paginated output. When this parameter is used, DescribeImages only
  returns maxResults results in a single page along with a nextToken response element. You
  can see the remaining results of the initial request by sending another DescribeImages
  request with the returned nextToken value. This value can be between 1 and 1000. If this
  parameter isn't used, then DescribeImages returns up to 100 results and a nextToken value,
  if applicable. If you specify images with imageIds, you can't use this option.
- `"nextToken"`: The nextToken value that's returned from a previous paginated
  DescribeImages request where maxResults was used and the results exceeded the value of that
  parameter. Pagination continues from the end of the previous results that returned the
  nextToken value. If there are no more results to return, this value is null. If you specify
  images with imageIds, you can't use this option.
- `"registryId"`: The Amazon Web Services account ID that's associated with the public
  registry that contains the repository where images are described. If you do not specify a
  registry, the default public registry is assumed.
"""
function describe_images(repositoryName; aws_config::AbstractAWSConfig=current_aws_config())
    return ecr_public(
        "DescribeImages",
        Dict{String,Any}("repositoryName" => repositoryName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_images(
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecr_public(
        "DescribeImages",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("repositoryName" => repositoryName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_registries()
    describe_registries(params::Dict{String,<:Any})

Returns details for a public registry.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of repository results that's returned by
  DescribeRegistries in paginated output. When this parameter is used, DescribeRegistries
  only returns maxResults results in a single page along with a nextToken response element.
  The remaining results of the initial request can be seen by sending another
  DescribeRegistries request with the returned nextToken value. This value can be between 1
  and 1000. If this parameter isn't used, then DescribeRegistries returns up to 100 results
  and a nextToken value, if applicable.
- `"nextToken"`: The nextToken value that's returned from a previous paginated
  DescribeRegistries request where maxResults was used and the results exceeded the value of
  that parameter. Pagination continues from the end of the previous results that returned the
  nextToken value. If there are no more results to return, this value is null.  This token
  should be treated as an opaque identifier that is only used to retrieve the next items in a
  list and not for other programmatic purposes.
"""
function describe_registries(; aws_config::AbstractAWSConfig=current_aws_config())
    return ecr_public(
        "DescribeRegistries"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_registries(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecr_public(
        "DescribeRegistries", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_repositories()
    describe_repositories(params::Dict{String,<:Any})

Describes repositories that are in a public registry.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of repository results that's returned by
  DescribeRepositories in paginated output. When this parameter is used, DescribeRepositories
  only returns maxResults results in a single page along with a nextToken response element.
  You can see the remaining results of the initial request by sending another
  DescribeRepositories request with the returned nextToken value. This value can be between 1
  and 1000. If this parameter isn't used, then DescribeRepositories returns up to 100 results
  and a nextToken value, if applicable. If you specify repositories with repositoryNames, you
  can't use this option.
- `"nextToken"`: The nextToken value that's returned from a previous paginated
  DescribeRepositories request where maxResults was used and the results exceeded the value
  of that parameter. Pagination continues from the end of the previous results that returned
  the nextToken value. If there are no more results to return, this value is null. If you
  specify repositories with repositoryNames, you can't use this option.  This token should be
  treated as an opaque identifier that is only used to retrieve the next items in a list and
  not for other programmatic purposes.
- `"registryId"`: The Amazon Web Services account ID that's associated with the registry
  that contains the repositories to be described. If you do not specify a registry, the
  default public registry is assumed.
- `"repositoryNames"`: A list of repositories to describe. If this parameter is omitted,
  then all repositories in a registry are described.
"""
function describe_repositories(; aws_config::AbstractAWSConfig=current_aws_config())
    return ecr_public(
        "DescribeRepositories"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_repositories(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecr_public(
        "DescribeRepositories",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_authorization_token()
    get_authorization_token(params::Dict{String,<:Any})

Retrieves an authorization token. An authorization token represents your IAM authentication
credentials. You can use it to access any Amazon ECR registry that your IAM principal has
access to. The authorization token is valid for 12 hours. This API requires the
ecr-public:GetAuthorizationToken and sts:GetServiceBearerToken permissions.

"""
function get_authorization_token(; aws_config::AbstractAWSConfig=current_aws_config())
    return ecr_public(
        "GetAuthorizationToken"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_authorization_token(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecr_public(
        "GetAuthorizationToken",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_registry_catalog_data()
    get_registry_catalog_data(params::Dict{String,<:Any})

Retrieves catalog metadata for a public registry.

"""
function get_registry_catalog_data(; aws_config::AbstractAWSConfig=current_aws_config())
    return ecr_public(
        "GetRegistryCatalogData"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_registry_catalog_data(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecr_public(
        "GetRegistryCatalogData",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_repository_catalog_data(repository_name)
    get_repository_catalog_data(repository_name, params::Dict{String,<:Any})

Retrieve catalog metadata for a repository in a public registry. This metadata is displayed
publicly in the Amazon ECR Public Gallery.

# Arguments
- `repository_name`: The name of the repository to retrieve the catalog metadata for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"registryId"`: The Amazon Web Services account ID that's associated with the registry
  that contains the repositories to be described. If you do not specify a registry, the
  default public registry is assumed.
"""
function get_repository_catalog_data(
    repositoryName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecr_public(
        "GetRepositoryCatalogData",
        Dict{String,Any}("repositoryName" => repositoryName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_repository_catalog_data(
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecr_public(
        "GetRepositoryCatalogData",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("repositoryName" => repositoryName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_repository_policy(repository_name)
    get_repository_policy(repository_name, params::Dict{String,<:Any})

Retrieves the repository policy for the specified repository.

# Arguments
- `repository_name`: The name of the repository with the policy to retrieve.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"registryId"`: The Amazon Web Services account ID that's associated with the public
  registry that contains the repository. If you do not specify a registry, the default public
  registry is assumed.
"""
function get_repository_policy(
    repositoryName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecr_public(
        "GetRepositoryPolicy",
        Dict{String,Any}("repositoryName" => repositoryName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_repository_policy(
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecr_public(
        "GetRepositoryPolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("repositoryName" => repositoryName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    initiate_layer_upload(repository_name)
    initiate_layer_upload(repository_name, params::Dict{String,<:Any})

Notifies Amazon ECR that you intend to upload an image layer. When an image is pushed, the
InitiateLayerUpload API is called once for each image layer that hasn't already been
uploaded. Whether an image layer uploads is determined by the BatchCheckLayerAvailability
API action.  This operation is used by the Amazon ECR proxy and is not generally used by
customers for pulling and pushing images. In most cases, you should use the docker CLI to
pull, tag, and push images.

# Arguments
- `repository_name`: The name of the repository that you want to upload layers to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"registryId"`: The Amazon Web Services account ID, or registry alias, that's associated
  with the registry to which you intend to upload layers. If you do not specify a registry,
  the default public registry is assumed.
"""
function initiate_layer_upload(
    repositoryName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecr_public(
        "InitiateLayerUpload",
        Dict{String,Any}("repositoryName" => repositoryName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function initiate_layer_upload(
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecr_public(
        "InitiateLayerUpload",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("repositoryName" => repositoryName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

List the tags for an Amazon ECR Public resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) that identifies the resource to list the
  tags for. Currently, the supported resource is an Amazon ECR Public repository.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecr_public(
        "ListTagsForResource",
        Dict{String,Any}("resourceArn" => resourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecr_public(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceArn" => resourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_image(image_manifest, repository_name)
    put_image(image_manifest, repository_name, params::Dict{String,<:Any})

Creates or updates the image manifest and tags that are associated with an image. When an
image is pushed and all new image layers have been uploaded, the PutImage API is called
once to create or update the image manifest and the tags that are associated with the
image.  This operation is used by the Amazon ECR proxy and is not generally used by
customers for pulling and pushing images. In most cases, you should use the docker CLI to
pull, tag, and push images.

# Arguments
- `image_manifest`: The image manifest that corresponds to the image to be uploaded.
- `repository_name`: The name of the repository where the image is put.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"imageDigest"`: The image digest of the image manifest that corresponds to the image.
- `"imageManifestMediaType"`: The media type of the image manifest. If you push an image
  manifest that doesn't contain the mediaType field, you must specify the
  imageManifestMediaType in the request.
- `"imageTag"`: The tag to associate with the image. This parameter is required for images
  that use the Docker Image Manifest V2 Schema 2 or Open Container Initiative (OCI) formats.
- `"registryId"`: The Amazon Web Services account ID, or registry alias, that's associated
  with the public registry that contains the repository where the image is put. If you do not
  specify a registry, the default public registry is assumed.
"""
function put_image(
    imageManifest, repositoryName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecr_public(
        "PutImage",
        Dict{String,Any}(
            "imageManifest" => imageManifest, "repositoryName" => repositoryName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_image(
    imageManifest,
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecr_public(
        "PutImage",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "imageManifest" => imageManifest, "repositoryName" => repositoryName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_registry_catalog_data()
    put_registry_catalog_data(params::Dict{String,<:Any})

Create or update the catalog data for a public registry.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"displayName"`: The display name for a public registry. The display name is shown as the
  repository author in the Amazon ECR Public Gallery.  The registry display name is only
  publicly visible in the Amazon ECR Public Gallery for verified accounts.
"""
function put_registry_catalog_data(; aws_config::AbstractAWSConfig=current_aws_config())
    return ecr_public(
        "PutRegistryCatalogData"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function put_registry_catalog_data(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecr_public(
        "PutRegistryCatalogData",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_repository_catalog_data(catalog_data, repository_name)
    put_repository_catalog_data(catalog_data, repository_name, params::Dict{String,<:Any})

Creates or updates the catalog data for a repository in a public registry.

# Arguments
- `catalog_data`: An object containing the catalog data for a repository. This data is
  publicly visible in the Amazon ECR Public Gallery.
- `repository_name`: The name of the repository to create or update the catalog data for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"registryId"`: The Amazon Web Services account ID that's associated with the public
  registry the repository is in. If you do not specify a registry, the default public
  registry is assumed.
"""
function put_repository_catalog_data(
    catalogData, repositoryName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecr_public(
        "PutRepositoryCatalogData",
        Dict{String,Any}("catalogData" => catalogData, "repositoryName" => repositoryName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_repository_catalog_data(
    catalogData,
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecr_public(
        "PutRepositoryCatalogData",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "catalogData" => catalogData, "repositoryName" => repositoryName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    set_repository_policy(policy_text, repository_name)
    set_repository_policy(policy_text, repository_name, params::Dict{String,<:Any})

Applies a repository policy to the specified public repository to control access
permissions. For more information, see Amazon ECR Repository Policies in the Amazon Elastic
Container Registry User Guide.

# Arguments
- `policy_text`: The JSON repository policy text to apply to the repository. For more
  information, see Amazon ECR Repository Policies in the Amazon Elastic Container Registry
  User Guide.
- `repository_name`: The name of the repository to receive the policy.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"force"`: If the policy that you want to set on a repository policy would prevent you
  from setting another policy in the future, you must force the SetRepositoryPolicy
  operation. This prevents accidental repository lockouts.
- `"registryId"`: The Amazon Web Services account ID that's associated with the registry
  that contains the repository. If you do not specify a registry, the default public registry
  is assumed.
"""
function set_repository_policy(
    policyText, repositoryName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecr_public(
        "SetRepositoryPolicy",
        Dict{String,Any}("policyText" => policyText, "repositoryName" => repositoryName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function set_repository_policy(
    policyText,
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecr_public(
        "SetRepositoryPolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "policyText" => policyText, "repositoryName" => repositoryName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Associates the specified tags to a resource with the specified resourceArn. If existing
tags on a resource aren't specified in the request parameters, they aren't changed. When a
resource is deleted, the tags associated with that resource are also deleted.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource to add tags to. Currently,
  the supported resource is an Amazon ECR Public repository.
- `tags`: The tags to add to the resource. A tag is an array of key-value pairs. Tag keys
  can have a maximum character length of 128 characters, and tag values can have a maximum
  length of 256 characters.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return ecr_public(
        "TagResource",
        Dict{String,Any}("resourceArn" => resourceArn, "tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecr_public(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceArn" => resourceArn, "tags" => tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Deletes specified tags from a resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource to delete tags from.
  Currently, the supported resource is an Amazon ECR Public repository.
- `tag_keys`: The keys of the tags to be removed.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecr_public(
        "UntagResource",
        Dict{String,Any}("resourceArn" => resourceArn, "tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecr_public(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceArn" => resourceArn, "tagKeys" => tagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    upload_layer_part(layer_part_blob, part_first_byte, part_last_byte, repository_name, upload_id)
    upload_layer_part(layer_part_blob, part_first_byte, part_last_byte, repository_name, upload_id, params::Dict{String,<:Any})

Uploads an image layer part to Amazon ECR. When an image is pushed, each new image layer is
uploaded in parts. The maximum size of each image layer part can be 20971520 bytes (about
20MB). The UploadLayerPart API is called once for each new image layer part.  This
operation is used by the Amazon ECR proxy and is not generally used by customers for
pulling and pushing images. In most cases, you should use the docker CLI to pull, tag, and
push images.

# Arguments
- `layer_part_blob`: The base64-encoded layer part payload.
- `part_first_byte`: The position of the first byte of the layer part witin the overall
  image layer.
- `part_last_byte`: The position of the last byte of the layer part within the overall
  image layer.
- `repository_name`: The name of the repository that you're uploading layer parts to.
- `upload_id`: The upload ID from a previous InitiateLayerUpload operation to associate
  with the layer part upload.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"registryId"`: The Amazon Web Services account ID, or registry alias, that's associated
  with the registry that you're uploading layer parts to. If you do not specify a registry,
  the default public registry is assumed.
"""
function upload_layer_part(
    layerPartBlob,
    partFirstByte,
    partLastByte,
    repositoryName,
    uploadId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecr_public(
        "UploadLayerPart",
        Dict{String,Any}(
            "layerPartBlob" => layerPartBlob,
            "partFirstByte" => partFirstByte,
            "partLastByte" => partLastByte,
            "repositoryName" => repositoryName,
            "uploadId" => uploadId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function upload_layer_part(
    layerPartBlob,
    partFirstByte,
    partLastByte,
    repositoryName,
    uploadId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecr_public(
        "UploadLayerPart",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "layerPartBlob" => layerPartBlob,
                    "partFirstByte" => partFirstByte,
                    "partLastByte" => partLastByte,
                    "repositoryName" => repositoryName,
                    "uploadId" => uploadId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: sts
using AWS.Compat
using AWS.UUIDs

"""
    assume_role(role_arn, role_session_name)
    assume_role(role_arn, role_session_name, params::Dict{String,<:Any})

Returns a set of temporary security credentials that you can use to access Amazon Web
Services resources. These temporary credentials consist of an access key ID, a secret
access key, and a security token. Typically, you use AssumeRole within your account or for
cross-account access. For a comparison of AssumeRole with other API operations that produce
temporary credentials, see Requesting Temporary Security Credentials and Comparing the
Amazon Web Services STS API operations in the IAM User Guide.  Permissions  The temporary
security credentials created by AssumeRole can be used to make API calls to any Amazon Web
Services service with the following exception: You cannot call the Amazon Web Services STS
GetFederationToken or GetSessionToken API operations. (Optional) You can pass inline or
managed session policies to this operation. You can pass a single JSON policy document to
use as an inline session policy. You can also specify up to 10 managed policy Amazon
Resource Names (ARNs) to use as managed session policies. The plaintext that you use for
both inline and managed session policies can't exceed 2,048 characters. Passing policies to
this operation returns new temporary credentials. The resulting session's permissions are
the intersection of the role's identity-based policy and the session policies. You can use
the role's temporary credentials in subsequent Amazon Web Services API calls to access
resources in the account that owns the role. You cannot use session policies to grant more
permissions than those allowed by the identity-based policy of the role that is being
assumed. For more information, see Session Policies in the IAM User Guide. When you create
a role, you create two policies: a role trust policy that specifies who can assume the
role, and a permissions policy that specifies what can be done with the role. You specify
the trusted principal that is allowed to assume the role in the role trust policy. To
assume a role from a different account, your Amazon Web Services account must be trusted by
the role. The trust relationship is defined in the role's trust policy when the role is
created. That trust policy states which accounts are allowed to delegate that access to
users in the account.  A user who wants to access a role in a different account must also
have permissions that are delegated from the account administrator. The administrator must
attach a policy that allows the user to call AssumeRole for the ARN of the role in the
other account. To allow a user to assume a role in the same account, you can do either of
the following:   Attach a policy to the user that allows the user to call AssumeRole (as
long as the role's trust policy trusts the account).   Add the user as a principal directly
in the role's trust policy.   You can do either because the role’s trust policy acts as
an IAM resource-based policy. When a resource-based policy grants access to a principal in
the same account, no additional identity-based policy is required. For more information
about trust policies and resource-based policies, see IAM Policies in the IAM User Guide.
Tags  (Optional) You can pass tag key-value pairs to your session. These tags are called
session tags. For more information about session tags, see Passing Session Tags in STS in
the IAM User Guide. An administrator must grant you the permissions necessary to pass
session tags. The administrator can also create granular permissions to allow you to pass
only specific session tags. For more information, see Tutorial: Using Tags for
Attribute-Based Access Control in the IAM User Guide. You can set the session tags as
transitive. Transitive tags persist during role chaining. For more information, see
Chaining Roles with Session Tags in the IAM User Guide.  Using MFA with AssumeRole
(Optional) You can include multi-factor authentication (MFA) information when you call
AssumeRole. This is useful for cross-account scenarios to ensure that the user that assumes
the role has been authenticated with an Amazon Web Services MFA device. In that scenario,
the trust policy of the role being assumed includes a condition that tests for MFA
authentication. If the caller does not include valid MFA information, the request to assume
the role is denied. The condition in a trust policy that tests for MFA authentication might
look like the following example.  \"Condition\": {\"Bool\":
{\"aws:MultiFactorAuthPresent\": true}}  For more information, see Configuring
MFA-Protected API Access in the IAM User Guide guide. To use MFA with AssumeRole, you pass
values for the SerialNumber and TokenCode parameters. The SerialNumber value identifies the
user's hardware or virtual MFA device. The TokenCode is the time-based one-time password
(TOTP) that the MFA device produces.

# Arguments
- `role_arn`: The Amazon Resource Name (ARN) of the role to assume.
- `role_session_name`: An identifier for the assumed role session. Use the role session
  name to uniquely identify a session when the same role is assumed by different principals
  or for different reasons. In cross-account scenarios, the role session name is visible to,
  and can be logged by the account that owns the role. The role session name is also used in
  the ARN of the assumed role principal. This means that subsequent cross-account API
  requests that use the temporary security credentials will expose the role session name to
  the external account in their CloudTrail logs. The regex used to validate this parameter is
  a string of characters consisting of upper- and lower-case alphanumeric characters with no
  spaces. You can also include underscores or any of the following characters: =,.@-

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DurationSeconds"`: The duration, in seconds, of the role session. The value specified
  can range from 900 seconds (15 minutes) up to the maximum session duration set for the
  role. The maximum session duration setting can have a value from 1 hour to 12 hours. If you
  specify a value higher than this setting or the administrator setting (whichever is lower),
  the operation fails. For example, if you specify a session duration of 12 hours, but your
  administrator set the maximum session duration to 6 hours, your operation fails.  Role
  chaining limits your Amazon Web Services CLI or Amazon Web Services API role session to a
  maximum of one hour. When you use the AssumeRole API operation to assume a role, you can
  specify the duration of your role session with the DurationSeconds parameter. You can
  specify a parameter value of up to 43200 seconds (12 hours), depending on the maximum
  session duration setting for your role. However, if you assume a role using role chaining
  and provide a DurationSeconds parameter value greater than one hour, the operation fails.
  To learn how to view the maximum value for your role, see View the Maximum Session Duration
  Setting for a Role in the IAM User Guide. By default, the value is set to 3600 seconds.
  The DurationSeconds parameter is separate from the duration of a console session that you
  might request using the returned credentials. The request to the federation endpoint for a
  console sign-in token takes a SessionDuration parameter that specifies the maximum length
  of the console session. For more information, see Creating a URL that Enables Federated
  Users to Access the Amazon Web Services Management Console in the IAM User Guide.
- `"ExternalId"`: A unique identifier that might be required when you assume a role in
  another account. If the administrator of the account to which the role belongs provided you
  with an external ID, then provide that value in the ExternalId parameter. This value can be
  any string, such as a passphrase or account number. A cross-account role is usually set up
  to trust everyone in an account. Therefore, the administrator of the trusting account might
  send an external ID to the administrator of the trusted account. That way, only someone
  with the ID can assume the role, rather than everyone in the account. For more information
  about the external ID, see How to Use an External ID When Granting Access to Your Amazon
  Web Services Resources to a Third Party in the IAM User Guide. The regex used to validate
  this parameter is a string of characters consisting of upper- and lower-case alphanumeric
  characters with no spaces. You can also include underscores or any of the following
  characters: =,.@:/-
- `"Policy"`: An IAM policy in JSON format that you want to use as an inline session
  policy. This parameter is optional. Passing policies to this operation returns new
  temporary credentials. The resulting session's permissions are the intersection of the
  role's identity-based policy and the session policies. You can use the role's temporary
  credentials in subsequent Amazon Web Services API calls to access resources in the account
  that owns the role. You cannot use session policies to grant more permissions than those
  allowed by the identity-based policy of the role that is being assumed. For more
  information, see Session Policies in the IAM User Guide. The plaintext that you use for
  both inline and managed session policies can't exceed 2,048 characters. The JSON policy
  characters can be any ASCII character from the space character to the end of the valid
  character list (u0020 through u00FF). It can also include the tab (u0009), linefeed
  (u000A), and carriage return (u000D) characters.  An Amazon Web Services conversion
  compresses the passed inline session policy, managed policy ARNs, and session tags into a
  packed binary format that has a separate limit. Your request can fail for this limit even
  if your plaintext meets the other requirements. The PackedPolicySize response element
  indicates by percentage how close the policies and tags for your request are to the upper
  size limit.
- `"PolicyArns"`: The Amazon Resource Names (ARNs) of the IAM managed policies that you
  want to use as managed session policies. The policies must exist in the same account as the
  role. This parameter is optional. You can provide up to 10 managed policy ARNs. However,
  the plaintext that you use for both inline and managed session policies can't exceed 2,048
  characters. For more information about ARNs, see Amazon Resource Names (ARNs) and Amazon
  Web Services Service Namespaces in the Amazon Web Services General Reference.  An Amazon
  Web Services conversion compresses the passed inline session policy, managed policy ARNs,
  and session tags into a packed binary format that has a separate limit. Your request can
  fail for this limit even if your plaintext meets the other requirements. The
  PackedPolicySize response element indicates by percentage how close the policies and tags
  for your request are to the upper size limit.  Passing policies to this operation returns
  new temporary credentials. The resulting session's permissions are the intersection of the
  role's identity-based policy and the session policies. You can use the role's temporary
  credentials in subsequent Amazon Web Services API calls to access resources in the account
  that owns the role. You cannot use session policies to grant more permissions than those
  allowed by the identity-based policy of the role that is being assumed. For more
  information, see Session Policies in the IAM User Guide.
- `"ProvidedContexts"`: A list of previously acquired trusted context assertions in the
  format of a JSON array. The trusted context assertion is signed and encrypted by Amazon Web
  Services STS. The following is an example of a ProvidedContext value that includes a single
  trusted context assertion and the ARN of the context provider from which the trusted
  context assertion was generated.
  [{\"ProviderArn\":\"arn:aws:iam::aws:contextProvider/IdentityCenter\",\"ContextAssertion
  \":\"trusted-context-assertion\"}]
- `"SerialNumber"`: The identification number of the MFA device that is associated with the
  user who is making the AssumeRole call. Specify this value if the trust policy of the role
  being assumed includes a condition that requires MFA authentication. The value is either
  the serial number for a hardware device (such as GAHT12345678) or an Amazon Resource Name
  (ARN) for a virtual device (such as arn:aws:iam::123456789012:mfa/user). The regex used to
  validate this parameter is a string of characters consisting of upper- and lower-case
  alphanumeric characters with no spaces. You can also include underscores or any of the
  following characters: =,.@-
- `"SourceIdentity"`: The source identity specified by the principal that is calling the
  AssumeRole operation. You can require users to specify a source identity when they assume a
  role. You do this by using the sts:SourceIdentity condition key in a role trust policy. You
  can use source identity information in CloudTrail logs to determine who took actions with a
  role. You can use the aws:SourceIdentity condition key to further control access to Amazon
  Web Services resources based on the value of source identity. For more information about
  using source identity, see Monitor and control actions taken with assumed roles in the IAM
  User Guide. The regex used to validate this parameter is a string of characters consisting
  of upper- and lower-case alphanumeric characters with no spaces. You can also include
  underscores or any of the following characters: =,.@-. You cannot use a value that begins
  with the text aws:. This prefix is reserved for Amazon Web Services internal use.
- `"Tags"`: A list of session tags that you want to pass. Each session tag consists of a
  key name and an associated value. For more information about session tags, see Tagging
  Amazon Web Services STS Sessions in the IAM User Guide. This parameter is optional. You can
  pass up to 50 session tags. The plaintext session tag keys can’t exceed 128 characters,
  and the values can’t exceed 256 characters. For these and additional limits, see IAM and
  STS Character Limits in the IAM User Guide.  An Amazon Web Services conversion compresses
  the passed inline session policy, managed policy ARNs, and session tags into a packed
  binary format that has a separate limit. Your request can fail for this limit even if your
  plaintext meets the other requirements. The PackedPolicySize response element indicates by
  percentage how close the policies and tags for your request are to the upper size limit.
  You can pass a session tag with the same key as a tag that is already attached to the role.
  When you do, session tags override a role tag with the same key.  Tag key–value pairs are
  not case sensitive, but case is preserved. This means that you cannot have separate
  Department and department tag keys. Assume that the role has the Department=Marketing tag
  and you pass the department=engineering session tag. Department and department are not
  saved as separate tags, and the session tag passed in the request takes precedence over the
  role tag. Additionally, if you used temporary credentials to perform this operation, the
  new session inherits any transitive session tags from the calling session. If you pass a
  session tag with the same key as an inherited tag, the operation fails. To view the
  inherited tags for a session, see the CloudTrail logs. For more information, see Viewing
  Session Tags in CloudTrail in the IAM User Guide.
- `"TokenCode"`: The value provided by the MFA device, if the trust policy of the role
  being assumed requires MFA. (In other words, if the policy includes a condition that tests
  for MFA). If the role being assumed requires MFA and if the TokenCode value is missing or
  expired, the AssumeRole call returns an \"access denied\" error. The format for this
  parameter, as described by its regex pattern, is a sequence of six numeric digits.
- `"TransitiveTagKeys"`: A list of keys for session tags that you want to set as
  transitive. If you set a tag key as transitive, the corresponding key and value passes to
  subsequent sessions in a role chain. For more information, see Chaining Roles with Session
  Tags in the IAM User Guide. This parameter is optional. When you set session tags as
  transitive, the session policy and session tags packed binary limit is not affected. If you
  choose not to specify a transitive tag key, then no tags are passed from this session to
  any subsequent sessions.
"""
function assume_role(
    RoleArn, RoleSessionName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sts(
        "AssumeRole",
        Dict{String,Any}("RoleArn" => RoleArn, "RoleSessionName" => RoleSessionName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function assume_role(
    RoleArn,
    RoleSessionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sts(
        "AssumeRole",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "RoleArn" => RoleArn, "RoleSessionName" => RoleSessionName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    assume_role_with_saml(principal_arn, role_arn, samlassertion)
    assume_role_with_saml(principal_arn, role_arn, samlassertion, params::Dict{String,<:Any})

Returns a set of temporary security credentials for users who have been authenticated via a
SAML authentication response. This operation provides a mechanism for tying an enterprise
identity store or directory to role-based Amazon Web Services access without user-specific
credentials or configuration. For a comparison of AssumeRoleWithSAML with the other API
operations that produce temporary credentials, see Requesting Temporary Security
Credentials and Comparing the Amazon Web Services STS API operations in the IAM User Guide.
The temporary security credentials returned by this operation consist of an access key ID,
a secret access key, and a security token. Applications can use these temporary security
credentials to sign calls to Amazon Web Services services.  Session Duration  By default,
the temporary security credentials created by AssumeRoleWithSAML last for one hour.
However, you can use the optional DurationSeconds parameter to specify the duration of your
session. Your role session lasts for the duration that you specify, or until the time
specified in the SAML authentication response's SessionNotOnOrAfter value, whichever is
shorter. You can provide a DurationSeconds value from 900 seconds (15 minutes) up to the
maximum session duration setting for the role. This setting can have a value from 1 hour to
12 hours. To learn how to view the maximum value for your role, see View the Maximum
Session Duration Setting for a Role in the IAM User Guide. The maximum session duration
limit applies when you use the AssumeRole* API operations or the assume-role* CLI commands.
However the limit does not apply when you use those operations to create a console URL. For
more information, see Using IAM Roles in the IAM User Guide.   Role chaining limits your
CLI or Amazon Web Services API role session to a maximum of one hour. When you use the
AssumeRole API operation to assume a role, you can specify the duration of your role
session with the DurationSeconds parameter. You can specify a parameter value of up to
43200 seconds (12 hours), depending on the maximum session duration setting for your role.
However, if you assume a role using role chaining and provide a DurationSeconds parameter
value greater than one hour, the operation fails.   Permissions  The temporary security
credentials created by AssumeRoleWithSAML can be used to make API calls to any Amazon Web
Services service with the following exception: you cannot call the STS GetFederationToken
or GetSessionToken API operations. (Optional) You can pass inline or managed session
policies to this operation. You can pass a single JSON policy document to use as an inline
session policy. You can also specify up to 10 managed policy Amazon Resource Names (ARNs)
to use as managed session policies. The plaintext that you use for both inline and managed
session policies can't exceed 2,048 characters. Passing policies to this operation returns
new temporary credentials. The resulting session's permissions are the intersection of the
role's identity-based policy and the session policies. You can use the role's temporary
credentials in subsequent Amazon Web Services API calls to access resources in the account
that owns the role. You cannot use session policies to grant more permissions than those
allowed by the identity-based policy of the role that is being assumed. For more
information, see Session Policies in the IAM User Guide. Calling AssumeRoleWithSAML does
not require the use of Amazon Web Services security credentials. The identity of the caller
is validated by using keys in the metadata document that is uploaded for the SAML provider
entity for your identity provider.   Calling AssumeRoleWithSAML can result in an entry in
your CloudTrail logs. The entry includes the value in the NameID element of the SAML
assertion. We recommend that you use a NameIDType that is not associated with any
personally identifiable information (PII). For example, you could instead use the
persistent identifier (urn:oasis:names:tc:SAML:2.0:nameid-format:persistent).   Tags
(Optional) You can configure your IdP to pass attributes into your SAML assertion as
session tags. Each session tag consists of a key name and an associated value. For more
information about session tags, see Passing Session Tags in STS in the IAM User Guide. You
can pass up to 50 session tags. The plaintext session tag keys can’t exceed 128
characters and the values can’t exceed 256 characters. For these and additional limits,
see IAM and STS Character Limits in the IAM User Guide.  An Amazon Web Services conversion
compresses the passed inline session policy, managed policy ARNs, and session tags into a
packed binary format that has a separate limit. Your request can fail for this limit even
if your plaintext meets the other requirements. The PackedPolicySize response element
indicates by percentage how close the policies and tags for your request are to the upper
size limit.  You can pass a session tag with the same key as a tag that is attached to the
role. When you do, session tags override the role's tags with the same key. An
administrator must grant you the permissions necessary to pass session tags. The
administrator can also create granular permissions to allow you to pass only specific
session tags. For more information, see Tutorial: Using Tags for Attribute-Based Access
Control in the IAM User Guide. You can set the session tags as transitive. Transitive tags
persist during role chaining. For more information, see Chaining Roles with Session Tags in
the IAM User Guide.  SAML Configuration  Before your application can call
AssumeRoleWithSAML, you must configure your SAML identity provider (IdP) to issue the
claims required by Amazon Web Services. Additionally, you must use Identity and Access
Management (IAM) to create a SAML provider entity in your Amazon Web Services account that
represents your identity provider. You must also create an IAM role that specifies this
SAML provider in its trust policy.  For more information, see the following resources:
About SAML 2.0-based Federation in the IAM User Guide.     Creating SAML Identity Providers
in the IAM User Guide.     Configuring a Relying Party and Claims in the IAM User Guide.
 Creating a Role for SAML 2.0 Federation in the IAM User Guide.

# Arguments
- `principal_arn`: The Amazon Resource Name (ARN) of the SAML provider in IAM that
  describes the IdP.
- `role_arn`: The Amazon Resource Name (ARN) of the role that the caller is assuming.
- `samlassertion`: The base64 encoded SAML authentication response provided by the IdP. For
  more information, see Configuring a Relying Party and Adding Claims in the IAM User Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DurationSeconds"`: The duration, in seconds, of the role session. Your role session
  lasts for the duration that you specify for the DurationSeconds parameter, or until the
  time specified in the SAML authentication response's SessionNotOnOrAfter value, whichever
  is shorter. You can provide a DurationSeconds value from 900 seconds (15 minutes) up to the
  maximum session duration setting for the role. This setting can have a value from 1 hour to
  12 hours. If you specify a value higher than this setting, the operation fails. For
  example, if you specify a session duration of 12 hours, but your administrator set the
  maximum session duration to 6 hours, your operation fails. To learn how to view the maximum
  value for your role, see View the Maximum Session Duration Setting for a Role in the IAM
  User Guide. By default, the value is set to 3600 seconds.   The DurationSeconds parameter
  is separate from the duration of a console session that you might request using the
  returned credentials. The request to the federation endpoint for a console sign-in token
  takes a SessionDuration parameter that specifies the maximum length of the console session.
  For more information, see Creating a URL that Enables Federated Users to Access the Amazon
  Web Services Management Console in the IAM User Guide.
- `"Policy"`: An IAM policy in JSON format that you want to use as an inline session
  policy. This parameter is optional. Passing policies to this operation returns new
  temporary credentials. The resulting session's permissions are the intersection of the
  role's identity-based policy and the session policies. You can use the role's temporary
  credentials in subsequent Amazon Web Services API calls to access resources in the account
  that owns the role. You cannot use session policies to grant more permissions than those
  allowed by the identity-based policy of the role that is being assumed. For more
  information, see Session Policies in the IAM User Guide.  The plaintext that you use for
  both inline and managed session policies can't exceed 2,048 characters. The JSON policy
  characters can be any ASCII character from the space character to the end of the valid
  character list (u0020 through u00FF). It can also include the tab (u0009), linefeed
  (u000A), and carriage return (u000D) characters.  An Amazon Web Services conversion
  compresses the passed inline session policy, managed policy ARNs, and session tags into a
  packed binary format that has a separate limit. Your request can fail for this limit even
  if your plaintext meets the other requirements. The PackedPolicySize response element
  indicates by percentage how close the policies and tags for your request are to the upper
  size limit.
- `"PolicyArns"`: The Amazon Resource Names (ARNs) of the IAM managed policies that you
  want to use as managed session policies. The policies must exist in the same account as the
  role. This parameter is optional. You can provide up to 10 managed policy ARNs. However,
  the plaintext that you use for both inline and managed session policies can't exceed 2,048
  characters. For more information about ARNs, see Amazon Resource Names (ARNs) and Amazon
  Web Services Service Namespaces in the Amazon Web Services General Reference.  An Amazon
  Web Services conversion compresses the passed inline session policy, managed policy ARNs,
  and session tags into a packed binary format that has a separate limit. Your request can
  fail for this limit even if your plaintext meets the other requirements. The
  PackedPolicySize response element indicates by percentage how close the policies and tags
  for your request are to the upper size limit.  Passing policies to this operation returns
  new temporary credentials. The resulting session's permissions are the intersection of the
  role's identity-based policy and the session policies. You can use the role's temporary
  credentials in subsequent Amazon Web Services API calls to access resources in the account
  that owns the role. You cannot use session policies to grant more permissions than those
  allowed by the identity-based policy of the role that is being assumed. For more
  information, see Session Policies in the IAM User Guide.
"""
function assume_role_with_saml(
    PrincipalArn, RoleArn, SAMLAssertion; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sts(
        "AssumeRoleWithSAML",
        Dict{String,Any}(
            "PrincipalArn" => PrincipalArn,
            "RoleArn" => RoleArn,
            "SAMLAssertion" => SAMLAssertion,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function assume_role_with_saml(
    PrincipalArn,
    RoleArn,
    SAMLAssertion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sts(
        "AssumeRoleWithSAML",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "PrincipalArn" => PrincipalArn,
                    "RoleArn" => RoleArn,
                    "SAMLAssertion" => SAMLAssertion,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    assume_role_with_web_identity(role_arn, role_session_name, web_identity_token)
    assume_role_with_web_identity(role_arn, role_session_name, web_identity_token, params::Dict{String,<:Any})

Returns a set of temporary security credentials for users who have been authenticated in a
mobile or web application with a web identity provider. Example providers include the OAuth
2.0 providers Login with Amazon and Facebook, or any OpenID Connect-compatible identity
provider such as Google or Amazon Cognito federated identities.  For mobile applications,
we recommend that you use Amazon Cognito. You can use Amazon Cognito with the Amazon Web
Services SDK for iOS Developer Guide and the Amazon Web Services SDK for Android Developer
Guide to uniquely identify a user. You can also supply the user with a consistent identity
throughout the lifetime of an application. To learn more about Amazon Cognito, see Amazon
Cognito identity pools in Amazon Cognito Developer Guide.  Calling
AssumeRoleWithWebIdentity does not require the use of Amazon Web Services security
credentials. Therefore, you can distribute an application (for example, on mobile devices)
that requests temporary security credentials without including long-term Amazon Web
Services credentials in the application. You also don't need to deploy server-based proxy
services that use long-term Amazon Web Services credentials. Instead, the identity of the
caller is validated by using a token from the web identity provider. For a comparison of
AssumeRoleWithWebIdentity with the other API operations that produce temporary credentials,
see Requesting Temporary Security Credentials and Comparing the Amazon Web Services STS API
operations in the IAM User Guide. The temporary security credentials returned by this API
consist of an access key ID, a secret access key, and a security token. Applications can
use these temporary security credentials to sign calls to Amazon Web Services service API
operations.  Session Duration  By default, the temporary security credentials created by
AssumeRoleWithWebIdentity last for one hour. However, you can use the optional
DurationSeconds parameter to specify the duration of your session. You can provide a value
from 900 seconds (15 minutes) up to the maximum session duration setting for the role. This
setting can have a value from 1 hour to 12 hours. To learn how to view the maximum value
for your role, see View the Maximum Session Duration Setting for a Role in the IAM User
Guide. The maximum session duration limit applies when you use the AssumeRole* API
operations or the assume-role* CLI commands. However the limit does not apply when you use
those operations to create a console URL. For more information, see Using IAM Roles in the
IAM User Guide.   Permissions  The temporary security credentials created by
AssumeRoleWithWebIdentity can be used to make API calls to any Amazon Web Services service
with the following exception: you cannot call the STS GetFederationToken or GetSessionToken
API operations. (Optional) You can pass inline or managed session policies to this
operation. You can pass a single JSON policy document to use as an inline session policy.
You can also specify up to 10 managed policy Amazon Resource Names (ARNs) to use as managed
session policies. The plaintext that you use for both inline and managed session policies
can't exceed 2,048 characters. Passing policies to this operation returns new temporary
credentials. The resulting session's permissions are the intersection of the role's
identity-based policy and the session policies. You can use the role's temporary
credentials in subsequent Amazon Web Services API calls to access resources in the account
that owns the role. You cannot use session policies to grant more permissions than those
allowed by the identity-based policy of the role that is being assumed. For more
information, see Session Policies in the IAM User Guide.  Tags  (Optional) You can
configure your IdP to pass attributes into your web identity token as session tags. Each
session tag consists of a key name and an associated value. For more information about
session tags, see Passing Session Tags in STS in the IAM User Guide. You can pass up to 50
session tags. The plaintext session tag keys can’t exceed 128 characters and the values
can’t exceed 256 characters. For these and additional limits, see IAM and STS Character
Limits in the IAM User Guide.  An Amazon Web Services conversion compresses the passed
inline session policy, managed policy ARNs, and session tags into a packed binary format
that has a separate limit. Your request can fail for this limit even if your plaintext
meets the other requirements. The PackedPolicySize response element indicates by percentage
how close the policies and tags for your request are to the upper size limit.  You can pass
a session tag with the same key as a tag that is attached to the role. When you do, the
session tag overrides the role tag with the same key. An administrator must grant you the
permissions necessary to pass session tags. The administrator can also create granular
permissions to allow you to pass only specific session tags. For more information, see
Tutorial: Using Tags for Attribute-Based Access Control in the IAM User Guide. You can set
the session tags as transitive. Transitive tags persist during role chaining. For more
information, see Chaining Roles with Session Tags in the IAM User Guide.  Identities
Before your application can call AssumeRoleWithWebIdentity, you must have an identity token
from a supported identity provider and create a role that the application can assume. The
role that your application assumes must trust the identity provider that is associated with
the identity token. In other words, the identity provider must be specified in the role's
trust policy.   Calling AssumeRoleWithWebIdentity can result in an entry in your CloudTrail
logs. The entry includes the Subject of the provided web identity token. We recommend that
you avoid using any personally identifiable information (PII) in this field. For example,
you could instead use a GUID or a pairwise identifier, as suggested in the OIDC
specification.  For more information about how to use web identity federation and the
AssumeRoleWithWebIdentity API, see the following resources:     Using Web Identity
Federation API Operations for Mobile Apps and Federation Through a Web-based Identity
Provider.      Web Identity Federation Playground. Walk through the process of
authenticating through Login with Amazon, Facebook, or Google, getting temporary security
credentials, and then using those credentials to make a request to Amazon Web Services.
Amazon Web Services SDK for iOS Developer Guide and Amazon Web Services SDK for Android
Developer Guide. These toolkits contain sample apps that show how to invoke the identity
providers. The toolkits then show how to use the information from these providers to get
and use temporary security credentials.     Web Identity Federation with Mobile
Applications. This article discusses web identity federation and shows an example of how to
use web identity federation to get access to content in Amazon S3.

# Arguments
- `role_arn`: The Amazon Resource Name (ARN) of the role that the caller is assuming.
- `role_session_name`: An identifier for the assumed role session. Typically, you pass the
  name or identifier that is associated with the user who is using your application. That
  way, the temporary security credentials that your application will use are associated with
  that user. This session name is included as part of the ARN and assumed role ID in the
  AssumedRoleUser response element. The regex used to validate this parameter is a string of
  characters consisting of upper- and lower-case alphanumeric characters with no spaces. You
  can also include underscores or any of the following characters: =,.@-
- `web_identity_token`: The OAuth 2.0 access token or OpenID Connect ID token that is
  provided by the identity provider. Your application must get this token by authenticating
  the user who is using your application with a web identity provider before the application
  makes an AssumeRoleWithWebIdentity call. Only tokens with RSA algorithms (RS256) are
  supported.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DurationSeconds"`: The duration, in seconds, of the role session. The value can range
  from 900 seconds (15 minutes) up to the maximum session duration setting for the role. This
  setting can have a value from 1 hour to 12 hours. If you specify a value higher than this
  setting, the operation fails. For example, if you specify a session duration of 12 hours,
  but your administrator set the maximum session duration to 6 hours, your operation fails.
  To learn how to view the maximum value for your role, see View the Maximum Session Duration
  Setting for a Role in the IAM User Guide. By default, the value is set to 3600 seconds.
  The DurationSeconds parameter is separate from the duration of a console session that you
  might request using the returned credentials. The request to the federation endpoint for a
  console sign-in token takes a SessionDuration parameter that specifies the maximum length
  of the console session. For more information, see Creating a URL that Enables Federated
  Users to Access the Amazon Web Services Management Console in the IAM User Guide.
- `"Policy"`: An IAM policy in JSON format that you want to use as an inline session
  policy. This parameter is optional. Passing policies to this operation returns new
  temporary credentials. The resulting session's permissions are the intersection of the
  role's identity-based policy and the session policies. You can use the role's temporary
  credentials in subsequent Amazon Web Services API calls to access resources in the account
  that owns the role. You cannot use session policies to grant more permissions than those
  allowed by the identity-based policy of the role that is being assumed. For more
  information, see Session Policies in the IAM User Guide. The plaintext that you use for
  both inline and managed session policies can't exceed 2,048 characters. The JSON policy
  characters can be any ASCII character from the space character to the end of the valid
  character list (u0020 through u00FF). It can also include the tab (u0009), linefeed
  (u000A), and carriage return (u000D) characters.  An Amazon Web Services conversion
  compresses the passed inline session policy, managed policy ARNs, and session tags into a
  packed binary format that has a separate limit. Your request can fail for this limit even
  if your plaintext meets the other requirements. The PackedPolicySize response element
  indicates by percentage how close the policies and tags for your request are to the upper
  size limit.
- `"PolicyArns"`: The Amazon Resource Names (ARNs) of the IAM managed policies that you
  want to use as managed session policies. The policies must exist in the same account as the
  role. This parameter is optional. You can provide up to 10 managed policy ARNs. However,
  the plaintext that you use for both inline and managed session policies can't exceed 2,048
  characters. For more information about ARNs, see Amazon Resource Names (ARNs) and Amazon
  Web Services Service Namespaces in the Amazon Web Services General Reference.  An Amazon
  Web Services conversion compresses the passed inline session policy, managed policy ARNs,
  and session tags into a packed binary format that has a separate limit. Your request can
  fail for this limit even if your plaintext meets the other requirements. The
  PackedPolicySize response element indicates by percentage how close the policies and tags
  for your request are to the upper size limit.  Passing policies to this operation returns
  new temporary credentials. The resulting session's permissions are the intersection of the
  role's identity-based policy and the session policies. You can use the role's temporary
  credentials in subsequent Amazon Web Services API calls to access resources in the account
  that owns the role. You cannot use session policies to grant more permissions than those
  allowed by the identity-based policy of the role that is being assumed. For more
  information, see Session Policies in the IAM User Guide.
- `"ProviderId"`: The fully qualified host component of the domain name of the OAuth 2.0
  identity provider. Do not specify this value for an OpenID Connect identity provider.
  Currently www.amazon.com and graph.facebook.com are the only supported identity providers
  for OAuth 2.0 access tokens. Do not include URL schemes and port numbers. Do not specify
  this value for OpenID Connect ID tokens.
"""
function assume_role_with_web_identity(
    RoleArn,
    RoleSessionName,
    WebIdentityToken;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sts(
        "AssumeRoleWithWebIdentity",
        Dict{String,Any}(
            "RoleArn" => RoleArn,
            "RoleSessionName" => RoleSessionName,
            "WebIdentityToken" => WebIdentityToken,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function assume_role_with_web_identity(
    RoleArn,
    RoleSessionName,
    WebIdentityToken,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sts(
        "AssumeRoleWithWebIdentity",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "RoleArn" => RoleArn,
                    "RoleSessionName" => RoleSessionName,
                    "WebIdentityToken" => WebIdentityToken,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    decode_authorization_message(encoded_message)
    decode_authorization_message(encoded_message, params::Dict{String,<:Any})

Decodes additional information about the authorization status of a request from an encoded
message returned in response to an Amazon Web Services request. For example, if a user is
not authorized to perform an operation that he or she has requested, the request returns a
Client.UnauthorizedOperation response (an HTTP 403 response). Some Amazon Web Services
operations additionally return an encoded message that can provide details about this
authorization failure.   Only certain Amazon Web Services operations return an encoded
authorization message. The documentation for an individual operation indicates whether that
operation returns an encoded message in addition to returning an HTTP code.  The message is
encoded because the details of the authorization status can contain privileged information
that the user who requested the operation should not see. To decode an authorization status
message, a user must be granted permissions through an IAM policy to request the
DecodeAuthorizationMessage (sts:DecodeAuthorizationMessage) action.  The decoded message
includes the following type of information:   Whether the request was denied due to an
explicit deny or due to the absence of an explicit allow. For more information, see
Determining Whether a Request is Allowed or Denied in the IAM User Guide.    The principal
who made the request.   The requested action.   The requested resource.   The values of
condition keys in the context of the user's request.

# Arguments
- `encoded_message`: The encoded message that was returned with the response.

"""
function decode_authorization_message(
    EncodedMessage; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sts(
        "DecodeAuthorizationMessage",
        Dict{String,Any}("EncodedMessage" => EncodedMessage);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function decode_authorization_message(
    EncodedMessage,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sts(
        "DecodeAuthorizationMessage",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("EncodedMessage" => EncodedMessage), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_access_key_info(access_key_id)
    get_access_key_info(access_key_id, params::Dict{String,<:Any})

Returns the account identifier for the specified access key ID. Access keys consist of two
parts: an access key ID (for example, AKIAIOSFODNN7EXAMPLE) and a secret access key (for
example, wJalrXUtnFEMI/K7MDENG/bPxRfiCYEXAMPLEKEY). For more information about access keys,
see Managing Access Keys for IAM Users in the IAM User Guide. When you pass an access key
ID to this operation, it returns the ID of the Amazon Web Services account to which the
keys belong. Access key IDs beginning with AKIA are long-term credentials for an IAM user
or the Amazon Web Services account root user. Access key IDs beginning with ASIA are
temporary credentials that are created using STS operations. If the account in the response
belongs to you, you can sign in as the root user and review your root user access keys.
Then, you can pull a credentials report to learn which IAM user owns the keys. To learn who
requested the temporary credentials for an ASIA access key, view the STS events in your
CloudTrail logs in the IAM User Guide. This operation does not indicate the state of the
access key. The key might be active, inactive, or deleted. Active keys might not have
permissions to perform an operation. Providing a deleted access key might return an error
that the key doesn't exist.

# Arguments
- `access_key_id`: The identifier of an access key. This parameter allows (through its
  regex pattern) a string of characters that can consist of any upper- or lowercase letter or
  digit.

"""
function get_access_key_info(
    AccessKeyId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sts(
        "GetAccessKeyInfo",
        Dict{String,Any}("AccessKeyId" => AccessKeyId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_access_key_info(
    AccessKeyId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sts(
        "GetAccessKeyInfo",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AccessKeyId" => AccessKeyId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_caller_identity()
    get_caller_identity(params::Dict{String,<:Any})

Returns details about the IAM user or role whose credentials are used to call the
operation.  No permissions are required to perform this operation. If an administrator
attaches a policy to your identity that explicitly denies access to the
sts:GetCallerIdentity action, you can still perform this operation. Permissions are not
required because the same information is returned when access is denied. To view an example
response, see I Am Not Authorized to Perform: iam:DeleteVirtualMFADevice in the IAM User
Guide.

"""
function get_caller_identity(; aws_config::AbstractAWSConfig=current_aws_config())
    return sts("GetCallerIdentity"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function get_caller_identity(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sts(
        "GetCallerIdentity", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_federation_token(name)
    get_federation_token(name, params::Dict{String,<:Any})

Returns a set of temporary security credentials (consisting of an access key ID, a secret
access key, and a security token) for a user. A typical use is in a proxy application that
gets temporary security credentials on behalf of distributed applications inside a
corporate network. You must call the GetFederationToken operation using the long-term
security credentials of an IAM user. As a result, this call is appropriate in contexts
where those credentials can be safeguarded, usually in a server-based application. For a
comparison of GetFederationToken with the other API operations that produce temporary
credentials, see Requesting Temporary Security Credentials and Comparing the Amazon Web
Services STS API operations in the IAM User Guide. Although it is possible to call
GetFederationToken using the security credentials of an Amazon Web Services account root
user rather than an IAM user that you create for the purpose of a proxy application, we do
not recommend it. For more information, see Safeguard your root user credentials and don't
use them for everyday tasks in the IAM User Guide.   You can create a mobile-based or
browser-based app that can authenticate users using a web identity provider like Login with
Amazon, Facebook, Google, or an OpenID Connect-compatible identity provider. In this case,
we recommend that you use Amazon Cognito or AssumeRoleWithWebIdentity. For more
information, see Federation Through a Web-based Identity Provider in the IAM User Guide.
Session duration  The temporary credentials are valid for the specified duration, from 900
seconds (15 minutes) up to a maximum of 129,600 seconds (36 hours). The default session
duration is 43,200 seconds (12 hours). Temporary credentials obtained by using the root
user credentials have a maximum duration of 3,600 seconds (1 hour).  Permissions  You can
use the temporary credentials created by GetFederationToken in any Amazon Web Services
service with the following exceptions:   You cannot call any IAM operations using the CLI
or the Amazon Web Services API. This limitation does not apply to console sessions.   You
cannot call any STS operations except GetCallerIdentity.   You can use temporary
credentials for single sign-on (SSO) to the console. You must pass an inline or managed
session policy to this operation. You can pass a single JSON policy document to use as an
inline session policy. You can also specify up to 10 managed policy Amazon Resource Names
(ARNs) to use as managed session policies. The plaintext that you use for both inline and
managed session policies can't exceed 2,048 characters. Though the session policy
parameters are optional, if you do not pass a policy, then the resulting federated user
session has no permissions. When you pass session policies, the session permissions are the
intersection of the IAM user policies and the session policies that you pass. This gives
you a way to further restrict the permissions for a federated user. You cannot use session
policies to grant more permissions than those that are defined in the permissions policy of
the IAM user. For more information, see Session Policies in the IAM User Guide. For
information about using GetFederationToken to create temporary security credentials, see
GetFederationToken—Federation Through a Custom Identity Broker.  You can use the
credentials to access a resource that has a resource-based policy. If that policy
specifically references the federated user session in the Principal element of the policy,
the session has the permissions allowed by the policy. These permissions are granted in
addition to the permissions granted by the session policies.  Tags  (Optional) You can pass
tag key-value pairs to your session. These are called session tags. For more information
about session tags, see Passing Session Tags in STS in the IAM User Guide.  You can create
a mobile-based or browser-based app that can authenticate users using a web identity
provider like Login with Amazon, Facebook, Google, or an OpenID Connect-compatible identity
provider. In this case, we recommend that you use Amazon Cognito or
AssumeRoleWithWebIdentity. For more information, see Federation Through a Web-based
Identity Provider in the IAM User Guide.  An administrator must grant you the permissions
necessary to pass session tags. The administrator can also create granular permissions to
allow you to pass only specific session tags. For more information, see Tutorial: Using
Tags for Attribute-Based Access Control in the IAM User Guide. Tag key–value pairs are
not case sensitive, but case is preserved. This means that you cannot have separate
Department and department tag keys. Assume that the user that you are federating has the
Department=Marketing tag and you pass the department=engineering session tag. Department
and department are not saved as separate tags, and the session tag passed in the request
takes precedence over the user tag.

# Arguments
- `name`: The name of the federated user. The name is used as an identifier for the
  temporary security credentials (such as Bob). For example, you can reference the federated
  user name in a resource-based policy, such as in an Amazon S3 bucket policy. The regex used
  to validate this parameter is a string of characters consisting of upper- and lower-case
  alphanumeric characters with no spaces. You can also include underscores or any of the
  following characters: =,.@-

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DurationSeconds"`: The duration, in seconds, that the session should last. Acceptable
  durations for federation sessions range from 900 seconds (15 minutes) to 129,600 seconds
  (36 hours), with 43,200 seconds (12 hours) as the default. Sessions obtained using root
  user credentials are restricted to a maximum of 3,600 seconds (one hour). If the specified
  duration is longer than one hour, the session obtained by using root user credentials
  defaults to one hour.
- `"Policy"`: An IAM policy in JSON format that you want to use as an inline session
  policy. You must pass an inline or managed session policy to this operation. You can pass a
  single JSON policy document to use as an inline session policy. You can also specify up to
  10 managed policy Amazon Resource Names (ARNs) to use as managed session policies. This
  parameter is optional. However, if you do not pass any session policies, then the resulting
  federated user session has no permissions. When you pass session policies, the session
  permissions are the intersection of the IAM user policies and the session policies that you
  pass. This gives you a way to further restrict the permissions for a federated user. You
  cannot use session policies to grant more permissions than those that are defined in the
  permissions policy of the IAM user. For more information, see Session Policies in the IAM
  User Guide. The resulting credentials can be used to access a resource that has a
  resource-based policy. If that policy specifically references the federated user session in
  the Principal element of the policy, the session has the permissions allowed by the policy.
  These permissions are granted in addition to the permissions that are granted by the
  session policies. The plaintext that you use for both inline and managed session policies
  can't exceed 2,048 characters. The JSON policy characters can be any ASCII character from
  the space character to the end of the valid character list (u0020 through u00FF). It can
  also include the tab (u0009), linefeed (u000A), and carriage return (u000D) characters.  An
  Amazon Web Services conversion compresses the passed inline session policy, managed policy
  ARNs, and session tags into a packed binary format that has a separate limit. Your request
  can fail for this limit even if your plaintext meets the other requirements. The
  PackedPolicySize response element indicates by percentage how close the policies and tags
  for your request are to the upper size limit.
- `"PolicyArns"`: The Amazon Resource Names (ARNs) of the IAM managed policies that you
  want to use as a managed session policy. The policies must exist in the same account as the
  IAM user that is requesting federated access. You must pass an inline or managed session
  policy to this operation. You can pass a single JSON policy document to use as an inline
  session policy. You can also specify up to 10 managed policy Amazon Resource Names (ARNs)
  to use as managed session policies. The plaintext that you use for both inline and managed
  session policies can't exceed 2,048 characters. You can provide up to 10 managed policy
  ARNs. For more information about ARNs, see Amazon Resource Names (ARNs) and Amazon Web
  Services Service Namespaces in the Amazon Web Services General Reference. This parameter is
  optional. However, if you do not pass any session policies, then the resulting federated
  user session has no permissions. When you pass session policies, the session permissions
  are the intersection of the IAM user policies and the session policies that you pass. This
  gives you a way to further restrict the permissions for a federated user. You cannot use
  session policies to grant more permissions than those that are defined in the permissions
  policy of the IAM user. For more information, see Session Policies in the IAM User Guide.
  The resulting credentials can be used to access a resource that has a resource-based
  policy. If that policy specifically references the federated user session in the Principal
  element of the policy, the session has the permissions allowed by the policy. These
  permissions are granted in addition to the permissions that are granted by the session
  policies.  An Amazon Web Services conversion compresses the passed inline session policy,
  managed policy ARNs, and session tags into a packed binary format that has a separate
  limit. Your request can fail for this limit even if your plaintext meets the other
  requirements. The PackedPolicySize response element indicates by percentage how close the
  policies and tags for your request are to the upper size limit.
- `"Tags"`: A list of session tags. Each session tag consists of a key name and an
  associated value. For more information about session tags, see Passing Session Tags in STS
  in the IAM User Guide. This parameter is optional. You can pass up to 50 session tags. The
  plaintext session tag keys can’t exceed 128 characters and the values can’t exceed 256
  characters. For these and additional limits, see IAM and STS Character Limits in the IAM
  User Guide.  An Amazon Web Services conversion compresses the passed inline session policy,
  managed policy ARNs, and session tags into a packed binary format that has a separate
  limit. Your request can fail for this limit even if your plaintext meets the other
  requirements. The PackedPolicySize response element indicates by percentage how close the
  policies and tags for your request are to the upper size limit.  You can pass a session tag
  with the same key as a tag that is already attached to the user you are federating. When
  you do, session tags override a user tag with the same key.  Tag key–value pairs are not
  case sensitive, but case is preserved. This means that you cannot have separate Department
  and department tag keys. Assume that the role has the Department=Marketing tag and you pass
  the department=engineering session tag. Department and department are not saved as separate
  tags, and the session tag passed in the request takes precedence over the role tag.
"""
function get_federation_token(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return sts(
        "GetFederationToken",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_federation_token(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sts(
        "GetFederationToken",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_session_token()
    get_session_token(params::Dict{String,<:Any})

Returns a set of temporary credentials for an Amazon Web Services account or IAM user. The
credentials consist of an access key ID, a secret access key, and a security token.
Typically, you use GetSessionToken if you want to use MFA to protect programmatic calls to
specific Amazon Web Services API operations like Amazon EC2 StopInstances. MFA-enabled IAM
users must call GetSessionToken and submit an MFA code that is associated with their MFA
device. Using the temporary security credentials that the call returns, IAM users can then
make programmatic calls to API operations that require MFA authentication. An incorrect MFA
code causes the API to return an access denied error. For a comparison of GetSessionToken
with the other API operations that produce temporary credentials, see Requesting Temporary
Security Credentials and Comparing the Amazon Web Services STS API operations in the IAM
User Guide.  No permissions are required for users to perform this operation. The purpose
of the sts:GetSessionToken operation is to authenticate the user using MFA. You cannot use
policies to control authentication operations. For more information, see Permissions for
GetSessionToken in the IAM User Guide.   Session Duration  The GetSessionToken operation
must be called by using the long-term Amazon Web Services security credentials of an IAM
user. Credentials that are created by IAM users are valid for the duration that you
specify. This duration can range from 900 seconds (15 minutes) up to a maximum of 129,600
seconds (36 hours), with a default of 43,200 seconds (12 hours). Credentials based on
account credentials can range from 900 seconds (15 minutes) up to 3,600 seconds (1 hour),
with a default of 1 hour.   Permissions  The temporary security credentials created by
GetSessionToken can be used to make API calls to any Amazon Web Services service with the
following exceptions:   You cannot call any IAM API operations unless MFA authentication
information is included in the request.   You cannot call any STS API except AssumeRole or
GetCallerIdentity.   The credentials that GetSessionToken returns are based on permissions
associated with the IAM user whose credentials were used to call the operation. The
temporary credentials have the same permissions as the IAM user.  Although it is possible
to call GetSessionToken using the security credentials of an Amazon Web Services account
root user rather than an IAM user, we do not recommend it. If GetSessionToken is called
using root user credentials, the temporary credentials have root user permissions. For more
information, see Safeguard your root user credentials and don't use them for everyday tasks
in the IAM User Guide   For more information about using GetSessionToken to create
temporary credentials, see Temporary Credentials for Users in Untrusted Environments in the
IAM User Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DurationSeconds"`: The duration, in seconds, that the credentials should remain valid.
  Acceptable durations for IAM user sessions range from 900 seconds (15 minutes) to 129,600
  seconds (36 hours), with 43,200 seconds (12 hours) as the default. Sessions for Amazon Web
  Services account owners are restricted to a maximum of 3,600 seconds (one hour). If the
  duration is longer than one hour, the session for Amazon Web Services account owners
  defaults to one hour.
- `"SerialNumber"`: The identification number of the MFA device that is associated with the
  IAM user who is making the GetSessionToken call. Specify this value if the IAM user has a
  policy that requires MFA authentication. The value is either the serial number for a
  hardware device (such as GAHT12345678) or an Amazon Resource Name (ARN) for a virtual
  device (such as arn:aws:iam::123456789012:mfa/user). You can find the device for an IAM
  user by going to the Amazon Web Services Management Console and viewing the user's security
  credentials.  The regex used to validate this parameter is a string of characters
  consisting of upper- and lower-case alphanumeric characters with no spaces. You can also
  include underscores or any of the following characters: =,.@:/-
- `"TokenCode"`: The value provided by the MFA device, if MFA is required. If any policy
  requires the IAM user to submit an MFA code, specify this value. If MFA authentication is
  required, the user must provide a code when requesting a set of temporary security
  credentials. A user who fails to provide the code receives an \"access denied\" response
  when requesting resources that require MFA authentication. The format for this parameter,
  as described by its regex pattern, is a sequence of six numeric digits.
"""
function get_session_token(; aws_config::AbstractAWSConfig=current_aws_config())
    return sts("GetSessionToken"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function get_session_token(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sts(
        "GetSessionToken", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

# Used to allow custom dispatches to `_http_request`
"""
    AWS.AbstractBackend

An abstract type representing a "backend" to use as an HTTP client
to connect to the AWS REST API.
"""
abstract type AbstractBackend end

"""
    AWS.HTTPBackend <: AWS.AbstractBackend

This backend uses HTTP.jl as an HTTP client to connect to the AWS
REST API, and has one field:

- `http_options::AbstractDict{Symbol,<:Any}`

which defaults to an empty dictionary. This field provides
default options to use, which can be any of the keyword
arguments to [`HTTP.request`](https://juliaweb.github.io/HTTP.jl/stable/public_interface/#HTTP.request). These options are overwritten by any per-request options.

This is the default backend.
"""
struct HTTPBackend <: AbstractBackend
    http_options::AbstractDict{Symbol,<:Any}
end

function statuserror(status, resp)
    return HTTP.StatusError(status, resp.request.method, resp.request.target, resp)
end

function HTTPBackend(; kwargs...)
    return if isempty(kwargs)
        HTTPBackend(LittleDict{Symbol,Any}())
    else
        HTTPBackend(LittleDict(kwargs))
    end
end
# populated in `__init__`
"""
    AWS.DEFAULT_BACKEND = Ref{AbstractBackend}()

This specifies the default backend to use. This can be modified
to change the default backend used by AWS.jl:

```julia
using AWS
AWS.DEFAULT_BACKEND[] = AWS.DownloadsBackend()
```

As an alternative, the `backend` can be specified on a per-request basis, by
adding a pair `"backend" => AWS.DownloadsBackend()` to the `params` argument of
AWS.jl functions.

!!! warning
    Setting the `AWS.DEFAULT_BACKEND` is a global change that affects all packages in your Julia session using AWS.jl. Therefore, it is not recommended for library code to change the default backend, and instead set the backend on a per-request basis if needed (or ask the user to set a default backend). If you do wish to change the default backend inside package code which is precompiled, then it must be changed from within the `__init__` method. See the [Julia manual](https://docs.julialang.org/en/v1/manual/modules/#Module-initialization-and-precompilation) for more on module initialization.
"""
const DEFAULT_BACKEND = Ref{AbstractBackend}()

Base.@kwdef mutable struct Request
    service::String
    api_version::String
    request_method::String

    headers::AbstractDict{String,String} = LittleDict{String,String}()
    content::Union{String,Vector{UInt8}} = ""
    resource::String = ""
    url::String = ""

    # Note: User provided `IO` should support seeking in order to support API error handling
    response_stream::Union{IO,Nothing} = nothing

    http_options::AbstractDict{Symbol,<:Any} = LittleDict{Symbol,String}()
    backend::AbstractBackend = DEFAULT_BACKEND[]

    # Deprecated fields
    use_response_type::Bool = false
    return_stream::Union{Bool,Nothing} = nothing
    return_raw::Union{Bool,Nothing} = nothing
    response_dict_type::Union{Type{<:AbstractDict},Nothing} = nothing
end

"""
    submit_request(aws::AbstractAWSConfig, request::Request; return_headers::Bool=false)

Submit the request to AWS.

# Arguments
- `aws::AbstractAWSConfig`: AWSConfig containing credentials and other information for fulfilling the request, default value is the global configuration
- `request::Request`: All the information about making a request to AWS

# Keywords
- `return_headers::Bool=false`: Set to `true` if you want the headers from the response returned back. Only
  used if `request.use_response_type = false`.

# Returns
- `AWS.Response`: A struct containing the response details
"""
function submit_request(aws::AbstractAWSConfig, request::Request; return_headers=nothing)
    aws_response = nothing
    TOO_MANY_REQUESTS = 429
    EXPIRED_ERROR_CODES = ["ExpiredToken", "ExpiredTokenException", "RequestExpired"]
    REDIRECT_ERROR_CODES = [301, 302, 303, 304, 305, 307, 308]
    THROTTLING_ERROR_CODES = [
        "Throttling",
        "ThrottlingException",
        "ThrottledException",
        "RequestThrottledException",
        "TooManyRequestsException",
        "ProvisionedThroughputExceededException",
        "TransactionInProgressException",
        "LimitExceededException",
        "RequestLimitExceeded",
        "BandwidthLimitExceeded",
        "RequestThrottled",
        "PriorRequestNotComplete",
        "SlowDown",
        "EC2ThrottledException",
    ]

    request.headers["User-Agent"] = user_agent[]
    request.headers["Host"] = HTTP.URI(request.url).host
    stream = @something request.response_stream IOBuffer()

    local aws_response
    local response

    get_response = function ()
        credentials(aws) === nothing || sign!(aws, request)

        aws_response = @mock _http_request(request.backend, request, stream)
        response = aws_response.response

        if response.status in REDIRECT_ERROR_CODES
            if HTTP.header(response, "Location") != ""
                request.url = HTTP.header(response, "Location")
            else
                e = statuserror(response.status, response)
                throw(AWSException(e, stream))
            end
        end
    end

    function upgrade_error(f)
        return () -> try
            return f()
        catch e
            if e isa HTTP.StatusError
                e = AWSException(e, stream)
                rethrow(e)
            end
            rethrow()
        end
    end

    check = function (s, e)
        # Pass on non-AWS exceptions.
        if !(e isa AWSException)
            return false
        end

        occursin("Signature expired", e.message) && return true

        # Handle ExpiredToken...
        # https://github.com/aws/aws-sdk-go/blob/v1.31.5/aws/request/retryer.go#L98
        if e isa AWSException && e.code in EXPIRED_ERROR_CODES
            check_credentials(credentials(aws); force_refresh=true)
            return true
        end

        # Throttle handling
        # https://github.com/boto/botocore/blob/1.16.17/botocore/data/_retry.json
        # https://docs.aws.amazon.com/general/latest/gr/api-retries.html
        if _http_status(e.cause) == TOO_MANY_REQUESTS || e.code in THROTTLING_ERROR_CODES
            return true
        end

        # Handle BadDigest error and CRC32 check sum failure
        if _header(e.cause, "crc32body") == "x-amz-crc32" ||
            e.code in ("BadDigest", "RequestTimeout", "RequestTimeoutException")
            return true
        end

        if occursin("Missing Authentication Token", e.message) &&
            aws.credentials === nothing
            return throw(
                NoCredentials(
                    "You're attempting to perform a request without credentials set."
                ),
            )
        end
        return false
    end

    delays = AWSExponentialBackoff(; max_attempts=max_attempts(aws))

    retry(upgrade_error(get_response); check=check, delays=delays)()

    if request.use_response_type
        return aws_response
    else
        return legacy_response(request, aws_response; return_headers=return_headers)
    end
end

function _http_request(http_backend::HTTPBackend, request::Request, response_stream::IO)
    http_options = merge(http_backend.http_options, request.http_options)

    local buffer
    local response

    get_response = function ()
        # Use a sacrificial I/O stream so that we only write to the `response_stream`
        # once even with multiple attempted requests. Additionally this works around the
        # HTTP.jl issue (https://github.com/JuliaWeb/HTTP.jl/issues/543) where the
        # `response_stream` is closed automatically. Effectively, this works as if we're
        # not using streaming I/O at all, as we write all data at once, but only
        # returning data via I/O ensures we aren't relying on response's body being
        # populated.
        buffer = Base.BufferStream()

        response = @mock HTTP.request(
            request.request_method,
            HTTP.URI(request.url),
            HTTP.mkheaders(request.headers),
            request.content;
            redirect=false,
            retry=false,
            response_stream=buffer,
            http_options...,
        )

        # We'll rely on lexical scoping; `buffer` and `response`
        # are bindings in the outer scope, so we don't need to return here.
        return nothing
    end

    check = function (s, e)
        return isa(e, HTTP.ConnectError) ||
               isa(e, HTTP.RequestError) ||
               (isa(e, HTTP.StatusError) && _http_status(e) >= 500)
    end

    delays = AWSExponentialBackoff(; max_attempts=4)

    try
        retry(get_response; check=check, delays=delays)()
    finally
        # We're unable to read from the `Base.BufferStream` until it has been closed.
        # HTTP.jl will close passed in `response_stream` keyword. This ensures that it
        # is always closed (e.g. HTTP.jl 0.9.15)
        close(buffer)

        # Transfer the contents of the `BufferStream` into `response_stream` variable.
        write(response_stream, buffer)
    end

    return @mock Response(response, response_stream)
end

_http_status(e::HTTP.StatusError) = e.status
_header(e::HTTP.StatusError, k, d="") = HTTP.header(e.response, k, d)

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: tnb
using AWS.Compat
using AWS.UUIDs

"""
    cancel_sol_network_operation(ns_lcm_op_occ_id)
    cancel_sol_network_operation(ns_lcm_op_occ_id, params::Dict{String,<:Any})

Cancels a network operation. A network operation is any operation that is done to your
network, such as network instance instantiation or termination.

# Arguments
- `ns_lcm_op_occ_id`: The identifier of the network operation.

"""
function cancel_sol_network_operation(
    nsLcmOpOccId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return tnb(
        "POST",
        "/sol/nslcm/v1/ns_lcm_op_occs/$(nsLcmOpOccId)/cancel";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_sol_network_operation(
    nsLcmOpOccId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return tnb(
        "POST",
        "/sol/nslcm/v1/ns_lcm_op_occs/$(nsLcmOpOccId)/cancel",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_sol_function_package()
    create_sol_function_package(params::Dict{String,<:Any})

Creates a function package. A function package is a .zip file in CSAR (Cloud Service
Archive) format that contains a network function (an ETSI standard telecommunication
application) and function package descriptor that uses the TOSCA standard to describe how
the network functions should run on your network. For more information, see Function
packages in the Amazon Web Services Telco Network Builder User Guide.  Creating a function
package is the first step for creating a network in AWS TNB. This request creates an empty
container with an ID. The next step is to upload the actual CSAR zip file into that empty
container. To upload function package content, see PutSolFunctionPackageContent.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tags"`: A tag is a label that you assign to an Amazon Web Services resource. Each tag
  consists of a key and an optional value. You can use tags to search and filter your
  resources or track your Amazon Web Services costs.
"""
function create_sol_function_package(; aws_config::AbstractAWSConfig=current_aws_config())
    return tnb(
        "POST",
        "/sol/vnfpkgm/v1/vnf_packages";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_sol_function_package(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return tnb(
        "POST",
        "/sol/vnfpkgm/v1/vnf_packages",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_sol_network_instance(ns_name, nsd_info_id)
    create_sol_network_instance(ns_name, nsd_info_id, params::Dict{String,<:Any})

Creates a network instance. A network instance is a single network created in Amazon Web
Services TNB that can be deployed and on which life-cycle operations (like terminate,
update, and delete) can be performed. Creating a network instance is the third step after
creating a network package. For more information about network instances, Network instances
in the Amazon Web Services Telco Network Builder User Guide. Once you create a network
instance, you can instantiate it. To instantiate a network, see
InstantiateSolNetworkInstance.

# Arguments
- `ns_name`: Network instance name.
- `nsd_info_id`: ID for network service descriptor.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nsDescription"`: Network instance description.
- `"tags"`: A tag is a label that you assign to an Amazon Web Services resource. Each tag
  consists of a key and an optional value. You can use tags to search and filter your
  resources or track your Amazon Web Services costs.
"""
function create_sol_network_instance(
    nsName, nsdInfoId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return tnb(
        "POST",
        "/sol/nslcm/v1/ns_instances",
        Dict{String,Any}("nsName" => nsName, "nsdInfoId" => nsdInfoId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_sol_network_instance(
    nsName,
    nsdInfoId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return tnb(
        "POST",
        "/sol/nslcm/v1/ns_instances",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("nsName" => nsName, "nsdInfoId" => nsdInfoId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_sol_network_package()
    create_sol_network_package(params::Dict{String,<:Any})

Creates a network package. A network package is a .zip file in CSAR (Cloud Service Archive)
format defines the function packages you want to deploy and the Amazon Web Services
infrastructure you want to deploy them on. For more information, see Network instances in
the Amazon Web Services Telco Network Builder User Guide.  A network package consists of a
network service descriptor (NSD) file (required) and any additional files (optional), such
as scripts specific to your needs. For example, if you have multiple function packages in
your network package, you can use the NSD to define which network functions should run in
certain VPCs, subnets, or EKS clusters. This request creates an empty network package
container with an ID. Once you create a network package, you can upload the network package
content using PutSolNetworkPackageContent.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tags"`: A tag is a label that you assign to an Amazon Web Services resource. Each tag
  consists of a key and an optional value. You can use tags to search and filter your
  resources or track your Amazon Web Services costs.
"""
function create_sol_network_package(; aws_config::AbstractAWSConfig=current_aws_config())
    return tnb(
        "POST",
        "/sol/nsd/v1/ns_descriptors";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_sol_network_package(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return tnb(
        "POST",
        "/sol/nsd/v1/ns_descriptors",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_sol_function_package(vnf_pkg_id)
    delete_sol_function_package(vnf_pkg_id, params::Dict{String,<:Any})

Deletes a function package. A function package is a .zip file in CSAR (Cloud Service
Archive) format that contains a network function (an ETSI standard telecommunication
application) and function package descriptor that uses the TOSCA standard to describe how
the network functions should run on your network. To delete a function package, the package
must be in a disabled state. To disable a function package, see UpdateSolFunctionPackage.

# Arguments
- `vnf_pkg_id`: ID of the function package.

"""
function delete_sol_function_package(
    vnfPkgId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return tnb(
        "DELETE",
        "/sol/vnfpkgm/v1/vnf_packages/$(vnfPkgId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_sol_function_package(
    vnfPkgId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return tnb(
        "DELETE",
        "/sol/vnfpkgm/v1/vnf_packages/$(vnfPkgId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_sol_network_instance(ns_instance_id)
    delete_sol_network_instance(ns_instance_id, params::Dict{String,<:Any})

Deletes a network instance. A network instance is a single network created in Amazon Web
Services TNB that can be deployed and on which life-cycle operations (like terminate,
update, and delete) can be performed. To delete a network instance, the instance must be in
a stopped or terminated state. To terminate a network instance, see
TerminateSolNetworkInstance.

# Arguments
- `ns_instance_id`: Network instance ID.

"""
function delete_sol_network_instance(
    nsInstanceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return tnb(
        "DELETE",
        "/sol/nslcm/v1/ns_instances/$(nsInstanceId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_sol_network_instance(
    nsInstanceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return tnb(
        "DELETE",
        "/sol/nslcm/v1/ns_instances/$(nsInstanceId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_sol_network_package(nsd_info_id)
    delete_sol_network_package(nsd_info_id, params::Dict{String,<:Any})

Deletes network package. A network package is a .zip file in CSAR (Cloud Service Archive)
format defines the function packages you want to deploy and the Amazon Web Services
infrastructure you want to deploy them on. To delete a network package, the package must be
in a disable state. To disable a network package, see UpdateSolNetworkPackage.

# Arguments
- `nsd_info_id`: ID of the network service descriptor in the network package.

"""
function delete_sol_network_package(
    nsdInfoId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return tnb(
        "DELETE",
        "/sol/nsd/v1/ns_descriptors/$(nsdInfoId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_sol_network_package(
    nsdInfoId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return tnb(
        "DELETE",
        "/sol/nsd/v1/ns_descriptors/$(nsdInfoId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_sol_function_instance(vnf_instance_id)
    get_sol_function_instance(vnf_instance_id, params::Dict{String,<:Any})

Gets the details of a network function instance, including the instantation state and
metadata from the function package descriptor in the network function package. A network
function instance is a function in a function package .

# Arguments
- `vnf_instance_id`: ID of the network function.

"""
function get_sol_function_instance(
    vnfInstanceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return tnb(
        "GET",
        "/sol/vnflcm/v1/vnf_instances/$(vnfInstanceId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_sol_function_instance(
    vnfInstanceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return tnb(
        "GET",
        "/sol/vnflcm/v1/vnf_instances/$(vnfInstanceId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_sol_function_package(vnf_pkg_id)
    get_sol_function_package(vnf_pkg_id, params::Dict{String,<:Any})

Gets the details of an individual function package, such as the operational state and
whether the package is in use. A function package is a .zip file in CSAR (Cloud Service
Archive) format that contains a network function (an ETSI standard telecommunication
application) and function package descriptor that uses the TOSCA standard to describe how
the network functions should run on your network..

# Arguments
- `vnf_pkg_id`: ID of the function package.

"""
function get_sol_function_package(
    vnfPkgId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return tnb(
        "GET",
        "/sol/vnfpkgm/v1/vnf_packages/$(vnfPkgId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_sol_function_package(
    vnfPkgId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return tnb(
        "GET",
        "/sol/vnfpkgm/v1/vnf_packages/$(vnfPkgId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_sol_function_package_content(accept, vnf_pkg_id)
    get_sol_function_package_content(accept, vnf_pkg_id, params::Dict{String,<:Any})

Gets the contents of a function package. A function package is a .zip file in CSAR (Cloud
Service Archive) format that contains a network function (an ETSI standard
telecommunication application) and function package descriptor that uses the TOSCA standard
to describe how the network functions should run on your network.

# Arguments
- `accept`: The format of the package that you want to download from the function packages.
- `vnf_pkg_id`: ID of the function package.

"""
function get_sol_function_package_content(
    Accept, vnfPkgId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return tnb(
        "GET",
        "/sol/vnfpkgm/v1/vnf_packages/$(vnfPkgId)/package_content",
        Dict{String,Any}("headers" => Dict{String,Any}("Accept" => Accept));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_sol_function_package_content(
    Accept,
    vnfPkgId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return tnb(
        "GET",
        "/sol/vnfpkgm/v1/vnf_packages/$(vnfPkgId)/package_content",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("headers" => Dict{String,Any}("Accept" => Accept)),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_sol_function_package_descriptor(accept, vnf_pkg_id)
    get_sol_function_package_descriptor(accept, vnf_pkg_id, params::Dict{String,<:Any})

Gets a function package descriptor in a function package. A function package descriptor is
a .yaml file in a function package that uses the TOSCA standard to describe how the network
function in the function package should run on your network. A function package is a .zip
file in CSAR (Cloud Service Archive) format that contains a network function (an ETSI
standard telecommunication application) and function package descriptor that uses the TOSCA
standard to describe how the network functions should run on your network.

# Arguments
- `accept`: Indicates which content types, expressed as MIME types, the client is able to
  understand.
- `vnf_pkg_id`: ID of the function package.

"""
function get_sol_function_package_descriptor(
    Accept, vnfPkgId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return tnb(
        "GET",
        "/sol/vnfpkgm/v1/vnf_packages/$(vnfPkgId)/vnfd",
        Dict{String,Any}("headers" => Dict{String,Any}("Accept" => Accept));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_sol_function_package_descriptor(
    Accept,
    vnfPkgId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return tnb(
        "GET",
        "/sol/vnfpkgm/v1/vnf_packages/$(vnfPkgId)/vnfd",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("headers" => Dict{String,Any}("Accept" => Accept)),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_sol_network_instance(ns_instance_id)
    get_sol_network_instance(ns_instance_id, params::Dict{String,<:Any})

Gets the details of the network instance. A network instance is a single network created in
Amazon Web Services TNB that can be deployed and on which life-cycle operations (like
terminate, update, and delete) can be performed.

# Arguments
- `ns_instance_id`: ID of the network instance.

"""
function get_sol_network_instance(
    nsInstanceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return tnb(
        "GET",
        "/sol/nslcm/v1/ns_instances/$(nsInstanceId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_sol_network_instance(
    nsInstanceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return tnb(
        "GET",
        "/sol/nslcm/v1/ns_instances/$(nsInstanceId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_sol_network_operation(ns_lcm_op_occ_id)
    get_sol_network_operation(ns_lcm_op_occ_id, params::Dict{String,<:Any})

Gets the details of a network operation, including the tasks involved in the network
operation and the status of the tasks. A network operation is any operation that is done to
your network, such as network instance instantiation or termination.

# Arguments
- `ns_lcm_op_occ_id`: The identifier of the network operation.

"""
function get_sol_network_operation(
    nsLcmOpOccId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return tnb(
        "GET",
        "/sol/nslcm/v1/ns_lcm_op_occs/$(nsLcmOpOccId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_sol_network_operation(
    nsLcmOpOccId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return tnb(
        "GET",
        "/sol/nslcm/v1/ns_lcm_op_occs/$(nsLcmOpOccId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_sol_network_package(nsd_info_id)
    get_sol_network_package(nsd_info_id, params::Dict{String,<:Any})

Gets the details of a network package. A network package is a .zip file in CSAR (Cloud
Service Archive) format defines the function packages you want to deploy and the Amazon Web
Services infrastructure you want to deploy them on.

# Arguments
- `nsd_info_id`: ID of the network service descriptor in the network package.

"""
function get_sol_network_package(
    nsdInfoId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return tnb(
        "GET",
        "/sol/nsd/v1/ns_descriptors/$(nsdInfoId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_sol_network_package(
    nsdInfoId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return tnb(
        "GET",
        "/sol/nsd/v1/ns_descriptors/$(nsdInfoId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_sol_network_package_content(accept, nsd_info_id)
    get_sol_network_package_content(accept, nsd_info_id, params::Dict{String,<:Any})

Gets the contents of a network package. A network package is a .zip file in CSAR (Cloud
Service Archive) format defines the function packages you want to deploy and the Amazon Web
Services infrastructure you want to deploy them on.

# Arguments
- `accept`: The format of the package you want to download from the network package.
- `nsd_info_id`: ID of the network service descriptor in the network package.

"""
function get_sol_network_package_content(
    Accept, nsdInfoId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return tnb(
        "GET",
        "/sol/nsd/v1/ns_descriptors/$(nsdInfoId)/nsd_content",
        Dict{String,Any}("headers" => Dict{String,Any}("Accept" => Accept));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_sol_network_package_content(
    Accept,
    nsdInfoId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return tnb(
        "GET",
        "/sol/nsd/v1/ns_descriptors/$(nsdInfoId)/nsd_content",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("headers" => Dict{String,Any}("Accept" => Accept)),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_sol_network_package_descriptor(nsd_info_id)
    get_sol_network_package_descriptor(nsd_info_id, params::Dict{String,<:Any})

Gets the content of the network service descriptor. A network service descriptor is a .yaml
file in a network package that uses the TOSCA standard to describe the network functions
you want to deploy and the Amazon Web Services infrastructure you want to deploy the
network functions on.

# Arguments
- `nsd_info_id`: ID of the network service descriptor in the network package.

"""
function get_sol_network_package_descriptor(
    nsdInfoId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return tnb(
        "GET",
        "/sol/nsd/v1/ns_descriptors/$(nsdInfoId)/nsd";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_sol_network_package_descriptor(
    nsdInfoId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return tnb(
        "GET",
        "/sol/nsd/v1/ns_descriptors/$(nsdInfoId)/nsd",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    instantiate_sol_network_instance(ns_instance_id)
    instantiate_sol_network_instance(ns_instance_id, params::Dict{String,<:Any})

Instantiates a network instance. A network instance is a single network created in Amazon
Web Services TNB that can be deployed and on which life-cycle operations (like terminate,
update, and delete) can be performed. Before you can instantiate a network instance, you
have to create a network instance. For more information, see CreateSolNetworkInstance.

# Arguments
- `ns_instance_id`: ID of the network instance.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"additionalParamsForNs"`: Provides values for the configurable properties.
- `"dry_run"`: A check for whether you have the required permissions for the action without
  actually making the request and provides an error response. If you have the required
  permissions, the error response is DryRunOperation. Otherwise, it is UnauthorizedOperation.
- `"tags"`: A tag is a label that you assign to an Amazon Web Services resource. Each tag
  consists of a key and an optional value. When you use this API, the tags are transferred to
  the network operation that is created. Use tags to search and filter your resources or
  track your Amazon Web Services costs.
"""
function instantiate_sol_network_instance(
    nsInstanceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return tnb(
        "POST",
        "/sol/nslcm/v1/ns_instances/$(nsInstanceId)/instantiate";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function instantiate_sol_network_instance(
    nsInstanceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return tnb(
        "POST",
        "/sol/nslcm/v1/ns_instances/$(nsInstanceId)/instantiate",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_sol_function_instances()
    list_sol_function_instances(params::Dict{String,<:Any})

Lists network function instances. A network function instance is a function in a function
package .

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"max_results"`: The maximum number of results to include in the response.
- `"nextpage_opaque_marker"`: The token for the next page of results.
"""
function list_sol_function_instances(; aws_config::AbstractAWSConfig=current_aws_config())
    return tnb(
        "GET",
        "/sol/vnflcm/v1/vnf_instances";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_sol_function_instances(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return tnb(
        "GET",
        "/sol/vnflcm/v1/vnf_instances",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_sol_function_packages()
    list_sol_function_packages(params::Dict{String,<:Any})

Lists information about function packages. A function package is a .zip file in CSAR (Cloud
Service Archive) format that contains a network function (an ETSI standard
telecommunication application) and function package descriptor that uses the TOSCA standard
to describe how the network functions should run on your network.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"max_results"`: The maximum number of results to include in the response.
- `"nextpage_opaque_marker"`: The token for the next page of results.
"""
function list_sol_function_packages(; aws_config::AbstractAWSConfig=current_aws_config())
    return tnb(
        "GET",
        "/sol/vnfpkgm/v1/vnf_packages";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_sol_function_packages(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return tnb(
        "GET",
        "/sol/vnfpkgm/v1/vnf_packages",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_sol_network_instances()
    list_sol_network_instances(params::Dict{String,<:Any})

Lists your network instances. A network instance is a single network created in Amazon Web
Services TNB that can be deployed and on which life-cycle operations (like terminate,
update, and delete) can be performed.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"max_results"`: The maximum number of results to include in the response.
- `"nextpage_opaque_marker"`: The token for the next page of results.
"""
function list_sol_network_instances(; aws_config::AbstractAWSConfig=current_aws_config())
    return tnb(
        "GET",
        "/sol/nslcm/v1/ns_instances";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_sol_network_instances(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return tnb(
        "GET",
        "/sol/nslcm/v1/ns_instances",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_sol_network_operations()
    list_sol_network_operations(params::Dict{String,<:Any})

Lists details for a network operation, including when the operation started and the status
of the operation. A network operation is any operation that is done to your network, such
as network instance instantiation or termination.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"max_results"`: The maximum number of results to include in the response.
- `"nextpage_opaque_marker"`: The token for the next page of results.
"""
function list_sol_network_operations(; aws_config::AbstractAWSConfig=current_aws_config())
    return tnb(
        "GET",
        "/sol/nslcm/v1/ns_lcm_op_occs";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_sol_network_operations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return tnb(
        "GET",
        "/sol/nslcm/v1/ns_lcm_op_occs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_sol_network_packages()
    list_sol_network_packages(params::Dict{String,<:Any})

Lists network packages. A network package is a .zip file in CSAR (Cloud Service Archive)
format defines the function packages you want to deploy and the Amazon Web Services
infrastructure you want to deploy them on.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"max_results"`: The maximum number of results to include in the response.
- `"nextpage_opaque_marker"`: The token for the next page of results.
"""
function list_sol_network_packages(; aws_config::AbstractAWSConfig=current_aws_config())
    return tnb(
        "GET",
        "/sol/nsd/v1/ns_descriptors";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_sol_network_packages(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return tnb(
        "GET",
        "/sol/nsd/v1/ns_descriptors",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists tags for AWS TNB resources.

# Arguments
- `resource_arn`: Resource ARN.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return tnb(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return tnb(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_sol_function_package_content(file, vnf_pkg_id)
    put_sol_function_package_content(file, vnf_pkg_id, params::Dict{String,<:Any})

Uploads the contents of a function package. A function package is a .zip file in CSAR
(Cloud Service Archive) format that contains a network function (an ETSI standard
telecommunication application) and function package descriptor that uses the TOSCA standard
to describe how the network functions should run on your network.

# Arguments
- `file`: Function package file.
- `vnf_pkg_id`: Function package ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Content-Type"`: Function package content type.
"""
function put_sol_function_package_content(
    file, vnfPkgId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return tnb(
        "PUT",
        "/sol/vnfpkgm/v1/vnf_packages/$(vnfPkgId)/package_content",
        Dict{String,Any}("file" => file);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_sol_function_package_content(
    file,
    vnfPkgId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return tnb(
        "PUT",
        "/sol/vnfpkgm/v1/vnf_packages/$(vnfPkgId)/package_content",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("file" => file), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_sol_network_package_content(file, nsd_info_id)
    put_sol_network_package_content(file, nsd_info_id, params::Dict{String,<:Any})

Uploads the contents of a network package. A network package is a .zip file in CSAR (Cloud
Service Archive) format defines the function packages you want to deploy and the Amazon Web
Services infrastructure you want to deploy them on.

# Arguments
- `file`: Network package file.
- `nsd_info_id`: Network service descriptor info ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Content-Type"`: Network package content type.
"""
function put_sol_network_package_content(
    file, nsdInfoId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return tnb(
        "PUT",
        "/sol/nsd/v1/ns_descriptors/$(nsdInfoId)/nsd_content",
        Dict{String,Any}("file" => file);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_sol_network_package_content(
    file,
    nsdInfoId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return tnb(
        "PUT",
        "/sol/nsd/v1/ns_descriptors/$(nsdInfoId)/nsd_content",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("file" => file), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Tags an AWS TNB resource. A tag is a label that you assign to an Amazon Web Services
resource. Each tag consists of a key and an optional value. You can use tags to search and
filter your resources or track your Amazon Web Services costs.

# Arguments
- `resource_arn`: Resource ARN.
- `tags`: A tag is a label that you assign to an Amazon Web Services resource. Each tag
  consists of a key and an optional value. You can use tags to search and filter your
  resources or track your Amazon Web Services costs.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return tnb(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return tnb(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    terminate_sol_network_instance(ns_instance_id)
    terminate_sol_network_instance(ns_instance_id, params::Dict{String,<:Any})

Terminates a network instance. A network instance is a single network created in Amazon Web
Services TNB that can be deployed and on which life-cycle operations (like terminate,
update, and delete) can be performed. You must terminate a network instance before you can
delete it.

# Arguments
- `ns_instance_id`: ID of the network instance.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tags"`: A tag is a label that you assign to an Amazon Web Services resource. Each tag
  consists of a key and an optional value. When you use this API, the tags are transferred to
  the network operation that is created. Use tags to search and filter your resources or
  track your Amazon Web Services costs.
"""
function terminate_sol_network_instance(
    nsInstanceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return tnb(
        "POST",
        "/sol/nslcm/v1/ns_instances/$(nsInstanceId)/terminate";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function terminate_sol_network_instance(
    nsInstanceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return tnb(
        "POST",
        "/sol/nslcm/v1/ns_instances/$(nsInstanceId)/terminate",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Untags an AWS TNB resource. A tag is a label that you assign to an Amazon Web Services
resource. Each tag consists of a key and an optional value. You can use tags to search and
filter your resources or track your Amazon Web Services costs.

# Arguments
- `resource_arn`: Resource ARN.
- `tag_keys`: Tag keys.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return tnb(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return tnb(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_sol_function_package(operational_state, vnf_pkg_id)
    update_sol_function_package(operational_state, vnf_pkg_id, params::Dict{String,<:Any})

Updates the operational state of function package. A function package is a .zip file in
CSAR (Cloud Service Archive) format that contains a network function (an ETSI standard
telecommunication application) and function package descriptor that uses the TOSCA standard
to describe how the network functions should run on your network.

# Arguments
- `operational_state`: Operational state of the function package.
- `vnf_pkg_id`: ID of the function package.

"""
function update_sol_function_package(
    operationalState, vnfPkgId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return tnb(
        "PATCH",
        "/sol/vnfpkgm/v1/vnf_packages/$(vnfPkgId)",
        Dict{String,Any}("operationalState" => operationalState);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_sol_function_package(
    operationalState,
    vnfPkgId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return tnb(
        "PATCH",
        "/sol/vnfpkgm/v1/vnf_packages/$(vnfPkgId)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("operationalState" => operationalState), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_sol_network_instance(ns_instance_id, update_type)
    update_sol_network_instance(ns_instance_id, update_type, params::Dict{String,<:Any})

Update a network instance. A network instance is a single network created in Amazon Web
Services TNB that can be deployed and on which life-cycle operations (like terminate,
update, and delete) can be performed.

# Arguments
- `ns_instance_id`: ID of the network instance.
- `update_type`: The type of update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"modifyVnfInfoData"`: Identifies the network function information parameters and/or the
  configurable properties of the network function to be modified.
- `"tags"`: A tag is a label that you assign to an Amazon Web Services resource. Each tag
  consists of a key and an optional value. When you use this API, the tags are transferred to
  the network operation that is created. Use tags to search and filter your resources or
  track your Amazon Web Services costs.
"""
function update_sol_network_instance(
    nsInstanceId, updateType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return tnb(
        "POST",
        "/sol/nslcm/v1/ns_instances/$(nsInstanceId)/update",
        Dict{String,Any}("updateType" => updateType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_sol_network_instance(
    nsInstanceId,
    updateType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return tnb(
        "POST",
        "/sol/nslcm/v1/ns_instances/$(nsInstanceId)/update",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("updateType" => updateType), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_sol_network_package(nsd_info_id, nsd_operational_state)
    update_sol_network_package(nsd_info_id, nsd_operational_state, params::Dict{String,<:Any})

Updates the operational state of a network package. A network package is a .zip file in
CSAR (Cloud Service Archive) format defines the function packages you want to deploy and
the Amazon Web Services infrastructure you want to deploy them on. A network service
descriptor is a .yaml file in a network package that uses the TOSCA standard to describe
the network functions you want to deploy and the Amazon Web Services infrastructure you
want to deploy the network functions on.

# Arguments
- `nsd_info_id`: ID of the network service descriptor in the network package.
- `nsd_operational_state`: Operational state of the network service descriptor in the
  network package.

"""
function update_sol_network_package(
    nsdInfoId, nsdOperationalState; aws_config::AbstractAWSConfig=current_aws_config()
)
    return tnb(
        "PATCH",
        "/sol/nsd/v1/ns_descriptors/$(nsdInfoId)",
        Dict{String,Any}("nsdOperationalState" => nsdOperationalState);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_sol_network_package(
    nsdInfoId,
    nsdOperationalState,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return tnb(
        "PATCH",
        "/sol/nsd/v1/ns_descriptors/$(nsdInfoId)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("nsdOperationalState" => nsdOperationalState),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    validate_sol_function_package_content(file, vnf_pkg_id)
    validate_sol_function_package_content(file, vnf_pkg_id, params::Dict{String,<:Any})

Validates function package content. This can be used as a dry run before uploading function
package content with PutSolFunctionPackageContent. A function package is a .zip file in
CSAR (Cloud Service Archive) format that contains a network function (an ETSI standard
telecommunication application) and function package descriptor that uses the TOSCA standard
to describe how the network functions should run on your network.

# Arguments
- `file`: Function package file.
- `vnf_pkg_id`: Function package ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Content-Type"`: Function package content type.
"""
function validate_sol_function_package_content(
    file, vnfPkgId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return tnb(
        "PUT",
        "/sol/vnfpkgm/v1/vnf_packages/$(vnfPkgId)/package_content/validate",
        Dict{String,Any}("file" => file);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function validate_sol_function_package_content(
    file,
    vnfPkgId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return tnb(
        "PUT",
        "/sol/vnfpkgm/v1/vnf_packages/$(vnfPkgId)/package_content/validate",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("file" => file), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    validate_sol_network_package_content(file, nsd_info_id)
    validate_sol_network_package_content(file, nsd_info_id, params::Dict{String,<:Any})

Validates network package content. This can be used as a dry run before uploading network
package content with PutSolNetworkPackageContent. A network package is a .zip file in CSAR
(Cloud Service Archive) format defines the function packages you want to deploy and the
Amazon Web Services infrastructure you want to deploy them on.

# Arguments
- `file`: Network package file.
- `nsd_info_id`: Network service descriptor file.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Content-Type"`: Network package content type.
"""
function validate_sol_network_package_content(
    file, nsdInfoId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return tnb(
        "PUT",
        "/sol/nsd/v1/ns_descriptors/$(nsdInfoId)/nsd_content/validate",
        Dict{String,Any}("file" => file);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function validate_sol_network_package_content(
    file,
    nsdInfoId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return tnb(
        "PUT",
        "/sol/nsd/v1/ns_descriptors/$(nsdInfoId)/nsd_content/validate",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("file" => file), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: ecr
using AWS.Compat
using AWS.UUIDs

"""
    batch_check_layer_availability(layer_digests, repository_name)
    batch_check_layer_availability(layer_digests, repository_name, params::Dict{String,<:Any})

Checks the availability of one or more image layers in a repository. When an image is
pushed to a repository, each image layer is checked to verify if it has been uploaded
before. If it has been uploaded, then the image layer is skipped.  This operation is used
by the Amazon ECR proxy and is not generally used by customers for pulling and pushing
images. In most cases, you should use the docker CLI to pull, tag, and push images.

# Arguments
- `layer_digests`: The digests of the image layers to check.
- `repository_name`: The name of the repository that is associated with the image layers to
  check.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"registryId"`: The Amazon Web Services account ID associated with the registry that
  contains the image layers to check. If you do not specify a registry, the default registry
  is assumed.
"""
function batch_check_layer_availability(
    layerDigests, repositoryName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecr(
        "BatchCheckLayerAvailability",
        Dict{String,Any}(
            "layerDigests" => layerDigests, "repositoryName" => repositoryName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_check_layer_availability(
    layerDigests,
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecr(
        "BatchCheckLayerAvailability",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "layerDigests" => layerDigests, "repositoryName" => repositoryName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_delete_image(image_ids, repository_name)
    batch_delete_image(image_ids, repository_name, params::Dict{String,<:Any})

Deletes a list of specified images within a repository. Images are specified with either an
imageTag or imageDigest. You can remove a tag from an image by specifying the image's tag
in your request. When you remove the last tag from an image, the image is deleted from your
repository. You can completely delete an image (and all of its tags) by specifying the
image's digest in your request.

# Arguments
- `image_ids`: A list of image ID references that correspond to images to delete. The
  format of the imageIds reference is imageTag=tag or imageDigest=digest.
- `repository_name`: The repository that contains the image to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"registryId"`: The Amazon Web Services account ID associated with the registry that
  contains the image to delete. If you do not specify a registry, the default registry is
  assumed.
"""
function batch_delete_image(
    imageIds, repositoryName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecr(
        "BatchDeleteImage",
        Dict{String,Any}("imageIds" => imageIds, "repositoryName" => repositoryName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_delete_image(
    imageIds,
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecr(
        "BatchDeleteImage",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "imageIds" => imageIds, "repositoryName" => repositoryName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_get_image(image_ids, repository_name)
    batch_get_image(image_ids, repository_name, params::Dict{String,<:Any})

Gets detailed information for an image. Images are specified with either an imageTag or
imageDigest. When an image is pulled, the BatchGetImage API is called once to retrieve the
image manifest.

# Arguments
- `image_ids`: A list of image ID references that correspond to images to describe. The
  format of the imageIds reference is imageTag=tag or imageDigest=digest.
- `repository_name`: The repository that contains the images to describe.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"acceptedMediaTypes"`: The accepted media types for the request. Valid values:
  application/vnd.docker.distribution.manifest.v1+json |
  application/vnd.docker.distribution.manifest.v2+json |
  application/vnd.oci.image.manifest.v1+json
- `"registryId"`: The Amazon Web Services account ID associated with the registry that
  contains the images to describe. If you do not specify a registry, the default registry is
  assumed.
"""
function batch_get_image(
    imageIds, repositoryName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecr(
        "BatchGetImage",
        Dict{String,Any}("imageIds" => imageIds, "repositoryName" => repositoryName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_image(
    imageIds,
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecr(
        "BatchGetImage",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "imageIds" => imageIds, "repositoryName" => repositoryName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_get_repository_scanning_configuration(repository_names)
    batch_get_repository_scanning_configuration(repository_names, params::Dict{String,<:Any})

Gets the scanning configuration for one or more repositories.

# Arguments
- `repository_names`: One or more repository names to get the scanning configuration for.

"""
function batch_get_repository_scanning_configuration(
    repositoryNames; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecr(
        "BatchGetRepositoryScanningConfiguration",
        Dict{String,Any}("repositoryNames" => repositoryNames);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_repository_scanning_configuration(
    repositoryNames,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecr(
        "BatchGetRepositoryScanningConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("repositoryNames" => repositoryNames), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    complete_layer_upload(layer_digests, repository_name, upload_id)
    complete_layer_upload(layer_digests, repository_name, upload_id, params::Dict{String,<:Any})

Informs Amazon ECR that the image layer upload has completed for a specified registry,
repository name, and upload ID. You can optionally provide a sha256 digest of the image
layer for data validation purposes. When an image is pushed, the CompleteLayerUpload API is
called once per each new image layer to verify that the upload has completed.  This
operation is used by the Amazon ECR proxy and is not generally used by customers for
pulling and pushing images. In most cases, you should use the docker CLI to pull, tag, and
push images.

# Arguments
- `layer_digests`: The sha256 digest of the image layer.
- `repository_name`: The name of the repository to associate with the image layer.
- `upload_id`: The upload ID from a previous InitiateLayerUpload operation to associate
  with the image layer.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"registryId"`: The Amazon Web Services account ID associated with the registry to which
  to upload layers. If you do not specify a registry, the default registry is assumed.
"""
function complete_layer_upload(
    layerDigests,
    repositoryName,
    uploadId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecr(
        "CompleteLayerUpload",
        Dict{String,Any}(
            "layerDigests" => layerDigests,
            "repositoryName" => repositoryName,
            "uploadId" => uploadId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function complete_layer_upload(
    layerDigests,
    repositoryName,
    uploadId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecr(
        "CompleteLayerUpload",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "layerDigests" => layerDigests,
                    "repositoryName" => repositoryName,
                    "uploadId" => uploadId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_pull_through_cache_rule(ecr_repository_prefix, upstream_registry_url)
    create_pull_through_cache_rule(ecr_repository_prefix, upstream_registry_url, params::Dict{String,<:Any})

Creates a pull through cache rule. A pull through cache rule provides a way to cache images
from an upstream registry source in your Amazon ECR private registry. For more information,
see Using pull through cache rules in the Amazon Elastic Container Registry User Guide.

# Arguments
- `ecr_repository_prefix`: The repository name prefix to use when caching images from the
  source registry.
- `upstream_registry_url`: The registry URL of the upstream public registry to use as the
  source for the pull through cache rule. The following is the syntax to use for each
  supported upstream registry.   Amazon ECR Public (ecr-public) - public.ecr.aws    Docker
  Hub (docker-hub) - registry-1.docker.io    Quay (quay) - quay.io    Kubernetes (k8s) -
  registry.k8s.io    GitHub Container Registry (github-container-registry) - ghcr.io
  Microsoft Azure Container Registry (azure-container-registry) - &lt;custom&gt;.azurecr.io
   GitLab Container Registry (gitlab-container-registry) - registry.gitlab.com

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"credentialArn"`: The Amazon Resource Name (ARN) of the Amazon Web Services Secrets
  Manager secret that identifies the credentials to authenticate to the upstream registry.
- `"registryId"`: The Amazon Web Services account ID associated with the registry to create
  the pull through cache rule for. If you do not specify a registry, the default registry is
  assumed.
- `"upstreamRegistry"`: The name of the upstream registry.
"""
function create_pull_through_cache_rule(
    ecrRepositoryPrefix,
    upstreamRegistryUrl;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecr(
        "CreatePullThroughCacheRule",
        Dict{String,Any}(
            "ecrRepositoryPrefix" => ecrRepositoryPrefix,
            "upstreamRegistryUrl" => upstreamRegistryUrl,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_pull_through_cache_rule(
    ecrRepositoryPrefix,
    upstreamRegistryUrl,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecr(
        "CreatePullThroughCacheRule",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ecrRepositoryPrefix" => ecrRepositoryPrefix,
                    "upstreamRegistryUrl" => upstreamRegistryUrl,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_repository(repository_name)
    create_repository(repository_name, params::Dict{String,<:Any})

Creates a repository. For more information, see Amazon ECR repositories in the Amazon
Elastic Container Registry User Guide.

# Arguments
- `repository_name`: The name to use for the repository. The repository name may be
  specified on its own (such as nginx-web-app) or it can be prepended with a namespace to
  group the repository into a category (such as project-a/nginx-web-app). The repository name
  must start with a letter and can only contain lowercase letters, numbers, hyphens,
  underscores, and forward slashes.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"encryptionConfiguration"`: The encryption configuration for the repository. This
  determines how the contents of your repository are encrypted at rest.
- `"imageScanningConfiguration"`: The image scanning configuration for the repository. This
  determines whether images are scanned for known vulnerabilities after being pushed to the
  repository.
- `"imageTagMutability"`: The tag mutability setting for the repository. If this parameter
  is omitted, the default setting of MUTABLE will be used which will allow image tags to be
  overwritten. If IMMUTABLE is specified, all image tags within the repository will be
  immutable which will prevent them from being overwritten.
- `"registryId"`: The Amazon Web Services account ID associated with the registry to create
  the repository. If you do not specify a registry, the default registry is assumed.
- `"tags"`: The metadata that you apply to the repository to help you categorize and
  organize them. Each tag consists of a key and an optional value, both of which you define.
  Tag keys can have a maximum character length of 128 characters, and tag values can have a
  maximum length of 256 characters.
"""
function create_repository(
    repositoryName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecr(
        "CreateRepository",
        Dict{String,Any}("repositoryName" => repositoryName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_repository(
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecr(
        "CreateRepository",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("repositoryName" => repositoryName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_lifecycle_policy(repository_name)
    delete_lifecycle_policy(repository_name, params::Dict{String,<:Any})

Deletes the lifecycle policy associated with the specified repository.

# Arguments
- `repository_name`: The name of the repository.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"registryId"`: The Amazon Web Services account ID associated with the registry that
  contains the repository. If you do not specify a registry, the default registry is assumed.
"""
function delete_lifecycle_policy(
    repositoryName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecr(
        "DeleteLifecyclePolicy",
        Dict{String,Any}("repositoryName" => repositoryName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_lifecycle_policy(
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecr(
        "DeleteLifecyclePolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("repositoryName" => repositoryName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_pull_through_cache_rule(ecr_repository_prefix)
    delete_pull_through_cache_rule(ecr_repository_prefix, params::Dict{String,<:Any})

Deletes a pull through cache rule.

# Arguments
- `ecr_repository_prefix`: The Amazon ECR repository prefix associated with the pull
  through cache rule to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"registryId"`: The Amazon Web Services account ID associated with the registry that
  contains the pull through cache rule. If you do not specify a registry, the default
  registry is assumed.
"""
function delete_pull_through_cache_rule(
    ecrRepositoryPrefix; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecr(
        "DeletePullThroughCacheRule",
        Dict{String,Any}("ecrRepositoryPrefix" => ecrRepositoryPrefix);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_pull_through_cache_rule(
    ecrRepositoryPrefix,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecr(
        "DeletePullThroughCacheRule",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ecrRepositoryPrefix" => ecrRepositoryPrefix),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_registry_policy()
    delete_registry_policy(params::Dict{String,<:Any})

Deletes the registry permissions policy.

"""
function delete_registry_policy(; aws_config::AbstractAWSConfig=current_aws_config())
    return ecr(
        "DeleteRegistryPolicy"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function delete_registry_policy(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecr(
        "DeleteRegistryPolicy",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_repository(repository_name)
    delete_repository(repository_name, params::Dict{String,<:Any})

Deletes a repository. If the repository isn't empty, you must either delete the contents of
the repository or use the force option to delete the repository and have Amazon ECR delete
all of its contents on your behalf.

# Arguments
- `repository_name`: The name of the repository to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"force"`: If true, deleting the repository force deletes the contents of the repository.
  If false, the repository must be empty before attempting to delete it.
- `"registryId"`: The Amazon Web Services account ID associated with the registry that
  contains the repository to delete. If you do not specify a registry, the default registry
  is assumed.
"""
function delete_repository(
    repositoryName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecr(
        "DeleteRepository",
        Dict{String,Any}("repositoryName" => repositoryName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_repository(
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecr(
        "DeleteRepository",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("repositoryName" => repositoryName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_repository_policy(repository_name)
    delete_repository_policy(repository_name, params::Dict{String,<:Any})

Deletes the repository policy associated with the specified repository.

# Arguments
- `repository_name`: The name of the repository that is associated with the repository
  policy to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"registryId"`: The Amazon Web Services account ID associated with the registry that
  contains the repository policy to delete. If you do not specify a registry, the default
  registry is assumed.
"""
function delete_repository_policy(
    repositoryName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecr(
        "DeleteRepositoryPolicy",
        Dict{String,Any}("repositoryName" => repositoryName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_repository_policy(
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecr(
        "DeleteRepositoryPolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("repositoryName" => repositoryName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_image_replication_status(image_id, repository_name)
    describe_image_replication_status(image_id, repository_name, params::Dict{String,<:Any})

Returns the replication status for a specified image.

# Arguments
- `image_id`:
- `repository_name`: The name of the repository that the image is in.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"registryId"`: The Amazon Web Services account ID associated with the registry. If you
  do not specify a registry, the default registry is assumed.
"""
function describe_image_replication_status(
    imageId, repositoryName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecr(
        "DescribeImageReplicationStatus",
        Dict{String,Any}("imageId" => imageId, "repositoryName" => repositoryName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_image_replication_status(
    imageId,
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecr(
        "DescribeImageReplicationStatus",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("imageId" => imageId, "repositoryName" => repositoryName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_image_scan_findings(image_id, repository_name)
    describe_image_scan_findings(image_id, repository_name, params::Dict{String,<:Any})

Returns the scan findings for the specified image.

# Arguments
- `image_id`:
- `repository_name`: The repository for the image for which to describe the scan findings.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of image scan results returned by
  DescribeImageScanFindings in paginated output. When this parameter is used,
  DescribeImageScanFindings only returns maxResults results in a single page along with a
  nextToken response element. The remaining results of the initial request can be seen by
  sending another DescribeImageScanFindings request with the returned nextToken value. This
  value can be between 1 and 1000. If this parameter is not used, then
  DescribeImageScanFindings returns up to 100 results and a nextToken value, if applicable.
- `"nextToken"`: The nextToken value returned from a previous paginated
  DescribeImageScanFindings request where maxResults was used and the results exceeded the
  value of that parameter. Pagination continues from the end of the previous results that
  returned the nextToken value. This value is null when there are no more results to return.
- `"registryId"`: The Amazon Web Services account ID associated with the registry that
  contains the repository in which to describe the image scan findings for. If you do not
  specify a registry, the default registry is assumed.
"""
function describe_image_scan_findings(
    imageId, repositoryName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecr(
        "DescribeImageScanFindings",
        Dict{String,Any}("imageId" => imageId, "repositoryName" => repositoryName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_image_scan_findings(
    imageId,
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecr(
        "DescribeImageScanFindings",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("imageId" => imageId, "repositoryName" => repositoryName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_images(repository_name)
    describe_images(repository_name, params::Dict{String,<:Any})

Returns metadata about the images in a repository.  Beginning with Docker version 1.9, the
Docker client compresses image layers before pushing them to a V2 Docker registry. The
output of the docker images command shows the uncompressed image size, so it may return a
larger image size than the image sizes returned by DescribeImages.

# Arguments
- `repository_name`: The repository that contains the images to describe.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filter"`: The filter key and value with which to filter your DescribeImages results.
- `"imageIds"`: The list of image IDs for the requested repository.
- `"maxResults"`: The maximum number of repository results returned by DescribeImages in
  paginated output. When this parameter is used, DescribeImages only returns maxResults
  results in a single page along with a nextToken response element. The remaining results of
  the initial request can be seen by sending another DescribeImages request with the returned
  nextToken value. This value can be between 1 and 1000. If this parameter is not used, then
  DescribeImages returns up to 100 results and a nextToken value, if applicable. This option
  cannot be used when you specify images with imageIds.
- `"nextToken"`: The nextToken value returned from a previous paginated DescribeImages
  request where maxResults was used and the results exceeded the value of that parameter.
  Pagination continues from the end of the previous results that returned the nextToken
  value. This value is null when there are no more results to return. This option cannot be
  used when you specify images with imageIds.
- `"registryId"`: The Amazon Web Services account ID associated with the registry that
  contains the repository in which to describe images. If you do not specify a registry, the
  default registry is assumed.
"""
function describe_images(repositoryName; aws_config::AbstractAWSConfig=current_aws_config())
    return ecr(
        "DescribeImages",
        Dict{String,Any}("repositoryName" => repositoryName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_images(
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecr(
        "DescribeImages",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("repositoryName" => repositoryName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_pull_through_cache_rules()
    describe_pull_through_cache_rules(params::Dict{String,<:Any})

Returns the pull through cache rules for a registry.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ecrRepositoryPrefixes"`: The Amazon ECR repository prefixes associated with the pull
  through cache rules to return. If no repository prefix value is specified, all pull through
  cache rules are returned.
- `"maxResults"`: The maximum number of pull through cache rules returned by
  DescribePullThroughCacheRulesRequest in paginated output. When this parameter is used,
  DescribePullThroughCacheRulesRequest only returns maxResults results in a single page along
  with a nextToken response element. The remaining results of the initial request can be seen
  by sending another DescribePullThroughCacheRulesRequest request with the returned nextToken
  value. This value can be between 1 and 1000. If this parameter is not used, then
  DescribePullThroughCacheRulesRequest returns up to 100 results and a nextToken value, if
  applicable.
- `"nextToken"`: The nextToken value returned from a previous paginated
  DescribePullThroughCacheRulesRequest request where maxResults was used and the results
  exceeded the value of that parameter. Pagination continues from the end of the previous
  results that returned the nextToken value. This value is null when there are no more
  results to return.
- `"registryId"`: The Amazon Web Services account ID associated with the registry to return
  the pull through cache rules for. If you do not specify a registry, the default registry is
  assumed.
"""
function describe_pull_through_cache_rules(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecr(
        "DescribePullThroughCacheRules";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_pull_through_cache_rules(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecr(
        "DescribePullThroughCacheRules",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_registry()
    describe_registry(params::Dict{String,<:Any})

Describes the settings for a registry. The replication configuration for a repository can
be created or updated with the PutReplicationConfiguration API action.

"""
function describe_registry(; aws_config::AbstractAWSConfig=current_aws_config())
    return ecr("DescribeRegistry"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function describe_registry(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecr(
        "DescribeRegistry", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_repositories()
    describe_repositories(params::Dict{String,<:Any})

Describes image repositories in a registry.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of repository results returned by DescribeRepositories
  in paginated output. When this parameter is used, DescribeRepositories only returns
  maxResults results in a single page along with a nextToken response element. The remaining
  results of the initial request can be seen by sending another DescribeRepositories request
  with the returned nextToken value. This value can be between 1 and 1000. If this parameter
  is not used, then DescribeRepositories returns up to 100 results and a nextToken value, if
  applicable. This option cannot be used when you specify repositories with repositoryNames.
- `"nextToken"`: The nextToken value returned from a previous paginated
  DescribeRepositories request where maxResults was used and the results exceeded the value
  of that parameter. Pagination continues from the end of the previous results that returned
  the nextToken value. This value is null when there are no more results to return. This
  option cannot be used when you specify repositories with repositoryNames.  This token
  should be treated as an opaque identifier that is only used to retrieve the next items in a
  list and not for other programmatic purposes.
- `"registryId"`: The Amazon Web Services account ID associated with the registry that
  contains the repositories to be described. If you do not specify a registry, the default
  registry is assumed.
- `"repositoryNames"`: A list of repositories to describe. If this parameter is omitted,
  then all repositories in a registry are described.
"""
function describe_repositories(; aws_config::AbstractAWSConfig=current_aws_config())
    return ecr(
        "DescribeRepositories"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_repositories(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecr(
        "DescribeRepositories",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_authorization_token()
    get_authorization_token(params::Dict{String,<:Any})

Retrieves an authorization token. An authorization token represents your IAM authentication
credentials and can be used to access any Amazon ECR registry that your IAM principal has
access to. The authorization token is valid for 12 hours. The authorizationToken returned
is a base64 encoded string that can be decoded and used in a docker login command to
authenticate to a registry. The CLI offers an get-login-password command that simplifies
the login process. For more information, see Registry authentication in the Amazon Elastic
Container Registry User Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"registryIds"`: A list of Amazon Web Services account IDs that are associated with the
  registries for which to get AuthorizationData objects. If you do not specify a registry,
  the default registry is assumed.
"""
function get_authorization_token(; aws_config::AbstractAWSConfig=current_aws_config())
    return ecr(
        "GetAuthorizationToken"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_authorization_token(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecr(
        "GetAuthorizationToken",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_download_url_for_layer(layer_digest, repository_name)
    get_download_url_for_layer(layer_digest, repository_name, params::Dict{String,<:Any})

Retrieves the pre-signed Amazon S3 download URL corresponding to an image layer. You can
only get URLs for image layers that are referenced in an image. When an image is pulled,
the GetDownloadUrlForLayer API is called once per image layer that is not already cached.
This operation is used by the Amazon ECR proxy and is not generally used by customers for
pulling and pushing images. In most cases, you should use the docker CLI to pull, tag, and
push images.

# Arguments
- `layer_digest`: The digest of the image layer to download.
- `repository_name`: The name of the repository that is associated with the image layer to
  download.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"registryId"`: The Amazon Web Services account ID associated with the registry that
  contains the image layer to download. If you do not specify a registry, the default
  registry is assumed.
"""
function get_download_url_for_layer(
    layerDigest, repositoryName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecr(
        "GetDownloadUrlForLayer",
        Dict{String,Any}("layerDigest" => layerDigest, "repositoryName" => repositoryName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_download_url_for_layer(
    layerDigest,
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecr(
        "GetDownloadUrlForLayer",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "layerDigest" => layerDigest, "repositoryName" => repositoryName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_lifecycle_policy(repository_name)
    get_lifecycle_policy(repository_name, params::Dict{String,<:Any})

Retrieves the lifecycle policy for the specified repository.

# Arguments
- `repository_name`: The name of the repository.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"registryId"`: The Amazon Web Services account ID associated with the registry that
  contains the repository. If you do not specify a registry, the default registry is assumed.
"""
function get_lifecycle_policy(
    repositoryName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecr(
        "GetLifecyclePolicy",
        Dict{String,Any}("repositoryName" => repositoryName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_lifecycle_policy(
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecr(
        "GetLifecyclePolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("repositoryName" => repositoryName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_lifecycle_policy_preview(repository_name)
    get_lifecycle_policy_preview(repository_name, params::Dict{String,<:Any})

Retrieves the results of the lifecycle policy preview request for the specified repository.

# Arguments
- `repository_name`: The name of the repository.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filter"`: An optional parameter that filters results based on image tag status and all
  tags, if tagged.
- `"imageIds"`: The list of imageIDs to be included.
- `"maxResults"`: The maximum number of repository results returned by
  GetLifecyclePolicyPreviewRequest in&#x2028; paginated output. When this parameter is used,
  GetLifecyclePolicyPreviewRequest only returns&#x2028; maxResults results in a single page
  along with a nextToken&#x2028; response element. The remaining results of the initial
  request can be seen by sending&#x2028; another GetLifecyclePolicyPreviewRequest request
  with the returned nextToken&#x2028; value. This value can be between 1 and 1000. If
  this&#x2028; parameter is not used, then GetLifecyclePolicyPreviewRequest returns up
  to&#x2028; 100 results and a nextToken value, if&#x2028; applicable. This option cannot be
  used when you specify images with imageIds.
- `"nextToken"`: The nextToken value returned from a previous paginated&#x2028;
  GetLifecyclePolicyPreviewRequest request where maxResults was used and the&#x2028; results
  exceeded the value of that parameter. Pagination continues from the end of the&#x2028;
  previous results that returned the nextToken value. This value is&#x2028; null when there
  are no more results to return. This option cannot be used when you specify images with
  imageIds.
- `"registryId"`: The Amazon Web Services account ID associated with the registry that
  contains the repository. If you do not specify a registry, the default registry is assumed.
"""
function get_lifecycle_policy_preview(
    repositoryName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecr(
        "GetLifecyclePolicyPreview",
        Dict{String,Any}("repositoryName" => repositoryName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_lifecycle_policy_preview(
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecr(
        "GetLifecyclePolicyPreview",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("repositoryName" => repositoryName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_registry_policy()
    get_registry_policy(params::Dict{String,<:Any})

Retrieves the permissions policy for a registry.

"""
function get_registry_policy(; aws_config::AbstractAWSConfig=current_aws_config())
    return ecr("GetRegistryPolicy"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function get_registry_policy(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecr(
        "GetRegistryPolicy", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_registry_scanning_configuration()
    get_registry_scanning_configuration(params::Dict{String,<:Any})

Retrieves the scanning configuration for a registry.

"""
function get_registry_scanning_configuration(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecr(
        "GetRegistryScanningConfiguration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_registry_scanning_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecr(
        "GetRegistryScanningConfiguration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_repository_policy(repository_name)
    get_repository_policy(repository_name, params::Dict{String,<:Any})

Retrieves the repository policy for the specified repository.

# Arguments
- `repository_name`: The name of the repository with the policy to retrieve.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"registryId"`: The Amazon Web Services account ID associated with the registry that
  contains the repository. If you do not specify a registry, the default registry is assumed.
"""
function get_repository_policy(
    repositoryName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecr(
        "GetRepositoryPolicy",
        Dict{String,Any}("repositoryName" => repositoryName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_repository_policy(
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecr(
        "GetRepositoryPolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("repositoryName" => repositoryName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    initiate_layer_upload(repository_name)
    initiate_layer_upload(repository_name, params::Dict{String,<:Any})

Notifies Amazon ECR that you intend to upload an image layer. When an image is pushed, the
InitiateLayerUpload API is called once per image layer that has not already been uploaded.
Whether or not an image layer has been uploaded is determined by the
BatchCheckLayerAvailability API action.  This operation is used by the Amazon ECR proxy and
is not generally used by customers for pulling and pushing images. In most cases, you
should use the docker CLI to pull, tag, and push images.

# Arguments
- `repository_name`: The name of the repository to which you intend to upload layers.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"registryId"`: The Amazon Web Services account ID associated with the registry to which
  you intend to upload layers. If you do not specify a registry, the default registry is
  assumed.
"""
function initiate_layer_upload(
    repositoryName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecr(
        "InitiateLayerUpload",
        Dict{String,Any}("repositoryName" => repositoryName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function initiate_layer_upload(
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecr(
        "InitiateLayerUpload",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("repositoryName" => repositoryName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_images(repository_name)
    list_images(repository_name, params::Dict{String,<:Any})

Lists all the image IDs for the specified repository. You can filter images based on
whether or not they are tagged by using the tagStatus filter and specifying either TAGGED,
UNTAGGED or ANY. For example, you can filter your results to return only UNTAGGED images
and then pipe that result to a BatchDeleteImage operation to delete them. Or, you can
filter your results to return only TAGGED images to list all of the tags in your repository.

# Arguments
- `repository_name`: The repository with image IDs to be listed.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filter"`: The filter key and value with which to filter your ListImages results.
- `"maxResults"`: The maximum number of image results returned by ListImages in paginated
  output. When this parameter is used, ListImages only returns maxResults results in a single
  page along with a nextToken response element. The remaining results of the initial request
  can be seen by sending another ListImages request with the returned nextToken value. This
  value can be between 1 and 1000. If this parameter is not used, then ListImages returns up
  to 100 results and a nextToken value, if applicable.
- `"nextToken"`: The nextToken value returned from a previous paginated ListImages request
  where maxResults was used and the results exceeded the value of that parameter. Pagination
  continues from the end of the previous results that returned the nextToken value. This
  value is null when there are no more results to return.  This token should be treated as an
  opaque identifier that is only used to retrieve the next items in a list and not for other
  programmatic purposes.
- `"registryId"`: The Amazon Web Services account ID associated with the registry that
  contains the repository in which to list images. If you do not specify a registry, the
  default registry is assumed.
"""
function list_images(repositoryName; aws_config::AbstractAWSConfig=current_aws_config())
    return ecr(
        "ListImages",
        Dict{String,Any}("repositoryName" => repositoryName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_images(
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecr(
        "ListImages",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("repositoryName" => repositoryName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

List the tags for an Amazon ECR resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) that identifies the resource for which to
  list the tags. Currently, the only supported resource is an Amazon ECR repository.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecr(
        "ListTagsForResource",
        Dict{String,Any}("resourceArn" => resourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecr(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceArn" => resourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_image(image_manifest, repository_name)
    put_image(image_manifest, repository_name, params::Dict{String,<:Any})

Creates or updates the image manifest and tags associated with an image. When an image is
pushed and all new image layers have been uploaded, the PutImage API is called once to
create or update the image manifest and the tags associated with the image.  This operation
is used by the Amazon ECR proxy and is not generally used by customers for pulling and
pushing images. In most cases, you should use the docker CLI to pull, tag, and push images.

# Arguments
- `image_manifest`: The image manifest corresponding to the image to be uploaded.
- `repository_name`: The name of the repository in which to put the image.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"imageDigest"`: The image digest of the image manifest corresponding to the image.
- `"imageManifestMediaType"`: The media type of the image manifest. If you push an image
  manifest that does not contain the mediaType field, you must specify the
  imageManifestMediaType in the request.
- `"imageTag"`: The tag to associate with the image. This parameter is required for images
  that use the Docker Image Manifest V2 Schema 2 or Open Container Initiative (OCI) formats.
- `"registryId"`: The Amazon Web Services account ID associated with the registry that
  contains the repository in which to put the image. If you do not specify a registry, the
  default registry is assumed.
"""
function put_image(
    imageManifest, repositoryName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecr(
        "PutImage",
        Dict{String,Any}(
            "imageManifest" => imageManifest, "repositoryName" => repositoryName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_image(
    imageManifest,
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecr(
        "PutImage",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "imageManifest" => imageManifest, "repositoryName" => repositoryName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_image_scanning_configuration(image_scanning_configuration, repository_name)
    put_image_scanning_configuration(image_scanning_configuration, repository_name, params::Dict{String,<:Any})

 The PutImageScanningConfiguration API is being deprecated, in favor of specifying the
image scanning configuration at the registry level. For more information, see
PutRegistryScanningConfiguration.  Updates the image scanning configuration for the
specified repository.

# Arguments
- `image_scanning_configuration`: The image scanning configuration for the repository. This
  setting determines whether images are scanned for known vulnerabilities after being pushed
  to the repository.
- `repository_name`: The name of the repository in which to update the image scanning
  configuration setting.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"registryId"`: The Amazon Web Services account ID associated with the registry that
  contains the repository in which to update the image scanning configuration setting. If you
  do not specify a registry, the default registry is assumed.
"""
function put_image_scanning_configuration(
    imageScanningConfiguration,
    repositoryName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecr(
        "PutImageScanningConfiguration",
        Dict{String,Any}(
            "imageScanningConfiguration" => imageScanningConfiguration,
            "repositoryName" => repositoryName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_image_scanning_configuration(
    imageScanningConfiguration,
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecr(
        "PutImageScanningConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "imageScanningConfiguration" => imageScanningConfiguration,
                    "repositoryName" => repositoryName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_image_tag_mutability(image_tag_mutability, repository_name)
    put_image_tag_mutability(image_tag_mutability, repository_name, params::Dict{String,<:Any})

Updates the image tag mutability settings for the specified repository. For more
information, see Image tag mutability in the Amazon Elastic Container Registry User Guide.

# Arguments
- `image_tag_mutability`: The tag mutability setting for the repository. If MUTABLE is
  specified, image tags can be overwritten. If IMMUTABLE is specified, all image tags within
  the repository will be immutable which will prevent them from being overwritten.
- `repository_name`: The name of the repository in which to update the image tag mutability
  settings.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"registryId"`: The Amazon Web Services account ID associated with the registry that
  contains the repository in which to update the image tag mutability settings. If you do not
  specify a registry, the default registry is assumed.
"""
function put_image_tag_mutability(
    imageTagMutability, repositoryName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecr(
        "PutImageTagMutability",
        Dict{String,Any}(
            "imageTagMutability" => imageTagMutability, "repositoryName" => repositoryName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_image_tag_mutability(
    imageTagMutability,
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecr(
        "PutImageTagMutability",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "imageTagMutability" => imageTagMutability,
                    "repositoryName" => repositoryName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_lifecycle_policy(lifecycle_policy_text, repository_name)
    put_lifecycle_policy(lifecycle_policy_text, repository_name, params::Dict{String,<:Any})

Creates or updates the lifecycle policy for the specified repository. For more information,
see Lifecycle policy template.

# Arguments
- `lifecycle_policy_text`: The JSON repository policy text to apply to the repository.
- `repository_name`: The name of the repository to receive the policy.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"registryId"`: The Amazon Web Services account ID associated with the registry that
  contains the repository. If you do&#x2028; not specify a registry, the default registry is
  assumed.
"""
function put_lifecycle_policy(
    lifecyclePolicyText, repositoryName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecr(
        "PutLifecyclePolicy",
        Dict{String,Any}(
            "lifecyclePolicyText" => lifecyclePolicyText, "repositoryName" => repositoryName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_lifecycle_policy(
    lifecyclePolicyText,
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecr(
        "PutLifecyclePolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "lifecyclePolicyText" => lifecyclePolicyText,
                    "repositoryName" => repositoryName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_registry_policy(policy_text)
    put_registry_policy(policy_text, params::Dict{String,<:Any})

Creates or updates the permissions policy for your registry. A registry policy is used to
specify permissions for another Amazon Web Services account and is used when configuring
cross-account replication. For more information, see Registry permissions in the Amazon
Elastic Container Registry User Guide.

# Arguments
- `policy_text`: The JSON policy text to apply to your registry. The policy text follows
  the same format as IAM policy text. For more information, see Registry permissions in the
  Amazon Elastic Container Registry User Guide.

"""
function put_registry_policy(policyText; aws_config::AbstractAWSConfig=current_aws_config())
    return ecr(
        "PutRegistryPolicy",
        Dict{String,Any}("policyText" => policyText);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_registry_policy(
    policyText,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecr(
        "PutRegistryPolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("policyText" => policyText), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_registry_scanning_configuration()
    put_registry_scanning_configuration(params::Dict{String,<:Any})

Creates or updates the scanning configuration for your private registry.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"rules"`: The scanning rules to use for the registry. A scanning rule is used to
  determine which repository filters are used and at what frequency scanning will occur.
- `"scanType"`: The scanning type to set for the registry. When a registry scanning
  configuration is not defined, by default the BASIC scan type is used. When basic scanning
  is used, you may specify filters to determine which individual repositories, or all
  repositories, are scanned when new images are pushed to those repositories. Alternatively,
  you can do manual scans of images with basic scanning. When the ENHANCED scan type is set,
  Amazon Inspector provides automated vulnerability scanning. You may choose between
  continuous scanning or scan on push and you may specify filters to determine which
  individual repositories, or all repositories, are scanned.
"""
function put_registry_scanning_configuration(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecr(
        "PutRegistryScanningConfiguration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_registry_scanning_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecr(
        "PutRegistryScanningConfiguration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_replication_configuration(replication_configuration)
    put_replication_configuration(replication_configuration, params::Dict{String,<:Any})

Creates or updates the replication configuration for a registry. The existing replication
configuration for a repository can be retrieved with the DescribeRegistry API action. The
first time the PutReplicationConfiguration API is called, a service-linked IAM role is
created in your account for the replication process. For more information, see Using
service-linked roles for Amazon ECR in the Amazon Elastic Container Registry User Guide.
When configuring cross-account replication, the destination account must grant the source
account permission to replicate. This permission is controlled using a registry permissions
policy. For more information, see PutRegistryPolicy.

# Arguments
- `replication_configuration`: An object representing the replication configuration for a
  registry.

"""
function put_replication_configuration(
    replicationConfiguration; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecr(
        "PutReplicationConfiguration",
        Dict{String,Any}("replicationConfiguration" => replicationConfiguration);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_replication_configuration(
    replicationConfiguration,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecr(
        "PutReplicationConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("replicationConfiguration" => replicationConfiguration),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    set_repository_policy(policy_text, repository_name)
    set_repository_policy(policy_text, repository_name, params::Dict{String,<:Any})

Applies a repository policy to the specified repository to control access permissions. For
more information, see Amazon ECR Repository policies in the Amazon Elastic Container
Registry User Guide.

# Arguments
- `policy_text`: The JSON repository policy text to apply to the repository. For more
  information, see Amazon ECR repository policies in the Amazon Elastic Container Registry
  User Guide.
- `repository_name`: The name of the repository to receive the policy.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"force"`: If the policy you are attempting to set on a repository policy would prevent
  you from setting another policy in the future, you must force the SetRepositoryPolicy
  operation. This is intended to prevent accidental repository lock outs.
- `"registryId"`: The Amazon Web Services account ID associated with the registry that
  contains the repository. If you do not specify a registry, the default registry is assumed.
"""
function set_repository_policy(
    policyText, repositoryName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecr(
        "SetRepositoryPolicy",
        Dict{String,Any}("policyText" => policyText, "repositoryName" => repositoryName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function set_repository_policy(
    policyText,
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecr(
        "SetRepositoryPolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "policyText" => policyText, "repositoryName" => repositoryName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_image_scan(image_id, repository_name)
    start_image_scan(image_id, repository_name, params::Dict{String,<:Any})

Starts an image vulnerability scan. An image scan can only be started once per 24 hours on
an individual image. This limit includes if an image was scanned on initial push. For more
information, see Image scanning in the Amazon Elastic Container Registry User Guide.

# Arguments
- `image_id`:
- `repository_name`: The name of the repository that contains the images to scan.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"registryId"`: The Amazon Web Services account ID associated with the registry that
  contains the repository in which to start an image scan request. If you do not specify a
  registry, the default registry is assumed.
"""
function start_image_scan(
    imageId, repositoryName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecr(
        "StartImageScan",
        Dict{String,Any}("imageId" => imageId, "repositoryName" => repositoryName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_image_scan(
    imageId,
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecr(
        "StartImageScan",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("imageId" => imageId, "repositoryName" => repositoryName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_lifecycle_policy_preview(repository_name)
    start_lifecycle_policy_preview(repository_name, params::Dict{String,<:Any})

Starts a preview of a lifecycle policy for the specified repository. This allows you to see
the results before associating the lifecycle policy with the repository.

# Arguments
- `repository_name`: The name of the repository to be evaluated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"lifecyclePolicyText"`: The policy to be evaluated against. If you do not specify a
  policy, the current policy for the repository is used.
- `"registryId"`: The Amazon Web Services account ID associated with the registry that
  contains the repository. If you do not specify a registry, the default registry is assumed.
"""
function start_lifecycle_policy_preview(
    repositoryName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecr(
        "StartLifecyclePolicyPreview",
        Dict{String,Any}("repositoryName" => repositoryName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_lifecycle_policy_preview(
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecr(
        "StartLifecyclePolicyPreview",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("repositoryName" => repositoryName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds specified tags to a resource with the specified ARN. Existing tags on a resource are
not changed if they are not specified in the request parameters.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the the resource to which to add tags.
  Currently, the only supported resource is an Amazon ECR repository.
- `tags`: The tags to add to the resource. A tag is an array of key-value pairs. Tag keys
  can have a maximum character length of 128 characters, and tag values can have a maximum
  length of 256 characters.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return ecr(
        "TagResource",
        Dict{String,Any}("resourceArn" => resourceArn, "tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecr(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceArn" => resourceArn, "tags" => tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Deletes specified tags from a resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource from which to remove tags.
  Currently, the only supported resource is an Amazon ECR repository.
- `tag_keys`: The keys of the tags to be removed.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecr(
        "UntagResource",
        Dict{String,Any}("resourceArn" => resourceArn, "tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecr(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceArn" => resourceArn, "tagKeys" => tagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_pull_through_cache_rule(credential_arn, ecr_repository_prefix)
    update_pull_through_cache_rule(credential_arn, ecr_repository_prefix, params::Dict{String,<:Any})

Updates an existing pull through cache rule.

# Arguments
- `credential_arn`: The Amazon Resource Name (ARN) of the Amazon Web Services Secrets
  Manager secret that identifies the credentials to authenticate to the upstream registry.
- `ecr_repository_prefix`: The repository name prefix to use when caching images from the
  source registry.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"registryId"`: The Amazon Web Services account ID associated with the registry
  associated with the pull through cache rule. If you do not specify a registry, the default
  registry is assumed.
"""
function update_pull_through_cache_rule(
    credentialArn, ecrRepositoryPrefix; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecr(
        "UpdatePullThroughCacheRule",
        Dict{String,Any}(
            "credentialArn" => credentialArn, "ecrRepositoryPrefix" => ecrRepositoryPrefix
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_pull_through_cache_rule(
    credentialArn,
    ecrRepositoryPrefix,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecr(
        "UpdatePullThroughCacheRule",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "credentialArn" => credentialArn,
                    "ecrRepositoryPrefix" => ecrRepositoryPrefix,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    upload_layer_part(layer_part_blob, part_first_byte, part_last_byte, repository_name, upload_id)
    upload_layer_part(layer_part_blob, part_first_byte, part_last_byte, repository_name, upload_id, params::Dict{String,<:Any})

Uploads an image layer part to Amazon ECR. When an image is pushed, each new image layer is
uploaded in parts. The maximum size of each image layer part can be 20971520 bytes (or
about 20MB). The UploadLayerPart API is called once per each new image layer part.  This
operation is used by the Amazon ECR proxy and is not generally used by customers for
pulling and pushing images. In most cases, you should use the docker CLI to pull, tag, and
push images.

# Arguments
- `layer_part_blob`: The base64-encoded layer part payload.
- `part_first_byte`: The position of the first byte of the layer part witin the overall
  image layer.
- `part_last_byte`: The position of the last byte of the layer part within the overall
  image layer.
- `repository_name`: The name of the repository to which you are uploading layer parts.
- `upload_id`: The upload ID from a previous InitiateLayerUpload operation to associate
  with the layer part upload.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"registryId"`: The Amazon Web Services account ID associated with the registry to which
  you are uploading layer parts. If you do not specify a registry, the default registry is
  assumed.
"""
function upload_layer_part(
    layerPartBlob,
    partFirstByte,
    partLastByte,
    repositoryName,
    uploadId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecr(
        "UploadLayerPart",
        Dict{String,Any}(
            "layerPartBlob" => layerPartBlob,
            "partFirstByte" => partFirstByte,
            "partLastByte" => partLastByte,
            "repositoryName" => repositoryName,
            "uploadId" => uploadId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function upload_layer_part(
    layerPartBlob,
    partFirstByte,
    partLastByte,
    repositoryName,
    uploadId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecr(
        "UploadLayerPart",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "layerPartBlob" => layerPartBlob,
                    "partFirstByte" => partFirstByte,
                    "partLastByte" => partLastByte,
                    "repositoryName" => repositoryName,
                    "uploadId" => uploadId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    validate_pull_through_cache_rule(ecr_repository_prefix)
    validate_pull_through_cache_rule(ecr_repository_prefix, params::Dict{String,<:Any})

Validates an existing pull through cache rule for an upstream registry that requires
authentication. This will retrieve the contents of the Amazon Web Services Secrets Manager
secret, verify the syntax, and then validate that authentication to the upstream registry
is successful.

# Arguments
- `ecr_repository_prefix`: The repository name prefix associated with the pull through
  cache rule.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"registryId"`: The registry ID associated with the pull through cache rule. If you do
  not specify a registry, the default registry is assumed.
"""
function validate_pull_through_cache_rule(
    ecrRepositoryPrefix; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecr(
        "ValidatePullThroughCacheRule",
        Dict{String,Any}("ecrRepositoryPrefix" => ecrRepositoryPrefix);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function validate_pull_through_cache_rule(
    ecrRepositoryPrefix,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecr(
        "ValidatePullThroughCacheRule",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ecrRepositoryPrefix" => ecrRepositoryPrefix),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: app_mesh
using AWS.Compat
using AWS.UUIDs

"""
    create_gateway_route(gateway_route_name, mesh_name, spec, virtual_gateway_name)
    create_gateway_route(gateway_route_name, mesh_name, spec, virtual_gateway_name, params::Dict{String,<:Any})

Creates a gateway route. A gateway route is attached to a virtual gateway and routes
traffic to an existing virtual service. If a route matches a request, it can distribute
traffic to a target virtual service. For more information about gateway routes, see Gateway
routes.

# Arguments
- `gateway_route_name`: The name to use for the gateway route.
- `mesh_name`: The name of the service mesh to create the gateway route in.
- `spec`: The gateway route specification to apply.
- `virtual_gateway_name`: The name of the virtual gateway to associate the gateway route
  with. If the virtual gateway is in a shared mesh, then you must be the owner of the virtual
  gateway resource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. Up to 36 letters, numbers, hyphens, and underscores are allowed.
- `"meshOwner"`: The Amazon Web Services IAM account ID of the service mesh owner. If the
  account ID is not your own, then the account that you specify must share the mesh with your
  account before you can create the resource in the service mesh. For more information about
  mesh sharing, see Working with shared meshes.
- `"tags"`: Optional metadata that you can apply to the gateway route to assist with
  categorization and organization. Each tag consists of a key and an optional value, both of
  which you define. Tag keys can have a maximum character length of 128 characters, and tag
  values can have a maximum length of 256 characters.
"""
function create_gateway_route(
    gatewayRouteName,
    meshName,
    spec,
    virtualGatewayName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return app_mesh(
        "PUT",
        "/v20190125/meshes/$(meshName)/virtualGateway/$(virtualGatewayName)/gatewayRoutes",
        Dict{String,Any}(
            "gatewayRouteName" => gatewayRouteName,
            "spec" => spec,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_gateway_route(
    gatewayRouteName,
    meshName,
    spec,
    virtualGatewayName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return app_mesh(
        "PUT",
        "/v20190125/meshes/$(meshName)/virtualGateway/$(virtualGatewayName)/gatewayRoutes",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "gatewayRouteName" => gatewayRouteName,
                    "spec" => spec,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_mesh(mesh_name)
    create_mesh(mesh_name, params::Dict{String,<:Any})

Creates a service mesh.  A service mesh is a logical boundary for network traffic between
services that are represented by resources within the mesh. After you create your service
mesh, you can create virtual services, virtual nodes, virtual routers, and routes to
distribute traffic between the applications in your mesh. For more information about
service meshes, see Service meshes.

# Arguments
- `mesh_name`: The name to use for the service mesh.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. Up to 36 letters, numbers, hyphens, and underscores are allowed.
- `"spec"`: The service mesh specification to apply.
- `"tags"`: Optional metadata that you can apply to the service mesh to assist with
  categorization and organization. Each tag consists of a key and an optional value, both of
  which you define. Tag keys can have a maximum character length of 128 characters, and tag
  values can have a maximum length of 256 characters.
"""
function create_mesh(meshName; aws_config::AbstractAWSConfig=current_aws_config())
    return app_mesh(
        "PUT",
        "/v20190125/meshes",
        Dict{String,Any}("meshName" => meshName, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_mesh(
    meshName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return app_mesh(
        "PUT",
        "/v20190125/meshes",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("meshName" => meshName, "clientToken" => string(uuid4())),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_route(mesh_name, route_name, spec, virtual_router_name)
    create_route(mesh_name, route_name, spec, virtual_router_name, params::Dict{String,<:Any})

Creates a route that is associated with a virtual router.  You can route several different
protocols and define a retry policy for a route. Traffic can be routed to one or more
virtual nodes. For more information about routes, see Routes.

# Arguments
- `mesh_name`: The name of the service mesh to create the route in.
- `route_name`: The name to use for the route.
- `spec`: The route specification to apply.
- `virtual_router_name`: The name of the virtual router in which to create the route. If
  the virtual router is in a shared mesh, then you must be the owner of the virtual router
  resource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. Up to 36 letters, numbers, hyphens, and underscores are allowed.
- `"meshOwner"`: The Amazon Web Services IAM account ID of the service mesh owner. If the
  account ID is not your own, then the account that you specify must share the mesh with your
  account before you can create the resource in the service mesh. For more information about
  mesh sharing, see Working with shared meshes.
- `"tags"`: Optional metadata that you can apply to the route to assist with categorization
  and organization. Each tag consists of a key and an optional value, both of which you
  define. Tag keys can have a maximum character length of 128 characters, and tag values can
  have a maximum length of 256 characters.
"""
function create_route(
    meshName,
    routeName,
    spec,
    virtualRouterName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return app_mesh(
        "PUT",
        "/v20190125/meshes/$(meshName)/virtualRouter/$(virtualRouterName)/routes",
        Dict{String,Any}(
            "routeName" => routeName, "spec" => spec, "clientToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_route(
    meshName,
    routeName,
    spec,
    virtualRouterName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return app_mesh(
        "PUT",
        "/v20190125/meshes/$(meshName)/virtualRouter/$(virtualRouterName)/routes",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "routeName" => routeName,
                    "spec" => spec,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_virtual_gateway(mesh_name, spec, virtual_gateway_name)
    create_virtual_gateway(mesh_name, spec, virtual_gateway_name, params::Dict{String,<:Any})

Creates a virtual gateway. A virtual gateway allows resources outside your mesh to
communicate to resources that are inside your mesh. The virtual gateway represents an Envoy
proxy running in an Amazon ECS task, in a Kubernetes service, or on an Amazon EC2 instance.
Unlike a virtual node, which represents an Envoy running with an application, a virtual
gateway represents Envoy deployed by itself. For more information about virtual gateways,
see Virtual gateways.

# Arguments
- `mesh_name`: The name of the service mesh to create the virtual gateway in.
- `spec`: The virtual gateway specification to apply.
- `virtual_gateway_name`: The name to use for the virtual gateway.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. Up to 36 letters, numbers, hyphens, and underscores are allowed.
- `"meshOwner"`: The Amazon Web Services IAM account ID of the service mesh owner. If the
  account ID is not your own, then the account that you specify must share the mesh with your
  account before you can create the resource in the service mesh. For more information about
  mesh sharing, see Working with shared meshes.
- `"tags"`: Optional metadata that you can apply to the virtual gateway to assist with
  categorization and organization. Each tag consists of a key and an optional value, both of
  which you define. Tag keys can have a maximum character length of 128 characters, and tag
  values can have a maximum length of 256 characters.
"""
function create_virtual_gateway(
    meshName, spec, virtualGatewayName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return app_mesh(
        "PUT",
        "/v20190125/meshes/$(meshName)/virtualGateways",
        Dict{String,Any}(
            "spec" => spec,
            "virtualGatewayName" => virtualGatewayName,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_virtual_gateway(
    meshName,
    spec,
    virtualGatewayName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return app_mesh(
        "PUT",
        "/v20190125/meshes/$(meshName)/virtualGateways",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "spec" => spec,
                    "virtualGatewayName" => virtualGatewayName,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_virtual_node(mesh_name, spec, virtual_node_name)
    create_virtual_node(mesh_name, spec, virtual_node_name, params::Dict{String,<:Any})

Creates a virtual node within a service mesh.  A virtual node acts as a logical pointer to
a particular task group, such as an Amazon ECS service or a Kubernetes deployment. When you
create a virtual node, you can specify the service discovery information for your task
group, and whether the proxy running in a task group will communicate with other proxies
using Transport Layer Security (TLS). You define a listener for any inbound traffic that
your virtual node expects. Any virtual service that your virtual node expects to
communicate to is specified as a backend. The response metadata for your new virtual node
contains the arn that is associated with the virtual node. Set this value to the full ARN;
for example, arn:aws:appmesh:us-west-2:123456789012:myMesh/default/virtualNode/myApp) as
the APPMESH_RESOURCE_ARN environment variable for your task group's Envoy proxy container
in your task definition or pod spec. This is then mapped to the node.id and node.cluster
Envoy parameters.  By default, App Mesh uses the name of the resource you specified in
APPMESH_RESOURCE_ARN when Envoy is referring to itself in metrics and traces. You can
override this behavior by setting the APPMESH_RESOURCE_CLUSTER environment variable with
your own name.  For more information about virtual nodes, see Virtual nodes. You must be
using 1.15.0 or later of the Envoy image when setting these variables. For more information
aboutApp Mesh Envoy variables, see Envoy image in the App Mesh User Guide.

# Arguments
- `mesh_name`: The name of the service mesh to create the virtual node in.
- `spec`: The virtual node specification to apply.
- `virtual_node_name`: The name to use for the virtual node.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. Up to 36 letters, numbers, hyphens, and underscores are allowed.
- `"meshOwner"`: The Amazon Web Services IAM account ID of the service mesh owner. If the
  account ID is not your own, then the account that you specify must share the mesh with your
  account before you can create the resource in the service mesh. For more information about
  mesh sharing, see Working with shared meshes.
- `"tags"`: Optional metadata that you can apply to the virtual node to assist with
  categorization and organization. Each tag consists of a key and an optional value, both of
  which you define. Tag keys can have a maximum character length of 128 characters, and tag
  values can have a maximum length of 256 characters.
"""
function create_virtual_node(
    meshName, spec, virtualNodeName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return app_mesh(
        "PUT",
        "/v20190125/meshes/$(meshName)/virtualNodes",
        Dict{String,Any}(
            "spec" => spec,
            "virtualNodeName" => virtualNodeName,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_virtual_node(
    meshName,
    spec,
    virtualNodeName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return app_mesh(
        "PUT",
        "/v20190125/meshes/$(meshName)/virtualNodes",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "spec" => spec,
                    "virtualNodeName" => virtualNodeName,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_virtual_router(mesh_name, spec, virtual_router_name)
    create_virtual_router(mesh_name, spec, virtual_router_name, params::Dict{String,<:Any})

Creates a virtual router within a service mesh. Specify a listener for any inbound traffic
that your virtual router receives. Create a virtual router for each protocol and port that
you need to route. Virtual routers handle traffic for one or more virtual services within
your mesh. After you create your virtual router, create and associate routes for your
virtual router that direct incoming requests to different virtual nodes. For more
information about virtual routers, see Virtual routers.

# Arguments
- `mesh_name`: The name of the service mesh to create the virtual router in.
- `spec`: The virtual router specification to apply.
- `virtual_router_name`: The name to use for the virtual router.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. Up to 36 letters, numbers, hyphens, and underscores are allowed.
- `"meshOwner"`: The Amazon Web Services IAM account ID of the service mesh owner. If the
  account ID is not your own, then the account that you specify must share the mesh with your
  account before you can create the resource in the service mesh. For more information about
  mesh sharing, see Working with shared meshes.
- `"tags"`: Optional metadata that you can apply to the virtual router to assist with
  categorization and organization. Each tag consists of a key and an optional value, both of
  which you define. Tag keys can have a maximum character length of 128 characters, and tag
  values can have a maximum length of 256 characters.
"""
function create_virtual_router(
    meshName, spec, virtualRouterName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return app_mesh(
        "PUT",
        "/v20190125/meshes/$(meshName)/virtualRouters",
        Dict{String,Any}(
            "spec" => spec,
            "virtualRouterName" => virtualRouterName,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_virtual_router(
    meshName,
    spec,
    virtualRouterName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return app_mesh(
        "PUT",
        "/v20190125/meshes/$(meshName)/virtualRouters",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "spec" => spec,
                    "virtualRouterName" => virtualRouterName,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_virtual_service(mesh_name, spec, virtual_service_name)
    create_virtual_service(mesh_name, spec, virtual_service_name, params::Dict{String,<:Any})

Creates a virtual service within a service mesh. A virtual service is an abstraction of a
real service that is provided by a virtual node directly or indirectly by means of a
virtual router. Dependent services call your virtual service by its virtualServiceName, and
those requests are routed to the virtual node or virtual router that is specified as the
provider for the virtual service. For more information about virtual services, see Virtual
services.

# Arguments
- `mesh_name`: The name of the service mesh to create the virtual service in.
- `spec`: The virtual service specification to apply.
- `virtual_service_name`: The name to use for the virtual service.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. Up to 36 letters, numbers, hyphens, and underscores are allowed.
- `"meshOwner"`: The Amazon Web Services IAM account ID of the service mesh owner. If the
  account ID is not your own, then the account that you specify must share the mesh with your
  account before you can create the resource in the service mesh. For more information about
  mesh sharing, see Working with shared meshes.
- `"tags"`: Optional metadata that you can apply to the virtual service to assist with
  categorization and organization. Each tag consists of a key and an optional value, both of
  which you define. Tag keys can have a maximum character length of 128 characters, and tag
  values can have a maximum length of 256 characters.
"""
function create_virtual_service(
    meshName, spec, virtualServiceName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return app_mesh(
        "PUT",
        "/v20190125/meshes/$(meshName)/virtualServices",
        Dict{String,Any}(
            "spec" => spec,
            "virtualServiceName" => virtualServiceName,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_virtual_service(
    meshName,
    spec,
    virtualServiceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return app_mesh(
        "PUT",
        "/v20190125/meshes/$(meshName)/virtualServices",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "spec" => spec,
                    "virtualServiceName" => virtualServiceName,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_gateway_route(gateway_route_name, mesh_name, virtual_gateway_name)
    delete_gateway_route(gateway_route_name, mesh_name, virtual_gateway_name, params::Dict{String,<:Any})

Deletes an existing gateway route.

# Arguments
- `gateway_route_name`: The name of the gateway route to delete.
- `mesh_name`: The name of the service mesh to delete the gateway route from.
- `virtual_gateway_name`: The name of the virtual gateway to delete the route from.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"meshOwner"`: The Amazon Web Services IAM account ID of the service mesh owner. If the
  account ID is not your own, then it's the ID of the account that shared the mesh with your
  account. For more information about mesh sharing, see Working with shared meshes.
"""
function delete_gateway_route(
    gatewayRouteName,
    meshName,
    virtualGatewayName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return app_mesh(
        "DELETE",
        "/v20190125/meshes/$(meshName)/virtualGateway/$(virtualGatewayName)/gatewayRoutes/$(gatewayRouteName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_gateway_route(
    gatewayRouteName,
    meshName,
    virtualGatewayName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return app_mesh(
        "DELETE",
        "/v20190125/meshes/$(meshName)/virtualGateway/$(virtualGatewayName)/gatewayRoutes/$(gatewayRouteName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_mesh(mesh_name)
    delete_mesh(mesh_name, params::Dict{String,<:Any})

Deletes an existing service mesh. You must delete all resources (virtual services, routes,
virtual routers, and virtual nodes) in the service mesh before you can delete the mesh
itself.

# Arguments
- `mesh_name`: The name of the service mesh to delete.

"""
function delete_mesh(meshName; aws_config::AbstractAWSConfig=current_aws_config())
    return app_mesh(
        "DELETE",
        "/v20190125/meshes/$(meshName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_mesh(
    meshName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return app_mesh(
        "DELETE",
        "/v20190125/meshes/$(meshName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_route(mesh_name, route_name, virtual_router_name)
    delete_route(mesh_name, route_name, virtual_router_name, params::Dict{String,<:Any})

Deletes an existing route.

# Arguments
- `mesh_name`: The name of the service mesh to delete the route in.
- `route_name`: The name of the route to delete.
- `virtual_router_name`: The name of the virtual router to delete the route in.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"meshOwner"`: The Amazon Web Services IAM account ID of the service mesh owner. If the
  account ID is not your own, then it's the ID of the account that shared the mesh with your
  account. For more information about mesh sharing, see Working with shared meshes.
"""
function delete_route(
    meshName,
    routeName,
    virtualRouterName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return app_mesh(
        "DELETE",
        "/v20190125/meshes/$(meshName)/virtualRouter/$(virtualRouterName)/routes/$(routeName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_route(
    meshName,
    routeName,
    virtualRouterName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return app_mesh(
        "DELETE",
        "/v20190125/meshes/$(meshName)/virtualRouter/$(virtualRouterName)/routes/$(routeName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_virtual_gateway(mesh_name, virtual_gateway_name)
    delete_virtual_gateway(mesh_name, virtual_gateway_name, params::Dict{String,<:Any})

Deletes an existing virtual gateway. You cannot delete a virtual gateway if any gateway
routes are associated to it.

# Arguments
- `mesh_name`: The name of the service mesh to delete the virtual gateway from.
- `virtual_gateway_name`: The name of the virtual gateway to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"meshOwner"`: The Amazon Web Services IAM account ID of the service mesh owner. If the
  account ID is not your own, then it's the ID of the account that shared the mesh with your
  account. For more information about mesh sharing, see Working with shared meshes.
"""
function delete_virtual_gateway(
    meshName, virtualGatewayName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return app_mesh(
        "DELETE",
        "/v20190125/meshes/$(meshName)/virtualGateways/$(virtualGatewayName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_virtual_gateway(
    meshName,
    virtualGatewayName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return app_mesh(
        "DELETE",
        "/v20190125/meshes/$(meshName)/virtualGateways/$(virtualGatewayName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_virtual_node(mesh_name, virtual_node_name)
    delete_virtual_node(mesh_name, virtual_node_name, params::Dict{String,<:Any})

Deletes an existing virtual node. You must delete any virtual services that list a virtual
node as a service provider before you can delete the virtual node itself.

# Arguments
- `mesh_name`: The name of the service mesh to delete the virtual node in.
- `virtual_node_name`: The name of the virtual node to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"meshOwner"`: The Amazon Web Services IAM account ID of the service mesh owner. If the
  account ID is not your own, then it's the ID of the account that shared the mesh with your
  account. For more information about mesh sharing, see Working with shared meshes.
"""
function delete_virtual_node(
    meshName, virtualNodeName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return app_mesh(
        "DELETE",
        "/v20190125/meshes/$(meshName)/virtualNodes/$(virtualNodeName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_virtual_node(
    meshName,
    virtualNodeName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return app_mesh(
        "DELETE",
        "/v20190125/meshes/$(meshName)/virtualNodes/$(virtualNodeName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_virtual_router(mesh_name, virtual_router_name)
    delete_virtual_router(mesh_name, virtual_router_name, params::Dict{String,<:Any})

Deletes an existing virtual router. You must delete any routes associated with the virtual
router before you can delete the router itself.

# Arguments
- `mesh_name`: The name of the service mesh to delete the virtual router in.
- `virtual_router_name`: The name of the virtual router to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"meshOwner"`: The Amazon Web Services IAM account ID of the service mesh owner. If the
  account ID is not your own, then it's the ID of the account that shared the mesh with your
  account. For more information about mesh sharing, see Working with shared meshes.
"""
function delete_virtual_router(
    meshName, virtualRouterName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return app_mesh(
        "DELETE",
        "/v20190125/meshes/$(meshName)/virtualRouters/$(virtualRouterName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_virtual_router(
    meshName,
    virtualRouterName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return app_mesh(
        "DELETE",
        "/v20190125/meshes/$(meshName)/virtualRouters/$(virtualRouterName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_virtual_service(mesh_name, virtual_service_name)
    delete_virtual_service(mesh_name, virtual_service_name, params::Dict{String,<:Any})

Deletes an existing virtual service.

# Arguments
- `mesh_name`: The name of the service mesh to delete the virtual service in.
- `virtual_service_name`: The name of the virtual service to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"meshOwner"`: The Amazon Web Services IAM account ID of the service mesh owner. If the
  account ID is not your own, then it's the ID of the account that shared the mesh with your
  account. For more information about mesh sharing, see Working with shared meshes.
"""
function delete_virtual_service(
    meshName, virtualServiceName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return app_mesh(
        "DELETE",
        "/v20190125/meshes/$(meshName)/virtualServices/$(virtualServiceName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_virtual_service(
    meshName,
    virtualServiceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return app_mesh(
        "DELETE",
        "/v20190125/meshes/$(meshName)/virtualServices/$(virtualServiceName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_gateway_route(gateway_route_name, mesh_name, virtual_gateway_name)
    describe_gateway_route(gateway_route_name, mesh_name, virtual_gateway_name, params::Dict{String,<:Any})

Describes an existing gateway route.

# Arguments
- `gateway_route_name`: The name of the gateway route to describe.
- `mesh_name`: The name of the service mesh that the gateway route resides in.
- `virtual_gateway_name`: The name of the virtual gateway that the gateway route is
  associated with.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"meshOwner"`: The Amazon Web Services IAM account ID of the service mesh owner. If the
  account ID is not your own, then it's the ID of the account that shared the mesh with your
  account. For more information about mesh sharing, see Working with shared meshes.
"""
function describe_gateway_route(
    gatewayRouteName,
    meshName,
    virtualGatewayName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return app_mesh(
        "GET",
        "/v20190125/meshes/$(meshName)/virtualGateway/$(virtualGatewayName)/gatewayRoutes/$(gatewayRouteName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_gateway_route(
    gatewayRouteName,
    meshName,
    virtualGatewayName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return app_mesh(
        "GET",
        "/v20190125/meshes/$(meshName)/virtualGateway/$(virtualGatewayName)/gatewayRoutes/$(gatewayRouteName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_mesh(mesh_name)
    describe_mesh(mesh_name, params::Dict{String,<:Any})

Describes an existing service mesh.

# Arguments
- `mesh_name`: The name of the service mesh to describe.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"meshOwner"`: The Amazon Web Services IAM account ID of the service mesh owner. If the
  account ID is not your own, then it's the ID of the account that shared the mesh with your
  account. For more information about mesh sharing, see Working with shared meshes.
"""
function describe_mesh(meshName; aws_config::AbstractAWSConfig=current_aws_config())
    return app_mesh(
        "GET",
        "/v20190125/meshes/$(meshName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_mesh(
    meshName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return app_mesh(
        "GET",
        "/v20190125/meshes/$(meshName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_route(mesh_name, route_name, virtual_router_name)
    describe_route(mesh_name, route_name, virtual_router_name, params::Dict{String,<:Any})

Describes an existing route.

# Arguments
- `mesh_name`: The name of the service mesh that the route resides in.
- `route_name`: The name of the route to describe.
- `virtual_router_name`: The name of the virtual router that the route is associated with.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"meshOwner"`: The Amazon Web Services IAM account ID of the service mesh owner. If the
  account ID is not your own, then it's the ID of the account that shared the mesh with your
  account. For more information about mesh sharing, see Working with shared meshes.
"""
function describe_route(
    meshName,
    routeName,
    virtualRouterName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return app_mesh(
        "GET",
        "/v20190125/meshes/$(meshName)/virtualRouter/$(virtualRouterName)/routes/$(routeName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_route(
    meshName,
    routeName,
    virtualRouterName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return app_mesh(
        "GET",
        "/v20190125/meshes/$(meshName)/virtualRouter/$(virtualRouterName)/routes/$(routeName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_virtual_gateway(mesh_name, virtual_gateway_name)
    describe_virtual_gateway(mesh_name, virtual_gateway_name, params::Dict{String,<:Any})

Describes an existing virtual gateway.

# Arguments
- `mesh_name`: The name of the service mesh that the gateway route resides in.
- `virtual_gateway_name`: The name of the virtual gateway to describe.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"meshOwner"`: The Amazon Web Services IAM account ID of the service mesh owner. If the
  account ID is not your own, then it's the ID of the account that shared the mesh with your
  account. For more information about mesh sharing, see Working with shared meshes.
"""
function describe_virtual_gateway(
    meshName, virtualGatewayName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return app_mesh(
        "GET",
        "/v20190125/meshes/$(meshName)/virtualGateways/$(virtualGatewayName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_virtual_gateway(
    meshName,
    virtualGatewayName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return app_mesh(
        "GET",
        "/v20190125/meshes/$(meshName)/virtualGateways/$(virtualGatewayName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_virtual_node(mesh_name, virtual_node_name)
    describe_virtual_node(mesh_name, virtual_node_name, params::Dict{String,<:Any})

Describes an existing virtual node.

# Arguments
- `mesh_name`: The name of the service mesh that the virtual node resides in.
- `virtual_node_name`: The name of the virtual node to describe.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"meshOwner"`: The Amazon Web Services IAM account ID of the service mesh owner. If the
  account ID is not your own, then it's the ID of the account that shared the mesh with your
  account. For more information about mesh sharing, see Working with shared meshes.
"""
function describe_virtual_node(
    meshName, virtualNodeName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return app_mesh(
        "GET",
        "/v20190125/meshes/$(meshName)/virtualNodes/$(virtualNodeName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_virtual_node(
    meshName,
    virtualNodeName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return app_mesh(
        "GET",
        "/v20190125/meshes/$(meshName)/virtualNodes/$(virtualNodeName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_virtual_router(mesh_name, virtual_router_name)
    describe_virtual_router(mesh_name, virtual_router_name, params::Dict{String,<:Any})

Describes an existing virtual router.

# Arguments
- `mesh_name`: The name of the service mesh that the virtual router resides in.
- `virtual_router_name`: The name of the virtual router to describe.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"meshOwner"`: The Amazon Web Services IAM account ID of the service mesh owner. If the
  account ID is not your own, then it's the ID of the account that shared the mesh with your
  account. For more information about mesh sharing, see Working with shared meshes.
"""
function describe_virtual_router(
    meshName, virtualRouterName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return app_mesh(
        "GET",
        "/v20190125/meshes/$(meshName)/virtualRouters/$(virtualRouterName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_virtual_router(
    meshName,
    virtualRouterName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return app_mesh(
        "GET",
        "/v20190125/meshes/$(meshName)/virtualRouters/$(virtualRouterName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_virtual_service(mesh_name, virtual_service_name)
    describe_virtual_service(mesh_name, virtual_service_name, params::Dict{String,<:Any})

Describes an existing virtual service.

# Arguments
- `mesh_name`: The name of the service mesh that the virtual service resides in.
- `virtual_service_name`: The name of the virtual service to describe.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"meshOwner"`: The Amazon Web Services IAM account ID of the service mesh owner. If the
  account ID is not your own, then it's the ID of the account that shared the mesh with your
  account. For more information about mesh sharing, see Working with shared meshes.
"""
function describe_virtual_service(
    meshName, virtualServiceName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return app_mesh(
        "GET",
        "/v20190125/meshes/$(meshName)/virtualServices/$(virtualServiceName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_virtual_service(
    meshName,
    virtualServiceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return app_mesh(
        "GET",
        "/v20190125/meshes/$(meshName)/virtualServices/$(virtualServiceName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_gateway_routes(mesh_name, virtual_gateway_name)
    list_gateway_routes(mesh_name, virtual_gateway_name, params::Dict{String,<:Any})

Returns a list of existing gateway routes that are associated to a virtual gateway.

# Arguments
- `mesh_name`: The name of the service mesh to list gateway routes in.
- `virtual_gateway_name`: The name of the virtual gateway to list gateway routes in.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"limit"`: The maximum number of results returned by ListGatewayRoutes in paginated
  output. When you use this parameter, ListGatewayRoutes returns only limit results in a
  single page along with a nextToken response element. You can see the remaining results of
  the initial request by sending another ListGatewayRoutes request with the returned
  nextToken value. This value can be between 1 and 100. If you don't use this parameter,
  ListGatewayRoutes returns up to 100 results and a nextToken value if applicable.
- `"meshOwner"`: The Amazon Web Services IAM account ID of the service mesh owner. If the
  account ID is not your own, then it's the ID of the account that shared the mesh with your
  account. For more information about mesh sharing, see Working with shared meshes.
- `"nextToken"`: The nextToken value returned from a previous paginated ListGatewayRoutes
  request where limit was used and the results exceeded the value of that parameter.
  Pagination continues from the end of the previous results that returned the nextToken value.
"""
function list_gateway_routes(
    meshName, virtualGatewayName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return app_mesh(
        "GET",
        "/v20190125/meshes/$(meshName)/virtualGateway/$(virtualGatewayName)/gatewayRoutes";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_gateway_routes(
    meshName,
    virtualGatewayName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return app_mesh(
        "GET",
        "/v20190125/meshes/$(meshName)/virtualGateway/$(virtualGatewayName)/gatewayRoutes",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_meshes()
    list_meshes(params::Dict{String,<:Any})

Returns a list of existing service meshes.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"limit"`: The maximum number of results returned by ListMeshes in paginated output. When
  you use this parameter, ListMeshes returns only limit results in a single page along with a
  nextToken response element. You can see the remaining results of the initial request by
  sending another ListMeshes request with the returned nextToken value. This value can be
  between 1 and 100. If you don't use this parameter, ListMeshes returns up to 100 results
  and a nextToken value if applicable.
- `"nextToken"`: The nextToken value returned from a previous paginated ListMeshes request
  where limit was used and the results exceeded the value of that parameter. Pagination
  continues from the end of the previous results that returned the nextToken value.  This
  token should be treated as an opaque identifier that is used only to retrieve the next
  items in a list and not for other programmatic purposes.
"""
function list_meshes(; aws_config::AbstractAWSConfig=current_aws_config())
    return app_mesh(
        "GET", "/v20190125/meshes"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_meshes(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return app_mesh(
        "GET",
        "/v20190125/meshes",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_routes(mesh_name, virtual_router_name)
    list_routes(mesh_name, virtual_router_name, params::Dict{String,<:Any})

Returns a list of existing routes in a service mesh.

# Arguments
- `mesh_name`: The name of the service mesh to list routes in.
- `virtual_router_name`: The name of the virtual router to list routes in.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"limit"`: The maximum number of results returned by ListRoutes in paginated output. When
  you use this parameter, ListRoutes returns only limit results in a single page along with a
  nextToken response element. You can see the remaining results of the initial request by
  sending another ListRoutes request with the returned nextToken value. This value can be
  between 1 and 100. If you don't use this parameter, ListRoutes returns up to 100 results
  and a nextToken value if applicable.
- `"meshOwner"`: The Amazon Web Services IAM account ID of the service mesh owner. If the
  account ID is not your own, then it's the ID of the account that shared the mesh with your
  account. For more information about mesh sharing, see Working with shared meshes.
- `"nextToken"`: The nextToken value returned from a previous paginated ListRoutes request
  where limit was used and the results exceeded the value of that parameter. Pagination
  continues from the end of the previous results that returned the nextToken value.
"""
function list_routes(
    meshName, virtualRouterName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return app_mesh(
        "GET",
        "/v20190125/meshes/$(meshName)/virtualRouter/$(virtualRouterName)/routes";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_routes(
    meshName,
    virtualRouterName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return app_mesh(
        "GET",
        "/v20190125/meshes/$(meshName)/virtualRouter/$(virtualRouterName)/routes",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

List the tags for an App Mesh resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) that identifies the resource to list the
  tags for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"limit"`: The maximum number of tag results returned by ListTagsForResource in paginated
  output. When this parameter is used, ListTagsForResource returns only limit results in a
  single page along with a nextToken response element. You can see the remaining results of
  the initial request by sending another ListTagsForResource request with the returned
  nextToken value. This value can be between 1 and 100. If you don't use this parameter,
  ListTagsForResource returns up to 100 results and a nextToken value if applicable.
- `"nextToken"`: The nextToken value returned from a previous paginated ListTagsForResource
  request where limit was used and the results exceeded the value of that parameter.
  Pagination continues from the end of the previous results that returned the nextToken value.
"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return app_mesh(
        "GET",
        "/v20190125/tags",
        Dict{String,Any}("resourceArn" => resourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return app_mesh(
        "GET",
        "/v20190125/tags",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceArn" => resourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_virtual_gateways(mesh_name)
    list_virtual_gateways(mesh_name, params::Dict{String,<:Any})

Returns a list of existing virtual gateways in a service mesh.

# Arguments
- `mesh_name`: The name of the service mesh to list virtual gateways in.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"limit"`: The maximum number of results returned by ListVirtualGateways in paginated
  output. When you use this parameter, ListVirtualGateways returns only limit results in a
  single page along with a nextToken response element. You can see the remaining results of
  the initial request by sending another ListVirtualGateways request with the returned
  nextToken value. This value can be between 1 and 100. If you don't use this parameter,
  ListVirtualGateways returns up to 100 results and a nextToken value if applicable.
- `"meshOwner"`: The Amazon Web Services IAM account ID of the service mesh owner. If the
  account ID is not your own, then it's the ID of the account that shared the mesh with your
  account. For more information about mesh sharing, see Working with shared meshes.
- `"nextToken"`: The nextToken value returned from a previous paginated ListVirtualGateways
  request where limit was used and the results exceeded the value of that parameter.
  Pagination continues from the end of the previous results that returned the nextToken value.
"""
function list_virtual_gateways(meshName; aws_config::AbstractAWSConfig=current_aws_config())
    return app_mesh(
        "GET",
        "/v20190125/meshes/$(meshName)/virtualGateways";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_virtual_gateways(
    meshName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return app_mesh(
        "GET",
        "/v20190125/meshes/$(meshName)/virtualGateways",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_virtual_nodes(mesh_name)
    list_virtual_nodes(mesh_name, params::Dict{String,<:Any})

Returns a list of existing virtual nodes.

# Arguments
- `mesh_name`: The name of the service mesh to list virtual nodes in.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"limit"`: The maximum number of results returned by ListVirtualNodes in paginated
  output. When you use this parameter, ListVirtualNodes returns only limit results in a
  single page along with a nextToken response element. You can see the remaining results of
  the initial request by sending another ListVirtualNodes request with the returned nextToken
  value. This value can be between 1 and 100. If you don't use this parameter,
  ListVirtualNodes returns up to 100 results and a nextToken value if applicable.
- `"meshOwner"`: The Amazon Web Services IAM account ID of the service mesh owner. If the
  account ID is not your own, then it's the ID of the account that shared the mesh with your
  account. For more information about mesh sharing, see Working with shared meshes.
- `"nextToken"`: The nextToken value returned from a previous paginated ListVirtualNodes
  request where limit was used and the results exceeded the value of that parameter.
  Pagination continues from the end of the previous results that returned the nextToken value.
"""
function list_virtual_nodes(meshName; aws_config::AbstractAWSConfig=current_aws_config())
    return app_mesh(
        "GET",
        "/v20190125/meshes/$(meshName)/virtualNodes";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_virtual_nodes(
    meshName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return app_mesh(
        "GET",
        "/v20190125/meshes/$(meshName)/virtualNodes",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_virtual_routers(mesh_name)
    list_virtual_routers(mesh_name, params::Dict{String,<:Any})

Returns a list of existing virtual routers in a service mesh.

# Arguments
- `mesh_name`: The name of the service mesh to list virtual routers in.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"limit"`: The maximum number of results returned by ListVirtualRouters in paginated
  output. When you use this parameter, ListVirtualRouters returns only limit results in a
  single page along with a nextToken response element. You can see the remaining results of
  the initial request by sending another ListVirtualRouters request with the returned
  nextToken value. This value can be between 1 and 100. If you don't use this parameter,
  ListVirtualRouters returns up to 100 results and a nextToken value if applicable.
- `"meshOwner"`: The Amazon Web Services IAM account ID of the service mesh owner. If the
  account ID is not your own, then it's the ID of the account that shared the mesh with your
  account. For more information about mesh sharing, see Working with shared meshes.
- `"nextToken"`: The nextToken value returned from a previous paginated ListVirtualRouters
  request where limit was used and the results exceeded the value of that parameter.
  Pagination continues from the end of the previous results that returned the nextToken value.
"""
function list_virtual_routers(meshName; aws_config::AbstractAWSConfig=current_aws_config())
    return app_mesh(
        "GET",
        "/v20190125/meshes/$(meshName)/virtualRouters";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_virtual_routers(
    meshName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return app_mesh(
        "GET",
        "/v20190125/meshes/$(meshName)/virtualRouters",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_virtual_services(mesh_name)
    list_virtual_services(mesh_name, params::Dict{String,<:Any})

Returns a list of existing virtual services in a service mesh.

# Arguments
- `mesh_name`: The name of the service mesh to list virtual services in.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"limit"`: The maximum number of results returned by ListVirtualServices in paginated
  output. When you use this parameter, ListVirtualServices returns only limit results in a
  single page along with a nextToken response element. You can see the remaining results of
  the initial request by sending another ListVirtualServices request with the returned
  nextToken value. This value can be between 1 and 100. If you don't use this parameter,
  ListVirtualServices returns up to 100 results and a nextToken value if applicable.
- `"meshOwner"`: The Amazon Web Services IAM account ID of the service mesh owner. If the
  account ID is not your own, then it's the ID of the account that shared the mesh with your
  account. For more information about mesh sharing, see Working with shared meshes.
- `"nextToken"`: The nextToken value returned from a previous paginated ListVirtualServices
  request where limit was used and the results exceeded the value of that parameter.
  Pagination continues from the end of the previous results that returned the nextToken value.
"""
function list_virtual_services(meshName; aws_config::AbstractAWSConfig=current_aws_config())
    return app_mesh(
        "GET",
        "/v20190125/meshes/$(meshName)/virtualServices";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_virtual_services(
    meshName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return app_mesh(
        "GET",
        "/v20190125/meshes/$(meshName)/virtualServices",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Associates the specified tags to a resource with the specified resourceArn. If existing
tags on a resource aren't specified in the request parameters, they aren't changed. When a
resource is deleted, the tags associated with that resource are also deleted.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource to add tags to.
- `tags`: The tags to add to the resource. A tag is an array of key-value pairs. Tag keys
  can have a maximum character length of 128 characters, and tag values can have a maximum
  length of 256 characters.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return app_mesh(
        "PUT",
        "/v20190125/tag",
        Dict{String,Any}("resourceArn" => resourceArn, "tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return app_mesh(
        "PUT",
        "/v20190125/tag",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceArn" => resourceArn, "tags" => tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Deletes specified tags from a resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource to delete tags from.
- `tag_keys`: The keys of the tags to be removed.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return app_mesh(
        "PUT",
        "/v20190125/untag",
        Dict{String,Any}("resourceArn" => resourceArn, "tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return app_mesh(
        "PUT",
        "/v20190125/untag",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceArn" => resourceArn, "tagKeys" => tagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_gateway_route(gateway_route_name, mesh_name, spec, virtual_gateway_name)
    update_gateway_route(gateway_route_name, mesh_name, spec, virtual_gateway_name, params::Dict{String,<:Any})

Updates an existing gateway route that is associated to a specified virtual gateway in a
service mesh.

# Arguments
- `gateway_route_name`: The name of the gateway route to update.
- `mesh_name`: The name of the service mesh that the gateway route resides in.
- `spec`: The new gateway route specification to apply. This overwrites the existing data.
- `virtual_gateway_name`: The name of the virtual gateway that the gateway route is
  associated with.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. Up to 36 letters, numbers, hyphens, and underscores are allowed.
- `"meshOwner"`: The Amazon Web Services IAM account ID of the service mesh owner. If the
  account ID is not your own, then it's the ID of the account that shared the mesh with your
  account. For more information about mesh sharing, see Working with shared meshes.
"""
function update_gateway_route(
    gatewayRouteName,
    meshName,
    spec,
    virtualGatewayName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return app_mesh(
        "PUT",
        "/v20190125/meshes/$(meshName)/virtualGateway/$(virtualGatewayName)/gatewayRoutes/$(gatewayRouteName)",
        Dict{String,Any}("spec" => spec, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_gateway_route(
    gatewayRouteName,
    meshName,
    spec,
    virtualGatewayName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return app_mesh(
        "PUT",
        "/v20190125/meshes/$(meshName)/virtualGateway/$(virtualGatewayName)/gatewayRoutes/$(gatewayRouteName)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("spec" => spec, "clientToken" => string(uuid4())),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_mesh(mesh_name)
    update_mesh(mesh_name, params::Dict{String,<:Any})

Updates an existing service mesh.

# Arguments
- `mesh_name`: The name of the service mesh to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. Up to 36 letters, numbers, hyphens, and underscores are allowed.
- `"spec"`: The service mesh specification to apply.
"""
function update_mesh(meshName; aws_config::AbstractAWSConfig=current_aws_config())
    return app_mesh(
        "PUT",
        "/v20190125/meshes/$(meshName)",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_mesh(
    meshName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return app_mesh(
        "PUT",
        "/v20190125/meshes/$(meshName)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_route(mesh_name, route_name, spec, virtual_router_name)
    update_route(mesh_name, route_name, spec, virtual_router_name, params::Dict{String,<:Any})

Updates an existing route for a specified service mesh and virtual router.

# Arguments
- `mesh_name`: The name of the service mesh that the route resides in.
- `route_name`: The name of the route to update.
- `spec`: The new route specification to apply. This overwrites the existing data.
- `virtual_router_name`: The name of the virtual router that the route is associated with.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. Up to 36 letters, numbers, hyphens, and underscores are allowed.
- `"meshOwner"`: The Amazon Web Services IAM account ID of the service mesh owner. If the
  account ID is not your own, then it's the ID of the account that shared the mesh with your
  account. For more information about mesh sharing, see Working with shared meshes.
"""
function update_route(
    meshName,
    routeName,
    spec,
    virtualRouterName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return app_mesh(
        "PUT",
        "/v20190125/meshes/$(meshName)/virtualRouter/$(virtualRouterName)/routes/$(routeName)",
        Dict{String,Any}("spec" => spec, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_route(
    meshName,
    routeName,
    spec,
    virtualRouterName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return app_mesh(
        "PUT",
        "/v20190125/meshes/$(meshName)/virtualRouter/$(virtualRouterName)/routes/$(routeName)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("spec" => spec, "clientToken" => string(uuid4())),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_virtual_gateway(mesh_name, spec, virtual_gateway_name)
    update_virtual_gateway(mesh_name, spec, virtual_gateway_name, params::Dict{String,<:Any})

Updates an existing virtual gateway in a specified service mesh.

# Arguments
- `mesh_name`: The name of the service mesh that the virtual gateway resides in.
- `spec`: The new virtual gateway specification to apply. This overwrites the existing data.
- `virtual_gateway_name`: The name of the virtual gateway to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. Up to 36 letters, numbers, hyphens, and underscores are allowed.
- `"meshOwner"`: The Amazon Web Services IAM account ID of the service mesh owner. If the
  account ID is not your own, then it's the ID of the account that shared the mesh with your
  account. For more information about mesh sharing, see Working with shared meshes.
"""
function update_virtual_gateway(
    meshName, spec, virtualGatewayName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return app_mesh(
        "PUT",
        "/v20190125/meshes/$(meshName)/virtualGateways/$(virtualGatewayName)",
        Dict{String,Any}("spec" => spec, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_virtual_gateway(
    meshName,
    spec,
    virtualGatewayName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return app_mesh(
        "PUT",
        "/v20190125/meshes/$(meshName)/virtualGateways/$(virtualGatewayName)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("spec" => spec, "clientToken" => string(uuid4())),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_virtual_node(mesh_name, spec, virtual_node_name)
    update_virtual_node(mesh_name, spec, virtual_node_name, params::Dict{String,<:Any})

Updates an existing virtual node in a specified service mesh.

# Arguments
- `mesh_name`: The name of the service mesh that the virtual node resides in.
- `spec`: The new virtual node specification to apply. This overwrites the existing data.
- `virtual_node_name`: The name of the virtual node to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. Up to 36 letters, numbers, hyphens, and underscores are allowed.
- `"meshOwner"`: The Amazon Web Services IAM account ID of the service mesh owner. If the
  account ID is not your own, then it's the ID of the account that shared the mesh with your
  account. For more information about mesh sharing, see Working with shared meshes.
"""
function update_virtual_node(
    meshName, spec, virtualNodeName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return app_mesh(
        "PUT",
        "/v20190125/meshes/$(meshName)/virtualNodes/$(virtualNodeName)",
        Dict{String,Any}("spec" => spec, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_virtual_node(
    meshName,
    spec,
    virtualNodeName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return app_mesh(
        "PUT",
        "/v20190125/meshes/$(meshName)/virtualNodes/$(virtualNodeName)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("spec" => spec, "clientToken" => string(uuid4())),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_virtual_router(mesh_name, spec, virtual_router_name)
    update_virtual_router(mesh_name, spec, virtual_router_name, params::Dict{String,<:Any})

Updates an existing virtual router in a specified service mesh.

# Arguments
- `mesh_name`: The name of the service mesh that the virtual router resides in.
- `spec`: The new virtual router specification to apply. This overwrites the existing data.
- `virtual_router_name`: The name of the virtual router to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. Up to 36 letters, numbers, hyphens, and underscores are allowed.
- `"meshOwner"`: The Amazon Web Services IAM account ID of the service mesh owner. If the
  account ID is not your own, then it's the ID of the account that shared the mesh with your
  account. For more information about mesh sharing, see Working with shared meshes.
"""
function update_virtual_router(
    meshName, spec, virtualRouterName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return app_mesh(
        "PUT",
        "/v20190125/meshes/$(meshName)/virtualRouters/$(virtualRouterName)",
        Dict{String,Any}("spec" => spec, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_virtual_router(
    meshName,
    spec,
    virtualRouterName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return app_mesh(
        "PUT",
        "/v20190125/meshes/$(meshName)/virtualRouters/$(virtualRouterName)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("spec" => spec, "clientToken" => string(uuid4())),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_virtual_service(mesh_name, spec, virtual_service_name)
    update_virtual_service(mesh_name, spec, virtual_service_name, params::Dict{String,<:Any})

Updates an existing virtual service in a specified service mesh.

# Arguments
- `mesh_name`: The name of the service mesh that the virtual service resides in.
- `spec`: The new virtual service specification to apply. This overwrites the existing data.
- `virtual_service_name`: The name of the virtual service to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. Up to 36 letters, numbers, hyphens, and underscores are allowed.
- `"meshOwner"`: The Amazon Web Services IAM account ID of the service mesh owner. If the
  account ID is not your own, then it's the ID of the account that shared the mesh with your
  account. For more information about mesh sharing, see Working with shared meshes.
"""
function update_virtual_service(
    meshName, spec, virtualServiceName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return app_mesh(
        "PUT",
        "/v20190125/meshes/$(meshName)/virtualServices/$(virtualServiceName)",
        Dict{String,Any}("spec" => spec, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_virtual_service(
    meshName,
    spec,
    virtualServiceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return app_mesh(
        "PUT",
        "/v20190125/meshes/$(meshName)/virtualServices/$(virtualServiceName)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("spec" => spec, "clientToken" => string(uuid4())),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

abstract type AbstractAWSConfig end

# https://docs.aws.amazon.com/sdkref/latest/guide/feature-retry-behavior.html
const AWS_MAX_RETRY_ATTEMPTS = 3

"""
    max_attempts(::AbstractAWSConfig) -> Int

The number of AWS request retry attempts to make.
Each backend may perform an additional layer backend-specific retries.

`AbstractAWSConfig` subtypes should allow users to override the default.
The default is 3, per the recommendations at
https://docs.aws.amazon.com/sdkref/latest/guide/feature-retry-behavior.html
"""
max_attempts(::AbstractAWSConfig) = AWS_MAX_RETRY_ATTEMPTS

mutable struct AWSConfig <: AbstractAWSConfig
    credentials::Union{AWSCredentials,Nothing}
    region::String
    output::String
    max_attempts::Int
end

# provide a default for the new field since people were using the default constructor
AWSConfig(creds, region, output) = AWSConfig(creds, region, output, AWS_MAX_RETRY_ATTEMPTS)

credentials(aws::AWSConfig) = aws.credentials
region(aws::AWSConfig) = aws.region
max_attempts(aws::AWSConfig) = aws.max_attempts

function AWSConfig(;
    profile=nothing,
    creds=AWSCredentials(; profile=profile),
    region=nothing,
    output="json",
    max_attempts=AWS_MAX_RETRY_ATTEMPTS,
)
    region = @something region aws_get_region(; profile=profile)
    return AWSConfig(creds, region, output, max_attempts)
end

"""
    aws_user_arn(aws::AWSConfig) -> String

Retrieve the `User ARN` from the `AWSConfig`, if not present query STS to update the
`user_arn`.

# Arguments
- `aws::AWSConfig`: AWSConfig used to retrieve the user arn
"""
function aws_user_arn(aws::AWSConfig)
    creds = aws.credentials

    if isempty(creds.user_arn)
        _update_creds!(aws)
    end

    return creds.user_arn
end

"""
    aws_account_number(aws::AWSConfig) -> String

Retrieve the `AWS account number` from the `AWSConfig`, if not present query STS to update
the `AWS account number`.

# Arguments
- `aws::AWSConfig`: AWSConfig used to retrieve the AWS account number
"""
function aws_account_number(aws::AWSConfig)
    creds = aws.credentials

    if isempty(creds.account_number)
        _update_creds!(aws)
    end

    return creds.account_number
end

function _update_creds!(aws_config::AWSConfig)
    response = AWSServices.sts(
        "GetCallerIdentity";
        aws_config=aws_config,
        feature_set=FeatureSet(; use_response_type=true),
    )
    dict = parse(response)["GetCallerIdentityResult"]
    creds = aws_config.credentials

    creds.user_arn = dict["Arn"]
    creds.account_number = dict["Account"]

    return creds
end

const _DEFAULT_AWS_CONFIG = Ref{AbstractAWSConfig}()
const _DEFAULT_AWS_CONFIG_LOCK = ReentrantLock()
const _SCOPED_AWS_CONFIG = ScopedValue{AbstractAWSConfig}()

"""
    default_aws_config(config::AbstractAWSConfig) -> Nothing

Sets the default AWS configuration to use when calling
[`current_aws_config()`](@ref current_aws_config) outside of the scope of any
[`with_aws_config`](@ref) calls.
"""
function default_aws_config(config::AbstractAWSConfig)
    @lock _DEFAULT_AWS_CONFIG_LOCK begin
        _DEFAULT_AWS_CONFIG[] = config
    end
    return nothing
end

"""
    default_aws_config() -> AbstractAWSConfig

Gets the default AWS configuration to use when calling
[`current_aws_config()`](@ref current_aws_config) outside of the scope of any
[`with_aws_config`](@ref) calls. If no configuration has been set with
`default_aws_config(::AbstractAWSConfig)` then the AWS configuration will be loaded using
`AWSConfig()`.

Users will typically want to use [`current_aws_config()](@ref current_aws_config) instead.
"""
function default_aws_config()
    # Load an initial default AWS configuration only if a user hasn't already loaded one.
    # We'll make use of a lock to avoid race conditions but only lock when necessary to
    # avoid unnecessary overhead.
    if !isassigned(_DEFAULT_AWS_CONFIG)
        @lock _DEFAULT_AWS_CONFIG_LOCK begin
            if !isassigned(_DEFAULT_AWS_CONFIG)
                _DEFAULT_AWS_CONFIG[] = @mock AWSConfig()
            end
        end
    end

    return _DEFAULT_AWS_CONFIG[]
end

"""
    current_aws_config() -> AbstractAWSConfig

Retrieve the current AWS configuration set within the current scope. If no configuration has
been set using [`with_aws_config`](@ref) then the default AWS configuration will be used.
"""
function current_aws_config()
    #! format: off
    return @something(
        ScopedValues.get(_SCOPED_AWS_CONFIG),
        @mock(default_aws_config()),
    )
    #! format: on
end

"""
    with_aws_config(f, config::AbstractAWSConfig) -> Any

Executes the function `f` where the result of `current_aws_config()` returns `config`.
Nesting of `with_aws_config` calls is supported.

The user provided function `f` takes no parameters. The `with_aws_config` function returns
the result return from `f`.
"""
function with_aws_config(f, config::AbstractAWSConfig)
    return @with _SCOPED_AWS_CONFIG => config begin
        f()
    end
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: redshift_data
using AWS.Compat
using AWS.UUIDs

"""
    batch_execute_statement(database, sqls)
    batch_execute_statement(database, sqls, params::Dict{String,<:Any})

Runs one or more SQL statements, which can be data manipulation language (DML) or data
definition language (DDL). Depending on the authorization method, use one of the following
combinations of request parameters:    Secrets Manager - when connecting to a cluster,
provide the secret-arn of a secret stored in Secrets Manager which has username and
password. The specified secret contains credentials to connect to the database you specify.
When you are connecting to a cluster, you also supply the database name, If you provide a
cluster identifier (dbClusterIdentifier), it must match the cluster identifier stored in
the secret. When you are connecting to a serverless workgroup, you also supply the database
name.   Temporary credentials - when connecting to your data warehouse, choose one of the
following options:   When connecting to a serverless workgroup, specify the workgroup name
and database name. The database user name is derived from the IAM identity. For example,
arn:iam::123456789012:user:foo has the database user name IAM:foo. Also, permission to call
the redshift-serverless:GetCredentials operation is required.   When connecting to a
cluster as an IAM identity, specify the cluster identifier and the database name. The
database user name is derived from the IAM identity. For example,
arn:iam::123456789012:user:foo has the database user name IAM:foo. Also, permission to call
the redshift:GetClusterCredentialsWithIAM operation is required.   When connecting to a
cluster as a database user, specify the cluster identifier, the database name, and the
database user name. Also, permission to call the redshift:GetClusterCredentials operation
is required.     For more information about the Amazon Redshift Data API and CLI usage
examples, see Using the Amazon Redshift Data API in the Amazon Redshift Management Guide.

# Arguments
- `database`: The name of the database. This parameter is required when authenticating
  using either Secrets Manager or temporary credentials.
- `sqls`: One or more SQL statements to run.  The SQL statements are run as a single
  transaction. They run serially in the order of the array. Subsequent SQL statements don't
  start until the previous statement in the array completes. If any SQL statement fails, then
  because they are run as one transaction, all work is rolled back.&lt;/p&gt;

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request.
- `"ClusterIdentifier"`: The cluster identifier. This parameter is required when connecting
  to a cluster and authenticating using either Secrets Manager or temporary credentials.
- `"DbUser"`: The database user name. This parameter is required when connecting to a
  cluster as a database user and authenticating using temporary credentials.
- `"SecretArn"`: The name or ARN of the secret that enables access to the database. This
  parameter is required when authenticating using Secrets Manager.
- `"StatementName"`: The name of the SQL statements. You can name the SQL statements when
  you create them to identify the query.
- `"WithEvent"`: A value that indicates whether to send an event to the Amazon EventBridge
  event bus after the SQL statements run.
- `"WorkgroupName"`: The serverless workgroup name or Amazon Resource Name (ARN). This
  parameter is required when connecting to a serverless workgroup and authenticating using
  either Secrets Manager or temporary credentials.
"""
function batch_execute_statement(
    Database, Sqls; aws_config::AbstractAWSConfig=current_aws_config()
)
    return redshift_data(
        "BatchExecuteStatement",
        Dict{String,Any}(
            "Database" => Database, "Sqls" => Sqls, "ClientToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_execute_statement(
    Database,
    Sqls,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return redshift_data(
        "BatchExecuteStatement",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Database" => Database, "Sqls" => Sqls, "ClientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_statement(id)
    cancel_statement(id, params::Dict{String,<:Any})

Cancels a running query. To be canceled, a query must be running.  For more information
about the Amazon Redshift Data API and CLI usage examples, see Using the Amazon Redshift
Data API in the Amazon Redshift Management Guide.

# Arguments
- `id`: The identifier of the SQL statement to cancel. This value is a universally unique
  identifier (UUID) generated by Amazon Redshift Data API. This identifier is returned by
  BatchExecuteStatment, ExecuteStatment, and ListStatements.

"""
function cancel_statement(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return redshift_data(
        "CancelStatement",
        Dict{String,Any}("Id" => Id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_statement(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return redshift_data(
        "CancelStatement",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Id" => Id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_statement(id)
    describe_statement(id, params::Dict{String,<:Any})

Describes the details about a specific instance when a query was run by the Amazon Redshift
Data API. The information includes when the query started, when it finished, the query
status, the number of rows returned, and the SQL statement.  For more information about the
Amazon Redshift Data API and CLI usage examples, see Using the Amazon Redshift Data API in
the Amazon Redshift Management Guide.

# Arguments
- `id`: The identifier of the SQL statement to describe. This value is a universally unique
  identifier (UUID) generated by Amazon Redshift Data API. A suffix indicates the number of
  the SQL statement. For example, d9b6c0c9-0747-4bf4-b142-e8883122f766:2 has a suffix of :2
  that indicates the second SQL statement of a batch query. This identifier is returned by
  BatchExecuteStatment, ExecuteStatement, and ListStatements.

"""
function describe_statement(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return redshift_data(
        "DescribeStatement",
        Dict{String,Any}("Id" => Id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_statement(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return redshift_data(
        "DescribeStatement",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Id" => Id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_table(database)
    describe_table(database, params::Dict{String,<:Any})

Describes the detailed information about a table from metadata in the cluster. The
information includes its columns. A token is returned to page through the column list.
Depending on the authorization method, use one of the following combinations of request
parameters:    Secrets Manager - when connecting to a cluster, provide the secret-arn of a
secret stored in Secrets Manager which has username and password. The specified secret
contains credentials to connect to the database you specify. When you are connecting to a
cluster, you also supply the database name, If you provide a cluster identifier
(dbClusterIdentifier), it must match the cluster identifier stored in the secret. When you
are connecting to a serverless workgroup, you also supply the database name.   Temporary
credentials - when connecting to your data warehouse, choose one of the following options:
 When connecting to a serverless workgroup, specify the workgroup name and database name.
The database user name is derived from the IAM identity. For example,
arn:iam::123456789012:user:foo has the database user name IAM:foo. Also, permission to call
the redshift-serverless:GetCredentials operation is required.   When connecting to a
cluster as an IAM identity, specify the cluster identifier and the database name. The
database user name is derived from the IAM identity. For example,
arn:iam::123456789012:user:foo has the database user name IAM:foo. Also, permission to call
the redshift:GetClusterCredentialsWithIAM operation is required.   When connecting to a
cluster as a database user, specify the cluster identifier, the database name, and the
database user name. Also, permission to call the redshift:GetClusterCredentials operation
is required.     For more information about the Amazon Redshift Data API and CLI usage
examples, see Using the Amazon Redshift Data API in the Amazon Redshift Management Guide.

# Arguments
- `database`: The name of the database that contains the tables to be described. If
  ConnectedDatabase is not specified, this is also the database to connect to with your
  authentication credentials.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClusterIdentifier"`: The cluster identifier. This parameter is required when connecting
  to a cluster and authenticating using either Secrets Manager or temporary credentials.
- `"ConnectedDatabase"`: A database name. The connected database is specified when you
  connect with your authentication credentials.
- `"DbUser"`: The database user name. This parameter is required when connecting to a
  cluster as a database user and authenticating using temporary credentials.
- `"MaxResults"`: The maximum number of tables to return in the response. If more tables
  exist than fit in one response, then NextToken is returned to page through the results.
- `"NextToken"`: A value that indicates the starting point for the next set of response
  records in a subsequent request. If a value is returned in a response, you can retrieve the
  next set of records by providing this returned NextToken value in the next NextToken
  parameter and retrying the command. If the NextToken field is empty, all response records
  have been retrieved for the request.
- `"Schema"`: The schema that contains the table. If no schema is specified, then matching
  tables for all schemas are returned.
- `"SecretArn"`: The name or ARN of the secret that enables access to the database. This
  parameter is required when authenticating using Secrets Manager.
- `"Table"`: The table name. If no table is specified, then all tables for all matching
  schemas are returned. If no table and no schema is specified, then all tables for all
  schemas in the database are returned
- `"WorkgroupName"`: The serverless workgroup name or Amazon Resource Name (ARN). This
  parameter is required when connecting to a serverless workgroup and authenticating using
  either Secrets Manager or temporary credentials.
"""
function describe_table(Database; aws_config::AbstractAWSConfig=current_aws_config())
    return redshift_data(
        "DescribeTable",
        Dict{String,Any}("Database" => Database);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_table(
    Database,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return redshift_data(
        "DescribeTable",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Database" => Database), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    execute_statement(database, sql)
    execute_statement(database, sql, params::Dict{String,<:Any})

Runs an SQL statement, which can be data manipulation language (DML) or data definition
language (DDL). This statement must be a single SQL statement. Depending on the
authorization method, use one of the following combinations of request parameters:
Secrets Manager - when connecting to a cluster, provide the secret-arn of a secret stored
in Secrets Manager which has username and password. The specified secret contains
credentials to connect to the database you specify. When you are connecting to a cluster,
you also supply the database name, If you provide a cluster identifier
(dbClusterIdentifier), it must match the cluster identifier stored in the secret. When you
are connecting to a serverless workgroup, you also supply the database name.   Temporary
credentials - when connecting to your data warehouse, choose one of the following options:
 When connecting to a serverless workgroup, specify the workgroup name and database name.
The database user name is derived from the IAM identity. For example,
arn:iam::123456789012:user:foo has the database user name IAM:foo. Also, permission to call
the redshift-serverless:GetCredentials operation is required.   When connecting to a
cluster as an IAM identity, specify the cluster identifier and the database name. The
database user name is derived from the IAM identity. For example,
arn:iam::123456789012:user:foo has the database user name IAM:foo. Also, permission to call
the redshift:GetClusterCredentialsWithIAM operation is required.   When connecting to a
cluster as a database user, specify the cluster identifier, the database name, and the
database user name. Also, permission to call the redshift:GetClusterCredentials operation
is required.     For more information about the Amazon Redshift Data API and CLI usage
examples, see Using the Amazon Redshift Data API in the Amazon Redshift Management Guide.

# Arguments
- `database`: The name of the database. This parameter is required when authenticating
  using either Secrets Manager or temporary credentials.
- `sql`: The SQL statement text to run.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request.
- `"ClusterIdentifier"`: The cluster identifier. This parameter is required when connecting
  to a cluster and authenticating using either Secrets Manager or temporary credentials.
- `"DbUser"`: The database user name. This parameter is required when connecting to a
  cluster as a database user and authenticating using temporary credentials.
- `"Parameters"`: The parameters for the SQL statement.
- `"SecretArn"`: The name or ARN of the secret that enables access to the database. This
  parameter is required when authenticating using Secrets Manager.
- `"StatementName"`: The name of the SQL statement. You can name the SQL statement when you
  create it to identify the query.
- `"WithEvent"`: A value that indicates whether to send an event to the Amazon EventBridge
  event bus after the SQL statement runs.
- `"WorkgroupName"`: The serverless workgroup name or Amazon Resource Name (ARN). This
  parameter is required when connecting to a serverless workgroup and authenticating using
  either Secrets Manager or temporary credentials.
"""
function execute_statement(
    Database, Sql; aws_config::AbstractAWSConfig=current_aws_config()
)
    return redshift_data(
        "ExecuteStatement",
        Dict{String,Any}(
            "Database" => Database, "Sql" => Sql, "ClientToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function execute_statement(
    Database,
    Sql,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return redshift_data(
        "ExecuteStatement",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Database" => Database, "Sql" => Sql, "ClientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_statement_result(id)
    get_statement_result(id, params::Dict{String,<:Any})

Fetches the temporarily cached result of an SQL statement. A token is returned to page
through the statement results.  For more information about the Amazon Redshift Data API and
CLI usage examples, see Using the Amazon Redshift Data API in the Amazon Redshift
Management Guide.

# Arguments
- `id`: The identifier of the SQL statement whose results are to be fetched. This value is
  a universally unique identifier (UUID) generated by Amazon Redshift Data API. A suffix
  indicates then number of the SQL statement. For example,
  d9b6c0c9-0747-4bf4-b142-e8883122f766:2 has a suffix of :2 that indicates the second SQL
  statement of a batch query. This identifier is returned by BatchExecuteStatment,
  ExecuteStatment, and ListStatements.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: A value that indicates the starting point for the next set of response
  records in a subsequent request. If a value is returned in a response, you can retrieve the
  next set of records by providing this returned NextToken value in the next NextToken
  parameter and retrying the command. If the NextToken field is empty, all response records
  have been retrieved for the request.
"""
function get_statement_result(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return redshift_data(
        "GetStatementResult",
        Dict{String,Any}("Id" => Id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_statement_result(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return redshift_data(
        "GetStatementResult",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Id" => Id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_databases(database)
    list_databases(database, params::Dict{String,<:Any})

List the databases in a cluster. A token is returned to page through the database list.
Depending on the authorization method, use one of the following combinations of request
parameters:    Secrets Manager - when connecting to a cluster, provide the secret-arn of a
secret stored in Secrets Manager which has username and password. The specified secret
contains credentials to connect to the database you specify. When you are connecting to a
cluster, you also supply the database name, If you provide a cluster identifier
(dbClusterIdentifier), it must match the cluster identifier stored in the secret. When you
are connecting to a serverless workgroup, you also supply the database name.   Temporary
credentials - when connecting to your data warehouse, choose one of the following options:
 When connecting to a serverless workgroup, specify the workgroup name and database name.
The database user name is derived from the IAM identity. For example,
arn:iam::123456789012:user:foo has the database user name IAM:foo. Also, permission to call
the redshift-serverless:GetCredentials operation is required.   When connecting to a
cluster as an IAM identity, specify the cluster identifier and the database name. The
database user name is derived from the IAM identity. For example,
arn:iam::123456789012:user:foo has the database user name IAM:foo. Also, permission to call
the redshift:GetClusterCredentialsWithIAM operation is required.   When connecting to a
cluster as a database user, specify the cluster identifier, the database name, and the
database user name. Also, permission to call the redshift:GetClusterCredentials operation
is required.     For more information about the Amazon Redshift Data API and CLI usage
examples, see Using the Amazon Redshift Data API in the Amazon Redshift Management Guide.

# Arguments
- `database`: The name of the database. This parameter is required when authenticating
  using either Secrets Manager or temporary credentials.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClusterIdentifier"`: The cluster identifier. This parameter is required when connecting
  to a cluster and authenticating using either Secrets Manager or temporary credentials.
- `"DbUser"`: The database user name. This parameter is required when connecting to a
  cluster as a database user and authenticating using temporary credentials.
- `"MaxResults"`: The maximum number of databases to return in the response. If more
  databases exist than fit in one response, then NextToken is returned to page through the
  results.
- `"NextToken"`: A value that indicates the starting point for the next set of response
  records in a subsequent request. If a value is returned in a response, you can retrieve the
  next set of records by providing this returned NextToken value in the next NextToken
  parameter and retrying the command. If the NextToken field is empty, all response records
  have been retrieved for the request.
- `"SecretArn"`: The name or ARN of the secret that enables access to the database. This
  parameter is required when authenticating using Secrets Manager.
- `"WorkgroupName"`: The serverless workgroup name or Amazon Resource Name (ARN). This
  parameter is required when connecting to a serverless workgroup and authenticating using
  either Secrets Manager or temporary credentials.
"""
function list_databases(Database; aws_config::AbstractAWSConfig=current_aws_config())
    return redshift_data(
        "ListDatabases",
        Dict{String,Any}("Database" => Database);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_databases(
    Database,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return redshift_data(
        "ListDatabases",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Database" => Database), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_schemas(database)
    list_schemas(database, params::Dict{String,<:Any})

Lists the schemas in a database. A token is returned to page through the schema list.
Depending on the authorization method, use one of the following combinations of request
parameters:    Secrets Manager - when connecting to a cluster, provide the secret-arn of a
secret stored in Secrets Manager which has username and password. The specified secret
contains credentials to connect to the database you specify. When you are connecting to a
cluster, you also supply the database name, If you provide a cluster identifier
(dbClusterIdentifier), it must match the cluster identifier stored in the secret. When you
are connecting to a serverless workgroup, you also supply the database name.   Temporary
credentials - when connecting to your data warehouse, choose one of the following options:
 When connecting to a serverless workgroup, specify the workgroup name and database name.
The database user name is derived from the IAM identity. For example,
arn:iam::123456789012:user:foo has the database user name IAM:foo. Also, permission to call
the redshift-serverless:GetCredentials operation is required.   When connecting to a
cluster as an IAM identity, specify the cluster identifier and the database name. The
database user name is derived from the IAM identity. For example,
arn:iam::123456789012:user:foo has the database user name IAM:foo. Also, permission to call
the redshift:GetClusterCredentialsWithIAM operation is required.   When connecting to a
cluster as a database user, specify the cluster identifier, the database name, and the
database user name. Also, permission to call the redshift:GetClusterCredentials operation
is required.     For more information about the Amazon Redshift Data API and CLI usage
examples, see Using the Amazon Redshift Data API in the Amazon Redshift Management Guide.

# Arguments
- `database`: The name of the database that contains the schemas to list. If
  ConnectedDatabase is not specified, this is also the database to connect to with your
  authentication credentials.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClusterIdentifier"`: The cluster identifier. This parameter is required when connecting
  to a cluster and authenticating using either Secrets Manager or temporary credentials.
- `"ConnectedDatabase"`: A database name. The connected database is specified when you
  connect with your authentication credentials.
- `"DbUser"`: The database user name. This parameter is required when connecting to a
  cluster as a database user and authenticating using temporary credentials.
- `"MaxResults"`: The maximum number of schemas to return in the response. If more schemas
  exist than fit in one response, then NextToken is returned to page through the results.
- `"NextToken"`: A value that indicates the starting point for the next set of response
  records in a subsequent request. If a value is returned in a response, you can retrieve the
  next set of records by providing this returned NextToken value in the next NextToken
  parameter and retrying the command. If the NextToken field is empty, all response records
  have been retrieved for the request.
- `"SchemaPattern"`: A pattern to filter results by schema name. Within a schema pattern,
  \"%\" means match any substring of 0 or more characters and \"_\" means match any one
  character. Only schema name entries matching the search pattern are returned.
- `"SecretArn"`: The name or ARN of the secret that enables access to the database. This
  parameter is required when authenticating using Secrets Manager.
- `"WorkgroupName"`: The serverless workgroup name or Amazon Resource Name (ARN). This
  parameter is required when connecting to a serverless workgroup and authenticating using
  either Secrets Manager or temporary credentials.
"""
function list_schemas(Database; aws_config::AbstractAWSConfig=current_aws_config())
    return redshift_data(
        "ListSchemas",
        Dict{String,Any}("Database" => Database);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_schemas(
    Database,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return redshift_data(
        "ListSchemas",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Database" => Database), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_statements()
    list_statements(params::Dict{String,<:Any})

List of SQL statements. By default, only finished statements are shown. A token is returned
to page through the statement list.  For more information about the Amazon Redshift Data
API and CLI usage examples, see Using the Amazon Redshift Data API in the Amazon Redshift
Management Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of SQL statements to return in the response. If more
  SQL statements exist than fit in one response, then NextToken is returned to page through
  the results.
- `"NextToken"`: A value that indicates the starting point for the next set of response
  records in a subsequent request. If a value is returned in a response, you can retrieve the
  next set of records by providing this returned NextToken value in the next NextToken
  parameter and retrying the command. If the NextToken field is empty, all response records
  have been retrieved for the request.
- `"RoleLevel"`: A value that filters which statements to return in the response. If true,
  all statements run by the caller's IAM role are returned. If false, only statements run by
  the caller's IAM role in the current IAM session are returned. The default is true.
- `"StatementName"`: The name of the SQL statement specified as input to
  BatchExecuteStatement or ExecuteStatement to identify the query. You can list multiple
  statements by providing a prefix that matches the beginning of the statement name. For
  example, to list myStatement1, myStatement2, myStatement3, and so on, then provide the a
  value of myStatement. Data API does a case-sensitive match of SQL statement names to the
  prefix value you provide.
- `"Status"`: The status of the SQL statement to list. Status values are defined as
  follows:    ABORTED - The query run was stopped by the user.    ALL - A status value that
  includes all query statuses. This value can be used to filter results.    FAILED - The
  query run failed.    FINISHED - The query has finished running.    PICKED - The query has
  been chosen to be run.    STARTED - The query run has started.    SUBMITTED - The query was
  submitted, but not yet processed.
"""
function list_statements(; aws_config::AbstractAWSConfig=current_aws_config())
    return redshift_data(
        "ListStatements"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_statements(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return redshift_data(
        "ListStatements", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tables(database)
    list_tables(database, params::Dict{String,<:Any})

List the tables in a database. If neither SchemaPattern nor TablePattern are specified,
then all tables in the database are returned. A token is returned to page through the table
list. Depending on the authorization method, use one of the following combinations of
request parameters:    Secrets Manager - when connecting to a cluster, provide the
secret-arn of a secret stored in Secrets Manager which has username and password. The
specified secret contains credentials to connect to the database you specify. When you are
connecting to a cluster, you also supply the database name, If you provide a cluster
identifier (dbClusterIdentifier), it must match the cluster identifier stored in the
secret. When you are connecting to a serverless workgroup, you also supply the database
name.   Temporary credentials - when connecting to your data warehouse, choose one of the
following options:   When connecting to a serverless workgroup, specify the workgroup name
and database name. The database user name is derived from the IAM identity. For example,
arn:iam::123456789012:user:foo has the database user name IAM:foo. Also, permission to call
the redshift-serverless:GetCredentials operation is required.   When connecting to a
cluster as an IAM identity, specify the cluster identifier and the database name. The
database user name is derived from the IAM identity. For example,
arn:iam::123456789012:user:foo has the database user name IAM:foo. Also, permission to call
the redshift:GetClusterCredentialsWithIAM operation is required.   When connecting to a
cluster as a database user, specify the cluster identifier, the database name, and the
database user name. Also, permission to call the redshift:GetClusterCredentials operation
is required.     For more information about the Amazon Redshift Data API and CLI usage
examples, see Using the Amazon Redshift Data API in the Amazon Redshift Management Guide.

# Arguments
- `database`: The name of the database that contains the tables to list. If
  ConnectedDatabase is not specified, this is also the database to connect to with your
  authentication credentials.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClusterIdentifier"`: The cluster identifier. This parameter is required when connecting
  to a cluster and authenticating using either Secrets Manager or temporary credentials.
- `"ConnectedDatabase"`: A database name. The connected database is specified when you
  connect with your authentication credentials.
- `"DbUser"`: The database user name. This parameter is required when connecting to a
  cluster as a database user and authenticating using temporary credentials.
- `"MaxResults"`: The maximum number of tables to return in the response. If more tables
  exist than fit in one response, then NextToken is returned to page through the results.
- `"NextToken"`: A value that indicates the starting point for the next set of response
  records in a subsequent request. If a value is returned in a response, you can retrieve the
  next set of records by providing this returned NextToken value in the next NextToken
  parameter and retrying the command. If the NextToken field is empty, all response records
  have been retrieved for the request.
- `"SchemaPattern"`: A pattern to filter results by schema name. Within a schema pattern,
  \"%\" means match any substring of 0 or more characters and \"_\" means match any one
  character. Only schema name entries matching the search pattern are returned. If
  SchemaPattern is not specified, then all tables that match TablePattern are returned. If
  neither SchemaPattern or TablePattern are specified, then all tables are returned.
- `"SecretArn"`: The name or ARN of the secret that enables access to the database. This
  parameter is required when authenticating using Secrets Manager.
- `"TablePattern"`: A pattern to filter results by table name. Within a table pattern,
  \"%\" means match any substring of 0 or more characters and \"_\" means match any one
  character. Only table name entries matching the search pattern are returned. If
  TablePattern is not specified, then all tables that match SchemaPatternare returned. If
  neither SchemaPattern or TablePattern are specified, then all tables are returned.
- `"WorkgroupName"`: The serverless workgroup name or Amazon Resource Name (ARN). This
  parameter is required when connecting to a serverless workgroup and authenticating using
  either Secrets Manager or temporary credentials.
"""
function list_tables(Database; aws_config::AbstractAWSConfig=current_aws_config())
    return redshift_data(
        "ListTables",
        Dict{String,Any}("Database" => Database);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tables(
    Database,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return redshift_data(
        "ListTables",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Database" => Database), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: securitylake
using AWS.Compat
using AWS.UUIDs

"""
    create_aws_log_source(sources)
    create_aws_log_source(sources, params::Dict{String,<:Any})

Adds a natively supported Amazon Web Service as an Amazon Security Lake source. Enables
source types for member accounts in required Amazon Web Services Regions, based on the
parameters you specify. You can choose any source type in any Region for either accounts
that are part of a trusted organization or standalone accounts. Once you add an Amazon Web
Service as a source, Security Lake starts collecting logs and events from it. You can use
this API only to enable natively supported Amazon Web Services as a source. Use
CreateCustomLogSource to enable data collection from a custom source.

# Arguments
- `sources`: Specify the natively-supported Amazon Web Services service to add as a source
  in Security Lake.

"""
function create_aws_log_source(sources; aws_config::AbstractAWSConfig=current_aws_config())
    return securitylake(
        "POST",
        "/v1/datalake/logsources/aws",
        Dict{String,Any}("sources" => sources);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_aws_log_source(
    sources,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securitylake(
        "POST",
        "/v1/datalake/logsources/aws",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("sources" => sources), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_custom_log_source(configuration, source_name)
    create_custom_log_source(configuration, source_name, params::Dict{String,<:Any})

Adds a third-party custom source in Amazon Security Lake, from the Amazon Web Services
Region where you want to create a custom source. Security Lake can collect logs and events
from third-party custom sources. After creating the appropriate IAM role to invoke Glue
crawler, use this API to add a custom source name in Security Lake. This operation creates
a partition in the Amazon S3 bucket for Security Lake as the target location for log files
from the custom source. In addition, this operation also creates an associated Glue table
and an Glue crawler.

# Arguments
- `configuration`: The configuration for the third-party custom source.
- `source_name`: Specify the name for a third-party custom source. This must be a
  Regionally unique value.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"eventClasses"`: The Open Cybersecurity Schema Framework (OCSF) event classes which
  describes the type of data that the custom source will send to Security Lake. The supported
  event classes are:    ACCESS_ACTIVITY     FILE_ACTIVITY     KERNEL_ACTIVITY
  KERNEL_EXTENSION     MEMORY_ACTIVITY     MODULE_ACTIVITY     PROCESS_ACTIVITY
  REGISTRY_KEY_ACTIVITY     REGISTRY_VALUE_ACTIVITY     RESOURCE_ACTIVITY
  SCHEDULED_JOB_ACTIVITY     SECURITY_FINDING     ACCOUNT_CHANGE     AUTHENTICATION
  AUTHORIZATION     ENTITY_MANAGEMENT_AUDIT     DHCP_ACTIVITY     NETWORK_ACTIVITY
  DNS_ACTIVITY     FTP_ACTIVITY     HTTP_ACTIVITY     RDP_ACTIVITY     SMB_ACTIVITY
  SSH_ACTIVITY     CONFIG_STATE     INVENTORY_INFO     EMAIL_ACTIVITY     API_ACTIVITY
  CLOUD_API
- `"sourceVersion"`: Specify the source version for the third-party custom source, to limit
  log collection to a specific version of custom data source.
"""
function create_custom_log_source(
    configuration, sourceName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securitylake(
        "POST",
        "/v1/datalake/logsources/custom",
        Dict{String,Any}("configuration" => configuration, "sourceName" => sourceName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_custom_log_source(
    configuration,
    sourceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securitylake(
        "POST",
        "/v1/datalake/logsources/custom",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "configuration" => configuration, "sourceName" => sourceName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_data_lake(configurations, meta_store_manager_role_arn)
    create_data_lake(configurations, meta_store_manager_role_arn, params::Dict{String,<:Any})

Initializes an Amazon Security Lake instance with the provided (or default) configuration.
You can enable Security Lake in Amazon Web Services Regions with customized settings before
enabling log collection in Regions. To specify particular Regions, configure these Regions
using the configurations parameter. If you have already enabled Security Lake in a Region
when you call this command, the command will update the Region if you provide new
configuration parameters. If you have not already enabled Security Lake in the Region when
you call this API, it will set up the data lake in the Region with the specified
configurations. When you enable Security Lake, it starts ingesting security data after the
CreateAwsLogSource call. This includes ingesting security data from sources, storing data,
and making data accessible to subscribers. Security Lake also enables all the existing
settings and resources that it stores or maintains for your Amazon Web Services account in
the current Region, including security log and event data. For more information, see the
Amazon Security Lake User Guide.

# Arguments
- `configurations`: Specify the Region or Regions that will contribute data to the rollup
  region.
- `meta_store_manager_role_arn`: The Amazon Resource Name (ARN) used to create and update
  the Glue table. This table contains partitions generated by the ingestion and normalization
  of Amazon Web Services log sources and custom sources.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tags"`: An array of objects, one for each tag to associate with the data lake
  configuration. For each tag, you must specify both a tag key and a tag value. A tag value
  cannot be null, but it can be an empty string.
"""
function create_data_lake(
    configurations,
    metaStoreManagerRoleArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securitylake(
        "POST",
        "/v1/datalake",
        Dict{String,Any}(
            "configurations" => configurations,
            "metaStoreManagerRoleArn" => metaStoreManagerRoleArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_data_lake(
    configurations,
    metaStoreManagerRoleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securitylake(
        "POST",
        "/v1/datalake",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "configurations" => configurations,
                    "metaStoreManagerRoleArn" => metaStoreManagerRoleArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_data_lake_exception_subscription(notification_endpoint, subscription_protocol)
    create_data_lake_exception_subscription(notification_endpoint, subscription_protocol, params::Dict{String,<:Any})

Creates the specified notification subscription in Amazon Security Lake for the
organization you specify.

# Arguments
- `notification_endpoint`: The Amazon Web Services account where you want to receive
  exception notifications.
- `subscription_protocol`: The subscription protocol to which exception notifications are
  posted.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"exceptionTimeToLive"`: The expiration period and time-to-live (TTL).
"""
function create_data_lake_exception_subscription(
    notificationEndpoint,
    subscriptionProtocol;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securitylake(
        "POST",
        "/v1/datalake/exceptions/subscription",
        Dict{String,Any}(
            "notificationEndpoint" => notificationEndpoint,
            "subscriptionProtocol" => subscriptionProtocol,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_data_lake_exception_subscription(
    notificationEndpoint,
    subscriptionProtocol,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securitylake(
        "POST",
        "/v1/datalake/exceptions/subscription",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "notificationEndpoint" => notificationEndpoint,
                    "subscriptionProtocol" => subscriptionProtocol,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_data_lake_organization_configuration()
    create_data_lake_organization_configuration(params::Dict{String,<:Any})

Automatically enables Amazon Security Lake for new member accounts in your organization.
Security Lake is not automatically enabled for any existing member accounts in your
organization.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"autoEnableNewAccount"`: Enable Security Lake with the specified configuration settings,
  to begin collecting security data for new accounts in your organization.
"""
function create_data_lake_organization_configuration(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return securitylake(
        "POST",
        "/v1/datalake/organization/configuration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_data_lake_organization_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securitylake(
        "POST",
        "/v1/datalake/organization/configuration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_subscriber(sources, subscriber_identity, subscriber_name)
    create_subscriber(sources, subscriber_identity, subscriber_name, params::Dict{String,<:Any})

Creates a subscription permission for accounts that are already enabled in Amazon Security
Lake. You can create a subscriber with access to data in the current Amazon Web Services
Region.

# Arguments
- `sources`: The supported Amazon Web Services from which logs and events are collected.
  Security Lake supports log and event collection for natively supported Amazon Web Services.
- `subscriber_identity`: The Amazon Web Services identity used to access your data.
- `subscriber_name`: The name of your Security Lake subscriber account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accessTypes"`: The Amazon S3 or Lake Formation access type.
- `"subscriberDescription"`: The description for your subscriber account in Security Lake.
- `"tags"`: An array of objects, one for each tag to associate with the subscriber. For
  each tag, you must specify both a tag key and a tag value. A tag value cannot be null, but
  it can be an empty string.
"""
function create_subscriber(
    sources,
    subscriberIdentity,
    subscriberName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securitylake(
        "POST",
        "/v1/subscribers",
        Dict{String,Any}(
            "sources" => sources,
            "subscriberIdentity" => subscriberIdentity,
            "subscriberName" => subscriberName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_subscriber(
    sources,
    subscriberIdentity,
    subscriberName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securitylake(
        "POST",
        "/v1/subscribers",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "sources" => sources,
                    "subscriberIdentity" => subscriberIdentity,
                    "subscriberName" => subscriberName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_subscriber_notification(configuration, subscriber_id)
    create_subscriber_notification(configuration, subscriber_id, params::Dict{String,<:Any})

Notifies the subscriber when new data is written to the data lake for the sources that the
subscriber consumes in Security Lake. You can create only one subscriber notification per
subscriber.

# Arguments
- `configuration`: Specify the configuration using which you want to create the subscriber
  notification.
- `subscriber_id`: The subscriber ID for the notification subscription.

"""
function create_subscriber_notification(
    configuration, subscriberId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securitylake(
        "POST",
        "/v1/subscribers/$(subscriberId)/notification",
        Dict{String,Any}("configuration" => configuration);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_subscriber_notification(
    configuration,
    subscriberId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securitylake(
        "POST",
        "/v1/subscribers/$(subscriberId)/notification",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("configuration" => configuration), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_aws_log_source(sources)
    delete_aws_log_source(sources, params::Dict{String,<:Any})

Removes a natively supported Amazon Web Service as an Amazon Security Lake source. You can
remove a source for one or more Regions. When you remove the source, Security Lake stops
collecting data from that source in the specified Regions and accounts, and subscribers can
no longer consume new data from the source. However, subscribers can still consume data
that Security Lake collected from the source before removal. You can choose any source type
in any Amazon Web Services Region for either accounts that are part of a trusted
organization or standalone accounts.

# Arguments
- `sources`: Specify the natively-supported Amazon Web Services service to remove as a
  source in Security Lake.

"""
function delete_aws_log_source(sources; aws_config::AbstractAWSConfig=current_aws_config())
    return securitylake(
        "POST",
        "/v1/datalake/logsources/aws/delete",
        Dict{String,Any}("sources" => sources);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_aws_log_source(
    sources,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securitylake(
        "POST",
        "/v1/datalake/logsources/aws/delete",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("sources" => sources), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_custom_log_source(source_name)
    delete_custom_log_source(source_name, params::Dict{String,<:Any})

Removes a custom log source from Amazon Security Lake, to stop sending data from the custom
source to Security Lake.

# Arguments
- `source_name`: The source name of custom log source that you want to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"sourceVersion"`: The source version for the third-party custom source. You can limit
  the custom source removal to the specified source version.
"""
function delete_custom_log_source(
    sourceName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securitylake(
        "DELETE",
        "/v1/datalake/logsources/custom/$(sourceName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_custom_log_source(
    sourceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securitylake(
        "DELETE",
        "/v1/datalake/logsources/custom/$(sourceName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_data_lake(regions)
    delete_data_lake(regions, params::Dict{String,<:Any})

When you disable Amazon Security Lake from your account, Security Lake is disabled in all
Amazon Web Services Regions and it stops collecting data from your sources. Also, this API
automatically takes steps to remove the account from Security Lake. However, Security Lake
retains all of your existing settings and the resources that it created in your Amazon Web
Services account in the current Amazon Web Services Region. The DeleteDataLake operation
does not delete the data that is stored in your Amazon S3 bucket, which is owned by your
Amazon Web Services account. For more information, see the Amazon Security Lake User Guide.

# Arguments
- `regions`: The list of Regions where Security Lake is enabled.

"""
function delete_data_lake(regions; aws_config::AbstractAWSConfig=current_aws_config())
    return securitylake(
        "POST",
        "/v1/datalake/delete",
        Dict{String,Any}("regions" => regions);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_data_lake(
    regions,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securitylake(
        "POST",
        "/v1/datalake/delete",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("regions" => regions), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_data_lake_exception_subscription()
    delete_data_lake_exception_subscription(params::Dict{String,<:Any})

Deletes the specified notification subscription in Amazon Security Lake for the
organization you specify.

"""
function delete_data_lake_exception_subscription(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return securitylake(
        "DELETE",
        "/v1/datalake/exceptions/subscription";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_data_lake_exception_subscription(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securitylake(
        "DELETE",
        "/v1/datalake/exceptions/subscription",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_data_lake_organization_configuration()
    delete_data_lake_organization_configuration(params::Dict{String,<:Any})

Turns off automatic enablement of Amazon Security Lake for member accounts that are added
to an organization in Organizations. Only the delegated Security Lake administrator for an
organization can perform this operation. If the delegated Security Lake administrator
performs this operation, new member accounts won't automatically contribute data to the
data lake.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"autoEnableNewAccount"`: Turns off automatic enablement of Security Lake for member
  accounts that are added to an organization.
"""
function delete_data_lake_organization_configuration(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return securitylake(
        "POST",
        "/v1/datalake/organization/configuration/delete";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_data_lake_organization_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securitylake(
        "POST",
        "/v1/datalake/organization/configuration/delete",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_subscriber(subscriber_id)
    delete_subscriber(subscriber_id, params::Dict{String,<:Any})

Deletes the subscription permission and all notification settings for accounts that are
already enabled in Amazon Security Lake. When you run DeleteSubscriber, the subscriber will
no longer consume data from Security Lake and the subscriber is removed. This operation
deletes the subscriber and removes access to data in the current Amazon Web Services Region.

# Arguments
- `subscriber_id`: A value created by Security Lake that uniquely identifies your
  DeleteSubscriber API request.

"""
function delete_subscriber(subscriberId; aws_config::AbstractAWSConfig=current_aws_config())
    return securitylake(
        "DELETE",
        "/v1/subscribers/$(subscriberId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_subscriber(
    subscriberId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securitylake(
        "DELETE",
        "/v1/subscribers/$(subscriberId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_subscriber_notification(subscriber_id)
    delete_subscriber_notification(subscriber_id, params::Dict{String,<:Any})

Deletes the specified notification subscription in Amazon Security Lake for the
organization you specify.

# Arguments
- `subscriber_id`: The ID of the Security Lake subscriber account.

"""
function delete_subscriber_notification(
    subscriberId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securitylake(
        "DELETE",
        "/v1/subscribers/$(subscriberId)/notification";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_subscriber_notification(
    subscriberId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securitylake(
        "DELETE",
        "/v1/subscribers/$(subscriberId)/notification",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    deregister_data_lake_delegated_administrator()
    deregister_data_lake_delegated_administrator(params::Dict{String,<:Any})

Deletes the Amazon Security Lake delegated administrator account for the organization. This
API can only be called by the organization management account. The organization management
account cannot be the delegated administrator account.

"""
function deregister_data_lake_delegated_administrator(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return securitylake(
        "DELETE",
        "/v1/datalake/delegate";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function deregister_data_lake_delegated_administrator(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securitylake(
        "DELETE",
        "/v1/datalake/delegate",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_data_lake_exception_subscription()
    get_data_lake_exception_subscription(params::Dict{String,<:Any})

Retrieves the details of exception notifications for the account in Amazon Security Lake.

"""
function get_data_lake_exception_subscription(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return securitylake(
        "GET",
        "/v1/datalake/exceptions/subscription";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_data_lake_exception_subscription(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securitylake(
        "GET",
        "/v1/datalake/exceptions/subscription",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_data_lake_organization_configuration()
    get_data_lake_organization_configuration(params::Dict{String,<:Any})

Retrieves the configuration that will be automatically set up for accounts added to the
organization after the organization has onboarded to Amazon Security Lake. This API does
not take input parameters.

"""
function get_data_lake_organization_configuration(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return securitylake(
        "GET",
        "/v1/datalake/organization/configuration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_data_lake_organization_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securitylake(
        "GET",
        "/v1/datalake/organization/configuration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_data_lake_sources()
    get_data_lake_sources(params::Dict{String,<:Any})

Retrieves a snapshot of the current Region, including whether Amazon Security Lake is
enabled for those accounts and which sources Security Lake is collecting data from.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accounts"`: The Amazon Web Services account ID for which a static snapshot of the
  current Amazon Web Services Region, including enabled accounts and log sources, is
  retrieved.
- `"maxResults"`: The maximum limit of accounts for which the static snapshot of the
  current Region, including enabled accounts and log sources, is retrieved.
- `"nextToken"`: Lists if there are more results available. The value of nextToken is a
  unique pagination token for each page. Repeat the call using the returned token to retrieve
  the next page. Keep all other arguments unchanged. Each pagination token expires after 24
  hours. Using an expired pagination token will return an HTTP 400 InvalidToken error.
"""
function get_data_lake_sources(; aws_config::AbstractAWSConfig=current_aws_config())
    return securitylake(
        "POST",
        "/v1/datalake/sources";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_data_lake_sources(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securitylake(
        "POST",
        "/v1/datalake/sources",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_subscriber(subscriber_id)
    get_subscriber(subscriber_id, params::Dict{String,<:Any})

Retrieves the subscription information for the specified subscription ID. You can get
information about a specific subscriber.

# Arguments
- `subscriber_id`: A value created by Amazon Security Lake that uniquely identifies your
  GetSubscriber API request.

"""
function get_subscriber(subscriberId; aws_config::AbstractAWSConfig=current_aws_config())
    return securitylake(
        "GET",
        "/v1/subscribers/$(subscriberId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_subscriber(
    subscriberId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securitylake(
        "GET",
        "/v1/subscribers/$(subscriberId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_data_lake_exceptions()
    list_data_lake_exceptions(params::Dict{String,<:Any})

Lists the Amazon Security Lake exceptions that you can use to find the source of problems
and fix them.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: List the maximum number of failures in Security Lake.
- `"nextToken"`: List if there are more results available. The value of nextToken is a
  unique pagination token for each page. Repeat the call using the returned token to retrieve
  the next page. Keep all other arguments unchanged. Each pagination token expires after 24
  hours. Using an expired pagination token will return an HTTP 400 InvalidToken error.
- `"regions"`: The Amazon Web Services Regions from which exceptions are retrieved.
"""
function list_data_lake_exceptions(; aws_config::AbstractAWSConfig=current_aws_config())
    return securitylake(
        "POST",
        "/v1/datalake/exceptions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_data_lake_exceptions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securitylake(
        "POST",
        "/v1/datalake/exceptions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_data_lakes()
    list_data_lakes(params::Dict{String,<:Any})

Retrieves the Amazon Security Lake configuration object for the specified Amazon Web
Services Regions. You can use this operation to determine whether Security Lake is enabled
for a Region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"regions"`: The list of Regions where Security Lake is enabled.
"""
function list_data_lakes(; aws_config::AbstractAWSConfig=current_aws_config())
    return securitylake(
        "GET", "/v1/datalakes"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_data_lakes(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securitylake(
        "GET",
        "/v1/datalakes",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_log_sources()
    list_log_sources(params::Dict{String,<:Any})

Retrieves the log sources in the current Amazon Web Services Region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accounts"`: The list of Amazon Web Services accounts for which log sources are
  displayed.
- `"maxResults"`: The maximum number of accounts for which the log sources are displayed.
- `"nextToken"`: If nextToken is returned, there are more results available. You can repeat
  the call using the returned token to retrieve the next page.
- `"regions"`: The list of Regions for which log sources are displayed.
- `"sources"`: The list of sources for which log sources are displayed.
"""
function list_log_sources(; aws_config::AbstractAWSConfig=current_aws_config())
    return securitylake(
        "POST",
        "/v1/datalake/logsources/list";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_log_sources(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securitylake(
        "POST",
        "/v1/datalake/logsources/list",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_subscribers()
    list_subscribers(params::Dict{String,<:Any})

List all subscribers for the specific Amazon Security Lake account ID. You can retrieve a
list of subscriptions associated with a specific organization or Amazon Web Services
account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of accounts for which the configuration is displayed.
- `"nextToken"`: If nextToken is returned, there are more results available. You can repeat
  the call using the returned token to retrieve the next page.
"""
function list_subscribers(; aws_config::AbstractAWSConfig=current_aws_config())
    return securitylake(
        "GET", "/v1/subscribers"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_subscribers(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securitylake(
        "GET",
        "/v1/subscribers",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Retrieves the tags (keys and values) that are associated with an Amazon Security Lake
resource: a subscriber, or the data lake configuration for your Amazon Web Services account
in a particular Amazon Web Services Region.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the Amazon Security Lake resource for
  which you want to retrieve the tags.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securitylake(
        "GET",
        "/v1/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securitylake(
        "GET",
        "/v1/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    register_data_lake_delegated_administrator(account_id)
    register_data_lake_delegated_administrator(account_id, params::Dict{String,<:Any})

Designates the Amazon Security Lake delegated administrator account for the organization.
This API can only be called by the organization management account. The organization
management account cannot be the delegated administrator account.

# Arguments
- `account_id`: The Amazon Web Services account ID of the Security Lake delegated
  administrator.

"""
function register_data_lake_delegated_administrator(
    accountId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securitylake(
        "POST",
        "/v1/datalake/delegate",
        Dict{String,Any}("accountId" => accountId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function register_data_lake_delegated_administrator(
    accountId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securitylake(
        "POST",
        "/v1/datalake/delegate",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("accountId" => accountId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds or updates one or more tags that are associated with an Amazon Security Lake resource:
a subscriber, or the data lake configuration for your Amazon Web Services account in a
particular Amazon Web Services Region. A tag is a label that you can define and associate
with Amazon Web Services resources. Each tag consists of a required tag key and an
associated tag value. A tag key is a general label that acts as a category for a more
specific tag value. A tag value acts as a descriptor for a tag key. Tags can help you
identify, categorize, and manage resources in different ways, such as by owner,
environment, or other criteria. For more information, see Tagging Amazon Security Lake
resources in the Amazon Security Lake User Guide.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the Amazon Security Lake resource to
  add or update the tags for.
- `tags`: An array of objects, one for each tag (key and value) to associate with the
  Amazon Security Lake resource. For each tag, you must specify both a tag key and a tag
  value. A tag value cannot be null, but it can be an empty string.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return securitylake(
        "POST",
        "/v1/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securitylake(
        "POST",
        "/v1/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes one or more tags (keys and values) from an Amazon Security Lake resource: a
subscriber, or the data lake configuration for your Amazon Web Services account in a
particular Amazon Web Services Region.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the Amazon Security Lake resource to
  remove one or more tags from.
- `tag_keys`: A list of one or more tag keys. For each value in the list, specify the tag
  key for a tag to remove from the Amazon Security Lake resource.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securitylake(
        "DELETE",
        "/v1/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securitylake(
        "DELETE",
        "/v1/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_data_lake(configurations)
    update_data_lake(configurations, params::Dict{String,<:Any})

Specifies where to store your security data and for how long. You can add a rollup Region
to consolidate data from multiple Amazon Web Services Regions.

# Arguments
- `configurations`: Specify the Region or Regions that will contribute data to the rollup
  region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"metaStoreManagerRoleArn"`: The Amazon Resource Name (ARN) used to create and update the
  Glue table. This table contains partitions generated by the ingestion and normalization of
  Amazon Web Services log sources and custom sources.
"""
function update_data_lake(
    configurations; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securitylake(
        "PUT",
        "/v1/datalake",
        Dict{String,Any}("configurations" => configurations);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_data_lake(
    configurations,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securitylake(
        "PUT",
        "/v1/datalake",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("configurations" => configurations), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_data_lake_exception_subscription(notification_endpoint, subscription_protocol)
    update_data_lake_exception_subscription(notification_endpoint, subscription_protocol, params::Dict{String,<:Any})

Updates the specified notification subscription in Amazon Security Lake for the
organization you specify.

# Arguments
- `notification_endpoint`: The account that is subscribed to receive exception
  notifications.
- `subscription_protocol`: The subscription protocol to which exception messages are posted.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"exceptionTimeToLive"`: The time-to-live (TTL) for the exception message to remain.
"""
function update_data_lake_exception_subscription(
    notificationEndpoint,
    subscriptionProtocol;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securitylake(
        "PUT",
        "/v1/datalake/exceptions/subscription",
        Dict{String,Any}(
            "notificationEndpoint" => notificationEndpoint,
            "subscriptionProtocol" => subscriptionProtocol,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_data_lake_exception_subscription(
    notificationEndpoint,
    subscriptionProtocol,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securitylake(
        "PUT",
        "/v1/datalake/exceptions/subscription",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "notificationEndpoint" => notificationEndpoint,
                    "subscriptionProtocol" => subscriptionProtocol,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_subscriber(subscriber_id)
    update_subscriber(subscriber_id, params::Dict{String,<:Any})

Updates an existing subscription for the given Amazon Security Lake account ID. You can
update a subscriber by changing the sources that the subscriber consumes data from.

# Arguments
- `subscriber_id`: A value created by Security Lake that uniquely identifies your
  subscription.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"sources"`: The supported Amazon Web Services from which logs and events are collected.
  For the list of supported Amazon Web Services, see the Amazon Security Lake User Guide.
- `"subscriberDescription"`: The description of the Security Lake account subscriber.
- `"subscriberIdentity"`: The AWS identity used to access your data.
- `"subscriberName"`: The name of the Security Lake account subscriber.
"""
function update_subscriber(subscriberId; aws_config::AbstractAWSConfig=current_aws_config())
    return securitylake(
        "PUT",
        "/v1/subscribers/$(subscriberId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_subscriber(
    subscriberId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securitylake(
        "PUT",
        "/v1/subscribers/$(subscriberId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_subscriber_notification(configuration, subscriber_id)
    update_subscriber_notification(configuration, subscriber_id, params::Dict{String,<:Any})

Updates an existing notification method for the subscription (SQS or HTTPs endpoint) or
switches the notification subscription endpoint for a subscriber.

# Arguments
- `configuration`: The configuration for subscriber notification.
- `subscriber_id`: The subscription ID for which the subscription notification is specified.

"""
function update_subscriber_notification(
    configuration, subscriberId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securitylake(
        "PUT",
        "/v1/subscribers/$(subscriberId)/notification",
        Dict{String,Any}("configuration" => configuration);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_subscriber_notification(
    configuration,
    subscriberId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securitylake(
        "PUT",
        "/v1/subscribers/$(subscriberId)/notification",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("configuration" => configuration), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: freetier
using AWS.Compat
using AWS.UUIDs

"""
    get_free_tier_usage()
    get_free_tier_usage(params::Dict{String,<:Any})

Returns a list of all Free Tier usage objects that match your filters.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filter"`: An expression that specifies the conditions that you want each FreeTierUsage
  object to meet.
- `"maxResults"`: The maximum number of results to return in the response. MaxResults means
  that there can be up to the specified number of values, but there might be fewer results
  based on your filters.
- `"nextToken"`: The pagination token that indicates the next set of results to retrieve.
"""
function get_free_tier_usage(; aws_config::AbstractAWSConfig=current_aws_config())
    return freetier(
        "GetFreeTierUsage"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_free_tier_usage(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return freetier(
        "GetFreeTierUsage", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

function sign!(aws::AbstractAWSConfig, request::Request; time::DateTime=now(Dates.UTC))
    if request.service in ("sdb", "importexport")
        sign_aws2!(aws, request, time)
    else
        sign_aws4!(aws, request, time)
    end
end

function sign_aws2!(aws::AbstractAWSConfig, request::Request, time::DateTime)
    # Create AWS Signature Version 2 Authentication query parameters.
    # http://docs.aws.amazon.com/general/latest/gr/signature-version-2.html

    query = Dict{String,String}()
    for elem in split(request.content, '&'; keepempty=false)
        (n, v) = split(elem, "=")
        query[n] = HTTP.unescapeuri(v)
    end

    request.headers["Content-Type"] = "application/x-www-form-urlencoded; charset=utf-8"

    creds = check_credentials(credentials(aws))
    query["AWSAccessKeyId"] = creds.access_key_id
    query["Expires"] = Dates.format(
        time + Dates.Minute(2), dateformat"yyyy-mm-dd\THH:MM:SS\Z"
    )
    query["SignatureVersion"] = "2"
    query["SignatureMethod"] = "HmacSHA256"

    if !isempty(creds.token)
        query["SecurityToken"] = creds.token
    end

    query = [k => query[k] for k in sort!(collect(keys(query)))]
    uri = HTTP.URI(request.url)
    to_sign = "POST\n$(uri.host)\n$(uri.path)\n$(HTTP.escapeuri(query))"
    push!(
        query,
        "Signature" => strip(base64encode(digest(MD_SHA256, to_sign, creds.secret_key))),
    )

    request.content = HTTP.escapeuri(query)

    return request
end

function sign_aws4!(aws::AbstractAWSConfig, request::Request, time::DateTime)
    # Create AWS Signature Version 4 Authentication Headers.
    # http://docs.aws.amazon.com/general/latest/gr/signature-version-4.html

    date = Dates.format(time, dateformat"yyyymmdd")
    datetime = Dates.format(time, dateformat"yyyymmdd\THHMMSS\Z")

    # Authentication scope...
    authentication_scope = [date, region(aws), request.service, "aws4_request"]

    creds = check_credentials(credentials(aws))
    signing_key = "AWS4$(creds.secret_key)"

    for scope in authentication_scope
        signing_key = digest(MD_SHA256, scope, signing_key)
    end

    # Authentication scope string...
    authentication_scope = join(authentication_scope, "/")

    # SHA256 hash of content...
    content_hash = bytes2hex(digest(MD_SHA256, request.content))

    # HTTP headers...
    delete!(request.headers, "Authorization")

    merge!(
        request.headers,
        Dict(
            "x-amz-content-sha256" => content_hash,
            "x-amz-date" => datetime,
            "Content-MD5" => base64encode(digest(MD_MD5, request.content)),
        ),
    )

    if !isempty(creds.token)
        request.headers["x-amz-security-token"] = creds.token
    end

    # Sort and lowercase() Headers to produce canonical form...
    canonical_headers = join(
        sort!(["$(lowercase(k)):$(strip(v))" for (k, v) in request.headers]), "\n"
    )
    signed_headers = join(sort!([lowercase(k) for k in keys(request.headers)]), ";")

    # Sort query parameters...
    # Ensure we retain duplicate query parameters when computing the signature
    uri = HTTP.URI(request.url)
    query = HTTP.URIs.queryparampairs(uri.query)
    query = sort!(query)

    # Create hash of canonical request...
    canonical_form = string(
        request.request_method,
        "\n",
        request.service == "s3" ? uri.path : HTTP.escapepath(uri.path),
        "\n",
        HTTP.escapeuri(query),
        "\n",
        canonical_headers,
        "\n\n",
        signed_headers,
        "\n",
        content_hash,
    )

    canonical_hash = bytes2hex(digest(MD_SHA256, canonical_form))

    # Create and sign "String to Sign"...
    string_to_sign = "AWS4-HMAC-SHA256\n$datetime\n$authentication_scope\n$canonical_hash"
    signature = bytes2hex(digest(MD_SHA256, string_to_sign, signing_key))

    # Append Authorization header...
    request.headers["Authorization"] = join(
        [
            "AWS4-HMAC-SHA256 Credential=$(creds.access_key_id)/$authentication_scope",
            "SignedHeaders=$signed_headers",
            "Signature=$signature",
        ],
        ", ",
    )

    return request
end

@testset "AWSException" begin
    function _test_exception(ex::AWSException, expected::AbstractDict, msg::String)
        @test ex.code == expected["code"]
        @test ex.message == ex.info[msg] == expected["message"]
        @test ex.cause.response.body == expected["body"]
        @test ex.cause.status == expected["status_code"]
        @test ex.cause.response.headers == expected["headers"]
        @test ex.streamed_body == expected["streamed_body"]
    end

    cases = [
        ("Error", "message"),
        ("Error", "Message"),
        ("Errors", "message"),
        ("Errors", "Message"),
    ]
    @testset "XMLRequest $err -- $msg" for (err, msg) in cases
        expected = Dict(
            "code" => "NoSuchKey",
            "message" => "The resource you requested does not exist",
            "resource" => "/mybucket/myfoto.jpg",
            "requestId" => "4442587FB7D0A2F9",
            "headers" => ["Content-Type" => "application/xml"],
            "status_code" => 400,
        )

        expected["body"] = IOBuffer()
        expected["streamed_body"] = """
            <?xml version="1.0" encoding="UTF-8"?>
            <$err>
            <Code>$(expected["code"])</Code>
            <$msg>$(expected["message"])</$msg>
            <Resource>$(expected["resource"])</Resource>
            <RequestId>$(expected["requestId"])</RequestId>
            </$err>
            """

        # This does not actually send a request, just creates the object to test with
        req = HTTP.Request("GET", "https://aws.com", expected["headers"], expected["body"])
        resp = HTTP.Response(
            expected["status_code"], expected["headers"]; body=expected["body"], request=req
        )
        status_error = AWS.statuserror(expected["status_code"], resp)
        ex = AWSException(status_error, expected["streamed_body"])

        _test_exception(ex, expected, msg)
        @test ex.info["Resource"] == expected["resource"]
        @test ex.info["RequestId"] == expected["requestId"]
    end

    @testset "XMLRequest - Invalid XML" begin
        expected = Dict(
            "body" => IOBuffer(),
            "streamed_body" => """<?xml version="1.0" encoding="UTF-8"?>InvalidXML""",
            "headers" => ["Content-Type" => "application/xml"],
            "status_code" => 404,
        )
        req = HTTP.Request("GET", "https://aws.com", expected["headers"], expected["body"])
        resp = HTTP.Response(
            expected["status_code"], expected["headers"]; body=expected["body"], request=req
        )
        status_error = AWS.statuserror(expected["status_code"], resp)
        ex = @test_logs (:error,) AWSException(status_error, expected["streamed_body"])

        @test ex.code == "404"
        @test ex.streamed_body == expected["streamed_body"]
    end

    @testset "JSON Request -- $msg" for msg in ["message", "Message"]
        expected = Dict(
            "code" => "InvalidSignatureException",
            "message" => "Signature expired: ...",
            "headers" => ["Content-Type" => "application/x-amz-json-1.1"],
            "status_code" => 400,
        )

        expected["body"] = IOBuffer()
        expected["streamed_body"] = """
            {
            "__type": "$(expected["code"])",
            "$msg": "$(expected["message"])"
            }
            """

        # This does not actually send a request, just creates the object to test with
        req = HTTP.Request("GET", "https://aws.com", expected["headers"], expected["body"])
        resp = HTTP.Response(
            expected["status_code"], expected["headers"]; body=expected["body"], request=req
        )
        status_error = AWS.statuserror(expected["status_code"], resp)
        ex = AWSException(status_error, expected["streamed_body"])

        _test_exception(ex, expected, "$msg")
        @test ex.info["__type"] == expected["code"]
    end

    @testset "JSON requests can have invalid bodies" begin
        expected = Dict(
            "code" => "400",
            "message" => "AWSException",
            "headers" => ["Content-Type" => "application/json"],
            "status_code" => 400,
        )

        expected["body"] = IOBuffer()
        expected["streamed_body"] = "\"foo\""

        # This does not actually send a request, just creates the object to test with
        req = HTTP.Request("GET", "https://aws.com", expected["headers"], expected["body"])
        resp = HTTP.Response(
            expected["status_code"], expected["headers"]; body=expected["body"], request=req
        )
        status_error = AWS.statuserror(expected["status_code"], resp)
        ex = AWSException(status_error, expected["streamed_body"])

        @test ex.code == expected["code"]
        @test ex.info == "foo" # nothing better we can do than just forward the invalid body
        @test ex.message == expected["message"]
        @test ex.cause.response.body == expected["body"]
        @test ex.cause.status == expected["status_code"]
        @test ex.cause.response.headers == expected["headers"]
        @test ex.streamed_body == expected["streamed_body"]
    end
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: migrationhuborchestrator
using AWS.Compat
using AWS.UUIDs

"""
    create_template(template_name, template_source)
    create_template(template_name, template_source, params::Dict{String,<:Any})

Creates a migration workflow template.

# Arguments
- `template_name`: The name of the migration workflow template.
- `template_source`: The source of the migration workflow template.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. For more information, see Idempotency in the Smithy
  documentation.
- `"tags"`: The tags to add to the migration workflow template.
- `"templateDescription"`: A description of the migration workflow template.
"""
function create_template(
    templateName, templateSource; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migrationhuborchestrator(
        "POST",
        "/template",
        Dict{String,Any}(
            "templateName" => templateName,
            "templateSource" => templateSource,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_template(
    templateName,
    templateSource,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migrationhuborchestrator(
        "POST",
        "/template",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "templateName" => templateName,
                    "templateSource" => templateSource,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_workflow(input_parameters, name, template_id)
    create_workflow(input_parameters, name, template_id, params::Dict{String,<:Any})

Create a workflow to orchestrate your migrations.

# Arguments
- `input_parameters`: The input parameters required to create a migration workflow.
- `name`: The name of the migration workflow.
- `template_id`: The ID of the template.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"applicationConfigurationId"`: The configuration ID of the application configured in
  Application Discovery Service.
- `"description"`: The description of the migration workflow.
- `"stepTargets"`: The servers on which a step will be run.
- `"tags"`: The tags to add on a migration workflow.
"""
function create_workflow(
    inputParameters, name, templateId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migrationhuborchestrator(
        "POST",
        "/migrationworkflow/",
        Dict{String,Any}(
            "inputParameters" => inputParameters, "name" => name, "templateId" => templateId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_workflow(
    inputParameters,
    name,
    templateId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migrationhuborchestrator(
        "POST",
        "/migrationworkflow/",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "inputParameters" => inputParameters,
                    "name" => name,
                    "templateId" => templateId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_workflow_step(name, step_action_type, step_group_id, workflow_id)
    create_workflow_step(name, step_action_type, step_group_id, workflow_id, params::Dict{String,<:Any})

Create a step in the migration workflow.

# Arguments
- `name`: The name of the step.
- `step_action_type`: The action type of the step. You must run and update the status of a
  manual step for the workflow to continue after the completion of the step.
- `step_group_id`: The ID of the step group.
- `workflow_id`: The ID of the migration workflow.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description of the step.
- `"next"`: The next step.
- `"outputs"`: The key value pairs added for the expected output.
- `"previous"`: The previous step.
- `"stepTarget"`: The servers on which a step will be run.
- `"workflowStepAutomationConfiguration"`: The custom script to run tests on source or
  target environments.
"""
function create_workflow_step(
    name,
    stepActionType,
    stepGroupId,
    workflowId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migrationhuborchestrator(
        "POST",
        "/workflowstep",
        Dict{String,Any}(
            "name" => name,
            "stepActionType" => stepActionType,
            "stepGroupId" => stepGroupId,
            "workflowId" => workflowId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_workflow_step(
    name,
    stepActionType,
    stepGroupId,
    workflowId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migrationhuborchestrator(
        "POST",
        "/workflowstep",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "name" => name,
                    "stepActionType" => stepActionType,
                    "stepGroupId" => stepGroupId,
                    "workflowId" => workflowId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_workflow_step_group(name, workflow_id)
    create_workflow_step_group(name, workflow_id, params::Dict{String,<:Any})

Create a step group in a migration workflow.

# Arguments
- `name`: The name of the step group.
- `workflow_id`: The ID of the migration workflow that will contain the step group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description of the step group.
- `"next"`: The next step group.
- `"previous"`: The previous step group.
"""
function create_workflow_step_group(
    name, workflowId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migrationhuborchestrator(
        "POST",
        "/workflowstepgroups",
        Dict{String,Any}("name" => name, "workflowId" => workflowId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_workflow_step_group(
    name,
    workflowId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migrationhuborchestrator(
        "POST",
        "/workflowstepgroups",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("name" => name, "workflowId" => workflowId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_template(id)
    delete_template(id, params::Dict{String,<:Any})

Deletes a migration workflow template.

# Arguments
- `id`: The ID of the request to delete a migration workflow template.

"""
function delete_template(id; aws_config::AbstractAWSConfig=current_aws_config())
    return migrationhuborchestrator(
        "DELETE", "/template/$(id)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function delete_template(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migrationhuborchestrator(
        "DELETE",
        "/template/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_workflow(id)
    delete_workflow(id, params::Dict{String,<:Any})

Delete a migration workflow. You must pause a running workflow in Migration Hub
Orchestrator console to delete it.

# Arguments
- `id`: The ID of the migration workflow you want to delete.

"""
function delete_workflow(id; aws_config::AbstractAWSConfig=current_aws_config())
    return migrationhuborchestrator(
        "DELETE",
        "/migrationworkflow/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_workflow(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migrationhuborchestrator(
        "DELETE",
        "/migrationworkflow/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_workflow_step(id, step_group_id, workflow_id)
    delete_workflow_step(id, step_group_id, workflow_id, params::Dict{String,<:Any})

Delete a step in a migration workflow. Pause the workflow to delete a running step.

# Arguments
- `id`: The ID of the step you want to delete.
- `step_group_id`: The ID of the step group that contains the step you want to delete.
- `workflow_id`: The ID of the migration workflow.

"""
function delete_workflow_step(
    id, stepGroupId, workflowId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migrationhuborchestrator(
        "DELETE",
        "/workflowstep/$(id)",
        Dict{String,Any}("stepGroupId" => stepGroupId, "workflowId" => workflowId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_workflow_step(
    id,
    stepGroupId,
    workflowId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migrationhuborchestrator(
        "DELETE",
        "/workflowstep/$(id)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("stepGroupId" => stepGroupId, "workflowId" => workflowId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_workflow_step_group(id, workflow_id)
    delete_workflow_step_group(id, workflow_id, params::Dict{String,<:Any})

Delete a step group in a migration workflow.

# Arguments
- `id`: The ID of the step group you want to delete.
- `workflow_id`: The ID of the migration workflow.

"""
function delete_workflow_step_group(
    id, workflowId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migrationhuborchestrator(
        "DELETE",
        "/workflowstepgroup/$(id)",
        Dict{String,Any}("workflowId" => workflowId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_workflow_step_group(
    id,
    workflowId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migrationhuborchestrator(
        "DELETE",
        "/workflowstepgroup/$(id)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("workflowId" => workflowId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_template(id)
    get_template(id, params::Dict{String,<:Any})

Get the template you want to use for creating a migration workflow.

# Arguments
- `id`: The ID of the template.

"""
function get_template(id; aws_config::AbstractAWSConfig=current_aws_config())
    return migrationhuborchestrator(
        "GET",
        "/migrationworkflowtemplate/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_template(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migrationhuborchestrator(
        "GET",
        "/migrationworkflowtemplate/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_template_step(id, step_group_id, template_id)
    get_template_step(id, step_group_id, template_id, params::Dict{String,<:Any})

Get a specific step in a template.

# Arguments
- `id`: The ID of the step.
- `step_group_id`: The ID of the step group.
- `template_id`: The ID of the template.

"""
function get_template_step(
    id, stepGroupId, templateId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migrationhuborchestrator(
        "GET",
        "/templatestep/$(id)",
        Dict{String,Any}("stepGroupId" => stepGroupId, "templateId" => templateId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_template_step(
    id,
    stepGroupId,
    templateId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migrationhuborchestrator(
        "GET",
        "/templatestep/$(id)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("stepGroupId" => stepGroupId, "templateId" => templateId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_template_step_group(id, template_id)
    get_template_step_group(id, template_id, params::Dict{String,<:Any})

Get a step group in a template.

# Arguments
- `id`: The ID of the step group.
- `template_id`: The ID of the template.

"""
function get_template_step_group(
    id, templateId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migrationhuborchestrator(
        "GET",
        "/templates/$(templateId)/stepgroups/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_template_step_group(
    id,
    templateId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migrationhuborchestrator(
        "GET",
        "/templates/$(templateId)/stepgroups/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_workflow(id)
    get_workflow(id, params::Dict{String,<:Any})

Get migration workflow.

# Arguments
- `id`: The ID of the migration workflow.

"""
function get_workflow(id; aws_config::AbstractAWSConfig=current_aws_config())
    return migrationhuborchestrator(
        "GET",
        "/migrationworkflow/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_workflow(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migrationhuborchestrator(
        "GET",
        "/migrationworkflow/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_workflow_step(id, step_group_id, workflow_id)
    get_workflow_step(id, step_group_id, workflow_id, params::Dict{String,<:Any})

Get a step in the migration workflow.

# Arguments
- `id`: The ID of the step.
- `step_group_id`: The ID of the step group.
- `workflow_id`: The ID of the migration workflow.

"""
function get_workflow_step(
    id, stepGroupId, workflowId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migrationhuborchestrator(
        "GET",
        "/workflowstep/$(id)",
        Dict{String,Any}("stepGroupId" => stepGroupId, "workflowId" => workflowId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_workflow_step(
    id,
    stepGroupId,
    workflowId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migrationhuborchestrator(
        "GET",
        "/workflowstep/$(id)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("stepGroupId" => stepGroupId, "workflowId" => workflowId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_workflow_step_group(id, workflow_id)
    get_workflow_step_group(id, workflow_id, params::Dict{String,<:Any})

Get the step group of a migration workflow.

# Arguments
- `id`: The ID of the step group.
- `workflow_id`: The ID of the migration workflow.

"""
function get_workflow_step_group(
    id, workflowId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migrationhuborchestrator(
        "GET",
        "/workflowstepgroup/$(id)",
        Dict{String,Any}("workflowId" => workflowId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_workflow_step_group(
    id,
    workflowId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migrationhuborchestrator(
        "GET",
        "/workflowstepgroup/$(id)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("workflowId" => workflowId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_plugins()
    list_plugins(params::Dict{String,<:Any})

List AWS Migration Hub Orchestrator plugins.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of plugins that can be returned.
- `"nextToken"`: The pagination token.
"""
function list_plugins(; aws_config::AbstractAWSConfig=current_aws_config())
    return migrationhuborchestrator(
        "GET", "/plugins"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_plugins(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migrationhuborchestrator(
        "GET", "/plugins", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

List the tags added to a resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migrationhuborchestrator(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migrationhuborchestrator(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_template_step_groups(template_id)
    list_template_step_groups(template_id, params::Dict{String,<:Any})

List the step groups in a template.

# Arguments
- `template_id`: The ID of the template.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results that can be returned.
- `"nextToken"`: The pagination token.
"""
function list_template_step_groups(
    templateId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migrationhuborchestrator(
        "GET",
        "/templatestepgroups/$(templateId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_template_step_groups(
    templateId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migrationhuborchestrator(
        "GET",
        "/templatestepgroups/$(templateId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_template_steps(step_group_id, template_id)
    list_template_steps(step_group_id, template_id, params::Dict{String,<:Any})

List the steps in a template.

# Arguments
- `step_group_id`: The ID of the step group.
- `template_id`: The ID of the template.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results that can be returned.
- `"nextToken"`: The pagination token.
"""
function list_template_steps(
    stepGroupId, templateId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migrationhuborchestrator(
        "GET",
        "/templatesteps",
        Dict{String,Any}("stepGroupId" => stepGroupId, "templateId" => templateId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_template_steps(
    stepGroupId,
    templateId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migrationhuborchestrator(
        "GET",
        "/templatesteps",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("stepGroupId" => stepGroupId, "templateId" => templateId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_templates()
    list_templates(params::Dict{String,<:Any})

List the templates available in Migration Hub Orchestrator to create a migration workflow.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results that can be returned.
- `"name"`: The name of the template.
- `"nextToken"`: The pagination token.
"""
function list_templates(; aws_config::AbstractAWSConfig=current_aws_config())
    return migrationhuborchestrator(
        "GET",
        "/migrationworkflowtemplates";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_templates(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migrationhuborchestrator(
        "GET",
        "/migrationworkflowtemplates",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_workflow_step_groups(workflow_id)
    list_workflow_step_groups(workflow_id, params::Dict{String,<:Any})

List the step groups in a migration workflow.

# Arguments
- `workflow_id`: The ID of the migration workflow.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results that can be returned.
- `"nextToken"`: The pagination token.
"""
function list_workflow_step_groups(
    workflowId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migrationhuborchestrator(
        "GET",
        "/workflowstepgroups",
        Dict{String,Any}("workflowId" => workflowId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_workflow_step_groups(
    workflowId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migrationhuborchestrator(
        "GET",
        "/workflowstepgroups",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("workflowId" => workflowId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_workflow_steps(step_group_id, workflow_id)
    list_workflow_steps(step_group_id, workflow_id, params::Dict{String,<:Any})

List the steps in a workflow.

# Arguments
- `step_group_id`: The ID of the step group.
- `workflow_id`: The ID of the migration workflow.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results that can be returned.
- `"nextToken"`: The pagination token.
"""
function list_workflow_steps(
    stepGroupId, workflowId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migrationhuborchestrator(
        "GET",
        "/workflow/$(workflowId)/workflowstepgroups/$(stepGroupId)/workflowsteps";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_workflow_steps(
    stepGroupId,
    workflowId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migrationhuborchestrator(
        "GET",
        "/workflow/$(workflowId)/workflowstepgroups/$(stepGroupId)/workflowsteps",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_workflows()
    list_workflows(params::Dict{String,<:Any})

List the migration workflows.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"adsApplicationConfigurationName"`: The name of the application configured in
  Application Discovery Service.
- `"maxResults"`: The maximum number of results that can be returned.
- `"name"`: The name of the migration workflow.
- `"nextToken"`: The pagination token.
- `"status"`: The status of the migration workflow.
- `"templateId"`: The ID of the template.
"""
function list_workflows(; aws_config::AbstractAWSConfig=current_aws_config())
    return migrationhuborchestrator(
        "GET", "/migrationworkflows"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_workflows(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migrationhuborchestrator(
        "GET",
        "/migrationworkflows",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    retry_workflow_step(id, step_group_id, workflow_id)
    retry_workflow_step(id, step_group_id, workflow_id, params::Dict{String,<:Any})

Retry a failed step in a migration workflow.

# Arguments
- `id`: The ID of the step.
- `step_group_id`: The ID of the step group.
- `workflow_id`: The ID of the migration workflow.

"""
function retry_workflow_step(
    id, stepGroupId, workflowId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migrationhuborchestrator(
        "POST",
        "/retryworkflowstep/$(id)",
        Dict{String,Any}("stepGroupId" => stepGroupId, "workflowId" => workflowId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function retry_workflow_step(
    id,
    stepGroupId,
    workflowId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migrationhuborchestrator(
        "POST",
        "/retryworkflowstep/$(id)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("stepGroupId" => stepGroupId, "workflowId" => workflowId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_workflow(id)
    start_workflow(id, params::Dict{String,<:Any})

Start a migration workflow.

# Arguments
- `id`: The ID of the migration workflow.

"""
function start_workflow(id; aws_config::AbstractAWSConfig=current_aws_config())
    return migrationhuborchestrator(
        "POST",
        "/migrationworkflow/$(id)/start";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_workflow(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migrationhuborchestrator(
        "POST",
        "/migrationworkflow/$(id)/start",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_workflow(id)
    stop_workflow(id, params::Dict{String,<:Any})

Stop an ongoing migration workflow.

# Arguments
- `id`: The ID of the migration workflow.

"""
function stop_workflow(id; aws_config::AbstractAWSConfig=current_aws_config())
    return migrationhuborchestrator(
        "POST",
        "/migrationworkflow/$(id)/stop";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_workflow(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migrationhuborchestrator(
        "POST",
        "/migrationworkflow/$(id)/stop",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Tag a resource by specifying its Amazon Resource Name (ARN).

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource to which you want to add
  tags.
- `tags`: A collection of labels, in the form of key:value pairs, that apply to this
  resource.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return migrationhuborchestrator(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migrationhuborchestrator(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Deletes the tags for a resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource from which you want to
  remove tags.
- `tag_keys`: One or more tag keys. Specify only the tag keys, not the tag values.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migrationhuborchestrator(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migrationhuborchestrator(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_template(id)
    update_template(id, params::Dict{String,<:Any})

Updates a migration workflow template.

# Arguments
- `id`: The ID of the request to update a migration workflow template.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request.
- `"templateDescription"`: The description of the migration workflow template to update.
- `"templateName"`: The name of the migration workflow template to update.
"""
function update_template(id; aws_config::AbstractAWSConfig=current_aws_config())
    return migrationhuborchestrator(
        "POST",
        "/template/$(id)",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_template(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migrationhuborchestrator(
        "POST",
        "/template/$(id)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_workflow(id)
    update_workflow(id, params::Dict{String,<:Any})

Update a migration workflow.

# Arguments
- `id`: The ID of the migration workflow.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description of the migration workflow.
- `"inputParameters"`: The input parameters required to update a migration workflow.
- `"name"`: The name of the migration workflow.
- `"stepTargets"`: The servers on which a step will be run.
"""
function update_workflow(id; aws_config::AbstractAWSConfig=current_aws_config())
    return migrationhuborchestrator(
        "POST",
        "/migrationworkflow/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_workflow(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migrationhuborchestrator(
        "POST",
        "/migrationworkflow/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_workflow_step(id, step_group_id, workflow_id)
    update_workflow_step(id, step_group_id, workflow_id, params::Dict{String,<:Any})

Update a step in a migration workflow.

# Arguments
- `id`: The ID of the step.
- `step_group_id`: The ID of the step group.
- `workflow_id`: The ID of the migration workflow.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description of the step.
- `"name"`: The name of the step.
- `"next"`: The next step.
- `"outputs"`: The outputs of a step.
- `"previous"`: The previous step.
- `"status"`: The status of the step.
- `"stepActionType"`: The action type of the step. You must run and update the status of a
  manual step for the workflow to continue after the completion of the step.
- `"stepTarget"`: The servers on which a step will be run.
- `"workflowStepAutomationConfiguration"`: The custom script to run tests on the source and
  target environments.
"""
function update_workflow_step(
    id, stepGroupId, workflowId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migrationhuborchestrator(
        "POST",
        "/workflowstep/$(id)",
        Dict{String,Any}("stepGroupId" => stepGroupId, "workflowId" => workflowId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_workflow_step(
    id,
    stepGroupId,
    workflowId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migrationhuborchestrator(
        "POST",
        "/workflowstep/$(id)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("stepGroupId" => stepGroupId, "workflowId" => workflowId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_workflow_step_group(id, workflow_id)
    update_workflow_step_group(id, workflow_id, params::Dict{String,<:Any})

Update the step group in a migration workflow.

# Arguments
- `id`: The ID of the step group.
- `workflow_id`: The ID of the migration workflow.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description of the step group.
- `"name"`: The name of the step group.
- `"next"`: The next step group.
- `"previous"`: The previous step group.
"""
function update_workflow_step_group(
    id, workflowId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migrationhuborchestrator(
        "POST",
        "/workflowstepgroup/$(id)",
        Dict{String,Any}("workflowId" => workflowId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_workflow_step_group(
    id,
    workflowId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migrationhuborchestrator(
        "POST",
        "/workflowstepgroup/$(id)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("workflowId" => workflowId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: codedeploy
using AWS.Compat
using AWS.UUIDs

"""
    add_tags_to_on_premises_instances(instance_names, tags)
    add_tags_to_on_premises_instances(instance_names, tags, params::Dict{String,<:Any})

Adds tags to on-premises instances.

# Arguments
- `instance_names`: The names of the on-premises instances to which to add tags.
- `tags`: The tag key-value pairs to add to the on-premises instances. Keys and values are
  both required. Keys cannot be null or empty strings. Value-only tags are not allowed.

"""
function add_tags_to_on_premises_instances(
    instanceNames, tags; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codedeploy(
        "AddTagsToOnPremisesInstances",
        Dict{String,Any}("instanceNames" => instanceNames, "tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_tags_to_on_premises_instances(
    instanceNames,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codedeploy(
        "AddTagsToOnPremisesInstances",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("instanceNames" => instanceNames, "tags" => tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_get_application_revisions(application_name, revisions)
    batch_get_application_revisions(application_name, revisions, params::Dict{String,<:Any})

Gets information about one or more application revisions. The maximum number of application
revisions that can be returned is 25.

# Arguments
- `application_name`: The name of an CodeDeploy application about which to get revision
  information.
- `revisions`: An array of RevisionLocation objects that specify information to get about
  the application revisions, including type and location. The maximum number of
  RevisionLocation objects you can specify is 25.

"""
function batch_get_application_revisions(
    applicationName, revisions; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codedeploy(
        "BatchGetApplicationRevisions",
        Dict{String,Any}("applicationName" => applicationName, "revisions" => revisions);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_application_revisions(
    applicationName,
    revisions,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codedeploy(
        "BatchGetApplicationRevisions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "applicationName" => applicationName, "revisions" => revisions
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_get_applications(application_names)
    batch_get_applications(application_names, params::Dict{String,<:Any})

Gets information about one or more applications. The maximum number of applications that
can be returned is 100.

# Arguments
- `application_names`: A list of application names separated by spaces. The maximum number
  of application names you can specify is 100.

"""
function batch_get_applications(
    applicationNames; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codedeploy(
        "BatchGetApplications",
        Dict{String,Any}("applicationNames" => applicationNames);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_applications(
    applicationNames,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codedeploy(
        "BatchGetApplications",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("applicationNames" => applicationNames), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_get_deployment_groups(application_name, deployment_group_names)
    batch_get_deployment_groups(application_name, deployment_group_names, params::Dict{String,<:Any})

Gets information about one or more deployment groups.

# Arguments
- `application_name`: The name of an CodeDeploy application associated with the applicable
  user or Amazon Web Services account.
- `deployment_group_names`: The names of the deployment groups.

"""
function batch_get_deployment_groups(
    applicationName,
    deploymentGroupNames;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codedeploy(
        "BatchGetDeploymentGroups",
        Dict{String,Any}(
            "applicationName" => applicationName,
            "deploymentGroupNames" => deploymentGroupNames,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_deployment_groups(
    applicationName,
    deploymentGroupNames,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codedeploy(
        "BatchGetDeploymentGroups",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "applicationName" => applicationName,
                    "deploymentGroupNames" => deploymentGroupNames,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_get_deployment_instances(deployment_id, instance_ids)
    batch_get_deployment_instances(deployment_id, instance_ids, params::Dict{String,<:Any})

  This method works, but is deprecated. Use BatchGetDeploymentTargets instead.    Returns
an array of one or more instances associated with a deployment. This method works with
EC2/On-premises and Lambda compute platforms. The newer BatchGetDeploymentTargets works
with all compute platforms. The maximum number of instances that can be returned is 25.

# Arguments
- `deployment_id`:  The unique ID of a deployment.
- `instance_ids`: The unique IDs of instances used in the deployment. The maximum number of
  instance IDs you can specify is 25.

"""
function batch_get_deployment_instances(
    deploymentId, instanceIds; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codedeploy(
        "BatchGetDeploymentInstances",
        Dict{String,Any}("deploymentId" => deploymentId, "instanceIds" => instanceIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_deployment_instances(
    deploymentId,
    instanceIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codedeploy(
        "BatchGetDeploymentInstances",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "deploymentId" => deploymentId, "instanceIds" => instanceIds
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_get_deployment_targets(deployment_id, target_ids)
    batch_get_deployment_targets(deployment_id, target_ids, params::Dict{String,<:Any})

 Returns an array of one or more targets associated with a deployment. This method works
with all compute types and should be used instead of the deprecated
BatchGetDeploymentInstances. The maximum number of targets that can be returned is 25.  The
type of targets returned depends on the deployment's compute platform or deployment method:
    EC2/On-premises: Information about Amazon EC2 instance targets.     Lambda: Information
about Lambda functions targets.     Amazon ECS: Information about Amazon ECS service
targets.     CloudFormation: Information about targets of blue/green deployments initiated
by a CloudFormation stack update.

# Arguments
- `deployment_id`:  The unique ID of a deployment.
- `target_ids`:  The unique IDs of the deployment targets. The compute platform of the
  deployment determines the type of the targets and their formats. The maximum number of
  deployment target IDs you can specify is 25.    For deployments that use the
  EC2/On-premises compute platform, the target IDs are Amazon EC2 or on-premises instances
  IDs, and their target type is instanceTarget.     For deployments that use the Lambda
  compute platform, the target IDs are the names of Lambda functions, and their target type
  is instanceTarget.     For deployments that use the Amazon ECS compute platform, the target
  IDs are pairs of Amazon ECS clusters and services specified using the format
  &lt;clustername&gt;:&lt;servicename&gt;. Their target type is ecsTarget.     For
  deployments that are deployed with CloudFormation, the target IDs are CloudFormation stack
  IDs. Their target type is cloudFormationTarget.

"""
function batch_get_deployment_targets(
    deploymentId, targetIds; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codedeploy(
        "BatchGetDeploymentTargets",
        Dict{String,Any}("deploymentId" => deploymentId, "targetIds" => targetIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_deployment_targets(
    deploymentId,
    targetIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codedeploy(
        "BatchGetDeploymentTargets",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("deploymentId" => deploymentId, "targetIds" => targetIds),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_get_deployments(deployment_ids)
    batch_get_deployments(deployment_ids, params::Dict{String,<:Any})

Gets information about one or more deployments. The maximum number of deployments that can
be returned is 25.

# Arguments
- `deployment_ids`:  A list of deployment IDs, separated by spaces. The maximum number of
  deployment IDs you can specify is 25.

"""
function batch_get_deployments(
    deploymentIds; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codedeploy(
        "BatchGetDeployments",
        Dict{String,Any}("deploymentIds" => deploymentIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_deployments(
    deploymentIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codedeploy(
        "BatchGetDeployments",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("deploymentIds" => deploymentIds), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_get_on_premises_instances(instance_names)
    batch_get_on_premises_instances(instance_names, params::Dict{String,<:Any})

Gets information about one or more on-premises instances. The maximum number of on-premises
instances that can be returned is 25.

# Arguments
- `instance_names`: The names of the on-premises instances about which to get information.
  The maximum number of instance names you can specify is 25.

"""
function batch_get_on_premises_instances(
    instanceNames; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codedeploy(
        "BatchGetOnPremisesInstances",
        Dict{String,Any}("instanceNames" => instanceNames);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_on_premises_instances(
    instanceNames,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codedeploy(
        "BatchGetOnPremisesInstances",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("instanceNames" => instanceNames), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    continue_deployment()
    continue_deployment(params::Dict{String,<:Any})

For a blue/green deployment, starts the process of rerouting traffic from instances in the
original environment to instances in the replacement environment without waiting for a
specified wait time to elapse. (Traffic rerouting, which is achieved by registering
instances in the replacement environment with the load balancer, can start as soon as all
instances have a status of Ready.)

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"deploymentId"`:  The unique ID of a blue/green deployment for which you want to start
  rerouting traffic to the replacement environment.
- `"deploymentWaitType"`:  The status of the deployment's waiting period. READY_WAIT
  indicates that the deployment is ready to start shifting traffic. TERMINATION_WAIT
  indicates that the traffic is shifted, but the original target is not terminated.
"""
function continue_deployment(; aws_config::AbstractAWSConfig=current_aws_config())
    return codedeploy(
        "ContinueDeployment"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function continue_deployment(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codedeploy(
        "ContinueDeployment", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    create_application(application_name)
    create_application(application_name, params::Dict{String,<:Any})

Creates an application.

# Arguments
- `application_name`: The name of the application. This name must be unique with the
  applicable user or Amazon Web Services account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"computePlatform"`:  The destination platform type for the deployment (Lambda, Server,
  or ECS).
- `"tags"`:  The metadata that you apply to CodeDeploy applications to help you organize
  and categorize them. Each tag consists of a key and an optional value, both of which you
  define.
"""
function create_application(
    applicationName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codedeploy(
        "CreateApplication",
        Dict{String,Any}("applicationName" => applicationName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_application(
    applicationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codedeploy(
        "CreateApplication",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("applicationName" => applicationName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_deployment(application_name)
    create_deployment(application_name, params::Dict{String,<:Any})

Deploys an application revision through the specified deployment group.

# Arguments
- `application_name`: The name of an CodeDeploy application associated with the user or
  Amazon Web Services account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"autoRollbackConfiguration"`: Configuration information for an automatic rollback that
  is added when a deployment is created.
- `"deploymentConfigName"`: The name of a deployment configuration associated with the user
  or Amazon Web Services account. If not specified, the value configured in the deployment
  group is used as the default. If the deployment group does not have a deployment
  configuration associated with it, CodeDeployDefault.OneAtATime is used by default.
- `"deploymentGroupName"`: The name of the deployment group.
- `"description"`: A comment about the deployment.
- `"fileExistsBehavior"`: Information about how CodeDeploy handles files that already exist
  in a deployment target location but weren't part of the previous successful deployment. The
  fileExistsBehavior parameter takes any of the following values:   DISALLOW: The deployment
  fails. This is also the default behavior if no option is specified.   OVERWRITE: The
  version of the file from the application revision currently being deployed replaces the
  version already on the instance.   RETAIN: The version of the file already on the instance
  is kept and used as part of the new deployment.
- `"ignoreApplicationStopFailures"`:  If true, then if an ApplicationStop,
  BeforeBlockTraffic, or AfterBlockTraffic deployment lifecycle event to an instance fails,
  then the deployment continues to the next deployment lifecycle event. For example, if
  ApplicationStop fails, the deployment continues with DownloadBundle. If BeforeBlockTraffic
  fails, the deployment continues with BlockTraffic. If AfterBlockTraffic fails, the
  deployment continues with ApplicationStop.   If false or not specified, then if a lifecycle
  event fails during a deployment to an instance, that deployment fails. If deployment to
  that instance is part of an overall deployment and the number of healthy hosts is not less
  than the minimum number of healthy hosts, then a deployment to the next instance is
  attempted.   During a deployment, the CodeDeploy agent runs the scripts specified for
  ApplicationStop, BeforeBlockTraffic, and AfterBlockTraffic in the AppSpec file from the
  previous successful deployment. (All other scripts are run from the AppSpec file in the
  current deployment.) If one of these scripts contains an error and does not run
  successfully, the deployment can fail.   If the cause of the failure is a script from the
  last successful deployment that will never run successfully, create a new deployment and
  use ignoreApplicationStopFailures to specify that the ApplicationStop, BeforeBlockTraffic,
  and AfterBlockTraffic failures should be ignored.
- `"overrideAlarmConfiguration"`: Allows you to specify information about alarms associated
  with a deployment. The alarm configuration that you specify here will override the alarm
  configuration at the deployment group level. Consider overriding the alarm configuration if
  you have set up alarms at the deployment group level that are causing deployment failures.
  In this case, you would call CreateDeployment to create a new deployment that uses a
  previous application revision that is known to work, and set its alarm configuration to
  turn off alarm polling. Turning off alarm polling ensures that the new deployment proceeds
  without being blocked by the alarm that was generated by the previous, failed, deployment.
  If you specify an overrideAlarmConfiguration, you need the UpdateDeploymentGroup IAM
  permission when calling CreateDeployment.
- `"revision"`:  The type and location of the revision to deploy.
- `"targetInstances"`:  Information about the instances that belong to the replacement
  environment in a blue/green deployment.
- `"updateOutdatedInstancesOnly"`:  Indicates whether to deploy to all instances or only to
  instances that are not running the latest application revision.
"""
function create_deployment(
    applicationName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codedeploy(
        "CreateDeployment",
        Dict{String,Any}("applicationName" => applicationName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_deployment(
    applicationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codedeploy(
        "CreateDeployment",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("applicationName" => applicationName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_deployment_config(deployment_config_name)
    create_deployment_config(deployment_config_name, params::Dict{String,<:Any})

 Creates a deployment configuration.

# Arguments
- `deployment_config_name`: The name of the deployment configuration to create.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"computePlatform"`: The destination platform type for the deployment (Lambda, Server, or
  ECS).
- `"minimumHealthyHosts"`: The minimum number of healthy instances that should be available
  at any time during the deployment. There are two parameters expected in the input: type and
  value. The type parameter takes either of the following values:   HOST_COUNT: The value
  parameter represents the minimum number of healthy instances as an absolute value.
  FLEET_PERCENT: The value parameter represents the minimum number of healthy instances as a
  percentage of the total number of instances in the deployment. If you specify
  FLEET_PERCENT, at the start of the deployment, CodeDeploy converts the percentage to the
  equivalent number of instances and rounds up fractional instances.   The value parameter
  takes an integer. For example, to set a minimum of 95% healthy instance, specify a type of
  FLEET_PERCENT and a value of 95.
- `"trafficRoutingConfig"`: The configuration that specifies how the deployment traffic is
  routed.
- `"zonalConfig"`: Configure the ZonalConfig object if you want CodeDeploy to deploy your
  application to one Availability Zone at a time, within an Amazon Web Services Region. For
  more information about the zonal configuration feature, see zonal configuration in the
  CodeDeploy User Guide.
"""
function create_deployment_config(
    deploymentConfigName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codedeploy(
        "CreateDeploymentConfig",
        Dict{String,Any}("deploymentConfigName" => deploymentConfigName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_deployment_config(
    deploymentConfigName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codedeploy(
        "CreateDeploymentConfig",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("deploymentConfigName" => deploymentConfigName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_deployment_group(application_name, deployment_group_name, service_role_arn)
    create_deployment_group(application_name, deployment_group_name, service_role_arn, params::Dict{String,<:Any})

Creates a deployment group to which application revisions are deployed.

# Arguments
- `application_name`: The name of an CodeDeploy application associated with the user or
  Amazon Web Services account.
- `deployment_group_name`: The name of a new deployment group for the specified application.
- `service_role_arn`: A service role Amazon Resource Name (ARN) that allows CodeDeploy to
  act on the user's behalf when interacting with Amazon Web Services services.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"alarmConfiguration"`: Information to add about Amazon CloudWatch alarms when the
  deployment group is created.
- `"autoRollbackConfiguration"`: Configuration information for an automatic rollback that
  is added when a deployment group is created.
- `"autoScalingGroups"`: A list of associated Amazon EC2 Auto Scaling groups.
- `"blueGreenDeploymentConfiguration"`: Information about blue/green deployment options for
  a deployment group.
- `"deploymentConfigName"`: If specified, the deployment configuration name can be either
  one of the predefined configurations provided with CodeDeploy or a custom deployment
  configuration that you create by calling the create deployment configuration operation.
  CodeDeployDefault.OneAtATime is the default deployment configuration. It is used if a
  configuration isn't specified for the deployment or deployment group. For more information
  about the predefined deployment configurations in CodeDeploy, see Working with Deployment
  Configurations in CodeDeploy in the CodeDeploy User Guide.
- `"deploymentStyle"`: Information about the type of deployment, in-place or blue/green,
  that you want to run and whether to route deployment traffic behind a load balancer.
- `"ec2TagFilters"`: The Amazon EC2 tags on which to filter. The deployment group includes
  Amazon EC2 instances with any of the specified tags. Cannot be used in the same call as
  ec2TagSet.
- `"ec2TagSet"`: Information about groups of tags applied to Amazon EC2 instances. The
  deployment group includes only Amazon EC2 instances identified by all the tag groups.
  Cannot be used in the same call as ec2TagFilters.
- `"ecsServices"`:  The target Amazon ECS services in the deployment group. This applies
  only to deployment groups that use the Amazon ECS compute platform. A target Amazon ECS
  service is specified as an Amazon ECS cluster and service name pair using the format
  &lt;clustername&gt;:&lt;servicename&gt;.
- `"loadBalancerInfo"`: Information about the load balancer used in a deployment.
- `"onPremisesInstanceTagFilters"`: The on-premises instance tags on which to filter. The
  deployment group includes on-premises instances with any of the specified tags. Cannot be
  used in the same call as OnPremisesTagSet.
- `"onPremisesTagSet"`: Information about groups of tags applied to on-premises instances.
  The deployment group includes only on-premises instances identified by all of the tag
  groups. Cannot be used in the same call as onPremisesInstanceTagFilters.
- `"outdatedInstancesStrategy"`: Indicates what happens when new Amazon EC2 instances are
  launched mid-deployment and do not receive the deployed application revision. If this
  option is set to UPDATE or is unspecified, CodeDeploy initiates one or more 'auto-update
  outdated instances' deployments to apply the deployed application revision to the new
  Amazon EC2 instances. If this option is set to IGNORE, CodeDeploy does not initiate a
  deployment to update the new Amazon EC2 instances. This may result in instances having
  different revisions.
- `"tags"`:  The metadata that you apply to CodeDeploy deployment groups to help you
  organize and categorize them. Each tag consists of a key and an optional value, both of
  which you define.
- `"terminationHookEnabled"`: This parameter only applies if you are using CodeDeploy with
  Amazon EC2 Auto Scaling. For more information, see Integrating CodeDeploy with Amazon EC2
  Auto Scaling in the CodeDeploy User Guide. Set terminationHookEnabled to true to have
  CodeDeploy install a termination hook into your Auto Scaling group when you create a
  deployment group. When this hook is installed, CodeDeploy will perform termination
  deployments. For information about termination deployments, see Enabling termination
  deployments during Auto Scaling scale-in events in the CodeDeploy User Guide. For more
  information about Auto Scaling scale-in events, see the Scale in topic in the Amazon EC2
  Auto Scaling User Guide.
- `"triggerConfigurations"`: Information about triggers to create when the deployment group
  is created. For examples, see Create a Trigger for an CodeDeploy Event in the CodeDeploy
  User Guide.
"""
function create_deployment_group(
    applicationName,
    deploymentGroupName,
    serviceRoleArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codedeploy(
        "CreateDeploymentGroup",
        Dict{String,Any}(
            "applicationName" => applicationName,
            "deploymentGroupName" => deploymentGroupName,
            "serviceRoleArn" => serviceRoleArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_deployment_group(
    applicationName,
    deploymentGroupName,
    serviceRoleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codedeploy(
        "CreateDeploymentGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "applicationName" => applicationName,
                    "deploymentGroupName" => deploymentGroupName,
                    "serviceRoleArn" => serviceRoleArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_application(application_name)
    delete_application(application_name, params::Dict{String,<:Any})

Deletes an application.

# Arguments
- `application_name`: The name of an CodeDeploy application associated with the user or
  Amazon Web Services account.

"""
function delete_application(
    applicationName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codedeploy(
        "DeleteApplication",
        Dict{String,Any}("applicationName" => applicationName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_application(
    applicationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codedeploy(
        "DeleteApplication",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("applicationName" => applicationName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_deployment_config(deployment_config_name)
    delete_deployment_config(deployment_config_name, params::Dict{String,<:Any})

Deletes a deployment configuration.  A deployment configuration cannot be deleted if it is
currently in use. Predefined configurations cannot be deleted.

# Arguments
- `deployment_config_name`: The name of a deployment configuration associated with the user
  or Amazon Web Services account.

"""
function delete_deployment_config(
    deploymentConfigName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codedeploy(
        "DeleteDeploymentConfig",
        Dict{String,Any}("deploymentConfigName" => deploymentConfigName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_deployment_config(
    deploymentConfigName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codedeploy(
        "DeleteDeploymentConfig",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("deploymentConfigName" => deploymentConfigName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_deployment_group(application_name, deployment_group_name)
    delete_deployment_group(application_name, deployment_group_name, params::Dict{String,<:Any})

Deletes a deployment group.

# Arguments
- `application_name`: The name of an CodeDeploy application associated with the user or
  Amazon Web Services account.
- `deployment_group_name`: The name of a deployment group for the specified application.

"""
function delete_deployment_group(
    applicationName, deploymentGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codedeploy(
        "DeleteDeploymentGroup",
        Dict{String,Any}(
            "applicationName" => applicationName,
            "deploymentGroupName" => deploymentGroupName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_deployment_group(
    applicationName,
    deploymentGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codedeploy(
        "DeleteDeploymentGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "applicationName" => applicationName,
                    "deploymentGroupName" => deploymentGroupName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_git_hub_account_token()
    delete_git_hub_account_token(params::Dict{String,<:Any})

Deletes a GitHub account connection.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tokenName"`: The name of the GitHub account connection to delete.
"""
function delete_git_hub_account_token(; aws_config::AbstractAWSConfig=current_aws_config())
    return codedeploy(
        "DeleteGitHubAccountToken"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function delete_git_hub_account_token(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codedeploy(
        "DeleteGitHubAccountToken",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_resources_by_external_id()
    delete_resources_by_external_id(params::Dict{String,<:Any})

Deletes resources linked to an external ID. This action only applies if you have configured
blue/green deployments through CloudFormation.   It is not necessary to call this action
directly. CloudFormation calls it on your behalf when it needs to delete stack resources.
This action is offered publicly in case you need to delete resources to comply with General
Data Protection Regulation (GDPR) requirements.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"externalId"`: The unique ID of an external resource (for example, a CloudFormation
  stack ID) that is linked to one or more CodeDeploy resources.
"""
function delete_resources_by_external_id(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return codedeploy(
        "DeleteResourcesByExternalId";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_resources_by_external_id(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codedeploy(
        "DeleteResourcesByExternalId",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    deregister_on_premises_instance(instance_name)
    deregister_on_premises_instance(instance_name, params::Dict{String,<:Any})

Deregisters an on-premises instance.

# Arguments
- `instance_name`: The name of the on-premises instance to deregister.

"""
function deregister_on_premises_instance(
    instanceName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codedeploy(
        "DeregisterOnPremisesInstance",
        Dict{String,Any}("instanceName" => instanceName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function deregister_on_premises_instance(
    instanceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codedeploy(
        "DeregisterOnPremisesInstance",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("instanceName" => instanceName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_application(application_name)
    get_application(application_name, params::Dict{String,<:Any})

Gets information about an application.

# Arguments
- `application_name`: The name of an CodeDeploy application associated with the user or
  Amazon Web Services account.

"""
function get_application(
    applicationName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codedeploy(
        "GetApplication",
        Dict{String,Any}("applicationName" => applicationName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_application(
    applicationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codedeploy(
        "GetApplication",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("applicationName" => applicationName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_application_revision(application_name, revision)
    get_application_revision(application_name, revision, params::Dict{String,<:Any})

Gets information about an application revision.

# Arguments
- `application_name`: The name of the application that corresponds to the revision.
- `revision`: Information about the application revision to get, including type and
  location.

"""
function get_application_revision(
    applicationName, revision; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codedeploy(
        "GetApplicationRevision",
        Dict{String,Any}("applicationName" => applicationName, "revision" => revision);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_application_revision(
    applicationName,
    revision,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codedeploy(
        "GetApplicationRevision",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "applicationName" => applicationName, "revision" => revision
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_deployment(deployment_id)
    get_deployment(deployment_id, params::Dict{String,<:Any})

Gets information about a deployment.   The content property of the appSpecContent object in
the returned revision is always null. Use GetApplicationRevision and the sha256 property of
the returned appSpecContent object to get the content of the deployment’s AppSpec file.

# Arguments
- `deployment_id`:  The unique ID of a deployment associated with the user or Amazon Web
  Services account.

"""
function get_deployment(deploymentId; aws_config::AbstractAWSConfig=current_aws_config())
    return codedeploy(
        "GetDeployment",
        Dict{String,Any}("deploymentId" => deploymentId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_deployment(
    deploymentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codedeploy(
        "GetDeployment",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("deploymentId" => deploymentId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_deployment_config(deployment_config_name)
    get_deployment_config(deployment_config_name, params::Dict{String,<:Any})

Gets information about a deployment configuration.

# Arguments
- `deployment_config_name`: The name of a deployment configuration associated with the user
  or Amazon Web Services account.

"""
function get_deployment_config(
    deploymentConfigName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codedeploy(
        "GetDeploymentConfig",
        Dict{String,Any}("deploymentConfigName" => deploymentConfigName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_deployment_config(
    deploymentConfigName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codedeploy(
        "GetDeploymentConfig",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("deploymentConfigName" => deploymentConfigName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_deployment_group(application_name, deployment_group_name)
    get_deployment_group(application_name, deployment_group_name, params::Dict{String,<:Any})

Gets information about a deployment group.

# Arguments
- `application_name`: The name of an CodeDeploy application associated with the user or
  Amazon Web Services account.
- `deployment_group_name`: The name of a deployment group for the specified application.

"""
function get_deployment_group(
    applicationName, deploymentGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codedeploy(
        "GetDeploymentGroup",
        Dict{String,Any}(
            "applicationName" => applicationName,
            "deploymentGroupName" => deploymentGroupName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_deployment_group(
    applicationName,
    deploymentGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codedeploy(
        "GetDeploymentGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "applicationName" => applicationName,
                    "deploymentGroupName" => deploymentGroupName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_deployment_instance(deployment_id, instance_id)
    get_deployment_instance(deployment_id, instance_id, params::Dict{String,<:Any})

Gets information about an instance as part of a deployment.

# Arguments
- `deployment_id`:  The unique ID of a deployment.
- `instance_id`:  The unique ID of an instance in the deployment group.

"""
function get_deployment_instance(
    deploymentId, instanceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codedeploy(
        "GetDeploymentInstance",
        Dict{String,Any}("deploymentId" => deploymentId, "instanceId" => instanceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_deployment_instance(
    deploymentId,
    instanceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codedeploy(
        "GetDeploymentInstance",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "deploymentId" => deploymentId, "instanceId" => instanceId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_deployment_target(deployment_id, target_id)
    get_deployment_target(deployment_id, target_id, params::Dict{String,<:Any})

 Returns information about a deployment target.

# Arguments
- `deployment_id`:  The unique ID of a deployment.
- `target_id`:  The unique ID of a deployment target.

"""
function get_deployment_target(
    deploymentId, targetId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codedeploy(
        "GetDeploymentTarget",
        Dict{String,Any}("deploymentId" => deploymentId, "targetId" => targetId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_deployment_target(
    deploymentId,
    targetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codedeploy(
        "GetDeploymentTarget",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("deploymentId" => deploymentId, "targetId" => targetId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_on_premises_instance(instance_name)
    get_on_premises_instance(instance_name, params::Dict{String,<:Any})

 Gets information about an on-premises instance.

# Arguments
- `instance_name`:  The name of the on-premises instance about which to get information.

"""
function get_on_premises_instance(
    instanceName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codedeploy(
        "GetOnPremisesInstance",
        Dict{String,Any}("instanceName" => instanceName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_on_premises_instance(
    instanceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codedeploy(
        "GetOnPremisesInstance",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("instanceName" => instanceName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_application_revisions(application_name)
    list_application_revisions(application_name, params::Dict{String,<:Any})

Lists information about revisions for an application.

# Arguments
- `application_name`:  The name of an CodeDeploy application associated with the user or
  Amazon Web Services account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"deployed"`:  Whether to list revisions based on whether the revision is the target
  revision of a deployment group:     include: List revisions that are target revisions of a
  deployment group.    exclude: Do not list revisions that are target revisions of a
  deployment group.    ignore: List all revisions.
- `"nextToken"`: An identifier returned from the previous ListApplicationRevisions call. It
  can be used to return the next set of applications in the list.
- `"s3Bucket"`:  An Amazon S3 bucket name to limit the search for revisions.   If set to
  null, all of the user's buckets are searched.
- `"s3KeyPrefix"`:  A key prefix for the set of Amazon S3 objects to limit the search for
  revisions.
- `"sortBy"`: The column name to use to sort the list results:    registerTime: Sort by the
  time the revisions were registered with CodeDeploy.    firstUsedTime: Sort by the time the
  revisions were first used in a deployment.    lastUsedTime: Sort by the time the revisions
  were last used in a deployment.    If not specified or set to null, the results are
  returned in an arbitrary order.
- `"sortOrder"`:  The order in which to sort the list results:     ascending: ascending
  order.    descending: descending order.   If not specified, the results are sorted in
  ascending order. If set to null, the results are sorted in an arbitrary order.
"""
function list_application_revisions(
    applicationName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codedeploy(
        "ListApplicationRevisions",
        Dict{String,Any}("applicationName" => applicationName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_application_revisions(
    applicationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codedeploy(
        "ListApplicationRevisions",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("applicationName" => applicationName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_applications()
    list_applications(params::Dict{String,<:Any})

Lists the applications registered with the user or Amazon Web Services account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: An identifier returned from the previous list applications call. It can be
  used to return the next set of applications in the list.
"""
function list_applications(; aws_config::AbstractAWSConfig=current_aws_config())
    return codedeploy(
        "ListApplications"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_applications(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codedeploy(
        "ListApplications", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_deployment_configs()
    list_deployment_configs(params::Dict{String,<:Any})

Lists the deployment configurations with the user or Amazon Web Services account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: An identifier returned from the previous ListDeploymentConfigs call. It
  can be used to return the next set of deployment configurations in the list.
"""
function list_deployment_configs(; aws_config::AbstractAWSConfig=current_aws_config())
    return codedeploy(
        "ListDeploymentConfigs"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_deployment_configs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codedeploy(
        "ListDeploymentConfigs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_deployment_groups(application_name)
    list_deployment_groups(application_name, params::Dict{String,<:Any})

Lists the deployment groups for an application registered with the Amazon Web Services user
or Amazon Web Services account.

# Arguments
- `application_name`: The name of an CodeDeploy application associated with the user or
  Amazon Web Services account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: An identifier returned from the previous list deployment groups call. It
  can be used to return the next set of deployment groups in the list.
"""
function list_deployment_groups(
    applicationName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codedeploy(
        "ListDeploymentGroups",
        Dict{String,Any}("applicationName" => applicationName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_deployment_groups(
    applicationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codedeploy(
        "ListDeploymentGroups",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("applicationName" => applicationName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_deployment_instances(deployment_id)
    list_deployment_instances(deployment_id, params::Dict{String,<:Any})

  The newer BatchGetDeploymentTargets should be used instead because it works with all
compute types. ListDeploymentInstances throws an exception if it is used with a compute
platform other than EC2/On-premises or Lambda.    Lists the instance for a deployment
associated with the user or Amazon Web Services account.

# Arguments
- `deployment_id`:  The unique ID of a deployment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"instanceStatusFilter"`: A subset of instances to list by status:    Pending: Include
  those instances with pending deployments.    InProgress: Include those instances where
  deployments are still in progress.    Succeeded: Include those instances with successful
  deployments.    Failed: Include those instances with failed deployments.    Skipped:
  Include those instances with skipped deployments.    Unknown: Include those instances with
  deployments in an unknown state.
- `"instanceTypeFilter"`: The set of instances in a blue/green deployment, either those in
  the original environment (\"BLUE\") or those in the replacement environment (\"GREEN\"),
  for which you want to view instance information.
- `"nextToken"`: An identifier returned from the previous list deployment instances call.
  It can be used to return the next set of deployment instances in the list.
"""
function list_deployment_instances(
    deploymentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codedeploy(
        "ListDeploymentInstances",
        Dict{String,Any}("deploymentId" => deploymentId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_deployment_instances(
    deploymentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codedeploy(
        "ListDeploymentInstances",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("deploymentId" => deploymentId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_deployment_targets(deployment_id)
    list_deployment_targets(deployment_id, params::Dict{String,<:Any})

 Returns an array of target IDs that are associated a deployment.

# Arguments
- `deployment_id`:  The unique ID of a deployment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`:  A token identifier returned from the previous ListDeploymentTargets call.
  It can be used to return the next set of deployment targets in the list.
- `"targetFilters"`:  A key used to filter the returned targets. The two valid values are:
    TargetStatus - A TargetStatus filter string can be Failed, InProgress, Pending, Ready,
  Skipped, Succeeded, or Unknown.     ServerInstanceLabel - A ServerInstanceLabel filter
  string can be Blue or Green.
"""
function list_deployment_targets(
    deploymentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codedeploy(
        "ListDeploymentTargets",
        Dict{String,Any}("deploymentId" => deploymentId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_deployment_targets(
    deploymentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codedeploy(
        "ListDeploymentTargets",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("deploymentId" => deploymentId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_deployments()
    list_deployments(params::Dict{String,<:Any})

Lists the deployments in a deployment group for an application registered with the user or
Amazon Web Services account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"applicationName"`: The name of an CodeDeploy application associated with the user or
  Amazon Web Services account.  If applicationName is specified, then deploymentGroupName
  must be specified. If it is not specified, then deploymentGroupName must not be specified.
- `"createTimeRange"`: A time range (start and end) for returning a subset of the list of
  deployments.
- `"deploymentGroupName"`: The name of a deployment group for the specified application.
  If deploymentGroupName is specified, then applicationName must be specified. If it is not
  specified, then applicationName must not be specified.
- `"externalId"`: The unique ID of an external resource for returning deployments linked to
  the external resource.
- `"includeOnlyStatuses"`: A subset of deployments to list by status:    Created: Include
  created deployments in the resulting list.    Queued: Include queued deployments in the
  resulting list.    In Progress: Include in-progress deployments in the resulting list.
  Succeeded: Include successful deployments in the resulting list.    Failed: Include failed
  deployments in the resulting list.    Stopped: Include stopped deployments in the resulting
  list.
- `"nextToken"`: An identifier returned from the previous list deployments call. It can be
  used to return the next set of deployments in the list.
"""
function list_deployments(; aws_config::AbstractAWSConfig=current_aws_config())
    return codedeploy(
        "ListDeployments"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_deployments(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codedeploy(
        "ListDeployments", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_git_hub_account_token_names()
    list_git_hub_account_token_names(params::Dict{String,<:Any})

Lists the names of stored connections to GitHub accounts.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: An identifier returned from the previous ListGitHubAccountTokenNames call.
  It can be used to return the next set of names in the list.
"""
function list_git_hub_account_token_names(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return codedeploy(
        "ListGitHubAccountTokenNames";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_git_hub_account_token_names(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codedeploy(
        "ListGitHubAccountTokenNames",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_on_premises_instances()
    list_on_premises_instances(params::Dict{String,<:Any})

Gets a list of names for one or more on-premises instances. Unless otherwise specified,
both registered and deregistered on-premises instance names are listed. To list only
registered or deregistered on-premises instance names, use the registration status
parameter.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: An identifier returned from the previous list on-premises instances call.
  It can be used to return the next set of on-premises instances in the list.
- `"registrationStatus"`: The registration status of the on-premises instances:
  Deregistered: Include deregistered on-premises instances in the resulting list.
  Registered: Include registered on-premises instances in the resulting list.
- `"tagFilters"`: The on-premises instance tags that are used to restrict the on-premises
  instance names returned.
"""
function list_on_premises_instances(; aws_config::AbstractAWSConfig=current_aws_config())
    return codedeploy(
        "ListOnPremisesInstances"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_on_premises_instances(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codedeploy(
        "ListOnPremisesInstances",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

 Returns a list of tags for the resource identified by a specified Amazon Resource Name
(ARN). Tags are used to organize and categorize your CodeDeploy resources.

# Arguments
- `resource_arn`:  The ARN of a CodeDeploy resource. ListTagsForResource returns all the
  tags associated with the resource that is identified by the ResourceArn.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: An identifier returned from the previous ListTagsForResource call. It can
  be used to return the next set of applications in the list.
"""
function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codedeploy(
        "ListTagsForResource",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codedeploy(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_lifecycle_event_hook_execution_status()
    put_lifecycle_event_hook_execution_status(params::Dict{String,<:Any})

 Sets the result of a Lambda validation function. The function validates lifecycle hooks
during a deployment that uses the Lambda or Amazon ECS compute platform. For Lambda
deployments, the available lifecycle hooks are BeforeAllowTraffic and AfterAllowTraffic.
For Amazon ECS deployments, the available lifecycle hooks are BeforeInstall, AfterInstall,
AfterAllowTestTraffic, BeforeAllowTraffic, and AfterAllowTraffic. Lambda validation
functions return Succeeded or Failed. For more information, see AppSpec 'hooks' Section for
an Lambda Deployment  and AppSpec 'hooks' Section for an Amazon ECS Deployment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"deploymentId"`:  The unique ID of a deployment. Pass this ID to a Lambda function that
  validates a deployment lifecycle event.
- `"lifecycleEventHookExecutionId"`:  The execution ID of a deployment's lifecycle hook. A
  deployment lifecycle hook is specified in the hooks section of the AppSpec file.
- `"status"`: The result of a Lambda function that validates a deployment lifecycle event.
  The values listed in Valid Values are valid for lifecycle statuses in general; however,
  only Succeeded and Failed can be passed successfully in your API call.
"""
function put_lifecycle_event_hook_execution_status(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return codedeploy(
        "PutLifecycleEventHookExecutionStatus";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_lifecycle_event_hook_execution_status(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codedeploy(
        "PutLifecycleEventHookExecutionStatus",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    register_application_revision(application_name, revision)
    register_application_revision(application_name, revision, params::Dict{String,<:Any})

Registers with CodeDeploy a revision for the specified application.

# Arguments
- `application_name`: The name of an CodeDeploy application associated with the user or
  Amazon Web Services account.
- `revision`: Information about the application revision to register, including type and
  location.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A comment about the revision.
"""
function register_application_revision(
    applicationName, revision; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codedeploy(
        "RegisterApplicationRevision",
        Dict{String,Any}("applicationName" => applicationName, "revision" => revision);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function register_application_revision(
    applicationName,
    revision,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codedeploy(
        "RegisterApplicationRevision",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "applicationName" => applicationName, "revision" => revision
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    register_on_premises_instance(instance_name)
    register_on_premises_instance(instance_name, params::Dict{String,<:Any})

Registers an on-premises instance.  Only one IAM ARN (an IAM session ARN or IAM user ARN)
is supported in the request. You cannot use both.

# Arguments
- `instance_name`: The name of the on-premises instance to register.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"iamSessionArn"`: The ARN of the IAM session to associate with the on-premises instance.
- `"iamUserArn"`: The ARN of the user to associate with the on-premises instance.
"""
function register_on_premises_instance(
    instanceName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codedeploy(
        "RegisterOnPremisesInstance",
        Dict{String,Any}("instanceName" => instanceName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function register_on_premises_instance(
    instanceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codedeploy(
        "RegisterOnPremisesInstance",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("instanceName" => instanceName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_tags_from_on_premises_instances(instance_names, tags)
    remove_tags_from_on_premises_instances(instance_names, tags, params::Dict{String,<:Any})

Removes one or more tags from one or more on-premises instances.

# Arguments
- `instance_names`: The names of the on-premises instances from which to remove tags.
- `tags`: The tag key-value pairs to remove from the on-premises instances.

"""
function remove_tags_from_on_premises_instances(
    instanceNames, tags; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codedeploy(
        "RemoveTagsFromOnPremisesInstances",
        Dict{String,Any}("instanceNames" => instanceNames, "tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_tags_from_on_premises_instances(
    instanceNames,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codedeploy(
        "RemoveTagsFromOnPremisesInstances",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("instanceNames" => instanceNames, "tags" => tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    skip_wait_time_for_instance_termination()
    skip_wait_time_for_instance_termination(params::Dict{String,<:Any})

In a blue/green deployment, overrides any specified wait time and starts terminating
instances immediately after the traffic routing is complete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"deploymentId"`:  The unique ID of a blue/green deployment for which you want to skip
  the instance termination wait time.
"""
function skip_wait_time_for_instance_termination(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return codedeploy(
        "SkipWaitTimeForInstanceTermination";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function skip_wait_time_for_instance_termination(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codedeploy(
        "SkipWaitTimeForInstanceTermination",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_deployment(deployment_id)
    stop_deployment(deployment_id, params::Dict{String,<:Any})

Attempts to stop an ongoing deployment.

# Arguments
- `deployment_id`:  The unique ID of a deployment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"autoRollbackEnabled"`:  Indicates, when a deployment is stopped, whether instances that
  have been updated should be rolled back to the previous version of the application
  revision.
"""
function stop_deployment(deploymentId; aws_config::AbstractAWSConfig=current_aws_config())
    return codedeploy(
        "StopDeployment",
        Dict{String,Any}("deploymentId" => deploymentId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_deployment(
    deploymentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codedeploy(
        "StopDeployment",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("deploymentId" => deploymentId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

 Associates the list of tags in the input Tags parameter with the resource identified by
the ResourceArn input parameter.

# Arguments
- `resource_arn`:  The ARN of a resource, such as a CodeDeploy application or deployment
  group.
- `tags`:  A list of tags that TagResource associates with a resource. The resource is
  identified by the ResourceArn input parameter.

"""
function tag_resource(ResourceArn, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return codedeploy(
        "TagResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceArn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codedeploy(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

 Disassociates a resource from a list of tags. The resource is identified by the
ResourceArn input parameter. The tags are identified by the list of keys in the TagKeys
input parameter.

# Arguments
- `resource_arn`:  The Amazon Resource Name (ARN) that specifies from which resource to
  disassociate the tags with the keys in the TagKeys input parameter.
- `tag_keys`:  A list of keys of Tag objects. The Tag objects identified by the keys are
  disassociated from the resource specified by the ResourceArn input parameter.

"""
function untag_resource(
    ResourceArn, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codedeploy(
        "UntagResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceArn,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codedeploy(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_application()
    update_application(params::Dict{String,<:Any})

Changes the name of an application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"applicationName"`: The current name of the application you want to change.
- `"newApplicationName"`: The new name to give the application.
"""
function update_application(; aws_config::AbstractAWSConfig=current_aws_config())
    return codedeploy(
        "UpdateApplication"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function update_application(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codedeploy(
        "UpdateApplication", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    update_deployment_group(application_name, current_deployment_group_name)
    update_deployment_group(application_name, current_deployment_group_name, params::Dict{String,<:Any})

Changes information about a deployment group.

# Arguments
- `application_name`: The application name that corresponds to the deployment group to
  update.
- `current_deployment_group_name`: The current name of the deployment group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"alarmConfiguration"`: Information to add or change about Amazon CloudWatch alarms when
  the deployment group is updated.
- `"autoRollbackConfiguration"`: Information for an automatic rollback configuration that
  is added or changed when a deployment group is updated.
- `"autoScalingGroups"`: The replacement list of Auto Scaling groups to be included in the
  deployment group, if you want to change them.   To keep the Auto Scaling groups, enter
  their names or do not specify this parameter.    To remove Auto Scaling groups, specify a
  non-null empty list of Auto Scaling group names to detach all CodeDeploy-managed Auto
  Scaling lifecycle hooks. For examples, see Amazon EC2 instances in an Amazon EC2 Auto
  Scaling group fail to launch and receive the error \"Heartbeat Timeout\" in the CodeDeploy
  User Guide.
- `"blueGreenDeploymentConfiguration"`: Information about blue/green deployment options for
  a deployment group.
- `"deploymentConfigName"`: The replacement deployment configuration name to use, if you
  want to change it.
- `"deploymentStyle"`: Information about the type of deployment, either in-place or
  blue/green, you want to run and whether to route deployment traffic behind a load balancer.
- `"ec2TagFilters"`: The replacement set of Amazon EC2 tags on which to filter, if you want
  to change them. To keep the existing tags, enter their names. To remove tags, do not enter
  any tag names.
- `"ec2TagSet"`: Information about groups of tags applied to on-premises instances. The
  deployment group includes only Amazon EC2 instances identified by all the tag groups.
- `"ecsServices"`:  The target Amazon ECS services in the deployment group. This applies
  only to deployment groups that use the Amazon ECS compute platform. A target Amazon ECS
  service is specified as an Amazon ECS cluster and service name pair using the format
  &lt;clustername&gt;:&lt;servicename&gt;.
- `"loadBalancerInfo"`: Information about the load balancer used in a deployment.
- `"newDeploymentGroupName"`: The new name of the deployment group, if you want to change
  it.
- `"onPremisesInstanceTagFilters"`: The replacement set of on-premises instance tags on
  which to filter, if you want to change them. To keep the existing tags, enter their names.
  To remove tags, do not enter any tag names.
- `"onPremisesTagSet"`: Information about an on-premises instance tag set. The deployment
  group includes only on-premises instances identified by all the tag groups.
- `"outdatedInstancesStrategy"`: Indicates what happens when new Amazon EC2 instances are
  launched mid-deployment and do not receive the deployed application revision. If this
  option is set to UPDATE or is unspecified, CodeDeploy initiates one or more 'auto-update
  outdated instances' deployments to apply the deployed application revision to the new
  Amazon EC2 instances. If this option is set to IGNORE, CodeDeploy does not initiate a
  deployment to update the new Amazon EC2 instances. This may result in instances having
  different revisions.
- `"serviceRoleArn"`: A replacement ARN for the service role, if you want to change it.
- `"terminationHookEnabled"`: This parameter only applies if you are using CodeDeploy with
  Amazon EC2 Auto Scaling. For more information, see Integrating CodeDeploy with Amazon EC2
  Auto Scaling in the CodeDeploy User Guide. Set terminationHookEnabled to true to have
  CodeDeploy install a termination hook into your Auto Scaling group when you update a
  deployment group. When this hook is installed, CodeDeploy will perform termination
  deployments. For information about termination deployments, see Enabling termination
  deployments during Auto Scaling scale-in events in the CodeDeploy User Guide. For more
  information about Auto Scaling scale-in events, see the Scale in topic in the Amazon EC2
  Auto Scaling User Guide.
- `"triggerConfigurations"`: Information about triggers to change when the deployment group
  is updated. For examples, see Edit a Trigger in a CodeDeploy Deployment Group in the
  CodeDeploy User Guide.
"""
function update_deployment_group(
    applicationName,
    currentDeploymentGroupName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codedeploy(
        "UpdateDeploymentGroup",
        Dict{String,Any}(
            "applicationName" => applicationName,
            "currentDeploymentGroupName" => currentDeploymentGroupName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_deployment_group(
    applicationName,
    currentDeploymentGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codedeploy(
        "UpdateDeploymentGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "applicationName" => applicationName,
                    "currentDeploymentGroupName" => currentDeploymentGroupName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: amplify
using AWS.Compat
using AWS.UUIDs

"""
    create_app(name)
    create_app(name, params::Dict{String,<:Any})

Creates a new Amplify app.

# Arguments
- `name`: The name of the Amplify app.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accessToken"`: The personal access token for a GitHub repository for an Amplify app.
  The personal access token is used to authorize access to a GitHub repository using the
  Amplify GitHub App. The token is not stored. Use accessToken for GitHub repositories only.
  To authorize access to a repository provider such as Bitbucket or CodeCommit, use
  oauthToken. You must specify either accessToken or oauthToken when you create a new app.
  Existing Amplify apps deployed from a GitHub repository using OAuth continue to work with
  CI/CD. However, we strongly recommend that you migrate these apps to use the GitHub App.
  For more information, see Migrating an existing OAuth app to the Amplify GitHub App in the
  Amplify User Guide .
- `"autoBranchCreationConfig"`: The automated branch creation configuration for an Amplify
  app.
- `"autoBranchCreationPatterns"`: The automated branch creation glob patterns for an
  Amplify app.
- `"basicAuthCredentials"`: The credentials for basic authorization for an Amplify app. You
  must base64-encode the authorization credentials and provide them in the format
  user:password.
- `"buildSpec"`: The build specification (build spec) for an Amplify app.
- `"customHeaders"`: The custom HTTP headers for an Amplify app.
- `"customRules"`: The custom rewrite and redirect rules for an Amplify app.
- `"description"`: The description of the Amplify app.
- `"enableAutoBranchCreation"`: Enables automated branch creation for an Amplify app.
- `"enableBasicAuth"`: Enables basic authorization for an Amplify app. This will apply to
  all branches that are part of this app.
- `"enableBranchAutoBuild"`: Enables the auto building of branches for an Amplify app.
- `"enableBranchAutoDeletion"`: Automatically disconnects a branch in the Amplify console
  when you delete a branch from your Git repository.
- `"environmentVariables"`: The environment variables map for an Amplify app.  For a list
  of the environment variables that are accessible to Amplify by default, see Amplify
  Environment variables in the Amplify Hosting User Guide.
- `"iamServiceRoleArn"`: The AWS Identity and Access Management (IAM) service role for an
  Amplify app.
- `"oauthToken"`: The OAuth token for a third-party source control system for an Amplify
  app. The OAuth token is used to create a webhook and a read-only deploy key using SSH
  cloning. The OAuth token is not stored. Use oauthToken for repository providers other than
  GitHub, such as Bitbucket or CodeCommit. To authorize access to GitHub as your repository
  provider, use accessToken. You must specify either oauthToken or accessToken when you
  create a new app. Existing Amplify apps deployed from a GitHub repository using OAuth
  continue to work with CI/CD. However, we strongly recommend that you migrate these apps to
  use the GitHub App. For more information, see Migrating an existing OAuth app to the
  Amplify GitHub App in the Amplify User Guide .
- `"platform"`: The platform for the Amplify app. For a static app, set the platform type
  to WEB. For a dynamic server-side rendered (SSR) app, set the platform type to WEB_COMPUTE.
  For an app requiring Amplify Hosting's original SSR support only, set the platform type to
  WEB_DYNAMIC.
- `"repository"`: The Git repository for the Amplify app.
- `"tags"`: The tag for an Amplify app.
"""
function create_app(name; aws_config::AbstractAWSConfig=current_aws_config())
    return amplify(
        "POST",
        "/apps",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_app(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplify(
        "POST",
        "/apps",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_backend_environment(app_id, environment_name)
    create_backend_environment(app_id, environment_name, params::Dict{String,<:Any})

Creates a new backend environment for an Amplify app.  This API is available only to
Amplify Gen 1 applications where the backend is created using Amplify Studio or the Amplify
command line interface (CLI). This API isn’t available to Amplify Gen 2 applications.
When you deploy an application with Amplify Gen 2, you provision the app's backend
infrastructure using Typescript code.

# Arguments
- `app_id`: The unique ID for an Amplify app.
- `environment_name`: The name for the backend environment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"deploymentArtifacts"`: The name of deployment artifacts.
- `"stackName"`: The AWS CloudFormation stack name of a backend environment.
"""
function create_backend_environment(
    appId, environmentName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplify(
        "POST",
        "/apps/$(appId)/backendenvironments",
        Dict{String,Any}("environmentName" => environmentName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_backend_environment(
    appId,
    environmentName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplify(
        "POST",
        "/apps/$(appId)/backendenvironments",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("environmentName" => environmentName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_branch(app_id, branch_name)
    create_branch(app_id, branch_name, params::Dict{String,<:Any})

 Creates a new branch for an Amplify app.

# Arguments
- `app_id`:  The unique ID for an Amplify app.
- `branch_name`: The name for the branch.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"backend"`: The backend for a Branch of an Amplify app. Use for a backend created from
  an CloudFormation stack. This field is available to Amplify Gen 2 apps only. When you
  deploy an application with Amplify Gen 2, you provision the app's backend infrastructure
  using Typescript code.
- `"backendEnvironmentArn"`: The Amazon Resource Name (ARN) for a backend environment that
  is part of a Gen 1 Amplify app.  This field is available to Amplify Gen 1 apps only where
  the backend is created using Amplify Studio or the Amplify command line interface (CLI).
- `"basicAuthCredentials"`:  The basic authorization credentials for the branch. You must
  base64-encode the authorization credentials and provide them in the format user:password.
- `"buildSpec"`:  The build specification (build spec) for the branch.
- `"description"`: The description for the branch.
- `"displayName"`:  The display name for a branch. This is used as the default domain
  prefix.
- `"enableAutoBuild"`:  Enables auto building for the branch.
- `"enableBasicAuth"`:  Enables basic authorization for the branch.
- `"enableNotification"`:  Enables notifications for the branch.
- `"enablePerformanceMode"`: Enables performance mode for the branch. Performance mode
  optimizes for faster hosting performance by keeping content cached at the edge for a longer
  interval. When performance mode is enabled, hosting configuration or code changes can take
  up to 10 minutes to roll out.
- `"enablePullRequestPreview"`:  Enables pull request previews for this branch.
- `"environmentVariables"`:  The environment variables for the branch.
- `"framework"`:  The framework for the branch.
- `"pullRequestEnvironmentName"`:  The Amplify environment name for the pull request.
- `"stage"`: Describes the current stage for the branch.
- `"tags"`:  The tag for the branch.
- `"ttl"`:  The content Time To Live (TTL) for the website in seconds.
"""
function create_branch(
    appId, branchName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplify(
        "POST",
        "/apps/$(appId)/branches",
        Dict{String,Any}("branchName" => branchName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_branch(
    appId,
    branchName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplify(
        "POST",
        "/apps/$(appId)/branches",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("branchName" => branchName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_deployment(app_id, branch_name)
    create_deployment(app_id, branch_name, params::Dict{String,<:Any})

Creates a deployment for a manually deployed Amplify app. Manually deployed apps are not
connected to a repository.  The maximum duration between the CreateDeployment call and the
StartDeployment call cannot exceed 8 hours. If the duration exceeds 8 hours, the
StartDeployment call and the associated Job will fail.

# Arguments
- `app_id`:  The unique ID for an Amplify app.
- `branch_name`:  The name of the branch to use for the job.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"fileMap"`:  An optional file map that contains the file name as the key and the file
  content md5 hash as the value. If this argument is provided, the service will generate a
  unique upload URL per file. Otherwise, the service will only generate a single upload URL
  for the zipped files.
"""
function create_deployment(
    appId, branchName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplify(
        "POST",
        "/apps/$(appId)/branches/$(branchName)/deployments";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_deployment(
    appId,
    branchName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplify(
        "POST",
        "/apps/$(appId)/branches/$(branchName)/deployments",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_domain_association(app_id, domain_name, sub_domain_settings)
    create_domain_association(app_id, domain_name, sub_domain_settings, params::Dict{String,<:Any})

Creates a new domain association for an Amplify app. This action associates a custom domain
with the Amplify app

# Arguments
- `app_id`:  The unique ID for an Amplify app.
- `domain_name`:  The domain name for the domain association.
- `sub_domain_settings`:  The setting for the subdomain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"autoSubDomainCreationPatterns"`:  Sets the branch patterns for automatic subdomain
  creation.
- `"autoSubDomainIAMRole"`:  The required AWS Identity and Access Management (IAM) service
  role for the Amazon Resource Name (ARN) for automatically creating subdomains.
- `"certificateSettings"`: The type of SSL/TLS certificate to use for your custom domain.
  If you don't specify a certificate type, Amplify uses the default certificate that it
  provisions and manages for you.
- `"enableAutoSubDomain"`:  Enables the automated creation of subdomains for branches.
"""
function create_domain_association(
    appId, domainName, subDomainSettings; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplify(
        "POST",
        "/apps/$(appId)/domains",
        Dict{String,Any}(
            "domainName" => domainName, "subDomainSettings" => subDomainSettings
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_domain_association(
    appId,
    domainName,
    subDomainSettings,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplify(
        "POST",
        "/apps/$(appId)/domains",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "domainName" => domainName, "subDomainSettings" => subDomainSettings
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_webhook(app_id, branch_name)
    create_webhook(app_id, branch_name, params::Dict{String,<:Any})

Creates a new webhook on an Amplify app.

# Arguments
- `app_id`: The unique ID for an Amplify app.
- `branch_name`: The name for a branch that is part of an Amplify app.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description for a webhook.
"""
function create_webhook(
    appId, branchName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplify(
        "POST",
        "/apps/$(appId)/webhooks",
        Dict{String,Any}("branchName" => branchName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_webhook(
    appId,
    branchName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplify(
        "POST",
        "/apps/$(appId)/webhooks",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("branchName" => branchName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_app(app_id)
    delete_app(app_id, params::Dict{String,<:Any})

Deletes an existing Amplify app specified by an app ID.

# Arguments
- `app_id`: The unique ID for an Amplify app.

"""
function delete_app(appId; aws_config::AbstractAWSConfig=current_aws_config())
    return amplify(
        "DELETE", "/apps/$(appId)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function delete_app(
    appId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplify(
        "DELETE",
        "/apps/$(appId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_backend_environment(app_id, environment_name)
    delete_backend_environment(app_id, environment_name, params::Dict{String,<:Any})

Deletes a backend environment for an Amplify app.  This API is available only to Amplify
Gen 1 applications where the backend is created using Amplify Studio or the Amplify command
line interface (CLI). This API isn’t available to Amplify Gen 2 applications. When you
deploy an application with Amplify Gen 2, you provision the app's backend infrastructure
using Typescript code.

# Arguments
- `app_id`: The unique ID of an Amplify app.
- `environment_name`: The name of a backend environment of an Amplify app.

"""
function delete_backend_environment(
    appId, environmentName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplify(
        "DELETE",
        "/apps/$(appId)/backendenvironments/$(environmentName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_backend_environment(
    appId,
    environmentName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplify(
        "DELETE",
        "/apps/$(appId)/backendenvironments/$(environmentName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_branch(app_id, branch_name)
    delete_branch(app_id, branch_name, params::Dict{String,<:Any})

 Deletes a branch for an Amplify app.

# Arguments
- `app_id`:  The unique ID for an Amplify app.
- `branch_name`: The name of the branch.

"""
function delete_branch(
    appId, branchName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplify(
        "DELETE",
        "/apps/$(appId)/branches/$(branchName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_branch(
    appId,
    branchName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplify(
        "DELETE",
        "/apps/$(appId)/branches/$(branchName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_domain_association(app_id, domain_name)
    delete_domain_association(app_id, domain_name, params::Dict{String,<:Any})

Deletes a domain association for an Amplify app.

# Arguments
- `app_id`:  The unique id for an Amplify app.
- `domain_name`:  The name of the domain.

"""
function delete_domain_association(
    appId, domainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplify(
        "DELETE",
        "/apps/$(appId)/domains/$(domainName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_domain_association(
    appId,
    domainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplify(
        "DELETE",
        "/apps/$(appId)/domains/$(domainName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_job(app_id, branch_name, job_id)
    delete_job(app_id, branch_name, job_id, params::Dict{String,<:Any})

 Deletes a job for a branch of an Amplify app.

# Arguments
- `app_id`:  The unique ID for an Amplify app.
- `branch_name`: The name of the branch to use for the job.
- `job_id`:  The unique ID for the job.

"""
function delete_job(
    appId, branchName, jobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplify(
        "DELETE",
        "/apps/$(appId)/branches/$(branchName)/jobs/$(jobId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_job(
    appId,
    branchName,
    jobId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplify(
        "DELETE",
        "/apps/$(appId)/branches/$(branchName)/jobs/$(jobId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_webhook(webhook_id)
    delete_webhook(webhook_id, params::Dict{String,<:Any})

Deletes a webhook.

# Arguments
- `webhook_id`: The unique ID for a webhook.

"""
function delete_webhook(webhookId; aws_config::AbstractAWSConfig=current_aws_config())
    return amplify(
        "DELETE",
        "/webhooks/$(webhookId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_webhook(
    webhookId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplify(
        "DELETE",
        "/webhooks/$(webhookId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    generate_access_logs(app_id, domain_name)
    generate_access_logs(app_id, domain_name, params::Dict{String,<:Any})

Returns the website access logs for a specific time range using a presigned URL.

# Arguments
- `app_id`: The unique ID for an Amplify app.
- `domain_name`: The name of the domain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"endTime"`: The time at which the logs should end. The time range specified is inclusive
  of the end time.
- `"startTime"`: The time at which the logs should start. The time range specified is
  inclusive of the start time.
"""
function generate_access_logs(
    appId, domainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplify(
        "POST",
        "/apps/$(appId)/accesslogs",
        Dict{String,Any}("domainName" => domainName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function generate_access_logs(
    appId,
    domainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplify(
        "POST",
        "/apps/$(appId)/accesslogs",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("domainName" => domainName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_app(app_id)
    get_app(app_id, params::Dict{String,<:Any})

Returns an existing Amplify app specified by an app ID.

# Arguments
- `app_id`: The unique ID for an Amplify app.

"""
function get_app(appId; aws_config::AbstractAWSConfig=current_aws_config())
    return amplify(
        "GET", "/apps/$(appId)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_app(
    appId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplify(
        "GET",
        "/apps/$(appId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_artifact_url(artifact_id)
    get_artifact_url(artifact_id, params::Dict{String,<:Any})

Returns the artifact info that corresponds to an artifact id.

# Arguments
- `artifact_id`: The unique ID for an artifact.

"""
function get_artifact_url(artifactId; aws_config::AbstractAWSConfig=current_aws_config())
    return amplify(
        "GET",
        "/artifacts/$(artifactId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_artifact_url(
    artifactId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplify(
        "GET",
        "/artifacts/$(artifactId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_backend_environment(app_id, environment_name)
    get_backend_environment(app_id, environment_name, params::Dict{String,<:Any})

Returns a backend environment for an Amplify app.  This API is available only to Amplify
Gen 1 applications where the backend is created using Amplify Studio or the Amplify command
line interface (CLI). This API isn’t available to Amplify Gen 2 applications. When you
deploy an application with Amplify Gen 2, you provision the app's backend infrastructure
using Typescript code.

# Arguments
- `app_id`: The unique id for an Amplify app.
- `environment_name`: The name for the backend environment.

"""
function get_backend_environment(
    appId, environmentName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplify(
        "GET",
        "/apps/$(appId)/backendenvironments/$(environmentName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_backend_environment(
    appId,
    environmentName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplify(
        "GET",
        "/apps/$(appId)/backendenvironments/$(environmentName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_branch(app_id, branch_name)
    get_branch(app_id, branch_name, params::Dict{String,<:Any})

 Returns a branch for an Amplify app.

# Arguments
- `app_id`:  The unique ID for an Amplify app.
- `branch_name`: The name of the branch.

"""
function get_branch(appId, branchName; aws_config::AbstractAWSConfig=current_aws_config())
    return amplify(
        "GET",
        "/apps/$(appId)/branches/$(branchName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_branch(
    appId,
    branchName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplify(
        "GET",
        "/apps/$(appId)/branches/$(branchName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_domain_association(app_id, domain_name)
    get_domain_association(app_id, domain_name, params::Dict{String,<:Any})

Returns the domain information for an Amplify app.

# Arguments
- `app_id`:  The unique id for an Amplify app.
- `domain_name`:  The name of the domain.

"""
function get_domain_association(
    appId, domainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplify(
        "GET",
        "/apps/$(appId)/domains/$(domainName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_domain_association(
    appId,
    domainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplify(
        "GET",
        "/apps/$(appId)/domains/$(domainName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_job(app_id, branch_name, job_id)
    get_job(app_id, branch_name, job_id, params::Dict{String,<:Any})

 Returns a job for a branch of an Amplify app.

# Arguments
- `app_id`: The unique ID for an Amplify app.
- `branch_name`: The name of the branch to use for the job.
- `job_id`: The unique ID for the job.

"""
function get_job(
    appId, branchName, jobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplify(
        "GET",
        "/apps/$(appId)/branches/$(branchName)/jobs/$(jobId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_job(
    appId,
    branchName,
    jobId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplify(
        "GET",
        "/apps/$(appId)/branches/$(branchName)/jobs/$(jobId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_webhook(webhook_id)
    get_webhook(webhook_id, params::Dict{String,<:Any})

Returns the webhook information that corresponds to a specified webhook ID.

# Arguments
- `webhook_id`: The unique ID for a webhook.

"""
function get_webhook(webhookId; aws_config::AbstractAWSConfig=current_aws_config())
    return amplify(
        "GET",
        "/webhooks/$(webhookId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_webhook(
    webhookId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplify(
        "GET",
        "/webhooks/$(webhookId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_apps()
    list_apps(params::Dict{String,<:Any})

Returns a list of the existing Amplify apps.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of records to list in a single response.
- `"nextToken"`: A pagination token. If non-null, the pagination token is returned in a
  result. Pass its value in another request to retrieve more entries.
"""
function list_apps(; aws_config::AbstractAWSConfig=current_aws_config())
    return amplify("GET", "/apps"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_apps(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplify(
        "GET", "/apps", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_artifacts(app_id, branch_name, job_id)
    list_artifacts(app_id, branch_name, job_id, params::Dict{String,<:Any})

Returns a list of artifacts for a specified app, branch, and job.

# Arguments
- `app_id`: The unique ID for an Amplify app.
- `branch_name`: The name of a branch that is part of an Amplify app.
- `job_id`: The unique ID for a job.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of records to list in a single response.
- `"nextToken"`: A pagination token. Set to null to start listing artifacts from start. If
  a non-null pagination token is returned in a result, pass its value in here to list more
  artifacts.
"""
function list_artifacts(
    appId, branchName, jobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplify(
        "GET",
        "/apps/$(appId)/branches/$(branchName)/jobs/$(jobId)/artifacts";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_artifacts(
    appId,
    branchName,
    jobId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplify(
        "GET",
        "/apps/$(appId)/branches/$(branchName)/jobs/$(jobId)/artifacts",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_backend_environments(app_id)
    list_backend_environments(app_id, params::Dict{String,<:Any})

Lists the backend environments for an Amplify app.  This API is available only to Amplify
Gen 1 applications where the backend is created using Amplify Studio or the Amplify command
line interface (CLI). This API isn’t available to Amplify Gen 2 applications. When you
deploy an application with Amplify Gen 2, you provision the app's backend infrastructure
using Typescript code.

# Arguments
- `app_id`: The unique ID for an Amplify app.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"environmentName"`: The name of the backend environment
- `"maxResults"`: The maximum number of records to list in a single response.
- `"nextToken"`: A pagination token. Set to null to start listing backend environments from
  the start. If a non-null pagination token is returned in a result, pass its value in here
  to list more backend environments.
"""
function list_backend_environments(
    appId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplify(
        "GET",
        "/apps/$(appId)/backendenvironments";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_backend_environments(
    appId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplify(
        "GET",
        "/apps/$(appId)/backendenvironments",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_branches(app_id)
    list_branches(app_id, params::Dict{String,<:Any})

 Lists the branches of an Amplify app.

# Arguments
- `app_id`: The unique ID for an Amplify app.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:  The maximum number of records to list in a single response.
- `"nextToken"`: A pagination token. Set to null to start listing branches from the start.
  If a non-null pagination token is returned in a result, pass its value in here to list more
  branches.
"""
function list_branches(appId; aws_config::AbstractAWSConfig=current_aws_config())
    return amplify(
        "GET",
        "/apps/$(appId)/branches";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_branches(
    appId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplify(
        "GET",
        "/apps/$(appId)/branches",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_domain_associations(app_id)
    list_domain_associations(app_id, params::Dict{String,<:Any})

Returns the domain associations for an Amplify app.

# Arguments
- `app_id`:  The unique ID for an Amplify app.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:  The maximum number of records to list in a single response.
- `"nextToken"`:  A pagination token. Set to null to start listing apps from the start. If
  non-null, a pagination token is returned in a result. Pass its value in here to list more
  projects.
"""
function list_domain_associations(appId; aws_config::AbstractAWSConfig=current_aws_config())
    return amplify(
        "GET",
        "/apps/$(appId)/domains";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_domain_associations(
    appId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplify(
        "GET",
        "/apps/$(appId)/domains",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_jobs(app_id, branch_name)
    list_jobs(app_id, branch_name, params::Dict{String,<:Any})

 Lists the jobs for a branch of an Amplify app.

# Arguments
- `app_id`:  The unique ID for an Amplify app.
- `branch_name`: The name of the branch to use for the request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of records to list in a single response.
- `"nextToken"`: A pagination token. Set to null to start listing steps from the start. If
  a non-null pagination token is returned in a result, pass its value in here to list more
  steps.
"""
function list_jobs(appId, branchName; aws_config::AbstractAWSConfig=current_aws_config())
    return amplify(
        "GET",
        "/apps/$(appId)/branches/$(branchName)/jobs";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_jobs(
    appId,
    branchName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplify(
        "GET",
        "/apps/$(appId)/branches/$(branchName)/jobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Returns a list of tags for a specified Amazon Resource Name (ARN).

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) to use to list tags.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplify(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplify(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_webhooks(app_id)
    list_webhooks(app_id, params::Dict{String,<:Any})

Returns a list of webhooks for an Amplify app.

# Arguments
- `app_id`: The unique ID for an Amplify app.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of records to list in a single response.
- `"nextToken"`: A pagination token. Set to null to start listing webhooks from the start.
  If non-null,the pagination token is returned in a result. Pass its value in here to list
  more webhooks.
"""
function list_webhooks(appId; aws_config::AbstractAWSConfig=current_aws_config())
    return amplify(
        "GET",
        "/apps/$(appId)/webhooks";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_webhooks(
    appId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplify(
        "GET",
        "/apps/$(appId)/webhooks",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_deployment(app_id, branch_name)
    start_deployment(app_id, branch_name, params::Dict{String,<:Any})

Starts a deployment for a manually deployed app. Manually deployed apps are not connected
to a repository.  The maximum duration between the CreateDeployment call and the
StartDeployment call cannot exceed 8 hours. If the duration exceeds 8 hours, the
StartDeployment call and the associated Job will fail.

# Arguments
- `app_id`: The unique ID for an Amplify app.
- `branch_name`: The name of the branch to use for the job.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"jobId"`: The job ID for this deployment, generated by the create deployment request.
- `"sourceUrl"`: The source URL for this deployment, used when calling start deployment
  without create deployment. The source URL can be any HTTP GET URL that is publicly
  accessible and downloads a single .zip file.
"""
function start_deployment(
    appId, branchName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplify(
        "POST",
        "/apps/$(appId)/branches/$(branchName)/deployments/start";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_deployment(
    appId,
    branchName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplify(
        "POST",
        "/apps/$(appId)/branches/$(branchName)/deployments/start",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_job(app_id, branch_name, job_type)
    start_job(app_id, branch_name, job_type, params::Dict{String,<:Any})

 Starts a new job for a branch of an Amplify app.

# Arguments
- `app_id`: The unique ID for an Amplify app.
- `branch_name`: The name of the branch to use for the job.
- `job_type`: Describes the type for the job. The job type RELEASE starts a new job with
  the latest change from the specified branch. This value is available only for apps that are
  connected to a repository.  The job type RETRY retries an existing job. If the job type
  value is RETRY, the jobId is also required.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"commitId"`:  The commit ID from a third-party repository provider for the job.
- `"commitMessage"`:  The commit message from a third-party repository provider for the
  job.
- `"commitTime"`:  The commit date and time for the job.
- `"jobId"`: The unique ID for an existing job. This is required if the value of jobType is
  RETRY.
- `"jobReason"`: A descriptive reason for starting the job.
"""
function start_job(
    appId, branchName, jobType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplify(
        "POST",
        "/apps/$(appId)/branches/$(branchName)/jobs",
        Dict{String,Any}("jobType" => jobType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_job(
    appId,
    branchName,
    jobType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplify(
        "POST",
        "/apps/$(appId)/branches/$(branchName)/jobs",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("jobType" => jobType), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_job(app_id, branch_name, job_id)
    stop_job(app_id, branch_name, job_id, params::Dict{String,<:Any})

 Stops a job that is in progress for a branch of an Amplify app.

# Arguments
- `app_id`:  The unique ID for an Amplify app.
- `branch_name`: The name of the branch to use for the stop job request.
- `job_id`:  The unique id for the job.

"""
function stop_job(
    appId, branchName, jobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplify(
        "DELETE",
        "/apps/$(appId)/branches/$(branchName)/jobs/$(jobId)/stop";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_job(
    appId,
    branchName,
    jobId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplify(
        "DELETE",
        "/apps/$(appId)/branches/$(branchName)/jobs/$(jobId)/stop",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Tags the resource with a tag key and value.

# Arguments
- `resource_arn`:  The Amazon Resource Name (ARN) to use to tag a resource.
- `tags`: The tags used to tag the resource.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return amplify(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplify(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Untags a resource with a specified Amazon Resource Name (ARN).

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) to use to untag a resource.
- `tag_keys`: The tag keys to use to untag a resource.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplify(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplify(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_app(app_id)
    update_app(app_id, params::Dict{String,<:Any})

Updates an existing Amplify app.

# Arguments
- `app_id`: The unique ID for an Amplify app.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accessToken"`: The personal access token for a GitHub repository for an Amplify app.
  The personal access token is used to authorize access to a GitHub repository using the
  Amplify GitHub App. The token is not stored. Use accessToken for GitHub repositories only.
  To authorize access to a repository provider such as Bitbucket or CodeCommit, use
  oauthToken. You must specify either accessToken or oauthToken when you update an app.
  Existing Amplify apps deployed from a GitHub repository using OAuth continue to work with
  CI/CD. However, we strongly recommend that you migrate these apps to use the GitHub App.
  For more information, see Migrating an existing OAuth app to the Amplify GitHub App in the
  Amplify User Guide .
- `"autoBranchCreationConfig"`: The automated branch creation configuration for an Amplify
  app.
- `"autoBranchCreationPatterns"`: Describes the automated branch creation glob patterns for
  an Amplify app.
- `"basicAuthCredentials"`: The basic authorization credentials for an Amplify app. You
  must base64-encode the authorization credentials and provide them in the format
  user:password.
- `"buildSpec"`: The build specification (build spec) for an Amplify app.
- `"customHeaders"`: The custom HTTP headers for an Amplify app.
- `"customRules"`: The custom redirect and rewrite rules for an Amplify app.
- `"description"`: The description for an Amplify app.
- `"enableAutoBranchCreation"`: Enables automated branch creation for an Amplify app.
- `"enableBasicAuth"`: Enables basic authorization for an Amplify app.
- `"enableBranchAutoBuild"`: Enables branch auto-building for an Amplify app.
- `"enableBranchAutoDeletion"`: Automatically disconnects a branch in the Amplify console
  when you delete a branch from your Git repository.
- `"environmentVariables"`: The environment variables for an Amplify app.
- `"iamServiceRoleArn"`: The AWS Identity and Access Management (IAM) service role for an
  Amplify app.
- `"name"`: The name for an Amplify app.
- `"oauthToken"`: The OAuth token for a third-party source control system for an Amplify
  app. The OAuth token is used to create a webhook and a read-only deploy key using SSH
  cloning. The OAuth token is not stored. Use oauthToken for repository providers other than
  GitHub, such as Bitbucket or CodeCommit. To authorize access to GitHub as your repository
  provider, use accessToken. You must specify either oauthToken or accessToken when you
  update an app. Existing Amplify apps deployed from a GitHub repository using OAuth continue
  to work with CI/CD. However, we strongly recommend that you migrate these apps to use the
  GitHub App. For more information, see Migrating an existing OAuth app to the Amplify GitHub
  App in the Amplify User Guide .
- `"platform"`: The platform for the Amplify app. For a static app, set the platform type
  to WEB. For a dynamic server-side rendered (SSR) app, set the platform type to WEB_COMPUTE.
  For an app requiring Amplify Hosting's original SSR support only, set the platform type to
  WEB_DYNAMIC.
- `"repository"`: The name of the Git repository for an Amplify app.
"""
function update_app(appId; aws_config::AbstractAWSConfig=current_aws_config())
    return amplify(
        "POST", "/apps/$(appId)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function update_app(
    appId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplify(
        "POST",
        "/apps/$(appId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_branch(app_id, branch_name)
    update_branch(app_id, branch_name, params::Dict{String,<:Any})

 Updates a branch for an Amplify app.

# Arguments
- `app_id`:  The unique ID for an Amplify app.
- `branch_name`: The name of the branch.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"backend"`: The backend for a Branch of an Amplify app. Use for a backend created from
  an CloudFormation stack. This field is available to Amplify Gen 2 apps only. When you
  deploy an application with Amplify Gen 2, you provision the app's backend infrastructure
  using Typescript code.
- `"backendEnvironmentArn"`: The Amazon Resource Name (ARN) for a backend environment that
  is part of a Gen 1 Amplify app.  This field is available to Amplify Gen 1 apps only where
  the backend is created using Amplify Studio or the Amplify command line interface (CLI).
- `"basicAuthCredentials"`:  The basic authorization credentials for the branch. You must
  base64-encode the authorization credentials and provide them in the format user:password.
- `"buildSpec"`:  The build specification (build spec) for the branch.
- `"description"`:  The description for the branch.
- `"displayName"`:  The display name for a branch. This is used as the default domain
  prefix.
- `"enableAutoBuild"`:  Enables auto building for the branch.
- `"enableBasicAuth"`:  Enables basic authorization for the branch.
- `"enableNotification"`:  Enables notifications for the branch.
- `"enablePerformanceMode"`: Enables performance mode for the branch. Performance mode
  optimizes for faster hosting performance by keeping content cached at the edge for a longer
  interval. When performance mode is enabled, hosting configuration or code changes can take
  up to 10 minutes to roll out.
- `"enablePullRequestPreview"`:  Enables pull request previews for this branch.
- `"environmentVariables"`:  The environment variables for the branch.
- `"framework"`:  The framework for the branch.
- `"pullRequestEnvironmentName"`:  The Amplify environment name for the pull request.
- `"stage"`:  Describes the current stage for the branch.
- `"ttl"`:  The content Time to Live (TTL) for the website in seconds.
"""
function update_branch(
    appId, branchName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplify(
        "POST",
        "/apps/$(appId)/branches/$(branchName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_branch(
    appId,
    branchName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplify(
        "POST",
        "/apps/$(appId)/branches/$(branchName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_domain_association(app_id, domain_name)
    update_domain_association(app_id, domain_name, params::Dict{String,<:Any})

Creates a new domain association for an Amplify app.

# Arguments
- `app_id`:  The unique ID for an Amplify app.
- `domain_name`:  The name of the domain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"autoSubDomainCreationPatterns"`:  Sets the branch patterns for automatic subdomain
  creation.
- `"autoSubDomainIAMRole"`:  The required AWS Identity and Access Management (IAM) service
  role for the Amazon Resource Name (ARN) for automatically creating subdomains.
- `"certificateSettings"`: The type of SSL/TLS certificate to use for your custom domain.
- `"enableAutoSubDomain"`:  Enables the automated creation of subdomains for branches.
- `"subDomainSettings"`:  Describes the settings for the subdomain.
"""
function update_domain_association(
    appId, domainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplify(
        "POST",
        "/apps/$(appId)/domains/$(domainName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_domain_association(
    appId,
    domainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplify(
        "POST",
        "/apps/$(appId)/domains/$(domainName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_webhook(webhook_id)
    update_webhook(webhook_id, params::Dict{String,<:Any})

Updates a webhook.

# Arguments
- `webhook_id`: The unique ID for a webhook.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"branchName"`: The name for a branch that is part of an Amplify app.
- `"description"`: The description for a webhook.
"""
function update_webhook(webhookId; aws_config::AbstractAWSConfig=current_aws_config())
    return amplify(
        "POST",
        "/webhooks/$(webhookId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_webhook(
    webhookId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplify(
        "POST",
        "/webhooks/$(webhookId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWS.jl
using AWS
using AWS.AWSServices: qapps
using AWS.Compat
using AWS.UUIDs

"""
    associate_library_item_review(instance-id, library_item_id)
    associate_library_item_review(instance-id, library_item_id, params::Dict{String,<:Any})

Associates a rating or review for a library item with the user submitting the request. This
increments the rating count for the specified library item.

# Arguments
- `instance-id`: The unique identifier for the Amazon Q Business application environment
  instance.
- `library_item_id`: The unique identifier of the library item to associate the review with.

"""
function associate_library_item_review end

function associate_library_item_review(
    instance_id, libraryItemId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qapps(
        "POST",
        "/catalog.associateItemRating",
        Dict{String,Any}(
            "libraryItemId" => libraryItemId,
            "headers" => Dict{String,Any}("instance-id" => instance_id),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function associate_library_item_review(
    instance_id,
    libraryItemId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qapps(
        "POST",
        "/catalog.associateItemRating",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "libraryItemId" => libraryItemId,
                    "headers" => Dict{String,Any}("instance-id" => instance_id),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_qapp_with_user(app_id, instance-id)
    associate_qapp_with_user(app_id, instance-id, params::Dict{String,<:Any})

This operation creates a link between the user's identity calling the operation and a
specific Q App. This is useful to mark the Q App as a favorite for the user if the user
doesn't own the Amazon Q App so they can still run it and see it in their inventory of Q
Apps.

# Arguments
- `app_id`: The ID of the Amazon Q App to associate with the user.
- `instance-id`: The unique identifier of the Amazon Q Business application environment
  instance.

"""
function associate_qapp_with_user end

function associate_qapp_with_user(
    appId, instance_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qapps(
        "POST",
        "/apps.install",
        Dict{String,Any}(
            "appId" => appId, "headers" => Dict{String,Any}("instance-id" => instance_id)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function associate_qapp_with_user(
    appId,
    instance_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qapps(
        "POST",
        "/apps.install",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "appId" => appId,
                    "headers" => Dict{String,Any}("instance-id" => instance_id),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_library_item(app_id, app_version, categories, instance-id)
    create_library_item(app_id, app_version, categories, instance-id, params::Dict{String,<:Any})

Creates a new library item for an Amazon Q App, allowing it to be discovered and used by
other allowed users.

# Arguments
- `app_id`: The unique identifier of the Amazon Q App to publish to the library.
- `app_version`: The version of the Amazon Q App to publish to the library.
- `categories`: The categories to associate with the library item for easier discovery.
- `instance-id`: The unique identifier of the Amazon Q Business application environment
  instance.

"""
function create_library_item end

function create_library_item(
    appId,
    appVersion,
    categories,
    instance_id;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qapps(
        "POST",
        "/catalog.createItem",
        Dict{String,Any}(
            "appId" => appId,
            "appVersion" => appVersion,
            "categories" => categories,
            "headers" => Dict{String,Any}("instance-id" => instance_id),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function create_library_item(
    appId,
    appVersion,
    categories,
    instance_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qapps(
        "POST",
        "/catalog.createItem",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "appId" => appId,
                    "appVersion" => appVersion,
                    "categories" => categories,
                    "headers" => Dict{String,Any}("instance-id" => instance_id),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_qapp(app_definition, instance-id, title)
    create_qapp(app_definition, instance-id, title, params::Dict{String,<:Any})

Creates a new Amazon Q App based on the provided definition. The Q App definition specifies
the cards and flow of the Q App. This operation also calculates the dependencies between
the cards by inspecting the references in the prompts.

# Arguments
- `app_definition`: The definition of the new Q App, specifying the cards and flow.
- `instance-id`: The unique identifier of the Amazon Q Business application environment
  instance.
- `title`: The title of the new Q App.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description of the new Q App.
- `"tags"`: Optional tags to associate with the new Q App.
"""
function create_qapp end

function create_qapp(
    appDefinition, instance_id, title; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qapps(
        "POST",
        "/apps.create",
        Dict{String,Any}(
            "appDefinition" => appDefinition,
            "title" => title,
            "headers" => Dict{String,Any}("instance-id" => instance_id),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function create_qapp(
    appDefinition,
    instance_id,
    title,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qapps(
        "POST",
        "/apps.create",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "appDefinition" => appDefinition,
                    "title" => title,
                    "headers" => Dict{String,Any}("instance-id" => instance_id),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_library_item(instance-id, library_item_id)
    delete_library_item(instance-id, library_item_id, params::Dict{String,<:Any})

Deletes a library item for an Amazon Q App, removing it from the library so it can no
longer be discovered or used by other users.

# Arguments
- `instance-id`: The unique identifier of the Amazon Q Business application environment
  instance.
- `library_item_id`: The unique identifier of the library item to delete.

"""
function delete_library_item end

function delete_library_item(
    instance_id, libraryItemId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qapps(
        "POST",
        "/catalog.deleteItem",
        Dict{String,Any}(
            "libraryItemId" => libraryItemId,
            "headers" => Dict{String,Any}("instance-id" => instance_id),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function delete_library_item(
    instance_id,
    libraryItemId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qapps(
        "POST",
        "/catalog.deleteItem",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "libraryItemId" => libraryItemId,
                    "headers" => Dict{String,Any}("instance-id" => instance_id),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_qapp(app_id, instance-id)
    delete_qapp(app_id, instance-id, params::Dict{String,<:Any})

Deletes an Amazon Q App owned by the user. If the Q App was previously published to the
library, it is also removed from the library.

# Arguments
- `app_id`: The unique identifier of the Q App to delete.
- `instance-id`: The unique identifier of the Amazon Q Business application environment
  instance.

"""
function delete_qapp end

function delete_qapp(appId, instance_id; aws_config::AbstractAWSConfig=current_aws_config())
    return qapps(
        "POST",
        "/apps.delete",
        Dict{String,Any}(
            "appId" => appId, "headers" => Dict{String,Any}("instance-id" => instance_id)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function delete_qapp(
    appId,
    instance_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qapps(
        "POST",
        "/apps.delete",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "appId" => appId,
                    "headers" => Dict{String,Any}("instance-id" => instance_id),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_library_item_review(instance-id, library_item_id)
    disassociate_library_item_review(instance-id, library_item_id, params::Dict{String,<:Any})

Removes a rating or review previously submitted by the user for a library item.

# Arguments
- `instance-id`: The unique identifier of the Amazon Q Business application environment
  instance.
- `library_item_id`: The unique identifier of the library item to remove the review from.

"""
function disassociate_library_item_review end

function disassociate_library_item_review(
    instance_id, libraryItemId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qapps(
        "POST",
        "/catalog.disassociateItemRating",
        Dict{String,Any}(
            "libraryItemId" => libraryItemId,
            "headers" => Dict{String,Any}("instance-id" => instance_id),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function disassociate_library_item_review(
    instance_id,
    libraryItemId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qapps(
        "POST",
        "/catalog.disassociateItemRating",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "libraryItemId" => libraryItemId,
                    "headers" => Dict{String,Any}("instance-id" => instance_id),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_qapp_from_user(app_id, instance-id)
    disassociate_qapp_from_user(app_id, instance-id, params::Dict{String,<:Any})

Disassociates a Q App from a user removing the user's access to run the Q App.

# Arguments
- `app_id`: The unique identifier of the Q App to disassociate from the user.
- `instance-id`: The unique identifier of the Amazon Q Business application environment
  instance.

"""
function disassociate_qapp_from_user end

function disassociate_qapp_from_user(
    appId, instance_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qapps(
        "POST",
        "/apps.uninstall",
        Dict{String,Any}(
            "appId" => appId, "headers" => Dict{String,Any}("instance-id" => instance_id)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function disassociate_qapp_from_user(
    appId,
    instance_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qapps(
        "POST",
        "/apps.uninstall",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "appId" => appId,
                    "headers" => Dict{String,Any}("instance-id" => instance_id),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_library_item(instance-id, library_item_id)
    get_library_item(instance-id, library_item_id, params::Dict{String,<:Any})

Retrieves details about a library item for an Amazon Q App, including its metadata,
categories, ratings, and usage statistics.

# Arguments
- `instance-id`: The unique identifier of the Amazon Q Business application environment
  instance.
- `library_item_id`: The unique identifier of the library item to retrieve.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"appId"`: The unique identifier of the Amazon Q App associated with the library item.
"""
function get_library_item end

function get_library_item(
    instance_id, libraryItemId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qapps(
        "GET",
        "/catalog.getItem",
        Dict{String,Any}(
            "libraryItemId" => libraryItemId,
            "headers" => Dict{String,Any}("instance-id" => instance_id),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function get_library_item(
    instance_id,
    libraryItemId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qapps(
        "GET",
        "/catalog.getItem",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "libraryItemId" => libraryItemId,
                    "headers" => Dict{String,Any}("instance-id" => instance_id),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_qapp(app_id, instance-id)
    get_qapp(app_id, instance-id, params::Dict{String,<:Any})

Retrieves the full details of an Q App, including its definition specifying the cards and
flow.

# Arguments
- `app_id`: The unique identifier of the Q App to retrieve.
- `instance-id`: The unique identifier of the Amazon Q Business application environment
  instance.

"""
function get_qapp end

function get_qapp(appId, instance_id; aws_config::AbstractAWSConfig=current_aws_config())
    return qapps(
        "GET",
        "/apps.get",
        Dict{String,Any}(
            "appId" => appId, "headers" => Dict{String,Any}("instance-id" => instance_id)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function get_qapp(
    appId,
    instance_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qapps(
        "GET",
        "/apps.get",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "appId" => appId,
                    "headers" => Dict{String,Any}("instance-id" => instance_id),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_qapp_session(instance-id, session_id)
    get_qapp_session(instance-id, session_id, params::Dict{String,<:Any})

Retrieves the current state and results for an active session of an Amazon Q App.

# Arguments
- `instance-id`: The unique identifier of the Amazon Q Business application environment
  instance.
- `session_id`: The unique identifier of the Q App session to retrieve.

"""
function get_qapp_session end

function get_qapp_session(
    instance_id, sessionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qapps(
        "GET",
        "/runtime.getQAppSession",
        Dict{String,Any}(
            "sessionId" => sessionId,
            "headers" => Dict{String,Any}("instance-id" => instance_id),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function get_qapp_session(
    instance_id,
    sessionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qapps(
        "GET",
        "/runtime.getQAppSession",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "sessionId" => sessionId,
                    "headers" => Dict{String,Any}("instance-id" => instance_id),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    import_document(app_id, card_id, file_contents_base64, file_name, instance-id, scope)
    import_document(app_id, card_id, file_contents_base64, file_name, instance-id, scope, params::Dict{String,<:Any})

Uploads a file that can then be used either as a default in a FileUploadCard from Q App
definition or as a file that is used inside a single Q App run. The purpose of the document
is determined by a scope parameter that indicates whether it is at the app definition level
or at the app session level.

# Arguments
- `app_id`: The unique identifier of the Q App the file is associated with.
- `card_id`: The unique identifier of the card the file is associated with, if applicable.
- `file_contents_base64`: The base64-encoded contents of the file to upload.
- `file_name`: The name of the file being uploaded.
- `instance-id`: The unique identifier of the Amazon Q Business application environment
  instance.
- `scope`: Whether the file is associated with an Q App definition or a specific Q App
  session.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"sessionId"`: The unique identifier of the Q App session the file is associated with, if
  applicable.
"""
function import_document end

function import_document(
    appId,
    cardId,
    fileContentsBase64,
    fileName,
    instance_id,
    scope;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qapps(
        "POST",
        "/apps.importDocument",
        Dict{String,Any}(
            "appId" => appId,
            "cardId" => cardId,
            "fileContentsBase64" => fileContentsBase64,
            "fileName" => fileName,
            "scope" => scope,
            "headers" => Dict{String,Any}("instance-id" => instance_id),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function import_document(
    appId,
    cardId,
    fileContentsBase64,
    fileName,
    instance_id,
    scope,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qapps(
        "POST",
        "/apps.importDocument",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "appId" => appId,
                    "cardId" => cardId,
                    "fileContentsBase64" => fileContentsBase64,
                    "fileName" => fileName,
                    "scope" => scope,
                    "headers" => Dict{String,Any}("instance-id" => instance_id),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_library_items(instance-id)
    list_library_items(instance-id, params::Dict{String,<:Any})

Lists the library items for Amazon Q Apps that are published and available for users in
your Amazon Web Services account.

# Arguments
- `instance-id`: The unique identifier of the Amazon Q Business application environment
  instance.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"categoryId"`: Optional category to filter the library items by.
- `"limit"`: The maximum number of library items to return in the response.
- `"nextToken"`: The token to request the next page of results.
"""
function list_library_items end

function list_library_items(instance_id; aws_config::AbstractAWSConfig=current_aws_config())
    return qapps(
        "GET",
        "/catalog.list",
        Dict{String,Any}("headers" => Dict{String,Any}("instance-id" => instance_id));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function list_library_items(
    instance_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qapps(
        "GET",
        "/catalog.list",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "headers" => Dict{String,Any}("instance-id" => instance_id)
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_qapps(instance-id)
    list_qapps(instance-id, params::Dict{String,<:Any})

Lists the Amazon Q Apps owned by or associated with the user either because they created it
or because they used it from the library in the past. The user identity is extracted from
the credentials used to invoke this operation..

# Arguments
- `instance-id`: The unique identifier of the Amazon Q Business application environment
  instance.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"limit"`: The maximum number of Q Apps to return in the response.
- `"nextToken"`: The token to request the next page of results.
"""
function list_qapps end

function list_qapps(instance_id; aws_config::AbstractAWSConfig=current_aws_config())
    return qapps(
        "GET",
        "/apps.list",
        Dict{String,Any}("headers" => Dict{String,Any}("instance-id" => instance_id));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function list_qapps(
    instance_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qapps(
        "GET",
        "/apps.list",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "headers" => Dict{String,Any}("instance-id" => instance_id)
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists the tags associated with an Amazon Q Apps resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource whose tags should be
  listed.

"""
function list_tags_for_resource end

function list_tags_for_resource(
    resourceARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qapps(
        "GET",
        "/tags/$(resourceARN)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function list_tags_for_resource(
    resourceARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qapps(
        "GET",
        "/tags/$(resourceARN)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    predict_qapp(instance-id)
    predict_qapp(instance-id, params::Dict{String,<:Any})

Generates an Amazon Q App definition based on either a conversation or a problem statement
provided as input.The resulting app definition can be used to call CreateQApp. This API
doesn't create Amazon Q Apps directly.

# Arguments
- `instance-id`: The unique identifier of the Amazon Q Business application environment
  instance.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"options"`: The input to generate the Q App definition from, either a conversation or
  problem statement.
"""
function predict_qapp end

function predict_qapp(instance_id; aws_config::AbstractAWSConfig=current_aws_config())
    return qapps(
        "POST",
        "/apps.predictQApp",
        Dict{String,Any}("headers" => Dict{String,Any}("instance-id" => instance_id));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function predict_qapp(
    instance_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qapps(
        "POST",
        "/apps.predictQApp",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "headers" => Dict{String,Any}("instance-id" => instance_id)
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_qapp_session(app_id, app_version, instance-id)
    start_qapp_session(app_id, app_version, instance-id, params::Dict{String,<:Any})

Starts a new session for an Amazon Q App, allowing inputs to be provided and the app to be
run.  Each Q App session will be condensed into a single conversation in the web
experience.

# Arguments
- `app_id`: The unique identifier of the Q App to start a session for.
- `app_version`: The version of the Q App to use for the session.
- `instance-id`: The unique identifier of the Amazon Q Business application environment
  instance.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"initialValues"`: Optional initial input values to provide for the Q App session.
- `"tags"`: Optional tags to associate with the new Q App session.
"""
function start_qapp_session end

function start_qapp_session(
    appId, appVersion, instance_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qapps(
        "POST",
        "/runtime.startQAppSession",
        Dict{String,Any}(
            "appId" => appId,
            "appVersion" => appVersion,
            "headers" => Dict{String,Any}("instance-id" => instance_id),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function start_qapp_session(
    appId,
    appVersion,
    instance_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qapps(
        "POST",
        "/runtime.startQAppSession",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "appId" => appId,
                    "appVersion" => appVersion,
                    "headers" => Dict{String,Any}("instance-id" => instance_id),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_qapp_session(instance-id, session_id)
    stop_qapp_session(instance-id, session_id, params::Dict{String,<:Any})

Stops an active session for an Amazon Q App.This deletes all data related to the session
and makes it invalid for future uses. The results of the session will be persisted as part
of the conversation.

# Arguments
- `instance-id`: The unique identifier of the Amazon Q Business application environment
  instance.
- `session_id`: The unique identifier of the Q App session to stop.

"""
function stop_qapp_session end

function stop_qapp_session(
    instance_id, sessionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qapps(
        "POST",
        "/runtime.deleteMiniAppRun",
        Dict{String,Any}(
            "sessionId" => sessionId,
            "headers" => Dict{String,Any}("instance-id" => instance_id),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function stop_qapp_session(
    instance_id,
    sessionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qapps(
        "POST",
        "/runtime.deleteMiniAppRun",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "sessionId" => sessionId,
                    "headers" => Dict{String,Any}("instance-id" => instance_id),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Associates tags with an Amazon Q Apps resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource to tag.
- `tags`: The tags to associate with the resource.

"""
function tag_resource end

function tag_resource(resourceARN, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return qapps(
        "POST",
        "/tags/$(resourceARN)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function tag_resource(
    resourceARN,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qapps(
        "POST",
        "/tags/$(resourceARN)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Disassociates tags from an Amazon Q Apps resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource to disassociate the tag
  from.
- `tag_keys`: The keys of the tags to disassociate from the resource.

"""
function untag_resource end

function untag_resource(
    resourceARN, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qapps(
        "DELETE",
        "/tags/$(resourceARN)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function untag_resource(
    resourceARN,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qapps(
        "DELETE",
        "/tags/$(resourceARN)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_library_item(instance-id, library_item_id)
    update_library_item(instance-id, library_item_id, params::Dict{String,<:Any})

Updates the library item for an Amazon Q App.

# Arguments
- `instance-id`: The unique identifier of the Amazon Q Business application environment
  instance.
- `library_item_id`: The unique identifier of the library item to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"categories"`: The new categories to associate with the library item.
- `"status"`: The new status to set for the library item, such as \"Published\" or
  \"Hidden\".
"""
function update_library_item end

function update_library_item(
    instance_id, libraryItemId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qapps(
        "POST",
        "/catalog.updateItem",
        Dict{String,Any}(
            "libraryItemId" => libraryItemId,
            "headers" => Dict{String,Any}("instance-id" => instance_id),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function update_library_item(
    instance_id,
    libraryItemId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qapps(
        "POST",
        "/catalog.updateItem",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "libraryItemId" => libraryItemId,
                    "headers" => Dict{String,Any}("instance-id" => instance_id),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_library_item_metadata(instance-id, library_item_id)
    update_library_item_metadata(instance-id, library_item_id, params::Dict{String,<:Any})

Updates the verification status of a library item for an Amazon Q App.

# Arguments
- `instance-id`: The unique identifier of the Amazon Q Business application environment
  instance.
- `library_item_id`: The unique identifier of the updated library item.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"isVerified"`: The verification status of the library item
"""
function update_library_item_metadata end

function update_library_item_metadata(
    instance_id, libraryItemId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qapps(
        "POST",
        "/catalog.updateItemMetadata",
        Dict{String,Any}(
            "libraryItemId" => libraryItemId,
            "headers" => Dict{String,Any}("instance-id" => instance_id),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function update_library_item_metadata(
    instance_id,
    libraryItemId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qapps(
        "POST",
        "/catalog.updateItemMetadata",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "libraryItemId" => libraryItemId,
                    "headers" => Dict{String,Any}("instance-id" => instance_id),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_qapp(app_id, instance-id)
    update_qapp(app_id, instance-id, params::Dict{String,<:Any})

Updates an existing Amazon Q App, allowing modifications to its title, description, and
definition.

# Arguments
- `app_id`: The unique identifier of the Q App to update.
- `instance-id`: The unique identifier of the Amazon Q Business application environment
  instance.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"appDefinition"`: The new definition specifying the cards and flow for the Q App.
- `"description"`: The new description for the Q App.
- `"title"`: The new title for the Q App.
"""
function update_qapp end

function update_qapp(appId, instance_id; aws_config::AbstractAWSConfig=current_aws_config())
    return qapps(
        "POST",
        "/apps.update",
        Dict{String,Any}(
            "appId" => appId, "headers" => Dict{String,Any}("instance-id" => instance_id)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function update_qapp(
    appId,
    instance_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qapps(
        "POST",
        "/apps.update",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "appId" => appId,
                    "headers" => Dict{String,Any}("instance-id" => instance_id),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_qapp_session(instance-id, session_id)
    update_qapp_session(instance-id, session_id, params::Dict{String,<:Any})

Updates the session for a given Q App sessionId. This is only valid when at least one card
of the session is in the WAITING state. Data for each WAITING card can be provided as
input. If inputs are not provided, the call will be accepted but session will not move
forward. Inputs for cards that are not in the WAITING status will be ignored.

# Arguments
- `instance-id`: The unique identifier of the Amazon Q Business application environment
  instance.
- `session_id`: The unique identifier of the Q App session to provide input for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"values"`: The input values to provide for the current state of the Q App session.
"""
function update_qapp_session end

function update_qapp_session(
    instance_id, sessionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qapps(
        "POST",
        "/runtime.updateQAppSession",
        Dict{String,Any}(
            "sessionId" => sessionId,
            "headers" => Dict{String,Any}("instance-id" => instance_id),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function update_qapp_session(
    instance_id,
    sessionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qapps(
        "POST",
        "/runtime.updateQAppSession",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "sessionId" => sessionId,
                    "headers" => Dict{String,Any}("instance-id" => instance_id),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: iot_data_plane
using AWS.Compat
using AWS.UUIDs

"""
    delete_thing_shadow(thing_name)
    delete_thing_shadow(thing_name, params::Dict{String,<:Any})

Deletes the shadow for the specified thing. Requires permission to access the
DeleteThingShadow action. For more information, see DeleteThingShadow in the IoT Developer
Guide.

# Arguments
- `thing_name`: The name of the thing.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"name"`: The name of the shadow.
"""
function delete_thing_shadow(thingName; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_data_plane(
        "DELETE",
        "/things/$(thingName)/shadow";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_thing_shadow(
    thingName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_data_plane(
        "DELETE",
        "/things/$(thingName)/shadow",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_retained_message(topic)
    get_retained_message(topic, params::Dict{String,<:Any})

Gets the details of a single retained message for the specified topic. This action returns
the message payload of the retained message, which can incur messaging costs. To list only
the topic names of the retained messages, call ListRetainedMessages. Requires permission to
access the GetRetainedMessage action. For more information about messaging costs, see
Amazon Web Services IoT Core pricing - Messaging.

# Arguments
- `topic`: The topic name of the retained message to retrieve.

"""
function get_retained_message(topic; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_data_plane(
        "GET",
        "/retainedMessage/$(topic)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_retained_message(
    topic, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_data_plane(
        "GET",
        "/retainedMessage/$(topic)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_thing_shadow(thing_name)
    get_thing_shadow(thing_name, params::Dict{String,<:Any})

Gets the shadow for the specified thing. Requires permission to access the GetThingShadow
action. For more information, see GetThingShadow in the IoT Developer Guide.

# Arguments
- `thing_name`: The name of the thing.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"name"`: The name of the shadow.
"""
function get_thing_shadow(thingName; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_data_plane(
        "GET",
        "/things/$(thingName)/shadow";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_thing_shadow(
    thingName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_data_plane(
        "GET",
        "/things/$(thingName)/shadow",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_named_shadows_for_thing(thing_name)
    list_named_shadows_for_thing(thing_name, params::Dict{String,<:Any})

Lists the shadows for the specified thing. Requires permission to access the
ListNamedShadowsForThing action.

# Arguments
- `thing_name`: The name of the thing.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: The token to retrieve the next set of results.
- `"pageSize"`: The result page size.
"""
function list_named_shadows_for_thing(
    thingName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_data_plane(
        "GET",
        "/api/things/shadow/ListNamedShadowsForThing/$(thingName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_named_shadows_for_thing(
    thingName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_data_plane(
        "GET",
        "/api/things/shadow/ListNamedShadowsForThing/$(thingName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_retained_messages()
    list_retained_messages(params::Dict{String,<:Any})

Lists summary information about the retained messages stored for the account. This action
returns only the topic names of the retained messages. It doesn't return any message
payloads. Although this action doesn't return a message payload, it can still incur
messaging costs. To get the message payload of a retained message, call GetRetainedMessage
with the topic name of the retained message. Requires permission to access the
ListRetainedMessages action. For more information about messaging costs, see Amazon Web
Services IoT Core pricing - Messaging.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return at one time.
- `"nextToken"`: To retrieve the next set of results, the nextToken value from a previous
  response; otherwise null to receive the first set of results.
"""
function list_retained_messages(; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_data_plane(
        "GET", "/retainedMessage"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_retained_messages(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_data_plane(
        "GET",
        "/retainedMessage",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    publish(topic)
    publish(topic, params::Dict{String,<:Any})

Publishes an MQTT message. Requires permission to access the Publish action. For more
information about MQTT messages, see MQTT Protocol in the IoT Developer Guide. For more
information about messaging costs, see Amazon Web Services IoT Core pricing - Messaging.

# Arguments
- `topic`: The name of the MQTT topic.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"contentType"`: A UTF-8 encoded string that describes the content of the publishing
  message.
- `"messageExpiry"`: A user-defined integer value that represents the message expiry
  interval in seconds. If absent, the message doesn't expire. For more information about the
  limits of messageExpiry, see Amazon Web Services IoT Core message broker and protocol
  limits and quotas  from the Amazon Web Services Reference Guide.
- `"payload"`: The message body. MQTT accepts text, binary, and empty (null) message
  payloads. Publishing an empty (null) payload with retain = true deletes the retained
  message identified by topic from Amazon Web Services IoT Core.
- `"qos"`: The Quality of Service (QoS) level. The default QoS level is 0.
- `"responseTopic"`: A UTF-8 encoded string that's used as the topic name for a response
  message. The response topic is used to describe the topic which the receiver should publish
  to as part of the request-response flow. The topic must not contain wildcard characters.
- `"retain"`: A Boolean value that determines whether to set the RETAIN flag when the
  message is published. Setting the RETAIN flag causes the message to be retained and sent to
  new subscribers to the topic. Valid values: true | false  Default value: false
- `"x-amz-mqtt5-correlation-data"`: The base64-encoded binary data used by the sender of
  the request message to identify which request the response message is for when it's
  received. correlationData is an HTTP header value in the API.
- `"x-amz-mqtt5-payload-format-indicator"`: An Enum string value that indicates whether the
  payload is formatted as UTF-8. payloadFormatIndicator is an HTTP header value in the API.
- `"x-amz-mqtt5-user-properties"`: A JSON string that contains an array of JSON objects. If
  you don’t use Amazon Web Services SDK or CLI, you must encode the JSON string to base64
  format before adding it to the HTTP header. userProperties is an HTTP header value in the
  API. The following example userProperties parameter is a JSON string which represents two
  User Properties. Note that it needs to be base64-encoded:  [{\"deviceName\": \"alpha\"},
  {\"deviceCnt\": \"45\"}]
"""
function publish(topic; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_data_plane(
        "POST", "/topics/$(topic)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function publish(
    topic, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_data_plane(
        "POST",
        "/topics/$(topic)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_thing_shadow(payload, thing_name)
    update_thing_shadow(payload, thing_name, params::Dict{String,<:Any})

Updates the shadow for the specified thing. Requires permission to access the
UpdateThingShadow action. For more information, see UpdateThingShadow in the IoT Developer
Guide.

# Arguments
- `payload`: The state information, in JSON format.
- `thing_name`: The name of the thing.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"name"`: The name of the shadow.
"""
function update_thing_shadow(
    payload, thingName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_data_plane(
        "POST",
        "/things/$(thingName)/shadow",
        Dict{String,Any}("payload" => payload);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_thing_shadow(
    payload,
    thingName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_data_plane(
        "POST",
        "/things/$(thingName)/shadow",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("payload" => payload), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: ivschat
using AWS.Compat
using AWS.UUIDs

"""
    create_chat_token(room_identifier, user_id)
    create_chat_token(room_identifier, user_id, params::Dict{String,<:Any})

Creates an encrypted token that is used by a chat participant to establish an individual
WebSocket chat connection to a room. When the token is used to connect to chat, the
connection is valid for the session duration specified in the request. The token becomes
invalid at the token-expiration timestamp included in the response. Use the capabilities
field to permit an end user to send messages or moderate a room. The attributes field
securely attaches structured data to the chat session; the data is included within each
message sent by the end user and received by other participants in the room. Common use
cases for attributes include passing end-user profile data like an icon, display name,
colors, badges, and other display features. Encryption keys are owned by Amazon IVS Chat
and never used directly by your application.

# Arguments
- `room_identifier`: Identifier of the room that the client is trying to access. Currently
  this must be an ARN.
- `user_id`: Application-provided ID that uniquely identifies the user associated with this
  token. This can be any UTF-8 encoded text.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"attributes"`: Application-provided attributes to encode into the token and attach to a
  chat session. Map keys and values can contain UTF-8 encoded text. The maximum length of
  this field is 1 KB total.
- `"capabilities"`: Set of capabilities that the user is allowed to perform in the room.
  Default: None (the capability to view messages is implicitly included in all requests).
- `"sessionDurationInMinutes"`: Session duration (in minutes), after which the session
  expires. Default: 60 (1 hour).
"""
function create_chat_token(
    roomIdentifier, userId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivschat(
        "POST",
        "/CreateChatToken",
        Dict{String,Any}("roomIdentifier" => roomIdentifier, "userId" => userId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_chat_token(
    roomIdentifier,
    userId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ivschat(
        "POST",
        "/CreateChatToken",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("roomIdentifier" => roomIdentifier, "userId" => userId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_logging_configuration(destination_configuration)
    create_logging_configuration(destination_configuration, params::Dict{String,<:Any})

Creates a logging configuration that allows clients to store and record sent messages.

# Arguments
- `destination_configuration`: A complex type that contains a destination configuration for
  where chat content will be logged. There can be only one type of destination
  (cloudWatchLogs, firehose, or s3) in a destinationConfiguration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"name"`: Logging-configuration name. The value does not need to be unique.
- `"tags"`: Tags to attach to the resource. Array of maps, each of the form string:string
  (key:value). See Tagging AWS Resources for details, including restrictions that apply to
  tags and \"Tag naming limits and requirements\"; Amazon IVS Chat has no constraints on tags
  beyond what is documented there.
"""
function create_logging_configuration(
    destinationConfiguration; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivschat(
        "POST",
        "/CreateLoggingConfiguration",
        Dict{String,Any}("destinationConfiguration" => destinationConfiguration);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_logging_configuration(
    destinationConfiguration,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ivschat(
        "POST",
        "/CreateLoggingConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("destinationConfiguration" => destinationConfiguration),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_room()
    create_room(params::Dict{String,<:Any})

Creates a room that allows clients to connect and pass messages.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"loggingConfigurationIdentifiers"`: Array of logging-configuration identifiers attached
  to the room.
- `"maximumMessageLength"`: Maximum number of characters in a single message. Messages are
  expected to be UTF-8 encoded and this limit applies specifically to rune/code-point count,
  not number of bytes. Default: 500.
- `"maximumMessageRatePerSecond"`: Maximum number of messages per second that can be sent
  to the room (by all clients). Default: 10.
- `"messageReviewHandler"`: Configuration information for optional review of messages.
- `"name"`: Room name. The value does not need to be unique.
- `"tags"`: Tags to attach to the resource. Array of maps, each of the form string:string
  (key:value). See Tagging AWS Resources for details, including restrictions that apply to
  tags and \"Tag naming limits and requirements\"; Amazon IVS Chat has no constraints beyond
  what is documented there.
"""
function create_room(; aws_config::AbstractAWSConfig=current_aws_config())
    return ivschat(
        "POST", "/CreateRoom"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function create_room(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivschat(
        "POST",
        "/CreateRoom",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_logging_configuration(identifier)
    delete_logging_configuration(identifier, params::Dict{String,<:Any})

Deletes the specified logging configuration.

# Arguments
- `identifier`: Identifier of the logging configuration to be deleted.

"""
function delete_logging_configuration(
    identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivschat(
        "POST",
        "/DeleteLoggingConfiguration",
        Dict{String,Any}("identifier" => identifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_logging_configuration(
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ivschat(
        "POST",
        "/DeleteLoggingConfiguration",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("identifier" => identifier), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_message(id, room_identifier)
    delete_message(id, room_identifier, params::Dict{String,<:Any})

Sends an event to a specific room which directs clients to delete a specific message; that
is, unrender it from view and delete it from the client’s chat history. This event’s
EventName is aws:DELETE_MESSAGE. This replicates the  DeleteMessage WebSocket operation in
the Amazon IVS Chat Messaging API.

# Arguments
- `id`: ID of the message to be deleted. This is the Id field in the received message (see
  Message (Subscribe) in the Chat Messaging API).
- `room_identifier`: Identifier of the room where the message should be deleted. Currently
  this must be an ARN.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"reason"`: Reason for deleting the message.
"""
function delete_message(
    id, roomIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivschat(
        "POST",
        "/DeleteMessage",
        Dict{String,Any}("id" => id, "roomIdentifier" => roomIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_message(
    id,
    roomIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ivschat(
        "POST",
        "/DeleteMessage",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("id" => id, "roomIdentifier" => roomIdentifier),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_room(identifier)
    delete_room(identifier, params::Dict{String,<:Any})

Deletes the specified room.

# Arguments
- `identifier`: Identifier of the room to be deleted. Currently this must be an ARN.

"""
function delete_room(identifier; aws_config::AbstractAWSConfig=current_aws_config())
    return ivschat(
        "POST",
        "/DeleteRoom",
        Dict{String,Any}("identifier" => identifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_room(
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ivschat(
        "POST",
        "/DeleteRoom",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("identifier" => identifier), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disconnect_user(room_identifier, user_id)
    disconnect_user(room_identifier, user_id, params::Dict{String,<:Any})

Disconnects all connections using a specified user ID from a room. This replicates the
DisconnectUser WebSocket operation in the Amazon IVS Chat Messaging API.

# Arguments
- `room_identifier`: Identifier of the room from which the user's clients should be
  disconnected. Currently this must be an ARN.
- `user_id`: ID of the user (connection) to disconnect from the room.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"reason"`: Reason for disconnecting the user.
"""
function disconnect_user(
    roomIdentifier, userId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivschat(
        "POST",
        "/DisconnectUser",
        Dict{String,Any}("roomIdentifier" => roomIdentifier, "userId" => userId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disconnect_user(
    roomIdentifier,
    userId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ivschat(
        "POST",
        "/DisconnectUser",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("roomIdentifier" => roomIdentifier, "userId" => userId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_logging_configuration(identifier)
    get_logging_configuration(identifier, params::Dict{String,<:Any})

Gets the specified logging configuration.

# Arguments
- `identifier`: Identifier of the logging configuration to be retrieved.

"""
function get_logging_configuration(
    identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivschat(
        "POST",
        "/GetLoggingConfiguration",
        Dict{String,Any}("identifier" => identifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_logging_configuration(
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ivschat(
        "POST",
        "/GetLoggingConfiguration",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("identifier" => identifier), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_room(identifier)
    get_room(identifier, params::Dict{String,<:Any})

Gets the specified room.

# Arguments
- `identifier`: Identifier of the room for which the configuration is to be retrieved.
  Currently this must be an ARN.

"""
function get_room(identifier; aws_config::AbstractAWSConfig=current_aws_config())
    return ivschat(
        "POST",
        "/GetRoom",
        Dict{String,Any}("identifier" => identifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_room(
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ivschat(
        "POST",
        "/GetRoom",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("identifier" => identifier), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_logging_configurations()
    list_logging_configurations(params::Dict{String,<:Any})

Gets summary information about all your logging configurations in the AWS region where the
API request is processed.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Maximum number of logging configurations to return. Default: 50.
- `"nextToken"`: The first logging configurations to retrieve. This is used for pagination;
  see the nextToken response field.
"""
function list_logging_configurations(; aws_config::AbstractAWSConfig=current_aws_config())
    return ivschat(
        "POST",
        "/ListLoggingConfigurations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_logging_configurations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivschat(
        "POST",
        "/ListLoggingConfigurations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_rooms()
    list_rooms(params::Dict{String,<:Any})

Gets summary information about all your rooms in the AWS region where the API request is
processed. Results are sorted in descending order of updateTime.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"loggingConfigurationIdentifier"`: Logging-configuration identifier.
- `"maxResults"`: Maximum number of rooms to return. Default: 50.
- `"messageReviewHandlerUri"`: Filters the list to match the specified message review
  handler URI.
- `"name"`: Filters the list to match the specified room name.
- `"nextToken"`: The first room to retrieve. This is used for pagination; see the nextToken
  response field.
"""
function list_rooms(; aws_config::AbstractAWSConfig=current_aws_config())
    return ivschat(
        "POST", "/ListRooms"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_rooms(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivschat(
        "POST", "/ListRooms", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Gets information about AWS tags for the specified ARN.

# Arguments
- `resource_arn`: The ARN of the resource to be retrieved. The ARN must be URL-encoded.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivschat(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ivschat(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    send_event(event_name, room_identifier)
    send_event(event_name, room_identifier, params::Dict{String,<:Any})

Sends an event to a room. Use this within your application’s business logic to send
events to clients of a room; e.g., to notify clients to change the way the chat UI is
rendered.

# Arguments
- `event_name`: Application-defined name of the event to send to clients.
- `room_identifier`: Identifier of the room to which the event will be sent. Currently this
  must be an ARN.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"attributes"`: Application-defined metadata to attach to the event sent to clients. The
  maximum length of the metadata is 1 KB total.
"""
function send_event(
    eventName, roomIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivschat(
        "POST",
        "/SendEvent",
        Dict{String,Any}("eventName" => eventName, "roomIdentifier" => roomIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function send_event(
    eventName,
    roomIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ivschat(
        "POST",
        "/SendEvent",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "eventName" => eventName, "roomIdentifier" => roomIdentifier
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds or updates tags for the AWS resource with the specified ARN.

# Arguments
- `resource_arn`: The ARN of the resource to be tagged. The ARN must be URL-encoded.
- `tags`: Array of tags to be added or updated. Array of maps, each of the form
  string:string (key:value). See Tagging AWS Resources for details, including restrictions
  that apply to tags and \"Tag naming limits and requirements\"; Amazon IVS Chat has no
  constraints beyond what is documented there.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return ivschat(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ivschat(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes tags from the resource with the specified ARN.

# Arguments
- `resource_arn`: The ARN of the resource to be untagged. The ARN must be URL-encoded.
- `tag_keys`: Array of tags to be removed. Array of maps, each of the form string:string
  (key:value). See Tagging AWS Resources for details, including restrictions that apply to
  tags and \"Tag naming limits and requirements\"; Amazon IVS Chat has no constraints beyond
  what is documented there.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivschat(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ivschat(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_logging_configuration(identifier)
    update_logging_configuration(identifier, params::Dict{String,<:Any})

Updates a specified logging configuration.

# Arguments
- `identifier`: Identifier of the logging configuration to be updated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"destinationConfiguration"`: A complex type that contains a destination configuration
  for where chat content will be logged. There can be only one type of destination
  (cloudWatchLogs, firehose, or s3) in a destinationConfiguration.
- `"name"`: Logging-configuration name. The value does not need to be unique.
"""
function update_logging_configuration(
    identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivschat(
        "POST",
        "/UpdateLoggingConfiguration",
        Dict{String,Any}("identifier" => identifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_logging_configuration(
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ivschat(
        "POST",
        "/UpdateLoggingConfiguration",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("identifier" => identifier), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_room(identifier)
    update_room(identifier, params::Dict{String,<:Any})

Updates a room’s configuration.

# Arguments
- `identifier`: Identifier of the room to be updated. Currently this must be an ARN.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"loggingConfigurationIdentifiers"`: Array of logging-configuration identifiers attached
  to the room.
- `"maximumMessageLength"`: The maximum number of characters in a single message. Messages
  are expected to be UTF-8 encoded and this limit applies specifically to rune/code-point
  count, not number of bytes. Default: 500.
- `"maximumMessageRatePerSecond"`: Maximum number of messages per second that can be sent
  to the room (by all clients). Default: 10.
- `"messageReviewHandler"`: Configuration information for optional review of messages.
  Specify an empty uri string to disassociate a message review handler from the specified
  room.
- `"name"`: Room name. The value does not need to be unique.
"""
function update_room(identifier; aws_config::AbstractAWSConfig=current_aws_config())
    return ivschat(
        "POST",
        "/UpdateRoom",
        Dict{String,Any}("identifier" => identifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_room(
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ivschat(
        "POST",
        "/UpdateRoom",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("identifier" => identifier), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: lex_models_v2
using AWS.Compat
using AWS.UUIDs

"""
    batch_create_custom_vocabulary_item(bot_id, bot_version, custom_vocabulary_item_list, locale_id)
    batch_create_custom_vocabulary_item(bot_id, bot_version, custom_vocabulary_item_list, locale_id, params::Dict{String,<:Any})

Create a batch of custom vocabulary items for a given bot locale's custom vocabulary.

# Arguments
- `bot_id`: The identifier of the bot associated with this custom vocabulary.
- `bot_version`: The identifier of the version of the bot associated with this custom
  vocabulary.
- `custom_vocabulary_item_list`: A list of new custom vocabulary items. Each entry must
  contain a phrase and can optionally contain a displayAs and/or a weight.
- `locale_id`: The identifier of the language and locale where this custom vocabulary is
  used. The string must match one of the supported locales. For more information, see
  Supported Languages .

"""
function batch_create_custom_vocabulary_item(
    botId,
    botVersion,
    customVocabularyItemList,
    localeId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "PUT",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/customvocabulary/DEFAULT/batchcreate",
        Dict{String,Any}("customVocabularyItemList" => customVocabularyItemList);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_create_custom_vocabulary_item(
    botId,
    botVersion,
    customVocabularyItemList,
    localeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "PUT",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/customvocabulary/DEFAULT/batchcreate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("customVocabularyItemList" => customVocabularyItemList),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_delete_custom_vocabulary_item(bot_id, bot_version, custom_vocabulary_item_list, locale_id)
    batch_delete_custom_vocabulary_item(bot_id, bot_version, custom_vocabulary_item_list, locale_id, params::Dict{String,<:Any})

Delete a batch of custom vocabulary items for a given bot locale's custom vocabulary.

# Arguments
- `bot_id`: The identifier of the bot associated with this custom vocabulary.
- `bot_version`: The identifier of the version of the bot associated with this custom
  vocabulary.
- `custom_vocabulary_item_list`: A list of custom vocabulary items requested to be deleted.
  Each entry must contain the unique custom vocabulary entry identifier.
- `locale_id`: The identifier of the language and locale where this custom vocabulary is
  used. The string must match one of the supported locales. For more information, see
  Supported Languages .

"""
function batch_delete_custom_vocabulary_item(
    botId,
    botVersion,
    customVocabularyItemList,
    localeId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "POST",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/customvocabulary/DEFAULT/batchdelete",
        Dict{String,Any}("customVocabularyItemList" => customVocabularyItemList);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_delete_custom_vocabulary_item(
    botId,
    botVersion,
    customVocabularyItemList,
    localeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "POST",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/customvocabulary/DEFAULT/batchdelete",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("customVocabularyItemList" => customVocabularyItemList),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_update_custom_vocabulary_item(bot_id, bot_version, custom_vocabulary_item_list, locale_id)
    batch_update_custom_vocabulary_item(bot_id, bot_version, custom_vocabulary_item_list, locale_id, params::Dict{String,<:Any})

Update a batch of custom vocabulary items for a given bot locale's custom vocabulary.

# Arguments
- `bot_id`: The identifier of the bot associated with this custom vocabulary
- `bot_version`: The identifier of the version of the bot associated with this custom
  vocabulary.
- `custom_vocabulary_item_list`: A list of custom vocabulary items with updated fields.
  Each entry must contain a phrase and can optionally contain a displayAs and/or a weight.
- `locale_id`: The identifier of the language and locale where this custom vocabulary is
  used. The string must match one of the supported locales. For more information, see
  Supported Languages .

"""
function batch_update_custom_vocabulary_item(
    botId,
    botVersion,
    customVocabularyItemList,
    localeId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "PUT",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/customvocabulary/DEFAULT/batchupdate",
        Dict{String,Any}("customVocabularyItemList" => customVocabularyItemList);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_update_custom_vocabulary_item(
    botId,
    botVersion,
    customVocabularyItemList,
    localeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "PUT",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/customvocabulary/DEFAULT/batchupdate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("customVocabularyItemList" => customVocabularyItemList),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    build_bot_locale(bot_id, bot_version, locale_id)
    build_bot_locale(bot_id, bot_version, locale_id, params::Dict{String,<:Any})

Builds a bot, its intents, and its slot types into a specific locale. A bot can be built
into multiple locales. At runtime the locale is used to choose a specific build of the bot.

# Arguments
- `bot_id`: The identifier of the bot to build. The identifier is returned in the response
  from the CreateBot operation.
- `bot_version`: The version of the bot to build. This can only be the draft version of the
  bot.
- `locale_id`: The identifier of the language and locale that the bot will be used in. The
  string must match one of the supported locales. All of the intents, slot types, and slots
  used in the bot must have the same locale. For more information, see Supported languages.

"""
function build_bot_locale(
    botId, botVersion, localeId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_models_v2(
        "POST",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function build_bot_locale(
    botId,
    botVersion,
    localeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "POST",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_bot(bot_name, data_privacy, idle_session_ttlin_seconds, role_arn)
    create_bot(bot_name, data_privacy, idle_session_ttlin_seconds, role_arn, params::Dict{String,<:Any})

Creates an Amazon Lex conversational bot.

# Arguments
- `bot_name`: The name of the bot. The bot name must be unique in the account that creates
  the bot.
- `data_privacy`: Provides information on additional privacy protections Amazon Lex should
  use with the bot's data.
- `idle_session_ttlin_seconds`: The time, in seconds, that Amazon Lex should keep
  information about a user's conversation with the bot.  A user interaction remains active
  for the amount of time specified. If no conversation occurs during this time, the session
  expires and Amazon Lex deletes any data provided before the timeout. You can specify
  between 60 (1 minute) and 86,400 (24 hours) seconds.
- `role_arn`: The Amazon Resource Name (ARN) of an IAM role that has permission to access
  the bot.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"botMembers"`: The list of bot members in a network to be created.
- `"botTags"`: A list of tags to add to the bot. You can only add tags when you create a
  bot. You can't use the UpdateBot operation to update tags. To update tags, use the
  TagResource operation.
- `"botType"`: The type of a bot to create.
- `"description"`: A description of the bot. It appears in lists to help you identify a
  particular bot.
- `"testBotAliasTags"`: A list of tags to add to the test alias for a bot. You can only add
  tags when you create a bot. You can't use the UpdateAlias operation to update tags. To
  update tags on the test alias, use the TagResource operation.
"""
function create_bot(
    botName,
    dataPrivacy,
    idleSessionTTLInSeconds,
    roleArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "PUT",
        "/bots/",
        Dict{String,Any}(
            "botName" => botName,
            "dataPrivacy" => dataPrivacy,
            "idleSessionTTLInSeconds" => idleSessionTTLInSeconds,
            "roleArn" => roleArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_bot(
    botName,
    dataPrivacy,
    idleSessionTTLInSeconds,
    roleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "PUT",
        "/bots/",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "botName" => botName,
                    "dataPrivacy" => dataPrivacy,
                    "idleSessionTTLInSeconds" => idleSessionTTLInSeconds,
                    "roleArn" => roleArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_bot_alias(bot_alias_name, bot_id)
    create_bot_alias(bot_alias_name, bot_id, params::Dict{String,<:Any})

Creates an alias for the specified version of a bot. Use an alias to enable you to change
the version of a bot without updating applications that use the bot. For example, you can
create an alias called \"PROD\" that your applications use to call the Amazon Lex bot.

# Arguments
- `bot_alias_name`: The alias to create. The name must be unique for the bot.
- `bot_id`: The unique identifier of the bot that the alias applies to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"botAliasLocaleSettings"`: Maps configuration information to a specific locale. You can
  use this parameter to specify a specific Lambda function to run different functions in
  different locales.
- `"botVersion"`: The version of the bot that this alias points to. You can use the
  UpdateBotAlias operation to change the bot version associated with the alias.
- `"conversationLogSettings"`: Specifies whether Amazon Lex logs text and audio for a
  conversation with the bot. When you enable conversation logs, text logs store text input,
  transcripts of audio input, and associated metadata in Amazon CloudWatch Logs. Audio logs
  store audio input in Amazon S3.
- `"description"`: A description of the alias. Use this description to help identify the
  alias.
- `"sentimentAnalysisSettings"`:
- `"tags"`: A list of tags to add to the bot alias. You can only add tags when you create
  an alias, you can't use the UpdateBotAlias operation to update the tags on a bot alias. To
  update tags, use the TagResource operation.
"""
function create_bot_alias(
    botAliasName, botId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_models_v2(
        "PUT",
        "/bots/$(botId)/botaliases/",
        Dict{String,Any}("botAliasName" => botAliasName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_bot_alias(
    botAliasName,
    botId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "PUT",
        "/bots/$(botId)/botaliases/",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("botAliasName" => botAliasName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_bot_locale(bot_id, bot_version, locale_id, nlu_intent_confidence_threshold)
    create_bot_locale(bot_id, bot_version, locale_id, nlu_intent_confidence_threshold, params::Dict{String,<:Any})

Creates a locale in the bot. The locale contains the intents and slot types that the bot
uses in conversations with users in the specified language and locale. You must add a
locale to a bot before you can add intents and slot types to the bot.

# Arguments
- `bot_id`: The identifier of the bot to create the locale for.
- `bot_version`: The version of the bot to create the locale for. This can only be the
  draft version of the bot.
- `locale_id`: The identifier of the language and locale that the bot will be used in. The
  string must match one of the supported locales. All of the intents, slot types, and slots
  used in the bot must have the same locale. For more information, see Supported languages.
- `nlu_intent_confidence_threshold`: Determines the threshold where Amazon Lex will insert
  the AMAZON.FallbackIntent, AMAZON.KendraSearchIntent, or both when returning alternative
  intents. AMAZON.FallbackIntent and AMAZON.KendraSearchIntent are only inserted if they are
  configured for the bot. For example, suppose a bot is configured with the confidence
  threshold of 0.80 and the AMAZON.FallbackIntent. Amazon Lex returns three alternative
  intents with the following confidence scores: IntentA (0.70), IntentB (0.60), IntentC
  (0.50). The response from the RecognizeText operation would be:   AMAZON.FallbackIntent
  IntentA   IntentB   IntentC

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A description of the bot locale. Use this to help identify the bot
  locale in lists.
- `"generativeAISettings"`:
- `"voiceSettings"`: The Amazon Polly voice ID that Amazon Lex uses for voice interaction
  with the user.
"""
function create_bot_locale(
    botId,
    botVersion,
    localeId,
    nluIntentConfidenceThreshold;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "PUT",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/",
        Dict{String,Any}(
            "localeId" => localeId,
            "nluIntentConfidenceThreshold" => nluIntentConfidenceThreshold,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_bot_locale(
    botId,
    botVersion,
    localeId,
    nluIntentConfidenceThreshold,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "PUT",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "localeId" => localeId,
                    "nluIntentConfidenceThreshold" => nluIntentConfidenceThreshold,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_bot_replica(bot_id, replica_region)
    create_bot_replica(bot_id, replica_region, params::Dict{String,<:Any})

Action to create a replication of the source bot in the secondary region.

# Arguments
- `bot_id`: The request for the unique bot ID of the source bot to be replicated in the
  secondary region.
- `replica_region`: The request for the secondary region that will be used in the
  replication of the source bot.

"""
function create_bot_replica(
    botId, replicaRegion; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_models_v2(
        "PUT",
        "/bots/$(botId)/replicas/",
        Dict{String,Any}("replicaRegion" => replicaRegion);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_bot_replica(
    botId,
    replicaRegion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "PUT",
        "/bots/$(botId)/replicas/",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("replicaRegion" => replicaRegion), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_bot_version(bot_id, bot_version_locale_specification)
    create_bot_version(bot_id, bot_version_locale_specification, params::Dict{String,<:Any})

Creates an immutable version of the bot. When you create the first version of a bot, Amazon
Lex sets the version number to 1. Subsequent bot versions increase in an increment of 1.
The version number will always represent the total number of versions created of the bot,
not the current number of versions. If a bot version is deleted, that bot version number
will not be reused.

# Arguments
- `bot_id`: The identifier of the bot to create the version for.
- `bot_version_locale_specification`: Specifies the locales that Amazon Lex adds to this
  version. You can choose the Draft version or any other previously published version for
  each locale. When you specify a source version, the locale data is copied from the source
  version to the new version.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A description of the version. Use the description to help identify the
  version in lists.
"""
function create_bot_version(
    botId, botVersionLocaleSpecification; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_models_v2(
        "PUT",
        "/bots/$(botId)/botversions/",
        Dict{String,Any}("botVersionLocaleSpecification" => botVersionLocaleSpecification);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_bot_version(
    botId,
    botVersionLocaleSpecification,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "PUT",
        "/bots/$(botId)/botversions/",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "botVersionLocaleSpecification" => botVersionLocaleSpecification
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_export(file_format, resource_specification)
    create_export(file_format, resource_specification, params::Dict{String,<:Any})

Creates a zip archive containing the contents of a bot or a bot locale. The archive
contains a directory structure that contains JSON files that define the bot. You can create
an archive that contains the complete definition of a bot, or you can specify that the
archive contain only the definition of a single bot locale. For more information about
exporting bots, and about the structure of the export archive, see  Importing and exporting
bots

# Arguments
- `file_format`: The file format of the bot or bot locale definition files.
- `resource_specification`: Specifies the type of resource to export, either a bot or a bot
  locale. You can only specify one type of resource to export.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filePassword"`: An password to use to encrypt the exported archive. Using a password is
  optional, but you should encrypt the archive to protect the data in transit between Amazon
  Lex and your local computer.
"""
function create_export(
    fileFormat, resourceSpecification; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_models_v2(
        "PUT",
        "/exports/",
        Dict{String,Any}(
            "fileFormat" => fileFormat, "resourceSpecification" => resourceSpecification
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_export(
    fileFormat,
    resourceSpecification,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "PUT",
        "/exports/",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "fileFormat" => fileFormat,
                    "resourceSpecification" => resourceSpecification,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_intent(bot_id, bot_version, intent_name, locale_id)
    create_intent(bot_id, bot_version, intent_name, locale_id, params::Dict{String,<:Any})

Creates an intent. To define the interaction between the user and your bot, you define one
or more intents. For example, for a pizza ordering bot you would create an OrderPizza
intent. When you create an intent, you must provide a name. You can optionally provide the
following:   Sample utterances. For example, \"I want to order a pizza\" and \"Can I order
a pizza.\" You can't provide utterances for built-in intents.   Information to be gathered.
You specify slots for the information that you bot requests from the user. You can specify
standard slot types, such as date and time, or custom slot types for your application.
How the intent is fulfilled. You can provide a Lambda function or configure the intent to
return the intent information to your client application. If you use a Lambda function,
Amazon Lex invokes the function when all of the intent information is available.   A
confirmation prompt to send to the user to confirm an intent. For example, \"Shall I order
your pizza?\"   A conclusion statement to send to the user after the intent is fulfilled.
For example, \"I ordered your pizza.\"   A follow-up prompt that asks the user for
additional activity. For example, \"Do you want a drink with your pizza?\"

# Arguments
- `bot_id`: The identifier of the bot associated with this intent.
- `bot_version`: The version of the bot associated with this intent.
- `intent_name`: The name of the intent. Intent names must be unique in the locale that
  contains the intent and cannot match the name of any built-in intent.
- `locale_id`: The identifier of the language and locale where this intent is used. All of
  the bots, slot types, and slots used by the intent must have the same locale. For more
  information, see Supported languages.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A description of the intent. Use the description to help identify the
  intent in lists.
- `"dialogCodeHook"`: Specifies that Amazon Lex invokes the alias Lambda function for each
  user input. You can invoke this Lambda function to personalize user interaction. For
  example, suppose that your bot determines that the user's name is John. You Lambda function
  might retrieve John's information from a backend database and prepopulate some of the
  values. For example, if you find that John is gluten intolerant, you might set the
  corresponding intent slot, glutenIntolerant to true. You might find John's phone number and
  set the corresponding session attribute.
- `"fulfillmentCodeHook"`: Specifies that Amazon Lex invokes the alias Lambda function when
  the intent is ready for fulfillment. You can invoke this function to complete the bot's
  transaction with the user. For example, in a pizza ordering bot, the Lambda function can
  look up the closest pizza restaurant to the customer's location and then place an order on
  the customer's behalf.
- `"initialResponseSetting"`: Configuration settings for the response that is sent to the
  user at the beginning of a conversation, before eliciting slot values.
- `"inputContexts"`: A list of contexts that must be active for this intent to be
  considered by Amazon Lex. When an intent has an input context list, Amazon Lex only
  considers using the intent in an interaction with the user when the specified contexts are
  included in the active context list for the session. If the contexts are not active, then
  Amazon Lex will not use the intent. A context can be automatically activated using the
  outputContexts property or it can be set at runtime.  For example, if there are two intents
  with different input contexts that respond to the same utterances, only the intent with the
  active context will respond. An intent may have up to 5 input contexts. If an intent has
  multiple input contexts, all of the contexts must be active to consider the intent.
- `"intentClosingSetting"`: Sets the response that Amazon Lex sends to the user when the
  intent is closed.
- `"intentConfirmationSetting"`: Provides prompts that Amazon Lex sends to the user to
  confirm the completion of an intent. If the user answers \"no,\" the settings contain a
  statement that is sent to the user to end the intent.
- `"kendraConfiguration"`: Configuration information required to use the
  AMAZON.KendraSearchIntent intent to connect to an Amazon Kendra index. The
  AMAZON.KendraSearchIntent intent is called when Amazon Lex can't determine another intent
  to invoke.
- `"outputContexts"`: A lists of contexts that the intent activates when it is fulfilled.
  You can use an output context to indicate the intents that Amazon Lex should consider for
  the next turn of the conversation with a customer.  When you use the outputContextsList
  property, all of the contexts specified in the list are activated when the intent is
  fulfilled. You can set up to 10 output contexts. You can also set the number of
  conversation turns that the context should be active, or the length of time that the
  context should be active.
- `"parentIntentSignature"`: A unique identifier for the built-in intent to base this
  intent on.
- `"qnAIntentConfiguration"`: Specifies the configuration of the built-in Amazon.QnAIntent.
  The AMAZON.QnAIntent intent is called when Amazon Lex can't determine another intent to
  invoke. If you specify this field, you can't specify the kendraConfiguration field.
- `"sampleUtterances"`: An array of strings that a user might say to signal the intent. For
  example, \"I want a pizza\", or \"I want a {PizzaSize} pizza\".  In an utterance, slot
  names are enclosed in curly braces (\"{\", \"}\") to indicate where they should be
  displayed in the utterance shown to the user..
"""
function create_intent(
    botId,
    botVersion,
    intentName,
    localeId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "PUT",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/intents/",
        Dict{String,Any}("intentName" => intentName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_intent(
    botId,
    botVersion,
    intentName,
    localeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "PUT",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/intents/",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("intentName" => intentName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_resource_policy(policy, resource_arn)
    create_resource_policy(policy, resource_arn, params::Dict{String,<:Any})

Creates a new resource policy with the specified policy statements.

# Arguments
- `policy`: A resource policy to add to the resource. The policy is a JSON structure that
  contains one or more statements that define the policy. The policy must follow the IAM
  syntax. For more information about the contents of a JSON policy document, see  IAM JSON
  policy reference .  If the policy isn't valid, Amazon Lex returns a validation exception.
- `resource_arn`: The Amazon Resource Name (ARN) of the bot or bot alias that the resource
  policy is attached to.

"""
function create_resource_policy(
    policy, resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_models_v2(
        "POST",
        "/policy/$(resourceArn)/",
        Dict{String,Any}("policy" => policy);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_resource_policy(
    policy,
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "POST",
        "/policy/$(resourceArn)/",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("policy" => policy), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_resource_policy_statement(action, effect, principal, resource_arn, statement_id)
    create_resource_policy_statement(action, effect, principal, resource_arn, statement_id, params::Dict{String,<:Any})

Adds a new resource policy statement to a bot or bot alias. If a resource policy exists,
the statement is added to the current resource policy. If a policy doesn't exist, a new
policy is created. You can't create a resource policy statement that allows cross-account
access.

# Arguments
- `action`: The Amazon Lex action that this policy either allows or denies. The action must
  apply to the resource type of the specified ARN. For more information, see  Actions,
  resources, and condition keys for Amazon Lex V2.
- `effect`: Determines whether the statement allows or denies access to the resource.
- `principal`: An IAM principal, such as an IAM user, IAM role, or Amazon Web Services
  services that is allowed or denied access to a resource. For more information, see Amazon
  Web Services JSON policy elements: Principal.
- `resource_arn`: The Amazon Resource Name (ARN) of the bot or bot alias that the resource
  policy is attached to.
- `statement_id`: The name of the statement. The ID is the same as the Sid IAM property.
  The statement name must be unique within the policy. For more information, see IAM JSON
  policy elements: Sid.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"condition"`: Specifies a condition when the policy is in effect. If the principal of
  the policy is a service principal, you must provide two condition blocks, one with a
  SourceAccount global condition key and one with a SourceArn global condition key. For more
  information, see IAM JSON policy elements: Condition .
- `"expectedRevisionId"`: The identifier of the revision of the policy to edit. If this
  revision ID doesn't match the current revision ID, Amazon Lex throws an exception. If you
  don't specify a revision, Amazon Lex overwrites the contents of the policy with the new
  values.
"""
function create_resource_policy_statement(
    action,
    effect,
    principal,
    resourceArn,
    statementId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "POST",
        "/policy/$(resourceArn)/statements/",
        Dict{String,Any}(
            "action" => action,
            "effect" => effect,
            "principal" => principal,
            "statementId" => statementId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_resource_policy_statement(
    action,
    effect,
    principal,
    resourceArn,
    statementId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "POST",
        "/policy/$(resourceArn)/statements/",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "action" => action,
                    "effect" => effect,
                    "principal" => principal,
                    "statementId" => statementId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_slot(bot_id, bot_version, intent_id, locale_id, slot_name, value_elicitation_setting)
    create_slot(bot_id, bot_version, intent_id, locale_id, slot_name, value_elicitation_setting, params::Dict{String,<:Any})

Creates a slot in an intent. A slot is a variable needed to fulfill an intent. For example,
an OrderPizza intent might need slots for size, crust, and number of pizzas. For each slot,
you define one or more utterances that Amazon Lex uses to elicit a response from the user.

# Arguments
- `bot_id`: The identifier of the bot associated with the slot.
- `bot_version`: The version of the bot associated with the slot.
- `intent_id`: The identifier of the intent that contains the slot.
- `locale_id`: The identifier of the language and locale that the slot will be used in. The
  string must match one of the supported locales. All of the bots, intents, slot types used
  by the slot must have the same locale. For more information, see Supported languages.
- `slot_name`: The name of the slot. Slot names must be unique within the bot that contains
  the slot.
- `value_elicitation_setting`: Specifies prompts that Amazon Lex sends to the user to
  elicit a response that provides the value for the slot.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A description of the slot. Use this to help identify the slot in lists.
- `"multipleValuesSetting"`: Indicates whether the slot returns multiple values in one
  response. Multi-value slots are only available in the en-US locale. If you set this value
  to true in any other locale, Amazon Lex throws a ValidationException.  If the
  multipleValuesSetting is not set, the default value is false.
- `"obfuscationSetting"`: Determines how slot values are used in Amazon CloudWatch logs. If
  the value of the obfuscationSetting parameter is DefaultObfuscation, slot values are
  obfuscated in the log output. If the value is None, the actual value is present in the log
  output. The default is to obfuscate values in the CloudWatch logs.
- `"slotTypeId"`: The unique identifier for the slot type associated with this slot. The
  slot type determines the values that can be entered into the slot.
- `"subSlotSetting"`: Specifications for the constituent sub slots and the expression for
  the composite slot.
"""
function create_slot(
    botId,
    botVersion,
    intentId,
    localeId,
    slotName,
    valueElicitationSetting;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "PUT",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/intents/$(intentId)/slots/",
        Dict{String,Any}(
            "slotName" => slotName, "valueElicitationSetting" => valueElicitationSetting
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_slot(
    botId,
    botVersion,
    intentId,
    localeId,
    slotName,
    valueElicitationSetting,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "PUT",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/intents/$(intentId)/slots/",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "slotName" => slotName,
                    "valueElicitationSetting" => valueElicitationSetting,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_slot_type(bot_id, bot_version, locale_id, slot_type_name)
    create_slot_type(bot_id, bot_version, locale_id, slot_type_name, params::Dict{String,<:Any})

Creates a custom slot type  To create a custom slot type, specify a name for the slot type
and a set of enumeration values, the values that a slot of this type can assume.

# Arguments
- `bot_id`: The identifier of the bot associated with this slot type.
- `bot_version`: The identifier of the bot version associated with this slot type.
- `locale_id`: The identifier of the language and locale that the slot type will be used
  in. The string must match one of the supported locales. All of the bots, intents, and slots
  used by the slot type must have the same locale. For more information, see Supported
  languages.
- `slot_type_name`: The name for the slot. A slot type name must be unique within the
  intent.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"compositeSlotTypeSetting"`: Specifications for a composite slot type.
- `"description"`: A description of the slot type. Use the description to help identify the
  slot type in lists.
- `"externalSourceSetting"`: Sets the type of external information used to create the slot
  type.
- `"parentSlotTypeSignature"`: The built-in slot type used as a parent of this slot type.
  When you define a parent slot type, the new slot type has the configuration of the parent
  slot type. Only AMAZON.AlphaNumeric is supported.
- `"slotTypeValues"`: A list of SlotTypeValue objects that defines the values that the slot
  type can take. Each value can have a list of synonyms, additional values that help train
  the machine learning model about the values that it resolves for a slot.
- `"valueSelectionSetting"`: Determines the strategy that Amazon Lex uses to select a value
  from the list of possible values. The field can be set to one of the following values:
  ORIGINAL_VALUE - Returns the value entered by the user, if the user value is similar to the
  slot value.    TOP_RESOLUTION - If there is a resolution list for the slot, return the
  first value in the resolution list. If there is no resolution list, return null.   If you
  don't specify the valueSelectionSetting parameter, the default is ORIGINAL_VALUE.
"""
function create_slot_type(
    botId,
    botVersion,
    localeId,
    slotTypeName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "PUT",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/slottypes/",
        Dict{String,Any}("slotTypeName" => slotTypeName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_slot_type(
    botId,
    botVersion,
    localeId,
    slotTypeName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "PUT",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/slottypes/",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("slotTypeName" => slotTypeName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_test_set_discrepancy_report(target, test_set_id)
    create_test_set_discrepancy_report(target, test_set_id, params::Dict{String,<:Any})

Create a report that describes the differences between the bot and the test set.

# Arguments
- `target`: The target bot for the test set discrepancy report.
- `test_set_id`: The test set Id for the test set discrepancy report.

"""
function create_test_set_discrepancy_report(
    target, testSetId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_models_v2(
        "POST",
        "/testsets/$(testSetId)/testsetdiscrepancy",
        Dict{String,Any}("target" => target);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_test_set_discrepancy_report(
    target,
    testSetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "POST",
        "/testsets/$(testSetId)/testsetdiscrepancy",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("target" => target), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_upload_url()
    create_upload_url(params::Dict{String,<:Any})

Gets a pre-signed S3 write URL that you use to upload the zip archive when importing a bot
or a bot locale.

"""
function create_upload_url(; aws_config::AbstractAWSConfig=current_aws_config())
    return lex_models_v2(
        "POST", "/createuploadurl/"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function create_upload_url(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_models_v2(
        "POST",
        "/createuploadurl/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_bot(bot_id)
    delete_bot(bot_id, params::Dict{String,<:Any})

Deletes all versions of a bot, including the Draft version. To delete a specific version,
use the DeleteBotVersion operation. When you delete a bot, all of the resources contained
in the bot are also deleted. Deleting a bot removes all locales, intents, slot, and slot
types defined for the bot. If a bot has an alias, the DeleteBot operation returns a
ResourceInUseException exception. If you want to delete the bot and the alias, set the
skipResourceInUseCheck parameter to true.

# Arguments
- `bot_id`: The identifier of the bot to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"skipResourceInUseCheck"`: By default, Amazon Lex checks if any other resource, such as
  an alias or bot network, is using the bot version before it is deleted and throws a
  ResourceInUseException exception if the bot is being used by another resource. Set this
  parameter to true to skip this check and remove the bot even if it is being used by another
  resource.
"""
function delete_bot(botId; aws_config::AbstractAWSConfig=current_aws_config())
    return lex_models_v2(
        "DELETE", "/bots/$(botId)/"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function delete_bot(
    botId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_models_v2(
        "DELETE",
        "/bots/$(botId)/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_bot_alias(bot_alias_id, bot_id)
    delete_bot_alias(bot_alias_id, bot_id, params::Dict{String,<:Any})

Deletes the specified bot alias.

# Arguments
- `bot_alias_id`: The unique identifier of the bot alias to delete.
- `bot_id`: The unique identifier of the bot associated with the alias to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"skipResourceInUseCheck"`: By default, Amazon Lex checks if any other resource, such as
  a bot network, is using the bot alias before it is deleted and throws a
  ResourceInUseException exception if the alias is being used by another resource. Set this
  parameter to true to skip this check and remove the alias even if it is being used by
  another resource.
"""
function delete_bot_alias(
    botAliasId, botId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_models_v2(
        "DELETE",
        "/bots/$(botId)/botaliases/$(botAliasId)/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_bot_alias(
    botAliasId,
    botId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "DELETE",
        "/bots/$(botId)/botaliases/$(botAliasId)/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_bot_locale(bot_id, bot_version, locale_id)
    delete_bot_locale(bot_id, bot_version, locale_id, params::Dict{String,<:Any})

Removes a locale from a bot. When you delete a locale, all intents, slots, and slot types
defined for the locale are also deleted.

# Arguments
- `bot_id`: The unique identifier of the bot that contains the locale.
- `bot_version`: The version of the bot that contains the locale.
- `locale_id`: The identifier of the language and locale that will be deleted. The string
  must match one of the supported locales. For more information, see Supported languages.

"""
function delete_bot_locale(
    botId, botVersion, localeId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_models_v2(
        "DELETE",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_bot_locale(
    botId,
    botVersion,
    localeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "DELETE",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_bot_replica(bot_id, replica_region)
    delete_bot_replica(bot_id, replica_region, params::Dict{String,<:Any})

The action to delete the replicated bot in the secondary region.

# Arguments
- `bot_id`: The unique ID of the replicated bot to be deleted from the secondary region
- `replica_region`: The secondary region of the replicated bot that will be deleted.

"""
function delete_bot_replica(
    botId, replicaRegion; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_models_v2(
        "DELETE",
        "/bots/$(botId)/replicas/$(replicaRegion)/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_bot_replica(
    botId,
    replicaRegion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "DELETE",
        "/bots/$(botId)/replicas/$(replicaRegion)/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_bot_version(bot_id, bot_version)
    delete_bot_version(bot_id, bot_version, params::Dict{String,<:Any})

Deletes a specific version of a bot. To delete all versions of a bot, use the DeleteBot
operation.

# Arguments
- `bot_id`: The identifier of the bot that contains the version.
- `bot_version`: The version of the bot to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"skipResourceInUseCheck"`: By default, Amazon Lex checks if any other resource, such as
  an alias or bot network, is using the bot version before it is deleted and throws a
  ResourceInUseException exception if the version is being used by another resource. Set this
  parameter to true to skip this check and remove the version even if it is being used by
  another resource.
"""
function delete_bot_version(
    botId, botVersion; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_models_v2(
        "DELETE",
        "/bots/$(botId)/botversions/$(botVersion)/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_bot_version(
    botId,
    botVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "DELETE",
        "/bots/$(botId)/botversions/$(botVersion)/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_custom_vocabulary(bot_id, bot_version, locale_id)
    delete_custom_vocabulary(bot_id, bot_version, locale_id, params::Dict{String,<:Any})

Removes a custom vocabulary from the specified locale in the specified bot.

# Arguments
- `bot_id`: The unique identifier of the bot to remove the custom vocabulary from.
- `bot_version`: The version of the bot to remove the custom vocabulary from.
- `locale_id`: The locale identifier for the locale that contains the custom vocabulary to
  remove.

"""
function delete_custom_vocabulary(
    botId, botVersion, localeId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_models_v2(
        "DELETE",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/customvocabulary";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_custom_vocabulary(
    botId,
    botVersion,
    localeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "DELETE",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/customvocabulary",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_export(export_id)
    delete_export(export_id, params::Dict{String,<:Any})

Removes a previous export and the associated files stored in an S3 bucket.

# Arguments
- `export_id`: The unique identifier of the export to delete.

"""
function delete_export(exportId; aws_config::AbstractAWSConfig=current_aws_config())
    return lex_models_v2(
        "DELETE",
        "/exports/$(exportId)/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_export(
    exportId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "DELETE",
        "/exports/$(exportId)/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_import(import_id)
    delete_import(import_id, params::Dict{String,<:Any})

Removes a previous import and the associated file stored in an S3 bucket.

# Arguments
- `import_id`: The unique identifier of the import to delete.

"""
function delete_import(importId; aws_config::AbstractAWSConfig=current_aws_config())
    return lex_models_v2(
        "DELETE",
        "/imports/$(importId)/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_import(
    importId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "DELETE",
        "/imports/$(importId)/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_intent(bot_id, bot_version, intent_id, locale_id)
    delete_intent(bot_id, bot_version, intent_id, locale_id, params::Dict{String,<:Any})

Removes the specified intent. Deleting an intent also deletes the slots associated with the
intent.

# Arguments
- `bot_id`: The identifier of the bot associated with the intent.
- `bot_version`: The version of the bot associated with the intent.
- `intent_id`: The unique identifier of the intent to delete.
- `locale_id`: The identifier of the language and locale where the bot will be deleted. The
  string must match one of the supported locales. For more information, see Supported
  languages.

"""
function delete_intent(
    botId,
    botVersion,
    intentId,
    localeId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "DELETE",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/intents/$(intentId)/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_intent(
    botId,
    botVersion,
    intentId,
    localeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "DELETE",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/intents/$(intentId)/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_resource_policy(resource_arn)
    delete_resource_policy(resource_arn, params::Dict{String,<:Any})

Removes an existing policy from a bot or bot alias. If the resource doesn't have a policy
attached, Amazon Lex returns an exception.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the bot or bot alias that has the
  resource policy attached.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"expectedRevisionId"`: The identifier of the revision to edit. If this ID doesn't match
  the current revision number, Amazon Lex returns an exception If you don't specify a
  revision ID, Amazon Lex will delete the current policy.
"""
function delete_resource_policy(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_models_v2(
        "DELETE",
        "/policy/$(resourceArn)/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_resource_policy(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "DELETE",
        "/policy/$(resourceArn)/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_resource_policy_statement(resource_arn, statement_id)
    delete_resource_policy_statement(resource_arn, statement_id, params::Dict{String,<:Any})

Deletes a policy statement from a resource policy. If you delete the last statement from a
policy, the policy is deleted. If you specify a statement ID that doesn't exist in the
policy, or if the bot or bot alias doesn't have a policy attached, Amazon Lex returns an
exception.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the bot or bot alias that the resource
  policy is attached to.
- `statement_id`: The name of the statement (SID) to delete from the policy.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"expectedRevisionId"`: The identifier of the revision of the policy to delete the
  statement from. If this revision ID doesn't match the current revision ID, Amazon Lex
  throws an exception. If you don't specify a revision, Amazon Lex removes the current
  contents of the statement.
"""
function delete_resource_policy_statement(
    resourceArn, statementId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_models_v2(
        "DELETE",
        "/policy/$(resourceArn)/statements/$(statementId)/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_resource_policy_statement(
    resourceArn,
    statementId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "DELETE",
        "/policy/$(resourceArn)/statements/$(statementId)/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_slot(bot_id, bot_version, intent_id, locale_id, slot_id)
    delete_slot(bot_id, bot_version, intent_id, locale_id, slot_id, params::Dict{String,<:Any})

Deletes the specified slot from an intent.

# Arguments
- `bot_id`: The identifier of the bot associated with the slot to delete.
- `bot_version`: The version of the bot associated with the slot to delete.
- `intent_id`: The identifier of the intent associated with the slot.
- `locale_id`: The identifier of the language and locale that the slot will be deleted
  from. The string must match one of the supported locales. For more information, see
  Supported languages.
- `slot_id`: The identifier of the slot to delete.

"""
function delete_slot(
    botId,
    botVersion,
    intentId,
    localeId,
    slotId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "DELETE",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/intents/$(intentId)/slots/$(slotId)/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_slot(
    botId,
    botVersion,
    intentId,
    localeId,
    slotId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "DELETE",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/intents/$(intentId)/slots/$(slotId)/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_slot_type(bot_id, bot_version, locale_id, slot_type_id)
    delete_slot_type(bot_id, bot_version, locale_id, slot_type_id, params::Dict{String,<:Any})

Deletes a slot type from a bot locale. If a slot is using the slot type, Amazon Lex throws
a ResourceInUseException exception. To avoid the exception, set the skipResourceInUseCheck
parameter to true.

# Arguments
- `bot_id`: The identifier of the bot associated with the slot type.
- `bot_version`: The version of the bot associated with the slot type.
- `locale_id`: The identifier of the language and locale that the slot type will be deleted
  from. The string must match one of the supported locales. For more information, see
  Supported languages.
- `slot_type_id`: The identifier of the slot type to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"skipResourceInUseCheck"`: By default, the DeleteSlotType operations throws a
  ResourceInUseException exception if you try to delete a slot type used by a slot. Set the
  skipResourceInUseCheck parameter to true to skip this check and remove the slot type even
  if a slot uses it.
"""
function delete_slot_type(
    botId,
    botVersion,
    localeId,
    slotTypeId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "DELETE",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/slottypes/$(slotTypeId)/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_slot_type(
    botId,
    botVersion,
    localeId,
    slotTypeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "DELETE",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/slottypes/$(slotTypeId)/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_test_set(test_set_id)
    delete_test_set(test_set_id, params::Dict{String,<:Any})

The action to delete the selected test set.

# Arguments
- `test_set_id`: The test set Id of the test set to be deleted.

"""
function delete_test_set(testSetId; aws_config::AbstractAWSConfig=current_aws_config())
    return lex_models_v2(
        "DELETE",
        "/testsets/$(testSetId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_test_set(
    testSetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "DELETE",
        "/testsets/$(testSetId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_utterances(bot_id)
    delete_utterances(bot_id, params::Dict{String,<:Any})

Deletes stored utterances. Amazon Lex stores the utterances that users send to your bot.
Utterances are stored for 15 days for use with the ListAggregatedUtterances operation, and
then stored indefinitely for use in improving the ability of your bot to respond to user
input.. Use the DeleteUtterances operation to manually delete utterances for a specific
session. When you use the DeleteUtterances operation, utterances stored for improving your
bot's ability to respond to user input are deleted immediately. Utterances stored for use
with the ListAggregatedUtterances operation are deleted after 15 days.

# Arguments
- `bot_id`: The unique identifier of the bot that contains the utterances.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"localeId"`: The identifier of the language and locale where the utterances were
  collected. The string must match one of the supported locales. For more information, see
  Supported languages.
- `"sessionId"`: The unique identifier of the session with the user. The ID is returned in
  the response from the RecognizeText and RecognizeUtterance operations.
"""
function delete_utterances(botId; aws_config::AbstractAWSConfig=current_aws_config())
    return lex_models_v2(
        "DELETE",
        "/bots/$(botId)/utterances/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_utterances(
    botId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_models_v2(
        "DELETE",
        "/bots/$(botId)/utterances/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_bot(bot_id)
    describe_bot(bot_id, params::Dict{String,<:Any})

Provides metadata information about a bot.

# Arguments
- `bot_id`: The unique identifier of the bot to describe.

"""
function describe_bot(botId; aws_config::AbstractAWSConfig=current_aws_config())
    return lex_models_v2(
        "GET", "/bots/$(botId)/"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_bot(
    botId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_models_v2(
        "GET",
        "/bots/$(botId)/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_bot_alias(bot_alias_id, bot_id)
    describe_bot_alias(bot_alias_id, bot_id, params::Dict{String,<:Any})

Get information about a specific bot alias.

# Arguments
- `bot_alias_id`: The identifier of the bot alias to describe.
- `bot_id`: The identifier of the bot associated with the bot alias to describe.

"""
function describe_bot_alias(
    botAliasId, botId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_models_v2(
        "GET",
        "/bots/$(botId)/botaliases/$(botAliasId)/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_bot_alias(
    botAliasId,
    botId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "GET",
        "/bots/$(botId)/botaliases/$(botAliasId)/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_bot_locale(bot_id, bot_version, locale_id)
    describe_bot_locale(bot_id, bot_version, locale_id, params::Dict{String,<:Any})

Describes the settings that a bot has for a specific locale.

# Arguments
- `bot_id`: The identifier of the bot associated with the locale.
- `bot_version`: The version of the bot associated with the locale.
- `locale_id`: The unique identifier of the locale to describe. The string must match one
  of the supported locales. For more information, see Supported languages.

"""
function describe_bot_locale(
    botId, botVersion, localeId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_models_v2(
        "GET",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_bot_locale(
    botId,
    botVersion,
    localeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "GET",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_bot_recommendation(bot_id, bot_recommendation_id, bot_version, locale_id)
    describe_bot_recommendation(bot_id, bot_recommendation_id, bot_version, locale_id, params::Dict{String,<:Any})

Provides metadata information about a bot recommendation. This information will enable you
to get a description on the request inputs, to download associated transcripts after
processing is complete, and to download intents and slot-types generated by the bot
recommendation.

# Arguments
- `bot_id`: The unique identifier of the bot associated with the bot recommendation.
- `bot_recommendation_id`: The identifier of the bot recommendation to describe.
- `bot_version`: The version of the bot associated with the bot recommendation.
- `locale_id`: The identifier of the language and locale of the bot recommendation to
  describe. The string must match one of the supported locales. For more information, see
  Supported languages.

"""
function describe_bot_recommendation(
    botId,
    botRecommendationId,
    botVersion,
    localeId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "GET",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/botrecommendations/$(botRecommendationId)/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_bot_recommendation(
    botId,
    botRecommendationId,
    botVersion,
    localeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "GET",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/botrecommendations/$(botRecommendationId)/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_bot_replica(bot_id, replica_region)
    describe_bot_replica(bot_id, replica_region, params::Dict{String,<:Any})

Monitors the bot replication status through the UI console.

# Arguments
- `bot_id`: The request for the unique bot ID of the replicated bot being monitored.
- `replica_region`: The request for the region of the replicated bot being monitored.

"""
function describe_bot_replica(
    botId, replicaRegion; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_models_v2(
        "GET",
        "/bots/$(botId)/replicas/$(replicaRegion)/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_bot_replica(
    botId,
    replicaRegion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "GET",
        "/bots/$(botId)/replicas/$(replicaRegion)/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_bot_resource_generation(bot_id, bot_version, generation_id, locale_id)
    describe_bot_resource_generation(bot_id, bot_version, generation_id, locale_id, params::Dict{String,<:Any})

Returns information about a request to generate a bot through natural language description,
made through the StartBotResource API. Use the generatedBotLocaleUrl to retrieve the Amazon
S3 object containing the bot locale configuration. You can then modify and import this
configuration.

# Arguments
- `bot_id`: The unique identifier of the bot for which to return the generation details.
- `bot_version`: The version of the bot for which to return the generation details.
- `generation_id`: The unique identifier of the generation request for which to return the
  generation details.
- `locale_id`: The locale of the bot for which to return the generation details.

"""
function describe_bot_resource_generation(
    botId,
    botVersion,
    generationId,
    localeId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "GET",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/generations/$(generationId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_bot_resource_generation(
    botId,
    botVersion,
    generationId,
    localeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "GET",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/generations/$(generationId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_bot_version(bot_id, bot_version)
    describe_bot_version(bot_id, bot_version, params::Dict{String,<:Any})

Provides metadata about a version of a bot.

# Arguments
- `bot_id`: The identifier of the bot containing the version to return metadata for.
- `bot_version`: The version of the bot to return metadata for.

"""
function describe_bot_version(
    botId, botVersion; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_models_v2(
        "GET",
        "/bots/$(botId)/botversions/$(botVersion)/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_bot_version(
    botId,
    botVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "GET",
        "/bots/$(botId)/botversions/$(botVersion)/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_custom_vocabulary_metadata(bot_id, bot_version, locale_id)
    describe_custom_vocabulary_metadata(bot_id, bot_version, locale_id, params::Dict{String,<:Any})

Provides metadata information about a custom vocabulary.

# Arguments
- `bot_id`: The unique identifier of the bot that contains the custom vocabulary.
- `bot_version`: The bot version of the bot to return metadata for.
- `locale_id`: The locale to return the custom vocabulary information for. The locale must
  be en_GB.

"""
function describe_custom_vocabulary_metadata(
    botId, botVersion, localeId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_models_v2(
        "GET",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/customvocabulary/DEFAULT/metadata";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_custom_vocabulary_metadata(
    botId,
    botVersion,
    localeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "GET",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/customvocabulary/DEFAULT/metadata",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_export(export_id)
    describe_export(export_id, params::Dict{String,<:Any})

Gets information about a specific export.

# Arguments
- `export_id`: The unique identifier of the export to describe.

"""
function describe_export(exportId; aws_config::AbstractAWSConfig=current_aws_config())
    return lex_models_v2(
        "GET",
        "/exports/$(exportId)/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_export(
    exportId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "GET",
        "/exports/$(exportId)/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_import(import_id)
    describe_import(import_id, params::Dict{String,<:Any})

Gets information about a specific import.

# Arguments
- `import_id`: The unique identifier of the import to describe.

"""
function describe_import(importId; aws_config::AbstractAWSConfig=current_aws_config())
    return lex_models_v2(
        "GET",
        "/imports/$(importId)/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_import(
    importId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "GET",
        "/imports/$(importId)/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_intent(bot_id, bot_version, intent_id, locale_id)
    describe_intent(bot_id, bot_version, intent_id, locale_id, params::Dict{String,<:Any})

Returns metadata about an intent.

# Arguments
- `bot_id`: The identifier of the bot associated with the intent.
- `bot_version`: The version of the bot associated with the intent.
- `intent_id`: The identifier of the intent to describe.
- `locale_id`: The identifier of the language and locale of the intent to describe. The
  string must match one of the supported locales. For more information, see Supported
  languages.

"""
function describe_intent(
    botId,
    botVersion,
    intentId,
    localeId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "GET",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/intents/$(intentId)/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_intent(
    botId,
    botVersion,
    intentId,
    localeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "GET",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/intents/$(intentId)/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_resource_policy(resource_arn)
    describe_resource_policy(resource_arn, params::Dict{String,<:Any})

Gets the resource policy and policy revision for a bot or bot alias.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the bot or bot alias that the resource
  policy is attached to.

"""
function describe_resource_policy(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_models_v2(
        "GET",
        "/policy/$(resourceArn)/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_resource_policy(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "GET",
        "/policy/$(resourceArn)/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_slot(bot_id, bot_version, intent_id, locale_id, slot_id)
    describe_slot(bot_id, bot_version, intent_id, locale_id, slot_id, params::Dict{String,<:Any})

Gets metadata information about a slot.

# Arguments
- `bot_id`: The identifier of the bot associated with the slot.
- `bot_version`: The version of the bot associated with the slot.
- `intent_id`: The identifier of the intent that contains the slot.
- `locale_id`: The identifier of the language and locale of the slot to describe. The
  string must match one of the supported locales. For more information, see Supported
  languages.
- `slot_id`: The unique identifier for the slot.

"""
function describe_slot(
    botId,
    botVersion,
    intentId,
    localeId,
    slotId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "GET",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/intents/$(intentId)/slots/$(slotId)/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_slot(
    botId,
    botVersion,
    intentId,
    localeId,
    slotId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "GET",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/intents/$(intentId)/slots/$(slotId)/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_slot_type(bot_id, bot_version, locale_id, slot_type_id)
    describe_slot_type(bot_id, bot_version, locale_id, slot_type_id, params::Dict{String,<:Any})

Gets metadata information about a slot type.

# Arguments
- `bot_id`: The identifier of the bot associated with the slot type.
- `bot_version`: The version of the bot associated with the slot type.
- `locale_id`: The identifier of the language and locale of the slot type to describe. The
  string must match one of the supported locales. For more information, see Supported
  languages.
- `slot_type_id`: The identifier of the slot type.

"""
function describe_slot_type(
    botId,
    botVersion,
    localeId,
    slotTypeId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "GET",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/slottypes/$(slotTypeId)/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_slot_type(
    botId,
    botVersion,
    localeId,
    slotTypeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "GET",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/slottypes/$(slotTypeId)/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_test_execution(test_execution_id)
    describe_test_execution(test_execution_id, params::Dict{String,<:Any})

Gets metadata information about the test execution.

# Arguments
- `test_execution_id`: The execution Id of the test set execution.

"""
function describe_test_execution(
    testExecutionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_models_v2(
        "GET",
        "/testexecutions/$(testExecutionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_test_execution(
    testExecutionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "GET",
        "/testexecutions/$(testExecutionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_test_set(test_set_id)
    describe_test_set(test_set_id, params::Dict{String,<:Any})

Gets metadata information about the test set.

# Arguments
- `test_set_id`: The test set Id for the test set request.

"""
function describe_test_set(testSetId; aws_config::AbstractAWSConfig=current_aws_config())
    return lex_models_v2(
        "GET",
        "/testsets/$(testSetId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_test_set(
    testSetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "GET",
        "/testsets/$(testSetId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_test_set_discrepancy_report(test_set_discrepancy_report_id)
    describe_test_set_discrepancy_report(test_set_discrepancy_report_id, params::Dict{String,<:Any})

Gets metadata information about the test set discrepancy report.

# Arguments
- `test_set_discrepancy_report_id`: The unique identifier of the test set discrepancy
  report.

"""
function describe_test_set_discrepancy_report(
    testSetDiscrepancyReportId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_models_v2(
        "GET",
        "/testsetdiscrepancy/$(testSetDiscrepancyReportId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_test_set_discrepancy_report(
    testSetDiscrepancyReportId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "GET",
        "/testsetdiscrepancy/$(testSetDiscrepancyReportId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_test_set_generation(test_set_generation_id)
    describe_test_set_generation(test_set_generation_id, params::Dict{String,<:Any})

Gets metadata information about the test set generation.

# Arguments
- `test_set_generation_id`: The unique identifier of the test set generation.

"""
function describe_test_set_generation(
    testSetGenerationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_models_v2(
        "GET",
        "/testsetgenerations/$(testSetGenerationId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_test_set_generation(
    testSetGenerationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "GET",
        "/testsetgenerations/$(testSetGenerationId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    generate_bot_element(bot_id, bot_version, intent_id, locale_id)
    generate_bot_element(bot_id, bot_version, intent_id, locale_id, params::Dict{String,<:Any})

Generates sample utterances for an intent.

# Arguments
- `bot_id`: The bot unique Id for the bot request to generate utterances.
- `bot_version`: The bot version for the bot request to generate utterances.
- `intent_id`: The intent unique Id for the bot request to generate utterances.
- `locale_id`: The unique locale Id for the bot request to generate utterances.

"""
function generate_bot_element(
    botId,
    botVersion,
    intentId,
    localeId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "POST",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/generate",
        Dict{String,Any}("intentId" => intentId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function generate_bot_element(
    botId,
    botVersion,
    intentId,
    localeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "POST",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/generate",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("intentId" => intentId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_test_execution_artifacts_url(test_execution_id)
    get_test_execution_artifacts_url(test_execution_id, params::Dict{String,<:Any})

The pre-signed Amazon S3 URL to download the test execution result artifacts.

# Arguments
- `test_execution_id`: The unique identifier of the completed test execution.

"""
function get_test_execution_artifacts_url(
    testExecutionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_models_v2(
        "GET",
        "/testexecutions/$(testExecutionId)/artifacturl";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_test_execution_artifacts_url(
    testExecutionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "GET",
        "/testexecutions/$(testExecutionId)/artifacturl",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_aggregated_utterances(aggregation_duration, bot_id, locale_id)
    list_aggregated_utterances(aggregation_duration, bot_id, locale_id, params::Dict{String,<:Any})

Provides a list of utterances that users have sent to the bot. Utterances are aggregated by
the text of the utterance. For example, all instances where customers used the phrase \"I
want to order pizza\" are aggregated into the same line in the response. You can see both
detected utterances and missed utterances. A detected utterance is where the bot properly
recognized the utterance and activated the associated intent. A missed utterance was not
recognized by the bot and didn't activate an intent. Utterances can be aggregated for a bot
alias or for a bot version, but not both at the same time. Utterances statistics are not
generated under the following conditions:   The childDirected field was set to true when
the bot was created.   You are using slot obfuscation with one or more slots.   You opted
out of participating in improving Amazon Lex.

# Arguments
- `aggregation_duration`: The time window for aggregating the utterance information. You
  can specify a time between one hour and two weeks.
- `bot_id`: The unique identifier of the bot associated with this request.
- `locale_id`: The identifier of the language and locale where the utterances were
  collected. For more information, see Supported languages.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"botAliasId"`: The identifier of the bot alias associated with this request. If you
  specify the bot alias, you can't specify the bot version.
- `"botVersion"`: The identifier of the bot version associated with this request. If you
  specify the bot version, you can't specify the bot alias.
- `"filters"`: Provides the specification of a filter used to limit the utterances in the
  response to only those that match the filter specification. You can only specify one filter
  and one string to filter on.
- `"maxResults"`: The maximum number of utterances to return in each page of results. If
  there are fewer results than the maximum page size, only the actual number of results are
  returned. If you don't specify the maxResults parameter, 1,000 results are returned.
- `"nextToken"`: If the response from the ListAggregatedUtterances operation contains more
  results that specified in the maxResults parameter, a token is returned in the response.
  Use that token in the nextToken parameter to return the next page of results.
- `"sortBy"`: Specifies sorting parameters for the list of utterances. You can sort by the
  hit count, the missed count, or the number of distinct sessions the utterance appeared in.
"""
function list_aggregated_utterances(
    aggregationDuration, botId, localeId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_models_v2(
        "POST",
        "/bots/$(botId)/aggregatedutterances/",
        Dict{String,Any}(
            "aggregationDuration" => aggregationDuration, "localeId" => localeId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_aggregated_utterances(
    aggregationDuration,
    botId,
    localeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "POST",
        "/bots/$(botId)/aggregatedutterances/",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "aggregationDuration" => aggregationDuration, "localeId" => localeId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_bot_alias_replicas(bot_id, replica_region)
    list_bot_alias_replicas(bot_id, replica_region, params::Dict{String,<:Any})

The action to list the replicated bots created from the source bot alias.

# Arguments
- `bot_id`: The request for the unique bot ID of the replicated bot created from the source
  bot alias.
- `replica_region`: The request for the secondary region of the replicated bot created from
  the source bot alias.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The request for maximum results to list the replicated bots created from
  the source bot alias.
- `"nextToken"`: The request for the next token for the replicated bot created from the
  source bot alias.
"""
function list_bot_alias_replicas(
    botId, replicaRegion; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_models_v2(
        "POST",
        "/bots/$(botId)/replicas/$(replicaRegion)/botaliases/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_bot_alias_replicas(
    botId,
    replicaRegion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "POST",
        "/bots/$(botId)/replicas/$(replicaRegion)/botaliases/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_bot_aliases(bot_id)
    list_bot_aliases(bot_id, params::Dict{String,<:Any})

Gets a list of aliases for the specified bot.

# Arguments
- `bot_id`: The identifier of the bot to list aliases for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of aliases to return in each page of results. If there
  are fewer results than the max page size, only the actual number of results are returned.
- `"nextToken"`: If the response from the ListBotAliases operation contains more results
  than specified in the maxResults parameter, a token is returned in the response. Use that
  token in the nextToken parameter to return the next page of results.
"""
function list_bot_aliases(botId; aws_config::AbstractAWSConfig=current_aws_config())
    return lex_models_v2(
        "POST",
        "/bots/$(botId)/botaliases/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_bot_aliases(
    botId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_models_v2(
        "POST",
        "/bots/$(botId)/botaliases/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_bot_locales(bot_id, bot_version)
    list_bot_locales(bot_id, bot_version, params::Dict{String,<:Any})

Gets a list of locales for the specified bot.

# Arguments
- `bot_id`: The identifier of the bot to list locales for.
- `bot_version`: The version of the bot to list locales for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: Provides the specification for a filter used to limit the response to only
  those locales that match the filter specification. You can only specify one filter and one
  value to filter on.
- `"maxResults"`: The maximum number of aliases to return in each page of results. If there
  are fewer results than the max page size, only the actual number of results are returned.
- `"nextToken"`: If the response from the ListBotLocales operation contains more results
  than specified in the maxResults parameter, a token is returned in the response. Use that
  token as the nextToken parameter to return the next page of results.
- `"sortBy"`: Specifies sorting parameters for the list of locales. You can sort by locale
  name in ascending or descending order.
"""
function list_bot_locales(
    botId, botVersion; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_models_v2(
        "POST",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_bot_locales(
    botId,
    botVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "POST",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_bot_recommendations(bot_id, bot_version, locale_id)
    list_bot_recommendations(bot_id, bot_version, locale_id, params::Dict{String,<:Any})

Get a list of bot recommendations that meet the specified criteria.

# Arguments
- `bot_id`: The unique identifier of the bot that contains the bot recommendation list.
- `bot_version`: The version of the bot that contains the bot recommendation list.
- `locale_id`: The identifier of the language and locale of the bot recommendation list.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of bot recommendations to return in each page of
  results. If there are fewer results than the max page size, only the actual number of
  results are returned.
- `"nextToken"`: If the response from the ListBotRecommendation operation contains more
  results than specified in the maxResults parameter, a token is returned in the response.
  Use that token in the nextToken parameter to return the next page of results.
"""
function list_bot_recommendations(
    botId, botVersion, localeId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_models_v2(
        "POST",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/botrecommendations/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_bot_recommendations(
    botId,
    botVersion,
    localeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "POST",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/botrecommendations/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_bot_replicas(bot_id)
    list_bot_replicas(bot_id, params::Dict{String,<:Any})

The action to list the replicated bots.

# Arguments
- `bot_id`: The request for the unique bot IDs in the list of replicated bots.

"""
function list_bot_replicas(botId; aws_config::AbstractAWSConfig=current_aws_config())
    return lex_models_v2(
        "POST",
        "/bots/$(botId)/replicas/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_bot_replicas(
    botId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_models_v2(
        "POST",
        "/bots/$(botId)/replicas/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_bot_resource_generations(bot_id, bot_version, locale_id)
    list_bot_resource_generations(bot_id, bot_version, locale_id, params::Dict{String,<:Any})

Lists the generation requests made for a bot locale.

# Arguments
- `bot_id`: The unique identifier of the bot whose generation requests you want to view.
- `bot_version`: The version of the bot whose generation requests you want to view.
- `locale_id`: The locale of the bot whose generation requests you want to view.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in the response.
- `"nextToken"`: If the total number of results is greater than the number specified in the
  maxResults, the response returns a token in the nextToken field. Use this token when making
  a request to return the next batch of results.
- `"sortBy"`: An object containing information about the attribute and the method by which
  to sort the results
"""
function list_bot_resource_generations(
    botId, botVersion, localeId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_models_v2(
        "POST",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/generations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_bot_resource_generations(
    botId,
    botVersion,
    localeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "POST",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/generations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_bot_version_replicas(bot_id, replica_region)
    list_bot_version_replicas(bot_id, replica_region, params::Dict{String,<:Any})

Contains information about all the versions replication statuses applicable for Global
Resiliency.

# Arguments
- `bot_id`: The request for the unique ID in the list of replicated bots.
- `replica_region`: The request for the region used in the list of replicated bots.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum results given in the list of replicated bots.
- `"nextToken"`: The next token given in the list of replicated bots.
- `"sortBy"`: The requested sort category for the list of replicated bots.
"""
function list_bot_version_replicas(
    botId, replicaRegion; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_models_v2(
        "POST",
        "/bots/$(botId)/replicas/$(replicaRegion)/botversions/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_bot_version_replicas(
    botId,
    replicaRegion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "POST",
        "/bots/$(botId)/replicas/$(replicaRegion)/botversions/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_bot_versions(bot_id)
    list_bot_versions(bot_id, params::Dict{String,<:Any})

Gets information about all of the versions of a bot. The ListBotVersions operation returns
a summary of each version of a bot. For example, if a bot has three numbered versions, the
ListBotVersions operation returns for summaries, one for each numbered version and one for
the DRAFT version. The ListBotVersions operation always returns at least one version, the
DRAFT version.

# Arguments
- `bot_id`: The identifier of the bot to list versions for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of versions to return in each page of results. If
  there are fewer results than the max page size, only the actual number of results are
  returned.
- `"nextToken"`: If the response to the ListBotVersion operation contains more results than
  specified in the maxResults parameter, a token is returned in the response. Use that token
  in the nextToken parameter to return the next page of results.
- `"sortBy"`: Specifies sorting parameters for the list of versions. You can specify that
  the list be sorted by version name in either ascending or descending order.
"""
function list_bot_versions(botId; aws_config::AbstractAWSConfig=current_aws_config())
    return lex_models_v2(
        "POST",
        "/bots/$(botId)/botversions/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_bot_versions(
    botId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_models_v2(
        "POST",
        "/bots/$(botId)/botversions/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_bots()
    list_bots(params::Dict{String,<:Any})

Gets a list of available bots.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: Provides the specification of a filter used to limit the bots in the
  response to only those that match the filter specification. You can only specify one filter
  and one string to filter on.
- `"maxResults"`: The maximum number of bots to return in each page of results. If there
  are fewer results than the maximum page size, only the actual number of results are
  returned.
- `"nextToken"`: If the response from the ListBots operation contains more results than
  specified in the maxResults parameter, a token is returned in the response.  Use the
  returned token in the nextToken parameter of a ListBots request to return the next page of
  results. For a complete set of results, call the ListBots operation until the nextToken
  returned in the response is null.
- `"sortBy"`: Specifies sorting parameters for the list of bots. You can specify that the
  list be sorted by bot name in ascending or descending order.
"""
function list_bots(; aws_config::AbstractAWSConfig=current_aws_config())
    return lex_models_v2(
        "POST", "/bots/"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_bots(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_models_v2(
        "POST", "/bots/", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_built_in_intents(locale_id)
    list_built_in_intents(locale_id, params::Dict{String,<:Any})

Gets a list of built-in intents provided by Amazon Lex that you can use in your bot.  To
use a built-in intent as a the base for your own intent, include the built-in intent
signature in the parentIntentSignature parameter when you call the CreateIntent operation.
For more information, see CreateIntent.

# Arguments
- `locale_id`: The identifier of the language and locale of the intents to list. The string
  must match one of the supported locales. For more information, see Supported languages.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of built-in intents to return in each page of results.
  If there are fewer results than the max page size, only the actual number of results are
  returned.
- `"nextToken"`: If the response from the ListBuiltInIntents operation contains more
  results than specified in the maxResults parameter, a token is returned in the response.
  Use that token in the nextToken parameter to return the next page of results.
- `"sortBy"`: Specifies sorting parameters for the list of built-in intents. You can
  specify that the list be sorted by the built-in intent signature in either ascending or
  descending order.
"""
function list_built_in_intents(localeId; aws_config::AbstractAWSConfig=current_aws_config())
    return lex_models_v2(
        "POST",
        "/builtins/locales/$(localeId)/intents/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_built_in_intents(
    localeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "POST",
        "/builtins/locales/$(localeId)/intents/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_built_in_slot_types(locale_id)
    list_built_in_slot_types(locale_id, params::Dict{String,<:Any})

Gets a list of built-in slot types that meet the specified criteria.

# Arguments
- `locale_id`: The identifier of the language and locale of the slot types to list. The
  string must match one of the supported locales. For more information, see Supported
  languages.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of built-in slot types to return in each page of
  results. If there are fewer results than the max page size, only the actual number of
  results are returned.
- `"nextToken"`: If the response from the ListBuiltInSlotTypes operation contains more
  results than specified in the maxResults parameter, a token is returned in the response.
  Use that token in the nextToken parameter to return the next page of results.
- `"sortBy"`: Determines the sort order for the response from the ListBuiltInSlotTypes
  operation. You can choose to sort by the slot type signature in either ascending or
  descending order.
"""
function list_built_in_slot_types(
    localeId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_models_v2(
        "POST",
        "/builtins/locales/$(localeId)/slottypes/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_built_in_slot_types(
    localeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "POST",
        "/builtins/locales/$(localeId)/slottypes/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_custom_vocabulary_items(bot_id, bot_version, locale_id)
    list_custom_vocabulary_items(bot_id, bot_version, locale_id, params::Dict{String,<:Any})

Paginated list of custom vocabulary items for a given bot locale's custom vocabulary.

# Arguments
- `bot_id`: The identifier of the version of the bot associated with this custom vocabulary.
- `bot_version`: The bot version of the bot to the list custom vocabulary request.
- `locale_id`: The identifier of the language and locale where this custom vocabulary is
  used. The string must match one of the supported locales. For more information, see
  Supported languages (https://docs.aws.amazon.com/lexv2/latest/dg/how-languages.html).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of items returned by the list operation.
- `"nextToken"`: The nextToken identifier to the list custom vocabulary request.
"""
function list_custom_vocabulary_items(
    botId, botVersion, localeId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_models_v2(
        "POST",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/customvocabulary/DEFAULT/list";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_custom_vocabulary_items(
    botId,
    botVersion,
    localeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "POST",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/customvocabulary/DEFAULT/list",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_exports()
    list_exports(params::Dict{String,<:Any})

Lists the exports for a bot, bot locale, or custom vocabulary. Exports are kept in the list
for 7 days.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"botId"`: The unique identifier that Amazon Lex assigned to the bot.
- `"botVersion"`: The version of the bot to list exports for.
- `"filters"`: Provides the specification of a filter used to limit the exports in the
  response to only those that match the filter specification. You can only specify one filter
  and one string to filter on.
- `"localeId"`: Specifies the resources that should be exported. If you don't specify a
  resource type in the filters parameter, both bot locales and custom vocabularies are
  exported.
- `"maxResults"`: The maximum number of exports to return in each page of results. If there
  are fewer results than the max page size, only the actual number of results are returned.
- `"nextToken"`: If the response from the ListExports operation contains more results that
  specified in the maxResults parameter, a token is returned in the response.  Use the
  returned token in the nextToken parameter of a ListExports request to return the next page
  of results. For a complete set of results, call the ListExports operation until the
  nextToken returned in the response is null.
- `"sortBy"`: Determines the field that the list of exports is sorted by. You can sort by
  the LastUpdatedDateTime field in ascending or descending order.
"""
function list_exports(; aws_config::AbstractAWSConfig=current_aws_config())
    return lex_models_v2(
        "POST", "/exports/"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_exports(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_models_v2(
        "POST", "/exports/", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_imports()
    list_imports(params::Dict{String,<:Any})

Lists the imports for a bot, bot locale, or custom vocabulary. Imports are kept in the list
for 7 days.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"botId"`: The unique identifier that Amazon Lex assigned to the bot.
- `"botVersion"`: The version of the bot to list imports for.
- `"filters"`: Provides the specification of a filter used to limit the bots in the
  response to only those that match the filter specification. You can only specify one filter
  and one string to filter on.
- `"localeId"`: Specifies the locale that should be present in the list. If you don't
  specify a resource type in the filters parameter, the list contains both bot locales and
  custom vocabularies.
- `"maxResults"`: The maximum number of imports to return in each page of results. If there
  are fewer results than the max page size, only the actual number of results are returned.
- `"nextToken"`: If the response from the ListImports operation contains more results than
  specified in the maxResults parameter, a token is returned in the response. Use the
  returned token in the nextToken parameter of a ListImports request to return the next page
  of results. For a complete set of results, call the ListImports operation until the
  nextToken returned in the response is null.
- `"sortBy"`: Determines the field that the list of imports is sorted by. You can sort by
  the LastUpdatedDateTime field in ascending or descending order.
"""
function list_imports(; aws_config::AbstractAWSConfig=current_aws_config())
    return lex_models_v2(
        "POST", "/imports/"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_imports(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_models_v2(
        "POST", "/imports/", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_intent_metrics(bot_id, end_date_time, metrics, start_date_time)
    list_intent_metrics(bot_id, end_date_time, metrics, start_date_time, params::Dict{String,<:Any})

Retrieves summary metrics for the intents in your bot. The following fields are required:
 metrics – A list of AnalyticsIntentMetric objects. In each object, use the name field to
specify the metric to calculate, the statistic field to specify whether to calculate the
Sum, Average, or Max number, and the order field to specify whether to sort the results in
Ascending or Descending order.    startDateTime and endDateTime – Define a time range for
which you want to retrieve results.   Of the optional fields, you can organize the results
in the following ways:   Use the filters field to filter the results, the groupBy field to
specify categories by which to group the results, and the binBy field to specify time
intervals by which to group the results.   Use the maxResults field to limit the number of
results to return in a single response and the nextToken field to return the next batch of
results if the response does not return the full set of results.   Note that an order field
exists in both binBy and metrics. You can specify only one order in a given request.

# Arguments
- `bot_id`: The identifier for the bot for which you want to retrieve intent metrics.
- `end_date_time`: The date and time that marks the end of the range of time for which you
  want to see intent metrics.
- `metrics`: A list of objects, each of which contains a metric you want to list, the
  statistic for the metric you want to return, and the order by which to organize the results.
- `start_date_time`: The timestamp that marks the beginning of the range of time for which
  you want to see intent metrics.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"binBy"`: A list of objects, each of which contains specifications for organizing the
  results by time.
- `"filters"`: A list of objects, each of which describes a condition by which you want to
  filter the results.
- `"groupBy"`: A list of objects, each of which specifies how to group the results. You can
  group by the following criteria:    IntentName – The name of the intent.
  IntentEndState – The final state of the intent. The possible end states are detailed in
  Key definitions in the user guide.
- `"maxResults"`: The maximum number of results to return in each page of results. If there
  are fewer results than the maximum page size, only the actual number of results are
  returned.
- `"nextToken"`: If the response from the ListIntentMetrics operation contains more results
  than specified in the maxResults parameter, a token is returned in the response. Use the
  returned token in the nextToken parameter of a ListIntentMetrics request to return the next
  page of results. For a complete set of results, call the ListIntentMetrics operation until
  the nextToken returned in the response is null.
"""
function list_intent_metrics(
    botId,
    endDateTime,
    metrics,
    startDateTime;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "POST",
        "/bots/$(botId)/analytics/intentmetrics",
        Dict{String,Any}(
            "endDateTime" => endDateTime,
            "metrics" => metrics,
            "startDateTime" => startDateTime,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_intent_metrics(
    botId,
    endDateTime,
    metrics,
    startDateTime,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "POST",
        "/bots/$(botId)/analytics/intentmetrics",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "endDateTime" => endDateTime,
                    "metrics" => metrics,
                    "startDateTime" => startDateTime,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_intent_paths(bot_id, end_date_time, intent_path, start_date_time)
    list_intent_paths(bot_id, end_date_time, intent_path, start_date_time, params::Dict{String,<:Any})

Retrieves summary statistics for a path of intents that users take over sessions with your
bot. The following fields are required:    startDateTime and endDateTime – Define a time
range for which you want to retrieve results.    intentPath – Define an order of intents
for which you want to retrieve metrics. Separate intents in the path with a forward slash.
For example, populate the intentPath field with /BookCar/BookHotel to see details about how
many times users invoked the BookCar and BookHotel intents in that order.   Use the
optional filters field to filter the results.

# Arguments
- `bot_id`: The identifier for the bot for which you want to retrieve intent path metrics.
- `end_date_time`: The date and time that marks the end of the range of time for which you
  want to see intent path metrics.
- `intent_path`: The intent path for which you want to retrieve metrics. Use a forward
  slash to separate intents in the path. For example:   /BookCar   /BookCar/BookHotel
  /BookHotel/BookCar
- `start_date_time`: The date and time that marks the beginning of the range of time for
  which you want to see intent path metrics.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: A list of objects, each describes a condition by which you want to filter
  the results.
"""
function list_intent_paths(
    botId,
    endDateTime,
    intentPath,
    startDateTime;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "POST",
        "/bots/$(botId)/analytics/intentpaths",
        Dict{String,Any}(
            "endDateTime" => endDateTime,
            "intentPath" => intentPath,
            "startDateTime" => startDateTime,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_intent_paths(
    botId,
    endDateTime,
    intentPath,
    startDateTime,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "POST",
        "/bots/$(botId)/analytics/intentpaths",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "endDateTime" => endDateTime,
                    "intentPath" => intentPath,
                    "startDateTime" => startDateTime,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_intent_stage_metrics(bot_id, end_date_time, metrics, start_date_time)
    list_intent_stage_metrics(bot_id, end_date_time, metrics, start_date_time, params::Dict{String,<:Any})

Retrieves summary metrics for the stages within intents in your bot. The following fields
are required:    metrics – A list of AnalyticsIntentStageMetric objects. In each object,
use the name field to specify the metric to calculate, the statistic field to specify
whether to calculate the Sum, Average, or Max number, and the order field to specify
whether to sort the results in Ascending or Descending order.    startDateTime and
endDateTime – Define a time range for which you want to retrieve results.   Of the
optional fields, you can organize the results in the following ways:   Use the filters
field to filter the results, the groupBy field to specify categories by which to group the
results, and the binBy field to specify time intervals by which to group the results.   Use
the maxResults field to limit the number of results to return in a single response and the
nextToken field to return the next batch of results if the response does not return the
full set of results.   Note that an order field exists in both binBy and metrics. You can
only specify one order in a given request.

# Arguments
- `bot_id`: The identifier for the bot for which you want to retrieve intent stage metrics.
- `end_date_time`: The date and time that marks the end of the range of time for which you
  want to see intent stage metrics.
- `metrics`: A list of objects, each of which contains a metric you want to list, the
  statistic for the metric you want to return, and the method by which to organize the
  results.
- `start_date_time`: The date and time that marks the beginning of the range of time for
  which you want to see intent stage metrics.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"binBy"`: A list of objects, each of which contains specifications for organizing the
  results by time.
- `"filters"`: A list of objects, each of which describes a condition by which you want to
  filter the results.
- `"groupBy"`: A list of objects, each of which specifies how to group the results. You can
  group by the following criteria:    IntentStageName – The name of the intent stage.
  SwitchedToIntent – The intent to which the conversation was switched (if any).
- `"maxResults"`: The maximum number of results to return in each page of results. If there
  are fewer results than the maximum page size, only the actual number of results are
  returned.
- `"nextToken"`: If the response from the ListIntentStageMetrics operation contains more
  results than specified in the maxResults parameter, a token is returned in the response.
  Use the returned token in the nextToken parameter of a ListIntentStageMetrics request to
  return the next page of results. For a complete set of results, call the
  ListIntentStageMetrics operation until the nextToken returned in the response is null.
"""
function list_intent_stage_metrics(
    botId,
    endDateTime,
    metrics,
    startDateTime;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "POST",
        "/bots/$(botId)/analytics/intentstagemetrics",
        Dict{String,Any}(
            "endDateTime" => endDateTime,
            "metrics" => metrics,
            "startDateTime" => startDateTime,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_intent_stage_metrics(
    botId,
    endDateTime,
    metrics,
    startDateTime,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "POST",
        "/bots/$(botId)/analytics/intentstagemetrics",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "endDateTime" => endDateTime,
                    "metrics" => metrics,
                    "startDateTime" => startDateTime,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_intents(bot_id, bot_version, locale_id)
    list_intents(bot_id, bot_version, locale_id, params::Dict{String,<:Any})

Get a list of intents that meet the specified criteria.

# Arguments
- `bot_id`: The unique identifier of the bot that contains the intent.
- `bot_version`: The version of the bot that contains the intent.
- `locale_id`: The identifier of the language and locale of the intents to list. The string
  must match one of the supported locales. For more information, see Supported languages.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: Provides the specification of a filter used to limit the intents in the
  response to only those that match the filter specification. You can only specify one filter
  and only one string to filter on.
- `"maxResults"`: The maximum number of intents to return in each page of results. If there
  are fewer results than the max page size, only the actual number of results are returned.
- `"nextToken"`: If the response from the ListIntents operation contains more results than
  specified in the maxResults parameter, a token is returned in the response. Use the
  returned token in the nextToken parameter of a ListIntents request to return the next page
  of results. For a complete set of results, call the ListIntents operation until the
  nextToken returned in the response is null.
- `"sortBy"`: Determines the sort order for the response from the ListIntents operation.
  You can choose to sort by the intent name or last updated date in either ascending or
  descending order.
"""
function list_intents(
    botId, botVersion, localeId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_models_v2(
        "POST",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/intents/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_intents(
    botId,
    botVersion,
    localeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "POST",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/intents/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_recommended_intents(bot_id, bot_recommendation_id, bot_version, locale_id)
    list_recommended_intents(bot_id, bot_recommendation_id, bot_version, locale_id, params::Dict{String,<:Any})

Gets a list of recommended intents provided by the bot recommendation that you can use in
your bot. Intents in the response are ordered by relevance.

# Arguments
- `bot_id`: The unique identifier of the bot associated with the recommended intents.
- `bot_recommendation_id`: The identifier of the bot recommendation that contains the
  recommended intents.
- `bot_version`: The version of the bot that contains the recommended intents.
- `locale_id`: The identifier of the language and locale of the recommended intents.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of bot recommendations to return in each page of
  results. If there are fewer results than the max page size, only the actual number of
  results are returned.
- `"nextToken"`: If the response from the ListRecommendedIntents operation contains more
  results than specified in the maxResults parameter, a token is returned in the response.
  Use that token in the nextToken parameter to return the next page of results.
"""
function list_recommended_intents(
    botId,
    botRecommendationId,
    botVersion,
    localeId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "POST",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/botrecommendations/$(botRecommendationId)/intents";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_recommended_intents(
    botId,
    botRecommendationId,
    botVersion,
    localeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "POST",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/botrecommendations/$(botRecommendationId)/intents",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_session_analytics_data(bot_id, end_date_time, start_date_time)
    list_session_analytics_data(bot_id, end_date_time, start_date_time, params::Dict{String,<:Any})

Retrieves a list of metadata for individual user sessions with your bot. The startDateTime
and endDateTime fields are required. These fields define a time range for which you want to
retrieve results. Of the optional fields, you can organize the results in the following
ways:   Use the filters field to filter the results and the sortBy field to specify the
values by which to sort the results.   Use the maxResults field to limit the number of
results to return in a single response and the nextToken field to return the next batch of
results if the response does not return the full set of results.

# Arguments
- `bot_id`: The identifier for the bot for which you want to retrieve session analytics.
- `end_date_time`: The date and time that marks the end of the range of time for which you
  want to see session analytics.
- `start_date_time`: The date and time that marks the beginning of the range of time for
  which you want to see session analytics.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: A list of objects, each of which describes a condition by which you want to
  filter the results.
- `"maxResults"`: The maximum number of results to return in each page of results. If there
  are fewer results than the maximum page size, only the actual number of results are
  returned.
- `"nextToken"`: If the response from the ListSessionAnalyticsData operation contains more
  results than specified in the maxResults parameter, a token is returned in the response.
  Use the returned token in the nextToken parameter of a ListSessionAnalyticsData request to
  return the next page of results. For a complete set of results, call the
  ListSessionAnalyticsData operation until the nextToken returned in the response is null.
- `"sortBy"`: An object specifying the measure and method by which to sort the session
  analytics data.
"""
function list_session_analytics_data(
    botId, endDateTime, startDateTime; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_models_v2(
        "POST",
        "/bots/$(botId)/analytics/sessions",
        Dict{String,Any}("endDateTime" => endDateTime, "startDateTime" => startDateTime);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_session_analytics_data(
    botId,
    endDateTime,
    startDateTime,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "POST",
        "/bots/$(botId)/analytics/sessions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "endDateTime" => endDateTime, "startDateTime" => startDateTime
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_session_metrics(bot_id, end_date_time, metrics, start_date_time)
    list_session_metrics(bot_id, end_date_time, metrics, start_date_time, params::Dict{String,<:Any})

Retrieves summary metrics for the user sessions with your bot. The following fields are
required:    metrics – A list of AnalyticsSessionMetric objects. In each object, use the
name field to specify the metric to calculate, the statistic field to specify whether to
calculate the Sum, Average, or Max number, and the order field to specify whether to sort
the results in Ascending or Descending order.    startDateTime and endDateTime – Define a
time range for which you want to retrieve results.   Of the optional fields, you can
organize the results in the following ways:   Use the filters field to filter the results,
the groupBy field to specify categories by which to group the results, and the binBy field
to specify time intervals by which to group the results.   Use the maxResults field to
limit the number of results to return in a single response and the nextToken field to
return the next batch of results if the response does not return the full set of results.
Note that an order field exists in both binBy and metrics. Currently, you can specify it in
either field, but not in both.

# Arguments
- `bot_id`: The identifier for the bot for which you want to retrieve session metrics.
- `end_date_time`: The date and time that marks the end of the range of time for which you
  want to see session metrics.
- `metrics`: A list of objects, each of which contains a metric you want to list, the
  statistic for the metric you want to return, and the method by which to organize the
  results.
- `start_date_time`: The date and time that marks the beginning of the range of time for
  which you want to see session metrics.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"binBy"`: A list of objects, each of which contains specifications for organizing the
  results by time.
- `"filters"`: A list of objects, each of which describes a condition by which you want to
  filter the results.
- `"groupBy"`: A list of objects, each of which specifies how to group the results. You can
  group by the following criteria:    ConversationEndState – The final state of the
  conversation. The possible end states are detailed in Key definitions in the user guide.
  LocaleId – The unique identifier of the bot locale.
- `"maxResults"`: The maximum number of results to return in each page of results. If there
  are fewer results than the maximum page size, only the actual number of results are
  returned.
- `"nextToken"`: If the response from the ListSessionMetrics operation contains more
  results than specified in the maxResults parameter, a token is returned in the response.
  Use the returned token in the nextToken parameter of a ListSessionMetrics request to return
  the next page of results. For a complete set of results, call the ListSessionMetrics
  operation until the nextToken returned in the response is null.
"""
function list_session_metrics(
    botId,
    endDateTime,
    metrics,
    startDateTime;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "POST",
        "/bots/$(botId)/analytics/sessionmetrics",
        Dict{String,Any}(
            "endDateTime" => endDateTime,
            "metrics" => metrics,
            "startDateTime" => startDateTime,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_session_metrics(
    botId,
    endDateTime,
    metrics,
    startDateTime,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "POST",
        "/bots/$(botId)/analytics/sessionmetrics",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "endDateTime" => endDateTime,
                    "metrics" => metrics,
                    "startDateTime" => startDateTime,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_slot_types(bot_id, bot_version, locale_id)
    list_slot_types(bot_id, bot_version, locale_id, params::Dict{String,<:Any})

Gets a list of slot types that match the specified criteria.

# Arguments
- `bot_id`: The unique identifier of the bot that contains the slot types.
- `bot_version`: The version of the bot that contains the slot type.
- `locale_id`: The identifier of the language and locale of the slot types to list. The
  string must match one of the supported locales. For more information, see Supported
  languages.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: Provides the specification of a filter used to limit the slot types in the
  response to only those that match the filter specification. You can only specify one filter
  and only one string to filter on.
- `"maxResults"`: The maximum number of slot types to return in each page of results. If
  there are fewer results than the max page size, only the actual number of results are
  returned.
- `"nextToken"`: If the response from the ListSlotTypes operation contains more results
  than specified in the maxResults parameter, a token is returned in the response. Use that
  token in the nextToken parameter to return the next page of results.
- `"sortBy"`: Determines the sort order for the response from the ListSlotTypes operation.
  You can choose to sort by the slot type name or last updated date in either ascending or
  descending order.
"""
function list_slot_types(
    botId, botVersion, localeId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_models_v2(
        "POST",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/slottypes/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_slot_types(
    botId,
    botVersion,
    localeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "POST",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/slottypes/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_slots(bot_id, bot_version, intent_id, locale_id)
    list_slots(bot_id, bot_version, intent_id, locale_id, params::Dict{String,<:Any})

Gets a list of slots that match the specified criteria.

# Arguments
- `bot_id`: The identifier of the bot that contains the slot.
- `bot_version`: The version of the bot that contains the slot.
- `intent_id`: The unique identifier of the intent that contains the slot.
- `locale_id`: The identifier of the language and locale of the slots to list. The string
  must match one of the supported locales. For more information, see Supported languages.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: Provides the specification of a filter used to limit the slots in the
  response to only those that match the filter specification. You can only specify one filter
  and only one string to filter on.
- `"maxResults"`: The maximum number of slots to return in each page of results. If there
  are fewer results than the max page size, only the actual number of results are returned.
- `"nextToken"`: If the response from the ListSlots operation contains more results than
  specified in the maxResults parameter, a token is returned in the response. Use that token
  in the nextToken parameter to return the next page of results.
- `"sortBy"`: Determines the sort order for the response from the ListSlots operation. You
  can choose to sort by the slot name or last updated date in either ascending or descending
  order.
"""
function list_slots(
    botId,
    botVersion,
    intentId,
    localeId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "POST",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/intents/$(intentId)/slots/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_slots(
    botId,
    botVersion,
    intentId,
    localeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "POST",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/intents/$(intentId)/slots/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Gets a list of tags associated with a resource. Only bots, bot aliases, and bot channels
can have tags associated with them.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource to get a list of tags for.

"""
function list_tags_for_resource(
    resourceARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_models_v2(
        "GET",
        "/tags/$(resourceARN)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "GET",
        "/tags/$(resourceARN)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_test_execution_result_items(result_filter_by, test_execution_id)
    list_test_execution_result_items(result_filter_by, test_execution_id, params::Dict{String,<:Any})

Gets a list of test execution result items.

# Arguments
- `result_filter_by`: The filter for the list of results from the test set execution.
- `test_execution_id`: The unique identifier of the test execution to list the result items.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of test execution result items to return in each page.
  If there are fewer results than the max page size, only the actual number of results are
  returned.
- `"nextToken"`: If the response from the ListTestExecutionResultItems operation contains
  more results than specified in the maxResults parameter, a token is returned in the
  response. Use that token in the nextToken parameter to return the next page of results.
"""
function list_test_execution_result_items(
    resultFilterBy, testExecutionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_models_v2(
        "POST",
        "/testexecutions/$(testExecutionId)/results",
        Dict{String,Any}("resultFilterBy" => resultFilterBy);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_test_execution_result_items(
    resultFilterBy,
    testExecutionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "POST",
        "/testexecutions/$(testExecutionId)/results",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resultFilterBy" => resultFilterBy), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_test_executions()
    list_test_executions(params::Dict{String,<:Any})

The list of test set executions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of test executions to return in each page. If there
  are fewer results than the max page size, only the actual number of results are returned.
- `"nextToken"`: If the response from the ListTestExecutions operation contains more
  results than specified in the maxResults parameter, a token is returned in the response.
  Use that token in the nextToken parameter to return the next page of results.
- `"sortBy"`: The sort order of the test set executions.
"""
function list_test_executions(; aws_config::AbstractAWSConfig=current_aws_config())
    return lex_models_v2(
        "POST", "/testexecutions"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_test_executions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_models_v2(
        "POST",
        "/testexecutions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_test_set_records(test_set_id)
    list_test_set_records(test_set_id, params::Dict{String,<:Any})

The list of test set records.

# Arguments
- `test_set_id`: The identifier of the test set to list its test set records.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of test set records to return in each page. If there
  are fewer records than the max page size, only the actual number of records are returned.
- `"nextToken"`: If the response from the ListTestSetRecords operation contains more
  results than specified in the maxResults parameter, a token is returned in the response.
  Use that token in the nextToken parameter to return the next page of results.
"""
function list_test_set_records(
    testSetId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_models_v2(
        "POST",
        "/testsets/$(testSetId)/records";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_test_set_records(
    testSetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "POST",
        "/testsets/$(testSetId)/records",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_test_sets()
    list_test_sets(params::Dict{String,<:Any})

The list of the test sets

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of test sets to return in each page. If there are
  fewer results than the max page size, only the actual number of results are returned.
- `"nextToken"`: If the response from the ListTestSets operation contains more results than
  specified in the maxResults parameter, a token is returned in the response. Use that token
  in the nextToken parameter to return the next page of results.
- `"sortBy"`: The sort order for the list of test sets.
"""
function list_test_sets(; aws_config::AbstractAWSConfig=current_aws_config())
    return lex_models_v2(
        "POST", "/testsets"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_test_sets(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_models_v2(
        "POST", "/testsets", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_utterance_analytics_data(bot_id, end_date_time, start_date_time)
    list_utterance_analytics_data(bot_id, end_date_time, start_date_time, params::Dict{String,<:Any})

 To use this API operation, your IAM role must have permissions to perform the
ListAggregatedUtterances operation, which provides access to utterance-related analytics.
See Viewing utterance statistics for the IAM policy to apply to the IAM role.  Retrieves a
list of metadata for individual user utterances to your bot. The following fields are
required:    startDateTime and endDateTime – Define a time range for which you want to
retrieve results.   Of the optional fields, you can organize the results in the following
ways:   Use the filters field to filter the results and the sortBy field to specify the
values by which to sort the results.   Use the maxResults field to limit the number of
results to return in a single response and the nextToken field to return the next batch of
results if the response does not return the full set of results.

# Arguments
- `bot_id`: The identifier for the bot for which you want to retrieve utterance analytics.
- `end_date_time`: The date and time that marks the end of the range of time for which you
  want to see utterance analytics.
- `start_date_time`: The date and time that marks the beginning of the range of time for
  which you want to see utterance analytics.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: A list of objects, each of which describes a condition by which you want to
  filter the results.
- `"maxResults"`: The maximum number of results to return in each page of results. If there
  are fewer results than the maximum page size, only the actual number of results are
  returned.
- `"nextToken"`: If the response from the ListUtteranceAnalyticsData operation contains
  more results than specified in the maxResults parameter, a token is returned in the
  response. Use the returned token in the nextToken parameter of a ListUtteranceAnalyticsData
  request to return the next page of results. For a complete set of results, call the
  ListUtteranceAnalyticsData operation until the nextToken returned in the response is null.
- `"sortBy"`: An object specifying the measure and method by which to sort the utterance
  analytics data.
"""
function list_utterance_analytics_data(
    botId, endDateTime, startDateTime; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_models_v2(
        "POST",
        "/bots/$(botId)/analytics/utterances",
        Dict{String,Any}("endDateTime" => endDateTime, "startDateTime" => startDateTime);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_utterance_analytics_data(
    botId,
    endDateTime,
    startDateTime,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "POST",
        "/bots/$(botId)/analytics/utterances",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "endDateTime" => endDateTime, "startDateTime" => startDateTime
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_utterance_metrics(bot_id, end_date_time, metrics, start_date_time)
    list_utterance_metrics(bot_id, end_date_time, metrics, start_date_time, params::Dict{String,<:Any})

 To use this API operation, your IAM role must have permissions to perform the
ListAggregatedUtterances operation, which provides access to utterance-related analytics.
See Viewing utterance statistics for the IAM policy to apply to the IAM role.  Retrieves
summary metrics for the utterances in your bot. The following fields are required:
metrics – A list of AnalyticsUtteranceMetric objects. In each object, use the name field
to specify the metric to calculate, the statistic field to specify whether to calculate the
Sum, Average, or Max number, and the order field to specify whether to sort the results in
Ascending or Descending order.    startDateTime and endDateTime – Define a time range for
which you want to retrieve results.   Of the optional fields, you can organize the results
in the following ways:   Use the filters field to filter the results, the groupBy field to
specify categories by which to group the results, and the binBy field to specify time
intervals by which to group the results.   Use the maxResults field to limit the number of
results to return in a single response and the nextToken field to return the next batch of
results if the response does not return the full set of results.   Note that an order field
exists in both binBy and metrics. Currently, you can specify it in either field, but not in
both.

# Arguments
- `bot_id`: The identifier for the bot for which you want to retrieve utterance metrics.
- `end_date_time`: The date and time that marks the end of the range of time for which you
  want to see utterance metrics.
- `metrics`: A list of objects, each of which contains a metric you want to list, the
  statistic for the metric you want to return, and the method by which to organize the
  results.
- `start_date_time`: The date and time that marks the beginning of the range of time for
  which you want to see utterance metrics.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"attributes"`: A list containing attributes related to the utterance that you want the
  response to return. The following attributes are possible:    LastUsedIntent – The last
  used intent at the time of the utterance.
- `"binBy"`: A list of objects, each of which contains specifications for organizing the
  results by time.
- `"filters"`: A list of objects, each of which describes a condition by which you want to
  filter the results.
- `"groupBy"`: A list of objects, each of which specifies how to group the results. You can
  group by the following criteria:    UtteranceText – The transcription of the utterance.
   UtteranceState – The state of the utterance. The possible states are detailed in Key
  definitions in the user guide.
- `"maxResults"`: The maximum number of results to return in each page of results. If there
  are fewer results than the maximum page size, only the actual number of results are
  returned.
- `"nextToken"`: If the response from the ListUtteranceMetrics operation contains more
  results than specified in the maxResults parameter, a token is returned in the response.
  Use the returned token in the nextToken parameter of a ListUtteranceMetrics request to
  return the next page of results. For a complete set of results, call the
  ListUtteranceMetrics operation until the nextToken returned in the response is null.
"""
function list_utterance_metrics(
    botId,
    endDateTime,
    metrics,
    startDateTime;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "POST",
        "/bots/$(botId)/analytics/utterancemetrics",
        Dict{String,Any}(
            "endDateTime" => endDateTime,
            "metrics" => metrics,
            "startDateTime" => startDateTime,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_utterance_metrics(
    botId,
    endDateTime,
    metrics,
    startDateTime,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "POST",
        "/bots/$(botId)/analytics/utterancemetrics",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "endDateTime" => endDateTime,
                    "metrics" => metrics,
                    "startDateTime" => startDateTime,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    search_associated_transcripts(bot_id, bot_recommendation_id, bot_version, filters, locale_id)
    search_associated_transcripts(bot_id, bot_recommendation_id, bot_version, filters, locale_id, params::Dict{String,<:Any})

Search for associated transcripts that meet the specified criteria.

# Arguments
- `bot_id`: The unique identifier of the bot associated with the transcripts that you are
  searching.
- `bot_recommendation_id`: The unique identifier of the bot recommendation associated with
  the transcripts to search.
- `bot_version`: The version of the bot containing the transcripts that you are searching.
- `filters`: A list of filter objects.
- `locale_id`: The identifier of the language and locale of the transcripts to search. The
  string must match one of the supported locales. For more information, see Supported
  languages

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of bot recommendations to return in each page of
  results. If there are fewer results than the max page size, only the actual number of
  results are returned.
- `"nextIndex"`: If the response from the SearchAssociatedTranscriptsRequest operation
  contains more results than specified in the maxResults parameter, an index is returned in
  the response. Use that index in the nextIndex parameter to return the next page of results.
- `"searchOrder"`: How SearchResults are ordered. Valid values are Ascending or Descending.
  The default is Descending.
"""
function search_associated_transcripts(
    botId,
    botRecommendationId,
    botVersion,
    filters,
    localeId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "POST",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/botrecommendations/$(botRecommendationId)/associatedtranscripts",
        Dict{String,Any}("filters" => filters);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function search_associated_transcripts(
    botId,
    botRecommendationId,
    botVersion,
    filters,
    localeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "POST",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/botrecommendations/$(botRecommendationId)/associatedtranscripts",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("filters" => filters), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_bot_recommendation(bot_id, bot_version, locale_id, transcript_source_setting)
    start_bot_recommendation(bot_id, bot_version, locale_id, transcript_source_setting, params::Dict{String,<:Any})

Use this to provide your transcript data, and to start the bot recommendation process.

# Arguments
- `bot_id`: The unique identifier of the bot containing the bot recommendation.
- `bot_version`: The version of the bot containing the bot recommendation.
- `locale_id`: The identifier of the language and locale of the bot recommendation to
  start. The string must match one of the supported locales. For more information, see
  Supported languages
- `transcript_source_setting`: The object representing the Amazon S3 bucket containing the
  transcript, as well as the associated metadata.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"encryptionSetting"`: The object representing the passwords that will be used to encrypt
  the data related to the bot recommendation results, as well as the KMS key ARN used to
  encrypt the associated metadata.
"""
function start_bot_recommendation(
    botId,
    botVersion,
    localeId,
    transcriptSourceSetting;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "PUT",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/botrecommendations/",
        Dict{String,Any}("transcriptSourceSetting" => transcriptSourceSetting);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_bot_recommendation(
    botId,
    botVersion,
    localeId,
    transcriptSourceSetting,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "PUT",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/botrecommendations/",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("transcriptSourceSetting" => transcriptSourceSetting),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_bot_resource_generation(bot_id, bot_version, generation_input_prompt, locale_id)
    start_bot_resource_generation(bot_id, bot_version, generation_input_prompt, locale_id, params::Dict{String,<:Any})

Starts a request for the descriptive bot builder to generate a bot locale configuration
based on the prompt you provide it. After you make this call, use the
DescribeBotResourceGeneration operation to check on the status of the generation and for
the generatedBotLocaleUrl when the generation is complete. Use that value to retrieve the
Amazon S3 object containing the bot locale configuration. You can then modify and import
this configuration.

# Arguments
- `bot_id`: The unique identifier of the bot for which to generate intents and slot types.
- `bot_version`: The version of the bot for which to generate intents and slot types.
- `generation_input_prompt`: The prompt to generate intents and slot types for the bot
  locale. Your description should be both detailed and precise to help generate appropriate
  and sufficient intents for your bot. Include a list of actions to improve the intent
  creation process.
- `locale_id`: The locale of the bot for which to generate intents and slot types.

"""
function start_bot_resource_generation(
    botId,
    botVersion,
    generationInputPrompt,
    localeId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "PUT",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/startgeneration",
        Dict{String,Any}("generationInputPrompt" => generationInputPrompt);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_bot_resource_generation(
    botId,
    botVersion,
    generationInputPrompt,
    localeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "PUT",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/startgeneration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("generationInputPrompt" => generationInputPrompt),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_import(import_id, merge_strategy, resource_specification)
    start_import(import_id, merge_strategy, resource_specification, params::Dict{String,<:Any})

Starts importing a bot, bot locale, or custom vocabulary from a zip archive that you
uploaded to an S3 bucket.

# Arguments
- `import_id`: The unique identifier for the import. It is included in the response from
  the CreateUploadUrl operation.
- `merge_strategy`: The strategy to use when there is a name conflict between the imported
  resource and an existing resource. When the merge strategy is FailOnConflict existing
  resources are not overwritten and the import fails.
- `resource_specification`: Parameters for creating the bot, bot locale or custom
  vocabulary.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filePassword"`: The password used to encrypt the zip archive that contains the resource
  definition. You should always encrypt the zip archive to protect it during transit between
  your site and Amazon Lex.
"""
function start_import(
    importId,
    mergeStrategy,
    resourceSpecification;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "PUT",
        "/imports/",
        Dict{String,Any}(
            "importId" => importId,
            "mergeStrategy" => mergeStrategy,
            "resourceSpecification" => resourceSpecification,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_import(
    importId,
    mergeStrategy,
    resourceSpecification,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "PUT",
        "/imports/",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "importId" => importId,
                    "mergeStrategy" => mergeStrategy,
                    "resourceSpecification" => resourceSpecification,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_test_execution(api_mode, target, test_set_id)
    start_test_execution(api_mode, target, test_set_id, params::Dict{String,<:Any})

The action to start test set execution.

# Arguments
- `api_mode`: Indicates whether we use streaming or non-streaming APIs for the test set
  execution. For streaming, StartConversation Runtime API is used. Whereas, for
  non-streaming, RecognizeUtterance and RecognizeText Amazon Lex Runtime API are used.
- `target`: The target bot for the test set execution.
- `test_set_id`: The test set Id for the test set execution.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"testExecutionModality"`: Indicates whether audio or text is used.
"""
function start_test_execution(
    apiMode, target, testSetId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_models_v2(
        "POST",
        "/testsets/$(testSetId)/testexecutions",
        Dict{String,Any}("apiMode" => apiMode, "target" => target);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_test_execution(
    apiMode,
    target,
    testSetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "POST",
        "/testsets/$(testSetId)/testexecutions",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("apiMode" => apiMode, "target" => target), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_test_set_generation(generation_data_source, role_arn, storage_location, test_set_name)
    start_test_set_generation(generation_data_source, role_arn, storage_location, test_set_name, params::Dict{String,<:Any})

The action to start the generation of test set.

# Arguments
- `generation_data_source`: The data source for the test set generation.
- `role_arn`: The roleARN used for any operation in the test set to access resources in the
  Amazon Web Services account.
- `storage_location`: The Amazon S3 storage location for the test set generation.
- `test_set_name`: The test set name for the test set generation request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The test set description for the test set generation request.
- `"testSetTags"`: A list of tags to add to the test set. You can only add tags when you
  import/generate a new test set. You can't use the UpdateTestSet operation to update tags.
  To update tags, use the TagResource operation.
"""
function start_test_set_generation(
    generationDataSource,
    roleArn,
    storageLocation,
    testSetName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "PUT",
        "/testsetgenerations",
        Dict{String,Any}(
            "generationDataSource" => generationDataSource,
            "roleArn" => roleArn,
            "storageLocation" => storageLocation,
            "testSetName" => testSetName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_test_set_generation(
    generationDataSource,
    roleArn,
    storageLocation,
    testSetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "PUT",
        "/testsetgenerations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "generationDataSource" => generationDataSource,
                    "roleArn" => roleArn,
                    "storageLocation" => storageLocation,
                    "testSetName" => testSetName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_bot_recommendation(bot_id, bot_recommendation_id, bot_version, locale_id)
    stop_bot_recommendation(bot_id, bot_recommendation_id, bot_version, locale_id, params::Dict{String,<:Any})

Stop an already running Bot Recommendation request.

# Arguments
- `bot_id`: The unique identifier of the bot containing the bot recommendation to be
  stopped.
- `bot_recommendation_id`: The unique identifier of the bot recommendation to be stopped.
- `bot_version`: The version of the bot containing the bot recommendation.
- `locale_id`: The identifier of the language and locale of the bot recommendation to stop.
  The string must match one of the supported locales. For more information, see Supported
  languages

"""
function stop_bot_recommendation(
    botId,
    botRecommendationId,
    botVersion,
    localeId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "PUT",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/botrecommendations/$(botRecommendationId)/stopbotrecommendation";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_bot_recommendation(
    botId,
    botRecommendationId,
    botVersion,
    localeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "PUT",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/botrecommendations/$(botRecommendationId)/stopbotrecommendation",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds the specified tags to the specified resource. If a tag key already exists, the
existing value is replaced with the new value.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the bot, bot alias, or bot channel to
  tag.
- `tags`: A list of tag keys to add to the resource. If a tag key already exists, the
  existing value is replaced with the new value.

"""
function tag_resource(resourceARN, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return lex_models_v2(
        "POST",
        "/tags/$(resourceARN)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceARN,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "POST",
        "/tags/$(resourceARN)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes tags from a bot, bot alias, or bot channel.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource to remove the tags from.
- `tag_keys`: A list of tag keys to remove from the resource. If a tag key does not exist
  on the resource, it is ignored.

"""
function untag_resource(
    resourceARN, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_models_v2(
        "DELETE",
        "/tags/$(resourceARN)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceARN,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "DELETE",
        "/tags/$(resourceARN)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_bot(bot_id, bot_name, data_privacy, idle_session_ttlin_seconds, role_arn)
    update_bot(bot_id, bot_name, data_privacy, idle_session_ttlin_seconds, role_arn, params::Dict{String,<:Any})

Updates the configuration of an existing bot.

# Arguments
- `bot_id`: The unique identifier of the bot to update. This identifier is returned by the
  CreateBot operation.
- `bot_name`: The new name of the bot. The name must be unique in the account that creates
  the bot.
- `data_privacy`: Provides information on additional privacy protections Amazon Lex should
  use with the bot's data.
- `idle_session_ttlin_seconds`: The time, in seconds, that Amazon Lex should keep
  information about a user's conversation with the bot. A user interaction remains active for
  the amount of time specified. If no conversation occurs during this time, the session
  expires and Amazon Lex deletes any data provided before the timeout. You can specify
  between 60 (1 minute) and 86,400 (24 hours) seconds.
- `role_arn`: The Amazon Resource Name (ARN) of an IAM role that has permissions to access
  the bot.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"botMembers"`: The list of bot members in the network associated with the update action.
- `"botType"`: The type of the bot to be updated.
- `"description"`: A description of the bot.
"""
function update_bot(
    botId,
    botName,
    dataPrivacy,
    idleSessionTTLInSeconds,
    roleArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "PUT",
        "/bots/$(botId)/",
        Dict{String,Any}(
            "botName" => botName,
            "dataPrivacy" => dataPrivacy,
            "idleSessionTTLInSeconds" => idleSessionTTLInSeconds,
            "roleArn" => roleArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_bot(
    botId,
    botName,
    dataPrivacy,
    idleSessionTTLInSeconds,
    roleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "PUT",
        "/bots/$(botId)/",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "botName" => botName,
                    "dataPrivacy" => dataPrivacy,
                    "idleSessionTTLInSeconds" => idleSessionTTLInSeconds,
                    "roleArn" => roleArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_bot_alias(bot_alias_id, bot_alias_name, bot_id)
    update_bot_alias(bot_alias_id, bot_alias_name, bot_id, params::Dict{String,<:Any})

Updates the configuration of an existing bot alias.

# Arguments
- `bot_alias_id`: The unique identifier of the bot alias.
- `bot_alias_name`: The new name to assign to the bot alias.
- `bot_id`: The identifier of the bot with the updated alias.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"botAliasLocaleSettings"`: The new Lambda functions to use in each locale for the bot
  alias.
- `"botVersion"`: The new bot version to assign to the bot alias.
- `"conversationLogSettings"`: The new settings for storing conversation logs in Amazon
  CloudWatch Logs and Amazon S3 buckets.
- `"description"`: The new description to assign to the bot alias.
- `"sentimentAnalysisSettings"`:
"""
function update_bot_alias(
    botAliasId, botAliasName, botId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_models_v2(
        "PUT",
        "/bots/$(botId)/botaliases/$(botAliasId)/",
        Dict{String,Any}("botAliasName" => botAliasName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_bot_alias(
    botAliasId,
    botAliasName,
    botId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "PUT",
        "/bots/$(botId)/botaliases/$(botAliasId)/",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("botAliasName" => botAliasName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_bot_locale(bot_id, bot_version, locale_id, nlu_intent_confidence_threshold)
    update_bot_locale(bot_id, bot_version, locale_id, nlu_intent_confidence_threshold, params::Dict{String,<:Any})

Updates the settings that a bot has for a specific locale.

# Arguments
- `bot_id`: The unique identifier of the bot that contains the locale.
- `bot_version`: The version of the bot that contains the locale to be updated. The version
  can only be the DRAFT version.
- `locale_id`: The identifier of the language and locale to update. The string must match
  one of the supported locales. For more information, see Supported languages.
- `nlu_intent_confidence_threshold`: The new confidence threshold where Amazon Lex inserts
  the AMAZON.FallbackIntent and AMAZON.KendraSearchIntent intents in the list of possible
  intents for an utterance.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The new description of the locale.
- `"generativeAISettings"`: Contains settings for generative AI features powered by Amazon
  Bedrock for your bot locale. Use this object to turn generative AI features on and off.
  Pricing may differ if you turn a feature on. For more information, see LINK.
- `"voiceSettings"`: The new Amazon Polly voice Amazon Lex should use for voice interaction
  with the user.
"""
function update_bot_locale(
    botId,
    botVersion,
    localeId,
    nluIntentConfidenceThreshold;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "PUT",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/",
        Dict{String,Any}("nluIntentConfidenceThreshold" => nluIntentConfidenceThreshold);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_bot_locale(
    botId,
    botVersion,
    localeId,
    nluIntentConfidenceThreshold,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "PUT",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "nluIntentConfidenceThreshold" => nluIntentConfidenceThreshold
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_bot_recommendation(bot_id, bot_recommendation_id, bot_version, encryption_setting, locale_id)
    update_bot_recommendation(bot_id, bot_recommendation_id, bot_version, encryption_setting, locale_id, params::Dict{String,<:Any})

Updates an existing bot recommendation request.

# Arguments
- `bot_id`: The unique identifier of the bot containing the bot recommendation to be
  updated.
- `bot_recommendation_id`: The unique identifier of the bot recommendation to be updated.
- `bot_version`: The version of the bot containing the bot recommendation to be updated.
- `encryption_setting`: The object representing the passwords that will be used to encrypt
  the data related to the bot recommendation results, as well as the KMS key ARN used to
  encrypt the associated metadata.
- `locale_id`: The identifier of the language and locale of the bot recommendation to
  update. The string must match one of the supported locales. For more information, see
  Supported languages

"""
function update_bot_recommendation(
    botId,
    botRecommendationId,
    botVersion,
    encryptionSetting,
    localeId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "PUT",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/botrecommendations/$(botRecommendationId)/",
        Dict{String,Any}("encryptionSetting" => encryptionSetting);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_bot_recommendation(
    botId,
    botRecommendationId,
    botVersion,
    encryptionSetting,
    localeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "PUT",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/botrecommendations/$(botRecommendationId)/",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("encryptionSetting" => encryptionSetting), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_export(export_id)
    update_export(export_id, params::Dict{String,<:Any})

Updates the password used to protect an export zip archive. The password is not required.
If you don't supply a password, Amazon Lex generates a zip file that is not protected by a
password. This is the archive that is available at the pre-signed S3 URL provided by the
DescribeExport operation.

# Arguments
- `export_id`: The unique identifier Amazon Lex assigned to the export.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filePassword"`: The new password to use to encrypt the export zip archive.
"""
function update_export(exportId; aws_config::AbstractAWSConfig=current_aws_config())
    return lex_models_v2(
        "PUT",
        "/exports/$(exportId)/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_export(
    exportId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "PUT",
        "/exports/$(exportId)/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_intent(bot_id, bot_version, intent_id, intent_name, locale_id)
    update_intent(bot_id, bot_version, intent_id, intent_name, locale_id, params::Dict{String,<:Any})

Updates the settings for an intent.

# Arguments
- `bot_id`: The identifier of the bot that contains the intent.
- `bot_version`: The version of the bot that contains the intent. Must be DRAFT.
- `intent_id`: The unique identifier of the intent to update.
- `intent_name`: The new name for the intent.
- `locale_id`: The identifier of the language and locale where this intent is used. The
  string must match one of the supported locales. For more information, see Supported
  languages.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The new description of the intent.
- `"dialogCodeHook"`: The new Lambda function to use between each turn of the conversation
  with the bot.
- `"fulfillmentCodeHook"`: The new Lambda function to call when all of the intents required
  slots are provided and the intent is ready for fulfillment.
- `"initialResponseSetting"`: Configuration settings for a response sent to the user before
  Amazon Lex starts eliciting slots.
- `"inputContexts"`: A new list of contexts that must be active in order for Amazon Lex to
  consider the intent.
- `"intentClosingSetting"`: The new response that Amazon Lex sends the user when the intent
  is closed.
- `"intentConfirmationSetting"`: New prompts that Amazon Lex sends to the user to confirm
  the completion of an intent.
- `"kendraConfiguration"`: New configuration settings for connecting to an Amazon Kendra
  index.
- `"outputContexts"`: A new list of contexts that Amazon Lex activates when the intent is
  fulfilled.
- `"parentIntentSignature"`: The signature of the new built-in intent to use as the parent
  of this intent.
- `"qnAIntentConfiguration"`: Specifies the configuration of the built-in Amazon.QnAIntent.
  The AMAZON.QnAIntent intent is called when Amazon Lex can't determine another intent to
  invoke. If you specify this field, you can't specify the kendraConfiguration field.
- `"sampleUtterances"`: New utterances used to invoke the intent.
- `"slotPriorities"`: A new list of slots and their priorities that are contained by the
  intent.
"""
function update_intent(
    botId,
    botVersion,
    intentId,
    intentName,
    localeId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "PUT",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/intents/$(intentId)/",
        Dict{String,Any}("intentName" => intentName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_intent(
    botId,
    botVersion,
    intentId,
    intentName,
    localeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "PUT",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/intents/$(intentId)/",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("intentName" => intentName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_resource_policy(policy, resource_arn)
    update_resource_policy(policy, resource_arn, params::Dict{String,<:Any})

Replaces the existing resource policy for a bot or bot alias with a new one. If the policy
doesn't exist, Amazon Lex returns an exception.

# Arguments
- `policy`: A resource policy to add to the resource. The policy is a JSON structure that
  contains one or more statements that define the policy. The policy must follow the IAM
  syntax. For more information about the contents of a JSON policy document, see  IAM JSON
  policy reference .  If the policy isn't valid, Amazon Lex returns a validation exception.
- `resource_arn`: The Amazon Resource Name (ARN) of the bot or bot alias that the resource
  policy is attached to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"expectedRevisionId"`: The identifier of the revision of the policy to update. If this
  revision ID doesn't match the current revision ID, Amazon Lex throws an exception. If you
  don't specify a revision, Amazon Lex overwrites the contents of the policy with the new
  values.
"""
function update_resource_policy(
    policy, resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_models_v2(
        "PUT",
        "/policy/$(resourceArn)/",
        Dict{String,Any}("policy" => policy);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_resource_policy(
    policy,
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "PUT",
        "/policy/$(resourceArn)/",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("policy" => policy), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_slot(bot_id, bot_version, intent_id, locale_id, slot_id, slot_name, value_elicitation_setting)
    update_slot(bot_id, bot_version, intent_id, locale_id, slot_id, slot_name, value_elicitation_setting, params::Dict{String,<:Any})

Updates the settings for a slot.

# Arguments
- `bot_id`: The unique identifier of the bot that contains the slot.
- `bot_version`: The version of the bot that contains the slot. Must always be DRAFT.
- `intent_id`: The identifier of the intent that contains the slot.
- `locale_id`: The identifier of the language and locale that contains the slot. The string
  must match one of the supported locales. For more information, see Supported languages.
- `slot_id`: The unique identifier for the slot to update.
- `slot_name`: The new name for the slot.
- `value_elicitation_setting`: A new set of prompts that Amazon Lex sends to the user to
  elicit a response the provides a value for the slot.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The new description for the slot.
- `"multipleValuesSetting"`: Determines whether the slot accepts multiple values in one
  response. Multiple value slots are only available in the en-US locale. If you set this
  value to true in any other locale, Amazon Lex throws a ValidationException. If the
  multipleValuesSetting is not set, the default value is false.
- `"obfuscationSetting"`: New settings that determine how slot values are formatted in
  Amazon CloudWatch logs.
- `"slotTypeId"`: The unique identifier of the new slot type to associate with this slot.
- `"subSlotSetting"`: Specifications for the constituent sub slots and the expression for
  the composite slot.
"""
function update_slot(
    botId,
    botVersion,
    intentId,
    localeId,
    slotId,
    slotName,
    valueElicitationSetting;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "PUT",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/intents/$(intentId)/slots/$(slotId)/",
        Dict{String,Any}(
            "slotName" => slotName, "valueElicitationSetting" => valueElicitationSetting
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_slot(
    botId,
    botVersion,
    intentId,
    localeId,
    slotId,
    slotName,
    valueElicitationSetting,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "PUT",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/intents/$(intentId)/slots/$(slotId)/",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "slotName" => slotName,
                    "valueElicitationSetting" => valueElicitationSetting,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_slot_type(bot_id, bot_version, locale_id, slot_type_id, slot_type_name)
    update_slot_type(bot_id, bot_version, locale_id, slot_type_id, slot_type_name, params::Dict{String,<:Any})

Updates the configuration of an existing slot type.

# Arguments
- `bot_id`: The identifier of the bot that contains the slot type.
- `bot_version`: The version of the bot that contains the slot type. Must be DRAFT.
- `locale_id`: The identifier of the language and locale that contains the slot type. The
  string must match one of the supported locales. For more information, see Supported
  languages.
- `slot_type_id`: The unique identifier of the slot type to update.
- `slot_type_name`: The new name of the slot type.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"compositeSlotTypeSetting"`: Specifications for a composite slot type.
- `"description"`: The new description of the slot type.
- `"externalSourceSetting"`:
- `"parentSlotTypeSignature"`: The new built-in slot type that should be used as the parent
  of this slot type.
- `"slotTypeValues"`: A new list of values and their optional synonyms that define the
  values that the slot type can take.
- `"valueSelectionSetting"`: The strategy that Amazon Lex should use when deciding on a
  value from the list of slot type values.
"""
function update_slot_type(
    botId,
    botVersion,
    localeId,
    slotTypeId,
    slotTypeName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "PUT",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/slottypes/$(slotTypeId)/",
        Dict{String,Any}("slotTypeName" => slotTypeName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_slot_type(
    botId,
    botVersion,
    localeId,
    slotTypeId,
    slotTypeName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "PUT",
        "/bots/$(botId)/botversions/$(botVersion)/botlocales/$(localeId)/slottypes/$(slotTypeId)/",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("slotTypeName" => slotTypeName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_test_set(test_set_id, test_set_name)
    update_test_set(test_set_id, test_set_name, params::Dict{String,<:Any})

The action to update the test set.

# Arguments
- `test_set_id`: The test set Id for which update test operation to be performed.
- `test_set_name`: The new test set name.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The new test set description.
"""
function update_test_set(
    testSetId, testSetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_models_v2(
        "PUT",
        "/testsets/$(testSetId)",
        Dict{String,Any}("testSetName" => testSetName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_test_set(
    testSetId,
    testSetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_models_v2(
        "PUT",
        "/testsets/$(testSetId)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("testSetName" => testSetName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: codestar_notifications
using AWS.Compat
using AWS.UUIDs

"""
    create_notification_rule(detail_type, event_type_ids, name, resource, targets)
    create_notification_rule(detail_type, event_type_ids, name, resource, targets, params::Dict{String,<:Any})

Creates a notification rule for a resource. The rule specifies the events you want
notifications about and the targets (such as Chatbot topics or Chatbot clients configured
for Slack) where you want to receive them.

# Arguments
- `detail_type`: The level of detail to include in the notifications for this resource.
  BASIC will include only the contents of the event as it would appear in Amazon CloudWatch.
  FULL will include any supplemental information provided by AWS CodeStar Notifications
  and/or the service for the resource for which the notification is created.
- `event_type_ids`: A list of event types associated with this notification rule. For a
  list of allowed events, see EventTypeSummary.
- `name`: The name for the notification rule. Notification rule names must be unique in
  your Amazon Web Services account.
- `resource`: The Amazon Resource Name (ARN) of the resource to associate with the
  notification rule. Supported resources include pipelines in CodePipeline, repositories in
  CodeCommit, and build projects in CodeBuild.
- `targets`: A list of Amazon Resource Names (ARNs) of Amazon Simple Notification Service
  topics and Chatbot clients to associate with the notification rule.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: A unique, client-generated idempotency token that, when provided
  in a request, ensures the request cannot be repeated with a changed parameter. If a request
  with the same parameters is received and a token is included, the request returns
  information about the initial request that used that token.  The Amazon Web Services SDKs
  prepopulate client request tokens. If you are using an Amazon Web Services SDK, an
  idempotency token is created for you.
- `"Status"`: The status of the notification rule. The default value is ENABLED. If the
  status is set to DISABLED, notifications aren't sent for the notification rule.
- `"Tags"`: A list of tags to apply to this notification rule. Key names cannot start with
  \"aws\".
"""
function create_notification_rule(
    DetailType,
    EventTypeIds,
    Name,
    Resource,
    Targets;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codestar_notifications(
        "POST",
        "/createNotificationRule",
        Dict{String,Any}(
            "DetailType" => DetailType,
            "EventTypeIds" => EventTypeIds,
            "Name" => Name,
            "Resource" => Resource,
            "Targets" => Targets,
            "ClientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_notification_rule(
    DetailType,
    EventTypeIds,
    Name,
    Resource,
    Targets,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codestar_notifications(
        "POST",
        "/createNotificationRule",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DetailType" => DetailType,
                    "EventTypeIds" => EventTypeIds,
                    "Name" => Name,
                    "Resource" => Resource,
                    "Targets" => Targets,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_notification_rule(arn)
    delete_notification_rule(arn, params::Dict{String,<:Any})

Deletes a notification rule for a resource.

# Arguments
- `arn`: The Amazon Resource Name (ARN) of the notification rule you want to delete.

"""
function delete_notification_rule(Arn; aws_config::AbstractAWSConfig=current_aws_config())
    return codestar_notifications(
        "POST",
        "/deleteNotificationRule",
        Dict{String,Any}("Arn" => Arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_notification_rule(
    Arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codestar_notifications(
        "POST",
        "/deleteNotificationRule",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Arn" => Arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_target(target_address)
    delete_target(target_address, params::Dict{String,<:Any})

Deletes a specified target for notifications.

# Arguments
- `target_address`: The Amazon Resource Name (ARN) of the Chatbot topic or Chatbot client
  to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ForceUnsubscribeAll"`: A Boolean value that can be used to delete all associations with
  this Chatbot topic. The default value is FALSE. If set to TRUE, all associations between
  that target and every notification rule in your Amazon Web Services account are deleted.
"""
function delete_target(TargetAddress; aws_config::AbstractAWSConfig=current_aws_config())
    return codestar_notifications(
        "POST",
        "/deleteTarget",
        Dict{String,Any}("TargetAddress" => TargetAddress);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_target(
    TargetAddress,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codestar_notifications(
        "POST",
        "/deleteTarget",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TargetAddress" => TargetAddress), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_notification_rule(arn)
    describe_notification_rule(arn, params::Dict{String,<:Any})

Returns information about a specified notification rule.

# Arguments
- `arn`: The Amazon Resource Name (ARN) of the notification rule.

"""
function describe_notification_rule(Arn; aws_config::AbstractAWSConfig=current_aws_config())
    return codestar_notifications(
        "POST",
        "/describeNotificationRule",
        Dict{String,Any}("Arn" => Arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_notification_rule(
    Arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codestar_notifications(
        "POST",
        "/describeNotificationRule",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Arn" => Arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_event_types()
    list_event_types(params::Dict{String,<:Any})

Returns information about the event types available for configuring notifications.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: The filters to use to return information by service or resource type.
- `"MaxResults"`: A non-negative integer used to limit the number of returned results. The
  default number is 50. The maximum number of results that can be returned is 100.
- `"NextToken"`: An enumeration token that, when provided in a request, returns the next
  batch of the results.
"""
function list_event_types(; aws_config::AbstractAWSConfig=current_aws_config())
    return codestar_notifications(
        "POST", "/listEventTypes"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_event_types(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codestar_notifications(
        "POST",
        "/listEventTypes",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_notification_rules()
    list_notification_rules(params::Dict{String,<:Any})

Returns a list of the notification rules for an Amazon Web Services account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: The filters to use to return information by service or resource type. For
  valid values, see ListNotificationRulesFilter.  A filter with the same name can appear more
  than once when used with OR statements. Filters with different names should be applied with
  AND statements.
- `"MaxResults"`: A non-negative integer used to limit the number of returned results. The
  maximum number of results that can be returned is 100.
- `"NextToken"`: An enumeration token that, when provided in a request, returns the next
  batch of the results.
"""
function list_notification_rules(; aws_config::AbstractAWSConfig=current_aws_config())
    return codestar_notifications(
        "POST",
        "/listNotificationRules";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_notification_rules(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codestar_notifications(
        "POST",
        "/listNotificationRules",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(arn)
    list_tags_for_resource(arn, params::Dict{String,<:Any})

Returns a list of the tags associated with a notification rule.

# Arguments
- `arn`: The Amazon Resource Name (ARN) for the notification rule.

"""
function list_tags_for_resource(Arn; aws_config::AbstractAWSConfig=current_aws_config())
    return codestar_notifications(
        "POST",
        "/listTagsForResource",
        Dict{String,Any}("Arn" => Arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    Arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codestar_notifications(
        "POST",
        "/listTagsForResource",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Arn" => Arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_targets()
    list_targets(params::Dict{String,<:Any})

Returns a list of the notification rule targets for an Amazon Web Services account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: The filters to use to return information by service or resource type. Valid
  filters include target type, target address, and target status.  A filter with the same
  name can appear more than once when used with OR statements. Filters with different names
  should be applied with AND statements.
- `"MaxResults"`: A non-negative integer used to limit the number of returned results. The
  maximum number of results that can be returned is 100.
- `"NextToken"`: An enumeration token that, when provided in a request, returns the next
  batch of the results.
"""
function list_targets(; aws_config::AbstractAWSConfig=current_aws_config())
    return codestar_notifications(
        "POST", "/listTargets"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_targets(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codestar_notifications(
        "POST",
        "/listTargets",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    subscribe(arn, target)
    subscribe(arn, target, params::Dict{String,<:Any})

Creates an association between a notification rule and an Chatbot topic or Chatbot client
so that the associated target can receive notifications when the events described in the
rule are triggered.

# Arguments
- `arn`: The Amazon Resource Name (ARN) of the notification rule for which you want to
  create the association.
- `target`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: An enumeration token that, when provided in a request, returns
  the next batch of the results.
"""
function subscribe(Arn, Target; aws_config::AbstractAWSConfig=current_aws_config())
    return codestar_notifications(
        "POST",
        "/subscribe",
        Dict{String,Any}("Arn" => Arn, "Target" => Target);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function subscribe(
    Arn,
    Target,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codestar_notifications(
        "POST",
        "/subscribe",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Arn" => Arn, "Target" => Target), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(arn, tags)
    tag_resource(arn, tags, params::Dict{String,<:Any})

Associates a set of provided tags with a notification rule.

# Arguments
- `arn`: The Amazon Resource Name (ARN) of the notification rule to tag.
- `tags`: The list of tags to associate with the resource. Tag key names cannot start with
  \"aws\".

"""
function tag_resource(Arn, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return codestar_notifications(
        "POST",
        "/tagResource",
        Dict{String,Any}("Arn" => Arn, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    Arn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codestar_notifications(
        "POST",
        "/tagResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Arn" => Arn, "Tags" => Tags), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    unsubscribe(arn, target_address)
    unsubscribe(arn, target_address, params::Dict{String,<:Any})

Removes an association between a notification rule and an Chatbot topic so that subscribers
to that topic stop receiving notifications when the events described in the rule are
triggered.

# Arguments
- `arn`: The Amazon Resource Name (ARN) of the notification rule.
- `target_address`: The ARN of the Chatbot topic to unsubscribe from the notification rule.

"""
function unsubscribe(Arn, TargetAddress; aws_config::AbstractAWSConfig=current_aws_config())
    return codestar_notifications(
        "POST",
        "/unsubscribe",
        Dict{String,Any}("Arn" => Arn, "TargetAddress" => TargetAddress);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function unsubscribe(
    Arn,
    TargetAddress,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codestar_notifications(
        "POST",
        "/unsubscribe",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Arn" => Arn, "TargetAddress" => TargetAddress),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes the association between one or more provided tags and a notification rule.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the notification rule from which to
  remove the tags.
- `tag_keys`: The key names of the tags to remove.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codestar_notifications(
        "POST",
        "/untagResource/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codestar_notifications(
        "POST",
        "/untagResource/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_notification_rule(arn)
    update_notification_rule(arn, params::Dict{String,<:Any})

Updates a notification rule for a resource. You can change the events that trigger the
notification rule, the status of the rule, and the targets that receive the notifications.
To add or remove tags for a notification rule, you must use TagResource and UntagResource.

# Arguments
- `arn`: The Amazon Resource Name (ARN) of the notification rule.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DetailType"`: The level of detail to include in the notifications for this resource.
  BASIC will include only the contents of the event as it would appear in Amazon CloudWatch.
  FULL will include any supplemental information provided by AWS CodeStar Notifications
  and/or the service for the resource for which the notification is created.
- `"EventTypeIds"`: A list of event types associated with this notification rule. For a
  complete list of event types and IDs, see Notification concepts in the Developer Tools
  Console User Guide.
- `"Name"`: The name of the notification rule.
- `"Status"`: The status of the notification rule. Valid statuses include enabled (sending
  notifications) or disabled (not sending notifications).
- `"Targets"`: The address and type of the targets to receive notifications from this
  notification rule.
"""
function update_notification_rule(Arn; aws_config::AbstractAWSConfig=current_aws_config())
    return codestar_notifications(
        "POST",
        "/updateNotificationRule",
        Dict{String,Any}("Arn" => Arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_notification_rule(
    Arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codestar_notifications(
        "POST",
        "/updateNotificationRule",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Arn" => Arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: lex_model_building_service
using AWS.Compat
using AWS.UUIDs

"""
    create_bot_version(name)
    create_bot_version(name, params::Dict{String,<:Any})

Creates a new version of the bot based on the LATEST version. If the LATEST version of this
resource hasn't changed since you created the last version, Amazon Lex doesn't create a new
version. It returns the last created version.  You can update only the LATEST version of
the bot. You can't update the numbered versions that you create with the CreateBotVersion
operation.   When you create the first version of a bot, Amazon Lex sets the version to 1.
Subsequent versions increment by 1. For more information, see versioning-intro.   This
operation requires permission for the lex:CreateBotVersion action.

# Arguments
- `name`: The name of the bot that you want to create a new version of. The name is case
  sensitive.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"checksum"`: Identifies a specific revision of the LATEST version of the bot. If you
  specify a checksum and the LATEST version of the bot has a different checksum, a
  PreconditionFailedException exception is returned and Amazon Lex doesn't publish a new
  version. If you don't specify a checksum, Amazon Lex publishes the LATEST version.
"""
function create_bot_version(name; aws_config::AbstractAWSConfig=current_aws_config())
    return lex_model_building_service(
        "POST",
        "/bots/$(name)/versions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_bot_version(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_model_building_service(
        "POST",
        "/bots/$(name)/versions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_intent_version(name)
    create_intent_version(name, params::Dict{String,<:Any})

Creates a new version of an intent based on the LATEST version of the intent. If the LATEST
version of this intent hasn't changed since you last updated it, Amazon Lex doesn't create
a new version. It returns the last version you created.  You can update only the LATEST
version of the intent. You can't update the numbered versions that you create with the
CreateIntentVersion operation.   When you create a version of an intent, Amazon Lex sets
the version to 1. Subsequent versions increment by 1. For more information, see
versioning-intro.  This operation requires permissions to perform the
lex:CreateIntentVersion action.

# Arguments
- `name`: The name of the intent that you want to create a new version of. The name is case
  sensitive.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"checksum"`: Checksum of the LATEST version of the intent that should be used to create
  the new version. If you specify a checksum and the LATEST version of the intent has a
  different checksum, Amazon Lex returns a PreconditionFailedException exception and doesn't
  publish a new version. If you don't specify a checksum, Amazon Lex publishes the LATEST
  version.
"""
function create_intent_version(name; aws_config::AbstractAWSConfig=current_aws_config())
    return lex_model_building_service(
        "POST",
        "/intents/$(name)/versions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_intent_version(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_model_building_service(
        "POST",
        "/intents/$(name)/versions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_slot_type_version(name)
    create_slot_type_version(name, params::Dict{String,<:Any})

Creates a new version of a slot type based on the LATEST version of the specified slot
type. If the LATEST version of this resource has not changed since the last version that
you created, Amazon Lex doesn't create a new version. It returns the last version that you
created.   You can update only the LATEST version of a slot type. You can't update the
numbered versions that you create with the CreateSlotTypeVersion operation.  When you
create a version of a slot type, Amazon Lex sets the version to 1. Subsequent versions
increment by 1. For more information, see versioning-intro.  This operation requires
permissions for the lex:CreateSlotTypeVersion action.

# Arguments
- `name`: The name of the slot type that you want to create a new version for. The name is
  case sensitive.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"checksum"`: Checksum for the LATEST version of the slot type that you want to publish.
  If you specify a checksum and the LATEST version of the slot type has a different checksum,
  Amazon Lex returns a PreconditionFailedException exception and doesn't publish the new
  version. If you don't specify a checksum, Amazon Lex publishes the LATEST version.
"""
function create_slot_type_version(name; aws_config::AbstractAWSConfig=current_aws_config())
    return lex_model_building_service(
        "POST",
        "/slottypes/$(name)/versions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_slot_type_version(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_model_building_service(
        "POST",
        "/slottypes/$(name)/versions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_bot(name)
    delete_bot(name, params::Dict{String,<:Any})

Deletes all versions of the bot, including the LATEST version. To delete a specific version
of the bot, use the DeleteBotVersion operation. The DeleteBot operation doesn't immediately
remove the bot schema. Instead, it is marked for deletion and removed later. Amazon Lex
stores utterances indefinitely for improving the ability of your bot to respond to user
inputs. These utterances are not removed when the bot is deleted. To remove the utterances,
use the DeleteUtterances operation. If a bot has an alias, you can't delete it. Instead,
the DeleteBot operation returns a ResourceInUseException exception that includes a
reference to the alias that refers to the bot. To remove the reference to the bot, delete
the alias. If you get the same exception again, delete the referring alias until the
DeleteBot operation is successful. This operation requires permissions for the
lex:DeleteBot action.

# Arguments
- `name`: The name of the bot. The name is case sensitive.

"""
function delete_bot(name; aws_config::AbstractAWSConfig=current_aws_config())
    return lex_model_building_service(
        "DELETE", "/bots/$(name)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function delete_bot(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_model_building_service(
        "DELETE",
        "/bots/$(name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_bot_alias(bot_name, name)
    delete_bot_alias(bot_name, name, params::Dict{String,<:Any})

Deletes an alias for the specified bot.  You can't delete an alias that is used in the
association between a bot and a messaging channel. If an alias is used in a channel
association, the DeleteBot operation returns a ResourceInUseException exception that
includes a reference to the channel association that refers to the bot. You can remove the
reference to the alias by deleting the channel association. If you get the same exception
again, delete the referring association until the DeleteBotAlias operation is successful.

# Arguments
- `bot_name`: The name of the bot that the alias points to.
- `name`: The name of the alias to delete. The name is case sensitive.

"""
function delete_bot_alias(botName, name; aws_config::AbstractAWSConfig=current_aws_config())
    return lex_model_building_service(
        "DELETE",
        "/bots/$(botName)/aliases/$(name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_bot_alias(
    botName,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_model_building_service(
        "DELETE",
        "/bots/$(botName)/aliases/$(name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_bot_channel_association(alias_name, bot_name, name)
    delete_bot_channel_association(alias_name, bot_name, name, params::Dict{String,<:Any})

Deletes the association between an Amazon Lex bot and a messaging platform. This operation
requires permission for the lex:DeleteBotChannelAssociation action.

# Arguments
- `alias_name`: An alias that points to the specific version of the Amazon Lex bot to which
  this association is being made.
- `bot_name`: The name of the Amazon Lex bot.
- `name`: The name of the association. The name is case sensitive.

"""
function delete_bot_channel_association(
    aliasName, botName, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_model_building_service(
        "DELETE",
        "/bots/$(botName)/aliases/$(aliasName)/channels/$(name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_bot_channel_association(
    aliasName,
    botName,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_model_building_service(
        "DELETE",
        "/bots/$(botName)/aliases/$(aliasName)/channels/$(name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_bot_version(name, version)
    delete_bot_version(name, version, params::Dict{String,<:Any})

Deletes a specific version of a bot. To delete all versions of a bot, use the DeleteBot
operation.  This operation requires permissions for the lex:DeleteBotVersion action.

# Arguments
- `name`: The name of the bot.
- `version`: The version of the bot to delete. You cannot delete the LATEST version of the
  bot. To delete the LATEST version, use the DeleteBot operation.

"""
function delete_bot_version(
    name, version; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_model_building_service(
        "DELETE",
        "/bots/$(name)/versions/$(version)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_bot_version(
    name,
    version,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_model_building_service(
        "DELETE",
        "/bots/$(name)/versions/$(version)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_intent(name)
    delete_intent(name, params::Dict{String,<:Any})

Deletes all versions of the intent, including the LATEST version. To delete a specific
version of the intent, use the DeleteIntentVersion operation.  You can delete a version of
an intent only if it is not referenced. To delete an intent that is referred to in one or
more bots (see how-it-works), you must remove those references first.    If you get the
ResourceInUseException exception, it provides an example reference that shows where the
intent is referenced. To remove the reference to the intent, either update the bot or
delete it. If you get the same exception when you attempt to delete the intent again,
repeat until the intent has no references and the call to DeleteIntent is successful.
This operation requires permission for the lex:DeleteIntent action.

# Arguments
- `name`: The name of the intent. The name is case sensitive.

"""
function delete_intent(name; aws_config::AbstractAWSConfig=current_aws_config())
    return lex_model_building_service(
        "DELETE", "/intents/$(name)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function delete_intent(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_model_building_service(
        "DELETE",
        "/intents/$(name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_intent_version(name, version)
    delete_intent_version(name, version, params::Dict{String,<:Any})

Deletes a specific version of an intent. To delete all versions of a intent, use the
DeleteIntent operation.  This operation requires permissions for the
lex:DeleteIntentVersion action.

# Arguments
- `name`: The name of the intent.
- `version`: The version of the intent to delete. You cannot delete the LATEST version of
  the intent. To delete the LATEST version, use the DeleteIntent operation.

"""
function delete_intent_version(
    name, version; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_model_building_service(
        "DELETE",
        "/intents/$(name)/versions/$(version)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_intent_version(
    name,
    version,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_model_building_service(
        "DELETE",
        "/intents/$(name)/versions/$(version)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_slot_type(name)
    delete_slot_type(name, params::Dict{String,<:Any})

Deletes all versions of the slot type, including the LATEST version. To delete a specific
version of the slot type, use the DeleteSlotTypeVersion operation.  You can delete a
version of a slot type only if it is not referenced. To delete a slot type that is referred
to in one or more intents, you must remove those references first.    If you get the
ResourceInUseException exception, the exception provides an example reference that shows
the intent where the slot type is referenced. To remove the reference to the slot type,
either update the intent or delete it. If you get the same exception when you attempt to
delete the slot type again, repeat until the slot type has no references and the
DeleteSlotType call is successful.   This operation requires permission for the
lex:DeleteSlotType action.

# Arguments
- `name`: The name of the slot type. The name is case sensitive.

"""
function delete_slot_type(name; aws_config::AbstractAWSConfig=current_aws_config())
    return lex_model_building_service(
        "DELETE",
        "/slottypes/$(name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_slot_type(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_model_building_service(
        "DELETE",
        "/slottypes/$(name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_slot_type_version(name, version)
    delete_slot_type_version(name, version, params::Dict{String,<:Any})

Deletes a specific version of a slot type. To delete all versions of a slot type, use the
DeleteSlotType operation.  This operation requires permissions for the
lex:DeleteSlotTypeVersion action.

# Arguments
- `name`: The name of the slot type.
- `version`: The version of the slot type to delete. You cannot delete the LATEST version
  of the slot type. To delete the LATEST version, use the DeleteSlotType operation.

"""
function delete_slot_type_version(
    name, version; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_model_building_service(
        "DELETE",
        "/slottypes/$(name)/version/$(version)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_slot_type_version(
    name,
    version,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_model_building_service(
        "DELETE",
        "/slottypes/$(name)/version/$(version)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_utterances(bot_name, user_id)
    delete_utterances(bot_name, user_id, params::Dict{String,<:Any})

Deletes stored utterances. Amazon Lex stores the utterances that users send to your bot.
Utterances are stored for 15 days for use with the GetUtterancesView operation, and then
stored indefinitely for use in improving the ability of your bot to respond to user input.
Use the DeleteUtterances operation to manually delete stored utterances for a specific
user. When you use the DeleteUtterances operation, utterances stored for improving your
bot's ability to respond to user input are deleted immediately. Utterances stored for use
with the GetUtterancesView operation are deleted after 15 days. This operation requires
permissions for the lex:DeleteUtterances action.

# Arguments
- `bot_name`: The name of the bot that stored the utterances.
- `user_id`:  The unique identifier for the user that made the utterances. This is the user
  ID that was sent in the PostContent or PostText operation request that contained the
  utterance.

"""
function delete_utterances(
    botName, userId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_model_building_service(
        "DELETE",
        "/bots/$(botName)/utterances/$(userId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_utterances(
    botName,
    userId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_model_building_service(
        "DELETE",
        "/bots/$(botName)/utterances/$(userId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_bot(name, versionoralias)
    get_bot(name, versionoralias, params::Dict{String,<:Any})

Returns metadata information for a specific bot. You must provide the bot name and the bot
version or alias.   This operation requires permissions for the lex:GetBot action.

# Arguments
- `name`: The name of the bot. The name is case sensitive.
- `versionoralias`: The version or alias of the bot.

"""
function get_bot(name, versionoralias; aws_config::AbstractAWSConfig=current_aws_config())
    return lex_model_building_service(
        "GET",
        "/bots/$(name)/versions/$(versionoralias)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_bot(
    name,
    versionoralias,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_model_building_service(
        "GET",
        "/bots/$(name)/versions/$(versionoralias)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_bot_alias(bot_name, name)
    get_bot_alias(bot_name, name, params::Dict{String,<:Any})

Returns information about an Amazon Lex bot alias. For more information about aliases, see
versioning-aliases. This operation requires permissions for the lex:GetBotAlias action.

# Arguments
- `bot_name`: The name of the bot.
- `name`: The name of the bot alias. The name is case sensitive.

"""
function get_bot_alias(botName, name; aws_config::AbstractAWSConfig=current_aws_config())
    return lex_model_building_service(
        "GET",
        "/bots/$(botName)/aliases/$(name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_bot_alias(
    botName,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_model_building_service(
        "GET",
        "/bots/$(botName)/aliases/$(name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_bot_aliases(bot_name)
    get_bot_aliases(bot_name, params::Dict{String,<:Any})

Returns a list of aliases for a specified Amazon Lex bot. This operation requires
permissions for the lex:GetBotAliases action.

# Arguments
- `bot_name`: The name of the bot.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of aliases to return in the response. The default is
  50. .
- `"nameContains"`: Substring to match in bot alias names. An alias will be returned if any
  part of its name matches the substring. For example, \"xyz\" matches both \"xyzabc\" and
  \"abcxyz.\"
- `"nextToken"`: A pagination token for fetching the next page of aliases. If the response
  to this call is truncated, Amazon Lex returns a pagination token in the response. To fetch
  the next page of aliases, specify the pagination token in the next request.
"""
function get_bot_aliases(botName; aws_config::AbstractAWSConfig=current_aws_config())
    return lex_model_building_service(
        "GET",
        "/bots/$(botName)/aliases/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_bot_aliases(
    botName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_model_building_service(
        "GET",
        "/bots/$(botName)/aliases/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_bot_channel_association(alias_name, bot_name, name)
    get_bot_channel_association(alias_name, bot_name, name, params::Dict{String,<:Any})

Returns information about the association between an Amazon Lex bot and a messaging
platform. This operation requires permissions for the lex:GetBotChannelAssociation action.

# Arguments
- `alias_name`: An alias pointing to the specific version of the Amazon Lex bot to which
  this association is being made.
- `bot_name`: The name of the Amazon Lex bot.
- `name`: The name of the association between the bot and the channel. The name is case
  sensitive.

"""
function get_bot_channel_association(
    aliasName, botName, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_model_building_service(
        "GET",
        "/bots/$(botName)/aliases/$(aliasName)/channels/$(name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_bot_channel_association(
    aliasName,
    botName,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_model_building_service(
        "GET",
        "/bots/$(botName)/aliases/$(aliasName)/channels/$(name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_bot_channel_associations(alias_name, bot_name)
    get_bot_channel_associations(alias_name, bot_name, params::Dict{String,<:Any})

 Returns a list of all of the channels associated with the specified bot.  The
GetBotChannelAssociations operation requires permissions for the
lex:GetBotChannelAssociations action.

# Arguments
- `alias_name`: An alias pointing to the specific version of the Amazon Lex bot to which
  this association is being made.
- `bot_name`: The name of the Amazon Lex bot in the association.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of associations to return in the response. The default
  is 50.
- `"nameContains"`: Substring to match in channel association names. An association will be
  returned if any part of its name matches the substring. For example, \"xyz\" matches both
  \"xyzabc\" and \"abcxyz.\" To return all bot channel associations, use a hyphen (\"-\") as
  the nameContains parameter.
- `"nextToken"`: A pagination token for fetching the next page of associations. If the
  response to this call is truncated, Amazon Lex returns a pagination token in the response.
  To fetch the next page of associations, specify the pagination token in the next request.
"""
function get_bot_channel_associations(
    aliasName, botName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_model_building_service(
        "GET",
        "/bots/$(botName)/aliases/$(aliasName)/channels/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_bot_channel_associations(
    aliasName,
    botName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_model_building_service(
        "GET",
        "/bots/$(botName)/aliases/$(aliasName)/channels/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_bot_versions(name)
    get_bot_versions(name, params::Dict{String,<:Any})

Gets information about all of the versions of a bot. The GetBotVersions operation returns a
BotMetadata object for each version of a bot. For example, if a bot has three numbered
versions, the GetBotVersions operation returns four BotMetadata objects in the response,
one for each numbered version and one for the LATEST version.  The GetBotVersions operation
always returns at least one version, the LATEST version. This operation requires
permissions for the lex:GetBotVersions action.

# Arguments
- `name`: The name of the bot for which versions should be returned.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of bot versions to return in the response. The default
  is 10.
- `"nextToken"`: A pagination token for fetching the next page of bot versions. If the
  response to this call is truncated, Amazon Lex returns a pagination token in the response.
  To fetch the next page of versions, specify the pagination token in the next request.
"""
function get_bot_versions(name; aws_config::AbstractAWSConfig=current_aws_config())
    return lex_model_building_service(
        "GET",
        "/bots/$(name)/versions/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_bot_versions(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_model_building_service(
        "GET",
        "/bots/$(name)/versions/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_bots()
    get_bots(params::Dict{String,<:Any})

Returns bot information as follows:    If you provide the nameContains field, the response
includes information for the LATEST version of all bots whose name contains the specified
string.   If you don't specify the nameContains field, the operation returns information
about the LATEST version of all of your bots.   This operation requires permission for the
lex:GetBots action.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of bots to return in the response that the request
  will return. The default is 10.
- `"nameContains"`: Substring to match in bot names. A bot will be returned if any part of
  its name matches the substring. For example, \"xyz\" matches both \"xyzabc\" and \"abcxyz.\"
- `"nextToken"`: A pagination token that fetches the next page of bots. If the response to
  this call is truncated, Amazon Lex returns a pagination token in the response. To fetch the
  next page of bots, specify the pagination token in the next request.
"""
function get_bots(; aws_config::AbstractAWSConfig=current_aws_config())
    return lex_model_building_service(
        "GET", "/bots/"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_bots(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_model_building_service(
        "GET", "/bots/", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_builtin_intent(signature)
    get_builtin_intent(signature, params::Dict{String,<:Any})

Returns information about a built-in intent. This operation requires permission for the
lex:GetBuiltinIntent action.

# Arguments
- `signature`: The unique identifier for a built-in intent. To find the signature for an
  intent, see Standard Built-in Intents in the Alexa Skills Kit.

"""
function get_builtin_intent(signature; aws_config::AbstractAWSConfig=current_aws_config())
    return lex_model_building_service(
        "GET",
        "/builtins/intents/$(signature)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_builtin_intent(
    signature,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_model_building_service(
        "GET",
        "/builtins/intents/$(signature)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_builtin_intents()
    get_builtin_intents(params::Dict{String,<:Any})

Gets a list of built-in intents that meet the specified criteria. This operation requires
permission for the lex:GetBuiltinIntents action.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"locale"`: A list of locales that the intent supports.
- `"maxResults"`: The maximum number of intents to return in the response. The default is
  10.
- `"nextToken"`: A pagination token that fetches the next page of intents. If this API call
  is truncated, Amazon Lex returns a pagination token in the response. To fetch the next page
  of intents, use the pagination token in the next request.
- `"signatureContains"`: Substring to match in built-in intent signatures. An intent will
  be returned if any part of its signature matches the substring. For example, \"xyz\"
  matches both \"xyzabc\" and \"abcxyz.\" To find the signature for an intent, see Standard
  Built-in Intents in the Alexa Skills Kit.
"""
function get_builtin_intents(; aws_config::AbstractAWSConfig=current_aws_config())
    return lex_model_building_service(
        "GET", "/builtins/intents/"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_builtin_intents(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_model_building_service(
        "GET",
        "/builtins/intents/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_builtin_slot_types()
    get_builtin_slot_types(params::Dict{String,<:Any})

Gets a list of built-in slot types that meet the specified criteria. For a list of built-in
slot types, see Slot Type Reference in the Alexa Skills Kit. This operation requires
permission for the lex:GetBuiltInSlotTypes action.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"locale"`: A list of locales that the slot type supports.
- `"maxResults"`: The maximum number of slot types to return in the response. The default
  is 10.
- `"nextToken"`: A pagination token that fetches the next page of slot types. If the
  response to this API call is truncated, Amazon Lex returns a pagination token in the
  response. To fetch the next page of slot types, specify the pagination token in the next
  request.
- `"signatureContains"`: Substring to match in built-in slot type signatures. A slot type
  will be returned if any part of its signature matches the substring. For example, \"xyz\"
  matches both \"xyzabc\" and \"abcxyz.\"
"""
function get_builtin_slot_types(; aws_config::AbstractAWSConfig=current_aws_config())
    return lex_model_building_service(
        "GET",
        "/builtins/slottypes/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_builtin_slot_types(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_model_building_service(
        "GET",
        "/builtins/slottypes/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_export(export_type, name, resource_type, version)
    get_export(export_type, name, resource_type, version, params::Dict{String,<:Any})

Exports the contents of a Amazon Lex resource in a specified format.

# Arguments
- `export_type`: The format of the exported data.
- `name`: The name of the bot to export.
- `resource_type`: The type of resource to export.
- `version`: The version of the bot to export.

"""
function get_export(
    exportType,
    name,
    resourceType,
    version;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_model_building_service(
        "GET",
        "/exports/",
        Dict{String,Any}(
            "exportType" => exportType,
            "name" => name,
            "resourceType" => resourceType,
            "version" => version,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_export(
    exportType,
    name,
    resourceType,
    version,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_model_building_service(
        "GET",
        "/exports/",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "exportType" => exportType,
                    "name" => name,
                    "resourceType" => resourceType,
                    "version" => version,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_import(import_id)
    get_import(import_id, params::Dict{String,<:Any})

Gets information about an import job started with the StartImport operation.

# Arguments
- `import_id`: The identifier of the import job information to return.

"""
function get_import(importId; aws_config::AbstractAWSConfig=current_aws_config())
    return lex_model_building_service(
        "GET",
        "/imports/$(importId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_import(
    importId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_model_building_service(
        "GET",
        "/imports/$(importId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_intent(name, version)
    get_intent(name, version, params::Dict{String,<:Any})

 Returns information about an intent. In addition to the intent name, you must specify the
intent version.   This operation requires permissions to perform the lex:GetIntent action.

# Arguments
- `name`: The name of the intent. The name is case sensitive.
- `version`: The version of the intent.

"""
function get_intent(name, version; aws_config::AbstractAWSConfig=current_aws_config())
    return lex_model_building_service(
        "GET",
        "/intents/$(name)/versions/$(version)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_intent(
    name,
    version,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_model_building_service(
        "GET",
        "/intents/$(name)/versions/$(version)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_intent_versions(name)
    get_intent_versions(name, params::Dict{String,<:Any})

Gets information about all of the versions of an intent. The GetIntentVersions operation
returns an IntentMetadata object for each version of an intent. For example, if an intent
has three numbered versions, the GetIntentVersions operation returns four IntentMetadata
objects in the response, one for each numbered version and one for the LATEST version.  The
GetIntentVersions operation always returns at least one version, the LATEST version. This
operation requires permissions for the lex:GetIntentVersions action.

# Arguments
- `name`: The name of the intent for which versions should be returned.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of intent versions to return in the response. The
  default is 10.
- `"nextToken"`: A pagination token for fetching the next page of intent versions. If the
  response to this call is truncated, Amazon Lex returns a pagination token in the response.
  To fetch the next page of versions, specify the pagination token in the next request.
"""
function get_intent_versions(name; aws_config::AbstractAWSConfig=current_aws_config())
    return lex_model_building_service(
        "GET",
        "/intents/$(name)/versions/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_intent_versions(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_model_building_service(
        "GET",
        "/intents/$(name)/versions/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_intents()
    get_intents(params::Dict{String,<:Any})

Returns intent information as follows:    If you specify the nameContains field, returns
the LATEST version of all intents that contain the specified string.    If you don't
specify the nameContains field, returns information about the LATEST version of all
intents.     The operation requires permission for the lex:GetIntents action.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of intents to return in the response. The default is
  10.
- `"nameContains"`: Substring to match in intent names. An intent will be returned if any
  part of its name matches the substring. For example, \"xyz\" matches both \"xyzabc\" and
  \"abcxyz.\"
- `"nextToken"`: A pagination token that fetches the next page of intents. If the response
  to this API call is truncated, Amazon Lex returns a pagination token in the response. To
  fetch the next page of intents, specify the pagination token in the next request.
"""
function get_intents(; aws_config::AbstractAWSConfig=current_aws_config())
    return lex_model_building_service(
        "GET", "/intents/"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_intents(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_model_building_service(
        "GET", "/intents/", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_migration(migration_id)
    get_migration(migration_id, params::Dict{String,<:Any})

Provides details about an ongoing or complete migration from an Amazon Lex V1 bot to an
Amazon Lex V2 bot. Use this operation to view the migration alerts and warnings related to
the migration.

# Arguments
- `migration_id`: The unique identifier of the migration to view. The migrationID is
  returned by the operation.

"""
function get_migration(migrationId; aws_config::AbstractAWSConfig=current_aws_config())
    return lex_model_building_service(
        "GET",
        "/migrations/$(migrationId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_migration(
    migrationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_model_building_service(
        "GET",
        "/migrations/$(migrationId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_migrations()
    get_migrations(params::Dict{String,<:Any})

Gets a list of migrations between Amazon Lex V1 and Amazon Lex V2.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of migrations to return in the response. The default
  is 10.
- `"migrationStatusEquals"`: Filters the list to contain only migrations in the specified
  state.
- `"nextToken"`: A pagination token that fetches the next page of migrations. If the
  response to this operation is truncated, Amazon Lex returns a pagination token in the
  response. To fetch the next page of migrations, specify the pagination token in the request.
- `"sortByAttribute"`: The field to sort the list of migrations by. You can sort by the
  Amazon Lex V1 bot name or the date and time that the migration was started.
- `"sortByOrder"`: The order so sort the list.
- `"v1BotNameContains"`: Filters the list to contain only bots whose name contains the
  specified string. The string is matched anywhere in bot name.
"""
function get_migrations(; aws_config::AbstractAWSConfig=current_aws_config())
    return lex_model_building_service(
        "GET", "/migrations"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_migrations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_model_building_service(
        "GET", "/migrations", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_slot_type(name, version)
    get_slot_type(name, version, params::Dict{String,<:Any})

Returns information about a specific version of a slot type. In addition to specifying the
slot type name, you must specify the slot type version. This operation requires permissions
for the lex:GetSlotType action.

# Arguments
- `name`: The name of the slot type. The name is case sensitive.
- `version`: The version of the slot type.

"""
function get_slot_type(name, version; aws_config::AbstractAWSConfig=current_aws_config())
    return lex_model_building_service(
        "GET",
        "/slottypes/$(name)/versions/$(version)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_slot_type(
    name,
    version,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_model_building_service(
        "GET",
        "/slottypes/$(name)/versions/$(version)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_slot_type_versions(name)
    get_slot_type_versions(name, params::Dict{String,<:Any})

Gets information about all versions of a slot type. The GetSlotTypeVersions operation
returns a SlotTypeMetadata object for each version of a slot type. For example, if a slot
type has three numbered versions, the GetSlotTypeVersions operation returns four
SlotTypeMetadata objects in the response, one for each numbered version and one for the
LATEST version.  The GetSlotTypeVersions operation always returns at least one version, the
LATEST version. This operation requires permissions for the lex:GetSlotTypeVersions action.

# Arguments
- `name`: The name of the slot type for which versions should be returned.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of slot type versions to return in the response. The
  default is 10.
- `"nextToken"`: A pagination token for fetching the next page of slot type versions. If
  the response to this call is truncated, Amazon Lex returns a pagination token in the
  response. To fetch the next page of versions, specify the pagination token in the next
  request.
"""
function get_slot_type_versions(name; aws_config::AbstractAWSConfig=current_aws_config())
    return lex_model_building_service(
        "GET",
        "/slottypes/$(name)/versions/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_slot_type_versions(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_model_building_service(
        "GET",
        "/slottypes/$(name)/versions/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_slot_types()
    get_slot_types(params::Dict{String,<:Any})

Returns slot type information as follows:    If you specify the nameContains field, returns
the LATEST version of all slot types that contain the specified string.    If you don't
specify the nameContains field, returns information about the LATEST version of all slot
types.     The operation requires permission for the lex:GetSlotTypes action.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of slot types to return in the response. The default
  is 10.
- `"nameContains"`: Substring to match in slot type names. A slot type will be returned if
  any part of its name matches the substring. For example, \"xyz\" matches both \"xyzabc\"
  and \"abcxyz.\"
- `"nextToken"`: A pagination token that fetches the next page of slot types. If the
  response to this API call is truncated, Amazon Lex returns a pagination token in the
  response. To fetch next page of slot types, specify the pagination token in the next
  request.
"""
function get_slot_types(; aws_config::AbstractAWSConfig=current_aws_config())
    return lex_model_building_service(
        "GET", "/slottypes/"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_slot_types(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_model_building_service(
        "GET", "/slottypes/", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_utterances_view(bot_versions, botname, status_type)
    get_utterances_view(bot_versions, botname, status_type, params::Dict{String,<:Any})

Use the GetUtterancesView operation to get information about the utterances that your users
have made to your bot. You can use this list to tune the utterances that your bot responds
to. For example, say that you have created a bot to order flowers. After your users have
used your bot for a while, use the GetUtterancesView operation to see the requests that
they have made and whether they have been successful. You might find that the utterance \"I
want flowers\" is not being recognized. You could add this utterance to the OrderFlowers
intent so that your bot recognizes that utterance. After you publish a new version of a
bot, you can get information about the old version and the new so that you can compare the
performance across the two versions.  Utterance statistics are generated once a day. Data
is available for the last 15 days. You can request information for up to 5 versions of your
bot in each request. Amazon Lex returns the most frequent utterances received by the bot in
the last 15 days. The response contains information about a maximum of 100 utterances for
each version. If you set childDirected field to true when you created your bot, if you are
using slot obfuscation with one or more slots, or if you opted out of participating in
improving Amazon Lex, utterances are not available. This operation requires permissions for
the lex:GetUtterancesView action.

# Arguments
- `bot_versions`: An array of bot versions for which utterance information should be
  returned. The limit is 5 versions per request.
- `botname`: The name of the bot for which utterance information should be returned.
- `status_type`: To return utterances that were recognized and handled, use Detected. To
  return utterances that were not recognized, use Missed.

"""
function get_utterances_view(
    bot_versions, botname, status_type; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_model_building_service(
        "GET",
        "/bots/$(botname)/utterances?view=aggregation",
        Dict{String,Any}("bot_versions" => bot_versions, "status_type" => status_type);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_utterances_view(
    bot_versions,
    botname,
    status_type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_model_building_service(
        "GET",
        "/bots/$(botname)/utterances?view=aggregation",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "bot_versions" => bot_versions, "status_type" => status_type
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Gets a list of tags associated with the specified resource. Only bots, bot aliases, and bot
channels can have tags associated with them.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource to get a list of tags for.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_model_building_service(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_model_building_service(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_bot(child_directed, locale, name)
    put_bot(child_directed, locale, name, params::Dict{String,<:Any})

Creates an Amazon Lex conversational bot or replaces an existing bot. When you create or
update a bot you are only required to specify a name, a locale, and whether the bot is
directed toward children under age 13. You can use this to add intents later, or to remove
intents from an existing bot. When you create a bot with the minimum information, the bot
is created or updated but Amazon Lex returns the  response FAILED. You can build the bot
after you add one or more intents. For more information about Amazon Lex bots, see
how-it-works.  If you specify the name of an existing bot, the fields in the request
replace the existing values in the LATEST version of the bot. Amazon Lex removes any fields
that you don't provide values for in the request, except for the idleTTLInSeconds and
privacySettings fields, which are set to their default values. If you don't specify values
for required fields, Amazon Lex throws an exception. This operation requires permissions
for the lex:PutBot action. For more information, see security-iam.

# Arguments
- `child_directed`: For each Amazon Lex bot created with the Amazon Lex Model Building
  Service, you must specify whether your use of Amazon Lex is related to a website, program,
  or other application that is directed or targeted, in whole or in part, to children under
  age 13 and subject to the Children's Online Privacy Protection Act (COPPA) by specifying
  true or false in the childDirected field. By specifying true in the childDirected field,
  you confirm that your use of Amazon Lex is related to a website, program, or other
  application that is directed or targeted, in whole or in part, to children under age 13 and
  subject to COPPA. By specifying false in the childDirected field, you confirm that your use
  of Amazon Lex is not related to a website, program, or other application that is directed
  or targeted, in whole or in part, to children under age 13 and subject to COPPA. You may
  not specify a default value for the childDirected field that does not accurately reflect
  whether your use of Amazon Lex is related to a website, program, or other application that
  is directed or targeted, in whole or in part, to children under age 13 and subject to
  COPPA. If your use of Amazon Lex relates to a website, program, or other application that
  is directed in whole or in part, to children under age 13, you must obtain any required
  verifiable parental consent under COPPA. For information regarding the use of Amazon Lex in
  connection with websites, programs, or other applications that are directed or targeted, in
  whole or in part, to children under age 13, see the Amazon Lex FAQ.
- `locale`:  Specifies the target locale for the bot. Any intent used in the bot must be
  compatible with the locale of the bot.  The default is en-US.
- `name`: The name of the bot. The name is not case sensitive.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"abortStatement"`: When Amazon Lex can't understand the user's input in context, it
  tries to elicit the information a few times. After that, Amazon Lex sends the message
  defined in abortStatement to the user, and then cancels the conversation. To set the number
  of retries, use the valueElicitationPrompt field for the slot type.  For example, in a
  pizza ordering bot, Amazon Lex might ask a user \"What type of crust would you like?\" If
  the user's response is not one of the expected responses (for example, \"thin crust, \"deep
  dish,\" etc.), Amazon Lex tries to elicit a correct response a few more times.  For
  example, in a pizza ordering application, OrderPizza might be one of the intents. This
  intent might require the CrustType slot. You specify the valueElicitationPrompt field when
  you create the CrustType slot. If you have defined a fallback intent the cancel statement
  will not be sent to the user, the fallback intent is used instead. For more information,
  see  AMAZON.FallbackIntent.
- `"checksum"`: Identifies a specific revision of the LATEST version. When you create a new
  bot, leave the checksum field blank. If you specify a checksum you get a
  BadRequestException exception. When you want to update a bot, set the checksum field to the
  checksum of the most recent revision of the LATEST version. If you don't specify the
  checksum field, or if the checksum does not match the LATEST version, you get a
  PreconditionFailedException exception.
- `"clarificationPrompt"`: When Amazon Lex doesn't understand the user's intent, it uses
  this message to get clarification. To specify how many times Amazon Lex should repeat the
  clarification prompt, use the maxAttempts field. If Amazon Lex still doesn't understand, it
  sends the message in the abortStatement field.  When you create a clarification prompt,
  make sure that it suggests the correct response from the user. for example, for a bot that
  orders pizza and drinks, you might create this clarification prompt: \"What would you like
  to do? You can say 'Order a pizza' or 'Order a drink.'\" If you have defined a fallback
  intent, it will be invoked if the clarification prompt is repeated the number of times
  defined in the maxAttempts field. For more information, see  AMAZON.FallbackIntent. If you
  don't define a clarification prompt, at runtime Amazon Lex will return a 400 Bad Request
  exception in three cases:    Follow-up prompt - When the user responds to a follow-up
  prompt but does not provide an intent. For example, in response to a follow-up prompt that
  says \"Would you like anything else today?\" the user says \"Yes.\" Amazon Lex will return
  a 400 Bad Request exception because it does not have a clarification prompt to send to the
  user to get an intent.   Lambda function - When using a Lambda function, you return an
  ElicitIntent dialog type. Since Amazon Lex does not have a clarification prompt to get an
  intent from the user, it returns a 400 Bad Request exception.   PutSession operation - When
  using the PutSession operation, you send an ElicitIntent dialog type. Since Amazon Lex does
  not have a clarification prompt to get an intent from the user, it returns a 400 Bad
  Request exception.
- `"createVersion"`: When set to true a new numbered version of the bot is created. This is
  the same as calling the CreateBotVersion operation. If you don't specify createVersion, the
  default is false.
- `"description"`: A description of the bot.
- `"detectSentiment"`: When set to true user utterances are sent to Amazon Comprehend for
  sentiment analysis. If you don't specify detectSentiment, the default is false.
- `"enableModelImprovements"`: Set to true to enable access to natural language
  understanding improvements.  When you set the enableModelImprovements parameter to true you
  can use the nluIntentConfidenceThreshold parameter to configure confidence scores. For more
  information, see Confidence Scores. You can only set the enableModelImprovements parameter
  in certain Regions. If you set the parameter to true, your bot has access to accuracy
  improvements. The Regions where you can set the enableModelImprovements parameter to true
  are:   US East (N. Virginia) (us-east-1)   US West (Oregon) (us-west-2)   Asia Pacific
  (Sydney) (ap-southeast-2)   EU (Ireland) (eu-west-1)   In other Regions, the
  enableModelImprovements parameter is set to true by default. In these Regions setting the
  parameter to false throws a ValidationException exception.
- `"idleSessionTTLInSeconds"`: The maximum time in seconds that Amazon Lex retains the data
  gathered in a conversation. A user interaction session remains active for the amount of
  time specified. If no conversation occurs during this time, the session expires and Amazon
  Lex deletes any data provided before the timeout. For example, suppose that a user chooses
  the OrderPizza intent, but gets sidetracked halfway through placing an order. If the user
  doesn't complete the order within the specified time, Amazon Lex discards the slot
  information that it gathered, and the user must start over. If you don't include the
  idleSessionTTLInSeconds element in a PutBot operation request, Amazon Lex uses the default
  value. This is also true if the request replaces an existing bot. The default is 300
  seconds (5 minutes).
- `"intents"`: An array of Intent objects. Each intent represents a command that a user can
  express. For example, a pizza ordering bot might support an OrderPizza intent. For more
  information, see how-it-works.
- `"nluIntentConfidenceThreshold"`: Determines the threshold where Amazon Lex will insert
  the AMAZON.FallbackIntent, AMAZON.KendraSearchIntent, or both when returning alternative
  intents in a PostContent or PostText response. AMAZON.FallbackIntent and
  AMAZON.KendraSearchIntent are only inserted if they are configured for the bot. You must
  set the enableModelImprovements parameter to true to use confidence scores in the following
  regions.   US East (N. Virginia) (us-east-1)   US West (Oregon) (us-west-2)   Asia Pacific
  (Sydney) (ap-southeast-2)   EU (Ireland) (eu-west-1)   In other Regions, the
  enableModelImprovements parameter is set to true by default. For example, suppose a bot is
  configured with the confidence threshold of 0.80 and the AMAZON.FallbackIntent. Amazon Lex
  returns three alternative intents with the following confidence scores: IntentA (0.70),
  IntentB (0.60), IntentC (0.50). The response from the PostText operation would be:
  AMAZON.FallbackIntent   IntentA   IntentB   IntentC
- `"processBehavior"`: If you set the processBehavior element to BUILD, Amazon Lex builds
  the bot so that it can be run. If you set the element to SAVE Amazon Lex saves the bot, but
  doesn't build it.  If you don't specify this value, the default value is BUILD.
- `"tags"`: A list of tags to add to the bot. You can only add tags when you create a bot,
  you can't use the PutBot operation to update the tags on a bot. To update tags, use the
  TagResource operation.
- `"voiceId"`: The Amazon Polly voice ID that you want Amazon Lex to use for voice
  interactions with the user. The locale configured for the voice must match the locale of
  the bot. For more information, see Voices in Amazon Polly in the Amazon Polly Developer
  Guide.
"""
function put_bot(
    childDirected, locale, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_model_building_service(
        "PUT",
        "/bots/$(name)/versions/$LATEST",
        Dict{String,Any}("childDirected" => childDirected, "locale" => locale);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_bot(
    childDirected,
    locale,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_model_building_service(
        "PUT",
        "/bots/$(name)/versions/$LATEST",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("childDirected" => childDirected, "locale" => locale),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_bot_alias(bot_name, bot_version, name)
    put_bot_alias(bot_name, bot_version, name, params::Dict{String,<:Any})

Creates an alias for the specified version of the bot or replaces an alias for the
specified bot. To change the version of the bot that the alias points to, replace the
alias. For more information about aliases, see versioning-aliases. This operation requires
permissions for the lex:PutBotAlias action.

# Arguments
- `bot_name`: The name of the bot.
- `bot_version`: The version of the bot.
- `name`: The name of the alias. The name is not case sensitive.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"checksum"`: Identifies a specific revision of the LATEST version. When you create a new
  bot alias, leave the checksum field blank. If you specify a checksum you get a
  BadRequestException exception. When you want to update a bot alias, set the checksum field
  to the checksum of the most recent revision of the LATEST version. If you don't specify the
   checksum field, or if the checksum does not match the LATEST version, you get a
  PreconditionFailedException exception.
- `"conversationLogs"`: Settings for conversation logs for the alias.
- `"description"`: A description of the alias.
- `"tags"`: A list of tags to add to the bot alias. You can only add tags when you create
  an alias, you can't use the PutBotAlias operation to update the tags on a bot alias. To
  update tags, use the TagResource operation.
"""
function put_bot_alias(
    botName, botVersion, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_model_building_service(
        "PUT",
        "/bots/$(botName)/aliases/$(name)",
        Dict{String,Any}("botVersion" => botVersion);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_bot_alias(
    botName,
    botVersion,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_model_building_service(
        "PUT",
        "/bots/$(botName)/aliases/$(name)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("botVersion" => botVersion), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_intent(name)
    put_intent(name, params::Dict{String,<:Any})

Creates an intent or replaces an existing intent. To define the interaction between the
user and your bot, you use one or more intents. For a pizza ordering bot, for example, you
would create an OrderPizza intent.  To create an intent or replace an existing intent, you
must provide the following:   Intent name. For example, OrderPizza.   Sample utterances.
For example, \"Can I order a pizza, please.\" and \"I want to order a pizza.\"
Information to be gathered. You specify slot types for the information that your bot will
request from the user. You can specify standard slot types, such as a date or a time, or
custom slot types such as the size and crust of a pizza.   How the intent will be
fulfilled. You can provide a Lambda function or configure the intent to return the intent
information to the client application. If you use a Lambda function, when all of the intent
information is available, Amazon Lex invokes your Lambda function. If you configure your
intent to return the intent information to the client application.    You can specify other
optional information in the request, such as:   A confirmation prompt to ask the user to
confirm an intent. For example, \"Shall I order your pizza?\"   A conclusion statement to
send to the user after the intent has been fulfilled. For example, \"I placed your pizza
order.\"   A follow-up prompt that asks the user for additional activity. For example,
asking \"Do you want to order a drink with your pizza?\"   If you specify an existing
intent name to update the intent, Amazon Lex replaces the values in the LATEST version of
the intent with the values in the request. Amazon Lex removes fields that you don't provide
in the request. If you don't specify the required fields, Amazon Lex throws an exception.
When you update the LATEST version of an intent, the status field of any bot that uses the
LATEST version of the intent is set to NOT_BUILT. For more information, see how-it-works.
This operation requires permissions for the lex:PutIntent action.

# Arguments
- `name`: The name of the intent. The name is not case sensitive.  The name can't match a
  built-in intent name, or a built-in intent name with \"AMAZON.\" removed. For example,
  because there is a built-in intent called AMAZON.HelpIntent, you can't create a custom
  intent called HelpIntent. For a list of built-in intents, see Standard Built-in Intents in
  the Alexa Skills Kit.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"checksum"`: Identifies a specific revision of the LATEST version. When you create a new
  intent, leave the checksum field blank. If you specify a checksum you get a
  BadRequestException exception. When you want to update a intent, set the checksum field to
  the checksum of the most recent revision of the LATEST version. If you don't specify the
  checksum field, or if the checksum does not match the LATEST version, you get a
  PreconditionFailedException exception.
- `"conclusionStatement"`:  The statement that you want Amazon Lex to convey to the user
  after the intent is successfully fulfilled by the Lambda function.  This element is
  relevant only if you provide a Lambda function in the fulfillmentActivity. If you return
  the intent to the client application, you can't specify this element.  The followUpPrompt
  and conclusionStatement are mutually exclusive. You can specify only one.
- `"confirmationPrompt"`: Prompts the user to confirm the intent. This question should have
  a yes or no answer. Amazon Lex uses this prompt to ensure that the user acknowledges that
  the intent is ready for fulfillment. For example, with the OrderPizza intent, you might
  want to confirm that the order is correct before placing it. For other intents, such as
  intents that simply respond to user questions, you might not need to ask the user for
  confirmation before providing the information.   You you must provide both the
  rejectionStatement and the confirmationPrompt, or neither.
- `"createVersion"`: When set to true a new numbered version of the intent is created. This
  is the same as calling the CreateIntentVersion operation. If you do not specify
  createVersion, the default is false.
- `"description"`: A description of the intent.
- `"dialogCodeHook"`:  Specifies a Lambda function to invoke for each user input. You can
  invoke this Lambda function to personalize user interaction.  For example, suppose your bot
  determines that the user is John. Your Lambda function might retrieve John's information
  from a backend database and prepopulate some of the values. For example, if you find that
  John is gluten intolerant, you might set the corresponding intent slot, GlutenIntolerant,
  to true. You might find John's phone number and set the corresponding session attribute.
- `"followUpPrompt"`: Amazon Lex uses this prompt to solicit additional activity after
  fulfilling an intent. For example, after the OrderPizza intent is fulfilled, you might
  prompt the user to order a drink. The action that Amazon Lex takes depends on the user's
  response, as follows:   If the user says \"Yes\" it responds with the clarification prompt
  that is configured for the bot.   if the user says \"Yes\" and continues with an utterance
  that triggers an intent it starts a conversation for the intent.   If the user says \"No\"
  it responds with the rejection statement configured for the the follow-up prompt.   If it
  doesn't recognize the utterance it repeats the follow-up prompt again.   The followUpPrompt
  field and the conclusionStatement field are mutually exclusive. You can specify only one.
- `"fulfillmentActivity"`: Required. Describes how the intent is fulfilled. For example,
  after a user provides all of the information for a pizza order, fulfillmentActivity defines
  how the bot places an order with a local pizza store.   You might configure Amazon Lex to
  return all of the intent information to the client application, or direct it to invoke a
  Lambda function that can process the intent (for example, place an order with a pizzeria).
- `"inputContexts"`: An array of InputContext objects that lists the contexts that must be
  active for Amazon Lex to choose the intent in a conversation with the user.
- `"kendraConfiguration"`: Configuration information required to use the
  AMAZON.KendraSearchIntent intent to connect to an Amazon Kendra index. For more
  information, see  AMAZON.KendraSearchIntent.
- `"outputContexts"`: An array of OutputContext objects that lists the contexts that the
  intent activates when the intent is fulfilled.
- `"parentIntentSignature"`: A unique identifier for the built-in intent to base this
  intent on. To find the signature for an intent, see Standard Built-in Intents in the Alexa
  Skills Kit.
- `"rejectionStatement"`: When the user answers \"no\" to the question defined in
  confirmationPrompt, Amazon Lex responds with this statement to acknowledge that the intent
  was canceled.   You must provide both the rejectionStatement and the confirmationPrompt, or
  neither.
- `"sampleUtterances"`: An array of utterances (strings) that a user might say to signal
  the intent. For example, \"I want {PizzaSize} pizza\", \"Order {Quantity} {PizzaSize}
  pizzas\".  In each utterance, a slot name is enclosed in curly braces.
- `"slots"`: An array of intent slots. At runtime, Amazon Lex elicits required slot values
  from the user using prompts defined in the slots. For more information, see how-it-works.
"""
function put_intent(name; aws_config::AbstractAWSConfig=current_aws_config())
    return lex_model_building_service(
        "PUT",
        "/intents/$(name)/versions/$LATEST";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_intent(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_model_building_service(
        "PUT",
        "/intents/$(name)/versions/$LATEST",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_slot_type(name)
    put_slot_type(name, params::Dict{String,<:Any})

Creates a custom slot type or replaces an existing custom slot type. To create a custom
slot type, specify a name for the slot type and a set of enumeration values, which are the
values that a slot of this type can assume. For more information, see how-it-works. If you
specify the name of an existing slot type, the fields in the request replace the existing
values in the LATEST version of the slot type. Amazon Lex removes the fields that you don't
provide in the request. If you don't specify required fields, Amazon Lex throws an
exception. When you update the LATEST version of a slot type, if a bot uses the LATEST
version of an intent that contains the slot type, the bot's status field is set to
NOT_BUILT. This operation requires permissions for the lex:PutSlotType action.

# Arguments
- `name`: The name of the slot type. The name is not case sensitive.  The name can't match
  a built-in slot type name, or a built-in slot type name with \"AMAZON.\" removed. For
  example, because there is a built-in slot type called AMAZON.DATE, you can't create a
  custom slot type called DATE. For a list of built-in slot types, see Slot Type Reference in
  the Alexa Skills Kit.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"checksum"`: Identifies a specific revision of the LATEST version. When you create a new
  slot type, leave the checksum field blank. If you specify a checksum you get a
  BadRequestException exception. When you want to update a slot type, set the checksum field
  to the checksum of the most recent revision of the LATEST version. If you don't specify the
   checksum field, or if the checksum does not match the LATEST version, you get a
  PreconditionFailedException exception.
- `"createVersion"`: When set to true a new numbered version of the slot type is created.
  This is the same as calling the CreateSlotTypeVersion operation. If you do not specify
  createVersion, the default is false.
- `"description"`: A description of the slot type.
- `"enumerationValues"`: A list of EnumerationValue objects that defines the values that
  the slot type can take. Each value can have a list of synonyms, which are additional values
  that help train the machine learning model about the values that it resolves for a slot.  A
  regular expression slot type doesn't require enumeration values. All other slot types
  require a list of enumeration values. When Amazon Lex resolves a slot value, it generates a
  resolution list that contains up to five possible values for the slot. If you are using a
  Lambda function, this resolution list is passed to the function. If you are not using a
  Lambda function you can choose to return the value that the user entered or the first value
  in the resolution list as the slot value. The valueSelectionStrategy field indicates the
  option to use.
- `"parentSlotTypeSignature"`: The built-in slot type used as the parent of the slot type.
  When you define a parent slot type, the new slot type has all of the same configuration as
  the parent. Only AMAZON.AlphaNumeric is supported.
- `"slotTypeConfigurations"`: Configuration information that extends the parent built-in
  slot type. The configuration is added to the settings for the parent slot type.
- `"valueSelectionStrategy"`: Determines the slot resolution strategy that Amazon Lex uses
  to return slot type values. The field can be set to one of the following values:
  ORIGINAL_VALUE - Returns the value entered by the user, if the user value is similar to the
  slot value.    TOP_RESOLUTION - If there is a resolution list for the slot, return the
  first value in the resolution list as the slot type value. If there is no resolution list,
  null is returned.   If you don't specify the valueSelectionStrategy, the default is
  ORIGINAL_VALUE.
"""
function put_slot_type(name; aws_config::AbstractAWSConfig=current_aws_config())
    return lex_model_building_service(
        "PUT",
        "/slottypes/$(name)/versions/$LATEST";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_slot_type(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_model_building_service(
        "PUT",
        "/slottypes/$(name)/versions/$LATEST",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_import(merge_strategy, payload, resource_type)
    start_import(merge_strategy, payload, resource_type, params::Dict{String,<:Any})

Starts a job to import a resource to Amazon Lex.

# Arguments
- `merge_strategy`: Specifies the action that the StartImport operation should take when
  there is an existing resource with the same name.   FAIL_ON_CONFLICT - The import operation
  is stopped on the first conflict between a resource in the import file and an existing
  resource. The name of the resource causing the conflict is in the failureReason field of
  the response to the GetImport operation. OVERWRITE_LATEST - The import operation proceeds
  even if there is a conflict with an existing resource. The LASTEST version of the existing
  resource is overwritten with the data from the import file.
- `payload`: A zip archive in binary format. The archive should contain one file, a JSON
  file containing the resource to import. The resource should match the type specified in the
  resourceType field.
- `resource_type`: Specifies the type of resource to export. Each resource also exports any
  resources that it depends on.    A bot exports dependent intents.   An intent exports
  dependent slot types.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tags"`: A list of tags to add to the imported bot. You can only add tags when you
  import a bot, you can't add tags to an intent or slot type.
"""
function start_import(
    mergeStrategy, payload, resourceType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_model_building_service(
        "POST",
        "/imports/",
        Dict{String,Any}(
            "mergeStrategy" => mergeStrategy,
            "payload" => payload,
            "resourceType" => resourceType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_import(
    mergeStrategy,
    payload,
    resourceType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_model_building_service(
        "POST",
        "/imports/",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "mergeStrategy" => mergeStrategy,
                    "payload" => payload,
                    "resourceType" => resourceType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_migration(migration_strategy, v1_bot_name, v1_bot_version, v2_bot_name, v2_bot_role)
    start_migration(migration_strategy, v1_bot_name, v1_bot_version, v2_bot_name, v2_bot_role, params::Dict{String,<:Any})

Starts migrating a bot from Amazon Lex V1 to Amazon Lex V2. Migrate your bot when you want
to take advantage of the new features of Amazon Lex V2. For more information, see Migrating
a bot in the Amazon Lex developer guide.

# Arguments
- `migration_strategy`: The strategy used to conduct the migration.    CREATE_NEW - Creates
  a new Amazon Lex V2 bot and migrates the Amazon Lex V1 bot to the new bot.
  UPDATE_EXISTING - Overwrites the existing Amazon Lex V2 bot metadata and the locale being
  migrated. It doesn't change any other locales in the Amazon Lex V2 bot. If the locale
  doesn't exist, a new locale is created in the Amazon Lex V2 bot.
- `v1_bot_name`: The name of the Amazon Lex V1 bot that you are migrating to Amazon Lex V2.
- `v1_bot_version`: The version of the bot to migrate to Amazon Lex V2. You can migrate the
  LATEST version as well as any numbered version.
- `v2_bot_name`: The name of the Amazon Lex V2 bot that you are migrating the Amazon Lex V1
  bot to.    If the Amazon Lex V2 bot doesn't exist, you must use the CREATE_NEW migration
  strategy.   If the Amazon Lex V2 bot exists, you must use the UPDATE_EXISTING migration
  strategy to change the contents of the Amazon Lex V2 bot.
- `v2_bot_role`: The IAM role that Amazon Lex uses to run the Amazon Lex V2 bot.

"""
function start_migration(
    migrationStrategy,
    v1BotName,
    v1BotVersion,
    v2BotName,
    v2BotRole;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_model_building_service(
        "POST",
        "/migrations",
        Dict{String,Any}(
            "migrationStrategy" => migrationStrategy,
            "v1BotName" => v1BotName,
            "v1BotVersion" => v1BotVersion,
            "v2BotName" => v2BotName,
            "v2BotRole" => v2BotRole,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_migration(
    migrationStrategy,
    v1BotName,
    v1BotVersion,
    v2BotName,
    v2BotRole,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_model_building_service(
        "POST",
        "/migrations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "migrationStrategy" => migrationStrategy,
                    "v1BotName" => v1BotName,
                    "v1BotVersion" => v1BotVersion,
                    "v2BotName" => v2BotName,
                    "v2BotRole" => v2BotRole,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds the specified tags to the specified resource. If a tag key already exists, the
existing value is replaced with the new value.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the bot, bot alias, or bot channel to
  tag.
- `tags`: A list of tag keys to add to the resource. If a tag key already exists, the
  existing value is replaced with the new value.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return lex_model_building_service(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_model_building_service(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes tags from a bot, bot alias or bot channel.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource to remove the tags from.
- `tag_keys`: A list of tag keys to remove from the resource. If a tag key does not exist
  on the resource, it is ignored.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lex_model_building_service(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lex_model_building_service(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: timestream_influxdb
using AWS.Compat
using AWS.UUIDs

"""
    create_db_instance(allocated_storage, db_instance_type, name, password, vpc_security_group_ids, vpc_subnet_ids)
    create_db_instance(allocated_storage, db_instance_type, name, password, vpc_security_group_ids, vpc_subnet_ids, params::Dict{String,<:Any})

Creates a new Timestream for InfluxDB DB instance.

# Arguments
- `allocated_storage`: The amount of storage to allocate for your DB storage type in GiB
  (gibibytes).
- `db_instance_type`: The Timestream for InfluxDB DB instance type to run InfluxDB on.
- `name`: The name that uniquely identifies the DB instance when interacting with the
  Amazon Timestream for InfluxDB API and CLI commands. This name will also be a prefix
  included in the endpoint. DB instance names must be unique per customer and per region.
- `password`: The password of the initial admin user created in InfluxDB. This password
  will allow you to access the InfluxDB UI to perform various administrative tasks and also
  use the InfluxDB CLI to create an operator token. These attributes will be stored in a
  Secret created in AWS SecretManager in your account.
- `vpc_security_group_ids`: A list of VPC security group IDs to associate with the DB
  instance.
- `vpc_subnet_ids`: A list of VPC subnet IDs to associate with the DB instance. Provide at
  least two VPC subnet IDs in different availability zones when deploying with a Multi-AZ
  standby.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"bucket"`: The name of the initial InfluxDB bucket. All InfluxDB data is stored in a
  bucket. A bucket combines the concept of a database and a retention period (the duration of
  time that each data point persists). A bucket belongs to an organization.
- `"dbParameterGroupIdentifier"`: The id of the DB parameter group to assign to your DB
  instance. DB parameter groups specify how the database is configured. For example, DB
  parameter groups can specify the limit for query concurrency.
- `"dbStorageType"`: The Timestream for InfluxDB DB storage type to read and write InfluxDB
  data. You can choose between 3 different types of provisioned Influx IOPS included storage
  according to your workloads requirements:   Influx IO Included 3000 IOPS   Influx IO
  Included 12000 IOPS   Influx IO Included 16000 IOPS
- `"deploymentType"`: Specifies whether the DB instance will be deployed as a standalone
  instance or with a Multi-AZ standby for high availability.
- `"logDeliveryConfiguration"`: Configuration for sending InfluxDB engine logs to a
  specified S3 bucket.
- `"organization"`: The name of the initial organization for the initial admin user in
  InfluxDB. An InfluxDB organization is a workspace for a group of users.
- `"publiclyAccessible"`: Configures the DB instance with a public IP to facilitate access.
- `"tags"`: A list of key-value pairs to associate with the DB instance.
- `"username"`: The username of the initial admin user created in InfluxDB. Must start with
  a letter and can't end with a hyphen or contain two consecutive hyphens. For example,
  my-user1. This username will allow you to access the InfluxDB UI to perform various
  administrative tasks and also use the InfluxDB CLI to create an operator token. These
  attributes will be stored in a Secret created in Amazon Secrets Manager in your account.
"""
function create_db_instance(
    allocatedStorage,
    dbInstanceType,
    name,
    password,
    vpcSecurityGroupIds,
    vpcSubnetIds;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return timestream_influxdb(
        "CreateDbInstance",
        Dict{String,Any}(
            "allocatedStorage" => allocatedStorage,
            "dbInstanceType" => dbInstanceType,
            "name" => name,
            "password" => password,
            "vpcSecurityGroupIds" => vpcSecurityGroupIds,
            "vpcSubnetIds" => vpcSubnetIds,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_db_instance(
    allocatedStorage,
    dbInstanceType,
    name,
    password,
    vpcSecurityGroupIds,
    vpcSubnetIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return timestream_influxdb(
        "CreateDbInstance",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "allocatedStorage" => allocatedStorage,
                    "dbInstanceType" => dbInstanceType,
                    "name" => name,
                    "password" => password,
                    "vpcSecurityGroupIds" => vpcSecurityGroupIds,
                    "vpcSubnetIds" => vpcSubnetIds,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_db_parameter_group(name)
    create_db_parameter_group(name, params::Dict{String,<:Any})

Creates a new Timestream for InfluxDB DB parameter group to associate with DB instances.

# Arguments
- `name`: The name of the DB parameter group. The name must be unique per customer and per
  region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A description of the DB parameter group.
- `"parameters"`: A list of the parameters that comprise the DB parameter group.
- `"tags"`: A list of key-value pairs to associate with the DB parameter group.
"""
function create_db_parameter_group(name; aws_config::AbstractAWSConfig=current_aws_config())
    return timestream_influxdb(
        "CreateDbParameterGroup",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_db_parameter_group(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return timestream_influxdb(
        "CreateDbParameterGroup",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_db_instance(identifier)
    delete_db_instance(identifier, params::Dict{String,<:Any})

Deletes a Timestream for InfluxDB DB instance.

# Arguments
- `identifier`: The id of the DB instance.

"""
function delete_db_instance(identifier; aws_config::AbstractAWSConfig=current_aws_config())
    return timestream_influxdb(
        "DeleteDbInstance",
        Dict{String,Any}("identifier" => identifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_db_instance(
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return timestream_influxdb(
        "DeleteDbInstance",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("identifier" => identifier), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_db_instance(identifier)
    get_db_instance(identifier, params::Dict{String,<:Any})

Returns a Timestream for InfluxDB DB instance.

# Arguments
- `identifier`: The id of the DB instance.

"""
function get_db_instance(identifier; aws_config::AbstractAWSConfig=current_aws_config())
    return timestream_influxdb(
        "GetDbInstance",
        Dict{String,Any}("identifier" => identifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_db_instance(
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return timestream_influxdb(
        "GetDbInstance",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("identifier" => identifier), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_db_parameter_group(identifier)
    get_db_parameter_group(identifier, params::Dict{String,<:Any})

Returns a Timestream for InfluxDB DB parameter group.

# Arguments
- `identifier`: The id of the DB parameter group.

"""
function get_db_parameter_group(
    identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return timestream_influxdb(
        "GetDbParameterGroup",
        Dict{String,Any}("identifier" => identifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_db_parameter_group(
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return timestream_influxdb(
        "GetDbParameterGroup",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("identifier" => identifier), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_db_instances()
    list_db_instances(params::Dict{String,<:Any})

Returns a list of Timestream for InfluxDB DB instances.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of items to return in the output. If the total number
  of items available is more than the value specified, a NextToken is provided in the output.
  To resume pagination, provide the NextToken value as argument of a subsequent API
  invocation.
- `"nextToken"`: The pagination token. To resume pagination, provide the NextToken value as
  argument of a subsequent API invocation.
"""
function list_db_instances(; aws_config::AbstractAWSConfig=current_aws_config())
    return timestream_influxdb(
        "ListDbInstances"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_db_instances(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return timestream_influxdb(
        "ListDbInstances", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_db_parameter_groups()
    list_db_parameter_groups(params::Dict{String,<:Any})

Returns a list of Timestream for InfluxDB DB parameter groups.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of items to return in the output. If the total number
  of items available is more than the value specified, a NextToken is provided in the output.
  To resume pagination, provide the NextToken value as argument of a subsequent API
  invocation.
- `"nextToken"`: The pagination token. To resume pagination, provide the NextToken value as
  argument of a subsequent API invocation.
"""
function list_db_parameter_groups(; aws_config::AbstractAWSConfig=current_aws_config())
    return timestream_influxdb(
        "ListDbParameterGroups"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_db_parameter_groups(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return timestream_influxdb(
        "ListDbParameterGroups",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

A list of tags applied to the resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the tagged resource.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return timestream_influxdb(
        "ListTagsForResource",
        Dict{String,Any}("resourceArn" => resourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return timestream_influxdb(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceArn" => resourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Tags are composed of a Key/Value pairs. You can use tags to categorize and track your
Timestream for InfluxDB resources.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the tagged resource.
- `tags`: A list of tags used to categorize and track resources.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return timestream_influxdb(
        "TagResource",
        Dict{String,Any}("resourceArn" => resourceArn, "tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return timestream_influxdb(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceArn" => resourceArn, "tags" => tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes the tag from the specified resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the tagged resource.
- `tag_keys`: The keys used to identify the tags.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return timestream_influxdb(
        "UntagResource",
        Dict{String,Any}("resourceArn" => resourceArn, "tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return timestream_influxdb(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceArn" => resourceArn, "tagKeys" => tagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_db_instance(identifier)
    update_db_instance(identifier, params::Dict{String,<:Any})

Updates a Timestream for InfluxDB DB instance.

# Arguments
- `identifier`: The id of the DB instance.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"dbParameterGroupIdentifier"`: The id of the DB parameter group to assign to your DB
  instance. DB parameter groups specify how the database is configured. For example, DB
  parameter groups can specify the limit for query concurrency.
- `"logDeliveryConfiguration"`: Configuration for sending InfluxDB engine logs to send to
  specified S3 bucket.
"""
function update_db_instance(identifier; aws_config::AbstractAWSConfig=current_aws_config())
    return timestream_influxdb(
        "UpdateDbInstance",
        Dict{String,Any}("identifier" => identifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_db_instance(
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return timestream_influxdb(
        "UpdateDbInstance",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("identifier" => identifier), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWS.jl
using AWS
using AWS.AWSServices: controlcatalog
using AWS.Compat
using AWS.UUIDs

"""
    get_control(control_arn)
    get_control(control_arn, params::Dict{String,<:Any})

Returns details about a specific control, most notably a list of Amazon Web Services
Regions where this control is supported. Input a value for the ControlArn parameter, in ARN
form. GetControl accepts controltower or controlcatalog control ARNs as input. Returns a
controlcatalog ARN format. In the API response, controls that have the value GLOBAL in the
Scope field do not show the DeployableRegions field, because it does not apply. Controls
that have the value REGIONAL in the Scope field return a value for the DeployableRegions
field, as shown in the example.

# Arguments
- `control_arn`: The Amazon Resource Name (ARN) of the control. It has one of the following
  formats:  Global format
  arn:{PARTITION}:controlcatalog:::control/{CONTROL_CATALOG_OPAQUE_ID}   Or Regional format
  arn:{PARTITION}:controltower:{REGION}::control/{CONTROL_TOWER_OPAQUE_ID}  Here is a more
  general pattern that covers Amazon Web Services Control Tower and Control Catalog ARNs:
  ^arn:(aws(?:[-a-z]*)?):(controlcatalog|controltower):[a-zA-Z0-9-]*::control/[0-9a-zA-Z_-]+

"""
function get_control end

function get_control(ControlArn; aws_config::AbstractAWSConfig=current_aws_config())
    return controlcatalog(
        "POST",
        "/get-control",
        Dict{String,Any}("ControlArn" => ControlArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function get_control(
    ControlArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return controlcatalog(
        "POST",
        "/get-control",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ControlArn" => ControlArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_common_controls()
    list_common_controls(params::Dict{String,<:Any})

Returns a paginated list of common controls from the Amazon Web Services Control Catalog.
You can apply an optional filter to see common controls that have a specific objective. If
you don’t provide a filter, the operation returns all common controls.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CommonControlFilter"`: An optional filter that narrows the results to a specific
  objective. This filter allows you to specify one objective ARN at a time. Passing multiple
  ARNs in the CommonControlFilter isn’t currently supported.
- `"maxResults"`: The maximum number of results on a page or for an API request call.
- `"nextToken"`: The pagination token that's used to fetch the next set of results.
"""
function list_common_controls end

function list_common_controls(; aws_config::AbstractAWSConfig=current_aws_config())
    return controlcatalog(
        "POST", "/common-controls"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

function list_common_controls(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return controlcatalog(
        "POST",
        "/common-controls",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_controls()
    list_controls(params::Dict{String,<:Any})

Returns a paginated list of all available controls in the Amazon Web Services Control
Catalog library. Allows you to discover available controls. The list of controls is given
as structures of type controlSummary. The ARN is returned in the global controlcatalog
format, as shown in the examples.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results on a page or for an API request call.
- `"nextToken"`: The pagination token that's used to fetch the next set of results.
"""
function list_controls end

function list_controls(; aws_config::AbstractAWSConfig=current_aws_config())
    return controlcatalog(
        "POST", "/list-controls"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

function list_controls(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return controlcatalog(
        "POST",
        "/list-controls",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_domains()
    list_domains(params::Dict{String,<:Any})

Returns a paginated list of domains from the Amazon Web Services Control Catalog.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results on a page or for an API request call.
- `"nextToken"`: The pagination token that's used to fetch the next set of results.
"""
function list_domains end

function list_domains(; aws_config::AbstractAWSConfig=current_aws_config())
    return controlcatalog(
        "POST", "/domains"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

function list_domains(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return controlcatalog(
        "POST", "/domains", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_objectives()
    list_objectives(params::Dict{String,<:Any})

Returns a paginated list of objectives from the Amazon Web Services Control Catalog. You
can apply an optional filter to see the objectives that belong to a specific domain. If you
don’t provide a filter, the operation returns all objectives.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ObjectiveFilter"`: An optional filter that narrows the results to a specific domain.
  This filter allows you to specify one domain ARN at a time. Passing multiple ARNs in the
  ObjectiveFilter isn’t currently supported.
- `"maxResults"`: The maximum number of results on a page or for an API request call.
- `"nextToken"`: The pagination token that's used to fetch the next set of results.
"""
function list_objectives end

function list_objectives(; aws_config::AbstractAWSConfig=current_aws_config())
    return controlcatalog(
        "POST", "/objectives"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

function list_objectives(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return controlcatalog(
        "POST",
        "/objectives",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

const EXPIRATION_FMT = dateformat"yyyy-mm-dd\THH:MM:SS\Z"

@testset "_role_session_name" begin
    @test AWS._role_session_name("prefix-", "name", "-suffix") == "prefix-name-suffix"
    @test AWS._role_session_name("a"^22, "b"^22, "c"^22) == "a"^22 * "b"^20 * "c"^22
end

@testset "_aws_profile_config" begin
    using AWS: _aws_profile_config

    @testset "access" begin
        #! format: off
        buffer = IOBuffer(
            """
            [profile A]
            output = json
            region = us-east-1

            [profile B]
            role_arn = arn:aws:iam::123456789000:role/A
            source_profile = A
            """
        )
        #! format: on
        ini = Inifile()
        read(ini, buffer)

        # Retrieve fields from profile "A"
        config = _aws_profile_config(ini, "A")
        @test keys(config) ⊆ Set(["output", "region"])
        @test config["output"] == "json"
        @test config["region"] == "us-east-1"

        # Ensure that mutating the returned dictionary does not mutated the contents of the
        # `ini`
        config["output"] = "yaml-stream"
        section = sections(ini)["profile A"]
        @test section["output"] == "json"

        # Use of `source_profile` does not inherit properties from the source. This mirrors
        # the AWS CLI (version v2.27.15) behavior for `region` which can be seen using
        # `aws configure list --profile X`
        config = _aws_profile_config(ini, "B")
        @test keys(config) ⊆ Set(["role_arn", "source_profile"])
        @test config["role_arn"] == "arn:aws:iam::123456789000:role/A"
        @test config["source_profile"] == "A"
    end

    # AWS CLI (version v2.27.15) will use "profile default" over "default" when both are
    # defined within the configuration. This is true when `AWS_PROFILE` is unset or
    # `AWS_PROFILE="default".
    @testset "default profile" begin
        #! format: off
        buffer = IOBuffer(
            """
            [default]
            region = default-1

            [profile default]
            region = default-2
            """
        )
        #! format: on
        ini = Inifile()
        read(ini, buffer)

        config = _aws_profile_config(ini, "default")
        @test config["region"] == "default-2"
    end
end

@testset "aws_get_profile_settings" begin
    @testset "no profile" begin
        @test aws_get_profile_settings("foo", Inifile()) === nothing
    end
end

@testset "_aws_get_role" begin
    profile = "foobar"
    ini = Inifile()

    @testset "settings early exit" begin
        apply(Patches.get_profile_settings_empty_patch) do
            @test AWS._aws_get_role(profile, ini) === nothing
        end
    end

    @testset "source_profile early exit" begin
        apply(Patches.get_profile_settings_empty_patch) do
            @test AWS._aws_get_role(profile, ini) === nothing
        end
    end

    @testset "default profile" begin
        access_key_id = "assumed_access_key_id"
        config_dir = joinpath(@__DIR__, "..", "config", "default-role")

        patch = Patches._assume_role_patch("AssumeRole"; access_key=access_key_id)

        cred = withenv(
            "AWS_CONFIG_FILE" => joinpath(config_dir, "config"),
            "AWS_SHARED_CREDENTIALS_FILE" => joinpath(config_dir, "credentials"),
            "AWS_ACCESS_KEY_ID" => nothing,
            "AWS_SECRET_ACCESS_KEY" => nothing,
        ) do
            ini = read(Inifile(), ENV["AWS_CONFIG_FILE"])
            apply(patch) do
                AWS._aws_get_role("default", ini)
            end
        end

        @test cred.access_key_id == access_key_id
    end

    @testset "profile with role and MFA" begin
        access_key_id = "assumed_access_key_id"
        config_dir = joinpath(@__DIR__, "..", "config", "role-with-mfa")

        mfa_token = "123456"
        sent_token = Ref("")
        server_time = DateTime(0)
        patches = [
            Patches._assume_role_patch(
                "AssumeRole";
                access_key=access_key_id,
                expiry=duration -> server_time + duration,
                token_code_ref=sent_token,
            ),
            Patches._getpass_patch(; secret=mfa_token),
        ]

        cred = withenv(
            "AWS_CONFIG_FILE" => joinpath(config_dir, "config"),
            "AWS_SHARED_CREDENTIALS_FILE" => joinpath(config_dir, "credentials"),
            "AWS_ACCESS_KEY_ID" => nothing,
            "AWS_SECRET_ACCESS_KEY" => nothing,
        ) do
            ini = read(Inifile(), ENV["AWS_CONFIG_FILE"])
            apply(patches) do
                AWS._aws_get_role("role_and_mfa", ini)
            end
        end

        @test cred.access_key_id == access_key_id
        @test cred.expiry == server_time + Second(1234)
        @test sent_token[] == mfa_token
    end
end

# Only testing the invalid code paths here. Valid code paths are tested elsewhere.
@testset "_aws_get_sso_credential_details" begin
    using AWS: _aws_get_sso_credential_details, _sso_cache_access_token
    using AWS.AWSExceptions: InvalidAWSConfig

    @testset "invalid SSO configuration" begin
        #! format: off
        ini = gen_ini(
            """
            [default]
            sso_session = my-sso
            sso_account_id = 111122223333
            sso_role_name = role1

            [sso-session my-sso]
            sso_region = us-east-1
            """
        )
        #! format: on
        ex = InvalidAWSConfig(
            "The SSO session \"my-sso\" section must define `sso_start_url`."
        )
        @test_throws ex _aws_get_sso_credential_details("default", ini)

        #! format: off
        ini = gen_ini(
            """
            [default]
            sso_session = my-sso
            sso_account_id = 111122223333
            sso_role_name = role1

            [sso-session my-sso]
            sso_start_url = https://my-sso-portal.awsapps.com/start
            """
        )
        #! format: on
        ex = InvalidAWSConfig(
            "The SSO session \"my-sso\" section must define `sso_region`."
        )
        @test_throws ex _aws_get_sso_credential_details("default", ini)

        #! format: off
        ini = gen_ini(
            """
            [default]
            sso_session = my-sso
            sso_role_name = role1

            [sso-session my-sso]
            sso_start_url = https://my-sso-portal.awsapps.com/start
            sso_region = us-east-1
            """
        )
        #! format: on
        ex = InvalidAWSConfig(
            "Profile \"default\" must define `sso_account_id` in order to request SSO credentials.",
        )
        @test_throws ex _aws_get_sso_credential_details("default", ini)

        #! format: off
        ini = gen_ini(
            """
            [default]
            sso_session = my-sso
            sso_account_id = 111122223333

            [sso-session my-sso]
            sso_start_url = https://my-sso-portal.awsapps.com/start
            sso_region = us-east-1
            """
        )
        #! format: on
        ex = InvalidAWSConfig(
            "Profile \"default\" must define `sso_role_name` in order to request SSO credentials.",
        )
        @test_throws ex _aws_get_sso_credential_details("default", ini)
    end

    @testset "invalid legacy SSO configuration" begin
        #! format: off
        ini = gen_ini(
            """
            [default]
            sso_account_id = 111122223333
            sso_region = us-legacy-1
            sso_role_name = role1
            """
        )
        #! format: on
        ex = InvalidAWSConfig(
            "Profile \"default\" must define `sso_start_url` in order to request SSO credentials.",
        )
        @test_throws ex _aws_get_sso_credential_details("default", ini)

        #! format: off
        ini = gen_ini(
            """
            [default]
            sso_start_url = https://my-legacy-sso-portal.awsapps.com/start
            sso_account_id = 111122223333
            sso_role_name = role1
            """
        )
        #! format: on
        ex = InvalidAWSConfig(
            "Profile \"default\" must define `sso_region` in order to request SSO credentials.",
        )
        @test_throws ex _aws_get_sso_credential_details("default", ini)

        #! format: off
        ini = gen_ini(
            """
            [default]
            sso_start_url = https://my-legacy-sso-portal.awsapps.com/start
            sso_region = us-legacy-1
            sso_role_name = role1
            """
        )
        #! format: on
        ex = InvalidAWSConfig(
            "Profile \"default\" must define `sso_account_id` in order to request SSO credentials.",
        )
        @test_throws ex _aws_get_sso_credential_details("default", ini)

        #! format: off
        ini = gen_ini(
            """
            [default]
            sso_start_url = https://my-legacy-sso-portal.awsapps.com/start
            sso_region = us-legacy-1
            sso_account_id = 111122223333
            """
        )
        #! format: on
        ex = InvalidAWSConfig(
            "Profile \"default\" must define `sso_role_name` in order to request SSO credentials.",
        )
        @test_throws ex _aws_get_sso_credential_details("default", ini)
    end

    @testset "inconsistent SSO/legacy SSO configuration" begin
        #! format: off
        ini = gen_ini(
            """
            [default]
            sso_session = my-sso
            sso_start_url = https://my-legacy-sso-portal.awsapps.com/start
            sso_region = us-east-1
            sso_account_id = 111122223333
            sso_role_name = role1

            [sso-session my-sso]
            sso_start_url = https://my-sso-portal.awsapps.com/start
            sso_region = us-east-1
            """
        )
        #! format: on
        ex = InvalidAWSConfig(
            "The value for `sso_start_url` is inconsistent between the profile (https://my-legacy-sso-portal.awsapps.com/start) and the sso-session (https://my-sso-portal.awsapps.com/start).",
        )
        @test_throws ex _aws_get_sso_credential_details("default", ini)

        #! format: off
        ini = gen_ini(
            """
            [default]
            sso_session = my-sso
            sso_start_url = https://my-sso-portal.awsapps.com/start
            sso_region = us-legacy-1
            sso_account_id = 111122223333
            sso_role_name = role1

            [sso-session my-sso]
            sso_start_url = https://my-sso-portal.awsapps.com/start
            sso_region = us-east-1
            """
        )
        #! format: on
        ex = InvalidAWSConfig(
            "The value for `sso_region` is inconsistent between the profile (us-legacy-1) and the sso-session (us-east-1).",
        )
        @test_throws ex _aws_get_sso_credential_details("default", ini)
    end

    @testset "SSO login required" begin
        # Ensure we don't accidentally use a valid session name
        session_name = "___null___"
        @test isnothing(_sso_cache_access_token(session_name))

        ex = ErrorException(
            "You must first sign in to a IAM Identity Center session via `aws sso login --profile default`. See https://docs.aws.amazon.com/cli/latest/userguide/cli-configure-sso.html#cli-configure-sso-login for more details.",
        )

        #! format: off
        ini = gen_ini(
            """
            [default]
            sso_session = $session_name
            sso_account_id = 111122223333
            sso_role_name = role1

            [sso-session $session_name]
            sso_start_url = https://my-sso-portal.awsapps.com/start
            sso_region = us-east-1
            """
        )
        #! format: on
        @test_throws ex _aws_get_sso_credential_details("default", ini)

        #! format: off
        ini = gen_ini(
            """
            [default]
            sso_start_url = $session_name
            sso_region = us-east-1
            sso_account_id = 111122223333
            sso_role_name = role1
            """
        )
        #! format: on
        @test_throws ex _aws_get_sso_credential_details("default", ini)
    end
end

@testset "AWSCredentials" begin
    @testset "Defaults" begin
        creds = AWSCredentials("access_key_id", "secret_key")
        @test creds.token == ""
        @test creds.user_arn == ""
        @test creds.account_number == ""
        @test creds.expiry == typemax(DateTime)
        @test creds.renew === nothing
    end

    @testset "Renewal" begin
        # Credentials shouldn't throw an error if no renew function is supplied
        creds = AWSCredentials("access_key_id", "secret_key"; renew=nothing)
        newcreds = check_credentials(creds; force_refresh=true)

        # Creds should remain unchanged if no renew function exists
        @test creds === newcreds
        @test creds.access_key_id == "access_key_id"
        @test creds.secret_key == "secret_key"
        @test creds.renew === nothing

        # Creds should error if the renew function returns nothing
        creds = AWSCredentials("access_key_id", "secret_key"; renew=() -> nothing)
        @test_throws NoCredentials check_credentials(creds; force_refresh=true)

        # Creds should remain unchanged
        @test creds.access_key_id == "access_key_id"
        @test creds.secret_key == "secret_key"

        # Creds should take on value of a returned AWSCredentials except renew function
        function gen_credentials()
            i = 0
            return () -> (i += 1; AWSCredentials("NEW_ID_$i", "NEW_KEY_$i"))
        end

        creds = AWSCredentials(
            "access_key_id", "secret_key"; renew=gen_credentials(), expiry=now(UTC)
        )

        @test creds.renew !== nothing
        renewed = creds.renew()

        @test creds.access_key_id == "access_key_id"
        @test creds.secret_key == "secret_key"
        @test creds.expiry <= now(UTC)
        @test AWS._will_expire(creds)

        @test renewed.access_key_id === "NEW_ID_1"
        @test renewed.secret_key == "NEW_KEY_1"
        @test renewed.renew === nothing
        @test renewed.expiry == typemax(DateTime)
        @test !AWS._will_expire(renewed)
        renew = creds.renew

        # Check renewal on time out
        newcreds = check_credentials(creds; force_refresh=false)
        @test creds === newcreds
        @test creds.access_key_id == "NEW_ID_2"
        @test creds.secret_key == "NEW_KEY_2"
        @test creds.renew !== nothing
        @test creds.renew === renew
        @test creds.expiry == typemax(DateTime)
        @test !AWS._will_expire(creds)

        # Check renewal doesn't happen if not forced or timed out
        newcreds = check_credentials(creds; force_refresh=false)
        @test creds === newcreds
        @test creds.access_key_id == "NEW_ID_2"
        @test creds.secret_key == "NEW_KEY_2"
        @test creds.renew !== nothing
        @test creds.renew === renew
        @test creds.expiry == typemax(DateTime)

        # Check forced renewal works
        newcreds = check_credentials(creds; force_refresh=true)
        @test creds === newcreds
        @test creds.access_key_id == "NEW_ID_3"
        @test creds.secret_key == "NEW_KEY_3"
        @test creds.renew !== nothing
        @test creds.renew === renew
        @test creds.expiry == typemax(DateTime)
    end

    mktempdir() do dir
        config_file = joinpath(dir, "config")
        creds_file = joinpath(dir, "creds")
        write(
            config_file,
            """
            [profile test]
            output = json

            [profile test:dev]
            source_profile = test
            role_arn = arn:aws:iam::123456789000:role/Dev

            [profile test:sub-dev]
            source_profile = test:dev
            role_arn = arn:aws:iam::123456789000:role/SubDev

            [profile test2]
            aws_access_key_id = WRONG_ACCESS_ID
            aws_secret_access_key = WRONG_ACCESS_KEY

            [profile test3]
            source_profile = test:dev
            role_arn = arn:aws:iam::123456789000:role/test3

            [profile test4]
            aws_access_key_id = RIGHT_ACCESS_ID4
            aws_secret_access_key = RIGHT_ACCESS_KEY4
            source_profile = test:dev
            role_arn = arn:aws:iam::123456789000:role/test3
            """,
        )

        write(
            creds_file,
            """
            [test]
            aws_access_key_id = TEST_ACCESS_ID
            aws_secret_access_key = TEST_ACCESS_KEY

            [test2]
            aws_access_key_id = RIGHT_ACCESS_ID2
            aws_secret_access_key = RIGHT_ACCESS_KEY2

            [test3]
            aws_access_key_id = RIGHT_ACCESS_ID3
            aws_secret_access_key = RIGHT_ACCESS_KEY3
            """,
        )

        withenv(
            "AWS_SHARED_CREDENTIALS_FILE" => creds_file,
            "AWS_CONFIG_FILE" => config_file,
            "AWS_DEFAULT_PROFILE" => "test",
            "AWS_PROFILE" => nothing,
            "AWS_ACCESS_KEY_ID" => nothing,
            "AWS_REGION" => "us-east-1",
        ) do
            @testset "Loading" begin
                # Check credentials load
                config = AWSConfig()
                creds = config.credentials

                @test creds isa AWSCredentials

                @test creds.access_key_id == "TEST_ACCESS_ID"
                @test creds.secret_key == "TEST_ACCESS_KEY"
                @test creds.renew !== nothing

                # Check credential file takes precedence over config
                withenv("AWS_DEFAULT_PROFILE" => "test2") do
                    config = AWSConfig()
                    creds = config.credentials

                    @test creds.access_key_id == "RIGHT_ACCESS_ID2"
                    @test creds.secret_key == "RIGHT_ACCESS_KEY2"
                end

                # Check credentials take precedence over role
                withenv("AWS_DEFAULT_PROFILE" => "test3") do
                    config = AWSConfig()
                    creds = config.credentials

                    @test creds.access_key_id == "RIGHT_ACCESS_ID3"
                    @test creds.secret_key == "RIGHT_ACCESS_KEY3"
                end

                withenv("AWS_DEFAULT_PROFILE" => "test4") do
                    config = AWSConfig()
                    creds = config.credentials

                    @test creds.access_key_id == "RIGHT_ACCESS_ID4"
                    @test creds.secret_key == "RIGHT_ACCESS_KEY4"
                end
            end

            @testset "Refresh" begin
                withenv("AWS_DEFAULT_PROFILE" => "test") do
                    # Check credentials refresh on timeout
                    config = AWSConfig()
                    creds = config.credentials
                    creds.access_key_id = "EXPIRED_ACCESS_ID"
                    creds.secret_key = "EXPIRED_ACCESS_KEY"
                    creds.expiry = now(UTC)

                    @test creds.renew !== nothing
                    renew = creds.renew

                    @test renew() isa AWSCredentials

                    creds = check_credentials(config.credentials)

                    @test creds.access_key_id == "TEST_ACCESS_ID"
                    @test creds.secret_key == "TEST_ACCESS_KEY"
                    @test creds.expiry > now(UTC)

                    # Check renew function remains unchanged
                    @test creds.renew !== nothing
                    @test creds.renew === renew

                    # Check force_refresh
                    creds.access_key_id = "WRONG_ACCESS_KEY"
                    creds = check_credentials(creds; force_refresh=true)
                    @test creds.access_key_id == "TEST_ACCESS_ID"
                end
            end

            @testset "Profile" begin
                # Check profile kwarg
                withenv("AWS_DEFAULT_PROFILE" => "test") do
                    creds = AWSCredentials(; profile="test2")
                    @test creds.access_key_id == "RIGHT_ACCESS_ID2"
                    @test creds.secret_key == "RIGHT_ACCESS_KEY2"

                    config = AWSConfig(; profile="test2")
                    creds = config.credentials
                    @test creds.access_key_id == "RIGHT_ACCESS_ID2"
                    @test creds.secret_key == "RIGHT_ACCESS_KEY2"

                    # Check profile persists on renewal
                    creds.access_key_id = "WRONG_ACCESS_ID2"
                    creds.secret_key = "WRONG_ACCESS_KEY2"
                    creds = check_credentials(creds; force_refresh=true)

                    @test creds.access_key_id == "RIGHT_ACCESS_ID2"
                    @test creds.secret_key == "RIGHT_ACCESS_KEY2"
                end
            end

            @testset "Assume Role" begin
                # Check we try to assume a role
                withenv("AWS_DEFAULT_PROFILE" => "test:dev") do
                    @test_ecode("InvalidClientTokenId", AWSConfig())
                end

                # Check we try to assume a role
                withenv("AWS_DEFAULT_PROFILE" => "test:sub-dev") do
                    oldout = stdout
                    r, w = redirect_stdout()

                    @test_ecode("InvalidClientTokenId", AWSConfig())
                    redirect_stdout(oldout)
                    close(w)
                    output = String(read(r))
                    occursin("Assuming \"test:dev\"", output)
                    occursin("Assuming \"test\"", output)
                    close(r)
                end
            end
        end
    end

    # Verify that the search order for credentials mirrors the behavior of the AWS CLI
    # (version 2.11.13). Whenever support is added for new credential types new tests should
    # be added to this test set. To determine the credential preference order used by AWS
    # CLI it is recommended you use a set of valid credentials and a set of invalid
    # credentials to determine the precedence.
    #
    # Documentation on credential precedence:
    # - https://docs.aws.amazon.com/cli/latest/userguide/cli-chap-authentication.html#cli-chap-authentication-precedence
    # - https://docs.aws.amazon.com/sdk-for-net/v3/developer-guide/creds-assign.html
    # - https://docs.aws.amazon.com/sdk-for-java/v1/developer-guide/credentials.html
    @testset "Credential Precedence" begin
        mktempdir() do dir
            config_file = joinpath(dir, "config")
            creds_file = joinpath(dir, "creds")

            basic_creds_content = """
                [profile1]
                aws_access_key_id = AKI1
                aws_secret_access_key = SAK1

                [profile2]
                aws_access_key_id = AKI2
                aws_secret_access_key = SAK2
                """

            ec2_json = Dict(
                "AccessKeyId" => "AKI_EC2",
                "SecretAccessKey" => "SAK_EC2",
                "Token" => "TOK_EC2",
                "Expiration" => Dates.format(now(UTC), EXPIRATION_FMT),
            )

            function ec2_metadata(url::AbstractString)
                name = "local-credentials"
                metadata_uri = "http://169.254.169.254/latest/meta-data"
                if url == "$metadata_uri/iam/info"
                    return HTTP.Response(200, JSON.json("InstanceProfileArn" => "ARN0"))
                elseif url == "$metadata_uri/iam/security-credentials/"
                    return HTTP.Response(200, name)
                elseif url == "$metadata_uri/iam/security-credentials/$name"
                    return HTTP.Response(200, JSON.json(ec2_json))
                else
                    return HTTP.Response(404)
                end
            end

            ecs_json = Dict(
                "AccessKeyId" => "AKI_ECS",
                "SecretAccessKey" => "SAK_ECS",
                "Token" => "TOK_ECS",
                "Expiration" => Dates.format(now(UTC), EXPIRATION_FMT),
            )

            function ecs_metadata(url::AbstractString)
                if startswith(url, "http://169.254.170.2/")
                    return HTTP.Response(200, JSON.json(ecs_json))
                else
                    return HTTP.Response(404)
                end
            end

            function ecs_metadata_localhost(url::AbstractString)
                if startswith(url, "http://localhost:8080")
                    return HTTP.Response(200, JSON.json(ecs_json))
                else
                    return HTTP.Response(404)
                end
            end

            function http_request_patcher(funcs)
                @patch function HTTP.request(method, url, args...; kwargs...)
                    local r
                    for f in funcs
                        r = f(string(url))
                        r.status != 404 && break
                    end
                    return r
                end
            end

            withenv(
                [k => nothing for k in filter(startswith("AWS_"), keys(ENV))]...,
                "AWS_SHARED_CREDENTIALS_FILE" => creds_file,
                "AWS_CONFIG_FILE" => config_file,
            ) do
                @testset "explicit profile preferred" begin
                    isfile(config_file) && rm(config_file)
                    write(creds_file, basic_creds_content)

                    withenv("AWS_PROFILE" => "profile1") do
                        creds = AWSCredentials(; profile="profile2")
                        @test creds.access_key_id == "AKI2"
                    end

                    withenv(
                        "AWS_ACCESS_KEY_ID" => "AKI0",
                        "AWS_SECRET_ACCESS_KEY" => "SAK0",
                        # format trick: using this comment to force use of multiple lines
                    ) do
                        creds = AWSCredentials(; profile="profile2")
                        @test creds.access_key_id == "AKI2"
                    end
                end

                @testset "AWS_ACCESS_KEY_ID preferred over AWS_PROFILE" begin
                    isfile(config_file) && rm(config_file)
                    write(creds_file, basic_creds_content)

                    withenv(
                        "AWS_PROFILE" => "profile1",
                        "AWS_ACCESS_KEY_ID" => "AKI0",
                        "AWS_SECRET_ACCESS_KEY" => "SAK0",
                    ) do
                        creds = AWSCredentials()
                        @test creds.access_key_id == "AKI0"
                    end
                end

                # The AWS CLI used to use `AWS_DEFAULT_PROFILE` to set the AWS profile via the
                # command line but this was deprecated in favor of `AWS_PROFILE`. We'll probably
                # keeps support for this as long as AWS CLI continues to support it.
                # https://github.com/aws/aws-cli/issues/2597
                @testset "AWS_PROFILE preferred over AWS_DEFAULT_PROFILE" begin
                    isfile(config_file) && rm(config_file)
                    write(creds_file, basic_creds_content)

                    withenv(
                        "AWS_DEFAULT_PROFILE" => "profile1",
                        "AWS_PROFILE" => "profile2",
                        # format trick: using this comment to force use of multiple lines
                    ) do
                        creds = AWSCredentials()
                        @test creds.access_key_id == "AKI2"
                    end
                end

                @testset "Web identity preferred over IAM Identity Center (SSO)" begin
                    write(
                        config_file,
                        """
                        [default]
                        sso_session = my-sso
                        sso_account_id = 111122223333
                        sso_role_name = role1

                        [sso-session my-sso]
                        sso_region = us-east-1
                        sso_start_url = https://my-sso-portal.awsapps.com/start
                        """,
                    )
                    isfile(creds_file) && rm(creds_file)

                    web_identity_file = joinpath(dir, "web_identity")
                    write(web_identity_file, "webid")

                    patches = [
                        Patches._assume_role_patch(
                            "AssumeRoleWithWebIdentity";
                            access_key="AKI_WEB",
                            secret_key="SAK_WEB",
                            session_token="TOK_WEB",
                        ),
                        Patches.sso_service_patches("AKI_SSO", "SAK_SSO"),
                        Patches._imds_region_patch(nothing),
                    ]

                    withenv(
                        "AWS_WEB_IDENTITY_TOKEN_FILE" => web_identity_file,
                        "AWS_ROLE_ARN" => "webid",
                    ) do
                        apply(patches) do
                            creds = AWSCredentials()
                            @test creds.access_key_id == "AKI_WEB"
                        end
                    end
                end

                @testset "IAM Identity Center (SSO) preferred over Legacy IAM Identity Center" begin
                    write(
                        config_file,
                        """
                        [default]
                        sso_session = my-sso
                        sso_account_id = 111122223333
                        sso_role_name = role1
                        sso_start_url = https://my-sso-portal.awsapps.com/start
                        sso_region = us-east-1

                        [sso-session my-sso]
                        sso_start_url = https://my-sso-portal.awsapps.com/start
                        sso_region = us-east-1
                        """,
                    )
                    isfile(creds_file) && rm(creds_file)

                    apply(Patches.sso_service_patches("AKI_SSO", "SAK_SSO")) do
                        creds = AWSCredentials()
                        @test creds.access_key_id == "AKI_SSO"

                        # Using the credential token to identify the which SSO system is
                        # used. For legacy SSO this would be `sso_start_url` instead of
                        # `sso_session`.
                        @test creds.token == "my-sso"
                    end
                end

                @testset "Legacy IAM Identity Center (SSO) preferred over credentials file" begin
                    write(
                        config_file,
                        """
                        [profile profile1]
                        sso_start_url = https://my-sso-portal.awsapps.com/start
                        sso_account_id = 111122223333
                        sso_role_name = role1
                        sso_region = us-east-1
                        """,
                    )
                    write(creds_file, basic_creds_content)

                    apply(Patches.sso_service_patches("AKI_SSO", "SAK_SSO")) do
                        creds = AWSCredentials(; profile="profile1")
                        @test creds.access_key_id == "AKI_SSO"
                    end
                end

                @testset "Credential file over credential_process" begin
                    json = Dict(
                        "Version" => 1,
                        "AccessKeyId" => "AKI0",
                        "SecretAccessKey" => "SAK0",
                        # format trick: using this comment to force use of multiple lines
                    )
                    write(
                        config_file,
                        """
                        [profile profile1]
                        credential_process = echo '$(JSON.json(json))'
                        """,
                    )
                    write(creds_file, basic_creds_content)

                    creds = AWSCredentials(; profile="profile1")
                    @test creds.access_key_id == "AKI1"
                end

                @testset "credential_process over config credentials" begin
                    json = Dict(
                        "Version" => 1,
                        "AccessKeyId" => "AKI0",
                        "SecretAccessKey" => "SAK0",
                        # format trick: using this comment to force use of multiple lines
                    )
                    write(
                        config_file,
                        """
                        [profile profile1]
                        aws_access_key_id = AKI1
                        aws_secret_access_key = SAK1
                        credential_process = echo '$(JSON.json(json))'
                        """,
                    )
                    isfile(creds_file) && rm(creds_file)

                    creds = AWSCredentials(; profile="profile1")
                    @test creds.access_key_id == "AKI0"
                end

                @testset "default config credentials over ECS container credentials ENV variables" begin
                    write(
                        config_file,
                        """
                        [default]
                        aws_access_key_id = AKI1
                        aws_secret_access_key = SAK1
                        """,
                    )
                    isfile(creds_file) && rm(creds_file)

                    withenv("AWS_CONTAINER_CREDENTIALS_RELATIVE_URI" => "/get-creds") do
                        apply(http_request_patcher([ecs_metadata])) do
                            @test isnothing(AWS._aws_get_profile(; default=nothing))

                            creds = AWSCredentials()
                            @test creds.access_key_id == "AKI1"
                        end
                    end

                    withenv(
                        "AWS_CONTAINER_CREDENTIALS_FULL_URI" => "http://localhost:8080"
                    ) do
                        apply(http_request_patcher([ecs_metadata_localhost])) do
                            @test isnothing(AWS._aws_get_profile(; default=nothing))

                            creds = AWSCredentials()
                            @test creds.access_key_id == "AKI1"
                        end
                    end
                end

                @testset "default config credentials over EC2 instance credentials" begin
                    write(
                        config_file,
                        """
                        [default]
                        aws_access_key_id = AKI1
                        aws_secret_access_key = SAK1
                        """,
                    )
                    isfile(creds_file) && rm(creds_file)

                    apply(http_request_patcher([ec2_metadata])) do
                        @test isnothing(AWS._aws_get_profile(; default=nothing))

                        creds = AWSCredentials()
                        @test creds.access_key_id == "AKI1"
                    end
                end

                @testset "ECS container credentials ENV variables over EC2 instance credentials" begin
                    isfile(config_file) && rm(config_file)
                    isfile(creds_file) && rm(creds_file)

                    withenv("AWS_CONTAINER_CREDENTIALS_RELATIVE_URI" => "/get-creds") do
                        apply(http_request_patcher([ec2_metadata, ecs_metadata])) do
                            creds = AWSCredentials()
                            @test creds.access_key_id == "AKI_ECS"
                        end
                    end

                    withenv(
                        "AWS_CONTAINER_CREDENTIALS_FULL_URI" => "http://localhost:8080"
                    ) do
                        p = http_request_patcher([ec2_metadata, ecs_metadata_localhost])
                        apply(p) do
                            creds = AWSCredentials()
                            @test creds.access_key_id == "AKI_ECS"
                        end
                    end
                end

                # Note: It appears that the ECS container credentials are only used when
                # a `AWS_CONTAINER_*` environmental variable is set. However, this test
                # ensures that if we do add implicit support that the documented precedence
                # order is not violated.
                @testset "EC2 instance credentials over ECS container credentials" begin
                    isfile(config_file) && rm(config_file)
                    isfile(creds_file) && rm(creds_file)

                    apply(http_request_patcher([ec2_metadata, ecs_metadata])) do
                        creds = AWSCredentials()
                        @test creds.access_key_id == "AKI_EC2"
                    end
                end
            end
        end
    end
end

@testset "Retrieving AWS Credentials" begin
    test_values = Dict{String,Any}(
        "Default-Profile" => "default",
        "Test-Profile" => "test",
        "Test-Config-Profile" => "test",
        "AccessKeyId" => "Default-Key",
        "SecretAccessKey" => "Default-Secret",
        "Test-AccessKeyId" => "Test-Key",
        "Test-SecretAccessKey" => "Test-Secret",
        "Token" => "Test-Token",
        "InstanceProfileArn" => "Test-Arn",
        "RoleArn" => "Test-Arn",
        "Expiration" => now(UTC),
        "Security-Credentials" => "Test-Security-Credentials",
        "Test-SSO-Profile" => "sso-test",
        "Test-SSO-start-url" => "https://test-sso.com/start",
        "Test-SSO-Role" => "SSORoleName",
        "Test-SSO-Account-Id" => "111122223333",
        "Test-SSO-Region" => "us-east-1",
    )

    @testset "~/.aws/config - Default Profile" begin
        mktemp() do config_file, config_io
            write(
                config_io,
                """
                [$(test_values["Default-Profile"])]
                aws_access_key_id=$(test_values["AccessKeyId"])
                aws_secret_access_key=$(test_values["SecretAccessKey"])
                """,
            )
            close(config_io)

            withenv("AWS_CONFIG_FILE" => config_file) do
                default_profile = dot_aws_config(test_values["Default-Profile"])

                @test default_profile.access_key_id == test_values["AccessKeyId"]
                @test default_profile.secret_key == test_values["SecretAccessKey"]
            end
        end
    end

    @testset "~/.aws/config - Specified Profile" begin
        mktemp() do config_file, config_io
            write(
                config_io,
                """
                [profile $(test_values["Test-Config-Profile"])]
                aws_access_key_id=$(test_values["Test-AccessKeyId"])
                aws_secret_access_key=$(test_values["Test-SecretAccessKey"])
                """,
            )
            close(config_io)

            withenv("AWS_CONFIG_FILE" => config_file) do
                specified_result = dot_aws_config(test_values["Test-Profile"])

                @test specified_result.access_key_id == test_values["Test-AccessKeyId"]
                @test specified_result.secret_key == test_values["Test-SecretAccessKey"]
            end
        end
    end

    @testset "~/.aws/config - Specified SSO Profile" begin
        mktemp() do config_file, config_io
            write(
                config_io,
                """
                [profile $(test_values["Test-SSO-Profile"])]
                sso_start_url=$(test_values["Test-SSO-start-url"])
                sso_role_name=$(test_values["Test-SSO-Role"])
                sso_account_id=$(test_values["Test-SSO-Account-Id"])
                sso_region=$(test_values["Test-SSO-Region"])
                """,
            )
            close(config_io)

            withenv("AWS_CONFIG_FILE" => config_file) do
                apply(
                    Patches.sso_service_patches(
                        test_values["AccessKeyId"], test_values["SecretAccessKey"]
                    ),
                ) do
                    specified_result = sso_credentials(test_values["Test-SSO-Profile"])

                    @test specified_result.access_key_id == test_values["AccessKeyId"]
                    @test specified_result.secret_key == test_values["SecretAccessKey"]
                end
            end
        end
    end

    @testset "~/.aws/config - Credential Process" begin
        mktempdir() do dir
            config_file = joinpath(dir, "config")
            credential_process_file = joinpath(dir, "cred_process")
            open(credential_process_file, "w") do io
                println(io, "#!/bin/sh")
                println(io, "cat <<EOF")
                json = Dict(
                    "Version" => 1,
                    "AccessKeyId" => test_values["Test-AccessKeyId"],
                    "SecretAccessKey" => test_values["Test-SecretAccessKey"],
                )
                JSON.print(io, json)
                println(io, "\nEOF")
            end
            chmod(credential_process_file, 0o700)

            withenv("AWS_CONFIG_FILE" => config_file) do
                open(config_file, "w") do io
                    write(
                        io,
                        """
                        [profile $(test_values["Test-Config-Profile"])]
                        credential_process = $(abspath(credential_process_file))
                        """,
                    )
                end

                result = dot_aws_config(test_values["Test-Config-Profile"])

                @test result.access_key_id == test_values["Test-AccessKeyId"]
                @test result.secret_key == test_values["Test-SecretAccessKey"]
                @test isempty(result.token)
                @test result.expiry == typemax(DateTime)
            end
        end
    end

    @testset "~/.aws/creds - Default Profile" begin
        mktemp() do creds_file, creds_io
            write(
                creds_io,
                """
                [$(test_values["Default-Profile"])]
                aws_access_key_id=$(test_values["AccessKeyId"])
                aws_secret_access_key=$(test_values["SecretAccessKey"])
                """,
            )
            close(creds_io)

            withenv("AWS_SHARED_CREDENTIALS_FILE" => creds_file) do
                specified_result = dot_aws_credentials(test_values["Default-Profile"])

                @test specified_result.access_key_id == test_values["AccessKeyId"]
                @test specified_result.secret_key == test_values["SecretAccessKey"]
            end
        end
    end

    @testset "~/.aws/creds - Specified Profile" begin
        mktemp() do creds_file, creds_io
            write(
                creds_io,
                """
                [$(test_values["Test-Profile"])]
                aws_access_key_id=$(test_values["Test-AccessKeyId"])
                aws_secret_access_key=$(test_values["Test-SecretAccessKey"])
                """,
            )
            close(creds_io)

            withenv("AWS_SHARED_CREDENTIALS_FILE" => creds_file) do
                specified_result = dot_aws_credentials(test_values["Test-Profile"])

                @test specified_result.access_key_id == test_values["Test-AccessKeyId"]
                @test specified_result.secret_key == test_values["Test-SecretAccessKey"]
            end
        end
    end

    @testset "Environment Variables" begin
        withenv(
            "AWS_ACCESS_KEY_ID" => test_values["AccessKeyId"],
            "AWS_SECRET_ACCESS_KEY" => test_values["SecretAccessKey"],
        ) do
            aws_creds = env_var_credentials()
            @test aws_creds.access_key_id == test_values["AccessKeyId"]
            @test aws_creds.secret_key == test_values["SecretAccessKey"]
        end
    end

    @testset "Instance - EC2" begin
        role_name = "foobar"
        role_arn = "arn:aws:sts::1234:assumed-role/$role_name"
        access_key = "access-key-$(randstring(6))"
        secret_key = "secret-key-$(randstring(6))"
        session_token = "session-token-$(randstring(6))"
        session_name = "$role_name-session"

        assume_role_patch = Patches._assume_role_patch(
            "AssumeRole";
            access_key=access_key,
            secret_key=secret_key,
            session_token=session_token,
            role_arn=role_arn,
        )
        ec2_metadata_patch = @patch function HTTP.request(method, url, args...; kwargs...)
            url = string(url)
            security_credentials = test_values["Security-Credentials"]

            metadata_uri = "http://169.254.169.254/latest/meta-data"
            if url == "$metadata_uri/iam/info"
                json = JSON.json("InstanceProfileArn" => test_values["InstanceProfileArn"])
                return HTTP.Response(200, json)
            elseif url == "$metadata_uri/iam/security-credentials/"
                return HTTP.Response(200, security_credentials)
            elseif url == "$metadata_uri/iam/security-credentials/$security_credentials"
                return HTTP.Response(200, JSON.json(test_values))
            else
                return HTTP.Response(404)
            end
        end

        apply([assume_role_patch, ec2_metadata_patch]) do
            result = ec2_instance_credentials("default")
            @test result.access_key_id == test_values["AccessKeyId"]
            @test result.secret_key == test_values["SecretAccessKey"]
            @test result.token == test_values["Token"]
            @test result.user_arn == test_values["InstanceProfileArn"]
            @test result.expiry == test_values["Expiration"]
            @test result.renew !== nothing

            result = mktemp() do config_file, config_io
                write(
                    config_io,
                    """
                    [profile $role_name]
                    credential_source = Ec2InstanceMetadata
                    role_arn = $role_arn
                    """,
                )
                close(config_io)

                withenv(
                    "AWS_CONFIG_FILE" => config_file,
                    "AWS_ROLE_SESSION_NAME" => session_name,
                ) do
                    ec2_instance_credentials(role_name)
                end
            end

            @test result.access_key_id == access_key
            @test result.secret_key == secret_key
            @test result.token == session_token
            @test result.user_arn == "$(role_arn)/$(session_name)"
            @test result.renew !== nothing
        end
    end

    @testset "Instance - ECS" begin
        expiration = floor(now(UTC), Second)
        rel_uri_json = Dict(
            "AccessKeyId" => "AKI_REL_ECS",
            "SecretAccessKey" => "SAK_REL_ECS",
            "Token" => "TOK_REL_ECS",
            "Expiration" => Dates.format(expiration, dateformat"yyyy-mm-dd\THH:MM:SS\Z"),
            "RoleArn" => "ROLE_REL_ECS",
        )

        rel_uri_patch = @patch function HTTP.request(::String, url, headers=[]; kwargs...)
            url = string(url)

            @test url == "http://169.254.170.2/get-credentials"
            @test isempty(headers)

            if url == "http://169.254.170.2/get-credentials"
                return HTTP.Response(200, JSON.json(rel_uri_json))
            else
                return HTTP.Response(404)
            end
        end

        withenv("AWS_CONTAINER_CREDENTIALS_RELATIVE_URI" => "/get-credentials") do
            apply(rel_uri_patch) do
                result = ecs_instance_credentials()
                @test result.access_key_id == rel_uri_json["AccessKeyId"]
                @test result.secret_key == rel_uri_json["SecretAccessKey"]
                @test result.token == rel_uri_json["Token"]
                @test result.user_arn == rel_uri_json["RoleArn"]
                @test result.expiry == expiration
                @test result.renew == ecs_instance_credentials
            end
        end

        # When the environmental variable isn't set then the ECS credential provider is
        # unavailable.
        withenv("AWS_CONTAINER_CREDENTIALS_RELATIVE_URI" => nothing) do
            @test ecs_instance_credentials() === nothing
        end

        # Specifying the environmental variable results in us attempting to connect to the
        # ECS credential provider.
        withenv("AWS_CONTAINER_CREDENTIALS_RELATIVE_URI" => "/invalid") do
            # Internally throws a `ConnectError` exception
            @test ecs_instance_credentials() === nothing
        end

        full_uri_json = Dict(
            "AccessKeyId" => "AKI_FULL_ECS",
            "SecretAccessKey" => "SAK_FULL_ECS",
            "Token" => "TOK_FULL_ECS",
            "Expiration" => Dates.format(expiration, dateformat"yyyy-mm-dd\THH:MM:SS\Z"),
            "RoleArn" => "ROLE_FULL_ECS",
        )

        full_uri_patch = @patch function HTTP.request(::String, url, headers=[]; kwargs...)
            url = string(url)
            authorization = http_header(headers, "Authorization")

            @test url == "http://localhost/get-credentials"
            @test authorization == "Basic abcd"

            if url == "http://localhost/get-credentials" && authorization == "Basic abcd"
                return HTTP.Response(200, JSON.json(full_uri_json))
            else
                return HTTP.Response(403)
            end
        end

        withenv(
            "AWS_CONTAINER_CREDENTIALS_FULL_URI" => "http://localhost/get-credentials",
            "AWS_CONTAINER_AUTHORIZATION_TOKEN" => "Basic abcd",
        ) do
            apply(full_uri_patch) do
                result = ecs_instance_credentials()
                @test result.access_key_id == full_uri_json["AccessKeyId"]
                @test result.secret_key == full_uri_json["SecretAccessKey"]
                @test result.token == full_uri_json["Token"]
                @test result.user_arn == full_uri_json["RoleArn"]
                @test result.expiry == expiration
                @test result.renew == ecs_instance_credentials
            end
        end

        # `AWS_CONTAINER_CREDENTIALS_RELATIVE_URI` should be preferred over
        # `AWS_CONTAINER_CREDENTIALS_FULL_URI`.
        withenv(
            "AWS_CONTAINER_CREDENTIALS_RELATIVE_URI" => "/get-credentials",
            "AWS_CONTAINER_CREDENTIALS_FULL_URI" => "http://localhost/get-credentials",
        ) do
            apply(rel_uri_patch) do
                result = ecs_instance_credentials()
                @test result.access_key_id == rel_uri_json["AccessKeyId"]
            end
        end
    end

    @testset "Web Identity File" begin
        @test credentials_from_webtoken() == nothing

        mktempdir() do dir
            web_identity_file = joinpath(dir, "web_identity")
            write(web_identity_file, "foobar")
            session_name = "foobar-session"

            access_key = "access-key-$(randstring(6))"
            secret_key = "secret-key-$(randstring(6))"
            session_token = "session-token-$(randstring(6))"
            role_arn = "arn:aws:sts::1234:assumed-role/foobar"

            patch = Patches._assume_role_patch(
                "AssumeRoleWithWebIdentity";
                access_key=access_key,
                secret_key=secret_key,
                session_token=session_token,
                role_arn=role_arn,
                expiry=duration -> now(UTC), # expire immediately to check renewal
            )

            withenv(
                "AWS_ROLE_ARN" => "foobar",
                "AWS_WEB_IDENTITY_TOKEN_FILE" => web_identity_file,
                "AWS_ROLE_SESSION_NAME" => session_name,
            ) do
                apply(patch) do
                    result = credentials_from_webtoken()

                    @test result.access_key_id == access_key
                    @test result.secret_key == secret_key
                    @test result.token == session_token
                    @test result.user_arn == "$(role_arn)/$(session_name)"
                    @test result.renew == credentials_from_webtoken
                    expiry = result.expiry
                    sleep(0.1)
                    result = check_credentials(result)

                    @test result.access_key_id == access_key
                    @test result.secret_key == secret_key
                    @test result.token == session_token
                    @test result.user_arn == "$(role_arn)/$(session_name)"
                    @test result.renew == credentials_from_webtoken
                    @test expiry != result.expiry
                end
            end

            session_name = "AWS.jl-role-foobar-20210101T000000Z"
            patches = [
                patch
                @patch Dates.now(::Type{UTC}) = DateTime(2021)
            ]

            withenv(
                "AWS_ROLE_ARN" => "foobar",
                "AWS_WEB_IDENTITY_TOKEN_FILE" => web_identity_file,
                "AWS_ROLE_SESSION_NAME" => nothing,
            ) do
                apply(patches) do
                    result = credentials_from_webtoken()
                    @test result.user_arn == "$(role_arn)/$(session_name)"
                end
            end
        end
    end

    @testset "Credential Process" begin
        gen_process(json) = Cmd(["echo", JSON.json(json)])

        long_term_resp = Dict(
            "Version" => 1,
            "AccessKeyId" => "access-key",
            "SecretAccessKey" => "secret-key",
            # format trick: using this comment to force use of multiple lines
        )
        creds = external_process_credentials(gen_process(long_term_resp))
        @test creds.access_key_id == long_term_resp["AccessKeyId"]
        @test creds.secret_key == long_term_resp["SecretAccessKey"]
        @test isempty(creds.token)
        @test creds.expiry == typemax(DateTime)

        expiration = floor(now(UTC), Second)
        temporary_resp = Dict(
            "Version" => 1,
            "AccessKeyId" => "access-key",
            "SecretAccessKey" => "secret-key",
            "SessionToken" => "session-token",
            "Expiration" => Dates.format(expiration, EXPIRATION_FMT),
        )
        creds = external_process_credentials(gen_process(temporary_resp))
        @test creds.access_key_id == temporary_resp["AccessKeyId"]
        @test creds.secret_key == temporary_resp["SecretAccessKey"]
        @test creds.token == temporary_resp["SessionToken"]
        @test creds.expiry == expiration

        unhandled_version_resp = Dict("Version" => 2)
        json = sprint(JSON.print, unhandled_version_resp, 2)
        ex = ErrorException("Credential process returned unhandled version 2:\n$json")
        @test_throws ex external_process_credentials(gen_process(unhandled_version_resp))

        missing_token_resp = Dict(
            "Version" => 1,
            "AccessKeyId" => "access-key",
            "SecretAccessKey" => "secret-key",
            "Expiration" => Dates.format(expiration, EXPIRATION_FMT),
        )
        ex = KeyError("SessionToken")
        @test_throws ex external_process_credentials(gen_process(missing_token_resp))

        missing_expiration_resp = Dict(
            "Version" => 1,
            "AccessKeyId" => "access-key",
            "SecretAccessKey" => "secret-key",
            "SessionToken" => "session-token",
        )
        ex = KeyError("Expiration")
        @test_throws ex external_process_credentials(gen_process(missing_expiration_resp))
    end

    @testset "Credentials Not Found" begin
        patches = [
            @patch function HTTP.request(method::String, url, args...; kwargs...)
                throw(HTTP.Exceptions.ConnectError(string(url), "host is unreachable"))
            end
            Patches._cred_file_patch
            Patches._config_file_patch
        ]

        withenv(
            "AWS_ACCESS_KEY_ID" => nothing,
            "AWS_CONTAINER_CREDENTIALS_RELATIVE_URI" => nothing,
        ) do
            apply(patches) do
                @test_throws NoCredentials AWSConfig()
            end
        end
    end

    @testset "Helper functions" begin
        @testset "Check Credentials - EnvVars" begin
            withenv(
                "AWS_ACCESS_KEY_ID" => test_values["AccessKeyId"],
                "AWS_SECRET_ACCESS_KEY" => test_values["SecretAccessKey"],
            ) do
                testAWSCredentials = AWSCredentials(
                    test_values["AccessKeyId"],
                    test_values["SecretAccessKey"];
                    expiry=Dates.now(UTC) - Minute(10),
                    renew=env_var_credentials,
                )

                result = check_credentials(testAWSCredentials; force_refresh=true)
                @test result.access_key_id == testAWSCredentials.access_key_id
                @test result.secret_key == testAWSCredentials.secret_key
                @test result.expiry == typemax(DateTime)
                @test result.renew == testAWSCredentials.renew
            end
        end
    end
end

@testset "aws_get_region" begin
    mktempdir() do dir
        config_str = """
            [default]
            region = us-west-2

            [profile test]
            region = ap-northeast-1
            """
        config_file = joinpath(dir, "config")
        write(config_file, config_str)
        ini = read(Inifile(), IOBuffer(config_str))

        @testset "environmental variable (AWS_REGION)" begin
            withenv("AWS_REGION" => "eu-west-1", "AWS_DEFAULT_REGION" => nothing) do
                @test aws_get_region(; config=ini, profile="default") == "eu-west-1"
                @test aws_get_region() == "eu-west-1"
            end

            withenv("AWS_REGION" => nothing, "AWS_DEFAULT_REGION" => "us-gov-east-1") do
                @test aws_get_region(; config=ini, profile="default") == "us-gov-east-1"
                @test aws_get_region() == "us-gov-east-1"
            end

            withenv("AWS_REGION" => "eu-west-1", "AWS_DEFAULT_REGION" => "us-gov-east-1") do
                @test aws_get_region(; config=ini, profile="default") == "eu-west-1"
                @test aws_get_region() == "eu-west-1"
            end
        end

        @testset "default profile" begin
            withenv("AWS_REGION" => nothing, "AWS_DEFAULT_REGION" => nothing) do
                @test aws_get_region(; config=ini, profile="default") == "us-west-2"
                @test aws_get_region(; config=config_file, profile="default") == "us-west-2"
            end

            withenv(
                "AWS_REGION" => nothing,
                "AWS_DEFAULT_REGION" => nothing,
                "AWS_CONFIG_FILE" => config_file,
                "AWS_PROFILE" => nothing,
                "AWS_DEFAULT_PROFILE" => nothing,
            ) do
                @test aws_get_region() == "us-west-2"
            end
        end

        @testset "specified profile" begin
            withenv("AWS_DEFAULT_REGION" => nothing, "AWS_REGION" => nothing) do
                @test aws_get_region(; config=ini, profile="test") == "ap-northeast-1"
                @test aws_get_region(; config=config_file, profile="test") ==
                    "ap-northeast-1"
            end

            withenv(
                "AWS_REGION" => nothing,
                "AWS_DEFAULT_REGION" => nothing,
                "AWS_CONFIG_FILE" => config_file,
                "AWS_PROFILE" => "test",
            ) do
                @test aws_get_region() == "ap-northeast-1"
            end
        end

        @testset "unknown profile" begin
            withenv("AWS_DEFAULT_REGION" => nothing, "AWS_REGION" => nothing) do
                apply(Patches._imds_region_patch(nothing)) do
                    @test aws_get_region(; config=ini, profile="unknown") ==
                        AWS.DEFAULT_REGION
                    @test aws_get_region(; config=config_file, profile="unknown") ==
                        AWS.DEFAULT_REGION
                end
            end

            withenv(
                "AWS_REGION" => nothing,
                "AWS_DEFAULT_REGION" => nothing,
                "AWS_CONFIG_FILE" => config_file,
                "AWS_PROFILE" => "unknown",
            ) do
                apply(Patches._imds_region_patch(nothing)) do
                    @test aws_get_region() == AWS.DEFAULT_REGION
                end
            end
        end

        @testset "default keyword" begin
            default = nothing
            withenv("AWS_DEFAULT_REGION" => nothing, "AWS_REGION" => nothing) do
                apply(Patches._imds_region_patch(nothing)) do
                    @test aws_get_region(; config=ini, profile="unknown", default) ===
                        default
                    @test aws_get_region(;
                        config=config_file, profile="unknown", default
                    ) === default
                end
            end

            withenv(
                "AWS_REGION" => nothing,
                "AWS_DEFAULT_REGION" => nothing,
                "AWS_CONFIG_FILE" => config_file,
                "AWS_PROFILE" => "unknown",
            ) do
                apply(Patches._imds_region_patch(nothing)) do
                    @test aws_get_region(; default=default) === default
                end
            end
        end

        @testset "no such config file" begin
            withenv(
                "AWS_DEFAULT_REGION" => nothing,
                "AWS_REGION" => nothing,
                "AWS_CONFIG_FILE" => tempname(),
            ) do
                apply(Patches._imds_region_patch(nothing)) do
                    @test aws_get_region() == AWS.DEFAULT_REGION
                end
            end
        end

        @testset "instance profile" begin
            withenv(
                "AWS_DEFAULT_REGION" => nothing,
                "AWS_REGION" => nothing,
                "AWS_CONFIG_FILE" => tempname(),
            ) do
                apply(Patches._imds_region_patch("ap-atlantis-1")) do
                    @test aws_get_region() == "ap-atlantis-1"
                end
            end
        end
    end
end

"""
Generate the low-level `src/AWSServices.jl` file with all definitions.
"""
function _generate_low_level_wrappers(
    service_files::AbstractArray{ServiceFile}, auth::GitHub.Authorization
)
    service_definitions = sort!(_generate_low_level_definitions(service_files, auth))

    template = """
    # This file is auto-generated by AWSMetadata.jl

    module AWSServices

    using AWS
    using OrderedCollections: LittleDict

    $(join(service_definitions, "\n"))

    end
    """

    open(services_path, "w") do f
        print(f, template)
    end

    return template
end

"""
Get the low-level definitions for all AWS Services.
"""
function _generate_low_level_definitions(
    service_files::AbstractArray{ServiceFile}, auth::GitHub.Authorization
)
    low_level_defs = Vector{String}(undef, length(service_files))

    Threads.@threads for i in eachindex(service_files)
        service_file = service_files[i]
        service_name = service_file.name
        @info "Generating low level wrapper for $service_name"

        service = service_definition(service_file; auth=auth)
        service_metadata = service["metadata"]

        low_level_defs[i] = _generate_low_level_definition(service_metadata)
    end

    return low_level_defs
end

"""
Get the low-level definition for an AWS Service.
"""
function _generate_low_level_definition(service::AbstractDict)
    protocol = service["protocol"]
    endpoint_prefix = service["endpointPrefix"]
    signing_name =
        haskey(service, "signingName") ? service["signingName"] : service["endpointPrefix"]
    service_id = replace(lowercase(service["serviceId"]), ' ' => '_')
    api_version = service["apiVersion"]

    service_specifics = LittleDict{String,String}()

    if service_id == "glacier"
        service_specifics[service_id] = "LittleDict(\"x-amz-glacier-version\" => \"$(service["apiVersion"])\")"
    end

    if protocol == "rest-xml"
        return "const $service_id = AWS.RestXMLService(\"$signing_name\", \"$endpoint_prefix\", \"$api_version\")"
    elseif protocol in ("ec2", "query")
        return "const $service_id = AWS.QueryService(\"$signing_name\", \"$endpoint_prefix\", \"$api_version\")"
    elseif protocol == "rest-json" && haskey(service_specifics, service_id)
        return "const $service_id = AWS.RestJSONService(\"$signing_name\", \"$endpoint_prefix\", \"$api_version\", $(service_specifics[service_id]))"
    elseif protocol == "rest-json"
        return "const $service_id = AWS.RestJSONService(\"$signing_name\", \"$endpoint_prefix\", \"$api_version\")"
    elseif protocol == "json"
        json_version = service["jsonVersion"]
        target = service["targetPrefix"]
        return "const $service_id = AWS.JSONService(\"$signing_name\", \"$endpoint_prefix\", \"$api_version\", \"$json_version\", \"$target\")"
    else
        throw(
            ProtocolNotDefined(
                "$service_id is using a new protocol; $protocol which is not supported."
            ),
        )
    end
end

# This file is auto-generated by AWS.jl
using AWS
using AWS.AWSServices: kinesis_video_webrtc_storage
using AWS.Compat
using AWS.UUIDs

"""
    join_storage_session(channel_arn)
    join_storage_session(channel_arn, params::Dict{String,<:Any})

 Before using this API, you must call the GetSignalingChannelEndpoint API to request the
WEBRTC endpoint. You then specify the endpoint and region in your JoinStorageSession API
request.  Join the ongoing one way-video and/or multi-way audio WebRTC session as a video
producing device for an input channel. If there’s no existing session for the channel, a
new streaming session needs to be created, and the Amazon Resource Name (ARN) of the
signaling channel must be provided.  Currently for the SINGLE_MASTER type, a video
producing device is able to ingest both audio and video media into a stream. Only video
producing devices can join the session and record media.  Both audio and video tracks are
currently required for WebRTC ingestion. Current requirements:   Video track: H.264   Audio
track: Opus    The resulting ingested video in the Kinesis video stream will have the
following parameters: H.264 video and AAC audio. Once a master participant has negotiated a
connection through WebRTC, the ingested media session will be stored in the Kinesis video
stream. Multiple viewers are then able to play back real-time media through our Playback
APIs. You can also use existing Kinesis Video Streams features like HLS or DASH playback,
image generation via GetImages, and more with ingested WebRTC media.  S3 image delivery and
notifications are not currently supported.   Assume that only one video producing device
client can be associated with a session for the channel. If more than one client joins the
session of a specific channel as a video producing device, the most recent client request
takes precedence.    Additional information     Idempotent - This API is not idempotent.
Retry behavior - This is counted as a new API call.    Concurrent calls - Concurrent calls
are allowed. An offer is sent once per each call.

# Arguments
- `channel_arn`:  The Amazon Resource Name (ARN) of the signaling channel.

"""
function join_storage_session end

function join_storage_session(
    channelArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_video_webrtc_storage(
        "POST",
        "/joinStorageSession",
        Dict{String,Any}("channelArn" => channelArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function join_storage_session(
    channelArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_video_webrtc_storage(
        "POST",
        "/joinStorageSession",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("channelArn" => channelArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    join_storage_session_as_viewer(channel_arn, client_id)
    join_storage_session_as_viewer(channel_arn, client_id, params::Dict{String,<:Any})

 Join the ongoing one way-video and/or multi-way audio WebRTC session as a viewer for an
input channel. If there’s no existing session for the channel, create a new streaming
session and provide the Amazon Resource Name (ARN) of the signaling channel (channelArn)
and client id (clientId).  Currently for SINGLE_MASTER type, a video producing device is
able to ingest both audio and video media into a stream, while viewers can only ingest
audio. Both a video producing device and viewers can join a session first and wait for
other participants. While participants are having peer to peer conversations through
WebRTC, the ingested media session will be stored into the Kinesis Video Stream. Multiple
viewers are able to playback real-time media.  Customers can also use existing Kinesis
Video Streams features like HLS or DASH playback, Image generation, and more with ingested
WebRTC media. If there’s an existing session with the same clientId that's found in the
join session request, the new request takes precedence.

# Arguments
- `channel_arn`:  The Amazon Resource Name (ARN) of the signaling channel.
- `client_id`:  The unique identifier for the sender client.

"""
function join_storage_session_as_viewer end

function join_storage_session_as_viewer(
    channelArn, clientId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_video_webrtc_storage(
        "POST",
        "/joinStorageSessionAsViewer",
        Dict{String,Any}("channelArn" => channelArn, "clientId" => clientId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function join_storage_session_as_viewer(
    channelArn,
    clientId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_video_webrtc_storage(
        "POST",
        "/joinStorageSessionAsViewer",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("channelArn" => channelArn, "clientId" => clientId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: ssm_contacts
using AWS.Compat
using AWS.UUIDs

"""
    accept_page(accept_code, accept_type, page_id)
    accept_page(accept_code, accept_type, page_id, params::Dict{String,<:Any})

Used to acknowledge an engagement to a contact channel during an incident.

# Arguments
- `accept_code`: A 6-digit code used to acknowledge the page.
- `accept_type`: The type indicates if the page was DELIVERED or READ.
- `page_id`: The Amazon Resource Name (ARN) of the engagement to a contact channel.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptCodeValidation"`: An optional field that Incident Manager uses to ENFORCE
  AcceptCode validation when acknowledging an page. Acknowledgement can occur by replying to
  a page, or when entering the AcceptCode in the console. Enforcing AcceptCode validation
  causes Incident Manager to verify that the code entered by the user matches the code sent
  by Incident Manager with the page. Incident Manager can also IGNORE AcceptCode validation.
  Ignoring AcceptCode validation causes Incident Manager to accept any value entered for the
  AcceptCode.
- `"ContactChannelId"`: The ARN of the contact channel.
- `"Note"`: Information provided by the user when the user acknowledges the page.
"""
function accept_page(
    AcceptCode, AcceptType, PageId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_contacts(
        "AcceptPage",
        Dict{String,Any}(
            "AcceptCode" => AcceptCode, "AcceptType" => AcceptType, "PageId" => PageId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function accept_page(
    AcceptCode,
    AcceptType,
    PageId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_contacts(
        "AcceptPage",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AcceptCode" => AcceptCode,
                    "AcceptType" => AcceptType,
                    "PageId" => PageId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    activate_contact_channel(activation_code, contact_channel_id)
    activate_contact_channel(activation_code, contact_channel_id, params::Dict{String,<:Any})

Activates a contact's contact channel. Incident Manager can't engage a contact until the
contact channel has been activated.

# Arguments
- `activation_code`: The code sent to the contact channel when it was created in the
  contact.
- `contact_channel_id`: The Amazon Resource Name (ARN) of the contact channel.

"""
function activate_contact_channel(
    ActivationCode, ContactChannelId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_contacts(
        "ActivateContactChannel",
        Dict{String,Any}(
            "ActivationCode" => ActivationCode, "ContactChannelId" => ContactChannelId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function activate_contact_channel(
    ActivationCode,
    ContactChannelId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_contacts(
        "ActivateContactChannel",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ActivationCode" => ActivationCode,
                    "ContactChannelId" => ContactChannelId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_contact(alias, plan, type)
    create_contact(alias, plan, type, params::Dict{String,<:Any})

Contacts are either the contacts that Incident Manager engages during an incident or the
escalation plans that Incident Manager uses to engage contacts in phases during an incident.

# Arguments
- `alias`: The short name to quickly identify a contact or escalation plan. The contact
  alias must be unique and identifiable.
- `plan`: A list of stages. A contact has an engagement plan with stages that contact
  specified contact channels. An escalation plan uses stages that contact specified contacts.
- `type`: To create an escalation plan use ESCALATION. To create a contact use PERSONAL.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DisplayName"`: The full name of the contact or escalation plan.
- `"IdempotencyToken"`: A token ensuring that the operation is called only once with the
  specified details.
- `"Tags"`: Adds a tag to the target. You can only tag resources created in the first
  Region of your replication set.
"""
function create_contact(
    Alias, Plan, Type; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_contacts(
        "CreateContact",
        Dict{String,Any}(
            "Alias" => Alias,
            "Plan" => Plan,
            "Type" => Type,
            "IdempotencyToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_contact(
    Alias,
    Plan,
    Type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_contacts(
        "CreateContact",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Alias" => Alias,
                    "Plan" => Plan,
                    "Type" => Type,
                    "IdempotencyToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_contact_channel(contact_id, delivery_address, name, type)
    create_contact_channel(contact_id, delivery_address, name, type, params::Dict{String,<:Any})

A contact channel is the method that Incident Manager uses to engage your contact.

# Arguments
- `contact_id`: The Amazon Resource Name (ARN) of the contact you are adding the contact
  channel to.
- `delivery_address`: The details that Incident Manager uses when trying to engage the
  contact channel. The format is dependent on the type of the contact channel. The following
  are the expected formats:   SMS - '+' followed by the country code and phone number   VOICE
  - '+' followed by the country code and phone number   EMAIL - any standard email format
- `name`: The name of the contact channel.
- `type`: Incident Manager supports three types of contact channels:    SMS     VOICE
  EMAIL

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DeferActivation"`: If you want to activate the channel at a later time, you can choose
  to defer activation. Incident Manager can't engage your contact channel until it has been
  activated.
- `"IdempotencyToken"`: A token ensuring that the operation is called only once with the
  specified details.
"""
function create_contact_channel(
    ContactId,
    DeliveryAddress,
    Name,
    Type;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_contacts(
        "CreateContactChannel",
        Dict{String,Any}(
            "ContactId" => ContactId,
            "DeliveryAddress" => DeliveryAddress,
            "Name" => Name,
            "Type" => Type,
            "IdempotencyToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_contact_channel(
    ContactId,
    DeliveryAddress,
    Name,
    Type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_contacts(
        "CreateContactChannel",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ContactId" => ContactId,
                    "DeliveryAddress" => DeliveryAddress,
                    "Name" => Name,
                    "Type" => Type,
                    "IdempotencyToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_rotation(contact_ids, name, recurrence, time_zone_id)
    create_rotation(contact_ids, name, recurrence, time_zone_id, params::Dict{String,<:Any})

Creates a rotation in an on-call schedule.

# Arguments
- `contact_ids`: The Amazon Resource Names (ARNs) of the contacts to add to the rotation.
  The order that you list the contacts in is their shift order in the rotation schedule. To
  change the order of the contact's shifts, use the UpdateRotation operation.
- `name`: The name of the rotation.
- `recurrence`: Information about the rule that specifies when a shift's team members
  rotate.
- `time_zone_id`: The time zone to base the rotation’s activity on in Internet Assigned
  Numbers Authority (IANA) format. For example: \"America/Los_Angeles\", \"UTC\", or
  \"Asia/Seoul\". For more information, see the Time Zone Database on the IANA website.
  Designators for time zones that don’t support Daylight Savings Time rules, such as
  Pacific Standard Time (PST) and Pacific Daylight Time (PDT), are not supported.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"IdempotencyToken"`: A token that ensures that the operation is called only once with
  the specified details.
- `"StartTime"`: The date and time that the rotation goes into effect.
- `"Tags"`: Optional metadata to assign to the rotation. Tags enable you to categorize a
  resource in different ways, such as by purpose, owner, or environment. For more
  information, see Tagging Incident Manager resources in the Incident Manager User Guide.
"""
function create_rotation(
    ContactIds,
    Name,
    Recurrence,
    TimeZoneId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_contacts(
        "CreateRotation",
        Dict{String,Any}(
            "ContactIds" => ContactIds,
            "Name" => Name,
            "Recurrence" => Recurrence,
            "TimeZoneId" => TimeZoneId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_rotation(
    ContactIds,
    Name,
    Recurrence,
    TimeZoneId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_contacts(
        "CreateRotation",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ContactIds" => ContactIds,
                    "Name" => Name,
                    "Recurrence" => Recurrence,
                    "TimeZoneId" => TimeZoneId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_rotation_override(end_time, new_contact_ids, rotation_id, start_time)
    create_rotation_override(end_time, new_contact_ids, rotation_id, start_time, params::Dict{String,<:Any})

Creates an override for a rotation in an on-call schedule.

# Arguments
- `end_time`: The date and time when the override ends.
- `new_contact_ids`: The Amazon Resource Names (ARNs) of the contacts to replace those in
  the current on-call rotation with. If you want to include any current team members in the
  override shift, you must include their ARNs in the new contact ID list.
- `rotation_id`: The Amazon Resource Name (ARN) of the rotation to create an override for.
- `start_time`: The date and time when the override goes into effect.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"IdempotencyToken"`: A token that ensures that the operation is called only once with
  the specified details.
"""
function create_rotation_override(
    EndTime,
    NewContactIds,
    RotationId,
    StartTime;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_contacts(
        "CreateRotationOverride",
        Dict{String,Any}(
            "EndTime" => EndTime,
            "NewContactIds" => NewContactIds,
            "RotationId" => RotationId,
            "StartTime" => StartTime,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_rotation_override(
    EndTime,
    NewContactIds,
    RotationId,
    StartTime,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_contacts(
        "CreateRotationOverride",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EndTime" => EndTime,
                    "NewContactIds" => NewContactIds,
                    "RotationId" => RotationId,
                    "StartTime" => StartTime,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    deactivate_contact_channel(contact_channel_id)
    deactivate_contact_channel(contact_channel_id, params::Dict{String,<:Any})

To no longer receive Incident Manager engagements to a contact channel, you can deactivate
the channel.

# Arguments
- `contact_channel_id`: The Amazon Resource Name (ARN) of the contact channel you're
  deactivating.

"""
function deactivate_contact_channel(
    ContactChannelId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_contacts(
        "DeactivateContactChannel",
        Dict{String,Any}("ContactChannelId" => ContactChannelId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function deactivate_contact_channel(
    ContactChannelId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_contacts(
        "DeactivateContactChannel",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ContactChannelId" => ContactChannelId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_contact(contact_id)
    delete_contact(contact_id, params::Dict{String,<:Any})

To remove a contact from Incident Manager, you can delete the contact. Deleting a contact
removes them from all escalation plans and related response plans. Deleting an escalation
plan removes it from all related response plans. You will have to recreate the contact and
its contact channels before you can use it again.

# Arguments
- `contact_id`: The Amazon Resource Name (ARN) of the contact that you're deleting.

"""
function delete_contact(ContactId; aws_config::AbstractAWSConfig=current_aws_config())
    return ssm_contacts(
        "DeleteContact",
        Dict{String,Any}("ContactId" => ContactId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_contact(
    ContactId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_contacts(
        "DeleteContact",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ContactId" => ContactId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_contact_channel(contact_channel_id)
    delete_contact_channel(contact_channel_id, params::Dict{String,<:Any})

To no longer receive engagements on a contact channel, you can delete the channel from a
contact. Deleting the contact channel removes it from the contact's engagement plan. If you
delete the only contact channel for a contact, you won't be able to engage that contact
during an incident.

# Arguments
- `contact_channel_id`: The Amazon Resource Name (ARN) of the contact channel.

"""
function delete_contact_channel(
    ContactChannelId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_contacts(
        "DeleteContactChannel",
        Dict{String,Any}("ContactChannelId" => ContactChannelId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_contact_channel(
    ContactChannelId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_contacts(
        "DeleteContactChannel",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ContactChannelId" => ContactChannelId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_rotation(rotation_id)
    delete_rotation(rotation_id, params::Dict{String,<:Any})

Deletes a rotation from the system. If a rotation belongs to more than one on-call
schedule, this operation deletes it from all of them.

# Arguments
- `rotation_id`: The Amazon Resource Name (ARN) of the on-call rotation to delete.

"""
function delete_rotation(RotationId; aws_config::AbstractAWSConfig=current_aws_config())
    return ssm_contacts(
        "DeleteRotation",
        Dict{String,Any}("RotationId" => RotationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_rotation(
    RotationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_contacts(
        "DeleteRotation",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("RotationId" => RotationId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_rotation_override(rotation_id, rotation_override_id)
    delete_rotation_override(rotation_id, rotation_override_id, params::Dict{String,<:Any})

Deletes an existing override for an on-call rotation.

# Arguments
- `rotation_id`: The Amazon Resource Name (ARN) of the rotation that was overridden.
- `rotation_override_id`: The Amazon Resource Name (ARN) of the on-call rotation override
  to delete.

"""
function delete_rotation_override(
    RotationId, RotationOverrideId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_contacts(
        "DeleteRotationOverride",
        Dict{String,Any}(
            "RotationId" => RotationId, "RotationOverrideId" => RotationOverrideId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_rotation_override(
    RotationId,
    RotationOverrideId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_contacts(
        "DeleteRotationOverride",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "RotationId" => RotationId, "RotationOverrideId" => RotationOverrideId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_engagement(engagement_id)
    describe_engagement(engagement_id, params::Dict{String,<:Any})

Incident Manager uses engagements to engage contacts and escalation plans during an
incident. Use this command to describe the engagement that occurred during an incident.

# Arguments
- `engagement_id`: The Amazon Resource Name (ARN) of the engagement you want the details of.

"""
function describe_engagement(
    EngagementId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_contacts(
        "DescribeEngagement",
        Dict{String,Any}("EngagementId" => EngagementId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_engagement(
    EngagementId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_contacts(
        "DescribeEngagement",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("EngagementId" => EngagementId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_page(page_id)
    describe_page(page_id, params::Dict{String,<:Any})

Lists details of the engagement to a contact channel.

# Arguments
- `page_id`: The ID of the engagement to a contact channel.

"""
function describe_page(PageId; aws_config::AbstractAWSConfig=current_aws_config())
    return ssm_contacts(
        "DescribePage",
        Dict{String,Any}("PageId" => PageId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_page(
    PageId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_contacts(
        "DescribePage",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("PageId" => PageId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_contact(contact_id)
    get_contact(contact_id, params::Dict{String,<:Any})

Retrieves information about the specified contact or escalation plan.

# Arguments
- `contact_id`: The Amazon Resource Name (ARN) of the contact or escalation plan.

"""
function get_contact(ContactId; aws_config::AbstractAWSConfig=current_aws_config())
    return ssm_contacts(
        "GetContact",
        Dict{String,Any}("ContactId" => ContactId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_contact(
    ContactId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_contacts(
        "GetContact",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ContactId" => ContactId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_contact_channel(contact_channel_id)
    get_contact_channel(contact_channel_id, params::Dict{String,<:Any})

List details about a specific contact channel.

# Arguments
- `contact_channel_id`: The Amazon Resource Name (ARN) of the contact channel you want
  information about.

"""
function get_contact_channel(
    ContactChannelId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_contacts(
        "GetContactChannel",
        Dict{String,Any}("ContactChannelId" => ContactChannelId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_contact_channel(
    ContactChannelId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_contacts(
        "GetContactChannel",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ContactChannelId" => ContactChannelId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_contact_policy(contact_arn)
    get_contact_policy(contact_arn, params::Dict{String,<:Any})

Retrieves the resource policies attached to the specified contact or escalation plan.

# Arguments
- `contact_arn`: The Amazon Resource Name (ARN) of the contact or escalation plan.

"""
function get_contact_policy(ContactArn; aws_config::AbstractAWSConfig=current_aws_config())
    return ssm_contacts(
        "GetContactPolicy",
        Dict{String,Any}("ContactArn" => ContactArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_contact_policy(
    ContactArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_contacts(
        "GetContactPolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ContactArn" => ContactArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_rotation(rotation_id)
    get_rotation(rotation_id, params::Dict{String,<:Any})

Retrieves information about an on-call rotation.

# Arguments
- `rotation_id`: The Amazon Resource Name (ARN) of the on-call rotation to retrieve
  information about.

"""
function get_rotation(RotationId; aws_config::AbstractAWSConfig=current_aws_config())
    return ssm_contacts(
        "GetRotation",
        Dict{String,Any}("RotationId" => RotationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_rotation(
    RotationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_contacts(
        "GetRotation",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("RotationId" => RotationId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_rotation_override(rotation_id, rotation_override_id)
    get_rotation_override(rotation_id, rotation_override_id, params::Dict{String,<:Any})

Retrieves information about an override to an on-call rotation.

# Arguments
- `rotation_id`: The Amazon Resource Name (ARN) of the overridden rotation to retrieve
  information about.
- `rotation_override_id`: The Amazon Resource Name (ARN) of the on-call rotation override
  to retrieve information about.

"""
function get_rotation_override(
    RotationId, RotationOverrideId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_contacts(
        "GetRotationOverride",
        Dict{String,Any}(
            "RotationId" => RotationId, "RotationOverrideId" => RotationOverrideId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_rotation_override(
    RotationId,
    RotationOverrideId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_contacts(
        "GetRotationOverride",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "RotationId" => RotationId, "RotationOverrideId" => RotationOverrideId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_contact_channels(contact_id)
    list_contact_channels(contact_id, params::Dict{String,<:Any})

Lists all contact channels for the specified contact.

# Arguments
- `contact_id`: The Amazon Resource Name (ARN) of the contact.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of contact channels per page.
- `"NextToken"`: The pagination token to continue to the next page of results.
"""
function list_contact_channels(
    ContactId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_contacts(
        "ListContactChannels",
        Dict{String,Any}("ContactId" => ContactId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_contact_channels(
    ContactId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_contacts(
        "ListContactChannels",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ContactId" => ContactId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_contacts()
    list_contacts(params::Dict{String,<:Any})

Lists all contacts and escalation plans in Incident Manager.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AliasPrefix"`: Used to list only contacts who's aliases start with the specified prefix.
- `"MaxResults"`: The maximum number of contacts and escalation plans per page of results.
- `"NextToken"`: The pagination token to continue to the next page of results.
- `"Type"`: The type of contact. A contact is type PERSONAL and an escalation plan is type
  ESCALATION.
"""
function list_contacts(; aws_config::AbstractAWSConfig=current_aws_config())
    return ssm_contacts(
        "ListContacts"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_contacts(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_contacts(
        "ListContacts", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_engagements()
    list_engagements(params::Dict{String,<:Any})

Lists all engagements that have happened in an incident.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"IncidentId"`: The Amazon Resource Name (ARN) of the incident you're listing engagements
  for.
- `"MaxResults"`: The maximum number of engagements per page of results.
- `"NextToken"`: The pagination token to continue to the next page of results.
- `"TimeRangeValue"`: The time range to lists engagements for an incident.
"""
function list_engagements(; aws_config::AbstractAWSConfig=current_aws_config())
    return ssm_contacts(
        "ListEngagements"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_engagements(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_contacts(
        "ListEngagements", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_page_receipts(page_id)
    list_page_receipts(page_id, params::Dict{String,<:Any})

Lists all of the engagements to contact channels that have been acknowledged.

# Arguments
- `page_id`: The Amazon Resource Name (ARN) of the engagement to a specific contact channel.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of acknowledgements per page of results.
- `"NextToken"`: The pagination token to continue to the next page of results.
"""
function list_page_receipts(PageId; aws_config::AbstractAWSConfig=current_aws_config())
    return ssm_contacts(
        "ListPageReceipts",
        Dict{String,Any}("PageId" => PageId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_page_receipts(
    PageId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_contacts(
        "ListPageReceipts",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("PageId" => PageId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_page_resolutions(page_id)
    list_page_resolutions(page_id, params::Dict{String,<:Any})

Returns the resolution path of an engagement. For example, the escalation plan engaged in
an incident might target an on-call schedule that includes several contacts in a rotation,
but just one contact on-call when the incident starts. The resolution path indicates the
hierarchy of escalation plan &gt; on-call schedule &gt; contact.

# Arguments
- `page_id`: The Amazon Resource Name (ARN) of the contact engaged for the incident.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: A token to start the list. Use this token to get the next set of results.
"""
function list_page_resolutions(PageId; aws_config::AbstractAWSConfig=current_aws_config())
    return ssm_contacts(
        "ListPageResolutions",
        Dict{String,Any}("PageId" => PageId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_page_resolutions(
    PageId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_contacts(
        "ListPageResolutions",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("PageId" => PageId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_pages_by_contact(contact_id)
    list_pages_by_contact(contact_id, params::Dict{String,<:Any})

Lists the engagements to a contact's contact channels.

# Arguments
- `contact_id`: The Amazon Resource Name (ARN) of the contact you are retrieving
  engagements for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of engagements to contact channels to list per page of
  results.
- `"NextToken"`: The pagination token to continue to the next page of results.
"""
function list_pages_by_contact(
    ContactId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_contacts(
        "ListPagesByContact",
        Dict{String,Any}("ContactId" => ContactId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_pages_by_contact(
    ContactId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_contacts(
        "ListPagesByContact",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ContactId" => ContactId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_pages_by_engagement(engagement_id)
    list_pages_by_engagement(engagement_id, params::Dict{String,<:Any})

Lists the engagements to contact channels that occurred by engaging a contact.

# Arguments
- `engagement_id`: The Amazon Resource Name (ARN) of the engagement.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of engagements to contact channels to list per page of
  results.
- `"NextToken"`: The pagination token to continue to the next page of results.
"""
function list_pages_by_engagement(
    EngagementId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_contacts(
        "ListPagesByEngagement",
        Dict{String,Any}("EngagementId" => EngagementId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_pages_by_engagement(
    EngagementId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_contacts(
        "ListPagesByEngagement",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("EngagementId" => EngagementId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_preview_rotation_shifts(end_time, members, recurrence, time_zone_id)
    list_preview_rotation_shifts(end_time, members, recurrence, time_zone_id, params::Dict{String,<:Any})

Returns a list of shifts based on rotation configuration parameters.  The Incident Manager
primarily uses this operation to populate the Preview calendar. It is not typically run by
end users.

# Arguments
- `end_time`: The date and time a rotation shift would end.
- `members`: The contacts that would be assigned to a rotation.
- `recurrence`: Information about how long a rotation would last before restarting at the
  beginning of the shift order.
- `time_zone_id`: The time zone the rotation’s activity would be based on, in Internet
  Assigned Numbers Authority (IANA) format. For example: \"America/Los_Angeles\", \"UTC\", or
  \"Asia/Seoul\".

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of items to return for this call. The call also
  returns a token that can be specified in a subsequent call to get the next set of results.
- `"NextToken"`: A token to start the list. This token is used to get the next set of
  results.
- `"Overrides"`: Information about changes that would be made in a rotation override.
- `"RotationStartTime"`: The date and time a rotation would begin. The first shift is
  calculated from this date and time.
- `"StartTime"`: Used to filter the range of calculated shifts before sending the response
  back to the user.
"""
function list_preview_rotation_shifts(
    EndTime,
    Members,
    Recurrence,
    TimeZoneId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_contacts(
        "ListPreviewRotationShifts",
        Dict{String,Any}(
            "EndTime" => EndTime,
            "Members" => Members,
            "Recurrence" => Recurrence,
            "TimeZoneId" => TimeZoneId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_preview_rotation_shifts(
    EndTime,
    Members,
    Recurrence,
    TimeZoneId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_contacts(
        "ListPreviewRotationShifts",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EndTime" => EndTime,
                    "Members" => Members,
                    "Recurrence" => Recurrence,
                    "TimeZoneId" => TimeZoneId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_rotation_overrides(end_time, rotation_id, start_time)
    list_rotation_overrides(end_time, rotation_id, start_time, params::Dict{String,<:Any})

Retrieves a list of overrides currently specified for an on-call rotation.

# Arguments
- `end_time`: The date and time for the end of a time range for listing overrides.
- `rotation_id`: The Amazon Resource Name (ARN) of the rotation to retrieve information
  about.
- `start_time`: The date and time for the beginning of a time range for listing overrides.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of items to return for this call. The call also
  returns a token that you can specify in a subsequent call to get the next set of results.
- `"NextToken"`: A token to start the list. Use this token to get the next set of results.
"""
function list_rotation_overrides(
    EndTime, RotationId, StartTime; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_contacts(
        "ListRotationOverrides",
        Dict{String,Any}(
            "EndTime" => EndTime, "RotationId" => RotationId, "StartTime" => StartTime
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_rotation_overrides(
    EndTime,
    RotationId,
    StartTime,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_contacts(
        "ListRotationOverrides",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EndTime" => EndTime,
                    "RotationId" => RotationId,
                    "StartTime" => StartTime,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_rotation_shifts(end_time, rotation_id)
    list_rotation_shifts(end_time, rotation_id, params::Dict{String,<:Any})

Returns a list of shifts generated by an existing rotation in the system.

# Arguments
- `end_time`: The date and time for the end of the time range to list shifts for.
- `rotation_id`: The Amazon Resource Name (ARN) of the rotation to retrieve shift
  information about.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of items to return for this call. The call also
  returns a token that you can specify in a subsequent call to get the next set of results.
- `"NextToken"`: A token to start the list. Use this token to get the next set of results.
- `"StartTime"`: The date and time for the beginning of the time range to list shifts for.
"""
function list_rotation_shifts(
    EndTime, RotationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_contacts(
        "ListRotationShifts",
        Dict{String,Any}("EndTime" => EndTime, "RotationId" => RotationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_rotation_shifts(
    EndTime,
    RotationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_contacts(
        "ListRotationShifts",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("EndTime" => EndTime, "RotationId" => RotationId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_rotations()
    list_rotations(params::Dict{String,<:Any})

Retrieves a list of on-call rotations.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of items to return for this call. The call also
  returns a token that you can specify in a subsequent call to get the next set of results.
- `"NextToken"`: A token to start the list. Use this token to get the next set of results.
- `"RotationNamePrefix"`: A filter to include rotations in list results based on their
  common prefix. For example, entering prod returns a list of all rotation names that begin
  with prod, such as production and prod-1.
"""
function list_rotations(; aws_config::AbstractAWSConfig=current_aws_config())
    return ssm_contacts(
        "ListRotations"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_rotations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_contacts(
        "ListRotations", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists the tags of an escalation plan or contact.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the contact or escalation plan.

"""
function list_tags_for_resource(
    ResourceARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_contacts(
        "ListTagsForResource",
        Dict{String,Any}("ResourceARN" => ResourceARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_contacts(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceARN" => ResourceARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_contact_policy(contact_arn, policy)
    put_contact_policy(contact_arn, policy, params::Dict{String,<:Any})

Adds a resource policy to the specified contact or escalation plan. The resource policy is
used to share the contact or escalation plan using Resource Access Manager (RAM). For more
information about cross-account sharing, see Setting up cross-account functionality.

# Arguments
- `contact_arn`: The Amazon Resource Name (ARN) of the contact or escalation plan.
- `policy`: Details of the resource policy.

"""
function put_contact_policy(
    ContactArn, Policy; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_contacts(
        "PutContactPolicy",
        Dict{String,Any}("ContactArn" => ContactArn, "Policy" => Policy);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_contact_policy(
    ContactArn,
    Policy,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_contacts(
        "PutContactPolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ContactArn" => ContactArn, "Policy" => Policy),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    send_activation_code(contact_channel_id)
    send_activation_code(contact_channel_id, params::Dict{String,<:Any})

Sends an activation code to a contact channel. The contact can use this code to activate
the contact channel in the console or with the ActivateChannel operation. Incident Manager
can't engage a contact channel until it has been activated.

# Arguments
- `contact_channel_id`: The Amazon Resource Name (ARN) of the contact channel.

"""
function send_activation_code(
    ContactChannelId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_contacts(
        "SendActivationCode",
        Dict{String,Any}("ContactChannelId" => ContactChannelId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function send_activation_code(
    ContactChannelId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_contacts(
        "SendActivationCode",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ContactChannelId" => ContactChannelId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_engagement(contact_id, content, sender, subject)
    start_engagement(contact_id, content, sender, subject, params::Dict{String,<:Any})

Starts an engagement to a contact or escalation plan. The engagement engages each contact
specified in the incident.

# Arguments
- `contact_id`: The Amazon Resource Name (ARN) of the contact being engaged.
- `content`: The secure content of the message that was sent to the contact. Use this field
  for engagements to VOICE or EMAIL.
- `sender`: The user that started the engagement.
- `subject`: The secure subject of the message that was sent to the contact. Use this field
  for engagements to VOICE or EMAIL.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"IdempotencyToken"`: A token ensuring that the operation is called only once with the
  specified details.
- `"IncidentId"`: The ARN of the incident that the engagement is part of.
- `"PublicContent"`: The insecure content of the message that was sent to the contact. Use
  this field for engagements to SMS.
- `"PublicSubject"`: The insecure subject of the message that was sent to the contact. Use
  this field for engagements to SMS.
"""
function start_engagement(
    ContactId, Content, Sender, Subject; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_contacts(
        "StartEngagement",
        Dict{String,Any}(
            "ContactId" => ContactId,
            "Content" => Content,
            "Sender" => Sender,
            "Subject" => Subject,
            "IdempotencyToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_engagement(
    ContactId,
    Content,
    Sender,
    Subject,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_contacts(
        "StartEngagement",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ContactId" => ContactId,
                    "Content" => Content,
                    "Sender" => Sender,
                    "Subject" => Subject,
                    "IdempotencyToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_engagement(engagement_id)
    stop_engagement(engagement_id, params::Dict{String,<:Any})

Stops an engagement before it finishes the final stage of the escalation plan or engagement
plan. Further contacts aren't engaged.

# Arguments
- `engagement_id`: The Amazon Resource Name (ARN) of the engagement.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Reason"`: The reason that you're stopping the engagement.
"""
function stop_engagement(EngagementId; aws_config::AbstractAWSConfig=current_aws_config())
    return ssm_contacts(
        "StopEngagement",
        Dict{String,Any}("EngagementId" => EngagementId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_engagement(
    EngagementId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_contacts(
        "StopEngagement",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("EngagementId" => EngagementId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Tags a contact or escalation plan. You can tag only contacts and escalation plans in the
first region of your replication set.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the contact or escalation plan.
- `tags`: A list of tags that you are adding to the contact or escalation plan.

"""
function tag_resource(ResourceARN, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return ssm_contacts(
        "TagResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceARN,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_contacts(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes tags from the specified resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the contact or escalation plan.
- `tag_keys`: The key of the tag that you want to remove.

"""
function untag_resource(
    ResourceARN, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_contacts(
        "UntagResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceARN,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_contacts(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_contact(contact_id)
    update_contact(contact_id, params::Dict{String,<:Any})

Updates the contact or escalation plan specified.

# Arguments
- `contact_id`: The Amazon Resource Name (ARN) of the contact or escalation plan you're
  updating.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DisplayName"`: The full name of the contact or escalation plan.
- `"Plan"`: A list of stages. A contact has an engagement plan with stages for specified
  contact channels. An escalation plan uses these stages to contact specified contacts.
"""
function update_contact(ContactId; aws_config::AbstractAWSConfig=current_aws_config())
    return ssm_contacts(
        "UpdateContact",
        Dict{String,Any}("ContactId" => ContactId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_contact(
    ContactId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_contacts(
        "UpdateContact",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ContactId" => ContactId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_contact_channel(contact_channel_id)
    update_contact_channel(contact_channel_id, params::Dict{String,<:Any})

Updates a contact's contact channel.

# Arguments
- `contact_channel_id`: The Amazon Resource Name (ARN) of the contact channel you want to
  update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DeliveryAddress"`: The details that Incident Manager uses when trying to engage the
  contact channel.
- `"Name"`: The name of the contact channel.
"""
function update_contact_channel(
    ContactChannelId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_contacts(
        "UpdateContactChannel",
        Dict{String,Any}("ContactChannelId" => ContactChannelId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_contact_channel(
    ContactChannelId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_contacts(
        "UpdateContactChannel",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ContactChannelId" => ContactChannelId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_rotation(recurrence, rotation_id)
    update_rotation(recurrence, rotation_id, params::Dict{String,<:Any})

Updates the information specified for an on-call rotation.

# Arguments
- `recurrence`: Information about how long the updated rotation lasts before restarting at
  the beginning of the shift order.
- `rotation_id`: The Amazon Resource Name (ARN) of the rotation to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ContactIds"`: The Amazon Resource Names (ARNs) of the contacts to include in the
  updated rotation.  The order in which you list the contacts is their shift order in the
  rotation schedule.
- `"StartTime"`: The date and time the rotation goes into effect.
- `"TimeZoneId"`: The time zone to base the updated rotation’s activity on, in Internet
  Assigned Numbers Authority (IANA) format. For example: \"America/Los_Angeles\", \"UTC\", or
  \"Asia/Seoul\". For more information, see the Time Zone Database on the IANA website.
  Designators for time zones that don’t support Daylight Savings Time Rules, such as
  Pacific Standard Time (PST) and Pacific Daylight Time (PDT), aren't supported.
"""
function update_rotation(
    Recurrence, RotationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_contacts(
        "UpdateRotation",
        Dict{String,Any}("Recurrence" => Recurrence, "RotationId" => RotationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_rotation(
    Recurrence,
    RotationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_contacts(
        "UpdateRotation",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Recurrence" => Recurrence, "RotationId" => RotationId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: route53_recovery_readiness
using AWS.Compat
using AWS.UUIDs

"""
    create_cell(cell_name)
    create_cell(cell_name, params::Dict{String,<:Any})

Creates a cell in an account.

# Arguments
- `cell_name`: The name of the cell to create.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"cells"`: A list of cell Amazon Resource Names (ARNs) contained within this cell, for
  use in nested cells. For example, Availability Zones within specific Amazon Web Services
  Regions.
- `"tags"`:
"""
function create_cell(cellName; aws_config::AbstractAWSConfig=current_aws_config())
    return route53_recovery_readiness(
        "POST",
        "/cells",
        Dict{String,Any}("cellName" => cellName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_cell(
    cellName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53_recovery_readiness(
        "POST",
        "/cells",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("cellName" => cellName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_cross_account_authorization(cross_account_authorization)
    create_cross_account_authorization(cross_account_authorization, params::Dict{String,<:Any})

Creates a cross-account readiness authorization. This lets you authorize another account to
work with Route 53 Application Recovery Controller, for example, to check the readiness
status of resources in a separate account.

# Arguments
- `cross_account_authorization`: The cross-account authorization.

"""
function create_cross_account_authorization(
    crossAccountAuthorization; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53_recovery_readiness(
        "POST",
        "/crossaccountauthorizations",
        Dict{String,Any}("crossAccountAuthorization" => crossAccountAuthorization);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_cross_account_authorization(
    crossAccountAuthorization,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53_recovery_readiness(
        "POST",
        "/crossaccountauthorizations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("crossAccountAuthorization" => crossAccountAuthorization),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_readiness_check(readiness_check_name, resource_set_name)
    create_readiness_check(readiness_check_name, resource_set_name, params::Dict{String,<:Any})

Creates a readiness check in an account. A readiness check monitors a resource set in your
application, such as a set of Amazon Aurora instances, that Application Recovery Controller
is auditing recovery readiness for. The audits run once every minute on every resource
that's associated with a readiness check.

# Arguments
- `readiness_check_name`: The name of the readiness check to create.
- `resource_set_name`: The name of the resource set to check.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tags"`:
"""
function create_readiness_check(
    readinessCheckName, resourceSetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53_recovery_readiness(
        "POST",
        "/readinesschecks",
        Dict{String,Any}(
            "readinessCheckName" => readinessCheckName, "resourceSetName" => resourceSetName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_readiness_check(
    readinessCheckName,
    resourceSetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53_recovery_readiness(
        "POST",
        "/readinesschecks",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "readinessCheckName" => readinessCheckName,
                    "resourceSetName" => resourceSetName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_recovery_group(recovery_group_name)
    create_recovery_group(recovery_group_name, params::Dict{String,<:Any})

Creates a recovery group in an account. A recovery group corresponds to an application and
includes a list of the cells that make up the application.

# Arguments
- `recovery_group_name`: The name of the recovery group to create.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"cells"`: A list of the cell Amazon Resource Names (ARNs) in the recovery group.
- `"tags"`:
"""
function create_recovery_group(
    recoveryGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53_recovery_readiness(
        "POST",
        "/recoverygroups",
        Dict{String,Any}("recoveryGroupName" => recoveryGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_recovery_group(
    recoveryGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53_recovery_readiness(
        "POST",
        "/recoverygroups",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("recoveryGroupName" => recoveryGroupName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_resource_set(resource_set_name, resource_set_type, resources)
    create_resource_set(resource_set_name, resource_set_type, resources, params::Dict{String,<:Any})

Creates a resource set. A resource set is a set of resources of one type that span multiple
cells. You can associate a resource set with a readiness check to monitor the resources for
failover readiness.

# Arguments
- `resource_set_name`: The name of the resource set to create.
- `resource_set_type`: The resource type of the resources in the resource set. Enter one of
  the following values for resource type: AWS::ApiGateway::Stage, AWS::ApiGatewayV2::Stage,
  AWS::AutoScaling::AutoScalingGroup, AWS::CloudWatch::Alarm, AWS::EC2::CustomerGateway,
  AWS::DynamoDB::Table, AWS::EC2::Volume, AWS::ElasticLoadBalancing::LoadBalancer,
  AWS::ElasticLoadBalancingV2::LoadBalancer, AWS::Lambda::Function, AWS::MSK::Cluster,
  AWS::RDS::DBCluster, AWS::Route53::HealthCheck, AWS::SQS::Queue, AWS::SNS::Topic,
  AWS::SNS::Subscription, AWS::EC2::VPC, AWS::EC2::VPNConnection, AWS::EC2::VPNGateway,
  AWS::Route53RecoveryReadiness::DNSTargetResource
- `resources`: A list of resource objects in the resource set.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tags"`: A tag to associate with the parameters for a resource set.
"""
function create_resource_set(
    resourceSetName,
    resourceSetType,
    resources;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53_recovery_readiness(
        "POST",
        "/resourcesets",
        Dict{String,Any}(
            "resourceSetName" => resourceSetName,
            "resourceSetType" => resourceSetType,
            "resources" => resources,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_resource_set(
    resourceSetName,
    resourceSetType,
    resources,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53_recovery_readiness(
        "POST",
        "/resourcesets",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "resourceSetName" => resourceSetName,
                    "resourceSetType" => resourceSetType,
                    "resources" => resources,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_cell(cell_name)
    delete_cell(cell_name, params::Dict{String,<:Any})

Delete a cell. When successful, the response code is 204, with no response body.

# Arguments
- `cell_name`: The name of the cell.

"""
function delete_cell(cellName; aws_config::AbstractAWSConfig=current_aws_config())
    return route53_recovery_readiness(
        "DELETE",
        "/cells/$(cellName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_cell(
    cellName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53_recovery_readiness(
        "DELETE",
        "/cells/$(cellName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_cross_account_authorization(cross_account_authorization)
    delete_cross_account_authorization(cross_account_authorization, params::Dict{String,<:Any})

Deletes cross account readiness authorization.

# Arguments
- `cross_account_authorization`: The cross-account authorization.

"""
function delete_cross_account_authorization(
    crossAccountAuthorization; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53_recovery_readiness(
        "DELETE",
        "/crossaccountauthorizations/$(crossAccountAuthorization)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_cross_account_authorization(
    crossAccountAuthorization,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53_recovery_readiness(
        "DELETE",
        "/crossaccountauthorizations/$(crossAccountAuthorization)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_readiness_check(readiness_check_name)
    delete_readiness_check(readiness_check_name, params::Dict{String,<:Any})

Deletes a readiness check.

# Arguments
- `readiness_check_name`: Name of a readiness check.

"""
function delete_readiness_check(
    readinessCheckName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53_recovery_readiness(
        "DELETE",
        "/readinesschecks/$(readinessCheckName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_readiness_check(
    readinessCheckName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53_recovery_readiness(
        "DELETE",
        "/readinesschecks/$(readinessCheckName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_recovery_group(recovery_group_name)
    delete_recovery_group(recovery_group_name, params::Dict{String,<:Any})

Deletes a recovery group.

# Arguments
- `recovery_group_name`: The name of a recovery group.

"""
function delete_recovery_group(
    recoveryGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53_recovery_readiness(
        "DELETE",
        "/recoverygroups/$(recoveryGroupName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_recovery_group(
    recoveryGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53_recovery_readiness(
        "DELETE",
        "/recoverygroups/$(recoveryGroupName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_resource_set(resource_set_name)
    delete_resource_set(resource_set_name, params::Dict{String,<:Any})

Deletes a resource set.

# Arguments
- `resource_set_name`: Name of a resource set.

"""
function delete_resource_set(
    resourceSetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53_recovery_readiness(
        "DELETE",
        "/resourcesets/$(resourceSetName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_resource_set(
    resourceSetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53_recovery_readiness(
        "DELETE",
        "/resourcesets/$(resourceSetName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_architecture_recommendations(recovery_group_name)
    get_architecture_recommendations(recovery_group_name, params::Dict{String,<:Any})

Gets recommendations about architecture designs for improving resiliency for an
application, based on a recovery group.

# Arguments
- `recovery_group_name`: The name of a recovery group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The number of objects that you want to return with this call.
- `"nextToken"`: The token that identifies which batch of results you want to see.
"""
function get_architecture_recommendations(
    recoveryGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53_recovery_readiness(
        "GET",
        "/recoverygroups/$(recoveryGroupName)/architectureRecommendations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_architecture_recommendations(
    recoveryGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53_recovery_readiness(
        "GET",
        "/recoverygroups/$(recoveryGroupName)/architectureRecommendations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_cell(cell_name)
    get_cell(cell_name, params::Dict{String,<:Any})

Gets information about a cell including cell name, cell Amazon Resource Name (ARN), ARNs of
nested cells for this cell, and a list of those cell ARNs with their associated recovery
group ARNs.

# Arguments
- `cell_name`: The name of the cell.

"""
function get_cell(cellName; aws_config::AbstractAWSConfig=current_aws_config())
    return route53_recovery_readiness(
        "GET", "/cells/$(cellName)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_cell(
    cellName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53_recovery_readiness(
        "GET",
        "/cells/$(cellName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_cell_readiness_summary(cell_name)
    get_cell_readiness_summary(cell_name, params::Dict{String,<:Any})

Gets readiness for a cell. Aggregates the readiness of all the resources that are
associated with the cell into a single value.

# Arguments
- `cell_name`: The name of the cell.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The number of objects that you want to return with this call.
- `"nextToken"`: The token that identifies which batch of results you want to see.
"""
function get_cell_readiness_summary(
    cellName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53_recovery_readiness(
        "GET",
        "/cellreadiness/$(cellName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_cell_readiness_summary(
    cellName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53_recovery_readiness(
        "GET",
        "/cellreadiness/$(cellName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_readiness_check(readiness_check_name)
    get_readiness_check(readiness_check_name, params::Dict{String,<:Any})

Gets details about a readiness check.

# Arguments
- `readiness_check_name`: Name of a readiness check.

"""
function get_readiness_check(
    readinessCheckName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53_recovery_readiness(
        "GET",
        "/readinesschecks/$(readinessCheckName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_readiness_check(
    readinessCheckName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53_recovery_readiness(
        "GET",
        "/readinesschecks/$(readinessCheckName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_readiness_check_resource_status(readiness_check_name, resource_identifier)
    get_readiness_check_resource_status(readiness_check_name, resource_identifier, params::Dict{String,<:Any})

Gets individual readiness status for a readiness check. To see the overall readiness status
for a recovery group, that considers the readiness status for all the readiness checks in
the recovery group, use GetRecoveryGroupReadinessSummary.

# Arguments
- `readiness_check_name`: Name of a readiness check.
- `resource_identifier`: The resource identifier, which is the Amazon Resource Name (ARN)
  or the identifier generated for the resource by Application Recovery Controller (for
  example, for a DNS target resource).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The number of objects that you want to return with this call.
- `"nextToken"`: The token that identifies which batch of results you want to see.
"""
function get_readiness_check_resource_status(
    readinessCheckName,
    resourceIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53_recovery_readiness(
        "GET",
        "/readinesschecks/$(readinessCheckName)/resource/$(resourceIdentifier)/status";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_readiness_check_resource_status(
    readinessCheckName,
    resourceIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53_recovery_readiness(
        "GET",
        "/readinesschecks/$(readinessCheckName)/resource/$(resourceIdentifier)/status",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_readiness_check_status(readiness_check_name)
    get_readiness_check_status(readiness_check_name, params::Dict{String,<:Any})

Gets the readiness status for an individual readiness check. To see the overall readiness
status for a recovery group, that considers the readiness status for all the readiness
checks in a recovery group, use GetRecoveryGroupReadinessSummary.

# Arguments
- `readiness_check_name`: Name of a readiness check.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The number of objects that you want to return with this call.
- `"nextToken"`: The token that identifies which batch of results you want to see.
"""
function get_readiness_check_status(
    readinessCheckName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53_recovery_readiness(
        "GET",
        "/readinesschecks/$(readinessCheckName)/status";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_readiness_check_status(
    readinessCheckName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53_recovery_readiness(
        "GET",
        "/readinesschecks/$(readinessCheckName)/status",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_recovery_group(recovery_group_name)
    get_recovery_group(recovery_group_name, params::Dict{String,<:Any})

Gets details about a recovery group, including a list of the cells that are included in it.

# Arguments
- `recovery_group_name`: The name of a recovery group.

"""
function get_recovery_group(
    recoveryGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53_recovery_readiness(
        "GET",
        "/recoverygroups/$(recoveryGroupName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_recovery_group(
    recoveryGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53_recovery_readiness(
        "GET",
        "/recoverygroups/$(recoveryGroupName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_recovery_group_readiness_summary(recovery_group_name)
    get_recovery_group_readiness_summary(recovery_group_name, params::Dict{String,<:Any})

Displays a summary of information about a recovery group's readiness status. Includes the
readiness checks for resources in the recovery group and the readiness status of each one.

# Arguments
- `recovery_group_name`: The name of a recovery group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The number of objects that you want to return with this call.
- `"nextToken"`: The token that identifies which batch of results you want to see.
"""
function get_recovery_group_readiness_summary(
    recoveryGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53_recovery_readiness(
        "GET",
        "/recoverygroupreadiness/$(recoveryGroupName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_recovery_group_readiness_summary(
    recoveryGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53_recovery_readiness(
        "GET",
        "/recoverygroupreadiness/$(recoveryGroupName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_resource_set(resource_set_name)
    get_resource_set(resource_set_name, params::Dict{String,<:Any})

Displays the details about a resource set, including a list of the resources in the set.

# Arguments
- `resource_set_name`: Name of a resource set.

"""
function get_resource_set(
    resourceSetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53_recovery_readiness(
        "GET",
        "/resourcesets/$(resourceSetName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_resource_set(
    resourceSetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53_recovery_readiness(
        "GET",
        "/resourcesets/$(resourceSetName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_cells()
    list_cells(params::Dict{String,<:Any})

Lists the cells for an account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The number of objects that you want to return with this call.
- `"nextToken"`: The token that identifies which batch of results you want to see.
"""
function list_cells(; aws_config::AbstractAWSConfig=current_aws_config())
    return route53_recovery_readiness(
        "GET", "/cells"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_cells(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53_recovery_readiness(
        "GET", "/cells", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_cross_account_authorizations()
    list_cross_account_authorizations(params::Dict{String,<:Any})

Lists the cross-account readiness authorizations that are in place for an account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The number of objects that you want to return with this call.
- `"nextToken"`: The token that identifies which batch of results you want to see.
"""
function list_cross_account_authorizations(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53_recovery_readiness(
        "GET",
        "/crossaccountauthorizations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_cross_account_authorizations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53_recovery_readiness(
        "GET",
        "/crossaccountauthorizations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_readiness_checks()
    list_readiness_checks(params::Dict{String,<:Any})

Lists the readiness checks for an account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The number of objects that you want to return with this call.
- `"nextToken"`: The token that identifies which batch of results you want to see.
"""
function list_readiness_checks(; aws_config::AbstractAWSConfig=current_aws_config())
    return route53_recovery_readiness(
        "GET", "/readinesschecks"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_readiness_checks(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53_recovery_readiness(
        "GET",
        "/readinesschecks",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_recovery_groups()
    list_recovery_groups(params::Dict{String,<:Any})

Lists the recovery groups in an account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The number of objects that you want to return with this call.
- `"nextToken"`: The token that identifies which batch of results you want to see.
"""
function list_recovery_groups(; aws_config::AbstractAWSConfig=current_aws_config())
    return route53_recovery_readiness(
        "GET", "/recoverygroups"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_recovery_groups(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53_recovery_readiness(
        "GET",
        "/recoverygroups",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_resource_sets()
    list_resource_sets(params::Dict{String,<:Any})

Lists the resource sets in an account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The number of objects that you want to return with this call.
- `"nextToken"`: The token that identifies which batch of results you want to see.
"""
function list_resource_sets(; aws_config::AbstractAWSConfig=current_aws_config())
    return route53_recovery_readiness(
        "GET", "/resourcesets"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_resource_sets(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53_recovery_readiness(
        "GET",
        "/resourcesets",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_rules()
    list_rules(params::Dict{String,<:Any})

Lists all readiness rules, or lists the readiness rules for a specific resource type.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The number of objects that you want to return with this call.
- `"nextToken"`: The token that identifies which batch of results you want to see.
- `"resourceType"`: The resource type that a readiness rule applies to.
"""
function list_rules(; aws_config::AbstractAWSConfig=current_aws_config())
    return route53_recovery_readiness(
        "GET", "/rules"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_rules(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53_recovery_readiness(
        "GET", "/rules", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resources(resource-arn)
    list_tags_for_resources(resource-arn, params::Dict{String,<:Any})

Lists the tags for a resource.

# Arguments
- `resource-arn`: The Amazon Resource Name (ARN) for a resource.

"""
function list_tags_for_resources(
    resource_arn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53_recovery_readiness(
        "GET",
        "/tags/$(resource-arn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resources(
    resource_arn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53_recovery_readiness(
        "GET",
        "/tags/$(resource-arn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource-arn, tags)
    tag_resource(resource-arn, tags, params::Dict{String,<:Any})

Adds a tag to a resource.

# Arguments
- `resource-arn`: The Amazon Resource Name (ARN) for a resource.
- `tags`:

"""
function tag_resource(
    resource_arn, tags; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53_recovery_readiness(
        "POST",
        "/tags/$(resource-arn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resource_arn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53_recovery_readiness(
        "POST",
        "/tags/$(resource-arn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource-arn, tag_keys)
    untag_resource(resource-arn, tag_keys, params::Dict{String,<:Any})

Removes a tag from a resource.

# Arguments
- `resource-arn`: The Amazon Resource Name (ARN) for a resource.
- `tag_keys`: The keys for tags you add to resources.

"""
function untag_resource(
    resource_arn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53_recovery_readiness(
        "DELETE",
        "/tags/$(resource-arn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resource_arn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53_recovery_readiness(
        "DELETE",
        "/tags/$(resource-arn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_cell(cell_name, cells)
    update_cell(cell_name, cells, params::Dict{String,<:Any})

Updates a cell to replace the list of nested cells with a new list of nested cells.

# Arguments
- `cell_name`: The name of the cell.
- `cells`: A list of cell Amazon Resource Names (ARNs), which completely replaces the
  previous list.

"""
function update_cell(cellName, cells; aws_config::AbstractAWSConfig=current_aws_config())
    return route53_recovery_readiness(
        "PUT",
        "/cells/$(cellName)",
        Dict{String,Any}("cells" => cells);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_cell(
    cellName,
    cells,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53_recovery_readiness(
        "PUT",
        "/cells/$(cellName)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("cells" => cells), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_readiness_check(readiness_check_name, resource_set_name)
    update_readiness_check(readiness_check_name, resource_set_name, params::Dict{String,<:Any})

Updates a readiness check.

# Arguments
- `readiness_check_name`: Name of a readiness check.
- `resource_set_name`: The name of the resource set to be checked.

"""
function update_readiness_check(
    readinessCheckName, resourceSetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53_recovery_readiness(
        "PUT",
        "/readinesschecks/$(readinessCheckName)",
        Dict{String,Any}("resourceSetName" => resourceSetName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_readiness_check(
    readinessCheckName,
    resourceSetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53_recovery_readiness(
        "PUT",
        "/readinesschecks/$(readinessCheckName)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("resourceSetName" => resourceSetName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_recovery_group(cells, recovery_group_name)
    update_recovery_group(cells, recovery_group_name, params::Dict{String,<:Any})

Updates a recovery group.

# Arguments
- `cells`: A list of cell Amazon Resource Names (ARNs). This list completely replaces the
  previous list.
- `recovery_group_name`: The name of a recovery group.

"""
function update_recovery_group(
    cells, recoveryGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53_recovery_readiness(
        "PUT",
        "/recoverygroups/$(recoveryGroupName)",
        Dict{String,Any}("cells" => cells);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_recovery_group(
    cells,
    recoveryGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53_recovery_readiness(
        "PUT",
        "/recoverygroups/$(recoveryGroupName)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("cells" => cells), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_resource_set(resource_set_name, resource_set_type, resources)
    update_resource_set(resource_set_name, resource_set_type, resources, params::Dict{String,<:Any})

Updates a resource set.

# Arguments
- `resource_set_name`: Name of a resource set.
- `resource_set_type`: The resource type of the resources in the resource set. Enter one of
  the following values for resource type: AWS::ApiGateway::Stage, AWS::ApiGatewayV2::Stage,
  AWS::AutoScaling::AutoScalingGroup, AWS::CloudWatch::Alarm, AWS::EC2::CustomerGateway,
  AWS::DynamoDB::Table, AWS::EC2::Volume, AWS::ElasticLoadBalancing::LoadBalancer,
  AWS::ElasticLoadBalancingV2::LoadBalancer, AWS::Lambda::Function, AWS::MSK::Cluster,
  AWS::RDS::DBCluster, AWS::Route53::HealthCheck, AWS::SQS::Queue, AWS::SNS::Topic,
  AWS::SNS::Subscription, AWS::EC2::VPC, AWS::EC2::VPNConnection, AWS::EC2::VPNGateway,
  AWS::Route53RecoveryReadiness::DNSTargetResource
- `resources`: A list of resource objects.

"""
function update_resource_set(
    resourceSetName,
    resourceSetType,
    resources;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53_recovery_readiness(
        "PUT",
        "/resourcesets/$(resourceSetName)",
        Dict{String,Any}("resourceSetType" => resourceSetType, "resources" => resources);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_resource_set(
    resourceSetName,
    resourceSetType,
    resources,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53_recovery_readiness(
        "PUT",
        "/resourcesets/$(resourceSetName)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "resourceSetType" => resourceSetType, "resources" => resources
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: dynamodb
using AWS.Compat
using AWS.UUIDs

"""
    batch_execute_statement(statements)
    batch_execute_statement(statements, params::Dict{String,<:Any})

This operation allows you to perform batch reads or writes on data stored in DynamoDB,
using PartiQL. Each read statement in a BatchExecuteStatement must specify an equality
condition on all key attributes. This enforces that each SELECT statement in a batch
returns at most a single item.  The entire batch must consist of either read statements or
write statements, you cannot mix both in one batch.   A HTTP 200 response does not mean
that all statements in the BatchExecuteStatement succeeded. Error details for individual
statements can be found under the Error field of the BatchStatementResponse for each
statement.

# Arguments
- `statements`: The list of PartiQL statements representing the batch to run.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ReturnConsumedCapacity"`:
"""
function batch_execute_statement(
    Statements; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dynamodb(
        "BatchExecuteStatement",
        Dict{String,Any}("Statements" => Statements);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_execute_statement(
    Statements,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dynamodb(
        "BatchExecuteStatement",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Statements" => Statements), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_get_item(request_items)
    batch_get_item(request_items, params::Dict{String,<:Any})

The BatchGetItem operation returns the attributes of one or more items from one or more
tables. You identify requested items by primary key. A single operation can retrieve up to
16 MB of data, which can contain as many as 100 items. BatchGetItem returns a partial
result if the response size limit is exceeded, the table's provisioned throughput is
exceeded, more than 1MB per partition is requested, or an internal processing failure
occurs. If a partial result is returned, the operation returns a value for UnprocessedKeys.
You can use this value to retry the operation starting with the next item to get.  If you
request more than 100 items, BatchGetItem returns a ValidationException with the message
\"Too many items requested for the BatchGetItem call.\"  For example, if you ask to
retrieve 100 items, but each individual item is 300 KB in size, the system returns 52 items
(so as not to exceed the 16 MB limit). It also returns an appropriate UnprocessedKeys value
so you can get the next page of results. If desired, your application can include its own
logic to assemble the pages of results into one dataset. If none of the items can be
processed due to insufficient provisioned throughput on all of the tables in the request,
then BatchGetItem returns a ProvisionedThroughputExceededException. If at least one of the
items is successfully processed, then BatchGetItem completes successfully, while returning
the keys of the unread items in UnprocessedKeys.  If DynamoDB returns any unprocessed
items, you should retry the batch operation on those items. However, we strongly recommend
that you use an exponential backoff algorithm. If you retry the batch operation
immediately, the underlying read or write requests can still fail due to throttling on the
individual tables. If you delay the batch operation using exponential backoff, the
individual requests in the batch are much more likely to succeed. For more information, see
Batch Operations and Error Handling in the Amazon DynamoDB Developer Guide.  By default,
BatchGetItem performs eventually consistent reads on every table in the request. If you
want strongly consistent reads instead, you can set ConsistentRead to true for any or all
tables. In order to minimize response latency, BatchGetItem may retrieve items in parallel.
When designing your application, keep in mind that DynamoDB does not return items in any
particular order. To help parse the response by item, include the primary key values for
the items in your request in the ProjectionExpression parameter. If a requested item does
not exist, it is not returned in the result. Requests for nonexistent items consume the
minimum read capacity units according to the type of read. For more information, see
Working with Tables in the Amazon DynamoDB Developer Guide.

# Arguments
- `request_items`: A map of one or more table names or table ARNs and, for each table, a
  map that describes one or more items to retrieve from that table. Each table name or ARN
  can be used only once per BatchGetItem request. Each element in the map of items to
  retrieve consists of the following:    ConsistentRead - If true, a strongly consistent read
  is used; if false (the default), an eventually consistent read is used.
  ExpressionAttributeNames - One or more substitution tokens for attribute names in the
  ProjectionExpression parameter. The following are some use cases for using
  ExpressionAttributeNames:   To access an attribute whose name conflicts with a DynamoDB
  reserved word.   To create a placeholder for repeating occurrences of an attribute name in
  an expression.   To prevent special characters in an attribute name from being
  misinterpreted in an expression.   Use the # character in an expression to dereference an
  attribute name. For example, consider the following attribute name:    Percentile    The
  name of this attribute conflicts with a reserved word, so it cannot be used directly in an
  expression. (For the complete list of reserved words, see Reserved Words in the Amazon
  DynamoDB Developer Guide). To work around this, you could specify the following for
  ExpressionAttributeNames:    {\"#P\":\"Percentile\"}    You could then use this
  substitution in an expression, as in this example:    #P = :val     Tokens that begin with
  the : character are expression attribute values, which are placeholders for the actual
  value at runtime.  For more information about expression attribute names, see Accessing
  Item Attributes in the Amazon DynamoDB Developer Guide.    Keys - An array of primary key
  attribute values that define specific items in the table. For each primary key, you must
  provide all of the key attributes. For example, with a simple primary key, you only need to
  provide the partition key value. For a composite key, you must provide both the partition
  key value and the sort key value.    ProjectionExpression - A string that identifies one or
  more attributes to retrieve from the table. These attributes can include scalars, sets, or
  elements of a JSON document. The attributes in the expression must be separated by commas.
  If no attribute names are specified, then all attributes are returned. If any of the
  requested attributes are not found, they do not appear in the result. For more information,
  see Accessing Item Attributes in the Amazon DynamoDB Developer Guide.    AttributesToGet -
  This is a legacy parameter. Use ProjectionExpression instead. For more information, see
  AttributesToGet in the Amazon DynamoDB Developer Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ReturnConsumedCapacity"`:
"""
function batch_get_item(RequestItems; aws_config::AbstractAWSConfig=current_aws_config())
    return dynamodb(
        "BatchGetItem",
        Dict{String,Any}("RequestItems" => RequestItems);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_item(
    RequestItems,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dynamodb(
        "BatchGetItem",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("RequestItems" => RequestItems), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_write_item(request_items)
    batch_write_item(request_items, params::Dict{String,<:Any})

The BatchWriteItem operation puts or deletes multiple items in one or more tables. A single
call to BatchWriteItem can transmit up to 16MB of data over the network, consisting of up
to 25 item put or delete operations. While individual items can be up to 400 KB once
stored, it's important to note that an item's representation might be greater than 400KB
while being sent in DynamoDB's JSON format for the API call. For more details on this
distinction, see Naming Rules and Data Types.   BatchWriteItem cannot update items. If you
perform a BatchWriteItem operation on an existing item, that item's values will be
overwritten by the operation and it will appear like it was updated. To update items, we
recommend you use the UpdateItem action.  The individual PutItem and DeleteItem operations
specified in BatchWriteItem are atomic; however BatchWriteItem as a whole is not. If any
requested operations fail because the table's provisioned throughput is exceeded or an
internal processing failure occurs, the failed operations are returned in the
UnprocessedItems response parameter. You can investigate and optionally resend the
requests. Typically, you would call BatchWriteItem in a loop. Each iteration would check
for unprocessed items and submit a new BatchWriteItem request with those unprocessed items
until all items have been processed. If none of the items can be processed due to
insufficient provisioned throughput on all of the tables in the request, then
BatchWriteItem returns a ProvisionedThroughputExceededException.  If DynamoDB returns any
unprocessed items, you should retry the batch operation on those items. However, we
strongly recommend that you use an exponential backoff algorithm. If you retry the batch
operation immediately, the underlying read or write requests can still fail due to
throttling on the individual tables. If you delay the batch operation using exponential
backoff, the individual requests in the batch are much more likely to succeed. For more
information, see Batch Operations and Error Handling in the Amazon DynamoDB Developer
Guide.  With BatchWriteItem, you can efficiently write or delete large amounts of data,
such as from Amazon EMR, or copy data from another database into DynamoDB. In order to
improve performance with these large-scale operations, BatchWriteItem does not behave in
the same way as individual PutItem and DeleteItem calls would. For example, you cannot
specify conditions on individual put and delete requests, and BatchWriteItem does not
return deleted items in the response. If you use a programming language that supports
concurrency, you can use threads to write items in parallel. Your application must include
the necessary logic to manage the threads. With languages that don't support threading, you
must update or delete the specified items one at a time. In both situations, BatchWriteItem
performs the specified put and delete operations in parallel, giving you the power of the
thread pool approach without having to introduce complexity into your application. Parallel
processing reduces latency, but each specified put and delete request consumes the same
number of write capacity units whether it is processed in parallel or not. Delete
operations on nonexistent items consume one write capacity unit. If one or more of the
following is true, DynamoDB rejects the entire batch write operation:   One or more tables
specified in the BatchWriteItem request does not exist.   Primary key attributes specified
on an item in the request do not match those in the corresponding table's primary key
schema.   You try to perform multiple operations on the same item in the same
BatchWriteItem request. For example, you cannot put and delete the same item in the same
BatchWriteItem request.     Your request contains at least two items with identical hash
and range keys (which essentially is two put operations).    There are more than 25
requests in the batch.   Any individual item in a batch exceeds 400 KB.   The total request
size exceeds 16 MB.   Any individual items with keys exceeding the key length limits. For a
partition key, the limit is 2048 bytes and for a sort key, the limit is 1024 bytes.

# Arguments
- `request_items`: A map of one or more table names or table ARNs and, for each table, a
  list of operations to be performed (DeleteRequest or PutRequest). Each element in the map
  consists of the following:    DeleteRequest - Perform a DeleteItem operation on the
  specified item. The item to be deleted is identified by a Key subelement:    Key - A map of
  primary key attribute values that uniquely identify the item. Each entry in this map
  consists of an attribute name and an attribute value. For each primary key, you must
  provide all of the key attributes. For example, with a simple primary key, you only need to
  provide a value for the partition key. For a composite primary key, you must provide values
  for both the partition key and the sort key.      PutRequest - Perform a PutItem operation
  on the specified item. The item to be put is identified by an Item subelement:    Item - A
  map of attributes and their values. Each entry in this map consists of an attribute name
  and an attribute value. Attribute values must not be null; string and binary type
  attributes must have lengths greater than zero; and set type attributes must not be empty.
  Requests that contain empty values are rejected with a ValidationException exception. If
  you specify any attributes that are part of an index key, then the data types for those
  attributes must match those of the schema in the table's attribute definition.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ReturnConsumedCapacity"`:
- `"ReturnItemCollectionMetrics"`: Determines whether item collection metrics are returned.
  If set to SIZE, the response includes statistics about item collections, if any, that were
  modified during the operation are returned in the response. If set to NONE (the default),
  no statistics are returned.
"""
function batch_write_item(RequestItems; aws_config::AbstractAWSConfig=current_aws_config())
    return dynamodb(
        "BatchWriteItem",
        Dict{String,Any}("RequestItems" => RequestItems);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_write_item(
    RequestItems,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dynamodb(
        "BatchWriteItem",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("RequestItems" => RequestItems), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_backup(backup_name, table_name)
    create_backup(backup_name, table_name, params::Dict{String,<:Any})

Creates a backup for an existing table.  Each time you create an on-demand backup, the
entire table data is backed up. There is no limit to the number of on-demand backups that
can be taken.   When you create an on-demand backup, a time marker of the request is
cataloged, and the backup is created asynchronously, by applying all changes until the time
of the request to the last full table snapshot. Backup requests are processed
instantaneously and become available for restore within minutes.  You can call CreateBackup
at a maximum rate of 50 times per second. All backups in DynamoDB work without consuming
any provisioned throughput on the table.  If you submit a backup request on 2018-12-14 at
14:25:00, the backup is guaranteed to contain all data committed to the table up to
14:24:00, and data committed after 14:26:00 will not be. The backup might contain data
modifications made between 14:24:00 and 14:26:00. On-demand backup does not support causal
consistency.   Along with data, the following are also included on the backups:    Global
secondary indexes (GSIs)   Local secondary indexes (LSIs)   Streams   Provisioned read and
write capacity

# Arguments
- `backup_name`: Specified name for the backup.
- `table_name`: The name of the table. You can also provide the Amazon Resource Name (ARN)
  of the table in this parameter.

"""
function create_backup(
    BackupName, TableName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dynamodb(
        "CreateBackup",
        Dict{String,Any}("BackupName" => BackupName, "TableName" => TableName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_backup(
    BackupName,
    TableName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dynamodb(
        "CreateBackup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("BackupName" => BackupName, "TableName" => TableName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_global_table(global_table_name, replication_group)
    create_global_table(global_table_name, replication_group, params::Dict{String,<:Any})

Creates a global table from an existing table. A global table creates a replication
relationship between two or more DynamoDB tables with the same table name in the provided
Regions.   This documentation is for version 2017.11.29 (Legacy) of global tables, which
should be avoided for new global tables. Customers should use Global Tables version
2019.11.21 (Current) when possible, because it provides greater flexibility, higher
efficiency, and consumes less write capacity than 2017.11.29 (Legacy). To determine which
version you're using, see Determining the global table version you are using. To update
existing global tables from version 2017.11.29 (Legacy) to version 2019.11.21 (Current),
see Upgrading global tables.  If you want to add a new replica table to a global table,
each of the following conditions must be true:   The table must have the same primary key
as all of the other replicas.   The table must have the same name as all of the other
replicas.   The table must have DynamoDB Streams enabled, with the stream containing both
the new and the old images of the item.   None of the replica tables in the global table
can contain any data.    If global secondary indexes are specified, then the following
conditions must also be met:     The global secondary indexes must have the same name.
The global secondary indexes must have the same hash key and sort key (if present).     If
local secondary indexes are specified, then the following conditions must also be met:
The local secondary indexes must have the same name.     The local secondary indexes must
have the same hash key and sort key (if present).      Write capacity settings should be
set consistently across your replica tables and secondary indexes. DynamoDB strongly
recommends enabling auto scaling to manage the write capacity settings for all of your
global tables replicas and indexes.   If you prefer to manage write capacity settings
manually, you should provision equal replicated write capacity units to your replica
tables. You should also provision equal replicated write capacity units to matching
secondary indexes across your global table.

# Arguments
- `global_table_name`: The global table name.
- `replication_group`: The Regions where the global table needs to be created.

"""
function create_global_table(
    GlobalTableName, ReplicationGroup; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dynamodb(
        "CreateGlobalTable",
        Dict{String,Any}(
            "GlobalTableName" => GlobalTableName, "ReplicationGroup" => ReplicationGroup
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_global_table(
    GlobalTableName,
    ReplicationGroup,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dynamodb(
        "CreateGlobalTable",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "GlobalTableName" => GlobalTableName,
                    "ReplicationGroup" => ReplicationGroup,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_table(attribute_definitions, key_schema, table_name)
    create_table(attribute_definitions, key_schema, table_name, params::Dict{String,<:Any})

The CreateTable operation adds a new table to your account. In an Amazon Web Services
account, table names must be unique within each Region. That is, you can have two tables
with same name if you create the tables in different Regions.  CreateTable is an
asynchronous operation. Upon receiving a CreateTable request, DynamoDB immediately returns
a response with a TableStatus of CREATING. After the table is created, DynamoDB sets the
TableStatus to ACTIVE. You can perform read and write operations only on an ACTIVE table.
You can optionally define secondary indexes on the new table, as part of the CreateTable
operation. If you want to create multiple tables with secondary indexes on them, you must
create the tables sequentially. Only one table with secondary indexes can be in the
CREATING state at any given time. You can use the DescribeTable action to check the table
status.

# Arguments
- `attribute_definitions`: An array of attributes that describe the key schema for the
  table and indexes.
- `key_schema`: Specifies the attributes that make up the primary key for a table or an
  index. The attributes in KeySchema must also be defined in the AttributeDefinitions array.
  For more information, see Data Model in the Amazon DynamoDB Developer Guide. Each
  KeySchemaElement in the array is composed of:    AttributeName - The name of this key
  attribute.    KeyType - The role that the key attribute will assume:    HASH - partition
  key    RANGE - sort key      The partition key of an item is also known as its hash
  attribute. The term \"hash attribute\" derives from the DynamoDB usage of an internal hash
  function to evenly distribute data items across partitions, based on their partition key
  values. The sort key of an item is also known as its range attribute. The term \"range
  attribute\" derives from the way DynamoDB stores items with the same partition key
  physically close together, in sorted order by the sort key value.  For a simple primary key
  (partition key), you must provide exactly one element with a KeyType of HASH. For a
  composite primary key (partition key and sort key), you must provide exactly two elements,
  in this order: The first element must have a KeyType of HASH, and the second element must
  have a KeyType of RANGE. For more information, see Working with Tables in the Amazon
  DynamoDB Developer Guide.
- `table_name`: The name of the table to create. You can also provide the Amazon Resource
  Name (ARN) of the table in this parameter.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"BillingMode"`: Controls how you are charged for read and write throughput and how you
  manage capacity. This setting can be changed later.    PROVISIONED - We recommend using
  PROVISIONED for predictable workloads. PROVISIONED sets the billing mode to Provisioned
  capacity mode.    PAY_PER_REQUEST - We recommend using PAY_PER_REQUEST for unpredictable
  workloads. PAY_PER_REQUEST sets the billing mode to On-demand capacity mode.
- `"DeletionProtectionEnabled"`: Indicates whether deletion protection is to be enabled
  (true) or disabled (false) on the table.
- `"GlobalSecondaryIndexes"`: One or more global secondary indexes (the maximum is 20) to
  be created on the table. Each global secondary index in the array includes the following:
   IndexName - The name of the global secondary index. Must be unique only for this table.
   KeySchema - Specifies the key schema for the global secondary index.    Projection -
  Specifies attributes that are copied (projected) from the table into the index. These are
  in addition to the primary key attributes and index key attributes, which are automatically
  projected. Each attribute specification is composed of:    ProjectionType - One of the
  following:    KEYS_ONLY - Only the index and primary keys are projected into the index.
  INCLUDE - Only the specified table attributes are projected into the index. The list of
  projected attributes is in NonKeyAttributes.    ALL - All of the table attributes are
  projected into the index.      NonKeyAttributes - A list of one or more non-key attribute
  names that are projected into the secondary index. The total count of attributes provided
  in NonKeyAttributes, summed across all of the secondary indexes, must not exceed 100. If
  you project the same attribute into two different indexes, this counts as two distinct
  attributes when determining the total.      ProvisionedThroughput - The provisioned
  throughput settings for the global secondary index, consisting of read and write capacity
  units.
- `"LocalSecondaryIndexes"`: One or more local secondary indexes (the maximum is 5) to be
  created on the table. Each index is scoped to a given partition key value. There is a 10 GB
  size limit per partition key value; otherwise, the size of a local secondary index is
  unconstrained. Each local secondary index in the array includes the following:    IndexName
  - The name of the local secondary index. Must be unique only for this table.     KeySchema
  - Specifies the key schema for the local secondary index. The key schema must begin with
  the same partition key as the table.    Projection - Specifies attributes that are copied
  (projected) from the table into the index. These are in addition to the primary key
  attributes and index key attributes, which are automatically projected. Each attribute
  specification is composed of:    ProjectionType - One of the following:    KEYS_ONLY - Only
  the index and primary keys are projected into the index.    INCLUDE - Only the specified
  table attributes are projected into the index. The list of projected attributes is in
  NonKeyAttributes.    ALL - All of the table attributes are projected into the index.
  NonKeyAttributes - A list of one or more non-key attribute names that are projected into
  the secondary index. The total count of attributes provided in NonKeyAttributes, summed
  across all of the secondary indexes, must not exceed 100. If you project the same attribute
  into two different indexes, this counts as two distinct attributes when determining the
  total.
- `"OnDemandThroughput"`: Sets the maximum number of read and write units for the specified
  table in on-demand capacity mode. If you use this parameter, you must specify
  MaxReadRequestUnits, MaxWriteRequestUnits, or both.
- `"ProvisionedThroughput"`: Represents the provisioned throughput settings for a specified
  table or index. The settings can be modified using the UpdateTable operation.  If you set
  BillingMode as PROVISIONED, you must specify this property. If you set BillingMode as
  PAY_PER_REQUEST, you cannot specify this property. For current minimum and maximum
  provisioned throughput values, see Service, Account, and Table Quotas in the Amazon
  DynamoDB Developer Guide.
- `"ResourcePolicy"`: An Amazon Web Services resource-based policy document in JSON format
  that will be attached to the table. When you attach a resource-based policy while creating
  a table, the policy application is strongly consistent. The maximum size supported for a
  resource-based policy document is 20 KB. DynamoDB counts whitespaces when calculating the
  size of a policy against this limit. For a full list of all considerations that apply for
  resource-based policies, see Resource-based policy considerations.  You need to specify the
  CreateTable and PutResourcePolicy IAM actions for authorizing a user to create a table with
  a resource-based policy.
- `"SSESpecification"`: Represents the settings used to enable server-side encryption.
- `"StreamSpecification"`: The settings for DynamoDB Streams on the table. These settings
  consist of:    StreamEnabled - Indicates whether DynamoDB Streams is to be enabled (true)
  or disabled (false).    StreamViewType - When an item in the table is modified,
  StreamViewType determines what information is written to the table's stream. Valid values
  for StreamViewType are:    KEYS_ONLY - Only the key attributes of the modified item are
  written to the stream.    NEW_IMAGE - The entire item, as it appears after it was modified,
  is written to the stream.    OLD_IMAGE - The entire item, as it appeared before it was
  modified, is written to the stream.    NEW_AND_OLD_IMAGES - Both the new and the old item
  images of the item are written to the stream.
- `"TableClass"`: The table class of the new table. Valid values are STANDARD and
  STANDARD_INFREQUENT_ACCESS.
- `"Tags"`: A list of key-value pairs to label the table. For more information, see Tagging
  for DynamoDB.
"""
function create_table(
    AttributeDefinitions,
    KeySchema,
    TableName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dynamodb(
        "CreateTable",
        Dict{String,Any}(
            "AttributeDefinitions" => AttributeDefinitions,
            "KeySchema" => KeySchema,
            "TableName" => TableName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_table(
    AttributeDefinitions,
    KeySchema,
    TableName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dynamodb(
        "CreateTable",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AttributeDefinitions" => AttributeDefinitions,
                    "KeySchema" => KeySchema,
                    "TableName" => TableName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_backup(backup_arn)
    delete_backup(backup_arn, params::Dict{String,<:Any})

Deletes an existing backup of a table. You can call DeleteBackup at a maximum rate of 10
times per second.

# Arguments
- `backup_arn`: The ARN associated with the backup.

"""
function delete_backup(BackupArn; aws_config::AbstractAWSConfig=current_aws_config())
    return dynamodb(
        "DeleteBackup",
        Dict{String,Any}("BackupArn" => BackupArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_backup(
    BackupArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dynamodb(
        "DeleteBackup",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("BackupArn" => BackupArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_item(key, table_name)
    delete_item(key, table_name, params::Dict{String,<:Any})

Deletes a single item in a table by primary key. You can perform a conditional delete
operation that deletes the item if it exists, or if it has an expected attribute value. In
addition to deleting an item, you can also return the item's attribute values in the same
operation, using the ReturnValues parameter. Unless you specify conditions, the DeleteItem
is an idempotent operation; running it multiple times on the same item or attribute does
not result in an error response. Conditional deletes are useful for deleting items only if
specific conditions are met. If those conditions are met, DynamoDB performs the delete.
Otherwise, the item is not deleted.

# Arguments
- `key`: A map of attribute names to AttributeValue objects, representing the primary key
  of the item to delete. For the primary key, you must provide all of the key attributes. For
  example, with a simple primary key, you only need to provide a value for the partition key.
  For a composite primary key, you must provide values for both the partition key and the
  sort key.
- `table_name`: The name of the table from which to delete the item. You can also provide
  the Amazon Resource Name (ARN) of the table in this parameter.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConditionExpression"`: A condition that must be satisfied in order for a conditional
  DeleteItem to succeed. An expression can contain any of the following:   Functions:
  attribute_exists | attribute_not_exists | attribute_type | contains | begins_with | size
  These function names are case-sensitive.   Comparison operators: = | &lt;&gt; | &lt; | &gt;
  | &lt;= | &gt;= | BETWEEN | IN      Logical operators: AND | OR | NOT    For more
  information about condition expressions, see Condition Expressions in the Amazon DynamoDB
  Developer Guide.
- `"ConditionalOperator"`: This is a legacy parameter. Use ConditionExpression instead. For
  more information, see ConditionalOperator in the Amazon DynamoDB Developer Guide.
- `"Expected"`: This is a legacy parameter. Use ConditionExpression instead. For more
  information, see Expected in the Amazon DynamoDB Developer Guide.
- `"ExpressionAttributeNames"`: One or more substitution tokens for attribute names in an
  expression. The following are some use cases for using ExpressionAttributeNames:   To
  access an attribute whose name conflicts with a DynamoDB reserved word.   To create a
  placeholder for repeating occurrences of an attribute name in an expression.   To prevent
  special characters in an attribute name from being misinterpreted in an expression.   Use
  the # character in an expression to dereference an attribute name. For example, consider
  the following attribute name:    Percentile    The name of this attribute conflicts with a
  reserved word, so it cannot be used directly in an expression. (For the complete list of
  reserved words, see Reserved Words in the Amazon DynamoDB Developer Guide). To work around
  this, you could specify the following for ExpressionAttributeNames:
  {\"#P\":\"Percentile\"}    You could then use this substitution in an expression, as in
  this example:    #P = :val     Tokens that begin with the : character are expression
  attribute values, which are placeholders for the actual value at runtime.  For more
  information on expression attribute names, see Specifying Item Attributes in the Amazon
  DynamoDB Developer Guide.
- `"ExpressionAttributeValues"`: One or more values that can be substituted in an
  expression. Use the : (colon) character in an expression to dereference an attribute value.
  For example, suppose that you wanted to check whether the value of the ProductStatus
  attribute was one of the following:   Available | Backordered | Discontinued  You would
  first need to specify ExpressionAttributeValues as follows:  {
  \":avail\":{\"S\":\"Available\"}, \":back\":{\"S\":\"Backordered\"},
  \":disc\":{\"S\":\"Discontinued\"} }  You could then use these values in an expression,
  such as this:  ProductStatus IN (:avail, :back, :disc)  For more information on expression
  attribute values, see Condition Expressions in the Amazon DynamoDB Developer Guide.
- `"ReturnConsumedCapacity"`:
- `"ReturnItemCollectionMetrics"`: Determines whether item collection metrics are returned.
  If set to SIZE, the response includes statistics about item collections, if any, that were
  modified during the operation are returned in the response. If set to NONE (the default),
  no statistics are returned.
- `"ReturnValues"`: Use ReturnValues if you want to get the item attributes as they
  appeared before they were deleted. For DeleteItem, the valid values are:    NONE - If
  ReturnValues is not specified, or if its value is NONE, then nothing is returned. (This
  setting is the default for ReturnValues.)    ALL_OLD - The content of the old item is
  returned.   There is no additional cost associated with requesting a return value aside
  from the small network and processing overhead of receiving a larger response. No read
  capacity units are consumed.  The ReturnValues parameter is used by several DynamoDB
  operations; however, DeleteItem does not recognize any values other than NONE or ALL_OLD.
- `"ReturnValuesOnConditionCheckFailure"`: An optional parameter that returns the item
  attributes for a DeleteItem operation that failed a condition check. There is no additional
  cost associated with requesting a return value aside from the small network and processing
  overhead of receiving a larger response. No read capacity units are consumed.
"""
function delete_item(Key, TableName; aws_config::AbstractAWSConfig=current_aws_config())
    return dynamodb(
        "DeleteItem",
        Dict{String,Any}("Key" => Key, "TableName" => TableName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_item(
    Key,
    TableName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dynamodb(
        "DeleteItem",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("Key" => Key, "TableName" => TableName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_resource_policy(resource_arn)
    delete_resource_policy(resource_arn, params::Dict{String,<:Any})

Deletes the resource-based policy attached to the resource, which can be a table or stream.
 DeleteResourcePolicy is an idempotent operation; running it multiple times on the same
resource doesn't result in an error response, unless you specify an ExpectedRevisionId,
which will then return a PolicyNotFoundException.  To make sure that you don't
inadvertently lock yourself out of your own resources, the root principal in your Amazon
Web Services account can perform DeleteResourcePolicy requests, even if your resource-based
policy explicitly denies the root principal's access.     DeleteResourcePolicy is an
asynchronous operation. If you issue a GetResourcePolicy request immediately after running
the DeleteResourcePolicy request, DynamoDB might still return the deleted policy. This is
because the policy for your resource might not have been deleted yet. Wait for a few
seconds, and then try the GetResourcePolicy request again.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the DynamoDB resource from which the
  policy will be removed. The resources you can specify include tables and streams. If you
  remove the policy of a table, it will also remove the permissions for the table's indexes
  defined in that policy document. This is because index permissions are defined in the
  table's policy.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ExpectedRevisionId"`: A string value that you can use to conditionally delete your
  policy. When you provide an expected revision ID, if the revision ID of the existing policy
  on the resource doesn't match or if there's no policy attached to the resource, the request
  will fail and return a PolicyNotFoundException.
"""
function delete_resource_policy(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dynamodb(
        "DeleteResourcePolicy",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_resource_policy(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dynamodb(
        "DeleteResourcePolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_table(table_name)
    delete_table(table_name, params::Dict{String,<:Any})

The DeleteTable operation deletes a table and all of its items. After a DeleteTable
request, the specified table is in the DELETING state until DynamoDB completes the
deletion. If the table is in the ACTIVE state, you can delete it. If a table is in CREATING
or UPDATING states, then DynamoDB returns a ResourceInUseException. If the specified table
does not exist, DynamoDB returns a ResourceNotFoundException. If table is already in the
DELETING state, no error is returned.   For global tables, this operation only applies to
global tables using Version 2019.11.21 (Current version).    DynamoDB might continue to
accept data read and write operations, such as GetItem and PutItem, on a table in the
DELETING state until the table deletion is complete.  When you delete a table, any indexes
on that table are also deleted. If you have DynamoDB Streams enabled on the table, then the
corresponding stream on that table goes into the DISABLED state, and the stream is
automatically deleted after 24 hours. Use the DescribeTable action to check the status of
the table.

# Arguments
- `table_name`: The name of the table to delete. You can also provide the Amazon Resource
  Name (ARN) of the table in this parameter.

"""
function delete_table(TableName; aws_config::AbstractAWSConfig=current_aws_config())
    return dynamodb(
        "DeleteTable",
        Dict{String,Any}("TableName" => TableName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_table(
    TableName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dynamodb(
        "DeleteTable",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TableName" => TableName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_backup(backup_arn)
    describe_backup(backup_arn, params::Dict{String,<:Any})

Describes an existing backup of a table. You can call DescribeBackup at a maximum rate of
10 times per second.

# Arguments
- `backup_arn`: The Amazon Resource Name (ARN) associated with the backup.

"""
function describe_backup(BackupArn; aws_config::AbstractAWSConfig=current_aws_config())
    return dynamodb(
        "DescribeBackup",
        Dict{String,Any}("BackupArn" => BackupArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_backup(
    BackupArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dynamodb(
        "DescribeBackup",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("BackupArn" => BackupArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_continuous_backups(table_name)
    describe_continuous_backups(table_name, params::Dict{String,<:Any})

Checks the status of continuous backups and point in time recovery on the specified table.
Continuous backups are ENABLED on all tables at table creation. If point in time recovery
is enabled, PointInTimeRecoveryStatus will be set to ENABLED.  After continuous backups and
point in time recovery are enabled, you can restore to any point in time within
EarliestRestorableDateTime and LatestRestorableDateTime.   LatestRestorableDateTime is
typically 5 minutes before the current time. You can restore your table to any point in
time during the last 35 days.  You can call DescribeContinuousBackups at a maximum rate of
10 times per second.

# Arguments
- `table_name`: Name of the table for which the customer wants to check the continuous
  backups and point in time recovery settings. You can also provide the Amazon Resource Name
  (ARN) of the table in this parameter.

"""
function describe_continuous_backups(
    TableName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dynamodb(
        "DescribeContinuousBackups",
        Dict{String,Any}("TableName" => TableName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_continuous_backups(
    TableName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dynamodb(
        "DescribeContinuousBackups",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TableName" => TableName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_contributor_insights(table_name)
    describe_contributor_insights(table_name, params::Dict{String,<:Any})

Returns information about contributor insights for a given table or global secondary index.

# Arguments
- `table_name`: The name of the table to describe. You can also provide the Amazon Resource
  Name (ARN) of the table in this parameter.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"IndexName"`: The name of the global secondary index to describe, if applicable.
"""
function describe_contributor_insights(
    TableName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dynamodb(
        "DescribeContributorInsights",
        Dict{String,Any}("TableName" => TableName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_contributor_insights(
    TableName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dynamodb(
        "DescribeContributorInsights",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TableName" => TableName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_endpoints()
    describe_endpoints(params::Dict{String,<:Any})

Returns the regional endpoint information. For more information on policy permissions,
please see Internetwork traffic privacy.

"""
function describe_endpoints(; aws_config::AbstractAWSConfig=current_aws_config())
    return dynamodb(
        "DescribeEndpoints"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_endpoints(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dynamodb(
        "DescribeEndpoints", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_export(export_arn)
    describe_export(export_arn, params::Dict{String,<:Any})

Describes an existing table export.

# Arguments
- `export_arn`: The Amazon Resource Name (ARN) associated with the export.

"""
function describe_export(ExportArn; aws_config::AbstractAWSConfig=current_aws_config())
    return dynamodb(
        "DescribeExport",
        Dict{String,Any}("ExportArn" => ExportArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_export(
    ExportArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dynamodb(
        "DescribeExport",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ExportArn" => ExportArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_global_table(global_table_name)
    describe_global_table(global_table_name, params::Dict{String,<:Any})

Returns information about the specified global table.  This documentation is for version
2017.11.29 (Legacy) of global tables, which should be avoided for new global tables.
Customers should use Global Tables version 2019.11.21 (Current) when possible, because it
provides greater flexibility, higher efficiency, and consumes less write capacity than
2017.11.29 (Legacy). To determine which version you're using, see Determining the global
table version you are using. To update existing global tables from version 2017.11.29
(Legacy) to version 2019.11.21 (Current), see Upgrading global tables.

# Arguments
- `global_table_name`: The name of the global table.

"""
function describe_global_table(
    GlobalTableName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dynamodb(
        "DescribeGlobalTable",
        Dict{String,Any}("GlobalTableName" => GlobalTableName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_global_table(
    GlobalTableName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dynamodb(
        "DescribeGlobalTable",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("GlobalTableName" => GlobalTableName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_global_table_settings(global_table_name)
    describe_global_table_settings(global_table_name, params::Dict{String,<:Any})

Describes Region-specific settings for a global table.  This documentation is for version
2017.11.29 (Legacy) of global tables, which should be avoided for new global tables.
Customers should use Global Tables version 2019.11.21 (Current) when possible, because it
provides greater flexibility, higher efficiency, and consumes less write capacity than
2017.11.29 (Legacy). To determine which version you're using, see Determining the global
table version you are using. To update existing global tables from version 2017.11.29
(Legacy) to version 2019.11.21 (Current), see Upgrading global tables.

# Arguments
- `global_table_name`: The name of the global table to describe.

"""
function describe_global_table_settings(
    GlobalTableName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dynamodb(
        "DescribeGlobalTableSettings",
        Dict{String,Any}("GlobalTableName" => GlobalTableName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_global_table_settings(
    GlobalTableName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dynamodb(
        "DescribeGlobalTableSettings",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("GlobalTableName" => GlobalTableName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_import(import_arn)
    describe_import(import_arn, params::Dict{String,<:Any})

 Represents the properties of the import.

# Arguments
- `import_arn`:  The Amazon Resource Name (ARN) associated with the table you're importing
  to.

"""
function describe_import(ImportArn; aws_config::AbstractAWSConfig=current_aws_config())
    return dynamodb(
        "DescribeImport",
        Dict{String,Any}("ImportArn" => ImportArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_import(
    ImportArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dynamodb(
        "DescribeImport",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ImportArn" => ImportArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_kinesis_streaming_destination(table_name)
    describe_kinesis_streaming_destination(table_name, params::Dict{String,<:Any})

Returns information about the status of Kinesis streaming.

# Arguments
- `table_name`: The name of the table being described. You can also provide the Amazon
  Resource Name (ARN) of the table in this parameter.

"""
function describe_kinesis_streaming_destination(
    TableName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dynamodb(
        "DescribeKinesisStreamingDestination",
        Dict{String,Any}("TableName" => TableName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_kinesis_streaming_destination(
    TableName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dynamodb(
        "DescribeKinesisStreamingDestination",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TableName" => TableName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_limits()
    describe_limits(params::Dict{String,<:Any})

Returns the current provisioned-capacity quotas for your Amazon Web Services account in a
Region, both for the Region as a whole and for any one DynamoDB table that you create
there. When you establish an Amazon Web Services account, the account has initial quotas on
the maximum read capacity units and write capacity units that you can provision across all
of your DynamoDB tables in a given Region. Also, there are per-table quotas that apply when
you create a table there. For more information, see Service, Account, and Table Quotas page
in the Amazon DynamoDB Developer Guide. Although you can increase these quotas by filing a
case at Amazon Web Services Support Center, obtaining the increase is not instantaneous.
The DescribeLimits action lets you write code to compare the capacity you are currently
using to those quotas imposed by your account so that you have enough time to apply for an
increase before you hit a quota. For example, you could use one of the Amazon Web Services
SDKs to do the following:   Call DescribeLimits for a particular Region to obtain your
current account quotas on provisioned capacity there.   Create a variable to hold the
aggregate read capacity units provisioned for all your tables in that Region, and one to
hold the aggregate write capacity units. Zero them both.   Call ListTables to obtain a list
of all your DynamoDB tables.   For each table name listed by ListTables, do the following:
 Call DescribeTable with the table name.   Use the data returned by DescribeTable to add
the read capacity units and write capacity units provisioned for the table itself to your
variables.   If the table has one or more global secondary indexes (GSIs), loop over these
GSIs and add their provisioned capacity values to your variables as well.     Report the
account quotas for that Region returned by DescribeLimits, along with the total current
provisioned capacity levels you have calculated.   This will let you see whether you are
getting close to your account-level quotas. The per-table quotas apply only when you are
creating a new table. They restrict the sum of the provisioned capacity of the new table
itself and all its global secondary indexes. For existing tables and their GSIs, DynamoDB
doesn't let you increase provisioned capacity extremely rapidly, but the only quota that
applies is that the aggregate provisioned capacity over all your tables and GSIs cannot
exceed either of the per-account quotas.   DescribeLimits should only be called
periodically. You can expect throttling errors if you call it more than once in a minute.
The DescribeLimits Request element has no content.

"""
function describe_limits(; aws_config::AbstractAWSConfig=current_aws_config())
    return dynamodb(
        "DescribeLimits"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_limits(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dynamodb(
        "DescribeLimits", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_table(table_name)
    describe_table(table_name, params::Dict{String,<:Any})

Returns information about the table, including the current status of the table, when it was
created, the primary key schema, and any indexes on the table.  For global tables, this
operation only applies to global tables using Version 2019.11.21 (Current version).    If
you issue a DescribeTable request immediately after a CreateTable request, DynamoDB might
return a ResourceNotFoundException. This is because DescribeTable uses an eventually
consistent query, and the metadata for your table might not be available at that moment.
Wait for a few seconds, and then try the DescribeTable request again.

# Arguments
- `table_name`: The name of the table to describe. You can also provide the Amazon Resource
  Name (ARN) of the table in this parameter.

"""
function describe_table(TableName; aws_config::AbstractAWSConfig=current_aws_config())
    return dynamodb(
        "DescribeTable",
        Dict{String,Any}("TableName" => TableName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_table(
    TableName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dynamodb(
        "DescribeTable",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TableName" => TableName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_table_replica_auto_scaling(table_name)
    describe_table_replica_auto_scaling(table_name, params::Dict{String,<:Any})

Describes auto scaling settings across replicas of the global table at once.  For global
tables, this operation only applies to global tables using Version 2019.11.21 (Current
version).

# Arguments
- `table_name`: The name of the table. You can also provide the Amazon Resource Name (ARN)
  of the table in this parameter.

"""
function describe_table_replica_auto_scaling(
    TableName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dynamodb(
        "DescribeTableReplicaAutoScaling",
        Dict{String,Any}("TableName" => TableName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_table_replica_auto_scaling(
    TableName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dynamodb(
        "DescribeTableReplicaAutoScaling",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TableName" => TableName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_time_to_live(table_name)
    describe_time_to_live(table_name, params::Dict{String,<:Any})

Gives a description of the Time to Live (TTL) status on the specified table.

# Arguments
- `table_name`: The name of the table to be described. You can also provide the Amazon
  Resource Name (ARN) of the table in this parameter.

"""
function describe_time_to_live(
    TableName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dynamodb(
        "DescribeTimeToLive",
        Dict{String,Any}("TableName" => TableName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_time_to_live(
    TableName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dynamodb(
        "DescribeTimeToLive",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TableName" => TableName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disable_kinesis_streaming_destination(stream_arn, table_name)
    disable_kinesis_streaming_destination(stream_arn, table_name, params::Dict{String,<:Any})

Stops replication from the DynamoDB table to the Kinesis data stream. This is done without
deleting either of the resources.

# Arguments
- `stream_arn`: The ARN for a Kinesis data stream.
- `table_name`: The name of the DynamoDB table. You can also provide the Amazon Resource
  Name (ARN) of the table in this parameter.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EnableKinesisStreamingConfiguration"`: The source for the Kinesis streaming information
  that is being enabled.
"""
function disable_kinesis_streaming_destination(
    StreamArn, TableName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dynamodb(
        "DisableKinesisStreamingDestination",
        Dict{String,Any}("StreamArn" => StreamArn, "TableName" => TableName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disable_kinesis_streaming_destination(
    StreamArn,
    TableName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dynamodb(
        "DisableKinesisStreamingDestination",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("StreamArn" => StreamArn, "TableName" => TableName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    enable_kinesis_streaming_destination(stream_arn, table_name)
    enable_kinesis_streaming_destination(stream_arn, table_name, params::Dict{String,<:Any})

Starts table data replication to the specified Kinesis data stream at a timestamp chosen
during the enable workflow. If this operation doesn't return results immediately, use
DescribeKinesisStreamingDestination to check if streaming to the Kinesis data stream is
ACTIVE.

# Arguments
- `stream_arn`: The ARN for a Kinesis data stream.
- `table_name`: The name of the DynamoDB table. You can also provide the Amazon Resource
  Name (ARN) of the table in this parameter.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EnableKinesisStreamingConfiguration"`: The source for the Kinesis streaming information
  that is being enabled.
"""
function enable_kinesis_streaming_destination(
    StreamArn, TableName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dynamodb(
        "EnableKinesisStreamingDestination",
        Dict{String,Any}("StreamArn" => StreamArn, "TableName" => TableName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function enable_kinesis_streaming_destination(
    StreamArn,
    TableName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dynamodb(
        "EnableKinesisStreamingDestination",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("StreamArn" => StreamArn, "TableName" => TableName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    execute_statement(statement)
    execute_statement(statement, params::Dict{String,<:Any})

This operation allows you to perform reads and singleton writes on data stored in DynamoDB,
using PartiQL. For PartiQL reads (SELECT statement), if the total number of processed items
exceeds the maximum dataset size limit of 1 MB, the read stops and results are returned to
the user as a LastEvaluatedKey value to continue the read in a subsequent operation. If the
filter criteria in WHERE clause does not match any data, the read will return an empty
result set. A single SELECT statement response can return up to the maximum number of items
(if using the Limit parameter) or a maximum of 1 MB of data (and then apply any filtering
to the results using WHERE clause). If LastEvaluatedKey is present in the response, you
need to paginate the result set. If NextToken is present, you need to paginate the result
set and include NextToken.

# Arguments
- `statement`: The PartiQL statement representing the operation to run.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConsistentRead"`: The consistency of a read operation. If set to true, then a strongly
  consistent read is used; otherwise, an eventually consistent read is used.
- `"Limit"`: The maximum number of items to evaluate (not necessarily the number of
  matching items). If DynamoDB processes the number of items up to the limit while processing
  the results, it stops the operation and returns the matching values up to that point, along
  with a key in LastEvaluatedKey to apply in a subsequent operation so you can pick up where
  you left off. Also, if the processed dataset size exceeds 1 MB before DynamoDB reaches this
  limit, it stops the operation and returns the matching values up to the limit, and a key in
  LastEvaluatedKey to apply in a subsequent operation to continue the operation.
- `"NextToken"`: Set this value to get remaining results, if NextToken was returned in the
  statement response.
- `"Parameters"`: The parameters for the PartiQL statement, if any.
- `"ReturnConsumedCapacity"`:
- `"ReturnValuesOnConditionCheckFailure"`: An optional parameter that returns the item
  attributes for an ExecuteStatement operation that failed a condition check. There is no
  additional cost associated with requesting a return value aside from the small network and
  processing overhead of receiving a larger response. No read capacity units are consumed.
"""
function execute_statement(Statement; aws_config::AbstractAWSConfig=current_aws_config())
    return dynamodb(
        "ExecuteStatement",
        Dict{String,Any}("Statement" => Statement);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function execute_statement(
    Statement,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dynamodb(
        "ExecuteStatement",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Statement" => Statement), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    execute_transaction(transact_statements)
    execute_transaction(transact_statements, params::Dict{String,<:Any})

This operation allows you to perform transactional reads or writes on data stored in
DynamoDB, using PartiQL.  The entire transaction must consist of either read statements or
write statements, you cannot mix both in one transaction. The EXISTS function is an
exception and can be used to check the condition of specific attributes of the item in a
similar manner to ConditionCheck in the TransactWriteItems API.

# Arguments
- `transact_statements`: The list of PartiQL statements representing the transaction to run.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: Set this value to get remaining results, if NextToken was
  returned in the statement response.
- `"ReturnConsumedCapacity"`: Determines the level of detail about either provisioned or
  on-demand throughput consumption that is returned in the response. For more information,
  see TransactGetItems and TransactWriteItems.
"""
function execute_transaction(
    TransactStatements; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dynamodb(
        "ExecuteTransaction",
        Dict{String,Any}(
            "TransactStatements" => TransactStatements,
            "ClientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function execute_transaction(
    TransactStatements,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dynamodb(
        "ExecuteTransaction",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "TransactStatements" => TransactStatements,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    export_table_to_point_in_time(s3_bucket, table_arn)
    export_table_to_point_in_time(s3_bucket, table_arn, params::Dict{String,<:Any})

Exports table data to an S3 bucket. The table must have point in time recovery enabled, and
you can export data from any time within the point in time recovery window.

# Arguments
- `s3_bucket`: The name of the Amazon S3 bucket to export the snapshot to.
- `table_arn`: The Amazon Resource Name (ARN) associated with the table to export.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: Providing a ClientToken makes the call to ExportTableToPointInTimeInput
  idempotent, meaning that multiple identical calls have the same effect as one single call.
  A client token is valid for 8 hours after the first request that uses it is completed.
  After 8 hours, any request with the same client token is treated as a new request. Do not
  resubmit the same request with the same client token for more than 8 hours, or the result
  might not be idempotent. If you submit a request with the same client token but a change in
  other parameters within the 8-hour idempotency window, DynamoDB returns an
  ImportConflictException.
- `"ExportFormat"`: The format for the exported data. Valid values for ExportFormat are
  DYNAMODB_JSON or ION.
- `"ExportTime"`: Time in the past from which to export table data, counted in seconds from
  the start of the Unix epoch. The table export will be a snapshot of the table's state at
  this point in time.
- `"ExportType"`: Choice of whether to execute as a full export or incremental export.
  Valid values are FULL_EXPORT or INCREMENTAL_EXPORT. The default value is FULL_EXPORT. If
  INCREMENTAL_EXPORT is provided, the IncrementalExportSpecification must also be used.
- `"IncrementalExportSpecification"`: Optional object containing the parameters specific to
  an incremental export.
- `"S3BucketOwner"`: The ID of the Amazon Web Services account that owns the bucket the
  export will be stored in.  S3BucketOwner is a required parameter when exporting to a S3
  bucket in another account.
- `"S3Prefix"`: The Amazon S3 bucket prefix to use as the file name and path of the
  exported snapshot.
- `"S3SseAlgorithm"`: Type of encryption used on the bucket where export data will be
  stored. Valid values for S3SseAlgorithm are:    AES256 - server-side encryption with Amazon
  S3 managed keys    KMS - server-side encryption with KMS managed keys
- `"S3SseKmsKeyId"`: The ID of the KMS managed key used to encrypt the S3 bucket where
  export data will be stored (if applicable).
"""
function export_table_to_point_in_time(
    S3Bucket, TableArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dynamodb(
        "ExportTableToPointInTime",
        Dict{String,Any}(
            "S3Bucket" => S3Bucket, "TableArn" => TableArn, "ClientToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function export_table_to_point_in_time(
    S3Bucket,
    TableArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dynamodb(
        "ExportTableToPointInTime",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "S3Bucket" => S3Bucket,
                    "TableArn" => TableArn,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_item(key, table_name)
    get_item(key, table_name, params::Dict{String,<:Any})

The GetItem operation returns a set of attributes for the item with the given primary key.
If there is no matching item, GetItem does not return any data and there will be no Item
element in the response.  GetItem provides an eventually consistent read by default. If
your application requires a strongly consistent read, set ConsistentRead to true. Although
a strongly consistent read might take more time than an eventually consistent read, it
always returns the last updated value.

# Arguments
- `key`: A map of attribute names to AttributeValue objects, representing the primary key
  of the item to retrieve. For the primary key, you must provide all of the attributes. For
  example, with a simple primary key, you only need to provide a value for the partition key.
  For a composite primary key, you must provide values for both the partition key and the
  sort key.
- `table_name`: The name of the table containing the requested item. You can also provide
  the Amazon Resource Name (ARN) of the table in this parameter.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AttributesToGet"`: This is a legacy parameter. Use ProjectionExpression instead. For
  more information, see AttributesToGet in the Amazon DynamoDB Developer Guide.
- `"ConsistentRead"`: Determines the read consistency model: If set to true, then the
  operation uses strongly consistent reads; otherwise, the operation uses eventually
  consistent reads.
- `"ExpressionAttributeNames"`: One or more substitution tokens for attribute names in an
  expression. The following are some use cases for using ExpressionAttributeNames:   To
  access an attribute whose name conflicts with a DynamoDB reserved word.   To create a
  placeholder for repeating occurrences of an attribute name in an expression.   To prevent
  special characters in an attribute name from being misinterpreted in an expression.   Use
  the # character in an expression to dereference an attribute name. For example, consider
  the following attribute name:    Percentile    The name of this attribute conflicts with a
  reserved word, so it cannot be used directly in an expression. (For the complete list of
  reserved words, see Reserved Words in the Amazon DynamoDB Developer Guide). To work around
  this, you could specify the following for ExpressionAttributeNames:
  {\"#P\":\"Percentile\"}    You could then use this substitution in an expression, as in
  this example:    #P = :val     Tokens that begin with the : character are expression
  attribute values, which are placeholders for the actual value at runtime.  For more
  information on expression attribute names, see Specifying Item Attributes in the Amazon
  DynamoDB Developer Guide.
- `"ProjectionExpression"`: A string that identifies one or more attributes to retrieve
  from the table. These attributes can include scalars, sets, or elements of a JSON document.
  The attributes in the expression must be separated by commas. If no attribute names are
  specified, then all attributes are returned. If any of the requested attributes are not
  found, they do not appear in the result. For more information, see Specifying Item
  Attributes in the Amazon DynamoDB Developer Guide.
- `"ReturnConsumedCapacity"`:
"""
function get_item(Key, TableName; aws_config::AbstractAWSConfig=current_aws_config())
    return dynamodb(
        "GetItem",
        Dict{String,Any}("Key" => Key, "TableName" => TableName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_item(
    Key,
    TableName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dynamodb(
        "GetItem",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("Key" => Key, "TableName" => TableName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_resource_policy(resource_arn)
    get_resource_policy(resource_arn, params::Dict{String,<:Any})

Returns the resource-based policy document attached to the resource, which can be a table
or stream, in JSON format.  GetResourcePolicy follows an  eventually consistent  model. The
following list describes the outcomes when you issue the GetResourcePolicy request
immediately after issuing another request:   If you issue a GetResourcePolicy request
immediately after a PutResourcePolicy request, DynamoDB might return a
PolicyNotFoundException.   If you issue a GetResourcePolicyrequest immediately after a
DeleteResourcePolicy request, DynamoDB might return the policy that was present before the
deletion request.   If you issue a GetResourcePolicy request immediately after a
CreateTable request, which includes a resource-based policy, DynamoDB might return a
ResourceNotFoundException or a PolicyNotFoundException.   Because GetResourcePolicy uses an
eventually consistent query, the metadata for your policy or table might not be available
at that moment. Wait for a few seconds, and then retry the GetResourcePolicy request. After
a GetResourcePolicy request returns a policy created using the PutResourcePolicy request,
the policy will be applied in the authorization of requests to the resource. Because this
process is eventually consistent, it will take some time to apply the policy to all
requests to a resource. Policies that you attach while creating a table using the
CreateTable request will always be applied to all requests for that table.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the DynamoDB resource to which the
  policy is attached. The resources you can specify include tables and streams.

"""
function get_resource_policy(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dynamodb(
        "GetResourcePolicy",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_resource_policy(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dynamodb(
        "GetResourcePolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    import_table(input_format, s3_bucket_source, table_creation_parameters)
    import_table(input_format, s3_bucket_source, table_creation_parameters, params::Dict{String,<:Any})

 Imports table data from an S3 bucket.

# Arguments
- `input_format`:  The format of the source data. Valid values for ImportFormat are CSV,
  DYNAMODB_JSON or ION.
- `s3_bucket_source`:  The S3 bucket that provides the source for the import.
- `table_creation_parameters`: Parameters for the table to import the data into.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: Providing a ClientToken makes the call to ImportTableInput idempotent,
  meaning that multiple identical calls have the same effect as one single call. A client
  token is valid for 8 hours after the first request that uses it is completed. After 8
  hours, any request with the same client token is treated as a new request. Do not resubmit
  the same request with the same client token for more than 8 hours, or the result might not
  be idempotent. If you submit a request with the same client token but a change in other
  parameters within the 8-hour idempotency window, DynamoDB returns an
  IdempotentParameterMismatch exception.
- `"InputCompressionType"`:  Type of compression to be used on the input coming from the
  imported table.
- `"InputFormatOptions"`:  Additional properties that specify how the input is formatted,
"""
function import_table(
    InputFormat,
    S3BucketSource,
    TableCreationParameters;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dynamodb(
        "ImportTable",
        Dict{String,Any}(
            "InputFormat" => InputFormat,
            "S3BucketSource" => S3BucketSource,
            "TableCreationParameters" => TableCreationParameters,
            "ClientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function import_table(
    InputFormat,
    S3BucketSource,
    TableCreationParameters,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dynamodb(
        "ImportTable",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "InputFormat" => InputFormat,
                    "S3BucketSource" => S3BucketSource,
                    "TableCreationParameters" => TableCreationParameters,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_backups()
    list_backups(params::Dict{String,<:Any})

List DynamoDB backups that are associated with an Amazon Web Services account and weren't
made with Amazon Web Services Backup. To list these backups for a given table, specify
TableName. ListBackups returns a paginated list of results with at most 1 MB worth of items
in a page. You can also specify a maximum number of entries to be returned in a page. In
the request, start time is inclusive, but end time is exclusive. Note that these boundaries
are for the time at which the original backup was requested. You can call ListBackups a
maximum of five times per second. If you want to retrieve the complete list of backups made
with Amazon Web Services Backup, use the Amazon Web Services Backup list API.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"BackupType"`: The backups from the table specified by BackupType are listed. Where
  BackupType can be:    USER - On-demand backup created by you. (The default setting if no
  other backup types are specified.)    SYSTEM - On-demand backup automatically created by
  DynamoDB.    ALL - All types of on-demand backups (USER and SYSTEM).
- `"ExclusiveStartBackupArn"`:  LastEvaluatedBackupArn is the Amazon Resource Name (ARN) of
  the backup last evaluated when the current page of results was returned, inclusive of the
  current page of results. This value may be specified as the ExclusiveStartBackupArn of a
  new ListBackups operation in order to fetch the next page of results.
- `"Limit"`: Maximum number of backups to return at once.
- `"TableName"`: Lists the backups from the table specified in TableName. You can also
  provide the Amazon Resource Name (ARN) of the table in this parameter.
- `"TimeRangeLowerBound"`: Only backups created after this time are listed.
  TimeRangeLowerBound is inclusive.
- `"TimeRangeUpperBound"`: Only backups created before this time are listed.
  TimeRangeUpperBound is exclusive.
"""
function list_backups(; aws_config::AbstractAWSConfig=current_aws_config())
    return dynamodb("ListBackups"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_backups(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dynamodb(
        "ListBackups", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_contributor_insights()
    list_contributor_insights(params::Dict{String,<:Any})

Returns a list of ContributorInsightsSummary for a table and all its global secondary
indexes.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Maximum number of results to return per page.
- `"NextToken"`: A token to for the desired page, if there is one.
- `"TableName"`: The name of the table. You can also provide the Amazon Resource Name (ARN)
  of the table in this parameter.
"""
function list_contributor_insights(; aws_config::AbstractAWSConfig=current_aws_config())
    return dynamodb(
        "ListContributorInsights"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_contributor_insights(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dynamodb(
        "ListContributorInsights",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_exports()
    list_exports(params::Dict{String,<:Any})

Lists completed exports within the past 90 days.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Maximum number of results to return per page.
- `"NextToken"`: An optional string that, if supplied, must be copied from the output of a
  previous call to ListExports. When provided in this manner, the API fetches the next page
  of results.
- `"TableArn"`: The Amazon Resource Name (ARN) associated with the exported table.
"""
function list_exports(; aws_config::AbstractAWSConfig=current_aws_config())
    return dynamodb("ListExports"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_exports(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dynamodb(
        "ListExports", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_global_tables()
    list_global_tables(params::Dict{String,<:Any})

Lists all global tables that have a replica in the specified Region.  This documentation is
for version 2017.11.29 (Legacy) of global tables, which should be avoided for new global
tables. Customers should use Global Tables version 2019.11.21 (Current) when possible,
because it provides greater flexibility, higher efficiency, and consumes less write
capacity than 2017.11.29 (Legacy). To determine which version you're using, see Determining
the global table version you are using. To update existing global tables from version
2017.11.29 (Legacy) to version 2019.11.21 (Current), see Upgrading global tables.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ExclusiveStartGlobalTableName"`: The first global table name that this operation will
  evaluate.
- `"Limit"`: The maximum number of table names to return, if the parameter is not specified
  DynamoDB defaults to 100. If the number of global tables DynamoDB finds reaches this limit,
  it stops the operation and returns the table names collected up to that point, with a table
  name in the LastEvaluatedGlobalTableName to apply in a subsequent operation to the
  ExclusiveStartGlobalTableName parameter.
- `"RegionName"`: Lists the global tables in a specific Region.
"""
function list_global_tables(; aws_config::AbstractAWSConfig=current_aws_config())
    return dynamodb(
        "ListGlobalTables"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_global_tables(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dynamodb(
        "ListGlobalTables", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_imports()
    list_imports(params::Dict{String,<:Any})

 Lists completed imports within the past 90 days.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`:  An optional string that, if supplied, must be copied from the output of a
  previous call to ListImports. When provided in this manner, the API fetches the next page
  of results.
- `"PageSize"`:  The number of ImportSummary objects returned in a single page.
- `"TableArn"`:  The Amazon Resource Name (ARN) associated with the table that was imported
  to.
"""
function list_imports(; aws_config::AbstractAWSConfig=current_aws_config())
    return dynamodb("ListImports"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_imports(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dynamodb(
        "ListImports", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tables()
    list_tables(params::Dict{String,<:Any})

Returns an array of table names associated with the current account and endpoint. The
output from ListTables is paginated, with each page returning a maximum of 100 table names.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ExclusiveStartTableName"`: The first table name that this operation will evaluate. Use
  the value that was returned for LastEvaluatedTableName in a previous operation, so that you
  can obtain the next page of results.
- `"Limit"`: A maximum number of table names to return. If this parameter is not specified,
  the limit is 100.
"""
function list_tables(; aws_config::AbstractAWSConfig=current_aws_config())
    return dynamodb("ListTables"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_tables(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dynamodb(
        "ListTables", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_of_resource(resource_arn)
    list_tags_of_resource(resource_arn, params::Dict{String,<:Any})

List all tags on an Amazon DynamoDB resource. You can call ListTagsOfResource up to 10
times per second, per account. For an overview on tagging DynamoDB resources, see Tagging
for DynamoDB in the Amazon DynamoDB Developer Guide.

# Arguments
- `resource_arn`: The Amazon DynamoDB resource with tags to be listed. This value is an
  Amazon Resource Name (ARN).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: An optional string that, if supplied, must be copied from the output of a
  previous call to ListTagOfResource. When provided in this manner, this API fetches the next
  page of results.
"""
function list_tags_of_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dynamodb(
        "ListTagsOfResource",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_of_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dynamodb(
        "ListTagsOfResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_item(item, table_name)
    put_item(item, table_name, params::Dict{String,<:Any})

Creates a new item, or replaces an old item with a new item. If an item that has the same
primary key as the new item already exists in the specified table, the new item completely
replaces the existing item. You can perform a conditional put operation (add a new item if
one with the specified primary key doesn't exist), or replace an existing item if it has
certain attribute values. You can return the item's attribute values in the same operation,
using the ReturnValues parameter. When you add an item, the primary key attributes are the
only required attributes.  Empty String and Binary attribute values are allowed. Attribute
values of type String and Binary must have a length greater than zero if the attribute is
used as a key attribute for a table or index. Set type attributes cannot be empty.  Invalid
Requests with empty values will be rejected with a ValidationException exception.  To
prevent a new item from replacing an existing item, use a conditional expression that
contains the attribute_not_exists function with the name of the attribute being used as the
partition key for the table. Since every record must contain that attribute, the
attribute_not_exists function will only succeed if no matching item exists.  For more
information about PutItem, see Working with Items in the Amazon DynamoDB Developer Guide.

# Arguments
- `item`: A map of attribute name/value pairs, one for each attribute. Only the primary key
  attributes are required; you can optionally provide other attribute name-value pairs for
  the item. You must provide all of the attributes for the primary key. For example, with a
  simple primary key, you only need to provide a value for the partition key. For a composite
  primary key, you must provide both values for both the partition key and the sort key. If
  you specify any attributes that are part of an index key, then the data types for those
  attributes must match those of the schema in the table's attribute definition. Empty String
  and Binary attribute values are allowed. Attribute values of type String and Binary must
  have a length greater than zero if the attribute is used as a key attribute for a table or
  index. For more information about primary keys, see Primary Key in the Amazon DynamoDB
  Developer Guide. Each element in the Item map is an AttributeValue object.
- `table_name`: The name of the table to contain the item. You can also provide the Amazon
  Resource Name (ARN) of the table in this parameter.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConditionExpression"`: A condition that must be satisfied in order for a conditional
  PutItem operation to succeed. An expression can contain any of the following:   Functions:
  attribute_exists | attribute_not_exists | attribute_type | contains | begins_with | size
  These function names are case-sensitive.   Comparison operators: = | &lt;&gt; | &lt; | &gt;
  | &lt;= | &gt;= | BETWEEN | IN      Logical operators: AND | OR | NOT    For more
  information on condition expressions, see Condition Expressions in the Amazon DynamoDB
  Developer Guide.
- `"ConditionalOperator"`: This is a legacy parameter. Use ConditionExpression instead. For
  more information, see ConditionalOperator in the Amazon DynamoDB Developer Guide.
- `"Expected"`: This is a legacy parameter. Use ConditionExpression instead. For more
  information, see Expected in the Amazon DynamoDB Developer Guide.
- `"ExpressionAttributeNames"`: One or more substitution tokens for attribute names in an
  expression. The following are some use cases for using ExpressionAttributeNames:   To
  access an attribute whose name conflicts with a DynamoDB reserved word.   To create a
  placeholder for repeating occurrences of an attribute name in an expression.   To prevent
  special characters in an attribute name from being misinterpreted in an expression.   Use
  the # character in an expression to dereference an attribute name. For example, consider
  the following attribute name:    Percentile    The name of this attribute conflicts with a
  reserved word, so it cannot be used directly in an expression. (For the complete list of
  reserved words, see Reserved Words in the Amazon DynamoDB Developer Guide). To work around
  this, you could specify the following for ExpressionAttributeNames:
  {\"#P\":\"Percentile\"}    You could then use this substitution in an expression, as in
  this example:    #P = :val     Tokens that begin with the : character are expression
  attribute values, which are placeholders for the actual value at runtime.  For more
  information on expression attribute names, see Specifying Item Attributes in the Amazon
  DynamoDB Developer Guide.
- `"ExpressionAttributeValues"`: One or more values that can be substituted in an
  expression. Use the : (colon) character in an expression to dereference an attribute value.
  For example, suppose that you wanted to check whether the value of the ProductStatus
  attribute was one of the following:   Available | Backordered | Discontinued  You would
  first need to specify ExpressionAttributeValues as follows:  {
  \":avail\":{\"S\":\"Available\"}, \":back\":{\"S\":\"Backordered\"},
  \":disc\":{\"S\":\"Discontinued\"} }  You could then use these values in an expression,
  such as this:  ProductStatus IN (:avail, :back, :disc)  For more information on expression
  attribute values, see Condition Expressions in the Amazon DynamoDB Developer Guide.
- `"ReturnConsumedCapacity"`:
- `"ReturnItemCollectionMetrics"`: Determines whether item collection metrics are returned.
  If set to SIZE, the response includes statistics about item collections, if any, that were
  modified during the operation are returned in the response. If set to NONE (the default),
  no statistics are returned.
- `"ReturnValues"`: Use ReturnValues if you want to get the item attributes as they
  appeared before they were updated with the PutItem request. For PutItem, the valid values
  are:    NONE - If ReturnValues is not specified, or if its value is NONE, then nothing is
  returned. (This setting is the default for ReturnValues.)    ALL_OLD - If PutItem overwrote
  an attribute name-value pair, then the content of the old item is returned.   The values
  returned are strongly consistent. There is no additional cost associated with requesting a
  return value aside from the small network and processing overhead of receiving a larger
  response. No read capacity units are consumed.  The ReturnValues parameter is used by
  several DynamoDB operations; however, PutItem does not recognize any values other than NONE
  or ALL_OLD.
- `"ReturnValuesOnConditionCheckFailure"`: An optional parameter that returns the item
  attributes for a PutItem operation that failed a condition check. There is no additional
  cost associated with requesting a return value aside from the small network and processing
  overhead of receiving a larger response. No read capacity units are consumed.
"""
function put_item(Item, TableName; aws_config::AbstractAWSConfig=current_aws_config())
    return dynamodb(
        "PutItem",
        Dict{String,Any}("Item" => Item, "TableName" => TableName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_item(
    Item,
    TableName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dynamodb(
        "PutItem",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("Item" => Item, "TableName" => TableName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_resource_policy(policy, resource_arn)
    put_resource_policy(policy, resource_arn, params::Dict{String,<:Any})

Attaches a resource-based policy document to the resource, which can be a table or stream.
When you attach a resource-based policy using this API, the policy application is
eventually consistent .  PutResourcePolicy is an idempotent operation; running it multiple
times on the same resource using the same policy document will return the same revision ID.
If you specify an ExpectedRevisionId that doesn't match the current policy's RevisionId,
the PolicyNotFoundException will be returned.   PutResourcePolicy is an asynchronous
operation. If you issue a GetResourcePolicy request immediately after a PutResourcePolicy
request, DynamoDB might return your previous policy, if there was one, or return the
PolicyNotFoundException. This is because GetResourcePolicy uses an eventually consistent
query, and the metadata for your policy or table might not be available at that moment.
Wait for a few seconds, and then try the GetResourcePolicy request again.

# Arguments
- `policy`: An Amazon Web Services resource-based policy document in JSON format.   The
  maximum size supported for a resource-based policy document is 20 KB. DynamoDB counts
  whitespaces when calculating the size of a policy against this limit.   Within a
  resource-based policy, if the action for a DynamoDB service-linked role (SLR) to replicate
  data for a global table is denied, adding or deleting a replica will fail with an error.
  For a full list of all considerations that apply while attaching a resource-based policy,
  see Resource-based policy considerations.
- `resource_arn`: The Amazon Resource Name (ARN) of the DynamoDB resource to which the
  policy will be attached. The resources you can specify include tables and streams. You can
  control index permissions using the base table's policy. To specify the same permission
  level for your table and its indexes, you can provide both the table and index Amazon
  Resource Name (ARN)s in the Resource field of a given Statement in your policy document.
  Alternatively, to specify different permissions for your table, indexes, or both, you can
  define multiple Statement fields in your policy document.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConfirmRemoveSelfResourceAccess"`: Set this parameter to true to confirm that you want
  to remove your permissions to change the policy of this resource in the future.
- `"ExpectedRevisionId"`: A string value that you can use to conditionally update your
  policy. You can provide the revision ID of your existing policy to make mutating requests
  against that policy.  When you provide an expected revision ID, if the revision ID of the
  existing policy on the resource doesn't match or if there's no policy attached to the
  resource, your request will be rejected with a PolicyNotFoundException.  To conditionally
  attach a policy when no policy exists for the resource, specify NO_POLICY for the revision
  ID.
"""
function put_resource_policy(
    Policy, ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dynamodb(
        "PutResourcePolicy",
        Dict{String,Any}("Policy" => Policy, "ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_resource_policy(
    Policy,
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dynamodb(
        "PutResourcePolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Policy" => Policy, "ResourceArn" => ResourceArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    query(table_name)
    query(table_name, params::Dict{String,<:Any})

You must provide the name of the partition key attribute and a single value for that
attribute. Query returns all items with that partition key value. Optionally, you can
provide a sort key attribute and use a comparison operator to refine the search results.
Use the KeyConditionExpression parameter to provide a specific value for the partition key.
The Query operation will return all of the items from the table or index with that
partition key value. You can optionally narrow the scope of the Query operation by
specifying a sort key value and a comparison operator in KeyConditionExpression. To further
refine the Query results, you can optionally provide a FilterExpression. A FilterExpression
determines which items within the results should be returned to you. All of the other
results are discarded.   A Query operation always returns a result set. If no matching
items are found, the result set will be empty. Queries that do not return results consume
the minimum number of read capacity units for that type of read operation.    DynamoDB
calculates the number of read capacity units consumed based on item size, not on the amount
of data that is returned to an application. The number of capacity units consumed will be
the same whether you request all of the attributes (the default behavior) or just some of
them (using a projection expression). The number will also be the same whether or not you
use a FilterExpression.    Query results are always sorted by the sort key value. If the
data type of the sort key is Number, the results are returned in numeric order; otherwise,
the results are returned in order of UTF-8 bytes. By default, the sort order is ascending.
To reverse the order, set the ScanIndexForward parameter to false.   A single Query
operation will read up to the maximum number of items set (if using the Limit parameter) or
a maximum of 1 MB of data and then apply any filtering to the results using
FilterExpression. If LastEvaluatedKey is present in the response, you will need to paginate
the result set. For more information, see Paginating the Results in the Amazon DynamoDB
Developer Guide.   FilterExpression is applied after a Query finishes, but before the
results are returned. A FilterExpression cannot contain partition key or sort key
attributes. You need to specify those attributes in the KeyConditionExpression.    A Query
operation can return an empty result set and a LastEvaluatedKey if all the items read for
the page of results are filtered out.   You can query a table, a local secondary index, or
a global secondary index. For a query on a table or on a local secondary index, you can set
the ConsistentRead parameter to true and obtain a strongly consistent result. Global
secondary indexes support eventually consistent reads only, so do not specify
ConsistentRead when querying a global secondary index.

# Arguments
- `table_name`: The name of the table containing the requested items. You can also provide
  the Amazon Resource Name (ARN) of the table in this parameter.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AttributesToGet"`: This is a legacy parameter. Use ProjectionExpression instead. For
  more information, see AttributesToGet in the Amazon DynamoDB Developer Guide.
- `"ConditionalOperator"`: This is a legacy parameter. Use FilterExpression instead. For
  more information, see ConditionalOperator in the Amazon DynamoDB Developer Guide.
- `"ConsistentRead"`: Determines the read consistency model: If set to true, then the
  operation uses strongly consistent reads; otherwise, the operation uses eventually
  consistent reads. Strongly consistent reads are not supported on global secondary indexes.
  If you query a global secondary index with ConsistentRead set to true, you will receive a
  ValidationException.
- `"ExclusiveStartKey"`: The primary key of the first item that this operation will
  evaluate. Use the value that was returned for LastEvaluatedKey in the previous operation.
  The data type for ExclusiveStartKey must be String, Number, or Binary. No set data types
  are allowed.
- `"ExpressionAttributeNames"`: One or more substitution tokens for attribute names in an
  expression. The following are some use cases for using ExpressionAttributeNames:   To
  access an attribute whose name conflicts with a DynamoDB reserved word.   To create a
  placeholder for repeating occurrences of an attribute name in an expression.   To prevent
  special characters in an attribute name from being misinterpreted in an expression.   Use
  the # character in an expression to dereference an attribute name. For example, consider
  the following attribute name:    Percentile    The name of this attribute conflicts with a
  reserved word, so it cannot be used directly in an expression. (For the complete list of
  reserved words, see Reserved Words in the Amazon DynamoDB Developer Guide). To work around
  this, you could specify the following for ExpressionAttributeNames:
  {\"#P\":\"Percentile\"}    You could then use this substitution in an expression, as in
  this example:    #P = :val     Tokens that begin with the : character are expression
  attribute values, which are placeholders for the actual value at runtime.  For more
  information on expression attribute names, see Specifying Item Attributes in the Amazon
  DynamoDB Developer Guide.
- `"ExpressionAttributeValues"`: One or more values that can be substituted in an
  expression. Use the : (colon) character in an expression to dereference an attribute value.
  For example, suppose that you wanted to check whether the value of the ProductStatus
  attribute was one of the following:   Available | Backordered | Discontinued  You would
  first need to specify ExpressionAttributeValues as follows:  {
  \":avail\":{\"S\":\"Available\"}, \":back\":{\"S\":\"Backordered\"},
  \":disc\":{\"S\":\"Discontinued\"} }  You could then use these values in an expression,
  such as this:  ProductStatus IN (:avail, :back, :disc)  For more information on expression
  attribute values, see Specifying Conditions in the Amazon DynamoDB Developer Guide.
- `"FilterExpression"`: A string that contains conditions that DynamoDB applies after the
  Query operation, but before the data is returned to you. Items that do not satisfy the
  FilterExpression criteria are not returned. A FilterExpression does not allow key
  attributes. You cannot define a filter expression based on a partition key or a sort key.
  A FilterExpression is applied after the items have already been read; the process of
  filtering does not consume any additional read capacity units.  For more information, see
  Filter Expressions in the Amazon DynamoDB Developer Guide.
- `"IndexName"`: The name of an index to query. This index can be any local secondary index
  or global secondary index on the table. Note that if you use the IndexName parameter, you
  must also provide TableName.
- `"KeyConditionExpression"`: The condition that specifies the key values for items to be
  retrieved by the Query action. The condition must perform an equality test on a single
  partition key value. The condition can optionally perform one of several comparison tests
  on a single sort key value. This allows Query to retrieve one item with a given partition
  key value and sort key value, or several items that have the same partition key value but
  different sort key values. The partition key equality test is required, and must be
  specified in the following format:  partitionKeyName = :partitionkeyval  If you also want
  to provide a condition for the sort key, it must be combined using AND with the condition
  for the sort key. Following is an example, using the = comparison operator for the sort
  key:  partitionKeyName = :partitionkeyval AND sortKeyName = :sortkeyval  Valid comparisons
  for the sort key condition are as follows:    sortKeyName = :sortkeyval - true if the sort
  key value is equal to :sortkeyval.    sortKeyName &lt; :sortkeyval - true if the sort key
  value is less than :sortkeyval.    sortKeyName &lt;= :sortkeyval - true if the sort key
  value is less than or equal to :sortkeyval.    sortKeyName &gt; :sortkeyval - true if the
  sort key value is greater than :sortkeyval.    sortKeyName &gt;=  :sortkeyval - true if the
  sort key value is greater than or equal to :sortkeyval.    sortKeyName BETWEEN :sortkeyval1
  AND :sortkeyval2 - true if the sort key value is greater than or equal to :sortkeyval1, and
  less than or equal to :sortkeyval2.    begins_with ( sortKeyName, :sortkeyval ) - true if
  the sort key value begins with a particular operand. (You cannot use this function with a
  sort key that is of type Number.) Note that the function name begins_with is
  case-sensitive.   Use the ExpressionAttributeValues parameter to replace tokens such as
  :partitionval and :sortval with actual values at runtime. You can optionally use the
  ExpressionAttributeNames parameter to replace the names of the partition key and sort key
  with placeholder tokens. This option might be necessary if an attribute name conflicts with
  a DynamoDB reserved word. For example, the following KeyConditionExpression parameter
  causes an error because Size is a reserved word:    Size = :myval    To work around this,
  define a placeholder (such a #S) to represent the attribute name Size.
  KeyConditionExpression then is as follows:    #S = :myval    For a list of reserved words,
  see Reserved Words in the Amazon DynamoDB Developer Guide. For more information on
  ExpressionAttributeNames and ExpressionAttributeValues, see Using Placeholders for
  Attribute Names and Values in the Amazon DynamoDB Developer Guide.
- `"KeyConditions"`: This is a legacy parameter. Use KeyConditionExpression instead. For
  more information, see KeyConditions in the Amazon DynamoDB Developer Guide.
- `"Limit"`: The maximum number of items to evaluate (not necessarily the number of
  matching items). If DynamoDB processes the number of items up to the limit while processing
  the results, it stops the operation and returns the matching values up to that point, and a
  key in LastEvaluatedKey to apply in a subsequent operation, so that you can pick up where
  you left off. Also, if the processed dataset size exceeds 1 MB before DynamoDB reaches this
  limit, it stops the operation and returns the matching values up to the limit, and a key in
  LastEvaluatedKey to apply in a subsequent operation to continue the operation. For more
  information, see Query and Scan in the Amazon DynamoDB Developer Guide.
- `"ProjectionExpression"`: A string that identifies one or more attributes to retrieve
  from the table. These attributes can include scalars, sets, or elements of a JSON document.
  The attributes in the expression must be separated by commas. If no attribute names are
  specified, then all attributes will be returned. If any of the requested attributes are not
  found, they will not appear in the result. For more information, see Accessing Item
  Attributes in the Amazon DynamoDB Developer Guide.
- `"QueryFilter"`: This is a legacy parameter. Use FilterExpression instead. For more
  information, see QueryFilter in the Amazon DynamoDB Developer Guide.
- `"ReturnConsumedCapacity"`:
- `"ScanIndexForward"`: Specifies the order for index traversal: If true (default), the
  traversal is performed in ascending order; if false, the traversal is performed in
  descending order.  Items with the same partition key value are stored in sorted order by
  sort key. If the sort key data type is Number, the results are stored in numeric order. For
  type String, the results are stored in order of UTF-8 bytes. For type Binary, DynamoDB
  treats each byte of the binary data as unsigned. If ScanIndexForward is true, DynamoDB
  returns the results in the order in which they are stored (by sort key value). This is the
  default behavior. If ScanIndexForward is false, DynamoDB reads the results in reverse order
  by sort key value, and then returns the results to the client.
- `"Select"`: The attributes to be returned in the result. You can retrieve all item
  attributes, specific item attributes, the count of matching items, or in the case of an
  index, some or all of the attributes projected into the index.    ALL_ATTRIBUTES - Returns
  all of the item attributes from the specified table or index. If you query a local
  secondary index, then for each matching item in the index, DynamoDB fetches the entire item
  from the parent table. If the index is configured to project all item attributes, then all
  of the data can be obtained from the local secondary index, and no fetching is required.
  ALL_PROJECTED_ATTRIBUTES - Allowed only when querying an index. Retrieves all attributes
  that have been projected into the index. If the index is configured to project all
  attributes, this return value is equivalent to specifying ALL_ATTRIBUTES.    COUNT -
  Returns the number of matching items, rather than the matching items themselves. Note that
  this uses the same quantity of read capacity units as getting the items, and is subject to
  the same item size calculations.    SPECIFIC_ATTRIBUTES - Returns only the attributes
  listed in ProjectionExpression. This return value is equivalent to specifying
  ProjectionExpression without specifying any value for Select. If you query or scan a local
  secondary index and request only attributes that are projected into that index, the
  operation will read only the index and not the table. If any of the requested attributes
  are not projected into the local secondary index, DynamoDB fetches each of these attributes
  from the parent table. This extra fetching incurs additional throughput cost and latency.
  If you query or scan a global secondary index, you can only request attributes that are
  projected into the index. Global secondary index queries cannot fetch attributes from the
  parent table.   If neither Select nor ProjectionExpression are specified, DynamoDB defaults
  to ALL_ATTRIBUTES when accessing a table, and ALL_PROJECTED_ATTRIBUTES when accessing an
  index. You cannot use both Select and ProjectionExpression together in a single request,
  unless the value for Select is SPECIFIC_ATTRIBUTES. (This usage is equivalent to specifying
  ProjectionExpression without any value for Select.)  If you use the ProjectionExpression
  parameter, then the value for Select can only be SPECIFIC_ATTRIBUTES. Any other value for
  Select will return an error.
"""
function query(TableName; aws_config::AbstractAWSConfig=current_aws_config())
    return dynamodb(
        "Query",
        Dict{String,Any}("TableName" => TableName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function query(
    TableName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dynamodb(
        "Query",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TableName" => TableName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    restore_table_from_backup(backup_arn, target_table_name)
    restore_table_from_backup(backup_arn, target_table_name, params::Dict{String,<:Any})

Creates a new table from an existing backup. Any number of users can execute up to 50
concurrent restores (any type of restore) in a given account.  You can call
RestoreTableFromBackup at a maximum rate of 10 times per second. You must manually set up
the following on the restored table:   Auto scaling policies   IAM policies   Amazon
CloudWatch metrics and alarms   Tags   Stream settings   Time to Live (TTL) settings

# Arguments
- `backup_arn`: The Amazon Resource Name (ARN) associated with the backup.
- `target_table_name`: The name of the new table to which the backup must be restored.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"BillingModeOverride"`: The billing mode of the restored table.
- `"GlobalSecondaryIndexOverride"`: List of global secondary indexes for the restored
  table. The indexes provided should match existing secondary indexes. You can choose to
  exclude some or all of the indexes at the time of restore.
- `"LocalSecondaryIndexOverride"`: List of local secondary indexes for the restored table.
  The indexes provided should match existing secondary indexes. You can choose to exclude
  some or all of the indexes at the time of restore.
- `"OnDemandThroughputOverride"`:
- `"ProvisionedThroughputOverride"`: Provisioned throughput settings for the restored table.
- `"SSESpecificationOverride"`: The new server-side encryption settings for the restored
  table.
"""
function restore_table_from_backup(
    BackupArn, TargetTableName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dynamodb(
        "RestoreTableFromBackup",
        Dict{String,Any}("BackupArn" => BackupArn, "TargetTableName" => TargetTableName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function restore_table_from_backup(
    BackupArn,
    TargetTableName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dynamodb(
        "RestoreTableFromBackup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "BackupArn" => BackupArn, "TargetTableName" => TargetTableName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    restore_table_to_point_in_time(target_table_name)
    restore_table_to_point_in_time(target_table_name, params::Dict{String,<:Any})

Restores the specified table to the specified point in time within
EarliestRestorableDateTime and LatestRestorableDateTime. You can restore your table to any
point in time during the last 35 days. Any number of users can execute up to 50 concurrent
restores (any type of restore) in a given account.  When you restore using point in time
recovery, DynamoDB restores your table data to the state based on the selected date and
time (day:hour:minute:second) to a new table.  Along with data, the following are also
included on the new restored table using point in time recovery:    Global secondary
indexes (GSIs)   Local secondary indexes (LSIs)   Provisioned read and write capacity
Encryption settings   All these settings come from the current settings of the source table
at the time of restore.     You must manually set up the following on the restored table:
Auto scaling policies   IAM policies   Amazon CloudWatch metrics and alarms   Tags   Stream
settings   Time to Live (TTL) settings   Point in time recovery settings

# Arguments
- `target_table_name`: The name of the new table to which it must be restored to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"BillingModeOverride"`: The billing mode of the restored table.
- `"GlobalSecondaryIndexOverride"`: List of global secondary indexes for the restored
  table. The indexes provided should match existing secondary indexes. You can choose to
  exclude some or all of the indexes at the time of restore.
- `"LocalSecondaryIndexOverride"`: List of local secondary indexes for the restored table.
  The indexes provided should match existing secondary indexes. You can choose to exclude
  some or all of the indexes at the time of restore.
- `"OnDemandThroughputOverride"`:
- `"ProvisionedThroughputOverride"`: Provisioned throughput settings for the restored table.
- `"RestoreDateTime"`: Time in the past to restore the table to.
- `"SSESpecificationOverride"`: The new server-side encryption settings for the restored
  table.
- `"SourceTableArn"`: The DynamoDB table that will be restored. This value is an Amazon
  Resource Name (ARN).
- `"SourceTableName"`: Name of the source table that is being restored.
- `"UseLatestRestorableTime"`: Restore the table to the latest possible time.
  LatestRestorableDateTime is typically 5 minutes before the current time.
"""
function restore_table_to_point_in_time(
    TargetTableName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dynamodb(
        "RestoreTableToPointInTime",
        Dict{String,Any}("TargetTableName" => TargetTableName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function restore_table_to_point_in_time(
    TargetTableName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dynamodb(
        "RestoreTableToPointInTime",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("TargetTableName" => TargetTableName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    scan(table_name)
    scan(table_name, params::Dict{String,<:Any})

The Scan operation returns one or more items and item attributes by accessing every item in
a table or a secondary index. To have DynamoDB return fewer items, you can provide a
FilterExpression operation. If the total size of scanned items exceeds the maximum dataset
size limit of 1 MB, the scan completes and results are returned to the user. The
LastEvaluatedKey value is also returned and the requestor can use the LastEvaluatedKey to
continue the scan in a subsequent operation. Each scan response also includes number of
items that were scanned (ScannedCount) as part of the request. If using a FilterExpression,
a scan result can result in no items meeting the criteria and the Count will result in
zero. If you did not use a FilterExpression in the scan request, then Count is the same as
ScannedCount.   Count and ScannedCount only return the count of items specific to a single
scan request and, unless the table is less than 1MB, do not represent the total number of
items in the table.   A single Scan operation first reads up to the maximum number of items
set (if using the Limit parameter) or a maximum of 1 MB of data and then applies any
filtering to the results if a FilterExpression is provided. If LastEvaluatedKey is present
in the response, pagination is required to complete the full table scan. For more
information, see Paginating the Results in the Amazon DynamoDB Developer Guide.  Scan
operations proceed sequentially; however, for faster performance on a large table or
secondary index, applications can request a parallel Scan operation by providing the
Segment and TotalSegments parameters. For more information, see Parallel Scan in the Amazon
DynamoDB Developer Guide. By default, a Scan uses eventually consistent reads when
accessing the items in a table. Therefore, the results from an eventually consistent Scan
may not include the latest item changes at the time the scan iterates through each item in
the table. If you require a strongly consistent read of each item as the scan iterates
through the items in the table, you can set the ConsistentRead parameter to true. Strong
consistency only relates to the consistency of the read at the item level.   DynamoDB does
not provide snapshot isolation for a scan operation when the ConsistentRead parameter is
set to true. Thus, a DynamoDB scan operation does not guarantee that all reads in a scan
see a consistent snapshot of the table when the scan operation was requested.

# Arguments
- `table_name`: The name of the table containing the requested items or if you provide
  IndexName, the name of the table to which that index belongs. You can also provide the
  Amazon Resource Name (ARN) of the table in this parameter.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AttributesToGet"`: This is a legacy parameter. Use ProjectionExpression instead. For
  more information, see AttributesToGet in the Amazon DynamoDB Developer Guide.
- `"ConditionalOperator"`: This is a legacy parameter. Use FilterExpression instead. For
  more information, see ConditionalOperator in the Amazon DynamoDB Developer Guide.
- `"ConsistentRead"`: A Boolean value that determines the read consistency model during the
  scan:   If ConsistentRead is false, then the data returned from Scan might not contain the
  results from other recently completed write operations (PutItem, UpdateItem, or
  DeleteItem).   If ConsistentRead is true, then all of the write operations that completed
  before the Scan began are guaranteed to be contained in the Scan response.   The default
  setting for ConsistentRead is false. The ConsistentRead parameter is not supported on
  global secondary indexes. If you scan a global secondary index with ConsistentRead set to
  true, you will receive a ValidationException.
- `"ExclusiveStartKey"`: The primary key of the first item that this operation will
  evaluate. Use the value that was returned for LastEvaluatedKey in the previous operation.
  The data type for ExclusiveStartKey must be String, Number or Binary. No set data types are
  allowed. In a parallel scan, a Scan request that includes ExclusiveStartKey must specify
  the same segment whose previous Scan returned the corresponding value of LastEvaluatedKey.
- `"ExpressionAttributeNames"`: One or more substitution tokens for attribute names in an
  expression. The following are some use cases for using ExpressionAttributeNames:   To
  access an attribute whose name conflicts with a DynamoDB reserved word.   To create a
  placeholder for repeating occurrences of an attribute name in an expression.   To prevent
  special characters in an attribute name from being misinterpreted in an expression.   Use
  the # character in an expression to dereference an attribute name. For example, consider
  the following attribute name:    Percentile    The name of this attribute conflicts with a
  reserved word, so it cannot be used directly in an expression. (For the complete list of
  reserved words, see Reserved Words in the Amazon DynamoDB Developer Guide). To work around
  this, you could specify the following for ExpressionAttributeNames:
  {\"#P\":\"Percentile\"}    You could then use this substitution in an expression, as in
  this example:    #P = :val     Tokens that begin with the : character are expression
  attribute values, which are placeholders for the actual value at runtime.  For more
  information on expression attribute names, see Specifying Item Attributes in the Amazon
  DynamoDB Developer Guide.
- `"ExpressionAttributeValues"`: One or more values that can be substituted in an
  expression. Use the : (colon) character in an expression to dereference an attribute value.
  For example, suppose that you wanted to check whether the value of the ProductStatus
  attribute was one of the following:   Available | Backordered | Discontinued  You would
  first need to specify ExpressionAttributeValues as follows:  {
  \":avail\":{\"S\":\"Available\"}, \":back\":{\"S\":\"Backordered\"},
  \":disc\":{\"S\":\"Discontinued\"} }  You could then use these values in an expression,
  such as this:  ProductStatus IN (:avail, :back, :disc)  For more information on expression
  attribute values, see Condition Expressions in the Amazon DynamoDB Developer Guide.
- `"FilterExpression"`: A string that contains conditions that DynamoDB applies after the
  Scan operation, but before the data is returned to you. Items that do not satisfy the
  FilterExpression criteria are not returned.  A FilterExpression is applied after the items
  have already been read; the process of filtering does not consume any additional read
  capacity units.  For more information, see Filter Expressions in the Amazon DynamoDB
  Developer Guide.
- `"IndexName"`: The name of a secondary index to scan. This index can be any local
  secondary index or global secondary index. Note that if you use the IndexName parameter,
  you must also provide TableName.
- `"Limit"`: The maximum number of items to evaluate (not necessarily the number of
  matching items). If DynamoDB processes the number of items up to the limit while processing
  the results, it stops the operation and returns the matching values up to that point, and a
  key in LastEvaluatedKey to apply in a subsequent operation, so that you can pick up where
  you left off. Also, if the processed dataset size exceeds 1 MB before DynamoDB reaches this
  limit, it stops the operation and returns the matching values up to the limit, and a key in
  LastEvaluatedKey to apply in a subsequent operation to continue the operation. For more
  information, see Working with Queries in the Amazon DynamoDB Developer Guide.
- `"ProjectionExpression"`: A string that identifies one or more attributes to retrieve
  from the specified table or index. These attributes can include scalars, sets, or elements
  of a JSON document. The attributes in the expression must be separated by commas. If no
  attribute names are specified, then all attributes will be returned. If any of the
  requested attributes are not found, they will not appear in the result. For more
  information, see Specifying Item Attributes in the Amazon DynamoDB Developer Guide.
- `"ReturnConsumedCapacity"`:
- `"ScanFilter"`: This is a legacy parameter. Use FilterExpression instead. For more
  information, see ScanFilter in the Amazon DynamoDB Developer Guide.
- `"Segment"`: For a parallel Scan request, Segment identifies an individual segment to be
  scanned by an application worker. Segment IDs are zero-based, so the first segment is
  always 0. For example, if you want to use four application threads to scan a table or an
  index, then the first thread specifies a Segment value of 0, the second thread specifies 1,
  and so on. The value of LastEvaluatedKey returned from a parallel Scan request must be used
  as ExclusiveStartKey with the same segment ID in a subsequent Scan operation. The value for
  Segment must be greater than or equal to 0, and less than the value provided for
  TotalSegments. If you provide Segment, you must also provide TotalSegments.
- `"Select"`: The attributes to be returned in the result. You can retrieve all item
  attributes, specific item attributes, the count of matching items, or in the case of an
  index, some or all of the attributes projected into the index.    ALL_ATTRIBUTES - Returns
  all of the item attributes from the specified table or index. If you query a local
  secondary index, then for each matching item in the index, DynamoDB fetches the entire item
  from the parent table. If the index is configured to project all item attributes, then all
  of the data can be obtained from the local secondary index, and no fetching is required.
  ALL_PROJECTED_ATTRIBUTES - Allowed only when querying an index. Retrieves all attributes
  that have been projected into the index. If the index is configured to project all
  attributes, this return value is equivalent to specifying ALL_ATTRIBUTES.    COUNT -
  Returns the number of matching items, rather than the matching items themselves. Note that
  this uses the same quantity of read capacity units as getting the items, and is subject to
  the same item size calculations.    SPECIFIC_ATTRIBUTES - Returns only the attributes
  listed in ProjectionExpression. This return value is equivalent to specifying
  ProjectionExpression without specifying any value for Select. If you query or scan a local
  secondary index and request only attributes that are projected into that index, the
  operation reads only the index and not the table. If any of the requested attributes are
  not projected into the local secondary index, DynamoDB fetches each of these attributes
  from the parent table. This extra fetching incurs additional throughput cost and latency.
  If you query or scan a global secondary index, you can only request attributes that are
  projected into the index. Global secondary index queries cannot fetch attributes from the
  parent table.   If neither Select nor ProjectionExpression are specified, DynamoDB defaults
  to ALL_ATTRIBUTES when accessing a table, and ALL_PROJECTED_ATTRIBUTES when accessing an
  index. You cannot use both Select and ProjectionExpression together in a single request,
  unless the value for Select is SPECIFIC_ATTRIBUTES. (This usage is equivalent to specifying
  ProjectionExpression without any value for Select.)  If you use the ProjectionExpression
  parameter, then the value for Select can only be SPECIFIC_ATTRIBUTES. Any other value for
  Select will return an error.
- `"TotalSegments"`: For a parallel Scan request, TotalSegments represents the total number
  of segments into which the Scan operation will be divided. The value of TotalSegments
  corresponds to the number of application workers that will perform the parallel scan. For
  example, if you want to use four application threads to scan a table or an index, specify a
  TotalSegments value of 4. The value for TotalSegments must be greater than or equal to 1,
  and less than or equal to 1000000. If you specify a TotalSegments value of 1, the Scan
  operation will be sequential rather than parallel. If you specify TotalSegments, you must
  also specify Segment.
"""
function scan(TableName; aws_config::AbstractAWSConfig=current_aws_config())
    return dynamodb(
        "Scan",
        Dict{String,Any}("TableName" => TableName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function scan(
    TableName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dynamodb(
        "Scan",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TableName" => TableName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Associate a set of tags with an Amazon DynamoDB resource. You can then activate these
user-defined tags so that they appear on the Billing and Cost Management console for cost
allocation tracking. You can call TagResource up to five times per second, per account.
For an overview on tagging DynamoDB resources, see Tagging for DynamoDB in the Amazon
DynamoDB Developer Guide.

# Arguments
- `resource_arn`: Identifies the Amazon DynamoDB resource to which tags should be added.
  This value is an Amazon Resource Name (ARN).
- `tags`: The tags to be assigned to the Amazon DynamoDB resource.

"""
function tag_resource(ResourceArn, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return dynamodb(
        "TagResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceArn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dynamodb(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    transact_get_items(transact_items)
    transact_get_items(transact_items, params::Dict{String,<:Any})

 TransactGetItems is a synchronous operation that atomically retrieves multiple items from
one or more tables (but not from indexes) in a single account and Region. A
TransactGetItems call can contain up to 100 TransactGetItem objects, each of which contains
a Get structure that specifies an item to retrieve from a table in the account and Region.
A call to TransactGetItems cannot retrieve items from tables in more than one Amazon Web
Services account or Region. The aggregate size of the items in the transaction cannot
exceed 4 MB. DynamoDB rejects the entire TransactGetItems request if any of the following
is true:   A conflicting operation is in the process of updating an item to be read.
There is insufficient provisioned capacity for the transaction to be completed.   There is
a user error, such as an invalid data format.   The aggregate size of the items in the
transaction exceeded 4 MB.

# Arguments
- `transact_items`: An ordered array of up to 100 TransactGetItem objects, each of which
  contains a Get structure.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ReturnConsumedCapacity"`: A value of TOTAL causes consumed capacity information to be
  returned, and a value of NONE prevents that information from being returned. No other value
  is valid.
"""
function transact_get_items(
    TransactItems; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dynamodb(
        "TransactGetItems",
        Dict{String,Any}("TransactItems" => TransactItems);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function transact_get_items(
    TransactItems,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dynamodb(
        "TransactGetItems",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TransactItems" => TransactItems), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    transact_write_items(transact_items)
    transact_write_items(transact_items, params::Dict{String,<:Any})

 TransactWriteItems is a synchronous write operation that groups up to 100 action requests.
These actions can target items in different tables, but not in different Amazon Web
Services accounts or Regions, and no two actions can target the same item. For example, you
cannot both ConditionCheck and Update the same item. The aggregate size of the items in the
transaction cannot exceed 4 MB. The actions are completed atomically so that either all of
them succeed, or all of them fail. They are defined by the following objects:    Put  —
  Initiates a PutItem operation to write a new item. This structure specifies the primary
key of the item to be written, the name of the table to write it in, an optional condition
expression that must be satisfied for the write to succeed, a list of the item's
attributes, and a field indicating whether to retrieve the item's attributes if the
condition is not met.    Update  —   Initiates an UpdateItem operation to update an
existing item. This structure specifies the primary key of the item to be updated, the name
of the table where it resides, an optional condition expression that must be satisfied for
the update to succeed, an expression that defines one or more attributes to be updated, and
a field indicating whether to retrieve the item's attributes if the condition is not met.
 Delete  —   Initiates a DeleteItem operation to delete an existing item. This
structure specifies the primary key of the item to be deleted, the name of the table where
it resides, an optional condition expression that must be satisfied for the deletion to
succeed, and a field indicating whether to retrieve the item's attributes if the condition
is not met.    ConditionCheck  —   Applies a condition to an item that is not being
modified by the transaction. This structure specifies the primary key of the item to be
checked, the name of the table where it resides, a condition expression that must be
satisfied for the transaction to succeed, and a field indicating whether to retrieve the
item's attributes if the condition is not met.   DynamoDB rejects the entire
TransactWriteItems request if any of the following is true:   A condition in one of the
condition expressions is not met.   An ongoing operation is in the process of updating the
same item.   There is insufficient provisioned capacity for the transaction to be
completed.   An item size becomes too large (bigger than 400 KB), a local secondary index
(LSI) becomes too large, or a similar validation error occurs because of changes made by
the transaction.   The aggregate size of the items in the transaction exceeds 4 MB.   There
is a user error, such as an invalid data format.

# Arguments
- `transact_items`: An ordered array of up to 100 TransactWriteItem objects, each of which
  contains a ConditionCheck, Put, Update, or Delete object. These can operate on items in
  different tables, but the tables must reside in the same Amazon Web Services account and
  Region, and no two of them can operate on the same item.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: Providing a ClientRequestToken makes the call to
  TransactWriteItems idempotent, meaning that multiple identical calls have the same effect
  as one single call. Although multiple identical calls using the same client request token
  produce the same result on the server (no side effects), the responses to the calls might
  not be the same. If the ReturnConsumedCapacity parameter is set, then the initial
  TransactWriteItems call returns the amount of write capacity units consumed in making the
  changes. Subsequent TransactWriteItems calls with the same client token return the number
  of read capacity units consumed in reading the item. A client request token is valid for 10
  minutes after the first request that uses it is completed. After 10 minutes, any request
  with the same client token is treated as a new request. Do not resubmit the same request
  with the same client token for more than 10 minutes, or the result might not be idempotent.
  If you submit a request with the same client token but a change in other parameters within
  the 10-minute idempotency window, DynamoDB returns an IdempotentParameterMismatch exception.
- `"ReturnConsumedCapacity"`:
- `"ReturnItemCollectionMetrics"`: Determines whether item collection metrics are returned.
  If set to SIZE, the response includes statistics about item collections (if any), that were
  modified during the operation and are returned in the response. If set to NONE (the
  default), no statistics are returned.
"""
function transact_write_items(
    TransactItems; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dynamodb(
        "TransactWriteItems",
        Dict{String,Any}(
            "TransactItems" => TransactItems, "ClientRequestToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function transact_write_items(
    TransactItems,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dynamodb(
        "TransactWriteItems",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "TransactItems" => TransactItems,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes the association of tags from an Amazon DynamoDB resource. You can call
UntagResource up to five times per second, per account.  For an overview on tagging
DynamoDB resources, see Tagging for DynamoDB in the Amazon DynamoDB Developer Guide.

# Arguments
- `resource_arn`: The DynamoDB resource that the tags will be removed from. This value is
  an Amazon Resource Name (ARN).
- `tag_keys`: A list of tag keys. Existing tags of the resource whose keys are members of
  this list will be removed from the DynamoDB resource.

"""
function untag_resource(
    ResourceArn, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dynamodb(
        "UntagResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceArn,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dynamodb(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_continuous_backups(point_in_time_recovery_specification, table_name)
    update_continuous_backups(point_in_time_recovery_specification, table_name, params::Dict{String,<:Any})

 UpdateContinuousBackups enables or disables point in time recovery for the specified
table. A successful UpdateContinuousBackups call returns the current
ContinuousBackupsDescription. Continuous backups are ENABLED on all tables at table
creation. If point in time recovery is enabled, PointInTimeRecoveryStatus will be set to
ENABLED.  Once continuous backups and point in time recovery are enabled, you can restore
to any point in time within EarliestRestorableDateTime and LatestRestorableDateTime.
LatestRestorableDateTime is typically 5 minutes before the current time. You can restore
your table to any point in time during the last 35 days.

# Arguments
- `point_in_time_recovery_specification`: Represents the settings used to enable point in
  time recovery.
- `table_name`: The name of the table. You can also provide the Amazon Resource Name (ARN)
  of the table in this parameter.

"""
function update_continuous_backups(
    PointInTimeRecoverySpecification,
    TableName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dynamodb(
        "UpdateContinuousBackups",
        Dict{String,Any}(
            "PointInTimeRecoverySpecification" => PointInTimeRecoverySpecification,
            "TableName" => TableName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_continuous_backups(
    PointInTimeRecoverySpecification,
    TableName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dynamodb(
        "UpdateContinuousBackups",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "PointInTimeRecoverySpecification" => PointInTimeRecoverySpecification,
                    "TableName" => TableName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_contributor_insights(contributor_insights_action, table_name)
    update_contributor_insights(contributor_insights_action, table_name, params::Dict{String,<:Any})

Updates the status for contributor insights for a specific table or index. CloudWatch
Contributor Insights for DynamoDB graphs display the partition key and (if applicable) sort
key of frequently accessed items and frequently throttled items in plaintext. If you
require the use of Amazon Web Services Key Management Service (KMS) to encrypt this
table’s partition key and sort key data with an Amazon Web Services managed key or
customer managed key, you should not enable CloudWatch Contributor Insights for DynamoDB
for this table.

# Arguments
- `contributor_insights_action`: Represents the contributor insights action.
- `table_name`: The name of the table. You can also provide the Amazon Resource Name (ARN)
  of the table in this parameter.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"IndexName"`: The global secondary index name, if applicable.
"""
function update_contributor_insights(
    ContributorInsightsAction, TableName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dynamodb(
        "UpdateContributorInsights",
        Dict{String,Any}(
            "ContributorInsightsAction" => ContributorInsightsAction,
            "TableName" => TableName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_contributor_insights(
    ContributorInsightsAction,
    TableName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dynamodb(
        "UpdateContributorInsights",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ContributorInsightsAction" => ContributorInsightsAction,
                    "TableName" => TableName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_global_table(global_table_name, replica_updates)
    update_global_table(global_table_name, replica_updates, params::Dict{String,<:Any})

Adds or removes replicas in the specified global table. The global table must already exist
to be able to use this operation. Any replica to be added must be empty, have the same name
as the global table, have the same key schema, have DynamoDB Streams enabled, and have the
same provisioned and maximum write capacity units.  This documentation is for version
2017.11.29 (Legacy) of global tables, which should be avoided for new global tables.
Customers should use Global Tables version 2019.11.21 (Current) when possible, because it
provides greater flexibility, higher efficiency, and consumes less write capacity than
2017.11.29 (Legacy). To determine which version you're using, see Determining the global
table version you are using. To update existing global tables from version 2017.11.29
(Legacy) to version 2019.11.21 (Current), see Upgrading global tables.    For global
tables, this operation only applies to global tables using Version 2019.11.21 (Current
version). If you are using global tables Version 2019.11.21 you can use UpdateTable
instead.   Although you can use UpdateGlobalTable to add replicas and remove replicas in a
single request, for simplicity we recommend that you issue separate requests for adding or
removing replicas.    If global secondary indexes are specified, then the following
conditions must also be met:     The global secondary indexes must have the same name.
The global secondary indexes must have the same hash key and sort key (if present).     The
global secondary indexes must have the same provisioned and maximum write capacity units.

# Arguments
- `global_table_name`: The global table name.
- `replica_updates`: A list of Regions that should be added or removed from the global
  table.

"""
function update_global_table(
    GlobalTableName, ReplicaUpdates; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dynamodb(
        "UpdateGlobalTable",
        Dict{String,Any}(
            "GlobalTableName" => GlobalTableName, "ReplicaUpdates" => ReplicaUpdates
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_global_table(
    GlobalTableName,
    ReplicaUpdates,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dynamodb(
        "UpdateGlobalTable",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "GlobalTableName" => GlobalTableName, "ReplicaUpdates" => ReplicaUpdates
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_global_table_settings(global_table_name)
    update_global_table_settings(global_table_name, params::Dict{String,<:Any})

Updates settings for a global table.  This documentation is for version 2017.11.29 (Legacy)
of global tables, which should be avoided for new global tables. Customers should use
Global Tables version 2019.11.21 (Current) when possible, because it provides greater
flexibility, higher efficiency, and consumes less write capacity than 2017.11.29 (Legacy).
To determine which version you're using, see Determining the global table version you are
using. To update existing global tables from version 2017.11.29 (Legacy) to version
2019.11.21 (Current), see Upgrading global tables.

# Arguments
- `global_table_name`: The name of the global table

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"GlobalTableBillingMode"`: The billing mode of the global table. If
  GlobalTableBillingMode is not specified, the global table defaults to PROVISIONED capacity
  billing mode.    PROVISIONED - We recommend using PROVISIONED for predictable workloads.
  PROVISIONED sets the billing mode to Provisioned capacity mode.    PAY_PER_REQUEST - We
  recommend using PAY_PER_REQUEST for unpredictable workloads. PAY_PER_REQUEST sets the
  billing mode to On-demand capacity mode.
- `"GlobalTableGlobalSecondaryIndexSettingsUpdate"`: Represents the settings of a global
  secondary index for a global table that will be modified.
- `"GlobalTableProvisionedWriteCapacityAutoScalingSettingsUpdate"`: Auto scaling settings
  for managing provisioned write capacity for the global table.
- `"GlobalTableProvisionedWriteCapacityUnits"`: The maximum number of writes consumed per
  second before DynamoDB returns a ThrottlingException.
- `"ReplicaSettingsUpdate"`: Represents the settings for a global table in a Region that
  will be modified.
"""
function update_global_table_settings(
    GlobalTableName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dynamodb(
        "UpdateGlobalTableSettings",
        Dict{String,Any}("GlobalTableName" => GlobalTableName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_global_table_settings(
    GlobalTableName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dynamodb(
        "UpdateGlobalTableSettings",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("GlobalTableName" => GlobalTableName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_item(key, table_name)
    update_item(key, table_name, params::Dict{String,<:Any})

Edits an existing item's attributes, or adds a new item to the table if it does not already
exist. You can put, delete, or add attribute values. You can also perform a conditional
update on an existing item (insert a new attribute name-value pair if it doesn't exist, or
replace an existing name-value pair if it has certain expected attribute values). You can
also return the item's attribute values in the same UpdateItem operation using the
ReturnValues parameter.

# Arguments
- `key`: The primary key of the item to be updated. Each element consists of an attribute
  name and a value for that attribute. For the primary key, you must provide all of the
  attributes. For example, with a simple primary key, you only need to provide a value for
  the partition key. For a composite primary key, you must provide values for both the
  partition key and the sort key.
- `table_name`: The name of the table containing the item to update. You can also provide
  the Amazon Resource Name (ARN) of the table in this parameter.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AttributeUpdates"`: This is a legacy parameter. Use UpdateExpression instead. For more
  information, see AttributeUpdates in the Amazon DynamoDB Developer Guide.
- `"ConditionExpression"`: A condition that must be satisfied in order for a conditional
  update to succeed. An expression can contain any of the following:   Functions:
  attribute_exists | attribute_not_exists | attribute_type | contains | begins_with | size
  These function names are case-sensitive.   Comparison operators: = | &lt;&gt; | &lt; | &gt;
  | &lt;= | &gt;= | BETWEEN | IN      Logical operators: AND | OR | NOT    For more
  information about condition expressions, see Specifying Conditions in the Amazon DynamoDB
  Developer Guide.
- `"ConditionalOperator"`: This is a legacy parameter. Use ConditionExpression instead. For
  more information, see ConditionalOperator in the Amazon DynamoDB Developer Guide.
- `"Expected"`: This is a legacy parameter. Use ConditionExpression instead. For more
  information, see Expected in the Amazon DynamoDB Developer Guide.
- `"ExpressionAttributeNames"`: One or more substitution tokens for attribute names in an
  expression. The following are some use cases for using ExpressionAttributeNames:   To
  access an attribute whose name conflicts with a DynamoDB reserved word.   To create a
  placeholder for repeating occurrences of an attribute name in an expression.   To prevent
  special characters in an attribute name from being misinterpreted in an expression.   Use
  the # character in an expression to dereference an attribute name. For example, consider
  the following attribute name:    Percentile    The name of this attribute conflicts with a
  reserved word, so it cannot be used directly in an expression. (For the complete list of
  reserved words, see Reserved Words in the Amazon DynamoDB Developer Guide.) To work around
  this, you could specify the following for ExpressionAttributeNames:
  {\"#P\":\"Percentile\"}    You could then use this substitution in an expression, as in
  this example:    #P = :val     Tokens that begin with the : character are expression
  attribute values, which are placeholders for the actual value at runtime.  For more
  information about expression attribute names, see Specifying Item Attributes in the Amazon
  DynamoDB Developer Guide.
- `"ExpressionAttributeValues"`: One or more values that can be substituted in an
  expression. Use the : (colon) character in an expression to dereference an attribute value.
  For example, suppose that you wanted to check whether the value of the ProductStatus
  attribute was one of the following:   Available | Backordered | Discontinued  You would
  first need to specify ExpressionAttributeValues as follows:  {
  \":avail\":{\"S\":\"Available\"}, \":back\":{\"S\":\"Backordered\"},
  \":disc\":{\"S\":\"Discontinued\"} }  You could then use these values in an expression,
  such as this:  ProductStatus IN (:avail, :back, :disc)  For more information on expression
  attribute values, see Condition Expressions in the Amazon DynamoDB Developer Guide.
- `"ReturnConsumedCapacity"`:
- `"ReturnItemCollectionMetrics"`: Determines whether item collection metrics are returned.
  If set to SIZE, the response includes statistics about item collections, if any, that were
  modified during the operation are returned in the response. If set to NONE (the default),
  no statistics are returned.
- `"ReturnValues"`: Use ReturnValues if you want to get the item attributes as they appear
  before or after they are successfully updated. For UpdateItem, the valid values are:
  NONE - If ReturnValues is not specified, or if its value is NONE, then nothing is returned.
  (This setting is the default for ReturnValues.)    ALL_OLD - Returns all of the attributes
  of the item, as they appeared before the UpdateItem operation.    UPDATED_OLD - Returns
  only the updated attributes, as they appeared before the UpdateItem operation.    ALL_NEW -
  Returns all of the attributes of the item, as they appear after the UpdateItem operation.
   UPDATED_NEW - Returns only the updated attributes, as they appear after the UpdateItem
  operation.   There is no additional cost associated with requesting a return value aside
  from the small network and processing overhead of receiving a larger response. No read
  capacity units are consumed. The values returned are strongly consistent.
- `"ReturnValuesOnConditionCheckFailure"`: An optional parameter that returns the item
  attributes for an UpdateItem operation that failed a condition check. There is no
  additional cost associated with requesting a return value aside from the small network and
  processing overhead of receiving a larger response. No read capacity units are consumed.
- `"UpdateExpression"`: An expression that defines one or more attributes to be updated,
  the action to be performed on them, and new values for them. The following action values
  are available for UpdateExpression.    SET - Adds one or more attributes and values to an
  item. If any of these attributes already exist, they are replaced by the new values. You
  can also use SET to add or subtract from an attribute that is of type Number. For example:
  SET myNum = myNum + :val   SET supports the following functions:    if_not_exists (path,
  operand) - if the item does not contain an attribute at the specified path, then
  if_not_exists evaluates to operand; otherwise, it evaluates to path. You can use this
  function to avoid overwriting an attribute that may already be present in the item.
  list_append (operand, operand) - evaluates to a list with a new element added to it. You
  can append the new element to the start or the end of the list by reversing the order of
  the operands.   These function names are case-sensitive.    REMOVE - Removes one or more
  attributes from an item.    ADD - Adds the specified value to the item, if the attribute
  does not already exist. If the attribute does exist, then the behavior of ADD depends on
  the data type of the attribute:   If the existing attribute is a number, and if Value is
  also a number, then Value is mathematically added to the existing attribute. If Value is a
  negative number, then it is subtracted from the existing attribute.  If you use ADD to
  increment or decrement a number value for an item that doesn't exist before the update,
  DynamoDB uses 0 as the initial value. Similarly, if you use ADD for an existing item to
  increment or decrement an attribute value that doesn't exist before the update, DynamoDB
  uses 0 as the initial value. For example, suppose that the item you want to update doesn't
  have an attribute named itemcount, but you decide to ADD the number 3 to this attribute
  anyway. DynamoDB will create the itemcount attribute, set its initial value to 0, and
  finally add 3 to it. The result will be a new itemcount attribute in the item, with a value
  of 3.    If the existing data type is a set and if Value is also a set, then Value is added
  to the existing set. For example, if the attribute value is the set [1,2], and the ADD
  action specified [3], then the final attribute value is [1,2,3]. An error occurs if an ADD
  action is specified for a set attribute and the attribute type specified does not match the
  existing set type.  Both sets must have the same primitive data type. For example, if the
  existing data type is a set of strings, the Value must also be a set of strings.    The ADD
  action only supports Number and set data types. In addition, ADD can only be used on
  top-level attributes, not nested attributes.     DELETE - Deletes an element from a set. If
  a set of values is specified, then those values are subtracted from the old set. For
  example, if the attribute value was the set [a,b,c] and the DELETE action specifies [a,c],
  then the final attribute value is [b]. Specifying an empty set is an error.  The DELETE
  action only supports set data types. In addition, DELETE can only be used on top-level
  attributes, not nested attributes.    You can have many actions in a single expression,
  such as the following: SET a=:value1, b=:value2 DELETE :value3, :value4, :value5  For more
  information on update expressions, see Modifying Items and Attributes in the Amazon
  DynamoDB Developer Guide.
"""
function update_item(Key, TableName; aws_config::AbstractAWSConfig=current_aws_config())
    return dynamodb(
        "UpdateItem",
        Dict{String,Any}("Key" => Key, "TableName" => TableName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_item(
    Key,
    TableName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dynamodb(
        "UpdateItem",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("Key" => Key, "TableName" => TableName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_kinesis_streaming_destination(stream_arn, table_name)
    update_kinesis_streaming_destination(stream_arn, table_name, params::Dict{String,<:Any})

The command to update the Kinesis stream destination.

# Arguments
- `stream_arn`: The Amazon Resource Name (ARN) for the Kinesis stream input.
- `table_name`: The table name for the Kinesis streaming destination input. You can also
  provide the ARN of the table in this parameter.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"UpdateKinesisStreamingConfiguration"`: The command to update the Kinesis stream
  configuration.
"""
function update_kinesis_streaming_destination(
    StreamArn, TableName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dynamodb(
        "UpdateKinesisStreamingDestination",
        Dict{String,Any}("StreamArn" => StreamArn, "TableName" => TableName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_kinesis_streaming_destination(
    StreamArn,
    TableName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dynamodb(
        "UpdateKinesisStreamingDestination",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("StreamArn" => StreamArn, "TableName" => TableName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_table(table_name)
    update_table(table_name, params::Dict{String,<:Any})

Modifies the provisioned throughput settings, global secondary indexes, or DynamoDB Streams
settings for a given table.  For global tables, this operation only applies to global
tables using Version 2019.11.21 (Current version).   You can only perform one of the
following operations at once:   Modify the provisioned throughput settings of the table.
Remove a global secondary index from the table.   Create a new global secondary index on
the table. After the index begins backfilling, you can use UpdateTable to perform other
operations.    UpdateTable is an asynchronous operation; while it's executing, the table
status changes from ACTIVE to UPDATING. While it's UPDATING, you can't issue another
UpdateTable request. When the table returns to the ACTIVE state, the UpdateTable operation
is complete.

# Arguments
- `table_name`: The name of the table to be updated. You can also provide the Amazon
  Resource Name (ARN) of the table in this parameter.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AttributeDefinitions"`: An array of attributes that describe the key schema for the
  table and indexes. If you are adding a new global secondary index to the table,
  AttributeDefinitions must include the key element(s) of the new index.
- `"BillingMode"`: Controls how you are charged for read and write throughput and how you
  manage capacity. When switching from pay-per-request to provisioned capacity, initial
  provisioned capacity values must be set. The initial provisioned capacity values are
  estimated based on the consumed read and write capacity of your table and global secondary
  indexes over the past 30 minutes.    PROVISIONED - We recommend using PROVISIONED for
  predictable workloads. PROVISIONED sets the billing mode to Provisioned capacity mode.
  PAY_PER_REQUEST - We recommend using PAY_PER_REQUEST for unpredictable workloads.
  PAY_PER_REQUEST sets the billing mode to On-demand capacity mode.
- `"DeletionProtectionEnabled"`: Indicates whether deletion protection is to be enabled
  (true) or disabled (false) on the table.
- `"GlobalSecondaryIndexUpdates"`: An array of one or more global secondary indexes for the
  table. For each index in the array, you can request one action:    Create - add a new
  global secondary index to the table.    Update - modify the provisioned throughput settings
  of an existing global secondary index.    Delete - remove a global secondary index from the
  table.   You can create or delete only one global secondary index per UpdateTable
  operation. For more information, see Managing Global Secondary Indexes in the Amazon
  DynamoDB Developer Guide.
- `"OnDemandThroughput"`: Updates the maximum number of read and write units for the
  specified table in on-demand capacity mode. If you use this parameter, you must specify
  MaxReadRequestUnits, MaxWriteRequestUnits, or both.
- `"ProvisionedThroughput"`: The new provisioned throughput settings for the specified
  table or index.
- `"ReplicaUpdates"`: A list of replica update actions (create, delete, or update) for the
  table.  For global tables, this property only applies to global tables using Version
  2019.11.21 (Current version).
- `"SSESpecification"`: The new server-side encryption settings for the specified table.
- `"StreamSpecification"`: Represents the DynamoDB Streams configuration for the table.
  You receive a ValidationException if you try to enable a stream on a table that already has
  a stream, or if you try to disable a stream on a table that doesn't have a stream.
- `"TableClass"`: The table class of the table to be updated. Valid values are STANDARD and
  STANDARD_INFREQUENT_ACCESS.
"""
function update_table(TableName; aws_config::AbstractAWSConfig=current_aws_config())
    return dynamodb(
        "UpdateTable",
        Dict{String,Any}("TableName" => TableName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_table(
    TableName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dynamodb(
        "UpdateTable",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TableName" => TableName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_table_replica_auto_scaling(table_name)
    update_table_replica_auto_scaling(table_name, params::Dict{String,<:Any})

Updates auto scaling settings on your global tables at once.  For global tables, this
operation only applies to global tables using Version 2019.11.21 (Current version).

# Arguments
- `table_name`: The name of the global table to be updated. You can also provide the Amazon
  Resource Name (ARN) of the table in this parameter.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"GlobalSecondaryIndexUpdates"`: Represents the auto scaling settings of the global
  secondary indexes of the replica to be updated.
- `"ProvisionedWriteCapacityAutoScalingUpdate"`:
- `"ReplicaUpdates"`: Represents the auto scaling settings of replicas of the table that
  will be modified.
"""
function update_table_replica_auto_scaling(
    TableName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dynamodb(
        "UpdateTableReplicaAutoScaling",
        Dict{String,Any}("TableName" => TableName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_table_replica_auto_scaling(
    TableName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dynamodb(
        "UpdateTableReplicaAutoScaling",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TableName" => TableName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_time_to_live(table_name, time_to_live_specification)
    update_time_to_live(table_name, time_to_live_specification, params::Dict{String,<:Any})

The UpdateTimeToLive method enables or disables Time to Live (TTL) for the specified table.
A successful UpdateTimeToLive call returns the current TimeToLiveSpecification. It can take
up to one hour for the change to fully process. Any additional UpdateTimeToLive calls for
the same table during this one hour duration result in a ValidationException.  TTL compares
the current time in epoch time format to the time stored in the TTL attribute of an item.
If the epoch time value stored in the attribute is less than the current time, the item is
marked as expired and subsequently deleted.   The epoch time format is the number of
seconds elapsed since 12:00:00 AM January 1, 1970 UTC.   DynamoDB deletes expired items on
a best-effort basis to ensure availability of throughput for other data operations.
DynamoDB typically deletes expired items within two days of expiration. The exact duration
within which an item gets deleted after expiration is specific to the nature of the
workload. Items that have expired and not been deleted will still show up in reads,
queries, and scans.  As items are deleted, they are removed from any local secondary index
and global secondary index immediately in the same eventually consistent way as a standard
delete operation. For more information, see Time To Live in the Amazon DynamoDB Developer
Guide.

# Arguments
- `table_name`: The name of the table to be configured. You can also provide the Amazon
  Resource Name (ARN) of the table in this parameter.
- `time_to_live_specification`: Represents the settings used to enable or disable Time to
  Live for the specified table.

"""
function update_time_to_live(
    TableName, TimeToLiveSpecification; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dynamodb(
        "UpdateTimeToLive",
        Dict{String,Any}(
            "TableName" => TableName, "TimeToLiveSpecification" => TimeToLiveSpecification
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_time_to_live(
    TableName,
    TimeToLiveSpecification,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dynamodb(
        "UpdateTimeToLive",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "TableName" => TableName,
                    "TimeToLiveSpecification" => TimeToLiveSpecification,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: cloudfront
using AWS.Compat
using AWS.UUIDs

"""
    associate_alias2020_05_31(alias, target_distribution_id)
    associate_alias2020_05_31(alias, target_distribution_id, params::Dict{String,<:Any})

Associates an alias (also known as a CNAME or an alternate domain name) with a CloudFront
distribution. With this operation you can move an alias that's already in use on a
CloudFront distribution to a different distribution in one step. This prevents the downtime
that could occur if you first remove the alias from one distribution and then separately
add the alias to another distribution. To use this operation to associate an alias with a
distribution, you provide the alias and the ID of the target distribution for the alias.
For more information, including how to set up the target distribution, prerequisites that
you must complete, and other restrictions, see Moving an alternate domain name to a
different distribution in the Amazon CloudFront Developer Guide.

# Arguments
- `alias`: The alias (also known as a CNAME) to add to the target distribution.
- `target_distribution_id`: The ID of the distribution that you're associating the alias
  with.

"""
function associate_alias2020_05_31(
    Alias, TargetDistributionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "PUT",
        "/2020-05-31/distribution/$(TargetDistributionId)/associate-alias",
        Dict{String,Any}("Alias" => Alias);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_alias2020_05_31(
    Alias,
    TargetDistributionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudfront(
        "PUT",
        "/2020-05-31/distribution/$(TargetDistributionId)/associate-alias",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Alias" => Alias), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    copy_distribution2020_05_31(caller_reference, primary_distribution_id)
    copy_distribution2020_05_31(caller_reference, primary_distribution_id, params::Dict{String,<:Any})

Creates a staging distribution using the configuration of the provided primary
distribution. A staging distribution is a copy of an existing distribution (called the
primary distribution) that you can use in a continuous deployment workflow. After you
create a staging distribution, you can use UpdateDistribution to modify the staging
distribution's configuration. Then you can use CreateContinuousDeploymentPolicy to
incrementally move traffic to the staging distribution. This API operation requires the
following IAM permissions:    GetDistribution     CreateDistribution     CopyDistribution

# Arguments
- `caller_reference`: A value that uniquely identifies a request to create a resource. This
  helps to prevent CloudFront from creating a duplicate resource if you accidentally resubmit
  an identical request.
- `primary_distribution_id`: The identifier of the primary distribution whose configuration
  you are copying. To get a distribution ID, use ListDistributions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Enabled"`: A Boolean flag to specify the state of the staging distribution when it's
  created. When you set this value to True, the staging distribution is enabled. When you set
  this value to False, the staging distribution is disabled. If you omit this field, the
  default value is True.
- `"If-Match"`: The version identifier of the primary distribution whose configuration you
  are copying. This is the ETag value returned in the response to GetDistribution and
  GetDistributionConfig.
- `"Staging"`: The type of distribution that your primary distribution will be copied to.
  The only valid value is True, indicating that you are copying to a staging distribution.
"""
function copy_distribution2020_05_31(
    CallerReference,
    PrimaryDistributionId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudfront(
        "POST",
        "/2020-05-31/distribution/$(PrimaryDistributionId)/copy",
        Dict{String,Any}("CallerReference" => CallerReference);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function copy_distribution2020_05_31(
    CallerReference,
    PrimaryDistributionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudfront(
        "POST",
        "/2020-05-31/distribution/$(PrimaryDistributionId)/copy",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("CallerReference" => CallerReference), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_cache_policy2020_05_31(cache_policy_config)
    create_cache_policy2020_05_31(cache_policy_config, params::Dict{String,<:Any})

Creates a cache policy. After you create a cache policy, you can attach it to one or more
cache behaviors. When it's attached to a cache behavior, the cache policy determines the
following:   The values that CloudFront includes in the cache key. These values can include
HTTP headers, cookies, and URL query strings. CloudFront uses the cache key to find an
object in its cache that it can return to the viewer.   The default, minimum, and maximum
time to live (TTL) values that you want objects to stay in the CloudFront cache.   The
headers, cookies, and query strings that are included in the cache key are also included in
requests that CloudFront sends to the origin. CloudFront sends a request when it can't find
an object in its cache that matches the request's cache key. If you want to send values to
the origin but not include them in the cache key, use OriginRequestPolicy. For more
information about cache policies, see Controlling the cache key in the Amazon CloudFront
Developer Guide.

# Arguments
- `cache_policy_config`: A cache policy configuration.

"""
function create_cache_policy2020_05_31(
    CachePolicyConfig; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "POST",
        "/2020-05-31/cache-policy",
        Dict{String,Any}("CachePolicyConfig" => CachePolicyConfig);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_cache_policy2020_05_31(
    CachePolicyConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudfront(
        "POST",
        "/2020-05-31/cache-policy",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("CachePolicyConfig" => CachePolicyConfig), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_cloud_front_origin_access_identity2020_05_31(cloud_front_origin_access_identity_config)
    create_cloud_front_origin_access_identity2020_05_31(cloud_front_origin_access_identity_config, params::Dict{String,<:Any})

Creates a new origin access identity. If you're using Amazon S3 for your origin, you can
use an origin access identity to require users to access your content using a CloudFront
URL instead of the Amazon S3 URL. For more information about how to use origin access
identities, see Serving Private Content through CloudFront in the Amazon CloudFront
Developer Guide.

# Arguments
- `cloud_front_origin_access_identity_config`: The current configuration information for
  the identity.

"""
function create_cloud_front_origin_access_identity2020_05_31(
    CloudFrontOriginAccessIdentityConfig; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "POST",
        "/2020-05-31/origin-access-identity/cloudfront",
        Dict{String,Any}(
            "CloudFrontOriginAccessIdentityConfig" => CloudFrontOriginAccessIdentityConfig
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_cloud_front_origin_access_identity2020_05_31(
    CloudFrontOriginAccessIdentityConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudfront(
        "POST",
        "/2020-05-31/origin-access-identity/cloudfront",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CloudFrontOriginAccessIdentityConfig" =>
                        CloudFrontOriginAccessIdentityConfig,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_continuous_deployment_policy2020_05_31(continuous_deployment_policy_config)
    create_continuous_deployment_policy2020_05_31(continuous_deployment_policy_config, params::Dict{String,<:Any})

Creates a continuous deployment policy that distributes traffic for a custom domain name to
two different CloudFront distributions. To use a continuous deployment policy, first use
CopyDistribution to create a staging distribution, then use UpdateDistribution to modify
the staging distribution's configuration. After you create and update a staging
distribution, you can use a continuous deployment policy to incrementally move traffic to
the staging distribution. This workflow enables you to test changes to a distribution's
configuration before moving all of your domain's production traffic to the new
configuration.

# Arguments
- `continuous_deployment_policy_config`: Contains the configuration for a continuous
  deployment policy.

"""
function create_continuous_deployment_policy2020_05_31(
    ContinuousDeploymentPolicyConfig; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "POST",
        "/2020-05-31/continuous-deployment-policy",
        Dict{String,Any}(
            "ContinuousDeploymentPolicyConfig" => ContinuousDeploymentPolicyConfig
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_continuous_deployment_policy2020_05_31(
    ContinuousDeploymentPolicyConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudfront(
        "POST",
        "/2020-05-31/continuous-deployment-policy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ContinuousDeploymentPolicyConfig" => ContinuousDeploymentPolicyConfig
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_distribution2020_05_31(distribution_config)
    create_distribution2020_05_31(distribution_config, params::Dict{String,<:Any})

Creates a CloudFront distribution.

# Arguments
- `distribution_config`: The distribution's configuration information.

"""
function create_distribution2020_05_31(
    DistributionConfig; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "POST",
        "/2020-05-31/distribution",
        Dict{String,Any}("DistributionConfig" => DistributionConfig);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_distribution2020_05_31(
    DistributionConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudfront(
        "POST",
        "/2020-05-31/distribution",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("DistributionConfig" => DistributionConfig), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_distribution_with_tags2020_05_31(distribution_config_with_tags)
    create_distribution_with_tags2020_05_31(distribution_config_with_tags, params::Dict{String,<:Any})

Create a new distribution with tags. This API operation requires the following IAM
permissions:    CreateDistribution     TagResource

# Arguments
- `distribution_config_with_tags`: The distribution's configuration information.

"""
function create_distribution_with_tags2020_05_31(
    DistributionConfigWithTags; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "POST",
        "/2020-05-31/distribution?WithTags",
        Dict{String,Any}("DistributionConfigWithTags" => DistributionConfigWithTags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_distribution_with_tags2020_05_31(
    DistributionConfigWithTags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudfront(
        "POST",
        "/2020-05-31/distribution?WithTags",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DistributionConfigWithTags" => DistributionConfigWithTags
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_field_level_encryption_config2020_05_31(field_level_encryption_config)
    create_field_level_encryption_config2020_05_31(field_level_encryption_config, params::Dict{String,<:Any})

Create a new field-level encryption configuration.

# Arguments
- `field_level_encryption_config`: The request to create a new field-level encryption
  configuration.

"""
function create_field_level_encryption_config2020_05_31(
    FieldLevelEncryptionConfig; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "POST",
        "/2020-05-31/field-level-encryption",
        Dict{String,Any}("FieldLevelEncryptionConfig" => FieldLevelEncryptionConfig);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_field_level_encryption_config2020_05_31(
    FieldLevelEncryptionConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudfront(
        "POST",
        "/2020-05-31/field-level-encryption",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "FieldLevelEncryptionConfig" => FieldLevelEncryptionConfig
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_field_level_encryption_profile2020_05_31(field_level_encryption_profile_config)
    create_field_level_encryption_profile2020_05_31(field_level_encryption_profile_config, params::Dict{String,<:Any})

Create a field-level encryption profile.

# Arguments
- `field_level_encryption_profile_config`: The request to create a field-level encryption
  profile.

"""
function create_field_level_encryption_profile2020_05_31(
    FieldLevelEncryptionProfileConfig; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "POST",
        "/2020-05-31/field-level-encryption-profile",
        Dict{String,Any}(
            "FieldLevelEncryptionProfileConfig" => FieldLevelEncryptionProfileConfig
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_field_level_encryption_profile2020_05_31(
    FieldLevelEncryptionProfileConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudfront(
        "POST",
        "/2020-05-31/field-level-encryption-profile",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "FieldLevelEncryptionProfileConfig" => FieldLevelEncryptionProfileConfig
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_function2020_05_31(function_code, function_config, name)
    create_function2020_05_31(function_code, function_config, name, params::Dict{String,<:Any})

Creates a CloudFront function. To create a function, you provide the function code and some
configuration information about the function. The response contains an Amazon Resource Name
(ARN) that uniquely identifies the function. When you create a function, it's in the
DEVELOPMENT stage. In this stage, you can test the function with TestFunction, and update
it with UpdateFunction. When you're ready to use your function with a CloudFront
distribution, use PublishFunction to copy the function from the DEVELOPMENT stage to LIVE.
When it's live, you can attach the function to a distribution's cache behavior, using the
function's ARN.

# Arguments
- `function_code`: The function code. For more information about writing a CloudFront
  function, see Writing function code for CloudFront Functions in the Amazon CloudFront
  Developer Guide.
- `function_config`: Configuration information about the function, including an optional
  comment and the function's runtime.
- `name`: A name to identify the function.

"""
function create_function2020_05_31(
    FunctionCode, FunctionConfig, Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "POST",
        "/2020-05-31/function",
        Dict{String,Any}(
            "FunctionCode" => FunctionCode,
            "FunctionConfig" => FunctionConfig,
            "Name" => Name,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_function2020_05_31(
    FunctionCode,
    FunctionConfig,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudfront(
        "POST",
        "/2020-05-31/function",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "FunctionCode" => FunctionCode,
                    "FunctionConfig" => FunctionConfig,
                    "Name" => Name,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_invalidation2020_05_31(distribution_id, invalidation_batch)
    create_invalidation2020_05_31(distribution_id, invalidation_batch, params::Dict{String,<:Any})

Create a new invalidation. For more information, see Invalidating files in the Amazon
CloudFront Developer Guide.

# Arguments
- `distribution_id`: The distribution's id.
- `invalidation_batch`: The batch information for the invalidation.

"""
function create_invalidation2020_05_31(
    DistributionId, InvalidationBatch; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "POST",
        "/2020-05-31/distribution/$(DistributionId)/invalidation",
        Dict{String,Any}("InvalidationBatch" => InvalidationBatch);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_invalidation2020_05_31(
    DistributionId,
    InvalidationBatch,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudfront(
        "POST",
        "/2020-05-31/distribution/$(DistributionId)/invalidation",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("InvalidationBatch" => InvalidationBatch), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_key_group2020_05_31(key_group_config)
    create_key_group2020_05_31(key_group_config, params::Dict{String,<:Any})

Creates a key group that you can use with CloudFront signed URLs and signed cookies. To
create a key group, you must specify at least one public key for the key group. After you
create a key group, you can reference it from one or more cache behaviors. When you
reference a key group in a cache behavior, CloudFront requires signed URLs or signed
cookies for all requests that match the cache behavior. The URLs or cookies must be signed
with a private key whose corresponding public key is in the key group. The signed URL or
cookie contains information about which public key CloudFront should use to verify the
signature. For more information, see Serving private content in the Amazon CloudFront
Developer Guide.

# Arguments
- `key_group_config`: A key group configuration.

"""
function create_key_group2020_05_31(
    KeyGroupConfig; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "POST",
        "/2020-05-31/key-group",
        Dict{String,Any}("KeyGroupConfig" => KeyGroupConfig);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_key_group2020_05_31(
    KeyGroupConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudfront(
        "POST",
        "/2020-05-31/key-group",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("KeyGroupConfig" => KeyGroupConfig), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_key_value_store2020_05_31(name)
    create_key_value_store2020_05_31(name, params::Dict{String,<:Any})

Specifies the key value store resource to add to your account. In your account, the key
value store names must be unique. You can also import key value store data in JSON format
from an S3 bucket by providing a valid ImportSource that you own.

# Arguments
- `name`: The name of the key value store. The minimum length is 1 character and the
  maximum length is 64 characters.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Comment"`: The comment of the key value store.
- `"ImportSource"`: The S3 bucket that provides the source for the import. The source must
  be in a valid JSON format.
"""
function create_key_value_store2020_05_31(
    Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "POST",
        "/2020-05-31/key-value-store/",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_key_value_store2020_05_31(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "POST",
        "/2020-05-31/key-value-store/",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_monitoring_subscription2020_05_31(distribution_id, monitoring_subscription)
    create_monitoring_subscription2020_05_31(distribution_id, monitoring_subscription, params::Dict{String,<:Any})

Enables additional CloudWatch metrics for the specified CloudFront distribution. The
additional metrics incur an additional cost. For more information, see Viewing additional
CloudFront distribution metrics in the Amazon CloudFront Developer Guide.

# Arguments
- `distribution_id`: The ID of the distribution that you are enabling metrics for.
- `monitoring_subscription`: A monitoring subscription. This structure contains information
  about whether additional CloudWatch metrics are enabled for a given CloudFront distribution.

"""
function create_monitoring_subscription2020_05_31(
    DistributionId,
    MonitoringSubscription;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudfront(
        "POST",
        "/2020-05-31/distributions/$(DistributionId)/monitoring-subscription/",
        Dict{String,Any}("MonitoringSubscription" => MonitoringSubscription);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_monitoring_subscription2020_05_31(
    DistributionId,
    MonitoringSubscription,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudfront(
        "POST",
        "/2020-05-31/distributions/$(DistributionId)/monitoring-subscription/",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("MonitoringSubscription" => MonitoringSubscription),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_origin_access_control2020_05_31(origin_access_control_config)
    create_origin_access_control2020_05_31(origin_access_control_config, params::Dict{String,<:Any})

Creates a new origin access control in CloudFront. After you create an origin access
control, you can add it to an origin in a CloudFront distribution so that CloudFront sends
authenticated (signed) requests to the origin. This makes it possible to block public
access to the origin, allowing viewers (users) to access the origin's content only through
CloudFront. For more information about using a CloudFront origin access control, see
Restricting access to an Amazon Web Services origin in the Amazon CloudFront Developer
Guide.

# Arguments
- `origin_access_control_config`: Contains the origin access control.

"""
function create_origin_access_control2020_05_31(
    OriginAccessControlConfig; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "POST",
        "/2020-05-31/origin-access-control",
        Dict{String,Any}("OriginAccessControlConfig" => OriginAccessControlConfig);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_origin_access_control2020_05_31(
    OriginAccessControlConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudfront(
        "POST",
        "/2020-05-31/origin-access-control",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("OriginAccessControlConfig" => OriginAccessControlConfig),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_origin_request_policy2020_05_31(origin_request_policy_config)
    create_origin_request_policy2020_05_31(origin_request_policy_config, params::Dict{String,<:Any})

Creates an origin request policy. After you create an origin request policy, you can attach
it to one or more cache behaviors. When it's attached to a cache behavior, the origin
request policy determines the values that CloudFront includes in requests that it sends to
the origin. Each request that CloudFront sends to the origin includes the following:   The
request body and the URL path (without the domain name) from the viewer request.   The
headers that CloudFront automatically includes in every origin request, including Host,
User-Agent, and X-Amz-Cf-Id.   All HTTP headers, cookies, and URL query strings that are
specified in the cache policy or the origin request policy. These can include items from
the viewer request and, in the case of headers, additional ones that are added by
CloudFront.   CloudFront sends a request when it can't find a valid object in its cache
that matches the request. If you want to send values to the origin and also include them in
the cache key, use CachePolicy. For more information about origin request policies, see
Controlling origin requests in the Amazon CloudFront Developer Guide.

# Arguments
- `origin_request_policy_config`: An origin request policy configuration.

"""
function create_origin_request_policy2020_05_31(
    OriginRequestPolicyConfig; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "POST",
        "/2020-05-31/origin-request-policy",
        Dict{String,Any}("OriginRequestPolicyConfig" => OriginRequestPolicyConfig);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_origin_request_policy2020_05_31(
    OriginRequestPolicyConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudfront(
        "POST",
        "/2020-05-31/origin-request-policy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("OriginRequestPolicyConfig" => OriginRequestPolicyConfig),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_public_key2020_05_31(public_key_config)
    create_public_key2020_05_31(public_key_config, params::Dict{String,<:Any})

Uploads a public key to CloudFront that you can use with signed URLs and signed cookies, or
with field-level encryption.

# Arguments
- `public_key_config`: A CloudFront public key configuration.

"""
function create_public_key2020_05_31(
    PublicKeyConfig; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "POST",
        "/2020-05-31/public-key",
        Dict{String,Any}("PublicKeyConfig" => PublicKeyConfig);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_public_key2020_05_31(
    PublicKeyConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudfront(
        "POST",
        "/2020-05-31/public-key",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("PublicKeyConfig" => PublicKeyConfig), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_realtime_log_config2020_05_31(end_points, field, name, sampling_rate)
    create_realtime_log_config2020_05_31(end_points, field, name, sampling_rate, params::Dict{String,<:Any})

Creates a real-time log configuration. After you create a real-time log configuration, you
can attach it to one or more cache behaviors to send real-time log data to the specified
Amazon Kinesis data stream. For more information about real-time log configurations, see
Real-time logs in the Amazon CloudFront Developer Guide.

# Arguments
- `end_points`: Contains information about the Amazon Kinesis data stream where you are
  sending real-time log data.
- `field`: A list of fields to include in each real-time log record. For more information
  about fields, see Real-time log configuration fields in the Amazon CloudFront Developer
  Guide.
- `name`: A unique name to identify this real-time log configuration.
- `sampling_rate`: The sampling rate for this real-time log configuration. You can specify
  a whole number between 1 and 100 (inclusive) to determine the percentage of viewer requests
  that are represented in the real-time log data.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Fields"`: A list of fields to include in each real-time log record. For more
  information about fields, see Real-time log configuration fields in the Amazon CloudFront
  Developer Guide.
"""
function create_realtime_log_config2020_05_31(
    EndPoints, Field, Name, SamplingRate; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "POST",
        "/2020-05-31/realtime-log-config",
        Dict{String,Any}(
            "EndPoints" => EndPoints,
            "Field" => Field,
            "Name" => Name,
            "SamplingRate" => SamplingRate,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_realtime_log_config2020_05_31(
    EndPoints,
    Field,
    Name,
    SamplingRate,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudfront(
        "POST",
        "/2020-05-31/realtime-log-config",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EndPoints" => EndPoints,
                    "Field" => Field,
                    "Name" => Name,
                    "SamplingRate" => SamplingRate,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_response_headers_policy2020_05_31(response_headers_policy_config)
    create_response_headers_policy2020_05_31(response_headers_policy_config, params::Dict{String,<:Any})

Creates a response headers policy. A response headers policy contains information about a
set of HTTP headers. To create a response headers policy, you provide some metadata about
the policy and a set of configurations that specify the headers. After you create a
response headers policy, you can use its ID to attach it to one or more cache behaviors in
a CloudFront distribution. When it's attached to a cache behavior, the response headers
policy affects the HTTP headers that CloudFront includes in HTTP responses to requests that
match the cache behavior. CloudFront adds or removes response headers according to the
configuration of the response headers policy. For more information, see Adding or removing
HTTP headers in CloudFront responses in the Amazon CloudFront Developer Guide.

# Arguments
- `response_headers_policy_config`: Contains metadata about the response headers policy,
  and a set of configurations that specify the HTTP headers.

"""
function create_response_headers_policy2020_05_31(
    ResponseHeadersPolicyConfig; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "POST",
        "/2020-05-31/response-headers-policy",
        Dict{String,Any}("ResponseHeadersPolicyConfig" => ResponseHeadersPolicyConfig);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_response_headers_policy2020_05_31(
    ResponseHeadersPolicyConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudfront(
        "POST",
        "/2020-05-31/response-headers-policy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ResponseHeadersPolicyConfig" => ResponseHeadersPolicyConfig
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_streaming_distribution2020_05_31(streaming_distribution_config)
    create_streaming_distribution2020_05_31(streaming_distribution_config, params::Dict{String,<:Any})

This API is deprecated. Amazon CloudFront is deprecating real-time messaging protocol
(RTMP) distributions on December 31, 2020. For more information, read the announcement on
the Amazon CloudFront discussion forum.

# Arguments
- `streaming_distribution_config`: The streaming distribution's configuration information.

"""
function create_streaming_distribution2020_05_31(
    StreamingDistributionConfig; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "POST",
        "/2020-05-31/streaming-distribution",
        Dict{String,Any}("StreamingDistributionConfig" => StreamingDistributionConfig);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_streaming_distribution2020_05_31(
    StreamingDistributionConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudfront(
        "POST",
        "/2020-05-31/streaming-distribution",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "StreamingDistributionConfig" => StreamingDistributionConfig
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_streaming_distribution_with_tags2020_05_31(streaming_distribution_config_with_tags)
    create_streaming_distribution_with_tags2020_05_31(streaming_distribution_config_with_tags, params::Dict{String,<:Any})

This API is deprecated. Amazon CloudFront is deprecating real-time messaging protocol
(RTMP) distributions on December 31, 2020. For more information, read the announcement on
the Amazon CloudFront discussion forum.

# Arguments
- `streaming_distribution_config_with_tags`: The streaming distribution's configuration
  information.

"""
function create_streaming_distribution_with_tags2020_05_31(
    StreamingDistributionConfigWithTags; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "POST",
        "/2020-05-31/streaming-distribution?WithTags",
        Dict{String,Any}(
            "StreamingDistributionConfigWithTags" => StreamingDistributionConfigWithTags
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_streaming_distribution_with_tags2020_05_31(
    StreamingDistributionConfigWithTags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudfront(
        "POST",
        "/2020-05-31/streaming-distribution?WithTags",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "StreamingDistributionConfigWithTags" =>
                        StreamingDistributionConfigWithTags,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_cache_policy2020_05_31(id)
    delete_cache_policy2020_05_31(id, params::Dict{String,<:Any})

Deletes a cache policy. You cannot delete a cache policy if it's attached to a cache
behavior. First update your distributions to remove the cache policy from all cache
behaviors, then delete the cache policy. To delete a cache policy, you must provide the
policy's identifier and version. To get these values, you can use ListCachePolicies or
GetCachePolicy.

# Arguments
- `id`: The unique identifier for the cache policy that you are deleting. To get the
  identifier, you can use ListCachePolicies.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"If-Match"`: The version of the cache policy that you are deleting. The version is the
  cache policy's ETag value, which you can get using ListCachePolicies, GetCachePolicy, or
  GetCachePolicyConfig.
"""
function delete_cache_policy2020_05_31(
    Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "DELETE",
        "/2020-05-31/cache-policy/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_cache_policy2020_05_31(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "DELETE",
        "/2020-05-31/cache-policy/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_cloud_front_origin_access_identity2020_05_31(id)
    delete_cloud_front_origin_access_identity2020_05_31(id, params::Dict{String,<:Any})

Delete an origin access identity.

# Arguments
- `id`: The origin access identity's ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"If-Match"`: The value of the ETag header you received from a previous GET or PUT
  request. For example: E2QWRUHAPOMQZL.
"""
function delete_cloud_front_origin_access_identity2020_05_31(
    Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "DELETE",
        "/2020-05-31/origin-access-identity/cloudfront/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_cloud_front_origin_access_identity2020_05_31(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "DELETE",
        "/2020-05-31/origin-access-identity/cloudfront/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_continuous_deployment_policy2020_05_31(id)
    delete_continuous_deployment_policy2020_05_31(id, params::Dict{String,<:Any})

Deletes a continuous deployment policy. You cannot delete a continuous deployment policy
that's attached to a primary distribution. First update your distribution to remove the
continuous deployment policy, then you can delete the policy.

# Arguments
- `id`: The identifier of the continuous deployment policy that you are deleting.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"If-Match"`: The current version (ETag value) of the continuous deployment policy that
  you are deleting.
"""
function delete_continuous_deployment_policy2020_05_31(
    Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "DELETE",
        "/2020-05-31/continuous-deployment-policy/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_continuous_deployment_policy2020_05_31(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "DELETE",
        "/2020-05-31/continuous-deployment-policy/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_distribution2020_05_31(id)
    delete_distribution2020_05_31(id, params::Dict{String,<:Any})

Delete a distribution.

# Arguments
- `id`: The distribution ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"If-Match"`: The value of the ETag header that you received when you disabled the
  distribution. For example: E2QWRUHAPOMQZL.
"""
function delete_distribution2020_05_31(
    Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "DELETE",
        "/2020-05-31/distribution/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_distribution2020_05_31(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "DELETE",
        "/2020-05-31/distribution/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_field_level_encryption_config2020_05_31(id)
    delete_field_level_encryption_config2020_05_31(id, params::Dict{String,<:Any})

Remove a field-level encryption configuration.

# Arguments
- `id`: The ID of the configuration you want to delete from CloudFront.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"If-Match"`: The value of the ETag header that you received when retrieving the
  configuration identity to delete. For example: E2QWRUHAPOMQZL.
"""
function delete_field_level_encryption_config2020_05_31(
    Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "DELETE",
        "/2020-05-31/field-level-encryption/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_field_level_encryption_config2020_05_31(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "DELETE",
        "/2020-05-31/field-level-encryption/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_field_level_encryption_profile2020_05_31(id)
    delete_field_level_encryption_profile2020_05_31(id, params::Dict{String,<:Any})

Remove a field-level encryption profile.

# Arguments
- `id`: Request the ID of the profile you want to delete from CloudFront.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"If-Match"`: The value of the ETag header that you received when retrieving the profile
  to delete. For example: E2QWRUHAPOMQZL.
"""
function delete_field_level_encryption_profile2020_05_31(
    Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "DELETE",
        "/2020-05-31/field-level-encryption-profile/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_field_level_encryption_profile2020_05_31(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "DELETE",
        "/2020-05-31/field-level-encryption-profile/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_function2020_05_31(if-_match, name)
    delete_function2020_05_31(if-_match, name, params::Dict{String,<:Any})

Deletes a CloudFront function. You cannot delete a function if it's associated with a cache
behavior. First, update your distributions to remove the function association from all
cache behaviors, then delete the function. To delete a function, you must provide the
function's name and version (ETag value). To get these values, you can use ListFunctions
and DescribeFunction.

# Arguments
- `if-_match`: The current version (ETag value) of the function that you are deleting,
  which you can get using DescribeFunction.
- `name`: The name of the function that you are deleting.

"""
function delete_function2020_05_31(
    If_Match, Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "DELETE",
        "/2020-05-31/function/$(Name)",
        Dict{String,Any}("headers" => Dict{String,Any}("If-Match" => If_Match));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_function2020_05_31(
    If_Match,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudfront(
        "DELETE",
        "/2020-05-31/function/$(Name)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("headers" => Dict{String,Any}("If-Match" => If_Match)),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_key_group2020_05_31(id)
    delete_key_group2020_05_31(id, params::Dict{String,<:Any})

Deletes a key group. You cannot delete a key group that is referenced in a cache behavior.
First update your distributions to remove the key group from all cache behaviors, then
delete the key group. To delete a key group, you must provide the key group's identifier
and version. To get these values, use ListKeyGroups followed by GetKeyGroup or
GetKeyGroupConfig.

# Arguments
- `id`: The identifier of the key group that you are deleting. To get the identifier, use
  ListKeyGroups.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"If-Match"`: The version of the key group that you are deleting. The version is the key
  group's ETag value. To get the ETag, use GetKeyGroup or GetKeyGroupConfig.
"""
function delete_key_group2020_05_31(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudfront(
        "DELETE",
        "/2020-05-31/key-group/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_key_group2020_05_31(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "DELETE",
        "/2020-05-31/key-group/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_key_value_store2020_05_31(if-_match, name)
    delete_key_value_store2020_05_31(if-_match, name, params::Dict{String,<:Any})

Specifies the key value store to delete.

# Arguments
- `if-_match`: The key value store to delete, if a match occurs.
- `name`: The name of the key value store.

"""
function delete_key_value_store2020_05_31(
    If_Match, Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "DELETE",
        "/2020-05-31/key-value-store/$(Name)",
        Dict{String,Any}("headers" => Dict{String,Any}("If-Match" => If_Match));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_key_value_store2020_05_31(
    If_Match,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudfront(
        "DELETE",
        "/2020-05-31/key-value-store/$(Name)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("headers" => Dict{String,Any}("If-Match" => If_Match)),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_monitoring_subscription2020_05_31(distribution_id)
    delete_monitoring_subscription2020_05_31(distribution_id, params::Dict{String,<:Any})

Disables additional CloudWatch metrics for the specified CloudFront distribution.

# Arguments
- `distribution_id`: The ID of the distribution that you are disabling metrics for.

"""
function delete_monitoring_subscription2020_05_31(
    DistributionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "DELETE",
        "/2020-05-31/distributions/$(DistributionId)/monitoring-subscription/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_monitoring_subscription2020_05_31(
    DistributionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudfront(
        "DELETE",
        "/2020-05-31/distributions/$(DistributionId)/monitoring-subscription/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_origin_access_control2020_05_31(id)
    delete_origin_access_control2020_05_31(id, params::Dict{String,<:Any})

Deletes a CloudFront origin access control. You cannot delete an origin access control if
it's in use. First, update all distributions to remove the origin access control from all
origins, then delete the origin access control.

# Arguments
- `id`: The unique identifier of the origin access control that you are deleting.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"If-Match"`: The current version (ETag value) of the origin access control that you are
  deleting.
"""
function delete_origin_access_control2020_05_31(
    Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "DELETE",
        "/2020-05-31/origin-access-control/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_origin_access_control2020_05_31(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "DELETE",
        "/2020-05-31/origin-access-control/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_origin_request_policy2020_05_31(id)
    delete_origin_request_policy2020_05_31(id, params::Dict{String,<:Any})

Deletes an origin request policy. You cannot delete an origin request policy if it's
attached to any cache behaviors. First update your distributions to remove the origin
request policy from all cache behaviors, then delete the origin request policy. To delete
an origin request policy, you must provide the policy's identifier and version. To get the
identifier, you can use ListOriginRequestPolicies or GetOriginRequestPolicy.

# Arguments
- `id`: The unique identifier for the origin request policy that you are deleting. To get
  the identifier, you can use ListOriginRequestPolicies.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"If-Match"`: The version of the origin request policy that you are deleting. The version
  is the origin request policy's ETag value, which you can get using
  ListOriginRequestPolicies, GetOriginRequestPolicy, or GetOriginRequestPolicyConfig.
"""
function delete_origin_request_policy2020_05_31(
    Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "DELETE",
        "/2020-05-31/origin-request-policy/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_origin_request_policy2020_05_31(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "DELETE",
        "/2020-05-31/origin-request-policy/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_public_key2020_05_31(id)
    delete_public_key2020_05_31(id, params::Dict{String,<:Any})

Remove a public key you previously added to CloudFront.

# Arguments
- `id`: The ID of the public key you want to remove from CloudFront.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"If-Match"`: The value of the ETag header that you received when retrieving the public
  key identity to delete. For example: E2QWRUHAPOMQZL.
"""
function delete_public_key2020_05_31(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudfront(
        "DELETE",
        "/2020-05-31/public-key/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_public_key2020_05_31(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "DELETE",
        "/2020-05-31/public-key/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_realtime_log_config2020_05_31()
    delete_realtime_log_config2020_05_31(params::Dict{String,<:Any})

Deletes a real-time log configuration. You cannot delete a real-time log configuration if
it's attached to a cache behavior. First update your distributions to remove the real-time
log configuration from all cache behaviors, then delete the real-time log configuration. To
delete a real-time log configuration, you can provide the configuration's name or its
Amazon Resource Name (ARN). You must provide at least one. If you provide both, CloudFront
uses the name to identify the real-time log configuration to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ARN"`: The Amazon Resource Name (ARN) of the real-time log configuration to delete.
- `"Name"`: The name of the real-time log configuration to delete.
"""
function delete_realtime_log_config2020_05_31(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "POST",
        "/2020-05-31/delete-realtime-log-config/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_realtime_log_config2020_05_31(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "POST",
        "/2020-05-31/delete-realtime-log-config/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_response_headers_policy2020_05_31(id)
    delete_response_headers_policy2020_05_31(id, params::Dict{String,<:Any})

Deletes a response headers policy. You cannot delete a response headers policy if it's
attached to a cache behavior. First update your distributions to remove the response
headers policy from all cache behaviors, then delete the response headers policy. To delete
a response headers policy, you must provide the policy's identifier and version. To get
these values, you can use ListResponseHeadersPolicies or GetResponseHeadersPolicy.

# Arguments
- `id`: The identifier for the response headers policy that you are deleting. To get the
  identifier, you can use ListResponseHeadersPolicies.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"If-Match"`: The version of the response headers policy that you are deleting. The
  version is the response headers policy's ETag value, which you can get using
  ListResponseHeadersPolicies, GetResponseHeadersPolicy, or GetResponseHeadersPolicyConfig.
"""
function delete_response_headers_policy2020_05_31(
    Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "DELETE",
        "/2020-05-31/response-headers-policy/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_response_headers_policy2020_05_31(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "DELETE",
        "/2020-05-31/response-headers-policy/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_streaming_distribution2020_05_31(id)
    delete_streaming_distribution2020_05_31(id, params::Dict{String,<:Any})

Delete a streaming distribution. To delete an RTMP distribution using the CloudFront API,
perform the following steps.  To delete an RTMP distribution using the CloudFront API:
Disable the RTMP distribution.   Submit a GET Streaming Distribution Config request to get
the current configuration and the Etag header for the distribution.    Update the XML
document that was returned in the response to your GET Streaming Distribution Config
request to change the value of Enabled to false.   Submit a PUT Streaming Distribution
Config request to update the configuration for your distribution. In the request body,
include the XML document that you updated in Step 3. Then set the value of the HTTP
If-Match header to the value of the ETag header that CloudFront returned when you submitted
the GET Streaming Distribution Config request in Step 2.   Review the response to the PUT
Streaming Distribution Config request to confirm that the distribution was successfully
disabled.   Submit a GET Streaming Distribution Config request to confirm that your changes
have propagated. When propagation is complete, the value of Status is Deployed.   Submit a
DELETE Streaming Distribution request. Set the value of the HTTP If-Match header to the
value of the ETag header that CloudFront returned when you submitted the GET Streaming
Distribution Config request in Step 2.   Review the response to your DELETE Streaming
Distribution request to confirm that the distribution was successfully deleted.   For
information about deleting a distribution using the CloudFront console, see Deleting a
Distribution in the Amazon CloudFront Developer Guide.

# Arguments
- `id`: The distribution ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"If-Match"`: The value of the ETag header that you received when you disabled the
  streaming distribution. For example: E2QWRUHAPOMQZL.
"""
function delete_streaming_distribution2020_05_31(
    Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "DELETE",
        "/2020-05-31/streaming-distribution/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_streaming_distribution2020_05_31(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "DELETE",
        "/2020-05-31/streaming-distribution/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_function2020_05_31(name)
    describe_function2020_05_31(name, params::Dict{String,<:Any})

Gets configuration information and metadata about a CloudFront function, but not the
function's code. To get a function's code, use GetFunction. To get configuration
information and metadata about a function, you must provide the function's name and stage.
To get these values, you can use ListFunctions.

# Arguments
- `name`: The name of the function that you are getting information about.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Stage"`: The function's stage, either DEVELOPMENT or LIVE.
"""
function describe_function2020_05_31(
    Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/function/$(Name)/describe";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_function2020_05_31(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/function/$(Name)/describe",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_key_value_store2020_05_31(name)
    describe_key_value_store2020_05_31(name, params::Dict{String,<:Any})

Specifies the key value store and its configuration.

# Arguments
- `name`: The name of the key value store.

"""
function describe_key_value_store2020_05_31(
    Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/key-value-store/$(Name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_key_value_store2020_05_31(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/key-value-store/$(Name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_cache_policy2020_05_31(id)
    get_cache_policy2020_05_31(id, params::Dict{String,<:Any})

Gets a cache policy, including the following metadata:   The policy's identifier.   The
date and time when the policy was last modified.   To get a cache policy, you must provide
the policy's identifier. If the cache policy is attached to a distribution's cache
behavior, you can get the policy's identifier using ListDistributions or GetDistribution.
If the cache policy is not attached to a cache behavior, you can get the identifier using
ListCachePolicies.

# Arguments
- `id`: The unique identifier for the cache policy. If the cache policy is attached to a
  distribution's cache behavior, you can get the policy's identifier using ListDistributions
  or GetDistribution. If the cache policy is not attached to a cache behavior, you can get
  the identifier using ListCachePolicies.

"""
function get_cache_policy2020_05_31(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudfront(
        "GET",
        "/2020-05-31/cache-policy/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_cache_policy2020_05_31(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/cache-policy/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_cache_policy_config2020_05_31(id)
    get_cache_policy_config2020_05_31(id, params::Dict{String,<:Any})

Gets a cache policy configuration. To get a cache policy configuration, you must provide
the policy's identifier. If the cache policy is attached to a distribution's cache
behavior, you can get the policy's identifier using ListDistributions or GetDistribution.
If the cache policy is not attached to a cache behavior, you can get the identifier using
ListCachePolicies.

# Arguments
- `id`: The unique identifier for the cache policy. If the cache policy is attached to a
  distribution's cache behavior, you can get the policy's identifier using ListDistributions
  or GetDistribution. If the cache policy is not attached to a cache behavior, you can get
  the identifier using ListCachePolicies.

"""
function get_cache_policy_config2020_05_31(
    Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/cache-policy/$(Id)/config";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_cache_policy_config2020_05_31(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/cache-policy/$(Id)/config",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_cloud_front_origin_access_identity2020_05_31(id)
    get_cloud_front_origin_access_identity2020_05_31(id, params::Dict{String,<:Any})

Get the information about an origin access identity.

# Arguments
- `id`: The identity's ID.

"""
function get_cloud_front_origin_access_identity2020_05_31(
    Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/origin-access-identity/cloudfront/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_cloud_front_origin_access_identity2020_05_31(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/origin-access-identity/cloudfront/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_cloud_front_origin_access_identity_config2020_05_31(id)
    get_cloud_front_origin_access_identity_config2020_05_31(id, params::Dict{String,<:Any})

Get the configuration information about an origin access identity.

# Arguments
- `id`: The identity's ID.

"""
function get_cloud_front_origin_access_identity_config2020_05_31(
    Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/origin-access-identity/cloudfront/$(Id)/config";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_cloud_front_origin_access_identity_config2020_05_31(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/origin-access-identity/cloudfront/$(Id)/config",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_continuous_deployment_policy2020_05_31(id)
    get_continuous_deployment_policy2020_05_31(id, params::Dict{String,<:Any})

Gets a continuous deployment policy, including metadata (the policy's identifier and the
date and time when the policy was last modified).

# Arguments
- `id`: The identifier of the continuous deployment policy that you are getting.

"""
function get_continuous_deployment_policy2020_05_31(
    Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/continuous-deployment-policy/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_continuous_deployment_policy2020_05_31(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/continuous-deployment-policy/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_continuous_deployment_policy_config2020_05_31(id)
    get_continuous_deployment_policy_config2020_05_31(id, params::Dict{String,<:Any})

Gets configuration information about a continuous deployment policy.

# Arguments
- `id`: The identifier of the continuous deployment policy whose configuration you are
  getting.

"""
function get_continuous_deployment_policy_config2020_05_31(
    Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/continuous-deployment-policy/$(Id)/config";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_continuous_deployment_policy_config2020_05_31(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/continuous-deployment-policy/$(Id)/config",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_distribution2020_05_31(id)
    get_distribution2020_05_31(id, params::Dict{String,<:Any})

Get the information about a distribution.

# Arguments
- `id`: The distribution's ID. If the ID is empty, an empty distribution configuration is
  returned.

"""
function get_distribution2020_05_31(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudfront(
        "GET",
        "/2020-05-31/distribution/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_distribution2020_05_31(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/distribution/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_distribution_config2020_05_31(id)
    get_distribution_config2020_05_31(id, params::Dict{String,<:Any})

Get the configuration information about a distribution.

# Arguments
- `id`: The distribution's ID. If the ID is empty, an empty distribution configuration is
  returned.

"""
function get_distribution_config2020_05_31(
    Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/distribution/$(Id)/config";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_distribution_config2020_05_31(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/distribution/$(Id)/config",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_field_level_encryption2020_05_31(id)
    get_field_level_encryption2020_05_31(id, params::Dict{String,<:Any})

Get the field-level encryption configuration information.

# Arguments
- `id`: Request the ID for the field-level encryption configuration information.

"""
function get_field_level_encryption2020_05_31(
    Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/field-level-encryption/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_field_level_encryption2020_05_31(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/field-level-encryption/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_field_level_encryption_config2020_05_31(id)
    get_field_level_encryption_config2020_05_31(id, params::Dict{String,<:Any})

Get the field-level encryption configuration information.

# Arguments
- `id`: Request the ID for the field-level encryption configuration information.

"""
function get_field_level_encryption_config2020_05_31(
    Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/field-level-encryption/$(Id)/config";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_field_level_encryption_config2020_05_31(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/field-level-encryption/$(Id)/config",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_field_level_encryption_profile2020_05_31(id)
    get_field_level_encryption_profile2020_05_31(id, params::Dict{String,<:Any})

Get the field-level encryption profile information.

# Arguments
- `id`: Get the ID for the field-level encryption profile information.

"""
function get_field_level_encryption_profile2020_05_31(
    Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/field-level-encryption-profile/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_field_level_encryption_profile2020_05_31(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/field-level-encryption-profile/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_field_level_encryption_profile_config2020_05_31(id)
    get_field_level_encryption_profile_config2020_05_31(id, params::Dict{String,<:Any})

Get the field-level encryption profile configuration information.

# Arguments
- `id`: Get the ID for the field-level encryption profile configuration information.

"""
function get_field_level_encryption_profile_config2020_05_31(
    Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/field-level-encryption-profile/$(Id)/config";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_field_level_encryption_profile_config2020_05_31(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/field-level-encryption-profile/$(Id)/config",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_function2020_05_31(name)
    get_function2020_05_31(name, params::Dict{String,<:Any})

Gets the code of a CloudFront function. To get configuration information and metadata about
a function, use DescribeFunction. To get a function's code, you must provide the function's
name and stage. To get these values, you can use ListFunctions.

# Arguments
- `name`: The name of the function whose code you are getting.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Stage"`: The function's stage, either DEVELOPMENT or LIVE.
"""
function get_function2020_05_31(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudfront(
        "GET",
        "/2020-05-31/function/$(Name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_function2020_05_31(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/function/$(Name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_invalidation2020_05_31(distribution_id, id)
    get_invalidation2020_05_31(distribution_id, id, params::Dict{String,<:Any})

Get the information about an invalidation.

# Arguments
- `distribution_id`: The distribution's ID.
- `id`: The identifier for the invalidation request, for example, IDFDVBD632BHDS5.

"""
function get_invalidation2020_05_31(
    DistributionId, Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/distribution/$(DistributionId)/invalidation/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_invalidation2020_05_31(
    DistributionId,
    Id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudfront(
        "GET",
        "/2020-05-31/distribution/$(DistributionId)/invalidation/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_key_group2020_05_31(id)
    get_key_group2020_05_31(id, params::Dict{String,<:Any})

Gets a key group, including the date and time when the key group was last modified. To get
a key group, you must provide the key group's identifier. If the key group is referenced in
a distribution's cache behavior, you can get the key group's identifier using
ListDistributions or GetDistribution. If the key group is not referenced in a cache
behavior, you can get the identifier using ListKeyGroups.

# Arguments
- `id`: The identifier of the key group that you are getting. To get the identifier, use
  ListKeyGroups.

"""
function get_key_group2020_05_31(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudfront(
        "GET",
        "/2020-05-31/key-group/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_key_group2020_05_31(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/key-group/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_key_group_config2020_05_31(id)
    get_key_group_config2020_05_31(id, params::Dict{String,<:Any})

Gets a key group configuration. To get a key group configuration, you must provide the key
group's identifier. If the key group is referenced in a distribution's cache behavior, you
can get the key group's identifier using ListDistributions or GetDistribution. If the key
group is not referenced in a cache behavior, you can get the identifier using ListKeyGroups.

# Arguments
- `id`: The identifier of the key group whose configuration you are getting. To get the
  identifier, use ListKeyGroups.

"""
function get_key_group_config2020_05_31(
    Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/key-group/$(Id)/config";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_key_group_config2020_05_31(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/key-group/$(Id)/config",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_monitoring_subscription2020_05_31(distribution_id)
    get_monitoring_subscription2020_05_31(distribution_id, params::Dict{String,<:Any})

Gets information about whether additional CloudWatch metrics are enabled for the specified
CloudFront distribution.

# Arguments
- `distribution_id`: The ID of the distribution that you are getting metrics information
  for.

"""
function get_monitoring_subscription2020_05_31(
    DistributionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/distributions/$(DistributionId)/monitoring-subscription/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_monitoring_subscription2020_05_31(
    DistributionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudfront(
        "GET",
        "/2020-05-31/distributions/$(DistributionId)/monitoring-subscription/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_origin_access_control2020_05_31(id)
    get_origin_access_control2020_05_31(id, params::Dict{String,<:Any})

Gets a CloudFront origin access control, including its unique identifier.

# Arguments
- `id`: The unique identifier of the origin access control.

"""
function get_origin_access_control2020_05_31(
    Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/origin-access-control/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_origin_access_control2020_05_31(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/origin-access-control/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_origin_access_control_config2020_05_31(id)
    get_origin_access_control_config2020_05_31(id, params::Dict{String,<:Any})

Gets a CloudFront origin access control configuration.

# Arguments
- `id`: The unique identifier of the origin access control.

"""
function get_origin_access_control_config2020_05_31(
    Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/origin-access-control/$(Id)/config";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_origin_access_control_config2020_05_31(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/origin-access-control/$(Id)/config",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_origin_request_policy2020_05_31(id)
    get_origin_request_policy2020_05_31(id, params::Dict{String,<:Any})

Gets an origin request policy, including the following metadata:   The policy's identifier.
  The date and time when the policy was last modified.   To get an origin request policy,
you must provide the policy's identifier. If the origin request policy is attached to a
distribution's cache behavior, you can get the policy's identifier using ListDistributions
or GetDistribution. If the origin request policy is not attached to a cache behavior, you
can get the identifier using ListOriginRequestPolicies.

# Arguments
- `id`: The unique identifier for the origin request policy. If the origin request policy
  is attached to a distribution's cache behavior, you can get the policy's identifier using
  ListDistributions or GetDistribution. If the origin request policy is not attached to a
  cache behavior, you can get the identifier using ListOriginRequestPolicies.

"""
function get_origin_request_policy2020_05_31(
    Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/origin-request-policy/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_origin_request_policy2020_05_31(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/origin-request-policy/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_origin_request_policy_config2020_05_31(id)
    get_origin_request_policy_config2020_05_31(id, params::Dict{String,<:Any})

Gets an origin request policy configuration. To get an origin request policy configuration,
you must provide the policy's identifier. If the origin request policy is attached to a
distribution's cache behavior, you can get the policy's identifier using ListDistributions
or GetDistribution. If the origin request policy is not attached to a cache behavior, you
can get the identifier using ListOriginRequestPolicies.

# Arguments
- `id`: The unique identifier for the origin request policy. If the origin request policy
  is attached to a distribution's cache behavior, you can get the policy's identifier using
  ListDistributions or GetDistribution. If the origin request policy is not attached to a
  cache behavior, you can get the identifier using ListOriginRequestPolicies.

"""
function get_origin_request_policy_config2020_05_31(
    Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/origin-request-policy/$(Id)/config";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_origin_request_policy_config2020_05_31(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/origin-request-policy/$(Id)/config",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_public_key2020_05_31(id)
    get_public_key2020_05_31(id, params::Dict{String,<:Any})

Gets a public key.

# Arguments
- `id`: The identifier of the public key you are getting.

"""
function get_public_key2020_05_31(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudfront(
        "GET",
        "/2020-05-31/public-key/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_public_key2020_05_31(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/public-key/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_public_key_config2020_05_31(id)
    get_public_key_config2020_05_31(id, params::Dict{String,<:Any})

Gets a public key configuration.

# Arguments
- `id`: The identifier of the public key whose configuration you are getting.

"""
function get_public_key_config2020_05_31(
    Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/public-key/$(Id)/config";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_public_key_config2020_05_31(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/public-key/$(Id)/config",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_realtime_log_config2020_05_31()
    get_realtime_log_config2020_05_31(params::Dict{String,<:Any})

Gets a real-time log configuration. To get a real-time log configuration, you can provide
the configuration's name or its Amazon Resource Name (ARN). You must provide at least one.
If you provide both, CloudFront uses the name to identify the real-time log configuration
to get.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ARN"`: The Amazon Resource Name (ARN) of the real-time log configuration to get.
- `"Name"`: The name of the real-time log configuration to get.
"""
function get_realtime_log_config2020_05_31(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "POST",
        "/2020-05-31/get-realtime-log-config/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_realtime_log_config2020_05_31(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "POST",
        "/2020-05-31/get-realtime-log-config/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_response_headers_policy2020_05_31(id)
    get_response_headers_policy2020_05_31(id, params::Dict{String,<:Any})

Gets a response headers policy, including metadata (the policy's identifier and the date
and time when the policy was last modified). To get a response headers policy, you must
provide the policy's identifier. If the response headers policy is attached to a
distribution's cache behavior, you can get the policy's identifier using ListDistributions
or GetDistribution. If the response headers policy is not attached to a cache behavior, you
can get the identifier using ListResponseHeadersPolicies.

# Arguments
- `id`: The identifier for the response headers policy. If the response headers policy is
  attached to a distribution's cache behavior, you can get the policy's identifier using
  ListDistributions or GetDistribution. If the response headers policy is not attached to a
  cache behavior, you can get the identifier using ListResponseHeadersPolicies.

"""
function get_response_headers_policy2020_05_31(
    Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/response-headers-policy/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_response_headers_policy2020_05_31(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/response-headers-policy/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_response_headers_policy_config2020_05_31(id)
    get_response_headers_policy_config2020_05_31(id, params::Dict{String,<:Any})

Gets a response headers policy configuration. To get a response headers policy
configuration, you must provide the policy's identifier. If the response headers policy is
attached to a distribution's cache behavior, you can get the policy's identifier using
ListDistributions or GetDistribution. If the response headers policy is not attached to a
cache behavior, you can get the identifier using ListResponseHeadersPolicies.

# Arguments
- `id`: The identifier for the response headers policy. If the response headers policy is
  attached to a distribution's cache behavior, you can get the policy's identifier using
  ListDistributions or GetDistribution. If the response headers policy is not attached to a
  cache behavior, you can get the identifier using ListResponseHeadersPolicies.

"""
function get_response_headers_policy_config2020_05_31(
    Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/response-headers-policy/$(Id)/config";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_response_headers_policy_config2020_05_31(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/response-headers-policy/$(Id)/config",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_streaming_distribution2020_05_31(id)
    get_streaming_distribution2020_05_31(id, params::Dict{String,<:Any})

Gets information about a specified RTMP distribution, including the distribution
configuration.

# Arguments
- `id`: The streaming distribution's ID.

"""
function get_streaming_distribution2020_05_31(
    Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/streaming-distribution/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_streaming_distribution2020_05_31(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/streaming-distribution/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_streaming_distribution_config2020_05_31(id)
    get_streaming_distribution_config2020_05_31(id, params::Dict{String,<:Any})

Get the configuration information about a streaming distribution.

# Arguments
- `id`: The streaming distribution's ID.

"""
function get_streaming_distribution_config2020_05_31(
    Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/streaming-distribution/$(Id)/config";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_streaming_distribution_config2020_05_31(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/streaming-distribution/$(Id)/config",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_cache_policies2020_05_31()
    list_cache_policies2020_05_31(params::Dict{String,<:Any})

Gets a list of cache policies. You can optionally apply a filter to return only the managed
policies created by Amazon Web Services, or only the custom policies created in your Amazon
Web Services account. You can optionally specify the maximum number of items to receive in
the response. If the total number of items in the list exceeds the maximum that you
specify, or the default maximum, the response is paginated. To get the next page of items,
send a subsequent request that specifies the NextMarker value from the current response as
the Marker value in the subsequent request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Marker"`: Use this field when paginating results to indicate where to begin in your
  list of cache policies. The response includes cache policies in the list that occur after
  the marker. To get the next page of the list, set this field's value to the value of
  NextMarker from the current page's response.
- `"MaxItems"`: The maximum number of cache policies that you want in the response.
- `"Type"`: A filter to return only the specified kinds of cache policies. Valid values
  are:    managed – Returns only the managed policies created by Amazon Web Services.
  custom – Returns only the custom policies created in your Amazon Web Services account.
"""
function list_cache_policies2020_05_31(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudfront(
        "GET",
        "/2020-05-31/cache-policy";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_cache_policies2020_05_31(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/cache-policy",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_cloud_front_origin_access_identities2020_05_31()
    list_cloud_front_origin_access_identities2020_05_31(params::Dict{String,<:Any})

Lists origin access identities.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Marker"`: Use this when paginating results to indicate where to begin in your list of
  origin access identities. The results include identities in the list that occur after the
  marker. To get the next page of results, set the Marker to the value of the NextMarker from
  the current page's response (which is also the ID of the last identity on that page).
- `"MaxItems"`: The maximum number of origin access identities you want in the response
  body.
"""
function list_cloud_front_origin_access_identities2020_05_31(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/origin-access-identity/cloudfront";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_cloud_front_origin_access_identities2020_05_31(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/origin-access-identity/cloudfront",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_conflicting_aliases2020_05_31(alias, distribution_id)
    list_conflicting_aliases2020_05_31(alias, distribution_id, params::Dict{String,<:Any})

Gets a list of aliases (also called CNAMEs or alternate domain names) that conflict or
overlap with the provided alias, and the associated CloudFront distributions and Amazon Web
Services accounts for each conflicting alias. In the returned list, the distribution and
account IDs are partially hidden, which allows you to identify the distributions and
accounts that you own, but helps to protect the information of ones that you don't own. Use
this operation to find aliases that are in use in CloudFront that conflict or overlap with
the provided alias. For example, if you provide www.example.com as input, the returned list
can include www.example.com and the overlapping wildcard alternate domain name
(*.example.com), if they exist. If you provide *.example.com as input, the returned list
can include *.example.com and any alternate domain names covered by that wildcard (for
example, www.example.com, test.example.com, dev.example.com, and so on), if they exist. To
list conflicting aliases, you provide the alias to search and the ID of a distribution in
your account that has an attached SSL/TLS certificate that includes the provided alias. For
more information, including how to set up the distribution and certificate, see Moving an
alternate domain name to a different distribution in the Amazon CloudFront Developer Guide.
You can optionally specify the maximum number of items to receive in the response. If the
total number of items in the list exceeds the maximum that you specify, or the default
maximum, the response is paginated. To get the next page of items, send a subsequent
request that specifies the NextMarker value from the current response as the Marker value
in the subsequent request.

# Arguments
- `alias`: The alias (also called a CNAME) to search for conflicting aliases.
- `distribution_id`: The ID of a distribution in your account that has an attached SSL/TLS
  certificate that includes the provided alias.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Marker"`: Use this field when paginating results to indicate where to begin in the list
  of conflicting aliases. The response includes conflicting aliases in the list that occur
  after the marker. To get the next page of the list, set this field's value to the value of
  NextMarker from the current page's response.
- `"MaxItems"`: The maximum number of conflicting aliases that you want in the response.
"""
function list_conflicting_aliases2020_05_31(
    Alias, DistributionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/conflicting-alias",
        Dict{String,Any}("Alias" => Alias, "DistributionId" => DistributionId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_conflicting_aliases2020_05_31(
    Alias,
    DistributionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudfront(
        "GET",
        "/2020-05-31/conflicting-alias",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Alias" => Alias, "DistributionId" => DistributionId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_continuous_deployment_policies2020_05_31()
    list_continuous_deployment_policies2020_05_31(params::Dict{String,<:Any})

Gets a list of the continuous deployment policies in your Amazon Web Services account. You
can optionally specify the maximum number of items to receive in the response. If the total
number of items in the list exceeds the maximum that you specify, or the default maximum,
the response is paginated. To get the next page of items, send a subsequent request that
specifies the NextMarker value from the current response as the Marker value in the
subsequent request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Marker"`: Use this field when paginating results to indicate where to begin in your
  list of continuous deployment policies. The response includes policies in the list that
  occur after the marker. To get the next page of the list, set this field's value to the
  value of NextMarker from the current page's response.
- `"MaxItems"`: The maximum number of continuous deployment policies that you want returned
  in the response.
"""
function list_continuous_deployment_policies2020_05_31(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/continuous-deployment-policy";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_continuous_deployment_policies2020_05_31(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/continuous-deployment-policy",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_distributions2020_05_31()
    list_distributions2020_05_31(params::Dict{String,<:Any})

List CloudFront distributions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Marker"`: Use this when paginating results to indicate where to begin in your list of
  distributions. The results include distributions in the list that occur after the marker.
  To get the next page of results, set the Marker to the value of the NextMarker from the
  current page's response (which is also the ID of the last distribution on that page).
- `"MaxItems"`: The maximum number of distributions you want in the response body.
"""
function list_distributions2020_05_31(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudfront(
        "GET",
        "/2020-05-31/distribution";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_distributions2020_05_31(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/distribution",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_distributions_by_cache_policy_id2020_05_31(cache_policy_id)
    list_distributions_by_cache_policy_id2020_05_31(cache_policy_id, params::Dict{String,<:Any})

Gets a list of distribution IDs for distributions that have a cache behavior that's
associated with the specified cache policy. You can optionally specify the maximum number
of items to receive in the response. If the total number of items in the list exceeds the
maximum that you specify, or the default maximum, the response is paginated. To get the
next page of items, send a subsequent request that specifies the NextMarker value from the
current response as the Marker value in the subsequent request.

# Arguments
- `cache_policy_id`: The ID of the cache policy whose associated distribution IDs you want
  to list.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Marker"`: Use this field when paginating results to indicate where to begin in your
  list of distribution IDs. The response includes distribution IDs in the list that occur
  after the marker. To get the next page of the list, set this field's value to the value of
  NextMarker from the current page's response.
- `"MaxItems"`: The maximum number of distribution IDs that you want in the response.
"""
function list_distributions_by_cache_policy_id2020_05_31(
    CachePolicyId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/distributionsByCachePolicyId/$(CachePolicyId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_distributions_by_cache_policy_id2020_05_31(
    CachePolicyId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudfront(
        "GET",
        "/2020-05-31/distributionsByCachePolicyId/$(CachePolicyId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_distributions_by_key_group2020_05_31(key_group_id)
    list_distributions_by_key_group2020_05_31(key_group_id, params::Dict{String,<:Any})

Gets a list of distribution IDs for distributions that have a cache behavior that
references the specified key group. You can optionally specify the maximum number of items
to receive in the response. If the total number of items in the list exceeds the maximum
that you specify, or the default maximum, the response is paginated. To get the next page
of items, send a subsequent request that specifies the NextMarker value from the current
response as the Marker value in the subsequent request.

# Arguments
- `key_group_id`: The ID of the key group whose associated distribution IDs you are listing.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Marker"`: Use this field when paginating results to indicate where to begin in your
  list of distribution IDs. The response includes distribution IDs in the list that occur
  after the marker. To get the next page of the list, set this field's value to the value of
  NextMarker from the current page's response.
- `"MaxItems"`: The maximum number of distribution IDs that you want in the response.
"""
function list_distributions_by_key_group2020_05_31(
    KeyGroupId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/distributionsByKeyGroupId/$(KeyGroupId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_distributions_by_key_group2020_05_31(
    KeyGroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudfront(
        "GET",
        "/2020-05-31/distributionsByKeyGroupId/$(KeyGroupId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_distributions_by_origin_request_policy_id2020_05_31(origin_request_policy_id)
    list_distributions_by_origin_request_policy_id2020_05_31(origin_request_policy_id, params::Dict{String,<:Any})

Gets a list of distribution IDs for distributions that have a cache behavior that's
associated with the specified origin request policy. You can optionally specify the maximum
number of items to receive in the response. If the total number of items in the list
exceeds the maximum that you specify, or the default maximum, the response is paginated. To
get the next page of items, send a subsequent request that specifies the NextMarker value
from the current response as the Marker value in the subsequent request.

# Arguments
- `origin_request_policy_id`: The ID of the origin request policy whose associated
  distribution IDs you want to list.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Marker"`: Use this field when paginating results to indicate where to begin in your
  list of distribution IDs. The response includes distribution IDs in the list that occur
  after the marker. To get the next page of the list, set this field's value to the value of
  NextMarker from the current page's response.
- `"MaxItems"`: The maximum number of distribution IDs that you want in the response.
"""
function list_distributions_by_origin_request_policy_id2020_05_31(
    OriginRequestPolicyId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/distributionsByOriginRequestPolicyId/$(OriginRequestPolicyId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_distributions_by_origin_request_policy_id2020_05_31(
    OriginRequestPolicyId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudfront(
        "GET",
        "/2020-05-31/distributionsByOriginRequestPolicyId/$(OriginRequestPolicyId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_distributions_by_realtime_log_config2020_05_31()
    list_distributions_by_realtime_log_config2020_05_31(params::Dict{String,<:Any})

Gets a list of distributions that have a cache behavior that's associated with the
specified real-time log configuration. You can specify the real-time log configuration by
its name or its Amazon Resource Name (ARN). You must provide at least one. If you provide
both, CloudFront uses the name to identify the real-time log configuration to list
distributions for. You can optionally specify the maximum number of items to receive in the
response. If the total number of items in the list exceeds the maximum that you specify, or
the default maximum, the response is paginated. To get the next page of items, send a
subsequent request that specifies the NextMarker value from the current response as the
Marker value in the subsequent request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Marker"`: Use this field when paginating results to indicate where to begin in your
  list of distributions. The response includes distributions in the list that occur after the
  marker. To get the next page of the list, set this field's value to the value of NextMarker
  from the current page's response.
- `"MaxItems"`: The maximum number of distributions that you want in the response.
- `"RealtimeLogConfigArn"`: The Amazon Resource Name (ARN) of the real-time log
  configuration whose associated distributions you want to list.
- `"RealtimeLogConfigName"`: The name of the real-time log configuration whose associated
  distributions you want to list.
"""
function list_distributions_by_realtime_log_config2020_05_31(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "POST",
        "/2020-05-31/distributionsByRealtimeLogConfig/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_distributions_by_realtime_log_config2020_05_31(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "POST",
        "/2020-05-31/distributionsByRealtimeLogConfig/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_distributions_by_response_headers_policy_id2020_05_31(response_headers_policy_id)
    list_distributions_by_response_headers_policy_id2020_05_31(response_headers_policy_id, params::Dict{String,<:Any})

Gets a list of distribution IDs for distributions that have a cache behavior that's
associated with the specified response headers policy. You can optionally specify the
maximum number of items to receive in the response. If the total number of items in the
list exceeds the maximum that you specify, or the default maximum, the response is
paginated. To get the next page of items, send a subsequent request that specifies the
NextMarker value from the current response as the Marker value in the subsequent request.

# Arguments
- `response_headers_policy_id`: The ID of the response headers policy whose associated
  distribution IDs you want to list.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Marker"`: Use this field when paginating results to indicate where to begin in your
  list of distribution IDs. The response includes distribution IDs in the list that occur
  after the marker. To get the next page of the list, set this field's value to the value of
  NextMarker from the current page's response.
- `"MaxItems"`: The maximum number of distribution IDs that you want to get in the response.
"""
function list_distributions_by_response_headers_policy_id2020_05_31(
    ResponseHeadersPolicyId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/distributionsByResponseHeadersPolicyId/$(ResponseHeadersPolicyId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_distributions_by_response_headers_policy_id2020_05_31(
    ResponseHeadersPolicyId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudfront(
        "GET",
        "/2020-05-31/distributionsByResponseHeadersPolicyId/$(ResponseHeadersPolicyId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_distributions_by_web_aclid2020_05_31(web_aclid)
    list_distributions_by_web_aclid2020_05_31(web_aclid, params::Dict{String,<:Any})

List the distributions that are associated with a specified WAF web ACL.

# Arguments
- `web_aclid`: The ID of the WAF web ACL that you want to list the associated
  distributions. If you specify \"null\" for the ID, the request returns a list of the
  distributions that aren't associated with a web ACL.  For WAFV2, this is the ARN of the web
  ACL, such as
  arn:aws:wafv2:us-east-1:123456789012:global/webacl/ExampleWebACL/a1b2c3d4-5678-90ab-cdef-EXA
  MPLE11111. For WAF Classic, this is the ID of the web ACL, such as
  a1b2c3d4-5678-90ab-cdef-EXAMPLE11111.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Marker"`: Use Marker and MaxItems to control pagination of results. If you have more
  than MaxItems distributions that satisfy the request, the response includes a NextMarker
  element. To get the next page of results, submit another request. For the value of Marker,
  specify the value of NextMarker from the last response. (For the first request, omit
  Marker.)
- `"MaxItems"`: The maximum number of distributions that you want CloudFront to return in
  the response body. The maximum and default values are both 100.
"""
function list_distributions_by_web_aclid2020_05_31(
    WebACLId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/distributionsByWebACLId/$(WebACLId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_distributions_by_web_aclid2020_05_31(
    WebACLId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudfront(
        "GET",
        "/2020-05-31/distributionsByWebACLId/$(WebACLId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_field_level_encryption_configs2020_05_31()
    list_field_level_encryption_configs2020_05_31(params::Dict{String,<:Any})

List all field-level encryption configurations that have been created in CloudFront for
this account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Marker"`: Use this when paginating results to indicate where to begin in your list of
  configurations. The results include configurations in the list that occur after the marker.
  To get the next page of results, set the Marker to the value of the NextMarker from the
  current page's response (which is also the ID of the last configuration on that page).
- `"MaxItems"`: The maximum number of field-level encryption configurations you want in the
  response body.
"""
function list_field_level_encryption_configs2020_05_31(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/field-level-encryption";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_field_level_encryption_configs2020_05_31(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/field-level-encryption",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_field_level_encryption_profiles2020_05_31()
    list_field_level_encryption_profiles2020_05_31(params::Dict{String,<:Any})

Request a list of field-level encryption profiles that have been created in CloudFront for
this account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Marker"`: Use this when paginating results to indicate where to begin in your list of
  profiles. The results include profiles in the list that occur after the marker. To get the
  next page of results, set the Marker to the value of the NextMarker from the current page's
  response (which is also the ID of the last profile on that page).
- `"MaxItems"`: The maximum number of field-level encryption profiles you want in the
  response body.
"""
function list_field_level_encryption_profiles2020_05_31(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/field-level-encryption-profile";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_field_level_encryption_profiles2020_05_31(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/field-level-encryption-profile",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_functions2020_05_31()
    list_functions2020_05_31(params::Dict{String,<:Any})

Gets a list of all CloudFront functions in your Amazon Web Services account. You can
optionally apply a filter to return only the functions that are in the specified stage,
either DEVELOPMENT or LIVE. You can optionally specify the maximum number of items to
receive in the response. If the total number of items in the list exceeds the maximum that
you specify, or the default maximum, the response is paginated. To get the next page of
items, send a subsequent request that specifies the NextMarker value from the current
response as the Marker value in the subsequent request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Marker"`: Use this field when paginating results to indicate where to begin in your
  list of functions. The response includes functions in the list that occur after the marker.
  To get the next page of the list, set this field's value to the value of NextMarker from
  the current page's response.
- `"MaxItems"`: The maximum number of functions that you want in the response.
- `"Stage"`: An optional filter to return only the functions that are in the specified
  stage, either DEVELOPMENT or LIVE.
"""
function list_functions2020_05_31(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudfront(
        "GET",
        "/2020-05-31/function";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_functions2020_05_31(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/function",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_invalidations2020_05_31(distribution_id)
    list_invalidations2020_05_31(distribution_id, params::Dict{String,<:Any})

Lists invalidation batches.

# Arguments
- `distribution_id`: The distribution's ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Marker"`: Use this parameter when paginating results to indicate where to begin in your
  list of invalidation batches. Because the results are returned in decreasing order from
  most recent to oldest, the most recent results are on the first page, the second page will
  contain earlier results, and so on. To get the next page of results, set Marker to the
  value of the NextMarker from the current page's response. This value is the same as the ID
  of the last invalidation batch on that page.
- `"MaxItems"`: The maximum number of invalidation batches that you want in the response
  body.
"""
function list_invalidations2020_05_31(
    DistributionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/distribution/$(DistributionId)/invalidation";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_invalidations2020_05_31(
    DistributionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudfront(
        "GET",
        "/2020-05-31/distribution/$(DistributionId)/invalidation",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_key_groups2020_05_31()
    list_key_groups2020_05_31(params::Dict{String,<:Any})

Gets a list of key groups. You can optionally specify the maximum number of items to
receive in the response. If the total number of items in the list exceeds the maximum that
you specify, or the default maximum, the response is paginated. To get the next page of
items, send a subsequent request that specifies the NextMarker value from the current
response as the Marker value in the subsequent request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Marker"`: Use this field when paginating results to indicate where to begin in your
  list of key groups. The response includes key groups in the list that occur after the
  marker. To get the next page of the list, set this field's value to the value of NextMarker
  from the current page's response.
- `"MaxItems"`: The maximum number of key groups that you want in the response.
"""
function list_key_groups2020_05_31(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudfront(
        "GET",
        "/2020-05-31/key-group";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_key_groups2020_05_31(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/key-group",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_key_value_stores2020_05_31()
    list_key_value_stores2020_05_31(params::Dict{String,<:Any})

Specifies the key value stores to list.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Marker"`: The marker associated with the key value stores list.
- `"MaxItems"`: The maximum number of items in the key value stores list.
- `"Status"`: The status of the request for the key value stores list.
"""
function list_key_value_stores2020_05_31(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/key-value-store";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_key_value_stores2020_05_31(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/key-value-store",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_origin_access_controls2020_05_31()
    list_origin_access_controls2020_05_31(params::Dict{String,<:Any})

Gets the list of CloudFront origin access controls in this Amazon Web Services account. You
can optionally specify the maximum number of items to receive in the response. If the total
number of items in the list exceeds the maximum that you specify, or the default maximum,
the response is paginated. To get the next page of items, send another request that
specifies the NextMarker value from the current response as the Marker value in the next
request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Marker"`: Use this field when paginating results to indicate where to begin in your
  list of origin access controls. The response includes the items in the list that occur
  after the marker. To get the next page of the list, set this field's value to the value of
  NextMarker from the current page's response.
- `"MaxItems"`: The maximum number of origin access controls that you want in the response.
"""
function list_origin_access_controls2020_05_31(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/origin-access-control";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_origin_access_controls2020_05_31(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/origin-access-control",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_origin_request_policies2020_05_31()
    list_origin_request_policies2020_05_31(params::Dict{String,<:Any})

Gets a list of origin request policies. You can optionally apply a filter to return only
the managed policies created by Amazon Web Services, or only the custom policies created in
your Amazon Web Services account. You can optionally specify the maximum number of items to
receive in the response. If the total number of items in the list exceeds the maximum that
you specify, or the default maximum, the response is paginated. To get the next page of
items, send a subsequent request that specifies the NextMarker value from the current
response as the Marker value in the subsequent request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Marker"`: Use this field when paginating results to indicate where to begin in your
  list of origin request policies. The response includes origin request policies in the list
  that occur after the marker. To get the next page of the list, set this field's value to
  the value of NextMarker from the current page's response.
- `"MaxItems"`: The maximum number of origin request policies that you want in the response.
- `"Type"`: A filter to return only the specified kinds of origin request policies. Valid
  values are:    managed – Returns only the managed policies created by Amazon Web
  Services.    custom – Returns only the custom policies created in your Amazon Web
  Services account.
"""
function list_origin_request_policies2020_05_31(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/origin-request-policy";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_origin_request_policies2020_05_31(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/origin-request-policy",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_public_keys2020_05_31()
    list_public_keys2020_05_31(params::Dict{String,<:Any})

List all public keys that have been added to CloudFront for this account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Marker"`: Use this when paginating results to indicate where to begin in your list of
  public keys. The results include public keys in the list that occur after the marker. To
  get the next page of results, set the Marker to the value of the NextMarker from the
  current page's response (which is also the ID of the last public key on that page).
- `"MaxItems"`: The maximum number of public keys you want in the response body.
"""
function list_public_keys2020_05_31(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudfront(
        "GET",
        "/2020-05-31/public-key";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_public_keys2020_05_31(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/public-key",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_realtime_log_configs2020_05_31()
    list_realtime_log_configs2020_05_31(params::Dict{String,<:Any})

Gets a list of real-time log configurations. You can optionally specify the maximum number
of items to receive in the response. If the total number of items in the list exceeds the
maximum that you specify, or the default maximum, the response is paginated. To get the
next page of items, send a subsequent request that specifies the NextMarker value from the
current response as the Marker value in the subsequent request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Marker"`: Use this field when paginating results to indicate where to begin in your
  list of real-time log configurations. The response includes real-time log configurations in
  the list that occur after the marker. To get the next page of the list, set this field's
  value to the value of NextMarker from the current page's response.
- `"MaxItems"`: The maximum number of real-time log configurations that you want in the
  response.
"""
function list_realtime_log_configs2020_05_31(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/realtime-log-config";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_realtime_log_configs2020_05_31(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/realtime-log-config",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_response_headers_policies2020_05_31()
    list_response_headers_policies2020_05_31(params::Dict{String,<:Any})

Gets a list of response headers policies. You can optionally apply a filter to get only the
managed policies created by Amazon Web Services, or only the custom policies created in
your Amazon Web Services account. You can optionally specify the maximum number of items to
receive in the response. If the total number of items in the list exceeds the maximum that
you specify, or the default maximum, the response is paginated. To get the next page of
items, send a subsequent request that specifies the NextMarker value from the current
response as the Marker value in the subsequent request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Marker"`: Use this field when paginating results to indicate where to begin in your
  list of response headers policies. The response includes response headers policies in the
  list that occur after the marker. To get the next page of the list, set this field's value
  to the value of NextMarker from the current page's response.
- `"MaxItems"`: The maximum number of response headers policies that you want to get in the
  response.
- `"Type"`: A filter to get only the specified kind of response headers policies. Valid
  values are:    managed – Gets only the managed policies created by Amazon Web Services.
   custom – Gets only the custom policies created in your Amazon Web Services account.
"""
function list_response_headers_policies2020_05_31(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/response-headers-policy";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_response_headers_policies2020_05_31(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/response-headers-policy",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_streaming_distributions2020_05_31()
    list_streaming_distributions2020_05_31(params::Dict{String,<:Any})

List streaming distributions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Marker"`: The value that you provided for the Marker request parameter.
- `"MaxItems"`: The value that you provided for the MaxItems request parameter.
"""
function list_streaming_distributions2020_05_31(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/streaming-distribution";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_streaming_distributions2020_05_31(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/streaming-distribution",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource2020_05_31(resource)
    list_tags_for_resource2020_05_31(resource, params::Dict{String,<:Any})

List tags for a CloudFront resource.

# Arguments
- `resource`: An ARN of a CloudFront resource.

"""
function list_tags_for_resource2020_05_31(
    Resource; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "GET",
        "/2020-05-31/tagging",
        Dict{String,Any}("Resource" => Resource);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource2020_05_31(
    Resource,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudfront(
        "GET",
        "/2020-05-31/tagging",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Resource" => Resource), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    publish_function2020_05_31(if-_match, name)
    publish_function2020_05_31(if-_match, name, params::Dict{String,<:Any})

Publishes a CloudFront function by copying the function code from the DEVELOPMENT stage to
LIVE. This automatically updates all cache behaviors that are using this function to use
the newly published copy in the LIVE stage. When a function is published to the LIVE stage,
you can attach the function to a distribution's cache behavior, using the function's Amazon
Resource Name (ARN). To publish a function, you must provide the function's name and
version (ETag value). To get these values, you can use ListFunctions and DescribeFunction.

# Arguments
- `if-_match`: The current version (ETag value) of the function that you are publishing,
  which you can get using DescribeFunction.
- `name`: The name of the function that you are publishing.

"""
function publish_function2020_05_31(
    If_Match, Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "POST",
        "/2020-05-31/function/$(Name)/publish",
        Dict{String,Any}("headers" => Dict{String,Any}("If-Match" => If_Match));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function publish_function2020_05_31(
    If_Match,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudfront(
        "POST",
        "/2020-05-31/function/$(Name)/publish",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("headers" => Dict{String,Any}("If-Match" => If_Match)),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource2020_05_31(resource, tags)
    tag_resource2020_05_31(resource, tags, params::Dict{String,<:Any})

Add tags to a CloudFront resource.

# Arguments
- `resource`: An ARN of a CloudFront resource.
- `tags`: A complex type that contains zero or more Tag elements.

"""
function tag_resource2020_05_31(
    Resource, Tags; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "POST",
        "/2020-05-31/tagging?Operation=Tag",
        Dict{String,Any}("Resource" => Resource, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource2020_05_31(
    Resource,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudfront(
        "POST",
        "/2020-05-31/tagging?Operation=Tag",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("Resource" => Resource, "Tags" => Tags), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    test_function2020_05_31(event_object, if-_match, name)
    test_function2020_05_31(event_object, if-_match, name, params::Dict{String,<:Any})

Tests a CloudFront function. To test a function, you provide an event object that
represents an HTTP request or response that your CloudFront distribution could receive in
production. CloudFront runs the function, passing it the event object that you provided,
and returns the function's result (the modified event object) in the response. The response
also contains function logs and error messages, if any exist. For more information about
testing functions, see Testing functions in the Amazon CloudFront Developer Guide. To test
a function, you provide the function's name and version (ETag value) along with the event
object. To get the function's name and version, you can use ListFunctions and
DescribeFunction.

# Arguments
- `event_object`: The event object to test the function with. For more information about
  the structure of the event object, see Testing functions in the Amazon CloudFront Developer
  Guide.
- `if-_match`: The current version (ETag value) of the function that you are testing, which
  you can get using DescribeFunction.
- `name`: The name of the function that you are testing.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Stage"`: The stage of the function that you are testing, either DEVELOPMENT or LIVE.
"""
function test_function2020_05_31(
    EventObject, If_Match, Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "POST",
        "/2020-05-31/function/$(Name)/test",
        Dict{String,Any}(
            "EventObject" => EventObject,
            "headers" => Dict{String,Any}("If-Match" => If_Match),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function test_function2020_05_31(
    EventObject,
    If_Match,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudfront(
        "POST",
        "/2020-05-31/function/$(Name)/test",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EventObject" => EventObject,
                    "headers" => Dict{String,Any}("If-Match" => If_Match),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource2020_05_31(resource, tag_keys)
    untag_resource2020_05_31(resource, tag_keys, params::Dict{String,<:Any})

Remove tags from a CloudFront resource.

# Arguments
- `resource`: An ARN of a CloudFront resource.
- `tag_keys`: A complex type that contains zero or more Tag key elements.

"""
function untag_resource2020_05_31(
    Resource, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "POST",
        "/2020-05-31/tagging?Operation=Untag",
        Dict{String,Any}("Resource" => Resource, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource2020_05_31(
    Resource,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudfront(
        "POST",
        "/2020-05-31/tagging?Operation=Untag",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Resource" => Resource, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_cache_policy2020_05_31(cache_policy_config, id)
    update_cache_policy2020_05_31(cache_policy_config, id, params::Dict{String,<:Any})

Updates a cache policy configuration. When you update a cache policy configuration, all the
fields are updated with the values provided in the request. You cannot update some fields
independent of others. To update a cache policy configuration:   Use GetCachePolicyConfig
to get the current configuration.   Locally modify the fields in the cache policy
configuration that you want to update.   Call UpdateCachePolicy by providing the entire
cache policy configuration, including the fields that you modified and those that you
didn't.

# Arguments
- `cache_policy_config`: A cache policy configuration.
- `id`: The unique identifier for the cache policy that you are updating. The identifier is
  returned in a cache behavior's CachePolicyId field in the response to GetDistributionConfig.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"If-Match"`: The version of the cache policy that you are updating. The version is
  returned in the cache policy's ETag field in the response to GetCachePolicyConfig.
"""
function update_cache_policy2020_05_31(
    CachePolicyConfig, Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "PUT",
        "/2020-05-31/cache-policy/$(Id)",
        Dict{String,Any}("CachePolicyConfig" => CachePolicyConfig);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_cache_policy2020_05_31(
    CachePolicyConfig,
    Id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudfront(
        "PUT",
        "/2020-05-31/cache-policy/$(Id)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("CachePolicyConfig" => CachePolicyConfig), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_cloud_front_origin_access_identity2020_05_31(cloud_front_origin_access_identity_config, id)
    update_cloud_front_origin_access_identity2020_05_31(cloud_front_origin_access_identity_config, id, params::Dict{String,<:Any})

Update an origin access identity.

# Arguments
- `cloud_front_origin_access_identity_config`: The identity's configuration information.
- `id`: The identity's id.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"If-Match"`: The value of the ETag header that you received when retrieving the
  identity's configuration. For example: E2QWRUHAPOMQZL.
"""
function update_cloud_front_origin_access_identity2020_05_31(
    CloudFrontOriginAccessIdentityConfig,
    Id;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudfront(
        "PUT",
        "/2020-05-31/origin-access-identity/cloudfront/$(Id)/config",
        Dict{String,Any}(
            "CloudFrontOriginAccessIdentityConfig" => CloudFrontOriginAccessIdentityConfig
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_cloud_front_origin_access_identity2020_05_31(
    CloudFrontOriginAccessIdentityConfig,
    Id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudfront(
        "PUT",
        "/2020-05-31/origin-access-identity/cloudfront/$(Id)/config",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CloudFrontOriginAccessIdentityConfig" =>
                        CloudFrontOriginAccessIdentityConfig,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_continuous_deployment_policy2020_05_31(continuous_deployment_policy_config, id)
    update_continuous_deployment_policy2020_05_31(continuous_deployment_policy_config, id, params::Dict{String,<:Any})

Updates a continuous deployment policy. You can update a continuous deployment policy to
enable or disable it, to change the percentage of traffic that it sends to the staging
distribution, or to change the staging distribution that it sends traffic to. When you
update a continuous deployment policy configuration, all the fields are updated with the
values that are provided in the request. You cannot update some fields independent of
others. To update a continuous deployment policy configuration:   Use
GetContinuousDeploymentPolicyConfig to get the current configuration.   Locally modify the
fields in the continuous deployment policy configuration that you want to update.   Use
UpdateContinuousDeploymentPolicy, providing the entire continuous deployment policy
configuration, including the fields that you modified and those that you didn't.

# Arguments
- `continuous_deployment_policy_config`: The continuous deployment policy configuration.
- `id`: The identifier of the continuous deployment policy that you are updating.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"If-Match"`: The current version (ETag value) of the continuous deployment policy that
  you are updating.
"""
function update_continuous_deployment_policy2020_05_31(
    ContinuousDeploymentPolicyConfig, Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "PUT",
        "/2020-05-31/continuous-deployment-policy/$(Id)",
        Dict{String,Any}(
            "ContinuousDeploymentPolicyConfig" => ContinuousDeploymentPolicyConfig
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_continuous_deployment_policy2020_05_31(
    ContinuousDeploymentPolicyConfig,
    Id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudfront(
        "PUT",
        "/2020-05-31/continuous-deployment-policy/$(Id)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ContinuousDeploymentPolicyConfig" => ContinuousDeploymentPolicyConfig
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_distribution2020_05_31(distribution_config, id)
    update_distribution2020_05_31(distribution_config, id, params::Dict{String,<:Any})

Updates the configuration for a CloudFront distribution. The update process includes
getting the current distribution configuration, updating it to make your changes, and then
submitting an UpdateDistribution request to make the updates.  To update a web distribution
using the CloudFront API    Use GetDistributionConfig to get the current configuration,
including the version identifier (ETag).   Update the distribution configuration that was
returned in the response. Note the following important requirements and restrictions:   You
must rename the ETag field to IfMatch, leaving the value unchanged. (Set the value of
IfMatch to the value of ETag, then remove the ETag field.)   You can't change the value of
CallerReference.     Submit an UpdateDistribution request, providing the distribution
configuration. The new configuration replaces the existing configuration. The values that
you specify in an UpdateDistribution request are not merged into your existing
configuration. Make sure to include all fields: the ones that you modified and also the
ones that you didn't.

# Arguments
- `distribution_config`: The distribution's configuration information.
- `id`: The distribution's id.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"If-Match"`: The value of the ETag header that you received when retrieving the
  distribution's configuration. For example: E2QWRUHAPOMQZL.
"""
function update_distribution2020_05_31(
    DistributionConfig, Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "PUT",
        "/2020-05-31/distribution/$(Id)/config",
        Dict{String,Any}("DistributionConfig" => DistributionConfig);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_distribution2020_05_31(
    DistributionConfig,
    Id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudfront(
        "PUT",
        "/2020-05-31/distribution/$(Id)/config",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("DistributionConfig" => DistributionConfig), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_distribution_with_staging_config2020_05_31(id)
    update_distribution_with_staging_config2020_05_31(id, params::Dict{String,<:Any})

Copies the staging distribution's configuration to its corresponding primary distribution.
The primary distribution retains its Aliases (also known as alternate domain names or
CNAMEs) and ContinuousDeploymentPolicyId value, but otherwise its configuration is
overwritten to match the staging distribution. You can use this operation in a continuous
deployment workflow after you have tested configuration changes on the staging
distribution. After using a continuous deployment policy to move a portion of your domain
name's traffic to the staging distribution and verifying that it works as intended, you can
use this operation to copy the staging distribution's configuration to the primary
distribution. This action will disable the continuous deployment policy and move your
domain's traffic back to the primary distribution. This API operation requires the
following IAM permissions:    GetDistribution     UpdateDistribution

# Arguments
- `id`: The identifier of the primary distribution to which you are copying a staging
  distribution's configuration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"If-Match"`: The current versions (ETag values) of both primary and staging
  distributions. Provide these in the following format:  &lt;primary ETag&gt;, &lt;staging
  ETag&gt;
- `"StagingDistributionId"`: The identifier of the staging distribution whose configuration
  you are copying to the primary distribution.
"""
function update_distribution_with_staging_config2020_05_31(
    Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "PUT",
        "/2020-05-31/distribution/$(Id)/promote-staging-config";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_distribution_with_staging_config2020_05_31(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "PUT",
        "/2020-05-31/distribution/$(Id)/promote-staging-config",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_field_level_encryption_config2020_05_31(field_level_encryption_config, id)
    update_field_level_encryption_config2020_05_31(field_level_encryption_config, id, params::Dict{String,<:Any})

Update a field-level encryption configuration.

# Arguments
- `field_level_encryption_config`: Request to update a field-level encryption configuration.
- `id`: The ID of the configuration you want to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"If-Match"`: The value of the ETag header that you received when retrieving the
  configuration identity to update. For example: E2QWRUHAPOMQZL.
"""
function update_field_level_encryption_config2020_05_31(
    FieldLevelEncryptionConfig, Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "PUT",
        "/2020-05-31/field-level-encryption/$(Id)/config",
        Dict{String,Any}("FieldLevelEncryptionConfig" => FieldLevelEncryptionConfig);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_field_level_encryption_config2020_05_31(
    FieldLevelEncryptionConfig,
    Id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudfront(
        "PUT",
        "/2020-05-31/field-level-encryption/$(Id)/config",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "FieldLevelEncryptionConfig" => FieldLevelEncryptionConfig
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_field_level_encryption_profile2020_05_31(field_level_encryption_profile_config, id)
    update_field_level_encryption_profile2020_05_31(field_level_encryption_profile_config, id, params::Dict{String,<:Any})

Update a field-level encryption profile.

# Arguments
- `field_level_encryption_profile_config`: Request to update a field-level encryption
  profile.
- `id`: The ID of the field-level encryption profile request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"If-Match"`: The value of the ETag header that you received when retrieving the profile
  identity to update. For example: E2QWRUHAPOMQZL.
"""
function update_field_level_encryption_profile2020_05_31(
    FieldLevelEncryptionProfileConfig,
    Id;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudfront(
        "PUT",
        "/2020-05-31/field-level-encryption-profile/$(Id)/config",
        Dict{String,Any}(
            "FieldLevelEncryptionProfileConfig" => FieldLevelEncryptionProfileConfig
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_field_level_encryption_profile2020_05_31(
    FieldLevelEncryptionProfileConfig,
    Id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudfront(
        "PUT",
        "/2020-05-31/field-level-encryption-profile/$(Id)/config",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "FieldLevelEncryptionProfileConfig" => FieldLevelEncryptionProfileConfig
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_function2020_05_31(function_code, function_config, if-_match, name)
    update_function2020_05_31(function_code, function_config, if-_match, name, params::Dict{String,<:Any})

Updates a CloudFront function. You can update a function's code or the comment that
describes the function. You cannot update a function's name. To update a function, you
provide the function's name and version (ETag value) along with the updated function code.
To get the name and version, you can use ListFunctions and DescribeFunction.

# Arguments
- `function_code`: The function code. For more information about writing a CloudFront
  function, see Writing function code for CloudFront Functions in the Amazon CloudFront
  Developer Guide.
- `function_config`: Configuration information about the function.
- `if-_match`: The current version (ETag value) of the function that you are updating,
  which you can get using DescribeFunction.
- `name`: The name of the function that you are updating.

"""
function update_function2020_05_31(
    FunctionCode,
    FunctionConfig,
    If_Match,
    Name;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudfront(
        "PUT",
        "/2020-05-31/function/$(Name)",
        Dict{String,Any}(
            "FunctionCode" => FunctionCode,
            "FunctionConfig" => FunctionConfig,
            "headers" => Dict{String,Any}("If-Match" => If_Match),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_function2020_05_31(
    FunctionCode,
    FunctionConfig,
    If_Match,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudfront(
        "PUT",
        "/2020-05-31/function/$(Name)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "FunctionCode" => FunctionCode,
                    "FunctionConfig" => FunctionConfig,
                    "headers" => Dict{String,Any}("If-Match" => If_Match),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_key_group2020_05_31(id, key_group_config)
    update_key_group2020_05_31(id, key_group_config, params::Dict{String,<:Any})

Updates a key group. When you update a key group, all the fields are updated with the
values provided in the request. You cannot update some fields independent of others. To
update a key group:   Get the current key group with GetKeyGroup or GetKeyGroupConfig.
Locally modify the fields in the key group that you want to update. For example, add or
remove public key IDs.   Call UpdateKeyGroup with the entire key group object, including
the fields that you modified and those that you didn't.

# Arguments
- `id`: The identifier of the key group that you are updating.
- `key_group_config`: The key group configuration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"If-Match"`: The version of the key group that you are updating. The version is the key
  group's ETag value.
"""
function update_key_group2020_05_31(
    Id, KeyGroupConfig; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "PUT",
        "/2020-05-31/key-group/$(Id)",
        Dict{String,Any}("KeyGroupConfig" => KeyGroupConfig);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_key_group2020_05_31(
    Id,
    KeyGroupConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudfront(
        "PUT",
        "/2020-05-31/key-group/$(Id)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("KeyGroupConfig" => KeyGroupConfig), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_key_value_store2020_05_31(comment, if-_match, name)
    update_key_value_store2020_05_31(comment, if-_match, name, params::Dict{String,<:Any})

Specifies the key value store to update.

# Arguments
- `comment`: The comment of the key value store to update.
- `if-_match`: The key value store to update, if a match occurs.
- `name`: The name of the key value store to update.

"""
function update_key_value_store2020_05_31(
    Comment, If_Match, Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "PUT",
        "/2020-05-31/key-value-store/$(Name)",
        Dict{String,Any}(
            "Comment" => Comment, "headers" => Dict{String,Any}("If-Match" => If_Match)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_key_value_store2020_05_31(
    Comment,
    If_Match,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudfront(
        "PUT",
        "/2020-05-31/key-value-store/$(Name)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Comment" => Comment,
                    "headers" => Dict{String,Any}("If-Match" => If_Match),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_origin_access_control2020_05_31(id, origin_access_control_config)
    update_origin_access_control2020_05_31(id, origin_access_control_config, params::Dict{String,<:Any})

Updates a CloudFront origin access control.

# Arguments
- `id`: The unique identifier of the origin access control that you are updating.
- `origin_access_control_config`: An origin access control.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"If-Match"`: The current version (ETag value) of the origin access control that you are
  updating.
"""
function update_origin_access_control2020_05_31(
    Id, OriginAccessControlConfig; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "PUT",
        "/2020-05-31/origin-access-control/$(Id)/config",
        Dict{String,Any}("OriginAccessControlConfig" => OriginAccessControlConfig);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_origin_access_control2020_05_31(
    Id,
    OriginAccessControlConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudfront(
        "PUT",
        "/2020-05-31/origin-access-control/$(Id)/config",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("OriginAccessControlConfig" => OriginAccessControlConfig),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_origin_request_policy2020_05_31(id, origin_request_policy_config)
    update_origin_request_policy2020_05_31(id, origin_request_policy_config, params::Dict{String,<:Any})

Updates an origin request policy configuration. When you update an origin request policy
configuration, all the fields are updated with the values provided in the request. You
cannot update some fields independent of others. To update an origin request policy
configuration:   Use GetOriginRequestPolicyConfig to get the current configuration.
Locally modify the fields in the origin request policy configuration that you want to
update.   Call UpdateOriginRequestPolicy by providing the entire origin request policy
configuration, including the fields that you modified and those that you didn't.

# Arguments
- `id`: The unique identifier for the origin request policy that you are updating. The
  identifier is returned in a cache behavior's OriginRequestPolicyId field in the response to
  GetDistributionConfig.
- `origin_request_policy_config`: An origin request policy configuration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"If-Match"`: The version of the origin request policy that you are updating. The version
  is returned in the origin request policy's ETag field in the response to
  GetOriginRequestPolicyConfig.
"""
function update_origin_request_policy2020_05_31(
    Id, OriginRequestPolicyConfig; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "PUT",
        "/2020-05-31/origin-request-policy/$(Id)",
        Dict{String,Any}("OriginRequestPolicyConfig" => OriginRequestPolicyConfig);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_origin_request_policy2020_05_31(
    Id,
    OriginRequestPolicyConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudfront(
        "PUT",
        "/2020-05-31/origin-request-policy/$(Id)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("OriginRequestPolicyConfig" => OriginRequestPolicyConfig),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_public_key2020_05_31(id, public_key_config)
    update_public_key2020_05_31(id, public_key_config, params::Dict{String,<:Any})

Update public key information. Note that the only value you can change is the comment.

# Arguments
- `id`: The identifier of the public key that you are updating.
- `public_key_config`: A public key configuration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"If-Match"`: The value of the ETag header that you received when retrieving the public
  key to update. For example: E2QWRUHAPOMQZL.
"""
function update_public_key2020_05_31(
    Id, PublicKeyConfig; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "PUT",
        "/2020-05-31/public-key/$(Id)/config",
        Dict{String,Any}("PublicKeyConfig" => PublicKeyConfig);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_public_key2020_05_31(
    Id,
    PublicKeyConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudfront(
        "PUT",
        "/2020-05-31/public-key/$(Id)/config",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("PublicKeyConfig" => PublicKeyConfig), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_realtime_log_config2020_05_31()
    update_realtime_log_config2020_05_31(params::Dict{String,<:Any})

Updates a real-time log configuration. When you update a real-time log configuration, all
the parameters are updated with the values provided in the request. You cannot update some
parameters independent of others. To update a real-time log configuration:   Call
GetRealtimeLogConfig to get the current real-time log configuration.   Locally modify the
parameters in the real-time log configuration that you want to update.   Call this API
(UpdateRealtimeLogConfig) by providing the entire real-time log configuration, including
the parameters that you modified and those that you didn't.   You cannot update a real-time
log configuration's Name or ARN.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ARN"`: The Amazon Resource Name (ARN) for this real-time log configuration.
- `"EndPoints"`: Contains information about the Amazon Kinesis data stream where you are
  sending real-time log data.
- `"Fields"`: A list of fields to include in each real-time log record. For more
  information about fields, see Real-time log configuration fields in the Amazon CloudFront
  Developer Guide.
- `"Name"`: The name for this real-time log configuration.
- `"SamplingRate"`: The sampling rate for this real-time log configuration. The sampling
  rate determines the percentage of viewer requests that are represented in the real-time log
  data. You must provide an integer between 1 and 100, inclusive.
"""
function update_realtime_log_config2020_05_31(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "PUT",
        "/2020-05-31/realtime-log-config/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_realtime_log_config2020_05_31(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "PUT",
        "/2020-05-31/realtime-log-config/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_response_headers_policy2020_05_31(id, response_headers_policy_config)
    update_response_headers_policy2020_05_31(id, response_headers_policy_config, params::Dict{String,<:Any})

Updates a response headers policy. When you update a response headers policy, the entire
policy is replaced. You cannot update some policy fields independent of others. To update a
response headers policy configuration:   Use GetResponseHeadersPolicyConfig to get the
current policy's configuration.   Modify the fields in the response headers policy
configuration that you want to update.   Call UpdateResponseHeadersPolicy, providing the
entire response headers policy configuration, including the fields that you modified and
those that you didn't.

# Arguments
- `id`: The identifier for the response headers policy that you are updating.
- `response_headers_policy_config`: A response headers policy configuration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"If-Match"`: The version of the response headers policy that you are updating. The
  version is returned in the cache policy's ETag field in the response to
  GetResponseHeadersPolicyConfig.
"""
function update_response_headers_policy2020_05_31(
    Id, ResponseHeadersPolicyConfig; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "PUT",
        "/2020-05-31/response-headers-policy/$(Id)",
        Dict{String,Any}("ResponseHeadersPolicyConfig" => ResponseHeadersPolicyConfig);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_response_headers_policy2020_05_31(
    Id,
    ResponseHeadersPolicyConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudfront(
        "PUT",
        "/2020-05-31/response-headers-policy/$(Id)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ResponseHeadersPolicyConfig" => ResponseHeadersPolicyConfig
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_streaming_distribution2020_05_31(id, streaming_distribution_config)
    update_streaming_distribution2020_05_31(id, streaming_distribution_config, params::Dict{String,<:Any})

Update a streaming distribution.

# Arguments
- `id`: The streaming distribution's id.
- `streaming_distribution_config`: The streaming distribution's configuration information.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"If-Match"`: The value of the ETag header that you received when retrieving the
  streaming distribution's configuration. For example: E2QWRUHAPOMQZL.
"""
function update_streaming_distribution2020_05_31(
    Id, StreamingDistributionConfig; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudfront(
        "PUT",
        "/2020-05-31/streaming-distribution/$(Id)/config",
        Dict{String,Any}("StreamingDistributionConfig" => StreamingDistributionConfig);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_streaming_distribution2020_05_31(
    Id,
    StreamingDistributionConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudfront(
        "PUT",
        "/2020-05-31/streaming-distribution/$(Id)/config",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "StreamingDistributionConfig" => StreamingDistributionConfig
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

using Base: Base, @deprecate

# Emulates the legacy `use_response_type=false` response behavior using the `AWS.Response`
function legacy_response(
    request::AWS.Request, response::AWS.Response; return_headers=nothing
)
    response_dict_type = something(request.response_dict_type, LittleDict)
    return_headers = something(return_headers, false)

    # When a user defined I/O stream is passed in use the actual `HTTP.Response` body
    # instead of the `AWS.Response` body which requires the I/O stream to be seekable.
    body = if request.response_stream !== nothing
        b"[Message Body was streamed]"
    else
        response.body
    end

    # The stored service name is always lowercase and may not match the module name
    # specified by the user. We'll assume that the typical casing used is titlecase.
    alt_service = "@service $(titlecase(request.service)) use_response_type=true"

    # When a user specifies a `response_dict_type` we'll update the deprecations to show how
    # to use this type.
    # Note: Using overly terse function name to stick within line length. A more descriptive
    # function name would be `response_dict_type_str`.
    tstr = if request.response_dict_type !== nothing
        str -> "$(request.response_dict_type)($str)"
    else
        identity
    end

    # For HEAD request, return headers...
    if request.request_method == "HEAD"
        Base.depwarn(
            "Using \"HEAD\" in AWS requests to return headers is deprecated, " *
            "use `$alt_service` to return an `AWS.Response` allowing for " *
            "header access via " *
            "`$(tstr("response.headers"))`.",
            :legacy_response,
        )

        return response_dict_type(response.headers)
    end

    # Return response stream if requested...
    if something(request.return_stream, false)
        Base.depwarn(
            "The keyword `return_stream` is deprecated, " *
            "use `$alt_service` instead to return an `AWS.Response` allowing for " *
            "streaming access via `response.io`.",
            :legacy_response,
        )

        # When `return_stream` was `true` the backends would create different I/O types to
        # use. We'll replicate that behavior.
        if request.response_stream === nothing
            io = if request.backend isa HTTPBackend
                Base.BufferStream()
            else
                IOBuffer()
            end

            write(io, _rewind(read, response.io))
            request.response_stream = io
        end

        # Emulate HTTP 0.9.14 behavior of always closing the passed in stream. Doing this is
        # particularly important for `Base.BufferStream`.
        if request.backend isa HTTPBackend
            close(request.response_stream)
        end

        return request.response_stream
    elseif request.response_stream !== nothing
        # Emulate HTTP 0.9.14 behavior of always closing the passed in stream and the
        # `read_body` behavior of closing all non-`IOBuffer` streams when `return_stream` is
        # not `true`. Doing this is particularly important for `Base.BufferStream`.
        if request.backend isa HTTPBackend || !(request.response_stream isa IOBuffer)
            close(request.response_stream)
        end
    end

    # Return raw data if requested...
    if something(request.return_raw, false)
        if return_headers
            Base.depwarn(
                "The keywords `return_raw` and `return_headers` are deprecated, " *
                "use `$alt_service` instead to return an `AWS.Response` allowing for " *
                "raw data and header access via " *
                "`response.body`/`response.header`.",
                :legacy_response,
            )
        else
            Base.depwarn(
                "The keyword `return_raw` is deprecated, " *
                "use `$alt_service` instead to return an `AWS.Response` allowing for " *
                "raw data access via " *
                "`response.body`.",
                :legacy_response,
            )
        end

        return (return_headers ? (body, response.headers) : body)
    end

    # Parse response data according to mimetype...
    mime = HTTP.header(response.response, "Content-Type", "")

    if isempty(mime)
        if length(body) > 5 && body[1:5] == b"<?xml"
            mime = "text/xml"
        end
    end

    body_str = String(copy(body))

    if isempty(body_str)
        return (
            if return_headers
                (nothing, response_dict_type(response.headers))
            else
                nothing
            end
        )
    elseif occursin(r"/xml", mime)
        if return_headers
            Base.depwarn(
                "The keyword `return_headers` is deprecated, " *
                "use `$alt_service` instead to return an `AWS.Response` allowing for " *
                "parsed XML and header access via " *
                "`$(tstr("parse(response)"))`/`$(tstr("response.header"))` respectively",
                :legacy_response,
            )
        else
            Base.depwarn(
                "Returning the parsed AWS response is deprecated, " *
                "use `$alt_service` instead to return an `AWS.Response` allowing for " *
                "parsed XML access via " *
                "`$(tstr("parse(response.body)"))`.",
                :legacy_response,
            )
        end

        xml_dict_type = response_dict_type{Union{Symbol,String},Any}
        xml = parse_xml(body_str)
        root = XMLDict.root(xml.x)

        return (
            if return_headers
                (xml_dict(root, xml_dict_type), response_dict_type(response.headers))
            else
                xml_dict(root, xml_dict_type)
            end
        )
    elseif occursin(r"/x-amz-json-1.[01]$", mime) || endswith(mime, "json")
        if return_headers
            Base.depwarn(
                "The keyword `return_headers` is deprecated, " *
                "use `$alt_service` instead to return an `AWS.Response` allowing for " *
                "parsed JSON and header access via " *
                "`$(tstr("parse(response)"))`/`$(tstr("response.header"))` respectively",
                :legacy_response,
            )
        else
            Base.depwarn(
                "Returning the parsed AWS response is deprecated, " *
                "use `$alt_service` instead to return an `AWS.Response` allowing for " *
                "parsed JSON access via " *
                "`$(tstr("parse(response.body)"))`.",
                :legacy_response,
            )
        end

        info = isempty(body) ? nothing : JSON.parse(body_str; dicttype=response_dict_type)
        return (return_headers ? (info, response_dict_type(response.headers)) : info)
    elseif startswith(mime, "text/")
        if return_headers
            Base.depwarn(
                "The keyword `return_headers` is deprecated, " *
                "use `$alt_service` instead to return an `AWS.Response` allowing for " *
                "raw string data and header access via " *
                "`String(response.body)`/`$(tstr("response.header"))` respectively.",
                :legacy_response,
            )
        else
            Base.depwarn(
                "Returning the raw AWS response body is deprecated, " *
                "use `$alt_service` instead to return an `AWS.Response` allowing for " *
                "raw string data access via " *
                "`String(response.body)`.",
                :legacy_response,
            )
        end

        return (
            return_headers ? (body_str, response_dict_type(response.headers)) : body_str
        )
    else
        if return_headers
            Base.depwarn(
                "The keyword `return_headers` is deprecated, " *
                "use `$alt_service` instead to return an `AWS.Response` allowing for " *
                "raw data and header access via " *
                "`response.body`/`response.header` respectively.",
                :legacy_response,
            )
        else
            Base.depwarn(
                "Returning the raw AWS response body is deprecated, " *
                "use `$alt_service` instead to return an `AWS.Response` allowing for " *
                "raw data access via " *
                "`response.body`.",
                :legacy_response,
            )
        end

        return (return_headers ? (body, response.headers) : body)
    end
end

@deprecate ec2_instance_metadata(path::AbstractString) IMDS.get(path)
@deprecate ec2_instance_region() IMDS.region()

# Binding has no user accessible replacement. Users were expected to use `global_aws_config`
# and not interact with this global directly. We'll include this during the deprecation
# phase out of an abundance of caution.
const aws_config = Ref{AbstractAWSConfig}()

export global_aws_config

# Note: These old functions were never thread safe.
function global_aws_config(; kwargs...)
    return if isempty(kwargs)
        Base.depwarn(
            "`global_aws_config()` is deprecated, use `current_aws_config()` instead.",
            :global_aws_config,
        )
        # Not calling `current_aws_config` as we don't want to return scoped configs for
        # full backwards compatibility.
        default_aws_config()
    else
        Base.depwarn(
            "`global_aws_config(; kwargs...)` is deprecated, use `with_aws_config(AWSConfig(; kwargs...)) do ... end` " *
            "instead to temporarily modify the AWS configuration or `default_aws_config(AWSConfig(; kwargs...))` " *
            "to set the AWS configuration outside the scope of any `with_aws_config` blocks.",
            :global_aws_config,
        )
        config = AWSConfig(; kwargs...)
        default_aws_config(config)
        aws_config[] = config
        config
    end
end

function global_aws_config(config::AbstractAWSConfig)
    Base.depwarn(
        "`global_aws_config(config::AbstractAWSConfig)` is deprecated, use `with_aws_config(config) do ... end` " *
        "instead to temporarily modify the AWS configuration or `default_aws_config(config)` " *
        "to set the AWS configuration outside the scope of any `with_aws_config` blocks.",
        :global_aws_config,
    )
    default_aws_config(config)
    aws_config[] = config
    return config
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: backup
using AWS.Compat
using AWS.UUIDs

"""
    cancel_legal_hold(cancel_description, legal_hold_id)
    cancel_legal_hold(cancel_description, legal_hold_id, params::Dict{String,<:Any})

This action removes the specified legal hold on a recovery point. This action can only be
performed by a user with sufficient permissions.

# Arguments
- `cancel_description`: String describing the reason for removing the legal hold.
- `legal_hold_id`: Legal hold ID required to remove the specified legal hold on a recovery
  point.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"retainRecordInDays"`: The integer amount in days specifying amount of days after this
  API operation to remove legal hold.
"""
function cancel_legal_hold(
    cancelDescription, legalHoldId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "DELETE",
        "/legal-holds/$(legalHoldId)",
        Dict{String,Any}("cancelDescription" => cancelDescription);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_legal_hold(
    cancelDescription,
    legalHoldId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "DELETE",
        "/legal-holds/$(legalHoldId)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("cancelDescription" => cancelDescription), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_backup_plan(backup_plan)
    create_backup_plan(backup_plan, params::Dict{String,<:Any})

Creates a backup plan using a backup plan name and backup rules. A backup plan is a
document that contains information that Backup uses to schedule tasks that create recovery
points for resources. If you call CreateBackupPlan with a plan that already exists, you
receive an AlreadyExistsException exception.

# Arguments
- `backup_plan`: Specifies the body of a backup plan. Includes a BackupPlanName and one or
  more sets of Rules.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"BackupPlanTags"`: To help organize your resources, you can assign your own metadata to
  the resources that you create. Each tag is a key-value pair. The specified tags are
  assigned to all backups created with this plan.
- `"CreatorRequestId"`: Identifies the request and allows failed requests to be retried
  without the risk of running the operation twice. If the request includes a CreatorRequestId
  that matches an existing backup plan, that plan is returned. This parameter is optional. If
  used, this parameter must contain 1 to 50 alphanumeric or '-_.' characters.
"""
function create_backup_plan(BackupPlan; aws_config::AbstractAWSConfig=current_aws_config())
    return backup(
        "PUT",
        "/backup/plans/",
        Dict{String,Any}("BackupPlan" => BackupPlan);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_backup_plan(
    BackupPlan,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "PUT",
        "/backup/plans/",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("BackupPlan" => BackupPlan), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_backup_selection(backup_selection, backup_plan_id)
    create_backup_selection(backup_selection, backup_plan_id, params::Dict{String,<:Any})

Creates a JSON document that specifies a set of resources to assign to a backup plan. For
examples, see Assigning resources programmatically.

# Arguments
- `backup_selection`: Specifies the body of a request to assign a set of resources to a
  backup plan.
- `backup_plan_id`: Uniquely identifies the backup plan to be associated with the selection
  of resources.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CreatorRequestId"`: A unique string that identifies the request and allows failed
  requests to be retried without the risk of running the operation twice. This parameter is
  optional. If used, this parameter must contain 1 to 50 alphanumeric or '-_.' characters.
"""
function create_backup_selection(
    BackupSelection, backupPlanId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "PUT",
        "/backup/plans/$(backupPlanId)/selections/",
        Dict{String,Any}("BackupSelection" => BackupSelection);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_backup_selection(
    BackupSelection,
    backupPlanId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "PUT",
        "/backup/plans/$(backupPlanId)/selections/",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("BackupSelection" => BackupSelection), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_backup_vault(backup_vault_name)
    create_backup_vault(backup_vault_name, params::Dict{String,<:Any})

Creates a logical container where backups are stored. A CreateBackupVault request includes
a name, optionally one or more resource tags, an encryption key, and a request ID.  Do not
include sensitive data, such as passport numbers, in the name of a backup vault.

# Arguments
- `backup_vault_name`: The name of a logical container where backups are stored. Backup
  vaults are identified by names that are unique to the account used to create them and the
  Amazon Web Services Region where they are created. They consist of letters, numbers, and
  hyphens.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"BackupVaultTags"`: Metadata that you can assign to help organize the resources that you
  create. Each tag is a key-value pair.
- `"CreatorRequestId"`: A unique string that identifies the request and allows failed
  requests to be retried without the risk of running the operation twice. This parameter is
  optional. If used, this parameter must contain 1 to 50 alphanumeric or '-_.' characters.
- `"EncryptionKeyArn"`: The server-side encryption key that is used to protect your
  backups; for example,
  arn:aws:kms:us-west-2:111122223333:key/1234abcd-12ab-34cd-56ef-1234567890ab.
"""
function create_backup_vault(
    backupVaultName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "PUT",
        "/backup-vaults/$(backupVaultName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_backup_vault(
    backupVaultName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "PUT",
        "/backup-vaults/$(backupVaultName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_framework(framework_controls, framework_name)
    create_framework(framework_controls, framework_name, params::Dict{String,<:Any})

Creates a framework with one or more controls. A framework is a collection of controls that
you can use to evaluate your backup practices. By using pre-built customizable controls to
define your policies, you can evaluate whether your backup practices comply with your
policies and which resources are not yet in compliance.

# Arguments
- `framework_controls`: A list of the controls that make up the framework. Each control in
  the list has a name, input parameters, and scope.
- `framework_name`: The unique name of the framework. The name must be between 1 and 256
  characters, starting with a letter, and consisting of letters (a-z, A-Z), numbers (0-9),
  and underscores (_).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FrameworkDescription"`: An optional description of the framework with a maximum of
  1,024 characters.
- `"FrameworkTags"`: Metadata that you can assign to help organize the frameworks that you
  create. Each tag is a key-value pair.
- `"IdempotencyToken"`: A customer-chosen string that you can use to distinguish between
  otherwise identical calls to CreateFrameworkInput. Retrying a successful request with the
  same idempotency token results in a success message with no action taken.
"""
function create_framework(
    FrameworkControls, FrameworkName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "POST",
        "/audit/frameworks",
        Dict{String,Any}(
            "FrameworkControls" => FrameworkControls,
            "FrameworkName" => FrameworkName,
            "IdempotencyToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_framework(
    FrameworkControls,
    FrameworkName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "POST",
        "/audit/frameworks",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "FrameworkControls" => FrameworkControls,
                    "FrameworkName" => FrameworkName,
                    "IdempotencyToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_legal_hold(description, title)
    create_legal_hold(description, title, params::Dict{String,<:Any})

This action creates a legal hold on a recovery point (backup). A legal hold is a restraint
on altering or deleting a backup until an authorized user cancels the legal hold. Any
actions to delete or disassociate a recovery point will fail with an error if one or more
active legal holds are on the recovery point.

# Arguments
- `description`: This is the string description of the legal hold.
- `title`: This is the string title of the legal hold.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"IdempotencyToken"`: This is a user-chosen string used to distinguish between otherwise
  identical calls. Retrying a successful request with the same idempotency token results in a
  success message with no action taken.
- `"RecoveryPointSelection"`: This specifies criteria to assign a set of resources, such as
  resource types or backup vaults.
- `"Tags"`: Optional tags to include. A tag is a key-value pair you can use to manage,
  filter, and search for your resources. Allowed characters include UTF-8 letters, numbers,
  spaces, and the following characters: + - = . _ : /.
"""
function create_legal_hold(
    Description, Title; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "POST",
        "/legal-holds/",
        Dict{String,Any}("Description" => Description, "Title" => Title);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_legal_hold(
    Description,
    Title,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "POST",
        "/legal-holds/",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Description" => Description, "Title" => Title),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_logically_air_gapped_backup_vault(max_retention_days, min_retention_days, backup_vault_name)
    create_logically_air_gapped_backup_vault(max_retention_days, min_retention_days, backup_vault_name, params::Dict{String,<:Any})

This request creates a logical container to where backups may be copied. This request
includes a name, the Region, the maximum number of retention days, the minimum number of
retention days, and optionally can include tags and a creator request ID.  Do not include
sensitive data, such as passport numbers, in the name of a backup vault.

# Arguments
- `max_retention_days`: This is the setting that specifies the maximum retention period
  that the vault retains its recovery points. If this parameter is not specified, Backup does
  not enforce a maximum retention period on the recovery points in the vault (allowing
  indefinite storage). If specified, any backup or copy job to the vault must have a
  lifecycle policy with a retention period equal to or shorter than the maximum retention
  period. If the job retention period is longer than that maximum retention period, then the
  vault fails the backup or copy job, and you should either modify your lifecycle settings or
  use a different vault.
- `min_retention_days`: This setting specifies the minimum retention period that the vault
  retains its recovery points. If this parameter is not specified, no minimum retention
  period is enforced. If specified, any backup or copy job to the vault must have a lifecycle
  policy with a retention period equal to or longer than the minimum retention period. If a
  job retention period is shorter than that minimum retention period, then the vault fails
  the backup or copy job, and you should either modify your lifecycle settings or use a
  different vault.
- `backup_vault_name`: This is the name of the vault that is being created.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"BackupVaultTags"`: These are the tags that will be included in the newly-created vault.
- `"CreatorRequestId"`: This is the ID of the creation request. This parameter is optional.
  If used, this parameter must contain 1 to 50 alphanumeric or '-_.' characters.
"""
function create_logically_air_gapped_backup_vault(
    MaxRetentionDays,
    MinRetentionDays,
    backupVaultName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "PUT",
        "/logically-air-gapped-backup-vaults/$(backupVaultName)",
        Dict{String,Any}(
            "MaxRetentionDays" => MaxRetentionDays, "MinRetentionDays" => MinRetentionDays
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_logically_air_gapped_backup_vault(
    MaxRetentionDays,
    MinRetentionDays,
    backupVaultName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "PUT",
        "/logically-air-gapped-backup-vaults/$(backupVaultName)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "MaxRetentionDays" => MaxRetentionDays,
                    "MinRetentionDays" => MinRetentionDays,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_report_plan(report_delivery_channel, report_plan_name, report_setting)
    create_report_plan(report_delivery_channel, report_plan_name, report_setting, params::Dict{String,<:Any})

Creates a report plan. A report plan is a document that contains information about the
contents of the report and where Backup will deliver it. If you call CreateReportPlan with
a plan that already exists, you receive an AlreadyExistsException exception.

# Arguments
- `report_delivery_channel`: A structure that contains information about where and how to
  deliver your reports, specifically your Amazon S3 bucket name, S3 key prefix, and the
  formats of your reports.
- `report_plan_name`: The unique name of the report plan. The name must be between 1 and
  256 characters, starting with a letter, and consisting of letters (a-z, A-Z), numbers
  (0-9), and underscores (_).
- `report_setting`: Identifies the report template for the report. Reports are built using
  a report template. The report templates are:  RESOURCE_COMPLIANCE_REPORT |
  CONTROL_COMPLIANCE_REPORT | BACKUP_JOB_REPORT | COPY_JOB_REPORT | RESTORE_JOB_REPORT  If
  the report template is RESOURCE_COMPLIANCE_REPORT or CONTROL_COMPLIANCE_REPORT, this API
  resource also describes the report coverage by Amazon Web Services Regions and frameworks.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"IdempotencyToken"`: A customer-chosen string that you can use to distinguish between
  otherwise identical calls to CreateReportPlanInput. Retrying a successful request with the
  same idempotency token results in a success message with no action taken.
- `"ReportPlanDescription"`: An optional description of the report plan with a maximum of
  1,024 characters.
- `"ReportPlanTags"`: Metadata that you can assign to help organize the report plans that
  you create. Each tag is a key-value pair.
"""
function create_report_plan(
    ReportDeliveryChannel,
    ReportPlanName,
    ReportSetting;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "POST",
        "/audit/report-plans",
        Dict{String,Any}(
            "ReportDeliveryChannel" => ReportDeliveryChannel,
            "ReportPlanName" => ReportPlanName,
            "ReportSetting" => ReportSetting,
            "IdempotencyToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_report_plan(
    ReportDeliveryChannel,
    ReportPlanName,
    ReportSetting,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "POST",
        "/audit/report-plans",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ReportDeliveryChannel" => ReportDeliveryChannel,
                    "ReportPlanName" => ReportPlanName,
                    "ReportSetting" => ReportSetting,
                    "IdempotencyToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_restore_testing_plan(restore_testing_plan)
    create_restore_testing_plan(restore_testing_plan, params::Dict{String,<:Any})

This is the first of two steps to create a restore testing plan; once this request is
successful, finish the procedure with request CreateRestoreTestingSelection. You must
include the parameter RestoreTestingPlan. You may optionally include CreatorRequestId and
Tags.

# Arguments
- `restore_testing_plan`: A restore testing plan must contain a unique
  RestoreTestingPlanName string you create and must contain a ScheduleExpression cron. You
  may optionally include a StartWindowHours integer and a CreatorRequestId string. The
  RestoreTestingPlanName is a unique string that is the name of the restore testing plan.
  This cannot be changed after creation, and it must consist of only alphanumeric characters
  and underscores.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CreatorRequestId"`: This is a unique string that identifies the request and allows
  failed requests to be retriedwithout the risk of running the operation twice. This
  parameter is optional. If used, this parameter must contain 1 to 50 alphanumeric or '-_.'
  characters.
- `"Tags"`: Optional tags to include. A tag is a key-value pair you can use to manage,
  filter, and search for your resources. Allowed characters include UTF-8 letters,numbers,
  spaces, and the following characters: + - = . _ : /.
"""
function create_restore_testing_plan(
    RestoreTestingPlan; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "PUT",
        "/restore-testing/plans",
        Dict{String,Any}("RestoreTestingPlan" => RestoreTestingPlan);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_restore_testing_plan(
    RestoreTestingPlan,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "PUT",
        "/restore-testing/plans",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("RestoreTestingPlan" => RestoreTestingPlan), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_restore_testing_selection(restore_testing_plan_name, restore_testing_selection)
    create_restore_testing_selection(restore_testing_plan_name, restore_testing_selection, params::Dict{String,<:Any})

This request can be sent after CreateRestoreTestingPlan request returns successfully. This
is the second part of creating a resource testing plan, and it must be completed
sequentially. This consists of RestoreTestingSelectionName, ProtectedResourceType, and one
of the following:    ProtectedResourceArns     ProtectedResourceConditions    Each
protected resource type can have one single value. A restore testing selection can include
a wildcard value (\"*\") for ProtectedResourceArns along with ProtectedResourceConditions.
Alternatively, you can include up to 30 specific protected resource ARNs in
ProtectedResourceArns. Cannot select by both protected resource types AND specific ARNs.
Request will fail if both are included.

# Arguments
- `restore_testing_plan_name`: Input the restore testing plan name that was returned from
  the related CreateRestoreTestingPlan request.
- `restore_testing_selection`: This consists of RestoreTestingSelectionName,
  ProtectedResourceType, and one of the following:    ProtectedResourceArns
  ProtectedResourceConditions    Each protected resource type can have one single value. A
  restore testing selection can include a wildcard value (\"*\") for ProtectedResourceArns
  along with ProtectedResourceConditions. Alternatively, you can include up to 30 specific
  protected resource ARNs in ProtectedResourceArns.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CreatorRequestId"`: This is an optional unique string that identifies the request and
  allows failed requests to be retried without the risk of running the operation twice. If
  used, this parameter must contain 1 to 50 alphanumeric or '-_.' characters.
"""
function create_restore_testing_selection(
    RestoreTestingPlanName,
    RestoreTestingSelection;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "PUT",
        "/restore-testing/plans/$(RestoreTestingPlanName)/selections",
        Dict{String,Any}("RestoreTestingSelection" => RestoreTestingSelection);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_restore_testing_selection(
    RestoreTestingPlanName,
    RestoreTestingSelection,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "PUT",
        "/restore-testing/plans/$(RestoreTestingPlanName)/selections",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("RestoreTestingSelection" => RestoreTestingSelection),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_backup_plan(backup_plan_id)
    delete_backup_plan(backup_plan_id, params::Dict{String,<:Any})

Deletes a backup plan. A backup plan can only be deleted after all associated selections of
resources have been deleted. Deleting a backup plan deletes the current version of a backup
plan. Previous versions, if any, will still exist.

# Arguments
- `backup_plan_id`: Uniquely identifies a backup plan.

"""
function delete_backup_plan(
    backupPlanId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "DELETE",
        "/backup/plans/$(backupPlanId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_backup_plan(
    backupPlanId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "DELETE",
        "/backup/plans/$(backupPlanId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_backup_selection(backup_plan_id, selection_id)
    delete_backup_selection(backup_plan_id, selection_id, params::Dict{String,<:Any})

Deletes the resource selection associated with a backup plan that is specified by the
SelectionId.

# Arguments
- `backup_plan_id`: Uniquely identifies a backup plan.
- `selection_id`: Uniquely identifies the body of a request to assign a set of resources to
  a backup plan.

"""
function delete_backup_selection(
    backupPlanId, selectionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "DELETE",
        "/backup/plans/$(backupPlanId)/selections/$(selectionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_backup_selection(
    backupPlanId,
    selectionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "DELETE",
        "/backup/plans/$(backupPlanId)/selections/$(selectionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_backup_vault(backup_vault_name)
    delete_backup_vault(backup_vault_name, params::Dict{String,<:Any})

Deletes the backup vault identified by its name. A vault can be deleted only if it is empty.

# Arguments
- `backup_vault_name`: The name of a logical container where backups are stored. Backup
  vaults are identified by names that are unique to the account used to create them and the
  Amazon Web Services Region where they are created. They consist of lowercase letters,
  numbers, and hyphens.

"""
function delete_backup_vault(
    backupVaultName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "DELETE",
        "/backup-vaults/$(backupVaultName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_backup_vault(
    backupVaultName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "DELETE",
        "/backup-vaults/$(backupVaultName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_backup_vault_access_policy(backup_vault_name)
    delete_backup_vault_access_policy(backup_vault_name, params::Dict{String,<:Any})

Deletes the policy document that manages permissions on a backup vault.

# Arguments
- `backup_vault_name`: The name of a logical container where backups are stored. Backup
  vaults are identified by names that are unique to the account used to create them and the
  Amazon Web Services Region where they are created. They consist of lowercase letters,
  numbers, and hyphens.

"""
function delete_backup_vault_access_policy(
    backupVaultName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "DELETE",
        "/backup-vaults/$(backupVaultName)/access-policy";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_backup_vault_access_policy(
    backupVaultName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "DELETE",
        "/backup-vaults/$(backupVaultName)/access-policy",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_backup_vault_lock_configuration(backup_vault_name)
    delete_backup_vault_lock_configuration(backup_vault_name, params::Dict{String,<:Any})

Deletes Backup Vault Lock from a backup vault specified by a backup vault name. If the
Vault Lock configuration is immutable, then you cannot delete Vault Lock using API
operations, and you will receive an InvalidRequestException if you attempt to do so. For
more information, see Vault Lock in the Backup Developer Guide.

# Arguments
- `backup_vault_name`: The name of the backup vault from which to delete Backup Vault Lock.

"""
function delete_backup_vault_lock_configuration(
    backupVaultName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "DELETE",
        "/backup-vaults/$(backupVaultName)/vault-lock";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_backup_vault_lock_configuration(
    backupVaultName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "DELETE",
        "/backup-vaults/$(backupVaultName)/vault-lock",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_backup_vault_notifications(backup_vault_name)
    delete_backup_vault_notifications(backup_vault_name, params::Dict{String,<:Any})

Deletes event notifications for the specified backup vault.

# Arguments
- `backup_vault_name`: The name of a logical container where backups are stored. Backup
  vaults are identified by names that are unique to the account used to create them and the
  Region where they are created. They consist of lowercase letters, numbers, and hyphens.

"""
function delete_backup_vault_notifications(
    backupVaultName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "DELETE",
        "/backup-vaults/$(backupVaultName)/notification-configuration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_backup_vault_notifications(
    backupVaultName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "DELETE",
        "/backup-vaults/$(backupVaultName)/notification-configuration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_framework(framework_name)
    delete_framework(framework_name, params::Dict{String,<:Any})

Deletes the framework specified by a framework name.

# Arguments
- `framework_name`: The unique name of a framework.

"""
function delete_framework(frameworkName; aws_config::AbstractAWSConfig=current_aws_config())
    return backup(
        "DELETE",
        "/audit/frameworks/$(frameworkName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_framework(
    frameworkName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "DELETE",
        "/audit/frameworks/$(frameworkName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_recovery_point(backup_vault_name, recovery_point_arn)
    delete_recovery_point(backup_vault_name, recovery_point_arn, params::Dict{String,<:Any})

Deletes the recovery point specified by a recovery point ID. If the recovery point ID
belongs to a continuous backup, calling this endpoint deletes the existing continuous
backup and stops future continuous backup. When an IAM role's permissions are insufficient
to call this API, the service sends back an HTTP 200 response with an empty HTTP body, but
the recovery point is not deleted. Instead, it enters an EXPIRED state.  EXPIRED recovery
points can be deleted with this API once the IAM role has the iam:CreateServiceLinkedRole
action. To learn more about adding this role, see  Troubleshooting manual deletions. If the
user or role is deleted or the permission within the role is removed, the deletion will not
be successful and will enter an EXPIRED state.

# Arguments
- `backup_vault_name`: The name of a logical container where backups are stored. Backup
  vaults are identified by names that are unique to the account used to create them and the
  Amazon Web Services Region where they are created. They consist of lowercase letters,
  numbers, and hyphens.
- `recovery_point_arn`: An Amazon Resource Name (ARN) that uniquely identifies a recovery
  point; for example,
  arn:aws:backup:us-east-1:123456789012:recovery-point:1EB3B5E7-9EB0-435A-A80B-108B488B0D45.

"""
function delete_recovery_point(
    backupVaultName, recoveryPointArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "DELETE",
        "/backup-vaults/$(backupVaultName)/recovery-points/$(recoveryPointArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_recovery_point(
    backupVaultName,
    recoveryPointArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "DELETE",
        "/backup-vaults/$(backupVaultName)/recovery-points/$(recoveryPointArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_report_plan(report_plan_name)
    delete_report_plan(report_plan_name, params::Dict{String,<:Any})

Deletes the report plan specified by a report plan name.

# Arguments
- `report_plan_name`: The unique name of a report plan.

"""
function delete_report_plan(
    reportPlanName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "DELETE",
        "/audit/report-plans/$(reportPlanName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_report_plan(
    reportPlanName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "DELETE",
        "/audit/report-plans/$(reportPlanName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_restore_testing_plan(restore_testing_plan_name)
    delete_restore_testing_plan(restore_testing_plan_name, params::Dict{String,<:Any})

This request deletes the specified restore testing plan. Deletion can only successfully
occur if all associated restore testing selections are deleted first.

# Arguments
- `restore_testing_plan_name`: Required unique name of the restore testing plan you wish to
  delete.

"""
function delete_restore_testing_plan(
    RestoreTestingPlanName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "DELETE",
        "/restore-testing/plans/$(RestoreTestingPlanName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_restore_testing_plan(
    RestoreTestingPlanName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "DELETE",
        "/restore-testing/plans/$(RestoreTestingPlanName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_restore_testing_selection(restore_testing_plan_name, restore_testing_selection_name)
    delete_restore_testing_selection(restore_testing_plan_name, restore_testing_selection_name, params::Dict{String,<:Any})

Input the Restore Testing Plan name and Restore Testing Selection name. All testing
selections associated with a restore testing plan must be deleted before the restore
testing plan can be deleted.

# Arguments
- `restore_testing_plan_name`: Required unique name of the restore testing plan that
  contains the restore testing selection you wish to delete.
- `restore_testing_selection_name`: Required unique name of the restore testing selection
  you wish to delete.

"""
function delete_restore_testing_selection(
    RestoreTestingPlanName,
    RestoreTestingSelectionName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "DELETE",
        "/restore-testing/plans/$(RestoreTestingPlanName)/selections/$(RestoreTestingSelectionName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_restore_testing_selection(
    RestoreTestingPlanName,
    RestoreTestingSelectionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "DELETE",
        "/restore-testing/plans/$(RestoreTestingPlanName)/selections/$(RestoreTestingSelectionName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_backup_job(backup_job_id)
    describe_backup_job(backup_job_id, params::Dict{String,<:Any})

Returns backup job details for the specified BackupJobId.

# Arguments
- `backup_job_id`: Uniquely identifies a request to Backup to back up a resource.

"""
function describe_backup_job(
    backupJobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "GET",
        "/backup-jobs/$(backupJobId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_backup_job(
    backupJobId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "GET",
        "/backup-jobs/$(backupJobId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_backup_vault(backup_vault_name)
    describe_backup_vault(backup_vault_name, params::Dict{String,<:Any})

Returns metadata about a backup vault specified by its name.

# Arguments
- `backup_vault_name`: The name of a logical container where backups are stored. Backup
  vaults are identified by names that are unique to the account used to create them and the
  Amazon Web Services Region where they are created. They consist of lowercase letters,
  numbers, and hyphens.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"backupVaultAccountId"`: This is the account ID of the specified backup vault.
"""
function describe_backup_vault(
    backupVaultName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "GET",
        "/backup-vaults/$(backupVaultName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_backup_vault(
    backupVaultName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "GET",
        "/backup-vaults/$(backupVaultName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_copy_job(copy_job_id)
    describe_copy_job(copy_job_id, params::Dict{String,<:Any})

Returns metadata associated with creating a copy of a resource.

# Arguments
- `copy_job_id`: Uniquely identifies a copy job.

"""
function describe_copy_job(copyJobId; aws_config::AbstractAWSConfig=current_aws_config())
    return backup(
        "GET",
        "/copy-jobs/$(copyJobId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_copy_job(
    copyJobId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "GET",
        "/copy-jobs/$(copyJobId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_framework(framework_name)
    describe_framework(framework_name, params::Dict{String,<:Any})

Returns the framework details for the specified FrameworkName.

# Arguments
- `framework_name`: The unique name of a framework.

"""
function describe_framework(
    frameworkName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "GET",
        "/audit/frameworks/$(frameworkName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_framework(
    frameworkName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "GET",
        "/audit/frameworks/$(frameworkName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_global_settings()
    describe_global_settings(params::Dict{String,<:Any})

Describes whether the Amazon Web Services account is opted in to cross-account backup.
Returns an error if the account is not a member of an Organizations organization. Example:
describe-global-settings --region us-west-2

"""
function describe_global_settings(; aws_config::AbstractAWSConfig=current_aws_config())
    return backup(
        "GET", "/global-settings"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_global_settings(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "GET",
        "/global-settings",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_protected_resource(resource_arn)
    describe_protected_resource(resource_arn, params::Dict{String,<:Any})

Returns information about a saved resource, including the last time it was backed up, its
Amazon Resource Name (ARN), and the Amazon Web Services service type of the saved resource.

# Arguments
- `resource_arn`: An Amazon Resource Name (ARN) that uniquely identifies a resource. The
  format of the ARN depends on the resource type.

"""
function describe_protected_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "GET",
        "/resources/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_protected_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "GET",
        "/resources/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_recovery_point(backup_vault_name, recovery_point_arn)
    describe_recovery_point(backup_vault_name, recovery_point_arn, params::Dict{String,<:Any})

Returns metadata associated with a recovery point, including ID, status, encryption, and
lifecycle.

# Arguments
- `backup_vault_name`: The name of a logical container where backups are stored. Backup
  vaults are identified by names that are unique to the account used to create them and the
  Amazon Web Services Region where they are created. They consist of lowercase letters,
  numbers, and hyphens.
- `recovery_point_arn`: An Amazon Resource Name (ARN) that uniquely identifies a recovery
  point; for example,
  arn:aws:backup:us-east-1:123456789012:recovery-point:1EB3B5E7-9EB0-435A-A80B-108B488B0D45.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"backupVaultAccountId"`: This is the account ID of the specified backup vault.
"""
function describe_recovery_point(
    backupVaultName, recoveryPointArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "GET",
        "/backup-vaults/$(backupVaultName)/recovery-points/$(recoveryPointArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_recovery_point(
    backupVaultName,
    recoveryPointArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "GET",
        "/backup-vaults/$(backupVaultName)/recovery-points/$(recoveryPointArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_region_settings()
    describe_region_settings(params::Dict{String,<:Any})

Returns the current service opt-in settings for the Region. If service opt-in is enabled
for a service, Backup tries to protect that service's resources in this Region, when the
resource is included in an on-demand backup or scheduled backup plan. Otherwise, Backup
does not try to protect that service's resources in this Region.

"""
function describe_region_settings(; aws_config::AbstractAWSConfig=current_aws_config())
    return backup(
        "GET", "/account-settings"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_region_settings(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "GET",
        "/account-settings",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_report_job(report_job_id)
    describe_report_job(report_job_id, params::Dict{String,<:Any})

Returns the details associated with creating a report as specified by its ReportJobId.

# Arguments
- `report_job_id`: The identifier of the report job. A unique, randomly generated, Unicode,
  UTF-8 encoded string that is at most 1,024 bytes long. The report job ID cannot be edited.

"""
function describe_report_job(
    reportJobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "GET",
        "/audit/report-jobs/$(reportJobId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_report_job(
    reportJobId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "GET",
        "/audit/report-jobs/$(reportJobId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_report_plan(report_plan_name)
    describe_report_plan(report_plan_name, params::Dict{String,<:Any})

Returns a list of all report plans for an Amazon Web Services account and Amazon Web
Services Region.

# Arguments
- `report_plan_name`: The unique name of a report plan.

"""
function describe_report_plan(
    reportPlanName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "GET",
        "/audit/report-plans/$(reportPlanName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_report_plan(
    reportPlanName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "GET",
        "/audit/report-plans/$(reportPlanName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_restore_job(restore_job_id)
    describe_restore_job(restore_job_id, params::Dict{String,<:Any})

Returns metadata associated with a restore job that is specified by a job ID.

# Arguments
- `restore_job_id`: Uniquely identifies the job that restores a recovery point.

"""
function describe_restore_job(
    restoreJobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "GET",
        "/restore-jobs/$(restoreJobId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_restore_job(
    restoreJobId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "GET",
        "/restore-jobs/$(restoreJobId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_recovery_point(backup_vault_name, recovery_point_arn)
    disassociate_recovery_point(backup_vault_name, recovery_point_arn, params::Dict{String,<:Any})

Deletes the specified continuous backup recovery point from Backup and releases control of
that continuous backup to the source service, such as Amazon RDS. The source service will
continue to create and retain continuous backups using the lifecycle that you specified in
your original backup plan. Does not support snapshot backup recovery points.

# Arguments
- `backup_vault_name`: The unique name of an Backup vault.
- `recovery_point_arn`: An Amazon Resource Name (ARN) that uniquely identifies an Backup
  recovery point.

"""
function disassociate_recovery_point(
    backupVaultName, recoveryPointArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "POST",
        "/backup-vaults/$(backupVaultName)/recovery-points/$(recoveryPointArn)/disassociate";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_recovery_point(
    backupVaultName,
    recoveryPointArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "POST",
        "/backup-vaults/$(backupVaultName)/recovery-points/$(recoveryPointArn)/disassociate",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_recovery_point_from_parent(backup_vault_name, recovery_point_arn)
    disassociate_recovery_point_from_parent(backup_vault_name, recovery_point_arn, params::Dict{String,<:Any})

This action to a specific child (nested) recovery point removes the relationship between
the specified recovery point and its parent (composite) recovery point.

# Arguments
- `backup_vault_name`: This is the name of a logical container where the child (nested)
  recovery point is stored. Backup vaults are identified by names that are unique to the
  account used to create them and the Amazon Web Services Region where they are created. They
  consist of lowercase letters, numbers, and hyphens.
- `recovery_point_arn`: This is the Amazon Resource Name (ARN) that uniquely identifies the
  child (nested) recovery point; for example,
  arn:aws:backup:us-east-1:123456789012:recovery-point:1EB3B5E7-9EB0-435A-A80B-108B488B0D45.

"""
function disassociate_recovery_point_from_parent(
    backupVaultName, recoveryPointArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "DELETE",
        "/backup-vaults/$(backupVaultName)/recovery-points/$(recoveryPointArn)/parentAssociation";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_recovery_point_from_parent(
    backupVaultName,
    recoveryPointArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "DELETE",
        "/backup-vaults/$(backupVaultName)/recovery-points/$(recoveryPointArn)/parentAssociation",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    export_backup_plan_template(backup_plan_id)
    export_backup_plan_template(backup_plan_id, params::Dict{String,<:Any})

Returns the backup plan that is specified by the plan ID as a backup template.

# Arguments
- `backup_plan_id`: Uniquely identifies a backup plan.

"""
function export_backup_plan_template(
    backupPlanId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "GET",
        "/backup/plans/$(backupPlanId)/toTemplate/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function export_backup_plan_template(
    backupPlanId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "GET",
        "/backup/plans/$(backupPlanId)/toTemplate/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_backup_plan(backup_plan_id)
    get_backup_plan(backup_plan_id, params::Dict{String,<:Any})

Returns BackupPlan details for the specified BackupPlanId. The details are the body of a
backup plan in JSON format, in addition to plan metadata.

# Arguments
- `backup_plan_id`: Uniquely identifies a backup plan.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"versionId"`: Unique, randomly generated, Unicode, UTF-8 encoded strings that are at
  most 1,024 bytes long. Version IDs cannot be edited.
"""
function get_backup_plan(backupPlanId; aws_config::AbstractAWSConfig=current_aws_config())
    return backup(
        "GET",
        "/backup/plans/$(backupPlanId)/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_backup_plan(
    backupPlanId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "GET",
        "/backup/plans/$(backupPlanId)/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_backup_plan_from_json(backup_plan_template_json)
    get_backup_plan_from_json(backup_plan_template_json, params::Dict{String,<:Any})

Returns a valid JSON document specifying a backup plan or an error.

# Arguments
- `backup_plan_template_json`: A customer-supplied backup plan document in JSON format.

"""
function get_backup_plan_from_json(
    BackupPlanTemplateJson; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "POST",
        "/backup/template/json/toPlan",
        Dict{String,Any}("BackupPlanTemplateJson" => BackupPlanTemplateJson);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_backup_plan_from_json(
    BackupPlanTemplateJson,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "POST",
        "/backup/template/json/toPlan",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("BackupPlanTemplateJson" => BackupPlanTemplateJson),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_backup_plan_from_template(template_id)
    get_backup_plan_from_template(template_id, params::Dict{String,<:Any})

Returns the template specified by its templateId as a backup plan.

# Arguments
- `template_id`: Uniquely identifies a stored backup plan template.

"""
function get_backup_plan_from_template(
    templateId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "GET",
        "/backup/template/plans/$(templateId)/toPlan";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_backup_plan_from_template(
    templateId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "GET",
        "/backup/template/plans/$(templateId)/toPlan",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_backup_selection(backup_plan_id, selection_id)
    get_backup_selection(backup_plan_id, selection_id, params::Dict{String,<:Any})

Returns selection metadata and a document in JSON format that specifies a list of resources
that are associated with a backup plan.

# Arguments
- `backup_plan_id`: Uniquely identifies a backup plan.
- `selection_id`: Uniquely identifies the body of a request to assign a set of resources to
  a backup plan.

"""
function get_backup_selection(
    backupPlanId, selectionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "GET",
        "/backup/plans/$(backupPlanId)/selections/$(selectionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_backup_selection(
    backupPlanId,
    selectionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "GET",
        "/backup/plans/$(backupPlanId)/selections/$(selectionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_backup_vault_access_policy(backup_vault_name)
    get_backup_vault_access_policy(backup_vault_name, params::Dict{String,<:Any})

Returns the access policy document that is associated with the named backup vault.

# Arguments
- `backup_vault_name`: The name of a logical container where backups are stored. Backup
  vaults are identified by names that are unique to the account used to create them and the
  Amazon Web Services Region where they are created. They consist of lowercase letters,
  numbers, and hyphens.

"""
function get_backup_vault_access_policy(
    backupVaultName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "GET",
        "/backup-vaults/$(backupVaultName)/access-policy";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_backup_vault_access_policy(
    backupVaultName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "GET",
        "/backup-vaults/$(backupVaultName)/access-policy",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_backup_vault_notifications(backup_vault_name)
    get_backup_vault_notifications(backup_vault_name, params::Dict{String,<:Any})

Returns event notifications for the specified backup vault.

# Arguments
- `backup_vault_name`: The name of a logical container where backups are stored. Backup
  vaults are identified by names that are unique to the account used to create them and the
  Amazon Web Services Region where they are created. They consist of lowercase letters,
  numbers, and hyphens.

"""
function get_backup_vault_notifications(
    backupVaultName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "GET",
        "/backup-vaults/$(backupVaultName)/notification-configuration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_backup_vault_notifications(
    backupVaultName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "GET",
        "/backup-vaults/$(backupVaultName)/notification-configuration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_legal_hold(legal_hold_id)
    get_legal_hold(legal_hold_id, params::Dict{String,<:Any})

This action returns details for a specified legal hold. The details are the body of a legal
hold in JSON format, in addition to metadata.

# Arguments
- `legal_hold_id`: This is the ID required to use GetLegalHold. This unique ID is
  associated with a specific legal hold.

"""
function get_legal_hold(legalHoldId; aws_config::AbstractAWSConfig=current_aws_config())
    return backup(
        "GET",
        "/legal-holds/$(legalHoldId)/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_legal_hold(
    legalHoldId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "GET",
        "/legal-holds/$(legalHoldId)/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_recovery_point_restore_metadata(backup_vault_name, recovery_point_arn)
    get_recovery_point_restore_metadata(backup_vault_name, recovery_point_arn, params::Dict{String,<:Any})

Returns a set of metadata key-value pairs that were used to create the backup.

# Arguments
- `backup_vault_name`: The name of a logical container where backups are stored. Backup
  vaults are identified by names that are unique to the account used to create them and the
  Amazon Web Services Region where they are created. They consist of lowercase letters,
  numbers, and hyphens.
- `recovery_point_arn`: An Amazon Resource Name (ARN) that uniquely identifies a recovery
  point; for example,
  arn:aws:backup:us-east-1:123456789012:recovery-point:1EB3B5E7-9EB0-435A-A80B-108B488B0D45.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"backupVaultAccountId"`: This is the account ID of the specified backup vault.
"""
function get_recovery_point_restore_metadata(
    backupVaultName, recoveryPointArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "GET",
        "/backup-vaults/$(backupVaultName)/recovery-points/$(recoveryPointArn)/restore-metadata";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_recovery_point_restore_metadata(
    backupVaultName,
    recoveryPointArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "GET",
        "/backup-vaults/$(backupVaultName)/recovery-points/$(recoveryPointArn)/restore-metadata",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_restore_job_metadata(restore_job_id)
    get_restore_job_metadata(restore_job_id, params::Dict{String,<:Any})

This request returns the metadata for the specified restore job.

# Arguments
- `restore_job_id`: This is a unique identifier of a restore job within Backup.

"""
function get_restore_job_metadata(
    restoreJobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "GET",
        "/restore-jobs/$(restoreJobId)/metadata";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_restore_job_metadata(
    restoreJobId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "GET",
        "/restore-jobs/$(restoreJobId)/metadata",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_restore_testing_inferred_metadata(backup_vault_name, recovery_point_arn)
    get_restore_testing_inferred_metadata(backup_vault_name, recovery_point_arn, params::Dict{String,<:Any})

This request returns the minimal required set of metadata needed to start a restore job
with secure default settings. BackupVaultName and RecoveryPointArn are required parameters.
BackupVaultAccountId is an optional parameter.

# Arguments
- `backup_vault_name`: The name of a logical container where backups are stored. Backup
  vaults are identified by names that are unique to the account used to create them and the
  Amazon Web ServicesRegion where they are created. They consist of letters, numbers, and
  hyphens.
- `recovery_point_arn`: An Amazon Resource Name (ARN) that uniquely identifies a recovery
  point; for example,
  arn:aws:backup:us-east-1:123456789012:recovery-point:1EB3B5E7-9EB0-435A-A80B-108B488B0D45.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"BackupVaultAccountId"`: This is the account ID of the specified backup vault.
"""
function get_restore_testing_inferred_metadata(
    BackupVaultName, RecoveryPointArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "GET",
        "/restore-testing/inferred-metadata",
        Dict{String,Any}(
            "BackupVaultName" => BackupVaultName, "RecoveryPointArn" => RecoveryPointArn
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_restore_testing_inferred_metadata(
    BackupVaultName,
    RecoveryPointArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "GET",
        "/restore-testing/inferred-metadata",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "BackupVaultName" => BackupVaultName,
                    "RecoveryPointArn" => RecoveryPointArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_restore_testing_plan(restore_testing_plan_name)
    get_restore_testing_plan(restore_testing_plan_name, params::Dict{String,<:Any})

Returns RestoreTestingPlan details for the specified RestoreTestingPlanName. The details
are the body of a restore testing plan in JSON format, in addition to plan metadata.

# Arguments
- `restore_testing_plan_name`: Required unique name of the restore testing plan.

"""
function get_restore_testing_plan(
    RestoreTestingPlanName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "GET",
        "/restore-testing/plans/$(RestoreTestingPlanName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_restore_testing_plan(
    RestoreTestingPlanName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "GET",
        "/restore-testing/plans/$(RestoreTestingPlanName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_restore_testing_selection(restore_testing_plan_name, restore_testing_selection_name)
    get_restore_testing_selection(restore_testing_plan_name, restore_testing_selection_name, params::Dict{String,<:Any})

Returns RestoreTestingSelection, which displays resources and elements of the restore
testing plan.

# Arguments
- `restore_testing_plan_name`: Required unique name of the restore testing plan.
- `restore_testing_selection_name`: Required unique name of the restore testing selection.

"""
function get_restore_testing_selection(
    RestoreTestingPlanName,
    RestoreTestingSelectionName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "GET",
        "/restore-testing/plans/$(RestoreTestingPlanName)/selections/$(RestoreTestingSelectionName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_restore_testing_selection(
    RestoreTestingPlanName,
    RestoreTestingSelectionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "GET",
        "/restore-testing/plans/$(RestoreTestingPlanName)/selections/$(RestoreTestingSelectionName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_supported_resource_types()
    get_supported_resource_types(params::Dict{String,<:Any})

Returns the Amazon Web Services resource types supported by Backup.

"""
function get_supported_resource_types(; aws_config::AbstractAWSConfig=current_aws_config())
    return backup(
        "GET",
        "/supported-resource-types";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_supported_resource_types(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "GET",
        "/supported-resource-types",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_backup_job_summaries()
    list_backup_job_summaries(params::Dict{String,<:Any})

This is a request for a summary of backup jobs created or running within the most recent 30
days. You can include parameters AccountID, State, ResourceType, MessageCategory,
AggregationPeriod, MaxResults, or NextToken to filter results. This request returns a
summary that contains Region, Account, State, ResourceType, MessageCategory, StartTime,
EndTime, and Count of included jobs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccountId"`: Returns the job count for the specified account. If the request is sent
  from a member account or an account not part of Amazon Web Services Organizations, jobs
  within requestor's account will be returned. Root, admin, and delegated administrator
  accounts can use the value ANY to return job counts from every account in the organization.
   AGGREGATE_ALL aggregates job counts from all accounts within the authenticated
  organization, then returns the sum.
- `"AggregationPeriod"`: This is the period that sets the boundaries for returned results.
  Acceptable values include    ONE_DAY for daily job count for the prior 14 days.
  SEVEN_DAYS for the aggregated job count for the prior 7 days.    FOURTEEN_DAYS for
  aggregated job count for prior 14 days.
- `"MaxResults"`: This parameter sets the maximum number of items to be returned. The value
  is an integer. Range of accepted values is from 1 to 500.
- `"MessageCategory"`: This parameter returns the job count for the specified message
  category. Example accepted strings include AccessDenied, Success, and InvalidParameters.
  See Monitoring for a list of accepted MessageCategory strings. The the value ANY returns
  count of all message categories.  AGGREGATE_ALL aggregates job counts for all message
  categories and returns the sum.
- `"NextToken"`: The next item following a partial list of returned resources. For example,
  if a request is made to return MaxResults number of resources, NextToken allows you to
  return more items in your list starting at the location pointed to by the next token.
- `"ResourceType"`: Returns the job count for the specified resource type. Use request
  GetSupportedResourceTypes to obtain strings for supported resource types. The the value ANY
  returns count of all resource types.  AGGREGATE_ALL aggregates job counts for all resource
  types and returns the sum. The type of Amazon Web Services resource to be backed up; for
  example, an Amazon Elastic Block Store (Amazon EBS) volume or an Amazon Relational Database
  Service (Amazon RDS) database.
- `"State"`: This parameter returns the job count for jobs with the specified state. The
  the value ANY returns count of all states.  AGGREGATE_ALL aggregates job counts for all
  states and returns the sum.  Completed with issues is a status found only in the Backup
  console. For API, this status refers to jobs with a state of COMPLETED and a
  MessageCategory with a value other than SUCCESS; that is, the status is completed but comes
  with a status message. To obtain the job count for Completed with issues, run two GET
  requests, and subtract the second, smaller number: GET
  /audit/backup-job-summaries?AggregationPeriod=FOURTEEN_DAYS&amp;State=COMPLETED GET
  /audit/backup-job-summaries?AggregationPeriod=FOURTEEN_DAYS&amp;MessageCategory=SUCCESS&amp
  ;State=COMPLETED
"""
function list_backup_job_summaries(; aws_config::AbstractAWSConfig=current_aws_config())
    return backup(
        "GET",
        "/audit/backup-job-summaries";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_backup_job_summaries(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "GET",
        "/audit/backup-job-summaries",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_backup_jobs()
    list_backup_jobs(params::Dict{String,<:Any})

Returns a list of existing backup jobs for an authenticated account for the last 30 days.
For a longer period of time, consider using these monitoring tools.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountId"`: The account ID to list the jobs from. Returns only backup jobs associated
  with the specified account ID. If used from an Organizations management account, passing *
  returns all jobs across the organization.
- `"backupVaultName"`: Returns only backup jobs that will be stored in the specified backup
  vault. Backup vaults are identified by names that are unique to the account used to create
  them and the Amazon Web Services Region where they are created. They consist of lowercase
  letters, numbers, and hyphens.
- `"completeAfter"`: Returns only backup jobs completed after a date expressed in Unix
  format and Coordinated Universal Time (UTC).
- `"completeBefore"`: Returns only backup jobs completed before a date expressed in Unix
  format and Coordinated Universal Time (UTC).
- `"createdAfter"`: Returns only backup jobs that were created after the specified date.
- `"createdBefore"`: Returns only backup jobs that were created before the specified date.
- `"maxResults"`: The maximum number of items to be returned.
- `"messageCategory"`: This is an optional parameter that can be used to filter out jobs
  with a MessageCategory which matches the value you input. Example strings may include
  AccessDenied, SUCCESS, AGGREGATE_ALL, and InvalidParameters. View Monitoring  The wildcard
  () returns count of all message categories.  AGGREGATE_ALL aggregates job counts for all
  message categories and returns the sum.
- `"nextToken"`: The next item following a partial list of returned items. For example, if
  a request is made to return MaxResults number of items, NextToken allows you to return more
  items in your list starting at the location pointed to by the next token.
- `"parentJobId"`: This is a filter to list child (nested) jobs based on parent job ID.
- `"resourceArn"`: Returns only backup jobs that match the specified resource Amazon
  Resource Name (ARN).
- `"resourceType"`: Returns only backup jobs for the specified resources:    Aurora for
  Amazon Aurora    CloudFormation for CloudFormation    DocumentDB for Amazon DocumentDB
  (with MongoDB compatibility)    DynamoDB for Amazon DynamoDB    EBS for Amazon Elastic
  Block Store    EC2 for Amazon Elastic Compute Cloud    EFS for Amazon Elastic File System
   FSx for Amazon FSx    Neptune for Amazon Neptune    Redshift for Amazon Redshift    RDS
  for Amazon Relational Database Service    SAP HANA on Amazon EC2 for SAP HANA databases
  Storage Gateway for Storage Gateway    S3 for Amazon S3    Timestream for Amazon Timestream
     VirtualMachine for virtual machines
- `"state"`: Returns only backup jobs that are in the specified state.  Completed with
  issues is a status found only in the Backup console. For API, this status refers to jobs
  with a state of COMPLETED and a MessageCategory with a value other than SUCCESS; that is,
  the status is completed but comes with a status message. To obtain the job count for
  Completed with issues, run two GET requests, and subtract the second, smaller number: GET
  /backup-jobs/?state=COMPLETED GET /backup-jobs/?messageCategory=SUCCESS&amp;state=COMPLETED
"""
function list_backup_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return backup(
        "GET", "/backup-jobs/"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_backup_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "GET",
        "/backup-jobs/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_backup_plan_templates()
    list_backup_plan_templates(params::Dict{String,<:Any})

Returns metadata of your saved backup plan templates, including the template ID, name, and
the creation and deletion dates.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of items to be returned.
- `"nextToken"`: The next item following a partial list of returned items. For example, if
  a request is made to return MaxResults number of items, NextToken allows you to return more
  items in your list starting at the location pointed to by the next token.
"""
function list_backup_plan_templates(; aws_config::AbstractAWSConfig=current_aws_config())
    return backup(
        "GET",
        "/backup/template/plans";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_backup_plan_templates(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "GET",
        "/backup/template/plans",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_backup_plan_versions(backup_plan_id)
    list_backup_plan_versions(backup_plan_id, params::Dict{String,<:Any})

Returns version metadata of your backup plans, including Amazon Resource Names (ARNs),
backup plan IDs, creation and deletion dates, plan names, and version IDs.

# Arguments
- `backup_plan_id`: Uniquely identifies a backup plan.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of items to be returned.
- `"nextToken"`: The next item following a partial list of returned items. For example, if
  a request is made to return MaxResults number of items, NextToken allows you to return more
  items in your list starting at the location pointed to by the next token.
"""
function list_backup_plan_versions(
    backupPlanId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "GET",
        "/backup/plans/$(backupPlanId)/versions/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_backup_plan_versions(
    backupPlanId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "GET",
        "/backup/plans/$(backupPlanId)/versions/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_backup_plans()
    list_backup_plans(params::Dict{String,<:Any})

Returns a list of all active backup plans for an authenticated account. The list contains
information such as Amazon Resource Names (ARNs), plan IDs, creation and deletion dates,
version IDs, plan names, and creator request IDs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"includeDeleted"`: A Boolean value with a default value of FALSE that returns deleted
  backup plans when set to TRUE.
- `"maxResults"`: The maximum number of items to be returned.
- `"nextToken"`: The next item following a partial list of returned items. For example, if
  a request is made to return MaxResults number of items, NextToken allows you to return more
  items in your list starting at the location pointed to by the next token.
"""
function list_backup_plans(; aws_config::AbstractAWSConfig=current_aws_config())
    return backup(
        "GET", "/backup/plans/"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_backup_plans(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "GET",
        "/backup/plans/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_backup_selections(backup_plan_id)
    list_backup_selections(backup_plan_id, params::Dict{String,<:Any})

Returns an array containing metadata of the resources associated with the target backup
plan.

# Arguments
- `backup_plan_id`: Uniquely identifies a backup plan.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of items to be returned.
- `"nextToken"`: The next item following a partial list of returned items. For example, if
  a request is made to return MaxResults number of items, NextToken allows you to return more
  items in your list starting at the location pointed to by the next token.
"""
function list_backup_selections(
    backupPlanId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "GET",
        "/backup/plans/$(backupPlanId)/selections/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_backup_selections(
    backupPlanId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "GET",
        "/backup/plans/$(backupPlanId)/selections/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_backup_vaults()
    list_backup_vaults(params::Dict{String,<:Any})

Returns a list of recovery point storage containers along with information about them.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of items to be returned.
- `"nextToken"`: The next item following a partial list of returned items. For example, if
  a request is made to return MaxResults number of items, NextToken allows you to return more
  items in your list starting at the location pointed to by the next token.
- `"shared"`: This parameter will sort the list of vaults by shared vaults.
- `"vaultType"`: This parameter will sort the list of vaults by vault type.
"""
function list_backup_vaults(; aws_config::AbstractAWSConfig=current_aws_config())
    return backup(
        "GET", "/backup-vaults/"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_backup_vaults(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "GET",
        "/backup-vaults/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_copy_job_summaries()
    list_copy_job_summaries(params::Dict{String,<:Any})

This request obtains a list of copy jobs created or running within the the most recent 30
days. You can include parameters AccountID, State, ResourceType, MessageCategory,
AggregationPeriod, MaxResults, or NextToken to filter results. This request returns a
summary that contains Region, Account, State, RestourceType, MessageCategory, StartTime,
EndTime, and Count of included jobs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccountId"`: Returns the job count for the specified account. If the request is sent
  from a member account or an account not part of Amazon Web Services Organizations, jobs
  within requestor's account will be returned. Root, admin, and delegated administrator
  accounts can use the value ANY to return job counts from every account in the organization.
   AGGREGATE_ALL aggregates job counts from all accounts within the authenticated
  organization, then returns the sum.
- `"AggregationPeriod"`: This is the period that sets the boundaries for returned results.
    ONE_DAY for daily job count for the prior 14 days.    SEVEN_DAYS for the aggregated job
  count for the prior 7 days.    FOURTEEN_DAYS for aggregated job count for prior 14 days.
- `"MaxResults"`: This parameter sets the maximum number of items to be returned. The value
  is an integer. Range of accepted values is from 1 to 500.
- `"MessageCategory"`: This parameter returns the job count for the specified message
  category. Example accepted strings include AccessDenied, Success, and InvalidParameters.
  See Monitoring for a list of accepted MessageCategory strings. The the value ANY returns
  count of all message categories.  AGGREGATE_ALL aggregates job counts for all message
  categories and returns the sum.
- `"NextToken"`: The next item following a partial list of returned resources. For example,
  if a request is made to return MaxResults number of resources, NextToken allows you to
  return more items in your list starting at the location pointed to by the next token.
- `"ResourceType"`: Returns the job count for the specified resource type. Use request
  GetSupportedResourceTypes to obtain strings for supported resource types. The the value ANY
  returns count of all resource types.  AGGREGATE_ALL aggregates job counts for all resource
  types and returns the sum. The type of Amazon Web Services resource to be backed up; for
  example, an Amazon Elastic Block Store (Amazon EBS) volume or an Amazon Relational Database
  Service (Amazon RDS) database.
- `"State"`: This parameter returns the job count for jobs with the specified state. The
  the value ANY returns count of all states.  AGGREGATE_ALL aggregates job counts for all
  states and returns the sum.
"""
function list_copy_job_summaries(; aws_config::AbstractAWSConfig=current_aws_config())
    return backup(
        "GET",
        "/audit/copy-job-summaries";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_copy_job_summaries(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "GET",
        "/audit/copy-job-summaries",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_copy_jobs()
    list_copy_jobs(params::Dict{String,<:Any})

Returns metadata about your copy jobs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountId"`: The account ID to list the jobs from. Returns only copy jobs associated
  with the specified account ID.
- `"completeAfter"`: Returns only copy jobs completed after a date expressed in Unix format
  and Coordinated Universal Time (UTC).
- `"completeBefore"`: Returns only copy jobs completed before a date expressed in Unix
  format and Coordinated Universal Time (UTC).
- `"createdAfter"`: Returns only copy jobs that were created after the specified date.
- `"createdBefore"`: Returns only copy jobs that were created before the specified date.
- `"destinationVaultArn"`: An Amazon Resource Name (ARN) that uniquely identifies a source
  backup vault to copy from; for example,
  arn:aws:backup:us-east-1:123456789012:vault:aBackupVault.
- `"maxResults"`: The maximum number of items to be returned.
- `"messageCategory"`: This is an optional parameter that can be used to filter out jobs
  with a MessageCategory which matches the value you input. Example strings may include
  AccessDenied, SUCCESS, AGGREGATE_ALL, and INVALIDPARAMETERS. View Monitoring for a list of
  accepted strings. The the value ANY returns count of all message categories.  AGGREGATE_ALL
  aggregates job counts for all message categories and returns the sum.
- `"nextToken"`: The next item following a partial list of returned items. For example, if
  a request is made to return MaxResults number of items, NextToken allows you to return more
  items in your list starting at the location pointed to by the next token.
- `"parentJobId"`: This is a filter to list child (nested) jobs based on parent job ID.
- `"resourceArn"`: Returns only copy jobs that match the specified resource Amazon Resource
  Name (ARN).
- `"resourceType"`: Returns only backup jobs for the specified resources:    Aurora for
  Amazon Aurora    CloudFormation for CloudFormation    DocumentDB for Amazon DocumentDB
  (with MongoDB compatibility)    DynamoDB for Amazon DynamoDB    EBS for Amazon Elastic
  Block Store    EC2 for Amazon Elastic Compute Cloud    EFS for Amazon Elastic File System
   FSx for Amazon FSx    Neptune for Amazon Neptune    Redshift for Amazon Redshift    RDS
  for Amazon Relational Database Service    SAP HANA on Amazon EC2 for SAP HANA databases
  Storage Gateway for Storage Gateway    S3 for Amazon S3    Timestream for Amazon Timestream
     VirtualMachine for virtual machines
- `"state"`: Returns only copy jobs that are in the specified state.
"""
function list_copy_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return backup(
        "GET", "/copy-jobs/"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_copy_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "GET", "/copy-jobs/", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_frameworks()
    list_frameworks(params::Dict{String,<:Any})

Returns a list of all frameworks for an Amazon Web Services account and Amazon Web Services
Region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The number of desired results from 1 to 1000. Optional. If unspecified,
  the query will return 1 MB of data.
- `"NextToken"`: An identifier that was returned from the previous call to this operation,
  which can be used to return the next set of items in the list.
"""
function list_frameworks(; aws_config::AbstractAWSConfig=current_aws_config())
    return backup(
        "GET", "/audit/frameworks"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_frameworks(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "GET",
        "/audit/frameworks",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_legal_holds()
    list_legal_holds(params::Dict{String,<:Any})

This action returns metadata about active and previous legal holds.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of resource list items to be returned.
- `"nextToken"`: The next item following a partial list of returned resources. For example,
  if a request is made to return MaxResults number of resources, NextToken allows you to
  return more items in your list starting at the location pointed to by the next token.
"""
function list_legal_holds(; aws_config::AbstractAWSConfig=current_aws_config())
    return backup(
        "GET", "/legal-holds/"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_legal_holds(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "GET",
        "/legal-holds/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_protected_resources()
    list_protected_resources(params::Dict{String,<:Any})

Returns an array of resources successfully backed up by Backup, including the time the
resource was saved, an Amazon Resource Name (ARN) of the resource, and a resource type.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of items to be returned.
- `"nextToken"`: The next item following a partial list of returned items. For example, if
  a request is made to return MaxResults number of items, NextToken allows you to return more
  items in your list starting at the location pointed to by the next token.
"""
function list_protected_resources(; aws_config::AbstractAWSConfig=current_aws_config())
    return backup(
        "GET", "/resources/"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_protected_resources(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "GET", "/resources/", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_protected_resources_by_backup_vault(backup_vault_name)
    list_protected_resources_by_backup_vault(backup_vault_name, params::Dict{String,<:Any})

This request lists the protected resources corresponding to each backup vault.

# Arguments
- `backup_vault_name`: This is the list of protected resources by backup vault within the
  vault(s) you specify by name.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"backupVaultAccountId"`: This is the list of protected resources by backup vault within
  the vault(s) you specify by account ID.
- `"maxResults"`: The maximum number of items to be returned.
- `"nextToken"`: The next item following a partial list of returned items. For example, if
  a request is made to return MaxResults number of items, NextToken allows you to return more
  items in your list starting at the location pointed to by the next token.
"""
function list_protected_resources_by_backup_vault(
    backupVaultName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "GET",
        "/backup-vaults/$(backupVaultName)/resources/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_protected_resources_by_backup_vault(
    backupVaultName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "GET",
        "/backup-vaults/$(backupVaultName)/resources/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_recovery_points_by_backup_vault(backup_vault_name)
    list_recovery_points_by_backup_vault(backup_vault_name, params::Dict{String,<:Any})

Returns detailed information about the recovery points stored in a backup vault.

# Arguments
- `backup_vault_name`: The name of a logical container where backups are stored. Backup
  vaults are identified by names that are unique to the account used to create them and the
  Amazon Web Services Region where they are created. They consist of lowercase letters,
  numbers, and hyphens.  Backup vault name might not be available when a supported service
  creates the backup.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"backupPlanId"`: Returns only recovery points that match the specified backup plan ID.
- `"backupVaultAccountId"`: This parameter will sort the list of recovery points by account
  ID.
- `"createdAfter"`: Returns only recovery points that were created after the specified
  timestamp.
- `"createdBefore"`: Returns only recovery points that were created before the specified
  timestamp.
- `"maxResults"`: The maximum number of items to be returned.
- `"nextToken"`: The next item following a partial list of returned items. For example, if
  a request is made to return MaxResults number of items, NextToken allows you to return more
  items in your list starting at the location pointed to by the next token.
- `"parentRecoveryPointArn"`: This returns only recovery points that match the specified
  parent (composite) recovery point Amazon Resource Name (ARN).
- `"resourceArn"`: Returns only recovery points that match the specified resource Amazon
  Resource Name (ARN).
- `"resourceType"`: Returns only recovery points that match the specified resource type(s):
     Aurora for Amazon Aurora    CloudFormation for CloudFormation    DocumentDB for Amazon
  DocumentDB (with MongoDB compatibility)    DynamoDB for Amazon DynamoDB    EBS for Amazon
  Elastic Block Store    EC2 for Amazon Elastic Compute Cloud    EFS for Amazon Elastic File
  System    FSx for Amazon FSx    Neptune for Amazon Neptune    Redshift for Amazon Redshift
    RDS for Amazon Relational Database Service    SAP HANA on Amazon EC2 for SAP HANA
  databases    Storage Gateway for Storage Gateway    S3 for Amazon S3    Timestream for
  Amazon Timestream    VirtualMachine for virtual machines
"""
function list_recovery_points_by_backup_vault(
    backupVaultName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "GET",
        "/backup-vaults/$(backupVaultName)/recovery-points/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_recovery_points_by_backup_vault(
    backupVaultName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "GET",
        "/backup-vaults/$(backupVaultName)/recovery-points/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_recovery_points_by_legal_hold(legal_hold_id)
    list_recovery_points_by_legal_hold(legal_hold_id, params::Dict{String,<:Any})

This action returns recovery point ARNs (Amazon Resource Names) of the specified legal hold.

# Arguments
- `legal_hold_id`: This is the ID of the legal hold.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: This is the maximum number of resource list items to be returned.
- `"nextToken"`: This is the next item following a partial list of returned resources. For
  example, if a request is made to return MaxResults number of resources, NextToken allows
  you to return more items in your list starting at the location pointed to by the next token.
"""
function list_recovery_points_by_legal_hold(
    legalHoldId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "GET",
        "/legal-holds/$(legalHoldId)/recovery-points";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_recovery_points_by_legal_hold(
    legalHoldId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "GET",
        "/legal-holds/$(legalHoldId)/recovery-points",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_recovery_points_by_resource(resource_arn)
    list_recovery_points_by_resource(resource_arn, params::Dict{String,<:Any})

Returns detailed information about all the recovery points of the type specified by a
resource Amazon Resource Name (ARN).  For Amazon EFS and Amazon EC2, this action only lists
recovery points created by Backup.

# Arguments
- `resource_arn`: An ARN that uniquely identifies a resource. The format of the ARN depends
  on the resource type.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"managedByAWSBackupOnly"`: This attribute filters recovery points based on ownership. If
  this is set to TRUE, the response will contain recovery points associated with the selected
  resources that are managed by Backup. If this is set to FALSE, the response will contain
  all recovery points associated with the selected resource. Type: Boolean
- `"maxResults"`: The maximum number of items to be returned.  Amazon RDS requires a value
  of at least 20.
- `"nextToken"`: The next item following a partial list of returned items. For example, if
  a request is made to return MaxResults number of items, NextToken allows you to return more
  items in your list starting at the location pointed to by the next token.
"""
function list_recovery_points_by_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "GET",
        "/resources/$(resourceArn)/recovery-points/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_recovery_points_by_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "GET",
        "/resources/$(resourceArn)/recovery-points/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_report_jobs()
    list_report_jobs(params::Dict{String,<:Any})

Returns details about your report jobs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CreationAfter"`: Returns only report jobs that were created after the date and time
  specified in Unix format and Coordinated Universal Time (UTC). For example, the value
  1516925490 represents Friday, January 26, 2018 12:11:30 AM.
- `"CreationBefore"`: Returns only report jobs that were created before the date and time
  specified in Unix format and Coordinated Universal Time (UTC). For example, the value
  1516925490 represents Friday, January 26, 2018 12:11:30 AM.
- `"MaxResults"`: The number of desired results from 1 to 1000. Optional. If unspecified,
  the query will return 1 MB of data.
- `"NextToken"`: An identifier that was returned from the previous call to this operation,
  which can be used to return the next set of items in the list.
- `"ReportPlanName"`: Returns only report jobs with the specified report plan name.
- `"Status"`: Returns only report jobs that are in the specified status. The statuses are:
  CREATED | RUNNING | COMPLETED | FAILED
"""
function list_report_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return backup(
        "GET", "/audit/report-jobs"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_report_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "GET",
        "/audit/report-jobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_report_plans()
    list_report_plans(params::Dict{String,<:Any})

Returns a list of your report plans. For detailed information about a single report plan,
use DescribeReportPlan.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The number of desired results from 1 to 1000. Optional. If unspecified,
  the query will return 1 MB of data.
- `"NextToken"`: An identifier that was returned from the previous call to this operation,
  which can be used to return the next set of items in the list.
"""
function list_report_plans(; aws_config::AbstractAWSConfig=current_aws_config())
    return backup(
        "GET", "/audit/report-plans"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_report_plans(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "GET",
        "/audit/report-plans",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_restore_job_summaries()
    list_restore_job_summaries(params::Dict{String,<:Any})

This request obtains a summary of restore jobs created or running within the the most
recent 30 days. You can include parameters AccountID, State, ResourceType,
AggregationPeriod, MaxResults, or NextToken to filter results. This request returns a
summary that contains Region, Account, State, RestourceType, MessageCategory, StartTime,
EndTime, and Count of included jobs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccountId"`: Returns the job count for the specified account. If the request is sent
  from a member account or an account not part of Amazon Web Services Organizations, jobs
  within requestor's account will be returned. Root, admin, and delegated administrator
  accounts can use the value ANY to return job counts from every account in the organization.
   AGGREGATE_ALL aggregates job counts from all accounts within the authenticated
  organization, then returns the sum.
- `"AggregationPeriod"`: This is the period that sets the boundaries for returned results.
  Acceptable values include    ONE_DAY for daily job count for the prior 14 days.
  SEVEN_DAYS for the aggregated job count for the prior 7 days.    FOURTEEN_DAYS for
  aggregated job count for prior 14 days.
- `"MaxResults"`: This parameter sets the maximum number of items to be returned. The value
  is an integer. Range of accepted values is from 1 to 500.
- `"NextToken"`: The next item following a partial list of returned resources. For example,
  if a request is made to return MaxResults number of resources, NextToken allows you to
  return more items in your list starting at the location pointed to by the next token.
- `"ResourceType"`: Returns the job count for the specified resource type. Use request
  GetSupportedResourceTypes to obtain strings for supported resource types. The the value ANY
  returns count of all resource types.  AGGREGATE_ALL aggregates job counts for all resource
  types and returns the sum. The type of Amazon Web Services resource to be backed up; for
  example, an Amazon Elastic Block Store (Amazon EBS) volume or an Amazon Relational Database
  Service (Amazon RDS) database.
- `"State"`: This parameter returns the job count for jobs with the specified state. The
  the value ANY returns count of all states.  AGGREGATE_ALL aggregates job counts for all
  states and returns the sum.
"""
function list_restore_job_summaries(; aws_config::AbstractAWSConfig=current_aws_config())
    return backup(
        "GET",
        "/audit/restore-job-summaries";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_restore_job_summaries(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "GET",
        "/audit/restore-job-summaries",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_restore_jobs()
    list_restore_jobs(params::Dict{String,<:Any})

Returns a list of jobs that Backup initiated to restore a saved resource, including details
about the recovery process.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountId"`: The account ID to list the jobs from. Returns only restore jobs associated
  with the specified account ID.
- `"completeAfter"`: Returns only copy jobs completed after a date expressed in Unix format
  and Coordinated Universal Time (UTC).
- `"completeBefore"`: Returns only copy jobs completed before a date expressed in Unix
  format and Coordinated Universal Time (UTC).
- `"createdAfter"`: Returns only restore jobs that were created after the specified date.
- `"createdBefore"`: Returns only restore jobs that were created before the specified date.
- `"maxResults"`: The maximum number of items to be returned.
- `"nextToken"`: The next item following a partial list of returned items. For example, if
  a request is made to return MaxResults number of items, NextToken allows you to return more
  items in your list starting at the location pointed to by the next token.
- `"resourceType"`: Include this parameter to return only restore jobs for the specified
  resources:    Aurora for Amazon Aurora    CloudFormation for CloudFormation    DocumentDB
  for Amazon DocumentDB (with MongoDB compatibility)    DynamoDB for Amazon DynamoDB    EBS
  for Amazon Elastic Block Store    EC2 for Amazon Elastic Compute Cloud    EFS for Amazon
  Elastic File System    FSx for Amazon FSx    Neptune for Amazon Neptune    Redshift for
  Amazon Redshift    RDS for Amazon Relational Database Service    SAP HANA on Amazon EC2 for
  SAP HANA databases    Storage Gateway for Storage Gateway    S3 for Amazon S3    Timestream
  for Amazon Timestream    VirtualMachine for virtual machines
- `"restoreTestingPlanArn"`: This returns only restore testing jobs that match the
  specified resource Amazon Resource Name (ARN).
- `"status"`: Returns only restore jobs associated with the specified job status.
"""
function list_restore_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return backup(
        "GET", "/restore-jobs/"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_restore_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "GET",
        "/restore-jobs/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_restore_jobs_by_protected_resource(resource_arn)
    list_restore_jobs_by_protected_resource(resource_arn, params::Dict{String,<:Any})

This returns restore jobs that contain the specified protected resource. You must include
ResourceArn. You can optionally include NextToken, ByStatus, MaxResults,
ByRecoveryPointCreationDateAfter , and ByRecoveryPointCreationDateBefore.

# Arguments
- `resource_arn`: Returns only restore jobs that match the specified resource Amazon
  Resource Name (ARN).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of items to be returned.
- `"nextToken"`: The next item following a partial list of returned items. For example, if
  a request ismade to return MaxResults number of items, NextToken allows you to return more
  items in your list starting at the location pointed to by the next token.
- `"recoveryPointCreationDateAfter"`: Returns only restore jobs of recovery points that
  were created after the specified date.
- `"recoveryPointCreationDateBefore"`: Returns only restore jobs of recovery points that
  were created before the specified date.
- `"status"`: Returns only restore jobs associated with the specified job status.
"""
function list_restore_jobs_by_protected_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "GET",
        "/resources/$(resourceArn)/restore-jobs/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_restore_jobs_by_protected_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "GET",
        "/resources/$(resourceArn)/restore-jobs/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_restore_testing_plans()
    list_restore_testing_plans(params::Dict{String,<:Any})

Returns a list of restore testing plans.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of items to be returned.
- `"NextToken"`: The next item following a partial list of returned items. For example, if
  a request is made to return MaxResults number of items, NextToken allows you to return more
  items in your list starting at the location pointed to by the nexttoken.
"""
function list_restore_testing_plans(; aws_config::AbstractAWSConfig=current_aws_config())
    return backup(
        "GET",
        "/restore-testing/plans";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_restore_testing_plans(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "GET",
        "/restore-testing/plans",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_restore_testing_selections(restore_testing_plan_name)
    list_restore_testing_selections(restore_testing_plan_name, params::Dict{String,<:Any})

Returns a list of restore testing selections. Can be filtered by MaxResults and
RestoreTestingPlanName.

# Arguments
- `restore_testing_plan_name`: Returns restore testing selections by the specified restore
  testing plan name.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of items to be returned.
- `"NextToken"`: The next item following a partial list of returned items. For example, if
  a request is made to return MaxResults number of items, NextToken allows you to return more
  items in your list starting at the location pointed to by the nexttoken.
"""
function list_restore_testing_selections(
    RestoreTestingPlanName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "GET",
        "/restore-testing/plans/$(RestoreTestingPlanName)/selections";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_restore_testing_selections(
    RestoreTestingPlanName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "GET",
        "/restore-testing/plans/$(RestoreTestingPlanName)/selections",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags(resource_arn)
    list_tags(resource_arn, params::Dict{String,<:Any})

Returns a list of key-value pairs assigned to a target recovery point, backup plan, or
backup vault.  ListTags only works for resource types that support full Backup management
of their backups. Those resource types are listed in the \"Full Backup management\" section
of the  Feature availability by resource table.

# Arguments
- `resource_arn`: An Amazon Resource Name (ARN) that uniquely identifies a resource. The
  format of the ARN depends on the type of resource. Valid targets for ListTags are recovery
  points, backup plans, and backup vaults.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of items to be returned.
- `"nextToken"`: The next item following a partial list of returned items. For example, if
  a request is made to return MaxResults number of items, NextToken allows you to return more
  items in your list starting at the location pointed to by the next token.
"""
function list_tags(resourceArn; aws_config::AbstractAWSConfig=current_aws_config())
    return backup(
        "GET",
        "/tags/$(resourceArn)/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "GET",
        "/tags/$(resourceArn)/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_backup_vault_access_policy(backup_vault_name)
    put_backup_vault_access_policy(backup_vault_name, params::Dict{String,<:Any})

Sets a resource-based policy that is used to manage access permissions on the target backup
vault. Requires a backup vault name and an access policy document in JSON format.

# Arguments
- `backup_vault_name`: The name of a logical container where backups are stored. Backup
  vaults are identified by names that are unique to the account used to create them and the
  Amazon Web Services Region where they are created. They consist of lowercase letters,
  numbers, and hyphens.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Policy"`: The backup vault access policy document in JSON format.
"""
function put_backup_vault_access_policy(
    backupVaultName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "PUT",
        "/backup-vaults/$(backupVaultName)/access-policy";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_backup_vault_access_policy(
    backupVaultName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "PUT",
        "/backup-vaults/$(backupVaultName)/access-policy",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_backup_vault_lock_configuration(backup_vault_name)
    put_backup_vault_lock_configuration(backup_vault_name, params::Dict{String,<:Any})

Applies Backup Vault Lock to a backup vault, preventing attempts to delete any recovery
point stored in or created in a backup vault. Vault Lock also prevents attempts to update
the lifecycle policy that controls the retention period of any recovery point currently
stored in a backup vault. If specified, Vault Lock enforces a minimum and maximum retention
period for future backup and copy jobs that target a backup vault.  Backup Vault Lock has
been assessed by Cohasset Associates for use in environments that are subject to SEC 17a-4,
CFTC, and FINRA regulations. For more information about how Backup Vault Lock relates to
these regulations, see the Cohasset Associates Compliance Assessment.

# Arguments
- `backup_vault_name`: The Backup Vault Lock configuration that specifies the name of the
  backup vault it protects.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ChangeableForDays"`: The Backup Vault Lock configuration that specifies the number of
  days before the lock date. For example, setting ChangeableForDays to 30 on Jan. 1, 2022 at
  8pm UTC will set the lock date to Jan. 31, 2022 at 8pm UTC. Backup enforces a 72-hour
  cooling-off period before Vault Lock takes effect and becomes immutable. Therefore, you
  must set ChangeableForDays to 3 or greater. Before the lock date, you can delete Vault Lock
  from the vault using DeleteBackupVaultLockConfiguration or change the Vault Lock
  configuration using PutBackupVaultLockConfiguration. On and after the lock date, the Vault
  Lock becomes immutable and cannot be changed or deleted. If this parameter is not
  specified, you can delete Vault Lock from the vault using
  DeleteBackupVaultLockConfiguration or change the Vault Lock configuration using
  PutBackupVaultLockConfiguration at any time.
- `"MaxRetentionDays"`: The Backup Vault Lock configuration that specifies the maximum
  retention period that the vault retains its recovery points. This setting can be useful if,
  for example, your organization's policies require you to destroy certain data after
  retaining it for four years (1460 days). If this parameter is not included, Vault Lock does
  not enforce a maximum retention period on the recovery points in the vault. If this
  parameter is included without a value, Vault Lock will not enforce a maximum retention
  period. If this parameter is specified, any backup or copy job to the vault must have a
  lifecycle policy with a retention period equal to or shorter than the maximum retention
  period. If the job's retention period is longer than that maximum retention period, then
  the vault fails the backup or copy job, and you should either modify your lifecycle
  settings or use a different vault. The longest maximum retention period you can specify is
  36500 days (approximately 100 years). Recovery points already saved in the vault prior to
  Vault Lock are not affected.
- `"MinRetentionDays"`: The Backup Vault Lock configuration that specifies the minimum
  retention period that the vault retains its recovery points. This setting can be useful if,
  for example, your organization's policies require you to retain certain data for at least
  seven years (2555 days). If this parameter is not specified, Vault Lock will not enforce a
  minimum retention period. If this parameter is specified, any backup or copy job to the
  vault must have a lifecycle policy with a retention period equal to or longer than the
  minimum retention period. If the job's retention period is shorter than that minimum
  retention period, then the vault fails that backup or copy job, and you should either
  modify your lifecycle settings or use a different vault. The shortest minimum retention
  period you can specify is 1 day. Recovery points already saved in the vault prior to Vault
  Lock are not affected.
"""
function put_backup_vault_lock_configuration(
    backupVaultName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "PUT",
        "/backup-vaults/$(backupVaultName)/vault-lock";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_backup_vault_lock_configuration(
    backupVaultName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "PUT",
        "/backup-vaults/$(backupVaultName)/vault-lock",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_backup_vault_notifications(backup_vault_events, snstopic_arn, backup_vault_name)
    put_backup_vault_notifications(backup_vault_events, snstopic_arn, backup_vault_name, params::Dict{String,<:Any})

Turns on notifications on a backup vault for the specified topic and events.

# Arguments
- `backup_vault_events`: An array of events that indicate the status of jobs to back up
  resources to the backup vault. For common use cases and code samples, see Using Amazon SNS
  to track Backup events. The following events are supported:    BACKUP_JOB_STARTED |
  BACKUP_JOB_COMPLETED     COPY_JOB_STARTED | COPY_JOB_SUCCESSFUL | COPY_JOB_FAILED
  RESTORE_JOB_STARTED | RESTORE_JOB_COMPLETED | RECOVERY_POINT_MODIFIED
  S3_BACKUP_OBJECT_FAILED | S3_RESTORE_OBJECT_FAILED     The list below shows items that are
  deprecated events (for reference) and are no longer in use. They are no longer supported
  and will not return statuses or notifications. Refer to the list above for current
  supported events.
- `snstopic_arn`: The Amazon Resource Name (ARN) that specifies the topic for a backup
  vault’s events; for example, arn:aws:sns:us-west-2:111122223333:MyVaultTopic.
- `backup_vault_name`: The name of a logical container where backups are stored. Backup
  vaults are identified by names that are unique to the account used to create them and the
  Amazon Web Services Region where they are created. They consist of lowercase letters,
  numbers, and hyphens.

"""
function put_backup_vault_notifications(
    BackupVaultEvents,
    SNSTopicArn,
    backupVaultName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "PUT",
        "/backup-vaults/$(backupVaultName)/notification-configuration",
        Dict{String,Any}(
            "BackupVaultEvents" => BackupVaultEvents, "SNSTopicArn" => SNSTopicArn
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_backup_vault_notifications(
    BackupVaultEvents,
    SNSTopicArn,
    backupVaultName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "PUT",
        "/backup-vaults/$(backupVaultName)/notification-configuration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "BackupVaultEvents" => BackupVaultEvents, "SNSTopicArn" => SNSTopicArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_restore_validation_result(validation_status, restore_job_id)
    put_restore_validation_result(validation_status, restore_job_id, params::Dict{String,<:Any})

This request allows you to send your independent self-run restore test validation results.
RestoreJobId and ValidationStatus are required. Optionally, you can input a
ValidationStatusMessage.

# Arguments
- `validation_status`: This is the status of your restore validation.
- `restore_job_id`: This is a unique identifier of a restore job within Backup.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ValidationStatusMessage"`: This is an optional message string you can input to describe
  the validation status for the restore test validation.
"""
function put_restore_validation_result(
    ValidationStatus, restoreJobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "PUT",
        "/restore-jobs/$(restoreJobId)/validations",
        Dict{String,Any}("ValidationStatus" => ValidationStatus);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_restore_validation_result(
    ValidationStatus,
    restoreJobId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "PUT",
        "/restore-jobs/$(restoreJobId)/validations",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ValidationStatus" => ValidationStatus), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_backup_job(backup_vault_name, iam_role_arn, resource_arn)
    start_backup_job(backup_vault_name, iam_role_arn, resource_arn, params::Dict{String,<:Any})

Starts an on-demand backup job for the specified resource.

# Arguments
- `backup_vault_name`: The name of a logical container where backups are stored. Backup
  vaults are identified by names that are unique to the account used to create them and the
  Amazon Web Services Region where they are created. They consist of lowercase letters,
  numbers, and hyphens.
- `iam_role_arn`: Specifies the IAM role ARN used to create the target recovery point; for
  example, arn:aws:iam::123456789012:role/S3Access.
- `resource_arn`: An Amazon Resource Name (ARN) that uniquely identifies a resource. The
  format of the ARN depends on the resource type.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"BackupOptions"`: Specifies the backup option for a selected resource. This option is
  only available for Windows Volume Shadow Copy Service (VSS) backup jobs. Valid values: Set
  to \"WindowsVSS\":\"enabled\" to enable the WindowsVSS backup option and create a Windows
  VSS backup. Set to \"WindowsVSS\"\"disabled\" to create a regular backup. The WindowsVSS
  option is not enabled by default.
- `"CompleteWindowMinutes"`: A value in minutes during which a successfully started backup
  must complete, or else Backup will cancel the job. This value is optional. This value
  begins counting down from when the backup was scheduled. It does not add additional time
  for StartWindowMinutes, or if the backup started later than scheduled. Like
  StartWindowMinutes, this parameter has a maximum value of 100 years (52,560,000 minutes).
- `"IdempotencyToken"`: A customer-chosen string that you can use to distinguish between
  otherwise identical calls to StartBackupJob. Retrying a successful request with the same
  idempotency token results in a success message with no action taken.
- `"Lifecycle"`: The lifecycle defines when a protected resource is transitioned to cold
  storage and when it expires. Backup will transition and expire backups automatically
  according to the lifecycle that you define.  Backups transitioned to cold storage must be
  stored in cold storage for a minimum of 90 days. Therefore, the “retention” setting
  must be 90 days greater than the “transition to cold after days” setting. The
  “transition to cold after days” setting cannot be changed after a backup has been
  transitioned to cold.  Resource types that are able to be transitioned to cold storage are
  listed in the \"Lifecycle to cold storage\" section of the  Feature availability by
  resource table. Backup ignores this expression for other resource types. This parameter has
  a maximum value of 100 years (36,500 days).
- `"RecoveryPointTags"`: To help organize your resources, you can assign your own metadata
  to the resources that you create. Each tag is a key-value pair.
- `"StartWindowMinutes"`: A value in minutes after a backup is scheduled before a job will
  be canceled if it doesn't start successfully. This value is optional, and the default is 8
  hours. If this value is included, it must be at least 60 minutes to avoid errors. This
  parameter has a maximum value of 100 years (52,560,000 minutes). During the start window,
  the backup job status remains in CREATED status until it has successfully begun or until
  the start window time has run out. If within the start window time Backup receives an error
  that allows the job to be retried, Backup will automatically retry to begin the job at
  least every 10 minutes until the backup successfully begins (the job status changes to
  RUNNING) or until the job status changes to EXPIRED (which is expected to occur when the
  start window time is over).
"""
function start_backup_job(
    BackupVaultName,
    IamRoleArn,
    ResourceArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "PUT",
        "/backup-jobs",
        Dict{String,Any}(
            "BackupVaultName" => BackupVaultName,
            "IamRoleArn" => IamRoleArn,
            "ResourceArn" => ResourceArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_backup_job(
    BackupVaultName,
    IamRoleArn,
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "PUT",
        "/backup-jobs",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "BackupVaultName" => BackupVaultName,
                    "IamRoleArn" => IamRoleArn,
                    "ResourceArn" => ResourceArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_copy_job(destination_backup_vault_arn, iam_role_arn, recovery_point_arn, source_backup_vault_name)
    start_copy_job(destination_backup_vault_arn, iam_role_arn, recovery_point_arn, source_backup_vault_name, params::Dict{String,<:Any})

Starts a job to create a one-time copy of the specified resource. Does not support
continuous backups.

# Arguments
- `destination_backup_vault_arn`: An Amazon Resource Name (ARN) that uniquely identifies a
  destination backup vault to copy to; for example,
  arn:aws:backup:us-east-1:123456789012:vault:aBackupVault.
- `iam_role_arn`: Specifies the IAM role ARN used to copy the target recovery point; for
  example, arn:aws:iam::123456789012:role/S3Access.
- `recovery_point_arn`: An ARN that uniquely identifies a recovery point to use for the
  copy job; for example,
  arn:aws:backup:us-east-1:123456789012:recovery-point:1EB3B5E7-9EB0-435A-A80B-108B488B0D45.
- `source_backup_vault_name`: The name of a logical source container where backups are
  stored. Backup vaults are identified by names that are unique to the account used to create
  them and the Amazon Web Services Region where they are created. They consist of lowercase
  letters, numbers, and hyphens.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"IdempotencyToken"`: A customer-chosen string that you can use to distinguish between
  otherwise identical calls to StartCopyJob. Retrying a successful request with the same
  idempotency token results in a success message with no action taken.
- `"Lifecycle"`:
"""
function start_copy_job(
    DestinationBackupVaultArn,
    IamRoleArn,
    RecoveryPointArn,
    SourceBackupVaultName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "PUT",
        "/copy-jobs",
        Dict{String,Any}(
            "DestinationBackupVaultArn" => DestinationBackupVaultArn,
            "IamRoleArn" => IamRoleArn,
            "RecoveryPointArn" => RecoveryPointArn,
            "SourceBackupVaultName" => SourceBackupVaultName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_copy_job(
    DestinationBackupVaultArn,
    IamRoleArn,
    RecoveryPointArn,
    SourceBackupVaultName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "PUT",
        "/copy-jobs",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DestinationBackupVaultArn" => DestinationBackupVaultArn,
                    "IamRoleArn" => IamRoleArn,
                    "RecoveryPointArn" => RecoveryPointArn,
                    "SourceBackupVaultName" => SourceBackupVaultName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_report_job(report_plan_name)
    start_report_job(report_plan_name, params::Dict{String,<:Any})

Starts an on-demand report job for the specified report plan.

# Arguments
- `report_plan_name`: The unique name of a report plan.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"IdempotencyToken"`: A customer-chosen string that you can use to distinguish between
  otherwise identical calls to StartReportJobInput. Retrying a successful request with the
  same idempotency token results in a success message with no action taken.
"""
function start_report_job(
    reportPlanName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "POST",
        "/audit/report-jobs/$(reportPlanName)",
        Dict{String,Any}("IdempotencyToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_report_job(
    reportPlanName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "POST",
        "/audit/report-jobs/$(reportPlanName)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("IdempotencyToken" => string(uuid4())), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_restore_job(metadata, recovery_point_arn)
    start_restore_job(metadata, recovery_point_arn, params::Dict{String,<:Any})

Recovers the saved resource identified by an Amazon Resource Name (ARN).

# Arguments
- `metadata`: A set of metadata key-value pairs. Contains information, such as a resource
  name, required to restore a recovery point.  You can get configuration metadata about a
  resource at the time it was backed up by calling GetRecoveryPointRestoreMetadata. However,
  values in addition to those provided by GetRecoveryPointRestoreMetadata might be required
  to restore a resource. For example, you might need to provide a new resource name if the
  original already exists. You need to specify specific metadata to restore an Amazon Elastic
  File System (Amazon EFS) instance:    file-system-id: The ID of the Amazon EFS file system
  that is backed up by Backup. Returned in GetRecoveryPointRestoreMetadata.    Encrypted: A
  Boolean value that, if true, specifies that the file system is encrypted. If KmsKeyId is
  specified, Encrypted must be set to true.    KmsKeyId: Specifies the Amazon Web Services
  KMS key that is used to encrypt the restored file system. You can specify a key from
  another Amazon Web Services account provided that key it is properly shared with your
  account via Amazon Web Services KMS.    PerformanceMode: Specifies the throughput mode of
  the file system.    CreationToken: A user-supplied value that ensures the uniqueness
  (idempotency) of the request.    newFileSystem: A Boolean value that, if true, specifies
  that the recovery point is restored to a new Amazon EFS file system.    ItemsToRestore: An
  array of one to five strings where each string is a file path. Use ItemsToRestore to
  restore specific files or directories rather than the entire file system. This parameter is
  optional. For example, \"itemsToRestore\":\"[\"/my.test\"]\".
- `recovery_point_arn`: An ARN that uniquely identifies a recovery point; for example,
  arn:aws:backup:us-east-1:123456789012:recovery-point:1EB3B5E7-9EB0-435A-A80B-108B488B0D45.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CopySourceTagsToRestoredResource"`: This is an optional parameter. If this equals True,
  tags included in the backup will be copied to the restored resource. This can only be
  applied to backups created through Backup.
- `"IamRoleArn"`: The Amazon Resource Name (ARN) of the IAM role that Backup uses to create
  the target resource; for example: arn:aws:iam::123456789012:role/S3Access.
- `"IdempotencyToken"`: A customer-chosen string that you can use to distinguish between
  otherwise identical calls to StartRestoreJob. Retrying a successful request with the same
  idempotency token results in a success message with no action taken.
- `"ResourceType"`: Starts a job to restore a recovery point for one of the following
  resources:    Aurora for Amazon Aurora    DocumentDB for Amazon DocumentDB (with MongoDB
  compatibility)    CloudFormation for CloudFormation    DynamoDB for Amazon DynamoDB    EBS
  for Amazon Elastic Block Store    EC2 for Amazon Elastic Compute Cloud    EFS for Amazon
  Elastic File System    FSx for Amazon FSx    Neptune for Amazon Neptune    RDS for Amazon
  Relational Database Service    Redshift for Amazon Redshift    Storage Gateway for Storage
  Gateway    S3 for Amazon S3    Timestream for Amazon Timestream    VirtualMachine for
  virtual machines
"""
function start_restore_job(
    Metadata, RecoveryPointArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "PUT",
        "/restore-jobs",
        Dict{String,Any}("Metadata" => Metadata, "RecoveryPointArn" => RecoveryPointArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_restore_job(
    Metadata,
    RecoveryPointArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "PUT",
        "/restore-jobs",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Metadata" => Metadata, "RecoveryPointArn" => RecoveryPointArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_backup_job(backup_job_id)
    stop_backup_job(backup_job_id, params::Dict{String,<:Any})

Attempts to cancel a job to create a one-time backup of a resource. This action is not
supported for the following services: Amazon FSx for Windows File Server, Amazon FSx for
Lustre, Amazon FSx for NetApp ONTAP , Amazon FSx for OpenZFS, Amazon DocumentDB (with
MongoDB compatibility), Amazon RDS, Amazon Aurora, and Amazon Neptune.

# Arguments
- `backup_job_id`: Uniquely identifies a request to Backup to back up a resource.

"""
function stop_backup_job(backupJobId; aws_config::AbstractAWSConfig=current_aws_config())
    return backup(
        "POST",
        "/backup-jobs/$(backupJobId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_backup_job(
    backupJobId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "POST",
        "/backup-jobs/$(backupJobId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(tags, resource_arn)
    tag_resource(tags, resource_arn, params::Dict{String,<:Any})

Assigns a set of key-value pairs to a recovery point, backup plan, or backup vault
identified by an Amazon Resource Name (ARN).

# Arguments
- `tags`: Key-value pairs that are used to help organize your resources. You can assign
  your own metadata to the resources you create. For clarity, this is the structure to assign
  tags: [{\"Key\":\"string\",\"Value\":\"string\"}].
- `resource_arn`: An ARN that uniquely identifies a resource. The format of the ARN depends
  on the type of the tagged resource.

"""
function tag_resource(Tags, resourceArn; aws_config::AbstractAWSConfig=current_aws_config())
    return backup(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    Tags,
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Tags" => Tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(tag_key_list, resource_arn)
    untag_resource(tag_key_list, resource_arn, params::Dict{String,<:Any})

Removes a set of key-value pairs from a recovery point, backup plan, or backup vault
identified by an Amazon Resource Name (ARN)

# Arguments
- `tag_key_list`: A list of keys to identify which key-value tags to remove from a resource.
- `resource_arn`: An ARN that uniquely identifies a resource. The format of the ARN depends
  on the type of the tagged resource.

"""
function untag_resource(
    TagKeyList, resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "POST",
        "/untag/$(resourceArn)",
        Dict{String,Any}("TagKeyList" => TagKeyList);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    TagKeyList,
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "POST",
        "/untag/$(resourceArn)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TagKeyList" => TagKeyList), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_backup_plan(backup_plan, backup_plan_id)
    update_backup_plan(backup_plan, backup_plan_id, params::Dict{String,<:Any})

Updates an existing backup plan identified by its backupPlanId with the input document in
JSON format. The new version is uniquely identified by a VersionId.

# Arguments
- `backup_plan`: Specifies the body of a backup plan. Includes a BackupPlanName and one or
  more sets of Rules.
- `backup_plan_id`: Uniquely identifies a backup plan.

"""
function update_backup_plan(
    BackupPlan, backupPlanId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "POST",
        "/backup/plans/$(backupPlanId)",
        Dict{String,Any}("BackupPlan" => BackupPlan);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_backup_plan(
    BackupPlan,
    backupPlanId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "POST",
        "/backup/plans/$(backupPlanId)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("BackupPlan" => BackupPlan), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_framework(framework_name)
    update_framework(framework_name, params::Dict{String,<:Any})

Updates an existing framework identified by its FrameworkName with the input document in
JSON format.

# Arguments
- `framework_name`: The unique name of a framework. This name is between 1 and 256
  characters, starting with a letter, and consisting of letters (a-z, A-Z), numbers (0-9),
  and underscores (_).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FrameworkControls"`: A list of the controls that make up the framework. Each control in
  the list has a name, input parameters, and scope.
- `"FrameworkDescription"`: An optional description of the framework with a maximum 1,024
  characters.
- `"IdempotencyToken"`: A customer-chosen string that you can use to distinguish between
  otherwise identical calls to UpdateFrameworkInput. Retrying a successful request with the
  same idempotency token results in a success message with no action taken.
"""
function update_framework(frameworkName; aws_config::AbstractAWSConfig=current_aws_config())
    return backup(
        "PUT",
        "/audit/frameworks/$(frameworkName)",
        Dict{String,Any}("IdempotencyToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_framework(
    frameworkName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "PUT",
        "/audit/frameworks/$(frameworkName)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("IdempotencyToken" => string(uuid4())), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_global_settings()
    update_global_settings(params::Dict{String,<:Any})

Updates whether the Amazon Web Services account is opted in to cross-account backup.
Returns an error if the account is not an Organizations management account. Use the
DescribeGlobalSettings API to determine the current settings.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"GlobalSettings"`: A value for isCrossAccountBackupEnabled and a Region. Example:
  update-global-settings --global-settings isCrossAccountBackupEnabled=false --region
  us-west-2.
"""
function update_global_settings(; aws_config::AbstractAWSConfig=current_aws_config())
    return backup(
        "PUT", "/global-settings"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function update_global_settings(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "PUT",
        "/global-settings",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_recovery_point_lifecycle(backup_vault_name, recovery_point_arn)
    update_recovery_point_lifecycle(backup_vault_name, recovery_point_arn, params::Dict{String,<:Any})

Sets the transition lifecycle of a recovery point. The lifecycle defines when a protected
resource is transitioned to cold storage and when it expires. Backup transitions and
expires backups automatically according to the lifecycle that you define. Backups
transitioned to cold storage must be stored in cold storage for a minimum of 90 days.
Therefore, the “retention” setting must be 90 days greater than the “transition to
cold after days” setting. The “transition to cold after days” setting cannot be
changed after a backup has been transitioned to cold. Resource types that are able to be
transitioned to cold storage are listed in the \"Lifecycle to cold storage\" section of the
 Feature availability by resource table. Backup ignores this expression for other resource
types. This operation does not support continuous backups.

# Arguments
- `backup_vault_name`: The name of a logical container where backups are stored. Backup
  vaults are identified by names that are unique to the account used to create them and the
  Amazon Web Services Region where they are created. They consist of lowercase letters,
  numbers, and hyphens.
- `recovery_point_arn`: An Amazon Resource Name (ARN) that uniquely identifies a recovery
  point; for example,
  arn:aws:backup:us-east-1:123456789012:recovery-point:1EB3B5E7-9EB0-435A-A80B-108B488B0D45.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Lifecycle"`: The lifecycle defines when a protected resource is transitioned to cold
  storage and when it expires. Backup transitions and expires backups automatically according
  to the lifecycle that you define.  Backups transitioned to cold storage must be stored in
  cold storage for a minimum of 90 days. Therefore, the “retention” setting must be 90
  days greater than the “transition to cold after days” setting. The “transition to
  cold after days” setting cannot be changed after a backup has been transitioned to cold.
"""
function update_recovery_point_lifecycle(
    backupVaultName, recoveryPointArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "POST",
        "/backup-vaults/$(backupVaultName)/recovery-points/$(recoveryPointArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_recovery_point_lifecycle(
    backupVaultName,
    recoveryPointArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "POST",
        "/backup-vaults/$(backupVaultName)/recovery-points/$(recoveryPointArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_region_settings()
    update_region_settings(params::Dict{String,<:Any})

Updates the current service opt-in settings for the Region. Use the DescribeRegionSettings
API to determine the resource types that are supported.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ResourceTypeManagementPreference"`: Enables or disables full Backup management of
  backups for a resource type. To enable full Backup management for DynamoDB along with
  Backup's advanced DynamoDB backup features, follow the procedure to  enable advanced
  DynamoDB backup programmatically.
- `"ResourceTypeOptInPreference"`: Updates the list of services along with the opt-in
  preferences for the Region. If resource assignments are only based on tags, then service
  opt-in settings are applied. If a resource type is explicitly assigned to a backup plan,
  such as Amazon S3, Amazon EC2, or Amazon RDS, it will be included in the backup even if the
  opt-in is not enabled for that particular service. If both a resource type and tags are
  specified in a resource assignment, the resource type specified in the backup plan takes
  priority over the tag condition. Service opt-in settings are disregarded in this situation.
"""
function update_region_settings(; aws_config::AbstractAWSConfig=current_aws_config())
    return backup(
        "PUT", "/account-settings"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function update_region_settings(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "PUT",
        "/account-settings",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_report_plan(report_plan_name)
    update_report_plan(report_plan_name, params::Dict{String,<:Any})

Updates an existing report plan identified by its ReportPlanName with the input document in
JSON format.

# Arguments
- `report_plan_name`: The unique name of the report plan. This name is between 1 and 256
  characters, starting with a letter, and consisting of letters (a-z, A-Z), numbers (0-9),
  and underscores (_).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"IdempotencyToken"`: A customer-chosen string that you can use to distinguish between
  otherwise identical calls to UpdateReportPlanInput. Retrying a successful request with the
  same idempotency token results in a success message with no action taken.
- `"ReportDeliveryChannel"`: A structure that contains information about where to deliver
  your reports, specifically your Amazon S3 bucket name, S3 key prefix, and the formats of
  your reports.
- `"ReportPlanDescription"`: An optional description of the report plan with a maximum
  1,024 characters.
- `"ReportSetting"`: Identifies the report template for the report. Reports are built using
  a report template. The report templates are:  RESOURCE_COMPLIANCE_REPORT |
  CONTROL_COMPLIANCE_REPORT | BACKUP_JOB_REPORT | COPY_JOB_REPORT | RESTORE_JOB_REPORT  If
  the report template is RESOURCE_COMPLIANCE_REPORT or CONTROL_COMPLIANCE_REPORT, this API
  resource also describes the report coverage by Amazon Web Services Regions and frameworks.
"""
function update_report_plan(
    reportPlanName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup(
        "PUT",
        "/audit/report-plans/$(reportPlanName)",
        Dict{String,Any}("IdempotencyToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_report_plan(
    reportPlanName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "PUT",
        "/audit/report-plans/$(reportPlanName)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("IdempotencyToken" => string(uuid4())), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_restore_testing_plan(restore_testing_plan, restore_testing_plan_name)
    update_restore_testing_plan(restore_testing_plan, restore_testing_plan_name, params::Dict{String,<:Any})

This request will send changes to your specified restore testing plan.
RestoreTestingPlanName cannot be updated after it is created.  RecoveryPointSelection can
contain:    Algorithm     ExcludeVaults     IncludeVaults     RecoveryPointTypes
SelectionWindowDays

# Arguments
- `restore_testing_plan`: Specifies the body of a restore testing plan.
- `restore_testing_plan_name`: This is the restore testing plan name you wish to update.

"""
function update_restore_testing_plan(
    RestoreTestingPlan,
    RestoreTestingPlanName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "PUT",
        "/restore-testing/plans/$(RestoreTestingPlanName)",
        Dict{String,Any}("RestoreTestingPlan" => RestoreTestingPlan);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_restore_testing_plan(
    RestoreTestingPlan,
    RestoreTestingPlanName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "PUT",
        "/restore-testing/plans/$(RestoreTestingPlanName)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("RestoreTestingPlan" => RestoreTestingPlan), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_restore_testing_selection(restore_testing_plan_name, restore_testing_selection, restore_testing_selection_name)
    update_restore_testing_selection(restore_testing_plan_name, restore_testing_selection, restore_testing_selection_name, params::Dict{String,<:Any})

Most elements except the RestoreTestingSelectionName can be updated with this request.
RestoreTestingSelection can use either protected resource ARNs or conditions, but not both.
That is, if your selection has ProtectedResourceArns, requesting an update with the
parameter ProtectedResourceConditions will be unsuccessful.

# Arguments
- `restore_testing_plan_name`: The restore testing plan name is required to update the
  indicated testing plan.
- `restore_testing_selection`: To update your restore testing selection, you can use either
  protected resource ARNs or conditions, but not both. That is, if your selection has
  ProtectedResourceArns, requesting an update with the parameter ProtectedResourceConditions
  will be unsuccessful.
- `restore_testing_selection_name`: This is the required restore testing selection name of
  the restore testing selection you wish to update.

"""
function update_restore_testing_selection(
    RestoreTestingPlanName,
    RestoreTestingSelection,
    RestoreTestingSelectionName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "PUT",
        "/restore-testing/plans/$(RestoreTestingPlanName)/selections/$(RestoreTestingSelectionName)",
        Dict{String,Any}("RestoreTestingSelection" => RestoreTestingSelection);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_restore_testing_selection(
    RestoreTestingPlanName,
    RestoreTestingSelection,
    RestoreTestingSelectionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup(
        "PUT",
        "/restore-testing/plans/$(RestoreTestingPlanName)/selections/$(RestoreTestingSelectionName)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("RestoreTestingSelection" => RestoreTestingSelection),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: mwaa
using AWS.Compat
using AWS.UUIDs

"""
    create_cli_token(name)
    create_cli_token(name, params::Dict{String,<:Any})

Creates a CLI token for the Airflow CLI. To learn more, see Creating an Apache Airflow CLI
token.

# Arguments
- `name`: The name of the Amazon MWAA environment. For example, MyMWAAEnvironment.

"""
function create_cli_token(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return mwaa(
        "POST", "/clitoken/$(Name)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function create_cli_token(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mwaa(
        "POST",
        "/clitoken/$(Name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_environment(dag_s3_path, execution_role_arn, name, network_configuration, source_bucket_arn)
    create_environment(dag_s3_path, execution_role_arn, name, network_configuration, source_bucket_arn, params::Dict{String,<:Any})

Creates an Amazon Managed Workflows for Apache Airflow (MWAA) environment.

# Arguments
- `dag_s3_path`: The relative path to the DAGs folder on your Amazon S3 bucket. For
  example, dags. For more information, see Adding or updating DAGs.
- `execution_role_arn`: The Amazon Resource Name (ARN) of the execution role for your
  environment. An execution role is an Amazon Web Services Identity and Access Management
  (IAM) role that grants MWAA permission to access Amazon Web Services services and resources
  used by your environment. For example, arn:aws:iam::123456789:role/my-execution-role. For
  more information, see Amazon MWAA Execution role.
- `name`: The name of the Amazon MWAA environment. For example, MyMWAAEnvironment.
- `network_configuration`: The VPC networking components used to secure and enable network
  traffic between the Amazon Web Services resources for your environment. For more
  information, see About networking on Amazon MWAA.
- `source_bucket_arn`: The Amazon Resource Name (ARN) of the Amazon S3 bucket where your
  DAG code and supporting files are stored. For example,
  arn:aws:s3:::my-airflow-bucket-unique-name. For more information, see Create an Amazon S3
  bucket for Amazon MWAA.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AirflowConfigurationOptions"`: A list of key-value pairs containing the Apache Airflow
  configuration options you want to attach to your environment. For more information, see
  Apache Airflow configuration options.
- `"AirflowVersion"`: The Apache Airflow version for your environment. If no value is
  specified, it defaults to the latest version. For more information, see Apache Airflow
  versions on Amazon Managed Workflows for Apache Airflow (MWAA). Valid values: 1.10.12,
  2.0.2, 2.2.2, 2.4.3, 2.5.1, 2.6.3, 2.7.2 2.8.1
- `"EndpointManagement"`: Defines whether the VPC endpoints configured for the environment
  are created, and managed, by the customer or by Amazon MWAA. If set to SERVICE, Amazon MWAA
  will create and manage the required VPC endpoints in your VPC. If set to CUSTOMER, you must
  create, and manage, the VPC endpoints for your VPC. If you choose to create an environment
  in a shared VPC, you must set this value to CUSTOMER. In a shared VPC deployment, the
  environment will remain in PENDING status until you create the VPC endpoints. If you do not
  take action to create the endpoints within 72 hours, the status will change to
  CREATE_FAILED. You can delete the failed environment and create a new one.
- `"EnvironmentClass"`: The environment class type. Valid values: mw1.small, mw1.medium,
  mw1.large, mw1.xlarge, and mw1.2xlarge. For more information, see Amazon MWAA environment
  class.
- `"KmsKey"`: The Amazon Web Services Key Management Service (KMS) key to encrypt the data
  in your environment. You can use an Amazon Web Services owned CMK, or a Customer managed
  CMK (advanced). For more information, see Create an Amazon MWAA environment.
- `"LoggingConfiguration"`: Defines the Apache Airflow logs to send to CloudWatch Logs.
- `"MaxWebservers"`:  The maximum number of web servers that you want to run in your
  environment. Amazon MWAA scales the number of Apache Airflow web servers up to the number
  you specify for MaxWebservers when you interact with your Apache Airflow environment using
  Apache Airflow REST API, or the Apache Airflow CLI. For example, in scenarios where your
  workload requires network calls to the Apache Airflow REST API with a high
  transaction-per-second (TPS) rate, Amazon MWAA will increase the number of web servers up
  to the number set in MaxWebserers. As TPS rates decrease Amazon MWAA disposes of the
  additional web servers, and scales down to the number set in MinxWebserers.  Valid values:
  Accepts between 2 and 5. Defaults to 2.
- `"MaxWorkers"`: The maximum number of workers that you want to run in your environment.
  MWAA scales the number of Apache Airflow workers up to the number you specify in the
  MaxWorkers field. For example, 20. When there are no more tasks running, and no more in the
  queue, MWAA disposes of the extra workers leaving the one worker that is included with your
  environment, or the number you specify in MinWorkers.
- `"MinWebservers"`:  The minimum number of web servers that you want to run in your
  environment. Amazon MWAA scales the number of Apache Airflow web servers up to the number
  you specify for MaxWebservers when you interact with your Apache Airflow environment using
  Apache Airflow REST API, or the Apache Airflow CLI. As the transaction-per-second rate, and
  the network load, decrease, Amazon MWAA disposes of the additional web servers, and scales
  down to the number set in MinxWebserers.  Valid values: Accepts between 2 and 5. Defaults
  to 2.
- `"MinWorkers"`: The minimum number of workers that you want to run in your environment.
  MWAA scales the number of Apache Airflow workers up to the number you specify in the
  MaxWorkers field. When there are no more tasks running, and no more in the queue, MWAA
  disposes of the extra workers leaving the worker count you specify in the MinWorkers field.
  For example, 2.
- `"PluginsS3ObjectVersion"`: The version of the plugins.zip file on your Amazon S3 bucket.
  You must specify a version each time a plugins.zip file is updated. For more information,
  see How S3 Versioning works.
- `"PluginsS3Path"`: The relative path to the plugins.zip file on your Amazon S3 bucket.
  For example, plugins.zip. If specified, then the plugins.zip version is required. For more
  information, see Installing custom plugins.
- `"RequirementsS3ObjectVersion"`: The version of the requirements.txt file on your Amazon
  S3 bucket. You must specify a version each time a requirements.txt file is updated. For
  more information, see How S3 Versioning works.
- `"RequirementsS3Path"`: The relative path to the requirements.txt file on your Amazon S3
  bucket. For example, requirements.txt. If specified, then a version is required. For more
  information, see Installing Python dependencies.
- `"Schedulers"`: The number of Apache Airflow schedulers to run in your environment. Valid
  values:   v2 - Accepts between 2 to 5. Defaults to 2.   v1 - Accepts 1.
- `"StartupScriptS3ObjectVersion"`: The version of the startup shell script in your Amazon
  S3 bucket. You must specify the version ID that Amazon S3 assigns to the file every time
  you update the script.   Version IDs are Unicode, UTF-8 encoded, URL-ready, opaque strings
  that are no more than 1,024 bytes long. The following is an example:
  3sL4kqtJlcpXroDTDmJ+rmSpXd3dIbrHY+MTRCxf3vjVBH40Nr8X8gdRQBpUMLUo   For more information,
  see Using a startup script.
- `"StartupScriptS3Path"`: The relative path to the startup shell script in your Amazon S3
  bucket. For example, s3://mwaa-environment/startup.sh.  Amazon MWAA runs the script as your
  environment starts, and before running the Apache Airflow process. You can use this script
  to install dependencies, modify Apache Airflow configuration options, and set environment
  variables. For more information, see Using a startup script.
- `"Tags"`: The key-value tag pairs you want to associate to your environment. For example,
  \"Environment\": \"Staging\". For more information, see Tagging Amazon Web Services
  resources.
- `"WebserverAccessMode"`: Defines the access mode for the Apache Airflow web server. For
  more information, see Apache Airflow access modes.
- `"WeeklyMaintenanceWindowStart"`: The day and time of the week in Coordinated Universal
  Time (UTC) 24-hour standard time to start weekly maintenance updates of your environment in
  the following format: DAY:HH:MM. For example: TUE:03:30. You can specify a start time in 30
  minute increments only.
"""
function create_environment(
    DagS3Path,
    ExecutionRoleArn,
    Name,
    NetworkConfiguration,
    SourceBucketArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mwaa(
        "PUT",
        "/environments/$(Name)",
        Dict{String,Any}(
            "DagS3Path" => DagS3Path,
            "ExecutionRoleArn" => ExecutionRoleArn,
            "NetworkConfiguration" => NetworkConfiguration,
            "SourceBucketArn" => SourceBucketArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_environment(
    DagS3Path,
    ExecutionRoleArn,
    Name,
    NetworkConfiguration,
    SourceBucketArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mwaa(
        "PUT",
        "/environments/$(Name)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DagS3Path" => DagS3Path,
                    "ExecutionRoleArn" => ExecutionRoleArn,
                    "NetworkConfiguration" => NetworkConfiguration,
                    "SourceBucketArn" => SourceBucketArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_web_login_token(name)
    create_web_login_token(name, params::Dict{String,<:Any})

Creates a web login token for the Airflow Web UI. To learn more, see Creating an Apache
Airflow web login token.

# Arguments
- `name`: The name of the Amazon MWAA environment. For example, MyMWAAEnvironment.

"""
function create_web_login_token(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return mwaa(
        "POST", "/webtoken/$(Name)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function create_web_login_token(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mwaa(
        "POST",
        "/webtoken/$(Name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_environment(name)
    delete_environment(name, params::Dict{String,<:Any})

Deletes an Amazon Managed Workflows for Apache Airflow (MWAA) environment.

# Arguments
- `name`: The name of the Amazon MWAA environment. For example, MyMWAAEnvironment.

"""
function delete_environment(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return mwaa(
        "DELETE",
        "/environments/$(Name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_environment(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mwaa(
        "DELETE",
        "/environments/$(Name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_environment(name)
    get_environment(name, params::Dict{String,<:Any})

Describes an Amazon Managed Workflows for Apache Airflow (MWAA) environment.

# Arguments
- `name`: The name of the Amazon MWAA environment. For example, MyMWAAEnvironment.

"""
function get_environment(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return mwaa(
        "GET",
        "/environments/$(Name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_environment(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mwaa(
        "GET",
        "/environments/$(Name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_environments()
    list_environments(params::Dict{String,<:Any})

Lists the Amazon Managed Workflows for Apache Airflow (MWAA) environments.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to retrieve per page. For example, 5
  environments per page.
- `"NextToken"`: Retrieves the next page of the results.
"""
function list_environments(; aws_config::AbstractAWSConfig=current_aws_config())
    return mwaa(
        "GET", "/environments"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_environments(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mwaa(
        "GET",
        "/environments",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists the key-value tag pairs associated to the Amazon Managed Workflows for Apache Airflow
(MWAA) environment. For example, \"Environment\": \"Staging\".

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the Amazon MWAA environment. For
  example, arn:aws:airflow:us-east-1:123456789012:environment/MyMWAAEnvironment.

"""
function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mwaa(
        "GET",
        "/tags/$(ResourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mwaa(
        "GET",
        "/tags/$(ResourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    publish_metrics(environment_name, metric_data)
    publish_metrics(environment_name, metric_data, params::Dict{String,<:Any})

 Internal only. Publishes environment health metrics to Amazon CloudWatch.

# Arguments
- `environment_name`:  Internal only. The name of the environment.
- `metric_data`:  Internal only. Publishes metrics to Amazon CloudWatch. To learn more
  about the metrics published to Amazon CloudWatch, see Amazon MWAA performance metrics in
  Amazon CloudWatch.

"""
function publish_metrics(
    EnvironmentName, MetricData; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mwaa(
        "POST",
        "/metrics/environments/$(EnvironmentName)",
        Dict{String,Any}("MetricData" => MetricData);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function publish_metrics(
    EnvironmentName,
    MetricData,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mwaa(
        "POST",
        "/metrics/environments/$(EnvironmentName)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("MetricData" => MetricData), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Associates key-value tag pairs to your Amazon Managed Workflows for Apache Airflow (MWAA)
environment.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the Amazon MWAA environment. For
  example, arn:aws:airflow:us-east-1:123456789012:environment/MyMWAAEnvironment.
- `tags`: The key-value tag pairs you want to associate to your environment. For example,
  \"Environment\": \"Staging\". For more information, see Tagging Amazon Web Services
  resources.

"""
function tag_resource(ResourceArn, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return mwaa(
        "POST",
        "/tags/$(ResourceArn)",
        Dict{String,Any}("Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceArn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mwaa(
        "POST",
        "/tags/$(ResourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Tags" => Tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes key-value tag pairs associated to your Amazon Managed Workflows for Apache Airflow
(MWAA) environment. For example, \"Environment\": \"Staging\".

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the Amazon MWAA environment. For
  example, arn:aws:airflow:us-east-1:123456789012:environment/MyMWAAEnvironment.
- `tag_keys`: The key-value tag pair you want to remove. For example, \"Environment\":
  \"Staging\".

"""
function untag_resource(
    ResourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mwaa(
        "DELETE",
        "/tags/$(ResourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mwaa(
        "DELETE",
        "/tags/$(ResourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_environment(name)
    update_environment(name, params::Dict{String,<:Any})

Updates an Amazon Managed Workflows for Apache Airflow (MWAA) environment.

# Arguments
- `name`: The name of your Amazon MWAA environment. For example, MyMWAAEnvironment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AirflowConfigurationOptions"`: A list of key-value pairs containing the Apache Airflow
  configuration options you want to attach to your environment. For more information, see
  Apache Airflow configuration options.
- `"AirflowVersion"`: The Apache Airflow version for your environment. To upgrade your
  environment, specify a newer version of Apache Airflow supported by Amazon MWAA. Before you
  upgrade an environment, make sure your requirements, DAGs, plugins, and other resources
  used in your workflows are compatible with the new Apache Airflow version. For more
  information about updating your resources, see Upgrading an Amazon MWAA environment. Valid
  values: 1.10.12, 2.0.2, 2.2.2, 2.4.3, 2.5.1, 2.6.3, 2.7.2, 2.8.1.
- `"DagS3Path"`: The relative path to the DAGs folder on your Amazon S3 bucket. For
  example, dags. For more information, see Adding or updating DAGs.
- `"EnvironmentClass"`: The environment class type. Valid values: mw1.small, mw1.medium,
  mw1.large, mw1.xlarge, and mw1.2xlarge. For more information, see Amazon MWAA environment
  class.
- `"ExecutionRoleArn"`: The Amazon Resource Name (ARN) of the execution role in IAM that
  allows MWAA to access Amazon Web Services resources in your environment. For example,
  arn:aws:iam::123456789:role/my-execution-role. For more information, see Amazon MWAA
  Execution role.
- `"LoggingConfiguration"`: The Apache Airflow log types to send to CloudWatch Logs.
- `"MaxWebservers"`:  The maximum number of web servers that you want to run in your
  environment. Amazon MWAA scales the number of Apache Airflow web servers up to the number
  you specify for MaxWebservers when you interact with your Apache Airflow environment using
  Apache Airflow REST API, or the Apache Airflow CLI. For example, in scenarios where your
  workload requires network calls to the Apache Airflow REST API with a high
  transaction-per-second (TPS) rate, Amazon MWAA will increase the number of web servers up
  to the number set in MaxWebserers. As TPS rates decrease Amazon MWAA disposes of the
  additional web servers, and scales down to the number set in MinxWebserers.  Valid values:
  Accepts between 2 and 5. Defaults to 2.
- `"MaxWorkers"`: The maximum number of workers that you want to run in your environment.
  MWAA scales the number of Apache Airflow workers up to the number you specify in the
  MaxWorkers field. For example, 20. When there are no more tasks running, and no more in the
  queue, MWAA disposes of the extra workers leaving the one worker that is included with your
  environment, or the number you specify in MinWorkers.
- `"MinWebservers"`:  The minimum number of web servers that you want to run in your
  environment. Amazon MWAA scales the number of Apache Airflow web servers up to the number
  you specify for MaxWebservers when you interact with your Apache Airflow environment using
  Apache Airflow REST API, or the Apache Airflow CLI. As the transaction-per-second rate, and
  the network load, decrease, Amazon MWAA disposes of the additional web servers, and scales
  down to the number set in MinxWebserers.  Valid values: Accepts between 2 and 5. Defaults
  to 2.
- `"MinWorkers"`: The minimum number of workers that you want to run in your environment.
  MWAA scales the number of Apache Airflow workers up to the number you specify in the
  MaxWorkers field. When there are no more tasks running, and no more in the queue, MWAA
  disposes of the extra workers leaving the worker count you specify in the MinWorkers field.
  For example, 2.
- `"NetworkConfiguration"`: The VPC networking components used to secure and enable network
  traffic between the Amazon Web Services resources for your environment. For more
  information, see About networking on Amazon MWAA.
- `"PluginsS3ObjectVersion"`: The version of the plugins.zip file on your Amazon S3 bucket.
  You must specify a version each time a plugins.zip file is updated. For more information,
  see How S3 Versioning works.
- `"PluginsS3Path"`: The relative path to the plugins.zip file on your Amazon S3 bucket.
  For example, plugins.zip. If specified, then the plugins.zip version is required. For more
  information, see Installing custom plugins.
- `"RequirementsS3ObjectVersion"`: The version of the requirements.txt file on your Amazon
  S3 bucket. You must specify a version each time a requirements.txt file is updated. For
  more information, see How S3 Versioning works.
- `"RequirementsS3Path"`: The relative path to the requirements.txt file on your Amazon S3
  bucket. For example, requirements.txt. If specified, then a file version is required. For
  more information, see Installing Python dependencies.
- `"Schedulers"`: The number of Apache Airflow schedulers to run in your Amazon MWAA
  environment.
- `"SourceBucketArn"`: The Amazon Resource Name (ARN) of the Amazon S3 bucket where your
  DAG code and supporting files are stored. For example,
  arn:aws:s3:::my-airflow-bucket-unique-name. For more information, see Create an Amazon S3
  bucket for Amazon MWAA.
- `"StartupScriptS3ObjectVersion"`:  The version of the startup shell script in your Amazon
  S3 bucket. You must specify the version ID that Amazon S3 assigns to the file every time
  you update the script.   Version IDs are Unicode, UTF-8 encoded, URL-ready, opaque strings
  that are no more than 1,024 bytes long. The following is an example:
  3sL4kqtJlcpXroDTDmJ+rmSpXd3dIbrHY+MTRCxf3vjVBH40Nr8X8gdRQBpUMLUo   For more information,
  see Using a startup script.
- `"StartupScriptS3Path"`: The relative path to the startup shell script in your Amazon S3
  bucket. For example, s3://mwaa-environment/startup.sh.  Amazon MWAA runs the script as your
  environment starts, and before running the Apache Airflow process. You can use this script
  to install dependencies, modify Apache Airflow configuration options, and set environment
  variables. For more information, see Using a startup script.
- `"WebserverAccessMode"`: The Apache Airflow Web server access mode. For more information,
  see Apache Airflow access modes.
- `"WeeklyMaintenanceWindowStart"`: The day and time of the week in Coordinated Universal
  Time (UTC) 24-hour standard time to start weekly maintenance updates of your environment in
  the following format: DAY:HH:MM. For example: TUE:03:30. You can specify a start time in 30
  minute increments only.
"""
function update_environment(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return mwaa(
        "PATCH",
        "/environments/$(Name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_environment(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mwaa(
        "PATCH",
        "/environments/$(Name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: chime_sdk_media_pipelines
using AWS.Compat
using AWS.UUIDs

"""
    create_media_capture_pipeline(sink_arn, sink_type, source_arn, source_type)
    create_media_capture_pipeline(sink_arn, sink_type, source_arn, source_type, params::Dict{String,<:Any})

Creates a media pipeline.

# Arguments
- `sink_arn`: The ARN of the sink type.
- `sink_type`: Destination type to which the media artifacts are saved. You must use an S3
  bucket.
- `source_arn`: ARN of the source from which the media artifacts are captured.
- `source_type`: Source type from which the media artifacts are captured. A Chime SDK
  Meeting is the only supported source.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ChimeSdkMeetingConfiguration"`: The configuration for a specified media pipeline.
  SourceType must be ChimeSdkMeeting.
- `"ClientRequestToken"`: The unique identifier for the client request. The token makes the
  API request idempotent. Use a unique token for each media pipeline request.
- `"Tags"`: The tag key-value pairs.
"""
function create_media_capture_pipeline(
    SinkArn,
    SinkType,
    SourceArn,
    SourceType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_media_pipelines(
        "POST",
        "/sdk-media-capture-pipelines",
        Dict{String,Any}(
            "SinkArn" => SinkArn,
            "SinkType" => SinkType,
            "SourceArn" => SourceArn,
            "SourceType" => SourceType,
            "ClientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_media_capture_pipeline(
    SinkArn,
    SinkType,
    SourceArn,
    SourceType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_media_pipelines(
        "POST",
        "/sdk-media-capture-pipelines",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "SinkArn" => SinkArn,
                    "SinkType" => SinkType,
                    "SourceArn" => SourceArn,
                    "SourceType" => SourceType,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_media_concatenation_pipeline(sinks, sources)
    create_media_concatenation_pipeline(sinks, sources, params::Dict{String,<:Any})

Creates a media concatenation pipeline.

# Arguments
- `sinks`: An object that specifies the data sinks for the media concatenation pipeline.
- `sources`: An object that specifies the sources for the media concatenation pipeline.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: The unique identifier for the client request. The token makes the
  API request idempotent. Use a unique token for each media concatenation pipeline request.
- `"Tags"`: The tags associated with the media concatenation pipeline.
"""
function create_media_concatenation_pipeline(
    Sinks, Sources; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_media_pipelines(
        "POST",
        "/sdk-media-concatenation-pipelines",
        Dict{String,Any}(
            "Sinks" => Sinks, "Sources" => Sources, "ClientRequestToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_media_concatenation_pipeline(
    Sinks,
    Sources,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_media_pipelines(
        "POST",
        "/sdk-media-concatenation-pipelines",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Sinks" => Sinks,
                    "Sources" => Sources,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_media_insights_pipeline(media_insights_pipeline_configuration_arn)
    create_media_insights_pipeline(media_insights_pipeline_configuration_arn, params::Dict{String,<:Any})

Creates a media insights pipeline.

# Arguments
- `media_insights_pipeline_configuration_arn`: The ARN of the pipeline's configuration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: The unique identifier for the media insights pipeline request.
- `"KinesisVideoStreamRecordingSourceRuntimeConfiguration"`: The runtime configuration for
  the Kinesis video recording stream source.
- `"KinesisVideoStreamSourceRuntimeConfiguration"`: The runtime configuration for the
  Kinesis video stream source of the media insights pipeline.
- `"MediaInsightsRuntimeMetadata"`: The runtime metadata for the media insights pipeline.
  Consists of a key-value map of strings.
- `"S3RecordingSinkRuntimeConfiguration"`: The runtime configuration for the S3 recording
  sink. If specified, the settings in this structure override any settings in
  S3RecordingSinkConfiguration.
- `"Tags"`: The tags assigned to the media insights pipeline.
"""
function create_media_insights_pipeline(
    MediaInsightsPipelineConfigurationArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_media_pipelines(
        "POST",
        "/media-insights-pipelines",
        Dict{String,Any}(
            "MediaInsightsPipelineConfigurationArn" =>
                MediaInsightsPipelineConfigurationArn,
            "ClientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_media_insights_pipeline(
    MediaInsightsPipelineConfigurationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_media_pipelines(
        "POST",
        "/media-insights-pipelines",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "MediaInsightsPipelineConfigurationArn" =>
                        MediaInsightsPipelineConfigurationArn,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_media_insights_pipeline_configuration(elements, media_insights_pipeline_configuration_name, resource_access_role_arn)
    create_media_insights_pipeline_configuration(elements, media_insights_pipeline_configuration_name, resource_access_role_arn, params::Dict{String,<:Any})

A structure that contains the static configurations for a media insights pipeline.

# Arguments
- `elements`: The elements in the request, such as a processor for Amazon Transcribe or a
  sink for a Kinesis Data Stream.
- `media_insights_pipeline_configuration_name`: The name of the media insights pipeline
  configuration.
- `resource_access_role_arn`: The ARN of the role used by the service to access Amazon Web
  Services resources, including Transcribe and Transcribe Call Analytics, on the caller’s
  behalf.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: The unique identifier for the media insights pipeline
  configuration request.
- `"RealTimeAlertConfiguration"`: The configuration settings for the real-time alerts in a
  media insights pipeline configuration.
- `"Tags"`: The tags assigned to the media insights pipeline configuration.
"""
function create_media_insights_pipeline_configuration(
    Elements,
    MediaInsightsPipelineConfigurationName,
    ResourceAccessRoleArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_media_pipelines(
        "POST",
        "/media-insights-pipeline-configurations",
        Dict{String,Any}(
            "Elements" => Elements,
            "MediaInsightsPipelineConfigurationName" =>
                MediaInsightsPipelineConfigurationName,
            "ResourceAccessRoleArn" => ResourceAccessRoleArn,
            "ClientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_media_insights_pipeline_configuration(
    Elements,
    MediaInsightsPipelineConfigurationName,
    ResourceAccessRoleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_media_pipelines(
        "POST",
        "/media-insights-pipeline-configurations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Elements" => Elements,
                    "MediaInsightsPipelineConfigurationName" =>
                        MediaInsightsPipelineConfigurationName,
                    "ResourceAccessRoleArn" => ResourceAccessRoleArn,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_media_live_connector_pipeline(sinks, sources)
    create_media_live_connector_pipeline(sinks, sources, params::Dict{String,<:Any})

Creates a media live connector pipeline in an Amazon Chime SDK meeting.

# Arguments
- `sinks`: The media live connector pipeline's data sinks.
- `sources`: The media live connector pipeline's data sources.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: The token assigned to the client making the request.
- `"Tags"`: The tags associated with the media live connector pipeline.
"""
function create_media_live_connector_pipeline(
    Sinks, Sources; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_media_pipelines(
        "POST",
        "/sdk-media-live-connector-pipelines",
        Dict{String,Any}(
            "Sinks" => Sinks, "Sources" => Sources, "ClientRequestToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_media_live_connector_pipeline(
    Sinks,
    Sources,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_media_pipelines(
        "POST",
        "/sdk-media-live-connector-pipelines",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Sinks" => Sinks,
                    "Sources" => Sources,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_media_pipeline_kinesis_video_stream_pool(pool_name, stream_configuration)
    create_media_pipeline_kinesis_video_stream_pool(pool_name, stream_configuration, params::Dict{String,<:Any})

Creates an Kinesis video stream pool for the media pipeline.

# Arguments
- `pool_name`: The name of the video stream pool.
- `stream_configuration`: The configuration settings for the video stream.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: The token assigned to the client making the request.
- `"Tags"`: The tags assigned to the video stream pool.
"""
function create_media_pipeline_kinesis_video_stream_pool(
    PoolName, StreamConfiguration; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_media_pipelines(
        "POST",
        "/media-pipeline-kinesis-video-stream-pools",
        Dict{String,Any}(
            "PoolName" => PoolName,
            "StreamConfiguration" => StreamConfiguration,
            "ClientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_media_pipeline_kinesis_video_stream_pool(
    PoolName,
    StreamConfiguration,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_media_pipelines(
        "POST",
        "/media-pipeline-kinesis-video-stream-pools",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "PoolName" => PoolName,
                    "StreamConfiguration" => StreamConfiguration,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_media_stream_pipeline(sinks, sources)
    create_media_stream_pipeline(sinks, sources, params::Dict{String,<:Any})

Creates a streaming media pipeline.

# Arguments
- `sinks`: The data sink for the media pipeline.
- `sources`: The data sources for the media pipeline.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: The token assigned to the client making the request.
- `"Tags"`: The tags assigned to the media pipeline.
"""
function create_media_stream_pipeline(
    Sinks, Sources; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_media_pipelines(
        "POST",
        "/sdk-media-stream-pipelines",
        Dict{String,Any}(
            "Sinks" => Sinks, "Sources" => Sources, "ClientRequestToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_media_stream_pipeline(
    Sinks,
    Sources,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_media_pipelines(
        "POST",
        "/sdk-media-stream-pipelines",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Sinks" => Sinks,
                    "Sources" => Sources,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_media_capture_pipeline(media_pipeline_id)
    delete_media_capture_pipeline(media_pipeline_id, params::Dict{String,<:Any})

Deletes the media pipeline.

# Arguments
- `media_pipeline_id`: The ID of the media pipeline being deleted.

"""
function delete_media_capture_pipeline(
    mediaPipelineId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_media_pipelines(
        "DELETE",
        "/sdk-media-capture-pipelines/$(mediaPipelineId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_media_capture_pipeline(
    mediaPipelineId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_media_pipelines(
        "DELETE",
        "/sdk-media-capture-pipelines/$(mediaPipelineId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_media_insights_pipeline_configuration(identifier)
    delete_media_insights_pipeline_configuration(identifier, params::Dict{String,<:Any})

Deletes the specified configuration settings.

# Arguments
- `identifier`: The unique identifier of the resource to be deleted. Valid values include
  the name and ARN of the media insights pipeline configuration.

"""
function delete_media_insights_pipeline_configuration(
    identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_media_pipelines(
        "DELETE",
        "/media-insights-pipeline-configurations/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_media_insights_pipeline_configuration(
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_media_pipelines(
        "DELETE",
        "/media-insights-pipeline-configurations/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_media_pipeline(media_pipeline_id)
    delete_media_pipeline(media_pipeline_id, params::Dict{String,<:Any})

Deletes the media pipeline.

# Arguments
- `media_pipeline_id`: The ID of the media pipeline to delete.

"""
function delete_media_pipeline(
    mediaPipelineId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_media_pipelines(
        "DELETE",
        "/sdk-media-pipelines/$(mediaPipelineId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_media_pipeline(
    mediaPipelineId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_media_pipelines(
        "DELETE",
        "/sdk-media-pipelines/$(mediaPipelineId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_media_pipeline_kinesis_video_stream_pool(identifier)
    delete_media_pipeline_kinesis_video_stream_pool(identifier, params::Dict{String,<:Any})

Deletes an Kinesis video stream pool.

# Arguments
- `identifier`: The ID of the pool being deleted.

"""
function delete_media_pipeline_kinesis_video_stream_pool(
    identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_media_pipelines(
        "DELETE",
        "/media-pipeline-kinesis-video-stream-pools/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_media_pipeline_kinesis_video_stream_pool(
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_media_pipelines(
        "DELETE",
        "/media-pipeline-kinesis-video-stream-pools/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_media_capture_pipeline(media_pipeline_id)
    get_media_capture_pipeline(media_pipeline_id, params::Dict{String,<:Any})

Gets an existing media pipeline.

# Arguments
- `media_pipeline_id`: The ID of the pipeline that you want to get.

"""
function get_media_capture_pipeline(
    mediaPipelineId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_media_pipelines(
        "GET",
        "/sdk-media-capture-pipelines/$(mediaPipelineId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_media_capture_pipeline(
    mediaPipelineId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_media_pipelines(
        "GET",
        "/sdk-media-capture-pipelines/$(mediaPipelineId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_media_insights_pipeline_configuration(identifier)
    get_media_insights_pipeline_configuration(identifier, params::Dict{String,<:Any})

Gets the configuration settings for a media insights pipeline.

# Arguments
- `identifier`: The unique identifier of the requested resource. Valid values include the
  name and ARN of the media insights pipeline configuration.

"""
function get_media_insights_pipeline_configuration(
    identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_media_pipelines(
        "GET",
        "/media-insights-pipeline-configurations/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_media_insights_pipeline_configuration(
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_media_pipelines(
        "GET",
        "/media-insights-pipeline-configurations/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_media_pipeline(media_pipeline_id)
    get_media_pipeline(media_pipeline_id, params::Dict{String,<:Any})

Gets an existing media pipeline.

# Arguments
- `media_pipeline_id`: The ID of the pipeline that you want to get.

"""
function get_media_pipeline(
    mediaPipelineId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_media_pipelines(
        "GET",
        "/sdk-media-pipelines/$(mediaPipelineId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_media_pipeline(
    mediaPipelineId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_media_pipelines(
        "GET",
        "/sdk-media-pipelines/$(mediaPipelineId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_media_pipeline_kinesis_video_stream_pool(identifier)
    get_media_pipeline_kinesis_video_stream_pool(identifier, params::Dict{String,<:Any})

Gets an Kinesis video stream pool.

# Arguments
- `identifier`: The ID of the video stream pool.

"""
function get_media_pipeline_kinesis_video_stream_pool(
    identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_media_pipelines(
        "GET",
        "/media-pipeline-kinesis-video-stream-pools/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_media_pipeline_kinesis_video_stream_pool(
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_media_pipelines(
        "GET",
        "/media-pipeline-kinesis-video-stream-pools/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_speaker_search_task(identifier, speaker_search_task_id)
    get_speaker_search_task(identifier, speaker_search_task_id, params::Dict{String,<:Any})

Retrieves the details of the specified speaker search task.

# Arguments
- `identifier`: The unique identifier of the resource to be updated. Valid values include
  the ID and ARN of the media insights pipeline.
- `speaker_search_task_id`: The ID of the speaker search task.

"""
function get_speaker_search_task(
    identifier, speakerSearchTaskId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_media_pipelines(
        "GET",
        "/media-insights-pipelines/$(identifier)/speaker-search-tasks/$(speakerSearchTaskId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_speaker_search_task(
    identifier,
    speakerSearchTaskId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_media_pipelines(
        "GET",
        "/media-insights-pipelines/$(identifier)/speaker-search-tasks/$(speakerSearchTaskId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_voice_tone_analysis_task(identifier, voice_tone_analysis_task_id)
    get_voice_tone_analysis_task(identifier, voice_tone_analysis_task_id, params::Dict{String,<:Any})

Retrieves the details of a voice tone analysis task.

# Arguments
- `identifier`: The unique identifier of the resource to be updated. Valid values include
  the ID and ARN of the media insights pipeline.
- `voice_tone_analysis_task_id`: The ID of the voice tone analysis task.

"""
function get_voice_tone_analysis_task(
    identifier, voiceToneAnalysisTaskId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_media_pipelines(
        "GET",
        "/media-insights-pipelines/$(identifier)/voice-tone-analysis-tasks/$(voiceToneAnalysisTaskId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_voice_tone_analysis_task(
    identifier,
    voiceToneAnalysisTaskId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_media_pipelines(
        "GET",
        "/media-insights-pipelines/$(identifier)/voice-tone-analysis-tasks/$(voiceToneAnalysisTaskId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_media_capture_pipelines()
    list_media_capture_pipelines(params::Dict{String,<:Any})

Returns a list of media pipelines.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"max-results"`: The maximum number of results to return in a single call. Valid Range: 1
  - 99.
- `"next-token"`: The token used to retrieve the next page of results.
"""
function list_media_capture_pipelines(; aws_config::AbstractAWSConfig=current_aws_config())
    return chime_sdk_media_pipelines(
        "GET",
        "/sdk-media-capture-pipelines";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_media_capture_pipelines(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_media_pipelines(
        "GET",
        "/sdk-media-capture-pipelines",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_media_insights_pipeline_configurations()
    list_media_insights_pipeline_configurations(params::Dict{String,<:Any})

Lists the available media insights pipeline configurations.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"max-results"`: The maximum number of results to return in a single call.
- `"next-token"`: The token used to return the next page of results.
"""
function list_media_insights_pipeline_configurations(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_media_pipelines(
        "GET",
        "/media-insights-pipeline-configurations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_media_insights_pipeline_configurations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_media_pipelines(
        "GET",
        "/media-insights-pipeline-configurations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_media_pipeline_kinesis_video_stream_pools()
    list_media_pipeline_kinesis_video_stream_pools(params::Dict{String,<:Any})

Lists the video stream pools in the media pipeline.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"max-results"`: The maximum number of results to return in a single call.
- `"next-token"`: The token used to return the next page of results.
"""
function list_media_pipeline_kinesis_video_stream_pools(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_media_pipelines(
        "GET",
        "/media-pipeline-kinesis-video-stream-pools";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_media_pipeline_kinesis_video_stream_pools(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_media_pipelines(
        "GET",
        "/media-pipeline-kinesis-video-stream-pools",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_media_pipelines()
    list_media_pipelines(params::Dict{String,<:Any})

Returns a list of media pipelines.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"max-results"`: The maximum number of results to return in a single call. Valid Range: 1
  - 99.
- `"next-token"`: The token used to retrieve the next page of results.
"""
function list_media_pipelines(; aws_config::AbstractAWSConfig=current_aws_config())
    return chime_sdk_media_pipelines(
        "GET",
        "/sdk-media-pipelines";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_media_pipelines(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_media_pipelines(
        "GET",
        "/sdk-media-pipelines",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(arn)
    list_tags_for_resource(arn, params::Dict{String,<:Any})

Lists the tags available for a media pipeline.

# Arguments
- `arn`: The ARN of the media pipeline associated with any tags. The ARN consists of the
  pipeline's region, resource ID, and pipeline ID.

"""
function list_tags_for_resource(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return chime_sdk_media_pipelines(
        "GET",
        "/tags",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_media_pipelines(
        "GET",
        "/tags",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_speaker_search_task(voice_profile_domain_arn, identifier)
    start_speaker_search_task(voice_profile_domain_arn, identifier, params::Dict{String,<:Any})

Starts a speaker search task.  Before starting any speaker search tasks, you must provide
all notices and obtain all consents from the speaker as required under applicable privacy
and biometrics laws, and as required under the AWS service terms for the Amazon Chime SDK.

# Arguments
- `voice_profile_domain_arn`: The ARN of the voice profile domain that will store the voice
  profile.
- `identifier`: The unique identifier of the resource to be updated. Valid values include
  the ID and ARN of the media insights pipeline.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: The unique identifier for the client request. Use a different
  token for different speaker search tasks.
- `"KinesisVideoStreamSourceTaskConfiguration"`: The task configuration for the Kinesis
  video stream source of the media insights pipeline.
"""
function start_speaker_search_task(
    VoiceProfileDomainArn, identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_media_pipelines(
        "POST",
        "/media-insights-pipelines/$(identifier)/speaker-search-tasks?operation=start",
        Dict{String,Any}(
            "VoiceProfileDomainArn" => VoiceProfileDomainArn,
            "ClientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_speaker_search_task(
    VoiceProfileDomainArn,
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_media_pipelines(
        "POST",
        "/media-insights-pipelines/$(identifier)/speaker-search-tasks?operation=start",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "VoiceProfileDomainArn" => VoiceProfileDomainArn,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_voice_tone_analysis_task(language_code, identifier)
    start_voice_tone_analysis_task(language_code, identifier, params::Dict{String,<:Any})

Starts a voice tone analysis task. For more information about voice tone analysis, see
Using Amazon Chime SDK voice analytics in the Amazon Chime SDK Developer Guide.  Before
starting any voice tone analysis tasks, you must provide all notices and obtain all
consents from the speaker as required under applicable privacy and biometrics laws, and as
required under the AWS service terms for the Amazon Chime SDK.

# Arguments
- `language_code`: The language code.
- `identifier`: The unique identifier of the resource to be updated. Valid values include
  the ID and ARN of the media insights pipeline.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: The unique identifier for the client request. Use a different
  token for different voice tone analysis tasks.
- `"KinesisVideoStreamSourceTaskConfiguration"`: The task configuration for the Kinesis
  video stream source of the media insights pipeline.
"""
function start_voice_tone_analysis_task(
    LanguageCode, identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_media_pipelines(
        "POST",
        "/media-insights-pipelines/$(identifier)/voice-tone-analysis-tasks?operation=start",
        Dict{String,Any}(
            "LanguageCode" => LanguageCode, "ClientRequestToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_voice_tone_analysis_task(
    LanguageCode,
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_media_pipelines(
        "POST",
        "/media-insights-pipelines/$(identifier)/voice-tone-analysis-tasks?operation=start",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "LanguageCode" => LanguageCode, "ClientRequestToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_speaker_search_task(identifier, speaker_search_task_id)
    stop_speaker_search_task(identifier, speaker_search_task_id, params::Dict{String,<:Any})

Stops a speaker search task.

# Arguments
- `identifier`: The unique identifier of the resource to be updated. Valid values include
  the ID and ARN of the media insights pipeline.
- `speaker_search_task_id`: The speaker search task ID.

"""
function stop_speaker_search_task(
    identifier, speakerSearchTaskId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_media_pipelines(
        "POST",
        "/media-insights-pipelines/$(identifier)/speaker-search-tasks/$(speakerSearchTaskId)?operation=stop";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_speaker_search_task(
    identifier,
    speakerSearchTaskId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_media_pipelines(
        "POST",
        "/media-insights-pipelines/$(identifier)/speaker-search-tasks/$(speakerSearchTaskId)?operation=stop",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_voice_tone_analysis_task(identifier, voice_tone_analysis_task_id)
    stop_voice_tone_analysis_task(identifier, voice_tone_analysis_task_id, params::Dict{String,<:Any})

Stops a voice tone analysis task.

# Arguments
- `identifier`: The unique identifier of the resource to be updated. Valid values include
  the ID and ARN of the media insights pipeline.
- `voice_tone_analysis_task_id`: The ID of the voice tone analysis task.

"""
function stop_voice_tone_analysis_task(
    identifier, voiceToneAnalysisTaskId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_media_pipelines(
        "POST",
        "/media-insights-pipelines/$(identifier)/voice-tone-analysis-tasks/$(voiceToneAnalysisTaskId)?operation=stop";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_voice_tone_analysis_task(
    identifier,
    voiceToneAnalysisTaskId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_media_pipelines(
        "POST",
        "/media-insights-pipelines/$(identifier)/voice-tone-analysis-tasks/$(voiceToneAnalysisTaskId)?operation=stop",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

The ARN of the media pipeline that you want to tag. Consists of the pipeline's endpoint
region, resource ID, and pipeline ID.

# Arguments
- `resource_arn`: The ARN of the media pipeline associated with any tags. The ARN consists
  of the pipeline's endpoint region, resource ID, and pipeline ID.
- `tags`: The tags associated with the specified media pipeline.

"""
function tag_resource(ResourceARN, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return chime_sdk_media_pipelines(
        "POST",
        "/tags?operation=tag-resource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceARN,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_media_pipelines(
        "POST",
        "/tags?operation=tag-resource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes any tags from a media pipeline.

# Arguments
- `resource_arn`: The ARN of the pipeline that you want to untag.
- `tag_keys`: The key/value pairs in the tag that you want to remove.

"""
function untag_resource(
    ResourceARN, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_media_pipelines(
        "POST",
        "/tags?operation=untag-resource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceARN,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_media_pipelines(
        "POST",
        "/tags?operation=untag-resource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_media_insights_pipeline_configuration(elements, resource_access_role_arn, identifier)
    update_media_insights_pipeline_configuration(elements, resource_access_role_arn, identifier, params::Dict{String,<:Any})

Updates the media insights pipeline's configuration settings.

# Arguments
- `elements`: The elements in the request, such as a processor for Amazon Transcribe or a
  sink for a Kinesis Data Stream..
- `resource_access_role_arn`: The ARN of the role used by the service to access Amazon Web
  Services resources.
- `identifier`: The unique identifier for the resource to be updated. Valid values include
  the name and ARN of the media insights pipeline configuration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"RealTimeAlertConfiguration"`: The configuration settings for real-time alerts for the
  media insights pipeline.
"""
function update_media_insights_pipeline_configuration(
    Elements,
    ResourceAccessRoleArn,
    identifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_media_pipelines(
        "PUT",
        "/media-insights-pipeline-configurations/$(identifier)",
        Dict{String,Any}(
            "Elements" => Elements, "ResourceAccessRoleArn" => ResourceAccessRoleArn
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_media_insights_pipeline_configuration(
    Elements,
    ResourceAccessRoleArn,
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_media_pipelines(
        "PUT",
        "/media-insights-pipeline-configurations/$(identifier)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Elements" => Elements, "ResourceAccessRoleArn" => ResourceAccessRoleArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_media_insights_pipeline_status(update_status, identifier)
    update_media_insights_pipeline_status(update_status, identifier, params::Dict{String,<:Any})

Updates the status of a media insights pipeline.

# Arguments
- `update_status`: The requested status of the media insights pipeline.
- `identifier`: The unique identifier of the resource to be updated. Valid values include
  the ID and ARN of the media insights pipeline.

"""
function update_media_insights_pipeline_status(
    UpdateStatus, identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_media_pipelines(
        "PUT",
        "/media-insights-pipeline-status/$(identifier)",
        Dict{String,Any}("UpdateStatus" => UpdateStatus);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_media_insights_pipeline_status(
    UpdateStatus,
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_media_pipelines(
        "PUT",
        "/media-insights-pipeline-status/$(identifier)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("UpdateStatus" => UpdateStatus), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_media_pipeline_kinesis_video_stream_pool(identifier)
    update_media_pipeline_kinesis_video_stream_pool(identifier, params::Dict{String,<:Any})

Updates an Kinesis video stream pool in a media pipeline.

# Arguments
- `identifier`: The ID of the video stream pool.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"StreamConfiguration"`: The configuration settings for the video stream.
"""
function update_media_pipeline_kinesis_video_stream_pool(
    identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_media_pipelines(
        "PUT",
        "/media-pipeline-kinesis-video-stream-pools/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_media_pipeline_kinesis_video_stream_pool(
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_media_pipelines(
        "PUT",
        "/media-pipeline-kinesis-video-stream-pools/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: service_quotas
using AWS.Compat
using AWS.UUIDs

"""
    associate_service_quota_template()
    associate_service_quota_template(params::Dict{String,<:Any})

Associates your quota request template with your organization. When a new Amazon Web
Services account is created in your organization, the quota increase requests in the
template are automatically applied to the account. You can add a quota increase request for
any adjustable quota to your template.

"""
function associate_service_quota_template(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_quotas(
        "AssociateServiceQuotaTemplate";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_service_quota_template(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_quotas(
        "AssociateServiceQuotaTemplate",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_service_quota_increase_request_from_template(aws_region, quota_code, service_code)
    delete_service_quota_increase_request_from_template(aws_region, quota_code, service_code, params::Dict{String,<:Any})

Deletes the quota increase request for the specified quota from your quota request template.

# Arguments
- `aws_region`: Specifies the Amazon Web Services Region for which the request was made.
- `quota_code`: Specifies the quota identifier. To find the quota code for a specific
  quota, use the ListServiceQuotas operation, and look for the QuotaCode response in the
  output for the quota you want.
- `service_code`: Specifies the service identifier. To find the service code value for an
  Amazon Web Services service, use the ListServices operation.

"""
function delete_service_quota_increase_request_from_template(
    AwsRegion, QuotaCode, ServiceCode; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_quotas(
        "DeleteServiceQuotaIncreaseRequestFromTemplate",
        Dict{String,Any}(
            "AwsRegion" => AwsRegion, "QuotaCode" => QuotaCode, "ServiceCode" => ServiceCode
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_service_quota_increase_request_from_template(
    AwsRegion,
    QuotaCode,
    ServiceCode,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_quotas(
        "DeleteServiceQuotaIncreaseRequestFromTemplate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AwsRegion" => AwsRegion,
                    "QuotaCode" => QuotaCode,
                    "ServiceCode" => ServiceCode,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_service_quota_template()
    disassociate_service_quota_template(params::Dict{String,<:Any})

Disables your quota request template. After a template is disabled, the quota increase
requests in the template are not applied to new Amazon Web Services accounts in your
organization. Disabling a quota request template does not apply its quota increase requests.

"""
function disassociate_service_quota_template(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_quotas(
        "DisassociateServiceQuotaTemplate";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_service_quota_template(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_quotas(
        "DisassociateServiceQuotaTemplate",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_association_for_service_quota_template()
    get_association_for_service_quota_template(params::Dict{String,<:Any})

Retrieves the status of the association for the quota request template.

"""
function get_association_for_service_quota_template(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_quotas(
        "GetAssociationForServiceQuotaTemplate";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_association_for_service_quota_template(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_quotas(
        "GetAssociationForServiceQuotaTemplate",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_awsdefault_service_quota(quota_code, service_code)
    get_awsdefault_service_quota(quota_code, service_code, params::Dict{String,<:Any})

Retrieves the default value for the specified quota. The default value does not reflect any
quota increases.

# Arguments
- `quota_code`: Specifies the quota identifier. To find the quota code for a specific
  quota, use the ListServiceQuotas operation, and look for the QuotaCode response in the
  output for the quota you want.
- `service_code`: Specifies the service identifier. To find the service code value for an
  Amazon Web Services service, use the ListServices operation.

"""
function get_awsdefault_service_quota(
    QuotaCode, ServiceCode; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_quotas(
        "GetAWSDefaultServiceQuota",
        Dict{String,Any}("QuotaCode" => QuotaCode, "ServiceCode" => ServiceCode);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_awsdefault_service_quota(
    QuotaCode,
    ServiceCode,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_quotas(
        "GetAWSDefaultServiceQuota",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("QuotaCode" => QuotaCode, "ServiceCode" => ServiceCode),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_requested_service_quota_change(request_id)
    get_requested_service_quota_change(request_id, params::Dict{String,<:Any})

Retrieves information about the specified quota increase request.

# Arguments
- `request_id`: Specifies the ID of the quota increase request.

"""
function get_requested_service_quota_change(
    RequestId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_quotas(
        "GetRequestedServiceQuotaChange",
        Dict{String,Any}("RequestId" => RequestId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_requested_service_quota_change(
    RequestId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_quotas(
        "GetRequestedServiceQuotaChange",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("RequestId" => RequestId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_service_quota(quota_code, service_code)
    get_service_quota(quota_code, service_code, params::Dict{String,<:Any})

Retrieves the applied quota value for the specified quota. For some quotas, only the
default values are available. If the applied quota value is not available for a quota, the
quota is not retrieved.

# Arguments
- `quota_code`: Specifies the quota identifier. To find the quota code for a specific
  quota, use the ListServiceQuotas operation, and look for the QuotaCode response in the
  output for the quota you want.
- `service_code`: Specifies the service identifier. To find the service code value for an
  Amazon Web Services service, use the ListServices operation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ContextId"`: Specifies the Amazon Web Services account or resource to which the quota
  applies. The value in this field depends on the context scope associated with the specified
  service quota.
"""
function get_service_quota(
    QuotaCode, ServiceCode; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_quotas(
        "GetServiceQuota",
        Dict{String,Any}("QuotaCode" => QuotaCode, "ServiceCode" => ServiceCode);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_service_quota(
    QuotaCode,
    ServiceCode,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_quotas(
        "GetServiceQuota",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("QuotaCode" => QuotaCode, "ServiceCode" => ServiceCode),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_service_quota_increase_request_from_template(aws_region, quota_code, service_code)
    get_service_quota_increase_request_from_template(aws_region, quota_code, service_code, params::Dict{String,<:Any})

Retrieves information about the specified quota increase request in your quota request
template.

# Arguments
- `aws_region`: Specifies the Amazon Web Services Region for which you made the request.
- `quota_code`: Specifies the quota identifier. To find the quota code for a specific
  quota, use the ListServiceQuotas operation, and look for the QuotaCode response in the
  output for the quota you want.
- `service_code`: Specifies the service identifier. To find the service code value for an
  Amazon Web Services service, use the ListServices operation.

"""
function get_service_quota_increase_request_from_template(
    AwsRegion, QuotaCode, ServiceCode; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_quotas(
        "GetServiceQuotaIncreaseRequestFromTemplate",
        Dict{String,Any}(
            "AwsRegion" => AwsRegion, "QuotaCode" => QuotaCode, "ServiceCode" => ServiceCode
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_service_quota_increase_request_from_template(
    AwsRegion,
    QuotaCode,
    ServiceCode,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_quotas(
        "GetServiceQuotaIncreaseRequestFromTemplate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AwsRegion" => AwsRegion,
                    "QuotaCode" => QuotaCode,
                    "ServiceCode" => ServiceCode,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_awsdefault_service_quotas(service_code)
    list_awsdefault_service_quotas(service_code, params::Dict{String,<:Any})

Lists the default values for the quotas for the specified Amazon Web Service. A default
value does not reflect any quota increases.

# Arguments
- `service_code`: Specifies the service identifier. To find the service code value for an
  Amazon Web Services service, use the ListServices operation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Specifies the maximum number of results that you want included on each
  page of the response. If you do not include this parameter, it defaults to a value
  appropriate to the operation. If additional items exist beyond those included in the
  current response, the NextToken response element is present and has a value (is not null).
  Include that value as the NextToken request parameter in the next call to the operation to
  get the next part of the results.  An API operation can return fewer results than the
  maximum even when there are more results available. You should check NextToken after every
  operation to ensure that you receive all of the results.
- `"NextToken"`: Specifies a value for receiving additional results after you receive a
  NextToken response in a previous request. A NextToken response indicates that more output
  is available. Set this parameter to the value of the previous call's NextToken response to
  indicate where the output should continue from.
"""
function list_awsdefault_service_quotas(
    ServiceCode; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_quotas(
        "ListAWSDefaultServiceQuotas",
        Dict{String,Any}("ServiceCode" => ServiceCode);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_awsdefault_service_quotas(
    ServiceCode,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_quotas(
        "ListAWSDefaultServiceQuotas",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ServiceCode" => ServiceCode), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_requested_service_quota_change_history()
    list_requested_service_quota_change_history(params::Dict{String,<:Any})

Retrieves the quota increase requests for the specified Amazon Web Service.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Specifies the maximum number of results that you want included on each
  page of the response. If you do not include this parameter, it defaults to a value
  appropriate to the operation. If additional items exist beyond those included in the
  current response, the NextToken response element is present and has a value (is not null).
  Include that value as the NextToken request parameter in the next call to the operation to
  get the next part of the results.  An API operation can return fewer results than the
  maximum even when there are more results available. You should check NextToken after every
  operation to ensure that you receive all of the results.
- `"NextToken"`: Specifies a value for receiving additional results after you receive a
  NextToken response in a previous request. A NextToken response indicates that more output
  is available. Set this parameter to the value of the previous call's NextToken response to
  indicate where the output should continue from.
- `"QuotaRequestedAtLevel"`: Specifies at which level within the Amazon Web Services
  account the quota request applies to.
- `"ServiceCode"`: Specifies the service identifier. To find the service code value for an
  Amazon Web Services service, use the ListServices operation.
- `"Status"`: Specifies that you want to filter the results to only the requests with the
  matching status.
"""
function list_requested_service_quota_change_history(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_quotas(
        "ListRequestedServiceQuotaChangeHistory";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_requested_service_quota_change_history(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_quotas(
        "ListRequestedServiceQuotaChangeHistory",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_requested_service_quota_change_history_by_quota(quota_code, service_code)
    list_requested_service_quota_change_history_by_quota(quota_code, service_code, params::Dict{String,<:Any})

Retrieves the quota increase requests for the specified quota.

# Arguments
- `quota_code`: Specifies the quota identifier. To find the quota code for a specific
  quota, use the ListServiceQuotas operation, and look for the QuotaCode response in the
  output for the quota you want.
- `service_code`: Specifies the service identifier. To find the service code value for an
  Amazon Web Services service, use the ListServices operation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Specifies the maximum number of results that you want included on each
  page of the response. If you do not include this parameter, it defaults to a value
  appropriate to the operation. If additional items exist beyond those included in the
  current response, the NextToken response element is present and has a value (is not null).
  Include that value as the NextToken request parameter in the next call to the operation to
  get the next part of the results.  An API operation can return fewer results than the
  maximum even when there are more results available. You should check NextToken after every
  operation to ensure that you receive all of the results.
- `"NextToken"`: Specifies a value for receiving additional results after you receive a
  NextToken response in a previous request. A NextToken response indicates that more output
  is available. Set this parameter to the value of the previous call's NextToken response to
  indicate where the output should continue from.
- `"QuotaRequestedAtLevel"`: Specifies at which level within the Amazon Web Services
  account the quota request applies to.
- `"Status"`: Specifies that you want to filter the results to only the requests with the
  matching status.
"""
function list_requested_service_quota_change_history_by_quota(
    QuotaCode, ServiceCode; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_quotas(
        "ListRequestedServiceQuotaChangeHistoryByQuota",
        Dict{String,Any}("QuotaCode" => QuotaCode, "ServiceCode" => ServiceCode);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_requested_service_quota_change_history_by_quota(
    QuotaCode,
    ServiceCode,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_quotas(
        "ListRequestedServiceQuotaChangeHistoryByQuota",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("QuotaCode" => QuotaCode, "ServiceCode" => ServiceCode),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_service_quota_increase_requests_in_template()
    list_service_quota_increase_requests_in_template(params::Dict{String,<:Any})

Lists the quota increase requests in the specified quota request template.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AwsRegion"`: Specifies the Amazon Web Services Region for which you made the request.
- `"MaxResults"`: Specifies the maximum number of results that you want included on each
  page of the response. If you do not include this parameter, it defaults to a value
  appropriate to the operation. If additional items exist beyond those included in the
  current response, the NextToken response element is present and has a value (is not null).
  Include that value as the NextToken request parameter in the next call to the operation to
  get the next part of the results.  An API operation can return fewer results than the
  maximum even when there are more results available. You should check NextToken after every
  operation to ensure that you receive all of the results.
- `"NextToken"`: Specifies a value for receiving additional results after you receive a
  NextToken response in a previous request. A NextToken response indicates that more output
  is available. Set this parameter to the value of the previous call's NextToken response to
  indicate where the output should continue from.
- `"ServiceCode"`: Specifies the service identifier. To find the service code value for an
  Amazon Web Services service, use the ListServices operation.
"""
function list_service_quota_increase_requests_in_template(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_quotas(
        "ListServiceQuotaIncreaseRequestsInTemplate";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_service_quota_increase_requests_in_template(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_quotas(
        "ListServiceQuotaIncreaseRequestsInTemplate",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_service_quotas(service_code)
    list_service_quotas(service_code, params::Dict{String,<:Any})

Lists the applied quota values for the specified Amazon Web Service. For some quotas, only
the default values are available. If the applied quota value is not available for a quota,
the quota is not retrieved.

# Arguments
- `service_code`: Specifies the service identifier. To find the service code value for an
  Amazon Web Services service, use the ListServices operation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Specifies the maximum number of results that you want included on each
  page of the response. If you do not include this parameter, it defaults to a value
  appropriate to the operation. If additional items exist beyond those included in the
  current response, the NextToken response element is present and has a value (is not null).
  Include that value as the NextToken request parameter in the next call to the operation to
  get the next part of the results.  An API operation can return fewer results than the
  maximum even when there are more results available. You should check NextToken after every
  operation to ensure that you receive all of the results.
- `"NextToken"`: Specifies a value for receiving additional results after you receive a
  NextToken response in a previous request. A NextToken response indicates that more output
  is available. Set this parameter to the value of the previous call's NextToken response to
  indicate where the output should continue from.
- `"QuotaAppliedAtLevel"`: Specifies at which level of granularity that the quota value is
  applied.
- `"QuotaCode"`: Specifies the quota identifier. To find the quota code for a specific
  quota, use the ListServiceQuotas operation, and look for the QuotaCode response in the
  output for the quota you want.
"""
function list_service_quotas(
    ServiceCode; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_quotas(
        "ListServiceQuotas",
        Dict{String,Any}("ServiceCode" => ServiceCode);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_service_quotas(
    ServiceCode,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_quotas(
        "ListServiceQuotas",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ServiceCode" => ServiceCode), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_services()
    list_services(params::Dict{String,<:Any})

Lists the names and codes for the Amazon Web Services integrated with Service Quotas.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Specifies the maximum number of results that you want included on each
  page of the response. If you do not include this parameter, it defaults to a value
  appropriate to the operation. If additional items exist beyond those included in the
  current response, the NextToken response element is present and has a value (is not null).
  Include that value as the NextToken request parameter in the next call to the operation to
  get the next part of the results.  An API operation can return fewer results than the
  maximum even when there are more results available. You should check NextToken after every
  operation to ensure that you receive all of the results.
- `"NextToken"`: Specifies a value for receiving additional results after you receive a
  NextToken response in a previous request. A NextToken response indicates that more output
  is available. Set this parameter to the value of the previous call's NextToken response to
  indicate where the output should continue from.
"""
function list_services(; aws_config::AbstractAWSConfig=current_aws_config())
    return service_quotas(
        "ListServices"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_services(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_quotas(
        "ListServices", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Returns a list of the tags assigned to the specified applied quota.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) for the applied quota for which you want
  to list tags. You can get this information by using the Service Quotas console, or by
  listing the quotas using the list-service-quotas CLI command or the ListServiceQuotas
  Amazon Web Services API operation.

"""
function list_tags_for_resource(
    ResourceARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_quotas(
        "ListTagsForResource",
        Dict{String,Any}("ResourceARN" => ResourceARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_quotas(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceARN" => ResourceARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_service_quota_increase_request_into_template(aws_region, desired_value, quota_code, service_code)
    put_service_quota_increase_request_into_template(aws_region, desired_value, quota_code, service_code, params::Dict{String,<:Any})

Adds a quota increase request to your quota request template.

# Arguments
- `aws_region`: Specifies the Amazon Web Services Region to which the template applies.
- `desired_value`: Specifies the new, increased value for the quota.
- `quota_code`: Specifies the quota identifier. To find the quota code for a specific
  quota, use the ListServiceQuotas operation, and look for the QuotaCode response in the
  output for the quota you want.
- `service_code`: Specifies the service identifier. To find the service code value for an
  Amazon Web Services service, use the ListServices operation.

"""
function put_service_quota_increase_request_into_template(
    AwsRegion,
    DesiredValue,
    QuotaCode,
    ServiceCode;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_quotas(
        "PutServiceQuotaIncreaseRequestIntoTemplate",
        Dict{String,Any}(
            "AwsRegion" => AwsRegion,
            "DesiredValue" => DesiredValue,
            "QuotaCode" => QuotaCode,
            "ServiceCode" => ServiceCode,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_service_quota_increase_request_into_template(
    AwsRegion,
    DesiredValue,
    QuotaCode,
    ServiceCode,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_quotas(
        "PutServiceQuotaIncreaseRequestIntoTemplate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AwsRegion" => AwsRegion,
                    "DesiredValue" => DesiredValue,
                    "QuotaCode" => QuotaCode,
                    "ServiceCode" => ServiceCode,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    request_service_quota_increase(desired_value, quota_code, service_code)
    request_service_quota_increase(desired_value, quota_code, service_code, params::Dict{String,<:Any})

Submits a quota increase request for the specified quota.

# Arguments
- `desired_value`: Specifies the new, increased value for the quota.
- `quota_code`: Specifies the quota identifier. To find the quota code for a specific
  quota, use the ListServiceQuotas operation, and look for the QuotaCode response in the
  output for the quota you want.
- `service_code`: Specifies the service identifier. To find the service code value for an
  Amazon Web Services service, use the ListServices operation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ContextId"`: Specifies the Amazon Web Services account or resource to which the quota
  applies. The value in this field depends on the context scope associated with the specified
  service quota.
"""
function request_service_quota_increase(
    DesiredValue, QuotaCode, ServiceCode; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_quotas(
        "RequestServiceQuotaIncrease",
        Dict{String,Any}(
            "DesiredValue" => DesiredValue,
            "QuotaCode" => QuotaCode,
            "ServiceCode" => ServiceCode,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function request_service_quota_increase(
    DesiredValue,
    QuotaCode,
    ServiceCode,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_quotas(
        "RequestServiceQuotaIncrease",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DesiredValue" => DesiredValue,
                    "QuotaCode" => QuotaCode,
                    "ServiceCode" => ServiceCode,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds tags to the specified applied quota. You can include one or more tags to add to the
quota.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) for the applied quota. You can get this
  information by using the Service Quotas console, or by listing the quotas using the
  list-service-quotas CLI command or the ListServiceQuotas Amazon Web Services API operation.
- `tags`: The tags that you want to add to the resource.

"""
function tag_resource(ResourceARN, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return service_quotas(
        "TagResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceARN,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_quotas(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes tags from the specified applied quota. You can specify one or more tags to remove.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) for the applied quota that you want to
  untag. You can get this information by using the Service Quotas console, or by listing the
  quotas using the list-service-quotas CLI command or the ListServiceQuotas Amazon Web
  Services API operation.
- `tag_keys`: The keys of the tags that you want to remove from the resource.

"""
function untag_resource(
    ResourceARN, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_quotas(
        "UntagResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceARN,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_quotas(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: application_discovery_service
using AWS.Compat
using AWS.UUIDs

"""
    associate_configuration_items_to_application(application_configuration_id, configuration_ids)
    associate_configuration_items_to_application(application_configuration_id, configuration_ids, params::Dict{String,<:Any})

Associates one or more configuration items with an application.

# Arguments
- `application_configuration_id`: The configuration ID of an application with which items
  are to be associated.
- `configuration_ids`: The ID of each configuration item to be associated with an
  application.

"""
function associate_configuration_items_to_application(
    applicationConfigurationId,
    configurationIds;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_discovery_service(
        "AssociateConfigurationItemsToApplication",
        Dict{String,Any}(
            "applicationConfigurationId" => applicationConfigurationId,
            "configurationIds" => configurationIds,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_configuration_items_to_application(
    applicationConfigurationId,
    configurationIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_discovery_service(
        "AssociateConfigurationItemsToApplication",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "applicationConfigurationId" => applicationConfigurationId,
                    "configurationIds" => configurationIds,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_delete_agents(delete_agents)
    batch_delete_agents(delete_agents, params::Dict{String,<:Any})

 Deletes one or more agents or collectors as specified by ID. Deleting an agent or
collector does not delete the previously discovered data. To delete the data collected, use
StartBatchDeleteConfigurationTask.

# Arguments
- `delete_agents`:  The list of agents to delete.

"""
function batch_delete_agents(
    deleteAgents; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_discovery_service(
        "BatchDeleteAgents",
        Dict{String,Any}("deleteAgents" => deleteAgents);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_delete_agents(
    deleteAgents,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_discovery_service(
        "BatchDeleteAgents",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("deleteAgents" => deleteAgents), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_delete_import_data(import_task_ids)
    batch_delete_import_data(import_task_ids, params::Dict{String,<:Any})

Deletes one or more import tasks, each identified by their import ID. Each import task has
a number of records that can identify servers or applications.  Amazon Web Services
Application Discovery Service has built-in matching logic that will identify when
discovered servers match existing entries that you've previously discovered, the
information for the already-existing discovered server is updated. When you delete an
import task that contains records that were used to match, the information in those matched
records that comes from the deleted records will also be deleted.

# Arguments
- `import_task_ids`: The IDs for the import tasks that you want to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"deleteHistory"`:  Set to true to remove the deleted import task from
  DescribeImportTasks.
"""
function batch_delete_import_data(
    importTaskIds; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_discovery_service(
        "BatchDeleteImportData",
        Dict{String,Any}("importTaskIds" => importTaskIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_delete_import_data(
    importTaskIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_discovery_service(
        "BatchDeleteImportData",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("importTaskIds" => importTaskIds), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_application(name)
    create_application(name, params::Dict{String,<:Any})

Creates an application with the given name and description.

# Arguments
- `name`: Name of the application to be created.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: Description of the application to be created.
"""
function create_application(name; aws_config::AbstractAWSConfig=current_aws_config())
    return application_discovery_service(
        "CreateApplication",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_application(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_discovery_service(
        "CreateApplication",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_tags(configuration_ids, tags)
    create_tags(configuration_ids, tags, params::Dict{String,<:Any})

Creates one or more tags for configuration items. Tags are metadata that help you
categorize IT assets. This API accepts a list of multiple configuration items.  Do not
store sensitive information (like personal data) in tags.

# Arguments
- `configuration_ids`: A list of configuration items that you want to tag.
- `tags`: Tags that you want to associate with one or more configuration items. Specify the
  tags that you want to create in a key-value format. For example:  {\"key\": \"serverType\",
  \"value\": \"webServer\"}

"""
function create_tags(
    configurationIds, tags; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_discovery_service(
        "CreateTags",
        Dict{String,Any}("configurationIds" => configurationIds, "tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_tags(
    configurationIds,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_discovery_service(
        "CreateTags",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("configurationIds" => configurationIds, "tags" => tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_applications(configuration_ids)
    delete_applications(configuration_ids, params::Dict{String,<:Any})

Deletes a list of applications and their associations with configuration items.

# Arguments
- `configuration_ids`: Configuration ID of an application to be deleted.

"""
function delete_applications(
    configurationIds; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_discovery_service(
        "DeleteApplications",
        Dict{String,Any}("configurationIds" => configurationIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_applications(
    configurationIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_discovery_service(
        "DeleteApplications",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("configurationIds" => configurationIds), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_tags(configuration_ids)
    delete_tags(configuration_ids, params::Dict{String,<:Any})

Deletes the association between configuration items and one or more tags. This API accepts
a list of multiple configuration items.

# Arguments
- `configuration_ids`: A list of configuration items with tags that you want to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tags"`: Tags that you want to delete from one or more configuration items. Specify the
  tags that you want to delete in a key-value format. For example:  {\"key\": \"serverType\",
  \"value\": \"webServer\"}
"""
function delete_tags(configurationIds; aws_config::AbstractAWSConfig=current_aws_config())
    return application_discovery_service(
        "DeleteTags",
        Dict{String,Any}("configurationIds" => configurationIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_tags(
    configurationIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_discovery_service(
        "DeleteTags",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("configurationIds" => configurationIds), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_agents()
    describe_agents(params::Dict{String,<:Any})

Lists agents or collectors as specified by ID or other filters. All agents/collectors
associated with your user can be listed if you call DescribeAgents as is without passing
any parameters.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"agentIds"`: The agent or the collector IDs for which you want information. If you
  specify no IDs, the system returns information about all agents/collectors associated with
  your user.
- `"filters"`: You can filter the request using various logical operators and a key-value
  format. For example:   {\"key\": \"collectionStatus\", \"value\": \"STARTED\"}
- `"maxResults"`: The total number of agents/collectors to return in a single page of
  output. The maximum value is 100.
- `"nextToken"`: Token to retrieve the next set of results. For example, if you previously
  specified 100 IDs for DescribeAgentsRequestagentIds but set DescribeAgentsRequestmaxResults
  to 10, you received a set of 10 results along with a token. Use that token in this query to
  get the next set of 10.
"""
function describe_agents(; aws_config::AbstractAWSConfig=current_aws_config())
    return application_discovery_service(
        "DescribeAgents"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_agents(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_discovery_service(
        "DescribeAgents", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_batch_delete_configuration_task(task_id)
    describe_batch_delete_configuration_task(task_id, params::Dict{String,<:Any})

 Takes a unique deletion task identifier as input and returns metadata about a
configuration deletion task.

# Arguments
- `task_id`:  The ID of the task to delete.

"""
function describe_batch_delete_configuration_task(
    taskId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_discovery_service(
        "DescribeBatchDeleteConfigurationTask",
        Dict{String,Any}("taskId" => taskId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_batch_delete_configuration_task(
    taskId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_discovery_service(
        "DescribeBatchDeleteConfigurationTask",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("taskId" => taskId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_configurations(configuration_ids)
    describe_configurations(configuration_ids, params::Dict{String,<:Any})

Retrieves attributes for a list of configuration item IDs.  All of the supplied IDs must be
for the same asset type from one of the following:   server   application   process
connection   Output fields are specific to the asset type specified. For example, the
output for a server configuration item includes a list of attributes about the server, such
as host name, operating system, number of network cards, etc. For a complete list of
outputs for each asset type, see Using the DescribeConfigurations Action in the Amazon Web
Services Application Discovery Service User Guide.

# Arguments
- `configuration_ids`: One or more configuration IDs.

"""
function describe_configurations(
    configurationIds; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_discovery_service(
        "DescribeConfigurations",
        Dict{String,Any}("configurationIds" => configurationIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_configurations(
    configurationIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_discovery_service(
        "DescribeConfigurations",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("configurationIds" => configurationIds), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_continuous_exports()
    describe_continuous_exports(params::Dict{String,<:Any})

Lists exports as specified by ID. All continuous exports associated with your user can be
listed if you call DescribeContinuousExports as is without passing any parameters.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"exportIds"`: The unique IDs assigned to the exports.
- `"maxResults"`: A number between 1 and 100 specifying the maximum number of continuous
  export descriptions returned.
- `"nextToken"`: The token from the previous call to DescribeExportTasks.
"""
function describe_continuous_exports(; aws_config::AbstractAWSConfig=current_aws_config())
    return application_discovery_service(
        "DescribeContinuousExports"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_continuous_exports(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_discovery_service(
        "DescribeContinuousExports",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_export_configurations()
    describe_export_configurations(params::Dict{String,<:Any})

 DescribeExportConfigurations is deprecated. Use DescribeExportTasks, instead.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"exportIds"`: A list of continuous export IDs to search for.
- `"maxResults"`: A number between 1 and 100 specifying the maximum number of continuous
  export descriptions returned.
- `"nextToken"`: The token from the previous call to describe-export-tasks.
"""
function describe_export_configurations(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_discovery_service(
        "DescribeExportConfigurations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_export_configurations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_discovery_service(
        "DescribeExportConfigurations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_export_tasks()
    describe_export_tasks(params::Dict{String,<:Any})

Retrieve status of one or more export tasks. You can retrieve the status of up to 100
export tasks.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"exportIds"`: One or more unique identifiers used to query the status of an export
  request.
- `"filters"`: One or more filters.    AgentId - ID of the agent whose collected data will
  be exported
- `"maxResults"`: The maximum number of volume results returned by DescribeExportTasks in
  paginated output. When this parameter is used, DescribeExportTasks only returns maxResults
  results in a single page along with a nextToken response element.
- `"nextToken"`: The nextToken value returned from a previous paginated DescribeExportTasks
  request where maxResults was used and the results exceeded the value of that parameter.
  Pagination continues from the end of the previous results that returned the nextToken
  value. This value is null when there are no more results to return.
"""
function describe_export_tasks(; aws_config::AbstractAWSConfig=current_aws_config())
    return application_discovery_service(
        "DescribeExportTasks"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_export_tasks(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_discovery_service(
        "DescribeExportTasks",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_import_tasks()
    describe_import_tasks(params::Dict{String,<:Any})

Returns an array of import tasks for your account, including status information, times,
IDs, the Amazon S3 Object URL for the import file, and more.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: An array of name-value pairs that you provide to filter the results for the
  DescribeImportTask request to a specific subset of results. Currently, wildcard values
  aren't supported for filters.
- `"maxResults"`: The maximum number of results that you want this request to return, up to
  100.
- `"nextToken"`: The token to request a specific page of results.
"""
function describe_import_tasks(; aws_config::AbstractAWSConfig=current_aws_config())
    return application_discovery_service(
        "DescribeImportTasks"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_import_tasks(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_discovery_service(
        "DescribeImportTasks",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_tags()
    describe_tags(params::Dict{String,<:Any})

Retrieves a list of configuration items that have tags as specified by the key-value pairs,
name and value, passed to the optional parameter filters. There are three valid tag filter
names:   tagKey   tagValue   configurationId   Also, all configuration items associated
with your user that have tags can be listed if you call DescribeTags as is without passing
any parameters.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: You can filter the list using a key-value format. You can separate these
  items by using logical operators. Allowed filters include tagKey, tagValue, and
  configurationId.
- `"maxResults"`: The total number of items to return in a single page of output. The
  maximum value is 100.
- `"nextToken"`: A token to start the list. Use this token to get the next set of results.
"""
function describe_tags(; aws_config::AbstractAWSConfig=current_aws_config())
    return application_discovery_service(
        "DescribeTags"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_tags(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_discovery_service(
        "DescribeTags", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    disassociate_configuration_items_from_application(application_configuration_id, configuration_ids)
    disassociate_configuration_items_from_application(application_configuration_id, configuration_ids, params::Dict{String,<:Any})

Disassociates one or more configuration items from an application.

# Arguments
- `application_configuration_id`: Configuration ID of an application from which each item
  is disassociated.
- `configuration_ids`: Configuration ID of each item to be disassociated from an
  application.

"""
function disassociate_configuration_items_from_application(
    applicationConfigurationId,
    configurationIds;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_discovery_service(
        "DisassociateConfigurationItemsFromApplication",
        Dict{String,Any}(
            "applicationConfigurationId" => applicationConfigurationId,
            "configurationIds" => configurationIds,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_configuration_items_from_application(
    applicationConfigurationId,
    configurationIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_discovery_service(
        "DisassociateConfigurationItemsFromApplication",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "applicationConfigurationId" => applicationConfigurationId,
                    "configurationIds" => configurationIds,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    export_configurations()
    export_configurations(params::Dict{String,<:Any})

Deprecated. Use StartExportTask instead. Exports all discovered configuration data to an
Amazon S3 bucket or an application that enables you to view and evaluate the data. Data
includes tags and tag associations, processes, connections, servers, and system
performance. This API returns an export ID that you can query using the
DescribeExportConfigurations API. The system imposes a limit of two configuration exports
in six hours.

"""
function export_configurations(; aws_config::AbstractAWSConfig=current_aws_config())
    return application_discovery_service(
        "ExportConfigurations"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function export_configurations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_discovery_service(
        "ExportConfigurations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_discovery_summary()
    get_discovery_summary(params::Dict{String,<:Any})

Retrieves a short summary of discovered assets. This API operation takes no request
parameters and is called as is at the command prompt as shown in the example.

"""
function get_discovery_summary(; aws_config::AbstractAWSConfig=current_aws_config())
    return application_discovery_service(
        "GetDiscoverySummary"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_discovery_summary(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_discovery_service(
        "GetDiscoverySummary",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_configurations(configuration_type)
    list_configurations(configuration_type, params::Dict{String,<:Any})

Retrieves a list of configuration items as specified by the value passed to the required
parameter configurationType. Optional filtering may be applied to refine search results.

# Arguments
- `configuration_type`: A valid configuration identified by Application Discovery Service.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: You can filter the request using various logical operators and a key-value
  format. For example:   {\"key\": \"serverType\", \"value\": \"webServer\"}  For a complete
  list of filter options and guidance about using them with this action, see Using the
  ListConfigurations Action in the Amazon Web Services Application Discovery Service User
  Guide.
- `"maxResults"`: The total number of items to return. The maximum value is 100.
- `"nextToken"`: Token to retrieve the next set of results. For example, if a previous call
  to ListConfigurations returned 100 items, but you set ListConfigurationsRequestmaxResults
  to 10, you received a set of 10 results along with a token. Use that token in this query to
  get the next set of 10.
- `"orderBy"`: Certain filter criteria return output that can be sorted in ascending or
  descending order. For a list of output characteristics for each filter, see Using the
  ListConfigurations Action in the Amazon Web Services Application Discovery Service User
  Guide.
"""
function list_configurations(
    configurationType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_discovery_service(
        "ListConfigurations",
        Dict{String,Any}("configurationType" => configurationType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_configurations(
    configurationType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_discovery_service(
        "ListConfigurations",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("configurationType" => configurationType), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_server_neighbors(configuration_id)
    list_server_neighbors(configuration_id, params::Dict{String,<:Any})

Retrieves a list of servers that are one network hop away from a specified server.

# Arguments
- `configuration_id`: Configuration ID of the server for which neighbors are being listed.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Maximum number of results to return in a single page of output.
- `"neighborConfigurationIds"`: List of configuration IDs to test for one-hop-away.
- `"nextToken"`: Token to retrieve the next set of results. For example, if you previously
  specified 100 IDs for ListServerNeighborsRequestneighborConfigurationIds but set
  ListServerNeighborsRequestmaxResults to 10, you received a set of 10 results along with a
  token. Use that token in this query to get the next set of 10.
- `"portInformationNeeded"`: Flag to indicate if port and protocol information is needed as
  part of the response.
"""
function list_server_neighbors(
    configurationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_discovery_service(
        "ListServerNeighbors",
        Dict{String,Any}("configurationId" => configurationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_server_neighbors(
    configurationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_discovery_service(
        "ListServerNeighbors",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("configurationId" => configurationId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_batch_delete_configuration_task(configuration_ids, configuration_type)
    start_batch_delete_configuration_task(configuration_ids, configuration_type, params::Dict{String,<:Any})

 Takes a list of configurationId as input and starts an asynchronous deletion task to
remove the configurationItems. Returns a unique deletion task identifier.

# Arguments
- `configuration_ids`:  The list of configuration IDs that will be deleted by the task.
- `configuration_type`:  The type of configuration item to delete. Supported types are:
  SERVER.

"""
function start_batch_delete_configuration_task(
    configurationIds, configurationType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_discovery_service(
        "StartBatchDeleteConfigurationTask",
        Dict{String,Any}(
            "configurationIds" => configurationIds, "configurationType" => configurationType
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_batch_delete_configuration_task(
    configurationIds,
    configurationType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_discovery_service(
        "StartBatchDeleteConfigurationTask",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "configurationIds" => configurationIds,
                    "configurationType" => configurationType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_continuous_export()
    start_continuous_export(params::Dict{String,<:Any})

Start the continuous flow of agent's discovered data into Amazon Athena.

"""
function start_continuous_export(; aws_config::AbstractAWSConfig=current_aws_config())
    return application_discovery_service(
        "StartContinuousExport"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function start_continuous_export(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_discovery_service(
        "StartContinuousExport",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_data_collection_by_agent_ids(agent_ids)
    start_data_collection_by_agent_ids(agent_ids, params::Dict{String,<:Any})

Instructs the specified agents to start collecting data.

# Arguments
- `agent_ids`: The IDs of the agents from which to start collecting data. If you send a
  request to an agent ID that you do not have permission to contact, according to your Amazon
  Web Services account, the service does not throw an exception. Instead, it returns the
  error in the Description field. If you send a request to multiple agents and you do not
  have permission to contact some of those agents, the system does not throw an exception.
  Instead, the system shows Failed in the Description field.

"""
function start_data_collection_by_agent_ids(
    agentIds; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_discovery_service(
        "StartDataCollectionByAgentIds",
        Dict{String,Any}("agentIds" => agentIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_data_collection_by_agent_ids(
    agentIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_discovery_service(
        "StartDataCollectionByAgentIds",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("agentIds" => agentIds), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_export_task()
    start_export_task(params::Dict{String,<:Any})

Begins the export of a discovered data report to an Amazon S3 bucket managed by Amazon Web
Services.  Exports might provide an estimate of fees and savings based on certain
information that you provide. Fee estimates do not include any taxes that might apply. Your
actual fees and savings depend on a variety of factors, including your actual usage of
Amazon Web Services services, which might vary from the estimates provided in this report.
If you do not specify preferences or agentIds in the filter, a summary of all servers,
applications, tags, and performance is generated. This data is an aggregation of all server
data collected through on-premises tooling, file import, application grouping and applying
tags. If you specify agentIds in a filter, the task exports up to 72 hours of detailed data
collected by the identified Application Discovery Agent, including network, process, and
performance details. A time range for exported agent data may be set by using startTime and
endTime. Export of detailed agent data is limited to five concurrently running exports.
Export of detailed agent data is limited to two exports per day. If you enable
ec2RecommendationsPreferences in preferences , an Amazon EC2 instance matching the
characteristics of each server in Application Discovery Service is generated. Changing the
attributes of the ec2RecommendationsPreferences changes the criteria of the recommendation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"endTime"`: The end timestamp for exported data from the single Application Discovery
  Agent selected in the filters. If no value is specified, exported data includes the most
  recent data collected by the agent.
- `"exportDataFormat"`: The file format for the returned export data. Default value is CSV.
  Note: The GRAPHML option has been deprecated.
- `"filters"`: If a filter is present, it selects the single agentId of the Application
  Discovery Agent for which data is exported. The agentId can be found in the results of the
  DescribeAgents API or CLI. If no filter is present, startTime and endTime are ignored and
  exported data includes both Amazon Web Services Application Discovery Service Agentless
  Collector collectors data and summary data from Application Discovery Agent agents.
- `"preferences"`:  Indicates the type of data that needs to be exported. Only one
  ExportPreferences can be enabled at any time.
- `"startTime"`: The start timestamp for exported data from the single Application
  Discovery Agent selected in the filters. If no value is specified, data is exported
  starting from the first data collected by the agent.
"""
function start_export_task(; aws_config::AbstractAWSConfig=current_aws_config())
    return application_discovery_service(
        "StartExportTask"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function start_export_task(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_discovery_service(
        "StartExportTask", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    start_import_task(import_url, name)
    start_import_task(import_url, name, params::Dict{String,<:Any})

Starts an import task, which allows you to import details of your on-premises environment
directly into Amazon Web Services Migration Hub without having to use the Amazon Web
Services Application Discovery Service (Application Discovery Service) tools such as the
Amazon Web Services Application Discovery Service Agentless Collector or Application
Discovery Agent. This gives you the option to perform migration assessment and planning
directly from your imported data, including the ability to group your devices as
applications and track their migration status. To start an import request, do this:
Download the specially formatted comma separated value (CSV) import template, which you can
find here:
https://s3.us-west-2.amazonaws.com/templates-7cffcf56-bd96-4b1c-b45b-a5b42f282e46/import_tem
plate.csv.   Fill out the template with your server and application data.   Upload your
import file to an Amazon S3 bucket, and make a note of it's Object URL. Your import file
must be in the CSV format.   Use the console or the StartImportTask command with the Amazon
Web Services CLI or one of the Amazon Web Services SDKs to import the records from your
file.   For more information, including step-by-step procedures, see Migration Hub Import
in the Amazon Web Services Application Discovery Service User Guide.  There are limits to
the number of import tasks you can create (and delete) in an Amazon Web Services account.
For more information, see Amazon Web Services Application Discovery Service Limits in the
Amazon Web Services Application Discovery Service User Guide.

# Arguments
- `import_url`: The URL for your import file that you've uploaded to Amazon S3.  If you're
  using the Amazon Web Services CLI, this URL is structured as follows:
  s3://BucketName/ImportFileName.CSV
- `name`: A descriptive name for this request. You can use this name to filter future
  requests related to this import task, such as identifying applications and servers that
  were included in this import task. We recommend that you use a meaningful name for each
  import task.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientRequestToken"`: Optional. A unique token that you can provide to prevent the same
  import request from occurring more than once. If you don't provide a token, a token is
  automatically generated. Sending more than one StartImportTask request with the same client
  request token will return information about the original import task with that client
  request token.
"""
function start_import_task(
    importUrl, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_discovery_service(
        "StartImportTask",
        Dict{String,Any}(
            "importUrl" => importUrl,
            "name" => name,
            "clientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_import_task(
    importUrl,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_discovery_service(
        "StartImportTask",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "importUrl" => importUrl,
                    "name" => name,
                    "clientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_continuous_export(export_id)
    stop_continuous_export(export_id, params::Dict{String,<:Any})

Stop the continuous flow of agent's discovered data into Amazon Athena.

# Arguments
- `export_id`: The unique ID assigned to this export.

"""
function stop_continuous_export(
    exportId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_discovery_service(
        "StopContinuousExport",
        Dict{String,Any}("exportId" => exportId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_continuous_export(
    exportId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_discovery_service(
        "StopContinuousExport",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("exportId" => exportId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_data_collection_by_agent_ids(agent_ids)
    stop_data_collection_by_agent_ids(agent_ids, params::Dict{String,<:Any})

Instructs the specified agents to stop collecting data.

# Arguments
- `agent_ids`: The IDs of the agents from which to stop collecting data.

"""
function stop_data_collection_by_agent_ids(
    agentIds; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_discovery_service(
        "StopDataCollectionByAgentIds",
        Dict{String,Any}("agentIds" => agentIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_data_collection_by_agent_ids(
    agentIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_discovery_service(
        "StopDataCollectionByAgentIds",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("agentIds" => agentIds), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_application(configuration_id)
    update_application(configuration_id, params::Dict{String,<:Any})

Updates metadata about an application.

# Arguments
- `configuration_id`: Configuration ID of the application to be updated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: New description of the application to be updated.
- `"name"`: New name of the application to be updated.
"""
function update_application(
    configurationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_discovery_service(
        "UpdateApplication",
        Dict{String,Any}("configurationId" => configurationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_application(
    configurationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_discovery_service(
        "UpdateApplication",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("configurationId" => configurationId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: workmailmessageflow
using AWS.Compat
using AWS.UUIDs

"""
    get_raw_message_content(message_id)
    get_raw_message_content(message_id, params::Dict{String,<:Any})

Retrieves the raw content of an in-transit email message, in MIME format.

# Arguments
- `message_id`: The identifier of the email message to retrieve.

"""
function get_raw_message_content(
    messageId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmailmessageflow(
        "GET",
        "/messages/$(messageId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_raw_message_content(
    messageId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmailmessageflow(
        "GET",
        "/messages/$(messageId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_raw_message_content(content, message_id)
    put_raw_message_content(content, message_id, params::Dict{String,<:Any})

Updates the raw content of an in-transit email message, in MIME format. This example
describes how to update in-transit email message. For more information and examples for
using this API, see  Updating message content with AWS Lambda.  Updates to an in-transit
message only appear when you call PutRawMessageContent from an AWS Lambda function
configured with a synchronous  Run Lambda rule. If you call PutRawMessageContent on a
delivered or sent message, the message remains unchanged, even though GetRawMessageContent
returns an updated message.

# Arguments
- `content`: Describes the raw message content of the updated email message.
- `message_id`: The identifier of the email message being updated.

"""
function put_raw_message_content(
    content, messageId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmailmessageflow(
        "POST",
        "/messages/$(messageId)",
        Dict{String,Any}("content" => content);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_raw_message_content(
    content,
    messageId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmailmessageflow(
        "POST",
        "/messages/$(messageId)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("content" => content), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
Generate the `src/services/{service}.jl` file.
"""
function _generate_high_level_wrapper(
    service_files::AbstractArray{ServiceFile}, auth::GitHub.OAuth2
)
    service_dir = joinpath(@__DIR__, "..", "services")

    # Remove old service files to ensure services that no longer exist are removed.
    for file in readdir(service_dir)
        path = joinpath(service_dir, file)
        if endswith(path, ".jl")
            rm(path)
        end
    end

    Threads.@threads for service_file in service_files
        service_name = service_file.name
        @info "Generating high level wrapper for $service_name"
        service = service_definition(service_file; auth=auth)

        service_name = lowercase(service["metadata"]["serviceId"])
        service_name = replace(service_name, ' ' => '_')
        operations = service["operations"]
        shapes = service["shapes"]

        protocol = service["metadata"]["protocol"]

        operations = sort!(
            _generate_high_level_definitions(service_name, protocol, operations, shapes)
        )

        service_path = joinpath(service_dir, "$service_name.jl")
        open(service_path, "w") do f
            println(
                f,
                """
             # This file is auto-generated by AWSMetadata.jl
             using AWS
             using AWS.AWSServices: $service_name
             using AWS.Compat
             using AWS.UUIDs
             """,
            )
            join(f, operations, "\n")
        end
    end
end

"""
Generate high-level definitions for the `service`.
All high-level definitions and documentation to be written into `services/{Service}.jl`
"""
function _generate_high_level_definitions(
    service_name::String, protocol::String, operations::AbstractDict, shapes::AbstractDict
)
    operation_definitions = String[]

    for (_, operation) in operations
        name = operation["name"]
        method = operation["http"]["method"]
        request_uri = operation["http"]["requestUri"]

        documentation = ""

        if haskey(operation, "documentation")
            documentation = _clean_documentation(operation["documentation"])
        end

        required_parameters = Dict{String,Any}()
        optional_parameters = Dict{String,Any}()

        if haskey(operation, "input")
            required_parameters, optional_parameters = _get_function_parameters(
                operation["input"]["shape"], shapes
            )
        end

        operation_definition = _generate_high_level_definition(
            service_name,
            protocol,
            name,
            method,
            request_uri,
            required_parameters,
            optional_parameters,
            documentation,
        )

        push!(operation_definitions, operation_definition)
    end

    return operation_definitions
end

"""
Generate the high-level definition for a services function.
"""
function _generate_high_level_definition(
    service_name::String,
    protocol::String,
    name::String,
    method::String,
    request_uri::String,
    required_parameters::AbstractDict,
    optional_parameters::AbstractDict,
    documentation::String,
)
    """
    Generate function definition for a service request given required, header and idempotent parameters.
    """
    function _generate_rest_operation_defintion(
        required_params::AbstractDict,
        optional_params::AbstractDict,
        function_name::String,
        service_name::String,
        method::String,
        request_uri::String,
    )
        request_uri = replace(request_uri, '{' => "\$(")  # Replace { with $(
        request_uri = replace(request_uri, '}' => ')')  # Replace } with )
        request_uri = replace(request_uri, '+' => "")  # Remove + from the request URI

        # Pre Julia-1.3 workaround
        req_keys = [replace(key, "-" => "_") for key in collect(keys(required_params))]

        required_params = filter(p -> (p[2]["location"] != "uri"), required_params)
        header_params = filter(p -> (p[2]["location"] == "header"), required_params)
        required_params = setdiff(required_params, header_params)

        idempotent_params = filter(p -> (p[2]["idempotent"]), optional_params)

        req_kv = ["\"$(p[1])\"=>$(replace(p[1], "-" => "_"))" for p in required_params]
        header_kv = ["\"$(p[1])\"=>$(replace(p[1], "-" => "_"))" for p in header_params]
        idempotent_kv = ["\"$(p[1])\"=>string(uuid4())" for p in idempotent_params]

        required_keys = !isempty(req_keys)
        headers = !isempty(header_params)
        idempotent = !isempty(idempotent_params)

        req_str = !isempty(req_kv) ? "Dict{String, Any}($(join(req_kv, ", "))" : ""
        params_str = if (!isempty(req_kv) || idempotent)
            "$(join(vcat(req_kv, idempotent_kv), ", "))"
        else
            ""
        end
        headers_str =
            headers ? "\"headers\"=>Dict{String, Any}($(join(header_kv, ", ")))" : ""
        params_headers_str = "Dict{String, Any}($(join([s for s in (params_str, headers_str) if !isempty(s)], ", ")))"

        formatted_function_name = _format_name(function_name)

        if required_keys && (idempotent || headers)
            return """
                $formatted_function_name($(join(req_keys, ", ")); aws_config::AbstractAWSConfig=current_aws_config()) = $service_name(\"$method\", \"$request_uri\", $params_headers_str; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
                $formatted_function_name($(join(req_keys, ", ")), params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()) = $service_name(\"$method\", \"$request_uri\", Dict{String, Any}(mergewith(_merge, $params_headers_str, params)); aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
                """
        elseif !required_keys && (idempotent || headers)
            return """
                $formatted_function_name(; aws_config::AbstractAWSConfig=current_aws_config()) = $service_name(\"$method\", \"$request_uri\", $params_headers_str; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
                $formatted_function_name(params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()) = $service_name(\"$method\", \"$request_uri\", Dict{String, Any}(mergewith(_merge, $params_headers_str, params)); aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
                """
        elseif required_keys && !isempty(req_kv)
            return """
                $formatted_function_name($(join(req_keys, ", ")); aws_config::AbstractAWSConfig=current_aws_config()) = $service_name(\"$method\", \"$request_uri\", $req_str); aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
                $formatted_function_name($(join(req_keys, ", ")), params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()) = $service_name(\"$method\", \"$request_uri\", Dict{String, Any}(mergewith(_merge, $req_str), params)); aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
                """
        elseif required_keys
            return """
                $formatted_function_name($(join(req_keys, ", ")); aws_config::AbstractAWSConfig=current_aws_config()) = $service_name(\"$method\", \"$request_uri\"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
                $formatted_function_name($(join(req_keys, ", ")), params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()) = $service_name(\"$method\", \"$request_uri\", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
                """
        else
            return """
                $formatted_function_name(; aws_config::AbstractAWSConfig=current_aws_config()) = $service_name(\"$method\", \"$request_uri\"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
                $formatted_function_name(params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()) = $service_name(\"$method\", \"$request_uri\", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
                """
        end
    end

    """
    Generate a JSON/Query high level definition.
    """
    function _generate_json_query_opeation_definition(
        required_params::AbstractDict,
        optional_params::AbstractDict,
        function_name::String,
        service_name::String,
    )
        req_keys = [replace(key, '-' => '_') for key in collect(keys(required_params))]

        idempotent_params = filter(p -> (p[2]["idempotent"]), optional_params)

        req_kv = ["\"$(p[1])\"=>$(replace(p[1], "-" => "_"))" for p in required_params]
        idempotent_kv = ["\"$(p[1])\"=>string(uuid4())" for p in idempotent_params]

        required = !isempty(req_kv)
        idempotent = !isempty(idempotent_kv)

        formatted_function_name = _format_name(function_name)

        if required && idempotent
            return """
                $formatted_function_name($(join(req_keys, ", ")); aws_config::AbstractAWSConfig=current_aws_config()) = $service_name(\"$function_name\", Dict{String, Any}($(join(req_kv, ", ")), $(join(idempotent_kv, ", "))); aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
                $formatted_function_name($(join(req_keys, ", ")), params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()) = $service_name(\"$function_name\", Dict{String, Any}(mergewith(_merge, Dict{String, Any}($(join(req_kv, ", ")), $(join(idempotent_kv, ", "))), params)); aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
                """
        elseif required
            return """
                $formatted_function_name($(join(req_keys, ", ")); aws_config::AbstractAWSConfig=current_aws_config()) = $service_name(\"$function_name\", Dict{String, Any}($(join(req_kv, ", "))); aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
                $formatted_function_name($(join(req_keys, ", ")), params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()) = $service_name(\"$function_name\", Dict{String, Any}(mergewith(_merge, Dict{String, Any}($(join(req_kv, ", "))), params)); aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
                """
        elseif idempotent
            return """
                $formatted_function_name(; aws_config::AbstractAWSConfig=current_aws_config()) = $service_name(\"$function_name\", Dict{String, Any}($(join(idempotent_kv, ", "))); aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
                $formatted_function_name(params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()) = $service_name(\"$function_name\", Dict{String, Any}(mergewith(_merge, Dict{String, Any}($(join(idempotent_kv, ", "))), params)); aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
                """
        else
            return """
                $formatted_function_name(; aws_config::AbstractAWSConfig=current_aws_config()) = $service_name(\"$function_name\"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
                $formatted_function_name(params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()) = $service_name(\"$function_name\", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
                """
        end
    end

    """
    Generate the docstring for the `function_name`.
    """
    function _generate_docstring(
        function_name, documentation, required_parameters, optional_parameters
    )
        function_name = _format_name(function_name)
        args = join((_format_name(key) for (key, val) in required_parameters), ", ")
        maybejoin = isempty(args) ? "" : ", "
        operation_definition = """
            $(repeat('"', 3))
                $function_name($(args))
                $function_name($(args)$(maybejoin)params::Dict{String,<:Any})

            $(_wraplines(documentation))\n
            """

        # Add in the required parameters if applicable
        if !isempty(required_parameters)
            operation_definition *= "# Arguments\n"

            for (required_key, required_value) in required_parameters
                key = _format_name(required_key)
                operation_definition *= _wraplines(
                    "- `$key`: $(required_value["documentation"])"; delim="\n  "
                )
                operation_definition *= "\n"
            end

            operation_definition *= "\n"
        end

        # Add in the optional parameters if applicable
        if !isempty(optional_parameters)
            operation_definition *= """
                # Optional Parameters
                Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
                """

            for (optional_key, optional_value) in optional_parameters
                operation_definition *= _wraplines(
                    "- `\"$optional_key\"`: $(optional_value["documentation"])";
                    delim="\n  ",
                )
                operation_definition *= "\n"
            end
        end

        return operation_definition *= repeat('"', 3)
    end

    doc_string = _generate_docstring(
        name, documentation, required_parameters, optional_parameters
    )

    if protocol in ("json", "query", "ec2")
        function_string = _generate_json_query_opeation_definition(
            required_parameters, optional_parameters, name, service_name
        )
    elseif protocol in ("rest-json", "rest-xml")
        function_string = _generate_rest_operation_defintion(
            required_parameters,
            optional_parameters,
            name,
            service_name,
            method,
            request_uri,
        )
    else
        throw(
            ProtocolNotDefined(
                "$function_name is using a new protocol; $protocol which is not supported."
            ),
        )
    end

    return string(doc_string, '\n', function_string)
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: sagemaker_runtime
using AWS.Compat
using AWS.UUIDs

"""
    invoke_endpoint(body, endpoint_name)
    invoke_endpoint(body, endpoint_name, params::Dict{String,<:Any})

After you deploy a model into production using Amazon SageMaker hosting services, your
client applications use this API to get inferences from the model hosted at the specified
endpoint.  For an overview of Amazon SageMaker, see How It Works.  Amazon SageMaker strips
all POST headers except those supported by the API. Amazon SageMaker might add additional
headers. You should not rely on the behavior of headers outside those enumerated in the
request syntax.  Calls to InvokeEndpoint are authenticated by using Amazon Web Services
Signature Version 4. For information, see Authenticating Requests (Amazon Web Services
Signature Version 4) in the Amazon S3 API Reference. A customer's model containers must
respond to requests within 60 seconds. The model itself can have a maximum processing time
of 60 seconds before responding to invocations. If your model is going to take 50-60
seconds of processing time, the SDK socket timeout should be set to be 70 seconds.
Endpoints are scoped to an individual account, and are not public. The URL does not contain
the account ID, but Amazon SageMaker determines the account ID from the authentication
token that is supplied by the caller.

# Arguments
- `body`: Provides input data, in the format specified in the ContentType request header.
  Amazon SageMaker passes all of the data in the body to the model.  For information about
  the format of the request body, see Common Data Formats-Inference.
- `endpoint_name`: The name of the endpoint that you specified when you created the
  endpoint using the CreateEndpoint API.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Accept"`: The desired MIME type of the inference response from the model container.
- `"Content-Type"`: The MIME type of the input data in the request body.
- `"X-Amzn-SageMaker-Custom-Attributes"`: Provides additional information about a request
  for an inference submitted to a model hosted at an Amazon SageMaker endpoint. The
  information is an opaque value that is forwarded verbatim. You could use this value, for
  example, to provide an ID that you can use to track a request or to provide other metadata
  that a service endpoint was programmed to process. The value must consist of no more than
  1024 visible US-ASCII characters as specified in Section 3.3.6. Field Value Components of
  the Hypertext Transfer Protocol (HTTP/1.1).  The code in your model is responsible for
  setting or updating any custom attributes in the response. If your code does not set this
  value in the response, an empty value is returned. For example, if a custom attribute
  represents the trace ID, your model can prepend the custom attribute with Trace ID: in your
  post-processing function.  This feature is currently supported in the Amazon Web Services
  SDKs but not in the Amazon SageMaker Python SDK.
- `"X-Amzn-SageMaker-Enable-Explanations"`: An optional JMESPath expression used to
  override the EnableExplanations parameter of the ClarifyExplainerConfig API. See the
  EnableExplanations section in the developer guide for more information.
- `"X-Amzn-SageMaker-Inference-Component"`: If the endpoint hosts one or more inference
  components, this parameter specifies the name of inference component to invoke.
- `"X-Amzn-SageMaker-Inference-Id"`: If you provide a value, it is added to the captured
  data when you enable data capture on the endpoint. For information about data capture, see
  Capture Data.
- `"X-Amzn-SageMaker-Target-Container-Hostname"`: If the endpoint hosts multiple containers
  and is configured to use direct invocation, this parameter specifies the host name of the
  container to invoke.
- `"X-Amzn-SageMaker-Target-Model"`: The model to request for inference when invoking a
  multi-model endpoint.
- `"X-Amzn-SageMaker-Target-Variant"`: Specify the production variant to send the inference
  request to when invoking an endpoint that is running two or more variants. Note that this
  parameter overrides the default behavior for the endpoint, which is to distribute the
  invocation traffic based on the variant weights. For information about how to use variant
  targeting to perform a/b testing, see Test models in production
"""
function invoke_endpoint(
    Body, EndpointName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sagemaker_runtime(
        "POST",
        "/endpoints/$(EndpointName)/invocations",
        Dict{String,Any}("Body" => Body);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function invoke_endpoint(
    Body,
    EndpointName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sagemaker_runtime(
        "POST",
        "/endpoints/$(EndpointName)/invocations",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Body" => Body), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    invoke_endpoint_async(endpoint_name, x-_amzn-_sage_maker-_input_location)
    invoke_endpoint_async(endpoint_name, x-_amzn-_sage_maker-_input_location, params::Dict{String,<:Any})

After you deploy a model into production using Amazon SageMaker hosting services, your
client applications use this API to get inferences from the model hosted at the specified
endpoint in an asynchronous manner. Inference requests sent to this API are enqueued for
asynchronous processing. The processing of the inference request may or may not complete
before you receive a response from this API. The response from this API will not contain
the result of the inference request but contain information about where you can locate it.
Amazon SageMaker strips all POST headers except those supported by the API. Amazon
SageMaker might add additional headers. You should not rely on the behavior of headers
outside those enumerated in the request syntax.  Calls to InvokeEndpointAsync are
authenticated by using Amazon Web Services Signature Version 4. For information, see
Authenticating Requests (Amazon Web Services Signature Version 4) in the Amazon S3 API
Reference.

# Arguments
- `endpoint_name`: The name of the endpoint that you specified when you created the
  endpoint using the CreateEndpoint API.
- `x-_amzn-_sage_maker-_input_location`: The Amazon S3 URI where the inference request
  payload is stored.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"X-Amzn-SageMaker-Accept"`: The desired MIME type of the inference response from the
  model container.
- `"X-Amzn-SageMaker-Content-Type"`: The MIME type of the input data in the request body.
- `"X-Amzn-SageMaker-Custom-Attributes"`: Provides additional information about a request
  for an inference submitted to a model hosted at an Amazon SageMaker endpoint. The
  information is an opaque value that is forwarded verbatim. You could use this value, for
  example, to provide an ID that you can use to track a request or to provide other metadata
  that a service endpoint was programmed to process. The value must consist of no more than
  1024 visible US-ASCII characters as specified in Section 3.3.6. Field Value Components of
  the Hypertext Transfer Protocol (HTTP/1.1).  The code in your model is responsible for
  setting or updating any custom attributes in the response. If your code does not set this
  value in the response, an empty value is returned. For example, if a custom attribute
  represents the trace ID, your model can prepend the custom attribute with Trace ID: in your
  post-processing function.  This feature is currently supported in the Amazon Web Services
  SDKs but not in the Amazon SageMaker Python SDK.
- `"X-Amzn-SageMaker-Inference-Id"`: The identifier for the inference request. Amazon
  SageMaker will generate an identifier for you if none is specified.
- `"X-Amzn-SageMaker-InvocationTimeoutSeconds"`: Maximum amount of time in seconds a
  request can be processed before it is marked as expired. The default is 15 minutes, or 900
  seconds.
- `"X-Amzn-SageMaker-RequestTTLSeconds"`: Maximum age in seconds a request can be in the
  queue before it is marked as expired. The default is 6 hours, or 21,600 seconds.
"""
function invoke_endpoint_async(
    EndpointName,
    X_Amzn_SageMaker_InputLocation;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sagemaker_runtime(
        "POST",
        "/endpoints/$(EndpointName)/async-invocations",
        Dict{String,Any}(
            "headers" => Dict{String,Any}(
                "X-Amzn-SageMaker-InputLocation" => X_Amzn_SageMaker_InputLocation
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function invoke_endpoint_async(
    EndpointName,
    X_Amzn_SageMaker_InputLocation,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sagemaker_runtime(
        "POST",
        "/endpoints/$(EndpointName)/async-invocations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "headers" => Dict{String,Any}(
                        "X-Amzn-SageMaker-InputLocation" =>
                            X_Amzn_SageMaker_InputLocation,
                    ),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    invoke_endpoint_with_response_stream(body, endpoint_name)
    invoke_endpoint_with_response_stream(body, endpoint_name, params::Dict{String,<:Any})

Invokes a model at the specified endpoint to return the inference response as a stream. The
inference stream provides the response payload incrementally as a series of parts. Before
you can get an inference stream, you must have access to a model that's deployed using
Amazon SageMaker hosting services, and the container for that model must support inference
streaming. For more information that can help you use this API, see the following sections
in the Amazon SageMaker Developer Guide:   For information about how to add streaming
support to a model, see How Containers Serve Requests.   For information about how to
process the streaming response, see Invoke real-time endpoints.   Before you can use this
operation, your IAM permissions must allow the sagemaker:InvokeEndpoint action. For more
information about Amazon SageMaker actions for IAM policies, see Actions, resources, and
condition keys for Amazon SageMaker in the IAM Service Authorization Reference. Amazon
SageMaker strips all POST headers except those supported by the API. Amazon SageMaker might
add additional headers. You should not rely on the behavior of headers outside those
enumerated in the request syntax.  Calls to InvokeEndpointWithResponseStream are
authenticated by using Amazon Web Services Signature Version 4. For information, see
Authenticating Requests (Amazon Web Services Signature Version 4) in the Amazon S3 API
Reference.

# Arguments
- `body`: Provides input data, in the format specified in the ContentType request header.
  Amazon SageMaker passes all of the data in the body to the model.  For information about
  the format of the request body, see Common Data Formats-Inference.
- `endpoint_name`: The name of the endpoint that you specified when you created the
  endpoint using the CreateEndpoint API.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Content-Type"`: The MIME type of the input data in the request body.
- `"X-Amzn-SageMaker-Accept"`: The desired MIME type of the inference response from the
  model container.
- `"X-Amzn-SageMaker-Custom-Attributes"`: Provides additional information about a request
  for an inference submitted to a model hosted at an Amazon SageMaker endpoint. The
  information is an opaque value that is forwarded verbatim. You could use this value, for
  example, to provide an ID that you can use to track a request or to provide other metadata
  that a service endpoint was programmed to process. The value must consist of no more than
  1024 visible US-ASCII characters as specified in Section 3.3.6. Field Value Components of
  the Hypertext Transfer Protocol (HTTP/1.1).  The code in your model is responsible for
  setting or updating any custom attributes in the response. If your code does not set this
  value in the response, an empty value is returned. For example, if a custom attribute
  represents the trace ID, your model can prepend the custom attribute with Trace ID: in your
  post-processing function.  This feature is currently supported in the Amazon Web Services
  SDKs but not in the Amazon SageMaker Python SDK.
- `"X-Amzn-SageMaker-Inference-Component"`: If the endpoint hosts one or more inference
  components, this parameter specifies the name of inference component to invoke for a
  streaming response.
- `"X-Amzn-SageMaker-Inference-Id"`: An identifier that you assign to your request.
- `"X-Amzn-SageMaker-Target-Container-Hostname"`: If the endpoint hosts multiple containers
  and is configured to use direct invocation, this parameter specifies the host name of the
  container to invoke.
- `"X-Amzn-SageMaker-Target-Variant"`: Specify the production variant to send the inference
  request to when invoking an endpoint that is running two or more variants. Note that this
  parameter overrides the default behavior for the endpoint, which is to distribute the
  invocation traffic based on the variant weights. For information about how to use variant
  targeting to perform a/b testing, see Test models in production
"""
function invoke_endpoint_with_response_stream(
    Body, EndpointName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sagemaker_runtime(
        "POST",
        "/endpoints/$(EndpointName)/invocations-response-stream",
        Dict{String,Any}("Body" => Body);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function invoke_endpoint_with_response_stream(
    Body,
    EndpointName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sagemaker_runtime(
        "POST",
        "/endpoints/$(EndpointName)/invocations-response-stream",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Body" => Body), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: global_accelerator
using AWS.Compat
using AWS.UUIDs

"""
    add_custom_routing_endpoints(endpoint_configurations, endpoint_group_arn)
    add_custom_routing_endpoints(endpoint_configurations, endpoint_group_arn, params::Dict{String,<:Any})

Associate a virtual private cloud (VPC) subnet endpoint with your custom routing
accelerator. The listener port range must be large enough to support the number of IP
addresses that can be specified in your subnet. The number of ports required is: subnet
size times the number of ports per destination EC2 instances. For example, a subnet defined
as /24 requires a listener port range of at least 255 ports.  Note: You must have enough
remaining listener ports available to map to the subnet ports, or the call will fail with a
LimitExceededException. By default, all destinations in a subnet in a custom routing
accelerator cannot receive traffic. To enable all destinations to receive traffic, or to
specify individual port mappings that can receive traffic, see the
AllowCustomRoutingTraffic operation.

# Arguments
- `endpoint_configurations`: The list of endpoint objects to add to a custom routing
  accelerator.
- `endpoint_group_arn`: The Amazon Resource Name (ARN) of the endpoint group for the custom
  routing endpoint.

"""
function add_custom_routing_endpoints(
    EndpointConfigurations,
    EndpointGroupArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return global_accelerator(
        "AddCustomRoutingEndpoints",
        Dict{String,Any}(
            "EndpointConfigurations" => EndpointConfigurations,
            "EndpointGroupArn" => EndpointGroupArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_custom_routing_endpoints(
    EndpointConfigurations,
    EndpointGroupArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return global_accelerator(
        "AddCustomRoutingEndpoints",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EndpointConfigurations" => EndpointConfigurations,
                    "EndpointGroupArn" => EndpointGroupArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    add_endpoints(endpoint_configurations, endpoint_group_arn)
    add_endpoints(endpoint_configurations, endpoint_group_arn, params::Dict{String,<:Any})

Add endpoints to an endpoint group. The AddEndpoints API operation is the recommended
option for adding endpoints. The alternative options are to add endpoints when you create
an endpoint group (with the CreateEndpointGroup API) or when you update an endpoint group
(with the UpdateEndpointGroup API).  There are two advantages to using AddEndpoints to add
endpoints in Global Accelerator:   It's faster, because Global Accelerator only has to
resolve the new endpoints that you're adding, rather than resolving new and existing
endpoints.   It's more convenient, because you don't need to specify the current endpoints
that are already in the endpoint group, in addition to the new endpoints that you want to
add.   For information about endpoint types and requirements for endpoints that you can add
to Global Accelerator, see  Endpoints for standard accelerators in the Global Accelerator
Developer Guide.

# Arguments
- `endpoint_configurations`: The list of endpoint objects.
- `endpoint_group_arn`: The Amazon Resource Name (ARN) of the endpoint group.

"""
function add_endpoints(
    EndpointConfigurations,
    EndpointGroupArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return global_accelerator(
        "AddEndpoints",
        Dict{String,Any}(
            "EndpointConfigurations" => EndpointConfigurations,
            "EndpointGroupArn" => EndpointGroupArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_endpoints(
    EndpointConfigurations,
    EndpointGroupArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return global_accelerator(
        "AddEndpoints",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EndpointConfigurations" => EndpointConfigurations,
                    "EndpointGroupArn" => EndpointGroupArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    advertise_byoip_cidr(cidr)
    advertise_byoip_cidr(cidr, params::Dict{String,<:Any})

Advertises an IPv4 address range that is provisioned for use with your Amazon Web Services
resources through bring your own IP addresses (BYOIP). It can take a few minutes before
traffic to the specified addresses starts routing to Amazon Web Services because of
propagation delays.  To stop advertising the BYOIP address range, use  WithdrawByoipCidr.
For more information, see Bring your own IP addresses (BYOIP) in the Global Accelerator
Developer Guide.

# Arguments
- `cidr`: The address range, in CIDR notation. This must be the exact range that you
  provisioned. You can't advertise only a portion of the provisioned range.  For more
  information, see Bring your own IP addresses (BYOIP) in the Global Accelerator Developer
  Guide.

"""
function advertise_byoip_cidr(Cidr; aws_config::AbstractAWSConfig=current_aws_config())
    return global_accelerator(
        "AdvertiseByoipCidr",
        Dict{String,Any}("Cidr" => Cidr);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function advertise_byoip_cidr(
    Cidr, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return global_accelerator(
        "AdvertiseByoipCidr",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Cidr" => Cidr), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    allow_custom_routing_traffic(endpoint_group_arn, endpoint_id)
    allow_custom_routing_traffic(endpoint_group_arn, endpoint_id, params::Dict{String,<:Any})

Specify the Amazon EC2 instance (destination) IP addresses and ports for a VPC subnet
endpoint that can receive traffic for a custom routing accelerator. You can allow traffic
to all destinations in the subnet endpoint, or allow traffic to a specified list of
destination IP addresses and ports in the subnet. Note that you cannot specify IP addresses
or ports outside of the range that you configured for the endpoint group. After you make
changes, you can verify that the updates are complete by checking the status of your
accelerator: the status changes from IN_PROGRESS to DEPLOYED.

# Arguments
- `endpoint_group_arn`: The Amazon Resource Name (ARN) of the endpoint group.
- `endpoint_id`: An ID for the endpoint. For custom routing accelerators, this is the
  virtual private cloud (VPC) subnet ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AllowAllTrafficToEndpoint"`: Indicates whether all destination IP addresses and ports
  for a specified VPC subnet endpoint can receive traffic from a custom routing accelerator.
  The value is TRUE or FALSE.  When set to TRUE, all destinations in the custom routing VPC
  subnet can receive traffic. Note that you cannot specify destination IP addresses and ports
  when the value is set to TRUE. When set to FALSE (or not specified), you must specify a
  list of destination IP addresses that are allowed to receive traffic. A list of ports is
  optional. If you don't specify a list of ports, the ports that can accept traffic is the
  same as the ports configured for the endpoint group. The default value is FALSE.
- `"DestinationAddresses"`: A list of specific Amazon EC2 instance IP addresses
  (destination addresses) in a subnet that you want to allow to receive traffic. The IP
  addresses must be a subset of the IP addresses that you specified for the endpoint group.
  DestinationAddresses is required if AllowAllTrafficToEndpoint is FALSE or is not specified.
- `"DestinationPorts"`: A list of specific Amazon EC2 instance ports (destination ports)
  that you want to allow to receive traffic.
"""
function allow_custom_routing_traffic(
    EndpointGroupArn, EndpointId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return global_accelerator(
        "AllowCustomRoutingTraffic",
        Dict{String,Any}(
            "EndpointGroupArn" => EndpointGroupArn, "EndpointId" => EndpointId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function allow_custom_routing_traffic(
    EndpointGroupArn,
    EndpointId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return global_accelerator(
        "AllowCustomRoutingTraffic",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EndpointGroupArn" => EndpointGroupArn, "EndpointId" => EndpointId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_accelerator(idempotency_token, name)
    create_accelerator(idempotency_token, name, params::Dict{String,<:Any})

Create an accelerator. An accelerator includes one or more listeners that process inbound
connections and direct traffic to one or more endpoint groups, each of which includes
endpoints, such as Network Load Balancers.   Global Accelerator is a global service that
supports endpoints in multiple Amazon Web Services Regions but you must specify the US West
(Oregon) Region to create, update, or otherwise work with accelerators. That is, for
example, specify --region us-west-2 on Amazon Web Services CLI commands.

# Arguments
- `idempotency_token`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency—that is, the uniqueness—of an accelerator.
- `name`: The name of the accelerator. The name can have a maximum of 64 characters, must
  contain only alphanumeric characters, periods (.), or hyphens (-), and must not begin or
  end with a hyphen or period.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Enabled"`: Indicates whether an accelerator is enabled. The value is true or false. The
  default value is true.  If the value is set to true, an accelerator cannot be deleted. If
  set to false, the accelerator can be deleted.
- `"IpAddressType"`: The IP address type that an accelerator supports. For a standard
  accelerator, the value can be IPV4 or DUAL_STACK.
- `"IpAddresses"`: Optionally, if you've added your own IP address pool to Global
  Accelerator (BYOIP), you can choose an IPv4 address from your own pool to use for the
  accelerator's static IPv4 address when you create an accelerator.  After you bring an
  address range to Amazon Web Services, it appears in your account as an address pool. When
  you create an accelerator, you can assign one IPv4 address from your range to it. Global
  Accelerator assigns you a second static IPv4 address from an Amazon IP address range. If
  you bring two IPv4 address ranges to Amazon Web Services, you can assign one IPv4 address
  from each range to your accelerator. This restriction is because Global Accelerator assigns
  each address range to a different network zone, for high availability. You can specify one
  or two addresses, separated by a space. Do not include the /32 suffix. Note that you can't
  update IP addresses for an existing accelerator. To change them, you must create a new
  accelerator with the new addresses. For more information, see Bring your own IP addresses
  (BYOIP) in the Global Accelerator Developer Guide.
- `"Tags"`: Create tags for an accelerator. For more information, see Tagging in Global
  Accelerator in the Global Accelerator Developer Guide.
"""
function create_accelerator(
    IdempotencyToken, Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return global_accelerator(
        "CreateAccelerator",
        Dict{String,Any}("IdempotencyToken" => IdempotencyToken, "Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_accelerator(
    IdempotencyToken,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return global_accelerator(
        "CreateAccelerator",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("IdempotencyToken" => IdempotencyToken, "Name" => Name),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_cross_account_attachment(idempotency_token, name)
    create_cross_account_attachment(idempotency_token, name, params::Dict{String,<:Any})

Create a cross-account attachment in Global Accelerator. You create a cross-account
attachment to specify the principals who have permission to work with resources in
accelerators in their own account. You specify, in the same attachment, the resources that
are shared. A principal can be an Amazon Web Services account number or the Amazon Resource
Name (ARN) for an accelerator. For account numbers that are listed as principals, to work
with a resource listed in the attachment, you must sign in to an account specified as a
principal. Then, you can work with resources that are listed, with any of your
accelerators. If an accelerator ARN is listed in the cross-account attachment as a
principal, anyone with permission to make updates to the accelerator can work with
resources that are listed in the attachment.  Specify each principal and resource
separately. To specify two CIDR address pools, list them individually under Resources, and
so on. For a command line operation, for example, you might use a statement like the
following:   \"Resources\": [{\"Cidr\": \"169.254.60.0/24\"},{\"Cidr\":
\"169.254.59.0/24\"}]  For more information, see  Working with cross-account attachments
and resources in Global Accelerator in the  Global Accelerator Developer Guide.

# Arguments
- `idempotency_token`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency—that is, the uniqueness—of the request.
- `name`: The name of the cross-account attachment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Principals"`: The principals to include in the cross-account attachment. A principal
  can be an Amazon Web Services account number or the Amazon Resource Name (ARN) for an
  accelerator.
- `"Resources"`: The Amazon Resource Names (ARNs) for the resources to include in the
  cross-account attachment. A resource can be any supported Amazon Web Services resource type
  for Global Accelerator or a CIDR range for a bring your own IP address (BYOIP) address
  pool.
- `"Tags"`: Add tags for a cross-account attachment. For more information, see Tagging in
  Global Accelerator in the Global Accelerator Developer Guide.
"""
function create_cross_account_attachment(
    IdempotencyToken, Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return global_accelerator(
        "CreateCrossAccountAttachment",
        Dict{String,Any}("IdempotencyToken" => IdempotencyToken, "Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_cross_account_attachment(
    IdempotencyToken,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return global_accelerator(
        "CreateCrossAccountAttachment",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("IdempotencyToken" => IdempotencyToken, "Name" => Name),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_custom_routing_accelerator(idempotency_token, name)
    create_custom_routing_accelerator(idempotency_token, name, params::Dict{String,<:Any})

Create a custom routing accelerator. A custom routing accelerator directs traffic to one of
possibly thousands of Amazon EC2 instance destinations running in a single or multiple
virtual private clouds (VPC) subnet endpoints. Be aware that, by default, all destination
EC2 instances in a VPC subnet endpoint cannot receive traffic. To enable all destinations
to receive traffic, or to specify individual port mappings that can receive traffic, see
the  AllowCustomRoutingTraffic operation.  Global Accelerator is a global service that
supports endpoints in multiple Amazon Web Services Regions but you must specify the US West
(Oregon) Region to create, update, or otherwise work with accelerators. That is, for
example, specify --region us-west-2 on Amazon Web Services CLI commands.

# Arguments
- `idempotency_token`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency—that is, the uniqueness—of the request.
- `name`: The name of a custom routing accelerator. The name can have a maximum of 64
  characters, must contain only alphanumeric characters or hyphens (-), and must not begin or
  end with a hyphen.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Enabled"`: Indicates whether an accelerator is enabled. The value is true or false. The
  default value is true.  If the value is set to true, an accelerator cannot be deleted. If
  set to false, the accelerator can be deleted.
- `"IpAddressType"`: The IP address type that an accelerator supports. For a custom routing
  accelerator, the value must be IPV4.
- `"IpAddresses"`: Optionally, if you've added your own IP address pool to Global
  Accelerator (BYOIP), you can choose an IPv4 address from your own pool to use for the
  accelerator's static IPv4 address when you create an accelerator.  After you bring an
  address range to Amazon Web Services, it appears in your account as an address pool. When
  you create an accelerator, you can assign one IPv4 address from your range to it. Global
  Accelerator assigns you a second static IPv4 address from an Amazon IP address range. If
  you bring two IPv4 address ranges to Amazon Web Services, you can assign one IPv4 address
  from each range to your accelerator. This restriction is because Global Accelerator assigns
  each address range to a different network zone, for high availability. You can specify one
  or two addresses, separated by a space. Do not include the /32 suffix. Note that you can't
  update IP addresses for an existing accelerator. To change them, you must create a new
  accelerator with the new addresses. For more information, see Bring your own IP addresses
  (BYOIP) in the Global Accelerator Developer Guide.
- `"Tags"`: Create tags for an accelerator. For more information, see Tagging in Global
  Accelerator in the Global Accelerator Developer Guide.
"""
function create_custom_routing_accelerator(
    IdempotencyToken, Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return global_accelerator(
        "CreateCustomRoutingAccelerator",
        Dict{String,Any}("IdempotencyToken" => IdempotencyToken, "Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_custom_routing_accelerator(
    IdempotencyToken,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return global_accelerator(
        "CreateCustomRoutingAccelerator",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("IdempotencyToken" => IdempotencyToken, "Name" => Name),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_custom_routing_endpoint_group(destination_configurations, endpoint_group_region, idempotency_token, listener_arn)
    create_custom_routing_endpoint_group(destination_configurations, endpoint_group_region, idempotency_token, listener_arn, params::Dict{String,<:Any})

Create an endpoint group for the specified listener for a custom routing accelerator. An
endpoint group is a collection of endpoints in one Amazon Web Services Region.

# Arguments
- `destination_configurations`: Sets the port range and protocol for all endpoints (virtual
  private cloud subnets) in a custom routing endpoint group to accept client traffic on.
- `endpoint_group_region`: The Amazon Web Services Region where the endpoint group is
  located. A listener can have only one endpoint group in a specific Region.
- `idempotency_token`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency—that is, the uniqueness—of the request.
- `listener_arn`: The Amazon Resource Name (ARN) of the listener for a custom routing
  endpoint.

"""
function create_custom_routing_endpoint_group(
    DestinationConfigurations,
    EndpointGroupRegion,
    IdempotencyToken,
    ListenerArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return global_accelerator(
        "CreateCustomRoutingEndpointGroup",
        Dict{String,Any}(
            "DestinationConfigurations" => DestinationConfigurations,
            "EndpointGroupRegion" => EndpointGroupRegion,
            "IdempotencyToken" => IdempotencyToken,
            "ListenerArn" => ListenerArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_custom_routing_endpoint_group(
    DestinationConfigurations,
    EndpointGroupRegion,
    IdempotencyToken,
    ListenerArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return global_accelerator(
        "CreateCustomRoutingEndpointGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DestinationConfigurations" => DestinationConfigurations,
                    "EndpointGroupRegion" => EndpointGroupRegion,
                    "IdempotencyToken" => IdempotencyToken,
                    "ListenerArn" => ListenerArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_custom_routing_listener(accelerator_arn, idempotency_token, port_ranges)
    create_custom_routing_listener(accelerator_arn, idempotency_token, port_ranges, params::Dict{String,<:Any})

Create a listener to process inbound connections from clients to a custom routing
accelerator. Connections arrive to assigned static IP addresses on the port range that you
specify.

# Arguments
- `accelerator_arn`: The Amazon Resource Name (ARN) of the accelerator for a custom routing
  listener.
- `idempotency_token`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency—that is, the uniqueness—of the request.
- `port_ranges`: The port range to support for connections from clients to your
  accelerator. Separately, you set port ranges for endpoints. For more information, see About
  endpoints for custom routing accelerators.

"""
function create_custom_routing_listener(
    AcceleratorArn,
    IdempotencyToken,
    PortRanges;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return global_accelerator(
        "CreateCustomRoutingListener",
        Dict{String,Any}(
            "AcceleratorArn" => AcceleratorArn,
            "IdempotencyToken" => IdempotencyToken,
            "PortRanges" => PortRanges,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_custom_routing_listener(
    AcceleratorArn,
    IdempotencyToken,
    PortRanges,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return global_accelerator(
        "CreateCustomRoutingListener",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AcceleratorArn" => AcceleratorArn,
                    "IdempotencyToken" => IdempotencyToken,
                    "PortRanges" => PortRanges,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_endpoint_group(endpoint_group_region, idempotency_token, listener_arn)
    create_endpoint_group(endpoint_group_region, idempotency_token, listener_arn, params::Dict{String,<:Any})

Create an endpoint group for the specified listener. An endpoint group is a collection of
endpoints in one Amazon Web Services Region. A resource must be valid and active when you
add it as an endpoint. For more information about endpoint types and requirements for
endpoints that you can add to Global Accelerator, see  Endpoints for standard accelerators
in the Global Accelerator Developer Guide.

# Arguments
- `endpoint_group_region`: The Amazon Web Services Region where the endpoint group is
  located. A listener can have only one endpoint group in a specific Region.
- `idempotency_token`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency—that is, the uniqueness—of the request.
- `listener_arn`: The Amazon Resource Name (ARN) of the listener.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EndpointConfigurations"`: The list of endpoint objects.
- `"HealthCheckIntervalSeconds"`: The time—10 seconds or 30 seconds—between each health
  check for an endpoint. The default value is 30.
- `"HealthCheckPath"`: If the protocol is HTTP/S, then this specifies the path that is the
  destination for health check targets. The default value is slash (/).
- `"HealthCheckPort"`: The port that Global Accelerator uses to check the health of
  endpoints that are part of this endpoint group. The default port is the listener port that
  this endpoint group is associated with. If listener port is a list of ports, Global
  Accelerator uses the first port in the list.
- `"HealthCheckProtocol"`: The protocol that Global Accelerator uses to check the health of
  endpoints that are part of this endpoint group. The default value is TCP.
- `"PortOverrides"`: Override specific listener ports used to route traffic to endpoints
  that are part of this endpoint group. For example, you can create a port override in which
  the listener receives user traffic on ports 80 and 443, but your accelerator routes that
  traffic to ports 1080 and 1443, respectively, on the endpoints. For more information, see
  Overriding listener ports in the Global Accelerator Developer Guide.
- `"ThresholdCount"`: The number of consecutive health checks required to set the state of
  a healthy endpoint to unhealthy, or to set an unhealthy endpoint to healthy. The default
  value is 3.
- `"TrafficDialPercentage"`: The percentage of traffic to send to an Amazon Web Services
  Region. Additional traffic is distributed to other endpoint groups for this listener.  Use
  this action to increase (dial up) or decrease (dial down) traffic to a specific Region. The
  percentage is applied to the traffic that would otherwise have been routed to the Region
  based on optimal routing. The default value is 100.
"""
function create_endpoint_group(
    EndpointGroupRegion,
    IdempotencyToken,
    ListenerArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return global_accelerator(
        "CreateEndpointGroup",
        Dict{String,Any}(
            "EndpointGroupRegion" => EndpointGroupRegion,
            "IdempotencyToken" => IdempotencyToken,
            "ListenerArn" => ListenerArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_endpoint_group(
    EndpointGroupRegion,
    IdempotencyToken,
    ListenerArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return global_accelerator(
        "CreateEndpointGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EndpointGroupRegion" => EndpointGroupRegion,
                    "IdempotencyToken" => IdempotencyToken,
                    "ListenerArn" => ListenerArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_listener(accelerator_arn, idempotency_token, port_ranges, protocol)
    create_listener(accelerator_arn, idempotency_token, port_ranges, protocol, params::Dict{String,<:Any})

Create a listener to process inbound connections from clients to an accelerator.
Connections arrive to assigned static IP addresses on a port, port range, or list of port
ranges that you specify.

# Arguments
- `accelerator_arn`: The Amazon Resource Name (ARN) of your accelerator.
- `idempotency_token`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency—that is, the uniqueness—of the request.
- `port_ranges`: The list of port ranges to support for connections from clients to your
  accelerator.
- `protocol`: The protocol for connections from clients to your accelerator.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientAffinity"`: Client affinity lets you direct all requests from a user to the same
  endpoint, if you have stateful applications, regardless of the port and protocol of the
  client request. Client affinity gives you control over whether to always route each client
  to the same specific endpoint. Global Accelerator uses a consistent-flow hashing algorithm
  to choose the optimal endpoint for a connection. If client affinity is NONE, Global
  Accelerator uses the \"five-tuple\" (5-tuple) properties—source IP address, source port,
  destination IP address, destination port, and protocol—to select the hash value, and then
  chooses the best endpoint. However, with this setting, if someone uses different ports to
  connect to Global Accelerator, their connections might not be always routed to the same
  endpoint because the hash value changes.  If you want a given client to always be routed to
  the same endpoint, set client affinity to SOURCE_IP instead. When you use the SOURCE_IP
  setting, Global Accelerator uses the \"two-tuple\" (2-tuple) properties— source (client)
  IP address and destination IP address—to select the hash value. The default value is NONE.
"""
function create_listener(
    AcceleratorArn,
    IdempotencyToken,
    PortRanges,
    Protocol;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return global_accelerator(
        "CreateListener",
        Dict{String,Any}(
            "AcceleratorArn" => AcceleratorArn,
            "IdempotencyToken" => IdempotencyToken,
            "PortRanges" => PortRanges,
            "Protocol" => Protocol,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_listener(
    AcceleratorArn,
    IdempotencyToken,
    PortRanges,
    Protocol,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return global_accelerator(
        "CreateListener",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AcceleratorArn" => AcceleratorArn,
                    "IdempotencyToken" => IdempotencyToken,
                    "PortRanges" => PortRanges,
                    "Protocol" => Protocol,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_accelerator(accelerator_arn)
    delete_accelerator(accelerator_arn, params::Dict{String,<:Any})

Delete an accelerator. Before you can delete an accelerator, you must disable it and remove
all dependent resources (listeners and endpoint groups). To disable the accelerator, update
the accelerator to set Enabled to false.  When you create an accelerator, by default,
Global Accelerator provides you with a set of two static IP addresses. Alternatively, you
can bring your own IP address ranges to Global Accelerator and assign IP addresses from
those ranges.  The IP addresses are assigned to your accelerator for as long as it exists,
even if you disable the accelerator and it no longer accepts or routes traffic. However,
when you delete an accelerator, you lose the static IP addresses that are assigned to the
accelerator, so you can no longer route traffic by using them. As a best practice, ensure
that you have permissions in place to avoid inadvertently deleting accelerators. You can
use IAM policies with Global Accelerator to limit the users who have permissions to delete
an accelerator. For more information, see Identity and access management in the Global
Accelerator Developer Guide.

# Arguments
- `accelerator_arn`: The Amazon Resource Name (ARN) of an accelerator.

"""
function delete_accelerator(
    AcceleratorArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return global_accelerator(
        "DeleteAccelerator",
        Dict{String,Any}("AcceleratorArn" => AcceleratorArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_accelerator(
    AcceleratorArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return global_accelerator(
        "DeleteAccelerator",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AcceleratorArn" => AcceleratorArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_cross_account_attachment(attachment_arn)
    delete_cross_account_attachment(attachment_arn, params::Dict{String,<:Any})

Delete a cross-account attachment. When you delete an attachment, Global Accelerator
revokes the permission to use the resources in the attachment from all principals in the
list of principals. Global Accelerator revokes the permission for specific resources. For
more information, see  Working with cross-account attachments and resources in Global
Accelerator in the  Global Accelerator Developer Guide.

# Arguments
- `attachment_arn`: The Amazon Resource Name (ARN) for the cross-account attachment to
  delete.

"""
function delete_cross_account_attachment(
    AttachmentArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return global_accelerator(
        "DeleteCrossAccountAttachment",
        Dict{String,Any}("AttachmentArn" => AttachmentArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_cross_account_attachment(
    AttachmentArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return global_accelerator(
        "DeleteCrossAccountAttachment",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AttachmentArn" => AttachmentArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_custom_routing_accelerator(accelerator_arn)
    delete_custom_routing_accelerator(accelerator_arn, params::Dict{String,<:Any})

Delete a custom routing accelerator. Before you can delete an accelerator, you must disable
it and remove all dependent resources (listeners and endpoint groups). To disable the
accelerator, update the accelerator to set Enabled to false.  When you create a custom
routing accelerator, by default, Global Accelerator provides you with a set of two static
IP addresses.  The IP addresses are assigned to your accelerator for as long as it exists,
even if you disable the accelerator and it no longer accepts or routes traffic. However,
when you delete an accelerator, you lose the static IP addresses that are assigned to the
accelerator, so you can no longer route traffic by using them. As a best practice, ensure
that you have permissions in place to avoid inadvertently deleting accelerators. You can
use IAM policies with Global Accelerator to limit the users who have permissions to delete
an accelerator. For more information, see Identity and access management in the Global
Accelerator Developer Guide.

# Arguments
- `accelerator_arn`: The Amazon Resource Name (ARN) of the custom routing accelerator to
  delete.

"""
function delete_custom_routing_accelerator(
    AcceleratorArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return global_accelerator(
        "DeleteCustomRoutingAccelerator",
        Dict{String,Any}("AcceleratorArn" => AcceleratorArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_custom_routing_accelerator(
    AcceleratorArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return global_accelerator(
        "DeleteCustomRoutingAccelerator",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AcceleratorArn" => AcceleratorArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_custom_routing_endpoint_group(endpoint_group_arn)
    delete_custom_routing_endpoint_group(endpoint_group_arn, params::Dict{String,<:Any})

Delete an endpoint group from a listener for a custom routing accelerator.

# Arguments
- `endpoint_group_arn`: The Amazon Resource Name (ARN) of the endpoint group to delete.

"""
function delete_custom_routing_endpoint_group(
    EndpointGroupArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return global_accelerator(
        "DeleteCustomRoutingEndpointGroup",
        Dict{String,Any}("EndpointGroupArn" => EndpointGroupArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_custom_routing_endpoint_group(
    EndpointGroupArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return global_accelerator(
        "DeleteCustomRoutingEndpointGroup",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("EndpointGroupArn" => EndpointGroupArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_custom_routing_listener(listener_arn)
    delete_custom_routing_listener(listener_arn, params::Dict{String,<:Any})

Delete a listener for a custom routing accelerator.

# Arguments
- `listener_arn`: The Amazon Resource Name (ARN) of the listener to delete.

"""
function delete_custom_routing_listener(
    ListenerArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return global_accelerator(
        "DeleteCustomRoutingListener",
        Dict{String,Any}("ListenerArn" => ListenerArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_custom_routing_listener(
    ListenerArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return global_accelerator(
        "DeleteCustomRoutingListener",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ListenerArn" => ListenerArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_endpoint_group(endpoint_group_arn)
    delete_endpoint_group(endpoint_group_arn, params::Dict{String,<:Any})

Delete an endpoint group from a listener.

# Arguments
- `endpoint_group_arn`: The Amazon Resource Name (ARN) of the endpoint group to delete.

"""
function delete_endpoint_group(
    EndpointGroupArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return global_accelerator(
        "DeleteEndpointGroup",
        Dict{String,Any}("EndpointGroupArn" => EndpointGroupArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_endpoint_group(
    EndpointGroupArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return global_accelerator(
        "DeleteEndpointGroup",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("EndpointGroupArn" => EndpointGroupArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_listener(listener_arn)
    delete_listener(listener_arn, params::Dict{String,<:Any})

Delete a listener from an accelerator.

# Arguments
- `listener_arn`: The Amazon Resource Name (ARN) of the listener.

"""
function delete_listener(ListenerArn; aws_config::AbstractAWSConfig=current_aws_config())
    return global_accelerator(
        "DeleteListener",
        Dict{String,Any}("ListenerArn" => ListenerArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_listener(
    ListenerArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return global_accelerator(
        "DeleteListener",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ListenerArn" => ListenerArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    deny_custom_routing_traffic(endpoint_group_arn, endpoint_id)
    deny_custom_routing_traffic(endpoint_group_arn, endpoint_id, params::Dict{String,<:Any})

Specify the Amazon EC2 instance (destination) IP addresses and ports for a VPC subnet
endpoint that cannot receive traffic for a custom routing accelerator. You can deny traffic
to all destinations in the VPC endpoint, or deny traffic to a specified list of destination
IP addresses and ports. Note that you cannot specify IP addresses or ports outside of the
range that you configured for the endpoint group. After you make changes, you can verify
that the updates are complete by checking the status of your accelerator: the status
changes from IN_PROGRESS to DEPLOYED.

# Arguments
- `endpoint_group_arn`: The Amazon Resource Name (ARN) of the endpoint group.
- `endpoint_id`: An ID for the endpoint. For custom routing accelerators, this is the
  virtual private cloud (VPC) subnet ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DenyAllTrafficToEndpoint"`: Indicates whether all destination IP addresses and ports
  for a specified VPC subnet endpoint cannot receive traffic from a custom routing
  accelerator. The value is TRUE or FALSE.  When set to TRUE, no destinations in the custom
  routing VPC subnet can receive traffic. Note that you cannot specify destination IP
  addresses and ports when the value is set to TRUE. When set to FALSE (or not specified),
  you must specify a list of destination IP addresses that cannot receive traffic. A list of
  ports is optional. If you don't specify a list of ports, the ports that can accept traffic
  is the same as the ports configured for the endpoint group. The default value is FALSE.
- `"DestinationAddresses"`: A list of specific Amazon EC2 instance IP addresses
  (destination addresses) in a subnet that you want to prevent from receiving traffic. The IP
  addresses must be a subset of the IP addresses allowed for the VPC subnet associated with
  the endpoint group.
- `"DestinationPorts"`: A list of specific Amazon EC2 instance ports (destination ports) in
  a subnet endpoint that you want to prevent from receiving traffic.
"""
function deny_custom_routing_traffic(
    EndpointGroupArn, EndpointId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return global_accelerator(
        "DenyCustomRoutingTraffic",
        Dict{String,Any}(
            "EndpointGroupArn" => EndpointGroupArn, "EndpointId" => EndpointId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function deny_custom_routing_traffic(
    EndpointGroupArn,
    EndpointId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return global_accelerator(
        "DenyCustomRoutingTraffic",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EndpointGroupArn" => EndpointGroupArn, "EndpointId" => EndpointId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    deprovision_byoip_cidr(cidr)
    deprovision_byoip_cidr(cidr, params::Dict{String,<:Any})

Releases the specified address range that you provisioned to use with your Amazon Web
Services resources through bring your own IP addresses (BYOIP) and deletes the
corresponding address pool.  Before you can release an address range, you must stop
advertising it by using WithdrawByoipCidr and you must not have any accelerators that are
using static IP addresses allocated from its address range.  For more information, see
Bring your own IP addresses (BYOIP) in the Global Accelerator Developer Guide.

# Arguments
- `cidr`: The address range, in CIDR notation. The prefix must be the same prefix that you
  specified when you provisioned the address range.  For more information, see Bring your own
  IP addresses (BYOIP) in the Global Accelerator Developer Guide.

"""
function deprovision_byoip_cidr(Cidr; aws_config::AbstractAWSConfig=current_aws_config())
    return global_accelerator(
        "DeprovisionByoipCidr",
        Dict{String,Any}("Cidr" => Cidr);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function deprovision_byoip_cidr(
    Cidr, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return global_accelerator(
        "DeprovisionByoipCidr",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Cidr" => Cidr), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_accelerator(accelerator_arn)
    describe_accelerator(accelerator_arn, params::Dict{String,<:Any})

Describe an accelerator.

# Arguments
- `accelerator_arn`: The Amazon Resource Name (ARN) of the accelerator to describe.

"""
function describe_accelerator(
    AcceleratorArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return global_accelerator(
        "DescribeAccelerator",
        Dict{String,Any}("AcceleratorArn" => AcceleratorArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_accelerator(
    AcceleratorArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return global_accelerator(
        "DescribeAccelerator",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AcceleratorArn" => AcceleratorArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_accelerator_attributes(accelerator_arn)
    describe_accelerator_attributes(accelerator_arn, params::Dict{String,<:Any})

Describe the attributes of an accelerator.

# Arguments
- `accelerator_arn`: The Amazon Resource Name (ARN) of the accelerator with the attributes
  that you want to describe.

"""
function describe_accelerator_attributes(
    AcceleratorArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return global_accelerator(
        "DescribeAcceleratorAttributes",
        Dict{String,Any}("AcceleratorArn" => AcceleratorArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_accelerator_attributes(
    AcceleratorArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return global_accelerator(
        "DescribeAcceleratorAttributes",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AcceleratorArn" => AcceleratorArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_cross_account_attachment(attachment_arn)
    describe_cross_account_attachment(attachment_arn, params::Dict{String,<:Any})

Gets configuration information about a cross-account attachment.

# Arguments
- `attachment_arn`: The Amazon Resource Name (ARN) for the cross-account attachment to
  describe.

"""
function describe_cross_account_attachment(
    AttachmentArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return global_accelerator(
        "DescribeCrossAccountAttachment",
        Dict{String,Any}("AttachmentArn" => AttachmentArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_cross_account_attachment(
    AttachmentArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return global_accelerator(
        "DescribeCrossAccountAttachment",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AttachmentArn" => AttachmentArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_custom_routing_accelerator(accelerator_arn)
    describe_custom_routing_accelerator(accelerator_arn, params::Dict{String,<:Any})

Describe a custom routing accelerator.

# Arguments
- `accelerator_arn`: The Amazon Resource Name (ARN) of the accelerator to describe.

"""
function describe_custom_routing_accelerator(
    AcceleratorArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return global_accelerator(
        "DescribeCustomRoutingAccelerator",
        Dict{String,Any}("AcceleratorArn" => AcceleratorArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_custom_routing_accelerator(
    AcceleratorArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return global_accelerator(
        "DescribeCustomRoutingAccelerator",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AcceleratorArn" => AcceleratorArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_custom_routing_accelerator_attributes(accelerator_arn)
    describe_custom_routing_accelerator_attributes(accelerator_arn, params::Dict{String,<:Any})

Describe the attributes of a custom routing accelerator.

# Arguments
- `accelerator_arn`: The Amazon Resource Name (ARN) of the custom routing accelerator to
  describe the attributes for.

"""
function describe_custom_routing_accelerator_attributes(
    AcceleratorArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return global_accelerator(
        "DescribeCustomRoutingAcceleratorAttributes",
        Dict{String,Any}("AcceleratorArn" => AcceleratorArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_custom_routing_accelerator_attributes(
    AcceleratorArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return global_accelerator(
        "DescribeCustomRoutingAcceleratorAttributes",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AcceleratorArn" => AcceleratorArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_custom_routing_endpoint_group(endpoint_group_arn)
    describe_custom_routing_endpoint_group(endpoint_group_arn, params::Dict{String,<:Any})

Describe an endpoint group for a custom routing accelerator.

# Arguments
- `endpoint_group_arn`: The Amazon Resource Name (ARN) of the endpoint group to describe.

"""
function describe_custom_routing_endpoint_group(
    EndpointGroupArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return global_accelerator(
        "DescribeCustomRoutingEndpointGroup",
        Dict{String,Any}("EndpointGroupArn" => EndpointGroupArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_custom_routing_endpoint_group(
    EndpointGroupArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return global_accelerator(
        "DescribeCustomRoutingEndpointGroup",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("EndpointGroupArn" => EndpointGroupArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_custom_routing_listener(listener_arn)
    describe_custom_routing_listener(listener_arn, params::Dict{String,<:Any})

The description of a listener for a custom routing accelerator.

# Arguments
- `listener_arn`: The Amazon Resource Name (ARN) of the listener to describe.

"""
function describe_custom_routing_listener(
    ListenerArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return global_accelerator(
        "DescribeCustomRoutingListener",
        Dict{String,Any}("ListenerArn" => ListenerArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_custom_routing_listener(
    ListenerArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return global_accelerator(
        "DescribeCustomRoutingListener",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ListenerArn" => ListenerArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_endpoint_group(endpoint_group_arn)
    describe_endpoint_group(endpoint_group_arn, params::Dict{String,<:Any})

Describe an endpoint group.

# Arguments
- `endpoint_group_arn`: The Amazon Resource Name (ARN) of the endpoint group to describe.

"""
function describe_endpoint_group(
    EndpointGroupArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return global_accelerator(
        "DescribeEndpointGroup",
        Dict{String,Any}("EndpointGroupArn" => EndpointGroupArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_endpoint_group(
    EndpointGroupArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return global_accelerator(
        "DescribeEndpointGroup",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("EndpointGroupArn" => EndpointGroupArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_listener(listener_arn)
    describe_listener(listener_arn, params::Dict{String,<:Any})

Describe a listener.

# Arguments
- `listener_arn`: The Amazon Resource Name (ARN) of the listener to describe.

"""
function describe_listener(ListenerArn; aws_config::AbstractAWSConfig=current_aws_config())
    return global_accelerator(
        "DescribeListener",
        Dict{String,Any}("ListenerArn" => ListenerArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_listener(
    ListenerArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return global_accelerator(
        "DescribeListener",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ListenerArn" => ListenerArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_accelerators()
    list_accelerators(params::Dict{String,<:Any})

List the accelerators for an Amazon Web Services account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The number of Global Accelerator objects that you want to return with
  this call. The default value is 10.
- `"NextToken"`: The token for the next set of results. You receive this token from a
  previous call.
"""
function list_accelerators(; aws_config::AbstractAWSConfig=current_aws_config())
    return global_accelerator(
        "ListAccelerators"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_accelerators(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return global_accelerator(
        "ListAccelerators", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_byoip_cidrs()
    list_byoip_cidrs(params::Dict{String,<:Any})

Lists the IP address ranges that were specified in calls to ProvisionByoipCidr, including
the current state and a history of state changes.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to return with a single call. To retrieve
  the remaining results, make another call with the returned nextToken value.
- `"NextToken"`: The token for the next page of results.
"""
function list_byoip_cidrs(; aws_config::AbstractAWSConfig=current_aws_config())
    return global_accelerator(
        "ListByoipCidrs"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_byoip_cidrs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return global_accelerator(
        "ListByoipCidrs", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_cross_account_attachments()
    list_cross_account_attachments(params::Dict{String,<:Any})

List the cross-account attachments that have been created in Global Accelerator.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The number of cross-account attachment objects that you want to return
  with this call. The default value is 10.
- `"NextToken"`: The token for the next set of results. You receive this token from a
  previous call.
"""
function list_cross_account_attachments(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return global_accelerator(
        "ListCrossAccountAttachments";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_cross_account_attachments(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return global_accelerator(
        "ListCrossAccountAttachments",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_cross_account_resource_accounts()
    list_cross_account_resource_accounts(params::Dict{String,<:Any})

List the accounts that have cross-account resources. For more information, see  Working
with cross-account attachments and resources in Global Accelerator in the  Global
Accelerator Developer Guide.

"""
function list_cross_account_resource_accounts(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return global_accelerator(
        "ListCrossAccountResourceAccounts";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_cross_account_resource_accounts(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return global_accelerator(
        "ListCrossAccountResourceAccounts",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_cross_account_resources(resource_owner_aws_account_id)
    list_cross_account_resources(resource_owner_aws_account_id, params::Dict{String,<:Any})

List the cross-account resources available to work with.

# Arguments
- `resource_owner_aws_account_id`: The account ID of a resource owner in a cross-account
  attachment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceleratorArn"`: The Amazon Resource Name (ARN) of an accelerator in a cross-account
  attachment.
- `"MaxResults"`: The number of cross-account resource objects that you want to return with
  this call. The default value is 10.
- `"NextToken"`: The token for the next set of results. You receive this token from a
  previous call.
"""
function list_cross_account_resources(
    ResourceOwnerAwsAccountId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return global_accelerator(
        "ListCrossAccountResources",
        Dict{String,Any}("ResourceOwnerAwsAccountId" => ResourceOwnerAwsAccountId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_cross_account_resources(
    ResourceOwnerAwsAccountId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return global_accelerator(
        "ListCrossAccountResources",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceOwnerAwsAccountId" => ResourceOwnerAwsAccountId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_custom_routing_accelerators()
    list_custom_routing_accelerators(params::Dict{String,<:Any})

List the custom routing accelerators for an Amazon Web Services account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The number of custom routing Global Accelerator objects that you want to
  return with this call. The default value is 10.
- `"NextToken"`: The token for the next set of results. You receive this token from a
  previous call.
"""
function list_custom_routing_accelerators(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return global_accelerator(
        "ListCustomRoutingAccelerators";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_custom_routing_accelerators(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return global_accelerator(
        "ListCustomRoutingAccelerators",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_custom_routing_endpoint_groups(listener_arn)
    list_custom_routing_endpoint_groups(listener_arn, params::Dict{String,<:Any})

List the endpoint groups that are associated with a listener for a custom routing
accelerator.

# Arguments
- `listener_arn`: The Amazon Resource Name (ARN) of the listener to list endpoint groups
  for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The number of endpoint group objects that you want to return with this
  call. The default value is 10.
- `"NextToken"`: The token for the next set of results. You receive this token from a
  previous call.
"""
function list_custom_routing_endpoint_groups(
    ListenerArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return global_accelerator(
        "ListCustomRoutingEndpointGroups",
        Dict{String,Any}("ListenerArn" => ListenerArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_custom_routing_endpoint_groups(
    ListenerArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return global_accelerator(
        "ListCustomRoutingEndpointGroups",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ListenerArn" => ListenerArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_custom_routing_listeners(accelerator_arn)
    list_custom_routing_listeners(accelerator_arn, params::Dict{String,<:Any})

List the listeners for a custom routing accelerator.

# Arguments
- `accelerator_arn`: The Amazon Resource Name (ARN) of the accelerator to list listeners
  for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The number of listener objects that you want to return with this call.
  The default value is 10.
- `"NextToken"`: The token for the next set of results. You receive this token from a
  previous call.
"""
function list_custom_routing_listeners(
    AcceleratorArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return global_accelerator(
        "ListCustomRoutingListeners",
        Dict{String,Any}("AcceleratorArn" => AcceleratorArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_custom_routing_listeners(
    AcceleratorArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return global_accelerator(
        "ListCustomRoutingListeners",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AcceleratorArn" => AcceleratorArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_custom_routing_port_mappings(accelerator_arn)
    list_custom_routing_port_mappings(accelerator_arn, params::Dict{String,<:Any})

Provides a complete mapping from the public accelerator IP address and port to destination
EC2 instance IP addresses and ports in the virtual public cloud (VPC) subnet endpoint for a
custom routing accelerator. For each subnet endpoint that you add, Global Accelerator
creates a new static port mapping for the accelerator. The port mappings don't change after
Global Accelerator generates them, so you can retrieve and cache the full mapping on your
servers.  If you remove a subnet from your accelerator, Global Accelerator removes
(reclaims) the port mappings. If you add a subnet to your accelerator, Global Accelerator
creates new port mappings (the existing ones don't change). If you add or remove EC2
instances in your subnet, the port mappings don't change, because the mappings are created
when you add the subnet to Global Accelerator. The mappings also include a flag for each
destination denoting which destination IP addresses and ports are allowed or denied traffic.

# Arguments
- `accelerator_arn`: The Amazon Resource Name (ARN) of the accelerator to list the custom
  routing port mappings for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EndpointGroupArn"`: The Amazon Resource Name (ARN) of the endpoint group to list the
  custom routing port mappings for.
- `"MaxResults"`: The number of destination port mappings that you want to return with this
  call. The default value is 10.
- `"NextToken"`: The token for the next set of results. You receive this token from a
  previous call.
"""
function list_custom_routing_port_mappings(
    AcceleratorArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return global_accelerator(
        "ListCustomRoutingPortMappings",
        Dict{String,Any}("AcceleratorArn" => AcceleratorArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_custom_routing_port_mappings(
    AcceleratorArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return global_accelerator(
        "ListCustomRoutingPortMappings",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AcceleratorArn" => AcceleratorArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_custom_routing_port_mappings_by_destination(destination_address, endpoint_id)
    list_custom_routing_port_mappings_by_destination(destination_address, endpoint_id, params::Dict{String,<:Any})

List the port mappings for a specific EC2 instance (destination) in a VPC subnet endpoint.
The response is the mappings for one destination IP address. This is useful when your
subnet endpoint has mappings that span multiple custom routing accelerators in your
account, or for scenarios where you only want to list the port mappings for a specific
destination instance.

# Arguments
- `destination_address`: The endpoint IP address in a virtual private cloud (VPC) subnet
  for which you want to receive back port mappings.
- `endpoint_id`: The ID for the virtual private cloud (VPC) subnet.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The number of destination port mappings that you want to return with this
  call. The default value is 10.
- `"NextToken"`: The token for the next set of results. You receive this token from a
  previous call.
"""
function list_custom_routing_port_mappings_by_destination(
    DestinationAddress, EndpointId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return global_accelerator(
        "ListCustomRoutingPortMappingsByDestination",
        Dict{String,Any}(
            "DestinationAddress" => DestinationAddress, "EndpointId" => EndpointId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_custom_routing_port_mappings_by_destination(
    DestinationAddress,
    EndpointId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return global_accelerator(
        "ListCustomRoutingPortMappingsByDestination",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DestinationAddress" => DestinationAddress, "EndpointId" => EndpointId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_endpoint_groups(listener_arn)
    list_endpoint_groups(listener_arn, params::Dict{String,<:Any})

List the endpoint groups that are associated with a listener.

# Arguments
- `listener_arn`: The Amazon Resource Name (ARN) of the listener.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The number of endpoint group objects that you want to return with this
  call. The default value is 10.
- `"NextToken"`: The token for the next set of results. You receive this token from a
  previous call.
"""
function list_endpoint_groups(
    ListenerArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return global_accelerator(
        "ListEndpointGroups",
        Dict{String,Any}("ListenerArn" => ListenerArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_endpoint_groups(
    ListenerArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return global_accelerator(
        "ListEndpointGroups",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ListenerArn" => ListenerArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_listeners(accelerator_arn)
    list_listeners(accelerator_arn, params::Dict{String,<:Any})

List the listeners for an accelerator.

# Arguments
- `accelerator_arn`: The Amazon Resource Name (ARN) of the accelerator for which you want
  to list listener objects.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The number of listener objects that you want to return with this call.
  The default value is 10.
- `"NextToken"`: The token for the next set of results. You receive this token from a
  previous call.
"""
function list_listeners(AcceleratorArn; aws_config::AbstractAWSConfig=current_aws_config())
    return global_accelerator(
        "ListListeners",
        Dict{String,Any}("AcceleratorArn" => AcceleratorArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_listeners(
    AcceleratorArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return global_accelerator(
        "ListListeners",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AcceleratorArn" => AcceleratorArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

List all tags for an accelerator.  For more information, see Tagging in Global Accelerator
in the Global Accelerator Developer Guide.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the accelerator to list tags for. An
  ARN uniquely identifies an accelerator.

"""
function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return global_accelerator(
        "ListTagsForResource",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return global_accelerator(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    provision_byoip_cidr(cidr, cidr_authorization_context)
    provision_byoip_cidr(cidr, cidr_authorization_context, params::Dict{String,<:Any})

Provisions an IP address range to use with your Amazon Web Services resources through bring
your own IP addresses (BYOIP) and creates a corresponding address pool. After the address
range is provisioned, it is ready to be advertised using  AdvertiseByoipCidr. For more
information, see Bring your own IP addresses (BYOIP) in the Global Accelerator Developer
Guide.

# Arguments
- `cidr`: The public IPv4 address range, in CIDR notation. The most specific IP prefix that
  you can specify is /24. The address range cannot overlap with another address range that
  you've brought to this Amazon Web Services Region or another Region.  For more information,
  see Bring your own IP addresses (BYOIP) in the Global Accelerator Developer Guide.
- `cidr_authorization_context`: A signed document that proves that you are authorized to
  bring the specified IP address range to Amazon using BYOIP.

"""
function provision_byoip_cidr(
    Cidr, CidrAuthorizationContext; aws_config::AbstractAWSConfig=current_aws_config()
)
    return global_accelerator(
        "ProvisionByoipCidr",
        Dict{String,Any}(
            "Cidr" => Cidr, "CidrAuthorizationContext" => CidrAuthorizationContext
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function provision_byoip_cidr(
    Cidr,
    CidrAuthorizationContext,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return global_accelerator(
        "ProvisionByoipCidr",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Cidr" => Cidr, "CidrAuthorizationContext" => CidrAuthorizationContext
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_custom_routing_endpoints(endpoint_group_arn, endpoint_ids)
    remove_custom_routing_endpoints(endpoint_group_arn, endpoint_ids, params::Dict{String,<:Any})

Remove endpoints from a custom routing accelerator.

# Arguments
- `endpoint_group_arn`: The Amazon Resource Name (ARN) of the endpoint group to remove
  endpoints from.
- `endpoint_ids`: The IDs for the endpoints. For custom routing accelerators, endpoint IDs
  are the virtual private cloud (VPC) subnet IDs.

"""
function remove_custom_routing_endpoints(
    EndpointGroupArn, EndpointIds; aws_config::AbstractAWSConfig=current_aws_config()
)
    return global_accelerator(
        "RemoveCustomRoutingEndpoints",
        Dict{String,Any}(
            "EndpointGroupArn" => EndpointGroupArn, "EndpointIds" => EndpointIds
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_custom_routing_endpoints(
    EndpointGroupArn,
    EndpointIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return global_accelerator(
        "RemoveCustomRoutingEndpoints",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EndpointGroupArn" => EndpointGroupArn, "EndpointIds" => EndpointIds
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_endpoints(endpoint_group_arn, endpoint_identifiers)
    remove_endpoints(endpoint_group_arn, endpoint_identifiers, params::Dict{String,<:Any})

Remove endpoints from an endpoint group.  The RemoveEndpoints API operation is the
recommended option for removing endpoints. The alternative is to remove endpoints by
updating an endpoint group by using the UpdateEndpointGroup API operation. There are two
advantages to using AddEndpoints to remove endpoints instead:   It's more convenient,
because you only need to specify the endpoints that you want to remove. With the
UpdateEndpointGroup API operation, you must specify all of the endpoints in the endpoint
group except the ones that you want to remove from the group.   It's faster, because Global
Accelerator doesn't need to resolve any endpoints. With the UpdateEndpointGroup API
operation, Global Accelerator must resolve all of the endpoints that remain in the group.

# Arguments
- `endpoint_group_arn`: The Amazon Resource Name (ARN) of the endpoint group.
- `endpoint_identifiers`: The identifiers of the endpoints that you want to remove.

"""
function remove_endpoints(
    EndpointGroupArn,
    EndpointIdentifiers;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return global_accelerator(
        "RemoveEndpoints",
        Dict{String,Any}(
            "EndpointGroupArn" => EndpointGroupArn,
            "EndpointIdentifiers" => EndpointIdentifiers,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_endpoints(
    EndpointGroupArn,
    EndpointIdentifiers,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return global_accelerator(
        "RemoveEndpoints",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EndpointGroupArn" => EndpointGroupArn,
                    "EndpointIdentifiers" => EndpointIdentifiers,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Add tags to an accelerator resource.  For more information, see Tagging in Global
Accelerator in the Global Accelerator Developer Guide.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the Global Accelerator resource to add
  tags to. An ARN uniquely identifies a resource.
- `tags`: The tags to add to a resource. A tag consists of a key and a value that you
  define.

"""
function tag_resource(ResourceArn, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return global_accelerator(
        "TagResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceArn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return global_accelerator(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Remove tags from a Global Accelerator resource. When you specify a tag key, the action
removes both that key and its associated value. The operation succeeds even if you attempt
to remove tags from an accelerator that was already removed. For more information, see
Tagging in Global Accelerator in the Global Accelerator Developer Guide.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the Global Accelerator resource to
  remove tags from. An ARN uniquely identifies a resource.
- `tag_keys`: The tag key pairs that you want to remove from the specified resources.

"""
function untag_resource(
    ResourceArn, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return global_accelerator(
        "UntagResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceArn,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return global_accelerator(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_accelerator(accelerator_arn)
    update_accelerator(accelerator_arn, params::Dict{String,<:Any})

Update an accelerator to make changes, such as the following:    Change the name of the
accelerator.   Disable the accelerator so that it no longer accepts or routes traffic, or
so that you can delete it.   Enable the accelerator, if it is disabled.   Change the IP
address type to dual-stack if it is IPv4, or change the IP address type to IPv4 if it's
dual-stack.   Be aware that static IP addresses remain assigned to your accelerator for as
long as it exists, even if you disable the accelerator and it no longer accepts or routes
traffic. However, when you delete the accelerator, you lose the static IP addresses that
are assigned to it, so you can no longer route traffic by using them.  Global Accelerator
is a global service that supports endpoints in multiple Amazon Web Services Regions but you
must specify the US West (Oregon) Region to create, update, or otherwise work with
accelerators. That is, for example, specify --region us-west-2 on Amazon Web Services CLI
commands.

# Arguments
- `accelerator_arn`: The Amazon Resource Name (ARN) of the accelerator to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Enabled"`: Indicates whether an accelerator is enabled. The value is true or false. The
  default value is true.  If the value is set to true, the accelerator cannot be deleted. If
  set to false, the accelerator can be deleted.
- `"IpAddressType"`: The IP address type that an accelerator supports. For a standard
  accelerator, the value can be IPV4 or DUAL_STACK.
- `"IpAddresses"`: The IP addresses for an accelerator.
- `"Name"`: The name of the accelerator. The name can have a maximum of 64 characters, must
  contain only alphanumeric characters, periods (.), or hyphens (-), and must not begin or
  end with a hyphen or period.
"""
function update_accelerator(
    AcceleratorArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return global_accelerator(
        "UpdateAccelerator",
        Dict{String,Any}("AcceleratorArn" => AcceleratorArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_accelerator(
    AcceleratorArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return global_accelerator(
        "UpdateAccelerator",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AcceleratorArn" => AcceleratorArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_accelerator_attributes(accelerator_arn)
    update_accelerator_attributes(accelerator_arn, params::Dict{String,<:Any})

Update the attributes for an accelerator.

# Arguments
- `accelerator_arn`: The Amazon Resource Name (ARN) of the accelerator that you want to
  update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FlowLogsEnabled"`: Update whether flow logs are enabled. The default value is false. If
  the value is true, FlowLogsS3Bucket and FlowLogsS3Prefix must be specified. For more
  information, see Flow Logs in the Global Accelerator Developer Guide.
- `"FlowLogsS3Bucket"`: The name of the Amazon S3 bucket for the flow logs. Attribute is
  required if FlowLogsEnabled is true. The bucket must exist and have a bucket policy that
  grants Global Accelerator permission to write to the bucket.
- `"FlowLogsS3Prefix"`: Update the prefix for the location in the Amazon S3 bucket for the
  flow logs. Attribute is required if FlowLogsEnabled is true.  If you specify slash (/) for
  the S3 bucket prefix, the log file bucket folder structure will include a double slash
  (//), like the following: s3-bucket_name//AWSLogs/aws_account_id
"""
function update_accelerator_attributes(
    AcceleratorArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return global_accelerator(
        "UpdateAcceleratorAttributes",
        Dict{String,Any}("AcceleratorArn" => AcceleratorArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_accelerator_attributes(
    AcceleratorArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return global_accelerator(
        "UpdateAcceleratorAttributes",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AcceleratorArn" => AcceleratorArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_cross_account_attachment(attachment_arn)
    update_cross_account_attachment(attachment_arn, params::Dict{String,<:Any})

Update a cross-account attachment to add or remove principals or resources. When you update
an attachment to remove a principal (account ID or accelerator) or a resource, Global
Accelerator revokes the permission for specific resources.  For more information, see
Working with cross-account attachments and resources in Global Accelerator in the  Global
Accelerator Developer Guide.

# Arguments
- `attachment_arn`: The Amazon Resource Name (ARN) of the cross-account attachment to
  update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AddPrincipals"`: The principals to add to the cross-account attachment. A principal is
  an account or the Amazon Resource Name (ARN) of an accelerator that the attachment gives
  permission to work with resources from another account. The resources are also listed in
  the attachment. To add more than one principal, separate the account numbers or accelerator
  ARNs, or both, with commas.
- `"AddResources"`: The resources to add to the cross-account attachment. A resource listed
  in a cross-account attachment can be used with an accelerator by the principals that are
  listed in the attachment. To add more than one resource, separate the resource ARNs with
  commas.
- `"Name"`: The name of the cross-account attachment.
- `"RemovePrincipals"`: The principals to remove from the cross-account attachment. A
  principal is an account or the Amazon Resource Name (ARN) of an accelerator that the
  attachment gives permission to work with resources from another account. The resources are
  also listed in the attachment. To remove more than one principal, separate the account
  numbers or accelerator ARNs, or both, with commas.
- `"RemoveResources"`: The resources to remove from the cross-account attachment. A
  resource listed in a cross-account attachment can be used with an accelerator by the
  principals that are listed in the attachment. To remove more than one resource, separate
  the resource ARNs with commas.
"""
function update_cross_account_attachment(
    AttachmentArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return global_accelerator(
        "UpdateCrossAccountAttachment",
        Dict{String,Any}("AttachmentArn" => AttachmentArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_cross_account_attachment(
    AttachmentArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return global_accelerator(
        "UpdateCrossAccountAttachment",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AttachmentArn" => AttachmentArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_custom_routing_accelerator(accelerator_arn)
    update_custom_routing_accelerator(accelerator_arn, params::Dict{String,<:Any})

Update a custom routing accelerator.

# Arguments
- `accelerator_arn`: The Amazon Resource Name (ARN) of the accelerator to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Enabled"`: Indicates whether an accelerator is enabled. The value is true or false. The
  default value is true.  If the value is set to true, the accelerator cannot be deleted. If
  set to false, the accelerator can be deleted.
- `"IpAddressType"`: The IP address type that an accelerator supports. For a custom routing
  accelerator, the value must be IPV4.
- `"IpAddresses"`: The IP addresses for an accelerator.
- `"Name"`: The name of the accelerator. The name can have a maximum of 64 characters, must
  contain only alphanumeric characters, periods (.), or hyphens (-), and must not begin or
  end with a hyphen or period.
"""
function update_custom_routing_accelerator(
    AcceleratorArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return global_accelerator(
        "UpdateCustomRoutingAccelerator",
        Dict{String,Any}("AcceleratorArn" => AcceleratorArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_custom_routing_accelerator(
    AcceleratorArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return global_accelerator(
        "UpdateCustomRoutingAccelerator",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AcceleratorArn" => AcceleratorArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_custom_routing_accelerator_attributes(accelerator_arn)
    update_custom_routing_accelerator_attributes(accelerator_arn, params::Dict{String,<:Any})

Update the attributes for a custom routing accelerator.

# Arguments
- `accelerator_arn`: The Amazon Resource Name (ARN) of the custom routing accelerator to
  update attributes for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FlowLogsEnabled"`: Update whether flow logs are enabled. The default value is false. If
  the value is true, FlowLogsS3Bucket and FlowLogsS3Prefix must be specified. For more
  information, see Flow logs in the Global Accelerator Developer Guide.
- `"FlowLogsS3Bucket"`: The name of the Amazon S3 bucket for the flow logs. Attribute is
  required if FlowLogsEnabled is true. The bucket must exist and have a bucket policy that
  grants Global Accelerator permission to write to the bucket.
- `"FlowLogsS3Prefix"`: Update the prefix for the location in the Amazon S3 bucket for the
  flow logs. Attribute is required if FlowLogsEnabled is true.  If you don’t specify a
  prefix, the flow logs are stored in the root of the bucket. If you specify slash (/) for
  the S3 bucket prefix, the log file bucket folder structure will include a double slash
  (//), like the following: DOC-EXAMPLE-BUCKET//AWSLogs/aws_account_id
"""
function update_custom_routing_accelerator_attributes(
    AcceleratorArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return global_accelerator(
        "UpdateCustomRoutingAcceleratorAttributes",
        Dict{String,Any}("AcceleratorArn" => AcceleratorArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_custom_routing_accelerator_attributes(
    AcceleratorArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return global_accelerator(
        "UpdateCustomRoutingAcceleratorAttributes",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AcceleratorArn" => AcceleratorArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_custom_routing_listener(listener_arn, port_ranges)
    update_custom_routing_listener(listener_arn, port_ranges, params::Dict{String,<:Any})

Update a listener for a custom routing accelerator.

# Arguments
- `listener_arn`: The Amazon Resource Name (ARN) of the listener to update.
- `port_ranges`: The updated port range to support for connections from clients to your
  accelerator. If you remove ports that are currently being used by a subnet endpoint, the
  call fails. Separately, you set port ranges for endpoints. For more information, see About
  endpoints for custom routing accelerators.

"""
function update_custom_routing_listener(
    ListenerArn, PortRanges; aws_config::AbstractAWSConfig=current_aws_config()
)
    return global_accelerator(
        "UpdateCustomRoutingListener",
        Dict{String,Any}("ListenerArn" => ListenerArn, "PortRanges" => PortRanges);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_custom_routing_listener(
    ListenerArn,
    PortRanges,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return global_accelerator(
        "UpdateCustomRoutingListener",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ListenerArn" => ListenerArn, "PortRanges" => PortRanges),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_endpoint_group(endpoint_group_arn)
    update_endpoint_group(endpoint_group_arn, params::Dict{String,<:Any})

Update an endpoint group. A resource must be valid and active when you add it as an
endpoint.

# Arguments
- `endpoint_group_arn`: The Amazon Resource Name (ARN) of the endpoint group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EndpointConfigurations"`: The list of endpoint objects. A resource must be valid and
  active when you add it as an endpoint.
- `"HealthCheckIntervalSeconds"`: The time—10 seconds or 30 seconds—between each health
  check for an endpoint. The default value is 30.
- `"HealthCheckPath"`: If the protocol is HTTP/S, then this specifies the path that is the
  destination for health check targets. The default value is slash (/).
- `"HealthCheckPort"`: The port that Global Accelerator uses to check the health of
  endpoints that are part of this endpoint group. The default port is the listener port that
  this endpoint group is associated with. If the listener port is a list of ports, Global
  Accelerator uses the first port in the list.
- `"HealthCheckProtocol"`: The protocol that Global Accelerator uses to check the health of
  endpoints that are part of this endpoint group. The default value is TCP.
- `"PortOverrides"`: Override specific listener ports used to route traffic to endpoints
  that are part of this endpoint group. For example, you can create a port override in which
  the listener receives user traffic on ports 80 and 443, but your accelerator routes that
  traffic to ports 1080 and 1443, respectively, on the endpoints. For more information, see
  Overriding listener ports in the Global Accelerator Developer Guide.
- `"ThresholdCount"`: The number of consecutive health checks required to set the state of
  a healthy endpoint to unhealthy, or to set an unhealthy endpoint to healthy. The default
  value is 3.
- `"TrafficDialPercentage"`: The percentage of traffic to send to an Amazon Web Services
  Region. Additional traffic is distributed to other endpoint groups for this listener.  Use
  this action to increase (dial up) or decrease (dial down) traffic to a specific Region. The
  percentage is applied to the traffic that would otherwise have been routed to the Region
  based on optimal routing. The default value is 100.
"""
function update_endpoint_group(
    EndpointGroupArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return global_accelerator(
        "UpdateEndpointGroup",
        Dict{String,Any}("EndpointGroupArn" => EndpointGroupArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_endpoint_group(
    EndpointGroupArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return global_accelerator(
        "UpdateEndpointGroup",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("EndpointGroupArn" => EndpointGroupArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_listener(listener_arn)
    update_listener(listener_arn, params::Dict{String,<:Any})

Update a listener.

# Arguments
- `listener_arn`: The Amazon Resource Name (ARN) of the listener to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientAffinity"`: Client affinity lets you direct all requests from a user to the same
  endpoint, if you have stateful applications, regardless of the port and protocol of the
  client request. Client affinity gives you control over whether to always route each client
  to the same specific endpoint. Global Accelerator uses a consistent-flow hashing algorithm
  to choose the optimal endpoint for a connection. If client affinity is NONE, Global
  Accelerator uses the \"five-tuple\" (5-tuple) properties—source IP address, source port,
  destination IP address, destination port, and protocol—to select the hash value, and then
  chooses the best endpoint. However, with this setting, if someone uses different ports to
  connect to Global Accelerator, their connections might not be always routed to the same
  endpoint because the hash value changes.  If you want a given client to always be routed to
  the same endpoint, set client affinity to SOURCE_IP instead. When you use the SOURCE_IP
  setting, Global Accelerator uses the \"two-tuple\" (2-tuple) properties— source (client)
  IP address and destination IP address—to select the hash value. The default value is NONE.
- `"PortRanges"`: The updated list of port ranges for the connections from clients to the
  accelerator.
- `"Protocol"`: The updated protocol for the connections from clients to the accelerator.
"""
function update_listener(ListenerArn; aws_config::AbstractAWSConfig=current_aws_config())
    return global_accelerator(
        "UpdateListener",
        Dict{String,Any}("ListenerArn" => ListenerArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_listener(
    ListenerArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return global_accelerator(
        "UpdateListener",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ListenerArn" => ListenerArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    withdraw_byoip_cidr(cidr)
    withdraw_byoip_cidr(cidr, params::Dict{String,<:Any})

Stops advertising an address range that is provisioned as an address pool. You can perform
this operation at most once every 10 seconds, even if you specify different address ranges
each time. It can take a few minutes before traffic to the specified addresses stops
routing to Amazon Web Services because of propagation delays. For more information, see
Bring your own IP addresses (BYOIP) in the Global Accelerator Developer Guide.

# Arguments
- `cidr`: The address range, in CIDR notation.  For more information, see Bring your own IP
  addresses (BYOIP) in the Global Accelerator Developer Guide.

"""
function withdraw_byoip_cidr(Cidr; aws_config::AbstractAWSConfig=current_aws_config())
    return global_accelerator(
        "WithdrawByoipCidr",
        Dict{String,Any}("Cidr" => Cidr);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function withdraw_byoip_cidr(
    Cidr, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return global_accelerator(
        "WithdrawByoipCidr",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Cidr" => Cidr), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: docdb_elastic
using AWS.Compat
using AWS.UUIDs

"""
    copy_cluster_snapshot(snapshot_arn, target_snapshot_name)
    copy_cluster_snapshot(snapshot_arn, target_snapshot_name, params::Dict{String,<:Any})

Copies a snapshot of an elastic cluster.

# Arguments
- `snapshot_arn`: The Amazon Resource Name (ARN) identifier of the elastic cluster snapshot.
- `target_snapshot_name`: The identifier of the new elastic cluster snapshot to create from
  the source cluster snapshot. This parameter is not case sensitive. Constraints:   Must
  contain from 1 to 63 letters, numbers, or hyphens.   The first character must be a letter.
   Cannot end with a hyphen or contain two consecutive hyphens.   Example:
  elastic-cluster-snapshot-5

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"copyTags"`: Set to true to copy all tags from the source cluster snapshot to the target
  elastic cluster snapshot. The default is false.
- `"kmsKeyId"`: The Amazon Web Services KMS key ID for an encrypted elastic cluster
  snapshot. The Amazon Web Services KMS key ID is the Amazon Resource Name (ARN), Amazon Web
  Services KMS key identifier, or the Amazon Web Services KMS key alias for the Amazon Web
  Services KMS encryption key. If you copy an encrypted elastic cluster snapshot from your
  Amazon Web Services account, you can specify a value for KmsKeyId to encrypt the copy with
  a new Amazon Web ServicesS KMS encryption key. If you don't specify a value for KmsKeyId,
  then the copy of the elastic cluster snapshot is encrypted with the same AWS KMS key as the
  source elastic cluster snapshot. To copy an encrypted elastic cluster snapshot to another
  Amazon Web Services region, set KmsKeyId to the Amazon Web Services KMS key ID that you
  want to use to encrypt the copy of the elastic cluster snapshot in the destination region.
  Amazon Web Services KMS encryption keys are specific to the Amazon Web Services region that
  they are created in, and you can't use encryption keys from one Amazon Web Services region
  in another Amazon Web Services region. If you copy an unencrypted elastic cluster snapshot
  and specify a value for the KmsKeyId parameter, an error is returned.
- `"tags"`: The tags to be assigned to the elastic cluster snapshot.
"""
function copy_cluster_snapshot(
    snapshotArn, targetSnapshotName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return docdb_elastic(
        "POST",
        "/cluster-snapshot/$(snapshotArn)/copy",
        Dict{String,Any}("targetSnapshotName" => targetSnapshotName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function copy_cluster_snapshot(
    snapshotArn,
    targetSnapshotName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb_elastic(
        "POST",
        "/cluster-snapshot/$(snapshotArn)/copy",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("targetSnapshotName" => targetSnapshotName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_cluster(admin_user_name, admin_user_password, auth_type, cluster_name, shard_capacity, shard_count)
    create_cluster(admin_user_name, admin_user_password, auth_type, cluster_name, shard_capacity, shard_count, params::Dict{String,<:Any})

Creates a new Amazon DocumentDB elastic cluster and returns its cluster structure.

# Arguments
- `admin_user_name`: The name of the Amazon DocumentDB elastic clusters administrator.
  Constraints:   Must be from 1 to 63 letters or numbers.   The first character must be a
  letter.   Cannot be a reserved word.
- `admin_user_password`: The password for the Amazon DocumentDB elastic clusters
  administrator. The password can contain any printable ASCII characters.  Constraints:
  Must contain from 8 to 100 characters.   Cannot contain a forward slash (/), double quote
  (\"), or the \"at\" symbol (@).
- `auth_type`: The authentication type used to determine where to fetch the password used
  for accessing the elastic cluster. Valid types are PLAIN_TEXT or SECRET_ARN.
- `cluster_name`: The name of the new elastic cluster. This parameter is stored as a
  lowercase string.  Constraints:   Must contain from 1 to 63 letters, numbers, or hyphens.
  The first character must be a letter.   Cannot end with a hyphen or contain two consecutive
  hyphens.    Example: my-cluster
- `shard_capacity`: The number of vCPUs assigned to each elastic cluster shard. Maximum is
  64. Allowed values are 2, 4, 8, 16, 32, 64.
- `shard_count`: The number of shards assigned to the elastic cluster. Maximum is 32.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"backupRetentionPeriod"`: The number of days for which automatic snapshots are retained.
- `"clientToken"`: The client token for the elastic cluster.
- `"kmsKeyId"`: The KMS key identifier to use to encrypt the new elastic cluster. The KMS
  key identifier is the Amazon Resource Name (ARN) for the KMS encryption key. If you are
  creating a cluster using the same Amazon account that owns this KMS encryption key, you can
  use the KMS key alias instead of the ARN as the KMS encryption key. If an encryption key is
  not specified, Amazon DocumentDB uses the default encryption key that KMS creates for your
  account. Your account has a different default encryption key for each Amazon Region.
- `"preferredBackupWindow"`: The daily time range during which automated backups are
  created if automated backups are enabled, as determined by the backupRetentionPeriod.
- `"preferredMaintenanceWindow"`: The weekly time range during which system maintenance can
  occur, in Universal Coordinated Time (UTC).  Format: ddd:hh24:mi-ddd:hh24:mi   Default: a
  30-minute window selected at random from an 8-hour block of time for each Amazon Web
  Services Region, occurring on a random day of the week.  Valid days: Mon, Tue, Wed, Thu,
  Fri, Sat, Sun  Constraints: Minimum 30-minute window.
- `"shardInstanceCount"`: The number of replica instances applying to all shards in the
  elastic cluster. A shardInstanceCount value of 1 means there is one writer instance, and
  any additional instances are replicas that can be used for reads and to improve
  availability.
- `"subnetIds"`: The Amazon EC2 subnet IDs for the new elastic cluster.
- `"tags"`: The tags to be assigned to the new elastic cluster.
- `"vpcSecurityGroupIds"`: A list of EC2 VPC security groups to associate with the new
  elastic cluster.
"""
function create_cluster(
    adminUserName,
    adminUserPassword,
    authType,
    clusterName,
    shardCapacity,
    shardCount;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb_elastic(
        "POST",
        "/cluster",
        Dict{String,Any}(
            "adminUserName" => adminUserName,
            "adminUserPassword" => adminUserPassword,
            "authType" => authType,
            "clusterName" => clusterName,
            "shardCapacity" => shardCapacity,
            "shardCount" => shardCount,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_cluster(
    adminUserName,
    adminUserPassword,
    authType,
    clusterName,
    shardCapacity,
    shardCount,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb_elastic(
        "POST",
        "/cluster",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "adminUserName" => adminUserName,
                    "adminUserPassword" => adminUserPassword,
                    "authType" => authType,
                    "clusterName" => clusterName,
                    "shardCapacity" => shardCapacity,
                    "shardCount" => shardCount,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_cluster_snapshot(cluster_arn, snapshot_name)
    create_cluster_snapshot(cluster_arn, snapshot_name, params::Dict{String,<:Any})

Creates a snapshot of an elastic cluster.

# Arguments
- `cluster_arn`: The ARN identifier of the elastic cluster of which you want to create a
  snapshot.
- `snapshot_name`: The name of the new elastic cluster snapshot.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tags"`: The tags to be assigned to the new elastic cluster snapshot.
"""
function create_cluster_snapshot(
    clusterArn, snapshotName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return docdb_elastic(
        "POST",
        "/cluster-snapshot",
        Dict{String,Any}("clusterArn" => clusterArn, "snapshotName" => snapshotName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_cluster_snapshot(
    clusterArn,
    snapshotName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb_elastic(
        "POST",
        "/cluster-snapshot",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "clusterArn" => clusterArn, "snapshotName" => snapshotName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_cluster(cluster_arn)
    delete_cluster(cluster_arn, params::Dict{String,<:Any})

Delete an elastic cluster.

# Arguments
- `cluster_arn`: The ARN identifier of the elastic cluster that is to be deleted.

"""
function delete_cluster(clusterArn; aws_config::AbstractAWSConfig=current_aws_config())
    return docdb_elastic(
        "DELETE",
        "/cluster/$(clusterArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_cluster(
    clusterArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb_elastic(
        "DELETE",
        "/cluster/$(clusterArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_cluster_snapshot(snapshot_arn)
    delete_cluster_snapshot(snapshot_arn, params::Dict{String,<:Any})

Delete an elastic cluster snapshot.

# Arguments
- `snapshot_arn`: The ARN identifier of the elastic cluster snapshot that is to be deleted.

"""
function delete_cluster_snapshot(
    snapshotArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return docdb_elastic(
        "DELETE",
        "/cluster-snapshot/$(snapshotArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_cluster_snapshot(
    snapshotArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb_elastic(
        "DELETE",
        "/cluster-snapshot/$(snapshotArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_cluster(cluster_arn)
    get_cluster(cluster_arn, params::Dict{String,<:Any})

Returns information about a specific elastic cluster.

# Arguments
- `cluster_arn`: The ARN identifier of the elastic cluster.

"""
function get_cluster(clusterArn; aws_config::AbstractAWSConfig=current_aws_config())
    return docdb_elastic(
        "GET",
        "/cluster/$(clusterArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_cluster(
    clusterArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb_elastic(
        "GET",
        "/cluster/$(clusterArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_cluster_snapshot(snapshot_arn)
    get_cluster_snapshot(snapshot_arn, params::Dict{String,<:Any})

Returns information about a specific elastic cluster snapshot

# Arguments
- `snapshot_arn`: The ARN identifier of the elastic cluster snapshot.

"""
function get_cluster_snapshot(
    snapshotArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return docdb_elastic(
        "GET",
        "/cluster-snapshot/$(snapshotArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_cluster_snapshot(
    snapshotArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb_elastic(
        "GET",
        "/cluster-snapshot/$(snapshotArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_cluster_snapshots()
    list_cluster_snapshots(params::Dict{String,<:Any})

Returns information about snapshots for a specified elastic cluster.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clusterArn"`: The ARN identifier of the elastic cluster.
- `"maxResults"`: The maximum number of elastic cluster snapshot results to receive in the
  response.
- `"nextToken"`: A pagination token provided by a previous request. If this parameter is
  specified, the response includes only records beyond this token, up to the value specified
  by max-results. If there is no more data in the responce, the nextToken will not be
  returned.
- `"snapshotType"`: The type of cluster snapshots to be returned. You can specify one of
  the following values:    automated - Return all cluster snapshots that Amazon DocumentDB
  has automatically created for your Amazon Web Services account.    manual - Return all
  cluster snapshots that you have manually created for your Amazon Web Services account.
"""
function list_cluster_snapshots(; aws_config::AbstractAWSConfig=current_aws_config())
    return docdb_elastic(
        "GET", "/cluster-snapshots"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_cluster_snapshots(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return docdb_elastic(
        "GET",
        "/cluster-snapshots",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_clusters()
    list_clusters(params::Dict{String,<:Any})

Returns information about provisioned Amazon DocumentDB elastic clusters.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of elastic cluster snapshot results to receive in the
  response.
- `"nextToken"`: A pagination token provided by a previous request. If this parameter is
  specified, the response includes only records beyond this token, up to the value specified
  by max-results. If there is no more data in the responce, the nextToken will not be
  returned.
"""
function list_clusters(; aws_config::AbstractAWSConfig=current_aws_config())
    return docdb_elastic(
        "GET", "/clusters"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_clusters(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return docdb_elastic(
        "GET", "/clusters", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists all tags on a elastic cluster resource

# Arguments
- `resource_arn`: The ARN identifier of the elastic cluster resource.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return docdb_elastic(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb_elastic(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    restore_cluster_from_snapshot(cluster_name, snapshot_arn)
    restore_cluster_from_snapshot(cluster_name, snapshot_arn, params::Dict{String,<:Any})

Restores an elastic cluster from a snapshot.

# Arguments
- `cluster_name`: The name of the elastic cluster.
- `snapshot_arn`: The ARN identifier of the elastic cluster snapshot.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"kmsKeyId"`: The KMS key identifier to use to encrypt the new Amazon DocumentDB elastic
  clusters cluster. The KMS key identifier is the Amazon Resource Name (ARN) for the KMS
  encryption key. If you are creating a cluster using the same Amazon account that owns this
  KMS encryption key, you can use the KMS key alias instead of the ARN as the KMS encryption
  key. If an encryption key is not specified here, Amazon DocumentDB uses the default
  encryption key that KMS creates for your account. Your account has a different default
  encryption key for each Amazon Region.
- `"shardCapacity"`: The capacity of each shard in the new restored elastic cluster.
- `"shardInstanceCount"`: The number of replica instances applying to all shards in the
  elastic cluster. A shardInstanceCount value of 1 means there is one writer instance, and
  any additional instances are replicas that can be used for reads and to improve
  availability.
- `"subnetIds"`: The Amazon EC2 subnet IDs for the elastic cluster.
- `"tags"`: A list of the tag names to be assigned to the restored elastic cluster, in the
  form of an array of key-value pairs in which the key is the tag name and the value is the
  key value.
- `"vpcSecurityGroupIds"`: A list of EC2 VPC security groups to associate with the elastic
  cluster.
"""
function restore_cluster_from_snapshot(
    clusterName, snapshotArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return docdb_elastic(
        "POST",
        "/cluster-snapshot/$(snapshotArn)/restore",
        Dict{String,Any}("clusterName" => clusterName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function restore_cluster_from_snapshot(
    clusterName,
    snapshotArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb_elastic(
        "POST",
        "/cluster-snapshot/$(snapshotArn)/restore",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clusterName" => clusterName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_cluster(cluster_arn)
    start_cluster(cluster_arn, params::Dict{String,<:Any})

Restarts the stopped elastic cluster that is specified by clusterARN.

# Arguments
- `cluster_arn`: The ARN identifier of the elastic cluster.

"""
function start_cluster(clusterArn; aws_config::AbstractAWSConfig=current_aws_config())
    return docdb_elastic(
        "POST",
        "/cluster/$(clusterArn)/start";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_cluster(
    clusterArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb_elastic(
        "POST",
        "/cluster/$(clusterArn)/start",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_cluster(cluster_arn)
    stop_cluster(cluster_arn, params::Dict{String,<:Any})

Stops the running elastic cluster that is specified by clusterArn. The elastic cluster must
be in the available state.

# Arguments
- `cluster_arn`: The ARN identifier of the elastic cluster.

"""
function stop_cluster(clusterArn; aws_config::AbstractAWSConfig=current_aws_config())
    return docdb_elastic(
        "POST",
        "/cluster/$(clusterArn)/stop";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_cluster(
    clusterArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb_elastic(
        "POST",
        "/cluster/$(clusterArn)/stop",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds metadata tags to an elastic cluster resource

# Arguments
- `resource_arn`: The ARN identifier of the elastic cluster resource.
- `tags`: The tags that are assigned to the elastic cluster resource.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return docdb_elastic(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb_elastic(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes metadata tags from an elastic cluster resource

# Arguments
- `resource_arn`: The ARN identifier of the elastic cluster resource.
- `tag_keys`: The tag keys to be removed from the elastic cluster resource.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return docdb_elastic(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb_elastic(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_cluster(cluster_arn)
    update_cluster(cluster_arn, params::Dict{String,<:Any})

Modifies an elastic cluster. This includes updating admin-username/password, upgrading the
API version, and setting up a backup window and maintenance window

# Arguments
- `cluster_arn`: The ARN identifier of the elastic cluster.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"adminUserPassword"`: The password associated with the elastic cluster administrator.
  This password can contain any printable ASCII character except forward slash (/), double
  quote (\"), or the \"at\" symbol (@).  Constraints: Must contain from 8 to 100 characters.
- `"authType"`: The authentication type used to determine where to fetch the password used
  for accessing the elastic cluster. Valid types are PLAIN_TEXT or SECRET_ARN.
- `"backupRetentionPeriod"`: The number of days for which automatic snapshots are retained.
- `"clientToken"`: The client token for the elastic cluster.
- `"preferredBackupWindow"`: The daily time range during which automated backups are
  created if automated backups are enabled, as determined by the backupRetentionPeriod.
- `"preferredMaintenanceWindow"`: The weekly time range during which system maintenance can
  occur, in Universal Coordinated Time (UTC).  Format: ddd:hh24:mi-ddd:hh24:mi   Default: a
  30-minute window selected at random from an 8-hour block of time for each Amazon Web
  Services Region, occurring on a random day of the week.  Valid days: Mon, Tue, Wed, Thu,
  Fri, Sat, Sun  Constraints: Minimum 30-minute window.
- `"shardCapacity"`: The number of vCPUs assigned to each elastic cluster shard. Maximum is
  64. Allowed values are 2, 4, 8, 16, 32, 64.
- `"shardCount"`: The number of shards assigned to the elastic cluster. Maximum is 32.
- `"shardInstanceCount"`: The number of replica instances applying to all shards in the
  elastic cluster. A shardInstanceCount value of 1 means there is one writer instance, and
  any additional instances are replicas that can be used for reads and to improve
  availability.
- `"subnetIds"`: The Amazon EC2 subnet IDs for the elastic cluster.
- `"vpcSecurityGroupIds"`: A list of EC2 VPC security groups to associate with the elastic
  cluster.
"""
function update_cluster(clusterArn; aws_config::AbstractAWSConfig=current_aws_config())
    return docdb_elastic(
        "PUT",
        "/cluster/$(clusterArn)",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_cluster(
    clusterArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb_elastic(
        "PUT",
        "/cluster/$(clusterArn)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: panorama
using AWS.Compat
using AWS.UUIDs

"""
    create_application_instance(default_runtime_context_device, manifest_payload)
    create_application_instance(default_runtime_context_device, manifest_payload, params::Dict{String,<:Any})

Creates an application instance and deploys it to a device.

# Arguments
- `default_runtime_context_device`: A device's ID.
- `manifest_payload`: The application's manifest document.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ApplicationInstanceIdToReplace"`: The ID of an application instance to replace with the
  new instance.
- `"Description"`: A description for the application instance.
- `"ManifestOverridesPayload"`: Setting overrides for the application manifest.
- `"Name"`: A name for the application instance.
- `"RuntimeRoleArn"`: The ARN of a runtime role for the application instance.
- `"Tags"`: Tags for the application instance.
"""
function create_application_instance(
    DefaultRuntimeContextDevice,
    ManifestPayload;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return panorama(
        "POST",
        "/application-instances",
        Dict{String,Any}(
            "DefaultRuntimeContextDevice" => DefaultRuntimeContextDevice,
            "ManifestPayload" => ManifestPayload,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_application_instance(
    DefaultRuntimeContextDevice,
    ManifestPayload,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return panorama(
        "POST",
        "/application-instances",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DefaultRuntimeContextDevice" => DefaultRuntimeContextDevice,
                    "ManifestPayload" => ManifestPayload,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_job_for_devices(device_ids, job_type)
    create_job_for_devices(device_ids, job_type, params::Dict{String,<:Any})

Creates a job to run on a device. A job can update a device's software or reboot it.

# Arguments
- `device_ids`: ID of target device.
- `job_type`: The type of job to run.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DeviceJobConfig"`: Configuration settings for a software update job.
"""
function create_job_for_devices(
    DeviceIds, JobType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return panorama(
        "POST",
        "/jobs",
        Dict{String,Any}("DeviceIds" => DeviceIds, "JobType" => JobType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_job_for_devices(
    DeviceIds,
    JobType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return panorama(
        "POST",
        "/jobs",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DeviceIds" => DeviceIds, "JobType" => JobType),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_node_from_template_job(node_name, output_package_name, output_package_version, template_parameters, template_type)
    create_node_from_template_job(node_name, output_package_name, output_package_version, template_parameters, template_type, params::Dict{String,<:Any})

Creates a camera stream node.

# Arguments
- `node_name`: A name for the node.
- `output_package_name`: An output package name for the node.
- `output_package_version`: An output package version for the node.
- `template_parameters`: Template parameters for the node.
- `template_type`: The type of node.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"JobTags"`: Tags for the job.
- `"NodeDescription"`: A description for the node.
"""
function create_node_from_template_job(
    NodeName,
    OutputPackageName,
    OutputPackageVersion,
    TemplateParameters,
    TemplateType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return panorama(
        "POST",
        "/packages/template-job",
        Dict{String,Any}(
            "NodeName" => NodeName,
            "OutputPackageName" => OutputPackageName,
            "OutputPackageVersion" => OutputPackageVersion,
            "TemplateParameters" => TemplateParameters,
            "TemplateType" => TemplateType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_node_from_template_job(
    NodeName,
    OutputPackageName,
    OutputPackageVersion,
    TemplateParameters,
    TemplateType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return panorama(
        "POST",
        "/packages/template-job",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "NodeName" => NodeName,
                    "OutputPackageName" => OutputPackageName,
                    "OutputPackageVersion" => OutputPackageVersion,
                    "TemplateParameters" => TemplateParameters,
                    "TemplateType" => TemplateType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_package(package_name)
    create_package(package_name, params::Dict{String,<:Any})

Creates a package and storage location in an Amazon S3 access point.

# Arguments
- `package_name`: A name for the package.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: Tags for the package.
"""
function create_package(PackageName; aws_config::AbstractAWSConfig=current_aws_config())
    return panorama(
        "POST",
        "/packages",
        Dict{String,Any}("PackageName" => PackageName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_package(
    PackageName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return panorama(
        "POST",
        "/packages",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("PackageName" => PackageName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_package_import_job(client_token, input_config, job_type, output_config)
    create_package_import_job(client_token, input_config, job_type, output_config, params::Dict{String,<:Any})

Imports a node package.

# Arguments
- `client_token`: A client token for the package import job.
- `input_config`: An input config for the package import job.
- `job_type`: A job type for the package import job.
- `output_config`: An output config for the package import job.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"JobTags"`: Tags for the package import job.
"""
function create_package_import_job(
    ClientToken,
    InputConfig,
    JobType,
    OutputConfig;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return panorama(
        "POST",
        "/packages/import-jobs",
        Dict{String,Any}(
            "ClientToken" => ClientToken,
            "InputConfig" => InputConfig,
            "JobType" => JobType,
            "OutputConfig" => OutputConfig,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_package_import_job(
    ClientToken,
    InputConfig,
    JobType,
    OutputConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return panorama(
        "POST",
        "/packages/import-jobs",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClientToken" => ClientToken,
                    "InputConfig" => InputConfig,
                    "JobType" => JobType,
                    "OutputConfig" => OutputConfig,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_device(device_id)
    delete_device(device_id, params::Dict{String,<:Any})

Deletes a device.

# Arguments
- `device_id`: The device's ID.

"""
function delete_device(DeviceId; aws_config::AbstractAWSConfig=current_aws_config())
    return panorama(
        "DELETE",
        "/devices/$(DeviceId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_device(
    DeviceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return panorama(
        "DELETE",
        "/devices/$(DeviceId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_package(package_id)
    delete_package(package_id, params::Dict{String,<:Any})

Deletes a package.  To delete a package, you need permission to call s3:DeleteObject in
addition to permissions for the AWS Panorama API.

# Arguments
- `package_id`: The package's ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ForceDelete"`: Delete the package even if it has artifacts stored in its access point.
  Deletes the package's artifacts from Amazon S3.
"""
function delete_package(PackageId; aws_config::AbstractAWSConfig=current_aws_config())
    return panorama(
        "DELETE",
        "/packages/$(PackageId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_package(
    PackageId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return panorama(
        "DELETE",
        "/packages/$(PackageId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    deregister_package_version(package_id, package_version, patch_version)
    deregister_package_version(package_id, package_version, patch_version, params::Dict{String,<:Any})

Deregisters a package version.

# Arguments
- `package_id`: A package ID.
- `package_version`: A package version.
- `patch_version`: A patch version.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"OwnerAccount"`: An owner account.
- `"UpdatedLatestPatchVersion"`: If the version was marked latest, the new version to maker
  as latest.
"""
function deregister_package_version(
    PackageId,
    PackageVersion,
    PatchVersion;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return panorama(
        "DELETE",
        "/packages/$(PackageId)/versions/$(PackageVersion)/patch/$(PatchVersion)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function deregister_package_version(
    PackageId,
    PackageVersion,
    PatchVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return panorama(
        "DELETE",
        "/packages/$(PackageId)/versions/$(PackageVersion)/patch/$(PatchVersion)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_application_instance(application_instance_id)
    describe_application_instance(application_instance_id, params::Dict{String,<:Any})

Returns information about an application instance on a device.

# Arguments
- `application_instance_id`: The application instance's ID.

"""
function describe_application_instance(
    ApplicationInstanceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return panorama(
        "GET",
        "/application-instances/$(ApplicationInstanceId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_application_instance(
    ApplicationInstanceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return panorama(
        "GET",
        "/application-instances/$(ApplicationInstanceId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_application_instance_details(application_instance_id)
    describe_application_instance_details(application_instance_id, params::Dict{String,<:Any})

Returns information about an application instance's configuration manifest.

# Arguments
- `application_instance_id`: The application instance's ID.

"""
function describe_application_instance_details(
    ApplicationInstanceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return panorama(
        "GET",
        "/application-instances/$(ApplicationInstanceId)/details";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_application_instance_details(
    ApplicationInstanceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return panorama(
        "GET",
        "/application-instances/$(ApplicationInstanceId)/details",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_device(device_id)
    describe_device(device_id, params::Dict{String,<:Any})

Returns information about a device.

# Arguments
- `device_id`: The device's ID.

"""
function describe_device(DeviceId; aws_config::AbstractAWSConfig=current_aws_config())
    return panorama(
        "GET",
        "/devices/$(DeviceId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_device(
    DeviceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return panorama(
        "GET",
        "/devices/$(DeviceId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_device_job(job_id)
    describe_device_job(job_id, params::Dict{String,<:Any})

Returns information about a device job.

# Arguments
- `job_id`: The job's ID.

"""
function describe_device_job(JobId; aws_config::AbstractAWSConfig=current_aws_config())
    return panorama(
        "GET", "/jobs/$(JobId)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_device_job(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return panorama(
        "GET",
        "/jobs/$(JobId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_node(node_id)
    describe_node(node_id, params::Dict{String,<:Any})

Returns information about a node.

# Arguments
- `node_id`: The node's ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"OwnerAccount"`: The account ID of the node's owner.
"""
function describe_node(NodeId; aws_config::AbstractAWSConfig=current_aws_config())
    return panorama(
        "GET", "/nodes/$(NodeId)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_node(
    NodeId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return panorama(
        "GET",
        "/nodes/$(NodeId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_node_from_template_job(job_id)
    describe_node_from_template_job(job_id, params::Dict{String,<:Any})

Returns information about a job to create a camera stream node.

# Arguments
- `job_id`: The job's ID.

"""
function describe_node_from_template_job(
    JobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return panorama(
        "GET",
        "/packages/template-job/$(JobId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_node_from_template_job(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return panorama(
        "GET",
        "/packages/template-job/$(JobId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_package(package_id)
    describe_package(package_id, params::Dict{String,<:Any})

Returns information about a package.

# Arguments
- `package_id`: The package's ID.

"""
function describe_package(PackageId; aws_config::AbstractAWSConfig=current_aws_config())
    return panorama(
        "GET",
        "/packages/metadata/$(PackageId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_package(
    PackageId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return panorama(
        "GET",
        "/packages/metadata/$(PackageId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_package_import_job(job_id)
    describe_package_import_job(job_id, params::Dict{String,<:Any})

Returns information about a package import job.

# Arguments
- `job_id`: The job's ID.

"""
function describe_package_import_job(
    JobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return panorama(
        "GET",
        "/packages/import-jobs/$(JobId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_package_import_job(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return panorama(
        "GET",
        "/packages/import-jobs/$(JobId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_package_version(package_id, package_version)
    describe_package_version(package_id, package_version, params::Dict{String,<:Any})

Returns information about a package version.

# Arguments
- `package_id`: The version's ID.
- `package_version`: The version's version.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"OwnerAccount"`: The version's owner account.
- `"PatchVersion"`: The version's patch version.
"""
function describe_package_version(
    PackageId, PackageVersion; aws_config::AbstractAWSConfig=current_aws_config()
)
    return panorama(
        "GET",
        "/packages/metadata/$(PackageId)/versions/$(PackageVersion)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_package_version(
    PackageId,
    PackageVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return panorama(
        "GET",
        "/packages/metadata/$(PackageId)/versions/$(PackageVersion)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_application_instance_dependencies(application_instance_id)
    list_application_instance_dependencies(application_instance_id, params::Dict{String,<:Any})

Returns a list of application instance dependencies.

# Arguments
- `application_instance_id`: The application instance's ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of application instance dependencies to return in one
  page of results.
- `"nextToken"`: Specify the pagination token from a previous request to retrieve the next
  page of results.
"""
function list_application_instance_dependencies(
    ApplicationInstanceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return panorama(
        "GET",
        "/application-instances/$(ApplicationInstanceId)/package-dependencies";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_application_instance_dependencies(
    ApplicationInstanceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return panorama(
        "GET",
        "/application-instances/$(ApplicationInstanceId)/package-dependencies",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_application_instance_node_instances(application_instance_id)
    list_application_instance_node_instances(application_instance_id, params::Dict{String,<:Any})

Returns a list of application node instances.

# Arguments
- `application_instance_id`: The node instances' application instance ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of node instances to return in one page of results.
- `"nextToken"`: Specify the pagination token from a previous request to retrieve the next
  page of results.
"""
function list_application_instance_node_instances(
    ApplicationInstanceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return panorama(
        "GET",
        "/application-instances/$(ApplicationInstanceId)/node-instances";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_application_instance_node_instances(
    ApplicationInstanceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return panorama(
        "GET",
        "/application-instances/$(ApplicationInstanceId)/node-instances",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_application_instances()
    list_application_instances(params::Dict{String,<:Any})

Returns a list of application instances.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"deviceId"`: The application instances' device ID.
- `"maxResults"`: The maximum number of application instances to return in one page of
  results.
- `"nextToken"`: Specify the pagination token from a previous request to retrieve the next
  page of results.
- `"statusFilter"`: Only include instances with a specific status.
"""
function list_application_instances(; aws_config::AbstractAWSConfig=current_aws_config())
    return panorama(
        "GET",
        "/application-instances";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_application_instances(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return panorama(
        "GET",
        "/application-instances",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_devices()
    list_devices(params::Dict{String,<:Any})

Returns a list of devices.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DeviceAggregatedStatusFilter"`: Filter based on a device's status.
- `"MaxResults"`: The maximum number of devices to return in one page of results.
- `"NameFilter"`: Filter based on device's name. Prefixes supported.
- `"NextToken"`: Specify the pagination token from a previous request to retrieve the next
  page of results.
- `"SortBy"`: The target column to be sorted on. Default column sort is CREATED_TIME.
- `"SortOrder"`: The sorting order for the returned list. SortOrder is DESCENDING by
  default based on CREATED_TIME. Otherwise, SortOrder is ASCENDING.
"""
function list_devices(; aws_config::AbstractAWSConfig=current_aws_config())
    return panorama(
        "GET", "/devices"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_devices(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return panorama(
        "GET", "/devices", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_devices_jobs()
    list_devices_jobs(params::Dict{String,<:Any})

Returns a list of jobs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DeviceId"`: Filter results by the job's target device ID.
- `"MaxResults"`: The maximum number of device jobs to return in one page of results.
- `"NextToken"`: Specify the pagination token from a previous request to retrieve the next
  page of results.
"""
function list_devices_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return panorama("GET", "/jobs"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_devices_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return panorama(
        "GET", "/jobs", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_node_from_template_jobs()
    list_node_from_template_jobs(params::Dict{String,<:Any})

Returns a list of camera stream node jobs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of node from template jobs to return in one page of
  results.
- `"NextToken"`: Specify the pagination token from a previous request to retrieve the next
  page of results.
"""
function list_node_from_template_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return panorama(
        "GET",
        "/packages/template-job";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_node_from_template_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return panorama(
        "GET",
        "/packages/template-job",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_nodes()
    list_nodes(params::Dict{String,<:Any})

Returns a list of nodes.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"category"`: Search for nodes by category.
- `"maxResults"`: The maximum number of nodes to return in one page of results.
- `"nextToken"`: Specify the pagination token from a previous request to retrieve the next
  page of results.
- `"ownerAccount"`: Search for nodes by the account ID of the nodes' owner.
- `"packageName"`: Search for nodes by name.
- `"packageVersion"`: Search for nodes by version.
- `"patchVersion"`: Search for nodes by patch version.
"""
function list_nodes(; aws_config::AbstractAWSConfig=current_aws_config())
    return panorama("GET", "/nodes"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_nodes(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return panorama(
        "GET", "/nodes", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_package_import_jobs()
    list_package_import_jobs(params::Dict{String,<:Any})

Returns a list of package import jobs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of package import jobs to return in one page of
  results.
- `"NextToken"`: Specify the pagination token from a previous request to retrieve the next
  page of results.
"""
function list_package_import_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return panorama(
        "GET",
        "/packages/import-jobs";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_package_import_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return panorama(
        "GET",
        "/packages/import-jobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_packages()
    list_packages(params::Dict{String,<:Any})

Returns a list of packages.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of packages to return in one page of results.
- `"nextToken"`: Specify the pagination token from a previous request to retrieve the next
  page of results.
"""
function list_packages(; aws_config::AbstractAWSConfig=current_aws_config())
    return panorama(
        "GET", "/packages"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_packages(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return panorama(
        "GET", "/packages", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Returns a list of tags for a resource.

# Arguments
- `resource_arn`: The resource's ARN.

"""
function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return panorama(
        "GET",
        "/tags/$(ResourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return panorama(
        "GET",
        "/tags/$(ResourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    provision_device(name)
    provision_device(name, params::Dict{String,<:Any})

Creates a device and returns a configuration archive. The configuration archive is a ZIP
file that contains a provisioning certificate that is valid for 5 minutes. Name the
configuration archive certificates-omni_device-name.zip and transfer it to the device
within 5 minutes. Use the included USB storage device and connect it to the USB 3.0 port
next to the HDMI output.

# Arguments
- `name`: A name for the device.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description for the device.
- `"NetworkingConfiguration"`: A networking configuration for the device.
- `"Tags"`: Tags for the device.
"""
function provision_device(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return panorama(
        "POST",
        "/devices",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function provision_device(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return panorama(
        "POST",
        "/devices",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    register_package_version(package_id, package_version, patch_version)
    register_package_version(package_id, package_version, patch_version, params::Dict{String,<:Any})

Registers a package version.

# Arguments
- `package_id`: A package ID.
- `package_version`: A package version.
- `patch_version`: A patch version.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MarkLatest"`: Whether to mark the new version as the latest version.
- `"OwnerAccount"`: An owner account.
"""
function register_package_version(
    PackageId,
    PackageVersion,
    PatchVersion;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return panorama(
        "PUT",
        "/packages/$(PackageId)/versions/$(PackageVersion)/patch/$(PatchVersion)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function register_package_version(
    PackageId,
    PackageVersion,
    PatchVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return panorama(
        "PUT",
        "/packages/$(PackageId)/versions/$(PackageVersion)/patch/$(PatchVersion)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_application_instance(application_instance_id)
    remove_application_instance(application_instance_id, params::Dict{String,<:Any})

Removes an application instance.

# Arguments
- `application_instance_id`: An application instance ID.

"""
function remove_application_instance(
    ApplicationInstanceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return panorama(
        "DELETE",
        "/application-instances/$(ApplicationInstanceId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_application_instance(
    ApplicationInstanceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return panorama(
        "DELETE",
        "/application-instances/$(ApplicationInstanceId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    signal_application_instance_node_instances(application_instance_id, node_signals)
    signal_application_instance_node_instances(application_instance_id, node_signals, params::Dict{String,<:Any})

Signal camera nodes to stop or resume.

# Arguments
- `application_instance_id`: An application instance ID.
- `node_signals`: A list of signals.

"""
function signal_application_instance_node_instances(
    ApplicationInstanceId, NodeSignals; aws_config::AbstractAWSConfig=current_aws_config()
)
    return panorama(
        "PUT",
        "/application-instances/$(ApplicationInstanceId)/node-signals",
        Dict{String,Any}("NodeSignals" => NodeSignals);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function signal_application_instance_node_instances(
    ApplicationInstanceId,
    NodeSignals,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return panorama(
        "PUT",
        "/application-instances/$(ApplicationInstanceId)/node-signals",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("NodeSignals" => NodeSignals), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Tags a resource.

# Arguments
- `resource_arn`: The resource's ARN.
- `tags`: Tags for the resource.

"""
function tag_resource(ResourceArn, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return panorama(
        "POST",
        "/tags/$(ResourceArn)",
        Dict{String,Any}("Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceArn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return panorama(
        "POST",
        "/tags/$(ResourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Tags" => Tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes tags from a resource.

# Arguments
- `resource_arn`: The resource's ARN.
- `tag_keys`: Tag keys to remove.

"""
function untag_resource(
    ResourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return panorama(
        "DELETE",
        "/tags/$(ResourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return panorama(
        "DELETE",
        "/tags/$(ResourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_device_metadata(device_id)
    update_device_metadata(device_id, params::Dict{String,<:Any})

Updates a device's metadata.

# Arguments
- `device_id`: The device's ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description for the device.
"""
function update_device_metadata(
    DeviceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return panorama(
        "PUT",
        "/devices/$(DeviceId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_device_metadata(
    DeviceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return panorama(
        "PUT",
        "/devices/$(DeviceId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: storage_gateway
using AWS.Compat
using AWS.UUIDs

"""
    activate_gateway(activation_key, gateway_name, gateway_region, gateway_timezone)
    activate_gateway(activation_key, gateway_name, gateway_region, gateway_timezone, params::Dict{String,<:Any})

Activates the gateway you previously deployed on your host. In the activation process, you
specify information such as the Amazon Web Services Region that you want to use for storing
snapshots or tapes, the time zone for scheduled snapshots the gateway snapshot schedule
window, an activation key, and a name for your gateway. The activation process also
associates your gateway with your account. For more information, see
UpdateGatewayInformation.  You must turn on the gateway VM before you can activate your
gateway.

# Arguments
- `activation_key`: Your gateway activation key. You can obtain the activation key by
  sending an HTTP GET request with redirects enabled to the gateway IP address (port 80). The
  redirect URL returned in the response provides you the activation key for your gateway in
  the query string parameter activationKey. It may also include other activation-related
  parameters, however, these are merely defaults -- the arguments you pass to the
  ActivateGateway API call determine the actual configuration of your gateway. For more
  information, see Getting activation key in the Storage Gateway User Guide.
- `gateway_name`: The name you configured for your gateway.
- `gateway_region`: A value that indicates the Amazon Web Services Region where you want to
  store your data. The gateway Amazon Web Services Region specified must be the same Amazon
  Web Services Region as the Amazon Web Services Region in your Host header in the request.
  For more information about available Amazon Web Services Regions and endpoints for Storage
  Gateway, see  Storage Gateway endpoints and quotas in the Amazon Web Services General
  Reference. Valid Values: See  Storage Gateway endpoints and quotas in the Amazon Web
  Services General Reference.
- `gateway_timezone`: A value that indicates the time zone you want to set for the gateway.
  The time zone is of the format \"GMT\", \"GMT-hr:mm\", or \"GMT+hr:mm\". For example, GMT
  indicates Greenwich Mean Time without any offset. GMT-4:00 indicates the time is 4 hours
  behind GMT. GMT+2:00 indicates the time is 2 hours ahead of GMT. The time zone is used, for
  example, for scheduling snapshots and your gateway's maintenance schedule.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"GatewayType"`: A value that defines the type of gateway to activate. The type specified
  is critical to all later functions of the gateway and cannot be changed after activation.
  The default value is CACHED. Valid Values: STORED | CACHED | VTL | FILE_S3 | FILE_FSX_SMB
- `"MediumChangerType"`: The value that indicates the type of medium changer to use for
  tape gateway. This field is optional. Valid Values: STK-L700 | AWS-Gateway-VTL |
  IBM-03584L32-0402
- `"Tags"`: A list of up to 50 tags that you can assign to the gateway. Each tag is a
  key-value pair.  Valid characters for key and value are letters, spaces, and numbers that
  can be represented in UTF-8 format, and the following special characters: + - = . _ : / @.
  The maximum length of a tag's key is 128 characters, and the maximum length for a tag's
  value is 256 characters.
- `"TapeDriveType"`: The value that indicates the type of tape drive to use for tape
  gateway. This field is optional. Valid Values: IBM-ULT3580-TD5
"""
function activate_gateway(
    ActivationKey,
    GatewayName,
    GatewayRegion,
    GatewayTimezone;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "ActivateGateway",
        Dict{String,Any}(
            "ActivationKey" => ActivationKey,
            "GatewayName" => GatewayName,
            "GatewayRegion" => GatewayRegion,
            "GatewayTimezone" => GatewayTimezone,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function activate_gateway(
    ActivationKey,
    GatewayName,
    GatewayRegion,
    GatewayTimezone,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "ActivateGateway",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ActivationKey" => ActivationKey,
                    "GatewayName" => GatewayName,
                    "GatewayRegion" => GatewayRegion,
                    "GatewayTimezone" => GatewayTimezone,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    add_cache(disk_ids, gateway_arn)
    add_cache(disk_ids, gateway_arn, params::Dict{String,<:Any})

Configures one or more gateway local disks as cache for a gateway. This operation is only
supported in the cached volume, tape, and file gateway type (see How Storage Gateway works
(architecture). In the request, you specify the gateway Amazon Resource Name (ARN) to which
you want to add cache, and one or more disk IDs that you want to configure as cache.

# Arguments
- `disk_ids`: An array of strings that identify disks that are to be configured as working
  storage. Each string has a minimum length of 1 and maximum length of 300. You can get the
  disk IDs from the ListLocalDisks API.
- `gateway_arn`:

"""
function add_cache(DiskIds, GatewayARN; aws_config::AbstractAWSConfig=current_aws_config())
    return storage_gateway(
        "AddCache",
        Dict{String,Any}("DiskIds" => DiskIds, "GatewayARN" => GatewayARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_cache(
    DiskIds,
    GatewayARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "AddCache",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DiskIds" => DiskIds, "GatewayARN" => GatewayARN),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    add_tags_to_resource(resource_arn, tags)
    add_tags_to_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds one or more tags to the specified resource. You use tags to add metadata to resources,
which you can use to categorize these resources. For example, you can categorize resources
by purpose, owner, environment, or team. Each tag consists of a key and a value, which you
define. You can add tags to the following Storage Gateway resources:   Storage gateways of
all types   Storage volumes   Virtual tapes   NFS and SMB file shares   File System
associations   You can create a maximum of 50 tags for each resource. Virtual tapes and
storage volumes that are recovered to a new gateway maintain their tags.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource you want to add tags to.
- `tags`: The key-value pair that represents the tag you want to add to the resource. The
  value can be an empty string.  Valid characters for key and value are letters, spaces, and
  numbers representable in UTF-8 format, and the following special characters: + - = . _ : /
  @. The maximum length of a tag's key is 128 characters, and the maximum length for a tag's
  value is 256.

"""
function add_tags_to_resource(
    ResourceARN, Tags; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "AddTagsToResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_tags_to_resource(
    ResourceARN,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "AddTagsToResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    add_upload_buffer(disk_ids, gateway_arn)
    add_upload_buffer(disk_ids, gateway_arn, params::Dict{String,<:Any})

Configures one or more gateway local disks as upload buffer for a specified gateway. This
operation is supported for the stored volume, cached volume, and tape gateway types. In the
request, you specify the gateway Amazon Resource Name (ARN) to which you want to add upload
buffer, and one or more disk IDs that you want to configure as upload buffer.

# Arguments
- `disk_ids`: An array of strings that identify disks that are to be configured as working
  storage. Each string has a minimum length of 1 and maximum length of 300. You can get the
  disk IDs from the ListLocalDisks API.
- `gateway_arn`:

"""
function add_upload_buffer(
    DiskIds, GatewayARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "AddUploadBuffer",
        Dict{String,Any}("DiskIds" => DiskIds, "GatewayARN" => GatewayARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_upload_buffer(
    DiskIds,
    GatewayARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "AddUploadBuffer",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DiskIds" => DiskIds, "GatewayARN" => GatewayARN),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    add_working_storage(disk_ids, gateway_arn)
    add_working_storage(disk_ids, gateway_arn, params::Dict{String,<:Any})

Configures one or more gateway local disks as working storage for a gateway. This operation
is only supported in the stored volume gateway type. This operation is deprecated in cached
volume API version 20120630. Use AddUploadBuffer instead.  Working storage is also referred
to as upload buffer. You can also use the AddUploadBuffer operation to add upload buffer to
a stored volume gateway.  In the request, you specify the gateway Amazon Resource Name
(ARN) to which you want to add working storage, and one or more disk IDs that you want to
configure as working storage.

# Arguments
- `disk_ids`: An array of strings that identify disks that are to be configured as working
  storage. Each string has a minimum length of 1 and maximum length of 300. You can get the
  disk IDs from the ListLocalDisks API.
- `gateway_arn`:

"""
function add_working_storage(
    DiskIds, GatewayARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "AddWorkingStorage",
        Dict{String,Any}("DiskIds" => DiskIds, "GatewayARN" => GatewayARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_working_storage(
    DiskIds,
    GatewayARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "AddWorkingStorage",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DiskIds" => DiskIds, "GatewayARN" => GatewayARN),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    assign_tape_pool(pool_id, tape_arn)
    assign_tape_pool(pool_id, tape_arn, params::Dict{String,<:Any})

Assigns a tape to a tape pool for archiving. The tape assigned to a pool is archived in the
S3 storage class that is associated with the pool. When you use your backup application to
eject the tape, the tape is archived directly into the S3 storage class (S3 Glacier or S3
Glacier Deep Archive) that corresponds to the pool.

# Arguments
- `pool_id`: The ID of the pool that you want to add your tape to for archiving. The tape
  in this pool is archived in the S3 storage class that is associated with the pool. When you
  use your backup application to eject the tape, the tape is archived directly into the
  storage class (S3 Glacier or S3 Glacier Deep Archive) that corresponds to the pool.
- `tape_arn`: The unique Amazon Resource Name (ARN) of the virtual tape that you want to
  add to the tape pool.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"BypassGovernanceRetention"`: Set permissions to bypass governance retention. If the
  lock type of the archived tape is Governance, the tape's archived age is not older than
  RetentionLockInDays, and the user does not already have BypassGovernanceRetention, setting
  this to TRUE enables the user to bypass the retention lock. This parameter is set to true
  by default for calls from the console. Valid values: TRUE | FALSE
"""
function assign_tape_pool(
    PoolId, TapeARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "AssignTapePool",
        Dict{String,Any}("PoolId" => PoolId, "TapeARN" => TapeARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function assign_tape_pool(
    PoolId,
    TapeARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "AssignTapePool",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("PoolId" => PoolId, "TapeARN" => TapeARN), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_file_system(client_token, gateway_arn, location_arn, password, user_name)
    associate_file_system(client_token, gateway_arn, location_arn, password, user_name, params::Dict{String,<:Any})

Associate an Amazon FSx file system with the FSx File Gateway. After the association
process is complete, the file shares on the Amazon FSx file system are available for access
through the gateway. This operation only supports the FSx File Gateway type.

# Arguments
- `client_token`: A unique string value that you supply that is used by the FSx File
  Gateway to ensure idempotent file system association creation.
- `gateway_arn`:
- `location_arn`: The Amazon Resource Name (ARN) of the Amazon FSx file system to associate
  with the FSx File Gateway.
- `password`: The password of the user credential.
- `user_name`: The user name of the user credential that has permission to access the root
  share D of the Amazon FSx file system. The user account must belong to the Amazon FSx
  delegated admin user group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AuditDestinationARN"`: The Amazon Resource Name (ARN) of the storage used for the audit
  logs.
- `"CacheAttributes"`:
- `"EndpointNetworkConfiguration"`: Specifies the network configuration information for the
  gateway associated with the Amazon FSx file system.  If multiple file systems are
  associated with this gateway, this parameter's IpAddresses field is required.
- `"Tags"`: A list of up to 50 tags that can be assigned to the file system association.
  Each tag is a key-value pair.
"""
function associate_file_system(
    ClientToken,
    GatewayARN,
    LocationARN,
    Password,
    UserName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "AssociateFileSystem",
        Dict{String,Any}(
            "ClientToken" => ClientToken,
            "GatewayARN" => GatewayARN,
            "LocationARN" => LocationARN,
            "Password" => Password,
            "UserName" => UserName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_file_system(
    ClientToken,
    GatewayARN,
    LocationARN,
    Password,
    UserName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "AssociateFileSystem",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClientToken" => ClientToken,
                    "GatewayARN" => GatewayARN,
                    "LocationARN" => LocationARN,
                    "Password" => Password,
                    "UserName" => UserName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    attach_volume(gateway_arn, network_interface_id, volume_arn)
    attach_volume(gateway_arn, network_interface_id, volume_arn, params::Dict{String,<:Any})

Connects a volume to an iSCSI connection and then attaches the volume to the specified
gateway. Detaching and attaching a volume enables you to recover your data from one gateway
to a different gateway without creating a snapshot. It also makes it easier to move your
volumes from an on-premises gateway to a gateway hosted on an Amazon EC2 instance.

# Arguments
- `gateway_arn`: The Amazon Resource Name (ARN) of the gateway that you want to attach the
  volume to.
- `network_interface_id`: The network interface of the gateway on which to expose the iSCSI
  target. Only IPv4 addresses are accepted. Use DescribeGatewayInformation to get a list of
  the network interfaces available on a gateway. Valid Values: A valid IP address.
- `volume_arn`: The Amazon Resource Name (ARN) of the volume to attach to the specified
  gateway.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DiskId"`: The unique device ID or other distinguishing data that identifies the local
  disk used to create the volume. This value is only required when you are attaching a stored
  volume.
- `"TargetName"`: The name of the iSCSI target used by an initiator to connect to a volume
  and used as a suffix for the target ARN. For example, specifying TargetName as myvolume
  results in the target ARN of
  arn:aws:storagegateway:us-east-2:111122223333:gateway/sgw-12A3456B/target/iqn.1997-05.com.am
  azon:myvolume. The target name must be unique across all volumes on a gateway. If you don't
  specify a value, Storage Gateway uses the value that was previously used for this volume as
  the new target name.
"""
function attach_volume(
    GatewayARN,
    NetworkInterfaceId,
    VolumeARN;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "AttachVolume",
        Dict{String,Any}(
            "GatewayARN" => GatewayARN,
            "NetworkInterfaceId" => NetworkInterfaceId,
            "VolumeARN" => VolumeARN,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function attach_volume(
    GatewayARN,
    NetworkInterfaceId,
    VolumeARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "AttachVolume",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "GatewayARN" => GatewayARN,
                    "NetworkInterfaceId" => NetworkInterfaceId,
                    "VolumeARN" => VolumeARN,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_archival(gateway_arn, tape_arn)
    cancel_archival(gateway_arn, tape_arn, params::Dict{String,<:Any})

Cancels archiving of a virtual tape to the virtual tape shelf (VTS) after the archiving
process is initiated. This operation is only supported in the tape gateway type.

# Arguments
- `gateway_arn`:
- `tape_arn`: The Amazon Resource Name (ARN) of the virtual tape you want to cancel
  archiving for.

"""
function cancel_archival(
    GatewayARN, TapeARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "CancelArchival",
        Dict{String,Any}("GatewayARN" => GatewayARN, "TapeARN" => TapeARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_archival(
    GatewayARN,
    TapeARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "CancelArchival",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("GatewayARN" => GatewayARN, "TapeARN" => TapeARN),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_retrieval(gateway_arn, tape_arn)
    cancel_retrieval(gateway_arn, tape_arn, params::Dict{String,<:Any})

Cancels retrieval of a virtual tape from the virtual tape shelf (VTS) to a gateway after
the retrieval process is initiated. The virtual tape is returned to the VTS. This operation
is only supported in the tape gateway type.

# Arguments
- `gateway_arn`:
- `tape_arn`: The Amazon Resource Name (ARN) of the virtual tape you want to cancel
  retrieval for.

"""
function cancel_retrieval(
    GatewayARN, TapeARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "CancelRetrieval",
        Dict{String,Any}("GatewayARN" => GatewayARN, "TapeARN" => TapeARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_retrieval(
    GatewayARN,
    TapeARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "CancelRetrieval",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("GatewayARN" => GatewayARN, "TapeARN" => TapeARN),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_cachedi_scsivolume(client_token, gateway_arn, network_interface_id, target_name, volume_size_in_bytes)
    create_cachedi_scsivolume(client_token, gateway_arn, network_interface_id, target_name, volume_size_in_bytes, params::Dict{String,<:Any})

Creates a cached volume on a specified cached volume gateway. This operation is only
supported in the cached volume gateway type.  Cache storage must be allocated to the
gateway before you can create a cached volume. Use the AddCache operation to add cache
storage to a gateway.  In the request, you must specify the gateway, size of the volume in
bytes, the iSCSI target name, an IP address on which to expose the target, and a unique
client token. In response, the gateway creates the volume and returns information about it.
This information includes the volume Amazon Resource Name (ARN), its size, and the iSCSI
target ARN that initiators can use to connect to the volume target. Optionally, you can
provide the ARN for an existing volume as the SourceVolumeARN for this cached volume, which
creates an exact copy of the existing volume’s latest recovery point. The
VolumeSizeInBytes value must be equal to or larger than the size of the copied volume, in
bytes.

# Arguments
- `client_token`: A unique identifier that you use to retry a request. If you retry a
  request, use the same ClientToken you specified in the initial request.
- `gateway_arn`:
- `network_interface_id`: The network interface of the gateway on which to expose the iSCSI
  target. Only IPv4 addresses are accepted. Use DescribeGatewayInformation to get a list of
  the network interfaces available on a gateway. Valid Values: A valid IP address.
- `target_name`: The name of the iSCSI target used by an initiator to connect to a volume
  and used as a suffix for the target ARN. For example, specifying TargetName as myvolume
  results in the target ARN of
  arn:aws:storagegateway:us-east-2:111122223333:gateway/sgw-12A3456B/target/iqn.1997-05.com.am
  azon:myvolume. The target name must be unique across all volumes on a gateway. If you don't
  specify a value, Storage Gateway uses the value that was previously used for this volume as
  the new target name.
- `volume_size_in_bytes`: The size of the volume in bytes.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"KMSEncrypted"`: Set to true to use Amazon S3 server-side encryption with your own KMS
  key, or false to use a key managed by Amazon S3. Optional. Valid Values: true | false
- `"KMSKey"`: The Amazon Resource Name (ARN) of a symmetric customer master key (CMK) used
  for Amazon S3 server-side encryption. Storage Gateway does not support asymmetric CMKs.
  This value can only be set when KMSEncrypted is true. Optional.
- `"SnapshotId"`: The snapshot ID (e.g. \"snap-1122aabb\") of the snapshot to restore as
  the new cached volume. Specify this field if you want to create the iSCSI storage volume
  from a snapshot; otherwise, do not include this field. To list snapshots for your account
  use DescribeSnapshots in the Amazon Elastic Compute Cloud API Reference.
- `"SourceVolumeARN"`: The ARN for an existing volume. Specifying this ARN makes the new
  volume into an exact copy of the specified existing volume's latest recovery point. The
  VolumeSizeInBytes value for this new volume must be equal to or larger than the size of the
  existing volume, in bytes.
- `"Tags"`: A list of up to 50 tags that you can assign to a cached volume. Each tag is a
  key-value pair.  Valid characters for key and value are letters, spaces, and numbers that
  you can represent in UTF-8 format, and the following special characters: + - = . _ : / @.
  The maximum length of a tag's key is 128 characters, and the maximum length for a tag's
  value is 256 characters.
"""
function create_cachedi_scsivolume(
    ClientToken,
    GatewayARN,
    NetworkInterfaceId,
    TargetName,
    VolumeSizeInBytes;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "CreateCachediSCSIVolume",
        Dict{String,Any}(
            "ClientToken" => ClientToken,
            "GatewayARN" => GatewayARN,
            "NetworkInterfaceId" => NetworkInterfaceId,
            "TargetName" => TargetName,
            "VolumeSizeInBytes" => VolumeSizeInBytes,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_cachedi_scsivolume(
    ClientToken,
    GatewayARN,
    NetworkInterfaceId,
    TargetName,
    VolumeSizeInBytes,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "CreateCachediSCSIVolume",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClientToken" => ClientToken,
                    "GatewayARN" => GatewayARN,
                    "NetworkInterfaceId" => NetworkInterfaceId,
                    "TargetName" => TargetName,
                    "VolumeSizeInBytes" => VolumeSizeInBytes,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_nfsfile_share(client_token, gateway_arn, location_arn, role)
    create_nfsfile_share(client_token, gateway_arn, location_arn, role, params::Dict{String,<:Any})

Creates a Network File System (NFS) file share on an existing S3 File Gateway. In Storage
Gateway, a file share is a file system mount point backed by Amazon S3 cloud storage.
Storage Gateway exposes file shares using an NFS interface. This operation is only
supported for S3 File Gateways.  S3 File gateway requires Security Token Service (Amazon
Web Services STS) to be activated to enable you to create a file share. Make sure Amazon
Web Services STS is activated in the Amazon Web Services Region you are creating your S3
File Gateway in. If Amazon Web Services STS is not activated in the Amazon Web Services
Region, activate it. For information about how to activate Amazon Web Services STS, see
Activating and deactivating Amazon Web Services STS in an Amazon Web Services Region in the
Identity and Access Management User Guide. S3 File Gateways do not support creating hard or
symbolic links on a file share.

# Arguments
- `client_token`: A unique string value that you supply that is used by S3 File Gateway to
  ensure idempotent file share creation.
- `gateway_arn`: The Amazon Resource Name (ARN) of the S3 File Gateway on which you want to
  create a file share.
- `location_arn`: A custom ARN for the backend storage used for storing data for file
  shares. It includes a resource ARN with an optional prefix concatenation. The prefix must
  end with a forward slash (/).  You can specify LocationARN as a bucket ARN, access point
  ARN or access point alias, as shown in the following examples. Bucket ARN:
  arn:aws:s3:::my-bucket/prefix/  Access point ARN:
  arn:aws:s3:region:account-id:accesspoint/access-point-name/prefix/  If you specify an
  access point, the bucket policy must be configured to delegate access control to the access
  point. For information, see Delegating access control to access points in the Amazon S3
  User Guide. Access point alias:  test-ap-ab123cdef4gehijklmn5opqrstuvuse1a-s3alias
- `role`: The ARN of the Identity and Access Management (IAM) role that an S3 File Gateway
  assumes when it accesses the underlying storage.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AuditDestinationARN"`: The Amazon Resource Name (ARN) of the storage used for audit
  logs.
- `"BucketRegion"`: Specifies the Region of the S3 bucket where the NFS file share stores
  files.  This parameter is required for NFS file shares that connect to Amazon S3 through a
  VPC endpoint, a VPC access point, or an access point alias that points to a VPC access
  point.
- `"CacheAttributes"`: Specifies refresh cache information for the file share.
- `"ClientList"`: The list of clients that are allowed to access the S3 File Gateway. The
  list must contain either valid IP addresses or valid CIDR blocks.
- `"DefaultStorageClass"`: The default storage class for objects put into an Amazon S3
  bucket by the S3 File Gateway. The default value is S3_STANDARD. Optional. Valid Values:
  S3_STANDARD | S3_INTELLIGENT_TIERING | S3_STANDARD_IA | S3_ONEZONE_IA
- `"FileShareName"`: The name of the file share. Optional.   FileShareName must be set if
  an S3 prefix name is set in LocationARN, or if an access point or access point alias is
  used.
- `"GuessMIMETypeEnabled"`: A value that enables guessing of the MIME type for uploaded
  objects based on file extensions. Set this value to true to enable MIME type guessing,
  otherwise set to false. The default value is true. Valid Values: true | false
- `"KMSEncrypted"`: Set to true to use Amazon S3 server-side encryption with your own KMS
  key, or false to use a key managed by Amazon S3. Optional. Valid Values: true | false
- `"KMSKey"`: The Amazon Resource Name (ARN) of a symmetric customer master key (CMK) used
  for Amazon S3 server-side encryption. Storage Gateway does not support asymmetric CMKs.
  This value can only be set when KMSEncrypted is true. Optional.
- `"NFSFileShareDefaults"`: File share default values. Optional.
- `"NotificationPolicy"`: The notification policy of the file share. SettlingTimeInSeconds
  controls the number of seconds to wait after the last point in time a client wrote to a
  file before generating an ObjectUploaded notification. Because clients can make many small
  writes to files, it's best to set this parameter for as long as possible to avoid
  generating multiple notifications for the same file in a small time period.
  SettlingTimeInSeconds has no effect on the timing of the object uploading to Amazon S3,
  only the timing of the notification.  The following example sets NotificationPolicy on with
  SettlingTimeInSeconds set to 60.  {\"Upload\": {\"SettlingTimeInSeconds\": 60}}  The
  following example sets NotificationPolicy off.  {}
- `"ObjectACL"`: A value that sets the access control list (ACL) permission for objects in
  the S3 bucket that a S3 File Gateway puts objects into. The default value is private.
- `"ReadOnly"`: A value that sets the write status of a file share. Set this value to true
  to set the write status to read-only, otherwise set to false. Valid Values: true | false
- `"RequesterPays"`: A value that sets who pays the cost of the request and the cost
  associated with data download from the S3 bucket. If this value is set to true, the
  requester pays the costs; otherwise, the S3 bucket owner pays. However, the S3 bucket owner
  always pays the cost of storing data.   RequesterPays is a configuration for the S3 bucket
  that backs the file share, so make sure that the configuration on the file share is the
  same as the S3 bucket configuration.  Valid Values: true | false
- `"Squash"`: A value that maps a user to anonymous user. Valid values are the following:
   RootSquash: Only root is mapped to anonymous user.    NoSquash: No one is mapped to
  anonymous user.    AllSquash: Everyone is mapped to anonymous user.
- `"Tags"`: A list of up to 50 tags that can be assigned to the NFS file share. Each tag is
  a key-value pair.  Valid characters for key and value are letters, spaces, and numbers
  representable in UTF-8 format, and the following special characters: + - = . _ : / @. The
  maximum length of a tag's key is 128 characters, and the maximum length for a tag's value
  is 256.
- `"VPCEndpointDNSName"`: Specifies the DNS name for the VPC endpoint that the NFS file
  share uses to connect to Amazon S3.  This parameter is required for NFS file shares that
  connect to Amazon S3 through a VPC endpoint, a VPC access point, or an access point alias
  that points to a VPC access point.
"""
function create_nfsfile_share(
    ClientToken,
    GatewayARN,
    LocationARN,
    Role;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "CreateNFSFileShare",
        Dict{String,Any}(
            "ClientToken" => ClientToken,
            "GatewayARN" => GatewayARN,
            "LocationARN" => LocationARN,
            "Role" => Role,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_nfsfile_share(
    ClientToken,
    GatewayARN,
    LocationARN,
    Role,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "CreateNFSFileShare",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClientToken" => ClientToken,
                    "GatewayARN" => GatewayARN,
                    "LocationARN" => LocationARN,
                    "Role" => Role,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_smbfile_share(client_token, gateway_arn, location_arn, role)
    create_smbfile_share(client_token, gateway_arn, location_arn, role, params::Dict{String,<:Any})

Creates a Server Message Block (SMB) file share on an existing S3 File Gateway. In Storage
Gateway, a file share is a file system mount point backed by Amazon S3 cloud storage.
Storage Gateway exposes file shares using an SMB interface. This operation is only
supported for S3 File Gateways.  S3 File Gateways require Security Token Service (Amazon
Web Services STS) to be activated to enable you to create a file share. Make sure that
Amazon Web Services STS is activated in the Amazon Web Services Region you are creating
your S3 File Gateway in. If Amazon Web Services STS is not activated in this Amazon Web
Services Region, activate it. For information about how to activate Amazon Web Services
STS, see Activating and deactivating Amazon Web Services STS in an Amazon Web Services
Region in the Identity and Access Management User Guide. File gateways don't support
creating hard or symbolic links on a file share.

# Arguments
- `client_token`: A unique string value that you supply that is used by S3 File Gateway to
  ensure idempotent file share creation.
- `gateway_arn`: The ARN of the S3 File Gateway on which you want to create a file share.
- `location_arn`: A custom ARN for the backend storage used for storing data for file
  shares. It includes a resource ARN with an optional prefix concatenation. The prefix must
  end with a forward slash (/).  You can specify LocationARN as a bucket ARN, access point
  ARN or access point alias, as shown in the following examples. Bucket ARN:
  arn:aws:s3:::my-bucket/prefix/  Access point ARN:
  arn:aws:s3:region:account-id:accesspoint/access-point-name/prefix/  If you specify an
  access point, the bucket policy must be configured to delegate access control to the access
  point. For information, see Delegating access control to access points in the Amazon S3
  User Guide. Access point alias:  test-ap-ab123cdef4gehijklmn5opqrstuvuse1a-s3alias
- `role`: The ARN of the Identity and Access Management (IAM) role that an S3 File Gateway
  assumes when it accesses the underlying storage.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccessBasedEnumeration"`: The files and folders on this share will only be visible to
  users with read access.
- `"AdminUserList"`: A list of users or groups in the Active Directory that will be granted
  administrator privileges on the file share. These users can do all file operations as the
  super-user. Acceptable formats include: DOMAINUser1, user1, @group1, and @DOMAINgroup1.
  Use this option very carefully, because any user in this list can do anything they like on
  the file share, regardless of file permissions.
- `"AuditDestinationARN"`: The Amazon Resource Name (ARN) of the storage used for audit
  logs.
- `"Authentication"`: The authentication method that users use to access the file share.
  The default is ActiveDirectory. Valid Values: ActiveDirectory | GuestAccess
- `"BucketRegion"`: Specifies the Region of the S3 bucket where the SMB file share stores
  files.  This parameter is required for SMB file shares that connect to Amazon S3 through a
  VPC endpoint, a VPC access point, or an access point alias that points to a VPC access
  point.
- `"CacheAttributes"`: Specifies refresh cache information for the file share.
- `"CaseSensitivity"`: The case of an object name in an Amazon S3 bucket. For
  ClientSpecified, the client determines the case sensitivity. For CaseSensitive, the gateway
  determines the case sensitivity. The default value is ClientSpecified.
- `"DefaultStorageClass"`: The default storage class for objects put into an Amazon S3
  bucket by the S3 File Gateway. The default value is S3_STANDARD. Optional. Valid Values:
  S3_STANDARD | S3_INTELLIGENT_TIERING | S3_STANDARD_IA | S3_ONEZONE_IA
- `"FileShareName"`: The name of the file share. Optional.   FileShareName must be set if
  an S3 prefix name is set in LocationARN, or if an access point or access point alias is
  used.
- `"GuessMIMETypeEnabled"`: A value that enables guessing of the MIME type for uploaded
  objects based on file extensions. Set this value to true to enable MIME type guessing,
  otherwise set to false. The default value is true. Valid Values: true | false
- `"InvalidUserList"`: A list of users or groups in the Active Directory that are not
  allowed to access the file share. A group must be prefixed with the @ character. Acceptable
  formats include: DOMAINUser1, user1, @group1, and @DOMAINgroup1. Can only be set if
  Authentication is set to ActiveDirectory.
- `"KMSEncrypted"`: Set to true to use Amazon S3 server-side encryption with your own KMS
  key, or false to use a key managed by Amazon S3. Optional. Valid Values: true | false
- `"KMSKey"`: The Amazon Resource Name (ARN) of a symmetric customer master key (CMK) used
  for Amazon S3 server-side encryption. Storage Gateway does not support asymmetric CMKs.
  This value can only be set when KMSEncrypted is true. Optional.
- `"NotificationPolicy"`: The notification policy of the file share. SettlingTimeInSeconds
  controls the number of seconds to wait after the last point in time a client wrote to a
  file before generating an ObjectUploaded notification. Because clients can make many small
  writes to files, it's best to set this parameter for as long as possible to avoid
  generating multiple notifications for the same file in a small time period.
  SettlingTimeInSeconds has no effect on the timing of the object uploading to Amazon S3,
  only the timing of the notification.  The following example sets NotificationPolicy on with
  SettlingTimeInSeconds set to 60.  {\"Upload\": {\"SettlingTimeInSeconds\": 60}}  The
  following example sets NotificationPolicy off.  {}
- `"ObjectACL"`: A value that sets the access control list (ACL) permission for objects in
  the S3 bucket that a S3 File Gateway puts objects into. The default value is private.
- `"OplocksEnabled"`: Specifies whether opportunistic locking is enabled for the SMB file
  share.  Enabling opportunistic locking on case-sensitive shares is not recommended for
  workloads that involve access to files with the same name in different case.  Valid Values:
  true | false
- `"ReadOnly"`: A value that sets the write status of a file share. Set this value to true
  to set the write status to read-only, otherwise set to false. Valid Values: true | false
- `"RequesterPays"`: A value that sets who pays the cost of the request and the cost
  associated with data download from the S3 bucket. If this value is set to true, the
  requester pays the costs; otherwise, the S3 bucket owner pays. However, the S3 bucket owner
  always pays the cost of storing data.   RequesterPays is a configuration for the S3 bucket
  that backs the file share, so make sure that the configuration on the file share is the
  same as the S3 bucket configuration.  Valid Values: true | false
- `"SMBACLEnabled"`: Set this value to true to enable access control list (ACL) on the SMB
  file share. Set it to false to map file and directory permissions to the POSIX permissions.
  For more information, see Using Microsoft Windows ACLs to control access to an SMB file
  share in the Storage Gateway User Guide. Valid Values: true | false
- `"Tags"`: A list of up to 50 tags that can be assigned to the NFS file share. Each tag is
  a key-value pair.  Valid characters for key and value are letters, spaces, and numbers
  representable in UTF-8 format, and the following special characters: + - = . _ : / @. The
  maximum length of a tag's key is 128 characters, and the maximum length for a tag's value
  is 256.
- `"VPCEndpointDNSName"`: Specifies the DNS name for the VPC endpoint that the SMB file
  share uses to connect to Amazon S3.  This parameter is required for SMB file shares that
  connect to Amazon S3 through a VPC endpoint, a VPC access point, or an access point alias
  that points to a VPC access point.
- `"ValidUserList"`: A list of users or groups in the Active Directory that are allowed to
  access the file  share. A group must be prefixed with the @ character. Acceptable formats
  include: DOMAINUser1, user1, @group1, and @DOMAINgroup1. Can only be set if Authentication
  is set to ActiveDirectory.
"""
function create_smbfile_share(
    ClientToken,
    GatewayARN,
    LocationARN,
    Role;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "CreateSMBFileShare",
        Dict{String,Any}(
            "ClientToken" => ClientToken,
            "GatewayARN" => GatewayARN,
            "LocationARN" => LocationARN,
            "Role" => Role,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_smbfile_share(
    ClientToken,
    GatewayARN,
    LocationARN,
    Role,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "CreateSMBFileShare",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClientToken" => ClientToken,
                    "GatewayARN" => GatewayARN,
                    "LocationARN" => LocationARN,
                    "Role" => Role,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_snapshot(snapshot_description, volume_arn)
    create_snapshot(snapshot_description, volume_arn, params::Dict{String,<:Any})

Initiates a snapshot of a volume. Storage Gateway provides the ability to back up
point-in-time snapshots of your data to Amazon Simple Storage (Amazon S3) for durable
off-site recovery, and also import the data to an Amazon Elastic Block Store (EBS) volume
in Amazon Elastic Compute Cloud (EC2). You can take snapshots of your gateway volume on a
scheduled or ad hoc basis. This API enables you to take an ad hoc snapshot. For more
information, see Editing a snapshot schedule. In the CreateSnapshot request, you identify
the volume by providing its Amazon Resource Name (ARN). You must also provide description
for the snapshot. When Storage Gateway takes the snapshot of specified volume, the snapshot
and description appears in the Storage Gateway console. In response, Storage Gateway
returns you a snapshot ID. You can use this snapshot ID to check the snapshot progress or
later use it when you want to create a volume from a snapshot. This operation is only
supported in stored and cached volume gateway type.  To list or delete a snapshot, you must
use the Amazon EC2 API. For more information, see DescribeSnapshots or DeleteSnapshot in
the Amazon Elastic Compute Cloud API Reference.   Volume and snapshot IDs are changing to a
longer length ID format. For more information, see the important note on the Welcome page.

# Arguments
- `snapshot_description`: Textual description of the snapshot that appears in the Amazon
  EC2 console, Elastic Block Store snapshots panel in the Description field, and in the
  Storage Gateway snapshot Details pane, Description field.
- `volume_arn`: The Amazon Resource Name (ARN) of the volume. Use the ListVolumes operation
  to return a list of gateway volumes.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: A list of up to 50 tags that can be assigned to a snapshot. Each tag is a
  key-value pair.  Valid characters for key and value are letters, spaces, and numbers
  representable in UTF-8 format, and the following special characters: + - = . _ : / @. The
  maximum length of a tag's key is 128 characters, and the maximum length for a tag's value
  is 256.
"""
function create_snapshot(
    SnapshotDescription, VolumeARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "CreateSnapshot",
        Dict{String,Any}(
            "SnapshotDescription" => SnapshotDescription, "VolumeARN" => VolumeARN
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_snapshot(
    SnapshotDescription,
    VolumeARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "CreateSnapshot",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "SnapshotDescription" => SnapshotDescription, "VolumeARN" => VolumeARN
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_snapshot_from_volume_recovery_point(snapshot_description, volume_arn)
    create_snapshot_from_volume_recovery_point(snapshot_description, volume_arn, params::Dict{String,<:Any})

Initiates a snapshot of a gateway from a volume recovery point. This operation is only
supported in the cached volume gateway type. A volume recovery point is a point in time at
which all data of the volume is consistent and from which you can create a snapshot. To get
a list of volume recovery point for cached volume gateway, use ListVolumeRecoveryPoints. In
the CreateSnapshotFromVolumeRecoveryPoint request, you identify the volume by providing its
Amazon Resource Name (ARN). You must also provide a description for the snapshot. When the
gateway takes a snapshot of the specified volume, the snapshot and its description appear
in the Storage Gateway console. In response, the gateway returns you a snapshot ID. You can
use this snapshot ID to check the snapshot progress or later use it when you want to create
a volume from a snapshot.  To list or delete a snapshot, you must use the Amazon EC2 API.
For more information, see DescribeSnapshots or DeleteSnapshot in the Amazon Elastic Compute
Cloud API Reference.

# Arguments
- `snapshot_description`: Textual description of the snapshot that appears in the Amazon
  EC2 console, Elastic Block Store snapshots panel in the Description field, and in the
  Storage Gateway snapshot Details pane, Description field.
- `volume_arn`: The Amazon Resource Name (ARN) of the iSCSI volume target. Use the
  DescribeStorediSCSIVolumes operation to return to retrieve the TargetARN for specified
  VolumeARN.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: A list of up to 50 tags that can be assigned to a snapshot. Each tag is a
  key-value pair.  Valid characters for key and value are letters, spaces, and numbers
  representable in UTF-8 format, and the following special characters: + - = . _ : / @. The
  maximum length of a tag's key is 128 characters, and the maximum length for a tag's value
  is 256.
"""
function create_snapshot_from_volume_recovery_point(
    SnapshotDescription, VolumeARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "CreateSnapshotFromVolumeRecoveryPoint",
        Dict{String,Any}(
            "SnapshotDescription" => SnapshotDescription, "VolumeARN" => VolumeARN
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_snapshot_from_volume_recovery_point(
    SnapshotDescription,
    VolumeARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "CreateSnapshotFromVolumeRecoveryPoint",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "SnapshotDescription" => SnapshotDescription, "VolumeARN" => VolumeARN
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_storedi_scsivolume(disk_id, gateway_arn, network_interface_id, preserve_existing_data, target_name)
    create_storedi_scsivolume(disk_id, gateway_arn, network_interface_id, preserve_existing_data, target_name, params::Dict{String,<:Any})

Creates a volume on a specified gateway. This operation is only supported in the stored
volume gateway type. The size of the volume to create is inferred from the disk size. You
can choose to preserve existing data on the disk, create volume from an existing snapshot,
or create an empty volume. If you choose to create an empty gateway volume, then any
existing data on the disk is erased. In the request, you must specify the gateway and the
disk information on which you are creating the volume. In response, the gateway creates the
volume and returns volume information such as the volume Amazon Resource Name (ARN), its
size, and the iSCSI target ARN that initiators can use to connect to the volume target.

# Arguments
- `disk_id`: The unique identifier for the gateway local disk that is configured as a
  stored volume. Use ListLocalDisks to list disk IDs for a gateway.
- `gateway_arn`:
- `network_interface_id`: The network interface of the gateway on which to expose the iSCSI
  target. Only IPv4 addresses are accepted. Use DescribeGatewayInformation to get a list of
  the network interfaces available on a gateway. Valid Values: A valid IP address.
- `preserve_existing_data`: Set to true if you want to preserve the data on the local disk.
  Otherwise, set to false to create an empty volume. Valid Values: true | false
- `target_name`: The name of the iSCSI target used by an initiator to connect to a volume
  and used as a suffix for the target ARN. For example, specifying TargetName as myvolume
  results in the target ARN of
  arn:aws:storagegateway:us-east-2:111122223333:gateway/sgw-12A3456B/target/iqn.1997-05.com.am
  azon:myvolume. The target name must be unique across all volumes on a gateway. If you don't
  specify a value, Storage Gateway uses the value that was previously used for this volume as
  the new target name.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"KMSEncrypted"`: Set to true to use Amazon S3 server-side encryption with your own KMS
  key, or false to use a key managed by Amazon S3. Optional. Valid Values: true | false
- `"KMSKey"`: The Amazon Resource Name (ARN) of a symmetric customer master key (CMK) used
  for Amazon S3 server-side encryption. Storage Gateway does not support asymmetric CMKs.
  This value can only be set when KMSEncrypted is true. Optional.
- `"SnapshotId"`: The snapshot ID (e.g., \"snap-1122aabb\") of the snapshot to restore as
  the new stored volume. Specify this field if you want to create the iSCSI storage volume
  from a snapshot; otherwise, do not include this field. To list snapshots for your account
  use DescribeSnapshots in the Amazon Elastic Compute Cloud API Reference.
- `"Tags"`: A list of up to 50 tags that can be assigned to a stored volume. Each tag is a
  key-value pair.  Valid characters for key and value are letters, spaces, and numbers
  representable in UTF-8 format, and the following special characters: + - = . _ : / @. The
  maximum length of a tag's key is 128 characters, and the maximum length for a tag's value
  is 256.
"""
function create_storedi_scsivolume(
    DiskId,
    GatewayARN,
    NetworkInterfaceId,
    PreserveExistingData,
    TargetName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "CreateStorediSCSIVolume",
        Dict{String,Any}(
            "DiskId" => DiskId,
            "GatewayARN" => GatewayARN,
            "NetworkInterfaceId" => NetworkInterfaceId,
            "PreserveExistingData" => PreserveExistingData,
            "TargetName" => TargetName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_storedi_scsivolume(
    DiskId,
    GatewayARN,
    NetworkInterfaceId,
    PreserveExistingData,
    TargetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "CreateStorediSCSIVolume",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DiskId" => DiskId,
                    "GatewayARN" => GatewayARN,
                    "NetworkInterfaceId" => NetworkInterfaceId,
                    "PreserveExistingData" => PreserveExistingData,
                    "TargetName" => TargetName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_tape_pool(pool_name, storage_class)
    create_tape_pool(pool_name, storage_class, params::Dict{String,<:Any})

Creates a new custom tape pool. You can use custom tape pool to enable tape retention lock
on tapes that are archived in the custom pool.

# Arguments
- `pool_name`: The name of the new custom tape pool.
- `storage_class`: The storage class that is associated with the new custom pool. When you
  use your backup application to eject the tape, the tape is archived directly into the
  storage class (S3 Glacier or S3 Glacier Deep Archive) that corresponds to the pool.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"RetentionLockTimeInDays"`: Tape retention lock time is set in days. Tape retention lock
  can be enabled for up to 100 years (36,500 days).
- `"RetentionLockType"`: Tape retention lock can be configured in two modes. When
  configured in governance mode, Amazon Web Services accounts with specific IAM permissions
  are authorized to remove the tape retention lock from archived virtual tapes. When
  configured in compliance mode, the tape retention lock cannot be removed by any user,
  including the root Amazon Web Services account.
- `"Tags"`: A list of up to 50 tags that can be assigned to tape pool. Each tag is a
  key-value pair.  Valid characters for key and value are letters, spaces, and numbers
  representable in UTF-8 format, and the following special characters: + - = . _ : / @. The
  maximum length of a tag's key is 128 characters, and the maximum length for a tag's value
  is 256.
"""
function create_tape_pool(
    PoolName, StorageClass; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "CreateTapePool",
        Dict{String,Any}("PoolName" => PoolName, "StorageClass" => StorageClass);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_tape_pool(
    PoolName,
    StorageClass,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "CreateTapePool",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("PoolName" => PoolName, "StorageClass" => StorageClass),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_tape_with_barcode(gateway_arn, tape_barcode, tape_size_in_bytes)
    create_tape_with_barcode(gateway_arn, tape_barcode, tape_size_in_bytes, params::Dict{String,<:Any})

Creates a virtual tape by using your own barcode. You write data to the virtual tape and
then archive the tape. A barcode is unique and cannot be reused if it has already been used
on a tape. This applies to barcodes used on deleted tapes. This operation is only supported
in the tape gateway type.  Cache storage must be allocated to the gateway before you can
create a virtual tape. Use the AddCache operation to add cache storage to a gateway.

# Arguments
- `gateway_arn`: The unique Amazon Resource Name (ARN) that represents the gateway to
  associate the virtual tape with. Use the ListGateways operation to return a list of
  gateways for your account and Amazon Web Services Region.
- `tape_barcode`: The barcode that you want to assign to the tape.  Barcodes cannot be
  reused. This includes barcodes used for tapes that have been deleted.
- `tape_size_in_bytes`: The size, in bytes, of the virtual tape that you want to create.
  The size must be aligned by gigabyte (1024*1024*1024 bytes).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"KMSEncrypted"`: Set to true to use Amazon S3 server-side encryption with your own KMS
  key, or false to use a key managed by Amazon S3. Optional. Valid Values: true | false
- `"KMSKey"`: The Amazon Resource Name (ARN) of a symmetric customer master key (CMK) used
  for Amazon S3 server-side encryption. Storage Gateway does not support asymmetric CMKs.
  This value can only be set when KMSEncrypted is true. Optional.
- `"PoolId"`: The ID of the pool that you want to add your tape to for archiving. The tape
  in this pool is archived in the S3 storage class that is associated with the pool. When you
  use your backup application to eject the tape, the tape is archived directly into the
  storage class (S3 Glacier or S3 Deep Archive) that corresponds to the pool.
- `"Tags"`: A list of up to 50 tags that can be assigned to a virtual tape that has a
  barcode. Each tag is a key-value pair.  Valid characters for key and value are letters,
  spaces, and numbers representable in UTF-8 format, and the following special characters: +
  - = . _ : / @. The maximum length of a tag's key is 128 characters, and the maximum length
  for a tag's value is 256.
- `"Worm"`: Set to TRUE if the tape you are creating is to be configured as a
  write-once-read-many (WORM) tape.
"""
function create_tape_with_barcode(
    GatewayARN,
    TapeBarcode,
    TapeSizeInBytes;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "CreateTapeWithBarcode",
        Dict{String,Any}(
            "GatewayARN" => GatewayARN,
            "TapeBarcode" => TapeBarcode,
            "TapeSizeInBytes" => TapeSizeInBytes,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_tape_with_barcode(
    GatewayARN,
    TapeBarcode,
    TapeSizeInBytes,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "CreateTapeWithBarcode",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "GatewayARN" => GatewayARN,
                    "TapeBarcode" => TapeBarcode,
                    "TapeSizeInBytes" => TapeSizeInBytes,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_tapes(client_token, gateway_arn, num_tapes_to_create, tape_barcode_prefix, tape_size_in_bytes)
    create_tapes(client_token, gateway_arn, num_tapes_to_create, tape_barcode_prefix, tape_size_in_bytes, params::Dict{String,<:Any})

Creates one or more virtual tapes. You write data to the virtual tapes and then archive the
tapes. This operation is only supported in the tape gateway type.  Cache storage must be
allocated to the gateway before you can create virtual tapes. Use the AddCache operation to
add cache storage to a gateway.

# Arguments
- `client_token`: A unique identifier that you use to retry a request. If you retry a
  request, use the same ClientToken you specified in the initial request.  Using the same
  ClientToken prevents creating the tape multiple times.
- `gateway_arn`: The unique Amazon Resource Name (ARN) that represents the gateway to
  associate the virtual tapes with. Use the ListGateways operation to return a list of
  gateways for your account and Amazon Web Services Region.
- `num_tapes_to_create`: The number of virtual tapes that you want to create.
- `tape_barcode_prefix`: A prefix that you append to the barcode of the virtual tape you
  are creating. This prefix makes the barcode unique.  The prefix must be 1-4 characters in
  length and must be one of the uppercase letters from A to Z.
- `tape_size_in_bytes`: The size, in bytes, of the virtual tapes that you want to create.
  The size must be aligned by gigabyte (1024*1024*1024 bytes).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"KMSEncrypted"`: Set to true to use Amazon S3 server-side encryption with your own KMS
  key, or false to use a key managed by Amazon S3. Optional. Valid Values: true | false
- `"KMSKey"`: The Amazon Resource Name (ARN) of a symmetric customer master key (CMK) used
  for Amazon S3 server-side encryption. Storage Gateway does not support asymmetric CMKs.
  This value can only be set when KMSEncrypted is true. Optional.
- `"PoolId"`: The ID of the pool that you want to add your tape to for archiving. The tape
  in this pool is archived in the S3 storage class that is associated with the pool. When you
  use your backup application to eject the tape, the tape is archived directly into the
  storage class (S3 Glacier or S3 Glacier Deep Archive) that corresponds to the pool.
- `"Tags"`: A list of up to 50 tags that can be assigned to a virtual tape. Each tag is a
  key-value pair.  Valid characters for key and value are letters, spaces, and numbers
  representable in UTF-8 format, and the following special characters: + - = . _ : / @. The
  maximum length of a tag's key is 128 characters, and the maximum length for a tag's value
  is 256.
- `"Worm"`: Set to TRUE if the tape you are creating is to be configured as a
  write-once-read-many (WORM) tape.
"""
function create_tapes(
    ClientToken,
    GatewayARN,
    NumTapesToCreate,
    TapeBarcodePrefix,
    TapeSizeInBytes;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "CreateTapes",
        Dict{String,Any}(
            "ClientToken" => ClientToken,
            "GatewayARN" => GatewayARN,
            "NumTapesToCreate" => NumTapesToCreate,
            "TapeBarcodePrefix" => TapeBarcodePrefix,
            "TapeSizeInBytes" => TapeSizeInBytes,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_tapes(
    ClientToken,
    GatewayARN,
    NumTapesToCreate,
    TapeBarcodePrefix,
    TapeSizeInBytes,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "CreateTapes",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClientToken" => ClientToken,
                    "GatewayARN" => GatewayARN,
                    "NumTapesToCreate" => NumTapesToCreate,
                    "TapeBarcodePrefix" => TapeBarcodePrefix,
                    "TapeSizeInBytes" => TapeSizeInBytes,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_automatic_tape_creation_policy(gateway_arn)
    delete_automatic_tape_creation_policy(gateway_arn, params::Dict{String,<:Any})

Deletes the automatic tape creation policy of a gateway. If you delete this policy, new
virtual tapes must be created manually. Use the Amazon Resource Name (ARN) of the gateway
in your request to remove the policy.

# Arguments
- `gateway_arn`:

"""
function delete_automatic_tape_creation_policy(
    GatewayARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "DeleteAutomaticTapeCreationPolicy",
        Dict{String,Any}("GatewayARN" => GatewayARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_automatic_tape_creation_policy(
    GatewayARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "DeleteAutomaticTapeCreationPolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("GatewayARN" => GatewayARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_bandwidth_rate_limit(bandwidth_type, gateway_arn)
    delete_bandwidth_rate_limit(bandwidth_type, gateway_arn, params::Dict{String,<:Any})

Deletes the bandwidth rate limits of a gateway. You can delete either the upload and
download bandwidth rate limit, or you can delete both. If you delete only one of the
limits, the other limit remains unchanged. To specify which gateway to work with, use the
Amazon Resource Name (ARN) of the gateway in your request. This operation is supported only
for the stored volume, cached volume, and tape gateway types.

# Arguments
- `bandwidth_type`: One of the BandwidthType values that indicates the gateway bandwidth
  rate limit to delete. Valid Values: UPLOAD | DOWNLOAD | ALL
- `gateway_arn`:

"""
function delete_bandwidth_rate_limit(
    BandwidthType, GatewayARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "DeleteBandwidthRateLimit",
        Dict{String,Any}("BandwidthType" => BandwidthType, "GatewayARN" => GatewayARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_bandwidth_rate_limit(
    BandwidthType,
    GatewayARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "DeleteBandwidthRateLimit",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "BandwidthType" => BandwidthType, "GatewayARN" => GatewayARN
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_chap_credentials(initiator_name, target_arn)
    delete_chap_credentials(initiator_name, target_arn, params::Dict{String,<:Any})

Deletes Challenge-Handshake Authentication Protocol (CHAP) credentials for a specified
iSCSI target and initiator pair. This operation is supported in volume and tape gateway
types.

# Arguments
- `initiator_name`: The iSCSI initiator that connects to the target.
- `target_arn`: The Amazon Resource Name (ARN) of the iSCSI volume target. Use the
  DescribeStorediSCSIVolumes operation to return to retrieve the TargetARN for specified
  VolumeARN.

"""
function delete_chap_credentials(
    InitiatorName, TargetARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "DeleteChapCredentials",
        Dict{String,Any}("InitiatorName" => InitiatorName, "TargetARN" => TargetARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_chap_credentials(
    InitiatorName,
    TargetARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "DeleteChapCredentials",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "InitiatorName" => InitiatorName, "TargetARN" => TargetARN
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_file_share(file_share_arn)
    delete_file_share(file_share_arn, params::Dict{String,<:Any})

Deletes a file share from an S3 File Gateway. This operation is only supported for S3 File
Gateways.

# Arguments
- `file_share_arn`: The Amazon Resource Name (ARN) of the file share to be deleted.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ForceDelete"`: If this value is set to true, the operation deletes a file share
  immediately and aborts all data uploads to Amazon Web Services. Otherwise, the file share
  is not deleted until all data is uploaded to Amazon Web Services. This process aborts the
  data upload process, and the file share enters the FORCE_DELETING status. Valid Values:
  true | false
"""
function delete_file_share(FileShareARN; aws_config::AbstractAWSConfig=current_aws_config())
    return storage_gateway(
        "DeleteFileShare",
        Dict{String,Any}("FileShareARN" => FileShareARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_file_share(
    FileShareARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "DeleteFileShare",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("FileShareARN" => FileShareARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_gateway(gateway_arn)
    delete_gateway(gateway_arn, params::Dict{String,<:Any})

Deletes a gateway. To specify which gateway to delete, use the Amazon Resource Name (ARN)
of the gateway in your request. The operation deletes the gateway; however, it does not
delete the gateway virtual machine (VM) from your host computer. After you delete a
gateway, you cannot reactivate it. Completed snapshots of the gateway volumes are not
deleted upon deleting the gateway, however, pending snapshots will not complete. After you
delete a gateway, your next step is to remove it from your environment.  You no longer pay
software charges after the gateway is deleted; however, your existing Amazon EBS snapshots
persist and you will continue to be billed for these snapshots. You can choose to remove
all remaining Amazon EBS snapshots by canceling your Amazon EC2 subscription.  If you
prefer not to cancel your Amazon EC2 subscription, you can delete your snapshots using the
Amazon EC2 console. For more information, see the Storage Gateway detail page.

# Arguments
- `gateway_arn`:

"""
function delete_gateway(GatewayARN; aws_config::AbstractAWSConfig=current_aws_config())
    return storage_gateway(
        "DeleteGateway",
        Dict{String,Any}("GatewayARN" => GatewayARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_gateway(
    GatewayARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "DeleteGateway",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("GatewayARN" => GatewayARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_snapshot_schedule(volume_arn)
    delete_snapshot_schedule(volume_arn, params::Dict{String,<:Any})

Deletes a snapshot of a volume. You can take snapshots of your gateway volumes on a
scheduled or ad hoc basis. This API action enables you to delete a snapshot schedule for a
volume. For more information, see Backing up your volumes. In the DeleteSnapshotSchedule
request, you identify the volume by providing its Amazon Resource Name (ARN). This
operation is only supported for cached volume gateway types.  To list or delete a snapshot,
you must use the Amazon EC2 API. For more information, go to DescribeSnapshots in the
Amazon Elastic Compute Cloud API Reference.

# Arguments
- `volume_arn`: The volume which snapshot schedule to delete.

"""
function delete_snapshot_schedule(
    VolumeARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "DeleteSnapshotSchedule",
        Dict{String,Any}("VolumeARN" => VolumeARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_snapshot_schedule(
    VolumeARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "DeleteSnapshotSchedule",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("VolumeARN" => VolumeARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_tape(gateway_arn, tape_arn)
    delete_tape(gateway_arn, tape_arn, params::Dict{String,<:Any})

Deletes the specified virtual tape. This operation is only supported in the tape gateway
type.

# Arguments
- `gateway_arn`: The unique Amazon Resource Name (ARN) of the gateway that the virtual tape
  to delete is associated with. Use the ListGateways operation to return a list of gateways
  for your account and Amazon Web Services Region.
- `tape_arn`: The Amazon Resource Name (ARN) of the virtual tape to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"BypassGovernanceRetention"`: Set to TRUE to delete an archived tape that belongs to a
  custom pool with tape retention lock. Only archived tapes with tape retention lock set to
  governance can be deleted. Archived tapes with tape retention lock set to compliance can't
  be deleted.
"""
function delete_tape(
    GatewayARN, TapeARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "DeleteTape",
        Dict{String,Any}("GatewayARN" => GatewayARN, "TapeARN" => TapeARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_tape(
    GatewayARN,
    TapeARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "DeleteTape",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("GatewayARN" => GatewayARN, "TapeARN" => TapeARN),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_tape_archive(tape_arn)
    delete_tape_archive(tape_arn, params::Dict{String,<:Any})

Deletes the specified virtual tape from the virtual tape shelf (VTS). This operation is
only supported in the tape gateway type.

# Arguments
- `tape_arn`: The Amazon Resource Name (ARN) of the virtual tape to delete from the virtual
  tape shelf (VTS).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"BypassGovernanceRetention"`: Set to TRUE to delete an archived tape that belongs to a
  custom pool with tape retention lock. Only archived tapes with tape retention lock set to
  governance can be deleted. Archived tapes with tape retention lock set to compliance can't
  be deleted.
"""
function delete_tape_archive(TapeARN; aws_config::AbstractAWSConfig=current_aws_config())
    return storage_gateway(
        "DeleteTapeArchive",
        Dict{String,Any}("TapeARN" => TapeARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_tape_archive(
    TapeARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "DeleteTapeArchive",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("TapeARN" => TapeARN), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_tape_pool(pool_arn)
    delete_tape_pool(pool_arn, params::Dict{String,<:Any})

Delete a custom tape pool. A custom tape pool can only be deleted if there are no tapes in
the pool and if there are no automatic tape creation policies that reference the custom
tape pool.

# Arguments
- `pool_arn`: The Amazon Resource Name (ARN) of the custom tape pool to delete.

"""
function delete_tape_pool(PoolARN; aws_config::AbstractAWSConfig=current_aws_config())
    return storage_gateway(
        "DeleteTapePool",
        Dict{String,Any}("PoolARN" => PoolARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_tape_pool(
    PoolARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "DeleteTapePool",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("PoolARN" => PoolARN), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_volume(volume_arn)
    delete_volume(volume_arn, params::Dict{String,<:Any})

Deletes the specified storage volume that you previously created using the
CreateCachediSCSIVolume or CreateStorediSCSIVolume API. This operation is only supported in
the cached volume and stored volume types. For stored volume gateways, the local disk that
was configured as the storage volume is not deleted. You can reuse the local disk to create
another storage volume. Before you delete a volume, make sure there are no iSCSI
connections to the volume you are deleting. You should also make sure there is no snapshot
in progress. You can use the Amazon Elastic Compute Cloud (Amazon EC2) API to query
snapshots on the volume you are deleting and check the snapshot status. For more
information, go to DescribeSnapshots in the Amazon Elastic Compute Cloud API Reference. In
the request, you must provide the Amazon Resource Name (ARN) of the storage volume you want
to delete.

# Arguments
- `volume_arn`: The Amazon Resource Name (ARN) of the volume. Use the ListVolumes operation
  to return a list of gateway volumes.

"""
function delete_volume(VolumeARN; aws_config::AbstractAWSConfig=current_aws_config())
    return storage_gateway(
        "DeleteVolume",
        Dict{String,Any}("VolumeARN" => VolumeARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_volume(
    VolumeARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "DeleteVolume",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("VolumeARN" => VolumeARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_availability_monitor_test(gateway_arn)
    describe_availability_monitor_test(gateway_arn, params::Dict{String,<:Any})

Returns information about the most recent high availability monitoring test that was
performed on the host in a cluster. If a test isn't performed, the status and start time in
the response would be null.

# Arguments
- `gateway_arn`:

"""
function describe_availability_monitor_test(
    GatewayARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "DescribeAvailabilityMonitorTest",
        Dict{String,Any}("GatewayARN" => GatewayARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_availability_monitor_test(
    GatewayARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "DescribeAvailabilityMonitorTest",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("GatewayARN" => GatewayARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_bandwidth_rate_limit(gateway_arn)
    describe_bandwidth_rate_limit(gateway_arn, params::Dict{String,<:Any})

Returns the bandwidth rate limits of a gateway. By default, these limits are not set, which
means no bandwidth rate limiting is in effect. This operation is supported only for the
stored volume, cached volume, and tape gateway types. To describe bandwidth rate limits for
S3 file gateways, use DescribeBandwidthRateLimitSchedule. This operation returns a value
for a bandwidth rate limit only if the limit is set. If no limits are set for the gateway,
then this operation returns only the gateway ARN in the response body. To specify which
gateway to describe, use the Amazon Resource Name (ARN) of the gateway in your request.

# Arguments
- `gateway_arn`:

"""
function describe_bandwidth_rate_limit(
    GatewayARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "DescribeBandwidthRateLimit",
        Dict{String,Any}("GatewayARN" => GatewayARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_bandwidth_rate_limit(
    GatewayARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "DescribeBandwidthRateLimit",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("GatewayARN" => GatewayARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_bandwidth_rate_limit_schedule(gateway_arn)
    describe_bandwidth_rate_limit_schedule(gateway_arn, params::Dict{String,<:Any})

 Returns information about the bandwidth rate limit schedule of a gateway. By default,
gateways do not have bandwidth rate limit schedules, which means no bandwidth rate limiting
is in effect. This operation is supported only for volume, tape and S3 file gateways. FSx
file gateways do not support bandwidth rate limits. This operation returns information
about a gateway's bandwidth rate limit schedule. A bandwidth rate limit schedule consists
of one or more bandwidth rate limit intervals. A bandwidth rate limit interval defines a
period of time on one or more days of the week, during which bandwidth rate limits are
specified for uploading, downloading, or both.   A bandwidth rate limit interval consists
of one or more days of the week, a start hour and minute, an ending hour and minute, and
bandwidth rate limits for uploading and downloading   If no bandwidth rate limit schedule
intervals are set for the gateway, this operation returns an empty response. To specify
which gateway to describe, use the Amazon Resource Name (ARN) of the gateway in your
request.

# Arguments
- `gateway_arn`:

"""
function describe_bandwidth_rate_limit_schedule(
    GatewayARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "DescribeBandwidthRateLimitSchedule",
        Dict{String,Any}("GatewayARN" => GatewayARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_bandwidth_rate_limit_schedule(
    GatewayARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "DescribeBandwidthRateLimitSchedule",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("GatewayARN" => GatewayARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_cache(gateway_arn)
    describe_cache(gateway_arn, params::Dict{String,<:Any})

Returns information about the cache of a gateway. This operation is only supported in the
cached volume, tape, and file gateway types. The response includes disk IDs that are
configured as cache, and it includes the amount of cache allocated and used.

# Arguments
- `gateway_arn`:

"""
function describe_cache(GatewayARN; aws_config::AbstractAWSConfig=current_aws_config())
    return storage_gateway(
        "DescribeCache",
        Dict{String,Any}("GatewayARN" => GatewayARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_cache(
    GatewayARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "DescribeCache",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("GatewayARN" => GatewayARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_cachedi_scsivolumes(volume_arns)
    describe_cachedi_scsivolumes(volume_arns, params::Dict{String,<:Any})

Returns a description of the gateway volumes specified in the request. This operation is
only supported in the cached volume gateway types. The list of gateway volumes in the
request must be from one gateway. In the response, Storage Gateway returns volume
information sorted by volume Amazon Resource Name (ARN).

# Arguments
- `volume_arns`: An array of strings where each string represents the Amazon Resource Name
  (ARN) of a cached volume. All of the specified cached volumes must be from the same
  gateway. Use ListVolumes to get volume ARNs for a gateway.

"""
function describe_cachedi_scsivolumes(
    VolumeARNs; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "DescribeCachediSCSIVolumes",
        Dict{String,Any}("VolumeARNs" => VolumeARNs);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_cachedi_scsivolumes(
    VolumeARNs,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "DescribeCachediSCSIVolumes",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("VolumeARNs" => VolumeARNs), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_chap_credentials(target_arn)
    describe_chap_credentials(target_arn, params::Dict{String,<:Any})

Returns an array of Challenge-Handshake Authentication Protocol (CHAP) credentials
information for a specified iSCSI target, one for each target-initiator pair. This
operation is supported in the volume and tape gateway types.

# Arguments
- `target_arn`: The Amazon Resource Name (ARN) of the iSCSI volume target. Use the
  DescribeStorediSCSIVolumes operation to return to retrieve the TargetARN for specified
  VolumeARN.

"""
function describe_chap_credentials(
    TargetARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "DescribeChapCredentials",
        Dict{String,Any}("TargetARN" => TargetARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_chap_credentials(
    TargetARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "DescribeChapCredentials",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TargetARN" => TargetARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_file_system_associations(file_system_association_arnlist)
    describe_file_system_associations(file_system_association_arnlist, params::Dict{String,<:Any})

Gets the file system association information. This operation is only supported for FSx File
Gateways.

# Arguments
- `file_system_association_arnlist`: An array containing the Amazon Resource Name (ARN) of
  each file system association to be described.

"""
function describe_file_system_associations(
    FileSystemAssociationARNList; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "DescribeFileSystemAssociations",
        Dict{String,Any}("FileSystemAssociationARNList" => FileSystemAssociationARNList);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_file_system_associations(
    FileSystemAssociationARNList,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "DescribeFileSystemAssociations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "FileSystemAssociationARNList" => FileSystemAssociationARNList
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_gateway_information(gateway_arn)
    describe_gateway_information(gateway_arn, params::Dict{String,<:Any})

Returns metadata about a gateway such as its name, network interfaces, time zone, status,
and software version. To specify which gateway to describe, use the Amazon Resource Name
(ARN) of the gateway in your request.

# Arguments
- `gateway_arn`:

"""
function describe_gateway_information(
    GatewayARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "DescribeGatewayInformation",
        Dict{String,Any}("GatewayARN" => GatewayARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_gateway_information(
    GatewayARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "DescribeGatewayInformation",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("GatewayARN" => GatewayARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_maintenance_start_time(gateway_arn)
    describe_maintenance_start_time(gateway_arn, params::Dict{String,<:Any})

Returns your gateway's maintenance window schedule information, with values for monthly or
weekly cadence, specific day and time to begin maintenance, and which types of updates to
apply. Time values returned are for the gateway's time zone.

# Arguments
- `gateway_arn`:

"""
function describe_maintenance_start_time(
    GatewayARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "DescribeMaintenanceStartTime",
        Dict{String,Any}("GatewayARN" => GatewayARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_maintenance_start_time(
    GatewayARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "DescribeMaintenanceStartTime",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("GatewayARN" => GatewayARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_nfsfile_shares(file_share_arnlist)
    describe_nfsfile_shares(file_share_arnlist, params::Dict{String,<:Any})

Gets a description for one or more Network File System (NFS) file shares from an S3 File
Gateway. This operation is only supported for S3 File Gateways.

# Arguments
- `file_share_arnlist`: An array containing the Amazon Resource Name (ARN) of each file
  share to be described.

"""
function describe_nfsfile_shares(
    FileShareARNList; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "DescribeNFSFileShares",
        Dict{String,Any}("FileShareARNList" => FileShareARNList);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_nfsfile_shares(
    FileShareARNList,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "DescribeNFSFileShares",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("FileShareARNList" => FileShareARNList), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_smbfile_shares(file_share_arnlist)
    describe_smbfile_shares(file_share_arnlist, params::Dict{String,<:Any})

Gets a description for one or more Server Message Block (SMB) file shares from a S3 File
Gateway. This operation is only supported for S3 File Gateways.

# Arguments
- `file_share_arnlist`: An array containing the Amazon Resource Name (ARN) of each file
  share to be described.

"""
function describe_smbfile_shares(
    FileShareARNList; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "DescribeSMBFileShares",
        Dict{String,Any}("FileShareARNList" => FileShareARNList);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_smbfile_shares(
    FileShareARNList,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "DescribeSMBFileShares",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("FileShareARNList" => FileShareARNList), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_smbsettings(gateway_arn)
    describe_smbsettings(gateway_arn, params::Dict{String,<:Any})

Gets a description of a Server Message Block (SMB) file share settings from a file gateway.
This operation is only supported for file gateways.

# Arguments
- `gateway_arn`:

"""
function describe_smbsettings(
    GatewayARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "DescribeSMBSettings",
        Dict{String,Any}("GatewayARN" => GatewayARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_smbsettings(
    GatewayARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "DescribeSMBSettings",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("GatewayARN" => GatewayARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_snapshot_schedule(volume_arn)
    describe_snapshot_schedule(volume_arn, params::Dict{String,<:Any})

Describes the snapshot schedule for the specified gateway volume. The snapshot schedule
information includes intervals at which snapshots are automatically initiated on the
volume. This operation is only supported in the cached volume and stored volume types.

# Arguments
- `volume_arn`: The Amazon Resource Name (ARN) of the volume. Use the ListVolumes operation
  to return a list of gateway volumes.

"""
function describe_snapshot_schedule(
    VolumeARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "DescribeSnapshotSchedule",
        Dict{String,Any}("VolumeARN" => VolumeARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_snapshot_schedule(
    VolumeARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "DescribeSnapshotSchedule",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("VolumeARN" => VolumeARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_storedi_scsivolumes(volume_arns)
    describe_storedi_scsivolumes(volume_arns, params::Dict{String,<:Any})

Returns the description of the gateway volumes specified in the request. The list of
gateway volumes in the request must be from one gateway. In the response, Storage Gateway
returns volume information sorted by volume ARNs. This operation is only supported in
stored volume gateway type.

# Arguments
- `volume_arns`: An array of strings where each string represents the Amazon Resource Name
  (ARN) of a stored volume. All of the specified stored volumes must be from the same
  gateway. Use ListVolumes to get volume ARNs for a gateway.

"""
function describe_storedi_scsivolumes(
    VolumeARNs; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "DescribeStorediSCSIVolumes",
        Dict{String,Any}("VolumeARNs" => VolumeARNs);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_storedi_scsivolumes(
    VolumeARNs,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "DescribeStorediSCSIVolumes",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("VolumeARNs" => VolumeARNs), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_tape_archives()
    describe_tape_archives(params::Dict{String,<:Any})

Returns a description of specified virtual tapes in the virtual tape shelf (VTS). This
operation is only supported in the tape gateway type. If a specific TapeARN is not
specified, Storage Gateway returns a description of all virtual tapes found in the VTS
associated with your account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: Specifies that the number of virtual tapes described be limited to the
  specified number.
- `"Marker"`: An opaque string that indicates the position at which to begin describing
  virtual tapes.
- `"TapeARNs"`: Specifies one or more unique Amazon Resource Names (ARNs) that represent
  the virtual tapes you want to describe.
"""
function describe_tape_archives(; aws_config::AbstractAWSConfig=current_aws_config())
    return storage_gateway(
        "DescribeTapeArchives"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_tape_archives(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "DescribeTapeArchives",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_tape_recovery_points(gateway_arn)
    describe_tape_recovery_points(gateway_arn, params::Dict{String,<:Any})

Returns a list of virtual tape recovery points that are available for the specified tape
gateway. A recovery point is a point-in-time view of a virtual tape at which all the data
on the virtual tape is consistent. If your gateway crashes, virtual tapes that have
recovery points can be recovered to a new gateway. This operation is only supported in the
tape gateway type.

# Arguments
- `gateway_arn`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: Specifies that the number of virtual tape recovery points that are described
  be limited to the specified number.
- `"Marker"`: An opaque string that indicates the position at which to begin describing the
  virtual tape recovery points.
"""
function describe_tape_recovery_points(
    GatewayARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "DescribeTapeRecoveryPoints",
        Dict{String,Any}("GatewayARN" => GatewayARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_tape_recovery_points(
    GatewayARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "DescribeTapeRecoveryPoints",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("GatewayARN" => GatewayARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_tapes(gateway_arn)
    describe_tapes(gateway_arn, params::Dict{String,<:Any})

Returns a description of virtual tapes that correspond to the specified Amazon Resource
Names (ARNs). If TapeARN is not specified, returns a description of the virtual tapes
associated with the specified gateway. This operation is only supported for the tape
gateway type. The operation supports pagination. By default, the operation returns a
maximum of up to 100 tapes. You can optionally specify the Limit field in the body to limit
the number of tapes in the response. If the number of tapes returned in the response is
truncated, the response includes a Marker field. You can use this Marker value in your
subsequent request to retrieve the next set of tapes.

# Arguments
- `gateway_arn`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: Specifies that the number of virtual tapes described be limited to the
  specified number.  Amazon Web Services may impose its own limit, if this field is not set.
- `"Marker"`: A marker value, obtained in a previous call to DescribeTapes. This marker
  indicates which page of results to retrieve. If not specified, the first page of results is
  retrieved.
- `"TapeARNs"`: Specifies one or more unique Amazon Resource Names (ARNs) that represent
  the virtual tapes you want to describe. If this parameter is not specified, Tape gateway
  returns a description of all virtual tapes associated with the specified gateway.
"""
function describe_tapes(GatewayARN; aws_config::AbstractAWSConfig=current_aws_config())
    return storage_gateway(
        "DescribeTapes",
        Dict{String,Any}("GatewayARN" => GatewayARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_tapes(
    GatewayARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "DescribeTapes",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("GatewayARN" => GatewayARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_upload_buffer(gateway_arn)
    describe_upload_buffer(gateway_arn, params::Dict{String,<:Any})

Returns information about the upload buffer of a gateway. This operation is supported for
the stored volume, cached volume, and tape gateway types. The response includes disk IDs
that are configured as upload buffer space, and it includes the amount of upload buffer
space allocated and used.

# Arguments
- `gateway_arn`:

"""
function describe_upload_buffer(
    GatewayARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "DescribeUploadBuffer",
        Dict{String,Any}("GatewayARN" => GatewayARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_upload_buffer(
    GatewayARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "DescribeUploadBuffer",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("GatewayARN" => GatewayARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_vtldevices(gateway_arn)
    describe_vtldevices(gateway_arn, params::Dict{String,<:Any})

Returns a description of virtual tape library (VTL) devices for the specified tape gateway.
In the response, Storage Gateway returns VTL device information. This operation is only
supported in the tape gateway type.

# Arguments
- `gateway_arn`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: Specifies that the number of VTL devices described be limited to the specified
  number.
- `"Marker"`: An opaque string that indicates the position at which to begin describing the
  VTL devices.
- `"VTLDeviceARNs"`: An array of strings, where each string represents the Amazon Resource
  Name (ARN) of a VTL device.  All of the specified VTL devices must be from the same
  gateway. If no VTL devices are specified, the result will contain all devices on the
  specified gateway.
"""
function describe_vtldevices(GatewayARN; aws_config::AbstractAWSConfig=current_aws_config())
    return storage_gateway(
        "DescribeVTLDevices",
        Dict{String,Any}("GatewayARN" => GatewayARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_vtldevices(
    GatewayARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "DescribeVTLDevices",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("GatewayARN" => GatewayARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_working_storage(gateway_arn)
    describe_working_storage(gateway_arn, params::Dict{String,<:Any})

Returns information about the working storage of a gateway. This operation is only
supported in the stored volumes gateway type. This operation is deprecated in cached
volumes API version (20120630). Use DescribeUploadBuffer instead.  Working storage is also
referred to as upload buffer. You can also use the DescribeUploadBuffer operation to add
upload buffer to a stored volume gateway.  The response includes disk IDs that are
configured as working storage, and it includes the amount of working storage allocated and
used.

# Arguments
- `gateway_arn`:

"""
function describe_working_storage(
    GatewayARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "DescribeWorkingStorage",
        Dict{String,Any}("GatewayARN" => GatewayARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_working_storage(
    GatewayARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "DescribeWorkingStorage",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("GatewayARN" => GatewayARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    detach_volume(volume_arn)
    detach_volume(volume_arn, params::Dict{String,<:Any})

Disconnects a volume from an iSCSI connection and then detaches the volume from the
specified gateway. Detaching and attaching a volume enables you to recover your data from
one gateway to a different gateway without creating a snapshot. It also makes it easier to
move your volumes from an on-premises gateway to a gateway hosted on an Amazon EC2
instance. This operation is only supported in the volume gateway type.

# Arguments
- `volume_arn`: The Amazon Resource Name (ARN) of the volume to detach from the gateway.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ForceDetach"`: Set to true to forcibly remove the iSCSI connection of the target volume
  and detach the volume. The default is false. If this value is set to false, you must
  manually disconnect the iSCSI connection from the target volume. Valid Values: true | false
"""
function detach_volume(VolumeARN; aws_config::AbstractAWSConfig=current_aws_config())
    return storage_gateway(
        "DetachVolume",
        Dict{String,Any}("VolumeARN" => VolumeARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function detach_volume(
    VolumeARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "DetachVolume",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("VolumeARN" => VolumeARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disable_gateway(gateway_arn)
    disable_gateway(gateway_arn, params::Dict{String,<:Any})

Disables a tape gateway when the gateway is no longer functioning. For example, if your
gateway VM is damaged, you can disable the gateway so you can recover virtual tapes. Use
this operation for a tape gateway that is not reachable or not functioning. This operation
is only supported in the tape gateway type.  After a gateway is disabled, it cannot be
enabled.

# Arguments
- `gateway_arn`:

"""
function disable_gateway(GatewayARN; aws_config::AbstractAWSConfig=current_aws_config())
    return storage_gateway(
        "DisableGateway",
        Dict{String,Any}("GatewayARN" => GatewayARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disable_gateway(
    GatewayARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "DisableGateway",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("GatewayARN" => GatewayARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_file_system(file_system_association_arn)
    disassociate_file_system(file_system_association_arn, params::Dict{String,<:Any})

Disassociates an Amazon FSx file system from the specified gateway. After the
disassociation process finishes, the gateway can no longer access the Amazon FSx file
system. This operation is only supported in the FSx File Gateway type.

# Arguments
- `file_system_association_arn`: The Amazon Resource Name (ARN) of the file system
  association to be deleted.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ForceDelete"`: If this value is set to true, the operation disassociates an Amazon FSx
  file system immediately. It ends all data uploads to the file system, and the file system
  association enters the FORCE_DELETING status. If this value is set to false, the Amazon FSx
  file system does not disassociate until all data is uploaded.
"""
function disassociate_file_system(
    FileSystemAssociationARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "DisassociateFileSystem",
        Dict{String,Any}("FileSystemAssociationARN" => FileSystemAssociationARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_file_system(
    FileSystemAssociationARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "DisassociateFileSystem",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("FileSystemAssociationARN" => FileSystemAssociationARN),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    join_domain(domain_name, gateway_arn, password, user_name)
    join_domain(domain_name, gateway_arn, password, user_name, params::Dict{String,<:Any})

Adds a file gateway to an Active Directory domain. This operation is only supported for
file gateways that support the SMB file protocol.  Joining a domain creates an Active
Directory computer account in the default organizational unit, using the gateway's Gateway
ID as the account name (for example, SGW-1234ADE). If your Active Directory environment
requires that you pre-stage accounts to facilitate the join domain process, you will need
to create this account ahead of time. To create the gateway's computer account in an
organizational unit other than the default, you must specify the organizational unit when
joining the domain.

# Arguments
- `domain_name`: The name of the domain that you want the gateway to join.
- `gateway_arn`: The Amazon Resource Name (ARN) of the gateway. Use the ListGateways
  operation to return a list of gateways for your account and Amazon Web Services Region.
- `password`: Sets the password of the user who has permission to add the gateway to the
  Active Directory domain.
- `user_name`: Sets the user name of user who has permission to add the gateway to the
  Active Directory domain. The domain user account should be enabled to join computers to the
  domain. For example, you can use the domain administrator account or an account with
  delegated permissions to join computers to the domain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DomainControllers"`: List of IPv4 addresses, NetBIOS names, or host names of your
  domain server. If you need to specify the port number include it after the colon (“:”).
  For example, mydc.mydomain.com:389.
- `"OrganizationalUnit"`: The organizational unit (OU) is a container in an Active
  Directory that can hold users, groups, computers, and other OUs and this parameter
  specifies the OU that the gateway will join within the AD domain.
- `"TimeoutInSeconds"`: Specifies the time in seconds, in which the JoinDomain operation
  must complete. The default is 20 seconds.
"""
function join_domain(
    DomainName,
    GatewayARN,
    Password,
    UserName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "JoinDomain",
        Dict{String,Any}(
            "DomainName" => DomainName,
            "GatewayARN" => GatewayARN,
            "Password" => Password,
            "UserName" => UserName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function join_domain(
    DomainName,
    GatewayARN,
    Password,
    UserName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "JoinDomain",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DomainName" => DomainName,
                    "GatewayARN" => GatewayARN,
                    "Password" => Password,
                    "UserName" => UserName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_automatic_tape_creation_policies()
    list_automatic_tape_creation_policies(params::Dict{String,<:Any})

Lists the automatic tape creation policies for a gateway. If there are no automatic tape
creation policies for the gateway, it returns an empty list. This operation is only
supported for tape gateways.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"GatewayARN"`:
"""
function list_automatic_tape_creation_policies(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "ListAutomaticTapeCreationPolicies";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_automatic_tape_creation_policies(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "ListAutomaticTapeCreationPolicies",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_file_shares()
    list_file_shares(params::Dict{String,<:Any})

Gets a list of the file shares for a specific S3 File Gateway, or the list of file shares
that belong to the calling Amazon Web Services account. This operation is only supported
for S3 File Gateways.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"GatewayARN"`: The Amazon Resource Name (ARN) of the gateway whose file shares you want
  to list. If this field is not present, all file shares under your account are listed.
- `"Limit"`: The maximum number of file shares to return in the response. The value must be
  an integer with a value greater than zero. Optional.
- `"Marker"`: Opaque pagination token returned from a previous ListFileShares operation. If
  present, Marker specifies where to continue the list from after a previous call to
  ListFileShares. Optional.
"""
function list_file_shares(; aws_config::AbstractAWSConfig=current_aws_config())
    return storage_gateway(
        "ListFileShares"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_file_shares(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "ListFileShares", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_file_system_associations()
    list_file_system_associations(params::Dict{String,<:Any})

Gets a list of FileSystemAssociationSummary objects. Each object contains a summary of a
file system association. This operation is only supported for FSx File Gateways.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"GatewayARN"`:
- `"Limit"`: The maximum number of file system associations to return in the response. If
  present, Limit must be an integer with a value greater than zero. Optional.
- `"Marker"`: Opaque pagination token returned from a previous ListFileSystemAssociations
  operation. If present, Marker specifies where to continue the list from after a previous
  call to ListFileSystemAssociations. Optional.
"""
function list_file_system_associations(; aws_config::AbstractAWSConfig=current_aws_config())
    return storage_gateway(
        "ListFileSystemAssociations"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_file_system_associations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "ListFileSystemAssociations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_gateways()
    list_gateways(params::Dict{String,<:Any})

Lists gateways owned by an Amazon Web Services account in an Amazon Web Services Region
specified in the request. The returned list is ordered by gateway Amazon Resource Name
(ARN). By default, the operation returns a maximum of 100 gateways. This operation supports
pagination that allows you to optionally reduce the number of gateways returned in a
response. If you have more gateways than are returned in a response (that is, the response
returns only a truncated list of your gateways), the response contains a marker that you
can specify in your next request to fetch the next page of gateways.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: Specifies that the list of gateways returned be limited to the specified
  number of items.
- `"Marker"`: An opaque string that indicates the position at which to begin the returned
  list of gateways.
"""
function list_gateways(; aws_config::AbstractAWSConfig=current_aws_config())
    return storage_gateway(
        "ListGateways"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_gateways(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "ListGateways", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_local_disks(gateway_arn)
    list_local_disks(gateway_arn, params::Dict{String,<:Any})

Returns a list of the gateway's local disks. To specify which gateway to describe, you use
the Amazon Resource Name (ARN) of the gateway in the body of the request. The request
returns a list of all disks, specifying which are configured as working storage, cache
storage, or stored volume or not configured at all. The response includes a DiskStatus
field. This field can have a value of present (the disk is available to use), missing (the
disk is no longer connected to the gateway), or mismatch (the disk node is occupied by a
disk that has incorrect metadata or the disk content is corrupted).

# Arguments
- `gateway_arn`:

"""
function list_local_disks(GatewayARN; aws_config::AbstractAWSConfig=current_aws_config())
    return storage_gateway(
        "ListLocalDisks",
        Dict{String,Any}("GatewayARN" => GatewayARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_local_disks(
    GatewayARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "ListLocalDisks",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("GatewayARN" => GatewayARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists the tags that have been added to the specified resource. This operation is supported
in storage gateways of all types.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource for which you want to list
  tags.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: Specifies that the list of tags returned be limited to the specified number of
  items.
- `"Marker"`: An opaque string that indicates the position at which to begin returning the
  list of tags.
"""
function list_tags_for_resource(
    ResourceARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "ListTagsForResource",
        Dict{String,Any}("ResourceARN" => ResourceARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceARN" => ResourceARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tape_pools()
    list_tape_pools(params::Dict{String,<:Any})

Lists custom tape pools. You specify custom tape pools to list by specifying one or more
custom tape pool Amazon Resource Names (ARNs). If you don't specify a custom tape pool ARN,
the operation lists all custom tape pools. This operation supports pagination. You can
optionally specify the Limit parameter in the body to limit the number of tape pools in the
response. If the number of tape pools returned in the response is truncated, the response
includes a Marker element that you can use in your subsequent request to retrieve the next
set of tape pools.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: An optional number limit for the tape pools in the list returned by this call.
- `"Marker"`: A string that indicates the position at which to begin the returned list of
  tape pools.
- `"PoolARNs"`: The Amazon Resource Name (ARN) of each of the custom tape pools you want to
  list. If you don't specify a custom tape pool ARN, the response lists all custom tape
  pools.
"""
function list_tape_pools(; aws_config::AbstractAWSConfig=current_aws_config())
    return storage_gateway(
        "ListTapePools"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_tape_pools(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "ListTapePools", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tapes()
    list_tapes(params::Dict{String,<:Any})

Lists virtual tapes in your virtual tape library (VTL) and your virtual tape shelf (VTS).
You specify the tapes to list by specifying one or more tape Amazon Resource Names (ARNs).
If you don't specify a tape ARN, the operation lists all virtual tapes in both your VTL and
VTS. This operation supports pagination. By default, the operation returns a maximum of up
to 100 tapes. You can optionally specify the Limit parameter in the body to limit the
number of tapes in the response. If the number of tapes returned in the response is
truncated, the response includes a Marker element that you can use in your subsequent
request to retrieve the next set of tapes. This operation is only supported in the tape
gateway type.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: An optional number limit for the tapes in the list returned by this call.
- `"Marker"`: A string that indicates the position at which to begin the returned list of
  tapes.
- `"TapeARNs"`:
"""
function list_tapes(; aws_config::AbstractAWSConfig=current_aws_config())
    return storage_gateway(
        "ListTapes"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_tapes(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "ListTapes", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_volume_initiators(volume_arn)
    list_volume_initiators(volume_arn, params::Dict{String,<:Any})

Lists iSCSI initiators that are connected to a volume. You can use this operation to
determine whether a volume is being used or not. This operation is only supported in the
cached volume and stored volume gateway types.

# Arguments
- `volume_arn`: The Amazon Resource Name (ARN) of the volume. Use the ListVolumes operation
  to return a list of gateway volumes for the gateway.

"""
function list_volume_initiators(
    VolumeARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "ListVolumeInitiators",
        Dict{String,Any}("VolumeARN" => VolumeARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_volume_initiators(
    VolumeARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "ListVolumeInitiators",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("VolumeARN" => VolumeARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_volume_recovery_points(gateway_arn)
    list_volume_recovery_points(gateway_arn, params::Dict{String,<:Any})

Lists the recovery points for a specified gateway. This operation is only supported in the
cached volume gateway type. Each cache volume has one recovery point. A volume recovery
point is a point in time at which all data of the volume is consistent and from which you
can create a snapshot or clone a new cached volume from a source volume. To create a
snapshot from a volume recovery point use the CreateSnapshotFromVolumeRecoveryPoint
operation.

# Arguments
- `gateway_arn`:

"""
function list_volume_recovery_points(
    GatewayARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "ListVolumeRecoveryPoints",
        Dict{String,Any}("GatewayARN" => GatewayARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_volume_recovery_points(
    GatewayARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "ListVolumeRecoveryPoints",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("GatewayARN" => GatewayARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_volumes()
    list_volumes(params::Dict{String,<:Any})

Lists the iSCSI stored volumes of a gateway. Results are sorted by volume ARN. The response
includes only the volume ARNs. If you want additional volume information, use the
DescribeStorediSCSIVolumes or the DescribeCachediSCSIVolumes API. The operation supports
pagination. By default, the operation returns a maximum of up to 100 volumes. You can
optionally specify the Limit field in the body to limit the number of volumes in the
response. If the number of volumes returned in the response is truncated, the response
includes a Marker field. You can use this Marker value in your subsequent request to
retrieve the next set of volumes. This operation is only supported in the cached volume and
stored volume gateway types.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"GatewayARN"`:
- `"Limit"`: Specifies that the list of volumes returned be limited to the specified number
  of items.
- `"Marker"`: A string that indicates the position at which to begin the returned list of
  volumes. Obtain the marker from the response of a previous List iSCSI Volumes request.
"""
function list_volumes(; aws_config::AbstractAWSConfig=current_aws_config())
    return storage_gateway(
        "ListVolumes"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_volumes(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "ListVolumes", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    notify_when_uploaded(file_share_arn)
    notify_when_uploaded(file_share_arn, params::Dict{String,<:Any})

Sends you notification through CloudWatch Events when all files written to your file share
have been uploaded to Amazon S3. Storage Gateway can send a notification through Amazon
CloudWatch Events when all files written to your file share up to that point in time have
been uploaded to Amazon S3. These files include files written to the file share up to the
time that you make a request for notification. When the upload is done, Storage Gateway
sends you notification through an Amazon CloudWatch Event. You can configure CloudWatch
Events to send the notification through event targets such as Amazon SNS or Lambda
function. This operation is only supported for S3 File Gateways. For more information, see
Getting file upload notification in the Amazon S3 File Gateway User Guide.

# Arguments
- `file_share_arn`:

"""
function notify_when_uploaded(
    FileShareARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "NotifyWhenUploaded",
        Dict{String,Any}("FileShareARN" => FileShareARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function notify_when_uploaded(
    FileShareARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "NotifyWhenUploaded",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("FileShareARN" => FileShareARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    refresh_cache(file_share_arn)
    refresh_cache(file_share_arn, params::Dict{String,<:Any})

Refreshes the cached inventory of objects for the specified file share. This operation
finds objects in the Amazon S3 bucket that were added, removed, or replaced since the
gateway last listed the bucket's contents and cached the results. This operation does not
import files into the S3 File Gateway cache storage. It only updates the cached inventory
to reflect changes in the inventory of the objects in the S3 bucket. This operation is only
supported in the S3 File Gateway types. You can subscribe to be notified through an Amazon
CloudWatch event when your RefreshCache operation completes. For more information, see
Getting notified about file operations in the Amazon S3 File Gateway User Guide. This
operation is Only supported for S3 File Gateways. When this API is called, it only
initiates the refresh operation. When the API call completes and returns a success code, it
doesn't necessarily mean that the file refresh has completed. You should use the
refresh-complete notification to determine that the operation has completed before you
check for new files on the gateway file share. You can subscribe to be notified through a
CloudWatch event when your RefreshCache operation completes. Throttle limit: This API is
asynchronous, so the gateway will accept no more than two refreshes at any time. We
recommend using the refresh-complete CloudWatch event notification before issuing
additional requests. For more information, see Getting notified about file operations in
the Amazon S3 File Gateway User Guide.    Wait at least 60 seconds between consecutive
RefreshCache API requests.   If you invoke the RefreshCache API when two requests are
already being processed, any new request will cause an InvalidGatewayRequestException error
because too many requests were sent to the server.     The S3 bucket name does not need to
be included when entering the list of folders in the FolderList parameter.  For more
information, see Getting notified about file operations in the Amazon S3 File Gateway User
Guide.

# Arguments
- `file_share_arn`: The Amazon Resource Name (ARN) of the file share you want to refresh.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FolderList"`: A comma-separated list of the paths of folders to refresh in the cache.
  The default is [\"/\"]. The default refreshes objects and folders at the root of the Amazon
  S3 bucket. If Recursive is set to true, the entire S3 bucket that the file share has access
  to is refreshed. Do not include / when specifying folder names. For example, you would
  specify samplefolder rather than samplefolder/.
- `"Recursive"`: A value that specifies whether to recursively refresh folders in the
  cache. The refresh includes folders that were in the cache the last time the gateway listed
  the folder's contents. If this value set to true, each folder that is listed in FolderList
  is recursively updated. Otherwise, subfolders listed in FolderList are not refreshed. Only
  objects that are in folders listed directly under FolderList are found and used for the
  update. The default is true. Valid Values: true | false
"""
function refresh_cache(FileShareARN; aws_config::AbstractAWSConfig=current_aws_config())
    return storage_gateway(
        "RefreshCache",
        Dict{String,Any}("FileShareARN" => FileShareARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function refresh_cache(
    FileShareARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "RefreshCache",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("FileShareARN" => FileShareARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_tags_from_resource(resource_arn, tag_keys)
    remove_tags_from_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes one or more tags from the specified resource. This operation is supported in
storage gateways of all types.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource you want to remove the
  tags from.
- `tag_keys`: The keys of the tags you want to remove from the specified resource. A tag is
  composed of a key-value pair.

"""
function remove_tags_from_resource(
    ResourceARN, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "RemoveTagsFromResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_tags_from_resource(
    ResourceARN,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "RemoveTagsFromResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    reset_cache(gateway_arn)
    reset_cache(gateway_arn, params::Dict{String,<:Any})

Resets all cache disks that have encountered an error and makes the disks available for
reconfiguration as cache storage. If your cache disk encounters an error, the gateway
prevents read and write operations on virtual tapes in the gateway. For example, an error
can occur when a disk is corrupted or removed from the gateway. When a cache is reset, the
gateway loses its cache storage. At this point, you can reconfigure the disks as cache
disks. This operation is only supported in the cached volume and tape types.  If the cache
disk you are resetting contains data that has not been uploaded to Amazon S3 yet, that data
can be lost. After you reset cache disks, there will be no configured cache disks left in
the gateway, so you must configure at least one new cache disk for your gateway to function
properly.

# Arguments
- `gateway_arn`:

"""
function reset_cache(GatewayARN; aws_config::AbstractAWSConfig=current_aws_config())
    return storage_gateway(
        "ResetCache",
        Dict{String,Any}("GatewayARN" => GatewayARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function reset_cache(
    GatewayARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "ResetCache",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("GatewayARN" => GatewayARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    retrieve_tape_archive(gateway_arn, tape_arn)
    retrieve_tape_archive(gateway_arn, tape_arn, params::Dict{String,<:Any})

Retrieves an archived virtual tape from the virtual tape shelf (VTS) to a tape gateway.
Virtual tapes archived in the VTS are not associated with any gateway. However after a tape
is retrieved, it is associated with a gateway, even though it is also listed in the VTS,
that is, archive. This operation is only supported in the tape gateway type. Once a tape is
successfully retrieved to a gateway, it cannot be retrieved again to another gateway. You
must archive the tape again before you can retrieve it to another gateway. This operation
is only supported in the tape gateway type.

# Arguments
- `gateway_arn`: The Amazon Resource Name (ARN) of the gateway you want to retrieve the
  virtual tape to. Use the ListGateways operation to return a list of gateways for your
  account and Amazon Web Services Region. You retrieve archived virtual tapes to only one
  gateway and the gateway must be a tape gateway.
- `tape_arn`: The Amazon Resource Name (ARN) of the virtual tape you want to retrieve from
  the virtual tape shelf (VTS).

"""
function retrieve_tape_archive(
    GatewayARN, TapeARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "RetrieveTapeArchive",
        Dict{String,Any}("GatewayARN" => GatewayARN, "TapeARN" => TapeARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function retrieve_tape_archive(
    GatewayARN,
    TapeARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "RetrieveTapeArchive",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("GatewayARN" => GatewayARN, "TapeARN" => TapeARN),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    retrieve_tape_recovery_point(gateway_arn, tape_arn)
    retrieve_tape_recovery_point(gateway_arn, tape_arn, params::Dict{String,<:Any})

Retrieves the recovery point for the specified virtual tape. This operation is only
supported in the tape gateway type. A recovery point is a point in time view of a virtual
tape at which all the data on the tape is consistent. If your gateway crashes, virtual
tapes that have recovery points can be recovered to a new gateway.  The virtual tape can be
retrieved to only one gateway. The retrieved tape is read-only. The virtual tape can be
retrieved to only a tape gateway. There is no charge for retrieving recovery points.

# Arguments
- `gateway_arn`:
- `tape_arn`: The Amazon Resource Name (ARN) of the virtual tape for which you want to
  retrieve the recovery point.

"""
function retrieve_tape_recovery_point(
    GatewayARN, TapeARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "RetrieveTapeRecoveryPoint",
        Dict{String,Any}("GatewayARN" => GatewayARN, "TapeARN" => TapeARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function retrieve_tape_recovery_point(
    GatewayARN,
    TapeARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "RetrieveTapeRecoveryPoint",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("GatewayARN" => GatewayARN, "TapeARN" => TapeARN),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    set_local_console_password(gateway_arn, local_console_password)
    set_local_console_password(gateway_arn, local_console_password, params::Dict{String,<:Any})

Sets the password for your VM local console. When you log in to the local console for the
first time, you log in to the VM with the default credentials. We recommend that you set a
new password. You don't need to know the default password to set a new password.

# Arguments
- `gateway_arn`:
- `local_console_password`: The password you want to set for your VM local console.

"""
function set_local_console_password(
    GatewayARN, LocalConsolePassword; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "SetLocalConsolePassword",
        Dict{String,Any}(
            "GatewayARN" => GatewayARN, "LocalConsolePassword" => LocalConsolePassword
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function set_local_console_password(
    GatewayARN,
    LocalConsolePassword,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "SetLocalConsolePassword",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "GatewayARN" => GatewayARN,
                    "LocalConsolePassword" => LocalConsolePassword,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    set_smbguest_password(gateway_arn, password)
    set_smbguest_password(gateway_arn, password, params::Dict{String,<:Any})

Sets the password for the guest user smbguest. The smbguest user is the user when the
authentication method for the file share is set to GuestAccess. This operation only
supported for S3 File Gateways

# Arguments
- `gateway_arn`: The Amazon Resource Name (ARN) of the S3 File Gateway the SMB file share
  is associated with.
- `password`: The password that you want to set for your SMB server.

"""
function set_smbguest_password(
    GatewayARN, Password; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "SetSMBGuestPassword",
        Dict{String,Any}("GatewayARN" => GatewayARN, "Password" => Password);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function set_smbguest_password(
    GatewayARN,
    Password,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "SetSMBGuestPassword",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("GatewayARN" => GatewayARN, "Password" => Password),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    shutdown_gateway(gateway_arn)
    shutdown_gateway(gateway_arn, params::Dict{String,<:Any})

Shuts down a Tape Gateway or Volume Gateway. To specify which gateway to shut down, use the
Amazon Resource Name (ARN) of the gateway in the body of your request.  This API action
cannot be used to shut down S3 File Gateway or FSx File Gateway.  The operation shuts down
the gateway service component running in the gateway's virtual machine (VM) and not the
host VM.  If you want to shut down the VM, it is recommended that you first shut down the
gateway component in the VM to avoid unpredictable conditions.  After the gateway is
shutdown, you cannot call any other API except StartGateway, DescribeGatewayInformation,
and ListGateways. For more information, see ActivateGateway. Your applications cannot read
from or write to the gateway's storage volumes, and there are no snapshots taken.  When you
make a shutdown request, you will get a 200 OK success response immediately. However, it
might take some time for the gateway to shut down. You can call the
DescribeGatewayInformation API to check the status. For more information, see
ActivateGateway.  If do not intend to use the gateway again, you must delete the gateway
(using DeleteGateway) to no longer pay software charges associated with the gateway.

# Arguments
- `gateway_arn`:

"""
function shutdown_gateway(GatewayARN; aws_config::AbstractAWSConfig=current_aws_config())
    return storage_gateway(
        "ShutdownGateway",
        Dict{String,Any}("GatewayARN" => GatewayARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function shutdown_gateway(
    GatewayARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "ShutdownGateway",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("GatewayARN" => GatewayARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_availability_monitor_test(gateway_arn)
    start_availability_monitor_test(gateway_arn, params::Dict{String,<:Any})

Start a test that verifies that the specified gateway is configured for High Availability
monitoring in your host environment. This request only initiates the test and that a
successful response only indicates that the test was started. It doesn't indicate that the
test passed. For the status of the test, invoke the DescribeAvailabilityMonitorTest API.
Starting this test will cause your gateway to go offline for a brief period.

# Arguments
- `gateway_arn`:

"""
function start_availability_monitor_test(
    GatewayARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "StartAvailabilityMonitorTest",
        Dict{String,Any}("GatewayARN" => GatewayARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_availability_monitor_test(
    GatewayARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "StartAvailabilityMonitorTest",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("GatewayARN" => GatewayARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_gateway(gateway_arn)
    start_gateway(gateway_arn, params::Dict{String,<:Any})

Starts a gateway that you previously shut down (see ShutdownGateway). After the gateway
starts, you can then make other API calls, your applications can read from or write to the
gateway's storage volumes and you will be able to take snapshot backups.  When you make a
request, you will get a 200 OK success response immediately. However, it might take some
time for the gateway to be ready. You should call DescribeGatewayInformation and check the
status before making any additional API calls. For more information, see ActivateGateway.
To specify which gateway to start, use the Amazon Resource Name (ARN) of the gateway in
your request.

# Arguments
- `gateway_arn`:

"""
function start_gateway(GatewayARN; aws_config::AbstractAWSConfig=current_aws_config())
    return storage_gateway(
        "StartGateway",
        Dict{String,Any}("GatewayARN" => GatewayARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_gateway(
    GatewayARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "StartGateway",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("GatewayARN" => GatewayARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_automatic_tape_creation_policy(automatic_tape_creation_rules, gateway_arn)
    update_automatic_tape_creation_policy(automatic_tape_creation_rules, gateway_arn, params::Dict{String,<:Any})

Updates the automatic tape creation policy of a gateway. Use this to update the policy with
a new set of automatic tape creation rules. This is only supported for tape gateways. By
default, there is no automatic tape creation policy.  A gateway can have only one automatic
tape creation policy.

# Arguments
- `automatic_tape_creation_rules`: An automatic tape creation policy consists of a list of
  automatic tape creation rules. The rules determine when and how to automatically create new
  tapes.
- `gateway_arn`:

"""
function update_automatic_tape_creation_policy(
    AutomaticTapeCreationRules,
    GatewayARN;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "UpdateAutomaticTapeCreationPolicy",
        Dict{String,Any}(
            "AutomaticTapeCreationRules" => AutomaticTapeCreationRules,
            "GatewayARN" => GatewayARN,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_automatic_tape_creation_policy(
    AutomaticTapeCreationRules,
    GatewayARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "UpdateAutomaticTapeCreationPolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AutomaticTapeCreationRules" => AutomaticTapeCreationRules,
                    "GatewayARN" => GatewayARN,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_bandwidth_rate_limit(gateway_arn)
    update_bandwidth_rate_limit(gateway_arn, params::Dict{String,<:Any})

Updates the bandwidth rate limits of a gateway. You can update both the upload and download
bandwidth rate limit or specify only one of the two. If you don't set a bandwidth rate
limit, the existing rate limit remains. This operation is supported only for the stored
volume, cached volume, and tape gateway types. To update bandwidth rate limits for S3 file
gateways, use UpdateBandwidthRateLimitSchedule. By default, a gateway's bandwidth rate
limits are not set. If you don't set any limit, the gateway does not have any limitations
on its bandwidth usage and could potentially use the maximum available bandwidth. To
specify which gateway to update, use the Amazon Resource Name (ARN) of the gateway in your
request.

# Arguments
- `gateway_arn`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AverageDownloadRateLimitInBitsPerSec"`: The average download bandwidth rate limit in
  bits per second.
- `"AverageUploadRateLimitInBitsPerSec"`: The average upload bandwidth rate limit in bits
  per second.
"""
function update_bandwidth_rate_limit(
    GatewayARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "UpdateBandwidthRateLimit",
        Dict{String,Any}("GatewayARN" => GatewayARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_bandwidth_rate_limit(
    GatewayARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "UpdateBandwidthRateLimit",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("GatewayARN" => GatewayARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_bandwidth_rate_limit_schedule(bandwidth_rate_limit_intervals, gateway_arn)
    update_bandwidth_rate_limit_schedule(bandwidth_rate_limit_intervals, gateway_arn, params::Dict{String,<:Any})

 Updates the bandwidth rate limit schedule for a specified gateway. By default, gateways do
not have bandwidth rate limit schedules, which means no bandwidth rate limiting is in
effect. Use this to initiate or update a gateway's bandwidth rate limit schedule. This
operation is supported for volume, tape, and S3 file gateways. S3 file gateways support
bandwidth rate limits for upload only. FSx file gateways do not support bandwidth rate
limits.

# Arguments
- `bandwidth_rate_limit_intervals`:  An array containing bandwidth rate limit schedule
  intervals for a gateway. When no bandwidth rate limit intervals have been scheduled, the
  array is empty.
- `gateway_arn`:

"""
function update_bandwidth_rate_limit_schedule(
    BandwidthRateLimitIntervals,
    GatewayARN;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "UpdateBandwidthRateLimitSchedule",
        Dict{String,Any}(
            "BandwidthRateLimitIntervals" => BandwidthRateLimitIntervals,
            "GatewayARN" => GatewayARN,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_bandwidth_rate_limit_schedule(
    BandwidthRateLimitIntervals,
    GatewayARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "UpdateBandwidthRateLimitSchedule",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "BandwidthRateLimitIntervals" => BandwidthRateLimitIntervals,
                    "GatewayARN" => GatewayARN,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_chap_credentials(initiator_name, secret_to_authenticate_initiator, target_arn)
    update_chap_credentials(initiator_name, secret_to_authenticate_initiator, target_arn, params::Dict{String,<:Any})

Updates the Challenge-Handshake Authentication Protocol (CHAP) credentials for a specified
iSCSI target. By default, a gateway does not have CHAP enabled; however, for added
security, you might use it. This operation is supported in the volume and tape gateway
types.  When you update CHAP credentials, all existing connections on the target are closed
and initiators must reconnect with the new credentials.

# Arguments
- `initiator_name`: The iSCSI initiator that connects to the target.
- `secret_to_authenticate_initiator`: The secret key that the initiator (for example, the
  Windows client) must provide to participate in mutual CHAP with the target.  The secret key
  must be between 12 and 16 bytes when encoded in UTF-8.
- `target_arn`: The Amazon Resource Name (ARN) of the iSCSI volume target. Use the
  DescribeStorediSCSIVolumes operation to return the TargetARN for specified VolumeARN.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"SecretToAuthenticateTarget"`: The secret key that the target must provide to
  participate in mutual CHAP with the initiator (e.g. Windows client). Byte constraints:
  Minimum bytes of 12. Maximum bytes of 16.  The secret key must be between 12 and 16 bytes
  when encoded in UTF-8.
"""
function update_chap_credentials(
    InitiatorName,
    SecretToAuthenticateInitiator,
    TargetARN;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "UpdateChapCredentials",
        Dict{String,Any}(
            "InitiatorName" => InitiatorName,
            "SecretToAuthenticateInitiator" => SecretToAuthenticateInitiator,
            "TargetARN" => TargetARN,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_chap_credentials(
    InitiatorName,
    SecretToAuthenticateInitiator,
    TargetARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "UpdateChapCredentials",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "InitiatorName" => InitiatorName,
                    "SecretToAuthenticateInitiator" => SecretToAuthenticateInitiator,
                    "TargetARN" => TargetARN,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_file_system_association(file_system_association_arn)
    update_file_system_association(file_system_association_arn, params::Dict{String,<:Any})

Updates a file system association. This operation is only supported in the FSx File
Gateways.

# Arguments
- `file_system_association_arn`: The Amazon Resource Name (ARN) of the file system
  association that you want to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AuditDestinationARN"`: The Amazon Resource Name (ARN) of the storage used for the audit
  logs.
- `"CacheAttributes"`:
- `"Password"`: The password of the user credential.
- `"UserName"`: The user name of the user credential that has permission to access the root
  share D of the Amazon FSx file system. The user account must belong to the Amazon FSx
  delegated admin user group.
"""
function update_file_system_association(
    FileSystemAssociationARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "UpdateFileSystemAssociation",
        Dict{String,Any}("FileSystemAssociationARN" => FileSystemAssociationARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_file_system_association(
    FileSystemAssociationARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "UpdateFileSystemAssociation",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("FileSystemAssociationARN" => FileSystemAssociationARN),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_gateway_information(gateway_arn)
    update_gateway_information(gateway_arn, params::Dict{String,<:Any})

Updates a gateway's metadata, which includes the gateway's name, time zone, and metadata
cache size. To specify which gateway to update, use the Amazon Resource Name (ARN) of the
gateway in your request.  For gateways activated after September 2, 2015, the gateway's ARN
contains the gateway ID rather than the gateway name. However, changing the name of the
gateway has no effect on the gateway's ARN.

# Arguments
- `gateway_arn`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CloudWatchLogGroupARN"`: The Amazon Resource Name (ARN) of the Amazon CloudWatch log
  group that you want to use to monitor and log events in the gateway. For more information,
  see What is Amazon CloudWatch Logs?
- `"GatewayCapacity"`: Specifies the size of the gateway's metadata cache. This setting
  impacts gateway performance and hardware recommendations. For more information, see
  Performance guidance for gateways with multiple file shares in the Amazon S3 File Gateway
  User Guide.
- `"GatewayName"`:
- `"GatewayTimezone"`: A value that indicates the time zone of the gateway.
"""
function update_gateway_information(
    GatewayARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "UpdateGatewayInformation",
        Dict{String,Any}("GatewayARN" => GatewayARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_gateway_information(
    GatewayARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "UpdateGatewayInformation",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("GatewayARN" => GatewayARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_gateway_software_now(gateway_arn)
    update_gateway_software_now(gateway_arn, params::Dict{String,<:Any})

Updates the gateway virtual machine (VM) software. The request immediately triggers the
software update.  When you make this request, you get a 200 OK success response
immediately. However, it might take some time for the update to complete. You can call
DescribeGatewayInformation to verify the gateway is in the STATE_RUNNING state.   A
software update forces a system restart of your gateway. You can minimize the chance of any
disruption to your applications by increasing your iSCSI Initiators' timeouts. For more
information about increasing iSCSI Initiator timeouts for Windows and Linux, see
Customizing your Windows iSCSI settings and Customizing your Linux iSCSI settings,
respectively.

# Arguments
- `gateway_arn`:

"""
function update_gateway_software_now(
    GatewayARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "UpdateGatewaySoftwareNow",
        Dict{String,Any}("GatewayARN" => GatewayARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_gateway_software_now(
    GatewayARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "UpdateGatewaySoftwareNow",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("GatewayARN" => GatewayARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_maintenance_start_time(gateway_arn)
    update_maintenance_start_time(gateway_arn, params::Dict{String,<:Any})

Updates a gateway's maintenance window schedule, with settings for monthly or weekly
cadence, specific day and time to begin maintenance, and which types of updates to apply.
Time configuration uses the gateway's time zone. You can pass values for a complete
maintenance schedule, or update policy, or both. Previous values will persist for whichever
setting you choose not to modify. If an incomplete or invalid maintenance schedule is
passed, the entire request will be rejected with an error and no changes will occur. A
complete maintenance schedule must include values for both MinuteOfHour and HourOfDay, and
either DayOfMonth or DayOfWeek.  We recommend keeping maintenance updates turned on, except
in specific use cases where the brief disruptions caused by updating the gateway could
critically impact your deployment.

# Arguments
- `gateway_arn`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DayOfMonth"`: The day of the month component of the maintenance start time represented
  as an ordinal number from 1 to 28, where 1 represents the first day of the month. It is not
  possible to set the maintenance schedule to start on days 29 through 31.
- `"DayOfWeek"`: The day of the week component of the maintenance start time week
  represented as an ordinal number from 0 to 6, where 0 represents Sunday and 6 represents
  Saturday.
- `"HourOfDay"`: The hour component of the maintenance start time represented as hh, where
  hh is the hour (00 to 23). The hour of the day is in the time zone of the gateway.
- `"MinuteOfHour"`: The minute component of the maintenance start time represented as mm,
  where mm is the minute (00 to 59). The minute of the hour is in the time zone of the
  gateway.
- `"SoftwareUpdatePreferences"`: A set of variables indicating the software update
  preferences for the gateway. Includes AutomaticUpdatePolicy field with the following
  inputs:  ALL_VERSIONS - Enables regular gateway maintenance updates.
  EMERGENCY_VERSIONS_ONLY - Disables regular gateway maintenance updates.
"""
function update_maintenance_start_time(
    GatewayARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "UpdateMaintenanceStartTime",
        Dict{String,Any}("GatewayARN" => GatewayARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_maintenance_start_time(
    GatewayARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "UpdateMaintenanceStartTime",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("GatewayARN" => GatewayARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_nfsfile_share(file_share_arn)
    update_nfsfile_share(file_share_arn, params::Dict{String,<:Any})

Updates a Network File System (NFS) file share. This operation is only supported in S3 File
Gateways.  To leave a file share field unchanged, set the corresponding input field to
null.  Updates the following file share settings:   Default storage class for your S3
bucket   Metadata defaults for your S3 bucket   Allowed NFS clients for your file share
Squash settings   Write status of your file share

# Arguments
- `file_share_arn`: The Amazon Resource Name (ARN) of the file share to be updated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AuditDestinationARN"`: The Amazon Resource Name (ARN) of the storage used for audit
  logs.
- `"CacheAttributes"`: Specifies refresh cache information for the file share.
- `"ClientList"`: The list of clients that are allowed to access the S3 File Gateway. The
  list must contain either valid IP addresses or valid CIDR blocks.
- `"DefaultStorageClass"`: The default storage class for objects put into an Amazon S3
  bucket by the S3 File Gateway. The default value is S3_STANDARD. Optional. Valid Values:
  S3_STANDARD | S3_INTELLIGENT_TIERING | S3_STANDARD_IA | S3_ONEZONE_IA
- `"FileShareName"`: The name of the file share. Optional.   FileShareName must be set if
  an S3 prefix name is set in LocationARN, or if an access point or access point alias is
  used.
- `"GuessMIMETypeEnabled"`: A value that enables guessing of the MIME type for uploaded
  objects based on file extensions. Set this value to true to enable MIME type guessing,
  otherwise set to false. The default value is true. Valid Values: true | false
- `"KMSEncrypted"`: Set to true to use Amazon S3 server-side encryption with your own KMS
  key, or false to use a key managed by Amazon S3. Optional. Valid Values: true | false
- `"KMSKey"`: The Amazon Resource Name (ARN) of a symmetric customer master key (CMK) used
  for Amazon S3 server-side encryption. Storage Gateway does not support asymmetric CMKs.
  This value can only be set when KMSEncrypted is true. Optional.
- `"NFSFileShareDefaults"`: The default values for the file share. Optional.
- `"NotificationPolicy"`: The notification policy of the file share. SettlingTimeInSeconds
  controls the number of seconds to wait after the last point in time a client wrote to a
  file before generating an ObjectUploaded notification. Because clients can make many small
  writes to files, it's best to set this parameter for as long as possible to avoid
  generating multiple notifications for the same file in a small time period.
  SettlingTimeInSeconds has no effect on the timing of the object uploading to Amazon S3,
  only the timing of the notification.  The following example sets NotificationPolicy on with
  SettlingTimeInSeconds set to 60.  {\"Upload\": {\"SettlingTimeInSeconds\": 60}}  The
  following example sets NotificationPolicy off.  {}
- `"ObjectACL"`: A value that sets the access control list (ACL) permission for objects in
  the S3 bucket that a S3 File Gateway puts objects into. The default value is private.
- `"ReadOnly"`: A value that sets the write status of a file share. Set this value to true
  to set the write status to read-only, otherwise set to false. Valid Values: true | false
- `"RequesterPays"`: A value that sets who pays the cost of the request and the cost
  associated with data download from the S3 bucket. If this value is set to true, the
  requester pays the costs; otherwise, the S3 bucket owner pays. However, the S3 bucket owner
  always pays the cost of storing data.   RequesterPays is a configuration for the S3 bucket
  that backs the file share, so make sure that the configuration on the file share is the
  same as the S3 bucket configuration.  Valid Values: true | false
- `"Squash"`: The user mapped to anonymous user. Valid values are the following:
  RootSquash: Only root is mapped to anonymous user.    NoSquash: No one is mapped to
  anonymous user.    AllSquash: Everyone is mapped to anonymous user.
"""
function update_nfsfile_share(
    FileShareARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "UpdateNFSFileShare",
        Dict{String,Any}("FileShareARN" => FileShareARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_nfsfile_share(
    FileShareARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "UpdateNFSFileShare",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("FileShareARN" => FileShareARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_smbfile_share(file_share_arn)
    update_smbfile_share(file_share_arn, params::Dict{String,<:Any})

Updates a Server Message Block (SMB) file share. This operation is only supported for S3
File Gateways.  To leave a file share field unchanged, set the corresponding input field to
null.   File gateways require Security Token Service (Amazon Web Services STS) to be
activated to enable you to create a file share. Make sure that Amazon Web Services STS is
activated in the Amazon Web Services Region you are creating your file gateway in. If
Amazon Web Services STS is not activated in this Amazon Web Services Region, activate it.
For information about how to activate Amazon Web Services STS, see Activating and
deactivating Amazon Web Services STS in an Amazon Web Services Region in the Identity and
Access Management User Guide. File gateways don't support creating hard or symbolic links
on a file share.

# Arguments
- `file_share_arn`: The Amazon Resource Name (ARN) of the SMB file share that you want to
  update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccessBasedEnumeration"`: The files and folders on this share will only be visible to
  users with read access.
- `"AdminUserList"`: A list of users or groups in the Active Directory that have
  administrator rights to the file share. A group must be prefixed with the @ character.
  Acceptable formats include: DOMAINUser1, user1, @group1, and @DOMAINgroup1. Can only be set
  if Authentication is set to ActiveDirectory.
- `"AuditDestinationARN"`: The Amazon Resource Name (ARN) of the storage used for audit
  logs.
- `"CacheAttributes"`: Specifies refresh cache information for the file share.
- `"CaseSensitivity"`: The case of an object name in an Amazon S3 bucket. For
  ClientSpecified, the client determines the case sensitivity. For CaseSensitive, the gateway
  determines the case sensitivity. The default value is ClientSpecified.
- `"DefaultStorageClass"`: The default storage class for objects put into an Amazon S3
  bucket by the S3 File Gateway. The default value is S3_STANDARD. Optional. Valid Values:
  S3_STANDARD | S3_INTELLIGENT_TIERING | S3_STANDARD_IA | S3_ONEZONE_IA
- `"FileShareName"`: The name of the file share. Optional.   FileShareName must be set if
  an S3 prefix name is set in LocationARN, or if an access point or access point alias is
  used.
- `"GuessMIMETypeEnabled"`: A value that enables guessing of the MIME type for uploaded
  objects based on file extensions. Set this value to true to enable MIME type guessing,
  otherwise set to false. The default value is true. Valid Values: true | false
- `"InvalidUserList"`: A list of users or groups in the Active Directory that are not
  allowed to access the file share. A group must be prefixed with the @ character. Acceptable
  formats include: DOMAINUser1, user1, @group1, and @DOMAINgroup1. Can only be set if
  Authentication is set to ActiveDirectory.
- `"KMSEncrypted"`: Set to true to use Amazon S3 server-side encryption with your own KMS
  key, or false to use a key managed by Amazon S3. Optional. Valid Values: true | false
- `"KMSKey"`: The Amazon Resource Name (ARN) of a symmetric customer master key (CMK) used
  for Amazon S3 server-side encryption. Storage Gateway does not support asymmetric CMKs.
  This value can only be set when KMSEncrypted is true. Optional.
- `"NotificationPolicy"`: The notification policy of the file share. SettlingTimeInSeconds
  controls the number of seconds to wait after the last point in time a client wrote to a
  file before generating an ObjectUploaded notification. Because clients can make many small
  writes to files, it's best to set this parameter for as long as possible to avoid
  generating multiple notifications for the same file in a small time period.
  SettlingTimeInSeconds has no effect on the timing of the object uploading to Amazon S3,
  only the timing of the notification.  The following example sets NotificationPolicy on with
  SettlingTimeInSeconds set to 60.  {\"Upload\": {\"SettlingTimeInSeconds\": 60}}  The
  following example sets NotificationPolicy off.  {}
- `"ObjectACL"`: A value that sets the access control list (ACL) permission for objects in
  the S3 bucket that a S3 File Gateway puts objects into. The default value is private.
- `"OplocksEnabled"`: Specifies whether opportunistic locking is enabled for the SMB file
  share.  Enabling opportunistic locking on case-sensitive shares is not recommended for
  workloads that involve access to files with the same name in different case.  Valid Values:
  true | false
- `"ReadOnly"`: A value that sets the write status of a file share. Set this value to true
  to set write status to read-only, otherwise set to false. Valid Values: true | false
- `"RequesterPays"`: A value that sets who pays the cost of the request and the cost
  associated with data download from the S3 bucket. If this value is set to true, the
  requester pays the costs; otherwise, the S3 bucket owner pays. However, the S3 bucket owner
  always pays the cost of storing data.   RequesterPays is a configuration for the S3 bucket
  that backs the file share, so make sure that the configuration on the file share is the
  same as the S3 bucket configuration.  Valid Values: true | false
- `"SMBACLEnabled"`: Set this value to true to enable access control list (ACL) on the SMB
  file share. Set it to false to map file and directory permissions to the POSIX permissions.
  For more information, see Using Microsoft Windows ACLs to control access to an SMB file
  share in the Storage Gateway User Guide. Valid Values: true | false
- `"ValidUserList"`: A list of users or groups in the Active Directory that are allowed to
  access the file share. A group must be prefixed with the @ character. Acceptable formats
  include: DOMAINUser1, user1, @group1, and @DOMAINgroup1. Can only be set if Authentication
  is set to ActiveDirectory.
"""
function update_smbfile_share(
    FileShareARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "UpdateSMBFileShare",
        Dict{String,Any}("FileShareARN" => FileShareARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_smbfile_share(
    FileShareARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "UpdateSMBFileShare",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("FileShareARN" => FileShareARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_smbfile_share_visibility(file_shares_visible, gateway_arn)
    update_smbfile_share_visibility(file_shares_visible, gateway_arn, params::Dict{String,<:Any})

Controls whether the shares on an S3 File Gateway are visible in a net view or browse list.
The operation is only supported for S3 File Gateways.

# Arguments
- `file_shares_visible`: The shares on this gateway appear when listing shares.
- `gateway_arn`:

"""
function update_smbfile_share_visibility(
    FileSharesVisible, GatewayARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "UpdateSMBFileShareVisibility",
        Dict{String,Any}(
            "FileSharesVisible" => FileSharesVisible, "GatewayARN" => GatewayARN
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_smbfile_share_visibility(
    FileSharesVisible,
    GatewayARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "UpdateSMBFileShareVisibility",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "FileSharesVisible" => FileSharesVisible, "GatewayARN" => GatewayARN
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_smblocal_groups(gateway_arn, smblocal_groups)
    update_smblocal_groups(gateway_arn, smblocal_groups, params::Dict{String,<:Any})

Updates the list of Active Directory users and groups that have special permissions for SMB
file shares on the gateway.

# Arguments
- `gateway_arn`:
- `smblocal_groups`: A list of Active Directory users and groups that you want to grant
  special permissions for SMB file shares on the gateway.

"""
function update_smblocal_groups(
    GatewayARN, SMBLocalGroups; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "UpdateSMBLocalGroups",
        Dict{String,Any}("GatewayARN" => GatewayARN, "SMBLocalGroups" => SMBLocalGroups);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_smblocal_groups(
    GatewayARN,
    SMBLocalGroups,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "UpdateSMBLocalGroups",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "GatewayARN" => GatewayARN, "SMBLocalGroups" => SMBLocalGroups
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_smbsecurity_strategy(gateway_arn, smbsecurity_strategy)
    update_smbsecurity_strategy(gateway_arn, smbsecurity_strategy, params::Dict{String,<:Any})

Updates the SMB security strategy level for an Amazon S3 file gateway. This action is only
supported for Amazon S3 file gateways.  For information about configuring this setting
using the Amazon Web Services console, see Setting a security level for your gateway in the
Amazon S3 File Gateway User Guide. A higher security strategy level can affect performance
of the gateway.

# Arguments
- `gateway_arn`:
- `smbsecurity_strategy`: Specifies the type of security strategy.  ClientSpecified: If you
  choose this option, requests are established based on what is negotiated by the client.
  This option is recommended when you want to maximize compatibility across different clients
  in your environment. Supported only for S3 File Gateway.  MandatorySigning: If you choose
  this option, File Gateway only allows connections from SMBv2 or SMBv3 clients that have
  signing enabled. This option works with SMB clients on Microsoft Windows Vista, Windows
  Server 2008 or newer.  MandatoryEncryption: If you choose this option, File Gateway only
  allows connections from SMBv3 clients that have encryption enabled. This option is
  recommended for environments that handle sensitive data. This option works with SMB clients
  on Microsoft Windows 8, Windows Server 2012 or newer.  MandatoryEncryptionNoAes128: If you
  choose this option, File Gateway only allows connections from SMBv3 clients that use
  256-bit AES encryption algorithms. 128-bit algorithms are not allowed. This option is
  recommended for environments that handle sensitive data. It works with SMB clients on
  Microsoft Windows 8, Windows Server 2012, or later.

"""
function update_smbsecurity_strategy(
    GatewayARN, SMBSecurityStrategy; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "UpdateSMBSecurityStrategy",
        Dict{String,Any}(
            "GatewayARN" => GatewayARN, "SMBSecurityStrategy" => SMBSecurityStrategy
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_smbsecurity_strategy(
    GatewayARN,
    SMBSecurityStrategy,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "UpdateSMBSecurityStrategy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "GatewayARN" => GatewayARN, "SMBSecurityStrategy" => SMBSecurityStrategy
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_snapshot_schedule(recurrence_in_hours, start_at, volume_arn)
    update_snapshot_schedule(recurrence_in_hours, start_at, volume_arn, params::Dict{String,<:Any})

Updates a snapshot schedule configured for a gateway volume. This operation is only
supported in the cached volume and stored volume gateway types. The default snapshot
schedule for volume is once every 24 hours, starting at the creation time of the volume.
You can use this API to change the snapshot schedule configured for the volume. In the
request you must identify the gateway volume whose snapshot schedule you want to update,
and the schedule information, including when you want the snapshot to begin on a day and
the frequency (in hours) of snapshots.

# Arguments
- `recurrence_in_hours`: Frequency of snapshots. Specify the number of hours between
  snapshots.
- `start_at`: The hour of the day at which the snapshot schedule begins represented as hh,
  where hh is the hour (0 to 23). The hour of the day is in the time zone of the gateway.
- `volume_arn`: The Amazon Resource Name (ARN) of the volume. Use the ListVolumes operation
  to return a list of gateway volumes.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: Optional description of the snapshot that overwrites the existing
  description.
- `"Tags"`: A list of up to 50 tags that can be assigned to a snapshot. Each tag is a
  key-value pair.  Valid characters for key and value are letters, spaces, and numbers
  representable in UTF-8 format, and the following special characters: + - = . _ : / @. The
  maximum length of a tag's key is 128 characters, and the maximum length for a tag's value
  is 256.
"""
function update_snapshot_schedule(
    RecurrenceInHours,
    StartAt,
    VolumeARN;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "UpdateSnapshotSchedule",
        Dict{String,Any}(
            "RecurrenceInHours" => RecurrenceInHours,
            "StartAt" => StartAt,
            "VolumeARN" => VolumeARN,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_snapshot_schedule(
    RecurrenceInHours,
    StartAt,
    VolumeARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "UpdateSnapshotSchedule",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "RecurrenceInHours" => RecurrenceInHours,
                    "StartAt" => StartAt,
                    "VolumeARN" => VolumeARN,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_vtldevice_type(device_type, vtldevice_arn)
    update_vtldevice_type(device_type, vtldevice_arn, params::Dict{String,<:Any})

Updates the type of medium changer in a tape gateway. When you activate a tape gateway, you
select a medium changer type for the tape gateway. This operation enables you to select a
different type of medium changer after a tape gateway is activated. This operation is only
supported in the tape gateway type.

# Arguments
- `device_type`: The type of medium changer you want to select. Valid Values: STK-L700 |
  AWS-Gateway-VTL | IBM-03584L32-0402
- `vtldevice_arn`: The Amazon Resource Name (ARN) of the medium changer you want to select.

"""
function update_vtldevice_type(
    DeviceType, VTLDeviceARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return storage_gateway(
        "UpdateVTLDeviceType",
        Dict{String,Any}("DeviceType" => DeviceType, "VTLDeviceARN" => VTLDeviceARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_vtldevice_type(
    DeviceType,
    VTLDeviceARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return storage_gateway(
        "UpdateVTLDeviceType",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DeviceType" => DeviceType, "VTLDeviceARN" => VTLDeviceARN
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: ses
using AWS.Compat
using AWS.UUIDs

"""
    clone_receipt_rule_set(original_rule_set_name, rule_set_name)
    clone_receipt_rule_set(original_rule_set_name, rule_set_name, params::Dict{String,<:Any})

Creates a receipt rule set by cloning an existing one. All receipt rules and configurations
are copied to the new receipt rule set and are completely independent of the source rule
set. For information about setting up rule sets, see the Amazon SES Developer Guide. You
can execute this operation no more than once per second.

# Arguments
- `original_rule_set_name`: The name of the rule set to clone.
- `rule_set_name`: The name of the rule set to create. The name must meet the following
  requirements:   Contain only ASCII letters (a-z, A-Z), numbers (0-9), underscores (_), or
  dashes (-).   Start and end with a letter or number.   Contain 64 characters or fewer.

"""
function clone_receipt_rule_set(
    OriginalRuleSetName, RuleSetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "CloneReceiptRuleSet",
        Dict{String,Any}(
            "OriginalRuleSetName" => OriginalRuleSetName, "RuleSetName" => RuleSetName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function clone_receipt_rule_set(
    OriginalRuleSetName,
    RuleSetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "CloneReceiptRuleSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "OriginalRuleSetName" => OriginalRuleSetName,
                    "RuleSetName" => RuleSetName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_configuration_set(configuration_set)
    create_configuration_set(configuration_set, params::Dict{String,<:Any})

Creates a configuration set. Configuration sets enable you to publish email sending events.
For information about using configuration sets, see the Amazon SES Developer Guide. You can
execute this operation no more than once per second.

# Arguments
- `configuration_set`: A data structure that contains the name of the configuration set.

"""
function create_configuration_set(
    ConfigurationSet; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "CreateConfigurationSet",
        Dict{String,Any}("ConfigurationSet" => ConfigurationSet);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_configuration_set(
    ConfigurationSet,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "CreateConfigurationSet",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ConfigurationSet" => ConfigurationSet), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_configuration_set_event_destination(configuration_set_name, event_destination)
    create_configuration_set_event_destination(configuration_set_name, event_destination, params::Dict{String,<:Any})

Creates a configuration set event destination.  When you create or update an event
destination, you must provide one, and only one, destination. The destination can be
CloudWatch, Amazon Kinesis Firehose, or Amazon Simple Notification Service (Amazon SNS).
An event destination is the Amazon Web Services service to which Amazon SES publishes the
email sending events associated with a configuration set. For information about using
configuration sets, see the Amazon SES Developer Guide. You can execute this operation no
more than once per second.

# Arguments
- `configuration_set_name`: The name of the configuration set that the event destination
  should be associated with.
- `event_destination`: An object that describes the Amazon Web Services service that email
  sending event where information is published.

"""
function create_configuration_set_event_destination(
    ConfigurationSetName,
    EventDestination;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "CreateConfigurationSetEventDestination",
        Dict{String,Any}(
            "ConfigurationSetName" => ConfigurationSetName,
            "EventDestination" => EventDestination,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_configuration_set_event_destination(
    ConfigurationSetName,
    EventDestination,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "CreateConfigurationSetEventDestination",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ConfigurationSetName" => ConfigurationSetName,
                    "EventDestination" => EventDestination,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_configuration_set_tracking_options(configuration_set_name, tracking_options)
    create_configuration_set_tracking_options(configuration_set_name, tracking_options, params::Dict{String,<:Any})

Creates an association between a configuration set and a custom domain for open and click
event tracking.  By default, images and links used for tracking open and click events are
hosted on domains operated by Amazon SES. You can configure a subdomain of your own to
handle these events. For information about using custom domains, see the Amazon SES
Developer Guide.

# Arguments
- `configuration_set_name`: The name of the configuration set that the tracking options
  should be associated with.
- `tracking_options`:

"""
function create_configuration_set_tracking_options(
    ConfigurationSetName,
    TrackingOptions;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "CreateConfigurationSetTrackingOptions",
        Dict{String,Any}(
            "ConfigurationSetName" => ConfigurationSetName,
            "TrackingOptions" => TrackingOptions,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_configuration_set_tracking_options(
    ConfigurationSetName,
    TrackingOptions,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "CreateConfigurationSetTrackingOptions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ConfigurationSetName" => ConfigurationSetName,
                    "TrackingOptions" => TrackingOptions,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_custom_verification_email_template(failure_redirection_url, from_email_address, success_redirection_url, template_content, template_name, template_subject)
    create_custom_verification_email_template(failure_redirection_url, from_email_address, success_redirection_url, template_content, template_name, template_subject, params::Dict{String,<:Any})

Creates a new custom verification email template. For more information about custom
verification email templates, see Using Custom Verification Email Templates in the Amazon
SES Developer Guide. You can execute this operation no more than once per second.

# Arguments
- `failure_redirection_url`: The URL that the recipient of the verification email is sent
  to if his or her address is not successfully verified.
- `from_email_address`: The email address that the custom verification email is sent from.
- `success_redirection_url`: The URL that the recipient of the verification email is sent
  to if his or her address is successfully verified.
- `template_content`: The content of the custom verification email. The total size of the
  email must be less than 10 MB. The message body may contain HTML, with some limitations.
  For more information, see Custom Verification Email Frequently Asked Questions in the
  Amazon SES Developer Guide.
- `template_name`: The name of the custom verification email template.
- `template_subject`: The subject line of the custom verification email.

"""
function create_custom_verification_email_template(
    FailureRedirectionURL,
    FromEmailAddress,
    SuccessRedirectionURL,
    TemplateContent,
    TemplateName,
    TemplateSubject;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "CreateCustomVerificationEmailTemplate",
        Dict{String,Any}(
            "FailureRedirectionURL" => FailureRedirectionURL,
            "FromEmailAddress" => FromEmailAddress,
            "SuccessRedirectionURL" => SuccessRedirectionURL,
            "TemplateContent" => TemplateContent,
            "TemplateName" => TemplateName,
            "TemplateSubject" => TemplateSubject,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_custom_verification_email_template(
    FailureRedirectionURL,
    FromEmailAddress,
    SuccessRedirectionURL,
    TemplateContent,
    TemplateName,
    TemplateSubject,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "CreateCustomVerificationEmailTemplate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "FailureRedirectionURL" => FailureRedirectionURL,
                    "FromEmailAddress" => FromEmailAddress,
                    "SuccessRedirectionURL" => SuccessRedirectionURL,
                    "TemplateContent" => TemplateContent,
                    "TemplateName" => TemplateName,
                    "TemplateSubject" => TemplateSubject,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_receipt_filter(filter)
    create_receipt_filter(filter, params::Dict{String,<:Any})

Creates a new IP address filter. For information about setting up IP address filters, see
the Amazon SES Developer Guide. You can execute this operation no more than once per second.

# Arguments
- `filter`: A data structure that describes the IP address filter to create, which consists
  of a name, an IP address range, and whether to allow or block mail from it.

"""
function create_receipt_filter(Filter; aws_config::AbstractAWSConfig=current_aws_config())
    return ses(
        "CreateReceiptFilter",
        Dict{String,Any}("Filter" => Filter);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_receipt_filter(
    Filter, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "CreateReceiptFilter",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Filter" => Filter), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_receipt_rule(rule, rule_set_name)
    create_receipt_rule(rule, rule_set_name, params::Dict{String,<:Any})

Creates a receipt rule. For information about setting up receipt rules, see the Amazon SES
Developer Guide. You can execute this operation no more than once per second.

# Arguments
- `rule`: A data structure that contains the specified rule's name, actions, recipients,
  domains, enabled status, scan status, and TLS policy.
- `rule_set_name`: The name of the rule set where the receipt rule is added.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"After"`: The name of an existing rule after which the new rule is placed. If this
  parameter is null, the new rule is inserted at the beginning of the rule list.
"""
function create_receipt_rule(
    Rule, RuleSetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "CreateReceiptRule",
        Dict{String,Any}("Rule" => Rule, "RuleSetName" => RuleSetName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_receipt_rule(
    Rule,
    RuleSetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "CreateReceiptRule",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Rule" => Rule, "RuleSetName" => RuleSetName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_receipt_rule_set(rule_set_name)
    create_receipt_rule_set(rule_set_name, params::Dict{String,<:Any})

Creates an empty receipt rule set. For information about setting up receipt rule sets, see
the Amazon SES Developer Guide. You can execute this operation no more than once per second.

# Arguments
- `rule_set_name`: The name of the rule set to create. The name must meet the following
  requirements:   Contain only ASCII letters (a-z, A-Z), numbers (0-9), underscores (_), or
  dashes (-).   Start and end with a letter or number.   Contain 64 characters or fewer.

"""
function create_receipt_rule_set(
    RuleSetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "CreateReceiptRuleSet",
        Dict{String,Any}("RuleSetName" => RuleSetName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_receipt_rule_set(
    RuleSetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "CreateReceiptRuleSet",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("RuleSetName" => RuleSetName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_template(template)
    create_template(template, params::Dict{String,<:Any})

Creates an email template. Email templates enable you to send personalized email to one or
more destinations in a single operation. For more information, see the Amazon SES Developer
Guide. You can execute this operation no more than once per second.

# Arguments
- `template`: The content of the email, composed of a subject line and either an HTML part
  or a text-only part.

"""
function create_template(Template; aws_config::AbstractAWSConfig=current_aws_config())
    return ses(
        "CreateTemplate",
        Dict{String,Any}("Template" => Template);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_template(
    Template,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "CreateTemplate",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Template" => Template), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_configuration_set(configuration_set_name)
    delete_configuration_set(configuration_set_name, params::Dict{String,<:Any})

Deletes a configuration set. Configuration sets enable you to publish email sending events.
For information about using configuration sets, see the Amazon SES Developer Guide. You can
execute this operation no more than once per second.

# Arguments
- `configuration_set_name`: The name of the configuration set to delete.

"""
function delete_configuration_set(
    ConfigurationSetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "DeleteConfigurationSet",
        Dict{String,Any}("ConfigurationSetName" => ConfigurationSetName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_configuration_set(
    ConfigurationSetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "DeleteConfigurationSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ConfigurationSetName" => ConfigurationSetName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_configuration_set_event_destination(configuration_set_name, event_destination_name)
    delete_configuration_set_event_destination(configuration_set_name, event_destination_name, params::Dict{String,<:Any})

Deletes a configuration set event destination. Configuration set event destinations are
associated with configuration sets, which enable you to publish email sending events. For
information about using configuration sets, see the Amazon SES Developer Guide. You can
execute this operation no more than once per second.

# Arguments
- `configuration_set_name`: The name of the configuration set from which to delete the
  event destination.
- `event_destination_name`: The name of the event destination to delete.

"""
function delete_configuration_set_event_destination(
    ConfigurationSetName,
    EventDestinationName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "DeleteConfigurationSetEventDestination",
        Dict{String,Any}(
            "ConfigurationSetName" => ConfigurationSetName,
            "EventDestinationName" => EventDestinationName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_configuration_set_event_destination(
    ConfigurationSetName,
    EventDestinationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "DeleteConfigurationSetEventDestination",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ConfigurationSetName" => ConfigurationSetName,
                    "EventDestinationName" => EventDestinationName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_configuration_set_tracking_options(configuration_set_name)
    delete_configuration_set_tracking_options(configuration_set_name, params::Dict{String,<:Any})

Deletes an association between a configuration set and a custom domain for open and click
event tracking. By default, images and links used for tracking open and click events are
hosted on domains operated by Amazon SES. You can configure a subdomain of your own to
handle these events. For information about using custom domains, see the Amazon SES
Developer Guide.  Deleting this kind of association results in emails sent using the
specified configuration set to capture open and click events using the standard, Amazon
SES-operated domains.

# Arguments
- `configuration_set_name`: The name of the configuration set.

"""
function delete_configuration_set_tracking_options(
    ConfigurationSetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "DeleteConfigurationSetTrackingOptions",
        Dict{String,Any}("ConfigurationSetName" => ConfigurationSetName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_configuration_set_tracking_options(
    ConfigurationSetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "DeleteConfigurationSetTrackingOptions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ConfigurationSetName" => ConfigurationSetName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_custom_verification_email_template(template_name)
    delete_custom_verification_email_template(template_name, params::Dict{String,<:Any})

Deletes an existing custom verification email template.  For more information about custom
verification email templates, see Using Custom Verification Email Templates in the Amazon
SES Developer Guide. You can execute this operation no more than once per second.

# Arguments
- `template_name`: The name of the custom verification email template to delete.

"""
function delete_custom_verification_email_template(
    TemplateName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "DeleteCustomVerificationEmailTemplate",
        Dict{String,Any}("TemplateName" => TemplateName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_custom_verification_email_template(
    TemplateName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "DeleteCustomVerificationEmailTemplate",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TemplateName" => TemplateName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_identity(identity)
    delete_identity(identity, params::Dict{String,<:Any})

Deletes the specified identity (an email address or a domain) from the list of verified
identities. You can execute this operation no more than once per second.

# Arguments
- `identity`: The identity to be removed from the list of identities for the Amazon Web
  Services account.

"""
function delete_identity(Identity; aws_config::AbstractAWSConfig=current_aws_config())
    return ses(
        "DeleteIdentity",
        Dict{String,Any}("Identity" => Identity);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_identity(
    Identity,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "DeleteIdentity",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Identity" => Identity), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_identity_policy(identity, policy_name)
    delete_identity_policy(identity, policy_name, params::Dict{String,<:Any})

Deletes the specified sending authorization policy for the given identity (an email address
or a domain). This operation returns successfully even if a policy with the specified name
does not exist.  This operation is for the identity owner only. If you have not verified
the identity, it returns an error.  Sending authorization is a feature that enables an
identity owner to authorize other senders to use its identities. For information about
using sending authorization, see the Amazon SES Developer Guide. You can execute this
operation no more than once per second.

# Arguments
- `identity`: The identity that is associated with the policy to delete. You can specify
  the identity by using its name or by using its Amazon Resource Name (ARN). Examples:
  user@example.com, example.com, arn:aws:ses:us-east-1:123456789012:identity/example.com. To
  successfully call this operation, you must own the identity.
- `policy_name`: The name of the policy to be deleted.

"""
function delete_identity_policy(
    Identity, PolicyName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "DeleteIdentityPolicy",
        Dict{String,Any}("Identity" => Identity, "PolicyName" => PolicyName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_identity_policy(
    Identity,
    PolicyName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "DeleteIdentityPolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Identity" => Identity, "PolicyName" => PolicyName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_receipt_filter(filter_name)
    delete_receipt_filter(filter_name, params::Dict{String,<:Any})

Deletes the specified IP address filter. For information about managing IP address filters,
see the Amazon SES Developer Guide. You can execute this operation no more than once per
second.

# Arguments
- `filter_name`: The name of the IP address filter to delete.

"""
function delete_receipt_filter(
    FilterName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "DeleteReceiptFilter",
        Dict{String,Any}("FilterName" => FilterName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_receipt_filter(
    FilterName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "DeleteReceiptFilter",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("FilterName" => FilterName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_receipt_rule(rule_name, rule_set_name)
    delete_receipt_rule(rule_name, rule_set_name, params::Dict{String,<:Any})

Deletes the specified receipt rule. For information about managing receipt rules, see the
Amazon SES Developer Guide. You can execute this operation no more than once per second.

# Arguments
- `rule_name`: The name of the receipt rule to delete.
- `rule_set_name`: The name of the receipt rule set that contains the receipt rule to
  delete.

"""
function delete_receipt_rule(
    RuleName, RuleSetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "DeleteReceiptRule",
        Dict{String,Any}("RuleName" => RuleName, "RuleSetName" => RuleSetName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_receipt_rule(
    RuleName,
    RuleSetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "DeleteReceiptRule",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("RuleName" => RuleName, "RuleSetName" => RuleSetName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_receipt_rule_set(rule_set_name)
    delete_receipt_rule_set(rule_set_name, params::Dict{String,<:Any})

Deletes the specified receipt rule set and all of the receipt rules it contains.  The
currently active rule set cannot be deleted.  For information about managing receipt rule
sets, see the Amazon SES Developer Guide. You can execute this operation no more than once
per second.

# Arguments
- `rule_set_name`: The name of the receipt rule set to delete.

"""
function delete_receipt_rule_set(
    RuleSetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "DeleteReceiptRuleSet",
        Dict{String,Any}("RuleSetName" => RuleSetName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_receipt_rule_set(
    RuleSetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "DeleteReceiptRuleSet",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("RuleSetName" => RuleSetName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_template(template_name)
    delete_template(template_name, params::Dict{String,<:Any})

Deletes an email template. You can execute this operation no more than once per second.

# Arguments
- `template_name`: The name of the template to be deleted.

"""
function delete_template(TemplateName; aws_config::AbstractAWSConfig=current_aws_config())
    return ses(
        "DeleteTemplate",
        Dict{String,Any}("TemplateName" => TemplateName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_template(
    TemplateName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "DeleteTemplate",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TemplateName" => TemplateName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_verified_email_address(email_address)
    delete_verified_email_address(email_address, params::Dict{String,<:Any})

Deprecated. Use the DeleteIdentity operation to delete email addresses and domains.

# Arguments
- `email_address`: An email address to be removed from the list of verified addresses.

"""
function delete_verified_email_address(
    EmailAddress; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "DeleteVerifiedEmailAddress",
        Dict{String,Any}("EmailAddress" => EmailAddress);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_verified_email_address(
    EmailAddress,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "DeleteVerifiedEmailAddress",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("EmailAddress" => EmailAddress), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_active_receipt_rule_set()
    describe_active_receipt_rule_set(params::Dict{String,<:Any})

Returns the metadata and receipt rules for the receipt rule set that is currently active.
For information about setting up receipt rule sets, see the Amazon SES Developer Guide. You
can execute this operation no more than once per second.

"""
function describe_active_receipt_rule_set(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "DescribeActiveReceiptRuleSet";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_active_receipt_rule_set(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "DescribeActiveReceiptRuleSet",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_configuration_set(configuration_set_name)
    describe_configuration_set(configuration_set_name, params::Dict{String,<:Any})

Returns the details of the specified configuration set. For information about using
configuration sets, see the Amazon SES Developer Guide. You can execute this operation no
more than once per second.

# Arguments
- `configuration_set_name`: The name of the configuration set to describe.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConfigurationSetAttributeNames"`: A list of configuration set attributes to return.
"""
function describe_configuration_set(
    ConfigurationSetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "DescribeConfigurationSet",
        Dict{String,Any}("ConfigurationSetName" => ConfigurationSetName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_configuration_set(
    ConfigurationSetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "DescribeConfigurationSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ConfigurationSetName" => ConfigurationSetName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_receipt_rule(rule_name, rule_set_name)
    describe_receipt_rule(rule_name, rule_set_name, params::Dict{String,<:Any})

Returns the details of the specified receipt rule. For information about setting up receipt
rules, see the Amazon SES Developer Guide. You can execute this operation no more than once
per second.

# Arguments
- `rule_name`: The name of the receipt rule.
- `rule_set_name`: The name of the receipt rule set that the receipt rule belongs to.

"""
function describe_receipt_rule(
    RuleName, RuleSetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "DescribeReceiptRule",
        Dict{String,Any}("RuleName" => RuleName, "RuleSetName" => RuleSetName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_receipt_rule(
    RuleName,
    RuleSetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "DescribeReceiptRule",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("RuleName" => RuleName, "RuleSetName" => RuleSetName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_receipt_rule_set(rule_set_name)
    describe_receipt_rule_set(rule_set_name, params::Dict{String,<:Any})

Returns the details of the specified receipt rule set. For information about managing
receipt rule sets, see the Amazon SES Developer Guide. You can execute this operation no
more than once per second.

# Arguments
- `rule_set_name`: The name of the receipt rule set to describe.

"""
function describe_receipt_rule_set(
    RuleSetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "DescribeReceiptRuleSet",
        Dict{String,Any}("RuleSetName" => RuleSetName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_receipt_rule_set(
    RuleSetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "DescribeReceiptRuleSet",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("RuleSetName" => RuleSetName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_account_sending_enabled()
    get_account_sending_enabled(params::Dict{String,<:Any})

Returns the email sending status of the Amazon SES account for the current Region. You can
execute this operation no more than once per second.

"""
function get_account_sending_enabled(; aws_config::AbstractAWSConfig=current_aws_config())
    return ses(
        "GetAccountSendingEnabled"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_account_sending_enabled(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "GetAccountSendingEnabled",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_custom_verification_email_template(template_name)
    get_custom_verification_email_template(template_name, params::Dict{String,<:Any})

Returns the custom email verification template for the template name you specify. For more
information about custom verification email templates, see Using Custom Verification Email
Templates in the Amazon SES Developer Guide. You can execute this operation no more than
once per second.

# Arguments
- `template_name`: The name of the custom verification email template to retrieve.

"""
function get_custom_verification_email_template(
    TemplateName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "GetCustomVerificationEmailTemplate",
        Dict{String,Any}("TemplateName" => TemplateName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_custom_verification_email_template(
    TemplateName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "GetCustomVerificationEmailTemplate",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TemplateName" => TemplateName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_identity_dkim_attributes(identities)
    get_identity_dkim_attributes(identities, params::Dict{String,<:Any})

Returns the current status of Easy DKIM signing for an entity. For domain name identities,
this operation also returns the DKIM tokens that are required for Easy DKIM signing, and
whether Amazon SES has successfully verified that these tokens have been published. This
operation takes a list of identities as input and returns the following information for
each:   Whether Easy DKIM signing is enabled or disabled.   A set of DKIM tokens that
represent the identity. If the identity is an email address, the tokens represent the
domain of that address.   Whether Amazon SES has successfully verified the DKIM tokens
published in the domain's DNS. This information is only returned for domain name
identities, not for email addresses.   This operation is throttled at one request per
second and can only get DKIM attributes for up to 100 identities at a time. For more
information about creating DNS records using DKIM tokens, go to the Amazon SES Developer
Guide.

# Arguments
- `identities`: A list of one or more verified identities - email addresses, domains, or
  both.

"""
function get_identity_dkim_attributes(
    Identities; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "GetIdentityDkimAttributes",
        Dict{String,Any}("Identities" => Identities);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_identity_dkim_attributes(
    Identities,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "GetIdentityDkimAttributes",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Identities" => Identities), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_identity_mail_from_domain_attributes(identities)
    get_identity_mail_from_domain_attributes(identities, params::Dict{String,<:Any})

Returns the custom MAIL FROM attributes for a list of identities (email addresses :
domains). This operation is throttled at one request per second and can only get custom
MAIL FROM attributes for up to 100 identities at a time.

# Arguments
- `identities`: A list of one or more identities.

"""
function get_identity_mail_from_domain_attributes(
    Identities; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "GetIdentityMailFromDomainAttributes",
        Dict{String,Any}("Identities" => Identities);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_identity_mail_from_domain_attributes(
    Identities,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "GetIdentityMailFromDomainAttributes",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Identities" => Identities), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_identity_notification_attributes(identities)
    get_identity_notification_attributes(identities, params::Dict{String,<:Any})

Given a list of verified identities (email addresses and/or domains), returns a structure
describing identity notification attributes. This operation is throttled at one request per
second and can only get notification attributes for up to 100 identities at a time. For
more information about using notifications with Amazon SES, see the Amazon SES Developer
Guide.

# Arguments
- `identities`: A list of one or more identities. You can specify an identity by using its
  name or by using its Amazon Resource Name (ARN). Examples: user@example.com, example.com,
  arn:aws:ses:us-east-1:123456789012:identity/example.com.

"""
function get_identity_notification_attributes(
    Identities; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "GetIdentityNotificationAttributes",
        Dict{String,Any}("Identities" => Identities);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_identity_notification_attributes(
    Identities,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "GetIdentityNotificationAttributes",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Identities" => Identities), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_identity_policies(identity, policy_names)
    get_identity_policies(identity, policy_names, params::Dict{String,<:Any})

Returns the requested sending authorization policies for the given identity (an email
address or a domain). The policies are returned as a map of policy names to policy
contents. You can retrieve a maximum of 20 policies at a time.  This operation is for the
identity owner only. If you have not verified the identity, it returns an error.  Sending
authorization is a feature that enables an identity owner to authorize other senders to use
its identities. For information about using sending authorization, see the Amazon SES
Developer Guide. You can execute this operation no more than once per second.

# Arguments
- `identity`: The identity for which the policies are retrieved. You can specify an
  identity by using its name or by using its Amazon Resource Name (ARN). Examples:
  user@example.com, example.com, arn:aws:ses:us-east-1:123456789012:identity/example.com. To
  successfully call this operation, you must own the identity.
- `policy_names`: A list of the names of policies to be retrieved. You can retrieve a
  maximum of 20 policies at a time. If you do not know the names of the policies that are
  attached to the identity, you can use ListIdentityPolicies.

"""
function get_identity_policies(
    Identity, PolicyNames; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "GetIdentityPolicies",
        Dict{String,Any}("Identity" => Identity, "PolicyNames" => PolicyNames);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_identity_policies(
    Identity,
    PolicyNames,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "GetIdentityPolicies",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Identity" => Identity, "PolicyNames" => PolicyNames),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_identity_verification_attributes(identities)
    get_identity_verification_attributes(identities, params::Dict{String,<:Any})

Given a list of identities (email addresses and/or domains), returns the verification
status and (for domain identities) the verification token for each identity. The
verification status of an email address is \"Pending\" until the email address owner clicks
the link within the verification email that Amazon SES sent to that address. If the email
address owner clicks the link within 24 hours, the verification status of the email address
changes to \"Success\". If the link is not clicked within 24 hours, the verification status
changes to \"Failed.\" In that case, to verify the email address, you must restart the
verification process from the beginning. For domain identities, the domain's verification
status is \"Pending\" as Amazon SES searches for the required TXT record in the DNS
settings of the domain. When Amazon SES detects the record, the domain's verification
status changes to \"Success\". If Amazon SES is unable to detect the record within 72
hours, the domain's verification status changes to \"Failed.\" In that case, to verify the
domain, you must restart the verification process from the beginning. This operation is
throttled at one request per second and can only get verification attributes for up to 100
identities at a time.

# Arguments
- `identities`: A list of identities.

"""
function get_identity_verification_attributes(
    Identities; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "GetIdentityVerificationAttributes",
        Dict{String,Any}("Identities" => Identities);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_identity_verification_attributes(
    Identities,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "GetIdentityVerificationAttributes",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Identities" => Identities), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_send_quota()
    get_send_quota(params::Dict{String,<:Any})

Provides the sending limits for the Amazon SES account.  You can execute this operation no
more than once per second.

"""
function get_send_quota(; aws_config::AbstractAWSConfig=current_aws_config())
    return ses("GetSendQuota"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function get_send_quota(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "GetSendQuota", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_send_statistics()
    get_send_statistics(params::Dict{String,<:Any})

Provides sending statistics for the current Amazon Web Services Region. The result is a
list of data points, representing the last two weeks of sending activity. Each data point
in the list contains statistics for a 15-minute period of time. You can execute this
operation no more than once per second.

"""
function get_send_statistics(; aws_config::AbstractAWSConfig=current_aws_config())
    return ses("GetSendStatistics"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function get_send_statistics(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "GetSendStatistics", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_template(template_name)
    get_template(template_name, params::Dict{String,<:Any})

Displays the template object (which includes the Subject line, HTML part and text part) for
the template you specify. You can execute this operation no more than once per second.

# Arguments
- `template_name`: The name of the template to retrieve.

"""
function get_template(TemplateName; aws_config::AbstractAWSConfig=current_aws_config())
    return ses(
        "GetTemplate",
        Dict{String,Any}("TemplateName" => TemplateName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_template(
    TemplateName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "GetTemplate",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TemplateName" => TemplateName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_configuration_sets()
    list_configuration_sets(params::Dict{String,<:Any})

Provides a list of the configuration sets associated with your Amazon SES account in the
current Amazon Web Services Region. For information about using configuration sets, see
Monitoring Your Amazon SES Sending Activity in the Amazon SES Developer Guide.  You can
execute this operation no more than once per second. This operation returns up to 1,000
configuration sets each time it is run. If your Amazon SES account has more than 1,000
configuration sets, this operation also returns NextToken. You can then execute the
ListConfigurationSets operation again, passing the NextToken parameter and the value of the
NextToken element to retrieve additional results.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxItems"`: The number of configuration sets to return.
- `"NextToken"`: A token returned from a previous call to ListConfigurationSets to indicate
  the position of the configuration set in the configuration set list.
"""
function list_configuration_sets(; aws_config::AbstractAWSConfig=current_aws_config())
    return ses(
        "ListConfigurationSets"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_configuration_sets(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "ListConfigurationSets",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_custom_verification_email_templates()
    list_custom_verification_email_templates(params::Dict{String,<:Any})

Lists the existing custom verification email templates for your account in the current
Amazon Web Services Region. For more information about custom verification email templates,
see Using Custom Verification Email Templates in the Amazon SES Developer Guide. You can
execute this operation no more than once per second.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of custom verification email templates to return. This
  value must be at least 1 and less than or equal to 50. If you do not specify a value, or if
  you specify a value less than 1 or greater than 50, the operation returns up to 50 results.
- `"NextToken"`: An array the contains the name and creation time stamp for each template
  in your Amazon SES account.
"""
function list_custom_verification_email_templates(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "ListCustomVerificationEmailTemplates";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_custom_verification_email_templates(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "ListCustomVerificationEmailTemplates",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_identities()
    list_identities(params::Dict{String,<:Any})

Returns a list containing all of the identities (email addresses and domains) for your
Amazon Web Services account in the current Amazon Web Services Region, regardless of
verification status. You can execute this operation no more than once per second.  It's
recommended that for successive pagination calls of this API, you continue to the use the
same parameter/value pairs as used in the original call, e.g., if you used
IdentityType=Domain in the the original call and received a NextToken in the response, you
should continue providing the IdentityType=Domain parameter for further NextToken calls;
however, if you didn't provide the IdentityType parameter in the original call, then
continue to not provide it for successive pagination calls. Using this protocol will ensure
consistent results.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"IdentityType"`: The type of the identities to list. Possible values are
  \"EmailAddress\" and \"Domain\". If this parameter is omitted, then all identities are
  listed.
- `"MaxItems"`: The maximum number of identities per page. Possible values are 1-1000
  inclusive.
- `"NextToken"`: The token to use for pagination.
"""
function list_identities(; aws_config::AbstractAWSConfig=current_aws_config())
    return ses("ListIdentities"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_identities(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "ListIdentities", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_identity_policies(identity)
    list_identity_policies(identity, params::Dict{String,<:Any})

Returns a list of sending authorization policies that are attached to the given identity
(an email address or a domain). This operation returns only a list. To get the actual
policy content, use GetIdentityPolicies.  This operation is for the identity owner only. If
you have not verified the identity, it returns an error.  Sending authorization is a
feature that enables an identity owner to authorize other senders to use its identities.
For information about using sending authorization, see the Amazon SES Developer Guide. You
can execute this operation no more than once per second.

# Arguments
- `identity`: The identity that is associated with the policy for which the policies are
  listed. You can specify an identity by using its name or by using its Amazon Resource Name
  (ARN). Examples: user@example.com, example.com,
  arn:aws:ses:us-east-1:123456789012:identity/example.com. To successfully call this
  operation, you must own the identity.

"""
function list_identity_policies(
    Identity; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "ListIdentityPolicies",
        Dict{String,Any}("Identity" => Identity);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_identity_policies(
    Identity,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "ListIdentityPolicies",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Identity" => Identity), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_receipt_filters()
    list_receipt_filters(params::Dict{String,<:Any})

Lists the IP address filters associated with your Amazon Web Services account in the
current Amazon Web Services Region. For information about managing IP address filters, see
the Amazon SES Developer Guide. You can execute this operation no more than once per second.

"""
function list_receipt_filters(; aws_config::AbstractAWSConfig=current_aws_config())
    return ses("ListReceiptFilters"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_receipt_filters(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "ListReceiptFilters", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_receipt_rule_sets()
    list_receipt_rule_sets(params::Dict{String,<:Any})

Lists the receipt rule sets that exist under your Amazon Web Services account in the
current Amazon Web Services Region. If there are additional receipt rule sets to be
retrieved, you receive a NextToken that you can provide to the next call to
ListReceiptRuleSets to retrieve the additional entries. For information about managing
receipt rule sets, see the Amazon SES Developer Guide. You can execute this operation no
more than once per second.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: A token returned from a previous call to ListReceiptRuleSets to indicate
  the position in the receipt rule set list.
"""
function list_receipt_rule_sets(; aws_config::AbstractAWSConfig=current_aws_config())
    return ses(
        "ListReceiptRuleSets"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_receipt_rule_sets(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "ListReceiptRuleSets",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_templates()
    list_templates(params::Dict{String,<:Any})

Lists the email templates present in your Amazon SES account in the current Amazon Web
Services Region. You can execute this operation no more than once per second.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxItems"`: The maximum number of templates to return. This value must be at least 1
  and less than or equal to 100. If more than 100 items are requested, the page size will
  automatically set to 100. If you do not specify a value, 10 is the default page size.
- `"NextToken"`: A token returned from a previous call to ListTemplates to indicate the
  position in the list of email templates.
"""
function list_templates(; aws_config::AbstractAWSConfig=current_aws_config())
    return ses("ListTemplates"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_templates(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "ListTemplates", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_verified_email_addresses()
    list_verified_email_addresses(params::Dict{String,<:Any})

Deprecated. Use the ListIdentities operation to list the email addresses and domains
associated with your account.

"""
function list_verified_email_addresses(; aws_config::AbstractAWSConfig=current_aws_config())
    return ses(
        "ListVerifiedEmailAddresses"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_verified_email_addresses(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "ListVerifiedEmailAddresses",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_configuration_set_delivery_options(configuration_set_name)
    put_configuration_set_delivery_options(configuration_set_name, params::Dict{String,<:Any})

Adds or updates the delivery options for a configuration set.

# Arguments
- `configuration_set_name`: The name of the configuration set.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DeliveryOptions"`: Specifies whether messages that use the configuration set are
  required to use Transport Layer Security (TLS).
"""
function put_configuration_set_delivery_options(
    ConfigurationSetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "PutConfigurationSetDeliveryOptions",
        Dict{String,Any}("ConfigurationSetName" => ConfigurationSetName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_configuration_set_delivery_options(
    ConfigurationSetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "PutConfigurationSetDeliveryOptions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ConfigurationSetName" => ConfigurationSetName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_identity_policy(identity, policy, policy_name)
    put_identity_policy(identity, policy, policy_name, params::Dict{String,<:Any})

Adds or updates a sending authorization policy for the specified identity (an email address
or a domain).  This operation is for the identity owner only. If you have not verified the
identity, it returns an error.  Sending authorization is a feature that enables an identity
owner to authorize other senders to use its identities. For information about using sending
authorization, see the Amazon SES Developer Guide. You can execute this operation no more
than once per second.

# Arguments
- `identity`: The identity to which that the policy applies. You can specify an identity by
  using its name or by using its Amazon Resource Name (ARN). Examples: user@example.com,
  example.com, arn:aws:ses:us-east-1:123456789012:identity/example.com. To successfully call
  this operation, you must own the identity.
- `policy`: The text of the policy in JSON format. The policy cannot exceed 4 KB. For
  information about the syntax of sending authorization policies, see the Amazon SES
  Developer Guide.
- `policy_name`: The name of the policy. The policy name cannot exceed 64 characters and
  can only include alphanumeric characters, dashes, and underscores.

"""
function put_identity_policy(
    Identity, Policy, PolicyName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "PutIdentityPolicy",
        Dict{String,Any}(
            "Identity" => Identity, "Policy" => Policy, "PolicyName" => PolicyName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_identity_policy(
    Identity,
    Policy,
    PolicyName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "PutIdentityPolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Identity" => Identity, "Policy" => Policy, "PolicyName" => PolicyName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    reorder_receipt_rule_set(rule_names, rule_set_name)
    reorder_receipt_rule_set(rule_names, rule_set_name, params::Dict{String,<:Any})

Reorders the receipt rules within a receipt rule set.  All of the rules in the rule set
must be represented in this request. That is, it is error if the reorder request doesn't
explicitly position all of the rules.  For information about managing receipt rule sets,
see the Amazon SES Developer Guide. You can execute this operation no more than once per
second.

# Arguments
- `rule_names`: The specified receipt rule set's receipt rules, in order.
- `rule_set_name`: The name of the receipt rule set to reorder.

"""
function reorder_receipt_rule_set(
    RuleNames, RuleSetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "ReorderReceiptRuleSet",
        Dict{String,Any}("RuleNames" => RuleNames, "RuleSetName" => RuleSetName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function reorder_receipt_rule_set(
    RuleNames,
    RuleSetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "ReorderReceiptRuleSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("RuleNames" => RuleNames, "RuleSetName" => RuleSetName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    send_bounce(bounce_sender, bounced_recipient_info_list, original_message_id)
    send_bounce(bounce_sender, bounced_recipient_info_list, original_message_id, params::Dict{String,<:Any})

Generates and sends a bounce message to the sender of an email you received through Amazon
SES. You can only use this operation on an email up to 24 hours after you receive it.  You
cannot use this operation to send generic bounces for mail that was not received by Amazon
SES.  For information about receiving email through Amazon SES, see the Amazon SES
Developer Guide. You can execute this operation no more than once per second.

# Arguments
- `bounce_sender`: The address to use in the \"From\" header of the bounce message. This
  must be an identity that you have verified with Amazon SES.
- `bounced_recipient_info_list`: A list of recipients of the bounced message, including the
  information required to create the Delivery Status Notifications (DSNs) for the recipients.
  You must specify at least one BouncedRecipientInfo in the list.
- `original_message_id`: The message ID of the message to be bounced.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"BounceSenderArn"`: This parameter is used only for sending authorization. It is the ARN
  of the identity that is associated with the sending authorization policy that permits you
  to use the address in the \"From\" header of the bounce. For more information about sending
  authorization, see the Amazon SES Developer Guide.
- `"Explanation"`: Human-readable text for the bounce message to explain the failure. If
  not specified, the text is auto-generated based on the bounced recipient information.
- `"MessageDsn"`: Message-related DSN fields. If not specified, Amazon SES chooses the
  values.
"""
function send_bounce(
    BounceSender,
    BouncedRecipientInfoList,
    OriginalMessageId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "SendBounce",
        Dict{String,Any}(
            "BounceSender" => BounceSender,
            "BouncedRecipientInfoList" => BouncedRecipientInfoList,
            "OriginalMessageId" => OriginalMessageId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function send_bounce(
    BounceSender,
    BouncedRecipientInfoList,
    OriginalMessageId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "SendBounce",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "BounceSender" => BounceSender,
                    "BouncedRecipientInfoList" => BouncedRecipientInfoList,
                    "OriginalMessageId" => OriginalMessageId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    send_bulk_templated_email(destinations, source, template)
    send_bulk_templated_email(destinations, source, template, params::Dict{String,<:Any})

Composes an email message to multiple destinations. The message body is created using an
email template. To send email using this operation, your call must meet the following
requirements:   The call must refer to an existing email template. You can create email
templates using CreateTemplate.   The message must be sent from a verified email address or
domain.   If your account is still in the Amazon SES sandbox, you may send only to verified
addresses or domains, or to email addresses associated with the Amazon SES Mailbox
Simulator. For more information, see Verifying Email Addresses and Domains in the Amazon
SES Developer Guide.    The maximum message size is 10 MB.   Each Destination parameter
must include at least one recipient email address. The recipient address can be a To:
address, a CC: address, or a BCC: address. If a recipient email address is invalid (that
is, it is not in the format UserName@[SubDomain.]Domain.TopLevelDomain), the entire message
is rejected, even if the message contains other recipients that are valid.   The message
may not include more than 50 recipients, across the To:, CC: and BCC: fields. If you need
to send an email message to a larger audience, you can divide your recipient list into
groups of 50 or fewer, and then call the SendBulkTemplatedEmail operation several times to
send the message to each group.   The number of destinations you can contact in a single
call can be limited by your account's maximum sending rate.

# Arguments
- `destinations`: One or more Destination objects. All of the recipients in a Destination
  receive the same version of the email. You can specify up to 50 Destination objects within
  a Destinations array.
- `source`: The email address that is sending the email. This email address must be either
  individually verified with Amazon SES, or from a domain that has been verified with Amazon
  SES. For information about verifying identities, see the Amazon SES Developer Guide. If you
  are sending on behalf of another user and have been permitted to do so by a sending
  authorization policy, then you must also specify the SourceArn parameter. For more
  information about sending authorization, see the Amazon SES Developer Guide.  Amazon SES
  does not support the SMTPUTF8 extension, as described in RFC6531. For this reason, the
  email address string must be 7-bit ASCII. If you want to send to or from email addresses
  that contain Unicode characters in the domain part of an address, you must encode the
  domain using Punycode. Punycode is not permitted in the local part of the email address
  (the part before the @ sign) nor in the \"friendly from\" name. If you want to use Unicode
  characters in the \"friendly from\" name, you must encode the \"friendly from\" name using
  MIME encoded-word syntax, as described in Sending raw email using the Amazon SES API. For
  more information about Punycode, see RFC 3492.
- `template`: The template to use when sending this email.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConfigurationSetName"`: The name of the configuration set to use when you send an email
  using SendBulkTemplatedEmail.
- `"DefaultTags"`: A list of tags, in the form of name/value pairs, to apply to an email
  that you send to a destination using SendBulkTemplatedEmail.
- `"DefaultTemplateData"`: A list of replacement values to apply to the template when
  replacement data is not specified in a Destination object. These values act as a default or
  fallback option when no other data is available. The template data is a JSON object,
  typically consisting of key-value pairs in which the keys correspond to replacement tags in
  the email template.
- `"ReplyToAddresses"`: The reply-to email address(es) for the message. If the recipient
  replies to the message, each reply-to address receives the reply.
- `"ReturnPath"`: The email address that bounces and complaints are forwarded to when
  feedback forwarding is enabled. If the message cannot be delivered to the recipient, then
  an error message is returned from the recipient's ISP; this message is forwarded to the
  email address specified by the ReturnPath parameter. The ReturnPath parameter is never
  overwritten. This email address must be either individually verified with Amazon SES, or
  from a domain that has been verified with Amazon SES.
- `"ReturnPathArn"`: This parameter is used only for sending authorization. It is the ARN
  of the identity that is associated with the sending authorization policy that permits you
  to use the email address specified in the ReturnPath parameter. For example, if the owner
  of example.com (which has ARN arn:aws:ses:us-east-1:123456789012:identity/example.com)
  attaches a policy to it that authorizes you to use feedback@example.com, then you would
  specify the ReturnPathArn to be arn:aws:ses:us-east-1:123456789012:identity/example.com,
  and the ReturnPath to be feedback@example.com. For more information about sending
  authorization, see the Amazon SES Developer Guide.
- `"SourceArn"`: This parameter is used only for sending authorization. It is the ARN of
  the identity that is associated with the sending authorization policy that permits you to
  send for the email address specified in the Source parameter. For example, if the owner of
  example.com (which has ARN arn:aws:ses:us-east-1:123456789012:identity/example.com)
  attaches a policy to it that authorizes you to send from user@example.com, then you would
  specify the SourceArn to be arn:aws:ses:us-east-1:123456789012:identity/example.com, and
  the Source to be user@example.com. For more information about sending authorization, see
  the Amazon SES Developer Guide.
- `"TemplateArn"`: The ARN of the template to use when sending this email.
"""
function send_bulk_templated_email(
    Destinations, Source, Template; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "SendBulkTemplatedEmail",
        Dict{String,Any}(
            "Destinations" => Destinations, "Source" => Source, "Template" => Template
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function send_bulk_templated_email(
    Destinations,
    Source,
    Template,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "SendBulkTemplatedEmail",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Destinations" => Destinations,
                    "Source" => Source,
                    "Template" => Template,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    send_custom_verification_email(email_address, template_name)
    send_custom_verification_email(email_address, template_name, params::Dict{String,<:Any})

Adds an email address to the list of identities for your Amazon SES account in the current
Amazon Web Services Region and attempts to verify it. As a result of executing this
operation, a customized verification email is sent to the specified address. To use this
operation, you must first create a custom verification email template. For more information
about creating and using custom verification email templates, see Using Custom Verification
Email Templates in the Amazon SES Developer Guide. You can execute this operation no more
than once per second.

# Arguments
- `email_address`: The email address to verify.
- `template_name`: The name of the custom verification email template to use when sending
  the verification email.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConfigurationSetName"`: Name of a configuration set to use when sending the
  verification email.
"""
function send_custom_verification_email(
    EmailAddress, TemplateName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "SendCustomVerificationEmail",
        Dict{String,Any}("EmailAddress" => EmailAddress, "TemplateName" => TemplateName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function send_custom_verification_email(
    EmailAddress,
    TemplateName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "SendCustomVerificationEmail",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EmailAddress" => EmailAddress, "TemplateName" => TemplateName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    send_email(destination, message, source)
    send_email(destination, message, source, params::Dict{String,<:Any})

Composes an email message and immediately queues it for sending. To send email using this
operation, your message must meet the following requirements:   The message must be sent
from a verified email address or domain. If you attempt to send email using a non-verified
address or domain, the operation results in an \"Email address not verified\" error.    If
your account is still in the Amazon SES sandbox, you may only send to verified addresses or
domains, or to email addresses associated with the Amazon SES Mailbox Simulator. For more
information, see Verifying Email Addresses and Domains in the Amazon SES Developer Guide.
 The maximum message size is 10 MB.   The message must include at least one recipient email
address. The recipient address can be a To: address, a CC: address, or a BCC: address. If a
recipient email address is invalid (that is, it is not in the format
UserName@[SubDomain.]Domain.TopLevelDomain), the entire message is rejected, even if the
message contains other recipients that are valid.   The message may not include more than
50 recipients, across the To:, CC: and BCC: fields. If you need to send an email message to
a larger audience, you can divide your recipient list into groups of 50 or fewer, and then
call the SendEmail operation several times to send the message to each group.    For every
message that you send, the total number of recipients (including each recipient in the To:,
CC: and BCC: fields) is counted against the maximum number of emails you can send in a
24-hour period (your sending quota). For more information about sending quotas in Amazon
SES, see Managing Your Amazon SES Sending Limits in the Amazon SES Developer Guide.

# Arguments
- `destination`: The destination for this email, composed of To:, CC:, and BCC: fields.
- `message`: The message to be sent.
- `source`: The email address that is sending the email. This email address must be either
  individually verified with Amazon SES, or from a domain that has been verified with Amazon
  SES. For information about verifying identities, see the Amazon SES Developer Guide. If you
  are sending on behalf of another user and have been permitted to do so by a sending
  authorization policy, then you must also specify the SourceArn parameter. For more
  information about sending authorization, see the Amazon SES Developer Guide.  Amazon SES
  does not support the SMTPUTF8 extension, as described in RFC6531. For this reason, the
  email address string must be 7-bit ASCII. If you want to send to or from email addresses
  that contain Unicode characters in the domain part of an address, you must encode the
  domain using Punycode. Punycode is not permitted in the local part of the email address
  (the part before the @ sign) nor in the \"friendly from\" name. If you want to use Unicode
  characters in the \"friendly from\" name, you must encode the \"friendly from\" name using
  MIME encoded-word syntax, as described in Sending raw email using the Amazon SES API. For
  more information about Punycode, see RFC 3492.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConfigurationSetName"`: The name of the configuration set to use when you send an email
  using SendEmail.
- `"ReplyToAddresses"`: The reply-to email address(es) for the message. If the recipient
  replies to the message, each reply-to address receives the reply.
- `"ReturnPath"`: The email address that bounces and complaints are forwarded to when
  feedback forwarding is enabled. If the message cannot be delivered to the recipient, then
  an error message is returned from the recipient's ISP; this message is forwarded to the
  email address specified by the ReturnPath parameter. The ReturnPath parameter is never
  overwritten. This email address must be either individually verified with Amazon SES, or
  from a domain that has been verified with Amazon SES.
- `"ReturnPathArn"`: This parameter is used only for sending authorization. It is the ARN
  of the identity that is associated with the sending authorization policy that permits you
  to use the email address specified in the ReturnPath parameter. For example, if the owner
  of example.com (which has ARN arn:aws:ses:us-east-1:123456789012:identity/example.com)
  attaches a policy to it that authorizes you to use feedback@example.com, then you would
  specify the ReturnPathArn to be arn:aws:ses:us-east-1:123456789012:identity/example.com,
  and the ReturnPath to be feedback@example.com. For more information about sending
  authorization, see the Amazon SES Developer Guide.
- `"SourceArn"`: This parameter is used only for sending authorization. It is the ARN of
  the identity that is associated with the sending authorization policy that permits you to
  send for the email address specified in the Source parameter. For example, if the owner of
  example.com (which has ARN arn:aws:ses:us-east-1:123456789012:identity/example.com)
  attaches a policy to it that authorizes you to send from user@example.com, then you would
  specify the SourceArn to be arn:aws:ses:us-east-1:123456789012:identity/example.com, and
  the Source to be user@example.com. For more information about sending authorization, see
  the Amazon SES Developer Guide.
- `"Tags"`: A list of tags, in the form of name/value pairs, to apply to an email that you
  send using SendEmail. Tags correspond to characteristics of the email that you define, so
  that you can publish email sending events.
"""
function send_email(
    Destination, Message, Source; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "SendEmail",
        Dict{String,Any}(
            "Destination" => Destination, "Message" => Message, "Source" => Source
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function send_email(
    Destination,
    Message,
    Source,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "SendEmail",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Destination" => Destination, "Message" => Message, "Source" => Source
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    send_raw_email(raw_message)
    send_raw_email(raw_message, params::Dict{String,<:Any})

Composes an email message and immediately queues it for sending. This operation is more
flexible than the SendEmail operation. When you use the SendRawEmail operation, you can
specify the headers of the message as well as its content. This flexibility is useful, for
example, when you need to send a multipart MIME email (such a message that contains both a
text and an HTML version). You can also use this operation to send messages that include
attachments. The SendRawEmail operation has the following requirements:   You can only send
email from verified email addresses or domains. If you try to send email from an address
that isn't verified, the operation results in an \"Email address not verified\" error.   If
your account is still in the Amazon SES sandbox, you can only send email to other verified
addresses in your account, or to addresses that are associated with the Amazon SES mailbox
simulator.   The maximum message size, including attachments, is 10 MB.   Each message has
to include at least one recipient address. A recipient address includes any address on the
To:, CC:, or BCC: lines.   If you send a single message to more than one recipient address,
and one of the recipient addresses isn't in a valid format (that is, it's not in the format
UserName@[SubDomain.]Domain.TopLevelDomain), Amazon SES rejects the entire message, even if
the other addresses are valid.   Each message can include up to 50 recipient addresses
across the To:, CC:, or BCC: lines. If you need to send a single message to more than 50
recipients, you have to split the list of recipient addresses into groups of less than 50
recipients, and send separate messages to each group.   Amazon SES allows you to specify
8-bit Content-Transfer-Encoding for MIME message parts. However, if Amazon SES has to
modify the contents of your message (for example, if you use open and click tracking),
8-bit content isn't preserved. For this reason, we highly recommend that you encode all
content that isn't 7-bit ASCII. For more information, see MIME Encoding in the Amazon SES
Developer Guide.   Additionally, keep the following considerations in mind when using the
SendRawEmail operation:   Although you can customize the message headers when using the
SendRawEmail operation, Amazon SES automatically applies its own Message-ID and Date
headers; if you passed these headers when creating the message, they are overwritten by the
values that Amazon SES provides.   If you are using sending authorization to send on behalf
of another user, SendRawEmail enables you to specify the cross-account identity for the
email's Source, From, and Return-Path parameters in one of two ways: you can pass optional
parameters SourceArn, FromArn, and/or ReturnPathArn, or you can include the following
X-headers in the header of your raw email:    X-SES-SOURCE-ARN     X-SES-FROM-ARN
X-SES-RETURN-PATH-ARN     Don't include these X-headers in the DKIM signature. Amazon SES
removes these before it sends the email.  If you only specify the SourceIdentityArn
parameter, Amazon SES sets the From and Return-Path addresses to the same identity that you
specified. For more information about sending authorization, see the Using Sending
Authorization with Amazon SES in the Amazon SES Developer Guide.    For every message that
you send, the total number of recipients (including each recipient in the To:, CC: and BCC:
fields) is counted against the maximum number of emails you can send in a 24-hour period
(your sending quota). For more information about sending quotas in Amazon SES, see Managing
Your Amazon SES Sending Limits in the Amazon SES Developer Guide.

# Arguments
- `raw_message`: The raw email message itself. The message has to meet the following
  criteria:   The message has to contain a header and a body, separated by a blank line.
  All of the required header fields must be present in the message.   Each part of a
  multipart MIME message must be formatted properly.   Attachments must be of a content type
  that Amazon SES supports. For a list on unsupported content types, see Unsupported
  Attachment Types in the Amazon SES Developer Guide.   The entire message must be
  base64-encoded.   If any of the MIME parts in your message contain content that is outside
  of the 7-bit ASCII character range, we highly recommend that you encode that content. For
  more information, see Sending Raw Email in the Amazon SES Developer Guide.   Per RFC 5321,
  the maximum length of each line of text, including the &lt;CRLF&gt;, must not exceed 1,000
  characters.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConfigurationSetName"`: The name of the configuration set to use when you send an email
  using SendRawEmail.
- `"Destinations"`: A list of destinations for the message, consisting of To:, CC:, and
  BCC: addresses.
- `"FromArn"`: This parameter is used only for sending authorization. It is the ARN of the
  identity that is associated with the sending authorization policy that permits you to
  specify a particular \"From\" address in the header of the raw email. Instead of using this
  parameter, you can use the X-header X-SES-FROM-ARN in the raw message of the email. If you
  use both the FromArn parameter and the corresponding X-header, Amazon SES uses the value of
  the FromArn parameter.  For information about when to use this parameter, see the
  description of SendRawEmail in this guide, or see the Amazon SES Developer Guide.
- `"ReturnPathArn"`: This parameter is used only for sending authorization. It is the ARN
  of the identity that is associated with the sending authorization policy that permits you
  to use the email address specified in the ReturnPath parameter. For example, if the owner
  of example.com (which has ARN arn:aws:ses:us-east-1:123456789012:identity/example.com)
  attaches a policy to it that authorizes you to use feedback@example.com, then you would
  specify the ReturnPathArn to be arn:aws:ses:us-east-1:123456789012:identity/example.com,
  and the ReturnPath to be feedback@example.com. Instead of using this parameter, you can use
  the X-header X-SES-RETURN-PATH-ARN in the raw message of the email. If you use both the
  ReturnPathArn parameter and the corresponding X-header, Amazon SES uses the value of the
  ReturnPathArn parameter.  For information about when to use this parameter, see the
  description of SendRawEmail in this guide, or see the Amazon SES Developer Guide.
- `"Source"`: The identity's email address. If you do not provide a value for this
  parameter, you must specify a \"From\" address in the raw text of the message. (You can
  also specify both.)  Amazon SES does not support the SMTPUTF8 extension, as described
  inRFC6531. For this reason, the email address string must be 7-bit ASCII. If you want to
  send to or from email addresses that contain Unicode characters in the domain part of an
  address, you must encode the domain using Punycode. Punycode is not permitted in the local
  part of the email address (the part before the @ sign) nor in the \"friendly from\" name.
  If you want to use Unicode characters in the \"friendly from\" name, you must encode the
  \"friendly from\" name using MIME encoded-word syntax, as described in Sending raw email
  using the Amazon SES API. For more information about Punycode, see RFC 3492.  If you
  specify the Source parameter and have feedback forwarding enabled, then bounces and
  complaints are sent to this email address. This takes precedence over any Return-Path
  header that you might include in the raw text of the message.
- `"SourceArn"`: This parameter is used only for sending authorization. It is the ARN of
  the identity that is associated with the sending authorization policy that permits you to
  send for the email address specified in the Source parameter. For example, if the owner of
  example.com (which has ARN arn:aws:ses:us-east-1:123456789012:identity/example.com)
  attaches a policy to it that authorizes you to send from user@example.com, then you would
  specify the SourceArn to be arn:aws:ses:us-east-1:123456789012:identity/example.com, and
  the Source to be user@example.com. Instead of using this parameter, you can use the
  X-header X-SES-SOURCE-ARN in the raw message of the email. If you use both the SourceArn
  parameter and the corresponding X-header, Amazon SES uses the value of the SourceArn
  parameter.  For information about when to use this parameter, see the description of
  SendRawEmail in this guide, or see the Amazon SES Developer Guide.
- `"Tags"`: A list of tags, in the form of name/value pairs, to apply to an email that you
  send using SendRawEmail. Tags correspond to characteristics of the email that you define,
  so that you can publish email sending events.
"""
function send_raw_email(RawMessage; aws_config::AbstractAWSConfig=current_aws_config())
    return ses(
        "SendRawEmail",
        Dict{String,Any}("RawMessage" => RawMessage);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function send_raw_email(
    RawMessage,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "SendRawEmail",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("RawMessage" => RawMessage), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    send_templated_email(destination, source, template, template_data)
    send_templated_email(destination, source, template, template_data, params::Dict{String,<:Any})

Composes an email message using an email template and immediately queues it for sending. To
send email using this operation, your call must meet the following requirements:   The call
must refer to an existing email template. You can create email templates using the
CreateTemplate operation.   The message must be sent from a verified email address or
domain.   If your account is still in the Amazon SES sandbox, you may only send to verified
addresses or domains, or to email addresses associated with the Amazon SES Mailbox
Simulator. For more information, see Verifying Email Addresses and Domains in the Amazon
SES Developer Guide.    The maximum message size is 10 MB.   Calls to the
SendTemplatedEmail operation may only include one Destination parameter. A destination is a
set of recipients that receives the same version of the email. The Destination parameter
can include up to 50 recipients, across the To:, CC: and BCC: fields.   The Destination
parameter must include at least one recipient email address. The recipient address can be a
To: address, a CC: address, or a BCC: address. If a recipient email address is invalid
(that is, it is not in the format UserName@[SubDomain.]Domain.TopLevelDomain), the entire
message is rejected, even if the message contains other recipients that are valid.    If
your call to the SendTemplatedEmail operation includes all of the required parameters,
Amazon SES accepts it and returns a Message ID. However, if Amazon SES can't render the
email because the template contains errors, it doesn't send the email. Additionally,
because it already accepted the message, Amazon SES doesn't return a message stating that
it was unable to send the email. For these reasons, we highly recommend that you set up
Amazon SES to send you notifications when Rendering Failure events occur. For more
information, see Sending Personalized Email Using the Amazon SES API in the Amazon Simple
Email Service Developer Guide.

# Arguments
- `destination`: The destination for this email, composed of To:, CC:, and BCC: fields. A
  Destination can include up to 50 recipients across these three fields.
- `source`: The email address that is sending the email. This email address must be either
  individually verified with Amazon SES, or from a domain that has been verified with Amazon
  SES. For information about verifying identities, see the Amazon SES Developer Guide. If you
  are sending on behalf of another user and have been permitted to do so by a sending
  authorization policy, then you must also specify the SourceArn parameter. For more
  information about sending authorization, see the Amazon SES Developer Guide.  Amazon SES
  does not support the SMTPUTF8 extension, as described in RFC6531. for this reason, The
  email address string must be 7-bit ASCII. If you want to send to or from email addresses
  that contain Unicode characters in the domain part of an address, you must encode the
  domain using Punycode. Punycode is not permitted in the local part of the email address
  (the part before the @ sign) nor in the \"friendly from\" name. If you want to use Unicode
  characters in the \"friendly from\" name, you must encode the \"friendly from\" name using
  MIME encoded-word syntax, as described in Sending raw email using the Amazon SES API. For
  more information about Punycode, see RFC 3492.
- `template`: The template to use when sending this email.
- `template_data`: A list of replacement values to apply to the template. This parameter is
  a JSON object, typically consisting of key-value pairs in which the keys correspond to
  replacement tags in the email template.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConfigurationSetName"`: The name of the configuration set to use when you send an email
  using SendTemplatedEmail.
- `"ReplyToAddresses"`: The reply-to email address(es) for the message. If the recipient
  replies to the message, each reply-to address receives the reply.
- `"ReturnPath"`: The email address that bounces and complaints are forwarded to when
  feedback forwarding is enabled. If the message cannot be delivered to the recipient, then
  an error message is returned from the recipient's ISP; this message is forwarded to the
  email address specified by the ReturnPath parameter. The ReturnPath parameter is never
  overwritten. This email address must be either individually verified with Amazon SES, or
  from a domain that has been verified with Amazon SES.
- `"ReturnPathArn"`: This parameter is used only for sending authorization. It is the ARN
  of the identity that is associated with the sending authorization policy that permits you
  to use the email address specified in the ReturnPath parameter. For example, if the owner
  of example.com (which has ARN arn:aws:ses:us-east-1:123456789012:identity/example.com)
  attaches a policy to it that authorizes you to use feedback@example.com, then you would
  specify the ReturnPathArn to be arn:aws:ses:us-east-1:123456789012:identity/example.com,
  and the ReturnPath to be feedback@example.com. For more information about sending
  authorization, see the Amazon SES Developer Guide.
- `"SourceArn"`: This parameter is used only for sending authorization. It is the ARN of
  the identity that is associated with the sending authorization policy that permits you to
  send for the email address specified in the Source parameter. For example, if the owner of
  example.com (which has ARN arn:aws:ses:us-east-1:123456789012:identity/example.com)
  attaches a policy to it that authorizes you to send from user@example.com, then you would
  specify the SourceArn to be arn:aws:ses:us-east-1:123456789012:identity/example.com, and
  the Source to be user@example.com. For more information about sending authorization, see
  the Amazon SES Developer Guide.
- `"Tags"`: A list of tags, in the form of name/value pairs, to apply to an email that you
  send using SendTemplatedEmail. Tags correspond to characteristics of the email that you
  define, so that you can publish email sending events.
- `"TemplateArn"`: The ARN of the template to use when sending this email.
"""
function send_templated_email(
    Destination,
    Source,
    Template,
    TemplateData;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "SendTemplatedEmail",
        Dict{String,Any}(
            "Destination" => Destination,
            "Source" => Source,
            "Template" => Template,
            "TemplateData" => TemplateData,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function send_templated_email(
    Destination,
    Source,
    Template,
    TemplateData,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "SendTemplatedEmail",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Destination" => Destination,
                    "Source" => Source,
                    "Template" => Template,
                    "TemplateData" => TemplateData,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    set_active_receipt_rule_set()
    set_active_receipt_rule_set(params::Dict{String,<:Any})

Sets the specified receipt rule set as the active receipt rule set.  To disable your
email-receiving through Amazon SES completely, you can call this operation with RuleSetName
set to null.  For information about managing receipt rule sets, see the Amazon SES
Developer Guide. You can execute this operation no more than once per second.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"RuleSetName"`: The name of the receipt rule set to make active. Setting this value to
  null disables all email receiving.
"""
function set_active_receipt_rule_set(; aws_config::AbstractAWSConfig=current_aws_config())
    return ses(
        "SetActiveReceiptRuleSet"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function set_active_receipt_rule_set(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "SetActiveReceiptRuleSet",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    set_identity_dkim_enabled(dkim_enabled, identity)
    set_identity_dkim_enabled(dkim_enabled, identity, params::Dict{String,<:Any})

Enables or disables Easy DKIM signing of email sent from an identity. If Easy DKIM signing
is enabled for a domain, then Amazon SES uses DKIM to sign all email that it sends from
addresses on that domain. If Easy DKIM signing is enabled for an email address, then Amazon
SES uses DKIM to sign all email it sends from that address.  For email addresses (for
example, user@example.com), you can only enable DKIM signing if the corresponding domain
(in this case, example.com) has been set up to use Easy DKIM.  You can enable DKIM signing
for an identity at any time after you start the verification process for the identity, even
if the verification process isn't complete.  You can execute this operation no more than
once per second. For more information about Easy DKIM signing, go to the Amazon SES
Developer Guide.

# Arguments
- `dkim_enabled`: Sets whether DKIM signing is enabled for an identity. Set to true to
  enable DKIM signing for this identity; false to disable it.
- `identity`: The identity for which DKIM signing should be enabled or disabled.

"""
function set_identity_dkim_enabled(
    DkimEnabled, Identity; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "SetIdentityDkimEnabled",
        Dict{String,Any}("DkimEnabled" => DkimEnabled, "Identity" => Identity);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function set_identity_dkim_enabled(
    DkimEnabled,
    Identity,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "SetIdentityDkimEnabled",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DkimEnabled" => DkimEnabled, "Identity" => Identity),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    set_identity_feedback_forwarding_enabled(forwarding_enabled, identity)
    set_identity_feedback_forwarding_enabled(forwarding_enabled, identity, params::Dict{String,<:Any})

Given an identity (an email address or a domain), enables or disables whether Amazon SES
forwards bounce and complaint notifications as email. Feedback forwarding can only be
disabled when Amazon Simple Notification Service (Amazon SNS) topics are specified for both
bounces and complaints.  Feedback forwarding does not apply to delivery notifications.
Delivery notifications are only available through Amazon SNS.  You can execute this
operation no more than once per second. For more information about using notifications with
Amazon SES, see the Amazon SES Developer Guide.

# Arguments
- `forwarding_enabled`: Sets whether Amazon SES forwards bounce and complaint notifications
  as email. true specifies that Amazon SES forwards bounce and complaint notifications as
  email, in addition to any Amazon SNS topic publishing otherwise specified. false specifies
  that Amazon SES publishes bounce and complaint notifications only through Amazon SNS. This
  value can only be set to false when Amazon SNS topics are set for both Bounce and Complaint
  notification types.
- `identity`: The identity for which to set bounce and complaint notification forwarding.
  Examples: user@example.com, example.com.

"""
function set_identity_feedback_forwarding_enabled(
    ForwardingEnabled, Identity; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "SetIdentityFeedbackForwardingEnabled",
        Dict{String,Any}("ForwardingEnabled" => ForwardingEnabled, "Identity" => Identity);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function set_identity_feedback_forwarding_enabled(
    ForwardingEnabled,
    Identity,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "SetIdentityFeedbackForwardingEnabled",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ForwardingEnabled" => ForwardingEnabled, "Identity" => Identity
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    set_identity_headers_in_notifications_enabled(enabled, identity, notification_type)
    set_identity_headers_in_notifications_enabled(enabled, identity, notification_type, params::Dict{String,<:Any})

Given an identity (an email address or a domain), sets whether Amazon SES includes the
original email headers in the Amazon Simple Notification Service (Amazon SNS) notifications
of a specified type. You can execute this operation no more than once per second. For more
information about using notifications with Amazon SES, see the Amazon SES Developer Guide.

# Arguments
- `enabled`: Sets whether Amazon SES includes the original email headers in Amazon SNS
  notifications of the specified notification type. A value of true specifies that Amazon SES
  includes headers in notifications, and a value of false specifies that Amazon SES does not
  include headers in notifications. This value can only be set when NotificationType is
  already set to use a particular Amazon SNS topic.
- `identity`: The identity for which to enable or disable headers in notifications.
  Examples: user@example.com, example.com.
- `notification_type`: The notification type for which to enable or disable headers in
  notifications.

"""
function set_identity_headers_in_notifications_enabled(
    Enabled, Identity, NotificationType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "SetIdentityHeadersInNotificationsEnabled",
        Dict{String,Any}(
            "Enabled" => Enabled,
            "Identity" => Identity,
            "NotificationType" => NotificationType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function set_identity_headers_in_notifications_enabled(
    Enabled,
    Identity,
    NotificationType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "SetIdentityHeadersInNotificationsEnabled",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Enabled" => Enabled,
                    "Identity" => Identity,
                    "NotificationType" => NotificationType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    set_identity_mail_from_domain(identity)
    set_identity_mail_from_domain(identity, params::Dict{String,<:Any})

Enables or disables the custom MAIL FROM domain setup for a verified identity (an email
address or a domain).  To send emails using the specified MAIL FROM domain, you must add an
MX record to your MAIL FROM domain's DNS settings. To ensure that your emails pass Sender
Policy Framework (SPF) checks, you must also add or update an SPF record. For more
information, see the Amazon SES Developer Guide.  You can execute this operation no more
than once per second.

# Arguments
- `identity`: The verified identity.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"BehaviorOnMXFailure"`: The action for Amazon SES to take if it cannot successfully read
  the required MX record when you send an email. If you choose UseDefaultValue, Amazon SES
  uses amazonses.com (or a subdomain of that) as the MAIL FROM domain. If you choose
  RejectMessage, Amazon SES returns a MailFromDomainNotVerified error and not send the email.
  The action specified in BehaviorOnMXFailure is taken when the custom MAIL FROM domain setup
  is in the Pending, Failed, and TemporaryFailure states.
- `"MailFromDomain"`: The custom MAIL FROM domain for the verified identity to use. The
  MAIL FROM domain must 1) be a subdomain of the verified identity, 2) not be used in a
  \"From\" address if the MAIL FROM domain is the destination of email feedback forwarding
  (for more information, see the Amazon SES Developer Guide), and 3) not be used to receive
  emails. A value of null disables the custom MAIL FROM setting for the identity.
"""
function set_identity_mail_from_domain(
    Identity; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "SetIdentityMailFromDomain",
        Dict{String,Any}("Identity" => Identity);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function set_identity_mail_from_domain(
    Identity,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "SetIdentityMailFromDomain",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Identity" => Identity), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    set_identity_notification_topic(identity, notification_type)
    set_identity_notification_topic(identity, notification_type, params::Dict{String,<:Any})

Sets an Amazon Simple Notification Service (Amazon SNS) topic to use when delivering
notifications. When you use this operation, you specify a verified identity, such as an
email address or domain. When you send an email that uses the chosen identity in the Source
field, Amazon SES sends notifications to the topic you specified. You can send bounce,
complaint, or delivery notifications (or any combination of the three) to the Amazon SNS
topic that you specify. You can execute this operation no more than once per second. For
more information about feedback notification, see the Amazon SES Developer Guide.

# Arguments
- `identity`: The identity (email address or domain) for the Amazon SNS topic.  You can
  only specify a verified identity for this parameter.  You can specify an identity by using
  its name or by using its Amazon Resource Name (ARN). The following examples are all valid
  identities: sender@example.com, example.com,
  arn:aws:ses:us-east-1:123456789012:identity/example.com.
- `notification_type`: The type of notifications that are published to the specified Amazon
  SNS topic.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"SnsTopic"`: The Amazon Resource Name (ARN) of the Amazon SNS topic. If the parameter is
  omitted from the request or a null value is passed, SnsTopic is cleared and publishing is
  disabled.
"""
function set_identity_notification_topic(
    Identity, NotificationType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "SetIdentityNotificationTopic",
        Dict{String,Any}("Identity" => Identity, "NotificationType" => NotificationType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function set_identity_notification_topic(
    Identity,
    NotificationType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "SetIdentityNotificationTopic",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Identity" => Identity, "NotificationType" => NotificationType
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    set_receipt_rule_position(rule_name, rule_set_name)
    set_receipt_rule_position(rule_name, rule_set_name, params::Dict{String,<:Any})

Sets the position of the specified receipt rule in the receipt rule set. For information
about managing receipt rules, see the Amazon SES Developer Guide. You can execute this
operation no more than once per second.

# Arguments
- `rule_name`: The name of the receipt rule to reposition.
- `rule_set_name`: The name of the receipt rule set that contains the receipt rule to
  reposition.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"After"`: The name of the receipt rule after which to place the specified receipt rule.
"""
function set_receipt_rule_position(
    RuleName, RuleSetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "SetReceiptRulePosition",
        Dict{String,Any}("RuleName" => RuleName, "RuleSetName" => RuleSetName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function set_receipt_rule_position(
    RuleName,
    RuleSetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "SetReceiptRulePosition",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("RuleName" => RuleName, "RuleSetName" => RuleSetName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    test_render_template(template_data, template_name)
    test_render_template(template_data, template_name, params::Dict{String,<:Any})

Creates a preview of the MIME content of an email when provided with a template and a set
of replacement data. You can execute this operation no more than once per second.

# Arguments
- `template_data`: A list of replacement values to apply to the template. This parameter is
  a JSON object, typically consisting of key-value pairs in which the keys correspond to
  replacement tags in the email template.
- `template_name`: The name of the template to render.

"""
function test_render_template(
    TemplateData, TemplateName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "TestRenderTemplate",
        Dict{String,Any}("TemplateData" => TemplateData, "TemplateName" => TemplateName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function test_render_template(
    TemplateData,
    TemplateName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "TestRenderTemplate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "TemplateData" => TemplateData, "TemplateName" => TemplateName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_account_sending_enabled()
    update_account_sending_enabled(params::Dict{String,<:Any})

Enables or disables email sending across your entire Amazon SES account in the current
Amazon Web Services Region. You can use this operation in conjunction with Amazon
CloudWatch alarms to temporarily pause email sending across your Amazon SES account in a
given Amazon Web Services Region when reputation metrics (such as your bounce or complaint
rates) reach certain thresholds. You can execute this operation no more than once per
second.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Enabled"`: Describes whether email sending is enabled or disabled for your Amazon SES
  account in the current Amazon Web Services Region.
"""
function update_account_sending_enabled(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "UpdateAccountSendingEnabled";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_account_sending_enabled(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "UpdateAccountSendingEnabled",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_configuration_set_event_destination(configuration_set_name, event_destination)
    update_configuration_set_event_destination(configuration_set_name, event_destination, params::Dict{String,<:Any})

Updates the event destination of a configuration set. Event destinations are associated
with configuration sets, which enable you to publish email sending events to Amazon
CloudWatch, Amazon Kinesis Firehose, or Amazon Simple Notification Service (Amazon SNS).
For information about using configuration sets, see Monitoring Your Amazon SES Sending
Activity in the Amazon SES Developer Guide.   When you create or update an event
destination, you must provide one, and only one, destination. The destination can be Amazon
CloudWatch, Amazon Kinesis Firehose, or Amazon Simple Notification Service (Amazon SNS).
You can execute this operation no more than once per second.

# Arguments
- `configuration_set_name`: The name of the configuration set that contains the event
  destination.
- `event_destination`: The event destination object.

"""
function update_configuration_set_event_destination(
    ConfigurationSetName,
    EventDestination;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "UpdateConfigurationSetEventDestination",
        Dict{String,Any}(
            "ConfigurationSetName" => ConfigurationSetName,
            "EventDestination" => EventDestination,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_configuration_set_event_destination(
    ConfigurationSetName,
    EventDestination,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "UpdateConfigurationSetEventDestination",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ConfigurationSetName" => ConfigurationSetName,
                    "EventDestination" => EventDestination,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_configuration_set_reputation_metrics_enabled(configuration_set_name, enabled)
    update_configuration_set_reputation_metrics_enabled(configuration_set_name, enabled, params::Dict{String,<:Any})

Enables or disables the publishing of reputation metrics for emails sent using a specific
configuration set in a given Amazon Web Services Region. Reputation metrics include bounce
and complaint rates. These metrics are published to Amazon CloudWatch. By using CloudWatch,
you can create alarms when bounce or complaint rates exceed certain thresholds. You can
execute this operation no more than once per second.

# Arguments
- `configuration_set_name`: The name of the configuration set to update.
- `enabled`: Describes whether or not Amazon SES publishes reputation metrics for the
  configuration set, such as bounce and complaint rates, to Amazon CloudWatch.

"""
function update_configuration_set_reputation_metrics_enabled(
    ConfigurationSetName, Enabled; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "UpdateConfigurationSetReputationMetricsEnabled",
        Dict{String,Any}(
            "ConfigurationSetName" => ConfigurationSetName, "Enabled" => Enabled
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_configuration_set_reputation_metrics_enabled(
    ConfigurationSetName,
    Enabled,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "UpdateConfigurationSetReputationMetricsEnabled",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ConfigurationSetName" => ConfigurationSetName, "Enabled" => Enabled
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_configuration_set_sending_enabled(configuration_set_name, enabled)
    update_configuration_set_sending_enabled(configuration_set_name, enabled, params::Dict{String,<:Any})

Enables or disables email sending for messages sent using a specific configuration set in a
given Amazon Web Services Region. You can use this operation in conjunction with Amazon
CloudWatch alarms to temporarily pause email sending for a configuration set when the
reputation metrics for that configuration set (such as your bounce on complaint rate)
exceed certain thresholds. You can execute this operation no more than once per second.

# Arguments
- `configuration_set_name`: The name of the configuration set to update.
- `enabled`: Describes whether email sending is enabled or disabled for the configuration
  set.

"""
function update_configuration_set_sending_enabled(
    ConfigurationSetName, Enabled; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "UpdateConfigurationSetSendingEnabled",
        Dict{String,Any}(
            "ConfigurationSetName" => ConfigurationSetName, "Enabled" => Enabled
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_configuration_set_sending_enabled(
    ConfigurationSetName,
    Enabled,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "UpdateConfigurationSetSendingEnabled",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ConfigurationSetName" => ConfigurationSetName, "Enabled" => Enabled
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_configuration_set_tracking_options(configuration_set_name, tracking_options)
    update_configuration_set_tracking_options(configuration_set_name, tracking_options, params::Dict{String,<:Any})

Modifies an association between a configuration set and a custom domain for open and click
event tracking.  By default, images and links used for tracking open and click events are
hosted on domains operated by Amazon SES. You can configure a subdomain of your own to
handle these events. For information about using custom domains, see the Amazon SES
Developer Guide.

# Arguments
- `configuration_set_name`: The name of the configuration set.
- `tracking_options`:

"""
function update_configuration_set_tracking_options(
    ConfigurationSetName,
    TrackingOptions;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "UpdateConfigurationSetTrackingOptions",
        Dict{String,Any}(
            "ConfigurationSetName" => ConfigurationSetName,
            "TrackingOptions" => TrackingOptions,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_configuration_set_tracking_options(
    ConfigurationSetName,
    TrackingOptions,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "UpdateConfigurationSetTrackingOptions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ConfigurationSetName" => ConfigurationSetName,
                    "TrackingOptions" => TrackingOptions,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_custom_verification_email_template(template_name)
    update_custom_verification_email_template(template_name, params::Dict{String,<:Any})

Updates an existing custom verification email template. For more information about custom
verification email templates, see Using Custom Verification Email Templates in the Amazon
SES Developer Guide. You can execute this operation no more than once per second.

# Arguments
- `template_name`: The name of the custom verification email template to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FailureRedirectionURL"`: The URL that the recipient of the verification email is sent
  to if his or her address is not successfully verified.
- `"FromEmailAddress"`: The email address that the custom verification email is sent from.
- `"SuccessRedirectionURL"`: The URL that the recipient of the verification email is sent
  to if his or her address is successfully verified.
- `"TemplateContent"`: The content of the custom verification email. The total size of the
  email must be less than 10 MB. The message body may contain HTML, with some limitations.
  For more information, see Custom Verification Email Frequently Asked Questions in the
  Amazon SES Developer Guide.
- `"TemplateSubject"`: The subject line of the custom verification email.
"""
function update_custom_verification_email_template(
    TemplateName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "UpdateCustomVerificationEmailTemplate",
        Dict{String,Any}("TemplateName" => TemplateName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_custom_verification_email_template(
    TemplateName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "UpdateCustomVerificationEmailTemplate",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TemplateName" => TemplateName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_receipt_rule(rule, rule_set_name)
    update_receipt_rule(rule, rule_set_name, params::Dict{String,<:Any})

Updates a receipt rule. For information about managing receipt rules, see the Amazon SES
Developer Guide. You can execute this operation no more than once per second.

# Arguments
- `rule`: A data structure that contains the updated receipt rule information.
- `rule_set_name`: The name of the receipt rule set that the receipt rule belongs to.

"""
function update_receipt_rule(
    Rule, RuleSetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "UpdateReceiptRule",
        Dict{String,Any}("Rule" => Rule, "RuleSetName" => RuleSetName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_receipt_rule(
    Rule,
    RuleSetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "UpdateReceiptRule",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Rule" => Rule, "RuleSetName" => RuleSetName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_template(template)
    update_template(template, params::Dict{String,<:Any})

Updates an email template. Email templates enable you to send personalized email to one or
more destinations in a single operation. For more information, see the Amazon SES Developer
Guide. You can execute this operation no more than once per second.

# Arguments
- `template`:

"""
function update_template(Template; aws_config::AbstractAWSConfig=current_aws_config())
    return ses(
        "UpdateTemplate",
        Dict{String,Any}("Template" => Template);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_template(
    Template,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "UpdateTemplate",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Template" => Template), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    verify_domain_dkim(domain)
    verify_domain_dkim(domain, params::Dict{String,<:Any})

Returns a set of DKIM tokens for a domain identity.  When you execute the VerifyDomainDkim
operation, the domain that you specify is added to the list of identities that are
associated with your account. This is true even if you haven't already associated the
domain with your account by using the VerifyDomainIdentity operation. However, you can't
send email from the domain until you either successfully verify it or you successfully set
up DKIM for it.  You use the tokens that are generated by this operation to create CNAME
records. When Amazon SES detects that you've added these records to the DNS configuration
for a domain, you can start sending email from that domain. You can start sending email
even if you haven't added the TXT record provided by the VerifyDomainIdentity operation to
the DNS configuration for your domain. All email that you send from the domain is
authenticated using DKIM. To create the CNAME records for DKIM authentication, use the
following values:    Name: token._domainkey.example.com     Type: CNAME    Value:
token.dkim.amazonses.com   In the preceding example, replace token with one of the tokens
that are generated when you execute this operation. Replace example.com with your domain.
Repeat this process for each token that's generated by this operation. You can execute this
operation no more than once per second.

# Arguments
- `domain`: The name of the domain to be verified for Easy DKIM signing.

"""
function verify_domain_dkim(Domain; aws_config::AbstractAWSConfig=current_aws_config())
    return ses(
        "VerifyDomainDkim",
        Dict{String,Any}("Domain" => Domain);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function verify_domain_dkim(
    Domain, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "VerifyDomainDkim",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Domain" => Domain), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    verify_domain_identity(domain)
    verify_domain_identity(domain, params::Dict{String,<:Any})

Adds a domain to the list of identities for your Amazon SES account in the current Amazon
Web Services Region and attempts to verify it. For more information about verifying
domains, see Verifying Email Addresses and Domains in the Amazon SES Developer Guide.  You
can execute this operation no more than once per second.

# Arguments
- `domain`: The domain to be verified.

"""
function verify_domain_identity(Domain; aws_config::AbstractAWSConfig=current_aws_config())
    return ses(
        "VerifyDomainIdentity",
        Dict{String,Any}("Domain" => Domain);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function verify_domain_identity(
    Domain, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "VerifyDomainIdentity",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Domain" => Domain), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    verify_email_address(email_address)
    verify_email_address(email_address, params::Dict{String,<:Any})

Deprecated. Use the VerifyEmailIdentity operation to verify a new email address.

# Arguments
- `email_address`: The email address to be verified.

"""
function verify_email_address(
    EmailAddress; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "VerifyEmailAddress",
        Dict{String,Any}("EmailAddress" => EmailAddress);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function verify_email_address(
    EmailAddress,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "VerifyEmailAddress",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("EmailAddress" => EmailAddress), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    verify_email_identity(email_address)
    verify_email_identity(email_address, params::Dict{String,<:Any})

Adds an email address to the list of identities for your Amazon SES account in the current
Amazon Web Services Region and attempts to verify it. As a result of executing this
operation, a verification email is sent to the specified address. You can execute this
operation no more than once per second.

# Arguments
- `email_address`: The email address to be verified.

"""
function verify_email_identity(
    EmailAddress; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ses(
        "VerifyEmailIdentity",
        Dict{String,Any}("EmailAddress" => EmailAddress);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function verify_email_identity(
    EmailAddress,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ses(
        "VerifyEmailIdentity",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("EmailAddress" => EmailAddress), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: eventbridge
using AWS.Compat
using AWS.UUIDs

"""
    activate_event_source(name)
    activate_event_source(name, params::Dict{String,<:Any})

Activates a partner event source that has been deactivated. Once activated, your matching
event bus will start receiving events from the event source.

# Arguments
- `name`: The name of the partner event source to activate.

"""
function activate_event_source(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return eventbridge(
        "ActivateEventSource",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function activate_event_source(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eventbridge(
        "ActivateEventSource",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_replay(replay_name)
    cancel_replay(replay_name, params::Dict{String,<:Any})

Cancels the specified replay.

# Arguments
- `replay_name`: The name of the replay to cancel.

"""
function cancel_replay(ReplayName; aws_config::AbstractAWSConfig=current_aws_config())
    return eventbridge(
        "CancelReplay",
        Dict{String,Any}("ReplayName" => ReplayName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_replay(
    ReplayName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eventbridge(
        "CancelReplay",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ReplayName" => ReplayName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_api_destination(connection_arn, http_method, invocation_endpoint, name)
    create_api_destination(connection_arn, http_method, invocation_endpoint, name, params::Dict{String,<:Any})

Creates an API destination, which is an HTTP invocation endpoint configured as a target for
events. API destinations do not support private destinations, such as interface VPC
endpoints. For more information, see API destinations in the EventBridge User Guide.

# Arguments
- `connection_arn`: The ARN of the connection to use for the API destination. The
  destination endpoint must support the authorization type specified for the connection.
- `http_method`: The method to use for the request to the HTTP invocation endpoint.
- `invocation_endpoint`: The URL to the HTTP invocation endpoint for the API destination.
- `name`: The name for the API destination to create.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description for the API destination to create.
- `"InvocationRateLimitPerSecond"`: The maximum number of requests per second to send to
  the HTTP invocation endpoint.
"""
function create_api_destination(
    ConnectionArn,
    HttpMethod,
    InvocationEndpoint,
    Name;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eventbridge(
        "CreateApiDestination",
        Dict{String,Any}(
            "ConnectionArn" => ConnectionArn,
            "HttpMethod" => HttpMethod,
            "InvocationEndpoint" => InvocationEndpoint,
            "Name" => Name,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_api_destination(
    ConnectionArn,
    HttpMethod,
    InvocationEndpoint,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eventbridge(
        "CreateApiDestination",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ConnectionArn" => ConnectionArn,
                    "HttpMethod" => HttpMethod,
                    "InvocationEndpoint" => InvocationEndpoint,
                    "Name" => Name,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_archive(archive_name, event_source_arn)
    create_archive(archive_name, event_source_arn, params::Dict{String,<:Any})

Creates an archive of events with the specified settings. When you create an archive,
incoming events might not immediately start being sent to the archive. Allow a short period
of time for changes to take effect. If you do not specify a pattern to filter events sent
to the archive, all events are sent to the archive except replayed events. Replayed events
are not sent to an archive.  Archives and schema discovery are not supported for event
buses encrypted using a customer managed key. EventBridge returns an error if:   You call
CreateArchive  on an event bus set to use a customer managed key for encryption.   You call
 CreateDiscoverer  on an event bus set to use a customer managed key for encryption.   You
call  UpdatedEventBus  to set a customer managed key on an event bus with an archives or
schema discovery enabled.   To enable archives or schema discovery on an event bus, choose
to use an Amazon Web Services owned key. For more information, see Data encryption in
EventBridge in the Amazon EventBridge User Guide.

# Arguments
- `archive_name`: The name for the archive to create.
- `event_source_arn`: The ARN of the event bus that sends events to the archive.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description for the archive.
- `"EventPattern"`: An event pattern to use to filter events sent to the archive.
- `"RetentionDays"`: The number of days to retain events for. Default value is 0. If set to
  0, events are retained indefinitely
"""
function create_archive(
    ArchiveName, EventSourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eventbridge(
        "CreateArchive",
        Dict{String,Any}("ArchiveName" => ArchiveName, "EventSourceArn" => EventSourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_archive(
    ArchiveName,
    EventSourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eventbridge(
        "CreateArchive",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ArchiveName" => ArchiveName, "EventSourceArn" => EventSourceArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_connection(auth_parameters, authorization_type, name)
    create_connection(auth_parameters, authorization_type, name, params::Dict{String,<:Any})

Creates a connection. A connection defines the authorization type and credentials to use
for authorization with an API destination HTTP endpoint.

# Arguments
- `auth_parameters`: A CreateConnectionAuthRequestParameters object that contains the
  authorization parameters to use to authorize with the endpoint.
- `authorization_type`: The type of authorization to use for the connection.  OAUTH tokens
  are refreshed when a 401 or 407 response is returned.
- `name`: The name for the connection to create.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description for the connection to create.
"""
function create_connection(
    AuthParameters,
    AuthorizationType,
    Name;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eventbridge(
        "CreateConnection",
        Dict{String,Any}(
            "AuthParameters" => AuthParameters,
            "AuthorizationType" => AuthorizationType,
            "Name" => Name,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_connection(
    AuthParameters,
    AuthorizationType,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eventbridge(
        "CreateConnection",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AuthParameters" => AuthParameters,
                    "AuthorizationType" => AuthorizationType,
                    "Name" => Name,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_endpoint(event_buses, name, routing_config)
    create_endpoint(event_buses, name, routing_config, params::Dict{String,<:Any})

Creates a global endpoint. Global endpoints improve your application's availability by
making it regional-fault tolerant. To do this, you define a primary and secondary Region
with event buses in each Region. You also create a Amazon Route 53 health check that will
tell EventBridge to route events to the secondary Region when an \"unhealthy\" state is
encountered and events will be routed back to the primary Region when the health check
reports a \"healthy\" state.

# Arguments
- `event_buses`: Define the event buses used.   The names of the event buses must be
  identical in each Region.
- `name`: The name of the global endpoint. For example,
  \"Name\":\"us-east-2-custom_bus_A-endpoint\".
- `routing_config`: Configure the routing policy, including the health check and secondary
  Region..

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description of the global endpoint.
- `"ReplicationConfig"`: Enable or disable event replication. The default state is ENABLED
  which means you must supply a RoleArn. If you don't have a RoleArn or you don't want event
  replication enabled, set the state to DISABLED.
- `"RoleArn"`: The ARN of the role used for replication.
"""
function create_endpoint(
    EventBuses, Name, RoutingConfig; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eventbridge(
        "CreateEndpoint",
        Dict{String,Any}(
            "EventBuses" => EventBuses, "Name" => Name, "RoutingConfig" => RoutingConfig
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_endpoint(
    EventBuses,
    Name,
    RoutingConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eventbridge(
        "CreateEndpoint",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EventBuses" => EventBuses,
                    "Name" => Name,
                    "RoutingConfig" => RoutingConfig,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_event_bus(name)
    create_event_bus(name, params::Dict{String,<:Any})

Creates a new event bus within your account. This can be a custom event bus which you can
use to receive events from your custom applications and services, or it can be a partner
event bus which can be matched to a partner event source.

# Arguments
- `name`: The name of the new event bus.  Custom event bus names can't contain the /
  character, but you can use the / character in partner event bus names. In addition, for
  partner event buses, the name must exactly match the name of the partner event source that
  this event bus is matched to. You can't use the name default for a custom event bus, as
  this name is already used for your account's default event bus.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DeadLetterConfig"`:
- `"Description"`: The event bus description.
- `"EventSourceName"`: If you are creating a partner event bus, this specifies the partner
  event source that the new event bus will be matched with.
- `"KmsKeyIdentifier"`: The identifier of the KMS customer managed key for EventBridge to
  use, if you choose to use a customer managed key to encrypt events on this event bus. The
  identifier can be the key Amazon Resource Name (ARN), KeyId, key alias, or key alias ARN.
  If you do not specify a customer managed key identifier, EventBridge uses an Amazon Web
  Services owned key to encrypt events on the event bus. For more information, see Managing
  keys in the Key Management Service Developer Guide.   Archives and schema discovery are not
  supported for event buses encrypted using a customer managed key. EventBridge returns an
  error if:   You call  CreateArchive  on an event bus set to use a customer managed key for
  encryption.   You call  CreateDiscoverer  on an event bus set to use a customer managed key
  for encryption.   You call  UpdatedEventBus  to set a customer managed key on an event bus
  with an archives or schema discovery enabled.   To enable archives or schema discovery on
  an event bus, choose to use an Amazon Web Services owned key. For more information, see
  Data encryption in EventBridge in the Amazon EventBridge User Guide.
- `"Tags"`: Tags to associate with the event bus.
"""
function create_event_bus(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return eventbridge(
        "CreateEventBus",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_event_bus(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eventbridge(
        "CreateEventBus",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_partner_event_source(account, name)
    create_partner_event_source(account, name, params::Dict{String,<:Any})

Called by an SaaS partner to create a partner event source. This operation is not used by
Amazon Web Services customers. Each partner event source can be used by one Amazon Web
Services account to create a matching partner event bus in that Amazon Web Services
account. A SaaS partner must create one partner event source for each Amazon Web Services
account that wants to receive those event types.  A partner event source creates events
based on resources within the SaaS partner's service or application. An Amazon Web Services
account that creates a partner event bus that matches the partner event source can use that
event bus to receive events from the partner, and then process them using Amazon Web
Services Events rules and targets. Partner event source names follow this format:
partner_name/event_namespace/event_name      partner_name is determined during partner
registration, and identifies the partner to Amazon Web Services customers.
event_namespace is determined by the partner, and is a way for the partner to categorize
their events.    event_name is determined by the partner, and should uniquely identify an
event-generating resource within the partner system.  The event_name must be unique across
all Amazon Web Services customers. This is because the event source is a shared resource
between the partner and customer accounts, and each partner event source unique in the
partner account.   The combination of event_namespace and event_name should help Amazon Web
Services customers decide whether to create an event bus to receive these events.

# Arguments
- `account`: The Amazon Web Services account ID that is permitted to create a matching
  partner event bus for this partner event source.
- `name`: The name of the partner event source. This name must be unique and must be in the
  format  partner_name/event_namespace/event_name . The Amazon Web Services account that
  wants to use this partner event source must create a partner event bus with a name that
  matches the name of the partner event source.

"""
function create_partner_event_source(
    Account, Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eventbridge(
        "CreatePartnerEventSource",
        Dict{String,Any}("Account" => Account, "Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_partner_event_source(
    Account,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eventbridge(
        "CreatePartnerEventSource",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("Account" => Account, "Name" => Name), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    deactivate_event_source(name)
    deactivate_event_source(name, params::Dict{String,<:Any})

You can use this operation to temporarily stop receiving events from the specified partner
event source. The matching event bus is not deleted.  When you deactivate a partner event
source, the source goes into PENDING state. If it remains in PENDING state for more than
two weeks, it is deleted. To activate a deactivated partner event source, use
ActivateEventSource.

# Arguments
- `name`: The name of the partner event source to deactivate.

"""
function deactivate_event_source(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return eventbridge(
        "DeactivateEventSource",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function deactivate_event_source(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eventbridge(
        "DeactivateEventSource",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    deauthorize_connection(name)
    deauthorize_connection(name, params::Dict{String,<:Any})

Removes all authorization parameters from the connection. This lets you remove the secret
from the connection so you can reuse it without having to create a new connection.

# Arguments
- `name`: The name of the connection to remove authorization from.

"""
function deauthorize_connection(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return eventbridge(
        "DeauthorizeConnection",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function deauthorize_connection(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eventbridge(
        "DeauthorizeConnection",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_api_destination(name)
    delete_api_destination(name, params::Dict{String,<:Any})

Deletes the specified API destination.

# Arguments
- `name`: The name of the destination to delete.

"""
function delete_api_destination(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return eventbridge(
        "DeleteApiDestination",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_api_destination(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eventbridge(
        "DeleteApiDestination",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_archive(archive_name)
    delete_archive(archive_name, params::Dict{String,<:Any})

Deletes the specified archive.

# Arguments
- `archive_name`: The name of the archive to delete.

"""
function delete_archive(ArchiveName; aws_config::AbstractAWSConfig=current_aws_config())
    return eventbridge(
        "DeleteArchive",
        Dict{String,Any}("ArchiveName" => ArchiveName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_archive(
    ArchiveName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eventbridge(
        "DeleteArchive",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ArchiveName" => ArchiveName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_connection(name)
    delete_connection(name, params::Dict{String,<:Any})

Deletes a connection.

# Arguments
- `name`: The name of the connection to delete.

"""
function delete_connection(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return eventbridge(
        "DeleteConnection",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_connection(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eventbridge(
        "DeleteConnection",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_endpoint(name)
    delete_endpoint(name, params::Dict{String,<:Any})

Delete an existing global endpoint. For more information about global endpoints, see Making
applications Regional-fault tolerant with global endpoints and event replication in the
Amazon EventBridge User Guide .

# Arguments
- `name`: The name of the endpoint you want to delete. For example,
  \"Name\":\"us-east-2-custom_bus_A-endpoint\"..

"""
function delete_endpoint(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return eventbridge(
        "DeleteEndpoint",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_endpoint(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eventbridge(
        "DeleteEndpoint",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_event_bus(name)
    delete_event_bus(name, params::Dict{String,<:Any})

Deletes the specified custom event bus or partner event bus. All rules associated with this
event bus need to be deleted. You can't delete your account's default event bus.

# Arguments
- `name`: The name of the event bus to delete.

"""
function delete_event_bus(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return eventbridge(
        "DeleteEventBus",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_event_bus(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eventbridge(
        "DeleteEventBus",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_partner_event_source(account, name)
    delete_partner_event_source(account, name, params::Dict{String,<:Any})

This operation is used by SaaS partners to delete a partner event source. This operation is
not used by Amazon Web Services customers. When you delete an event source, the status of
the corresponding partner event bus in the Amazon Web Services customer account becomes
DELETED.

# Arguments
- `account`: The Amazon Web Services account ID of the Amazon Web Services customer that
  the event source was created for.
- `name`: The name of the event source to delete.

"""
function delete_partner_event_source(
    Account, Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eventbridge(
        "DeletePartnerEventSource",
        Dict{String,Any}("Account" => Account, "Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_partner_event_source(
    Account,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eventbridge(
        "DeletePartnerEventSource",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("Account" => Account, "Name" => Name), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_rule(name)
    delete_rule(name, params::Dict{String,<:Any})

Deletes the specified rule. Before you can delete the rule, you must remove all targets,
using RemoveTargets. When you delete a rule, incoming events might continue to match to the
deleted rule. Allow a short period of time for changes to take effect. If you call delete
rule multiple times for the same rule, all calls will succeed. When you call delete rule
for a non-existent custom eventbus, ResourceNotFoundException is returned. Managed rules
are rules created and managed by another Amazon Web Services service on your behalf. These
rules are created by those other Amazon Web Services services to support functionality in
those services. You can delete these rules using the Force option, but you should do so
only if you are sure the other service is not still using that rule.

# Arguments
- `name`: The name of the rule.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EventBusName"`: The name or ARN of the event bus associated with the rule. If you omit
  this, the default event bus is used.
- `"Force"`: If this is a managed rule, created by an Amazon Web Services service on your
  behalf, you must specify Force as True to delete the rule. This parameter is ignored for
  rules that are not managed rules. You can check whether a rule is a managed rule by using
  DescribeRule or ListRules and checking the ManagedBy field of the response.
"""
function delete_rule(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return eventbridge(
        "DeleteRule",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_rule(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eventbridge(
        "DeleteRule",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_api_destination(name)
    describe_api_destination(name, params::Dict{String,<:Any})

Retrieves details about an API destination.

# Arguments
- `name`: The name of the API destination to retrieve.

"""
function describe_api_destination(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return eventbridge(
        "DescribeApiDestination",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_api_destination(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eventbridge(
        "DescribeApiDestination",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_archive(archive_name)
    describe_archive(archive_name, params::Dict{String,<:Any})

Retrieves details about an archive.

# Arguments
- `archive_name`: The name of the archive to retrieve.

"""
function describe_archive(ArchiveName; aws_config::AbstractAWSConfig=current_aws_config())
    return eventbridge(
        "DescribeArchive",
        Dict{String,Any}("ArchiveName" => ArchiveName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_archive(
    ArchiveName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eventbridge(
        "DescribeArchive",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ArchiveName" => ArchiveName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_connection(name)
    describe_connection(name, params::Dict{String,<:Any})

Retrieves details about a connection.

# Arguments
- `name`: The name of the connection to retrieve.

"""
function describe_connection(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return eventbridge(
        "DescribeConnection",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_connection(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eventbridge(
        "DescribeConnection",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_endpoint(name)
    describe_endpoint(name, params::Dict{String,<:Any})

Get the information about an existing global endpoint. For more information about global
endpoints, see Making applications Regional-fault tolerant with global endpoints and event
replication in the  Amazon EventBridge User Guide .

# Arguments
- `name`: The name of the endpoint you want to get information about. For example,
  \"Name\":\"us-east-2-custom_bus_A-endpoint\".

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"HomeRegion"`: The primary Region of the endpoint you want to get information about. For
  example \"HomeRegion\": \"us-east-1\".
"""
function describe_endpoint(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return eventbridge(
        "DescribeEndpoint",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_endpoint(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eventbridge(
        "DescribeEndpoint",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_event_bus()
    describe_event_bus(params::Dict{String,<:Any})

Displays details about an event bus in your account. This can include the external Amazon
Web Services accounts that are permitted to write events to your default event bus, and the
associated policy. For custom event buses and partner event buses, it displays the name,
ARN, policy, state, and creation time.  To enable your account to receive events from other
accounts on its default event bus, use PutPermission. For more information about partner
event buses, see CreateEventBus.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Name"`: The name or ARN of the event bus to show details for. If you omit this, the
  default event bus is displayed.
"""
function describe_event_bus(; aws_config::AbstractAWSConfig=current_aws_config())
    return eventbridge(
        "DescribeEventBus"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_event_bus(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eventbridge(
        "DescribeEventBus", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_event_source(name)
    describe_event_source(name, params::Dict{String,<:Any})

This operation lists details about a partner event source that is shared with your account.

# Arguments
- `name`: The name of the partner event source to display the details of.

"""
function describe_event_source(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return eventbridge(
        "DescribeEventSource",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_event_source(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eventbridge(
        "DescribeEventSource",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_partner_event_source(name)
    describe_partner_event_source(name, params::Dict{String,<:Any})

An SaaS partner can use this operation to list details about a partner event source that
they have created. Amazon Web Services customers do not use this operation. Instead, Amazon
Web Services customers can use DescribeEventSource to see details about a partner event
source that is shared with them.

# Arguments
- `name`: The name of the event source to display.

"""
function describe_partner_event_source(
    Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eventbridge(
        "DescribePartnerEventSource",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_partner_event_source(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eventbridge(
        "DescribePartnerEventSource",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_replay(replay_name)
    describe_replay(replay_name, params::Dict{String,<:Any})

Retrieves details about a replay. Use DescribeReplay to determine the progress of a running
replay. A replay processes events to replay based on the time in the event, and replays
them using 1 minute intervals. If you use StartReplay and specify an EventStartTime and an
EventEndTime that covers a 20 minute time range, the events are replayed from the first
minute of that 20 minute range first. Then the events from the second minute are replayed.
You can use DescribeReplay to determine the progress of a replay. The value returned for
EventLastReplayedTime indicates the time within the specified time range associated with
the last event replayed.

# Arguments
- `replay_name`: The name of the replay to retrieve.

"""
function describe_replay(ReplayName; aws_config::AbstractAWSConfig=current_aws_config())
    return eventbridge(
        "DescribeReplay",
        Dict{String,Any}("ReplayName" => ReplayName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_replay(
    ReplayName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eventbridge(
        "DescribeReplay",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ReplayName" => ReplayName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_rule(name)
    describe_rule(name, params::Dict{String,<:Any})

Describes the specified rule. DescribeRule does not list the targets of a rule. To see the
targets associated with a rule, use ListTargetsByRule.

# Arguments
- `name`: The name of the rule.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EventBusName"`: The name or ARN of the event bus associated with the rule. If you omit
  this, the default event bus is used.
"""
function describe_rule(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return eventbridge(
        "DescribeRule",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_rule(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eventbridge(
        "DescribeRule",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disable_rule(name)
    disable_rule(name, params::Dict{String,<:Any})

Disables the specified rule. A disabled rule won't match any events, and won't self-trigger
if it has a schedule expression. When you disable a rule, incoming events might continue to
match to the disabled rule. Allow a short period of time for changes to take effect.

# Arguments
- `name`: The name of the rule.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EventBusName"`: The name or ARN of the event bus associated with the rule. If you omit
  this, the default event bus is used.
"""
function disable_rule(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return eventbridge(
        "DisableRule",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disable_rule(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eventbridge(
        "DisableRule",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    enable_rule(name)
    enable_rule(name, params::Dict{String,<:Any})

Enables the specified rule. If the rule does not exist, the operation fails. When you
enable a rule, incoming events might not immediately start matching to a newly enabled
rule. Allow a short period of time for changes to take effect.

# Arguments
- `name`: The name of the rule.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EventBusName"`: The name or ARN of the event bus associated with the rule. If you omit
  this, the default event bus is used.
"""
function enable_rule(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return eventbridge(
        "EnableRule",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function enable_rule(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eventbridge(
        "EnableRule",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_api_destinations()
    list_api_destinations(params::Dict{String,<:Any})

Retrieves a list of API destination in the account in the current Region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConnectionArn"`: The ARN of the connection specified for the API destination.
- `"Limit"`: The maximum number of API destinations to include in the response.
- `"NamePrefix"`: A name prefix to filter results returned. Only API destinations with a
  name that starts with the prefix are returned.
- `"NextToken"`: The token returned by a previous call to retrieve the next set of results.
"""
function list_api_destinations(; aws_config::AbstractAWSConfig=current_aws_config())
    return eventbridge(
        "ListApiDestinations"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_api_destinations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eventbridge(
        "ListApiDestinations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_archives()
    list_archives(params::Dict{String,<:Any})

Lists your archives. You can either list all the archives or you can provide a prefix to
match to the archive names. Filter parameters are exclusive.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EventSourceArn"`: The ARN of the event source associated with the archive.
- `"Limit"`: The maximum number of results to return.
- `"NamePrefix"`: A name prefix to filter the archives returned. Only archives with name
  that match the prefix are returned.
- `"NextToken"`: The token returned by a previous call to retrieve the next set of results.
- `"State"`: The state of the archive.
"""
function list_archives(; aws_config::AbstractAWSConfig=current_aws_config())
    return eventbridge(
        "ListArchives"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_archives(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eventbridge(
        "ListArchives", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_connections()
    list_connections(params::Dict{String,<:Any})

Retrieves a list of connections from the account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConnectionState"`: The state of the connection.
- `"Limit"`: The maximum number of connections to return.
- `"NamePrefix"`: A name prefix to filter results returned. Only connections with a name
  that starts with the prefix are returned.
- `"NextToken"`: The token returned by a previous call to retrieve the next set of results.
"""
function list_connections(; aws_config::AbstractAWSConfig=current_aws_config())
    return eventbridge(
        "ListConnections"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_connections(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eventbridge(
        "ListConnections", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_endpoints()
    list_endpoints(params::Dict{String,<:Any})

List the global endpoints associated with this account. For more information about global
endpoints, see Making applications Regional-fault tolerant with global endpoints and event
replication in the  Amazon EventBridge User Guide .

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"HomeRegion"`: The primary Region of the endpoints associated with this account. For
  example \"HomeRegion\": \"us-east-1\".
- `"MaxResults"`: The maximum number of results returned by the call.
- `"NamePrefix"`: A value that will return a subset of the endpoints associated with this
  account. For example, \"NamePrefix\": \"ABC\" will return all endpoints with \"ABC\" in the
  name.
- `"NextToken"`: If nextToken is returned, there are more results available. The value of
  nextToken is a unique pagination token for each page. Make the call again using the
  returned token to retrieve the next page. Keep all other arguments unchanged. Each
  pagination token expires after 24 hours. Using an expired pagination token will return an
  HTTP 400 InvalidToken error.
"""
function list_endpoints(; aws_config::AbstractAWSConfig=current_aws_config())
    return eventbridge(
        "ListEndpoints"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_endpoints(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eventbridge(
        "ListEndpoints", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_event_buses()
    list_event_buses(params::Dict{String,<:Any})

Lists all the event buses in your account, including the default event bus, custom event
buses, and partner event buses.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: Specifying this limits the number of results returned by this operation. The
  operation also returns a NextToken which you can use in a subsequent operation to retrieve
  the next set of results.
- `"NamePrefix"`: Specifying this limits the results to only those event buses with names
  that start with the specified prefix.
- `"NextToken"`: The token returned by a previous call to retrieve the next set of results.
"""
function list_event_buses(; aws_config::AbstractAWSConfig=current_aws_config())
    return eventbridge(
        "ListEventBuses"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_event_buses(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eventbridge(
        "ListEventBuses", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_event_sources()
    list_event_sources(params::Dict{String,<:Any})

You can use this to see all the partner event sources that have been shared with your
Amazon Web Services account. For more information about partner event sources, see
CreateEventBus.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: Specifying this limits the number of results returned by this operation. The
  operation also returns a NextToken which you can use in a subsequent operation to retrieve
  the next set of results.
- `"NamePrefix"`: Specifying this limits the results to only those partner event sources
  with names that start with the specified prefix.
- `"NextToken"`: The token returned by a previous call to retrieve the next set of results.
"""
function list_event_sources(; aws_config::AbstractAWSConfig=current_aws_config())
    return eventbridge(
        "ListEventSources"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_event_sources(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eventbridge(
        "ListEventSources", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_partner_event_source_accounts(event_source_name)
    list_partner_event_source_accounts(event_source_name, params::Dict{String,<:Any})

An SaaS partner can use this operation to display the Amazon Web Services account ID that a
particular partner event source name is associated with. This operation is not used by
Amazon Web Services customers.

# Arguments
- `event_source_name`: The name of the partner event source to display account information
  about.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: Specifying this limits the number of results returned by this operation. The
  operation also returns a NextToken which you can use in a subsequent operation to retrieve
  the next set of results.
- `"NextToken"`: The token returned by a previous call to this operation. Specifying this
  retrieves the next set of results.
"""
function list_partner_event_source_accounts(
    EventSourceName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eventbridge(
        "ListPartnerEventSourceAccounts",
        Dict{String,Any}("EventSourceName" => EventSourceName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_partner_event_source_accounts(
    EventSourceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eventbridge(
        "ListPartnerEventSourceAccounts",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("EventSourceName" => EventSourceName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_partner_event_sources(name_prefix)
    list_partner_event_sources(name_prefix, params::Dict{String,<:Any})

An SaaS partner can use this operation to list all the partner event source names that they
have created. This operation is not used by Amazon Web Services customers.

# Arguments
- `name_prefix`: If you specify this, the results are limited to only those partner event
  sources that start with the string you specify.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: pecifying this limits the number of results returned by this operation. The
  operation also returns a NextToken which you can use in a subsequent operation to retrieve
  the next set of results.
- `"NextToken"`: The token returned by a previous call to this operation. Specifying this
  retrieves the next set of results.
"""
function list_partner_event_sources(
    NamePrefix; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eventbridge(
        "ListPartnerEventSources",
        Dict{String,Any}("NamePrefix" => NamePrefix);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_partner_event_sources(
    NamePrefix,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eventbridge(
        "ListPartnerEventSources",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("NamePrefix" => NamePrefix), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_replays()
    list_replays(params::Dict{String,<:Any})

Lists your replays. You can either list all the replays or you can provide a prefix to
match to the replay names. Filter parameters are exclusive.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EventSourceArn"`: The ARN of the archive from which the events are replayed.
- `"Limit"`: The maximum number of replays to retrieve.
- `"NamePrefix"`: A name prefix to filter the replays returned. Only replays with name that
  match the prefix are returned.
- `"NextToken"`: The token returned by a previous call to retrieve the next set of results.
- `"State"`: The state of the replay.
"""
function list_replays(; aws_config::AbstractAWSConfig=current_aws_config())
    return eventbridge(
        "ListReplays"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_replays(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eventbridge(
        "ListReplays", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_rule_names_by_target(target_arn)
    list_rule_names_by_target(target_arn, params::Dict{String,<:Any})

Lists the rules for the specified target. You can see which of the rules in Amazon
EventBridge can invoke a specific target in your account. The maximum number of results per
page for requests is 100.

# Arguments
- `target_arn`: The Amazon Resource Name (ARN) of the target resource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EventBusName"`: The name or ARN of the event bus to list rules for. If you omit this,
  the default event bus is used.
- `"Limit"`: The maximum number of results to return.
- `"NextToken"`: The token returned by a previous call to retrieve the next set of results.
"""
function list_rule_names_by_target(
    TargetArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eventbridge(
        "ListRuleNamesByTarget",
        Dict{String,Any}("TargetArn" => TargetArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_rule_names_by_target(
    TargetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eventbridge(
        "ListRuleNamesByTarget",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TargetArn" => TargetArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_rules()
    list_rules(params::Dict{String,<:Any})

Lists your Amazon EventBridge rules. You can either list all the rules or you can provide a
prefix to match to the rule names. The maximum number of results per page for requests is
100. ListRules does not list the targets of a rule. To see the targets associated with a
rule, use ListTargetsByRule.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EventBusName"`: The name or ARN of the event bus to list the rules for. If you omit
  this, the default event bus is used.
- `"Limit"`: The maximum number of results to return.
- `"NamePrefix"`: The prefix matching the rule name.
- `"NextToken"`: The token returned by a previous call to retrieve the next set of results.
"""
function list_rules(; aws_config::AbstractAWSConfig=current_aws_config())
    return eventbridge("ListRules"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_rules(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eventbridge(
        "ListRules", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Displays the tags associated with an EventBridge resource. In EventBridge, rules and event
buses can be tagged.

# Arguments
- `resource_arn`: The ARN of the EventBridge resource for which you want to view tags.

"""
function list_tags_for_resource(
    ResourceARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eventbridge(
        "ListTagsForResource",
        Dict{String,Any}("ResourceARN" => ResourceARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eventbridge(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceARN" => ResourceARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_targets_by_rule(rule)
    list_targets_by_rule(rule, params::Dict{String,<:Any})

Lists the targets assigned to the specified rule. The maximum number of results per page
for requests is 100.

# Arguments
- `rule`: The name of the rule.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EventBusName"`: The name or ARN of the event bus associated with the rule. If you omit
  this, the default event bus is used.
- `"Limit"`: The maximum number of results to return.
- `"NextToken"`: The token returned by a previous call to retrieve the next set of results.
"""
function list_targets_by_rule(Rule; aws_config::AbstractAWSConfig=current_aws_config())
    return eventbridge(
        "ListTargetsByRule",
        Dict{String,Any}("Rule" => Rule);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_targets_by_rule(
    Rule, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eventbridge(
        "ListTargetsByRule",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Rule" => Rule), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_events(entries)
    put_events(entries, params::Dict{String,<:Any})

Sends custom events to Amazon EventBridge so that they can be matched to rules. The maximum
size for a PutEvents event entry is 256 KB. Entry size is calculated including the event
and any necessary characters and keys of the JSON representation of the event. To learn
more, see Calculating PutEvents event entry size in the  Amazon EventBridge User Guide
PutEvents accepts the data in JSON format. For the JSON number (integer) data type, the
constraints are: a minimum value of -9,223,372,036,854,775,808 and a maximum value of
9,223,372,036,854,775,807.  PutEvents will only process nested JSON up to 1100 levels deep.

# Arguments
- `entries`: The entry that defines an event in your system. You can specify several
  parameters for the entry such as the source and type of the event, resources associated
  with the event, and so on.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EndpointId"`: The URL subdomain of the endpoint. For example, if the URL for Endpoint
  is https://abcde.veo.endpoints.event.amazonaws.com, then the EndpointId is abcde.veo.  When
  using Java, you must include auth-crt on the class path.
"""
function put_events(Entries; aws_config::AbstractAWSConfig=current_aws_config())
    return eventbridge(
        "PutEvents",
        Dict{String,Any}("Entries" => Entries);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_events(
    Entries,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eventbridge(
        "PutEvents",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Entries" => Entries), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_partner_events(entries)
    put_partner_events(entries, params::Dict{String,<:Any})

This is used by SaaS partners to write events to a customer's partner event bus. Amazon Web
Services customers do not use this operation. For information on calculating event batch
size, see Calculating EventBridge PutEvents event entry size in the EventBridge User Guide.

# Arguments
- `entries`: The list of events to write to the event bus.

"""
function put_partner_events(Entries; aws_config::AbstractAWSConfig=current_aws_config())
    return eventbridge(
        "PutPartnerEvents",
        Dict{String,Any}("Entries" => Entries);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_partner_events(
    Entries,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eventbridge(
        "PutPartnerEvents",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Entries" => Entries), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_permission()
    put_permission(params::Dict{String,<:Any})

Running PutPermission permits the specified Amazon Web Services account or Amazon Web
Services organization to put events to the specified event bus. Amazon EventBridge
(CloudWatch Events) rules in your account are triggered by these events arriving to an
event bus in your account.  For another account to send events to your account, that
external account must have an EventBridge rule with your account's event bus as a target.
To enable multiple Amazon Web Services accounts to put events to your event bus, run
PutPermission once for each of these accounts. Or, if all the accounts are members of the
same Amazon Web Services organization, you can run PutPermission once specifying Principal
as \"*\" and specifying the Amazon Web Services organization ID in Condition, to grant
permissions to all accounts in that organization. If you grant permissions using an
organization, then accounts in that organization must specify a RoleArn with proper
permissions when they use PutTarget to add your account's event bus as a target. For more
information, see Sending and Receiving Events Between Amazon Web Services Accounts in the
Amazon EventBridge User Guide. The permission policy on the event bus cannot exceed 10 KB
in size.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Action"`: The action that you are enabling the other account to perform.
- `"Condition"`: This parameter enables you to limit the permission to accounts that
  fulfill a certain condition, such as being a member of a certain Amazon Web Services
  organization. For more information about Amazon Web Services Organizations, see What Is
  Amazon Web Services Organizations in the Amazon Web Services Organizations User Guide. If
  you specify Condition with an Amazon Web Services organization ID, and specify \"*\" as the
  value for Principal, you grant permission to all the accounts in the named organization.
  The Condition is a JSON string which must contain Type, Key, and Value fields.
- `"EventBusName"`: The name of the event bus associated with the rule. If you omit this,
  the default event bus is used.
- `"Policy"`: A JSON string that describes the permission policy statement. You can include
  a Policy parameter in the request instead of using the StatementId, Action, Principal, or
  Condition parameters.
- `"Principal"`: The 12-digit Amazon Web Services account ID that you are permitting to put
  events to your default event bus. Specify \"*\" to permit any account to put events to your
  default event bus. If you specify \"*\" without specifying Condition, avoid creating rules
  that may match undesirable events. To create more secure rules, make sure that the event
  pattern for each rule contains an account field with a specific account ID from which to
  receive events. Rules with an account field do not match any events sent from other
  accounts.
- `"StatementId"`: An identifier string for the external account that you are granting
  permissions to. If you later want to revoke the permission for this external account,
  specify this StatementId when you run RemovePermission.  Each StatementId must be unique.
"""
function put_permission(; aws_config::AbstractAWSConfig=current_aws_config())
    return eventbridge(
        "PutPermission"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function put_permission(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eventbridge(
        "PutPermission", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    put_rule(name)
    put_rule(name, params::Dict{String,<:Any})

Creates or updates the specified rule. Rules are enabled by default, or based on value of
the state. You can disable a rule using DisableRule. A single rule watches for events from
a single event bus. Events generated by Amazon Web Services services go to your account's
default event bus. Events generated by SaaS partner services or applications go to the
matching partner event bus. If you have custom applications or services, you can specify
whether their events go to your default event bus or a custom event bus that you have
created. For more information, see CreateEventBus. If you are updating an existing rule,
the rule is replaced with what you specify in this PutRule command. If you omit arguments
in PutRule, the old values for those arguments are not kept. Instead, they are replaced
with null values. When you create or update a rule, incoming events might not immediately
start matching to new or updated rules. Allow a short period of time for changes to take
effect. A rule must contain at least an EventPattern or ScheduleExpression. Rules with
EventPatterns are triggered when a matching event is observed. Rules with
ScheduleExpressions self-trigger based on the given schedule. A rule can have both an
EventPattern and a ScheduleExpression, in which case the rule triggers on matching events
as well as on a schedule. When you initially create a rule, you can optionally assign one
or more tags to the rule. Tags can help you organize and categorize your resources. You can
also use them to scope user permissions, by granting a user permission to access or change
only rules with certain tag values. To use the PutRule operation and assign tags, you must
have both the events:PutRule and events:TagResource permissions. If you are updating an
existing rule, any tags you specify in the PutRule operation are ignored. To update the
tags of an existing rule, use TagResource and UntagResource. Most services in Amazon Web
Services treat : or / as the same character in Amazon Resource Names (ARNs). However,
EventBridge uses an exact match in event patterns and rules. Be sure to use the correct ARN
characters when creating event patterns so that they match the ARN syntax in the event you
want to match. In EventBridge, it is possible to create rules that lead to infinite loops,
where a rule is fired repeatedly. For example, a rule might detect that ACLs have changed
on an S3 bucket, and trigger software to change them to the desired state. If the rule is
not written carefully, the subsequent change to the ACLs fires the rule again, creating an
infinite loop. To prevent this, write the rules so that the triggered actions do not
re-fire the same rule. For example, your rule could fire only if ACLs are found to be in a
bad state, instead of after any change.  An infinite loop can quickly cause higher than
expected charges. We recommend that you use budgeting, which alerts you when charges exceed
your specified limit. For more information, see Managing Your Costs with Budgets.

# Arguments
- `name`: The name of the rule that you are creating or updating.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description of the rule.
- `"EventBusName"`: The name or ARN of the event bus to associate with this rule. If you
  omit this, the default event bus is used.
- `"EventPattern"`: The event pattern. For more information, see Amazon EventBridge event
  patterns in the  Amazon EventBridge User Guide .
- `"RoleArn"`: The Amazon Resource Name (ARN) of the IAM role associated with the rule. If
  you're setting an event bus in another account as the target and that account granted
  permission to your account through an organization instead of directly by the account ID,
  you must specify a RoleArn with proper permissions in the Target structure, instead of here
  in this parameter.
- `"ScheduleExpression"`: The scheduling expression. For example, \"cron(0 20 * * ? *)\" or
  \"rate(5 minutes)\".
- `"State"`: The state of the rule. Valid values include:    DISABLED: The rule is
  disabled. EventBridge does not match any events against the rule.    ENABLED: The rule is
  enabled. EventBridge matches events against the rule, except for Amazon Web Services
  management events delivered through CloudTrail.
  ENABLED_WITH_ALL_CLOUDTRAIL_MANAGEMENT_EVENTS: The rule is enabled for all events,
  including Amazon Web Services management events delivered through CloudTrail. Management
  events provide visibility into management operations that are performed on resources in
  your Amazon Web Services account. These are also known as control plane operations. For
  more information, see Logging management events in the CloudTrail User Guide, and Filtering
  management events from Amazon Web Services services in the  Amazon EventBridge User Guide .
  This value is only valid for rules on the default event bus or custom event buses. It does
  not apply to partner event buses.
- `"Tags"`: The list of key-value pairs to associate with the rule.
"""
function put_rule(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return eventbridge(
        "PutRule",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_rule(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eventbridge(
        "PutRule",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_targets(rule, targets)
    put_targets(rule, targets, params::Dict{String,<:Any})

Adds the specified targets to the specified rule, or updates the targets if they are
already associated with the rule. Targets are the resources that are invoked when a rule is
triggered. The maximum number of entries per request is 10.  Each rule can have up to five
(5) targets associated with it at one time.  For a list of services you can configure as
targets for events, see EventBridge targets in the  Amazon EventBridge User Guide .
Creating rules with built-in targets is supported only in the Amazon Web Services
Management Console. The built-in targets are:    Amazon EBS CreateSnapshot API call
Amazon EC2 RebootInstances API call     Amazon EC2 StopInstances API call     Amazon EC2
TerminateInstances API call    For some target types, PutTargets provides target-specific
parameters. If the target is a Kinesis data stream, you can optionally specify which shard
the event goes to by using the KinesisParameters argument. To invoke a command on multiple
EC2 instances with one rule, you can use the RunCommandParameters field. To be able to make
API calls against the resources that you own, Amazon EventBridge needs the appropriate
permissions:    For Lambda and Amazon SNS resources, EventBridge relies on resource-based
policies.   For EC2 instances, Kinesis Data Streams, Step Functions state machines and API
Gateway APIs, EventBridge relies on IAM roles that you specify in the RoleARN argument in
PutTargets.   For more information, see Authentication and Access Control in the  Amazon
EventBridge User Guide . If another Amazon Web Services account is in the same region and
has granted you permission (using PutPermission), you can send events to that account. Set
that account's event bus as a target of the rules in your account. To send the matched
events to the other account, specify that account's event bus as the Arn value when you run
PutTargets. If your account sends events to another account, your account is charged for
each sent event. Each event sent to another account is charged as a custom event. The
account receiving the event is not charged. For more information, see Amazon EventBridge
Pricing.   Input, InputPath, and InputTransformer are not available with PutTarget if the
target is an event bus of a different Amazon Web Services account.  If you are setting the
event bus of another account as the target, and that account granted permission to your
account through an organization instead of directly by the account ID, then you must
specify a RoleArn with proper permissions in the Target structure. For more information,
see Sending and Receiving Events Between Amazon Web Services Accounts in the Amazon
EventBridge User Guide.  If you have an IAM role on a cross-account event bus target, a
PutTargets call without a role on the same target (same Id and Arn) will not remove the
role.  For more information about enabling cross-account events, see PutPermission.  Input,
InputPath, and InputTransformer are mutually exclusive and optional parameters of a target.
When a rule is triggered due to a matched event:   If none of the following arguments are
specified for a target, then the entire event is passed to the target in JSON format
(unless the target is Amazon EC2 Run Command or Amazon ECS task, in which case nothing from
the event is passed to the target).   If Input is specified in the form of valid JSON, then
the matched event is overridden with this constant.   If InputPath is specified in the form
of JSONPath (for example, .detail), then only the part of the event specified in the path
is passed to the target (for example, only the detail part of the event is passed).   If
InputTransformer is specified, then one or more specified JSONPaths are extracted from the
event and used as values in a template that you specify as the input to the target.   When
you specify InputPath or InputTransformer, you must use JSON dot notation, not bracket
notation. When you add targets to a rule and the associated rule triggers soon after, new
or updated targets might not be immediately invoked. Allow a short period of time for
changes to take effect. This action can partially fail if too many requests are made at the
same time. If that happens, FailedEntryCount is non-zero in the response and each entry in
FailedEntries provides the ID of the failed target and the error code.

# Arguments
- `rule`: The name of the rule.
- `targets`: The targets to update or add to the rule.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EventBusName"`: The name or ARN of the event bus associated with the rule. If you omit
  this, the default event bus is used.
"""
function put_targets(Rule, Targets; aws_config::AbstractAWSConfig=current_aws_config())
    return eventbridge(
        "PutTargets",
        Dict{String,Any}("Rule" => Rule, "Targets" => Targets);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_targets(
    Rule,
    Targets,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eventbridge(
        "PutTargets",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("Rule" => Rule, "Targets" => Targets), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_permission()
    remove_permission(params::Dict{String,<:Any})

Revokes the permission of another Amazon Web Services account to be able to put events to
the specified event bus. Specify the account to revoke by the StatementId value that you
associated with the account when you granted it permission with PutPermission. You can find
the StatementId by using DescribeEventBus.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EventBusName"`: The name of the event bus to revoke permissions for. If you omit this,
  the default event bus is used.
- `"RemoveAllPermissions"`: Specifies whether to remove all permissions.
- `"StatementId"`: The statement ID corresponding to the account that is no longer allowed
  to put events to the default event bus.
"""
function remove_permission(; aws_config::AbstractAWSConfig=current_aws_config())
    return eventbridge(
        "RemovePermission"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function remove_permission(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eventbridge(
        "RemovePermission", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    remove_targets(ids, rule)
    remove_targets(ids, rule, params::Dict{String,<:Any})

Removes the specified targets from the specified rule. When the rule is triggered, those
targets are no longer be invoked.  A successful execution of RemoveTargets doesn't
guarantee all targets are removed from the rule, it means that the target(s) listed in the
request are removed.  When you remove a target, when the associated rule triggers, removed
targets might continue to be invoked. Allow a short period of time for changes to take
effect. This action can partially fail if too many requests are made at the same time. If
that happens, FailedEntryCount is non-zero in the response and each entry in FailedEntries
provides the ID of the failed target and the error code. The maximum number of entries per
request is 10.

# Arguments
- `ids`: The IDs of the targets to remove from the rule.
- `rule`: The name of the rule.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EventBusName"`: The name or ARN of the event bus associated with the rule. If you omit
  this, the default event bus is used.
- `"Force"`: If this is a managed rule, created by an Amazon Web Services service on your
  behalf, you must specify Force as True to remove targets. This parameter is ignored for
  rules that are not managed rules. You can check whether a rule is a managed rule by using
  DescribeRule or ListRules and checking the ManagedBy field of the response.
"""
function remove_targets(Ids, Rule; aws_config::AbstractAWSConfig=current_aws_config())
    return eventbridge(
        "RemoveTargets",
        Dict{String,Any}("Ids" => Ids, "Rule" => Rule);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_targets(
    Ids,
    Rule,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eventbridge(
        "RemoveTargets",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Ids" => Ids, "Rule" => Rule), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_replay(destination, event_end_time, event_source_arn, event_start_time, replay_name)
    start_replay(destination, event_end_time, event_source_arn, event_start_time, replay_name, params::Dict{String,<:Any})

Starts the specified replay. Events are not necessarily replayed in the exact same order
that they were added to the archive. A replay processes events to replay based on the time
in the event, and replays them using 1 minute intervals. If you specify an EventStartTime
and an EventEndTime that covers a 20 minute time range, the events are replayed from the
first minute of that 20 minute range first. Then the events from the second minute are
replayed. You can use DescribeReplay to determine the progress of a replay. The value
returned for EventLastReplayedTime indicates the time within the specified time range
associated with the last event replayed.

# Arguments
- `destination`: A ReplayDestination object that includes details about the destination for
  the replay.
- `event_end_time`: A time stamp for the time to stop replaying events. Only events that
  occurred between the EventStartTime and EventEndTime are replayed.
- `event_source_arn`: The ARN of the archive to replay events from.
- `event_start_time`: A time stamp for the time to start replaying events. Only events that
  occurred between the EventStartTime and EventEndTime are replayed.
- `replay_name`: The name of the replay to start.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description for the replay to start.
"""
function start_replay(
    Destination,
    EventEndTime,
    EventSourceArn,
    EventStartTime,
    ReplayName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eventbridge(
        "StartReplay",
        Dict{String,Any}(
            "Destination" => Destination,
            "EventEndTime" => EventEndTime,
            "EventSourceArn" => EventSourceArn,
            "EventStartTime" => EventStartTime,
            "ReplayName" => ReplayName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_replay(
    Destination,
    EventEndTime,
    EventSourceArn,
    EventStartTime,
    ReplayName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eventbridge(
        "StartReplay",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Destination" => Destination,
                    "EventEndTime" => EventEndTime,
                    "EventSourceArn" => EventSourceArn,
                    "EventStartTime" => EventStartTime,
                    "ReplayName" => ReplayName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Assigns one or more tags (key-value pairs) to the specified EventBridge resource. Tags can
help you organize and categorize your resources. You can also use them to scope user
permissions by granting a user permission to access or change only resources with certain
tag values. In EventBridge, rules and event buses can be tagged. Tags don't have any
semantic meaning to Amazon Web Services and are interpreted strictly as strings of
characters. You can use the TagResource action with a resource that already has tags. If
you specify a new tag key, this tag is appended to the list of tags associated with the
resource. If you specify a tag key that is already associated with the resource, the new
tag value that you specify replaces the previous value for that tag. You can associate as
many as 50 tags with a resource.

# Arguments
- `resource_arn`: The ARN of the EventBridge resource that you're adding tags to.
- `tags`: The list of key-value pairs to associate with the resource.

"""
function tag_resource(ResourceARN, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return eventbridge(
        "TagResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceARN,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eventbridge(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    test_event_pattern(event, event_pattern)
    test_event_pattern(event, event_pattern, params::Dict{String,<:Any})

Tests whether the specified event pattern matches the provided event. Most services in
Amazon Web Services treat : or / as the same character in Amazon Resource Names (ARNs).
However, EventBridge uses an exact match in event patterns and rules. Be sure to use the
correct ARN characters when creating event patterns so that they match the ARN syntax in
the event you want to match.

# Arguments
- `event`: The event, in JSON format, to test against the event pattern. The JSON must
  follow the format specified in Amazon Web Services Events, and the following fields are
  mandatory:    id     account     source     time     region     resources     detail-type
- `event_pattern`: The event pattern. For more information, see Events and Event Patterns
  in the  Amazon EventBridge User Guide .

"""
function test_event_pattern(
    Event, EventPattern; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eventbridge(
        "TestEventPattern",
        Dict{String,Any}("Event" => Event, "EventPattern" => EventPattern);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function test_event_pattern(
    Event,
    EventPattern,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eventbridge(
        "TestEventPattern",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Event" => Event, "EventPattern" => EventPattern),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes one or more tags from the specified EventBridge resource. In Amazon EventBridge
(CloudWatch Events), rules and event buses can be tagged.

# Arguments
- `resource_arn`: The ARN of the EventBridge resource from which you are removing tags.
- `tag_keys`: The list of tag keys to remove from the resource.

"""
function untag_resource(
    ResourceARN, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eventbridge(
        "UntagResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceARN,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eventbridge(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_api_destination(name)
    update_api_destination(name, params::Dict{String,<:Any})

Updates an API destination.

# Arguments
- `name`: The name of the API destination to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConnectionArn"`: The ARN of the connection to use for the API destination.
- `"Description"`: The name of the API destination to update.
- `"HttpMethod"`: The method to use for the API destination.
- `"InvocationEndpoint"`: The URL to the endpoint to use for the API destination.
- `"InvocationRateLimitPerSecond"`: The maximum number of invocations per second to send to
  the API destination.
"""
function update_api_destination(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return eventbridge(
        "UpdateApiDestination",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_api_destination(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eventbridge(
        "UpdateApiDestination",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_archive(archive_name)
    update_archive(archive_name, params::Dict{String,<:Any})

Updates the specified archive.

# Arguments
- `archive_name`: The name of the archive to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: The description for the archive.
- `"EventPattern"`: The event pattern to use to filter events sent to the archive.
- `"RetentionDays"`: The number of days to retain events in the archive.
"""
function update_archive(ArchiveName; aws_config::AbstractAWSConfig=current_aws_config())
    return eventbridge(
        "UpdateArchive",
        Dict{String,Any}("ArchiveName" => ArchiveName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_archive(
    ArchiveName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return eventbridge(
        "UpdateArchive",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ArchiveName" => ArchiveName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_connection(name)
    update_connection(name, params::Dict{String,<:Any})

Updates settings for a connection.

# Arguments
- `name`: The name of the connection to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AuthParameters"`: The authorization parameters to use for the connection.
- `"AuthorizationType"`: The type of authorization to use for the connection.
- `"Description"`: A description for the connection.
"""
function update_connection(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return eventbridge(
        "UpdateConnection",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_connection(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eventbridge(
        "UpdateConnection",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_endpoint(name)
    update_endpoint(name, params::Dict{String,<:Any})

Update an existing endpoint. For more information about global endpoints, see Making
applications Regional-fault tolerant with global endpoints and event replication in the
Amazon EventBridge User Guide .

# Arguments
- `name`: The name of the endpoint you want to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description for the endpoint.
- `"EventBuses"`: Define event buses used for replication.
- `"ReplicationConfig"`: Whether event replication was enabled or disabled by this request.
- `"RoleArn"`: The ARN of the role used by event replication for this request.
- `"RoutingConfig"`: Configure the routing policy, including the health check and secondary
  Region.
"""
function update_endpoint(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return eventbridge(
        "UpdateEndpoint",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_endpoint(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eventbridge(
        "UpdateEndpoint",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_event_bus()
    update_event_bus(params::Dict{String,<:Any})

Updates the specified event bus.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DeadLetterConfig"`:
- `"Description"`: The event bus description.
- `"KmsKeyIdentifier"`: The identifier of the KMS customer managed key for EventBridge to
  use, if you choose to use a customer managed key to encrypt events on this event bus. The
  identifier can be the key Amazon Resource Name (ARN), KeyId, key alias, or key alias ARN.
  If you do not specify a customer managed key identifier, EventBridge uses an Amazon Web
  Services owned key to encrypt events on the event bus. For more information, see Managing
  keys in the Key Management Service Developer Guide.   Archives and schema discovery are not
  supported for event buses encrypted using a customer managed key. EventBridge returns an
  error if:   You call  CreateArchive  on an event bus set to use a customer managed key for
  encryption.   You call  CreateDiscoverer  on an event bus set to use a customer managed key
  for encryption.   You call  UpdatedEventBus  to set a customer managed key on an event bus
  with an archives or schema discovery enabled.   To enable archives or schema discovery on
  an event bus, choose to use an Amazon Web Services owned key. For more information, see
  Data encryption in EventBridge in the Amazon EventBridge User Guide.
- `"Name"`: The name of the event bus.
"""
function update_event_bus(; aws_config::AbstractAWSConfig=current_aws_config())
    return eventbridge(
        "UpdateEventBus"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function update_event_bus(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return eventbridge(
        "UpdateEventBus", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: timestream_write
using AWS.Compat
using AWS.UUIDs

"""
    create_batch_load_task(data_source_configuration, report_configuration, target_database_name, target_table_name)
    create_batch_load_task(data_source_configuration, report_configuration, target_database_name, target_table_name, params::Dict{String,<:Any})

Creates a new Timestream batch load task. A batch load task processes data from a CSV
source in an S3 location and writes to a Timestream table. A mapping from source to target
is defined in a batch load task. Errors and events are written to a report at an S3
location. For the report, if the KMS key is not specified, the report will be encrypted
with an S3 managed key when SSE_S3 is the option. Otherwise an error is thrown. For more
information, see Amazon Web Services managed keys. Service quotas apply. For details, see
code sample.

# Arguments
- `data_source_configuration`: Defines configuration details about the data source for a
  batch load task.
- `report_configuration`:
- `target_database_name`: Target Timestream database for a batch load task.
- `target_table_name`: Target Timestream table for a batch load task.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`:
- `"DataModelConfiguration"`:
- `"RecordVersion"`:
"""
function create_batch_load_task(
    DataSourceConfiguration,
    ReportConfiguration,
    TargetDatabaseName,
    TargetTableName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return timestream_write(
        "CreateBatchLoadTask",
        Dict{String,Any}(
            "DataSourceConfiguration" => DataSourceConfiguration,
            "ReportConfiguration" => ReportConfiguration,
            "TargetDatabaseName" => TargetDatabaseName,
            "TargetTableName" => TargetTableName,
            "ClientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_batch_load_task(
    DataSourceConfiguration,
    ReportConfiguration,
    TargetDatabaseName,
    TargetTableName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return timestream_write(
        "CreateBatchLoadTask",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DataSourceConfiguration" => DataSourceConfiguration,
                    "ReportConfiguration" => ReportConfiguration,
                    "TargetDatabaseName" => TargetDatabaseName,
                    "TargetTableName" => TargetTableName,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_database(database_name)
    create_database(database_name, params::Dict{String,<:Any})

Creates a new Timestream database. If the KMS key is not specified, the database will be
encrypted with a Timestream managed KMS key located in your account. For more information,
see Amazon Web Services managed keys. Service quotas apply. For details, see code sample.

# Arguments
- `database_name`: The name of the Timestream database.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"KmsKeyId"`: The KMS key for the database. If the KMS key is not specified, the database
  will be encrypted with a Timestream managed KMS key located in your account. For more
  information, see Amazon Web Services managed keys.
- `"Tags"`:  A list of key-value pairs to label the table.
"""
function create_database(DatabaseName; aws_config::AbstractAWSConfig=current_aws_config())
    return timestream_write(
        "CreateDatabase",
        Dict{String,Any}("DatabaseName" => DatabaseName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_database(
    DatabaseName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return timestream_write(
        "CreateDatabase",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DatabaseName" => DatabaseName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_table(database_name, table_name)
    create_table(database_name, table_name, params::Dict{String,<:Any})

Adds a new table to an existing database in your account. In an Amazon Web Services
account, table names must be at least unique within each Region if they are in the same
database. You might have identical table names in the same Region if the tables are in
separate databases. While creating the table, you must specify the table name, database
name, and the retention properties. Service quotas apply. See code sample for details.

# Arguments
- `database_name`: The name of the Timestream database.
- `table_name`: The name of the Timestream table.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MagneticStoreWriteProperties"`: Contains properties to set on the table when enabling
  magnetic store writes.
- `"RetentionProperties"`: The duration for which your time-series data must be stored in
  the memory store and the magnetic store.
- `"Schema"`:  The schema of the table.
- `"Tags"`:  A list of key-value pairs to label the table.
"""
function create_table(
    DatabaseName, TableName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return timestream_write(
        "CreateTable",
        Dict{String,Any}("DatabaseName" => DatabaseName, "TableName" => TableName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_table(
    DatabaseName,
    TableName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return timestream_write(
        "CreateTable",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DatabaseName" => DatabaseName, "TableName" => TableName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_database(database_name)
    delete_database(database_name, params::Dict{String,<:Any})

Deletes a given Timestream database. This is an irreversible operation. After a database is
deleted, the time-series data from its tables cannot be recovered.   All tables in the
database must be deleted first, or a ValidationException error will be thrown.  Due to the
nature of distributed retries, the operation can return either success or a
ResourceNotFoundException. Clients should consider them equivalent.  See code sample for
details.

# Arguments
- `database_name`: The name of the Timestream database to be deleted.

"""
function delete_database(DatabaseName; aws_config::AbstractAWSConfig=current_aws_config())
    return timestream_write(
        "DeleteDatabase",
        Dict{String,Any}("DatabaseName" => DatabaseName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_database(
    DatabaseName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return timestream_write(
        "DeleteDatabase",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DatabaseName" => DatabaseName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_table(database_name, table_name)
    delete_table(database_name, table_name, params::Dict{String,<:Any})

Deletes a given Timestream table. This is an irreversible operation. After a Timestream
database table is deleted, the time-series data stored in the table cannot be recovered.
Due to the nature of distributed retries, the operation can return either success or a
ResourceNotFoundException. Clients should consider them equivalent.  See code sample for
details.

# Arguments
- `database_name`: The name of the database where the Timestream database is to be deleted.
- `table_name`: The name of the Timestream table to be deleted.

"""
function delete_table(
    DatabaseName, TableName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return timestream_write(
        "DeleteTable",
        Dict{String,Any}("DatabaseName" => DatabaseName, "TableName" => TableName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_table(
    DatabaseName,
    TableName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return timestream_write(
        "DeleteTable",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DatabaseName" => DatabaseName, "TableName" => TableName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_batch_load_task(task_id)
    describe_batch_load_task(task_id, params::Dict{String,<:Any})

Returns information about the batch load task, including configurations, mappings,
progress, and other details. Service quotas apply. See code sample for details.

# Arguments
- `task_id`: The ID of the batch load task.

"""
function describe_batch_load_task(
    TaskId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return timestream_write(
        "DescribeBatchLoadTask",
        Dict{String,Any}("TaskId" => TaskId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_batch_load_task(
    TaskId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return timestream_write(
        "DescribeBatchLoadTask",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("TaskId" => TaskId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_database(database_name)
    describe_database(database_name, params::Dict{String,<:Any})

Returns information about the database, including the database name, time that the database
was created, and the total number of tables found within the database. Service quotas
apply. See code sample for details.

# Arguments
- `database_name`: The name of the Timestream database.

"""
function describe_database(DatabaseName; aws_config::AbstractAWSConfig=current_aws_config())
    return timestream_write(
        "DescribeDatabase",
        Dict{String,Any}("DatabaseName" => DatabaseName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_database(
    DatabaseName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return timestream_write(
        "DescribeDatabase",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DatabaseName" => DatabaseName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_endpoints()
    describe_endpoints(params::Dict{String,<:Any})

Returns a list of available endpoints to make Timestream API calls against. This API
operation is available through both the Write and Query APIs. Because the Timestream SDKs
are designed to transparently work with the service’s architecture, including the
management and mapping of the service endpoints, we don't recommend that you use this API
operation unless:   You are using VPC endpoints (Amazon Web Services PrivateLink) with
Timestream    Your application uses a programming language that does not yet have SDK
support   You require better control over the client-side implementation   For detailed
information on how and when to use and implement DescribeEndpoints, see The Endpoint
Discovery Pattern.

"""
function describe_endpoints(; aws_config::AbstractAWSConfig=current_aws_config())
    return timestream_write(
        "DescribeEndpoints"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_endpoints(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return timestream_write(
        "DescribeEndpoints", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_table(database_name, table_name)
    describe_table(database_name, table_name, params::Dict{String,<:Any})

Returns information about the table, including the table name, database name, retention
duration of the memory store and the magnetic store. Service quotas apply. See code sample
for details.

# Arguments
- `database_name`: The name of the Timestream database.
- `table_name`: The name of the Timestream table.

"""
function describe_table(
    DatabaseName, TableName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return timestream_write(
        "DescribeTable",
        Dict{String,Any}("DatabaseName" => DatabaseName, "TableName" => TableName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_table(
    DatabaseName,
    TableName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return timestream_write(
        "DescribeTable",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DatabaseName" => DatabaseName, "TableName" => TableName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_batch_load_tasks()
    list_batch_load_tasks(params::Dict{String,<:Any})

Provides a list of batch load tasks, along with the name, status, when the task is
resumable until, and other details. See code sample for details.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The total number of items to return in the output. If the total number of
  items available is more than the value specified, a NextToken is provided in the output. To
  resume pagination, provide the NextToken value as argument of a subsequent API invocation.
- `"NextToken"`: A token to specify where to start paginating. This is the NextToken from a
  previously truncated response.
- `"TaskStatus"`: Status of the batch load task.
"""
function list_batch_load_tasks(; aws_config::AbstractAWSConfig=current_aws_config())
    return timestream_write(
        "ListBatchLoadTasks"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_batch_load_tasks(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return timestream_write(
        "ListBatchLoadTasks", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_databases()
    list_databases(params::Dict{String,<:Any})

Returns a list of your Timestream databases. Service quotas apply. See code sample for
details.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The total number of items to return in the output. If the total number of
  items available is more than the value specified, a NextToken is provided in the output. To
  resume pagination, provide the NextToken value as argument of a subsequent API invocation.
- `"NextToken"`: The pagination token. To resume pagination, provide the NextToken value as
  argument of a subsequent API invocation.
"""
function list_databases(; aws_config::AbstractAWSConfig=current_aws_config())
    return timestream_write(
        "ListDatabases"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_databases(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return timestream_write(
        "ListDatabases", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tables()
    list_tables(params::Dict{String,<:Any})

Provides a list of tables, along with the name, status, and retention properties of each
table. See code sample for details.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DatabaseName"`: The name of the Timestream database.
- `"MaxResults"`: The total number of items to return in the output. If the total number of
  items available is more than the value specified, a NextToken is provided in the output. To
  resume pagination, provide the NextToken value as argument of a subsequent API invocation.
- `"NextToken"`: The pagination token. To resume pagination, provide the NextToken value as
  argument of a subsequent API invocation.
"""
function list_tables(; aws_config::AbstractAWSConfig=current_aws_config())
    return timestream_write(
        "ListTables"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_tables(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return timestream_write(
        "ListTables", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

 Lists all tags on a Timestream resource.

# Arguments
- `resource_arn`:  The Timestream resource with tags to be listed. This value is an Amazon
  Resource Name (ARN).

"""
function list_tags_for_resource(
    ResourceARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return timestream_write(
        "ListTagsForResource",
        Dict{String,Any}("ResourceARN" => ResourceARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return timestream_write(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceARN" => ResourceARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    resume_batch_load_task(task_id)
    resume_batch_load_task(task_id, params::Dict{String,<:Any})



# Arguments
- `task_id`: The ID of the batch load task to resume.

"""
function resume_batch_load_task(TaskId; aws_config::AbstractAWSConfig=current_aws_config())
    return timestream_write(
        "ResumeBatchLoadTask",
        Dict{String,Any}("TaskId" => TaskId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function resume_batch_load_task(
    TaskId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return timestream_write(
        "ResumeBatchLoadTask",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("TaskId" => TaskId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

 Associates a set of tags with a Timestream resource. You can then activate these
user-defined tags so that they appear on the Billing and Cost Management console for cost
allocation tracking.

# Arguments
- `resource_arn`:  Identifies the Timestream resource to which tags should be added. This
  value is an Amazon Resource Name (ARN).
- `tags`:  The tags to be assigned to the Timestream resource.

"""
function tag_resource(ResourceARN, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return timestream_write(
        "TagResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceARN,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return timestream_write(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

 Removes the association of tags from a Timestream resource.

# Arguments
- `resource_arn`:  The Timestream resource that the tags will be removed from. This value
  is an Amazon Resource Name (ARN).
- `tag_keys`:  A list of tags keys. Existing tags of the resource whose keys are members of
  this list will be removed from the Timestream resource.

"""
function untag_resource(
    ResourceARN, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return timestream_write(
        "UntagResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceARN,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return timestream_write(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_database(database_name, kms_key_id)
    update_database(database_name, kms_key_id, params::Dict{String,<:Any})

 Modifies the KMS key for an existing database. While updating the database, you must
specify the database name and the identifier of the new KMS key to be used (KmsKeyId). If
there are any concurrent UpdateDatabase requests, first writer wins.  See code sample for
details.

# Arguments
- `database_name`:  The name of the database.
- `kms_key_id`:  The identifier of the new KMS key (KmsKeyId) to be used to encrypt the
  data stored in the database. If the KmsKeyId currently registered with the database is the
  same as the KmsKeyId in the request, there will not be any update.  You can specify the
  KmsKeyId using any of the following:   Key ID: 1234abcd-12ab-34cd-56ef-1234567890ab    Key
  ARN: arn:aws:kms:us-east-1:111122223333:key/1234abcd-12ab-34cd-56ef-1234567890ab    Alias
  name: alias/ExampleAlias    Alias ARN:
  arn:aws:kms:us-east-1:111122223333:alias/ExampleAlias

"""
function update_database(
    DatabaseName, KmsKeyId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return timestream_write(
        "UpdateDatabase",
        Dict{String,Any}("DatabaseName" => DatabaseName, "KmsKeyId" => KmsKeyId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_database(
    DatabaseName,
    KmsKeyId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return timestream_write(
        "UpdateDatabase",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DatabaseName" => DatabaseName, "KmsKeyId" => KmsKeyId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_table(database_name, table_name)
    update_table(database_name, table_name, params::Dict{String,<:Any})

Modifies the retention duration of the memory store and magnetic store for your Timestream
table. Note that the change in retention duration takes effect immediately. For example, if
the retention period of the memory store was initially set to 2 hours and then changed to
24 hours, the memory store will be capable of holding 24 hours of data, but will be
populated with 24 hours of data 22 hours after this change was made. Timestream does not
retrieve data from the magnetic store to populate the memory store.  See code sample for
details.

# Arguments
- `database_name`: The name of the Timestream database.
- `table_name`: The name of the Timestream table.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MagneticStoreWriteProperties"`: Contains properties to set on the table when enabling
  magnetic store writes.
- `"RetentionProperties"`: The retention duration of the memory store and the magnetic
  store.
- `"Schema"`:  The schema of the table.
"""
function update_table(
    DatabaseName, TableName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return timestream_write(
        "UpdateTable",
        Dict{String,Any}("DatabaseName" => DatabaseName, "TableName" => TableName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_table(
    DatabaseName,
    TableName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return timestream_write(
        "UpdateTable",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DatabaseName" => DatabaseName, "TableName" => TableName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    write_records(database_name, records, table_name)
    write_records(database_name, records, table_name, params::Dict{String,<:Any})

Enables you to write your time-series data into Timestream. You can specify a single data
point or a batch of data points to be inserted into the system. Timestream offers you a
flexible schema that auto detects the column names and data types for your Timestream
tables based on the dimension names and data types of the data points you specify when
invoking writes into the database.  Timestream supports eventual consistency read
semantics. This means that when you query data immediately after writing a batch of data
into Timestream, the query results might not reflect the results of a recently completed
write operation. The results may also include some stale data. If you repeat the query
request after a short time, the results should return the latest data. Service quotas
apply.  See code sample for details.  Upserts  You can use the Version parameter in a
WriteRecords request to update data points. Timestream tracks a version number with each
record. Version defaults to 1 when it's not specified for the record in the request.
Timestream updates an existing record’s measure value along with its Version when it
receives a write request with a higher Version number for that record. When it receives an
update request where the measure value is the same as that of the existing record,
Timestream still updates Version, if it is greater than the existing value of Version. You
can update a data point as many times as desired, as long as the value of Version
continuously increases.   For example, suppose you write a new record without indicating
Version in the request. Timestream stores this record, and set Version to 1. Now, suppose
you try to update this record with a WriteRecords request of the same record with a
different measure value but, like before, do not provide Version. In this case, Timestream
will reject this update with a RejectedRecordsException since the updated record’s
version is not greater than the existing value of Version.  However, if you were to resend
the update request with Version set to 2, Timestream would then succeed in updating the
record’s value, and the Version would be set to 2. Next, suppose you sent a WriteRecords
request with this same record and an identical measure value, but with Version set to 3. In
this case, Timestream would only update Version to 3. Any further updates would need to
send a version number greater than 3, or the update requests would receive a
RejectedRecordsException.

# Arguments
- `database_name`: The name of the Timestream database.
- `records`: An array of records that contain the unique measure, dimension, time, and
  version attributes for each time-series data point.
- `table_name`: The name of the Timestream table.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CommonAttributes"`: A record that contains the common measure, dimension, time, and
  version attributes shared across all the records in the request. The measure and dimension
  attributes specified will be merged with the measure and dimension attributes in the
  records object when the data is written into Timestream. Dimensions may not overlap, or a
  ValidationException will be thrown. In other words, a record must contain dimensions with
  unique names.
"""
function write_records(
    DatabaseName, Records, TableName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return timestream_write(
        "WriteRecords",
        Dict{String,Any}(
            "DatabaseName" => DatabaseName, "Records" => Records, "TableName" => TableName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function write_records(
    DatabaseName,
    Records,
    TableName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return timestream_write(
        "WriteRecords",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DatabaseName" => DatabaseName,
                    "Records" => Records,
                    "TableName" => TableName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: ssm_incidents
using AWS.Compat
using AWS.UUIDs

"""
    batch_get_incident_findings(finding_ids, incident_record_arn)
    batch_get_incident_findings(finding_ids, incident_record_arn, params::Dict{String,<:Any})

Retrieves details about all specified findings for an incident, including descriptive
details about each finding. A finding represents a recent application environment change
made by an CodeDeploy deployment or an CloudFormation stack creation or update that can be
investigated as a potential cause of the incident.

# Arguments
- `finding_ids`: A list of IDs of findings for which you want to view details.
- `incident_record_arn`: The Amazon Resource Name (ARN) of the incident for which you want
  to view finding details.

"""
function batch_get_incident_findings(
    findingIds, incidentRecordArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_incidents(
        "POST",
        "/batchGetIncidentFindings",
        Dict{String,Any}(
            "findingIds" => findingIds, "incidentRecordArn" => incidentRecordArn
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_incident_findings(
    findingIds,
    incidentRecordArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_incidents(
        "POST",
        "/batchGetIncidentFindings",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "findingIds" => findingIds, "incidentRecordArn" => incidentRecordArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_replication_set(regions)
    create_replication_set(regions, params::Dict{String,<:Any})

A replication set replicates and encrypts your data to the provided Regions with the
provided KMS key.

# Arguments
- `regions`: The Regions that Incident Manager replicates your data to. You can have up to
  three Regions in your replication set.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A token that ensures that the operation is called only once with the
  specified details.
- `"tags"`: A list of tags to add to the replication set.
"""
function create_replication_set(regions; aws_config::AbstractAWSConfig=current_aws_config())
    return ssm_incidents(
        "POST",
        "/createReplicationSet",
        Dict{String,Any}("regions" => regions, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_replication_set(
    regions,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_incidents(
        "POST",
        "/createReplicationSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("regions" => regions, "clientToken" => string(uuid4())),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_response_plan(incident_template, name)
    create_response_plan(incident_template, name, params::Dict{String,<:Any})

Creates a response plan that automates the initial response to incidents. A response plan
engages contacts, starts chat channel collaboration, and initiates runbooks at the
beginning of an incident.

# Arguments
- `incident_template`: Details used to create an incident when using this response plan.
- `name`: The short format name of the response plan. Can't include spaces.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"actions"`: The actions that the response plan starts at the beginning of an incident.
- `"chatChannel"`: The Chatbot chat channel used for collaboration during an incident.
- `"clientToken"`: A token ensuring that the operation is called only once with the
  specified details.
- `"displayName"`: The long format of the response plan name. This field can contain spaces.
- `"engagements"`: The Amazon Resource Name (ARN) for the contacts and escalation plans
  that the response plan engages during an incident.
- `"integrations"`: Information about third-party services integrated into the response
  plan.
- `"tags"`: A list of tags that you are adding to the response plan.
"""
function create_response_plan(
    incidentTemplate, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_incidents(
        "POST",
        "/createResponsePlan",
        Dict{String,Any}(
            "incidentTemplate" => incidentTemplate,
            "name" => name,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_response_plan(
    incidentTemplate,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_incidents(
        "POST",
        "/createResponsePlan",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "incidentTemplate" => incidentTemplate,
                    "name" => name,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_timeline_event(event_data, event_time, event_type, incident_record_arn)
    create_timeline_event(event_data, event_time, event_type, incident_record_arn, params::Dict{String,<:Any})

Creates a custom timeline event on the incident details page of an incident record.
Incident Manager automatically creates timeline events that mark key moments during an
incident. You can create custom timeline events to mark important events that Incident
Manager can detect automatically.

# Arguments
- `event_data`: A short description of the event.
- `event_time`: The timestamp for when the event occurred.
- `event_type`: The type of event. You can create timeline events of type Custom Event and
  Note. To make a Note-type event appear on the Incident notes panel in the console, specify
  eventType as Noteand enter the Amazon Resource Name (ARN) of the incident as the value for
  eventReference.
- `incident_record_arn`: The Amazon Resource Name (ARN) of the incident record that the
  action adds the incident to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A token that ensures that a client calls the action only once with the
  specified details.
- `"eventReferences"`: Adds one or more references to the TimelineEvent. A reference is an
  Amazon Web Services resource involved or associated with the incident. To specify a
  reference, enter its Amazon Resource Name (ARN). You can also specify a related item
  associated with a resource. For example, to specify an Amazon DynamoDB (DynamoDB) table as
  a resource, use the table's ARN. You can also specify an Amazon CloudWatch metric
  associated with the DynamoDB table as a related item.
"""
function create_timeline_event(
    eventData,
    eventTime,
    eventType,
    incidentRecordArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_incidents(
        "POST",
        "/createTimelineEvent",
        Dict{String,Any}(
            "eventData" => eventData,
            "eventTime" => eventTime,
            "eventType" => eventType,
            "incidentRecordArn" => incidentRecordArn,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_timeline_event(
    eventData,
    eventTime,
    eventType,
    incidentRecordArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_incidents(
        "POST",
        "/createTimelineEvent",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "eventData" => eventData,
                    "eventTime" => eventTime,
                    "eventType" => eventType,
                    "incidentRecordArn" => incidentRecordArn,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_incident_record(arn)
    delete_incident_record(arn, params::Dict{String,<:Any})

Delete an incident record from Incident Manager.

# Arguments
- `arn`: The Amazon Resource Name (ARN) of the incident record you are deleting.

"""
function delete_incident_record(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return ssm_incidents(
        "POST",
        "/deleteIncidentRecord",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_incident_record(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_incidents(
        "POST",
        "/deleteIncidentRecord",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_replication_set(arn)
    delete_replication_set(arn, params::Dict{String,<:Any})

Deletes all Regions in your replication set. Deleting the replication set deletes all
Incident Manager data.

# Arguments
- `arn`: The Amazon Resource Name (ARN) of the replication set you're deleting.

"""
function delete_replication_set(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return ssm_incidents(
        "POST",
        "/deleteReplicationSet",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_replication_set(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_incidents(
        "POST",
        "/deleteReplicationSet",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_resource_policy(policy_id, resource_arn)
    delete_resource_policy(policy_id, resource_arn, params::Dict{String,<:Any})

Deletes the resource policy that Resource Access Manager uses to share your Incident
Manager resource.

# Arguments
- `policy_id`: The ID of the resource policy you're deleting.
- `resource_arn`: The Amazon Resource Name (ARN) of the resource you're deleting the policy
  from.

"""
function delete_resource_policy(
    policyId, resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_incidents(
        "POST",
        "/deleteResourcePolicy",
        Dict{String,Any}("policyId" => policyId, "resourceArn" => resourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_resource_policy(
    policyId,
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_incidents(
        "POST",
        "/deleteResourcePolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("policyId" => policyId, "resourceArn" => resourceArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_response_plan(arn)
    delete_response_plan(arn, params::Dict{String,<:Any})

Deletes the specified response plan. Deleting a response plan stops all linked CloudWatch
alarms and EventBridge events from creating an incident with this response plan.

# Arguments
- `arn`: The Amazon Resource Name (ARN) of the response plan.

"""
function delete_response_plan(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return ssm_incidents(
        "POST",
        "/deleteResponsePlan",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_response_plan(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_incidents(
        "POST",
        "/deleteResponsePlan",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_timeline_event(event_id, incident_record_arn)
    delete_timeline_event(event_id, incident_record_arn, params::Dict{String,<:Any})

Deletes a timeline event from an incident.

# Arguments
- `event_id`: The ID of the event to update. You can use ListTimelineEvents to find an
  event's ID.
- `incident_record_arn`: The Amazon Resource Name (ARN) of the incident that includes the
  timeline event.

"""
function delete_timeline_event(
    eventId, incidentRecordArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_incidents(
        "POST",
        "/deleteTimelineEvent",
        Dict{String,Any}("eventId" => eventId, "incidentRecordArn" => incidentRecordArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_timeline_event(
    eventId,
    incidentRecordArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_incidents(
        "POST",
        "/deleteTimelineEvent",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "eventId" => eventId, "incidentRecordArn" => incidentRecordArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_incident_record(arn)
    get_incident_record(arn, params::Dict{String,<:Any})

Returns the details for the specified incident record.

# Arguments
- `arn`: The Amazon Resource Name (ARN) of the incident record.

"""
function get_incident_record(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return ssm_incidents(
        "GET",
        "/getIncidentRecord",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_incident_record(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_incidents(
        "GET",
        "/getIncidentRecord",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_replication_set(arn)
    get_replication_set(arn, params::Dict{String,<:Any})

Retrieve your Incident Manager replication set.

# Arguments
- `arn`: The Amazon Resource Name (ARN) of the replication set you want to retrieve.

"""
function get_replication_set(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return ssm_incidents(
        "GET",
        "/getReplicationSet",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_replication_set(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_incidents(
        "GET",
        "/getReplicationSet",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_resource_policies(resource_arn)
    get_resource_policies(resource_arn, params::Dict{String,<:Any})

Retrieves the resource policies attached to the specified response plan.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the response plan with the attached
  resource policy.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of resource policies to display for each page of
  results.
- `"nextToken"`: The pagination token for the next set of items to return. (You received
  this token from a previous call.)
"""
function get_resource_policies(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_incidents(
        "POST",
        "/getResourcePolicies",
        Dict{String,Any}("resourceArn" => resourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_resource_policies(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_incidents(
        "POST",
        "/getResourcePolicies",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceArn" => resourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_response_plan(arn)
    get_response_plan(arn, params::Dict{String,<:Any})

Retrieves the details of the specified response plan.

# Arguments
- `arn`: The Amazon Resource Name (ARN) of the response plan.

"""
function get_response_plan(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return ssm_incidents(
        "GET",
        "/getResponsePlan",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_response_plan(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_incidents(
        "GET",
        "/getResponsePlan",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_timeline_event(event_id, incident_record_arn)
    get_timeline_event(event_id, incident_record_arn, params::Dict{String,<:Any})

Retrieves a timeline event based on its ID and incident record.

# Arguments
- `event_id`: The ID of the event. You can get an event's ID when you create it, or by
  using ListTimelineEvents.
- `incident_record_arn`: The Amazon Resource Name (ARN) of the incident that includes the
  timeline event.

"""
function get_timeline_event(
    eventId, incidentRecordArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_incidents(
        "GET",
        "/getTimelineEvent",
        Dict{String,Any}("eventId" => eventId, "incidentRecordArn" => incidentRecordArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_timeline_event(
    eventId,
    incidentRecordArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_incidents(
        "GET",
        "/getTimelineEvent",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "eventId" => eventId, "incidentRecordArn" => incidentRecordArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_incident_findings(incident_record_arn)
    list_incident_findings(incident_record_arn, params::Dict{String,<:Any})

Retrieves a list of the IDs of findings, plus their last modified times, that have been
identified for a specified incident. A finding represents a recent application environment
change made by an CloudFormation stack creation or update or an CodeDeploy deployment that
can be investigated as a potential cause of the incident.

# Arguments
- `incident_record_arn`: The Amazon Resource Name (ARN) of the incident for which you want
  to view associated findings.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of findings to retrieve per call.
- `"nextToken"`: The pagination token for the next set of items to return. (You received
  this token from a previous call.)
"""
function list_incident_findings(
    incidentRecordArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_incidents(
        "POST",
        "/listIncidentFindings",
        Dict{String,Any}("incidentRecordArn" => incidentRecordArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_incident_findings(
    incidentRecordArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_incidents(
        "POST",
        "/listIncidentFindings",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("incidentRecordArn" => incidentRecordArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_incident_records()
    list_incident_records(params::Dict{String,<:Any})

Lists all incident records in your account. Use this command to retrieve the Amazon
Resource Name (ARN) of the incident record you want to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: Filters the list of incident records you want to search through. You can
  filter on the following keys:    creationTime     impact     status     createdBy    Note
  the following when when you use Filters:   If you don't specify a Filter, the response
  includes all incident records.   If you specify more than one filter in a single request,
  the response returns incident records that match all filters.   If you specify a filter
  with more than one value, the response returns incident records that match any of the
  values provided.
- `"maxResults"`: The maximum number of results per page.
- `"nextToken"`: The pagination token for the next set of items to return. (You received
  this token from a previous call.)
"""
function list_incident_records(; aws_config::AbstractAWSConfig=current_aws_config())
    return ssm_incidents(
        "POST",
        "/listIncidentRecords";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_incident_records(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_incidents(
        "POST",
        "/listIncidentRecords",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_related_items(incident_record_arn)
    list_related_items(incident_record_arn, params::Dict{String,<:Any})

List all related items for an incident record.

# Arguments
- `incident_record_arn`: The Amazon Resource Name (ARN) of the incident record containing
  the listed related items.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of related items per page.
- `"nextToken"`: The pagination token for the next set of items to return. (You received
  this token from a previous call.)
"""
function list_related_items(
    incidentRecordArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_incidents(
        "POST",
        "/listRelatedItems",
        Dict{String,Any}("incidentRecordArn" => incidentRecordArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_related_items(
    incidentRecordArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_incidents(
        "POST",
        "/listRelatedItems",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("incidentRecordArn" => incidentRecordArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_replication_sets()
    list_replication_sets(params::Dict{String,<:Any})

Lists details about the replication set configured in your account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results per page.
- `"nextToken"`: The pagination token for the next set of items to return. (You received
  this token from a previous call.)
"""
function list_replication_sets(; aws_config::AbstractAWSConfig=current_aws_config())
    return ssm_incidents(
        "POST",
        "/listReplicationSets";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_replication_sets(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_incidents(
        "POST",
        "/listReplicationSets",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_response_plans()
    list_response_plans(params::Dict{String,<:Any})

Lists all response plans in your account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of response plans per page.
- `"nextToken"`: The pagination token for the next set of items to return. (You received
  this token from a previous call.)
"""
function list_response_plans(; aws_config::AbstractAWSConfig=current_aws_config())
    return ssm_incidents(
        "POST", "/listResponsePlans"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_response_plans(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_incidents(
        "POST",
        "/listResponsePlans",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists the tags that are attached to the specified response plan or incident.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the response plan or incident.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_incidents(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_incidents(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_timeline_events(incident_record_arn)
    list_timeline_events(incident_record_arn, params::Dict{String,<:Any})

Lists timeline events for the specified incident record.

# Arguments
- `incident_record_arn`: The Amazon Resource Name (ARN) of the incident that includes the
  timeline event.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: Filters the timeline events based on the provided conditional values. You
  can filter timeline events with the following keys:    eventReference     eventTime
  eventType    Note the following when deciding how to use Filters:   If you don't specify a
  Filter, the response includes all timeline events.   If you specify more than one filter in
  a single request, the response returns timeline events that match all filters.   If you
  specify a filter with more than one value, the response returns timeline events that match
  any of the values provided.
- `"maxResults"`: The maximum number of results per page.
- `"nextToken"`: The pagination token for the next set of items to return. (You received
  this token from a previous call.)
- `"sortBy"`: Sort timeline events by the specified key value pair.
- `"sortOrder"`: Sorts the order of timeline events by the value specified in the sortBy
  field.
"""
function list_timeline_events(
    incidentRecordArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_incidents(
        "POST",
        "/listTimelineEvents",
        Dict{String,Any}("incidentRecordArn" => incidentRecordArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_timeline_events(
    incidentRecordArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_incidents(
        "POST",
        "/listTimelineEvents",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("incidentRecordArn" => incidentRecordArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_resource_policy(policy, resource_arn)
    put_resource_policy(policy, resource_arn, params::Dict{String,<:Any})

Adds a resource policy to the specified response plan. The resource policy is used to share
the response plan using Resource Access Manager (RAM). For more information about
cross-account sharing, see Cross-Region and cross-account incident management.

# Arguments
- `policy`: Details of the resource policy.
- `resource_arn`: The Amazon Resource Name (ARN) of the response plan to add the resource
  policy to.

"""
function put_resource_policy(
    policy, resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_incidents(
        "POST",
        "/putResourcePolicy",
        Dict{String,Any}("policy" => policy, "resourceArn" => resourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_resource_policy(
    policy,
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_incidents(
        "POST",
        "/putResourcePolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("policy" => policy, "resourceArn" => resourceArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_incident(response_plan_arn)
    start_incident(response_plan_arn, params::Dict{String,<:Any})

Used to start an incident from CloudWatch alarms, EventBridge events, or manually.

# Arguments
- `response_plan_arn`: The Amazon Resource Name (ARN) of the response plan that pre-defines
  summary, chat channels, Amazon SNS topics, runbooks, title, and impact of the incident.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A token ensuring that the operation is called only once with the
  specified details.
- `"impact"`: Defines the impact to the customers. Providing an impact overwrites the
  impact provided by a response plan.  Supported impact codes     1 - Critical    2 - High
  3 - Medium    4 - Low    5 - No Impact
- `"relatedItems"`: Add related items to the incident for other responders to use. Related
  items are Amazon Web Services resources, external links, or files uploaded to an Amazon S3
  bucket.
- `"title"`: Provide a title for the incident. Providing a title overwrites the title
  provided by the response plan.
- `"triggerDetails"`: Details of what created the incident record in Incident Manager.
"""
function start_incident(responsePlanArn; aws_config::AbstractAWSConfig=current_aws_config())
    return ssm_incidents(
        "POST",
        "/startIncident",
        Dict{String,Any}(
            "responsePlanArn" => responsePlanArn, "clientToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_incident(
    responsePlanArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_incidents(
        "POST",
        "/startIncident",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "responsePlanArn" => responsePlanArn, "clientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds a tag to a response plan.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the response plan you're adding the
  tags to.
- `tags`: A list of tags to add to the response plan.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return ssm_incidents(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_incidents(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes a tag from a resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the response plan you're removing a tag
  from.
- `tag_keys`: The name of the tag to remove from the response plan.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_incidents(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_incidents(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_deletion_protection(arn, deletion_protected)
    update_deletion_protection(arn, deletion_protected, params::Dict{String,<:Any})

Update deletion protection to either allow or deny deletion of the final Region in a
replication set.

# Arguments
- `arn`: The Amazon Resource Name (ARN) of the replication set to update.
- `deletion_protected`: Specifies if deletion protection is turned on or off in your
  account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A token that ensures that the operation is called only once with the
  specified details.
"""
function update_deletion_protection(
    arn, deletionProtected; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_incidents(
        "POST",
        "/updateDeletionProtection",
        Dict{String,Any}(
            "arn" => arn,
            "deletionProtected" => deletionProtected,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_deletion_protection(
    arn,
    deletionProtected,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_incidents(
        "POST",
        "/updateDeletionProtection",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "arn" => arn,
                    "deletionProtected" => deletionProtected,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_incident_record(arn)
    update_incident_record(arn, params::Dict{String,<:Any})

Update the details of an incident record. You can use this operation to update an incident
record from the defined chat channel. For more information about using actions in chat
channels, see Interacting through chat.

# Arguments
- `arn`: The Amazon Resource Name (ARN) of the incident record you are updating.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"chatChannel"`: The Chatbot chat channel where responders can collaborate.
- `"clientToken"`: A token that ensures that a client calls the operation only once with
  the specified details.
- `"impact"`: Defines the impact of the incident to customers and applications. If you
  provide an impact for an incident, it overwrites the impact provided by the response plan.
  Supported impact codes     1 - Critical    2 - High    3 - Medium    4 - Low    5 - No
  Impact
- `"notificationTargets"`: The Amazon SNS targets that Incident Manager notifies when a
  client updates an incident. Using multiple SNS topics creates redundancy in the event that
  a Region is down during the incident.
- `"status"`: The status of the incident. Possible statuses are Open or Resolved.
- `"summary"`: A longer description of what occurred during the incident.
- `"title"`: A brief description of the incident.
"""
function update_incident_record(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return ssm_incidents(
        "POST",
        "/updateIncidentRecord",
        Dict{String,Any}("arn" => arn, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_incident_record(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_incidents(
        "POST",
        "/updateIncidentRecord",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("arn" => arn, "clientToken" => string(uuid4())),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_related_items(incident_record_arn, related_items_update)
    update_related_items(incident_record_arn, related_items_update, params::Dict{String,<:Any})

Add or remove related items from the related items tab of an incident record.

# Arguments
- `incident_record_arn`: The Amazon Resource Name (ARN) of the incident record that
  contains the related items that you update.
- `related_items_update`: Details about the item that you are add to, or delete from, an
  incident.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A token that ensures that a client calls the operation only once with
  the specified details.
"""
function update_related_items(
    incidentRecordArn,
    relatedItemsUpdate;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_incidents(
        "POST",
        "/updateRelatedItems",
        Dict{String,Any}(
            "incidentRecordArn" => incidentRecordArn,
            "relatedItemsUpdate" => relatedItemsUpdate,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_related_items(
    incidentRecordArn,
    relatedItemsUpdate,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_incidents(
        "POST",
        "/updateRelatedItems",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "incidentRecordArn" => incidentRecordArn,
                    "relatedItemsUpdate" => relatedItemsUpdate,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_replication_set(actions, arn)
    update_replication_set(actions, arn, params::Dict{String,<:Any})

Add or delete Regions from your replication set.

# Arguments
- `actions`: An action to add or delete a Region.
- `arn`: The Amazon Resource Name (ARN) of the replication set you're updating.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A token that ensures that the operation is called only once with the
  specified details.
"""
function update_replication_set(
    actions, arn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_incidents(
        "POST",
        "/updateReplicationSet",
        Dict{String,Any}(
            "actions" => actions, "arn" => arn, "clientToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_replication_set(
    actions,
    arn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_incidents(
        "POST",
        "/updateReplicationSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "actions" => actions, "arn" => arn, "clientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_response_plan(arn)
    update_response_plan(arn, params::Dict{String,<:Any})

Updates the specified response plan.

# Arguments
- `arn`: The Amazon Resource Name (ARN) of the response plan.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"actions"`: The actions that this response plan takes at the beginning of an incident.
- `"chatChannel"`: The Chatbot chat channel used for collaboration during an incident. Use
  the empty structure to remove the chat channel from the response plan.
- `"clientToken"`: A token ensuring that the operation is called only once with the
  specified details.
- `"displayName"`: The long format name of the response plan. The display name can't
  contain spaces.
- `"engagements"`: The Amazon Resource Name (ARN) for the contacts and escalation plans
  that the response plan engages during an incident.
- `"incidentTemplateDedupeString"`: The string Incident Manager uses to prevent duplicate
  incidents from being created by the same incident in the same account.
- `"incidentTemplateImpact"`: Defines the impact to the customers. Providing an impact
  overwrites the impact provided by a response plan.  Supported impact codes     1 - Critical
     2 - High    3 - Medium    4 - Low    5 - No Impact
- `"incidentTemplateNotificationTargets"`: The Amazon SNS targets that are notified when
  updates are made to an incident.
- `"incidentTemplateSummary"`: A brief summary of the incident. This typically contains
  what has happened, what's currently happening, and next steps.
- `"incidentTemplateTags"`: Tags to assign to the template. When the StartIncident API
  action is called, Incident Manager assigns the tags specified in the template to the
  incident. To call this action, you must also have permission to call the TagResource API
  action for the incident record resource.
- `"incidentTemplateTitle"`: The short format name of the incident. The title can't contain
  spaces.
- `"integrations"`: Information about third-party services integrated into the response
  plan.
"""
function update_response_plan(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return ssm_incidents(
        "POST",
        "/updateResponsePlan",
        Dict{String,Any}("arn" => arn, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_response_plan(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_incidents(
        "POST",
        "/updateResponsePlan",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("arn" => arn, "clientToken" => string(uuid4())),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_timeline_event(event_id, incident_record_arn)
    update_timeline_event(event_id, incident_record_arn, params::Dict{String,<:Any})

Updates a timeline event. You can update events of type Custom Event.

# Arguments
- `event_id`: The ID of the event to update. You can use ListTimelineEvents to find an
  event's ID.
- `incident_record_arn`: The Amazon Resource Name (ARN) of the incident that includes the
  timeline event.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A token that ensures that a client calls the operation only once with
  the specified details.
- `"eventData"`: A short description of the event.
- `"eventReferences"`: Updates all existing references in a TimelineEvent. A reference is
  an Amazon Web Services resource involved or associated with the incident. To specify a
  reference, enter its Amazon Resource Name (ARN). You can also specify a related item
  associated with that resource. For example, to specify an Amazon DynamoDB (DynamoDB) table
  as a resource, use its ARN. You can also specify an Amazon CloudWatch metric associated
  with the DynamoDB table as a related item.  This update action overrides all existing
  references. If you want to keep existing references, you must specify them in the call. If
  you don't, this action removes any existing references and enters only new references.
- `"eventTime"`: The timestamp for when the event occurred.
- `"eventType"`: The type of event. You can update events of type Custom Event and Note.
"""
function update_timeline_event(
    eventId, incidentRecordArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_incidents(
        "POST",
        "/updateTimelineEvent",
        Dict{String,Any}(
            "eventId" => eventId,
            "incidentRecordArn" => incidentRecordArn,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_timeline_event(
    eventId,
    incidentRecordArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_incidents(
        "POST",
        "/updateTimelineEvent",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "eventId" => eventId,
                    "incidentRecordArn" => incidentRecordArn,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWS.jl
using AWS
using AWS.AWSServices: arc_zonal_shift
using AWS.Compat
using AWS.UUIDs

"""
    cancel_zonal_shift(zonal_shift_id)
    cancel_zonal_shift(zonal_shift_id, params::Dict{String,<:Any})

Cancel a zonal shift in Amazon Route 53 Application Recovery Controller. To cancel the
zonal shift, specify the zonal shift ID. A zonal shift can be one that you've started for a
resource in your Amazon Web Services account in an Amazon Web Services Region, or it can be
a zonal shift started by a practice run with zonal autoshift.

# Arguments
- `zonal_shift_id`: The internally-generated identifier of a zonal shift.

"""
function cancel_zonal_shift end

function cancel_zonal_shift(
    zonalShiftId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return arc_zonal_shift(
        "DELETE",
        "/zonalshifts/$(zonalShiftId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function cancel_zonal_shift(
    zonalShiftId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return arc_zonal_shift(
        "DELETE",
        "/zonalshifts/$(zonalShiftId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_practice_run_configuration(outcome_alarms, resource_identifier)
    create_practice_run_configuration(outcome_alarms, resource_identifier, params::Dict{String,<:Any})

A practice run configuration for zonal autoshift is required when you enable zonal
autoshift. A practice run configuration includes specifications for blocked dates and
blocked time windows, and for Amazon CloudWatch alarms that you create to use with practice
runs. The alarms that you specify are an outcome alarm, to monitor application health
during practice runs and, optionally, a blocking alarm, to block practice runs from
starting. When a resource has a practice run configuration, Route 53 ARC starts zonal
shifts for the resource weekly, to shift traffic for practice runs. Practice runs help you
to ensure that shifting away traffic from an Availability Zone during an autoshift is safe
for your application. For more information, see  Considerations when you configure zonal
autoshift in the Amazon Route 53 Application Recovery Controller Developer Guide.

# Arguments
- `outcome_alarms`: The outcome alarm for practice runs is a required Amazon CloudWatch
  alarm that you specify that ends a practice run when the alarm is in an ALARM state.
  Configure the alarm to monitor the health of your application when traffic is shifted away
  from an Availability Zone during each weekly practice run. You should configure the alarm
  to go into an ALARM state if your application is impacted by the zonal shift, and you want
  to stop the zonal shift, to let traffic for the resource return to the Availability Zone.
- `resource_identifier`: The identifier of the resource that Amazon Web Services shifts
  traffic for with a practice run zonal shift. The identifier is the Amazon Resource Name
  (ARN) for the resource. At this time, supported resources are Network Load Balancers and
  Application Load Balancers with cross-zone load balancing turned off.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"blockedDates"`: Optionally, you can block Route 53 ARC from starting practice runs for
  a resource on specific calendar dates. The format for blocked dates is: YYYY-MM-DD. Keep in
  mind, when you specify dates, that dates and times for practice runs are in UTC. Separate
  multiple blocked dates with spaces. For example, if you have an application update
  scheduled to launch on May 1, 2024, and you don't want practice runs to shift traffic away
  at that time, you could set a blocked date for 2024-05-01.
- `"blockedWindows"`: Optionally, you can block Route 53 ARC from starting practice runs
  for specific windows of days and times.  The format for blocked windows is:
  DAY:HH:SS-DAY:HH:SS. Keep in mind, when you specify dates, that dates and times for
  practice runs are in UTC. Also, be aware of potential time adjustments that might be
  required for daylight saving time differences. Separate multiple blocked windows with
  spaces. For example, say you run business report summaries three days a week. For this
  scenario, you might set the following recurring days and times as blocked windows, for
  example: MON-20:30-21:30 WED-20:30-21:30 FRI-20:30-21:30.
- `"blockingAlarms"`: An Amazon CloudWatch alarm that you can specify for zonal autoshift
  practice runs. This alarm blocks Route 53 ARC from starting practice run zonal shifts, and
  ends a practice run that's in progress, when the alarm is in an ALARM state.
"""
function create_practice_run_configuration end

function create_practice_run_configuration(
    outcomeAlarms, resourceIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return arc_zonal_shift(
        "POST",
        "/configuration",
        Dict{String,Any}(
            "outcomeAlarms" => outcomeAlarms, "resourceIdentifier" => resourceIdentifier
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function create_practice_run_configuration(
    outcomeAlarms,
    resourceIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return arc_zonal_shift(
        "POST",
        "/configuration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "outcomeAlarms" => outcomeAlarms,
                    "resourceIdentifier" => resourceIdentifier,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_practice_run_configuration(resource_identifier)
    delete_practice_run_configuration(resource_identifier, params::Dict{String,<:Any})

Deletes the practice run configuration for a resource. Before you can delete a practice run
configuration for a resource., you must disable zonal autoshift for the resource. Practice
runs must be configured for zonal autoshift to be enabled.

# Arguments
- `resource_identifier`: The identifier for the resource that you want to delete the
  practice run configuration for. The identifier is the Amazon Resource Name (ARN) for the
  resource.

"""
function delete_practice_run_configuration end

function delete_practice_run_configuration(
    resourceIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return arc_zonal_shift(
        "DELETE",
        "/configuration/$(resourceIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function delete_practice_run_configuration(
    resourceIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return arc_zonal_shift(
        "DELETE",
        "/configuration/$(resourceIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_autoshift_observer_notification_status()
    get_autoshift_observer_notification_status(params::Dict{String,<:Any})

Returns the status of autoshift observer notification. Autoshift observer notification
enables you to be notified, through Amazon EventBridge, when there is an autoshift event
for zonal autoshift. If the status is ENABLED, Route 53 ARC includes all autoshift events
when you use the EventBridge pattern Autoshift In Progress. When the status is DISABLED,
Route 53 ARC includes only autoshift events for autoshifts when one or more of your
resources is included in the autoshift. For more information, see  Notifications for
practice runs and autoshifts in the Amazon Route 53 Application Recovery Controller
Developer Guide.

"""
function get_autoshift_observer_notification_status end

function get_autoshift_observer_notification_status(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return arc_zonal_shift(
        "GET",
        "/autoshift-observer-notification";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function get_autoshift_observer_notification_status(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return arc_zonal_shift(
        "GET",
        "/autoshift-observer-notification",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_managed_resource(resource_identifier)
    get_managed_resource(resource_identifier, params::Dict{String,<:Any})

Get information about a resource that's been registered for zonal shifts with Amazon Route
53 Application Recovery Controller in this Amazon Web Services Region. Resources that are
registered for zonal shifts are managed resources in Route 53 ARC. You can start zonal
shifts and configure zonal autoshift for managed resources. At this time, you can only
start a zonal shift or configure zonal autoshift for Network Load Balancers and Application
Load Balancers with cross-zone load balancing turned off.

# Arguments
- `resource_identifier`: The identifier for the resource that Amazon Web Services shifts
  traffic for. The identifier is the Amazon Resource Name (ARN) for the resource. At this
  time, supported resources are Network Load Balancers and Application Load Balancers with
  cross-zone load balancing turned off.

"""
function get_managed_resource end

function get_managed_resource(
    resourceIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return arc_zonal_shift(
        "GET",
        "/managedresources/$(resourceIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function get_managed_resource(
    resourceIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return arc_zonal_shift(
        "GET",
        "/managedresources/$(resourceIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_autoshifts()
    list_autoshifts(params::Dict{String,<:Any})

Returns a list of autoshifts for an Amazon Web Services Region. By default, the call
returns only ACTIVE autoshifts. Optionally, you can specify the status parameter to return
COMPLETED autoshifts.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The number of objects that you want to return with this call.
- `"nextToken"`: Specifies that you want to receive the next page of results. Valid only if
  you received a NextToken response in the previous request. If you did, it indicates that
  more output is available. Set this parameter to the value provided by the previous call's
  NextToken response to request the next page of results.
- `"status"`: The status of the autoshift.
"""
function list_autoshifts end

function list_autoshifts(; aws_config::AbstractAWSConfig=current_aws_config())
    return arc_zonal_shift(
        "GET", "/autoshifts"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

function list_autoshifts(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return arc_zonal_shift(
        "GET", "/autoshifts", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_managed_resources()
    list_managed_resources(params::Dict{String,<:Any})

Lists all the resources in your Amazon Web Services account in this Amazon Web Services
Region that are managed for zonal shifts in Amazon Route 53 Application Recovery
Controller, and information about them. The information includes the zonal autoshift status
for the resource, as well as the Amazon Resource Name (ARN), the Availability Zones that
each resource is deployed in, and the resource name.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The number of objects that you want to return with this call.
- `"nextToken"`: Specifies that you want to receive the next page of results. Valid only if
  you received a NextToken response in the previous request. If you did, it indicates that
  more output is available. Set this parameter to the value provided by the previous call's
  NextToken response to request the next page of results.
"""
function list_managed_resources end

function list_managed_resources(; aws_config::AbstractAWSConfig=current_aws_config())
    return arc_zonal_shift(
        "GET", "/managedresources"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

function list_managed_resources(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return arc_zonal_shift(
        "GET",
        "/managedresources",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_zonal_shifts()
    list_zonal_shifts(params::Dict{String,<:Any})

Lists all active and completed zonal shifts in Amazon Route 53 Application Recovery
Controller in your Amazon Web Services account in this Amazon Web Services Region.
ListZonalShifts returns customer-initiated zonal shifts, as well as practice run zonal
shifts that Route 53 ARC started on your behalf for zonal autoshift. The ListZonalShifts
operation does not list autoshifts. For more information about listing autoshifts, see
\"&gt;ListAutoshifts.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The number of objects that you want to return with this call.
- `"nextToken"`: Specifies that you want to receive the next page of results. Valid only if
  you received a NextToken response in the previous request. If you did, it indicates that
  more output is available. Set this parameter to the value provided by the previous call's
  NextToken response to request the next page of results.
- `"resourceIdentifier"`: The identifier for the resource that you want to list zonal
  shifts for. The identifier is the Amazon Resource Name (ARN) for the resource.
- `"status"`: A status for a zonal shift. The Status for a zonal shift can have one of the
  following values:    ACTIVE: The zonal shift has been started and active.    EXPIRED: The
  zonal shift has expired (the expiry time was exceeded).    CANCELED: The zonal shift was
  canceled.
"""
function list_zonal_shifts end

function list_zonal_shifts(; aws_config::AbstractAWSConfig=current_aws_config())
    return arc_zonal_shift(
        "GET", "/zonalshifts"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

function list_zonal_shifts(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return arc_zonal_shift(
        "GET",
        "/zonalshifts",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_zonal_shift(away_from, comment, expires_in, resource_identifier)
    start_zonal_shift(away_from, comment, expires_in, resource_identifier, params::Dict{String,<:Any})

You start a zonal shift to temporarily move load balancer traffic away from an Availability
Zone in an Amazon Web Services Region, to help your application recover immediately, for
example, from a developer's bad code deployment or from an Amazon Web Services
infrastructure failure in a single Availability Zone. You can start a zonal shift in Route
53 ARC only for managed resources in your Amazon Web Services account in an Amazon Web
Services Region. Resources are automatically registered with Route 53 ARC by Amazon Web
Services services. At this time, you can only start a zonal shift for Network Load
Balancers and Application Load Balancers with cross-zone load balancing turned off. When
you start a zonal shift, traffic for the resource is no longer routed to the Availability
Zone. The zonal shift is created immediately in Route 53 ARC. However, it can take a short
time, typically up to a few minutes, for existing, in-progress connections in the
Availability Zone to complete. For more information, see Zonal shift in the Amazon Route 53
Application Recovery Controller Developer Guide.

# Arguments
- `away_from`: The Availability Zone (for example, use1-az1) that traffic is moved away
  from for a resource when you start a zonal shift. Until the zonal shift expires or you
  cancel it, traffic for the resource is instead moved to other Availability Zones in the
  Amazon Web Services Region.
- `comment`: A comment that you enter about the zonal shift. Only the latest comment is
  retained; no comment history is maintained. A new comment overwrites any existing comment
  string.
- `expires_in`: The length of time that you want a zonal shift to be active, which Route 53
  ARC converts to an expiry time (expiration time). Zonal shifts are temporary. You can set a
  zonal shift to be active initially for up to three days (72 hours). If you want to still
  keep traffic away from an Availability Zone, you can update the zonal shift and set a new
  expiration. You can also cancel a zonal shift, before it expires, for example, if you're
  ready to restore traffic to the Availability Zone. To set a length of time for a zonal
  shift to be active, specify a whole number, and then one of the following, with no space:
   A lowercase letter m: To specify that the value is in minutes.    A lowercase letter h: To
  specify that the value is in hours.   For example: 20h means the zonal shift expires in 20
  hours. 120m means the zonal shift expires in 120 minutes (2 hours).
- `resource_identifier`: The identifier for the resource that Amazon Web Services shifts
  traffic for. The identifier is the Amazon Resource Name (ARN) for the resource. At this
  time, supported resources are Network Load Balancers and Application Load Balancers with
  cross-zone load balancing turned off.

"""
function start_zonal_shift end

function start_zonal_shift(
    awayFrom,
    comment,
    expiresIn,
    resourceIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return arc_zonal_shift(
        "POST",
        "/zonalshifts",
        Dict{String,Any}(
            "awayFrom" => awayFrom,
            "comment" => comment,
            "expiresIn" => expiresIn,
            "resourceIdentifier" => resourceIdentifier,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function start_zonal_shift(
    awayFrom,
    comment,
    expiresIn,
    resourceIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return arc_zonal_shift(
        "POST",
        "/zonalshifts",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "awayFrom" => awayFrom,
                    "comment" => comment,
                    "expiresIn" => expiresIn,
                    "resourceIdentifier" => resourceIdentifier,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_autoshift_observer_notification_status(status)
    update_autoshift_observer_notification_status(status, params::Dict{String,<:Any})

Update the status of autoshift observer notification. Autoshift observer notification
enables you to be notified, through Amazon EventBridge, when there is an autoshift event
for zonal autoshift. If the status is ENABLED, Route 53 ARC includes all autoshift events
when you use the EventBridge pattern Autoshift In Progress. When the status is DISABLED,
Route 53 ARC includes only autoshift events for autoshifts when one or more of your
resources is included in the autoshift. For more information, see  Notifications for
practice runs and autoshifts in the Amazon Route 53 Application Recovery Controller
Developer Guide.

# Arguments
- `status`: The status to set for autoshift observer notification. If the status is
  ENABLED, Route 53 ARC includes all autoshift events when you use the Amazon EventBridge
  pattern Autoshift In Progress. When the status is DISABLED, Route 53 ARC includes only
  autoshift events for autoshifts when one or more of your resources is included in the
  autoshift.

"""
function update_autoshift_observer_notification_status end

function update_autoshift_observer_notification_status(
    status; aws_config::AbstractAWSConfig=current_aws_config()
)
    return arc_zonal_shift(
        "PUT",
        "/autoshift-observer-notification",
        Dict{String,Any}("status" => status);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function update_autoshift_observer_notification_status(
    status, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return arc_zonal_shift(
        "PUT",
        "/autoshift-observer-notification",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("status" => status), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_practice_run_configuration(resource_identifier)
    update_practice_run_configuration(resource_identifier, params::Dict{String,<:Any})

Update a practice run configuration to change one or more of the following: add, change, or
remove the blocking alarm; change the outcome alarm; or add, change, or remove blocking
dates or time windows.

# Arguments
- `resource_identifier`: The identifier for the resource that you want to update the
  practice run configuration for. The identifier is the Amazon Resource Name (ARN) for the
  resource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"blockedDates"`: Add, change, or remove blocked dates for a practice run in zonal
  autoshift. Optionally, you can block practice runs for specific calendar dates. The format
  for blocked dates is: YYYY-MM-DD. Keep in mind, when you specify dates, that dates and
  times for practice runs are in UTC. Separate multiple blocked dates with spaces. For
  example, if you have an application update scheduled to launch on May 1, 2024, and you
  don't want practice runs to shift traffic away at that time, you could set a blocked date
  for 2024-05-01.
- `"blockedWindows"`: Add, change, or remove windows of days and times for when you can,
  optionally, block Route 53 ARC from starting a practice run for a resource. The format for
  blocked windows is: DAY:HH:SS-DAY:HH:SS. Keep in mind, when you specify dates, that dates
  and times for practice runs are in UTC. Also, be aware of potential time adjustments that
  might be required for daylight saving time differences. Separate multiple blocked windows
  with spaces. For example, say you run business report summaries three days a week. For this
  scenario, you might set the following recurring days and times as blocked windows, for
  example: MON-20:30-21:30 WED-20:30-21:30 FRI-20:30-21:30.
- `"blockingAlarms"`: Add, change, or remove the Amazon CloudWatch alarm that you
  optionally specify as the blocking alarm for practice runs.
- `"outcomeAlarms"`: Specify a new the Amazon CloudWatch alarm as the outcome alarm for
  practice runs.
"""
function update_practice_run_configuration end

function update_practice_run_configuration(
    resourceIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return arc_zonal_shift(
        "PATCH",
        "/configuration/$(resourceIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function update_practice_run_configuration(
    resourceIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return arc_zonal_shift(
        "PATCH",
        "/configuration/$(resourceIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_zonal_autoshift_configuration(resource_identifier, zonal_autoshift_status)
    update_zonal_autoshift_configuration(resource_identifier, zonal_autoshift_status, params::Dict{String,<:Any})

The zonal autoshift configuration for a resource includes the practice run configuration
and the status for running autoshifts, zonal autoshift status. When a resource has a
practice run configuation, Route 53 ARC starts weekly zonal shifts for the resource, to
shift traffic away from an Availability Zone. Weekly practice runs help you to make sure
that your application can continue to operate normally with the loss of one Availability
Zone. You can update the zonal autoshift autoshift status to enable or disable zonal
autoshift. When zonal autoshift is ENABLED, you authorize Amazon Web Services to shift away
resource traffic for an application from an Availability Zone during events, on your
behalf, to help reduce time to recovery. Traffic is also shifted away for the required
weekly practice runs.

# Arguments
- `resource_identifier`: The identifier for the resource that you want to update the zonal
  autoshift configuration for. The identifier is the Amazon Resource Name (ARN) for the
  resource.
- `zonal_autoshift_status`: The zonal autoshift status for the resource that you want to
  update the zonal autoshift configuration for. Choose ENABLED to authorize Amazon Web
  Services to shift away resource traffic for an application from an Availability Zone during
  events, on your behalf, to help reduce time to recovery.

"""
function update_zonal_autoshift_configuration end

function update_zonal_autoshift_configuration(
    resourceIdentifier,
    zonalAutoshiftStatus;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return arc_zonal_shift(
        "PUT",
        "/managedresources/$(resourceIdentifier)",
        Dict{String,Any}("zonalAutoshiftStatus" => zonalAutoshiftStatus);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function update_zonal_autoshift_configuration(
    resourceIdentifier,
    zonalAutoshiftStatus,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return arc_zonal_shift(
        "PUT",
        "/managedresources/$(resourceIdentifier)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("zonalAutoshiftStatus" => zonalAutoshiftStatus),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_zonal_shift(zonal_shift_id)
    update_zonal_shift(zonal_shift_id, params::Dict{String,<:Any})

Update an active zonal shift in Amazon Route 53 Application Recovery Controller in your
Amazon Web Services account. You can update a zonal shift to set a new expiration, or edit
or replace the comment for the zonal shift.

# Arguments
- `zonal_shift_id`: The identifier of a zonal shift.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"comment"`: A comment that you enter about the zonal shift. Only the latest comment is
  retained; no comment history is maintained. A new comment overwrites any existing comment
  string.
- `"expiresIn"`: The length of time that you want a zonal shift to be active, which Route
  53 ARC converts to an expiry time (expiration time). Zonal shifts are temporary. You can
  set a zonal shift to be active initially for up to three days (72 hours). If you want to
  still keep traffic away from an Availability Zone, you can update the zonal shift and set a
  new expiration. You can also cancel a zonal shift, before it expires, for example, if
  you're ready to restore traffic to the Availability Zone. To set a length of time for a
  zonal shift to be active, specify a whole number, and then one of the following, with no
  space:    A lowercase letter m: To specify that the value is in minutes.    A lowercase
  letter h: To specify that the value is in hours.   For example: 20h means the zonal shift
  expires in 20 hours. 120m means the zonal shift expires in 120 minutes (2 hours).
"""
function update_zonal_shift end

function update_zonal_shift(
    zonalShiftId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return arc_zonal_shift(
        "PATCH",
        "/zonalshifts/$(zonalShiftId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function update_zonal_shift(
    zonalShiftId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return arc_zonal_shift(
        "PATCH",
        "/zonalshifts/$(zonalShiftId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: emr
using AWS.Compat
using AWS.UUIDs

"""
    add_instance_fleet(cluster_id, instance_fleet)
    add_instance_fleet(cluster_id, instance_fleet, params::Dict{String,<:Any})

Adds an instance fleet to a running cluster.  The instance fleet configuration is available
only in Amazon EMR releases 4.8.0 and later, excluding 5.0.x.

# Arguments
- `cluster_id`: The unique identifier of the cluster.
- `instance_fleet`: Specifies the configuration of the instance fleet.

"""
function add_instance_fleet(
    ClusterId, InstanceFleet; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr(
        "AddInstanceFleet",
        Dict{String,Any}("ClusterId" => ClusterId, "InstanceFleet" => InstanceFleet);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_instance_fleet(
    ClusterId,
    InstanceFleet,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr(
        "AddInstanceFleet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClusterId" => ClusterId, "InstanceFleet" => InstanceFleet
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    add_instance_groups(instance_groups, job_flow_id)
    add_instance_groups(instance_groups, job_flow_id, params::Dict{String,<:Any})

Adds one or more instance groups to a running cluster.

# Arguments
- `instance_groups`: Instance groups to add.
- `job_flow_id`: Job flow in which to add the instance groups.

"""
function add_instance_groups(
    InstanceGroups, JobFlowId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr(
        "AddInstanceGroups",
        Dict{String,Any}("InstanceGroups" => InstanceGroups, "JobFlowId" => JobFlowId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_instance_groups(
    InstanceGroups,
    JobFlowId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr(
        "AddInstanceGroups",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "InstanceGroups" => InstanceGroups, "JobFlowId" => JobFlowId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    add_job_flow_steps(job_flow_id, steps)
    add_job_flow_steps(job_flow_id, steps, params::Dict{String,<:Any})

AddJobFlowSteps adds new steps to a running cluster. A maximum of 256 steps are allowed in
each job flow. If your cluster is long-running (such as a Hive data warehouse) or complex,
you may require more than 256 steps to process your data. You can bypass the 256-step
limitation in various ways, including using SSH to connect to the master node and
submitting queries directly to the software running on the master node, such as Hive and
Hadoop. A step specifies the location of a JAR file stored either on the master node of the
cluster or in Amazon S3. Each step is performed by the main function of the main class of
the JAR file. The main class can be specified either in the manifest of the JAR or by using
the MainFunction parameter of the step. Amazon EMR executes each step in the order listed.
For a step to be considered complete, the main function must exit with a zero exit code and
all Hadoop jobs started while the step was running must have completed and run
successfully. You can only add steps to a cluster that is in one of the following states:
STARTING, BOOTSTRAPPING, RUNNING, or WAITING.  The string values passed into HadoopJarStep
object cannot exceed a total of 10240 characters.

# Arguments
- `job_flow_id`: A string that uniquely identifies the job flow. This identifier is
  returned by RunJobFlow and can also be obtained from ListClusters.
- `steps`:  A list of StepConfig to be executed by the job flow.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ExecutionRoleArn"`: The Amazon Resource Name (ARN) of the runtime role for a step on
  the cluster. The runtime role can be a cross-account IAM role. The runtime role ARN is a
  combination of account ID, role name, and role type using the following format:
  arn:partition:service:region:account:resource.  For example,
  arn:aws:IAM::1234567890:role/ReadOnly is a correctly formatted runtime role ARN.
"""
function add_job_flow_steps(
    JobFlowId, Steps; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr(
        "AddJobFlowSteps",
        Dict{String,Any}("JobFlowId" => JobFlowId, "Steps" => Steps);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_job_flow_steps(
    JobFlowId,
    Steps,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr(
        "AddJobFlowSteps",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("JobFlowId" => JobFlowId, "Steps" => Steps), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    add_tags(resource_id, tags)
    add_tags(resource_id, tags, params::Dict{String,<:Any})

Adds tags to an Amazon EMR resource, such as a cluster or an Amazon EMR Studio. Tags make
it easier to associate resources in various ways, such as grouping clusters to track your
Amazon EMR resource allocation costs. For more information, see Tag Clusters.

# Arguments
- `resource_id`: The Amazon EMR resource identifier to which tags will be added. For
  example, a cluster identifier or an Amazon EMR Studio ID.
- `tags`: A list of tags to associate with a resource. Tags are user-defined key-value
  pairs that consist of a required key string with a maximum of 128 characters, and an
  optional value string with a maximum of 256 characters.

"""
function add_tags(ResourceId, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return emr(
        "AddTags",
        Dict{String,Any}("ResourceId" => ResourceId, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_tags(
    ResourceId,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr(
        "AddTags",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ResourceId" => ResourceId, "Tags" => Tags), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_steps(cluster_id, step_ids)
    cancel_steps(cluster_id, step_ids, params::Dict{String,<:Any})

Cancels a pending step or steps in a running cluster. Available only in Amazon EMR versions
4.8.0 and later, excluding version 5.0.0. A maximum of 256 steps are allowed in each
CancelSteps request. CancelSteps is idempotent but asynchronous; it does not guarantee that
a step will be canceled, even if the request is successfully submitted. When you use Amazon
EMR releases 5.28.0 and later, you can cancel steps that are in a PENDING or RUNNING state.
In earlier versions of Amazon EMR, you can only cancel steps that are in a PENDING state.

# Arguments
- `cluster_id`: The ClusterID for the specified steps that will be canceled. Use RunJobFlow
  and ListClusters to get ClusterIDs.
- `step_ids`: The list of StepIDs to cancel. Use ListSteps to get steps and their states
  for the specified cluster.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"StepCancellationOption"`: The option to choose to cancel RUNNING steps. By default, the
  value is SEND_INTERRUPT.
"""
function cancel_steps(
    ClusterId, StepIds; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr(
        "CancelSteps",
        Dict{String,Any}("ClusterId" => ClusterId, "StepIds" => StepIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_steps(
    ClusterId,
    StepIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr(
        "CancelSteps",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ClusterId" => ClusterId, "StepIds" => StepIds),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_security_configuration(name, security_configuration)
    create_security_configuration(name, security_configuration, params::Dict{String,<:Any})

Creates a security configuration, which is stored in the service and can be specified when
a cluster is created.

# Arguments
- `name`: The name of the security configuration.
- `security_configuration`: The security configuration details in JSON format. For JSON
  parameters and examples, see Use Security Configurations to Set Up Cluster Security in the
  Amazon EMR Management Guide.

"""
function create_security_configuration(
    Name, SecurityConfiguration; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr(
        "CreateSecurityConfiguration",
        Dict{String,Any}("Name" => Name, "SecurityConfiguration" => SecurityConfiguration);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_security_configuration(
    Name,
    SecurityConfiguration,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr(
        "CreateSecurityConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Name" => Name, "SecurityConfiguration" => SecurityConfiguration
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_studio(auth_mode, default_s3_location, engine_security_group_id, name, service_role, subnet_ids, vpc_id, workspace_security_group_id)
    create_studio(auth_mode, default_s3_location, engine_security_group_id, name, service_role, subnet_ids, vpc_id, workspace_security_group_id, params::Dict{String,<:Any})

Creates a new Amazon EMR Studio.

# Arguments
- `auth_mode`: Specifies whether the Studio authenticates users using IAM or IAM Identity
  Center.
- `default_s3_location`: The Amazon S3 location to back up Amazon EMR Studio Workspaces and
  notebook files.
- `engine_security_group_id`: The ID of the Amazon EMR Studio Engine security group. The
  Engine security group allows inbound network traffic from the Workspace security group, and
  it must be in the same VPC specified by VpcId.
- `name`: A descriptive name for the Amazon EMR Studio.
- `service_role`: The IAM role that the Amazon EMR Studio assumes. The service role
  provides a way for Amazon EMR Studio to interoperate with other Amazon Web Services
  services.
- `subnet_ids`: A list of subnet IDs to associate with the Amazon EMR Studio. A Studio can
  have a maximum of 5 subnets. The subnets must belong to the VPC specified by VpcId. Studio
  users can create a Workspace in any of the specified subnets.
- `vpc_id`: The ID of the Amazon Virtual Private Cloud (Amazon VPC) to associate with the
  Studio.
- `workspace_security_group_id`: The ID of the Amazon EMR Studio Workspace security group.
  The Workspace security group allows outbound network traffic to resources in the Engine
  security group, and it must be in the same VPC specified by VpcId.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A detailed description of the Amazon EMR Studio.
- `"EncryptionKeyArn"`: The KMS key identifier (ARN) used to encrypt Amazon EMR Studio
  workspace and notebook files when backed up to Amazon S3.
- `"IdcInstanceArn"`:  The ARN of the IAM Identity Center instance to create the Studio
  application.
- `"IdcUserAssignment"`:  Specifies whether IAM Identity Center user assignment is REQUIRED
  or OPTIONAL. If the value is set to REQUIRED, users must be explicitly assigned to the
  Studio application to access the Studio.
- `"IdpAuthUrl"`: The authentication endpoint of your identity provider (IdP). Specify this
  value when you use IAM authentication and want to let federated users log in to a Studio
  with the Studio URL and credentials from your IdP. Amazon EMR Studio redirects users to
  this endpoint to enter credentials.
- `"IdpRelayStateParameterName"`: The name that your identity provider (IdP) uses for its
  RelayState parameter. For example, RelayState or TargetSource. Specify this value when you
  use IAM authentication and want to let federated users log in to a Studio using the Studio
  URL. The RelayState parameter differs by IdP.
- `"Tags"`: A list of tags to associate with the Amazon EMR Studio. Tags are user-defined
  key-value pairs that consist of a required key string with a maximum of 128 characters, and
  an optional value string with a maximum of 256 characters.
- `"TrustedIdentityPropagationEnabled"`:  A Boolean indicating whether to enable Trusted
  identity propagation for the Studio. The default value is false.
- `"UserRole"`: The IAM user role that users and groups assume when logged in to an Amazon
  EMR Studio. Only specify a UserRole when you use IAM Identity Center authentication. The
  permissions attached to the UserRole can be scoped down for each user or group using
  session policies.
"""
function create_studio(
    AuthMode,
    DefaultS3Location,
    EngineSecurityGroupId,
    Name,
    ServiceRole,
    SubnetIds,
    VpcId,
    WorkspaceSecurityGroupId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr(
        "CreateStudio",
        Dict{String,Any}(
            "AuthMode" => AuthMode,
            "DefaultS3Location" => DefaultS3Location,
            "EngineSecurityGroupId" => EngineSecurityGroupId,
            "Name" => Name,
            "ServiceRole" => ServiceRole,
            "SubnetIds" => SubnetIds,
            "VpcId" => VpcId,
            "WorkspaceSecurityGroupId" => WorkspaceSecurityGroupId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_studio(
    AuthMode,
    DefaultS3Location,
    EngineSecurityGroupId,
    Name,
    ServiceRole,
    SubnetIds,
    VpcId,
    WorkspaceSecurityGroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr(
        "CreateStudio",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AuthMode" => AuthMode,
                    "DefaultS3Location" => DefaultS3Location,
                    "EngineSecurityGroupId" => EngineSecurityGroupId,
                    "Name" => Name,
                    "ServiceRole" => ServiceRole,
                    "SubnetIds" => SubnetIds,
                    "VpcId" => VpcId,
                    "WorkspaceSecurityGroupId" => WorkspaceSecurityGroupId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_studio_session_mapping(identity_type, session_policy_arn, studio_id)
    create_studio_session_mapping(identity_type, session_policy_arn, studio_id, params::Dict{String,<:Any})

Maps a user or group to the Amazon EMR Studio specified by StudioId, and applies a session
policy to refine Studio permissions for that user or group. Use CreateStudioSessionMapping
to assign users to a Studio when you use IAM Identity Center authentication. For
instructions on how to assign users to a Studio when you use IAM authentication, see Assign
a user or group to your EMR Studio.

# Arguments
- `identity_type`: Specifies whether the identity to map to the Amazon EMR Studio is a user
  or a group.
- `session_policy_arn`: The Amazon Resource Name (ARN) for the session policy that will be
  applied to the user or group. You should specify the ARN for the session policy that you
  want to apply, not the ARN of your user role. For more information, see Create an Amazon
  EMR Studio User Role with Session Policies.
- `studio_id`: The ID of the Amazon EMR Studio to which the user or group will be mapped.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"IdentityId"`: The globally unique identifier (GUID) of the user or group from the IAM
  Identity Center Identity Store. For more information, see UserId and GroupId in the IAM
  Identity Center Identity Store API Reference. Either IdentityName or IdentityId must be
  specified, but not both.
- `"IdentityName"`: The name of the user or group. For more information, see UserName and
  DisplayName in the IAM Identity Center Identity Store API Reference. Either IdentityName or
  IdentityId must be specified, but not both.
"""
function create_studio_session_mapping(
    IdentityType,
    SessionPolicyArn,
    StudioId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr(
        "CreateStudioSessionMapping",
        Dict{String,Any}(
            "IdentityType" => IdentityType,
            "SessionPolicyArn" => SessionPolicyArn,
            "StudioId" => StudioId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_studio_session_mapping(
    IdentityType,
    SessionPolicyArn,
    StudioId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr(
        "CreateStudioSessionMapping",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "IdentityType" => IdentityType,
                    "SessionPolicyArn" => SessionPolicyArn,
                    "StudioId" => StudioId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_security_configuration(name)
    delete_security_configuration(name, params::Dict{String,<:Any})

Deletes a security configuration.

# Arguments
- `name`: The name of the security configuration.

"""
function delete_security_configuration(
    Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr(
        "DeleteSecurityConfiguration",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_security_configuration(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr(
        "DeleteSecurityConfiguration",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_studio(studio_id)
    delete_studio(studio_id, params::Dict{String,<:Any})

Removes an Amazon EMR Studio from the Studio metadata store.

# Arguments
- `studio_id`: The ID of the Amazon EMR Studio.

"""
function delete_studio(StudioId; aws_config::AbstractAWSConfig=current_aws_config())
    return emr(
        "DeleteStudio",
        Dict{String,Any}("StudioId" => StudioId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_studio(
    StudioId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr(
        "DeleteStudio",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("StudioId" => StudioId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_studio_session_mapping(identity_type, studio_id)
    delete_studio_session_mapping(identity_type, studio_id, params::Dict{String,<:Any})

Removes a user or group from an Amazon EMR Studio.

# Arguments
- `identity_type`: Specifies whether the identity to delete from the Amazon EMR Studio is a
  user or a group.
- `studio_id`: The ID of the Amazon EMR Studio.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"IdentityId"`: The globally unique identifier (GUID) of the user or group to remove from
  the Amazon EMR Studio. For more information, see UserId and GroupId in the IAM Identity
  Center Identity Store API Reference. Either IdentityName or IdentityId must be specified.
- `"IdentityName"`: The name of the user name or group to remove from the Amazon EMR
  Studio. For more information, see UserName and DisplayName in the IAM Identity Center Store
  API Reference. Either IdentityName or IdentityId must be specified.
"""
function delete_studio_session_mapping(
    IdentityType, StudioId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr(
        "DeleteStudioSessionMapping",
        Dict{String,Any}("IdentityType" => IdentityType, "StudioId" => StudioId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_studio_session_mapping(
    IdentityType,
    StudioId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr(
        "DeleteStudioSessionMapping",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("IdentityType" => IdentityType, "StudioId" => StudioId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_cluster(cluster_id)
    describe_cluster(cluster_id, params::Dict{String,<:Any})

Provides cluster-level details including status, hardware and software configuration, VPC
settings, and so on.

# Arguments
- `cluster_id`: The identifier of the cluster to describe.

"""
function describe_cluster(ClusterId; aws_config::AbstractAWSConfig=current_aws_config())
    return emr(
        "DescribeCluster",
        Dict{String,Any}("ClusterId" => ClusterId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_cluster(
    ClusterId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr(
        "DescribeCluster",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ClusterId" => ClusterId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_job_flows()
    describe_job_flows(params::Dict{String,<:Any})

This API is no longer supported and will eventually be removed. We recommend you use
ListClusters, DescribeCluster, ListSteps, ListInstanceGroups and ListBootstrapActions
instead. DescribeJobFlows returns a list of job flows that match all of the supplied
parameters. The parameters can include a list of job flow IDs, job flow states, and
restrictions on job flow creation date and time. Regardless of supplied parameters, only
job flows created within the last two months are returned. If no parameters are supplied,
then job flows matching either of the following criteria are returned:   Job flows created
and completed in the last two weeks    Job flows created within the last two months that
are in one of the following states: RUNNING, WAITING, SHUTTING_DOWN, STARTING    Amazon EMR
can return a maximum of 512 job flow descriptions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CreatedAfter"`: Return only job flows created after this date and time.
- `"CreatedBefore"`: Return only job flows created before this date and time.
- `"JobFlowIds"`: Return only job flows whose job flow ID is contained in this list.
- `"JobFlowStates"`: Return only job flows whose state is contained in this list.
"""
function describe_job_flows(; aws_config::AbstractAWSConfig=current_aws_config())
    return emr("DescribeJobFlows"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function describe_job_flows(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr(
        "DescribeJobFlows", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_notebook_execution(notebook_execution_id)
    describe_notebook_execution(notebook_execution_id, params::Dict{String,<:Any})

Provides details of a notebook execution.

# Arguments
- `notebook_execution_id`: The unique identifier of the notebook execution.

"""
function describe_notebook_execution(
    NotebookExecutionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr(
        "DescribeNotebookExecution",
        Dict{String,Any}("NotebookExecutionId" => NotebookExecutionId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_notebook_execution(
    NotebookExecutionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr(
        "DescribeNotebookExecution",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("NotebookExecutionId" => NotebookExecutionId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_release_label()
    describe_release_label(params::Dict{String,<:Any})

Provides Amazon EMR release label details, such as the releases available the Region where
the API request is run, and the available applications for a specific Amazon EMR release
label. Can also list Amazon EMR releases that support a specified version of Spark.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Reserved for future use. Currently set to null.
- `"NextToken"`: The pagination token. Reserved for future use. Currently set to null.
- `"ReleaseLabel"`: The target release label to be described.
"""
function describe_release_label(; aws_config::AbstractAWSConfig=current_aws_config())
    return emr(
        "DescribeReleaseLabel"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_release_label(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr(
        "DescribeReleaseLabel",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_security_configuration(name)
    describe_security_configuration(name, params::Dict{String,<:Any})

Provides the details of a security configuration by returning the configuration JSON.

# Arguments
- `name`: The name of the security configuration.

"""
function describe_security_configuration(
    Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr(
        "DescribeSecurityConfiguration",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_security_configuration(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr(
        "DescribeSecurityConfiguration",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_step(cluster_id, step_id)
    describe_step(cluster_id, step_id, params::Dict{String,<:Any})

Provides more detail about the cluster step.

# Arguments
- `cluster_id`: The identifier of the cluster with steps to describe.
- `step_id`: The identifier of the step to describe.

"""
function describe_step(
    ClusterId, StepId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr(
        "DescribeStep",
        Dict{String,Any}("ClusterId" => ClusterId, "StepId" => StepId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_step(
    ClusterId,
    StepId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr(
        "DescribeStep",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ClusterId" => ClusterId, "StepId" => StepId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_studio(studio_id)
    describe_studio(studio_id, params::Dict{String,<:Any})

Returns details for the specified Amazon EMR Studio including ID, Name, VPC, Studio access
URL, and so on.

# Arguments
- `studio_id`: The Amazon EMR Studio ID.

"""
function describe_studio(StudioId; aws_config::AbstractAWSConfig=current_aws_config())
    return emr(
        "DescribeStudio",
        Dict{String,Any}("StudioId" => StudioId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_studio(
    StudioId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr(
        "DescribeStudio",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("StudioId" => StudioId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_auto_termination_policy(cluster_id)
    get_auto_termination_policy(cluster_id, params::Dict{String,<:Any})

Returns the auto-termination policy for an Amazon EMR cluster.

# Arguments
- `cluster_id`: Specifies the ID of the Amazon EMR cluster for which the auto-termination
  policy will be fetched.

"""
function get_auto_termination_policy(
    ClusterId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr(
        "GetAutoTerminationPolicy",
        Dict{String,Any}("ClusterId" => ClusterId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_auto_termination_policy(
    ClusterId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr(
        "GetAutoTerminationPolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ClusterId" => ClusterId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_block_public_access_configuration()
    get_block_public_access_configuration(params::Dict{String,<:Any})

Returns the Amazon EMR block public access configuration for your Amazon Web Services
account in the current Region. For more information see Configure Block Public Access for
Amazon EMR in the Amazon EMR Management Guide.

"""
function get_block_public_access_configuration(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr(
        "GetBlockPublicAccessConfiguration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_block_public_access_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr(
        "GetBlockPublicAccessConfiguration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_cluster_session_credentials(cluster_id)
    get_cluster_session_credentials(cluster_id, params::Dict{String,<:Any})

Provides temporary, HTTP basic credentials that are associated with a given runtime IAM
role and used by a cluster with fine-grained access control activated. You can use these
credentials to connect to cluster endpoints that support username and password
authentication.

# Arguments
- `cluster_id`: The unique identifier of the cluster.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ExecutionRoleArn"`: The Amazon Resource Name (ARN) of the runtime role for interactive
  workload submission on the cluster. The runtime role can be a cross-account IAM role. The
  runtime role ARN is a combination of account ID, role name, and role type using the
  following format: arn:partition:service:region:account:resource.
"""
function get_cluster_session_credentials(
    ClusterId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr(
        "GetClusterSessionCredentials",
        Dict{String,Any}("ClusterId" => ClusterId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_cluster_session_credentials(
    ClusterId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr(
        "GetClusterSessionCredentials",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ClusterId" => ClusterId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_managed_scaling_policy(cluster_id)
    get_managed_scaling_policy(cluster_id, params::Dict{String,<:Any})

Fetches the attached managed scaling policy for an Amazon EMR cluster.

# Arguments
- `cluster_id`: Specifies the ID of the cluster for which the managed scaling policy will
  be fetched.

"""
function get_managed_scaling_policy(
    ClusterId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr(
        "GetManagedScalingPolicy",
        Dict{String,Any}("ClusterId" => ClusterId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_managed_scaling_policy(
    ClusterId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr(
        "GetManagedScalingPolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ClusterId" => ClusterId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_studio_session_mapping(identity_type, studio_id)
    get_studio_session_mapping(identity_type, studio_id, params::Dict{String,<:Any})

Fetches mapping details for the specified Amazon EMR Studio and identity (user or group).

# Arguments
- `identity_type`: Specifies whether the identity to fetch is a user or a group.
- `studio_id`: The ID of the Amazon EMR Studio.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"IdentityId"`: The globally unique identifier (GUID) of the user or group. For more
  information, see UserId and GroupId in the IAM Identity Center Identity Store API
  Reference. Either IdentityName or IdentityId must be specified.
- `"IdentityName"`: The name of the user or group to fetch. For more information, see
  UserName and DisplayName in the IAM Identity Center Identity Store API Reference. Either
  IdentityName or IdentityId must be specified.
"""
function get_studio_session_mapping(
    IdentityType, StudioId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr(
        "GetStudioSessionMapping",
        Dict{String,Any}("IdentityType" => IdentityType, "StudioId" => StudioId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_studio_session_mapping(
    IdentityType,
    StudioId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr(
        "GetStudioSessionMapping",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("IdentityType" => IdentityType, "StudioId" => StudioId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_bootstrap_actions(cluster_id)
    list_bootstrap_actions(cluster_id, params::Dict{String,<:Any})

Provides information about the bootstrap actions associated with a cluster.

# Arguments
- `cluster_id`: The cluster identifier for the bootstrap actions to list.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Marker"`: The pagination token that indicates the next set of results to retrieve.
"""
function list_bootstrap_actions(
    ClusterId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr(
        "ListBootstrapActions",
        Dict{String,Any}("ClusterId" => ClusterId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_bootstrap_actions(
    ClusterId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr(
        "ListBootstrapActions",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ClusterId" => ClusterId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_clusters()
    list_clusters(params::Dict{String,<:Any})

Provides the status of all clusters visible to this Amazon Web Services account. Allows you
to filter the list of clusters based on certain criteria; for example, filtering by cluster
creation date and time or by status. This call returns a maximum of 50 clusters in unsorted
order per call, but returns a marker to track the paging of the cluster list across
multiple ListClusters calls.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClusterStates"`: The cluster state filters to apply when listing clusters. Clusters
  that change state while this action runs may be not be returned as expected in the list of
  clusters.
- `"CreatedAfter"`: The creation date and time beginning value filter for listing clusters.
- `"CreatedBefore"`: The creation date and time end value filter for listing clusters.
- `"Marker"`: The pagination token that indicates the next set of results to retrieve.
"""
function list_clusters(; aws_config::AbstractAWSConfig=current_aws_config())
    return emr("ListClusters"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_clusters(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr(
        "ListClusters", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_instance_fleets(cluster_id)
    list_instance_fleets(cluster_id, params::Dict{String,<:Any})

Lists all available details about the instance fleets in a cluster.  The instance fleet
configuration is available only in Amazon EMR releases 4.8.0 and later, excluding 5.0.x
versions.

# Arguments
- `cluster_id`: The unique identifier of the cluster.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Marker"`: The pagination token that indicates the next set of results to retrieve.
"""
function list_instance_fleets(ClusterId; aws_config::AbstractAWSConfig=current_aws_config())
    return emr(
        "ListInstanceFleets",
        Dict{String,Any}("ClusterId" => ClusterId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_instance_fleets(
    ClusterId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr(
        "ListInstanceFleets",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ClusterId" => ClusterId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_instance_groups(cluster_id)
    list_instance_groups(cluster_id, params::Dict{String,<:Any})

Provides all available details about the instance groups in a cluster.

# Arguments
- `cluster_id`: The identifier of the cluster for which to list the instance groups.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Marker"`: The pagination token that indicates the next set of results to retrieve.
"""
function list_instance_groups(ClusterId; aws_config::AbstractAWSConfig=current_aws_config())
    return emr(
        "ListInstanceGroups",
        Dict{String,Any}("ClusterId" => ClusterId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_instance_groups(
    ClusterId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr(
        "ListInstanceGroups",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ClusterId" => ClusterId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_instances(cluster_id)
    list_instances(cluster_id, params::Dict{String,<:Any})

Provides information for all active Amazon EC2 instances and Amazon EC2 instances
terminated in the last 30 days, up to a maximum of 2,000. Amazon EC2 instances in any of
the following states are considered active: AWAITING_FULFILLMENT, PROVISIONING,
BOOTSTRAPPING, RUNNING.

# Arguments
- `cluster_id`: The identifier of the cluster for which to list the instances.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"InstanceFleetId"`: The unique identifier of the instance fleet.
- `"InstanceFleetType"`: The node type of the instance fleet. For example MASTER, CORE, or
  TASK.
- `"InstanceGroupId"`: The identifier of the instance group for which to list the instances.
- `"InstanceGroupTypes"`: The type of instance group for which to list the instances.
- `"InstanceStates"`: A list of instance states that will filter the instances returned
  with this request.
- `"Marker"`: The pagination token that indicates the next set of results to retrieve.
"""
function list_instances(ClusterId; aws_config::AbstractAWSConfig=current_aws_config())
    return emr(
        "ListInstances",
        Dict{String,Any}("ClusterId" => ClusterId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_instances(
    ClusterId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr(
        "ListInstances",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ClusterId" => ClusterId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_notebook_executions()
    list_notebook_executions(params::Dict{String,<:Any})

Provides summaries of all notebook executions. You can filter the list based on multiple
criteria such as status, time range, and editor id. Returns a maximum of 50 notebook
executions and a marker to track the paging of a longer notebook execution list across
multiple ListNotebookExecutions calls.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EditorId"`: The unique ID of the editor associated with the notebook execution.
- `"ExecutionEngineId"`: The unique ID of the execution engine.
- `"From"`: The beginning of time range filter for listing notebook executions. The default
  is the timestamp of 30 days ago.
- `"Marker"`: The pagination token, returned by a previous ListNotebookExecutions call,
  that indicates the start of the list for this ListNotebookExecutions call.
- `"Status"`: The status filter for listing notebook executions.    START_PENDING indicates
  that the cluster has received the execution request but execution has not begun.
  STARTING indicates that the execution is starting on the cluster.    RUNNING indicates that
  the execution is being processed by the cluster.    FINISHING indicates that execution
  processing is in the final stages.    FINISHED indicates that the execution has completed
  without error.    FAILING indicates that the execution is failing and will not finish
  successfully.    FAILED indicates that the execution failed.    STOP_PENDING indicates that
  the cluster has received a StopNotebookExecution request and the stop is pending.
  STOPPING indicates that the cluster is in the process of stopping the execution as a result
  of a StopNotebookExecution request.    STOPPED indicates that the execution stopped because
  of a StopNotebookExecution request.
- `"To"`: The end of time range filter for listing notebook executions. The default is the
  current timestamp.
"""
function list_notebook_executions(; aws_config::AbstractAWSConfig=current_aws_config())
    return emr(
        "ListNotebookExecutions"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_notebook_executions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr(
        "ListNotebookExecutions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_release_labels()
    list_release_labels(params::Dict{String,<:Any})

Retrieves release labels of Amazon EMR services in the Region where the API is called.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: Filters the results of the request. Prefix specifies the prefix of release
  labels to return. Application specifies the application (with/without version) of release
  labels to return.
- `"MaxResults"`: Defines the maximum number of release labels to return in a single
  response. The default is 100.
- `"NextToken"`: Specifies the next page of results. If NextToken is not specified, which
  is usually the case for the first request of ListReleaseLabels, the first page of results
  are determined by other filtering parameters or by the latest version. The
  ListReleaseLabels request fails if the identity (Amazon Web Services account ID) and all
  filtering parameters are different from the original request, or if the NextToken is
  expired or tampered with.
"""
function list_release_labels(; aws_config::AbstractAWSConfig=current_aws_config())
    return emr("ListReleaseLabels"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_release_labels(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr(
        "ListReleaseLabels", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_security_configurations()
    list_security_configurations(params::Dict{String,<:Any})

Lists all the security configurations visible to this account, providing their creation
dates and times, and their names. This call returns a maximum of 50 clusters per call, but
returns a marker to track the paging of the cluster list across multiple
ListSecurityConfigurations calls.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Marker"`: The pagination token that indicates the set of results to retrieve.
"""
function list_security_configurations(; aws_config::AbstractAWSConfig=current_aws_config())
    return emr(
        "ListSecurityConfigurations"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_security_configurations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr(
        "ListSecurityConfigurations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_steps(cluster_id)
    list_steps(cluster_id, params::Dict{String,<:Any})

Provides a list of steps for the cluster in reverse order unless you specify stepIds with
the request or filter by StepStates. You can specify a maximum of 10 stepIDs. The CLI
automatically paginates results to return a list greater than 50 steps. To return more than
50 steps using the CLI, specify a Marker, which is a pagination token that indicates the
next set of steps to retrieve.

# Arguments
- `cluster_id`: The identifier of the cluster for which to list the steps.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Marker"`: The maximum number of steps that a single ListSteps action returns is 50. To
  return a longer list of steps, use multiple ListSteps actions along with the Marker
  parameter, which is a pagination token that indicates the next set of results to retrieve.
- `"StepIds"`: The filter to limit the step list based on the identifier of the steps. You
  can specify a maximum of ten Step IDs. The character constraint applies to the overall
  length of the array.
- `"StepStates"`: The filter to limit the step list based on certain states.
"""
function list_steps(ClusterId; aws_config::AbstractAWSConfig=current_aws_config())
    return emr(
        "ListSteps",
        Dict{String,Any}("ClusterId" => ClusterId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_steps(
    ClusterId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr(
        "ListSteps",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ClusterId" => ClusterId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_studio_session_mappings()
    list_studio_session_mappings(params::Dict{String,<:Any})

Returns a list of all user or group session mappings for the Amazon EMR Studio specified by
StudioId.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"IdentityType"`: Specifies whether to return session mappings for users or groups. If
  not specified, the results include session mapping details for both users and groups.
- `"Marker"`: The pagination token that indicates the set of results to retrieve.
- `"StudioId"`: The ID of the Amazon EMR Studio.
"""
function list_studio_session_mappings(; aws_config::AbstractAWSConfig=current_aws_config())
    return emr(
        "ListStudioSessionMappings"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_studio_session_mappings(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr(
        "ListStudioSessionMappings",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_studios()
    list_studios(params::Dict{String,<:Any})

Returns a list of all Amazon EMR Studios associated with the Amazon Web Services account.
The list includes details such as ID, Studio Access URL, and creation time for each Studio.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Marker"`: The pagination token that indicates the set of results to retrieve.
"""
function list_studios(; aws_config::AbstractAWSConfig=current_aws_config())
    return emr("ListStudios"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_studios(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr(
        "ListStudios", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_supported_instance_types(release_label)
    list_supported_instance_types(release_label, params::Dict{String,<:Any})

A list of the instance types that Amazon EMR supports. You can filter the list by Amazon
Web Services Region and Amazon EMR release.

# Arguments
- `release_label`: The Amazon EMR release label determines the versions of open-source
  application packages that Amazon EMR has installed on the cluster. Release labels are in
  the format emr-x.x.x, where x.x.x is an Amazon EMR release number such as emr-6.10.0. For
  more information about Amazon EMR releases and their included application versions and
  features, see the  Amazon EMR Release Guide .

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Marker"`: The pagination token that marks the next set of results to retrieve.
"""
function list_supported_instance_types(
    ReleaseLabel; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr(
        "ListSupportedInstanceTypes",
        Dict{String,Any}("ReleaseLabel" => ReleaseLabel);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_supported_instance_types(
    ReleaseLabel,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr(
        "ListSupportedInstanceTypes",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ReleaseLabel" => ReleaseLabel), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    modify_cluster(cluster_id)
    modify_cluster(cluster_id, params::Dict{String,<:Any})

Modifies the number of steps that can be executed concurrently for the cluster specified
using ClusterID.

# Arguments
- `cluster_id`: The unique identifier of the cluster.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"StepConcurrencyLevel"`: The number of steps that can be executed concurrently. You can
  specify a minimum of 1 step and a maximum of 256 steps. We recommend that you do not change
  this parameter while steps are running or the ActionOnFailure setting may not behave as
  expected. For more information see StepActionOnFailure.
"""
function modify_cluster(ClusterId; aws_config::AbstractAWSConfig=current_aws_config())
    return emr(
        "ModifyCluster",
        Dict{String,Any}("ClusterId" => ClusterId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function modify_cluster(
    ClusterId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr(
        "ModifyCluster",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ClusterId" => ClusterId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    modify_instance_fleet(cluster_id, instance_fleet)
    modify_instance_fleet(cluster_id, instance_fleet, params::Dict{String,<:Any})

Modifies the target On-Demand and target Spot capacities for the instance fleet with the
specified InstanceFleetID within the cluster specified using ClusterID. The call either
succeeds or fails atomically.  The instance fleet configuration is available only in Amazon
EMR releases 4.8.0 and later, excluding 5.0.x versions.

# Arguments
- `cluster_id`: The unique identifier of the cluster.
- `instance_fleet`: The configuration parameters of the instance fleet.

"""
function modify_instance_fleet(
    ClusterId, InstanceFleet; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr(
        "ModifyInstanceFleet",
        Dict{String,Any}("ClusterId" => ClusterId, "InstanceFleet" => InstanceFleet);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function modify_instance_fleet(
    ClusterId,
    InstanceFleet,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr(
        "ModifyInstanceFleet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClusterId" => ClusterId, "InstanceFleet" => InstanceFleet
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    modify_instance_groups()
    modify_instance_groups(params::Dict{String,<:Any})

ModifyInstanceGroups modifies the number of nodes and configuration settings of an instance
group. The input parameters include the new target instance count for the group and the
instance group ID. The call will either succeed or fail atomically.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClusterId"`: The ID of the cluster to which the instance group belongs.
- `"InstanceGroups"`: Instance groups to change.
"""
function modify_instance_groups(; aws_config::AbstractAWSConfig=current_aws_config())
    return emr(
        "ModifyInstanceGroups"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function modify_instance_groups(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr(
        "ModifyInstanceGroups",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_auto_scaling_policy(auto_scaling_policy, cluster_id, instance_group_id)
    put_auto_scaling_policy(auto_scaling_policy, cluster_id, instance_group_id, params::Dict{String,<:Any})

Creates or updates an automatic scaling policy for a core instance group or task instance
group in an Amazon EMR cluster. The automatic scaling policy defines how an instance group
dynamically adds and terminates Amazon EC2 instances in response to the value of a
CloudWatch metric.

# Arguments
- `auto_scaling_policy`: Specifies the definition of the automatic scaling policy.
- `cluster_id`: Specifies the ID of a cluster. The instance group to which the automatic
  scaling policy is applied is within this cluster.
- `instance_group_id`: Specifies the ID of the instance group to which the automatic
  scaling policy is applied.

"""
function put_auto_scaling_policy(
    AutoScalingPolicy,
    ClusterId,
    InstanceGroupId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr(
        "PutAutoScalingPolicy",
        Dict{String,Any}(
            "AutoScalingPolicy" => AutoScalingPolicy,
            "ClusterId" => ClusterId,
            "InstanceGroupId" => InstanceGroupId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_auto_scaling_policy(
    AutoScalingPolicy,
    ClusterId,
    InstanceGroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr(
        "PutAutoScalingPolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AutoScalingPolicy" => AutoScalingPolicy,
                    "ClusterId" => ClusterId,
                    "InstanceGroupId" => InstanceGroupId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_auto_termination_policy(cluster_id)
    put_auto_termination_policy(cluster_id, params::Dict{String,<:Any})

 Auto-termination is supported in Amazon EMR releases 5.30.0 and 6.1.0 and later. For more
information, see Using an auto-termination policy.  Creates or updates an auto-termination
policy for an Amazon EMR cluster. An auto-termination policy defines the amount of idle
time in seconds after which a cluster automatically terminates. For alternative cluster
termination options, see Control cluster termination.

# Arguments
- `cluster_id`: Specifies the ID of the Amazon EMR cluster to which the auto-termination
  policy will be attached.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AutoTerminationPolicy"`: Specifies the auto-termination policy to attach to the cluster.
"""
function put_auto_termination_policy(
    ClusterId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr(
        "PutAutoTerminationPolicy",
        Dict{String,Any}("ClusterId" => ClusterId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_auto_termination_policy(
    ClusterId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr(
        "PutAutoTerminationPolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ClusterId" => ClusterId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_block_public_access_configuration(block_public_access_configuration)
    put_block_public_access_configuration(block_public_access_configuration, params::Dict{String,<:Any})

Creates or updates an Amazon EMR block public access configuration for your Amazon Web
Services account in the current Region. For more information see Configure Block Public
Access for Amazon EMR in the Amazon EMR Management Guide.

# Arguments
- `block_public_access_configuration`: A configuration for Amazon EMR block public access.
  The configuration applies to all clusters created in your account for the current Region.
  The configuration specifies whether block public access is enabled. If block public access
  is enabled, security groups associated with the cluster cannot have rules that allow
  inbound traffic from 0.0.0.0/0 or ::/0 on a port, unless the port is specified as an
  exception using PermittedPublicSecurityGroupRuleRanges in the
  BlockPublicAccessConfiguration. By default, Port 22 (SSH) is an exception, and public
  access is allowed on this port. You can change this by updating
  BlockPublicSecurityGroupRules to remove the exception.  For accounts that created clusters
  in a Region before November 25, 2019, block public access is disabled by default in that
  Region. To use this feature, you must manually enable and configure it. For accounts that
  did not create an Amazon EMR cluster in a Region before this date, block public access is
  enabled by default in that Region.

"""
function put_block_public_access_configuration(
    BlockPublicAccessConfiguration; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr(
        "PutBlockPublicAccessConfiguration",
        Dict{String,Any}(
            "BlockPublicAccessConfiguration" => BlockPublicAccessConfiguration
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_block_public_access_configuration(
    BlockPublicAccessConfiguration,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr(
        "PutBlockPublicAccessConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "BlockPublicAccessConfiguration" => BlockPublicAccessConfiguration
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_managed_scaling_policy(cluster_id, managed_scaling_policy)
    put_managed_scaling_policy(cluster_id, managed_scaling_policy, params::Dict{String,<:Any})

Creates or updates a managed scaling policy for an Amazon EMR cluster. The managed scaling
policy defines the limits for resources, such as Amazon EC2 instances that can be added or
terminated from a cluster. The policy only applies to the core and task nodes. The master
node cannot be scaled after initial configuration.

# Arguments
- `cluster_id`: Specifies the ID of an Amazon EMR cluster where the managed scaling policy
  is attached.
- `managed_scaling_policy`: Specifies the constraints for the managed scaling policy.

"""
function put_managed_scaling_policy(
    ClusterId, ManagedScalingPolicy; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr(
        "PutManagedScalingPolicy",
        Dict{String,Any}(
            "ClusterId" => ClusterId, "ManagedScalingPolicy" => ManagedScalingPolicy
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_managed_scaling_policy(
    ClusterId,
    ManagedScalingPolicy,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr(
        "PutManagedScalingPolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClusterId" => ClusterId, "ManagedScalingPolicy" => ManagedScalingPolicy
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_auto_scaling_policy(cluster_id, instance_group_id)
    remove_auto_scaling_policy(cluster_id, instance_group_id, params::Dict{String,<:Any})

Removes an automatic scaling policy from a specified instance group within an Amazon EMR
cluster.

# Arguments
- `cluster_id`: Specifies the ID of a cluster. The instance group to which the automatic
  scaling policy is applied is within this cluster.
- `instance_group_id`: Specifies the ID of the instance group to which the scaling policy
  is applied.

"""
function remove_auto_scaling_policy(
    ClusterId, InstanceGroupId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr(
        "RemoveAutoScalingPolicy",
        Dict{String,Any}("ClusterId" => ClusterId, "InstanceGroupId" => InstanceGroupId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_auto_scaling_policy(
    ClusterId,
    InstanceGroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr(
        "RemoveAutoScalingPolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClusterId" => ClusterId, "InstanceGroupId" => InstanceGroupId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_auto_termination_policy(cluster_id)
    remove_auto_termination_policy(cluster_id, params::Dict{String,<:Any})

Removes an auto-termination policy from an Amazon EMR cluster.

# Arguments
- `cluster_id`: Specifies the ID of the Amazon EMR cluster from which the auto-termination
  policy will be removed.

"""
function remove_auto_termination_policy(
    ClusterId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr(
        "RemoveAutoTerminationPolicy",
        Dict{String,Any}("ClusterId" => ClusterId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_auto_termination_policy(
    ClusterId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr(
        "RemoveAutoTerminationPolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ClusterId" => ClusterId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_managed_scaling_policy(cluster_id)
    remove_managed_scaling_policy(cluster_id, params::Dict{String,<:Any})

 Removes a managed scaling policy from a specified Amazon EMR cluster.

# Arguments
- `cluster_id`:  Specifies the ID of the cluster from which the managed scaling policy will
  be removed.

"""
function remove_managed_scaling_policy(
    ClusterId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr(
        "RemoveManagedScalingPolicy",
        Dict{String,Any}("ClusterId" => ClusterId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_managed_scaling_policy(
    ClusterId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr(
        "RemoveManagedScalingPolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ClusterId" => ClusterId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_tags(resource_id, tag_keys)
    remove_tags(resource_id, tag_keys, params::Dict{String,<:Any})

Removes tags from an Amazon EMR resource, such as a cluster or Amazon EMR Studio. Tags make
it easier to associate resources in various ways, such as grouping clusters to track your
Amazon EMR resource allocation costs. For more information, see Tag Clusters.  The
following example removes the stack tag with value Prod from a cluster:

# Arguments
- `resource_id`: The Amazon EMR resource identifier from which tags will be removed. For
  example, a cluster identifier or an Amazon EMR Studio ID.
- `tag_keys`: A list of tag keys to remove from the resource.

"""
function remove_tags(
    ResourceId, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr(
        "RemoveTags",
        Dict{String,Any}("ResourceId" => ResourceId, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_tags(
    ResourceId,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr(
        "RemoveTags",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceId" => ResourceId, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    run_job_flow(instances, name)
    run_job_flow(instances, name, params::Dict{String,<:Any})

RunJobFlow creates and starts running a new cluster (job flow). The cluster runs the steps
specified. After the steps complete, the cluster stops and the HDFS partition is lost. To
prevent loss of data, configure the last step of the job flow to store results in Amazon
S3. If the JobFlowInstancesConfig KeepJobFlowAliveWhenNoSteps parameter is set to TRUE, the
cluster transitions to the WAITING state rather than shutting down after the steps have
completed.  For additional protection, you can set the JobFlowInstancesConfig
TerminationProtected parameter to TRUE to lock the cluster and prevent it from being
terminated by API call, user intervention, or in the event of a job flow error. A maximum
of 256 steps are allowed in each job flow. If your cluster is long-running (such as a Hive
data warehouse) or complex, you may require more than 256 steps to process your data. You
can bypass the 256-step limitation in various ways, including using the SSH shell to
connect to the master node and submitting queries directly to the software running on the
master node, such as Hive and Hadoop. For long-running clusters, we recommend that you
periodically store your results.  The instance fleets configuration is available only in
Amazon EMR releases 4.8.0 and later, excluding 5.0.x versions. The RunJobFlow request can
contain InstanceFleets parameters or InstanceGroups parameters, but not both.

# Arguments
- `instances`: A specification of the number and type of Amazon EC2 instances.
- `name`: The name of the job flow.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AdditionalInfo"`: A JSON string for selecting additional features.
- `"AmiVersion"`: Applies only to Amazon EMR AMI versions 3.x and 2.x. For Amazon EMR
  releases 4.0 and later, ReleaseLabel is used. To specify a custom AMI, use CustomAmiID.
- `"Applications"`: Applies to Amazon EMR releases 4.0 and later. A case-insensitive list
  of applications for Amazon EMR to install and configure when launching the cluster. For a
  list of applications available for each Amazon EMR release version, see the Amazon
  EMRRelease Guide.
- `"AutoScalingRole"`: An IAM role for automatic scaling policies. The default role is
  EMR_AutoScaling_DefaultRole. The IAM role provides permissions that the automatic scaling
  feature requires to launch and terminate Amazon EC2 instances in an instance group.
- `"AutoTerminationPolicy"`:
- `"BootstrapActions"`: A list of bootstrap actions to run before Hadoop starts on the
  cluster nodes.
- `"Configurations"`: For Amazon EMR releases 4.0 and later. The list of configurations
  supplied for the Amazon EMR cluster that you are creating.
- `"CustomAmiId"`: Available only in Amazon EMR releases 5.7.0 and later. The ID of a
  custom Amazon EBS-backed Linux AMI. If specified, Amazon EMR uses this AMI when it launches
  cluster Amazon EC2 instances. For more information about custom AMIs in Amazon EMR, see
  Using a Custom AMI in the Amazon EMR Management Guide. If omitted, the cluster uses the
  base Linux AMI for the ReleaseLabel specified. For Amazon EMR releases 2.x and 3.x, use
  AmiVersion instead. For information about creating a custom AMI, see Creating an Amazon
  EBS-Backed Linux AMI in the Amazon Elastic Compute Cloud User Guide for Linux Instances.
  For information about finding an AMI ID, see Finding a Linux AMI.
- `"EbsRootVolumeIops"`: The IOPS, of the Amazon EBS root device volume of the Linux AMI
  that is used for each Amazon EC2 instance. Available in Amazon EMR releases 6.15.0 and
  later.
- `"EbsRootVolumeSize"`: The size, in GiB, of the Amazon EBS root device volume of the
  Linux AMI that is used for each Amazon EC2 instance. Available in Amazon EMR releases 4.x
  and later.
- `"EbsRootVolumeThroughput"`: The throughput, in MiB/s, of the Amazon EBS root device
  volume of the Linux AMI that is used for each Amazon EC2 instance. Available in Amazon EMR
  releases 6.15.0 and later.
- `"JobFlowRole"`: Also called instance profile and Amazon EC2 role. An IAM role for an
  Amazon EMR cluster. The Amazon EC2 instances of the cluster assume this role. The default
  role is EMR_EC2_DefaultRole. In order to use the default role, you must have already
  created it using the CLI or console.
- `"KerberosAttributes"`: Attributes for Kerberos configuration when Kerberos
  authentication is enabled using a security configuration. For more information see Use
  Kerberos Authentication in the Amazon EMR Management Guide.
- `"LogEncryptionKmsKeyId"`: The KMS key used for encrypting log files. If a value is not
  provided, the logs remain encrypted by AES-256. This attribute is only available with
  Amazon EMR releases 5.30.0 and later, excluding Amazon EMR 6.0.0.
- `"LogUri"`: The location in Amazon S3 to write the log files of the job flow. If a value
  is not provided, logs are not created.
- `"ManagedScalingPolicy"`:  The specified managed scaling policy for an Amazon EMR
  cluster.
- `"NewSupportedProducts"`:  For Amazon EMR releases 3.x and 2.x. For Amazon EMR releases
  4.x and later, use Applications.  A list of strings that indicates third-party software to
  use with the job flow that accepts a user argument list. Amazon EMR accepts and forwards
  the argument list to the corresponding installation script as bootstrap action arguments.
  For more information, see \"Launch a Job Flow on the MapR Distribution for Hadoop\" in the
  Amazon EMR Developer Guide. Supported values are:   \"mapr-m3\" - launch the cluster using
  MapR M3 Edition.   \"mapr-m5\" - launch the cluster using MapR M5 Edition.   \"mapr\" with
  the user arguments specifying \"--edition,m3\" or \"--edition,m5\" - launch the job flow
  using MapR M3 or M5 Edition respectively.   \"mapr-m7\" - launch the cluster using MapR M7
  Edition.   \"hunk\" - launch the cluster with the Hunk Big Data Analytics Platform.
  \"hue\"- launch the cluster with Hue installed.   \"spark\" - launch the cluster with
  Apache Spark installed.   \"ganglia\" - launch the cluster with the Ganglia Monitoring
  System installed.
- `"OSReleaseLabel"`: Specifies a particular Amazon Linux release for all nodes in a
  cluster launch RunJobFlow request. If a release is not specified, Amazon EMR uses the
  latest validated Amazon Linux release for cluster launch.
- `"PlacementGroupConfigs"`: The specified placement group configuration for an Amazon EMR
  cluster.
- `"ReleaseLabel"`: The Amazon EMR release label, which determines the version of
  open-source application packages installed on the cluster. Release labels are in the form
  emr-x.x.x, where x.x.x is an Amazon EMR release version such as emr-5.14.0. For more
  information about Amazon EMR release versions and included application versions and
  features, see https://docs.aws.amazon.com/emr/latest/ReleaseGuide/. The release label
  applies only to Amazon EMR releases version 4.0 and later. Earlier versions use AmiVersion.
- `"RepoUpgradeOnBoot"`: Applies only when CustomAmiID is used. Specifies which updates
  from the Amazon Linux AMI package repositories to apply automatically when the instance
  boots using the AMI. If omitted, the default is SECURITY, which indicates that only
  security updates are applied. If NONE is specified, no updates are applied, and all updates
  must be applied manually.
- `"ScaleDownBehavior"`: Specifies the way that individual Amazon EC2 instances terminate
  when an automatic scale-in activity occurs or an instance group is resized.
  TERMINATE_AT_INSTANCE_HOUR indicates that Amazon EMR terminates nodes at the instance-hour
  boundary, regardless of when the request to terminate the instance was submitted. This
  option is only available with Amazon EMR 5.1.0 and later and is the default for clusters
  created using that version. TERMINATE_AT_TASK_COMPLETION indicates that Amazon EMR adds
  nodes to a deny list and drains tasks from nodes before terminating the Amazon EC2
  instances, regardless of the instance-hour boundary. With either behavior, Amazon EMR
  removes the least active nodes first and blocks instance termination if it could lead to
  HDFS corruption. TERMINATE_AT_TASK_COMPLETION available only in Amazon EMR releases 4.1.0
  and later, and is the default for releases of Amazon EMR earlier than 5.1.0.
- `"SecurityConfiguration"`: The name of a security configuration to apply to the cluster.
- `"ServiceRole"`: The IAM role that Amazon EMR assumes in order to access Amazon Web
  Services resources on your behalf. If you've created a custom service role path, you must
  specify it for the service role when you launch your cluster.
- `"StepConcurrencyLevel"`: Specifies the number of steps that can be executed
  concurrently. The default value is 1. The maximum value is 256.
- `"Steps"`: A list of steps to run.
- `"SupportedProducts"`:  For Amazon EMR releases 3.x and 2.x. For Amazon EMR releases 4.x
  and later, use Applications.  A list of strings that indicates third-party software to use.
  For more information, see the Amazon EMR Developer Guide. Currently supported values are:
  \"mapr-m3\" - launch the job flow using MapR M3 Edition.   \"mapr-m5\" - launch the job
  flow using MapR M5 Edition.
- `"Tags"`: A list of tags to associate with a cluster and propagate to Amazon EC2
  instances.
- `"VisibleToAllUsers"`:  The VisibleToAllUsers parameter is no longer supported. By
  default, the value is set to true. Setting it to false now has no effect.  Set this value
  to true so that IAM principals in the Amazon Web Services account associated with the
  cluster can perform Amazon EMR actions on the cluster that their IAM policies allow. This
  value defaults to true for clusters created using the Amazon EMR API or the CLI
  create-cluster command. When set to false, only the IAM principal that created the cluster
  and the Amazon Web Services account root user can perform Amazon EMR actions for the
  cluster, regardless of the IAM permissions policies attached to other IAM principals. For
  more information, see Understanding the Amazon EMR cluster VisibleToAllUsers setting in the
  Amazon EMR Management Guide.
"""
function run_job_flow(Instances, Name; aws_config::AbstractAWSConfig=current_aws_config())
    return emr(
        "RunJobFlow",
        Dict{String,Any}("Instances" => Instances, "Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function run_job_flow(
    Instances,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr(
        "RunJobFlow",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("Instances" => Instances, "Name" => Name), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    set_keep_job_flow_alive_when_no_steps(job_flow_ids, keep_job_flow_alive_when_no_steps)
    set_keep_job_flow_alive_when_no_steps(job_flow_ids, keep_job_flow_alive_when_no_steps, params::Dict{String,<:Any})

You can use the SetKeepJobFlowAliveWhenNoSteps to configure a cluster (job flow) to
terminate after the step execution, i.e., all your steps are executed. If you want a
transient cluster that shuts down after the last of the current executing steps are
completed, you can configure SetKeepJobFlowAliveWhenNoSteps to false. If you want a long
running cluster, configure SetKeepJobFlowAliveWhenNoSteps to true. For more information,
see Managing Cluster Termination in the Amazon EMR Management Guide.

# Arguments
- `job_flow_ids`: A list of strings that uniquely identify the clusters to protect. This
  identifier is returned by RunJobFlow and can also be obtained from DescribeJobFlows.
- `keep_job_flow_alive_when_no_steps`: A Boolean that indicates whether to terminate the
  cluster after all steps are executed.

"""
function set_keep_job_flow_alive_when_no_steps(
    JobFlowIds,
    KeepJobFlowAliveWhenNoSteps;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr(
        "SetKeepJobFlowAliveWhenNoSteps",
        Dict{String,Any}(
            "JobFlowIds" => JobFlowIds,
            "KeepJobFlowAliveWhenNoSteps" => KeepJobFlowAliveWhenNoSteps,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function set_keep_job_flow_alive_when_no_steps(
    JobFlowIds,
    KeepJobFlowAliveWhenNoSteps,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr(
        "SetKeepJobFlowAliveWhenNoSteps",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "JobFlowIds" => JobFlowIds,
                    "KeepJobFlowAliveWhenNoSteps" => KeepJobFlowAliveWhenNoSteps,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    set_termination_protection(job_flow_ids, termination_protected)
    set_termination_protection(job_flow_ids, termination_protected, params::Dict{String,<:Any})

SetTerminationProtection locks a cluster (job flow) so the Amazon EC2 instances in the
cluster cannot be terminated by user intervention, an API call, or in the event of a
job-flow error. The cluster still terminates upon successful completion of the job flow.
Calling SetTerminationProtection on a cluster is similar to calling the Amazon EC2
DisableAPITermination API on all Amazon EC2 instances in a cluster.
SetTerminationProtection is used to prevent accidental termination of a cluster and to
ensure that in the event of an error, the instances persist so that you can recover any
data stored in their ephemeral instance storage.  To terminate a cluster that has been
locked by setting SetTerminationProtection to true, you must first unlock the job flow by a
subsequent call to SetTerminationProtection in which you set the value to false.   For more
information, see Managing Cluster Termination in the Amazon EMR Management Guide.

# Arguments
- `job_flow_ids`:  A list of strings that uniquely identify the clusters to protect. This
  identifier is returned by RunJobFlow and can also be obtained from DescribeJobFlows .
- `termination_protected`: A Boolean that indicates whether to protect the cluster and
  prevent the Amazon EC2 instances in the cluster from shutting down due to API calls, user
  intervention, or job-flow error.

"""
function set_termination_protection(
    JobFlowIds, TerminationProtected; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr(
        "SetTerminationProtection",
        Dict{String,Any}(
            "JobFlowIds" => JobFlowIds, "TerminationProtected" => TerminationProtected
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function set_termination_protection(
    JobFlowIds,
    TerminationProtected,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr(
        "SetTerminationProtection",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "JobFlowIds" => JobFlowIds,
                    "TerminationProtected" => TerminationProtected,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    set_unhealthy_node_replacement(job_flow_ids, unhealthy_node_replacement)
    set_unhealthy_node_replacement(job_flow_ids, unhealthy_node_replacement, params::Dict{String,<:Any})

Specify whether to enable unhealthy node replacement, which lets Amazon EMR gracefully
replace core nodes on a cluster if any nodes become unhealthy. For example, a node becomes
unhealthy if disk usage is above 90%. If unhealthy node replacement is on and
TerminationProtected are off, Amazon EMR immediately terminates the unhealthy core nodes.
To use unhealthy node replacement and retain unhealthy core nodes, use to turn on
termination protection. In such cases, Amazon EMR adds the unhealthy nodes to a denylist,
reducing job interruptions and failures. If unhealthy node replacement is on, Amazon EMR
notifies YARN and other applications on the cluster to stop scheduling tasks with these
nodes, moves the data, and then terminates the nodes. For more information, see graceful
node replacement in the Amazon EMR Management Guide.

# Arguments
- `job_flow_ids`: The list of strings that uniquely identify the clusters for which to turn
  on unhealthy node replacement. You can get these identifiers by running the RunJobFlow or
  the DescribeJobFlows operations.
- `unhealthy_node_replacement`: Indicates whether to turn on or turn off graceful unhealthy
  node replacement.

"""
function set_unhealthy_node_replacement(
    JobFlowIds, UnhealthyNodeReplacement; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr(
        "SetUnhealthyNodeReplacement",
        Dict{String,Any}(
            "JobFlowIds" => JobFlowIds,
            "UnhealthyNodeReplacement" => UnhealthyNodeReplacement,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function set_unhealthy_node_replacement(
    JobFlowIds,
    UnhealthyNodeReplacement,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr(
        "SetUnhealthyNodeReplacement",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "JobFlowIds" => JobFlowIds,
                    "UnhealthyNodeReplacement" => UnhealthyNodeReplacement,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    set_visible_to_all_users(job_flow_ids, visible_to_all_users)
    set_visible_to_all_users(job_flow_ids, visible_to_all_users, params::Dict{String,<:Any})

 The SetVisibleToAllUsers parameter is no longer supported. Your cluster may be visible to
all users in your account. To restrict cluster access using an IAM policy, see Identity and
Access Management for Amazon EMR.   Sets the ClusterVisibleToAllUsers value for an Amazon
EMR cluster. When true, IAM principals in the Amazon Web Services account can perform
Amazon EMR cluster actions that their IAM policies allow. When false, only the IAM
principal that created the cluster and the Amazon Web Services account root user can
perform Amazon EMR actions on the cluster, regardless of IAM permissions policies attached
to other IAM principals. This action works on running clusters. When you create a cluster,
use the RunJobFlowInputVisibleToAllUsers parameter. For more information, see Understanding
the Amazon EMR Cluster VisibleToAllUsers Setting in the Amazon EMR Management Guide.

# Arguments
- `job_flow_ids`: The unique identifier of the job flow (cluster).
- `visible_to_all_users`: A value of true indicates that an IAM principal in the Amazon Web
  Services account can perform Amazon EMR actions on the cluster that the IAM policies
  attached to the principal allow. A value of false indicates that only the IAM principal
  that created the cluster and the Amazon Web Services root user can perform Amazon EMR
  actions on the cluster.

"""
function set_visible_to_all_users(
    JobFlowIds, VisibleToAllUsers; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr(
        "SetVisibleToAllUsers",
        Dict{String,Any}(
            "JobFlowIds" => JobFlowIds, "VisibleToAllUsers" => VisibleToAllUsers
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function set_visible_to_all_users(
    JobFlowIds,
    VisibleToAllUsers,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr(
        "SetVisibleToAllUsers",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "JobFlowIds" => JobFlowIds, "VisibleToAllUsers" => VisibleToAllUsers
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_notebook_execution(execution_engine, service_role)
    start_notebook_execution(execution_engine, service_role, params::Dict{String,<:Any})

Starts a notebook execution.

# Arguments
- `execution_engine`: Specifies the execution engine (cluster) that runs the notebook
  execution.
- `service_role`: The name or ARN of the IAM role that is used as the service role for
  Amazon EMR (the Amazon EMR role) for the notebook execution.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EditorId"`: The unique identifier of the Amazon EMR Notebook to use for notebook
  execution.
- `"EnvironmentVariables"`: The environment variables associated with the notebook
  execution.
- `"NotebookExecutionName"`: An optional name for the notebook execution.
- `"NotebookInstanceSecurityGroupId"`: The unique identifier of the Amazon EC2 security
  group to associate with the Amazon EMR Notebook for this notebook execution.
- `"NotebookParams"`: Input parameters in JSON format passed to the Amazon EMR Notebook at
  runtime for execution.
- `"NotebookS3Location"`: The Amazon S3 location for the notebook execution input.
- `"OutputNotebookFormat"`: The output format for the notebook execution.
- `"OutputNotebookS3Location"`: The Amazon S3 location for the notebook execution output.
- `"RelativePath"`: The path and file name of the notebook file for this execution,
  relative to the path specified for the Amazon EMR Notebook. For example, if you specify a
  path of s3://MyBucket/MyNotebooks when you create an Amazon EMR Notebook for a notebook
  with an ID of e-ABCDEFGHIJK1234567890ABCD (the EditorID of this request), and you specify a
  RelativePath of my_notebook_executions/notebook_execution.ipynb, the location of the file
  for the notebook execution is
  s3://MyBucket/MyNotebooks/e-ABCDEFGHIJK1234567890ABCD/my_notebook_executions/notebook_execut
  ion.ipynb.
- `"Tags"`: A list of tags associated with a notebook execution. Tags are user-defined
  key-value pairs that consist of a required key string with a maximum of 128 characters and
  an optional value string with a maximum of 256 characters.
"""
function start_notebook_execution(
    ExecutionEngine, ServiceRole; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr(
        "StartNotebookExecution",
        Dict{String,Any}(
            "ExecutionEngine" => ExecutionEngine, "ServiceRole" => ServiceRole
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_notebook_execution(
    ExecutionEngine,
    ServiceRole,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr(
        "StartNotebookExecution",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ExecutionEngine" => ExecutionEngine, "ServiceRole" => ServiceRole
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_notebook_execution(notebook_execution_id)
    stop_notebook_execution(notebook_execution_id, params::Dict{String,<:Any})

Stops a notebook execution.

# Arguments
- `notebook_execution_id`: The unique identifier of the notebook execution.

"""
function stop_notebook_execution(
    NotebookExecutionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr(
        "StopNotebookExecution",
        Dict{String,Any}("NotebookExecutionId" => NotebookExecutionId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_notebook_execution(
    NotebookExecutionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr(
        "StopNotebookExecution",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("NotebookExecutionId" => NotebookExecutionId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    terminate_job_flows(job_flow_ids)
    terminate_job_flows(job_flow_ids, params::Dict{String,<:Any})

TerminateJobFlows shuts a list of clusters (job flows) down. When a job flow is shut down,
any step not yet completed is canceled and the Amazon EC2 instances on which the cluster is
running are stopped. Any log files not already saved are uploaded to Amazon S3 if a LogUri
was specified when the cluster was created. The maximum number of clusters allowed is 10.
The call to TerminateJobFlows is asynchronous. Depending on the configuration of the
cluster, it may take up to 1-5 minutes for the cluster to completely terminate and release
allocated resources, such as Amazon EC2 instances.

# Arguments
- `job_flow_ids`: A list of job flows to be shut down.

"""
function terminate_job_flows(JobFlowIds; aws_config::AbstractAWSConfig=current_aws_config())
    return emr(
        "TerminateJobFlows",
        Dict{String,Any}("JobFlowIds" => JobFlowIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function terminate_job_flows(
    JobFlowIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr(
        "TerminateJobFlows",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("JobFlowIds" => JobFlowIds), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_studio(studio_id)
    update_studio(studio_id, params::Dict{String,<:Any})

Updates an Amazon EMR Studio configuration, including attributes such as name, description,
and subnets.

# Arguments
- `studio_id`: The ID of the Amazon EMR Studio to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DefaultS3Location"`: The Amazon S3 location to back up Workspaces and notebook files
  for the Amazon EMR Studio.
- `"Description"`: A detailed description to assign to the Amazon EMR Studio.
- `"EncryptionKeyArn"`: The KMS key identifier (ARN) used to encrypt Amazon EMR Studio
  workspace and notebook files when backed up to Amazon S3.
- `"Name"`: A descriptive name for the Amazon EMR Studio.
- `"SubnetIds"`: A list of subnet IDs to associate with the Amazon EMR Studio. The list can
  include new subnet IDs, but must also include all of the subnet IDs previously associated
  with the Studio. The list order does not matter. A Studio can have a maximum of 5 subnets.
  The subnets must belong to the same VPC as the Studio.
"""
function update_studio(StudioId; aws_config::AbstractAWSConfig=current_aws_config())
    return emr(
        "UpdateStudio",
        Dict{String,Any}("StudioId" => StudioId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_studio(
    StudioId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr(
        "UpdateStudio",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("StudioId" => StudioId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_studio_session_mapping(identity_type, session_policy_arn, studio_id)
    update_studio_session_mapping(identity_type, session_policy_arn, studio_id, params::Dict{String,<:Any})

Updates the session policy attached to the user or group for the specified Amazon EMR
Studio.

# Arguments
- `identity_type`: Specifies whether the identity to update is a user or a group.
- `session_policy_arn`: The Amazon Resource Name (ARN) of the session policy to associate
  with the specified user or group.
- `studio_id`: The ID of the Amazon EMR Studio.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"IdentityId"`: The globally unique identifier (GUID) of the user or group. For more
  information, see UserId and GroupId in the IAM Identity Center Identity Store API
  Reference. Either IdentityName or IdentityId must be specified.
- `"IdentityName"`: The name of the user or group to update. For more information, see
  UserName and DisplayName in the IAM Identity Center Identity Store API Reference. Either
  IdentityName or IdentityId must be specified.
"""
function update_studio_session_mapping(
    IdentityType,
    SessionPolicyArn,
    StudioId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr(
        "UpdateStudioSessionMapping",
        Dict{String,Any}(
            "IdentityType" => IdentityType,
            "SessionPolicyArn" => SessionPolicyArn,
            "StudioId" => StudioId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_studio_session_mapping(
    IdentityType,
    SessionPolicyArn,
    StudioId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr(
        "UpdateStudioSessionMapping",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "IdentityType" => IdentityType,
                    "SessionPolicyArn" => SessionPolicyArn,
                    "StudioId" => StudioId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: vpc_lattice
using AWS.Compat
using AWS.UUIDs

"""
    batch_update_rule(listener_identifier, rules, service_identifier)
    batch_update_rule(listener_identifier, rules, service_identifier, params::Dict{String,<:Any})

Updates the listener rules in a batch. You can use this operation to change the priority of
listener rules. This can be useful when bulk updating or swapping rule priority.  Required
permissions: vpc-lattice:UpdateRule  For more information, see How Amazon VPC Lattice works
with IAM in the Amazon VPC Lattice User Guide.

# Arguments
- `listener_identifier`: The ID or Amazon Resource Name (ARN) of the listener.
- `rules`: The rules for the specified listener.
- `service_identifier`: The ID or Amazon Resource Name (ARN) of the service.

"""
function batch_update_rule(
    listenerIdentifier,
    rules,
    serviceIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "PATCH",
        "/services/$(serviceIdentifier)/listeners/$(listenerIdentifier)/rules",
        Dict{String,Any}("rules" => rules);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_update_rule(
    listenerIdentifier,
    rules,
    serviceIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "PATCH",
        "/services/$(serviceIdentifier)/listeners/$(listenerIdentifier)/rules",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("rules" => rules), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_access_log_subscription(destination_arn, resource_identifier)
    create_access_log_subscription(destination_arn, resource_identifier, params::Dict{String,<:Any})

Enables access logs to be sent to Amazon CloudWatch, Amazon S3, and Amazon Kinesis Data
Firehose. The service network owner can use the access logs to audit the services in the
network. The service network owner can only see access logs from clients and services that
are associated with their service network. Access log entries represent traffic originated
from VPCs associated with that network. For more information, see Access logs in the Amazon
VPC Lattice User Guide.

# Arguments
- `destination_arn`: The Amazon Resource Name (ARN) of the destination. The supported
  destination types are CloudWatch Log groups, Kinesis Data Firehose delivery streams, and
  Amazon S3 buckets.
- `resource_identifier`: The ID or Amazon Resource Name (ARN) of the service network or
  service.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If you retry a request that completed successfully using the
  same client token and parameters, the retry succeeds without performing any actions. If the
  parameters aren't identical, the retry fails.
- `"tags"`: The tags for the access log subscription.
"""
function create_access_log_subscription(
    destinationArn, resourceIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return vpc_lattice(
        "POST",
        "/accesslogsubscriptions",
        Dict{String,Any}(
            "destinationArn" => destinationArn,
            "resourceIdentifier" => resourceIdentifier,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_access_log_subscription(
    destinationArn,
    resourceIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "POST",
        "/accesslogsubscriptions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "destinationArn" => destinationArn,
                    "resourceIdentifier" => resourceIdentifier,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_listener(default_action, name, protocol, service_identifier)
    create_listener(default_action, name, protocol, service_identifier, params::Dict{String,<:Any})

Creates a listener for a service. Before you start using your Amazon VPC Lattice service,
you must add one or more listeners. A listener is a process that checks for connection
requests to your services. For more information, see Listeners in the Amazon VPC Lattice
User Guide.

# Arguments
- `default_action`: The action for the default rule. Each listener has a default rule. The
  default rule is used if no other rules match.
- `name`: The name of the listener. A listener name must be unique within a service. The
  valid characters are a-z, 0-9, and hyphens (-). You can't use a hyphen as the first or last
  character, or immediately after another hyphen.
- `protocol`: The listener protocol.
- `service_identifier`: The ID or Amazon Resource Name (ARN) of the service.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If you retry a request that completed successfully using the
  same client token and parameters, the retry succeeds without performing any actions. If the
  parameters aren't identical, the retry fails.
- `"port"`: The listener port. You can specify a value from 1 to 65535. For HTTP, the
  default is 80. For HTTPS, the default is 443.
- `"tags"`: The tags for the listener.
"""
function create_listener(
    defaultAction,
    name,
    protocol,
    serviceIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "POST",
        "/services/$(serviceIdentifier)/listeners",
        Dict{String,Any}(
            "defaultAction" => defaultAction,
            "name" => name,
            "protocol" => protocol,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_listener(
    defaultAction,
    name,
    protocol,
    serviceIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "POST",
        "/services/$(serviceIdentifier)/listeners",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "defaultAction" => defaultAction,
                    "name" => name,
                    "protocol" => protocol,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_rule(action, listener_identifier, match, name, priority, service_identifier)
    create_rule(action, listener_identifier, match, name, priority, service_identifier, params::Dict{String,<:Any})

Creates a listener rule. Each listener has a default rule for checking connection requests,
but you can define additional rules. Each rule consists of a priority, one or more actions,
and one or more conditions. For more information, see Listener rules in the Amazon VPC
Lattice User Guide.

# Arguments
- `action`: The action for the default rule.
- `listener_identifier`: The ID or Amazon Resource Name (ARN) of the listener.
- `match`: The rule match.
- `name`: The name of the rule. The name must be unique within the listener. The valid
  characters are a-z, 0-9, and hyphens (-). You can't use a hyphen as the first or last
  character, or immediately after another hyphen.
- `priority`: The priority assigned to the rule. Each rule for a specific listener must
  have a unique priority. The lower the priority number the higher the priority.
- `service_identifier`: The ID or Amazon Resource Name (ARN) of the service.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If you retry a request that completed successfully using the
  same client token and parameters, the retry succeeds without performing any actions. If the
  parameters aren't identical, the retry fails.
- `"tags"`: The tags for the rule.
"""
function create_rule(
    action,
    listenerIdentifier,
    match,
    name,
    priority,
    serviceIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "POST",
        "/services/$(serviceIdentifier)/listeners/$(listenerIdentifier)/rules",
        Dict{String,Any}(
            "action" => action,
            "match" => match,
            "name" => name,
            "priority" => priority,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_rule(
    action,
    listenerIdentifier,
    match,
    name,
    priority,
    serviceIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "POST",
        "/services/$(serviceIdentifier)/listeners/$(listenerIdentifier)/rules",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "action" => action,
                    "match" => match,
                    "name" => name,
                    "priority" => priority,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_service(name)
    create_service(name, params::Dict{String,<:Any})

Creates a service. A service is any software application that can run on instances
containers, or serverless functions within an account or virtual private cloud (VPC). For
more information, see Services in the Amazon VPC Lattice User Guide.

# Arguments
- `name`: The name of the service. The name must be unique within the account. The valid
  characters are a-z, 0-9, and hyphens (-). You can't use a hyphen as the first or last
  character, or immediately after another hyphen.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"authType"`: The type of IAM policy.    NONE: The resource does not use an IAM policy.
  This is the default.    AWS_IAM: The resource uses an IAM policy. When this type is used,
  auth is enabled and an auth policy is required.
- `"certificateArn"`: The Amazon Resource Name (ARN) of the certificate.
- `"clientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If you retry a request that completed successfully using the
  same client token and parameters, the retry succeeds without performing any actions. If the
  parameters aren't identical, the retry fails.
- `"customDomainName"`: The custom domain name of the service.
- `"tags"`: The tags for the service.
"""
function create_service(name; aws_config::AbstractAWSConfig=current_aws_config())
    return vpc_lattice(
        "POST",
        "/services",
        Dict{String,Any}("name" => name, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_service(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return vpc_lattice(
        "POST",
        "/services",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("name" => name, "clientToken" => string(uuid4())),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_service_network(name)
    create_service_network(name, params::Dict{String,<:Any})

Creates a service network. A service network is a logical boundary for a collection of
services. You can associate services and VPCs with a service network. For more information,
see Service networks in the Amazon VPC Lattice User Guide.

# Arguments
- `name`: The name of the service network. The name must be unique to the account. The
  valid characters are a-z, 0-9, and hyphens (-). You can't use a hyphen as the first or last
  character, or immediately after another hyphen.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"authType"`: The type of IAM policy.    NONE: The resource does not use an IAM policy.
  This is the default.    AWS_IAM: The resource uses an IAM policy. When this type is used,
  auth is enabled and an auth policy is required.
- `"clientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If you retry a request that completed successfully using the
  same client token and parameters, the retry succeeds without performing any actions. If the
  parameters aren't identical, the retry fails.
- `"tags"`: The tags for the service network.
"""
function create_service_network(name; aws_config::AbstractAWSConfig=current_aws_config())
    return vpc_lattice(
        "POST",
        "/servicenetworks",
        Dict{String,Any}("name" => name, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_service_network(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return vpc_lattice(
        "POST",
        "/servicenetworks",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("name" => name, "clientToken" => string(uuid4())),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_service_network_service_association(service_identifier, service_network_identifier)
    create_service_network_service_association(service_identifier, service_network_identifier, params::Dict{String,<:Any})

Associates a service with a service network. For more information, see Manage service
associations in the Amazon VPC Lattice User Guide. You can't use this operation if the
service and service network are already associated or if there is a disassociation or
deletion in progress. If the association fails, you can retry the operation by deleting the
association and recreating it. You cannot associate a service and service network that are
shared with a caller. The caller must own either the service or the service network. As a
result of this operation, the association is created in the service network account and the
association owner account.

# Arguments
- `service_identifier`: The ID or Amazon Resource Name (ARN) of the service.
- `service_network_identifier`: The ID or Amazon Resource Name (ARN) of the service
  network. You must use the ARN if the resources specified in the operation are in different
  accounts.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If you retry a request that completed successfully using the
  same client token and parameters, the retry succeeds without performing any actions. If the
  parameters aren't identical, the retry fails.
- `"tags"`: The tags for the association.
"""
function create_service_network_service_association(
    serviceIdentifier,
    serviceNetworkIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "POST",
        "/servicenetworkserviceassociations",
        Dict{String,Any}(
            "serviceIdentifier" => serviceIdentifier,
            "serviceNetworkIdentifier" => serviceNetworkIdentifier,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_service_network_service_association(
    serviceIdentifier,
    serviceNetworkIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "POST",
        "/servicenetworkserviceassociations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "serviceIdentifier" => serviceIdentifier,
                    "serviceNetworkIdentifier" => serviceNetworkIdentifier,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_service_network_vpc_association(service_network_identifier, vpc_identifier)
    create_service_network_vpc_association(service_network_identifier, vpc_identifier, params::Dict{String,<:Any})

Associates a VPC with a service network. When you associate a VPC with the service network,
it enables all the resources within that VPC to be clients and communicate with other
services in the service network. For more information, see Manage VPC associations in the
Amazon VPC Lattice User Guide. You can't use this operation if there is a disassociation in
progress. If the association fails, retry by deleting the association and recreating it. As
a result of this operation, the association gets created in the service network account and
the VPC owner account. If you add a security group to the service network and VPC
association, the association must continue to always have at least one security group. You
can add or edit security groups at any time. However, to remove all security groups, you
must first delete the association and recreate it without security groups.

# Arguments
- `service_network_identifier`: The ID or Amazon Resource Name (ARN) of the service
  network. You must use the ARN when the resources specified in the operation are in
  different accounts.
- `vpc_identifier`: The ID of the VPC.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If you retry a request that completed successfully using the
  same client token and parameters, the retry succeeds without performing any actions. If the
  parameters aren't identical, the retry fails.
- `"securityGroupIds"`: The IDs of the security groups. Security groups aren't added by
  default. You can add a security group to apply network level controls to control which
  resources in a VPC are allowed to access the service network and its services. For more
  information, see Control traffic to resources using security groups in the Amazon VPC User
  Guide.
- `"tags"`: The tags for the association.
"""
function create_service_network_vpc_association(
    serviceNetworkIdentifier,
    vpcIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "POST",
        "/servicenetworkvpcassociations",
        Dict{String,Any}(
            "serviceNetworkIdentifier" => serviceNetworkIdentifier,
            "vpcIdentifier" => vpcIdentifier,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_service_network_vpc_association(
    serviceNetworkIdentifier,
    vpcIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "POST",
        "/servicenetworkvpcassociations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "serviceNetworkIdentifier" => serviceNetworkIdentifier,
                    "vpcIdentifier" => vpcIdentifier,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_target_group(name, type)
    create_target_group(name, type, params::Dict{String,<:Any})

Creates a target group. A target group is a collection of targets, or compute resources,
that run your application or service. A target group can only be used by a single service.
For more information, see Target groups in the Amazon VPC Lattice User Guide.

# Arguments
- `name`: The name of the target group. The name must be unique within the account. The
  valid characters are a-z, 0-9, and hyphens (-). You can't use a hyphen as the first or last
  character, or immediately after another hyphen.
- `type`: The type of target group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If you retry a request that completed successfully using the
  same client token and parameters, the retry succeeds without performing any actions. If the
  parameters aren't identical, the retry fails.
- `"config"`: The target group configuration.
- `"tags"`: The tags for the target group.
"""
function create_target_group(name, type; aws_config::AbstractAWSConfig=current_aws_config())
    return vpc_lattice(
        "POST",
        "/targetgroups",
        Dict{String,Any}("name" => name, "type" => type, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_target_group(
    name,
    type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "POST",
        "/targetgroups",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "name" => name, "type" => type, "clientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_access_log_subscription(access_log_subscription_identifier)
    delete_access_log_subscription(access_log_subscription_identifier, params::Dict{String,<:Any})

Deletes the specified access log subscription.

# Arguments
- `access_log_subscription_identifier`: The ID or Amazon Resource Name (ARN) of the access
  log subscription.

"""
function delete_access_log_subscription(
    accessLogSubscriptionIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return vpc_lattice(
        "DELETE",
        "/accesslogsubscriptions/$(accessLogSubscriptionIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_access_log_subscription(
    accessLogSubscriptionIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "DELETE",
        "/accesslogsubscriptions/$(accessLogSubscriptionIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_auth_policy(resource_identifier)
    delete_auth_policy(resource_identifier, params::Dict{String,<:Any})

Deletes the specified auth policy. If an auth is set to AWS_IAM and the auth policy is
deleted, all requests are denied. If you are trying to remove the auth policy completely,
you must set the auth type to NONE. If auth is enabled on the resource, but no auth policy
is set, all requests are denied.

# Arguments
- `resource_identifier`: The ID or Amazon Resource Name (ARN) of the resource.

"""
function delete_auth_policy(
    resourceIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return vpc_lattice(
        "DELETE",
        "/authpolicy/$(resourceIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_auth_policy(
    resourceIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "DELETE",
        "/authpolicy/$(resourceIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_listener(listener_identifier, service_identifier)
    delete_listener(listener_identifier, service_identifier, params::Dict{String,<:Any})

Deletes the specified listener.

# Arguments
- `listener_identifier`: The ID or Amazon Resource Name (ARN) of the listener.
- `service_identifier`: The ID or Amazon Resource Name (ARN) of the service.

"""
function delete_listener(
    listenerIdentifier,
    serviceIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "DELETE",
        "/services/$(serviceIdentifier)/listeners/$(listenerIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_listener(
    listenerIdentifier,
    serviceIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "DELETE",
        "/services/$(serviceIdentifier)/listeners/$(listenerIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_resource_policy(resource_arn)
    delete_resource_policy(resource_arn, params::Dict{String,<:Any})

Deletes the specified resource policy.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.

"""
function delete_resource_policy(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return vpc_lattice(
        "DELETE",
        "/resourcepolicy/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_resource_policy(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "DELETE",
        "/resourcepolicy/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_rule(listener_identifier, rule_identifier, service_identifier)
    delete_rule(listener_identifier, rule_identifier, service_identifier, params::Dict{String,<:Any})

Deletes a listener rule. Each listener has a default rule for checking connection requests,
but you can define additional rules. Each rule consists of a priority, one or more actions,
and one or more conditions. You can delete additional listener rules, but you cannot delete
the default rule. For more information, see Listener rules in the Amazon VPC Lattice User
Guide.

# Arguments
- `listener_identifier`: The ID or Amazon Resource Name (ARN) of the listener.
- `rule_identifier`: The ID or Amazon Resource Name (ARN) of the rule.
- `service_identifier`: The ID or Amazon Resource Name (ARN) of the service.

"""
function delete_rule(
    listenerIdentifier,
    ruleIdentifier,
    serviceIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "DELETE",
        "/services/$(serviceIdentifier)/listeners/$(listenerIdentifier)/rules/$(ruleIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_rule(
    listenerIdentifier,
    ruleIdentifier,
    serviceIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "DELETE",
        "/services/$(serviceIdentifier)/listeners/$(listenerIdentifier)/rules/$(ruleIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_service(service_identifier)
    delete_service(service_identifier, params::Dict{String,<:Any})

Deletes a service. A service can't be deleted if it's associated with a service network. If
you delete a service, all resources related to the service, such as the resource policy,
auth policy, listeners, listener rules, and access log subscriptions, are also deleted. For
more information, see Delete a service in the Amazon VPC Lattice User Guide.

# Arguments
- `service_identifier`: The ID or Amazon Resource Name (ARN) of the service.

"""
function delete_service(
    serviceIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return vpc_lattice(
        "DELETE",
        "/services/$(serviceIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_service(
    serviceIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "DELETE",
        "/services/$(serviceIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_service_network(service_network_identifier)
    delete_service_network(service_network_identifier, params::Dict{String,<:Any})

Deletes a service network. You can only delete the service network if there is no service
or VPC associated with it. If you delete a service network, all resources related to the
service network, such as the resource policy, auth policy, and access log subscriptions,
are also deleted. For more information, see Delete a service network in the Amazon VPC
Lattice User Guide.

# Arguments
- `service_network_identifier`: The Amazon Resource Name (ARN) or ID of the service network.

"""
function delete_service_network(
    serviceNetworkIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return vpc_lattice(
        "DELETE",
        "/servicenetworks/$(serviceNetworkIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_service_network(
    serviceNetworkIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "DELETE",
        "/servicenetworks/$(serviceNetworkIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_service_network_service_association(service_network_service_association_identifier)
    delete_service_network_service_association(service_network_service_association_identifier, params::Dict{String,<:Any})

Deletes the association between a specified service and the specific service network. This
operation fails if an association is still in progress.

# Arguments
- `service_network_service_association_identifier`: The ID or Amazon Resource Name (ARN) of
  the association.

"""
function delete_service_network_service_association(
    serviceNetworkServiceAssociationIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "DELETE",
        "/servicenetworkserviceassociations/$(serviceNetworkServiceAssociationIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_service_network_service_association(
    serviceNetworkServiceAssociationIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "DELETE",
        "/servicenetworkserviceassociations/$(serviceNetworkServiceAssociationIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_service_network_vpc_association(service_network_vpc_association_identifier)
    delete_service_network_vpc_association(service_network_vpc_association_identifier, params::Dict{String,<:Any})

Disassociates the VPC from the service network. You can't disassociate the VPC if there is
a create or update association in progress.

# Arguments
- `service_network_vpc_association_identifier`: The ID or Amazon Resource Name (ARN) of the
  association.

"""
function delete_service_network_vpc_association(
    serviceNetworkVpcAssociationIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "DELETE",
        "/servicenetworkvpcassociations/$(serviceNetworkVpcAssociationIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_service_network_vpc_association(
    serviceNetworkVpcAssociationIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "DELETE",
        "/servicenetworkvpcassociations/$(serviceNetworkVpcAssociationIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_target_group(target_group_identifier)
    delete_target_group(target_group_identifier, params::Dict{String,<:Any})

Deletes a target group. You can't delete a target group if it is used in a listener rule or
if the target group creation is in progress.

# Arguments
- `target_group_identifier`: The ID or Amazon Resource Name (ARN) of the target group.

"""
function delete_target_group(
    targetGroupIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return vpc_lattice(
        "DELETE",
        "/targetgroups/$(targetGroupIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_target_group(
    targetGroupIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "DELETE",
        "/targetgroups/$(targetGroupIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    deregister_targets(target_group_identifier, targets)
    deregister_targets(target_group_identifier, targets, params::Dict{String,<:Any})

Deregisters the specified targets from the specified target group.

# Arguments
- `target_group_identifier`: The ID or Amazon Resource Name (ARN) of the target group.
- `targets`: The targets to deregister.

"""
function deregister_targets(
    targetGroupIdentifier, targets; aws_config::AbstractAWSConfig=current_aws_config()
)
    return vpc_lattice(
        "POST",
        "/targetgroups/$(targetGroupIdentifier)/deregistertargets",
        Dict{String,Any}("targets" => targets);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function deregister_targets(
    targetGroupIdentifier,
    targets,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "POST",
        "/targetgroups/$(targetGroupIdentifier)/deregistertargets",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("targets" => targets), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_access_log_subscription(access_log_subscription_identifier)
    get_access_log_subscription(access_log_subscription_identifier, params::Dict{String,<:Any})

Retrieves information about the specified access log subscription.

# Arguments
- `access_log_subscription_identifier`: The ID or Amazon Resource Name (ARN) of the access
  log subscription.

"""
function get_access_log_subscription(
    accessLogSubscriptionIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return vpc_lattice(
        "GET",
        "/accesslogsubscriptions/$(accessLogSubscriptionIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_access_log_subscription(
    accessLogSubscriptionIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "GET",
        "/accesslogsubscriptions/$(accessLogSubscriptionIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_auth_policy(resource_identifier)
    get_auth_policy(resource_identifier, params::Dict{String,<:Any})

Retrieves information about the auth policy for the specified service or service network.

# Arguments
- `resource_identifier`: The ID or Amazon Resource Name (ARN) of the service network or
  service.

"""
function get_auth_policy(
    resourceIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return vpc_lattice(
        "GET",
        "/authpolicy/$(resourceIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_auth_policy(
    resourceIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "GET",
        "/authpolicy/$(resourceIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_listener(listener_identifier, service_identifier)
    get_listener(listener_identifier, service_identifier, params::Dict{String,<:Any})

Retrieves information about the specified listener for the specified service.

# Arguments
- `listener_identifier`: The ID or Amazon Resource Name (ARN) of the listener.
- `service_identifier`: The ID or Amazon Resource Name (ARN) of the service.

"""
function get_listener(
    listenerIdentifier,
    serviceIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "GET",
        "/services/$(serviceIdentifier)/listeners/$(listenerIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_listener(
    listenerIdentifier,
    serviceIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "GET",
        "/services/$(serviceIdentifier)/listeners/$(listenerIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_resource_policy(resource_arn)
    get_resource_policy(resource_arn, params::Dict{String,<:Any})

Retrieves information about the resource policy. The resource policy is an IAM policy
created on behalf of the resource owner when they share a resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the service network or service.

"""
function get_resource_policy(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return vpc_lattice(
        "GET",
        "/resourcepolicy/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_resource_policy(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "GET",
        "/resourcepolicy/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_rule(listener_identifier, rule_identifier, service_identifier)
    get_rule(listener_identifier, rule_identifier, service_identifier, params::Dict{String,<:Any})

Retrieves information about listener rules. You can also retrieve information about the
default listener rule. For more information, see Listener rules in the Amazon VPC Lattice
User Guide.

# Arguments
- `listener_identifier`: The ID or Amazon Resource Name (ARN) of the listener.
- `rule_identifier`: The ID or Amazon Resource Name (ARN) of the listener rule.
- `service_identifier`: The ID or Amazon Resource Name (ARN) of the service.

"""
function get_rule(
    listenerIdentifier,
    ruleIdentifier,
    serviceIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "GET",
        "/services/$(serviceIdentifier)/listeners/$(listenerIdentifier)/rules/$(ruleIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_rule(
    listenerIdentifier,
    ruleIdentifier,
    serviceIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "GET",
        "/services/$(serviceIdentifier)/listeners/$(listenerIdentifier)/rules/$(ruleIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_service(service_identifier)
    get_service(service_identifier, params::Dict{String,<:Any})

Retrieves information about the specified service.

# Arguments
- `service_identifier`: The ID or Amazon Resource Name (ARN) of the service.

"""
function get_service(serviceIdentifier; aws_config::AbstractAWSConfig=current_aws_config())
    return vpc_lattice(
        "GET",
        "/services/$(serviceIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_service(
    serviceIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "GET",
        "/services/$(serviceIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_service_network(service_network_identifier)
    get_service_network(service_network_identifier, params::Dict{String,<:Any})

Retrieves information about the specified service network.

# Arguments
- `service_network_identifier`: The ID or Amazon Resource Name (ARN) of the service network.

"""
function get_service_network(
    serviceNetworkIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return vpc_lattice(
        "GET",
        "/servicenetworks/$(serviceNetworkIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_service_network(
    serviceNetworkIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "GET",
        "/servicenetworks/$(serviceNetworkIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_service_network_service_association(service_network_service_association_identifier)
    get_service_network_service_association(service_network_service_association_identifier, params::Dict{String,<:Any})

Retrieves information about the specified association between a service network and a
service.

# Arguments
- `service_network_service_association_identifier`: The ID or Amazon Resource Name (ARN) of
  the association.

"""
function get_service_network_service_association(
    serviceNetworkServiceAssociationIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "GET",
        "/servicenetworkserviceassociations/$(serviceNetworkServiceAssociationIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_service_network_service_association(
    serviceNetworkServiceAssociationIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "GET",
        "/servicenetworkserviceassociations/$(serviceNetworkServiceAssociationIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_service_network_vpc_association(service_network_vpc_association_identifier)
    get_service_network_vpc_association(service_network_vpc_association_identifier, params::Dict{String,<:Any})

Retrieves information about the association between a service network and a VPC.

# Arguments
- `service_network_vpc_association_identifier`: The ID or Amazon Resource Name (ARN) of the
  association.

"""
function get_service_network_vpc_association(
    serviceNetworkVpcAssociationIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "GET",
        "/servicenetworkvpcassociations/$(serviceNetworkVpcAssociationIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_service_network_vpc_association(
    serviceNetworkVpcAssociationIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "GET",
        "/servicenetworkvpcassociations/$(serviceNetworkVpcAssociationIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_target_group(target_group_identifier)
    get_target_group(target_group_identifier, params::Dict{String,<:Any})

Retrieves information about the specified target group.

# Arguments
- `target_group_identifier`: The ID or Amazon Resource Name (ARN) of the target group.

"""
function get_target_group(
    targetGroupIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return vpc_lattice(
        "GET",
        "/targetgroups/$(targetGroupIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_target_group(
    targetGroupIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "GET",
        "/targetgroups/$(targetGroupIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_access_log_subscriptions(resource_identifier)
    list_access_log_subscriptions(resource_identifier, params::Dict{String,<:Any})

Lists all access log subscriptions for the specified service network or service.

# Arguments
- `resource_identifier`: The ID or Amazon Resource Name (ARN) of the service network or
  service.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return.
- `"nextToken"`: A pagination token for the next page of results.
"""
function list_access_log_subscriptions(
    resourceIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return vpc_lattice(
        "GET",
        "/accesslogsubscriptions",
        Dict{String,Any}("resourceIdentifier" => resourceIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_access_log_subscriptions(
    resourceIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "GET",
        "/accesslogsubscriptions",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("resourceIdentifier" => resourceIdentifier), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_listeners(service_identifier)
    list_listeners(service_identifier, params::Dict{String,<:Any})

Lists the listeners for the specified service.

# Arguments
- `service_identifier`: The ID or Amazon Resource Name (ARN) of the service.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return.
- `"nextToken"`: A pagination token for the next page of results.
"""
function list_listeners(
    serviceIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return vpc_lattice(
        "GET",
        "/services/$(serviceIdentifier)/listeners";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_listeners(
    serviceIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "GET",
        "/services/$(serviceIdentifier)/listeners",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_rules(listener_identifier, service_identifier)
    list_rules(listener_identifier, service_identifier, params::Dict{String,<:Any})

Lists the rules for the listener.

# Arguments
- `listener_identifier`: The ID or Amazon Resource Name (ARN) of the listener.
- `service_identifier`: The ID or Amazon Resource Name (ARN) of the service.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return.
- `"nextToken"`: A pagination token for the next page of results.
"""
function list_rules(
    listenerIdentifier,
    serviceIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "GET",
        "/services/$(serviceIdentifier)/listeners/$(listenerIdentifier)/rules";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_rules(
    listenerIdentifier,
    serviceIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "GET",
        "/services/$(serviceIdentifier)/listeners/$(listenerIdentifier)/rules",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_service_network_service_associations()
    list_service_network_service_associations(params::Dict{String,<:Any})

Lists the associations between the service network and the service. You can filter the list
either by service or service network. You must provide either the service network
identifier or the service identifier. Every association in Amazon VPC Lattice is given a
unique Amazon Resource Name (ARN), such as when a service network is associated with a VPC
or when a service is associated with a service network. If the association is for a
resource that is shared with another account, the association includes the local account ID
as the prefix in the ARN for each account the resource is shared with.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return.
- `"nextToken"`: A pagination token for the next page of results.
- `"serviceIdentifier"`: The ID or Amazon Resource Name (ARN) of the service.
- `"serviceNetworkIdentifier"`: The ID or Amazon Resource Name (ARN) of the service network.
"""
function list_service_network_service_associations(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return vpc_lattice(
        "GET",
        "/servicenetworkserviceassociations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_service_network_service_associations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return vpc_lattice(
        "GET",
        "/servicenetworkserviceassociations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_service_network_vpc_associations()
    list_service_network_vpc_associations(params::Dict{String,<:Any})

Lists the service network and VPC associations. You can filter the list either by VPC or
service network. You must provide either the service network identifier or the VPC
identifier.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return.
- `"nextToken"`: A pagination token for the next page of results.
- `"serviceNetworkIdentifier"`: The ID or Amazon Resource Name (ARN) of the service network.
- `"vpcIdentifier"`: The ID or Amazon Resource Name (ARN) of the VPC.
"""
function list_service_network_vpc_associations(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return vpc_lattice(
        "GET",
        "/servicenetworkvpcassociations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_service_network_vpc_associations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return vpc_lattice(
        "GET",
        "/servicenetworkvpcassociations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_service_networks()
    list_service_networks(params::Dict{String,<:Any})

Lists the service networks owned by the caller account or shared with the caller account.
Also includes the account ID in the ARN to show which account owns the service network.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return.
- `"nextToken"`: A pagination token for the next page of results.
"""
function list_service_networks(; aws_config::AbstractAWSConfig=current_aws_config())
    return vpc_lattice(
        "GET", "/servicenetworks"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_service_networks(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return vpc_lattice(
        "GET",
        "/servicenetworks",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_services()
    list_services(params::Dict{String,<:Any})

Lists the services owned by the caller account or shared with the caller account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return.
- `"nextToken"`: A pagination token for the next page of results.
"""
function list_services(; aws_config::AbstractAWSConfig=current_aws_config())
    return vpc_lattice(
        "GET", "/services"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_services(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return vpc_lattice(
        "GET", "/services", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists the tags for the specified resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return vpc_lattice(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_target_groups()
    list_target_groups(params::Dict{String,<:Any})

Lists your target groups. You can narrow your search by using the filters below in your
request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return.
- `"nextToken"`: A pagination token for the next page of results.
- `"targetGroupType"`: The target group type.
- `"vpcIdentifier"`: The ID or Amazon Resource Name (ARN) of the VPC.
"""
function list_target_groups(; aws_config::AbstractAWSConfig=current_aws_config())
    return vpc_lattice(
        "GET", "/targetgroups"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_target_groups(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return vpc_lattice(
        "GET",
        "/targetgroups",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_targets(target_group_identifier)
    list_targets(target_group_identifier, params::Dict{String,<:Any})

Lists the targets for the target group. By default, all targets are included. You can use
this API to check the health status of targets. You can also ﬁlter the results by target.

# Arguments
- `target_group_identifier`: The ID or Amazon Resource Name (ARN) of the target group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return.
- `"nextToken"`: A pagination token for the next page of results.
- `"targets"`: The targets.
"""
function list_targets(
    targetGroupIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return vpc_lattice(
        "POST",
        "/targetgroups/$(targetGroupIdentifier)/listtargets";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_targets(
    targetGroupIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "POST",
        "/targetgroups/$(targetGroupIdentifier)/listtargets",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_auth_policy(policy, resource_identifier)
    put_auth_policy(policy, resource_identifier, params::Dict{String,<:Any})

Creates or updates the auth policy. The policy string in JSON must not contain newlines or
blank lines. For more information, see Auth policies in the Amazon VPC Lattice User Guide.

# Arguments
- `policy`: The auth policy. The policy string in JSON must not contain newlines or blank
  lines.
- `resource_identifier`: The ID or Amazon Resource Name (ARN) of the service network or
  service for which the policy is created.

"""
function put_auth_policy(
    policy, resourceIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return vpc_lattice(
        "PUT",
        "/authpolicy/$(resourceIdentifier)",
        Dict{String,Any}("policy" => policy);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_auth_policy(
    policy,
    resourceIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "PUT",
        "/authpolicy/$(resourceIdentifier)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("policy" => policy), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_resource_policy(policy, resource_arn)
    put_resource_policy(policy, resource_arn, params::Dict{String,<:Any})

Attaches a resource-based permission policy to a service or service network. The policy
must contain the same actions and condition statements as the Amazon Web Services Resource
Access Manager permission for sharing services and service networks.

# Arguments
- `policy`: An IAM policy. The policy string in JSON must not contain newlines or blank
  lines.
- `resource_arn`: The ID or Amazon Resource Name (ARN) of the service network or service
  for which the policy is created.

"""
function put_resource_policy(
    policy, resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return vpc_lattice(
        "PUT",
        "/resourcepolicy/$(resourceArn)",
        Dict{String,Any}("policy" => policy);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_resource_policy(
    policy,
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "PUT",
        "/resourcepolicy/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("policy" => policy), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    register_targets(target_group_identifier, targets)
    register_targets(target_group_identifier, targets, params::Dict{String,<:Any})

Registers the targets with the target group. If it's a Lambda target, you can only have one
target in a target group.

# Arguments
- `target_group_identifier`: The ID or Amazon Resource Name (ARN) of the target group.
- `targets`: The targets.

"""
function register_targets(
    targetGroupIdentifier, targets; aws_config::AbstractAWSConfig=current_aws_config()
)
    return vpc_lattice(
        "POST",
        "/targetgroups/$(targetGroupIdentifier)/registertargets",
        Dict{String,Any}("targets" => targets);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function register_targets(
    targetGroupIdentifier,
    targets,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "POST",
        "/targetgroups/$(targetGroupIdentifier)/registertargets",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("targets" => targets), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds the specified tags to the specified resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.
- `tags`: The tags for the resource.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return vpc_lattice(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes the specified tags from the specified resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.
- `tag_keys`: The tag keys of the tags to remove.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return vpc_lattice(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_access_log_subscription(access_log_subscription_identifier, destination_arn)
    update_access_log_subscription(access_log_subscription_identifier, destination_arn, params::Dict{String,<:Any})

Updates the specified access log subscription.

# Arguments
- `access_log_subscription_identifier`: The ID or Amazon Resource Name (ARN) of the access
  log subscription.
- `destination_arn`: The Amazon Resource Name (ARN) of the access log destination.

"""
function update_access_log_subscription(
    accessLogSubscriptionIdentifier,
    destinationArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "PATCH",
        "/accesslogsubscriptions/$(accessLogSubscriptionIdentifier)",
        Dict{String,Any}("destinationArn" => destinationArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_access_log_subscription(
    accessLogSubscriptionIdentifier,
    destinationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "PATCH",
        "/accesslogsubscriptions/$(accessLogSubscriptionIdentifier)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("destinationArn" => destinationArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_listener(default_action, listener_identifier, service_identifier)
    update_listener(default_action, listener_identifier, service_identifier, params::Dict{String,<:Any})

Updates the specified listener for the specified service.

# Arguments
- `default_action`: The action for the default rule.
- `listener_identifier`: The ID or Amazon Resource Name (ARN) of the listener.
- `service_identifier`: The ID or Amazon Resource Name (ARN) of the service.

"""
function update_listener(
    defaultAction,
    listenerIdentifier,
    serviceIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "PATCH",
        "/services/$(serviceIdentifier)/listeners/$(listenerIdentifier)",
        Dict{String,Any}("defaultAction" => defaultAction);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_listener(
    defaultAction,
    listenerIdentifier,
    serviceIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "PATCH",
        "/services/$(serviceIdentifier)/listeners/$(listenerIdentifier)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("defaultAction" => defaultAction), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_rule(listener_identifier, rule_identifier, service_identifier)
    update_rule(listener_identifier, rule_identifier, service_identifier, params::Dict{String,<:Any})

Updates a rule for the listener. You can't modify a default listener rule. To modify a
default listener rule, use UpdateListener.

# Arguments
- `listener_identifier`: The ID or Amazon Resource Name (ARN) of the listener.
- `rule_identifier`: The ID or Amazon Resource Name (ARN) of the rule.
- `service_identifier`: The ID or Amazon Resource Name (ARN) of the service.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"action"`: Information about the action for the specified listener rule.
- `"match"`: The rule match.
- `"priority"`: The rule priority. A listener can't have multiple rules with the same
  priority.
"""
function update_rule(
    listenerIdentifier,
    ruleIdentifier,
    serviceIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "PATCH",
        "/services/$(serviceIdentifier)/listeners/$(listenerIdentifier)/rules/$(ruleIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_rule(
    listenerIdentifier,
    ruleIdentifier,
    serviceIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "PATCH",
        "/services/$(serviceIdentifier)/listeners/$(listenerIdentifier)/rules/$(ruleIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_service(service_identifier)
    update_service(service_identifier, params::Dict{String,<:Any})

Updates the specified service.

# Arguments
- `service_identifier`: The ID or Amazon Resource Name (ARN) of the service.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"authType"`: The type of IAM policy.    NONE: The resource does not use an IAM policy.
  This is the default.    AWS_IAM: The resource uses an IAM policy. When this type is used,
  auth is enabled and an auth policy is required.
- `"certificateArn"`: The Amazon Resource Name (ARN) of the certificate.
"""
function update_service(
    serviceIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return vpc_lattice(
        "PATCH",
        "/services/$(serviceIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_service(
    serviceIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "PATCH",
        "/services/$(serviceIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_service_network(auth_type, service_network_identifier)
    update_service_network(auth_type, service_network_identifier, params::Dict{String,<:Any})

Updates the specified service network.

# Arguments
- `auth_type`: The type of IAM policy.    NONE: The resource does not use an IAM policy.
  This is the default.    AWS_IAM: The resource uses an IAM policy. When this type is used,
  auth is enabled and an auth policy is required.
- `service_network_identifier`: The ID or Amazon Resource Name (ARN) of the service network.

"""
function update_service_network(
    authType, serviceNetworkIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return vpc_lattice(
        "PATCH",
        "/servicenetworks/$(serviceNetworkIdentifier)",
        Dict{String,Any}("authType" => authType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_service_network(
    authType,
    serviceNetworkIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "PATCH",
        "/servicenetworks/$(serviceNetworkIdentifier)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("authType" => authType), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_service_network_vpc_association(security_group_ids, service_network_vpc_association_identifier)
    update_service_network_vpc_association(security_group_ids, service_network_vpc_association_identifier, params::Dict{String,<:Any})

Updates the service network and VPC association. If you add a security group to the service
network and VPC association, the association must continue to always have at least one
security group. You can add or edit security groups at any time. However, to remove all
security groups, you must first delete the association and recreate it without security
groups.

# Arguments
- `security_group_ids`: The IDs of the security groups.
- `service_network_vpc_association_identifier`: The ID or Amazon Resource Name (ARN) of the
  association.

"""
function update_service_network_vpc_association(
    securityGroupIds,
    serviceNetworkVpcAssociationIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "PATCH",
        "/servicenetworkvpcassociations/$(serviceNetworkVpcAssociationIdentifier)",
        Dict{String,Any}("securityGroupIds" => securityGroupIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_service_network_vpc_association(
    securityGroupIds,
    serviceNetworkVpcAssociationIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "PATCH",
        "/servicenetworkvpcassociations/$(serviceNetworkVpcAssociationIdentifier)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("securityGroupIds" => securityGroupIds), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_target_group(health_check, target_group_identifier)
    update_target_group(health_check, target_group_identifier, params::Dict{String,<:Any})

Updates the specified target group.

# Arguments
- `health_check`: The health check configuration.
- `target_group_identifier`: The ID or Amazon Resource Name (ARN) of the target group.

"""
function update_target_group(
    healthCheck, targetGroupIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return vpc_lattice(
        "PATCH",
        "/targetgroups/$(targetGroupIdentifier)",
        Dict{String,Any}("healthCheck" => healthCheck);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_target_group(
    healthCheck,
    targetGroupIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return vpc_lattice(
        "PATCH",
        "/targetgroups/$(targetGroupIdentifier)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("healthCheck" => healthCheck), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: network_firewall
using AWS.Compat
using AWS.UUIDs

"""
    associate_firewall_policy(firewall_policy_arn)
    associate_firewall_policy(firewall_policy_arn, params::Dict{String,<:Any})

Associates a FirewallPolicy to a Firewall.  A firewall policy defines how to monitor and
manage your VPC network traffic, using a collection of inspection rule groups and other
settings. Each firewall requires one firewall policy association, and you can use the same
firewall policy for multiple firewalls.

# Arguments
- `firewall_policy_arn`: The Amazon Resource Name (ARN) of the firewall policy.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FirewallArn"`: The Amazon Resource Name (ARN) of the firewall. You must specify the ARN
  or the name, and you can specify both.
- `"FirewallName"`: The descriptive name of the firewall. You can't change the name of a
  firewall after you create it. You must specify the ARN or the name, and you can specify
  both.
- `"UpdateToken"`: An optional token that you can use for optimistic locking. Network
  Firewall returns a token to your requests that access the firewall. The token marks the
  state of the firewall resource at the time of the request.  To make an unconditional change
  to the firewall, omit the token in your update request. Without the token, Network Firewall
  performs your updates regardless of whether the firewall has changed since you last
  retrieved it. To make a conditional change to the firewall, provide the token in your
  update request. Network Firewall uses the token to ensure that the firewall hasn't changed
  since you last retrieved it. If it has changed, the operation fails with an
  InvalidTokenException. If this happens, retrieve the firewall again to get a current copy
  of it with a new token. Reapply your changes as needed, then try the operation again using
  the new token.
"""
function associate_firewall_policy(
    FirewallPolicyArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return network_firewall(
        "AssociateFirewallPolicy",
        Dict{String,Any}("FirewallPolicyArn" => FirewallPolicyArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_firewall_policy(
    FirewallPolicyArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return network_firewall(
        "AssociateFirewallPolicy",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("FirewallPolicyArn" => FirewallPolicyArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_subnets(subnet_mappings)
    associate_subnets(subnet_mappings, params::Dict{String,<:Any})

Associates the specified subnets in the Amazon VPC to the firewall. You can specify one
subnet for each of the Availability Zones that the VPC spans.  This request creates an
Network Firewall firewall endpoint in each of the subnets. To enable the firewall's
protections, you must also modify the VPC's route tables for each subnet's Availability
Zone, to redirect the traffic that's coming into and going out of the zone through the
firewall endpoint.

# Arguments
- `subnet_mappings`: The IDs of the subnets that you want to associate with the firewall.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FirewallArn"`: The Amazon Resource Name (ARN) of the firewall. You must specify the ARN
  or the name, and you can specify both.
- `"FirewallName"`: The descriptive name of the firewall. You can't change the name of a
  firewall after you create it. You must specify the ARN or the name, and you can specify
  both.
- `"UpdateToken"`: An optional token that you can use for optimistic locking. Network
  Firewall returns a token to your requests that access the firewall. The token marks the
  state of the firewall resource at the time of the request.  To make an unconditional change
  to the firewall, omit the token in your update request. Without the token, Network Firewall
  performs your updates regardless of whether the firewall has changed since you last
  retrieved it. To make a conditional change to the firewall, provide the token in your
  update request. Network Firewall uses the token to ensure that the firewall hasn't changed
  since you last retrieved it. If it has changed, the operation fails with an
  InvalidTokenException. If this happens, retrieve the firewall again to get a current copy
  of it with a new token. Reapply your changes as needed, then try the operation again using
  the new token.
"""
function associate_subnets(
    SubnetMappings; aws_config::AbstractAWSConfig=current_aws_config()
)
    return network_firewall(
        "AssociateSubnets",
        Dict{String,Any}("SubnetMappings" => SubnetMappings);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_subnets(
    SubnetMappings,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return network_firewall(
        "AssociateSubnets",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("SubnetMappings" => SubnetMappings), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_firewall(firewall_name, firewall_policy_arn, subnet_mappings, vpc_id)
    create_firewall(firewall_name, firewall_policy_arn, subnet_mappings, vpc_id, params::Dict{String,<:Any})

Creates an Network Firewall Firewall and accompanying FirewallStatus for a VPC.  The
firewall defines the configuration settings for an Network Firewall firewall. The settings
that you can define at creation include the firewall policy, the subnets in your VPC to use
for the firewall endpoints, and any tags that are attached to the firewall Amazon Web
Services resource.  After you create a firewall, you can provide additional settings, like
the logging configuration.  To update the settings for a firewall, you use the operations
that apply to the settings themselves, for example UpdateLoggingConfiguration,
AssociateSubnets, and UpdateFirewallDeleteProtection.  To manage a firewall's tags, use the
standard Amazon Web Services resource tagging operations, ListTagsForResource, TagResource,
and UntagResource. To retrieve information about firewalls, use ListFirewalls and
DescribeFirewall.

# Arguments
- `firewall_name`: The descriptive name of the firewall. You can't change the name of a
  firewall after you create it.
- `firewall_policy_arn`: The Amazon Resource Name (ARN) of the FirewallPolicy that you want
  to use for the firewall.
- `subnet_mappings`: The public subnets to use for your Network Firewall firewalls. Each
  subnet must belong to a different Availability Zone in the VPC. Network Firewall creates a
  firewall endpoint in each subnet.
- `vpc_id`: The unique identifier of the VPC where Network Firewall should create the
  firewall.  You can't change this setting after you create the firewall.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DeleteProtection"`: A flag indicating whether it is possible to delete the firewall. A
  setting of TRUE indicates that the firewall is protected against deletion. Use this setting
  to protect against accidentally deleting a firewall that is in use. When you create a
  firewall, the operation initializes this flag to TRUE.
- `"Description"`: A description of the firewall.
- `"EncryptionConfiguration"`: A complex type that contains settings for encryption of your
  firewall resources.
- `"FirewallPolicyChangeProtection"`: A setting indicating whether the firewall is
  protected against a change to the firewall policy association. Use this setting to protect
  against accidentally modifying the firewall policy for a firewall that is in use. When you
  create a firewall, the operation initializes this setting to TRUE.
- `"SubnetChangeProtection"`: A setting indicating whether the firewall is protected
  against changes to the subnet associations. Use this setting to protect against
  accidentally modifying the subnet associations for a firewall that is in use. When you
  create a firewall, the operation initializes this setting to TRUE.
- `"Tags"`: The key:value pairs to associate with the resource.
"""
function create_firewall(
    FirewallName,
    FirewallPolicyArn,
    SubnetMappings,
    VpcId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return network_firewall(
        "CreateFirewall",
        Dict{String,Any}(
            "FirewallName" => FirewallName,
            "FirewallPolicyArn" => FirewallPolicyArn,
            "SubnetMappings" => SubnetMappings,
            "VpcId" => VpcId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_firewall(
    FirewallName,
    FirewallPolicyArn,
    SubnetMappings,
    VpcId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return network_firewall(
        "CreateFirewall",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "FirewallName" => FirewallName,
                    "FirewallPolicyArn" => FirewallPolicyArn,
                    "SubnetMappings" => SubnetMappings,
                    "VpcId" => VpcId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_firewall_policy(firewall_policy, firewall_policy_name)
    create_firewall_policy(firewall_policy, firewall_policy_name, params::Dict{String,<:Any})

Creates the firewall policy for the firewall according to the specifications.  An Network
Firewall firewall policy defines the behavior of a firewall, in a collection of stateless
and stateful rule groups and other settings. You can use one firewall policy for multiple
firewalls.

# Arguments
- `firewall_policy`: The rule groups and policy actions to use in the firewall policy.
- `firewall_policy_name`: The descriptive name of the firewall policy. You can't change the
  name of a firewall policy after you create it.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description of the firewall policy.
- `"DryRun"`: Indicates whether you want Network Firewall to just check the validity of the
  request, rather than run the request.  If set to TRUE, Network Firewall checks whether the
  request can run successfully, but doesn't actually make the requested changes. The call
  returns the value that the request would return if you ran it with dry run set to FALSE,
  but doesn't make additions or changes to your resources. This option allows you to make
  sure that you have the required permissions to run the request and that your request
  parameters are valid.  If set to FALSE, Network Firewall makes the requested changes to
  your resources.
- `"EncryptionConfiguration"`: A complex type that contains settings for encryption of your
  firewall policy resources.
- `"Tags"`: The key:value pairs to associate with the resource.
"""
function create_firewall_policy(
    FirewallPolicy, FirewallPolicyName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return network_firewall(
        "CreateFirewallPolicy",
        Dict{String,Any}(
            "FirewallPolicy" => FirewallPolicy, "FirewallPolicyName" => FirewallPolicyName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_firewall_policy(
    FirewallPolicy,
    FirewallPolicyName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return network_firewall(
        "CreateFirewallPolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "FirewallPolicy" => FirewallPolicy,
                    "FirewallPolicyName" => FirewallPolicyName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_rule_group(capacity, rule_group_name, type)
    create_rule_group(capacity, rule_group_name, type, params::Dict{String,<:Any})

Creates the specified stateless or stateful rule group, which includes the rules for
network traffic inspection, a capacity setting, and tags.  You provide your rule group
specification in your request using either RuleGroup or Rules.

# Arguments
- `capacity`: The maximum operating resources that this rule group can use. Rule group
  capacity is fixed at creation. When you update a rule group, you are limited to this
  capacity. When you reference a rule group from a firewall policy, Network Firewall reserves
  this capacity for the rule group.  You can retrieve the capacity that would be required for
  a rule group before you create the rule group by calling CreateRuleGroup with DryRun set to
  TRUE.   You can't change or exceed this capacity when you update the rule group, so leave
  room for your rule group to grow.    Capacity for a stateless rule group  For a stateless
  rule group, the capacity required is the sum of the capacity requirements of the individual
  rules that you expect to have in the rule group.  To calculate the capacity requirement of
  a single rule, multiply the capacity requirement values of each of the rule's match
  settings:   A match setting with no criteria specified has a value of 1.    A match setting
  with Any specified has a value of 1.    All other match settings have a value equal to the
  number of elements provided in the setting. For example, a protocol setting [\"UDP\"] and a
  source setting [\"10.0.0.0/24\"] each have a value of 1. A protocol setting
  [\"UDP\",\"TCP\"] has a value of 2. A source setting
  [\"10.0.0.0/24\",\"10.0.0.1/24\",\"10.0.0.2/24\"] has a value of 3.    A rule with no
  criteria specified in any of its match settings has a capacity requirement of 1. A rule
  with protocol setting [\"UDP\",\"TCP\"], source setting
  [\"10.0.0.0/24\",\"10.0.0.1/24\",\"10.0.0.2/24\"], and a single specification or no
  specification for each of the other match settings has a capacity requirement of 6.
  Capacity for a stateful rule group  For a stateful rule group, the minimum capacity
  required is the number of individual rules that you expect to have in the rule group.
- `rule_group_name`: The descriptive name of the rule group. You can't change the name of a
  rule group after you create it.
- `type`: Indicates whether the rule group is stateless or stateful. If the rule group is
  stateless, it contains stateless rules. If it is stateful, it contains stateful rules.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AnalyzeRuleGroup"`: Indicates whether you want Network Firewall to analyze the
  stateless rules in the rule group for rule behavior such as asymmetric routing. If set to
  TRUE, Network Firewall runs the analysis and then creates the rule group for you. To run
  the stateless rule group analyzer without creating the rule group, set DryRun to TRUE.
- `"Description"`: A description of the rule group.
- `"DryRun"`: Indicates whether you want Network Firewall to just check the validity of the
  request, rather than run the request.  If set to TRUE, Network Firewall checks whether the
  request can run successfully, but doesn't actually make the requested changes. The call
  returns the value that the request would return if you ran it with dry run set to FALSE,
  but doesn't make additions or changes to your resources. This option allows you to make
  sure that you have the required permissions to run the request and that your request
  parameters are valid.  If set to FALSE, Network Firewall makes the requested changes to
  your resources.
- `"EncryptionConfiguration"`: A complex type that contains settings for encryption of your
  rule group resources.
- `"RuleGroup"`: An object that defines the rule group rules.   You must provide either
  this rule group setting or a Rules setting, but not both.
- `"Rules"`: A string containing stateful rule group rules specifications in Suricata flat
  format, with one rule per line. Use this to import your existing Suricata compatible rule
  groups.   You must provide either this rules setting or a populated RuleGroup setting, but
  not both.   You can provide your rule group specification in Suricata flat format through
  this setting when you create or update your rule group. The call response returns a
  RuleGroup object that Network Firewall has populated from your string.
- `"SourceMetadata"`: A complex type that contains metadata about the rule group that your
  own rule group is copied from. You can use the metadata to keep track of updates made to
  the originating rule group.
- `"Tags"`: The key:value pairs to associate with the resource.
"""
function create_rule_group(
    Capacity, RuleGroupName, Type; aws_config::AbstractAWSConfig=current_aws_config()
)
    return network_firewall(
        "CreateRuleGroup",
        Dict{String,Any}(
            "Capacity" => Capacity, "RuleGroupName" => RuleGroupName, "Type" => Type
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_rule_group(
    Capacity,
    RuleGroupName,
    Type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return network_firewall(
        "CreateRuleGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Capacity" => Capacity, "RuleGroupName" => RuleGroupName, "Type" => Type
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_tlsinspection_configuration(tlsinspection_configuration, tlsinspection_configuration_name)
    create_tlsinspection_configuration(tlsinspection_configuration, tlsinspection_configuration_name, params::Dict{String,<:Any})

Creates an Network Firewall TLS inspection configuration. A TLS inspection configuration
contains Certificate Manager certificate associations between and the scope configurations
that Network Firewall uses to decrypt and re-encrypt traffic traveling through your
firewall. After you create a TLS inspection configuration, you can associate it with a new
firewall policy. To update the settings for a TLS inspection configuration, use
UpdateTLSInspectionConfiguration. To manage a TLS inspection configuration's tags, use the
standard Amazon Web Services resource tagging operations, ListTagsForResource, TagResource,
and UntagResource. To retrieve information about TLS inspection configurations, use
ListTLSInspectionConfigurations and DescribeTLSInspectionConfiguration.  For more
information about TLS inspection configurations, see Inspecting SSL/TLS traffic with TLS
inspection configurations in the Network Firewall Developer Guide.

# Arguments
- `tlsinspection_configuration`: The object that defines a TLS inspection configuration.
  This, along with TLSInspectionConfigurationResponse, define the TLS inspection
  configuration. You can retrieve all objects for a TLS inspection configuration by calling
  DescribeTLSInspectionConfiguration.  Network Firewall uses a TLS inspection configuration
  to decrypt traffic. Network Firewall re-encrypts the traffic before sending it to its
  destination. To use a TLS inspection configuration, you add it to a new Network Firewall
  firewall policy, then you apply the firewall policy to a firewall. Network Firewall acts as
  a proxy service to decrypt and inspect the traffic traveling through your firewalls. You
  can reference a TLS inspection configuration from more than one firewall policy, and you
  can use a firewall policy in more than one firewall. For more information about using TLS
  inspection configurations, see Inspecting SSL/TLS traffic with TLS inspection
  configurations in the Network Firewall Developer Guide.
- `tlsinspection_configuration_name`: The descriptive name of the TLS inspection
  configuration. You can't change the name of a TLS inspection configuration after you create
  it.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description of the TLS inspection configuration.
- `"EncryptionConfiguration"`:
- `"Tags"`: The key:value pairs to associate with the resource.
"""
function create_tlsinspection_configuration(
    TLSInspectionConfiguration,
    TLSInspectionConfigurationName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return network_firewall(
        "CreateTLSInspectionConfiguration",
        Dict{String,Any}(
            "TLSInspectionConfiguration" => TLSInspectionConfiguration,
            "TLSInspectionConfigurationName" => TLSInspectionConfigurationName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_tlsinspection_configuration(
    TLSInspectionConfiguration,
    TLSInspectionConfigurationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return network_firewall(
        "CreateTLSInspectionConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "TLSInspectionConfiguration" => TLSInspectionConfiguration,
                    "TLSInspectionConfigurationName" => TLSInspectionConfigurationName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_firewall()
    delete_firewall(params::Dict{String,<:Any})

Deletes the specified Firewall and its FirewallStatus. This operation requires the
firewall's DeleteProtection flag to be FALSE. You can't revert this operation.  You can
check whether a firewall is in use by reviewing the route tables for the Availability Zones
where you have firewall subnet mappings. Retrieve the subnet mappings by calling
DescribeFirewall. You define and update the route tables through Amazon VPC. As needed,
update the route tables for the zones to remove the firewall endpoints. When the route
tables no longer use the firewall endpoints, you can remove the firewall safely. To delete
a firewall, remove the delete protection if you need to using
UpdateFirewallDeleteProtection, then delete the firewall by calling DeleteFirewall.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FirewallArn"`: The Amazon Resource Name (ARN) of the firewall. You must specify the ARN
  or the name, and you can specify both.
- `"FirewallName"`: The descriptive name of the firewall. You can't change the name of a
  firewall after you create it. You must specify the ARN or the name, and you can specify
  both.
"""
function delete_firewall(; aws_config::AbstractAWSConfig=current_aws_config())
    return network_firewall(
        "DeleteFirewall"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function delete_firewall(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return network_firewall(
        "DeleteFirewall", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    delete_firewall_policy()
    delete_firewall_policy(params::Dict{String,<:Any})

Deletes the specified FirewallPolicy.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FirewallPolicyArn"`: The Amazon Resource Name (ARN) of the firewall policy. You must
  specify the ARN or the name, and you can specify both.
- `"FirewallPolicyName"`: The descriptive name of the firewall policy. You can't change the
  name of a firewall policy after you create it. You must specify the ARN or the name, and
  you can specify both.
"""
function delete_firewall_policy(; aws_config::AbstractAWSConfig=current_aws_config())
    return network_firewall(
        "DeleteFirewallPolicy"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function delete_firewall_policy(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return network_firewall(
        "DeleteFirewallPolicy",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_resource_policy(resource_arn)
    delete_resource_policy(resource_arn, params::Dict{String,<:Any})

Deletes a resource policy that you created in a PutResourcePolicy request.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the rule group or firewall policy whose
  resource policy you want to delete.

"""
function delete_resource_policy(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return network_firewall(
        "DeleteResourcePolicy",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_resource_policy(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return network_firewall(
        "DeleteResourcePolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_rule_group()
    delete_rule_group(params::Dict{String,<:Any})

Deletes the specified RuleGroup.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"RuleGroupArn"`: The Amazon Resource Name (ARN) of the rule group. You must specify the
  ARN or the name, and you can specify both.
- `"RuleGroupName"`: The descriptive name of the rule group. You can't change the name of a
  rule group after you create it. You must specify the ARN or the name, and you can specify
  both.
- `"Type"`: Indicates whether the rule group is stateless or stateful. If the rule group is
  stateless, it contains stateless rules. If it is stateful, it contains stateful rules.
  This setting is required for requests that do not include the RuleGroupARN.
"""
function delete_rule_group(; aws_config::AbstractAWSConfig=current_aws_config())
    return network_firewall(
        "DeleteRuleGroup"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function delete_rule_group(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return network_firewall(
        "DeleteRuleGroup", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    delete_tlsinspection_configuration()
    delete_tlsinspection_configuration(params::Dict{String,<:Any})

Deletes the specified TLSInspectionConfiguration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"TLSInspectionConfigurationArn"`: The Amazon Resource Name (ARN) of the TLS inspection
  configuration. You must specify the ARN or the name, and you can specify both.
- `"TLSInspectionConfigurationName"`: The descriptive name of the TLS inspection
  configuration. You can't change the name of a TLS inspection configuration after you create
  it. You must specify the ARN or the name, and you can specify both.
"""
function delete_tlsinspection_configuration(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return network_firewall(
        "DeleteTLSInspectionConfiguration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_tlsinspection_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return network_firewall(
        "DeleteTLSInspectionConfiguration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_firewall()
    describe_firewall(params::Dict{String,<:Any})

Returns the data objects for the specified firewall.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FirewallArn"`: The Amazon Resource Name (ARN) of the firewall. You must specify the ARN
  or the name, and you can specify both.
- `"FirewallName"`: The descriptive name of the firewall. You can't change the name of a
  firewall after you create it. You must specify the ARN or the name, and you can specify
  both.
"""
function describe_firewall(; aws_config::AbstractAWSConfig=current_aws_config())
    return network_firewall(
        "DescribeFirewall"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_firewall(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return network_firewall(
        "DescribeFirewall", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_firewall_policy()
    describe_firewall_policy(params::Dict{String,<:Any})

Returns the data objects for the specified firewall policy.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FirewallPolicyArn"`: The Amazon Resource Name (ARN) of the firewall policy. You must
  specify the ARN or the name, and you can specify both.
- `"FirewallPolicyName"`: The descriptive name of the firewall policy. You can't change the
  name of a firewall policy after you create it. You must specify the ARN or the name, and
  you can specify both.
"""
function describe_firewall_policy(; aws_config::AbstractAWSConfig=current_aws_config())
    return network_firewall(
        "DescribeFirewallPolicy"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_firewall_policy(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return network_firewall(
        "DescribeFirewallPolicy",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_logging_configuration()
    describe_logging_configuration(params::Dict{String,<:Any})

Returns the logging configuration for the specified firewall.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FirewallArn"`: The Amazon Resource Name (ARN) of the firewall. You must specify the ARN
  or the name, and you can specify both.
- `"FirewallName"`: The descriptive name of the firewall. You can't change the name of a
  firewall after you create it. You must specify the ARN or the name, and you can specify
  both.
"""
function describe_logging_configuration(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return network_firewall(
        "DescribeLoggingConfiguration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_logging_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return network_firewall(
        "DescribeLoggingConfiguration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_resource_policy(resource_arn)
    describe_resource_policy(resource_arn, params::Dict{String,<:Any})

Retrieves a resource policy that you created in a PutResourcePolicy request.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the rule group or firewall policy whose
  resource policy you want to retrieve.

"""
function describe_resource_policy(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return network_firewall(
        "DescribeResourcePolicy",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_resource_policy(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return network_firewall(
        "DescribeResourcePolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_rule_group()
    describe_rule_group(params::Dict{String,<:Any})

Returns the data objects for the specified rule group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AnalyzeRuleGroup"`: Indicates whether you want Network Firewall to analyze the
  stateless rules in the rule group for rule behavior such as asymmetric routing. If set to
  TRUE, Network Firewall runs the analysis.
- `"RuleGroupArn"`: The Amazon Resource Name (ARN) of the rule group. You must specify the
  ARN or the name, and you can specify both.
- `"RuleGroupName"`: The descriptive name of the rule group. You can't change the name of a
  rule group after you create it. You must specify the ARN or the name, and you can specify
  both.
- `"Type"`: Indicates whether the rule group is stateless or stateful. If the rule group is
  stateless, it contains stateless rules. If it is stateful, it contains stateful rules.
  This setting is required for requests that do not include the RuleGroupARN.
"""
function describe_rule_group(; aws_config::AbstractAWSConfig=current_aws_config())
    return network_firewall(
        "DescribeRuleGroup"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_rule_group(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return network_firewall(
        "DescribeRuleGroup", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_rule_group_metadata()
    describe_rule_group_metadata(params::Dict{String,<:Any})

High-level information about a rule group, returned by operations like create and describe.
You can use the information provided in the metadata to retrieve and manage a rule group.
You can retrieve all objects for a rule group by calling DescribeRuleGroup.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"RuleGroupArn"`: The descriptive name of the rule group. You can't change the name of a
  rule group after you create it. You must specify the ARN or the name, and you can specify
  both.
- `"RuleGroupName"`: The descriptive name of the rule group. You can't change the name of a
  rule group after you create it. You must specify the ARN or the name, and you can specify
  both.
- `"Type"`: Indicates whether the rule group is stateless or stateful. If the rule group is
  stateless, it contains stateless rules. If it is stateful, it contains stateful rules.
  This setting is required for requests that do not include the RuleGroupARN.
"""
function describe_rule_group_metadata(; aws_config::AbstractAWSConfig=current_aws_config())
    return network_firewall(
        "DescribeRuleGroupMetadata"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_rule_group_metadata(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return network_firewall(
        "DescribeRuleGroupMetadata",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_tlsinspection_configuration()
    describe_tlsinspection_configuration(params::Dict{String,<:Any})

Returns the data objects for the specified TLS inspection configuration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"TLSInspectionConfigurationArn"`: The Amazon Resource Name (ARN) of the TLS inspection
  configuration. You must specify the ARN or the name, and you can specify both.
- `"TLSInspectionConfigurationName"`: The descriptive name of the TLS inspection
  configuration. You can't change the name of a TLS inspection configuration after you create
  it. You must specify the ARN or the name, and you can specify both.
"""
function describe_tlsinspection_configuration(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return network_firewall(
        "DescribeTLSInspectionConfiguration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_tlsinspection_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return network_firewall(
        "DescribeTLSInspectionConfiguration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_subnets(subnet_ids)
    disassociate_subnets(subnet_ids, params::Dict{String,<:Any})

Removes the specified subnet associations from the firewall. This removes the firewall
endpoints from the subnets and removes any network filtering protections that the endpoints
were providing.

# Arguments
- `subnet_ids`: The unique identifiers for the subnets that you want to disassociate.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FirewallArn"`: The Amazon Resource Name (ARN) of the firewall. You must specify the ARN
  or the name, and you can specify both.
- `"FirewallName"`: The descriptive name of the firewall. You can't change the name of a
  firewall after you create it. You must specify the ARN or the name, and you can specify
  both.
- `"UpdateToken"`: An optional token that you can use for optimistic locking. Network
  Firewall returns a token to your requests that access the firewall. The token marks the
  state of the firewall resource at the time of the request.  To make an unconditional change
  to the firewall, omit the token in your update request. Without the token, Network Firewall
  performs your updates regardless of whether the firewall has changed since you last
  retrieved it. To make a conditional change to the firewall, provide the token in your
  update request. Network Firewall uses the token to ensure that the firewall hasn't changed
  since you last retrieved it. If it has changed, the operation fails with an
  InvalidTokenException. If this happens, retrieve the firewall again to get a current copy
  of it with a new token. Reapply your changes as needed, then try the operation again using
  the new token.
"""
function disassociate_subnets(SubnetIds; aws_config::AbstractAWSConfig=current_aws_config())
    return network_firewall(
        "DisassociateSubnets",
        Dict{String,Any}("SubnetIds" => SubnetIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_subnets(
    SubnetIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return network_firewall(
        "DisassociateSubnets",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("SubnetIds" => SubnetIds), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_firewall_policies()
    list_firewall_policies(params::Dict{String,<:Any})

Retrieves the metadata for the firewall policies that you have defined. Depending on your
setting for max results and the number of firewall policies, a single call might not return
the full list.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of objects that you want Network Firewall to return
  for this request. If more objects are available, in the response, Network Firewall provides
  a NextToken value that you can use in a subsequent call to get the next batch of objects.
- `"NextToken"`: When you request a list of objects with a MaxResults setting, if the
  number of objects that are still available for retrieval exceeds the maximum you requested,
  Network Firewall returns a NextToken value in the response. To retrieve the next batch of
  objects, use the token returned from the prior request in your next request.
"""
function list_firewall_policies(; aws_config::AbstractAWSConfig=current_aws_config())
    return network_firewall(
        "ListFirewallPolicies"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_firewall_policies(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return network_firewall(
        "ListFirewallPolicies",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_firewalls()
    list_firewalls(params::Dict{String,<:Any})

Retrieves the metadata for the firewalls that you have defined. If you provide VPC
identifiers in your request, this returns only the firewalls for those VPCs. Depending on
your setting for max results and the number of firewalls, a single call might not return
the full list.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of objects that you want Network Firewall to return
  for this request. If more objects are available, in the response, Network Firewall provides
  a NextToken value that you can use in a subsequent call to get the next batch of objects.
- `"NextToken"`: When you request a list of objects with a MaxResults setting, if the
  number of objects that are still available for retrieval exceeds the maximum you requested,
  Network Firewall returns a NextToken value in the response. To retrieve the next batch of
  objects, use the token returned from the prior request in your next request.
- `"VpcIds"`: The unique identifiers of the VPCs that you want Network Firewall to retrieve
  the firewalls for. Leave this blank to retrieve all firewalls that you have defined.
"""
function list_firewalls(; aws_config::AbstractAWSConfig=current_aws_config())
    return network_firewall(
        "ListFirewalls"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_firewalls(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return network_firewall(
        "ListFirewalls", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_rule_groups()
    list_rule_groups(params::Dict{String,<:Any})

Retrieves the metadata for the rule groups that you have defined. Depending on your setting
for max results and the number of rule groups, a single call might not return the full
list.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ManagedType"`: Indicates the general category of the Amazon Web Services managed rule
  group.
- `"MaxResults"`: The maximum number of objects that you want Network Firewall to return
  for this request. If more objects are available, in the response, Network Firewall provides
  a NextToken value that you can use in a subsequent call to get the next batch of objects.
- `"NextToken"`: When you request a list of objects with a MaxResults setting, if the
  number of objects that are still available for retrieval exceeds the maximum you requested,
  Network Firewall returns a NextToken value in the response. To retrieve the next batch of
  objects, use the token returned from the prior request in your next request.
- `"Scope"`: The scope of the request. The default setting of ACCOUNT or a setting of NULL
  returns all of the rule groups in your account. A setting of MANAGED returns all available
  managed rule groups.
- `"Type"`: Indicates whether the rule group is stateless or stateful. If the rule group is
  stateless, it contains stateless rules. If it is stateful, it contains stateful rules.
"""
function list_rule_groups(; aws_config::AbstractAWSConfig=current_aws_config())
    return network_firewall(
        "ListRuleGroups"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_rule_groups(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return network_firewall(
        "ListRuleGroups", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Retrieves the tags associated with the specified resource. Tags are key:value pairs that
you can use to categorize and manage your resources, for purposes like billing. For
example, you might set the tag key to \"customer\" and the value to the customer name or
ID. You can specify one or more tags to add to each Amazon Web Services resource, up to 50
tags for a resource. You can tag the Amazon Web Services resources that you manage through
Network Firewall: firewalls, firewall policies, and rule groups.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of objects that you want Network Firewall to return
  for this request. If more objects are available, in the response, Network Firewall provides
  a NextToken value that you can use in a subsequent call to get the next batch of objects.
- `"NextToken"`: When you request a list of objects with a MaxResults setting, if the
  number of objects that are still available for retrieval exceeds the maximum you requested,
  Network Firewall returns a NextToken value in the response. To retrieve the next batch of
  objects, use the token returned from the prior request in your next request.
"""
function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return network_firewall(
        "ListTagsForResource",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return network_firewall(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tlsinspection_configurations()
    list_tlsinspection_configurations(params::Dict{String,<:Any})

Retrieves the metadata for the TLS inspection configurations that you have defined.
Depending on your setting for max results and the number of TLS inspection configurations,
a single call might not return the full list.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of objects that you want Network Firewall to return
  for this request. If more objects are available, in the response, Network Firewall provides
  a NextToken value that you can use in a subsequent call to get the next batch of objects.
- `"NextToken"`: When you request a list of objects with a MaxResults setting, if the
  number of objects that are still available for retrieval exceeds the maximum you requested,
  Network Firewall returns a NextToken value in the response. To retrieve the next batch of
  objects, use the token returned from the prior request in your next request.
"""
function list_tlsinspection_configurations(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return network_firewall(
        "ListTLSInspectionConfigurations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tlsinspection_configurations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return network_firewall(
        "ListTLSInspectionConfigurations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_resource_policy(policy, resource_arn)
    put_resource_policy(policy, resource_arn, params::Dict{String,<:Any})

Creates or updates an IAM policy for your rule group or firewall policy. Use this to share
rule groups and firewall policies between accounts. This operation works in conjunction
with the Amazon Web Services Resource Access Manager (RAM) service to manage resource
sharing for Network Firewall.  Use this operation to create or update a resource policy for
your rule group or firewall policy. In the policy, you specify the accounts that you want
to share the resource with and the operations that you want the accounts to be able to
perform.  When you add an account in the resource policy, you then run the following
Resource Access Manager (RAM) operations to access and accept the shared rule group or
firewall policy.     GetResourceShareInvitations - Returns the Amazon Resource Names (ARNs)
of the resource share invitations.     AcceptResourceShareInvitation - Accepts the share
invitation for a specified resource share.    For additional information about resource
sharing using RAM, see Resource Access Manager User Guide.

# Arguments
- `policy`: The IAM policy statement that lists the accounts that you want to share your
  rule group or firewall policy with and the operations that you want the accounts to be able
  to perform.  For a rule group resource, you can specify the following operations in the
  Actions section of the statement:   network-firewall:CreateFirewallPolicy
  network-firewall:UpdateFirewallPolicy   network-firewall:ListRuleGroups   For a firewall
  policy resource, you can specify the following operations in the Actions section of the
  statement:   network-firewall:AssociateFirewallPolicy
  network-firewall:ListFirewallPolicies   In the Resource section of the statement, you
  specify the ARNs for the rule groups and firewall policies that you want to share with the
  account that you specified in Arn.
- `resource_arn`: The Amazon Resource Name (ARN) of the account that you want to share rule
  groups and firewall policies with.

"""
function put_resource_policy(
    Policy, ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return network_firewall(
        "PutResourcePolicy",
        Dict{String,Any}("Policy" => Policy, "ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_resource_policy(
    Policy,
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return network_firewall(
        "PutResourcePolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Policy" => Policy, "ResourceArn" => ResourceArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds the specified tags to the specified resource. Tags are key:value pairs that you can
use to categorize and manage your resources, for purposes like billing. For example, you
might set the tag key to \"customer\" and the value to the customer name or ID. You can
specify one or more tags to add to each Amazon Web Services resource, up to 50 tags for a
resource. You can tag the Amazon Web Services resources that you manage through Network
Firewall: firewalls, firewall policies, and rule groups.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.
- `tags`:

"""
function tag_resource(ResourceArn, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return network_firewall(
        "TagResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceArn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return network_firewall(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes the tags with the specified keys from the specified resource. Tags are key:value
pairs that you can use to categorize and manage your resources, for purposes like billing.
For example, you might set the tag key to \"customer\" and the value to the customer name
or ID. You can specify one or more tags to add to each Amazon Web Services resource, up to
50 tags for a resource. You can manage tags for the Amazon Web Services resources that you
manage through Network Firewall: firewalls, firewall policies, and rule groups.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.
- `tag_keys`:

"""
function untag_resource(
    ResourceArn, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return network_firewall(
        "UntagResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceArn,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return network_firewall(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_firewall_delete_protection(delete_protection)
    update_firewall_delete_protection(delete_protection, params::Dict{String,<:Any})

Modifies the flag, DeleteProtection, which indicates whether it is possible to delete the
firewall. If the flag is set to TRUE, the firewall is protected against deletion. This
setting helps protect against accidentally deleting a firewall that's in use.

# Arguments
- `delete_protection`: A flag indicating whether it is possible to delete the firewall. A
  setting of TRUE indicates that the firewall is protected against deletion. Use this setting
  to protect against accidentally deleting a firewall that is in use. When you create a
  firewall, the operation initializes this flag to TRUE.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FirewallArn"`: The Amazon Resource Name (ARN) of the firewall. You must specify the ARN
  or the name, and you can specify both.
- `"FirewallName"`: The descriptive name of the firewall. You can't change the name of a
  firewall after you create it. You must specify the ARN or the name, and you can specify
  both.
- `"UpdateToken"`: An optional token that you can use for optimistic locking. Network
  Firewall returns a token to your requests that access the firewall. The token marks the
  state of the firewall resource at the time of the request.  To make an unconditional change
  to the firewall, omit the token in your update request. Without the token, Network Firewall
  performs your updates regardless of whether the firewall has changed since you last
  retrieved it. To make a conditional change to the firewall, provide the token in your
  update request. Network Firewall uses the token to ensure that the firewall hasn't changed
  since you last retrieved it. If it has changed, the operation fails with an
  InvalidTokenException. If this happens, retrieve the firewall again to get a current copy
  of it with a new token. Reapply your changes as needed, then try the operation again using
  the new token.
"""
function update_firewall_delete_protection(
    DeleteProtection; aws_config::AbstractAWSConfig=current_aws_config()
)
    return network_firewall(
        "UpdateFirewallDeleteProtection",
        Dict{String,Any}("DeleteProtection" => DeleteProtection);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_firewall_delete_protection(
    DeleteProtection,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return network_firewall(
        "UpdateFirewallDeleteProtection",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("DeleteProtection" => DeleteProtection), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_firewall_description()
    update_firewall_description(params::Dict{String,<:Any})

Modifies the description for the specified firewall. Use the description to help you
identify the firewall when you're working with it.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: The new description for the firewall. If you omit this setting, Network
  Firewall removes the description for the firewall.
- `"FirewallArn"`: The Amazon Resource Name (ARN) of the firewall. You must specify the ARN
  or the name, and you can specify both.
- `"FirewallName"`: The descriptive name of the firewall. You can't change the name of a
  firewall after you create it. You must specify the ARN or the name, and you can specify
  both.
- `"UpdateToken"`: An optional token that you can use for optimistic locking. Network
  Firewall returns a token to your requests that access the firewall. The token marks the
  state of the firewall resource at the time of the request.  To make an unconditional change
  to the firewall, omit the token in your update request. Without the token, Network Firewall
  performs your updates regardless of whether the firewall has changed since you last
  retrieved it. To make a conditional change to the firewall, provide the token in your
  update request. Network Firewall uses the token to ensure that the firewall hasn't changed
  since you last retrieved it. If it has changed, the operation fails with an
  InvalidTokenException. If this happens, retrieve the firewall again to get a current copy
  of it with a new token. Reapply your changes as needed, then try the operation again using
  the new token.
"""
function update_firewall_description(; aws_config::AbstractAWSConfig=current_aws_config())
    return network_firewall(
        "UpdateFirewallDescription"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function update_firewall_description(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return network_firewall(
        "UpdateFirewallDescription",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_firewall_encryption_configuration()
    update_firewall_encryption_configuration(params::Dict{String,<:Any})

A complex type that contains settings for encryption of your firewall resources.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EncryptionConfiguration"`:
- `"FirewallArn"`: The Amazon Resource Name (ARN) of the firewall.
- `"FirewallName"`: The descriptive name of the firewall. You can't change the name of a
  firewall after you create it.
- `"UpdateToken"`: An optional token that you can use for optimistic locking. Network
  Firewall returns a token to your requests that access the firewall. The token marks the
  state of the firewall resource at the time of the request.  To make an unconditional change
  to the firewall, omit the token in your update request. Without the token, Network Firewall
  performs your updates regardless of whether the firewall has changed since you last
  retrieved it. To make a conditional change to the firewall, provide the token in your
  update request. Network Firewall uses the token to ensure that the firewall hasn't changed
  since you last retrieved it. If it has changed, the operation fails with an
  InvalidTokenException. If this happens, retrieve the firewall again to get a current copy
  of it with a new token. Reapply your changes as needed, then try the operation again using
  the new token.
"""
function update_firewall_encryption_configuration(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return network_firewall(
        "UpdateFirewallEncryptionConfiguration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_firewall_encryption_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return network_firewall(
        "UpdateFirewallEncryptionConfiguration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_firewall_policy(firewall_policy, update_token)
    update_firewall_policy(firewall_policy, update_token, params::Dict{String,<:Any})

Updates the properties of the specified firewall policy.

# Arguments
- `firewall_policy`: The updated firewall policy to use for the firewall. You can't add or
  remove a TLSInspectionConfiguration after you create a firewall policy. However, you can
  replace an existing TLS inspection configuration with another TLSInspectionConfiguration.
- `update_token`: A token used for optimistic locking. Network Firewall returns a token to
  your requests that access the firewall policy. The token marks the state of the policy
  resource at the time of the request.  To make changes to the policy, you provide the token
  in your request. Network Firewall uses the token to ensure that the policy hasn't changed
  since you last retrieved it. If it has changed, the operation fails with an
  InvalidTokenException. If this happens, retrieve the firewall policy again to get a current
  copy of it with current token. Reapply your changes as needed, then try the operation again
  using the new token.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description of the firewall policy.
- `"DryRun"`: Indicates whether you want Network Firewall to just check the validity of the
  request, rather than run the request.  If set to TRUE, Network Firewall checks whether the
  request can run successfully, but doesn't actually make the requested changes. The call
  returns the value that the request would return if you ran it with dry run set to FALSE,
  but doesn't make additions or changes to your resources. This option allows you to make
  sure that you have the required permissions to run the request and that your request
  parameters are valid.  If set to FALSE, Network Firewall makes the requested changes to
  your resources.
- `"EncryptionConfiguration"`: A complex type that contains settings for encryption of your
  firewall policy resources.
- `"FirewallPolicyArn"`: The Amazon Resource Name (ARN) of the firewall policy. You must
  specify the ARN or the name, and you can specify both.
- `"FirewallPolicyName"`: The descriptive name of the firewall policy. You can't change the
  name of a firewall policy after you create it. You must specify the ARN or the name, and
  you can specify both.
"""
function update_firewall_policy(
    FirewallPolicy, UpdateToken; aws_config::AbstractAWSConfig=current_aws_config()
)
    return network_firewall(
        "UpdateFirewallPolicy",
        Dict{String,Any}("FirewallPolicy" => FirewallPolicy, "UpdateToken" => UpdateToken);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_firewall_policy(
    FirewallPolicy,
    UpdateToken,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return network_firewall(
        "UpdateFirewallPolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "FirewallPolicy" => FirewallPolicy, "UpdateToken" => UpdateToken
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_firewall_policy_change_protection(firewall_policy_change_protection)
    update_firewall_policy_change_protection(firewall_policy_change_protection, params::Dict{String,<:Any})

Modifies the flag, ChangeProtection, which indicates whether it is possible to change the
firewall. If the flag is set to TRUE, the firewall is protected from changes. This setting
helps protect against accidentally changing a firewall that's in use.

# Arguments
- `firewall_policy_change_protection`: A setting indicating whether the firewall is
  protected against a change to the firewall policy association. Use this setting to protect
  against accidentally modifying the firewall policy for a firewall that is in use. When you
  create a firewall, the operation initializes this setting to TRUE.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FirewallArn"`: The Amazon Resource Name (ARN) of the firewall. You must specify the ARN
  or the name, and you can specify both.
- `"FirewallName"`: The descriptive name of the firewall. You can't change the name of a
  firewall after you create it. You must specify the ARN or the name, and you can specify
  both.
- `"UpdateToken"`: An optional token that you can use for optimistic locking. Network
  Firewall returns a token to your requests that access the firewall. The token marks the
  state of the firewall resource at the time of the request.  To make an unconditional change
  to the firewall, omit the token in your update request. Without the token, Network Firewall
  performs your updates regardless of whether the firewall has changed since you last
  retrieved it. To make a conditional change to the firewall, provide the token in your
  update request. Network Firewall uses the token to ensure that the firewall hasn't changed
  since you last retrieved it. If it has changed, the operation fails with an
  InvalidTokenException. If this happens, retrieve the firewall again to get a current copy
  of it with a new token. Reapply your changes as needed, then try the operation again using
  the new token.
"""
function update_firewall_policy_change_protection(
    FirewallPolicyChangeProtection; aws_config::AbstractAWSConfig=current_aws_config()
)
    return network_firewall(
        "UpdateFirewallPolicyChangeProtection",
        Dict{String,Any}(
            "FirewallPolicyChangeProtection" => FirewallPolicyChangeProtection
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_firewall_policy_change_protection(
    FirewallPolicyChangeProtection,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return network_firewall(
        "UpdateFirewallPolicyChangeProtection",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "FirewallPolicyChangeProtection" => FirewallPolicyChangeProtection
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_logging_configuration()
    update_logging_configuration(params::Dict{String,<:Any})

Sets the logging configuration for the specified firewall.  To change the logging
configuration, retrieve the LoggingConfiguration by calling DescribeLoggingConfiguration,
then change it and provide the modified object to this update call. You must change the
logging configuration one LogDestinationConfig at a time inside the retrieved
LoggingConfiguration object.  You can perform only one of the following actions in any call
to UpdateLoggingConfiguration:    Create a new log destination object by adding a single
LogDestinationConfig array element to LogDestinationConfigs.   Delete a log destination
object by removing a single LogDestinationConfig array element from LogDestinationConfigs.
 Change the LogDestination setting in a single LogDestinationConfig array element.   You
can't change the LogDestinationType or LogType in a LogDestinationConfig. To change these
settings, delete the existing LogDestinationConfig object and create a new one, using two
separate calls to this update operation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FirewallArn"`: The Amazon Resource Name (ARN) of the firewall. You must specify the ARN
  or the name, and you can specify both.
- `"FirewallName"`: The descriptive name of the firewall. You can't change the name of a
  firewall after you create it. You must specify the ARN or the name, and you can specify
  both.
- `"LoggingConfiguration"`: Defines how Network Firewall performs logging for a firewall.
  If you omit this setting, Network Firewall disables logging for the firewall.
"""
function update_logging_configuration(; aws_config::AbstractAWSConfig=current_aws_config())
    return network_firewall(
        "UpdateLoggingConfiguration"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function update_logging_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return network_firewall(
        "UpdateLoggingConfiguration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_rule_group(update_token)
    update_rule_group(update_token, params::Dict{String,<:Any})

Updates the rule settings for the specified rule group. You use a rule group by reference
in one or more firewall policies. When you modify a rule group, you modify all firewall
policies that use the rule group.  To update a rule group, first call DescribeRuleGroup to
retrieve the current RuleGroup object, update the object as needed, and then provide the
updated object to this call.

# Arguments
- `update_token`: A token used for optimistic locking. Network Firewall returns a token to
  your requests that access the rule group. The token marks the state of the rule group
  resource at the time of the request.  To make changes to the rule group, you provide the
  token in your request. Network Firewall uses the token to ensure that the rule group hasn't
  changed since you last retrieved it. If it has changed, the operation fails with an
  InvalidTokenException. If this happens, retrieve the rule group again to get a current copy
  of it with a current token. Reapply your changes as needed, then try the operation again
  using the new token.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AnalyzeRuleGroup"`: Indicates whether you want Network Firewall to analyze the
  stateless rules in the rule group for rule behavior such as asymmetric routing. If set to
  TRUE, Network Firewall runs the analysis and then updates the rule group for you. To run
  the stateless rule group analyzer without updating the rule group, set DryRun to TRUE.
- `"Description"`: A description of the rule group.
- `"DryRun"`: Indicates whether you want Network Firewall to just check the validity of the
  request, rather than run the request.  If set to TRUE, Network Firewall checks whether the
  request can run successfully, but doesn't actually make the requested changes. The call
  returns the value that the request would return if you ran it with dry run set to FALSE,
  but doesn't make additions or changes to your resources. This option allows you to make
  sure that you have the required permissions to run the request and that your request
  parameters are valid.  If set to FALSE, Network Firewall makes the requested changes to
  your resources.
- `"EncryptionConfiguration"`: A complex type that contains settings for encryption of your
  rule group resources.
- `"RuleGroup"`: An object that defines the rule group rules.   You must provide either
  this rule group setting or a Rules setting, but not both.
- `"RuleGroupArn"`: The Amazon Resource Name (ARN) of the rule group. You must specify the
  ARN or the name, and you can specify both.
- `"RuleGroupName"`: The descriptive name of the rule group. You can't change the name of a
  rule group after you create it. You must specify the ARN or the name, and you can specify
  both.
- `"Rules"`: A string containing stateful rule group rules specifications in Suricata flat
  format, with one rule per line. Use this to import your existing Suricata compatible rule
  groups.   You must provide either this rules setting or a populated RuleGroup setting, but
  not both.   You can provide your rule group specification in Suricata flat format through
  this setting when you create or update your rule group. The call response returns a
  RuleGroup object that Network Firewall has populated from your string.
- `"SourceMetadata"`: A complex type that contains metadata about the rule group that your
  own rule group is copied from. You can use the metadata to keep track of updates made to
  the originating rule group.
- `"Type"`: Indicates whether the rule group is stateless or stateful. If the rule group is
  stateless, it contains stateless rules. If it is stateful, it contains stateful rules.
  This setting is required for requests that do not include the RuleGroupARN.
"""
function update_rule_group(UpdateToken; aws_config::AbstractAWSConfig=current_aws_config())
    return network_firewall(
        "UpdateRuleGroup",
        Dict{String,Any}("UpdateToken" => UpdateToken);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_rule_group(
    UpdateToken,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return network_firewall(
        "UpdateRuleGroup",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("UpdateToken" => UpdateToken), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_subnet_change_protection(subnet_change_protection)
    update_subnet_change_protection(subnet_change_protection, params::Dict{String,<:Any})



# Arguments
- `subnet_change_protection`: A setting indicating whether the firewall is protected
  against changes to the subnet associations. Use this setting to protect against
  accidentally modifying the subnet associations for a firewall that is in use. When you
  create a firewall, the operation initializes this setting to TRUE.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FirewallArn"`: The Amazon Resource Name (ARN) of the firewall. You must specify the ARN
  or the name, and you can specify both.
- `"FirewallName"`: The descriptive name of the firewall. You can't change the name of a
  firewall after you create it. You must specify the ARN or the name, and you can specify
  both.
- `"UpdateToken"`: An optional token that you can use for optimistic locking. Network
  Firewall returns a token to your requests that access the firewall. The token marks the
  state of the firewall resource at the time of the request.  To make an unconditional change
  to the firewall, omit the token in your update request. Without the token, Network Firewall
  performs your updates regardless of whether the firewall has changed since you last
  retrieved it. To make a conditional change to the firewall, provide the token in your
  update request. Network Firewall uses the token to ensure that the firewall hasn't changed
  since you last retrieved it. If it has changed, the operation fails with an
  InvalidTokenException. If this happens, retrieve the firewall again to get a current copy
  of it with a new token. Reapply your changes as needed, then try the operation again using
  the new token.
"""
function update_subnet_change_protection(
    SubnetChangeProtection; aws_config::AbstractAWSConfig=current_aws_config()
)
    return network_firewall(
        "UpdateSubnetChangeProtection",
        Dict{String,Any}("SubnetChangeProtection" => SubnetChangeProtection);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_subnet_change_protection(
    SubnetChangeProtection,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return network_firewall(
        "UpdateSubnetChangeProtection",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("SubnetChangeProtection" => SubnetChangeProtection),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_tlsinspection_configuration(tlsinspection_configuration, update_token)
    update_tlsinspection_configuration(tlsinspection_configuration, update_token, params::Dict{String,<:Any})

Updates the TLS inspection configuration settings for the specified TLS inspection
configuration. You use a TLS inspection configuration by referencing it in one or more
firewall policies. When you modify a TLS inspection configuration, you modify all firewall
policies that use the TLS inspection configuration.  To update a TLS inspection
configuration, first call DescribeTLSInspectionConfiguration to retrieve the current
TLSInspectionConfiguration object, update the object as needed, and then provide the
updated object to this call.

# Arguments
- `tlsinspection_configuration`: The object that defines a TLS inspection configuration.
  This, along with TLSInspectionConfigurationResponse, define the TLS inspection
  configuration. You can retrieve all objects for a TLS inspection configuration by calling
  DescribeTLSInspectionConfiguration.  Network Firewall uses a TLS inspection configuration
  to decrypt traffic. Network Firewall re-encrypts the traffic before sending it to its
  destination. To use a TLS inspection configuration, you add it to a new Network Firewall
  firewall policy, then you apply the firewall policy to a firewall. Network Firewall acts as
  a proxy service to decrypt and inspect the traffic traveling through your firewalls. You
  can reference a TLS inspection configuration from more than one firewall policy, and you
  can use a firewall policy in more than one firewall. For more information about using TLS
  inspection configurations, see Inspecting SSL/TLS traffic with TLS inspection
  configurations in the Network Firewall Developer Guide.
- `update_token`: A token used for optimistic locking. Network Firewall returns a token to
  your requests that access the TLS inspection configuration. The token marks the state of
  the TLS inspection configuration resource at the time of the request.  To make changes to
  the TLS inspection configuration, you provide the token in your request. Network Firewall
  uses the token to ensure that the TLS inspection configuration hasn't changed since you
  last retrieved it. If it has changed, the operation fails with an InvalidTokenException. If
  this happens, retrieve the TLS inspection configuration again to get a current copy of it
  with a current token. Reapply your changes as needed, then try the operation again using
  the new token.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description of the TLS inspection configuration.
- `"EncryptionConfiguration"`: A complex type that contains the Amazon Web Services KMS
  encryption configuration settings for your TLS inspection configuration.
- `"TLSInspectionConfigurationArn"`: The Amazon Resource Name (ARN) of the TLS inspection
  configuration.
- `"TLSInspectionConfigurationName"`: The descriptive name of the TLS inspection
  configuration. You can't change the name of a TLS inspection configuration after you create
  it.
"""
function update_tlsinspection_configuration(
    TLSInspectionConfiguration,
    UpdateToken;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return network_firewall(
        "UpdateTLSInspectionConfiguration",
        Dict{String,Any}(
            "TLSInspectionConfiguration" => TLSInspectionConfiguration,
            "UpdateToken" => UpdateToken,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_tlsinspection_configuration(
    TLSInspectionConfiguration,
    UpdateToken,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return network_firewall(
        "UpdateTLSInspectionConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "TLSInspectionConfiguration" => TLSInspectionConfiguration,
                    "UpdateToken" => UpdateToken,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: resource_groups
using AWS.Compat
using AWS.UUIDs

"""
    create_group(name)
    create_group(name, params::Dict{String,<:Any})

Creates a resource group with the specified name and description. You can optionally
include either a resource query or a service configuration. For more information about
constructing a resource query, see Build queries and groups in Resource Groups in the
Resource Groups User Guide. For more information about service-linked groups and service
configurations, see Service configurations for Resource Groups.  Minimum permissions  To
run this command, you must have the following permissions:    resource-groups:CreateGroup

# Arguments
- `name`: The name of the group, which is the identifier of the group in other operations.
  You can't change the name of a resource group after you create it. A resource group name
  can consist of letters, numbers, hyphens, periods, and underscores. The name cannot start
  with AWS, aws, or any other possible capitalization; these are reserved. A resource group
  name must be unique within each Amazon Web Services Region in your Amazon Web Services
  account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Configuration"`: A configuration associates the resource group with an Amazon Web
  Services service and specifies how the service can interact with the resources in the
  group. A configuration is an array of GroupConfigurationItem elements. For details about
  the syntax of service configurations, see Service configurations for Resource Groups.  A
  resource group can contain either a Configuration or a ResourceQuery, but not both.
- `"Description"`: The description of the resource group. Descriptions can consist of
  letters, numbers, hyphens, underscores, periods, and spaces.
- `"ResourceQuery"`: The resource query that determines which Amazon Web Services resources
  are members of this group. For more information about resource queries, see Create a
  tag-based group in Resource Groups.   A resource group can contain either a ResourceQuery
  or a Configuration, but not both.
- `"Tags"`: The tags to add to the group. A tag is key-value pair string.
"""
function create_group(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return resource_groups(
        "POST",
        "/groups",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_group(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resource_groups(
        "POST",
        "/groups",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_group()
    delete_group(params::Dict{String,<:Any})

Deletes the specified resource group. Deleting a resource group does not delete any
resources that are members of the group; it only deletes the group structure.  Minimum
permissions  To run this command, you must have the following permissions:
resource-groups:DeleteGroup

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Group"`: The name or the ARN of the resource group to delete.
- `"GroupName"`: Deprecated - don't use this parameter. Use Group instead.
"""
function delete_group(; aws_config::AbstractAWSConfig=current_aws_config())
    return resource_groups(
        "POST", "/delete-group"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function delete_group(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resource_groups(
        "POST",
        "/delete-group",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_account_settings()
    get_account_settings(params::Dict{String,<:Any})

Retrieves the current status of optional features in Resource Groups.

"""
function get_account_settings(; aws_config::AbstractAWSConfig=current_aws_config())
    return resource_groups(
        "POST",
        "/get-account-settings";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_account_settings(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resource_groups(
        "POST",
        "/get-account-settings",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_group()
    get_group(params::Dict{String,<:Any})

Returns information about a specified resource group.  Minimum permissions  To run this
command, you must have the following permissions:    resource-groups:GetGroup

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Group"`: The name or the ARN of the resource group to retrieve.
- `"GroupName"`: Deprecated - don't use this parameter. Use Group instead.
"""
function get_group(; aws_config::AbstractAWSConfig=current_aws_config())
    return resource_groups(
        "POST", "/get-group"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_group(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resource_groups(
        "POST", "/get-group", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_group_configuration()
    get_group_configuration(params::Dict{String,<:Any})

Retrieves the service configuration associated with the specified resource group. For
details about the service configuration syntax, see Service configurations for Resource
Groups.  Minimum permissions  To run this command, you must have the following permissions:
   resource-groups:GetGroupConfiguration

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Group"`: The name or the ARN of the resource group for which you want to retrive the
  service configuration.
"""
function get_group_configuration(; aws_config::AbstractAWSConfig=current_aws_config())
    return resource_groups(
        "POST",
        "/get-group-configuration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_group_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resource_groups(
        "POST",
        "/get-group-configuration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_group_query()
    get_group_query(params::Dict{String,<:Any})

Retrieves the resource query associated with the specified resource group. For more
information about resource queries, see Create a tag-based group in Resource Groups.
Minimum permissions  To run this command, you must have the following permissions:
resource-groups:GetGroupQuery

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Group"`: The name or the ARN of the resource group to query.
- `"GroupName"`: Don't use this parameter. Use Group instead.
"""
function get_group_query(; aws_config::AbstractAWSConfig=current_aws_config())
    return resource_groups(
        "POST", "/get-group-query"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_group_query(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resource_groups(
        "POST",
        "/get-group-query",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_tags(arn)
    get_tags(arn, params::Dict{String,<:Any})

Returns a list of tags that are associated with a resource group, specified by an ARN.
Minimum permissions  To run this command, you must have the following permissions:
resource-groups:GetTags

# Arguments
- `arn`: The ARN of the resource group whose tags you want to retrieve.

"""
function get_tags(Arn; aws_config::AbstractAWSConfig=current_aws_config())
    return resource_groups(
        "GET",
        "/resources/$(Arn)/tags";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_tags(
    Arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resource_groups(
        "GET",
        "/resources/$(Arn)/tags",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    group_resources(group, resource_arns)
    group_resources(group, resource_arns, params::Dict{String,<:Any})

Adds the specified resources to the specified group.  You can use this operation with only
resource groups that are configured with the following types:    AWS::EC2::HostManagement
  AWS::EC2::CapacityReservationPool    Other resource group type and resource types aren't
currently supported by this operation.   Minimum permissions  To run this command, you must
have the following permissions:    resource-groups:GroupResources

# Arguments
- `group`: The name or the ARN of the resource group to add resources to.
- `resource_arns`: The list of ARNs of the resources to be added to the group.

"""
function group_resources(
    Group, ResourceArns; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resource_groups(
        "POST",
        "/group-resources",
        Dict{String,Any}("Group" => Group, "ResourceArns" => ResourceArns);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function group_resources(
    Group,
    ResourceArns,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return resource_groups(
        "POST",
        "/group-resources",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Group" => Group, "ResourceArns" => ResourceArns),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_group_resources()
    list_group_resources(params::Dict{String,<:Any})

Returns a list of ARNs of the resources that are members of a specified resource group.
Minimum permissions  To run this command, you must have the following permissions:
resource-groups:ListGroupResources     cloudformation:DescribeStacks
cloudformation:ListStackResources     tag:GetResources

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: Filters, formatted as ResourceFilter objects, that you want to apply to a
  ListGroupResources operation. Filters the results to include only those of the specified
  resource types.    resource-type - Filter resources by their type. Specify up to five
  resource types in the format AWS::ServiceCode::ResourceType. For example,
  AWS::EC2::Instance, or AWS::S3::Bucket.    When you specify a resource-type filter for
  ListGroupResources, Resource Groups validates your filter resource types against the types
  that are defined in the query associated with the group. For example, if a group contains
  only S3 buckets because its query specifies only that resource type, but your resource-type
  filter includes EC2 instances, AWS Resource Groups does not filter for EC2 instances. In
  this case, a ListGroupResources request returns a BadRequestException error with a message
  similar to the following:  The resource types specified as filters in the request are not
  valid.  The error includes a list of resource types that failed the validation because they
  are not part of the query associated with the group. This validation doesn't occur when the
  group query specifies AWS::AllSupported, because a group based on such a query can contain
  any of the allowed resource types for the query type (tag-based or Amazon CloudFront
  stack-based queries).
- `"Group"`: The name or the ARN of the resource group
- `"GroupName"`:    Deprecated - don't use this parameter. Use the Group request field
  instead.
- `"MaxResults"`: The total number of results that you want included on each page of the
  response. If you do not include this parameter, it defaults to a value that is specific to
  the operation. If additional items exist beyond the maximum you specify, the NextToken
  response element is present and has a value (is not null). Include that value as the
  NextToken request parameter in the next call to the operation to get the next part of the
  results. Note that the service might return fewer results than the maximum even when there
  are more results available. You should check NextToken after every operation to ensure that
  you receive all of the results.
- `"NextToken"`: The parameter for receiving additional results if you receive a NextToken
  response in a previous request. A NextToken response indicates that more output is
  available. Set this parameter to the value provided by a previous call's NextToken response
  to indicate where the output should continue from.
"""
function list_group_resources(; aws_config::AbstractAWSConfig=current_aws_config())
    return resource_groups(
        "POST",
        "/list-group-resources";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_group_resources(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resource_groups(
        "POST",
        "/list-group-resources",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_groups()
    list_groups(params::Dict{String,<:Any})

Returns a list of existing Resource Groups in your account.  Minimum permissions  To run
this command, you must have the following permissions:    resource-groups:ListGroups

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: Filters, formatted as GroupFilter objects, that you want to apply to a
  ListGroups operation.    resource-type - Filter the results to include only those resource
  groups that have the specified resource type in their ResourceTypeFilter. For example,
  AWS::EC2::Instance would return any resource group with a ResourceTypeFilter that includes
  AWS::EC2::Instance.    configuration-type - Filter the results to include only those groups
  that have the specified configuration types attached. The current supported values are:
  AWS::AppRegistry::Application     AWS::AppRegistry::ApplicationResourceGroups
  AWS::CloudFormation::Stack     AWS::EC2::CapacityReservationPool
  AWS::EC2::HostManagement     AWS::NetworkFirewall::RuleGroup
- `"maxResults"`: The total number of results that you want included on each page of the
  response. If you do not include this parameter, it defaults to a value that is specific to
  the operation. If additional items exist beyond the maximum you specify, the NextToken
  response element is present and has a value (is not null). Include that value as the
  NextToken request parameter in the next call to the operation to get the next part of the
  results. Note that the service might return fewer results than the maximum even when there
  are more results available. You should check NextToken after every operation to ensure that
  you receive all of the results.
- `"nextToken"`: The parameter for receiving additional results if you receive a NextToken
  response in a previous request. A NextToken response indicates that more output is
  available. Set this parameter to the value provided by a previous call's NextToken response
  to indicate where the output should continue from.
"""
function list_groups(; aws_config::AbstractAWSConfig=current_aws_config())
    return resource_groups(
        "POST", "/groups-list"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_groups(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resource_groups(
        "POST",
        "/groups-list",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_group_configuration()
    put_group_configuration(params::Dict{String,<:Any})

Attaches a service configuration to the specified group. This occurs asynchronously, and
can take time to complete. You can use GetGroupConfiguration to check the status of the
update.  Minimum permissions  To run this command, you must have the following permissions:
   resource-groups:PutGroupConfiguration

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Configuration"`: The new configuration to associate with the specified group. A
  configuration associates the resource group with an Amazon Web Services service and
  specifies how the service can interact with the resources in the group. A configuration is
  an array of GroupConfigurationItem elements. For information about the syntax of a service
  configuration, see Service configurations for Resource Groups.  A resource group can
  contain either a Configuration or a ResourceQuery, but not both.
- `"Group"`: The name or ARN of the resource group with the configuration that you want to
  update.
"""
function put_group_configuration(; aws_config::AbstractAWSConfig=current_aws_config())
    return resource_groups(
        "POST",
        "/put-group-configuration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_group_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resource_groups(
        "POST",
        "/put-group-configuration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    search_resources(resource_query)
    search_resources(resource_query, params::Dict{String,<:Any})

Returns a list of Amazon Web Services resource identifiers that matches the specified
query. The query uses the same format as a resource query in a CreateGroup or
UpdateGroupQuery operation.  Minimum permissions  To run this command, you must have the
following permissions:    resource-groups:SearchResources     cloudformation:DescribeStacks
    cloudformation:ListStackResources     tag:GetResources

# Arguments
- `resource_query`: The search query, using the same formats that are supported for
  resource group definition. For more information, see CreateGroup.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The total number of results that you want included on each page of the
  response. If you do not include this parameter, it defaults to a value that is specific to
  the operation. If additional items exist beyond the maximum you specify, the NextToken
  response element is present and has a value (is not null). Include that value as the
  NextToken request parameter in the next call to the operation to get the next part of the
  results. Note that the service might return fewer results than the maximum even when there
  are more results available. You should check NextToken after every operation to ensure that
  you receive all of the results.
- `"NextToken"`: The parameter for receiving additional results if you receive a NextToken
  response in a previous request. A NextToken response indicates that more output is
  available. Set this parameter to the value provided by a previous call's NextToken response
  to indicate where the output should continue from.
"""
function search_resources(ResourceQuery; aws_config::AbstractAWSConfig=current_aws_config())
    return resource_groups(
        "POST",
        "/resources/search",
        Dict{String,Any}("ResourceQuery" => ResourceQuery);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function search_resources(
    ResourceQuery,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return resource_groups(
        "POST",
        "/resources/search",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceQuery" => ResourceQuery), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag(arn, tags)
    tag(arn, tags, params::Dict{String,<:Any})

Adds tags to a resource group with the specified ARN. Existing tags on a resource group are
not changed if they are not specified in the request parameters.  Do not store personally
identifiable information (PII) or other confidential or sensitive information in tags. We
use tags to provide you with billing and administration services. Tags are not intended to
be used for private or sensitive data.   Minimum permissions  To run this command, you must
have the following permissions:    resource-groups:Tag

# Arguments
- `arn`: The ARN of the resource group to which to add tags.
- `tags`: The tags to add to the specified resource group. A tag is a string-to-string map
  of key-value pairs.

"""
function tag(Arn, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return resource_groups(
        "PUT",
        "/resources/$(Arn)/tags",
        Dict{String,Any}("Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag(
    Arn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return resource_groups(
        "PUT",
        "/resources/$(Arn)/tags",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Tags" => Tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    ungroup_resources(group, resource_arns)
    ungroup_resources(group, resource_arns, params::Dict{String,<:Any})

Removes the specified resources from the specified group. This operation works only with
static groups that you populated using the GroupResources operation. It doesn't work with
any resource groups that are automatically populated by tag-based or CloudFormation
stack-based queries.  Minimum permissions  To run this command, you must have the following
permissions:    resource-groups:UngroupResources

# Arguments
- `group`: The name or the ARN of the resource group from which to remove the resources.
- `resource_arns`: The ARNs of the resources to be removed from the group.

"""
function ungroup_resources(
    Group, ResourceArns; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resource_groups(
        "POST",
        "/ungroup-resources",
        Dict{String,Any}("Group" => Group, "ResourceArns" => ResourceArns);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function ungroup_resources(
    Group,
    ResourceArns,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return resource_groups(
        "POST",
        "/ungroup-resources",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Group" => Group, "ResourceArns" => ResourceArns),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag(arn, keys)
    untag(arn, keys, params::Dict{String,<:Any})

Deletes tags from a specified resource group.  Minimum permissions  To run this command,
you must have the following permissions:    resource-groups:Untag

# Arguments
- `arn`: The ARN of the resource group from which to remove tags. The command removed both
  the specified keys and any values associated with those keys.
- `keys`: The keys of the tags to be removed.

"""
function untag(Arn, Keys; aws_config::AbstractAWSConfig=current_aws_config())
    return resource_groups(
        "PATCH",
        "/resources/$(Arn)/tags",
        Dict{String,Any}("Keys" => Keys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag(
    Arn,
    Keys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return resource_groups(
        "PATCH",
        "/resources/$(Arn)/tags",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Keys" => Keys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_account_settings()
    update_account_settings(params::Dict{String,<:Any})

Turns on or turns off optional features in Resource Groups. The preceding example shows
that the request to turn on group lifecycle events is IN_PROGRESS. You can call the
GetAccountSettings operation to check for completion by looking for
GroupLifecycleEventsStatus to change to ACTIVE.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"GroupLifecycleEventsDesiredStatus"`: Specifies whether you want to turn group lifecycle
  events on or off.
"""
function update_account_settings(; aws_config::AbstractAWSConfig=current_aws_config())
    return resource_groups(
        "POST",
        "/update-account-settings";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_account_settings(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resource_groups(
        "POST",
        "/update-account-settings",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_group()
    update_group(params::Dict{String,<:Any})

Updates the description for an existing group. You cannot update the name of a resource
group.  Minimum permissions  To run this command, you must have the following permissions:
  resource-groups:UpdateGroup

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: The new description that you want to update the resource group with.
  Descriptions can contain letters, numbers, hyphens, underscores, periods, and spaces.
- `"Group"`: The name or the ARN of the resource group to modify.
- `"GroupName"`: Don't use this parameter. Use Group instead.
"""
function update_group(; aws_config::AbstractAWSConfig=current_aws_config())
    return resource_groups(
        "POST", "/update-group"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function update_group(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resource_groups(
        "POST",
        "/update-group",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_group_query(resource_query)
    update_group_query(resource_query, params::Dict{String,<:Any})

Updates the resource query of a group. For more information about resource queries, see
Create a tag-based group in Resource Groups.  Minimum permissions  To run this command, you
must have the following permissions:    resource-groups:UpdateGroupQuery

# Arguments
- `resource_query`: The resource query to determine which Amazon Web Services resources are
  members of this resource group.  A resource group can contain either a Configuration or a
  ResourceQuery, but not both.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Group"`: The name or the ARN of the resource group to query.
- `"GroupName"`: Don't use this parameter. Use Group instead.
"""
function update_group_query(
    ResourceQuery; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resource_groups(
        "POST",
        "/update-group-query",
        Dict{String,Any}("ResourceQuery" => ResourceQuery);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_group_query(
    ResourceQuery,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return resource_groups(
        "POST",
        "/update-group-query",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceQuery" => ResourceQuery), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: transcribe
using AWS.Compat
using AWS.UUIDs

"""
    create_call_analytics_category(category_name, rules)
    create_call_analytics_category(category_name, rules, params::Dict{String,<:Any})

Creates a new Call Analytics category. All categories are automatically applied to your
Call Analytics transcriptions. Note that in order to apply categories to your
transcriptions, you must create them before submitting your transcription request, as
categories cannot be applied retroactively. When creating a new category, you can use the
InputType parameter to label the category as a POST_CALL or a REAL_TIME category. POST_CALL
categories can only be applied to post-call transcriptions and REAL_TIME categories can
only be applied to real-time transcriptions. If you do not include InputType, your category
is created as a POST_CALL category by default. Call Analytics categories are composed of
rules. For each category, you must create between 1 and 20 rules. Rules can include these
parameters: , , , and . To update an existing category, see . To learn more about Call
Analytics categories, see Creating categories for post-call transcriptions and Creating
categories for real-time transcriptions.

# Arguments
- `category_name`: A unique name, chosen by you, for your Call Analytics category. It's
  helpful to use a detailed naming system that will make sense to you in the future. For
  example, it's better to use sentiment-positive-last30seconds for a category over a generic
  name like test-category. Category names are case sensitive.
- `rules`: Rules define a Call Analytics category. When creating a new category, you must
  create between 1 and 20 rules for that category. For each rule, you specify a filter you
  want applied to the attributes of a call. For example, you can choose a sentiment filter
  that detects if a customer's sentiment was positive during the last 30 seconds of the call.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"InputType"`: Choose whether you want to create a real-time or a post-call category for
  your Call Analytics transcription. Specifying POST_CALL assigns your category to post-call
  transcriptions; categories with this input type cannot be applied to streaming (real-time)
  transcriptions. Specifying REAL_TIME assigns your category to streaming transcriptions;
  categories with this input type cannot be applied to post-call transcriptions. If you do
  not include InputType, your category is created as a post-call category by default.
"""
function create_call_analytics_category(
    CategoryName, Rules; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transcribe(
        "CreateCallAnalyticsCategory",
        Dict{String,Any}("CategoryName" => CategoryName, "Rules" => Rules);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_call_analytics_category(
    CategoryName,
    Rules,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transcribe(
        "CreateCallAnalyticsCategory",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("CategoryName" => CategoryName, "Rules" => Rules),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_language_model(base_model_name, input_data_config, language_code, model_name)
    create_language_model(base_model_name, input_data_config, language_code, model_name, params::Dict{String,<:Any})

Creates a new custom language model. When creating a new custom language model, you must
specify:   If you want a Wideband (audio sample rates over 16,000 Hz) or Narrowband (audio
sample rates under 16,000 Hz) base model   The location of your training and tuning files
(this must be an Amazon S3 URI)   The language of your model   A unique name for your model


# Arguments
- `base_model_name`: The Amazon Transcribe standard language model, or base model, used to
  create your custom language model. Amazon Transcribe offers two options for base models:
  Wideband and Narrowband. If the audio you want to transcribe has a sample rate of 16,000 Hz
  or greater, choose WideBand. To transcribe audio with a sample rate less than 16,000 Hz,
  choose NarrowBand.
- `input_data_config`: Contains the Amazon S3 location of the training data you want to use
  to create a new custom language model, and permissions to access this location. When using
  InputDataConfig, you must include these sub-parameters: S3Uri, which is the Amazon S3
  location of your training data, and DataAccessRoleArn, which is the Amazon Resource Name
  (ARN) of the role that has permission to access your specified Amazon S3 location. You can
  optionally include TuningDataS3Uri, which is the Amazon S3 location of your tuning data. If
  you specify different Amazon S3 locations for training and tuning data, the ARN you use
  must have permissions to access both locations.
- `language_code`: The language code that represents the language of your model. Each
  custom language model must contain terms in only one language, and the language you select
  for your custom language model must match the language of your training and tuning data.
  For a list of supported languages and their associated language codes, refer to the
  Supported languages table. Note that US English (en-US) is the only language supported with
  Amazon Transcribe Medical. A custom language model can only be used to transcribe files in
  the same language as the model. For example, if you create a custom language model using US
  English (en-US), you can only apply this model to files that contain English audio.
- `model_name`: A unique name, chosen by you, for your custom language model. This name is
  case sensitive, cannot contain spaces, and must be unique within an Amazon Web Services
  account. If you try to create a new custom language model with the same name as an existing
  custom language model, you get a ConflictException error.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: Adds one or more custom tags, each in the form of a key:value pair, to a new
  custom language model at the time you create this new model. To learn more about using tags
  with Amazon Transcribe, refer to Tagging resources.
"""
function create_language_model(
    BaseModelName,
    InputDataConfig,
    LanguageCode,
    ModelName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transcribe(
        "CreateLanguageModel",
        Dict{String,Any}(
            "BaseModelName" => BaseModelName,
            "InputDataConfig" => InputDataConfig,
            "LanguageCode" => LanguageCode,
            "ModelName" => ModelName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_language_model(
    BaseModelName,
    InputDataConfig,
    LanguageCode,
    ModelName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transcribe(
        "CreateLanguageModel",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "BaseModelName" => BaseModelName,
                    "InputDataConfig" => InputDataConfig,
                    "LanguageCode" => LanguageCode,
                    "ModelName" => ModelName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_medical_vocabulary(language_code, vocabulary_file_uri, vocabulary_name)
    create_medical_vocabulary(language_code, vocabulary_file_uri, vocabulary_name, params::Dict{String,<:Any})

Creates a new custom medical vocabulary. Before creating a new custom medical vocabulary,
you must first upload a text file that contains your vocabulary table into an Amazon S3
bucket. Note that this differs from , where you can include a list of terms within your
request using the Phrases flag; CreateMedicalVocabulary does not support the Phrases flag
and only accepts vocabularies in table format. Each language has a character set that
contains all allowed characters for that specific language. If you use unsupported
characters, your custom vocabulary request fails. Refer to Character Sets for Custom
Vocabularies to get the character set for your language. For more information, see Custom
vocabularies.

# Arguments
- `language_code`: The language code that represents the language of the entries in your
  custom vocabulary. US English (en-US) is the only language supported with Amazon Transcribe
  Medical.
- `vocabulary_file_uri`: The Amazon S3 location (URI) of the text file that contains your
  custom medical vocabulary. The URI must be in the same Amazon Web Services Region as the
  resource you're calling. Here's an example URI path:
  s3://DOC-EXAMPLE-BUCKET/my-vocab-file.txt
- `vocabulary_name`: A unique name, chosen by you, for your new custom medical vocabulary.
  This name is case sensitive, cannot contain spaces, and must be unique within an Amazon Web
  Services account. If you try to create a new custom medical vocabulary with the same name
  as an existing custom medical vocabulary, you get a ConflictException error.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: Adds one or more custom tags, each in the form of a key:value pair, to a new
  custom medical vocabulary at the time you create this new custom vocabulary. To learn more
  about using tags with Amazon Transcribe, refer to Tagging resources.
"""
function create_medical_vocabulary(
    LanguageCode,
    VocabularyFileUri,
    VocabularyName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transcribe(
        "CreateMedicalVocabulary",
        Dict{String,Any}(
            "LanguageCode" => LanguageCode,
            "VocabularyFileUri" => VocabularyFileUri,
            "VocabularyName" => VocabularyName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_medical_vocabulary(
    LanguageCode,
    VocabularyFileUri,
    VocabularyName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transcribe(
        "CreateMedicalVocabulary",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "LanguageCode" => LanguageCode,
                    "VocabularyFileUri" => VocabularyFileUri,
                    "VocabularyName" => VocabularyName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_vocabulary(language_code, vocabulary_name)
    create_vocabulary(language_code, vocabulary_name, params::Dict{String,<:Any})

Creates a new custom vocabulary. When creating a new custom vocabulary, you can either
upload a text file that contains your new entries, phrases, and terms into an Amazon S3
bucket and include the URI in your request. Or you can include a list of terms directly in
your request using the Phrases flag. Each language has a character set that contains all
allowed characters for that specific language. If you use unsupported characters, your
custom vocabulary request fails. Refer to Character Sets for Custom Vocabularies to get the
character set for your language. For more information, see Custom vocabularies.

# Arguments
- `language_code`: The language code that represents the language of the entries in your
  custom vocabulary. Each custom vocabulary must contain terms in only one language. A custom
  vocabulary can only be used to transcribe files in the same language as the custom
  vocabulary. For example, if you create a custom vocabulary using US English (en-US), you
  can only apply this custom vocabulary to files that contain English audio. For a list of
  supported languages and their associated language codes, refer to the Supported languages
  table.
- `vocabulary_name`: A unique name, chosen by you, for your new custom vocabulary. This
  name is case sensitive, cannot contain spaces, and must be unique within an Amazon Web
  Services account. If you try to create a new custom vocabulary with the same name as an
  existing custom vocabulary, you get a ConflictException error.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DataAccessRoleArn"`: The Amazon Resource Name (ARN) of an IAM role that has permissions
  to access the Amazon S3 bucket that contains your input files (in this case, your custom
  vocabulary). If the role that you specify doesn’t have the appropriate permissions to
  access the specified Amazon S3 location, your request fails. IAM role ARNs have the format
  arn:partition:iam::account:role/role-name-with-path. For example:
  arn:aws:iam::111122223333:role/Admin. For more information, see IAM ARNs.
- `"Phrases"`: Use this parameter if you want to create your custom vocabulary by including
  all desired terms, as comma-separated values, within your request. The other option for
  creating your custom vocabulary is to save your entries in a text file and upload them to
  an Amazon S3 bucket, then specify the location of your file using the VocabularyFileUri
  parameter. Note that if you include Phrases in your request, you cannot use
  VocabularyFileUri; you must choose one or the other. Each language has a character set that
  contains all allowed characters for that specific language. If you use unsupported
  characters, your custom vocabulary filter request fails. Refer to Character Sets for Custom
  Vocabularies to get the character set for your language.
- `"Tags"`: Adds one or more custom tags, each in the form of a key:value pair, to a new
  custom vocabulary at the time you create this new custom vocabulary. To learn more about
  using tags with Amazon Transcribe, refer to Tagging resources.
- `"VocabularyFileUri"`: The Amazon S3 location of the text file that contains your custom
  vocabulary. The URI must be located in the same Amazon Web Services Region as the resource
  you're calling. Here's an example URI path: s3://DOC-EXAMPLE-BUCKET/my-vocab-file.txt  Note
  that if you include VocabularyFileUri in your request, you cannot use the Phrases flag; you
  must choose one or the other.
"""
function create_vocabulary(
    LanguageCode, VocabularyName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transcribe(
        "CreateVocabulary",
        Dict{String,Any}(
            "LanguageCode" => LanguageCode, "VocabularyName" => VocabularyName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_vocabulary(
    LanguageCode,
    VocabularyName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transcribe(
        "CreateVocabulary",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "LanguageCode" => LanguageCode, "VocabularyName" => VocabularyName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_vocabulary_filter(language_code, vocabulary_filter_name)
    create_vocabulary_filter(language_code, vocabulary_filter_name, params::Dict{String,<:Any})

Creates a new custom vocabulary filter. You can use custom vocabulary filters to mask,
delete, or flag specific words from your transcript. Custom vocabulary filters are commonly
used to mask profanity in transcripts. Each language has a character set that contains all
allowed characters for that specific language. If you use unsupported characters, your
custom vocabulary filter request fails. Refer to Character Sets for Custom Vocabularies to
get the character set for your language. For more information, see Vocabulary filtering.

# Arguments
- `language_code`: The language code that represents the language of the entries in your
  vocabulary filter. Each custom vocabulary filter must contain terms in only one language. A
  custom vocabulary filter can only be used to transcribe files in the same language as the
  filter. For example, if you create a custom vocabulary filter using US English (en-US), you
  can only apply this filter to files that contain English audio. For a list of supported
  languages and their associated language codes, refer to the Supported languages table.
- `vocabulary_filter_name`: A unique name, chosen by you, for your new custom vocabulary
  filter. This name is case sensitive, cannot contain spaces, and must be unique within an
  Amazon Web Services account. If you try to create a new custom vocabulary filter with the
  same name as an existing custom vocabulary filter, you get a ConflictException error.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DataAccessRoleArn"`: The Amazon Resource Name (ARN) of an IAM role that has permissions
  to access the Amazon S3 bucket that contains your input files (in this case, your custom
  vocabulary filter). If the role that you specify doesn’t have the appropriate permissions
  to access the specified Amazon S3 location, your request fails. IAM role ARNs have the
  format arn:partition:iam::account:role/role-name-with-path. For example:
  arn:aws:iam::111122223333:role/Admin. For more information, see IAM ARNs.
- `"Tags"`: Adds one or more custom tags, each in the form of a key:value pair, to a new
  custom vocabulary filter at the time you create this new vocabulary filter. To learn more
  about using tags with Amazon Transcribe, refer to Tagging resources.
- `"VocabularyFilterFileUri"`: The Amazon S3 location of the text file that contains your
  custom vocabulary filter terms. The URI must be located in the same Amazon Web Services
  Region as the resource you're calling. Here's an example URI path:
  s3://DOC-EXAMPLE-BUCKET/my-vocab-filter-file.txt  Note that if you include
  VocabularyFilterFileUri in your request, you cannot use Words; you must choose one or the
  other.
- `"Words"`: Use this parameter if you want to create your custom vocabulary filter by
  including all desired terms, as comma-separated values, within your request. The other
  option for creating your vocabulary filter is to save your entries in a text file and
  upload them to an Amazon S3 bucket, then specify the location of your file using the
  VocabularyFilterFileUri parameter. Note that if you include Words in your request, you
  cannot use VocabularyFilterFileUri; you must choose one or the other. Each language has a
  character set that contains all allowed characters for that specific language. If you use
  unsupported characters, your custom vocabulary filter request fails. Refer to Character
  Sets for Custom Vocabularies to get the character set for your language.
"""
function create_vocabulary_filter(
    LanguageCode, VocabularyFilterName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transcribe(
        "CreateVocabularyFilter",
        Dict{String,Any}(
            "LanguageCode" => LanguageCode, "VocabularyFilterName" => VocabularyFilterName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_vocabulary_filter(
    LanguageCode,
    VocabularyFilterName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transcribe(
        "CreateVocabularyFilter",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "LanguageCode" => LanguageCode,
                    "VocabularyFilterName" => VocabularyFilterName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_call_analytics_category(category_name)
    delete_call_analytics_category(category_name, params::Dict{String,<:Any})

Deletes a Call Analytics category. To use this operation, specify the name of the category
you want to delete using CategoryName. Category names are case sensitive.

# Arguments
- `category_name`: The name of the Call Analytics category you want to delete. Category
  names are case sensitive.

"""
function delete_call_analytics_category(
    CategoryName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transcribe(
        "DeleteCallAnalyticsCategory",
        Dict{String,Any}("CategoryName" => CategoryName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_call_analytics_category(
    CategoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transcribe(
        "DeleteCallAnalyticsCategory",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("CategoryName" => CategoryName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_call_analytics_job(call_analytics_job_name)
    delete_call_analytics_job(call_analytics_job_name, params::Dict{String,<:Any})

Deletes a Call Analytics job. To use this operation, specify the name of the job you want
to delete using CallAnalyticsJobName. Job names are case sensitive.

# Arguments
- `call_analytics_job_name`: The name of the Call Analytics job you want to delete. Job
  names are case sensitive.

"""
function delete_call_analytics_job(
    CallAnalyticsJobName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transcribe(
        "DeleteCallAnalyticsJob",
        Dict{String,Any}("CallAnalyticsJobName" => CallAnalyticsJobName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_call_analytics_job(
    CallAnalyticsJobName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transcribe(
        "DeleteCallAnalyticsJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("CallAnalyticsJobName" => CallAnalyticsJobName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_language_model(model_name)
    delete_language_model(model_name, params::Dict{String,<:Any})

Deletes a custom language model. To use this operation, specify the name of the language
model you want to delete using ModelName. custom language model names are case sensitive.

# Arguments
- `model_name`: The name of the custom language model you want to delete. Model names are
  case sensitive.

"""
function delete_language_model(
    ModelName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transcribe(
        "DeleteLanguageModel",
        Dict{String,Any}("ModelName" => ModelName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_language_model(
    ModelName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transcribe(
        "DeleteLanguageModel",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ModelName" => ModelName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_medical_scribe_job(medical_scribe_job_name)
    delete_medical_scribe_job(medical_scribe_job_name, params::Dict{String,<:Any})

Deletes a Medical Scribe job. To use this operation, specify the name of the job you want
to delete using MedicalScribeJobName. Job names are case sensitive.

# Arguments
- `medical_scribe_job_name`: The name of the Medical Scribe job you want to delete. Job
  names are case sensitive.

"""
function delete_medical_scribe_job(
    MedicalScribeJobName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transcribe(
        "DeleteMedicalScribeJob",
        Dict{String,Any}("MedicalScribeJobName" => MedicalScribeJobName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_medical_scribe_job(
    MedicalScribeJobName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transcribe(
        "DeleteMedicalScribeJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("MedicalScribeJobName" => MedicalScribeJobName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_medical_transcription_job(medical_transcription_job_name)
    delete_medical_transcription_job(medical_transcription_job_name, params::Dict{String,<:Any})

Deletes a medical transcription job. To use this operation, specify the name of the job you
want to delete using MedicalTranscriptionJobName. Job names are case sensitive.

# Arguments
- `medical_transcription_job_name`: The name of the medical transcription job you want to
  delete. Job names are case sensitive.

"""
function delete_medical_transcription_job(
    MedicalTranscriptionJobName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transcribe(
        "DeleteMedicalTranscriptionJob",
        Dict{String,Any}("MedicalTranscriptionJobName" => MedicalTranscriptionJobName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_medical_transcription_job(
    MedicalTranscriptionJobName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transcribe(
        "DeleteMedicalTranscriptionJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "MedicalTranscriptionJobName" => MedicalTranscriptionJobName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_medical_vocabulary(vocabulary_name)
    delete_medical_vocabulary(vocabulary_name, params::Dict{String,<:Any})

Deletes a custom medical vocabulary. To use this operation, specify the name of the custom
vocabulary you want to delete using VocabularyName. Custom vocabulary names are case
sensitive.

# Arguments
- `vocabulary_name`: The name of the custom medical vocabulary you want to delete. Custom
  medical vocabulary names are case sensitive.

"""
function delete_medical_vocabulary(
    VocabularyName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transcribe(
        "DeleteMedicalVocabulary",
        Dict{String,Any}("VocabularyName" => VocabularyName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_medical_vocabulary(
    VocabularyName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transcribe(
        "DeleteMedicalVocabulary",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("VocabularyName" => VocabularyName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_transcription_job(transcription_job_name)
    delete_transcription_job(transcription_job_name, params::Dict{String,<:Any})

Deletes a transcription job. To use this operation, specify the name of the job you want to
delete using TranscriptionJobName. Job names are case sensitive.

# Arguments
- `transcription_job_name`: The name of the transcription job you want to delete. Job names
  are case sensitive.

"""
function delete_transcription_job(
    TranscriptionJobName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transcribe(
        "DeleteTranscriptionJob",
        Dict{String,Any}("TranscriptionJobName" => TranscriptionJobName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_transcription_job(
    TranscriptionJobName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transcribe(
        "DeleteTranscriptionJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("TranscriptionJobName" => TranscriptionJobName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_vocabulary(vocabulary_name)
    delete_vocabulary(vocabulary_name, params::Dict{String,<:Any})

Deletes a custom vocabulary. To use this operation, specify the name of the custom
vocabulary you want to delete using VocabularyName. Custom vocabulary names are case
sensitive.

# Arguments
- `vocabulary_name`: The name of the custom vocabulary you want to delete. Custom
  vocabulary names are case sensitive.

"""
function delete_vocabulary(
    VocabularyName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transcribe(
        "DeleteVocabulary",
        Dict{String,Any}("VocabularyName" => VocabularyName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_vocabulary(
    VocabularyName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transcribe(
        "DeleteVocabulary",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("VocabularyName" => VocabularyName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_vocabulary_filter(vocabulary_filter_name)
    delete_vocabulary_filter(vocabulary_filter_name, params::Dict{String,<:Any})

Deletes a custom vocabulary filter. To use this operation, specify the name of the custom
vocabulary filter you want to delete using VocabularyFilterName. Custom vocabulary filter
names are case sensitive.

# Arguments
- `vocabulary_filter_name`: The name of the custom vocabulary filter you want to delete.
  Custom vocabulary filter names are case sensitive.

"""
function delete_vocabulary_filter(
    VocabularyFilterName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transcribe(
        "DeleteVocabularyFilter",
        Dict{String,Any}("VocabularyFilterName" => VocabularyFilterName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_vocabulary_filter(
    VocabularyFilterName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transcribe(
        "DeleteVocabularyFilter",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("VocabularyFilterName" => VocabularyFilterName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_language_model(model_name)
    describe_language_model(model_name, params::Dict{String,<:Any})

Provides information about the specified custom language model. This operation also shows
if the base language model that you used to create your custom language model has been
updated. If Amazon Transcribe has updated the base model, you can create a new custom
language model using the updated base model. If you tried to create a new custom language
model and the request wasn't successful, you can use DescribeLanguageModel to help identify
the reason for this failure.

# Arguments
- `model_name`: The name of the custom language model you want information about. Model
  names are case sensitive.

"""
function describe_language_model(
    ModelName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transcribe(
        "DescribeLanguageModel",
        Dict{String,Any}("ModelName" => ModelName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_language_model(
    ModelName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transcribe(
        "DescribeLanguageModel",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ModelName" => ModelName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_call_analytics_category(category_name)
    get_call_analytics_category(category_name, params::Dict{String,<:Any})

Provides information about the specified Call Analytics category. To get a list of your
Call Analytics categories, use the operation.

# Arguments
- `category_name`: The name of the Call Analytics category you want information about.
  Category names are case sensitive.

"""
function get_call_analytics_category(
    CategoryName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transcribe(
        "GetCallAnalyticsCategory",
        Dict{String,Any}("CategoryName" => CategoryName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_call_analytics_category(
    CategoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transcribe(
        "GetCallAnalyticsCategory",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("CategoryName" => CategoryName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_call_analytics_job(call_analytics_job_name)
    get_call_analytics_job(call_analytics_job_name, params::Dict{String,<:Any})

Provides information about the specified Call Analytics job. To view the job's status,
refer to CallAnalyticsJobStatus. If the status is COMPLETED, the job is finished. You can
find your completed transcript at the URI specified in TranscriptFileUri. If the status is
FAILED, FailureReason provides details on why your transcription job failed. If you enabled
personally identifiable information (PII) redaction, the redacted transcript appears at the
location specified in RedactedTranscriptFileUri. If you chose to redact the audio in your
media file, you can find your redacted media file at the location specified in
RedactedMediaFileUri. To get a list of your Call Analytics jobs, use the operation.

# Arguments
- `call_analytics_job_name`: The name of the Call Analytics job you want information about.
  Job names are case sensitive.

"""
function get_call_analytics_job(
    CallAnalyticsJobName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transcribe(
        "GetCallAnalyticsJob",
        Dict{String,Any}("CallAnalyticsJobName" => CallAnalyticsJobName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_call_analytics_job(
    CallAnalyticsJobName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transcribe(
        "GetCallAnalyticsJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("CallAnalyticsJobName" => CallAnalyticsJobName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_medical_scribe_job(medical_scribe_job_name)
    get_medical_scribe_job(medical_scribe_job_name, params::Dict{String,<:Any})

Provides information about the specified Medical Scribe job. To view the status of the
specified medical transcription job, check the MedicalScribeJobStatus field. If the status
is COMPLETED, the job is finished. You can find the results at the location specified in
MedicalScribeOutput. If the status is FAILED, FailureReason provides details on why your
Medical Scribe job failed. To get a list of your Medical Scribe jobs, use the operation.

# Arguments
- `medical_scribe_job_name`: The name of the Medical Scribe job you want information about.
  Job names are case sensitive.

"""
function get_medical_scribe_job(
    MedicalScribeJobName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transcribe(
        "GetMedicalScribeJob",
        Dict{String,Any}("MedicalScribeJobName" => MedicalScribeJobName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_medical_scribe_job(
    MedicalScribeJobName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transcribe(
        "GetMedicalScribeJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("MedicalScribeJobName" => MedicalScribeJobName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_medical_transcription_job(medical_transcription_job_name)
    get_medical_transcription_job(medical_transcription_job_name, params::Dict{String,<:Any})

Provides information about the specified medical transcription job. To view the status of
the specified medical transcription job, check the TranscriptionJobStatus field. If the
status is COMPLETED, the job is finished. You can find the results at the location
specified in TranscriptFileUri. If the status is FAILED, FailureReason provides details on
why your transcription job failed. To get a list of your medical transcription jobs, use
the operation.

# Arguments
- `medical_transcription_job_name`: The name of the medical transcription job you want
  information about. Job names are case sensitive.

"""
function get_medical_transcription_job(
    MedicalTranscriptionJobName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transcribe(
        "GetMedicalTranscriptionJob",
        Dict{String,Any}("MedicalTranscriptionJobName" => MedicalTranscriptionJobName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_medical_transcription_job(
    MedicalTranscriptionJobName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transcribe(
        "GetMedicalTranscriptionJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "MedicalTranscriptionJobName" => MedicalTranscriptionJobName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_medical_vocabulary(vocabulary_name)
    get_medical_vocabulary(vocabulary_name, params::Dict{String,<:Any})

Provides information about the specified custom medical vocabulary. To view the status of
the specified custom medical vocabulary, check the VocabularyState field. If the status is
READY, your custom vocabulary is available to use. If the status is FAILED, FailureReason
provides details on why your vocabulary failed. To get a list of your custom medical
vocabularies, use the operation.

# Arguments
- `vocabulary_name`: The name of the custom medical vocabulary you want information about.
  Custom medical vocabulary names are case sensitive.

"""
function get_medical_vocabulary(
    VocabularyName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transcribe(
        "GetMedicalVocabulary",
        Dict{String,Any}("VocabularyName" => VocabularyName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_medical_vocabulary(
    VocabularyName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transcribe(
        "GetMedicalVocabulary",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("VocabularyName" => VocabularyName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_transcription_job(transcription_job_name)
    get_transcription_job(transcription_job_name, params::Dict{String,<:Any})

Provides information about the specified transcription job. To view the status of the
specified transcription job, check the TranscriptionJobStatus field. If the status is
COMPLETED, the job is finished. You can find the results at the location specified in
TranscriptFileUri. If the status is FAILED, FailureReason provides details on why your
transcription job failed. If you enabled content redaction, the redacted transcript can be
found at the location specified in RedactedTranscriptFileUri. To get a list of your
transcription jobs, use the operation.

# Arguments
- `transcription_job_name`: The name of the transcription job you want information about.
  Job names are case sensitive.

"""
function get_transcription_job(
    TranscriptionJobName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transcribe(
        "GetTranscriptionJob",
        Dict{String,Any}("TranscriptionJobName" => TranscriptionJobName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_transcription_job(
    TranscriptionJobName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transcribe(
        "GetTranscriptionJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("TranscriptionJobName" => TranscriptionJobName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_vocabulary(vocabulary_name)
    get_vocabulary(vocabulary_name, params::Dict{String,<:Any})

Provides information about the specified custom vocabulary. To view the status of the
specified custom vocabulary, check the VocabularyState field. If the status is READY, your
custom vocabulary is available to use. If the status is FAILED, FailureReason provides
details on why your custom vocabulary failed. To get a list of your custom vocabularies,
use the operation.

# Arguments
- `vocabulary_name`: The name of the custom vocabulary you want information about. Custom
  vocabulary names are case sensitive.

"""
function get_vocabulary(VocabularyName; aws_config::AbstractAWSConfig=current_aws_config())
    return transcribe(
        "GetVocabulary",
        Dict{String,Any}("VocabularyName" => VocabularyName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_vocabulary(
    VocabularyName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transcribe(
        "GetVocabulary",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("VocabularyName" => VocabularyName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_vocabulary_filter(vocabulary_filter_name)
    get_vocabulary_filter(vocabulary_filter_name, params::Dict{String,<:Any})

Provides information about the specified custom vocabulary filter. To get a list of your
custom vocabulary filters, use the operation.

# Arguments
- `vocabulary_filter_name`: The name of the custom vocabulary filter you want information
  about. Custom vocabulary filter names are case sensitive.

"""
function get_vocabulary_filter(
    VocabularyFilterName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transcribe(
        "GetVocabularyFilter",
        Dict{String,Any}("VocabularyFilterName" => VocabularyFilterName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_vocabulary_filter(
    VocabularyFilterName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transcribe(
        "GetVocabularyFilter",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("VocabularyFilterName" => VocabularyFilterName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_call_analytics_categories()
    list_call_analytics_categories(params::Dict{String,<:Any})

Provides a list of Call Analytics categories, including all rules that make up each
category. To get detailed information about a specific Call Analytics category, use the
operation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of Call Analytics categories to return in each page of
  results. If there are fewer results than the value that you specify, only the actual
  results are returned. If you do not specify a value, a default of 5 is used.
- `"NextToken"`: If your ListCallAnalyticsCategories request returns more results than can
  be displayed, NextToken is displayed in the response with an associated string. To get the
  next page of results, copy this string and repeat your request, including NextToken with
  the value of the copied string. Repeat as needed to view all your results.
"""
function list_call_analytics_categories(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return transcribe(
        "ListCallAnalyticsCategories";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_call_analytics_categories(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transcribe(
        "ListCallAnalyticsCategories",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_call_analytics_jobs()
    list_call_analytics_jobs(params::Dict{String,<:Any})

Provides a list of Call Analytics jobs that match the specified criteria. If no criteria
are specified, all Call Analytics jobs are returned. To get detailed information about a
specific Call Analytics job, use the operation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"JobNameContains"`: Returns only the Call Analytics jobs that contain the specified
  string. The search is not case sensitive.
- `"MaxResults"`: The maximum number of Call Analytics jobs to return in each page of
  results. If there are fewer results than the value that you specify, only the actual
  results are returned. If you do not specify a value, a default of 5 is used.
- `"NextToken"`: If your ListCallAnalyticsJobs request returns more results than can be
  displayed, NextToken is displayed in the response with an associated string. To get the
  next page of results, copy this string and repeat your request, including NextToken with
  the value of the copied string. Repeat as needed to view all your results.
- `"Status"`: Returns only Call Analytics jobs with the specified status. Jobs are ordered
  by creation date, with the newest job first. If you do not include Status, all Call
  Analytics jobs are returned.
"""
function list_call_analytics_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return transcribe(
        "ListCallAnalyticsJobs"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_call_analytics_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transcribe(
        "ListCallAnalyticsJobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_language_models()
    list_language_models(params::Dict{String,<:Any})

Provides a list of custom language models that match the specified criteria. If no criteria
are specified, all custom language models are returned. To get detailed information about a
specific custom language model, use the operation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of custom language models to return in each page of
  results. If there are fewer results than the value that you specify, only the actual
  results are returned. If you do not specify a value, a default of 5 is used.
- `"NameContains"`: Returns only the custom language models that contain the specified
  string. The search is not case sensitive.
- `"NextToken"`: If your ListLanguageModels request returns more results than can be
  displayed, NextToken is displayed in the response with an associated string. To get the
  next page of results, copy this string and repeat your request, including NextToken with
  the value of the copied string. Repeat as needed to view all your results.
- `"StatusEquals"`: Returns only custom language models with the specified status. Language
  models are ordered by creation date, with the newest model first. If you do not include
  StatusEquals, all custom language models are returned.
"""
function list_language_models(; aws_config::AbstractAWSConfig=current_aws_config())
    return transcribe(
        "ListLanguageModels"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_language_models(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transcribe(
        "ListLanguageModels", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_medical_scribe_jobs()
    list_medical_scribe_jobs(params::Dict{String,<:Any})

Provides a list of Medical Scribe jobs that match the specified criteria. If no criteria
are specified, all Medical Scribe jobs are returned. To get detailed information about a
specific Medical Scribe job, use the operation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"JobNameContains"`: Returns only the Medical Scribe jobs that contain the specified
  string. The search is not case sensitive.
- `"MaxResults"`: The maximum number of Medical Scribe jobs to return in each page of
  results. If there are fewer results than the value that you specify, only the actual
  results are returned. If you do not specify a value, a default of 5 is used.
- `"NextToken"`: If your ListMedicalScribeJobs request returns more results than can be
  displayed, NextToken is displayed in the response with an associated string. To get the
  next page of results, copy this string and repeat your request, including NextToken with
  the value of the copied string. Repeat as needed to view all your results.
- `"Status"`: Returns only Medical Scribe jobs with the specified status. Jobs are ordered
  by creation date, with the newest job first. If you do not include Status, all Medical
  Scribe jobs are returned.
"""
function list_medical_scribe_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return transcribe(
        "ListMedicalScribeJobs"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_medical_scribe_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transcribe(
        "ListMedicalScribeJobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_medical_transcription_jobs()
    list_medical_transcription_jobs(params::Dict{String,<:Any})

Provides a list of medical transcription jobs that match the specified criteria. If no
criteria are specified, all medical transcription jobs are returned. To get detailed
information about a specific medical transcription job, use the operation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"JobNameContains"`: Returns only the medical transcription jobs that contain the
  specified string. The search is not case sensitive.
- `"MaxResults"`: The maximum number of medical transcription jobs to return in each page
  of results. If there are fewer results than the value that you specify, only the actual
  results are returned. If you do not specify a value, a default of 5 is used.
- `"NextToken"`: If your ListMedicalTranscriptionJobs request returns more results than can
  be displayed, NextToken is displayed in the response with an associated string. To get the
  next page of results, copy this string and repeat your request, including NextToken with
  the value of the copied string. Repeat as needed to view all your results.
- `"Status"`: Returns only medical transcription jobs with the specified status. Jobs are
  ordered by creation date, with the newest job first. If you do not include Status, all
  medical transcription jobs are returned.
"""
function list_medical_transcription_jobs(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return transcribe(
        "ListMedicalTranscriptionJobs";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_medical_transcription_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transcribe(
        "ListMedicalTranscriptionJobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_medical_vocabularies()
    list_medical_vocabularies(params::Dict{String,<:Any})

Provides a list of custom medical vocabularies that match the specified criteria. If no
criteria are specified, all custom medical vocabularies are returned. To get detailed
information about a specific custom medical vocabulary, use the operation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of custom medical vocabularies to return in each page
  of results. If there are fewer results than the value that you specify, only the actual
  results are returned. If you do not specify a value, a default of 5 is used.
- `"NameContains"`: Returns only the custom medical vocabularies that contain the specified
  string. The search is not case sensitive.
- `"NextToken"`: If your ListMedicalVocabularies request returns more results than can be
  displayed, NextToken is displayed in the response with an associated string. To get the
  next page of results, copy this string and repeat your request, including NextToken with
  the value of the copied string. Repeat as needed to view all your results.
- `"StateEquals"`: Returns only custom medical vocabularies with the specified state.
  Custom vocabularies are ordered by creation date, with the newest vocabulary first. If you
  do not include StateEquals, all custom medical vocabularies are returned.
"""
function list_medical_vocabularies(; aws_config::AbstractAWSConfig=current_aws_config())
    return transcribe(
        "ListMedicalVocabularies"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_medical_vocabularies(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transcribe(
        "ListMedicalVocabularies",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists all tags associated with the specified transcription job, vocabulary, model, or
resource. To learn more about using tags with Amazon Transcribe, refer to Tagging resources.

# Arguments
- `resource_arn`: Returns a list of all tags associated with the specified Amazon Resource
  Name (ARN). ARNs have the format
  arn:partition:service:region:account-id:resource-type/resource-id. For example,
  arn:aws:transcribe:us-west-2:111122223333:transcription-job/transcription-job-name. Valid
  values for resource-type are: transcription-job, medical-transcription-job, vocabulary,
  medical-vocabulary, vocabulary-filter, and language-model.

"""
function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transcribe(
        "ListTagsForResource",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transcribe(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_transcription_jobs()
    list_transcription_jobs(params::Dict{String,<:Any})

Provides a list of transcription jobs that match the specified criteria. If no criteria are
specified, all transcription jobs are returned. To get detailed information about a
specific transcription job, use the operation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"JobNameContains"`: Returns only the transcription jobs that contain the specified
  string. The search is not case sensitive.
- `"MaxResults"`: The maximum number of transcription jobs to return in each page of
  results. If there are fewer results than the value that you specify, only the actual
  results are returned. If you do not specify a value, a default of 5 is used.
- `"NextToken"`: If your ListTranscriptionJobs request returns more results than can be
  displayed, NextToken is displayed in the response with an associated string. To get the
  next page of results, copy this string and repeat your request, including NextToken with
  the value of the copied string. Repeat as needed to view all your results.
- `"Status"`: Returns only transcription jobs with the specified status. Jobs are ordered
  by creation date, with the newest job first. If you do not include Status, all
  transcription jobs are returned.
"""
function list_transcription_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return transcribe(
        "ListTranscriptionJobs"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_transcription_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transcribe(
        "ListTranscriptionJobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_vocabularies()
    list_vocabularies(params::Dict{String,<:Any})

Provides a list of custom vocabularies that match the specified criteria. If no criteria
are specified, all custom vocabularies are returned. To get detailed information about a
specific custom vocabulary, use the operation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of custom vocabularies to return in each page of
  results. If there are fewer results than the value that you specify, only the actual
  results are returned. If you do not specify a value, a default of 5 is used.
- `"NameContains"`: Returns only the custom vocabularies that contain the specified string.
  The search is not case sensitive.
- `"NextToken"`: If your ListVocabularies request returns more results than can be
  displayed, NextToken is displayed in the response with an associated string. To get the
  next page of results, copy this string and repeat your request, including NextToken with
  the value of the copied string. Repeat as needed to view all your results.
- `"StateEquals"`: Returns only custom vocabularies with the specified state. Vocabularies
  are ordered by creation date, with the newest vocabulary first. If you do not include
  StateEquals, all custom medical vocabularies are returned.
"""
function list_vocabularies(; aws_config::AbstractAWSConfig=current_aws_config())
    return transcribe(
        "ListVocabularies"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_vocabularies(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transcribe(
        "ListVocabularies", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_vocabulary_filters()
    list_vocabulary_filters(params::Dict{String,<:Any})

Provides a list of custom vocabulary filters that match the specified criteria. If no
criteria are specified, all custom vocabularies are returned. To get detailed information
about a specific custom vocabulary filter, use the operation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of custom vocabulary filters to return in each page of
  results. If there are fewer results than the value that you specify, only the actual
  results are returned. If you do not specify a value, a default of 5 is used.
- `"NameContains"`: Returns only the custom vocabulary filters that contain the specified
  string. The search is not case sensitive.
- `"NextToken"`: If your ListVocabularyFilters request returns more results than can be
  displayed, NextToken is displayed in the response with an associated string. To get the
  next page of results, copy this string and repeat your request, including NextToken with
  the value of the copied string. Repeat as needed to view all your results.
"""
function list_vocabulary_filters(; aws_config::AbstractAWSConfig=current_aws_config())
    return transcribe(
        "ListVocabularyFilters"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_vocabulary_filters(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transcribe(
        "ListVocabularyFilters",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_call_analytics_job(call_analytics_job_name, media)
    start_call_analytics_job(call_analytics_job_name, media, params::Dict{String,<:Any})

Transcribes the audio from a customer service call and applies any additional Request
Parameters you choose to include in your request. In addition to many standard
transcription features, Call Analytics provides you with call characteristics, call
summarization, speaker sentiment, and optional redaction of your text transcript and your
audio file. You can also apply custom categories to flag specified conditions. To learn
more about these features and insights, refer to Analyzing call center audio with Call
Analytics. If you want to apply categories to your Call Analytics job, you must create them
before submitting your job request. Categories cannot be retroactively applied to a job. To
create a new category, use the operation. To learn more about Call Analytics categories,
see Creating categories for post-call transcriptions and Creating categories for real-time
transcriptions. To make a StartCallAnalyticsJob request, you must first upload your media
file into an Amazon S3 bucket; you can then specify the Amazon S3 location of the file
using the Media parameter. Note that job queuing is enabled by default for Call Analytics
jobs. You must include the following parameters in your StartCallAnalyticsJob request:
region: The Amazon Web Services Region where you are making your request. For a list of
Amazon Web Services Regions supported with Amazon Transcribe, refer to Amazon Transcribe
endpoints and quotas.    CallAnalyticsJobName: A custom name that you create for your
transcription job that's unique within your Amazon Web Services account.
DataAccessRoleArn: The Amazon Resource Name (ARN) of an IAM role that has permissions to
access the Amazon S3 bucket that contains your input files.    Media (MediaFileUri or
RedactedMediaFileUri): The Amazon S3 location of your media file.    With Call Analytics,
you can redact the audio contained in your media file by including RedactedMediaFileUri,
instead of MediaFileUri, to specify the location of your input audio. If you choose to
redact your audio, you can find your redacted media at the location specified in the
RedactedMediaFileUri field of your response.

# Arguments
- `call_analytics_job_name`: A unique name, chosen by you, for your Call Analytics job.
  This name is case sensitive, cannot contain spaces, and must be unique within an Amazon Web
  Services account. If you try to create a new job with the same name as an existing job, you
  get a ConflictException error.
- `media`: Describes the Amazon S3 location of the media file you want to use in your Call
  Analytics request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ChannelDefinitions"`: Makes it possible to specify which speaker is on which channel.
  For example, if your agent is the first participant to speak, you would set ChannelId to 0
  (to indicate the first channel) and ParticipantRole to AGENT (to indicate that it's the
  agent speaking).
- `"DataAccessRoleArn"`: The Amazon Resource Name (ARN) of an IAM role that has permissions
  to access the Amazon S3 bucket that contains your input files. If the role that you specify
  doesn’t have the appropriate permissions to access the specified Amazon S3 location, your
  request fails. IAM role ARNs have the format
  arn:partition:iam::account:role/role-name-with-path. For example:
  arn:aws:iam::111122223333:role/Admin. For more information, see IAM ARNs.
- `"OutputEncryptionKMSKeyId"`: The KMS key you want to use to encrypt your Call Analytics
  output. If using a key located in the current Amazon Web Services account, you can specify
  your KMS key in one of four ways:   Use the KMS key ID itself. For example,
  1234abcd-12ab-34cd-56ef-1234567890ab.   Use an alias for the KMS key ID. For example,
  alias/ExampleAlias.   Use the Amazon Resource Name (ARN) for the KMS key ID. For example,
  arn:aws:kms:region:account-ID:key/1234abcd-12ab-34cd-56ef-1234567890ab.   Use the ARN for
  the KMS key alias. For example, arn:aws:kms:region:account-ID:alias/ExampleAlias.   If
  using a key located in a different Amazon Web Services account than the current Amazon Web
  Services account, you can specify your KMS key in one of two ways:   Use the ARN for the
  KMS key ID. For example,
  arn:aws:kms:region:account-ID:key/1234abcd-12ab-34cd-56ef-1234567890ab.   Use the ARN for
  the KMS key alias. For example, arn:aws:kms:region:account-ID:alias/ExampleAlias.   If you
  do not specify an encryption key, your output is encrypted with the default Amazon S3 key
  (SSE-S3). If you specify a KMS key to encrypt your output, you must also specify an output
  location using the OutputLocation parameter. Note that the role making the request must
  have permission to use the specified KMS key.
- `"OutputLocation"`: The Amazon S3 location where you want your Call Analytics
  transcription output stored. You can use any of the following formats to specify the output
  location:   s3://DOC-EXAMPLE-BUCKET   s3://DOC-EXAMPLE-BUCKET/my-output-folder/
  s3://DOC-EXAMPLE-BUCKET/my-output-folder/my-call-analytics-job.json   Unless you specify a
  file name (option 3), the name of your output file has a default value that matches the
  name you specified for your transcription job using the CallAnalyticsJobName parameter. You
  can specify a KMS key to encrypt your output using the OutputEncryptionKMSKeyId parameter.
  If you do not specify a KMS key, Amazon Transcribe uses the default Amazon S3 key for
  server-side encryption. If you do not specify OutputLocation, your transcript is placed in
  a service-managed Amazon S3 bucket and you are provided with a URI to access your
  transcript.
- `"Settings"`: Specify additional optional settings in your request, including content
  redaction; allows you to apply custom language models, vocabulary filters, and custom
  vocabularies to your Call Analytics job.
"""
function start_call_analytics_job(
    CallAnalyticsJobName, Media; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transcribe(
        "StartCallAnalyticsJob",
        Dict{String,Any}("CallAnalyticsJobName" => CallAnalyticsJobName, "Media" => Media);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_call_analytics_job(
    CallAnalyticsJobName,
    Media,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transcribe(
        "StartCallAnalyticsJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CallAnalyticsJobName" => CallAnalyticsJobName, "Media" => Media
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_medical_scribe_job(data_access_role_arn, media, medical_scribe_job_name, output_bucket_name, settings)
    start_medical_scribe_job(data_access_role_arn, media, medical_scribe_job_name, output_bucket_name, settings, params::Dict{String,<:Any})

Transcribes patient-clinician conversations and generates clinical notes.  Amazon Web
Services HealthScribe automatically provides rich conversation transcripts, identifies
speaker roles, classifies dialogues, extracts medical terms, and generates preliminary
clinical notes. To learn more about these features, refer to Amazon Web Services
HealthScribe. To make a StartMedicalScribeJob request, you must first upload your media
file into an Amazon S3 bucket; you can then specify the Amazon S3 location of the file
using the Media parameter. You must include the following parameters in your
StartMedicalTranscriptionJob request:    DataAccessRoleArn: The ARN of an IAM role with the
these minimum permissions: read permission on input file Amazon S3 bucket specified in
Media, write permission on the Amazon S3 bucket specified in OutputBucketName, and full
permissions on the KMS key specified in OutputEncryptionKMSKeyId (if set). The role should
also allow transcribe.amazonaws.com to assume it.     Media (MediaFileUri): The Amazon S3
location of your media file.    MedicalScribeJobName: A custom name you create for your
MedicalScribe job that is unique within your Amazon Web Services account.
OutputBucketName: The Amazon S3 bucket where you want your output files stored.
Settings: A MedicalScribeSettings obect that must set exactly one of ShowSpeakerLabels or
ChannelIdentification to true. If ShowSpeakerLabels is true, MaxSpeakerLabels must also be
set.     ChannelDefinitions: A MedicalScribeChannelDefinitions array should be set if and
only if the ChannelIdentification value of Settings is set to true.

# Arguments
- `data_access_role_arn`: The Amazon Resource Name (ARN) of an IAM role that has
  permissions to access the Amazon S3 bucket that contains your input files, write to the
  output bucket, and use your KMS key if supplied. If the role that you specify doesn’t
  have the appropriate permissions your request fails. IAM role ARNs have the format
  arn:partition:iam::account:role/role-name-with-path. For example:
  arn:aws:iam::111122223333:role/Admin. For more information, see IAM ARNs.
- `media`:
- `medical_scribe_job_name`: A unique name, chosen by you, for your Medical Scribe job.
  This name is case sensitive, cannot contain spaces, and must be unique within an Amazon Web
  Services account. If you try to create a new job with the same name as an existing job, you
  get a ConflictException error.
- `output_bucket_name`: The name of the Amazon S3 bucket where you want your Medical Scribe
  output stored. Do not include the S3:// prefix of the specified bucket. Note that the role
  specified in the DataAccessRoleArn request parameter must have permission to use the
  specified location. You can change Amazon S3 permissions using the Amazon Web Services
  Management Console. See also Permissions Required for IAM User Roles.
- `settings`: Makes it possible to control how your Medical Scribe job is processed using a
  MedicalScribeSettings object. Specify ChannelIdentification if ChannelDefinitions are set.
  Enabled ShowSpeakerLabels if ChannelIdentification and ChannelDefinitions are not set. One
  and only one of ChannelIdentification and ShowSpeakerLabels must be set. If
  ShowSpeakerLabels is set, MaxSpeakerLabels must also be set. Use Settings to specify a
  vocabulary or vocabulary filter or both using VocabularyName, VocabularyFilterName.
  VocabularyFilterMethod must be specified if VocabularyFilterName is set.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ChannelDefinitions"`: Makes it possible to specify which speaker is on which channel.
  For example, if the clinician is the first participant to speak, you would set ChannelId of
  the first ChannelDefinition in the list to 0 (to indicate the first channel) and
  ParticipantRole to CLINICIAN (to indicate that it's the clinician speaking). Then you would
  set the ChannelId of the second ChannelDefinition in the list to 1 (to indicate the second
  channel) and ParticipantRole to PATIENT (to indicate that it's the patient speaking).
- `"KMSEncryptionContext"`: A map of plain text, non-secret key:value pairs, known as
  encryption context pairs, that provide an added layer of security for your data. For more
  information, see KMS encryption context and Asymmetric keys in KMS.
- `"OutputEncryptionKMSKeyId"`: The KMS key you want to use to encrypt your Medical Scribe
  output. If using a key located in the current Amazon Web Services account, you can specify
  your KMS key in one of four ways:   Use the KMS key ID itself. For example,
  1234abcd-12ab-34cd-56ef-1234567890ab.   Use an alias for the KMS key ID. For example,
  alias/ExampleAlias.   Use the Amazon Resource Name (ARN) for the KMS key ID. For example,
  arn:aws:kms:region:account-ID:key/1234abcd-12ab-34cd-56ef-1234567890ab.   Use the ARN for
  the KMS key alias. For example, arn:aws:kms:region:account-ID:alias/ExampleAlias.   If
  using a key located in a different Amazon Web Services account than the current Amazon Web
  Services account, you can specify your KMS key in one of two ways:   Use the ARN for the
  KMS key ID. For example,
  arn:aws:kms:region:account-ID:key/1234abcd-12ab-34cd-56ef-1234567890ab.   Use the ARN for
  the KMS key alias. For example, arn:aws:kms:region:account-ID:alias/ExampleAlias.   If you
  do not specify an encryption key, your output is encrypted with the default Amazon S3 key
  (SSE-S3). Note that the role specified in the DataAccessRoleArn request parameter must have
  permission to use the specified KMS key.
- `"Tags"`: Adds one or more custom tags, each in the form of a key:value pair, to the
  Medica Scribe job. To learn more about using tags with Amazon Transcribe, refer to Tagging
  resources.
"""
function start_medical_scribe_job(
    DataAccessRoleArn,
    Media,
    MedicalScribeJobName,
    OutputBucketName,
    Settings;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transcribe(
        "StartMedicalScribeJob",
        Dict{String,Any}(
            "DataAccessRoleArn" => DataAccessRoleArn,
            "Media" => Media,
            "MedicalScribeJobName" => MedicalScribeJobName,
            "OutputBucketName" => OutputBucketName,
            "Settings" => Settings,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_medical_scribe_job(
    DataAccessRoleArn,
    Media,
    MedicalScribeJobName,
    OutputBucketName,
    Settings,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transcribe(
        "StartMedicalScribeJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DataAccessRoleArn" => DataAccessRoleArn,
                    "Media" => Media,
                    "MedicalScribeJobName" => MedicalScribeJobName,
                    "OutputBucketName" => OutputBucketName,
                    "Settings" => Settings,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_medical_transcription_job(language_code, media, medical_transcription_job_name, output_bucket_name, specialty, type)
    start_medical_transcription_job(language_code, media, medical_transcription_job_name, output_bucket_name, specialty, type, params::Dict{String,<:Any})

Transcribes the audio from a medical dictation or conversation and applies any additional
Request Parameters you choose to include in your request. In addition to many standard
transcription features, Amazon Transcribe Medical provides you with a robust medical
vocabulary and, optionally, content identification, which adds flags to personal health
information (PHI). To learn more about these features, refer to How Amazon Transcribe
Medical works. To make a StartMedicalTranscriptionJob request, you must first upload your
media file into an Amazon S3 bucket; you can then specify the Amazon S3 location of the
file using the Media parameter. You must include the following parameters in your
StartMedicalTranscriptionJob request:    region: The Amazon Web Services Region where you
are making your request. For a list of Amazon Web Services Regions supported with Amazon
Transcribe, refer to Amazon Transcribe endpoints and quotas.
MedicalTranscriptionJobName: A custom name you create for your transcription job that is
unique within your Amazon Web Services account.    Media (MediaFileUri): The Amazon S3
location of your media file.    LanguageCode: This must be en-US.    OutputBucketName: The
Amazon S3 bucket where you want your transcript stored. If you want your output stored in a
sub-folder of this bucket, you must also include OutputKey.    Specialty: This must be
PRIMARYCARE.    Type: Choose whether your audio is a conversation or a dictation.

# Arguments
- `language_code`: The language code that represents the language spoken in the input media
  file. US English (en-US) is the only valid value for medical transcription jobs. Any other
  value you enter for language code results in a BadRequestException error.
- `media`:
- `medical_transcription_job_name`: A unique name, chosen by you, for your medical
  transcription job. The name that you specify is also used as the default name of your
  transcription output file. If you want to specify a different name for your transcription
  output, use the OutputKey parameter. This name is case sensitive, cannot contain spaces,
  and must be unique within an Amazon Web Services account. If you try to create a new job
  with the same name as an existing job, you get a ConflictException error.
- `output_bucket_name`: The name of the Amazon S3 bucket where you want your medical
  transcription output stored. Do not include the S3:// prefix of the specified bucket. If
  you want your output to go to a sub-folder of this bucket, specify it using the OutputKey
  parameter; OutputBucketName only accepts the name of a bucket. For example, if you want
  your output stored in S3://DOC-EXAMPLE-BUCKET, set OutputBucketName to DOC-EXAMPLE-BUCKET.
  However, if you want your output stored in S3://DOC-EXAMPLE-BUCKET/test-files/, set
  OutputBucketName to DOC-EXAMPLE-BUCKET and OutputKey to test-files/. Note that Amazon
  Transcribe must have permission to use the specified location. You can change Amazon S3
  permissions using the Amazon Web Services Management Console. See also Permissions Required
  for IAM User Roles.
- `specialty`: Specify the predominant medical specialty represented in your media. For
  batch transcriptions, PRIMARYCARE is the only valid value. If you require additional
  specialties, refer to .
- `type`: Specify whether your input media contains only one person (DICTATION) or contains
  a conversation between two people (CONVERSATION). For example, DICTATION could be used for
  a medical professional wanting to transcribe voice memos; CONVERSATION could be used for
  transcribing the doctor-patient dialogue during the patient's office visit.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ContentIdentificationType"`: Labels all personal health information (PHI) identified in
  your transcript. For more information, see Identifying personal health information (PHI) in
  a transcription.
- `"KMSEncryptionContext"`: A map of plain text, non-secret key:value pairs, known as
  encryption context pairs, that provide an added layer of security for your data. For more
  information, see KMS encryption context and Asymmetric keys in KMS.
- `"MediaFormat"`: Specify the format of your input media file.
- `"MediaSampleRateHertz"`: The sample rate, in hertz, of the audio track in your input
  media file. If you do not specify the media sample rate, Amazon Transcribe Medical
  determines it for you. If you specify the sample rate, it must match the rate detected by
  Amazon Transcribe Medical; if there's a mismatch between the value that you specify and the
  value detected, your job fails. Therefore, in most cases, it's advised to omit
  MediaSampleRateHertz and let Amazon Transcribe Medical determine the sample rate.
- `"OutputEncryptionKMSKeyId"`: The KMS key you want to use to encrypt your medical
  transcription output. If using a key located in the current Amazon Web Services account,
  you can specify your KMS key in one of four ways:   Use the KMS key ID itself. For example,
  1234abcd-12ab-34cd-56ef-1234567890ab.   Use an alias for the KMS key ID. For example,
  alias/ExampleAlias.   Use the Amazon Resource Name (ARN) for the KMS key ID. For example,
  arn:aws:kms:region:account-ID:key/1234abcd-12ab-34cd-56ef-1234567890ab.   Use the ARN for
  the KMS key alias. For example, arn:aws:kms:region:account-ID:alias/ExampleAlias.   If
  using a key located in a different Amazon Web Services account than the current Amazon Web
  Services account, you can specify your KMS key in one of two ways:   Use the ARN for the
  KMS key ID. For example,
  arn:aws:kms:region:account-ID:key/1234abcd-12ab-34cd-56ef-1234567890ab.   Use the ARN for
  the KMS key alias. For example, arn:aws:kms:region:account-ID:alias/ExampleAlias.   If you
  do not specify an encryption key, your output is encrypted with the default Amazon S3 key
  (SSE-S3). If you specify a KMS key to encrypt your output, you must also specify an output
  location using the OutputLocation parameter. Note that the role making the request must
  have permission to use the specified KMS key.
- `"OutputKey"`: Use in combination with OutputBucketName to specify the output location of
  your transcript and, optionally, a unique name for your output file. The default name for
  your transcription output is the same as the name you specified for your medical
  transcription job (MedicalTranscriptionJobName). Here are some examples of how you can use
  OutputKey:   If you specify 'DOC-EXAMPLE-BUCKET' as the OutputBucketName and
  'my-transcript.json' as the OutputKey, your transcription output path is
  s3://DOC-EXAMPLE-BUCKET/my-transcript.json.   If you specify 'my-first-transcription' as
  the MedicalTranscriptionJobName, 'DOC-EXAMPLE-BUCKET' as the OutputBucketName, and
  'my-transcript' as the OutputKey, your transcription output path is
  s3://DOC-EXAMPLE-BUCKET/my-transcript/my-first-transcription.json.   If you specify
  'DOC-EXAMPLE-BUCKET' as the OutputBucketName and 'test-files/my-transcript.json' as the
  OutputKey, your transcription output path is
  s3://DOC-EXAMPLE-BUCKET/test-files/my-transcript.json.   If you specify
  'my-first-transcription' as the MedicalTranscriptionJobName, 'DOC-EXAMPLE-BUCKET' as the
  OutputBucketName, and 'test-files/my-transcript' as the OutputKey, your transcription
  output path is
  s3://DOC-EXAMPLE-BUCKET/test-files/my-transcript/my-first-transcription.json.   If you
  specify the name of an Amazon S3 bucket sub-folder that doesn't exist, one is created for
  you.
- `"Settings"`: Specify additional optional settings in your request, including channel
  identification, alternative transcriptions, and speaker partitioning. You can use that to
  apply custom vocabularies to your transcription job.
- `"Tags"`: Adds one or more custom tags, each in the form of a key:value pair, to a new
  medical transcription job at the time you start this new job. To learn more about using
  tags with Amazon Transcribe, refer to Tagging resources.
"""
function start_medical_transcription_job(
    LanguageCode,
    Media,
    MedicalTranscriptionJobName,
    OutputBucketName,
    Specialty,
    Type;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transcribe(
        "StartMedicalTranscriptionJob",
        Dict{String,Any}(
            "LanguageCode" => LanguageCode,
            "Media" => Media,
            "MedicalTranscriptionJobName" => MedicalTranscriptionJobName,
            "OutputBucketName" => OutputBucketName,
            "Specialty" => Specialty,
            "Type" => Type,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_medical_transcription_job(
    LanguageCode,
    Media,
    MedicalTranscriptionJobName,
    OutputBucketName,
    Specialty,
    Type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transcribe(
        "StartMedicalTranscriptionJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "LanguageCode" => LanguageCode,
                    "Media" => Media,
                    "MedicalTranscriptionJobName" => MedicalTranscriptionJobName,
                    "OutputBucketName" => OutputBucketName,
                    "Specialty" => Specialty,
                    "Type" => Type,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_transcription_job(media, transcription_job_name)
    start_transcription_job(media, transcription_job_name, params::Dict{String,<:Any})

Transcribes the audio from a media file and applies any additional Request Parameters you
choose to include in your request. To make a StartTranscriptionJob request, you must first
upload your media file into an Amazon S3 bucket; you can then specify the Amazon S3
location of the file using the Media parameter. You must include the following parameters
in your StartTranscriptionJob request:    region: The Amazon Web Services Region where you
are making your request. For a list of Amazon Web Services Regions supported with Amazon
Transcribe, refer to Amazon Transcribe endpoints and quotas.    TranscriptionJobName: A
custom name you create for your transcription job that is unique within your Amazon Web
Services account.    Media (MediaFileUri): The Amazon S3 location of your media file.   One
of LanguageCode, IdentifyLanguage, or IdentifyMultipleLanguages: If you know the language
of your media file, specify it using the LanguageCode parameter; you can find all valid
language codes in the Supported languages table. If you do not know the languages spoken in
your media, use either IdentifyLanguage or IdentifyMultipleLanguages and let Amazon
Transcribe identify the languages for you.

# Arguments
- `media`: Describes the Amazon S3 location of the media file you want to use in your
  request.
- `transcription_job_name`: A unique name, chosen by you, for your transcription job. The
  name that you specify is also used as the default name of your transcription output file.
  If you want to specify a different name for your transcription output, use the OutputKey
  parameter. This name is case sensitive, cannot contain spaces, and must be unique within an
  Amazon Web Services account. If you try to create a new job with the same name as an
  existing job, you get a ConflictException error.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ContentRedaction"`: Makes it possible to redact or flag specified personally
  identifiable information (PII) in your transcript. If you use ContentRedaction, you must
  also include the sub-parameters: RedactionOutput and RedactionType. You can optionally
  include PiiEntityTypes to choose which types of PII you want to redact. If you do not
  include PiiEntityTypes in your request, all PII is redacted.
- `"IdentifyLanguage"`: Enables automatic language identification in your transcription job
  request. Use this parameter if your media file contains only one language. If your media
  contains multiple languages, use IdentifyMultipleLanguages instead. If you include
  IdentifyLanguage, you can optionally include a list of language codes, using
  LanguageOptions, that you think may be present in your media file. Including
  LanguageOptions restricts IdentifyLanguage to only the language options that you specify,
  which can improve transcription accuracy. If you want to apply a custom language model, a
  custom vocabulary, or a custom vocabulary filter to your automatic language identification
  request, include LanguageIdSettings with the relevant sub-parameters (VocabularyName,
  LanguageModelName, and VocabularyFilterName). If you include LanguageIdSettings, also
  include LanguageOptions. Note that you must include one of LanguageCode, IdentifyLanguage,
  or IdentifyMultipleLanguages in your request. If you include more than one of these
  parameters, your transcription job fails.
- `"IdentifyMultipleLanguages"`: Enables automatic multi-language identification in your
  transcription job request. Use this parameter if your media file contains more than one
  language. If your media contains only one language, use IdentifyLanguage instead. If you
  include IdentifyMultipleLanguages, you can optionally include a list of language codes,
  using LanguageOptions, that you think may be present in your media file. Including
  LanguageOptions restricts IdentifyLanguage to only the language options that you specify,
  which can improve transcription accuracy. If you want to apply a custom vocabulary or a
  custom vocabulary filter to your automatic language identification request, include
  LanguageIdSettings with the relevant sub-parameters (VocabularyName and
  VocabularyFilterName). If you include LanguageIdSettings, also include LanguageOptions.
  Note that you must include one of LanguageCode, IdentifyLanguage, or
  IdentifyMultipleLanguages in your request. If you include more than one of these
  parameters, your transcription job fails.
- `"JobExecutionSettings"`: Makes it possible to control how your transcription job is
  processed. Currently, the only JobExecutionSettings modification you can choose is enabling
  job queueing using the AllowDeferredExecution sub-parameter. If you include
  JobExecutionSettings in your request, you must also include the sub-parameters:
  AllowDeferredExecution and DataAccessRoleArn.
- `"KMSEncryptionContext"`: A map of plain text, non-secret key:value pairs, known as
  encryption context pairs, that provide an added layer of security for your data. For more
  information, see KMS encryption context and Asymmetric keys in KMS.
- `"LanguageCode"`: The language code that represents the language spoken in the input
  media file. If you're unsure of the language spoken in your media file, consider using
  IdentifyLanguage or IdentifyMultipleLanguages to enable automatic language identification.
  Note that you must include one of LanguageCode, IdentifyLanguage, or
  IdentifyMultipleLanguages in your request. If you include more than one of these
  parameters, your transcription job fails. For a list of supported languages and their
  associated language codes, refer to the Supported languages table.  To transcribe speech in
  Modern Standard Arabic (ar-SA), your media file must be encoded at a sample rate of 16,000
  Hz or higher.
- `"LanguageIdSettings"`: If using automatic language identification in your request and
  you want to apply a custom language model, a custom vocabulary, or a custom vocabulary
  filter, include LanguageIdSettings with the relevant sub-parameters (VocabularyName,
  LanguageModelName, and VocabularyFilterName). Note that multi-language identification
  (IdentifyMultipleLanguages) doesn't support custom language models.  LanguageIdSettings
  supports two to five language codes. Each language code you include can have an associated
  custom language model, custom vocabulary, and custom vocabulary filter. The language codes
  that you specify must match the languages of the associated custom language models, custom
  vocabularies, and custom vocabulary filters. It's recommended that you include
  LanguageOptions when using LanguageIdSettings to ensure that the correct language dialect
  is identified. For example, if you specify a custom vocabulary that is in en-US but Amazon
  Transcribe determines that the language spoken in your media is en-AU, your custom
  vocabulary is not applied to your transcription. If you include LanguageOptions and include
  en-US as the only English language dialect, your custom vocabulary is applied to your
  transcription. If you want to include a custom language model with your request but do not
  want to use automatic language identification, use instead the  parameter with the
  LanguageModelName sub-parameter. If you want to include a custom vocabulary or a custom
  vocabulary filter (or both) with your request but do not want to use automatic language
  identification, use instead the  parameter with the VocabularyName or VocabularyFilterName
  (or both) sub-parameter.
- `"LanguageOptions"`: You can specify two or more language codes that represent the
  languages you think may be present in your media. Including more than five is not
  recommended. If you're unsure what languages are present, do not include this parameter. If
  you include LanguageOptions in your request, you must also include IdentifyLanguage. For
  more information, refer to Supported languages. To transcribe speech in Modern Standard
  Arabic (ar-SA), your media file must be encoded at a sample rate of 16,000 Hz or higher.
- `"MediaFormat"`: Specify the format of your input media file.
- `"MediaSampleRateHertz"`: The sample rate, in hertz, of the audio track in your input
  media file. If you do not specify the media sample rate, Amazon Transcribe determines it
  for you. If you specify the sample rate, it must match the rate detected by Amazon
  Transcribe. If there's a mismatch between the value that you specify and the value
  detected, your job fails. In most cases, you can omit MediaSampleRateHertz and let Amazon
  Transcribe determine the sample rate.
- `"ModelSettings"`: Specify the custom language model you want to include with your
  transcription job. If you include ModelSettings in your request, you must include the
  LanguageModelName sub-parameter. For more information, see Custom language models.
- `"OutputBucketName"`: The name of the Amazon S3 bucket where you want your transcription
  output stored. Do not include the S3:// prefix of the specified bucket. If you want your
  output to go to a sub-folder of this bucket, specify it using the OutputKey parameter;
  OutputBucketName only accepts the name of a bucket. For example, if you want your output
  stored in S3://DOC-EXAMPLE-BUCKET, set OutputBucketName to DOC-EXAMPLE-BUCKET. However, if
  you want your output stored in S3://DOC-EXAMPLE-BUCKET/test-files/, set OutputBucketName to
  DOC-EXAMPLE-BUCKET and OutputKey to test-files/. Note that Amazon Transcribe must have
  permission to use the specified location. You can change Amazon S3 permissions using the
  Amazon Web Services Management Console. See also Permissions Required for IAM User Roles.
  If you do not specify OutputBucketName, your transcript is placed in a service-managed
  Amazon S3 bucket and you are provided with a URI to access your transcript.
- `"OutputEncryptionKMSKeyId"`: The KMS key you want to use to encrypt your transcription
  output. If using a key located in the current Amazon Web Services account, you can specify
  your KMS key in one of four ways:   Use the KMS key ID itself. For example,
  1234abcd-12ab-34cd-56ef-1234567890ab.   Use an alias for the KMS key ID. For example,
  alias/ExampleAlias.   Use the Amazon Resource Name (ARN) for the KMS key ID. For example,
  arn:aws:kms:region:account-ID:key/1234abcd-12ab-34cd-56ef-1234567890ab.   Use the ARN for
  the KMS key alias. For example, arn:aws:kms:region:account-ID:alias/ExampleAlias.   If
  using a key located in a different Amazon Web Services account than the current Amazon Web
  Services account, you can specify your KMS key in one of two ways:   Use the ARN for the
  KMS key ID. For example,
  arn:aws:kms:region:account-ID:key/1234abcd-12ab-34cd-56ef-1234567890ab.   Use the ARN for
  the KMS key alias. For example, arn:aws:kms:region:account-ID:alias/ExampleAlias.   If you
  do not specify an encryption key, your output is encrypted with the default Amazon S3 key
  (SSE-S3). If you specify a KMS key to encrypt your output, you must also specify an output
  location using the OutputLocation parameter. Note that the role making the request must
  have permission to use the specified KMS key.
- `"OutputKey"`: Use in combination with OutputBucketName to specify the output location of
  your transcript and, optionally, a unique name for your output file. The default name for
  your transcription output is the same as the name you specified for your transcription job
  (TranscriptionJobName). Here are some examples of how you can use OutputKey:   If you
  specify 'DOC-EXAMPLE-BUCKET' as the OutputBucketName and 'my-transcript.json' as the
  OutputKey, your transcription output path is s3://DOC-EXAMPLE-BUCKET/my-transcript.json.
  If you specify 'my-first-transcription' as the TranscriptionJobName, 'DOC-EXAMPLE-BUCKET'
  as the OutputBucketName, and 'my-transcript' as the OutputKey, your transcription output
  path is s3://DOC-EXAMPLE-BUCKET/my-transcript/my-first-transcription.json.   If you specify
  'DOC-EXAMPLE-BUCKET' as the OutputBucketName and 'test-files/my-transcript.json' as the
  OutputKey, your transcription output path is
  s3://DOC-EXAMPLE-BUCKET/test-files/my-transcript.json.   If you specify
  'my-first-transcription' as the TranscriptionJobName, 'DOC-EXAMPLE-BUCKET' as the
  OutputBucketName, and 'test-files/my-transcript' as the OutputKey, your transcription
  output path is
  s3://DOC-EXAMPLE-BUCKET/test-files/my-transcript/my-first-transcription.json.   If you
  specify the name of an Amazon S3 bucket sub-folder that doesn't exist, one is created for
  you.
- `"Settings"`: Specify additional optional settings in your request, including channel
  identification, alternative transcriptions, speaker partitioning. You can use that to apply
  custom vocabularies and vocabulary filters. If you want to include a custom vocabulary or a
  custom vocabulary filter (or both) with your request but do not want to use automatic
  language identification, use Settings with the VocabularyName or VocabularyFilterName (or
  both) sub-parameter. If you're using automatic language identification with your request
  and want to include a custom language model, a custom vocabulary, or a custom vocabulary
  filter, use instead the  parameter with the LanguageModelName, VocabularyName or
  VocabularyFilterName sub-parameters.
- `"Subtitles"`: Produces subtitle files for your input media. You can specify WebVTT
  (*.vtt) and SubRip (*.srt) formats.
- `"Tags"`: Adds one or more custom tags, each in the form of a key:value pair, to a new
  transcription job at the time you start this new job. To learn more about using tags with
  Amazon Transcribe, refer to Tagging resources.
- `"ToxicityDetection"`: Enables toxic speech detection in your transcript. If you include
  ToxicityDetection in your request, you must also include ToxicityCategories. For
  information on the types of toxic speech Amazon Transcribe can detect, see Detecting toxic
  speech.
"""
function start_transcription_job(
    Media, TranscriptionJobName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transcribe(
        "StartTranscriptionJob",
        Dict{String,Any}("Media" => Media, "TranscriptionJobName" => TranscriptionJobName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_transcription_job(
    Media,
    TranscriptionJobName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transcribe(
        "StartTranscriptionJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Media" => Media, "TranscriptionJobName" => TranscriptionJobName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds one or more custom tags, each in the form of a key:value pair, to the specified
resource. To learn more about using tags with Amazon Transcribe, refer to Tagging resources.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource you want to tag. ARNs have
  the format arn:partition:service:region:account-id:resource-type/resource-id. For example,
  arn:aws:transcribe:us-west-2:111122223333:transcription-job/transcription-job-name. Valid
  values for resource-type are: transcription-job, medical-transcription-job, vocabulary,
  medical-vocabulary, vocabulary-filter, and language-model.
- `tags`: Adds one or more custom tags, each in the form of a key:value pair, to the
  specified resource. To learn more about using tags with Amazon Transcribe, refer to Tagging
  resources.

"""
function tag_resource(ResourceArn, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return transcribe(
        "TagResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceArn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transcribe(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes the specified tags from the specified Amazon Transcribe resource. If you include
UntagResource in your request, you must also include ResourceArn and TagKeys.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the Amazon Transcribe resource you want
  to remove tags from. ARNs have the format
  arn:partition:service:region:account-id:resource-type/resource-id. For example,
  arn:aws:transcribe:us-west-2:111122223333:transcription-job/transcription-job-name. Valid
  values for resource-type are: transcription-job, medical-transcription-job, vocabulary,
  medical-vocabulary, vocabulary-filter, and language-model.
- `tag_keys`: Removes the specified tag keys from the specified Amazon Transcribe resource.

"""
function untag_resource(
    ResourceArn, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transcribe(
        "UntagResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceArn,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transcribe(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_call_analytics_category(category_name, rules)
    update_call_analytics_category(category_name, rules, params::Dict{String,<:Any})

Updates the specified Call Analytics category with new rules. Note that the
UpdateCallAnalyticsCategory operation overwrites all existing rules contained in the
specified category. You cannot append additional rules onto an existing category. To create
a new category, see .

# Arguments
- `category_name`: The name of the Call Analytics category you want to update. Category
  names are case sensitive.
- `rules`: The rules used for the updated Call Analytics category. The rules you provide in
  this field replace the ones that are currently being used in the specified category.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"InputType"`: Choose whether you want to update a real-time or a post-call category. The
  input type you specify must match the input type specified when the category was created.
  For example, if you created a category with the POST_CALL input type, you must use
  POST_CALL as the input type when updating this category.
"""
function update_call_analytics_category(
    CategoryName, Rules; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transcribe(
        "UpdateCallAnalyticsCategory",
        Dict{String,Any}("CategoryName" => CategoryName, "Rules" => Rules);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_call_analytics_category(
    CategoryName,
    Rules,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transcribe(
        "UpdateCallAnalyticsCategory",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("CategoryName" => CategoryName, "Rules" => Rules),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_medical_vocabulary(language_code, vocabulary_file_uri, vocabulary_name)
    update_medical_vocabulary(language_code, vocabulary_file_uri, vocabulary_name, params::Dict{String,<:Any})

Updates an existing custom medical vocabulary with new values. This operation overwrites
all existing information with your new values; you cannot append new terms onto an existing
custom vocabulary.

# Arguments
- `language_code`: The language code that represents the language of the entries in the
  custom vocabulary you want to update. US English (en-US) is the only language supported
  with Amazon Transcribe Medical.
- `vocabulary_file_uri`: The Amazon S3 location of the text file that contains your custom
  medical vocabulary. The URI must be located in the same Amazon Web Services Region as the
  resource you're calling. Here's an example URI path:
  s3://DOC-EXAMPLE-BUCKET/my-vocab-file.txt
- `vocabulary_name`: The name of the custom medical vocabulary you want to update. Custom
  medical vocabulary names are case sensitive.

"""
function update_medical_vocabulary(
    LanguageCode,
    VocabularyFileUri,
    VocabularyName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transcribe(
        "UpdateMedicalVocabulary",
        Dict{String,Any}(
            "LanguageCode" => LanguageCode,
            "VocabularyFileUri" => VocabularyFileUri,
            "VocabularyName" => VocabularyName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_medical_vocabulary(
    LanguageCode,
    VocabularyFileUri,
    VocabularyName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transcribe(
        "UpdateMedicalVocabulary",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "LanguageCode" => LanguageCode,
                    "VocabularyFileUri" => VocabularyFileUri,
                    "VocabularyName" => VocabularyName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_vocabulary(language_code, vocabulary_name)
    update_vocabulary(language_code, vocabulary_name, params::Dict{String,<:Any})

Updates an existing custom vocabulary with new values. This operation overwrites all
existing information with your new values; you cannot append new terms onto an existing
custom vocabulary.

# Arguments
- `language_code`: The language code that represents the language of the entries in the
  custom vocabulary you want to update. Each custom vocabulary must contain terms in only one
  language. A custom vocabulary can only be used to transcribe files in the same language as
  the custom vocabulary. For example, if you create a custom vocabulary using US English
  (en-US), you can only apply this custom vocabulary to files that contain English audio. For
  a list of supported languages and their associated language codes, refer to the Supported
  languages table.
- `vocabulary_name`: The name of the custom vocabulary you want to update. Custom
  vocabulary names are case sensitive.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DataAccessRoleArn"`: The Amazon Resource Name (ARN) of an IAM role that has permissions
  to access the Amazon S3 bucket that contains your input files (in this case, your custom
  vocabulary). If the role that you specify doesn’t have the appropriate permissions to
  access the specified Amazon S3 location, your request fails. IAM role ARNs have the format
  arn:partition:iam::account:role/role-name-with-path. For example:
  arn:aws:iam::111122223333:role/Admin. For more information, see IAM ARNs.
- `"Phrases"`: Use this parameter if you want to update your custom vocabulary by including
  all desired terms, as comma-separated values, within your request. The other option for
  updating your custom vocabulary is to save your entries in a text file and upload them to
  an Amazon S3 bucket, then specify the location of your file using the VocabularyFileUri
  parameter. Note that if you include Phrases in your request, you cannot use
  VocabularyFileUri; you must choose one or the other. Each language has a character set that
  contains all allowed characters for that specific language. If you use unsupported
  characters, your custom vocabulary filter request fails. Refer to Character Sets for Custom
  Vocabularies to get the character set for your language.
- `"VocabularyFileUri"`: The Amazon S3 location of the text file that contains your custom
  vocabulary. The URI must be located in the same Amazon Web Services Region as the resource
  you're calling. Here's an example URI path: s3://DOC-EXAMPLE-BUCKET/my-vocab-file.txt  Note
  that if you include VocabularyFileUri in your request, you cannot use the Phrases flag; you
  must choose one or the other.
"""
function update_vocabulary(
    LanguageCode, VocabularyName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transcribe(
        "UpdateVocabulary",
        Dict{String,Any}(
            "LanguageCode" => LanguageCode, "VocabularyName" => VocabularyName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_vocabulary(
    LanguageCode,
    VocabularyName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transcribe(
        "UpdateVocabulary",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "LanguageCode" => LanguageCode, "VocabularyName" => VocabularyName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_vocabulary_filter(vocabulary_filter_name)
    update_vocabulary_filter(vocabulary_filter_name, params::Dict{String,<:Any})

Updates an existing custom vocabulary filter with a new list of words. The new list you
provide overwrites all previous entries; you cannot append new terms onto an existing
custom vocabulary filter.

# Arguments
- `vocabulary_filter_name`: The name of the custom vocabulary filter you want to update.
  Custom vocabulary filter names are case sensitive.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DataAccessRoleArn"`: The Amazon Resource Name (ARN) of an IAM role that has permissions
  to access the Amazon S3 bucket that contains your input files (in this case, your custom
  vocabulary filter). If the role that you specify doesn’t have the appropriate permissions
  to access the specified Amazon S3 location, your request fails. IAM role ARNs have the
  format arn:partition:iam::account:role/role-name-with-path. For example:
  arn:aws:iam::111122223333:role/Admin. For more information, see IAM ARNs.
- `"VocabularyFilterFileUri"`: The Amazon S3 location of the text file that contains your
  custom vocabulary filter terms. The URI must be located in the same Amazon Web Services
  Region as the resource you're calling. Here's an example URI path:
  s3://DOC-EXAMPLE-BUCKET/my-vocab-filter-file.txt  Note that if you include
  VocabularyFilterFileUri in your request, you cannot use Words; you must choose one or the
  other.
- `"Words"`: Use this parameter if you want to update your custom vocabulary filter by
  including all desired terms, as comma-separated values, within your request. The other
  option for updating your vocabulary filter is to save your entries in a text file and
  upload them to an Amazon S3 bucket, then specify the location of your file using the
  VocabularyFilterFileUri parameter. Note that if you include Words in your request, you
  cannot use VocabularyFilterFileUri; you must choose one or the other. Each language has a
  character set that contains all allowed characters for that specific language. If you use
  unsupported characters, your custom vocabulary filter request fails. Refer to Character
  Sets for Custom Vocabularies to get the character set for your language.
"""
function update_vocabulary_filter(
    VocabularyFilterName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transcribe(
        "UpdateVocabularyFilter",
        Dict{String,Any}("VocabularyFilterName" => VocabularyFilterName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_vocabulary_filter(
    VocabularyFilterName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transcribe(
        "UpdateVocabularyFilter",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("VocabularyFilterName" => VocabularyFilterName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: importexport
using AWS.Compat
using AWS.UUIDs

"""
    cancel_job(job_id)
    cancel_job(job_id, params::Dict{String,<:Any})

This operation cancels a specified job. Only the job owner can cancel it. The operation
fails if the job has already started or is complete.

# Arguments
- `job_id`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"APIVersion"`:
"""
function cancel_job(JobId; aws_config::AbstractAWSConfig=current_aws_config())
    return importexport(
        "CancelJob",
        Dict{String,Any}("JobId" => JobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_job(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return importexport(
        "CancelJob",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("JobId" => JobId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_job(job_type, manifest, validate_only)
    create_job(job_type, manifest, validate_only, params::Dict{String,<:Any})

This operation initiates the process of scheduling an upload or download of your data. You
include in the request a manifest that describes the data transfer specifics. The response
to the request includes a job ID, which you can use in other operations, a signature that
you use to identify your storage device, and the address where you should ship your storage
device.

# Arguments
- `job_type`:
- `manifest`:
- `validate_only`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"APIVersion"`:
- `"ManifestAddendum"`:
"""
function create_job(
    JobType, Manifest, ValidateOnly; aws_config::AbstractAWSConfig=current_aws_config()
)
    return importexport(
        "CreateJob",
        Dict{String,Any}(
            "JobType" => JobType, "Manifest" => Manifest, "ValidateOnly" => ValidateOnly
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_job(
    JobType,
    Manifest,
    ValidateOnly,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return importexport(
        "CreateJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "JobType" => JobType,
                    "Manifest" => Manifest,
                    "ValidateOnly" => ValidateOnly,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_shipping_label(job_ids)
    get_shipping_label(job_ids, params::Dict{String,<:Any})

This operation generates a pre-paid UPS shipping label that you will use to ship your
device to AWS for processing.

# Arguments
- `job_ids`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"APIVersion"`:
- `"city"`:
- `"company"`:
- `"country"`:
- `"name"`:
- `"phoneNumber"`:
- `"postalCode"`:
- `"stateOrProvince"`:
- `"street1"`:
- `"street2"`:
- `"street3"`:
"""
function get_shipping_label(jobIds; aws_config::AbstractAWSConfig=current_aws_config())
    return importexport(
        "GetShippingLabel",
        Dict{String,Any}("jobIds" => jobIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_shipping_label(
    jobIds, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return importexport(
        "GetShippingLabel",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("jobIds" => jobIds), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_status(job_id)
    get_status(job_id, params::Dict{String,<:Any})

This operation returns information about a job, including where the job is in the
processing pipeline, the status of the results, and the signature value associated with the
job. You can only return information about jobs you own.

# Arguments
- `job_id`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"APIVersion"`:
"""
function get_status(JobId; aws_config::AbstractAWSConfig=current_aws_config())
    return importexport(
        "GetStatus",
        Dict{String,Any}("JobId" => JobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_status(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return importexport(
        "GetStatus",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("JobId" => JobId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_jobs()
    list_jobs(params::Dict{String,<:Any})

This operation returns the jobs associated with the requester. AWS Import/Export lists the
jobs in reverse chronological order based on the date of creation. For example if Job Test1
was created 2009Dec30 and Test2 was created 2010Feb05, the ListJobs operation would return
Test2 followed by Test1.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"APIVersion"`:
- `"Marker"`:
- `"MaxJobs"`:
"""
function list_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return importexport("ListJobs"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return importexport(
        "ListJobs", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    update_job(job_id, job_type, manifest, validate_only)
    update_job(job_id, job_type, manifest, validate_only, params::Dict{String,<:Any})

You use this operation to change the parameters specified in the original manifest file by
supplying a new manifest file. The manifest file attached to this request replaces the
original manifest file. You can only use the operation after a CreateJob request but before
the data transfer starts and you can only use it on jobs you own.

# Arguments
- `job_id`:
- `job_type`:
- `manifest`:
- `validate_only`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"APIVersion"`:
"""
function update_job(
    JobId,
    JobType,
    Manifest,
    ValidateOnly;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return importexport(
        "UpdateJob",
        Dict{String,Any}(
            "JobId" => JobId,
            "JobType" => JobType,
            "Manifest" => Manifest,
            "ValidateOnly" => ValidateOnly,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_job(
    JobId,
    JobType,
    Manifest,
    ValidateOnly,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return importexport(
        "UpdateJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "JobId" => JobId,
                    "JobType" => JobType,
                    "Manifest" => Manifest,
                    "ValidateOnly" => ValidateOnly,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

mutable struct ServiceFile
    repo::String
    name::String
    sha::String
    definition::Union{AbstractDict,Nothing}
end

function ServiceFile(repo::String, tree_item::AbstractDict)
    return ServiceFile(repo, tree_item["path"], tree_item["sha"], nothing)
end

function service_definition(
    service_file::ServiceFile; auth::GitHub.Authorization=GitHub.AnonymousAuth()
)
    if service_file.definition === nothing
        # Retrieve the contents of the ${service}.normal.json file
        service_blob = blob(service_file.repo, service_file.sha; auth=auth)
        def = JSON.parse(String(base64decode(service_blob.content)))
        service_file.definition = def
    end

    return service_file.definition
end

function Base.:(==)(a::ServiceFile, b::ServiceFile)
    return (
        a.repo == b.repo &&
        a.name == b.name &&
        a.sha == b.sha &&
        a.definition == b.definition
    )
end

"""
Get a list of all AWS service API definition files from the `awsk-sdk-js` GitHub repository.
"""
function _get_service_files(repo_name::String, auth::GitHub.Authorization)
    master_tree = @mock tree(repo_name, "master"; auth=auth)
    apis_sha = [t for t in master_tree.tree if t["path"] == "apis"][1]["sha"]
    files = @mock tree(repo_name, apis_sha)
    tree_items = files.tree

    filter!(f -> endswith(f["path"], ".normal.json"), tree_items)
    tree_items = _filter_latest_service_version(tree_items)

    return [ServiceFile(repo_name, item) for item in tree_items]
end

"""
Return a list of all AWS Services and their latest version.
"""
function _filter_latest_service_version(services::AbstractArray)
    seen_services = Set{String}()
    latest_versions = OrderedDict[]

    for service in reverse(services)
        service_name, _ = _get_service_and_version(service["path"])

        if !(service_name in seen_services)
            push!(seen_services, service_name)
            push!(latest_versions, service)
        end
    end

    return latest_versions
end

"""
Return a string with line breaks added such that lines are wrapped at or before the limit.
"""
function _wraplines(str, limit=92; delim="\n")
    lines = String[]

    while !isempty(str)
        line, str = _splitline(str, limit)
        push!(lines, rstrip(line))  # strip trailing whitespace
    end

    return join(lines, delim)
end

"""
Split the string `str` at or before `limit`.
Prefers splitting the string on whitespace rather than mid-word, when possible.
`limit` is measured in codeunits, which is an upper-bound on the number of characters.
"""
function _splitline(str, limit)
    limit >= 1 || throw(DomainError(limit, "Lines cannot be split before the first char."))
    ncodeunits(str) <= limit && return (str, "")
    limit = _validindex(str, limit)
    first_line = str[1:limit]
    # split on whitespace if possible, else just split when we hit the limit.
    split_point = something(findlast(==(' '), first_line), limit)
    stop = _validindex(first_line, split_point)

    while ispunct(first_line[stop])  # avoid splitting escaped characters.
        stop = prevind(first_line, stop)
    end

    restart = nextind(first_line, stop)

    return (str[1:stop], str[restart:end])
end

"""
Return a valid index into the string `str`, rounding towards the first index of `str` if `i` is not itself a valid index into `str`.
`i` must be within the bounds of `string`. `_validindex(str, i)` only protects against a `StringIndexError`, not a `BoundsError`.
"""
function _validindex(str, limit)
    prev = max(firstindex(str), prevind(str, limit))
    next = nextind(str, prev)

    return next == limit ? limit : prev
end

"""
Convert a function name from CamelCase to snake_case
"""
function _format_name(function_name::String)
    # Replace a string of uppercase characters with themselves prefaced by an underscore
    # [A-Z](?![A-Z]) => Match a single uppercase character that is not followed by another uppercase character
    # |(A-Z]{1,})    => Match 1-Infinite amounts of uppercase characters
    function_name = replace(function_name, r"[A-Z](?![A-Z])|([A-Z]{1,})" => s"_\g<0>")

    # Lowercase the entire string
    function_name = lowercase(function_name)

    # Chop off the leading underscore
    return if startswith(function_name, "_")
        chop(function_name; head=1, tail=0)
    else
        function_name
    end
end

"""
Replace URI parameters with the appropriate syntax for Julia interpolation.

Find all URI parameters, and apply the following replacements:
    * { => \$(
    * } => )
    * - => _
    * + => empty string

Example: "/v1/configurations/{configuration-id}" => "/v1/configurations/\$(configuration_id)"
"""
function _clean_uri(uri::String)
    uri_parameters = eachmatch(r"{.*?}", uri) # Match anything surrounded in "{ }"

    for param in uri_parameters
        match = param.match
        original_match = match

        match = replace(match, '{' => "\$(")  # Replace { with $(
        match = replace(match, '}' => ')')  # Replace } with )
        match = replace(match, '-' => '_')  # Replace hyphens with underscores
        match = replace(match, '+' => "")  # Remove +

        uri = replace(uri, original_match => match)
    end

    return uri
end

"""
Clean up the documentation to make it Julia compiler and human-readable.

- Remove any HTML tags
- Remove any dollar signs
- Remove any backslashes
- Escape any double-quotes
- Escape any patterns which would be interpreted as markdown links
"""
function _clean_documentation(documentation::String)
    documentation = replace(documentation, r"\<.*?\>" => "")
    documentation = replace(documentation, '$' => "")
    documentation = replace(documentation, '\\' => "")
    documentation = replace(documentation, '"' => "\\\"")
    documentation = replace(documentation, r"\[(.*?)\]\((.*?)\)" => s"\\\\[\1](\2)")

    return documentation
end

"""
Get the `service` and `version` from a filename.
Example filename: `{Service}-{Version}.normal.json`
"""
function _get_service_and_version(filename::String)
    try
        # Remove ".normal.json" suffix
        service_and_version = join(split(filename, '.')[1:(end - 2)], '.')

        service_and_version = split(service_and_version, '-')
        service = join(service_and_version[1:(end - 3)], '-')
        version = join(service_and_version[(end - 2):end], '-')

        return (service, version)
    catch e
        if e isa BoundsError
            throw(InvalidFileName("$filename is an invalid AWS JSON filename."))
        else
            rethrow()
        end
    end
end

"""
Get the required and optional parameters for a given operation.
"""
function _get_function_parameters(input::String, shapes::AbstractDict{String})
    """
        _get_parameter_name(parameter::String, input_shape::AbstractDict{String, <:Any})

    Find the correct parameter name for making requests. Certain ones have a specific locationName, for Batch requests this locationName is nested one shape deeper.

    # Arguments
    - `parameter::String`: Name of the original parameter
    - `input_shape::AbstractDict{String, <:Any}`: The parameter shape

    # Returns
    - `String`: Either the original parameter name, the locationName for the parameter, or the locationName nested one shape deeper
    """
    function _get_parameter_name(parameter::String, input_shape::AbstractDict{String,<:Any})
        # If the parameter has a locationName, return it
        if haskey(input_shape["members"][parameter], "locationName")
            return input_shape["members"][parameter]["locationName"]
        end

        # Check to see if the nested shape has a locationName
        nested_shape = input_shape["members"][parameter]["shape"]
        nested_member = get(shapes[nested_shape], "member", Dict())

        # If nested_shape[member] exists return locationName (if exists), otherwise return the original parameter name
        return get(nested_member, "locationName", parameter)
    end

    required_parameters = LittleDict{String,Any}()
    optional_parameters = LittleDict{String,Any}()
    input_shape = shapes[input]

    if haskey(input_shape, "required")
        for parameter in input_shape["required"]
            parameter_name = _get_parameter_name(parameter, input_shape)

            # Check if the parameter needs to be in a certain place
            parameter_location = get(input_shape["members"][parameter], "location", "")

            documentation = _clean_documentation(
                get(input_shape["members"][parameter], "documentation", "")
            )

            required_parameters[parameter_name] = LittleDict{String,String}(
                "location" => parameter_location, "documentation" => documentation
            )
        end
    end

    if haskey(input_shape, "members")
        for (member_key, member_value) in input_shape["members"]
            parameter_name = get(
                input_shape["members"][member_key], "locationName", member_key
            )

            if !haskey(required_parameters, parameter_name)
                documentation = _clean_documentation(get(member_value, "documentation", ""))
                idempotent = get(member_value, "idempotencyToken", false)

                optional_parameters[parameter_name] = LittleDict{String,Union{String,Bool}}(
                    "documentation" => documentation, "idempotent" => idempotent
                )
            end
        end
    end

    return (sort(required_parameters), sort(optional_parameters))
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: codeconnections
using AWS.Compat
using AWS.UUIDs

"""
    create_connection(connection_name)
    create_connection(connection_name, params::Dict{String,<:Any})

Creates a connection that can then be given to other Amazon Web Services services like
CodePipeline so that it can access third-party code repositories. The connection is in
pending status until the third-party connection handshake is completed from the console.

# Arguments
- `connection_name`: The name of the connection to be created.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"HostArn"`: The Amazon Resource Name (ARN) of the host associated with the connection to
  be created.
- `"ProviderType"`: The name of the external provider where your third-party code
  repository is configured.
- `"Tags"`: The key-value pair to use when tagging the resource.
"""
function create_connection(
    ConnectionName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeconnections(
        "CreateConnection",
        Dict{String,Any}("ConnectionName" => ConnectionName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_connection(
    ConnectionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeconnections(
        "CreateConnection",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ConnectionName" => ConnectionName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_host(name, provider_endpoint, provider_type)
    create_host(name, provider_endpoint, provider_type, params::Dict{String,<:Any})

Creates a resource that represents the infrastructure where a third-party provider is
installed. The host is used when you create connections to an installed third-party
provider type, such as GitHub Enterprise Server. You create one host for all connections to
that provider.  A host created through the CLI or the SDK is in `PENDING` status by
default. You can make its status `AVAILABLE` by setting up the host in the console.

# Arguments
- `name`: The name of the host to be created.
- `provider_endpoint`: The endpoint of the infrastructure to be represented by the host
  after it is created.
- `provider_type`: The name of the installed provider to be associated with your
  connection. The host resource represents the infrastructure where your provider type is
  installed. The valid provider type is GitHub Enterprise Server.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: Tags for the host to be created.
- `"VpcConfiguration"`: The VPC configuration to be provisioned for the host. A VPC must be
  configured and the infrastructure to be represented by the host must already be connected
  to the VPC.
"""
function create_host(
    Name, ProviderEndpoint, ProviderType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeconnections(
        "CreateHost",
        Dict{String,Any}(
            "Name" => Name,
            "ProviderEndpoint" => ProviderEndpoint,
            "ProviderType" => ProviderType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_host(
    Name,
    ProviderEndpoint,
    ProviderType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeconnections(
        "CreateHost",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Name" => Name,
                    "ProviderEndpoint" => ProviderEndpoint,
                    "ProviderType" => ProviderType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_repository_link(connection_arn, owner_id, repository_name)
    create_repository_link(connection_arn, owner_id, repository_name, params::Dict{String,<:Any})

Creates a link to a specified external Git repository. A repository link allows Git sync to
monitor and sync changes to files in a specified Git repository.

# Arguments
- `connection_arn`: The Amazon Resource Name (ARN) of the connection to be associated with
  the repository link.
- `owner_id`: The owner ID for the repository associated with a specific sync
  configuration, such as the owner ID in GitHub.
- `repository_name`: The name of the repository to be associated with the repository link.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EncryptionKeyArn"`: The Amazon Resource Name (ARN) encryption key for the repository to
  be associated with the repository link.
- `"Tags"`: The tags for the repository to be associated with the repository link.
"""
function create_repository_link(
    ConnectionArn,
    OwnerId,
    RepositoryName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeconnections(
        "CreateRepositoryLink",
        Dict{String,Any}(
            "ConnectionArn" => ConnectionArn,
            "OwnerId" => OwnerId,
            "RepositoryName" => RepositoryName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_repository_link(
    ConnectionArn,
    OwnerId,
    RepositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeconnections(
        "CreateRepositoryLink",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ConnectionArn" => ConnectionArn,
                    "OwnerId" => OwnerId,
                    "RepositoryName" => RepositoryName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_sync_configuration(branch, config_file, repository_link_id, resource_name, role_arn, sync_type)
    create_sync_configuration(branch, config_file, repository_link_id, resource_name, role_arn, sync_type, params::Dict{String,<:Any})

Creates a sync configuration which allows Amazon Web Services to sync content from a Git
repository to update a specified Amazon Web Services resource. Parameters for the sync
configuration are determined by the sync type.

# Arguments
- `branch`: The branch in the repository from which changes will be synced.
- `config_file`: The file name of the configuration file that manages syncing between the
  connection and the repository. This configuration file is stored in the repository.
- `repository_link_id`: The ID of the repository link created for the connection. A
  repository link allows Git sync to monitor and sync changes to files in a specified Git
  repository.
- `resource_name`: The name of the Amazon Web Services resource (for example, a
  CloudFormation stack in the case of CFN_STACK_SYNC) that will be synchronized from the
  linked repository.
- `role_arn`: The ARN of the IAM role that grants permission for Amazon Web Services to use
  Git sync to update a given Amazon Web Services resource on your behalf.
- `sync_type`: The type of sync configuration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"PublishDeploymentStatus"`: Whether to enable or disable publishing of deployment status
  to source providers.
- `"TriggerResourceUpdateOn"`: When to trigger Git sync to begin the stack update.
"""
function create_sync_configuration(
    Branch,
    ConfigFile,
    RepositoryLinkId,
    ResourceName,
    RoleArn,
    SyncType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeconnections(
        "CreateSyncConfiguration",
        Dict{String,Any}(
            "Branch" => Branch,
            "ConfigFile" => ConfigFile,
            "RepositoryLinkId" => RepositoryLinkId,
            "ResourceName" => ResourceName,
            "RoleArn" => RoleArn,
            "SyncType" => SyncType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_sync_configuration(
    Branch,
    ConfigFile,
    RepositoryLinkId,
    ResourceName,
    RoleArn,
    SyncType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeconnections(
        "CreateSyncConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Branch" => Branch,
                    "ConfigFile" => ConfigFile,
                    "RepositoryLinkId" => RepositoryLinkId,
                    "ResourceName" => ResourceName,
                    "RoleArn" => RoleArn,
                    "SyncType" => SyncType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_connection(connection_arn)
    delete_connection(connection_arn, params::Dict{String,<:Any})

The connection to be deleted.

# Arguments
- `connection_arn`: The Amazon Resource Name (ARN) of the connection to be deleted.  The
  ARN is never reused if the connection is deleted.

"""
function delete_connection(
    ConnectionArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeconnections(
        "DeleteConnection",
        Dict{String,Any}("ConnectionArn" => ConnectionArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_connection(
    ConnectionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeconnections(
        "DeleteConnection",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ConnectionArn" => ConnectionArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_host(host_arn)
    delete_host(host_arn, params::Dict{String,<:Any})

The host to be deleted. Before you delete a host, all connections associated to the host
must be deleted.  A host cannot be deleted if it is in the VPC_CONFIG_INITIALIZING or
VPC_CONFIG_DELETING state.

# Arguments
- `host_arn`: The Amazon Resource Name (ARN) of the host to be deleted.

"""
function delete_host(HostArn; aws_config::AbstractAWSConfig=current_aws_config())
    return codeconnections(
        "DeleteHost",
        Dict{String,Any}("HostArn" => HostArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_host(
    HostArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeconnections(
        "DeleteHost",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("HostArn" => HostArn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_repository_link(repository_link_id)
    delete_repository_link(repository_link_id, params::Dict{String,<:Any})

Deletes the association between your connection and a specified external Git repository.

# Arguments
- `repository_link_id`: The ID of the repository link to be deleted.

"""
function delete_repository_link(
    RepositoryLinkId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeconnections(
        "DeleteRepositoryLink",
        Dict{String,Any}("RepositoryLinkId" => RepositoryLinkId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_repository_link(
    RepositoryLinkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeconnections(
        "DeleteRepositoryLink",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("RepositoryLinkId" => RepositoryLinkId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_sync_configuration(resource_name, sync_type)
    delete_sync_configuration(resource_name, sync_type, params::Dict{String,<:Any})

Deletes the sync configuration for a specified repository and connection.

# Arguments
- `resource_name`: The name of the Amazon Web Services resource associated with the sync
  configuration to be deleted.
- `sync_type`: The type of sync configuration to be deleted.

"""
function delete_sync_configuration(
    ResourceName, SyncType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeconnections(
        "DeleteSyncConfiguration",
        Dict{String,Any}("ResourceName" => ResourceName, "SyncType" => SyncType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_sync_configuration(
    ResourceName,
    SyncType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeconnections(
        "DeleteSyncConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceName" => ResourceName, "SyncType" => SyncType),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_connection(connection_arn)
    get_connection(connection_arn, params::Dict{String,<:Any})

Returns the connection ARN and details such as status, owner, and provider type.

# Arguments
- `connection_arn`: The Amazon Resource Name (ARN) of a connection.

"""
function get_connection(ConnectionArn; aws_config::AbstractAWSConfig=current_aws_config())
    return codeconnections(
        "GetConnection",
        Dict{String,Any}("ConnectionArn" => ConnectionArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_connection(
    ConnectionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeconnections(
        "GetConnection",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ConnectionArn" => ConnectionArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_host(host_arn)
    get_host(host_arn, params::Dict{String,<:Any})

Returns the host ARN and details such as status, provider type, endpoint, and, if
applicable, the VPC configuration.

# Arguments
- `host_arn`: The Amazon Resource Name (ARN) of the requested host.

"""
function get_host(HostArn; aws_config::AbstractAWSConfig=current_aws_config())
    return codeconnections(
        "GetHost",
        Dict{String,Any}("HostArn" => HostArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_host(
    HostArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeconnections(
        "GetHost",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("HostArn" => HostArn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_repository_link(repository_link_id)
    get_repository_link(repository_link_id, params::Dict{String,<:Any})

Returns details about a repository link. A repository link allows Git sync to monitor and
sync changes from files in a specified Git repository.

# Arguments
- `repository_link_id`: The ID of the repository link to get.

"""
function get_repository_link(
    RepositoryLinkId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeconnections(
        "GetRepositoryLink",
        Dict{String,Any}("RepositoryLinkId" => RepositoryLinkId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_repository_link(
    RepositoryLinkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeconnections(
        "GetRepositoryLink",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("RepositoryLinkId" => RepositoryLinkId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_repository_sync_status(branch, repository_link_id, sync_type)
    get_repository_sync_status(branch, repository_link_id, sync_type, params::Dict{String,<:Any})

Returns details about the sync status for a repository. A repository sync uses Git sync to
push and pull changes from your remote repository.

# Arguments
- `branch`: The branch of the repository link for the requested repository sync status.
- `repository_link_id`: The repository link ID for the requested repository sync status.
- `sync_type`: The sync type of the requested sync status.

"""
function get_repository_sync_status(
    Branch, RepositoryLinkId, SyncType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeconnections(
        "GetRepositorySyncStatus",
        Dict{String,Any}(
            "Branch" => Branch,
            "RepositoryLinkId" => RepositoryLinkId,
            "SyncType" => SyncType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_repository_sync_status(
    Branch,
    RepositoryLinkId,
    SyncType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeconnections(
        "GetRepositorySyncStatus",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Branch" => Branch,
                    "RepositoryLinkId" => RepositoryLinkId,
                    "SyncType" => SyncType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_resource_sync_status(resource_name, sync_type)
    get_resource_sync_status(resource_name, sync_type, params::Dict{String,<:Any})

Returns the status of the sync with the Git repository for a specific Amazon Web Services
resource.

# Arguments
- `resource_name`: The name of the Amazon Web Services resource for the sync status with
  the Git repository.
- `sync_type`: The sync type for the sync status with the Git repository.

"""
function get_resource_sync_status(
    ResourceName, SyncType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeconnections(
        "GetResourceSyncStatus",
        Dict{String,Any}("ResourceName" => ResourceName, "SyncType" => SyncType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_resource_sync_status(
    ResourceName,
    SyncType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeconnections(
        "GetResourceSyncStatus",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceName" => ResourceName, "SyncType" => SyncType),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_sync_blocker_summary(resource_name, sync_type)
    get_sync_blocker_summary(resource_name, sync_type, params::Dict{String,<:Any})

Returns a list of the most recent sync blockers.

# Arguments
- `resource_name`: The name of the Amazon Web Services resource currently blocked from
  automatically being synced from a Git repository.
- `sync_type`: The sync type for the sync blocker summary.

"""
function get_sync_blocker_summary(
    ResourceName, SyncType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeconnections(
        "GetSyncBlockerSummary",
        Dict{String,Any}("ResourceName" => ResourceName, "SyncType" => SyncType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_sync_blocker_summary(
    ResourceName,
    SyncType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeconnections(
        "GetSyncBlockerSummary",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceName" => ResourceName, "SyncType" => SyncType),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_sync_configuration(resource_name, sync_type)
    get_sync_configuration(resource_name, sync_type, params::Dict{String,<:Any})

Returns details about a sync configuration, including the sync type and resource name. A
sync configuration allows the configuration to sync (push and pull) changes from the remote
repository for a specified branch in a Git repository.

# Arguments
- `resource_name`: The name of the Amazon Web Services resource for the sync configuration
  for which you want to retrieve information.
- `sync_type`: The sync type for the sync configuration for which you want to retrieve
  information.

"""
function get_sync_configuration(
    ResourceName, SyncType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeconnections(
        "GetSyncConfiguration",
        Dict{String,Any}("ResourceName" => ResourceName, "SyncType" => SyncType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_sync_configuration(
    ResourceName,
    SyncType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeconnections(
        "GetSyncConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceName" => ResourceName, "SyncType" => SyncType),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_connections()
    list_connections(params::Dict{String,<:Any})

Lists the connections associated with your account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"HostArnFilter"`: Filters the list of connections to those associated with a specified
  host.
- `"MaxResults"`: The maximum number of results to return in a single call. To retrieve the
  remaining results, make another call with the returned nextToken value.
- `"NextToken"`: The token that was returned from the previous ListConnections call, which
  can be used to return the next set of connections in the list.
- `"ProviderTypeFilter"`: Filters the list of connections to those associated with a
  specified provider, such as Bitbucket.
"""
function list_connections(; aws_config::AbstractAWSConfig=current_aws_config())
    return codeconnections(
        "ListConnections"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_connections(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeconnections(
        "ListConnections", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_hosts()
    list_hosts(params::Dict{String,<:Any})

Lists the hosts associated with your account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to return in a single call. To retrieve the
  remaining results, make another call with the returned nextToken value.
- `"NextToken"`: The token that was returned from the previous ListHosts call, which can be
  used to return the next set of hosts in the list.
"""
function list_hosts(; aws_config::AbstractAWSConfig=current_aws_config())
    return codeconnections(
        "ListHosts"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_hosts(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeconnections(
        "ListHosts", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_repository_links()
    list_repository_links(params::Dict{String,<:Any})

Lists the repository links created for connections in your account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`:  A non-zero, non-negative integer used to limit the number of returned
  results.
- `"NextToken"`:  An enumeration token that, when provided in a request, returns the next
  batch of the results.
"""
function list_repository_links(; aws_config::AbstractAWSConfig=current_aws_config())
    return codeconnections(
        "ListRepositoryLinks"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_repository_links(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeconnections(
        "ListRepositoryLinks",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_repository_sync_definitions(repository_link_id, sync_type)
    list_repository_sync_definitions(repository_link_id, sync_type, params::Dict{String,<:Any})

Lists the repository sync definitions for repository links in your account.

# Arguments
- `repository_link_id`: The ID of the repository link for the sync definition for which you
  want to retrieve information.
- `sync_type`: The sync type of the repository link for the the sync definition for which
  you want to retrieve information.

"""
function list_repository_sync_definitions(
    RepositoryLinkId, SyncType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeconnections(
        "ListRepositorySyncDefinitions",
        Dict{String,Any}("RepositoryLinkId" => RepositoryLinkId, "SyncType" => SyncType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_repository_sync_definitions(
    RepositoryLinkId,
    SyncType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeconnections(
        "ListRepositorySyncDefinitions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "RepositoryLinkId" => RepositoryLinkId, "SyncType" => SyncType
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_sync_configurations(repository_link_id, sync_type)
    list_sync_configurations(repository_link_id, sync_type, params::Dict{String,<:Any})

Returns a list of sync configurations for a specified repository.

# Arguments
- `repository_link_id`: The ID of the repository link for the requested list of sync
  configurations.
- `sync_type`: The sync type for the requested list of sync configurations.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: A non-zero, non-negative integer used to limit the number of returned
  results.
- `"NextToken"`: An enumeration token that allows the operation to batch the results of the
  operation.
"""
function list_sync_configurations(
    RepositoryLinkId, SyncType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeconnections(
        "ListSyncConfigurations",
        Dict{String,Any}("RepositoryLinkId" => RepositoryLinkId, "SyncType" => SyncType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_sync_configurations(
    RepositoryLinkId,
    SyncType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeconnections(
        "ListSyncConfigurations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "RepositoryLinkId" => RepositoryLinkId, "SyncType" => SyncType
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Gets the set of key-value pairs (metadata) that are used to manage the resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource for which you want to get
  information about tags, if any.

"""
function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeconnections(
        "ListTagsForResource",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeconnections(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds to or modifies the tags of the given resource. Tags are metadata that can be used to
manage a resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource to which you want to add
  or update tags.
- `tags`: The tags you want to modify or add to the resource.

"""
function tag_resource(ResourceArn, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return codeconnections(
        "TagResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceArn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeconnections(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes tags from an Amazon Web Services resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource to remove tags from.
- `tag_keys`: The list of keys for the tags to be removed from the resource.

"""
function untag_resource(
    ResourceArn, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeconnections(
        "UntagResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceArn,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeconnections(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_host(host_arn)
    update_host(host_arn, params::Dict{String,<:Any})

Updates a specified host with the provided configurations.

# Arguments
- `host_arn`: The Amazon Resource Name (ARN) of the host to be updated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ProviderEndpoint"`: The URL or endpoint of the host to be updated.
- `"VpcConfiguration"`: The VPC configuration of the host to be updated. A VPC must be
  configured and the infrastructure to be represented by the host must already be connected
  to the VPC.
"""
function update_host(HostArn; aws_config::AbstractAWSConfig=current_aws_config())
    return codeconnections(
        "UpdateHost",
        Dict{String,Any}("HostArn" => HostArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_host(
    HostArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeconnections(
        "UpdateHost",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("HostArn" => HostArn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_repository_link(repository_link_id)
    update_repository_link(repository_link_id, params::Dict{String,<:Any})

Updates the association between your connection and a specified external Git repository. A
repository link allows Git sync to monitor and sync changes to files in a specified Git
repository.

# Arguments
- `repository_link_id`: The ID of the repository link to be updated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConnectionArn"`: The Amazon Resource Name (ARN) of the connection for the repository
  link to be updated. The updated connection ARN must have the same providerType (such as
  GitHub) as the original connection ARN for the repo link.
- `"EncryptionKeyArn"`: The Amazon Resource Name (ARN) of the encryption key for the
  repository link to be updated.
"""
function update_repository_link(
    RepositoryLinkId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeconnections(
        "UpdateRepositoryLink",
        Dict{String,Any}("RepositoryLinkId" => RepositoryLinkId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_repository_link(
    RepositoryLinkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeconnections(
        "UpdateRepositoryLink",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("RepositoryLinkId" => RepositoryLinkId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_sync_blocker(id, resolved_reason, resource_name, sync_type)
    update_sync_blocker(id, resolved_reason, resource_name, sync_type, params::Dict{String,<:Any})

Allows you to update the status of a sync blocker, resolving the blocker and allowing
syncing to continue.

# Arguments
- `id`: The ID of the sync blocker to be updated.
- `resolved_reason`: The reason for resolving the sync blocker.
- `resource_name`: The name of the resource for the sync blocker to be updated.
- `sync_type`: The sync type of the sync blocker to be updated.

"""
function update_sync_blocker(
    Id,
    ResolvedReason,
    ResourceName,
    SyncType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeconnections(
        "UpdateSyncBlocker",
        Dict{String,Any}(
            "Id" => Id,
            "ResolvedReason" => ResolvedReason,
            "ResourceName" => ResourceName,
            "SyncType" => SyncType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_sync_blocker(
    Id,
    ResolvedReason,
    ResourceName,
    SyncType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeconnections(
        "UpdateSyncBlocker",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Id" => Id,
                    "ResolvedReason" => ResolvedReason,
                    "ResourceName" => ResourceName,
                    "SyncType" => SyncType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_sync_configuration(resource_name, sync_type)
    update_sync_configuration(resource_name, sync_type, params::Dict{String,<:Any})

Updates the sync configuration for your connection and a specified external Git repository.

# Arguments
- `resource_name`: The name of the Amazon Web Services resource for the sync configuration
  to be updated.
- `sync_type`: The sync type for the sync configuration to be updated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Branch"`: The branch for the sync configuration to be updated.
- `"ConfigFile"`: The configuration file for the sync configuration to be updated.
- `"PublishDeploymentStatus"`: Whether to enable or disable publishing of deployment status
  to source providers.
- `"RepositoryLinkId"`: The ID of the repository link for the sync configuration to be
  updated.
- `"RoleArn"`: The ARN of the IAM role for the sync configuration to be updated.
- `"TriggerResourceUpdateOn"`: When to trigger Git sync to begin the stack update.
"""
function update_sync_configuration(
    ResourceName, SyncType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeconnections(
        "UpdateSyncConfiguration",
        Dict{String,Any}("ResourceName" => ResourceName, "SyncType" => SyncType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_sync_configuration(
    ResourceName,
    SyncType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeconnections(
        "UpdateSyncConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceName" => ResourceName, "SyncType" => SyncType),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: resource_groups_tagging_api
using AWS.Compat
using AWS.UUIDs

"""
    describe_report_creation()
    describe_report_creation(params::Dict{String,<:Any})

Describes the status of the StartReportCreation operation.  You can call this operation
only from the organization's management account and from the us-east-1 Region.

"""
function describe_report_creation(; aws_config::AbstractAWSConfig=current_aws_config())
    return resource_groups_tagging_api(
        "DescribeReportCreation"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_report_creation(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resource_groups_tagging_api(
        "DescribeReportCreation",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_compliance_summary()
    get_compliance_summary(params::Dict{String,<:Any})

Returns a table that shows counts of resources that are noncompliant with their tag
policies. For more information on tag policies, see Tag Policies in the Organizations User
Guide.  You can call this operation only from the organization's management account and
from the us-east-1 Region. This operation supports pagination, where the response can be
sent in multiple pages. You should check the PaginationToken response parameter to
determine if there are additional results available to return. Repeat the query, passing
the PaginationToken response parameter value as an input to the next request until you
recieve a null value. A null value for PaginationToken indicates that there are no more
results waiting to be returned.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"GroupBy"`: Specifies a list of attributes to group the counts of noncompliant resources
  by. If supplied, the counts are sorted by those attributes.
- `"MaxResults"`: Specifies the maximum number of results to be returned in each page. A
  query can return fewer than this maximum, even if there are more results still to return.
  You should always check the PaginationToken response value to see if there are more
  results. You can specify a minimum of 1 and a maximum value of 100.
- `"PaginationToken"`: Specifies a PaginationToken response value from a previous request
  to indicate that you want the next page of results. Leave this parameter empty in your
  initial request.
- `"RegionFilters"`: Specifies a list of Amazon Web Services Regions to limit the output
  to. If you use this parameter, the count of returned noncompliant resources includes only
  resources in the specified Regions.
- `"ResourceTypeFilters"`: Specifies that you want the response to include information for
  only resources of the specified types. The format of each resource type is
  service[:resourceType]. For example, specifying a resource type of ec2 returns all Amazon
  EC2 resources (which includes EC2 instances). Specifying a resource type of ec2:instance
  returns only EC2 instances. The string for each service name and resource type is the same
  as that embedded in a resource's Amazon Resource Name (ARN). Consult the  Amazon Web
  Services General Reference  for the following:   For a list of service name strings, see
  Amazon Web Services Service Namespaces.   For resource type strings, see Example ARNs.
  For more information about ARNs, see Amazon Resource Names (ARNs) and Amazon Web Services
  Service Namespaces.   You can specify multiple resource types by using a comma separated
  array. The array can include up to 100 items. Note that the length constraint requirement
  applies to each resource type filter.
- `"TagKeyFilters"`: Specifies that you want the response to include information for only
  resources that have tags with the specified tag keys. If you use this parameter, the count
  of returned noncompliant resources includes only resources that have the specified tag keys.
- `"TargetIdFilters"`: Specifies target identifiers (usually, specific account IDs) to
  limit the output by. If you use this parameter, the count of returned noncompliant
  resources includes only resources with the specified target IDs.
"""
function get_compliance_summary(; aws_config::AbstractAWSConfig=current_aws_config())
    return resource_groups_tagging_api(
        "GetComplianceSummary"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_compliance_summary(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resource_groups_tagging_api(
        "GetComplianceSummary",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_resources()
    get_resources(params::Dict{String,<:Any})

Returns all the tagged or previously tagged resources that are located in the specified
Amazon Web Services Region for the account. Depending on what information you want
returned, you can also specify the following:    Filters that specify what tags and
resource types you want returned. The response includes all tags that are associated with
the requested resources.   Information about compliance with the account's effective tag
policy. For more information on tag policies, see Tag Policies in the Organizations User
Guide.    This operation supports pagination, where the response can be sent in multiple
pages. You should check the PaginationToken response parameter to determine if there are
additional results available to return. Repeat the query, passing the PaginationToken
response parameter value as an input to the next request until you recieve a null value. A
null value for PaginationToken indicates that there are no more results waiting to be
returned.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ExcludeCompliantResources"`: Specifies whether to exclude resources that are compliant
  with the tag policy. Set this to true if you are interested in retrieving information on
  noncompliant resources only. You can use this parameter only if the
  IncludeComplianceDetails parameter is also set to true.
- `"IncludeComplianceDetails"`: Specifies whether to include details regarding the
  compliance with the effective tag policy. Set this to true to determine whether resources
  are compliant with the tag policy and to get details.
- `"PaginationToken"`: Specifies a PaginationToken response value from a previous request
  to indicate that you want the next page of results. Leave this parameter empty in your
  initial request.
- `"ResourceARNList"`: Specifies a list of ARNs of resources for which you want to retrieve
  tag data. You can't specify both this parameter and any of the pagination parameters
  (ResourcesPerPage, TagsPerPage, PaginationToken) in the same request. If you specify both,
  you get an Invalid Parameter exception. If a resource specified by this parameter doesn't
  exist, it doesn't generate an error; it simply isn't included in the response. An ARN
  (Amazon Resource Name) uniquely identifies a resource. For more information, see Amazon
  Resource Names (ARNs) and Amazon Web Services Service Namespaces in the Amazon Web Services
  General Reference.
- `"ResourceTypeFilters"`: Specifies the resource types that you want included in the
  response. The format of each resource type is service[:resourceType]. For example,
  specifying a resource type of ec2 returns all Amazon EC2 resources (which includes EC2
  instances). Specifying a resource type of ec2:instance returns only EC2 instances.  The
  string for each service name and resource type is the same as that embedded in a resource's
  Amazon Resource Name (ARN). For the list of services whose resources you can use in this
  parameter, see Services that support the Resource Groups Tagging API. You can specify
  multiple resource types by using an array. The array can include up to 100 items. Note that
  the length constraint requirement applies to each resource type filter. For example, the
  following string would limit the response to only Amazon EC2 instances, Amazon S3 buckets,
  or any Audit Manager resource:  ec2:instance,s3:bucket,auditmanager
- `"ResourcesPerPage"`: Specifies the maximum number of results to be returned in each
  page. A query can return fewer than this maximum, even if there are more results still to
  return. You should always check the PaginationToken response value to see if there are more
  results. You can specify a minimum of 1 and a maximum value of 100.
- `"TagFilters"`: Specifies a list of TagFilters (keys and values) to restrict the output
  to only those resources that have tags with the specified keys and, if included, the
  specified values. Each TagFilter must contain a key with values optional. A request can
  include up to 50 keys, and each key can include up to 20 values.  Note the following when
  deciding how to use TagFilters:   If you don't specify a TagFilter, the response includes
  all resources that are currently tagged or ever had a tag. Resources that currently don't
  have tags are shown with an empty tag set, like this: \"Tags\": [].   If you specify more
  than one filter in a single request, the response returns only those resources that satisfy
  all filters.   If you specify a filter that contains more than one value for a key, the
  response returns resources that match any of the specified values for that key.   If you
  don't specify a value for a key, the response returns all resources that are tagged with
  that key, with any or no value. For example, for the following filters: filter1=
  {keyA,{value1}}, filter2={keyB,{value2,value3,value4}}, filter3= {keyC}:
  GetResources({filter1}) returns resources tagged with key1=value1
  GetResources({filter2}) returns resources tagged with key2=value2 or key2=value3 or
  key2=value4     GetResources({filter3}) returns resources tagged with any tag with the key
  key3, and with any or no value    GetResources({filter1,filter2,filter3}) returns resources
  tagged with (key1=value1) and (key2=value2 or key2=value3 or key2=value4) and (key3, any or
  no value)
- `"TagsPerPage"`: Amazon Web Services recommends using ResourcesPerPage instead of this
  parameter. A limit that restricts the number of tags (key and value pairs) returned by
  GetResources in paginated output. A resource with no tags is counted as having one tag (one
  key and value pair).  GetResources does not split a resource and its associated tags across
  pages. If the specified TagsPerPage would cause such a break, a PaginationToken is returned
  in place of the affected resource and its tags. Use that token in another request to get
  the remaining data. For example, if you specify a TagsPerPage of 100 and the account has 22
  resources with 10 tags each (meaning that each resource has 10 key and value pairs), the
  output will consist of three pages. The first page displays the first 10 resources, each
  with its 10 tags. The second page displays the next 10 resources, each with its 10 tags.
  The third page displays the remaining 2 resources, each with its 10 tags. You can set
  TagsPerPage to a minimum of 100 items up to a maximum of 500 items.
"""
function get_resources(; aws_config::AbstractAWSConfig=current_aws_config())
    return resource_groups_tagging_api(
        "GetResources"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_resources(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resource_groups_tagging_api(
        "GetResources", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_tag_keys()
    get_tag_keys(params::Dict{String,<:Any})

Returns all tag keys currently in use in the specified Amazon Web Services Region for the
calling account. This operation supports pagination, where the response can be sent in
multiple pages. You should check the PaginationToken response parameter to determine if
there are additional results available to return. Repeat the query, passing the
PaginationToken response parameter value as an input to the next request until you recieve
a null value. A null value for PaginationToken indicates that there are no more results
waiting to be returned.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"PaginationToken"`: Specifies a PaginationToken response value from a previous request
  to indicate that you want the next page of results. Leave this parameter empty in your
  initial request.
"""
function get_tag_keys(; aws_config::AbstractAWSConfig=current_aws_config())
    return resource_groups_tagging_api(
        "GetTagKeys"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_tag_keys(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resource_groups_tagging_api(
        "GetTagKeys", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_tag_values(key)
    get_tag_values(key, params::Dict{String,<:Any})

Returns all tag values for the specified key that are used in the specified Amazon Web
Services Region for the calling account. This operation supports pagination, where the
response can be sent in multiple pages. You should check the PaginationToken response
parameter to determine if there are additional results available to return. Repeat the
query, passing the PaginationToken response parameter value as an input to the next request
until you recieve a null value. A null value for PaginationToken indicates that there are
no more results waiting to be returned.

# Arguments
- `key`: Specifies the tag key for which you want to list all existing values that are
  currently used in the specified Amazon Web Services Region for the calling account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"PaginationToken"`: Specifies a PaginationToken response value from a previous request
  to indicate that you want the next page of results. Leave this parameter empty in your
  initial request.
"""
function get_tag_values(Key; aws_config::AbstractAWSConfig=current_aws_config())
    return resource_groups_tagging_api(
        "GetTagValues",
        Dict{String,Any}("Key" => Key);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_tag_values(
    Key, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resource_groups_tagging_api(
        "GetTagValues",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Key" => Key), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_report_creation(s3_bucket)
    start_report_creation(s3_bucket, params::Dict{String,<:Any})

Generates a report that lists all tagged resources in the accounts across your organization
and tells whether each resource is compliant with the effective tag policy. Compliance data
is refreshed daily. The report is generated asynchronously. The generated report is saved
to the following location:
s3://example-bucket/AwsTagPolicies/o-exampleorgid/YYYY-MM-ddTHH:mm:ssZ/report.csv  You can
call this operation only from the organization's management account and from the us-east-1
Region.

# Arguments
- `s3_bucket`: The name of the Amazon S3 bucket where the report will be stored; for
  example:  awsexamplebucket  For more information on S3 bucket requirements, including an
  example bucket policy, see the example S3 bucket policy on this page.

"""
function start_report_creation(S3Bucket; aws_config::AbstractAWSConfig=current_aws_config())
    return resource_groups_tagging_api(
        "StartReportCreation",
        Dict{String,Any}("S3Bucket" => S3Bucket);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_report_creation(
    S3Bucket,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return resource_groups_tagging_api(
        "StartReportCreation",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("S3Bucket" => S3Bucket), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resources(resource_arnlist, tags)
    tag_resources(resource_arnlist, tags, params::Dict{String,<:Any})

Applies one or more tags to the specified resources. Note the following:   Not all
resources can have tags. For a list of services with resources that support tagging using
this operation, see Services that support the Resource Groups Tagging API. If the resource
doesn't yet support this operation, the resource's service might support tagging using its
own API operations. For more information, refer to the documentation for that service.
Each resource can have up to 50 tags. For other limits, see Tag Naming and Usage
Conventions in the Amazon Web Services General Reference.    You can only tag resources
that are located in the specified Amazon Web Services Region for the Amazon Web Services
account.   To add tags to a resource, you need the necessary permissions for the service
that the resource belongs to as well as permissions for adding tags. For more information,
see the documentation for each service.    Do not store personally identifiable information
(PII) or other confidential or sensitive information in tags. We use tags to provide you
with billing and administration services. Tags are not intended to be used for private or
sensitive data.   Minimum permissions  In addition to the tag:TagResources permission
required by this operation, you must also have the tagging permission defined by the
service that created the resource. For example, to tag an Amazon EC2 instance using the
TagResources operation, you must have both of the following permissions:    tag:TagResource
    ec2:CreateTags

# Arguments
- `resource_arnlist`: Specifies the list of ARNs of the resources that you want to apply
  tags to. An ARN (Amazon Resource Name) uniquely identifies a resource. For more
  information, see Amazon Resource Names (ARNs) and Amazon Web Services Service Namespaces in
  the Amazon Web Services General Reference.
- `tags`: Specifies a list of tags that you want to add to the specified resources. A tag
  consists of a key and a value that you define.

"""
function tag_resources(
    ResourceARNList, Tags; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resource_groups_tagging_api(
        "TagResources",
        Dict{String,Any}("ResourceARNList" => ResourceARNList, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resources(
    ResourceARNList,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return resource_groups_tagging_api(
        "TagResources",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARNList" => ResourceARNList, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resources(resource_arnlist, tag_keys)
    untag_resources(resource_arnlist, tag_keys, params::Dict{String,<:Any})

Removes the specified tags from the specified resources. When you specify a tag key, the
action removes both that key and its associated value. The operation succeeds even if you
attempt to remove tags from a resource that were already removed. Note the following:   To
remove tags from a resource, you need the necessary permissions for the service that the
resource belongs to as well as permissions for removing tags. For more information, see the
documentation for the service whose resource you want to untag.   You can only tag
resources that are located in the specified Amazon Web Services Region for the calling
Amazon Web Services account.    Minimum permissions  In addition to the tag:UntagResources
permission required by this operation, you must also have the remove tags permission
defined by the service that created the resource. For example, to remove the tags from an
Amazon EC2 instance using the UntagResources operation, you must have both of the following
permissions:    tag:UntagResource     ec2:DeleteTags

# Arguments
- `resource_arnlist`: Specifies a list of ARNs of the resources that you want to remove
  tags from. An ARN (Amazon Resource Name) uniquely identifies a resource. For more
  information, see Amazon Resource Names (ARNs) and Amazon Web Services Service Namespaces in
  the Amazon Web Services General Reference.
- `tag_keys`: Specifies a list of tag keys that you want to remove from the specified
  resources.

"""
function untag_resources(
    ResourceARNList, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return resource_groups_tagging_api(
        "UntagResources",
        Dict{String,Any}("ResourceARNList" => ResourceARNList, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resources(
    ResourceARNList,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return resource_groups_tagging_api(
        "UntagResources",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ResourceARNList" => ResourceARNList, "TagKeys" => TagKeys
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: auto_scaling
using AWS.Compat
using AWS.UUIDs

"""
    attach_instances(auto_scaling_group_name)
    attach_instances(auto_scaling_group_name, params::Dict{String,<:Any})

Attaches one or more EC2 instances to the specified Auto Scaling group. When you attach
instances, Amazon EC2 Auto Scaling increases the desired capacity of the group by the
number of instances being attached. If the number of instances being attached plus the
desired capacity of the group exceeds the maximum size of the group, the operation fails.
If there is a Classic Load Balancer attached to your Auto Scaling group, the instances are
also registered with the load balancer. If there are target groups attached to your Auto
Scaling group, the instances are also registered with the target groups. For more
information, see Detach or attach instances in the Amazon EC2 Auto Scaling User Guide.

# Arguments
- `auto_scaling_group_name`: The name of the Auto Scaling group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"InstanceIds"`: The IDs of the instances. You can specify up to 20 instances.
"""
function attach_instances(
    AutoScalingGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auto_scaling(
        "AttachInstances",
        Dict{String,Any}("AutoScalingGroupName" => AutoScalingGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function attach_instances(
    AutoScalingGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "AttachInstances",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("AutoScalingGroupName" => AutoScalingGroupName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    attach_load_balancer_target_groups(auto_scaling_group_name, target_group_arns)
    attach_load_balancer_target_groups(auto_scaling_group_name, target_group_arns, params::Dict{String,<:Any})

 This API operation is superseded by AttachTrafficSources, which can attach multiple
traffic sources types. We recommend using AttachTrafficSources to simplify how you manage
traffic sources. However, we continue to support AttachLoadBalancerTargetGroups. You can
use both the original AttachLoadBalancerTargetGroups API operation and AttachTrafficSources
on the same Auto Scaling group.  Attaches one or more target groups to the specified Auto
Scaling group. This operation is used with the following load balancer types:
Application Load Balancer - Operates at the application layer (layer 7) and supports HTTP
and HTTPS.    Network Load Balancer - Operates at the transport layer (layer 4) and
supports TCP, TLS, and UDP.    Gateway Load Balancer - Operates at the network layer (layer
3).   To describe the target groups for an Auto Scaling group, call the
DescribeLoadBalancerTargetGroups API. To detach the target group from the Auto Scaling
group, call the DetachLoadBalancerTargetGroups API. This operation is additive and does not
detach existing target groups or Classic Load Balancers from the Auto Scaling group. For
more information, see Use Elastic Load Balancing to distribute traffic across the instances
in your Auto Scaling group in the Amazon EC2 Auto Scaling User Guide.

# Arguments
- `auto_scaling_group_name`: The name of the Auto Scaling group.
- `target_group_arns`: The Amazon Resource Names (ARNs) of the target groups. You can
  specify up to 10 target groups. To get the ARN of a target group, use the Elastic Load
  Balancing DescribeTargetGroups API operation.

"""
function attach_load_balancer_target_groups(
    AutoScalingGroupName,
    TargetGroupARNs;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "AttachLoadBalancerTargetGroups",
        Dict{String,Any}(
            "AutoScalingGroupName" => AutoScalingGroupName,
            "TargetGroupARNs" => TargetGroupARNs,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function attach_load_balancer_target_groups(
    AutoScalingGroupName,
    TargetGroupARNs,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "AttachLoadBalancerTargetGroups",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AutoScalingGroupName" => AutoScalingGroupName,
                    "TargetGroupARNs" => TargetGroupARNs,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    attach_load_balancers(auto_scaling_group_name, load_balancer_names)
    attach_load_balancers(auto_scaling_group_name, load_balancer_names, params::Dict{String,<:Any})

 This API operation is superseded by AttachTrafficSources, which can attach multiple
traffic sources types. We recommend using AttachTrafficSources to simplify how you manage
traffic sources. However, we continue to support AttachLoadBalancers. You can use both the
original AttachLoadBalancers API operation and AttachTrafficSources on the same Auto
Scaling group.  Attaches one or more Classic Load Balancers to the specified Auto Scaling
group. Amazon EC2 Auto Scaling registers the running instances with these Classic Load
Balancers. To describe the load balancers for an Auto Scaling group, call the
DescribeLoadBalancers API. To detach a load balancer from the Auto Scaling group, call the
DetachLoadBalancers API. This operation is additive and does not detach existing Classic
Load Balancers or target groups from the Auto Scaling group. For more information, see Use
Elastic Load Balancing to distribute traffic across the instances in your Auto Scaling
group in the Amazon EC2 Auto Scaling User Guide.

# Arguments
- `auto_scaling_group_name`: The name of the Auto Scaling group.
- `load_balancer_names`: The names of the load balancers. You can specify up to 10 load
  balancers.

"""
function attach_load_balancers(
    AutoScalingGroupName,
    LoadBalancerNames;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "AttachLoadBalancers",
        Dict{String,Any}(
            "AutoScalingGroupName" => AutoScalingGroupName,
            "LoadBalancerNames" => LoadBalancerNames,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function attach_load_balancers(
    AutoScalingGroupName,
    LoadBalancerNames,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "AttachLoadBalancers",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AutoScalingGroupName" => AutoScalingGroupName,
                    "LoadBalancerNames" => LoadBalancerNames,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    attach_traffic_sources(auto_scaling_group_name, traffic_sources)
    attach_traffic_sources(auto_scaling_group_name, traffic_sources, params::Dict{String,<:Any})

Attaches one or more traffic sources to the specified Auto Scaling group. You can use any
of the following as traffic sources for an Auto Scaling group:   Application Load Balancer
 Classic Load Balancer   Gateway Load Balancer   Network Load Balancer   VPC Lattice   This
operation is additive and does not detach existing traffic sources from the Auto Scaling
group.  After the operation completes, use the DescribeTrafficSources API to return details
about the state of the attachments between traffic sources and your Auto Scaling group. To
detach a traffic source from the Auto Scaling group, call the DetachTrafficSources API.

# Arguments
- `auto_scaling_group_name`: The name of the Auto Scaling group.
- `traffic_sources`: The unique identifiers of one or more traffic sources. You can specify
  up to 10 traffic sources.

"""
function attach_traffic_sources(
    AutoScalingGroupName, TrafficSources; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auto_scaling(
        "AttachTrafficSources",
        Dict{String,Any}(
            "AutoScalingGroupName" => AutoScalingGroupName,
            "TrafficSources" => TrafficSources,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function attach_traffic_sources(
    AutoScalingGroupName,
    TrafficSources,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "AttachTrafficSources",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AutoScalingGroupName" => AutoScalingGroupName,
                    "TrafficSources" => TrafficSources,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_delete_scheduled_action(auto_scaling_group_name, scheduled_action_names)
    batch_delete_scheduled_action(auto_scaling_group_name, scheduled_action_names, params::Dict{String,<:Any})

Deletes one or more scheduled actions for the specified Auto Scaling group.

# Arguments
- `auto_scaling_group_name`: The name of the Auto Scaling group.
- `scheduled_action_names`: The names of the scheduled actions to delete. The maximum
  number allowed is 50.

"""
function batch_delete_scheduled_action(
    AutoScalingGroupName,
    ScheduledActionNames;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "BatchDeleteScheduledAction",
        Dict{String,Any}(
            "AutoScalingGroupName" => AutoScalingGroupName,
            "ScheduledActionNames" => ScheduledActionNames,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_delete_scheduled_action(
    AutoScalingGroupName,
    ScheduledActionNames,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "BatchDeleteScheduledAction",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AutoScalingGroupName" => AutoScalingGroupName,
                    "ScheduledActionNames" => ScheduledActionNames,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_put_scheduled_update_group_action(auto_scaling_group_name, scheduled_update_group_actions)
    batch_put_scheduled_update_group_action(auto_scaling_group_name, scheduled_update_group_actions, params::Dict{String,<:Any})

Creates or updates one or more scheduled scaling actions for an Auto Scaling group.

# Arguments
- `auto_scaling_group_name`: The name of the Auto Scaling group.
- `scheduled_update_group_actions`: One or more scheduled actions. The maximum number
  allowed is 50.

"""
function batch_put_scheduled_update_group_action(
    AutoScalingGroupName,
    ScheduledUpdateGroupActions;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "BatchPutScheduledUpdateGroupAction",
        Dict{String,Any}(
            "AutoScalingGroupName" => AutoScalingGroupName,
            "ScheduledUpdateGroupActions" => ScheduledUpdateGroupActions,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_put_scheduled_update_group_action(
    AutoScalingGroupName,
    ScheduledUpdateGroupActions,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "BatchPutScheduledUpdateGroupAction",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AutoScalingGroupName" => AutoScalingGroupName,
                    "ScheduledUpdateGroupActions" => ScheduledUpdateGroupActions,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_instance_refresh(auto_scaling_group_name)
    cancel_instance_refresh(auto_scaling_group_name, params::Dict{String,<:Any})

Cancels an instance refresh or rollback that is in progress. If an instance refresh or
rollback is not in progress, an ActiveInstanceRefreshNotFound error occurs. This operation
is part of the instance refresh feature in Amazon EC2 Auto Scaling, which helps you update
instances in your Auto Scaling group after you make configuration changes. When you cancel
an instance refresh, this does not roll back any changes that it made. Use the
RollbackInstanceRefresh API to roll back instead.

# Arguments
- `auto_scaling_group_name`: The name of the Auto Scaling group.

"""
function cancel_instance_refresh(
    AutoScalingGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auto_scaling(
        "CancelInstanceRefresh",
        Dict{String,Any}("AutoScalingGroupName" => AutoScalingGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_instance_refresh(
    AutoScalingGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "CancelInstanceRefresh",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("AutoScalingGroupName" => AutoScalingGroupName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    complete_lifecycle_action(auto_scaling_group_name, lifecycle_action_result, lifecycle_hook_name)
    complete_lifecycle_action(auto_scaling_group_name, lifecycle_action_result, lifecycle_hook_name, params::Dict{String,<:Any})

Completes the lifecycle action for the specified token or instance with the specified
result. This step is a part of the procedure for adding a lifecycle hook to an Auto Scaling
group:   (Optional) Create a launch template or launch configuration with a user data
script that runs while an instance is in a wait state due to a lifecycle hook.   (Optional)
Create a Lambda function and a rule that allows Amazon EventBridge to invoke your Lambda
function when an instance is put into a wait state due to a lifecycle hook.   (Optional)
Create a notification target and an IAM role. The target can be either an Amazon SQS queue
or an Amazon SNS topic. The role allows Amazon EC2 Auto Scaling to publish lifecycle
notifications to the target.   Create the lifecycle hook. Specify whether the hook is used
when the instances launch or terminate.   If you need more time, record the lifecycle
action heartbeat to keep the instance in a wait state.    If you finish before the timeout
period ends, send a callback by using the CompleteLifecycleAction API call.    For more
information, see Complete a lifecycle action in the Amazon EC2 Auto Scaling User Guide.

# Arguments
- `auto_scaling_group_name`: The name of the Auto Scaling group.
- `lifecycle_action_result`: The action for the group to take. You can specify either
  CONTINUE or ABANDON.
- `lifecycle_hook_name`: The name of the lifecycle hook.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"InstanceId"`: The ID of the instance.
- `"LifecycleActionToken"`: A universally unique identifier (UUID) that identifies a
  specific lifecycle action associated with an instance. Amazon EC2 Auto Scaling sends this
  token to the notification target you specified when you created the lifecycle hook.
"""
function complete_lifecycle_action(
    AutoScalingGroupName,
    LifecycleActionResult,
    LifecycleHookName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "CompleteLifecycleAction",
        Dict{String,Any}(
            "AutoScalingGroupName" => AutoScalingGroupName,
            "LifecycleActionResult" => LifecycleActionResult,
            "LifecycleHookName" => LifecycleHookName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function complete_lifecycle_action(
    AutoScalingGroupName,
    LifecycleActionResult,
    LifecycleHookName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "CompleteLifecycleAction",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AutoScalingGroupName" => AutoScalingGroupName,
                    "LifecycleActionResult" => LifecycleActionResult,
                    "LifecycleHookName" => LifecycleHookName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_auto_scaling_group(auto_scaling_group_name, max_size, min_size)
    create_auto_scaling_group(auto_scaling_group_name, max_size, min_size, params::Dict{String,<:Any})

 We strongly recommend using a launch template when calling this operation to ensure full
functionality for Amazon EC2 Auto Scaling and Amazon EC2.  Creates an Auto Scaling group
with the specified name and attributes.  If you exceed your maximum limit of Auto Scaling
groups, the call fails. To query this limit, call the DescribeAccountLimits API. For
information about updating this limit, see Quotas for Amazon EC2 Auto Scaling in the Amazon
EC2 Auto Scaling User Guide. If you're new to Amazon EC2 Auto Scaling, see the introductory
tutorials in Get started with Amazon EC2 Auto Scaling in the Amazon EC2 Auto Scaling User
Guide. Every Auto Scaling group has three size properties (DesiredCapacity, MaxSize, and
MinSize). Usually, you set these sizes based on a specific number of instances. However, if
you configure a mixed instances policy that defines weights for the instance types, you
must specify these sizes with the same units that you use for weighting instances.

# Arguments
- `auto_scaling_group_name`: The name of the Auto Scaling group. This name must be unique
  per Region per account. The name can contain any ASCII character 33 to 126 including most
  punctuation characters, digits, and upper and lowercased letters.  You cannot use a colon
  (:) in the name.
- `max_size`: The maximum size of the group.  With a mixed instances policy that uses
  instance weighting, Amazon EC2 Auto Scaling may need to go above MaxSize to meet your
  capacity requirements. In this event, Amazon EC2 Auto Scaling will never go above MaxSize
  by more than your largest instance weight (weights that define how many units each instance
  contributes to the desired capacity of the group).
- `min_size`: The minimum size of the group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AvailabilityZones"`: A list of Availability Zones where instances in the Auto Scaling
  group can be created. Used for launching into the default VPC subnet in each Availability
  Zone when not using the VPCZoneIdentifier property, or for attaching a network interface
  when an existing network interface ID is specified in a launch template.
- `"CapacityRebalance"`: Indicates whether Capacity Rebalancing is enabled. Otherwise,
  Capacity Rebalancing is disabled. When you turn on Capacity Rebalancing, Amazon EC2 Auto
  Scaling attempts to launch a Spot Instance whenever Amazon EC2 notifies that a Spot
  Instance is at an elevated risk of interruption. After launching a new instance, it then
  terminates an old instance. For more information, see Use Capacity Rebalancing to handle
  Amazon EC2 Spot Interruptions in the in the Amazon EC2 Auto Scaling User Guide.
- `"Context"`: Reserved.
- `"DefaultCooldown"`:  Only needed if you use simple scaling policies.  The amount of
  time, in seconds, between one scaling activity ending and another one starting due to
  simple scaling policies. For more information, see Scaling cooldowns for Amazon EC2 Auto
  Scaling in the Amazon EC2 Auto Scaling User Guide. Default: 300 seconds
- `"DefaultInstanceWarmup"`: The amount of time, in seconds, until a new instance is
  considered to have finished initializing and resource consumption to become stable after it
  enters the InService state.  During an instance refresh, Amazon EC2 Auto Scaling waits for
  the warm-up period after it replaces an instance before it moves on to replacing the next
  instance. Amazon EC2 Auto Scaling also waits for the warm-up period before aggregating the
  metrics for new instances with existing instances in the Amazon CloudWatch metrics that are
  used for scaling, resulting in more reliable usage data. For more information, see Set the
  default instance warmup for an Auto Scaling group in the Amazon EC2 Auto Scaling User
  Guide.  To manage various warm-up settings at the group level, we recommend that you set
  the default instance warmup, even if it is set to 0 seconds. To remove a value that you
  previously set, include the property but specify -1 for the value. However, we strongly
  recommend keeping the default instance warmup enabled by specifying a value of 0 or other
  nominal value.  Default: None
- `"DesiredCapacity"`: The desired capacity is the initial capacity of the Auto Scaling
  group at the time of its creation and the capacity it attempts to maintain. It can scale
  beyond this capacity if you configure auto scaling. This number must be greater than or
  equal to the minimum size of the group and less than or equal to the maximum size of the
  group. If you do not specify a desired capacity, the default is the minimum size of the
  group.
- `"DesiredCapacityType"`: The unit of measurement for the value specified for desired
  capacity. Amazon EC2 Auto Scaling supports DesiredCapacityType for attribute-based instance
  type selection only. For more information, see Create a mixed instances group using
  attribute-based instance type selection in the Amazon EC2 Auto Scaling User Guide. By
  default, Amazon EC2 Auto Scaling specifies units, which translates into number of
  instances. Valid values: units | vcpu | memory-mib
- `"HealthCheckGracePeriod"`: The amount of time, in seconds, that Amazon EC2 Auto Scaling
  waits before checking the health status of an EC2 instance that has come into service and
  marking it unhealthy due to a failed health check. This is useful if your instances do not
  immediately pass their health checks after they enter the InService state. For more
  information, see Set the health check grace period for an Auto Scaling group in the Amazon
  EC2 Auto Scaling User Guide. Default: 0 seconds
- `"HealthCheckType"`: A comma-separated value string of one or more health check types.
  The valid values are EC2, ELB, and VPC_LATTICE. EC2 is the default health check and cannot
  be disabled. For more information, see Health checks for instances in an Auto Scaling group
  in the Amazon EC2 Auto Scaling User Guide. Only specify EC2 if you must clear a value that
  was previously set.
- `"InstanceId"`: The ID of the instance used to base the launch configuration on. If
  specified, Amazon EC2 Auto Scaling uses the configuration values from the specified
  instance to create a new launch configuration. To get the instance ID, use the Amazon EC2
  DescribeInstances API operation. For more information, see Create an Auto Scaling group
  using parameters from an existing instance in the Amazon EC2 Auto Scaling User Guide.
- `"InstanceMaintenancePolicy"`: An instance maintenance policy. For more information, see
  Set instance maintenance policy in the Amazon EC2 Auto Scaling User Guide.
- `"LaunchConfigurationName"`: The name of the launch configuration to use to launch
  instances.  Conditional: You must specify either a launch template (LaunchTemplate or
  MixedInstancesPolicy) or a launch configuration (LaunchConfigurationName or InstanceId).
- `"LaunchTemplate"`: Information used to specify the launch template and version to use to
  launch instances.  Conditional: You must specify either a launch template (LaunchTemplate
  or MixedInstancesPolicy) or a launch configuration (LaunchConfigurationName or InstanceId).
   The launch template that is specified must be configured for use with an Auto Scaling
  group. For more information, see Create a launch template for an Auto Scaling group in the
  Amazon EC2 Auto Scaling User Guide.
- `"LifecycleHookSpecificationList"`: One or more lifecycle hooks to add to the Auto
  Scaling group before instances are launched.
- `"LoadBalancerNames"`: A list of Classic Load Balancers associated with this Auto Scaling
  group. For Application Load Balancers, Network Load Balancers, and Gateway Load Balancers,
  specify the TargetGroupARNs property instead.
- `"MaxInstanceLifetime"`: The maximum amount of time, in seconds, that an instance can be
  in service. The default is null. If specified, the value must be either 0 or a number equal
  to or greater than 86,400 seconds (1 day). For more information, see Replace Auto Scaling
  instances based on maximum instance lifetime in the Amazon EC2 Auto Scaling User Guide.
- `"MixedInstancesPolicy"`: The mixed instances policy. For more information, see Auto
  Scaling groups with multiple instance types and purchase options in the Amazon EC2 Auto
  Scaling User Guide.
- `"NewInstancesProtectedFromScaleIn"`: Indicates whether newly launched instances are
  protected from termination by Amazon EC2 Auto Scaling when scaling in. For more information
  about preventing instances from terminating on scale in, see Use instance scale-in
  protection in the Amazon EC2 Auto Scaling User Guide.
- `"PlacementGroup"`: The name of the placement group into which to launch your instances.
  For more information, see Placement groups in the Amazon EC2 User Guide for Linux
  Instances.  A cluster placement group is a logical grouping of instances within a single
  Availability Zone. You cannot specify multiple Availability Zones and a cluster placement
  group.
- `"ServiceLinkedRoleARN"`: The Amazon Resource Name (ARN) of the service-linked role that
  the Auto Scaling group uses to call other Amazon Web Services service on your behalf. By
  default, Amazon EC2 Auto Scaling uses a service-linked role named
  AWSServiceRoleForAutoScaling, which it creates if it does not exist. For more information,
  see Service-linked roles in the Amazon EC2 Auto Scaling User Guide.
- `"Tags"`: One or more tags. You can tag your Auto Scaling group and propagate the tags to
  the Amazon EC2 instances it launches. Tags are not propagated to Amazon EBS volumes. To add
  tags to Amazon EBS volumes, specify the tags in a launch template but use caution. If the
  launch template specifies an instance tag with a key that is also specified for the Auto
  Scaling group, Amazon EC2 Auto Scaling overrides the value of that instance tag with the
  value specified by the Auto Scaling group. For more information, see Tag Auto Scaling
  groups and instances in the Amazon EC2 Auto Scaling User Guide.
- `"TargetGroupARNs"`: The Amazon Resource Names (ARN) of the Elastic Load Balancing target
  groups to associate with the Auto Scaling group. Instances are registered as targets with
  the target groups. The target groups receive incoming traffic and route requests to one or
  more registered targets. For more information, see Use Elastic Load Balancing to distribute
  traffic across the instances in your Auto Scaling group in the Amazon EC2 Auto Scaling User
  Guide.
- `"TerminationPolicies"`: A policy or a list of policies that are used to select the
  instance to terminate. These policies are executed in the order that you list them. For
  more information, see Configure termination policies for Amazon EC2 Auto Scaling in the
  Amazon EC2 Auto Scaling User Guide. Valid values: Default | AllocationStrategy |
  ClosestToNextInstanceHour | NewestInstance | OldestInstance | OldestLaunchConfiguration |
  OldestLaunchTemplate | arn:aws:lambda:region:account-id:function:my-function:my-alias
- `"TrafficSources"`: The list of traffic sources to attach to this Auto Scaling group. You
  can use any of the following as traffic sources for an Auto Scaling group: Classic Load
  Balancer, Application Load Balancer, Gateway Load Balancer, Network Load Balancer, and VPC
  Lattice.
- `"VPCZoneIdentifier"`: A comma-separated list of subnet IDs for a virtual private cloud
  (VPC) where instances in the Auto Scaling group can be created. If you specify
  VPCZoneIdentifier with AvailabilityZones, the subnets that you specify must reside in those
  Availability Zones.
"""
function create_auto_scaling_group(
    AutoScalingGroupName,
    MaxSize,
    MinSize;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "CreateAutoScalingGroup",
        Dict{String,Any}(
            "AutoScalingGroupName" => AutoScalingGroupName,
            "MaxSize" => MaxSize,
            "MinSize" => MinSize,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_auto_scaling_group(
    AutoScalingGroupName,
    MaxSize,
    MinSize,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "CreateAutoScalingGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AutoScalingGroupName" => AutoScalingGroupName,
                    "MaxSize" => MaxSize,
                    "MinSize" => MinSize,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_launch_configuration(launch_configuration_name)
    create_launch_configuration(launch_configuration_name, params::Dict{String,<:Any})

Creates a launch configuration. If you exceed your maximum limit of launch configurations,
the call fails. To query this limit, call the DescribeAccountLimits API. For information
about updating this limit, see Quotas for Amazon EC2 Auto Scaling in the Amazon EC2 Auto
Scaling User Guide. For more information, see Launch configurations in the Amazon EC2 Auto
Scaling User Guide.  Amazon EC2 Auto Scaling configures instances launched as part of an
Auto Scaling group using either a launch template or a launch configuration. We strongly
recommend that you do not use launch configurations. They do not provide full functionality
for Amazon EC2 Auto Scaling or Amazon EC2. For information about using launch templates,
see Launch templates in the Amazon EC2 Auto Scaling User Guide.

# Arguments
- `launch_configuration_name`: The name of the launch configuration. This name must be
  unique per Region per account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AssociatePublicIpAddress"`: Specifies whether to assign a public IPv4 address to the
  group's instances. If the instance is launched into a default subnet, the default is to
  assign a public IPv4 address, unless you disabled the option to assign a public IPv4
  address on the subnet. If the instance is launched into a nondefault subnet, the default is
  not to assign a public IPv4 address, unless you enabled the option to assign a public IPv4
  address on the subnet. If you specify true, each instance in the Auto Scaling group
  receives a unique public IPv4 address. For more information, see Provide network
  connectivity for your Auto Scaling instances using Amazon VPC in the Amazon EC2 Auto
  Scaling User Guide. If you specify this property, you must specify at least one subnet for
  VPCZoneIdentifier when you create your group.
- `"BlockDeviceMappings"`: The block device mapping entries that define the block devices
  to attach to the instances at launch. By default, the block devices specified in the block
  device mapping for the AMI are used. For more information, see Block device mappings in the
  Amazon EC2 User Guide for Linux Instances.
- `"ClassicLinkVPCId"`: Available for backward compatibility.
- `"ClassicLinkVPCSecurityGroups"`: Available for backward compatibility.
- `"EbsOptimized"`: Specifies whether the launch configuration is optimized for EBS I/O
  (true) or not (false). The optimization provides dedicated throughput to Amazon EBS and an
  optimized configuration stack to provide optimal I/O performance. This optimization is not
  available with all instance types. Additional fees are incurred when you enable EBS
  optimization for an instance type that is not EBS-optimized by default. For more
  information, see Amazon EBS-optimized instances in the Amazon EC2 User Guide for Linux
  Instances. The default value is false.
- `"IamInstanceProfile"`: The name or the Amazon Resource Name (ARN) of the instance
  profile associated with the IAM role for the instance. The instance profile contains the
  IAM role. For more information, see IAM role for applications that run on Amazon EC2
  instances in the Amazon EC2 Auto Scaling User Guide.
- `"ImageId"`: The ID of the Amazon Machine Image (AMI) that was assigned during
  registration. For more information, see Find a Linux AMI in the Amazon EC2 User Guide for
  Linux Instances. If you specify InstanceId, an ImageId is not required.
- `"InstanceId"`: The ID of the instance to use to create the launch configuration. The new
  launch configuration derives attributes from the instance, except for the block device
  mapping. To create a launch configuration with a block device mapping or override any other
  instance attributes, specify them as part of the same request. For more information, see
  Create a launch configuration in the Amazon EC2 Auto Scaling User Guide.
- `"InstanceMonitoring"`: Controls whether instances in this group are launched with
  detailed (true) or basic (false) monitoring. The default value is true (enabled).  When
  detailed monitoring is enabled, Amazon CloudWatch generates metrics every minute and your
  account is charged a fee. When you disable detailed monitoring, CloudWatch generates
  metrics every 5 minutes. For more information, see Configure monitoring for Auto Scaling
  instances in the Amazon EC2 Auto Scaling User Guide.
- `"InstanceType"`: Specifies the instance type of the EC2 instance. For information about
  available instance types, see Available instance types in the Amazon EC2 User Guide for
  Linux Instances. If you specify InstanceId, an InstanceType is not required.
- `"KernelId"`: The ID of the kernel associated with the AMI.  We recommend that you use
  PV-GRUB instead of kernels and RAM disks. For more information, see User provided kernels
  in the Amazon EC2 User Guide for Linux Instances.
- `"KeyName"`: The name of the key pair. For more information, see Amazon EC2 key pairs and
  Amazon EC2 instances in the Amazon EC2 User Guide for Linux Instances.
- `"MetadataOptions"`: The metadata options for the instances. For more information, see
  Configure the instance metadata options in the Amazon EC2 Auto Scaling User Guide.
- `"PlacementTenancy"`: The tenancy of the instance, either default or dedicated. An
  instance with dedicated tenancy runs on isolated, single-tenant hardware and can only be
  launched into a VPC. To launch dedicated instances into a shared tenancy VPC (a VPC with
  the instance placement tenancy attribute set to default), you must set the value of this
  property to dedicated. If you specify PlacementTenancy, you must specify at least one
  subnet for VPCZoneIdentifier when you create your group. Valid values: default | dedicated
- `"RamdiskId"`: The ID of the RAM disk to select.  We recommend that you use PV-GRUB
  instead of kernels and RAM disks. For more information, see User provided kernels in the
  Amazon EC2 User Guide for Linux Instances.
- `"SecurityGroups"`: A list that contains the security group IDs to assign to the
  instances in the Auto Scaling group. For more information, see Control traffic to your
  Amazon Web Services resources using security groups in the Amazon Virtual Private Cloud
  User Guide.
- `"SpotPrice"`: The maximum hourly price to be paid for any Spot Instance launched to
  fulfill the request. Spot Instances are launched when the price you specify exceeds the
  current Spot price. For more information, see Request Spot Instances for fault-tolerant and
  flexible applications in the Amazon EC2 Auto Scaling User Guide. Valid Range: Minimum value
  of 0.001  When you change your maximum price by creating a new launch configuration,
  running instances will continue to run as long as the maximum price for those running
  instances is higher than the current Spot price.
- `"UserData"`: The user data to make available to the launched EC2 instances. For more
  information, see Instance metadata and user data (Linux) and Instance metadata and user
  data (Windows). If you are using a command line tool, base64-encoding is performed for you,
  and you can load the text from a file. Otherwise, you must provide base64-encoded text.
  User data is limited to 16 KB.
"""
function create_launch_configuration(
    LaunchConfigurationName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auto_scaling(
        "CreateLaunchConfiguration",
        Dict{String,Any}("LaunchConfigurationName" => LaunchConfigurationName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_launch_configuration(
    LaunchConfigurationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "CreateLaunchConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("LaunchConfigurationName" => LaunchConfigurationName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_or_update_tags(tags)
    create_or_update_tags(tags, params::Dict{String,<:Any})

Creates or updates tags for the specified Auto Scaling group. When you specify a tag with a
key that already exists, the operation overwrites the previous tag definition, and you do
not get an error message. For more information, see Tag Auto Scaling groups and instances
in the Amazon EC2 Auto Scaling User Guide.

# Arguments
- `tags`: One or more tags.

"""
function create_or_update_tags(Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return auto_scaling(
        "CreateOrUpdateTags",
        Dict{String,Any}("Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_or_update_tags(
    Tags, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auto_scaling(
        "CreateOrUpdateTags",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Tags" => Tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_auto_scaling_group(auto_scaling_group_name)
    delete_auto_scaling_group(auto_scaling_group_name, params::Dict{String,<:Any})

Deletes the specified Auto Scaling group. If the group has instances or scaling activities
in progress, you must specify the option to force the deletion in order for it to succeed.
The force delete operation will also terminate the EC2 instances. If the group has a warm
pool, the force delete option also deletes the warm pool. To remove instances from the Auto
Scaling group before deleting it, call the DetachInstances API with the list of instances
and the option to decrement the desired capacity. This ensures that Amazon EC2 Auto Scaling
does not launch replacement instances. To terminate all instances before deleting the Auto
Scaling group, call the UpdateAutoScalingGroup API and set the minimum size and desired
capacity of the Auto Scaling group to zero. If the group has scaling policies, deleting the
group deletes the policies, the underlying alarm actions, and any alarm that no longer has
an associated action. For more information, see Delete your Auto Scaling infrastructure in
the Amazon EC2 Auto Scaling User Guide.

# Arguments
- `auto_scaling_group_name`: The name of the Auto Scaling group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ForceDelete"`: Specifies that the group is to be deleted along with all instances
  associated with the group, without waiting for all instances to be terminated. This action
  also deletes any outstanding lifecycle actions associated with the group.
"""
function delete_auto_scaling_group(
    AutoScalingGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auto_scaling(
        "DeleteAutoScalingGroup",
        Dict{String,Any}("AutoScalingGroupName" => AutoScalingGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_auto_scaling_group(
    AutoScalingGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "DeleteAutoScalingGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("AutoScalingGroupName" => AutoScalingGroupName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_launch_configuration(launch_configuration_name)
    delete_launch_configuration(launch_configuration_name, params::Dict{String,<:Any})

Deletes the specified launch configuration. The launch configuration must not be attached
to an Auto Scaling group. When this call completes, the launch configuration is no longer
available for use.

# Arguments
- `launch_configuration_name`: The name of the launch configuration.

"""
function delete_launch_configuration(
    LaunchConfigurationName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auto_scaling(
        "DeleteLaunchConfiguration",
        Dict{String,Any}("LaunchConfigurationName" => LaunchConfigurationName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_launch_configuration(
    LaunchConfigurationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "DeleteLaunchConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("LaunchConfigurationName" => LaunchConfigurationName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_lifecycle_hook(auto_scaling_group_name, lifecycle_hook_name)
    delete_lifecycle_hook(auto_scaling_group_name, lifecycle_hook_name, params::Dict{String,<:Any})

Deletes the specified lifecycle hook. If there are any outstanding lifecycle actions, they
are completed first (ABANDON for launching instances, CONTINUE for terminating instances).

# Arguments
- `auto_scaling_group_name`: The name of the Auto Scaling group.
- `lifecycle_hook_name`: The name of the lifecycle hook.

"""
function delete_lifecycle_hook(
    AutoScalingGroupName,
    LifecycleHookName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "DeleteLifecycleHook",
        Dict{String,Any}(
            "AutoScalingGroupName" => AutoScalingGroupName,
            "LifecycleHookName" => LifecycleHookName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_lifecycle_hook(
    AutoScalingGroupName,
    LifecycleHookName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "DeleteLifecycleHook",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AutoScalingGroupName" => AutoScalingGroupName,
                    "LifecycleHookName" => LifecycleHookName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_notification_configuration(auto_scaling_group_name, topic_arn)
    delete_notification_configuration(auto_scaling_group_name, topic_arn, params::Dict{String,<:Any})

Deletes the specified notification.

# Arguments
- `auto_scaling_group_name`: The name of the Auto Scaling group.
- `topic_arn`: The Amazon Resource Name (ARN) of the Amazon SNS topic.

"""
function delete_notification_configuration(
    AutoScalingGroupName, TopicARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auto_scaling(
        "DeleteNotificationConfiguration",
        Dict{String,Any}(
            "AutoScalingGroupName" => AutoScalingGroupName, "TopicARN" => TopicARN
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_notification_configuration(
    AutoScalingGroupName,
    TopicARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "DeleteNotificationConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AutoScalingGroupName" => AutoScalingGroupName, "TopicARN" => TopicARN
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_policy(policy_name)
    delete_policy(policy_name, params::Dict{String,<:Any})

Deletes the specified scaling policy. Deleting either a step scaling policy or a simple
scaling policy deletes the underlying alarm action, but does not delete the alarm, even if
it no longer has an associated action. For more information, see Delete a scaling policy in
the Amazon EC2 Auto Scaling User Guide.

# Arguments
- `policy_name`: The name or Amazon Resource Name (ARN) of the policy.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AutoScalingGroupName"`: The name of the Auto Scaling group.
"""
function delete_policy(PolicyName; aws_config::AbstractAWSConfig=current_aws_config())
    return auto_scaling(
        "DeletePolicy",
        Dict{String,Any}("PolicyName" => PolicyName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_policy(
    PolicyName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "DeletePolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("PolicyName" => PolicyName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_scheduled_action(auto_scaling_group_name, scheduled_action_name)
    delete_scheduled_action(auto_scaling_group_name, scheduled_action_name, params::Dict{String,<:Any})

Deletes the specified scheduled action.

# Arguments
- `auto_scaling_group_name`: The name of the Auto Scaling group.
- `scheduled_action_name`: The name of the action to delete.

"""
function delete_scheduled_action(
    AutoScalingGroupName,
    ScheduledActionName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "DeleteScheduledAction",
        Dict{String,Any}(
            "AutoScalingGroupName" => AutoScalingGroupName,
            "ScheduledActionName" => ScheduledActionName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_scheduled_action(
    AutoScalingGroupName,
    ScheduledActionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "DeleteScheduledAction",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AutoScalingGroupName" => AutoScalingGroupName,
                    "ScheduledActionName" => ScheduledActionName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_tags(tags)
    delete_tags(tags, params::Dict{String,<:Any})

Deletes the specified tags.

# Arguments
- `tags`: One or more tags.

"""
function delete_tags(Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return auto_scaling(
        "DeleteTags",
        Dict{String,Any}("Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_tags(
    Tags, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auto_scaling(
        "DeleteTags",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Tags" => Tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_warm_pool(auto_scaling_group_name)
    delete_warm_pool(auto_scaling_group_name, params::Dict{String,<:Any})

Deletes the warm pool for the specified Auto Scaling group. For more information, see Warm
pools for Amazon EC2 Auto Scaling in the Amazon EC2 Auto Scaling User Guide.

# Arguments
- `auto_scaling_group_name`: The name of the Auto Scaling group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ForceDelete"`: Specifies that the warm pool is to be deleted along with all of its
  associated instances, without waiting for all instances to be terminated. This parameter
  also deletes any outstanding lifecycle actions associated with the warm pool instances.
"""
function delete_warm_pool(
    AutoScalingGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auto_scaling(
        "DeleteWarmPool",
        Dict{String,Any}("AutoScalingGroupName" => AutoScalingGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_warm_pool(
    AutoScalingGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "DeleteWarmPool",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("AutoScalingGroupName" => AutoScalingGroupName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_account_limits()
    describe_account_limits(params::Dict{String,<:Any})

Describes the current Amazon EC2 Auto Scaling resource quotas for your account. When you
establish an Amazon Web Services account, the account has initial quotas on the maximum
number of Auto Scaling groups and launch configurations that you can create in a given
Region. For more information, see Quotas for Amazon EC2 Auto Scaling in the Amazon EC2 Auto
Scaling User Guide.

"""
function describe_account_limits(; aws_config::AbstractAWSConfig=current_aws_config())
    return auto_scaling(
        "DescribeAccountLimits"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_account_limits(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auto_scaling(
        "DescribeAccountLimits",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_adjustment_types()
    describe_adjustment_types(params::Dict{String,<:Any})

Describes the available adjustment types for step scaling and simple scaling policies. The
following adjustment types are supported:    ChangeInCapacity     ExactCapacity
PercentChangeInCapacity

"""
function describe_adjustment_types(; aws_config::AbstractAWSConfig=current_aws_config())
    return auto_scaling(
        "DescribeAdjustmentTypes"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_adjustment_types(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auto_scaling(
        "DescribeAdjustmentTypes",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_auto_scaling_groups()
    describe_auto_scaling_groups(params::Dict{String,<:Any})

Gets information about the Auto Scaling groups in the account and Region. If you specify
Auto Scaling group names, the output includes information for only the specified Auto
Scaling groups. If you specify filters, the output includes information for only those Auto
Scaling groups that meet the filter criteria. If you do not specify group names or filters,
the output includes information for all Auto Scaling groups.  This operation also returns
information about instances in Auto Scaling groups. To retrieve information about the
instances in a warm pool, you must call the DescribeWarmPool API.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AutoScalingGroupNames"`: The names of the Auto Scaling groups. By default, you can only
  specify up to 50 names. You can optionally increase this limit using the MaxRecords
  property. If you omit this property, all Auto Scaling groups are described.
- `"Filters"`: One or more filters to limit the results based on specific tags.
- `"MaxRecords"`: The maximum number of items to return with this call. The default value
  is 50 and the maximum value is 100.
- `"NextToken"`: The token for the next set of items to return. (You received this token
  from a previous call.)
"""
function describe_auto_scaling_groups(; aws_config::AbstractAWSConfig=current_aws_config())
    return auto_scaling(
        "DescribeAutoScalingGroups"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_auto_scaling_groups(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auto_scaling(
        "DescribeAutoScalingGroups",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_auto_scaling_instances()
    describe_auto_scaling_instances(params::Dict{String,<:Any})

Gets information about the Auto Scaling instances in the account and Region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"InstanceIds"`: The IDs of the instances. If you omit this property, all Auto Scaling
  instances are described. If you specify an ID that does not exist, it is ignored with no
  error. Array Members: Maximum number of 50 items.
- `"MaxRecords"`: The maximum number of items to return with this call. The default value
  is 50 and the maximum value is 50.
- `"NextToken"`: The token for the next set of items to return. (You received this token
  from a previous call.)
"""
function describe_auto_scaling_instances(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return auto_scaling(
        "DescribeAutoScalingInstances";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_auto_scaling_instances(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auto_scaling(
        "DescribeAutoScalingInstances",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_auto_scaling_notification_types()
    describe_auto_scaling_notification_types(params::Dict{String,<:Any})

Describes the notification types that are supported by Amazon EC2 Auto Scaling.

"""
function describe_auto_scaling_notification_types(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return auto_scaling(
        "DescribeAutoScalingNotificationTypes";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_auto_scaling_notification_types(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auto_scaling(
        "DescribeAutoScalingNotificationTypes",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_instance_refreshes(auto_scaling_group_name)
    describe_instance_refreshes(auto_scaling_group_name, params::Dict{String,<:Any})

Gets information about the instance refreshes for the specified Auto Scaling group from the
previous six weeks. This operation is part of the instance refresh feature in Amazon EC2
Auto Scaling, which helps you update instances in your Auto Scaling group after you make
configuration changes. To help you determine the status of an instance refresh, Amazon EC2
Auto Scaling returns information about the instance refreshes you previously initiated,
including their status, start time, end time, the percentage of the instance refresh that
is complete, and the number of instances remaining to update before the instance refresh is
complete. If a rollback is initiated while an instance refresh is in progress, Amazon EC2
Auto Scaling also returns information about the rollback of the instance refresh.

# Arguments
- `auto_scaling_group_name`: The name of the Auto Scaling group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"InstanceRefreshIds"`: One or more instance refresh IDs.
- `"MaxRecords"`: The maximum number of items to return with this call. The default value
  is 50 and the maximum value is 100.
- `"NextToken"`: The token for the next set of items to return. (You received this token
  from a previous call.)
"""
function describe_instance_refreshes(
    AutoScalingGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auto_scaling(
        "DescribeInstanceRefreshes",
        Dict{String,Any}("AutoScalingGroupName" => AutoScalingGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_instance_refreshes(
    AutoScalingGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "DescribeInstanceRefreshes",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("AutoScalingGroupName" => AutoScalingGroupName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_launch_configurations()
    describe_launch_configurations(params::Dict{String,<:Any})

Gets information about the launch configurations in the account and Region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"LaunchConfigurationNames"`: The launch configuration names. If you omit this property,
  all launch configurations are described. Array Members: Maximum number of 50 items.
- `"MaxRecords"`: The maximum number of items to return with this call. The default value
  is 50 and the maximum value is 100.
- `"NextToken"`: The token for the next set of items to return. (You received this token
  from a previous call.)
"""
function describe_launch_configurations(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return auto_scaling(
        "DescribeLaunchConfigurations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_launch_configurations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auto_scaling(
        "DescribeLaunchConfigurations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_lifecycle_hook_types()
    describe_lifecycle_hook_types(params::Dict{String,<:Any})

Describes the available types of lifecycle hooks. The following hook types are supported:
 autoscaling:EC2_INSTANCE_LAUNCHING     autoscaling:EC2_INSTANCE_TERMINATING

"""
function describe_lifecycle_hook_types(; aws_config::AbstractAWSConfig=current_aws_config())
    return auto_scaling(
        "DescribeLifecycleHookTypes"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_lifecycle_hook_types(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auto_scaling(
        "DescribeLifecycleHookTypes",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_lifecycle_hooks(auto_scaling_group_name)
    describe_lifecycle_hooks(auto_scaling_group_name, params::Dict{String,<:Any})

Gets information about the lifecycle hooks for the specified Auto Scaling group.

# Arguments
- `auto_scaling_group_name`: The name of the Auto Scaling group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"LifecycleHookNames"`: The names of one or more lifecycle hooks. If you omit this
  property, all lifecycle hooks are described.
"""
function describe_lifecycle_hooks(
    AutoScalingGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auto_scaling(
        "DescribeLifecycleHooks",
        Dict{String,Any}("AutoScalingGroupName" => AutoScalingGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_lifecycle_hooks(
    AutoScalingGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "DescribeLifecycleHooks",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("AutoScalingGroupName" => AutoScalingGroupName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_load_balancer_target_groups(auto_scaling_group_name)
    describe_load_balancer_target_groups(auto_scaling_group_name, params::Dict{String,<:Any})

 This API operation is superseded by DescribeTrafficSources, which can describe multiple
traffic sources types. We recommend using DetachTrafficSources to simplify how you manage
traffic sources. However, we continue to support DescribeLoadBalancerTargetGroups. You can
use both the original DescribeLoadBalancerTargetGroups API operation and
DescribeTrafficSources on the same Auto Scaling group.  Gets information about the Elastic
Load Balancing target groups for the specified Auto Scaling group. To determine the
attachment status of the target group, use the State element in the response. When you
attach a target group to an Auto Scaling group, the initial State value is Adding. The
state transitions to Added after all Auto Scaling instances are registered with the target
group. If Elastic Load Balancing health checks are enabled for the Auto Scaling group, the
state transitions to InService after at least one Auto Scaling instance passes the health
check. When the target group is in the InService state, Amazon EC2 Auto Scaling can
terminate and replace any instances that are reported as unhealthy. If no registered
instances pass the health checks, the target group doesn't enter the InService state.
Target groups also have an InService state if you attach them in the CreateAutoScalingGroup
API call. If your target group state is InService, but it is not working properly, check
the scaling activities by calling DescribeScalingActivities and take any corrective actions
necessary. For help with failed health checks, see Troubleshooting Amazon EC2 Auto Scaling:
Health checks in the Amazon EC2 Auto Scaling User Guide. For more information, see Use
Elastic Load Balancing to distribute traffic across the instances in your Auto Scaling
group in the Amazon EC2 Auto Scaling User Guide.   You can use this operation to describe
target groups that were attached by using AttachLoadBalancerTargetGroups, but not for
target groups that were attached by using AttachTrafficSources.

# Arguments
- `auto_scaling_group_name`: The name of the Auto Scaling group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxRecords"`: The maximum number of items to return with this call. The default value
  is 100 and the maximum value is 100.
- `"NextToken"`: The token for the next set of items to return. (You received this token
  from a previous call.)
"""
function describe_load_balancer_target_groups(
    AutoScalingGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auto_scaling(
        "DescribeLoadBalancerTargetGroups",
        Dict{String,Any}("AutoScalingGroupName" => AutoScalingGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_load_balancer_target_groups(
    AutoScalingGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "DescribeLoadBalancerTargetGroups",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("AutoScalingGroupName" => AutoScalingGroupName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_load_balancers(auto_scaling_group_name)
    describe_load_balancers(auto_scaling_group_name, params::Dict{String,<:Any})

 This API operation is superseded by DescribeTrafficSources, which can describe multiple
traffic sources types. We recommend using DescribeTrafficSources to simplify how you manage
traffic sources. However, we continue to support DescribeLoadBalancers. You can use both
the original DescribeLoadBalancers API operation and DescribeTrafficSources on the same
Auto Scaling group.  Gets information about the load balancers for the specified Auto
Scaling group. This operation describes only Classic Load Balancers. If you have
Application Load Balancers, Network Load Balancers, or Gateway Load Balancers, use the
DescribeLoadBalancerTargetGroups API instead. To determine the attachment status of the
load balancer, use the State element in the response. When you attach a load balancer to an
Auto Scaling group, the initial State value is Adding. The state transitions to Added after
all Auto Scaling instances are registered with the load balancer. If Elastic Load Balancing
health checks are enabled for the Auto Scaling group, the state transitions to InService
after at least one Auto Scaling instance passes the health check. When the load balancer is
in the InService state, Amazon EC2 Auto Scaling can terminate and replace any instances
that are reported as unhealthy. If no registered instances pass the health checks, the load
balancer doesn't enter the InService state.  Load balancers also have an InService state if
you attach them in the CreateAutoScalingGroup API call. If your load balancer state is
InService, but it is not working properly, check the scaling activities by calling
DescribeScalingActivities and take any corrective actions necessary. For help with failed
health checks, see Troubleshooting Amazon EC2 Auto Scaling: Health checks in the Amazon EC2
Auto Scaling User Guide. For more information, see Use Elastic Load Balancing to distribute
traffic across the instances in your Auto Scaling group in the Amazon EC2 Auto Scaling User
Guide.

# Arguments
- `auto_scaling_group_name`: The name of the Auto Scaling group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxRecords"`: The maximum number of items to return with this call. The default value
  is 100 and the maximum value is 100.
- `"NextToken"`: The token for the next set of items to return. (You received this token
  from a previous call.)
"""
function describe_load_balancers(
    AutoScalingGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auto_scaling(
        "DescribeLoadBalancers",
        Dict{String,Any}("AutoScalingGroupName" => AutoScalingGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_load_balancers(
    AutoScalingGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "DescribeLoadBalancers",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("AutoScalingGroupName" => AutoScalingGroupName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_metric_collection_types()
    describe_metric_collection_types(params::Dict{String,<:Any})

Describes the available CloudWatch metrics for Amazon EC2 Auto Scaling.

"""
function describe_metric_collection_types(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return auto_scaling(
        "DescribeMetricCollectionTypes";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_metric_collection_types(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auto_scaling(
        "DescribeMetricCollectionTypes",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_notification_configurations()
    describe_notification_configurations(params::Dict{String,<:Any})

Gets information about the Amazon SNS notifications that are configured for one or more
Auto Scaling groups.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AutoScalingGroupNames"`: The name of the Auto Scaling group.
- `"MaxRecords"`: The maximum number of items to return with this call. The default value
  is 50 and the maximum value is 100.
- `"NextToken"`: The token for the next set of items to return. (You received this token
  from a previous call.)
"""
function describe_notification_configurations(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return auto_scaling(
        "DescribeNotificationConfigurations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_notification_configurations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auto_scaling(
        "DescribeNotificationConfigurations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_policies()
    describe_policies(params::Dict{String,<:Any})

Gets information about the scaling policies in the account and Region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AutoScalingGroupName"`: The name of the Auto Scaling group.
- `"MaxRecords"`: The maximum number of items to be returned with each call. The default
  value is 50 and the maximum value is 100.
- `"NextToken"`: The token for the next set of items to return. (You received this token
  from a previous call.)
- `"PolicyNames"`: The names of one or more policies. If you omit this property, all
  policies are described. If a group name is provided, the results are limited to that group.
  If you specify an unknown policy name, it is ignored with no error. Array Members: Maximum
  number of 50 items.
- `"PolicyTypes"`: One or more policy types. The valid values are SimpleScaling,
  StepScaling, TargetTrackingScaling, and PredictiveScaling.
"""
function describe_policies(; aws_config::AbstractAWSConfig=current_aws_config())
    return auto_scaling(
        "DescribePolicies"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_policies(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auto_scaling(
        "DescribePolicies", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_scaling_activities()
    describe_scaling_activities(params::Dict{String,<:Any})

Gets information about the scaling activities in the account and Region. When scaling
events occur, you see a record of the scaling activity in the scaling activities. For more
information, see Verify a scaling activity for an Auto Scaling group in the Amazon EC2 Auto
Scaling User Guide. If the scaling event succeeds, the value of the StatusCode element in
the response is Successful. If an attempt to launch instances failed, the StatusCode value
is Failed or Cancelled and the StatusMessage element in the response indicates the cause of
the failure. For help interpreting the StatusMessage, see Troubleshooting Amazon EC2 Auto
Scaling in the Amazon EC2 Auto Scaling User Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ActivityIds"`: The activity IDs of the desired scaling activities. If you omit this
  property, all activities for the past six weeks are described. If unknown activities are
  requested, they are ignored with no error. If you specify an Auto Scaling group, the
  results are limited to that group. Array Members: Maximum number of 50 IDs.
- `"AutoScalingGroupName"`: The name of the Auto Scaling group.
- `"IncludeDeletedGroups"`: Indicates whether to include scaling activity from deleted Auto
  Scaling groups.
- `"MaxRecords"`: The maximum number of items to return with this call. The default value
  is 100 and the maximum value is 100.
- `"NextToken"`: The token for the next set of items to return. (You received this token
  from a previous call.)
"""
function describe_scaling_activities(; aws_config::AbstractAWSConfig=current_aws_config())
    return auto_scaling(
        "DescribeScalingActivities"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_scaling_activities(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auto_scaling(
        "DescribeScalingActivities",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_scaling_process_types()
    describe_scaling_process_types(params::Dict{String,<:Any})

Describes the scaling process types for use with the ResumeProcesses and SuspendProcesses
APIs.

"""
function describe_scaling_process_types(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return auto_scaling(
        "DescribeScalingProcessTypes";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_scaling_process_types(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auto_scaling(
        "DescribeScalingProcessTypes",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_scheduled_actions()
    describe_scheduled_actions(params::Dict{String,<:Any})

Gets information about the scheduled actions that haven't run or that have not reached
their end time. To describe the scaling activities for scheduled actions that have already
run, call the DescribeScalingActivities API.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AutoScalingGroupName"`: The name of the Auto Scaling group.
- `"EndTime"`: The latest scheduled start time to return. If scheduled action names are
  provided, this property is ignored.
- `"MaxRecords"`: The maximum number of items to return with this call. The default value
  is 50 and the maximum value is 100.
- `"NextToken"`: The token for the next set of items to return. (You received this token
  from a previous call.)
- `"ScheduledActionNames"`: The names of one or more scheduled actions. If you omit this
  property, all scheduled actions are described. If you specify an unknown scheduled action,
  it is ignored with no error. Array Members: Maximum number of 50 actions.
- `"StartTime"`: The earliest scheduled start time to return. If scheduled action names are
  provided, this property is ignored.
"""
function describe_scheduled_actions(; aws_config::AbstractAWSConfig=current_aws_config())
    return auto_scaling(
        "DescribeScheduledActions"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_scheduled_actions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auto_scaling(
        "DescribeScheduledActions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_tags()
    describe_tags(params::Dict{String,<:Any})

Describes the specified tags. You can use filters to limit the results. For example, you
can query for the tags for a specific Auto Scaling group. You can specify multiple values
for a filter. A tag must match at least one of the specified values for it to be included
in the results. You can also specify multiple filters. The result includes information for
a particular tag only if it matches all the filters. If there's no match, no special
message is returned. For more information, see Tag Auto Scaling groups and instances in the
Amazon EC2 Auto Scaling User Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: One or more filters to scope the tags to return. The maximum number of
  filters per filter type (for example, auto-scaling-group) is 1000.
- `"MaxRecords"`: The maximum number of items to return with this call. The default value
  is 50 and the maximum value is 100.
- `"NextToken"`: The token for the next set of items to return. (You received this token
  from a previous call.)
"""
function describe_tags(; aws_config::AbstractAWSConfig=current_aws_config())
    return auto_scaling(
        "DescribeTags"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_tags(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auto_scaling(
        "DescribeTags", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_termination_policy_types()
    describe_termination_policy_types(params::Dict{String,<:Any})

Describes the termination policies supported by Amazon EC2 Auto Scaling. For more
information, see Configure termination policies for Amazon EC2 Auto Scaling in the Amazon
EC2 Auto Scaling User Guide.

"""
function describe_termination_policy_types(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return auto_scaling(
        "DescribeTerminationPolicyTypes";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_termination_policy_types(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auto_scaling(
        "DescribeTerminationPolicyTypes",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_traffic_sources(auto_scaling_group_name)
    describe_traffic_sources(auto_scaling_group_name, params::Dict{String,<:Any})

Gets information about the traffic sources for the specified Auto Scaling group. You can
optionally provide a traffic source type. If you provide a traffic source type, then the
results only include that traffic source type. If you do not provide a traffic source type,
then the results include all the traffic sources for the specified Auto Scaling group.

# Arguments
- `auto_scaling_group_name`: The name of the Auto Scaling group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxRecords"`: The maximum number of items to return with this call. The maximum value
  is 50.
- `"NextToken"`: The token for the next set of items to return. (You received this token
  from a previous call.)
- `"TrafficSourceType"`: The traffic source type that you want to describe. The following
  lists the valid values:    elb if the traffic source is a Classic Load Balancer.    elbv2
  if the traffic source is a Application Load Balancer, Gateway Load Balancer, or Network
  Load Balancer.    vpc-lattice if the traffic source is VPC Lattice.
"""
function describe_traffic_sources(
    AutoScalingGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auto_scaling(
        "DescribeTrafficSources",
        Dict{String,Any}("AutoScalingGroupName" => AutoScalingGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_traffic_sources(
    AutoScalingGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "DescribeTrafficSources",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("AutoScalingGroupName" => AutoScalingGroupName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_warm_pool(auto_scaling_group_name)
    describe_warm_pool(auto_scaling_group_name, params::Dict{String,<:Any})

Gets information about a warm pool and its instances. For more information, see Warm pools
for Amazon EC2 Auto Scaling in the Amazon EC2 Auto Scaling User Guide.

# Arguments
- `auto_scaling_group_name`: The name of the Auto Scaling group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxRecords"`: The maximum number of instances to return with this call. The maximum
  value is 50.
- `"NextToken"`: The token for the next set of instances to return. (You received this
  token from a previous call.)
"""
function describe_warm_pool(
    AutoScalingGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auto_scaling(
        "DescribeWarmPool",
        Dict{String,Any}("AutoScalingGroupName" => AutoScalingGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_warm_pool(
    AutoScalingGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "DescribeWarmPool",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("AutoScalingGroupName" => AutoScalingGroupName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    detach_instances(auto_scaling_group_name, should_decrement_desired_capacity)
    detach_instances(auto_scaling_group_name, should_decrement_desired_capacity, params::Dict{String,<:Any})

Removes one or more instances from the specified Auto Scaling group. After the instances
are detached, you can manage them independent of the Auto Scaling group. If you do not
specify the option to decrement the desired capacity, Amazon EC2 Auto Scaling launches
instances to replace the ones that are detached. If there is a Classic Load Balancer
attached to the Auto Scaling group, the instances are deregistered from the load balancer.
If there are target groups attached to the Auto Scaling group, the instances are
deregistered from the target groups. For more information, see Detach or attach instances
in the Amazon EC2 Auto Scaling User Guide.

# Arguments
- `auto_scaling_group_name`: The name of the Auto Scaling group.
- `should_decrement_desired_capacity`: Indicates whether the Auto Scaling group decrements
  the desired capacity value by the number of instances detached.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"InstanceIds"`: The IDs of the instances. You can specify up to 20 instances.
"""
function detach_instances(
    AutoScalingGroupName,
    ShouldDecrementDesiredCapacity;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "DetachInstances",
        Dict{String,Any}(
            "AutoScalingGroupName" => AutoScalingGroupName,
            "ShouldDecrementDesiredCapacity" => ShouldDecrementDesiredCapacity,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function detach_instances(
    AutoScalingGroupName,
    ShouldDecrementDesiredCapacity,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "DetachInstances",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AutoScalingGroupName" => AutoScalingGroupName,
                    "ShouldDecrementDesiredCapacity" => ShouldDecrementDesiredCapacity,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    detach_load_balancer_target_groups(auto_scaling_group_name, target_group_arns)
    detach_load_balancer_target_groups(auto_scaling_group_name, target_group_arns, params::Dict{String,<:Any})

 This API operation is superseded by DetachTrafficSources, which can detach multiple
traffic sources types. We recommend using DetachTrafficSources to simplify how you manage
traffic sources. However, we continue to support DetachLoadBalancerTargetGroups. You can
use both the original DetachLoadBalancerTargetGroups API operation and DetachTrafficSources
on the same Auto Scaling group.  Detaches one or more target groups from the specified Auto
Scaling group. When you detach a target group, it enters the Removing state while
deregistering the instances in the group. When all instances are deregistered, then you can
no longer describe the target group using the DescribeLoadBalancerTargetGroups API call.
The instances remain running.  You can use this operation to detach target groups that were
attached by using AttachLoadBalancerTargetGroups, but not for target groups that were
attached by using AttachTrafficSources.

# Arguments
- `auto_scaling_group_name`: The name of the Auto Scaling group.
- `target_group_arns`: The Amazon Resource Names (ARN) of the target groups. You can
  specify up to 10 target groups.

"""
function detach_load_balancer_target_groups(
    AutoScalingGroupName,
    TargetGroupARNs;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "DetachLoadBalancerTargetGroups",
        Dict{String,Any}(
            "AutoScalingGroupName" => AutoScalingGroupName,
            "TargetGroupARNs" => TargetGroupARNs,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function detach_load_balancer_target_groups(
    AutoScalingGroupName,
    TargetGroupARNs,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "DetachLoadBalancerTargetGroups",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AutoScalingGroupName" => AutoScalingGroupName,
                    "TargetGroupARNs" => TargetGroupARNs,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    detach_load_balancers(auto_scaling_group_name, load_balancer_names)
    detach_load_balancers(auto_scaling_group_name, load_balancer_names, params::Dict{String,<:Any})

 This API operation is superseded by DetachTrafficSources, which can detach multiple
traffic sources types. We recommend using DetachTrafficSources to simplify how you manage
traffic sources. However, we continue to support DetachLoadBalancers. You can use both the
original DetachLoadBalancers API operation and DetachTrafficSources on the same Auto
Scaling group.  Detaches one or more Classic Load Balancers from the specified Auto Scaling
group. This operation detaches only Classic Load Balancers. If you have Application Load
Balancers, Network Load Balancers, or Gateway Load Balancers, use the
DetachLoadBalancerTargetGroups API instead. When you detach a load balancer, it enters the
Removing state while deregistering the instances in the group. When all instances are
deregistered, then you can no longer describe the load balancer using the
DescribeLoadBalancers API call. The instances remain running.

# Arguments
- `auto_scaling_group_name`: The name of the Auto Scaling group.
- `load_balancer_names`: The names of the load balancers. You can specify up to 10 load
  balancers.

"""
function detach_load_balancers(
    AutoScalingGroupName,
    LoadBalancerNames;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "DetachLoadBalancers",
        Dict{String,Any}(
            "AutoScalingGroupName" => AutoScalingGroupName,
            "LoadBalancerNames" => LoadBalancerNames,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function detach_load_balancers(
    AutoScalingGroupName,
    LoadBalancerNames,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "DetachLoadBalancers",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AutoScalingGroupName" => AutoScalingGroupName,
                    "LoadBalancerNames" => LoadBalancerNames,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    detach_traffic_sources(auto_scaling_group_name, traffic_sources)
    detach_traffic_sources(auto_scaling_group_name, traffic_sources, params::Dict{String,<:Any})

Detaches one or more traffic sources from the specified Auto Scaling group. When you detach
a traffic source, it enters the Removing state while deregistering the instances in the
group. When all instances are deregistered, then you can no longer describe the traffic
source using the DescribeTrafficSources API call. The instances continue to run.

# Arguments
- `auto_scaling_group_name`: The name of the Auto Scaling group.
- `traffic_sources`: The unique identifiers of one or more traffic sources. You can specify
  up to 10 traffic sources.

"""
function detach_traffic_sources(
    AutoScalingGroupName, TrafficSources; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auto_scaling(
        "DetachTrafficSources",
        Dict{String,Any}(
            "AutoScalingGroupName" => AutoScalingGroupName,
            "TrafficSources" => TrafficSources,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function detach_traffic_sources(
    AutoScalingGroupName,
    TrafficSources,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "DetachTrafficSources",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AutoScalingGroupName" => AutoScalingGroupName,
                    "TrafficSources" => TrafficSources,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disable_metrics_collection(auto_scaling_group_name)
    disable_metrics_collection(auto_scaling_group_name, params::Dict{String,<:Any})

Disables group metrics collection for the specified Auto Scaling group.

# Arguments
- `auto_scaling_group_name`: The name of the Auto Scaling group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Metrics"`: Identifies the metrics to disable. You can specify one or more of the
  following metrics:    GroupMinSize     GroupMaxSize     GroupDesiredCapacity
  GroupInServiceInstances     GroupPendingInstances     GroupStandbyInstances
  GroupTerminatingInstances     GroupTotalInstances     GroupInServiceCapacity
  GroupPendingCapacity     GroupStandbyCapacity     GroupTerminatingCapacity
  GroupTotalCapacity     WarmPoolDesiredCapacity     WarmPoolWarmedCapacity
  WarmPoolPendingCapacity     WarmPoolTerminatingCapacity     WarmPoolTotalCapacity
  GroupAndWarmPoolDesiredCapacity     GroupAndWarmPoolTotalCapacity    If you omit this
  property, all metrics are disabled. For more information, see Amazon CloudWatch metrics for
  Amazon EC2 Auto Scaling in the Amazon EC2 Auto Scaling User Guide.
"""
function disable_metrics_collection(
    AutoScalingGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auto_scaling(
        "DisableMetricsCollection",
        Dict{String,Any}("AutoScalingGroupName" => AutoScalingGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disable_metrics_collection(
    AutoScalingGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "DisableMetricsCollection",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("AutoScalingGroupName" => AutoScalingGroupName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    enable_metrics_collection(auto_scaling_group_name, granularity)
    enable_metrics_collection(auto_scaling_group_name, granularity, params::Dict{String,<:Any})

Enables group metrics collection for the specified Auto Scaling group. You can use these
metrics to track changes in an Auto Scaling group and to set alarms on threshold values.
You can view group metrics using the Amazon EC2 Auto Scaling console or the CloudWatch
console. For more information, see Monitor CloudWatch metrics for your Auto Scaling groups
and instances in the Amazon EC2 Auto Scaling User Guide.

# Arguments
- `auto_scaling_group_name`: The name of the Auto Scaling group.
- `granularity`: The frequency at which Amazon EC2 Auto Scaling sends aggregated data to
  CloudWatch. The only valid value is 1Minute.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Metrics"`: Identifies the metrics to enable. You can specify one or more of the
  following metrics:    GroupMinSize     GroupMaxSize     GroupDesiredCapacity
  GroupInServiceInstances     GroupPendingInstances     GroupStandbyInstances
  GroupTerminatingInstances     GroupTotalInstances     GroupInServiceCapacity
  GroupPendingCapacity     GroupStandbyCapacity     GroupTerminatingCapacity
  GroupTotalCapacity     WarmPoolDesiredCapacity     WarmPoolWarmedCapacity
  WarmPoolPendingCapacity     WarmPoolTerminatingCapacity     WarmPoolTotalCapacity
  GroupAndWarmPoolDesiredCapacity     GroupAndWarmPoolTotalCapacity    If you specify
  Granularity and don't specify any metrics, all metrics are enabled. For more information,
  see Amazon CloudWatch metrics for Amazon EC2 Auto Scaling in the Amazon EC2 Auto Scaling
  User Guide.
"""
function enable_metrics_collection(
    AutoScalingGroupName, Granularity; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auto_scaling(
        "EnableMetricsCollection",
        Dict{String,Any}(
            "AutoScalingGroupName" => AutoScalingGroupName, "Granularity" => Granularity
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function enable_metrics_collection(
    AutoScalingGroupName,
    Granularity,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "EnableMetricsCollection",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AutoScalingGroupName" => AutoScalingGroupName,
                    "Granularity" => Granularity,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    enter_standby(auto_scaling_group_name, should_decrement_desired_capacity)
    enter_standby(auto_scaling_group_name, should_decrement_desired_capacity, params::Dict{String,<:Any})

Moves the specified instances into the standby state. If you choose to decrement the
desired capacity of the Auto Scaling group, the instances can enter standby as long as the
desired capacity of the Auto Scaling group after the instances are placed into standby is
equal to or greater than the minimum capacity of the group. If you choose not to decrement
the desired capacity of the Auto Scaling group, the Auto Scaling group launches new
instances to replace the instances on standby. For more information, see Temporarily
removing instances from your Auto Scaling group in the Amazon EC2 Auto Scaling User Guide.

# Arguments
- `auto_scaling_group_name`: The name of the Auto Scaling group.
- `should_decrement_desired_capacity`: Indicates whether to decrement the desired capacity
  of the Auto Scaling group by the number of instances moved to Standby mode.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"InstanceIds"`: The IDs of the instances. You can specify up to 20 instances.
"""
function enter_standby(
    AutoScalingGroupName,
    ShouldDecrementDesiredCapacity;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "EnterStandby",
        Dict{String,Any}(
            "AutoScalingGroupName" => AutoScalingGroupName,
            "ShouldDecrementDesiredCapacity" => ShouldDecrementDesiredCapacity,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function enter_standby(
    AutoScalingGroupName,
    ShouldDecrementDesiredCapacity,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "EnterStandby",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AutoScalingGroupName" => AutoScalingGroupName,
                    "ShouldDecrementDesiredCapacity" => ShouldDecrementDesiredCapacity,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    execute_policy(policy_name)
    execute_policy(policy_name, params::Dict{String,<:Any})

Executes the specified policy. This can be useful for testing the design of your scaling
policy.

# Arguments
- `policy_name`: The name or ARN of the policy.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AutoScalingGroupName"`: The name of the Auto Scaling group.
- `"BreachThreshold"`: The breach threshold for the alarm. Required if the policy type is
  StepScaling and not supported otherwise.
- `"HonorCooldown"`: Indicates whether Amazon EC2 Auto Scaling waits for the cooldown
  period to complete before executing the policy. Valid only if the policy type is
  SimpleScaling. For more information, see Scaling cooldowns for Amazon EC2 Auto Scaling in
  the Amazon EC2 Auto Scaling User Guide.
- `"MetricValue"`: The metric value to compare to BreachThreshold. This enables you to
  execute a policy of type StepScaling and determine which step adjustment to use. For
  example, if the breach threshold is 50 and you want to use a step adjustment with a lower
  bound of 0 and an upper bound of 10, you can set the metric value to 59. If you specify a
  metric value that doesn't correspond to a step adjustment for the policy, the call returns
  an error. Required if the policy type is StepScaling and not supported otherwise.
"""
function execute_policy(PolicyName; aws_config::AbstractAWSConfig=current_aws_config())
    return auto_scaling(
        "ExecutePolicy",
        Dict{String,Any}("PolicyName" => PolicyName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function execute_policy(
    PolicyName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "ExecutePolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("PolicyName" => PolicyName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    exit_standby(auto_scaling_group_name)
    exit_standby(auto_scaling_group_name, params::Dict{String,<:Any})

Moves the specified instances out of the standby state. After you put the instances back in
service, the desired capacity is incremented. For more information, see Temporarily
removing instances from your Auto Scaling group in the Amazon EC2 Auto Scaling User Guide.

# Arguments
- `auto_scaling_group_name`: The name of the Auto Scaling group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"InstanceIds"`: The IDs of the instances. You can specify up to 20 instances.
"""
function exit_standby(
    AutoScalingGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auto_scaling(
        "ExitStandby",
        Dict{String,Any}("AutoScalingGroupName" => AutoScalingGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function exit_standby(
    AutoScalingGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "ExitStandby",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("AutoScalingGroupName" => AutoScalingGroupName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_predictive_scaling_forecast(auto_scaling_group_name, end_time, policy_name, start_time)
    get_predictive_scaling_forecast(auto_scaling_group_name, end_time, policy_name, start_time, params::Dict{String,<:Any})

Retrieves the forecast data for a predictive scaling policy. Load forecasts are predictions
of the hourly load values using historical load data from CloudWatch and an analysis of
historical trends. Capacity forecasts are represented as predicted values for the minimum
capacity that is needed on an hourly basis, based on the hourly load forecast. A minimum of
24 hours of data is required to create the initial forecasts. However, having a full 14
days of historical data results in more accurate forecasts. For more information, see
Predictive scaling for Amazon EC2 Auto Scaling in the Amazon EC2 Auto Scaling User Guide.

# Arguments
- `auto_scaling_group_name`: The name of the Auto Scaling group.
- `end_time`: The exclusive end time of the time range for the forecast data to get. The
  maximum time duration between the start and end time is 30 days.  Although this parameter
  can accept a date and time that is more than two days in the future, the availability of
  forecast data has limits. Amazon EC2 Auto Scaling only issues forecasts for periods of two
  days in advance.
- `policy_name`: The name of the policy.
- `start_time`: The inclusive start time of the time range for the forecast data to get. At
  most, the date and time can be one year before the current date and time.

"""
function get_predictive_scaling_forecast(
    AutoScalingGroupName,
    EndTime,
    PolicyName,
    StartTime;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "GetPredictiveScalingForecast",
        Dict{String,Any}(
            "AutoScalingGroupName" => AutoScalingGroupName,
            "EndTime" => EndTime,
            "PolicyName" => PolicyName,
            "StartTime" => StartTime,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_predictive_scaling_forecast(
    AutoScalingGroupName,
    EndTime,
    PolicyName,
    StartTime,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "GetPredictiveScalingForecast",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AutoScalingGroupName" => AutoScalingGroupName,
                    "EndTime" => EndTime,
                    "PolicyName" => PolicyName,
                    "StartTime" => StartTime,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_lifecycle_hook(auto_scaling_group_name, lifecycle_hook_name)
    put_lifecycle_hook(auto_scaling_group_name, lifecycle_hook_name, params::Dict{String,<:Any})

Creates or updates a lifecycle hook for the specified Auto Scaling group. Lifecycle hooks
let you create solutions that are aware of events in the Auto Scaling instance lifecycle,
and then perform a custom action on instances when the corresponding lifecycle event
occurs. This step is a part of the procedure for adding a lifecycle hook to an Auto Scaling
group:   (Optional) Create a launch template or launch configuration with a user data
script that runs while an instance is in a wait state due to a lifecycle hook.   (Optional)
Create a Lambda function and a rule that allows Amazon EventBridge to invoke your Lambda
function when an instance is put into a wait state due to a lifecycle hook.   (Optional)
Create a notification target and an IAM role. The target can be either an Amazon SQS queue
or an Amazon SNS topic. The role allows Amazon EC2 Auto Scaling to publish lifecycle
notifications to the target.    Create the lifecycle hook. Specify whether the hook is used
when the instances launch or terminate.    If you need more time, record the lifecycle
action heartbeat to keep the instance in a wait state using the
RecordLifecycleActionHeartbeat API call.   If you finish before the timeout period ends,
send a callback by using the CompleteLifecycleAction API call.   For more information, see
Amazon EC2 Auto Scaling lifecycle hooks in the Amazon EC2 Auto Scaling User Guide. If you
exceed your maximum limit of lifecycle hooks, which by default is 50 per Auto Scaling
group, the call fails. You can view the lifecycle hooks for an Auto Scaling group using the
DescribeLifecycleHooks API call. If you are no longer using a lifecycle hook, you can
delete it by calling the DeleteLifecycleHook API.

# Arguments
- `auto_scaling_group_name`: The name of the Auto Scaling group.
- `lifecycle_hook_name`: The name of the lifecycle hook.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DefaultResult"`: The action the Auto Scaling group takes when the lifecycle hook
  timeout elapses or if an unexpected failure occurs. The default value is ABANDON. Valid
  values: CONTINUE | ABANDON
- `"HeartbeatTimeout"`: The maximum time, in seconds, that can elapse before the lifecycle
  hook times out. The range is from 30 to 7200 seconds. The default value is 3600 seconds (1
  hour).
- `"LifecycleTransition"`: The lifecycle transition. For Auto Scaling groups, there are two
  major lifecycle transitions.   To create a lifecycle hook for scale-out events, specify
  autoscaling:EC2_INSTANCE_LAUNCHING.   To create a lifecycle hook for scale-in events,
  specify autoscaling:EC2_INSTANCE_TERMINATING.   Required for new lifecycle hooks, but
  optional when updating existing hooks.
- `"NotificationMetadata"`: Additional information that you want to include any time Amazon
  EC2 Auto Scaling sends a message to the notification target.
- `"NotificationTargetARN"`: The Amazon Resource Name (ARN) of the notification target that
  Amazon EC2 Auto Scaling uses to notify you when an instance is in a wait state for the
  lifecycle hook. You can specify either an Amazon SNS topic or an Amazon SQS queue. If you
  specify an empty string, this overrides the current ARN. This operation uses the JSON
  format when sending notifications to an Amazon SQS queue, and an email key-value pair
  format when sending notifications to an Amazon SNS topic. When you specify a notification
  target, Amazon EC2 Auto Scaling sends it a test message. Test messages contain the
  following additional key-value pair: \"Event\": \"autoscaling:TEST_NOTIFICATION\".
- `"RoleARN"`: The ARN of the IAM role that allows the Auto Scaling group to publish to the
  specified notification target. Valid only if the notification target is an Amazon SNS topic
  or an Amazon SQS queue. Required for new lifecycle hooks, but optional when updating
  existing hooks.
"""
function put_lifecycle_hook(
    AutoScalingGroupName,
    LifecycleHookName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "PutLifecycleHook",
        Dict{String,Any}(
            "AutoScalingGroupName" => AutoScalingGroupName,
            "LifecycleHookName" => LifecycleHookName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_lifecycle_hook(
    AutoScalingGroupName,
    LifecycleHookName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "PutLifecycleHook",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AutoScalingGroupName" => AutoScalingGroupName,
                    "LifecycleHookName" => LifecycleHookName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_notification_configuration(auto_scaling_group_name, notification_types, topic_arn)
    put_notification_configuration(auto_scaling_group_name, notification_types, topic_arn, params::Dict{String,<:Any})

Configures an Auto Scaling group to send notifications when specified events take place.
Subscribers to the specified topic can have messages delivered to an endpoint such as a web
server or an email address. This configuration overwrites any existing configuration. For
more information, see Amazon SNS notification options for Amazon EC2 Auto Scaling in the
Amazon EC2 Auto Scaling User Guide. If you exceed your maximum limit of SNS topics, which
is 10 per Auto Scaling group, the call fails.

# Arguments
- `auto_scaling_group_name`: The name of the Auto Scaling group.
- `notification_types`: The type of event that causes the notification to be sent. To query
  the notification types supported by Amazon EC2 Auto Scaling, call the
  DescribeAutoScalingNotificationTypes API.
- `topic_arn`: The Amazon Resource Name (ARN) of the Amazon SNS topic.

"""
function put_notification_configuration(
    AutoScalingGroupName,
    NotificationTypes,
    TopicARN;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "PutNotificationConfiguration",
        Dict{String,Any}(
            "AutoScalingGroupName" => AutoScalingGroupName,
            "NotificationTypes" => NotificationTypes,
            "TopicARN" => TopicARN,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_notification_configuration(
    AutoScalingGroupName,
    NotificationTypes,
    TopicARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "PutNotificationConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AutoScalingGroupName" => AutoScalingGroupName,
                    "NotificationTypes" => NotificationTypes,
                    "TopicARN" => TopicARN,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_scaling_policy(auto_scaling_group_name, policy_name)
    put_scaling_policy(auto_scaling_group_name, policy_name, params::Dict{String,<:Any})

Creates or updates a scaling policy for an Auto Scaling group. Scaling policies are used to
scale an Auto Scaling group based on configurable metrics. If no policies are defined, the
dynamic scaling and predictive scaling features are not used.  For more information about
using dynamic scaling, see Target tracking scaling policies and Step and simple scaling
policies in the Amazon EC2 Auto Scaling User Guide. For more information about using
predictive scaling, see Predictive scaling for Amazon EC2 Auto Scaling in the Amazon EC2
Auto Scaling User Guide. You can view the scaling policies for an Auto Scaling group using
the DescribePolicies API call. If you are no longer using a scaling policy, you can delete
it by calling the DeletePolicy API.

# Arguments
- `auto_scaling_group_name`: The name of the Auto Scaling group.
- `policy_name`: The name of the policy.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AdjustmentType"`: Specifies how the scaling adjustment is interpreted (for example, an
  absolute number or a percentage). The valid values are ChangeInCapacity, ExactCapacity, and
  PercentChangeInCapacity. Required if the policy type is StepScaling or SimpleScaling. For
  more information, see Scaling adjustment types in the Amazon EC2 Auto Scaling User Guide.
- `"Cooldown"`: A cooldown period, in seconds, that applies to a specific simple scaling
  policy. When a cooldown period is specified here, it overrides the default cooldown. Valid
  only if the policy type is SimpleScaling. For more information, see Scaling cooldowns for
  Amazon EC2 Auto Scaling in the Amazon EC2 Auto Scaling User Guide. Default: None
- `"Enabled"`: Indicates whether the scaling policy is enabled or disabled. The default is
  enabled. For more information, see Disable a scaling policy for an Auto Scaling group in
  the Amazon EC2 Auto Scaling User Guide.
- `"EstimatedInstanceWarmup"`:  Not needed if the default instance warmup is defined for
  the group.  The estimated time, in seconds, until a newly launched instance can contribute
  to the CloudWatch metrics. This warm-up period applies to instances launched due to a
  specific target tracking or step scaling policy. When a warm-up period is specified here,
  it overrides the default instance warmup. Valid only if the policy type is
  TargetTrackingScaling or StepScaling.  The default is to use the value for the default
  instance warmup defined for the group. If default instance warmup is null, then
  EstimatedInstanceWarmup falls back to the value of default cooldown.
- `"MetricAggregationType"`: The aggregation type for the CloudWatch metrics. The valid
  values are Minimum, Maximum, and Average. If the aggregation type is null, the value is
  treated as Average. Valid only if the policy type is StepScaling.
- `"MinAdjustmentMagnitude"`: The minimum value to scale by when the adjustment type is
  PercentChangeInCapacity. For example, suppose that you create a step scaling policy to
  scale out an Auto Scaling group by 25 percent and you specify a MinAdjustmentMagnitude of
  2. If the group has 4 instances and the scaling policy is performed, 25 percent of 4 is 1.
  However, because you specified a MinAdjustmentMagnitude of 2, Amazon EC2 Auto Scaling
  scales out the group by 2 instances. Valid only if the policy type is StepScaling or
  SimpleScaling. For more information, see Scaling adjustment types in the Amazon EC2 Auto
  Scaling User Guide.  Some Auto Scaling groups use instance weights. In this case, set the
  MinAdjustmentMagnitude to a value that is at least as large as your largest instance
  weight.
- `"MinAdjustmentStep"`: Available for backward compatibility. Use MinAdjustmentMagnitude
  instead.
- `"PolicyType"`: One of the following policy types:     TargetTrackingScaling
  StepScaling     SimpleScaling (default)    PredictiveScaling
- `"PredictiveScalingConfiguration"`: A predictive scaling policy. Provides support for
  predefined and custom metrics. Predefined metrics include CPU utilization, network in/out,
  and the Application Load Balancer request count. For more information, see
  PredictiveScalingConfiguration in the Amazon EC2 Auto Scaling API Reference. Required if
  the policy type is PredictiveScaling.
- `"ScalingAdjustment"`: The amount by which to scale, based on the specified adjustment
  type. A positive value adds to the current capacity while a negative number removes from
  the current capacity. For exact capacity, you must specify a non-negative value. Required
  if the policy type is SimpleScaling. (Not used with any other policy type.)
- `"StepAdjustments"`: A set of adjustments that enable you to scale based on the size of
  the alarm breach. Required if the policy type is StepScaling. (Not used with any other
  policy type.)
- `"TargetTrackingConfiguration"`: A target tracking scaling policy. Provides support for
  predefined or custom metrics. The following predefined metrics are available:
  ASGAverageCPUUtilization     ASGAverageNetworkIn     ASGAverageNetworkOut
  ALBRequestCountPerTarget    If you specify ALBRequestCountPerTarget for the metric, you
  must specify the ResourceLabel property with the PredefinedMetricSpecification. For more
  information, see TargetTrackingConfiguration in the Amazon EC2 Auto Scaling API Reference.
  Required if the policy type is TargetTrackingScaling.
"""
function put_scaling_policy(
    AutoScalingGroupName, PolicyName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auto_scaling(
        "PutScalingPolicy",
        Dict{String,Any}(
            "AutoScalingGroupName" => AutoScalingGroupName, "PolicyName" => PolicyName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_scaling_policy(
    AutoScalingGroupName,
    PolicyName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "PutScalingPolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AutoScalingGroupName" => AutoScalingGroupName,
                    "PolicyName" => PolicyName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_scheduled_update_group_action(auto_scaling_group_name, scheduled_action_name)
    put_scheduled_update_group_action(auto_scaling_group_name, scheduled_action_name, params::Dict{String,<:Any})

Creates or updates a scheduled scaling action for an Auto Scaling group. For more
information, see Scheduled scaling in the Amazon EC2 Auto Scaling User Guide. You can view
the scheduled actions for an Auto Scaling group using the DescribeScheduledActions API
call. If you are no longer using a scheduled action, you can delete it by calling the
DeleteScheduledAction API. If you try to schedule your action in the past, Amazon EC2 Auto
Scaling returns an error message.

# Arguments
- `auto_scaling_group_name`: The name of the Auto Scaling group.
- `scheduled_action_name`: The name of this scaling action.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DesiredCapacity"`: The desired capacity is the initial capacity of the Auto Scaling
  group after the scheduled action runs and the capacity it attempts to maintain. It can
  scale beyond this capacity if you add more scaling conditions.   You must specify at least
  one of the following properties: MaxSize, MinSize, or DesiredCapacity.
- `"EndTime"`: The date and time for the recurring schedule to end, in UTC. For example,
  \"2021-06-01T00:00:00Z\".
- `"MaxSize"`: The maximum size of the Auto Scaling group.
- `"MinSize"`: The minimum size of the Auto Scaling group.
- `"Recurrence"`: The recurring schedule for this action. This format consists of five
  fields separated by white spaces: [Minute] [Hour] [Day_of_Month] [Month_of_Year]
  [Day_of_Week]. The value must be in quotes (for example, \"30 0 1 1,6,12 *\"). For more
  information about this format, see Crontab. When StartTime and EndTime are specified with
  Recurrence, they form the boundaries of when the recurring action starts and stops. Cron
  expressions use Universal Coordinated Time (UTC) by default.
- `"StartTime"`: The date and time for this action to start, in YYYY-MM-DDThh:mm:ssZ format
  in UTC/GMT only and in quotes (for example, \"2021-06-01T00:00:00Z\"). If you specify
  Recurrence and StartTime, Amazon EC2 Auto Scaling performs the action at this time, and
  then performs the action based on the specified recurrence.
- `"Time"`: This property is no longer used.
- `"TimeZone"`: Specifies the time zone for a cron expression. If a time zone is not
  provided, UTC is used by default.  Valid values are the canonical names of the IANA time
  zones, derived from the IANA Time Zone Database (such as Etc/GMT+9 or Pacific/Tahiti). For
  more information, see https://en.wikipedia.org/wiki/List_of_tz_database_time_zones.
"""
function put_scheduled_update_group_action(
    AutoScalingGroupName,
    ScheduledActionName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "PutScheduledUpdateGroupAction",
        Dict{String,Any}(
            "AutoScalingGroupName" => AutoScalingGroupName,
            "ScheduledActionName" => ScheduledActionName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_scheduled_update_group_action(
    AutoScalingGroupName,
    ScheduledActionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "PutScheduledUpdateGroupAction",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AutoScalingGroupName" => AutoScalingGroupName,
                    "ScheduledActionName" => ScheduledActionName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_warm_pool(auto_scaling_group_name)
    put_warm_pool(auto_scaling_group_name, params::Dict{String,<:Any})

Creates or updates a warm pool for the specified Auto Scaling group. A warm pool is a pool
of pre-initialized EC2 instances that sits alongside the Auto Scaling group. Whenever your
application needs to scale out, the Auto Scaling group can draw on the warm pool to meet
its new desired capacity. This operation must be called from the Region in which the Auto
Scaling group was created. You can view the instances in the warm pool using the
DescribeWarmPool API call. If you are no longer using a warm pool, you can delete it by
calling the DeleteWarmPool API. For more information, see Warm pools for Amazon EC2 Auto
Scaling in the Amazon EC2 Auto Scaling User Guide.

# Arguments
- `auto_scaling_group_name`: The name of the Auto Scaling group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"InstanceReusePolicy"`: Indicates whether instances in the Auto Scaling group can be
  returned to the warm pool on scale in. The default is to terminate instances in the Auto
  Scaling group when the group scales in.
- `"MaxGroupPreparedCapacity"`: Specifies the maximum number of instances that are allowed
  to be in the warm pool or in any state except Terminated for the Auto Scaling group. This
  is an optional property. Specify it only if you do not want the warm pool size to be
  determined by the difference between the group's maximum capacity and its desired capacity.
    If a value for MaxGroupPreparedCapacity is not specified, Amazon EC2 Auto Scaling
  launches and maintains the difference between the group's maximum capacity and its desired
  capacity. If you specify a value for MaxGroupPreparedCapacity, Amazon EC2 Auto Scaling uses
  the difference between the MaxGroupPreparedCapacity and the desired capacity instead.  The
  size of the warm pool is dynamic. Only when MaxGroupPreparedCapacity and MinSize are set to
  the same value does the warm pool have an absolute size.  If the desired capacity of the
  Auto Scaling group is higher than the MaxGroupPreparedCapacity, the capacity of the warm
  pool is 0, unless you specify a value for MinSize. To remove a value that you previously
  set, include the property but specify -1 for the value.
- `"MinSize"`: Specifies the minimum number of instances to maintain in the warm pool. This
  helps you to ensure that there is always a certain number of warmed instances available to
  handle traffic spikes. Defaults to 0 if not specified.
- `"PoolState"`: Sets the instance state to transition to after the lifecycle actions are
  complete. Default is Stopped.
"""
function put_warm_pool(
    AutoScalingGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auto_scaling(
        "PutWarmPool",
        Dict{String,Any}("AutoScalingGroupName" => AutoScalingGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_warm_pool(
    AutoScalingGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "PutWarmPool",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("AutoScalingGroupName" => AutoScalingGroupName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    record_lifecycle_action_heartbeat(auto_scaling_group_name, lifecycle_hook_name)
    record_lifecycle_action_heartbeat(auto_scaling_group_name, lifecycle_hook_name, params::Dict{String,<:Any})

Records a heartbeat for the lifecycle action associated with the specified token or
instance. This extends the timeout by the length of time defined using the PutLifecycleHook
API call. This step is a part of the procedure for adding a lifecycle hook to an Auto
Scaling group:   (Optional) Create a launch template or launch configuration with a user
data script that runs while an instance is in a wait state due to a lifecycle hook.
(Optional) Create a Lambda function and a rule that allows Amazon EventBridge to invoke
your Lambda function when an instance is put into a wait state due to a lifecycle hook.
(Optional) Create a notification target and an IAM role. The target can be either an Amazon
SQS queue or an Amazon SNS topic. The role allows Amazon EC2 Auto Scaling to publish
lifecycle notifications to the target.   Create the lifecycle hook. Specify whether the
hook is used when the instances launch or terminate.    If you need more time, record the
lifecycle action heartbeat to keep the instance in a wait state.    If you finish before
the timeout period ends, send a callback by using the CompleteLifecycleAction API call.
For more information, see Amazon EC2 Auto Scaling lifecycle hooks in the Amazon EC2 Auto
Scaling User Guide.

# Arguments
- `auto_scaling_group_name`: The name of the Auto Scaling group.
- `lifecycle_hook_name`: The name of the lifecycle hook.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"InstanceId"`: The ID of the instance.
- `"LifecycleActionToken"`: A token that uniquely identifies a specific lifecycle action
  associated with an instance. Amazon EC2 Auto Scaling sends this token to the notification
  target that you specified when you created the lifecycle hook.
"""
function record_lifecycle_action_heartbeat(
    AutoScalingGroupName,
    LifecycleHookName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "RecordLifecycleActionHeartbeat",
        Dict{String,Any}(
            "AutoScalingGroupName" => AutoScalingGroupName,
            "LifecycleHookName" => LifecycleHookName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function record_lifecycle_action_heartbeat(
    AutoScalingGroupName,
    LifecycleHookName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "RecordLifecycleActionHeartbeat",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AutoScalingGroupName" => AutoScalingGroupName,
                    "LifecycleHookName" => LifecycleHookName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    resume_processes(auto_scaling_group_name)
    resume_processes(auto_scaling_group_name, params::Dict{String,<:Any})

Resumes the specified suspended auto scaling processes, or all suspended process, for the
specified Auto Scaling group. For more information, see Suspend and resume Amazon EC2 Auto
Scaling processes in the Amazon EC2 Auto Scaling User Guide.

# Arguments
- `auto_scaling_group_name`: The name of the Auto Scaling group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ScalingProcesses"`: One or more of the following processes:    Launch     Terminate
  AddToLoadBalancer     AlarmNotification     AZRebalance     HealthCheck     InstanceRefresh
      ReplaceUnhealthy     ScheduledActions    If you omit this property, all processes are
  specified.
"""
function resume_processes(
    AutoScalingGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auto_scaling(
        "ResumeProcesses",
        Dict{String,Any}("AutoScalingGroupName" => AutoScalingGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function resume_processes(
    AutoScalingGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "ResumeProcesses",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("AutoScalingGroupName" => AutoScalingGroupName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    rollback_instance_refresh(auto_scaling_group_name)
    rollback_instance_refresh(auto_scaling_group_name, params::Dict{String,<:Any})

Cancels an instance refresh that is in progress and rolls back any changes that it made.
Amazon EC2 Auto Scaling replaces any instances that were replaced during the instance
refresh. This restores your Auto Scaling group to the configuration that it was using
before the start of the instance refresh.  This operation is part of the instance refresh
feature in Amazon EC2 Auto Scaling, which helps you update instances in your Auto Scaling
group after you make configuration changes. A rollback is not supported in the following
situations:    There is no desired configuration specified for the instance refresh.   The
Auto Scaling group has a launch template that uses an Amazon Web Services Systems Manager
parameter instead of an AMI ID for the ImageId property.   The Auto Scaling group uses the
launch template's Latest or Default version.   When you receive a successful response from
this operation, Amazon EC2 Auto Scaling immediately begins replacing instances. You can
check the status of this operation through the DescribeInstanceRefreshes API operation.

# Arguments
- `auto_scaling_group_name`: The name of the Auto Scaling group.

"""
function rollback_instance_refresh(
    AutoScalingGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auto_scaling(
        "RollbackInstanceRefresh",
        Dict{String,Any}("AutoScalingGroupName" => AutoScalingGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function rollback_instance_refresh(
    AutoScalingGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "RollbackInstanceRefresh",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("AutoScalingGroupName" => AutoScalingGroupName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    set_desired_capacity(auto_scaling_group_name, desired_capacity)
    set_desired_capacity(auto_scaling_group_name, desired_capacity, params::Dict{String,<:Any})

Sets the size of the specified Auto Scaling group. If a scale-in activity occurs as a
result of a new DesiredCapacity value that is lower than the current size of the group, the
Auto Scaling group uses its termination policy to determine which instances to terminate.
For more information, see Manual scaling in the Amazon EC2 Auto Scaling User Guide.

# Arguments
- `auto_scaling_group_name`: The name of the Auto Scaling group.
- `desired_capacity`: The desired capacity is the initial capacity of the Auto Scaling
  group after this operation completes and the capacity it attempts to maintain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"HonorCooldown"`: Indicates whether Amazon EC2 Auto Scaling waits for the cooldown
  period to complete before initiating a scaling activity to set your Auto Scaling group to
  its new capacity. By default, Amazon EC2 Auto Scaling does not honor the cooldown period
  during manual scaling activities.
"""
function set_desired_capacity(
    AutoScalingGroupName,
    DesiredCapacity;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "SetDesiredCapacity",
        Dict{String,Any}(
            "AutoScalingGroupName" => AutoScalingGroupName,
            "DesiredCapacity" => DesiredCapacity,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function set_desired_capacity(
    AutoScalingGroupName,
    DesiredCapacity,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "SetDesiredCapacity",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AutoScalingGroupName" => AutoScalingGroupName,
                    "DesiredCapacity" => DesiredCapacity,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    set_instance_health(health_status, instance_id)
    set_instance_health(health_status, instance_id, params::Dict{String,<:Any})

Sets the health status of the specified instance. For more information, see Health checks
for instances in an Auto Scaling group in the Amazon EC2 Auto Scaling User Guide.

# Arguments
- `health_status`: The health status of the instance. Set to Healthy to have the instance
  remain in service. Set to Unhealthy to have the instance be out of service. Amazon EC2 Auto
  Scaling terminates and replaces the unhealthy instance.
- `instance_id`: The ID of the instance.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ShouldRespectGracePeriod"`: If the Auto Scaling group of the specified instance has a
  HealthCheckGracePeriod specified for the group, by default, this call respects the grace
  period. Set this to False, to have the call not respect the grace period associated with
  the group. For more information about the health check grace period, see Set the health
  check grace period for an Auto Scaling group in the Amazon EC2 Auto Scaling User Guide.
"""
function set_instance_health(
    HealthStatus, InstanceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auto_scaling(
        "SetInstanceHealth",
        Dict{String,Any}("HealthStatus" => HealthStatus, "InstanceId" => InstanceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function set_instance_health(
    HealthStatus,
    InstanceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "SetInstanceHealth",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "HealthStatus" => HealthStatus, "InstanceId" => InstanceId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    set_instance_protection(auto_scaling_group_name, instance_ids, protected_from_scale_in)
    set_instance_protection(auto_scaling_group_name, instance_ids, protected_from_scale_in, params::Dict{String,<:Any})

Updates the instance protection settings of the specified instances. This operation cannot
be called on instances in a warm pool. For more information, see Use instance scale-in
protection in the Amazon EC2 Auto Scaling User Guide. If you exceed your maximum limit of
instance IDs, which is 50 per Auto Scaling group, the call fails.

# Arguments
- `auto_scaling_group_name`: The name of the Auto Scaling group.
- `instance_ids`: One or more instance IDs. You can specify up to 50 instances.
- `protected_from_scale_in`: Indicates whether the instance is protected from termination
  by Amazon EC2 Auto Scaling when scaling in.

"""
function set_instance_protection(
    AutoScalingGroupName,
    InstanceIds,
    ProtectedFromScaleIn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "SetInstanceProtection",
        Dict{String,Any}(
            "AutoScalingGroupName" => AutoScalingGroupName,
            "InstanceIds" => InstanceIds,
            "ProtectedFromScaleIn" => ProtectedFromScaleIn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function set_instance_protection(
    AutoScalingGroupName,
    InstanceIds,
    ProtectedFromScaleIn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "SetInstanceProtection",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AutoScalingGroupName" => AutoScalingGroupName,
                    "InstanceIds" => InstanceIds,
                    "ProtectedFromScaleIn" => ProtectedFromScaleIn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_instance_refresh(auto_scaling_group_name)
    start_instance_refresh(auto_scaling_group_name, params::Dict{String,<:Any})

Starts an instance refresh. This operation is part of the instance refresh feature in
Amazon EC2 Auto Scaling, which helps you update instances in your Auto Scaling group. This
feature is helpful, for example, when you have a new AMI or a new user data script. You
just need to create a new launch template that specifies the new AMI or user data script.
Then start an instance refresh to immediately begin the process of updating instances in
the group.  If successful, the request's response contains a unique ID that you can use to
track the progress of the instance refresh. To query its status, call the
DescribeInstanceRefreshes API. To describe the instance refreshes that have already run,
call the DescribeInstanceRefreshes API. To cancel an instance refresh that is in progress,
use the CancelInstanceRefresh API.  An instance refresh might fail for several reasons,
such as EC2 launch failures, misconfigured health checks, or not ignoring or allowing the
termination of instances that are in Standby state or protected from scale in. You can
monitor for failed EC2 launches using the scaling activities. To find the scaling
activities, call the DescribeScalingActivities API. If you enable auto rollback, your Auto
Scaling group will be rolled back automatically when the instance refresh fails. You can
enable this feature before starting an instance refresh by specifying the AutoRollback
property in the instance refresh preferences. Otherwise, to roll back an instance refresh
before it finishes, use the RollbackInstanceRefresh API.

# Arguments
- `auto_scaling_group_name`: The name of the Auto Scaling group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DesiredConfiguration"`: The desired configuration. For example, the desired
  configuration can specify a new launch template or a new version of the current launch
  template. Once the instance refresh succeeds, Amazon EC2 Auto Scaling updates the settings
  of the Auto Scaling group to reflect the new desired configuration.   When you specify a
  new launch template or a new version of the current launch template for your desired
  configuration, consider enabling the SkipMatching property in preferences. If it's enabled,
  Amazon EC2 Auto Scaling skips replacing instances that already use the specified launch
  template and instance types. This can help you reduce the number of replacements that are
  required to apply updates.
- `"Preferences"`: Sets your preferences for the instance refresh so that it performs as
  expected when you start it. Includes the instance warmup time, the minimum and maximum
  healthy percentages, and the behaviors that you want Amazon EC2 Auto Scaling to use if
  instances that are in Standby state or protected from scale in are found. You can also
  choose to enable additional features, such as the following:   Auto rollback   Checkpoints
   CloudWatch alarms   Skip matching
- `"Strategy"`: The strategy to use for the instance refresh. The only valid value is
  Rolling.
"""
function start_instance_refresh(
    AutoScalingGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auto_scaling(
        "StartInstanceRefresh",
        Dict{String,Any}("AutoScalingGroupName" => AutoScalingGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_instance_refresh(
    AutoScalingGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "StartInstanceRefresh",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("AutoScalingGroupName" => AutoScalingGroupName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    suspend_processes(auto_scaling_group_name)
    suspend_processes(auto_scaling_group_name, params::Dict{String,<:Any})

Suspends the specified auto scaling processes, or all processes, for the specified Auto
Scaling group. If you suspend either the Launch or Terminate process types, it can prevent
other process types from functioning properly. For more information, see Suspend and resume
Amazon EC2 Auto Scaling processes in the Amazon EC2 Auto Scaling User Guide. To resume
processes that have been suspended, call the ResumeProcesses API.

# Arguments
- `auto_scaling_group_name`: The name of the Auto Scaling group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ScalingProcesses"`: One or more of the following processes:    Launch     Terminate
  AddToLoadBalancer     AlarmNotification     AZRebalance     HealthCheck     InstanceRefresh
      ReplaceUnhealthy     ScheduledActions    If you omit this property, all processes are
  specified.
"""
function suspend_processes(
    AutoScalingGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auto_scaling(
        "SuspendProcesses",
        Dict{String,Any}("AutoScalingGroupName" => AutoScalingGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function suspend_processes(
    AutoScalingGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "SuspendProcesses",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("AutoScalingGroupName" => AutoScalingGroupName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    terminate_instance_in_auto_scaling_group(instance_id, should_decrement_desired_capacity)
    terminate_instance_in_auto_scaling_group(instance_id, should_decrement_desired_capacity, params::Dict{String,<:Any})

Terminates the specified instance and optionally adjusts the desired group size. This
operation cannot be called on instances in a warm pool. This call simply makes a
termination request. The instance is not terminated immediately. When an instance is
terminated, the instance status changes to terminated. You can't connect to or start an
instance after you've terminated it. If you do not specify the option to decrement the
desired capacity, Amazon EC2 Auto Scaling launches instances to replace the ones that are
terminated.  By default, Amazon EC2 Auto Scaling balances instances across all Availability
Zones. If you decrement the desired capacity, your Auto Scaling group can become unbalanced
between Availability Zones. Amazon EC2 Auto Scaling tries to rebalance the group, and
rebalancing might terminate instances in other zones. For more information, see Manual
scaling in the Amazon EC2 Auto Scaling User Guide.

# Arguments
- `instance_id`: The ID of the instance.
- `should_decrement_desired_capacity`: Indicates whether terminating the instance also
  decrements the size of the Auto Scaling group.

"""
function terminate_instance_in_auto_scaling_group(
    InstanceId,
    ShouldDecrementDesiredCapacity;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "TerminateInstanceInAutoScalingGroup",
        Dict{String,Any}(
            "InstanceId" => InstanceId,
            "ShouldDecrementDesiredCapacity" => ShouldDecrementDesiredCapacity,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function terminate_instance_in_auto_scaling_group(
    InstanceId,
    ShouldDecrementDesiredCapacity,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "TerminateInstanceInAutoScalingGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "InstanceId" => InstanceId,
                    "ShouldDecrementDesiredCapacity" => ShouldDecrementDesiredCapacity,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_auto_scaling_group(auto_scaling_group_name)
    update_auto_scaling_group(auto_scaling_group_name, params::Dict{String,<:Any})

 We strongly recommend that all Auto Scaling groups use launch templates to ensure full
functionality for Amazon EC2 Auto Scaling and Amazon EC2.  Updates the configuration for
the specified Auto Scaling group. To update an Auto Scaling group, specify the name of the
group and the property that you want to change. Any properties that you don't specify are
not changed by this update request. The new settings take effect on any scaling activities
after this call returns.  If you associate a new launch configuration or template with an
Auto Scaling group, all new instances will get the updated configuration. Existing
instances continue to run with the configuration that they were originally launched with.
When you update a group to specify a mixed instances policy instead of a launch
configuration or template, existing instances may be replaced to match the new purchasing
options that you specified in the policy. For example, if the group currently has 100%
On-Demand capacity and the policy specifies 50% Spot capacity, this means that half of your
instances will be gradually terminated and relaunched as Spot Instances. When replacing
instances, Amazon EC2 Auto Scaling launches new instances before terminating the old ones,
so that updating your group does not compromise the performance or availability of your
application. Note the following about changing DesiredCapacity, MaxSize, or MinSize:   If a
scale-in activity occurs as a result of a new DesiredCapacity value that is lower than the
current size of the group, the Auto Scaling group uses its termination policy to determine
which instances to terminate.   If you specify a new value for MinSize without specifying a
value for DesiredCapacity, and the new MinSize is larger than the current size of the
group, this sets the group's DesiredCapacity to the new MinSize value.   If you specify a
new value for MaxSize without specifying a value for DesiredCapacity, and the new MaxSize
is smaller than the current size of the group, this sets the group's DesiredCapacity to the
new MaxSize value.   To see which properties have been set, call the
DescribeAutoScalingGroups API. To view the scaling policies for an Auto Scaling group, call
the DescribePolicies API. If the group has scaling policies, you can update them by calling
the PutScalingPolicy API.

# Arguments
- `auto_scaling_group_name`: The name of the Auto Scaling group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AvailabilityZones"`: One or more Availability Zones for the group.
- `"CapacityRebalance"`: Enables or disables Capacity Rebalancing. For more information,
  see Use Capacity Rebalancing to handle Amazon EC2 Spot Interruptions in the Amazon EC2 Auto
  Scaling User Guide.
- `"Context"`: Reserved.
- `"DefaultCooldown"`:  Only needed if you use simple scaling policies.  The amount of
  time, in seconds, between one scaling activity ending and another one starting due to
  simple scaling policies. For more information, see Scaling cooldowns for Amazon EC2 Auto
  Scaling in the Amazon EC2 Auto Scaling User Guide.
- `"DefaultInstanceWarmup"`: The amount of time, in seconds, until a new instance is
  considered to have finished initializing and resource consumption to become stable after it
  enters the InService state.  During an instance refresh, Amazon EC2 Auto Scaling waits for
  the warm-up period after it replaces an instance before it moves on to replacing the next
  instance. Amazon EC2 Auto Scaling also waits for the warm-up period before aggregating the
  metrics for new instances with existing instances in the Amazon CloudWatch metrics that are
  used for scaling, resulting in more reliable usage data. For more information, see Set the
  default instance warmup for an Auto Scaling group in the Amazon EC2 Auto Scaling User
  Guide.  To manage various warm-up settings at the group level, we recommend that you set
  the default instance warmup, even if it is set to 0 seconds. To remove a value that you
  previously set, include the property but specify -1 for the value. However, we strongly
  recommend keeping the default instance warmup enabled by specifying a value of 0 or other
  nominal value.
- `"DesiredCapacity"`: The desired capacity is the initial capacity of the Auto Scaling
  group after this operation completes and the capacity it attempts to maintain. This number
  must be greater than or equal to the minimum size of the group and less than or equal to
  the maximum size of the group.
- `"DesiredCapacityType"`: The unit of measurement for the value specified for desired
  capacity. Amazon EC2 Auto Scaling supports DesiredCapacityType for attribute-based instance
  type selection only. For more information, see Create a mixed instances group using
  attribute-based instance type selection in the Amazon EC2 Auto Scaling User Guide. By
  default, Amazon EC2 Auto Scaling specifies units, which translates into number of
  instances. Valid values: units | vcpu | memory-mib
- `"HealthCheckGracePeriod"`: The amount of time, in seconds, that Amazon EC2 Auto Scaling
  waits before checking the health status of an EC2 instance that has come into service and
  marking it unhealthy due to a failed health check. This is useful if your instances do not
  immediately pass their health checks after they enter the InService state. For more
  information, see Set the health check grace period for an Auto Scaling group in the Amazon
  EC2 Auto Scaling User Guide.
- `"HealthCheckType"`: A comma-separated value string of one or more health check types.
  The valid values are EC2, ELB, and VPC_LATTICE. EC2 is the default health check and cannot
  be disabled. For more information, see Health checks for instances in an Auto Scaling group
  in the Amazon EC2 Auto Scaling User Guide. Only specify EC2 if you must clear a value that
  was previously set.
- `"InstanceMaintenancePolicy"`: An instance maintenance policy. For more information, see
  Set instance maintenance policy in the Amazon EC2 Auto Scaling User Guide.
- `"LaunchConfigurationName"`: The name of the launch configuration. If you specify
  LaunchConfigurationName in your update request, you can't specify LaunchTemplate or
  MixedInstancesPolicy.
- `"LaunchTemplate"`: The launch template and version to use to specify the updates. If you
  specify LaunchTemplate in your update request, you can't specify LaunchConfigurationName or
  MixedInstancesPolicy.
- `"MaxInstanceLifetime"`: The maximum amount of time, in seconds, that an instance can be
  in service. The default is null. If specified, the value must be either 0 or a number equal
  to or greater than 86,400 seconds (1 day). To clear a previously set value, specify a new
  value of 0. For more information, see Replacing Auto Scaling instances based on maximum
  instance lifetime in the Amazon EC2 Auto Scaling User Guide.
- `"MaxSize"`: The maximum size of the Auto Scaling group.  With a mixed instances policy
  that uses instance weighting, Amazon EC2 Auto Scaling may need to go above MaxSize to meet
  your capacity requirements. In this event, Amazon EC2 Auto Scaling will never go above
  MaxSize by more than your largest instance weight (weights that define how many units each
  instance contributes to the desired capacity of the group).
- `"MinSize"`: The minimum size of the Auto Scaling group.
- `"MixedInstancesPolicy"`: The mixed instances policy. For more information, see Auto
  Scaling groups with multiple instance types and purchase options in the Amazon EC2 Auto
  Scaling User Guide.
- `"NewInstancesProtectedFromScaleIn"`: Indicates whether newly launched instances are
  protected from termination by Amazon EC2 Auto Scaling when scaling in. For more information
  about preventing instances from terminating on scale in, see Use instance scale-in
  protection in the Amazon EC2 Auto Scaling User Guide.
- `"PlacementGroup"`: The name of an existing placement group into which to launch your
  instances. For more information, see Placement groups in the Amazon EC2 User Guide for
  Linux Instances.  A cluster placement group is a logical grouping of instances within a
  single Availability Zone. You cannot specify multiple Availability Zones and a cluster
  placement group.
- `"ServiceLinkedRoleARN"`: The Amazon Resource Name (ARN) of the service-linked role that
  the Auto Scaling group uses to call other Amazon Web Services on your behalf. For more
  information, see Service-linked roles in the Amazon EC2 Auto Scaling User Guide.
- `"TerminationPolicies"`: A policy or a list of policies that are used to select the
  instances to terminate. The policies are executed in the order that you list them. For more
  information, see Configure termination policies for Amazon EC2 Auto Scaling in the Amazon
  EC2 Auto Scaling User Guide. Valid values: Default | AllocationStrategy |
  ClosestToNextInstanceHour | NewestInstance | OldestInstance | OldestLaunchConfiguration |
  OldestLaunchTemplate | arn:aws:lambda:region:account-id:function:my-function:my-alias
- `"VPCZoneIdentifier"`: A comma-separated list of subnet IDs for a virtual private cloud
  (VPC). If you specify VPCZoneIdentifier with AvailabilityZones, the subnets that you
  specify must reside in those Availability Zones.
"""
function update_auto_scaling_group(
    AutoScalingGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return auto_scaling(
        "UpdateAutoScalingGroup",
        Dict{String,Any}("AutoScalingGroupName" => AutoScalingGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_auto_scaling_group(
    AutoScalingGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return auto_scaling(
        "UpdateAutoScalingGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("AutoScalingGroupName" => AutoScalingGroupName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: qbusiness
using AWS.Compat
using AWS.UUIDs

"""
    batch_delete_document(application_id, documents, index_id)
    batch_delete_document(application_id, documents, index_id, params::Dict{String,<:Any})

Asynchronously deletes one or more documents added using the BatchPutDocument API from an
Amazon Q Business index. You can see the progress of the deletion, and any error messages
related to the process, by using CloudWatch.

# Arguments
- `application_id`: The identifier of the Amazon Q Business application.
- `documents`: Documents deleted from the Amazon Q Business index.
- `index_id`: The identifier of the Amazon Q Business index that contains the documents to
  delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"dataSourceSyncId"`: The identifier of the data source sync during which the documents
  were deleted.
"""
function batch_delete_document(
    applicationId, documents, indexId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qbusiness(
        "POST",
        "/applications/$(applicationId)/indices/$(indexId)/documents/delete",
        Dict{String,Any}("documents" => documents);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_delete_document(
    applicationId,
    documents,
    indexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "POST",
        "/applications/$(applicationId)/indices/$(indexId)/documents/delete",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("documents" => documents), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_put_document(application_id, documents, index_id)
    batch_put_document(application_id, documents, index_id, params::Dict{String,<:Any})

Adds one or more documents to an Amazon Q Business index. You use this API to:   ingest
your structured and unstructured documents and documents stored in an Amazon S3 bucket into
an Amazon Q Business index.   add custom attributes to documents in an Amazon Q Business
index.   attach an access control list to the documents added to an Amazon Q Business
index.   You can see the progress of the deletion, and any error messages related to the
process, by using CloudWatch.

# Arguments
- `application_id`: The identifier of the Amazon Q Business application.
- `documents`: One or more documents to add to the index.
- `index_id`: The identifier of the Amazon Q Business index to add the documents to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"dataSourceSyncId"`: The identifier of the data source sync during which the documents
  were added.
- `"roleArn"`: The Amazon Resource Name (ARN) of an IAM role with permission to access your
  S3 bucket.
"""
function batch_put_document(
    applicationId, documents, indexId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qbusiness(
        "POST",
        "/applications/$(applicationId)/indices/$(indexId)/documents",
        Dict{String,Any}("documents" => documents);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_put_document(
    applicationId,
    documents,
    indexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "POST",
        "/applications/$(applicationId)/indices/$(indexId)/documents",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("documents" => documents), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    chat_sync(application_id)
    chat_sync(application_id, params::Dict{String,<:Any})

Starts or continues a non-streaming Amazon Q Business conversation.

# Arguments
- `application_id`: The identifier of the Amazon Q Business application linked to the
  Amazon Q Business conversation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"actionExecution"`: A request from an end user to perform an Amazon Q Business plugin
  action.
- `"attachments"`: A list of files uploaded directly during chat. You can upload a maximum
  of 5 files of upto 10 MB each.
- `"attributeFilter"`: Enables filtering of Amazon Q Business web experience responses
  based on document attributes or metadata fields.
- `"authChallengeResponse"`: An authentication verification event response by a third party
  authentication server to Amazon Q Business.
- `"chatMode"`: The chat modes available to an Amazon Q Business end user.
  RETRIEVAL_MODE - The default chat mode for an Amazon Q Business application. When this mode
  is enabled, Amazon Q Business generates responses only from data sources connected to an
  Amazon Q Business application.    CREATOR_MODE - By selecting this mode, users can choose
  to generate responses only from the LLM knowledge, without consulting connected data
  sources, for a chat request.    PLUGIN_MODE - By selecting this mode, users can choose to
  use plugins in chat.   For more information, see Admin controls and guardrails, Plugins,
  and Conversation settings.
- `"chatModeConfiguration"`: The chat mode configuration for an Amazon Q Business
  application.
- `"clientToken"`: A token that you provide to identify a chat request.
- `"conversationId"`: The identifier of the Amazon Q Business conversation.
- `"parentMessageId"`: The identifier of the previous system message in a conversation.
- `"userGroups"`: The groups that a user associated with the chat input belongs to.
- `"userId"`: The identifier of the user attached to the chat input.
- `"userMessage"`: A end user message in a conversation.
"""
function chat_sync(applicationId; aws_config::AbstractAWSConfig=current_aws_config())
    return qbusiness(
        "POST",
        "/applications/$(applicationId)/conversations?sync",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function chat_sync(
    applicationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "POST",
        "/applications/$(applicationId)/conversations?sync",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_application(display_name)
    create_application(display_name, params::Dict{String,<:Any})

Creates an Amazon Q Business application.  There are new tiers for Amazon Q Business. Not
all features in Amazon Q Business Pro are also available in Amazon Q Business Lite. For
information on what's included in Amazon Q Business Lite and what's included in Amazon Q
Business Pro, see Amazon Q Business tiers. You must use the Amazon Q Business console to
assign subscription tiers to users.

# Arguments
- `display_name`: A name for the Amazon Q Business application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"attachmentsConfiguration"`: An option to allow end users to upload files directly
  during chat.
- `"clientToken"`: A token that you provide to identify the request to create your Amazon Q
  Business application.
- `"description"`: A description for the Amazon Q Business application.
- `"encryptionConfiguration"`: The identifier of the KMS key that is used to encrypt your
  data. Amazon Q Business doesn't support asymmetric keys.
- `"identityCenterInstanceArn"`:  The Amazon Resource Name (ARN) of the IAM Identity Center
  instance you are either creating for—or connecting to—your Amazon Q Business
  application.
- `"qAppsConfiguration"`: An option to allow end users to create and use Amazon Q Apps in
  the web experience.
- `"roleArn"`:  The Amazon Resource Name (ARN) of an IAM role with permissions to access
  your Amazon CloudWatch logs and metrics.
- `"tags"`: A list of key-value pairs that identify or categorize your Amazon Q Business
  application. You can also use tags to help control access to the application. Tag keys and
  values can consist of Unicode letters, digits, white space, and any of the following
  symbols: _ . : / = + - @.
"""
function create_application(displayName; aws_config::AbstractAWSConfig=current_aws_config())
    return qbusiness(
        "POST",
        "/applications",
        Dict{String,Any}("displayName" => displayName, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_application(
    displayName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "POST",
        "/applications",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "displayName" => displayName, "clientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_data_source(application_id, configuration, display_name, index_id)
    create_data_source(application_id, configuration, display_name, index_id, params::Dict{String,<:Any})

Creates a data source connector for an Amazon Q Business application.  CreateDataSource is
a synchronous operation. The operation returns 200 if the data source was successfully
created. Otherwise, an exception is raised.

# Arguments
- `application_id`:  The identifier of the Amazon Q Business application the data source
  will be attached to.
- `configuration`: Configuration information to connect to your data source repository. For
  configuration templates for your specific data source, see Supported connectors.
- `display_name`: A name for the data source connector.
- `index_id`: The identifier of the index that you want to use with the data source
  connector.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A token you provide to identify a request to create a data source
  connector. Multiple calls to the CreateDataSource API with the same client token will
  create only one data source connector.
- `"description"`: A description for the data source connector.
- `"documentEnrichmentConfiguration"`:
- `"roleArn"`: The Amazon Resource Name (ARN) of an IAM role with permission to access the
  data source and required resources.
- `"syncSchedule"`: Sets the frequency for Amazon Q Business to check the documents in your
  data source repository and update your index. If you don't set a schedule, Amazon Q
  Business won't periodically update the index. Specify a cron- format schedule string or an
  empty string to indicate that the index is updated on demand. You can't specify the
  Schedule parameter when the Type parameter is set to CUSTOM. If you do, you receive a
  ValidationException exception.
- `"tags"`: A list of key-value pairs that identify or categorize the data source
  connector. You can also use tags to help control access to the data source connector. Tag
  keys and values can consist of Unicode letters, digits, white space, and any of the
  following symbols: _ . : / = + - @.
- `"vpcConfiguration"`: Configuration information for an Amazon VPC (Virtual Private Cloud)
  to connect to your data source. For more information, see Using Amazon VPC with Amazon Q
  Business connectors.
"""
function create_data_source(
    applicationId,
    configuration,
    displayName,
    indexId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "POST",
        "/applications/$(applicationId)/indices/$(indexId)/datasources",
        Dict{String,Any}(
            "configuration" => configuration,
            "displayName" => displayName,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_data_source(
    applicationId,
    configuration,
    displayName,
    indexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "POST",
        "/applications/$(applicationId)/indices/$(indexId)/datasources",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "configuration" => configuration,
                    "displayName" => displayName,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_index(application_id, display_name)
    create_index(application_id, display_name, params::Dict{String,<:Any})

Creates an Amazon Q Business index. To determine if index creation has completed, check the
Status field returned from a call to DescribeIndex. The Status field is set to ACTIVE when
the index is ready to use. Once the index is active, you can index your documents using the
 BatchPutDocument  API or the  CreateDataSource  API.

# Arguments
- `application_id`: The identifier of the Amazon Q Business application using the index.
- `display_name`: A name for the Amazon Q Business index.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"capacityConfiguration"`: The capacity units you want to provision for your index. You
  can add and remove capacity to fit your usage needs.
- `"clientToken"`: A token that you provide to identify the request to create an index.
  Multiple calls to the CreateIndex API with the same client token will create only one index.
- `"description"`: A description for the Amazon Q Business index.
- `"tags"`: A list of key-value pairs that identify or categorize the index. You can also
  use tags to help control access to the index. Tag keys and values can consist of Unicode
  letters, digits, white space, and any of the following symbols: _ . : / = + - @.
- `"type"`: The index type that's suitable for your needs. For more information on what's
  included in each type of index, see Amazon Q Business tiers.
"""
function create_index(
    applicationId, displayName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qbusiness(
        "POST",
        "/applications/$(applicationId)/indices",
        Dict{String,Any}("displayName" => displayName, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_index(
    applicationId,
    displayName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "POST",
        "/applications/$(applicationId)/indices",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "displayName" => displayName, "clientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_plugin(application_id, auth_configuration, display_name, type)
    create_plugin(application_id, auth_configuration, display_name, type, params::Dict{String,<:Any})

Creates an Amazon Q Business plugin.

# Arguments
- `application_id`: The identifier of the application that will contain the plugin.
- `auth_configuration`:
- `display_name`: A the name for your plugin.
- `type`: The type of plugin you want to create.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A token that you provide to identify the request to create your Amazon Q
  Business plugin.
- `"customPluginConfiguration"`: Contains configuration for a custom plugin.
- `"serverUrl"`: The source URL used for plugin configuration.
- `"tags"`: A list of key-value pairs that identify or categorize the data source
  connector. You can also use tags to help control access to the data source connector. Tag
  keys and values can consist of Unicode letters, digits, white space, and any of the
  following symbols: _ . : / = + - @.
"""
function create_plugin(
    applicationId,
    authConfiguration,
    displayName,
    type;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "POST",
        "/applications/$(applicationId)/plugins",
        Dict{String,Any}(
            "authConfiguration" => authConfiguration,
            "displayName" => displayName,
            "type" => type,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_plugin(
    applicationId,
    authConfiguration,
    displayName,
    type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "POST",
        "/applications/$(applicationId)/plugins",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "authConfiguration" => authConfiguration,
                    "displayName" => displayName,
                    "type" => type,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_retriever(application_id, configuration, display_name, type)
    create_retriever(application_id, configuration, display_name, type, params::Dict{String,<:Any})

Adds a retriever to your Amazon Q Business application.

# Arguments
- `application_id`: The identifier of your Amazon Q Business application.
- `configuration`:
- `display_name`: The name of your retriever.
- `type`: The type of retriever you are using.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A token that you provide to identify the request to create your Amazon Q
  Business application retriever.
- `"roleArn"`: The ARN of an IAM role used by Amazon Q Business to access the basic
  authentication credentials stored in a Secrets Manager secret.
- `"tags"`: A list of key-value pairs that identify or categorize the retriever. You can
  also use tags to help control access to the retriever. Tag keys and values can consist of
  Unicode letters, digits, white space, and any of the following symbols: _ . : / = + - @.
"""
function create_retriever(
    applicationId,
    configuration,
    displayName,
    type;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "POST",
        "/applications/$(applicationId)/retrievers",
        Dict{String,Any}(
            "configuration" => configuration,
            "displayName" => displayName,
            "type" => type,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_retriever(
    applicationId,
    configuration,
    displayName,
    type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "POST",
        "/applications/$(applicationId)/retrievers",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "configuration" => configuration,
                    "displayName" => displayName,
                    "type" => type,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_user(application_id, user_id)
    create_user(application_id, user_id, params::Dict{String,<:Any})

Creates a universally unique identifier (UUID) mapped to a list of local user ids within an
application.

# Arguments
- `application_id`: The identifier of the application for which the user mapping will be
  created.
- `user_id`: The user emails attached to a user mapping.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A token that you provide to identify the request to create your Amazon Q
  Business user mapping.
- `"userAliases"`: The list of user aliases in the mapping.
"""
function create_user(
    applicationId, userId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qbusiness(
        "POST",
        "/applications/$(applicationId)/users",
        Dict{String,Any}("userId" => userId, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_user(
    applicationId,
    userId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "POST",
        "/applications/$(applicationId)/users",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("userId" => userId, "clientToken" => string(uuid4())),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_web_experience(application_id)
    create_web_experience(application_id, params::Dict{String,<:Any})

Creates an Amazon Q Business web experience.

# Arguments
- `application_id`: The identifier of the Amazon Q Business web experience.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A token you provide to identify a request to create an Amazon Q Business
  web experience.
- `"roleArn"`: The Amazon Resource Name (ARN) of the service role attached to your web
  experience.
- `"samplePromptsControlMode"`: Determines whether sample prompts are enabled in the web
  experience for an end user.
- `"subtitle"`: A subtitle to personalize your Amazon Q Business web experience.
- `"tags"`: A list of key-value pairs that identify or categorize your Amazon Q Business
  web experience. You can also use tags to help control access to the web experience. Tag
  keys and values can consist of Unicode letters, digits, white space, and any of the
  following symbols: _ . : / = + - @.
- `"title"`: The title for your Amazon Q Business web experience.
- `"welcomeMessage"`: The customized welcome message for end users of an Amazon Q Business
  web experience.
"""
function create_web_experience(
    applicationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qbusiness(
        "POST",
        "/applications/$(applicationId)/experiences",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_web_experience(
    applicationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "POST",
        "/applications/$(applicationId)/experiences",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_application(application_id)
    delete_application(application_id, params::Dict{String,<:Any})

Deletes an Amazon Q Business application.

# Arguments
- `application_id`: The identifier of the Amazon Q Business application.

"""
function delete_application(
    applicationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qbusiness(
        "DELETE",
        "/applications/$(applicationId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_application(
    applicationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "DELETE",
        "/applications/$(applicationId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_chat_controls_configuration(application_id)
    delete_chat_controls_configuration(application_id, params::Dict{String,<:Any})

Deletes chat controls configured for an existing Amazon Q Business application.

# Arguments
- `application_id`: The identifier of the application the chat controls have been
  configured for.

"""
function delete_chat_controls_configuration(
    applicationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qbusiness(
        "DELETE",
        "/applications/$(applicationId)/chatcontrols";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_chat_controls_configuration(
    applicationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "DELETE",
        "/applications/$(applicationId)/chatcontrols",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_conversation(application_id, conversation_id)
    delete_conversation(application_id, conversation_id, params::Dict{String,<:Any})

Deletes an Amazon Q Business web experience conversation.

# Arguments
- `application_id`: The identifier of the Amazon Q Business application associated with the
  conversation.
- `conversation_id`: The identifier of the Amazon Q Business web experience conversation
  being deleted.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"userId"`: The identifier of the user who is deleting the conversation.
"""
function delete_conversation(
    applicationId, conversationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qbusiness(
        "DELETE",
        "/applications/$(applicationId)/conversations/$(conversationId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_conversation(
    applicationId,
    conversationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "DELETE",
        "/applications/$(applicationId)/conversations/$(conversationId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_data_source(application_id, data_source_id, index_id)
    delete_data_source(application_id, data_source_id, index_id, params::Dict{String,<:Any})

Deletes an Amazon Q Business data source connector. While the data source is being deleted,
the Status field returned by a call to the DescribeDataSource API is set to DELETING.

# Arguments
- `application_id`: The identifier of the Amazon Q Business application used with the data
  source connector.
- `data_source_id`: The identifier of the data source connector that you want to delete.
- `index_id`: The identifier of the index used with the data source connector.

"""
function delete_data_source(
    applicationId, dataSourceId, indexId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qbusiness(
        "DELETE",
        "/applications/$(applicationId)/indices/$(indexId)/datasources/$(dataSourceId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_data_source(
    applicationId,
    dataSourceId,
    indexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "DELETE",
        "/applications/$(applicationId)/indices/$(indexId)/datasources/$(dataSourceId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_group(application_id, group_name, index_id)
    delete_group(application_id, group_name, index_id, params::Dict{String,<:Any})

Deletes a group so that all users and sub groups that belong to the group can no longer
access documents only available to that group. For example, after deleting the group
\"Summer Interns\", all interns who belonged to that group no longer see intern-only
documents in their chat results.  If you want to delete, update, or replace users or sub
groups of a group, you need to use the PutGroup operation. For example, if a user in the
group \"Engineering\" leaves the engineering team and another user takes their place, you
provide an updated list of users or sub groups that belong to the \"Engineering\" group
when calling PutGroup.

# Arguments
- `application_id`: The identifier of the application in which the group mapping belongs.
- `group_name`: The name of the group you want to delete.
- `index_id`: The identifier of the index you want to delete the group from.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"dataSourceId"`: The identifier of the data source linked to the group A group can be
  tied to multiple data sources. You can delete a group from accessing documents in a certain
  data source. For example, the groups \"Research\", \"Engineering\", and \"Sales and
  Marketing\" are all tied to the company's documents stored in the data sources Confluence
  and Salesforce. You want to delete \"Research\" and \"Engineering\" groups from Salesforce,
  so that these groups cannot access customer-related documents stored in Salesforce. Only
  \"Sales and Marketing\" should access documents in the Salesforce data source.
"""
function delete_group(
    applicationId, groupName, indexId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qbusiness(
        "DELETE",
        "/applications/$(applicationId)/indices/$(indexId)/groups/$(groupName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_group(
    applicationId,
    groupName,
    indexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "DELETE",
        "/applications/$(applicationId)/indices/$(indexId)/groups/$(groupName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_index(application_id, index_id)
    delete_index(application_id, index_id, params::Dict{String,<:Any})

Deletes an Amazon Q Business index.

# Arguments
- `application_id`: The identifier of the Amazon Q Business application the Amazon Q
  Business index is linked to.
- `index_id`: The identifier of the Amazon Q Business index.

"""
function delete_index(
    applicationId, indexId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qbusiness(
        "DELETE",
        "/applications/$(applicationId)/indices/$(indexId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_index(
    applicationId,
    indexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "DELETE",
        "/applications/$(applicationId)/indices/$(indexId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_plugin(application_id, plugin_id)
    delete_plugin(application_id, plugin_id, params::Dict{String,<:Any})

Deletes an Amazon Q Business plugin.

# Arguments
- `application_id`: The identifier the application attached to the Amazon Q Business plugin.
- `plugin_id`: The identifier of the plugin being deleted.

"""
function delete_plugin(
    applicationId, pluginId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qbusiness(
        "DELETE",
        "/applications/$(applicationId)/plugins/$(pluginId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_plugin(
    applicationId,
    pluginId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "DELETE",
        "/applications/$(applicationId)/plugins/$(pluginId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_retriever(application_id, retriever_id)
    delete_retriever(application_id, retriever_id, params::Dict{String,<:Any})

Deletes the retriever used by an Amazon Q Business application.

# Arguments
- `application_id`: The identifier of the Amazon Q Business application using the retriever.
- `retriever_id`: The identifier of the retriever being deleted.

"""
function delete_retriever(
    applicationId, retrieverId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qbusiness(
        "DELETE",
        "/applications/$(applicationId)/retrievers/$(retrieverId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_retriever(
    applicationId,
    retrieverId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "DELETE",
        "/applications/$(applicationId)/retrievers/$(retrieverId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_user(application_id, user_id)
    delete_user(application_id, user_id, params::Dict{String,<:Any})

Deletes a user by email id.

# Arguments
- `application_id`: The identifier of the application from which the user is being deleted.
- `user_id`: The user email being deleted.

"""
function delete_user(
    applicationId, userId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qbusiness(
        "DELETE",
        "/applications/$(applicationId)/users/$(userId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_user(
    applicationId,
    userId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "DELETE",
        "/applications/$(applicationId)/users/$(userId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_web_experience(application_id, web_experience_id)
    delete_web_experience(application_id, web_experience_id, params::Dict{String,<:Any})

Deletes an Amazon Q Business web experience.

# Arguments
- `application_id`: The identifier of the Amazon Q Business application linked to the
  Amazon Q Business web experience.
- `web_experience_id`: The identifier of the Amazon Q Business web experience being deleted.

"""
function delete_web_experience(
    applicationId, webExperienceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qbusiness(
        "DELETE",
        "/applications/$(applicationId)/experiences/$(webExperienceId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_web_experience(
    applicationId,
    webExperienceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "DELETE",
        "/applications/$(applicationId)/experiences/$(webExperienceId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_application(application_id)
    get_application(application_id, params::Dict{String,<:Any})

Gets information about an existing Amazon Q Business application.

# Arguments
- `application_id`: The identifier of the Amazon Q Business application.

"""
function get_application(applicationId; aws_config::AbstractAWSConfig=current_aws_config())
    return qbusiness(
        "GET",
        "/applications/$(applicationId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_application(
    applicationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "GET",
        "/applications/$(applicationId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_chat_controls_configuration(application_id)
    get_chat_controls_configuration(application_id, params::Dict{String,<:Any})

Gets information about an chat controls configured for an existing Amazon Q Business
application.

# Arguments
- `application_id`: The identifier of the application for which the chat controls are
  configured.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of configured chat controls to return.
- `"nextToken"`: If the maxResults response was incomplete because there is more data to
  retrieve, Amazon Q Business returns a pagination token in the response. You can use this
  pagination token to retrieve the next set of Amazon Q Business chat controls configured.
"""
function get_chat_controls_configuration(
    applicationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qbusiness(
        "GET",
        "/applications/$(applicationId)/chatcontrols";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_chat_controls_configuration(
    applicationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "GET",
        "/applications/$(applicationId)/chatcontrols",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_data_source(application_id, data_source_id, index_id)
    get_data_source(application_id, data_source_id, index_id, params::Dict{String,<:Any})

Gets information about an existing Amazon Q Business data source connector.

# Arguments
- `application_id`: The identifier of the Amazon Q Business application.
- `data_source_id`: The identifier of the data source connector.
- `index_id`: The identfier of the index used with the data source connector.

"""
function get_data_source(
    applicationId, dataSourceId, indexId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qbusiness(
        "GET",
        "/applications/$(applicationId)/indices/$(indexId)/datasources/$(dataSourceId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_data_source(
    applicationId,
    dataSourceId,
    indexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "GET",
        "/applications/$(applicationId)/indices/$(indexId)/datasources/$(dataSourceId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_group(application_id, group_name, index_id)
    get_group(application_id, group_name, index_id, params::Dict{String,<:Any})

Describes a group by group name.

# Arguments
- `application_id`: The identifier of the application id the group is attached to.
- `group_name`: The name of the group.
- `index_id`: The identifier of the index the group is attached to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"dataSourceId"`: The identifier of the data source the group is attached to.
"""
function get_group(
    applicationId, groupName, indexId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qbusiness(
        "GET",
        "/applications/$(applicationId)/indices/$(indexId)/groups/$(groupName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_group(
    applicationId,
    groupName,
    indexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "GET",
        "/applications/$(applicationId)/indices/$(indexId)/groups/$(groupName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_index(application_id, index_id)
    get_index(application_id, index_id, params::Dict{String,<:Any})

Gets information about an existing Amazon Q Business index.

# Arguments
- `application_id`: The identifier of the Amazon Q Business application connected to the
  index.
- `index_id`: The identifier of the Amazon Q Business index you want information on.

"""
function get_index(
    applicationId, indexId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qbusiness(
        "GET",
        "/applications/$(applicationId)/indices/$(indexId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_index(
    applicationId,
    indexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "GET",
        "/applications/$(applicationId)/indices/$(indexId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_plugin(application_id, plugin_id)
    get_plugin(application_id, plugin_id, params::Dict{String,<:Any})

Gets information about an existing Amazon Q Business plugin.

# Arguments
- `application_id`: The identifier of the application which contains the plugin.
- `plugin_id`: The identifier of the plugin.

"""
function get_plugin(
    applicationId, pluginId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qbusiness(
        "GET",
        "/applications/$(applicationId)/plugins/$(pluginId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_plugin(
    applicationId,
    pluginId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "GET",
        "/applications/$(applicationId)/plugins/$(pluginId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_retriever(application_id, retriever_id)
    get_retriever(application_id, retriever_id, params::Dict{String,<:Any})

Gets information about an existing retriever used by an Amazon Q Business application.

# Arguments
- `application_id`: The identifier of the Amazon Q Business application using the retriever.
- `retriever_id`: The identifier of the retriever.

"""
function get_retriever(
    applicationId, retrieverId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qbusiness(
        "GET",
        "/applications/$(applicationId)/retrievers/$(retrieverId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_retriever(
    applicationId,
    retrieverId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "GET",
        "/applications/$(applicationId)/retrievers/$(retrieverId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_user(application_id, user_id)
    get_user(application_id, user_id, params::Dict{String,<:Any})

Describes the universally unique identifier (UUID) associated with a local user in a data
source.

# Arguments
- `application_id`: The identifier of the application connected to the user.
- `user_id`: The user email address attached to the user.

"""
function get_user(applicationId, userId; aws_config::AbstractAWSConfig=current_aws_config())
    return qbusiness(
        "GET",
        "/applications/$(applicationId)/users/$(userId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_user(
    applicationId,
    userId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "GET",
        "/applications/$(applicationId)/users/$(userId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_web_experience(application_id, web_experience_id)
    get_web_experience(application_id, web_experience_id, params::Dict{String,<:Any})

Gets information about an existing Amazon Q Business web experience.

# Arguments
- `application_id`: The identifier of the Amazon Q Business application linked to the web
  experience.
- `web_experience_id`: The identifier of the Amazon Q Business web experience.

"""
function get_web_experience(
    applicationId, webExperienceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qbusiness(
        "GET",
        "/applications/$(applicationId)/experiences/$(webExperienceId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_web_experience(
    applicationId,
    webExperienceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "GET",
        "/applications/$(applicationId)/experiences/$(webExperienceId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_applications()
    list_applications(params::Dict{String,<:Any})

Lists Amazon Q Business applications.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of Amazon Q Business applications to return.
- `"nextToken"`: If the maxResults response was incomplete because there is more data to
  retrieve, Amazon Q Business returns a pagination token in the response. You can use this
  pagination token to retrieve the next set of Amazon Q Business applications.
"""
function list_applications(; aws_config::AbstractAWSConfig=current_aws_config())
    return qbusiness(
        "GET", "/applications"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_applications(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qbusiness(
        "GET",
        "/applications",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_conversations(application_id)
    list_conversations(application_id, params::Dict{String,<:Any})

Lists one or more Amazon Q Business conversations.

# Arguments
- `application_id`: The identifier of the Amazon Q Business application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of Amazon Q Business conversations to return.
- `"nextToken"`: If the maxResults response was incomplete because there is more data to
  retrieve, Amazon Q Business returns a pagination token in the response. You can use this
  pagination token to retrieve the next set of Amazon Q Business conversations.
- `"userId"`: The identifier of the user involved in the Amazon Q Business web experience
  conversation.
"""
function list_conversations(
    applicationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qbusiness(
        "GET",
        "/applications/$(applicationId)/conversations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_conversations(
    applicationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "GET",
        "/applications/$(applicationId)/conversations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_data_source_sync_jobs(application_id, data_source_id, index_id)
    list_data_source_sync_jobs(application_id, data_source_id, index_id, params::Dict{String,<:Any})

Get information about an Amazon Q Business data source connector synchronization.

# Arguments
- `application_id`: The identifier of the Amazon Q Business application connected to the
  data source.
- `data_source_id`:  The identifier of the data source connector.
- `index_id`: The identifier of the index used with the Amazon Q Business data source
  connector.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"endTime"`:  The end time of the data source connector sync.
- `"maxResults"`: The maximum number of synchronization jobs to return in the response.
- `"nextToken"`: If the maxResults response was incpmplete because there is more data to
  retriever, Amazon Q Business returns a pagination token in the response. You can use this
  pagination token to retrieve the next set of responses.
- `"startTime"`:  The start time of the data source connector sync.
- `"syncStatus"`: Only returns synchronization jobs with the Status field equal to the
  specified status.
"""
function list_data_source_sync_jobs(
    applicationId, dataSourceId, indexId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qbusiness(
        "GET",
        "/applications/$(applicationId)/indices/$(indexId)/datasources/$(dataSourceId)/syncjobs";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_data_source_sync_jobs(
    applicationId,
    dataSourceId,
    indexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "GET",
        "/applications/$(applicationId)/indices/$(indexId)/datasources/$(dataSourceId)/syncjobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_data_sources(application_id, index_id)
    list_data_sources(application_id, index_id, params::Dict{String,<:Any})

Lists the Amazon Q Business data source connectors that you have created.

# Arguments
- `application_id`: The identifier of the Amazon Q Business application linked to the data
  source connectors.
- `index_id`: The identifier of the index used with one or more data source connectors.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of data source connectors to return.
- `"nextToken"`: If the maxResults response was incomplete because there is more data to
  retrieve, Amazon Q Business returns a pagination token in the response. You can use this
  pagination token to retrieve the next set of Amazon Q Business data source connectors.
"""
function list_data_sources(
    applicationId, indexId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qbusiness(
        "GET",
        "/applications/$(applicationId)/indices/$(indexId)/datasources";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_data_sources(
    applicationId,
    indexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "GET",
        "/applications/$(applicationId)/indices/$(indexId)/datasources",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_documents(application_id, index_id)
    list_documents(application_id, index_id, params::Dict{String,<:Any})

A list of documents attached to an index.

# Arguments
- `application_id`: The identifier of the application id the documents are attached to.
- `index_id`: The identifier of the index the documents are attached to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"dataSourceIds"`: The identifier of the data sources the documents are attached to.
- `"maxResults"`: The maximum number of documents to return.
- `"nextToken"`: If the maxResults response was incomplete because there is more data to
  retrieve, Amazon Q Business returns a pagination token in the response. You can use this
  pagination token to retrieve the next set of documents.
"""
function list_documents(
    applicationId, indexId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qbusiness(
        "GET",
        "/applications/$(applicationId)/index/$(indexId)/documents";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_documents(
    applicationId,
    indexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "GET",
        "/applications/$(applicationId)/index/$(indexId)/documents",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_groups(application_id, index_id, updated_earlier_than)
    list_groups(application_id, index_id, updated_earlier_than, params::Dict{String,<:Any})

Provides a list of groups that are mapped to users.

# Arguments
- `application_id`: The identifier of the application for getting a list of groups mapped
  to users.
- `index_id`: The identifier of the index for getting a list of groups mapped to users.
- `updated_earlier_than`: The timestamp identifier used for the latest PUT or DELETE action
  for mapping users to their groups.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"dataSourceId"`: The identifier of the data source for getting a list of groups mapped
  to users.
- `"maxResults"`: The maximum number of returned groups that are mapped to users.
- `"nextToken"`: If the previous response was incomplete (because there is more data to
  retrieve), Amazon Q Business returns a pagination token in the response. You can use this
  pagination token to retrieve the next set of groups that are mapped to users.
"""
function list_groups(
    applicationId,
    indexId,
    updatedEarlierThan;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "GET",
        "/applications/$(applicationId)/indices/$(indexId)/groups",
        Dict{String,Any}("updatedEarlierThan" => updatedEarlierThan);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_groups(
    applicationId,
    indexId,
    updatedEarlierThan,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "GET",
        "/applications/$(applicationId)/indices/$(indexId)/groups",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("updatedEarlierThan" => updatedEarlierThan), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_indices(application_id)
    list_indices(application_id, params::Dict{String,<:Any})

Lists the Amazon Q Business indices you have created.

# Arguments
- `application_id`: The identifier of the Amazon Q Business application connected to the
  index.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of indices to return.
- `"nextToken"`: If the maxResults response was incomplete because there is more data to
  retrieve, Amazon Q Business returns a pagination token in the response. You can use this
  pagination token to retrieve the next set of Amazon Q Business indices.
"""
function list_indices(applicationId; aws_config::AbstractAWSConfig=current_aws_config())
    return qbusiness(
        "GET",
        "/applications/$(applicationId)/indices";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_indices(
    applicationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "GET",
        "/applications/$(applicationId)/indices",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_messages(application_id, conversation_id)
    list_messages(application_id, conversation_id, params::Dict{String,<:Any})

Gets a list of messages associated with an Amazon Q Business web experience.

# Arguments
- `application_id`: The identifier for the Amazon Q Business application.
- `conversation_id`: The identifier of the Amazon Q Business web experience conversation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of messages to return.
- `"nextToken"`: If the number of retrievers returned exceeds maxResults, Amazon Q Business
  returns a next token as a pagination token to retrieve the next set of messages.
- `"userId"`: The identifier of the user involved in the Amazon Q Business web experience
  conversation.
"""
function list_messages(
    applicationId, conversationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qbusiness(
        "GET",
        "/applications/$(applicationId)/conversations/$(conversationId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_messages(
    applicationId,
    conversationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "GET",
        "/applications/$(applicationId)/conversations/$(conversationId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_plugins(application_id)
    list_plugins(application_id, params::Dict{String,<:Any})

Lists configured Amazon Q Business plugins.

# Arguments
- `application_id`: The identifier of the application the plugin is attached to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of documents to return.
- `"nextToken"`: If the maxResults response was incomplete because there is more data to
  retrieve, Amazon Q Business returns a pagination token in the response. You can use this
  pagination token to retrieve the next set of plugins.
"""
function list_plugins(applicationId; aws_config::AbstractAWSConfig=current_aws_config())
    return qbusiness(
        "GET",
        "/applications/$(applicationId)/plugins";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_plugins(
    applicationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "GET",
        "/applications/$(applicationId)/plugins",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_retrievers(application_id)
    list_retrievers(application_id, params::Dict{String,<:Any})

Lists the retriever used by an Amazon Q Business application.

# Arguments
- `application_id`: The identifier of the Amazon Q Business application using the retriever.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of retrievers returned.
- `"nextToken"`: If the number of retrievers returned exceeds maxResults, Amazon Q Business
  returns a next token as a pagination token to retrieve the next set of retrievers.
"""
function list_retrievers(applicationId; aws_config::AbstractAWSConfig=current_aws_config())
    return qbusiness(
        "GET",
        "/applications/$(applicationId)/retrievers";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_retrievers(
    applicationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "GET",
        "/applications/$(applicationId)/retrievers",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Gets a list of tags associated with a specified resource. Amazon Q Business applications
and data sources can have tags associated with them.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the Amazon Q Business application or
  data source to get a list of tags for.

"""
function list_tags_for_resource(
    resourceARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qbusiness(
        "GET",
        "/v1/tags/$(resourceARN)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "GET",
        "/v1/tags/$(resourceARN)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_web_experiences(application_id)
    list_web_experiences(application_id, params::Dict{String,<:Any})

Lists one or more Amazon Q Business Web Experiences.

# Arguments
- `application_id`: The identifier of the Amazon Q Business application linked to the
  listed web experiences.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of Amazon Q Business Web Experiences to return.
- `"nextToken"`: If the maxResults response was incomplete because there is more data to
  retrieve, Amazon Q Business returns a pagination token in the response. You can use this
  pagination token to retrieve the next set of Amazon Q Business conversations.
"""
function list_web_experiences(
    applicationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qbusiness(
        "GET",
        "/applications/$(applicationId)/experiences";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_web_experiences(
    applicationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "GET",
        "/applications/$(applicationId)/experiences",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_feedback(application_id, conversation_id, message_id)
    put_feedback(application_id, conversation_id, message_id, params::Dict{String,<:Any})

Enables your end user to provide feedback on their Amazon Q Business generated chat
responses.

# Arguments
- `application_id`: The identifier of the application associated with the feedback.
- `conversation_id`: The identifier of the conversation the feedback is attached to.
- `message_id`: The identifier of the chat message that the feedback was given for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"messageCopiedAt"`: The timestamp for when the feedback was recorded.
- `"messageUsefulness"`: The feedback usefulness value given by the user to the chat
  message.
- `"userId"`: The identifier of the user giving the feedback.
"""
function put_feedback(
    applicationId,
    conversationId,
    messageId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "POST",
        "/applications/$(applicationId)/conversations/$(conversationId)/messages/$(messageId)/feedback";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_feedback(
    applicationId,
    conversationId,
    messageId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "POST",
        "/applications/$(applicationId)/conversations/$(conversationId)/messages/$(messageId)/feedback",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_group(application_id, group_members, group_name, index_id, type)
    put_group(application_id, group_members, group_name, index_id, type, params::Dict{String,<:Any})

Create, or updates, a mapping of users—who have access to a document—to groups. You can
also map sub groups to groups. For example, the group \"Company Intellectual Property
Teams\" includes sub groups \"Research\" and \"Engineering\". These sub groups include
their own list of users or people who work in these teams. Only users who work in research
and engineering, and therefore belong in the intellectual property group, can see
top-secret company documents in their Amazon Q Business chat results.

# Arguments
- `application_id`: The identifier of the application in which the user and group mapping
  belongs.
- `group_members`:
- `group_name`: The list that contains your users or sub groups that belong the same group.
  For example, the group \"Company\" includes the user \"CEO\" and the sub groups
  \"Research\", \"Engineering\", and \"Sales and Marketing\". If you have more than 1000
  users and/or sub groups for a single group, you need to provide the path to the S3 file
  that lists your users and sub groups for a group. Your sub groups can contain more than
  1000 users, but the list of sub groups that belong to a group (and/or users) must be no
  more than 1000.
- `index_id`: The identifier of the index in which you want to map users to their groups.
- `type`: The type of the group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"dataSourceId"`: The identifier of the data source for which you want to map users to
  their groups. This is useful if a group is tied to multiple data sources, but you only want
  the group to access documents of a certain data source. For example, the groups
  \"Research\", \"Engineering\", and \"Sales and Marketing\" are all tied to the company's
  documents stored in the data sources Confluence and Salesforce. However, \"Sales and
  Marketing\" team only needs access to customer-related documents stored in Salesforce.
"""
function put_group(
    applicationId,
    groupMembers,
    groupName,
    indexId,
    type;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "PUT",
        "/applications/$(applicationId)/indices/$(indexId)/groups",
        Dict{String,Any}(
            "groupMembers" => groupMembers, "groupName" => groupName, "type" => type
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_group(
    applicationId,
    groupMembers,
    groupName,
    indexId,
    type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "PUT",
        "/applications/$(applicationId)/indices/$(indexId)/groups",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "groupMembers" => groupMembers, "groupName" => groupName, "type" => type
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_data_source_sync_job(application_id, data_source_id, index_id)
    start_data_source_sync_job(application_id, data_source_id, index_id, params::Dict{String,<:Any})

Starts a data source connector synchronization job. If a synchronization job is already in
progress, Amazon Q Business returns a ConflictException.

# Arguments
- `application_id`: The identifier of Amazon Q Business application the data source is
  connected to.
- `data_source_id`:  The identifier of the data source connector.
- `index_id`: The identifier of the index used with the data source connector.

"""
function start_data_source_sync_job(
    applicationId, dataSourceId, indexId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qbusiness(
        "POST",
        "/applications/$(applicationId)/indices/$(indexId)/datasources/$(dataSourceId)/startsync";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_data_source_sync_job(
    applicationId,
    dataSourceId,
    indexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "POST",
        "/applications/$(applicationId)/indices/$(indexId)/datasources/$(dataSourceId)/startsync",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_data_source_sync_job(application_id, data_source_id, index_id)
    stop_data_source_sync_job(application_id, data_source_id, index_id, params::Dict{String,<:Any})

Stops an Amazon Q Business data source connector synchronization job already in progress.

# Arguments
- `application_id`: The identifier of the Amazon Q Business application that the data
  source is connected to.
- `data_source_id`:  The identifier of the data source connector.
- `index_id`: The identifier of the index used with the Amazon Q Business data source
  connector.

"""
function stop_data_source_sync_job(
    applicationId, dataSourceId, indexId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qbusiness(
        "POST",
        "/applications/$(applicationId)/indices/$(indexId)/datasources/$(dataSourceId)/stopsync";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_data_source_sync_job(
    applicationId,
    dataSourceId,
    indexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "POST",
        "/applications/$(applicationId)/indices/$(indexId)/datasources/$(dataSourceId)/stopsync",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds the specified tag to the specified Amazon Q Business application or data source
resource. If the tag already exists, the existing value is replaced with the new value.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the Amazon Q Business application or
  data source to tag.
- `tags`: A list of tag keys to add to the Amazon Q Business application or data source. If
  a tag already exists, the existing value is replaced with the new value.

"""
function tag_resource(resourceARN, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return qbusiness(
        "POST",
        "/v1/tags/$(resourceARN)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceARN,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "POST",
        "/v1/tags/$(resourceARN)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes a tag from an Amazon Q Business application or a data source.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the Amazon Q Business application, or
  data source to remove the tag from.
- `tag_keys`: A list of tag keys to remove from the Amazon Q Business application or data
  source. If a tag key does not exist on the resource, it is ignored.

"""
function untag_resource(
    resourceARN, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qbusiness(
        "DELETE",
        "/v1/tags/$(resourceARN)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceARN,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "DELETE",
        "/v1/tags/$(resourceARN)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_application(application_id)
    update_application(application_id, params::Dict{String,<:Any})

Updates an existing Amazon Q Business application.

# Arguments
- `application_id`: The identifier of the Amazon Q Business application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"attachmentsConfiguration"`: An option to allow end users to upload files directly
  during chat.
- `"description"`: A description for the Amazon Q Business application.
- `"displayName"`: A name for the Amazon Q Business application.
- `"identityCenterInstanceArn"`:  The Amazon Resource Name (ARN) of the IAM Identity Center
  instance you are either creating for—or connecting to—your Amazon Q Business
  application.
- `"qAppsConfiguration"`: An option to allow end users to create and use Amazon Q Apps in
  the web experience.
- `"roleArn"`: An Amazon Web Services Identity and Access Management (IAM) role that gives
  Amazon Q Business permission to access Amazon CloudWatch logs and metrics.
"""
function update_application(
    applicationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qbusiness(
        "PUT",
        "/applications/$(applicationId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_application(
    applicationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "PUT",
        "/applications/$(applicationId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_chat_controls_configuration(application_id)
    update_chat_controls_configuration(application_id, params::Dict{String,<:Any})

Updates an set of chat controls configured for an existing Amazon Q Business application.

# Arguments
- `application_id`: The identifier of the application for which the chat controls are
  configured.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"blockedPhrasesConfigurationUpdate"`: The phrases blocked from chat by your chat control
  configuration.
- `"clientToken"`: A token that you provide to identify the request to update a Amazon Q
  Business application chat configuration.
- `"creatorModeConfiguration"`: The configuration details for CREATOR_MODE.
- `"responseScope"`: The response scope configured for your application. This determines
  whether your application uses its retrieval augmented generation (RAG) system to generate
  answers only from your enterprise data, or also uses the large language models (LLM)
  knowledge to respons to end user questions in chat.
- `"topicConfigurationsToCreateOrUpdate"`: The configured topic specific chat controls you
  want to update.
- `"topicConfigurationsToDelete"`: The configured topic specific chat controls you want to
  delete.
"""
function update_chat_controls_configuration(
    applicationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qbusiness(
        "PATCH",
        "/applications/$(applicationId)/chatcontrols",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_chat_controls_configuration(
    applicationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "PATCH",
        "/applications/$(applicationId)/chatcontrols",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_data_source(application_id, data_source_id, index_id)
    update_data_source(application_id, data_source_id, index_id, params::Dict{String,<:Any})

Updates an existing Amazon Q Business data source connector.

# Arguments
- `application_id`:  The identifier of the Amazon Q Business application the data source is
  attached to.
- `data_source_id`: The identifier of the data source connector.
- `index_id`: The identifier of the index attached to the data source connector.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"configuration"`:
- `"description"`: The description of the data source connector.
- `"displayName"`: A name of the data source connector.
- `"documentEnrichmentConfiguration"`:
- `"roleArn"`: The Amazon Resource Name (ARN) of an IAM role with permission to access the
  data source and required resources.
- `"syncSchedule"`: The chosen update frequency for your data source.
- `"vpcConfiguration"`:
"""
function update_data_source(
    applicationId, dataSourceId, indexId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qbusiness(
        "PUT",
        "/applications/$(applicationId)/indices/$(indexId)/datasources/$(dataSourceId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_data_source(
    applicationId,
    dataSourceId,
    indexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "PUT",
        "/applications/$(applicationId)/indices/$(indexId)/datasources/$(dataSourceId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_index(application_id, index_id)
    update_index(application_id, index_id, params::Dict{String,<:Any})

Updates an Amazon Q Business index.

# Arguments
- `application_id`: The identifier of the Amazon Q Business application connected to the
  index.
- `index_id`: The identifier of the Amazon Q Business index.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"capacityConfiguration"`: The storage capacity units you want to provision for your
  Amazon Q Business index. You can add and remove capacity to fit your usage needs.
- `"description"`: The description of the Amazon Q Business index.
- `"displayName"`: The name of the Amazon Q Business index.
- `"documentAttributeConfigurations"`: Configuration information for document metadata or
  fields. Document metadata are fields or attributes associated with your documents. For
  example, the company department name associated with each document. For more information,
  see Understanding document attributes.
"""
function update_index(
    applicationId, indexId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qbusiness(
        "PUT",
        "/applications/$(applicationId)/indices/$(indexId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_index(
    applicationId,
    indexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "PUT",
        "/applications/$(applicationId)/indices/$(indexId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_plugin(application_id, plugin_id)
    update_plugin(application_id, plugin_id, params::Dict{String,<:Any})

Updates an Amazon Q Business plugin.

# Arguments
- `application_id`: The identifier of the application the plugin is attached to.
- `plugin_id`: The identifier of the plugin.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"authConfiguration"`: The authentication configuration the plugin is using.
- `"customPluginConfiguration"`: The configuration for a custom plugin.
- `"displayName"`: The name of the plugin.
- `"serverUrl"`: The source URL used for plugin configuration.
- `"state"`: The status of the plugin.
"""
function update_plugin(
    applicationId, pluginId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qbusiness(
        "PUT",
        "/applications/$(applicationId)/plugins/$(pluginId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_plugin(
    applicationId,
    pluginId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "PUT",
        "/applications/$(applicationId)/plugins/$(pluginId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_retriever(application_id, retriever_id)
    update_retriever(application_id, retriever_id, params::Dict{String,<:Any})

Updates the retriever used for your Amazon Q Business application.

# Arguments
- `application_id`: The identifier of your Amazon Q Business application.
- `retriever_id`: The identifier of your retriever.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"configuration"`:
- `"displayName"`: The name of your retriever.
- `"roleArn"`: The Amazon Resource Name (ARN) of an IAM role with permission to access the
  retriever and required resources.
"""
function update_retriever(
    applicationId, retrieverId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qbusiness(
        "PUT",
        "/applications/$(applicationId)/retrievers/$(retrieverId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_retriever(
    applicationId,
    retrieverId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "PUT",
        "/applications/$(applicationId)/retrievers/$(retrieverId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_user(application_id, user_id)
    update_user(application_id, user_id, params::Dict{String,<:Any})

Updates a information associated with a user id.

# Arguments
- `application_id`: The identifier of the application the user is attached to.
- `user_id`: The email id attached to the user.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"userAliasesToDelete"`: The user aliases attached to the user id that are to be deleted.
- `"userAliasesToUpdate"`: The user aliases attached to the user id that are to be updated.
"""
function update_user(
    applicationId, userId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qbusiness(
        "PUT",
        "/applications/$(applicationId)/users/$(userId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_user(
    applicationId,
    userId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "PUT",
        "/applications/$(applicationId)/users/$(userId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_web_experience(application_id, web_experience_id)
    update_web_experience(application_id, web_experience_id, params::Dict{String,<:Any})

Updates an Amazon Q Business web experience.

# Arguments
- `application_id`: The identifier of the Amazon Q Business application attached to the web
  experience.
- `web_experience_id`: The identifier of the Amazon Q Business web experience.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"authenticationConfiguration"`: The authentication configuration of the Amazon Q
  Business web experience.
- `"roleArn"`: The Amazon Resource Name (ARN) of the role with permission to access the
  Amazon Q Business web experience and required resources.
- `"samplePromptsControlMode"`: Determines whether sample prompts are enabled in the web
  experience for an end user.
- `"subtitle"`: The subtitle of the Amazon Q Business web experience.
- `"title"`: The title of the Amazon Q Business web experience.
- `"welcomeMessage"`: A customized welcome message for an end user in an Amazon Q Business
  web experience.
"""
function update_web_experience(
    applicationId, webExperienceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qbusiness(
        "PUT",
        "/applications/$(applicationId)/experiences/$(webExperienceId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_web_experience(
    applicationId,
    webExperienceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qbusiness(
        "PUT",
        "/applications/$(applicationId)/experiences/$(webExperienceId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: forecastquery
using AWS.Compat
using AWS.UUIDs

"""
    query_forecast(filters, forecast_arn)
    query_forecast(filters, forecast_arn, params::Dict{String,<:Any})

Retrieves a forecast for a single item, filtered by the supplied criteria. The criteria is
a key-value pair. The key is either item_id (or the equivalent non-timestamp, non-target
field) from the TARGET_TIME_SERIES dataset, or one of the forecast dimensions specified as
part of the FeaturizationConfig object. By default, QueryForecast returns the complete date
range for the filtered forecast. You can request a specific date range. To get the full
forecast, use the CreateForecastExportJob operation.  The forecasts generated by Amazon
Forecast are in the same timezone as the dataset that was used to create the predictor.

# Arguments
- `filters`: The filtering criteria to apply when retrieving the forecast. For example, to
  get the forecast for client_21 in the electricity usage dataset, specify the following:
  {\"item_id\" : \"client_21\"}  To get the full forecast, use the CreateForecastExportJob
  operation.
- `forecast_arn`: The Amazon Resource Name (ARN) of the forecast to query.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EndDate"`: The end date for the forecast. Specify the date using this format:
  yyyy-MM-dd'T'HH:mm:ss (ISO 8601 format). For example, 2015-01-01T20:00:00.
- `"NextToken"`: If the result of the previous request was truncated, the response includes
  a NextToken. To retrieve the next set of results, use the token in the next request. Tokens
  expire after 24 hours.
- `"StartDate"`: The start date for the forecast. Specify the date using this format:
  yyyy-MM-dd'T'HH:mm:ss (ISO 8601 format). For example, 2015-01-01T08:00:00.
"""
function query_forecast(
    Filters, ForecastArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return forecastquery(
        "QueryForecast",
        Dict{String,Any}("Filters" => Filters, "ForecastArn" => ForecastArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function query_forecast(
    Filters,
    ForecastArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecastquery(
        "QueryForecast",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Filters" => Filters, "ForecastArn" => ForecastArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    query_what_if_forecast(filters, what_if_forecast_arn)
    query_what_if_forecast(filters, what_if_forecast_arn, params::Dict{String,<:Any})

Retrieves a what-if forecast.

# Arguments
- `filters`: The filtering criteria to apply when retrieving the forecast. For example, to
  get the forecast for client_21 in the electricity usage dataset, specify the following:
  {\"item_id\" : \"client_21\"}  To get the full what-if forecast, use the
  CreateForecastExportJob operation.
- `what_if_forecast_arn`: The Amazon Resource Name (ARN) of the what-if forecast to query.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EndDate"`: The end date for the what-if forecast. Specify the date using this format:
  yyyy-MM-dd'T'HH:mm:ss (ISO 8601 format). For example, 2015-01-01T20:00:00.
- `"NextToken"`: If the result of the previous request was truncated, the response includes
  a NextToken. To retrieve the next set of results, use the token in the next request. Tokens
  expire after 24 hours.
- `"StartDate"`: The start date for the what-if forecast. Specify the date using this
  format: yyyy-MM-dd'T'HH:mm:ss (ISO 8601 format). For example, 2015-01-01T08:00:00.
"""
function query_what_if_forecast(
    Filters, WhatIfForecastArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return forecastquery(
        "QueryWhatIfForecast",
        Dict{String,Any}("Filters" => Filters, "WhatIfForecastArn" => WhatIfForecastArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function query_what_if_forecast(
    Filters,
    WhatIfForecastArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return forecastquery(
        "QueryWhatIfForecast",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Filters" => Filters, "WhatIfForecastArn" => WhatIfForecastArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: mediaconnect
using AWS.Compat
using AWS.UUIDs

"""
    add_bridge_outputs(bridge_arn, outputs)
    add_bridge_outputs(bridge_arn, outputs, params::Dict{String,<:Any})

Adds outputs to an existing bridge.

# Arguments
- `bridge_arn`: The ARN of the bridge that you want to update.
- `outputs`: The outputs that you want to add to this bridge.

"""
function add_bridge_outputs(
    bridgeArn, outputs; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconnect(
        "POST",
        "/v1/bridges/$(bridgeArn)/outputs",
        Dict{String,Any}("outputs" => outputs);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_bridge_outputs(
    bridgeArn,
    outputs,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediaconnect(
        "POST",
        "/v1/bridges/$(bridgeArn)/outputs",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("outputs" => outputs), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    add_bridge_sources(bridge_arn, sources)
    add_bridge_sources(bridge_arn, sources, params::Dict{String,<:Any})

Adds sources to an existing bridge.

# Arguments
- `bridge_arn`: The ARN of the bridge that you want to update.
- `sources`: The sources that you want to add to this bridge.

"""
function add_bridge_sources(
    bridgeArn, sources; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconnect(
        "POST",
        "/v1/bridges/$(bridgeArn)/sources",
        Dict{String,Any}("sources" => sources);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_bridge_sources(
    bridgeArn,
    sources,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediaconnect(
        "POST",
        "/v1/bridges/$(bridgeArn)/sources",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("sources" => sources), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    add_flow_media_streams(flow_arn, media_streams)
    add_flow_media_streams(flow_arn, media_streams, params::Dict{String,<:Any})

Adds media streams to an existing flow. After you add a media stream to a flow, you can
associate it with a source and/or an output that uses the ST 2110 JPEG XS or CDI protocol.

# Arguments
- `flow_arn`: The Amazon Resource Name (ARN) of the flow.
- `media_streams`: The media streams that you want to add to the flow.

"""
function add_flow_media_streams(
    flowArn, mediaStreams; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconnect(
        "POST",
        "/v1/flows/$(flowArn)/mediaStreams",
        Dict{String,Any}("mediaStreams" => mediaStreams);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_flow_media_streams(
    flowArn,
    mediaStreams,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediaconnect(
        "POST",
        "/v1/flows/$(flowArn)/mediaStreams",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("mediaStreams" => mediaStreams), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    add_flow_outputs(flow_arn, outputs)
    add_flow_outputs(flow_arn, outputs, params::Dict{String,<:Any})

Adds outputs to an existing flow. You can create up to 50 outputs per flow.

# Arguments
- `flow_arn`: The flow that you want to add outputs to.
- `outputs`: A list of outputs that you want to add.

"""
function add_flow_outputs(
    flowArn, outputs; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconnect(
        "POST",
        "/v1/flows/$(flowArn)/outputs",
        Dict{String,Any}("outputs" => outputs);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_flow_outputs(
    flowArn,
    outputs,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediaconnect(
        "POST",
        "/v1/flows/$(flowArn)/outputs",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("outputs" => outputs), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    add_flow_sources(flow_arn, sources)
    add_flow_sources(flow_arn, sources, params::Dict{String,<:Any})

Adds Sources to flow

# Arguments
- `flow_arn`: The flow that you want to mutate.
- `sources`: A list of sources that you want to add.

"""
function add_flow_sources(
    flowArn, sources; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconnect(
        "POST",
        "/v1/flows/$(flowArn)/source",
        Dict{String,Any}("sources" => sources);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_flow_sources(
    flowArn,
    sources,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediaconnect(
        "POST",
        "/v1/flows/$(flowArn)/source",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("sources" => sources), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    add_flow_vpc_interfaces(flow_arn, vpc_interfaces)
    add_flow_vpc_interfaces(flow_arn, vpc_interfaces, params::Dict{String,<:Any})

Adds VPC interfaces to flow

# Arguments
- `flow_arn`: The flow that you want to mutate.
- `vpc_interfaces`: A list of VPC interfaces that you want to add.

"""
function add_flow_vpc_interfaces(
    flowArn, vpcInterfaces; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconnect(
        "POST",
        "/v1/flows/$(flowArn)/vpcInterfaces",
        Dict{String,Any}("vpcInterfaces" => vpcInterfaces);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_flow_vpc_interfaces(
    flowArn,
    vpcInterfaces,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediaconnect(
        "POST",
        "/v1/flows/$(flowArn)/vpcInterfaces",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("vpcInterfaces" => vpcInterfaces), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_bridge(name, placement_arn, sources)
    create_bridge(name, placement_arn, sources, params::Dict{String,<:Any})

Creates a new bridge. The request must include one source.

# Arguments
- `name`: The name of the bridge. This name can not be modified after the bridge is created.
- `placement_arn`: The bridge placement Amazon Resource Number (ARN).
- `sources`: The sources that you want to add to this bridge.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"egressGatewayBridge"`: Create a bridge with the egress bridge type. An egress bridge is
  a cloud-to-ground bridge. The content comes from an existing MediaConnect flow and is
  delivered to your premises.
- `"ingressGatewayBridge"`: Create a bridge with the ingress bridge type. An ingress bridge
  is a ground-to-cloud bridge. The content originates at your premises and is delivered to
  the cloud.
- `"outputs"`: The outputs that you want to add to this bridge.
- `"sourceFailoverConfig"`: The settings for source failover.
"""
function create_bridge(
    name, placementArn, sources; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconnect(
        "POST",
        "/v1/bridges",
        Dict{String,Any}(
            "name" => name, "placementArn" => placementArn, "sources" => sources
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_bridge(
    name,
    placementArn,
    sources,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediaconnect(
        "POST",
        "/v1/bridges",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "name" => name, "placementArn" => placementArn, "sources" => sources
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_flow(name)
    create_flow(name, params::Dict{String,<:Any})

Creates a new flow. The request must include one source. The request optionally can include
outputs (up to 50) and entitlements (up to 50).

# Arguments
- `name`: The name of the flow.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"availabilityZone"`: The Availability Zone that you want to create the flow in. These
  options are limited to the Availability Zones within the current AWS Region.
- `"entitlements"`: The entitlements that you want to grant on a flow.
- `"maintenance"`:
- `"mediaStreams"`: The media streams that you want to add to the flow. You can associate
  these media streams with sources and outputs on the flow.
- `"outputs"`: The outputs that you want to add to this flow.
- `"source"`:
- `"sourceFailoverConfig"`:
- `"sources"`:
- `"vpcInterfaces"`: The VPC interfaces you want on the flow.
"""
function create_flow(name; aws_config::AbstractAWSConfig=current_aws_config())
    return mediaconnect(
        "POST",
        "/v1/flows",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_flow(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconnect(
        "POST",
        "/v1/flows",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_gateway(egress_cidr_blocks, name, networks)
    create_gateway(egress_cidr_blocks, name, networks, params::Dict{String,<:Any})

Creates a new gateway. The request must include at least one network (up to 4).

# Arguments
- `egress_cidr_blocks`: The range of IP addresses that are allowed to contribute content or
  initiate output requests for flows communicating with this gateway. These IP addresses
  should be in the form of a Classless Inter-Domain Routing (CIDR) block; for example,
  10.0.0.0/16.
- `name`: The name of the gateway. This name can not be modified after the gateway is
  created.
- `networks`: The list of networks that you want to add.

"""
function create_gateway(
    egressCidrBlocks, name, networks; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconnect(
        "POST",
        "/v1/gateways",
        Dict{String,Any}(
            "egressCidrBlocks" => egressCidrBlocks, "name" => name, "networks" => networks
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_gateway(
    egressCidrBlocks,
    name,
    networks,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediaconnect(
        "POST",
        "/v1/gateways",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "egressCidrBlocks" => egressCidrBlocks,
                    "name" => name,
                    "networks" => networks,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_bridge(bridge_arn)
    delete_bridge(bridge_arn, params::Dict{String,<:Any})

Deletes a bridge. Before you can delete a bridge, you must stop the bridge.

# Arguments
- `bridge_arn`: The ARN of the bridge that you want to delete.

"""
function delete_bridge(bridgeArn; aws_config::AbstractAWSConfig=current_aws_config())
    return mediaconnect(
        "DELETE",
        "/v1/bridges/$(bridgeArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_bridge(
    bridgeArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediaconnect(
        "DELETE",
        "/v1/bridges/$(bridgeArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_flow(flow_arn)
    delete_flow(flow_arn, params::Dict{String,<:Any})

Deletes a flow. Before you can delete a flow, you must stop the flow.

# Arguments
- `flow_arn`: The ARN of the flow that you want to delete.

"""
function delete_flow(flowArn; aws_config::AbstractAWSConfig=current_aws_config())
    return mediaconnect(
        "DELETE",
        "/v1/flows/$(flowArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_flow(
    flowArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediaconnect(
        "DELETE",
        "/v1/flows/$(flowArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_gateway(gateway_arn)
    delete_gateway(gateway_arn, params::Dict{String,<:Any})

Deletes a gateway. Before you can delete a gateway, you must deregister its instances and
delete its bridges.

# Arguments
- `gateway_arn`: The ARN of the gateway that you want to delete.

"""
function delete_gateway(gatewayArn; aws_config::AbstractAWSConfig=current_aws_config())
    return mediaconnect(
        "DELETE",
        "/v1/gateways/$(gatewayArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_gateway(
    gatewayArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediaconnect(
        "DELETE",
        "/v1/gateways/$(gatewayArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    deregister_gateway_instance(gateway_instance_arn)
    deregister_gateway_instance(gateway_instance_arn, params::Dict{String,<:Any})

Deregisters an instance. Before you deregister an instance, all bridges running on the
instance must be stopped. If you want to deregister an instance without stopping the
bridges, you must use the --force option.

# Arguments
- `gateway_instance_arn`: The Amazon Resource Name (ARN) of the gateway that contains the
  instance that you want to deregister.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"force"`: Force the deregistration of an instance. Force will deregister an instance,
  even if there are bridges running on it.
"""
function deregister_gateway_instance(
    gatewayInstanceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconnect(
        "DELETE",
        "/v1/gateway-instances/$(gatewayInstanceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function deregister_gateway_instance(
    gatewayInstanceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediaconnect(
        "DELETE",
        "/v1/gateway-instances/$(gatewayInstanceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_bridge(bridge_arn)
    describe_bridge(bridge_arn, params::Dict{String,<:Any})

Displays the details of a bridge.

# Arguments
- `bridge_arn`: The ARN of the bridge that you want to describe.

"""
function describe_bridge(bridgeArn; aws_config::AbstractAWSConfig=current_aws_config())
    return mediaconnect(
        "GET",
        "/v1/bridges/$(bridgeArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_bridge(
    bridgeArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediaconnect(
        "GET",
        "/v1/bridges/$(bridgeArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_flow(flow_arn)
    describe_flow(flow_arn, params::Dict{String,<:Any})

Displays the details of a flow. The response includes the flow ARN, name, and Availability
Zone, as well as details about the source, outputs, and entitlements.

# Arguments
- `flow_arn`: The ARN of the flow that you want to describe.

"""
function describe_flow(flowArn; aws_config::AbstractAWSConfig=current_aws_config())
    return mediaconnect(
        "GET",
        "/v1/flows/$(flowArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_flow(
    flowArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediaconnect(
        "GET",
        "/v1/flows/$(flowArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_flow_source_metadata(flow_arn)
    describe_flow_source_metadata(flow_arn, params::Dict{String,<:Any})

Displays details of the flow's source stream. The response contains information about the
contents of the stream and its programs.

# Arguments
- `flow_arn`: The Amazon Resource Name (ARN) of the flow.

"""
function describe_flow_source_metadata(
    flowArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconnect(
        "GET",
        "/v1/flows/$(flowArn)/source-metadata";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_flow_source_metadata(
    flowArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediaconnect(
        "GET",
        "/v1/flows/$(flowArn)/source-metadata",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_gateway(gateway_arn)
    describe_gateway(gateway_arn, params::Dict{String,<:Any})

Displays the details of a gateway. The response includes the gateway ARN, name, and CIDR
blocks, as well as details about the networks.

# Arguments
- `gateway_arn`: The Amazon Resource Name (ARN) of the gateway that you want to describe.

"""
function describe_gateway(gatewayArn; aws_config::AbstractAWSConfig=current_aws_config())
    return mediaconnect(
        "GET",
        "/v1/gateways/$(gatewayArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_gateway(
    gatewayArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediaconnect(
        "GET",
        "/v1/gateways/$(gatewayArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_gateway_instance(gateway_instance_arn)
    describe_gateway_instance(gateway_instance_arn, params::Dict{String,<:Any})

Displays the details of an instance.

# Arguments
- `gateway_instance_arn`: The Amazon Resource Name (ARN) of the gateway instance that you
  want to describe.

"""
function describe_gateway_instance(
    gatewayInstanceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconnect(
        "GET",
        "/v1/gateway-instances/$(gatewayInstanceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_gateway_instance(
    gatewayInstanceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediaconnect(
        "GET",
        "/v1/gateway-instances/$(gatewayInstanceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_offering(offering_arn)
    describe_offering(offering_arn, params::Dict{String,<:Any})

Displays the details of an offering. The response includes the offering description,
duration, outbound bandwidth, price, and Amazon Resource Name (ARN).

# Arguments
- `offering_arn`: The Amazon Resource Name (ARN) of the offering.

"""
function describe_offering(offeringArn; aws_config::AbstractAWSConfig=current_aws_config())
    return mediaconnect(
        "GET",
        "/v1/offerings/$(offeringArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_offering(
    offeringArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediaconnect(
        "GET",
        "/v1/offerings/$(offeringArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_reservation(reservation_arn)
    describe_reservation(reservation_arn, params::Dict{String,<:Any})

Displays the details of a reservation. The response includes the reservation name, state,
start date and time, and the details of the offering that make up the rest of the
reservation (such as price, duration, and outbound bandwidth).

# Arguments
- `reservation_arn`: The Amazon Resource Name (ARN) of the reservation.

"""
function describe_reservation(
    reservationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconnect(
        "GET",
        "/v1/reservations/$(reservationArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_reservation(
    reservationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediaconnect(
        "GET",
        "/v1/reservations/$(reservationArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    grant_flow_entitlements(entitlements, flow_arn)
    grant_flow_entitlements(entitlements, flow_arn, params::Dict{String,<:Any})

Grants entitlements to an existing flow.

# Arguments
- `entitlements`: The list of entitlements that you want to grant.
- `flow_arn`: The flow that you want to grant entitlements on.

"""
function grant_flow_entitlements(
    entitlements, flowArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconnect(
        "POST",
        "/v1/flows/$(flowArn)/entitlements",
        Dict{String,Any}("entitlements" => entitlements);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function grant_flow_entitlements(
    entitlements,
    flowArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediaconnect(
        "POST",
        "/v1/flows/$(flowArn)/entitlements",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("entitlements" => entitlements), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_bridges()
    list_bridges(params::Dict{String,<:Any})

Displays a list of bridges that are associated with this account and an optionally
specified Arn. This request returns a paginated result.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filterArn"`: Filter the list results to display only the bridges associated with the
  selected Amazon Resource Name (ARN).
- `"maxResults"`: The maximum number of results to return per API request. For example, you
  submit a ListBridges request with MaxResults set at 5. Although 20 items match your
  request, the service returns no more than the first 5 items. (The service also returns a
  NextToken value that you can use to fetch the next batch of results.) The service might
  return fewer results than the MaxResults value. If MaxResults is not included in the
  request, the service defaults to pagination with a maximum of 10 results per page.
- `"nextToken"`: The token that identifies which batch of results that you want to see. For
  example, you submit a ListBridges request with MaxResults set at 5. The service returns the
  first batch of results (up to 5) and a NextToken value. To see the next batch of results,
  you can submit the ListBridges request a second time and specify the NextToken value.
"""
function list_bridges(; aws_config::AbstractAWSConfig=current_aws_config())
    return mediaconnect(
        "GET", "/v1/bridges"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_bridges(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconnect(
        "GET", "/v1/bridges", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_entitlements()
    list_entitlements(params::Dict{String,<:Any})

Displays a list of all entitlements that have been granted to this account. This request
returns 20 results per page.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return per API request. For example, you
  submit a ListEntitlements request with MaxResults set at 5. Although 20 items match your
  request, the service returns no more than the first 5 items. (The service also returns a
  NextToken value that you can use to fetch the next batch of results.) The service might
  return fewer results than the MaxResults value. If MaxResults is not included in the
  request, the service defaults to pagination with a maximum of 20 results per page.
- `"nextToken"`: The token that identifies which batch of results that you want to see. For
  example, you submit a ListEntitlements request with MaxResults set at 5. The service
  returns the first batch of results (up to 5) and a NextToken value. To see the next batch
  of results, you can submit the ListEntitlements request a second time and specify the
  NextToken value.
"""
function list_entitlements(; aws_config::AbstractAWSConfig=current_aws_config())
    return mediaconnect(
        "GET", "/v1/entitlements"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_entitlements(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconnect(
        "GET",
        "/v1/entitlements",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_flows()
    list_flows(params::Dict{String,<:Any})

Displays a list of flows that are associated with this account. This request returns a
paginated result.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return per API request. For example, you
  submit a ListFlows request with MaxResults set at 5. Although 20 items match your request,
  the service returns no more than the first 5 items. (The service also returns a NextToken
  value that you can use to fetch the next batch of results.) The service might return fewer
  results than the MaxResults value. If MaxResults is not included in the request, the
  service defaults to pagination with a maximum of 10 results per page.
- `"nextToken"`: The token that identifies which batch of results that you want to see. For
  example, you submit a ListFlows request with MaxResults set at 5. The service returns the
  first batch of results (up to 5) and a NextToken value. To see the next batch of results,
  you can submit the ListFlows request a second time and specify the NextToken value.
"""
function list_flows(; aws_config::AbstractAWSConfig=current_aws_config())
    return mediaconnect(
        "GET", "/v1/flows"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_flows(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconnect(
        "GET", "/v1/flows", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_gateway_instances()
    list_gateway_instances(params::Dict{String,<:Any})

Displays a list of instances associated with the AWS account. This request returns a
paginated result. You can use the filterArn property to display only the instances
associated with the selected Gateway Amazon Resource Name (ARN).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filterArn"`: Filter the list results to display only the instances associated with the
  selected Gateway Amazon Resource Name (ARN).
- `"maxResults"`: The maximum number of results to return per API request. For example, you
  submit a ListInstances request with MaxResults set at 5. Although 20 items match your
  request, the service returns no more than the first 5 items. (The service also returns a
  NextToken value that you can use to fetch the next batch of results.) The service might
  return fewer results than the MaxResults value. If MaxResults is not included in the
  request, the service defaults to pagination with a maximum of 10 results per page.
- `"nextToken"`: The token that identifies which batch of results that you want to see. For
  example, you submit a ListInstances request with MaxResults set at 5. The service returns
  the first batch of results (up to 5) and a NextToken value. To see the next batch of
  results, you can submit the ListInstances request a second time and specify the NextToken
  value.
"""
function list_gateway_instances(; aws_config::AbstractAWSConfig=current_aws_config())
    return mediaconnect(
        "GET",
        "/v1/gateway-instances";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_gateway_instances(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconnect(
        "GET",
        "/v1/gateway-instances",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_gateways()
    list_gateways(params::Dict{String,<:Any})

Displays a list of gateways that are associated with this account. This request returns a
paginated result.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return per API request. For example, you
  submit a ListGateways request with MaxResults set at 5. Although 20 items match your
  request, the service returns no more than the first 5 items. (The service also returns a
  NextToken value that you can use to fetch the next batch of results.) The service might
  return fewer results than the MaxResults value. If MaxResults is not included in the
  request, the service defaults to pagination with a maximum of 10 results per page.
- `"nextToken"`: The token that identifies which batch of results that you want to see. For
  example, you submit a ListGateways request with MaxResults set at 5. The service returns
  the first batch of results (up to 5) and a NextToken value. To see the next batch of
  results, you can submit the ListGateways request a second time and specify the NextToken
  value.
"""
function list_gateways(; aws_config::AbstractAWSConfig=current_aws_config())
    return mediaconnect(
        "GET", "/v1/gateways"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_gateways(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconnect(
        "GET",
        "/v1/gateways",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_offerings()
    list_offerings(params::Dict{String,<:Any})

Displays a list of all offerings that are available to this account in the current AWS
Region. If you have an active reservation (which means you've purchased an offering that
has already started and hasn't expired yet), your account isn't eligible for other
offerings.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return per API request. For example, you
  submit a ListOfferings request with MaxResults set at 5. Although 20 items match your
  request, the service returns no more than the first 5 items. (The service also returns a
  NextToken value that you can use to fetch the next batch of results.) The service might
  return fewer results than the MaxResults value. If MaxResults is not included in the
  request, the service defaults to pagination with a maximum of 10 results per page.
- `"nextToken"`: The token that identifies which batch of results that you want to see. For
  example, you submit a ListOfferings request with MaxResults set at 5. The service returns
  the first batch of results (up to 5) and a NextToken value. To see the next batch of
  results, you can submit the ListOfferings request a second time and specify the NextToken
  value.
"""
function list_offerings(; aws_config::AbstractAWSConfig=current_aws_config())
    return mediaconnect(
        "GET", "/v1/offerings"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_offerings(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconnect(
        "GET",
        "/v1/offerings",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_reservations()
    list_reservations(params::Dict{String,<:Any})

Displays a list of all reservations that have been purchased by this account in the current
AWS Region. This list includes all reservations in all states (such as active and expired).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return per API request. For example, you
  submit a ListReservations request with MaxResults set at 5. Although 20 items match your
  request, the service returns no more than the first 5 items. (The service also returns a
  NextToken value that you can use to fetch the next batch of results.) The service might
  return fewer results than the MaxResults value. If MaxResults is not included in the
  request, the service defaults to pagination with a maximum of 10 results per page.
- `"nextToken"`: The token that identifies which batch of results that you want to see. For
  example, you submit a ListReservations request with MaxResults set at 5. The service
  returns the first batch of results (up to 5) and a NextToken value. To see the next batch
  of results, you can submit the ListOfferings request a second time and specify the
  NextToken value.
"""
function list_reservations(; aws_config::AbstractAWSConfig=current_aws_config())
    return mediaconnect(
        "GET", "/v1/reservations"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_reservations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconnect(
        "GET",
        "/v1/reservations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

List all tags on an AWS Elemental MediaConnect resource

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) that identifies the AWS Elemental
  MediaConnect resource for which to list the tags.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconnect(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediaconnect(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    purchase_offering(offering_arn, reservation_name, start)
    purchase_offering(offering_arn, reservation_name, start, params::Dict{String,<:Any})

Submits a request to purchase an offering. If you already have an active reservation, you
can't purchase another offering.

# Arguments
- `offering_arn`: The Amazon Resource Name (ARN) of the offering.
- `reservation_name`: The name that you want to use for the reservation.
- `start`: The date and time that you want the reservation to begin, in Coordinated
  Universal Time (UTC). You can specify any date and time between 12:00am on the first day of
  the current month to the current time on today's date, inclusive. Specify the start in a
  24-hour notation. Use the following format: YYYY-MM-DDTHH:mm:SSZ, where T and Z are literal
  characters. For example, to specify 11:30pm on March 5, 2020, enter 2020-03-05T23:30:00Z.

"""
function purchase_offering(
    offeringArn, reservationName, start; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconnect(
        "POST",
        "/v1/offerings/$(offeringArn)",
        Dict{String,Any}("reservationName" => reservationName, "start" => start);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function purchase_offering(
    offeringArn,
    reservationName,
    start,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediaconnect(
        "POST",
        "/v1/offerings/$(offeringArn)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("reservationName" => reservationName, "start" => start),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_bridge_output(bridge_arn, output_name)
    remove_bridge_output(bridge_arn, output_name, params::Dict{String,<:Any})

Removes an output from a bridge.

# Arguments
- `bridge_arn`: The ARN of the bridge that you want to update.
- `output_name`: The name of the bridge output that you want to remove.

"""
function remove_bridge_output(
    bridgeArn, outputName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconnect(
        "DELETE",
        "/v1/bridges/$(bridgeArn)/outputs/$(outputName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_bridge_output(
    bridgeArn,
    outputName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediaconnect(
        "DELETE",
        "/v1/bridges/$(bridgeArn)/outputs/$(outputName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_bridge_source(bridge_arn, source_name)
    remove_bridge_source(bridge_arn, source_name, params::Dict{String,<:Any})

Removes a source from a bridge.

# Arguments
- `bridge_arn`: The ARN of the bridge that you want to update.
- `source_name`: The name of the bridge source that you want to remove.

"""
function remove_bridge_source(
    bridgeArn, sourceName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconnect(
        "DELETE",
        "/v1/bridges/$(bridgeArn)/sources/$(sourceName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_bridge_source(
    bridgeArn,
    sourceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediaconnect(
        "DELETE",
        "/v1/bridges/$(bridgeArn)/sources/$(sourceName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_flow_media_stream(flow_arn, media_stream_name)
    remove_flow_media_stream(flow_arn, media_stream_name, params::Dict{String,<:Any})

Removes a media stream from a flow. This action is only available if the media stream is
not associated with a source or output.

# Arguments
- `flow_arn`: The Amazon Resource Name (ARN) of the flow.
- `media_stream_name`: The name of the media stream that you want to remove.

"""
function remove_flow_media_stream(
    flowArn, mediaStreamName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconnect(
        "DELETE",
        "/v1/flows/$(flowArn)/mediaStreams/$(mediaStreamName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_flow_media_stream(
    flowArn,
    mediaStreamName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediaconnect(
        "DELETE",
        "/v1/flows/$(flowArn)/mediaStreams/$(mediaStreamName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_flow_output(flow_arn, output_arn)
    remove_flow_output(flow_arn, output_arn, params::Dict{String,<:Any})

Removes an output from an existing flow. This request can be made only on an output that
does not have an entitlement associated with it. If the output has an entitlement, you must
revoke the entitlement instead. When an entitlement is revoked from a flow, the service
automatically removes the associated output.

# Arguments
- `flow_arn`: The flow that you want to remove an output from.
- `output_arn`: The ARN of the output that you want to remove.

"""
function remove_flow_output(
    flowArn, outputArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconnect(
        "DELETE",
        "/v1/flows/$(flowArn)/outputs/$(outputArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_flow_output(
    flowArn,
    outputArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediaconnect(
        "DELETE",
        "/v1/flows/$(flowArn)/outputs/$(outputArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_flow_source(flow_arn, source_arn)
    remove_flow_source(flow_arn, source_arn, params::Dict{String,<:Any})

Removes a source from an existing flow. This request can be made only if there is more than
one source on the flow.

# Arguments
- `flow_arn`: The flow that you want to remove a source from.
- `source_arn`: The ARN of the source that you want to remove.

"""
function remove_flow_source(
    flowArn, sourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconnect(
        "DELETE",
        "/v1/flows/$(flowArn)/source/$(sourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_flow_source(
    flowArn,
    sourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediaconnect(
        "DELETE",
        "/v1/flows/$(flowArn)/source/$(sourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_flow_vpc_interface(flow_arn, vpc_interface_name)
    remove_flow_vpc_interface(flow_arn, vpc_interface_name, params::Dict{String,<:Any})

Removes a VPC Interface from an existing flow. This request can be made only on a VPC
interface that does not have a Source or Output associated with it. If the VPC interface is
referenced by a Source or Output, you must first delete or update the Source or Output to
no longer reference the VPC interface.

# Arguments
- `flow_arn`: The flow that you want to remove a VPC interface from.
- `vpc_interface_name`: The name of the VPC interface that you want to remove.

"""
function remove_flow_vpc_interface(
    flowArn, vpcInterfaceName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconnect(
        "DELETE",
        "/v1/flows/$(flowArn)/vpcInterfaces/$(vpcInterfaceName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_flow_vpc_interface(
    flowArn,
    vpcInterfaceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediaconnect(
        "DELETE",
        "/v1/flows/$(flowArn)/vpcInterfaces/$(vpcInterfaceName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    revoke_flow_entitlement(entitlement_arn, flow_arn)
    revoke_flow_entitlement(entitlement_arn, flow_arn, params::Dict{String,<:Any})

Revokes an entitlement from a flow. Once an entitlement is revoked, the content becomes
unavailable to the subscriber and the associated output is removed.

# Arguments
- `entitlement_arn`: The ARN of the entitlement that you want to revoke.
- `flow_arn`: The flow that you want to revoke an entitlement from.

"""
function revoke_flow_entitlement(
    entitlementArn, flowArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconnect(
        "DELETE",
        "/v1/flows/$(flowArn)/entitlements/$(entitlementArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function revoke_flow_entitlement(
    entitlementArn,
    flowArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediaconnect(
        "DELETE",
        "/v1/flows/$(flowArn)/entitlements/$(entitlementArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_flow(flow_arn)
    start_flow(flow_arn, params::Dict{String,<:Any})

Starts a flow.

# Arguments
- `flow_arn`: The ARN of the flow that you want to start.

"""
function start_flow(flowArn; aws_config::AbstractAWSConfig=current_aws_config())
    return mediaconnect(
        "POST",
        "/v1/flows/start/$(flowArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_flow(
    flowArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediaconnect(
        "POST",
        "/v1/flows/start/$(flowArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_flow(flow_arn)
    stop_flow(flow_arn, params::Dict{String,<:Any})

Stops a flow.

# Arguments
- `flow_arn`: The ARN of the flow that you want to stop.

"""
function stop_flow(flowArn; aws_config::AbstractAWSConfig=current_aws_config())
    return mediaconnect(
        "POST",
        "/v1/flows/stop/$(flowArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_flow(
    flowArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediaconnect(
        "POST",
        "/v1/flows/stop/$(flowArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Associates the specified tags to a resource with the specified resourceArn. If existing
tags on a resource are not specified in the request parameters, they are not changed. When
a resource is deleted, the tags associated with that resource are deleted as well.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) that identifies the AWS Elemental
  MediaConnect resource to which to add tags.
- `tags`: A map from tag keys to values. Tag keys can have a maximum character length of
  128 characters, and tag values can have a maximum length of 256 characters.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return mediaconnect(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediaconnect(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Deletes specified tags from a resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) that identifies the AWS Elemental
  MediaConnect resource from which to delete tags.
- `tag_keys`: The keys of the tags to be removed.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconnect(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediaconnect(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_bridge(bridge_arn)
    update_bridge(bridge_arn, params::Dict{String,<:Any})

Updates the bridge

# Arguments
- `bridge_arn`: The Amazon Resource Number (ARN) of the bridge that you want to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"egressGatewayBridge"`:
- `"ingressGatewayBridge"`:
- `"sourceFailoverConfig"`:
"""
function update_bridge(bridgeArn; aws_config::AbstractAWSConfig=current_aws_config())
    return mediaconnect(
        "PUT",
        "/v1/bridges/$(bridgeArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_bridge(
    bridgeArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediaconnect(
        "PUT",
        "/v1/bridges/$(bridgeArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_bridge_output(bridge_arn, output_name)
    update_bridge_output(bridge_arn, output_name, params::Dict{String,<:Any})

Updates an existing bridge output.

# Arguments
- `bridge_arn`: The ARN of the bridge that you want to update.
- `output_name`: The name of the bridge output that you want to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"networkOutput"`:
"""
function update_bridge_output(
    bridgeArn, outputName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconnect(
        "PUT",
        "/v1/bridges/$(bridgeArn)/outputs/$(outputName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_bridge_output(
    bridgeArn,
    outputName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediaconnect(
        "PUT",
        "/v1/bridges/$(bridgeArn)/outputs/$(outputName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_bridge_source(bridge_arn, source_name)
    update_bridge_source(bridge_arn, source_name, params::Dict{String,<:Any})

Updates an existing bridge source.

# Arguments
- `bridge_arn`: The ARN of the bridge that you want to update.
- `source_name`: The name of the source that you want to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"flowSource"`:
- `"networkSource"`:
"""
function update_bridge_source(
    bridgeArn, sourceName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconnect(
        "PUT",
        "/v1/bridges/$(bridgeArn)/sources/$(sourceName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_bridge_source(
    bridgeArn,
    sourceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediaconnect(
        "PUT",
        "/v1/bridges/$(bridgeArn)/sources/$(sourceName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_bridge_state(bridge_arn, desired_state)
    update_bridge_state(bridge_arn, desired_state, params::Dict{String,<:Any})

Updates the bridge state

# Arguments
- `bridge_arn`: The ARN of the bridge that you want to update.
- `desired_state`:

"""
function update_bridge_state(
    bridgeArn, desiredState; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconnect(
        "PUT",
        "/v1/bridges/$(bridgeArn)/state",
        Dict{String,Any}("desiredState" => desiredState);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_bridge_state(
    bridgeArn,
    desiredState,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediaconnect(
        "PUT",
        "/v1/bridges/$(bridgeArn)/state",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("desiredState" => desiredState), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_flow(flow_arn)
    update_flow(flow_arn, params::Dict{String,<:Any})

Updates flow

# Arguments
- `flow_arn`: The flow that you want to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maintenance"`:
- `"sourceFailoverConfig"`:
"""
function update_flow(flowArn; aws_config::AbstractAWSConfig=current_aws_config())
    return mediaconnect(
        "PUT",
        "/v1/flows/$(flowArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_flow(
    flowArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediaconnect(
        "PUT",
        "/v1/flows/$(flowArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_flow_entitlement(entitlement_arn, flow_arn)
    update_flow_entitlement(entitlement_arn, flow_arn, params::Dict{String,<:Any})

You can change an entitlement's description, subscribers, and encryption. If you change the
subscribers, the service will remove the outputs that are are used by the subscribers that
are removed.

# Arguments
- `entitlement_arn`: The ARN of the entitlement that you want to update.
- `flow_arn`: The flow that is associated with the entitlement that you want to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A description of the entitlement. This description appears only on the
  AWS Elemental MediaConnect console and will not be seen by the subscriber or end user.
- `"encryption"`: The type of encryption that will be used on the output associated with
  this entitlement. Allowable encryption types: static-key, speke.
- `"entitlementStatus"`: An indication of whether you want to enable the entitlement to
  allow access, or disable it to stop streaming content to the subscriber’s flow
  temporarily. If you don’t specify the entitlementStatus field in your request,
  MediaConnect leaves the value unchanged.
- `"subscribers"`: The AWS account IDs that you want to share your content with. The
  receiving accounts (subscribers) will be allowed to create their own flow using your
  content as the source.
"""
function update_flow_entitlement(
    entitlementArn, flowArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconnect(
        "PUT",
        "/v1/flows/$(flowArn)/entitlements/$(entitlementArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_flow_entitlement(
    entitlementArn,
    flowArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediaconnect(
        "PUT",
        "/v1/flows/$(flowArn)/entitlements/$(entitlementArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_flow_media_stream(flow_arn, media_stream_name)
    update_flow_media_stream(flow_arn, media_stream_name, params::Dict{String,<:Any})

Updates an existing media stream.

# Arguments
- `flow_arn`: The Amazon Resource Name (ARN) of the flow.
- `media_stream_name`: The name of the media stream that you want to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"attributes"`: The attributes that you want to assign to the media stream.
- `"clockRate"`: The sample rate (in Hz) for the stream. If the media stream type is video
  or ancillary data, set this value to 90000. If the media stream type is audio, set this
  value to either 48000 or 96000.
- `"description"`: Description
- `"mediaStreamType"`: The type of media stream.
- `"videoFormat"`: The resolution of the video.
"""
function update_flow_media_stream(
    flowArn, mediaStreamName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconnect(
        "PUT",
        "/v1/flows/$(flowArn)/mediaStreams/$(mediaStreamName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_flow_media_stream(
    flowArn,
    mediaStreamName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediaconnect(
        "PUT",
        "/v1/flows/$(flowArn)/mediaStreams/$(mediaStreamName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_flow_output(flow_arn, output_arn)
    update_flow_output(flow_arn, output_arn, params::Dict{String,<:Any})

Updates an existing flow output.

# Arguments
- `flow_arn`: The flow that is associated with the output that you want to update.
- `output_arn`: The ARN of the output that you want to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"cidrAllowList"`: The range of IP addresses that should be allowed to initiate output
  requests to this flow. These IP addresses should be in the form of a Classless Inter-Domain
  Routing (CIDR) block; for example, 10.0.0.0/16.
- `"description"`: A description of the output. This description appears only on the AWS
  Elemental MediaConnect console and will not be seen by the end user.
- `"destination"`: The IP address where you want to send the output.
- `"encryption"`: The type of key used for the encryption. If no keyType is provided, the
  service will use the default setting (static-key). Allowable encryption types: static-key.
- `"maxLatency"`: The maximum latency in milliseconds. This parameter applies only to
  RIST-based, Zixi-based, and Fujitsu-based streams.
- `"mediaStreamOutputConfigurations"`: The media streams that are associated with the
  output, and the parameters for those associations.
- `"minLatency"`: The minimum latency in milliseconds for SRT-based streams. In streams
  that use the SRT protocol, this value that you set on your MediaConnect source or output
  represents the minimal potential latency of that connection. The latency of the stream is
  set to the highest number between the sender’s minimum latency and the receiver’s
  minimum latency.
- `"port"`: The port to use when content is distributed to this output.
- `"protocol"`: The protocol to use for the output.
- `"remoteId"`: The remote ID for the Zixi-pull stream.
- `"senderControlPort"`: The port that the flow uses to send outbound requests to initiate
  connection with the sender.
- `"senderIpAddress"`: The IP address that the flow communicates with to initiate
  connection with the sender.
- `"smoothingLatency"`: The smoothing latency in milliseconds for RIST, RTP, and RTP-FEC
  streams.
- `"streamId"`: The stream ID that you want to use for this transport. This parameter
  applies only to Zixi and SRT caller-based streams.
- `"vpcInterfaceAttachment"`: The name of the VPC interface attachment to use for this
  output.
"""
function update_flow_output(
    flowArn, outputArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconnect(
        "PUT",
        "/v1/flows/$(flowArn)/outputs/$(outputArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_flow_output(
    flowArn,
    outputArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediaconnect(
        "PUT",
        "/v1/flows/$(flowArn)/outputs/$(outputArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_flow_source(flow_arn, source_arn)
    update_flow_source(flow_arn, source_arn, params::Dict{String,<:Any})

Updates the source of a flow.

# Arguments
- `flow_arn`: The flow that is associated with the source that you want to update.
- `source_arn`: The ARN of the source that you want to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"decryption"`: The type of encryption used on the content ingested from this source.
  Allowable encryption types: static-key.
- `"description"`: A description for the source. This value is not used or seen outside of
  the current AWS Elemental MediaConnect account.
- `"entitlementArn"`: The ARN of the entitlement that allows you to subscribe to this flow.
  The entitlement is set by the flow originator, and the ARN is generated as part of the
  originator's flow.
- `"gatewayBridgeSource"`: The source configuration for cloud flows receiving a stream from
  a bridge.
- `"ingestPort"`: The port that the flow will be listening on for incoming content.
- `"maxBitrate"`: The smoothing max bitrate (in bps) for RIST, RTP, and RTP-FEC streams.
- `"maxLatency"`: The maximum latency in milliseconds. This parameter applies only to
  RIST-based, Zixi-based, and Fujitsu-based streams.
- `"maxSyncBuffer"`: The size of the buffer (in milliseconds) to use to sync incoming
  source data.
- `"mediaStreamSourceConfigurations"`: The media streams that are associated with the
  source, and the parameters for those associations.
- `"minLatency"`: The minimum latency in milliseconds for SRT-based streams. In streams
  that use the SRT protocol, this value that you set on your MediaConnect source or output
  represents the minimal potential latency of that connection. The latency of the stream is
  set to the highest number between the sender’s minimum latency and the receiver’s
  minimum latency.
- `"protocol"`: The protocol that is used by the source.
- `"senderControlPort"`: The port that the flow uses to send outbound requests to initiate
  connection with the sender.
- `"senderIpAddress"`: The IP address that the flow communicates with to initiate
  connection with the sender.
- `"sourceListenerAddress"`: Source IP or domain name for SRT-caller protocol.
- `"sourceListenerPort"`: Source port for SRT-caller protocol.
- `"streamId"`: The stream ID that you want to use for this transport. This parameter
  applies only to Zixi and SRT caller-based streams.
- `"vpcInterfaceName"`: The name of the VPC interface to use for this source.
- `"whitelistCidr"`: The range of IP addresses that should be allowed to contribute content
  to your source. These IP addresses should be in the form of a Classless Inter-Domain
  Routing (CIDR) block; for example, 10.0.0.0/16.
"""
function update_flow_source(
    flowArn, sourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconnect(
        "PUT",
        "/v1/flows/$(flowArn)/source/$(sourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_flow_source(
    flowArn,
    sourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediaconnect(
        "PUT",
        "/v1/flows/$(flowArn)/source/$(sourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_gateway_instance(gateway_instance_arn)
    update_gateway_instance(gateway_instance_arn, params::Dict{String,<:Any})

Updates the configuration of an existing Gateway Instance.

# Arguments
- `gateway_instance_arn`: The Amazon Resource Name (ARN) of the instance that you want to
  update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"bridgePlacement"`: The availability of the instance to host new bridges. The
  bridgePlacement property can be LOCKED or AVAILABLE. If it is LOCKED, no new bridges can be
  deployed to this instance. If it is AVAILABLE, new bridges can be added to this instance.
"""
function update_gateway_instance(
    gatewayInstanceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconnect(
        "PUT",
        "/v1/gateway-instances/$(gatewayInstanceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_gateway_instance(
    gatewayInstanceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediaconnect(
        "PUT",
        "/v1/gateway-instances/$(gatewayInstanceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: ecs
using AWS.Compat
using AWS.UUIDs

"""
    create_capacity_provider(auto_scaling_group_provider, name)
    create_capacity_provider(auto_scaling_group_provider, name, params::Dict{String,<:Any})

Creates a new capacity provider. Capacity providers are associated with an Amazon ECS
cluster and are used in capacity provider strategies to facilitate cluster auto scaling.
Only capacity providers that use an Auto Scaling group can be created. Amazon ECS tasks on
Fargate use the FARGATE and FARGATE_SPOT capacity providers. These providers are available
to all accounts in the Amazon Web Services Regions that Fargate supports.

# Arguments
- `auto_scaling_group_provider`: The details of the Auto Scaling group for the capacity
  provider.
- `name`: The name of the capacity provider. Up to 255 characters are allowed. They include
  letters (both upper and lowercase letters), numbers, underscores (_), and hyphens (-). The
  name can't be prefixed with \"aws\", \"ecs\", or \"fargate\".

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tags"`: The metadata that you apply to the capacity provider to categorize and organize
  them more conveniently. Each tag consists of a key and an optional value. You define both
  of them. The following basic restrictions apply to tags:   Maximum number of tags per
  resource - 50   For each resource, each tag key must be unique, and each tag key can have
  only one value.   Maximum key length - 128 Unicode characters in UTF-8   Maximum value
  length - 256 Unicode characters in UTF-8   If your tagging schema is used across multiple
  services and resources, remember that other services may have restrictions on allowed
  characters. Generally allowed characters are: letters, numbers, and spaces representable in
  UTF-8, and the following characters: + - = . _ : / @.   Tag keys and values are
  case-sensitive.   Do not use aws:, AWS:, or any upper or lowercase combination of such as a
  prefix for either keys or values as it is reserved for Amazon Web Services use. You cannot
  edit or delete tag keys or values with this prefix. Tags with this prefix do not count
  against your tags per resource limit.
"""
function create_capacity_provider(
    autoScalingGroupProvider, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecs(
        "CreateCapacityProvider",
        Dict{String,Any}(
            "autoScalingGroupProvider" => autoScalingGroupProvider, "name" => name
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_capacity_provider(
    autoScalingGroupProvider,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecs(
        "CreateCapacityProvider",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "autoScalingGroupProvider" => autoScalingGroupProvider, "name" => name
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_cluster()
    create_cluster(params::Dict{String,<:Any})

Creates a new Amazon ECS cluster. By default, your account receives a default cluster when
you launch your first container instance. However, you can create your own cluster with a
unique name with the CreateCluster action.  When you call the CreateCluster API operation,
Amazon ECS attempts to create the Amazon ECS service-linked role for your account. This is
so that it can manage required resources in other Amazon Web Services services on your
behalf. However, if the user that makes the call doesn't have permissions to create the
service-linked role, it isn't created. For more information, see Using service-linked roles
for Amazon ECS in the Amazon Elastic Container Service Developer Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"capacityProviders"`: The short name of one or more capacity providers to associate with
  the cluster. A capacity provider must be associated with a cluster before it can be
  included as part of the default capacity provider strategy of the cluster or used in a
  capacity provider strategy when calling the CreateService or RunTask actions. If specifying
  a capacity provider that uses an Auto Scaling group, the capacity provider must be created
  but not associated with another cluster. New Auto Scaling group capacity providers can be
  created with the CreateCapacityProvider API operation. To use a Fargate capacity provider,
  specify either the FARGATE or FARGATE_SPOT capacity providers. The Fargate capacity
  providers are available to all accounts and only need to be associated with a cluster to be
  used. The PutCapacityProvider API operation is used to update the list of available
  capacity providers for a cluster after the cluster is created.
- `"clusterName"`: The name of your cluster. If you don't specify a name for your cluster,
  you create a cluster that's named default. Up to 255 letters (uppercase and lowercase),
  numbers, underscores, and hyphens are allowed.
- `"configuration"`: The execute command configuration for the cluster.
- `"defaultCapacityProviderStrategy"`: The capacity provider strategy to set as the default
  for the cluster. After a default capacity provider strategy is set for a cluster, when you
  call the CreateService or RunTask APIs with no capacity provider strategy or launch type
  specified, the default capacity provider strategy for the cluster is used. If a default
  capacity provider strategy isn't defined for a cluster when it was created, it can be
  defined later with the PutClusterCapacityProviders API operation.
- `"serviceConnectDefaults"`: Use this parameter to set a default Service Connect
  namespace. After you set a default Service Connect namespace, any new services with Service
  Connect turned on that are created in the cluster are added as client services in the
  namespace. This setting only applies to new services that set the enabled parameter to true
  in the ServiceConnectConfiguration. You can set the namespace of each service individually
  in the ServiceConnectConfiguration to override this default parameter. Tasks that run in a
  namespace can use short names to connect to services in the namespace. Tasks can connect to
  services across all of the clusters in the namespace. Tasks connect through a managed proxy
  container that collects logs and metrics for increased visibility. Only the tasks that
  Amazon ECS services create are supported with Service Connect. For more information, see
  Service Connect in the Amazon Elastic Container Service Developer Guide.
- `"settings"`: The setting to use when creating a cluster. This parameter is used to turn
  on CloudWatch Container Insights for a cluster. If this value is specified, it overrides
  the containerInsights value set with PutAccountSetting or PutAccountSettingDefault.
- `"tags"`: The metadata that you apply to the cluster to help you categorize and organize
  them. Each tag consists of a key and an optional value. You define both. The following
  basic restrictions apply to tags:   Maximum number of tags per resource - 50   For each
  resource, each tag key must be unique, and each tag key can have only one value.   Maximum
  key length - 128 Unicode characters in UTF-8   Maximum value length - 256 Unicode
  characters in UTF-8   If your tagging schema is used across multiple services and
  resources, remember that other services may have restrictions on allowed characters.
  Generally allowed characters are: letters, numbers, and spaces representable in UTF-8, and
  the following characters: + - = . _ : / @.   Tag keys and values are case-sensitive.   Do
  not use aws:, AWS:, or any upper or lowercase combination of such as a prefix for either
  keys or values as it is reserved for Amazon Web Services use. You cannot edit or delete tag
  keys or values with this prefix. Tags with this prefix do not count against your tags per
  resource limit.
"""
function create_cluster(; aws_config::AbstractAWSConfig=current_aws_config())
    return ecs("CreateCluster"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function create_cluster(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecs(
        "CreateCluster", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    create_service(service_name)
    create_service(service_name, params::Dict{String,<:Any})

Runs and maintains your desired number of tasks from a specified task definition. If the
number of tasks running in a service drops below the desiredCount, Amazon ECS runs another
copy of the task in the specified cluster. To update an existing service, see the
UpdateService action.  On March 21, 2024, a change was made to resolve the task definition
revision before authorization. When a task definition revision is not specified,
authorization will occur using the latest revision of a task definition.  In addition to
maintaining the desired count of tasks in your service, you can optionally run your service
behind one or more load balancers. The load balancers distribute traffic across the tasks
that are associated with the service. For more information, see Service load balancing in
the Amazon Elastic Container Service Developer Guide. You can attach Amazon EBS volumes to
Amazon ECS tasks by configuring the volume when creating or updating a service.
volumeConfigurations is only supported for REPLICA service and not DAEMON service. For more
infomation, see Amazon EBS volumes in the Amazon Elastic Container Service Developer Guide.
Tasks for services that don't use a load balancer are considered healthy if they're in the
RUNNING state. Tasks for services that use a load balancer are considered healthy if
they're in the RUNNING state and are reported as healthy by the load balancer. There are
two service scheduler strategies available:    REPLICA - The replica scheduling strategy
places and maintains your desired number of tasks across your cluster. By default, the
service scheduler spreads tasks across Availability Zones. You can use task placement
strategies and constraints to customize task placement decisions. For more information, see
Service scheduler concepts in the Amazon Elastic Container Service Developer Guide.
DAEMON - The daemon scheduling strategy deploys exactly one task on each active container
instance that meets all of the task placement constraints that you specify in your cluster.
The service scheduler also evaluates the task placement constraints for running tasks. It
also stops tasks that don't meet the placement constraints. When using this strategy, you
don't need to specify a desired number of tasks, a task placement strategy, or use Service
Auto Scaling policies. For more information, see Service scheduler concepts in the Amazon
Elastic Container Service Developer Guide.   You can optionally specify a deployment
configuration for your service. The deployment is initiated by changing properties. For
example, the deployment might be initiated by the task definition or by your desired count
of a service. This is done with an UpdateService operation. The default value for a replica
service for minimumHealthyPercent is 100%. The default value for a daemon service for
minimumHealthyPercent is 0%. If a service uses the ECS deployment controller, the minimum
healthy percent represents a lower limit on the number of tasks in a service that must
remain in the RUNNING state during a deployment. Specifically, it represents it as a
percentage of your desired number of tasks (rounded up to the nearest integer). This
happens when any of your container instances are in the DRAINING state if the service
contains tasks using the EC2 launch type. Using this parameter, you can deploy without
using additional cluster capacity. For example, if you set your service to have desired
number of four tasks and a minimum healthy percent of 50%, the scheduler might stop two
existing tasks to free up cluster capacity before starting two new tasks. If they're in the
RUNNING state, tasks for services that don't use a load balancer are considered healthy .
If they're in the RUNNING state and reported as healthy by the load balancer, tasks for
services that do use a load balancer are considered healthy . The default value for minimum
healthy percent is 100%. If a service uses the ECS deployment controller, the maximum
percent parameter represents an upper limit on the number of tasks in a service that are
allowed in the RUNNING or PENDING state during a deployment. Specifically, it represents it
as a percentage of the desired number of tasks (rounded down to the nearest integer). This
happens when any of your container instances are in the DRAINING state if the service
contains tasks using the EC2 launch type. Using this parameter, you can define the
deployment batch size. For example, if your service has a desired number of four tasks and
a maximum percent value of 200%, the scheduler may start four new tasks before stopping the
four older tasks (provided that the cluster resources required to do this are available).
The default value for maximum percent is 200%. If a service uses either the CODE_DEPLOY or
EXTERNAL deployment controller types and tasks that use the EC2 launch type, the minimum
healthy percent and maximum percent values are used only to define the lower and upper
limit on the number of the tasks in the service that remain in the RUNNING state. This is
while the container instances are in the DRAINING state. If the tasks in the service use
the Fargate launch type, the minimum healthy percent and maximum percent values aren't
used. This is the case even if they're currently visible when describing your service. When
creating a service that uses the EXTERNAL deployment controller, you can specify only
parameters that aren't controlled at the task set level. The only required parameter is the
service name. You control your services using the CreateTaskSet operation. For more
information, see Amazon ECS deployment types in the Amazon Elastic Container Service
Developer Guide. When the service scheduler launches new tasks, it determines task
placement. For information about task placement and task placement strategies, see Amazon
ECS task placement in the Amazon Elastic Container Service Developer Guide  Starting April
15, 2023, Amazon Web Services will not onboard new customers to Amazon Elastic Inference
(EI), and will help current customers migrate their workloads to options that offer better
price and performance. After April 15, 2023, new customers will not be able to launch
instances with Amazon EI accelerators in Amazon SageMaker, Amazon ECS, or Amazon EC2.
However, customers who have used Amazon EI at least once during the past 30-day period are
considered current customers and will be able to continue using the service.

# Arguments
- `service_name`: The name of your service. Up to 255 letters (uppercase and lowercase),
  numbers, underscores, and hyphens are allowed. Service names must be unique within a
  cluster, but you can have similarly named services in multiple clusters within a Region or
  across multiple Regions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"capacityProviderStrategy"`: The capacity provider strategy to use for the service. If a
  capacityProviderStrategy is specified, the launchType parameter must be omitted. If no
  capacityProviderStrategy or launchType is specified, the defaultCapacityProviderStrategy
  for the cluster is used. A capacity provider strategy may contain a maximum of 6 capacity
  providers.
- `"clientToken"`: An identifier that you provide to ensure the idempotency of the request.
  It must be unique and is case sensitive. Up to 36 ASCII characters in the range of 33-126
  (inclusive) are allowed.
- `"cluster"`: The short name or full Amazon Resource Name (ARN) of the cluster that you
  run your service on. If you do not specify a cluster, the default cluster is assumed.
- `"deploymentConfiguration"`: Optional deployment parameters that control how many tasks
  run during the deployment and the ordering of stopping and starting tasks.
- `"deploymentController"`: The deployment controller to use for the service. If no
  deployment controller is specified, the default value of ECS is used.
- `"desiredCount"`: The number of instantiations of the specified task definition to place
  and keep running in your service. This is required if schedulingStrategy is REPLICA or
  isn't specified. If schedulingStrategy is DAEMON then this isn't required.
- `"enableECSManagedTags"`: Specifies whether to turn on Amazon ECS managed tags for the
  tasks within the service. For more information, see Tagging your Amazon ECS resources in
  the Amazon Elastic Container Service Developer Guide. When you use Amazon ECS managed tags,
  you need to set the propagateTags request parameter.
- `"enableExecuteCommand"`: Determines whether the execute command functionality is turned
  on for the service. If true, this enables execute command functionality on all containers
  in the service tasks.
- `"healthCheckGracePeriodSeconds"`: The period of time, in seconds, that the Amazon ECS
  service scheduler ignores unhealthy Elastic Load Balancing target health checks after a
  task has first started. This is only used when your service is configured to use a load
  balancer. If your service has a load balancer defined and you don't specify a health check
  grace period value, the default value of 0 is used. If you do not use an Elastic Load
  Balancing, we recommend that you use the startPeriod in the task definition health check
  parameters. For more information, see Health check. If your service's tasks take a while to
  start and respond to Elastic Load Balancing health checks, you can specify a health check
  grace period of up to 2,147,483,647 seconds (about 69 years). During that time, the Amazon
  ECS service scheduler ignores health check status. This grace period can prevent the
  service scheduler from marking tasks as unhealthy and stopping them before they have time
  to come up.
- `"launchType"`: The infrastructure that you run your service on. For more information,
  see Amazon ECS launch types in the Amazon Elastic Container Service Developer Guide. The
  FARGATE launch type runs your tasks on Fargate On-Demand infrastructure.  Fargate Spot
  infrastructure is available for use but a capacity provider strategy must be used. For more
  information, see Fargate capacity providers in the Amazon ECS Developer Guide.  The EC2
  launch type runs your tasks on Amazon EC2 instances registered to your cluster. The
  EXTERNAL launch type runs your tasks on your on-premises server or virtual machine (VM)
  capacity registered to your cluster. A service can use either a launch type or a capacity
  provider strategy. If a launchType is specified, the capacityProviderStrategy parameter
  must be omitted.
- `"loadBalancers"`: A load balancer object representing the load balancers to use with
  your service. For more information, see Service load balancing in the Amazon Elastic
  Container Service Developer Guide. If the service uses the rolling update (ECS) deployment
  controller and using either an Application Load Balancer or Network Load Balancer, you must
  specify one or more target group ARNs to attach to the service. The service-linked role is
  required for services that use multiple target groups. For more information, see Using
  service-linked roles for Amazon ECS in the Amazon Elastic Container Service Developer
  Guide. If the service uses the CODE_DEPLOY deployment controller, the service is required
  to use either an Application Load Balancer or Network Load Balancer. When creating an
  CodeDeploy deployment group, you specify two target groups (referred to as a
  targetGroupPair). During a deployment, CodeDeploy determines which task set in your service
  has the status PRIMARY, and it associates one target group with it. Then, it also
  associates the other target group with the replacement task set. The load balancer can also
  have up to two listeners: a required listener for production traffic and an optional
  listener that you can use to perform validation tests with Lambda functions before routing
  production traffic to it. If you use the CODE_DEPLOY deployment controller, these values
  can be changed when updating the service. For Application Load Balancers and Network Load
  Balancers, this object must contain the load balancer target group ARN, the container name,
  and the container port to access from the load balancer. The container name must be as it
  appears in a container definition. The load balancer name parameter must be omitted. When a
  task from this service is placed on a container instance, the container instance and port
  combination is registered as a target in the target group that's specified here. For
  Classic Load Balancers, this object must contain the load balancer name, the container name
  , and the container port to access from the load balancer. The container name must be as it
  appears in a container definition. The target group ARN parameter must be omitted. When a
  task from this service is placed on a container instance, the container instance is
  registered with the load balancer that's specified here. Services with tasks that use the
  awsvpc network mode (for example, those with the Fargate launch type) only support
  Application Load Balancers and Network Load Balancers. Classic Load Balancers aren't
  supported. Also, when you create any target groups for these services, you must choose ip
  as the target type, not instance. This is because tasks that use the awsvpc network mode
  are associated with an elastic network interface, not an Amazon EC2 instance.
- `"networkConfiguration"`: The network configuration for the service. This parameter is
  required for task definitions that use the awsvpc network mode to receive their own elastic
  network interface, and it isn't supported for other network modes. For more information,
  see Task networking in the Amazon Elastic Container Service Developer Guide.
- `"placementConstraints"`: An array of placement constraint objects to use for tasks in
  your service. You can specify a maximum of 10 constraints for each task. This limit
  includes constraints in the task definition and those specified at runtime.
- `"placementStrategy"`: The placement strategy objects to use for tasks in your service.
  You can specify a maximum of 5 strategy rules for each service.
- `"platformVersion"`: The platform version that your tasks in the service are running on.
  A platform version is specified only for tasks using the Fargate launch type. If one isn't
  specified, the LATEST platform version is used. For more information, see Fargate platform
  versions in the Amazon Elastic Container Service Developer Guide.
- `"propagateTags"`: Specifies whether to propagate the tags from the task definition to
  the task. If no value is specified, the tags aren't propagated. Tags can only be propagated
  to the task during task creation. To add tags to a task after task creation, use the
  TagResource API action. You must set this to a value other than NONE when you use Cost
  Explorer. For more information, see Amazon ECS usage reports in the Amazon Elastic
  Container Service Developer Guide. The default is NONE.
- `"role"`: The name or full Amazon Resource Name (ARN) of the IAM role that allows Amazon
  ECS to make calls to your load balancer on your behalf. This parameter is only permitted if
  you are using a load balancer with your service and your task definition doesn't use the
  awsvpc network mode. If you specify the role parameter, you must also specify a load
  balancer object with the loadBalancers parameter.  If your account has already created the
  Amazon ECS service-linked role, that role is used for your service unless you specify a
  role here. The service-linked role is required if your task definition uses the awsvpc
  network mode or if the service is configured to use service discovery, an external
  deployment controller, multiple target groups, or Elastic Inference accelerators in which
  case you don't specify a role here. For more information, see Using service-linked roles
  for Amazon ECS in the Amazon Elastic Container Service Developer Guide.  If your specified
  role has a path other than /, then you must either specify the full role ARN (this is
  recommended) or prefix the role name with the path. For example, if a role with the name
  bar has a path of /foo/ then you would specify /foo/bar as the role name. For more
  information, see Friendly names and paths in the IAM User Guide.
- `"schedulingStrategy"`: The scheduling strategy to use for the service. For more
  information, see Services. There are two service scheduler strategies available:
  REPLICA-The replica scheduling strategy places and maintains the desired number of tasks
  across your cluster. By default, the service scheduler spreads tasks across Availability
  Zones. You can use task placement strategies and constraints to customize task placement
  decisions. This scheduler strategy is required if the service uses the CODE_DEPLOY or
  EXTERNAL deployment controller types.    DAEMON-The daemon scheduling strategy deploys
  exactly one task on each active container instance that meets all of the task placement
  constraints that you specify in your cluster. The service scheduler also evaluates the task
  placement constraints for running tasks and will stop tasks that don't meet the placement
  constraints. When you're using this strategy, you don't need to specify a desired number of
  tasks, a task placement strategy, or use Service Auto Scaling policies.  Tasks using the
  Fargate launch type or the CODE_DEPLOY or EXTERNAL deployment controller types don't
  support the DAEMON scheduling strategy.
- `"serviceConnectConfiguration"`: The configuration for this service to discover and
  connect to services, and be discovered by, and connected from, other services within a
  namespace. Tasks that run in a namespace can use short names to connect to services in the
  namespace. Tasks can connect to services across all of the clusters in the namespace. Tasks
  connect through a managed proxy container that collects logs and metrics for increased
  visibility. Only the tasks that Amazon ECS services create are supported with Service
  Connect. For more information, see Service Connect in the Amazon Elastic Container Service
  Developer Guide.
- `"serviceRegistries"`: The details of the service discovery registry to associate with
  this service. For more information, see Service discovery.  Each service may be associated
  with one service registry. Multiple service registries for each service isn't supported.
- `"tags"`: The metadata that you apply to the service to help you categorize and organize
  them. Each tag consists of a key and an optional value, both of which you define. When a
  service is deleted, the tags are deleted as well. The following basic restrictions apply to
  tags:   Maximum number of tags per resource - 50   For each resource, each tag key must be
  unique, and each tag key can have only one value.   Maximum key length - 128 Unicode
  characters in UTF-8   Maximum value length - 256 Unicode characters in UTF-8   If your
  tagging schema is used across multiple services and resources, remember that other services
  may have restrictions on allowed characters. Generally allowed characters are: letters,
  numbers, and spaces representable in UTF-8, and the following characters: + - = . _ : / @.
   Tag keys and values are case-sensitive.   Do not use aws:, AWS:, or any upper or lowercase
  combination of such as a prefix for either keys or values as it is reserved for Amazon Web
  Services use. You cannot edit or delete tag keys or values with this prefix. Tags with this
  prefix do not count against your tags per resource limit.
- `"taskDefinition"`: The family and revision (family:revision) or full ARN of the task
  definition to run in your service. If a revision isn't specified, the latest ACTIVE
  revision is used. A task definition must be specified if the service uses either the ECS or
  CODE_DEPLOY deployment controllers. For more information about deployment types, see Amazon
  ECS deployment types.
- `"volumeConfigurations"`: The configuration for a volume specified in the task definition
  as a volume that is configured at launch time. Currently, the only supported volume type is
  an Amazon EBS volume.
"""
function create_service(serviceName; aws_config::AbstractAWSConfig=current_aws_config())
    return ecs(
        "CreateService",
        Dict{String,Any}("serviceName" => serviceName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_service(
    serviceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecs(
        "CreateService",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("serviceName" => serviceName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_task_set(cluster, service, task_definition)
    create_task_set(cluster, service, task_definition, params::Dict{String,<:Any})

Create a task set in the specified cluster and service. This is used when a service uses
the EXTERNAL deployment controller type. For more information, see Amazon ECS deployment
types in the Amazon Elastic Container Service Developer Guide.  On March 21, 2024, a change
was made to resolve the task definition revision before authorization. When a task
definition revision is not specified, authorization will occur using the latest revision of
a task definition.  For information about the maximum number of task sets and otther
quotas, see Amazon ECS service quotas in the Amazon Elastic Container Service Developer
Guide.

# Arguments
- `cluster`: The short name or full Amazon Resource Name (ARN) of the cluster that hosts
  the service to create the task set in.
- `service`: The short name or full Amazon Resource Name (ARN) of the service to create the
  task set in.
- `task_definition`: The task definition for the tasks in the task set to use. If a
  revision isn't specified, the latest ACTIVE revision is used.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"capacityProviderStrategy"`: The capacity provider strategy to use for the task set. A
  capacity provider strategy consists of one or more capacity providers along with the base
  and weight to assign to them. A capacity provider must be associated with the cluster to be
  used in a capacity provider strategy. The PutClusterCapacityProviders API is used to
  associate a capacity provider with a cluster. Only capacity providers with an ACTIVE or
  UPDATING status can be used. If a capacityProviderStrategy is specified, the launchType
  parameter must be omitted. If no capacityProviderStrategy or launchType is specified, the
  defaultCapacityProviderStrategy for the cluster is used. If specifying a capacity provider
  that uses an Auto Scaling group, the capacity provider must already be created. New
  capacity providers can be created with the CreateCapacityProvider API operation. To use a
  Fargate capacity provider, specify either the FARGATE or FARGATE_SPOT capacity providers.
  The Fargate capacity providers are available to all accounts and only need to be associated
  with a cluster to be used. The PutClusterCapacityProviders API operation is used to update
  the list of available capacity providers for a cluster after the cluster is created.
- `"clientToken"`: An identifier that you provide to ensure the idempotency of the request.
  It must be unique and is case sensitive. Up to 36 ASCII characters in the range of 33-126
  (inclusive) are allowed.
- `"externalId"`: An optional non-unique tag that identifies this task set in external
  systems. If the task set is associated with a service discovery registry, the tasks in this
  task set will have the ECS_TASK_SET_EXTERNAL_ID Cloud Map attribute set to the provided
  value.
- `"launchType"`: The launch type that new tasks in the task set uses. For more
  information, see Amazon ECS launch types in the Amazon Elastic Container Service Developer
  Guide. If a launchType is specified, the capacityProviderStrategy parameter must be omitted.
- `"loadBalancers"`: A load balancer object representing the load balancer to use with the
  task set. The supported load balancer types are either an Application Load Balancer or a
  Network Load Balancer.
- `"networkConfiguration"`: An object representing the network configuration for a task set.
- `"platformVersion"`: The platform version that the tasks in the task set uses. A platform
  version is specified only for tasks using the Fargate launch type. If one isn't specified,
  the LATEST platform version is used.
- `"scale"`: A floating-point percentage of the desired number of tasks to place and keep
  running in the task set.
- `"serviceRegistries"`: The details of the service discovery registries to assign to this
  task set. For more information, see Service discovery.
- `"tags"`: The metadata that you apply to the task set to help you categorize and organize
  them. Each tag consists of a key and an optional value. You define both. When a service is
  deleted, the tags are deleted. The following basic restrictions apply to tags:   Maximum
  number of tags per resource - 50   For each resource, each tag key must be unique, and each
  tag key can have only one value.   Maximum key length - 128 Unicode characters in UTF-8
  Maximum value length - 256 Unicode characters in UTF-8   If your tagging schema is used
  across multiple services and resources, remember that other services may have restrictions
  on allowed characters. Generally allowed characters are: letters, numbers, and spaces
  representable in UTF-8, and the following characters: + - = . _ : / @.   Tag keys and
  values are case-sensitive.   Do not use aws:, AWS:, or any upper or lowercase combination
  of such as a prefix for either keys or values as it is reserved for Amazon Web Services
  use. You cannot edit or delete tag keys or values with this prefix. Tags with this prefix
  do not count against your tags per resource limit.
"""
function create_task_set(
    cluster, service, taskDefinition; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecs(
        "CreateTaskSet",
        Dict{String,Any}(
            "cluster" => cluster, "service" => service, "taskDefinition" => taskDefinition
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_task_set(
    cluster,
    service,
    taskDefinition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecs(
        "CreateTaskSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "cluster" => cluster,
                    "service" => service,
                    "taskDefinition" => taskDefinition,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_account_setting(name)
    delete_account_setting(name, params::Dict{String,<:Any})

Disables an account setting for a specified user, role, or the root user for an account.

# Arguments
- `name`: The resource name to disable the account setting for. If serviceLongArnFormat is
  specified, the ARN for your Amazon ECS services is affected. If taskLongArnFormat is
  specified, the ARN and resource ID for your Amazon ECS tasks is affected. If
  containerInstanceLongArnFormat is specified, the ARN and resource ID for your Amazon ECS
  container instances is affected. If awsvpcTrunking is specified, the ENI limit for your
  Amazon ECS container instances is affected.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"principalArn"`: The Amazon Resource Name (ARN) of the principal. It can be an user,
  role, or the root user. If you specify the root user, it disables the account setting for
  all users, roles, and the root user of the account unless a user or role explicitly
  overrides these settings. If this field is omitted, the setting is changed only for the
  authenticated user.
"""
function delete_account_setting(name; aws_config::AbstractAWSConfig=current_aws_config())
    return ecs(
        "DeleteAccountSetting",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_account_setting(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecs(
        "DeleteAccountSetting",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_attributes(attributes)
    delete_attributes(attributes, params::Dict{String,<:Any})

Deletes one or more custom attributes from an Amazon ECS resource.

# Arguments
- `attributes`: The attributes to delete from your resource. You can specify up to 10
  attributes for each request. For custom attributes, specify the attribute name and target
  ID, but don't specify the value. If you specify the target ID using the short form, you
  must also specify the target type.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"cluster"`: The short name or full Amazon Resource Name (ARN) of the cluster that
  contains the resource to delete attributes. If you do not specify a cluster, the default
  cluster is assumed.
"""
function delete_attributes(attributes; aws_config::AbstractAWSConfig=current_aws_config())
    return ecs(
        "DeleteAttributes",
        Dict{String,Any}("attributes" => attributes);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_attributes(
    attributes,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecs(
        "DeleteAttributes",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("attributes" => attributes), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_capacity_provider(capacity_provider)
    delete_capacity_provider(capacity_provider, params::Dict{String,<:Any})

Deletes the specified capacity provider.  The FARGATE and FARGATE_SPOT capacity providers
are reserved and can't be deleted. You can disassociate them from a cluster using either
the PutClusterCapacityProviders API or by deleting the cluster.  Prior to a capacity
provider being deleted, the capacity provider must be removed from the capacity provider
strategy from all services. The UpdateService API can be used to remove a capacity provider
from a service's capacity provider strategy. When updating a service, the
forceNewDeployment option can be used to ensure that any tasks using the Amazon EC2
instance capacity provided by the capacity provider are transitioned to use the capacity
from the remaining capacity providers. Only capacity providers that aren't associated with
a cluster can be deleted. To remove a capacity provider from a cluster, you can either use
PutClusterCapacityProviders or delete the cluster.

# Arguments
- `capacity_provider`: The short name or full Amazon Resource Name (ARN) of the capacity
  provider to delete.

"""
function delete_capacity_provider(
    capacityProvider; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecs(
        "DeleteCapacityProvider",
        Dict{String,Any}("capacityProvider" => capacityProvider);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_capacity_provider(
    capacityProvider,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecs(
        "DeleteCapacityProvider",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("capacityProvider" => capacityProvider), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_cluster(cluster)
    delete_cluster(cluster, params::Dict{String,<:Any})

Deletes the specified cluster. The cluster transitions to the INACTIVE state. Clusters with
an INACTIVE status might remain discoverable in your account for a period of time. However,
this behavior is subject to change in the future. We don't recommend that you rely on
INACTIVE clusters persisting. You must deregister all container instances from this cluster
before you may delete it. You can list the container instances in a cluster with
ListContainerInstances and deregister them with DeregisterContainerInstance.

# Arguments
- `cluster`: The short name or full Amazon Resource Name (ARN) of the cluster to delete.

"""
function delete_cluster(cluster; aws_config::AbstractAWSConfig=current_aws_config())
    return ecs(
        "DeleteCluster",
        Dict{String,Any}("cluster" => cluster);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_cluster(
    cluster,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecs(
        "DeleteCluster",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("cluster" => cluster), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_service(service)
    delete_service(service, params::Dict{String,<:Any})

Deletes a specified service within a cluster. You can delete a service if you have no
running tasks in it and the desired task count is zero. If the service is actively
maintaining tasks, you can't delete it, and you must update the service to a desired task
count of zero. For more information, see UpdateService.  When you delete a service, if
there are still running tasks that require cleanup, the service status moves from ACTIVE to
DRAINING, and the service is no longer visible in the console or in the ListServices API
operation. After all tasks have transitioned to either STOPPING or STOPPED status, the
service status moves from DRAINING to INACTIVE. Services in the DRAINING or INACTIVE status
can still be viewed with the DescribeServices API operation. However, in the future,
INACTIVE services may be cleaned up and purged from Amazon ECS record keeping, and
DescribeServices calls on those services return a ServiceNotFoundException error.   If you
attempt to create a new service with the same name as an existing service in either ACTIVE
or DRAINING status, you receive an error.

# Arguments
- `service`: The name of the service to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"cluster"`: The short name or full Amazon Resource Name (ARN) of the cluster that hosts
  the service to delete. If you do not specify a cluster, the default cluster is assumed.
- `"force"`: If true, allows you to delete a service even if it wasn't scaled down to zero
  tasks. It's only necessary to use this if the service uses the REPLICA scheduling strategy.
"""
function delete_service(service; aws_config::AbstractAWSConfig=current_aws_config())
    return ecs(
        "DeleteService",
        Dict{String,Any}("service" => service);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_service(
    service,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecs(
        "DeleteService",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("service" => service), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_task_definitions(task_definitions)
    delete_task_definitions(task_definitions, params::Dict{String,<:Any})

Deletes one or more task definitions. You must deregister a task definition revision before
you delete it. For more information, see DeregisterTaskDefinition. When you delete a task
definition revision, it is immediately transitions from the INACTIVE to DELETE_IN_PROGRESS.
Existing tasks and services that reference a DELETE_IN_PROGRESS task definition revision
continue to run without disruption. Existing services that reference a DELETE_IN_PROGRESS
task definition revision can still scale up or down by modifying the service's desired
count. You can't use a DELETE_IN_PROGRESS task definition revision to run new tasks or
create new services. You also can't update an existing service to reference a
DELETE_IN_PROGRESS task definition revision.  A task definition revision will stay in
DELETE_IN_PROGRESS status until all the associated tasks and services have been terminated.
When you delete all INACTIVE task definition revisions, the task definition name is not
displayed in the console and not returned in the API. If a task definition revisions are in
the DELETE_IN_PROGRESS state, the task definition name is displayed in the console and
returned in the API. The task definition name is retained by Amazon ECS and the revision is
incremented the next time you create a task definition with that name.

# Arguments
- `task_definitions`: The family and revision (family:revision) or full Amazon Resource
  Name (ARN) of the task definition to delete. You must specify a revision. You can specify
  up to 10 task definitions as a comma separated list.

"""
function delete_task_definitions(
    taskDefinitions; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecs(
        "DeleteTaskDefinitions",
        Dict{String,Any}("taskDefinitions" => taskDefinitions);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_task_definitions(
    taskDefinitions,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecs(
        "DeleteTaskDefinitions",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("taskDefinitions" => taskDefinitions), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_task_set(cluster, service, task_set)
    delete_task_set(cluster, service, task_set, params::Dict{String,<:Any})

Deletes a specified task set within a service. This is used when a service uses the
EXTERNAL deployment controller type. For more information, see Amazon ECS deployment types
in the Amazon Elastic Container Service Developer Guide.

# Arguments
- `cluster`: The short name or full Amazon Resource Name (ARN) of the cluster that hosts
  the service that the task set found in to delete.
- `service`: The short name or full Amazon Resource Name (ARN) of the service that hosts
  the task set to delete.
- `task_set`: The task set ID or full Amazon Resource Name (ARN) of the task set to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"force"`: If true, you can delete a task set even if it hasn't been scaled down to zero.
"""
function delete_task_set(
    cluster, service, taskSet; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecs(
        "DeleteTaskSet",
        Dict{String,Any}("cluster" => cluster, "service" => service, "taskSet" => taskSet);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_task_set(
    cluster,
    service,
    taskSet,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecs(
        "DeleteTaskSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "cluster" => cluster, "service" => service, "taskSet" => taskSet
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    deregister_container_instance(container_instance)
    deregister_container_instance(container_instance, params::Dict{String,<:Any})

Deregisters an Amazon ECS container instance from the specified cluster. This instance is
no longer available to run tasks. If you intend to use the container instance for some
other purpose after deregistration, we recommend that you stop all of the tasks running on
the container instance before deregistration. That prevents any orphaned tasks from
consuming resources. Deregistering a container instance removes the instance from a
cluster, but it doesn't terminate the EC2 instance. If you are finished using the instance,
be sure to terminate it in the Amazon EC2 console to stop billing.  If you terminate a
running container instance, Amazon ECS automatically deregisters the instance from your
cluster (stopped container instances or instances with disconnected agents aren't
automatically deregistered when terminated).

# Arguments
- `container_instance`: The container instance ID or full ARN of the container instance to
  deregister. For more information about the ARN format, see Amazon Resource Name (ARN) in
  the Amazon ECS Developer Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"cluster"`: The short name or full Amazon Resource Name (ARN) of the cluster that hosts
  the container instance to deregister. If you do not specify a cluster, the default cluster
  is assumed.
- `"force"`: Forces the container instance to be deregistered. If you have tasks running on
  the container instance when you deregister it with the force option, these tasks remain
  running until you terminate the instance or the tasks stop through some other means, but
  they're orphaned (no longer monitored or accounted for by Amazon ECS). If an orphaned task
  on your container instance is part of an Amazon ECS service, then the service scheduler
  starts another copy of that task, on a different container instance if possible.  Any
  containers in orphaned service tasks that are registered with a Classic Load Balancer or an
  Application Load Balancer target group are deregistered. They begin connection draining
  according to the settings on the load balancer or target group.
"""
function deregister_container_instance(
    containerInstance; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecs(
        "DeregisterContainerInstance",
        Dict{String,Any}("containerInstance" => containerInstance);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function deregister_container_instance(
    containerInstance,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecs(
        "DeregisterContainerInstance",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("containerInstance" => containerInstance), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    deregister_task_definition(task_definition)
    deregister_task_definition(task_definition, params::Dict{String,<:Any})

Deregisters the specified task definition by family and revision. Upon deregistration, the
task definition is marked as INACTIVE. Existing tasks and services that reference an
INACTIVE task definition continue to run without disruption. Existing services that
reference an INACTIVE task definition can still scale up or down by modifying the service's
desired count. If you want to delete a task definition revision, you must first deregister
the task definition revision. You can't use an INACTIVE task definition to run new tasks or
create new services, and you can't update an existing service to reference an INACTIVE task
definition. However, there may be up to a 10-minute window following deregistration where
these restrictions have not yet taken effect.  At this time, INACTIVE task definitions
remain discoverable in your account indefinitely. However, this behavior is subject to
change in the future. We don't recommend that you rely on INACTIVE task definitions
persisting beyond the lifecycle of any associated tasks and services.  You must deregister
a task definition revision before you delete it. For more information, see
DeleteTaskDefinitions.

# Arguments
- `task_definition`: The family and revision (family:revision) or full Amazon Resource Name
  (ARN) of the task definition to deregister. You must specify a revision.

"""
function deregister_task_definition(
    taskDefinition; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecs(
        "DeregisterTaskDefinition",
        Dict{String,Any}("taskDefinition" => taskDefinition);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function deregister_task_definition(
    taskDefinition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecs(
        "DeregisterTaskDefinition",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("taskDefinition" => taskDefinition), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_capacity_providers()
    describe_capacity_providers(params::Dict{String,<:Any})

Describes one or more of your capacity providers.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"capacityProviders"`: The short name or full Amazon Resource Name (ARN) of one or more
  capacity providers. Up to 100 capacity providers can be described in an action.
- `"include"`: Specifies whether or not you want to see the resource tags for the capacity
  provider. If TAGS is specified, the tags are included in the response. If this field is
  omitted, tags aren't included in the response.
- `"maxResults"`: The maximum number of account setting results returned by
  DescribeCapacityProviders in paginated output. When this parameter is used,
  DescribeCapacityProviders only returns maxResults results in a single page along with a
  nextToken response element. The remaining results of the initial request can be seen by
  sending another DescribeCapacityProviders request with the returned nextToken value. This
  value can be between 1 and 10. If this parameter is not used, then
  DescribeCapacityProviders returns up to 10 results and a nextToken value if applicable.
- `"nextToken"`: The nextToken value returned from a previous paginated
  DescribeCapacityProviders request where maxResults was used and the results exceeded the
  value of that parameter. Pagination continues from the end of the previous results that
  returned the nextToken value.  This token should be treated as an opaque identifier that is
  only used to retrieve the next items in a list and not for other programmatic purposes.
"""
function describe_capacity_providers(; aws_config::AbstractAWSConfig=current_aws_config())
    return ecs(
        "DescribeCapacityProviders"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_capacity_providers(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecs(
        "DescribeCapacityProviders",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_clusters()
    describe_clusters(params::Dict{String,<:Any})

Describes one or more of your clusters.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clusters"`: A list of up to 100 cluster names or full cluster Amazon Resource Name
  (ARN) entries. If you do not specify a cluster, the default cluster is assumed.
- `"include"`: Determines whether to include additional information about the clusters in
  the response. If this field is omitted, this information isn't included. If ATTACHMENTS is
  specified, the attachments for the container instances or tasks within the cluster are
  included, for example the capacity providers. If SETTINGS is specified, the settings for
  the cluster are included. If CONFIGURATIONS is specified, the configuration for the cluster
  is included. If STATISTICS is specified, the task and service count is included, separated
  by launch type. If TAGS is specified, the metadata tags associated with the cluster are
  included.
"""
function describe_clusters(; aws_config::AbstractAWSConfig=current_aws_config())
    return ecs("DescribeClusters"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function describe_clusters(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecs(
        "DescribeClusters", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_container_instances(container_instances)
    describe_container_instances(container_instances, params::Dict{String,<:Any})

Describes one or more container instances. Returns metadata about each container instance
requested.

# Arguments
- `container_instances`: A list of up to 100 container instance IDs or full Amazon Resource
  Name (ARN) entries.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"cluster"`: The short name or full Amazon Resource Name (ARN) of the cluster that hosts
  the container instances to describe. If you do not specify a cluster, the default cluster
  is assumed. This parameter is required if the container instance or container instances you
  are describing were launched in any cluster other than the default cluster.
- `"include"`: Specifies whether you want to see the resource tags for the container
  instance. If TAGS is specified, the tags are included in the response. If
  CONTAINER_INSTANCE_HEALTH is specified, the container instance health is included in the
  response. If this field is omitted, tags and container instance health status aren't
  included in the response.
"""
function describe_container_instances(
    containerInstances; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecs(
        "DescribeContainerInstances",
        Dict{String,Any}("containerInstances" => containerInstances);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_container_instances(
    containerInstances,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecs(
        "DescribeContainerInstances",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("containerInstances" => containerInstances), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_services(services)
    describe_services(services, params::Dict{String,<:Any})

Describes the specified services running in your cluster.

# Arguments
- `services`: A list of services to describe. You may specify up to 10 services to describe
  in a single operation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"cluster"`: The short name or full Amazon Resource Name (ARN)the cluster that hosts the
  service to describe. If you do not specify a cluster, the default cluster is assumed. This
  parameter is required if the service or services you are describing were launched in any
  cluster other than the default cluster.
- `"include"`: Determines whether you want to see the resource tags for the service. If
  TAGS is specified, the tags are included in the response. If this field is omitted, tags
  aren't included in the response.
"""
function describe_services(services; aws_config::AbstractAWSConfig=current_aws_config())
    return ecs(
        "DescribeServices",
        Dict{String,Any}("services" => services);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_services(
    services,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecs(
        "DescribeServices",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("services" => services), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_task_definition(task_definition)
    describe_task_definition(task_definition, params::Dict{String,<:Any})

Describes a task definition. You can specify a family and revision to find information
about a specific task definition, or you can simply specify the family to find the latest
ACTIVE revision in that family.  You can only describe INACTIVE task definitions while an
active task or service references them.

# Arguments
- `task_definition`: The family for the latest ACTIVE revision, family and revision
  (family:revision) for a specific revision in the family, or full Amazon Resource Name (ARN)
  of the task definition to describe.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"include"`: Determines whether to see the resource tags for the task definition. If TAGS
  is specified, the tags are included in the response. If this field is omitted, tags aren't
  included in the response.
"""
function describe_task_definition(
    taskDefinition; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecs(
        "DescribeTaskDefinition",
        Dict{String,Any}("taskDefinition" => taskDefinition);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_task_definition(
    taskDefinition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecs(
        "DescribeTaskDefinition",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("taskDefinition" => taskDefinition), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_task_sets(cluster, service)
    describe_task_sets(cluster, service, params::Dict{String,<:Any})

Describes the task sets in the specified cluster and service. This is used when a service
uses the EXTERNAL deployment controller type. For more information, see Amazon ECS
Deployment Types in the Amazon Elastic Container Service Developer Guide.

# Arguments
- `cluster`: The short name or full Amazon Resource Name (ARN) of the cluster that hosts
  the service that the task sets exist in.
- `service`: The short name or full Amazon Resource Name (ARN) of the service that the task
  sets exist in.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"include"`: Specifies whether to see the resource tags for the task set. If TAGS is
  specified, the tags are included in the response. If this field is omitted, tags aren't
  included in the response.
- `"taskSets"`: The ID or full Amazon Resource Name (ARN) of task sets to describe.
"""
function describe_task_sets(
    cluster, service; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecs(
        "DescribeTaskSets",
        Dict{String,Any}("cluster" => cluster, "service" => service);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_task_sets(
    cluster,
    service,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecs(
        "DescribeTaskSets",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("cluster" => cluster, "service" => service), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_tasks(tasks)
    describe_tasks(tasks, params::Dict{String,<:Any})

Describes a specified task or tasks. Currently, stopped tasks appear in the returned
results for at least one hour. If you have tasks with tags, and then delete the cluster,
the tagged tasks are returned in the response. If you create a new cluster with the same
name as the deleted cluster, the tagged tasks are not included in the response.

# Arguments
- `tasks`: A list of up to 100 task IDs or full ARN entries.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"cluster"`: The short name or full Amazon Resource Name (ARN) of the cluster that hosts
  the task or tasks to describe. If you do not specify a cluster, the default cluster is
  assumed. This parameter is required if the task or tasks you are describing were launched
  in any cluster other than the default cluster.
- `"include"`: Specifies whether you want to see the resource tags for the task. If TAGS is
  specified, the tags are included in the response. If this field is omitted, tags aren't
  included in the response.
"""
function describe_tasks(tasks; aws_config::AbstractAWSConfig=current_aws_config())
    return ecs(
        "DescribeTasks",
        Dict{String,Any}("tasks" => tasks);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_tasks(
    tasks, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecs(
        "DescribeTasks",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tasks" => tasks), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    discover_poll_endpoint()
    discover_poll_endpoint(params::Dict{String,<:Any})

 This action is only used by the Amazon ECS agent, and it is not intended for use outside
of the agent.  Returns an endpoint for the Amazon ECS agent to poll for updates.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"cluster"`: The short name or full Amazon Resource Name (ARN) of the cluster that the
  container instance belongs to.
- `"containerInstance"`: The container instance ID or full ARN of the container instance.
  For more information about the ARN format, see Amazon Resource Name (ARN) in the Amazon ECS
  Developer Guide.
"""
function discover_poll_endpoint(; aws_config::AbstractAWSConfig=current_aws_config())
    return ecs(
        "DiscoverPollEndpoint"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function discover_poll_endpoint(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecs(
        "DiscoverPollEndpoint",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    execute_command(command, interactive, task)
    execute_command(command, interactive, task, params::Dict{String,<:Any})

Runs a command remotely on a container within a task. If you use a condition key in your
IAM policy to refine the conditions for the policy statement, for example limit the actions
to a specific cluster, you receive an AccessDeniedException when there is a mismatch
between the condition key value and the corresponding parameter value. For information
about required permissions and considerations, see Using Amazon ECS Exec for debugging in
the Amazon ECS Developer Guide.

# Arguments
- `command`: The command to run on the container.
- `interactive`: Use this flag to run your command in interactive mode.
- `task`: The Amazon Resource Name (ARN) or ID of the task the container is part of.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"cluster"`: The Amazon Resource Name (ARN) or short name of the cluster the task is
  running in. If you do not specify a cluster, the default cluster is assumed.
- `"container"`: The name of the container to execute the command on. A container name only
  needs to be specified for tasks containing multiple containers.
"""
function execute_command(
    command, interactive, task; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecs(
        "ExecuteCommand",
        Dict{String,Any}(
            "command" => command, "interactive" => interactive, "task" => task
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function execute_command(
    command,
    interactive,
    task,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecs(
        "ExecuteCommand",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "command" => command, "interactive" => interactive, "task" => task
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_task_protection(cluster)
    get_task_protection(cluster, params::Dict{String,<:Any})

Retrieves the protection status of tasks in an Amazon ECS service.

# Arguments
- `cluster`: The short name or full Amazon Resource Name (ARN) of the cluster that hosts
  the service that the task sets exist in.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tasks"`: A list of up to 100 task IDs or full ARN entries.
"""
function get_task_protection(cluster; aws_config::AbstractAWSConfig=current_aws_config())
    return ecs(
        "GetTaskProtection",
        Dict{String,Any}("cluster" => cluster);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_task_protection(
    cluster,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecs(
        "GetTaskProtection",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("cluster" => cluster), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_account_settings()
    list_account_settings(params::Dict{String,<:Any})

Lists the account settings for a specified principal.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"effectiveSettings"`: Determines whether to return the effective settings. If true, the
  account settings for the root user or the default setting for the principalArn are
  returned. If false, the account settings for the principalArn are returned if they're set.
  Otherwise, no account settings are returned.
- `"maxResults"`: The maximum number of account setting results returned by
  ListAccountSettings in paginated output. When this parameter is used, ListAccountSettings
  only returns maxResults results in a single page along with a nextToken response element.
  The remaining results of the initial request can be seen by sending another
  ListAccountSettings request with the returned nextToken value. This value can be between 1
  and 10. If this parameter isn't used, then ListAccountSettings returns up to 10 results and
  a nextToken value if applicable.
- `"name"`: The name of the account setting you want to list the settings for.
- `"nextToken"`: The nextToken value returned from a ListAccountSettings request indicating
  that more results are available to fulfill the request and further calls will be needed. If
  maxResults was provided, it's possible the number of results to be fewer than maxResults.
  This token should be treated as an opaque identifier that is only used to retrieve the next
  items in a list and not for other programmatic purposes.
- `"principalArn"`: The ARN of the principal, which can be a user, role, or the root user.
  If this field is omitted, the account settings are listed only for the authenticated user.
  Federated users assume the account setting of the root user and can't have explicit account
  settings set for them.
- `"value"`: The value of the account settings to filter results with. You must also
  specify an account setting name to use this parameter.
"""
function list_account_settings(; aws_config::AbstractAWSConfig=current_aws_config())
    return ecs(
        "ListAccountSettings"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_account_settings(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecs(
        "ListAccountSettings",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_attributes(target_type)
    list_attributes(target_type, params::Dict{String,<:Any})

Lists the attributes for Amazon ECS resources within a specified target type and cluster.
When you specify a target type and cluster, ListAttributes returns a list of attribute
objects, one for each attribute on each resource. You can filter the list of results to a
single attribute name to only return results that have that name. You can also filter the
results by attribute name and value. You can do this, for example, to see which container
instances in a cluster are running a Linux AMI (ecs.os-type=linux).

# Arguments
- `target_type`: The type of the target to list attributes with.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"attributeName"`: The name of the attribute to filter the results with.
- `"attributeValue"`: The value of the attribute to filter results with. You must also
  specify an attribute name to use this parameter.
- `"cluster"`: The short name or full Amazon Resource Name (ARN) of the cluster to list
  attributes. If you do not specify a cluster, the default cluster is assumed.
- `"maxResults"`: The maximum number of cluster results that ListAttributes returned in
  paginated output. When this parameter is used, ListAttributes only returns maxResults
  results in a single page along with a nextToken response element. The remaining results of
  the initial request can be seen by sending another ListAttributes request with the returned
  nextToken value. This value can be between 1 and 100. If this parameter isn't used, then
  ListAttributes returns up to 100 results and a nextToken value if applicable.
- `"nextToken"`: The nextToken value returned from a ListAttributes request indicating that
  more results are available to fulfill the request and further calls are needed. If
  maxResults was provided, it's possible the number of results to be fewer than maxResults.
  This token should be treated as an opaque identifier that is only used to retrieve the next
  items in a list and not for other programmatic purposes.
"""
function list_attributes(targetType; aws_config::AbstractAWSConfig=current_aws_config())
    return ecs(
        "ListAttributes",
        Dict{String,Any}("targetType" => targetType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_attributes(
    targetType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecs(
        "ListAttributes",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("targetType" => targetType), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_clusters()
    list_clusters(params::Dict{String,<:Any})

Returns a list of existing clusters.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of cluster results that ListClusters returned in
  paginated output. When this parameter is used, ListClusters only returns maxResults results
  in a single page along with a nextToken response element. The remaining results of the
  initial request can be seen by sending another ListClusters request with the returned
  nextToken value. This value can be between 1 and 100. If this parameter isn't used, then
  ListClusters returns up to 100 results and a nextToken value if applicable.
- `"nextToken"`: The nextToken value returned from a ListClusters request indicating that
  more results are available to fulfill the request and further calls are needed. If
  maxResults was provided, it's possible the number of results to be fewer than maxResults.
  This token should be treated as an opaque identifier that is only used to retrieve the next
  items in a list and not for other programmatic purposes.
"""
function list_clusters(; aws_config::AbstractAWSConfig=current_aws_config())
    return ecs("ListClusters"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_clusters(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecs(
        "ListClusters", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_container_instances()
    list_container_instances(params::Dict{String,<:Any})

Returns a list of container instances in a specified cluster. You can filter the results of
a ListContainerInstances operation with cluster query language statements inside the filter
parameter. For more information, see Cluster Query Language in the Amazon Elastic Container
Service Developer Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"cluster"`: The short name or full Amazon Resource Name (ARN) of the cluster that hosts
  the container instances to list. If you do not specify a cluster, the default cluster is
  assumed.
- `"filter"`: You can filter the results of a ListContainerInstances operation with cluster
  query language statements. For more information, see Cluster Query Language in the Amazon
  Elastic Container Service Developer Guide.
- `"maxResults"`: The maximum number of container instance results that
  ListContainerInstances returned in paginated output. When this parameter is used,
  ListContainerInstances only returns maxResults results in a single page along with a
  nextToken response element. The remaining results of the initial request can be seen by
  sending another ListContainerInstances request with the returned nextToken value. This
  value can be between 1 and 100. If this parameter isn't used, then ListContainerInstances
  returns up to 100 results and a nextToken value if applicable.
- `"nextToken"`: The nextToken value returned from a ListContainerInstances request
  indicating that more results are available to fulfill the request and further calls are
  needed. If maxResults was provided, it's possible the number of results to be fewer than
  maxResults.  This token should be treated as an opaque identifier that is only used to
  retrieve the next items in a list and not for other programmatic purposes.
- `"status"`: Filters the container instances by status. For example, if you specify the
  DRAINING status, the results include only container instances that have been set to
  DRAINING using UpdateContainerInstancesState. If you don't specify this parameter, the
  default is to include container instances set to all states other than INACTIVE.
"""
function list_container_instances(; aws_config::AbstractAWSConfig=current_aws_config())
    return ecs(
        "ListContainerInstances"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_container_instances(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecs(
        "ListContainerInstances",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_services()
    list_services(params::Dict{String,<:Any})

Returns a list of services. You can filter the results by cluster, launch type, and
scheduling strategy.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"cluster"`: The short name or full Amazon Resource Name (ARN) of the cluster to use when
  filtering the ListServices results. If you do not specify a cluster, the default cluster is
  assumed.
- `"launchType"`: The launch type to use when filtering the ListServices results.
- `"maxResults"`: The maximum number of service results that ListServices returned in
  paginated output. When this parameter is used, ListServices only returns maxResults results
  in a single page along with a nextToken response element. The remaining results of the
  initial request can be seen by sending another ListServices request with the returned
  nextToken value. This value can be between 1 and 100. If this parameter isn't used, then
  ListServices returns up to 10 results and a nextToken value if applicable.
- `"nextToken"`: The nextToken value returned from a ListServices request indicating that
  more results are available to fulfill the request and further calls will be needed. If
  maxResults was provided, it is possible the number of results to be fewer than maxResults.
  This token should be treated as an opaque identifier that is only used to retrieve the next
  items in a list and not for other programmatic purposes.
- `"schedulingStrategy"`: The scheduling strategy to use when filtering the ListServices
  results.
"""
function list_services(; aws_config::AbstractAWSConfig=current_aws_config())
    return ecs("ListServices"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_services(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecs(
        "ListServices", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_services_by_namespace(namespace)
    list_services_by_namespace(namespace, params::Dict{String,<:Any})

This operation lists all of the services that are associated with a Cloud Map namespace.
This list might include services in different clusters. In contrast, ListServices can only
list services in one cluster at a time. If you need to filter the list of services in a
single cluster by various parameters, use ListServices. For more information, see Service
Connect in the Amazon Elastic Container Service Developer Guide.

# Arguments
- `namespace`: The namespace name or full Amazon Resource Name (ARN) of the Cloud Map
  namespace to list the services in. Tasks that run in a namespace can use short names to
  connect to services in the namespace. Tasks can connect to services across all of the
  clusters in the namespace. Tasks connect through a managed proxy container that collects
  logs and metrics for increased visibility. Only the tasks that Amazon ECS services create
  are supported with Service Connect. For more information, see Service Connect in the Amazon
  Elastic Container Service Developer Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of service results that ListServicesByNamespace
  returns in paginated output. When this parameter is used, ListServicesByNamespace only
  returns maxResults results in a single page along with a nextToken response element. The
  remaining results of the initial request can be seen by sending another
  ListServicesByNamespace request with the returned nextToken value. This value can be
  between 1 and 100. If this parameter isn't used, then ListServicesByNamespace returns up to
  10 results and a nextToken value if applicable.
- `"nextToken"`: The nextToken value that's returned from a ListServicesByNamespace
  request. It indicates that more results are available to fulfill the request and further
  calls are needed. If maxResults is returned, it is possible the number of results is less
  than maxResults.
"""
function list_services_by_namespace(
    namespace; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecs(
        "ListServicesByNamespace",
        Dict{String,Any}("namespace" => namespace);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_services_by_namespace(
    namespace,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecs(
        "ListServicesByNamespace",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("namespace" => namespace), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

List the tags for an Amazon ECS resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) that identifies the resource to list the
  tags for. Currently, the supported resources are Amazon ECS tasks, services, task
  definitions, clusters, and container instances.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecs(
        "ListTagsForResource",
        Dict{String,Any}("resourceArn" => resourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecs(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceArn" => resourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_task_definition_families()
    list_task_definition_families(params::Dict{String,<:Any})

Returns a list of task definition families that are registered to your account. This list
includes task definition families that no longer have any ACTIVE task definition revisions.
You can filter out task definition families that don't contain any ACTIVE task definition
revisions by setting the status parameter to ACTIVE. You can also filter the results with
the familyPrefix parameter.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"familyPrefix"`: The familyPrefix is a string that's used to filter the results of
  ListTaskDefinitionFamilies. If you specify a familyPrefix, only task definition family
  names that begin with the familyPrefix string are returned.
- `"maxResults"`: The maximum number of task definition family results that
  ListTaskDefinitionFamilies returned in paginated output. When this parameter is used,
  ListTaskDefinitions only returns maxResults results in a single page along with a nextToken
  response element. The remaining results of the initial request can be seen by sending
  another ListTaskDefinitionFamilies request with the returned nextToken value. This value
  can be between 1 and 100. If this parameter isn't used, then ListTaskDefinitionFamilies
  returns up to 100 results and a nextToken value if applicable.
- `"nextToken"`: The nextToken value returned from a ListTaskDefinitionFamilies request
  indicating that more results are available to fulfill the request and further calls will be
  needed. If maxResults was provided, it is possible the number of results to be fewer than
  maxResults.  This token should be treated as an opaque identifier that is only used to
  retrieve the next items in a list and not for other programmatic purposes.
- `"status"`: The task definition family status to filter the ListTaskDefinitionFamilies
  results with. By default, both ACTIVE and INACTIVE task definition families are listed. If
  this parameter is set to ACTIVE, only task definition families that have an ACTIVE task
  definition revision are returned. If this parameter is set to INACTIVE, only task
  definition families that do not have any ACTIVE task definition revisions are returned. If
  you paginate the resulting output, be sure to keep the status value constant in each
  subsequent request.
"""
function list_task_definition_families(; aws_config::AbstractAWSConfig=current_aws_config())
    return ecs(
        "ListTaskDefinitionFamilies"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_task_definition_families(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecs(
        "ListTaskDefinitionFamilies",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_task_definitions()
    list_task_definitions(params::Dict{String,<:Any})

Returns a list of task definitions that are registered to your account. You can filter the
results by family name with the familyPrefix parameter or by status with the status
parameter.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"familyPrefix"`: The full family name to filter the ListTaskDefinitions results with.
  Specifying a familyPrefix limits the listed task definitions to task definition revisions
  that belong to that family.
- `"maxResults"`: The maximum number of task definition results that ListTaskDefinitions
  returned in paginated output. When this parameter is used, ListTaskDefinitions only returns
  maxResults results in a single page along with a nextToken response element. The remaining
  results of the initial request can be seen by sending another ListTaskDefinitions request
  with the returned nextToken value. This value can be between 1 and 100. If this parameter
  isn't used, then ListTaskDefinitions returns up to 100 results and a nextToken value if
  applicable.
- `"nextToken"`: The nextToken value returned from a ListTaskDefinitions request indicating
  that more results are available to fulfill the request and further calls will be needed. If
  maxResults was provided, it is possible the number of results to be fewer than maxResults.
  This token should be treated as an opaque identifier that is only used to retrieve the next
  items in a list and not for other programmatic purposes.
- `"sort"`: The order to sort the results in. Valid values are ASC and DESC. By default,
  (ASC) task definitions are listed lexicographically by family name and in ascending
  numerical order by revision so that the newest task definitions in a family are listed
  last. Setting this parameter to DESC reverses the sort order on family name and revision.
  This is so that the newest task definitions in a family are listed first.
- `"status"`: The task definition status to filter the ListTaskDefinitions results with. By
  default, only ACTIVE task definitions are listed. By setting this parameter to INACTIVE,
  you can view task definitions that are INACTIVE as long as an active task or service still
  references them. If you paginate the resulting output, be sure to keep the status value
  constant in each subsequent request.
"""
function list_task_definitions(; aws_config::AbstractAWSConfig=current_aws_config())
    return ecs(
        "ListTaskDefinitions"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_task_definitions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecs(
        "ListTaskDefinitions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tasks()
    list_tasks(params::Dict{String,<:Any})

Returns a list of tasks. You can filter the results by cluster, task definition family,
container instance, launch type, what IAM principal started the task, or by the desired
status of the task. Recently stopped tasks might appear in the returned results.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"cluster"`: The short name or full Amazon Resource Name (ARN) of the cluster to use when
  filtering the ListTasks results. If you do not specify a cluster, the default cluster is
  assumed.
- `"containerInstance"`: The container instance ID or full ARN of the container instance to
  use when filtering the ListTasks results. Specifying a containerInstance limits the results
  to tasks that belong to that container instance.
- `"desiredStatus"`: The task desired status to use when filtering the ListTasks results.
  Specifying a desiredStatus of STOPPED limits the results to tasks that Amazon ECS has set
  the desired status to STOPPED. This can be useful for debugging tasks that aren't starting
  properly or have died or finished. The default status filter is RUNNING, which shows tasks
  that Amazon ECS has set the desired status to RUNNING.  Although you can filter results
  based on a desired status of PENDING, this doesn't return any results. Amazon ECS never
  sets the desired status of a task to that value (only a task's lastStatus may have a value
  of PENDING).
- `"family"`: The name of the task definition family to use when filtering the ListTasks
  results. Specifying a family limits the results to tasks that belong to that family.
- `"launchType"`: The launch type to use when filtering the ListTasks results.
- `"maxResults"`: The maximum number of task results that ListTasks returned in paginated
  output. When this parameter is used, ListTasks only returns maxResults results in a single
  page along with a nextToken response element. The remaining results of the initial request
  can be seen by sending another ListTasks request with the returned nextToken value. This
  value can be between 1 and 100. If this parameter isn't used, then ListTasks returns up to
  100 results and a nextToken value if applicable.
- `"nextToken"`: The nextToken value returned from a ListTasks request indicating that more
  results are available to fulfill the request and further calls will be needed. If
  maxResults was provided, it's possible the number of results to be fewer than maxResults.
  This token should be treated as an opaque identifier that is only used to retrieve the next
  items in a list and not for other programmatic purposes.
- `"serviceName"`: The name of the service to use when filtering the ListTasks results.
  Specifying a serviceName limits the results to tasks that belong to that service.
- `"startedBy"`: The startedBy value to filter the task results with. Specifying a
  startedBy value limits the results to tasks that were started with that value. When you
  specify startedBy as the filter, it must be the only filter that you use.
"""
function list_tasks(; aws_config::AbstractAWSConfig=current_aws_config())
    return ecs("ListTasks"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_tasks(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecs("ListTasks", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end

"""
    put_account_setting(name, value)
    put_account_setting(name, value, params::Dict{String,<:Any})

Modifies an account setting. Account settings are set on a per-Region basis. If you change
the root user account setting, the default settings are reset for users and roles that do
not have specified individual account settings. For more information, see Account Settings
in the Amazon Elastic Container Service Developer Guide.

# Arguments
- `name`: The Amazon ECS account setting name to modify. The following are the valid values
  for the account setting name.    serviceLongArnFormat - When modified, the Amazon Resource
  Name (ARN) and resource ID format of the resource type for a specified user, role, or the
  root user for an account is affected. The opt-in and opt-out account setting must be set
  for each Amazon ECS resource separately. The ARN and resource ID format of a resource is
  defined by the opt-in status of the user or role that created the resource. You must turn
  on this setting to use Amazon ECS features such as resource tagging.    taskLongArnFormat -
  When modified, the Amazon Resource Name (ARN) and resource ID format of the resource type
  for a specified user, role, or the root user for an account is affected. The opt-in and
  opt-out account setting must be set for each Amazon ECS resource separately. The ARN and
  resource ID format of a resource is defined by the opt-in status of the user or role that
  created the resource. You must turn on this setting to use Amazon ECS features such as
  resource tagging.    containerInstanceLongArnFormat - When modified, the Amazon Resource
  Name (ARN) and resource ID format of the resource type for a specified user, role, or the
  root user for an account is affected. The opt-in and opt-out account setting must be set
  for each Amazon ECS resource separately. The ARN and resource ID format of a resource is
  defined by the opt-in status of the user or role that created the resource. You must turn
  on this setting to use Amazon ECS features such as resource tagging.    awsvpcTrunking -
  When modified, the elastic network interface (ENI) limit for any new container instances
  that support the feature is changed. If awsvpcTrunking is turned on, any new container
  instances that support the feature are launched have the increased ENI limits available to
  them. For more information, see Elastic Network Interface Trunking in the Amazon Elastic
  Container Service Developer Guide.    containerInsights - When modified, the default
  setting indicating whether Amazon Web Services CloudWatch Container Insights is turned on
  for your clusters is changed. If containerInsights is turned on, any new clusters that are
  created will have Container Insights turned on unless you disable it during cluster
  creation. For more information, see CloudWatch Container Insights in the Amazon Elastic
  Container Service Developer Guide.    dualStackIPv6 - When turned on, when using a VPC in
  dual stack mode, your tasks using the awsvpc network mode can have an IPv6 address
  assigned. For more information on using IPv6 with tasks launched on Amazon EC2 instances,
  see Using a VPC in dual-stack mode. For more information on using IPv6 with tasks launched
  on Fargate, see Using a VPC in dual-stack mode.    fargateFIPSMode - If you specify
  fargateFIPSMode, Fargate FIPS 140 compliance is affected.
  fargateTaskRetirementWaitPeriod - When Amazon Web Services determines that a security or
  infrastructure update is needed for an Amazon ECS task hosted on Fargate, the tasks need to
  be stopped and new tasks launched to replace them. Use fargateTaskRetirementWaitPeriod to
  configure the wait time to retire a Fargate task. For information about the Fargate tasks
  maintenance, see Amazon Web Services Fargate task maintenance in the Amazon ECS Developer
  Guide.    tagResourceAuthorization - Amazon ECS is introducing tagging authorization for
  resource creation. Users must have permissions for actions that create the resource, such
  as ecsCreateCluster. If tags are specified when you create a resource, Amazon Web Services
  performs additional authorization to verify if users or roles have permissions to create
  tags. Therefore, you must grant explicit permissions to use the ecs:TagResource action. For
  more information, see Grant permission to tag resources on creation in the Amazon ECS
  Developer Guide.    guardDutyActivate - The guardDutyActivate parameter is read-only in
  Amazon ECS and indicates whether Amazon ECS Runtime Monitoring is enabled or disabled by
  your security administrator in your Amazon ECS account. Amazon GuardDuty controls this
  account setting on your behalf. For more information, see Protecting Amazon ECS workloads
  with Amazon ECS Runtime Monitoring.
- `value`: The account setting value for the specified principal ARN. Accepted values are
  enabled, disabled, on, and off. When you specify fargateTaskRetirementWaitPeriod for the
  name, the following are the valid values:    0 - Amazon Web Services sends the
  notification, and immediately retires the affected tasks.    7 - Amazon Web Services sends
  the notification, and waits 7 calendar days to retire the tasks.    14 - Amazon Web
  Services sends the notification, and waits 14 calendar days to retire the tasks.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"principalArn"`: The ARN of the principal, which can be a user, role, or the root user.
  If you specify the root user, it modifies the account setting for all users, roles, and the
  root user of the account unless a user or role explicitly overrides these settings. If this
  field is omitted, the setting is changed only for the authenticated user.  You must use the
  root user when you set the Fargate wait time (fargateTaskRetirementWaitPeriod).  Federated
  users assume the account setting of the root user and can't have explicit account settings
  set for them.
"""
function put_account_setting(
    name, value; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecs(
        "PutAccountSetting",
        Dict{String,Any}("name" => name, "value" => value);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_account_setting(
    name,
    value,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecs(
        "PutAccountSetting",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("name" => name, "value" => value), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_account_setting_default(name, value)
    put_account_setting_default(name, value, params::Dict{String,<:Any})

Modifies an account setting for all users on an account for whom no individual account
setting has been specified. Account settings are set on a per-Region basis.

# Arguments
- `name`: The resource name for which to modify the account setting. The following are the
  valid values for the account setting name.    serviceLongArnFormat - When modified, the
  Amazon Resource Name (ARN) and resource ID format of the resource type for a specified
  user, role, or the root user for an account is affected. The opt-in and opt-out account
  setting must be set for each Amazon ECS resource separately. The ARN and resource ID format
  of a resource is defined by the opt-in status of the user or role that created the
  resource. You must turn on this setting to use Amazon ECS features such as resource
  tagging.    taskLongArnFormat - When modified, the Amazon Resource Name (ARN) and resource
  ID format of the resource type for a specified user, role, or the root user for an account
  is affected. The opt-in and opt-out account setting must be set for each Amazon ECS
  resource separately. The ARN and resource ID format of a resource is defined by the opt-in
  status of the user or role that created the resource. You must turn on this setting to use
  Amazon ECS features such as resource tagging.    containerInstanceLongArnFormat - When
  modified, the Amazon Resource Name (ARN) and resource ID format of the resource type for a
  specified user, role, or the root user for an account is affected. The opt-in and opt-out
  account setting must be set for each Amazon ECS resource separately. The ARN and resource
  ID format of a resource is defined by the opt-in status of the user or role that created
  the resource. You must turn on this setting to use Amazon ECS features such as resource
  tagging.    awsvpcTrunking - When modified, the elastic network interface (ENI) limit for
  any new container instances that support the feature is changed. If awsvpcTrunking is
  turned on, any new container instances that support the feature are launched have the
  increased ENI limits available to them. For more information, see Elastic Network Interface
  Trunking in the Amazon Elastic Container Service Developer Guide.    containerInsights -
  When modified, the default setting indicating whether Amazon Web Services CloudWatch
  Container Insights is turned on for your clusters is changed. If containerInsights is
  turned on, any new clusters that are created will have Container Insights turned on unless
  you disable it during cluster creation. For more information, see CloudWatch Container
  Insights in the Amazon Elastic Container Service Developer Guide.    dualStackIPv6 - When
  turned on, when using a VPC in dual stack mode, your tasks using the awsvpc network mode
  can have an IPv6 address assigned. For more information on using IPv6 with tasks launched
  on Amazon EC2 instances, see Using a VPC in dual-stack mode. For more information on using
  IPv6 with tasks launched on Fargate, see Using a VPC in dual-stack mode.    fargateFIPSMode
  - If you specify fargateFIPSMode, Fargate FIPS 140 compliance is affected.
  fargateTaskRetirementWaitPeriod - When Amazon Web Services determines that a security or
  infrastructure update is needed for an Amazon ECS task hosted on Fargate, the tasks need to
  be stopped and new tasks launched to replace them. Use fargateTaskRetirementWaitPeriod to
  configure the wait time to retire a Fargate task. For information about the Fargate tasks
  maintenance, see Amazon Web Services Fargate task maintenance in the Amazon ECS Developer
  Guide.    tagResourceAuthorization - Amazon ECS is introducing tagging authorization for
  resource creation. Users must have permissions for actions that create the resource, such
  as ecsCreateCluster. If tags are specified when you create a resource, Amazon Web Services
  performs additional authorization to verify if users or roles have permissions to create
  tags. Therefore, you must grant explicit permissions to use the ecs:TagResource action. For
  more information, see Grant permission to tag resources on creation in the Amazon ECS
  Developer Guide.    guardDutyActivate - The guardDutyActivate parameter is read-only in
  Amazon ECS and indicates whether Amazon ECS Runtime Monitoring is enabled or disabled by
  your security administrator in your Amazon ECS account. Amazon GuardDuty controls this
  account setting on your behalf. For more information, see Protecting Amazon ECS workloads
  with Amazon ECS Runtime Monitoring.
- `value`: The account setting value for the specified principal ARN. Accepted values are
  enabled, disabled, on, and off. When you specify fargateTaskRetirementWaitPeriod for the
  name, the following are the valid values:    0 - Amazon Web Services sends the
  notification, and immediately retires the affected tasks.    7 - Amazon Web Services sends
  the notification, and waits 7 calendar days to retire the tasks.    14 - Amazon Web
  Services sends the notification, and waits 14 calendar days to retire the tasks.

"""
function put_account_setting_default(
    name, value; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecs(
        "PutAccountSettingDefault",
        Dict{String,Any}("name" => name, "value" => value);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_account_setting_default(
    name,
    value,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecs(
        "PutAccountSettingDefault",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("name" => name, "value" => value), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_attributes(attributes)
    put_attributes(attributes, params::Dict{String,<:Any})

Create or update an attribute on an Amazon ECS resource. If the attribute doesn't exist,
it's created. If the attribute exists, its value is replaced with the specified value. To
delete an attribute, use DeleteAttributes. For more information, see Attributes in the
Amazon Elastic Container Service Developer Guide.

# Arguments
- `attributes`: The attributes to apply to your resource. You can specify up to 10 custom
  attributes for each resource. You can specify up to 10 attributes in a single call.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"cluster"`: The short name or full Amazon Resource Name (ARN) of the cluster that
  contains the resource to apply attributes. If you do not specify a cluster, the default
  cluster is assumed.
"""
function put_attributes(attributes; aws_config::AbstractAWSConfig=current_aws_config())
    return ecs(
        "PutAttributes",
        Dict{String,Any}("attributes" => attributes);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_attributes(
    attributes,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecs(
        "PutAttributes",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("attributes" => attributes), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_cluster_capacity_providers(capacity_providers, cluster, default_capacity_provider_strategy)
    put_cluster_capacity_providers(capacity_providers, cluster, default_capacity_provider_strategy, params::Dict{String,<:Any})

Modifies the available capacity providers and the default capacity provider strategy for a
cluster. You must specify both the available capacity providers and a default capacity
provider strategy for the cluster. If the specified cluster has existing capacity providers
associated with it, you must specify all existing capacity providers in addition to any new
ones you want to add. Any existing capacity providers that are associated with a cluster
that are omitted from a PutClusterCapacityProviders API call will be disassociated with the
cluster. You can only disassociate an existing capacity provider from a cluster if it's not
being used by any existing tasks. When creating a service or running a task on a cluster,
if no capacity provider or launch type is specified, then the cluster's default capacity
provider strategy is used. We recommend that you define a default capacity provider
strategy for your cluster. However, you must specify an empty array ([]) to bypass defining
a default strategy.

# Arguments
- `capacity_providers`: The name of one or more capacity providers to associate with the
  cluster. If specifying a capacity provider that uses an Auto Scaling group, the capacity
  provider must already be created. New capacity providers can be created with the
  CreateCapacityProvider API operation. To use a Fargate capacity provider, specify either
  the FARGATE or FARGATE_SPOT capacity providers. The Fargate capacity providers are
  available to all accounts and only need to be associated with a cluster to be used.
- `cluster`: The short name or full Amazon Resource Name (ARN) of the cluster to modify the
  capacity provider settings for. If you don't specify a cluster, the default cluster is
  assumed.
- `default_capacity_provider_strategy`: The capacity provider strategy to use by default
  for the cluster. When creating a service or running a task on a cluster, if no capacity
  provider or launch type is specified then the default capacity provider strategy for the
  cluster is used. A capacity provider strategy consists of one or more capacity providers
  along with the base and weight to assign to them. A capacity provider must be associated
  with the cluster to be used in a capacity provider strategy. The
  PutClusterCapacityProviders API is used to associate a capacity provider with a cluster.
  Only capacity providers with an ACTIVE or UPDATING status can be used. If specifying a
  capacity provider that uses an Auto Scaling group, the capacity provider must already be
  created. New capacity providers can be created with the CreateCapacityProvider API
  operation. To use a Fargate capacity provider, specify either the FARGATE or FARGATE_SPOT
  capacity providers. The Fargate capacity providers are available to all accounts and only
  need to be associated with a cluster to be used.

"""
function put_cluster_capacity_providers(
    capacityProviders,
    cluster,
    defaultCapacityProviderStrategy;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecs(
        "PutClusterCapacityProviders",
        Dict{String,Any}(
            "capacityProviders" => capacityProviders,
            "cluster" => cluster,
            "defaultCapacityProviderStrategy" => defaultCapacityProviderStrategy,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_cluster_capacity_providers(
    capacityProviders,
    cluster,
    defaultCapacityProviderStrategy,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecs(
        "PutClusterCapacityProviders",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "capacityProviders" => capacityProviders,
                    "cluster" => cluster,
                    "defaultCapacityProviderStrategy" => defaultCapacityProviderStrategy,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    register_container_instance()
    register_container_instance(params::Dict{String,<:Any})

 This action is only used by the Amazon ECS agent, and it is not intended for use outside
of the agent.  Registers an EC2 instance into the specified cluster. This instance becomes
available to place containers on.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"attributes"`: The container instance attributes that this container instance supports.
- `"cluster"`: The short name or full Amazon Resource Name (ARN) of the cluster to register
  your container instance with. If you do not specify a cluster, the default cluster is
  assumed.
- `"containerInstanceArn"`: The ARN of the container instance (if it was previously
  registered).
- `"instanceIdentityDocument"`: The instance identity document for the EC2 instance to
  register. This document can be found by running the following command from the instance:
  curl http://169.254.169.254/latest/dynamic/instance-identity/document/
- `"instanceIdentityDocumentSignature"`: The instance identity document signature for the
  EC2 instance to register. This signature can be found by running the following command from
  the instance: curl http://169.254.169.254/latest/dynamic/instance-identity/signature/
- `"platformDevices"`: The devices that are available on the container instance. The only
  supported device type is a GPU.
- `"tags"`: The metadata that you apply to the container instance to help you categorize
  and organize them. Each tag consists of a key and an optional value. You define both. The
  following basic restrictions apply to tags:   Maximum number of tags per resource - 50
  For each resource, each tag key must be unique, and each tag key can have only one value.
  Maximum key length - 128 Unicode characters in UTF-8   Maximum value length - 256 Unicode
  characters in UTF-8   If your tagging schema is used across multiple services and
  resources, remember that other services may have restrictions on allowed characters.
  Generally allowed characters are: letters, numbers, and spaces representable in UTF-8, and
  the following characters: + - = . _ : / @.   Tag keys and values are case-sensitive.   Do
  not use aws:, AWS:, or any upper or lowercase combination of such as a prefix for either
  keys or values as it is reserved for Amazon Web Services use. You cannot edit or delete tag
  keys or values with this prefix. Tags with this prefix do not count against your tags per
  resource limit.
- `"totalResources"`: The resources available on the instance.
- `"versionInfo"`: The version information for the Amazon ECS container agent and Docker
  daemon that runs on the container instance.
"""
function register_container_instance(; aws_config::AbstractAWSConfig=current_aws_config())
    return ecs(
        "RegisterContainerInstance"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function register_container_instance(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecs(
        "RegisterContainerInstance",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    register_task_definition(container_definitions, family)
    register_task_definition(container_definitions, family, params::Dict{String,<:Any})

Registers a new task definition from the supplied family and containerDefinitions.
Optionally, you can add data volumes to your containers with the volumes parameter. For
more information about task definition parameters and defaults, see Amazon ECS Task
Definitions in the Amazon Elastic Container Service Developer Guide. You can specify a role
for your task with the taskRoleArn parameter. When you specify a role for a task, its
containers can then use the latest versions of the CLI or SDKs to make API requests to the
Amazon Web Services services that are specified in the policy that's associated with the
role. For more information, see IAM Roles for Tasks in the Amazon Elastic Container Service
Developer Guide. You can specify a Docker networking mode for the containers in your task
definition with the networkMode parameter. The available network modes correspond to those
described in Network settings in the Docker run reference. If you specify the awsvpc
network mode, the task is allocated an elastic network interface, and you must specify a
NetworkConfiguration when you create a service or run a task with the task definition. For
more information, see Task Networking in the Amazon Elastic Container Service Developer
Guide.

# Arguments
- `container_definitions`: A list of container definitions in JSON format that describe the
  different containers that make up your task.
- `family`: You must specify a family for a task definition. You can use it track multiple
  versions of the same task definition. The family is used as a name for your task
  definition. Up to 255 letters (uppercase and lowercase), numbers, underscores, and hyphens
  are allowed.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"cpu"`: The number of CPU units used by the task. It can be expressed as an integer
  using CPU units (for example, 1024) or as a string using vCPUs (for example, 1 vCPU or 1
  vcpu) in a task definition. String values are converted to an integer indicating the CPU
  units when the task definition is registered.  Task-level CPU and memory parameters are
  ignored for Windows containers. We recommend specifying container-level resources for
  Windows containers.  If you're using the EC2 launch type, this field is optional. Supported
  values are between 128 CPU units (0.125 vCPUs) and 10240 CPU units (10 vCPUs). If you do
  not specify a value, the parameter is ignored. If you're using the Fargate launch type,
  this field is required and you must use one of the following values, which determines your
  range of supported values for the memory parameter: The CPU units cannot be less than 1
  vCPU when you use Windows containers on Fargate.   256 (.25 vCPU) - Available memory
  values: 512 (0.5 GB), 1024 (1 GB), 2048 (2 GB)   512 (.5 vCPU) - Available memory values:
  1024 (1 GB), 2048 (2 GB), 3072 (3 GB), 4096 (4 GB)   1024 (1 vCPU) - Available memory
  values: 2048 (2 GB), 3072 (3 GB), 4096 (4 GB), 5120 (5 GB), 6144 (6 GB), 7168 (7 GB), 8192
  (8 GB)   2048 (2 vCPU) - Available memory values: 4096 (4 GB) and 16384 (16 GB) in
  increments of 1024 (1 GB)   4096 (4 vCPU) - Available memory values: 8192 (8 GB) and 30720
  (30 GB) in increments of 1024 (1 GB)   8192 (8 vCPU) - Available memory values: 16 GB and
  60 GB in 4 GB increments This option requires Linux platform 1.4.0 or later.   16384
  (16vCPU) - Available memory values: 32GB and 120 GB in 8 GB increments This option requires
  Linux platform 1.4.0 or later.
- `"ephemeralStorage"`: The amount of ephemeral storage to allocate for the task. This
  parameter is used to expand the total amount of ephemeral storage available, beyond the
  default amount, for tasks hosted on Fargate. For more information, see Using data volumes
  in tasks in the Amazon ECS Developer Guide.  For tasks using the Fargate launch type, the
  task requires the following platforms:   Linux platform version 1.4.0 or later.   Windows
  platform version 1.0.0 or later.
- `"executionRoleArn"`: The Amazon Resource Name (ARN) of the task execution role that
  grants the Amazon ECS container agent permission to make Amazon Web Services API calls on
  your behalf. The task execution IAM role is required depending on the requirements of your
  task. For more information, see Amazon ECS task execution IAM role in the Amazon Elastic
  Container Service Developer Guide.
- `"inferenceAccelerators"`: The Elastic Inference accelerators to use for the containers
  in the task.
- `"ipcMode"`: The IPC resource namespace to use for the containers in the task. The valid
  values are host, task, or none. If host is specified, then all containers within the tasks
  that specified the host IPC mode on the same container instance share the same IPC
  resources with the host Amazon EC2 instance. If task is specified, all containers within
  the specified task share the same IPC resources. If none is specified, then IPC resources
  within the containers of a task are private and not shared with other containers in a task
  or on the container instance. If no value is specified, then the IPC resource namespace
  sharing depends on the Docker daemon setting on the container instance. For more
  information, see IPC settings in the Docker run reference. If the host IPC mode is used, be
  aware that there is a heightened risk of undesired IPC namespace expose. For more
  information, see Docker security. If you are setting namespaced kernel parameters using
  systemControls for the containers in the task, the following will apply to your IPC
  resource namespace. For more information, see System Controls in the Amazon Elastic
  Container Service Developer Guide.   For tasks that use the host IPC mode, IPC namespace
  related systemControls are not supported.   For tasks that use the task IPC mode, IPC
  namespace related systemControls will apply to all containers within a task.    This
  parameter is not supported for Windows containers or tasks run on Fargate.
- `"memory"`: The amount of memory (in MiB) used by the task. It can be expressed as an
  integer using MiB (for example ,1024) or as a string using GB (for example, 1GB or 1 GB) in
  a task definition. String values are converted to an integer indicating the MiB when the
  task definition is registered.  Task-level CPU and memory parameters are ignored for
  Windows containers. We recommend specifying container-level resources for Windows
  containers.  If using the EC2 launch type, this field is optional. If using the Fargate
  launch type, this field is required and you must use one of the following values. This
  determines your range of supported values for the cpu parameter. The CPU units cannot be
  less than 1 vCPU when you use Windows containers on Fargate.   512 (0.5 GB), 1024 (1 GB),
  2048 (2 GB) - Available cpu values: 256 (.25 vCPU)   1024 (1 GB), 2048 (2 GB), 3072 (3 GB),
  4096 (4 GB) - Available cpu values: 512 (.5 vCPU)   2048 (2 GB), 3072 (3 GB), 4096 (4 GB),
  5120 (5 GB), 6144 (6 GB), 7168 (7 GB), 8192 (8 GB) - Available cpu values: 1024 (1 vCPU)
  Between 4096 (4 GB) and 16384 (16 GB) in increments of 1024 (1 GB) - Available cpu values:
  2048 (2 vCPU)   Between 8192 (8 GB) and 30720 (30 GB) in increments of 1024 (1 GB) -
  Available cpu values: 4096 (4 vCPU)   Between 16 GB and 60 GB in 4 GB increments -
  Available cpu values: 8192 (8 vCPU) This option requires Linux platform 1.4.0 or later.
  Between 32GB and 120 GB in 8 GB increments - Available cpu values: 16384 (16 vCPU) This
  option requires Linux platform 1.4.0 or later.
- `"networkMode"`: The Docker networking mode to use for the containers in the task. The
  valid values are none, bridge, awsvpc, and host. If no network mode is specified, the
  default is bridge. For Amazon ECS tasks on Fargate, the awsvpc network mode is required.
  For Amazon ECS tasks on Amazon EC2 Linux instances, any network mode can be used. For
  Amazon ECS tasks on Amazon EC2 Windows instances, &lt;default&gt; or awsvpc can be used. If
  the network mode is set to none, you cannot specify port mappings in your container
  definitions, and the tasks containers do not have external connectivity. The host and
  awsvpc network modes offer the highest networking performance for containers because they
  use the EC2 network stack instead of the virtualized network stack provided by the bridge
  mode. With the host and awsvpc network modes, exposed container ports are mapped directly
  to the corresponding host port (for the host network mode) or the attached elastic network
  interface port (for the awsvpc network mode), so you cannot take advantage of dynamic host
  port mappings.   When using the host network mode, you should not run containers using the
  root user (UID 0). It is considered best practice to use a non-root user.  If the network
  mode is awsvpc, the task is allocated an elastic network interface, and you must specify a
  NetworkConfiguration value when you create a service or run a task with the task
  definition. For more information, see Task Networking in the Amazon Elastic Container
  Service Developer Guide. If the network mode is host, you cannot run multiple
  instantiations of the same task on a single container instance when port mappings are used.
  For more information, see Network settings in the Docker run reference.
- `"pidMode"`: The process namespace to use for the containers in the task. The valid
  values are host or task. On Fargate for Linux containers, the only valid value is task. For
  example, monitoring sidecars might need pidMode to access information about other
  containers running in the same task. If host is specified, all containers within the tasks
  that specified the host PID mode on the same container instance share the same process
  namespace with the host Amazon EC2 instance. If task is specified, all containers within
  the specified task share the same process namespace. If no value is specified, the default
  is a private namespace for each container. For more information, see PID settings in the
  Docker run reference. If the host PID mode is used, there's a heightened risk of undesired
  process namespace exposure. For more information, see Docker security.  This parameter is
  not supported for Windows containers.   This parameter is only supported for tasks that are
  hosted on Fargate if the tasks are using platform version 1.4.0 or later (Linux). This
  isn't supported for Windows containers on Fargate.
- `"placementConstraints"`: An array of placement constraint objects to use for the task.
  You can specify a maximum of 10 constraints for each task. This limit includes constraints
  in the task definition and those specified at runtime.
- `"proxyConfiguration"`: The configuration details for the App Mesh proxy. For tasks
  hosted on Amazon EC2 instances, the container instances require at least version 1.26.0 of
  the container agent and at least version 1.26.0-1 of the ecs-init package to use a proxy
  configuration. If your container instances are launched from the Amazon ECS-optimized AMI
  version 20190301 or later, then they contain the required versions of the container agent
  and ecs-init. For more information, see Amazon ECS-optimized AMI versions in the Amazon
  Elastic Container Service Developer Guide.
- `"requiresCompatibilities"`: The task launch type that Amazon ECS validates the task
  definition against. A client exception is returned if the task definition doesn't validate
  against the compatibilities specified. If no value is specified, the parameter is omitted
  from the response.
- `"runtimePlatform"`: The operating system that your tasks definitions run on. A platform
  family is specified only for tasks using the Fargate launch type.
- `"tags"`: The metadata that you apply to the task definition to help you categorize and
  organize them. Each tag consists of a key and an optional value. You define both of them.
  The following basic restrictions apply to tags:   Maximum number of tags per resource - 50
   For each resource, each tag key must be unique, and each tag key can have only one value.
   Maximum key length - 128 Unicode characters in UTF-8   Maximum value length - 256 Unicode
  characters in UTF-8   If your tagging schema is used across multiple services and
  resources, remember that other services may have restrictions on allowed characters.
  Generally allowed characters are: letters, numbers, and spaces representable in UTF-8, and
  the following characters: + - = . _ : / @.   Tag keys and values are case-sensitive.   Do
  not use aws:, AWS:, or any upper or lowercase combination of such as a prefix for either
  keys or values as it is reserved for Amazon Web Services use. You cannot edit or delete tag
  keys or values with this prefix. Tags with this prefix do not count against your tags per
  resource limit.
- `"taskRoleArn"`: The short name or full Amazon Resource Name (ARN) of the IAM role that
  containers in this task can assume. All containers in this task are granted the permissions
  that are specified in this role. For more information, see IAM Roles for Tasks in the
  Amazon Elastic Container Service Developer Guide.
- `"volumes"`: A list of volume definitions in JSON format that containers in your task
  might use.
"""
function register_task_definition(
    containerDefinitions, family; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecs(
        "RegisterTaskDefinition",
        Dict{String,Any}(
            "containerDefinitions" => containerDefinitions, "family" => family
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function register_task_definition(
    containerDefinitions,
    family,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecs(
        "RegisterTaskDefinition",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "containerDefinitions" => containerDefinitions, "family" => family
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    run_task(task_definition)
    run_task(task_definition, params::Dict{String,<:Any})

Starts a new task using the specified task definition.  On March 21, 2024, a change was
made to resolve the task definition revision before authorization. When a task definition
revision is not specified, authorization will occur using the latest revision of a task
definition.  You can allow Amazon ECS to place tasks for you, or you can customize how
Amazon ECS places tasks using placement constraints and placement strategies. For more
information, see Scheduling Tasks in the Amazon Elastic Container Service Developer Guide.
Alternatively, you can use StartTask to use your own scheduler or place tasks manually on
specific container instances. Starting April 15, 2023, Amazon Web Services will not onboard
new customers to Amazon Elastic Inference (EI), and will help current customers migrate
their workloads to options that offer better price and performance. After April 15, 2023,
new customers will not be able to launch instances with Amazon EI accelerators in Amazon
SageMaker, Amazon ECS, or Amazon EC2. However, customers who have used Amazon EI at least
once during the past 30-day period are considered current customers and will be able to
continue using the service.  You can attach Amazon EBS volumes to Amazon ECS tasks by
configuring the volume when creating or updating a service. For more infomation, see Amazon
EBS volumes in the Amazon Elastic Container Service Developer Guide. The Amazon ECS API
follows an eventual consistency model. This is because of the distributed nature of the
system supporting the API. This means that the result of an API command you run that
affects your Amazon ECS resources might not be immediately visible to all subsequent
commands you run. Keep this in mind when you carry out an API command that immediately
follows a previous API command. To manage eventual consistency, you can do the following:
Confirm the state of the resource before you run a command to modify it. Run the
DescribeTasks command using an exponential backoff algorithm to ensure that you allow
enough time for the previous command to propagate through the system. To do this, run the
DescribeTasks command repeatedly, starting with a couple of seconds of wait time and
increasing gradually up to five minutes of wait time.   Add wait time between subsequent
commands, even if the DescribeTasks command returns an accurate response. Apply an
exponential backoff algorithm starting with a couple of seconds of wait time, and increase
gradually up to about five minutes of wait time.

# Arguments
- `task_definition`: The family and revision (family:revision) or full ARN of the task
  definition to run. If a revision isn't specified, the latest ACTIVE revision is used. The
  full ARN value must match the value that you specified as the Resource of the principal's
  permissions policy. When you specify a task definition, you must either specify a specific
  revision, or all revisions in the ARN. To specify a specific revision, include the revision
  number in the ARN. For example, to specify revision 2, use
  arn:aws:ecs:us-east-1:111122223333:task-definition/TaskFamilyName:2. To specify all
  revisions, use the wildcard (*) in the ARN. For example, to specify all revisions, use
  arn:aws:ecs:us-east-1:111122223333:task-definition/TaskFamilyName:*. For more information,
  see Policy Resources for Amazon ECS in the Amazon Elastic Container Service Developer Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"capacityProviderStrategy"`: The capacity provider strategy to use for the task. If a
  capacityProviderStrategy is specified, the launchType parameter must be omitted. If no
  capacityProviderStrategy or launchType is specified, the defaultCapacityProviderStrategy
  for the cluster is used. When you use cluster auto scaling, you must specify
  capacityProviderStrategy and not launchType.  A capacity provider strategy may contain a
  maximum of 6 capacity providers.
- `"clientToken"`: An identifier that you provide to ensure the idempotency of the request.
  It must be unique and is case sensitive. Up to 64 characters are allowed. The valid
  characters are characters in the range of 33-126, inclusive. For more information, see
  Ensuring idempotency.
- `"cluster"`: The short name or full Amazon Resource Name (ARN) of the cluster to run your
  task on. If you do not specify a cluster, the default cluster is assumed.
- `"count"`: The number of instantiations of the specified task to place on your cluster.
  You can specify up to 10 tasks for each call.
- `"enableECSManagedTags"`: Specifies whether to use Amazon ECS managed tags for the task.
  For more information, see Tagging Your Amazon ECS Resources in the Amazon Elastic Container
  Service Developer Guide.
- `"enableExecuteCommand"`: Determines whether to use the execute command functionality for
  the containers in this task. If true, this enables execute command functionality on all
  containers in the task. If true, then the task definition must have a task role, or you
  must provide one as an override.
- `"group"`: The name of the task group to associate with the task. The default value is
  the family name of the task definition (for example, family:my-family-name).
- `"launchType"`: The infrastructure to run your standalone task on. For more information,
  see Amazon ECS launch types in the Amazon Elastic Container Service Developer Guide. The
  FARGATE launch type runs your tasks on Fargate On-Demand infrastructure.  Fargate Spot
  infrastructure is available for use but a capacity provider strategy must be used. For more
  information, see Fargate capacity providers in the Amazon ECS Developer Guide.  The EC2
  launch type runs your tasks on Amazon EC2 instances registered to your cluster. The
  EXTERNAL launch type runs your tasks on your on-premises server or virtual machine (VM)
  capacity registered to your cluster. A task can use either a launch type or a capacity
  provider strategy. If a launchType is specified, the capacityProviderStrategy parameter
  must be omitted. When you use cluster auto scaling, you must specify
  capacityProviderStrategy and not launchType.
- `"networkConfiguration"`: The network configuration for the task. This parameter is
  required for task definitions that use the awsvpc network mode to receive their own elastic
  network interface, and it isn't supported for other network modes. For more information,
  see Task networking in the Amazon Elastic Container Service Developer Guide.
- `"overrides"`: A list of container overrides in JSON format that specify the name of a
  container in the specified task definition and the overrides it should receive. You can
  override the default command for a container (that's specified in the task definition or
  Docker image) with a command override. You can also override existing environment variables
  (that are specified in the task definition or Docker image) on a container or add new
  environment variables to it with an environment override. A total of 8192 characters are
  allowed for overrides. This limit includes the JSON formatting characters of the override
  structure.
- `"placementConstraints"`: An array of placement constraint objects to use for the task.
  You can specify up to 10 constraints for each task (including constraints in the task
  definition and those specified at runtime).
- `"placementStrategy"`: The placement strategy objects to use for the task. You can
  specify a maximum of 5 strategy rules for each task.
- `"platformVersion"`: The platform version the task uses. A platform version is only
  specified for tasks hosted on Fargate. If one isn't specified, the LATEST platform version
  is used. For more information, see Fargate platform versions in the Amazon Elastic
  Container Service Developer Guide.
- `"propagateTags"`: Specifies whether to propagate the tags from the task definition to
  the task. If no value is specified, the tags aren't propagated. Tags can only be propagated
  to the task during task creation. To add tags to a task after task creation, use the
  TagResource API action.  An error will be received if you specify the SERVICE option when
  running a task.
- `"referenceId"`: The reference ID to use for the task. The reference ID can have a
  maximum length of 1024 characters.
- `"startedBy"`: An optional tag specified when a task is started. For example, if you
  automatically trigger a task to run a batch process job, you could apply a unique
  identifier for that job to your task with the startedBy parameter. You can then identify
  which tasks belong to that job by filtering the results of a ListTasks call with the
  startedBy value. Up to 128 letters (uppercase and lowercase), numbers, hyphens (-), and
  underscores (_) are allowed. If a task is started by an Amazon ECS service, then the
  startedBy parameter contains the deployment ID of the service that starts it.
- `"tags"`: The metadata that you apply to the task to help you categorize and organize
  them. Each tag consists of a key and an optional value, both of which you define. The
  following basic restrictions apply to tags:   Maximum number of tags per resource - 50
  For each resource, each tag key must be unique, and each tag key can have only one value.
  Maximum key length - 128 Unicode characters in UTF-8   Maximum value length - 256 Unicode
  characters in UTF-8   If your tagging schema is used across multiple services and
  resources, remember that other services may have restrictions on allowed characters.
  Generally allowed characters are: letters, numbers, and spaces representable in UTF-8, and
  the following characters: + - = . _ : / @.   Tag keys and values are case-sensitive.   Do
  not use aws:, AWS:, or any upper or lowercase combination of such as a prefix for either
  keys or values as it is reserved for Amazon Web Services use. You cannot edit or delete tag
  keys or values with this prefix. Tags with this prefix do not count against your tags per
  resource limit.
- `"volumeConfigurations"`: The details of the volume that was configuredAtLaunch. You can
  configure the size, volumeType, IOPS, throughput, snapshot and encryption in in
  TaskManagedEBSVolumeConfiguration. The name of the volume must match the name from the task
  definition.
"""
function run_task(taskDefinition; aws_config::AbstractAWSConfig=current_aws_config())
    return ecs(
        "RunTask",
        Dict{String,Any}(
            "taskDefinition" => taskDefinition, "clientToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function run_task(
    taskDefinition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecs(
        "RunTask",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "taskDefinition" => taskDefinition, "clientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_task(container_instances, task_definition)
    start_task(container_instances, task_definition, params::Dict{String,<:Any})

Starts a new task from the specified task definition on the specified container instance or
instances.  On March 21, 2024, a change was made to resolve the task definition revision
before authorization. When a task definition revision is not specified, authorization will
occur using the latest revision of a task definition.  Starting April 15, 2023, Amazon Web
Services will not onboard new customers to Amazon Elastic Inference (EI), and will help
current customers migrate their workloads to options that offer better price and
performance. After April 15, 2023, new customers will not be able to launch instances with
Amazon EI accelerators in Amazon SageMaker, Amazon ECS, or Amazon EC2. However, customers
who have used Amazon EI at least once during the past 30-day period are considered current
customers and will be able to continue using the service.  Alternatively, you can use
RunTask to place tasks for you. For more information, see Scheduling Tasks in the Amazon
Elastic Container Service Developer Guide. You can attach Amazon EBS volumes to Amazon ECS
tasks by configuring the volume when creating or updating a service. For more infomation,
see Amazon EBS volumes in the Amazon Elastic Container Service Developer Guide.

# Arguments
- `container_instances`: The container instance IDs or full ARN entries for the container
  instances where you would like to place your task. You can specify up to 10 container
  instances.
- `task_definition`: The family and revision (family:revision) or full ARN of the task
  definition to start. If a revision isn't specified, the latest ACTIVE revision is used.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"cluster"`: The short name or full Amazon Resource Name (ARN) of the cluster where to
  start your task. If you do not specify a cluster, the default cluster is assumed.
- `"enableECSManagedTags"`: Specifies whether to use Amazon ECS managed tags for the task.
  For more information, see Tagging Your Amazon ECS Resources in the Amazon Elastic Container
  Service Developer Guide.
- `"enableExecuteCommand"`: Whether or not the execute command functionality is turned on
  for the task. If true, this turns on the execute command functionality on all containers in
  the task.
- `"group"`: The name of the task group to associate with the task. The default value is
  the family name of the task definition (for example, family:my-family-name).
- `"networkConfiguration"`: The VPC subnet and security group configuration for tasks that
  receive their own elastic network interface by using the awsvpc networking mode.
- `"overrides"`: A list of container overrides in JSON format that specify the name of a
  container in the specified task definition and the overrides it receives. You can override
  the default command for a container (that's specified in the task definition or Docker
  image) with a command override. You can also override existing environment variables (that
  are specified in the task definition or Docker image) on a container or add new environment
  variables to it with an environment override.  A total of 8192 characters are allowed for
  overrides. This limit includes the JSON formatting characters of the override structure.
- `"propagateTags"`: Specifies whether to propagate the tags from the task definition or
  the service to the task. If no value is specified, the tags aren't propagated.
- `"referenceId"`: The reference ID to use for the task.
- `"startedBy"`: An optional tag specified when a task is started. For example, if you
  automatically trigger a task to run a batch process job, you could apply a unique
  identifier for that job to your task with the startedBy parameter. You can then identify
  which tasks belong to that job by filtering the results of a ListTasks call with the
  startedBy value. Up to 36 letters (uppercase and lowercase), numbers, hyphens (-), and
  underscores (_) are allowed. If a task is started by an Amazon ECS service, the startedBy
  parameter contains the deployment ID of the service that starts it.
- `"tags"`: The metadata that you apply to the task to help you categorize and organize
  them. Each tag consists of a key and an optional value, both of which you define. The
  following basic restrictions apply to tags:   Maximum number of tags per resource - 50
  For each resource, each tag key must be unique, and each tag key can have only one value.
  Maximum key length - 128 Unicode characters in UTF-8   Maximum value length - 256 Unicode
  characters in UTF-8   If your tagging schema is used across multiple services and
  resources, remember that other services may have restrictions on allowed characters.
  Generally allowed characters are: letters, numbers, and spaces representable in UTF-8, and
  the following characters: + - = . _ : / @.   Tag keys and values are case-sensitive.   Do
  not use aws:, AWS:, or any upper or lowercase combination of such as a prefix for either
  keys or values as it is reserved for Amazon Web Services use. You cannot edit or delete tag
  keys or values with this prefix. Tags with this prefix do not count against your tags per
  resource limit.
- `"volumeConfigurations"`: The details of the volume that was configuredAtLaunch. You can
  configure the size, volumeType, IOPS, throughput, snapshot and encryption in
  TaskManagedEBSVolumeConfiguration. The name of the volume must match the name from the task
  definition.
"""
function start_task(
    containerInstances, taskDefinition; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecs(
        "StartTask",
        Dict{String,Any}(
            "containerInstances" => containerInstances, "taskDefinition" => taskDefinition
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_task(
    containerInstances,
    taskDefinition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecs(
        "StartTask",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "containerInstances" => containerInstances,
                    "taskDefinition" => taskDefinition,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_task(task)
    stop_task(task, params::Dict{String,<:Any})

Stops a running task. Any tags associated with the task will be deleted. When StopTask is
called on a task, the equivalent of docker stop is issued to the containers running in the
task. This results in a SIGTERM value and a default 30-second timeout, after which the
SIGKILL value is sent and the containers are forcibly stopped. If the container handles the
SIGTERM value gracefully and exits within 30 seconds from receiving it, no SIGKILL value is
sent. For Windows containers, POSIX signals do not work and runtime stops the container by
sending a CTRL_SHUTDOWN_EVENT. For more information, see Unable to react to graceful
shutdown of (Windows) container #25982 on GitHub.  The default 30-second timeout can be
configured on the Amazon ECS container agent with the ECS_CONTAINER_STOP_TIMEOUT variable.
For more information, see Amazon ECS Container Agent Configuration in the Amazon Elastic
Container Service Developer Guide.

# Arguments
- `task`: The task ID of the task to stop.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"cluster"`: The short name or full Amazon Resource Name (ARN) of the cluster that hosts
  the task to stop. If you do not specify a cluster, the default cluster is assumed.
- `"reason"`: An optional message specified when a task is stopped. For example, if you're
  using a custom scheduler, you can use this parameter to specify the reason for stopping the
  task here, and the message appears in subsequent DescribeTasks API operations on this task.
"""
function stop_task(task; aws_config::AbstractAWSConfig=current_aws_config())
    return ecs(
        "StopTask",
        Dict{String,Any}("task" => task);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_task(
    task, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecs(
        "StopTask",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("task" => task), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    submit_attachment_state_changes(attachments)
    submit_attachment_state_changes(attachments, params::Dict{String,<:Any})

 This action is only used by the Amazon ECS agent, and it is not intended for use outside
of the agent.  Sent to acknowledge that an attachment changed states.

# Arguments
- `attachments`: Any attachments associated with the state change request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"cluster"`: The short name or full ARN of the cluster that hosts the container instance
  the attachment belongs to.
"""
function submit_attachment_state_changes(
    attachments; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecs(
        "SubmitAttachmentStateChanges",
        Dict{String,Any}("attachments" => attachments);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function submit_attachment_state_changes(
    attachments,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecs(
        "SubmitAttachmentStateChanges",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("attachments" => attachments), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    submit_container_state_change()
    submit_container_state_change(params::Dict{String,<:Any})

 This action is only used by the Amazon ECS agent, and it is not intended for use outside
of the agent.  Sent to acknowledge that a container changed states.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"cluster"`: The short name or full ARN of the cluster that hosts the container.
- `"containerName"`: The name of the container.
- `"exitCode"`: The exit code that's returned for the state change request.
- `"networkBindings"`: The network bindings of the container.
- `"reason"`: The reason for the state change request.
- `"runtimeId"`: The ID of the Docker container.
- `"status"`: The status of the state change request.
- `"task"`: The task ID or full Amazon Resource Name (ARN) of the task that hosts the
  container.
"""
function submit_container_state_change(; aws_config::AbstractAWSConfig=current_aws_config())
    return ecs(
        "SubmitContainerStateChange"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function submit_container_state_change(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecs(
        "SubmitContainerStateChange",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    submit_task_state_change()
    submit_task_state_change(params::Dict{String,<:Any})

 This action is only used by the Amazon ECS agent, and it is not intended for use outside
of the agent.  Sent to acknowledge that a task changed states.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"attachments"`: Any attachments associated with the state change request.
- `"cluster"`: The short name or full Amazon Resource Name (ARN) of the cluster that hosts
  the task.
- `"containers"`: Any containers that's associated with the state change request.
- `"executionStoppedAt"`: The Unix timestamp for the time when the task execution stopped.
- `"managedAgents"`: The details for the managed agent that's associated with the task.
- `"pullStartedAt"`: The Unix timestamp for the time when the container image pull started.
- `"pullStoppedAt"`: The Unix timestamp for the time when the container image pull
  completed.
- `"reason"`: The reason for the state change request.
- `"status"`: The status of the state change request.
- `"task"`: The task ID or full ARN of the task in the state change request.
"""
function submit_task_state_change(; aws_config::AbstractAWSConfig=current_aws_config())
    return ecs(
        "SubmitTaskStateChange"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function submit_task_state_change(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecs(
        "SubmitTaskStateChange",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Associates the specified tags to a resource with the specified resourceArn. If existing
tags on a resource aren't specified in the request parameters, they aren't changed. When a
resource is deleted, the tags that are associated with that resource are deleted as well.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource to add tags to. Currently,
  the supported resources are Amazon ECS capacity providers, tasks, services, task
  definitions, clusters, and container instances.
- `tags`: The tags to add to the resource. A tag is an array of key-value pairs. The
  following basic restrictions apply to tags:   Maximum number of tags per resource - 50
  For each resource, each tag key must be unique, and each tag key can have only one value.
  Maximum key length - 128 Unicode characters in UTF-8   Maximum value length - 256 Unicode
  characters in UTF-8   If your tagging schema is used across multiple services and
  resources, remember that other services may have restrictions on allowed characters.
  Generally allowed characters are: letters, numbers, and spaces representable in UTF-8, and
  the following characters: + - = . _ : / @.   Tag keys and values are case-sensitive.   Do
  not use aws:, AWS:, or any upper or lowercase combination of such as a prefix for either
  keys or values as it is reserved for Amazon Web Services use. You cannot edit or delete tag
  keys or values with this prefix. Tags with this prefix do not count against your tags per
  resource limit.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return ecs(
        "TagResource",
        Dict{String,Any}("resourceArn" => resourceArn, "tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecs(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceArn" => resourceArn, "tags" => tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Deletes specified tags from a resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource to delete tags from.
  Currently, the supported resources are Amazon ECS capacity providers, tasks, services, task
  definitions, clusters, and container instances.
- `tag_keys`: The keys of the tags to be removed.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecs(
        "UntagResource",
        Dict{String,Any}("resourceArn" => resourceArn, "tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecs(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceArn" => resourceArn, "tagKeys" => tagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_capacity_provider(auto_scaling_group_provider, name)
    update_capacity_provider(auto_scaling_group_provider, name, params::Dict{String,<:Any})

Modifies the parameters for a capacity provider.

# Arguments
- `auto_scaling_group_provider`: An object that represent the parameters to update for the
  Auto Scaling group capacity provider.
- `name`: The name of the capacity provider to update.

"""
function update_capacity_provider(
    autoScalingGroupProvider, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecs(
        "UpdateCapacityProvider",
        Dict{String,Any}(
            "autoScalingGroupProvider" => autoScalingGroupProvider, "name" => name
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_capacity_provider(
    autoScalingGroupProvider,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecs(
        "UpdateCapacityProvider",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "autoScalingGroupProvider" => autoScalingGroupProvider, "name" => name
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_cluster(cluster)
    update_cluster(cluster, params::Dict{String,<:Any})

Updates the cluster.

# Arguments
- `cluster`: The name of the cluster to modify the settings for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"configuration"`: The execute command configuration for the cluster.
- `"serviceConnectDefaults"`: Use this parameter to set a default Service Connect
  namespace. After you set a default Service Connect namespace, any new services with Service
  Connect turned on that are created in the cluster are added as client services in the
  namespace. This setting only applies to new services that set the enabled parameter to true
  in the ServiceConnectConfiguration. You can set the namespace of each service individually
  in the ServiceConnectConfiguration to override this default parameter. Tasks that run in a
  namespace can use short names to connect to services in the namespace. Tasks can connect to
  services across all of the clusters in the namespace. Tasks connect through a managed proxy
  container that collects logs and metrics for increased visibility. Only the tasks that
  Amazon ECS services create are supported with Service Connect. For more information, see
  Service Connect in the Amazon Elastic Container Service Developer Guide.
- `"settings"`: The cluster settings for your cluster.
"""
function update_cluster(cluster; aws_config::AbstractAWSConfig=current_aws_config())
    return ecs(
        "UpdateCluster",
        Dict{String,Any}("cluster" => cluster);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_cluster(
    cluster,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecs(
        "UpdateCluster",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("cluster" => cluster), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_cluster_settings(cluster, settings)
    update_cluster_settings(cluster, settings, params::Dict{String,<:Any})

Modifies the settings to use for a cluster.

# Arguments
- `cluster`: The name of the cluster to modify the settings for.
- `settings`: The setting to use by default for a cluster. This parameter is used to turn
  on CloudWatch Container Insights for a cluster. If this value is specified, it overrides
  the containerInsights value set with PutAccountSetting or PutAccountSettingDefault.
  Currently, if you delete an existing cluster that does not have Container Insights turned
  on, and then create a new cluster with the same name with Container Insights tuned on,
  Container Insights will not actually be turned on. If you want to preserve the same name
  for your existing cluster and turn on Container Insights, you must wait 7 days before you
  can re-create it.

"""
function update_cluster_settings(
    cluster, settings; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecs(
        "UpdateClusterSettings",
        Dict{String,Any}("cluster" => cluster, "settings" => settings);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_cluster_settings(
    cluster,
    settings,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecs(
        "UpdateClusterSettings",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("cluster" => cluster, "settings" => settings),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_container_agent(container_instance)
    update_container_agent(container_instance, params::Dict{String,<:Any})

Updates the Amazon ECS container agent on a specified container instance. Updating the
Amazon ECS container agent doesn't interrupt running tasks or services on the container
instance. The process for updating the agent differs depending on whether your container
instance was launched with the Amazon ECS-optimized AMI or another operating system.  The
UpdateContainerAgent API isn't supported for container instances using the Amazon
ECS-optimized Amazon Linux 2 (arm64) AMI. To update the container agent, you can update the
ecs-init package. This updates the agent. For more information, see Updating the Amazon ECS
container agent in the Amazon Elastic Container Service Developer Guide.   Agent updates
with the UpdateContainerAgent API operation do not apply to Windows container instances. We
recommend that you launch new container instances to update the agent version in your
Windows clusters.  The UpdateContainerAgent API requires an Amazon ECS-optimized AMI or
Amazon Linux AMI with the ecs-init service installed and running. For help updating the
Amazon ECS container agent on other operating systems, see Manually updating the Amazon ECS
container agent in the Amazon Elastic Container Service Developer Guide.

# Arguments
- `container_instance`: The container instance ID or full ARN entries for the container
  instance where you would like to update the Amazon ECS container agent.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"cluster"`: The short name or full Amazon Resource Name (ARN) of the cluster that your
  container instance is running on. If you do not specify a cluster, the default cluster is
  assumed.
"""
function update_container_agent(
    containerInstance; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecs(
        "UpdateContainerAgent",
        Dict{String,Any}("containerInstance" => containerInstance);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_container_agent(
    containerInstance,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecs(
        "UpdateContainerAgent",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("containerInstance" => containerInstance), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_container_instances_state(container_instances, status)
    update_container_instances_state(container_instances, status, params::Dict{String,<:Any})

Modifies the status of an Amazon ECS container instance. Once a container instance has
reached an ACTIVE state, you can change the status of a container instance to DRAINING to
manually remove an instance from a cluster, for example to perform system updates, update
the Docker daemon, or scale down the cluster size.  A container instance can't be changed
to DRAINING until it has reached an ACTIVE status. If the instance is in any other status,
an error will be received.  When you set a container instance to DRAINING, Amazon ECS
prevents new tasks from being scheduled for placement on the container instance and
replacement service tasks are started on other container instances in the cluster if the
resources are available. Service tasks on the container instance that are in the PENDING
state are stopped immediately. Service tasks on the container instance that are in the
RUNNING state are stopped and replaced according to the service's deployment configuration
parameters, minimumHealthyPercent and maximumPercent. You can change the deployment
configuration of your service using UpdateService.   If minimumHealthyPercent is below
100%, the scheduler can ignore desiredCount temporarily during task replacement. For
example, desiredCount is four tasks, a minimum of 50% allows the scheduler to stop two
existing tasks before starting two new tasks. If the minimum is 100%, the service scheduler
can't remove existing tasks until the replacement tasks are considered healthy. Tasks for
services that do not use a load balancer are considered healthy if they're in the RUNNING
state. Tasks for services that use a load balancer are considered healthy if they're in the
RUNNING state and are reported as healthy by the load balancer.   The maximumPercent
parameter represents an upper limit on the number of running tasks during task replacement.
You can use this to define the replacement batch size. For example, if desiredCount is four
tasks, a maximum of 200% starts four new tasks before stopping the four tasks to be
drained, provided that the cluster resources required to do this are available. If the
maximum is 100%, then replacement tasks can't start until the draining tasks have stopped.
 Any PENDING or RUNNING tasks that do not belong to a service aren't affected. You must
wait for them to finish or stop them manually. A container instance has completed draining
when it has no more RUNNING tasks. You can verify this using ListTasks. When a container
instance has been drained, you can set a container instance to ACTIVE status and once it
has reached that status the Amazon ECS scheduler can begin scheduling tasks on the instance
again.

# Arguments
- `container_instances`: A list of up to 10 container instance IDs or full ARN entries.
- `status`: The container instance state to update the container instance with. The only
  valid values for this action are ACTIVE and DRAINING. A container instance can only be
  updated to DRAINING status once it has reached an ACTIVE state. If a container instance is
  in REGISTERING, DEREGISTERING, or REGISTRATION_FAILED state you can describe the container
  instance but can't update the container instance state.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"cluster"`: The short name or full Amazon Resource Name (ARN) of the cluster that hosts
  the container instance to update. If you do not specify a cluster, the default cluster is
  assumed.
"""
function update_container_instances_state(
    containerInstances, status; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecs(
        "UpdateContainerInstancesState",
        Dict{String,Any}("containerInstances" => containerInstances, "status" => status);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_container_instances_state(
    containerInstances,
    status,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecs(
        "UpdateContainerInstancesState",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "containerInstances" => containerInstances, "status" => status
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_service(service)
    update_service(service, params::Dict{String,<:Any})

Modifies the parameters of a service.  On March 21, 2024, a change was made to resolve the
task definition revision before authorization. When a task definition revision is not
specified, authorization will occur using the latest revision of a task definition.  For
services using the rolling update (ECS) you can update the desired count, deployment
configuration, network configuration, load balancers, service registries, enable ECS
managed tags option, propagate tags option, task placement constraints and strategies, and
task definition. When you update any of these parameters, Amazon ECS starts new tasks with
the new configuration.  You can attach Amazon EBS volumes to Amazon ECS tasks by
configuring the volume when starting or running a task, or when creating or updating a
service. For more infomation, see Amazon EBS volumes in the Amazon Elastic Container
Service Developer Guide. You can update your volume configurations and trigger a new
deployment. volumeConfigurations is only supported for REPLICA service and not DAEMON
service. If you leave volumeConfigurations null, it doesn't trigger a new deployment. For
more infomation on volumes, see Amazon EBS volumes in the Amazon Elastic Container Service
Developer Guide. For services using the blue/green (CODE_DEPLOY) deployment controller,
only the desired count, deployment configuration, health check grace period, task placement
constraints and strategies, enable ECS managed tags option, and propagate tags can be
updated using this API. If the network configuration, platform version, task definition, or
load balancer need to be updated, create a new CodeDeploy deployment. For more information,
see CreateDeployment in the CodeDeploy API Reference. For services using an external
deployment controller, you can update only the desired count, task placement constraints
and strategies, health check grace period, enable ECS managed tags option, and propagate
tags option, using this API. If the launch type, load balancer, network configuration,
platform version, or task definition need to be updated, create a new task set For more
information, see CreateTaskSet. You can add to or subtract from the number of
instantiations of a task definition in a service by specifying the cluster that the service
is running in and a new desiredCount parameter. You can attach Amazon EBS volumes to Amazon
ECS tasks by configuring the volume when starting or running a task, or when creating or
updating a service. For more infomation, see Amazon EBS volumes in the Amazon Elastic
Container Service Developer Guide. If you have updated the container image of your
application, you can create a new task definition with that image and deploy it to your
service. The service scheduler uses the minimum healthy percent and maximum percent
parameters (in the service's deployment configuration) to determine the deployment
strategy.  If your updated Docker image uses the same tag as what is in the existing task
definition for your service (for example, my_image:latest), you don't need to create a new
revision of your task definition. You can update the service using the forceNewDeployment
option. The new tasks launched by the deployment pull the current image/tag combination
from your repository when they start.  You can also update the deployment configuration of
a service. When a deployment is triggered by updating the task definition of a service, the
service scheduler uses the deployment configuration parameters, minimumHealthyPercent and
maximumPercent, to determine the deployment strategy.   If minimumHealthyPercent is below
100%, the scheduler can ignore desiredCount temporarily during a deployment. For example,
if desiredCount is four tasks, a minimum of 50% allows the scheduler to stop two existing
tasks before starting two new tasks. Tasks for services that don't use a load balancer are
considered healthy if they're in the RUNNING state. Tasks for services that use a load
balancer are considered healthy if they're in the RUNNING state and are reported as healthy
by the load balancer.   The maximumPercent parameter represents an upper limit on the
number of running tasks during a deployment. You can use it to define the deployment batch
size. For example, if desiredCount is four tasks, a maximum of 200% starts four new tasks
before stopping the four older tasks (provided that the cluster resources required to do
this are available).   When UpdateService stops a task during a deployment, the equivalent
of docker stop is issued to the containers running in the task. This results in a SIGTERM
and a 30-second timeout. After this, SIGKILL is sent and the containers are forcibly
stopped. If the container handles the SIGTERM gracefully and exits within 30 seconds from
receiving it, no SIGKILL is sent. When the service scheduler launches new tasks, it
determines task placement in your cluster with the following logic.   Determine which of
the container instances in your cluster can support your service's task definition. For
example, they have the required CPU, memory, ports, and container instance attributes.   By
default, the service scheduler attempts to balance tasks across Availability Zones in this
manner even though you can choose a different placement strategy.   Sort the valid
container instances by the fewest number of running tasks for this service in the same
Availability Zone as the instance. For example, if zone A has one running service task and
zones B and C each have zero, valid container instances in either zone B or C are
considered optimal for placement.   Place the new service task on a valid container
instance in an optimal Availability Zone (based on the previous steps), favoring container
instances with the fewest number of running tasks for this service.     When the service
scheduler stops running tasks, it attempts to maintain balance across the Availability
Zones in your cluster using the following logic:    Sort the container instances by the
largest number of running tasks for this service in the same Availability Zone as the
instance. For example, if zone A has one running service task and zones B and C each have
two, container instances in either zone B or C are considered optimal for termination.
Stop the task on a container instance in an optimal Availability Zone (based on the
previous steps), favoring container instances with the largest number of running tasks for
this service.    You must have a service-linked role when you update any of the following
service properties:    loadBalancers,    serviceRegistries    For more information about
the role see the CreateService request parameter  role .

# Arguments
- `service`: The name of the service to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"capacityProviderStrategy"`: The capacity provider strategy to update the service to
  use. if the service uses the default capacity provider strategy for the cluster, the
  service can be updated to use one or more capacity providers as opposed to the default
  capacity provider strategy. However, when a service is using a capacity provider strategy
  that's not the default capacity provider strategy, the service can't be updated to use the
  cluster's default capacity provider strategy. A capacity provider strategy consists of one
  or more capacity providers along with the base and weight to assign to them. A capacity
  provider must be associated with the cluster to be used in a capacity provider strategy.
  The PutClusterCapacityProviders API is used to associate a capacity provider with a
  cluster. Only capacity providers with an ACTIVE or UPDATING status can be used. If
  specifying a capacity provider that uses an Auto Scaling group, the capacity provider must
  already be created. New capacity providers can be created with the CreateCapacityProvider
  API operation. To use a Fargate capacity provider, specify either the FARGATE or
  FARGATE_SPOT capacity providers. The Fargate capacity providers are available to all
  accounts and only need to be associated with a cluster to be used. The
  PutClusterCapacityProviders API operation is used to update the list of available capacity
  providers for a cluster after the cluster is created.
- `"cluster"`: The short name or full Amazon Resource Name (ARN) of the cluster that your
  service runs on. If you do not specify a cluster, the default cluster is assumed.
- `"deploymentConfiguration"`: Optional deployment parameters that control how many tasks
  run during the deployment and the ordering of stopping and starting tasks.
- `"desiredCount"`: The number of instantiations of the task to place and keep running in
  your service.
- `"enableECSManagedTags"`: Determines whether to turn on Amazon ECS managed tags for the
  tasks in the service. For more information, see Tagging Your Amazon ECS Resources in the
  Amazon Elastic Container Service Developer Guide. Only tasks launched after the update will
  reflect the update. To update the tags on all tasks, set forceNewDeployment to true, so
  that Amazon ECS starts new tasks with the updated tags.
- `"enableExecuteCommand"`: If true, this enables execute command functionality on all task
  containers. If you do not want to override the value that was set when the service was
  created, you can set this to null when performing this action.
- `"forceNewDeployment"`: Determines whether to force a new deployment of the service. By
  default, deployments aren't forced. You can use this option to start a new deployment with
  no service definition changes. For example, you can update a service's tasks to use a newer
  Docker image with the same image/tag combination (my_image:latest) or to roll Fargate tasks
  onto a newer platform version.
- `"healthCheckGracePeriodSeconds"`: The period of time, in seconds, that the Amazon ECS
  service scheduler ignores unhealthy Elastic Load Balancing target health checks after a
  task has first started. This is only valid if your service is configured to use a load
  balancer. If your service's tasks take a while to start and respond to Elastic Load
  Balancing health checks, you can specify a health check grace period of up to 2,147,483,647
  seconds. During that time, the Amazon ECS service scheduler ignores the Elastic Load
  Balancing health check status. This grace period can prevent the ECS service scheduler from
  marking tasks as unhealthy and stopping them before they have time to come up.
- `"loadBalancers"`: A list of Elastic Load Balancing load balancer objects. It contains
  the load balancer name, the container name, and the container port to access from the load
  balancer. The container name is as it appears in a container definition. When you add,
  update, or remove a load balancer configuration, Amazon ECS starts new tasks with the
  updated Elastic Load Balancing configuration, and then stops the old tasks when the new
  tasks are running. For services that use rolling updates, you can add, update, or remove
  Elastic Load Balancing target groups. You can update from a single target group to multiple
  target groups and from multiple target groups to a single target group. For services that
  use blue/green deployments, you can update Elastic Load Balancing target groups by using
  CreateDeployment  through CodeDeploy. Note that multiple target groups are not supported
  for blue/green deployments. For more information see Register multiple target groups with a
  service in the Amazon Elastic Container Service Developer Guide.  For services that use the
  external deployment controller, you can add, update, or remove load balancers by using
  CreateTaskSet. Note that multiple target groups are not supported for external deployments.
  For more information see Register multiple target groups with a service in the Amazon
  Elastic Container Service Developer Guide.  You can remove existing loadBalancers by
  passing an empty list.
- `"networkConfiguration"`: An object representing the network configuration for the
  service.
- `"placementConstraints"`: An array of task placement constraint objects to update the
  service to use. If no value is specified, the existing placement constraints for the
  service will remain unchanged. If this value is specified, it will override any existing
  placement constraints defined for the service. To remove all existing placement
  constraints, specify an empty array. You can specify a maximum of 10 constraints for each
  task. This limit includes constraints in the task definition and those specified at runtime.
- `"placementStrategy"`: The task placement strategy objects to update the service to use.
  If no value is specified, the existing placement strategy for the service will remain
  unchanged. If this value is specified, it will override the existing placement strategy
  defined for the service. To remove an existing placement strategy, specify an empty object.
  You can specify a maximum of five strategy rules for each service.
- `"platformVersion"`: The platform version that your tasks in the service run on. A
  platform version is only specified for tasks using the Fargate launch type. If a platform
  version is not specified, the LATEST platform version is used. For more information, see
  Fargate Platform Versions in the Amazon Elastic Container Service Developer Guide.
- `"propagateTags"`: Determines whether to propagate the tags from the task definition or
  the service to the task. If no value is specified, the tags aren't propagated. Only tasks
  launched after the update will reflect the update. To update the tags on all tasks, set
  forceNewDeployment to true, so that Amazon ECS starts new tasks with the updated tags.
- `"serviceConnectConfiguration"`: The configuration for this service to discover and
  connect to services, and be discovered by, and connected from, other services within a
  namespace. Tasks that run in a namespace can use short names to connect to services in the
  namespace. Tasks can connect to services across all of the clusters in the namespace. Tasks
  connect through a managed proxy container that collects logs and metrics for increased
  visibility. Only the tasks that Amazon ECS services create are supported with Service
  Connect. For more information, see Service Connect in the Amazon Elastic Container Service
  Developer Guide.
- `"serviceRegistries"`: The details for the service discovery registries to assign to this
  service. For more information, see Service Discovery. When you add, update, or remove the
  service registries configuration, Amazon ECS starts new tasks with the updated service
  registries configuration, and then stops the old tasks when the new tasks are running. You
  can remove existing serviceRegistries by passing an empty list.
- `"taskDefinition"`: The family and revision (family:revision) or full ARN of the task
  definition to run in your service. If a revision is not specified, the latest ACTIVE
  revision is used. If you modify the task definition with UpdateService, Amazon ECS spawns a
  task with the new version of the task definition and then stops an old task after the new
  version is running.
- `"volumeConfigurations"`: The details of the volume that was configuredAtLaunch. You can
  configure the size, volumeType, IOPS, throughput, snapshot and encryption in
  ServiceManagedEBSVolumeConfiguration. The name of the volume must match the name from the
  task definition. If set to null, no new deployment is triggered. Otherwise, if this
  configuration differs from the existing one, it triggers a new deployment.
"""
function update_service(service; aws_config::AbstractAWSConfig=current_aws_config())
    return ecs(
        "UpdateService",
        Dict{String,Any}("service" => service);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_service(
    service,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecs(
        "UpdateService",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("service" => service), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_service_primary_task_set(cluster, primary_task_set, service)
    update_service_primary_task_set(cluster, primary_task_set, service, params::Dict{String,<:Any})

Modifies which task set in a service is the primary task set. Any parameters that are
updated on the primary task set in a service will transition to the service. This is used
when a service uses the EXTERNAL deployment controller type. For more information, see
Amazon ECS Deployment Types in the Amazon Elastic Container Service Developer Guide.

# Arguments
- `cluster`: The short name or full Amazon Resource Name (ARN) of the cluster that hosts
  the service that the task set exists in.
- `primary_task_set`: The short name or full Amazon Resource Name (ARN) of the task set to
  set as the primary task set in the deployment.
- `service`: The short name or full Amazon Resource Name (ARN) of the service that the task
  set exists in.

"""
function update_service_primary_task_set(
    cluster, primaryTaskSet, service; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecs(
        "UpdateServicePrimaryTaskSet",
        Dict{String,Any}(
            "cluster" => cluster, "primaryTaskSet" => primaryTaskSet, "service" => service
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_service_primary_task_set(
    cluster,
    primaryTaskSet,
    service,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecs(
        "UpdateServicePrimaryTaskSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "cluster" => cluster,
                    "primaryTaskSet" => primaryTaskSet,
                    "service" => service,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_task_protection(cluster, protection_enabled, tasks)
    update_task_protection(cluster, protection_enabled, tasks, params::Dict{String,<:Any})

Updates the protection status of a task. You can set protectionEnabled to true to protect
your task from termination during scale-in events from Service Autoscaling or deployments.
Task-protection, by default, expires after 2 hours at which point Amazon ECS clears the
protectionEnabled property making the task eligible for termination by a subsequent
scale-in event. You can specify a custom expiration period for task protection from 1
minute to up to 2,880 minutes (48 hours). To specify the custom expiration period, set the
expiresInMinutes property. The expiresInMinutes property is always reset when you invoke
this operation for a task that already has protectionEnabled set to true. You can keep
extending the protection expiration period of a task by invoking this operation repeatedly.
To learn more about Amazon ECS task protection, see Task scale-in protection in the  Amazon
Elastic Container Service Developer Guide .  This operation is only supported for tasks
belonging to an Amazon ECS service. Invoking this operation for a standalone task will
result in an TASK_NOT_VALID failure. For more information, see API failure reasons.   If
you prefer to set task protection from within the container, we recommend using the Task
scale-in protection endpoint.

# Arguments
- `cluster`: The short name or full Amazon Resource Name (ARN) of the cluster that hosts
  the service that the task sets exist in.
- `protection_enabled`: Specify true to mark a task for protection and false to unset
  protection, making it eligible for termination.
- `tasks`: A list of up to 10 task IDs or full ARN entries.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"expiresInMinutes"`: If you set protectionEnabled to true, you can specify the duration
  for task protection in minutes. You can specify a value from 1 minute to up to 2,880
  minutes (48 hours). During this time, your task will not be terminated by scale-in events
  from Service Auto Scaling or deployments. After this time period lapses, protectionEnabled
  will be reset to false. If you don’t specify the time, then the task is automatically
  protected for 120 minutes (2 hours).
"""
function update_task_protection(
    cluster, protectionEnabled, tasks; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecs(
        "UpdateTaskProtection",
        Dict{String,Any}(
            "cluster" => cluster, "protectionEnabled" => protectionEnabled, "tasks" => tasks
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_task_protection(
    cluster,
    protectionEnabled,
    tasks,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecs(
        "UpdateTaskProtection",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "cluster" => cluster,
                    "protectionEnabled" => protectionEnabled,
                    "tasks" => tasks,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_task_set(cluster, scale, service, task_set)
    update_task_set(cluster, scale, service, task_set, params::Dict{String,<:Any})

Modifies a task set. This is used when a service uses the EXTERNAL deployment controller
type. For more information, see Amazon ECS Deployment Types in the Amazon Elastic Container
Service Developer Guide.

# Arguments
- `cluster`: The short name or full Amazon Resource Name (ARN) of the cluster that hosts
  the service that the task set is found in.
- `scale`: A floating-point percentage of the desired number of tasks to place and keep
  running in the task set.
- `service`: The short name or full Amazon Resource Name (ARN) of the service that the task
  set is found in.
- `task_set`: The short name or full Amazon Resource Name (ARN) of the task set to update.

"""
function update_task_set(
    cluster, scale, service, taskSet; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ecs(
        "UpdateTaskSet",
        Dict{String,Any}(
            "cluster" => cluster,
            "scale" => scale,
            "service" => service,
            "taskSet" => taskSet,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_task_set(
    cluster,
    scale,
    service,
    taskSet,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ecs(
        "UpdateTaskSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "cluster" => cluster,
                    "scale" => scale,
                    "service" => service,
                    "taskSet" => taskSet,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: cloudcontrol
using AWS.Compat
using AWS.UUIDs

"""
    cancel_resource_request(request_token)
    cancel_resource_request(request_token, params::Dict{String,<:Any})

Cancels the specified resource operation request. For more information, see Canceling
resource operation requests in the Amazon Web Services Cloud Control API User Guide. Only
resource operations requests with a status of PENDING or IN_PROGRESS can be canceled.

# Arguments
- `request_token`: The RequestToken of the ProgressEvent object returned by the resource
  operation request.

"""
function cancel_resource_request(
    RequestToken; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudcontrol(
        "CancelResourceRequest",
        Dict{String,Any}("RequestToken" => RequestToken);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_resource_request(
    RequestToken,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudcontrol(
        "CancelResourceRequest",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("RequestToken" => RequestToken), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_resource(desired_state, type_name)
    create_resource(desired_state, type_name, params::Dict{String,<:Any})

Creates the specified resource. For more information, see Creating a resource in the Amazon
Web Services Cloud Control API User Guide. After you have initiated a resource creation
request, you can monitor the progress of your request by calling GetResourceRequestStatus
using the RequestToken of the ProgressEvent type returned by CreateResource.

# Arguments
- `desired_state`: Structured data format representing the desired state of the resource,
  consisting of that resource's properties and their desired values.  Cloud Control API
  currently supports JSON as a structured data format.  Specify the desired state as one of
  the following:   A JSON blob   A local path containing the desired state in JSON data
  format   For more information, see Composing the desired state of the resource in the
  Amazon Web Services Cloud Control API User Guide. For more information about the properties
  of a specific resource, refer to the related topic for the resource in the Resource and
  property types reference in the CloudFormation Users Guide.
- `type_name`: The name of the resource type.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: A unique identifier to ensure the idempotency of the resource request.
  As a best practice, specify this token to ensure idempotency, so that Amazon Web Services
  Cloud Control API can accurately distinguish between request retries and new resource
  requests. You might retry a resource request to ensure that it was successfully received. A
  client token is valid for 36 hours once used. After that, a resource request with the same
  client token is treated as a new request. If you do not specify a client token, one is
  generated for inclusion in the request. For more information, see Ensuring resource
  operation requests are unique in the Amazon Web Services Cloud Control API User Guide.
- `"RoleArn"`: The Amazon Resource Name (ARN) of the Identity and Access Management (IAM)
  role for Cloud Control API to use when performing this resource operation. The role
  specified must have the permissions required for this operation. The necessary permissions
  for each event handler are defined in the  handlers  section of the resource type
  definition schema. If you do not specify a role, Cloud Control API uses a temporary session
  created using your Amazon Web Services user credentials. For more information, see
  Specifying credentials in the Amazon Web Services Cloud Control API User Guide.
- `"TypeVersionId"`: For private resource types, the type version to use in this resource
  operation. If you do not specify a resource version, CloudFormation uses the default
  version.
"""
function create_resource(
    DesiredState, TypeName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudcontrol(
        "CreateResource",
        Dict{String,Any}(
            "DesiredState" => DesiredState,
            "TypeName" => TypeName,
            "ClientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_resource(
    DesiredState,
    TypeName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudcontrol(
        "CreateResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DesiredState" => DesiredState,
                    "TypeName" => TypeName,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_resource(identifier, type_name)
    delete_resource(identifier, type_name, params::Dict{String,<:Any})

Deletes the specified resource. For details, see Deleting a resource in the Amazon Web
Services Cloud Control API User Guide. After you have initiated a resource deletion
request, you can monitor the progress of your request by calling GetResourceRequestStatus
using the RequestToken of the ProgressEvent returned by DeleteResource.

# Arguments
- `identifier`: The identifier for the resource. You can specify the primary identifier, or
  any secondary identifier defined for the resource type in its resource schema. You can only
  specify one identifier. Primary identifiers can be specified as a string or JSON; secondary
  identifiers must be specified as JSON. For compound primary identifiers (that is, one that
  consists of multiple resource properties strung together), to specify the primary
  identifier as a string, list the property values in the order they are specified in the
  primary identifier definition, separated by |. For more information, see Identifying
  resources in the Amazon Web Services Cloud Control API User Guide.
- `type_name`: The name of the resource type.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: A unique identifier to ensure the idempotency of the resource request.
  As a best practice, specify this token to ensure idempotency, so that Amazon Web Services
  Cloud Control API can accurately distinguish between request retries and new resource
  requests. You might retry a resource request to ensure that it was successfully received. A
  client token is valid for 36 hours once used. After that, a resource request with the same
  client token is treated as a new request. If you do not specify a client token, one is
  generated for inclusion in the request. For more information, see Ensuring resource
  operation requests are unique in the Amazon Web Services Cloud Control API User Guide.
- `"RoleArn"`: The Amazon Resource Name (ARN) of the Identity and Access Management (IAM)
  role for Cloud Control API to use when performing this resource operation. The role
  specified must have the permissions required for this operation. The necessary permissions
  for each event handler are defined in the  handlers  section of the resource type
  definition schema. If you do not specify a role, Cloud Control API uses a temporary session
  created using your Amazon Web Services user credentials. For more information, see
  Specifying credentials in the Amazon Web Services Cloud Control API User Guide.
- `"TypeVersionId"`: For private resource types, the type version to use in this resource
  operation. If you do not specify a resource version, CloudFormation uses the default
  version.
"""
function delete_resource(
    Identifier, TypeName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudcontrol(
        "DeleteResource",
        Dict{String,Any}(
            "Identifier" => Identifier,
            "TypeName" => TypeName,
            "ClientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_resource(
    Identifier,
    TypeName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudcontrol(
        "DeleteResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Identifier" => Identifier,
                    "TypeName" => TypeName,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_resource(identifier, type_name)
    get_resource(identifier, type_name, params::Dict{String,<:Any})

Returns information about the current state of the specified resource. For details, see
Reading a resource's current state. You can use this action to return information about an
existing resource in your account and Amazon Web Services Region, whether those resources
were provisioned using Cloud Control API.

# Arguments
- `identifier`: The identifier for the resource. You can specify the primary identifier, or
  any secondary identifier defined for the resource type in its resource schema. You can only
  specify one identifier. Primary identifiers can be specified as a string or JSON; secondary
  identifiers must be specified as JSON. For compound primary identifiers (that is, one that
  consists of multiple resource properties strung together), to specify the primary
  identifier as a string, list the property values in the order they are specified in the
  primary identifier definition, separated by |. For more information, see Identifying
  resources in the Amazon Web Services Cloud Control API User Guide.
- `type_name`: The name of the resource type.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"RoleArn"`: The Amazon Resource Name (ARN) of the Identity and Access Management (IAM)
  role for Cloud Control API to use when performing this resource operation. The role
  specified must have the permissions required for this operation. The necessary permissions
  for each event handler are defined in the  handlers  section of the resource type
  definition schema. If you do not specify a role, Cloud Control API uses a temporary session
  created using your Amazon Web Services user credentials. For more information, see
  Specifying credentials in the Amazon Web Services Cloud Control API User Guide.
- `"TypeVersionId"`: For private resource types, the type version to use in this resource
  operation. If you do not specify a resource version, CloudFormation uses the default
  version.
"""
function get_resource(
    Identifier, TypeName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudcontrol(
        "GetResource",
        Dict{String,Any}("Identifier" => Identifier, "TypeName" => TypeName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_resource(
    Identifier,
    TypeName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudcontrol(
        "GetResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Identifier" => Identifier, "TypeName" => TypeName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_resource_request_status(request_token)
    get_resource_request_status(request_token, params::Dict{String,<:Any})

Returns the current status of a resource operation request. For more information, see
Tracking the progress of resource operation requests in the Amazon Web Services Cloud
Control API User Guide.

# Arguments
- `request_token`: A unique token used to track the progress of the resource operation
  request. Request tokens are included in the ProgressEvent type returned by a resource
  operation request.

"""
function get_resource_request_status(
    RequestToken; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudcontrol(
        "GetResourceRequestStatus",
        Dict{String,Any}("RequestToken" => RequestToken);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_resource_request_status(
    RequestToken,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudcontrol(
        "GetResourceRequestStatus",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("RequestToken" => RequestToken), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_resource_requests()
    list_resource_requests(params::Dict{String,<:Any})

Returns existing resource operation requests. This includes requests of all status types.
For more information, see Listing active resource operation requests in the Amazon Web
Services Cloud Control API User Guide.  Resource operation requests expire after 7 days.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to be returned with a single call. If the
  number of available results exceeds this maximum, the response includes a NextToken value
  that you can assign to the NextToken request parameter to get the next set of results. The
  default is 20.
- `"NextToken"`: If the previous paginated request didn't return all of the remaining
  results, the response object's NextToken parameter value is set to a token. To retrieve the
  next set of results, call this action again and assign that token to the request object's
  NextToken parameter. If there are no remaining results, the previous response object's
  NextToken parameter is set to null.
- `"ResourceRequestStatusFilter"`: The filter criteria to apply to the requests returned.
"""
function list_resource_requests(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudcontrol(
        "ListResourceRequests"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_resource_requests(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudcontrol(
        "ListResourceRequests",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_resources(type_name)
    list_resources(type_name, params::Dict{String,<:Any})

Returns information about the specified resources. For more information, see Discovering
resources in the Amazon Web Services Cloud Control API User Guide. You can use this action
to return information about existing resources in your account and Amazon Web Services
Region, whether those resources were provisioned using Cloud Control API.

# Arguments
- `type_name`: The name of the resource type.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Reserved.
- `"NextToken"`: If the previous paginated request didn't return all of the remaining
  results, the response object's NextToken parameter value is set to a token. To retrieve the
  next set of results, call this action again and assign that token to the request object's
  NextToken parameter. If there are no remaining results, the previous response object's
  NextToken parameter is set to null.
- `"ResourceModel"`: The resource model to use to select the resources to return.
- `"RoleArn"`: The Amazon Resource Name (ARN) of the Identity and Access Management (IAM)
  role for Cloud Control API to use when performing this resource operation. The role
  specified must have the permissions required for this operation. The necessary permissions
  for each event handler are defined in the  handlers  section of the resource type
  definition schema. If you do not specify a role, Cloud Control API uses a temporary session
  created using your Amazon Web Services user credentials. For more information, see
  Specifying credentials in the Amazon Web Services Cloud Control API User Guide.
- `"TypeVersionId"`: For private resource types, the type version to use in this resource
  operation. If you do not specify a resource version, CloudFormation uses the default
  version.
"""
function list_resources(TypeName; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudcontrol(
        "ListResources",
        Dict{String,Any}("TypeName" => TypeName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_resources(
    TypeName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudcontrol(
        "ListResources",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TypeName" => TypeName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_resource(identifier, patch_document, type_name)
    update_resource(identifier, patch_document, type_name, params::Dict{String,<:Any})

Updates the specified property values in the resource. You specify your resource property
updates as a list of patch operations contained in a JSON patch document that adheres to
the  RFC 6902 - JavaScript Object Notation (JSON) Patch  standard. For details on how Cloud
Control API performs resource update operations, see Updating a resource in the Amazon Web
Services Cloud Control API User Guide. After you have initiated a resource update request,
you can monitor the progress of your request by calling GetResourceRequestStatus using the
RequestToken of the ProgressEvent returned by UpdateResource. For more information about
the properties of a specific resource, refer to the related topic for the resource in the
Resource and property types reference in the CloudFormation Users Guide.

# Arguments
- `identifier`: The identifier for the resource. You can specify the primary identifier, or
  any secondary identifier defined for the resource type in its resource schema. You can only
  specify one identifier. Primary identifiers can be specified as a string or JSON; secondary
  identifiers must be specified as JSON. For compound primary identifiers (that is, one that
  consists of multiple resource properties strung together), to specify the primary
  identifier as a string, list the property values in the order they are specified in the
  primary identifier definition, separated by |. For more information, see Identifying
  resources in the Amazon Web Services Cloud Control API User Guide.
- `patch_document`: A JavaScript Object Notation (JSON) document listing the patch
  operations that represent the updates to apply to the current resource properties. For
  details, see Composing the patch document in the Amazon Web Services Cloud Control API User
  Guide.
- `type_name`: The name of the resource type.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: A unique identifier to ensure the idempotency of the resource request.
  As a best practice, specify this token to ensure idempotency, so that Amazon Web Services
  Cloud Control API can accurately distinguish between request retries and new resource
  requests. You might retry a resource request to ensure that it was successfully received. A
  client token is valid for 36 hours once used. After that, a resource request with the same
  client token is treated as a new request. If you do not specify a client token, one is
  generated for inclusion in the request. For more information, see Ensuring resource
  operation requests are unique in the Amazon Web Services Cloud Control API User Guide.
- `"RoleArn"`: The Amazon Resource Name (ARN) of the Identity and Access Management (IAM)
  role for Cloud Control API to use when performing this resource operation. The role
  specified must have the permissions required for this operation. The necessary permissions
  for each event handler are defined in the  handlers  section of the resource type
  definition schema. If you do not specify a role, Cloud Control API uses a temporary session
  created using your Amazon Web Services user credentials. For more information, see
  Specifying credentials in the Amazon Web Services Cloud Control API User Guide.
- `"TypeVersionId"`: For private resource types, the type version to use in this resource
  operation. If you do not specify a resource version, CloudFormation uses the default
  version.
"""
function update_resource(
    Identifier, PatchDocument, TypeName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudcontrol(
        "UpdateResource",
        Dict{String,Any}(
            "Identifier" => Identifier,
            "PatchDocument" => PatchDocument,
            "TypeName" => TypeName,
            "ClientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_resource(
    Identifier,
    PatchDocument,
    TypeName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudcontrol(
        "UpdateResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Identifier" => Identifier,
                    "PatchDocument" => PatchDocument,
                    "TypeName" => TypeName,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: b2bi
using AWS.Compat
using AWS.UUIDs

"""
    create_capability(configuration, name, type)
    create_capability(configuration, name, type, params::Dict{String,<:Any})

Instantiates a capability based on the specified parameters. A trading capability contains
the information required to transform incoming EDI documents into JSON or XML outputs.

# Arguments
- `configuration`: Specifies a structure that contains the details for a capability.
- `name`: Specifies the name of the capability, used to identify it.
- `type`: Specifies the type of the capability. Currently, only edi is supported.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Reserved for future use.
- `"instructionsDocuments"`: Specifies one or more locations in Amazon S3, each specifying
  an EDI document that can be used with this capability. Each item contains the name of the
  bucket and the key, to identify the document's location.
- `"tags"`: Specifies the key-value pairs assigned to ARNs that you can use to group and
  search for resources by type. You can attach this metadata to resources (capabilities,
  partnerships, and so on) for any purpose.
"""
function create_capability(
    configuration, name, type; aws_config::AbstractAWSConfig=current_aws_config()
)
    return b2bi(
        "CreateCapability",
        Dict{String,Any}(
            "configuration" => configuration,
            "name" => name,
            "type" => type,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_capability(
    configuration,
    name,
    type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return b2bi(
        "CreateCapability",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "configuration" => configuration,
                    "name" => name,
                    "type" => type,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_partnership(capabilities, email, name, profile_id)
    create_partnership(capabilities, email, name, profile_id, params::Dict{String,<:Any})

Creates a partnership between a customer and a trading partner, based on the supplied
parameters. A partnership represents the connection between you and your trading partner.
It ties together a profile and one or more trading capabilities.

# Arguments
- `capabilities`: Specifies a list of the capabilities associated with this partnership.
- `email`: Specifies the email address associated with this trading partner.
- `name`: Specifies a descriptive name for the partnership.
- `profile_id`: Specifies the unique, system-generated identifier for the profile connected
  to this partnership.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Reserved for future use.
- `"phone"`: Specifies the phone number associated with the partnership.
- `"tags"`: Specifies the key-value pairs assigned to ARNs that you can use to group and
  search for resources by type. You can attach this metadata to resources (capabilities,
  partnerships, and so on) for any purpose.
"""
function create_partnership(
    capabilities, email, name, profileId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return b2bi(
        "CreatePartnership",
        Dict{String,Any}(
            "capabilities" => capabilities,
            "email" => email,
            "name" => name,
            "profileId" => profileId,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_partnership(
    capabilities,
    email,
    name,
    profileId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return b2bi(
        "CreatePartnership",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "capabilities" => capabilities,
                    "email" => email,
                    "name" => name,
                    "profileId" => profileId,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_profile(business_name, logging, name, phone)
    create_profile(business_name, logging, name, phone, params::Dict{String,<:Any})

Creates a customer profile. You can have up to five customer profiles, each representing a
distinct private network. A profile is the mechanism used to create the concept of a
private network.

# Arguments
- `business_name`: Specifies the name for the business associated with this profile.
- `logging`: Specifies whether or not logging is enabled for this profile.
- `name`: Specifies the name of the profile.
- `phone`: Specifies the phone number associated with the profile.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Reserved for future use.
- `"email"`: Specifies the email address associated with this customer profile.
- `"tags"`: Specifies the key-value pairs assigned to ARNs that you can use to group and
  search for resources by type. You can attach this metadata to resources (capabilities,
  partnerships, and so on) for any purpose.
"""
function create_profile(
    businessName, logging, name, phone; aws_config::AbstractAWSConfig=current_aws_config()
)
    return b2bi(
        "CreateProfile",
        Dict{String,Any}(
            "businessName" => businessName,
            "logging" => logging,
            "name" => name,
            "phone" => phone,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_profile(
    businessName,
    logging,
    name,
    phone,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return b2bi(
        "CreateProfile",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "businessName" => businessName,
                    "logging" => logging,
                    "name" => name,
                    "phone" => phone,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_transformer(edi_type, file_format, mapping_template, name)
    create_transformer(edi_type, file_format, mapping_template, name, params::Dict{String,<:Any})

Creates a transformer. A transformer describes how to process the incoming EDI documents
and extract the necessary information to the output file.

# Arguments
- `edi_type`: Specifies the details for the EDI standard that is being used for the
  transformer. Currently, only X12 is supported. X12 is a set of standards and corresponding
  messages that define specific business documents.
- `file_format`: Specifies that the currently supported file formats for EDI
  transformations are JSON and XML.
- `mapping_template`: Specifies the mapping template for the transformer. This template is
  used to map the parsed EDI file using JSONata or XSLT.
- `name`: Specifies the name of the transformer, used to identify it.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Reserved for future use.
- `"sampleDocument"`: Specifies a sample EDI document that is used by a transformer as a
  guide for processing the EDI data.
- `"tags"`: Specifies the key-value pairs assigned to ARNs that you can use to group and
  search for resources by type. You can attach this metadata to resources (capabilities,
  partnerships, and so on) for any purpose.
"""
function create_transformer(
    ediType,
    fileFormat,
    mappingTemplate,
    name;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return b2bi(
        "CreateTransformer",
        Dict{String,Any}(
            "ediType" => ediType,
            "fileFormat" => fileFormat,
            "mappingTemplate" => mappingTemplate,
            "name" => name,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_transformer(
    ediType,
    fileFormat,
    mappingTemplate,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return b2bi(
        "CreateTransformer",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ediType" => ediType,
                    "fileFormat" => fileFormat,
                    "mappingTemplate" => mappingTemplate,
                    "name" => name,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_capability(capability_id)
    delete_capability(capability_id, params::Dict{String,<:Any})

Deletes the specified capability. A trading capability contains the information required to
transform incoming EDI documents into JSON or XML outputs.

# Arguments
- `capability_id`: Specifies a system-assigned unique identifier for the capability.

"""
function delete_capability(capabilityId; aws_config::AbstractAWSConfig=current_aws_config())
    return b2bi(
        "DeleteCapability",
        Dict{String,Any}("capabilityId" => capabilityId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_capability(
    capabilityId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return b2bi(
        "DeleteCapability",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("capabilityId" => capabilityId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_partnership(partnership_id)
    delete_partnership(partnership_id, params::Dict{String,<:Any})

Deletes the specified partnership. A partnership represents the connection between you and
your trading partner. It ties together a profile and one or more trading capabilities.

# Arguments
- `partnership_id`: Specifies the unique, system-generated identifier for a partnership.

"""
function delete_partnership(
    partnershipId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return b2bi(
        "DeletePartnership",
        Dict{String,Any}("partnershipId" => partnershipId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_partnership(
    partnershipId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return b2bi(
        "DeletePartnership",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("partnershipId" => partnershipId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_profile(profile_id)
    delete_profile(profile_id, params::Dict{String,<:Any})

Deletes the specified profile. A profile is the mechanism used to create the concept of a
private network.

# Arguments
- `profile_id`: Specifies the unique, system-generated identifier for the profile.

"""
function delete_profile(profileId; aws_config::AbstractAWSConfig=current_aws_config())
    return b2bi(
        "DeleteProfile",
        Dict{String,Any}("profileId" => profileId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_profile(
    profileId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return b2bi(
        "DeleteProfile",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("profileId" => profileId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_transformer(transformer_id)
    delete_transformer(transformer_id, params::Dict{String,<:Any})

Deletes the specified transformer. A transformer describes how to process the incoming EDI
documents and extract the necessary information to the output file.

# Arguments
- `transformer_id`: Specifies the system-assigned unique identifier for the transformer.

"""
function delete_transformer(
    transformerId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return b2bi(
        "DeleteTransformer",
        Dict{String,Any}("transformerId" => transformerId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_transformer(
    transformerId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return b2bi(
        "DeleteTransformer",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("transformerId" => transformerId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_capability(capability_id)
    get_capability(capability_id, params::Dict{String,<:Any})

Retrieves the details for the specified capability. A trading capability contains the
information required to transform incoming EDI documents into JSON or XML outputs.

# Arguments
- `capability_id`: Specifies a system-assigned unique identifier for the capability.

"""
function get_capability(capabilityId; aws_config::AbstractAWSConfig=current_aws_config())
    return b2bi(
        "GetCapability",
        Dict{String,Any}("capabilityId" => capabilityId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_capability(
    capabilityId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return b2bi(
        "GetCapability",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("capabilityId" => capabilityId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_partnership(partnership_id)
    get_partnership(partnership_id, params::Dict{String,<:Any})

Retrieves the details for a partnership, based on the partner and profile IDs specified. A
partnership represents the connection between you and your trading partner. It ties
together a profile and one or more trading capabilities.

# Arguments
- `partnership_id`: Specifies the unique, system-generated identifier for a partnership.

"""
function get_partnership(partnershipId; aws_config::AbstractAWSConfig=current_aws_config())
    return b2bi(
        "GetPartnership",
        Dict{String,Any}("partnershipId" => partnershipId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_partnership(
    partnershipId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return b2bi(
        "GetPartnership",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("partnershipId" => partnershipId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_profile(profile_id)
    get_profile(profile_id, params::Dict{String,<:Any})

Retrieves the details for the profile specified by the profile ID. A profile is the
mechanism used to create the concept of a private network.

# Arguments
- `profile_id`: Specifies the unique, system-generated identifier for the profile.

"""
function get_profile(profileId; aws_config::AbstractAWSConfig=current_aws_config())
    return b2bi(
        "GetProfile",
        Dict{String,Any}("profileId" => profileId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_profile(
    profileId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return b2bi(
        "GetProfile",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("profileId" => profileId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_transformer(transformer_id)
    get_transformer(transformer_id, params::Dict{String,<:Any})

Retrieves the details for the transformer specified by the transformer ID. A transformer
describes how to process the incoming EDI documents and extract the necessary information
to the output file.

# Arguments
- `transformer_id`: Specifies the system-assigned unique identifier for the transformer.

"""
function get_transformer(transformerId; aws_config::AbstractAWSConfig=current_aws_config())
    return b2bi(
        "GetTransformer",
        Dict{String,Any}("transformerId" => transformerId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_transformer(
    transformerId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return b2bi(
        "GetTransformer",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("transformerId" => transformerId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_transformer_job(transformer_id, transformer_job_id)
    get_transformer_job(transformer_id, transformer_job_id, params::Dict{String,<:Any})

Returns the details of the transformer run, based on the Transformer job ID.

# Arguments
- `transformer_id`: Specifies the system-assigned unique identifier for the transformer.
- `transformer_job_id`: Specifies the unique, system-generated identifier for a transformer
  run.

"""
function get_transformer_job(
    transformerId, transformerJobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return b2bi(
        "GetTransformerJob",
        Dict{String,Any}(
            "transformerId" => transformerId, "transformerJobId" => transformerJobId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_transformer_job(
    transformerId,
    transformerJobId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return b2bi(
        "GetTransformerJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "transformerId" => transformerId, "transformerJobId" => transformerJobId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_capabilities()
    list_capabilities(params::Dict{String,<:Any})

Lists the capabilities associated with your Amazon Web Services account for your current or
specified region. A trading capability contains the information required to transform
incoming EDI documents into JSON or XML outputs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Specifies the maximum number of capabilities to return.
- `"nextToken"`: When additional results are obtained from the command, a NextToken
  parameter is returned in the output. You can then pass the NextToken parameter in a
  subsequent command to continue listing additional resources.
"""
function list_capabilities(; aws_config::AbstractAWSConfig=current_aws_config())
    return b2bi("ListCapabilities"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_capabilities(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return b2bi(
        "ListCapabilities", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_partnerships()
    list_partnerships(params::Dict{String,<:Any})

Lists the partnerships associated with your Amazon Web Services account for your current or
specified region. A partnership represents the connection between you and your trading
partner. It ties together a profile and one or more trading capabilities.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Specifies the maximum number of capabilities to return.
- `"nextToken"`: When additional results are obtained from the command, a NextToken
  parameter is returned in the output. You can then pass the NextToken parameter in a
  subsequent command to continue listing additional resources.
- `"profileId"`: Specifies the unique, system-generated identifier for the profile
  connected to this partnership.
"""
function list_partnerships(; aws_config::AbstractAWSConfig=current_aws_config())
    return b2bi("ListPartnerships"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_partnerships(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return b2bi(
        "ListPartnerships", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_profiles()
    list_profiles(params::Dict{String,<:Any})

Lists the profiles associated with your Amazon Web Services account for your current or
specified region. A profile is the mechanism used to create the concept of a private
network.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Specifies the maximum number of profiles to return.
- `"nextToken"`: When additional results are obtained from the command, a NextToken
  parameter is returned in the output. You can then pass the NextToken parameter in a
  subsequent command to continue listing additional resources.
"""
function list_profiles(; aws_config::AbstractAWSConfig=current_aws_config())
    return b2bi("ListProfiles"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_profiles(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return b2bi(
        "ListProfiles", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists all of the tags associated with the Amazon Resource Name (ARN) that you specify. The
resource can be a capability, partnership, profile, or transformer.

# Arguments
- `resource_arn`: Requests the tags associated with a particular Amazon Resource Name
  (ARN). An ARN is an identifier for a specific Amazon Web Services resource, such as a
  capability, partnership, profile, or transformer.

"""
function list_tags_for_resource(
    ResourceARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return b2bi(
        "ListTagsForResource",
        Dict{String,Any}("ResourceARN" => ResourceARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return b2bi(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceARN" => ResourceARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_transformers()
    list_transformers(params::Dict{String,<:Any})

Lists the available transformers. A transformer describes how to process the incoming EDI
documents and extract the necessary information to the output file.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Specifies the number of items to return for the API response.
- `"nextToken"`: When additional results are obtained from the command, a NextToken
  parameter is returned in the output. You can then pass the NextToken parameter in a
  subsequent command to continue listing additional resources.
"""
function list_transformers(; aws_config::AbstractAWSConfig=current_aws_config())
    return b2bi("ListTransformers"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_transformers(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return b2bi(
        "ListTransformers", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    start_transformer_job(input_file, output_location, transformer_id)
    start_transformer_job(input_file, output_location, transformer_id, params::Dict{String,<:Any})

Runs a job, using a transformer, to parse input EDI (electronic data interchange) file into
the output structures used by Amazon Web Services B2BI Data Interchange. If you only want
to transform EDI (electronic data interchange) documents, you don't need to create
profiles, partnerships or capabilities. Just create and configure a transformer, and then
run the StartTransformerJob API to process your files.

# Arguments
- `input_file`: Specifies the location of the input file for the transformation. The
  location consists of an Amazon S3 bucket and prefix.
- `output_location`: Specifies the location of the output file for the transformation. The
  location consists of an Amazon S3 bucket and prefix.
- `transformer_id`: Specifies the system-assigned unique identifier for the transformer.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Reserved for future use.
"""
function start_transformer_job(
    inputFile,
    outputLocation,
    transformerId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return b2bi(
        "StartTransformerJob",
        Dict{String,Any}(
            "inputFile" => inputFile,
            "outputLocation" => outputLocation,
            "transformerId" => transformerId,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_transformer_job(
    inputFile,
    outputLocation,
    transformerId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return b2bi(
        "StartTransformerJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "inputFile" => inputFile,
                    "outputLocation" => outputLocation,
                    "transformerId" => transformerId,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Attaches a key-value pair to a resource, as identified by its Amazon Resource Name (ARN).
Resources are capability, partnership, profile, transformers and other entities. There is
no response returned from this call.

# Arguments
- `resource_arn`: Specifies an Amazon Resource Name (ARN) for a specific Amazon Web
  Services resource, such as a capability, partnership, profile, or transformer.
- `tags`: Specifies the key-value pairs assigned to ARNs that you can use to group and
  search for resources by type. You can attach this metadata to resources (capabilities,
  partnerships, and so on) for any purpose.

"""
function tag_resource(ResourceARN, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return b2bi(
        "TagResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceARN,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return b2bi(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    test_mapping(file_format, input_file_content, mapping_template)
    test_mapping(file_format, input_file_content, mapping_template, params::Dict{String,<:Any})

Maps the input file according to the provided template file. The API call downloads the
file contents from the Amazon S3 location, and passes the contents in as a string, to the
inputFileContent parameter.

# Arguments
- `file_format`: Specifies that the currently supported file formats for EDI
  transformations are JSON and XML.
- `input_file_content`: Specify the contents of the EDI (electronic data interchange) XML
  or JSON file that is used as input for the transform.
- `mapping_template`: Specifies the mapping template for the transformer. This template is
  used to map the parsed EDI file using JSONata or XSLT.

"""
function test_mapping(
    fileFormat,
    inputFileContent,
    mappingTemplate;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return b2bi(
        "TestMapping",
        Dict{String,Any}(
            "fileFormat" => fileFormat,
            "inputFileContent" => inputFileContent,
            "mappingTemplate" => mappingTemplate,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function test_mapping(
    fileFormat,
    inputFileContent,
    mappingTemplate,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return b2bi(
        "TestMapping",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "fileFormat" => fileFormat,
                    "inputFileContent" => inputFileContent,
                    "mappingTemplate" => mappingTemplate,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    test_parsing(edi_type, file_format, input_file)
    test_parsing(edi_type, file_format, input_file, params::Dict{String,<:Any})

Parses the input EDI (electronic data interchange) file. The input file has a file size
limit of 250 KB.

# Arguments
- `edi_type`: Specifies the details for the EDI standard that is being used for the
  transformer. Currently, only X12 is supported. X12 is a set of standards and corresponding
  messages that define specific business documents.
- `file_format`: Specifies that the currently supported file formats for EDI
  transformations are JSON and XML.
- `input_file`: Specifies an S3Location object, which contains the Amazon S3 bucket and
  prefix for the location of the input file.

"""
function test_parsing(
    ediType, fileFormat, inputFile; aws_config::AbstractAWSConfig=current_aws_config()
)
    return b2bi(
        "TestParsing",
        Dict{String,Any}(
            "ediType" => ediType, "fileFormat" => fileFormat, "inputFile" => inputFile
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function test_parsing(
    ediType,
    fileFormat,
    inputFile,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return b2bi(
        "TestParsing",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ediType" => ediType,
                    "fileFormat" => fileFormat,
                    "inputFile" => inputFile,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Detaches a key-value pair from the specified resource, as identified by its Amazon Resource
Name (ARN). Resources are capability, partnership, profile, transformers and other entities.

# Arguments
- `resource_arn`: Specifies an Amazon Resource Name (ARN) for a specific Amazon Web
  Services resource, such as a capability, partnership, profile, or transformer.
- `tag_keys`: Specifies the key-value pairs assigned to ARNs that you can use to group and
  search for resources by type. You can attach this metadata to resources (capabilities,
  partnerships, and so on) for any purpose.

"""
function untag_resource(
    ResourceARN, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return b2bi(
        "UntagResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceARN,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return b2bi(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_capability(capability_id)
    update_capability(capability_id, params::Dict{String,<:Any})

Updates some of the parameters for a capability, based on the specified parameters. A
trading capability contains the information required to transform incoming EDI documents
into JSON or XML outputs.

# Arguments
- `capability_id`: Specifies a system-assigned unique identifier for the capability.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"configuration"`: Specifies a structure that contains the details for a capability.
- `"instructionsDocuments"`: Specifies one or more locations in Amazon S3, each specifying
  an EDI document that can be used with this capability. Each item contains the name of the
  bucket and the key, to identify the document's location.
- `"name"`: Specifies a new name for the capability, to replace the existing name.
"""
function update_capability(capabilityId; aws_config::AbstractAWSConfig=current_aws_config())
    return b2bi(
        "UpdateCapability",
        Dict{String,Any}("capabilityId" => capabilityId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_capability(
    capabilityId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return b2bi(
        "UpdateCapability",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("capabilityId" => capabilityId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_partnership(partnership_id)
    update_partnership(partnership_id, params::Dict{String,<:Any})

Updates some of the parameters for a partnership between a customer and trading partner. A
partnership represents the connection between you and your trading partner. It ties
together a profile and one or more trading capabilities.

# Arguments
- `partnership_id`: Specifies the unique, system-generated identifier for a partnership.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"capabilities"`: List of the capabilities associated with this partnership.
- `"name"`: The name of the partnership, used to identify it.
"""
function update_partnership(
    partnershipId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return b2bi(
        "UpdatePartnership",
        Dict{String,Any}("partnershipId" => partnershipId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_partnership(
    partnershipId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return b2bi(
        "UpdatePartnership",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("partnershipId" => partnershipId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_profile(profile_id)
    update_profile(profile_id, params::Dict{String,<:Any})

Updates the specified parameters for a profile. A profile is the mechanism used to create
the concept of a private network.

# Arguments
- `profile_id`: Specifies the unique, system-generated identifier for the profile.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"businessName"`: Specifies the name for the business associated with this profile.
- `"email"`: Specifies the email address associated with this customer profile.
- `"name"`: The name of the profile, used to identify it.
- `"phone"`: Specifies the phone number associated with the profile.
"""
function update_profile(profileId; aws_config::AbstractAWSConfig=current_aws_config())
    return b2bi(
        "UpdateProfile",
        Dict{String,Any}("profileId" => profileId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_profile(
    profileId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return b2bi(
        "UpdateProfile",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("profileId" => profileId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_transformer(transformer_id)
    update_transformer(transformer_id, params::Dict{String,<:Any})

Updates the specified parameters for a transformer. A transformer describes how to process
the incoming EDI documents and extract the necessary information to the output file.

# Arguments
- `transformer_id`: Specifies the system-assigned unique identifier for the transformer.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ediType"`: Specifies the details for the EDI standard that is being used for the
  transformer. Currently, only X12 is supported. X12 is a set of standards and corresponding
  messages that define specific business documents.
- `"fileFormat"`: Specifies that the currently supported file formats for EDI
  transformations are JSON and XML.
- `"mappingTemplate"`: Specifies the mapping template for the transformer. This template is
  used to map the parsed EDI file using JSONata or XSLT.
- `"name"`: Specify a new name for the transformer, if you want to update it.
- `"sampleDocument"`: Specifies a sample EDI document that is used by a transformer as a
  guide for processing the EDI data.
- `"status"`: Specifies the transformer's status. You can update the state of the
  transformer, from active to inactive, or inactive to active.
"""
function update_transformer(
    transformerId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return b2bi(
        "UpdateTransformer",
        Dict{String,Any}("transformerId" => transformerId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_transformer(
    transformerId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return b2bi(
        "UpdateTransformer",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("transformerId" => transformerId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: iotsitewise
using AWS.Compat
using AWS.UUIDs

"""
    associate_assets(asset_id, child_asset_id, hierarchy_id)
    associate_assets(asset_id, child_asset_id, hierarchy_id, params::Dict{String,<:Any})

Associates a child asset with the given parent asset through a hierarchy defined in the
parent asset's model. For more information, see Associating assets in the IoT SiteWise User
Guide.

# Arguments
- `asset_id`: The ID of the parent asset. This can be either the actual ID in UUID format,
  or else externalId: followed by the external ID, if it has one. For more information, see
  Referencing objects with external IDs in the IoT SiteWise User Guide.
- `child_asset_id`: The ID of the child asset to be associated. This can be either the
  actual ID in UUID format, or else externalId: followed by the external ID, if it has one.
  For more information, see Referencing objects with external IDs in the IoT SiteWise User
  Guide.
- `hierarchy_id`: The ID of a hierarchy in the parent asset's model. (This can be either
  the actual ID in UUID format, or else externalId: followed by the external ID, if it has
  one. For more information, see Referencing objects with external IDs in the IoT SiteWise
  User Guide.) Hierarchies allow different groupings of assets to be formed that all come
  from the same asset model. For more information, see Asset hierarchies in the IoT SiteWise
  User Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique case-sensitive identifier that you can provide to ensure the
  idempotency of the request. Don't reuse this client token if a new idempotent request is
  required.
"""
function associate_assets(
    assetId, childAssetId, hierarchyId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotsitewise(
        "POST",
        "/assets/$(assetId)/associate",
        Dict{String,Any}(
            "childAssetId" => childAssetId,
            "hierarchyId" => hierarchyId,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_assets(
    assetId,
    childAssetId,
    hierarchyId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "POST",
        "/assets/$(assetId)/associate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "childAssetId" => childAssetId,
                    "hierarchyId" => hierarchyId,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_time_series_to_asset_property(alias, asset_id, property_id)
    associate_time_series_to_asset_property(alias, asset_id, property_id, params::Dict{String,<:Any})

Associates a time series (data stream) with an asset property.

# Arguments
- `alias`: The alias that identifies the time series.
- `asset_id`: The ID of the asset in which the asset property was created. This can be
  either the actual ID in UUID format, or else externalId: followed by the external ID, if it
  has one. For more information, see Referencing objects with external IDs in the IoT
  SiteWise User Guide.
- `property_id`: The ID of the asset property. This can be either the actual ID in UUID
  format, or else externalId: followed by the external ID, if it has one. For more
  information, see Referencing objects with external IDs in the IoT SiteWise User Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique case-sensitive identifier that you can provide to ensure the
  idempotency of the request. Don't reuse this client token if a new idempotent request is
  required.
"""
function associate_time_series_to_asset_property(
    alias, assetId, propertyId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotsitewise(
        "POST",
        "/timeseries/associate/",
        Dict{String,Any}(
            "alias" => alias,
            "assetId" => assetId,
            "propertyId" => propertyId,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_time_series_to_asset_property(
    alias,
    assetId,
    propertyId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "POST",
        "/timeseries/associate/",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "alias" => alias,
                    "assetId" => assetId,
                    "propertyId" => propertyId,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_associate_project_assets(asset_ids, project_id)
    batch_associate_project_assets(asset_ids, project_id, params::Dict{String,<:Any})

Associates a group (batch) of assets with an IoT SiteWise Monitor project.

# Arguments
- `asset_ids`: The IDs of the assets to be associated to the project.
- `project_id`: The ID of the project to which to associate the assets.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique case-sensitive identifier that you can provide to ensure the
  idempotency of the request. Don't reuse this client token if a new idempotent request is
  required.
"""
function batch_associate_project_assets(
    assetIds, projectId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotsitewise(
        "POST",
        "/projects/$(projectId)/assets/associate",
        Dict{String,Any}("assetIds" => assetIds, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_associate_project_assets(
    assetIds,
    projectId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "POST",
        "/projects/$(projectId)/assets/associate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("assetIds" => assetIds, "clientToken" => string(uuid4())),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_disassociate_project_assets(asset_ids, project_id)
    batch_disassociate_project_assets(asset_ids, project_id, params::Dict{String,<:Any})

Disassociates a group (batch) of assets from an IoT SiteWise Monitor project.

# Arguments
- `asset_ids`: The IDs of the assets to be disassociated from the project.
- `project_id`: The ID of the project from which to disassociate the assets.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique case-sensitive identifier that you can provide to ensure the
  idempotency of the request. Don't reuse this client token if a new idempotent request is
  required.
"""
function batch_disassociate_project_assets(
    assetIds, projectId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotsitewise(
        "POST",
        "/projects/$(projectId)/assets/disassociate",
        Dict{String,Any}("assetIds" => assetIds, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_disassociate_project_assets(
    assetIds,
    projectId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "POST",
        "/projects/$(projectId)/assets/disassociate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("assetIds" => assetIds, "clientToken" => string(uuid4())),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_get_asset_property_aggregates(entries)
    batch_get_asset_property_aggregates(entries, params::Dict{String,<:Any})

Gets aggregated values (for example, average, minimum, and maximum) for one or more asset
properties. For more information, see Querying aggregates in the IoT SiteWise User Guide.

# Arguments
- `entries`: The list of asset property aggregate entries for the batch get request. You
  can specify up to 16 entries per request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return for each paginated request. A
  result set is returned in the two cases, whichever occurs first.   The size of the result
  set is equal to 1 MB.   The number of data points in the result set is equal to the value
  of maxResults. The maximum value of maxResults is 4000.
- `"nextToken"`: The token to be used for the next set of paginated results.
"""
function batch_get_asset_property_aggregates(
    entries; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotsitewise(
        "POST",
        "/properties/batch/aggregates",
        Dict{String,Any}("entries" => entries);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_asset_property_aggregates(
    entries,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "POST",
        "/properties/batch/aggregates",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("entries" => entries), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_get_asset_property_value(entries)
    batch_get_asset_property_value(entries, params::Dict{String,<:Any})

Gets the current value for one or more asset properties. For more information, see Querying
current values in the IoT SiteWise User Guide.

# Arguments
- `entries`: The list of asset property value entries for the batch get request. You can
  specify up to 128 entries per request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: The token to be used for the next set of paginated results.
"""
function batch_get_asset_property_value(
    entries; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotsitewise(
        "POST",
        "/properties/batch/latest",
        Dict{String,Any}("entries" => entries);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_asset_property_value(
    entries,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "POST",
        "/properties/batch/latest",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("entries" => entries), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_get_asset_property_value_history(entries)
    batch_get_asset_property_value_history(entries, params::Dict{String,<:Any})

Gets the historical values for one or more asset properties. For more information, see
Querying historical values in the IoT SiteWise User Guide.

# Arguments
- `entries`: The list of asset property historical value entries for the batch get request.
  You can specify up to 16 entries per request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return for each paginated request. A
  result set is returned in the two cases, whichever occurs first.   The size of the result
  set is equal to 4 MB.   The number of data points in the result set is equal to the value
  of maxResults. The maximum value of maxResults is 20000.
- `"nextToken"`: The token to be used for the next set of paginated results.
"""
function batch_get_asset_property_value_history(
    entries; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotsitewise(
        "POST",
        "/properties/batch/history",
        Dict{String,Any}("entries" => entries);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_asset_property_value_history(
    entries,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "POST",
        "/properties/batch/history",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("entries" => entries), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_put_asset_property_value(entries)
    batch_put_asset_property_value(entries, params::Dict{String,<:Any})

Sends a list of asset property values to IoT SiteWise. Each value is a
timestamp-quality-value (TQV) data point. For more information, see Ingesting data using
the API in the IoT SiteWise User Guide. To identify an asset property, you must specify one
of the following:   The assetId and propertyId of an asset property.   A propertyAlias,
which is a data stream alias (for example, /company/windfarm/3/turbine/7/temperature). To
define an asset property's alias, see UpdateAssetProperty.    With respect to Unix epoch
time, IoT SiteWise accepts only TQVs that have a timestamp of no more than 7 days in the
past and no more than 10 minutes in the future. IoT SiteWise rejects timestamps outside of
the inclusive range of [-7 days, +10 minutes] and returns a TimestampOutOfRangeException
error. For each asset property, IoT SiteWise overwrites TQVs with duplicate timestamps
unless the newer TQV has a different quality. For example, if you store a TQV {T1, GOOD,
V1}, then storing {T1, GOOD, V2} replaces the existing TQV.  IoT SiteWise authorizes access
to each BatchPutAssetPropertyValue entry individually. For more information, see
BatchPutAssetPropertyValue authorization in the IoT SiteWise User Guide.

# Arguments
- `entries`: The list of asset property value entries for the batch put request. You can
  specify up to 10 entries per request.

"""
function batch_put_asset_property_value(
    entries; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotsitewise(
        "POST",
        "/properties",
        Dict{String,Any}("entries" => entries);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_put_asset_property_value(
    entries,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "POST",
        "/properties",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("entries" => entries), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_access_policy(access_policy_identity, access_policy_permission, access_policy_resource)
    create_access_policy(access_policy_identity, access_policy_permission, access_policy_resource, params::Dict{String,<:Any})

Creates an access policy that grants the specified identity (IAM Identity Center user, IAM
Identity Center group, or IAM user) access to the specified IoT SiteWise Monitor portal or
project resource.

# Arguments
- `access_policy_identity`: The identity for this access policy. Choose an IAM Identity
  Center user, an IAM Identity Center group, or an IAM user.
- `access_policy_permission`: The permission level for this access policy. Note that a
  project ADMINISTRATOR is also known as a project owner.
- `access_policy_resource`: The IoT SiteWise Monitor resource for this access policy.
  Choose either a portal or a project.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique case-sensitive identifier that you can provide to ensure the
  idempotency of the request. Don't reuse this client token if a new idempotent request is
  required.
- `"tags"`: A list of key-value pairs that contain metadata for the access policy. For more
  information, see Tagging your IoT SiteWise resources in the IoT SiteWise User Guide.
"""
function create_access_policy(
    accessPolicyIdentity,
    accessPolicyPermission,
    accessPolicyResource;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "POST",
        "/access-policies",
        Dict{String,Any}(
            "accessPolicyIdentity" => accessPolicyIdentity,
            "accessPolicyPermission" => accessPolicyPermission,
            "accessPolicyResource" => accessPolicyResource,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_access_policy(
    accessPolicyIdentity,
    accessPolicyPermission,
    accessPolicyResource,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "POST",
        "/access-policies",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "accessPolicyIdentity" => accessPolicyIdentity,
                    "accessPolicyPermission" => accessPolicyPermission,
                    "accessPolicyResource" => accessPolicyResource,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_asset(asset_model_id, asset_name)
    create_asset(asset_model_id, asset_name, params::Dict{String,<:Any})

Creates an asset from an existing asset model. For more information, see Creating assets in
the IoT SiteWise User Guide.

# Arguments
- `asset_model_id`: The ID of the asset model from which to create the asset. This can be
  either the actual ID in UUID format, or else externalId: followed by the external ID, if it
  has one. For more information, see Referencing objects with external IDs in the IoT
  SiteWise User Guide.
- `asset_name`: A friendly name for the asset.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"assetDescription"`: A description for the asset.
- `"assetExternalId"`: An external ID to assign to the asset. The external ID must be
  unique within your Amazon Web Services account. For more information, see Using external
  IDs in the IoT SiteWise User Guide.
- `"assetId"`: The ID to assign to the asset, if desired. IoT SiteWise automatically
  generates a unique ID for you, so this parameter is never required. However, if you prefer
  to supply your own ID instead, you can specify it here in UUID format. If you specify your
  own ID, it must be globally unique.
- `"clientToken"`: A unique case-sensitive identifier that you can provide to ensure the
  idempotency of the request. Don't reuse this client token if a new idempotent request is
  required.
- `"tags"`: A list of key-value pairs that contain metadata for the asset. For more
  information, see Tagging your IoT SiteWise resources in the IoT SiteWise User Guide.
"""
function create_asset(
    assetModelId, assetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotsitewise(
        "POST",
        "/assets",
        Dict{String,Any}(
            "assetModelId" => assetModelId,
            "assetName" => assetName,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_asset(
    assetModelId,
    assetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "POST",
        "/assets",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "assetModelId" => assetModelId,
                    "assetName" => assetName,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_asset_model(asset_model_name)
    create_asset_model(asset_model_name, params::Dict{String,<:Any})

Creates an asset model from specified property and hierarchy definitions. You create assets
from asset models. With asset models, you can easily create assets of the same type that
have standardized definitions. Each asset created from a model inherits the asset model's
property and hierarchy definitions. For more information, see Defining asset models in the
IoT SiteWise User Guide. You can create two types of asset models, ASSET_MODEL or
COMPONENT_MODEL.    ASSET_MODEL – (default) An asset model that you can use to create
assets. Can't be included as a component in another asset model.    COMPONENT_MODEL – A
reusable component that you can include in the composite models of other asset models. You
can't create assets directly from this type of asset model.

# Arguments
- `asset_model_name`: A unique, friendly name for the asset model.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"assetModelCompositeModels"`: The composite models that are part of this asset model. It
  groups properties (such as attributes, measurements, transforms, and metrics) and child
  composite models that model parts of your industrial equipment. Each composite model has a
  type that defines the properties that the composite model supports. Use composite models to
  define alarms on this asset model.  When creating custom composite models, you need to use
  CreateAssetModelCompositeModel. For more information, see &lt;LINK&gt;.
- `"assetModelDescription"`: A description for the asset model.
- `"assetModelExternalId"`: An external ID to assign to the asset model. The external ID
  must be unique within your Amazon Web Services account. For more information, see Using
  external IDs in the IoT SiteWise User Guide.
- `"assetModelHierarchies"`: The hierarchy definitions of the asset model. Each hierarchy
  specifies an asset model whose assets can be children of any other assets created from this
  asset model. For more information, see Asset hierarchies in the IoT SiteWise User Guide.
  You can specify up to 10 hierarchies per asset model. For more information, see Quotas in
  the IoT SiteWise User Guide.
- `"assetModelId"`: The ID to assign to the asset model, if desired. IoT SiteWise
  automatically generates a unique ID for you, so this parameter is never required. However,
  if you prefer to supply your own ID instead, you can specify it here in UUID format. If you
  specify your own ID, it must be globally unique.
- `"assetModelProperties"`: The property definitions of the asset model. For more
  information, see Asset properties in the IoT SiteWise User Guide. You can specify up to 200
  properties per asset model. For more information, see Quotas in the IoT SiteWise User Guide.
- `"assetModelType"`: The type of asset model.    ASSET_MODEL – (default) An asset model
  that you can use to create assets. Can't be included as a component in another asset model.
     COMPONENT_MODEL – A reusable component that you can include in the composite models of
  other asset models. You can't create assets directly from this type of asset model.
- `"clientToken"`: A unique case-sensitive identifier that you can provide to ensure the
  idempotency of the request. Don't reuse this client token if a new idempotent request is
  required.
- `"tags"`: A list of key-value pairs that contain metadata for the asset model. For more
  information, see Tagging your IoT SiteWise resources in the IoT SiteWise User Guide.
"""
function create_asset_model(
    assetModelName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotsitewise(
        "POST",
        "/asset-models",
        Dict{String,Any}(
            "assetModelName" => assetModelName, "clientToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_asset_model(
    assetModelName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "POST",
        "/asset-models",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "assetModelName" => assetModelName, "clientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_asset_model_composite_model(asset_model_composite_model_name, asset_model_composite_model_type, asset_model_id)
    create_asset_model_composite_model(asset_model_composite_model_name, asset_model_composite_model_type, asset_model_id, params::Dict{String,<:Any})

Creates a custom composite model from specified property and hierarchy definitions. There
are two types of custom composite models, inline and component-model-based.  Use
component-model-based custom composite models to define standard, reusable components. A
component-model-based custom composite model consists of a name, a description, and the ID
of the component model it references. A component-model-based custom composite model has no
properties of its own; its referenced component model provides its associated properties to
any created assets. For more information, see Custom composite models (Components) in the
IoT SiteWise User Guide. Use inline custom composite models to organize the properties of
an asset model. The properties of inline custom composite models are local to the asset
model where they are included and can't be used to create multiple assets. To create a
component-model-based model, specify the composedAssetModelId of an existing asset model
with assetModelType of COMPONENT_MODEL. To create an inline model, specify the
assetModelCompositeModelProperties and don't include an composedAssetModelId.

# Arguments
- `asset_model_composite_model_name`: A unique, friendly name for the composite model.
- `asset_model_composite_model_type`: The composite model type. Valid values are AWS/ALARM,
  CUSTOM, or  AWS/L4E_ANOMALY.
- `asset_model_id`: The ID of the asset model this composite model is a part of.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"assetModelCompositeModelDescription"`: A description for the composite model.
- `"assetModelCompositeModelExternalId"`: An external ID to assign to the composite model.
  If the composite model is a derived composite model, or one nested inside a component
  model, you can only set the external ID using UpdateAssetModelCompositeModel and specifying
  the derived ID of the model or property from the created model it's a part of.
- `"assetModelCompositeModelId"`: The ID of the composite model. IoT SiteWise automatically
  generates a unique ID for you, so this parameter is never required. However, if you prefer
  to supply your own ID instead, you can specify it here in UUID format. If you specify your
  own ID, it must be globally unique.
- `"assetModelCompositeModelProperties"`: The property definitions of the composite model.
  For more information, see &lt;LINK&gt;. You can specify up to 200 properties per composite
  model. For more information, see Quotas in the IoT SiteWise User Guide.
- `"clientToken"`: A unique case-sensitive identifier that you can provide to ensure the
  idempotency of the request. Don't reuse this client token if a new idempotent request is
  required.
- `"composedAssetModelId"`: The ID of a composite model on this asset.
- `"parentAssetModelCompositeModelId"`: The ID of the parent composite model in this asset
  model relationship.
"""
function create_asset_model_composite_model(
    assetModelCompositeModelName,
    assetModelCompositeModelType,
    assetModelId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "POST",
        "/asset-models/$(assetModelId)/composite-models",
        Dict{String,Any}(
            "assetModelCompositeModelName" => assetModelCompositeModelName,
            "assetModelCompositeModelType" => assetModelCompositeModelType,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_asset_model_composite_model(
    assetModelCompositeModelName,
    assetModelCompositeModelType,
    assetModelId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "POST",
        "/asset-models/$(assetModelId)/composite-models",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "assetModelCompositeModelName" => assetModelCompositeModelName,
                    "assetModelCompositeModelType" => assetModelCompositeModelType,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_bulk_import_job(error_report_location, files, job_configuration, job_name, job_role_arn)
    create_bulk_import_job(error_report_location, files, job_configuration, job_name, job_role_arn, params::Dict{String,<:Any})

Defines a job to ingest data to IoT SiteWise from Amazon S3. For more information, see
Create a bulk import job (CLI) in the Amazon Simple Storage Service User Guide.  Before you
create a bulk import job, you must enable IoT SiteWise warm tier or IoT SiteWise cold tier.
For more information about how to configure storage settings, see PutStorageConfiguration.
Bulk import is designed to store historical data to IoT SiteWise. It does not trigger
computations or notifications on IoT SiteWise warm or cold tier storage.

# Arguments
- `error_report_location`: The Amazon S3 destination where errors associated with the job
  creation request are saved.
- `files`: The files in the specified Amazon S3 bucket that contain your data.
- `job_configuration`: Contains the configuration information of a job, such as the file
  format used to save data in Amazon S3.
- `job_name`: The unique name that helps identify the job request.
- `job_role_arn`: The ARN of the IAM role that allows IoT SiteWise to read Amazon S3 data.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"adaptiveIngestion"`: If set to true, ingest new data into IoT SiteWise storage.
  Measurements with notifications, metrics and transforms are computed. If set to false,
  historical data is ingested into IoT SiteWise as is.
- `"deleteFilesAfterImport"`: If set to true, your data files is deleted from S3, after
  ingestion into IoT SiteWise storage.
"""
function create_bulk_import_job(
    errorReportLocation,
    files,
    jobConfiguration,
    jobName,
    jobRoleArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "POST",
        "/jobs",
        Dict{String,Any}(
            "errorReportLocation" => errorReportLocation,
            "files" => files,
            "jobConfiguration" => jobConfiguration,
            "jobName" => jobName,
            "jobRoleArn" => jobRoleArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_bulk_import_job(
    errorReportLocation,
    files,
    jobConfiguration,
    jobName,
    jobRoleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "POST",
        "/jobs",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "errorReportLocation" => errorReportLocation,
                    "files" => files,
                    "jobConfiguration" => jobConfiguration,
                    "jobName" => jobName,
                    "jobRoleArn" => jobRoleArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_dashboard(dashboard_definition, dashboard_name, project_id)
    create_dashboard(dashboard_definition, dashboard_name, project_id, params::Dict{String,<:Any})

Creates a dashboard in an IoT SiteWise Monitor project.

# Arguments
- `dashboard_definition`: The dashboard definition specified in a JSON literal. For
  detailed information, see Creating dashboards (CLI) in the IoT SiteWise User Guide.
- `dashboard_name`: A friendly name for the dashboard.
- `project_id`: The ID of the project in which to create the dashboard.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique case-sensitive identifier that you can provide to ensure the
  idempotency of the request. Don't reuse this client token if a new idempotent request is
  required.
- `"dashboardDescription"`: A description for the dashboard.
- `"tags"`: A list of key-value pairs that contain metadata for the dashboard. For more
  information, see Tagging your IoT SiteWise resources in the IoT SiteWise User Guide.
"""
function create_dashboard(
    dashboardDefinition,
    dashboardName,
    projectId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "POST",
        "/dashboards",
        Dict{String,Any}(
            "dashboardDefinition" => dashboardDefinition,
            "dashboardName" => dashboardName,
            "projectId" => projectId,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_dashboard(
    dashboardDefinition,
    dashboardName,
    projectId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "POST",
        "/dashboards",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "dashboardDefinition" => dashboardDefinition,
                    "dashboardName" => dashboardName,
                    "projectId" => projectId,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_gateway(gateway_name, gateway_platform)
    create_gateway(gateway_name, gateway_platform, params::Dict{String,<:Any})

Creates a gateway, which is a virtual or edge device that delivers industrial data streams
from local servers to IoT SiteWise. For more information, see Ingesting data using a
gateway in the IoT SiteWise User Guide.

# Arguments
- `gateway_name`: A unique, friendly name for the gateway.
- `gateway_platform`: The gateway's platform. You can only specify one platform in a
  gateway.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tags"`: A list of key-value pairs that contain metadata for the gateway. For more
  information, see Tagging your IoT SiteWise resources in the IoT SiteWise User Guide.
"""
function create_gateway(
    gatewayName, gatewayPlatform; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotsitewise(
        "POST",
        "/20200301/gateways",
        Dict{String,Any}(
            "gatewayName" => gatewayName, "gatewayPlatform" => gatewayPlatform
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_gateway(
    gatewayName,
    gatewayPlatform,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "POST",
        "/20200301/gateways",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "gatewayName" => gatewayName, "gatewayPlatform" => gatewayPlatform
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_portal(portal_contact_email, portal_name, role_arn)
    create_portal(portal_contact_email, portal_name, role_arn, params::Dict{String,<:Any})

Creates a portal, which can contain projects and dashboards. IoT SiteWise Monitor uses IAM
Identity Center or IAM to authenticate portal users and manage user permissions.  Before
you can sign in to a new portal, you must add at least one identity to that portal. For
more information, see Adding or removing portal administrators in the IoT SiteWise User
Guide.

# Arguments
- `portal_contact_email`: The Amazon Web Services administrator's contact email address.
- `portal_name`: A friendly name for the portal.
- `role_arn`: The ARN of a service role that allows the portal's users to access your IoT
  SiteWise resources on your behalf. For more information, see Using service roles for IoT
  SiteWise Monitor in the IoT SiteWise User Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"alarms"`: Contains the configuration information of an alarm created in an IoT SiteWise
  Monitor portal. You can use the alarm to monitor an asset property and get notified when
  the asset property value is outside a specified range. For more information, see Monitoring
  with alarms in the IoT SiteWise Application Guide.
- `"clientToken"`: A unique case-sensitive identifier that you can provide to ensure the
  idempotency of the request. Don't reuse this client token if a new idempotent request is
  required.
- `"notificationSenderEmail"`: The email address that sends alarm notifications.  If you
  use the IoT Events managed Lambda function to manage your emails, you must verify the
  sender email address in Amazon SES.
- `"portalAuthMode"`: The service to use to authenticate users to the portal. Choose from
  the following options:    SSO – The portal uses IAM Identity Center to authenticate users
  and manage user permissions. Before you can create a portal that uses IAM Identity Center,
  you must enable IAM Identity Center. For more information, see Enabling IAM Identity Center
  in the IoT SiteWise User Guide. This option is only available in Amazon Web Services
  Regions other than the China Regions.    IAM – The portal uses Identity and Access
  Management to authenticate users and manage user permissions.   You can't change this value
  after you create a portal. Default: SSO
- `"portalDescription"`: A description for the portal.
- `"portalLogoImageFile"`: A logo image to display in the portal. Upload a square,
  high-resolution image. The image is displayed on a dark background.
- `"tags"`: A list of key-value pairs that contain metadata for the portal. For more
  information, see Tagging your IoT SiteWise resources in the IoT SiteWise User Guide.
"""
function create_portal(
    portalContactEmail,
    portalName,
    roleArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "POST",
        "/portals",
        Dict{String,Any}(
            "portalContactEmail" => portalContactEmail,
            "portalName" => portalName,
            "roleArn" => roleArn,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_portal(
    portalContactEmail,
    portalName,
    roleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "POST",
        "/portals",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "portalContactEmail" => portalContactEmail,
                    "portalName" => portalName,
                    "roleArn" => roleArn,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_project(portal_id, project_name)
    create_project(portal_id, project_name, params::Dict{String,<:Any})

Creates a project in the specified portal.  Make sure that the project name and description
don't contain confidential information.

# Arguments
- `portal_id`: The ID of the portal in which to create the project.
- `project_name`: A friendly name for the project.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique case-sensitive identifier that you can provide to ensure the
  idempotency of the request. Don't reuse this client token if a new idempotent request is
  required.
- `"projectDescription"`: A description for the project.
- `"tags"`: A list of key-value pairs that contain metadata for the project. For more
  information, see Tagging your IoT SiteWise resources in the IoT SiteWise User Guide.
"""
function create_project(
    portalId, projectName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotsitewise(
        "POST",
        "/projects",
        Dict{String,Any}(
            "portalId" => portalId,
            "projectName" => projectName,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_project(
    portalId,
    projectName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "POST",
        "/projects",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "portalId" => portalId,
                    "projectName" => projectName,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_access_policy(access_policy_id)
    delete_access_policy(access_policy_id, params::Dict{String,<:Any})

Deletes an access policy that grants the specified identity access to the specified IoT
SiteWise Monitor resource. You can use this operation to revoke access to an IoT SiteWise
Monitor resource.

# Arguments
- `access_policy_id`: The ID of the access policy to be deleted.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique case-sensitive identifier that you can provide to ensure the
  idempotency of the request. Don't reuse this client token if a new idempotent request is
  required.
"""
function delete_access_policy(
    accessPolicyId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotsitewise(
        "DELETE",
        "/access-policies/$(accessPolicyId)",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_access_policy(
    accessPolicyId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "DELETE",
        "/access-policies/$(accessPolicyId)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_asset(asset_id)
    delete_asset(asset_id, params::Dict{String,<:Any})

Deletes an asset. This action can't be undone. For more information, see Deleting assets
and models in the IoT SiteWise User Guide.  You can't delete an asset that's associated to
another asset. For more information, see DisassociateAssets.

# Arguments
- `asset_id`: The ID of the asset to delete. This can be either the actual ID in UUID
  format, or else externalId: followed by the external ID, if it has one. For more
  information, see Referencing objects with external IDs in the IoT SiteWise User Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique case-sensitive identifier that you can provide to ensure the
  idempotency of the request. Don't reuse this client token if a new idempotent request is
  required.
"""
function delete_asset(assetId; aws_config::AbstractAWSConfig=current_aws_config())
    return iotsitewise(
        "DELETE",
        "/assets/$(assetId)",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_asset(
    assetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "DELETE",
        "/assets/$(assetId)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_asset_model(asset_model_id)
    delete_asset_model(asset_model_id, params::Dict{String,<:Any})

Deletes an asset model. This action can't be undone. You must delete all assets created
from an asset model before you can delete the model. Also, you can't delete an asset model
if a parent asset model exists that contains a property formula expression that depends on
the asset model that you want to delete. For more information, see Deleting assets and
models in the IoT SiteWise User Guide.

# Arguments
- `asset_model_id`: The ID of the asset model to delete. This can be either the actual ID
  in UUID format, or else externalId: followed by the external ID, if it has one. For more
  information, see Referencing objects with external IDs in the IoT SiteWise User Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique case-sensitive identifier that you can provide to ensure the
  idempotency of the request. Don't reuse this client token if a new idempotent request is
  required.
"""
function delete_asset_model(
    assetModelId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotsitewise(
        "DELETE",
        "/asset-models/$(assetModelId)",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_asset_model(
    assetModelId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "DELETE",
        "/asset-models/$(assetModelId)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_asset_model_composite_model(asset_model_composite_model_id, asset_model_id)
    delete_asset_model_composite_model(asset_model_composite_model_id, asset_model_id, params::Dict{String,<:Any})

Deletes a composite model. This action can't be undone. You must delete all assets created
from a composite model before you can delete the model. Also, you can't delete a composite
model if a parent asset model exists that contains a property formula expression that
depends on the asset model that you want to delete. For more information, see Deleting
assets and models in the IoT SiteWise User Guide.

# Arguments
- `asset_model_composite_model_id`: The ID of a composite model on this asset model.
- `asset_model_id`: The ID of the asset model, in UUID format.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique case-sensitive identifier that you can provide to ensure the
  idempotency of the request. Don't reuse this client token if a new idempotent request is
  required.
"""
function delete_asset_model_composite_model(
    assetModelCompositeModelId,
    assetModelId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "DELETE",
        "/asset-models/$(assetModelId)/composite-models/$(assetModelCompositeModelId)",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_asset_model_composite_model(
    assetModelCompositeModelId,
    assetModelId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "DELETE",
        "/asset-models/$(assetModelId)/composite-models/$(assetModelCompositeModelId)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_dashboard(dashboard_id)
    delete_dashboard(dashboard_id, params::Dict{String,<:Any})

Deletes a dashboard from IoT SiteWise Monitor.

# Arguments
- `dashboard_id`: The ID of the dashboard to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique case-sensitive identifier that you can provide to ensure the
  idempotency of the request. Don't reuse this client token if a new idempotent request is
  required.
"""
function delete_dashboard(dashboardId; aws_config::AbstractAWSConfig=current_aws_config())
    return iotsitewise(
        "DELETE",
        "/dashboards/$(dashboardId)",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_dashboard(
    dashboardId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "DELETE",
        "/dashboards/$(dashboardId)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_gateway(gateway_id)
    delete_gateway(gateway_id, params::Dict{String,<:Any})

Deletes a gateway from IoT SiteWise. When you delete a gateway, some of the gateway's files
remain in your gateway's file system.

# Arguments
- `gateway_id`: The ID of the gateway to delete.

"""
function delete_gateway(gatewayId; aws_config::AbstractAWSConfig=current_aws_config())
    return iotsitewise(
        "DELETE",
        "/20200301/gateways/$(gatewayId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_gateway(
    gatewayId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "DELETE",
        "/20200301/gateways/$(gatewayId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_portal(portal_id)
    delete_portal(portal_id, params::Dict{String,<:Any})

Deletes a portal from IoT SiteWise Monitor.

# Arguments
- `portal_id`: The ID of the portal to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique case-sensitive identifier that you can provide to ensure the
  idempotency of the request. Don't reuse this client token if a new idempotent request is
  required.
"""
function delete_portal(portalId; aws_config::AbstractAWSConfig=current_aws_config())
    return iotsitewise(
        "DELETE",
        "/portals/$(portalId)",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_portal(
    portalId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "DELETE",
        "/portals/$(portalId)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_project(project_id)
    delete_project(project_id, params::Dict{String,<:Any})

Deletes a project from IoT SiteWise Monitor.

# Arguments
- `project_id`: The ID of the project.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique case-sensitive identifier that you can provide to ensure the
  idempotency of the request. Don't reuse this client token if a new idempotent request is
  required.
"""
function delete_project(projectId; aws_config::AbstractAWSConfig=current_aws_config())
    return iotsitewise(
        "DELETE",
        "/projects/$(projectId)",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_project(
    projectId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "DELETE",
        "/projects/$(projectId)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_time_series()
    delete_time_series(params::Dict{String,<:Any})

Deletes a time series (data stream). If you delete a time series that's associated with an
asset property, the asset property still exists, but the time series will no longer be
associated with this asset property. To identify a time series, do one of the following:
If the time series isn't associated with an asset property, specify the alias of the time
series.   If the time series is associated with an asset property, specify one of the
following:    The alias of the time series.   The assetId and propertyId that identifies
the asset property.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"alias"`: The alias that identifies the time series.
- `"assetId"`: The ID of the asset in which the asset property was created. This can be
  either the actual ID in UUID format, or else externalId: followed by the external ID, if it
  has one. For more information, see Referencing objects with external IDs in the IoT
  SiteWise User Guide.
- `"clientToken"`: A unique case-sensitive identifier that you can provide to ensure the
  idempotency of the request. Don't reuse this client token if a new idempotent request is
  required.
- `"propertyId"`: The ID of the asset property. This can be either the actual ID in UUID
  format, or else externalId: followed by the external ID, if it has one. For more
  information, see Referencing objects with external IDs in the IoT SiteWise User Guide.
"""
function delete_time_series(; aws_config::AbstractAWSConfig=current_aws_config())
    return iotsitewise(
        "POST",
        "/timeseries/delete/",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_time_series(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotsitewise(
        "POST",
        "/timeseries/delete/",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_access_policy(access_policy_id)
    describe_access_policy(access_policy_id, params::Dict{String,<:Any})

Describes an access policy, which specifies an identity's access to an IoT SiteWise Monitor
portal or project.

# Arguments
- `access_policy_id`: The ID of the access policy.

"""
function describe_access_policy(
    accessPolicyId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotsitewise(
        "GET",
        "/access-policies/$(accessPolicyId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_access_policy(
    accessPolicyId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "GET",
        "/access-policies/$(accessPolicyId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_action(action_id)
    describe_action(action_id, params::Dict{String,<:Any})

Retrieves information about an action.

# Arguments
- `action_id`: The ID of the action.

"""
function describe_action(actionId; aws_config::AbstractAWSConfig=current_aws_config())
    return iotsitewise(
        "GET",
        "/actions/$(actionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_action(
    actionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "GET",
        "/actions/$(actionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_asset(asset_id)
    describe_asset(asset_id, params::Dict{String,<:Any})

Retrieves information about an asset.

# Arguments
- `asset_id`: The ID of the asset. This can be either the actual ID in UUID format, or else
  externalId: followed by the external ID, if it has one. For more information, see
  Referencing objects with external IDs in the IoT SiteWise User Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"excludeProperties"`:  Whether or not to exclude asset properties from the response.
"""
function describe_asset(assetId; aws_config::AbstractAWSConfig=current_aws_config())
    return iotsitewise(
        "GET", "/assets/$(assetId)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_asset(
    assetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "GET",
        "/assets/$(assetId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_asset_composite_model(asset_composite_model_id, asset_id)
    describe_asset_composite_model(asset_composite_model_id, asset_id, params::Dict{String,<:Any})

Retrieves information about an asset composite model (also known as an asset component). An
AssetCompositeModel is an instance of an AssetModelCompositeModel. If you want to see
information about the model this is based on, call DescribeAssetModelCompositeModel.

# Arguments
- `asset_composite_model_id`: The ID of a composite model on this asset. This can be either
  the actual ID in UUID format, or else externalId: followed by the external ID, if it has
  one. For more information, see Referencing objects with external IDs in the IoT SiteWise
  User Guide.
- `asset_id`: The ID of the asset. This can be either the actual ID in UUID format, or else
  externalId: followed by the external ID, if it has one. For more information, see
  Referencing objects with external IDs in the IoT SiteWise User Guide.

"""
function describe_asset_composite_model(
    assetCompositeModelId, assetId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotsitewise(
        "GET",
        "/assets/$(assetId)/composite-models/$(assetCompositeModelId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_asset_composite_model(
    assetCompositeModelId,
    assetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "GET",
        "/assets/$(assetId)/composite-models/$(assetCompositeModelId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_asset_model(asset_model_id)
    describe_asset_model(asset_model_id, params::Dict{String,<:Any})

Retrieves information about an asset model.

# Arguments
- `asset_model_id`: The ID of the asset model. This can be either the actual ID in UUID
  format, or else externalId: followed by the external ID, if it has one. For more
  information, see Referencing objects with external IDs in the IoT SiteWise User Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"excludeProperties"`:  Whether or not to exclude asset model properties from the
  response.
"""
function describe_asset_model(
    assetModelId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotsitewise(
        "GET",
        "/asset-models/$(assetModelId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_asset_model(
    assetModelId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "GET",
        "/asset-models/$(assetModelId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_asset_model_composite_model(asset_model_composite_model_id, asset_model_id)
    describe_asset_model_composite_model(asset_model_composite_model_id, asset_model_id, params::Dict{String,<:Any})

Retrieves information about an asset model composite model (also known as an asset model
component). For more information, see Custom composite models (Components) in the IoT
SiteWise User Guide.

# Arguments
- `asset_model_composite_model_id`: The ID of a composite model on this asset model. This
  can be either the actual ID in UUID format, or else externalId: followed by the external
  ID, if it has one. For more information, see Referencing objects with external IDs in the
  IoT SiteWise User Guide.
- `asset_model_id`: The ID of the asset model. This can be either the actual ID in UUID
  format, or else externalId: followed by the external ID, if it has one. For more
  information, see Referencing objects with external IDs in the IoT SiteWise User Guide.

"""
function describe_asset_model_composite_model(
    assetModelCompositeModelId,
    assetModelId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "GET",
        "/asset-models/$(assetModelId)/composite-models/$(assetModelCompositeModelId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_asset_model_composite_model(
    assetModelCompositeModelId,
    assetModelId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "GET",
        "/asset-models/$(assetModelId)/composite-models/$(assetModelCompositeModelId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_asset_property(asset_id, property_id)
    describe_asset_property(asset_id, property_id, params::Dict{String,<:Any})

Retrieves information about an asset property.  When you call this operation for an
attribute property, this response includes the default attribute value that you define in
the asset model. If you update the default value in the model, this operation's response
includes the new default value.  This operation doesn't return the value of the asset
property. To get the value of an asset property, use GetAssetPropertyValue.

# Arguments
- `asset_id`: The ID of the asset. This can be either the actual ID in UUID format, or else
  externalId: followed by the external ID, if it has one. For more information, see
  Referencing objects with external IDs in the IoT SiteWise User Guide.
- `property_id`: The ID of the asset property. This can be either the actual ID in UUID
  format, or else externalId: followed by the external ID, if it has one. For more
  information, see Referencing objects with external IDs in the IoT SiteWise User Guide.

"""
function describe_asset_property(
    assetId, propertyId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotsitewise(
        "GET",
        "/assets/$(assetId)/properties/$(propertyId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_asset_property(
    assetId,
    propertyId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "GET",
        "/assets/$(assetId)/properties/$(propertyId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_bulk_import_job(job_id)
    describe_bulk_import_job(job_id, params::Dict{String,<:Any})

Retrieves information about a bulk import job request. For more information, see Describe a
bulk import job (CLI) in the Amazon Simple Storage Service User Guide.

# Arguments
- `job_id`: The ID of the job.

"""
function describe_bulk_import_job(jobId; aws_config::AbstractAWSConfig=current_aws_config())
    return iotsitewise(
        "GET", "/jobs/$(jobId)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_bulk_import_job(
    jobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotsitewise(
        "GET",
        "/jobs/$(jobId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_dashboard(dashboard_id)
    describe_dashboard(dashboard_id, params::Dict{String,<:Any})

Retrieves information about a dashboard.

# Arguments
- `dashboard_id`: The ID of the dashboard.

"""
function describe_dashboard(dashboardId; aws_config::AbstractAWSConfig=current_aws_config())
    return iotsitewise(
        "GET",
        "/dashboards/$(dashboardId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_dashboard(
    dashboardId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "GET",
        "/dashboards/$(dashboardId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_default_encryption_configuration()
    describe_default_encryption_configuration(params::Dict{String,<:Any})

Retrieves information about the default encryption configuration for the Amazon Web
Services account in the default or specified Region. For more information, see Key
management in the IoT SiteWise User Guide.

"""
function describe_default_encryption_configuration(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotsitewise(
        "GET",
        "/configuration/account/encryption";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_default_encryption_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotsitewise(
        "GET",
        "/configuration/account/encryption",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_gateway(gateway_id)
    describe_gateway(gateway_id, params::Dict{String,<:Any})

Retrieves information about a gateway.

# Arguments
- `gateway_id`: The ID of the gateway device.

"""
function describe_gateway(gatewayId; aws_config::AbstractAWSConfig=current_aws_config())
    return iotsitewise(
        "GET",
        "/20200301/gateways/$(gatewayId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_gateway(
    gatewayId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "GET",
        "/20200301/gateways/$(gatewayId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_gateway_capability_configuration(capability_namespace, gateway_id)
    describe_gateway_capability_configuration(capability_namespace, gateway_id, params::Dict{String,<:Any})

Retrieves information about a gateway capability configuration. Each gateway capability
defines data sources for a gateway. A capability configuration can contain multiple data
source configurations. If you define OPC-UA sources for a gateway in the IoT SiteWise
console, all of your OPC-UA sources are stored in one capability configuration. To list all
capability configurations for a gateway, use DescribeGateway.

# Arguments
- `capability_namespace`: The namespace of the capability configuration. For example, if
  you configure OPC-UA sources from the IoT SiteWise console, your OPC-UA capability
  configuration has the namespace iotsitewise:opcuacollector:version, where version is a
  number such as 1.
- `gateway_id`: The ID of the gateway that defines the capability configuration.

"""
function describe_gateway_capability_configuration(
    capabilityNamespace, gatewayId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotsitewise(
        "GET",
        "/20200301/gateways/$(gatewayId)/capability/$(capabilityNamespace)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_gateway_capability_configuration(
    capabilityNamespace,
    gatewayId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "GET",
        "/20200301/gateways/$(gatewayId)/capability/$(capabilityNamespace)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_logging_options()
    describe_logging_options(params::Dict{String,<:Any})

Retrieves the current IoT SiteWise logging options.

"""
function describe_logging_options(; aws_config::AbstractAWSConfig=current_aws_config())
    return iotsitewise(
        "GET", "/logging"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_logging_options(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotsitewise(
        "GET", "/logging", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_portal(portal_id)
    describe_portal(portal_id, params::Dict{String,<:Any})

Retrieves information about a portal.

# Arguments
- `portal_id`: The ID of the portal.

"""
function describe_portal(portalId; aws_config::AbstractAWSConfig=current_aws_config())
    return iotsitewise(
        "GET",
        "/portals/$(portalId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_portal(
    portalId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "GET",
        "/portals/$(portalId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_project(project_id)
    describe_project(project_id, params::Dict{String,<:Any})

Retrieves information about a project.

# Arguments
- `project_id`: The ID of the project.

"""
function describe_project(projectId; aws_config::AbstractAWSConfig=current_aws_config())
    return iotsitewise(
        "GET",
        "/projects/$(projectId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_project(
    projectId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "GET",
        "/projects/$(projectId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_storage_configuration()
    describe_storage_configuration(params::Dict{String,<:Any})

Retrieves information about the storage configuration for IoT SiteWise.

"""
function describe_storage_configuration(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotsitewise(
        "GET",
        "/configuration/account/storage";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_storage_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotsitewise(
        "GET",
        "/configuration/account/storage",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_time_series()
    describe_time_series(params::Dict{String,<:Any})

Retrieves information about a time series (data stream). To identify a time series, do one
of the following:   If the time series isn't associated with an asset property, specify the
alias of the time series.   If the time series is associated with an asset property,
specify one of the following:    The alias of the time series.   The assetId and propertyId
that identifies the asset property.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"alias"`: The alias that identifies the time series.
- `"assetId"`: The ID of the asset in which the asset property was created. This can be
  either the actual ID in UUID format, or else externalId: followed by the external ID, if it
  has one. For more information, see Referencing objects with external IDs in the IoT
  SiteWise User Guide.
- `"propertyId"`: The ID of the asset property. This can be either the actual ID in UUID
  format, or else externalId: followed by the external ID, if it has one. For more
  information, see Referencing objects with external IDs in the IoT SiteWise User Guide.
"""
function describe_time_series(; aws_config::AbstractAWSConfig=current_aws_config())
    return iotsitewise(
        "GET",
        "/timeseries/describe/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_time_series(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotsitewise(
        "GET",
        "/timeseries/describe/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_assets(asset_id, child_asset_id, hierarchy_id)
    disassociate_assets(asset_id, child_asset_id, hierarchy_id, params::Dict{String,<:Any})

Disassociates a child asset from the given parent asset through a hierarchy defined in the
parent asset's model.

# Arguments
- `asset_id`: The ID of the parent asset from which to disassociate the child asset. This
  can be either the actual ID in UUID format, or else externalId: followed by the external
  ID, if it has one. For more information, see Referencing objects with external IDs in the
  IoT SiteWise User Guide.
- `child_asset_id`: The ID of the child asset to disassociate. This can be either the
  actual ID in UUID format, or else externalId: followed by the external ID, if it has one.
  For more information, see Referencing objects with external IDs in the IoT SiteWise User
  Guide.
- `hierarchy_id`: The ID of a hierarchy in the parent asset's model. (This can be either
  the actual ID in UUID format, or else externalId: followed by the external ID, if it has
  one. For more information, see Referencing objects with external IDs in the IoT SiteWise
  User Guide.) Hierarchies allow different groupings of assets to be formed that all come
  from the same asset model. You can use the hierarchy ID to identify the correct asset to
  disassociate. For more information, see Asset hierarchies in the IoT SiteWise User Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique case-sensitive identifier that you can provide to ensure the
  idempotency of the request. Don't reuse this client token if a new idempotent request is
  required.
"""
function disassociate_assets(
    assetId, childAssetId, hierarchyId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotsitewise(
        "POST",
        "/assets/$(assetId)/disassociate",
        Dict{String,Any}(
            "childAssetId" => childAssetId,
            "hierarchyId" => hierarchyId,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_assets(
    assetId,
    childAssetId,
    hierarchyId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "POST",
        "/assets/$(assetId)/disassociate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "childAssetId" => childAssetId,
                    "hierarchyId" => hierarchyId,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_time_series_from_asset_property(alias, asset_id, property_id)
    disassociate_time_series_from_asset_property(alias, asset_id, property_id, params::Dict{String,<:Any})

Disassociates a time series (data stream) from an asset property.

# Arguments
- `alias`: The alias that identifies the time series.
- `asset_id`: The ID of the asset in which the asset property was created. This can be
  either the actual ID in UUID format, or else externalId: followed by the external ID, if it
  has one. For more information, see Referencing objects with external IDs in the IoT
  SiteWise User Guide.
- `property_id`: The ID of the asset property. This can be either the actual ID in UUID
  format, or else externalId: followed by the external ID, if it has one. For more
  information, see Referencing objects with external IDs in the IoT SiteWise User Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique case-sensitive identifier that you can provide to ensure the
  idempotency of the request. Don't reuse this client token if a new idempotent request is
  required.
"""
function disassociate_time_series_from_asset_property(
    alias, assetId, propertyId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotsitewise(
        "POST",
        "/timeseries/disassociate/",
        Dict{String,Any}(
            "alias" => alias,
            "assetId" => assetId,
            "propertyId" => propertyId,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_time_series_from_asset_property(
    alias,
    assetId,
    propertyId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "POST",
        "/timeseries/disassociate/",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "alias" => alias,
                    "assetId" => assetId,
                    "propertyId" => propertyId,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    execute_action(action_definition_id, action_payload, target_resource)
    execute_action(action_definition_id, action_payload, target_resource, params::Dict{String,<:Any})

Executes an action on a target resource.

# Arguments
- `action_definition_id`: The ID of the action definition.
- `action_payload`: The JSON payload of the action.
- `target_resource`: The resource the action will be taken on.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique case-sensitive identifier that you can provide to ensure the
  idempotency of the request. Don't reuse this client token if a new idempotent request is
  required.
"""
function execute_action(
    actionDefinitionId,
    actionPayload,
    targetResource;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "POST",
        "/actions",
        Dict{String,Any}(
            "actionDefinitionId" => actionDefinitionId,
            "actionPayload" => actionPayload,
            "targetResource" => targetResource,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function execute_action(
    actionDefinitionId,
    actionPayload,
    targetResource,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "POST",
        "/actions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "actionDefinitionId" => actionDefinitionId,
                    "actionPayload" => actionPayload,
                    "targetResource" => targetResource,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    execute_query(query_statement)
    execute_query(query_statement, params::Dict{String,<:Any})

Run SQL queries to retrieve metadata and time-series data from asset models, assets,
measurements, metrics, transforms, and aggregates.

# Arguments
- `query_statement`: The IoT SiteWise query statement.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return at one time. The default is 25.
- `"nextToken"`: The string that specifies the next page of results.
"""
function execute_query(queryStatement; aws_config::AbstractAWSConfig=current_aws_config())
    return iotsitewise(
        "POST",
        "/queries/execution",
        Dict{String,Any}("queryStatement" => queryStatement);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function execute_query(
    queryStatement,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "POST",
        "/queries/execution",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("queryStatement" => queryStatement), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_asset_property_aggregates(aggregate_types, end_date, resolution, start_date)
    get_asset_property_aggregates(aggregate_types, end_date, resolution, start_date, params::Dict{String,<:Any})

Gets aggregated values for an asset property. For more information, see Querying aggregates
in the IoT SiteWise User Guide. To identify an asset property, you must specify one of the
following:   The assetId and propertyId of an asset property.   A propertyAlias, which is a
data stream alias (for example, /company/windfarm/3/turbine/7/temperature). To define an
asset property's alias, see UpdateAssetProperty.

# Arguments
- `aggregate_types`: The data aggregating function.
- `end_date`: The inclusive end of the range from which to query historical data, expressed
  in seconds in Unix epoch time.
- `resolution`: The time interval over which to aggregate data.
- `start_date`: The exclusive start of the range from which to query historical data,
  expressed in seconds in Unix epoch time.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"assetId"`: The ID of the asset, in UUID format.
- `"maxResults"`: The maximum number of results to return for each paginated request. A
  result set is returned in the two cases, whichever occurs first.   The size of the result
  set is equal to 1 MB.   The number of data points in the result set is equal to the value
  of maxResults. The maximum value of maxResults is 2500.
- `"nextToken"`: The token to be used for the next set of paginated results.
- `"propertyAlias"`: The alias that identifies the property, such as an OPC-UA server data
  stream path (for example, /company/windfarm/3/turbine/7/temperature). For more information,
  see Mapping industrial data streams to asset properties in the IoT SiteWise User Guide.
- `"propertyId"`: The ID of the asset property, in UUID format.
- `"qualities"`: The quality by which to filter asset data.
- `"timeOrdering"`: The chronological sorting order of the requested information. Default:
  ASCENDING
"""
function get_asset_property_aggregates(
    aggregateTypes,
    endDate,
    resolution,
    startDate;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "GET",
        "/properties/aggregates",
        Dict{String,Any}(
            "aggregateTypes" => aggregateTypes,
            "endDate" => endDate,
            "resolution" => resolution,
            "startDate" => startDate,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_asset_property_aggregates(
    aggregateTypes,
    endDate,
    resolution,
    startDate,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "GET",
        "/properties/aggregates",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "aggregateTypes" => aggregateTypes,
                    "endDate" => endDate,
                    "resolution" => resolution,
                    "startDate" => startDate,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_asset_property_value()
    get_asset_property_value(params::Dict{String,<:Any})

Gets an asset property's current value. For more information, see Querying current values
in the IoT SiteWise User Guide. To identify an asset property, you must specify one of the
following:   The assetId and propertyId of an asset property.   A propertyAlias, which is a
data stream alias (for example, /company/windfarm/3/turbine/7/temperature). To define an
asset property's alias, see UpdateAssetProperty.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"assetId"`: The ID of the asset, in UUID format.
- `"propertyAlias"`: The alias that identifies the property, such as an OPC-UA server data
  stream path (for example, /company/windfarm/3/turbine/7/temperature). For more information,
  see Mapping industrial data streams to asset properties in the IoT SiteWise User Guide.
- `"propertyId"`: The ID of the asset property, in UUID format.
"""
function get_asset_property_value(; aws_config::AbstractAWSConfig=current_aws_config())
    return iotsitewise(
        "GET", "/properties/latest"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_asset_property_value(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotsitewise(
        "GET",
        "/properties/latest",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_asset_property_value_history()
    get_asset_property_value_history(params::Dict{String,<:Any})

Gets the history of an asset property's values. For more information, see Querying
historical values in the IoT SiteWise User Guide. To identify an asset property, you must
specify one of the following:   The assetId and propertyId of an asset property.   A
propertyAlias, which is a data stream alias (for example,
/company/windfarm/3/turbine/7/temperature). To define an asset property's alias, see
UpdateAssetProperty.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"assetId"`: The ID of the asset, in UUID format.
- `"endDate"`: The inclusive end of the range from which to query historical data,
  expressed in seconds in Unix epoch time.
- `"maxResults"`: The maximum number of results to return for each paginated request. A
  result set is returned in the two cases, whichever occurs first.   The size of the result
  set is equal to 4 MB.   The number of data points in the result set is equal to the value
  of maxResults. The maximum value of maxResults is 20000.
- `"nextToken"`: The token to be used for the next set of paginated results.
- `"propertyAlias"`: The alias that identifies the property, such as an OPC-UA server data
  stream path (for example, /company/windfarm/3/turbine/7/temperature). For more information,
  see Mapping industrial data streams to asset properties in the IoT SiteWise User Guide.
- `"propertyId"`: The ID of the asset property, in UUID format.
- `"qualities"`: The quality by which to filter asset data.
- `"startDate"`: The exclusive start of the range from which to query historical data,
  expressed in seconds in Unix epoch time.
- `"timeOrdering"`: The chronological sorting order of the requested information. Default:
  ASCENDING
"""
function get_asset_property_value_history(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotsitewise(
        "GET", "/properties/history"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_asset_property_value_history(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotsitewise(
        "GET",
        "/properties/history",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_interpolated_asset_property_values(end_time_in_seconds, interval_in_seconds, quality, start_time_in_seconds, type)
    get_interpolated_asset_property_values(end_time_in_seconds, interval_in_seconds, quality, start_time_in_seconds, type, params::Dict{String,<:Any})

Get interpolated values for an asset property for a specified time interval, during a
period of time. If your time series is missing data points during the specified time
interval, you can use interpolation to estimate the missing data. For example, you can use
this operation to return the interpolated temperature values for a wind turbine every 24
hours over a duration of 7 days. To identify an asset property, you must specify one of the
following:   The assetId and propertyId of an asset property.   A propertyAlias, which is a
data stream alias (for example, /company/windfarm/3/turbine/7/temperature). To define an
asset property's alias, see UpdateAssetProperty.

# Arguments
- `end_time_in_seconds`: The inclusive end of the range from which to interpolate data,
  expressed in seconds in Unix epoch time.
- `interval_in_seconds`: The time interval in seconds over which to interpolate data. Each
  interval starts when the previous one ends.
- `quality`: The quality of the asset property value. You can use this parameter as a
  filter to choose only the asset property values that have a specific quality.
- `start_time_in_seconds`: The exclusive start of the range from which to interpolate data,
  expressed in seconds in Unix epoch time.
- `type`: The interpolation type. Valid values: LINEAR_INTERPOLATION | LOCF_INTERPOLATION
    LINEAR_INTERPOLATION – Estimates missing data using linear interpolation. For example,
  you can use this operation to return the interpolated temperature values for a wind turbine
  every 24 hours over a duration of 7 days. If the interpolation starts July 1, 2021, at 9
  AM, IoT SiteWise returns the first interpolated value on July 2, 2021, at 9 AM, the second
  interpolated value on July 3, 2021, at 9 AM, and so on.    LOCF_INTERPOLATION – Estimates
  missing data using last observation carried forward interpolation If no data point is found
  for an interval, IoT SiteWise returns the last observed data point for the previous
  interval and carries forward this interpolated value until a new data point is found. For
  example, you can get the state of an on-off valve every 24 hours over a duration of 7 days.
  If the interpolation starts July 1, 2021, at 9 AM, IoT SiteWise returns the last observed
  data point between July 1, 2021, at 9 AM and July 2, 2021, at 9 AM as the first
  interpolated value. If a data point isn't found after 9 AM on July 2, 2021, IoT SiteWise
  uses the same interpolated value for the rest of the days.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"assetId"`: The ID of the asset, in UUID format.
- `"endTimeOffsetInNanos"`: The nanosecond offset converted from endTimeInSeconds.
- `"intervalWindowInSeconds"`: The query interval for the window, in seconds. IoT SiteWise
  computes each interpolated value by using data points from the timestamp of each interval,
  minus the window to the timestamp of each interval plus the window. If not specified, the
  window ranges between the start time minus the interval and the end time plus the interval.
     If you specify a value for the intervalWindowInSeconds parameter, the value for the type
  parameter must be LINEAR_INTERPOLATION.   If a data point isn't found during the specified
  query window, IoT SiteWise won't return an interpolated value for the interval. This
  indicates that there's a gap in the ingested data points.    For example, you can get the
  interpolated temperature values for a wind turbine every 24 hours over a duration of 7
  days. If the interpolation starts on July 1, 2021, at 9 AM with a window of 2 hours, IoT
  SiteWise uses the data points from 7 AM (9 AM minus 2 hours) to 11 AM (9 AM plus 2 hours)
  on July 2, 2021 to compute the first interpolated value. Next, IoT SiteWise uses the data
  points from 7 AM (9 AM minus 2 hours) to 11 AM (9 AM plus 2 hours) on July 3, 2021 to
  compute the second interpolated value, and so on.
- `"maxResults"`: The maximum number of results to return for each paginated request. If
  not specified, the default value is 10.
- `"nextToken"`: The token to be used for the next set of paginated results.
- `"propertyAlias"`: The alias that identifies the property, such as an OPC-UA server data
  stream path (for example, /company/windfarm/3/turbine/7/temperature). For more information,
  see Mapping industrial data streams to asset properties in the IoT SiteWise User Guide.
- `"propertyId"`: The ID of the asset property, in UUID format.
- `"startTimeOffsetInNanos"`: The nanosecond offset converted from startTimeInSeconds.
"""
function get_interpolated_asset_property_values(
    endTimeInSeconds,
    intervalInSeconds,
    quality,
    startTimeInSeconds,
    type;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "GET",
        "/properties/interpolated",
        Dict{String,Any}(
            "endTimeInSeconds" => endTimeInSeconds,
            "intervalInSeconds" => intervalInSeconds,
            "quality" => quality,
            "startTimeInSeconds" => startTimeInSeconds,
            "type" => type,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_interpolated_asset_property_values(
    endTimeInSeconds,
    intervalInSeconds,
    quality,
    startTimeInSeconds,
    type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "GET",
        "/properties/interpolated",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "endTimeInSeconds" => endTimeInSeconds,
                    "intervalInSeconds" => intervalInSeconds,
                    "quality" => quality,
                    "startTimeInSeconds" => startTimeInSeconds,
                    "type" => type,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_access_policies()
    list_access_policies(params::Dict{String,<:Any})

Retrieves a paginated list of access policies for an identity (an IAM Identity Center user,
an IAM Identity Center group, or an IAM user) or an IoT SiteWise Monitor resource (a portal
or project).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"iamArn"`: The ARN of the IAM user. For more information, see IAM ARNs in the IAM User
  Guide. This parameter is required if you specify IAM for identityType.
- `"identityId"`: The ID of the identity. This parameter is required if you specify USER or
  GROUP for identityType.
- `"identityType"`: The type of identity (IAM Identity Center user, IAM Identity Center
  group, or IAM user). This parameter is required if you specify identityId.
- `"maxResults"`: The maximum number of results to return for each paginated request.
  Default: 50
- `"nextToken"`: The token to be used for the next set of paginated results.
- `"resourceId"`: The ID of the resource. This parameter is required if you specify
  resourceType.
- `"resourceType"`: The type of resource (portal or project). This parameter is required if
  you specify resourceId.
"""
function list_access_policies(; aws_config::AbstractAWSConfig=current_aws_config())
    return iotsitewise(
        "GET", "/access-policies"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_access_policies(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotsitewise(
        "GET",
        "/access-policies",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_actions(target_resource_id, target_resource_type)
    list_actions(target_resource_id, target_resource_type, params::Dict{String,<:Any})

Retrieves a paginated list of actions for a specific target resource.

# Arguments
- `target_resource_id`: The ID of the target resource.
- `target_resource_type`: The type of resource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return for each paginated request.
- `"nextToken"`: The token to be used for the next set of paginated results.
"""
function list_actions(
    targetResourceId, targetResourceType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotsitewise(
        "GET",
        "/actions",
        Dict{String,Any}(
            "targetResourceId" => targetResourceId,
            "targetResourceType" => targetResourceType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_actions(
    targetResourceId,
    targetResourceType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "GET",
        "/actions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "targetResourceId" => targetResourceId,
                    "targetResourceType" => targetResourceType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_asset_model_composite_models(asset_model_id)
    list_asset_model_composite_models(asset_model_id, params::Dict{String,<:Any})

Retrieves a paginated list of composite models associated with the asset model

# Arguments
- `asset_model_id`: The ID of the asset model. This can be either the actual ID in UUID
  format, or else externalId: followed by the external ID, if it has one. For more
  information, see Referencing objects with external IDs in the IoT SiteWise User Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return for each paginated request.
  Default: 50
- `"nextToken"`: The token to be used for the next set of paginated results.
"""
function list_asset_model_composite_models(
    assetModelId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotsitewise(
        "GET",
        "/asset-models/$(assetModelId)/composite-models";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_asset_model_composite_models(
    assetModelId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "GET",
        "/asset-models/$(assetModelId)/composite-models",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_asset_model_properties(asset_model_id)
    list_asset_model_properties(asset_model_id, params::Dict{String,<:Any})

Retrieves a paginated list of properties associated with an asset model. If you update
properties associated with the model before you finish listing all the properties, you need
to start all over again.

# Arguments
- `asset_model_id`: The ID of the asset model. This can be either the actual ID in UUID
  format, or else externalId: followed by the external ID, if it has one. For more
  information, see Referencing objects with external IDs in the IoT SiteWise User Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filter"`:  Filters the requested list of asset model properties. You can choose one of
  the following options:    ALL – The list includes all asset model properties for a given
  asset model ID.     BASE – The list includes only base asset model properties for a given
  asset model ID.    Default: BASE
- `"maxResults"`: The maximum number of results to return for each paginated request. If
  not specified, the default value is 50.
- `"nextToken"`: The token to be used for the next set of paginated results.
"""
function list_asset_model_properties(
    assetModelId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotsitewise(
        "GET",
        "/asset-models/$(assetModelId)/properties";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_asset_model_properties(
    assetModelId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "GET",
        "/asset-models/$(assetModelId)/properties",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_asset_models()
    list_asset_models(params::Dict{String,<:Any})

Retrieves a paginated list of summaries of all asset models.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"assetModelTypes"`: The type of asset model.    ASSET_MODEL – (default) An asset model
  that you can use to create assets. Can't be included as a component in another asset model.
     COMPONENT_MODEL – A reusable component that you can include in the composite models of
  other asset models. You can't create assets directly from this type of asset model.
- `"maxResults"`: The maximum number of results to return for each paginated request.
  Default: 50
- `"nextToken"`: The token to be used for the next set of paginated results.
"""
function list_asset_models(; aws_config::AbstractAWSConfig=current_aws_config())
    return iotsitewise(
        "GET", "/asset-models"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_asset_models(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotsitewise(
        "GET",
        "/asset-models",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_asset_properties(asset_id)
    list_asset_properties(asset_id, params::Dict{String,<:Any})

Retrieves a paginated list of properties associated with an asset. If you update properties
associated with the model before you finish listing all the properties, you need to start
all over again.

# Arguments
- `asset_id`: The ID of the asset. This can be either the actual ID in UUID format, or else
  externalId: followed by the external ID, if it has one. For more information, see
  Referencing objects with external IDs in the IoT SiteWise User Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filter"`:  Filters the requested list of asset properties. You can choose one of the
  following options:    ALL – The list includes all asset properties for a given asset
  model ID.     BASE – The list includes only base asset properties for a given asset model
  ID.    Default: BASE
- `"maxResults"`: The maximum number of results to return for each paginated request. If
  not specified, the default value is 50.
- `"nextToken"`: The token to be used for the next set of paginated results.
"""
function list_asset_properties(assetId; aws_config::AbstractAWSConfig=current_aws_config())
    return iotsitewise(
        "GET",
        "/assets/$(assetId)/properties";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_asset_properties(
    assetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "GET",
        "/assets/$(assetId)/properties",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_asset_relationships(asset_id, traversal_type)
    list_asset_relationships(asset_id, traversal_type, params::Dict{String,<:Any})

Retrieves a paginated list of asset relationships for an asset. You can use this operation
to identify an asset's root asset and all associated assets between that asset and its root.

# Arguments
- `asset_id`: The ID of the asset. This can be either the actual ID in UUID format, or else
  externalId: followed by the external ID, if it has one. For more information, see
  Referencing objects with external IDs in the IoT SiteWise User Guide.
- `traversal_type`: The type of traversal to use to identify asset relationships. Choose
  the following option:    PATH_TO_ROOT – Identify the asset's parent assets up to the root
  asset. The asset that you specify in assetId is the first result in the list of
  assetRelationshipSummaries, and the root asset is the last result.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return for each paginated request.
- `"nextToken"`: The token to be used for the next set of paginated results.
"""
function list_asset_relationships(
    assetId, traversalType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotsitewise(
        "GET",
        "/assets/$(assetId)/assetRelationships",
        Dict{String,Any}("traversalType" => traversalType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_asset_relationships(
    assetId,
    traversalType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "GET",
        "/assets/$(assetId)/assetRelationships",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("traversalType" => traversalType), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_assets()
    list_assets(params::Dict{String,<:Any})

Retrieves a paginated list of asset summaries. You can use this operation to do the
following:   List assets based on a specific asset model.   List top-level assets.   You
can't use this operation to list all assets. To retrieve summaries for all of your assets,
use ListAssetModels to get all of your asset model IDs. Then, use ListAssets to get all
assets for each asset model.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"assetModelId"`: The ID of the asset model by which to filter the list of assets. This
  parameter is required if you choose ALL for filter. This can be either the actual ID in
  UUID format, or else externalId: followed by the external ID, if it has one. For more
  information, see Referencing objects with external IDs in the IoT SiteWise User Guide.
- `"filter"`: The filter for the requested list of assets. Choose one of the following
  options:    ALL – The list includes all assets for a given asset model ID. The
  assetModelId parameter is required if you filter by ALL.    TOP_LEVEL – The list includes
  only top-level assets in the asset hierarchy tree.   Default: ALL
- `"maxResults"`: The maximum number of results to return for each paginated request.
  Default: 50
- `"nextToken"`: The token to be used for the next set of paginated results.
"""
function list_assets(; aws_config::AbstractAWSConfig=current_aws_config())
    return iotsitewise(
        "GET", "/assets"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_assets(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotsitewise(
        "GET", "/assets", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_associated_assets(asset_id)
    list_associated_assets(asset_id, params::Dict{String,<:Any})

Retrieves a paginated list of associated assets. You can use this operation to do the
following:   List child assets associated to a parent asset by a hierarchy that you
specify.   List an asset's parent asset.

# Arguments
- `asset_id`: The ID of the asset to query. This can be either the actual ID in UUID
  format, or else externalId: followed by the external ID, if it has one. For more
  information, see Referencing objects with external IDs in the IoT SiteWise User Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"hierarchyId"`: The ID of the hierarchy by which child assets are associated to the
  asset. (This can be either the actual ID in UUID format, or else externalId: followed by
  the external ID, if it has one. For more information, see Referencing objects with external
  IDs in the IoT SiteWise User Guide.) To find a hierarchy ID, use the DescribeAsset or
  DescribeAssetModel operations. This parameter is required if you choose CHILD for
  traversalDirection. For more information, see Asset hierarchies in the IoT SiteWise User
  Guide.
- `"maxResults"`: The maximum number of results to return for each paginated request.
  Default: 50
- `"nextToken"`: The token to be used for the next set of paginated results.
- `"traversalDirection"`: The direction to list associated assets. Choose one of the
  following options:    CHILD – The list includes all child assets associated to the asset.
  The hierarchyId parameter is required if you choose CHILD.    PARENT – The list includes
  the asset's parent asset.   Default: CHILD
"""
function list_associated_assets(assetId; aws_config::AbstractAWSConfig=current_aws_config())
    return iotsitewise(
        "GET",
        "/assets/$(assetId)/hierarchies";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_associated_assets(
    assetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "GET",
        "/assets/$(assetId)/hierarchies",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_bulk_import_jobs()
    list_bulk_import_jobs(params::Dict{String,<:Any})

Retrieves a paginated list of bulk import job requests. For more information, see List bulk
import jobs (CLI) in the IoT SiteWise User Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filter"`: You can use a filter to select the bulk import jobs that you want to retrieve.
- `"maxResults"`: The maximum number of results to return for each paginated request.
- `"nextToken"`: The token to be used for the next set of paginated results.
"""
function list_bulk_import_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return iotsitewise(
        "GET", "/jobs"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_bulk_import_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotsitewise(
        "GET", "/jobs", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_composition_relationships(asset_model_id)
    list_composition_relationships(asset_model_id, params::Dict{String,<:Any})

Retrieves a paginated list of composition relationships for an asset model of type
COMPONENT_MODEL.

# Arguments
- `asset_model_id`: The ID of the asset model. This can be either the actual ID in UUID
  format, or else externalId: followed by the external ID, if it has one. For more
  information, see Referencing objects with external IDs in the IoT SiteWise User Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return for each paginated request.
  Default: 50
- `"nextToken"`: The token to be used for the next set of paginated results.
"""
function list_composition_relationships(
    assetModelId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotsitewise(
        "GET",
        "/asset-models/$(assetModelId)/composition-relationships";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_composition_relationships(
    assetModelId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "GET",
        "/asset-models/$(assetModelId)/composition-relationships",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_dashboards(project_id)
    list_dashboards(project_id, params::Dict{String,<:Any})

Retrieves a paginated list of dashboards for an IoT SiteWise Monitor project.

# Arguments
- `project_id`: The ID of the project.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return for each paginated request.
  Default: 50
- `"nextToken"`: The token to be used for the next set of paginated results.
"""
function list_dashboards(projectId; aws_config::AbstractAWSConfig=current_aws_config())
    return iotsitewise(
        "GET",
        "/dashboards",
        Dict{String,Any}("projectId" => projectId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_dashboards(
    projectId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "GET",
        "/dashboards",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("projectId" => projectId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_gateways()
    list_gateways(params::Dict{String,<:Any})

Retrieves a paginated list of gateways.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return for each paginated request.
  Default: 50
- `"nextToken"`: The token to be used for the next set of paginated results.
"""
function list_gateways(; aws_config::AbstractAWSConfig=current_aws_config())
    return iotsitewise(
        "GET", "/20200301/gateways"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_gateways(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotsitewise(
        "GET",
        "/20200301/gateways",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_portals()
    list_portals(params::Dict{String,<:Any})

Retrieves a paginated list of IoT SiteWise Monitor portals.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return for each paginated request.
  Default: 50
- `"nextToken"`: The token to be used for the next set of paginated results.
"""
function list_portals(; aws_config::AbstractAWSConfig=current_aws_config())
    return iotsitewise(
        "GET", "/portals"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_portals(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotsitewise(
        "GET", "/portals", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_project_assets(project_id)
    list_project_assets(project_id, params::Dict{String,<:Any})

Retrieves a paginated list of assets associated with an IoT SiteWise Monitor project.

# Arguments
- `project_id`: The ID of the project.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return for each paginated request.
  Default: 50
- `"nextToken"`: The token to be used for the next set of paginated results.
"""
function list_project_assets(projectId; aws_config::AbstractAWSConfig=current_aws_config())
    return iotsitewise(
        "GET",
        "/projects/$(projectId)/assets";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_project_assets(
    projectId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "GET",
        "/projects/$(projectId)/assets",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_projects(portal_id)
    list_projects(portal_id, params::Dict{String,<:Any})

Retrieves a paginated list of projects for an IoT SiteWise Monitor portal.

# Arguments
- `portal_id`: The ID of the portal.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return for each paginated request.
  Default: 50
- `"nextToken"`: The token to be used for the next set of paginated results.
"""
function list_projects(portalId; aws_config::AbstractAWSConfig=current_aws_config())
    return iotsitewise(
        "GET",
        "/projects",
        Dict{String,Any}("portalId" => portalId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_projects(
    portalId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "GET",
        "/projects",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("portalId" => portalId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Retrieves the list of tags for an IoT SiteWise resource.

# Arguments
- `resource_arn`: The ARN of the resource.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotsitewise(
        "GET",
        "/tags",
        Dict{String,Any}("resourceArn" => resourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "GET",
        "/tags",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceArn" => resourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_time_series()
    list_time_series(params::Dict{String,<:Any})

Retrieves a paginated list of time series (data streams).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"aliasPrefix"`: The alias prefix of the time series.
- `"assetId"`: The ID of the asset in which the asset property was created. This can be
  either the actual ID in UUID format, or else externalId: followed by the external ID, if it
  has one. For more information, see Referencing objects with external IDs in the IoT
  SiteWise User Guide.
- `"maxResults"`: The maximum number of results to return for each paginated request.
- `"nextToken"`: The token to be used for the next set of paginated results.
- `"timeSeriesType"`: The type of the time series. The time series type can be one of the
  following values:    ASSOCIATED – The time series is associated with an asset property.
   DISASSOCIATED – The time series isn't associated with any asset property.
"""
function list_time_series(; aws_config::AbstractAWSConfig=current_aws_config())
    return iotsitewise(
        "GET", "/timeseries/"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_time_series(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotsitewise(
        "GET",
        "/timeseries/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_default_encryption_configuration(encryption_type)
    put_default_encryption_configuration(encryption_type, params::Dict{String,<:Any})

Sets the default encryption configuration for the Amazon Web Services account. For more
information, see Key management in the IoT SiteWise User Guide.

# Arguments
- `encryption_type`: The type of encryption used for the encryption configuration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"kmsKeyId"`: The Key ID of the customer managed key used for KMS encryption. This is
  required if you use KMS_BASED_ENCRYPTION.
"""
function put_default_encryption_configuration(
    encryptionType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotsitewise(
        "POST",
        "/configuration/account/encryption",
        Dict{String,Any}("encryptionType" => encryptionType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_default_encryption_configuration(
    encryptionType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "POST",
        "/configuration/account/encryption",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("encryptionType" => encryptionType), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_logging_options(logging_options)
    put_logging_options(logging_options, params::Dict{String,<:Any})

Sets logging options for IoT SiteWise.

# Arguments
- `logging_options`: The logging options to set.

"""
function put_logging_options(
    loggingOptions; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotsitewise(
        "PUT",
        "/logging",
        Dict{String,Any}("loggingOptions" => loggingOptions);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_logging_options(
    loggingOptions,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "PUT",
        "/logging",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("loggingOptions" => loggingOptions), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_storage_configuration(storage_type)
    put_storage_configuration(storage_type, params::Dict{String,<:Any})

Configures storage settings for IoT SiteWise.

# Arguments
- `storage_type`: The storage tier that you specified for your data. The storageType
  parameter can be one of the following values:    SITEWISE_DEFAULT_STORAGE – IoT SiteWise
  saves your data into the hot tier. The hot tier is a service-managed database.
  MULTI_LAYER_STORAGE – IoT SiteWise saves your data in both the cold tier and the hot
  tier. The cold tier is a customer-managed Amazon S3 bucket.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"disassociatedDataStorage"`: Contains the storage configuration for time series (data
  streams) that aren't associated with asset properties. The disassociatedDataStorage can be
  one of the following values:    ENABLED – IoT SiteWise accepts time series that aren't
  associated with asset properties.  After the disassociatedDataStorage is enabled, you can't
  disable it.     DISABLED – IoT SiteWise doesn't accept time series (data streams) that
  aren't associated with asset properties.   For more information, see Data streams in the
  IoT SiteWise User Guide.
- `"multiLayerStorage"`: Identifies a storage destination. If you specified
  MULTI_LAYER_STORAGE for the storage type, you must specify a MultiLayerStorage object.
- `"retentionPeriod"`:
- `"warmTier"`: A service managed storage tier optimized for analytical queries. It stores
  periodically uploaded, buffered and historical data ingested with the CreaeBulkImportJob
  API.
- `"warmTierRetentionPeriod"`: Set this period to specify how long your data is stored in
  the warm tier before it is deleted. You can set this only if cold tier is enabled.
"""
function put_storage_configuration(
    storageType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotsitewise(
        "POST",
        "/configuration/account/storage",
        Dict{String,Any}("storageType" => storageType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_storage_configuration(
    storageType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "POST",
        "/configuration/account/storage",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("storageType" => storageType), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds tags to an IoT SiteWise resource. If a tag already exists for the resource, this
operation updates the tag's value.

# Arguments
- `resource_arn`: The ARN of the resource to tag.
- `tags`: A list of key-value pairs that contain metadata for the resource. For more
  information, see Tagging your IoT SiteWise resources in the IoT SiteWise User Guide.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return iotsitewise(
        "POST",
        "/tags",
        Dict{String,Any}("resourceArn" => resourceArn, "tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "POST",
        "/tags",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceArn" => resourceArn, "tags" => tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes a tag from an IoT SiteWise resource.

# Arguments
- `resource_arn`: The ARN of the resource to untag.
- `tag_keys`: A list of keys for tags to remove from the resource.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotsitewise(
        "DELETE",
        "/tags",
        Dict{String,Any}("resourceArn" => resourceArn, "tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "DELETE",
        "/tags",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceArn" => resourceArn, "tagKeys" => tagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_access_policy(access_policy_id, access_policy_identity, access_policy_permission, access_policy_resource)
    update_access_policy(access_policy_id, access_policy_identity, access_policy_permission, access_policy_resource, params::Dict{String,<:Any})

Updates an existing access policy that specifies an identity's access to an IoT SiteWise
Monitor portal or project resource.

# Arguments
- `access_policy_id`: The ID of the access policy.
- `access_policy_identity`: The identity for this access policy. Choose an IAM Identity
  Center user, an IAM Identity Center group, or an IAM user.
- `access_policy_permission`: The permission level for this access policy. Note that a
  project ADMINISTRATOR is also known as a project owner.
- `access_policy_resource`: The IoT SiteWise Monitor resource for this access policy.
  Choose either a portal or a project.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique case-sensitive identifier that you can provide to ensure the
  idempotency of the request. Don't reuse this client token if a new idempotent request is
  required.
"""
function update_access_policy(
    accessPolicyId,
    accessPolicyIdentity,
    accessPolicyPermission,
    accessPolicyResource;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "PUT",
        "/access-policies/$(accessPolicyId)",
        Dict{String,Any}(
            "accessPolicyIdentity" => accessPolicyIdentity,
            "accessPolicyPermission" => accessPolicyPermission,
            "accessPolicyResource" => accessPolicyResource,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_access_policy(
    accessPolicyId,
    accessPolicyIdentity,
    accessPolicyPermission,
    accessPolicyResource,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "PUT",
        "/access-policies/$(accessPolicyId)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "accessPolicyIdentity" => accessPolicyIdentity,
                    "accessPolicyPermission" => accessPolicyPermission,
                    "accessPolicyResource" => accessPolicyResource,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_asset(asset_id, asset_name)
    update_asset(asset_id, asset_name, params::Dict{String,<:Any})

Updates an asset's name. For more information, see Updating assets and models in the IoT
SiteWise User Guide.

# Arguments
- `asset_id`: The ID of the asset to update. This can be either the actual ID in UUID
  format, or else externalId: followed by the external ID, if it has one. For more
  information, see Referencing objects with external IDs in the IoT SiteWise User Guide.
- `asset_name`: A friendly name for the asset.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"assetDescription"`: A description for the asset.
- `"assetExternalId"`: An external ID to assign to the asset. The asset must not already
  have an external ID. The external ID must be unique within your Amazon Web Services
  account. For more information, see Using external IDs in the IoT SiteWise User Guide.
- `"clientToken"`: A unique case-sensitive identifier that you can provide to ensure the
  idempotency of the request. Don't reuse this client token if a new idempotent request is
  required.
"""
function update_asset(
    assetId, assetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotsitewise(
        "PUT",
        "/assets/$(assetId)",
        Dict{String,Any}("assetName" => assetName, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_asset(
    assetId,
    assetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "PUT",
        "/assets/$(assetId)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "assetName" => assetName, "clientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_asset_model(asset_model_id, asset_model_name)
    update_asset_model(asset_model_id, asset_model_name, params::Dict{String,<:Any})

Updates an asset model and all of the assets that were created from the model. Each asset
created from the model inherits the updated asset model's property and hierarchy
definitions. For more information, see Updating assets and models in the IoT SiteWise User
Guide.  This operation overwrites the existing model with the provided model. To avoid
deleting your asset model's properties or hierarchies, you must include their IDs and
definitions in the updated asset model payload. For more information, see
DescribeAssetModel. If you remove a property from an asset model, IoT SiteWise deletes all
previous data for that property. If you remove a hierarchy definition from an asset model,
IoT SiteWise disassociates every asset associated with that hierarchy. You can't change the
type or data type of an existing property.

# Arguments
- `asset_model_id`: The ID of the asset model to update. This can be either the actual ID
  in UUID format, or else externalId: followed by the external ID, if it has one. For more
  information, see Referencing objects with external IDs in the IoT SiteWise User Guide.
- `asset_model_name`: A unique, friendly name for the asset model.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"assetModelCompositeModels"`: The composite models that are part of this asset model. It
  groups properties (such as attributes, measurements, transforms, and metrics) and child
  composite models that model parts of your industrial equipment. Each composite model has a
  type that defines the properties that the composite model supports. Use composite models to
  define alarms on this asset model.  When creating custom composite models, you need to use
  CreateAssetModelCompositeModel. For more information, see &lt;LINK&gt;.
- `"assetModelDescription"`: A description for the asset model.
- `"assetModelExternalId"`: An external ID to assign to the asset model. The asset model
  must not already have an external ID. The external ID must be unique within your Amazon Web
  Services account. For more information, see Using external IDs in the IoT SiteWise User
  Guide.
- `"assetModelHierarchies"`: The updated hierarchy definitions of the asset model. Each
  hierarchy specifies an asset model whose assets can be children of any other assets created
  from this asset model. For more information, see Asset hierarchies in the IoT SiteWise User
  Guide. You can specify up to 10 hierarchies per asset model. For more information, see
  Quotas in the IoT SiteWise User Guide.
- `"assetModelProperties"`: The updated property definitions of the asset model. For more
  information, see Asset properties in the IoT SiteWise User Guide. You can specify up to 200
  properties per asset model. For more information, see Quotas in the IoT SiteWise User Guide.
- `"clientToken"`: A unique case-sensitive identifier that you can provide to ensure the
  idempotency of the request. Don't reuse this client token if a new idempotent request is
  required.
"""
function update_asset_model(
    assetModelId, assetModelName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotsitewise(
        "PUT",
        "/asset-models/$(assetModelId)",
        Dict{String,Any}(
            "assetModelName" => assetModelName, "clientToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_asset_model(
    assetModelId,
    assetModelName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "PUT",
        "/asset-models/$(assetModelId)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "assetModelName" => assetModelName, "clientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_asset_model_composite_model(asset_model_composite_model_id, asset_model_composite_model_name, asset_model_id)
    update_asset_model_composite_model(asset_model_composite_model_id, asset_model_composite_model_name, asset_model_id, params::Dict{String,<:Any})

Updates a composite model and all of the assets that were created from the model. Each
asset created from the model inherits the updated asset model's property and hierarchy
definitions. For more information, see Updating assets and models in the IoT SiteWise User
Guide.  If you remove a property from a composite asset model, IoT SiteWise deletes all
previous data for that property. You can’t change the type or data type of an existing
property. To replace an existing composite asset model property with a new one with the
same name, do the following:   Submit an UpdateAssetModelCompositeModel request with the
entire existing property removed.   Submit a second UpdateAssetModelCompositeModel request
that includes the new property. The new asset property will have the same name as the
previous one and IoT SiteWise will generate a new unique id.

# Arguments
- `asset_model_composite_model_id`: The ID of a composite model on this asset model.
- `asset_model_composite_model_name`: A unique, friendly name for the composite model.
- `asset_model_id`: The ID of the asset model, in UUID format.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"assetModelCompositeModelDescription"`: A description for the composite model.
- `"assetModelCompositeModelExternalId"`: An external ID to assign to the asset model. You
  can only set the external ID of the asset model if it wasn't set when it was created, or
  you're setting it to the exact same thing as when it was created.
- `"assetModelCompositeModelProperties"`: The property definitions of the composite model.
  For more information, see &lt;LINK&gt;. You can specify up to 200 properties per composite
  model. For more information, see Quotas in the IoT SiteWise User Guide.
- `"clientToken"`: A unique case-sensitive identifier that you can provide to ensure the
  idempotency of the request. Don't reuse this client token if a new idempotent request is
  required.
"""
function update_asset_model_composite_model(
    assetModelCompositeModelId,
    assetModelCompositeModelName,
    assetModelId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "PUT",
        "/asset-models/$(assetModelId)/composite-models/$(assetModelCompositeModelId)",
        Dict{String,Any}(
            "assetModelCompositeModelName" => assetModelCompositeModelName,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_asset_model_composite_model(
    assetModelCompositeModelId,
    assetModelCompositeModelName,
    assetModelId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "PUT",
        "/asset-models/$(assetModelId)/composite-models/$(assetModelCompositeModelId)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "assetModelCompositeModelName" => assetModelCompositeModelName,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_asset_property(asset_id, property_id)
    update_asset_property(asset_id, property_id, params::Dict{String,<:Any})

Updates an asset property's alias and notification state.  This operation overwrites the
property's existing alias and notification state. To keep your existing property's alias or
notification state, you must include the existing values in the UpdateAssetProperty
request. For more information, see DescribeAssetProperty.

# Arguments
- `asset_id`: The ID of the asset to be updated. This can be either the actual ID in UUID
  format, or else externalId: followed by the external ID, if it has one. For more
  information, see Referencing objects with external IDs in the IoT SiteWise User Guide.
- `property_id`: The ID of the asset property to be updated. This can be either the actual
  ID in UUID format, or else externalId: followed by the external ID, if it has one. For more
  information, see Referencing objects with external IDs in the IoT SiteWise User Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique case-sensitive identifier that you can provide to ensure the
  idempotency of the request. Don't reuse this client token if a new idempotent request is
  required.
- `"propertyAlias"`: The alias that identifies the property, such as an OPC-UA server data
  stream path (for example, /company/windfarm/3/turbine/7/temperature). For more information,
  see Mapping industrial data streams to asset properties in the IoT SiteWise User Guide. If
  you omit this parameter, the alias is removed from the property.
- `"propertyNotificationState"`: The MQTT notification state (enabled or disabled) for this
  asset property. When the notification state is enabled, IoT SiteWise publishes property
  value updates to a unique MQTT topic. For more information, see Interacting with other
  services in the IoT SiteWise User Guide. If you omit this parameter, the notification state
  is set to DISABLED.
- `"propertyUnit"`: The unit of measure (such as Newtons or RPM) of the asset property. If
  you don't specify a value for this parameter, the service uses the value of the
  assetModelProperty in the asset model.
"""
function update_asset_property(
    assetId, propertyId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotsitewise(
        "PUT",
        "/assets/$(assetId)/properties/$(propertyId)",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_asset_property(
    assetId,
    propertyId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "PUT",
        "/assets/$(assetId)/properties/$(propertyId)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_dashboard(dashboard_definition, dashboard_id, dashboard_name)
    update_dashboard(dashboard_definition, dashboard_id, dashboard_name, params::Dict{String,<:Any})

Updates an IoT SiteWise Monitor dashboard.

# Arguments
- `dashboard_definition`: The new dashboard definition, as specified in a JSON literal. For
  detailed information, see Creating dashboards (CLI) in the IoT SiteWise User Guide.
- `dashboard_id`: The ID of the dashboard to update.
- `dashboard_name`: A new friendly name for the dashboard.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique case-sensitive identifier that you can provide to ensure the
  idempotency of the request. Don't reuse this client token if a new idempotent request is
  required.
- `"dashboardDescription"`: A new description for the dashboard.
"""
function update_dashboard(
    dashboardDefinition,
    dashboardId,
    dashboardName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "PUT",
        "/dashboards/$(dashboardId)",
        Dict{String,Any}(
            "dashboardDefinition" => dashboardDefinition,
            "dashboardName" => dashboardName,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_dashboard(
    dashboardDefinition,
    dashboardId,
    dashboardName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "PUT",
        "/dashboards/$(dashboardId)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "dashboardDefinition" => dashboardDefinition,
                    "dashboardName" => dashboardName,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_gateway(gateway_id, gateway_name)
    update_gateway(gateway_id, gateway_name, params::Dict{String,<:Any})

Updates a gateway's name.

# Arguments
- `gateway_id`: The ID of the gateway to update.
- `gateway_name`: A unique, friendly name for the gateway.

"""
function update_gateway(
    gatewayId, gatewayName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotsitewise(
        "PUT",
        "/20200301/gateways/$(gatewayId)",
        Dict{String,Any}("gatewayName" => gatewayName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_gateway(
    gatewayId,
    gatewayName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "PUT",
        "/20200301/gateways/$(gatewayId)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("gatewayName" => gatewayName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_gateway_capability_configuration(capability_configuration, capability_namespace, gateway_id)
    update_gateway_capability_configuration(capability_configuration, capability_namespace, gateway_id, params::Dict{String,<:Any})

Updates a gateway capability configuration or defines a new capability configuration. Each
gateway capability defines data sources for a gateway. A capability configuration can
contain multiple data source configurations. If you define OPC-UA sources for a gateway in
the IoT SiteWise console, all of your OPC-UA sources are stored in one capability
configuration. To list all capability configurations for a gateway, use DescribeGateway.

# Arguments
- `capability_configuration`: The JSON document that defines the configuration for the
  gateway capability. For more information, see Configuring data sources (CLI) in the IoT
  SiteWise User Guide.
- `capability_namespace`: The namespace of the gateway capability configuration to be
  updated. For example, if you configure OPC-UA sources from the IoT SiteWise console, your
  OPC-UA capability configuration has the namespace iotsitewise:opcuacollector:version, where
  version is a number such as 1.
- `gateway_id`: The ID of the gateway to be updated.

"""
function update_gateway_capability_configuration(
    capabilityConfiguration,
    capabilityNamespace,
    gatewayId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "POST",
        "/20200301/gateways/$(gatewayId)/capability",
        Dict{String,Any}(
            "capabilityConfiguration" => capabilityConfiguration,
            "capabilityNamespace" => capabilityNamespace,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_gateway_capability_configuration(
    capabilityConfiguration,
    capabilityNamespace,
    gatewayId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "POST",
        "/20200301/gateways/$(gatewayId)/capability",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "capabilityConfiguration" => capabilityConfiguration,
                    "capabilityNamespace" => capabilityNamespace,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_portal(portal_contact_email, portal_id, portal_name, role_arn)
    update_portal(portal_contact_email, portal_id, portal_name, role_arn, params::Dict{String,<:Any})

Updates an IoT SiteWise Monitor portal.

# Arguments
- `portal_contact_email`: The Amazon Web Services administrator's contact email address.
- `portal_id`: The ID of the portal to update.
- `portal_name`: A new friendly name for the portal.
- `role_arn`: The ARN of a service role that allows the portal's users to access your IoT
  SiteWise resources on your behalf. For more information, see Using service roles for IoT
  SiteWise Monitor in the IoT SiteWise User Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"alarms"`: Contains the configuration information of an alarm created in an IoT SiteWise
  Monitor portal. You can use the alarm to monitor an asset property and get notified when
  the asset property value is outside a specified range. For more information, see Monitoring
  with alarms in the IoT SiteWise Application Guide.
- `"clientToken"`: A unique case-sensitive identifier that you can provide to ensure the
  idempotency of the request. Don't reuse this client token if a new idempotent request is
  required.
- `"notificationSenderEmail"`: The email address that sends alarm notifications.
- `"portalDescription"`: A new description for the portal.
- `"portalLogoImage"`:
"""
function update_portal(
    portalContactEmail,
    portalId,
    portalName,
    roleArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "PUT",
        "/portals/$(portalId)",
        Dict{String,Any}(
            "portalContactEmail" => portalContactEmail,
            "portalName" => portalName,
            "roleArn" => roleArn,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_portal(
    portalContactEmail,
    portalId,
    portalName,
    roleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "PUT",
        "/portals/$(portalId)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "portalContactEmail" => portalContactEmail,
                    "portalName" => portalName,
                    "roleArn" => roleArn,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_project(project_id, project_name)
    update_project(project_id, project_name, params::Dict{String,<:Any})

Updates an IoT SiteWise Monitor project.

# Arguments
- `project_id`: The ID of the project to update.
- `project_name`: A new friendly name for the project.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique case-sensitive identifier that you can provide to ensure the
  idempotency of the request. Don't reuse this client token if a new idempotent request is
  required.
- `"projectDescription"`: A new description for the project.
"""
function update_project(
    projectId, projectName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotsitewise(
        "PUT",
        "/projects/$(projectId)",
        Dict{String,Any}("projectName" => projectName, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_project(
    projectId,
    projectName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsitewise(
        "PUT",
        "/projects/$(projectId)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "projectName" => projectName, "clientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: compute_optimizer
using AWS.Compat
using AWS.UUIDs

"""
    delete_recommendation_preferences(recommendation_preference_names, resource_type)
    delete_recommendation_preferences(recommendation_preference_names, resource_type, params::Dict{String,<:Any})

Deletes a recommendation preference, such as enhanced infrastructure metrics. For more
information, see Activating enhanced infrastructure metrics in the Compute Optimizer User
Guide.

# Arguments
- `recommendation_preference_names`: The name of the recommendation preference to delete.
- `resource_type`: The target resource type of the recommendation preference to delete. The
  Ec2Instance option encompasses standalone instances and instances that are part of Auto
  Scaling groups. The AutoScalingGroup option encompasses only instances that are part of an
  Auto Scaling group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"scope"`: An object that describes the scope of the recommendation preference to delete.
  You can delete recommendation preferences that are created at the organization level (for
  management accounts of an organization only), account level, and resource level. For more
  information, see Activating enhanced infrastructure metrics in the Compute Optimizer User
  Guide.
"""
function delete_recommendation_preferences(
    recommendationPreferenceNames,
    resourceType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return compute_optimizer(
        "DeleteRecommendationPreferences",
        Dict{String,Any}(
            "recommendationPreferenceNames" => recommendationPreferenceNames,
            "resourceType" => resourceType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_recommendation_preferences(
    recommendationPreferenceNames,
    resourceType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return compute_optimizer(
        "DeleteRecommendationPreferences",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "recommendationPreferenceNames" => recommendationPreferenceNames,
                    "resourceType" => resourceType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_recommendation_export_jobs()
    describe_recommendation_export_jobs(params::Dict{String,<:Any})

Describes recommendation export jobs created in the last seven days. Use the
ExportAutoScalingGroupRecommendations or ExportEC2InstanceRecommendations actions to
request an export of your recommendations. Then use the DescribeRecommendationExportJobs
action to view your export jobs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: An array of objects to specify a filter that returns a more specific list of
  export jobs.
- `"jobIds"`: The identification numbers of the export jobs to return. An export job ID is
  returned when you create an export using the ExportAutoScalingGroupRecommendations or
  ExportEC2InstanceRecommendations actions. All export jobs created in the last seven days
  are returned if this parameter is omitted.
- `"maxResults"`: The maximum number of export jobs to return with a single request. To
  retrieve the remaining results, make another request with the returned nextToken value.
- `"nextToken"`: The token to advance to the next page of export jobs.
"""
function describe_recommendation_export_jobs(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return compute_optimizer(
        "DescribeRecommendationExportJobs";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_recommendation_export_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return compute_optimizer(
        "DescribeRecommendationExportJobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    export_auto_scaling_group_recommendations(s3_destination_config)
    export_auto_scaling_group_recommendations(s3_destination_config, params::Dict{String,<:Any})

Exports optimization recommendations for Auto Scaling groups. Recommendations are exported
in a comma-separated values (.csv) file, and its metadata in a JavaScript Object Notation
(JSON) (.json) file, to an existing Amazon Simple Storage Service (Amazon S3) bucket that
you specify. For more information, see Exporting Recommendations in the Compute Optimizer
User Guide. You can have only one Auto Scaling group export job in progress per Amazon Web
Services Region.

# Arguments
- `s3_destination_config`: An object to specify the destination Amazon Simple Storage
  Service (Amazon S3) bucket name and key prefix for the export job. You must create the
  destination Amazon S3 bucket for your recommendations export before you create the export
  job. Compute Optimizer does not create the S3 bucket for you. After you create the S3
  bucket, ensure that it has the required permissions policy to allow Compute Optimizer to
  write the export file to it. If you plan to specify an object prefix when you create the
  export job, you must include the object prefix in the policy that you add to the S3 bucket.
  For more information, see Amazon S3 Bucket Policy for Compute Optimizer in the Compute
  Optimizer User Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountIds"`: The IDs of the Amazon Web Services accounts for which to export Auto
  Scaling group recommendations. If your account is the management account of an
  organization, use this parameter to specify the member account for which you want to export
  recommendations. This parameter cannot be specified together with the include member
  accounts parameter. The parameters are mutually exclusive. Recommendations for member
  accounts are not included in the export if this parameter, or the include member accounts
  parameter, is omitted. You can specify multiple account IDs per request.
- `"fieldsToExport"`: The recommendations data to include in the export file. For more
  information about the fields that can be exported, see Exported files in the Compute
  Optimizer User Guide.
- `"fileFormat"`: The format of the export file. The only export file format currently
  supported is Csv.
- `"filters"`: An array of objects to specify a filter that exports a more specific set of
  Auto Scaling group recommendations.
- `"includeMemberAccounts"`: Indicates whether to include recommendations for resources in
  all member accounts of the organization if your account is the management account of an
  organization. The member accounts must also be opted in to Compute Optimizer, and trusted
  access for Compute Optimizer must be enabled in the organization account. For more
  information, see Compute Optimizer and Amazon Web Services Organizations trusted access in
  the Compute Optimizer User Guide. Recommendations for member accounts of the organization
  are not included in the export file if this parameter is omitted. This parameter cannot be
  specified together with the account IDs parameter. The parameters are mutually exclusive.
  Recommendations for member accounts are not included in the export if this parameter, or
  the account IDs parameter, is omitted.
- `"recommendationPreferences"`: An object to specify the preferences for the Auto Scaling
  group recommendations to export.
"""
function export_auto_scaling_group_recommendations(
    s3DestinationConfig; aws_config::AbstractAWSConfig=current_aws_config()
)
    return compute_optimizer(
        "ExportAutoScalingGroupRecommendations",
        Dict{String,Any}("s3DestinationConfig" => s3DestinationConfig);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function export_auto_scaling_group_recommendations(
    s3DestinationConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return compute_optimizer(
        "ExportAutoScalingGroupRecommendations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("s3DestinationConfig" => s3DestinationConfig),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    export_ebsvolume_recommendations(s3_destination_config)
    export_ebsvolume_recommendations(s3_destination_config, params::Dict{String,<:Any})

Exports optimization recommendations for Amazon EBS volumes. Recommendations are exported
in a comma-separated values (.csv) file, and its metadata in a JavaScript Object Notation
(JSON) (.json) file, to an existing Amazon Simple Storage Service (Amazon S3) bucket that
you specify. For more information, see Exporting Recommendations in the Compute Optimizer
User Guide. You can have only one Amazon EBS volume export job in progress per Amazon Web
Services Region.

# Arguments
- `s3_destination_config`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountIds"`: The IDs of the Amazon Web Services accounts for which to export Amazon
  EBS volume recommendations. If your account is the management account of an organization,
  use this parameter to specify the member account for which you want to export
  recommendations. This parameter cannot be specified together with the include member
  accounts parameter. The parameters are mutually exclusive. Recommendations for member
  accounts are not included in the export if this parameter, or the include member accounts
  parameter, is omitted. You can specify multiple account IDs per request.
- `"fieldsToExport"`: The recommendations data to include in the export file. For more
  information about the fields that can be exported, see Exported files in the Compute
  Optimizer User Guide.
- `"fileFormat"`: The format of the export file. The only export file format currently
  supported is Csv.
- `"filters"`: An array of objects to specify a filter that exports a more specific set of
  Amazon EBS volume recommendations.
- `"includeMemberAccounts"`: Indicates whether to include recommendations for resources in
  all member accounts of the organization if your account is the management account of an
  organization. The member accounts must also be opted in to Compute Optimizer, and trusted
  access for Compute Optimizer must be enabled in the organization account. For more
  information, see Compute Optimizer and Amazon Web Services Organizations trusted access in
  the Compute Optimizer User Guide. Recommendations for member accounts of the organization
  are not included in the export file if this parameter is omitted. This parameter cannot be
  specified together with the account IDs parameter. The parameters are mutually exclusive.
  Recommendations for member accounts are not included in the export if this parameter, or
  the account IDs parameter, is omitted.
"""
function export_ebsvolume_recommendations(
    s3DestinationConfig; aws_config::AbstractAWSConfig=current_aws_config()
)
    return compute_optimizer(
        "ExportEBSVolumeRecommendations",
        Dict{String,Any}("s3DestinationConfig" => s3DestinationConfig);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function export_ebsvolume_recommendations(
    s3DestinationConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return compute_optimizer(
        "ExportEBSVolumeRecommendations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("s3DestinationConfig" => s3DestinationConfig),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    export_ec2_instance_recommendations(s3_destination_config)
    export_ec2_instance_recommendations(s3_destination_config, params::Dict{String,<:Any})

Exports optimization recommendations for Amazon EC2 instances. Recommendations are exported
in a comma-separated values (.csv) file, and its metadata in a JavaScript Object Notation
(JSON) (.json) file, to an existing Amazon Simple Storage Service (Amazon S3) bucket that
you specify. For more information, see Exporting Recommendations in the Compute Optimizer
User Guide. You can have only one Amazon EC2 instance export job in progress per Amazon Web
Services Region.

# Arguments
- `s3_destination_config`: An object to specify the destination Amazon Simple Storage
  Service (Amazon S3) bucket name and key prefix for the export job. You must create the
  destination Amazon S3 bucket for your recommendations export before you create the export
  job. Compute Optimizer does not create the S3 bucket for you. After you create the S3
  bucket, ensure that it has the required permissions policy to allow Compute Optimizer to
  write the export file to it. If you plan to specify an object prefix when you create the
  export job, you must include the object prefix in the policy that you add to the S3 bucket.
  For more information, see Amazon S3 Bucket Policy for Compute Optimizer in the Compute
  Optimizer User Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountIds"`: The IDs of the Amazon Web Services accounts for which to export instance
  recommendations. If your account is the management account of an organization, use this
  parameter to specify the member account for which you want to export recommendations. This
  parameter cannot be specified together with the include member accounts parameter. The
  parameters are mutually exclusive. Recommendations for member accounts are not included in
  the export if this parameter, or the include member accounts parameter, is omitted. You can
  specify multiple account IDs per request.
- `"fieldsToExport"`: The recommendations data to include in the export file. For more
  information about the fields that can be exported, see Exported files in the Compute
  Optimizer User Guide.
- `"fileFormat"`: The format of the export file. The only export file format currently
  supported is Csv.
- `"filters"`: An array of objects to specify a filter that exports a more specific set of
  instance recommendations.
- `"includeMemberAccounts"`: Indicates whether to include recommendations for resources in
  all member accounts of the organization if your account is the management account of an
  organization. The member accounts must also be opted in to Compute Optimizer, and trusted
  access for Compute Optimizer must be enabled in the organization account. For more
  information, see Compute Optimizer and Amazon Web Services Organizations trusted access in
  the Compute Optimizer User Guide. Recommendations for member accounts of the organization
  are not included in the export file if this parameter is omitted. Recommendations for
  member accounts are not included in the export if this parameter, or the account IDs
  parameter, is omitted.
- `"recommendationPreferences"`: An object to specify the preferences for the Amazon EC2
  instance recommendations to export.
"""
function export_ec2_instance_recommendations(
    s3DestinationConfig; aws_config::AbstractAWSConfig=current_aws_config()
)
    return compute_optimizer(
        "ExportEC2InstanceRecommendations",
        Dict{String,Any}("s3DestinationConfig" => s3DestinationConfig);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function export_ec2_instance_recommendations(
    s3DestinationConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return compute_optimizer(
        "ExportEC2InstanceRecommendations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("s3DestinationConfig" => s3DestinationConfig),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    export_ecsservice_recommendations(s3_destination_config)
    export_ecsservice_recommendations(s3_destination_config, params::Dict{String,<:Any})

 Exports optimization recommendations for Amazon ECS services on Fargate.  Recommendations
are exported in a CSV file, and its metadata in a JSON file, to an existing Amazon Simple
Storage Service (Amazon S3) bucket that you specify. For more information, see Exporting
Recommendations in the Compute Optimizer User Guide. You can only have one Amazon ECS
service export job in progress per Amazon Web Services Region.

# Arguments
- `s3_destination_config`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountIds"`:  The Amazon Web Services account IDs for the export Amazon ECS service
  recommendations.  If your account is the management account or the delegated administrator
  of an organization, use this parameter to specify the member account you want to export
  recommendations to. This parameter can't be specified together with the include member
  accounts parameter. The parameters are mutually exclusive. If this parameter or the include
  member accounts parameter is omitted, the recommendations for member accounts aren't
  included in the export. You can specify multiple account IDs per request.
- `"fieldsToExport"`: The recommendations data to include in the export file. For more
  information about the fields that can be exported, see Exported files in the Compute
  Optimizer User Guide.
- `"fileFormat"`:  The format of the export file.  The CSV file is the only export file
  format currently supported.
- `"filters"`:  An array of objects to specify a filter that exports a more specific set of
  Amazon ECS service recommendations.
- `"includeMemberAccounts"`: If your account is the management account or the delegated
  administrator of an organization, this parameter indicates whether to include
  recommendations for resources in all member accounts of the organization. The member
  accounts must also be opted in to Compute Optimizer, and trusted access for Compute
  Optimizer must be enabled in the organization account. For more information, see Compute
  Optimizer and Amazon Web Services Organizations trusted access in the Compute Optimizer
  User Guide. If this parameter is omitted, recommendations for member accounts of the
  organization aren't included in the export file. If this parameter or the account ID
  parameter is omitted, recommendations for member accounts aren't included in the export.
"""
function export_ecsservice_recommendations(
    s3DestinationConfig; aws_config::AbstractAWSConfig=current_aws_config()
)
    return compute_optimizer(
        "ExportECSServiceRecommendations",
        Dict{String,Any}("s3DestinationConfig" => s3DestinationConfig);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function export_ecsservice_recommendations(
    s3DestinationConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return compute_optimizer(
        "ExportECSServiceRecommendations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("s3DestinationConfig" => s3DestinationConfig),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    export_lambda_function_recommendations(s3_destination_config)
    export_lambda_function_recommendations(s3_destination_config, params::Dict{String,<:Any})

Exports optimization recommendations for Lambda functions. Recommendations are exported in
a comma-separated values (.csv) file, and its metadata in a JavaScript Object Notation
(JSON) (.json) file, to an existing Amazon Simple Storage Service (Amazon S3) bucket that
you specify. For more information, see Exporting Recommendations in the Compute Optimizer
User Guide. You can have only one Lambda function export job in progress per Amazon Web
Services Region.

# Arguments
- `s3_destination_config`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountIds"`: The IDs of the Amazon Web Services accounts for which to export Lambda
  function recommendations. If your account is the management account of an organization, use
  this parameter to specify the member account for which you want to export recommendations.
  This parameter cannot be specified together with the include member accounts parameter. The
  parameters are mutually exclusive. Recommendations for member accounts are not included in
  the export if this parameter, or the include member accounts parameter, is omitted. You can
  specify multiple account IDs per request.
- `"fieldsToExport"`: The recommendations data to include in the export file. For more
  information about the fields that can be exported, see Exported files in the Compute
  Optimizer User Guide.
- `"fileFormat"`: The format of the export file. The only export file format currently
  supported is Csv.
- `"filters"`: An array of objects to specify a filter that exports a more specific set of
  Lambda function recommendations.
- `"includeMemberAccounts"`: Indicates whether to include recommendations for resources in
  all member accounts of the organization if your account is the management account of an
  organization. The member accounts must also be opted in to Compute Optimizer, and trusted
  access for Compute Optimizer must be enabled in the organization account. For more
  information, see Compute Optimizer and Amazon Web Services Organizations trusted access in
  the Compute Optimizer User Guide. Recommendations for member accounts of the organization
  are not included in the export file if this parameter is omitted. This parameter cannot be
  specified together with the account IDs parameter. The parameters are mutually exclusive.
  Recommendations for member accounts are not included in the export if this parameter, or
  the account IDs parameter, is omitted.
"""
function export_lambda_function_recommendations(
    s3DestinationConfig; aws_config::AbstractAWSConfig=current_aws_config()
)
    return compute_optimizer(
        "ExportLambdaFunctionRecommendations",
        Dict{String,Any}("s3DestinationConfig" => s3DestinationConfig);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function export_lambda_function_recommendations(
    s3DestinationConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return compute_optimizer(
        "ExportLambdaFunctionRecommendations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("s3DestinationConfig" => s3DestinationConfig),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    export_license_recommendations(s3_destination_config)
    export_license_recommendations(s3_destination_config, params::Dict{String,<:Any})

 Export optimization recommendations for your licenses.  Recommendations are exported in a
comma-separated values (CSV) file, and its metadata in a JavaScript Object Notation (JSON)
file, to an existing Amazon Simple Storage Service (Amazon S3) bucket that you specify. For
more information, see Exporting Recommendations in the Compute Optimizer User Guide. You
can have only one license export job in progress per Amazon Web Services Region.

# Arguments
- `s3_destination_config`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountIds"`: The IDs of the Amazon Web Services accounts for which to export license
  recommendations. If your account is the management account of an organization, use this
  parameter to specify the member account for which you want to export recommendations. This
  parameter can't be specified together with the include member accounts parameter. The
  parameters are mutually exclusive. If this parameter is omitted, recommendations for member
  accounts aren't included in the export. You can specify multiple account IDs per request.
- `"fieldsToExport"`: The recommendations data to include in the export file. For more
  information about the fields that can be exported, see Exported files in the Compute
  Optimizer User Guide.
- `"fileFormat"`: The format of the export file. A CSV file is the only export format
  currently supported.
- `"filters"`:  An array of objects to specify a filter that exports a more specific set of
  license recommendations.
- `"includeMemberAccounts"`: Indicates whether to include recommendations for resources in
  all member accounts of the organization if your account is the management account of an
  organization. The member accounts must also be opted in to Compute Optimizer, and trusted
  access for Compute Optimizer must be enabled in the organization account. For more
  information, see Compute Optimizer and Amazon Web Services Organizations trusted access in
  the Compute Optimizer User Guide. If this parameter is omitted, recommendations for member
  accounts of the organization aren't included in the export file . This parameter cannot be
  specified together with the account IDs parameter. The parameters are mutually exclusive.
"""
function export_license_recommendations(
    s3DestinationConfig; aws_config::AbstractAWSConfig=current_aws_config()
)
    return compute_optimizer(
        "ExportLicenseRecommendations",
        Dict{String,Any}("s3DestinationConfig" => s3DestinationConfig);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function export_license_recommendations(
    s3DestinationConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return compute_optimizer(
        "ExportLicenseRecommendations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("s3DestinationConfig" => s3DestinationConfig),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    export_rdsdatabase_recommendations(s3_destination_config)
    export_rdsdatabase_recommendations(s3_destination_config, params::Dict{String,<:Any})

 Export optimization recommendations for your Amazon Relational Database Service (Amazon
RDS).  Recommendations are exported in a comma-separated values (CSV) file, and its
metadata in a JavaScript Object Notation (JSON) file, to an existing Amazon Simple Storage
Service (Amazon S3) bucket that you specify. For more information, see Exporting
Recommendations in the Compute Optimizer User Guide. You can have only one Amazon RDS
export job in progress per Amazon Web Services Region.

# Arguments
- `s3_destination_config`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountIds"`:  The Amazon Web Services account IDs for the export Amazon RDS
  recommendations.  If your account is the management account or the delegated administrator
  of an organization, use this parameter to specify the member account you want to export
  recommendations to. This parameter can't be specified together with the include member
  accounts parameter. The parameters are mutually exclusive. If this parameter or the include
  member accounts parameter is omitted, the recommendations for member accounts aren't
  included in the export. You can specify multiple account IDs per request.
- `"fieldsToExport"`: The recommendations data to include in the export file. For more
  information about the fields that can be exported, see Exported files in the Compute
  Optimizer User Guide.
- `"fileFormat"`:  The format of the export file.  The CSV file is the only export file
  format currently supported.
- `"filters"`:  An array of objects to specify a filter that exports a more specific set of
  Amazon RDS recommendations.
- `"includeMemberAccounts"`: If your account is the management account or the delegated
  administrator of an organization, this parameter indicates whether to include
  recommendations for resources in all member accounts of the organization. The member
  accounts must also be opted in to Compute Optimizer, and trusted access for Compute
  Optimizer must be enabled in the organization account. For more information, see Compute
  Optimizer and Amazon Web Services Organizations trusted access in the Compute Optimizer
  User Guide. If this parameter is omitted, recommendations for member accounts of the
  organization aren't included in the export file. If this parameter or the account ID
  parameter is omitted, recommendations for member accounts aren't included in the export.
- `"recommendationPreferences"`:
"""
function export_rdsdatabase_recommendations(
    s3DestinationConfig; aws_config::AbstractAWSConfig=current_aws_config()
)
    return compute_optimizer(
        "ExportRDSDatabaseRecommendations",
        Dict{String,Any}("s3DestinationConfig" => s3DestinationConfig);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function export_rdsdatabase_recommendations(
    s3DestinationConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return compute_optimizer(
        "ExportRDSDatabaseRecommendations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("s3DestinationConfig" => s3DestinationConfig),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_auto_scaling_group_recommendations()
    get_auto_scaling_group_recommendations(params::Dict{String,<:Any})

Returns Auto Scaling group recommendations. Compute Optimizer generates recommendations for
Amazon EC2 Auto Scaling groups that meet a specific set of requirements. For more
information, see the Supported resources and requirements in the Compute Optimizer User
Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountIds"`: The ID of the Amazon Web Services account for which to return Auto
  Scaling group recommendations. If your account is the management account of an
  organization, use this parameter to specify the member account for which you want to return
  Auto Scaling group recommendations. Only one account ID can be specified per request.
- `"autoScalingGroupArns"`: The Amazon Resource Name (ARN) of the Auto Scaling groups for
  which to return recommendations.
- `"filters"`: An array of objects to specify a filter that returns a more specific list of
  Auto Scaling group recommendations.
- `"maxResults"`: The maximum number of Auto Scaling group recommendations to return with a
  single request. To retrieve the remaining results, make another request with the returned
  nextToken value.
- `"nextToken"`: The token to advance to the next page of Auto Scaling group
  recommendations.
- `"recommendationPreferences"`: An object to specify the preferences for the Auto Scaling
  group recommendations to return in the response.
"""
function get_auto_scaling_group_recommendations(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return compute_optimizer(
        "GetAutoScalingGroupRecommendations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_auto_scaling_group_recommendations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return compute_optimizer(
        "GetAutoScalingGroupRecommendations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_ebsvolume_recommendations()
    get_ebsvolume_recommendations(params::Dict{String,<:Any})

Returns Amazon Elastic Block Store (Amazon EBS) volume recommendations. Compute Optimizer
generates recommendations for Amazon EBS volumes that meet a specific set of requirements.
For more information, see the Supported resources and requirements in the Compute Optimizer
User Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountIds"`: The ID of the Amazon Web Services account for which to return volume
  recommendations. If your account is the management account of an organization, use this
  parameter to specify the member account for which you want to return volume
  recommendations. Only one account ID can be specified per request.
- `"filters"`: An array of objects to specify a filter that returns a more specific list of
  volume recommendations.
- `"maxResults"`: The maximum number of volume recommendations to return with a single
  request. To retrieve the remaining results, make another request with the returned
  nextToken value.
- `"nextToken"`: The token to advance to the next page of volume recommendations.
- `"volumeArns"`: The Amazon Resource Name (ARN) of the volumes for which to return
  recommendations.
"""
function get_ebsvolume_recommendations(; aws_config::AbstractAWSConfig=current_aws_config())
    return compute_optimizer(
        "GetEBSVolumeRecommendations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_ebsvolume_recommendations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return compute_optimizer(
        "GetEBSVolumeRecommendations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_ec2_instance_recommendations()
    get_ec2_instance_recommendations(params::Dict{String,<:Any})

Returns Amazon EC2 instance recommendations. Compute Optimizer generates recommendations
for Amazon Elastic Compute Cloud (Amazon EC2) instances that meet a specific set of
requirements. For more information, see the Supported resources and requirements in the
Compute Optimizer User Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountIds"`: The ID of the Amazon Web Services account for which to return instance
  recommendations. If your account is the management account of an organization, use this
  parameter to specify the member account for which you want to return instance
  recommendations. Only one account ID can be specified per request.
- `"filters"`: An array of objects to specify a filter that returns a more specific list of
  instance recommendations.
- `"instanceArns"`: The Amazon Resource Name (ARN) of the instances for which to return
  recommendations.
- `"maxResults"`: The maximum number of instance recommendations to return with a single
  request. To retrieve the remaining results, make another request with the returned
  nextToken value.
- `"nextToken"`: The token to advance to the next page of instance recommendations.
- `"recommendationPreferences"`: An object to specify the preferences for the Amazon EC2
  instance recommendations to return in the response.
"""
function get_ec2_instance_recommendations(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return compute_optimizer(
        "GetEC2InstanceRecommendations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_ec2_instance_recommendations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return compute_optimizer(
        "GetEC2InstanceRecommendations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_ec2_recommendation_projected_metrics(end_time, instance_arn, period, start_time, stat)
    get_ec2_recommendation_projected_metrics(end_time, instance_arn, period, start_time, stat, params::Dict{String,<:Any})

Returns the projected utilization metrics of Amazon EC2 instance recommendations.  The Cpu
and Memory metrics are the only projected utilization metrics returned when you run this
action. Additionally, the Memory metric is returned only for resources that have the
unified CloudWatch agent installed on them. For more information, see Enabling Memory
Utilization with the CloudWatch Agent.

# Arguments
- `end_time`: The timestamp of the last projected metrics data point to return.
- `instance_arn`: The Amazon Resource Name (ARN) of the instances for which to return
  recommendation projected metrics.
- `period`: The granularity, in seconds, of the projected metrics data points.
- `start_time`: The timestamp of the first projected metrics data point to return.
- `stat`: The statistic of the projected metrics.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"recommendationPreferences"`: An object to specify the preferences for the Amazon EC2
  recommendation projected metrics to return in the response.
"""
function get_ec2_recommendation_projected_metrics(
    endTime,
    instanceArn,
    period,
    startTime,
    stat;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return compute_optimizer(
        "GetEC2RecommendationProjectedMetrics",
        Dict{String,Any}(
            "endTime" => endTime,
            "instanceArn" => instanceArn,
            "period" => period,
            "startTime" => startTime,
            "stat" => stat,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_ec2_recommendation_projected_metrics(
    endTime,
    instanceArn,
    period,
    startTime,
    stat,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return compute_optimizer(
        "GetEC2RecommendationProjectedMetrics",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "endTime" => endTime,
                    "instanceArn" => instanceArn,
                    "period" => period,
                    "startTime" => startTime,
                    "stat" => stat,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_ecsservice_recommendation_projected_metrics(end_time, period, service_arn, start_time, stat)
    get_ecsservice_recommendation_projected_metrics(end_time, period, service_arn, start_time, stat, params::Dict{String,<:Any})

 Returns the projected metrics of Amazon ECS service recommendations.

# Arguments
- `end_time`:  The timestamp of the last projected metrics data point to return.
- `period`:  The granularity, in seconds, of the projected metrics data points.
- `service_arn`:  The ARN that identifies the Amazon ECS service.   The following is the
  format of the ARN:   arn:aws:ecs:region:aws_account_id:service/cluster-name/service-name
- `start_time`:  The timestamp of the first projected metrics data point to return.
- `stat`:  The statistic of the projected metrics.

"""
function get_ecsservice_recommendation_projected_metrics(
    endTime,
    period,
    serviceArn,
    startTime,
    stat;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return compute_optimizer(
        "GetECSServiceRecommendationProjectedMetrics",
        Dict{String,Any}(
            "endTime" => endTime,
            "period" => period,
            "serviceArn" => serviceArn,
            "startTime" => startTime,
            "stat" => stat,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_ecsservice_recommendation_projected_metrics(
    endTime,
    period,
    serviceArn,
    startTime,
    stat,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return compute_optimizer(
        "GetECSServiceRecommendationProjectedMetrics",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "endTime" => endTime,
                    "period" => period,
                    "serviceArn" => serviceArn,
                    "startTime" => startTime,
                    "stat" => stat,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_ecsservice_recommendations()
    get_ecsservice_recommendations(params::Dict{String,<:Any})

 Returns Amazon ECS service recommendations.   Compute Optimizer generates recommendations
for Amazon ECS services on Fargate that meet a specific set of requirements. For more
information, see the Supported resources and requirements in the Compute Optimizer User
Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountIds"`:  Return the Amazon ECS service recommendations to the specified Amazon
  Web Services account IDs.  If your account is the management account or the delegated
  administrator of an organization, use this parameter to return the Amazon ECS service
  recommendations to specific member accounts. You can only specify one account ID per
  request.
- `"filters"`:  An array of objects to specify a filter that returns a more specific list
  of Amazon ECS service recommendations.
- `"maxResults"`:  The maximum number of Amazon ECS service recommendations to return with
  a single request.  To retrieve the remaining results, make another request with the
  returned nextToken value.
- `"nextToken"`:  The token to advance to the next page of Amazon ECS service
  recommendations.
- `"serviceArns"`:  The ARN that identifies the Amazon ECS service.   The following is the
  format of the ARN:   arn:aws:ecs:region:aws_account_id:service/cluster-name/service-name
"""
function get_ecsservice_recommendations(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return compute_optimizer(
        "GetECSServiceRecommendations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_ecsservice_recommendations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return compute_optimizer(
        "GetECSServiceRecommendations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_effective_recommendation_preferences(resource_arn)
    get_effective_recommendation_preferences(resource_arn, params::Dict{String,<:Any})

Returns the recommendation preferences that are in effect for a given resource, such as
enhanced infrastructure metrics. Considers all applicable preferences that you might have
set at the resource, account, and organization level. When you create a recommendation
preference, you can set its status to Active or Inactive. Use this action to view the
recommendation preferences that are in effect, or Active.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource for which to confirm
  effective recommendation preferences. Only EC2 instance and Auto Scaling group ARNs are
  currently supported.

"""
function get_effective_recommendation_preferences(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return compute_optimizer(
        "GetEffectiveRecommendationPreferences",
        Dict{String,Any}("resourceArn" => resourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_effective_recommendation_preferences(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return compute_optimizer(
        "GetEffectiveRecommendationPreferences",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceArn" => resourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_enrollment_status()
    get_enrollment_status(params::Dict{String,<:Any})

Returns the enrollment (opt in) status of an account to the Compute Optimizer service. If
the account is the management account of an organization, this action also confirms the
enrollment status of member accounts of the organization. Use the
GetEnrollmentStatusesForOrganization action to get detailed information about the
enrollment status of member accounts of an organization.

"""
function get_enrollment_status(; aws_config::AbstractAWSConfig=current_aws_config())
    return compute_optimizer(
        "GetEnrollmentStatus"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_enrollment_status(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return compute_optimizer(
        "GetEnrollmentStatus",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_enrollment_statuses_for_organization()
    get_enrollment_statuses_for_organization(params::Dict{String,<:Any})

Returns the Compute Optimizer enrollment (opt-in) status of organization member accounts,
if your account is an organization management account. To get the enrollment status of
standalone accounts, use the GetEnrollmentStatus action.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: An array of objects to specify a filter that returns a more specific list of
  account enrollment statuses.
- `"maxResults"`: The maximum number of account enrollment statuses to return with a single
  request. You can specify up to 100 statuses to return with each request. To retrieve the
  remaining results, make another request with the returned nextToken value.
- `"nextToken"`: The token to advance to the next page of account enrollment statuses.
"""
function get_enrollment_statuses_for_organization(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return compute_optimizer(
        "GetEnrollmentStatusesForOrganization";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_enrollment_statuses_for_organization(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return compute_optimizer(
        "GetEnrollmentStatusesForOrganization",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_lambda_function_recommendations()
    get_lambda_function_recommendations(params::Dict{String,<:Any})

Returns Lambda function recommendations. Compute Optimizer generates recommendations for
functions that meet a specific set of requirements. For more information, see the Supported
resources and requirements in the Compute Optimizer User Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountIds"`: The ID of the Amazon Web Services account for which to return function
  recommendations. If your account is the management account of an organization, use this
  parameter to specify the member account for which you want to return function
  recommendations. Only one account ID can be specified per request.
- `"filters"`: An array of objects to specify a filter that returns a more specific list of
  function recommendations.
- `"functionArns"`: The Amazon Resource Name (ARN) of the functions for which to return
  recommendations. You can specify a qualified or unqualified ARN. If you specify an
  unqualified ARN without a function version suffix, Compute Optimizer will return
  recommendations for the latest (LATEST) version of the function. If you specify a qualified
  ARN with a version suffix, Compute Optimizer will return recommendations for the specified
  function version. For more information about using function versions, see Using versions in
  the Lambda Developer Guide.
- `"maxResults"`: The maximum number of function recommendations to return with a single
  request. To retrieve the remaining results, make another request with the returned
  nextToken value.
- `"nextToken"`: The token to advance to the next page of function recommendations.
"""
function get_lambda_function_recommendations(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return compute_optimizer(
        "GetLambdaFunctionRecommendations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_lambda_function_recommendations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return compute_optimizer(
        "GetLambdaFunctionRecommendations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_license_recommendations()
    get_license_recommendations(params::Dict{String,<:Any})

Returns license recommendations for Amazon EC2 instances that run on a specific license.
Compute Optimizer generates recommendations for licenses that meet a specific set of
requirements. For more information, see the Supported resources and requirements in the
Compute Optimizer User Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountIds"`: The ID of the Amazon Web Services account for which to return license
  recommendations. If your account is the management account of an organization, use this
  parameter to specify the member account for which you want to return license
  recommendations. Only one account ID can be specified per request.
- `"filters"`:  An array of objects to specify a filter that returns a more specific list
  of license recommendations.
- `"maxResults"`:  The maximum number of license recommendations to return with a single
  request.   To retrieve the remaining results, make another request with the returned
  nextToken value.
- `"nextToken"`:  The token to advance to the next page of license recommendations.
- `"resourceArns"`:  The ARN that identifies the Amazon EC2 instance.   The following is
  the format of the ARN:   arn:aws:ec2:region:aws_account_id:instance/instance-id
"""
function get_license_recommendations(; aws_config::AbstractAWSConfig=current_aws_config())
    return compute_optimizer(
        "GetLicenseRecommendations"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_license_recommendations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return compute_optimizer(
        "GetLicenseRecommendations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_rdsdatabase_recommendation_projected_metrics(end_time, period, resource_arn, start_time, stat)
    get_rdsdatabase_recommendation_projected_metrics(end_time, period, resource_arn, start_time, stat, params::Dict{String,<:Any})

 Returns the projected metrics of Amazon RDS recommendations.

# Arguments
- `end_time`:  The timestamp of the last projected metrics data point to return.
- `period`:  The granularity, in seconds, of the projected metrics data points.
- `resource_arn`:  The ARN that identifies the Amazon RDS.   The following is the format of
  the ARN:   arn:aws:rds:{region}:{accountId}:db:{resourceName}
- `start_time`:  The timestamp of the first projected metrics data point to return.
- `stat`:  The statistic of the projected metrics.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"recommendationPreferences"`:
"""
function get_rdsdatabase_recommendation_projected_metrics(
    endTime,
    period,
    resourceArn,
    startTime,
    stat;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return compute_optimizer(
        "GetRDSDatabaseRecommendationProjectedMetrics",
        Dict{String,Any}(
            "endTime" => endTime,
            "period" => period,
            "resourceArn" => resourceArn,
            "startTime" => startTime,
            "stat" => stat,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_rdsdatabase_recommendation_projected_metrics(
    endTime,
    period,
    resourceArn,
    startTime,
    stat,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return compute_optimizer(
        "GetRDSDatabaseRecommendationProjectedMetrics",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "endTime" => endTime,
                    "period" => period,
                    "resourceArn" => resourceArn,
                    "startTime" => startTime,
                    "stat" => stat,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_rdsdatabase_recommendations()
    get_rdsdatabase_recommendations(params::Dict{String,<:Any})

 Returns Amazon RDS recommendations.  Compute Optimizer generates recommendations for
Amazon RDS that meet a specific set of requirements. For more information, see the
Supported resources and requirements in the Compute Optimizer User Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountIds"`:  Return the Amazon RDS recommendations to the specified Amazon Web
  Services account IDs.  If your account is the management account or the delegated
  administrator of an organization, use this parameter to return the Amazon RDS
  recommendations to specific member accounts. You can only specify one account ID per
  request.
- `"filters"`:  An array of objects to specify a filter that returns a more specific list
  of Amazon RDS recommendations.
- `"maxResults"`: The maximum number of Amazon RDS recommendations to return with a single
  request. To retrieve the remaining results, make another request with the returned
  nextToken value.
- `"nextToken"`:  The token to advance to the next page of Amazon RDS recommendations.
- `"recommendationPreferences"`:
- `"resourceArns"`:  The ARN that identifies the Amazon RDS.   The following is the format
  of the ARN:   arn:aws:rds:{region}:{accountId}:db:{resourceName}   The following is the
  format of a DB Cluster ARN:   arn:aws:rds:{region}:{accountId}:cluster:{resourceName}
"""
function get_rdsdatabase_recommendations(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return compute_optimizer(
        "GetRDSDatabaseRecommendations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_rdsdatabase_recommendations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return compute_optimizer(
        "GetRDSDatabaseRecommendations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_recommendation_preferences(resource_type)
    get_recommendation_preferences(resource_type, params::Dict{String,<:Any})

Returns existing recommendation preferences, such as enhanced infrastructure metrics. Use
the scope parameter to specify which preferences to return. You can specify to return
preferences for an organization, a specific account ID, or a specific EC2 instance or Auto
Scaling group Amazon Resource Name (ARN). For more information, see Activating enhanced
infrastructure metrics in the Compute Optimizer User Guide.

# Arguments
- `resource_type`: The target resource type of the recommendation preference for which to
  return preferences. The Ec2Instance option encompasses standalone instances and instances
  that are part of Auto Scaling groups. The AutoScalingGroup option encompasses only
  instances that are part of an Auto Scaling group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of recommendation preferences to return with a single
  request. To retrieve the remaining results, make another request with the returned
  nextToken value.
- `"nextToken"`: The token to advance to the next page of recommendation preferences.
- `"scope"`: An object that describes the scope of the recommendation preference to return.
  You can return recommendation preferences that are created at the organization level (for
  management accounts of an organization only), account level, and resource level. For more
  information, see Activating enhanced infrastructure metrics in the Compute Optimizer User
  Guide.
"""
function get_recommendation_preferences(
    resourceType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return compute_optimizer(
        "GetRecommendationPreferences",
        Dict{String,Any}("resourceType" => resourceType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_recommendation_preferences(
    resourceType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return compute_optimizer(
        "GetRecommendationPreferences",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceType" => resourceType), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_recommendation_summaries()
    get_recommendation_summaries(params::Dict{String,<:Any})

Returns the optimization findings for an account. It returns the number of:   Amazon EC2
instances in an account that are Underprovisioned, Overprovisioned, or Optimized.   Auto
Scaling groups in an account that are NotOptimized, or Optimized.   Amazon EBS volumes in
an account that are NotOptimized, or Optimized.   Lambda functions in an account that are
NotOptimized, or Optimized.   Amazon ECS services in an account that are Underprovisioned,
Overprovisioned, or Optimized.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountIds"`: The ID of the Amazon Web Services account for which to return
  recommendation summaries. If your account is the management account of an organization, use
  this parameter to specify the member account for which you want to return recommendation
  summaries. Only one account ID can be specified per request.
- `"maxResults"`: The maximum number of recommendation summaries to return with a single
  request. To retrieve the remaining results, make another request with the returned
  nextToken value.
- `"nextToken"`: The token to advance to the next page of recommendation summaries.
"""
function get_recommendation_summaries(; aws_config::AbstractAWSConfig=current_aws_config())
    return compute_optimizer(
        "GetRecommendationSummaries"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_recommendation_summaries(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return compute_optimizer(
        "GetRecommendationSummaries",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_recommendation_preferences(resource_type)
    put_recommendation_preferences(resource_type, params::Dict{String,<:Any})

Creates a new recommendation preference or updates an existing recommendation preference,
such as enhanced infrastructure metrics. For more information, see Activating enhanced
infrastructure metrics in the Compute Optimizer User Guide.

# Arguments
- `resource_type`: The target resource type of the recommendation preference to create. The
  Ec2Instance option encompasses standalone instances and instances that are part of Auto
  Scaling groups. The AutoScalingGroup option encompasses only instances that are part of an
  Auto Scaling group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"enhancedInfrastructureMetrics"`: The status of the enhanced infrastructure metrics
  recommendation preference to create or update. Specify the Active status to activate the
  preference, or specify Inactive to deactivate the preference. For more information, see
  Enhanced infrastructure metrics in the Compute Optimizer User Guide.
- `"externalMetricsPreference"`: The provider of the external metrics recommendation
  preference to create or update. Specify a valid provider in the source field to activate
  the preference. To delete this preference, see the DeleteRecommendationPreferences action.
  This preference can only be set for the Ec2Instance resource type. For more information,
  see External metrics ingestion in the Compute Optimizer User Guide.
- `"inferredWorkloadTypes"`: The status of the inferred workload types recommendation
  preference to create or update.  The inferred workload type feature is active by default.
  To deactivate it, create a recommendation preference.  Specify the Inactive status to
  deactivate the feature, or specify Active to activate it. For more information, see
  Inferred workload types in the Compute Optimizer User Guide.
- `"lookBackPeriod"`:  The preference to control the number of days the utilization metrics
  of the Amazon Web Services resource are analyzed. When this preference isn't specified, we
  use the default value DAYS_14.   You can only set this preference for the Amazon EC2
  instance and Auto Scaling group resource types.
- `"preferredResources"`:  The preference to control which resource type values are
  considered when generating rightsizing recommendations. You can specify this preference as
  a combination of include and exclude lists. You must specify either an includeList or
  excludeList. If the preference is an empty set of resource type values, an error occurs.
  You can only set this preference for the Amazon EC2 instance and Auto Scaling group
  resource types.
- `"savingsEstimationMode"`:  The status of the savings estimation mode preference to
  create or update.  Specify the AfterDiscounts status to activate the preference, or specify
  BeforeDiscounts to deactivate the preference. Only the account manager or delegated
  administrator of your organization can activate this preference. For more information, see
  Savings estimation mode in the Compute Optimizer User Guide.
- `"scope"`: An object that describes the scope of the recommendation preference to create.
  You can create recommendation preferences at the organization level (for management
  accounts of an organization only), account level, and resource level. For more information,
  see Activating enhanced infrastructure metrics in the Compute Optimizer User Guide.  You
  cannot create recommendation preferences for Auto Scaling groups at the organization and
  account levels. You can create recommendation preferences for Auto Scaling groups only at
  the resource level by specifying a scope name of ResourceArn and a scope value of the Auto
  Scaling group Amazon Resource Name (ARN). This will configure the preference for all
  instances that are part of the specified Auto Scaling group. You also cannot create
  recommendation preferences at the resource level for instances that are part of an Auto
  Scaling group. You can create recommendation preferences at the resource level only for
  standalone instances.
- `"utilizationPreferences"`:  The preference to control the resource’s CPU utilization
  threshold, CPU utilization headroom, and memory utilization headroom. When this preference
  isn't specified, we use the following default values.  CPU utilization:    P99_5 for
  threshold    PERCENT_20 for headroom   Memory utilization:    PERCENT_20 for headroom
  You can only set CPU and memory utilization preferences for the Amazon EC2 instance
  resource type.   The threshold setting isn’t available for memory utilization.
"""
function put_recommendation_preferences(
    resourceType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return compute_optimizer(
        "PutRecommendationPreferences",
        Dict{String,Any}("resourceType" => resourceType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_recommendation_preferences(
    resourceType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return compute_optimizer(
        "PutRecommendationPreferences",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceType" => resourceType), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_enrollment_status(status)
    update_enrollment_status(status, params::Dict{String,<:Any})

Updates the enrollment (opt in and opt out) status of an account to the Compute Optimizer
service. If the account is a management account of an organization, this action can also be
used to enroll member accounts of the organization. You must have the appropriate
permissions to opt in to Compute Optimizer, to view its recommendations, and to opt out.
For more information, see Controlling access with Amazon Web Services Identity and Access
Management in the Compute Optimizer User Guide. When you opt in, Compute Optimizer
automatically creates a service-linked role in your account to access its data. For more
information, see Using Service-Linked Roles for Compute Optimizer in the Compute Optimizer
User Guide.

# Arguments
- `status`: The new enrollment status of the account. The following status options are
  available:    Active - Opts in your account to the Compute Optimizer service. Compute
  Optimizer begins analyzing the configuration and utilization metrics of your Amazon Web
  Services resources after you opt in. For more information, see Metrics analyzed by Compute
  Optimizer in the Compute Optimizer User Guide.    Inactive - Opts out your account from the
  Compute Optimizer service. Your account's recommendations and related metrics data will be
  deleted from Compute Optimizer after you opt out.    The Pending and Failed options cannot
  be used to update the enrollment status of an account. They are returned in the response of
  a request to update the enrollment status of an account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"includeMemberAccounts"`: Indicates whether to enroll member accounts of the
  organization if the account is the management account of an organization.
"""
function update_enrollment_status(
    status; aws_config::AbstractAWSConfig=current_aws_config()
)
    return compute_optimizer(
        "UpdateEnrollmentStatus",
        Dict{String,Any}("status" => status);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_enrollment_status(
    status, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return compute_optimizer(
        "UpdateEnrollmentStatus",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("status" => status), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: sagemaker_metrics
using AWS.Compat
using AWS.UUIDs

"""
    batch_put_metrics(metric_data, trial_component_name)
    batch_put_metrics(metric_data, trial_component_name, params::Dict{String,<:Any})

Used to ingest training metrics into SageMaker. These metrics can be visualized in
SageMaker Studio and retrieved with the GetMetrics API.

# Arguments
- `metric_data`: A list of raw metric values to put.
- `trial_component_name`: The name of the Trial Component to associate with the metrics.

"""
function batch_put_metrics(
    MetricData, TrialComponentName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sagemaker_metrics(
        "PUT",
        "/BatchPutMetrics",
        Dict{String,Any}(
            "MetricData" => MetricData, "TrialComponentName" => TrialComponentName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_put_metrics(
    MetricData,
    TrialComponentName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sagemaker_metrics(
        "PUT",
        "/BatchPutMetrics",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "MetricData" => MetricData, "TrialComponentName" => TrialComponentName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

#!/usr/bin/env julia --project

# Using AWS.jl to bootstrap AWS.jl test resources.

using AWS
using AWS: AWSException
using JSON

@service CloudFormation use_response_type = true
@service IAM use_response_type = true
# TODO: Support PascalCase, https://github.com/JuliaCloud/AWS.jl/issues/642
@service Secrets_Manager use_response_type = true

include("totp.jl")

function create_or_update_stack(args...; kwargs...)
    response = nothing
    result_key = nothing
    try
        response = CloudFormation.update_stack(args...; kwargs...)
        result_key = "UpdateStackResult"
    catch e
        if (
            e isa AWSException &&
            e.code == "ValidationError" &&
            e.message == "No updates are to be performed."
        )
            nothing
        elseif (
            e isa AWSException &&
            e.code == "ValidationError" &&
            contains(e.message, r"^Stack .* does not exist$")
        )
            response = CloudFormation.create_stack(args...; kwargs...)
            result_key = "CreateStackResult"
        else
            rethrow()
        end
    end

    return response, result_key
end

function create_or_update_secret(secret_id, params)
    secret_exists = try
        Secrets_Manager.get_secret_value(secret_id)
        true
    catch e
        if e isa AWSException && e.code == "ResourceNotFoundException"
            false
        else
            rethrow()
        end
    end

    r = if !secret_exists
        Secrets_Manager.create_secret(secret_id, params)
    else
        Secrets_Manager.update_secret(secret_id, params)
    end

    return r
end

# TODO: Add timeout
function wait_for_user_to_exist(user_name)
    while true
        try
            IAM.get_user(Dict("UserName" => user_name))
            break
        catch e
            if e isa AWSException && e.code == "NoSuchEntity"
                sleep(5)
                continue
            else
                rethrow()
            end
        end
    end

    return nothing
end

# Create multiple MFA devices for the `MFAUser`. Utilizing virtual MFA devices for our AWS.jl
# integration tests proved challenging for the following reasons:
#
# 1. A TOTP code can only be used once.
# 2. MFA devices can only be associated with users. See `iam:EnableMFADevice`: https://docs.aws.amazon.com/IAM/latest/APIReference/API_EnableMFADevice.html
# 3. Up to 8 MFA devices can be associated win a single user: https://docs.aws.amazon.com/IAM/latest/UserGuide/id_credentials_mfa_enable_virtual.html#replace-virt-mfa
# 4. AWS CloudFormation supports creating MFA devices and even assocaiting the device with a
#    user but doesn't provide access to the seed. See `AWS::IAM::VirtualMFADevice`: https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-iam-role.html#aws-resource-iam-role-return-values
# 5. There is a lag between when you associating an MFA device with a user and when you can first use it (~10 seconds)
#
# When running integration tests in parallel having TOTP codes be consumed or having a
# limited amount of MFA devices per user can cause unwanted throttling when running tests.
# To mitigate this issue the following algorithm is employed:
#
# As part of our resource setup we'll create and associate 8 virtual MFA devices with our
# AWS user. When running a test that requires the MFA user iterate through a randomized list
# of the MFA devices and attempt the API call with the associated TOTP. If the TOTP has been
# consumed we'll try the next MFA device in the list until all MFA devices have been
# attempted. If all TOTPs have been consumed we'll wait until th next time window and try
# again with a new randomized list of MFA devices.
#
# The primary advantage of this approach is that it allows up to 8 API calls to occur
# concurrently during the same time window. Concurrent integration tests will only be
# throttled if all TOTP tokens have been consumed.
function create_or_update_mfa_devices(; user_name, secret_id, num_devices=8)
    # Assumes user exists
    # TODO: Should be `list_mfa_devices` instead of `list_mfadevices`
    r = IAM.list_mfadevices(Dict("UserName" => user_name))
    existing_mfa_devices = get(parse(r)["ListMFADevicesResult"]["MFADevices"], "member", [])

    # When only a single MFA device is associated with the `user_name` then an
    # `AbstractDict` will be returned instead of an `AbstractVector`.
    if existing_mfa_devices isa AbstractDict
        existing_mfa_devices = [existing_mfa_devices]
    end

    if !isempty(existing_mfa_devices)
        @info "Deleting MFA devices for $user_name"
        for mfa_device in existing_mfa_devices
            mfa_serial = mfa_device["SerialNumber"]
            IAM.deactivate_mfadevice(mfa_serial, user_name)
            IAM.delete_virtual_mfadevice(mfa_serial)
        end
    end

    # Under certain conditions (such as manually deleting a stack) the user may no longer
    # exist but the MFA devices we want to create
    mfa_device_names = ["$user_name-$i" for i in 1:8]
    account_id = aws_account_number(AWSConfig())
    for mfa_device_name in mfa_device_names
        mfa_serial = "arn:aws:iam::$account_id:mfa/$mfa_device_name"
        try
            IAM.delete_virtual_mfadevice(mfa_serial)
            @warn "Deleting orphaned MFA device: $mfa_serial"
        catch e
            if e isa AWSException && e.code == "NoSuchEntity"
                nothing
            else
                rethrow()
            end
        end
    end

    @info "Creating $num_devices MFA devices for $user_name"
    mfa_devices = NamedTuple{(:mfa_serial, :seed),Tuple{String,String}}[]
    for mfa_device_name in mfa_device_names
        r = IAM.create_virtual_mfadevice(mfa_device_name)
        mfa_device = parse(r)["CreateVirtualMFADeviceResult"]["VirtualMFADevice"]
        mfa_serial = mfa_device["SerialNumber"]
        seed = String(transcode(Base64Decoder(), mfa_device["Base32StringSeed"]))

        # When a human sets up an virtual MFA device they prompted to enter "two consecutive
        # authentication codes". Usually one would enter the currency OTP code and wait for
        # next code to be generated. Entering the current and future OTP codes could result in
        # issues.
        # https://aws.amazon.com/blogs/security/how-to-enable-mfa-protection-on-your-aws-api-calls/
        # TODO: Argument ordering here is horrible
        IAM.enable_mfadevice(totp(seed; offset=-1), totp(seed), mfa_serial, user_name)

        push!(mfa_devices, (; mfa_serial, seed))
    end

    @info "Storing MFA device details"
    return create_or_update_secret(
        secret_id, Dict("SecretString" => JSON.json(mfa_devices))
    )
end

if @__FILE__() == abspath(PROGRAM_FILE)
    stack_name = "AWS-jl-test"
    prefix = "AWS.jl"
    stack_params = Dict("GitHubRepo" => prefix)
    template_body = read("aws_jl_test.yaml", String)

    with_aws_config(AWSConfig(; region="us-east-1")) do
        @info "Creating/updating stack: $stack_name"
        parameters = [
            Dict("ParameterKey" => k, "ParameterValue" => v) for (k, v) in stack_params
        ]
        create_or_update_stack(
            stack_name,
            Dict(
                "Capabilities" => ["CAPABILITY_NAMED_IAM"],
                "TemplateBody" => template_body,
                "Parameters" => parameters,
            ),
        )

        # When the stack is first created we need to wait for the user to be created
        mfa_user = "$prefix-mfa-user"
        @info "Waiting for $mfa_user"
        wait_for_user_to_exist(mfa_user)

        create_or_update_mfa_devices(;
            user_name=mfa_user, secret_id="$prefix-mfa-user-virtual-mfa-devices"
        )
    end
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: cloudtrail
using AWS.Compat
using AWS.UUIDs

"""
    add_tags(resource_id, tags_list)
    add_tags(resource_id, tags_list, params::Dict{String,<:Any})

Adds one or more tags to a trail, event data store, or channel, up to a limit of 50.
Overwrites an existing tag's value when a new value is specified for an existing tag key.
Tag key names must be unique; you cannot have two keys with the same name but different
values. If you specify a key without a value, the tag will be created with the specified
key and a value of null. You can tag a trail or event data store that applies to all Amazon
Web Services Regions only from the Region in which the trail or event data store was
created (also known as its home Region).

# Arguments
- `resource_id`: Specifies the ARN of the trail, event data store, or channel to which one
  or more tags will be added. The format of a trail ARN is:
  arn:aws:cloudtrail:us-east-2:123456789012:trail/MyTrail  The format of an event data store
  ARN is:
  arn:aws:cloudtrail:us-east-2:123456789012:eventdatastore/EXAMPLE-f852-4e8f-8bd1-bcf6cEXAMPLE
    The format of a channel ARN is:
  arn:aws:cloudtrail:us-east-2:123456789012:channel/01234567890
- `tags_list`: Contains a list of tags, up to a limit of 50

"""
function add_tags(ResourceId, TagsList; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudtrail(
        "AddTags",
        Dict{String,Any}("ResourceId" => ResourceId, "TagsList" => TagsList);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_tags(
    ResourceId,
    TagsList,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudtrail(
        "AddTags",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceId" => ResourceId, "TagsList" => TagsList),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_query(query_id)
    cancel_query(query_id, params::Dict{String,<:Any})

Cancels a query if the query is not in a terminated state, such as CANCELLED, FAILED,
TIMED_OUT, or FINISHED. You must specify an ARN value for EventDataStore. The ID of the
query that you want to cancel is also required. When you run CancelQuery, the query status
might show as CANCELLED even if the operation is not yet finished.

# Arguments
- `query_id`: The ID of the query that you want to cancel. The QueryId comes from the
  response of a StartQuery operation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EventDataStore"`: The ARN (or the ID suffix of the ARN) of an event data store on which
  the specified query is running.
"""
function cancel_query(QueryId; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudtrail(
        "CancelQuery",
        Dict{String,Any}("QueryId" => QueryId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_query(
    QueryId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudtrail(
        "CancelQuery",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("QueryId" => QueryId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_channel(destinations, name, source)
    create_channel(destinations, name, source, params::Dict{String,<:Any})

Creates a channel for CloudTrail to ingest events from a partner or external source. After
you create a channel, a CloudTrail Lake event data store can log events from the partner or
source that you specify.

# Arguments
- `destinations`: One or more event data stores to which events arriving through a channel
  will be logged.
- `name`: The name of the channel.
- `source`: The name of the partner or external event source. You cannot change this name
  after you create the channel. A maximum of one channel is allowed per source.  A source can
  be either Custom for all valid non-Amazon Web Services events, or the name of a partner
  event source. For information about the source names for available partners, see Additional
  information about integration partners in the CloudTrail User Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`:
"""
function create_channel(
    Destinations, Name, Source; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudtrail(
        "CreateChannel",
        Dict{String,Any}(
            "Destinations" => Destinations, "Name" => Name, "Source" => Source
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_channel(
    Destinations,
    Name,
    Source,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudtrail(
        "CreateChannel",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Destinations" => Destinations, "Name" => Name, "Source" => Source
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_event_data_store(name)
    create_event_data_store(name, params::Dict{String,<:Any})

Creates a new event data store.

# Arguments
- `name`: The name of the event data store.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AdvancedEventSelectors"`: The advanced event selectors to use to select the events for
  the data store. You can configure up to five advanced event selectors for each event data
  store.  For more information about how to use advanced event selectors to log CloudTrail
  events, see Log events by using advanced event selectors in the CloudTrail User Guide. For
  more information about how to use advanced event selectors to include Config configuration
  items in your event data store, see Create an event data store for Config configuration
  items in the CloudTrail User Guide. For more information about how to use advanced event
  selectors to include events outside of Amazon Web Services events in your event data store,
  see Create an integration to log events from outside Amazon Web Services in the CloudTrail
  User Guide.
- `"BillingMode"`: The billing mode for the event data store determines the cost for
  ingesting events and the default and maximum retention period for the event data store. The
  following are the possible values:    EXTENDABLE_RETENTION_PRICING - This billing mode is
  generally recommended if you want a flexible retention period of up to 3653 days (about 10
  years). The default retention period for this billing mode is 366 days.
  FIXED_RETENTION_PRICING - This billing mode is recommended if you expect to ingest more
  than 25 TB of event data per month and need a retention period of up to 2557 days (about 7
  years). The default retention period for this billing mode is 2557 days.   The default
  value is EXTENDABLE_RETENTION_PRICING. For more information about CloudTrail pricing, see
  CloudTrail Pricing and Managing CloudTrail Lake costs.
- `"KmsKeyId"`: Specifies the KMS key ID to use to encrypt the events delivered by
  CloudTrail. The value can be an alias name prefixed by alias/, a fully specified ARN to an
  alias, a fully specified ARN to a key, or a globally unique identifier.  Disabling or
  deleting the KMS key, or removing CloudTrail permissions on the key, prevents CloudTrail
  from logging events to the event data store, and prevents users from querying the data in
  the event data store that was encrypted with the key. After you associate an event data
  store with a KMS key, the KMS key cannot be removed or changed. Before you disable or
  delete a KMS key that you are using with an event data store, delete or back up your event
  data store.  CloudTrail also supports KMS multi-Region keys. For more information about
  multi-Region keys, see Using multi-Region keys in the Key Management Service Developer
  Guide. Examples:    alias/MyAliasName
  arn:aws:kms:us-east-2:123456789012:alias/MyAliasName
  arn:aws:kms:us-east-2:123456789012:key/12345678-1234-1234-1234-123456789012
  12345678-1234-1234-1234-123456789012
- `"MultiRegionEnabled"`: Specifies whether the event data store includes events from all
  Regions, or only from the Region in which the event data store is created.
- `"OrganizationEnabled"`: Specifies whether an event data store collects events logged for
  an organization in Organizations.
- `"RetentionPeriod"`: The retention period of the event data store, in days. If
  BillingMode is set to EXTENDABLE_RETENTION_PRICING, you can set a retention period of up to
  3653 days, the equivalent of 10 years. If BillingMode is set to FIXED_RETENTION_PRICING,
  you can set a retention period of up to 2557 days, the equivalent of seven years.
  CloudTrail Lake determines whether to retain an event by checking if the eventTime of the
  event is within the specified retention period. For example, if you set a retention period
  of 90 days, CloudTrail will remove events when the eventTime is older than 90 days.  If you
  plan to copy trail events to this event data store, we recommend that you consider both the
  age of the events that you want to copy as well as how long you want to keep the copied
  events in your event data store. For example, if you copy trail events that are 5 years old
  and specify a retention period of 7 years, the event data store will retain those events
  for two years.
- `"StartIngestion"`: Specifies whether the event data store should start ingesting live
  events. The default is true.
- `"TagsList"`:
- `"TerminationProtectionEnabled"`: Specifies whether termination protection is enabled for
  the event data store. If termination protection is enabled, you cannot delete the event
  data store until termination protection is disabled.
"""
function create_event_data_store(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudtrail(
        "CreateEventDataStore",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_event_data_store(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudtrail(
        "CreateEventDataStore",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_trail(name, s3_bucket_name)
    create_trail(name, s3_bucket_name, params::Dict{String,<:Any})

Creates a trail that specifies the settings for delivery of log data to an Amazon S3
bucket.

# Arguments
- `name`: Specifies the name of the trail. The name must meet the following requirements:
  Contain only ASCII letters (a-z, A-Z), numbers (0-9), periods (.), underscores (_), or
  dashes (-)   Start with a letter or number, and end with a letter or number   Be between 3
  and 128 characters   Have no adjacent periods, underscores or dashes. Names like
  my-_namespace and my--namespace are not valid.   Not be in IP address format (for example,
  192.168.5.4)
- `s3_bucket_name`: Specifies the name of the Amazon S3 bucket designated for publishing
  log files. For information about bucket naming rules, see Bucket naming rules in the Amazon
  Simple Storage Service User Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CloudWatchLogsLogGroupArn"`: Specifies a log group name using an Amazon Resource Name
  (ARN), a unique identifier that represents the log group to which CloudTrail logs will be
  delivered. You must use a log group that exists in your account. Not required unless you
  specify CloudWatchLogsRoleArn.
- `"CloudWatchLogsRoleArn"`: Specifies the role for the CloudWatch Logs endpoint to assume
  to write to a user's log group. You must use a role that exists in your account.
- `"EnableLogFileValidation"`: Specifies whether log file integrity validation is enabled.
  The default is false.  When you disable log file integrity validation, the chain of digest
  files is broken after one hour. CloudTrail does not create digest files for log files that
  were delivered during a period in which log file integrity validation was disabled. For
  example, if you enable log file integrity validation at noon on January 1, disable it at
  noon on January 2, and re-enable it at noon on January 10, digest files will not be created
  for the log files delivered from noon on January 2 to noon on January 10. The same applies
  whenever you stop CloudTrail logging or delete a trail.
- `"IncludeGlobalServiceEvents"`: Specifies whether the trail is publishing events from
  global services such as IAM to the log files.
- `"IsMultiRegionTrail"`: Specifies whether the trail is created in the current Region or
  in all Regions. The default is false, which creates a trail only in the Region where you
  are signed in. As a best practice, consider creating trails that log events in all Regions.
- `"IsOrganizationTrail"`: Specifies whether the trail is created for all accounts in an
  organization in Organizations, or only for the current Amazon Web Services account. The
  default is false, and cannot be true unless the call is made on behalf of an Amazon Web
  Services account that is the management account or delegated administrator account for an
  organization in Organizations.
- `"KmsKeyId"`: Specifies the KMS key ID to use to encrypt the logs delivered by
  CloudTrail. The value can be an alias name prefixed by alias/, a fully specified ARN to an
  alias, a fully specified ARN to a key, or a globally unique identifier. CloudTrail also
  supports KMS multi-Region keys. For more information about multi-Region keys, see Using
  multi-Region keys in the Key Management Service Developer Guide. Examples:
  alias/MyAliasName     arn:aws:kms:us-east-2:123456789012:alias/MyAliasName
  arn:aws:kms:us-east-2:123456789012:key/12345678-1234-1234-1234-123456789012
  12345678-1234-1234-1234-123456789012
- `"S3KeyPrefix"`: Specifies the Amazon S3 key prefix that comes after the name of the
  bucket you have designated for log file delivery. For more information, see Finding Your
  CloudTrail Log Files. The maximum length is 200 characters.
- `"SnsTopicName"`: Specifies the name of the Amazon SNS topic defined for notification of
  log file delivery. The maximum length is 256 characters.
- `"TagsList"`:
"""
function create_trail(
    Name, S3BucketName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudtrail(
        "CreateTrail",
        Dict{String,Any}("Name" => Name, "S3BucketName" => S3BucketName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_trail(
    Name,
    S3BucketName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudtrail(
        "CreateTrail",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Name" => Name, "S3BucketName" => S3BucketName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_channel(channel)
    delete_channel(channel, params::Dict{String,<:Any})

Deletes a channel.

# Arguments
- `channel`: The ARN or the UUID value of the channel that you want to delete.

"""
function delete_channel(Channel; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudtrail(
        "DeleteChannel",
        Dict{String,Any}("Channel" => Channel);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_channel(
    Channel,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudtrail(
        "DeleteChannel",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Channel" => Channel), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_event_data_store(event_data_store)
    delete_event_data_store(event_data_store, params::Dict{String,<:Any})

Disables the event data store specified by EventDataStore, which accepts an event data
store ARN. After you run DeleteEventDataStore, the event data store enters a
PENDING_DELETION state, and is automatically deleted after a wait period of seven days.
TerminationProtectionEnabled must be set to False on the event data store and the
FederationStatus must be DISABLED. You cannot delete an event data store if
TerminationProtectionEnabled is True or the FederationStatus is ENABLED. After you run
DeleteEventDataStore on an event data store, you cannot run ListQueries, DescribeQuery, or
GetQueryResults on queries that are using an event data store in a PENDING_DELETION state.
An event data store in the PENDING_DELETION state does not incur costs.

# Arguments
- `event_data_store`: The ARN (or the ID suffix of the ARN) of the event data store to
  delete.

"""
function delete_event_data_store(
    EventDataStore; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudtrail(
        "DeleteEventDataStore",
        Dict{String,Any}("EventDataStore" => EventDataStore);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_event_data_store(
    EventDataStore,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudtrail(
        "DeleteEventDataStore",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("EventDataStore" => EventDataStore), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_resource_policy(resource_arn)
    delete_resource_policy(resource_arn, params::Dict{String,<:Any})

 Deletes the resource-based policy attached to the CloudTrail channel.

# Arguments
- `resource_arn`:  The Amazon Resource Name (ARN) of the CloudTrail channel you're deleting
  the resource-based policy from. The following is the format of a resource ARN:
  arn:aws:cloudtrail:us-east-2:123456789012:channel/MyChannel.

"""
function delete_resource_policy(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudtrail(
        "DeleteResourcePolicy",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_resource_policy(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudtrail(
        "DeleteResourcePolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_trail(name)
    delete_trail(name, params::Dict{String,<:Any})

Deletes a trail. This operation must be called from the Region in which the trail was
created. DeleteTrail cannot be called on the shadow trails (replicated trails in other
Regions) of a trail that is enabled in all Regions.

# Arguments
- `name`: Specifies the name or the CloudTrail ARN of the trail to be deleted. The
  following is the format of a trail ARN.
  arn:aws:cloudtrail:us-east-2:123456789012:trail/MyTrail

"""
function delete_trail(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudtrail(
        "DeleteTrail",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_trail(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudtrail(
        "DeleteTrail",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    deregister_organization_delegated_admin(delegated_admin_account_id)
    deregister_organization_delegated_admin(delegated_admin_account_id, params::Dict{String,<:Any})

Removes CloudTrail delegated administrator permissions from a member account in an
organization.

# Arguments
- `delegated_admin_account_id`: A delegated administrator account ID. This is a member
  account in an organization that is currently designated as a delegated administrator.

"""
function deregister_organization_delegated_admin(
    DelegatedAdminAccountId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudtrail(
        "DeregisterOrganizationDelegatedAdmin",
        Dict{String,Any}("DelegatedAdminAccountId" => DelegatedAdminAccountId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function deregister_organization_delegated_admin(
    DelegatedAdminAccountId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudtrail(
        "DeregisterOrganizationDelegatedAdmin",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DelegatedAdminAccountId" => DelegatedAdminAccountId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_query()
    describe_query(params::Dict{String,<:Any})

Returns metadata about a query, including query run time in milliseconds, number of events
scanned and matched, and query status. If the query results were delivered to an S3 bucket,
the response also provides the S3 URI and the delivery status. You must specify either a
QueryID or a QueryAlias. Specifying the QueryAlias parameter returns information about the
last query run for the alias.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EventDataStore"`: The ARN (or the ID suffix of the ARN) of an event data store on which
  the specified query was run.
- `"QueryAlias"`:  The alias that identifies a query template.
- `"QueryId"`: The query ID.
"""
function describe_query(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudtrail(
        "DescribeQuery"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_query(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudtrail(
        "DescribeQuery", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_trails()
    describe_trails(params::Dict{String,<:Any})

Retrieves settings for one or more trails associated with the current Region for your
account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"includeShadowTrails"`: Specifies whether to include shadow trails in the response. A
  shadow trail is the replication in a Region of a trail that was created in a different
  Region, or in the case of an organization trail, the replication of an organization trail
  in member accounts. If you do not include shadow trails, organization trails in a member
  account and Region replication trails will not be returned. The default is true.
- `"trailNameList"`: Specifies a list of trail names, trail ARNs, or both, of the trails to
  describe. The format of a trail ARN is:
  arn:aws:cloudtrail:us-east-2:123456789012:trail/MyTrail  If an empty list is specified,
  information for the trail in the current Region is returned.   If an empty list is
  specified and IncludeShadowTrails is false, then information for all trails in the current
  Region is returned.   If an empty list is specified and IncludeShadowTrails is null or
  true, then information for all trails in the current Region and any associated shadow
  trails in other Regions is returned.    If one or more trail names are specified,
  information is returned only if the names match the names of trails belonging only to the
  current Region and current account. To return information about a trail in another Region,
  you must specify its trail ARN.
"""
function describe_trails(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudtrail(
        "DescribeTrails"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_trails(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudtrail(
        "DescribeTrails", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    disable_federation(event_data_store)
    disable_federation(event_data_store, params::Dict{String,<:Any})

 Disables Lake query federation on the specified event data store. When you disable
federation, CloudTrail disables the integration with Glue, Lake Formation, and Amazon
Athena. After disabling Lake query federation, you can no longer query your event data in
Amazon Athena. No CloudTrail Lake data is deleted when you disable federation and you can
continue to run queries in CloudTrail Lake.

# Arguments
- `event_data_store`:  The ARN (or ID suffix of the ARN) of the event data store for which
  you want to disable Lake query federation.

"""
function disable_federation(
    EventDataStore; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudtrail(
        "DisableFederation",
        Dict{String,Any}("EventDataStore" => EventDataStore);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disable_federation(
    EventDataStore,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudtrail(
        "DisableFederation",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("EventDataStore" => EventDataStore), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    enable_federation(event_data_store, federation_role_arn)
    enable_federation(event_data_store, federation_role_arn, params::Dict{String,<:Any})

 Enables Lake query federation on the specified event data store. Federating an event data
store lets you view the metadata associated with the event data store in the Glue Data
Catalog and run SQL queries against your event data using Amazon Athena. The table metadata
stored in the Glue Data Catalog lets the Athena query engine know how to find, read, and
process the data that you want to query. When you enable Lake query federation, CloudTrail
creates a managed database named aws:cloudtrail (if the database doesn't already exist) and
a managed federated table in the Glue Data Catalog. The event data store ID is used for the
table name. CloudTrail registers the role ARN and event data store in Lake Formation, the
service responsible for allowing fine-grained access control of the federated resources in
the Glue Data Catalog. For more information about Lake query federation, see Federate an
event data store.

# Arguments
- `event_data_store`: The ARN (or ID suffix of the ARN) of the event data store for which
  you want to enable Lake query federation.
- `federation_role_arn`:  The ARN of the federation role to use for the event data store.
  Amazon Web Services services like Lake Formation use this federation role to access data
  for the federated event data store. The federation role must exist in your account and
  provide the required minimum permissions.

"""
function enable_federation(
    EventDataStore, FederationRoleArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudtrail(
        "EnableFederation",
        Dict{String,Any}(
            "EventDataStore" => EventDataStore, "FederationRoleArn" => FederationRoleArn
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function enable_federation(
    EventDataStore,
    FederationRoleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudtrail(
        "EnableFederation",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EventDataStore" => EventDataStore,
                    "FederationRoleArn" => FederationRoleArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_channel(channel)
    get_channel(channel, params::Dict{String,<:Any})

 Returns information about a specific channel.

# Arguments
- `channel`: The ARN or UUID of a channel.

"""
function get_channel(Channel; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudtrail(
        "GetChannel",
        Dict{String,Any}("Channel" => Channel);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_channel(
    Channel,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudtrail(
        "GetChannel",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Channel" => Channel), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_event_data_store(event_data_store)
    get_event_data_store(event_data_store, params::Dict{String,<:Any})

Returns information about an event data store specified as either an ARN or the ID portion
of the ARN.

# Arguments
- `event_data_store`: The ARN (or ID suffix of the ARN) of the event data store about which
  you want information.

"""
function get_event_data_store(
    EventDataStore; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudtrail(
        "GetEventDataStore",
        Dict{String,Any}("EventDataStore" => EventDataStore);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_event_data_store(
    EventDataStore,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudtrail(
        "GetEventDataStore",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("EventDataStore" => EventDataStore), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_event_selectors(trail_name)
    get_event_selectors(trail_name, params::Dict{String,<:Any})

Describes the settings for the event selectors that you configured for your trail. The
information returned for your event selectors includes the following:   If your event
selector includes read-only events, write-only events, or all events. This applies to both
management events and data events.   If your event selector includes management events.
If your event selector includes data events, the resources on which you are logging data
events.   For more information about logging management and data events, see the following
topics in the CloudTrail User Guide:    Logging management events     Logging data events

# Arguments
- `trail_name`: Specifies the name of the trail or trail ARN. If you specify a trail name,
  the string must meet the following requirements:   Contain only ASCII letters (a-z, A-Z),
  numbers (0-9), periods (.), underscores (_), or dashes (-)   Start with a letter or number,
  and end with a letter or number   Be between 3 and 128 characters   Have no adjacent
  periods, underscores or dashes. Names like my-_namespace and my--namespace are not valid.
  Not be in IP address format (for example, 192.168.5.4)   If you specify a trail ARN, it
  must be in the format:  arn:aws:cloudtrail:us-east-2:123456789012:trail/MyTrail

"""
function get_event_selectors(TrailName; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudtrail(
        "GetEventSelectors",
        Dict{String,Any}("TrailName" => TrailName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_event_selectors(
    TrailName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudtrail(
        "GetEventSelectors",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TrailName" => TrailName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_import(import_id)
    get_import(import_id, params::Dict{String,<:Any})

 Returns information about a specific import.

# Arguments
- `import_id`:  The ID for the import.

"""
function get_import(ImportId; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudtrail(
        "GetImport",
        Dict{String,Any}("ImportId" => ImportId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_import(
    ImportId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudtrail(
        "GetImport",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ImportId" => ImportId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_insight_selectors()
    get_insight_selectors(params::Dict{String,<:Any})

Describes the settings for the Insights event selectors that you configured for your trail
or event data store. GetInsightSelectors shows if CloudTrail Insights event logging is
enabled on the trail or event data store, and if it is, which Insights types are enabled.
If you run GetInsightSelectors on a trail or event data store that does not have Insights
events enabled, the operation throws the exception InsightNotEnabledException  Specify
either the EventDataStore parameter to get Insights event selectors for an event data
store, or the TrailName parameter to the get Insights event selectors for a trail. You
cannot specify these parameters together. For more information, see Logging CloudTrail
Insights events in the CloudTrail User Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EventDataStore"`:  Specifies the ARN (or ID suffix of the ARN) of the event data store
  for which you want to get Insights selectors.  You cannot use this parameter with the
  TrailName parameter.
- `"TrailName"`: Specifies the name of the trail or trail ARN. If you specify a trail name,
  the string must meet the following requirements:   Contain only ASCII letters (a-z, A-Z),
  numbers (0-9), periods (.), underscores (_), or dashes (-)   Start with a letter or number,
  and end with a letter or number   Be between 3 and 128 characters   Have no adjacent
  periods, underscores or dashes. Names like my-_namespace and my--namespace are not valid.
  Not be in IP address format (for example, 192.168.5.4)   If you specify a trail ARN, it
  must be in the format:  arn:aws:cloudtrail:us-east-2:123456789012:trail/MyTrail  You cannot
  use this parameter with the EventDataStore parameter.
"""
function get_insight_selectors(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudtrail(
        "GetInsightSelectors"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_insight_selectors(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudtrail(
        "GetInsightSelectors",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_query_results(query_id)
    get_query_results(query_id, params::Dict{String,<:Any})

Gets event data results of a query. You must specify the QueryID value returned by the
StartQuery operation.

# Arguments
- `query_id`: The ID of the query for which you want to get results.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EventDataStore"`: The ARN (or ID suffix of the ARN) of the event data store against
  which the query was run.
- `"MaxQueryResults"`: The maximum number of query results to display on a single page.
- `"NextToken"`: A token you can use to get the next page of query results.
"""
function get_query_results(QueryId; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudtrail(
        "GetQueryResults",
        Dict{String,Any}("QueryId" => QueryId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_query_results(
    QueryId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudtrail(
        "GetQueryResults",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("QueryId" => QueryId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_resource_policy(resource_arn)
    get_resource_policy(resource_arn, params::Dict{String,<:Any})

 Retrieves the JSON text of the resource-based policy document attached to the CloudTrail
channel.

# Arguments
- `resource_arn`:  The Amazon Resource Name (ARN) of the CloudTrail channel attached to the
  resource-based policy. The following is the format of a resource ARN:
  arn:aws:cloudtrail:us-east-2:123456789012:channel/MyChannel.

"""
function get_resource_policy(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudtrail(
        "GetResourcePolicy",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_resource_policy(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudtrail(
        "GetResourcePolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_trail(name)
    get_trail(name, params::Dict{String,<:Any})

Returns settings information for a specified trail.

# Arguments
- `name`: The name or the Amazon Resource Name (ARN) of the trail for which you want to
  retrieve settings information.

"""
function get_trail(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudtrail(
        "GetTrail",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_trail(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudtrail(
        "GetTrail",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_trail_status(name)
    get_trail_status(name, params::Dict{String,<:Any})

Returns a JSON-formatted list of information about the specified trail. Fields include
information on delivery errors, Amazon SNS and Amazon S3 errors, and start and stop logging
times for each trail. This operation returns trail status from a single Region. To return
trail status from all Regions, you must call the operation on each Region.

# Arguments
- `name`: Specifies the name or the CloudTrail ARN of the trail for which you are
  requesting status. To get the status of a shadow trail (a replication of the trail in
  another Region), you must specify its ARN. The following is the format of a trail ARN.
  arn:aws:cloudtrail:us-east-2:123456789012:trail/MyTrail

"""
function get_trail_status(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudtrail(
        "GetTrailStatus",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_trail_status(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudtrail(
        "GetTrailStatus",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_channels()
    list_channels(params::Dict{String,<:Any})

 Lists the channels in the current account, and their source names.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`:  The maximum number of CloudTrail channels to display on a single page.
- `"NextToken"`: The token to use to get the next page of results after a previous API
  call. This token must be passed in with the same parameters that were specified in the
  original call. For example, if the original call specified an AttributeKey of 'Username'
  with a value of 'root', the call with NextToken should include those same parameters.
"""
function list_channels(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudtrail(
        "ListChannels"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_channels(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudtrail(
        "ListChannels", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_event_data_stores()
    list_event_data_stores(params::Dict{String,<:Any})

Returns information about all event data stores in the account, in the current Region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of event data stores to display on a single page.
- `"NextToken"`: A token you can use to get the next page of event data store results.
"""
function list_event_data_stores(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudtrail(
        "ListEventDataStores"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_event_data_stores(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudtrail(
        "ListEventDataStores",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_import_failures(import_id)
    list_import_failures(import_id, params::Dict{String,<:Any})

 Returns a list of failures for the specified import.

# Arguments
- `import_id`:  The ID of the import.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`:  The maximum number of failures to display on a single page.
- `"NextToken"`:  A token you can use to get the next page of import failures.
"""
function list_import_failures(ImportId; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudtrail(
        "ListImportFailures",
        Dict{String,Any}("ImportId" => ImportId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_import_failures(
    ImportId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudtrail(
        "ListImportFailures",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ImportId" => ImportId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_imports()
    list_imports(params::Dict{String,<:Any})

 Returns information on all imports, or a select set of imports by ImportStatus or
Destination.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Destination"`:  The ARN of the destination event data store.
- `"ImportStatus"`:  The status of the import.
- `"MaxResults"`:  The maximum number of imports to display on a single page.
- `"NextToken"`:  A token you can use to get the next page of import results.
"""
function list_imports(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudtrail("ListImports"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_imports(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudtrail(
        "ListImports", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_insights_metric_data(event_name, event_source, insight_type)
    list_insights_metric_data(event_name, event_source, insight_type, params::Dict{String,<:Any})

Returns Insights metrics data for trails that have enabled Insights. The request must
include the EventSource, EventName, and InsightType parameters. If the InsightType is set
to ApiErrorRateInsight, the request must also include the ErrorCode parameter. The
following are the available time periods for ListInsightsMetricData. Each cutoff is
inclusive.   Data points with a period of 60 seconds (1-minute) are available for 15 days.
 Data points with a period of 300 seconds (5-minute) are available for 63 days.   Data
points with a period of 3600 seconds (1 hour) are available for 90 days.   Access to the
ListInsightsMetricData API operation is linked to the cloudtrail:LookupEvents action. To
use this operation, you must have permissions to perform the cloudtrail:LookupEvents action.

# Arguments
- `event_name`: The name of the event, typically the Amazon Web Services API on which
  unusual levels of activity were recorded.
- `event_source`: The Amazon Web Services service to which the request was made, such as
  iam.amazonaws.com or s3.amazonaws.com.
- `insight_type`: The type of CloudTrail Insights event, which is either ApiCallRateInsight
  or ApiErrorRateInsight. The ApiCallRateInsight Insights type analyzes write-only management
  API calls that are aggregated per minute against a baseline API call volume. The
  ApiErrorRateInsight Insights type analyzes management API calls that result in error codes.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DataType"`: Type of datapoints to return. Valid values are NonZeroData and
  FillWithZeros. The default is NonZeroData.
- `"EndTime"`: Specifies, in UTC, the end time for time-series data. The value specified is
  exclusive; results include data points up to the specified time stamp. The default is the
  time of request.
- `"ErrorCode"`: Conditionally required if the InsightType parameter is set to
  ApiErrorRateInsight. If returning metrics for the ApiErrorRateInsight Insights type, this
  is the error to retrieve data for. For example, AccessDenied.
- `"MaxResults"`: The maximum number of datapoints to return. Valid values are integers
  from 1 to 21600. The default value is 21600.
- `"NextToken"`: Returned if all datapoints can't be returned in a single call. For
  example, due to reaching MaxResults. Add this parameter to the request to continue
  retrieving results starting from the last evaluated point.
- `"Period"`: Granularity of data to retrieve, in seconds. Valid values are 60, 300, and
  3600. If you specify any other value, you will get an error. The default is 3600 seconds.
- `"StartTime"`: Specifies, in UTC, the start time for time-series data. The value
  specified is inclusive; results include data points with the specified time stamp. The
  default is 90 days before the time of request.
"""
function list_insights_metric_data(
    EventName, EventSource, InsightType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudtrail(
        "ListInsightsMetricData",
        Dict{String,Any}(
            "EventName" => EventName,
            "EventSource" => EventSource,
            "InsightType" => InsightType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_insights_metric_data(
    EventName,
    EventSource,
    InsightType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudtrail(
        "ListInsightsMetricData",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EventName" => EventName,
                    "EventSource" => EventSource,
                    "InsightType" => InsightType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_public_keys()
    list_public_keys(params::Dict{String,<:Any})

Returns all public keys whose private keys were used to sign the digest files within the
specified time range. The public key is needed to validate digest files that were signed
with its corresponding private key.  CloudTrail uses different private and public key pairs
per Region. Each digest file is signed with a private key unique to its Region. When you
validate a digest file from a specific Region, you must look in the same Region for its
corresponding public key.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EndTime"`: Optionally specifies, in UTC, the end of the time range to look up public
  keys for CloudTrail digest files. If not specified, the current time is used.
- `"NextToken"`: Reserved for future use.
- `"StartTime"`: Optionally specifies, in UTC, the start of the time range to look up
  public keys for CloudTrail digest files. If not specified, the current time is used, and
  the current public key is returned.
"""
function list_public_keys(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudtrail(
        "ListPublicKeys"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_public_keys(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudtrail(
        "ListPublicKeys", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_queries(event_data_store)
    list_queries(event_data_store, params::Dict{String,<:Any})

Returns a list of queries and query statuses for the past seven days. You must specify an
ARN value for EventDataStore. Optionally, to shorten the list of results, you can specify a
time range, formatted as timestamps, by adding StartTime and EndTime parameters, and a
QueryStatus value. Valid values for QueryStatus include QUEUED, RUNNING, FINISHED, FAILED,
TIMED_OUT, or CANCELLED.

# Arguments
- `event_data_store`: The ARN (or the ID suffix of the ARN) of an event data store on which
  queries were run.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EndTime"`: Use with StartTime to bound a ListQueries request, and limit its results to
  only those queries run within a specified time period.
- `"MaxResults"`: The maximum number of queries to show on a page.
- `"NextToken"`: A token you can use to get the next page of results.
- `"QueryStatus"`: The status of queries that you want to return in results. Valid values
  for QueryStatus include QUEUED, RUNNING, FINISHED, FAILED, TIMED_OUT, or CANCELLED.
- `"StartTime"`: Use with EndTime to bound a ListQueries request, and limit its results to
  only those queries run within a specified time period.
"""
function list_queries(EventDataStore; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudtrail(
        "ListQueries",
        Dict{String,Any}("EventDataStore" => EventDataStore);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_queries(
    EventDataStore,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudtrail(
        "ListQueries",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("EventDataStore" => EventDataStore), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags(resource_id_list)
    list_tags(resource_id_list, params::Dict{String,<:Any})

Lists the tags for the specified trails, event data stores, or channels in the current
Region.

# Arguments
- `resource_id_list`: Specifies a list of trail, event data store, or channel ARNs whose
  tags will be listed. The list has a limit of 20 ARNs.  Example trail ARN format:
  arn:aws:cloudtrail:us-east-2:123456789012:trail/MyTrail  Example event data store ARN
  format:
  arn:aws:cloudtrail:us-east-2:123456789012:eventdatastore/EXAMPLE-f852-4e8f-8bd1-bcf6cEXAMPLE
    Example channel ARN format: arn:aws:cloudtrail:us-east-2:123456789012:channel/01234567890

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: Reserved for future use.
"""
function list_tags(ResourceIdList; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudtrail(
        "ListTags",
        Dict{String,Any}("ResourceIdList" => ResourceIdList);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags(
    ResourceIdList,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudtrail(
        "ListTags",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceIdList" => ResourceIdList), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_trails()
    list_trails(params::Dict{String,<:Any})

Lists trails that are in the current account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: The token to use to get the next page of results after a previous API
  call. This token must be passed in with the same parameters that were specified in the
  original call. For example, if the original call specified an AttributeKey of 'Username'
  with a value of 'root', the call with NextToken should include those same parameters.
"""
function list_trails(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudtrail("ListTrails"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_trails(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudtrail(
        "ListTrails", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    lookup_events()
    lookup_events(params::Dict{String,<:Any})

Looks up management events or CloudTrail Insights events that are captured by CloudTrail.
You can look up events that occurred in a Region within the last 90 days.   LookupEvents
returns recent Insights events for trails that enable Insights. To view Insights events for
an event data store, you can run queries on your Insights event data store, and you can
also view the Lake dashboard for Insights.  Lookup supports the following attributes for
management events:   Amazon Web Services access key   Event ID   Event name   Event source
 Read only   Resource name   Resource type   User name   Lookup supports the following
attributes for Insights events:   Event ID   Event name   Event source   All attributes are
optional. The default number of results returned is 50, with a maximum of 50 possible. The
response includes a token that you can use to get the next page of results.  The rate of
lookup requests is limited to two per second, per account, per Region. If this limit is
exceeded, a throttling error occurs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EndTime"`: Specifies that only events that occur before or at the specified time are
  returned. If the specified end time is before the specified start time, an error is
  returned.
- `"EventCategory"`: Specifies the event category. If you do not specify an event category,
  events of the category are not returned in the response. For example, if you do not specify
  insight as the value of EventCategory, no Insights events are returned.
- `"LookupAttributes"`: Contains a list of lookup attributes. Currently the list can
  contain only one item.
- `"MaxResults"`: The number of events to return. Possible values are 1 through 50. The
  default is 50.
- `"NextToken"`: The token to use to get the next page of results after a previous API
  call. This token must be passed in with the same parameters that were specified in the
  original call. For example, if the original call specified an AttributeKey of 'Username'
  with a value of 'root', the call with NextToken should include those same parameters.
- `"StartTime"`: Specifies that only events that occur after or at the specified time are
  returned. If the specified start time is after the specified end time, an error is returned.
"""
function lookup_events(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudtrail(
        "LookupEvents"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function lookup_events(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudtrail(
        "LookupEvents", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    put_event_selectors(trail_name)
    put_event_selectors(trail_name, params::Dict{String,<:Any})

Configures an event selector or advanced event selectors for your trail. Use event
selectors or advanced event selectors to specify management and data event settings for
your trail. If you want your trail to log Insights events, be sure the event selector
enables logging of the Insights event types you want configured for your trail. For more
information about logging Insights events, see Logging Insights events in the CloudTrail
User Guide. By default, trails created without specific event selectors are configured to
log all read and write management events, and no data events. When an event occurs in your
account, CloudTrail evaluates the event selectors or advanced event selectors in all
trails. For each trail, if the event matches any event selector, the trail processes and
logs the event. If the event doesn't match any event selector, the trail doesn't log the
event. Example   You create an event selector for a trail and specify that you want
write-only events.   The EC2 GetConsoleOutput and RunInstances API operations occur in your
account.   CloudTrail evaluates whether the events match your event selectors.   The
RunInstances is a write-only event and it matches your event selector. The trail logs the
event.   The GetConsoleOutput is a read-only event that doesn't match your event selector.
The trail doesn't log the event.    The PutEventSelectors operation must be called from the
Region in which the trail was created; otherwise, an InvalidHomeRegionException exception
is thrown. You can configure up to five event selectors for each trail. For more
information, see Logging management events, Logging data events, and Quotas in CloudTrail
in the CloudTrail User Guide. You can add advanced event selectors, and conditions for your
advanced event selectors, up to a maximum of 500 values for all conditions and selectors on
a trail. You can use either AdvancedEventSelectors or EventSelectors, but not both. If you
apply AdvancedEventSelectors to a trail, any existing EventSelectors are overwritten. For
more information about advanced event selectors, see Logging data events in the CloudTrail
User Guide.

# Arguments
- `trail_name`: Specifies the name of the trail or trail ARN. If you specify a trail name,
  the string must meet the following requirements:   Contain only ASCII letters (a-z, A-Z),
  numbers (0-9), periods (.), underscores (_), or dashes (-)   Start with a letter or number,
  and end with a letter or number   Be between 3 and 128 characters   Have no adjacent
  periods, underscores or dashes. Names like my-_namespace and my--namespace are not valid.
  Not be in IP address format (for example, 192.168.5.4)   If you specify a trail ARN, it
  must be in the following format.  arn:aws:cloudtrail:us-east-2:123456789012:trail/MyTrail

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AdvancedEventSelectors"`:  Specifies the settings for advanced event selectors. You can
  add advanced event selectors, and conditions for your advanced event selectors, up to a
  maximum of 500 values for all conditions and selectors on a trail. You can use either
  AdvancedEventSelectors or EventSelectors, but not both. If you apply AdvancedEventSelectors
  to a trail, any existing EventSelectors are overwritten. For more information about
  advanced event selectors, see Logging data events in the CloudTrail User Guide.
- `"EventSelectors"`: Specifies the settings for your event selectors. You can configure up
  to five event selectors for a trail. You can use either EventSelectors or
  AdvancedEventSelectors in a PutEventSelectors request, but not both. If you apply
  EventSelectors to a trail, any existing AdvancedEventSelectors are overwritten.
"""
function put_event_selectors(TrailName; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudtrail(
        "PutEventSelectors",
        Dict{String,Any}("TrailName" => TrailName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_event_selectors(
    TrailName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudtrail(
        "PutEventSelectors",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TrailName" => TrailName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_insight_selectors(insight_selectors)
    put_insight_selectors(insight_selectors, params::Dict{String,<:Any})

Lets you enable Insights event logging by specifying the Insights selectors that you want
to enable on an existing trail or event data store. You also use PutInsightSelectors to
turn off Insights event logging, by passing an empty list of Insights types. The valid
Insights event types are ApiErrorRateInsight and ApiCallRateInsight. To enable Insights on
an event data store, you must specify the ARNs (or ID suffix of the ARNs) for the source
event data store (EventDataStore) and the destination event data store
(InsightsDestination). The source event data store logs management events and enables
Insights. The destination event data store logs Insights events based upon the management
event activity of the source event data store. The source and destination event data stores
must belong to the same Amazon Web Services account. To log Insights events for a trail,
you must specify the name (TrailName) of the CloudTrail trail for which you want to change
or add Insights selectors. To log CloudTrail Insights events on API call volume, the trail
or event data store must log write management events. To log CloudTrail Insights events on
API error rate, the trail or event data store must log read or write management events. You
can call GetEventSelectors on a trail to check whether the trail logs management events.
You can call GetEventDataStore on an event data store to check whether the event data store
logs management events. For more information, see Logging CloudTrail Insights events in the
CloudTrail User Guide.

# Arguments
- `insight_selectors`: A JSON string that contains the Insights types you want to log on a
  trail or event data store. ApiCallRateInsight and ApiErrorRateInsight are valid Insight
  types. The ApiCallRateInsight Insights type analyzes write-only management API calls that
  are aggregated per minute against a baseline API call volume. The ApiErrorRateInsight
  Insights type analyzes management API calls that result in error codes. The error is shown
  if the API call is unsuccessful.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EventDataStore"`: The ARN (or ID suffix of the ARN) of the source event data store for
  which you want to change or add Insights selectors. To enable Insights on an event data
  store, you must provide both the EventDataStore and InsightsDestination parameters. You
  cannot use this parameter with the TrailName parameter.
- `"InsightsDestination"`:  The ARN (or ID suffix of the ARN) of the destination event data
  store that logs Insights events. To enable Insights on an event data store, you must
  provide both the EventDataStore and InsightsDestination parameters.  You cannot use this
  parameter with the TrailName parameter.
- `"TrailName"`: The name of the CloudTrail trail for which you want to change or add
  Insights selectors. You cannot use this parameter with the EventDataStore and
  InsightsDestination parameters.
"""
function put_insight_selectors(
    InsightSelectors; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudtrail(
        "PutInsightSelectors",
        Dict{String,Any}("InsightSelectors" => InsightSelectors);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_insight_selectors(
    InsightSelectors,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudtrail(
        "PutInsightSelectors",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("InsightSelectors" => InsightSelectors), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_resource_policy(resource_arn, resource_policy)
    put_resource_policy(resource_arn, resource_policy, params::Dict{String,<:Any})

 Attaches a resource-based permission policy to a CloudTrail channel that is used for an
integration with an event source outside of Amazon Web Services. For more information about
resource-based policies, see CloudTrail resource-based policy examples in the CloudTrail
User Guide.

# Arguments
- `resource_arn`:  The Amazon Resource Name (ARN) of the CloudTrail channel attached to the
  resource-based policy. The following is the format of a resource ARN:
  arn:aws:cloudtrail:us-east-2:123456789012:channel/MyChannel.
- `resource_policy`:  A JSON-formatted string for an Amazon Web Services resource-based
  policy.  The following are requirements for the resource policy:    Contains only one
  action: cloudtrail-data:PutAuditEvents     Contains at least one statement. The policy can
  have a maximum of 20 statements.     Each statement contains at least one principal. A
  statement can have a maximum of 50 principals.

"""
function put_resource_policy(
    ResourceArn, ResourcePolicy; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudtrail(
        "PutResourcePolicy",
        Dict{String,Any}("ResourceArn" => ResourceArn, "ResourcePolicy" => ResourcePolicy);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_resource_policy(
    ResourceArn,
    ResourcePolicy,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudtrail(
        "PutResourcePolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ResourceArn" => ResourceArn, "ResourcePolicy" => ResourcePolicy
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    register_organization_delegated_admin(member_account_id)
    register_organization_delegated_admin(member_account_id, params::Dict{String,<:Any})

Registers an organization’s member account as the CloudTrail delegated administrator.

# Arguments
- `member_account_id`: An organization member account ID that you want to designate as a
  delegated administrator.

"""
function register_organization_delegated_admin(
    MemberAccountId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudtrail(
        "RegisterOrganizationDelegatedAdmin",
        Dict{String,Any}("MemberAccountId" => MemberAccountId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function register_organization_delegated_admin(
    MemberAccountId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudtrail(
        "RegisterOrganizationDelegatedAdmin",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("MemberAccountId" => MemberAccountId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_tags(resource_id, tags_list)
    remove_tags(resource_id, tags_list, params::Dict{String,<:Any})

Removes the specified tags from a trail, event data store, or channel.

# Arguments
- `resource_id`: Specifies the ARN of the trail, event data store, or channel from which
  tags should be removed.  Example trail ARN format:
  arn:aws:cloudtrail:us-east-2:123456789012:trail/MyTrail  Example event data store ARN
  format:
  arn:aws:cloudtrail:us-east-2:123456789012:eventdatastore/EXAMPLE-f852-4e8f-8bd1-bcf6cEXAMPLE
    Example channel ARN format: arn:aws:cloudtrail:us-east-2:123456789012:channel/01234567890
- `tags_list`: Specifies a list of tags to be removed.

"""
function remove_tags(
    ResourceId, TagsList; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudtrail(
        "RemoveTags",
        Dict{String,Any}("ResourceId" => ResourceId, "TagsList" => TagsList);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_tags(
    ResourceId,
    TagsList,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudtrail(
        "RemoveTags",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceId" => ResourceId, "TagsList" => TagsList),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    restore_event_data_store(event_data_store)
    restore_event_data_store(event_data_store, params::Dict{String,<:Any})

Restores a deleted event data store specified by EventDataStore, which accepts an event
data store ARN. You can only restore a deleted event data store within the seven-day wait
period after deletion. Restoring an event data store can take several minutes, depending on
the size of the event data store.

# Arguments
- `event_data_store`: The ARN (or the ID suffix of the ARN) of the event data store that
  you want to restore.

"""
function restore_event_data_store(
    EventDataStore; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudtrail(
        "RestoreEventDataStore",
        Dict{String,Any}("EventDataStore" => EventDataStore);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function restore_event_data_store(
    EventDataStore,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudtrail(
        "RestoreEventDataStore",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("EventDataStore" => EventDataStore), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_event_data_store_ingestion(event_data_store)
    start_event_data_store_ingestion(event_data_store, params::Dict{String,<:Any})

Starts the ingestion of live events on an event data store specified as either an ARN or
the ID portion of the ARN. To start ingestion, the event data store Status must be
STOPPED_INGESTION and the eventCategory must be Management, Data, or ConfigurationItem.

# Arguments
- `event_data_store`: The ARN (or ID suffix of the ARN) of the event data store for which
  you want to start ingestion.

"""
function start_event_data_store_ingestion(
    EventDataStore; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudtrail(
        "StartEventDataStoreIngestion",
        Dict{String,Any}("EventDataStore" => EventDataStore);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_event_data_store_ingestion(
    EventDataStore,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudtrail(
        "StartEventDataStoreIngestion",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("EventDataStore" => EventDataStore), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_import()
    start_import(params::Dict{String,<:Any})

 Starts an import of logged trail events from a source S3 bucket to a destination event
data store. By default, CloudTrail only imports events contained in the S3 bucket's
CloudTrail prefix and the prefixes inside the CloudTrail prefix, and does not check
prefixes for other Amazon Web Services services. If you want to import CloudTrail events
contained in another prefix, you must include the prefix in the S3LocationUri. For more
considerations about importing trail events, see Considerations for copying trail events in
the CloudTrail User Guide.   When you start a new import, the Destinations and ImportSource
parameters are required. Before starting a new import, disable any access control lists
(ACLs) attached to the source S3 bucket. For more information about disabling ACLs, see
Controlling ownership of objects and disabling ACLs for your bucket.   When you retry an
import, the ImportID parameter is required.    If the destination event data store is for
an organization, you must use the management account to import trail events. You cannot use
the delegated administrator account for the organization.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Destinations"`:  The ARN of the destination event data store. Use this parameter for a
  new import.
- `"EndEventTime"`:  Use with StartEventTime to bound a StartImport request, and limit
  imported trail events to only those events logged within a specified time period. When you
  specify a time range, CloudTrail checks the prefix and log file names to verify the names
  contain a date between the specified StartEventTime and EndEventTime before attempting to
  import events.
- `"ImportId"`:  The ID of the import. Use this parameter when you are retrying an import.
- `"ImportSource"`:  The source S3 bucket for the import. Use this parameter for a new
  import.
- `"StartEventTime"`:  Use with EndEventTime to bound a StartImport request, and limit
  imported trail events to only those events logged within a specified time period. When you
  specify a time range, CloudTrail checks the prefix and log file names to verify the names
  contain a date between the specified StartEventTime and EndEventTime before attempting to
  import events.
"""
function start_import(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudtrail("StartImport"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function start_import(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudtrail(
        "StartImport", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    start_logging(name)
    start_logging(name, params::Dict{String,<:Any})

Starts the recording of Amazon Web Services API calls and log file delivery for a trail.
For a trail that is enabled in all Regions, this operation must be called from the Region
in which the trail was created. This operation cannot be called on the shadow trails
(replicated trails in other Regions) of a trail that is enabled in all Regions.

# Arguments
- `name`: Specifies the name or the CloudTrail ARN of the trail for which CloudTrail logs
  Amazon Web Services API calls. The following is the format of a trail ARN.
  arn:aws:cloudtrail:us-east-2:123456789012:trail/MyTrail

"""
function start_logging(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudtrail(
        "StartLogging",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_logging(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudtrail(
        "StartLogging",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_query()
    start_query(params::Dict{String,<:Any})

Starts a CloudTrail Lake query. Use the QueryStatement parameter to provide your SQL query,
enclosed in single quotation marks. Use the optional DeliveryS3Uri parameter to deliver the
query results to an S3 bucket.  StartQuery requires you specify either the QueryStatement
parameter, or a QueryAlias and any QueryParameters. In the current release, the QueryAlias
and QueryParameters parameters are used only for the queries that populate the CloudTrail
Lake dashboards.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DeliveryS3Uri"`:  The URI for the S3 bucket where CloudTrail delivers the query
  results.
- `"QueryAlias"`:  The alias that identifies a query template.
- `"QueryParameters"`:  The query parameters for the specified QueryAlias.
- `"QueryStatement"`: The SQL code of your query.
"""
function start_query(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudtrail("StartQuery"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function start_query(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudtrail(
        "StartQuery", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    stop_event_data_store_ingestion(event_data_store)
    stop_event_data_store_ingestion(event_data_store, params::Dict{String,<:Any})

Stops the ingestion of live events on an event data store specified as either an ARN or the
ID portion of the ARN. To stop ingestion, the event data store Status must be ENABLED and
the eventCategory must be Management, Data, or ConfigurationItem.

# Arguments
- `event_data_store`: The ARN (or ID suffix of the ARN) of the event data store for which
  you want to stop ingestion.

"""
function stop_event_data_store_ingestion(
    EventDataStore; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudtrail(
        "StopEventDataStoreIngestion",
        Dict{String,Any}("EventDataStore" => EventDataStore);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_event_data_store_ingestion(
    EventDataStore,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudtrail(
        "StopEventDataStoreIngestion",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("EventDataStore" => EventDataStore), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_import(import_id)
    stop_import(import_id, params::Dict{String,<:Any})

 Stops a specified import.

# Arguments
- `import_id`:  The ID of the import.

"""
function stop_import(ImportId; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudtrail(
        "StopImport",
        Dict{String,Any}("ImportId" => ImportId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_import(
    ImportId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudtrail(
        "StopImport",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ImportId" => ImportId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_logging(name)
    stop_logging(name, params::Dict{String,<:Any})

Suspends the recording of Amazon Web Services API calls and log file delivery for the
specified trail. Under most circumstances, there is no need to use this action. You can
update a trail without stopping it first. This action is the only way to stop recording.
For a trail enabled in all Regions, this operation must be called from the Region in which
the trail was created, or an InvalidHomeRegionException will occur. This operation cannot
be called on the shadow trails (replicated trails in other Regions) of a trail enabled in
all Regions.

# Arguments
- `name`: Specifies the name or the CloudTrail ARN of the trail for which CloudTrail will
  stop logging Amazon Web Services API calls. The following is the format of a trail ARN.
  arn:aws:cloudtrail:us-east-2:123456789012:trail/MyTrail

"""
function stop_logging(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudtrail(
        "StopLogging",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_logging(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudtrail(
        "StopLogging",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_channel(channel)
    update_channel(channel, params::Dict{String,<:Any})

Updates a channel specified by a required channel ARN or UUID.

# Arguments
- `channel`: The ARN or ID (the ARN suffix) of the channel that you want to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Destinations"`: The ARNs of event data stores that you want to log events arriving
  through the channel.
- `"Name"`:  Changes the name of the channel.
"""
function update_channel(Channel; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudtrail(
        "UpdateChannel",
        Dict{String,Any}("Channel" => Channel);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_channel(
    Channel,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudtrail(
        "UpdateChannel",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Channel" => Channel), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_event_data_store(event_data_store)
    update_event_data_store(event_data_store, params::Dict{String,<:Any})

Updates an event data store. The required EventDataStore value is an ARN or the ID portion
of the ARN. Other parameters are optional, but at least one optional parameter must be
specified, or CloudTrail throws an error. RetentionPeriod is in days, and valid values are
integers between 7 and 3653 if the BillingMode is set to EXTENDABLE_RETENTION_PRICING, or
between 7 and 2557 if BillingMode is set to FIXED_RETENTION_PRICING. By default,
TerminationProtection is enabled. For event data stores for CloudTrail events,
AdvancedEventSelectors includes or excludes management or data events in your event data
store. For more information about AdvancedEventSelectors, see AdvancedEventSelectors.  For
event data stores for CloudTrail Insights events, Config configuration items, Audit Manager
evidence, or non-Amazon Web Services events, AdvancedEventSelectors includes events of that
type in your event data store.

# Arguments
- `event_data_store`: The ARN (or the ID suffix of the ARN) of the event data store that
  you want to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AdvancedEventSelectors"`: The advanced event selectors used to select events for the
  event data store. You can configure up to five advanced event selectors for each event data
  store.
- `"BillingMode"`:  You can't change the billing mode from EXTENDABLE_RETENTION_PRICING to
  FIXED_RETENTION_PRICING. If BillingMode is set to EXTENDABLE_RETENTION_PRICING and you want
  to use FIXED_RETENTION_PRICING instead, you'll need to stop ingestion on the event data
  store and create a new event data store that uses FIXED_RETENTION_PRICING.  The billing
  mode for the event data store determines the cost for ingesting events and the default and
  maximum retention period for the event data store. The following are the possible values:
   EXTENDABLE_RETENTION_PRICING - This billing mode is generally recommended if you want a
  flexible retention period of up to 3653 days (about 10 years). The default retention period
  for this billing mode is 366 days.    FIXED_RETENTION_PRICING - This billing mode is
  recommended if you expect to ingest more than 25 TB of event data per month and need a
  retention period of up to 2557 days (about 7 years). The default retention period for this
  billing mode is 2557 days.   For more information about CloudTrail pricing, see CloudTrail
  Pricing and Managing CloudTrail Lake costs.
- `"KmsKeyId"`: Specifies the KMS key ID to use to encrypt the events delivered by
  CloudTrail. The value can be an alias name prefixed by alias/, a fully specified ARN to an
  alias, a fully specified ARN to a key, or a globally unique identifier.  Disabling or
  deleting the KMS key, or removing CloudTrail permissions on the key, prevents CloudTrail
  from logging events to the event data store, and prevents users from querying the data in
  the event data store that was encrypted with the key. After you associate an event data
  store with a KMS key, the KMS key cannot be removed or changed. Before you disable or
  delete a KMS key that you are using with an event data store, delete or back up your event
  data store.  CloudTrail also supports KMS multi-Region keys. For more information about
  multi-Region keys, see Using multi-Region keys in the Key Management Service Developer
  Guide. Examples:    alias/MyAliasName
  arn:aws:kms:us-east-2:123456789012:alias/MyAliasName
  arn:aws:kms:us-east-2:123456789012:key/12345678-1234-1234-1234-123456789012
  12345678-1234-1234-1234-123456789012
- `"MultiRegionEnabled"`: Specifies whether an event data store collects events from all
  Regions, or only from the Region in which it was created.
- `"Name"`: The event data store name.
- `"OrganizationEnabled"`: Specifies whether an event data store collects events logged for
  an organization in Organizations.  Only the management account for the organization can
  convert an organization event data store to a non-organization event data store, or convert
  a non-organization event data store to an organization event data store.
- `"RetentionPeriod"`: The retention period of the event data store, in days. If
  BillingMode is set to EXTENDABLE_RETENTION_PRICING, you can set a retention period of up to
  3653 days, the equivalent of 10 years. If BillingMode is set to FIXED_RETENTION_PRICING,
  you can set a retention period of up to 2557 days, the equivalent of seven years.
  CloudTrail Lake determines whether to retain an event by checking if the eventTime of the
  event is within the specified retention period. For example, if you set a retention period
  of 90 days, CloudTrail will remove events when the eventTime is older than 90 days.  If you
  decrease the retention period of an event data store, CloudTrail will remove any events
  with an eventTime older than the new retention period. For example, if the previous
  retention period was 365 days and you decrease it to 100 days, CloudTrail will remove
  events with an eventTime older than 100 days.
- `"TerminationProtectionEnabled"`: Indicates that termination protection is enabled and
  the event data store cannot be automatically deleted.
"""
function update_event_data_store(
    EventDataStore; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudtrail(
        "UpdateEventDataStore",
        Dict{String,Any}("EventDataStore" => EventDataStore);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_event_data_store(
    EventDataStore,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudtrail(
        "UpdateEventDataStore",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("EventDataStore" => EventDataStore), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_trail(name)
    update_trail(name, params::Dict{String,<:Any})

Updates trail settings that control what events you are logging, and how to handle log
files. Changes to a trail do not require stopping the CloudTrail service. Use this action
to designate an existing bucket for log delivery. If the existing bucket has previously
been a target for CloudTrail log files, an IAM policy exists for the bucket. UpdateTrail
must be called from the Region in which the trail was created; otherwise, an
InvalidHomeRegionException is thrown.

# Arguments
- `name`: Specifies the name of the trail or trail ARN. If Name is a trail name, the string
  must meet the following requirements:   Contain only ASCII letters (a-z, A-Z), numbers
  (0-9), periods (.), underscores (_), or dashes (-)   Start with a letter or number, and end
  with a letter or number   Be between 3 and 128 characters   Have no adjacent periods,
  underscores or dashes. Names like my-_namespace and my--namespace are not valid.   Not be
  in IP address format (for example, 192.168.5.4)   If Name is a trail ARN, it must be in the
  following format.  arn:aws:cloudtrail:us-east-2:123456789012:trail/MyTrail

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CloudWatchLogsLogGroupArn"`: Specifies a log group name using an Amazon Resource Name
  (ARN), a unique identifier that represents the log group to which CloudTrail logs are
  delivered. You must use a log group that exists in your account. Not required unless you
  specify CloudWatchLogsRoleArn.
- `"CloudWatchLogsRoleArn"`: Specifies the role for the CloudWatch Logs endpoint to assume
  to write to a user's log group. You must use a role that exists in your account.
- `"EnableLogFileValidation"`: Specifies whether log file validation is enabled. The
  default is false.  When you disable log file integrity validation, the chain of digest
  files is broken after one hour. CloudTrail does not create digest files for log files that
  were delivered during a period in which log file integrity validation was disabled. For
  example, if you enable log file integrity validation at noon on January 1, disable it at
  noon on January 2, and re-enable it at noon on January 10, digest files will not be created
  for the log files delivered from noon on January 2 to noon on January 10. The same applies
  whenever you stop CloudTrail logging or delete a trail.
- `"IncludeGlobalServiceEvents"`: Specifies whether the trail is publishing events from
  global services such as IAM to the log files.
- `"IsMultiRegionTrail"`: Specifies whether the trail applies only to the current Region or
  to all Regions. The default is false. If the trail exists only in the current Region and
  this value is set to true, shadow trails (replications of the trail) will be created in the
  other Regions. If the trail exists in all Regions and this value is set to false, the trail
  will remain in the Region where it was created, and its shadow trails in other Regions will
  be deleted. As a best practice, consider using trails that log events in all Regions.
- `"IsOrganizationTrail"`: Specifies whether the trail is applied to all accounts in an
  organization in Organizations, or only for the current Amazon Web Services account. The
  default is false, and cannot be true unless the call is made on behalf of an Amazon Web
  Services account that is the management account for an organization in Organizations. If
  the trail is not an organization trail and this is set to true, the trail will be created
  in all Amazon Web Services accounts that belong to the organization. If the trail is an
  organization trail and this is set to false, the trail will remain in the current Amazon
  Web Services account but be deleted from all member accounts in the organization.  Only the
  management account for the organization can convert an organization trail to a
  non-organization trail, or convert a non-organization trail to an organization trail.
- `"KmsKeyId"`: Specifies the KMS key ID to use to encrypt the logs delivered by
  CloudTrail. The value can be an alias name prefixed by \"alias/\", a fully specified ARN to
  an alias, a fully specified ARN to a key, or a globally unique identifier. CloudTrail also
  supports KMS multi-Region keys. For more information about multi-Region keys, see Using
  multi-Region keys in the Key Management Service Developer Guide. Examples:
  alias/MyAliasName   arn:aws:kms:us-east-2:123456789012:alias/MyAliasName
  arn:aws:kms:us-east-2:123456789012:key/12345678-1234-1234-1234-123456789012
  12345678-1234-1234-1234-123456789012
- `"S3BucketName"`: Specifies the name of the Amazon S3 bucket designated for publishing
  log files. See Amazon S3 Bucket naming rules.
- `"S3KeyPrefix"`: Specifies the Amazon S3 key prefix that comes after the name of the
  bucket you have designated for log file delivery. For more information, see Finding Your
  CloudTrail Log Files. The maximum length is 200 characters.
- `"SnsTopicName"`: Specifies the name of the Amazon SNS topic defined for notification of
  log file delivery. The maximum length is 256 characters.
"""
function update_trail(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudtrail(
        "UpdateTrail",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_trail(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudtrail(
        "UpdateTrail",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: efs
using AWS.Compat
using AWS.UUIDs

"""
    create_access_point(client_token, file_system_id)
    create_access_point(client_token, file_system_id, params::Dict{String,<:Any})

Creates an EFS access point. An access point is an application-specific view into an EFS
file system that applies an operating system user and group, and a file system path, to any
file system request made through the access point. The operating system user and group
override any identity information provided by the NFS client. The file system path is
exposed as the access point's root directory. Applications using the access point can only
access data in the application's own directory and any subdirectories. To learn more, see
Mounting a file system using EFS access points.  If multiple requests to create access
points on the same file system are sent in quick succession, and the file system is near
the limit of 1,000 access points, you may experience a throttling response for these
requests. This is to ensure that the file system does not exceed the stated access point
limit.  This operation requires permissions for the elasticfilesystem:CreateAccessPoint
action. Access points can be tagged on creation. If tags are specified in the creation
action, IAM performs additional authorization on the elasticfilesystem:TagResource action
to verify if users have permissions to create tags. Therefore, you must grant explicit
permissions to use the elasticfilesystem:TagResource action. For more information, see
Granting permissions to tag resources during creation.

# Arguments
- `client_token`: A string of up to 64 ASCII characters that Amazon EFS uses to ensure
  idempotent creation.
- `file_system_id`: The ID of the EFS file system that the access point provides access to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"PosixUser"`: The operating system user and group applied to all file system requests
  made using the access point.
- `"RootDirectory"`: Specifies the directory on the EFS file system that the access point
  exposes as the root directory of your file system to NFS clients using the access point.
  The clients using the access point can only access the root directory and below. If the
  RootDirectory &gt; Path specified does not exist, Amazon EFS creates it and applies the
  CreationInfo settings when a client connects to an access point. When specifying a
  RootDirectory, you must provide the Path, and the CreationInfo. Amazon EFS creates a root
  directory only if you have provided the CreationInfo: OwnUid, OwnGID, and permissions for
  the directory. If you do not provide this information, Amazon EFS does not create the root
  directory. If the root directory does not exist, attempts to mount using the access point
  will fail.
- `"Tags"`: Creates tags associated with the access point. Each tag is a key-value pair,
  each key must be unique. For more information, see Tagging Amazon Web Services resources in
  the Amazon Web Services General Reference Guide.
"""
function create_access_point(
    ClientToken, FileSystemId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return efs(
        "POST",
        "/2015-02-01/access-points",
        Dict{String,Any}("ClientToken" => ClientToken, "FileSystemId" => FileSystemId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_access_point(
    ClientToken,
    FileSystemId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return efs(
        "POST",
        "/2015-02-01/access-points",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClientToken" => ClientToken, "FileSystemId" => FileSystemId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_file_system(creation_token)
    create_file_system(creation_token, params::Dict{String,<:Any})

Creates a new, empty file system. The operation requires a creation token in the request
that Amazon EFS uses to ensure idempotent creation (calling the operation with same
creation token has no effect). If a file system does not currently exist that is owned by
the caller's Amazon Web Services account with the specified creation token, this operation
does the following:   Creates a new, empty file system. The file system will have an Amazon
EFS assigned ID, and an initial lifecycle state creating.   Returns with the description of
the created file system.   Otherwise, this operation returns a FileSystemAlreadyExists
error with the ID of the existing file system.  For basic use cases, you can use a randomly
generated UUID for the creation token.  The idempotent operation allows you to retry a
CreateFileSystem call without risk of creating an extra file system. This can happen when
an initial call fails in a way that leaves it uncertain whether or not a file system was
actually created. An example might be that a transport level timeout occurred or your
connection was reset. As long as you use the same creation token, if the initial call had
succeeded in creating a file system, the client can learn of its existence from the
FileSystemAlreadyExists error. For more information, see Creating a file system in the
Amazon EFS User Guide.  The CreateFileSystem call returns while the file system's lifecycle
state is still creating. You can check the file system creation status by calling the
DescribeFileSystems operation, which among other things returns the file system state.
This operation accepts an optional PerformanceMode parameter that you choose for your file
system. We recommend generalPurpose performance mode for all file systems. File systems
using the maxIO mode is a previous generation performance type that is designed for highly
parallelized workloads that can tolerate higher latencies than the General Purpose mode.
Max I/O mode is not supported for One Zone file systems or file systems that use Elastic
throughput.  Due to the higher per-operation latencies with Max I/O, we recommend using
General Purpose performance mode for all file systems.  The performance mode can't be
changed after the file system has been created. For more information, see Amazon EFS
performance modes. You can set the throughput mode for the file system using the
ThroughputMode parameter. After the file system is fully created, Amazon EFS sets its
lifecycle state to available, at which point you can create one or more mount targets for
the file system in your VPC. For more information, see CreateMountTarget. You mount your
Amazon EFS file system on an EC2 instances in your VPC by using the mount target. For more
information, see Amazon EFS: How it Works.  This operation requires permissions for the
elasticfilesystem:CreateFileSystem action.  File systems can be tagged on creation. If tags
are specified in the creation action, IAM performs additional authorization on the
elasticfilesystem:TagResource action to verify if users have permissions to create tags.
Therefore, you must grant explicit permissions to use the elasticfilesystem:TagResource
action. For more information, see Granting permissions to tag resources during creation.

# Arguments
- `creation_token`: A string of up to 64 ASCII characters. Amazon EFS uses this to ensure
  idempotent creation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AvailabilityZoneName"`: Used to create a One Zone file system. It specifies the Amazon
  Web Services Availability Zone in which to create the file system. Use the format
  us-east-1a to specify the Availability Zone. For more information about One Zone file
  systems, see Using EFS storage classes in the Amazon EFS User Guide.  One Zone file systems
  are not available in all Availability Zones in Amazon Web Services Regions where Amazon EFS
  is available.
- `"Backup"`: Specifies whether automatic backups are enabled on the file system that you
  are creating. Set the value to true to enable automatic backups. If you are creating a One
  Zone file system, automatic backups are enabled by default. For more information, see
  Automatic backups in the Amazon EFS User Guide. Default is false. However, if you specify
  an AvailabilityZoneName, the default is true.  Backup is not available in all Amazon Web
  Services Regions where Amazon EFS is available.
- `"Encrypted"`: A Boolean value that, if true, creates an encrypted file system. When
  creating an encrypted file system, you have the option of specifying an existing Key
  Management Service key (KMS key). If you don't specify a KMS key, then the default KMS key
  for Amazon EFS, /aws/elasticfilesystem, is used to protect the encrypted file system.
- `"KmsKeyId"`: The ID of the KMS key that you want to use to protect the encrypted file
  system. This parameter is required only if you want to use a non-default KMS key. If this
  parameter is not specified, the default KMS key for Amazon EFS is used. You can specify a
  KMS key ID using the following formats:   Key ID - A unique identifier of the key, for
  example 1234abcd-12ab-34cd-56ef-1234567890ab.   ARN - An Amazon Resource Name (ARN) for the
  key, for example
  arn:aws:kms:us-west-2:111122223333:key/1234abcd-12ab-34cd-56ef-1234567890ab.   Key alias -
  A previously created display name for a key, for example alias/projectKey1.   Key alias ARN
  - An ARN for a key alias, for example arn:aws:kms:us-west-2:444455556666:alias/projectKey1.
    If you use KmsKeyId, you must set the CreateFileSystemRequestEncrypted parameter to true.
   EFS accepts only symmetric KMS keys. You cannot use asymmetric KMS keys with Amazon EFS
  file systems.
- `"PerformanceMode"`: The Performance mode of the file system. We recommend generalPurpose
  performance mode for all file systems. File systems using the maxIO performance mode can
  scale to higher levels of aggregate throughput and operations per second with a tradeoff of
  slightly higher latencies for most file operations. The performance mode can't be changed
  after the file system has been created. The maxIO mode is not supported on One Zone file
  systems.  Due to the higher per-operation latencies with Max I/O, we recommend using
  General Purpose performance mode for all file systems.  Default is generalPurpose.
- `"ProvisionedThroughputInMibps"`: The throughput, measured in mebibytes per second
  (MiBps), that you want to provision for a file system that you're creating. Required if
  ThroughputMode is set to provisioned. Valid values are 1-3414 MiBps, with the upper limit
  depending on Region. To increase this limit, contact Amazon Web Services Support. For more
  information, see Amazon EFS quotas that you can increase in the Amazon EFS User Guide.
- `"Tags"`: Use to create one or more tags associated with the file system. Each tag is a
  user-defined key-value pair. Name your file system on creation by including a
  \"Key\":\"Name\",\"Value\":\"{value}\" key-value pair. Each key must be unique. For more
  information, see Tagging Amazon Web Services resources in the Amazon Web Services General
  Reference Guide.
- `"ThroughputMode"`: Specifies the throughput mode for the file system. The mode can be
  bursting, provisioned, or elastic. If you set ThroughputMode to provisioned, you must also
  set a value for ProvisionedThroughputInMibps. After you create the file system, you can
  decrease your file system's Provisioned throughput or change between the throughput modes,
  with certain time restrictions. For more information, see Specifying throughput with
  provisioned mode in the Amazon EFS User Guide.  Default is bursting.
"""
function create_file_system(
    CreationToken; aws_config::AbstractAWSConfig=current_aws_config()
)
    return efs(
        "POST",
        "/2015-02-01/file-systems",
        Dict{String,Any}("CreationToken" => CreationToken);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_file_system(
    CreationToken,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return efs(
        "POST",
        "/2015-02-01/file-systems",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("CreationToken" => CreationToken), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_mount_target(file_system_id, subnet_id)
    create_mount_target(file_system_id, subnet_id, params::Dict{String,<:Any})

Creates a mount target for a file system. You can then mount the file system on EC2
instances by using the mount target. You can create one mount target in each Availability
Zone in your VPC. All EC2 instances in a VPC within a given Availability Zone share a
single mount target for a given file system. If you have multiple subnets in an
Availability Zone, you create a mount target in one of the subnets. EC2 instances do not
need to be in the same subnet as the mount target in order to access their file system. You
can create only one mount target for a One Zone file system. You must create that mount
target in the same Availability Zone in which the file system is located. Use the
AvailabilityZoneName and AvailabiltyZoneId properties in the DescribeFileSystems response
object to get this information. Use the subnetId associated with the file system's
Availability Zone when creating the mount target. For more information, see Amazon EFS: How
it Works.  To create a mount target for a file system, the file system's lifecycle state
must be available. For more information, see DescribeFileSystems. In the request, provide
the following:   The file system ID for which you are creating the mount target.   A subnet
ID, which determines the following:   The VPC in which Amazon EFS creates the mount target
 The Availability Zone in which Amazon EFS creates the mount target   The IP address range
from which Amazon EFS selects the IP address of the mount target (if you don't specify an
IP address in the request)     After creating the mount target, Amazon EFS returns a
response that includes, a MountTargetId and an IpAddress. You use this IP address when
mounting the file system in an EC2 instance. You can also use the mount target's DNS name
when mounting the file system. The EC2 instance on which you mount the file system by using
the mount target can resolve the mount target's DNS name to its IP address. For more
information, see How it Works: Implementation Overview.  Note that you can create mount
targets for a file system in only one VPC, and there can be only one mount target per
Availability Zone. That is, if the file system already has one or more mount targets
created for it, the subnet specified in the request to add another mount target must meet
the following requirements:   Must belong to the same VPC as the subnets of the existing
mount targets   Must not be in the same Availability Zone as any of the subnets of the
existing mount targets   If the request satisfies the requirements, Amazon EFS does the
following:   Creates a new mount target in the specified subnet.   Also creates a new
network interface in the subnet as follows:   If the request provides an IpAddress, Amazon
EFS assigns that IP address to the network interface. Otherwise, Amazon EFS assigns a free
address in the subnet (in the same way that the Amazon EC2 CreateNetworkInterface call does
when a request does not specify a primary private IP address).   If the request provides
SecurityGroups, this network interface is associated with those security groups. Otherwise,
it belongs to the default security group for the subnet's VPC.   Assigns the description
Mount target fsmt-id for file system fs-id  where  fsmt-id  is the mount target ID, and
fs-id  is the FileSystemId.   Sets the requesterManaged property of the network interface
to true, and the requesterId value to EFS.   Each Amazon EFS mount target has one
corresponding requester-managed EC2 network interface. After the network interface is
created, Amazon EFS sets the NetworkInterfaceId field in the mount target's description to
the network interface ID, and the IpAddress field to its address. If network interface
creation fails, the entire CreateMountTarget operation fails.    The CreateMountTarget call
returns only after creating the network interface, but while the mount target state is
still creating, you can check the mount target creation status by calling the
DescribeMountTargets operation, which among other things returns the mount target state.
We recommend that you create a mount target in each of the Availability Zones. There are
cost considerations for using a file system in an Availability Zone through a mount target
created in another Availability Zone. For more information, see Amazon EFS. In addition, by
always using a mount target local to the instance's Availability Zone, you eliminate a
partial failure scenario. If the Availability Zone in which your mount target is created
goes down, then you can't access your file system through that mount target.  This
operation requires permissions for the following action on the file system:
elasticfilesystem:CreateMountTarget    This operation also requires permissions for the
following Amazon EC2 actions:    ec2:DescribeSubnets     ec2:DescribeNetworkInterfaces
ec2:CreateNetworkInterface

# Arguments
- `file_system_id`: The ID of the file system for which to create the mount target.
- `subnet_id`: The ID of the subnet to add the mount target in. For One Zone file systems,
  use the subnet that is associated with the file system's Availability Zone.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"IpAddress"`: Valid IPv4 address within the address range of the specified subnet.
- `"SecurityGroups"`: Up to five VPC security group IDs, of the form sg-xxxxxxxx. These
  must be for the same VPC as subnet specified.
"""
function create_mount_target(
    FileSystemId, SubnetId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return efs(
        "POST",
        "/2015-02-01/mount-targets",
        Dict{String,Any}("FileSystemId" => FileSystemId, "SubnetId" => SubnetId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_mount_target(
    FileSystemId,
    SubnetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return efs(
        "POST",
        "/2015-02-01/mount-targets",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("FileSystemId" => FileSystemId, "SubnetId" => SubnetId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_replication_configuration(destinations, source_file_system_id)
    create_replication_configuration(destinations, source_file_system_id, params::Dict{String,<:Any})

Creates a replication configuration that replicates an existing EFS file system to a new,
read-only file system. For more information, see Amazon EFS replication in the Amazon EFS
User Guide. The replication configuration specifies the following:    Source file system
– The EFS file system that you want replicated. The source file system cannot be a
destination file system in an existing replication configuration.    Amazon Web Services
Region – The Amazon Web Services Region in which the destination file system is created.
Amazon EFS replication is available in all Amazon Web Services Regions in which EFS is
available. The Region must be enabled. For more information, see Managing Amazon Web
Services Regions in the Amazon Web Services General Reference Reference Guide.
Destination file system configuration – The configuration of the destination file system
to which the source file system will be replicated. There can only be one destination file
system in a replication configuration.  Parameters for the replication configuration
include:    File system ID – The ID of the destination file system for the replication.
If no ID is provided, then EFS creates a new file system with the default settings. For
existing file systems, the file system's replication overwrite protection must be disabled.
For more information, see  Replicating to an existing file system.    Availability Zone –
If you want the destination file system to use One Zone storage, you must specify the
Availability Zone to create the file system in. For more information, see  EFS file system
types in the Amazon EFS User Guide.    Encryption – All destination file systems are
created with encryption at rest enabled. You can specify the Key Management Service (KMS)
key that is used to encrypt the destination file system. If you don't specify a KMS key,
your service-managed KMS key for Amazon EFS is used.   After the file system is created,
you cannot change the KMS key.       After the file system is created, you cannot change
the KMS key.  For new destination file systems, the following properties are set by
default:    Performance mode - The destination file system's performance mode matches that
of the source file system, unless the destination file system uses EFS One Zone storage. In
that case, the General Purpose performance mode is used. The performance mode cannot be
changed.    Throughput mode - The destination file system's throughput mode matches that of
the source file system. After the file system is created, you can modify the throughput
mode.      Lifecycle management – Lifecycle management is not enabled on the destination
file system. After the destination file system is created, you can enable lifecycle
management.    Automatic backups – Automatic daily backups are enabled on the destination
file system. After the file system is created, you can change this setting.   For more
information, see Amazon EFS replication in the Amazon EFS User Guide.

# Arguments
- `destinations`: An array of destination configuration objects. Only one destination
  configuration object is supported.
- `source_file_system_id`: Specifies the Amazon EFS file system that you want to replicate.
  This file system cannot already be a source or destination file system in another
  replication configuration.

"""
function create_replication_configuration(
    Destinations, SourceFileSystemId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return efs(
        "POST",
        "/2015-02-01/file-systems/$(SourceFileSystemId)/replication-configuration",
        Dict{String,Any}("Destinations" => Destinations);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_replication_configuration(
    Destinations,
    SourceFileSystemId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return efs(
        "POST",
        "/2015-02-01/file-systems/$(SourceFileSystemId)/replication-configuration",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Destinations" => Destinations), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_tags(file_system_id, tags)
    create_tags(file_system_id, tags, params::Dict{String,<:Any})

 DEPRECATED - CreateTags is deprecated and not maintained. To create tags for EFS
resources, use the API action.  Creates or overwrites tags associated with a file system.
Each tag is a key-value pair. If a tag key specified in the request already exists on the
file system, this operation overwrites its value with the value provided in the request. If
you add the Name tag to your file system, Amazon EFS returns it in the response to the
DescribeFileSystems operation.  This operation requires permission for the
elasticfilesystem:CreateTags action.

# Arguments
- `file_system_id`: The ID of the file system whose tags you want to modify (String). This
  operation modifies the tags only, not the file system.
- `tags`: An array of Tag objects to add. Each Tag object is a key-value pair.

"""
function create_tags(FileSystemId, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return efs(
        "POST",
        "/2015-02-01/create-tags/$(FileSystemId)",
        Dict{String,Any}("Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_tags(
    FileSystemId,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return efs(
        "POST",
        "/2015-02-01/create-tags/$(FileSystemId)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Tags" => Tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_access_point(access_point_id)
    delete_access_point(access_point_id, params::Dict{String,<:Any})

Deletes the specified access point. After deletion is complete, new clients can no longer
connect to the access points. Clients connected to the access point at the time of deletion
will continue to function until they terminate their connection. This operation requires
permissions for the elasticfilesystem:DeleteAccessPoint action.

# Arguments
- `access_point_id`: The ID of the access point that you want to delete.

"""
function delete_access_point(
    AccessPointId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return efs(
        "DELETE",
        "/2015-02-01/access-points/$(AccessPointId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_access_point(
    AccessPointId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return efs(
        "DELETE",
        "/2015-02-01/access-points/$(AccessPointId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_file_system(file_system_id)
    delete_file_system(file_system_id, params::Dict{String,<:Any})

Deletes a file system, permanently severing access to its contents. Upon return, the file
system no longer exists and you can't access any contents of the deleted file system. You
need to manually delete mount targets attached to a file system before you can delete an
EFS file system. This step is performed for you when you use the Amazon Web Services
console to delete a file system.  You cannot delete a file system that is part of an EFS
Replication configuration. You need to delete the replication configuration first.   You
can't delete a file system that is in use. That is, if the file system has any mount
targets, you must first delete them. For more information, see DescribeMountTargets and
DeleteMountTarget.   The DeleteFileSystem call returns while the file system state is still
deleting. You can check the file system deletion status by calling the DescribeFileSystems
operation, which returns a list of file systems in your account. If you pass file system ID
or creation token for the deleted file system, the DescribeFileSystems returns a 404
FileSystemNotFound error.  This operation requires permissions for the
elasticfilesystem:DeleteFileSystem action.

# Arguments
- `file_system_id`: The ID of the file system you want to delete.

"""
function delete_file_system(
    FileSystemId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return efs(
        "DELETE",
        "/2015-02-01/file-systems/$(FileSystemId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_file_system(
    FileSystemId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return efs(
        "DELETE",
        "/2015-02-01/file-systems/$(FileSystemId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_file_system_policy(file_system_id)
    delete_file_system_policy(file_system_id, params::Dict{String,<:Any})

Deletes the FileSystemPolicy for the specified file system. The default FileSystemPolicy
goes into effect once the existing policy is deleted. For more information about the
default file system policy, see Using Resource-based Policies with EFS. This operation
requires permissions for the elasticfilesystem:DeleteFileSystemPolicy action.

# Arguments
- `file_system_id`: Specifies the EFS file system for which to delete the FileSystemPolicy.

"""
function delete_file_system_policy(
    FileSystemId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return efs(
        "DELETE",
        "/2015-02-01/file-systems/$(FileSystemId)/policy";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_file_system_policy(
    FileSystemId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return efs(
        "DELETE",
        "/2015-02-01/file-systems/$(FileSystemId)/policy",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_mount_target(mount_target_id)
    delete_mount_target(mount_target_id, params::Dict{String,<:Any})

Deletes the specified mount target. This operation forcibly breaks any mounts of the file
system by using the mount target that is being deleted, which might disrupt instances or
applications using those mounts. To avoid applications getting cut off abruptly, you might
consider unmounting any mounts of the mount target, if feasible. The operation also deletes
the associated network interface. Uncommitted writes might be lost, but breaking a mount
target using this operation does not corrupt the file system itself. The file system you
created remains. You can mount an EC2 instance in your VPC by using another mount target.
This operation requires permissions for the following action on the file system:
elasticfilesystem:DeleteMountTarget     The DeleteMountTarget call returns while the mount
target state is still deleting. You can check the mount target deletion by calling the
DescribeMountTargets operation, which returns a list of mount target descriptions for the
given file system.   The operation also requires permissions for the following Amazon EC2
action on the mount target's network interface:    ec2:DeleteNetworkInterface

# Arguments
- `mount_target_id`: The ID of the mount target to delete (String).

"""
function delete_mount_target(
    MountTargetId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return efs(
        "DELETE",
        "/2015-02-01/mount-targets/$(MountTargetId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_mount_target(
    MountTargetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return efs(
        "DELETE",
        "/2015-02-01/mount-targets/$(MountTargetId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_replication_configuration(source_file_system_id)
    delete_replication_configuration(source_file_system_id, params::Dict{String,<:Any})

Deletes a replication configuration. Deleting a replication configuration ends the
replication process. After a replication configuration is deleted, the destination file
system becomes Writeable and its replication overwrite protection is re-enabled. For more
information, see Delete a replication configuration. This operation requires permissions
for the elasticfilesystem:DeleteReplicationConfiguration action.

# Arguments
- `source_file_system_id`: The ID of the source file system in the replication
  configuration.

"""
function delete_replication_configuration(
    SourceFileSystemId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return efs(
        "DELETE",
        "/2015-02-01/file-systems/$(SourceFileSystemId)/replication-configuration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_replication_configuration(
    SourceFileSystemId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return efs(
        "DELETE",
        "/2015-02-01/file-systems/$(SourceFileSystemId)/replication-configuration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_tags(file_system_id, tag_keys)
    delete_tags(file_system_id, tag_keys, params::Dict{String,<:Any})

 DEPRECATED - DeleteTags is deprecated and not maintained. To remove tags from EFS
resources, use the API action.  Deletes the specified tags from a file system. If the
DeleteTags request includes a tag key that doesn't exist, Amazon EFS ignores it and doesn't
cause an error. For more information about tags and related restrictions, see Tag
restrictions in the Billing and Cost Management User Guide. This operation requires
permissions for the elasticfilesystem:DeleteTags action.

# Arguments
- `file_system_id`: The ID of the file system whose tags you want to delete (String).
- `tag_keys`: A list of tag keys to delete.

"""
function delete_tags(
    FileSystemId, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return efs(
        "POST",
        "/2015-02-01/delete-tags/$(FileSystemId)",
        Dict{String,Any}("TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_tags(
    FileSystemId,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return efs(
        "POST",
        "/2015-02-01/delete-tags/$(FileSystemId)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("TagKeys" => TagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_access_points()
    describe_access_points(params::Dict{String,<:Any})

Returns the description of a specific Amazon EFS access point if the AccessPointId is
provided. If you provide an EFS FileSystemId, it returns descriptions of all access points
for that file system. You can provide either an AccessPointId or a FileSystemId in the
request, but not both.  This operation requires permissions for the
elasticfilesystem:DescribeAccessPoints action.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccessPointId"`: (Optional) Specifies an EFS access point to describe in the response;
  mutually exclusive with FileSystemId.
- `"FileSystemId"`: (Optional) If you provide a FileSystemId, EFS returns all access points
  for that file system; mutually exclusive with AccessPointId.
- `"MaxResults"`: (Optional) When retrieving all access points for a file system, you can
  optionally specify the MaxItems parameter to limit the number of objects returned in a
  response. The default value is 100.
- `"NextToken"`:  NextToken is present if the response is paginated. You can use NextMarker
  in the subsequent request to fetch the next page of access point descriptions.
"""
function describe_access_points(; aws_config::AbstractAWSConfig=current_aws_config())
    return efs(
        "GET",
        "/2015-02-01/access-points";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_access_points(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return efs(
        "GET",
        "/2015-02-01/access-points",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_account_preferences()
    describe_account_preferences(params::Dict{String,<:Any})

Returns the account preferences settings for the Amazon Web Services account associated
with the user making the request, in the current Amazon Web Services Region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: (Optional) When retrieving account preferences, you can optionally
  specify the MaxItems parameter to limit the number of objects returned in a response. The
  default value is 100.
- `"NextToken"`: (Optional) You can use NextToken in a subsequent request to fetch the next
  page of Amazon Web Services account preferences if the response payload was paginated.
"""
function describe_account_preferences(; aws_config::AbstractAWSConfig=current_aws_config())
    return efs(
        "GET",
        "/2015-02-01/account-preferences";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_account_preferences(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return efs(
        "GET",
        "/2015-02-01/account-preferences",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_backup_policy(file_system_id)
    describe_backup_policy(file_system_id, params::Dict{String,<:Any})

Returns the backup policy for the specified EFS file system.

# Arguments
- `file_system_id`: Specifies which EFS file system for which to retrieve the BackupPolicy.

"""
function describe_backup_policy(
    FileSystemId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return efs(
        "GET",
        "/2015-02-01/file-systems/$(FileSystemId)/backup-policy";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_backup_policy(
    FileSystemId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return efs(
        "GET",
        "/2015-02-01/file-systems/$(FileSystemId)/backup-policy",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_file_system_policy(file_system_id)
    describe_file_system_policy(file_system_id, params::Dict{String,<:Any})

Returns the FileSystemPolicy for the specified EFS file system. This operation requires
permissions for the elasticfilesystem:DescribeFileSystemPolicy action.

# Arguments
- `file_system_id`: Specifies which EFS file system to retrieve the FileSystemPolicy for.

"""
function describe_file_system_policy(
    FileSystemId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return efs(
        "GET",
        "/2015-02-01/file-systems/$(FileSystemId)/policy";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_file_system_policy(
    FileSystemId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return efs(
        "GET",
        "/2015-02-01/file-systems/$(FileSystemId)/policy",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_file_systems()
    describe_file_systems(params::Dict{String,<:Any})

Returns the description of a specific Amazon EFS file system if either the file system
CreationToken or the FileSystemId is provided. Otherwise, it returns descriptions of all
file systems owned by the caller's Amazon Web Services account in the Amazon Web Services
Region of the endpoint that you're calling. When retrieving all file system descriptions,
you can optionally specify the MaxItems parameter to limit the number of descriptions in a
response. This number is automatically set to 100. If more file system descriptions remain,
Amazon EFS returns a NextMarker, an opaque token, in the response. In this case, you should
send a subsequent request with the Marker request parameter set to the value of NextMarker.
 To retrieve a list of your file system descriptions, this operation is used in an
iterative process, where DescribeFileSystems is called first without the Marker and then
the operation continues to call it with the Marker parameter set to the value of the
NextMarker from the previous response until the response has no NextMarker.   The order of
file systems returned in the response of one DescribeFileSystems call and the order of file
systems returned across the responses of a multi-call iteration is unspecified.   This
operation requires permissions for the elasticfilesystem:DescribeFileSystems action.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CreationToken"`: (Optional) Restricts the list to the file system with this creation
  token (String). You specify a creation token when you create an Amazon EFS file system.
- `"FileSystemId"`: (Optional) ID of the file system whose description you want to retrieve
  (String).
- `"Marker"`: (Optional) Opaque pagination token returned from a previous
  DescribeFileSystems operation (String). If present, specifies to continue the list from
  where the returning call had left off.
- `"MaxItems"`: (Optional) Specifies the maximum number of file systems to return in the
  response (integer). This number is automatically set to 100. The response is paginated at
  100 per page if you have more than 100 file systems.
"""
function describe_file_systems(; aws_config::AbstractAWSConfig=current_aws_config())
    return efs(
        "GET",
        "/2015-02-01/file-systems";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_file_systems(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return efs(
        "GET",
        "/2015-02-01/file-systems",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_lifecycle_configuration(file_system_id)
    describe_lifecycle_configuration(file_system_id, params::Dict{String,<:Any})

Returns the current LifecycleConfiguration object for the specified Amazon EFS file system.
Lifecycle management uses the LifecycleConfiguration object to identify when to move files
between storage classes. For a file system without a LifecycleConfiguration object, the
call returns an empty array in the response. This operation requires permissions for the
elasticfilesystem:DescribeLifecycleConfiguration operation.

# Arguments
- `file_system_id`: The ID of the file system whose LifecycleConfiguration object you want
  to retrieve (String).

"""
function describe_lifecycle_configuration(
    FileSystemId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return efs(
        "GET",
        "/2015-02-01/file-systems/$(FileSystemId)/lifecycle-configuration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_lifecycle_configuration(
    FileSystemId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return efs(
        "GET",
        "/2015-02-01/file-systems/$(FileSystemId)/lifecycle-configuration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_mount_target_security_groups(mount_target_id)
    describe_mount_target_security_groups(mount_target_id, params::Dict{String,<:Any})

Returns the security groups currently in effect for a mount target. This operation requires
that the network interface of the mount target has been created and the lifecycle state of
the mount target is not deleted. This operation requires permissions for the following
actions:    elasticfilesystem:DescribeMountTargetSecurityGroups action on the mount
target's file system.     ec2:DescribeNetworkInterfaceAttribute action on the mount
target's network interface.

# Arguments
- `mount_target_id`: The ID of the mount target whose security groups you want to retrieve.

"""
function describe_mount_target_security_groups(
    MountTargetId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return efs(
        "GET",
        "/2015-02-01/mount-targets/$(MountTargetId)/security-groups";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_mount_target_security_groups(
    MountTargetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return efs(
        "GET",
        "/2015-02-01/mount-targets/$(MountTargetId)/security-groups",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_mount_targets()
    describe_mount_targets(params::Dict{String,<:Any})

Returns the descriptions of all the current mount targets, or a specific mount target, for
a file system. When requesting all of the current mount targets, the order of mount targets
returned in the response is unspecified. This operation requires permissions for the
elasticfilesystem:DescribeMountTargets action, on either the file system ID that you
specify in FileSystemId, or on the file system of the mount target that you specify in
MountTargetId.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccessPointId"`: (Optional) The ID of the access point whose mount targets that you
  want to list. It must be included in your request if a FileSystemId or MountTargetId is not
  included in your request. Accepts either an access point ID or ARN as input.
- `"FileSystemId"`: (Optional) ID of the file system whose mount targets you want to list
  (String). It must be included in your request if an AccessPointId or MountTargetId is not
  included. Accepts either a file system ID or ARN as input.
- `"Marker"`: (Optional) Opaque pagination token returned from a previous
  DescribeMountTargets operation (String). If present, it specifies to continue the list from
  where the previous returning call left off.
- `"MaxItems"`: (Optional) Maximum number of mount targets to return in the response.
  Currently, this number is automatically set to 10, and other values are ignored. The
  response is paginated at 100 per page if you have more than 100 mount targets.
- `"MountTargetId"`: (Optional) ID of the mount target that you want to have described
  (String). It must be included in your request if FileSystemId is not included. Accepts
  either a mount target ID or ARN as input.
"""
function describe_mount_targets(; aws_config::AbstractAWSConfig=current_aws_config())
    return efs(
        "GET",
        "/2015-02-01/mount-targets";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_mount_targets(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return efs(
        "GET",
        "/2015-02-01/mount-targets",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_replication_configurations()
    describe_replication_configurations(params::Dict{String,<:Any})

Retrieves the replication configuration for a specific file system. If a file system is not
specified, all of the replication configurations for the Amazon Web Services account in an
Amazon Web Services Region are retrieved.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FileSystemId"`: You can retrieve the replication configuration for a specific file
  system by providing its file system ID.
- `"MaxResults"`: (Optional) To limit the number of objects returned in a response, you can
  specify the MaxItems parameter. The default value is 100.
- `"NextToken"`:  NextToken is present if the response is paginated. You can use NextToken
  in a subsequent request to fetch the next page of output.
"""
function describe_replication_configurations(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return efs(
        "GET",
        "/2015-02-01/file-systems/replication-configurations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_replication_configurations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return efs(
        "GET",
        "/2015-02-01/file-systems/replication-configurations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_tags(file_system_id)
    describe_tags(file_system_id, params::Dict{String,<:Any})

 DEPRECATED - The DescribeTags action is deprecated and not maintained. To view tags
associated with EFS resources, use the ListTagsForResource API action.  Returns the tags
associated with a file system. The order of tags returned in the response of one
DescribeTags call and the order of tags returned across the responses of a multiple-call
iteration (when using pagination) is unspecified.   This operation requires permissions for
the elasticfilesystem:DescribeTags action.

# Arguments
- `file_system_id`: The ID of the file system whose tag set you want to retrieve.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Marker"`: (Optional) An opaque pagination token returned from a previous DescribeTags
  operation (String). If present, it specifies to continue the list from where the previous
  call left off.
- `"MaxItems"`: (Optional) The maximum number of file system tags to return in the
  response. Currently, this number is automatically set to 100, and other values are ignored.
  The response is paginated at 100 per page if you have more than 100 tags.
"""
function describe_tags(FileSystemId; aws_config::AbstractAWSConfig=current_aws_config())
    return efs(
        "GET",
        "/2015-02-01/tags/$(FileSystemId)/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_tags(
    FileSystemId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return efs(
        "GET",
        "/2015-02-01/tags/$(FileSystemId)/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_id)
    list_tags_for_resource(resource_id, params::Dict{String,<:Any})

Lists all tags for a top-level EFS resource. You must provide the ID of the resource that
you want to retrieve the tags for. This operation requires permissions for the
elasticfilesystem:DescribeAccessPoints action.

# Arguments
- `resource_id`: Specifies the EFS resource you want to retrieve tags for. You can retrieve
  tags for EFS file systems and access points using this API endpoint.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: (Optional) Specifies the maximum number of tag objects to return in the
  response. The default value is 100.
- `"NextToken"`: (Optional) You can use NextToken in a subsequent request to fetch the next
  page of access point descriptions if the response payload was paginated.
"""
function list_tags_for_resource(
    ResourceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return efs(
        "GET",
        "/2015-02-01/resource-tags/$(ResourceId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return efs(
        "GET",
        "/2015-02-01/resource-tags/$(ResourceId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    modify_mount_target_security_groups(mount_target_id)
    modify_mount_target_security_groups(mount_target_id, params::Dict{String,<:Any})

Modifies the set of security groups in effect for a mount target. When you create a mount
target, Amazon EFS also creates a new network interface. For more information, see
CreateMountTarget. This operation replaces the security groups in effect for the network
interface associated with a mount target, with the SecurityGroups provided in the request.
This operation requires that the network interface of the mount target has been created and
the lifecycle state of the mount target is not deleted.  The operation requires permissions
for the following actions:    elasticfilesystem:ModifyMountTargetSecurityGroups action on
the mount target's file system.     ec2:ModifyNetworkInterfaceAttribute action on the mount
target's network interface.

# Arguments
- `mount_target_id`: The ID of the mount target whose security groups you want to modify.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"SecurityGroups"`: An array of up to five VPC security group IDs.
"""
function modify_mount_target_security_groups(
    MountTargetId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return efs(
        "PUT",
        "/2015-02-01/mount-targets/$(MountTargetId)/security-groups";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function modify_mount_target_security_groups(
    MountTargetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return efs(
        "PUT",
        "/2015-02-01/mount-targets/$(MountTargetId)/security-groups",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_account_preferences(resource_id_type)
    put_account_preferences(resource_id_type, params::Dict{String,<:Any})

Use this operation to set the account preference in the current Amazon Web Services Region
to use long 17 character (63 bit) or short 8 character (32 bit) resource IDs for new EFS
file system and mount target resources. All existing resource IDs are not affected by any
changes you make. You can set the ID preference during the opt-in period as EFS transitions
to long resource IDs. For more information, see Managing Amazon EFS resource IDs.  Starting
in October, 2021, you will receive an error if you try to set the account preference to use
the short 8 character format resource ID. Contact Amazon Web Services support if you
receive an error and must use short IDs for file system and mount target resources.

# Arguments
- `resource_id_type`: Specifies the EFS resource ID preference to set for the user's Amazon
  Web Services account, in the current Amazon Web Services Region, either LONG_ID (17
  characters), or SHORT_ID (8 characters).  Starting in October, 2021, you will receive an
  error when setting the account preference to SHORT_ID. Contact Amazon Web Services support
  if you receive an error and must use short IDs for file system and mount target resources.

"""
function put_account_preferences(
    ResourceIdType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return efs(
        "PUT",
        "/2015-02-01/account-preferences",
        Dict{String,Any}("ResourceIdType" => ResourceIdType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_account_preferences(
    ResourceIdType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return efs(
        "PUT",
        "/2015-02-01/account-preferences",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceIdType" => ResourceIdType), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_backup_policy(backup_policy, file_system_id)
    put_backup_policy(backup_policy, file_system_id, params::Dict{String,<:Any})

Updates the file system's backup policy. Use this action to start or stop automatic backups
of the file system.

# Arguments
- `backup_policy`: The backup policy included in the PutBackupPolicy request.
- `file_system_id`: Specifies which EFS file system to update the backup policy for.

"""
function put_backup_policy(
    BackupPolicy, FileSystemId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return efs(
        "PUT",
        "/2015-02-01/file-systems/$(FileSystemId)/backup-policy",
        Dict{String,Any}("BackupPolicy" => BackupPolicy);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_backup_policy(
    BackupPolicy,
    FileSystemId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return efs(
        "PUT",
        "/2015-02-01/file-systems/$(FileSystemId)/backup-policy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("BackupPolicy" => BackupPolicy), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_file_system_policy(file_system_id, policy)
    put_file_system_policy(file_system_id, policy, params::Dict{String,<:Any})

Applies an Amazon EFS FileSystemPolicy to an Amazon EFS file system. A file system policy
is an IAM resource-based policy and can contain multiple policy statements. A file system
always has exactly one file system policy, which can be the default policy or an explicit
policy set or updated using this API operation. EFS file system policies have a 20,000
character limit. When an explicit policy is set, it overrides the default policy. For more
information about the default file system policy, see Default EFS File System Policy.   EFS
file system policies have a 20,000 character limit.  This operation requires permissions
for the elasticfilesystem:PutFileSystemPolicy action.

# Arguments
- `file_system_id`: The ID of the EFS file system that you want to create or update the
  FileSystemPolicy for.
- `policy`: The FileSystemPolicy that you're creating. Accepts a JSON formatted policy
  definition. EFS file system policies have a 20,000 character limit. To find out more about
  the elements that make up a file system policy, see EFS Resource-based Policies.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"BypassPolicyLockoutSafetyCheck"`: (Optional) A boolean that specifies whether or not to
  bypass the FileSystemPolicy lockout safety check. The lockout safety check determines
  whether the policy in the request will lock out, or prevent, the IAM principal that is
  making the request from making future PutFileSystemPolicy requests on this file system. Set
  BypassPolicyLockoutSafetyCheck to True only when you intend to prevent the IAM principal
  that is making the request from making subsequent PutFileSystemPolicy requests on this file
  system. The default value is False.
"""
function put_file_system_policy(
    FileSystemId, Policy; aws_config::AbstractAWSConfig=current_aws_config()
)
    return efs(
        "PUT",
        "/2015-02-01/file-systems/$(FileSystemId)/policy",
        Dict{String,Any}("Policy" => Policy);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_file_system_policy(
    FileSystemId,
    Policy,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return efs(
        "PUT",
        "/2015-02-01/file-systems/$(FileSystemId)/policy",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Policy" => Policy), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_lifecycle_configuration(file_system_id, lifecycle_policies)
    put_lifecycle_configuration(file_system_id, lifecycle_policies, params::Dict{String,<:Any})

Use this action to manage storage for your file system. A LifecycleConfiguration consists
of one or more LifecyclePolicy objects that define the following:     TransitionToIA  –
When to move files in the file system from primary storage (Standard storage class) into
the Infrequent Access (IA) storage.     TransitionToArchive  – When to move files in the
file system from their current storage class (either IA or Standard storage) into the
Archive storage. File systems cannot transition into Archive storage before transitioning
into IA storage. Therefore, TransitionToArchive must either not be set or must be later
than TransitionToIA.   The Archive storage class is available only for file systems that
use the Elastic Throughput mode and the General Purpose Performance mode.
TransitionToPrimaryStorageClass  – Whether to move files in the file system back to
primary storage (Standard storage class) after they are accessed in IA or Archive storage.
 For more information, see  Managing file system storage. Each Amazon EFS file system
supports one lifecycle configuration, which applies to all files in the file system. If a
LifecycleConfiguration object already exists for the specified file system, a
PutLifecycleConfiguration call modifies the existing configuration. A
PutLifecycleConfiguration call with an empty LifecyclePolicies array in the request body
deletes any existing LifecycleConfiguration. In the request, specify the following:    The
ID for the file system for which you are enabling, disabling, or modifying Lifecycle
management.   A LifecyclePolicies array of LifecyclePolicy objects that define when to move
files to IA storage, to Archive storage, and back to primary storage.  Amazon EFS requires
that each LifecyclePolicy object have only have a single transition, so the
LifecyclePolicies array needs to be structured with separate LifecyclePolicy objects. See
the example requests in the following section for more information.    This operation
requires permissions for the elasticfilesystem:PutLifecycleConfiguration operation. To
apply a LifecycleConfiguration object to an encrypted file system, you need the same Key
Management Service permissions as when you created the encrypted file system.

# Arguments
- `file_system_id`: The ID of the file system for which you are creating the
  LifecycleConfiguration object (String).
- `lifecycle_policies`: An array of LifecyclePolicy objects that define the file system's
  LifecycleConfiguration object. A LifecycleConfiguration object informs EFS Lifecycle
  management of the following:     TransitionToIA  – When to move files in the file system
  from primary storage (Standard storage class) into the Infrequent Access (IA) storage.
  TransitionToArchive  – When to move files in the file system from their current storage
  class (either IA or Standard storage) into the Archive storage. File systems cannot
  transition into Archive storage before transitioning into IA storage. Therefore,
  TransitionToArchive must either not be set or must be later than TransitionToIA.   The
  Archive storage class is available only for file systems that use the Elastic Throughput
  mode and the General Purpose Performance mode.       TransitionToPrimaryStorageClass  –
  Whether to move files in the file system back to primary storage (Standard storage class)
  after they are accessed in IA or Archive storage.    When using the
  put-lifecycle-configuration CLI command or the PutLifecycleConfiguration API action, Amazon
  EFS requires that each LifecyclePolicy object have only a single transition. This means
  that in a request body, LifecyclePolicies must be structured as an array of LifecyclePolicy
  objects, one object for each storage transition. See the example requests in the following
  section for more information.

"""
function put_lifecycle_configuration(
    FileSystemId, LifecyclePolicies; aws_config::AbstractAWSConfig=current_aws_config()
)
    return efs(
        "PUT",
        "/2015-02-01/file-systems/$(FileSystemId)/lifecycle-configuration",
        Dict{String,Any}("LifecyclePolicies" => LifecyclePolicies);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_lifecycle_configuration(
    FileSystemId,
    LifecyclePolicies,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return efs(
        "PUT",
        "/2015-02-01/file-systems/$(FileSystemId)/lifecycle-configuration",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("LifecyclePolicies" => LifecyclePolicies), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_id, tags)
    tag_resource(resource_id, tags, params::Dict{String,<:Any})

Creates a tag for an EFS resource. You can create tags for EFS file systems and access
points using this API operation. This operation requires permissions for the
elasticfilesystem:TagResource action.

# Arguments
- `resource_id`: The ID specifying the EFS resource that you want to create a tag for.
- `tags`: An array of Tag objects to add. Each Tag object is a key-value pair.

"""
function tag_resource(ResourceId, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return efs(
        "POST",
        "/2015-02-01/resource-tags/$(ResourceId)",
        Dict{String,Any}("Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceId,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return efs(
        "POST",
        "/2015-02-01/resource-tags/$(ResourceId)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Tags" => Tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_id, tag_keys)
    untag_resource(resource_id, tag_keys, params::Dict{String,<:Any})

Removes tags from an EFS resource. You can remove tags from EFS file systems and access
points using this API operation. This operation requires permissions for the
elasticfilesystem:UntagResource action.

# Arguments
- `resource_id`: Specifies the EFS resource that you want to remove tags from.
- `tag_keys`: The keys of the key-value tag pairs that you want to remove from the
  specified EFS resource.

"""
function untag_resource(
    ResourceId, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return efs(
        "DELETE",
        "/2015-02-01/resource-tags/$(ResourceId)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceId,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return efs(
        "DELETE",
        "/2015-02-01/resource-tags/$(ResourceId)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_file_system(file_system_id)
    update_file_system(file_system_id, params::Dict{String,<:Any})

Updates the throughput mode or the amount of provisioned throughput of an existing file
system.

# Arguments
- `file_system_id`: The ID of the file system that you want to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ProvisionedThroughputInMibps"`: (Optional) The throughput, measured in mebibytes per
  second (MiBps), that you want to provision for a file system that you're creating. Required
  if ThroughputMode is set to provisioned. Valid values are 1-3414 MiBps, with the upper
  limit depending on Region. To increase this limit, contact Amazon Web Services Support. For
  more information, see Amazon EFS quotas that you can increase in the Amazon EFS User Guide.
- `"ThroughputMode"`: (Optional) Updates the file system's throughput mode. If you're not
  updating your throughput mode, you don't need to provide this value in your request. If you
  are changing the ThroughputMode to provisioned, you must also set a value for
  ProvisionedThroughputInMibps.
"""
function update_file_system(
    FileSystemId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return efs(
        "PUT",
        "/2015-02-01/file-systems/$(FileSystemId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_file_system(
    FileSystemId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return efs(
        "PUT",
        "/2015-02-01/file-systems/$(FileSystemId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_file_system_protection(file_system_id)
    update_file_system_protection(file_system_id, params::Dict{String,<:Any})

Updates protection on the file system. This operation requires permissions for the
elasticfilesystem:UpdateFileSystemProtection action.

# Arguments
- `file_system_id`: The ID of the file system to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ReplicationOverwriteProtection"`: The status of the file system's replication overwrite
  protection.    ENABLED – The file system cannot be used as the destination file system in
  a replication configuration. The file system is writeable. Replication overwrite protection
  is ENABLED by default.     DISABLED – The file system can be used as the destination file
  system in a replication configuration. The file system is read-only and can only be
  modified by EFS replication.    REPLICATING – The file system is being used as the
  destination file system in a replication configuration. The file system is read-only and is
  only modified only by EFS replication.   If the replication configuration is deleted, the
  file system's replication overwrite protection is re-enabled, the file system becomes
  writeable.
"""
function update_file_system_protection(
    FileSystemId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return efs(
        "PUT",
        "/2015-02-01/file-systems/$(FileSystemId)/protection";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_file_system_protection(
    FileSystemId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return efs(
        "PUT",
        "/2015-02-01/file-systems/$(FileSystemId)/protection",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: sso_oidc
using AWS.Compat
using AWS.UUIDs

"""
    create_token(client_id, client_secret, grant_type)
    create_token(client_id, client_secret, grant_type, params::Dict{String,<:Any})

Creates and returns access and refresh tokens for clients that are authenticated using
client secrets. The access token can be used to fetch short-term credentials for the
assigned AWS accounts or to access application APIs using bearer authentication.

# Arguments
- `client_id`: The unique identifier string for the client or application. This value comes
  from the result of the RegisterClient API.
- `client_secret`: A secret string generated for the client. This value should come from
  the persisted result of the RegisterClient API.
- `grant_type`: Supports the following OAuth grant types: Device Code and Refresh Token.
  Specify either of the following values, depending on the grant type that you want: * Device
  Code - urn:ietf:params:oauth:grant-type:device_code  * Refresh Token - refresh_token  For
  information about how to obtain the device code, see the StartDeviceAuthorization topic.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"code"`: Used only when calling this API for the Authorization Code grant type. The
  short-term code is used to identify this authorization request. This grant type is
  currently unsupported for the CreateToken API.
- `"codeVerifier"`: Used only when calling this API for the Authorization Code grant type.
  This value is generated by the client and presented to validate the original code challenge
  value the client passed at authorization time.
- `"deviceCode"`: Used only when calling this API for the Device Code grant type. This
  short-term code is used to identify this authorization request. This comes from the result
  of the StartDeviceAuthorization API.
- `"redirectUri"`: Used only when calling this API for the Authorization Code grant type.
  This value specifies the location of the client or application that has registered to
  receive the authorization code.
- `"refreshToken"`: Used only when calling this API for the Refresh Token grant type. This
  token is used to refresh short-term tokens, such as the access token, that might expire.
  For more information about the features and limitations of the current IAM Identity Center
  OIDC implementation, see Considerations for Using this Guide in the IAM Identity Center
  OIDC API Reference.
- `"scope"`: The list of scopes for which authorization is requested. The access token that
  is issued is limited to the scopes that are granted. If this value is not specified, IAM
  Identity Center authorizes all scopes that are configured for the client during the call to
  RegisterClient.
"""
function create_token(
    clientId, clientSecret, grantType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sso_oidc(
        "POST",
        "/token",
        Dict{String,Any}(
            "clientId" => clientId, "clientSecret" => clientSecret, "grantType" => grantType
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_token(
    clientId,
    clientSecret,
    grantType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_oidc(
        "POST",
        "/token",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "clientId" => clientId,
                    "clientSecret" => clientSecret,
                    "grantType" => grantType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_token_with_iam(client_id, grant_type)
    create_token_with_iam(client_id, grant_type, params::Dict{String,<:Any})

Creates and returns access and refresh tokens for clients and applications that are
authenticated using IAM entities. The access token can be used to fetch short-term
credentials for the assigned Amazon Web Services accounts or to access application APIs
using bearer authentication.

# Arguments
- `client_id`: The unique identifier string for the client or application. This value is an
  application ARN that has OAuth grants configured.
- `grant_type`: Supports the following OAuth grant types: Authorization Code, Refresh
  Token, JWT Bearer, and Token Exchange. Specify one of the following values, depending on
  the grant type that you want: * Authorization Code - authorization_code  * Refresh Token -
  refresh_token  * JWT Bearer - urn:ietf:params:oauth:grant-type:jwt-bearer  * Token Exchange
  - urn:ietf:params:oauth:grant-type:token-exchange

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"assertion"`: Used only when calling this API for the JWT Bearer grant type. This value
  specifies the JSON Web Token (JWT) issued by a trusted token issuer. To authorize a trusted
  token issuer, configure the JWT Bearer GrantOptions for the application.
- `"code"`: Used only when calling this API for the Authorization Code grant type. This
  short-term code is used to identify this authorization request. The code is obtained
  through a redirect from IAM Identity Center to a redirect URI persisted in the
  Authorization Code GrantOptions for the application.
- `"codeVerifier"`: Used only when calling this API for the Authorization Code grant type.
  This value is generated by the client and presented to validate the original code challenge
  value the client passed at authorization time.
- `"redirectUri"`: Used only when calling this API for the Authorization Code grant type.
  This value specifies the location of the client or application that has registered to
  receive the authorization code.
- `"refreshToken"`: Used only when calling this API for the Refresh Token grant type. This
  token is used to refresh short-term tokens, such as the access token, that might expire.
  For more information about the features and limitations of the current IAM Identity Center
  OIDC implementation, see Considerations for Using this Guide in the IAM Identity Center
  OIDC API Reference.
- `"requestedTokenType"`: Used only when calling this API for the Token Exchange grant
  type. This value specifies the type of token that the requester can receive. The following
  values are supported: * Access Token - urn:ietf:params:oauth:token-type:access_token  *
  Refresh Token - urn:ietf:params:oauth:token-type:refresh_token
- `"scope"`: The list of scopes for which authorization is requested. The access token that
  is issued is limited to the scopes that are granted. If the value is not specified, IAM
  Identity Center authorizes all scopes configured for the application, including the
  following default scopes: openid, aws, sts:identity_context.
- `"subjectToken"`: Used only when calling this API for the Token Exchange grant type. This
  value specifies the subject of the exchange. The value of the subject token must be an
  access token issued by IAM Identity Center to a different client or application. The access
  token must have authorized scopes that indicate the requested application as a target
  audience.
- `"subjectTokenType"`: Used only when calling this API for the Token Exchange grant type.
  This value specifies the type of token that is passed as the subject of the exchange. The
  following value is supported: * Access Token -
  urn:ietf:params:oauth:token-type:access_token
"""
function create_token_with_iam(
    clientId, grantType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sso_oidc(
        "POST",
        "/token?aws_iam=t",
        Dict{String,Any}("clientId" => clientId, "grantType" => grantType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_token_with_iam(
    clientId,
    grantType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_oidc(
        "POST",
        "/token?aws_iam=t",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("clientId" => clientId, "grantType" => grantType),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    register_client(client_name, client_type)
    register_client(client_name, client_type, params::Dict{String,<:Any})

Registers a client with IAM Identity Center. This allows clients to initiate device
authorization. The output should be persisted for reuse through many authentication
requests.

# Arguments
- `client_name`: The friendly name of the client.
- `client_type`: The type of client. The service supports only public as a client type.
  Anything other than public will be rejected by the service.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"entitledApplicationArn"`: This IAM Identity Center application ARN is used to define
  administrator-managed configuration for public client access to resources. At
  authorization, the scopes, grants, and redirect URI available to this client will be
  restricted by this application resource.
- `"grantTypes"`: The list of OAuth 2.0 grant types that are defined by the client. This
  list is used to restrict the token granting flows available to the client.
- `"issuerUrl"`: The IAM Identity Center Issuer URL associated with an instance of IAM
  Identity Center. This value is needed for user access to resources through the client.
- `"redirectUris"`: The list of redirect URI that are defined by the client. At completion
  of authorization, this list is used to restrict what locations the user agent can be
  redirected back to.
- `"scopes"`: The list of scopes that are defined by the client. Upon authorization, this
  list is used to restrict permissions when granting an access token.
"""
function register_client(
    clientName, clientType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sso_oidc(
        "POST",
        "/client/register",
        Dict{String,Any}("clientName" => clientName, "clientType" => clientType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function register_client(
    clientName,
    clientType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_oidc(
        "POST",
        "/client/register",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("clientName" => clientName, "clientType" => clientType),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_device_authorization(client_id, client_secret, start_url)
    start_device_authorization(client_id, client_secret, start_url, params::Dict{String,<:Any})

Initiates device authorization by requesting a pair of verification codes from the
authorization service.

# Arguments
- `client_id`: The unique identifier string for the client that is registered with IAM
  Identity Center. This value should come from the persisted result of the RegisterClient API
  operation.
- `client_secret`: A secret string that is generated for the client. This value should come
  from the persisted result of the RegisterClient API operation.
- `start_url`: The URL for the Amazon Web Services access portal. For more information, see
  Using the Amazon Web Services access portal in the IAM Identity Center User Guide.

"""
function start_device_authorization(
    clientId, clientSecret, startUrl; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sso_oidc(
        "POST",
        "/device_authorization",
        Dict{String,Any}(
            "clientId" => clientId, "clientSecret" => clientSecret, "startUrl" => startUrl
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_device_authorization(
    clientId,
    clientSecret,
    startUrl,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_oidc(
        "POST",
        "/device_authorization",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "clientId" => clientId,
                    "clientSecret" => clientSecret,
                    "startUrl" => startUrl,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: organizations
using AWS.Compat
using AWS.UUIDs

"""
    accept_handshake(handshake_id)
    accept_handshake(handshake_id, params::Dict{String,<:Any})

Sends a response to the originator of a handshake agreeing to the action proposed by the
handshake request. You can only call this operation by the following principals when they
also have the relevant IAM permissions:    Invitation to join or Approve all features
request handshakes: only a principal from the member account. The user who calls the API
for an invitation to join must have the organizations:AcceptHandshake permission. If you
enabled all features in the organization, the user must also have the
iam:CreateServiceLinkedRole permission so that Organizations can create the required
service-linked role named AWSServiceRoleForOrganizations. For more information, see
Organizations and service-linked roles in the Organizations User Guide.    Enable all
features final confirmation handshake: only a principal from the management account. For
more information about invitations, see Inviting an Amazon Web Services account to join
your organization in the Organizations User Guide. For more information about requests to
enable all features in the organization, see Enabling all features in your organization in
the Organizations User Guide.   After you accept a handshake, it continues to appear in the
results of relevant APIs for only 30 days. After that, it's deleted.

# Arguments
- `handshake_id`: The unique identifier (ID) of the handshake that you want to accept. The
  regex pattern for handshake ID string requires \"h-\" followed by from 8 to 32 lowercase
  letters or digits.

"""
function accept_handshake(HandshakeId; aws_config::AbstractAWSConfig=current_aws_config())
    return organizations(
        "AcceptHandshake",
        Dict{String,Any}("HandshakeId" => HandshakeId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function accept_handshake(
    HandshakeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return organizations(
        "AcceptHandshake",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("HandshakeId" => HandshakeId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    attach_policy(policy_id, target_id)
    attach_policy(policy_id, target_id, params::Dict{String,<:Any})

Attaches a policy to a root, an organizational unit (OU), or an individual account. How the
policy affects accounts depends on the type of policy. Refer to the Organizations User
Guide for information about each policy type:    AISERVICES_OPT_OUT_POLICY
BACKUP_POLICY     SERVICE_CONTROL_POLICY     TAG_POLICY    This operation can be called
only from the organization's management account or by a member account that is a delegated
administrator for an Amazon Web Services service.

# Arguments
- `policy_id`: The unique identifier (ID) of the policy that you want to attach to the
  target. You can get the ID for the policy by calling the ListPolicies operation. The regex
  pattern for a policy ID string requires \"p-\" followed by from 8 to 128 lowercase or
  uppercase letters, digits, or the underscore character (_).
- `target_id`: The unique identifier (ID) of the root, OU, or account that you want to
  attach the policy to. You can get the ID by calling the ListRoots,
  ListOrganizationalUnitsForParent, or ListAccounts operations. The regex pattern for a
  target ID string requires one of the following:    Root - A string that begins with \"r-\"
  followed by from 4 to 32 lowercase letters or digits.    Account - A string that consists
  of exactly 12 digits.    Organizational unit (OU) - A string that begins with \"ou-\"
  followed by from 4 to 32 lowercase letters or digits (the ID of the root that the OU is
  in). This string is followed by a second \"-\" dash and from 8 to 32 additional lowercase
  letters or digits.

"""
function attach_policy(
    PolicyId, TargetId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return organizations(
        "AttachPolicy",
        Dict{String,Any}("PolicyId" => PolicyId, "TargetId" => TargetId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function attach_policy(
    PolicyId,
    TargetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return organizations(
        "AttachPolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("PolicyId" => PolicyId, "TargetId" => TargetId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_handshake(handshake_id)
    cancel_handshake(handshake_id, params::Dict{String,<:Any})

Cancels a handshake. Canceling a handshake sets the handshake state to CANCELED. This
operation can be called only from the account that originated the handshake. The recipient
of the handshake can't cancel it, but can use DeclineHandshake instead. After a handshake
is canceled, the recipient can no longer respond to that handshake. After you cancel a
handshake, it continues to appear in the results of relevant APIs for only 30 days. After
that, it's deleted.

# Arguments
- `handshake_id`: The unique identifier (ID) of the handshake that you want to cancel. You
  can get the ID from the ListHandshakesForOrganization operation. The regex pattern for
  handshake ID string requires \"h-\" followed by from 8 to 32 lowercase letters or digits.

"""
function cancel_handshake(HandshakeId; aws_config::AbstractAWSConfig=current_aws_config())
    return organizations(
        "CancelHandshake",
        Dict{String,Any}("HandshakeId" => HandshakeId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_handshake(
    HandshakeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return organizations(
        "CancelHandshake",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("HandshakeId" => HandshakeId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    close_account(account_id)
    close_account(account_id, params::Dict{String,<:Any})

Closes an Amazon Web Services member account within an organization. You can close an
account when all features are enabled . You can't close the management account with this
API. This is an asynchronous request that Amazon Web Services performs in the background.
Because CloseAccount operates asynchronously, it can return a successful completion message
even though account closure might still be in progress. You need to wait a few minutes
before the account is fully closed. To check the status of the request, do one of the
following:   Use the AccountId that you sent in the CloseAccount request to provide as a
parameter to the DescribeAccount operation.  While the close account request is in
progress, Account status will indicate PENDING_CLOSURE. When the close account request
completes, the status will change to SUSPENDED.    Check the CloudTrail log for the
CloseAccountResult event that gets published after the account closes successfully. For
information on using CloudTrail with Organizations, see Logging and monitoring in
Organizations in the Organizations User Guide.      You can close only 10% of member
accounts, between 10 and 1000, within a rolling 30 day period. This quota is not bound by a
calendar month, but starts when you close an account. After you reach this limit, you can
close additional accounts. For more information, see Closing a member account in your
organization and Quotas for Organizationsin the Organizations User Guide.    To reinstate a
closed account, contact Amazon Web Services Support within the 90-day grace period while
the account is in SUSPENDED status.    If the Amazon Web Services account you attempt to
close is linked to an Amazon Web Services GovCloud (US) account, the CloseAccount request
will close both accounts. To learn important pre-closure details, see  Closing an Amazon
Web Services GovCloud (US) account in the  Amazon Web Services GovCloud User Guide.

# Arguments
- `account_id`: Retrieves the Amazon Web Services account Id for the current CloseAccount
  API request.

"""
function close_account(AccountId; aws_config::AbstractAWSConfig=current_aws_config())
    return organizations(
        "CloseAccount",
        Dict{String,Any}("AccountId" => AccountId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function close_account(
    AccountId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return organizations(
        "CloseAccount",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AccountId" => AccountId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_account(account_name, email)
    create_account(account_name, email, params::Dict{String,<:Any})

Creates an Amazon Web Services account that is automatically a member of the organization
whose credentials made the request. This is an asynchronous request that Amazon Web
Services performs in the background. Because CreateAccount operates asynchronously, it can
return a successful completion message even though account initialization might still be in
progress. You might need to wait a few minutes before you can successfully access the
account. To check the status of the request, do one of the following:   Use the Id value of
the CreateAccountStatus response element from this operation to provide as a parameter to
the DescribeCreateAccountStatus operation.   Check the CloudTrail log for the
CreateAccountResult event. For information on using CloudTrail with Organizations, see
Logging and monitoring in Organizations in the Organizations User Guide.   The user who
calls the API to create an account must have the organizations:CreateAccount permission. If
you enabled all features in the organization, Organizations creates the required
service-linked role named AWSServiceRoleForOrganizations. For more information, see
Organizations and service-linked roles in the Organizations User Guide. If the request
includes tags, then the requester must have the organizations:TagResource permission.
Organizations preconfigures the new member account with a role (named
OrganizationAccountAccessRole by default) that grants users in the management account
administrator permissions in the new member account. Principals in the management account
can assume the role. Organizations clones the company name and address information for the
new account from the organization's management account. This operation can be called only
from the organization's management account. For more information about creating accounts,
see Creating a member account in your organization in the Organizations User Guide.    When
you create an account in an organization using the Organizations console, API, or CLI
commands, the information required for the account to operate as a standalone account, such
as a payment method and signing the end user license agreement (EULA) is not automatically
collected. If you must remove an account from your organization later, you can do so only
after you provide the missing information. For more information, see Considerations before
removing an account from an organization in the Organizations User Guide.   If you get an
exception that indicates that you exceeded your account limits for the organization,
contact Amazon Web Services Support.   If you get an exception that indicates that the
operation failed because your organization is still initializing, wait one hour and then
try again. If the error persists, contact Amazon Web Services Support.   Using
CreateAccount to create multiple temporary accounts isn't recommended. You can only close
an account from the Billing and Cost Management console, and you must be signed in as the
root user. For information on the requirements and process for closing an account, see
Closing a member account in your organization in the Organizations User Guide.     When you
create a member account with this operation, you can choose whether to create the account
with the IAM User and Role Access to Billing Information switch enabled. If you enable it,
IAM users and roles that have appropriate permissions can view billing information for the
account. If you disable it, only the account root user can access billing information. For
information about how to disable this switch for an account, see Granting access to your
billing information and tools.

# Arguments
- `account_name`: The friendly name of the member account.
- `email`: The email address of the owner to assign to the new member account. This email
  address must not already be associated with another Amazon Web Services account. You must
  use a valid email address to complete account creation. The rules for a valid email
  address:   The address must be a minimum of 6 and a maximum of 64 characters long.   All
  characters must be 7-bit ASCII characters.   There must be one and only one @ symbol, which
  separates the local name from the domain name.   The local name can't contain any of the
  following characters: whitespace, \" ' ( ) &lt; &gt; [ ] : ; ,  | % &amp;   The local name
  can't begin with a dot (.)   The domain name can consist of only the characters
  [a-z],[A-Z],[0-9], hyphen (-), or dot (.)   The domain name can't begin or end with a
  hyphen (-) or dot (.)   The domain name must contain at least one dot   You can't access
  the root user of the account or remove an account that was created with an invalid email
  address.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"IamUserAccessToBilling"`: If set to ALLOW, the new account enables IAM users to access
  account billing information if they have the required permissions. If set to DENY, only the
  root user of the new account can access account billing information. For more information,
  see About IAM access to the Billing and Cost Management console in the Amazon Web Services
  Billing and Cost Management User Guide. If you don't specify this parameter, the value
  defaults to ALLOW, and IAM users and roles with the required permissions can access billing
  information for the new account.
- `"RoleName"`: The name of an IAM role that Organizations automatically preconfigures in
  the new member account. This role trusts the management account, allowing users in the
  management account to assume the role, as permitted by the management account
  administrator. The role has administrator permissions in the new member account. If you
  don't specify this parameter, the role name defaults to OrganizationAccountAccessRole. For
  more information about how to use this role to access the member account, see the following
  links:    Creating the OrganizationAccountAccessRole in an invited member account in the
  Organizations User Guide    Steps 2 and 3 in IAM Tutorial: Delegate access across Amazon
  Web Services accounts using IAM roles in the IAM User Guide    The regex pattern that is
  used to validate this parameter. The pattern can include uppercase letters, lowercase
  letters, digits with no spaces, and any of the following characters: =,.@-
- `"Tags"`: A list of tags that you want to attach to the newly created account. For each
  tag in the list, you must specify both a tag key and a value. You can set the value to an
  empty string, but you can't set it to null. For more information about tagging, see Tagging
  Organizations resources in the Organizations User Guide.  If any one of the tags is not
  valid or if you exceed the maximum allowed number of tags for an account, then the entire
  request fails and the account is not created.
"""
function create_account(
    AccountName, Email; aws_config::AbstractAWSConfig=current_aws_config()
)
    return organizations(
        "CreateAccount",
        Dict{String,Any}("AccountName" => AccountName, "Email" => Email);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_account(
    AccountName,
    Email,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return organizations(
        "CreateAccount",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("AccountName" => AccountName, "Email" => Email),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_gov_cloud_account(account_name, email)
    create_gov_cloud_account(account_name, email, params::Dict{String,<:Any})

This action is available if all of the following are true:   You're authorized to create
accounts in the Amazon Web Services GovCloud (US) Region. For more information on the
Amazon Web Services GovCloud (US) Region, see the  Amazon Web Services GovCloud User Guide.
   You already have an account in the Amazon Web Services GovCloud (US) Region that is
paired with a management account of an organization in the commercial Region.   You call
this action from the management account of your organization in the commercial Region.
You have the organizations:CreateGovCloudAccount permission.    Organizations automatically
creates the required service-linked role named AWSServiceRoleForOrganizations. For more
information, see Organizations and service-linked roles in the Organizations User Guide.
Amazon Web Services automatically enables CloudTrail for Amazon Web Services GovCloud (US)
accounts, but you should also do the following:   Verify that CloudTrail is enabled to
store logs.   Create an Amazon S3 bucket for CloudTrail log storage. For more information,
see Verifying CloudTrail Is Enabled in the Amazon Web Services GovCloud User Guide.    If
the request includes tags, then the requester must have the organizations:TagResource
permission. The tags are attached to the commercial account associated with the GovCloud
account, rather than the GovCloud account itself. To add tags to the GovCloud account, call
the TagResource operation in the GovCloud Region after the new GovCloud account exists. You
call this action from the management account of your organization in the commercial Region
to create a standalone Amazon Web Services account in the Amazon Web Services GovCloud (US)
Region. After the account is created, the management account of an organization in the
Amazon Web Services GovCloud (US) Region can invite it to that organization. For more
information on inviting standalone accounts in the Amazon Web Services GovCloud (US) to
join an organization, see Organizations in the Amazon Web Services GovCloud User Guide.
Calling CreateGovCloudAccount is an asynchronous request that Amazon Web Services performs
in the background. Because CreateGovCloudAccount operates asynchronously, it can return a
successful completion message even though account initialization might still be in
progress. You might need to wait a few minutes before you can successfully access the
account. To check the status of the request, do one of the following:   Use the OperationId
response element from this operation to provide as a parameter to the
DescribeCreateAccountStatus operation.   Check the CloudTrail log for the
CreateAccountResult event. For information on using CloudTrail with Organizations, see
Logging and monitoring in Organizations in the Organizations User Guide.    When you call
the CreateGovCloudAccount action, you create two accounts: a standalone account in the
Amazon Web Services GovCloud (US) Region and an associated account in the commercial Region
for billing and support purposes. The account in the commercial Region is automatically a
member of the organization whose credentials made the request. Both accounts are associated
with the same email address. A role is created in the new account in the commercial Region
that allows the management account in the organization in the commercial Region to assume
it. An Amazon Web Services GovCloud (US) account is then created and associated with the
commercial account that you just created. A role is also created in the new Amazon Web
Services GovCloud (US) account that can be assumed by the Amazon Web Services GovCloud (US)
account that is associated with the management account of the commercial organization. For
more information and to view a diagram that explains how account access works, see
Organizations in the Amazon Web Services GovCloud User Guide. For more information about
creating accounts, see Creating a member account in your organization in the Organizations
User Guide.    When you create an account in an organization using the Organizations
console, API, or CLI commands, the information required for the account to operate as a
standalone account is not automatically collected. This includes a payment method and
signing the end user license agreement (EULA). If you must remove an account from your
organization later, you can do so only after you provide the missing information. For more
information, see Considerations before removing an account from an organization in the
Organizations User Guide.   If you get an exception that indicates that you exceeded your
account limits for the organization, contact Amazon Web Services Support.   If you get an
exception that indicates that the operation failed because your organization is still
initializing, wait one hour and then try again. If the error persists, contact Amazon Web
Services Support.   Using CreateGovCloudAccount to create multiple temporary accounts isn't
recommended. You can only close an account from the Amazon Web Services Billing and Cost
Management console, and you must be signed in as the root user. For information on the
requirements and process for closing an account, see Closing a member account in your
organization in the Organizations User Guide.     When you create a member account with
this operation, you can choose whether to create the account with the IAM User and Role
Access to Billing Information switch enabled. If you enable it, IAM users and roles that
have appropriate permissions can view billing information for the account. If you disable
it, only the account root user can access billing information. For information about how to
disable this switch for an account, see Granting access to your billing information and
tools.

# Arguments
- `account_name`: The friendly name of the member account.  The account name can consist of
  only the characters [a-z],[A-Z],[0-9], hyphen (-), or dot (.) You can't separate characters
  with a dash (–).
- `email`: Specifies the email address of the owner to assign to the new member account in
  the commercial Region. This email address must not already be associated with another
  Amazon Web Services account. You must use a valid email address to complete account
  creation. The rules for a valid email address:   The address must be a minimum of 6 and a
  maximum of 64 characters long.   All characters must be 7-bit ASCII characters.   There
  must be one and only one @ symbol, which separates the local name from the domain name.
  The local name can't contain any of the following characters: whitespace, \" ' ( ) &lt;
  &gt; [ ] : ; ,  | % &amp;   The local name can't begin with a dot (.)   The domain name can
  consist of only the characters [a-z],[A-Z],[0-9], hyphen (-), or dot (.)   The domain name
  can't begin or end with a hyphen (-) or dot (.)   The domain name must contain at least one
  dot   You can't access the root user of the account or remove an account that was created
  with an invalid email address. Like all request parameters for CreateGovCloudAccount, the
  request for the email address for the Amazon Web Services GovCloud (US) account originates
  from the commercial Region, not from the Amazon Web Services GovCloud (US) Region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"IamUserAccessToBilling"`: If set to ALLOW, the new linked account in the commercial
  Region enables IAM users to access account billing information if they have the required
  permissions. If set to DENY, only the root user of the new account can access account
  billing information. For more information, see About IAM access to the Billing and Cost
  Management console in the Amazon Web Services Billing and Cost Management User Guide. If
  you don't specify this parameter, the value defaults to ALLOW, and IAM users and roles with
  the required permissions can access billing information for the new account.
- `"RoleName"`: (Optional) The name of an IAM role that Organizations automatically
  preconfigures in the new member accounts in both the Amazon Web Services GovCloud (US)
  Region and in the commercial Region. This role trusts the management account, allowing
  users in the management account to assume the role, as permitted by the management account
  administrator. The role has administrator permissions in the new member account. If you
  don't specify this parameter, the role name defaults to OrganizationAccountAccessRole. For
  more information about how to use this role to access the member account, see the following
  links:    Creating the OrganizationAccountAccessRole in an invited member account in the
  Organizations User Guide    Steps 2 and 3 in IAM Tutorial: Delegate access across Amazon
  Web Services accounts using IAM roles in the IAM User Guide    The regex pattern that is
  used to validate this parameter. The pattern can include uppercase letters, lowercase
  letters, digits with no spaces, and any of the following characters: =,.@-
- `"Tags"`: A list of tags that you want to attach to the newly created account. These tags
  are attached to the commercial account associated with the GovCloud account, and not to the
  GovCloud account itself. To add tags to the actual GovCloud account, call the TagResource
  operation in the GovCloud region after the new GovCloud account exists. For each tag in the
  list, you must specify both a tag key and a value. You can set the value to an empty
  string, but you can't set it to null. For more information about tagging, see Tagging
  Organizations resources in the Organizations User Guide.  If any one of the tags is not
  valid or if you exceed the maximum allowed number of tags for an account, then the entire
  request fails and the account is not created.
"""
function create_gov_cloud_account(
    AccountName, Email; aws_config::AbstractAWSConfig=current_aws_config()
)
    return organizations(
        "CreateGovCloudAccount",
        Dict{String,Any}("AccountName" => AccountName, "Email" => Email);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_gov_cloud_account(
    AccountName,
    Email,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return organizations(
        "CreateGovCloudAccount",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("AccountName" => AccountName, "Email" => Email),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_organization()
    create_organization(params::Dict{String,<:Any})

Creates an Amazon Web Services organization. The account whose user is calling the
CreateOrganization operation automatically becomes the management account of the new
organization. This operation must be called using credentials from the account that is to
become the new organization's management account. The principal must also have the relevant
IAM permissions. By default (or if you set the FeatureSet parameter to ALL), the new
organization is created with all features enabled and service control policies
automatically enabled in the root. If you instead choose to create the organization
supporting only the consolidated billing features by setting the FeatureSet parameter to
CONSOLIDATED_BILLING, no policy types are enabled by default and you can't use organization
policies.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FeatureSet"`: Specifies the feature set supported by the new organization. Each feature
  set supports different levels of functionality.    CONSOLIDATED_BILLING: All member
  accounts have their bills consolidated to and paid by the management account. For more
  information, see Consolidated billing in the Organizations User Guide.  The consolidated
  billing feature subset isn't available for organizations in the Amazon Web Services
  GovCloud (US) Region.    ALL: In addition to all the features supported by the consolidated
  billing feature set, the management account can also apply any policy type to any member
  account in the organization. For more information, see All features in the Organizations
  User Guide.
"""
function create_organization(; aws_config::AbstractAWSConfig=current_aws_config())
    return organizations(
        "CreateOrganization"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function create_organization(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return organizations(
        "CreateOrganization", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    create_organizational_unit(name, parent_id)
    create_organizational_unit(name, parent_id, params::Dict{String,<:Any})

Creates an organizational unit (OU) within a root or parent OU. An OU is a container for
accounts that enables you to organize your accounts to apply policies according to your
business requirements. The number of levels deep that you can nest OUs is dependent upon
the policy types enabled for that root. For service control policies, the limit is five.
For more information about OUs, see Managing organizational units (OUs) in the
Organizations User Guide. If the request includes tags, then the requester must have the
organizations:TagResource permission. This operation can be called only from the
organization's management account.

# Arguments
- `name`: The friendly name to assign to the new OU.
- `parent_id`: The unique identifier (ID) of the parent root or OU that you want to create
  the new OU in. The regex pattern for a parent ID string requires one of the following:
  Root - A string that begins with \"r-\" followed by from 4 to 32 lowercase letters or
  digits.    Organizational unit (OU) - A string that begins with \"ou-\" followed by from 4
  to 32 lowercase letters or digits (the ID of the root that the OU is in). This string is
  followed by a second \"-\" dash and from 8 to 32 additional lowercase letters or digits.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: A list of tags that you want to attach to the newly created OU. For each tag in
  the list, you must specify both a tag key and a value. You can set the value to an empty
  string, but you can't set it to null. For more information about tagging, see Tagging
  Organizations resources in the Organizations User Guide.  If any one of the tags is not
  valid or if you exceed the allowed number of tags for an OU, then the entire request fails
  and the OU is not created.
"""
function create_organizational_unit(
    Name, ParentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return organizations(
        "CreateOrganizationalUnit",
        Dict{String,Any}("Name" => Name, "ParentId" => ParentId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_organizational_unit(
    Name,
    ParentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return organizations(
        "CreateOrganizationalUnit",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("Name" => Name, "ParentId" => ParentId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_policy(content, description, name, type)
    create_policy(content, description, name, type, params::Dict{String,<:Any})

Creates a policy of a specified type that you can attach to a root, an organizational unit
(OU), or an individual Amazon Web Services account. For more information about policies and
their use, see Managing Organizations policies. If the request includes tags, then the
requester must have the organizations:TagResource permission. This operation can be called
only from the organization's management account or by a member account that is a delegated
administrator for an Amazon Web Services service.

# Arguments
- `content`: The policy text content to add to the new policy. The text that you supply
  must adhere to the rules of the policy type you specify in the Type parameter.  The maximum
  size of a policy document depends on the policy's type. For more information, see Maximum
  and minimum values in the Organizations User Guide.
- `description`: An optional description to assign to the policy.
- `name`: The friendly name to assign to the policy. The regex pattern that is used to
  validate this parameter is a string of any of the characters in the ASCII character range.
- `type`: The type of policy to create. You can specify one of the following values:
  AISERVICES_OPT_OUT_POLICY     BACKUP_POLICY     SERVICE_CONTROL_POLICY     TAG_POLICY

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: A list of tags that you want to attach to the newly created policy. For each
  tag in the list, you must specify both a tag key and a value. You can set the value to an
  empty string, but you can't set it to null. For more information about tagging, see Tagging
  Organizations resources in the Organizations User Guide.  If any one of the tags is not
  valid or if you exceed the allowed number of tags for a policy, then the entire request
  fails and the policy is not created.
"""
function create_policy(
    Content, Description, Name, Type; aws_config::AbstractAWSConfig=current_aws_config()
)
    return organizations(
        "CreatePolicy",
        Dict{String,Any}(
            "Content" => Content,
            "Description" => Description,
            "Name" => Name,
            "Type" => Type,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_policy(
    Content,
    Description,
    Name,
    Type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return organizations(
        "CreatePolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Content" => Content,
                    "Description" => Description,
                    "Name" => Name,
                    "Type" => Type,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    decline_handshake(handshake_id)
    decline_handshake(handshake_id, params::Dict{String,<:Any})

Declines a handshake request. This sets the handshake state to DECLINED and effectively
deactivates the request. This operation can be called only from the account that received
the handshake. The originator of the handshake can use CancelHandshake instead. The
originator can't reactivate a declined request, but can reinitiate the process with a new
handshake request. After you decline a handshake, it continues to appear in the results of
relevant APIs for only 30 days. After that, it's deleted.

# Arguments
- `handshake_id`: The unique identifier (ID) of the handshake that you want to decline. You
  can get the ID from the ListHandshakesForAccount operation. The regex pattern for handshake
  ID string requires \"h-\" followed by from 8 to 32 lowercase letters or digits.

"""
function decline_handshake(HandshakeId; aws_config::AbstractAWSConfig=current_aws_config())
    return organizations(
        "DeclineHandshake",
        Dict{String,Any}("HandshakeId" => HandshakeId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function decline_handshake(
    HandshakeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return organizations(
        "DeclineHandshake",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("HandshakeId" => HandshakeId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_organization()
    delete_organization(params::Dict{String,<:Any})

Deletes the organization. You can delete an organization only by using credentials from the
management account. The organization must be empty of member accounts.

"""
function delete_organization(; aws_config::AbstractAWSConfig=current_aws_config())
    return organizations(
        "DeleteOrganization"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function delete_organization(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return organizations(
        "DeleteOrganization", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    delete_organizational_unit(organizational_unit_id)
    delete_organizational_unit(organizational_unit_id, params::Dict{String,<:Any})

Deletes an organizational unit (OU) from a root or another OU. You must first remove all
accounts and child OUs from the OU that you want to delete. This operation can be called
only from the organization's management account.

# Arguments
- `organizational_unit_id`: The unique identifier (ID) of the organizational unit that you
  want to delete. You can get the ID from the ListOrganizationalUnitsForParent operation. The
  regex pattern for an organizational unit ID string requires \"ou-\" followed by from 4 to
  32 lowercase letters or digits (the ID of the root that contains the OU). This string is
  followed by a second \"-\" dash and from 8 to 32 additional lowercase letters or digits.

"""
function delete_organizational_unit(
    OrganizationalUnitId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return organizations(
        "DeleteOrganizationalUnit",
        Dict{String,Any}("OrganizationalUnitId" => OrganizationalUnitId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_organizational_unit(
    OrganizationalUnitId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return organizations(
        "DeleteOrganizationalUnit",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("OrganizationalUnitId" => OrganizationalUnitId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_policy(policy_id)
    delete_policy(policy_id, params::Dict{String,<:Any})

Deletes the specified policy from your organization. Before you perform this operation, you
must first detach the policy from all organizational units (OUs), roots, and accounts. This
operation can be called only from the organization's management account or by a member
account that is a delegated administrator for an Amazon Web Services service.

# Arguments
- `policy_id`: The unique identifier (ID) of the policy that you want to delete. You can
  get the ID from the ListPolicies or ListPoliciesForTarget operations. The regex pattern for
  a policy ID string requires \"p-\" followed by from 8 to 128 lowercase or uppercase
  letters, digits, or the underscore character (_).

"""
function delete_policy(PolicyId; aws_config::AbstractAWSConfig=current_aws_config())
    return organizations(
        "DeletePolicy",
        Dict{String,Any}("PolicyId" => PolicyId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_policy(
    PolicyId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return organizations(
        "DeletePolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("PolicyId" => PolicyId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_resource_policy()
    delete_resource_policy(params::Dict{String,<:Any})

Deletes the resource policy from your organization. You can only call this operation from
the organization's management account.

"""
function delete_resource_policy(; aws_config::AbstractAWSConfig=current_aws_config())
    return organizations(
        "DeleteResourcePolicy"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function delete_resource_policy(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return organizations(
        "DeleteResourcePolicy",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    deregister_delegated_administrator(account_id, service_principal)
    deregister_delegated_administrator(account_id, service_principal, params::Dict{String,<:Any})

Removes the specified member Amazon Web Services account as a delegated administrator for
the specified Amazon Web Services service.  Deregistering a delegated administrator can
have unintended impacts on the functionality of the enabled Amazon Web Services service.
See the documentation for the enabled service before you deregister a delegated
administrator so that you understand any potential impacts.  You can run this action only
for Amazon Web Services services that support this feature. For a current list of services
that support it, see the column Supports Delegated Administrator in the table at Amazon Web
Services Services that you can use with Organizations in the Organizations User Guide.
This operation can be called only from the organization's management account.

# Arguments
- `account_id`: The account ID number of the member account in the organization that you
  want to deregister as a delegated administrator.
- `service_principal`: The service principal name of an Amazon Web Services service for
  which the account is a delegated administrator. Delegated administrator privileges are
  revoked for only the specified Amazon Web Services service from the member account. If the
  specified service is the only service for which the member account is a delegated
  administrator, the operation also revokes Organizations read action permissions.

"""
function deregister_delegated_administrator(
    AccountId, ServicePrincipal; aws_config::AbstractAWSConfig=current_aws_config()
)
    return organizations(
        "DeregisterDelegatedAdministrator",
        Dict{String,Any}("AccountId" => AccountId, "ServicePrincipal" => ServicePrincipal);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function deregister_delegated_administrator(
    AccountId,
    ServicePrincipal,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return organizations(
        "DeregisterDelegatedAdministrator",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AccountId" => AccountId, "ServicePrincipal" => ServicePrincipal
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_account(account_id)
    describe_account(account_id, params::Dict{String,<:Any})

Retrieves Organizations-related information about the specified account. This operation can
be called only from the organization's management account or by a member account that is a
delegated administrator for an Amazon Web Services service.

# Arguments
- `account_id`: The unique identifier (ID) of the Amazon Web Services account that you want
  information about. You can get the ID from the ListAccounts or ListAccountsForParent
  operations. The regex pattern for an account ID string requires exactly 12 digits.

"""
function describe_account(AccountId; aws_config::AbstractAWSConfig=current_aws_config())
    return organizations(
        "DescribeAccount",
        Dict{String,Any}("AccountId" => AccountId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_account(
    AccountId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return organizations(
        "DescribeAccount",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AccountId" => AccountId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_create_account_status(create_account_request_id)
    describe_create_account_status(create_account_request_id, params::Dict{String,<:Any})

Retrieves the current status of an asynchronous request to create an account. This
operation can be called only from the organization's management account or by a member
account that is a delegated administrator for an Amazon Web Services service.

# Arguments
- `create_account_request_id`: Specifies the Id value that uniquely identifies the
  CreateAccount request. You can get the value from the CreateAccountStatus.Id response in an
  earlier CreateAccount request, or from the ListCreateAccountStatus operation. The regex
  pattern for a create account request ID string requires \"car-\" followed by from 8 to 32
  lowercase letters or digits.

"""
function describe_create_account_status(
    CreateAccountRequestId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return organizations(
        "DescribeCreateAccountStatus",
        Dict{String,Any}("CreateAccountRequestId" => CreateAccountRequestId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_create_account_status(
    CreateAccountRequestId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return organizations(
        "DescribeCreateAccountStatus",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("CreateAccountRequestId" => CreateAccountRequestId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_effective_policy(policy_type)
    describe_effective_policy(policy_type, params::Dict{String,<:Any})

Returns the contents of the effective policy for specified policy type and account. The
effective policy is the aggregation of any policies of the specified type that the account
inherits, plus any policy of that type that is directly attached to the account. This
operation applies only to policy types other than service control policies (SCPs). For more
information about policy inheritance, see Understanding management policy inheritance in
the Organizations User Guide. This operation can be called from any account in the
organization.

# Arguments
- `policy_type`: The type of policy that you want information about. You can specify one of
  the following values:    AISERVICES_OPT_OUT_POLICY     BACKUP_POLICY     TAG_POLICY

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"TargetId"`: When you're signed in as the management account, specify the ID of the
  account that you want details about. Specifying an organization root or organizational unit
  (OU) as the target is not supported.
"""
function describe_effective_policy(
    PolicyType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return organizations(
        "DescribeEffectivePolicy",
        Dict{String,Any}("PolicyType" => PolicyType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_effective_policy(
    PolicyType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return organizations(
        "DescribeEffectivePolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("PolicyType" => PolicyType), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_handshake(handshake_id)
    describe_handshake(handshake_id, params::Dict{String,<:Any})

Retrieves information about a previously requested handshake. The handshake ID comes from
the response to the original InviteAccountToOrganization operation that generated the
handshake. You can access handshakes that are ACCEPTED, DECLINED, or CANCELED for only 30
days after they change to that state. They're then deleted and no longer accessible. This
operation can be called from any account in the organization.

# Arguments
- `handshake_id`: The unique identifier (ID) of the handshake that you want information
  about. You can get the ID from the original call to InviteAccountToOrganization, or from a
  call to ListHandshakesForAccount or ListHandshakesForOrganization. The regex pattern for
  handshake ID string requires \"h-\" followed by from 8 to 32 lowercase letters or digits.

"""
function describe_handshake(HandshakeId; aws_config::AbstractAWSConfig=current_aws_config())
    return organizations(
        "DescribeHandshake",
        Dict{String,Any}("HandshakeId" => HandshakeId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_handshake(
    HandshakeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return organizations(
        "DescribeHandshake",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("HandshakeId" => HandshakeId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_organization()
    describe_organization(params::Dict{String,<:Any})

Retrieves information about the organization that the user's account belongs to. This
operation can be called from any account in the organization.  Even if a policy type is
shown as available in the organization, you can disable it separately at the root level
with DisablePolicyType. Use ListRoots to see the status of policy types for a specified
root.

"""
function describe_organization(; aws_config::AbstractAWSConfig=current_aws_config())
    return organizations(
        "DescribeOrganization"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_organization(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return organizations(
        "DescribeOrganization",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_organizational_unit(organizational_unit_id)
    describe_organizational_unit(organizational_unit_id, params::Dict{String,<:Any})

Retrieves information about an organizational unit (OU). This operation can be called only
from the organization's management account or by a member account that is a delegated
administrator for an Amazon Web Services service.

# Arguments
- `organizational_unit_id`: The unique identifier (ID) of the organizational unit that you
  want details about. You can get the ID from the ListOrganizationalUnitsForParent operation.
  The regex pattern for an organizational unit ID string requires \"ou-\" followed by from 4
  to 32 lowercase letters or digits (the ID of the root that contains the OU). This string is
  followed by a second \"-\" dash and from 8 to 32 additional lowercase letters or digits.

"""
function describe_organizational_unit(
    OrganizationalUnitId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return organizations(
        "DescribeOrganizationalUnit",
        Dict{String,Any}("OrganizationalUnitId" => OrganizationalUnitId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_organizational_unit(
    OrganizationalUnitId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return organizations(
        "DescribeOrganizationalUnit",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("OrganizationalUnitId" => OrganizationalUnitId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_policy(policy_id)
    describe_policy(policy_id, params::Dict{String,<:Any})

Retrieves information about a policy. This operation can be called only from the
organization's management account or by a member account that is a delegated administrator
for an Amazon Web Services service.

# Arguments
- `policy_id`: The unique identifier (ID) of the policy that you want details about. You
  can get the ID from the ListPolicies or ListPoliciesForTarget operations. The regex pattern
  for a policy ID string requires \"p-\" followed by from 8 to 128 lowercase or uppercase
  letters, digits, or the underscore character (_).

"""
function describe_policy(PolicyId; aws_config::AbstractAWSConfig=current_aws_config())
    return organizations(
        "DescribePolicy",
        Dict{String,Any}("PolicyId" => PolicyId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_policy(
    PolicyId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return organizations(
        "DescribePolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("PolicyId" => PolicyId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_resource_policy()
    describe_resource_policy(params::Dict{String,<:Any})

Retrieves information about a resource policy. This operation can be called only from the
organization's management account or by a member account that is a delegated administrator
for an Amazon Web Services service.

"""
function describe_resource_policy(; aws_config::AbstractAWSConfig=current_aws_config())
    return organizations(
        "DescribeResourcePolicy"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_resource_policy(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return organizations(
        "DescribeResourcePolicy",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    detach_policy(policy_id, target_id)
    detach_policy(policy_id, target_id, params::Dict{String,<:Any})

Detaches a policy from a target root, organizational unit (OU), or account.  If the policy
being detached is a service control policy (SCP), the changes to permissions for Identity
and Access Management (IAM) users and roles in affected accounts are immediate.  Every
root, OU, and account must have at least one SCP attached. If you want to replace the
default FullAWSAccess policy with an SCP that limits the permissions that can be delegated,
you must attach the replacement SCP before you can remove the default SCP. This is the
authorization strategy of an \"allow list\". If you instead attach a second SCP and leave
the FullAWSAccess SCP still attached, and specify \"Effect\": \"Deny\" in the second SCP to
override the \"Effect\": \"Allow\" in the FullAWSAccess policy (or any other attached SCP),
you're using the authorization strategy of a \"deny list\". This operation can be called
only from the organization's management account or by a member account that is a delegated
administrator for an Amazon Web Services service.

# Arguments
- `policy_id`: The unique identifier (ID) of the policy you want to detach. You can get the
  ID from the ListPolicies or ListPoliciesForTarget operations. The regex pattern for a
  policy ID string requires \"p-\" followed by from 8 to 128 lowercase or uppercase letters,
  digits, or the underscore character (_).
- `target_id`: The unique identifier (ID) of the root, OU, or account that you want to
  detach the policy from. You can get the ID from the ListRoots,
  ListOrganizationalUnitsForParent, or ListAccounts operations. The regex pattern for a
  target ID string requires one of the following:    Root - A string that begins with \"r-\"
  followed by from 4 to 32 lowercase letters or digits.    Account - A string that consists
  of exactly 12 digits.    Organizational unit (OU) - A string that begins with \"ou-\"
  followed by from 4 to 32 lowercase letters or digits (the ID of the root that the OU is
  in). This string is followed by a second \"-\" dash and from 8 to 32 additional lowercase
  letters or digits.

"""
function detach_policy(
    PolicyId, TargetId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return organizations(
        "DetachPolicy",
        Dict{String,Any}("PolicyId" => PolicyId, "TargetId" => TargetId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function detach_policy(
    PolicyId,
    TargetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return organizations(
        "DetachPolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("PolicyId" => PolicyId, "TargetId" => TargetId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disable_awsservice_access(service_principal)
    disable_awsservice_access(service_principal, params::Dict{String,<:Any})

Disables the integration of an Amazon Web Services service (the service that is specified
by ServicePrincipal) with Organizations. When you disable integration, the specified
service no longer can create a service-linked role in new accounts in your organization.
This means the service can't perform operations on your behalf on any new accounts in your
organization. The service can still perform operations in older accounts until the service
completes its clean-up from Organizations.  We  strongly recommend  that you don't use this
command to disable integration between Organizations and the specified Amazon Web Services
service. Instead, use the console or commands that are provided by the specified service.
This lets the trusted service perform any required initialization when enabling trusted
access, such as creating any required resources and any required clean up of resources when
disabling trusted access.  For information about how to disable trusted service access to
your organization using the trusted service, see the Learn more link under the Supports
Trusted Access column at Amazon Web Services services that you can use with Organizations.
on this page. If you disable access by using this command, it causes the following actions
to occur:   The service can no longer create a service-linked role in the accounts in your
organization. This means that the service can't perform operations on your behalf on any
new accounts in your organization. The service can still perform operations in older
accounts until the service completes its clean-up from Organizations.    The service can no
longer perform tasks in the member accounts in the organization, unless those operations
are explicitly permitted by the IAM policies that are attached to your roles. This includes
any data aggregation from the member accounts to the management account, or to a delegated
administrator account, where relevant.   Some services detect this and clean up any
remaining data or resources related to the integration, while other services stop accessing
the organization but leave any historical data and configuration in place to support a
possible re-enabling of the integration.   Using the other service's console or commands to
disable the integration ensures that the other service is aware that it can clean up any
resources that are required only for the integration. How the service cleans up its
resources in the organization's accounts depends on that service. For more information, see
the documentation for the other Amazon Web Services service.   After you perform the
DisableAWSServiceAccess operation, the specified service can no longer perform operations
in your organization's accounts  For more information about integrating other services with
Organizations, including the list of services that work with Organizations, see Using
Organizations with other Amazon Web Services services in the Organizations User Guide. This
operation can be called only from the organization's management account.

# Arguments
- `service_principal`: The service principal name of the Amazon Web Services service for
  which you want to disable integration with your organization. This is typically in the form
  of a URL, such as  service-abbreviation.amazonaws.com.

"""
function disable_awsservice_access(
    ServicePrincipal; aws_config::AbstractAWSConfig=current_aws_config()
)
    return organizations(
        "DisableAWSServiceAccess",
        Dict{String,Any}("ServicePrincipal" => ServicePrincipal);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disable_awsservice_access(
    ServicePrincipal,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return organizations(
        "DisableAWSServiceAccess",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ServicePrincipal" => ServicePrincipal), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disable_policy_type(policy_type, root_id)
    disable_policy_type(policy_type, root_id, params::Dict{String,<:Any})

Disables an organizational policy type in a root. A policy of a certain type can be
attached to entities in a root only if that type is enabled in the root. After you perform
this operation, you no longer can attach policies of the specified type to that root or to
any organizational unit (OU) or account in that root. You can undo this by using the
EnablePolicyType operation. This is an asynchronous request that Amazon Web Services
performs in the background. If you disable a policy type for a root, it still appears
enabled for the organization if all features are enabled for the organization. Amazon Web
Services recommends that you first use ListRoots to see the status of policy types for a
specified root, and then use this operation. This operation can be called only from the
organization's management account or by a member account that is a delegated administrator
for an Amazon Web Services service.  To view the status of available policy types in the
organization, use DescribeOrganization.

# Arguments
- `policy_type`: The policy type that you want to disable in this root. You can specify one
  of the following values:    AISERVICES_OPT_OUT_POLICY     BACKUP_POLICY
  SERVICE_CONTROL_POLICY     TAG_POLICY
- `root_id`: The unique identifier (ID) of the root in which you want to disable a policy
  type. You can get the ID from the ListRoots operation. The regex pattern for a root ID
  string requires \"r-\" followed by from 4 to 32 lowercase letters or digits.

"""
function disable_policy_type(
    PolicyType, RootId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return organizations(
        "DisablePolicyType",
        Dict{String,Any}("PolicyType" => PolicyType, "RootId" => RootId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disable_policy_type(
    PolicyType,
    RootId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return organizations(
        "DisablePolicyType",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("PolicyType" => PolicyType, "RootId" => RootId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    enable_all_features()
    enable_all_features(params::Dict{String,<:Any})

Enables all features in an organization. This enables the use of organization policies that
can restrict the services and actions that can be called in each account. Until you enable
all features, you have access only to consolidated billing, and you can't use any of the
advanced account administration features that Organizations supports. For more information,
see Enabling all features in your organization in the Organizations User Guide.  This
operation is required only for organizations that were created explicitly with only the
consolidated billing features enabled. Calling this operation sends a handshake to every
invited account in the organization. The feature set change can be finalized and the
additional features enabled only after all administrators in the invited accounts approve
the change by accepting the handshake.  After you enable all features, you can separately
enable or disable individual policy types in a root using EnablePolicyType and
DisablePolicyType. To see the status of policy types in a root, use ListRoots. After all
invited member accounts accept the handshake, you finalize the feature set change by
accepting the handshake that contains \"Action\": \"ENABLE_ALL_FEATURES\". This completes
the change. After you enable all features in your organization, the management account in
the organization can apply policies on all member accounts. These policies can restrict
what users and even administrators in those accounts can do. The management account can
apply policies that prevent accounts from leaving the organization. Ensure that your
account administrators are aware of this. This operation can be called only from the
organization's management account.

"""
function enable_all_features(; aws_config::AbstractAWSConfig=current_aws_config())
    return organizations(
        "EnableAllFeatures"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function enable_all_features(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return organizations(
        "EnableAllFeatures", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    enable_awsservice_access(service_principal)
    enable_awsservice_access(service_principal, params::Dict{String,<:Any})

Enables the integration of an Amazon Web Services service (the service that is specified by
ServicePrincipal) with Organizations. When you enable integration, you allow the specified
service to create a service-linked role in all the accounts in your organization. This
allows the service to perform operations on your behalf in your organization and its
accounts.  We recommend that you enable integration between Organizations and the specified
Amazon Web Services service by using the console or commands that are provided by the
specified service. Doing so ensures that the service is aware that it can create the
resources that are required for the integration. How the service creates those resources in
the organization's accounts depends on that service. For more information, see the
documentation for the other Amazon Web Services service.  For more information about
enabling services to integrate with Organizations, see Using Organizations with other
Amazon Web Services services in the Organizations User Guide. You can only call this
operation from the organization's management account and only if the organization has
enabled all features.

# Arguments
- `service_principal`: The service principal name of the Amazon Web Services service for
  which you want to enable integration with your organization. This is typically in the form
  of a URL, such as  service-abbreviation.amazonaws.com.

"""
function enable_awsservice_access(
    ServicePrincipal; aws_config::AbstractAWSConfig=current_aws_config()
)
    return organizations(
        "EnableAWSServiceAccess",
        Dict{String,Any}("ServicePrincipal" => ServicePrincipal);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function enable_awsservice_access(
    ServicePrincipal,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return organizations(
        "EnableAWSServiceAccess",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ServicePrincipal" => ServicePrincipal), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    enable_policy_type(policy_type, root_id)
    enable_policy_type(policy_type, root_id, params::Dict{String,<:Any})

Enables a policy type in a root. After you enable a policy type in a root, you can attach
policies of that type to the root, any organizational unit (OU), or account in that root.
You can undo this by using the DisablePolicyType operation. This is an asynchronous request
that Amazon Web Services performs in the background. Amazon Web Services recommends that
you first use ListRoots to see the status of policy types for a specified root, and then
use this operation. This operation can be called only from the organization's management
account or by a member account that is a delegated administrator for an Amazon Web Services
service. You can enable a policy type in a root only if that policy type is available in
the organization. To view the status of available policy types in the organization, use
DescribeOrganization.

# Arguments
- `policy_type`: The policy type that you want to enable. You can specify one of the
  following values:    AISERVICES_OPT_OUT_POLICY     BACKUP_POLICY     SERVICE_CONTROL_POLICY
      TAG_POLICY
- `root_id`: The unique identifier (ID) of the root in which you want to enable a policy
  type. You can get the ID from the ListRoots operation. The regex pattern for a root ID
  string requires \"r-\" followed by from 4 to 32 lowercase letters or digits.

"""
function enable_policy_type(
    PolicyType, RootId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return organizations(
        "EnablePolicyType",
        Dict{String,Any}("PolicyType" => PolicyType, "RootId" => RootId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function enable_policy_type(
    PolicyType,
    RootId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return organizations(
        "EnablePolicyType",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("PolicyType" => PolicyType, "RootId" => RootId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    invite_account_to_organization(target)
    invite_account_to_organization(target, params::Dict{String,<:Any})

Sends an invitation to another account to join your organization as a member account.
Organizations sends email on your behalf to the email address that is associated with the
other account's owner. The invitation is implemented as a Handshake whose details are in
the response.    You can invite Amazon Web Services accounts only from the same seller as
the management account. For example, if your organization's management account was created
by Amazon Internet Services Pvt. Ltd (AISPL), an Amazon Web Services seller in India, you
can invite only other AISPL accounts to your organization. You can't combine accounts from
AISPL and Amazon Web Services or from any other Amazon Web Services seller. For more
information, see Consolidated billing in India.   If you receive an exception that
indicates that you exceeded your account limits for the organization or that the operation
failed because your organization is still initializing, wait one hour and then try again.
If the error persists after an hour, contact Amazon Web Services Support.    If the request
includes tags, then the requester must have the organizations:TagResource permission. This
operation can be called only from the organization's management account.

# Arguments
- `target`: The identifier (ID) of the Amazon Web Services account that you want to invite
  to join your organization. This is a JSON object that contains the following elements:  {
  \"Type\": \"ACCOUNT\", \"Id\": \"&lt; account id number &gt;\" }  If you use the CLI, you
  can submit this as a single string, similar to the following example:  --target
  Id=123456789012,Type=ACCOUNT  If you specify \"Type\": \"ACCOUNT\", you must provide the
  Amazon Web Services account ID number as the Id. If you specify \"Type\": \"EMAIL\", you
  must specify the email address that is associated with the account.  --target
  Id=diego@example.com,Type=EMAIL

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Notes"`: Additional information that you want to include in the generated email to the
  recipient account owner.
- `"Tags"`: A list of tags that you want to attach to the account when it becomes a member
  of the organization. For each tag in the list, you must specify both a tag key and a value.
  You can set the value to an empty string, but you can't set it to null. For more
  information about tagging, see Tagging Organizations resources in the Organizations User
  Guide.  Any tags in the request are checked for compliance with any applicable tag policies
  when the request is made. The request is rejected if the tags in the request don't match
  the requirements of the policy at that time. Tag policy compliance is  not  checked again
  when the invitation is accepted and the tags are actually attached to the account. That
  means that if the tag policy changes between the invitation and the acceptance, then that
  tags could potentially be non-compliant.   If any one of the tags is not valid or if you
  exceed the allowed number of tags for an account, then the entire request fails and
  invitations are not sent.
"""
function invite_account_to_organization(
    Target; aws_config::AbstractAWSConfig=current_aws_config()
)
    return organizations(
        "InviteAccountToOrganization",
        Dict{String,Any}("Target" => Target);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function invite_account_to_organization(
    Target, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return organizations(
        "InviteAccountToOrganization",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Target" => Target), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    leave_organization()
    leave_organization(params::Dict{String,<:Any})

Removes a member account from its parent organization. This version of the operation is
performed by the account that wants to leave. To remove a member account as a user in the
management account, use RemoveAccountFromOrganization instead. This operation can be called
only from a member account in the organization.    The management account in an
organization with all features enabled can set service control policies (SCPs) that can
restrict what administrators of member accounts can do. This includes preventing them from
successfully calling LeaveOrganization and leaving the organization.   You can leave an
organization as a member account only if the account is configured with the information
required to operate as a standalone account. When you create an account in an organization
using the Organizations console, API, or CLI commands, the information required of
standalone accounts is not automatically collected. For each account that you want to make
standalone, you must perform the following steps. If any of the steps are already completed
for this account, that step doesn't appear.   Choose a support plan   Provide and verify
the required contact information   Provide a current payment method   Amazon Web Services
uses the payment method to charge for any billable (not free tier) Amazon Web Services
activity that occurs while the account isn't attached to an organization. For more
information, see Considerations before removing an account from an organization in the
Organizations User Guide.   The account that you want to leave must not be a delegated
administrator account for any Amazon Web Services service enabled for your organization. If
the account is a delegated administrator, you must first change the delegated administrator
account to another account that is remaining in the organization.   You can leave an
organization only after you enable IAM user access to billing in your account. For more
information, see About IAM access to the Billing and Cost Management console in the Amazon
Web Services Billing and Cost Management User Guide.   After the account leaves the
organization, all tags that were attached to the account object in the organization are
deleted. Amazon Web Services accounts outside of an organization do not support tags.   A
newly created account has a waiting period before it can be removed from its organization.
If you get an error that indicates that a wait period is required, then try again in a few
days.   If you are using an organization principal to call LeaveOrganization across
multiple accounts, you can only do this up to 5 accounts per second in a single
organization.

"""
function leave_organization(; aws_config::AbstractAWSConfig=current_aws_config())
    return organizations(
        "LeaveOrganization"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function leave_organization(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return organizations(
        "LeaveOrganization", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_accounts()
    list_accounts(params::Dict{String,<:Any})

Lists all the accounts in the organization. To request only the accounts in a specified
root or organizational unit (OU), use the ListAccountsForParent operation instead.  Always
check the NextToken response parameter for a null value when calling a List* operation.
These operations can occasionally return an empty set of results even when there are more
results available. The NextToken response parameter value is null only when there are no
more results to display.  This operation can be called only from the organization's
management account or by a member account that is a delegated administrator for an Amazon
Web Services service.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The total number of results that you want included on each page of the
  response. If you do not include this parameter, it defaults to a value that is specific to
  the operation. If additional items exist beyond the maximum you specify, the NextToken
  response element is present and has a value (is not null). Include that value as the
  NextToken request parameter in the next call to the operation to get the next part of the
  results. Note that Organizations might return fewer results than the maximum even when
  there are more results available. You should check NextToken after every operation to
  ensure that you receive all of the results.
- `"NextToken"`: The parameter for receiving additional results if you receive a NextToken
  response in a previous request. A NextToken response indicates that more output is
  available. Set this parameter to the value of the previous call's NextToken response to
  indicate where the output should continue from.
"""
function list_accounts(; aws_config::AbstractAWSConfig=current_aws_config())
    return organizations(
        "ListAccounts"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_accounts(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return organizations(
        "ListAccounts", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_accounts_for_parent(parent_id)
    list_accounts_for_parent(parent_id, params::Dict{String,<:Any})

Lists the accounts in an organization that are contained by the specified target root or
organizational unit (OU). If you specify the root, you get a list of all the accounts that
aren't in any OU. If you specify an OU, you get a list of all the accounts in only that OU
and not in any child OUs. To get a list of all accounts in the organization, use the
ListAccounts operation.  Always check the NextToken response parameter for a null value
when calling a List* operation. These operations can occasionally return an empty set of
results even when there are more results available. The NextToken response parameter value
is null only when there are no more results to display.  This operation can be called only
from the organization's management account or by a member account that is a delegated
administrator for an Amazon Web Services service.

# Arguments
- `parent_id`: The unique identifier (ID) for the parent root or organization unit (OU)
  whose accounts you want to list.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The total number of results that you want included on each page of the
  response. If you do not include this parameter, it defaults to a value that is specific to
  the operation. If additional items exist beyond the maximum you specify, the NextToken
  response element is present and has a value (is not null). Include that value as the
  NextToken request parameter in the next call to the operation to get the next part of the
  results. Note that Organizations might return fewer results than the maximum even when
  there are more results available. You should check NextToken after every operation to
  ensure that you receive all of the results.
- `"NextToken"`: The parameter for receiving additional results if you receive a NextToken
  response in a previous request. A NextToken response indicates that more output is
  available. Set this parameter to the value of the previous call's NextToken response to
  indicate where the output should continue from.
"""
function list_accounts_for_parent(
    ParentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return organizations(
        "ListAccountsForParent",
        Dict{String,Any}("ParentId" => ParentId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_accounts_for_parent(
    ParentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return organizations(
        "ListAccountsForParent",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ParentId" => ParentId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_awsservice_access_for_organization()
    list_awsservice_access_for_organization(params::Dict{String,<:Any})

Returns a list of the Amazon Web Services services that you enabled to integrate with your
organization. After a service on this list creates the resources that it requires for the
integration, it can perform operations on your organization and its accounts. For more
information about integrating other services with Organizations, including the list of
services that currently work with Organizations, see Using Organizations with other Amazon
Web Services services in the Organizations User Guide. This operation can be called only
from the organization's management account or by a member account that is a delegated
administrator for an Amazon Web Services service.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The total number of results that you want included on each page of the
  response. If you do not include this parameter, it defaults to a value that is specific to
  the operation. If additional items exist beyond the maximum you specify, the NextToken
  response element is present and has a value (is not null). Include that value as the
  NextToken request parameter in the next call to the operation to get the next part of the
  results. Note that Organizations might return fewer results than the maximum even when
  there are more results available. You should check NextToken after every operation to
  ensure that you receive all of the results.
- `"NextToken"`: The parameter for receiving additional results if you receive a NextToken
  response in a previous request. A NextToken response indicates that more output is
  available. Set this parameter to the value of the previous call's NextToken response to
  indicate where the output should continue from.
"""
function list_awsservice_access_for_organization(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return organizations(
        "ListAWSServiceAccessForOrganization";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_awsservice_access_for_organization(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return organizations(
        "ListAWSServiceAccessForOrganization",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_children(child_type, parent_id)
    list_children(child_type, parent_id, params::Dict{String,<:Any})

Lists all of the organizational units (OUs) or accounts that are contained in the specified
parent OU or root. This operation, along with ListParents enables you to traverse the tree
structure that makes up this root.  Always check the NextToken response parameter for a
null value when calling a List* operation. These operations can occasionally return an
empty set of results even when there are more results available. The NextToken response
parameter value is null only when there are no more results to display.  This operation can
be called only from the organization's management account or by a member account that is a
delegated administrator for an Amazon Web Services service.

# Arguments
- `child_type`: Filters the output to include only the specified child type.
- `parent_id`: The unique identifier (ID) for the parent root or OU whose children you want
  to list. The regex pattern for a parent ID string requires one of the following:    Root -
  A string that begins with \"r-\" followed by from 4 to 32 lowercase letters or digits.
  Organizational unit (OU) - A string that begins with \"ou-\" followed by from 4 to 32
  lowercase letters or digits (the ID of the root that the OU is in). This string is followed
  by a second \"-\" dash and from 8 to 32 additional lowercase letters or digits.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The total number of results that you want included on each page of the
  response. If you do not include this parameter, it defaults to a value that is specific to
  the operation. If additional items exist beyond the maximum you specify, the NextToken
  response element is present and has a value (is not null). Include that value as the
  NextToken request parameter in the next call to the operation to get the next part of the
  results. Note that Organizations might return fewer results than the maximum even when
  there are more results available. You should check NextToken after every operation to
  ensure that you receive all of the results.
- `"NextToken"`: The parameter for receiving additional results if you receive a NextToken
  response in a previous request. A NextToken response indicates that more output is
  available. Set this parameter to the value of the previous call's NextToken response to
  indicate where the output should continue from.
"""
function list_children(
    ChildType, ParentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return organizations(
        "ListChildren",
        Dict{String,Any}("ChildType" => ChildType, "ParentId" => ParentId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_children(
    ChildType,
    ParentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return organizations(
        "ListChildren",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ChildType" => ChildType, "ParentId" => ParentId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_create_account_status()
    list_create_account_status(params::Dict{String,<:Any})

Lists the account creation requests that match the specified status that is currently being
tracked for the organization.  Always check the NextToken response parameter for a null
value when calling a List* operation. These operations can occasionally return an empty set
of results even when there are more results available. The NextToken response parameter
value is null only when there are no more results to display.  This operation can be called
only from the organization's management account or by a member account that is a delegated
administrator for an Amazon Web Services service.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The total number of results that you want included on each page of the
  response. If you do not include this parameter, it defaults to a value that is specific to
  the operation. If additional items exist beyond the maximum you specify, the NextToken
  response element is present and has a value (is not null). Include that value as the
  NextToken request parameter in the next call to the operation to get the next part of the
  results. Note that Organizations might return fewer results than the maximum even when
  there are more results available. You should check NextToken after every operation to
  ensure that you receive all of the results.
- `"NextToken"`: The parameter for receiving additional results if you receive a NextToken
  response in a previous request. A NextToken response indicates that more output is
  available. Set this parameter to the value of the previous call's NextToken response to
  indicate where the output should continue from.
- `"States"`: A list of one or more states that you want included in the response. If this
  parameter isn't present, all requests are included in the response.
"""
function list_create_account_status(; aws_config::AbstractAWSConfig=current_aws_config())
    return organizations(
        "ListCreateAccountStatus"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_create_account_status(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return organizations(
        "ListCreateAccountStatus",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_delegated_administrators()
    list_delegated_administrators(params::Dict{String,<:Any})

Lists the Amazon Web Services accounts that are designated as delegated administrators in
this organization. This operation can be called only from the organization's management
account or by a member account that is a delegated administrator for an Amazon Web Services
service.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The total number of results that you want included on each page of the
  response. If you do not include this parameter, it defaults to a value that is specific to
  the operation. If additional items exist beyond the maximum you specify, the NextToken
  response element is present and has a value (is not null). Include that value as the
  NextToken request parameter in the next call to the operation to get the next part of the
  results. Note that Organizations might return fewer results than the maximum even when
  there are more results available. You should check NextToken after every operation to
  ensure that you receive all of the results.
- `"NextToken"`: The parameter for receiving additional results if you receive a NextToken
  response in a previous request. A NextToken response indicates that more output is
  available. Set this parameter to the value of the previous call's NextToken response to
  indicate where the output should continue from.
- `"ServicePrincipal"`: Specifies a service principal name. If specified, then the
  operation lists the delegated administrators only for the specified service. If you don't
  specify a service principal, the operation lists all delegated administrators for all
  services in your organization.
"""
function list_delegated_administrators(; aws_config::AbstractAWSConfig=current_aws_config())
    return organizations(
        "ListDelegatedAdministrators";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_delegated_administrators(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return organizations(
        "ListDelegatedAdministrators",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_delegated_services_for_account(account_id)
    list_delegated_services_for_account(account_id, params::Dict{String,<:Any})

List the Amazon Web Services services for which the specified account is a delegated
administrator. This operation can be called only from the organization's management account
or by a member account that is a delegated administrator for an Amazon Web Services service.

# Arguments
- `account_id`: The account ID number of a delegated administrator account in the
  organization.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The total number of results that you want included on each page of the
  response. If you do not include this parameter, it defaults to a value that is specific to
  the operation. If additional items exist beyond the maximum you specify, the NextToken
  response element is present and has a value (is not null). Include that value as the
  NextToken request parameter in the next call to the operation to get the next part of the
  results. Note that Organizations might return fewer results than the maximum even when
  there are more results available. You should check NextToken after every operation to
  ensure that you receive all of the results.
- `"NextToken"`: The parameter for receiving additional results if you receive a NextToken
  response in a previous request. A NextToken response indicates that more output is
  available. Set this parameter to the value of the previous call's NextToken response to
  indicate where the output should continue from.
"""
function list_delegated_services_for_account(
    AccountId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return organizations(
        "ListDelegatedServicesForAccount",
        Dict{String,Any}("AccountId" => AccountId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_delegated_services_for_account(
    AccountId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return organizations(
        "ListDelegatedServicesForAccount",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AccountId" => AccountId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_handshakes_for_account()
    list_handshakes_for_account(params::Dict{String,<:Any})

Lists the current handshakes that are associated with the account of the requesting user.
Handshakes that are ACCEPTED, DECLINED, CANCELED, or EXPIRED appear in the results of this
API for only 30 days after changing to that state. After that, they're deleted and no
longer accessible.  Always check the NextToken response parameter for a null value when
calling a List* operation. These operations can occasionally return an empty set of results
even when there are more results available. The NextToken response parameter value is null
only when there are no more results to display.  This operation can be called from any
account in the organization.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filter"`: Filters the handshakes that you want included in the response. The default is
  all types. Use the ActionType element to limit the output to only a specified type, such as
  INVITE, ENABLE_ALL_FEATURES, or APPROVE_ALL_FEATURES. Alternatively, for the
  ENABLE_ALL_FEATURES handshake that generates a separate child handshake for each member
  account, you can specify ParentHandshakeId to see only the handshakes that were generated
  by that parent request.
- `"MaxResults"`: The total number of results that you want included on each page of the
  response. If you do not include this parameter, it defaults to a value that is specific to
  the operation. If additional items exist beyond the maximum you specify, the NextToken
  response element is present and has a value (is not null). Include that value as the
  NextToken request parameter in the next call to the operation to get the next part of the
  results. Note that Organizations might return fewer results than the maximum even when
  there are more results available. You should check NextToken after every operation to
  ensure that you receive all of the results.
- `"NextToken"`: The parameter for receiving additional results if you receive a NextToken
  response in a previous request. A NextToken response indicates that more output is
  available. Set this parameter to the value of the previous call's NextToken response to
  indicate where the output should continue from.
"""
function list_handshakes_for_account(; aws_config::AbstractAWSConfig=current_aws_config())
    return organizations(
        "ListHandshakesForAccount"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_handshakes_for_account(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return organizations(
        "ListHandshakesForAccount",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_handshakes_for_organization()
    list_handshakes_for_organization(params::Dict{String,<:Any})

Lists the handshakes that are associated with the organization that the requesting user is
part of. The ListHandshakesForOrganization operation returns a list of handshake
structures. Each structure contains details and status about a handshake. Handshakes that
are ACCEPTED, DECLINED, CANCELED, or EXPIRED appear in the results of this API for only 30
days after changing to that state. After that, they're deleted and no longer accessible.
Always check the NextToken response parameter for a null value when calling a List*
operation. These operations can occasionally return an empty set of results even when there
are more results available. The NextToken response parameter value is null only when there
are no more results to display.  This operation can be called only from the organization's
management account or by a member account that is a delegated administrator for an Amazon
Web Services service.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filter"`: A filter of the handshakes that you want included in the response. The
  default is all types. Use the ActionType element to limit the output to only a specified
  type, such as INVITE, ENABLE-ALL-FEATURES, or APPROVE-ALL-FEATURES. Alternatively, for the
  ENABLE-ALL-FEATURES handshake that generates a separate child handshake for each member
  account, you can specify the ParentHandshakeId to see only the handshakes that were
  generated by that parent request.
- `"MaxResults"`: The total number of results that you want included on each page of the
  response. If you do not include this parameter, it defaults to a value that is specific to
  the operation. If additional items exist beyond the maximum you specify, the NextToken
  response element is present and has a value (is not null). Include that value as the
  NextToken request parameter in the next call to the operation to get the next part of the
  results. Note that Organizations might return fewer results than the maximum even when
  there are more results available. You should check NextToken after every operation to
  ensure that you receive all of the results.
- `"NextToken"`: The parameter for receiving additional results if you receive a NextToken
  response in a previous request. A NextToken response indicates that more output is
  available. Set this parameter to the value of the previous call's NextToken response to
  indicate where the output should continue from.
"""
function list_handshakes_for_organization(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return organizations(
        "ListHandshakesForOrganization";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_handshakes_for_organization(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return organizations(
        "ListHandshakesForOrganization",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_organizational_units_for_parent(parent_id)
    list_organizational_units_for_parent(parent_id, params::Dict{String,<:Any})

Lists the organizational units (OUs) in a parent organizational unit or root.  Always check
the NextToken response parameter for a null value when calling a List* operation. These
operations can occasionally return an empty set of results even when there are more results
available. The NextToken response parameter value is null only when there are no more
results to display.  This operation can be called only from the organization's management
account or by a member account that is a delegated administrator for an Amazon Web Services
service.

# Arguments
- `parent_id`: The unique identifier (ID) of the root or OU whose child OUs you want to
  list. The regex pattern for a parent ID string requires one of the following:    Root - A
  string that begins with \"r-\" followed by from 4 to 32 lowercase letters or digits.
  Organizational unit (OU) - A string that begins with \"ou-\" followed by from 4 to 32
  lowercase letters or digits (the ID of the root that the OU is in). This string is followed
  by a second \"-\" dash and from 8 to 32 additional lowercase letters or digits.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The total number of results that you want included on each page of the
  response. If you do not include this parameter, it defaults to a value that is specific to
  the operation. If additional items exist beyond the maximum you specify, the NextToken
  response element is present and has a value (is not null). Include that value as the
  NextToken request parameter in the next call to the operation to get the next part of the
  results. Note that Organizations might return fewer results than the maximum even when
  there are more results available. You should check NextToken after every operation to
  ensure that you receive all of the results.
- `"NextToken"`: The parameter for receiving additional results if you receive a NextToken
  response in a previous request. A NextToken response indicates that more output is
  available. Set this parameter to the value of the previous call's NextToken response to
  indicate where the output should continue from.
"""
function list_organizational_units_for_parent(
    ParentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return organizations(
        "ListOrganizationalUnitsForParent",
        Dict{String,Any}("ParentId" => ParentId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_organizational_units_for_parent(
    ParentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return organizations(
        "ListOrganizationalUnitsForParent",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ParentId" => ParentId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_parents(child_id)
    list_parents(child_id, params::Dict{String,<:Any})

Lists the root or organizational units (OUs) that serve as the immediate parent of the
specified child OU or account. This operation, along with ListChildren enables you to
traverse the tree structure that makes up this root.  Always check the NextToken response
parameter for a null value when calling a List* operation. These operations can
occasionally return an empty set of results even when there are more results available. The
NextToken response parameter value is null only when there are no more results to display.
This operation can be called only from the organization's management account or by a member
account that is a delegated administrator for an Amazon Web Services service.  In the
current release, a child can have only a single parent.

# Arguments
- `child_id`: The unique identifier (ID) of the OU or account whose parent containers you
  want to list. Don't specify a root. The regex pattern for a child ID string requires one of
  the following:    Account - A string that consists of exactly 12 digits.    Organizational
  unit (OU) - A string that begins with \"ou-\" followed by from 4 to 32 lowercase letters or
  digits (the ID of the root that contains the OU). This string is followed by a second \"-\"
  dash and from 8 to 32 additional lowercase letters or digits.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The total number of results that you want included on each page of the
  response. If you do not include this parameter, it defaults to a value that is specific to
  the operation. If additional items exist beyond the maximum you specify, the NextToken
  response element is present and has a value (is not null). Include that value as the
  NextToken request parameter in the next call to the operation to get the next part of the
  results. Note that Organizations might return fewer results than the maximum even when
  there are more results available. You should check NextToken after every operation to
  ensure that you receive all of the results.
- `"NextToken"`: The parameter for receiving additional results if you receive a NextToken
  response in a previous request. A NextToken response indicates that more output is
  available. Set this parameter to the value of the previous call's NextToken response to
  indicate where the output should continue from.
"""
function list_parents(ChildId; aws_config::AbstractAWSConfig=current_aws_config())
    return organizations(
        "ListParents",
        Dict{String,Any}("ChildId" => ChildId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_parents(
    ChildId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return organizations(
        "ListParents",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("ChildId" => ChildId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_policies(filter)
    list_policies(filter, params::Dict{String,<:Any})

Retrieves the list of all policies in an organization of a specified type.  Always check
the NextToken response parameter for a null value when calling a List* operation. These
operations can occasionally return an empty set of results even when there are more results
available. The NextToken response parameter value is null only when there are no more
results to display.  This operation can be called only from the organization's management
account or by a member account that is a delegated administrator for an Amazon Web Services
service.

# Arguments
- `filter`: Specifies the type of policy that you want to include in the response. You must
  specify one of the following values:    AISERVICES_OPT_OUT_POLICY     BACKUP_POLICY
  SERVICE_CONTROL_POLICY     TAG_POLICY

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The total number of results that you want included on each page of the
  response. If you do not include this parameter, it defaults to a value that is specific to
  the operation. If additional items exist beyond the maximum you specify, the NextToken
  response element is present and has a value (is not null). Include that value as the
  NextToken request parameter in the next call to the operation to get the next part of the
  results. Note that Organizations might return fewer results than the maximum even when
  there are more results available. You should check NextToken after every operation to
  ensure that you receive all of the results.
- `"NextToken"`: The parameter for receiving additional results if you receive a NextToken
  response in a previous request. A NextToken response indicates that more output is
  available. Set this parameter to the value of the previous call's NextToken response to
  indicate where the output should continue from.
"""
function list_policies(Filter; aws_config::AbstractAWSConfig=current_aws_config())
    return organizations(
        "ListPolicies",
        Dict{String,Any}("Filter" => Filter);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_policies(
    Filter, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return organizations(
        "ListPolicies",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Filter" => Filter), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_policies_for_target(filter, target_id)
    list_policies_for_target(filter, target_id, params::Dict{String,<:Any})

Lists the policies that are directly attached to the specified target root, organizational
unit (OU), or account. You must specify the policy type that you want included in the
returned list.  Always check the NextToken response parameter for a null value when calling
a List* operation. These operations can occasionally return an empty set of results even
when there are more results available. The NextToken response parameter value is null only
when there are no more results to display.  This operation can be called only from the
organization's management account or by a member account that is a delegated administrator
for an Amazon Web Services service.

# Arguments
- `filter`: The type of policy that you want to include in the returned list. You must
  specify one of the following values:    AISERVICES_OPT_OUT_POLICY     BACKUP_POLICY
  SERVICE_CONTROL_POLICY     TAG_POLICY
- `target_id`: The unique identifier (ID) of the root, organizational unit, or account
  whose policies you want to list. The regex pattern for a target ID string requires one of
  the following:    Root - A string that begins with \"r-\" followed by from 4 to 32
  lowercase letters or digits.    Account - A string that consists of exactly 12 digits.
  Organizational unit (OU) - A string that begins with \"ou-\" followed by from 4 to 32
  lowercase letters or digits (the ID of the root that the OU is in). This string is followed
  by a second \"-\" dash and from 8 to 32 additional lowercase letters or digits.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The total number of results that you want included on each page of the
  response. If you do not include this parameter, it defaults to a value that is specific to
  the operation. If additional items exist beyond the maximum you specify, the NextToken
  response element is present and has a value (is not null). Include that value as the
  NextToken request parameter in the next call to the operation to get the next part of the
  results. Note that Organizations might return fewer results than the maximum even when
  there are more results available. You should check NextToken after every operation to
  ensure that you receive all of the results.
- `"NextToken"`: The parameter for receiving additional results if you receive a NextToken
  response in a previous request. A NextToken response indicates that more output is
  available. Set this parameter to the value of the previous call's NextToken response to
  indicate where the output should continue from.
"""
function list_policies_for_target(
    Filter, TargetId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return organizations(
        "ListPoliciesForTarget",
        Dict{String,Any}("Filter" => Filter, "TargetId" => TargetId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_policies_for_target(
    Filter,
    TargetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return organizations(
        "ListPoliciesForTarget",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("Filter" => Filter, "TargetId" => TargetId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_roots()
    list_roots(params::Dict{String,<:Any})

Lists the roots that are defined in the current organization.  Always check the NextToken
response parameter for a null value when calling a List* operation. These operations can
occasionally return an empty set of results even when there are more results available. The
NextToken response parameter value is null only when there are no more results to display.
This operation can be called only from the organization's management account or by a member
account that is a delegated administrator for an Amazon Web Services service.  Policy types
can be enabled and disabled in roots. This is distinct from whether they're available in
the organization. When you enable all features, you make policy types available for use in
that organization. Individual policy types can then be enabled and disabled in a root. To
see the availability of a policy type in an organization, use DescribeOrganization.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The total number of results that you want included on each page of the
  response. If you do not include this parameter, it defaults to a value that is specific to
  the operation. If additional items exist beyond the maximum you specify, the NextToken
  response element is present and has a value (is not null). Include that value as the
  NextToken request parameter in the next call to the operation to get the next part of the
  results. Note that Organizations might return fewer results than the maximum even when
  there are more results available. You should check NextToken after every operation to
  ensure that you receive all of the results.
- `"NextToken"`: The parameter for receiving additional results if you receive a NextToken
  response in a previous request. A NextToken response indicates that more output is
  available. Set this parameter to the value of the previous call's NextToken response to
  indicate where the output should continue from.
"""
function list_roots(; aws_config::AbstractAWSConfig=current_aws_config())
    return organizations(
        "ListRoots"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_roots(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return organizations(
        "ListRoots", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_id)
    list_tags_for_resource(resource_id, params::Dict{String,<:Any})

Lists tags that are attached to the specified resource. You can attach tags to the
following resources in Organizations.   Amazon Web Services account   Organization root
Organizational unit (OU)   Policy (any type)   This operation can be called only from the
organization's management account or by a member account that is a delegated administrator
for an Amazon Web Services service.

# Arguments
- `resource_id`: The ID of the resource with the tags to list. You can specify any of the
  following taggable resources.   Amazon Web Services account – specify the account ID
  number.   Organizational unit – specify the OU ID that begins with ou- and looks similar
  to: ou-1a2b-34uvwxyz     Root – specify the root ID that begins with r- and looks similar
  to: r-1a2b     Policy – specify the policy ID that begins with p- andlooks similar to:
  p-12abcdefg3

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: The parameter for receiving additional results if you receive a NextToken
  response in a previous request. A NextToken response indicates that more output is
  available. Set this parameter to the value of the previous call's NextToken response to
  indicate where the output should continue from.
"""
function list_tags_for_resource(
    ResourceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return organizations(
        "ListTagsForResource",
        Dict{String,Any}("ResourceId" => ResourceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return organizations(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceId" => ResourceId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_targets_for_policy(policy_id)
    list_targets_for_policy(policy_id, params::Dict{String,<:Any})

Lists all the roots, organizational units (OUs), and accounts that the specified policy is
attached to.  Always check the NextToken response parameter for a null value when calling a
List* operation. These operations can occasionally return an empty set of results even when
there are more results available. The NextToken response parameter value is null only when
there are no more results to display.  This operation can be called only from the
organization's management account or by a member account that is a delegated administrator
for an Amazon Web Services service.

# Arguments
- `policy_id`: The unique identifier (ID) of the policy whose attachments you want to know.
  The regex pattern for a policy ID string requires \"p-\" followed by from 8 to 128
  lowercase or uppercase letters, digits, or the underscore character (_).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The total number of results that you want included on each page of the
  response. If you do not include this parameter, it defaults to a value that is specific to
  the operation. If additional items exist beyond the maximum you specify, the NextToken
  response element is present and has a value (is not null). Include that value as the
  NextToken request parameter in the next call to the operation to get the next part of the
  results. Note that Organizations might return fewer results than the maximum even when
  there are more results available. You should check NextToken after every operation to
  ensure that you receive all of the results.
- `"NextToken"`: The parameter for receiving additional results if you receive a NextToken
  response in a previous request. A NextToken response indicates that more output is
  available. Set this parameter to the value of the previous call's NextToken response to
  indicate where the output should continue from.
"""
function list_targets_for_policy(
    PolicyId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return organizations(
        "ListTargetsForPolicy",
        Dict{String,Any}("PolicyId" => PolicyId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_targets_for_policy(
    PolicyId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return organizations(
        "ListTargetsForPolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("PolicyId" => PolicyId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    move_account(account_id, destination_parent_id, source_parent_id)
    move_account(account_id, destination_parent_id, source_parent_id, params::Dict{String,<:Any})

Moves an account from its current source parent root or organizational unit (OU) to the
specified destination parent root or OU. This operation can be called only from the
organization's management account.

# Arguments
- `account_id`: The unique identifier (ID) of the account that you want to move. The regex
  pattern for an account ID string requires exactly 12 digits.
- `destination_parent_id`: The unique identifier (ID) of the root or organizational unit
  that you want to move the account to. The regex pattern for a parent ID string requires one
  of the following:    Root - A string that begins with \"r-\" followed by from 4 to 32
  lowercase letters or digits.    Organizational unit (OU) - A string that begins with
  \"ou-\" followed by from 4 to 32 lowercase letters or digits (the ID of the root that the
  OU is in). This string is followed by a second \"-\" dash and from 8 to 32 additional
  lowercase letters or digits.
- `source_parent_id`: The unique identifier (ID) of the root or organizational unit that
  you want to move the account from. The regex pattern for a parent ID string requires one of
  the following:    Root - A string that begins with \"r-\" followed by from 4 to 32
  lowercase letters or digits.    Organizational unit (OU) - A string that begins with
  \"ou-\" followed by from 4 to 32 lowercase letters or digits (the ID of the root that the
  OU is in). This string is followed by a second \"-\" dash and from 8 to 32 additional
  lowercase letters or digits.

"""
function move_account(
    AccountId,
    DestinationParentId,
    SourceParentId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return organizations(
        "MoveAccount",
        Dict{String,Any}(
            "AccountId" => AccountId,
            "DestinationParentId" => DestinationParentId,
            "SourceParentId" => SourceParentId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function move_account(
    AccountId,
    DestinationParentId,
    SourceParentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return organizations(
        "MoveAccount",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AccountId" => AccountId,
                    "DestinationParentId" => DestinationParentId,
                    "SourceParentId" => SourceParentId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_resource_policy(content)
    put_resource_policy(content, params::Dict{String,<:Any})

Creates or updates a resource policy. You can only call this operation from the
organization's management account.

# Arguments
- `content`: If provided, the new content for the resource policy. The text must be
  correctly formatted JSON that complies with the syntax for the resource policy's type. For
  more information, see SCP syntax in the Organizations User Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: A list of tags that you want to attach to the newly created resource policy.
  For each tag in the list, you must specify both a tag key and a value. You can set the
  value to an empty string, but you can't set it to null. For more information about tagging,
  see Tagging Organizations resources in the Organizations User Guide.  Calls with tags apply
  to the initial creation of the resource policy, otherwise an exception is thrown. If any
  one of the tags is not valid or if you exceed the allowed number of tags for the resource
  policy, then the entire request fails and the resource policy is not created.
"""
function put_resource_policy(Content; aws_config::AbstractAWSConfig=current_aws_config())
    return organizations(
        "PutResourcePolicy",
        Dict{String,Any}("Content" => Content);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_resource_policy(
    Content,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return organizations(
        "PutResourcePolicy",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Content" => Content), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    register_delegated_administrator(account_id, service_principal)
    register_delegated_administrator(account_id, service_principal, params::Dict{String,<:Any})

Enables the specified member account to administer the Organizations features of the
specified Amazon Web Services service. It grants read-only access to Organizations service
data. The account still requires IAM permissions to access and administer the Amazon Web
Services service. You can run this action only for Amazon Web Services services that
support this feature. For a current list of services that support it, see the column
Supports Delegated Administrator in the table at Amazon Web Services Services that you can
use with Organizations in the Organizations User Guide.  This operation can be called only
from the organization's management account.

# Arguments
- `account_id`: The account ID number of the member account in the organization to register
  as a delegated administrator.
- `service_principal`: The service principal of the Amazon Web Services service for which
  you want to make the member account a delegated administrator.

"""
function register_delegated_administrator(
    AccountId, ServicePrincipal; aws_config::AbstractAWSConfig=current_aws_config()
)
    return organizations(
        "RegisterDelegatedAdministrator",
        Dict{String,Any}("AccountId" => AccountId, "ServicePrincipal" => ServicePrincipal);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function register_delegated_administrator(
    AccountId,
    ServicePrincipal,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return organizations(
        "RegisterDelegatedAdministrator",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AccountId" => AccountId, "ServicePrincipal" => ServicePrincipal
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_account_from_organization(account_id)
    remove_account_from_organization(account_id, params::Dict{String,<:Any})

Removes the specified account from the organization. The removed account becomes a
standalone account that isn't a member of any organization. It's no longer subject to any
policies and is responsible for its own bill payments. The organization's management
account is no longer charged for any expenses accrued by the member account after it's
removed from the organization. This operation can be called only from the organization's
management account. Member accounts can remove themselves with LeaveOrganization instead.
 You can remove an account from your organization only if the account is configured with
the information required to operate as a standalone account. When you create an account in
an organization using the Organizations console, API, or CLI commands, the information
required of standalone accounts is not automatically collected. For more information, see
Considerations before removing an account from an organization in the Organizations User
Guide.   The account that you want to leave must not be a delegated administrator account
for any Amazon Web Services service enabled for your organization. If the account is a
delegated administrator, you must first change the delegated administrator account to
another account that is remaining in the organization.   After the account leaves the
organization, all tags that were attached to the account object in the organization are
deleted. Amazon Web Services accounts outside of an organization do not support tags.

# Arguments
- `account_id`: The unique identifier (ID) of the member account that you want to remove
  from the organization. The regex pattern for an account ID string requires exactly 12
  digits.

"""
function remove_account_from_organization(
    AccountId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return organizations(
        "RemoveAccountFromOrganization",
        Dict{String,Any}("AccountId" => AccountId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_account_from_organization(
    AccountId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return organizations(
        "RemoveAccountFromOrganization",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AccountId" => AccountId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_id, tags)
    tag_resource(resource_id, tags, params::Dict{String,<:Any})

Adds one or more tags to the specified resource. Currently, you can attach tags to the
following resources in Organizations.   Amazon Web Services account   Organization root
Organizational unit (OU)   Policy (any type)   This operation can be called only from the
organization's management account or by a member account that is a delegated administrator
for an Amazon Web Services service.

# Arguments
- `resource_id`: The ID of the resource to add a tag to. You can specify any of the
  following taggable resources.   Amazon Web Services account – specify the account ID
  number.   Organizational unit – specify the OU ID that begins with ou- and looks similar
  to: ou-1a2b-34uvwxyz     Root – specify the root ID that begins with r- and looks similar
  to: r-1a2b     Policy – specify the policy ID that begins with p- andlooks similar to:
  p-12abcdefg3
- `tags`: A list of tags to add to the specified resource. For each tag in the list, you
  must specify both a tag key and a value. The value can be an empty string, but you can't
  set it to null.  If any one of the tags is not valid or if you exceed the maximum allowed
  number of tags for a resource, then the entire request fails.

"""
function tag_resource(ResourceId, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return organizations(
        "TagResource",
        Dict{String,Any}("ResourceId" => ResourceId, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceId,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return organizations(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ResourceId" => ResourceId, "Tags" => Tags), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_id, tag_keys)
    untag_resource(resource_id, tag_keys, params::Dict{String,<:Any})

Removes any tags with the specified keys from the specified resource. You can attach tags
to the following resources in Organizations.   Amazon Web Services account   Organization
root   Organizational unit (OU)   Policy (any type)   This operation can be called only
from the organization's management account or by a member account that is a delegated
administrator for an Amazon Web Services service.

# Arguments
- `resource_id`: The ID of the resource to remove a tag from. You can specify any of the
  following taggable resources.   Amazon Web Services account – specify the account ID
  number.   Organizational unit – specify the OU ID that begins with ou- and looks similar
  to: ou-1a2b-34uvwxyz     Root – specify the root ID that begins with r- and looks similar
  to: r-1a2b     Policy – specify the policy ID that begins with p- andlooks similar to:
  p-12abcdefg3
- `tag_keys`: The list of keys for tags to remove from the specified resource.

"""
function untag_resource(
    ResourceId, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return organizations(
        "UntagResource",
        Dict{String,Any}("ResourceId" => ResourceId, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceId,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return organizations(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceId" => ResourceId, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_organizational_unit(organizational_unit_id)
    update_organizational_unit(organizational_unit_id, params::Dict{String,<:Any})

Renames the specified organizational unit (OU). The ID and ARN don't change. The child OUs
and accounts remain in place, and any attached policies of the OU remain attached. This
operation can be called only from the organization's management account.

# Arguments
- `organizational_unit_id`: The unique identifier (ID) of the OU that you want to rename.
  You can get the ID from the ListOrganizationalUnitsForParent operation. The regex pattern
  for an organizational unit ID string requires \"ou-\" followed by from 4 to 32 lowercase
  letters or digits (the ID of the root that contains the OU). This string is followed by a
  second \"-\" dash and from 8 to 32 additional lowercase letters or digits.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Name"`: The new name that you want to assign to the OU. The regex pattern that is used
  to validate this parameter is a string of any of the characters in the ASCII character
  range.
"""
function update_organizational_unit(
    OrganizationalUnitId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return organizations(
        "UpdateOrganizationalUnit",
        Dict{String,Any}("OrganizationalUnitId" => OrganizationalUnitId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_organizational_unit(
    OrganizationalUnitId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return organizations(
        "UpdateOrganizationalUnit",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("OrganizationalUnitId" => OrganizationalUnitId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_policy(policy_id)
    update_policy(policy_id, params::Dict{String,<:Any})

Updates an existing policy with a new name, description, or content. If you don't supply
any parameter, that value remains unchanged. You can't change a policy's type. This
operation can be called only from the organization's management account or by a member
account that is a delegated administrator for an Amazon Web Services service.

# Arguments
- `policy_id`: The unique identifier (ID) of the policy that you want to update. The regex
  pattern for a policy ID string requires \"p-\" followed by from 8 to 128 lowercase or
  uppercase letters, digits, or the underscore character (_).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Content"`: If provided, the new content for the policy. The text must be correctly
  formatted JSON that complies with the syntax for the policy's type. For more information,
  see SCP syntax in the Organizations User Guide. The maximum size of a policy document
  depends on the policy's type. For more information, see Maximum and minimum values in the
  Organizations User Guide.
- `"Description"`: If provided, the new description for the policy.
- `"Name"`: If provided, the new name for the policy. The regex pattern that is used to
  validate this parameter is a string of any of the characters in the ASCII character range.
"""
function update_policy(PolicyId; aws_config::AbstractAWSConfig=current_aws_config())
    return organizations(
        "UpdatePolicy",
        Dict{String,Any}("PolicyId" => PolicyId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_policy(
    PolicyId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return organizations(
        "UpdatePolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("PolicyId" => PolicyId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: sso_admin
using AWS.Compat
using AWS.UUIDs

"""
    attach_customer_managed_policy_reference_to_permission_set(customer_managed_policy_reference, instance_arn, permission_set_arn)
    attach_customer_managed_policy_reference_to_permission_set(customer_managed_policy_reference, instance_arn, permission_set_arn, params::Dict{String,<:Any})

Attaches the specified customer managed policy to the specified PermissionSet.

# Arguments
- `customer_managed_policy_reference`: Specifies the name and path of a customer managed
  policy. You must have an IAM policy that matches the name and path in each Amazon Web
  Services account where you want to deploy your permission set.
- `instance_arn`: The ARN of the IAM Identity Center instance under which the operation
  will be executed.
- `permission_set_arn`: The ARN of the PermissionSet.

"""
function attach_customer_managed_policy_reference_to_permission_set(
    CustomerManagedPolicyReference,
    InstanceArn,
    PermissionSetArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "AttachCustomerManagedPolicyReferenceToPermissionSet",
        Dict{String,Any}(
            "CustomerManagedPolicyReference" => CustomerManagedPolicyReference,
            "InstanceArn" => InstanceArn,
            "PermissionSetArn" => PermissionSetArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function attach_customer_managed_policy_reference_to_permission_set(
    CustomerManagedPolicyReference,
    InstanceArn,
    PermissionSetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "AttachCustomerManagedPolicyReferenceToPermissionSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CustomerManagedPolicyReference" => CustomerManagedPolicyReference,
                    "InstanceArn" => InstanceArn,
                    "PermissionSetArn" => PermissionSetArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    attach_managed_policy_to_permission_set(instance_arn, managed_policy_arn, permission_set_arn)
    attach_managed_policy_to_permission_set(instance_arn, managed_policy_arn, permission_set_arn, params::Dict{String,<:Any})

Attaches an Amazon Web Services managed policy ARN to a permission set.  If the permission
set is already referenced by one or more account assignments, you will need to call
ProvisionPermissionSet  after this operation. Calling ProvisionPermissionSet applies the
corresponding IAM policy updates to all assigned accounts.

# Arguments
- `instance_arn`: The ARN of the IAM Identity Center instance under which the operation
  will be executed. For more information about ARNs, see Amazon Resource Names (ARNs) and
  Amazon Web Services Service Namespaces in the Amazon Web Services General Reference.
- `managed_policy_arn`: The Amazon Web Services managed policy ARN to be attached to a
  permission set.
- `permission_set_arn`: The ARN of the PermissionSet that the managed policy should be
  attached to.

"""
function attach_managed_policy_to_permission_set(
    InstanceArn,
    ManagedPolicyArn,
    PermissionSetArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "AttachManagedPolicyToPermissionSet",
        Dict{String,Any}(
            "InstanceArn" => InstanceArn,
            "ManagedPolicyArn" => ManagedPolicyArn,
            "PermissionSetArn" => PermissionSetArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function attach_managed_policy_to_permission_set(
    InstanceArn,
    ManagedPolicyArn,
    PermissionSetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "AttachManagedPolicyToPermissionSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "InstanceArn" => InstanceArn,
                    "ManagedPolicyArn" => ManagedPolicyArn,
                    "PermissionSetArn" => PermissionSetArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_account_assignment(instance_arn, permission_set_arn, principal_id, principal_type, target_id, target_type)
    create_account_assignment(instance_arn, permission_set_arn, principal_id, principal_type, target_id, target_type, params::Dict{String,<:Any})

Assigns access to a principal for a specified Amazon Web Services account using a specified
permission set.  The term principal here refers to a user or group that is defined in IAM
Identity Center.   As part of a successful CreateAccountAssignment call, the specified
permission set will automatically be provisioned to the account in the form of an IAM
policy. That policy is attached to the IAM role created in IAM Identity Center. If the
permission set is subsequently updated, the corresponding IAM policies attached to roles in
your accounts will not be updated automatically. In this case, you must call
ProvisionPermissionSet  to make these updates.    After a successful response, call
DescribeAccountAssignmentCreationStatus to describe the status of an assignment creation
request.

# Arguments
- `instance_arn`: The ARN of the IAM Identity Center instance under which the operation
  will be executed. For more information about ARNs, see Amazon Resource Names (ARNs) and
  Amazon Web Services Service Namespaces in the Amazon Web Services General Reference.
- `permission_set_arn`: The ARN of the permission set that the admin wants to grant the
  principal access to.
- `principal_id`: An identifier for an object in IAM Identity Center, such as a user or
  group. PrincipalIds are GUIDs (For example, f81d4fae-7dec-11d0-a765-00a0c91e6bf6). For more
  information about PrincipalIds in IAM Identity Center, see the IAM Identity Center Identity
  Store API Reference.
- `principal_type`: The entity type for which the assignment will be created.
- `target_id`: TargetID is an Amazon Web Services account identifier, (For example,
  123456789012).
- `target_type`: The entity type for which the assignment will be created.

"""
function create_account_assignment(
    InstanceArn,
    PermissionSetArn,
    PrincipalId,
    PrincipalType,
    TargetId,
    TargetType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "CreateAccountAssignment",
        Dict{String,Any}(
            "InstanceArn" => InstanceArn,
            "PermissionSetArn" => PermissionSetArn,
            "PrincipalId" => PrincipalId,
            "PrincipalType" => PrincipalType,
            "TargetId" => TargetId,
            "TargetType" => TargetType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_account_assignment(
    InstanceArn,
    PermissionSetArn,
    PrincipalId,
    PrincipalType,
    TargetId,
    TargetType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "CreateAccountAssignment",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "InstanceArn" => InstanceArn,
                    "PermissionSetArn" => PermissionSetArn,
                    "PrincipalId" => PrincipalId,
                    "PrincipalType" => PrincipalType,
                    "TargetId" => TargetId,
                    "TargetType" => TargetType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_application(application_provider_arn, instance_arn, name)
    create_application(application_provider_arn, instance_arn, name, params::Dict{String,<:Any})

Creates an application in IAM Identity Center for the given application provider.

# Arguments
- `application_provider_arn`: The ARN of the application provider under which the operation
  will run.
- `instance_arn`: The ARN of the instance of IAM Identity Center under which the operation
  will run. For more information about ARNs, see Amazon Resource Names (ARNs) and Amazon Web
  Services Service Namespaces in the Amazon Web Services General Reference.
- `name`: The name of the .

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: Specifies a unique, case-sensitive ID that you provide to ensure the
  idempotency of the request. This lets you safely retry the request without accidentally
  performing the same operation a second time. Passing the same value to a later call to an
  operation requires that you also pass the same value for all other parameters. We recommend
  that you use a UUID type of value. If you don't provide this value, then Amazon Web
  Services generates a random one for you. If you retry the operation with the same
  ClientToken, but with different parameters, the retry fails with an
  IdempotentParameterMismatch error.
- `"Description"`: The description of the .
- `"PortalOptions"`: A structure that describes the options for the portal associated with
  an application.
- `"Status"`: Specifies whether the application is enabled or disabled.
- `"Tags"`: Specifies tags to be attached to the application.
"""
function create_application(
    ApplicationProviderArn,
    InstanceArn,
    Name;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "CreateApplication",
        Dict{String,Any}(
            "ApplicationProviderArn" => ApplicationProviderArn,
            "InstanceArn" => InstanceArn,
            "Name" => Name,
            "ClientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_application(
    ApplicationProviderArn,
    InstanceArn,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "CreateApplication",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationProviderArn" => ApplicationProviderArn,
                    "InstanceArn" => InstanceArn,
                    "Name" => Name,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_application_assignment(application_arn, principal_id, principal_type)
    create_application_assignment(application_arn, principal_id, principal_type, params::Dict{String,<:Any})

Grant application access to a user or group.

# Arguments
- `application_arn`: The ARN of the application provider under which the operation will run.
- `principal_id`: An identifier for an object in IAM Identity Center, such as a user or
  group. PrincipalIds are GUIDs (For example, f81d4fae-7dec-11d0-a765-00a0c91e6bf6). For more
  information about PrincipalIds in IAM Identity Center, see the IAM Identity Center Identity
  Store API Reference.
- `principal_type`: The entity type for which the assignment will be created.

"""
function create_application_assignment(
    ApplicationArn,
    PrincipalId,
    PrincipalType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "CreateApplicationAssignment",
        Dict{String,Any}(
            "ApplicationArn" => ApplicationArn,
            "PrincipalId" => PrincipalId,
            "PrincipalType" => PrincipalType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_application_assignment(
    ApplicationArn,
    PrincipalId,
    PrincipalType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "CreateApplicationAssignment",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationArn" => ApplicationArn,
                    "PrincipalId" => PrincipalId,
                    "PrincipalType" => PrincipalType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_instance()
    create_instance(params::Dict{String,<:Any})

Creates an instance of IAM Identity Center for a standalone Amazon Web Services account
that is not managed by Organizations or a member Amazon Web Services account in an
organization. You can create only one instance per account and across all Amazon Web
Services Regions. The CreateInstance request is rejected if the following apply:    The
instance is created within the organization management account.   An instance already
exists in the same account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: Specifies a unique, case-sensitive ID that you provide to ensure the
  idempotency of the request. This lets you safely retry the request without accidentally
  performing the same operation a second time. Passing the same value to a later call to an
  operation requires that you also pass the same value for all other parameters. We recommend
  that you use a UUID type of value. If you don't provide this value, then Amazon Web
  Services generates a random one for you. If you retry the operation with the same
  ClientToken, but with different parameters, the retry fails with an
  IdempotentParameterMismatch error.
- `"Name"`: The name of the instance of IAM Identity Center.
- `"Tags"`: Specifies tags to be attached to the instance of IAM Identity Center.
"""
function create_instance(; aws_config::AbstractAWSConfig=current_aws_config())
    return sso_admin(
        "CreateInstance",
        Dict{String,Any}("ClientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_instance(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sso_admin(
        "CreateInstance",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ClientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_instance_access_control_attribute_configuration(instance_access_control_attribute_configuration, instance_arn)
    create_instance_access_control_attribute_configuration(instance_access_control_attribute_configuration, instance_arn, params::Dict{String,<:Any})

Enables the attributes-based access control (ABAC) feature for the specified IAM Identity
Center instance. You can also specify new attributes to add to your ABAC configuration
during the enabling process. For more information about ABAC, see Attribute-Based Access
Control in the IAM Identity Center User Guide.  After a successful response, call
DescribeInstanceAccessControlAttributeConfiguration to validate that
InstanceAccessControlAttributeConfiguration was created.

# Arguments
- `instance_access_control_attribute_configuration`: Specifies the IAM Identity Center
  identity store attributes to add to your ABAC configuration. When using an external
  identity provider as an identity source, you can pass attributes through the SAML
  assertion. Doing so provides an alternative to configuring attributes from the IAM Identity
  Center identity store. If a SAML assertion passes any of these attributes, IAM Identity
  Center will replace the attribute value with the value from the IAM Identity Center
  identity store.
- `instance_arn`: The ARN of the IAM Identity Center instance under which the operation
  will be executed.

"""
function create_instance_access_control_attribute_configuration(
    InstanceAccessControlAttributeConfiguration,
    InstanceArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "CreateInstanceAccessControlAttributeConfiguration",
        Dict{String,Any}(
            "InstanceAccessControlAttributeConfiguration" =>
                InstanceAccessControlAttributeConfiguration,
            "InstanceArn" => InstanceArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_instance_access_control_attribute_configuration(
    InstanceAccessControlAttributeConfiguration,
    InstanceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "CreateInstanceAccessControlAttributeConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "InstanceAccessControlAttributeConfiguration" =>
                        InstanceAccessControlAttributeConfiguration,
                    "InstanceArn" => InstanceArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_permission_set(instance_arn, name)
    create_permission_set(instance_arn, name, params::Dict{String,<:Any})

Creates a permission set within a specified IAM Identity Center instance.  To grant users
and groups access to Amazon Web Services account resources, use  CreateAccountAssignment .

# Arguments
- `instance_arn`: The ARN of the IAM Identity Center instance under which the operation
  will be executed. For more information about ARNs, see Amazon Resource Names (ARNs) and
  Amazon Web Services Service Namespaces in the Amazon Web Services General Reference.
- `name`: The name of the PermissionSet.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: The description of the PermissionSet.
- `"RelayState"`: Used to redirect users within the application during the federation
  authentication process.
- `"SessionDuration"`: The length of time that the application user sessions are valid in
  the ISO-8601 standard.
- `"Tags"`: The tags to attach to the new PermissionSet.
"""
function create_permission_set(
    InstanceArn, Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sso_admin(
        "CreatePermissionSet",
        Dict{String,Any}("InstanceArn" => InstanceArn, "Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_permission_set(
    InstanceArn,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "CreatePermissionSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("InstanceArn" => InstanceArn, "Name" => Name),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_trusted_token_issuer(instance_arn, name, trusted_token_issuer_configuration, trusted_token_issuer_type)
    create_trusted_token_issuer(instance_arn, name, trusted_token_issuer_configuration, trusted_token_issuer_type, params::Dict{String,<:Any})

Creates a connection to a trusted token issuer in an instance of IAM Identity Center. A
trusted token issuer enables trusted identity propagation to be used with applications that
authenticate outside of Amazon Web Services. This trusted token issuer describes an
external identity provider (IdP) that can generate claims or assertions in the form of
access tokens for a user. Applications enabled for IAM Identity Center can use these tokens
for authentication.

# Arguments
- `instance_arn`: Specifies the ARN of the instance of IAM Identity Center to contain the
  new trusted token issuer configuration.
- `name`: Specifies the name of the new trusted token issuer configuration.
- `trusted_token_issuer_configuration`: Specifies settings that apply to the new trusted
  token issuer configuration. The settings that are available depend on what
  TrustedTokenIssuerType you specify.
- `trusted_token_issuer_type`: Specifies the type of the new trusted token issuer.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: Specifies a unique, case-sensitive ID that you provide to ensure the
  idempotency of the request. This lets you safely retry the request without accidentally
  performing the same operation a second time. Passing the same value to a later call to an
  operation requires that you also pass the same value for all other parameters. We recommend
  that you use a UUID type of value.. If you don't provide this value, then Amazon Web
  Services generates a random one for you. If you retry the operation with the same
  ClientToken, but with different parameters, the retry fails with an
  IdempotentParameterMismatch error.
- `"Tags"`: Specifies tags to be attached to the new trusted token issuer configuration.
"""
function create_trusted_token_issuer(
    InstanceArn,
    Name,
    TrustedTokenIssuerConfiguration,
    TrustedTokenIssuerType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "CreateTrustedTokenIssuer",
        Dict{String,Any}(
            "InstanceArn" => InstanceArn,
            "Name" => Name,
            "TrustedTokenIssuerConfiguration" => TrustedTokenIssuerConfiguration,
            "TrustedTokenIssuerType" => TrustedTokenIssuerType,
            "ClientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_trusted_token_issuer(
    InstanceArn,
    Name,
    TrustedTokenIssuerConfiguration,
    TrustedTokenIssuerType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "CreateTrustedTokenIssuer",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "InstanceArn" => InstanceArn,
                    "Name" => Name,
                    "TrustedTokenIssuerConfiguration" => TrustedTokenIssuerConfiguration,
                    "TrustedTokenIssuerType" => TrustedTokenIssuerType,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_account_assignment(instance_arn, permission_set_arn, principal_id, principal_type, target_id, target_type)
    delete_account_assignment(instance_arn, permission_set_arn, principal_id, principal_type, target_id, target_type, params::Dict{String,<:Any})

Deletes a principal's access from a specified Amazon Web Services account using a specified
permission set.  After a successful response, call DescribeAccountAssignmentDeletionStatus
to describe the status of an assignment deletion request.

# Arguments
- `instance_arn`: The ARN of the IAM Identity Center instance under which the operation
  will be executed. For more information about ARNs, see Amazon Resource Names (ARNs) and
  Amazon Web Services Service Namespaces in the Amazon Web Services General Reference.
- `permission_set_arn`: The ARN of the permission set that will be used to remove access.
- `principal_id`: An identifier for an object in IAM Identity Center, such as a user or
  group. PrincipalIds are GUIDs (For example, f81d4fae-7dec-11d0-a765-00a0c91e6bf6). For more
  information about PrincipalIds in IAM Identity Center, see the IAM Identity Center Identity
  Store API Reference.
- `principal_type`: The entity type for which the assignment will be deleted.
- `target_id`: TargetID is an Amazon Web Services account identifier, (For example,
  123456789012).
- `target_type`: The entity type for which the assignment will be deleted.

"""
function delete_account_assignment(
    InstanceArn,
    PermissionSetArn,
    PrincipalId,
    PrincipalType,
    TargetId,
    TargetType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "DeleteAccountAssignment",
        Dict{String,Any}(
            "InstanceArn" => InstanceArn,
            "PermissionSetArn" => PermissionSetArn,
            "PrincipalId" => PrincipalId,
            "PrincipalType" => PrincipalType,
            "TargetId" => TargetId,
            "TargetType" => TargetType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_account_assignment(
    InstanceArn,
    PermissionSetArn,
    PrincipalId,
    PrincipalType,
    TargetId,
    TargetType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "DeleteAccountAssignment",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "InstanceArn" => InstanceArn,
                    "PermissionSetArn" => PermissionSetArn,
                    "PrincipalId" => PrincipalId,
                    "PrincipalType" => PrincipalType,
                    "TargetId" => TargetId,
                    "TargetType" => TargetType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_application(application_arn)
    delete_application(application_arn, params::Dict{String,<:Any})

Deletes the association with the application. The connected service resource still exists.

# Arguments
- `application_arn`: Specifies the ARN of the application. For more information about ARNs,
  see Amazon Resource Names (ARNs) and Amazon Web Services Service Namespaces in the Amazon
  Web Services General Reference.

"""
function delete_application(
    ApplicationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sso_admin(
        "DeleteApplication",
        Dict{String,Any}("ApplicationArn" => ApplicationArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_application(
    ApplicationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "DeleteApplication",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ApplicationArn" => ApplicationArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_application_access_scope(application_arn, scope)
    delete_application_access_scope(application_arn, scope, params::Dict{String,<:Any})

Deletes an IAM Identity Center access scope from an application.

# Arguments
- `application_arn`: Specifies the ARN of the application with the access scope to delete.
- `scope`: Specifies the name of the access scope to remove from the application.

"""
function delete_application_access_scope(
    ApplicationArn, Scope; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sso_admin(
        "DeleteApplicationAccessScope",
        Dict{String,Any}("ApplicationArn" => ApplicationArn, "Scope" => Scope);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_application_access_scope(
    ApplicationArn,
    Scope,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "DeleteApplicationAccessScope",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ApplicationArn" => ApplicationArn, "Scope" => Scope),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_application_assignment(application_arn, principal_id, principal_type)
    delete_application_assignment(application_arn, principal_id, principal_type, params::Dict{String,<:Any})

Revoke application access to an application by deleting application assignments for a user
or group.

# Arguments
- `application_arn`: Specifies the ARN of the application.
- `principal_id`: An identifier for an object in IAM Identity Center, such as a user or
  group. PrincipalIds are GUIDs (For example, f81d4fae-7dec-11d0-a765-00a0c91e6bf6). For more
  information about PrincipalIds in IAM Identity Center, see the IAM Identity Center Identity
  Store API Reference.
- `principal_type`: The entity type for which the assignment will be deleted.

"""
function delete_application_assignment(
    ApplicationArn,
    PrincipalId,
    PrincipalType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "DeleteApplicationAssignment",
        Dict{String,Any}(
            "ApplicationArn" => ApplicationArn,
            "PrincipalId" => PrincipalId,
            "PrincipalType" => PrincipalType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_application_assignment(
    ApplicationArn,
    PrincipalId,
    PrincipalType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "DeleteApplicationAssignment",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationArn" => ApplicationArn,
                    "PrincipalId" => PrincipalId,
                    "PrincipalType" => PrincipalType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_application_authentication_method(application_arn, authentication_method_type)
    delete_application_authentication_method(application_arn, authentication_method_type, params::Dict{String,<:Any})

Deletes an authentication method from an application.

# Arguments
- `application_arn`: Specifies the ARN of the application with the authentication method to
  delete.
- `authentication_method_type`: Specifies the authentication method type to delete from the
  application.

"""
function delete_application_authentication_method(
    ApplicationArn,
    AuthenticationMethodType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "DeleteApplicationAuthenticationMethod",
        Dict{String,Any}(
            "ApplicationArn" => ApplicationArn,
            "AuthenticationMethodType" => AuthenticationMethodType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_application_authentication_method(
    ApplicationArn,
    AuthenticationMethodType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "DeleteApplicationAuthenticationMethod",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationArn" => ApplicationArn,
                    "AuthenticationMethodType" => AuthenticationMethodType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_application_grant(application_arn, grant_type)
    delete_application_grant(application_arn, grant_type, params::Dict{String,<:Any})

Deletes a grant from an application.

# Arguments
- `application_arn`: Specifies the ARN of the application with the grant to delete.
- `grant_type`: Specifies the type of grant to delete from the application.

"""
function delete_application_grant(
    ApplicationArn, GrantType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sso_admin(
        "DeleteApplicationGrant",
        Dict{String,Any}("ApplicationArn" => ApplicationArn, "GrantType" => GrantType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_application_grant(
    ApplicationArn,
    GrantType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "DeleteApplicationGrant",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationArn" => ApplicationArn, "GrantType" => GrantType
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_inline_policy_from_permission_set(instance_arn, permission_set_arn)
    delete_inline_policy_from_permission_set(instance_arn, permission_set_arn, params::Dict{String,<:Any})

Deletes the inline policy from a specified permission set.

# Arguments
- `instance_arn`: The ARN of the IAM Identity Center instance under which the operation
  will be executed. For more information about ARNs, see Amazon Resource Names (ARNs) and
  Amazon Web Services Service Namespaces in the Amazon Web Services General Reference.
- `permission_set_arn`: The ARN of the permission set that will be used to remove access.

"""
function delete_inline_policy_from_permission_set(
    InstanceArn, PermissionSetArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sso_admin(
        "DeleteInlinePolicyFromPermissionSet",
        Dict{String,Any}(
            "InstanceArn" => InstanceArn, "PermissionSetArn" => PermissionSetArn
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_inline_policy_from_permission_set(
    InstanceArn,
    PermissionSetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "DeleteInlinePolicyFromPermissionSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "InstanceArn" => InstanceArn, "PermissionSetArn" => PermissionSetArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_instance(instance_arn)
    delete_instance(instance_arn, params::Dict{String,<:Any})

Deletes the instance of IAM Identity Center. Only the account that owns the instance can
call this API. Neither the delegated administrator nor member account can delete the
organization instance, but those roles can delete their own instance.

# Arguments
- `instance_arn`: The ARN of the instance of IAM Identity Center under which the operation
  will run.

"""
function delete_instance(InstanceArn; aws_config::AbstractAWSConfig=current_aws_config())
    return sso_admin(
        "DeleteInstance",
        Dict{String,Any}("InstanceArn" => InstanceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_instance(
    InstanceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "DeleteInstance",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("InstanceArn" => InstanceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_instance_access_control_attribute_configuration(instance_arn)
    delete_instance_access_control_attribute_configuration(instance_arn, params::Dict{String,<:Any})

Disables the attributes-based access control (ABAC) feature for the specified IAM Identity
Center instance and deletes all of the attribute mappings that have been configured. Once
deleted, any attributes that are received from an identity source and any custom attributes
you have previously configured will not be passed. For more information about ABAC, see
Attribute-Based Access Control in the IAM Identity Center User Guide.

# Arguments
- `instance_arn`: The ARN of the IAM Identity Center instance under which the operation
  will be executed.

"""
function delete_instance_access_control_attribute_configuration(
    InstanceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sso_admin(
        "DeleteInstanceAccessControlAttributeConfiguration",
        Dict{String,Any}("InstanceArn" => InstanceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_instance_access_control_attribute_configuration(
    InstanceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "DeleteInstanceAccessControlAttributeConfiguration",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("InstanceArn" => InstanceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_permission_set(instance_arn, permission_set_arn)
    delete_permission_set(instance_arn, permission_set_arn, params::Dict{String,<:Any})

Deletes the specified permission set.

# Arguments
- `instance_arn`: The ARN of the IAM Identity Center instance under which the operation
  will be executed. For more information about ARNs, see Amazon Resource Names (ARNs) and
  Amazon Web Services Service Namespaces in the Amazon Web Services General Reference.
- `permission_set_arn`: The ARN of the permission set that should be deleted.

"""
function delete_permission_set(
    InstanceArn, PermissionSetArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sso_admin(
        "DeletePermissionSet",
        Dict{String,Any}(
            "InstanceArn" => InstanceArn, "PermissionSetArn" => PermissionSetArn
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_permission_set(
    InstanceArn,
    PermissionSetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "DeletePermissionSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "InstanceArn" => InstanceArn, "PermissionSetArn" => PermissionSetArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_permissions_boundary_from_permission_set(instance_arn, permission_set_arn)
    delete_permissions_boundary_from_permission_set(instance_arn, permission_set_arn, params::Dict{String,<:Any})

Deletes the permissions boundary from a specified PermissionSet.

# Arguments
- `instance_arn`: The ARN of the IAM Identity Center instance under which the operation
  will be executed.
- `permission_set_arn`: The ARN of the PermissionSet.

"""
function delete_permissions_boundary_from_permission_set(
    InstanceArn, PermissionSetArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sso_admin(
        "DeletePermissionsBoundaryFromPermissionSet",
        Dict{String,Any}(
            "InstanceArn" => InstanceArn, "PermissionSetArn" => PermissionSetArn
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_permissions_boundary_from_permission_set(
    InstanceArn,
    PermissionSetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "DeletePermissionsBoundaryFromPermissionSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "InstanceArn" => InstanceArn, "PermissionSetArn" => PermissionSetArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_trusted_token_issuer(trusted_token_issuer_arn)
    delete_trusted_token_issuer(trusted_token_issuer_arn, params::Dict{String,<:Any})

Deletes a trusted token issuer configuration from an instance of IAM Identity Center.
Deleting this trusted token issuer configuration will cause users to lose access to any
applications that are configured to use the trusted token issuer.

# Arguments
- `trusted_token_issuer_arn`: Specifies the ARN of the trusted token issuer configuration
  to delete.

"""
function delete_trusted_token_issuer(
    TrustedTokenIssuerArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sso_admin(
        "DeleteTrustedTokenIssuer",
        Dict{String,Any}("TrustedTokenIssuerArn" => TrustedTokenIssuerArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_trusted_token_issuer(
    TrustedTokenIssuerArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "DeleteTrustedTokenIssuer",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("TrustedTokenIssuerArn" => TrustedTokenIssuerArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_account_assignment_creation_status(account_assignment_creation_request_id, instance_arn)
    describe_account_assignment_creation_status(account_assignment_creation_request_id, instance_arn, params::Dict{String,<:Any})

Describes the status of the assignment creation request.

# Arguments
- `account_assignment_creation_request_id`: The identifier that is used to track the
  request operation progress.
- `instance_arn`: The ARN of the IAM Identity Center instance under which the operation
  will be executed. For more information about ARNs, see Amazon Resource Names (ARNs) and
  Amazon Web Services Service Namespaces in the Amazon Web Services General Reference.

"""
function describe_account_assignment_creation_status(
    AccountAssignmentCreationRequestId,
    InstanceArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "DescribeAccountAssignmentCreationStatus",
        Dict{String,Any}(
            "AccountAssignmentCreationRequestId" => AccountAssignmentCreationRequestId,
            "InstanceArn" => InstanceArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_account_assignment_creation_status(
    AccountAssignmentCreationRequestId,
    InstanceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "DescribeAccountAssignmentCreationStatus",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AccountAssignmentCreationRequestId" =>
                        AccountAssignmentCreationRequestId,
                    "InstanceArn" => InstanceArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_account_assignment_deletion_status(account_assignment_deletion_request_id, instance_arn)
    describe_account_assignment_deletion_status(account_assignment_deletion_request_id, instance_arn, params::Dict{String,<:Any})

Describes the status of the assignment deletion request.

# Arguments
- `account_assignment_deletion_request_id`: The identifier that is used to track the
  request operation progress.
- `instance_arn`: The ARN of the IAM Identity Center instance under which the operation
  will be executed. For more information about ARNs, see Amazon Resource Names (ARNs) and
  Amazon Web Services Service Namespaces in the Amazon Web Services General Reference.

"""
function describe_account_assignment_deletion_status(
    AccountAssignmentDeletionRequestId,
    InstanceArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "DescribeAccountAssignmentDeletionStatus",
        Dict{String,Any}(
            "AccountAssignmentDeletionRequestId" => AccountAssignmentDeletionRequestId,
            "InstanceArn" => InstanceArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_account_assignment_deletion_status(
    AccountAssignmentDeletionRequestId,
    InstanceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "DescribeAccountAssignmentDeletionStatus",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AccountAssignmentDeletionRequestId" =>
                        AccountAssignmentDeletionRequestId,
                    "InstanceArn" => InstanceArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_application(application_arn)
    describe_application(application_arn, params::Dict{String,<:Any})

Retrieves the details of an application associated with an instance of IAM Identity Center.

# Arguments
- `application_arn`: Specifies the ARN of the application. For more information about ARNs,
  see Amazon Resource Names (ARNs) and Amazon Web Services Service Namespaces in the Amazon
  Web Services General Reference.

"""
function describe_application(
    ApplicationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sso_admin(
        "DescribeApplication",
        Dict{String,Any}("ApplicationArn" => ApplicationArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_application(
    ApplicationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "DescribeApplication",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ApplicationArn" => ApplicationArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_application_assignment(application_arn, principal_id, principal_type)
    describe_application_assignment(application_arn, principal_id, principal_type, params::Dict{String,<:Any})

Retrieves a direct assignment of a user or group to an application. If the user doesn’t
have a direct assignment to the application, the user may still have access to the
application through a group. Therefore, don’t use this API to test access to an
application for a user. Instead use ListApplicationAssignmentsForPrincipal.

# Arguments
- `application_arn`: Specifies the ARN of the application. For more information about ARNs,
  see Amazon Resource Names (ARNs) and Amazon Web Services Service Namespaces in the Amazon
  Web Services General Reference.
- `principal_id`: An identifier for an object in IAM Identity Center, such as a user or
  group. PrincipalIds are GUIDs (For example, f81d4fae-7dec-11d0-a765-00a0c91e6bf6). For more
  information about PrincipalIds in IAM Identity Center, see the IAM Identity Center Identity
  Store API Reference.
- `principal_type`: The entity type for which the assignment will be created.

"""
function describe_application_assignment(
    ApplicationArn,
    PrincipalId,
    PrincipalType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "DescribeApplicationAssignment",
        Dict{String,Any}(
            "ApplicationArn" => ApplicationArn,
            "PrincipalId" => PrincipalId,
            "PrincipalType" => PrincipalType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_application_assignment(
    ApplicationArn,
    PrincipalId,
    PrincipalType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "DescribeApplicationAssignment",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationArn" => ApplicationArn,
                    "PrincipalId" => PrincipalId,
                    "PrincipalType" => PrincipalType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_application_provider(application_provider_arn)
    describe_application_provider(application_provider_arn, params::Dict{String,<:Any})

Retrieves details about a provider that can be used to connect an Amazon Web Services
managed application or customer managed application to IAM Identity Center.

# Arguments
- `application_provider_arn`: Specifies the ARN of the application provider for which you
  want details.

"""
function describe_application_provider(
    ApplicationProviderArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sso_admin(
        "DescribeApplicationProvider",
        Dict{String,Any}("ApplicationProviderArn" => ApplicationProviderArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_application_provider(
    ApplicationProviderArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "DescribeApplicationProvider",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ApplicationProviderArn" => ApplicationProviderArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_instance(instance_arn)
    describe_instance(instance_arn, params::Dict{String,<:Any})

Returns the details of an instance of IAM Identity Center. The status can be one of the
following:    CREATE_IN_PROGRESS - The instance is in the process of being created. When
the instance is ready for use, DescribeInstance returns the status of ACTIVE. While the
instance is in the CREATE_IN_PROGRESS state, you can call only DescribeInstance and
DeleteInstance operations.    DELETE_IN_PROGRESS - The instance is being deleted. Returns
AccessDeniedException after the delete operation completes.     ACTIVE - The instance is
active.

# Arguments
- `instance_arn`: The ARN of the instance of IAM Identity Center under which the operation
  will run.

"""
function describe_instance(InstanceArn; aws_config::AbstractAWSConfig=current_aws_config())
    return sso_admin(
        "DescribeInstance",
        Dict{String,Any}("InstanceArn" => InstanceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_instance(
    InstanceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "DescribeInstance",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("InstanceArn" => InstanceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_instance_access_control_attribute_configuration(instance_arn)
    describe_instance_access_control_attribute_configuration(instance_arn, params::Dict{String,<:Any})

Returns the list of IAM Identity Center identity store attributes that have been configured
to work with attributes-based access control (ABAC) for the specified IAM Identity Center
instance. This will not return attributes configured and sent by an external identity
provider. For more information about ABAC, see Attribute-Based Access Control in the IAM
Identity Center User Guide.

# Arguments
- `instance_arn`: The ARN of the IAM Identity Center instance under which the operation
  will be executed.

"""
function describe_instance_access_control_attribute_configuration(
    InstanceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sso_admin(
        "DescribeInstanceAccessControlAttributeConfiguration",
        Dict{String,Any}("InstanceArn" => InstanceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_instance_access_control_attribute_configuration(
    InstanceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "DescribeInstanceAccessControlAttributeConfiguration",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("InstanceArn" => InstanceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_permission_set(instance_arn, permission_set_arn)
    describe_permission_set(instance_arn, permission_set_arn, params::Dict{String,<:Any})

Gets the details of the permission set.

# Arguments
- `instance_arn`: The ARN of the IAM Identity Center instance under which the operation
  will be executed. For more information about ARNs, see Amazon Resource Names (ARNs) and
  Amazon Web Services Service Namespaces in the Amazon Web Services General Reference.
- `permission_set_arn`: The ARN of the permission set.

"""
function describe_permission_set(
    InstanceArn, PermissionSetArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sso_admin(
        "DescribePermissionSet",
        Dict{String,Any}(
            "InstanceArn" => InstanceArn, "PermissionSetArn" => PermissionSetArn
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_permission_set(
    InstanceArn,
    PermissionSetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "DescribePermissionSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "InstanceArn" => InstanceArn, "PermissionSetArn" => PermissionSetArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_permission_set_provisioning_status(instance_arn, provision_permission_set_request_id)
    describe_permission_set_provisioning_status(instance_arn, provision_permission_set_request_id, params::Dict{String,<:Any})

Describes the status for the given permission set provisioning request.

# Arguments
- `instance_arn`: The ARN of the IAM Identity Center instance under which the operation
  will be executed. For more information about ARNs, see Amazon Resource Names (ARNs) and
  Amazon Web Services Service Namespaces in the Amazon Web Services General Reference.
- `provision_permission_set_request_id`: The identifier that is provided by the
  ProvisionPermissionSet call to retrieve the current status of the provisioning workflow.

"""
function describe_permission_set_provisioning_status(
    InstanceArn,
    ProvisionPermissionSetRequestId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "DescribePermissionSetProvisioningStatus",
        Dict{String,Any}(
            "InstanceArn" => InstanceArn,
            "ProvisionPermissionSetRequestId" => ProvisionPermissionSetRequestId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_permission_set_provisioning_status(
    InstanceArn,
    ProvisionPermissionSetRequestId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "DescribePermissionSetProvisioningStatus",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "InstanceArn" => InstanceArn,
                    "ProvisionPermissionSetRequestId" => ProvisionPermissionSetRequestId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_trusted_token_issuer(trusted_token_issuer_arn)
    describe_trusted_token_issuer(trusted_token_issuer_arn, params::Dict{String,<:Any})

Retrieves details about a trusted token issuer configuration stored in an instance of IAM
Identity Center. Details include the name of the trusted token issuer, the issuer URL, and
the path of the source attribute and the destination attribute for a trusted token issuer
configuration.

# Arguments
- `trusted_token_issuer_arn`: Specifies the ARN of the trusted token issuer configuration
  that you want details about.

"""
function describe_trusted_token_issuer(
    TrustedTokenIssuerArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sso_admin(
        "DescribeTrustedTokenIssuer",
        Dict{String,Any}("TrustedTokenIssuerArn" => TrustedTokenIssuerArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_trusted_token_issuer(
    TrustedTokenIssuerArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "DescribeTrustedTokenIssuer",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("TrustedTokenIssuerArn" => TrustedTokenIssuerArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    detach_customer_managed_policy_reference_from_permission_set(customer_managed_policy_reference, instance_arn, permission_set_arn)
    detach_customer_managed_policy_reference_from_permission_set(customer_managed_policy_reference, instance_arn, permission_set_arn, params::Dict{String,<:Any})

Detaches the specified customer managed policy from the specified PermissionSet.

# Arguments
- `customer_managed_policy_reference`: Specifies the name and path of a customer managed
  policy. You must have an IAM policy that matches the name and path in each Amazon Web
  Services account where you want to deploy your permission set.
- `instance_arn`: The ARN of the IAM Identity Center instance under which the operation
  will be executed.
- `permission_set_arn`: The ARN of the PermissionSet.

"""
function detach_customer_managed_policy_reference_from_permission_set(
    CustomerManagedPolicyReference,
    InstanceArn,
    PermissionSetArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "DetachCustomerManagedPolicyReferenceFromPermissionSet",
        Dict{String,Any}(
            "CustomerManagedPolicyReference" => CustomerManagedPolicyReference,
            "InstanceArn" => InstanceArn,
            "PermissionSetArn" => PermissionSetArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function detach_customer_managed_policy_reference_from_permission_set(
    CustomerManagedPolicyReference,
    InstanceArn,
    PermissionSetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "DetachCustomerManagedPolicyReferenceFromPermissionSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CustomerManagedPolicyReference" => CustomerManagedPolicyReference,
                    "InstanceArn" => InstanceArn,
                    "PermissionSetArn" => PermissionSetArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    detach_managed_policy_from_permission_set(instance_arn, managed_policy_arn, permission_set_arn)
    detach_managed_policy_from_permission_set(instance_arn, managed_policy_arn, permission_set_arn, params::Dict{String,<:Any})

Detaches the attached Amazon Web Services managed policy ARN from the specified permission
set.

# Arguments
- `instance_arn`: The ARN of the IAM Identity Center instance under which the operation
  will be executed. For more information about ARNs, see Amazon Resource Names (ARNs) and
  Amazon Web Services Service Namespaces in the Amazon Web Services General Reference.
- `managed_policy_arn`: The Amazon Web Services managed policy ARN to be detached from a
  permission set.
- `permission_set_arn`: The ARN of the PermissionSet from which the policy should be
  detached.

"""
function detach_managed_policy_from_permission_set(
    InstanceArn,
    ManagedPolicyArn,
    PermissionSetArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "DetachManagedPolicyFromPermissionSet",
        Dict{String,Any}(
            "InstanceArn" => InstanceArn,
            "ManagedPolicyArn" => ManagedPolicyArn,
            "PermissionSetArn" => PermissionSetArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function detach_managed_policy_from_permission_set(
    InstanceArn,
    ManagedPolicyArn,
    PermissionSetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "DetachManagedPolicyFromPermissionSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "InstanceArn" => InstanceArn,
                    "ManagedPolicyArn" => ManagedPolicyArn,
                    "PermissionSetArn" => PermissionSetArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_application_access_scope(application_arn, scope)
    get_application_access_scope(application_arn, scope, params::Dict{String,<:Any})

Retrieves the authorized targets for an IAM Identity Center access scope for an application.

# Arguments
- `application_arn`: Specifies the ARN of the application with the access scope that you
  want to retrieve.
- `scope`: Specifies the name of the access scope for which you want the authorized targets.

"""
function get_application_access_scope(
    ApplicationArn, Scope; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sso_admin(
        "GetApplicationAccessScope",
        Dict{String,Any}("ApplicationArn" => ApplicationArn, "Scope" => Scope);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_application_access_scope(
    ApplicationArn,
    Scope,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "GetApplicationAccessScope",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ApplicationArn" => ApplicationArn, "Scope" => Scope),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_application_assignment_configuration(application_arn)
    get_application_assignment_configuration(application_arn, params::Dict{String,<:Any})

Retrieves the configuration of PutApplicationAssignmentConfiguration.

# Arguments
- `application_arn`: Specifies the ARN of the application. For more information about ARNs,
  see Amazon Resource Names (ARNs) and Amazon Web Services Service Namespaces in the Amazon
  Web Services General Reference.

"""
function get_application_assignment_configuration(
    ApplicationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sso_admin(
        "GetApplicationAssignmentConfiguration",
        Dict{String,Any}("ApplicationArn" => ApplicationArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_application_assignment_configuration(
    ApplicationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "GetApplicationAssignmentConfiguration",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ApplicationArn" => ApplicationArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_application_authentication_method(application_arn, authentication_method_type)
    get_application_authentication_method(application_arn, authentication_method_type, params::Dict{String,<:Any})

Retrieves details about an authentication method used by an application.

# Arguments
- `application_arn`: Specifies the ARN of the application.
- `authentication_method_type`: Specifies the type of authentication method for which you
  want details.

"""
function get_application_authentication_method(
    ApplicationArn,
    AuthenticationMethodType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "GetApplicationAuthenticationMethod",
        Dict{String,Any}(
            "ApplicationArn" => ApplicationArn,
            "AuthenticationMethodType" => AuthenticationMethodType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_application_authentication_method(
    ApplicationArn,
    AuthenticationMethodType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "GetApplicationAuthenticationMethod",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationArn" => ApplicationArn,
                    "AuthenticationMethodType" => AuthenticationMethodType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_application_grant(application_arn, grant_type)
    get_application_grant(application_arn, grant_type, params::Dict{String,<:Any})

Retrieves details about an application grant.

# Arguments
- `application_arn`: Specifies the ARN of the application that contains the grant.
- `grant_type`: Specifies the type of grant.

"""
function get_application_grant(
    ApplicationArn, GrantType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sso_admin(
        "GetApplicationGrant",
        Dict{String,Any}("ApplicationArn" => ApplicationArn, "GrantType" => GrantType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_application_grant(
    ApplicationArn,
    GrantType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "GetApplicationGrant",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationArn" => ApplicationArn, "GrantType" => GrantType
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_inline_policy_for_permission_set(instance_arn, permission_set_arn)
    get_inline_policy_for_permission_set(instance_arn, permission_set_arn, params::Dict{String,<:Any})

Obtains the inline policy assigned to the permission set.

# Arguments
- `instance_arn`: The ARN of the IAM Identity Center instance under which the operation
  will be executed. For more information about ARNs, see Amazon Resource Names (ARNs) and
  Amazon Web Services Service Namespaces in the Amazon Web Services General Reference.
- `permission_set_arn`: The ARN of the permission set.

"""
function get_inline_policy_for_permission_set(
    InstanceArn, PermissionSetArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sso_admin(
        "GetInlinePolicyForPermissionSet",
        Dict{String,Any}(
            "InstanceArn" => InstanceArn, "PermissionSetArn" => PermissionSetArn
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_inline_policy_for_permission_set(
    InstanceArn,
    PermissionSetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "GetInlinePolicyForPermissionSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "InstanceArn" => InstanceArn, "PermissionSetArn" => PermissionSetArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_permissions_boundary_for_permission_set(instance_arn, permission_set_arn)
    get_permissions_boundary_for_permission_set(instance_arn, permission_set_arn, params::Dict{String,<:Any})

Obtains the permissions boundary for a specified PermissionSet.

# Arguments
- `instance_arn`: The ARN of the IAM Identity Center instance under which the operation
  will be executed.
- `permission_set_arn`: The ARN of the PermissionSet.

"""
function get_permissions_boundary_for_permission_set(
    InstanceArn, PermissionSetArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sso_admin(
        "GetPermissionsBoundaryForPermissionSet",
        Dict{String,Any}(
            "InstanceArn" => InstanceArn, "PermissionSetArn" => PermissionSetArn
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_permissions_boundary_for_permission_set(
    InstanceArn,
    PermissionSetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "GetPermissionsBoundaryForPermissionSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "InstanceArn" => InstanceArn, "PermissionSetArn" => PermissionSetArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_account_assignment_creation_status(instance_arn)
    list_account_assignment_creation_status(instance_arn, params::Dict{String,<:Any})

Lists the status of the Amazon Web Services account assignment creation requests for a
specified IAM Identity Center instance.

# Arguments
- `instance_arn`: The ARN of the IAM Identity Center instance under which the operation
  will be executed. For more information about ARNs, see Amazon Resource Names (ARNs) and
  Amazon Web Services Service Namespaces in the Amazon Web Services General Reference.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filter"`: Filters results based on the passed attribute value.
- `"MaxResults"`: The maximum number of results to display for the assignment.
- `"NextToken"`: The pagination token for the list API. Initially the value is null. Use
  the output of previous API calls to make subsequent calls.
"""
function list_account_assignment_creation_status(
    InstanceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sso_admin(
        "ListAccountAssignmentCreationStatus",
        Dict{String,Any}("InstanceArn" => InstanceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_account_assignment_creation_status(
    InstanceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "ListAccountAssignmentCreationStatus",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("InstanceArn" => InstanceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_account_assignment_deletion_status(instance_arn)
    list_account_assignment_deletion_status(instance_arn, params::Dict{String,<:Any})

Lists the status of the Amazon Web Services account assignment deletion requests for a
specified IAM Identity Center instance.

# Arguments
- `instance_arn`: The ARN of the IAM Identity Center instance under which the operation
  will be executed. For more information about ARNs, see Amazon Resource Names (ARNs) and
  Amazon Web Services Service Namespaces in the Amazon Web Services General Reference.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filter"`: Filters results based on the passed attribute value.
- `"MaxResults"`: The maximum number of results to display for the assignment.
- `"NextToken"`: The pagination token for the list API. Initially the value is null. Use
  the output of previous API calls to make subsequent calls.
"""
function list_account_assignment_deletion_status(
    InstanceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sso_admin(
        "ListAccountAssignmentDeletionStatus",
        Dict{String,Any}("InstanceArn" => InstanceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_account_assignment_deletion_status(
    InstanceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "ListAccountAssignmentDeletionStatus",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("InstanceArn" => InstanceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_account_assignments(account_id, instance_arn, permission_set_arn)
    list_account_assignments(account_id, instance_arn, permission_set_arn, params::Dict{String,<:Any})

Lists the assignee of the specified Amazon Web Services account with the specified
permission set.

# Arguments
- `account_id`: The identifier of the Amazon Web Services account from which to list the
  assignments.
- `instance_arn`: The ARN of the IAM Identity Center instance under which the operation
  will be executed. For more information about ARNs, see Amazon Resource Names (ARNs) and
  Amazon Web Services Service Namespaces in the Amazon Web Services General Reference.
- `permission_set_arn`: The ARN of the permission set from which to list assignments.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to display for the assignment.
- `"NextToken"`: The pagination token for the list API. Initially the value is null. Use
  the output of previous API calls to make subsequent calls.
"""
function list_account_assignments(
    AccountId,
    InstanceArn,
    PermissionSetArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "ListAccountAssignments",
        Dict{String,Any}(
            "AccountId" => AccountId,
            "InstanceArn" => InstanceArn,
            "PermissionSetArn" => PermissionSetArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_account_assignments(
    AccountId,
    InstanceArn,
    PermissionSetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "ListAccountAssignments",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AccountId" => AccountId,
                    "InstanceArn" => InstanceArn,
                    "PermissionSetArn" => PermissionSetArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_account_assignments_for_principal(instance_arn, principal_id, principal_type)
    list_account_assignments_for_principal(instance_arn, principal_id, principal_type, params::Dict{String,<:Any})

Retrieves a list of the IAM Identity Center associated Amazon Web Services accounts that
the principal has access to.

# Arguments
- `instance_arn`: Specifies the ARN of the instance of IAM Identity Center that contains
  the principal.
- `principal_id`: Specifies the principal for which you want to retrieve the list of
  account assignments.
- `principal_type`: Specifies the type of the principal.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filter"`: Specifies an Amazon Web Services account ID number. Results are filtered to
  only those that match this ID number.
- `"MaxResults"`: Specifies the total number of results that you want included in each
  response. If additional items exist beyond the number you specify, the NextToken response
  element is returned with a value (not null). Include the specified value as the NextToken
  request parameter in the next call to the operation to get the next set of results. Note
  that the service might return fewer results than the maximum even when there are more
  results available. You should check NextToken after every operation to ensure that you
  receive all of the results.
- `"NextToken"`: Specifies that you want to receive the next page of results. Valid only if
  you received a NextToken response in the previous request. If you did, it indicates that
  more output is available. Set this parameter to the value provided by the previous call's
  NextToken response to request the next page of results.
"""
function list_account_assignments_for_principal(
    InstanceArn,
    PrincipalId,
    PrincipalType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "ListAccountAssignmentsForPrincipal",
        Dict{String,Any}(
            "InstanceArn" => InstanceArn,
            "PrincipalId" => PrincipalId,
            "PrincipalType" => PrincipalType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_account_assignments_for_principal(
    InstanceArn,
    PrincipalId,
    PrincipalType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "ListAccountAssignmentsForPrincipal",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "InstanceArn" => InstanceArn,
                    "PrincipalId" => PrincipalId,
                    "PrincipalType" => PrincipalType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_accounts_for_provisioned_permission_set(instance_arn, permission_set_arn)
    list_accounts_for_provisioned_permission_set(instance_arn, permission_set_arn, params::Dict{String,<:Any})

Lists all the Amazon Web Services accounts where the specified permission set is
provisioned.

# Arguments
- `instance_arn`: The ARN of the IAM Identity Center instance under which the operation
  will be executed. For more information about ARNs, see Amazon Resource Names (ARNs) and
  Amazon Web Services Service Namespaces in the Amazon Web Services General Reference.
- `permission_set_arn`: The ARN of the PermissionSet from which the associated Amazon Web
  Services accounts will be listed.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to display for the PermissionSet.
- `"NextToken"`: The pagination token for the list API. Initially the value is null. Use
  the output of previous API calls to make subsequent calls.
- `"ProvisioningStatus"`: The permission set provisioning status for an Amazon Web Services
  account.
"""
function list_accounts_for_provisioned_permission_set(
    InstanceArn, PermissionSetArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sso_admin(
        "ListAccountsForProvisionedPermissionSet",
        Dict{String,Any}(
            "InstanceArn" => InstanceArn, "PermissionSetArn" => PermissionSetArn
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_accounts_for_provisioned_permission_set(
    InstanceArn,
    PermissionSetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "ListAccountsForProvisionedPermissionSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "InstanceArn" => InstanceArn, "PermissionSetArn" => PermissionSetArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_application_access_scopes(application_arn)
    list_application_access_scopes(application_arn, params::Dict{String,<:Any})

Lists the access scopes and authorized targets associated with an application.

# Arguments
- `application_arn`: Specifies the ARN of the application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Specifies the total number of results that you want included in each
  response. If additional items exist beyond the number you specify, the NextToken response
  element is returned with a value (not null). Include the specified value as the NextToken
  request parameter in the next call to the operation to get the next set of results. Note
  that the service might return fewer results than the maximum even when there are more
  results available. You should check NextToken after every operation to ensure that you
  receive all of the results.
- `"NextToken"`: Specifies that you want to receive the next page of results. Valid only if
  you received a NextToken response in the previous request. If you did, it indicates that
  more output is available. Set this parameter to the value provided by the previous call's
  NextToken response to request the next page of results.
"""
function list_application_access_scopes(
    ApplicationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sso_admin(
        "ListApplicationAccessScopes",
        Dict{String,Any}("ApplicationArn" => ApplicationArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_application_access_scopes(
    ApplicationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "ListApplicationAccessScopes",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ApplicationArn" => ApplicationArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_application_assignments(application_arn)
    list_application_assignments(application_arn, params::Dict{String,<:Any})

Lists Amazon Web Services account users that are assigned to an application.

# Arguments
- `application_arn`: Specifies the ARN of the application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Specifies the total number of results that you want included in each
  response. If additional items exist beyond the number you specify, the NextToken response
  element is returned with a value (not null). Include the specified value as the NextToken
  request parameter in the next call to the operation to get the next set of results. Note
  that the service might return fewer results than the maximum even when there are more
  results available. You should check NextToken after every operation to ensure that you
  receive all of the results.
- `"NextToken"`: Specifies that you want to receive the next page of results. Valid only if
  you received a NextToken response in the previous request. If you did, it indicates that
  more output is available. Set this parameter to the value provided by the previous call's
  NextToken response to request the next page of results.
"""
function list_application_assignments(
    ApplicationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sso_admin(
        "ListApplicationAssignments",
        Dict{String,Any}("ApplicationArn" => ApplicationArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_application_assignments(
    ApplicationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "ListApplicationAssignments",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ApplicationArn" => ApplicationArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_application_assignments_for_principal(instance_arn, principal_id, principal_type)
    list_application_assignments_for_principal(instance_arn, principal_id, principal_type, params::Dict{String,<:Any})

Lists the applications to which a specified principal is assigned.

# Arguments
- `instance_arn`: Specifies the instance of IAM Identity Center that contains principal and
  applications.
- `principal_id`: Specifies the unique identifier of the principal for which you want to
  retrieve its assignments.
- `principal_type`: Specifies the type of the principal for which you want to retrieve its
  assignments.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filter"`: Filters the output to include only assignments associated with the
  application that has the specified ARN.
- `"MaxResults"`: Specifies the total number of results that you want included in each
  response. If additional items exist beyond the number you specify, the NextToken response
  element is returned with a value (not null). Include the specified value as the NextToken
  request parameter in the next call to the operation to get the next set of results. Note
  that the service might return fewer results than the maximum even when there are more
  results available. You should check NextToken after every operation to ensure that you
  receive all of the results.
- `"NextToken"`: Specifies that you want to receive the next page of results. Valid only if
  you received a NextToken response in the previous request. If you did, it indicates that
  more output is available. Set this parameter to the value provided by the previous call's
  NextToken response to request the next page of results.
"""
function list_application_assignments_for_principal(
    InstanceArn,
    PrincipalId,
    PrincipalType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "ListApplicationAssignmentsForPrincipal",
        Dict{String,Any}(
            "InstanceArn" => InstanceArn,
            "PrincipalId" => PrincipalId,
            "PrincipalType" => PrincipalType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_application_assignments_for_principal(
    InstanceArn,
    PrincipalId,
    PrincipalType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "ListApplicationAssignmentsForPrincipal",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "InstanceArn" => InstanceArn,
                    "PrincipalId" => PrincipalId,
                    "PrincipalType" => PrincipalType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_application_authentication_methods(application_arn)
    list_application_authentication_methods(application_arn, params::Dict{String,<:Any})

Lists all of the authentication methods supported by the specified application.

# Arguments
- `application_arn`: Specifies the ARN of the application with the authentication methods
  you want to list.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: Specifies that you want to receive the next page of results. Valid only if
  you received a NextToken response in the previous request. If you did, it indicates that
  more output is available. Set this parameter to the value provided by the previous call's
  NextToken response to request the next page of results.
"""
function list_application_authentication_methods(
    ApplicationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sso_admin(
        "ListApplicationAuthenticationMethods",
        Dict{String,Any}("ApplicationArn" => ApplicationArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_application_authentication_methods(
    ApplicationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "ListApplicationAuthenticationMethods",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ApplicationArn" => ApplicationArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_application_grants(application_arn)
    list_application_grants(application_arn, params::Dict{String,<:Any})

List the grants associated with an application.

# Arguments
- `application_arn`: Specifies the ARN of the application whose grants you want to list.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: Specifies that you want to receive the next page of results. Valid only if
  you received a NextToken response in the previous request. If you did, it indicates that
  more output is available. Set this parameter to the value provided by the previous call's
  NextToken response to request the next page of results.
"""
function list_application_grants(
    ApplicationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sso_admin(
        "ListApplicationGrants",
        Dict{String,Any}("ApplicationArn" => ApplicationArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_application_grants(
    ApplicationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "ListApplicationGrants",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ApplicationArn" => ApplicationArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_application_providers()
    list_application_providers(params::Dict{String,<:Any})

Lists the application providers configured in the IAM Identity Center identity store.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Specifies the total number of results that you want included in each
  response. If additional items exist beyond the number you specify, the NextToken response
  element is returned with a value (not null). Include the specified value as the NextToken
  request parameter in the next call to the operation to get the next set of results. Note
  that the service might return fewer results than the maximum even when there are more
  results available. You should check NextToken after every operation to ensure that you
  receive all of the results.
- `"NextToken"`: Specifies that you want to receive the next page of results. Valid only if
  you received a NextToken response in the previous request. If you did, it indicates that
  more output is available. Set this parameter to the value provided by the previous call's
  NextToken response to request the next page of results.
"""
function list_application_providers(; aws_config::AbstractAWSConfig=current_aws_config())
    return sso_admin(
        "ListApplicationProviders"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_application_providers(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sso_admin(
        "ListApplicationProviders",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_applications(instance_arn)
    list_applications(instance_arn, params::Dict{String,<:Any})

Lists all applications associated with the instance of IAM Identity Center. When listing
applications for an instance in the management account, member accounts must use the
applicationAccount parameter to filter the list to only applications created from that
account.

# Arguments
- `instance_arn`: The ARN of the IAM Identity Center application under which the operation
  will run. For more information about ARNs, see Amazon Resource Names (ARNs) and Amazon Web
  Services Service Namespaces in the Amazon Web Services General Reference.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filter"`: Filters response results.
- `"MaxResults"`: Specifies the total number of results that you want included in each
  response. If additional items exist beyond the number you specify, the NextToken response
  element is returned with a value (not null). Include the specified value as the NextToken
  request parameter in the next call to the operation to get the next set of results. Note
  that the service might return fewer results than the maximum even when there are more
  results available. You should check NextToken after every operation to ensure that you
  receive all of the results.
- `"NextToken"`: Specifies that you want to receive the next page of results. Valid only if
  you received a NextToken response in the previous request. If you did, it indicates that
  more output is available. Set this parameter to the value provided by the previous call's
  NextToken response to request the next page of results.
"""
function list_applications(InstanceArn; aws_config::AbstractAWSConfig=current_aws_config())
    return sso_admin(
        "ListApplications",
        Dict{String,Any}("InstanceArn" => InstanceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_applications(
    InstanceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "ListApplications",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("InstanceArn" => InstanceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_customer_managed_policy_references_in_permission_set(instance_arn, permission_set_arn)
    list_customer_managed_policy_references_in_permission_set(instance_arn, permission_set_arn, params::Dict{String,<:Any})

Lists all customer managed policies attached to a specified PermissionSet.

# Arguments
- `instance_arn`: The ARN of the IAM Identity Center instance under which the operation
  will be executed.
- `permission_set_arn`: The ARN of the PermissionSet.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to display for the list call.
- `"NextToken"`: The pagination token for the list API. Initially the value is null. Use
  the output of previous API calls to make subsequent calls.
"""
function list_customer_managed_policy_references_in_permission_set(
    InstanceArn, PermissionSetArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sso_admin(
        "ListCustomerManagedPolicyReferencesInPermissionSet",
        Dict{String,Any}(
            "InstanceArn" => InstanceArn, "PermissionSetArn" => PermissionSetArn
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_customer_managed_policy_references_in_permission_set(
    InstanceArn,
    PermissionSetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "ListCustomerManagedPolicyReferencesInPermissionSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "InstanceArn" => InstanceArn, "PermissionSetArn" => PermissionSetArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_instances()
    list_instances(params::Dict{String,<:Any})

Lists the details of the organization and account instances of IAM Identity Center that
were created in or visible to the account calling this API.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to display for the instance.
- `"NextToken"`: The pagination token for the list API. Initially the value is null. Use
  the output of previous API calls to make subsequent calls.
"""
function list_instances(; aws_config::AbstractAWSConfig=current_aws_config())
    return sso_admin(
        "ListInstances"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_instances(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sso_admin(
        "ListInstances", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_managed_policies_in_permission_set(instance_arn, permission_set_arn)
    list_managed_policies_in_permission_set(instance_arn, permission_set_arn, params::Dict{String,<:Any})

Lists the Amazon Web Services managed policy that is attached to a specified permission set.

# Arguments
- `instance_arn`: The ARN of the IAM Identity Center instance under which the operation
  will be executed. For more information about ARNs, see Amazon Resource Names (ARNs) and
  Amazon Web Services Service Namespaces in the Amazon Web Services General Reference.
- `permission_set_arn`: The ARN of the PermissionSet whose managed policies will be listed.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to display for the PermissionSet.
- `"NextToken"`: The pagination token for the list API. Initially the value is null. Use
  the output of previous API calls to make subsequent calls.
"""
function list_managed_policies_in_permission_set(
    InstanceArn, PermissionSetArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sso_admin(
        "ListManagedPoliciesInPermissionSet",
        Dict{String,Any}(
            "InstanceArn" => InstanceArn, "PermissionSetArn" => PermissionSetArn
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_managed_policies_in_permission_set(
    InstanceArn,
    PermissionSetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "ListManagedPoliciesInPermissionSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "InstanceArn" => InstanceArn, "PermissionSetArn" => PermissionSetArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_permission_set_provisioning_status(instance_arn)
    list_permission_set_provisioning_status(instance_arn, params::Dict{String,<:Any})

Lists the status of the permission set provisioning requests for a specified IAM Identity
Center instance.

# Arguments
- `instance_arn`: The ARN of the IAM Identity Center instance under which the operation
  will be executed. For more information about ARNs, see Amazon Resource Names (ARNs) and
  Amazon Web Services Service Namespaces in the Amazon Web Services General Reference.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filter"`: Filters results based on the passed attribute value.
- `"MaxResults"`: The maximum number of results to display for the assignment.
- `"NextToken"`: The pagination token for the list API. Initially the value is null. Use
  the output of previous API calls to make subsequent calls.
"""
function list_permission_set_provisioning_status(
    InstanceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sso_admin(
        "ListPermissionSetProvisioningStatus",
        Dict{String,Any}("InstanceArn" => InstanceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_permission_set_provisioning_status(
    InstanceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "ListPermissionSetProvisioningStatus",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("InstanceArn" => InstanceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_permission_sets(instance_arn)
    list_permission_sets(instance_arn, params::Dict{String,<:Any})

Lists the PermissionSets in an IAM Identity Center instance.

# Arguments
- `instance_arn`: The ARN of the IAM Identity Center instance under which the operation
  will be executed. For more information about ARNs, see Amazon Resource Names (ARNs) and
  Amazon Web Services Service Namespaces in the Amazon Web Services General Reference.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to display for the assignment.
- `"NextToken"`: The pagination token for the list API. Initially the value is null. Use
  the output of previous API calls to make subsequent calls.
"""
function list_permission_sets(
    InstanceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sso_admin(
        "ListPermissionSets",
        Dict{String,Any}("InstanceArn" => InstanceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_permission_sets(
    InstanceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "ListPermissionSets",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("InstanceArn" => InstanceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_permission_sets_provisioned_to_account(account_id, instance_arn)
    list_permission_sets_provisioned_to_account(account_id, instance_arn, params::Dict{String,<:Any})

Lists all the permission sets that are provisioned to a specified Amazon Web Services
account.

# Arguments
- `account_id`: The identifier of the Amazon Web Services account from which to list the
  assignments.
- `instance_arn`: The ARN of the IAM Identity Center instance under which the operation
  will be executed. For more information about ARNs, see Amazon Resource Names (ARNs) and
  Amazon Web Services Service Namespaces in the Amazon Web Services General Reference.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to display for the assignment.
- `"NextToken"`: The pagination token for the list API. Initially the value is null. Use
  the output of previous API calls to make subsequent calls.
- `"ProvisioningStatus"`: The status object for the permission set provisioning operation.
"""
function list_permission_sets_provisioned_to_account(
    AccountId, InstanceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sso_admin(
        "ListPermissionSetsProvisionedToAccount",
        Dict{String,Any}("AccountId" => AccountId, "InstanceArn" => InstanceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_permission_sets_provisioned_to_account(
    AccountId,
    InstanceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "ListPermissionSetsProvisionedToAccount",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("AccountId" => AccountId, "InstanceArn" => InstanceArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists the tags that are attached to a specified resource.

# Arguments
- `resource_arn`: The ARN of the resource with the tags to be listed.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"InstanceArn"`: The ARN of the IAM Identity Center instance under which the operation
  will be executed. For more information about ARNs, see Amazon Resource Names (ARNs) and
  Amazon Web Services Service Namespaces in the Amazon Web Services General Reference.
- `"NextToken"`: The pagination token for the list API. Initially the value is null. Use
  the output of previous API calls to make subsequent calls.
"""
function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sso_admin(
        "ListTagsForResource",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_trusted_token_issuers(instance_arn)
    list_trusted_token_issuers(instance_arn, params::Dict{String,<:Any})

Lists all the trusted token issuers configured in an instance of IAM Identity Center.

# Arguments
- `instance_arn`: Specifies the ARN of the instance of IAM Identity Center with the trusted
  token issuer configurations that you want to list.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Specifies the total number of results that you want included in each
  response. If additional items exist beyond the number you specify, the NextToken response
  element is returned with a value (not null). Include the specified value as the NextToken
  request parameter in the next call to the operation to get the next set of results. Note
  that the service might return fewer results than the maximum even when there are more
  results available. You should check NextToken after every operation to ensure that you
  receive all of the results.
- `"NextToken"`: Specifies that you want to receive the next page of results. Valid only if
  you received a NextToken response in the previous request. If you did, it indicates that
  more output is available. Set this parameter to the value provided by the previous call's
  NextToken response to request the next page of results.
"""
function list_trusted_token_issuers(
    InstanceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sso_admin(
        "ListTrustedTokenIssuers",
        Dict{String,Any}("InstanceArn" => InstanceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_trusted_token_issuers(
    InstanceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "ListTrustedTokenIssuers",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("InstanceArn" => InstanceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    provision_permission_set(instance_arn, permission_set_arn, target_type)
    provision_permission_set(instance_arn, permission_set_arn, target_type, params::Dict{String,<:Any})

The process by which a specified permission set is provisioned to the specified target.

# Arguments
- `instance_arn`: The ARN of the IAM Identity Center instance under which the operation
  will be executed. For more information about ARNs, see Amazon Resource Names (ARNs) and
  Amazon Web Services Service Namespaces in the Amazon Web Services General Reference.
- `permission_set_arn`: The ARN of the permission set.
- `target_type`: The entity type for which the assignment will be created.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"TargetId"`: TargetID is an Amazon Web Services account identifier, (For example,
  123456789012).
"""
function provision_permission_set(
    InstanceArn,
    PermissionSetArn,
    TargetType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "ProvisionPermissionSet",
        Dict{String,Any}(
            "InstanceArn" => InstanceArn,
            "PermissionSetArn" => PermissionSetArn,
            "TargetType" => TargetType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function provision_permission_set(
    InstanceArn,
    PermissionSetArn,
    TargetType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "ProvisionPermissionSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "InstanceArn" => InstanceArn,
                    "PermissionSetArn" => PermissionSetArn,
                    "TargetType" => TargetType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_application_access_scope(application_arn, scope)
    put_application_access_scope(application_arn, scope, params::Dict{String,<:Any})

Adds or updates the list of authorized targets for an IAM Identity Center access scope for
an application.

# Arguments
- `application_arn`: Specifies the ARN of the application with the access scope with the
  targets to add or update.
- `scope`: Specifies the name of the access scope to be associated with the specified
  targets.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AuthorizedTargets"`: Specifies an array list of ARNs that represent the authorized
  targets for this access scope.
"""
function put_application_access_scope(
    ApplicationArn, Scope; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sso_admin(
        "PutApplicationAccessScope",
        Dict{String,Any}("ApplicationArn" => ApplicationArn, "Scope" => Scope);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_application_access_scope(
    ApplicationArn,
    Scope,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "PutApplicationAccessScope",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ApplicationArn" => ApplicationArn, "Scope" => Scope),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_application_assignment_configuration(application_arn, assignment_required)
    put_application_assignment_configuration(application_arn, assignment_required, params::Dict{String,<:Any})

Configure how users gain access to an application. If AssignmentsRequired is true (default
value), users don’t have access to the application unless an assignment is created using
the CreateApplicationAssignment API. If false, all users have access to the application. If
an assignment is created using CreateApplicationAssignment., the user retains access if
AssignmentsRequired is set to true.

# Arguments
- `application_arn`: Specifies the ARN of the application. For more information about ARNs,
  see Amazon Resource Names (ARNs) and Amazon Web Services Service Namespaces in the Amazon
  Web Services General Reference.
- `assignment_required`: If AssignmentsRequired is true (default value), users don’t have
  access to the application unless an assignment is created using the
  CreateApplicationAssignment API. If false, all users have access to the application.

"""
function put_application_assignment_configuration(
    ApplicationArn, AssignmentRequired; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sso_admin(
        "PutApplicationAssignmentConfiguration",
        Dict{String,Any}(
            "ApplicationArn" => ApplicationArn, "AssignmentRequired" => AssignmentRequired
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_application_assignment_configuration(
    ApplicationArn,
    AssignmentRequired,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "PutApplicationAssignmentConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationArn" => ApplicationArn,
                    "AssignmentRequired" => AssignmentRequired,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_application_authentication_method(application_arn, authentication_method, authentication_method_type)
    put_application_authentication_method(application_arn, authentication_method, authentication_method_type, params::Dict{String,<:Any})

Adds or updates an authentication method for an application.

# Arguments
- `application_arn`: Specifies the ARN of the application with the authentication method to
  add or update.
- `authentication_method`: Specifies a structure that describes the authentication method
  to add or update. The structure type you provide is determined by the
  AuthenticationMethodType parameter.
- `authentication_method_type`: Specifies the type of the authentication method that you
  want to add or update.

"""
function put_application_authentication_method(
    ApplicationArn,
    AuthenticationMethod,
    AuthenticationMethodType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "PutApplicationAuthenticationMethod",
        Dict{String,Any}(
            "ApplicationArn" => ApplicationArn,
            "AuthenticationMethod" => AuthenticationMethod,
            "AuthenticationMethodType" => AuthenticationMethodType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_application_authentication_method(
    ApplicationArn,
    AuthenticationMethod,
    AuthenticationMethodType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "PutApplicationAuthenticationMethod",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationArn" => ApplicationArn,
                    "AuthenticationMethod" => AuthenticationMethod,
                    "AuthenticationMethodType" => AuthenticationMethodType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_application_grant(application_arn, grant, grant_type)
    put_application_grant(application_arn, grant, grant_type, params::Dict{String,<:Any})

Adds a grant to an application.

# Arguments
- `application_arn`: Specifies the ARN of the application to update.
- `grant`: Specifies a structure that describes the grant to update.
- `grant_type`: Specifies the type of grant to update.

"""
function put_application_grant(
    ApplicationArn, Grant, GrantType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sso_admin(
        "PutApplicationGrant",
        Dict{String,Any}(
            "ApplicationArn" => ApplicationArn, "Grant" => Grant, "GrantType" => GrantType
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_application_grant(
    ApplicationArn,
    Grant,
    GrantType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "PutApplicationGrant",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationArn" => ApplicationArn,
                    "Grant" => Grant,
                    "GrantType" => GrantType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_inline_policy_to_permission_set(inline_policy, instance_arn, permission_set_arn)
    put_inline_policy_to_permission_set(inline_policy, instance_arn, permission_set_arn, params::Dict{String,<:Any})

Attaches an inline policy to a permission set.  If the permission set is already referenced
by one or more account assignments, you will need to call  ProvisionPermissionSet  after
this action to apply the corresponding IAM policy updates to all assigned accounts.

# Arguments
- `inline_policy`: The inline policy to attach to a PermissionSet.
- `instance_arn`: The ARN of the IAM Identity Center instance under which the operation
  will be executed. For more information about ARNs, see Amazon Resource Names (ARNs) and
  Amazon Web Services Service Namespaces in the Amazon Web Services General Reference.
- `permission_set_arn`: The ARN of the permission set.

"""
function put_inline_policy_to_permission_set(
    InlinePolicy,
    InstanceArn,
    PermissionSetArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "PutInlinePolicyToPermissionSet",
        Dict{String,Any}(
            "InlinePolicy" => InlinePolicy,
            "InstanceArn" => InstanceArn,
            "PermissionSetArn" => PermissionSetArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_inline_policy_to_permission_set(
    InlinePolicy,
    InstanceArn,
    PermissionSetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "PutInlinePolicyToPermissionSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "InlinePolicy" => InlinePolicy,
                    "InstanceArn" => InstanceArn,
                    "PermissionSetArn" => PermissionSetArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_permissions_boundary_to_permission_set(instance_arn, permission_set_arn, permissions_boundary)
    put_permissions_boundary_to_permission_set(instance_arn, permission_set_arn, permissions_boundary, params::Dict{String,<:Any})

Attaches an Amazon Web Services managed or customer managed policy to the specified
PermissionSet as a permissions boundary.

# Arguments
- `instance_arn`: The ARN of the IAM Identity Center instance under which the operation
  will be executed.
- `permission_set_arn`: The ARN of the PermissionSet.
- `permissions_boundary`: The permissions boundary that you want to attach to a
  PermissionSet.

"""
function put_permissions_boundary_to_permission_set(
    InstanceArn,
    PermissionSetArn,
    PermissionsBoundary;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "PutPermissionsBoundaryToPermissionSet",
        Dict{String,Any}(
            "InstanceArn" => InstanceArn,
            "PermissionSetArn" => PermissionSetArn,
            "PermissionsBoundary" => PermissionsBoundary,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_permissions_boundary_to_permission_set(
    InstanceArn,
    PermissionSetArn,
    PermissionsBoundary,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "PutPermissionsBoundaryToPermissionSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "InstanceArn" => InstanceArn,
                    "PermissionSetArn" => PermissionSetArn,
                    "PermissionsBoundary" => PermissionsBoundary,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Associates a set of tags with a specified resource.

# Arguments
- `resource_arn`: The ARN of the resource with the tags to be listed.
- `tags`: A set of key-value pairs that are used to manage the resource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"InstanceArn"`: The ARN of the IAM Identity Center instance under which the operation
  will be executed. For more information about ARNs, see Amazon Resource Names (ARNs) and
  Amazon Web Services Service Namespaces in the Amazon Web Services General Reference.
"""
function tag_resource(ResourceArn, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return sso_admin(
        "TagResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceArn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Disassociates a set of tags from a specified resource.

# Arguments
- `resource_arn`: The ARN of the resource with the tags to be listed.
- `tag_keys`: The keys of tags that are attached to the resource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"InstanceArn"`: The ARN of the IAM Identity Center instance under which the operation
  will be executed. For more information about ARNs, see Amazon Resource Names (ARNs) and
  Amazon Web Services Service Namespaces in the Amazon Web Services General Reference.
"""
function untag_resource(
    ResourceArn, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sso_admin(
        "UntagResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceArn,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_application(application_arn)
    update_application(application_arn, params::Dict{String,<:Any})

Updates application properties.

# Arguments
- `application_arn`: Specifies the ARN of the application. For more information about ARNs,
  see Amazon Resource Names (ARNs) and Amazon Web Services Service Namespaces in the Amazon
  Web Services General Reference.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: The description of the .
- `"Name"`: Specifies the updated name for the application.
- `"PortalOptions"`: A structure that describes the options for the portal associated with
  an application.
- `"Status"`: Specifies whether the application is enabled or disabled.
"""
function update_application(
    ApplicationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sso_admin(
        "UpdateApplication",
        Dict{String,Any}("ApplicationArn" => ApplicationArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_application(
    ApplicationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "UpdateApplication",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ApplicationArn" => ApplicationArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_instance(instance_arn, name)
    update_instance(instance_arn, name, params::Dict{String,<:Any})

Update the details for the instance of IAM Identity Center that is owned by the Amazon Web
Services account.

# Arguments
- `instance_arn`: The ARN of the instance of IAM Identity Center under which the operation
  will run. For more information about ARNs, see Amazon Resource Names (ARNs) and Amazon Web
  Services Service Namespaces in the Amazon Web Services General Reference.
- `name`: Updates the instance name.

"""
function update_instance(
    InstanceArn, Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sso_admin(
        "UpdateInstance",
        Dict{String,Any}("InstanceArn" => InstanceArn, "Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_instance(
    InstanceArn,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "UpdateInstance",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("InstanceArn" => InstanceArn, "Name" => Name),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_instance_access_control_attribute_configuration(instance_access_control_attribute_configuration, instance_arn)
    update_instance_access_control_attribute_configuration(instance_access_control_attribute_configuration, instance_arn, params::Dict{String,<:Any})

Updates the IAM Identity Center identity store attributes that you can use with the IAM
Identity Center instance for attributes-based access control (ABAC). When using an external
identity provider as an identity source, you can pass attributes through the SAML assertion
as an alternative to configuring attributes from the IAM Identity Center identity store. If
a SAML assertion passes any of these attributes, IAM Identity Center replaces the attribute
value with the value from the IAM Identity Center identity store. For more information
about ABAC, see Attribute-Based Access Control in the IAM Identity Center User Guide.

# Arguments
- `instance_access_control_attribute_configuration`: Updates the attributes for your ABAC
  configuration.
- `instance_arn`: The ARN of the IAM Identity Center instance under which the operation
  will be executed.

"""
function update_instance_access_control_attribute_configuration(
    InstanceAccessControlAttributeConfiguration,
    InstanceArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "UpdateInstanceAccessControlAttributeConfiguration",
        Dict{String,Any}(
            "InstanceAccessControlAttributeConfiguration" =>
                InstanceAccessControlAttributeConfiguration,
            "InstanceArn" => InstanceArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_instance_access_control_attribute_configuration(
    InstanceAccessControlAttributeConfiguration,
    InstanceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "UpdateInstanceAccessControlAttributeConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "InstanceAccessControlAttributeConfiguration" =>
                        InstanceAccessControlAttributeConfiguration,
                    "InstanceArn" => InstanceArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_permission_set(instance_arn, permission_set_arn)
    update_permission_set(instance_arn, permission_set_arn, params::Dict{String,<:Any})

Updates an existing permission set.

# Arguments
- `instance_arn`: The ARN of the IAM Identity Center instance under which the operation
  will be executed. For more information about ARNs, see Amazon Resource Names (ARNs) and
  Amazon Web Services Service Namespaces in the Amazon Web Services General Reference.
- `permission_set_arn`: The ARN of the permission set.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: The description of the PermissionSet.
- `"RelayState"`: Used to redirect users within the application during the federation
  authentication process.
- `"SessionDuration"`: The length of time that the application user sessions are valid for
  in the ISO-8601 standard.
"""
function update_permission_set(
    InstanceArn, PermissionSetArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sso_admin(
        "UpdatePermissionSet",
        Dict{String,Any}(
            "InstanceArn" => InstanceArn, "PermissionSetArn" => PermissionSetArn
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_permission_set(
    InstanceArn,
    PermissionSetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "UpdatePermissionSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "InstanceArn" => InstanceArn, "PermissionSetArn" => PermissionSetArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_trusted_token_issuer(trusted_token_issuer_arn)
    update_trusted_token_issuer(trusted_token_issuer_arn, params::Dict{String,<:Any})

Updates the name of the trusted token issuer, or the path of a source attribute or
destination attribute for a trusted token issuer configuration.  Updating this trusted
token issuer configuration might cause users to lose access to any applications that are
configured to use the trusted token issuer.

# Arguments
- `trusted_token_issuer_arn`: Specifies the ARN of the trusted token issuer configuration
  that you want to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Name"`: Specifies the updated name to be applied to the trusted token issuer
  configuration.
- `"TrustedTokenIssuerConfiguration"`: Specifies a structure with settings to apply to the
  specified trusted token issuer. The settings that you can provide are determined by the
  type of the trusted token issuer that you are updating.
"""
function update_trusted_token_issuer(
    TrustedTokenIssuerArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sso_admin(
        "UpdateTrustedTokenIssuer",
        Dict{String,Any}("TrustedTokenIssuerArn" => TrustedTokenIssuerArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_trusted_token_issuer(
    TrustedTokenIssuerArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso_admin(
        "UpdateTrustedTokenIssuer",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("TrustedTokenIssuerArn" => TrustedTokenIssuerArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: elastic_load_balancing_v2
using AWS.Compat
using AWS.UUIDs

"""
    add_listener_certificates(certificates, listener_arn)
    add_listener_certificates(certificates, listener_arn, params::Dict{String,<:Any})

Adds the specified SSL server certificate to the certificate list for the specified HTTPS
or TLS listener. If the certificate in already in the certificate list, the call is
successful but the certificate is not added again. For more information, see HTTPS
listeners in the Application Load Balancers Guide or TLS listeners in the Network Load
Balancers Guide.

# Arguments
- `certificates`: The certificate to add. You can specify one certificate per call. Set
  CertificateArn to the certificate ARN but do not set IsDefault.
- `listener_arn`: The Amazon Resource Name (ARN) of the listener.

"""
function add_listener_certificates(
    Certificates, ListenerArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_load_balancing_v2(
        "AddListenerCertificates",
        Dict{String,Any}("Certificates" => Certificates, "ListenerArn" => ListenerArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_listener_certificates(
    Certificates,
    ListenerArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing_v2(
        "AddListenerCertificates",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Certificates" => Certificates, "ListenerArn" => ListenerArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    add_tags(resource_arns, tags)
    add_tags(resource_arns, tags, params::Dict{String,<:Any})

Adds the specified tags to the specified Elastic Load Balancing resource. You can tag your
Application Load Balancers, Network Load Balancers, Gateway Load Balancers, target groups,
trust stores, listeners, and rules. Each tag consists of a key and an optional value. If a
resource already has a tag with the same key, AddTags updates its value.

# Arguments
- `resource_arns`: The Amazon Resource Name (ARN) of the resource.
- `tags`: The tags.

"""
function add_tags(ResourceArns, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return elastic_load_balancing_v2(
        "AddTags",
        Dict{String,Any}("ResourceArns" => ResourceArns, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_tags(
    ResourceArns,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing_v2(
        "AddTags",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArns" => ResourceArns, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    add_trust_store_revocations(trust_store_arn)
    add_trust_store_revocations(trust_store_arn, params::Dict{String,<:Any})

Adds the specified revocation file to the specified trust store.

# Arguments
- `trust_store_arn`: The Amazon Resource Name (ARN) of the trust store.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"RevocationContents"`: The revocation file to add.
"""
function add_trust_store_revocations(
    TrustStoreArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_load_balancing_v2(
        "AddTrustStoreRevocations",
        Dict{String,Any}("TrustStoreArn" => TrustStoreArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_trust_store_revocations(
    TrustStoreArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing_v2(
        "AddTrustStoreRevocations",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TrustStoreArn" => TrustStoreArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_listener(default_actions, load_balancer_arn)
    create_listener(default_actions, load_balancer_arn, params::Dict{String,<:Any})

Creates a listener for the specified Application Load Balancer, Network Load Balancer, or
Gateway Load Balancer. For more information, see the following:    Listeners for your
Application Load Balancers     Listeners for your Network Load Balancers     Listeners for
your Gateway Load Balancers    This operation is idempotent, which means that it completes
at most one time. If you attempt to create multiple listeners with the same settings, each
call succeeds.

# Arguments
- `default_actions`: The actions for the default rule.
- `load_balancer_arn`: The Amazon Resource Name (ARN) of the load balancer.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AlpnPolicy"`: [TLS listeners] The name of the Application-Layer Protocol Negotiation
  (ALPN) policy. You can specify one policy name. The following are the possible values:
  HTTP1Only     HTTP2Only     HTTP2Optional     HTTP2Preferred     None    For more
  information, see ALPN policies in the Network Load Balancers Guide.
- `"Certificates"`: [HTTPS and TLS listeners] The default certificate for the listener. You
  must provide exactly one certificate. Set CertificateArn to the certificate ARN but do not
  set IsDefault.
- `"MutualAuthentication"`: The mutual authentication configuration information.
- `"Port"`: The port on which the load balancer is listening. You cannot specify a port for
  a Gateway Load Balancer.
- `"Protocol"`: The protocol for connections from clients to the load balancer. For
  Application Load Balancers, the supported protocols are HTTP and HTTPS. For Network Load
  Balancers, the supported protocols are TCP, TLS, UDP, and TCP_UDP. You can’t specify the
  UDP or TCP_UDP protocol if dual-stack mode is enabled. You cannot specify a protocol for a
  Gateway Load Balancer.
- `"SslPolicy"`: [HTTPS and TLS listeners] The security policy that defines which protocols
  and ciphers are supported. For more information, see Security policies in the Application
  Load Balancers Guide and Security policies in the Network Load Balancers Guide.
- `"Tags"`: The tags to assign to the listener.
"""
function create_listener(
    DefaultActions, LoadBalancerArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_load_balancing_v2(
        "CreateListener",
        Dict{String,Any}(
            "DefaultActions" => DefaultActions, "LoadBalancerArn" => LoadBalancerArn
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_listener(
    DefaultActions,
    LoadBalancerArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing_v2(
        "CreateListener",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DefaultActions" => DefaultActions, "LoadBalancerArn" => LoadBalancerArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_load_balancer(name)
    create_load_balancer(name, params::Dict{String,<:Any})

Creates an Application Load Balancer, Network Load Balancer, or Gateway Load Balancer. For
more information, see the following:    Application Load Balancers     Network Load
Balancers     Gateway Load Balancers    This operation is idempotent, which means that it
completes at most one time. If you attempt to create multiple load balancers with the same
settings, each call succeeds.

# Arguments
- `name`: The name of the load balancer. This name must be unique per region per account,
  can have a maximum of 32 characters, must contain only alphanumeric characters or hyphens,
  must not begin or end with a hyphen, and must not begin with \"internal-\".

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CustomerOwnedIpv4Pool"`: [Application Load Balancers on Outposts] The ID of the
  customer-owned address pool (CoIP pool).
- `"IpAddressType"`: Note: Internal load balancers must use the ipv4 IP address type.
  [Application Load Balancers] The IP address type. The possible values are ipv4 (for only
  IPv4 addresses), dualstack (for IPv4 and IPv6 addresses), and dualstack-without-public-ipv4
  (for IPv6 only public addresses, with private IPv4 and IPv6 addresses). [Network Load
  Balancers] The IP address type. The possible values are ipv4 (for only IPv4 addresses) and
  dualstack (for IPv4 and IPv6 addresses). You can’t specify dualstack for a load balancer
  with a UDP or TCP_UDP listener. [Gateway Load Balancers] The IP address type. The possible
  values are ipv4 (for only IPv4 addresses) and dualstack (for IPv4 and IPv6 addresses).
- `"Scheme"`: The nodes of an Internet-facing load balancer have public IP addresses. The
  DNS name of an Internet-facing load balancer is publicly resolvable to the public IP
  addresses of the nodes. Therefore, Internet-facing load balancers can route requests from
  clients over the internet. The nodes of an internal load balancer have only private IP
  addresses. The DNS name of an internal load balancer is publicly resolvable to the private
  IP addresses of the nodes. Therefore, internal load balancers can route requests only from
  clients with access to the VPC for the load balancer. The default is an Internet-facing
  load balancer. You cannot specify a scheme for a Gateway Load Balancer.
- `"SecurityGroups"`: [Application Load Balancers and Network Load Balancers] The IDs of
  the security groups for the load balancer.
- `"SubnetMappings"`: The IDs of the subnets. You can specify only one subnet per
  Availability Zone. You must specify either subnets or subnet mappings, but not both.
  [Application Load Balancers] You must specify subnets from at least two Availability Zones.
  You cannot specify Elastic IP addresses for your subnets. [Application Load Balancers on
  Outposts] You must specify one Outpost subnet. [Application Load Balancers on Local Zones]
  You can specify subnets from one or more Local Zones. [Network Load Balancers] You can
  specify subnets from one or more Availability Zones. You can specify one Elastic IP address
  per subnet if you need static IP addresses for your internet-facing load balancer. For
  internal load balancers, you can specify one private IP address per subnet from the IPv4
  range of the subnet. For internet-facing load balancer, you can specify one IPv6 address
  per subnet. [Gateway Load Balancers] You can specify subnets from one or more Availability
  Zones. You cannot specify Elastic IP addresses for your subnets.
- `"Subnets"`: The IDs of the subnets. You can specify only one subnet per Availability
  Zone. You must specify either subnets or subnet mappings, but not both. To specify an
  Elastic IP address, specify subnet mappings instead of subnets. [Application Load
  Balancers] You must specify subnets from at least two Availability Zones. [Application Load
  Balancers on Outposts] You must specify one Outpost subnet. [Application Load Balancers on
  Local Zones] You can specify subnets from one or more Local Zones. [Network Load Balancers]
  You can specify subnets from one or more Availability Zones. [Gateway Load Balancers] You
  can specify subnets from one or more Availability Zones.
- `"Tags"`: The tags to assign to the load balancer.
- `"Type"`: The type of load balancer. The default is application.
"""
function create_load_balancer(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return elastic_load_balancing_v2(
        "CreateLoadBalancer",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_load_balancer(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_load_balancing_v2(
        "CreateLoadBalancer",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_rule(actions, conditions, listener_arn, priority)
    create_rule(actions, conditions, listener_arn, priority, params::Dict{String,<:Any})

Creates a rule for the specified listener. The listener must be associated with an
Application Load Balancer. Each rule consists of a priority, one or more actions, and one
or more conditions. Rules are evaluated in priority order, from the lowest value to the
highest value. When the conditions for a rule are met, its actions are performed. If the
conditions for no rules are met, the actions for the default rule are performed. For more
information, see Listener rules in the Application Load Balancers Guide.

# Arguments
- `actions`: The actions.
- `conditions`: The conditions.
- `listener_arn`: The Amazon Resource Name (ARN) of the listener.
- `priority`: The rule priority. A listener can't have multiple rules with the same
  priority.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: The tags to assign to the rule.
"""
function create_rule(
    Actions,
    Conditions,
    ListenerArn,
    Priority;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing_v2(
        "CreateRule",
        Dict{String,Any}(
            "Actions" => Actions,
            "Conditions" => Conditions,
            "ListenerArn" => ListenerArn,
            "Priority" => Priority,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_rule(
    Actions,
    Conditions,
    ListenerArn,
    Priority,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing_v2(
        "CreateRule",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Actions" => Actions,
                    "Conditions" => Conditions,
                    "ListenerArn" => ListenerArn,
                    "Priority" => Priority,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_target_group(name)
    create_target_group(name, params::Dict{String,<:Any})

Creates a target group. For more information, see the following:    Target groups for your
Application Load Balancers     Target groups for your Network Load Balancers     Target
groups for your Gateway Load Balancers    This operation is idempotent, which means that it
completes at most one time. If you attempt to create multiple target groups with the same
settings, each call succeeds.

# Arguments
- `name`: The name of the target group. This name must be unique per region per account,
  can have a maximum of 32 characters, must contain only alphanumeric characters or hyphens,
  and must not begin or end with a hyphen.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"HealthCheckEnabled"`: Indicates whether health checks are enabled. If the target type
  is lambda, health checks are disabled by default but can be enabled. If the target type is
  instance, ip, or alb, health checks are always enabled and cannot be disabled.
- `"HealthCheckIntervalSeconds"`: The approximate amount of time, in seconds, between
  health checks of an individual target. The range is 5-300. If the target group protocol is
  TCP, TLS, UDP, TCP_UDP, HTTP or HTTPS, the default is 30 seconds. If the target group
  protocol is GENEVE, the default is 10 seconds. If the target type is lambda, the default is
  35 seconds.
- `"HealthCheckPath"`: [HTTP/HTTPS health checks] The destination for health checks on the
  targets. [HTTP1 or HTTP2 protocol version] The ping path. The default is /. [GRPC protocol
  version] The path of a custom health check method with the format /package.service/method.
  The default is /Amazon Web Services.ALB/healthcheck.
- `"HealthCheckPort"`: The port the load balancer uses when performing health checks on
  targets. If the protocol is HTTP, HTTPS, TCP, TLS, UDP, or TCP_UDP, the default is
  traffic-port, which is the port on which each target receives traffic from the load
  balancer. If the protocol is GENEVE, the default is port 80.
- `"HealthCheckProtocol"`: The protocol the load balancer uses when performing health
  checks on targets. For Application Load Balancers, the default is HTTP. For Network Load
  Balancers and Gateway Load Balancers, the default is TCP. The TCP protocol is not supported
  for health checks if the protocol of the target group is HTTP or HTTPS. The GENEVE, TLS,
  UDP, and TCP_UDP protocols are not supported for health checks.
- `"HealthCheckTimeoutSeconds"`: The amount of time, in seconds, during which no response
  from a target means a failed health check. The range is 2–120 seconds. For target groups
  with a protocol of HTTP, the default is 6 seconds. For target groups with a protocol of
  TCP, TLS or HTTPS, the default is 10 seconds. For target groups with a protocol of GENEVE,
  the default is 5 seconds. If the target type is lambda, the default is 30 seconds.
- `"HealthyThresholdCount"`: The number of consecutive health check successes required
  before considering a target healthy. The range is 2-10. If the target group protocol is
  TCP, TCP_UDP, UDP, TLS, HTTP or HTTPS, the default is 5. For target groups with a protocol
  of GENEVE, the default is 5. If the target type is lambda, the default is 5.
- `"IpAddressType"`: The type of IP address used for this target group. The possible values
  are ipv4 and ipv6. This is an optional parameter. If not specified, the IP address type
  defaults to ipv4.
- `"Matcher"`: [HTTP/HTTPS health checks] The HTTP or gRPC codes to use when checking for a
  successful response from a target. For target groups with a protocol of TCP, TCP_UDP, UDP
  or TLS the range is 200-599. For target groups with a protocol of HTTP or HTTPS, the range
  is 200-499. For target groups with a protocol of GENEVE, the range is 200-399.
- `"Port"`: The port on which the targets receive traffic. This port is used unless you
  specify a port override when registering the target. If the target is a Lambda function,
  this parameter does not apply. If the protocol is GENEVE, the supported port is 6081.
- `"Protocol"`: The protocol to use for routing traffic to the targets. For Application
  Load Balancers, the supported protocols are HTTP and HTTPS. For Network Load Balancers, the
  supported protocols are TCP, TLS, UDP, or TCP_UDP. For Gateway Load Balancers, the
  supported protocol is GENEVE. A TCP_UDP listener must be associated with a TCP_UDP target
  group. If the target is a Lambda function, this parameter does not apply.
- `"ProtocolVersion"`: [HTTP/HTTPS protocol] The protocol version. Specify GRPC to send
  requests to targets using gRPC. Specify HTTP2 to send requests to targets using HTTP/2. The
  default is HTTP1, which sends requests to targets using HTTP/1.1.
- `"Tags"`: The tags to assign to the target group.
- `"TargetType"`: The type of target that you must specify when registering targets with
  this target group. You can't specify targets for a target group using more than one target
  type.    instance - Register targets by instance ID. This is the default value.    ip -
  Register targets by IP address. You can specify IP addresses from the subnets of the
  virtual private cloud (VPC) for the target group, the RFC 1918 range (10.0.0.0/8,
  172.16.0.0/12, and 192.168.0.0/16), and the RFC 6598 range (100.64.0.0/10). You can't
  specify publicly routable IP addresses.    lambda - Register a single Lambda function as a
  target.    alb - Register a single Application Load Balancer as a target.
- `"UnhealthyThresholdCount"`: The number of consecutive health check failures required
  before considering a target unhealthy. The range is 2-10. If the target group protocol is
  TCP, TCP_UDP, UDP, TLS, HTTP or HTTPS, the default is 2. For target groups with a protocol
  of GENEVE, the default is 2. If the target type is lambda, the default is 5.
- `"VpcId"`: The identifier of the virtual private cloud (VPC). If the target is a Lambda
  function, this parameter does not apply. Otherwise, this parameter is required.
"""
function create_target_group(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return elastic_load_balancing_v2(
        "CreateTargetGroup",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_target_group(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_load_balancing_v2(
        "CreateTargetGroup",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_trust_store(ca_certificates_bundle_s3_bucket, ca_certificates_bundle_s3_key, name)
    create_trust_store(ca_certificates_bundle_s3_bucket, ca_certificates_bundle_s3_key, name, params::Dict{String,<:Any})

Creates a trust store.

# Arguments
- `ca_certificates_bundle_s3_bucket`: The Amazon S3 bucket for the ca certificates bundle.
- `ca_certificates_bundle_s3_key`: The Amazon S3 path for the ca certificates bundle.
- `name`: The name of the trust store. This name must be unique per region and cannot be
  changed after creation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CaCertificatesBundleS3ObjectVersion"`: The Amazon S3 object version for the ca
  certificates bundle. If undefined the current version is used.
- `"Tags"`: The tags to assign to the trust store.
"""
function create_trust_store(
    CaCertificatesBundleS3Bucket,
    CaCertificatesBundleS3Key,
    Name;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing_v2(
        "CreateTrustStore",
        Dict{String,Any}(
            "CaCertificatesBundleS3Bucket" => CaCertificatesBundleS3Bucket,
            "CaCertificatesBundleS3Key" => CaCertificatesBundleS3Key,
            "Name" => Name,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_trust_store(
    CaCertificatesBundleS3Bucket,
    CaCertificatesBundleS3Key,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing_v2(
        "CreateTrustStore",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CaCertificatesBundleS3Bucket" => CaCertificatesBundleS3Bucket,
                    "CaCertificatesBundleS3Key" => CaCertificatesBundleS3Key,
                    "Name" => Name,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_listener(listener_arn)
    delete_listener(listener_arn, params::Dict{String,<:Any})

Deletes the specified listener. Alternatively, your listener is deleted when you delete the
load balancer to which it is attached.

# Arguments
- `listener_arn`: The Amazon Resource Name (ARN) of the listener.

"""
function delete_listener(ListenerArn; aws_config::AbstractAWSConfig=current_aws_config())
    return elastic_load_balancing_v2(
        "DeleteListener",
        Dict{String,Any}("ListenerArn" => ListenerArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_listener(
    ListenerArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing_v2(
        "DeleteListener",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ListenerArn" => ListenerArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_load_balancer(load_balancer_arn)
    delete_load_balancer(load_balancer_arn, params::Dict{String,<:Any})

Deletes the specified Application Load Balancer, Network Load Balancer, or Gateway Load
Balancer. Deleting a load balancer also deletes its listeners. You can't delete a load
balancer if deletion protection is enabled. If the load balancer does not exist or has
already been deleted, the call succeeds. Deleting a load balancer does not affect its
registered targets. For example, your EC2 instances continue to run and are still
registered to their target groups. If you no longer need these EC2 instances, you can stop
or terminate them.

# Arguments
- `load_balancer_arn`: The Amazon Resource Name (ARN) of the load balancer.

"""
function delete_load_balancer(
    LoadBalancerArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_load_balancing_v2(
        "DeleteLoadBalancer",
        Dict{String,Any}("LoadBalancerArn" => LoadBalancerArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_load_balancer(
    LoadBalancerArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing_v2(
        "DeleteLoadBalancer",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("LoadBalancerArn" => LoadBalancerArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_rule(rule_arn)
    delete_rule(rule_arn, params::Dict{String,<:Any})

Deletes the specified rule. You can't delete the default rule.

# Arguments
- `rule_arn`: The Amazon Resource Name (ARN) of the rule.

"""
function delete_rule(RuleArn; aws_config::AbstractAWSConfig=current_aws_config())
    return elastic_load_balancing_v2(
        "DeleteRule",
        Dict{String,Any}("RuleArn" => RuleArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_rule(
    RuleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing_v2(
        "DeleteRule",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("RuleArn" => RuleArn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_target_group(target_group_arn)
    delete_target_group(target_group_arn, params::Dict{String,<:Any})

Deletes the specified target group. You can delete a target group if it is not referenced
by any actions. Deleting a target group also deletes any associated health checks. Deleting
a target group does not affect its registered targets. For example, any EC2 instances
continue to run until you stop or terminate them.

# Arguments
- `target_group_arn`: The Amazon Resource Name (ARN) of the target group.

"""
function delete_target_group(
    TargetGroupArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_load_balancing_v2(
        "DeleteTargetGroup",
        Dict{String,Any}("TargetGroupArn" => TargetGroupArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_target_group(
    TargetGroupArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing_v2(
        "DeleteTargetGroup",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TargetGroupArn" => TargetGroupArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_trust_store(trust_store_arn)
    delete_trust_store(trust_store_arn, params::Dict{String,<:Any})

Deletes a trust store.

# Arguments
- `trust_store_arn`: The Amazon Resource Name (ARN) of the trust store.

"""
function delete_trust_store(
    TrustStoreArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_load_balancing_v2(
        "DeleteTrustStore",
        Dict{String,Any}("TrustStoreArn" => TrustStoreArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_trust_store(
    TrustStoreArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing_v2(
        "DeleteTrustStore",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TrustStoreArn" => TrustStoreArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    deregister_targets(target_group_arn, targets)
    deregister_targets(target_group_arn, targets, params::Dict{String,<:Any})

Deregisters the specified targets from the specified target group. After the targets are
deregistered, they no longer receive traffic from the load balancer. The load balancer
stops sending requests to targets that are deregistering, but uses connection draining to
ensure that in-flight traffic completes on the existing connections. This deregistration
delay is configured by default but can be updated for each target group. For more
information, see the following:     Deregistration delay in the Application Load Balancers
User Guide      Deregistration delay in the Network Load Balancers User Guide
Deregistration delay in the Gateway Load Balancers User Guide    Note: If the specified
target does not exist, the action returns successfully.

# Arguments
- `target_group_arn`: The Amazon Resource Name (ARN) of the target group.
- `targets`: The targets. If you specified a port override when you registered a target,
  you must specify both the target ID and the port when you deregister it.

"""
function deregister_targets(
    TargetGroupArn, Targets; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_load_balancing_v2(
        "DeregisterTargets",
        Dict{String,Any}("TargetGroupArn" => TargetGroupArn, "Targets" => Targets);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function deregister_targets(
    TargetGroupArn,
    Targets,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing_v2(
        "DeregisterTargets",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("TargetGroupArn" => TargetGroupArn, "Targets" => Targets),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_account_limits()
    describe_account_limits(params::Dict{String,<:Any})

Describes the current Elastic Load Balancing resource limits for your Amazon Web Services
account. For more information, see the following:    Quotas for your Application Load
Balancers     Quotas for your Network Load Balancers     Quotas for your Gateway Load
Balancers

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Marker"`: The marker for the next set of results. (You received this marker from a
  previous call.)
- `"PageSize"`: The maximum number of results to return with this call.
"""
function describe_account_limits(; aws_config::AbstractAWSConfig=current_aws_config())
    return elastic_load_balancing_v2(
        "DescribeAccountLimits"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_account_limits(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_load_balancing_v2(
        "DescribeAccountLimits",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_listener_certificates(listener_arn)
    describe_listener_certificates(listener_arn, params::Dict{String,<:Any})

Describes the default certificate and the certificate list for the specified HTTPS or TLS
listener. If the default certificate is also in the certificate list, it appears twice in
the results (once with IsDefault set to true and once with IsDefault set to false). For
more information, see SSL certificates in the Application Load Balancers Guide or Server
certificates in the Network Load Balancers Guide.

# Arguments
- `listener_arn`: The Amazon Resource Names (ARN) of the listener.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Marker"`: The marker for the next set of results. (You received this marker from a
  previous call.)
- `"PageSize"`: The maximum number of results to return with this call.
"""
function describe_listener_certificates(
    ListenerArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_load_balancing_v2(
        "DescribeListenerCertificates",
        Dict{String,Any}("ListenerArn" => ListenerArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_listener_certificates(
    ListenerArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing_v2(
        "DescribeListenerCertificates",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ListenerArn" => ListenerArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_listeners()
    describe_listeners(params::Dict{String,<:Any})

Describes the specified listeners or the listeners for the specified Application Load
Balancer, Network Load Balancer, or Gateway Load Balancer. You must specify either a load
balancer or one or more listeners.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ListenerArns"`: The Amazon Resource Names (ARN) of the listeners.
- `"LoadBalancerArn"`: The Amazon Resource Name (ARN) of the load balancer.
- `"Marker"`: The marker for the next set of results. (You received this marker from a
  previous call.)
- `"PageSize"`: The maximum number of results to return with this call.
"""
function describe_listeners(; aws_config::AbstractAWSConfig=current_aws_config())
    return elastic_load_balancing_v2(
        "DescribeListeners"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_listeners(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_load_balancing_v2(
        "DescribeListeners", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_load_balancer_attributes(load_balancer_arn)
    describe_load_balancer_attributes(load_balancer_arn, params::Dict{String,<:Any})

Describes the attributes for the specified Application Load Balancer, Network Load
Balancer, or Gateway Load Balancer. For more information, see the following:    Load
balancer attributes in the Application Load Balancers Guide     Load balancer attributes in
the Network Load Balancers Guide     Load balancer attributes in the Gateway Load Balancers
Guide

# Arguments
- `load_balancer_arn`: The Amazon Resource Name (ARN) of the load balancer.

"""
function describe_load_balancer_attributes(
    LoadBalancerArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_load_balancing_v2(
        "DescribeLoadBalancerAttributes",
        Dict{String,Any}("LoadBalancerArn" => LoadBalancerArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_load_balancer_attributes(
    LoadBalancerArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing_v2(
        "DescribeLoadBalancerAttributes",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("LoadBalancerArn" => LoadBalancerArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_load_balancers()
    describe_load_balancers(params::Dict{String,<:Any})

Describes the specified load balancers or all of your load balancers.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"LoadBalancerArns"`: The Amazon Resource Names (ARN) of the load balancers. You can
  specify up to 20 load balancers in a single call.
- `"Marker"`: The marker for the next set of results. (You received this marker from a
  previous call.)
- `"Names"`: The names of the load balancers.
- `"PageSize"`: The maximum number of results to return with this call.
"""
function describe_load_balancers(; aws_config::AbstractAWSConfig=current_aws_config())
    return elastic_load_balancing_v2(
        "DescribeLoadBalancers"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_load_balancers(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_load_balancing_v2(
        "DescribeLoadBalancers",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_rules()
    describe_rules(params::Dict{String,<:Any})

Describes the specified rules or the rules for the specified listener. You must specify
either a listener or one or more rules.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ListenerArn"`: The Amazon Resource Name (ARN) of the listener.
- `"Marker"`: The marker for the next set of results. (You received this marker from a
  previous call.)
- `"PageSize"`: The maximum number of results to return with this call.
- `"RuleArns"`: The Amazon Resource Names (ARN) of the rules.
"""
function describe_rules(; aws_config::AbstractAWSConfig=current_aws_config())
    return elastic_load_balancing_v2(
        "DescribeRules"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_rules(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_load_balancing_v2(
        "DescribeRules", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_sslpolicies()
    describe_sslpolicies(params::Dict{String,<:Any})

Describes the specified policies or all policies used for SSL negotiation. For more
information, see Security policies in the Application Load Balancers Guide or Security
policies in the Network Load Balancers Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"LoadBalancerType"`:  The type of load balancer. The default lists the SSL policies for
  all load balancers.
- `"Marker"`: The marker for the next set of results. (You received this marker from a
  previous call.)
- `"Names"`: The names of the policies.
- `"PageSize"`: The maximum number of results to return with this call.
"""
function describe_sslpolicies(; aws_config::AbstractAWSConfig=current_aws_config())
    return elastic_load_balancing_v2(
        "DescribeSSLPolicies"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_sslpolicies(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_load_balancing_v2(
        "DescribeSSLPolicies",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_tags(resource_arns)
    describe_tags(resource_arns, params::Dict{String,<:Any})

Describes the tags for the specified Elastic Load Balancing resources. You can describe the
tags for one or more Application Load Balancers, Network Load Balancers, Gateway Load
Balancers, target groups, listeners, or rules.

# Arguments
- `resource_arns`: The Amazon Resource Names (ARN) of the resources. You can specify up to
  20 resources in a single call.

"""
function describe_tags(ResourceArns; aws_config::AbstractAWSConfig=current_aws_config())
    return elastic_load_balancing_v2(
        "DescribeTags",
        Dict{String,Any}("ResourceArns" => ResourceArns);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_tags(
    ResourceArns,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing_v2(
        "DescribeTags",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArns" => ResourceArns), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_target_group_attributes(target_group_arn)
    describe_target_group_attributes(target_group_arn, params::Dict{String,<:Any})

Describes the attributes for the specified target group. For more information, see the
following:    Target group attributes in the Application Load Balancers Guide     Target
group attributes in the Network Load Balancers Guide     Target group attributes in the
Gateway Load Balancers Guide

# Arguments
- `target_group_arn`: The Amazon Resource Name (ARN) of the target group.

"""
function describe_target_group_attributes(
    TargetGroupArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_load_balancing_v2(
        "DescribeTargetGroupAttributes",
        Dict{String,Any}("TargetGroupArn" => TargetGroupArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_target_group_attributes(
    TargetGroupArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing_v2(
        "DescribeTargetGroupAttributes",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TargetGroupArn" => TargetGroupArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_target_groups()
    describe_target_groups(params::Dict{String,<:Any})

Describes the specified target groups or all of your target groups. By default, all target
groups are described. Alternatively, you can specify one of the following to filter the
results: the ARN of the load balancer, the names of one or more target groups, or the ARNs
of one or more target groups.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"LoadBalancerArn"`: The Amazon Resource Name (ARN) of the load balancer.
- `"Marker"`: The marker for the next set of results. (You received this marker from a
  previous call.)
- `"Names"`: The names of the target groups.
- `"PageSize"`: The maximum number of results to return with this call.
- `"TargetGroupArns"`: The Amazon Resource Names (ARN) of the target groups.
"""
function describe_target_groups(; aws_config::AbstractAWSConfig=current_aws_config())
    return elastic_load_balancing_v2(
        "DescribeTargetGroups"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_target_groups(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_load_balancing_v2(
        "DescribeTargetGroups",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_target_health(target_group_arn)
    describe_target_health(target_group_arn, params::Dict{String,<:Any})

Describes the health of the specified targets or all of your targets.

# Arguments
- `target_group_arn`: The Amazon Resource Name (ARN) of the target group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Include"`: Used to inclue anomaly detection information.
- `"Targets"`: The targets.
"""
function describe_target_health(
    TargetGroupArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_load_balancing_v2(
        "DescribeTargetHealth",
        Dict{String,Any}("TargetGroupArn" => TargetGroupArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_target_health(
    TargetGroupArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing_v2(
        "DescribeTargetHealth",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TargetGroupArn" => TargetGroupArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_trust_store_associations(trust_store_arn)
    describe_trust_store_associations(trust_store_arn, params::Dict{String,<:Any})

Describes all resources associated with the specified trust store.

# Arguments
- `trust_store_arn`: The Amazon Resource Name (ARN) of the trust store.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Marker"`: The marker for the next set of results. (You received this marker from a
  previous call.)
- `"PageSize"`: The maximum number of results to return with this call.
"""
function describe_trust_store_associations(
    TrustStoreArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_load_balancing_v2(
        "DescribeTrustStoreAssociations",
        Dict{String,Any}("TrustStoreArn" => TrustStoreArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_trust_store_associations(
    TrustStoreArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing_v2(
        "DescribeTrustStoreAssociations",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TrustStoreArn" => TrustStoreArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_trust_store_revocations(trust_store_arn)
    describe_trust_store_revocations(trust_store_arn, params::Dict{String,<:Any})

Describes the revocation files in use by the specified trust store arn, or revocation ID.

# Arguments
- `trust_store_arn`: The Amazon Resource Name (ARN) of the trust store.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Marker"`: The marker for the next set of results. (You received this marker from a
  previous call.)
- `"PageSize"`: The maximum number of results to return with this call.
- `"RevocationIds"`: The revocation IDs of the revocation files you want to describe.
"""
function describe_trust_store_revocations(
    TrustStoreArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_load_balancing_v2(
        "DescribeTrustStoreRevocations",
        Dict{String,Any}("TrustStoreArn" => TrustStoreArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_trust_store_revocations(
    TrustStoreArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing_v2(
        "DescribeTrustStoreRevocations",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TrustStoreArn" => TrustStoreArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_trust_stores()
    describe_trust_stores(params::Dict{String,<:Any})

Describes all trust stores for a given account by trust store arn’s or name.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Marker"`: The marker for the next set of results. (You received this marker from a
  previous call.)
- `"Names"`: The names of the trust stores.
- `"PageSize"`: The maximum number of results to return with this call.
- `"TrustStoreArns"`: The Amazon Resource Name (ARN) of the trust store.
"""
function describe_trust_stores(; aws_config::AbstractAWSConfig=current_aws_config())
    return elastic_load_balancing_v2(
        "DescribeTrustStores"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_trust_stores(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_load_balancing_v2(
        "DescribeTrustStores",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_trust_store_ca_certificates_bundle(trust_store_arn)
    get_trust_store_ca_certificates_bundle(trust_store_arn, params::Dict{String,<:Any})

Retrieves the ca certificate bundle. This action returns a pre-signed S3 URI which is
active for ten minutes.

# Arguments
- `trust_store_arn`: The Amazon Resource Name (ARN) of the trust store.

"""
function get_trust_store_ca_certificates_bundle(
    TrustStoreArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_load_balancing_v2(
        "GetTrustStoreCaCertificatesBundle",
        Dict{String,Any}("TrustStoreArn" => TrustStoreArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_trust_store_ca_certificates_bundle(
    TrustStoreArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing_v2(
        "GetTrustStoreCaCertificatesBundle",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TrustStoreArn" => TrustStoreArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_trust_store_revocation_content(revocation_id, trust_store_arn)
    get_trust_store_revocation_content(revocation_id, trust_store_arn, params::Dict{String,<:Any})

Retrieves the specified revocation file. This action returns a pre-signed S3 URI which is
active for ten minutes.

# Arguments
- `revocation_id`: The revocation ID of the revocation file.
- `trust_store_arn`: The Amazon Resource Name (ARN) of the trust store.

"""
function get_trust_store_revocation_content(
    RevocationId, TrustStoreArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_load_balancing_v2(
        "GetTrustStoreRevocationContent",
        Dict{String,Any}("RevocationId" => RevocationId, "TrustStoreArn" => TrustStoreArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_trust_store_revocation_content(
    RevocationId,
    TrustStoreArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing_v2(
        "GetTrustStoreRevocationContent",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "RevocationId" => RevocationId, "TrustStoreArn" => TrustStoreArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    modify_listener(listener_arn)
    modify_listener(listener_arn, params::Dict{String,<:Any})

Replaces the specified properties of the specified listener. Any properties that you do not
specify remain unchanged. Changing the protocol from HTTPS to HTTP, or from TLS to TCP,
removes the security policy and default certificate properties. If you change the protocol
from HTTP to HTTPS, or from TCP to TLS, you must add the security policy and default
certificate properties. To add an item to a list, remove an item from a list, or update an
item in a list, you must provide the entire list. For example, to add an action, specify a
list with the current actions plus the new action.

# Arguments
- `listener_arn`: The Amazon Resource Name (ARN) of the listener.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AlpnPolicy"`: [TLS listeners] The name of the Application-Layer Protocol Negotiation
  (ALPN) policy. You can specify one policy name. The following are the possible values:
  HTTP1Only     HTTP2Only     HTTP2Optional     HTTP2Preferred     None    For more
  information, see ALPN policies in the Network Load Balancers Guide.
- `"Certificates"`: [HTTPS and TLS listeners] The default certificate for the listener. You
  must provide exactly one certificate. Set CertificateArn to the certificate ARN but do not
  set IsDefault.
- `"DefaultActions"`: The actions for the default rule.
- `"MutualAuthentication"`: The mutual authentication configuration information.
- `"Port"`: The port for connections from clients to the load balancer. You cannot specify
  a port for a Gateway Load Balancer.
- `"Protocol"`: The protocol for connections from clients to the load balancer. Application
  Load Balancers support the HTTP and HTTPS protocols. Network Load Balancers support the
  TCP, TLS, UDP, and TCP_UDP protocols. You can’t change the protocol to UDP or TCP_UDP if
  dual-stack mode is enabled. You cannot specify a protocol for a Gateway Load Balancer.
- `"SslPolicy"`: [HTTPS and TLS listeners] The security policy that defines which protocols
  and ciphers are supported. For more information, see Security policies in the Application
  Load Balancers Guide or Security policies in the Network Load Balancers Guide.
"""
function modify_listener(ListenerArn; aws_config::AbstractAWSConfig=current_aws_config())
    return elastic_load_balancing_v2(
        "ModifyListener",
        Dict{String,Any}("ListenerArn" => ListenerArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function modify_listener(
    ListenerArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing_v2(
        "ModifyListener",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ListenerArn" => ListenerArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    modify_load_balancer_attributes(attributes, load_balancer_arn)
    modify_load_balancer_attributes(attributes, load_balancer_arn, params::Dict{String,<:Any})

Modifies the specified attributes of the specified Application Load Balancer, Network Load
Balancer, or Gateway Load Balancer. If any of the specified attributes can't be modified as
requested, the call fails. Any existing attributes that you do not modify retain their
current values.

# Arguments
- `attributes`: The load balancer attributes.
- `load_balancer_arn`: The Amazon Resource Name (ARN) of the load balancer.

"""
function modify_load_balancer_attributes(
    Attributes, LoadBalancerArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_load_balancing_v2(
        "ModifyLoadBalancerAttributes",
        Dict{String,Any}("Attributes" => Attributes, "LoadBalancerArn" => LoadBalancerArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function modify_load_balancer_attributes(
    Attributes,
    LoadBalancerArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing_v2(
        "ModifyLoadBalancerAttributes",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Attributes" => Attributes, "LoadBalancerArn" => LoadBalancerArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    modify_rule(rule_arn)
    modify_rule(rule_arn, params::Dict{String,<:Any})

Replaces the specified properties of the specified rule. Any properties that you do not
specify are unchanged. To add an item to a list, remove an item from a list, or update an
item in a list, you must provide the entire list. For example, to add an action, specify a
list with the current actions plus the new action.

# Arguments
- `rule_arn`: The Amazon Resource Name (ARN) of the rule.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Actions"`: The actions.
- `"Conditions"`: The conditions.
"""
function modify_rule(RuleArn; aws_config::AbstractAWSConfig=current_aws_config())
    return elastic_load_balancing_v2(
        "ModifyRule",
        Dict{String,Any}("RuleArn" => RuleArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function modify_rule(
    RuleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing_v2(
        "ModifyRule",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("RuleArn" => RuleArn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    modify_target_group(target_group_arn)
    modify_target_group(target_group_arn, params::Dict{String,<:Any})

Modifies the health checks used when evaluating the health state of the targets in the
specified target group.

# Arguments
- `target_group_arn`: The Amazon Resource Name (ARN) of the target group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"HealthCheckEnabled"`: Indicates whether health checks are enabled.
- `"HealthCheckIntervalSeconds"`: The approximate amount of time, in seconds, between
  health checks of an individual target.
- `"HealthCheckPath"`: [HTTP/HTTPS health checks] The destination for health checks on the
  targets. [HTTP1 or HTTP2 protocol version] The ping path. The default is /. [GRPC protocol
  version] The path of a custom health check method with the format /package.service/method.
  The default is /Amazon Web Services.ALB/healthcheck.
- `"HealthCheckPort"`: The port the load balancer uses when performing health checks on
  targets.
- `"HealthCheckProtocol"`: The protocol the load balancer uses when performing health
  checks on targets. For Application Load Balancers, the default is HTTP. For Network Load
  Balancers and Gateway Load Balancers, the default is TCP. The TCP protocol is not supported
  for health checks if the protocol of the target group is HTTP or HTTPS. It is supported for
  health checks only if the protocol of the target group is TCP, TLS, UDP, or TCP_UDP. The
  GENEVE, TLS, UDP, and TCP_UDP protocols are not supported for health checks.
- `"HealthCheckTimeoutSeconds"`: [HTTP/HTTPS health checks] The amount of time, in seconds,
  during which no response means a failed health check.
- `"HealthyThresholdCount"`: The number of consecutive health checks successes required
  before considering an unhealthy target healthy.
- `"Matcher"`: [HTTP/HTTPS health checks] The HTTP or gRPC codes to use when checking for a
  successful response from a target. For target groups with a protocol of TCP, TCP_UDP, UDP
  or TLS the range is 200-599. For target groups with a protocol of HTTP or HTTPS, the range
  is 200-499. For target groups with a protocol of GENEVE, the range is 200-399.
- `"UnhealthyThresholdCount"`: The number of consecutive health check failures required
  before considering the target unhealthy.
"""
function modify_target_group(
    TargetGroupArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_load_balancing_v2(
        "ModifyTargetGroup",
        Dict{String,Any}("TargetGroupArn" => TargetGroupArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function modify_target_group(
    TargetGroupArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing_v2(
        "ModifyTargetGroup",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TargetGroupArn" => TargetGroupArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    modify_target_group_attributes(attributes, target_group_arn)
    modify_target_group_attributes(attributes, target_group_arn, params::Dict{String,<:Any})

Modifies the specified attributes of the specified target group.

# Arguments
- `attributes`: The attributes.
- `target_group_arn`: The Amazon Resource Name (ARN) of the target group.

"""
function modify_target_group_attributes(
    Attributes, TargetGroupArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_load_balancing_v2(
        "ModifyTargetGroupAttributes",
        Dict{String,Any}("Attributes" => Attributes, "TargetGroupArn" => TargetGroupArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function modify_target_group_attributes(
    Attributes,
    TargetGroupArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing_v2(
        "ModifyTargetGroupAttributes",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Attributes" => Attributes, "TargetGroupArn" => TargetGroupArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    modify_trust_store(ca_certificates_bundle_s3_bucket, ca_certificates_bundle_s3_key, trust_store_arn)
    modify_trust_store(ca_certificates_bundle_s3_bucket, ca_certificates_bundle_s3_key, trust_store_arn, params::Dict{String,<:Any})

Update the ca certificate bundle for a given trust store.

# Arguments
- `ca_certificates_bundle_s3_bucket`: The Amazon S3 bucket for the ca certificates bundle.
- `ca_certificates_bundle_s3_key`: The Amazon S3 path for the ca certificates bundle.
- `trust_store_arn`: The Amazon Resource Name (ARN) of the trust store.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CaCertificatesBundleS3ObjectVersion"`: The Amazon S3 object version for the ca
  certificates bundle. If undefined the current version is used.
"""
function modify_trust_store(
    CaCertificatesBundleS3Bucket,
    CaCertificatesBundleS3Key,
    TrustStoreArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing_v2(
        "ModifyTrustStore",
        Dict{String,Any}(
            "CaCertificatesBundleS3Bucket" => CaCertificatesBundleS3Bucket,
            "CaCertificatesBundleS3Key" => CaCertificatesBundleS3Key,
            "TrustStoreArn" => TrustStoreArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function modify_trust_store(
    CaCertificatesBundleS3Bucket,
    CaCertificatesBundleS3Key,
    TrustStoreArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing_v2(
        "ModifyTrustStore",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CaCertificatesBundleS3Bucket" => CaCertificatesBundleS3Bucket,
                    "CaCertificatesBundleS3Key" => CaCertificatesBundleS3Key,
                    "TrustStoreArn" => TrustStoreArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    register_targets(target_group_arn, targets)
    register_targets(target_group_arn, targets, params::Dict{String,<:Any})

Registers the specified targets with the specified target group. If the target is an EC2
instance, it must be in the running state when you register it. By default, the load
balancer routes requests to registered targets using the protocol and port for the target
group. Alternatively, you can override the port for a target when you register it. You can
register each EC2 instance or IP address with the same target group multiple times using
different ports. With a Network Load Balancer, you cannot register instances by instance ID
if they have the following instance types: C1, CC1, CC2, CG1, CG2, CR1, CS1, G1, G2, HI1,
HS1, M1, M2, M3, and T1. You can register instances of these types by IP address.

# Arguments
- `target_group_arn`: The Amazon Resource Name (ARN) of the target group.
- `targets`: The targets.

"""
function register_targets(
    TargetGroupArn, Targets; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_load_balancing_v2(
        "RegisterTargets",
        Dict{String,Any}("TargetGroupArn" => TargetGroupArn, "Targets" => Targets);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function register_targets(
    TargetGroupArn,
    Targets,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing_v2(
        "RegisterTargets",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("TargetGroupArn" => TargetGroupArn, "Targets" => Targets),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_listener_certificates(certificates, listener_arn)
    remove_listener_certificates(certificates, listener_arn, params::Dict{String,<:Any})

Removes the specified certificate from the certificate list for the specified HTTPS or TLS
listener.

# Arguments
- `certificates`: The certificate to remove. You can specify one certificate per call. Set
  CertificateArn to the certificate ARN but do not set IsDefault.
- `listener_arn`: The Amazon Resource Name (ARN) of the listener.

"""
function remove_listener_certificates(
    Certificates, ListenerArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_load_balancing_v2(
        "RemoveListenerCertificates",
        Dict{String,Any}("Certificates" => Certificates, "ListenerArn" => ListenerArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_listener_certificates(
    Certificates,
    ListenerArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing_v2(
        "RemoveListenerCertificates",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Certificates" => Certificates, "ListenerArn" => ListenerArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_tags(resource_arns, tag_keys)
    remove_tags(resource_arns, tag_keys, params::Dict{String,<:Any})

Removes the specified tags from the specified Elastic Load Balancing resources. You can
remove the tags for one or more Application Load Balancers, Network Load Balancers, Gateway
Load Balancers, target groups, listeners, or rules.

# Arguments
- `resource_arns`: The Amazon Resource Name (ARN) of the resource.
- `tag_keys`: The tag keys for the tags to remove.

"""
function remove_tags(
    ResourceArns, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_load_balancing_v2(
        "RemoveTags",
        Dict{String,Any}("ResourceArns" => ResourceArns, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_tags(
    ResourceArns,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing_v2(
        "RemoveTags",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArns" => ResourceArns, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_trust_store_revocations(revocation_ids, trust_store_arn)
    remove_trust_store_revocations(revocation_ids, trust_store_arn, params::Dict{String,<:Any})

Removes the specified revocation file from the specified trust store.

# Arguments
- `revocation_ids`: The revocation IDs of the revocation files you want to remove.
- `trust_store_arn`: The Amazon Resource Name (ARN) of the trust store.

"""
function remove_trust_store_revocations(
    RevocationIds, TrustStoreArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_load_balancing_v2(
        "RemoveTrustStoreRevocations",
        Dict{String,Any}(
            "RevocationIds" => RevocationIds, "TrustStoreArn" => TrustStoreArn
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_trust_store_revocations(
    RevocationIds,
    TrustStoreArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing_v2(
        "RemoveTrustStoreRevocations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "RevocationIds" => RevocationIds, "TrustStoreArn" => TrustStoreArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    set_ip_address_type(ip_address_type, load_balancer_arn)
    set_ip_address_type(ip_address_type, load_balancer_arn, params::Dict{String,<:Any})

Sets the type of IP addresses used by the subnets of the specified load balancer.

# Arguments
- `ip_address_type`: Note: Internal load balancers must use the ipv4 IP address type.
  [Application Load Balancers] The IP address type. The possible values are ipv4 (for only
  IPv4 addresses), dualstack (for IPv4 and IPv6 addresses), and dualstack-without-public-ipv4
  (for IPv6 only public addresses, with private IPv4 and IPv6 addresses). [Network Load
  Balancers] The IP address type. The possible values are ipv4 (for only IPv4 addresses) and
  dualstack (for IPv4 and IPv6 addresses). You can’t specify dualstack for a load balancer
  with a UDP or TCP_UDP listener. [Gateway Load Balancers] The IP address type. The possible
  values are ipv4 (for only IPv4 addresses) and dualstack (for IPv4 and IPv6 addresses).
- `load_balancer_arn`: The Amazon Resource Name (ARN) of the load balancer.

"""
function set_ip_address_type(
    IpAddressType, LoadBalancerArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_load_balancing_v2(
        "SetIpAddressType",
        Dict{String,Any}(
            "IpAddressType" => IpAddressType, "LoadBalancerArn" => LoadBalancerArn
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function set_ip_address_type(
    IpAddressType,
    LoadBalancerArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing_v2(
        "SetIpAddressType",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "IpAddressType" => IpAddressType, "LoadBalancerArn" => LoadBalancerArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    set_rule_priorities(rule_priorities)
    set_rule_priorities(rule_priorities, params::Dict{String,<:Any})

Sets the priorities of the specified rules. You can reorder the rules as long as there are
no priority conflicts in the new order. Any existing rules that you do not specify retain
their current priority.

# Arguments
- `rule_priorities`: The rule priorities.

"""
function set_rule_priorities(
    RulePriorities; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_load_balancing_v2(
        "SetRulePriorities",
        Dict{String,Any}("RulePriorities" => RulePriorities);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function set_rule_priorities(
    RulePriorities,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing_v2(
        "SetRulePriorities",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("RulePriorities" => RulePriorities), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    set_security_groups(load_balancer_arn, security_groups)
    set_security_groups(load_balancer_arn, security_groups, params::Dict{String,<:Any})

Associates the specified security groups with the specified Application Load Balancer or
Network Load Balancer. The specified security groups override the previously associated
security groups. You can't perform this operation on a Network Load Balancer unless you
specified a security group for the load balancer when you created it. You can't associate a
security group with a Gateway Load Balancer.

# Arguments
- `load_balancer_arn`: The Amazon Resource Name (ARN) of the load balancer.
- `security_groups`: The IDs of the security groups.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EnforceSecurityGroupInboundRulesOnPrivateLinkTraffic"`: Indicates whether to evaluate
  inbound security group rules for traffic sent to a Network Load Balancer through Amazon Web
  Services PrivateLink. The default is on.
"""
function set_security_groups(
    LoadBalancerArn, SecurityGroups; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_load_balancing_v2(
        "SetSecurityGroups",
        Dict{String,Any}(
            "LoadBalancerArn" => LoadBalancerArn, "SecurityGroups" => SecurityGroups
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function set_security_groups(
    LoadBalancerArn,
    SecurityGroups,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing_v2(
        "SetSecurityGroups",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "LoadBalancerArn" => LoadBalancerArn, "SecurityGroups" => SecurityGroups
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    set_subnets(load_balancer_arn)
    set_subnets(load_balancer_arn, params::Dict{String,<:Any})

Enables the Availability Zones for the specified public subnets for the specified
Application Load Balancer, Network Load Balancer or Gateway Load Balancer. The specified
subnets replace the previously enabled subnets. When you specify subnets for a Network Load
Balancer, or Gateway Load Balancer you must include all subnets that were enabled
previously, with their existing configurations, plus any additional subnets.

# Arguments
- `load_balancer_arn`: The Amazon Resource Name (ARN) of the load balancer.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"IpAddressType"`: [Application Load Balancers] The IP address type. The possible values
  are ipv4 (for only IPv4 addresses), dualstack (for IPv4 and IPv6 addresses), and
  dualstack-without-public-ipv4 (for IPv6 only public addresses, with private IPv4 and IPv6
  addresses). [Network Load Balancers] The type of IP addresses used by the subnets for your
  load balancer. The possible values are ipv4 (for IPv4 addresses) and dualstack (for IPv4
  and IPv6 addresses). You can’t specify dualstack for a load balancer with a UDP or
  TCP_UDP listener. [Gateway Load Balancers] The type of IP addresses used by the subnets for
  your load balancer. The possible values are ipv4 (for IPv4 addresses) and dualstack (for
  IPv4 and IPv6 addresses).
- `"SubnetMappings"`: The IDs of the public subnets. You can specify only one subnet per
  Availability Zone. You must specify either subnets or subnet mappings. [Application Load
  Balancers] You must specify subnets from at least two Availability Zones. You cannot
  specify Elastic IP addresses for your subnets. [Application Load Balancers on Outposts] You
  must specify one Outpost subnet. [Application Load Balancers on Local Zones] You can
  specify subnets from one or more Local Zones. [Network Load Balancers] You can specify
  subnets from one or more Availability Zones. You can specify one Elastic IP address per
  subnet if you need static IP addresses for your internet-facing load balancer. For internal
  load balancers, you can specify one private IP address per subnet from the IPv4 range of
  the subnet. For internet-facing load balancer, you can specify one IPv6 address per subnet.
  [Gateway Load Balancers] You can specify subnets from one or more Availability Zones.
- `"Subnets"`: The IDs of the public subnets. You can specify only one subnet per
  Availability Zone. You must specify either subnets or subnet mappings. [Application Load
  Balancers] You must specify subnets from at least two Availability Zones. [Application Load
  Balancers on Outposts] You must specify one Outpost subnet. [Application Load Balancers on
  Local Zones] You can specify subnets from one or more Local Zones. [Network Load Balancers]
  You can specify subnets from one or more Availability Zones. [Gateway Load Balancers] You
  can specify subnets from one or more Availability Zones.
"""
function set_subnets(LoadBalancerArn; aws_config::AbstractAWSConfig=current_aws_config())
    return elastic_load_balancing_v2(
        "SetSubnets",
        Dict{String,Any}("LoadBalancerArn" => LoadBalancerArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function set_subnets(
    LoadBalancerArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_load_balancing_v2(
        "SetSubnets",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("LoadBalancerArn" => LoadBalancerArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: savingsplans
using AWS.Compat
using AWS.UUIDs

"""
    create_savings_plan(commitment, savings_plan_offering_id)
    create_savings_plan(commitment, savings_plan_offering_id, params::Dict{String,<:Any})

Creates a Savings Plan.

# Arguments
- `commitment`: The hourly commitment, in the same currency of the savingsPlanOfferingId.
  This is a value between 0.001 and 1 million. You cannot specify more than five digits after
  the decimal point.
- `savings_plan_offering_id`: The ID of the offering.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request.
- `"purchaseTime"`: The purchase time of the Savings Plan in UTC format
  (YYYY-MM-DDTHH:MM:SSZ).
- `"tags"`: One or more tags.
- `"upfrontPaymentAmount"`: The up-front payment amount. This is a whole number between 50
  and 99 percent of the total value of the Savings Plan. This parameter is only supported if
  the payment option is Partial Upfront.
"""
function create_savings_plan(
    commitment, savingsPlanOfferingId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return savingsplans(
        "POST",
        "/CreateSavingsPlan",
        Dict{String,Any}(
            "commitment" => commitment,
            "savingsPlanOfferingId" => savingsPlanOfferingId,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_savings_plan(
    commitment,
    savingsPlanOfferingId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return savingsplans(
        "POST",
        "/CreateSavingsPlan",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "commitment" => commitment,
                    "savingsPlanOfferingId" => savingsPlanOfferingId,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_queued_savings_plan(savings_plan_id)
    delete_queued_savings_plan(savings_plan_id, params::Dict{String,<:Any})

Deletes the queued purchase for the specified Savings Plan.

# Arguments
- `savings_plan_id`: The ID of the Savings Plan.

"""
function delete_queued_savings_plan(
    savingsPlanId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return savingsplans(
        "POST",
        "/DeleteQueuedSavingsPlan",
        Dict{String,Any}("savingsPlanId" => savingsPlanId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_queued_savings_plan(
    savingsPlanId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return savingsplans(
        "POST",
        "/DeleteQueuedSavingsPlan",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("savingsPlanId" => savingsPlanId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_savings_plan_rates(savings_plan_id)
    describe_savings_plan_rates(savings_plan_id, params::Dict{String,<:Any})

Describes the rates for the specified Savings Plan.

# Arguments
- `savings_plan_id`: The ID of the Savings Plan.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: The filters.
- `"maxResults"`: The maximum number of results to return with a single call. To retrieve
  additional results, make another call with the returned token value.
- `"nextToken"`: The token for the next page of results.
"""
function describe_savings_plan_rates(
    savingsPlanId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return savingsplans(
        "POST",
        "/DescribeSavingsPlanRates",
        Dict{String,Any}("savingsPlanId" => savingsPlanId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_savings_plan_rates(
    savingsPlanId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return savingsplans(
        "POST",
        "/DescribeSavingsPlanRates",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("savingsPlanId" => savingsPlanId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_savings_plans()
    describe_savings_plans(params::Dict{String,<:Any})

Describes the specified Savings Plans.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: The filters.
- `"maxResults"`: The maximum number of results to return with a single call. To retrieve
  additional results, make another call with the returned token value.
- `"nextToken"`: The token for the next page of results.
- `"savingsPlanArns"`: The Amazon Resource Names (ARN) of the Savings Plans.
- `"savingsPlanIds"`: The IDs of the Savings Plans.
- `"states"`: The current states of the Savings Plans.
"""
function describe_savings_plans(; aws_config::AbstractAWSConfig=current_aws_config())
    return savingsplans(
        "POST",
        "/DescribeSavingsPlans";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_savings_plans(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return savingsplans(
        "POST",
        "/DescribeSavingsPlans",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_savings_plans_offering_rates()
    describe_savings_plans_offering_rates(params::Dict{String,<:Any})

Describes the offering rates for the specified Savings Plans.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: The filters.
- `"maxResults"`: The maximum number of results to return with a single call. To retrieve
  additional results, make another call with the returned token value.
- `"nextToken"`: The token for the next page of results.
- `"operations"`: The specific Amazon Web Services operation for the line item in the
  billing report.
- `"products"`: The Amazon Web Services products.
- `"savingsPlanOfferingIds"`: The IDs of the offerings.
- `"savingsPlanPaymentOptions"`: The payment options.
- `"savingsPlanTypes"`: The plan types.
- `"serviceCodes"`: The services.
- `"usageTypes"`: The usage details of the line item in the billing report.
"""
function describe_savings_plans_offering_rates(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return savingsplans(
        "POST",
        "/DescribeSavingsPlansOfferingRates";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_savings_plans_offering_rates(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return savingsplans(
        "POST",
        "/DescribeSavingsPlansOfferingRates",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_savings_plans_offerings()
    describe_savings_plans_offerings(params::Dict{String,<:Any})

Describes the offerings for the specified Savings Plans.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"currencies"`: The currencies.
- `"descriptions"`: The descriptions.
- `"durations"`: The duration, in seconds.
- `"filters"`: The filters.
- `"maxResults"`: The maximum number of results to return with a single call. To retrieve
  additional results, make another call with the returned token value.
- `"nextToken"`: The token for the next page of results.
- `"offeringIds"`: The IDs of the offerings.
- `"operations"`: The specific Amazon Web Services operation for the line item in the
  billing report.
- `"paymentOptions"`: The payment options.
- `"planTypes"`: The plan types.
- `"productType"`: The product type.
- `"serviceCodes"`: The services.
- `"usageTypes"`: The usage details of the line item in the billing report.
"""
function describe_savings_plans_offerings(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return savingsplans(
        "POST",
        "/DescribeSavingsPlansOfferings";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_savings_plans_offerings(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return savingsplans(
        "POST",
        "/DescribeSavingsPlansOfferings",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists the tags for the specified resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return savingsplans(
        "POST",
        "/ListTagsForResource",
        Dict{String,Any}("resourceArn" => resourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return savingsplans(
        "POST",
        "/ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceArn" => resourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    return_savings_plan(savings_plan_id)
    return_savings_plan(savings_plan_id, params::Dict{String,<:Any})

Returns the specified Savings Plan.

# Arguments
- `savings_plan_id`: The ID of the Savings Plan.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request.
"""
function return_savings_plan(
    savingsPlanId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return savingsplans(
        "POST",
        "/ReturnSavingsPlan",
        Dict{String,Any}(
            "savingsPlanId" => savingsPlanId, "clientToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function return_savings_plan(
    savingsPlanId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return savingsplans(
        "POST",
        "/ReturnSavingsPlan",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "savingsPlanId" => savingsPlanId, "clientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds the specified tags to the specified resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.
- `tags`: One or more tags. For example, { \"tags\": {\"key1\":\"value1\",
  \"key2\":\"value2\"} }.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return savingsplans(
        "POST",
        "/TagResource",
        Dict{String,Any}("resourceArn" => resourceArn, "tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return savingsplans(
        "POST",
        "/TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceArn" => resourceArn, "tags" => tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes the specified tags from the specified resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.
- `tag_keys`: The tag keys.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return savingsplans(
        "POST",
        "/UntagResource",
        Dict{String,Any}("resourceArn" => resourceArn, "tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return savingsplans(
        "POST",
        "/UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceArn" => resourceArn, "tagKeys" => tagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# Compatibility shims bridging HTTP.jl 1.x and 2.x.
#
# HTTP 2.0 is a breaking release which, among other changes relevant to AWS.jl:
# - deprecated the `HTTP.Exceptions` submodule (`StatusError`/`ConnectError` remain
#   available at the top level in both versions; note 2.x later re-added
#   `HTTP.Exceptions` as a deprecating compat shim — JuliaWeb/HTTP.jl#1315 — so it
#   can no longer be used to tell the two versions apart),
# - removed the `RequestError` type (transient request-path failures now surface
#   as the underlying exception),
# - removed the `iserror`, `isbytes`, and `resource` helpers,
# - changed the `StatusError` constructor from `(status, method, target, response)`
#   to `(status, response)`, and
# - buffers response bodies as `Vector{UInt8}` (1.x exposed a stream object when a
#   `response_stream` was supplied) and raises `TimeoutError` (not `ConnectError`)
#   when a connection attempt times out.
#
# Select the API era by HTTP's major version. HTTP.jl only defines its own
# `VERSION` constant in 2.x; in 1.x `HTTP.VERSION` is the binding re-exported from
# `Base` (Julia's version), so check that `VERSION` is actually owned by the `HTTP`
# module before trusting it — if it is not, we are on 1.x. (Don't key off the
# `HTTP.Exceptions` submodule either: 2.x re-adds it as a deprecating compat shim,
# JuliaWeb/HTTP.jl#1315, so its presence no longer distinguishes the versions.)
const _HTTP_V2 = Base.binding_module(HTTP, :VERSION) === HTTP && v"2" <= HTTP.VERSION < v"3"

@static if _HTTP_V2
    # `method`/`target` mirror the 1.x constructor arguments. On 2.x they are normally
    # carried by `response.request`, but 2.x's `Base.showerror(::StatusError)`
    # dereferences `response.request.method` unconditionally — so when the response
    # carries no request (e.g. one synthesized by the Downloads backend) attach a
    # minimal one to keep the error displayable.
    function _statuserror(status, method, target, response)
        if response.request === nothing
            response.request = HTTP.Request(
                isempty(method) ? "UNKNOWN" : String(method),
                isempty(target) ? "/" : String(target),
            )
        end
        return HTTP.StatusError(status, response)
    end

    # `true` when the response status is an error, mirroring 1.x's `HTTP.iserror`:
    # informational (100/101) and redirect statuses are not errors (AWS.jl follows
    # redirects itself in `submit_request`).
    function _http_iserror(r)
        status = r.status
        return status != 0 &&
               status != 100 &&
               status != 101 &&
               (status < 200 || status >= 300) &&
               !(status in (301, 302, 303, 307, 308))
    end

    # `true` when the response body itself carries the content. On 2.x the body is a
    # byte vector (or `nothing`); an empty/absent one means the content was streamed
    # elsewhere.
    _response_body_inline(x) = x !== nothing && !isempty(x)

    # Placeholder body for a response whose content was streamed elsewhere, such that
    # `_response_body_inline` classifies it as streamed.
    _streamed_body_placeholder() = UInt8[]

    # `true` when an exception indicates the endpoint could not be reached. On 2.x a
    # connection-phase timeout surfaces as `TimeoutError` (with `operation` of
    # "connect"/"tls_handshake") rather than `ConnectError`; read-phase timeouts
    # ("request", "response_header", "read_idle", ...) mean the endpoint was reached
    # and must not be classified as a connection failure.
    function _is_connection_failure(e)
        return e isa HTTP.ConnectError ||
               (e isa HTTP.TimeoutError && e.operation in ("connect", "tls_handshake"))
    end

    # `true` for transient transport/protocol failures that are safe to retry.
    # `HTTP.isrecoverable` is the documented 2.x replacement for 1.x's
    # `HTTP.RetryRequest.isrecoverable` / `RequestError` classification, but it
    # excludes `TimeoutError`; read-phase timeouts correspond to 1.x's
    # `RequestError(ReadTimeoutError)` and are equally transient.
    function _is_recoverable_request_error(e)
        return HTTP.isrecoverable(e) ||
               (e isa HTTP.TimeoutError && !_is_connection_failure(e))
    end

    # 1.x's `HTTP.resource`: the path/query/fragment portion of a URI, never empty.
    function _resource(uri)
        return string(
            isempty(uri.path) ? "/" : uri.path,
            isempty(uri.query) ? "" : "?",
            uri.query,
            isempty(uri.fragment) ? "" : "#",
            uri.fragment,
        )
    end
else
    function _statuserror(status, method, target, response)
        return HTTP.StatusError(status, method, target, response)
    end
    _http_iserror(r) = HTTP.iserror(r)
    _response_body_inline(x) = HTTP.isbytes(x)
    _streamed_body_placeholder() = IOBuffer()
    _is_connection_failure(e) = e isa HTTP.ConnectError
    _is_recoverable_request_error(e) = e isa HTTP.RequestError
    _resource(uri) = HTTP.resource(uri)
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: chime_sdk_meetings
using AWS.Compat
using AWS.UUIDs

"""
    batch_create_attendee(attendees, meeting_id)
    batch_create_attendee(attendees, meeting_id, params::Dict{String,<:Any})

Creates up to 100 attendees for an active Amazon Chime SDK meeting. For more information
about the Amazon Chime SDK, see Using the Amazon Chime SDK in the Amazon Chime Developer
Guide.

# Arguments
- `attendees`: The attendee information, including attendees' IDs and join tokens.
- `meeting_id`: The Amazon Chime SDK ID of the meeting to which you're adding attendees.

"""
function batch_create_attendee(
    Attendees, MeetingId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_meetings(
        "POST",
        "/meetings/$(MeetingId)/attendees?operation=batch-create",
        Dict{String,Any}("Attendees" => Attendees);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_create_attendee(
    Attendees,
    MeetingId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_meetings(
        "POST",
        "/meetings/$(MeetingId)/attendees?operation=batch-create",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Attendees" => Attendees), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_update_attendee_capabilities_except(capabilities, excluded_attendee_ids, meeting_id)
    batch_update_attendee_capabilities_except(capabilities, excluded_attendee_ids, meeting_id, params::Dict{String,<:Any})

Updates AttendeeCapabilities except the capabilities listed in an ExcludedAttendeeIds
table.  You use the capabilities with a set of values that control what the capabilities
can do, such as SendReceive data. For more information about those values, see .  When
using capabilities, be aware of these corner cases:   If you specify
MeetingFeatures:Video:MaxResolution:None when you create a meeting, all API requests that
include SendReceive, Send, or Receive for AttendeeCapabilities:Video will be rejected with
ValidationError 400.   If you specify MeetingFeatures:Content:MaxResolution:None when you
create a meeting, all API requests that include SendReceive, Send, or Receive for
AttendeeCapabilities:Content will be rejected with ValidationError 400.   You can't set
content capabilities to SendReceive or Receive unless you also set video capabilities to
SendReceive or Receive. If you don't set the video capability to receive, the response will
contain an HTTP 400 Bad Request status code. However, you can set your video capability to
receive and you set your content capability to not receive.   When you change an audio
capability from None or Receive to Send or SendReceive , and if the attendee left their
microphone unmuted, audio will flow from the attendee to the other meeting participants.
When you change a video or content capability from None or Receive to Send or SendReceive ,
and if the attendee turned on their video or content streams, remote attendees can receive
those streams, but only after media renegotiation between the client and the Amazon Chime
back-end server.

# Arguments
- `capabilities`: The capabilities (audio, video, or content) that you want to update.
- `excluded_attendee_ids`: The AttendeeIDs that you want to exclude from one or more
  capabilities.
- `meeting_id`: The ID of the meeting associated with the update request.

"""
function batch_update_attendee_capabilities_except(
    Capabilities,
    ExcludedAttendeeIds,
    MeetingId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_meetings(
        "PUT",
        "/meetings/$(MeetingId)/attendees/capabilities?operation=batch-update-except",
        Dict{String,Any}(
            "Capabilities" => Capabilities, "ExcludedAttendeeIds" => ExcludedAttendeeIds
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_update_attendee_capabilities_except(
    Capabilities,
    ExcludedAttendeeIds,
    MeetingId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_meetings(
        "PUT",
        "/meetings/$(MeetingId)/attendees/capabilities?operation=batch-update-except",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Capabilities" => Capabilities,
                    "ExcludedAttendeeIds" => ExcludedAttendeeIds,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_attendee(external_user_id, meeting_id)
    create_attendee(external_user_id, meeting_id, params::Dict{String,<:Any})

 Creates a new attendee for an active Amazon Chime SDK meeting. For more information about
the Amazon Chime SDK, see Using the Amazon Chime SDK in the Amazon Chime Developer Guide.

# Arguments
- `external_user_id`: The Amazon Chime SDK external user ID. An idempotency token. Links
  the attendee to an identity managed by a builder application. Pattern:
  [-_&amp;@+=,(){}[]/«».:|'\"#a-zA-Z0-9À-ÿs]*  Values that begin with aws: are reserved.
  You can't configure a value that uses this prefix.
- `meeting_id`: The unique ID of the meeting.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Capabilities"`: The capabilities (audio, video, or content) that you want to grant an
  attendee. If you don't specify capabilities, all users have send and receive capabilities
  on all media channels by default.  You use the capabilities with a set of values that
  control what the capabilities can do, such as SendReceive data. For more information about
  those values, see .  When using capabilities, be aware of these corner cases:   If you
  specify MeetingFeatures:Video:MaxResolution:None when you create a meeting, all API
  requests that include SendReceive, Send, or Receive for AttendeeCapabilities:Video will be
  rejected with ValidationError 400.   If you specify
  MeetingFeatures:Content:MaxResolution:None when you create a meeting, all API requests that
  include SendReceive, Send, or Receive for AttendeeCapabilities:Content will be rejected
  with ValidationError 400.   You can't set content capabilities to SendReceive or Receive
  unless you also set video capabilities to SendReceive or Receive. If you don't set the
  video capability to receive, the response will contain an HTTP 400 Bad Request status code.
  However, you can set your video capability to receive and you set your content capability
  to not receive.   When you change an audio capability from None or Receive to Send or
  SendReceive , and if the attendee left their microphone unmuted, audio will flow from the
  attendee to the other meeting participants.   When you change a video or content capability
  from None or Receive to Send or SendReceive , and if the attendee turned on their video or
  content streams, remote attendees can receive those streams, but only after media
  renegotiation between the client and the Amazon Chime back-end server.
"""
function create_attendee(
    ExternalUserId, MeetingId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_meetings(
        "POST",
        "/meetings/$(MeetingId)/attendees",
        Dict{String,Any}("ExternalUserId" => ExternalUserId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_attendee(
    ExternalUserId,
    MeetingId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_meetings(
        "POST",
        "/meetings/$(MeetingId)/attendees",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ExternalUserId" => ExternalUserId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_meeting(client_request_token, external_meeting_id, media_region)
    create_meeting(client_request_token, external_meeting_id, media_region, params::Dict{String,<:Any})

Creates a new Amazon Chime SDK meeting in the specified media Region with no initial
attendees. For more information about specifying media Regions, see Amazon Chime SDK Media
Regions in the Amazon Chime Developer Guide. For more information about the Amazon Chime
SDK, see Using the Amazon Chime SDK in the Amazon Chime Developer Guide.

# Arguments
- `client_request_token`: The unique identifier for the client request. Use a different
  token for different meetings.
- `external_meeting_id`: The external meeting ID. Pattern:
  [-_&amp;@+=,(){}[]/«».:|'\"#a-zA-Z0-9À-ÿs]*  Values that begin with aws: are reserved.
  You can't configure a value that uses this prefix. Case insensitive.
- `media_region`: The Region in which to create the meeting.  Available values: af-south-1,
  ap-northeast-1, ap-northeast-2, ap-south-1, ap-southeast-1, ap-southeast-2, ca-central-1,
  eu-central-1, eu-north-1, eu-south-1, eu-west-1, eu-west-2, eu-west-3, sa-east-1,
  us-east-1, us-east-2, us-west-1, us-west-2.  Available values in Amazon Web Services
  GovCloud (US) Regions: us-gov-east-1, us-gov-west-1.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MeetingFeatures"`: Lists the audio and video features enabled for a meeting, such as
  echo reduction.
- `"MeetingHostId"`: Reserved.
- `"NotificationsConfiguration"`: The configuration for resource targets to receive
  notifications when meeting and attendee events occur.
- `"PrimaryMeetingId"`: When specified, replicates the media from the primary meeting to
  the new meeting.
- `"Tags"`: Applies one or more tags to an Amazon Chime SDK meeting. Note the following:
  Not all resources have tags. For a list of services with resources that support tagging
  using this operation, see Services that support the Resource Groups Tagging API. If the
  resource doesn't yet support this operation, the resource's service might support tagging
  using its own API operations. For more information, refer to the documentation for that
  service.   Each resource can have up to 50 tags. For other limits, see Tag Naming and Usage
  Conventions in the AWS General Reference.   You can only tag resources that are located in
  the specified Amazon Web Services Region for the Amazon Web Services account.   To add tags
  to a resource, you need the necessary permissions for the service that the resource belongs
  to as well as permissions for adding tags. For more information, see the documentation for
  each service.    Do not store personally identifiable information (PII) or other
  confidential or sensitive information in tags. We use tags to provide you with billing and
  administration services. Tags are not intended to be used for private or sensitive data.
  Minimum permissions  In addition to the tag:TagResources permission required by this
  operation, you must also have the tagging permission defined by the service that created
  the resource. For example, to tag a ChimeSDKMeetings instance using the TagResources
  operation, you must have both of the following permissions:  tag:TagResources
  ChimeSDKMeetings:CreateTags   Some services might have specific requirements for tagging
  some resources. For example, to tag an Amazon S3 bucket, you must also have the
  s3:GetBucketTagging permission. If the expected minimum permissions don't work, check the
  documentation for that service's tagging APIs for more information.
- `"TenantIds"`: A consistent and opaque identifier, created and maintained by the builder
  to represent a segment of their users.
"""
function create_meeting(
    ClientRequestToken,
    ExternalMeetingId,
    MediaRegion;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_meetings(
        "POST",
        "/meetings",
        Dict{String,Any}(
            "ClientRequestToken" => ClientRequestToken,
            "ExternalMeetingId" => ExternalMeetingId,
            "MediaRegion" => MediaRegion,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_meeting(
    ClientRequestToken,
    ExternalMeetingId,
    MediaRegion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_meetings(
        "POST",
        "/meetings",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClientRequestToken" => ClientRequestToken,
                    "ExternalMeetingId" => ExternalMeetingId,
                    "MediaRegion" => MediaRegion,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_meeting_with_attendees(attendees, client_request_token, external_meeting_id, media_region)
    create_meeting_with_attendees(attendees, client_request_token, external_meeting_id, media_region, params::Dict{String,<:Any})

 Creates a new Amazon Chime SDK meeting in the specified media Region, with attendees. For
more information about specifying media Regions, see Amazon Chime SDK Media Regions in the
Amazon Chime Developer Guide. For more information about the Amazon Chime SDK, see Using
the Amazon Chime SDK in the Amazon Chime Developer Guide.

# Arguments
- `attendees`: The attendee information, including attendees' IDs and join tokens.
- `client_request_token`: The unique identifier for the client request. Use a different
  token for different meetings.
- `external_meeting_id`: The external meeting ID. Pattern:
  [-_&amp;@+=,(){}[]/«».:|'\"#a-zA-Z0-9À-ÿs]*  Values that begin with aws: are reserved.
  You can't configure a value that uses this prefix. Case insensitive.
- `media_region`: The Region in which to create the meeting.  Available values: af-south-1,
  ap-northeast-1, ap-northeast-2, ap-south-1, ap-southeast-1, ap-southeast-2, ca-central-1,
  eu-central-1, eu-north-1, eu-south-1, eu-west-1, eu-west-2, eu-west-3, sa-east-1,
  us-east-1, us-east-2, us-west-1, us-west-2.  Available values in Amazon Web Services
  GovCloud (US) Regions: us-gov-east-1, us-gov-west-1.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MeetingFeatures"`: Lists the audio and video features enabled for a meeting, such as
  echo reduction.
- `"MeetingHostId"`: Reserved.
- `"NotificationsConfiguration"`: The configuration for resource targets to receive
  notifications when meeting and attendee events occur.
- `"PrimaryMeetingId"`: When specified, replicates the media from the primary meeting to
  the new meeting.
- `"Tags"`: The tags in the request.
- `"TenantIds"`: A consistent and opaque identifier, created and maintained by the builder
  to represent a segment of their users.
"""
function create_meeting_with_attendees(
    Attendees,
    ClientRequestToken,
    ExternalMeetingId,
    MediaRegion;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_meetings(
        "POST",
        "/meetings?operation=create-attendees",
        Dict{String,Any}(
            "Attendees" => Attendees,
            "ClientRequestToken" => ClientRequestToken,
            "ExternalMeetingId" => ExternalMeetingId,
            "MediaRegion" => MediaRegion,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_meeting_with_attendees(
    Attendees,
    ClientRequestToken,
    ExternalMeetingId,
    MediaRegion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_meetings(
        "POST",
        "/meetings?operation=create-attendees",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Attendees" => Attendees,
                    "ClientRequestToken" => ClientRequestToken,
                    "ExternalMeetingId" => ExternalMeetingId,
                    "MediaRegion" => MediaRegion,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_attendee(attendee_id, meeting_id)
    delete_attendee(attendee_id, meeting_id, params::Dict{String,<:Any})

Deletes an attendee from the specified Amazon Chime SDK meeting and deletes their
JoinToken. Attendees are automatically deleted when a Amazon Chime SDK meeting is deleted.
For more information about the Amazon Chime SDK, see Using the Amazon Chime SDK in the
Amazon Chime Developer Guide.

# Arguments
- `attendee_id`: The Amazon Chime SDK attendee ID.
- `meeting_id`: The Amazon Chime SDK meeting ID.

"""
function delete_attendee(
    AttendeeId, MeetingId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_meetings(
        "DELETE",
        "/meetings/$(MeetingId)/attendees/$(AttendeeId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_attendee(
    AttendeeId,
    MeetingId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_meetings(
        "DELETE",
        "/meetings/$(MeetingId)/attendees/$(AttendeeId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_meeting(meeting_id)
    delete_meeting(meeting_id, params::Dict{String,<:Any})

Deletes the specified Amazon Chime SDK meeting. The operation deletes all attendees,
disconnects all clients, and prevents new clients from joining the meeting. For more
information about the Amazon Chime SDK, see Using the Amazon Chime SDK in the Amazon Chime
Developer Guide.

# Arguments
- `meeting_id`: The Amazon Chime SDK meeting ID.

"""
function delete_meeting(MeetingId; aws_config::AbstractAWSConfig=current_aws_config())
    return chime_sdk_meetings(
        "DELETE",
        "/meetings/$(MeetingId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_meeting(
    MeetingId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_meetings(
        "DELETE",
        "/meetings/$(MeetingId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_attendee(attendee_id, meeting_id)
    get_attendee(attendee_id, meeting_id, params::Dict{String,<:Any})

 Gets the Amazon Chime SDK attendee details for a specified meeting ID and attendee ID. For
more information about the Amazon Chime SDK, see Using the Amazon Chime SDK in the Amazon
Chime Developer Guide.

# Arguments
- `attendee_id`: The Amazon Chime SDK attendee ID.
- `meeting_id`: The Amazon Chime SDK meeting ID.

"""
function get_attendee(
    AttendeeId, MeetingId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_meetings(
        "GET",
        "/meetings/$(MeetingId)/attendees/$(AttendeeId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_attendee(
    AttendeeId,
    MeetingId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_meetings(
        "GET",
        "/meetings/$(MeetingId)/attendees/$(AttendeeId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_meeting(meeting_id)
    get_meeting(meeting_id, params::Dict{String,<:Any})

Gets the Amazon Chime SDK meeting details for the specified meeting ID. For more
information about the Amazon Chime SDK, see Using the Amazon Chime SDK in the Amazon Chime
Developer Guide.

# Arguments
- `meeting_id`: The Amazon Chime SDK meeting ID.

"""
function get_meeting(MeetingId; aws_config::AbstractAWSConfig=current_aws_config())
    return chime_sdk_meetings(
        "GET",
        "/meetings/$(MeetingId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_meeting(
    MeetingId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_meetings(
        "GET",
        "/meetings/$(MeetingId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_attendees(meeting_id)
    list_attendees(meeting_id, params::Dict{String,<:Any})

 Lists the attendees for the specified Amazon Chime SDK meeting. For more information about
the Amazon Chime SDK, see Using the Amazon Chime SDK in the Amazon Chime Developer Guide.

# Arguments
- `meeting_id`: The Amazon Chime SDK meeting ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"max-results"`: The maximum number of results to return in a single call.
- `"next-token"`: The token to use to retrieve the next page of results.
"""
function list_attendees(MeetingId; aws_config::AbstractAWSConfig=current_aws_config())
    return chime_sdk_meetings(
        "GET",
        "/meetings/$(MeetingId)/attendees";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_attendees(
    MeetingId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_meetings(
        "GET",
        "/meetings/$(MeetingId)/attendees",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(arn)
    list_tags_for_resource(arn, params::Dict{String,<:Any})

Returns a list of the tags available for the specified resource.

# Arguments
- `arn`: The ARN of the resource.

"""
function list_tags_for_resource(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return chime_sdk_meetings(
        "GET",
        "/tags",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_meetings(
        "GET",
        "/tags",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_meeting_transcription(meeting_id, transcription_configuration)
    start_meeting_transcription(meeting_id, transcription_configuration, params::Dict{String,<:Any})

Starts transcription for the specified meetingId. For more information, refer to  Using
Amazon Chime SDK live transcription  in the Amazon Chime SDK Developer Guide. If you
specify an invalid configuration, a TranscriptFailed event will be sent with the contents
of the BadRequestException generated by Amazon Transcribe. For more information on each
parameter and which combinations are valid, refer to the StartStreamTranscription API in
the Amazon Transcribe Developer Guide.  By default, Amazon Transcribe may use and store
audio content processed by the service to develop and improve Amazon Web Services AI/ML
services as further described in section 50 of the Amazon Web Services Service Terms. Using
Amazon Transcribe may be subject to federal and state laws or regulations regarding the
recording or interception of electronic communications. It is your and your end users’
responsibility to comply with all applicable laws regarding the recording, including
properly notifying all participants in a recorded session or communication that the session
or communication is being recorded, and obtaining all necessary consents. You can opt out
from Amazon Web Services using audio content to develop and improve AWS AI/ML services by
configuring an AI services opt out policy using Amazon Web Services Organizations.

# Arguments
- `meeting_id`: The unique ID of the meeting being transcribed.
- `transcription_configuration`: The configuration for the current transcription operation.
  Must contain EngineTranscribeSettings or EngineTranscribeMedicalSettings.

"""
function start_meeting_transcription(
    MeetingId,
    TranscriptionConfiguration;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_meetings(
        "POST",
        "/meetings/$(MeetingId)/transcription?operation=start",
        Dict{String,Any}("TranscriptionConfiguration" => TranscriptionConfiguration);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_meeting_transcription(
    MeetingId,
    TranscriptionConfiguration,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_meetings(
        "POST",
        "/meetings/$(MeetingId)/transcription?operation=start",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "TranscriptionConfiguration" => TranscriptionConfiguration
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_meeting_transcription(meeting_id)
    stop_meeting_transcription(meeting_id, params::Dict{String,<:Any})

Stops transcription for the specified meetingId. For more information, refer to  Using
Amazon Chime SDK live transcription  in the Amazon Chime SDK Developer Guide.  By default,
Amazon Transcribe may use and store audio content processed by the service to develop and
improve Amazon Web Services AI/ML services as further described in section 50 of the Amazon
Web Services Service Terms. Using Amazon Transcribe may be subject to federal and state
laws or regulations regarding the recording or interception of electronic communications.
It is your and your end users’ responsibility to comply with all applicable laws
regarding the recording, including properly notifying all participants in a recorded
session or communication that the session or communication is being recorded, and obtaining
all necessary consents. You can opt out from Amazon Web Services using audio content to
develop and improve Amazon Web Services AI/ML services by configuring an AI services opt
out policy using Amazon Web Services Organizations.

# Arguments
- `meeting_id`: The unique ID of the meeting for which you stop transcription.

"""
function stop_meeting_transcription(
    MeetingId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_meetings(
        "POST",
        "/meetings/$(MeetingId)/transcription?operation=stop";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_meeting_transcription(
    MeetingId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_meetings(
        "POST",
        "/meetings/$(MeetingId)/transcription?operation=stop",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

The resource that supports tags.

# Arguments
- `resource_arn`: The ARN of the resource.
- `tags`: Lists the requested tags.

"""
function tag_resource(ResourceARN, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return chime_sdk_meetings(
        "POST",
        "/tags?operation=tag-resource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceARN,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_meetings(
        "POST",
        "/tags?operation=tag-resource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes the specified tags from the specified resources. When you specify a tag key, the
action removes both that key and its associated value. The operation succeeds even if you
attempt to remove tags from a resource that were already removed. Note the following:   To
remove tags from a resource, you need the necessary permissions for the service that the
resource belongs to as well as permissions for removing tags. For more information, see the
documentation for the service whose resource you want to untag.   You can only tag
resources that are located in the specified Amazon Web Services Region for the calling
Amazon Web Services account.    Minimum permissions  In addition to the tag:UntagResources
permission required by this operation, you must also have the remove tags permission
defined by the service that created the resource. For example, to remove the tags from an
Amazon EC2 instance using the UntagResources operation, you must have both of the following
permissions:  tag:UntagResource   ChimeSDKMeetings:DeleteTags

# Arguments
- `resource_arn`: The ARN of the resource that you're removing tags from.
- `tag_keys`: The tag keys being removed from the resources.

"""
function untag_resource(
    ResourceARN, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_meetings(
        "POST",
        "/tags?operation=untag-resource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceARN,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_meetings(
        "POST",
        "/tags?operation=untag-resource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_attendee_capabilities(attendee_id, capabilities, meeting_id)
    update_attendee_capabilities(attendee_id, capabilities, meeting_id, params::Dict{String,<:Any})

The capabilities that you want to update.  You use the capabilities with a set of values
that control what the capabilities can do, such as SendReceive data. For more information
about those values, see .  When using capabilities, be aware of these corner cases:   If
you specify MeetingFeatures:Video:MaxResolution:None when you create a meeting, all API
requests that include SendReceive, Send, or Receive for AttendeeCapabilities:Video will be
rejected with ValidationError 400.   If you specify
MeetingFeatures:Content:MaxResolution:None when you create a meeting, all API requests that
include SendReceive, Send, or Receive for AttendeeCapabilities:Content will be rejected
with ValidationError 400.   You can't set content capabilities to SendReceive or Receive
unless you also set video capabilities to SendReceive or Receive. If you don't set the
video capability to receive, the response will contain an HTTP 400 Bad Request status code.
However, you can set your video capability to receive and you set your content capability
to not receive.   When you change an audio capability from None or Receive to Send or
SendReceive , and if the attendee left their microphone unmuted, audio will flow from the
attendee to the other meeting participants.   When you change a video or content capability
from None or Receive to Send or SendReceive , and if the attendee turned on their video or
content streams, remote attendees can receive those streams, but only after media
renegotiation between the client and the Amazon Chime back-end server.

# Arguments
- `attendee_id`: The ID of the attendee associated with the update request.
- `capabilities`: The capabilities that you want to update.
- `meeting_id`: The ID of the meeting associated with the update request.

"""
function update_attendee_capabilities(
    AttendeeId, Capabilities, MeetingId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_meetings(
        "PUT",
        "/meetings/$(MeetingId)/attendees/$(AttendeeId)/capabilities",
        Dict{String,Any}("Capabilities" => Capabilities);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_attendee_capabilities(
    AttendeeId,
    Capabilities,
    MeetingId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_meetings(
        "PUT",
        "/meetings/$(MeetingId)/attendees/$(AttendeeId)/capabilities",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Capabilities" => Capabilities), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: marketplace_entitlement_service
using AWS.Compat
using AWS.UUIDs

"""
    get_entitlements(product_code)
    get_entitlements(product_code, params::Dict{String,<:Any})

GetEntitlements retrieves entitlement values for a given product. The results can be
filtered based on customer identifier or product dimensions.

# Arguments
- `product_code`: Product code is used to uniquely identify a product in AWS Marketplace.
  The product code will be provided by AWS Marketplace when the product listing is created.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filter"`: Filter is used to return entitlements for a specific customer or for a
  specific dimension. Filters are described as keys mapped to a lists of values. Filtered
  requests are unioned for each value in the value list, and then intersected for each filter
  key.
- `"MaxResults"`: The maximum number of items to retrieve from the GetEntitlements
  operation. For pagination, use the NextToken field in subsequent calls to GetEntitlements.
- `"NextToken"`: For paginated calls to GetEntitlements, pass the NextToken from the
  previous GetEntitlementsResult.
"""
function get_entitlements(ProductCode; aws_config::AbstractAWSConfig=current_aws_config())
    return marketplace_entitlement_service(
        "GetEntitlements",
        Dict{String,Any}("ProductCode" => ProductCode);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_entitlements(
    ProductCode,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return marketplace_entitlement_service(
        "GetEntitlements",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ProductCode" => ProductCode), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: oam
using AWS.Compat
using AWS.UUIDs

"""
    create_link(label_template, resource_types, sink_identifier)
    create_link(label_template, resource_types, sink_identifier, params::Dict{String,<:Any})

Creates a link between a source account and a sink that you have created in a monitoring
account. After the link is created, data is sent from the source account to the monitoring
account. When you create a link, you can optionally specify filters that specify which
metric namespaces and which log groups are shared from the source account to the monitoring
account. Before you create a link, you must create a sink in the monitoring account and
create a sink policy in that account. The sink policy must permit the source account to
link to it. You can grant permission to source accounts by granting permission to an entire
organization or to individual accounts. For more information, see CreateSink and
PutSinkPolicy. Each monitoring account can be linked to as many as 100,000 source accounts.
Each source account can be linked to as many as five monitoring accounts.

# Arguments
- `label_template`: Specify a friendly human-readable name to use to identify this source
  account when you are viewing data from it in the monitoring account. You can use a custom
  label or use the following variables:    AccountName is the name of the account
  AccountEmail is the globally unique email address of the account    AccountEmailNoDomain is
  the email address of the account without the domain name
- `resource_types`: An array of strings that define which types of data that the source
  account shares with the monitoring account.
- `sink_identifier`: The ARN of the sink to use to create this link. You can use ListSinks
  to find the ARNs of sinks. For more information about sinks, see CreateSink.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"LinkConfiguration"`: Use this structure to optionally create filters that specify that
  only some metric namespaces or log groups are to be shared from the source account to the
  monitoring account.
- `"Tags"`: Assigns one or more tags (key-value pairs) to the link.  Tags can help you
  organize and categorize your resources. You can also use them to scope user permissions by
  granting a user permission to access or change only resources with certain tag values. For
  more information about using tags to control access, see Controlling access to Amazon Web
  Services resources using tags.
"""
function create_link(
    LabelTemplate,
    ResourceTypes,
    SinkIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return oam(
        "POST",
        "/CreateLink",
        Dict{String,Any}(
            "LabelTemplate" => LabelTemplate,
            "ResourceTypes" => ResourceTypes,
            "SinkIdentifier" => SinkIdentifier,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_link(
    LabelTemplate,
    ResourceTypes,
    SinkIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return oam(
        "POST",
        "/CreateLink",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "LabelTemplate" => LabelTemplate,
                    "ResourceTypes" => ResourceTypes,
                    "SinkIdentifier" => SinkIdentifier,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_sink(name)
    create_sink(name, params::Dict{String,<:Any})

Use this to create a sink in the current account, so that it can be used as a monitoring
account in CloudWatch cross-account observability. A sink is a resource that represents an
attachment point in a monitoring account. Source accounts can link to the sink to send
observability data. After you create a sink, you must create a sink policy that allows
source accounts to attach to it. For more information, see PutSinkPolicy. Each account can
contain one sink per Region. If you delete a sink, you can then create a new one in that
Region.

# Arguments
- `name`: A name for the sink.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: Assigns one or more tags (key-value pairs) to the link.  Tags can help you
  organize and categorize your resources. You can also use them to scope user permissions by
  granting a user permission to access or change only resources with certain tag values. For
  more information about using tags to control access, see Controlling access to Amazon Web
  Services resources using tags.
"""
function create_sink(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return oam(
        "POST",
        "/CreateSink",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_sink(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return oam(
        "POST",
        "/CreateSink",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_link(identifier)
    delete_link(identifier, params::Dict{String,<:Any})

Deletes a link between a monitoring account sink and a source account. You must run this
operation in the source account.

# Arguments
- `identifier`: The ARN of the link to delete.

"""
function delete_link(Identifier; aws_config::AbstractAWSConfig=current_aws_config())
    return oam(
        "POST",
        "/DeleteLink",
        Dict{String,Any}("Identifier" => Identifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_link(
    Identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return oam(
        "POST",
        "/DeleteLink",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Identifier" => Identifier), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_sink(identifier)
    delete_sink(identifier, params::Dict{String,<:Any})

Deletes a sink. You must delete all links to a sink before you can delete that sink.

# Arguments
- `identifier`: The ARN of the sink to delete.

"""
function delete_sink(Identifier; aws_config::AbstractAWSConfig=current_aws_config())
    return oam(
        "POST",
        "/DeleteSink",
        Dict{String,Any}("Identifier" => Identifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_sink(
    Identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return oam(
        "POST",
        "/DeleteSink",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Identifier" => Identifier), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_link(identifier)
    get_link(identifier, params::Dict{String,<:Any})

Returns complete information about one link. To use this operation, provide the link ARN.
To retrieve a list of link ARNs, use ListLinks.

# Arguments
- `identifier`: The ARN of the link to retrieve information for.

"""
function get_link(Identifier; aws_config::AbstractAWSConfig=current_aws_config())
    return oam(
        "POST",
        "/GetLink",
        Dict{String,Any}("Identifier" => Identifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_link(
    Identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return oam(
        "POST",
        "/GetLink",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Identifier" => Identifier), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_sink(identifier)
    get_sink(identifier, params::Dict{String,<:Any})

Returns complete information about one monitoring account sink. To use this operation,
provide the sink ARN. To retrieve a list of sink ARNs, use ListSinks.

# Arguments
- `identifier`: The ARN of the sink to retrieve information for.

"""
function get_sink(Identifier; aws_config::AbstractAWSConfig=current_aws_config())
    return oam(
        "POST",
        "/GetSink",
        Dict{String,Any}("Identifier" => Identifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_sink(
    Identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return oam(
        "POST",
        "/GetSink",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Identifier" => Identifier), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_sink_policy(sink_identifier)
    get_sink_policy(sink_identifier, params::Dict{String,<:Any})

Returns the current sink policy attached to this sink. The sink policy specifies what
accounts can attach to this sink as source accounts, and what types of data they can share.

# Arguments
- `sink_identifier`: The ARN of the sink to retrieve the policy of.

"""
function get_sink_policy(SinkIdentifier; aws_config::AbstractAWSConfig=current_aws_config())
    return oam(
        "POST",
        "/GetSinkPolicy",
        Dict{String,Any}("SinkIdentifier" => SinkIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_sink_policy(
    SinkIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return oam(
        "POST",
        "/GetSinkPolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("SinkIdentifier" => SinkIdentifier), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_attached_links(sink_identifier)
    list_attached_links(sink_identifier, params::Dict{String,<:Any})

Returns a list of source account links that are linked to this monitoring account sink. To
use this operation, provide the sink ARN. To retrieve a list of sink ARNs, use ListSinks.
To find a list of links for one source account, use ListLinks.

# Arguments
- `sink_identifier`: The ARN of the sink that you want to retrieve links for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Limits the number of returned links to the specified number.
- `"NextToken"`: The token for the next set of items to return. You received this token
  from a previous call.
"""
function list_attached_links(
    SinkIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return oam(
        "POST",
        "/ListAttachedLinks",
        Dict{String,Any}("SinkIdentifier" => SinkIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_attached_links(
    SinkIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return oam(
        "POST",
        "/ListAttachedLinks",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("SinkIdentifier" => SinkIdentifier), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_links()
    list_links(params::Dict{String,<:Any})

Use this operation in a source account to return a list of links to monitoring account
sinks that this source account has. To find a list of links for one monitoring account
sink, use ListAttachedLinks from within the monitoring account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Limits the number of returned links to the specified number.
- `"NextToken"`: The token for the next set of items to return. You received this token
  from a previous call.
"""
function list_links(; aws_config::AbstractAWSConfig=current_aws_config())
    return oam("POST", "/ListLinks"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_links(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return oam(
        "POST", "/ListLinks", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_sinks()
    list_sinks(params::Dict{String,<:Any})

Use this operation in a monitoring account to return the list of sinks created in that
account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Limits the number of returned links to the specified number.
- `"NextToken"`: The token for the next set of items to return. You received this token
  from a previous call.
"""
function list_sinks(; aws_config::AbstractAWSConfig=current_aws_config())
    return oam("POST", "/ListSinks"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_sinks(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return oam(
        "POST", "/ListSinks", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Displays the tags associated with a resource. Both sinks and links support tagging.

# Arguments
- `resource_arn`: The ARN of the resource that you want to view tags for. The ARN format of
  a sink is arn:aws:oam:Region:account-id:sink/sink-id   The ARN format of a link is
  arn:aws:oam:Region:account-id:link/link-id   For more information about ARN format, see
  CloudWatch Logs resources and operations.  Unlike tagging permissions in other Amazon Web
  Services services, to retrieve the list of tags for links or sinks you must have the
  oam:RequestTag permission. The aws:ReguestTag permission does not allow you to tag and
  untag links and sinks.

"""
function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return oam(
        "GET",
        "/tags/$(ResourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return oam(
        "GET",
        "/tags/$(ResourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_sink_policy(policy, sink_identifier)
    put_sink_policy(policy, sink_identifier, params::Dict{String,<:Any})

Creates or updates the resource policy that grants permissions to source accounts to link
to the monitoring account sink. When you create a sink policy, you can grant permissions to
all accounts in an organization or to individual accounts. You can also use a sink policy
to limit the types of data that is shared. The three types that you can allow or deny are:
  Metrics - Specify with AWS::CloudWatch::Metric     Log groups - Specify with
AWS::Logs::LogGroup     Traces - Specify with AWS::XRay::Trace     Application Insights -
Applications - Specify with AWS::ApplicationInsights::Application    See the examples in
this section to see how to specify permitted source accounts and data types.

# Arguments
- `policy`: The JSON policy to use. If you are updating an existing policy, the entire
  existing policy is replaced by what you specify here. The policy must be in JSON string
  format with quotation marks escaped and no newlines. For examples of different types of
  policies, see the Examples section on this page.
- `sink_identifier`: The ARN of the sink to attach this policy to.

"""
function put_sink_policy(
    Policy, SinkIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return oam(
        "POST",
        "/PutSinkPolicy",
        Dict{String,Any}("Policy" => Policy, "SinkIdentifier" => SinkIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_sink_policy(
    Policy,
    SinkIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return oam(
        "POST",
        "/PutSinkPolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Policy" => Policy, "SinkIdentifier" => SinkIdentifier),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Assigns one or more tags (key-value pairs) to the specified resource. Both sinks and links
can be tagged.  Tags can help you organize and categorize your resources. You can also use
them to scope user permissions by granting a user permission to access or change only
resources with certain tag values. Tags don't have any semantic meaning to Amazon Web
Services and are interpreted strictly as strings of characters. You can use the TagResource
action with a resource that already has tags. If you specify a new tag key for the alarm,
this tag is appended to the list of tags associated with the alarm. If you specify a tag
key that is already associated with the alarm, the new tag value that you specify replaces
the previous value for that tag. You can associate as many as 50 tags with a resource.
Unlike tagging permissions in other Amazon Web Services services, to tag or untag links and
sinks you must have the oam:ResourceTag permission. The iam:ResourceTag permission does not
allow you to tag and untag links and sinks.

# Arguments
- `resource_arn`: The ARN of the resource that you're adding tags to. The ARN format of a
  sink is arn:aws:oam:Region:account-id:sink/sink-id   The ARN format of a link is
  arn:aws:oam:Region:account-id:link/link-id   For more information about ARN format, see
  CloudWatch Logs resources and operations.
- `tags`: The list of key-value pairs to associate with the resource.

"""
function tag_resource(ResourceArn, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return oam(
        "PUT",
        "/tags/$(ResourceArn)",
        Dict{String,Any}("Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceArn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return oam(
        "PUT",
        "/tags/$(ResourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Tags" => Tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes one or more tags from the specified resource.  Unlike tagging permissions in other
Amazon Web Services services, to tag or untag links and sinks you must have the
oam:ResourceTag permission. The iam:TagResource permission does not allow you to tag and
untag links and sinks.

# Arguments
- `resource_arn`: The ARN of the resource that you're removing tags from. The ARN format of
  a sink is arn:aws:oam:Region:account-id:sink/sink-id   The ARN format of a link is
  arn:aws:oam:Region:account-id:link/link-id   For more information about ARN format, see
  CloudWatch Logs resources and operations.
- `tag_keys`: The list of tag keys to remove from the resource.

"""
function untag_resource(
    ResourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return oam(
        "DELETE",
        "/tags/$(ResourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return oam(
        "DELETE",
        "/tags/$(ResourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_link(identifier, resource_types)
    update_link(identifier, resource_types, params::Dict{String,<:Any})

Use this operation to change what types of data are shared from a source account to its
linked monitoring account sink. You can't change the sink or change the monitoring account
with this operation. When you update a link, you can optionally specify filters that
specify which metric namespaces and which log groups are shared from the source account to
the monitoring account. To update the list of tags associated with the sink, use
TagResource.

# Arguments
- `identifier`: The ARN of the link that you want to update.
- `resource_types`: An array of strings that define which types of data that the source
  account will send to the monitoring account. Your input here replaces the current set of
  data types that are shared.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"LinkConfiguration"`: Use this structure to filter which metric namespaces and which log
  groups are to be shared from the source account to the monitoring account.
"""
function update_link(
    Identifier, ResourceTypes; aws_config::AbstractAWSConfig=current_aws_config()
)
    return oam(
        "POST",
        "/UpdateLink",
        Dict{String,Any}("Identifier" => Identifier, "ResourceTypes" => ResourceTypes);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_link(
    Identifier,
    ResourceTypes,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return oam(
        "POST",
        "/UpdateLink",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Identifier" => Identifier, "ResourceTypes" => ResourceTypes
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: license_manager_user_subscriptions
using AWS.Compat
using AWS.UUIDs

"""
    associate_user(identity_provider, instance_id, username)
    associate_user(identity_provider, instance_id, username, params::Dict{String,<:Any})

Associates the user to an EC2 instance to utilize user-based subscriptions.  Your estimated
bill for charges on the number of users and related costs will take 48 hours to appear for
billing periods that haven't closed (marked as Pending billing status) in Amazon Web
Services Billing. For more information, see Viewing your monthly charges in the Amazon Web
Services Billing User Guide.

# Arguments
- `identity_provider`: The identity provider of the user.
- `instance_id`: The ID of the EC2 instance, which provides user-based subscriptions.
- `username`: The user name from the identity provider for the user.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Domain"`: The domain name of the user.
"""
function associate_user(
    IdentityProvider,
    InstanceId,
    Username;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager_user_subscriptions(
        "POST",
        "/user/AssociateUser",
        Dict{String,Any}(
            "IdentityProvider" => IdentityProvider,
            "InstanceId" => InstanceId,
            "Username" => Username,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_user(
    IdentityProvider,
    InstanceId,
    Username,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager_user_subscriptions(
        "POST",
        "/user/AssociateUser",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "IdentityProvider" => IdentityProvider,
                    "InstanceId" => InstanceId,
                    "Username" => Username,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    deregister_identity_provider(identity_provider, product)
    deregister_identity_provider(identity_provider, product, params::Dict{String,<:Any})

Deregisters the identity provider from providing user-based subscriptions.

# Arguments
- `identity_provider`: An object that specifies details for the identity provider.
- `product`: The name of the user-based subscription product.

"""
function deregister_identity_provider(
    IdentityProvider, Product; aws_config::AbstractAWSConfig=current_aws_config()
)
    return license_manager_user_subscriptions(
        "POST",
        "/identity-provider/DeregisterIdentityProvider",
        Dict{String,Any}("IdentityProvider" => IdentityProvider, "Product" => Product);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function deregister_identity_provider(
    IdentityProvider,
    Product,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager_user_subscriptions(
        "POST",
        "/identity-provider/DeregisterIdentityProvider",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "IdentityProvider" => IdentityProvider, "Product" => Product
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_user(identity_provider, instance_id, username)
    disassociate_user(identity_provider, instance_id, username, params::Dict{String,<:Any})

Disassociates the user from an EC2 instance providing user-based subscriptions.

# Arguments
- `identity_provider`: An object that specifies details for the identity provider.
- `instance_id`: The ID of the EC2 instance, which provides user-based subscriptions.
- `username`: The user name from the identity provider for the user.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Domain"`: The domain name of the user.
"""
function disassociate_user(
    IdentityProvider,
    InstanceId,
    Username;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager_user_subscriptions(
        "POST",
        "/user/DisassociateUser",
        Dict{String,Any}(
            "IdentityProvider" => IdentityProvider,
            "InstanceId" => InstanceId,
            "Username" => Username,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_user(
    IdentityProvider,
    InstanceId,
    Username,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager_user_subscriptions(
        "POST",
        "/user/DisassociateUser",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "IdentityProvider" => IdentityProvider,
                    "InstanceId" => InstanceId,
                    "Username" => Username,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_identity_providers()
    list_identity_providers(params::Dict{String,<:Any})

Lists the identity providers for user-based subscriptions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Maximum number of results to return in a single call.
- `"NextToken"`: Token for the next set of results.
"""
function list_identity_providers(; aws_config::AbstractAWSConfig=current_aws_config())
    return license_manager_user_subscriptions(
        "POST",
        "/identity-provider/ListIdentityProviders";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_identity_providers(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return license_manager_user_subscriptions(
        "POST",
        "/identity-provider/ListIdentityProviders",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_instances()
    list_instances(params::Dict{String,<:Any})

Lists the EC2 instances providing user-based subscriptions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: An array of structures that you can use to filter the results to those that
  match one or more sets of key-value pairs that you specify.
- `"MaxResults"`: Maximum number of results to return in a single call.
- `"NextToken"`: Token for the next set of results.
"""
function list_instances(; aws_config::AbstractAWSConfig=current_aws_config())
    return license_manager_user_subscriptions(
        "POST",
        "/instance/ListInstances";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_instances(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return license_manager_user_subscriptions(
        "POST",
        "/instance/ListInstances",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_product_subscriptions(identity_provider, product)
    list_product_subscriptions(identity_provider, product, params::Dict{String,<:Any})

Lists the user-based subscription products available from an identity provider.

# Arguments
- `identity_provider`: An object that specifies details for the identity provider.
- `product`: The name of the user-based subscription product.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: An array of structures that you can use to filter the results to those that
  match one or more sets of key-value pairs that you specify.
- `"MaxResults"`: Maximum number of results to return in a single call.
- `"NextToken"`: Token for the next set of results.
"""
function list_product_subscriptions(
    IdentityProvider, Product; aws_config::AbstractAWSConfig=current_aws_config()
)
    return license_manager_user_subscriptions(
        "POST",
        "/user/ListProductSubscriptions",
        Dict{String,Any}("IdentityProvider" => IdentityProvider, "Product" => Product);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_product_subscriptions(
    IdentityProvider,
    Product,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager_user_subscriptions(
        "POST",
        "/user/ListProductSubscriptions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "IdentityProvider" => IdentityProvider, "Product" => Product
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_user_associations(identity_provider, instance_id)
    list_user_associations(identity_provider, instance_id, params::Dict{String,<:Any})

Lists user associations for an identity provider.

# Arguments
- `identity_provider`: An object that specifies details for the identity provider.
- `instance_id`: The ID of the EC2 instance, which provides user-based subscriptions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: An array of structures that you can use to filter the results to those that
  match one or more sets of key-value pairs that you specify.
- `"MaxResults"`: Maximum number of results to return in a single call.
- `"NextToken"`: Token for the next set of results.
"""
function list_user_associations(
    IdentityProvider, InstanceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return license_manager_user_subscriptions(
        "POST",
        "/user/ListUserAssociations",
        Dict{String,Any}(
            "IdentityProvider" => IdentityProvider, "InstanceId" => InstanceId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_user_associations(
    IdentityProvider,
    InstanceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager_user_subscriptions(
        "POST",
        "/user/ListUserAssociations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "IdentityProvider" => IdentityProvider, "InstanceId" => InstanceId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    register_identity_provider(identity_provider, product)
    register_identity_provider(identity_provider, product, params::Dict{String,<:Any})

Registers an identity provider for user-based subscriptions.

# Arguments
- `identity_provider`: An object that specifies details for the identity provider.
- `product`: The name of the user-based subscription product.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Settings"`: The registered identity provider’s product related configuration settings
  such as the subnets to provision VPC endpoints.
"""
function register_identity_provider(
    IdentityProvider, Product; aws_config::AbstractAWSConfig=current_aws_config()
)
    return license_manager_user_subscriptions(
        "POST",
        "/identity-provider/RegisterIdentityProvider",
        Dict{String,Any}("IdentityProvider" => IdentityProvider, "Product" => Product);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function register_identity_provider(
    IdentityProvider,
    Product,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager_user_subscriptions(
        "POST",
        "/identity-provider/RegisterIdentityProvider",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "IdentityProvider" => IdentityProvider, "Product" => Product
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_product_subscription(identity_provider, product, username)
    start_product_subscription(identity_provider, product, username, params::Dict{String,<:Any})

Starts a product subscription for a user with the specified identity provider.  Your
estimated bill for charges on the number of users and related costs will take 48 hours to
appear for billing periods that haven't closed (marked as Pending billing status) in Amazon
Web Services Billing. For more information, see Viewing your monthly charges in the Amazon
Web Services Billing User Guide.

# Arguments
- `identity_provider`: An object that specifies details for the identity provider.
- `product`: The name of the user-based subscription product.
- `username`: The user name from the identity provider of the user.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Domain"`: The domain name of the user.
"""
function start_product_subscription(
    IdentityProvider, Product, Username; aws_config::AbstractAWSConfig=current_aws_config()
)
    return license_manager_user_subscriptions(
        "POST",
        "/user/StartProductSubscription",
        Dict{String,Any}(
            "IdentityProvider" => IdentityProvider,
            "Product" => Product,
            "Username" => Username,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_product_subscription(
    IdentityProvider,
    Product,
    Username,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager_user_subscriptions(
        "POST",
        "/user/StartProductSubscription",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "IdentityProvider" => IdentityProvider,
                    "Product" => Product,
                    "Username" => Username,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_product_subscription(identity_provider, product, username)
    stop_product_subscription(identity_provider, product, username, params::Dict{String,<:Any})

Stops a product subscription for a user with the specified identity provider.

# Arguments
- `identity_provider`: An object that specifies details for the identity provider.
- `product`: The name of the user-based subscription product.
- `username`: The user name from the identity provider for the user.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Domain"`: The domain name of the user.
"""
function stop_product_subscription(
    IdentityProvider, Product, Username; aws_config::AbstractAWSConfig=current_aws_config()
)
    return license_manager_user_subscriptions(
        "POST",
        "/user/StopProductSubscription",
        Dict{String,Any}(
            "IdentityProvider" => IdentityProvider,
            "Product" => Product,
            "Username" => Username,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_product_subscription(
    IdentityProvider,
    Product,
    Username,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager_user_subscriptions(
        "POST",
        "/user/StopProductSubscription",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "IdentityProvider" => IdentityProvider,
                    "Product" => Product,
                    "Username" => Username,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_identity_provider_settings(identity_provider, product, update_settings)
    update_identity_provider_settings(identity_provider, product, update_settings, params::Dict{String,<:Any})

Updates additional product configuration settings for the registered identity provider.

# Arguments
- `identity_provider`:
- `product`: The name of the user-based subscription product.
- `update_settings`: Updates the registered identity provider’s product related
  configuration settings. You can update any combination of settings in a single operation
  such as the:   Subnets which you want to add to provision VPC endpoints.   Subnets which
  you want to remove the VPC endpoints from.   Security group ID which permits traffic to the
  VPC endpoints.

"""
function update_identity_provider_settings(
    IdentityProvider,
    Product,
    UpdateSettings;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager_user_subscriptions(
        "POST",
        "/identity-provider/UpdateIdentityProviderSettings",
        Dict{String,Any}(
            "IdentityProvider" => IdentityProvider,
            "Product" => Product,
            "UpdateSettings" => UpdateSettings,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_identity_provider_settings(
    IdentityProvider,
    Product,
    UpdateSettings,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager_user_subscriptions(
        "POST",
        "/identity-provider/UpdateIdentityProviderSettings",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "IdentityProvider" => IdentityProvider,
                    "Product" => Product,
                    "UpdateSettings" => UpdateSettings,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: migrationhubstrategy
using AWS.Compat
using AWS.UUIDs

"""
    get_application_component_details(application_component_id)
    get_application_component_details(application_component_id, params::Dict{String,<:Any})

 Retrieves details about an application component.

# Arguments
- `application_component_id`:  The ID of the application component. The ID is unique within
  an AWS account.

"""
function get_application_component_details(
    applicationComponentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migrationhubstrategy(
        "GET",
        "/get-applicationcomponent-details/$(applicationComponentId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_application_component_details(
    applicationComponentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migrationhubstrategy(
        "GET",
        "/get-applicationcomponent-details/$(applicationComponentId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_application_component_strategies(application_component_id)
    get_application_component_strategies(application_component_id, params::Dict{String,<:Any})

 Retrieves a list of all the recommended strategies and tools for an application component
running on a server.

# Arguments
- `application_component_id`:  The ID of the application component. The ID is unique within
  an AWS account.

"""
function get_application_component_strategies(
    applicationComponentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migrationhubstrategy(
        "GET",
        "/get-applicationcomponent-strategies/$(applicationComponentId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_application_component_strategies(
    applicationComponentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migrationhubstrategy(
        "GET",
        "/get-applicationcomponent-strategies/$(applicationComponentId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_assessment(id)
    get_assessment(id, params::Dict{String,<:Any})

 Retrieves the status of an on-going assessment.

# Arguments
- `id`:  The assessmentid returned by StartAssessment.

"""
function get_assessment(id; aws_config::AbstractAWSConfig=current_aws_config())
    return migrationhubstrategy(
        "GET",
        "/get-assessment/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_assessment(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migrationhubstrategy(
        "GET",
        "/get-assessment/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_import_file_task(id)
    get_import_file_task(id, params::Dict{String,<:Any})

 Retrieves the details about a specific import task.

# Arguments
- `id`:  The ID of the import file task. This ID is returned in the response of
  StartImportFileTask.

"""
function get_import_file_task(id; aws_config::AbstractAWSConfig=current_aws_config())
    return migrationhubstrategy(
        "GET",
        "/get-import-file-task/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_import_file_task(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migrationhubstrategy(
        "GET",
        "/get-import-file-task/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_latest_assessment_id()
    get_latest_assessment_id(params::Dict{String,<:Any})

Retrieve the latest ID of a specific assessment task.

"""
function get_latest_assessment_id(; aws_config::AbstractAWSConfig=current_aws_config())
    return migrationhubstrategy(
        "GET",
        "/get-latest-assessment-id";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_latest_assessment_id(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migrationhubstrategy(
        "GET",
        "/get-latest-assessment-id",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_portfolio_preferences()
    get_portfolio_preferences(params::Dict{String,<:Any})

 Retrieves your migration and modernization preferences.

"""
function get_portfolio_preferences(; aws_config::AbstractAWSConfig=current_aws_config())
    return migrationhubstrategy(
        "GET",
        "/get-portfolio-preferences";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_portfolio_preferences(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migrationhubstrategy(
        "GET",
        "/get-portfolio-preferences",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_portfolio_summary()
    get_portfolio_summary(params::Dict{String,<:Any})

 Retrieves overall summary including the number of servers to rehost and the overall number
of anti-patterns.

"""
function get_portfolio_summary(; aws_config::AbstractAWSConfig=current_aws_config())
    return migrationhubstrategy(
        "GET",
        "/get-portfolio-summary";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_portfolio_summary(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migrationhubstrategy(
        "GET",
        "/get-portfolio-summary",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_recommendation_report_details(id)
    get_recommendation_report_details(id, params::Dict{String,<:Any})

 Retrieves detailed information about the specified recommendation report.

# Arguments
- `id`:  The recommendation report generation task id returned by
  StartRecommendationReportGeneration.

"""
function get_recommendation_report_details(
    id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migrationhubstrategy(
        "GET",
        "/get-recommendation-report-details/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_recommendation_report_details(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migrationhubstrategy(
        "GET",
        "/get-recommendation-report-details/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_server_details(server_id)
    get_server_details(server_id, params::Dict{String,<:Any})

 Retrieves detailed information about a specified server.

# Arguments
- `server_id`:  The ID of the server.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:  The maximum number of items to include in the response. The maximum
  value is 100.
- `"nextToken"`:  The token from a previous call that you use to retrieve the next set of
  results. For example, if a previous call to this action returned 100 items, but you set
  maxResults to 10. You'll receive a set of 10 results along with a token. You then use the
  returned token to retrieve the next set of 10.
"""
function get_server_details(serverId; aws_config::AbstractAWSConfig=current_aws_config())
    return migrationhubstrategy(
        "GET",
        "/get-server-details/$(serverId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_server_details(
    serverId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migrationhubstrategy(
        "GET",
        "/get-server-details/$(serverId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_server_strategies(server_id)
    get_server_strategies(server_id, params::Dict{String,<:Any})

 Retrieves recommended strategies and tools for the specified server.

# Arguments
- `server_id`:  The ID of the server.

"""
function get_server_strategies(serverId; aws_config::AbstractAWSConfig=current_aws_config())
    return migrationhubstrategy(
        "GET",
        "/get-server-strategies/$(serverId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_server_strategies(
    serverId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migrationhubstrategy(
        "GET",
        "/get-server-strategies/$(serverId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_analyzable_servers()
    list_analyzable_servers(params::Dict{String,<:Any})

Retrieves a list of all the servers fetched from customer vCenter using Strategy
Recommendation Collector.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of items to include in the response. The maximum value
  is 100.
- `"nextToken"`: The token from a previous call that you use to retrieve the next set of
  results. For example, if a previous call to this action returned 100 items, but you set
  maxResults to 10. You'll receive a set of 10 results along with a token. You then use the
  returned token to retrieve the next set of 10.
- `"sort"`: Specifies whether to sort by ascending (ASC) or descending (DESC) order.
"""
function list_analyzable_servers(; aws_config::AbstractAWSConfig=current_aws_config())
    return migrationhubstrategy(
        "POST",
        "/list-analyzable-servers";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_analyzable_servers(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migrationhubstrategy(
        "POST",
        "/list-analyzable-servers",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_application_components()
    list_application_components(params::Dict{String,<:Any})

 Retrieves a list of all the application components (processes).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"applicationComponentCriteria"`:  Criteria for filtering the list of application
  components.
- `"filterValue"`:  Specify the value based on the application component criteria type. For
  example, if applicationComponentCriteria is set to SERVER_ID and filterValue is set to
  server1, then ListApplicationComponents returns all the application components running on
  server1.
- `"groupIdFilter"`:  The group ID specified in to filter on.
- `"maxResults"`:  The maximum number of items to include in the response. The maximum
  value is 100.
- `"nextToken"`:  The token from a previous call that you use to retrieve the next set of
  results. For example, if a previous call to this action returned 100 items, but you set
  maxResults to 10. You'll receive a set of 10 results along with a token. You then use the
  returned token to retrieve the next set of 10.
- `"sort"`:  Specifies whether to sort by ascending (ASC) or descending (DESC) order.
"""
function list_application_components(; aws_config::AbstractAWSConfig=current_aws_config())
    return migrationhubstrategy(
        "POST",
        "/list-applicationcomponents";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_application_components(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migrationhubstrategy(
        "POST",
        "/list-applicationcomponents",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_collectors()
    list_collectors(params::Dict{String,<:Any})

 Retrieves a list of all the installed collectors.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:  The maximum number of items to include in the response. The maximum
  value is 100.
- `"nextToken"`:  The token from a previous call that you use to retrieve the next set of
  results. For example, if a previous call to this action returned 100 items, but you set
  maxResults to 10. You'll receive a set of 10 results along with a token. You then use the
  returned token to retrieve the next set of 10.
"""
function list_collectors(; aws_config::AbstractAWSConfig=current_aws_config())
    return migrationhubstrategy(
        "GET", "/list-collectors"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_collectors(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migrationhubstrategy(
        "GET",
        "/list-collectors",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_import_file_task()
    list_import_file_task(params::Dict{String,<:Any})

 Retrieves a list of all the imports performed.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:  The total number of items to return. The maximum value is 100.
- `"nextToken"`:  The token from a previous call that you use to retrieve the next set of
  results. For example, if a previous call to this action returned 100 items, but you set
  maxResults to 10. You'll receive a set of 10 results along with a token. You then use the
  returned token to retrieve the next set of 10.
"""
function list_import_file_task(; aws_config::AbstractAWSConfig=current_aws_config())
    return migrationhubstrategy(
        "GET",
        "/list-import-file-task";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_import_file_task(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migrationhubstrategy(
        "GET",
        "/list-import-file-task",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_servers()
    list_servers(params::Dict{String,<:Any})

 Returns a list of all the servers.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filterValue"`:  Specifies the filter value, which is based on the type of server
  criteria. For example, if serverCriteria is OS_NAME, and the filterValue is equal to
  WindowsServer, then ListServers returns all of the servers matching the OS name
  WindowsServer.
- `"groupIdFilter"`:  Specifies the group ID to filter on.
- `"maxResults"`:  The maximum number of items to include in the response. The maximum
  value is 100.
- `"nextToken"`:  The token from a previous call that you use to retrieve the next set of
  results. For example, if a previous call to this action returned 100 items, but you set
  maxResults to 10. You'll receive a set of 10 results along with a token. You then use the
  returned token to retrieve the next set of 10.
- `"serverCriteria"`:  Criteria for filtering servers.
- `"sort"`:  Specifies whether to sort by ascending (ASC) or descending (DESC) order.
"""
function list_servers(; aws_config::AbstractAWSConfig=current_aws_config())
    return migrationhubstrategy(
        "POST", "/list-servers"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_servers(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migrationhubstrategy(
        "POST",
        "/list-servers",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_portfolio_preferences()
    put_portfolio_preferences(params::Dict{String,<:Any})

 Saves the specified migration and modernization preferences.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"applicationMode"`: The classification for application component types.
- `"applicationPreferences"`:  The transformation preferences for non-database
  applications.
- `"databasePreferences"`:  The transformation preferences for database applications.
- `"prioritizeBusinessGoals"`:  The rank of the business goals based on priority.
"""
function put_portfolio_preferences(; aws_config::AbstractAWSConfig=current_aws_config())
    return migrationhubstrategy(
        "POST",
        "/put-portfolio-preferences";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_portfolio_preferences(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migrationhubstrategy(
        "POST",
        "/put-portfolio-preferences",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_assessment()
    start_assessment(params::Dict{String,<:Any})

 Starts the assessment of an on-premises environment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"assessmentDataSourceType"`: The data source type of an assessment to be started.
- `"assessmentTargets"`: List of criteria for assessment.
- `"s3bucketForAnalysisData"`:  The S3 bucket used by the collectors to send analysis data
  to the service. The bucket name must begin with migrationhub-strategy-.
- `"s3bucketForReportData"`:  The S3 bucket where all the reports generated by the service
  are stored. The bucket name must begin with migrationhub-strategy-.
"""
function start_assessment(; aws_config::AbstractAWSConfig=current_aws_config())
    return migrationhubstrategy(
        "POST", "/start-assessment"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function start_assessment(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migrationhubstrategy(
        "POST",
        "/start-assessment",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_import_file_task(s3_bucket, name, s3key)
    start_import_file_task(s3_bucket, name, s3key, params::Dict{String,<:Any})

 Starts a file import.

# Arguments
- `s3_bucket`:  The S3 bucket where the import file is located. The bucket name is required
  to begin with migrationhub-strategy-.
- `name`:  A descriptive name for the request.
- `s3key`:  The Amazon S3 key name of the import file.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"dataSourceType"`: Specifies the source that the servers are coming from. By default,
  Strategy Recommendations assumes that the servers specified in the import file are
  available in AWS Application Discovery Service.
- `"groupId"`: Groups the resources in the import file together with a unique name. This ID
  can be as filter in ListApplicationComponents and ListServers.
- `"s3bucketForReportData"`:  The S3 bucket where Strategy Recommendations uploads import
  results. The bucket name is required to begin with migrationhub-strategy-.
"""
function start_import_file_task(
    S3Bucket, name, s3key; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migrationhubstrategy(
        "POST",
        "/start-import-file-task",
        Dict{String,Any}("S3Bucket" => S3Bucket, "name" => name, "s3key" => s3key);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_import_file_task(
    S3Bucket,
    name,
    s3key,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migrationhubstrategy(
        "POST",
        "/start-import-file-task",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("S3Bucket" => S3Bucket, "name" => name, "s3key" => s3key),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_recommendation_report_generation()
    start_recommendation_report_generation(params::Dict{String,<:Any})

 Starts generating a recommendation report.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"groupIdFilter"`:  Groups the resources in the recommendation report with a unique name.
- `"outputFormat"`:  The output format for the recommendation report file. The default
  format is Microsoft Excel.
"""
function start_recommendation_report_generation(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return migrationhubstrategy(
        "POST",
        "/start-recommendation-report-generation";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_recommendation_report_generation(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migrationhubstrategy(
        "POST",
        "/start-recommendation-report-generation",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_assessment(assessment_id)
    stop_assessment(assessment_id, params::Dict{String,<:Any})

 Stops the assessment of an on-premises environment.

# Arguments
- `assessment_id`:  The assessmentId returned by StartAssessment.

"""
function stop_assessment(assessmentId; aws_config::AbstractAWSConfig=current_aws_config())
    return migrationhubstrategy(
        "POST",
        "/stop-assessment",
        Dict{String,Any}("assessmentId" => assessmentId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_assessment(
    assessmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migrationhubstrategy(
        "POST",
        "/stop-assessment",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("assessmentId" => assessmentId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_application_component_config(application_component_id)
    update_application_component_config(application_component_id, params::Dict{String,<:Any})

 Updates the configuration of an application component.

# Arguments
- `application_component_id`:  The ID of the application component. The ID is unique within
  an AWS account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"appType"`: The type of known component.
- `"configureOnly"`: Update the configuration request of an application component. If it is
  set to true, the source code and/or database credentials are updated. If it is set to
  false, the source code and/or database credentials are updated and an analysis is initiated.
- `"inclusionStatus"`:  Indicates whether the application component has been included for
  server recommendation or not.
- `"secretsManagerKey"`:  Database credentials.
- `"sourceCodeList"`:  The list of source code configurations to update for the application
  component.
- `"strategyOption"`:  The preferred strategy options for the application component. Use
  values from the GetApplicationComponentStrategies response.
"""
function update_application_component_config(
    applicationComponentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migrationhubstrategy(
        "POST",
        "/update-applicationcomponent-config/",
        Dict{String,Any}("applicationComponentId" => applicationComponentId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_application_component_config(
    applicationComponentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migrationhubstrategy(
        "POST",
        "/update-applicationcomponent-config/",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("applicationComponentId" => applicationComponentId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_server_config(server_id)
    update_server_config(server_id, params::Dict{String,<:Any})

 Updates the configuration of the specified server.

# Arguments
- `server_id`:  The ID of the server.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"strategyOption"`:  The preferred strategy options for the application component. See
  the response from GetServerStrategies.
"""
function update_server_config(serverId; aws_config::AbstractAWSConfig=current_aws_config())
    return migrationhubstrategy(
        "POST",
        "/update-server-config/",
        Dict{String,Any}("serverId" => serverId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_server_config(
    serverId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migrationhubstrategy(
        "POST",
        "/update-server-config/",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("serverId" => serverId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: entityresolution
using AWS.Compat
using AWS.UUIDs

"""
    add_policy_statement(action, arn, effect, principal, statement_id)
    add_policy_statement(action, arn, effect, principal, statement_id, params::Dict{String,<:Any})

Adds a policy statement object. To retrieve a list of existing policy statements, use the
GetPolicy API.

# Arguments
- `action`: The action that the principal can use on the resource.  For example,
  entityresolution:GetIdMappingJob, entityresolution:GetMatchingJob.
- `arn`: The Amazon Resource Name (ARN) of the resource that will be accessed by the
  principal.
- `effect`: Determines whether the permissions specified in the policy are to be allowed
  (Allow) or denied (Deny).
- `principal`: The Amazon Web Services service or Amazon Web Services account that can
  access the resource defined as ARN.
- `statement_id`: A statement identifier that differentiates the statement from others in
  the same policy.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"condition"`: A set of condition keys that you can use in key policies.
"""
function add_policy_statement(
    action,
    arn,
    effect,
    principal,
    statementId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return entityresolution(
        "POST",
        "/policies/$(arn)/$(statementId)",
        Dict{String,Any}("action" => action, "effect" => effect, "principal" => principal);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_policy_statement(
    action,
    arn,
    effect,
    principal,
    statementId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return entityresolution(
        "POST",
        "/policies/$(arn)/$(statementId)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "action" => action, "effect" => effect, "principal" => principal
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_delete_unique_id(unique_ids, workflow_name)
    batch_delete_unique_id(unique_ids, workflow_name, params::Dict{String,<:Any})

Deletes multiple unique IDs in a matching workflow.

# Arguments
- `unique_ids`: The unique IDs to delete.
- `workflow_name`: The name of the workflow.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"inputSource"`: The input source for the batch delete unique ID operation.
"""
function batch_delete_unique_id(
    uniqueIds, workflowName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return entityresolution(
        "DELETE",
        "/matchingworkflows/$(workflowName)/uniqueids",
        Dict{String,Any}("headers" => Dict{String,Any}("uniqueIds" => uniqueIds));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_delete_unique_id(
    uniqueIds,
    workflowName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return entityresolution(
        "DELETE",
        "/matchingworkflows/$(workflowName)/uniqueids",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("headers" => Dict{String,Any}("uniqueIds" => uniqueIds)),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_id_mapping_workflow(id_mapping_techniques, input_source_config, role_arn, workflow_name)
    create_id_mapping_workflow(id_mapping_techniques, input_source_config, role_arn, workflow_name, params::Dict{String,<:Any})

Creates an IdMappingWorkflow object which stores the configuration of the data processing
job to be run. Each IdMappingWorkflow must have a unique workflow name. To modify an
existing workflow, use the UpdateIdMappingWorkflow API.

# Arguments
- `id_mapping_techniques`: An object which defines the idMappingType and the
  providerProperties.
- `input_source_config`: A list of InputSource objects, which have the fields
  InputSourceARN and SchemaName.
- `role_arn`: The Amazon Resource Name (ARN) of the IAM role. Entity Resolution assumes
  this role to create resources on your behalf as part of workflow execution.
- `workflow_name`: The name of the workflow. There can't be multiple IdMappingWorkflows
  with the same name.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A description of the workflow.
- `"outputSourceConfig"`: A list of IdMappingWorkflowOutputSource objects, each of which
  contains fields OutputS3Path and Output.
- `"tags"`: The tags used to organize, track, or control access for this resource.
"""
function create_id_mapping_workflow(
    idMappingTechniques,
    inputSourceConfig,
    roleArn,
    workflowName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return entityresolution(
        "POST",
        "/idmappingworkflows",
        Dict{String,Any}(
            "idMappingTechniques" => idMappingTechniques,
            "inputSourceConfig" => inputSourceConfig,
            "roleArn" => roleArn,
            "workflowName" => workflowName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_id_mapping_workflow(
    idMappingTechniques,
    inputSourceConfig,
    roleArn,
    workflowName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return entityresolution(
        "POST",
        "/idmappingworkflows",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "idMappingTechniques" => idMappingTechniques,
                    "inputSourceConfig" => inputSourceConfig,
                    "roleArn" => roleArn,
                    "workflowName" => workflowName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_id_namespace(id_namespace_name, type)
    create_id_namespace(id_namespace_name, type, params::Dict{String,<:Any})

Creates an ID namespace object which will help customers provide metadata explaining their
dataset and how to use it. Each ID namespace must have a unique name. To modify an existing
ID namespace, use the UpdateIdNamespace API.

# Arguments
- `id_namespace_name`: The name of the ID namespace.
- `type`: The type of ID namespace. There are two types: SOURCE and TARGET.  The SOURCE
  contains configurations for sourceId data that will be processed in an ID mapping workflow.
   The TARGET contains a configuration of targetId to which all sourceIds will resolve to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description of the ID namespace.
- `"idMappingWorkflowProperties"`: Determines the properties of IdMappingWorflow where this
  IdNamespace can be used as a Source or a Target.
- `"inputSourceConfig"`: A list of InputSource objects, which have the fields
  InputSourceARN and SchemaName.
- `"roleArn"`: The Amazon Resource Name (ARN) of the IAM role. Entity Resolution assumes
  this role to access the resources defined in this IdNamespace on your behalf as part of the
  workflow run.
- `"tags"`: The tags used to organize, track, or control access for this resource.
"""
function create_id_namespace(
    idNamespaceName, type; aws_config::AbstractAWSConfig=current_aws_config()
)
    return entityresolution(
        "POST",
        "/idnamespaces",
        Dict{String,Any}("idNamespaceName" => idNamespaceName, "type" => type);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_id_namespace(
    idNamespaceName,
    type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return entityresolution(
        "POST",
        "/idnamespaces",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("idNamespaceName" => idNamespaceName, "type" => type),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_matching_workflow(input_source_config, output_source_config, resolution_techniques, role_arn, workflow_name)
    create_matching_workflow(input_source_config, output_source_config, resolution_techniques, role_arn, workflow_name, params::Dict{String,<:Any})

Creates a MatchingWorkflow object which stores the configuration of the data processing job
to be run. It is important to note that there should not be a pre-existing MatchingWorkflow
with the same name. To modify an existing workflow, utilize the UpdateMatchingWorkflow API.

# Arguments
- `input_source_config`: A list of InputSource objects, which have the fields
  InputSourceARN and SchemaName.
- `output_source_config`: A list of OutputSource objects, each of which contains fields
  OutputS3Path, ApplyNormalization, and Output.
- `resolution_techniques`: An object which defines the resolutionType and the
  ruleBasedProperties.
- `role_arn`: The Amazon Resource Name (ARN) of the IAM role. Entity Resolution assumes
  this role to create resources on your behalf as part of workflow execution.
- `workflow_name`: The name of the workflow. There can't be multiple MatchingWorkflows with
  the same name.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A description of the workflow.
- `"incrementalRunConfig"`: An object which defines an incremental run type and has only
  incrementalRunType as a field.
- `"tags"`: The tags used to organize, track, or control access for this resource.
"""
function create_matching_workflow(
    inputSourceConfig,
    outputSourceConfig,
    resolutionTechniques,
    roleArn,
    workflowName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return entityresolution(
        "POST",
        "/matchingworkflows",
        Dict{String,Any}(
            "inputSourceConfig" => inputSourceConfig,
            "outputSourceConfig" => outputSourceConfig,
            "resolutionTechniques" => resolutionTechniques,
            "roleArn" => roleArn,
            "workflowName" => workflowName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_matching_workflow(
    inputSourceConfig,
    outputSourceConfig,
    resolutionTechniques,
    roleArn,
    workflowName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return entityresolution(
        "POST",
        "/matchingworkflows",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "inputSourceConfig" => inputSourceConfig,
                    "outputSourceConfig" => outputSourceConfig,
                    "resolutionTechniques" => resolutionTechniques,
                    "roleArn" => roleArn,
                    "workflowName" => workflowName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_schema_mapping(mapped_input_fields, schema_name)
    create_schema_mapping(mapped_input_fields, schema_name, params::Dict{String,<:Any})

Creates a schema mapping, which defines the schema of the input customer records table. The
SchemaMapping also provides Entity Resolution with some metadata about the table, such as
the attribute types of the columns and which columns to match on.

# Arguments
- `mapped_input_fields`: A list of MappedInputFields. Each MappedInputField corresponds to
  a column the source data table, and contains column name plus additional information that
  Entity Resolution uses for matching.
- `schema_name`: The name of the schema. There can't be multiple SchemaMappings with the
  same name.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A description of the schema.
- `"tags"`: The tags used to organize, track, or control access for this resource.
"""
function create_schema_mapping(
    mappedInputFields, schemaName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return entityresolution(
        "POST",
        "/schemas",
        Dict{String,Any}(
            "mappedInputFields" => mappedInputFields, "schemaName" => schemaName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_schema_mapping(
    mappedInputFields,
    schemaName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return entityresolution(
        "POST",
        "/schemas",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "mappedInputFields" => mappedInputFields, "schemaName" => schemaName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_id_mapping_workflow(workflow_name)
    delete_id_mapping_workflow(workflow_name, params::Dict{String,<:Any})

Deletes the IdMappingWorkflow with a given name. This operation will succeed even if a
workflow with the given name does not exist.

# Arguments
- `workflow_name`: The name of the workflow to be deleted.

"""
function delete_id_mapping_workflow(
    workflowName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return entityresolution(
        "DELETE",
        "/idmappingworkflows/$(workflowName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_id_mapping_workflow(
    workflowName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return entityresolution(
        "DELETE",
        "/idmappingworkflows/$(workflowName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_id_namespace(id_namespace_name)
    delete_id_namespace(id_namespace_name, params::Dict{String,<:Any})

Deletes the IdNamespace with a given name.

# Arguments
- `id_namespace_name`: The name of the ID namespace.

"""
function delete_id_namespace(
    idNamespaceName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return entityresolution(
        "DELETE",
        "/idnamespaces/$(idNamespaceName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_id_namespace(
    idNamespaceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return entityresolution(
        "DELETE",
        "/idnamespaces/$(idNamespaceName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_matching_workflow(workflow_name)
    delete_matching_workflow(workflow_name, params::Dict{String,<:Any})

Deletes the MatchingWorkflow with a given name. This operation will succeed even if a
workflow with the given name does not exist.

# Arguments
- `workflow_name`: The name of the workflow to be retrieved.

"""
function delete_matching_workflow(
    workflowName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return entityresolution(
        "DELETE",
        "/matchingworkflows/$(workflowName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_matching_workflow(
    workflowName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return entityresolution(
        "DELETE",
        "/matchingworkflows/$(workflowName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_policy_statement(arn, statement_id)
    delete_policy_statement(arn, statement_id, params::Dict{String,<:Any})

Deletes the policy statement.

# Arguments
- `arn`: The ARN of the resource for which the policy need to be deleted.
- `statement_id`: A statement identifier that differentiates the statement from others in
  the same policy.

"""
function delete_policy_statement(
    arn, statementId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return entityresolution(
        "DELETE",
        "/policies/$(arn)/$(statementId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_policy_statement(
    arn,
    statementId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return entityresolution(
        "DELETE",
        "/policies/$(arn)/$(statementId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_schema_mapping(schema_name)
    delete_schema_mapping(schema_name, params::Dict{String,<:Any})

Deletes the SchemaMapping with a given name. This operation will succeed even if a schema
with the given name does not exist. This operation will fail if there is a MatchingWorkflow
object that references the SchemaMapping in the workflow's InputSourceConfig.

# Arguments
- `schema_name`: The name of the schema to delete.

"""
function delete_schema_mapping(
    schemaName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return entityresolution(
        "DELETE",
        "/schemas/$(schemaName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_schema_mapping(
    schemaName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return entityresolution(
        "DELETE",
        "/schemas/$(schemaName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_id_mapping_job(job_id, workflow_name)
    get_id_mapping_job(job_id, workflow_name, params::Dict{String,<:Any})

Gets the status, metrics, and errors (if there are any) that are associated with a job.

# Arguments
- `job_id`: The ID of the job.
- `workflow_name`: The name of the workflow.

"""
function get_id_mapping_job(
    jobId, workflowName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return entityresolution(
        "GET",
        "/idmappingworkflows/$(workflowName)/jobs/$(jobId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_id_mapping_job(
    jobId,
    workflowName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return entityresolution(
        "GET",
        "/idmappingworkflows/$(workflowName)/jobs/$(jobId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_id_mapping_workflow(workflow_name)
    get_id_mapping_workflow(workflow_name, params::Dict{String,<:Any})

Returns the IdMappingWorkflow with a given name, if it exists.

# Arguments
- `workflow_name`: The name of the workflow.

"""
function get_id_mapping_workflow(
    workflowName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return entityresolution(
        "GET",
        "/idmappingworkflows/$(workflowName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_id_mapping_workflow(
    workflowName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return entityresolution(
        "GET",
        "/idmappingworkflows/$(workflowName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_id_namespace(id_namespace_name)
    get_id_namespace(id_namespace_name, params::Dict{String,<:Any})

Returns the IdNamespace with a given name, if it exists.

# Arguments
- `id_namespace_name`: The name of the ID namespace.

"""
function get_id_namespace(
    idNamespaceName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return entityresolution(
        "GET",
        "/idnamespaces/$(idNamespaceName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_id_namespace(
    idNamespaceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return entityresolution(
        "GET",
        "/idnamespaces/$(idNamespaceName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_match_id(record, workflow_name)
    get_match_id(record, workflow_name, params::Dict{String,<:Any})

Returns the corresponding Match ID of a customer record if the record has been processed.

# Arguments
- `record`: The record to fetch the Match ID for.
- `workflow_name`: The name of the workflow.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"applyNormalization"`: Normalizes the attributes defined in the schema in the input
  data. For example, if an attribute has an AttributeType of PHONE_NUMBER, and the data in
  the input table is in a format of 1234567890, Entity Resolution will normalize this field
  in the output to (123)-456-7890.
"""
function get_match_id(
    record, workflowName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return entityresolution(
        "POST",
        "/matchingworkflows/$(workflowName)/matches",
        Dict{String,Any}("record" => record);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_match_id(
    record,
    workflowName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return entityresolution(
        "POST",
        "/matchingworkflows/$(workflowName)/matches",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("record" => record), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_matching_job(job_id, workflow_name)
    get_matching_job(job_id, workflow_name, params::Dict{String,<:Any})

Gets the status, metrics, and errors (if there are any) that are associated with a job.

# Arguments
- `job_id`: The ID of the job.
- `workflow_name`: The name of the workflow.

"""
function get_matching_job(
    jobId, workflowName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return entityresolution(
        "GET",
        "/matchingworkflows/$(workflowName)/jobs/$(jobId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_matching_job(
    jobId,
    workflowName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return entityresolution(
        "GET",
        "/matchingworkflows/$(workflowName)/jobs/$(jobId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_matching_workflow(workflow_name)
    get_matching_workflow(workflow_name, params::Dict{String,<:Any})

Returns the MatchingWorkflow with a given name, if it exists.

# Arguments
- `workflow_name`: The name of the workflow.

"""
function get_matching_workflow(
    workflowName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return entityresolution(
        "GET",
        "/matchingworkflows/$(workflowName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_matching_workflow(
    workflowName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return entityresolution(
        "GET",
        "/matchingworkflows/$(workflowName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_policy(arn)
    get_policy(arn, params::Dict{String,<:Any})

Returns the resource-based policy.

# Arguments
- `arn`: The Amazon Resource Name (ARN) of the resource for which the policy need to be
  returned.

"""
function get_policy(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return entityresolution(
        "GET", "/policies/$(arn)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_policy(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return entityresolution(
        "GET",
        "/policies/$(arn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_provider_service(provider_name, provider_service_name)
    get_provider_service(provider_name, provider_service_name, params::Dict{String,<:Any})

Returns the ProviderService of a given name.

# Arguments
- `provider_name`: The name of the provider. This name is typically the company name.
- `provider_service_name`: The ARN (Amazon Resource Name) of the product that the provider
  service provides.

"""
function get_provider_service(
    providerName, providerServiceName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return entityresolution(
        "GET",
        "/providerservices/$(providerName)/$(providerServiceName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_provider_service(
    providerName,
    providerServiceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return entityresolution(
        "GET",
        "/providerservices/$(providerName)/$(providerServiceName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_schema_mapping(schema_name)
    get_schema_mapping(schema_name, params::Dict{String,<:Any})

Returns the SchemaMapping of a given name.

# Arguments
- `schema_name`: The name of the schema to be retrieved.

"""
function get_schema_mapping(schemaName; aws_config::AbstractAWSConfig=current_aws_config())
    return entityresolution(
        "GET",
        "/schemas/$(schemaName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_schema_mapping(
    schemaName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return entityresolution(
        "GET",
        "/schemas/$(schemaName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_id_mapping_jobs(workflow_name)
    list_id_mapping_jobs(workflow_name, params::Dict{String,<:Any})

Lists all ID mapping jobs for a given workflow.

# Arguments
- `workflow_name`: The name of the workflow to be retrieved.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of objects returned per page.
- `"nextToken"`: The pagination token from the previous API call.
"""
function list_id_mapping_jobs(
    workflowName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return entityresolution(
        "GET",
        "/idmappingworkflows/$(workflowName)/jobs";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_id_mapping_jobs(
    workflowName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return entityresolution(
        "GET",
        "/idmappingworkflows/$(workflowName)/jobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_id_mapping_workflows()
    list_id_mapping_workflows(params::Dict{String,<:Any})

Returns a list of all the IdMappingWorkflows that have been created for an Amazon Web
Services account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of objects returned per page.
- `"nextToken"`: The pagination token from the previous API call.
"""
function list_id_mapping_workflows(; aws_config::AbstractAWSConfig=current_aws_config())
    return entityresolution(
        "GET", "/idmappingworkflows"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_id_mapping_workflows(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return entityresolution(
        "GET",
        "/idmappingworkflows",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_id_namespaces()
    list_id_namespaces(params::Dict{String,<:Any})

Returns a list of all ID namespaces.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of IdNamespace objects returned per page.
- `"nextToken"`: The pagination token from the previous API call.
"""
function list_id_namespaces(; aws_config::AbstractAWSConfig=current_aws_config())
    return entityresolution(
        "GET", "/idnamespaces"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_id_namespaces(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return entityresolution(
        "GET",
        "/idnamespaces",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_matching_jobs(workflow_name)
    list_matching_jobs(workflow_name, params::Dict{String,<:Any})

Lists all jobs for a given workflow.

# Arguments
- `workflow_name`: The name of the workflow to be retrieved.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of objects returned per page.
- `"nextToken"`: The pagination token from the previous API call.
"""
function list_matching_jobs(
    workflowName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return entityresolution(
        "GET",
        "/matchingworkflows/$(workflowName)/jobs";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_matching_jobs(
    workflowName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return entityresolution(
        "GET",
        "/matchingworkflows/$(workflowName)/jobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_matching_workflows()
    list_matching_workflows(params::Dict{String,<:Any})

Returns a list of all the MatchingWorkflows that have been created for an Amazon Web
Services account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of objects returned per page.
- `"nextToken"`: The pagination token from the previous API call.
"""
function list_matching_workflows(; aws_config::AbstractAWSConfig=current_aws_config())
    return entityresolution(
        "GET", "/matchingworkflows"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_matching_workflows(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return entityresolution(
        "GET",
        "/matchingworkflows",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_provider_services()
    list_provider_services(params::Dict{String,<:Any})

Returns a list of all the ProviderServices that are available in this Amazon Web Services
Region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of objects returned per page.
- `"nextToken"`: The pagination token from the previous API call.
- `"providerName"`: The name of the provider. This name is typically the company name.
"""
function list_provider_services(; aws_config::AbstractAWSConfig=current_aws_config())
    return entityresolution(
        "GET", "/providerservices"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_provider_services(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return entityresolution(
        "GET",
        "/providerservices",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_schema_mappings()
    list_schema_mappings(params::Dict{String,<:Any})

Returns a list of all the SchemaMappings that have been created for an Amazon Web Services
account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of objects returned per page.
- `"nextToken"`: The pagination token from the previous API call.
"""
function list_schema_mappings(; aws_config::AbstractAWSConfig=current_aws_config())
    return entityresolution(
        "GET", "/schemas"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_schema_mappings(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return entityresolution(
        "GET", "/schemas", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Displays the tags associated with an Entity Resolution resource. In Entity Resolution,
SchemaMapping, and MatchingWorkflow can be tagged.

# Arguments
- `resource_arn`: The ARN of the resource for which you want to view tags.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return entityresolution(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return entityresolution(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_policy(arn, policy)
    put_policy(arn, policy, params::Dict{String,<:Any})

Updates the resource-based policy.

# Arguments
- `arn`: The Amazon Resource Name (ARN) of the resource for which the policy needs to be
  updated.
- `policy`: The resource-based policy.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"token"`: A unique identifier for the current revision of the policy.
"""
function put_policy(arn, policy; aws_config::AbstractAWSConfig=current_aws_config())
    return entityresolution(
        "PUT",
        "/policies/$(arn)",
        Dict{String,Any}("policy" => policy);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_policy(
    arn,
    policy,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return entityresolution(
        "PUT",
        "/policies/$(arn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("policy" => policy), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_id_mapping_job(workflow_name)
    start_id_mapping_job(workflow_name, params::Dict{String,<:Any})

Starts the IdMappingJob of a workflow. The workflow must have previously been created using
the CreateIdMappingWorkflow endpoint.

# Arguments
- `workflow_name`: The name of the ID mapping job to be retrieved.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"outputSourceConfig"`: A list of OutputSource objects.
"""
function start_id_mapping_job(
    workflowName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return entityresolution(
        "POST",
        "/idmappingworkflows/$(workflowName)/jobs";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_id_mapping_job(
    workflowName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return entityresolution(
        "POST",
        "/idmappingworkflows/$(workflowName)/jobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_matching_job(workflow_name)
    start_matching_job(workflow_name, params::Dict{String,<:Any})

Starts the MatchingJob of a workflow. The workflow must have previously been created using
the CreateMatchingWorkflow endpoint.

# Arguments
- `workflow_name`: The name of the matching job to be retrieved.

"""
function start_matching_job(
    workflowName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return entityresolution(
        "POST",
        "/matchingworkflows/$(workflowName)/jobs";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_matching_job(
    workflowName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return entityresolution(
        "POST",
        "/matchingworkflows/$(workflowName)/jobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Assigns one or more tags (key-value pairs) to the specified Entity Resolution resource.
Tags can help you organize and categorize your resources. You can also use them to scope
user permissions by granting a user permission to access or change only resources with
certain tag values. In Entity Resolution, SchemaMapping and MatchingWorkflow can be tagged.
Tags don't have any semantic meaning to Amazon Web Services and are interpreted strictly as
strings of characters. You can use the TagResource action with a resource that already has
tags. If you specify a new tag key, this tag is appended to the list of tags associated
with the resource. If you specify a tag key that is already associated with the resource,
the new tag value that you specify replaces the previous value for that tag.

# Arguments
- `resource_arn`: The ARN of the resource for which you want to view tags.
- `tags`: The tags used to organize, track, or control access for this resource.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return entityresolution(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return entityresolution(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes one or more tags from the specified Entity Resolution resource. In Entity
Resolution, SchemaMapping, and MatchingWorkflow can be tagged.

# Arguments
- `resource_arn`: The ARN of the resource for which you want to untag.
- `tag_keys`: The list of tag keys to remove from the resource.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return entityresolution(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return entityresolution(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_id_mapping_workflow(id_mapping_techniques, input_source_config, role_arn, workflow_name)
    update_id_mapping_workflow(id_mapping_techniques, input_source_config, role_arn, workflow_name, params::Dict{String,<:Any})

Updates an existing IdMappingWorkflow. This method is identical to CreateIdMappingWorkflow,
except it uses an HTTP PUT request instead of a POST request, and the IdMappingWorkflow
must already exist for the method to succeed.

# Arguments
- `id_mapping_techniques`: An object which defines the idMappingType and the
  providerProperties.
- `input_source_config`: A list of InputSource objects, which have the fields
  InputSourceARN and SchemaName.
- `role_arn`: The Amazon Resource Name (ARN) of the IAM role. Entity Resolution assumes
  this role to access Amazon Web Services resources on your behalf.
- `workflow_name`: The name of the workflow.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A description of the workflow.
- `"outputSourceConfig"`: A list of OutputSource objects, each of which contains fields
  OutputS3Path and KMSArn.
"""
function update_id_mapping_workflow(
    idMappingTechniques,
    inputSourceConfig,
    roleArn,
    workflowName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return entityresolution(
        "PUT",
        "/idmappingworkflows/$(workflowName)",
        Dict{String,Any}(
            "idMappingTechniques" => idMappingTechniques,
            "inputSourceConfig" => inputSourceConfig,
            "roleArn" => roleArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_id_mapping_workflow(
    idMappingTechniques,
    inputSourceConfig,
    roleArn,
    workflowName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return entityresolution(
        "PUT",
        "/idmappingworkflows/$(workflowName)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "idMappingTechniques" => idMappingTechniques,
                    "inputSourceConfig" => inputSourceConfig,
                    "roleArn" => roleArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_id_namespace(id_namespace_name)
    update_id_namespace(id_namespace_name, params::Dict{String,<:Any})

Updates an existing ID namespace.

# Arguments
- `id_namespace_name`: The name of the ID namespace.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description of the ID namespace.
- `"idMappingWorkflowProperties"`: Determines the properties of IdMappingWorkflow where
  this IdNamespace can be used as a Source or a Target.
- `"inputSourceConfig"`: A list of InputSource objects, which have the fields
  InputSourceARN and SchemaName.
- `"roleArn"`: The Amazon Resource Name (ARN) of the IAM role. Entity Resolution assumes
  this role to access the resources defined in this IdNamespace on your behalf as part of a
  workflow run.
"""
function update_id_namespace(
    idNamespaceName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return entityresolution(
        "PUT",
        "/idnamespaces/$(idNamespaceName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_id_namespace(
    idNamespaceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return entityresolution(
        "PUT",
        "/idnamespaces/$(idNamespaceName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_matching_workflow(input_source_config, output_source_config, resolution_techniques, role_arn, workflow_name)
    update_matching_workflow(input_source_config, output_source_config, resolution_techniques, role_arn, workflow_name, params::Dict{String,<:Any})

Updates an existing MatchingWorkflow. This method is identical to CreateMatchingWorkflow,
except it uses an HTTP PUT request instead of a POST request, and the MatchingWorkflow must
already exist for the method to succeed.

# Arguments
- `input_source_config`: A list of InputSource objects, which have the fields
  InputSourceARN and SchemaName.
- `output_source_config`: A list of OutputSource objects, each of which contains fields
  OutputS3Path, ApplyNormalization, and Output.
- `resolution_techniques`: An object which defines the resolutionType and the
  ruleBasedProperties.
- `role_arn`: The Amazon Resource Name (ARN) of the IAM role. Entity Resolution assumes
  this role to create resources on your behalf as part of workflow execution.
- `workflow_name`: The name of the workflow to be retrieved.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A description of the workflow.
- `"incrementalRunConfig"`: An object which defines an incremental run type and has only
  incrementalRunType as a field.
"""
function update_matching_workflow(
    inputSourceConfig,
    outputSourceConfig,
    resolutionTechniques,
    roleArn,
    workflowName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return entityresolution(
        "PUT",
        "/matchingworkflows/$(workflowName)",
        Dict{String,Any}(
            "inputSourceConfig" => inputSourceConfig,
            "outputSourceConfig" => outputSourceConfig,
            "resolutionTechniques" => resolutionTechniques,
            "roleArn" => roleArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_matching_workflow(
    inputSourceConfig,
    outputSourceConfig,
    resolutionTechniques,
    roleArn,
    workflowName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return entityresolution(
        "PUT",
        "/matchingworkflows/$(workflowName)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "inputSourceConfig" => inputSourceConfig,
                    "outputSourceConfig" => outputSourceConfig,
                    "resolutionTechniques" => resolutionTechniques,
                    "roleArn" => roleArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_schema_mapping(mapped_input_fields, schema_name)
    update_schema_mapping(mapped_input_fields, schema_name, params::Dict{String,<:Any})

Updates a schema mapping.  A schema is immutable if it is being used by a workflow.
Therefore, you can't update a schema mapping if it's associated with a workflow.

# Arguments
- `mapped_input_fields`: A list of MappedInputFields. Each MappedInputField corresponds to
  a column the source data table, and contains column name plus additional information that
  Entity Resolution uses for matching.
- `schema_name`: The name of the schema. There can't be multiple SchemaMappings with the
  same name.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A description of the schema.
"""
function update_schema_mapping(
    mappedInputFields, schemaName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return entityresolution(
        "PUT",
        "/schemas/$(schemaName)",
        Dict{String,Any}("mappedInputFields" => mappedInputFields);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_schema_mapping(
    mappedInputFields,
    schemaName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return entityresolution(
        "PUT",
        "/schemas/$(schemaName)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("mappedInputFields" => mappedInputFields), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: route_53
using AWS.Compat
using AWS.UUIDs

"""
    activate_key_signing_key(hosted_zone_id, name)
    activate_key_signing_key(hosted_zone_id, name, params::Dict{String,<:Any})

Activates a key-signing key (KSK) so that it can be used for signing by DNSSEC. This
operation changes the KSK status to ACTIVE.

# Arguments
- `hosted_zone_id`: A unique string used to identify a hosted zone.
- `name`: A string used to identify a key-signing key (KSK). Name can include numbers,
  letters, and underscores (_). Name must be unique for each key-signing key in the same
  hosted zone.

"""
function activate_key_signing_key(
    HostedZoneId, Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "POST",
        "/2013-04-01/keysigningkey/$(HostedZoneId)/$(Name)/activate";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function activate_key_signing_key(
    HostedZoneId,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53(
        "POST",
        "/2013-04-01/keysigningkey/$(HostedZoneId)/$(Name)/activate",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_vpcwith_hosted_zone(id, vpc)
    associate_vpcwith_hosted_zone(id, vpc, params::Dict{String,<:Any})

Associates an Amazon VPC with a private hosted zone.   To perform the association, the VPC
and the private hosted zone must already exist. You can't convert a public hosted zone into
a private hosted zone.   If you want to associate a VPC that was created by using one
Amazon Web Services account with a private hosted zone that was created by using a
different account, the Amazon Web Services account that created the private hosted zone
must first submit a CreateVPCAssociationAuthorization request. Then the account that
created the VPC must submit an AssociateVPCWithHostedZone request.   When granting access,
the hosted zone and the Amazon VPC must belong to the same partition. A partition is a
group of Amazon Web Services Regions. Each Amazon Web Services account is scoped to one
partition. The following are the supported partitions:    aws - Amazon Web Services Regions
   aws-cn - China Regions    aws-us-gov - Amazon Web Services GovCloud (US) Region   For
more information, see Access Management in the Amazon Web Services General Reference.

# Arguments
- `id`: The ID of the private hosted zone that you want to associate an Amazon VPC with.
  Note that you can't associate a VPC with a hosted zone that doesn't have an existing VPC
  association.
- `vpc`: A complex type that contains information about the VPC that you want to associate
  with a private hosted zone.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Comment"`:  Optional: A comment about the association request.
"""
function associate_vpcwith_hosted_zone(
    Id, VPC; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "POST",
        "/2013-04-01/hostedzone/$(Id)/associatevpc",
        Dict{String,Any}("VPC" => VPC);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_vpcwith_hosted_zone(
    Id,
    VPC,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53(
        "POST",
        "/2013-04-01/hostedzone/$(Id)/associatevpc",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("VPC" => VPC), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    change_cidr_collection(changes, cidr_collection_id)
    change_cidr_collection(changes, cidr_collection_id, params::Dict{String,<:Any})

Creates, changes, or deletes CIDR blocks within a collection. Contains authoritative IP
information mapping blocks to one or multiple locations. A change request can update
multiple locations in a collection at a time, which is helpful if you want to move one or
more CIDR blocks from one location to another in one transaction, without downtime.
Limits  The max number of CIDR blocks included in the request is 1000. As a result, big
updates require multiple API calls.   PUT and DELETE_IF_EXISTS  Use ChangeCidrCollection to
perform the following actions:    PUT: Create a CIDR block within the specified collection.
    DELETE_IF_EXISTS: Delete an existing CIDR block from the collection.

# Arguments
- `changes`:  Information about changes to a CIDR collection.
- `cidr_collection_id`: The UUID of the CIDR collection to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CollectionVersion"`: A sequential counter that Amazon Route 53 sets to 1 when you
  create a collection and increments it by 1 each time you update the collection. We
  recommend that you use ListCidrCollection to get the current value of CollectionVersion for
  the collection that you want to update, and then include that value with the change
  request. This prevents Route 53 from overwriting an intervening update:    If the value in
  the request matches the value of CollectionVersion in the collection, Route 53 updates the
  collection.   If the value of CollectionVersion in the collection is greater than the value
  in the request, the collection was changed after you got the version number. Route 53 does
  not update the collection, and it returns a CidrCollectionVersionMismatch error.
"""
function change_cidr_collection(
    Changes, CidrCollectionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "POST",
        "/2013-04-01/cidrcollection/$(CidrCollectionId)",
        Dict{String,Any}("Changes" => Changes);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function change_cidr_collection(
    Changes,
    CidrCollectionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53(
        "POST",
        "/2013-04-01/cidrcollection/$(CidrCollectionId)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Changes" => Changes), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    change_resource_record_sets(change_batch, id)
    change_resource_record_sets(change_batch, id, params::Dict{String,<:Any})

Creates, changes, or deletes a resource record set, which contains authoritative DNS
information for a specified domain name or subdomain name. For example, you can use
ChangeResourceRecordSets to create a resource record set that routes traffic for
test.example.com to a web server that has an IP address of 192.0.2.44.  Deleting Resource
Record Sets  To delete a resource record set, you must specify all the same values that you
specified when you created it.  Change Batches and Transactional Changes  The request body
must include a document with a ChangeResourceRecordSetsRequest element. The request body
contains a list of change items, known as a change batch. Change batches are considered
transactional changes. Route 53 validates the changes in the request and then either makes
all or none of the changes in the change batch request. This ensures that DNS routing isn't
adversely affected by partial changes to the resource record sets in a hosted zone.  For
example, suppose a change batch request contains two changes: it deletes the CNAME resource
record set for www.example.com and creates an alias resource record set for
www.example.com. If validation for both records succeeds, Route 53 deletes the first
resource record set and creates the second resource record set in a single operation. If
validation for either the DELETE or the CREATE action fails, then the request is canceled,
and the original CNAME record continues to exist.  If you try to delete the same resource
record set more than once in a single change batch, Route 53 returns an InvalidChangeBatch
error.   Traffic Flow  To create resource record sets for complex routing configurations,
use either the traffic flow visual editor in the Route 53 console or the API actions for
traffic policies and traffic policy instances. Save the configuration as a traffic policy,
then associate the traffic policy with one or more domain names (such as example.com) or
subdomain names (such as www.example.com), in the same hosted zone or in multiple hosted
zones. You can roll back the updates if the new configuration isn't performing as expected.
For more information, see Using Traffic Flow to Route DNS Traffic in the Amazon Route 53
Developer Guide.  Create, Delete, and Upsert  Use ChangeResourceRecordsSetsRequest to
perform the following actions:    CREATE: Creates a resource record set that has the
specified values.    DELETE: Deletes an existing resource record set that has the specified
values.    UPSERT: If a resource set doesn't exist, Route 53 creates it. If a resource set
exists Route 53 updates it with the values in the request.     Syntaxes for Creating,
Updating, and Deleting Resource Record Sets  The syntax for a request depends on the type
of resource record set that you want to create, delete, or update, such as weighted, alias,
or failover. The XML elements in your request must appear in the order listed in the
syntax.  For an example for each type of resource record set, see \"Examples.\" Don't refer
to the syntax in the \"Parameter Syntax\" section, which includes all of the elements for
every kind of resource record set that you can create, delete, or update by using
ChangeResourceRecordSets.   Change Propagation to Route 53 DNS Servers  When you submit a
ChangeResourceRecordSets request, Route 53 propagates your changes to all of the Route 53
authoritative DNS servers managing the hosted zone. While your changes are propagating,
GetChange returns a status of PENDING. When propagation is complete, GetChange returns a
status of INSYNC. Changes generally propagate to all Route 53 name servers managing the
hosted zone within 60 seconds. For more information, see GetChange.  Limits on
ChangeResourceRecordSets Requests  For information about the limits on a
ChangeResourceRecordSets request, see Limits in the Amazon Route 53 Developer Guide.

# Arguments
- `change_batch`: A complex type that contains an optional comment and the Changes element.
- `id`: The ID of the hosted zone that contains the resource record sets that you want to
  change.

"""
function change_resource_record_sets(
    ChangeBatch, Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "POST",
        "/2013-04-01/hostedzone/$(Id)/rrset/",
        Dict{String,Any}("ChangeBatch" => ChangeBatch);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function change_resource_record_sets(
    ChangeBatch,
    Id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53(
        "POST",
        "/2013-04-01/hostedzone/$(Id)/rrset/",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ChangeBatch" => ChangeBatch), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    change_tags_for_resource(resource_id, resource_type)
    change_tags_for_resource(resource_id, resource_type, params::Dict{String,<:Any})

Adds, edits, or deletes tags for a health check or a hosted zone. For information about
using tags for cost allocation, see Using Cost Allocation Tags in the Billing and Cost
Management User Guide.

# Arguments
- `resource_id`: The ID of the resource for which you want to add, change, or delete tags.
- `resource_type`: The type of the resource.   The resource type for health checks is
  healthcheck.   The resource type for hosted zones is hostedzone.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AddTags"`: A complex type that contains a list of the tags that you want to add to the
  specified health check or hosted zone and/or the tags that you want to edit Value for. You
  can add a maximum of 10 tags to a health check or a hosted zone.
- `"RemoveTagKeys"`: A complex type that contains a list of the tags that you want to
  delete from the specified health check or hosted zone. You can specify up to 10 keys.
"""
function change_tags_for_resource(
    ResourceId, ResourceType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "POST",
        "/2013-04-01/tags/$(ResourceType)/$(ResourceId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function change_tags_for_resource(
    ResourceId,
    ResourceType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53(
        "POST",
        "/2013-04-01/tags/$(ResourceType)/$(ResourceId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_cidr_collection(caller_reference, name)
    create_cidr_collection(caller_reference, name, params::Dict{String,<:Any})

Creates a CIDR collection in the current Amazon Web Services account.

# Arguments
- `caller_reference`: A client-specific token that allows requests to be securely retried
  so that the intended outcome will only occur once, retries receive a similar response, and
  there are no additional edge cases to handle.
- `name`: A unique identifier for the account that can be used to reference the collection
  from other API calls.

"""
function create_cidr_collection(
    CallerReference, Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "POST",
        "/2013-04-01/cidrcollection",
        Dict{String,Any}("CallerReference" => CallerReference, "Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_cidr_collection(
    CallerReference,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53(
        "POST",
        "/2013-04-01/cidrcollection",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("CallerReference" => CallerReference, "Name" => Name),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_health_check(caller_reference, health_check_config)
    create_health_check(caller_reference, health_check_config, params::Dict{String,<:Any})

Creates a new health check. For information about adding health checks to resource record
sets, see HealthCheckId in ChangeResourceRecordSets.   ELB Load Balancers  If you're
registering EC2 instances with an Elastic Load Balancing (ELB) load balancer, do not create
Amazon Route 53 health checks for the EC2 instances. When you register an EC2 instance with
a load balancer, you configure settings for an ELB health check, which performs a similar
function to a Route 53 health check.  Private Hosted Zones  You can associate health checks
with failover resource record sets in a private hosted zone. Note the following:   Route 53
health checkers are outside the VPC. To check the health of an endpoint within a VPC by IP
address, you must assign a public IP address to the instance in the VPC.   You can
configure a health checker to check the health of an external resource that the instance
relies on, such as a database server.   You can create a CloudWatch metric, associate an
alarm with the metric, and then create a health check that is based on the state of the
alarm. For example, you might create a CloudWatch metric that checks the status of the
Amazon EC2 StatusCheckFailed metric, add an alarm to the metric, and then create a health
check that is based on the state of the alarm. For information about creating CloudWatch
metrics and alarms by using the CloudWatch console, see the Amazon CloudWatch User Guide.

# Arguments
- `caller_reference`: A unique string that identifies the request and that allows you to
  retry a failed CreateHealthCheck request without the risk of creating two identical health
  checks:   If you send a CreateHealthCheck request with the same CallerReference and
  settings as a previous request, and if the health check doesn't exist, Amazon Route 53
  creates the health check. If the health check does exist, Route 53 returns the settings for
  the existing health check.   If you send a CreateHealthCheck request with the same
  CallerReference as a deleted health check, regardless of the settings, Route 53 returns a
  HealthCheckAlreadyExists error.   If you send a CreateHealthCheck request with the same
  CallerReference as an existing health check but with different settings, Route 53 returns a
  HealthCheckAlreadyExists error.   If you send a CreateHealthCheck request with a unique
  CallerReference but settings identical to an existing health check, Route 53 creates the
  health check.    Route 53 does not store the CallerReference for a deleted health check
  indefinitely. The CallerReference for a deleted health check will be deleted after a number
  of days.
- `health_check_config`: A complex type that contains settings for a new health check.

"""
function create_health_check(
    CallerReference, HealthCheckConfig; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "POST",
        "/2013-04-01/healthcheck",
        Dict{String,Any}(
            "CallerReference" => CallerReference, "HealthCheckConfig" => HealthCheckConfig
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_health_check(
    CallerReference,
    HealthCheckConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53(
        "POST",
        "/2013-04-01/healthcheck",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CallerReference" => CallerReference,
                    "HealthCheckConfig" => HealthCheckConfig,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_hosted_zone(caller_reference, name)
    create_hosted_zone(caller_reference, name, params::Dict{String,<:Any})

Creates a new public or private hosted zone. You create records in a public hosted zone to
define how you want to route traffic on the internet for a domain, such as example.com, and
its subdomains (apex.example.com, acme.example.com). You create records in a private hosted
zone to define how you want to route traffic for a domain and its subdomains within one or
more Amazon Virtual Private Clouds (Amazon VPCs).   You can't convert a public hosted zone
to a private hosted zone or vice versa. Instead, you must create a new hosted zone with the
same name and create new resource record sets.  For more information about charges for
hosted zones, see Amazon Route 53 Pricing. Note the following:   You can't create a hosted
zone for a top-level domain (TLD) such as .com.   For public hosted zones, Route 53
automatically creates a default SOA record and four NS records for the zone. For more
information about SOA and NS records, see NS and SOA Records that Route 53 Creates for a
Hosted Zone in the Amazon Route 53 Developer Guide. If you want to use the same name
servers for multiple public hosted zones, you can optionally associate a reusable
delegation set with the hosted zone. See the DelegationSetId element.   If your domain is
registered with a registrar other than Route 53, you must update the name servers with
your registrar to make Route 53 the DNS service for the domain. For more information, see
Migrating DNS Service for an Existing Domain to Amazon Route 53 in the Amazon Route 53
Developer Guide.    When you submit a CreateHostedZone request, the initial status of the
hosted zone is PENDING. For public hosted zones, this means that the NS and SOA records are
not yet available on all Route 53 DNS servers. When the NS and SOA records are available,
the status of the zone changes to INSYNC. The CreateHostedZone request requires the caller
to have an ec2:DescribeVpcs permission.  When creating private hosted zones, the Amazon VPC
must belong to the same partition where the hosted zone is created. A partition is a group
of Amazon Web Services Regions. Each Amazon Web Services account is scoped to one
partition. The following are the supported partitions:    aws - Amazon Web Services Regions
   aws-cn - China Regions    aws-us-gov - Amazon Web Services GovCloud (US) Region   For
more information, see Access Management in the Amazon Web Services General Reference.

# Arguments
- `caller_reference`: A unique string that identifies the request and that allows failed
  CreateHostedZone requests to be retried without the risk of executing the operation twice.
  You must use a unique CallerReference string every time you submit a CreateHostedZone
  request. CallerReference can be any unique string, for example, a date/time stamp.
- `name`: The name of the domain. Specify a fully qualified domain name, for example,
  www.example.com. The trailing dot is optional; Amazon Route 53 assumes that the domain
  name is fully qualified. This means that Route 53 treats www.example.com (without a
  trailing dot) and www.example.com. (with a trailing dot) as identical. If you're creating a
  public hosted zone, this is the name you have registered with your DNS registrar. If your
  domain name is registered with a registrar other than Route 53, change the name servers
  for your domain to the set of NameServers that CreateHostedZone returns in DelegationSet.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DelegationSetId"`: If you want to associate a reusable delegation set with this hosted
  zone, the ID that Amazon Route 53 assigned to the reusable delegation set when you created
  it. For more information about reusable delegation sets, see CreateReusableDelegationSet.
  If you are using a reusable delegation set to create a public hosted zone for a subdomain,
  make sure that the parent hosted zone doesn't use one or more of the same name servers. If
  you have overlapping nameservers, the operation will cause a ConflictingDomainsExist error.
- `"HostedZoneConfig"`: (Optional) A complex type that contains the following optional
  values:   For public and private hosted zones, an optional comment   For private hosted
  zones, an optional PrivateZone element   If you don't specify a comment or the PrivateZone
  element, omit HostedZoneConfig and the other elements.
- `"VPC"`: (Private hosted zones only) A complex type that contains information about the
  Amazon VPC that you're associating with this hosted zone. You can specify only one Amazon
  VPC when you create a private hosted zone. If you are associating a VPC with a hosted zone
  with this request, the paramaters VPCId and VPCRegion are also required. To associate
  additional Amazon VPCs with the hosted zone, use AssociateVPCWithHostedZone after you
  create a hosted zone.
"""
function create_hosted_zone(
    CallerReference, Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "POST",
        "/2013-04-01/hostedzone",
        Dict{String,Any}("CallerReference" => CallerReference, "Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_hosted_zone(
    CallerReference,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53(
        "POST",
        "/2013-04-01/hostedzone",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("CallerReference" => CallerReference, "Name" => Name),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_key_signing_key(caller_reference, hosted_zone_id, key_management_service_arn, name, status)
    create_key_signing_key(caller_reference, hosted_zone_id, key_management_service_arn, name, status, params::Dict{String,<:Any})

Creates a new key-signing key (KSK) associated with a hosted zone. You can only have two
KSKs per hosted zone.

# Arguments
- `caller_reference`: A unique string that identifies the request.
- `hosted_zone_id`: The unique string (ID) used to identify a hosted zone.
- `key_management_service_arn`: The Amazon resource name (ARN) for a customer managed key
  in Key Management Service (KMS). The KeyManagementServiceArn must be unique for each
  key-signing key (KSK) in a single hosted zone. To see an example of KeyManagementServiceArn
  that grants the correct permissions for DNSSEC, scroll down to Example.  You must configure
  the customer managed customer managed key as follows:  Status  Enabled  Key spec
  ECC_NIST_P256  Key usage  Sign and verify  Key policy  The key policy must give permission
  for the following actions:   DescribeKey   GetPublicKey   Sign   The key policy must also
  include the Amazon Route 53 service in the principal for your account. Specify the
  following:    \"Service\": \"dnssec-route53.amazonaws.com\"      For more information about
  working with a customer managed key in KMS, see Key Management Service concepts.
- `name`: A string used to identify a key-signing key (KSK). Name can include numbers,
  letters, and underscores (_). Name must be unique for each key-signing key in the same
  hosted zone.
- `status`: A string specifying the initial status of the key-signing key (KSK). You can
  set the value to ACTIVE or INACTIVE.

"""
function create_key_signing_key(
    CallerReference,
    HostedZoneId,
    KeyManagementServiceArn,
    Name,
    Status;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53(
        "POST",
        "/2013-04-01/keysigningkey",
        Dict{String,Any}(
            "CallerReference" => CallerReference,
            "HostedZoneId" => HostedZoneId,
            "KeyManagementServiceArn" => KeyManagementServiceArn,
            "Name" => Name,
            "Status" => Status,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_key_signing_key(
    CallerReference,
    HostedZoneId,
    KeyManagementServiceArn,
    Name,
    Status,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53(
        "POST",
        "/2013-04-01/keysigningkey",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CallerReference" => CallerReference,
                    "HostedZoneId" => HostedZoneId,
                    "KeyManagementServiceArn" => KeyManagementServiceArn,
                    "Name" => Name,
                    "Status" => Status,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_query_logging_config(cloud_watch_logs_log_group_arn, hosted_zone_id)
    create_query_logging_config(cloud_watch_logs_log_group_arn, hosted_zone_id, params::Dict{String,<:Any})

Creates a configuration for DNS query logging. After you create a query logging
configuration, Amazon Route 53 begins to publish log data to an Amazon CloudWatch Logs log
group. DNS query logs contain information about the queries that Route 53 receives for a
specified public hosted zone, such as the following:   Route 53 edge location that
responded to the DNS query   Domain or subdomain that was requested   DNS record type, such
as A or AAAA   DNS response code, such as NoError or ServFail     Log Group and Resource
Policy  Before you create a query logging configuration, perform the following operations.
If you create a query logging configuration using the Route 53 console, Route 53 performs
these operations automatically.    Create a CloudWatch Logs log group, and make note of the
ARN, which you specify when you create a query logging configuration. Note the following:
You must create the log group in the us-east-1 region.   You must use the same Amazon Web
Services account to create the log group and the hosted zone that you want to configure
query logging for.   When you create log groups for query logging, we recommend that you
use a consistent prefix, for example:  /aws/route53/hosted zone name   In the next step,
you'll create a resource policy, which controls access to one or more log groups and the
associated Amazon Web Services resources, such as Route 53 hosted zones. There's a limit on
the number of resource policies that you can create, so we recommend that you use a
consistent prefix so you can use the same resource policy for all the log groups that you
create for query logging.     Create a CloudWatch Logs resource policy, and give it the
permissions that Route 53 needs to create log streams and to send query logs to log
streams. For the value of Resource, specify the ARN for the log group that you created in
the previous step. To use the same resource policy for all the CloudWatch Logs log groups
that you created for query logging configurations, replace the hosted zone name with *, for
example:  arn:aws:logs:us-east-1:123412341234:log-group:/aws/route53/*  To avoid the
confused deputy problem, a security issue where an entity without a permission for an
action can coerce a more-privileged entity to perform it, you can optionally limit the
permissions that a service has to a resource in a resource-based policy by supplying the
following values:   For aws:SourceArn, supply the hosted zone ARN used in creating the
query logging configuration. For example, aws:SourceArn:
arn:aws:route53:::hostedzone/hosted zone ID.   For aws:SourceAccount, supply the account ID
for the account that creates the query logging configuration. For example,
aws:SourceAccount:111111111111.   For more information, see The confused deputy problem in
the Amazon Web Services IAM User Guide.  You can't use the CloudWatch console to create or
edit a resource policy. You must use the CloudWatch API, one of the Amazon Web Services
SDKs, or the CLI.     Log Streams and Edge Locations  When Route 53 finishes creating the
configuration for DNS query logging, it does the following:   Creates a log stream for an
edge location the first time that the edge location responds to DNS queries for the
specified hosted zone. That log stream is used to log all queries that Route 53 responds to
for that edge location.   Begins to send query logs to the applicable log stream.   The
name of each log stream is in the following format:   hosted zone ID/edge location code
The edge location code is a three-letter code and an arbitrarily assigned number, for
example, DFW3. The three-letter code typically corresponds with the International Air
Transport Association airport code for an airport near the edge location. (These
abbreviations might change in the future.) For a list of edge locations, see \"The Route 53
Global Network\" on the Route 53 Product Details page.  Queries That Are Logged  Query logs
contain only the queries that DNS resolvers forward to Route 53. If a DNS resolver has
already cached the response to a query (such as the IP address for a load balancer for
example.com), the resolver will continue to return the cached response. It doesn't forward
another query to Route 53 until the TTL for the corresponding resource record set expires.
Depending on how many DNS queries are submitted for a resource record set, and depending on
the TTL for that resource record set, query logs might contain information about only one
query out of every several thousand queries that are submitted to DNS. For more information
about how DNS works, see Routing Internet Traffic to Your Website or Web Application in the
Amazon Route 53 Developer Guide.  Log File Format  For a list of the values in each query
log and the format of each value, see Logging DNS Queries in the Amazon Route 53 Developer
Guide.  Pricing  For information about charges for query logs, see Amazon CloudWatch
Pricing.  How to Stop Logging  If you want Route 53 to stop sending query logs to
CloudWatch Logs, delete the query logging configuration. For more information, see
DeleteQueryLoggingConfig.

# Arguments
- `cloud_watch_logs_log_group_arn`: The Amazon Resource Name (ARN) for the log group that
  you want to Amazon Route 53 to send query logs to. This is the format of the ARN:
  arn:aws:logs:region:account-id:log-group:log_group_name  To get the ARN for a log group,
  you can use the CloudWatch console, the DescribeLogGroups API action, the
  describe-log-groups command, or the applicable command in one of the Amazon Web Services
  SDKs.
- `hosted_zone_id`: The ID of the hosted zone that you want to log queries for. You can log
  queries only for public hosted zones.

"""
function create_query_logging_config(
    CloudWatchLogsLogGroupArn,
    HostedZoneId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53(
        "POST",
        "/2013-04-01/queryloggingconfig",
        Dict{String,Any}(
            "CloudWatchLogsLogGroupArn" => CloudWatchLogsLogGroupArn,
            "HostedZoneId" => HostedZoneId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_query_logging_config(
    CloudWatchLogsLogGroupArn,
    HostedZoneId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53(
        "POST",
        "/2013-04-01/queryloggingconfig",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CloudWatchLogsLogGroupArn" => CloudWatchLogsLogGroupArn,
                    "HostedZoneId" => HostedZoneId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_reusable_delegation_set(caller_reference)
    create_reusable_delegation_set(caller_reference, params::Dict{String,<:Any})

Creates a delegation set (a group of four name servers) that can be reused by multiple
hosted zones that were created by the same Amazon Web Services account.  You can also
create a reusable delegation set that uses the four name servers that are associated with
an existing hosted zone. Specify the hosted zone ID in the CreateReusableDelegationSet
request.  You can't associate a reusable delegation set with a private hosted zone.  For
information about using a reusable delegation set to configure white label name servers,
see Configuring White Label Name Servers. The process for migrating existing hosted zones
to use a reusable delegation set is comparable to the process for configuring white label
name servers. You need to perform the following steps:   Create a reusable delegation set.
 Recreate hosted zones, and reduce the TTL to 60 seconds or less.   Recreate resource
record sets in the new hosted zones.   Change the registrar's name servers to use the name
servers for the new hosted zones.   Monitor traffic for the website or application.
Change TTLs back to their original values.   If you want to migrate existing hosted zones
to use a reusable delegation set, the existing hosted zones can't use any of the name
servers that are assigned to the reusable delegation set. If one or more hosted zones do
use one or more name servers that are assigned to the reusable delegation set, you can do
one of the following:   For small numbers of hosted zones—up to a few hundred—it's
relatively easy to create reusable delegation sets until you get one that has four name
servers that don't overlap with any of the name servers in your hosted zones.   For larger
numbers of hosted zones, the easiest solution is to use more than one reusable delegation
set.   For larger numbers of hosted zones, you can also migrate hosted zones that have
overlapping name servers to hosted zones that don't have overlapping name servers, then
migrate the hosted zones again to use the reusable delegation set.

# Arguments
- `caller_reference`: A unique string that identifies the request, and that allows you to
  retry failed CreateReusableDelegationSet requests without the risk of executing the
  operation twice. You must use a unique CallerReference string every time you submit a
  CreateReusableDelegationSet request. CallerReference can be any unique string, for example
  a date/time stamp.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"HostedZoneId"`: If you want to mark the delegation set for an existing hosted zone as
  reusable, the ID for that hosted zone.
"""
function create_reusable_delegation_set(
    CallerReference; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "POST",
        "/2013-04-01/delegationset",
        Dict{String,Any}("CallerReference" => CallerReference);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_reusable_delegation_set(
    CallerReference,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53(
        "POST",
        "/2013-04-01/delegationset",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("CallerReference" => CallerReference), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_traffic_policy(document, name)
    create_traffic_policy(document, name, params::Dict{String,<:Any})

Creates a traffic policy, which you use to create multiple DNS resource record sets for one
domain name (such as example.com) or one subdomain name (such as www.example.com).

# Arguments
- `document`: The definition of this traffic policy in JSON format. For more information,
  see Traffic Policy Document Format.
- `name`: The name of the traffic policy.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Comment"`: (Optional) Any comments that you want to include about the traffic policy.
"""
function create_traffic_policy(
    Document, Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "POST",
        "/2013-04-01/trafficpolicy",
        Dict{String,Any}("Document" => Document, "Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_traffic_policy(
    Document,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53(
        "POST",
        "/2013-04-01/trafficpolicy",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("Document" => Document, "Name" => Name), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_traffic_policy_instance(hosted_zone_id, name, ttl, traffic_policy_id, traffic_policy_version)
    create_traffic_policy_instance(hosted_zone_id, name, ttl, traffic_policy_id, traffic_policy_version, params::Dict{String,<:Any})

Creates resource record sets in a specified hosted zone based on the settings in a
specified traffic policy version. In addition, CreateTrafficPolicyInstance associates the
resource record sets with a specified domain name (such as example.com) or subdomain name
(such as www.example.com). Amazon Route 53 responds to DNS queries for the domain or
subdomain name by using the resource record sets that CreateTrafficPolicyInstance created.
After you submit an CreateTrafficPolicyInstance request, there's a brief delay while Amazon
Route 53 creates the resource record sets that are specified in the traffic policy
definition. Use GetTrafficPolicyInstance with the id of new traffic policy instance to
confirm that the CreateTrafficPolicyInstance request completed successfully. For more
information, see the State response element.

# Arguments
- `hosted_zone_id`: The ID of the hosted zone that you want Amazon Route 53 to create
  resource record sets in by using the configuration in a traffic policy.
- `name`: The domain name (such as example.com) or subdomain name (such as www.example.com)
  for which Amazon Route 53 responds to DNS queries by using the resource record sets that
  Route 53 creates for this traffic policy instance.
- `ttl`: (Optional) The TTL that you want Amazon Route 53 to assign to all of the resource
  record sets that it creates in the specified hosted zone.
- `traffic_policy_id`: The ID of the traffic policy that you want to use to create resource
  record sets in the specified hosted zone.
- `traffic_policy_version`: The version of the traffic policy that you want to use to
  create resource record sets in the specified hosted zone.

"""
function create_traffic_policy_instance(
    HostedZoneId,
    Name,
    TTL,
    TrafficPolicyId,
    TrafficPolicyVersion;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53(
        "POST",
        "/2013-04-01/trafficpolicyinstance",
        Dict{String,Any}(
            "HostedZoneId" => HostedZoneId,
            "Name" => Name,
            "TTL" => TTL,
            "TrafficPolicyId" => TrafficPolicyId,
            "TrafficPolicyVersion" => TrafficPolicyVersion,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_traffic_policy_instance(
    HostedZoneId,
    Name,
    TTL,
    TrafficPolicyId,
    TrafficPolicyVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53(
        "POST",
        "/2013-04-01/trafficpolicyinstance",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "HostedZoneId" => HostedZoneId,
                    "Name" => Name,
                    "TTL" => TTL,
                    "TrafficPolicyId" => TrafficPolicyId,
                    "TrafficPolicyVersion" => TrafficPolicyVersion,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_traffic_policy_version(document, id)
    create_traffic_policy_version(document, id, params::Dict{String,<:Any})

Creates a new version of an existing traffic policy. When you create a new version of a
traffic policy, you specify the ID of the traffic policy that you want to update and a
JSON-formatted document that describes the new version. You use traffic policies to create
multiple DNS resource record sets for one domain name (such as example.com) or one
subdomain name (such as www.example.com). You can create a maximum of 1000 versions of a
traffic policy. If you reach the limit and need to create another version, you'll need to
start a new traffic policy.

# Arguments
- `document`: The definition of this version of the traffic policy, in JSON format. You
  specified the JSON in the CreateTrafficPolicyVersion request. For more information about
  the JSON format, see CreateTrafficPolicy.
- `id`: The ID of the traffic policy for which you want to create a new version.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Comment"`: The comment that you specified in the CreateTrafficPolicyVersion request, if
  any.
"""
function create_traffic_policy_version(
    Document, Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "POST",
        "/2013-04-01/trafficpolicy/$(Id)",
        Dict{String,Any}("Document" => Document);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_traffic_policy_version(
    Document,
    Id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53(
        "POST",
        "/2013-04-01/trafficpolicy/$(Id)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Document" => Document), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_vpcassociation_authorization(id, vpc)
    create_vpcassociation_authorization(id, vpc, params::Dict{String,<:Any})

Authorizes the Amazon Web Services account that created a specified VPC to submit an
AssociateVPCWithHostedZone request to associate the VPC with a specified hosted zone that
was created by a different account. To submit a CreateVPCAssociationAuthorization request,
you must use the account that created the hosted zone. After you authorize the association,
use the account that created the VPC to submit an AssociateVPCWithHostedZone request.  If
you want to associate multiple VPCs that you created by using one account with a hosted
zone that you created by using a different account, you must submit one authorization
request for each VPC.

# Arguments
- `id`: The ID of the private hosted zone that you want to authorize associating a VPC with.
- `vpc`: A complex type that contains the VPC ID and region for the VPC that you want to
  authorize associating with your hosted zone.

"""
function create_vpcassociation_authorization(
    Id, VPC; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "POST",
        "/2013-04-01/hostedzone/$(Id)/authorizevpcassociation",
        Dict{String,Any}("VPC" => VPC);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_vpcassociation_authorization(
    Id,
    VPC,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53(
        "POST",
        "/2013-04-01/hostedzone/$(Id)/authorizevpcassociation",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("VPC" => VPC), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    deactivate_key_signing_key(hosted_zone_id, name)
    deactivate_key_signing_key(hosted_zone_id, name, params::Dict{String,<:Any})

Deactivates a key-signing key (KSK) so that it will not be used for signing by DNSSEC. This
operation changes the KSK status to INACTIVE.

# Arguments
- `hosted_zone_id`: A unique string used to identify a hosted zone.
- `name`: A string used to identify a key-signing key (KSK).

"""
function deactivate_key_signing_key(
    HostedZoneId, Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "POST",
        "/2013-04-01/keysigningkey/$(HostedZoneId)/$(Name)/deactivate";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function deactivate_key_signing_key(
    HostedZoneId,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53(
        "POST",
        "/2013-04-01/keysigningkey/$(HostedZoneId)/$(Name)/deactivate",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_cidr_collection(cidr_collection_id)
    delete_cidr_collection(cidr_collection_id, params::Dict{String,<:Any})

Deletes a CIDR collection in the current Amazon Web Services account. The collection must
be empty before it can be deleted.

# Arguments
- `cidr_collection_id`: The UUID of the collection to delete.

"""
function delete_cidr_collection(
    CidrCollectionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "DELETE",
        "/2013-04-01/cidrcollection/$(CidrCollectionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_cidr_collection(
    CidrCollectionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53(
        "DELETE",
        "/2013-04-01/cidrcollection/$(CidrCollectionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_health_check(health_check_id)
    delete_health_check(health_check_id, params::Dict{String,<:Any})

Deletes a health check.  Amazon Route 53 does not prevent you from deleting a health check
even if the health check is associated with one or more resource record sets. If you delete
a health check and you don't update the associated resource record sets, the future status
of the health check can't be predicted and may change. This will affect the routing of DNS
queries for your DNS failover configuration. For more information, see Replacing and
Deleting Health Checks in the Amazon Route 53 Developer Guide.  If you're using Cloud Map
and you configured Cloud Map to create a Route 53 health check when you register an
instance, you can't use the Route 53 DeleteHealthCheck command to delete the health check.
The health check is deleted automatically when you deregister the instance; there can be a
delay of several hours before the health check is deleted from Route 53.

# Arguments
- `health_check_id`: The ID of the health check that you want to delete.

"""
function delete_health_check(
    HealthCheckId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "DELETE",
        "/2013-04-01/healthcheck/$(HealthCheckId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_health_check(
    HealthCheckId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53(
        "DELETE",
        "/2013-04-01/healthcheck/$(HealthCheckId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_hosted_zone(id)
    delete_hosted_zone(id, params::Dict{String,<:Any})

Deletes a hosted zone. If the hosted zone was created by another service, such as Cloud
Map, see Deleting Public Hosted Zones That Were Created by Another Service in the Amazon
Route 53 Developer Guide for information about how to delete it. (The process is the same
for public and private hosted zones that were created by another service.) If you want to
keep your domain registration but you want to stop routing internet traffic to your website
or web application, we recommend that you delete resource record sets in the hosted zone
instead of deleting the hosted zone.  If you delete a hosted zone, you can't undelete it.
You must create a new hosted zone and update the name servers for your domain registration,
which can require up to 48 hours to take effect. (If you delegated responsibility for a
subdomain to a hosted zone and you delete the child hosted zone, you must update the name
servers in the parent hosted zone.) In addition, if you delete a hosted zone, someone could
hijack the domain and route traffic to their own resources using your domain name.  If you
want to avoid the monthly charge for the hosted zone, you can transfer DNS service for the
domain to a free DNS service. When you transfer DNS service, you have to update the name
servers for the domain registration. If the domain is registered with Route 53, see
UpdateDomainNameservers for information about how to replace Route 53 name servers with
name servers for the new DNS service. If the domain is registered with another registrar,
use the method provided by the registrar to update name servers for the domain
registration. For more information, perform an internet search on \"free DNS service.\" You
can delete a hosted zone only if it contains only the default SOA record and NS resource
record sets. If the hosted zone contains other resource record sets, you must delete them
before you can delete the hosted zone. If you try to delete a hosted zone that contains
other resource record sets, the request fails, and Route 53 returns a HostedZoneNotEmpty
error. For information about deleting records from your hosted zone, see
ChangeResourceRecordSets. To verify that the hosted zone has been deleted, do one of the
following:   Use the GetHostedZone action to request information about the hosted zone.
Use the ListHostedZones action to get a list of the hosted zones associated with the
current Amazon Web Services account.

# Arguments
- `id`: The ID of the hosted zone you want to delete.

"""
function delete_hosted_zone(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return route_53(
        "DELETE",
        "/2013-04-01/hostedzone/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_hosted_zone(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "DELETE",
        "/2013-04-01/hostedzone/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_key_signing_key(hosted_zone_id, name)
    delete_key_signing_key(hosted_zone_id, name, params::Dict{String,<:Any})

Deletes a key-signing key (KSK). Before you can delete a KSK, you must deactivate it. The
KSK must be deactivated before you can delete it regardless of whether the hosted zone is
enabled for DNSSEC signing. You can use DeactivateKeySigningKey to deactivate the key
before you delete it. Use GetDNSSEC to verify that the KSK is in an INACTIVE status.

# Arguments
- `hosted_zone_id`: A unique string used to identify a hosted zone.
- `name`: A string used to identify a key-signing key (KSK).

"""
function delete_key_signing_key(
    HostedZoneId, Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "DELETE",
        "/2013-04-01/keysigningkey/$(HostedZoneId)/$(Name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_key_signing_key(
    HostedZoneId,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53(
        "DELETE",
        "/2013-04-01/keysigningkey/$(HostedZoneId)/$(Name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_query_logging_config(id)
    delete_query_logging_config(id, params::Dict{String,<:Any})

Deletes a configuration for DNS query logging. If you delete a configuration, Amazon Route
53 stops sending query logs to CloudWatch Logs. Route 53 doesn't delete any logs that are
already in CloudWatch Logs. For more information about DNS query logs, see
CreateQueryLoggingConfig.

# Arguments
- `id`: The ID of the configuration that you want to delete.

"""
function delete_query_logging_config(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return route_53(
        "DELETE",
        "/2013-04-01/queryloggingconfig/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_query_logging_config(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "DELETE",
        "/2013-04-01/queryloggingconfig/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_reusable_delegation_set(id)
    delete_reusable_delegation_set(id, params::Dict{String,<:Any})

Deletes a reusable delegation set.  You can delete a reusable delegation set only if it
isn't associated with any hosted zones.  To verify that the reusable delegation set is not
associated with any hosted zones, submit a GetReusableDelegationSet request and specify the
ID of the reusable delegation set that you want to delete.

# Arguments
- `id`: The ID of the reusable delegation set that you want to delete.

"""
function delete_reusable_delegation_set(
    Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "DELETE",
        "/2013-04-01/delegationset/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_reusable_delegation_set(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "DELETE",
        "/2013-04-01/delegationset/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_traffic_policy(id, version)
    delete_traffic_policy(id, version, params::Dict{String,<:Any})

Deletes a traffic policy. When you delete a traffic policy, Route 53 sets a flag on the
policy to indicate that it has been deleted. However, Route 53 never fully deletes the
traffic policy. Note the following:   Deleted traffic policies aren't listed if you run
ListTrafficPolicies.    There's no way to get a list of deleted policies.   If you retain
the ID of the policy, you can get information about the policy, including the traffic
policy document, by running GetTrafficPolicy.

# Arguments
- `id`: The ID of the traffic policy that you want to delete.
- `version`: The version number of the traffic policy that you want to delete.

"""
function delete_traffic_policy(
    Id, Version; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "DELETE",
        "/2013-04-01/trafficpolicy/$(Id)/$(Version)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_traffic_policy(
    Id,
    Version,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53(
        "DELETE",
        "/2013-04-01/trafficpolicy/$(Id)/$(Version)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_traffic_policy_instance(id)
    delete_traffic_policy_instance(id, params::Dict{String,<:Any})

Deletes a traffic policy instance and all of the resource record sets that Amazon Route 53
created when you created the instance.  In the Route 53 console, traffic policy instances
are known as policy records.

# Arguments
- `id`: The ID of the traffic policy instance that you want to delete.   When you delete a
  traffic policy instance, Amazon Route 53 also deletes all of the resource record sets that
  were created when you created the traffic policy instance.

"""
function delete_traffic_policy_instance(
    Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "DELETE",
        "/2013-04-01/trafficpolicyinstance/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_traffic_policy_instance(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "DELETE",
        "/2013-04-01/trafficpolicyinstance/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_vpcassociation_authorization(id, vpc)
    delete_vpcassociation_authorization(id, vpc, params::Dict{String,<:Any})

Removes authorization to submit an AssociateVPCWithHostedZone request to associate a
specified VPC with a hosted zone that was created by a different account. You must use the
account that created the hosted zone to submit a DeleteVPCAssociationAuthorization request.
 Sending this request only prevents the Amazon Web Services account that created the VPC
from associating the VPC with the Amazon Route 53 hosted zone in the future. If the VPC is
already associated with the hosted zone, DeleteVPCAssociationAuthorization won't
disassociate the VPC from the hosted zone. If you want to delete an existing association,
use DisassociateVPCFromHostedZone.

# Arguments
- `id`: When removing authorization to associate a VPC that was created by one Amazon Web
  Services account with a hosted zone that was created with a different Amazon Web Services
  account, the ID of the hosted zone.
- `vpc`: When removing authorization to associate a VPC that was created by one Amazon Web
  Services account with a hosted zone that was created with a different Amazon Web Services
  account, a complex type that includes the ID and region of the VPC.

"""
function delete_vpcassociation_authorization(
    Id, VPC; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "POST",
        "/2013-04-01/hostedzone/$(Id)/deauthorizevpcassociation",
        Dict{String,Any}("VPC" => VPC);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_vpcassociation_authorization(
    Id,
    VPC,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53(
        "POST",
        "/2013-04-01/hostedzone/$(Id)/deauthorizevpcassociation",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("VPC" => VPC), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disable_hosted_zone_dnssec(id)
    disable_hosted_zone_dnssec(id, params::Dict{String,<:Any})

Disables DNSSEC signing in a specific hosted zone. This action does not deactivate any
key-signing keys (KSKs) that are active in the hosted zone.

# Arguments
- `id`: A unique string used to identify a hosted zone.

"""
function disable_hosted_zone_dnssec(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return route_53(
        "POST",
        "/2013-04-01/hostedzone/$(Id)/disable-dnssec";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disable_hosted_zone_dnssec(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "POST",
        "/2013-04-01/hostedzone/$(Id)/disable-dnssec",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_vpcfrom_hosted_zone(id, vpc)
    disassociate_vpcfrom_hosted_zone(id, vpc, params::Dict{String,<:Any})

Disassociates an Amazon Virtual Private Cloud (Amazon VPC) from an Amazon Route 53 private
hosted zone. Note the following:   You can't disassociate the last Amazon VPC from a
private hosted zone.   You can't convert a private hosted zone into a public hosted zone.
You can submit a DisassociateVPCFromHostedZone request using either the account that
created the hosted zone or the account that created the Amazon VPC.   Some services, such
as Cloud Map and Amazon Elastic File System (Amazon EFS) automatically create hosted zones
and associate VPCs with the hosted zones. A service can create a hosted zone using your
account or using its own account. You can disassociate a VPC from a hosted zone only if the
service created the hosted zone using your account. When you run
DisassociateVPCFromHostedZone, if the hosted zone has a value for OwningAccount, you can
use DisassociateVPCFromHostedZone. If the hosted zone has a value for OwningService, you
can't use DisassociateVPCFromHostedZone.    When revoking access, the hosted zone and the
Amazon VPC must belong to the same partition. A partition is a group of Amazon Web Services
Regions. Each Amazon Web Services account is scoped to one partition. The following are the
supported partitions:    aws - Amazon Web Services Regions    aws-cn - China Regions
aws-us-gov - Amazon Web Services GovCloud (US) Region   For more information, see Access
Management in the Amazon Web Services General Reference.

# Arguments
- `id`: The ID of the private hosted zone that you want to disassociate a VPC from.
- `vpc`: A complex type that contains information about the VPC that you're disassociating
  from the specified hosted zone.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Comment"`:  Optional: A comment about the disassociation request.
"""
function disassociate_vpcfrom_hosted_zone(
    Id, VPC; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "POST",
        "/2013-04-01/hostedzone/$(Id)/disassociatevpc",
        Dict{String,Any}("VPC" => VPC);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_vpcfrom_hosted_zone(
    Id,
    VPC,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53(
        "POST",
        "/2013-04-01/hostedzone/$(Id)/disassociatevpc",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("VPC" => VPC), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    enable_hosted_zone_dnssec(id)
    enable_hosted_zone_dnssec(id, params::Dict{String,<:Any})

Enables DNSSEC signing in a specific hosted zone.

# Arguments
- `id`: A unique string used to identify a hosted zone.

"""
function enable_hosted_zone_dnssec(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return route_53(
        "POST",
        "/2013-04-01/hostedzone/$(Id)/enable-dnssec";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function enable_hosted_zone_dnssec(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "POST",
        "/2013-04-01/hostedzone/$(Id)/enable-dnssec",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_account_limit(type)
    get_account_limit(type, params::Dict{String,<:Any})

Gets the specified limit for the current account, for example, the maximum number of health
checks that you can create using the account. For the default limit, see Limits in the
Amazon Route 53 Developer Guide. To request a higher limit, open a case.  You can also view
account limits in Amazon Web Services Trusted Advisor. Sign in to the Amazon Web Services
Management Console and open the Trusted Advisor console at
https://console.aws.amazon.com/trustedadvisor/. Then choose Service limits in the
navigation pane.

# Arguments
- `type`: The limit that you want to get. Valid values include the following:
  MAX_HEALTH_CHECKS_BY_OWNER: The maximum number of health checks that you can create using
  the current account.    MAX_HOSTED_ZONES_BY_OWNER: The maximum number of hosted zones that
  you can create using the current account.    MAX_REUSABLE_DELEGATION_SETS_BY_OWNER: The
  maximum number of reusable delegation sets that you can create using the current account.
   MAX_TRAFFIC_POLICIES_BY_OWNER: The maximum number of traffic policies that you can create
  using the current account.    MAX_TRAFFIC_POLICY_INSTANCES_BY_OWNER: The maximum number of
  traffic policy instances that you can create using the current account. (Traffic policy
  instances are referred to as traffic flow policy records in the Amazon Route 53 console.)

"""
function get_account_limit(Type; aws_config::AbstractAWSConfig=current_aws_config())
    return route_53(
        "GET",
        "/2013-04-01/accountlimit/$(Type)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_account_limit(
    Type, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "GET",
        "/2013-04-01/accountlimit/$(Type)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_change(id)
    get_change(id, params::Dict{String,<:Any})

Returns the current status of a change batch request. The status is one of the following
values:    PENDING indicates that the changes in this request have not propagated to all
Amazon Route 53 DNS servers managing the hosted zone. This is the initial status of all
change batch requests.    INSYNC indicates that the changes have propagated to all Route 53
DNS servers managing the hosted zone.

# Arguments
- `id`: The ID of the change batch request. The value that you specify here is the value
  that ChangeResourceRecordSets returned in the Id element when you submitted the request.

"""
function get_change(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return route_53(
        "GET",
        "/2013-04-01/change/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_change(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "GET",
        "/2013-04-01/change/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_checker_ip_ranges()
    get_checker_ip_ranges(params::Dict{String,<:Any})

Route 53 does not perform authorization for this API because it retrieves information that
is already available to the public.   GetCheckerIpRanges still works, but we recommend that
you download ip-ranges.json, which includes IP address ranges for all Amazon Web Services
services. For more information, see IP Address Ranges of Amazon Route 53 Servers in the
Amazon Route 53 Developer Guide.

"""
function get_checker_ip_ranges(; aws_config::AbstractAWSConfig=current_aws_config())
    return route_53(
        "GET",
        "/2013-04-01/checkeripranges";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_checker_ip_ranges(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "GET",
        "/2013-04-01/checkeripranges",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_dnssec(id)
    get_dnssec(id, params::Dict{String,<:Any})

Returns information about DNSSEC for a specific hosted zone, including the key-signing keys
(KSKs) in the hosted zone.

# Arguments
- `id`: A unique string used to identify a hosted zone.

"""
function get_dnssec(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return route_53(
        "GET",
        "/2013-04-01/hostedzone/$(Id)/dnssec";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_dnssec(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "GET",
        "/2013-04-01/hostedzone/$(Id)/dnssec",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_geo_location()
    get_geo_location(params::Dict{String,<:Any})

Gets information about whether a specified geographic location is supported for Amazon
Route 53 geolocation resource record sets. Route 53 does not perform authorization for this
API because it retrieves information that is already available to the public. Use the
following syntax to determine whether a continent is supported for geolocation:  GET
/2013-04-01/geolocation?continentcode=two-letter abbreviation for a continent   Use the
following syntax to determine whether a country is supported for geolocation:  GET
/2013-04-01/geolocation?countrycode=two-character country code   Use the following syntax
to determine whether a subdivision of a country is supported for geolocation:  GET
/2013-04-01/geolocation?countrycode=two-character country
code&amp;subdivisioncode=subdivision code

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"continentcode"`: For geolocation resource record sets, a two-letter abbreviation that
  identifies a continent. Amazon Route 53 supports the following continent codes:    AF:
  Africa    AN: Antarctica    AS: Asia    EU: Europe    OC: Oceania    NA: North America
  SA: South America
- `"countrycode"`: Amazon Route 53 uses the two-letter country codes that are specified in
  ISO standard 3166-1 alpha-2. Route 53 also supports the country code UA for Ukraine.
- `"subdivisioncode"`: The code for the subdivision, such as a particular state within the
  United States. For a list of US state abbreviations, see Appendix B: Two–Letter State and
  Possession Abbreviations on the United States Postal Service website. For a list of all
  supported subdivision codes, use the ListGeoLocations API.
"""
function get_geo_location(; aws_config::AbstractAWSConfig=current_aws_config())
    return route_53(
        "GET",
        "/2013-04-01/geolocation";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_geo_location(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "GET",
        "/2013-04-01/geolocation",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_health_check(health_check_id)
    get_health_check(health_check_id, params::Dict{String,<:Any})

Gets information about a specified health check.

# Arguments
- `health_check_id`: The identifier that Amazon Route 53 assigned to the health check when
  you created it. When you add or update a resource record set, you use this value to specify
  which health check to use. The value can be up to 64 characters long.

"""
function get_health_check(HealthCheckId; aws_config::AbstractAWSConfig=current_aws_config())
    return route_53(
        "GET",
        "/2013-04-01/healthcheck/$(HealthCheckId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_health_check(
    HealthCheckId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53(
        "GET",
        "/2013-04-01/healthcheck/$(HealthCheckId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_health_check_count()
    get_health_check_count(params::Dict{String,<:Any})

Retrieves the number of health checks that are associated with the current Amazon Web
Services account.

"""
function get_health_check_count(; aws_config::AbstractAWSConfig=current_aws_config())
    return route_53(
        "GET",
        "/2013-04-01/healthcheckcount";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_health_check_count(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "GET",
        "/2013-04-01/healthcheckcount",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_health_check_last_failure_reason(health_check_id)
    get_health_check_last_failure_reason(health_check_id, params::Dict{String,<:Any})

Gets the reason that a specified health check failed most recently.

# Arguments
- `health_check_id`: The ID for the health check for which you want the last failure
  reason. When you created the health check, CreateHealthCheck returned the ID in the
  response, in the HealthCheckId element.  If you want to get the last failure reason for a
  calculated health check, you must use the Amazon Route 53 console or the CloudWatch
  console. You can't use GetHealthCheckLastFailureReason for a calculated health check.

"""
function get_health_check_last_failure_reason(
    HealthCheckId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "GET",
        "/2013-04-01/healthcheck/$(HealthCheckId)/lastfailurereason";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_health_check_last_failure_reason(
    HealthCheckId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53(
        "GET",
        "/2013-04-01/healthcheck/$(HealthCheckId)/lastfailurereason",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_health_check_status(health_check_id)
    get_health_check_status(health_check_id, params::Dict{String,<:Any})

Gets status of a specified health check.   This API is intended for use during development
to diagnose behavior. It doesn’t support production use-cases with high query rates that
require immediate and actionable responses.

# Arguments
- `health_check_id`: The ID for the health check that you want the current status for. When
  you created the health check, CreateHealthCheck returned the ID in the response, in the
  HealthCheckId element.  If you want to check the status of a calculated health check, you
  must use the Amazon Route 53 console or the CloudWatch console. You can't use
  GetHealthCheckStatus to get the status of a calculated health check.

"""
function get_health_check_status(
    HealthCheckId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "GET",
        "/2013-04-01/healthcheck/$(HealthCheckId)/status";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_health_check_status(
    HealthCheckId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53(
        "GET",
        "/2013-04-01/healthcheck/$(HealthCheckId)/status",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_hosted_zone(id)
    get_hosted_zone(id, params::Dict{String,<:Any})

Gets information about a specified hosted zone including the four name servers assigned to
the hosted zone.

# Arguments
- `id`: The ID of the hosted zone that you want to get information about.

"""
function get_hosted_zone(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return route_53(
        "GET",
        "/2013-04-01/hostedzone/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_hosted_zone(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "GET",
        "/2013-04-01/hostedzone/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_hosted_zone_count()
    get_hosted_zone_count(params::Dict{String,<:Any})

Retrieves the number of hosted zones that are associated with the current Amazon Web
Services account.

"""
function get_hosted_zone_count(; aws_config::AbstractAWSConfig=current_aws_config())
    return route_53(
        "GET",
        "/2013-04-01/hostedzonecount";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_hosted_zone_count(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "GET",
        "/2013-04-01/hostedzonecount",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_hosted_zone_limit(id, type)
    get_hosted_zone_limit(id, type, params::Dict{String,<:Any})

Gets the specified limit for a specified hosted zone, for example, the maximum number of
records that you can create in the hosted zone.  For the default limit, see Limits in the
Amazon Route 53 Developer Guide. To request a higher limit, open a case.

# Arguments
- `id`: The ID of the hosted zone that you want to get a limit for.
- `type`: The limit that you want to get. Valid values include the following:
  MAX_RRSETS_BY_ZONE: The maximum number of records that you can create in the specified
  hosted zone.    MAX_VPCS_ASSOCIATED_BY_ZONE: The maximum number of Amazon VPCs that you can
  associate with the specified private hosted zone.

"""
function get_hosted_zone_limit(Id, Type; aws_config::AbstractAWSConfig=current_aws_config())
    return route_53(
        "GET",
        "/2013-04-01/hostedzonelimit/$(Id)/$(Type)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_hosted_zone_limit(
    Id,
    Type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53(
        "GET",
        "/2013-04-01/hostedzonelimit/$(Id)/$(Type)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_query_logging_config(id)
    get_query_logging_config(id, params::Dict{String,<:Any})

Gets information about a specified configuration for DNS query logging. For more
information about DNS query logs, see CreateQueryLoggingConfig and Logging DNS Queries.

# Arguments
- `id`: The ID of the configuration for DNS query logging that you want to get information
  about.

"""
function get_query_logging_config(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return route_53(
        "GET",
        "/2013-04-01/queryloggingconfig/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_query_logging_config(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "GET",
        "/2013-04-01/queryloggingconfig/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_reusable_delegation_set(id)
    get_reusable_delegation_set(id, params::Dict{String,<:Any})

Retrieves information about a specified reusable delegation set, including the four name
servers that are assigned to the delegation set.

# Arguments
- `id`: The ID of the reusable delegation set that you want to get a list of name servers
  for.

"""
function get_reusable_delegation_set(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return route_53(
        "GET",
        "/2013-04-01/delegationset/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_reusable_delegation_set(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "GET",
        "/2013-04-01/delegationset/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_reusable_delegation_set_limit(id, type)
    get_reusable_delegation_set_limit(id, type, params::Dict{String,<:Any})

Gets the maximum number of hosted zones that you can associate with the specified reusable
delegation set. For the default limit, see Limits in the Amazon Route 53 Developer Guide.
To request a higher limit, open a case.

# Arguments
- `id`: The ID of the delegation set that you want to get the limit for.
- `type`: Specify MAX_ZONES_BY_REUSABLE_DELEGATION_SET to get the maximum number of hosted
  zones that you can associate with the specified reusable delegation set.

"""
function get_reusable_delegation_set_limit(
    Id, Type; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "GET",
        "/2013-04-01/reusabledelegationsetlimit/$(Id)/$(Type)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_reusable_delegation_set_limit(
    Id,
    Type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53(
        "GET",
        "/2013-04-01/reusabledelegationsetlimit/$(Id)/$(Type)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_traffic_policy(id, version)
    get_traffic_policy(id, version, params::Dict{String,<:Any})

Gets information about a specific traffic policy version. For information about how of
deleting a traffic policy affects the response from GetTrafficPolicy, see
DeleteTrafficPolicy.

# Arguments
- `id`: The ID of the traffic policy that you want to get information about.
- `version`: The version number of the traffic policy that you want to get information
  about.

"""
function get_traffic_policy(Id, Version; aws_config::AbstractAWSConfig=current_aws_config())
    return route_53(
        "GET",
        "/2013-04-01/trafficpolicy/$(Id)/$(Version)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_traffic_policy(
    Id,
    Version,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53(
        "GET",
        "/2013-04-01/trafficpolicy/$(Id)/$(Version)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_traffic_policy_instance(id)
    get_traffic_policy_instance(id, params::Dict{String,<:Any})

Gets information about a specified traffic policy instance.   Use GetTrafficPolicyInstance
with the id of new traffic policy instance to confirm that the CreateTrafficPolicyInstance
or an UpdateTrafficPolicyInstance request completed successfully. For more information, see
the State response element.   In the Route 53 console, traffic policy instances are known
as policy records.

# Arguments
- `id`: The ID of the traffic policy instance that you want to get information about.

"""
function get_traffic_policy_instance(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return route_53(
        "GET",
        "/2013-04-01/trafficpolicyinstance/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_traffic_policy_instance(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "GET",
        "/2013-04-01/trafficpolicyinstance/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_traffic_policy_instance_count()
    get_traffic_policy_instance_count(params::Dict{String,<:Any})

Gets the number of traffic policy instances that are associated with the current Amazon Web
Services account.

"""
function get_traffic_policy_instance_count(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "GET",
        "/2013-04-01/trafficpolicyinstancecount";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_traffic_policy_instance_count(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "GET",
        "/2013-04-01/trafficpolicyinstancecount",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_cidr_blocks(cidr_collection_id)
    list_cidr_blocks(cidr_collection_id, params::Dict{String,<:Any})

Returns a paginated list of location objects and their CIDR blocks.

# Arguments
- `cidr_collection_id`: The UUID of the CIDR collection.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"location"`: The name of the CIDR collection location.
- `"maxresults"`: Maximum number of results you want returned.
- `"nexttoken"`: An opaque pagination token to indicate where the service is to begin
  enumerating results.
"""
function list_cidr_blocks(
    CidrCollectionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "GET",
        "/2013-04-01/cidrcollection/$(CidrCollectionId)/cidrblocks";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_cidr_blocks(
    CidrCollectionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53(
        "GET",
        "/2013-04-01/cidrcollection/$(CidrCollectionId)/cidrblocks",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_cidr_collections()
    list_cidr_collections(params::Dict{String,<:Any})

Returns a paginated list of CIDR collections in the Amazon Web Services account (metadata
only).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxresults"`: The maximum number of CIDR collections to return in the response.
- `"nexttoken"`: An opaque pagination token to indicate where the service is to begin
  enumerating results. If no value is provided, the listing of results starts from the
  beginning.
"""
function list_cidr_collections(; aws_config::AbstractAWSConfig=current_aws_config())
    return route_53(
        "GET",
        "/2013-04-01/cidrcollection";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_cidr_collections(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "GET",
        "/2013-04-01/cidrcollection",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_cidr_locations(cidr_collection_id)
    list_cidr_locations(cidr_collection_id, params::Dict{String,<:Any})

Returns a paginated list of CIDR locations for the given collection (metadata only, does
not include CIDR blocks).

# Arguments
- `cidr_collection_id`: The CIDR collection ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxresults"`: The maximum number of CIDR collection locations to return in the response.
- `"nexttoken"`: An opaque pagination token to indicate where the service is to begin
  enumerating results. If no value is provided, the listing of results starts from the
  beginning.
"""
function list_cidr_locations(
    CidrCollectionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "GET",
        "/2013-04-01/cidrcollection/$(CidrCollectionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_cidr_locations(
    CidrCollectionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53(
        "GET",
        "/2013-04-01/cidrcollection/$(CidrCollectionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_geo_locations()
    list_geo_locations(params::Dict{String,<:Any})

Retrieves a list of supported geographic locations. Countries are listed first, and
continents are listed last. If Amazon Route 53 supports subdivisions for a country (for
example, states or provinces), the subdivisions for that country are listed in alphabetical
order immediately after the corresponding country. Route 53 does not perform authorization
for this API because it retrieves information that is already available to the public. For
a list of supported geolocation codes, see the GeoLocation data type.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxitems"`: (Optional) The maximum number of geolocations to be included in the
  response body for this request. If more than maxitems geolocations remain to be listed,
  then the value of the IsTruncated element in the response is true.
- `"startcontinentcode"`: The code for the continent with which you want to start listing
  locations that Amazon Route 53 supports for geolocation. If Route 53 has already returned a
  page or more of results, if IsTruncated is true, and if NextContinentCode from the previous
  response has a value, enter that value in startcontinentcode to return the next page of
  results. Include startcontinentcode only if you want to list continents. Don't include
  startcontinentcode when you're listing countries or countries with their subdivisions.
- `"startcountrycode"`: The code for the country with which you want to start listing
  locations that Amazon Route 53 supports for geolocation. If Route 53 has already returned a
  page or more of results, if IsTruncated is true, and if NextCountryCode from the previous
  response has a value, enter that value in startcountrycode to return the next page of
  results.
- `"startsubdivisioncode"`: The code for the state of the United States with which you want
  to start listing locations that Amazon Route 53 supports for geolocation. If Route 53 has
  already returned a page or more of results, if IsTruncated is true, and if
  NextSubdivisionCode from the previous response has a value, enter that value in
  startsubdivisioncode to return the next page of results. To list subdivisions (U.S.
  states), you must include both startcountrycode and startsubdivisioncode.
"""
function list_geo_locations(; aws_config::AbstractAWSConfig=current_aws_config())
    return route_53(
        "GET",
        "/2013-04-01/geolocations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_geo_locations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "GET",
        "/2013-04-01/geolocations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_health_checks()
    list_health_checks(params::Dict{String,<:Any})

Retrieve a list of the health checks that are associated with the current Amazon Web
Services account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"marker"`: If the value of IsTruncated in the previous response was true, you have more
  health checks. To get another group, submit another ListHealthChecks request.  For the
  value of marker, specify the value of NextMarker from the previous response, which is the
  ID of the first health check that Amazon Route 53 will return if you submit another
  request. If the value of IsTruncated in the previous response was false, there are no more
  health checks to get.
- `"maxitems"`: The maximum number of health checks that you want ListHealthChecks to
  return in response to the current request. Amazon Route 53 returns a maximum of 1000 items.
  If you set MaxItems to a value greater than 1000, Route 53 returns only the first 1000
  health checks.
"""
function list_health_checks(; aws_config::AbstractAWSConfig=current_aws_config())
    return route_53(
        "GET",
        "/2013-04-01/healthcheck";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_health_checks(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "GET",
        "/2013-04-01/healthcheck",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_hosted_zones()
    list_hosted_zones(params::Dict{String,<:Any})

Retrieves a list of the public and private hosted zones that are associated with the
current Amazon Web Services account. The response includes a HostedZones child element for
each hosted zone. Amazon Route 53 returns a maximum of 100 items in each response. If you
have a lot of hosted zones, you can use the maxitems parameter to list them in groups of up
to 100.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"delegationsetid"`: If you're using reusable delegation sets and you want to list all of
  the hosted zones that are associated with a reusable delegation set, specify the ID of that
  reusable delegation set.
- `"hostedzonetype"`:  (Optional) Specifies if the hosted zone is private.
- `"marker"`: If the value of IsTruncated in the previous response was true, you have more
  hosted zones. To get more hosted zones, submit another ListHostedZones request.  For the
  value of marker, specify the value of NextMarker from the previous response, which is the
  ID of the first hosted zone that Amazon Route 53 will return if you submit another request.
  If the value of IsTruncated in the previous response was false, there are no more hosted
  zones to get.
- `"maxitems"`: (Optional) The maximum number of hosted zones that you want Amazon Route 53
  to return. If you have more than maxitems hosted zones, the value of IsTruncated in the
  response is true, and the value of NextMarker is the hosted zone ID of the first hosted
  zone that Route 53 will return if you submit another request.
"""
function list_hosted_zones(; aws_config::AbstractAWSConfig=current_aws_config())
    return route_53(
        "GET",
        "/2013-04-01/hostedzone";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_hosted_zones(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "GET",
        "/2013-04-01/hostedzone",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_hosted_zones_by_name()
    list_hosted_zones_by_name(params::Dict{String,<:Any})

Retrieves a list of your hosted zones in lexicographic order. The response includes a
HostedZones child element for each hosted zone created by the current Amazon Web Services
account.   ListHostedZonesByName sorts hosted zones by name with the labels reversed. For
example:  com.example.www.  Note the trailing dot, which can change the sort order in some
circumstances. If the domain name includes escape characters or Punycode,
ListHostedZonesByName alphabetizes the domain name using the escaped or Punycoded value,
which is the format that Amazon Route 53 saves in its database. For example, to create a
hosted zone for exämple.com, you specify ex344mple.com for the domain name.
ListHostedZonesByName alphabetizes it as:  com.ex344mple.  The labels are reversed and
alphabetized using the escaped value. For more information about valid domain name formats,
including internationalized domain names, see DNS Domain Name Format in the Amazon Route 53
Developer Guide. Route 53 returns up to 100 items in each response. If you have a lot of
hosted zones, use the MaxItems parameter to list them in groups of up to 100. The response
includes values that help navigate from one group of MaxItems hosted zones to the next:
The DNSName and HostedZoneId elements in the response contain the values, if any, specified
for the dnsname and hostedzoneid parameters in the request that produced the current
response.   The MaxItems element in the response contains the value, if any, that you
specified for the maxitems parameter in the request that produced the current response.
If the value of IsTruncated in the response is true, there are more hosted zones associated
with the current Amazon Web Services account.  If IsTruncated is false, this response
includes the last hosted zone that is associated with the current account. The NextDNSName
element and NextHostedZoneId elements are omitted from the response.   The NextDNSName and
NextHostedZoneId elements in the response contain the domain name and the hosted zone ID of
the next hosted zone that is associated with the current Amazon Web Services account. If
you want to list more hosted zones, make another call to ListHostedZonesByName, and specify
the value of NextDNSName and NextHostedZoneId in the dnsname and hostedzoneid parameters,
respectively.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"dnsname"`: (Optional) For your first request to ListHostedZonesByName, include the
  dnsname parameter only if you want to specify the name of the first hosted zone in the
  response. If you don't include the dnsname parameter, Amazon Route 53 returns all of the
  hosted zones that were created by the current Amazon Web Services account, in ASCII order.
  For subsequent requests, include both dnsname and hostedzoneid parameters. For dnsname,
  specify the value of NextDNSName from the previous response.
- `"hostedzoneid"`: (Optional) For your first request to ListHostedZonesByName, do not
  include the hostedzoneid parameter. If you have more hosted zones than the value of
  maxitems, ListHostedZonesByName returns only the first maxitems hosted zones. To get the
  next group of maxitems hosted zones, submit another request to ListHostedZonesByName and
  include both dnsname and hostedzoneid parameters. For the value of hostedzoneid, specify
  the value of the NextHostedZoneId element from the previous response.
- `"maxitems"`: The maximum number of hosted zones to be included in the response body for
  this request. If you have more than maxitems hosted zones, then the value of the
  IsTruncated element in the response is true, and the values of NextDNSName and
  NextHostedZoneId specify the first hosted zone in the next group of maxitems hosted zones.
"""
function list_hosted_zones_by_name(; aws_config::AbstractAWSConfig=current_aws_config())
    return route_53(
        "GET",
        "/2013-04-01/hostedzonesbyname";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_hosted_zones_by_name(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "GET",
        "/2013-04-01/hostedzonesbyname",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_hosted_zones_by_vpc(vpcid, vpcregion)
    list_hosted_zones_by_vpc(vpcid, vpcregion, params::Dict{String,<:Any})

Lists all the private hosted zones that a specified VPC is associated with, regardless of
which Amazon Web Services account or Amazon Web Services service owns the hosted zones. The
HostedZoneOwner structure in the response contains one of the following values:   An
OwningAccount element, which contains the account number of either the current Amazon Web
Services account or another Amazon Web Services account. Some services, such as Cloud Map,
create hosted zones using the current account.    An OwningService element, which
identifies the Amazon Web Services service that created and owns the hosted zone. For
example, if a hosted zone was created by Amazon Elastic File System (Amazon EFS), the value
of Owner is efs.amazonaws.com.     When listing private hosted zones, the hosted zone and
the Amazon VPC must belong to the same partition where the hosted zones were created. A
partition is a group of Amazon Web Services Regions. Each Amazon Web Services account is
scoped to one partition. The following are the supported partitions:    aws - Amazon Web
Services Regions    aws-cn - China Regions    aws-us-gov - Amazon Web Services GovCloud
(US) Region   For more information, see Access Management in the Amazon Web Services
General Reference.

# Arguments
- `vpcid`: The ID of the Amazon VPC that you want to list hosted zones for.
- `vpcregion`: For the Amazon VPC that you specified for VPCId, the Amazon Web Services
  Region that you created the VPC in.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxitems"`: (Optional) The maximum number of hosted zones that you want Amazon Route 53
  to return. If the specified VPC is associated with more than MaxItems hosted zones, the
  response includes a NextToken element. NextToken contains an encrypted token that
  identifies the first hosted zone that Route 53 will return if you submit another request.
- `"nexttoken"`: If the previous response included a NextToken element, the specified VPC
  is associated with more hosted zones. To get more hosted zones, submit another
  ListHostedZonesByVPC request.  For the value of NextToken, specify the value of NextToken
  from the previous response. If the previous response didn't include a NextToken element,
  there are no more hosted zones to get.
"""
function list_hosted_zones_by_vpc(
    vpcid, vpcregion; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "GET",
        "/2013-04-01/hostedzonesbyvpc",
        Dict{String,Any}("vpcid" => vpcid, "vpcregion" => vpcregion);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_hosted_zones_by_vpc(
    vpcid,
    vpcregion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53(
        "GET",
        "/2013-04-01/hostedzonesbyvpc",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("vpcid" => vpcid, "vpcregion" => vpcregion), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_query_logging_configs()
    list_query_logging_configs(params::Dict{String,<:Any})

Lists the configurations for DNS query logging that are associated with the current Amazon
Web Services account or the configuration that is associated with a specified hosted zone.
For more information about DNS query logs, see CreateQueryLoggingConfig. Additional
information, including the format of DNS query logs, appears in Logging DNS Queries in the
Amazon Route 53 Developer Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"hostedzoneid"`: (Optional) If you want to list the query logging configuration that is
  associated with a hosted zone, specify the ID in HostedZoneId.  If you don't specify a
  hosted zone ID, ListQueryLoggingConfigs returns all of the configurations that are
  associated with the current Amazon Web Services account.
- `"maxresults"`: (Optional) The maximum number of query logging configurations that you
  want Amazon Route 53 to return in response to the current request. If the current Amazon
  Web Services account has more than MaxResults configurations, use the value of NextToken in
  the response to get the next page of results. If you don't specify a value for MaxResults,
  Route 53 returns up to 100 configurations.
- `"nexttoken"`: (Optional) If the current Amazon Web Services account has more than
  MaxResults query logging configurations, use NextToken to get the second and subsequent
  pages of results. For the first ListQueryLoggingConfigs request, omit this value. For the
  second and subsequent requests, get the value of NextToken from the previous response and
  specify that value for NextToken in the request.
"""
function list_query_logging_configs(; aws_config::AbstractAWSConfig=current_aws_config())
    return route_53(
        "GET",
        "/2013-04-01/queryloggingconfig";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_query_logging_configs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "GET",
        "/2013-04-01/queryloggingconfig",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_resource_record_sets(id)
    list_resource_record_sets(id, params::Dict{String,<:Any})

Lists the resource record sets in a specified hosted zone.  ListResourceRecordSets returns
up to 300 resource record sets at a time in ASCII order, beginning at a position specified
by the name and type elements.  Sort order   ListResourceRecordSets sorts results first by
DNS name with the labels reversed, for example:  com.example.www.  Note the trailing dot,
which can change the sort order when the record name contains characters that appear before
. (decimal 46) in the ASCII table. These characters include the following: ! \" #  % &amp;
' ( ) * + , -  When multiple records have the same DNS name, ListResourceRecordSets sorts
results by the record type.  Specifying where to start listing records  You can use the
name and type elements to specify the resource record set that the list begins with:  If
you do not specify Name or Type  The results begin with the first resource record set that
the hosted zone contains.  If you specify Name but not Type  The results begin with the
first resource record set in the list whose name is greater than or equal to Name.  If you
specify Type but not Name  Amazon Route 53 returns the InvalidInput error.  If you specify
both Name and Type  The results begin with the first resource record set in the list whose
name is greater than or equal to Name, and whose type is greater than or equal to Type.
Resource record sets that are PENDING  This action returns the most current version of the
records. This includes records that are PENDING, and that are not yet available on all
Route 53 DNS servers.  Changing resource record sets  To ensure that you get an accurate
listing of the resource record sets for a hosted zone at a point in time, do not submit a
ChangeResourceRecordSets request while you're paging through the results of a
ListResourceRecordSets request. If you do, some pages may display results without the
latest changes while other pages display results with the latest changes.  Displaying the
next page of results  If a ListResourceRecordSets command returns more than one page of
results, the value of IsTruncated is true. To display the next page of results, get the
values of NextRecordName, NextRecordType, and NextRecordIdentifier (if any) from the
response. Then submit another ListResourceRecordSets request, and specify those values for
StartRecordName, StartRecordType, and StartRecordIdentifier.

# Arguments
- `id`: The ID of the hosted zone that contains the resource record sets that you want to
  list.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"identifier"`:  Resource record sets that have a routing policy other than simple: If
  results were truncated for a given DNS name and type, specify the value of
  NextRecordIdentifier from the previous response to get the next resource record set that
  has the current DNS name and type.
- `"maxitems"`: (Optional) The maximum number of resource records sets to include in the
  response body for this request. If the response includes more than maxitems resource record
  sets, the value of the IsTruncated element in the response is true, and the values of the
  NextRecordName and NextRecordType elements in the response identify the first resource
  record set in the next group of maxitems resource record sets.
- `"name"`: The first name in the lexicographic ordering of resource record sets that you
  want to list. If the specified record name doesn't exist, the results begin with the first
  resource record set that has a name greater than the value of name.
- `"type"`: The type of resource record set to begin the record listing from. Valid values
  for basic resource record sets: A | AAAA | CAA | CNAME | MX | NAPTR | NS | PTR | SOA | SPF
  | SRV | TXT  Values for weighted, latency, geolocation, and failover resource record sets:
  A | AAAA | CAA | CNAME | MX | NAPTR | PTR | SPF | SRV | TXT  Values for alias resource
  record sets:     API Gateway custom regional API or edge-optimized API: A    CloudFront
  distribution: A or AAAA    Elastic Beanstalk environment that has a regionalized subdomain:
  A    Elastic Load Balancing load balancer: A | AAAA    S3 bucket: A    VPC interface VPC
  endpoint: A    Another resource record set in this hosted zone: The type of the resource
  record set that the alias references.   Constraint: Specifying type without specifying name
  returns an InvalidInput error.
"""
function list_resource_record_sets(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return route_53(
        "GET",
        "/2013-04-01/hostedzone/$(Id)/rrset";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_resource_record_sets(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "GET",
        "/2013-04-01/hostedzone/$(Id)/rrset",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_reusable_delegation_sets()
    list_reusable_delegation_sets(params::Dict{String,<:Any})

Retrieves a list of the reusable delegation sets that are associated with the current
Amazon Web Services account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"marker"`: If the value of IsTruncated in the previous response was true, you have more
  reusable delegation sets. To get another group, submit another ListReusableDelegationSets
  request.  For the value of marker, specify the value of NextMarker from the previous
  response, which is the ID of the first reusable delegation set that Amazon Route 53 will
  return if you submit another request. If the value of IsTruncated in the previous response
  was false, there are no more reusable delegation sets to get.
- `"maxitems"`: The number of reusable delegation sets that you want Amazon Route 53 to
  return in the response to this request. If you specify a value greater than 100, Route 53
  returns only the first 100 reusable delegation sets.
"""
function list_reusable_delegation_sets(; aws_config::AbstractAWSConfig=current_aws_config())
    return route_53(
        "GET",
        "/2013-04-01/delegationset";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_reusable_delegation_sets(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "GET",
        "/2013-04-01/delegationset",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_id, resource_type)
    list_tags_for_resource(resource_id, resource_type, params::Dict{String,<:Any})

Lists tags for one health check or hosted zone.  For information about using tags for cost
allocation, see Using Cost Allocation Tags in the Billing and Cost Management User Guide.

# Arguments
- `resource_id`: The ID of the resource for which you want to retrieve tags.
- `resource_type`: The type of the resource.   The resource type for health checks is
  healthcheck.   The resource type for hosted zones is hostedzone.

"""
function list_tags_for_resource(
    ResourceId, ResourceType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "GET",
        "/2013-04-01/tags/$(ResourceType)/$(ResourceId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceId,
    ResourceType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53(
        "GET",
        "/2013-04-01/tags/$(ResourceType)/$(ResourceId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resources(resource_id, resource_type)
    list_tags_for_resources(resource_id, resource_type, params::Dict{String,<:Any})

Lists tags for up to 10 health checks or hosted zones. For information about using tags for
cost allocation, see Using Cost Allocation Tags in the Billing and Cost Management User
Guide.

# Arguments
- `resource_id`: A complex type that contains the ResourceId element for each resource for
  which you want to get a list of tags.
- `resource_type`: The type of the resources.   The resource type for health checks is
  healthcheck.   The resource type for hosted zones is hostedzone.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ResourceIds"`: A complex type that contains the ResourceId element for each resource
  for which you want to get a list of tags.
"""
function list_tags_for_resources(
    ResourceId, ResourceType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "POST",
        "/2013-04-01/tags/$(ResourceType)",
        Dict{String,Any}("ResourceId" => ResourceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resources(
    ResourceId,
    ResourceType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53(
        "POST",
        "/2013-04-01/tags/$(ResourceType)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceId" => ResourceId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_traffic_policies()
    list_traffic_policies(params::Dict{String,<:Any})

Gets information about the latest version for every traffic policy that is associated with
the current Amazon Web Services account. Policies are listed in the order that they were
created in.  For information about how of deleting a traffic policy affects the response
from ListTrafficPolicies, see DeleteTrafficPolicy.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxitems"`: (Optional) The maximum number of traffic policies that you want Amazon
  Route 53 to return in response to this request. If you have more than MaxItems traffic
  policies, the value of IsTruncated in the response is true, and the value of
  TrafficPolicyIdMarker is the ID of the first traffic policy that Route 53 will return if
  you submit another request.
- `"trafficpolicyid"`: (Conditional) For your first request to ListTrafficPolicies, don't
  include the TrafficPolicyIdMarker parameter. If you have more traffic policies than the
  value of MaxItems, ListTrafficPolicies returns only the first MaxItems traffic policies. To
  get the next group of policies, submit another request to ListTrafficPolicies. For the
  value of TrafficPolicyIdMarker, specify the value of TrafficPolicyIdMarker that was
  returned in the previous response.
"""
function list_traffic_policies(; aws_config::AbstractAWSConfig=current_aws_config())
    return route_53(
        "GET",
        "/2013-04-01/trafficpolicies";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_traffic_policies(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "GET",
        "/2013-04-01/trafficpolicies",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_traffic_policy_instances()
    list_traffic_policy_instances(params::Dict{String,<:Any})

Gets information about the traffic policy instances that you created by using the current
Amazon Web Services account.  After you submit an UpdateTrafficPolicyInstance request,
there's a brief delay while Amazon Route 53 creates the resource record sets that are
specified in the traffic policy definition. For more information, see the State response
element.  Route 53 returns a maximum of 100 items in each response. If you have a lot of
traffic policy instances, you can use the MaxItems parameter to list them in groups of up
to 100.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"hostedzoneid"`: If the value of IsTruncated in the previous response was true, you have
  more traffic policy instances. To get more traffic policy instances, submit another
  ListTrafficPolicyInstances request. For the value of HostedZoneId, specify the value of
  HostedZoneIdMarker from the previous response, which is the hosted zone ID of the first
  traffic policy instance in the next group of traffic policy instances. If the value of
  IsTruncated in the previous response was false, there are no more traffic policy instances
  to get.
- `"maxitems"`: The maximum number of traffic policy instances that you want Amazon Route
  53 to return in response to a ListTrafficPolicyInstances request. If you have more than
  MaxItems traffic policy instances, the value of the IsTruncated element in the response is
  true, and the values of HostedZoneIdMarker, TrafficPolicyInstanceNameMarker, and
  TrafficPolicyInstanceTypeMarker represent the first traffic policy instance in the next
  group of MaxItems traffic policy instances.
- `"trafficpolicyinstancename"`: If the value of IsTruncated in the previous response was
  true, you have more traffic policy instances. To get more traffic policy instances, submit
  another ListTrafficPolicyInstances request. For the value of trafficpolicyinstancename,
  specify the value of TrafficPolicyInstanceNameMarker from the previous response, which is
  the name of the first traffic policy instance in the next group of traffic policy
  instances. If the value of IsTruncated in the previous response was false, there are no
  more traffic policy instances to get.
- `"trafficpolicyinstancetype"`: If the value of IsTruncated in the previous response was
  true, you have more traffic policy instances. To get more traffic policy instances, submit
  another ListTrafficPolicyInstances request. For the value of trafficpolicyinstancetype,
  specify the value of TrafficPolicyInstanceTypeMarker from the previous response, which is
  the type of the first traffic policy instance in the next group of traffic policy
  instances. If the value of IsTruncated in the previous response was false, there are no
  more traffic policy instances to get.
"""
function list_traffic_policy_instances(; aws_config::AbstractAWSConfig=current_aws_config())
    return route_53(
        "GET",
        "/2013-04-01/trafficpolicyinstances";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_traffic_policy_instances(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "GET",
        "/2013-04-01/trafficpolicyinstances",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_traffic_policy_instances_by_hosted_zone(id)
    list_traffic_policy_instances_by_hosted_zone(id, params::Dict{String,<:Any})

Gets information about the traffic policy instances that you created in a specified hosted
zone.  After you submit a CreateTrafficPolicyInstance or an UpdateTrafficPolicyInstance
request, there's a brief delay while Amazon Route 53 creates the resource record sets that
are specified in the traffic policy definition. For more information, see the State
response element.  Route 53 returns a maximum of 100 items in each response. If you have a
lot of traffic policy instances, you can use the MaxItems parameter to list them in groups
of up to 100.

# Arguments
- `id`: The ID of the hosted zone that you want to list traffic policy instances for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxitems"`: The maximum number of traffic policy instances to be included in the
  response body for this request. If you have more than MaxItems traffic policy instances,
  the value of the IsTruncated element in the response is true, and the values of
  HostedZoneIdMarker, TrafficPolicyInstanceNameMarker, and TrafficPolicyInstanceTypeMarker
  represent the first traffic policy instance that Amazon Route 53 will return if you submit
  another request.
- `"trafficpolicyinstancename"`: If the value of IsTruncated in the previous response is
  true, you have more traffic policy instances. To get more traffic policy instances, submit
  another ListTrafficPolicyInstances request. For the value of trafficpolicyinstancename,
  specify the value of TrafficPolicyInstanceNameMarker from the previous response, which is
  the name of the first traffic policy instance in the next group of traffic policy
  instances. If the value of IsTruncated in the previous response was false, there are no
  more traffic policy instances to get.
- `"trafficpolicyinstancetype"`: If the value of IsTruncated in the previous response is
  true, you have more traffic policy instances. To get more traffic policy instances, submit
  another ListTrafficPolicyInstances request. For the value of trafficpolicyinstancetype,
  specify the value of TrafficPolicyInstanceTypeMarker from the previous response, which is
  the type of the first traffic policy instance in the next group of traffic policy
  instances. If the value of IsTruncated in the previous response was false, there are no
  more traffic policy instances to get.
"""
function list_traffic_policy_instances_by_hosted_zone(
    id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "GET",
        "/2013-04-01/trafficpolicyinstances/hostedzone",
        Dict{String,Any}("id" => id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_traffic_policy_instances_by_hosted_zone(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "GET",
        "/2013-04-01/trafficpolicyinstances/hostedzone",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("id" => id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_traffic_policy_instances_by_policy(id, version)
    list_traffic_policy_instances_by_policy(id, version, params::Dict{String,<:Any})

Gets information about the traffic policy instances that you created by using a specify
traffic policy version.  After you submit a CreateTrafficPolicyInstance or an
UpdateTrafficPolicyInstance request, there's a brief delay while Amazon Route 53 creates
the resource record sets that are specified in the traffic policy definition. For more
information, see the State response element.  Route 53 returns a maximum of 100 items in
each response. If you have a lot of traffic policy instances, you can use the MaxItems
parameter to list them in groups of up to 100.

# Arguments
- `id`: The ID of the traffic policy for which you want to list traffic policy instances.
- `version`: The version of the traffic policy for which you want to list traffic policy
  instances. The version must be associated with the traffic policy that is specified by
  TrafficPolicyId.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"hostedzoneid"`: If the value of IsTruncated in the previous response was true, you have
  more traffic policy instances. To get more traffic policy instances, submit another
  ListTrafficPolicyInstancesByPolicy request.  For the value of hostedzoneid, specify the
  value of HostedZoneIdMarker from the previous response, which is the hosted zone ID of the
  first traffic policy instance that Amazon Route 53 will return if you submit another
  request. If the value of IsTruncated in the previous response was false, there are no more
  traffic policy instances to get.
- `"maxitems"`: The maximum number of traffic policy instances to be included in the
  response body for this request. If you have more than MaxItems traffic policy instances,
  the value of the IsTruncated element in the response is true, and the values of
  HostedZoneIdMarker, TrafficPolicyInstanceNameMarker, and TrafficPolicyInstanceTypeMarker
  represent the first traffic policy instance that Amazon Route 53 will return if you submit
  another request.
- `"trafficpolicyinstancename"`: If the value of IsTruncated in the previous response was
  true, you have more traffic policy instances. To get more traffic policy instances, submit
  another ListTrafficPolicyInstancesByPolicy request. For the value of
  trafficpolicyinstancename, specify the value of TrafficPolicyInstanceNameMarker from the
  previous response, which is the name of the first traffic policy instance that Amazon Route
  53 will return if you submit another request. If the value of IsTruncated in the previous
  response was false, there are no more traffic policy instances to get.
- `"trafficpolicyinstancetype"`: If the value of IsTruncated in the previous response was
  true, you have more traffic policy instances. To get more traffic policy instances, submit
  another ListTrafficPolicyInstancesByPolicy request. For the value of
  trafficpolicyinstancetype, specify the value of TrafficPolicyInstanceTypeMarker from the
  previous response, which is the name of the first traffic policy instance that Amazon Route
  53 will return if you submit another request. If the value of IsTruncated in the previous
  response was false, there are no more traffic policy instances to get.
"""
function list_traffic_policy_instances_by_policy(
    id, version; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "GET",
        "/2013-04-01/trafficpolicyinstances/trafficpolicy",
        Dict{String,Any}("id" => id, "version" => version);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_traffic_policy_instances_by_policy(
    id,
    version,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53(
        "GET",
        "/2013-04-01/trafficpolicyinstances/trafficpolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("id" => id, "version" => version), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_traffic_policy_versions(id)
    list_traffic_policy_versions(id, params::Dict{String,<:Any})

Gets information about all of the versions for a specified traffic policy. Traffic policy
versions are listed in numerical order by VersionNumber.

# Arguments
- `id`: Specify the value of Id of the traffic policy for which you want to list all
  versions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxitems"`: The maximum number of traffic policy versions that you want Amazon Route 53
  to include in the response body for this request. If the specified traffic policy has more
  than MaxItems versions, the value of IsTruncated in the response is true, and the value of
  the TrafficPolicyVersionMarker element is the ID of the first version that Route 53 will
  return if you submit another request.
- `"trafficpolicyversion"`: For your first request to ListTrafficPolicyVersions, don't
  include the TrafficPolicyVersionMarker parameter. If you have more traffic policy versions
  than the value of MaxItems, ListTrafficPolicyVersions returns only the first group of
  MaxItems versions. To get more traffic policy versions, submit another
  ListTrafficPolicyVersions request. For the value of TrafficPolicyVersionMarker, specify the
  value of TrafficPolicyVersionMarker in the previous response.
"""
function list_traffic_policy_versions(
    Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "GET",
        "/2013-04-01/trafficpolicies/$(Id)/versions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_traffic_policy_versions(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "GET",
        "/2013-04-01/trafficpolicies/$(Id)/versions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_vpcassociation_authorizations(id)
    list_vpcassociation_authorizations(id, params::Dict{String,<:Any})

Gets a list of the VPCs that were created by other accounts and that can be associated with
a specified hosted zone because you've submitted one or more
CreateVPCAssociationAuthorization requests.  The response includes a VPCs element with a
VPC child element for each VPC that can be associated with the hosted zone.

# Arguments
- `id`: The ID of the hosted zone for which you want a list of VPCs that can be associated
  with the hosted zone.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxresults"`:  Optional: An integer that specifies the maximum number of VPCs that you
  want Amazon Route 53 to return. If you don't specify a value for MaxResults, Route 53
  returns up to 50 VPCs per page.
- `"nexttoken"`:  Optional: If a response includes a NextToken element, there are more VPCs
  that can be associated with the specified hosted zone. To get the next page of results,
  submit another request, and include the value of NextToken from the response in the
  nexttoken parameter in another ListVPCAssociationAuthorizations request.
"""
function list_vpcassociation_authorizations(
    Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "GET",
        "/2013-04-01/hostedzone/$(Id)/authorizevpcassociation";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_vpcassociation_authorizations(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "GET",
        "/2013-04-01/hostedzone/$(Id)/authorizevpcassociation",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    test_dnsanswer(hostedzoneid, recordname, recordtype)
    test_dnsanswer(hostedzoneid, recordname, recordtype, params::Dict{String,<:Any})

Gets the value that Amazon Route 53 returns in response to a DNS request for a specified
record name and type. You can optionally specify the IP address of a DNS resolver, an EDNS0
client subnet IP address, and a subnet mask.  This call only supports querying public
hosted zones.  The TestDnsAnswer  returns information similar to what you would expect from
the answer section of the dig command. Therefore, if you query for the name servers of a
subdomain that point to the parent name servers, those will not be returned.

# Arguments
- `hostedzoneid`: The ID of the hosted zone that you want Amazon Route 53 to simulate a
  query for.
- `recordname`: The name of the resource record set that you want Amazon Route 53 to
  simulate a query for.
- `recordtype`: The type of the resource record set.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"edns0clientsubnetip"`: If the resolver that you specified for resolverip supports
  EDNS0, specify the IPv4 or IPv6 address of a client in the applicable location, for
  example, 192.0.2.44 or 2001:db8:85a3::8a2e:370:7334.
- `"edns0clientsubnetmask"`: If you specify an IP address for edns0clientsubnetip, you can
  optionally specify the number of bits of the IP address that you want the checking tool to
  include in the DNS query. For example, if you specify 192.0.2.44 for edns0clientsubnetip
  and 24 for edns0clientsubnetmask, the checking tool will simulate a request from
  192.0.2.0/24. The default value is 24 bits for IPv4 addresses and 64 bits for IPv6
  addresses. The range of valid values depends on whether edns0clientsubnetip is an IPv4 or
  an IPv6 address:    IPv4: Specify a value between 0 and 32    IPv6: Specify a value between
  0 and 128
- `"resolverip"`: If you want to simulate a request from a specific DNS resolver, specify
  the IP address for that resolver. If you omit this value, TestDnsAnswer uses the IP address
  of a DNS resolver in the Amazon Web Services US East (N. Virginia) Region (us-east-1).
"""
function test_dnsanswer(
    hostedzoneid, recordname, recordtype; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "GET",
        "/2013-04-01/testdnsanswer",
        Dict{String,Any}(
            "hostedzoneid" => hostedzoneid,
            "recordname" => recordname,
            "recordtype" => recordtype,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function test_dnsanswer(
    hostedzoneid,
    recordname,
    recordtype,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53(
        "GET",
        "/2013-04-01/testdnsanswer",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "hostedzoneid" => hostedzoneid,
                    "recordname" => recordname,
                    "recordtype" => recordtype,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_health_check(health_check_id)
    update_health_check(health_check_id, params::Dict{String,<:Any})

Updates an existing health check. Note that some values can't be updated.  For more
information about updating health checks, see Creating, Updating, and Deleting Health
Checks in the Amazon Route 53 Developer Guide.

# Arguments
- `health_check_id`: The ID for the health check for which you want detailed information.
  When you created the health check, CreateHealthCheck returned the ID in the response, in
  the HealthCheckId element.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AlarmIdentifier"`: A complex type that identifies the CloudWatch alarm that you want
  Amazon Route 53 health checkers to use to determine whether the specified health check is
  healthy.
- `"ChildHealthChecks"`: A complex type that contains one ChildHealthCheck element for each
  health check that you want to associate with a CALCULATED health check.
- `"Disabled"`: Stops Route 53 from performing health checks. When you disable a health
  check, here's what happens:    Health checks that check the health of endpoints: Route 53
  stops submitting requests to your application, server, or other resource.    Calculated
  health checks: Route 53 stops aggregating the status of the referenced health checks.
  Health checks that monitor CloudWatch alarms: Route 53 stops monitoring the corresponding
  CloudWatch metrics.   After you disable a health check, Route 53 considers the status of
  the health check to always be healthy. If you configured DNS failover, Route 53 continues
  to route traffic to the corresponding resources. If you want to stop routing traffic to a
  resource, change the value of Inverted.  Charges for a health check still apply when the
  health check is disabled. For more information, see Amazon Route 53 Pricing.
- `"EnableSNI"`: Specify whether you want Amazon Route 53 to send the value of
  FullyQualifiedDomainName to the endpoint in the client_hello message during TLS
  negotiation. This allows the endpoint to respond to HTTPS health check requests with the
  applicable SSL/TLS certificate. Some endpoints require that HTTPS requests include the host
  name in the client_hello message. If you don't enable SNI, the status of the health check
  will be SSL alert handshake_failure. A health check can also have that status for other
  reasons. If SNI is enabled and you're still getting the error, check the SSL/TLS
  configuration on your endpoint and confirm that your certificate is valid. The SSL/TLS
  certificate on your endpoint includes a domain name in the Common Name field and possibly
  several more in the Subject Alternative Names field. One of the domain names in the
  certificate should match the value that you specify for FullyQualifiedDomainName. If the
  endpoint responds to the client_hello message with a certificate that does not include the
  domain name that you specified in FullyQualifiedDomainName, a health checker will retry the
  handshake. In the second attempt, the health checker will omit FullyQualifiedDomainName
  from the client_hello message.
- `"FailureThreshold"`: The number of consecutive health checks that an endpoint must pass
  or fail for Amazon Route 53 to change the current status of the endpoint from unhealthy to
  healthy or vice versa. For more information, see How Amazon Route 53 Determines Whether an
  Endpoint Is Healthy in the Amazon Route 53 Developer Guide. If you don't specify a value
  for FailureThreshold, the default value is three health checks.
- `"FullyQualifiedDomainName"`: Amazon Route 53 behavior depends on whether you specify a
  value for IPAddress.  If a health check already has a value for IPAddress, you can change
  the value. However, you can't update an existing health check to add or remove the value of
  IPAddress.    If you specify a value for IPAddress: Route 53 sends health check requests to
  the specified IPv4 or IPv6 address and passes the value of FullyQualifiedDomainName in the
  Host header for all health checks except TCP health checks. This is typically the fully
  qualified DNS name of the endpoint on which you want Route 53 to perform health checks.
  When Route 53 checks the health of an endpoint, here is how it constructs the Host header:
   If you specify a value of 80 for Port and HTTP or HTTP_STR_MATCH for Type, Route 53 passes
  the value of FullyQualifiedDomainName to the endpoint in the Host header.   If you specify
  a value of 443 for Port and HTTPS or HTTPS_STR_MATCH for Type, Route 53 passes the value of
  FullyQualifiedDomainName to the endpoint in the Host header.   If you specify another value
  for Port and any value except TCP for Type, Route 53 passes  FullyQualifiedDomainName:Port
  to the endpoint in the Host header.   If you don't specify a value for
  FullyQualifiedDomainName, Route 53 substitutes the value of IPAddress in the Host header in
  each of the above cases.  If you don't specify a value for IPAddress: If you don't specify
  a value for IPAddress, Route 53 sends a DNS request to the domain that you specify in
  FullyQualifiedDomainName at the interval you specify in RequestInterval. Using an IPv4
  address that is returned by DNS, Route 53 then checks the health of the endpoint. If you
  don't specify a value for IPAddress, you can’t update the health check to remove the
  FullyQualifiedDomainName; if you don’t specify a value for IPAddress on creation, a
  FullyQualifiedDomainName is required.  If you don't specify a value for IPAddress, Route 53
  uses only IPv4 to send health checks to the endpoint. If there's no resource record set
  with a type of A for the name that you specify for FullyQualifiedDomainName, the health
  check fails with a \"DNS resolution failed\" error.  If you want to check the health of
  weighted, latency, or failover resource record sets and you choose to specify the endpoint
  only by FullyQualifiedDomainName, we recommend that you create a separate health check for
  each endpoint. For example, create a health check for each HTTP server that is serving
  content for www.example.com. For the value of FullyQualifiedDomainName, specify the domain
  name of the server (such as us-east-2-www.example.com), not the name of the resource record
  sets (www.example.com).  In this configuration, if the value of FullyQualifiedDomainName
  matches the name of the resource record sets and you then associate the health check with
  those resource record sets, health check results will be unpredictable.  In addition, if
  the value of Type is HTTP, HTTPS, HTTP_STR_MATCH, or HTTPS_STR_MATCH, Route 53 passes the
  value of FullyQualifiedDomainName in the Host header, as it does when you specify a value
  for IPAddress. If the value of Type is TCP, Route 53 doesn't pass a Host header.
- `"HealthCheckVersion"`: A sequential counter that Amazon Route 53 sets to 1 when you
  create a health check and increments by 1 each time you update settings for the health
  check. We recommend that you use GetHealthCheck or ListHealthChecks to get the current
  value of HealthCheckVersion for the health check that you want to update, and that you
  include that value in your UpdateHealthCheck request. This prevents Route 53 from
  overwriting an intervening update:   If the value in the UpdateHealthCheck request matches
  the value of HealthCheckVersion in the health check, Route 53 updates the health check with
  the new settings.   If the value of HealthCheckVersion in the health check is greater, the
  health check was changed after you got the version number. Route 53 does not update the
  health check, and it returns a HealthCheckVersionMismatch error.
- `"HealthThreshold"`: The number of child health checks that are associated with a
  CALCULATED health that Amazon Route 53 must consider healthy for the CALCULATED health
  check to be considered healthy. To specify the child health checks that you want to
  associate with a CALCULATED health check, use the ChildHealthChecks and ChildHealthCheck
  elements. Note the following:   If you specify a number greater than the number of child
  health checks, Route 53 always considers this health check to be unhealthy.   If you
  specify 0, Route 53 always considers this health check to be healthy.
- `"IPAddress"`: The IPv4 or IPv6 IP address for the endpoint that you want Amazon Route 53
  to perform health checks on. If you don't specify a value for IPAddress, Route 53 sends a
  DNS request to resolve the domain name that you specify in FullyQualifiedDomainName at the
  interval that you specify in RequestInterval. Using an IP address that is returned by DNS,
  Route 53 then checks the health of the endpoint. Use one of the following formats for the
  value of IPAddress:     IPv4 address: four values between 0 and 255, separated by periods
  (.), for example, 192.0.2.44.    IPv6 address: eight groups of four hexadecimal values,
  separated by colons (:), for example, 2001:0db8:85a3:0000:0000:abcd:0001:2345. You can also
  shorten IPv6 addresses as described in RFC 5952, for example, 2001:db8:85a3::abcd:1:2345.
  If the endpoint is an EC2 instance, we recommend that you create an Elastic IP address,
  associate it with your EC2 instance, and specify the Elastic IP address for IPAddress. This
  ensures that the IP address of your instance never changes. For more information, see the
  applicable documentation:   Linux: Elastic IP Addresses (EIP) in the Amazon EC2 User Guide
  for Linux Instances    Windows: Elastic IP Addresses (EIP) in the Amazon EC2 User Guide for
  Windows Instances     If a health check already has a value for IPAddress, you can change
  the value. However, you can't update an existing health check to add or remove the value of
  IPAddress.   For more information, see FullyQualifiedDomainName.  Constraints: Route 53
  can't check the health of endpoints for which the IP address is in local, private,
  non-routable, or multicast ranges. For more information about IP addresses for which you
  can't create health checks, see the following documents:    RFC 5735, Special Use IPv4
  Addresses     RFC 6598, IANA-Reserved IPv4 Prefix for Shared Address Space     RFC 5156,
  Special-Use IPv6 Addresses
- `"InsufficientDataHealthStatus"`: When CloudWatch has insufficient data about the metric
  to determine the alarm state, the status that you want Amazon Route 53 to assign to the
  health check:    Healthy: Route 53 considers the health check to be healthy.    Unhealthy:
  Route 53 considers the health check to be unhealthy.    LastKnownStatus: By default, Route
  53 uses the status of the health check from the last time CloudWatch had sufficient data to
  determine the alarm state. For new health checks that have no last known status, the status
  for the health check is healthy.
- `"Inverted"`: Specify whether you want Amazon Route 53 to invert the status of a health
  check, for example, to consider a health check unhealthy when it otherwise would be
  considered healthy.
- `"Port"`: The port on the endpoint that you want Amazon Route 53 to perform health checks
  on.  Don't specify a value for Port when you specify a value for Type of CLOUDWATCH_METRIC
  or CALCULATED.
- `"Regions"`: A complex type that contains one Region element for each region that you
  want Amazon Route 53 health checkers to check the specified endpoint from.
- `"ResetElements"`: A complex type that contains one ResettableElementName element for
  each element that you want to reset to the default value. Valid values for
  ResettableElementName include the following:    ChildHealthChecks: Amazon Route 53 resets
  ChildHealthChecks to null.    FullyQualifiedDomainName: Route 53 resets
  FullyQualifiedDomainName. to null.    Regions: Route 53 resets the Regions list to the
  default set of regions.     ResourcePath: Route 53 resets ResourcePath to null.
- `"ResourcePath"`: The path that you want Amazon Route 53 to request when performing
  health checks. The path can be any value for which your endpoint will return an HTTP status
  code of 2xx or 3xx when the endpoint is healthy, for example the file
  /docs/route53-health-check.html. You can also include query string parameters, for example,
  /welcome.html?language=jp&amp;login=y.  Specify this value only if you want to change it.
- `"SearchString"`: If the value of Type is HTTP_STR_MATCH or HTTPS_STR_MATCH, the string
  that you want Amazon Route 53 to search for in the response body from the specified
  resource. If the string appears in the response body, Route 53 considers the resource
  healthy. (You can't change the value of Type when you update a health check.)
"""
function update_health_check(
    HealthCheckId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "POST",
        "/2013-04-01/healthcheck/$(HealthCheckId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_health_check(
    HealthCheckId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53(
        "POST",
        "/2013-04-01/healthcheck/$(HealthCheckId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_hosted_zone_comment(id)
    update_hosted_zone_comment(id, params::Dict{String,<:Any})

Updates the comment for a specified hosted zone.

# Arguments
- `id`: The ID for the hosted zone that you want to update the comment for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Comment"`: The new comment for the hosted zone. If you don't specify a value for
  Comment, Amazon Route 53 deletes the existing value of the Comment element, if any.
"""
function update_hosted_zone_comment(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return route_53(
        "POST",
        "/2013-04-01/hostedzone/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_hosted_zone_comment(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "POST",
        "/2013-04-01/hostedzone/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_traffic_policy_comment(comment, id, version)
    update_traffic_policy_comment(comment, id, version, params::Dict{String,<:Any})

Updates the comment for a specified traffic policy version.

# Arguments
- `comment`: The new comment for the specified traffic policy and version.
- `id`: The value of Id for the traffic policy that you want to update the comment for.
- `version`: The value of Version for the traffic policy that you want to update the
  comment for.

"""
function update_traffic_policy_comment(
    Comment, Id, Version; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53(
        "POST",
        "/2013-04-01/trafficpolicy/$(Id)/$(Version)",
        Dict{String,Any}("Comment" => Comment);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_traffic_policy_comment(
    Comment,
    Id,
    Version,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53(
        "POST",
        "/2013-04-01/trafficpolicy/$(Id)/$(Version)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Comment" => Comment), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_traffic_policy_instance(id, ttl, traffic_policy_id, traffic_policy_version)
    update_traffic_policy_instance(id, ttl, traffic_policy_id, traffic_policy_version, params::Dict{String,<:Any})

 After you submit a UpdateTrafficPolicyInstance request, there's a brief delay while
Route 53 creates the resource record sets that are specified in the traffic policy
definition. Use GetTrafficPolicyInstance with the id of updated traffic policy instance
confirm that the UpdateTrafficPolicyInstance request completed successfully. For more
information, see the State response element.  Updates the resource record sets in a
specified hosted zone that were created based on the settings in a specified traffic policy
version. When you update a traffic policy instance, Amazon Route 53 continues to respond to
DNS queries for the root resource record set name (such as example.com) while it replaces
one group of resource record sets with another. Route 53 performs the following operations:
  Route 53 creates a new group of resource record sets based on the specified traffic
policy. This is true regardless of how significant the differences are between the existing
resource record sets and the new resource record sets.    When all of the new resource
record sets have been created, Route 53 starts to respond to DNS queries for the root
resource record set name (such as example.com) by using the new resource record sets.
Route 53 deletes the old group of resource record sets that are associated with the root
resource record set name.

# Arguments
- `id`: The ID of the traffic policy instance that you want to update.
- `ttl`: The TTL that you want Amazon Route 53 to assign to all of the updated resource
  record sets.
- `traffic_policy_id`: The ID of the traffic policy that you want Amazon Route 53 to use to
  update resource record sets for the specified traffic policy instance.
- `traffic_policy_version`: The version of the traffic policy that you want Amazon Route 53
  to use to update resource record sets for the specified traffic policy instance.

"""
function update_traffic_policy_instance(
    Id,
    TTL,
    TrafficPolicyId,
    TrafficPolicyVersion;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53(
        "POST",
        "/2013-04-01/trafficpolicyinstance/$(Id)",
        Dict{String,Any}(
            "TTL" => TTL,
            "TrafficPolicyId" => TrafficPolicyId,
            "TrafficPolicyVersion" => TrafficPolicyVersion,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_traffic_policy_instance(
    Id,
    TTL,
    TrafficPolicyId,
    TrafficPolicyVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53(
        "POST",
        "/2013-04-01/trafficpolicyinstance/$(Id)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "TTL" => TTL,
                    "TrafficPolicyId" => TrafficPolicyId,
                    "TrafficPolicyVersion" => TrafficPolicyVersion,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWS.jl
using AWS
using AWS.AWSServices: chatbot
using AWS.Compat
using AWS.UUIDs

"""
    create_chime_webhook_configuration(configuration_name, iam_role_arn, sns_topic_arns, webhook_description, webhook_url)
    create_chime_webhook_configuration(configuration_name, iam_role_arn, sns_topic_arns, webhook_description, webhook_url, params::Dict{String,<:Any})

Creates an AWS Chatbot configuration for Amazon Chime.

# Arguments
- `configuration_name`: The name of the configuration.
- `iam_role_arn`: A user-defined role that AWS Chatbot assumes. This is not the
  service-linked role. For more information, see IAM policies for AWS Chatbot in the  AWS
  Chatbot Administrator Guide.
- `sns_topic_arns`: The Amazon Resource Names (ARNs) of the SNS topics that deliver
  notifications to AWS Chatbot.
- `webhook_description`: A description of the webhook. We recommend using the convention
  RoomName/WebhookName. For more information, see Tutorial: Get started with Amazon Chime in
  the  AWS Chatbot Administrator Guide.
- `webhook_url`: The URL for the Amazon Chime webhook.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"LoggingLevel"`: Logging levels include ERROR, INFO, or NONE.
- `"Tags"`: A map of tags assigned to a resource. A tag is a string-to-string map of
  key-value pairs.
"""
function create_chime_webhook_configuration end

function create_chime_webhook_configuration(
    ConfigurationName,
    IamRoleArn,
    SnsTopicArns,
    WebhookDescription,
    WebhookUrl;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chatbot(
        "POST",
        "/create-chime-webhook-configuration",
        Dict{String,Any}(
            "ConfigurationName" => ConfigurationName,
            "IamRoleArn" => IamRoleArn,
            "SnsTopicArns" => SnsTopicArns,
            "WebhookDescription" => WebhookDescription,
            "WebhookUrl" => WebhookUrl,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function create_chime_webhook_configuration(
    ConfigurationName,
    IamRoleArn,
    SnsTopicArns,
    WebhookDescription,
    WebhookUrl,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chatbot(
        "POST",
        "/create-chime-webhook-configuration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ConfigurationName" => ConfigurationName,
                    "IamRoleArn" => IamRoleArn,
                    "SnsTopicArns" => SnsTopicArns,
                    "WebhookDescription" => WebhookDescription,
                    "WebhookUrl" => WebhookUrl,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_microsoft_teams_channel_configuration(channel_id, configuration_name, iam_role_arn, team_id, tenant_id)
    create_microsoft_teams_channel_configuration(channel_id, configuration_name, iam_role_arn, team_id, tenant_id, params::Dict{String,<:Any})

Creates an AWS Chatbot configuration for Microsoft Teams.

# Arguments
- `channel_id`: The ID of the Microsoft Teams channel.
- `configuration_name`: The name of the configuration.
- `iam_role_arn`: A user-defined role that AWS Chatbot assumes. This is not the
  service-linked role. For more information, see IAM policies for AWS Chatbot in the  AWS
  Chatbot Administrator Guide.
- `team_id`:  The ID of the Microsoft Teams authorized with AWS Chatbot. To get the team
  ID, you must perform the initial authorization flow with Microsoft Teams in the AWS Chatbot
  console. Then you can copy and paste the team ID from the console. For more information,
  see Step 1: Configure a Microsoft Teams client in the  AWS Chatbot Administrator Guide.
- `tenant_id`: The ID of the Microsoft Teams tenant.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ChannelName"`: The name of the Microsoft Teams channel.
- `"GuardrailPolicyArns"`: The list of IAM policy ARNs that are applied as channel
  guardrails. The AWS managed AdministratorAccess policy is applied by default if this is not
  set.
- `"LoggingLevel"`: Logging levels include ERROR, INFO, or NONE.
- `"SnsTopicArns"`: The Amazon Resource Names (ARNs) of the SNS topics that deliver
  notifications to AWS Chatbot.
- `"Tags"`: A map of tags assigned to a resource. A tag is a string-to-string map of
  key-value pairs.
- `"TeamName"`: The name of the Microsoft Teams Team.
- `"UserAuthorizationRequired"`: Enables use of a user role requirement in your chat
  configuration.
"""
function create_microsoft_teams_channel_configuration end

function create_microsoft_teams_channel_configuration(
    ChannelId,
    ConfigurationName,
    IamRoleArn,
    TeamId,
    TenantId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chatbot(
        "POST",
        "/create-ms-teams-channel-configuration",
        Dict{String,Any}(
            "ChannelId" => ChannelId,
            "ConfigurationName" => ConfigurationName,
            "IamRoleArn" => IamRoleArn,
            "TeamId" => TeamId,
            "TenantId" => TenantId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function create_microsoft_teams_channel_configuration(
    ChannelId,
    ConfigurationName,
    IamRoleArn,
    TeamId,
    TenantId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chatbot(
        "POST",
        "/create-ms-teams-channel-configuration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ChannelId" => ChannelId,
                    "ConfigurationName" => ConfigurationName,
                    "IamRoleArn" => IamRoleArn,
                    "TeamId" => TeamId,
                    "TenantId" => TenantId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_slack_channel_configuration(configuration_name, iam_role_arn, slack_channel_id, slack_team_id)
    create_slack_channel_configuration(configuration_name, iam_role_arn, slack_channel_id, slack_team_id, params::Dict{String,<:Any})

Creates an AWS Chatbot confugration for Slack.

# Arguments
- `configuration_name`: The name of the configuration.
- `iam_role_arn`: A user-defined role that AWS Chatbot assumes. This is not the
  service-linked role. For more information, see IAM policies for AWS Chatbot in the  AWS
  Chatbot Administrator Guide.
- `slack_channel_id`: The ID of the Slack channel. To get this ID, open Slack, right click
  on the channel name in the left pane, then choose Copy Link. The channel ID is the
  9-character string at the end of the URL. For example, ABCBBLZZZ.
- `slack_team_id`: The ID of the Slack workspace authorized with AWS Chatbot.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"GuardrailPolicyArns"`: The list of IAM policy ARNs that are applied as channel
  guardrails. The AWS managed AdministratorAccess policy is applied by default if this is not
  set.
- `"LoggingLevel"`: Logging levels include ERROR, INFO, or NONE.
- `"SlackChannelName"`: The name of the Slack channel.
- `"SnsTopicArns"`: The Amazon Resource Names (ARNs) of the SNS topics that deliver
  notifications to AWS Chatbot.
- `"Tags"`: A map of tags assigned to a resource. A tag is a string-to-string map of
  key-value pairs.
- `"UserAuthorizationRequired"`: Enables use of a user role requirement in your chat
  configuration.
"""
function create_slack_channel_configuration end

function create_slack_channel_configuration(
    ConfigurationName,
    IamRoleArn,
    SlackChannelId,
    SlackTeamId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chatbot(
        "POST",
        "/create-slack-channel-configuration",
        Dict{String,Any}(
            "ConfigurationName" => ConfigurationName,
            "IamRoleArn" => IamRoleArn,
            "SlackChannelId" => SlackChannelId,
            "SlackTeamId" => SlackTeamId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function create_slack_channel_configuration(
    ConfigurationName,
    IamRoleArn,
    SlackChannelId,
    SlackTeamId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chatbot(
        "POST",
        "/create-slack-channel-configuration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ConfigurationName" => ConfigurationName,
                    "IamRoleArn" => IamRoleArn,
                    "SlackChannelId" => SlackChannelId,
                    "SlackTeamId" => SlackTeamId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_chime_webhook_configuration(chat_configuration_arn)
    delete_chime_webhook_configuration(chat_configuration_arn, params::Dict{String,<:Any})

Deletes a Amazon Chime webhook configuration for AWS Chatbot.

# Arguments
- `chat_configuration_arn`: The Amazon Resource Name (ARN) of the ChimeWebhookConfiguration
  to delete.

"""
function delete_chime_webhook_configuration end

function delete_chime_webhook_configuration(
    ChatConfigurationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chatbot(
        "POST",
        "/delete-chime-webhook-configuration",
        Dict{String,Any}("ChatConfigurationArn" => ChatConfigurationArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function delete_chime_webhook_configuration(
    ChatConfigurationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chatbot(
        "POST",
        "/delete-chime-webhook-configuration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ChatConfigurationArn" => ChatConfigurationArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_microsoft_teams_channel_configuration(chat_configuration_arn)
    delete_microsoft_teams_channel_configuration(chat_configuration_arn, params::Dict{String,<:Any})

Deletes a Microsoft Teams channel configuration for AWS Chatbot

# Arguments
- `chat_configuration_arn`: The Amazon Resource Name (ARN) of the
  MicrosoftTeamsChannelConfiguration associated with the user identity to delete.

"""
function delete_microsoft_teams_channel_configuration end

function delete_microsoft_teams_channel_configuration(
    ChatConfigurationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chatbot(
        "POST",
        "/delete-ms-teams-channel-configuration",
        Dict{String,Any}("ChatConfigurationArn" => ChatConfigurationArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function delete_microsoft_teams_channel_configuration(
    ChatConfigurationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chatbot(
        "POST",
        "/delete-ms-teams-channel-configuration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ChatConfigurationArn" => ChatConfigurationArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_microsoft_teams_configured_team(team_id)
    delete_microsoft_teams_configured_team(team_id, params::Dict{String,<:Any})

Deletes the Microsoft Teams team authorization allowing for channels to be configured in
that Microsoft Teams team. Note that the Microsoft Teams team must have no channels
configured to remove it.

# Arguments
- `team_id`: The ID of the Microsoft Teams team authorized with AWS Chatbot. To get the
  team ID, you must perform the initial authorization flow with Microsoft Teams in the AWS
  Chatbot console. Then you can copy and paste the team ID from the console. For more
  information, see Step 1: Configure a Microsoft Teams client in the  AWS Chatbot
  Administrator Guide.

"""
function delete_microsoft_teams_configured_team end

function delete_microsoft_teams_configured_team(
    TeamId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chatbot(
        "POST",
        "/delete-ms-teams-configured-teams",
        Dict{String,Any}("TeamId" => TeamId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function delete_microsoft_teams_configured_team(
    TeamId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chatbot(
        "POST",
        "/delete-ms-teams-configured-teams",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("TeamId" => TeamId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_microsoft_teams_user_identity(chat_configuration_arn, user_id)
    delete_microsoft_teams_user_identity(chat_configuration_arn, user_id, params::Dict{String,<:Any})

Identifes a user level permission for a channel configuration.

# Arguments
- `chat_configuration_arn`: The ARN of the MicrosoftTeamsChannelConfiguration associated
  with the user identity to delete.
- `user_id`: The Microsoft Teams user ID.

"""
function delete_microsoft_teams_user_identity end

function delete_microsoft_teams_user_identity(
    ChatConfigurationArn, UserId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chatbot(
        "POST",
        "/delete-ms-teams-user-identity",
        Dict{String,Any}(
            "ChatConfigurationArn" => ChatConfigurationArn, "UserId" => UserId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function delete_microsoft_teams_user_identity(
    ChatConfigurationArn,
    UserId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chatbot(
        "POST",
        "/delete-ms-teams-user-identity",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ChatConfigurationArn" => ChatConfigurationArn, "UserId" => UserId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_slack_channel_configuration(chat_configuration_arn)
    delete_slack_channel_configuration(chat_configuration_arn, params::Dict{String,<:Any})

Deletes a Slack channel configuration for AWS Chatbot

# Arguments
- `chat_configuration_arn`: The Amazon Resource Name (ARN) of the SlackChannelConfiguration
  to delete.

"""
function delete_slack_channel_configuration end

function delete_slack_channel_configuration(
    ChatConfigurationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chatbot(
        "POST",
        "/delete-slack-channel-configuration",
        Dict{String,Any}("ChatConfigurationArn" => ChatConfigurationArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function delete_slack_channel_configuration(
    ChatConfigurationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chatbot(
        "POST",
        "/delete-slack-channel-configuration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ChatConfigurationArn" => ChatConfigurationArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_slack_user_identity(chat_configuration_arn, slack_team_id, slack_user_id)
    delete_slack_user_identity(chat_configuration_arn, slack_team_id, slack_user_id, params::Dict{String,<:Any})

Deletes a user level permission for a Slack channel configuration.

# Arguments
- `chat_configuration_arn`: The ARN of the SlackChannelConfiguration associated with the
  user identity to delete.
- `slack_team_id`: The ID of the Slack workspace authorized with AWS Chatbot.
- `slack_user_id`: The ID of the user in Slack

"""
function delete_slack_user_identity end

function delete_slack_user_identity(
    ChatConfigurationArn,
    SlackTeamId,
    SlackUserId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chatbot(
        "POST",
        "/delete-slack-user-identity",
        Dict{String,Any}(
            "ChatConfigurationArn" => ChatConfigurationArn,
            "SlackTeamId" => SlackTeamId,
            "SlackUserId" => SlackUserId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function delete_slack_user_identity(
    ChatConfigurationArn,
    SlackTeamId,
    SlackUserId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chatbot(
        "POST",
        "/delete-slack-user-identity",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ChatConfigurationArn" => ChatConfigurationArn,
                    "SlackTeamId" => SlackTeamId,
                    "SlackUserId" => SlackUserId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_slack_workspace_authorization(slack_team_id)
    delete_slack_workspace_authorization(slack_team_id, params::Dict{String,<:Any})

Deletes the Slack workspace authorization that allows channels to be configured in that
workspace. This requires all configured channels in the workspace to be deleted.

# Arguments
- `slack_team_id`: The ID of the Slack workspace authorized with AWS Chatbot.

"""
function delete_slack_workspace_authorization end

function delete_slack_workspace_authorization(
    SlackTeamId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chatbot(
        "POST",
        "/delete-slack-workspace-authorization",
        Dict{String,Any}("SlackTeamId" => SlackTeamId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function delete_slack_workspace_authorization(
    SlackTeamId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chatbot(
        "POST",
        "/delete-slack-workspace-authorization",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("SlackTeamId" => SlackTeamId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_chime_webhook_configurations()
    describe_chime_webhook_configurations(params::Dict{String,<:Any})

Lists Amazon Chime webhook configurations optionally filtered by ChatConfigurationArn

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ChatConfigurationArn"`: An optional Amazon Resource Number (ARN) of a
  ChimeWebhookConfiguration to describe.
- `"MaxResults"`: The maximum number of results to include in the response. If more results
  exist than the specified MaxResults value, a token is included in the response so that the
  remaining results can be retrieved.
- `"NextToken"`: An optional token returned from a prior request. Use this token for
  pagination of results from this action. If this parameter is specified, the response
  includes only results beyond the token, up to the value specified by MaxResults.
"""
function describe_chime_webhook_configurations end

function describe_chime_webhook_configurations(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return chatbot(
        "POST",
        "/describe-chime-webhook-configurations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function describe_chime_webhook_configurations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chatbot(
        "POST",
        "/describe-chime-webhook-configurations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_slack_channel_configurations()
    describe_slack_channel_configurations(params::Dict{String,<:Any})

Lists Slack channel configurations optionally filtered by ChatConfigurationArn

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ChatConfigurationArn"`: An optional Amazon Resource Number (ARN) of a
  SlackChannelConfiguration to describe.
- `"MaxResults"`: The maximum number of results to include in the response. If more results
  exist than the specified MaxResults value, a token is included in the response so that the
  remaining results can be retrieved.
- `"NextToken"`:  An optional token returned from a prior request. Use this token for
  pagination of results from this action. If this parameter is specified, the response
  includes only results beyond the token, up to the value specified by MaxResults.
"""
function describe_slack_channel_configurations end

function describe_slack_channel_configurations(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return chatbot(
        "POST",
        "/describe-slack-channel-configurations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function describe_slack_channel_configurations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chatbot(
        "POST",
        "/describe-slack-channel-configurations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_slack_user_identities()
    describe_slack_user_identities(params::Dict{String,<:Any})

Lists all Slack user identities with a mapped role.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ChatConfigurationArn"`: The Amazon Resource Number (ARN) of the
  SlackChannelConfiguration associated with the user identities to describe.
- `"MaxResults"`: The maximum number of results to include in the response. If more results
  exist than the specified MaxResults value, a token is included in the response so that the
  remaining results can be retrieved.
- `"NextToken"`:  An optional token returned from a prior request. Use this token for
  pagination of results from this action. If this parameter is specified, the response
  includes only results beyond the token, up to the value specified by MaxResults.
"""
function describe_slack_user_identities end

function describe_slack_user_identities(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return chatbot(
        "POST",
        "/describe-slack-user-identities";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function describe_slack_user_identities(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chatbot(
        "POST",
        "/describe-slack-user-identities",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_slack_workspaces()
    describe_slack_workspaces(params::Dict{String,<:Any})

List all authorized Slack workspaces connected to the AWS Account onboarded with AWS
Chatbot.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to include in the response. If more results
  exist than the specified MaxResults value, a token is included in the response so that the
  remaining results can be retrieved.
- `"NextToken"`:  An optional token returned from a prior request. Use this token for
  pagination of results from this action. If this parameter is specified, the response
  includes only results beyond the token, up to the value specified by MaxResults.
"""
function describe_slack_workspaces end

function describe_slack_workspaces(; aws_config::AbstractAWSConfig=current_aws_config())
    return chatbot(
        "POST",
        "/describe-slack-workspaces";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function describe_slack_workspaces(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chatbot(
        "POST",
        "/describe-slack-workspaces",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_account_preferences()
    get_account_preferences(params::Dict{String,<:Any})

Returns AWS Chatbot account preferences.

"""
function get_account_preferences end

function get_account_preferences(; aws_config::AbstractAWSConfig=current_aws_config())
    return chatbot(
        "POST",
        "/get-account-preferences";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function get_account_preferences(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chatbot(
        "POST",
        "/get-account-preferences",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_microsoft_teams_channel_configuration(chat_configuration_arn)
    get_microsoft_teams_channel_configuration(chat_configuration_arn, params::Dict{String,<:Any})

Returns a Microsoft Teams channel configuration in an AWS account.

# Arguments
- `chat_configuration_arn`: The Amazon Resource Number (ARN) of the
  MicrosoftTeamsChannelConfiguration to retrieve.

"""
function get_microsoft_teams_channel_configuration end

function get_microsoft_teams_channel_configuration(
    ChatConfigurationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chatbot(
        "POST",
        "/get-ms-teams-channel-configuration",
        Dict{String,Any}("ChatConfigurationArn" => ChatConfigurationArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function get_microsoft_teams_channel_configuration(
    ChatConfigurationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chatbot(
        "POST",
        "/get-ms-teams-channel-configuration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ChatConfigurationArn" => ChatConfigurationArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_microsoft_teams_channel_configurations()
    list_microsoft_teams_channel_configurations(params::Dict{String,<:Any})

Lists all AWS Chatbot Microsoft Teams channel configurations in an AWS account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to include in the response. If more results
  exist than the specified MaxResults value, a token is included in the response so that the
  remaining results can be retrieved.
- `"NextToken"`: An optional token returned from a prior request. Use this token for
  pagination of results from this action. If this parameter is specified, the response
  includes only results beyond the token, up to the value specified by MaxResults.
- `"TeamId"`:  The ID of the Microsoft Teams authorized with AWS Chatbot. To get the team
  ID, you must perform the initial authorization flow with Microsoft Teams in the AWS Chatbot
  console. Then you can copy and paste the team ID from the console. For more information,
  see Step 1: Configure a Microsoft Teams client in the  AWS Chatbot Administrator Guide.
"""
function list_microsoft_teams_channel_configurations end

function list_microsoft_teams_channel_configurations(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return chatbot(
        "POST",
        "/list-ms-teams-channel-configurations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function list_microsoft_teams_channel_configurations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chatbot(
        "POST",
        "/list-ms-teams-channel-configurations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_microsoft_teams_configured_teams()
    list_microsoft_teams_configured_teams(params::Dict{String,<:Any})

Lists all authorized Microsoft Teams for an AWS Account

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to include in the response. If more results
  exist than the specified MaxResults value, a token is included in the response so that the
  remaining results can be retrieved.
- `"NextToken"`: An optional token returned from a prior request. Use this token for
  pagination of results from this action. If this parameter is specified, the response
  includes only results beyond the token, up to the value specified by MaxResults.
"""
function list_microsoft_teams_configured_teams end

function list_microsoft_teams_configured_teams(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return chatbot(
        "POST",
        "/list-ms-teams-configured-teams";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function list_microsoft_teams_configured_teams(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chatbot(
        "POST",
        "/list-ms-teams-configured-teams",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_microsoft_teams_user_identities()
    list_microsoft_teams_user_identities(params::Dict{String,<:Any})

A list all Microsoft Teams user identities with a mapped role.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ChatConfigurationArn"`: The Amazon Resource Number (ARN) of the
  MicrosoftTeamsChannelConfiguration associated with the user identities to list.
- `"MaxResults"`: The maximum number of results to include in the response. If more results
  exist than the specified MaxResults value, a token is included in the response so that the
  remaining results can be retrieved.
- `"NextToken"`: An optional token returned from a prior request. Use this token for
  pagination of results from this action. If this parameter is specified, the response
  includes only results beyond the token, up to the value specified by MaxResults.
"""
function list_microsoft_teams_user_identities end

function list_microsoft_teams_user_identities(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return chatbot(
        "POST",
        "/list-ms-teams-user-identities";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function list_microsoft_teams_user_identities(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chatbot(
        "POST",
        "/list-ms-teams-user-identities",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists all of the tags associated with the Amazon Resource Name (ARN) that you specify. The
resource can be a user, server, or role.

# Arguments
- `resource_arn`: The ARN you specified to list the tags of.

"""
function list_tags_for_resource end

function list_tags_for_resource(
    ResourceARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chatbot(
        "POST",
        "/list-tags-for-resource",
        Dict{String,Any}("ResourceARN" => ResourceARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function list_tags_for_resource(
    ResourceARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chatbot(
        "POST",
        "/list-tags-for-resource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceARN" => ResourceARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Attaches a key-value pair to a resource, as identified by its Amazon Resource Name (ARN).
Resources are users, servers, roles, and other entities.

# Arguments
- `resource_arn`: The ARN of the configuration.
- `tags`: A list of tags to apply to the configuration.

"""
function tag_resource end

function tag_resource(ResourceARN, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return chatbot(
        "POST",
        "/tag-resource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function tag_resource(
    ResourceARN,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chatbot(
        "POST",
        "/tag-resource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Detaches a key-value pair from a resource, as identified by its Amazon Resource Name (ARN).
Resources are users, servers, roles, and other entities.

# Arguments
- `resource_arn`: The value of the resource that will have the tag removed. An Amazon
  Resource Name (ARN) is an identifier for a specific AWS resource, such as a server, user,
  or role.
- `tag_keys`: TagKeys are key-value pairs assigned to ARNs that can be used to group and
  search for resources by type. This metadata can be attached to resources for any purpose.

"""
function untag_resource end

function untag_resource(
    ResourceARN, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chatbot(
        "POST",
        "/untag-resource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function untag_resource(
    ResourceARN,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chatbot(
        "POST",
        "/untag-resource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_account_preferences()
    update_account_preferences(params::Dict{String,<:Any})

Updates AWS Chatbot account preferences.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"TrainingDataCollectionEnabled"`: Turns on training data collection. This helps improve
  the AWS Chatbot experience by allowing AWS Chatbot to store and use your customer
  information, such as AWS Chatbot configurations, notifications, user inputs, AWS Chatbot
  generated responses, and interaction data. This data helps us to continuously improve and
  develop Artificial Intelligence (AI) technologies. Your data is not shared with any third
  parties and is protected using sophisticated controls to prevent unauthorized access and
  misuse. AWS Chatbot does not store or use interactions in chat channels with Amazon Q for
  training AI technologies for AWS Chatbot.
- `"UserAuthorizationRequired"`: Enables use of a user role requirement in your chat
  configuration.
"""
function update_account_preferences end

function update_account_preferences(; aws_config::AbstractAWSConfig=current_aws_config())
    return chatbot(
        "POST",
        "/update-account-preferences";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function update_account_preferences(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chatbot(
        "POST",
        "/update-account-preferences",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_chime_webhook_configuration(chat_configuration_arn)
    update_chime_webhook_configuration(chat_configuration_arn, params::Dict{String,<:Any})

Updates a Amazon Chime webhook configuration.

# Arguments
- `chat_configuration_arn`: The Amazon Resource Number (ARN) of the
  ChimeWebhookConfiguration to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"IamRoleArn"`: A user-defined role that AWS Chatbot assumes. This is not the
  service-linked role. For more information, see IAM policies for AWS Chatbot in the  AWS
  Chatbot Administrator Guide.
- `"LoggingLevel"`: Logging levels include ERROR, INFO, or NONE.
- `"SnsTopicArns"`: The ARNs of the SNS topics that deliver notifications to AWS Chatbot.
- `"WebhookDescription"`: A description of the webhook. We recommend using the convention
  RoomName/WebhookName. For more information, see Tutorial: Get started with Amazon Chime in
  the  AWS Chatbot Administrator Guide.
- `"WebhookUrl"`: The URL for the Amazon Chime webhook.
"""
function update_chime_webhook_configuration end

function update_chime_webhook_configuration(
    ChatConfigurationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chatbot(
        "POST",
        "/update-chime-webhook-configuration",
        Dict{String,Any}("ChatConfigurationArn" => ChatConfigurationArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function update_chime_webhook_configuration(
    ChatConfigurationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chatbot(
        "POST",
        "/update-chime-webhook-configuration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ChatConfigurationArn" => ChatConfigurationArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_microsoft_teams_channel_configuration(channel_id, chat_configuration_arn)
    update_microsoft_teams_channel_configuration(channel_id, chat_configuration_arn, params::Dict{String,<:Any})

Updates an Microsoft Teams channel configuration.

# Arguments
- `channel_id`: The ID of the Microsoft Teams channel.
- `chat_configuration_arn`: The Amazon Resource Number (ARN) of the
  TeamsChannelConfiguration to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ChannelName"`: The name of the Microsoft Teams channel.
- `"GuardrailPolicyArns"`: The list of IAM policy ARNs that are applied as channel
  guardrails. The AWS managed AdministratorAccess policy is applied by default if this is not
  set.
- `"IamRoleArn"`: A user-defined role that AWS Chatbot assumes. This is not the
  service-linked role. For more information, see IAM policies for AWS Chatbot in the  AWS
  Chatbot Administrator Guide.
- `"LoggingLevel"`: Logging levels include ERROR, INFO, or NONE.
- `"SnsTopicArns"`: The Amazon Resource Names (ARNs) of the SNS topics that deliver
  notifications to AWS Chatbot.
- `"UserAuthorizationRequired"`: Enables use of a user role requirement in your chat
  configuration.
"""
function update_microsoft_teams_channel_configuration end

function update_microsoft_teams_channel_configuration(
    ChannelId, ChatConfigurationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chatbot(
        "POST",
        "/update-ms-teams-channel-configuration",
        Dict{String,Any}(
            "ChannelId" => ChannelId, "ChatConfigurationArn" => ChatConfigurationArn
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function update_microsoft_teams_channel_configuration(
    ChannelId,
    ChatConfigurationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chatbot(
        "POST",
        "/update-ms-teams-channel-configuration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ChannelId" => ChannelId, "ChatConfigurationArn" => ChatConfigurationArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_slack_channel_configuration(chat_configuration_arn, slack_channel_id)
    update_slack_channel_configuration(chat_configuration_arn, slack_channel_id, params::Dict{String,<:Any})

Updates a Slack channel configuration.

# Arguments
- `chat_configuration_arn`: The Amazon Resource Number (ARN) of the
  SlackChannelConfiguration to update.
- `slack_channel_id`: The ID of the Slack channel. To get this ID, open Slack, right click
  on the channel name in the left pane, then choose Copy Link. The channel ID is the
  9-character string at the end of the URL. For example, ABCBBLZZZ.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"GuardrailPolicyArns"`: The list of IAM policy ARNs that are applied as channel
  guardrails. The AWS managed AdministratorAccess policy is applied by default if this is not
  set.
- `"IamRoleArn"`: A user-defined role that AWS Chatbot assumes. This is not the
  service-linked role. For more information, see IAM policies for AWS Chatbot in the  AWS
  Chatbot Administrator Guide.
- `"LoggingLevel"`: Logging levels include ERROR, INFO, or NONE.
- `"SlackChannelName"`: The name of the Slack channel.
- `"SnsTopicArns"`: The Amazon Resource Names (ARNs) of the SNS topics that deliver
  notifications to AWS Chatbot.
- `"UserAuthorizationRequired"`: Enables use of a user role requirement in your chat
  configuration.
"""
function update_slack_channel_configuration end

function update_slack_channel_configuration(
    ChatConfigurationArn, SlackChannelId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chatbot(
        "POST",
        "/update-slack-channel-configuration",
        Dict{String,Any}(
            "ChatConfigurationArn" => ChatConfigurationArn,
            "SlackChannelId" => SlackChannelId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function update_slack_channel_configuration(
    ChatConfigurationArn,
    SlackChannelId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chatbot(
        "POST",
        "/update-slack-channel-configuration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ChatConfigurationArn" => ChatConfigurationArn,
                    "SlackChannelId" => SlackChannelId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: apigatewayv2
using AWS.Compat
using AWS.UUIDs

"""
    create_api(name, protocol_type)
    create_api(name, protocol_type, params::Dict{String,<:Any})

Creates an Api resource.

# Arguments
- `name`: The name of the API.
- `protocol_type`: The API protocol.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"apiKeySelectionExpression"`: An API key selection expression. Supported only for
  WebSocket APIs. See API Key Selection Expressions.
- `"corsConfiguration"`: A CORS configuration. Supported only for HTTP APIs. See
  Configuring CORS for more information.
- `"credentialsArn"`: This property is part of quick create. It specifies the credentials
  required for the integration, if any. For a Lambda integration, three options are
  available. To specify an IAM Role for API Gateway to assume, use the role's Amazon Resource
  Name (ARN). To require that the caller's identity be passed through from the request,
  specify arn:aws:iam::*:user/*. To use resource-based permissions on supported AWS services,
  specify null. Currently, this property is not used for HTTP integrations. Supported only
  for HTTP APIs.
- `"description"`: The description of the API.
- `"disableExecuteApiEndpoint"`: Specifies whether clients can invoke your API by using the
  default execute-api endpoint. By default, clients can invoke your API with the default
  https://{api_id}.execute-api.{region}.amazonaws.com endpoint. To require that clients use a
  custom domain name to invoke your API, disable the default endpoint.
- `"disableSchemaValidation"`: Avoid validating models when creating a deployment.
  Supported only for WebSocket APIs.
- `"routeKey"`: This property is part of quick create. If you don't specify a routeKey, a
  default route of default is created. The default route acts as a catch-all for any request
  made to your API, for a particular stage. The default route key can't be modified. You can
  add routes after creating the API, and you can update the route keys of additional routes.
  Supported only for HTTP APIs.
- `"routeSelectionExpression"`: The route selection expression for the API. For HTTP APIs,
  the routeSelectionExpression must be {request.method} {request.path}. If not provided, this
  will be the default for HTTP APIs. This property is required for WebSocket APIs.
- `"tags"`: The collection of tags. Each tag element is associated with a given resource.
- `"target"`: This property is part of quick create. Quick create produces an API with an
  integration, a default catch-all route, and a default stage which is configured to
  automatically deploy changes. For HTTP integrations, specify a fully qualified URL. For
  Lambda integrations, specify a function ARN. The type of the integration will be HTTP_PROXY
  or AWS_PROXY, respectively. Supported only for HTTP APIs.
- `"version"`: A version identifier for the API.
"""
function create_api(name, protocolType; aws_config::AbstractAWSConfig=current_aws_config())
    return apigatewayv2(
        "POST",
        "/v2/apis",
        Dict{String,Any}("name" => name, "protocolType" => protocolType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_api(
    name,
    protocolType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "POST",
        "/v2/apis",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("name" => name, "protocolType" => protocolType),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_api_mapping(api_id, domain_name, stage)
    create_api_mapping(api_id, domain_name, stage, params::Dict{String,<:Any})

Creates an API mapping.

# Arguments
- `api_id`: The API identifier.
- `domain_name`: The domain name.
- `stage`: The API stage.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"apiMappingKey"`: The API mapping key.
"""
function create_api_mapping(
    apiId, domainName, stage; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apigatewayv2(
        "POST",
        "/v2/domainnames/$(domainName)/apimappings",
        Dict{String,Any}("apiId" => apiId, "stage" => stage);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_api_mapping(
    apiId,
    domainName,
    stage,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "POST",
        "/v2/domainnames/$(domainName)/apimappings",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("apiId" => apiId, "stage" => stage), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_authorizer(api_id, authorizer_type, identity_source, name)
    create_authorizer(api_id, authorizer_type, identity_source, name, params::Dict{String,<:Any})

Creates an Authorizer for an API.

# Arguments
- `api_id`: The API identifier.
- `authorizer_type`: The authorizer type. Specify REQUEST for a Lambda function using
  incoming request parameters. Specify JWT to use JSON Web Tokens (supported only for HTTP
  APIs).
- `identity_source`: The identity source for which authorization is requested. For a
  REQUEST authorizer, this is optional. The value is a set of one or more mapping expressions
  of the specified request parameters. The identity source can be headers, query string
  parameters, stage variables, and context parameters. For example, if an Auth header and a
  Name query string parameter are defined as identity sources, this value is
  route.request.header.Auth, route.request.querystring.Name for WebSocket APIs. For HTTP
  APIs, use selection expressions prefixed with , for example, request.header.Auth,
  request.querystring.Name. These parameters are used to perform runtime validation for
  Lambda-based authorizers by verifying all of the identity-related request parameters are
  present in the request, not null, and non-empty. Only when this is true does the authorizer
  invoke the authorizer Lambda function. Otherwise, it returns a 401 Unauthorized response
  without calling the Lambda function. For HTTP APIs, identity sources are also used as the
  cache key when caching is enabled. To learn more, see Working with AWS Lambda authorizers
  for HTTP APIs. For JWT, a single entry that specifies where to extract the JSON Web Token
  (JWT) from inbound requests. Currently only header-based and query parameter-based
  selections are supported, for example request.header.Authorization.
- `name`: The name of the authorizer.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"authorizerCredentialsArn"`: Specifies the required credentials as an IAM role for API
  Gateway to invoke the authorizer. To specify an IAM role for API Gateway to assume, use the
  role's Amazon Resource Name (ARN). To use resource-based permissions on the Lambda
  function, don't specify this parameter. Supported only for REQUEST authorizers.
- `"authorizerPayloadFormatVersion"`: Specifies the format of the payload sent to an HTTP
  API Lambda authorizer. Required for HTTP API Lambda authorizers. Supported values are 1.0
  and 2.0. To learn more, see Working with AWS Lambda authorizers for HTTP APIs.
- `"authorizerResultTtlInSeconds"`: The time to live (TTL) for cached authorizer results,
  in seconds. If it equals 0, authorization caching is disabled. If it is greater than 0, API
  Gateway caches authorizer responses. The maximum value is 3600, or 1 hour. Supported only
  for HTTP API Lambda authorizers.
- `"authorizerUri"`: The authorizer's Uniform Resource Identifier (URI). For REQUEST
  authorizers, this must be a well-formed Lambda function URI, for example,
  arn:aws:apigateway:us-west-2:lambda:path/2015-03-31/functions/arn:aws:lambda:us-west-2:{acco
  unt_id}:function:{lambda_function_name}/invocations. In general, the URI has this form:
  arn:aws:apigateway:{region}:lambda:path/{service_api}
               , where {region} is
  the same as the region hosting the Lambda function, path indicates that the remaining
  substring in the URI should be treated as the path to the resource, including the initial
  /. For Lambda functions, this is usually of the form
  /2015-03-31/functions/[FunctionARN]/invocations. Supported only for REQUEST authorizers.
- `"enableSimpleResponses"`: Specifies whether a Lambda authorizer returns a response in a
  simple format. By default, a Lambda authorizer must return an IAM policy. If enabled, the
  Lambda authorizer can return a boolean value instead of an IAM policy. Supported only for
  HTTP APIs. To learn more, see Working with AWS Lambda authorizers for HTTP APIs
- `"identityValidationExpression"`: This parameter is not used.
- `"jwtConfiguration"`: Represents the configuration of a JWT authorizer. Required for the
  JWT authorizer type. Supported only for HTTP APIs.
"""
function create_authorizer(
    apiId,
    authorizerType,
    identitySource,
    name;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "POST",
        "/v2/apis/$(apiId)/authorizers",
        Dict{String,Any}(
            "authorizerType" => authorizerType,
            "identitySource" => identitySource,
            "name" => name,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_authorizer(
    apiId,
    authorizerType,
    identitySource,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "POST",
        "/v2/apis/$(apiId)/authorizers",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "authorizerType" => authorizerType,
                    "identitySource" => identitySource,
                    "name" => name,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_deployment(api_id)
    create_deployment(api_id, params::Dict{String,<:Any})

Creates a Deployment for an API.

# Arguments
- `api_id`: The API identifier.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description for the deployment resource.
- `"stageName"`: The name of the Stage resource for the Deployment resource to create.
"""
function create_deployment(apiId; aws_config::AbstractAWSConfig=current_aws_config())
    return apigatewayv2(
        "POST",
        "/v2/apis/$(apiId)/deployments";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_deployment(
    apiId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apigatewayv2(
        "POST",
        "/v2/apis/$(apiId)/deployments",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_domain_name(domain_name)
    create_domain_name(domain_name, params::Dict{String,<:Any})

Creates a domain name.

# Arguments
- `domain_name`: The domain name.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"domainNameConfigurations"`: The domain name configurations.
- `"mutualTlsAuthentication"`: The mutual TLS authentication configuration for a custom
  domain name.
- `"tags"`: The collection of tags associated with a domain name.
"""
function create_domain_name(domainName; aws_config::AbstractAWSConfig=current_aws_config())
    return apigatewayv2(
        "POST",
        "/v2/domainnames",
        Dict{String,Any}("domainName" => domainName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_domain_name(
    domainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "POST",
        "/v2/domainnames",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("domainName" => domainName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_integration(api_id, integration_type)
    create_integration(api_id, integration_type, params::Dict{String,<:Any})

Creates an Integration.

# Arguments
- `api_id`: The API identifier.
- `integration_type`: The integration type of an integration. One of the following: AWS:
  for integrating the route or method request with an AWS service action, including the
  Lambda function-invoking action. With the Lambda function-invoking action, this is referred
  to as the Lambda custom integration. With any other AWS service action, this is known as
  AWS integration. Supported only for WebSocket APIs. AWS_PROXY: for integrating the route or
  method request with a Lambda function or other AWS service action. This integration is also
  referred to as a Lambda proxy integration. HTTP: for integrating the route or method
  request with an HTTP endpoint. This integration is also referred to as the HTTP custom
  integration. Supported only for WebSocket APIs. HTTP_PROXY: for integrating the route or
  method request with an HTTP endpoint, with the client request passed through as-is. This is
  also referred to as HTTP proxy integration. For HTTP API private integrations, use an
  HTTP_PROXY integration. MOCK: for integrating the route or method request with API Gateway
  as a \"loopback\" endpoint without invoking any backend. Supported only for WebSocket APIs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"connectionId"`: The ID of the VPC link for a private integration. Supported only for
  HTTP APIs.
- `"connectionType"`: The type of the network connection to the integration endpoint.
  Specify INTERNET for connections through the public routable internet or VPC_LINK for
  private connections between API Gateway and resources in a VPC. The default value is
  INTERNET.
- `"contentHandlingStrategy"`: Supported only for WebSocket APIs. Specifies how to handle
  response payload content type conversions. Supported values are CONVERT_TO_BINARY and
  CONVERT_TO_TEXT, with the following behaviors: CONVERT_TO_BINARY: Converts a response
  payload from a Base64-encoded string to the corresponding binary blob. CONVERT_TO_TEXT:
  Converts a response payload from a binary blob to a Base64-encoded string. If this property
  is not defined, the response payload will be passed through from the integration response
  to the route response or method response without modification.
- `"credentialsArn"`: Specifies the credentials required for the integration, if any. For
  AWS integrations, three options are available. To specify an IAM Role for API Gateway to
  assume, use the role's Amazon Resource Name (ARN). To require that the caller's identity be
  passed through from the request, specify the string arn:aws:iam::*:user/*. To use
  resource-based permissions on supported AWS services, specify null.
- `"description"`: The description of the integration.
- `"integrationMethod"`: Specifies the integration's HTTP method type.
- `"integrationSubtype"`: Supported only for HTTP API AWS_PROXY integrations. Specifies the
  AWS service action to invoke. To learn more, see Integration subtype reference.
- `"integrationUri"`: For a Lambda integration, specify the URI of a Lambda function. For
  an HTTP integration, specify a fully-qualified URL. For an HTTP API private integration,
  specify the ARN of an Application Load Balancer listener, Network Load Balancer listener,
  or AWS Cloud Map service. If you specify the ARN of an AWS Cloud Map service, API Gateway
  uses DiscoverInstances to identify resources. You can use query parameters to target
  specific resources. To learn more, see DiscoverInstances. For private integrations, all
  resources must be owned by the same AWS account.
- `"passthroughBehavior"`: Specifies the pass-through behavior for incoming requests based
  on the Content-Type header in the request, and the available mapping templates specified as
  the requestTemplates property on the Integration resource. There are three valid values:
  WHEN_NO_MATCH, WHEN_NO_TEMPLATES, and NEVER. Supported only for WebSocket APIs.
  WHEN_NO_MATCH passes the request body for unmapped content types through to the integration
  backend without transformation. NEVER rejects unmapped content types with an HTTP 415
  Unsupported Media Type response. WHEN_NO_TEMPLATES allows pass-through when the integration
  has no content types mapped to templates. However, if there is at least one content type
  defined, unmapped content types will be rejected with the same HTTP 415 Unsupported Media
  Type response.
- `"payloadFormatVersion"`: Specifies the format of the payload sent to an integration.
  Required for HTTP APIs.
- `"requestParameters"`: For WebSocket APIs, a key-value map specifying request parameters
  that are passed from the method request to the backend. The key is an integration request
  parameter name and the associated value is a method request parameter value or static value
  that must be enclosed within single quotes and pre-encoded as required by the backend. The
  method request parameter value must match the pattern of method.request.{location}.{name}
               , where 
                  {location}
                is querystring, path, or
  header; and 
                  {name}
                must be a valid and unique method
  request parameter name. For HTTP API integrations with a specified integrationSubtype,
  request parameters are a key-value map specifying parameters that are passed to AWS_PROXY
  integrations. You can provide static values, or map request data, stage variables, or
  context variables that are evaluated at runtime. To learn more, see Working with AWS
  service integrations for HTTP APIs. For HTTP API integrations without a specified
  integrationSubtype request parameters are a key-value map specifying how to transform HTTP
  requests before sending them to the backend. The key should follow the pattern
  &lt;action&gt;:&lt;header|querystring|path&gt;.&lt;location&gt; where action can be append,
  overwrite or remove. For values, you can provide static values, or map request data, stage
  variables, or context variables that are evaluated at runtime. To learn more, see
  Transforming API requests and responses.
- `"requestTemplates"`: Represents a map of Velocity templates that are applied on the
  request payload based on the value of the Content-Type header sent by the client. The
  content type value is the key in this map, and the template (as a String) is the value.
  Supported only for WebSocket APIs.
- `"responseParameters"`: Supported only for HTTP APIs. You use response parameters to
  transform the HTTP response from a backend integration before returning the response to
  clients. Specify a key-value map from a selection key to response parameters. The selection
  key must be a valid HTTP status code within the range of 200-599. Response parameters are a
  key-value map. The key must match pattern &lt;action&gt;:&lt;header&gt;.&lt;location&gt; or
  overwrite.statuscode. The action can be append, overwrite or remove. The value can be a
  static value, or map to response data, stage variables, or context variables that are
  evaluated at runtime. To learn more, see Transforming API requests and responses.
- `"templateSelectionExpression"`: The template selection expression for the integration.
- `"timeoutInMillis"`: Custom timeout between 50 and 29,000 milliseconds for WebSocket APIs
  and between 50 and 30,000 milliseconds for HTTP APIs. The default timeout is 29 seconds for
  WebSocket APIs and 30 seconds for HTTP APIs.
- `"tlsConfig"`: The TLS configuration for a private integration. If you specify a TLS
  configuration, private integration traffic uses the HTTPS protocol. Supported only for HTTP
  APIs.
"""
function create_integration(
    apiId, integrationType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apigatewayv2(
        "POST",
        "/v2/apis/$(apiId)/integrations",
        Dict{String,Any}("integrationType" => integrationType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_integration(
    apiId,
    integrationType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "POST",
        "/v2/apis/$(apiId)/integrations",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("integrationType" => integrationType), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_integration_response(api_id, integration_id, integration_response_key)
    create_integration_response(api_id, integration_id, integration_response_key, params::Dict{String,<:Any})

Creates an IntegrationResponses.

# Arguments
- `api_id`: The API identifier.
- `integration_id`: The integration ID.
- `integration_response_key`: The integration response key.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"contentHandlingStrategy"`: Specifies how to handle response payload content type
  conversions. Supported values are CONVERT_TO_BINARY and CONVERT_TO_TEXT, with the following
  behaviors: CONVERT_TO_BINARY: Converts a response payload from a Base64-encoded string to
  the corresponding binary blob. CONVERT_TO_TEXT: Converts a response payload from a binary
  blob to a Base64-encoded string. If this property is not defined, the response payload will
  be passed through from the integration response to the route response or method response
  without modification.
- `"responseParameters"`: A key-value map specifying response parameters that are passed to
  the method response from the backend. The key is a method response header parameter name
  and the mapped value is an integration response header value, a static value enclosed
  within a pair of single quotes, or a JSON expression from the integration response body.
  The mapping key must match the pattern of method.response.header.{name}, where {name} is a
  valid and unique header name. The mapped non-static value must match the pattern of
  integration.response.header.{name} or integration.response.body.{JSON-expression}, where
  {name} is a valid and unique response header name and {JSON-expression} is a valid JSON
  expression without the  prefix.
- `"responseTemplates"`: The collection of response templates for the integration response
  as a string-to-string map of key-value pairs. Response templates are represented as a
  key/value map, with a content-type as the key and a template as the value.
- `"templateSelectionExpression"`: The template selection expression for the integration
  response. Supported only for WebSocket APIs.
"""
function create_integration_response(
    apiId,
    integrationId,
    integrationResponseKey;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "POST",
        "/v2/apis/$(apiId)/integrations/$(integrationId)/integrationresponses",
        Dict{String,Any}("integrationResponseKey" => integrationResponseKey);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_integration_response(
    apiId,
    integrationId,
    integrationResponseKey,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "POST",
        "/v2/apis/$(apiId)/integrations/$(integrationId)/integrationresponses",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("integrationResponseKey" => integrationResponseKey),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_model(api_id, name, schema)
    create_model(api_id, name, schema, params::Dict{String,<:Any})

Creates a Model for an API.

# Arguments
- `api_id`: The API identifier.
- `name`: The name of the model. Must be alphanumeric.
- `schema`: The schema for the model. For application/json models, this should be JSON
  schema draft 4 model.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"contentType"`: The content-type for the model, for example, \"application/json\".
- `"description"`: The description of the model.
"""
function create_model(
    apiId, name, schema; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apigatewayv2(
        "POST",
        "/v2/apis/$(apiId)/models",
        Dict{String,Any}("name" => name, "schema" => schema);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_model(
    apiId,
    name,
    schema,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "POST",
        "/v2/apis/$(apiId)/models",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("name" => name, "schema" => schema), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_route(api_id, route_key)
    create_route(api_id, route_key, params::Dict{String,<:Any})

Creates a Route for an API.

# Arguments
- `api_id`: The API identifier.
- `route_key`: The route key for the route.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"apiKeyRequired"`: Specifies whether an API key is required for the route. Supported
  only for WebSocket APIs.
- `"authorizationScopes"`: The authorization scopes supported by this route.
- `"authorizationType"`: The authorization type for the route. For WebSocket APIs, valid
  values are NONE for open access, AWS_IAM for using AWS IAM permissions, and CUSTOM for
  using a Lambda authorizer For HTTP APIs, valid values are NONE for open access, JWT for
  using JSON Web Tokens, AWS_IAM for using AWS IAM permissions, and CUSTOM for using a Lambda
  authorizer.
- `"authorizerId"`: The identifier of the Authorizer resource to be associated with this
  route. The authorizer identifier is generated by API Gateway when you created the
  authorizer.
- `"modelSelectionExpression"`: The model selection expression for the route. Supported
  only for WebSocket APIs.
- `"operationName"`: The operation name for the route.
- `"requestModels"`: The request models for the route. Supported only for WebSocket APIs.
- `"requestParameters"`: The request parameters for the route. Supported only for WebSocket
  APIs.
- `"routeResponseSelectionExpression"`: The route response selection expression for the
  route. Supported only for WebSocket APIs.
- `"target"`: The target for the route.
"""
function create_route(apiId, routeKey; aws_config::AbstractAWSConfig=current_aws_config())
    return apigatewayv2(
        "POST",
        "/v2/apis/$(apiId)/routes",
        Dict{String,Any}("routeKey" => routeKey);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_route(
    apiId,
    routeKey,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "POST",
        "/v2/apis/$(apiId)/routes",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("routeKey" => routeKey), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_route_response(api_id, route_id, route_response_key)
    create_route_response(api_id, route_id, route_response_key, params::Dict{String,<:Any})

Creates a RouteResponse for a Route.

# Arguments
- `api_id`: The API identifier.
- `route_id`: The route ID.
- `route_response_key`: The route response key.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"modelSelectionExpression"`: The model selection expression for the route response.
  Supported only for WebSocket APIs.
- `"responseModels"`: The response models for the route response.
- `"responseParameters"`: The route response parameters.
"""
function create_route_response(
    apiId, routeId, routeResponseKey; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apigatewayv2(
        "POST",
        "/v2/apis/$(apiId)/routes/$(routeId)/routeresponses",
        Dict{String,Any}("routeResponseKey" => routeResponseKey);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_route_response(
    apiId,
    routeId,
    routeResponseKey,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "POST",
        "/v2/apis/$(apiId)/routes/$(routeId)/routeresponses",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("routeResponseKey" => routeResponseKey), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_stage(api_id, stage_name)
    create_stage(api_id, stage_name, params::Dict{String,<:Any})

Creates a Stage for an API.

# Arguments
- `api_id`: The API identifier.
- `stage_name`: The name of the stage.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accessLogSettings"`: Settings for logging access in this stage.
- `"autoDeploy"`: Specifies whether updates to an API automatically trigger a new
  deployment. The default value is false.
- `"clientCertificateId"`: The identifier of a client certificate for a Stage. Supported
  only for WebSocket APIs.
- `"defaultRouteSettings"`: The default route settings for the stage.
- `"deploymentId"`: The deployment identifier of the API stage.
- `"description"`: The description for the API stage.
- `"routeSettings"`: Route settings for the stage, by routeKey.
- `"stageVariables"`: A map that defines the stage variables for a Stage. Variable names
  can have alphanumeric and underscore characters, and the values must match
  [A-Za-z0-9-._~:/?#&amp;=,]+.
- `"tags"`: The collection of tags. Each tag element is associated with a given resource.
"""
function create_stage(apiId, stageName; aws_config::AbstractAWSConfig=current_aws_config())
    return apigatewayv2(
        "POST",
        "/v2/apis/$(apiId)/stages",
        Dict{String,Any}("stageName" => stageName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_stage(
    apiId,
    stageName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "POST",
        "/v2/apis/$(apiId)/stages",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("stageName" => stageName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_vpc_link(name, subnet_ids)
    create_vpc_link(name, subnet_ids, params::Dict{String,<:Any})

Creates a VPC link.

# Arguments
- `name`: The name of the VPC link.
- `subnet_ids`: A list of subnet IDs to include in the VPC link.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"securityGroupIds"`: A list of security group IDs for the VPC link.
- `"tags"`: A list of tags.
"""
function create_vpc_link(
    name, subnetIds; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apigatewayv2(
        "POST",
        "/v2/vpclinks",
        Dict{String,Any}("name" => name, "subnetIds" => subnetIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_vpc_link(
    name,
    subnetIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "POST",
        "/v2/vpclinks",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("name" => name, "subnetIds" => subnetIds), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_access_log_settings(api_id, stage_name)
    delete_access_log_settings(api_id, stage_name, params::Dict{String,<:Any})

Deletes the AccessLogSettings for a Stage. To disable access logging for a Stage, delete
its AccessLogSettings.

# Arguments
- `api_id`: The API identifier.
- `stage_name`: The stage name. Stage names can only contain alphanumeric characters,
  hyphens, and underscores. Maximum length is 128 characters.

"""
function delete_access_log_settings(
    apiId, stageName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apigatewayv2(
        "DELETE",
        "/v2/apis/$(apiId)/stages/$(stageName)/accesslogsettings";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_access_log_settings(
    apiId,
    stageName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "DELETE",
        "/v2/apis/$(apiId)/stages/$(stageName)/accesslogsettings",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_api(api_id)
    delete_api(api_id, params::Dict{String,<:Any})

Deletes an Api resource.

# Arguments
- `api_id`: The API identifier.

"""
function delete_api(apiId; aws_config::AbstractAWSConfig=current_aws_config())
    return apigatewayv2(
        "DELETE",
        "/v2/apis/$(apiId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_api(
    apiId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apigatewayv2(
        "DELETE",
        "/v2/apis/$(apiId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_api_mapping(api_mapping_id, domain_name)
    delete_api_mapping(api_mapping_id, domain_name, params::Dict{String,<:Any})

Deletes an API mapping.

# Arguments
- `api_mapping_id`: The API mapping identifier.
- `domain_name`: The domain name.

"""
function delete_api_mapping(
    apiMappingId, domainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apigatewayv2(
        "DELETE",
        "/v2/domainnames/$(domainName)/apimappings/$(apiMappingId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_api_mapping(
    apiMappingId,
    domainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "DELETE",
        "/v2/domainnames/$(domainName)/apimappings/$(apiMappingId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_authorizer(api_id, authorizer_id)
    delete_authorizer(api_id, authorizer_id, params::Dict{String,<:Any})

Deletes an Authorizer.

# Arguments
- `api_id`: The API identifier.
- `authorizer_id`: The authorizer identifier.

"""
function delete_authorizer(
    apiId, authorizerId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apigatewayv2(
        "DELETE",
        "/v2/apis/$(apiId)/authorizers/$(authorizerId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_authorizer(
    apiId,
    authorizerId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "DELETE",
        "/v2/apis/$(apiId)/authorizers/$(authorizerId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_cors_configuration(api_id)
    delete_cors_configuration(api_id, params::Dict{String,<:Any})

Deletes a CORS configuration.

# Arguments
- `api_id`: The API identifier.

"""
function delete_cors_configuration(
    apiId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apigatewayv2(
        "DELETE",
        "/v2/apis/$(apiId)/cors";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_cors_configuration(
    apiId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apigatewayv2(
        "DELETE",
        "/v2/apis/$(apiId)/cors",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_deployment(api_id, deployment_id)
    delete_deployment(api_id, deployment_id, params::Dict{String,<:Any})

Deletes a Deployment.

# Arguments
- `api_id`: The API identifier.
- `deployment_id`: The deployment ID.

"""
function delete_deployment(
    apiId, deploymentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apigatewayv2(
        "DELETE",
        "/v2/apis/$(apiId)/deployments/$(deploymentId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_deployment(
    apiId,
    deploymentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "DELETE",
        "/v2/apis/$(apiId)/deployments/$(deploymentId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_domain_name(domain_name)
    delete_domain_name(domain_name, params::Dict{String,<:Any})

Deletes a domain name.

# Arguments
- `domain_name`: The domain name.

"""
function delete_domain_name(domainName; aws_config::AbstractAWSConfig=current_aws_config())
    return apigatewayv2(
        "DELETE",
        "/v2/domainnames/$(domainName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_domain_name(
    domainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "DELETE",
        "/v2/domainnames/$(domainName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_integration(api_id, integration_id)
    delete_integration(api_id, integration_id, params::Dict{String,<:Any})

Deletes an Integration.

# Arguments
- `api_id`: The API identifier.
- `integration_id`: The integration ID.

"""
function delete_integration(
    apiId, integrationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apigatewayv2(
        "DELETE",
        "/v2/apis/$(apiId)/integrations/$(integrationId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_integration(
    apiId,
    integrationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "DELETE",
        "/v2/apis/$(apiId)/integrations/$(integrationId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_integration_response(api_id, integration_id, integration_response_id)
    delete_integration_response(api_id, integration_id, integration_response_id, params::Dict{String,<:Any})

Deletes an IntegrationResponses.

# Arguments
- `api_id`: The API identifier.
- `integration_id`: The integration ID.
- `integration_response_id`: The integration response ID.

"""
function delete_integration_response(
    apiId,
    integrationId,
    integrationResponseId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "DELETE",
        "/v2/apis/$(apiId)/integrations/$(integrationId)/integrationresponses/$(integrationResponseId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_integration_response(
    apiId,
    integrationId,
    integrationResponseId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "DELETE",
        "/v2/apis/$(apiId)/integrations/$(integrationId)/integrationresponses/$(integrationResponseId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_model(api_id, model_id)
    delete_model(api_id, model_id, params::Dict{String,<:Any})

Deletes a Model.

# Arguments
- `api_id`: The API identifier.
- `model_id`: The model ID.

"""
function delete_model(apiId, modelId; aws_config::AbstractAWSConfig=current_aws_config())
    return apigatewayv2(
        "DELETE",
        "/v2/apis/$(apiId)/models/$(modelId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_model(
    apiId,
    modelId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "DELETE",
        "/v2/apis/$(apiId)/models/$(modelId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_route(api_id, route_id)
    delete_route(api_id, route_id, params::Dict{String,<:Any})

Deletes a Route.

# Arguments
- `api_id`: The API identifier.
- `route_id`: The route ID.

"""
function delete_route(apiId, routeId; aws_config::AbstractAWSConfig=current_aws_config())
    return apigatewayv2(
        "DELETE",
        "/v2/apis/$(apiId)/routes/$(routeId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_route(
    apiId,
    routeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "DELETE",
        "/v2/apis/$(apiId)/routes/$(routeId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_route_request_parameter(api_id, request_parameter_key, route_id)
    delete_route_request_parameter(api_id, request_parameter_key, route_id, params::Dict{String,<:Any})

Deletes a route request parameter. Supported only for WebSocket APIs.

# Arguments
- `api_id`: The API identifier.
- `request_parameter_key`: The route request parameter key.
- `route_id`: The route ID.

"""
function delete_route_request_parameter(
    apiId, requestParameterKey, routeId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apigatewayv2(
        "DELETE",
        "/v2/apis/$(apiId)/routes/$(routeId)/requestparameters/$(requestParameterKey)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_route_request_parameter(
    apiId,
    requestParameterKey,
    routeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "DELETE",
        "/v2/apis/$(apiId)/routes/$(routeId)/requestparameters/$(requestParameterKey)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_route_response(api_id, route_id, route_response_id)
    delete_route_response(api_id, route_id, route_response_id, params::Dict{String,<:Any})

Deletes a RouteResponse.

# Arguments
- `api_id`: The API identifier.
- `route_id`: The route ID.
- `route_response_id`: The route response ID.

"""
function delete_route_response(
    apiId, routeId, routeResponseId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apigatewayv2(
        "DELETE",
        "/v2/apis/$(apiId)/routes/$(routeId)/routeresponses/$(routeResponseId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_route_response(
    apiId,
    routeId,
    routeResponseId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "DELETE",
        "/v2/apis/$(apiId)/routes/$(routeId)/routeresponses/$(routeResponseId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_route_settings(api_id, route_key, stage_name)
    delete_route_settings(api_id, route_key, stage_name, params::Dict{String,<:Any})

Deletes the RouteSettings for a stage.

# Arguments
- `api_id`: The API identifier.
- `route_key`: The route key.
- `stage_name`: The stage name. Stage names can only contain alphanumeric characters,
  hyphens, and underscores. Maximum length is 128 characters.

"""
function delete_route_settings(
    apiId, routeKey, stageName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apigatewayv2(
        "DELETE",
        "/v2/apis/$(apiId)/stages/$(stageName)/routesettings/$(routeKey)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_route_settings(
    apiId,
    routeKey,
    stageName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "DELETE",
        "/v2/apis/$(apiId)/stages/$(stageName)/routesettings/$(routeKey)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_stage(api_id, stage_name)
    delete_stage(api_id, stage_name, params::Dict{String,<:Any})

Deletes a Stage.

# Arguments
- `api_id`: The API identifier.
- `stage_name`: The stage name. Stage names can only contain alphanumeric characters,
  hyphens, and underscores. Maximum length is 128 characters.

"""
function delete_stage(apiId, stageName; aws_config::AbstractAWSConfig=current_aws_config())
    return apigatewayv2(
        "DELETE",
        "/v2/apis/$(apiId)/stages/$(stageName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_stage(
    apiId,
    stageName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "DELETE",
        "/v2/apis/$(apiId)/stages/$(stageName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_vpc_link(vpc_link_id)
    delete_vpc_link(vpc_link_id, params::Dict{String,<:Any})

Deletes a VPC link.

# Arguments
- `vpc_link_id`: The ID of the VPC link.

"""
function delete_vpc_link(vpcLinkId; aws_config::AbstractAWSConfig=current_aws_config())
    return apigatewayv2(
        "DELETE",
        "/v2/vpclinks/$(vpcLinkId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_vpc_link(
    vpcLinkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "DELETE",
        "/v2/vpclinks/$(vpcLinkId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    export_api(api_id, output_type, specification)
    export_api(api_id, output_type, specification, params::Dict{String,<:Any})



# Arguments
- `api_id`: The API identifier.
- `output_type`: The output type of the exported definition file. Valid values are JSON and
  YAML.
- `specification`: The version of the API specification to use. OAS30, for OpenAPI 3.0, is
  the only supported value.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"exportVersion"`: The version of the API Gateway export algorithm. API Gateway uses the
  latest version by default. Currently, the only supported version is 1.0.
- `"includeExtensions"`: Specifies whether to include API Gateway extensions in the
  exported API definition. API Gateway extensions are included by default.
- `"stageName"`: The name of the API stage to export. If you don't specify this property, a
  representation of the latest API configuration is exported.
"""
function export_api(
    apiId, outputType, specification; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apigatewayv2(
        "GET",
        "/v2/apis/$(apiId)/exports/$(specification)",
        Dict{String,Any}("outputType" => outputType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function export_api(
    apiId,
    outputType,
    specification,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "GET",
        "/v2/apis/$(apiId)/exports/$(specification)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("outputType" => outputType), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_api(api_id)
    get_api(api_id, params::Dict{String,<:Any})

Gets an Api resource.

# Arguments
- `api_id`: The API identifier.

"""
function get_api(apiId; aws_config::AbstractAWSConfig=current_aws_config())
    return apigatewayv2(
        "GET", "/v2/apis/$(apiId)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_api(
    apiId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apigatewayv2(
        "GET",
        "/v2/apis/$(apiId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_api_mapping(api_mapping_id, domain_name)
    get_api_mapping(api_mapping_id, domain_name, params::Dict{String,<:Any})

Gets an API mapping.

# Arguments
- `api_mapping_id`: The API mapping identifier.
- `domain_name`: The domain name.

"""
function get_api_mapping(
    apiMappingId, domainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apigatewayv2(
        "GET",
        "/v2/domainnames/$(domainName)/apimappings/$(apiMappingId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_api_mapping(
    apiMappingId,
    domainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "GET",
        "/v2/domainnames/$(domainName)/apimappings/$(apiMappingId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_api_mappings(domain_name)
    get_api_mappings(domain_name, params::Dict{String,<:Any})

Gets API mappings.

# Arguments
- `domain_name`: The domain name.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of elements to be returned for this resource.
- `"nextToken"`: The next page of elements from this collection. Not valid for the last
  element of the collection.
"""
function get_api_mappings(domainName; aws_config::AbstractAWSConfig=current_aws_config())
    return apigatewayv2(
        "GET",
        "/v2/domainnames/$(domainName)/apimappings";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_api_mappings(
    domainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "GET",
        "/v2/domainnames/$(domainName)/apimappings",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_apis()
    get_apis(params::Dict{String,<:Any})

Gets a collection of Api resources.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of elements to be returned for this resource.
- `"nextToken"`: The next page of elements from this collection. Not valid for the last
  element of the collection.
"""
function get_apis(; aws_config::AbstractAWSConfig=current_aws_config())
    return apigatewayv2(
        "GET", "/v2/apis"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_apis(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apigatewayv2(
        "GET", "/v2/apis", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_authorizer(api_id, authorizer_id)
    get_authorizer(api_id, authorizer_id, params::Dict{String,<:Any})

Gets an Authorizer.

# Arguments
- `api_id`: The API identifier.
- `authorizer_id`: The authorizer identifier.

"""
function get_authorizer(
    apiId, authorizerId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apigatewayv2(
        "GET",
        "/v2/apis/$(apiId)/authorizers/$(authorizerId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_authorizer(
    apiId,
    authorizerId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "GET",
        "/v2/apis/$(apiId)/authorizers/$(authorizerId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_authorizers(api_id)
    get_authorizers(api_id, params::Dict{String,<:Any})

Gets the Authorizers for an API.

# Arguments
- `api_id`: The API identifier.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of elements to be returned for this resource.
- `"nextToken"`: The next page of elements from this collection. Not valid for the last
  element of the collection.
"""
function get_authorizers(apiId; aws_config::AbstractAWSConfig=current_aws_config())
    return apigatewayv2(
        "GET",
        "/v2/apis/$(apiId)/authorizers";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_authorizers(
    apiId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apigatewayv2(
        "GET",
        "/v2/apis/$(apiId)/authorizers",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_deployment(api_id, deployment_id)
    get_deployment(api_id, deployment_id, params::Dict{String,<:Any})

Gets a Deployment.

# Arguments
- `api_id`: The API identifier.
- `deployment_id`: The deployment ID.

"""
function get_deployment(
    apiId, deploymentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apigatewayv2(
        "GET",
        "/v2/apis/$(apiId)/deployments/$(deploymentId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_deployment(
    apiId,
    deploymentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "GET",
        "/v2/apis/$(apiId)/deployments/$(deploymentId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_deployments(api_id)
    get_deployments(api_id, params::Dict{String,<:Any})

Gets the Deployments for an API.

# Arguments
- `api_id`: The API identifier.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of elements to be returned for this resource.
- `"nextToken"`: The next page of elements from this collection. Not valid for the last
  element of the collection.
"""
function get_deployments(apiId; aws_config::AbstractAWSConfig=current_aws_config())
    return apigatewayv2(
        "GET",
        "/v2/apis/$(apiId)/deployments";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_deployments(
    apiId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apigatewayv2(
        "GET",
        "/v2/apis/$(apiId)/deployments",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_domain_name(domain_name)
    get_domain_name(domain_name, params::Dict{String,<:Any})

Gets a domain name.

# Arguments
- `domain_name`: The domain name.

"""
function get_domain_name(domainName; aws_config::AbstractAWSConfig=current_aws_config())
    return apigatewayv2(
        "GET",
        "/v2/domainnames/$(domainName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_domain_name(
    domainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "GET",
        "/v2/domainnames/$(domainName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_domain_names()
    get_domain_names(params::Dict{String,<:Any})

Gets the domain names for an AWS account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of elements to be returned for this resource.
- `"nextToken"`: The next page of elements from this collection. Not valid for the last
  element of the collection.
"""
function get_domain_names(; aws_config::AbstractAWSConfig=current_aws_config())
    return apigatewayv2(
        "GET", "/v2/domainnames"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_domain_names(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apigatewayv2(
        "GET",
        "/v2/domainnames",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_integration(api_id, integration_id)
    get_integration(api_id, integration_id, params::Dict{String,<:Any})

Gets an Integration.

# Arguments
- `api_id`: The API identifier.
- `integration_id`: The integration ID.

"""
function get_integration(
    apiId, integrationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apigatewayv2(
        "GET",
        "/v2/apis/$(apiId)/integrations/$(integrationId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_integration(
    apiId,
    integrationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "GET",
        "/v2/apis/$(apiId)/integrations/$(integrationId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_integration_response(api_id, integration_id, integration_response_id)
    get_integration_response(api_id, integration_id, integration_response_id, params::Dict{String,<:Any})

Gets an IntegrationResponses.

# Arguments
- `api_id`: The API identifier.
- `integration_id`: The integration ID.
- `integration_response_id`: The integration response ID.

"""
function get_integration_response(
    apiId,
    integrationId,
    integrationResponseId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "GET",
        "/v2/apis/$(apiId)/integrations/$(integrationId)/integrationresponses/$(integrationResponseId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_integration_response(
    apiId,
    integrationId,
    integrationResponseId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "GET",
        "/v2/apis/$(apiId)/integrations/$(integrationId)/integrationresponses/$(integrationResponseId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_integration_responses(api_id, integration_id)
    get_integration_responses(api_id, integration_id, params::Dict{String,<:Any})

Gets the IntegrationResponses for an Integration.

# Arguments
- `api_id`: The API identifier.
- `integration_id`: The integration ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of elements to be returned for this resource.
- `"nextToken"`: The next page of elements from this collection. Not valid for the last
  element of the collection.
"""
function get_integration_responses(
    apiId, integrationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apigatewayv2(
        "GET",
        "/v2/apis/$(apiId)/integrations/$(integrationId)/integrationresponses";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_integration_responses(
    apiId,
    integrationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "GET",
        "/v2/apis/$(apiId)/integrations/$(integrationId)/integrationresponses",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_integrations(api_id)
    get_integrations(api_id, params::Dict{String,<:Any})

Gets the Integrations for an API.

# Arguments
- `api_id`: The API identifier.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of elements to be returned for this resource.
- `"nextToken"`: The next page of elements from this collection. Not valid for the last
  element of the collection.
"""
function get_integrations(apiId; aws_config::AbstractAWSConfig=current_aws_config())
    return apigatewayv2(
        "GET",
        "/v2/apis/$(apiId)/integrations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_integrations(
    apiId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apigatewayv2(
        "GET",
        "/v2/apis/$(apiId)/integrations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_model(api_id, model_id)
    get_model(api_id, model_id, params::Dict{String,<:Any})

Gets a Model.

# Arguments
- `api_id`: The API identifier.
- `model_id`: The model ID.

"""
function get_model(apiId, modelId; aws_config::AbstractAWSConfig=current_aws_config())
    return apigatewayv2(
        "GET",
        "/v2/apis/$(apiId)/models/$(modelId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_model(
    apiId,
    modelId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "GET",
        "/v2/apis/$(apiId)/models/$(modelId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_model_template(api_id, model_id)
    get_model_template(api_id, model_id, params::Dict{String,<:Any})

Gets a model template.

# Arguments
- `api_id`: The API identifier.
- `model_id`: The model ID.

"""
function get_model_template(
    apiId, modelId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apigatewayv2(
        "GET",
        "/v2/apis/$(apiId)/models/$(modelId)/template";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_model_template(
    apiId,
    modelId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "GET",
        "/v2/apis/$(apiId)/models/$(modelId)/template",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_models(api_id)
    get_models(api_id, params::Dict{String,<:Any})

Gets the Models for an API.

# Arguments
- `api_id`: The API identifier.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of elements to be returned for this resource.
- `"nextToken"`: The next page of elements from this collection. Not valid for the last
  element of the collection.
"""
function get_models(apiId; aws_config::AbstractAWSConfig=current_aws_config())
    return apigatewayv2(
        "GET",
        "/v2/apis/$(apiId)/models";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_models(
    apiId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apigatewayv2(
        "GET",
        "/v2/apis/$(apiId)/models",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_route(api_id, route_id)
    get_route(api_id, route_id, params::Dict{String,<:Any})

Gets a Route.

# Arguments
- `api_id`: The API identifier.
- `route_id`: The route ID.

"""
function get_route(apiId, routeId; aws_config::AbstractAWSConfig=current_aws_config())
    return apigatewayv2(
        "GET",
        "/v2/apis/$(apiId)/routes/$(routeId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_route(
    apiId,
    routeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "GET",
        "/v2/apis/$(apiId)/routes/$(routeId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_route_response(api_id, route_id, route_response_id)
    get_route_response(api_id, route_id, route_response_id, params::Dict{String,<:Any})

Gets a RouteResponse.

# Arguments
- `api_id`: The API identifier.
- `route_id`: The route ID.
- `route_response_id`: The route response ID.

"""
function get_route_response(
    apiId, routeId, routeResponseId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apigatewayv2(
        "GET",
        "/v2/apis/$(apiId)/routes/$(routeId)/routeresponses/$(routeResponseId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_route_response(
    apiId,
    routeId,
    routeResponseId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "GET",
        "/v2/apis/$(apiId)/routes/$(routeId)/routeresponses/$(routeResponseId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_route_responses(api_id, route_id)
    get_route_responses(api_id, route_id, params::Dict{String,<:Any})

Gets the RouteResponses for a Route.

# Arguments
- `api_id`: The API identifier.
- `route_id`: The route ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of elements to be returned for this resource.
- `"nextToken"`: The next page of elements from this collection. Not valid for the last
  element of the collection.
"""
function get_route_responses(
    apiId, routeId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apigatewayv2(
        "GET",
        "/v2/apis/$(apiId)/routes/$(routeId)/routeresponses";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_route_responses(
    apiId,
    routeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "GET",
        "/v2/apis/$(apiId)/routes/$(routeId)/routeresponses",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_routes(api_id)
    get_routes(api_id, params::Dict{String,<:Any})

Gets the Routes for an API.

# Arguments
- `api_id`: The API identifier.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of elements to be returned for this resource.
- `"nextToken"`: The next page of elements from this collection. Not valid for the last
  element of the collection.
"""
function get_routes(apiId; aws_config::AbstractAWSConfig=current_aws_config())
    return apigatewayv2(
        "GET",
        "/v2/apis/$(apiId)/routes";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_routes(
    apiId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apigatewayv2(
        "GET",
        "/v2/apis/$(apiId)/routes",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_stage(api_id, stage_name)
    get_stage(api_id, stage_name, params::Dict{String,<:Any})

Gets a Stage.

# Arguments
- `api_id`: The API identifier.
- `stage_name`: The stage name. Stage names can only contain alphanumeric characters,
  hyphens, and underscores. Maximum length is 128 characters.

"""
function get_stage(apiId, stageName; aws_config::AbstractAWSConfig=current_aws_config())
    return apigatewayv2(
        "GET",
        "/v2/apis/$(apiId)/stages/$(stageName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_stage(
    apiId,
    stageName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "GET",
        "/v2/apis/$(apiId)/stages/$(stageName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_stages(api_id)
    get_stages(api_id, params::Dict{String,<:Any})

Gets the Stages for an API.

# Arguments
- `api_id`: The API identifier.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of elements to be returned for this resource.
- `"nextToken"`: The next page of elements from this collection. Not valid for the last
  element of the collection.
"""
function get_stages(apiId; aws_config::AbstractAWSConfig=current_aws_config())
    return apigatewayv2(
        "GET",
        "/v2/apis/$(apiId)/stages";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_stages(
    apiId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apigatewayv2(
        "GET",
        "/v2/apis/$(apiId)/stages",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_tags(resource-arn)
    get_tags(resource-arn, params::Dict{String,<:Any})

Gets a collection of Tag resources.

# Arguments
- `resource-arn`: The resource ARN for the tag.

"""
function get_tags(resource_arn; aws_config::AbstractAWSConfig=current_aws_config())
    return apigatewayv2(
        "GET",
        "/v2/tags/$(resource-arn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_tags(
    resource_arn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "GET",
        "/v2/tags/$(resource-arn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_vpc_link(vpc_link_id)
    get_vpc_link(vpc_link_id, params::Dict{String,<:Any})

Gets a VPC link.

# Arguments
- `vpc_link_id`: The ID of the VPC link.

"""
function get_vpc_link(vpcLinkId; aws_config::AbstractAWSConfig=current_aws_config())
    return apigatewayv2(
        "GET",
        "/v2/vpclinks/$(vpcLinkId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_vpc_link(
    vpcLinkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "GET",
        "/v2/vpclinks/$(vpcLinkId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_vpc_links()
    get_vpc_links(params::Dict{String,<:Any})

Gets a collection of VPC links.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of elements to be returned for this resource.
- `"nextToken"`: The next page of elements from this collection. Not valid for the last
  element of the collection.
"""
function get_vpc_links(; aws_config::AbstractAWSConfig=current_aws_config())
    return apigatewayv2(
        "GET", "/v2/vpclinks"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_vpc_links(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apigatewayv2(
        "GET",
        "/v2/vpclinks",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    import_api(body)
    import_api(body, params::Dict{String,<:Any})

Imports an API.

# Arguments
- `body`: The OpenAPI definition. Supported only for HTTP APIs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"basepath"`: Specifies how to interpret the base path of the API during import. Valid
  values are ignore, prepend, and split. The default value is ignore. To learn more, see Set
  the OpenAPI basePath Property. Supported only for HTTP APIs.
- `"failOnWarnings"`: Specifies whether to rollback the API creation when a warning is
  encountered. By default, API creation continues if a warning is encountered.
"""
function import_api(body; aws_config::AbstractAWSConfig=current_aws_config())
    return apigatewayv2(
        "PUT",
        "/v2/apis",
        Dict{String,Any}("body" => body);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function import_api(
    body, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apigatewayv2(
        "PUT",
        "/v2/apis",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("body" => body), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    reimport_api(api_id, body)
    reimport_api(api_id, body, params::Dict{String,<:Any})

Puts an Api resource.

# Arguments
- `api_id`: The API identifier.
- `body`: The OpenAPI definition. Supported only for HTTP APIs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"basepath"`: Specifies how to interpret the base path of the API during import. Valid
  values are ignore, prepend, and split. The default value is ignore. To learn more, see Set
  the OpenAPI basePath Property. Supported only for HTTP APIs.
- `"failOnWarnings"`: Specifies whether to rollback the API creation when a warning is
  encountered. By default, API creation continues if a warning is encountered.
"""
function reimport_api(apiId, body; aws_config::AbstractAWSConfig=current_aws_config())
    return apigatewayv2(
        "PUT",
        "/v2/apis/$(apiId)",
        Dict{String,Any}("body" => body);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function reimport_api(
    apiId,
    body,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "PUT",
        "/v2/apis/$(apiId)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("body" => body), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    reset_authorizers_cache(api_id, stage_name)
    reset_authorizers_cache(api_id, stage_name, params::Dict{String,<:Any})

Resets all authorizer cache entries on a stage. Supported only for HTTP APIs.

# Arguments
- `api_id`: The API identifier.
- `stage_name`: The stage name. Stage names can contain only alphanumeric characters,
  hyphens, and underscores, or be default. Maximum length is 128 characters.

"""
function reset_authorizers_cache(
    apiId, stageName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apigatewayv2(
        "DELETE",
        "/v2/apis/$(apiId)/stages/$(stageName)/cache/authorizers";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function reset_authorizers_cache(
    apiId,
    stageName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "DELETE",
        "/v2/apis/$(apiId)/stages/$(stageName)/cache/authorizers",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource-arn)
    tag_resource(resource-arn, params::Dict{String,<:Any})

Creates a new Tag resource to represent a tag.

# Arguments
- `resource-arn`: The resource ARN for the tag.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tags"`: The collection of tags. Each tag element is associated with a given resource.
"""
function tag_resource(resource_arn; aws_config::AbstractAWSConfig=current_aws_config())
    return apigatewayv2(
        "POST",
        "/v2/tags/$(resource-arn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resource_arn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "POST",
        "/v2/tags/$(resource-arn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource-arn, tag_keys)
    untag_resource(resource-arn, tag_keys, params::Dict{String,<:Any})

Deletes a Tag.

# Arguments
- `resource-arn`: The resource ARN for the tag.
- `tag_keys`: The Tag keys to delete

"""
function untag_resource(
    resource_arn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apigatewayv2(
        "DELETE",
        "/v2/tags/$(resource-arn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resource_arn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "DELETE",
        "/v2/tags/$(resource-arn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_api(api_id)
    update_api(api_id, params::Dict{String,<:Any})

Updates an Api resource.

# Arguments
- `api_id`: The API identifier.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"apiKeySelectionExpression"`: An API key selection expression. Supported only for
  WebSocket APIs. See API Key Selection Expressions.
- `"corsConfiguration"`: A CORS configuration. Supported only for HTTP APIs.
- `"credentialsArn"`: This property is part of quick create. It specifies the credentials
  required for the integration, if any. For a Lambda integration, three options are
  available. To specify an IAM Role for API Gateway to assume, use the role's Amazon Resource
  Name (ARN). To require that the caller's identity be passed through from the request,
  specify arn:aws:iam::*:user/*. To use resource-based permissions on supported AWS services,
  don't specify this parameter. Currently, this property is not used for HTTP integrations.
  If provided, this value replaces the credentials associated with the quick create
  integration. Supported only for HTTP APIs.
- `"description"`: The description of the API.
- `"disableExecuteApiEndpoint"`: Specifies whether clients can invoke your API by using the
  default execute-api endpoint. By default, clients can invoke your API with the default
  https://{api_id}.execute-api.{region}.amazonaws.com endpoint. To require that clients use a
  custom domain name to invoke your API, disable the default endpoint.
- `"disableSchemaValidation"`: Avoid validating models when creating a deployment.
  Supported only for WebSocket APIs.
- `"name"`: The name of the API.
- `"routeKey"`: This property is part of quick create. If not specified, the route created
  using quick create is kept. Otherwise, this value replaces the route key of the quick
  create route. Additional routes may still be added after the API is updated. Supported only
  for HTTP APIs.
- `"routeSelectionExpression"`: The route selection expression for the API. For HTTP APIs,
  the routeSelectionExpression must be {request.method} {request.path}. If not provided, this
  will be the default for HTTP APIs. This property is required for WebSocket APIs.
- `"target"`: This property is part of quick create. For HTTP integrations, specify a fully
  qualified URL. For Lambda integrations, specify a function ARN. The type of the integration
  will be HTTP_PROXY or AWS_PROXY, respectively. The value provided updates the integration
  URI and integration type. You can update a quick-created target, but you can't remove it
  from an API. Supported only for HTTP APIs.
- `"version"`: A version identifier for the API.
"""
function update_api(apiId; aws_config::AbstractAWSConfig=current_aws_config())
    return apigatewayv2(
        "PATCH", "/v2/apis/$(apiId)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function update_api(
    apiId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apigatewayv2(
        "PATCH",
        "/v2/apis/$(apiId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_api_mapping(api_id, api_mapping_id, domain_name)
    update_api_mapping(api_id, api_mapping_id, domain_name, params::Dict{String,<:Any})

The API mapping.

# Arguments
- `api_id`: The API identifier.
- `api_mapping_id`: The API mapping identifier.
- `domain_name`: The domain name.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"apiMappingKey"`: The API mapping key.
- `"stage"`: The API stage.
"""
function update_api_mapping(
    apiId, apiMappingId, domainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apigatewayv2(
        "PATCH",
        "/v2/domainnames/$(domainName)/apimappings/$(apiMappingId)",
        Dict{String,Any}("apiId" => apiId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_api_mapping(
    apiId,
    apiMappingId,
    domainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "PATCH",
        "/v2/domainnames/$(domainName)/apimappings/$(apiMappingId)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("apiId" => apiId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_authorizer(api_id, authorizer_id)
    update_authorizer(api_id, authorizer_id, params::Dict{String,<:Any})

Updates an Authorizer.

# Arguments
- `api_id`: The API identifier.
- `authorizer_id`: The authorizer identifier.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"authorizerCredentialsArn"`: Specifies the required credentials as an IAM role for API
  Gateway to invoke the authorizer. To specify an IAM role for API Gateway to assume, use the
  role's Amazon Resource Name (ARN). To use resource-based permissions on the Lambda
  function, don't specify this parameter.
- `"authorizerPayloadFormatVersion"`: Specifies the format of the payload sent to an HTTP
  API Lambda authorizer. Required for HTTP API Lambda authorizers. Supported values are 1.0
  and 2.0. To learn more, see Working with AWS Lambda authorizers for HTTP APIs.
- `"authorizerResultTtlInSeconds"`: The time to live (TTL) for cached authorizer results,
  in seconds. If it equals 0, authorization caching is disabled. If it is greater than 0, API
  Gateway caches authorizer responses. The maximum value is 3600, or 1 hour. Supported only
  for HTTP API Lambda authorizers.
- `"authorizerType"`: The authorizer type. Specify REQUEST for a Lambda function using
  incoming request parameters. Specify JWT to use JSON Web Tokens (supported only for HTTP
  APIs).
- `"authorizerUri"`: The authorizer's Uniform Resource Identifier (URI). For REQUEST
  authorizers, this must be a well-formed Lambda function URI, for example,
  arn:aws:apigateway:us-west-2:lambda:path/2015-03-31/functions/arn:aws:lambda:us-west-2:{acco
  unt_id}:function:{lambda_function_name}/invocations. In general, the URI has this form:
  arn:aws:apigateway:{region}:lambda:path/{service_api}
               , where {region} is
  the same as the region hosting the Lambda function, path indicates that the remaining
  substring in the URI should be treated as the path to the resource, including the initial
  /. For Lambda functions, this is usually of the form
  /2015-03-31/functions/[FunctionARN]/invocations. Supported only for REQUEST authorizers.
- `"enableSimpleResponses"`: Specifies whether a Lambda authorizer returns a response in a
  simple format. By default, a Lambda authorizer must return an IAM policy. If enabled, the
  Lambda authorizer can return a boolean value instead of an IAM policy. Supported only for
  HTTP APIs. To learn more, see Working with AWS Lambda authorizers for HTTP APIs
- `"identitySource"`: The identity source for which authorization is requested. For a
  REQUEST authorizer, this is optional. The value is a set of one or more mapping expressions
  of the specified request parameters. The identity source can be headers, query string
  parameters, stage variables, and context parameters. For example, if an Auth header and a
  Name query string parameter are defined as identity sources, this value is
  route.request.header.Auth, route.request.querystring.Name for WebSocket APIs. For HTTP
  APIs, use selection expressions prefixed with , for example, request.header.Auth,
  request.querystring.Name. These parameters are used to perform runtime validation for
  Lambda-based authorizers by verifying all of the identity-related request parameters are
  present in the request, not null, and non-empty. Only when this is true does the authorizer
  invoke the authorizer Lambda function. Otherwise, it returns a 401 Unauthorized response
  without calling the Lambda function. For HTTP APIs, identity sources are also used as the
  cache key when caching is enabled. To learn more, see Working with AWS Lambda authorizers
  for HTTP APIs. For JWT, a single entry that specifies where to extract the JSON Web Token
  (JWT) from inbound requests. Currently only header-based and query parameter-based
  selections are supported, for example request.header.Authorization.
- `"identityValidationExpression"`: This parameter is not used.
- `"jwtConfiguration"`: Represents the configuration of a JWT authorizer. Required for the
  JWT authorizer type. Supported only for HTTP APIs.
- `"name"`: The name of the authorizer.
"""
function update_authorizer(
    apiId, authorizerId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apigatewayv2(
        "PATCH",
        "/v2/apis/$(apiId)/authorizers/$(authorizerId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_authorizer(
    apiId,
    authorizerId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "PATCH",
        "/v2/apis/$(apiId)/authorizers/$(authorizerId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_deployment(api_id, deployment_id)
    update_deployment(api_id, deployment_id, params::Dict{String,<:Any})

Updates a Deployment.

# Arguments
- `api_id`: The API identifier.
- `deployment_id`: The deployment ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description for the deployment resource.
"""
function update_deployment(
    apiId, deploymentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apigatewayv2(
        "PATCH",
        "/v2/apis/$(apiId)/deployments/$(deploymentId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_deployment(
    apiId,
    deploymentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "PATCH",
        "/v2/apis/$(apiId)/deployments/$(deploymentId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_domain_name(domain_name)
    update_domain_name(domain_name, params::Dict{String,<:Any})

Updates a domain name.

# Arguments
- `domain_name`: The domain name.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"domainNameConfigurations"`: The domain name configurations.
- `"mutualTlsAuthentication"`: The mutual TLS authentication configuration for a custom
  domain name.
"""
function update_domain_name(domainName; aws_config::AbstractAWSConfig=current_aws_config())
    return apigatewayv2(
        "PATCH",
        "/v2/domainnames/$(domainName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_domain_name(
    domainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "PATCH",
        "/v2/domainnames/$(domainName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_integration(api_id, integration_id)
    update_integration(api_id, integration_id, params::Dict{String,<:Any})

Updates an Integration.

# Arguments
- `api_id`: The API identifier.
- `integration_id`: The integration ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"connectionId"`: The ID of the VPC link for a private integration. Supported only for
  HTTP APIs.
- `"connectionType"`: The type of the network connection to the integration endpoint.
  Specify INTERNET for connections through the public routable internet or VPC_LINK for
  private connections between API Gateway and resources in a VPC. The default value is
  INTERNET.
- `"contentHandlingStrategy"`: Supported only for WebSocket APIs. Specifies how to handle
  response payload content type conversions. Supported values are CONVERT_TO_BINARY and
  CONVERT_TO_TEXT, with the following behaviors: CONVERT_TO_BINARY: Converts a response
  payload from a Base64-encoded string to the corresponding binary blob. CONVERT_TO_TEXT:
  Converts a response payload from a binary blob to a Base64-encoded string. If this property
  is not defined, the response payload will be passed through from the integration response
  to the route response or method response without modification.
- `"credentialsArn"`: Specifies the credentials required for the integration, if any. For
  AWS integrations, three options are available. To specify an IAM Role for API Gateway to
  assume, use the role's Amazon Resource Name (ARN). To require that the caller's identity be
  passed through from the request, specify the string arn:aws:iam::*:user/*. To use
  resource-based permissions on supported AWS services, specify null.
- `"description"`: The description of the integration
- `"integrationMethod"`: Specifies the integration's HTTP method type.
- `"integrationSubtype"`: Supported only for HTTP API AWS_PROXY integrations. Specifies the
  AWS service action to invoke. To learn more, see Integration subtype reference.
- `"integrationType"`: The integration type of an integration. One of the following: AWS:
  for integrating the route or method request with an AWS service action, including the
  Lambda function-invoking action. With the Lambda function-invoking action, this is referred
  to as the Lambda custom integration. With any other AWS service action, this is known as
  AWS integration. Supported only for WebSocket APIs. AWS_PROXY: for integrating the route or
  method request with a Lambda function or other AWS service action. This integration is also
  referred to as a Lambda proxy integration. HTTP: for integrating the route or method
  request with an HTTP endpoint. This integration is also referred to as the HTTP custom
  integration. Supported only for WebSocket APIs. HTTP_PROXY: for integrating the route or
  method request with an HTTP endpoint, with the client request passed through as-is. This is
  also referred to as HTTP proxy integration. For HTTP API private integrations, use an
  HTTP_PROXY integration. MOCK: for integrating the route or method request with API Gateway
  as a \"loopback\" endpoint without invoking any backend. Supported only for WebSocket APIs.
- `"integrationUri"`: For a Lambda integration, specify the URI of a Lambda function. For
  an HTTP integration, specify a fully-qualified URL. For an HTTP API private integration,
  specify the ARN of an Application Load Balancer listener, Network Load Balancer listener,
  or AWS Cloud Map service. If you specify the ARN of an AWS Cloud Map service, API Gateway
  uses DiscoverInstances to identify resources. You can use query parameters to target
  specific resources. To learn more, see DiscoverInstances. For private integrations, all
  resources must be owned by the same AWS account.
- `"passthroughBehavior"`: Specifies the pass-through behavior for incoming requests based
  on the Content-Type header in the request, and the available mapping templates specified as
  the requestTemplates property on the Integration resource. There are three valid values:
  WHEN_NO_MATCH, WHEN_NO_TEMPLATES, and NEVER. Supported only for WebSocket APIs.
  WHEN_NO_MATCH passes the request body for unmapped content types through to the integration
  backend without transformation. NEVER rejects unmapped content types with an HTTP 415
  Unsupported Media Type response. WHEN_NO_TEMPLATES allows pass-through when the integration
  has no content types mapped to templates. However, if there is at least one content type
  defined, unmapped content types will be rejected with the same HTTP 415 Unsupported Media
  Type response.
- `"payloadFormatVersion"`: Specifies the format of the payload sent to an integration.
  Required for HTTP APIs.
- `"requestParameters"`: For WebSocket APIs, a key-value map specifying request parameters
  that are passed from the method request to the backend. The key is an integration request
  parameter name and the associated value is a method request parameter value or static value
  that must be enclosed within single quotes and pre-encoded as required by the backend. The
  method request parameter value must match the pattern of method.request.{location}.{name}
          , where 
            {location}
           is querystring, path, or header; and
           {name}
           must be a valid and unique method request parameter name. For
  HTTP API integrations with a specified integrationSubtype, request parameters are a
  key-value map specifying parameters that are passed to AWS_PROXY integrations. You can
  provide static values, or map request data, stage variables, or context variables that are
  evaluated at runtime. To learn more, see Working with AWS service integrations for HTTP
  APIs. For HTTP API integrations, without a specified integrationSubtype request parameters
  are a key-value map specifying how to transform HTTP requests before sending them to the
  backend. The key should follow the pattern
  &lt;action&gt;:&lt;header|querystring|path&gt;.&lt;location&gt; where action can be append,
  overwrite or remove. For values, you can provide static values, or map request data, stage
  variables, or context variables that are evaluated at runtime. To learn more, see
  Transforming API requests and responses.
- `"requestTemplates"`: Represents a map of Velocity templates that are applied on the
  request payload based on the value of the Content-Type header sent by the client. The
  content type value is the key in this map, and the template (as a String) is the value.
  Supported only for WebSocket APIs.
- `"responseParameters"`: Supported only for HTTP APIs. You use response parameters to
  transform the HTTP response from a backend integration before returning the response to
  clients. Specify a key-value map from a selection key to response parameters. The selection
  key must be a valid HTTP status code within the range of 200-599. Response parameters are a
  key-value map. The key must match pattern &lt;action&gt;:&lt;header&gt;.&lt;location&gt; or
  overwrite.statuscode. The action can be append, overwrite or remove. The value can be a
  static value, or map to response data, stage variables, or context variables that are
  evaluated at runtime. To learn more, see Transforming API requests and responses.
- `"templateSelectionExpression"`: The template selection expression for the integration.
- `"timeoutInMillis"`: Custom timeout between 50 and 29,000 milliseconds for WebSocket APIs
  and between 50 and 30,000 milliseconds for HTTP APIs. The default timeout is 29 seconds for
  WebSocket APIs and 30 seconds for HTTP APIs.
- `"tlsConfig"`: The TLS configuration for a private integration. If you specify a TLS
  configuration, private integration traffic uses the HTTPS protocol. Supported only for HTTP
  APIs.
"""
function update_integration(
    apiId, integrationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apigatewayv2(
        "PATCH",
        "/v2/apis/$(apiId)/integrations/$(integrationId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_integration(
    apiId,
    integrationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "PATCH",
        "/v2/apis/$(apiId)/integrations/$(integrationId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_integration_response(api_id, integration_id, integration_response_id)
    update_integration_response(api_id, integration_id, integration_response_id, params::Dict{String,<:Any})

Updates an IntegrationResponses.

# Arguments
- `api_id`: The API identifier.
- `integration_id`: The integration ID.
- `integration_response_id`: The integration response ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"contentHandlingStrategy"`: Supported only for WebSocket APIs. Specifies how to handle
  response payload content type conversions. Supported values are CONVERT_TO_BINARY and
  CONVERT_TO_TEXT, with the following behaviors: CONVERT_TO_BINARY: Converts a response
  payload from a Base64-encoded string to the corresponding binary blob. CONVERT_TO_TEXT:
  Converts a response payload from a binary blob to a Base64-encoded string. If this property
  is not defined, the response payload will be passed through from the integration response
  to the route response or method response without modification.
- `"integrationResponseKey"`: The integration response key.
- `"responseParameters"`: A key-value map specifying response parameters that are passed to
  the method response from the backend. The key is a method response header parameter name
  and the mapped value is an integration response header value, a static value enclosed
  within a pair of single quotes, or a JSON expression from the integration response body.
  The mapping key must match the pattern of method.response.header.{name}
               ,
  where name is a valid and unique header name. The mapped non-static value must match the
  pattern of integration.response.header.{name}
                or
  integration.response.body.{JSON-expression}
               , where
  {name}
                is a valid and unique response header name and
  {JSON-expression}
                is a valid JSON expression without the  prefix.
- `"responseTemplates"`: The collection of response templates for the integration response
  as a string-to-string map of key-value pairs. Response templates are represented as a
  key/value map, with a content-type as the key and a template as the value.
- `"templateSelectionExpression"`: The template selection expression for the integration
  response. Supported only for WebSocket APIs.
"""
function update_integration_response(
    apiId,
    integrationId,
    integrationResponseId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "PATCH",
        "/v2/apis/$(apiId)/integrations/$(integrationId)/integrationresponses/$(integrationResponseId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_integration_response(
    apiId,
    integrationId,
    integrationResponseId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "PATCH",
        "/v2/apis/$(apiId)/integrations/$(integrationId)/integrationresponses/$(integrationResponseId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_model(api_id, model_id)
    update_model(api_id, model_id, params::Dict{String,<:Any})

Updates a Model.

# Arguments
- `api_id`: The API identifier.
- `model_id`: The model ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"contentType"`: The content-type for the model, for example, \"application/json\".
- `"description"`: The description of the model.
- `"name"`: The name of the model.
- `"schema"`: The schema for the model. For application/json models, this should be JSON
  schema draft 4 model.
"""
function update_model(apiId, modelId; aws_config::AbstractAWSConfig=current_aws_config())
    return apigatewayv2(
        "PATCH",
        "/v2/apis/$(apiId)/models/$(modelId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_model(
    apiId,
    modelId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "PATCH",
        "/v2/apis/$(apiId)/models/$(modelId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_route(api_id, route_id)
    update_route(api_id, route_id, params::Dict{String,<:Any})

Updates a Route.

# Arguments
- `api_id`: The API identifier.
- `route_id`: The route ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"apiKeyRequired"`: Specifies whether an API key is required for the route. Supported
  only for WebSocket APIs.
- `"authorizationScopes"`: The authorization scopes supported by this route.
- `"authorizationType"`: The authorization type for the route. For WebSocket APIs, valid
  values are NONE for open access, AWS_IAM for using AWS IAM permissions, and CUSTOM for
  using a Lambda authorizer For HTTP APIs, valid values are NONE for open access, JWT for
  using JSON Web Tokens, AWS_IAM for using AWS IAM permissions, and CUSTOM for using a Lambda
  authorizer.
- `"authorizerId"`: The identifier of the Authorizer resource to be associated with this
  route. The authorizer identifier is generated by API Gateway when you created the
  authorizer.
- `"modelSelectionExpression"`: The model selection expression for the route. Supported
  only for WebSocket APIs.
- `"operationName"`: The operation name for the route.
- `"requestModels"`: The request models for the route. Supported only for WebSocket APIs.
- `"requestParameters"`: The request parameters for the route. Supported only for WebSocket
  APIs.
- `"routeKey"`: The route key for the route.
- `"routeResponseSelectionExpression"`: The route response selection expression for the
  route. Supported only for WebSocket APIs.
- `"target"`: The target for the route.
"""
function update_route(apiId, routeId; aws_config::AbstractAWSConfig=current_aws_config())
    return apigatewayv2(
        "PATCH",
        "/v2/apis/$(apiId)/routes/$(routeId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_route(
    apiId,
    routeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "PATCH",
        "/v2/apis/$(apiId)/routes/$(routeId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_route_response(api_id, route_id, route_response_id)
    update_route_response(api_id, route_id, route_response_id, params::Dict{String,<:Any})

Updates a RouteResponse.

# Arguments
- `api_id`: The API identifier.
- `route_id`: The route ID.
- `route_response_id`: The route response ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"modelSelectionExpression"`: The model selection expression for the route response.
  Supported only for WebSocket APIs.
- `"responseModels"`: The response models for the route response.
- `"responseParameters"`: The route response parameters.
- `"routeResponseKey"`: The route response key.
"""
function update_route_response(
    apiId, routeId, routeResponseId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apigatewayv2(
        "PATCH",
        "/v2/apis/$(apiId)/routes/$(routeId)/routeresponses/$(routeResponseId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_route_response(
    apiId,
    routeId,
    routeResponseId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "PATCH",
        "/v2/apis/$(apiId)/routes/$(routeId)/routeresponses/$(routeResponseId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_stage(api_id, stage_name)
    update_stage(api_id, stage_name, params::Dict{String,<:Any})

Updates a Stage.

# Arguments
- `api_id`: The API identifier.
- `stage_name`: The stage name. Stage names can contain only alphanumeric characters,
  hyphens, and underscores, or be default. Maximum length is 128 characters.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accessLogSettings"`: Settings for logging access in this stage.
- `"autoDeploy"`: Specifies whether updates to an API automatically trigger a new
  deployment. The default value is false.
- `"clientCertificateId"`: The identifier of a client certificate for a Stage.
- `"defaultRouteSettings"`: The default route settings for the stage.
- `"deploymentId"`: The deployment identifier for the API stage. Can't be updated if
  autoDeploy is enabled.
- `"description"`: The description for the API stage.
- `"routeSettings"`: Route settings for the stage.
- `"stageVariables"`: A map that defines the stage variables for a Stage. Variable names
  can have alphanumeric and underscore characters, and the values must match
  [A-Za-z0-9-._~:/?#&amp;=,]+.
"""
function update_stage(apiId, stageName; aws_config::AbstractAWSConfig=current_aws_config())
    return apigatewayv2(
        "PATCH",
        "/v2/apis/$(apiId)/stages/$(stageName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_stage(
    apiId,
    stageName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "PATCH",
        "/v2/apis/$(apiId)/stages/$(stageName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_vpc_link(vpc_link_id)
    update_vpc_link(vpc_link_id, params::Dict{String,<:Any})

Updates a VPC link.

# Arguments
- `vpc_link_id`: The ID of the VPC link.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"name"`: The name of the VPC link.
"""
function update_vpc_link(vpcLinkId; aws_config::AbstractAWSConfig=current_aws_config())
    return apigatewayv2(
        "PATCH",
        "/v2/vpclinks/$(vpcLinkId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_vpc_link(
    vpcLinkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewayv2(
        "PATCH",
        "/v2/vpclinks/$(vpcLinkId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: scheduler
using AWS.Compat
using AWS.UUIDs

"""
    create_schedule(flexible_time_window, name, schedule_expression, target)
    create_schedule(flexible_time_window, name, schedule_expression, target, params::Dict{String,<:Any})

Creates the specified schedule.

# Arguments
- `flexible_time_window`: Allows you to configure a time window during which EventBridge
  Scheduler invokes the schedule.
- `name`: The name of the schedule that you are creating.
- `schedule_expression`:  The expression that defines when the schedule runs. The following
  formats are supported.     at expression - at(yyyy-mm-ddThh:mm:ss)     rate expression -
  rate(value unit)     cron expression - cron(fields)     You can use at expressions to
  create one-time schedules that invoke a target once, at the time and in the time zone, that
  you specify. You can use rate and cron expressions to create recurring schedules.
  Rate-based schedules are useful when you want to invoke a target at regular intervals, such
  as every 15 minutes or every five days. Cron-based schedules are useful when you want to
  invoke a target periodically at a specific time, such as at 8:00 am (UTC+0) every 1st day
  of the month.   A cron expression consists of six fields separated by white spaces:
  (minutes hours day_of_month month day_of_week year).   A rate expression consists of a
  value as a positive integer, and a unit with the following options: minute | minutes | hour
  | hours | day | days   For more information and examples, see Schedule types on EventBridge
  Scheduler in the EventBridge Scheduler User Guide.
- `target`: The schedule's target.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ActionAfterCompletion"`: Specifies the action that EventBridge Scheduler applies to the
  schedule after the schedule completes invoking the target.
- `"ClientToken"`:  Unique, case-sensitive identifier you provide to ensure the idempotency
  of the request. If you do not specify a client token, EventBridge Scheduler uses a randomly
  generated token for the request to ensure idempotency.
- `"Description"`: The description you specify for the schedule.
- `"EndDate"`: The date, in UTC, before which the schedule can invoke its target. Depending
  on the schedule's recurrence expression, invocations might stop on, or before, the EndDate
  you specify. EventBridge Scheduler ignores EndDate for one-time schedules.
- `"GroupName"`: The name of the schedule group to associate with this schedule. If you
  omit this, the default schedule group is used.
- `"KmsKeyArn"`: The Amazon Resource Name (ARN) for the customer managed KMS key that
  EventBridge Scheduler will use to encrypt and decrypt your data.
- `"ScheduleExpressionTimezone"`: The timezone in which the scheduling expression is
  evaluated.
- `"StartDate"`: The date, in UTC, after which the schedule can begin invoking its target.
  Depending on the schedule's recurrence expression, invocations might occur on, or after,
  the StartDate you specify. EventBridge Scheduler ignores StartDate for one-time schedules.
- `"State"`: Specifies whether the schedule is enabled or disabled.
"""
function create_schedule(
    FlexibleTimeWindow,
    Name,
    ScheduleExpression,
    Target;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return scheduler(
        "POST",
        "/schedules/$(Name)",
        Dict{String,Any}(
            "FlexibleTimeWindow" => FlexibleTimeWindow,
            "ScheduleExpression" => ScheduleExpression,
            "Target" => Target,
            "ClientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_schedule(
    FlexibleTimeWindow,
    Name,
    ScheduleExpression,
    Target,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return scheduler(
        "POST",
        "/schedules/$(Name)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "FlexibleTimeWindow" => FlexibleTimeWindow,
                    "ScheduleExpression" => ScheduleExpression,
                    "Target" => Target,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_schedule_group(name)
    create_schedule_group(name, params::Dict{String,<:Any})

Creates the specified schedule group.

# Arguments
- `name`: The name of the schedule group that you are creating.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`:  Unique, case-sensitive identifier you provide to ensure the idempotency
  of the request. If you do not specify a client token, EventBridge Scheduler uses a randomly
  generated token for the request to ensure idempotency.
- `"Tags"`: The list of tags to associate with the schedule group.
"""
function create_schedule_group(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return scheduler(
        "POST",
        "/schedule-groups/$(Name)",
        Dict{String,Any}("ClientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_schedule_group(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return scheduler(
        "POST",
        "/schedule-groups/$(Name)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ClientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_schedule(name)
    delete_schedule(name, params::Dict{String,<:Any})

Deletes the specified schedule.

# Arguments
- `name`: The name of the schedule to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`:  Unique, case-sensitive identifier you provide to ensure the idempotency
  of the request. If you do not specify a client token, EventBridge Scheduler uses a randomly
  generated token for the request to ensure idempotency.
- `"groupName"`: The name of the schedule group associated with this schedule. If you omit
  this, the default schedule group is used.
"""
function delete_schedule(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return scheduler(
        "DELETE",
        "/schedules/$(Name)",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_schedule(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return scheduler(
        "DELETE",
        "/schedules/$(Name)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_schedule_group(name)
    delete_schedule_group(name, params::Dict{String,<:Any})

Deletes the specified schedule group. Deleting a schedule group results in EventBridge
Scheduler deleting all schedules associated with the group. When you delete a group, it
remains in a DELETING state until all of its associated schedules are deleted. Schedules
associated with the group that are set to run while the schedule group is in the process of
being deleted might continue to invoke their targets until the schedule group and its
associated schedules are deleted.   This operation is eventually consistent.

# Arguments
- `name`: The name of the schedule group to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`:  Unique, case-sensitive identifier you provide to ensure the idempotency
  of the request. If you do not specify a client token, EventBridge Scheduler uses a randomly
  generated token for the request to ensure idempotency.
"""
function delete_schedule_group(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return scheduler(
        "DELETE",
        "/schedule-groups/$(Name)",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_schedule_group(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return scheduler(
        "DELETE",
        "/schedule-groups/$(Name)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_schedule(name)
    get_schedule(name, params::Dict{String,<:Any})

Retrieves the specified schedule.

# Arguments
- `name`: The name of the schedule to retrieve.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"groupName"`: The name of the schedule group associated with this schedule. If you omit
  this, EventBridge Scheduler assumes that the schedule is associated with the default group.
"""
function get_schedule(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return scheduler(
        "GET", "/schedules/$(Name)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_schedule(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return scheduler(
        "GET",
        "/schedules/$(Name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_schedule_group(name)
    get_schedule_group(name, params::Dict{String,<:Any})

Retrieves the specified schedule group.

# Arguments
- `name`: The name of the schedule group to retrieve.

"""
function get_schedule_group(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return scheduler(
        "GET",
        "/schedule-groups/$(Name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_schedule_group(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return scheduler(
        "GET",
        "/schedule-groups/$(Name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_schedule_groups()
    list_schedule_groups(params::Dict{String,<:Any})

Returns a paginated list of your schedule groups.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: If specified, limits the number of results returned by this operation.
  The operation also returns a NextToken which you can use in a subsequent operation to
  retrieve the next set of results.
- `"NamePrefix"`: The name prefix that you can use to return a filtered list of your
  schedule groups.
- `"NextToken"`: The token returned by a previous call to retrieve the next set of results.
"""
function list_schedule_groups(; aws_config::AbstractAWSConfig=current_aws_config())
    return scheduler(
        "GET", "/schedule-groups"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_schedule_groups(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return scheduler(
        "GET",
        "/schedule-groups",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_schedules()
    list_schedules(params::Dict{String,<:Any})

Returns a paginated list of your EventBridge Scheduler schedules.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: If specified, limits the number of results returned by this operation.
  The operation also returns a NextToken which you can use in a subsequent operation to
  retrieve the next set of results.
- `"NamePrefix"`: Schedule name prefix to return the filtered list of resources.
- `"NextToken"`: The token returned by a previous call to retrieve the next set of results.
- `"ScheduleGroup"`: If specified, only lists the schedules whose associated schedule group
  matches the given filter.
- `"State"`: If specified, only lists the schedules whose current state matches the given
  filter.
"""
function list_schedules(; aws_config::AbstractAWSConfig=current_aws_config())
    return scheduler(
        "GET", "/schedules"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_schedules(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return scheduler(
        "GET", "/schedules", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists the tags associated with the Scheduler resource.

# Arguments
- `resource_arn`: The ARN of the EventBridge Scheduler resource for which you want to view
  tags.

"""
function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return scheduler(
        "GET",
        "/tags/$(ResourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return scheduler(
        "GET",
        "/tags/$(ResourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Assigns one or more tags (key-value pairs) to the specified EventBridge Scheduler resource.
You can only assign tags to schedule groups.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the schedule group that you are adding
  tags to.
- `tags`: The list of tags to associate with the schedule group.

"""
function tag_resource(ResourceArn, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return scheduler(
        "POST",
        "/tags/$(ResourceArn)",
        Dict{String,Any}("Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceArn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return scheduler(
        "POST",
        "/tags/$(ResourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Tags" => Tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes one or more tags from the specified EventBridge Scheduler schedule group.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the schedule group from which you are
  removing tags.
- `tag_keys`: The list of tag keys to remove from the resource.

"""
function untag_resource(
    ResourceArn, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return scheduler(
        "DELETE",
        "/tags/$(ResourceArn)",
        Dict{String,Any}("TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceArn,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return scheduler(
        "DELETE",
        "/tags/$(ResourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("TagKeys" => TagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_schedule(flexible_time_window, name, schedule_expression, target)
    update_schedule(flexible_time_window, name, schedule_expression, target, params::Dict{String,<:Any})

 Updates the specified schedule. When you call UpdateSchedule, EventBridge Scheduler uses
all values, including empty values, specified in the request and overrides the existing
schedule. This is by design. This means that if you do not set an optional field in your
request, that field will be set to its system-default value after the update.   Before
calling this operation, we recommend that you call the GetSchedule API operation and make a
note of all optional parameters for your UpdateSchedule call.

# Arguments
- `flexible_time_window`: Allows you to configure a time window during which EventBridge
  Scheduler invokes the schedule.
- `name`: The name of the schedule that you are updating.
- `schedule_expression`:  The expression that defines when the schedule runs. The following
  formats are supported.     at expression - at(yyyy-mm-ddThh:mm:ss)     rate expression -
  rate(value unit)     cron expression - cron(fields)     You can use at expressions to
  create one-time schedules that invoke a target once, at the time and in the time zone, that
  you specify. You can use rate and cron expressions to create recurring schedules.
  Rate-based schedules are useful when you want to invoke a target at regular intervals, such
  as every 15 minutes or every five days. Cron-based schedules are useful when you want to
  invoke a target periodically at a specific time, such as at 8:00 am (UTC+0) every 1st day
  of the month.   A cron expression consists of six fields separated by white spaces:
  (minutes hours day_of_month month day_of_week year).   A rate expression consists of a
  value as a positive integer, and a unit with the following options: minute | minutes | hour
  | hours | day | days   For more information and examples, see Schedule types on EventBridge
  Scheduler in the EventBridge Scheduler User Guide.
- `target`: The schedule target. You can use this operation to change the target that your
  schedule invokes.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ActionAfterCompletion"`: Specifies the action that EventBridge Scheduler applies to the
  schedule after the schedule completes invoking the target.
- `"ClientToken"`:  Unique, case-sensitive identifier you provide to ensure the idempotency
  of the request. If you do not specify a client token, EventBridge Scheduler uses a randomly
  generated token for the request to ensure idempotency.
- `"Description"`: The description you specify for the schedule.
- `"EndDate"`: The date, in UTC, before which the schedule can invoke its target. Depending
  on the schedule's recurrence expression, invocations might stop on, or before, the EndDate
  you specify. EventBridge Scheduler ignores EndDate for one-time schedules.
- `"GroupName"`: The name of the schedule group with which the schedule is associated. You
  must provide this value in order for EventBridge Scheduler to find the schedule you want to
  update. If you omit this value, EventBridge Scheduler assumes the group is associated to
  the default group.
- `"KmsKeyArn"`: The ARN for the customer managed KMS key that that you want EventBridge
  Scheduler to use to encrypt and decrypt your data.
- `"ScheduleExpressionTimezone"`: The timezone in which the scheduling expression is
  evaluated.
- `"StartDate"`: The date, in UTC, after which the schedule can begin invoking its target.
  Depending on the schedule's recurrence expression, invocations might occur on, or after,
  the StartDate you specify. EventBridge Scheduler ignores StartDate for one-time schedules.
- `"State"`: Specifies whether the schedule is enabled or disabled.
"""
function update_schedule(
    FlexibleTimeWindow,
    Name,
    ScheduleExpression,
    Target;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return scheduler(
        "PUT",
        "/schedules/$(Name)",
        Dict{String,Any}(
            "FlexibleTimeWindow" => FlexibleTimeWindow,
            "ScheduleExpression" => ScheduleExpression,
            "Target" => Target,
            "ClientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_schedule(
    FlexibleTimeWindow,
    Name,
    ScheduleExpression,
    Target,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return scheduler(
        "PUT",
        "/schedules/$(Name)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "FlexibleTimeWindow" => FlexibleTimeWindow,
                    "ScheduleExpression" => ScheduleExpression,
                    "Target" => Target,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: apigatewaymanagementapi
using AWS.Compat
using AWS.UUIDs

"""
    delete_connection(connection_id)
    delete_connection(connection_id, params::Dict{String,<:Any})

Delete the connection with the provided id.

# Arguments
- `connection_id`:

"""
function delete_connection(connectionId; aws_config::AbstractAWSConfig=current_aws_config())
    return apigatewaymanagementapi(
        "DELETE",
        "/@connections/$(connectionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_connection(
    connectionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewaymanagementapi(
        "DELETE",
        "/@connections/$(connectionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_connection(connection_id)
    get_connection(connection_id, params::Dict{String,<:Any})

Get information about the connection with the provided id.

# Arguments
- `connection_id`:

"""
function get_connection(connectionId; aws_config::AbstractAWSConfig=current_aws_config())
    return apigatewaymanagementapi(
        "GET",
        "/@connections/$(connectionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_connection(
    connectionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewaymanagementapi(
        "GET",
        "/@connections/$(connectionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    post_to_connection(data, connection_id)
    post_to_connection(data, connection_id, params::Dict{String,<:Any})

Sends the provided data to the specified connection.

# Arguments
- `data`: The data to be sent to the client specified by its connection id.
- `connection_id`: The identifier of the connection that a specific client is using.

"""
function post_to_connection(
    Data, connectionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apigatewaymanagementapi(
        "POST",
        "/@connections/$(connectionId)",
        Dict{String,Any}("Data" => Data);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function post_to_connection(
    Data,
    connectionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apigatewaymanagementapi(
        "POST",
        "/@connections/$(connectionId)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Data" => Data), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: data_pipeline
using AWS.Compat
using AWS.UUIDs

"""
    activate_pipeline(pipeline_id)
    activate_pipeline(pipeline_id, params::Dict{String,<:Any})

Validates the specified pipeline and starts processing pipeline tasks. If the pipeline does
not pass validation, activation fails. If you need to pause the pipeline to investigate an
issue with a component, such as a data source or script, call DeactivatePipeline. To
activate a finished pipeline, modify the end date for the pipeline and then activate it.

# Arguments
- `pipeline_id`: The ID of the pipeline.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"parameterValues"`: A list of parameter values to pass to the pipeline at activation.
- `"startTimestamp"`: The date and time to resume the pipeline. By default, the pipeline
  resumes from the last completed execution.
"""
function activate_pipeline(pipelineId; aws_config::AbstractAWSConfig=current_aws_config())
    return data_pipeline(
        "ActivatePipeline",
        Dict{String,Any}("pipelineId" => pipelineId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function activate_pipeline(
    pipelineId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return data_pipeline(
        "ActivatePipeline",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("pipelineId" => pipelineId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    add_tags(pipeline_id, tags)
    add_tags(pipeline_id, tags, params::Dict{String,<:Any})

Adds or modifies tags for the specified pipeline.

# Arguments
- `pipeline_id`: The ID of the pipeline.
- `tags`: The tags to add, as key/value pairs.

"""
function add_tags(pipelineId, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return data_pipeline(
        "AddTags",
        Dict{String,Any}("pipelineId" => pipelineId, "tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_tags(
    pipelineId,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return data_pipeline(
        "AddTags",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("pipelineId" => pipelineId, "tags" => tags), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_pipeline(name, unique_id)
    create_pipeline(name, unique_id, params::Dict{String,<:Any})

Creates a new, empty pipeline. Use PutPipelineDefinition to populate the pipeline.

# Arguments
- `name`: The name for the pipeline. You can use the same name for multiple pipelines
  associated with your AWS account, because AWS Data Pipeline assigns each pipeline a unique
  pipeline identifier.
- `unique_id`: A unique identifier. This identifier is not the same as the pipeline
  identifier assigned by AWS Data Pipeline. You are responsible for defining the format and
  ensuring the uniqueness of this identifier. You use this parameter to ensure idempotency
  during repeated calls to CreatePipeline. For example, if the first call to CreatePipeline
  does not succeed, you can pass in the same unique identifier and pipeline name combination
  on a subsequent call to CreatePipeline. CreatePipeline ensures that if a pipeline already
  exists with the same name and unique identifier, a new pipeline is not created. Instead,
  you'll receive the pipeline identifier from the previous attempt. The uniqueness of the
  name and unique identifier combination is scoped to the AWS account or IAM user credentials.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description for the pipeline.
- `"tags"`: A list of tags to associate with the pipeline at creation. Tags let you control
  access to pipelines. For more information, see Controlling User Access to Pipelines in the
  AWS Data Pipeline Developer Guide.
"""
function create_pipeline(name, uniqueId; aws_config::AbstractAWSConfig=current_aws_config())
    return data_pipeline(
        "CreatePipeline",
        Dict{String,Any}("name" => name, "uniqueId" => uniqueId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_pipeline(
    name,
    uniqueId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return data_pipeline(
        "CreatePipeline",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("name" => name, "uniqueId" => uniqueId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    deactivate_pipeline(pipeline_id)
    deactivate_pipeline(pipeline_id, params::Dict{String,<:Any})

Deactivates the specified running pipeline. The pipeline is set to the DEACTIVATING state
until the deactivation process completes. To resume a deactivated pipeline, use
ActivatePipeline. By default, the pipeline resumes from the last completed execution.
Optionally, you can specify the date and time to resume the pipeline.

# Arguments
- `pipeline_id`: The ID of the pipeline.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"cancelActive"`: Indicates whether to cancel any running objects. The default is true,
  which sets the state of any running objects to CANCELED. If this value is false, the
  pipeline is deactivated after all running objects finish.
"""
function deactivate_pipeline(pipelineId; aws_config::AbstractAWSConfig=current_aws_config())
    return data_pipeline(
        "DeactivatePipeline",
        Dict{String,Any}("pipelineId" => pipelineId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function deactivate_pipeline(
    pipelineId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return data_pipeline(
        "DeactivatePipeline",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("pipelineId" => pipelineId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_pipeline(pipeline_id)
    delete_pipeline(pipeline_id, params::Dict{String,<:Any})

Deletes a pipeline, its pipeline definition, and its run history. AWS Data Pipeline
attempts to cancel instances associated with the pipeline that are currently being
processed by task runners. Deleting a pipeline cannot be undone. You cannot query or
restore a deleted pipeline. To temporarily pause a pipeline instead of deleting it, call
SetStatus with the status set to PAUSE on individual components. Components that are paused
by SetStatus can be resumed.

# Arguments
- `pipeline_id`: The ID of the pipeline.

"""
function delete_pipeline(pipelineId; aws_config::AbstractAWSConfig=current_aws_config())
    return data_pipeline(
        "DeletePipeline",
        Dict{String,Any}("pipelineId" => pipelineId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_pipeline(
    pipelineId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return data_pipeline(
        "DeletePipeline",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("pipelineId" => pipelineId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_objects(object_ids, pipeline_id)
    describe_objects(object_ids, pipeline_id, params::Dict{String,<:Any})

Gets the object definitions for a set of objects associated with the pipeline. Object
definitions are composed of a set of fields that define the properties of the object.

# Arguments
- `object_ids`: The IDs of the pipeline objects that contain the definitions to be
  described. You can pass as many as 25 identifiers in a single call to DescribeObjects.
- `pipeline_id`: The ID of the pipeline that contains the object definitions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"evaluateExpressions"`: Indicates whether any expressions in the object should be
  evaluated when the object descriptions are returned.
- `"marker"`: The starting point for the results to be returned. For the first call, this
  value should be empty. As long as there are more results, continue to call DescribeObjects
  with the marker value from the previous call to retrieve the next set of results.
"""
function describe_objects(
    objectIds, pipelineId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return data_pipeline(
        "DescribeObjects",
        Dict{String,Any}("objectIds" => objectIds, "pipelineId" => pipelineId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_objects(
    objectIds,
    pipelineId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return data_pipeline(
        "DescribeObjects",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("objectIds" => objectIds, "pipelineId" => pipelineId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_pipelines(pipeline_ids)
    describe_pipelines(pipeline_ids, params::Dict{String,<:Any})

Retrieves metadata about one or more pipelines. The information retrieved includes the name
of the pipeline, the pipeline identifier, its current state, and the user account that owns
the pipeline. Using account credentials, you can retrieve metadata about pipelines that you
or your IAM users have created. If you are using an IAM user account, you can retrieve
metadata about only those pipelines for which you have read permissions. To retrieve the
full pipeline definition instead of metadata about the pipeline, call GetPipelineDefinition.

# Arguments
- `pipeline_ids`: The IDs of the pipelines to describe. You can pass as many as 25
  identifiers in a single call. To obtain pipeline IDs, call ListPipelines.

"""
function describe_pipelines(pipelineIds; aws_config::AbstractAWSConfig=current_aws_config())
    return data_pipeline(
        "DescribePipelines",
        Dict{String,Any}("pipelineIds" => pipelineIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_pipelines(
    pipelineIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return data_pipeline(
        "DescribePipelines",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("pipelineIds" => pipelineIds), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    evaluate_expression(expression, object_id, pipeline_id)
    evaluate_expression(expression, object_id, pipeline_id, params::Dict{String,<:Any})

Task runners call EvaluateExpression to evaluate a string in the context of the specified
object. For example, a task runner can evaluate SQL queries stored in Amazon S3.

# Arguments
- `expression`: The expression to evaluate.
- `object_id`: The ID of the object.
- `pipeline_id`: The ID of the pipeline.

"""
function evaluate_expression(
    expression, objectId, pipelineId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return data_pipeline(
        "EvaluateExpression",
        Dict{String,Any}(
            "expression" => expression, "objectId" => objectId, "pipelineId" => pipelineId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function evaluate_expression(
    expression,
    objectId,
    pipelineId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return data_pipeline(
        "EvaluateExpression",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "expression" => expression,
                    "objectId" => objectId,
                    "pipelineId" => pipelineId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_pipeline_definition(pipeline_id)
    get_pipeline_definition(pipeline_id, params::Dict{String,<:Any})

Gets the definition of the specified pipeline. You can call GetPipelineDefinition to
retrieve the pipeline definition that you provided using PutPipelineDefinition.

# Arguments
- `pipeline_id`: The ID of the pipeline.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"version"`: The version of the pipeline definition to retrieve. Set this parameter to
  latest (default) to use the last definition saved to the pipeline or active to use the last
  definition that was activated.
"""
function get_pipeline_definition(
    pipelineId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return data_pipeline(
        "GetPipelineDefinition",
        Dict{String,Any}("pipelineId" => pipelineId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_pipeline_definition(
    pipelineId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return data_pipeline(
        "GetPipelineDefinition",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("pipelineId" => pipelineId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_pipelines()
    list_pipelines(params::Dict{String,<:Any})

Lists the pipeline identifiers for all active pipelines that you have permission to access.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"marker"`: The starting point for the results to be returned. For the first call, this
  value should be empty. As long as there are more results, continue to call ListPipelines
  with the marker value from the previous call to retrieve the next set of results.
"""
function list_pipelines(; aws_config::AbstractAWSConfig=current_aws_config())
    return data_pipeline(
        "ListPipelines"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_pipelines(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return data_pipeline(
        "ListPipelines", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    poll_for_task(worker_group)
    poll_for_task(worker_group, params::Dict{String,<:Any})

Task runners call PollForTask to receive a task to perform from AWS Data Pipeline. The task
runner specifies which tasks it can perform by setting a value for the workerGroup
parameter. The task returned can come from any of the pipelines that match the workerGroup
value passed in by the task runner and that was launched using the IAM user credentials
specified by the task runner. If tasks are ready in the work queue, PollForTask returns a
response immediately. If no tasks are available in the queue, PollForTask uses long-polling
and holds on to a poll connection for up to a 90 seconds, during which time the first newly
scheduled task is handed to the task runner. To accomodate this, set the socket timeout in
your task runner to 90 seconds. The task runner should not call PollForTask again on the
same workerGroup until it receives a response, and this can take up to 90 seconds.

# Arguments
- `worker_group`: The type of task the task runner is configured to accept and process. The
  worker group is set as a field on objects in the pipeline when they are created. You can
  only specify a single value for workerGroup in the call to PollForTask. There are no
  wildcard values permitted in workerGroup; the string must be an exact, case-sensitive,
  match.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"hostname"`: The public DNS name of the calling task runner.
- `"instanceIdentity"`: Identity information for the EC2 instance that is hosting the task
  runner. You can get this value from the instance using
  http://169.254.169.254/latest/meta-data/instance-id. For more information, see Instance
  Metadata in the Amazon Elastic Compute Cloud User Guide. Passing in this value proves that
  your task runner is running on an EC2 instance, and ensures the proper AWS Data Pipeline
  service charges are applied to your pipeline.
"""
function poll_for_task(workerGroup; aws_config::AbstractAWSConfig=current_aws_config())
    return data_pipeline(
        "PollForTask",
        Dict{String,Any}("workerGroup" => workerGroup);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function poll_for_task(
    workerGroup,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return data_pipeline(
        "PollForTask",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("workerGroup" => workerGroup), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_pipeline_definition(pipeline_id, pipeline_objects)
    put_pipeline_definition(pipeline_id, pipeline_objects, params::Dict{String,<:Any})

Adds tasks, schedules, and preconditions to the specified pipeline. You can use
PutPipelineDefinition to populate a new pipeline.  PutPipelineDefinition also validates the
configuration as it adds it to the pipeline. Changes to the pipeline are saved unless one
of the following three validation errors exists in the pipeline.   An object is missing a
name or identifier field. A string or reference field is empty. The number of objects in
the pipeline exceeds the maximum allowed objects. The pipeline is in a FINISHED state.
Pipeline object definitions are passed to the PutPipelineDefinition action and returned by
the GetPipelineDefinition action.

# Arguments
- `pipeline_id`: The ID of the pipeline.
- `pipeline_objects`: The objects that define the pipeline. These objects overwrite the
  existing pipeline definition.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"parameterObjects"`: The parameter objects used with the pipeline.
- `"parameterValues"`: The parameter values used with the pipeline.
"""
function put_pipeline_definition(
    pipelineId, pipelineObjects; aws_config::AbstractAWSConfig=current_aws_config()
)
    return data_pipeline(
        "PutPipelineDefinition",
        Dict{String,Any}("pipelineId" => pipelineId, "pipelineObjects" => pipelineObjects);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_pipeline_definition(
    pipelineId,
    pipelineObjects,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return data_pipeline(
        "PutPipelineDefinition",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "pipelineId" => pipelineId, "pipelineObjects" => pipelineObjects
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    query_objects(pipeline_id, sphere)
    query_objects(pipeline_id, sphere, params::Dict{String,<:Any})

Queries the specified pipeline for the names of objects that match the specified set of
conditions.

# Arguments
- `pipeline_id`: The ID of the pipeline.
- `sphere`: Indicates whether the query applies to components or instances. The possible
  values are: COMPONENT, INSTANCE, and ATTEMPT.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"limit"`: The maximum number of object names that QueryObjects will return in a single
  call. The default value is 100.
- `"marker"`: The starting point for the results to be returned. For the first call, this
  value should be empty. As long as there are more results, continue to call QueryObjects
  with the marker value from the previous call to retrieve the next set of results.
- `"query"`: The query that defines the objects to be returned. The Query object can
  contain a maximum of ten selectors. The conditions in the query are limited to top-level
  String fields in the object. These filters can be applied to components, instances, and
  attempts.
"""
function query_objects(
    pipelineId, sphere; aws_config::AbstractAWSConfig=current_aws_config()
)
    return data_pipeline(
        "QueryObjects",
        Dict{String,Any}("pipelineId" => pipelineId, "sphere" => sphere);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function query_objects(
    pipelineId,
    sphere,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return data_pipeline(
        "QueryObjects",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("pipelineId" => pipelineId, "sphere" => sphere),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_tags(pipeline_id, tag_keys)
    remove_tags(pipeline_id, tag_keys, params::Dict{String,<:Any})

Removes existing tags from the specified pipeline.

# Arguments
- `pipeline_id`: The ID of the pipeline.
- `tag_keys`: The keys of the tags to remove.

"""
function remove_tags(
    pipelineId, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return data_pipeline(
        "RemoveTags",
        Dict{String,Any}("pipelineId" => pipelineId, "tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_tags(
    pipelineId,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return data_pipeline(
        "RemoveTags",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("pipelineId" => pipelineId, "tagKeys" => tagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    report_task_progress(task_id)
    report_task_progress(task_id, params::Dict{String,<:Any})

Task runners call ReportTaskProgress when assigned a task to acknowledge that it has the
task. If the web service does not receive this acknowledgement within 2 minutes, it assigns
the task in a subsequent PollForTask call. After this initial acknowledgement, the task
runner only needs to report progress every 15 minutes to maintain its ownership of the
task. You can change this reporting time from 15 minutes by specifying a
reportProgressTimeout field in your pipeline. If a task runner does not report its status
after 5 minutes, AWS Data Pipeline assumes that the task runner is unable to process the
task and reassigns the task in a subsequent response to PollForTask. Task runners should
call ReportTaskProgress every 60 seconds.

# Arguments
- `task_id`: The ID of the task assigned to the task runner. This value is provided in the
  response for PollForTask.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"fields"`: Key-value pairs that define the properties of the ReportTaskProgressInput
  object.
"""
function report_task_progress(taskId; aws_config::AbstractAWSConfig=current_aws_config())
    return data_pipeline(
        "ReportTaskProgress",
        Dict{String,Any}("taskId" => taskId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function report_task_progress(
    taskId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return data_pipeline(
        "ReportTaskProgress",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("taskId" => taskId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    report_task_runner_heartbeat(taskrunner_id)
    report_task_runner_heartbeat(taskrunner_id, params::Dict{String,<:Any})

Task runners call ReportTaskRunnerHeartbeat every 15 minutes to indicate that they are
operational. If the AWS Data Pipeline Task Runner is launched on a resource managed by AWS
Data Pipeline, the web service can use this call to detect when the task runner application
has failed and restart a new instance.

# Arguments
- `taskrunner_id`: The ID of the task runner. This value should be unique across your AWS
  account. In the case of AWS Data Pipeline Task Runner launched on a resource managed by AWS
  Data Pipeline, the web service provides a unique identifier when it launches the
  application. If you have written a custom task runner, you should assign a unique
  identifier for the task runner.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"hostname"`: The public DNS name of the task runner.
- `"workerGroup"`: The type of task the task runner is configured to accept and process.
  The worker group is set as a field on objects in the pipeline when they are created. You
  can only specify a single value for workerGroup. There are no wildcard values permitted in
  workerGroup; the string must be an exact, case-sensitive, match.
"""
function report_task_runner_heartbeat(
    taskrunnerId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return data_pipeline(
        "ReportTaskRunnerHeartbeat",
        Dict{String,Any}("taskrunnerId" => taskrunnerId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function report_task_runner_heartbeat(
    taskrunnerId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return data_pipeline(
        "ReportTaskRunnerHeartbeat",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("taskrunnerId" => taskrunnerId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    set_status(object_ids, pipeline_id, status)
    set_status(object_ids, pipeline_id, status, params::Dict{String,<:Any})

Requests that the status of the specified physical or logical pipeline objects be updated
in the specified pipeline. This update might not occur immediately, but is eventually
consistent. The status that can be set depends on the type of object (for example, DataNode
or Activity). You cannot perform this operation on FINISHED pipelines and attempting to do
so returns InvalidRequestException.

# Arguments
- `object_ids`: The IDs of the objects. The corresponding objects can be either physical or
  components, but not a mix of both types.
- `pipeline_id`: The ID of the pipeline that contains the objects.
- `status`: The status to be set on all the objects specified in objectIds. For components,
  use PAUSE or RESUME. For instances, use TRY_CANCEL, RERUN, or MARK_FINISHED.

"""
function set_status(
    objectIds, pipelineId, status; aws_config::AbstractAWSConfig=current_aws_config()
)
    return data_pipeline(
        "SetStatus",
        Dict{String,Any}(
            "objectIds" => objectIds, "pipelineId" => pipelineId, "status" => status
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function set_status(
    objectIds,
    pipelineId,
    status,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return data_pipeline(
        "SetStatus",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "objectIds" => objectIds, "pipelineId" => pipelineId, "status" => status
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    set_task_status(task_id, task_status)
    set_task_status(task_id, task_status, params::Dict{String,<:Any})

Task runners call SetTaskStatus to notify AWS Data Pipeline that a task is completed and
provide information about the final status. A task runner makes this call regardless of
whether the task was sucessful. A task runner does not need to call SetTaskStatus for tasks
that are canceled by the web service during a call to ReportTaskProgress.

# Arguments
- `task_id`: The ID of the task assigned to the task runner. This value is provided in the
  response for PollForTask.
- `task_status`: If FINISHED, the task successfully completed. If FAILED, the task ended
  unsuccessfully. Preconditions use false.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"errorId"`: If an error occurred during the task, this value specifies the error code.
  This value is set on the physical attempt object. It is used to display error information
  to the user. It should not start with string \"Service_\" which is reserved by the system.
- `"errorMessage"`: If an error occurred during the task, this value specifies a text
  description of the error. This value is set on the physical attempt object. It is used to
  display error information to the user. The web service does not parse this value.
- `"errorStackTrace"`: If an error occurred during the task, this value specifies the stack
  trace associated with the error. This value is set on the physical attempt object. It is
  used to display error information to the user. The web service does not parse this value.
"""
function set_task_status(
    taskId, taskStatus; aws_config::AbstractAWSConfig=current_aws_config()
)
    return data_pipeline(
        "SetTaskStatus",
        Dict{String,Any}("taskId" => taskId, "taskStatus" => taskStatus);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function set_task_status(
    taskId,
    taskStatus,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return data_pipeline(
        "SetTaskStatus",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("taskId" => taskId, "taskStatus" => taskStatus),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    validate_pipeline_definition(pipeline_id, pipeline_objects)
    validate_pipeline_definition(pipeline_id, pipeline_objects, params::Dict{String,<:Any})

Validates the specified pipeline definition to ensure that it is well formed and can be run
without error.

# Arguments
- `pipeline_id`: The ID of the pipeline.
- `pipeline_objects`: The objects that define the pipeline changes to validate against the
  pipeline.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"parameterObjects"`: The parameter objects used with the pipeline.
- `"parameterValues"`: The parameter values used with the pipeline.
"""
function validate_pipeline_definition(
    pipelineId, pipelineObjects; aws_config::AbstractAWSConfig=current_aws_config()
)
    return data_pipeline(
        "ValidatePipelineDefinition",
        Dict{String,Any}("pipelineId" => pipelineId, "pipelineObjects" => pipelineObjects);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function validate_pipeline_definition(
    pipelineId,
    pipelineObjects,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return data_pipeline(
        "ValidatePipelineDefinition",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "pipelineId" => pipelineId, "pipelineObjects" => pipelineObjects
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: application_signals
using AWS.Compat
using AWS.UUIDs

"""
    batch_get_service_level_objective_budget_report(slo_ids, timestamp)
    batch_get_service_level_objective_budget_report(slo_ids, timestamp, params::Dict{String,<:Any})

Use this operation to retrieve one or more service level objective (SLO) budget reports. An
error budget is the amount of time in unhealthy periods that your service can accumulate
during an interval before your overall SLO budget health is breached and the SLO is
considered to be unmet. For example, an SLO with a threshold of 99.95% and a monthly
interval translates to an error budget of 21.9 minutes of downtime in a 30-day month.
Budget reports include a health indicator, the attainment value, and remaining budget. For
more information about SLO error budgets, see  SLO concepts.

# Arguments
- `slo_ids`: An array containing the IDs of the service level objectives that you want to
  include in the report.
- `timestamp`: The date and time that you want the report to be for. It is expressed as the
  number of milliseconds since Jan 1, 1970 00:00:00 UTC.

"""
function batch_get_service_level_objective_budget_report(
    SloIds, Timestamp; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_signals(
        "POST",
        "/budget-report",
        Dict{String,Any}("SloIds" => SloIds, "Timestamp" => Timestamp);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_service_level_objective_budget_report(
    SloIds,
    Timestamp,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_signals(
        "POST",
        "/budget-report",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("SloIds" => SloIds, "Timestamp" => Timestamp),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_service_level_objective(name, sli_config)
    create_service_level_objective(name, sli_config, params::Dict{String,<:Any})

Creates a service level objective (SLO), which can help you ensure that your critical
business operations are meeting customer expectations. Use SLOs to set and track specific
target levels for the reliability and availability of your applications and services. SLOs
use service level indicators (SLIs) to calculate whether the application is performing at
the level that you want. Create an SLO to set a target for a service or operation’s
availability or latency. CloudWatch measures this target frequently you can find whether it
has been breached.  When you create an SLO, you set an attainment goal for it. An
attainment goal is the ratio of good periods that meet the threshold requirements to the
total periods within the interval. For example, an attainment goal of 99.9% means that
within your interval, you are targeting 99.9% of the periods to be in healthy state. After
you have created an SLO, you can retrieve error budget reports for it. An error budget is
the number of periods or amount of time that your service can accumulate during an interval
before your overall SLO budget health is breached and the SLO is considered to be unmet.
for example, an SLO with a threshold that 99.95% of requests must be completed under 2000ms
every month translates to an error budget of 21.9 minutes of downtime per month. When you
call this operation, Application Signals creates the
AWSServiceRoleForCloudWatchApplicationSignals service-linked role, if it doesn't already
exist in your account. This service- linked role has the following permissions:
xray:GetServiceGraph     logs:StartQuery     logs:GetQueryResults
cloudwatch:GetMetricData     cloudwatch:ListMetrics     tag:GetResources
autoscaling:DescribeAutoScalingGroups    You can easily set SLO targets for your
applications that are discovered by Application Signals, using critical metrics such as
latency and availability. You can also set SLOs against any CloudWatch metric or math
expression that produces a time series. For more information about SLOs, see  Service level
objectives (SLOs).

# Arguments
- `name`: A name for this SLO.
- `sli_config`: A structure that contains information about what service and what
  performance metric that this SLO will monitor.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: An optional description for this SLO.
- `"Goal"`: A structure that contains the attributes that determine the goal of the SLO.
  This includes the time period for evaluation and the attainment threshold.
- `"Tags"`: A list of key-value pairs to associate with the SLO. You can associate as many
  as 50 tags with an SLO. To be able to associate tags with the SLO when you create the SLO,
  you must have the cloudwatch:TagResource permission. Tags can help you organize and
  categorize your resources. You can also use them to scope user permissions by granting a
  user permission to access or change only resources with certain tag values.
"""
function create_service_level_objective(
    Name, SliConfig; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_signals(
        "POST",
        "/slo",
        Dict{String,Any}("Name" => Name, "SliConfig" => SliConfig);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_service_level_objective(
    Name,
    SliConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_signals(
        "POST",
        "/slo",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("Name" => Name, "SliConfig" => SliConfig), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_service_level_objective(id)
    delete_service_level_objective(id, params::Dict{String,<:Any})

Deletes the specified service level objective.

# Arguments
- `id`: The ARN or name of the service level objective to delete.

"""
function delete_service_level_objective(
    Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_signals(
        "DELETE", "/slo/$(Id)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function delete_service_level_objective(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_signals(
        "DELETE",
        "/slo/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_service(end_time, key_attributes, start_time)
    get_service(end_time, key_attributes, start_time, params::Dict{String,<:Any})

Returns information about a service discovered by Application Signals.

# Arguments
- `end_time`: The end of the time period to retrieve information about. When used in a raw
  HTTP Query API, it is formatted as be epoch time in seconds. For example: 1698778057
- `key_attributes`: Use this field to specify which service you want to retrieve
  information for. You must specify at least the Type, Name, and Environment attributes. This
  is a string-to-string map. It can include the following fields.    Type designates the type
  of object this is.    ResourceType specifies the type of the resource. This field is used
  only when the value of the Type field is Resource or AWS::Resource.    Name specifies the
  name of the object. This is used only if the value of the Type field is Service,
  RemoteService, or AWS::Service.    Identifier identifies the resource objects of this
  resource. This is used only if the value of the Type field is Resource or AWS::Resource.
  Environment specifies the location where this object is hosted, or what it belongs to.
- `start_time`: The start of the time period to retrieve information about. When used in a
  raw HTTP Query API, it is formatted as be epoch time in seconds. For example: 1698778057

"""
function get_service(
    EndTime, KeyAttributes, StartTime; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_signals(
        "POST",
        "/service",
        Dict{String,Any}(
            "EndTime" => EndTime, "KeyAttributes" => KeyAttributes, "StartTime" => StartTime
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_service(
    EndTime,
    KeyAttributes,
    StartTime,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_signals(
        "POST",
        "/service",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EndTime" => EndTime,
                    "KeyAttributes" => KeyAttributes,
                    "StartTime" => StartTime,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_service_level_objective(id)
    get_service_level_objective(id, params::Dict{String,<:Any})

Returns information about one SLO created in the account.

# Arguments
- `id`: The ARN or name of the SLO that you want to retrieve information about. You can
  find the ARNs of SLOs by using the ListServiceLevelObjectives operation.

"""
function get_service_level_objective(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return application_signals(
        "GET", "/slo/$(Id)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_service_level_objective(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_signals(
        "GET", "/slo/$(Id)", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_service_dependencies(end_time, key_attributes, start_time)
    list_service_dependencies(end_time, key_attributes, start_time, params::Dict{String,<:Any})

Returns a list of service dependencies of the service that you specify. A dependency is an
infrastructure component that an operation of this service connects with. Dependencies can
include Amazon Web Services services, Amazon Web Services resources, and third-party
services.

# Arguments
- `end_time`: The end of the time period to retrieve information about. When used in a raw
  HTTP Query API, it is formatted as be epoch time in seconds. For example: 1698778057
- `key_attributes`: Use this field to specify which service you want to retrieve
  information for. You must specify at least the Type, Name, and Environment attributes. This
  is a string-to-string map. It can include the following fields.    Type designates the type
  of object this is.    ResourceType specifies the type of the resource. This field is used
  only when the value of the Type field is Resource or AWS::Resource.    Name specifies the
  name of the object. This is used only if the value of the Type field is Service,
  RemoteService, or AWS::Service.    Identifier identifies the resource objects of this
  resource. This is used only if the value of the Type field is Resource or AWS::Resource.
  Environment specifies the location where this object is hosted, or what it belongs to.
- `start_time`: The start of the time period to retrieve information about. When used in a
  raw HTTP Query API, it is formatted as be epoch time in seconds. For example: 1698778057

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to return in one operation. If you omit
  this parameter, the default of 50 is used.
- `"NextToken"`: Include this value, if it was returned by the previous operation, to get
  the next set of service dependencies.
"""
function list_service_dependencies(
    EndTime, KeyAttributes, StartTime; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_signals(
        "POST",
        "/service-dependencies",
        Dict{String,Any}(
            "EndTime" => EndTime, "KeyAttributes" => KeyAttributes, "StartTime" => StartTime
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_service_dependencies(
    EndTime,
    KeyAttributes,
    StartTime,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_signals(
        "POST",
        "/service-dependencies",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EndTime" => EndTime,
                    "KeyAttributes" => KeyAttributes,
                    "StartTime" => StartTime,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_service_dependents(end_time, key_attributes, start_time)
    list_service_dependents(end_time, key_attributes, start_time, params::Dict{String,<:Any})

Returns the list of dependents that invoked the specified service during the provided time
range. Dependents include other services, CloudWatch Synthetics canaries, and clients that
are instrumented with CloudWatch RUM app monitors.

# Arguments
- `end_time`: The end of the time period to retrieve information about. When used in a raw
  HTTP Query API, it is formatted as be epoch time in seconds. For example: 1698778057
- `key_attributes`: Use this field to specify which service you want to retrieve
  information for. You must specify at least the Type, Name, and Environment attributes. This
  is a string-to-string map. It can include the following fields.    Type designates the type
  of object this is.    ResourceType specifies the type of the resource. This field is used
  only when the value of the Type field is Resource or AWS::Resource.    Name specifies the
  name of the object. This is used only if the value of the Type field is Service,
  RemoteService, or AWS::Service.    Identifier identifies the resource objects of this
  resource. This is used only if the value of the Type field is Resource or AWS::Resource.
  Environment specifies the location where this object is hosted, or what it belongs to.
- `start_time`: The start of the time period to retrieve information about. When used in a
  raw HTTP Query API, it is formatted as be epoch time in seconds. For example: 1698778057

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to return in one operation. If you omit
  this parameter, the default of 50 is used.
- `"NextToken"`: Include this value, if it was returned by the previous operation, to get
  the next set of service dependents.
"""
function list_service_dependents(
    EndTime, KeyAttributes, StartTime; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_signals(
        "POST",
        "/service-dependents",
        Dict{String,Any}(
            "EndTime" => EndTime, "KeyAttributes" => KeyAttributes, "StartTime" => StartTime
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_service_dependents(
    EndTime,
    KeyAttributes,
    StartTime,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_signals(
        "POST",
        "/service-dependents",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EndTime" => EndTime,
                    "KeyAttributes" => KeyAttributes,
                    "StartTime" => StartTime,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_service_level_objectives()
    list_service_level_objectives(params::Dict{String,<:Any})

Returns a list of SLOs created in this account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"KeyAttributes"`: You can use this optional field to specify which services you want to
  retrieve SLO information for. This is a string-to-string map. It can include the following
  fields.    Type designates the type of object this is.    ResourceType specifies the type
  of the resource. This field is used only when the value of the Type field is Resource or
  AWS::Resource.    Name specifies the name of the object. This is used only if the value of
  the Type field is Service, RemoteService, or AWS::Service.    Identifier identifies the
  resource objects of this resource. This is used only if the value of the Type field is
  Resource or AWS::Resource.    Environment specifies the location where this object is
  hosted, or what it belongs to.
- `"MaxResults"`: The maximum number of results to return in one operation. If you omit
  this parameter, the default of 50 is used.
- `"NextToken"`: Include this value, if it was returned by the previous operation, to get
  the next set of service level objectives.
- `"OperationName"`: The name of the operation that this SLO is associated with.
"""
function list_service_level_objectives(; aws_config::AbstractAWSConfig=current_aws_config())
    return application_signals(
        "POST", "/slos"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_service_level_objectives(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_signals(
        "POST", "/slos", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_service_operations(end_time, key_attributes, start_time)
    list_service_operations(end_time, key_attributes, start_time, params::Dict{String,<:Any})

Returns a list of the operations of this service that have been discovered by Application
Signals. Only the operations that were invoked during the specified time range are returned.

# Arguments
- `end_time`: The end of the time period to retrieve information about. When used in a raw
  HTTP Query API, it is formatted as be epoch time in seconds. For example: 1698778057
- `key_attributes`: Use this field to specify which service you want to retrieve
  information for. You must specify at least the Type, Name, and Environment attributes. This
  is a string-to-string map. It can include the following fields.    Type designates the type
  of object this is.    ResourceType specifies the type of the resource. This field is used
  only when the value of the Type field is Resource or AWS::Resource.    Name specifies the
  name of the object. This is used only if the value of the Type field is Service,
  RemoteService, or AWS::Service.    Identifier identifies the resource objects of this
  resource. This is used only if the value of the Type field is Resource or AWS::Resource.
  Environment specifies the location where this object is hosted, or what it belongs to.
- `start_time`: The start of the time period to retrieve information about. When used in a
  raw HTTP Query API, it is formatted as be epoch time in seconds. For example: 1698778057

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to return in one operation. If you omit
  this parameter, the default of 50 is used.
- `"NextToken"`: Include this value, if it was returned by the previous operation, to get
  the next set of service operations.
"""
function list_service_operations(
    EndTime, KeyAttributes, StartTime; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_signals(
        "POST",
        "/service-operations",
        Dict{String,Any}(
            "EndTime" => EndTime, "KeyAttributes" => KeyAttributes, "StartTime" => StartTime
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_service_operations(
    EndTime,
    KeyAttributes,
    StartTime,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_signals(
        "POST",
        "/service-operations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EndTime" => EndTime,
                    "KeyAttributes" => KeyAttributes,
                    "StartTime" => StartTime,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_services(end_time, start_time)
    list_services(end_time, start_time, params::Dict{String,<:Any})

Returns a list of services that have been discovered by Application Signals. A service
represents a minimum logical and transactional unit that completes a business function.
Services are discovered through Application Signals instrumentation.

# Arguments
- `end_time`: The end of the time period to retrieve information about. When used in a raw
  HTTP Query API, it is formatted as be epoch time in seconds. For example: 1698778057
- `start_time`: The start of the time period to retrieve information about. When used in a
  raw HTTP Query API, it is formatted as be epoch time in seconds. For example: 1698778057

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`:  The maximum number of results to return in one operation. If you omit
  this parameter, the default of 50 is used.
- `"NextToken"`: Include this value, if it was returned by the previous operation, to get
  the next set of services.
"""
function list_services(
    EndTime, StartTime; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_signals(
        "GET",
        "/services",
        Dict{String,Any}("EndTime" => EndTime, "StartTime" => StartTime);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_services(
    EndTime,
    StartTime,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_signals(
        "GET",
        "/services",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("EndTime" => EndTime, "StartTime" => StartTime),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Displays the tags associated with a CloudWatch resource. Tags can be assigned to service
level objectives.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the CloudWatch resource that you want
  to view tags for. The ARN format of an Application Signals SLO is
  arn:aws:cloudwatch:Region:account-id:slo:slo-name   For more information about ARN format,
  see  Resource Types Defined by Amazon CloudWatch in the Amazon Web Services General
  Reference.

"""
function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_signals(
        "GET",
        "/tags",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_signals(
        "GET",
        "/tags",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_discovery()
    start_discovery(params::Dict{String,<:Any})

Enables this Amazon Web Services account to be able to use CloudWatch Application Signals
by creating the AWSServiceRoleForCloudWatchApplicationSignals service-linked role. This
service- linked role has the following permissions:    xray:GetServiceGraph
logs:StartQuery     logs:GetQueryResults     cloudwatch:GetMetricData
cloudwatch:ListMetrics     tag:GetResources     autoscaling:DescribeAutoScalingGroups
After completing this step, you still need to instrument your Java and Python applications
to send data to Application Signals. For more information, see  Enabling Application
Signals.

"""
function start_discovery(; aws_config::AbstractAWSConfig=current_aws_config())
    return application_signals(
        "POST", "/start-discovery"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function start_discovery(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_signals(
        "POST",
        "/start-discovery",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Assigns one or more tags (key-value pairs) to the specified CloudWatch resource, such as a
service level objective. Tags can help you organize and categorize your resources. You can
also use them to scope user permissions by granting a user permission to access or change
only resources with certain tag values. Tags don't have any semantic meaning to Amazon Web
Services and are interpreted strictly as strings of characters. You can use the TagResource
action with an alarm that already has tags. If you specify a new tag key for the alarm,
this tag is appended to the list of tags associated with the alarm. If you specify a tag
key that is already associated with the alarm, the new tag value that you specify replaces
the previous value for that tag. You can associate as many as 50 tags with a CloudWatch
resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the CloudWatch resource that you want
  to set tags for. The ARN format of an Application Signals SLO is
  arn:aws:cloudwatch:Region:account-id:slo:slo-name   For more information about ARN format,
  see  Resource Types Defined by Amazon CloudWatch in the Amazon Web Services General
  Reference.
- `tags`: The list of key-value pairs to associate with the alarm.

"""
function tag_resource(ResourceArn, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return application_signals(
        "POST",
        "/tag-resource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceArn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_signals(
        "POST",
        "/tag-resource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes one or more tags from the specified resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the CloudWatch resource that you want
  to delete tags from. The ARN format of an Application Signals SLO is
  arn:aws:cloudwatch:Region:account-id:slo:slo-name   For more information about ARN format,
  see  Resource Types Defined by Amazon CloudWatch in the Amazon Web Services General
  Reference.
- `tag_keys`: The list of tag keys to remove from the resource.

"""
function untag_resource(
    ResourceArn, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_signals(
        "POST",
        "/untag-resource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceArn,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_signals(
        "POST",
        "/untag-resource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_service_level_objective(id)
    update_service_level_objective(id, params::Dict{String,<:Any})

Updates an existing service level objective (SLO). If you omit parameters, the previous
values of those parameters are retained.

# Arguments
- `id`: The Amazon Resource Name (ARN) or name of the service level objective that you want
  to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: An optional description for the SLO.
- `"Goal"`: A structure that contains the attributes that determine the goal of the SLO.
  This includes the time period for evaluation and the attainment threshold.
- `"SliConfig"`: A structure that contains information about what performance metric this
  SLO will monitor.
"""
function update_service_level_objective(
    Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_signals(
        "PATCH", "/slo/$(Id)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function update_service_level_objective(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_signals(
        "PATCH",
        "/slo/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: opsworkscm
using AWS.Compat
using AWS.UUIDs

"""
    associate_node(engine_attributes, node_name, server_name)
    associate_node(engine_attributes, node_name, server_name, params::Dict{String,<:Any})

 Associates a new node with the server. For more information about how to disassociate a
node, see DisassociateNode.  On a Chef server: This command is an alternative to knife
bootstrap.  Example (Chef): aws opsworks-cm associate-node --server-name MyServer
--node-name MyManagedNode --engine-attributes \"Name=CHEF_ORGANIZATION,Value=default\"
\"Name=CHEF_NODE_PUBLIC_KEY,Value=public-key-pem\"   On a Puppet server, this command is an
alternative to the puppet cert sign command that signs a Puppet node CSR.   Example
(Puppet): aws opsworks-cm associate-node --server-name MyServer --node-name MyManagedNode
--engine-attributes \"Name=PUPPET_NODE_CSR,Value=csr-pem\"   A node can can only be
associated with servers that are in a HEALTHY state. Otherwise, an InvalidStateException is
thrown. A ResourceNotFoundException is thrown when the server does not exist. A
ValidationException is raised when parameters of the request are not valid. The
AssociateNode API call can be integrated into Auto Scaling configurations, AWS
Cloudformation templates, or the user data of a server's instance.

# Arguments
- `engine_attributes`: Engine attributes used for associating the node.   Attributes
  accepted in a AssociateNode request for Chef     CHEF_ORGANIZATION: The Chef organization
  with which the node is associated. By default only one organization named default can
  exist.     CHEF_NODE_PUBLIC_KEY: A PEM-formatted public key. This key is required for the
  chef-client agent to access the Chef API.     Attributes accepted in a AssociateNode
  request for Puppet     PUPPET_NODE_CSR: A PEM-formatted certificate-signing request (CSR)
  that is created by the node.
- `node_name`: The name of the node.
- `server_name`: The name of the server with which to associate the node.

"""
function associate_node(
    EngineAttributes,
    NodeName,
    ServerName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworkscm(
        "AssociateNode",
        Dict{String,Any}(
            "EngineAttributes" => EngineAttributes,
            "NodeName" => NodeName,
            "ServerName" => ServerName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_node(
    EngineAttributes,
    NodeName,
    ServerName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworkscm(
        "AssociateNode",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EngineAttributes" => EngineAttributes,
                    "NodeName" => NodeName,
                    "ServerName" => ServerName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_backup(server_name)
    create_backup(server_name, params::Dict{String,<:Any})

 Creates an application-level backup of a server. While the server is in the BACKING_UP
state, the server cannot be changed, and no additional backup can be created.   Backups can
be created for servers in RUNNING, HEALTHY, and UNHEALTHY states. By default, you can
create a maximum of 50 manual backups.   This operation is asynchronous.   A
LimitExceededException is thrown when the maximum number of manual backups is reached. An
InvalidStateException is thrown when the server is not in any of the following states:
RUNNING, HEALTHY, or UNHEALTHY. A ResourceNotFoundException is thrown when the server is
not found. A ValidationException is thrown when parameters of the request are not valid.

# Arguments
- `server_name`: The name of the server that you want to back up.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`:  A user-defined description of the backup.
- `"Tags"`: A map that contains tag keys and tag values to attach to an AWS OpsWorks-CM
  server backup.   The key cannot be empty.   The key can be a maximum of 127 characters, and
  can contain only Unicode letters, numbers, or separators, or the following special
  characters: + - = . _ : /    The value can be a maximum 255 characters, and contain only
  Unicode letters, numbers, or separators, or the following special characters: + - = . _ : /
     Leading and trailing white spaces are trimmed from both the key and value.   A maximum
  of 50 user-applied tags is allowed for tag-supported AWS OpsWorks-CM resources.
"""
function create_backup(ServerName; aws_config::AbstractAWSConfig=current_aws_config())
    return opsworkscm(
        "CreateBackup",
        Dict{String,Any}("ServerName" => ServerName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_backup(
    ServerName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworkscm(
        "CreateBackup",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ServerName" => ServerName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_server(engine, instance_profile_arn, instance_type, server_name, service_role_arn)
    create_server(engine, instance_profile_arn, instance_type, server_name, service_role_arn, params::Dict{String,<:Any})

 Creates and immedately starts a new server. The server is ready to use when it is in the
HEALTHY state. By default, you can create a maximum of 10 servers.   This operation is
asynchronous.   A LimitExceededException is thrown when you have created the maximum number
of servers (10). A ResourceAlreadyExistsException is thrown when a server with the same
name already exists in the account. A ResourceNotFoundException is thrown when you specify
a backup ID that is not valid or is for a backup that does not exist. A ValidationException
is thrown when parameters of the request are not valid.   If you do not specify a security
group by adding the SecurityGroupIds parameter, AWS OpsWorks creates a new security group.
 Chef Automate: The default security group opens the Chef server to the world on TCP port
443. If a KeyName is present, AWS OpsWorks enables SSH access. SSH is also open to the
world on TCP port 22.   Puppet Enterprise: The default security group opens TCP ports 22,
443, 4433, 8140, 8142, 8143, and 8170. If a KeyName is present, AWS OpsWorks enables SSH
access. SSH is also open to the world on TCP port 22.  By default, your server is
accessible from any IP address. We recommend that you update your security group rules to
allow access from known IP addresses and address ranges only. To edit security group rules,
open Security Groups in the navigation pane of the EC2 management console.  To specify your
own domain for a server, and provide your own self-signed or CA-signed certificate and
private key, specify values for CustomDomain, CustomCertificate, and CustomPrivateKey.

# Arguments
- `engine`:  The configuration management engine to use. Valid values include ChefAutomate
  and Puppet.
- `instance_profile_arn`:  The ARN of the instance profile that your Amazon EC2 instances
  use. Although the AWS OpsWorks console typically creates the instance profile for you, if
  you are using API commands instead, run the service-role-creation.yaml AWS CloudFormation
  template, located at
  https://s3.amazonaws.com/opsworks-cm-us-east-1-prod-default-assets/misc/opsworks-cm-roles.ya
  ml. This template creates a CloudFormation stack that includes the instance profile you
  need.
- `instance_type`:  The Amazon EC2 instance type to use. For example, m5.large.
- `server_name`:  The name of the server. The server name must be unique within your AWS
  account, within each region. Server names must start with a letter; then letters, numbers,
  or hyphens (-) are allowed, up to a maximum of 40 characters.
- `service_role_arn`:  The service role that the AWS OpsWorks CM service backend uses to
  work with your account. Although the AWS OpsWorks management console typically creates the
  service role for you, if you are using the AWS CLI or API commands, run the
  service-role-creation.yaml AWS CloudFormation template, located at
  https://s3.amazonaws.com/opsworks-cm-us-east-1-prod-default-assets/misc/opsworks-cm-roles.ya
  ml. This template creates a CloudFormation stack that includes the service role and
  instance profile that you need.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AssociatePublicIpAddress"`:  Associate a public IP address with a server that you are
  launching. Valid values are true or false. The default value is true.
- `"BackupId"`:  If you specify this field, AWS OpsWorks CM creates the server by using the
  backup represented by BackupId.
- `"BackupRetentionCount"`:  The number of automated backups that you want to keep.
  Whenever a new backup is created, AWS OpsWorks CM deletes the oldest backups if this number
  is exceeded. The default value is 1.
- `"CustomCertificate"`: A PEM-formatted HTTPS certificate. The value can be be a single,
  self-signed certificate, or a certificate chain. If you specify a custom certificate, you
  must also specify values for CustomDomain and CustomPrivateKey. The following are
  requirements for the CustomCertificate value:   You can provide either a self-signed,
  custom certificate, or the full certificate chain.   The certificate must be a valid X509
  certificate, or a certificate chain in PEM format.   The certificate must be valid at the
  time of upload. A certificate can't be used before its validity period begins (the
  certificate's NotBefore date), or after it expires (the certificate's NotAfter date).   The
  certificate’s common name or subject alternative names (SANs), if present, must match the
  value of CustomDomain.   The certificate must match the value of CustomPrivateKey.
- `"CustomDomain"`: An optional public endpoint of a server, such as
  https://aws.my-company.com. To access the server, create a CNAME DNS record in your
  preferred DNS service that points the custom domain to the endpoint that is generated when
  the server is created (the value of the CreateServer Endpoint attribute). You cannot access
  the server by using the generated Endpoint value if the server is using a custom domain. If
  you specify a custom domain, you must also specify values for CustomCertificate and
  CustomPrivateKey.
- `"CustomPrivateKey"`: A private key in PEM format for connecting to the server by using
  HTTPS. The private key must not be encrypted; it cannot be protected by a password or
  passphrase. If you specify a custom private key, you must also specify values for
  CustomDomain and CustomCertificate.
- `"DisableAutomatedBackup"`:  Enable or disable scheduled backups. Valid values are true
  or false. The default value is true.
- `"EngineAttributes"`: Optional engine attributes on a specified server.   Attributes
  accepted in a Chef createServer request:     CHEF_AUTOMATE_PIVOTAL_KEY: A base64-encoded
  RSA public key. The corresponding private key is required to access the Chef API. When no
  CHEF_AUTOMATE_PIVOTAL_KEY is set, a private key is generated and returned in the response.
     CHEF_AUTOMATE_ADMIN_PASSWORD: The password for the administrative user in the Chef
  Automate web-based dashboard. The password length is a minimum of eight characters, and a
  maximum of 32. The password can contain letters, numbers, and special characters
  (!/@#%^&amp;+=_). The password must contain at least one lower case letter, one upper case
  letter, one number, and one special character. When no CHEF_AUTOMATE_ADMIN_PASSWORD is set,
  one is generated and returned in the response.    Attributes accepted in a Puppet
  createServer request:     PUPPET_ADMIN_PASSWORD: To work with the Puppet Enterprise
  console, a password must use ASCII characters.    PUPPET_R10K_REMOTE: The r10k remote is
  the URL of your control repository (for example,
  ssh://git@your.git-repo.com:user/control-repo.git). Specifying an r10k remote opens TCP
  port 8170.    PUPPET_R10K_PRIVATE_KEY: If you are using a private Git repository, add
  PUPPET_R10K_PRIVATE_KEY to specify a PEM-encoded private SSH key.
- `"EngineModel"`:  The engine model of the server. Valid values in this release include
  Monolithic for Puppet and Single for Chef.
- `"EngineVersion"`:  The major release version of the engine that you want to use. For a
  Chef server, the valid value for EngineVersion is currently 2. For a Puppet server, valid
  values are 2019 or 2017.
- `"KeyPair"`:  The Amazon EC2 key pair to set for the instance. This parameter is
  optional; if desired, you may specify this parameter to connect to your instances by using
  SSH.
- `"PreferredBackupWindow"`:  The start time for a one-hour period during which AWS
  OpsWorks CM backs up application-level data on your server if automated backups are
  enabled. Valid values must be specified in one of the following formats:     HH:MM for
  daily backups    DDD:HH:MM for weekly backups    MM must be specified as 00. The specified
  time is in coordinated universal time (UTC). The default value is a random, daily start
  time.  Example: 08:00, which represents a daily start time of 08:00 UTC.  Example:
  Mon:08:00, which represents a start time of every Monday at 08:00 UTC. (8:00 a.m.)
- `"PreferredMaintenanceWindow"`:  The start time for a one-hour period each week during
  which AWS OpsWorks CM performs maintenance on the instance. Valid values must be specified
  in the following format: DDD:HH:MM. MM must be specified as 00. The specified time is in
  coordinated universal time (UTC). The default value is a random one-hour period on Tuesday,
  Wednesday, or Friday. See TimeWindowDefinition for more information.   Example: Mon:08:00,
  which represents a start time of every Monday at 08:00 UTC. (8:00 a.m.)
- `"SecurityGroupIds"`:  A list of security group IDs to attach to the Amazon EC2 instance.
  If you add this parameter, the specified security groups must be within the VPC that is
  specified by SubnetIds.   If you do not specify this parameter, AWS OpsWorks CM creates one
  new security group that uses TCP ports 22 and 443, open to 0.0.0.0/0 (everyone).
- `"SubnetIds"`:  The IDs of subnets in which to launch the server EC2 instance.   Amazon
  EC2-Classic customers: This field is required. All servers must run within a VPC. The VPC
  must have \"Auto Assign Public IP\" enabled.   EC2-VPC customers: This field is optional.
  If you do not specify subnet IDs, your EC2 instances are created in a default subnet that
  is selected by Amazon EC2. If you specify subnet IDs, the VPC must have \"Auto Assign
  Public IP\" enabled.  For more information about supported Amazon EC2 platforms, see
  Supported Platforms.
- `"Tags"`: A map that contains tag keys and tag values to attach to an AWS OpsWorks for
  Chef Automate or AWS OpsWorks for Puppet Enterprise server.   The key cannot be empty.
  The key can be a maximum of 127 characters, and can contain only Unicode letters, numbers,
  or separators, or the following special characters: + - = . _ : / @    The value can be a
  maximum 255 characters, and contain only Unicode letters, numbers, or separators, or the
  following special characters: + - = . _ : / @    Leading and trailing white spaces are
  trimmed from both the key and value.   A maximum of 50 user-applied tags is allowed for any
  AWS OpsWorks-CM server.
"""
function create_server(
    Engine,
    InstanceProfileArn,
    InstanceType,
    ServerName,
    ServiceRoleArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworkscm(
        "CreateServer",
        Dict{String,Any}(
            "Engine" => Engine,
            "InstanceProfileArn" => InstanceProfileArn,
            "InstanceType" => InstanceType,
            "ServerName" => ServerName,
            "ServiceRoleArn" => ServiceRoleArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_server(
    Engine,
    InstanceProfileArn,
    InstanceType,
    ServerName,
    ServiceRoleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworkscm(
        "CreateServer",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Engine" => Engine,
                    "InstanceProfileArn" => InstanceProfileArn,
                    "InstanceType" => InstanceType,
                    "ServerName" => ServerName,
                    "ServiceRoleArn" => ServiceRoleArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_backup(backup_id)
    delete_backup(backup_id, params::Dict{String,<:Any})

 Deletes a backup. You can delete both manual and automated backups. This operation is
asynchronous.   An InvalidStateException is thrown when a backup deletion is already in
progress. A ResourceNotFoundException is thrown when the backup does not exist. A
ValidationException is thrown when parameters of the request are not valid.

# Arguments
- `backup_id`: The ID of the backup to delete. Run the DescribeBackups command to get a
  list of backup IDs. Backup IDs are in the format ServerName-yyyyMMddHHmmssSSS.

"""
function delete_backup(BackupId; aws_config::AbstractAWSConfig=current_aws_config())
    return opsworkscm(
        "DeleteBackup",
        Dict{String,Any}("BackupId" => BackupId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_backup(
    BackupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworkscm(
        "DeleteBackup",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("BackupId" => BackupId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_server(server_name)
    delete_server(server_name, params::Dict{String,<:Any})

 Deletes the server and the underlying AWS CloudFormation stacks (including the server's
EC2 instance). When you run this command, the server state is updated to DELETING. After
the server is deleted, it is no longer returned by DescribeServer requests. If the AWS
CloudFormation stack cannot be deleted, the server cannot be deleted.   This operation is
asynchronous.   An InvalidStateException is thrown when a server deletion is already in
progress. A ResourceNotFoundException is thrown when the server does not exist. A
ValidationException is raised when parameters of the request are not valid.

# Arguments
- `server_name`: The ID of the server to delete.

"""
function delete_server(ServerName; aws_config::AbstractAWSConfig=current_aws_config())
    return opsworkscm(
        "DeleteServer",
        Dict{String,Any}("ServerName" => ServerName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_server(
    ServerName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworkscm(
        "DeleteServer",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ServerName" => ServerName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_account_attributes()
    describe_account_attributes(params::Dict{String,<:Any})

 Describes your OpsWorks-CM account attributes.   This operation is synchronous.

"""
function describe_account_attributes(; aws_config::AbstractAWSConfig=current_aws_config())
    return opsworkscm(
        "DescribeAccountAttributes"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_account_attributes(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opsworkscm(
        "DescribeAccountAttributes",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_backups()
    describe_backups(params::Dict{String,<:Any})

 Describes backups. The results are ordered by time, with newest backups first. If you do
not specify a BackupId or ServerName, the command returns all backups.   This operation is
synchronous.   A ResourceNotFoundException is thrown when the backup does not exist. A
ValidationException is raised when parameters of the request are not valid.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"BackupId"`: Describes a single backup.
- `"MaxResults"`: This is not currently implemented for DescribeBackups requests.
- `"NextToken"`: This is not currently implemented for DescribeBackups requests.
- `"ServerName"`: Returns backups for the server with the specified ServerName.
"""
function describe_backups(; aws_config::AbstractAWSConfig=current_aws_config())
    return opsworkscm(
        "DescribeBackups"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_backups(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opsworkscm(
        "DescribeBackups", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_events(server_name)
    describe_events(server_name, params::Dict{String,<:Any})

 Describes events for a specified server. Results are ordered by time, with newest events
first.   This operation is synchronous.   A ResourceNotFoundException is thrown when the
server does not exist. A ValidationException is raised when parameters of the request are
not valid.

# Arguments
- `server_name`: The name of the server for which you want to view events.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: To receive a paginated response, use this parameter to specify the
  maximum number of results to be returned with a single call. If the number of available
  results exceeds this maximum, the response includes a NextToken value that you can assign
  to the NextToken request parameter to get the next set of results.
- `"NextToken"`: NextToken is a string that is returned in some command responses. It
  indicates that not all entries have been returned, and that you must run at least one more
  request to get remaining items. To get remaining results, call DescribeEvents again, and
  assign the token from the previous results as the value of the nextToken parameter. If
  there are no more results, the response object's nextToken parameter value is null. Setting
  a nextToken value that was not returned in your previous results causes an
  InvalidNextTokenException to occur.
"""
function describe_events(ServerName; aws_config::AbstractAWSConfig=current_aws_config())
    return opsworkscm(
        "DescribeEvents",
        Dict{String,Any}("ServerName" => ServerName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_events(
    ServerName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworkscm(
        "DescribeEvents",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ServerName" => ServerName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_node_association_status(node_association_status_token, server_name)
    describe_node_association_status(node_association_status_token, server_name, params::Dict{String,<:Any})

 Returns the current status of an existing association or disassociation request.   A
ResourceNotFoundException is thrown when no recent association or disassociation request
with the specified token is found, or when the server does not exist. A ValidationException
is raised when parameters of the request are not valid.

# Arguments
- `node_association_status_token`: The token returned in either the AssociateNodeResponse
  or the DisassociateNodeResponse.
- `server_name`: The name of the server from which to disassociate the node.

"""
function describe_node_association_status(
    NodeAssociationStatusToken,
    ServerName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworkscm(
        "DescribeNodeAssociationStatus",
        Dict{String,Any}(
            "NodeAssociationStatusToken" => NodeAssociationStatusToken,
            "ServerName" => ServerName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_node_association_status(
    NodeAssociationStatusToken,
    ServerName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworkscm(
        "DescribeNodeAssociationStatus",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "NodeAssociationStatusToken" => NodeAssociationStatusToken,
                    "ServerName" => ServerName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_servers()
    describe_servers(params::Dict{String,<:Any})

 Lists all configuration management servers that are identified with your account. Only the
stored results from Amazon DynamoDB are returned. AWS OpsWorks CM does not query other
services.   This operation is synchronous.   A ResourceNotFoundException is thrown when the
server does not exist. A ValidationException is raised when parameters of the request are
not valid.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: This is not currently implemented for DescribeServers requests.
- `"NextToken"`: This is not currently implemented for DescribeServers requests.
- `"ServerName"`: Describes the server with the specified ServerName.
"""
function describe_servers(; aws_config::AbstractAWSConfig=current_aws_config())
    return opsworkscm(
        "DescribeServers"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_servers(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opsworkscm(
        "DescribeServers", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    disassociate_node(node_name, server_name)
    disassociate_node(node_name, server_name, params::Dict{String,<:Any})

 Disassociates a node from an AWS OpsWorks CM server, and removes the node from the
server's managed nodes. After a node is disassociated, the node key pair is no longer valid
for accessing the configuration manager's API. For more information about how to associate
a node, see AssociateNode.  A node can can only be disassociated from a server that is in a
HEALTHY state. Otherwise, an InvalidStateException is thrown. A ResourceNotFoundException
is thrown when the server does not exist. A ValidationException is raised when parameters
of the request are not valid.

# Arguments
- `node_name`: The name of the client node.
- `server_name`: The name of the server from which to disassociate the node.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EngineAttributes"`: Engine attributes that are used for disassociating the node. No
  attributes are required for Puppet.   Attributes required in a DisassociateNode request for
  Chef     CHEF_ORGANIZATION: The Chef organization with which the node was associated. By
  default only one organization named default can exist.
"""
function disassociate_node(
    NodeName, ServerName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opsworkscm(
        "DisassociateNode",
        Dict{String,Any}("NodeName" => NodeName, "ServerName" => ServerName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_node(
    NodeName,
    ServerName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworkscm(
        "DisassociateNode",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("NodeName" => NodeName, "ServerName" => ServerName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    export_server_engine_attribute(export_attribute_name, server_name)
    export_server_engine_attribute(export_attribute_name, server_name, params::Dict{String,<:Any})

 Exports a specified server engine attribute as a base64-encoded string. For example, you
can export user data that you can use in EC2 to associate nodes with a server.   This
operation is synchronous.   A ValidationException is raised when parameters of the request
are not valid. A ResourceNotFoundException is thrown when the server does not exist. An
InvalidStateException is thrown when the server is in any of the following states:
CREATING, TERMINATED, FAILED or DELETING.

# Arguments
- `export_attribute_name`: The name of the export attribute. Currently, the supported
  export attribute is Userdata. This exports a user data script that includes parameters and
  values provided in the InputAttributes list.
- `server_name`: The name of the server from which you are exporting the attribute.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"InputAttributes"`: The list of engine attributes. The list type is EngineAttribute. An
  EngineAttribute list item is a pair that includes an attribute name and its value. For the
  Userdata ExportAttributeName, the following are supported engine attribute names.
  RunList In Chef, a list of roles or recipes that are run in the specified order. In Puppet,
  this parameter is ignored.    OrganizationName In Chef, an organization name. AWS OpsWorks
  for Chef Automate always creates the organization default. In Puppet, this parameter is
  ignored.    NodeEnvironment In Chef, a node environment (for example, development, staging,
  or one-box). In Puppet, this parameter is ignored.    NodeClientVersion In Chef, the
  version of the Chef engine (three numbers separated by dots, such as 13.8.5). If this
  attribute is empty, OpsWorks for Chef Automate uses the most current version. In Puppet,
  this parameter is ignored.
"""
function export_server_engine_attribute(
    ExportAttributeName, ServerName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opsworkscm(
        "ExportServerEngineAttribute",
        Dict{String,Any}(
            "ExportAttributeName" => ExportAttributeName, "ServerName" => ServerName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function export_server_engine_attribute(
    ExportAttributeName,
    ServerName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworkscm(
        "ExportServerEngineAttribute",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ExportAttributeName" => ExportAttributeName, "ServerName" => ServerName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Returns a list of tags that are applied to the specified AWS OpsWorks for Chef Automate or
AWS OpsWorks for Puppet Enterprise servers or backups.

# Arguments
- `resource_arn`: The Amazon Resource Number (ARN) of an AWS OpsWorks for Chef Automate or
  AWS OpsWorks for Puppet Enterprise server for which you want to show applied tags. For
  example,
  arn:aws:opsworks-cm:us-west-2:123456789012:server/test-owcm-server/EXAMPLE-66b0-4196-8274-d1
  a2bEXAMPLE.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: To receive a paginated response, use this parameter to specify the
  maximum number of results to be returned with a single call. If the number of available
  results exceeds this maximum, the response includes a NextToken value that you can assign
  to the NextToken request parameter to get the next set of results.
- `"NextToken"`: NextToken is a string that is returned in some command responses. It
  indicates that not all entries have been returned, and that you must run at least one more
  request to get remaining items. To get remaining results, call ListTagsForResource again,
  and assign the token from the previous results as the value of the nextToken parameter. If
  there are no more results, the response object's nextToken parameter value is null. Setting
  a nextToken value that was not returned in your previous results causes an
  InvalidNextTokenException to occur.
"""
function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opsworkscm(
        "ListTagsForResource",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworkscm(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    restore_server(backup_id, server_name)
    restore_server(backup_id, server_name, params::Dict{String,<:Any})

 Restores a backup to a server that is in a CONNECTION_LOST, HEALTHY, RUNNING, UNHEALTHY,
or TERMINATED state. When you run RestoreServer, the server's EC2 instance is deleted, and
a new EC2 instance is configured. RestoreServer maintains the existing server endpoint, so
configuration management of the server's client devices (nodes) should continue to work.
Restoring from a backup is performed by creating a new EC2 instance. If restoration is
successful, and the server is in a HEALTHY state, AWS OpsWorks CM switches traffic over to
the new instance. After restoration is finished, the old EC2 instance is maintained in a
Running or Stopped state, but is eventually terminated.  This operation is asynchronous.
An InvalidStateException is thrown when the server is not in a valid state. A
ResourceNotFoundException is thrown when the server does not exist. A ValidationException
is raised when parameters of the request are not valid.

# Arguments
- `backup_id`:  The ID of the backup that you want to use to restore a server.
- `server_name`:  The name of the server that you want to restore.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"InstanceType"`:  The type of instance to restore. Valid values must be specified in the
  following format: ^([cm][34]|t2).* For example, m5.large. Valid values are m5.large,
  r5.xlarge, and r5.2xlarge. If you do not specify this parameter, RestoreServer uses the
  instance type from the specified backup.
- `"KeyPair"`:  The name of the key pair to set on the new EC2 instance. This can be
  helpful if the administrator no longer has the SSH key.
"""
function restore_server(
    BackupId, ServerName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opsworkscm(
        "RestoreServer",
        Dict{String,Any}("BackupId" => BackupId, "ServerName" => ServerName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function restore_server(
    BackupId,
    ServerName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworkscm(
        "RestoreServer",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("BackupId" => BackupId, "ServerName" => ServerName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_maintenance(server_name)
    start_maintenance(server_name, params::Dict{String,<:Any})

 Manually starts server maintenance. This command can be useful if an earlier maintenance
attempt failed, and the underlying cause of maintenance failure has been resolved. The
server is in an UNDER_MAINTENANCE state while maintenance is in progress.   Maintenance can
only be started on servers in HEALTHY and UNHEALTHY states. Otherwise, an
InvalidStateException is thrown. A ResourceNotFoundException is thrown when the server does
not exist. A ValidationException is raised when parameters of the request are not valid.

# Arguments
- `server_name`: The name of the server on which to run maintenance.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EngineAttributes"`: Engine attributes that are specific to the server on which you want
  to run maintenance.  Attributes accepted in a StartMaintenance request for Chef
  CHEF_MAJOR_UPGRADE: If a Chef Automate server is eligible for upgrade to Chef Automate 2,
  add this engine attribute to a StartMaintenance request and set the value to true to
  upgrade the server to Chef Automate 2. For more information, see Upgrade an AWS OpsWorks
  for Chef Automate Server to Chef Automate 2.
"""
function start_maintenance(ServerName; aws_config::AbstractAWSConfig=current_aws_config())
    return opsworkscm(
        "StartMaintenance",
        Dict{String,Any}("ServerName" => ServerName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_maintenance(
    ServerName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworkscm(
        "StartMaintenance",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ServerName" => ServerName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Applies tags to an AWS OpsWorks for Chef Automate or AWS OpsWorks for Puppet Enterprise
server, or to server backups.

# Arguments
- `resource_arn`: The Amazon Resource Number (ARN) of a resource to which you want to apply
  tags. For example,
  arn:aws:opsworks-cm:us-west-2:123456789012:server/test-owcm-server/EXAMPLE-66b0-4196-8274-d1
  a2bEXAMPLE.
- `tags`: A map that contains tag keys and tag values to attach to AWS OpsWorks-CM servers
  or backups.   The key cannot be empty.   The key can be a maximum of 127 characters, and
  can contain only Unicode letters, numbers, or separators, or the following special
  characters: + - = . _ : /    The value can be a maximum 255 characters, and contain only
  Unicode letters, numbers, or separators, or the following special characters: + - = . _ : /
     Leading and trailing white spaces are trimmed from both the key and value.   A maximum
  of 50 user-applied tags is allowed for any AWS OpsWorks-CM server or backup.

"""
function tag_resource(ResourceArn, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return opsworkscm(
        "TagResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceArn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworkscm(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes specified tags from an AWS OpsWorks-CM server or backup.

# Arguments
- `resource_arn`: The Amazon Resource Number (ARN) of a resource from which you want to
  remove tags. For example,
  arn:aws:opsworks-cm:us-west-2:123456789012:server/test-owcm-server/EXAMPLE-66b0-4196-8274-d1
  a2bEXAMPLE.
- `tag_keys`: The keys of tags that you want to remove.

"""
function untag_resource(
    ResourceArn, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opsworkscm(
        "UntagResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceArn,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworkscm(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_server(server_name)
    update_server(server_name, params::Dict{String,<:Any})

 Updates settings for a server.   This operation is synchronous.

# Arguments
- `server_name`: The name of the server to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"BackupRetentionCount"`: Sets the number of automated backups that you want to keep.
- `"DisableAutomatedBackup"`: Setting DisableAutomatedBackup to true disables automated or
  scheduled backups. Automated backups are enabled by default.
- `"PreferredBackupWindow"`:
- `"PreferredMaintenanceWindow"`:
"""
function update_server(ServerName; aws_config::AbstractAWSConfig=current_aws_config())
    return opsworkscm(
        "UpdateServer",
        Dict{String,Any}("ServerName" => ServerName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_server(
    ServerName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworkscm(
        "UpdateServer",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ServerName" => ServerName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_server_engine_attributes(attribute_name, server_name)
    update_server_engine_attributes(attribute_name, server_name, params::Dict{String,<:Any})

 Updates engine-specific attributes on a specified server. The server enters the MODIFYING
state when this operation is in progress. Only one update can occur at a time. You can use
this command to reset a Chef server's public key (CHEF_PIVOTAL_KEY) or a Puppet server's
admin password (PUPPET_ADMIN_PASSWORD).   This operation is asynchronous.   This operation
can only be called for servers in HEALTHY or UNHEALTHY states. Otherwise, an
InvalidStateException is raised. A ResourceNotFoundException is thrown when the server does
not exist. A ValidationException is raised when parameters of the request are not valid.

# Arguments
- `attribute_name`: The name of the engine attribute to update.
- `server_name`: The name of the server to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AttributeValue"`: The value to set for the attribute.
"""
function update_server_engine_attributes(
    AttributeName, ServerName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opsworkscm(
        "UpdateServerEngineAttributes",
        Dict{String,Any}("AttributeName" => AttributeName, "ServerName" => ServerName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_server_engine_attributes(
    AttributeName,
    ServerName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworkscm(
        "UpdateServerEngineAttributes",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AttributeName" => AttributeName, "ServerName" => ServerName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: migrationhub_config
using AWS.Compat
using AWS.UUIDs

"""
    create_home_region_control(home_region, target)
    create_home_region_control(home_region, target, params::Dict{String,<:Any})

This API sets up the home region for the calling account only.

# Arguments
- `home_region`: The name of the home region of the calling account.
- `target`: The account for which this command sets up a home region control. The Target is
  always of type ACCOUNT.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DryRun"`: Optional Boolean flag to indicate whether any effect should take place. It
  tests whether the caller has permission to make the call.
"""
function create_home_region_control(
    HomeRegion, Target; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migrationhub_config(
        "CreateHomeRegionControl",
        Dict{String,Any}("HomeRegion" => HomeRegion, "Target" => Target);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_home_region_control(
    HomeRegion,
    Target,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migrationhub_config(
        "CreateHomeRegionControl",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("HomeRegion" => HomeRegion, "Target" => Target),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_home_region_control(control_id)
    delete_home_region_control(control_id, params::Dict{String,<:Any})

This operation deletes the home region configuration for the calling account. The operation
does not delete discovery or migration tracking data in the home region.

# Arguments
- `control_id`: A unique identifier that's generated for each home region control. It's
  always a string that begins with \"hrc-\" followed by 12 lowercase letters and numbers.

"""
function delete_home_region_control(
    ControlId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migrationhub_config(
        "DeleteHomeRegionControl",
        Dict{String,Any}("ControlId" => ControlId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_home_region_control(
    ControlId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migrationhub_config(
        "DeleteHomeRegionControl",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ControlId" => ControlId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_home_region_controls()
    describe_home_region_controls(params::Dict{String,<:Any})

This API permits filtering on the ControlId and HomeRegion fields.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ControlId"`: The ControlID is a unique identifier string of your HomeRegionControl
  object.
- `"HomeRegion"`: The name of the home region you'd like to view.
- `"MaxResults"`: The maximum number of filtering results to display per page.
- `"NextToken"`: If a NextToken was returned by a previous call, more results are
  available. To retrieve the next page of results, make the call again using the returned
  token in NextToken.
- `"Target"`: The target parameter specifies the identifier to which the home region is
  applied, which is always of type ACCOUNT. It applies the home region to the current ACCOUNT.
"""
function describe_home_region_controls(; aws_config::AbstractAWSConfig=current_aws_config())
    return migrationhub_config(
        "DescribeHomeRegionControls"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_home_region_controls(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migrationhub_config(
        "DescribeHomeRegionControls",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_home_region()
    get_home_region(params::Dict{String,<:Any})

Returns the calling account’s home region, if configured. This API is used by other AWS
services to determine the regional endpoint for calling AWS Application Discovery Service
and Migration Hub. You must call GetHomeRegion at least once before you call any other AWS
Application Discovery Service and AWS Migration Hub APIs, to obtain the account's Migration
Hub home region.

"""
function get_home_region(; aws_config::AbstractAWSConfig=current_aws_config())
    return migrationhub_config(
        "GetHomeRegion"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_home_region(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migrationhub_config(
        "GetHomeRegion", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: servicediscovery
using AWS.Compat
using AWS.UUIDs

"""
    create_http_namespace(name)
    create_http_namespace(name, params::Dict{String,<:Any})

Creates an HTTP namespace. Service instances registered using an HTTP namespace can be
discovered using a DiscoverInstances request but can't be discovered using DNS. For the
current quota on the number of namespaces that you can create using the same Amazon Web
Services account, see Cloud Map quotas in the Cloud Map Developer Guide.

# Arguments
- `name`: The name that you want to assign to this namespace.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CreatorRequestId"`: A unique string that identifies the request and that allows failed
  CreateHttpNamespace requests to be retried without the risk of running the operation twice.
  CreatorRequestId can be any unique string (for example, a date/time stamp).
- `"Description"`: A description for the namespace.
- `"Tags"`: The tags to add to the namespace. Each tag consists of a key and an optional
  value that you define. Tags keys can be up to 128 characters in length, and tag values can
  be up to 256 characters in length.
"""
function create_http_namespace(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return servicediscovery(
        "CreateHttpNamespace",
        Dict{String,Any}("Name" => Name, "CreatorRequestId" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_http_namespace(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return servicediscovery(
        "CreateHttpNamespace",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Name" => Name, "CreatorRequestId" => string(uuid4())),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_private_dns_namespace(name, vpc)
    create_private_dns_namespace(name, vpc, params::Dict{String,<:Any})

Creates a private namespace based on DNS, which is visible only inside a specified Amazon
VPC. The namespace defines your service naming scheme. For example, if you name your
namespace example.com and name your service backend, the resulting DNS name for the service
is backend.example.com. Service instances that are registered using a private DNS namespace
can be discovered using either a DiscoverInstances request or using DNS. For the current
quota on the number of namespaces that you can create using the same Amazon Web Services
account, see Cloud Map quotas in the Cloud Map Developer Guide.

# Arguments
- `name`: The name that you want to assign to this namespace. When you create a private DNS
  namespace, Cloud Map automatically creates an Amazon Route 53 private hosted zone that has
  the same name as the namespace.
- `vpc`: The ID of the Amazon VPC that you want to associate the namespace with.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CreatorRequestId"`: A unique string that identifies the request and that allows failed
  CreatePrivateDnsNamespace requests to be retried without the risk of running the operation
  twice. CreatorRequestId can be any unique string (for example, a date/timestamp).
- `"Description"`: A description for the namespace.
- `"Properties"`: Properties for the private DNS namespace.
- `"Tags"`: The tags to add to the namespace. Each tag consists of a key and an optional
  value that you define. Tags keys can be up to 128 characters in length, and tag values can
  be up to 256 characters in length.
"""
function create_private_dns_namespace(
    Name, Vpc; aws_config::AbstractAWSConfig=current_aws_config()
)
    return servicediscovery(
        "CreatePrivateDnsNamespace",
        Dict{String,Any}(
            "Name" => Name, "Vpc" => Vpc, "CreatorRequestId" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_private_dns_namespace(
    Name,
    Vpc,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return servicediscovery(
        "CreatePrivateDnsNamespace",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Name" => Name, "Vpc" => Vpc, "CreatorRequestId" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_public_dns_namespace(name)
    create_public_dns_namespace(name, params::Dict{String,<:Any})

Creates a public namespace based on DNS, which is visible on the internet. The namespace
defines your service naming scheme. For example, if you name your namespace example.com and
name your service backend, the resulting DNS name for the service is backend.example.com.
You can discover instances that were registered with a public DNS namespace by using either
a DiscoverInstances request or using DNS. For the current quota on the number of namespaces
that you can create using the same Amazon Web Services account, see Cloud Map quotas in the
Cloud Map Developer Guide.  The CreatePublicDnsNamespace API operation is not supported in
the Amazon Web Services GovCloud (US) Regions.

# Arguments
- `name`: The name that you want to assign to this namespace.  Do not include sensitive
  information in the name. The name is publicly available using DNS queries.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CreatorRequestId"`: A unique string that identifies the request and that allows failed
  CreatePublicDnsNamespace requests to be retried without the risk of running the operation
  twice. CreatorRequestId can be any unique string (for example, a date/timestamp).
- `"Description"`: A description for the namespace.
- `"Properties"`: Properties for the public DNS namespace.
- `"Tags"`: The tags to add to the namespace. Each tag consists of a key and an optional
  value that you define. Tags keys can be up to 128 characters in length, and tag values can
  be up to 256 characters in length.
"""
function create_public_dns_namespace(
    Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return servicediscovery(
        "CreatePublicDnsNamespace",
        Dict{String,Any}("Name" => Name, "CreatorRequestId" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_public_dns_namespace(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return servicediscovery(
        "CreatePublicDnsNamespace",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Name" => Name, "CreatorRequestId" => string(uuid4())),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_service(name)
    create_service(name, params::Dict{String,<:Any})

Creates a service. This action defines the configuration for the following entities:   For
public and private DNS namespaces, one of the following combinations of DNS records in
Amazon Route 53:    A     AAAA     A and AAAA     SRV     CNAME      Optionally, a health
check   After you create the service, you can submit a RegisterInstance request, and Cloud
Map uses the values in the configuration to create the specified entities. For the current
quota on the number of instances that you can register using the same namespace and using
the same service, see Cloud Map quotas in the Cloud Map Developer Guide.

# Arguments
- `name`: The name that you want to assign to the service.  Do not include sensitive
  information in the name if the namespace is discoverable by public DNS queries.  If you
  want Cloud Map to create an SRV record when you register an instance and you're using a
  system that requires a specific SRV format, such as HAProxy, specify the following for
  Name:   Start the name with an underscore (_), such as _exampleservice.   End the name with
  ._protocol, such as ._tcp.   When you register an instance, Cloud Map creates an SRV record
  and assigns a name to the record by concatenating the service name and the namespace name
  (for example,  _exampleservice._tcp.example.com).  For services that are accessible by DNS
  queries, you can't create multiple services with names that differ only by case (such as
  EXAMPLE and example). Otherwise, these services have the same DNS name and can't be
  distinguished. However, if you use a namespace that's only accessible by API calls, then
  you can create services that with names that differ only by case.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CreatorRequestId"`: A unique string that identifies the request and that allows failed
  CreateService requests to be retried without the risk of running the operation twice.
  CreatorRequestId can be any unique string (for example, a date/timestamp).
- `"Description"`: A description for the service.
- `"DnsConfig"`: A complex type that contains information about the Amazon Route 53
  records that you want Cloud Map to create when you register an instance.
- `"HealthCheckConfig"`:  Public DNS and HTTP namespaces only. A complex type that contains
  settings for an optional Route 53 health check. If you specify settings for a health
  check, Cloud Map associates the health check with all the Route 53 DNS records that you
  specify in DnsConfig.  If you specify a health check configuration, you can specify either
  HealthCheckCustomConfig or HealthCheckConfig but not both.  For information about the
  charges for health checks, see Cloud Map Pricing.
- `"HealthCheckCustomConfig"`: A complex type that contains information about an optional
  custom health check.  If you specify a health check configuration, you can specify either
  HealthCheckCustomConfig or HealthCheckConfig but not both.  You can't add, update, or
  delete a HealthCheckCustomConfig configuration from an existing service.
- `"NamespaceId"`: The ID of the namespace that you want to use to create the service. The
  namespace ID must be specified, but it can be specified either here or in the DnsConfig
  object.
- `"Tags"`: The tags to add to the service. Each tag consists of a key and an optional
  value that you define. Tags keys can be up to 128 characters in length, and tag values can
  be up to 256 characters in length.
- `"Type"`: If present, specifies that the service instances are only discoverable using
  the DiscoverInstances API operation. No DNS records is registered for the service
  instances. The only valid value is HTTP.
"""
function create_service(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return servicediscovery(
        "CreateService",
        Dict{String,Any}("Name" => Name, "CreatorRequestId" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_service(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return servicediscovery(
        "CreateService",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Name" => Name, "CreatorRequestId" => string(uuid4())),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_namespace(id)
    delete_namespace(id, params::Dict{String,<:Any})

Deletes a namespace from the current account. If the namespace still contains one or more
services, the request fails.

# Arguments
- `id`: The ID of the namespace that you want to delete.

"""
function delete_namespace(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return servicediscovery(
        "DeleteNamespace",
        Dict{String,Any}("Id" => Id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_namespace(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return servicediscovery(
        "DeleteNamespace",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Id" => Id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_service(id)
    delete_service(id, params::Dict{String,<:Any})

Deletes a specified service. If the service still contains one or more registered
instances, the request fails.

# Arguments
- `id`: The ID of the service that you want to delete.

"""
function delete_service(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return servicediscovery(
        "DeleteService",
        Dict{String,Any}("Id" => Id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_service(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return servicediscovery(
        "DeleteService",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Id" => Id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    deregister_instance(instance_id, service_id)
    deregister_instance(instance_id, service_id, params::Dict{String,<:Any})

Deletes the Amazon Route 53 DNS records and health check, if any, that Cloud Map created
for the specified instance.

# Arguments
- `instance_id`: The value that you specified for Id in the RegisterInstance request.
- `service_id`: The ID of the service that the instance is associated with.

"""
function deregister_instance(
    InstanceId, ServiceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return servicediscovery(
        "DeregisterInstance",
        Dict{String,Any}("InstanceId" => InstanceId, "ServiceId" => ServiceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function deregister_instance(
    InstanceId,
    ServiceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return servicediscovery(
        "DeregisterInstance",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("InstanceId" => InstanceId, "ServiceId" => ServiceId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    discover_instances(namespace_name, service_name)
    discover_instances(namespace_name, service_name, params::Dict{String,<:Any})

Discovers registered instances for a specified namespace and service. You can use
DiscoverInstances to discover instances for any type of namespace. DiscoverInstances
returns a randomized list of instances allowing customers to distribute traffic evenly
across instances. For public and private DNS namespaces, you can also use DNS queries to
discover instances.

# Arguments
- `namespace_name`: The HttpName name of the namespace. It's found in the HttpProperties
  member of the Properties member of the namespace. In most cases, Name and HttpName match.
  However, if you reuse Name for namespace creation, a generated hash is added to HttpName to
  distinguish the two.
- `service_name`: The name of the service that you specified when you registered the
  instance.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"HealthStatus"`: The health status of the instances that you want to discover. This
  parameter is ignored for services that don't have a health check configured, and all
  instances are returned.  HEALTHY  Returns healthy instances.  UNHEALTHY  Returns unhealthy
  instances.  ALL  Returns all instances.  HEALTHY_OR_ELSE_ALL  Returns healthy instances,
  unless none are reporting a healthy state. In that case, return all instances. This is also
  called failing open.
- `"MaxResults"`: The maximum number of instances that you want Cloud Map to return in the
  response to a DiscoverInstances request. If you don't specify a value for MaxResults, Cloud
  Map returns up to 100 instances.
- `"OptionalParameters"`: Opportunistic filters to scope the results based on custom
  attributes. If there are instances that match both the filters specified in both the
  QueryParameters parameter and this parameter, all of these instances are returned.
  Otherwise, the filters are ignored, and only instances that match the filters that are
  specified in the QueryParameters parameter are returned.
- `"QueryParameters"`: Filters to scope the results based on custom attributes for the
  instance (for example, {version=v1, az=1a}). Only instances that match all the specified
  key-value pairs are returned.
"""
function discover_instances(
    NamespaceName, ServiceName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return servicediscovery(
        "DiscoverInstances",
        Dict{String,Any}("NamespaceName" => NamespaceName, "ServiceName" => ServiceName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function discover_instances(
    NamespaceName,
    ServiceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return servicediscovery(
        "DiscoverInstances",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "NamespaceName" => NamespaceName, "ServiceName" => ServiceName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    discover_instances_revision(namespace_name, service_name)
    discover_instances_revision(namespace_name, service_name, params::Dict{String,<:Any})

Discovers the increasing revision associated with an instance.

# Arguments
- `namespace_name`: The HttpName name of the namespace. It's found in the HttpProperties
  member of the Properties member of the namespace.
- `service_name`: The name of the service that you specified when you registered the
  instance.

"""
function discover_instances_revision(
    NamespaceName, ServiceName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return servicediscovery(
        "DiscoverInstancesRevision",
        Dict{String,Any}("NamespaceName" => NamespaceName, "ServiceName" => ServiceName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function discover_instances_revision(
    NamespaceName,
    ServiceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return servicediscovery(
        "DiscoverInstancesRevision",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "NamespaceName" => NamespaceName, "ServiceName" => ServiceName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_instance(instance_id, service_id)
    get_instance(instance_id, service_id, params::Dict{String,<:Any})

Gets information about a specified instance.

# Arguments
- `instance_id`: The ID of the instance that you want to get information about.
- `service_id`: The ID of the service that the instance is associated with.

"""
function get_instance(
    InstanceId, ServiceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return servicediscovery(
        "GetInstance",
        Dict{String,Any}("InstanceId" => InstanceId, "ServiceId" => ServiceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_instance(
    InstanceId,
    ServiceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return servicediscovery(
        "GetInstance",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("InstanceId" => InstanceId, "ServiceId" => ServiceId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_instances_health_status(service_id)
    get_instances_health_status(service_id, params::Dict{String,<:Any})

Gets the current health status (Healthy, Unhealthy, or Unknown) of one or more instances
that are associated with a specified service.  There's a brief delay between when you
register an instance and when the health status for the instance is available.

# Arguments
- `service_id`: The ID of the service that the instance is associated with.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Instances"`: An array that contains the IDs of all the instances that you want to get
  the health status for. If you omit Instances, Cloud Map returns the health status for all
  the instances that are associated with the specified service.  To get the IDs for the
  instances that you've registered by using a specified service, submit a ListInstances
  request.
- `"MaxResults"`: The maximum number of instances that you want Cloud Map to return in the
  response to a GetInstancesHealthStatus request. If you don't specify a value for
  MaxResults, Cloud Map returns up to 100 instances.
- `"NextToken"`: For the first GetInstancesHealthStatus request, omit this value. If more
  than MaxResults instances match the specified criteria, you can submit another
  GetInstancesHealthStatus request to get the next group of results. Specify the value of
  NextToken from the previous response in the next request.
"""
function get_instances_health_status(
    ServiceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return servicediscovery(
        "GetInstancesHealthStatus",
        Dict{String,Any}("ServiceId" => ServiceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_instances_health_status(
    ServiceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return servicediscovery(
        "GetInstancesHealthStatus",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ServiceId" => ServiceId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_namespace(id)
    get_namespace(id, params::Dict{String,<:Any})

Gets information about a namespace.

# Arguments
- `id`: The ID of the namespace that you want to get information about.

"""
function get_namespace(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return servicediscovery(
        "GetNamespace",
        Dict{String,Any}("Id" => Id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_namespace(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return servicediscovery(
        "GetNamespace",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Id" => Id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_operation(operation_id)
    get_operation(operation_id, params::Dict{String,<:Any})

Gets information about any operation that returns an operation ID in the response, such as
a CreateHttpNamespace request.  To get a list of operations that match specified criteria,
see ListOperations.

# Arguments
- `operation_id`: The ID of the operation that you want to get more information about.

"""
function get_operation(OperationId; aws_config::AbstractAWSConfig=current_aws_config())
    return servicediscovery(
        "GetOperation",
        Dict{String,Any}("OperationId" => OperationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_operation(
    OperationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return servicediscovery(
        "GetOperation",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("OperationId" => OperationId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_service(id)
    get_service(id, params::Dict{String,<:Any})

Gets the settings for a specified service.

# Arguments
- `id`: The ID of the service that you want to get settings for.

"""
function get_service(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return servicediscovery(
        "GetService",
        Dict{String,Any}("Id" => Id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_service(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return servicediscovery(
        "GetService",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Id" => Id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_instances(service_id)
    list_instances(service_id, params::Dict{String,<:Any})

Lists summary information about the instances that you registered by using a specified
service.

# Arguments
- `service_id`: The ID of the service that you want to list instances for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of instances that you want Cloud Map to return in the
  response to a ListInstances request. If you don't specify a value for MaxResults, Cloud Map
  returns up to 100 instances.
- `"NextToken"`: For the first ListInstances request, omit this value. If more than
  MaxResults instances match the specified criteria, you can submit another ListInstances
  request to get the next group of results. Specify the value of NextToken from the previous
  response in the next request.
"""
function list_instances(ServiceId; aws_config::AbstractAWSConfig=current_aws_config())
    return servicediscovery(
        "ListInstances",
        Dict{String,Any}("ServiceId" => ServiceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_instances(
    ServiceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return servicediscovery(
        "ListInstances",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ServiceId" => ServiceId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_namespaces()
    list_namespaces(params::Dict{String,<:Any})

Lists summary information about the namespaces that were created by the current Amazon Web
Services account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: A complex type that contains specifications for the namespaces that you want
  to list. If you specify more than one filter, a namespace must match all filters to be
  returned by ListNamespaces.
- `"MaxResults"`: The maximum number of namespaces that you want Cloud Map to return in the
  response to a ListNamespaces request. If you don't specify a value for MaxResults, Cloud
  Map returns up to 100 namespaces.
- `"NextToken"`: For the first ListNamespaces request, omit this value. If the response
  contains NextToken, submit another ListNamespaces request to get the next group of results.
  Specify the value of NextToken from the previous response in the next request.  Cloud Map
  gets MaxResults namespaces and then filters them based on the specified criteria. It's
  possible that no namespaces in the first MaxResults namespaces matched the specified
  criteria but that subsequent groups of MaxResults namespaces do contain namespaces that
  match the criteria.
"""
function list_namespaces(; aws_config::AbstractAWSConfig=current_aws_config())
    return servicediscovery(
        "ListNamespaces"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_namespaces(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return servicediscovery(
        "ListNamespaces", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_operations()
    list_operations(params::Dict{String,<:Any})

Lists operations that match the criteria that you specify.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: A complex type that contains specifications for the operations that you want
  to list, for example, operations that you started between a specified start date and end
  date. If you specify more than one filter, an operation must match all filters to be
  returned by ListOperations.
- `"MaxResults"`: The maximum number of items that you want Cloud Map to return in the
  response to a ListOperations request. If you don't specify a value for MaxResults, Cloud
  Map returns up to 100 operations.
- `"NextToken"`: For the first ListOperations request, omit this value. If the response
  contains NextToken, submit another ListOperations request to get the next group of results.
  Specify the value of NextToken from the previous response in the next request.  Cloud Map
  gets MaxResults operations and then filters them based on the specified criteria. It's
  possible that no operations in the first MaxResults operations matched the specified
  criteria but that subsequent groups of MaxResults operations do contain operations that
  match the criteria.
"""
function list_operations(; aws_config::AbstractAWSConfig=current_aws_config())
    return servicediscovery(
        "ListOperations"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_operations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return servicediscovery(
        "ListOperations", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_services()
    list_services(params::Dict{String,<:Any})

Lists summary information for all the services that are associated with one or more
namespaces.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: A complex type that contains specifications for the namespaces that you want
  to list services for.  If you specify more than one filter, an operation must match all
  filters to be returned by ListServices.
- `"MaxResults"`: The maximum number of services that you want Cloud Map to return in the
  response to a ListServices request. If you don't specify a value for MaxResults, Cloud Map
  returns up to 100 services.
- `"NextToken"`: For the first ListServices request, omit this value. If the response
  contains NextToken, submit another ListServices request to get the next group of results.
  Specify the value of NextToken from the previous response in the next request.  Cloud Map
  gets MaxResults services and then filters them based on the specified criteria. It's
  possible that no services in the first MaxResults services matched the specified criteria
  but that subsequent groups of MaxResults services do contain services that match the
  criteria.
"""
function list_services(; aws_config::AbstractAWSConfig=current_aws_config())
    return servicediscovery(
        "ListServices"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_services(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return servicediscovery(
        "ListServices", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists tags for the specified resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource that you want to retrieve
  tags for.

"""
function list_tags_for_resource(
    ResourceARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return servicediscovery(
        "ListTagsForResource",
        Dict{String,Any}("ResourceARN" => ResourceARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return servicediscovery(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceARN" => ResourceARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    register_instance(attributes, instance_id, service_id)
    register_instance(attributes, instance_id, service_id, params::Dict{String,<:Any})

Creates or updates one or more records and, optionally, creates a health check based on the
settings in a specified service. When you submit a RegisterInstance request, the following
occurs:   For each DNS record that you define in the service that's specified by ServiceId,
a record is created or updated in the hosted zone that's associated with the corresponding
namespace.   If the service includes HealthCheckConfig, a health check is created based on
the settings in the health check configuration.   The health check, if any, is associated
with each of the new or updated records.    One RegisterInstance request must complete
before you can submit another request and specify the same service ID and instance ID.  For
more information, see CreateService. When Cloud Map receives a DNS query for the specified
DNS name, it returns the applicable value:    If the health check is healthy: returns all
the records    If the health check is unhealthy: returns the applicable value for the last
healthy instance    If you didn't specify a health check configuration: returns all the
records   For the current quota on the number of instances that you can register using the
same namespace and using the same service, see Cloud Map quotas in the Cloud Map Developer
Guide.

# Arguments
- `attributes`: A string map that contains the following information for the service that
  you specify in ServiceId:   The attributes that apply to the records that are defined in
  the service.    For each attribute, the applicable value.    Do not include sensitive
  information in the attributes if the namespace is discoverable by public DNS queries.  The
  following are the supported attribute keys.  AWS_ALIAS_DNS_NAME  If you want Cloud Map to
  create an Amazon Route 53 alias record that routes traffic to an Elastic Load Balancing
  load balancer, specify the DNS name that's associated with the load balancer. For
  information about how to get the DNS name, see \"DNSName\" in the topic AliasTarget in the
  Route 53 API Reference. Note the following:   The configuration for the service that's
  specified by ServiceId must include settings for an A record, an AAAA record, or both.   In
  the service that's specified by ServiceId, the value of RoutingPolicy must be WEIGHTED.
  If the service that's specified by ServiceId includes HealthCheckConfig settings, Cloud Map
  will create the Route 53 health check, but it doesn't associate the health check with the
  alias record.   Cloud Map currently doesn't support creating alias records that route
  traffic to Amazon Web Services resources other than Elastic Load Balancing load balancers.
   If you specify a value for AWS_ALIAS_DNS_NAME, don't specify values for any of the
  AWS_INSTANCE attributes.   The AWS_ALIAS_DNS_NAME is not supported in the GovCloud (US)
  Regions.    AWS_EC2_INSTANCE_ID   HTTP namespaces only. The Amazon EC2 instance ID for the
  instance. If the AWS_EC2_INSTANCE_ID attribute is specified, then the only other attribute
  that can be specified is AWS_INIT_HEALTH_STATUS. When the AWS_EC2_INSTANCE_ID attribute is
  specified, then the AWS_INSTANCE_IPV4 attribute will be filled out with the primary private
  IPv4 address.  AWS_INIT_HEALTH_STATUS  If the service configuration includes
  HealthCheckCustomConfig, you can optionally use AWS_INIT_HEALTH_STATUS to specify the
  initial status of the custom health check, HEALTHY or UNHEALTHY. If you don't specify a
  value for AWS_INIT_HEALTH_STATUS, the initial status is HEALTHY.  AWS_INSTANCE_CNAME  If
  the service configuration includes a CNAME record, the domain name that you want Route 53
  to return in response to DNS queries (for example, example.com). This value is required if
  the service specified by ServiceId includes settings for an CNAME record.
  AWS_INSTANCE_IPV4  If the service configuration includes an A record, the IPv4 address that
  you want Route 53 to return in response to DNS queries (for example, 192.0.2.44). This
  value is required if the service specified by ServiceId includes settings for an A record.
  If the service includes settings for an SRV record, you must specify a value for
  AWS_INSTANCE_IPV4, AWS_INSTANCE_IPV6, or both.  AWS_INSTANCE_IPV6  If the service
  configuration includes an AAAA record, the IPv6 address that you want Route 53 to return
  in response to DNS queries (for example, 2001:0db8:85a3:0000:0000:abcd:0001:2345). This
  value is required if the service specified by ServiceId includes settings for an AAAA
  record. If the service includes settings for an SRV record, you must specify a value for
  AWS_INSTANCE_IPV4, AWS_INSTANCE_IPV6, or both.  AWS_INSTANCE_PORT  If the service includes
  an SRV record, the value that you want Route 53 to return for the port. If the service
  includes HealthCheckConfig, the port on the endpoint that you want Route 53 to send
  requests to.  This value is required if you specified settings for an SRV record or a
  Route 53 health check when you created the service.  Custom attributes  You can add up to
  30 custom attributes. For each key-value pair, the maximum length of the attribute name is
  255 characters, and the maximum length of the attribute value is 1,024 characters. The
  total size of all provided attributes (sum of all keys and values) must not exceed 5,000
  characters.
- `instance_id`: An identifier that you want to associate with the instance. Note the
  following:   If the service that's specified by ServiceId includes settings for an SRV
  record, the value of InstanceId is automatically included as part of the value for the SRV
  record. For more information, see DnsRecord &gt; Type.   You can use this value to update
  an existing instance.   To register a new instance, you must specify a value that's unique
  among instances that you register by using the same service.    If you specify an existing
  InstanceId and ServiceId, Cloud Map updates the existing DNS records, if any. If there's
  also an existing health check, Cloud Map deletes the old health check and creates a new
  one.   The health check isn't deleted immediately, so it will still appear for a while if
  you submit a ListHealthChecks request, for example.     Do not include sensitive
  information in InstanceId if the namespace is discoverable by public DNS queries and any
  Type member of DnsRecord for the service contains SRV because the InstanceId is
  discoverable by public DNS queries.
- `service_id`: The ID of the service that you want to use for settings for the instance.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CreatorRequestId"`: A unique string that identifies the request and that allows failed
  RegisterInstance requests to be retried without the risk of executing the operation twice.
  You must use a unique CreatorRequestId string every time you submit a RegisterInstance
  request if you're registering additional instances for the same namespace and service.
  CreatorRequestId can be any unique string (for example, a date/time stamp).
"""
function register_instance(
    Attributes, InstanceId, ServiceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return servicediscovery(
        "RegisterInstance",
        Dict{String,Any}(
            "Attributes" => Attributes,
            "InstanceId" => InstanceId,
            "ServiceId" => ServiceId,
            "CreatorRequestId" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function register_instance(
    Attributes,
    InstanceId,
    ServiceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return servicediscovery(
        "RegisterInstance",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Attributes" => Attributes,
                    "InstanceId" => InstanceId,
                    "ServiceId" => ServiceId,
                    "CreatorRequestId" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds one or more tags to the specified resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource that you want to retrieve
  tags for.
- `tags`: The tags to add to the specified resource. Specifying the tag key is required.
  You can set the value of a tag to an empty string, but you can't set the value of a tag to
  null.

"""
function tag_resource(ResourceARN, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return servicediscovery(
        "TagResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceARN,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return servicediscovery(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes one or more tags from the specified resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource that you want to retrieve
  tags for.
- `tag_keys`: The tag keys to remove from the specified resource.

"""
function untag_resource(
    ResourceARN, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return servicediscovery(
        "UntagResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceARN,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return servicediscovery(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_http_namespace(id, namespace)
    update_http_namespace(id, namespace, params::Dict{String,<:Any})

Updates an HTTP namespace.

# Arguments
- `id`: The ID of the namespace that you want to update.
- `namespace`: Updated properties for the the HTTP namespace.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"UpdaterRequestId"`: A unique string that identifies the request and that allows failed
  UpdateHttpNamespace requests to be retried without the risk of running the operation twice.
  UpdaterRequestId can be any unique string (for example, a date/timestamp).
"""
function update_http_namespace(
    Id, Namespace; aws_config::AbstractAWSConfig=current_aws_config()
)
    return servicediscovery(
        "UpdateHttpNamespace",
        Dict{String,Any}(
            "Id" => Id, "Namespace" => Namespace, "UpdaterRequestId" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_http_namespace(
    Id,
    Namespace,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return servicediscovery(
        "UpdateHttpNamespace",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Id" => Id,
                    "Namespace" => Namespace,
                    "UpdaterRequestId" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_instance_custom_health_status(instance_id, service_id, status)
    update_instance_custom_health_status(instance_id, service_id, status, params::Dict{String,<:Any})

Submits a request to change the health status of a custom health check to healthy or
unhealthy. You can use UpdateInstanceCustomHealthStatus to change the status only for
custom health checks, which you define using HealthCheckCustomConfig when you create a
service. You can't use it to change the status for Route 53 health checks, which you
define using HealthCheckConfig. For more information, see HealthCheckCustomConfig.

# Arguments
- `instance_id`: The ID of the instance that you want to change the health status for.
- `service_id`: The ID of the service that includes the configuration for the custom health
  check that you want to change the status for.
- `status`: The new status of the instance, HEALTHY or UNHEALTHY.

"""
function update_instance_custom_health_status(
    InstanceId, ServiceId, Status; aws_config::AbstractAWSConfig=current_aws_config()
)
    return servicediscovery(
        "UpdateInstanceCustomHealthStatus",
        Dict{String,Any}(
            "InstanceId" => InstanceId, "ServiceId" => ServiceId, "Status" => Status
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_instance_custom_health_status(
    InstanceId,
    ServiceId,
    Status,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return servicediscovery(
        "UpdateInstanceCustomHealthStatus",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "InstanceId" => InstanceId, "ServiceId" => ServiceId, "Status" => Status
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_private_dns_namespace(id, namespace)
    update_private_dns_namespace(id, namespace, params::Dict{String,<:Any})

Updates a private DNS namespace.

# Arguments
- `id`: The ID of the namespace that you want to update.
- `namespace`: Updated properties for the private DNS namespace.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"UpdaterRequestId"`: A unique string that identifies the request and that allows failed
  UpdatePrivateDnsNamespace requests to be retried without the risk of running the operation
  twice. UpdaterRequestId can be any unique string (for example, a date/timestamp).
"""
function update_private_dns_namespace(
    Id, Namespace; aws_config::AbstractAWSConfig=current_aws_config()
)
    return servicediscovery(
        "UpdatePrivateDnsNamespace",
        Dict{String,Any}(
            "Id" => Id, "Namespace" => Namespace, "UpdaterRequestId" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_private_dns_namespace(
    Id,
    Namespace,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return servicediscovery(
        "UpdatePrivateDnsNamespace",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Id" => Id,
                    "Namespace" => Namespace,
                    "UpdaterRequestId" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_public_dns_namespace(id, namespace)
    update_public_dns_namespace(id, namespace, params::Dict{String,<:Any})

Updates a public DNS namespace.

# Arguments
- `id`: The ID of the namespace being updated.
- `namespace`: Updated properties for the public DNS namespace.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"UpdaterRequestId"`: A unique string that identifies the request and that allows failed
  UpdatePublicDnsNamespace requests to be retried without the risk of running the operation
  twice. UpdaterRequestId can be any unique string (for example, a date/timestamp).
"""
function update_public_dns_namespace(
    Id, Namespace; aws_config::AbstractAWSConfig=current_aws_config()
)
    return servicediscovery(
        "UpdatePublicDnsNamespace",
        Dict{String,Any}(
            "Id" => Id, "Namespace" => Namespace, "UpdaterRequestId" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_public_dns_namespace(
    Id,
    Namespace,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return servicediscovery(
        "UpdatePublicDnsNamespace",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Id" => Id,
                    "Namespace" => Namespace,
                    "UpdaterRequestId" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_service(id, service)
    update_service(id, service, params::Dict{String,<:Any})

Submits a request to perform the following operations:   Update the TTL setting for
existing DnsRecords configurations   Add, update, or delete HealthCheckConfig for a
specified service  You can't add, update, or delete a HealthCheckCustomConfig
configuration.    For public and private DNS namespaces, note the following:   If you omit
any existing DnsRecords or HealthCheckConfig configurations from an UpdateService request,
the configurations are deleted from the service.   If you omit an existing
HealthCheckCustomConfig configuration from an UpdateService request, the configuration
isn't deleted from the service.   When you update settings for a service, Cloud Map also
updates the corresponding settings in all the records and health checks that were created
by using the specified service.

# Arguments
- `id`: The ID of the service that you want to update.
- `service`: A complex type that contains the new settings for the service.

"""
function update_service(Id, Service; aws_config::AbstractAWSConfig=current_aws_config())
    return servicediscovery(
        "UpdateService",
        Dict{String,Any}("Id" => Id, "Service" => Service);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_service(
    Id,
    Service,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return servicediscovery(
        "UpdateService",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Id" => Id, "Service" => Service), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: workspaces
using AWS.Compat
using AWS.UUIDs

"""
    accept_account_link_invitation(link_id)
    accept_account_link_invitation(link_id, params::Dict{String,<:Any})

Accepts the account link invitation.  There's currently no unlinking capability after you
accept the account linking invitation.

# Arguments
- `link_id`: The identifier of the account link.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: A string of up to 64 ASCII characters that Amazon EFS uses to ensure
  idempotent creation.
"""
function accept_account_link_invitation(
    LinkId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "AcceptAccountLinkInvitation",
        Dict{String,Any}("LinkId" => LinkId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function accept_account_link_invitation(
    LinkId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "AcceptAccountLinkInvitation",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("LinkId" => LinkId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_connection_alias(alias_id, resource_id)
    associate_connection_alias(alias_id, resource_id, params::Dict{String,<:Any})

Associates the specified connection alias with the specified directory to enable
cross-Region redirection. For more information, see  Cross-Region Redirection for Amazon
WorkSpaces.  Before performing this operation, call  DescribeConnectionAliases to make sure
that the current state of the connection alias is CREATED.

# Arguments
- `alias_id`: The identifier of the connection alias.
- `resource_id`: The identifier of the directory to associate the connection alias with.

"""
function associate_connection_alias(
    AliasId, ResourceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "AssociateConnectionAlias",
        Dict{String,Any}("AliasId" => AliasId, "ResourceId" => ResourceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_connection_alias(
    AliasId,
    ResourceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "AssociateConnectionAlias",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("AliasId" => AliasId, "ResourceId" => ResourceId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_ip_groups(directory_id, group_ids)
    associate_ip_groups(directory_id, group_ids, params::Dict{String,<:Any})

Associates the specified IP access control group with the specified directory.

# Arguments
- `directory_id`: The identifier of the directory.
- `group_ids`: The identifiers of one or more IP access control groups.

"""
function associate_ip_groups(
    DirectoryId, GroupIds; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "AssociateIpGroups",
        Dict{String,Any}("DirectoryId" => DirectoryId, "GroupIds" => GroupIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_ip_groups(
    DirectoryId,
    GroupIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "AssociateIpGroups",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DirectoryId" => DirectoryId, "GroupIds" => GroupIds),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_workspace_application(application_id, workspace_id)
    associate_workspace_application(application_id, workspace_id, params::Dict{String,<:Any})

Associates the specified application to the specified WorkSpace.

# Arguments
- `application_id`: The identifier of the application.
- `workspace_id`: The identifier of the WorkSpace.

"""
function associate_workspace_application(
    ApplicationId, WorkspaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "AssociateWorkspaceApplication",
        Dict{String,Any}("ApplicationId" => ApplicationId, "WorkspaceId" => WorkspaceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_workspace_application(
    ApplicationId,
    WorkspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "AssociateWorkspaceApplication",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationId" => ApplicationId, "WorkspaceId" => WorkspaceId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    authorize_ip_rules(group_id, user_rules)
    authorize_ip_rules(group_id, user_rules, params::Dict{String,<:Any})

Adds one or more rules to the specified IP access control group. This action gives users
permission to access their WorkSpaces from the CIDR address ranges specified in the rules.

# Arguments
- `group_id`: The identifier of the group.
- `user_rules`: The rules to add to the group.

"""
function authorize_ip_rules(
    GroupId, UserRules; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "AuthorizeIpRules",
        Dict{String,Any}("GroupId" => GroupId, "UserRules" => UserRules);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function authorize_ip_rules(
    GroupId,
    UserRules,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "AuthorizeIpRules",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("GroupId" => GroupId, "UserRules" => UserRules),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    copy_workspace_image(name, source_image_id, source_region)
    copy_workspace_image(name, source_image_id, source_region, params::Dict{String,<:Any})

Copies the specified image from the specified Region to the current Region. For more
information about copying images, see  Copy a Custom WorkSpaces Image. In the China
(Ningxia) Region, you can copy images only within the same Region. In Amazon Web Services
GovCloud (US), to copy images to and from other Regions, contact Amazon Web Services
Support.  Before copying a shared image, be sure to verify that it has been shared from the
correct Amazon Web Services account. To determine if an image has been shared and to see
the ID of the Amazon Web Services account that owns an image, use the
DescribeWorkSpaceImages and DescribeWorkspaceImagePermissions API operations.

# Arguments
- `name`: The name of the image.
- `source_image_id`: The identifier of the source image.
- `source_region`: The identifier of the source Region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description of the image.
- `"Tags"`: The tags for the image.
"""
function copy_workspace_image(
    Name, SourceImageId, SourceRegion; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "CopyWorkspaceImage",
        Dict{String,Any}(
            "Name" => Name, "SourceImageId" => SourceImageId, "SourceRegion" => SourceRegion
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function copy_workspace_image(
    Name,
    SourceImageId,
    SourceRegion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "CopyWorkspaceImage",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Name" => Name,
                    "SourceImageId" => SourceImageId,
                    "SourceRegion" => SourceRegion,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_account_link_invitation(target_account_id)
    create_account_link_invitation(target_account_id, params::Dict{String,<:Any})

Creates the account link invitation.

# Arguments
- `target_account_id`: The identifier of the target account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: A string of up to 64 ASCII characters that Amazon EFS uses to ensure
  idempotent creation.
"""
function create_account_link_invitation(
    TargetAccountId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "CreateAccountLinkInvitation",
        Dict{String,Any}("TargetAccountId" => TargetAccountId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_account_link_invitation(
    TargetAccountId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "CreateAccountLinkInvitation",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("TargetAccountId" => TargetAccountId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_connect_client_add_in(name, resource_id, url)
    create_connect_client_add_in(name, resource_id, url, params::Dict{String,<:Any})

Creates a client-add-in for Amazon Connect within a directory. You can create only one
Amazon Connect client add-in within a directory. This client add-in allows WorkSpaces users
to seamlessly connect to Amazon Connect.

# Arguments
- `name`: The name of the client add-in.
- `resource_id`: The directory identifier for which to configure the client add-in.
- `url`: The endpoint URL of the Amazon Connect client add-in.

"""
function create_connect_client_add_in(
    Name, ResourceId, URL; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "CreateConnectClientAddIn",
        Dict{String,Any}("Name" => Name, "ResourceId" => ResourceId, "URL" => URL);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_connect_client_add_in(
    Name,
    ResourceId,
    URL,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "CreateConnectClientAddIn",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Name" => Name, "ResourceId" => ResourceId, "URL" => URL),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_connection_alias(connection_string)
    create_connection_alias(connection_string, params::Dict{String,<:Any})

Creates the specified connection alias for use with cross-Region redirection. For more
information, see  Cross-Region Redirection for Amazon WorkSpaces.

# Arguments
- `connection_string`: A connection string in the form of a fully qualified domain name
  (FQDN), such as www.example.com.  After you create a connection string, it is always
  associated to your Amazon Web Services account. You cannot recreate the same connection
  string with a different account, even if you delete all instances of it from the original
  account. The connection string is globally reserved for your account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: The tags to associate with the connection alias.
"""
function create_connection_alias(
    ConnectionString; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "CreateConnectionAlias",
        Dict{String,Any}("ConnectionString" => ConnectionString);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_connection_alias(
    ConnectionString,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "CreateConnectionAlias",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ConnectionString" => ConnectionString), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_ip_group(group_name)
    create_ip_group(group_name, params::Dict{String,<:Any})

Creates an IP access control group. An IP access control group provides you with the
ability to control the IP addresses from which users are allowed to access their
WorkSpaces. To specify the CIDR address ranges, add rules to your IP access control group
and then associate the group with your directory. You can add rules when you create the
group or at any time using AuthorizeIpRules. There is a default IP access control group
associated with your directory. If you don't associate an IP access control group with your
directory, the default group is used. The default group includes a default rule that allows
users to access their WorkSpaces from anywhere. You cannot modify the default IP access
control group for your directory.

# Arguments
- `group_name`: The name of the group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"GroupDesc"`: The description of the group.
- `"Tags"`: The tags. Each WorkSpaces resource can have a maximum of 50 tags.
- `"UserRules"`: The rules to add to the group.
"""
function create_ip_group(GroupName; aws_config::AbstractAWSConfig=current_aws_config())
    return workspaces(
        "CreateIpGroup",
        Dict{String,Any}("GroupName" => GroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_ip_group(
    GroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "CreateIpGroup",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("GroupName" => GroupName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_standby_workspaces(primary_region, standby_workspaces)
    create_standby_workspaces(primary_region, standby_workspaces, params::Dict{String,<:Any})

Creates a standby WorkSpace in a secondary Region.

# Arguments
- `primary_region`: The Region of the primary WorkSpace.
- `standby_workspaces`: Information about the standby WorkSpace to be created.

"""
function create_standby_workspaces(
    PrimaryRegion, StandbyWorkspaces; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "CreateStandbyWorkspaces",
        Dict{String,Any}(
            "PrimaryRegion" => PrimaryRegion, "StandbyWorkspaces" => StandbyWorkspaces
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_standby_workspaces(
    PrimaryRegion,
    StandbyWorkspaces,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "CreateStandbyWorkspaces",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "PrimaryRegion" => PrimaryRegion,
                    "StandbyWorkspaces" => StandbyWorkspaces,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_tags(resource_id, tags)
    create_tags(resource_id, tags, params::Dict{String,<:Any})

Creates the specified tags for the specified WorkSpaces resource.

# Arguments
- `resource_id`: The identifier of the WorkSpaces resource. The supported resource types
  are WorkSpaces, registered directories, images, custom bundles, IP access control groups,
  and connection aliases.
- `tags`: The tags. Each WorkSpaces resource can have a maximum of 50 tags.

"""
function create_tags(ResourceId, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return workspaces(
        "CreateTags",
        Dict{String,Any}("ResourceId" => ResourceId, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_tags(
    ResourceId,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "CreateTags",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ResourceId" => ResourceId, "Tags" => Tags), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_updated_workspace_image(description, name, source_image_id)
    create_updated_workspace_image(description, name, source_image_id, params::Dict{String,<:Any})

Creates a new updated WorkSpace image based on the specified source image. The new updated
WorkSpace image has the latest drivers and other updates required by the Amazon WorkSpaces
components. To determine which WorkSpace images need to be updated with the latest Amazon
WorkSpaces requirements, use  DescribeWorkspaceImages.    Only Windows 10, Windows Server
2016, and Windows Server 2019 WorkSpace images can be programmatically updated at this
time.   Microsoft Windows updates and other application updates are not included in the
update process.   The source WorkSpace image is not deleted. You can delete the source
image after you've verified your new updated image and created a new bundle.

# Arguments
- `description`: A description of whether updates for the WorkSpace image are available.
- `name`: The name of the new updated WorkSpace image.
- `source_image_id`: The identifier of the source WorkSpace image.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: The tags that you want to add to the new updated WorkSpace image.  To add tags
  at the same time when you're creating the updated image, you must create an IAM policy that
  grants your IAM user permissions to use workspaces:CreateTags.
"""
function create_updated_workspace_image(
    Description, Name, SourceImageId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "CreateUpdatedWorkspaceImage",
        Dict{String,Any}(
            "Description" => Description, "Name" => Name, "SourceImageId" => SourceImageId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_updated_workspace_image(
    Description,
    Name,
    SourceImageId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "CreateUpdatedWorkspaceImage",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Description" => Description,
                    "Name" => Name,
                    "SourceImageId" => SourceImageId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_workspace_bundle(bundle_description, bundle_name, compute_type, image_id, user_storage)
    create_workspace_bundle(bundle_description, bundle_name, compute_type, image_id, user_storage, params::Dict{String,<:Any})

Creates the specified WorkSpace bundle. For more information about creating WorkSpace
bundles, see  Create a Custom WorkSpaces Image and Bundle.

# Arguments
- `bundle_description`: The description of the bundle.
- `bundle_name`: The name of the bundle.
- `compute_type`:
- `image_id`: The identifier of the image that is used to create the bundle.
- `user_storage`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"RootStorage"`:
- `"Tags"`: The tags associated with the bundle.  To add tags at the same time when you're
  creating the bundle, you must create an IAM policy that grants your IAM user permissions to
  use workspaces:CreateTags.
"""
function create_workspace_bundle(
    BundleDescription,
    BundleName,
    ComputeType,
    ImageId,
    UserStorage;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "CreateWorkspaceBundle",
        Dict{String,Any}(
            "BundleDescription" => BundleDescription,
            "BundleName" => BundleName,
            "ComputeType" => ComputeType,
            "ImageId" => ImageId,
            "UserStorage" => UserStorage,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_workspace_bundle(
    BundleDescription,
    BundleName,
    ComputeType,
    ImageId,
    UserStorage,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "CreateWorkspaceBundle",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "BundleDescription" => BundleDescription,
                    "BundleName" => BundleName,
                    "ComputeType" => ComputeType,
                    "ImageId" => ImageId,
                    "UserStorage" => UserStorage,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_workspace_image(description, name, workspace_id)
    create_workspace_image(description, name, workspace_id, params::Dict{String,<:Any})

Creates a new WorkSpace image from an existing WorkSpace.

# Arguments
- `description`: The description of the new WorkSpace image.
- `name`: The name of the new WorkSpace image.
- `workspace_id`: The identifier of the source WorkSpace

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: The tags that you want to add to the new WorkSpace image. To add tags when
  you're creating the image, you must create an IAM policy that grants your IAM user
  permission to use workspaces:CreateTags.
"""
function create_workspace_image(
    Description, Name, WorkspaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "CreateWorkspaceImage",
        Dict{String,Any}(
            "Description" => Description, "Name" => Name, "WorkspaceId" => WorkspaceId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_workspace_image(
    Description,
    Name,
    WorkspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "CreateWorkspaceImage",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Description" => Description,
                    "Name" => Name,
                    "WorkspaceId" => WorkspaceId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_workspaces(workspaces)
    create_workspaces(workspaces, params::Dict{String,<:Any})

Creates one or more WorkSpaces. This operation is asynchronous and returns before the
WorkSpaces are created.    The MANUAL running mode value is only supported by Amazon
WorkSpaces Core. Contact your account team to be allow-listed to use this value. For more
information, see Amazon WorkSpaces Core.   You don't need to specify the PCOIP protocol for
Linux bundles because WSP is the default protocol for those bundles.   User-decoupled
WorkSpaces are only supported by Amazon WorkSpaces Core.

# Arguments
- `workspaces`: The WorkSpaces to create. You can specify up to 25 WorkSpaces.

"""
function create_workspaces(Workspaces; aws_config::AbstractAWSConfig=current_aws_config())
    return workspaces(
        "CreateWorkspaces",
        Dict{String,Any}("Workspaces" => Workspaces);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_workspaces(
    Workspaces,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "CreateWorkspaces",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Workspaces" => Workspaces), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_account_link_invitation(link_id)
    delete_account_link_invitation(link_id, params::Dict{String,<:Any})

Deletes the account link invitation.

# Arguments
- `link_id`: The identifier of the account link.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: A string of up to 64 ASCII characters that Amazon EFS uses to ensure
  idempotent creation.
"""
function delete_account_link_invitation(
    LinkId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "DeleteAccountLinkInvitation",
        Dict{String,Any}("LinkId" => LinkId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_account_link_invitation(
    LinkId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "DeleteAccountLinkInvitation",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("LinkId" => LinkId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_client_branding(platforms, resource_id)
    delete_client_branding(platforms, resource_id, params::Dict{String,<:Any})

Deletes customized client branding. Client branding allows you to customize your
WorkSpace's client login portal. You can tailor your login portal company logo, the support
email address, support link, link to reset password, and a custom message for users trying
to sign in. After you delete your customized client branding, your login portal reverts to
the default client branding.

# Arguments
- `platforms`: The device type for which you want to delete client branding.
- `resource_id`: The directory identifier of the WorkSpace for which you want to delete
  client branding.

"""
function delete_client_branding(
    Platforms, ResourceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "DeleteClientBranding",
        Dict{String,Any}("Platforms" => Platforms, "ResourceId" => ResourceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_client_branding(
    Platforms,
    ResourceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "DeleteClientBranding",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Platforms" => Platforms, "ResourceId" => ResourceId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_connect_client_add_in(add_in_id, resource_id)
    delete_connect_client_add_in(add_in_id, resource_id, params::Dict{String,<:Any})

Deletes a client-add-in for Amazon Connect that is configured within a directory.

# Arguments
- `add_in_id`: The identifier of the client add-in to delete.
- `resource_id`: The directory identifier for which the client add-in is configured.

"""
function delete_connect_client_add_in(
    AddInId, ResourceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "DeleteConnectClientAddIn",
        Dict{String,Any}("AddInId" => AddInId, "ResourceId" => ResourceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_connect_client_add_in(
    AddInId,
    ResourceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "DeleteConnectClientAddIn",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("AddInId" => AddInId, "ResourceId" => ResourceId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_connection_alias(alias_id)
    delete_connection_alias(alias_id, params::Dict{String,<:Any})

Deletes the specified connection alias. For more information, see  Cross-Region Redirection
for Amazon WorkSpaces.   If you will no longer be using a fully qualified domain name
(FQDN) as the registration code for your WorkSpaces users, you must take certain
precautions to prevent potential security issues. For more information, see  Security
Considerations if You Stop Using Cross-Region Redirection.   To delete a connection alias
that has been shared, the shared account must first disassociate the connection alias from
any directories it has been associated with. Then you must unshare the connection alias
from the account it has been shared with. You can delete a connection alias only after it
is no longer shared with any accounts or associated with any directories.

# Arguments
- `alias_id`: The identifier of the connection alias to delete.

"""
function delete_connection_alias(
    AliasId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "DeleteConnectionAlias",
        Dict{String,Any}("AliasId" => AliasId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_connection_alias(
    AliasId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "DeleteConnectionAlias",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("AliasId" => AliasId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_ip_group(group_id)
    delete_ip_group(group_id, params::Dict{String,<:Any})

Deletes the specified IP access control group. You cannot delete an IP access control group
that is associated with a directory.

# Arguments
- `group_id`: The identifier of the IP access control group.

"""
function delete_ip_group(GroupId; aws_config::AbstractAWSConfig=current_aws_config())
    return workspaces(
        "DeleteIpGroup",
        Dict{String,Any}("GroupId" => GroupId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_ip_group(
    GroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "DeleteIpGroup",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("GroupId" => GroupId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_tags(resource_id, tag_keys)
    delete_tags(resource_id, tag_keys, params::Dict{String,<:Any})

Deletes the specified tags from the specified WorkSpaces resource.

# Arguments
- `resource_id`: The identifier of the WorkSpaces resource. The supported resource types
  are WorkSpaces, registered directories, images, custom bundles, IP access control groups,
  and connection aliases.
- `tag_keys`: The tag keys.

"""
function delete_tags(
    ResourceId, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "DeleteTags",
        Dict{String,Any}("ResourceId" => ResourceId, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_tags(
    ResourceId,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "DeleteTags",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceId" => ResourceId, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_workspace_bundle()
    delete_workspace_bundle(params::Dict{String,<:Any})

Deletes the specified WorkSpace bundle. For more information about deleting WorkSpace
bundles, see  Delete a Custom WorkSpaces Bundle or Image.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"BundleId"`: The identifier of the bundle.
"""
function delete_workspace_bundle(; aws_config::AbstractAWSConfig=current_aws_config())
    return workspaces(
        "DeleteWorkspaceBundle"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function delete_workspace_bundle(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "DeleteWorkspaceBundle",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_workspace_image(image_id)
    delete_workspace_image(image_id, params::Dict{String,<:Any})

Deletes the specified image from your account. To delete an image, you must first delete
any bundles that are associated with the image and unshare the image if it is shared with
other accounts.

# Arguments
- `image_id`: The identifier of the image.

"""
function delete_workspace_image(ImageId; aws_config::AbstractAWSConfig=current_aws_config())
    return workspaces(
        "DeleteWorkspaceImage",
        Dict{String,Any}("ImageId" => ImageId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_workspace_image(
    ImageId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "DeleteWorkspaceImage",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("ImageId" => ImageId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    deploy_workspace_applications(workspace_id)
    deploy_workspace_applications(workspace_id, params::Dict{String,<:Any})

Deploys associated applications to the specified WorkSpace

# Arguments
- `workspace_id`: The identifier of the WorkSpace.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Force"`: Indicates whether the force flag is applied for the specified WorkSpace. When
  the force flag is enabled, it allows previously failed deployments to be retried.
"""
function deploy_workspace_applications(
    WorkspaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "DeployWorkspaceApplications",
        Dict{String,Any}("WorkspaceId" => WorkspaceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function deploy_workspace_applications(
    WorkspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "DeployWorkspaceApplications",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("WorkspaceId" => WorkspaceId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    deregister_workspace_directory(directory_id)
    deregister_workspace_directory(directory_id, params::Dict{String,<:Any})

Deregisters the specified directory. This operation is asynchronous and returns before the
WorkSpace directory is deregistered. If any WorkSpaces are registered to this directory,
you must remove them before you can deregister the directory.  Simple AD and AD Connector
are made available to you free of charge to use with WorkSpaces. If there are no WorkSpaces
being used with your Simple AD or AD Connector directory for 30 consecutive days, this
directory will be automatically deregistered for use with Amazon WorkSpaces, and you will
be charged for this directory as per the Directory Service pricing terms. To delete empty
directories, see  Delete the Directory for Your WorkSpaces. If you delete your Simple AD or
AD Connector directory, you can always create a new one when you want to start using
WorkSpaces again.

# Arguments
- `directory_id`: The identifier of the directory. If any WorkSpaces are registered to this
  directory, you must remove them before you deregister the directory, or you will receive an
  OperationNotSupportedException error.

"""
function deregister_workspace_directory(
    DirectoryId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "DeregisterWorkspaceDirectory",
        Dict{String,Any}("DirectoryId" => DirectoryId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function deregister_workspace_directory(
    DirectoryId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "DeregisterWorkspaceDirectory",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DirectoryId" => DirectoryId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_account()
    describe_account(params::Dict{String,<:Any})

Retrieves a list that describes the configuration of Bring Your Own License (BYOL) for the
specified account.

"""
function describe_account(; aws_config::AbstractAWSConfig=current_aws_config())
    return workspaces(
        "DescribeAccount"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_account(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "DescribeAccount", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_account_modifications()
    describe_account_modifications(params::Dict{String,<:Any})

Retrieves a list that describes modifications to the configuration of Bring Your Own
License (BYOL) for the specified account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: If you received a NextToken from a previous call that was paginated,
  provide this token to receive the next set of results.
"""
function describe_account_modifications(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "DescribeAccountModifications";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_account_modifications(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "DescribeAccountModifications",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_application_associations(application_id, associated_resource_types)
    describe_application_associations(application_id, associated_resource_types, params::Dict{String,<:Any})

Describes the associations between the application and the specified associated resources.

# Arguments
- `application_id`: The identifier of the specified application.
- `associated_resource_types`: The resource type of the associated resources.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of associations to return.
- `"NextToken"`: If you received a NextToken from a previous call that was paginated,
  provide this token to receive the next set of results.
"""
function describe_application_associations(
    ApplicationId,
    AssociatedResourceTypes;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "DescribeApplicationAssociations",
        Dict{String,Any}(
            "ApplicationId" => ApplicationId,
            "AssociatedResourceTypes" => AssociatedResourceTypes,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_application_associations(
    ApplicationId,
    AssociatedResourceTypes,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "DescribeApplicationAssociations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationId" => ApplicationId,
                    "AssociatedResourceTypes" => AssociatedResourceTypes,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_applications()
    describe_applications(params::Dict{String,<:Any})

Describes the specified applications by filtering based on their compute types, license
availability, operating systems, and owners.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ApplicationIds"`: The identifiers of one or more applications.
- `"ComputeTypeNames"`: The compute types supported by the applications.
- `"LicenseType"`: The license availability for the applications.
- `"MaxResults"`: The maximum number of applications to return.
- `"NextToken"`: If you received a NextToken from a previous call that was paginated,
  provide this token to receive the next set of results.
- `"OperatingSystemNames"`: The operating systems supported by the applications.
- `"Owner"`: The owner of the applications.
"""
function describe_applications(; aws_config::AbstractAWSConfig=current_aws_config())
    return workspaces(
        "DescribeApplications"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_applications(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "DescribeApplications",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_bundle_associations(associated_resource_types, bundle_id)
    describe_bundle_associations(associated_resource_types, bundle_id, params::Dict{String,<:Any})

Describes the associations between the applications and the specified bundle.

# Arguments
- `associated_resource_types`: The resource types of the associated resource.
- `bundle_id`: The identifier of the bundle.

"""
function describe_bundle_associations(
    AssociatedResourceTypes, BundleId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "DescribeBundleAssociations",
        Dict{String,Any}(
            "AssociatedResourceTypes" => AssociatedResourceTypes, "BundleId" => BundleId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_bundle_associations(
    AssociatedResourceTypes,
    BundleId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "DescribeBundleAssociations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AssociatedResourceTypes" => AssociatedResourceTypes,
                    "BundleId" => BundleId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_client_branding(resource_id)
    describe_client_branding(resource_id, params::Dict{String,<:Any})

Describes the specified client branding. Client branding allows you to customize the log in
page of various device types for your users. You can add your company logo, the support
email address, support link, link to reset password, and a custom message for users trying
to sign in.  Only device types that have branding information configured will be shown in
the response.

# Arguments
- `resource_id`: The directory identifier of the WorkSpace for which you want to view
  client branding information.

"""
function describe_client_branding(
    ResourceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "DescribeClientBranding",
        Dict{String,Any}("ResourceId" => ResourceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_client_branding(
    ResourceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "DescribeClientBranding",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceId" => ResourceId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_client_properties(resource_ids)
    describe_client_properties(resource_ids, params::Dict{String,<:Any})

Retrieves a list that describes one or more specified Amazon WorkSpaces clients.

# Arguments
- `resource_ids`: The resource identifier, in the form of directory IDs.

"""
function describe_client_properties(
    ResourceIds; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "DescribeClientProperties",
        Dict{String,Any}("ResourceIds" => ResourceIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_client_properties(
    ResourceIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "DescribeClientProperties",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceIds" => ResourceIds), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_connect_client_add_ins(resource_id)
    describe_connect_client_add_ins(resource_id, params::Dict{String,<:Any})

Retrieves a list of Amazon Connect client add-ins that have been created.

# Arguments
- `resource_id`: The directory identifier for which the client add-in is configured.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of items to return.
- `"NextToken"`: If you received a NextToken from a previous call that was paginated,
  provide this token to receive the next set of results.
"""
function describe_connect_client_add_ins(
    ResourceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "DescribeConnectClientAddIns",
        Dict{String,Any}("ResourceId" => ResourceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_connect_client_add_ins(
    ResourceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "DescribeConnectClientAddIns",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceId" => ResourceId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_connection_alias_permissions(alias_id)
    describe_connection_alias_permissions(alias_id, params::Dict{String,<:Any})

Describes the permissions that the owner of a connection alias has granted to another
Amazon Web Services account for the specified connection alias. For more information, see
Cross-Region Redirection for Amazon WorkSpaces.

# Arguments
- `alias_id`: The identifier of the connection alias.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to return.
- `"NextToken"`: If you received a NextToken from a previous call that was paginated,
  provide this token to receive the next set of results.
"""
function describe_connection_alias_permissions(
    AliasId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "DescribeConnectionAliasPermissions",
        Dict{String,Any}("AliasId" => AliasId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_connection_alias_permissions(
    AliasId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "DescribeConnectionAliasPermissions",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("AliasId" => AliasId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_connection_aliases()
    describe_connection_aliases(params::Dict{String,<:Any})

Retrieves a list that describes the connection aliases used for cross-Region redirection.
For more information, see  Cross-Region Redirection for Amazon WorkSpaces.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AliasIds"`: The identifiers of the connection aliases to describe.
- `"Limit"`: The maximum number of connection aliases to return.
- `"NextToken"`: If you received a NextToken from a previous call that was paginated,
  provide this token to receive the next set of results.
- `"ResourceId"`: The identifier of the directory associated with the connection alias.
"""
function describe_connection_aliases(; aws_config::AbstractAWSConfig=current_aws_config())
    return workspaces(
        "DescribeConnectionAliases"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_connection_aliases(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "DescribeConnectionAliases",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_image_associations(associated_resource_types, image_id)
    describe_image_associations(associated_resource_types, image_id, params::Dict{String,<:Any})

Describes the associations between the applications and the specified image.

# Arguments
- `associated_resource_types`: The resource types of the associated resource.
- `image_id`: The identifier of the image.

"""
function describe_image_associations(
    AssociatedResourceTypes, ImageId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "DescribeImageAssociations",
        Dict{String,Any}(
            "AssociatedResourceTypes" => AssociatedResourceTypes, "ImageId" => ImageId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_image_associations(
    AssociatedResourceTypes,
    ImageId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "DescribeImageAssociations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AssociatedResourceTypes" => AssociatedResourceTypes,
                    "ImageId" => ImageId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_ip_groups()
    describe_ip_groups(params::Dict{String,<:Any})

Describes one or more of your IP access control groups.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"GroupIds"`: The identifiers of one or more IP access control groups.
- `"MaxResults"`: The maximum number of items to return.
- `"NextToken"`: If you received a NextToken from a previous call that was paginated,
  provide this token to receive the next set of results.
"""
function describe_ip_groups(; aws_config::AbstractAWSConfig=current_aws_config())
    return workspaces(
        "DescribeIpGroups"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_ip_groups(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "DescribeIpGroups", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_tags(resource_id)
    describe_tags(resource_id, params::Dict{String,<:Any})

Describes the specified tags for the specified WorkSpaces resource.

# Arguments
- `resource_id`: The identifier of the WorkSpaces resource. The supported resource types
  are WorkSpaces, registered directories, images, custom bundles, IP access control groups,
  and connection aliases.

"""
function describe_tags(ResourceId; aws_config::AbstractAWSConfig=current_aws_config())
    return workspaces(
        "DescribeTags",
        Dict{String,Any}("ResourceId" => ResourceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_tags(
    ResourceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "DescribeTags",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceId" => ResourceId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_workspace_associations(associated_resource_types, workspace_id)
    describe_workspace_associations(associated_resource_types, workspace_id, params::Dict{String,<:Any})

Describes the associations betweens applications and the specified WorkSpace.

# Arguments
- `associated_resource_types`: The resource types of the associated resources.
- `workspace_id`: The identifier of the WorkSpace.

"""
function describe_workspace_associations(
    AssociatedResourceTypes, WorkspaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "DescribeWorkspaceAssociations",
        Dict{String,Any}(
            "AssociatedResourceTypes" => AssociatedResourceTypes,
            "WorkspaceId" => WorkspaceId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_workspace_associations(
    AssociatedResourceTypes,
    WorkspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "DescribeWorkspaceAssociations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AssociatedResourceTypes" => AssociatedResourceTypes,
                    "WorkspaceId" => WorkspaceId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_workspace_bundles()
    describe_workspace_bundles(params::Dict{String,<:Any})

Retrieves a list that describes the available WorkSpace bundles. You can filter the results
using either bundle ID or owner, but not both.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"BundleIds"`: The identifiers of the bundles. You cannot combine this parameter with any
  other filter.
- `"NextToken"`: The token for the next set of results. (You received this token from a
  previous call.)
- `"Owner"`: The owner of the bundles. You cannot combine this parameter with any other
  filter. To describe the bundles provided by Amazon Web Services, specify AMAZON. To
  describe the bundles that belong to your account, don't specify a value.
"""
function describe_workspace_bundles(; aws_config::AbstractAWSConfig=current_aws_config())
    return workspaces(
        "DescribeWorkspaceBundles"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_workspace_bundles(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "DescribeWorkspaceBundles",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_workspace_directories()
    describe_workspace_directories(params::Dict{String,<:Any})

Describes the available directories that are registered with Amazon WorkSpaces.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DirectoryIds"`: The identifiers of the directories. If the value is null, all
  directories are retrieved.
- `"Limit"`: The maximum number of directories to return.
- `"NextToken"`: If you received a NextToken from a previous call that was paginated,
  provide this token to receive the next set of results.
"""
function describe_workspace_directories(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "DescribeWorkspaceDirectories";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_workspace_directories(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "DescribeWorkspaceDirectories",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_workspace_image_permissions(image_id)
    describe_workspace_image_permissions(image_id, params::Dict{String,<:Any})

Describes the permissions that the owner of an image has granted to other Amazon Web
Services accounts for an image.

# Arguments
- `image_id`: The identifier of the image.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of items to return.
- `"NextToken"`: If you received a NextToken from a previous call that was paginated,
  provide this token to receive the next set of results.
"""
function describe_workspace_image_permissions(
    ImageId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "DescribeWorkspaceImagePermissions",
        Dict{String,Any}("ImageId" => ImageId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_workspace_image_permissions(
    ImageId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "DescribeWorkspaceImagePermissions",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("ImageId" => ImageId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_workspace_images()
    describe_workspace_images(params::Dict{String,<:Any})

Retrieves a list that describes one or more specified images, if the image identifiers are
provided. Otherwise, all images in the account are described.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ImageIds"`: The identifier of the image.
- `"ImageType"`: The type (owned or shared) of the image.
- `"MaxResults"`: The maximum number of items to return.
- `"NextToken"`: If you received a NextToken from a previous call that was paginated,
  provide this token to receive the next set of results.
"""
function describe_workspace_images(; aws_config::AbstractAWSConfig=current_aws_config())
    return workspaces(
        "DescribeWorkspaceImages"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_workspace_images(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "DescribeWorkspaceImages",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_workspace_snapshots(workspace_id)
    describe_workspace_snapshots(workspace_id, params::Dict{String,<:Any})

Describes the snapshots for the specified WorkSpace.

# Arguments
- `workspace_id`: The identifier of the WorkSpace.

"""
function describe_workspace_snapshots(
    WorkspaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "DescribeWorkspaceSnapshots",
        Dict{String,Any}("WorkspaceId" => WorkspaceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_workspace_snapshots(
    WorkspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "DescribeWorkspaceSnapshots",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("WorkspaceId" => WorkspaceId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_workspaces()
    describe_workspaces(params::Dict{String,<:Any})

Describes the specified WorkSpaces. You can filter the results by using the bundle
identifier, directory identifier, or owner, but you can specify only one filter at a time.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"BundleId"`: The identifier of the bundle. All WorkSpaces that are created from this
  bundle are retrieved. You cannot combine this parameter with any other filter.
- `"DirectoryId"`: The identifier of the directory. In addition, you can optionally specify
  a specific directory user (see UserName). You cannot combine this parameter with any other
  filter.
- `"Limit"`: The maximum number of items to return.
- `"NextToken"`: If you received a NextToken from a previous call that was paginated,
  provide this token to receive the next set of results.
- `"UserName"`: The name of the directory user. You must specify this parameter with
  DirectoryId.
- `"WorkspaceIds"`: The identifiers of the WorkSpaces. You cannot combine this parameter
  with any other filter. Because the CreateWorkspaces operation is asynchronous, the
  identifier it returns is not immediately available. If you immediately call
  DescribeWorkspaces with this identifier, no information is returned.
- `"WorkspaceName"`: The name of the user-decoupled WorkSpace.
"""
function describe_workspaces(; aws_config::AbstractAWSConfig=current_aws_config())
    return workspaces(
        "DescribeWorkspaces"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_workspaces(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "DescribeWorkspaces", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_workspaces_connection_status()
    describe_workspaces_connection_status(params::Dict{String,<:Any})

Describes the connection status of the specified WorkSpaces.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: If you received a NextToken from a previous call that was paginated,
  provide this token to receive the next set of results.
- `"WorkspaceIds"`: The identifiers of the WorkSpaces. You can specify up to 25 WorkSpaces.
"""
function describe_workspaces_connection_status(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "DescribeWorkspacesConnectionStatus";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_workspaces_connection_status(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "DescribeWorkspacesConnectionStatus",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_connection_alias(alias_id)
    disassociate_connection_alias(alias_id, params::Dict{String,<:Any})

Disassociates a connection alias from a directory. Disassociating a connection alias
disables cross-Region redirection between two directories in different Regions. For more
information, see  Cross-Region Redirection for Amazon WorkSpaces.  Before performing this
operation, call  DescribeConnectionAliases to make sure that the current state of the
connection alias is CREATED.

# Arguments
- `alias_id`: The identifier of the connection alias to disassociate.

"""
function disassociate_connection_alias(
    AliasId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "DisassociateConnectionAlias",
        Dict{String,Any}("AliasId" => AliasId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_connection_alias(
    AliasId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "DisassociateConnectionAlias",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("AliasId" => AliasId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_ip_groups(directory_id, group_ids)
    disassociate_ip_groups(directory_id, group_ids, params::Dict{String,<:Any})

Disassociates the specified IP access control group from the specified directory.

# Arguments
- `directory_id`: The identifier of the directory.
- `group_ids`: The identifiers of one or more IP access control groups.

"""
function disassociate_ip_groups(
    DirectoryId, GroupIds; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "DisassociateIpGroups",
        Dict{String,Any}("DirectoryId" => DirectoryId, "GroupIds" => GroupIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_ip_groups(
    DirectoryId,
    GroupIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "DisassociateIpGroups",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DirectoryId" => DirectoryId, "GroupIds" => GroupIds),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_workspace_application(application_id, workspace_id)
    disassociate_workspace_application(application_id, workspace_id, params::Dict{String,<:Any})

Disassociates the specified application from a WorkSpace.

# Arguments
- `application_id`: The identifier of the application.
- `workspace_id`: The identifier of the WorkSpace.

"""
function disassociate_workspace_application(
    ApplicationId, WorkspaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "DisassociateWorkspaceApplication",
        Dict{String,Any}("ApplicationId" => ApplicationId, "WorkspaceId" => WorkspaceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_workspace_application(
    ApplicationId,
    WorkspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "DisassociateWorkspaceApplication",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationId" => ApplicationId, "WorkspaceId" => WorkspaceId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_account_link()
    get_account_link(params::Dict{String,<:Any})

Retrieves account link information.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"LinkId"`: The identifier of the account to link.
- `"LinkedAccountId"`: The identifier of the account link
"""
function get_account_link(; aws_config::AbstractAWSConfig=current_aws_config())
    return workspaces(
        "GetAccountLink"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_account_link(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "GetAccountLink", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    import_client_branding(resource_id)
    import_client_branding(resource_id, params::Dict{String,<:Any})

Imports client branding. Client branding allows you to customize your WorkSpace's client
login portal. You can tailor your login portal company logo, the support email address,
support link, link to reset password, and a custom message for users trying to sign in.
After you import client branding, the default branding experience for the specified
platform type is replaced with the imported experience    You must specify at least one
platform type when importing client branding.   You can import up to 6 MB of data with each
request. If your request exceeds this limit, you can import client branding for different
platform types using separate requests.   In each platform type, the SupportEmail and
SupportLink parameters are mutually exclusive. You can specify only one parameter for each
platform type, but not both.   Imported data can take up to a minute to appear in the
WorkSpaces client.

# Arguments
- `resource_id`: The directory identifier of the WorkSpace for which you want to import
  client branding.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DeviceTypeAndroid"`: The branding information to import for Android devices.
- `"DeviceTypeIos"`: The branding information to import for iOS devices.
- `"DeviceTypeLinux"`: The branding information to import for Linux devices.
- `"DeviceTypeOsx"`: The branding information to import for macOS devices.
- `"DeviceTypeWeb"`: The branding information to import for web access.
- `"DeviceTypeWindows"`: The branding information to import for Windows devices.
"""
function import_client_branding(
    ResourceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "ImportClientBranding",
        Dict{String,Any}("ResourceId" => ResourceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function import_client_branding(
    ResourceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "ImportClientBranding",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceId" => ResourceId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    import_workspace_image(ec2_image_id, image_description, image_name, ingestion_process)
    import_workspace_image(ec2_image_id, image_description, image_name, ingestion_process, params::Dict{String,<:Any})

Imports the specified Windows 10 or 11 Bring Your Own License (BYOL) image into Amazon
WorkSpaces. The image must be an already licensed Amazon EC2 image that is in your Amazon
Web Services account, and you must own the image. For more information about creating BYOL
images, see  Bring Your Own Windows Desktop Licenses.

# Arguments
- `ec2_image_id`: The identifier of the EC2 image.
- `image_description`: The description of the WorkSpace image.
- `image_name`: The name of the WorkSpace image.
- `ingestion_process`: The ingestion process to be used when importing the image, depending
  on which protocol you want to use for your BYOL Workspace image, either PCoIP, WorkSpaces
  Streaming Protocol (WSP), or bring your own protocol (BYOP). To use WSP, specify a value
  that ends in _WSP. To use PCoIP, specify a value that does not end in _WSP. To use BYOP,
  specify a value that ends in _BYOP. For non-GPU-enabled bundles (bundles other than
  Graphics or GraphicsPro), specify BYOL_REGULAR, BYOL_REGULAR_WSP, or BYOL_REGULAR_BYOP,
  depending on the protocol.  The BYOL_REGULAR_BYOP and BYOL_GRAPHICS_G4DN_BYOP values are
  only supported by Amazon WorkSpaces Core. Contact your account team to be allow-listed to
  use these values. For more information, see Amazon WorkSpaces Core.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Applications"`: If specified, the version of Microsoft Office to subscribe to. Valid
  only for Windows 10 and 11 BYOL images. For more information about subscribing to Office
  for BYOL images, see  Bring Your Own Windows Desktop Licenses.    Although this parameter
  is an array, only one item is allowed at this time.   Windows 11 only supports
  Microsoft_Office_2019.
- `"Tags"`: The tags. Each WorkSpaces resource can have a maximum of 50 tags.
"""
function import_workspace_image(
    Ec2ImageId,
    ImageDescription,
    ImageName,
    IngestionProcess;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "ImportWorkspaceImage",
        Dict{String,Any}(
            "Ec2ImageId" => Ec2ImageId,
            "ImageDescription" => ImageDescription,
            "ImageName" => ImageName,
            "IngestionProcess" => IngestionProcess,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function import_workspace_image(
    Ec2ImageId,
    ImageDescription,
    ImageName,
    IngestionProcess,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "ImportWorkspaceImage",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Ec2ImageId" => Ec2ImageId,
                    "ImageDescription" => ImageDescription,
                    "ImageName" => ImageName,
                    "IngestionProcess" => IngestionProcess,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_account_links()
    list_account_links(params::Dict{String,<:Any})

Lists all account links.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"LinkStatusFilter"`: Filters the account based on their link status.
- `"MaxResults"`: The maximum number of accounts to return.
- `"NextToken"`: The token to use to retrieve the next page of results. This value is null
  when there are no more results to return.
"""
function list_account_links(; aws_config::AbstractAWSConfig=current_aws_config())
    return workspaces(
        "ListAccountLinks"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_account_links(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "ListAccountLinks", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_available_management_cidr_ranges(management_cidr_range_constraint)
    list_available_management_cidr_ranges(management_cidr_range_constraint, params::Dict{String,<:Any})

Retrieves a list of IP address ranges, specified as IPv4 CIDR blocks, that you can use for
the network management interface when you enable Bring Your Own License (BYOL).  This
operation can be run only by Amazon Web Services accounts that are enabled for BYOL. If
your account isn't enabled for BYOL, you'll receive an AccessDeniedException error. The
management network interface is connected to a secure Amazon WorkSpaces management network.
It is used for interactive streaming of the WorkSpace desktop to Amazon WorkSpaces clients,
and to allow Amazon WorkSpaces to manage the WorkSpace.

# Arguments
- `management_cidr_range_constraint`: The IP address range to search. Specify an IP address
  range that is compatible with your network and in CIDR notation (that is, specify the range
  as an IPv4 CIDR block).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of items to return.
- `"NextToken"`: If you received a NextToken from a previous call that was paginated,
  provide this token to receive the next set of results.
"""
function list_available_management_cidr_ranges(
    ManagementCidrRangeConstraint; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "ListAvailableManagementCidrRanges",
        Dict{String,Any}("ManagementCidrRangeConstraint" => ManagementCidrRangeConstraint);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_available_management_cidr_ranges(
    ManagementCidrRangeConstraint,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "ListAvailableManagementCidrRanges",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ManagementCidrRangeConstraint" => ManagementCidrRangeConstraint
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    migrate_workspace(bundle_id, source_workspace_id)
    migrate_workspace(bundle_id, source_workspace_id, params::Dict{String,<:Any})

Migrates a WorkSpace from one operating system or bundle type to another, while retaining
the data on the user volume. The migration process recreates the WorkSpace by using a new
root volume from the target bundle image and the user volume from the last available
snapshot of the original WorkSpace. During migration, the original D:Users%USERNAME% user
profile folder is renamed to D:Users%USERNAME%MMddyyTHHmmss%.NotMigrated. A new
D:Users%USERNAME% folder is generated by the new OS. Certain files in the old user profile
are moved to the new user profile. For available migration scenarios, details about what
happens during migration, and best practices, see Migrate a WorkSpace.

# Arguments
- `bundle_id`: The identifier of the target bundle type to migrate the WorkSpace to.
- `source_workspace_id`: The identifier of the WorkSpace to migrate from.

"""
function migrate_workspace(
    BundleId, SourceWorkspaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "MigrateWorkspace",
        Dict{String,Any}("BundleId" => BundleId, "SourceWorkspaceId" => SourceWorkspaceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function migrate_workspace(
    BundleId,
    SourceWorkspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "MigrateWorkspace",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "BundleId" => BundleId, "SourceWorkspaceId" => SourceWorkspaceId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    modify_account()
    modify_account(params::Dict{String,<:Any})

Modifies the configuration of Bring Your Own License (BYOL) for the specified account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DedicatedTenancyManagementCidrRange"`: The IP address range, specified as an IPv4 CIDR
  block, for the management network interface. Specify an IP address range that is compatible
  with your network and in CIDR notation (that is, specify the range as an IPv4 CIDR block).
  The CIDR block size must be /16 (for example, 203.0.113.25/16). It must also be specified
  as available by the ListAvailableManagementCidrRanges operation.
- `"DedicatedTenancySupport"`: The status of BYOL.
"""
function modify_account(; aws_config::AbstractAWSConfig=current_aws_config())
    return workspaces(
        "ModifyAccount"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function modify_account(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "ModifyAccount", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    modify_certificate_based_auth_properties(resource_id)
    modify_certificate_based_auth_properties(resource_id, params::Dict{String,<:Any})

Modifies the properties of the certificate-based authentication you want to use with your
WorkSpaces.

# Arguments
- `resource_id`: The resource identifiers, in the form of directory IDs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CertificateBasedAuthProperties"`: The properties of the certificate-based
  authentication.
- `"PropertiesToDelete"`: The properties of the certificate-based authentication you want
  to delete.
"""
function modify_certificate_based_auth_properties(
    ResourceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "ModifyCertificateBasedAuthProperties",
        Dict{String,Any}("ResourceId" => ResourceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function modify_certificate_based_auth_properties(
    ResourceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "ModifyCertificateBasedAuthProperties",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceId" => ResourceId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    modify_client_properties(client_properties, resource_id)
    modify_client_properties(client_properties, resource_id, params::Dict{String,<:Any})

Modifies the properties of the specified Amazon WorkSpaces clients.

# Arguments
- `client_properties`: Information about the Amazon WorkSpaces client.
- `resource_id`: The resource identifiers, in the form of directory IDs.

"""
function modify_client_properties(
    ClientProperties, ResourceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "ModifyClientProperties",
        Dict{String,Any}(
            "ClientProperties" => ClientProperties, "ResourceId" => ResourceId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function modify_client_properties(
    ClientProperties,
    ResourceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "ModifyClientProperties",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClientProperties" => ClientProperties, "ResourceId" => ResourceId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    modify_saml_properties(resource_id)
    modify_saml_properties(resource_id, params::Dict{String,<:Any})

Modifies multiple properties related to SAML 2.0 authentication, including the enablement
status, user access URL, and relay state parameter name that are used for configuring
federation with an SAML 2.0 identity provider.

# Arguments
- `resource_id`: The directory identifier for which you want to configure SAML properties.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"PropertiesToDelete"`: The SAML properties to delete as part of your request. Specify
  one of the following options:    SAML_PROPERTIES_USER_ACCESS_URL to delete the user access
  URL.    SAML_PROPERTIES_RELAY_STATE_PARAMETER_NAME to delete the relay state parameter
  name.
- `"SamlProperties"`: The properties for configuring SAML 2.0 authentication.
"""
function modify_saml_properties(
    ResourceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "ModifySamlProperties",
        Dict{String,Any}("ResourceId" => ResourceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function modify_saml_properties(
    ResourceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "ModifySamlProperties",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceId" => ResourceId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    modify_selfservice_permissions(resource_id, selfservice_permissions)
    modify_selfservice_permissions(resource_id, selfservice_permissions, params::Dict{String,<:Any})

Modifies the self-service WorkSpace management capabilities for your users. For more
information, see Enable Self-Service WorkSpace Management Capabilities for Your Users.

# Arguments
- `resource_id`: The identifier of the directory.
- `selfservice_permissions`: The permissions to enable or disable self-service capabilities.

"""
function modify_selfservice_permissions(
    ResourceId, SelfservicePermissions; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "ModifySelfservicePermissions",
        Dict{String,Any}(
            "ResourceId" => ResourceId, "SelfservicePermissions" => SelfservicePermissions
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function modify_selfservice_permissions(
    ResourceId,
    SelfservicePermissions,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "ModifySelfservicePermissions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ResourceId" => ResourceId,
                    "SelfservicePermissions" => SelfservicePermissions,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    modify_workspace_access_properties(resource_id, workspace_access_properties)
    modify_workspace_access_properties(resource_id, workspace_access_properties, params::Dict{String,<:Any})

Specifies which devices and operating systems users can use to access their WorkSpaces. For
more information, see  Control Device Access.

# Arguments
- `resource_id`: The identifier of the directory.
- `workspace_access_properties`: The device types and operating systems to enable or
  disable for access.

"""
function modify_workspace_access_properties(
    ResourceId,
    WorkspaceAccessProperties;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "ModifyWorkspaceAccessProperties",
        Dict{String,Any}(
            "ResourceId" => ResourceId,
            "WorkspaceAccessProperties" => WorkspaceAccessProperties,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function modify_workspace_access_properties(
    ResourceId,
    WorkspaceAccessProperties,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "ModifyWorkspaceAccessProperties",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ResourceId" => ResourceId,
                    "WorkspaceAccessProperties" => WorkspaceAccessProperties,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    modify_workspace_creation_properties(resource_id, workspace_creation_properties)
    modify_workspace_creation_properties(resource_id, workspace_creation_properties, params::Dict{String,<:Any})

Modify the default properties used to create WorkSpaces.

# Arguments
- `resource_id`: The identifier of the directory.
- `workspace_creation_properties`: The default properties for creating WorkSpaces.

"""
function modify_workspace_creation_properties(
    ResourceId,
    WorkspaceCreationProperties;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "ModifyWorkspaceCreationProperties",
        Dict{String,Any}(
            "ResourceId" => ResourceId,
            "WorkspaceCreationProperties" => WorkspaceCreationProperties,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function modify_workspace_creation_properties(
    ResourceId,
    WorkspaceCreationProperties,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "ModifyWorkspaceCreationProperties",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ResourceId" => ResourceId,
                    "WorkspaceCreationProperties" => WorkspaceCreationProperties,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    modify_workspace_properties(workspace_id)
    modify_workspace_properties(workspace_id, params::Dict{String,<:Any})

Modifies the specified WorkSpace properties. For important information about how to modify
the size of the root and user volumes, see  Modify a WorkSpace.   The MANUAL running mode
value is only supported by Amazon WorkSpaces Core. Contact your account team to be
allow-listed to use this value. For more information, see Amazon WorkSpaces Core.

# Arguments
- `workspace_id`: The identifier of the WorkSpace.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DataReplication"`: Indicates the data replication status.
- `"WorkspaceProperties"`: The properties of the WorkSpace.
"""
function modify_workspace_properties(
    WorkspaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "ModifyWorkspaceProperties",
        Dict{String,Any}("WorkspaceId" => WorkspaceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function modify_workspace_properties(
    WorkspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "ModifyWorkspaceProperties",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("WorkspaceId" => WorkspaceId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    modify_workspace_state(workspace_id, workspace_state)
    modify_workspace_state(workspace_id, workspace_state, params::Dict{String,<:Any})

Sets the state of the specified WorkSpace. To maintain a WorkSpace without being
interrupted, set the WorkSpace state to ADMIN_MAINTENANCE. WorkSpaces in this state do not
respond to requests to reboot, stop, start, rebuild, or restore. An AutoStop WorkSpace in
this state is not stopped. Users cannot log into a WorkSpace in the ADMIN_MAINTENANCE state.

# Arguments
- `workspace_id`: The identifier of the WorkSpace.
- `workspace_state`: The WorkSpace state.

"""
function modify_workspace_state(
    WorkspaceId, WorkspaceState; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "ModifyWorkspaceState",
        Dict{String,Any}("WorkspaceId" => WorkspaceId, "WorkspaceState" => WorkspaceState);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function modify_workspace_state(
    WorkspaceId,
    WorkspaceState,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "ModifyWorkspaceState",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "WorkspaceId" => WorkspaceId, "WorkspaceState" => WorkspaceState
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    reboot_workspaces(reboot_workspace_requests)
    reboot_workspaces(reboot_workspace_requests, params::Dict{String,<:Any})

Reboots the specified WorkSpaces. You cannot reboot a WorkSpace unless its state is
AVAILABLE, UNHEALTHY, or REBOOTING. Reboot a WorkSpace in the REBOOTING state only if your
WorkSpace has been stuck in the REBOOTING state for over 20 minutes. This operation is
asynchronous and returns before the WorkSpaces have rebooted.

# Arguments
- `reboot_workspace_requests`: The WorkSpaces to reboot. You can specify up to 25
  WorkSpaces.

"""
function reboot_workspaces(
    RebootWorkspaceRequests; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "RebootWorkspaces",
        Dict{String,Any}("RebootWorkspaceRequests" => RebootWorkspaceRequests);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function reboot_workspaces(
    RebootWorkspaceRequests,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "RebootWorkspaces",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("RebootWorkspaceRequests" => RebootWorkspaceRequests),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    rebuild_workspaces(rebuild_workspace_requests)
    rebuild_workspaces(rebuild_workspace_requests, params::Dict{String,<:Any})

Rebuilds the specified WorkSpace. You cannot rebuild a WorkSpace unless its state is
AVAILABLE, ERROR, UNHEALTHY, STOPPED, or REBOOTING. Rebuilding a WorkSpace is a potentially
destructive action that can result in the loss of data. For more information, see Rebuild a
WorkSpace. This operation is asynchronous and returns before the WorkSpaces have been
completely rebuilt.

# Arguments
- `rebuild_workspace_requests`: The WorkSpace to rebuild. You can specify a single
  WorkSpace.

"""
function rebuild_workspaces(
    RebuildWorkspaceRequests; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "RebuildWorkspaces",
        Dict{String,Any}("RebuildWorkspaceRequests" => RebuildWorkspaceRequests);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function rebuild_workspaces(
    RebuildWorkspaceRequests,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "RebuildWorkspaces",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("RebuildWorkspaceRequests" => RebuildWorkspaceRequests),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    register_workspace_directory(directory_id, enable_work_docs)
    register_workspace_directory(directory_id, enable_work_docs, params::Dict{String,<:Any})

Registers the specified directory. This operation is asynchronous and returns before the
WorkSpace directory is registered. If this is the first time you are registering a
directory, you will need to create the workspaces_DefaultRole role before you can register
a directory. For more information, see  Creating the workspaces_DefaultRole Role.

# Arguments
- `directory_id`: The identifier of the directory. You cannot register a directory if it
  does not have a status of Active. If the directory does not have a status of Active, you
  will receive an InvalidResourceStateException error. If you have already registered the
  maximum number of directories that you can register with Amazon WorkSpaces, you will
  receive a ResourceLimitExceededException error. Deregister directories that you are not
  using for WorkSpaces, and try again.
- `enable_work_docs`: Indicates whether Amazon WorkDocs is enabled or disabled. If you have
  enabled this parameter and WorkDocs is not available in the Region, you will receive an
  OperationNotSupportedException error. Set EnableWorkDocs to disabled, and try again.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EnableSelfService"`: Indicates whether self-service capabilities are enabled or
  disabled.
- `"SubnetIds"`: The identifiers of the subnets for your virtual private cloud (VPC). Make
  sure that the subnets are in supported Availability Zones. The subnets must also be in
  separate Availability Zones. If these conditions are not met, you will receive an
  OperationNotSupportedException error.
- `"Tags"`: The tags associated with the directory.
- `"Tenancy"`: Indicates whether your WorkSpace directory is dedicated or shared. To use
  Bring Your Own License (BYOL) images, this value must be set to DEDICATED and your Amazon
  Web Services account must be enabled for BYOL. If your account has not been enabled for
  BYOL, you will receive an InvalidParameterValuesException error. For more information about
  BYOL images, see Bring Your Own Windows Desktop Images.
"""
function register_workspace_directory(
    DirectoryId, EnableWorkDocs; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "RegisterWorkspaceDirectory",
        Dict{String,Any}("DirectoryId" => DirectoryId, "EnableWorkDocs" => EnableWorkDocs);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function register_workspace_directory(
    DirectoryId,
    EnableWorkDocs,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "RegisterWorkspaceDirectory",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DirectoryId" => DirectoryId, "EnableWorkDocs" => EnableWorkDocs
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    reject_account_link_invitation(link_id)
    reject_account_link_invitation(link_id, params::Dict{String,<:Any})

Rejects the account link invitation.

# Arguments
- `link_id`: The identifier of the account link

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: The client token of the account link invitation to reject.
"""
function reject_account_link_invitation(
    LinkId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "RejectAccountLinkInvitation",
        Dict{String,Any}("LinkId" => LinkId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function reject_account_link_invitation(
    LinkId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "RejectAccountLinkInvitation",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("LinkId" => LinkId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    restore_workspace(workspace_id)
    restore_workspace(workspace_id, params::Dict{String,<:Any})

Restores the specified WorkSpace to its last known healthy state. You cannot restore a
WorkSpace unless its state is  AVAILABLE, ERROR, UNHEALTHY, or STOPPED. Restoring a
WorkSpace is a potentially destructive action that can result in the loss of data. For more
information, see Restore a WorkSpace. This operation is asynchronous and returns before the
WorkSpace is completely restored.

# Arguments
- `workspace_id`: The identifier of the WorkSpace.

"""
function restore_workspace(WorkspaceId; aws_config::AbstractAWSConfig=current_aws_config())
    return workspaces(
        "RestoreWorkspace",
        Dict{String,Any}("WorkspaceId" => WorkspaceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function restore_workspace(
    WorkspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "RestoreWorkspace",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("WorkspaceId" => WorkspaceId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    revoke_ip_rules(group_id, user_rules)
    revoke_ip_rules(group_id, user_rules, params::Dict{String,<:Any})

Removes one or more rules from the specified IP access control group.

# Arguments
- `group_id`: The identifier of the group.
- `user_rules`: The rules to remove from the group.

"""
function revoke_ip_rules(
    GroupId, UserRules; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "RevokeIpRules",
        Dict{String,Any}("GroupId" => GroupId, "UserRules" => UserRules);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function revoke_ip_rules(
    GroupId,
    UserRules,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "RevokeIpRules",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("GroupId" => GroupId, "UserRules" => UserRules),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_workspaces(start_workspace_requests)
    start_workspaces(start_workspace_requests, params::Dict{String,<:Any})

Starts the specified WorkSpaces. You cannot start a WorkSpace unless it has a running mode
of AutoStop and a state of STOPPED.

# Arguments
- `start_workspace_requests`: The WorkSpaces to start. You can specify up to 25 WorkSpaces.

"""
function start_workspaces(
    StartWorkspaceRequests; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "StartWorkspaces",
        Dict{String,Any}("StartWorkspaceRequests" => StartWorkspaceRequests);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_workspaces(
    StartWorkspaceRequests,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "StartWorkspaces",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("StartWorkspaceRequests" => StartWorkspaceRequests),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_workspaces(stop_workspace_requests)
    stop_workspaces(stop_workspace_requests, params::Dict{String,<:Any})

 Stops the specified WorkSpaces. You cannot stop a WorkSpace unless it has a running mode
of AutoStop and a state of AVAILABLE, IMPAIRED, UNHEALTHY, or ERROR.

# Arguments
- `stop_workspace_requests`: The WorkSpaces to stop. You can specify up to 25 WorkSpaces.

"""
function stop_workspaces(
    StopWorkspaceRequests; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "StopWorkspaces",
        Dict{String,Any}("StopWorkspaceRequests" => StopWorkspaceRequests);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_workspaces(
    StopWorkspaceRequests,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "StopWorkspaces",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("StopWorkspaceRequests" => StopWorkspaceRequests),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    terminate_workspaces(terminate_workspace_requests)
    terminate_workspaces(terminate_workspace_requests, params::Dict{String,<:Any})

Terminates the specified WorkSpaces.  Terminating a WorkSpace is a permanent action and
cannot be undone. The user's data is destroyed. If you need to archive any user data,
contact Amazon Web Services Support before terminating the WorkSpace.  You can terminate a
WorkSpace that is in any state except SUSPENDED. This operation is asynchronous and returns
before the WorkSpaces have been completely terminated. After a WorkSpace is terminated, the
TERMINATED state is returned only briefly before the WorkSpace directory metadata is
cleaned up, so this state is rarely returned. To confirm that a WorkSpace is terminated,
check for the WorkSpace ID by using  DescribeWorkSpaces. If the WorkSpace ID isn't
returned, then the WorkSpace has been successfully terminated.  Simple AD and AD Connector
are made available to you free of charge to use with WorkSpaces. If there are no WorkSpaces
being used with your Simple AD or AD Connector directory for 30 consecutive days, this
directory will be automatically deregistered for use with Amazon WorkSpaces, and you will
be charged for this directory as per the Directory Service pricing terms. To delete empty
directories, see  Delete the Directory for Your WorkSpaces. If you delete your Simple AD or
AD Connector directory, you can always create a new one when you want to start using
WorkSpaces again.

# Arguments
- `terminate_workspace_requests`: The WorkSpaces to terminate. You can specify up to 25
  WorkSpaces.

"""
function terminate_workspaces(
    TerminateWorkspaceRequests; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "TerminateWorkspaces",
        Dict{String,Any}("TerminateWorkspaceRequests" => TerminateWorkspaceRequests);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function terminate_workspaces(
    TerminateWorkspaceRequests,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "TerminateWorkspaces",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "TerminateWorkspaceRequests" => TerminateWorkspaceRequests
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_connect_client_add_in(add_in_id, resource_id)
    update_connect_client_add_in(add_in_id, resource_id, params::Dict{String,<:Any})

Updates a Amazon Connect client add-in. Use this action to update the name and endpoint URL
of a Amazon Connect client add-in.

# Arguments
- `add_in_id`: The identifier of the client add-in to update.
- `resource_id`: The directory identifier for which the client add-in is configured.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Name"`: The name of the client add-in.
- `"URL"`: The endpoint URL of the Amazon Connect client add-in.
"""
function update_connect_client_add_in(
    AddInId, ResourceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "UpdateConnectClientAddIn",
        Dict{String,Any}("AddInId" => AddInId, "ResourceId" => ResourceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_connect_client_add_in(
    AddInId,
    ResourceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "UpdateConnectClientAddIn",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("AddInId" => AddInId, "ResourceId" => ResourceId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_connection_alias_permission(alias_id, connection_alias_permission)
    update_connection_alias_permission(alias_id, connection_alias_permission, params::Dict{String,<:Any})

Shares or unshares a connection alias with one account by specifying whether that account
has permission to associate the connection alias with a directory. If the association
permission is granted, the connection alias is shared with that account. If the association
permission is revoked, the connection alias is unshared with the account. For more
information, see  Cross-Region Redirection for Amazon WorkSpaces.    Before performing this
operation, call  DescribeConnectionAliases to make sure that the current state of the
connection alias is CREATED.   To delete a connection alias that has been shared, the
shared account must first disassociate the connection alias from any directories it has
been associated with. Then you must unshare the connection alias from the account it has
been shared with. You can delete a connection alias only after it is no longer shared with
any accounts or associated with any directories.

# Arguments
- `alias_id`: The identifier of the connection alias that you want to update permissions
  for.
- `connection_alias_permission`: Indicates whether to share or unshare the connection alias
  with the specified Amazon Web Services account.

"""
function update_connection_alias_permission(
    AliasId, ConnectionAliasPermission; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "UpdateConnectionAliasPermission",
        Dict{String,Any}(
            "AliasId" => AliasId, "ConnectionAliasPermission" => ConnectionAliasPermission
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_connection_alias_permission(
    AliasId,
    ConnectionAliasPermission,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "UpdateConnectionAliasPermission",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AliasId" => AliasId,
                    "ConnectionAliasPermission" => ConnectionAliasPermission,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_rules_of_ip_group(group_id, user_rules)
    update_rules_of_ip_group(group_id, user_rules, params::Dict{String,<:Any})

Replaces the current rules of the specified IP access control group with the specified
rules.

# Arguments
- `group_id`: The identifier of the group.
- `user_rules`: One or more rules.

"""
function update_rules_of_ip_group(
    GroupId, UserRules; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "UpdateRulesOfIpGroup",
        Dict{String,Any}("GroupId" => GroupId, "UserRules" => UserRules);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_rules_of_ip_group(
    GroupId,
    UserRules,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "UpdateRulesOfIpGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("GroupId" => GroupId, "UserRules" => UserRules),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_workspace_bundle()
    update_workspace_bundle(params::Dict{String,<:Any})

Updates a WorkSpace bundle with a new image. For more information about updating WorkSpace
bundles, see  Update a Custom WorkSpaces Bundle.  Existing WorkSpaces aren't automatically
updated when you update the bundle that they're based on. To update existing WorkSpaces
that are based on a bundle that you've updated, you must either rebuild the WorkSpaces or
delete and recreate them.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"BundleId"`: The identifier of the bundle.
- `"ImageId"`: The identifier of the image.
"""
function update_workspace_bundle(; aws_config::AbstractAWSConfig=current_aws_config())
    return workspaces(
        "UpdateWorkspaceBundle"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function update_workspace_bundle(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workspaces(
        "UpdateWorkspaceBundle",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_workspace_image_permission(allow_copy_image, image_id, shared_account_id)
    update_workspace_image_permission(allow_copy_image, image_id, shared_account_id, params::Dict{String,<:Any})

Shares or unshares an image with one account in the same Amazon Web Services Region by
specifying whether that account has permission to copy the image. If the copy image
permission is granted, the image is shared with that account. If the copy image permission
is revoked, the image is unshared with the account. After an image has been shared, the
recipient account can copy the image to other Regions as needed. In the China (Ningxia)
Region, you can copy images only within the same Region. In Amazon Web Services GovCloud
(US), to copy images to and from other Regions, contact Amazon Web Services Support. For
more information about sharing images, see  Share or Unshare a Custom WorkSpaces Image.
To delete an image that has been shared, you must unshare the image before you delete it.
Sharing Bring Your Own License (BYOL) images across Amazon Web Services accounts isn't
supported at this time in Amazon Web Services GovCloud (US). To share BYOL images across
accounts in Amazon Web Services GovCloud (US), contact Amazon Web Services Support.

# Arguments
- `allow_copy_image`: The permission to copy the image. This permission can be revoked only
  after an image has been shared.
- `image_id`: The identifier of the image.
- `shared_account_id`: The identifier of the Amazon Web Services account to share or
  unshare the image with.  Before sharing the image, confirm that you are sharing to the
  correct Amazon Web Services account ID.

"""
function update_workspace_image_permission(
    AllowCopyImage,
    ImageId,
    SharedAccountId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "UpdateWorkspaceImagePermission",
        Dict{String,Any}(
            "AllowCopyImage" => AllowCopyImage,
            "ImageId" => ImageId,
            "SharedAccountId" => SharedAccountId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_workspace_image_permission(
    AllowCopyImage,
    ImageId,
    SharedAccountId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workspaces(
        "UpdateWorkspaceImagePermission",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AllowCopyImage" => AllowCopyImage,
                    "ImageId" => ImageId,
                    "SharedAccountId" => SharedAccountId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: device_farm
using AWS.Compat
using AWS.UUIDs

"""
    create_device_pool(name, project_arn, rules)
    create_device_pool(name, project_arn, rules, params::Dict{String,<:Any})

Creates a device pool.

# Arguments
- `name`: The device pool's name.
- `project_arn`: The ARN of the project for the device pool.
- `rules`: The device pool's rules.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The device pool's description.
- `"maxDevices"`: The number of devices that Device Farm can add to your device pool.
  Device Farm adds devices that are available and meet the criteria that you assign for the
  rules parameter. Depending on how many devices meet these constraints, your device pool
  might contain fewer devices than the value for this parameter. By specifying the maximum
  number of devices, you can control the costs that you incur by running tests.
"""
function create_device_pool(
    name, projectArn, rules; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "CreateDevicePool",
        Dict{String,Any}("name" => name, "projectArn" => projectArn, "rules" => rules);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_device_pool(
    name,
    projectArn,
    rules,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return device_farm(
        "CreateDevicePool",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "name" => name, "projectArn" => projectArn, "rules" => rules
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_instance_profile(name)
    create_instance_profile(name, params::Dict{String,<:Any})

Creates a profile that can be applied to one or more private fleet device instances.

# Arguments
- `name`: The name of your instance profile.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description of your instance profile.
- `"excludeAppPackagesFromCleanup"`: An array of strings that specifies the list of app
  packages that should not be cleaned up from the device after a test run. The list of
  packages is considered only if you set packageCleanup to true.
- `"packageCleanup"`: When set to true, Device Farm removes app packages after a test run.
  The default value is false for private devices.
- `"rebootAfterUse"`: When set to true, Device Farm reboots the instance after a test run.
  The default value is true.
"""
function create_instance_profile(name; aws_config::AbstractAWSConfig=current_aws_config())
    return device_farm(
        "CreateInstanceProfile",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_instance_profile(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "CreateInstanceProfile",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_network_profile(name, project_arn)
    create_network_profile(name, project_arn, params::Dict{String,<:Any})

Creates a network profile.

# Arguments
- `name`: The name for the new network profile.
- `project_arn`: The Amazon Resource Name (ARN) of the project for which you want to create
  a network profile.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description of the network profile.
- `"downlinkBandwidthBits"`: The data throughput rate in bits per second, as an integer
  from 0 to 104857600.
- `"downlinkDelayMs"`: Delay time for all packets to destination in milliseconds as an
  integer from 0 to 2000.
- `"downlinkJitterMs"`: Time variation in the delay of received packets in milliseconds as
  an integer from 0 to 2000.
- `"downlinkLossPercent"`: Proportion of received packets that fail to arrive from 0 to 100
  percent.
- `"type"`: The type of network profile to create. Valid values are listed here.
- `"uplinkBandwidthBits"`: The data throughput rate in bits per second, as an integer from
  0 to 104857600.
- `"uplinkDelayMs"`: Delay time for all packets to destination in milliseconds as an
  integer from 0 to 2000.
- `"uplinkJitterMs"`: Time variation in the delay of received packets in milliseconds as an
  integer from 0 to 2000.
- `"uplinkLossPercent"`: Proportion of transmitted packets that fail to arrive from 0 to
  100 percent.
"""
function create_network_profile(
    name, projectArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "CreateNetworkProfile",
        Dict{String,Any}("name" => name, "projectArn" => projectArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_network_profile(
    name,
    projectArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return device_farm(
        "CreateNetworkProfile",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("name" => name, "projectArn" => projectArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_project(name)
    create_project(name, params::Dict{String,<:Any})

Creates a project.

# Arguments
- `name`: The project's name.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"defaultJobTimeoutMinutes"`: Sets the execution timeout value (in minutes) for a
  project. All test runs in this project use the specified execution timeout value unless
  overridden when scheduling a run.
- `"vpcConfig"`: The VPC security groups and subnets that are attached to a project.
"""
function create_project(name; aws_config::AbstractAWSConfig=current_aws_config())
    return device_farm(
        "CreateProject",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_project(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "CreateProject",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_remote_access_session(device_arn, project_arn)
    create_remote_access_session(device_arn, project_arn, params::Dict{String,<:Any})

Specifies and starts a remote access session.

# Arguments
- `device_arn`: The ARN of the device for which you want to create a remote access session.
- `project_arn`: The Amazon Resource Name (ARN) of the project for which you want to create
  a remote access session.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientId"`: Unique identifier for the client. If you want access to multiple devices on
  the same client, you should pass the same clientId value in each call to
  CreateRemoteAccessSession. This identifier is required only if remoteDebugEnabled is set to
  true. Remote debugging is no longer supported.
- `"configuration"`: The configuration information for the remote access session request.
- `"instanceArn"`: The Amazon Resource Name (ARN) of the device instance for which you want
  to create a remote access session.
- `"interactionMode"`: The interaction mode of the remote access session. Valid values are:
    INTERACTIVE: You can interact with the iOS device by viewing, touching, and rotating the
  screen. You cannot run XCUITest framework-based tests in this mode.   NO_VIDEO: You are
  connected to the device, but cannot interact with it or view the screen. This mode has the
  fastest test execution speed. You can run XCUITest framework-based tests in this mode.
  VIDEO_ONLY: You can view the screen, but cannot touch or rotate it. You can run XCUITest
  framework-based tests and watch the screen in this mode.
- `"name"`: The name of the remote access session to create.
- `"remoteDebugEnabled"`: Set to true if you want to access devices remotely for debugging
  in your remote access session. Remote debugging is no longer supported.
- `"remoteRecordAppArn"`: The Amazon Resource Name (ARN) for the app to be recorded in the
  remote access session.
- `"remoteRecordEnabled"`: Set to true to enable remote recording for the remote access
  session.
- `"skipAppResign"`: When set to true, for private devices, Device Farm does not sign your
  app again. For public devices, Device Farm always signs your apps again. For more
  information on how Device Farm modifies your uploads during tests, see Do you modify my
  app?
- `"sshPublicKey"`: Ignored. The public key of the ssh key pair you want to use for
  connecting to remote devices in your remote debugging session. This key is required only if
  remoteDebugEnabled is set to true. Remote debugging is no longer supported.
"""
function create_remote_access_session(
    deviceArn, projectArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "CreateRemoteAccessSession",
        Dict{String,Any}("deviceArn" => deviceArn, "projectArn" => projectArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_remote_access_session(
    deviceArn,
    projectArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return device_farm(
        "CreateRemoteAccessSession",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("deviceArn" => deviceArn, "projectArn" => projectArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_test_grid_project(name)
    create_test_grid_project(name, params::Dict{String,<:Any})

Creates a Selenium testing project. Projects are used to track TestGridSession instances.

# Arguments
- `name`: Human-readable name of the Selenium testing project.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: Human-readable description of the project.
- `"vpcConfig"`: The VPC security groups and subnets that are attached to a project.
"""
function create_test_grid_project(name; aws_config::AbstractAWSConfig=current_aws_config())
    return device_farm(
        "CreateTestGridProject",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_test_grid_project(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "CreateTestGridProject",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_test_grid_url(expires_in_seconds, project_arn)
    create_test_grid_url(expires_in_seconds, project_arn, params::Dict{String,<:Any})

Creates a signed, short-term URL that can be passed to a Selenium RemoteWebDriver
constructor.

# Arguments
- `expires_in_seconds`: Lifetime, in seconds, of the URL.
- `project_arn`: ARN (from CreateTestGridProject or ListTestGridProjects) to associate with
  the short-term URL.

"""
function create_test_grid_url(
    expiresInSeconds, projectArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "CreateTestGridUrl",
        Dict{String,Any}(
            "expiresInSeconds" => expiresInSeconds, "projectArn" => projectArn
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_test_grid_url(
    expiresInSeconds,
    projectArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return device_farm(
        "CreateTestGridUrl",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "expiresInSeconds" => expiresInSeconds, "projectArn" => projectArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_upload(name, project_arn, type)
    create_upload(name, project_arn, type, params::Dict{String,<:Any})

Uploads an app or test scripts.

# Arguments
- `name`: The upload's file name. The name should not contain any forward slashes (/). If
  you are uploading an iOS app, the file name must end with the .ipa extension. If you are
  uploading an Android app, the file name must end with the .apk extension. For all others,
  the file name must end with the .zip file extension.
- `project_arn`: The ARN of the project for the upload.
- `type`: The upload's upload type. Must be one of the following values:   ANDROID_APP
  IOS_APP   WEB_APP   EXTERNAL_DATA   APPIUM_JAVA_JUNIT_TEST_PACKAGE
  APPIUM_JAVA_TESTNG_TEST_PACKAGE   APPIUM_PYTHON_TEST_PACKAGE   APPIUM_NODE_TEST_PACKAGE
  APPIUM_RUBY_TEST_PACKAGE   APPIUM_WEB_JAVA_JUNIT_TEST_PACKAGE
  APPIUM_WEB_JAVA_TESTNG_TEST_PACKAGE   APPIUM_WEB_PYTHON_TEST_PACKAGE
  APPIUM_WEB_NODE_TEST_PACKAGE   APPIUM_WEB_RUBY_TEST_PACKAGE   CALABASH_TEST_PACKAGE
  INSTRUMENTATION_TEST_PACKAGE   UIAUTOMATION_TEST_PACKAGE   UIAUTOMATOR_TEST_PACKAGE
  XCTEST_TEST_PACKAGE   XCTEST_UI_TEST_PACKAGE   APPIUM_JAVA_JUNIT_TEST_SPEC
  APPIUM_JAVA_TESTNG_TEST_SPEC   APPIUM_PYTHON_TEST_SPEC   APPIUM_NODE_TEST_SPEC
  APPIUM_RUBY_TEST_SPEC   APPIUM_WEB_JAVA_JUNIT_TEST_SPEC   APPIUM_WEB_JAVA_TESTNG_TEST_SPEC
   APPIUM_WEB_PYTHON_TEST_SPEC   APPIUM_WEB_NODE_TEST_SPEC   APPIUM_WEB_RUBY_TEST_SPEC
  INSTRUMENTATION_TEST_SPEC   XCTEST_UI_TEST_SPEC    If you call CreateUpload with WEB_APP
  specified, AWS Device Farm throws an ArgumentException error.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"contentType"`: The upload's content type (for example, application/octet-stream).
"""
function create_upload(
    name, projectArn, type; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "CreateUpload",
        Dict{String,Any}("name" => name, "projectArn" => projectArn, "type" => type);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_upload(
    name,
    projectArn,
    type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return device_farm(
        "CreateUpload",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "name" => name, "projectArn" => projectArn, "type" => type
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_vpceconfiguration(service_dns_name, vpce_configuration_name, vpce_service_name)
    create_vpceconfiguration(service_dns_name, vpce_configuration_name, vpce_service_name, params::Dict{String,<:Any})

Creates a configuration record in Device Farm for your Amazon Virtual Private Cloud (VPC)
endpoint.

# Arguments
- `service_dns_name`: The DNS name of the service running in your VPC that you want Device
  Farm to test.
- `vpce_configuration_name`: The friendly name you give to your VPC endpoint configuration,
  to manage your configurations more easily.
- `vpce_service_name`: The name of the VPC endpoint service running in your AWS account
  that you want Device Farm to test.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"vpceConfigurationDescription"`: An optional description that provides details about
  your VPC endpoint configuration.
"""
function create_vpceconfiguration(
    serviceDnsName,
    vpceConfigurationName,
    vpceServiceName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return device_farm(
        "CreateVPCEConfiguration",
        Dict{String,Any}(
            "serviceDnsName" => serviceDnsName,
            "vpceConfigurationName" => vpceConfigurationName,
            "vpceServiceName" => vpceServiceName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_vpceconfiguration(
    serviceDnsName,
    vpceConfigurationName,
    vpceServiceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return device_farm(
        "CreateVPCEConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "serviceDnsName" => serviceDnsName,
                    "vpceConfigurationName" => vpceConfigurationName,
                    "vpceServiceName" => vpceServiceName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_device_pool(arn)
    delete_device_pool(arn, params::Dict{String,<:Any})

Deletes a device pool given the pool ARN. Does not allow deletion of curated pools owned by
the system.

# Arguments
- `arn`: Represents the Amazon Resource Name (ARN) of the Device Farm device pool to delete.

"""
function delete_device_pool(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return device_farm(
        "DeleteDevicePool",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_device_pool(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "DeleteDevicePool",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_instance_profile(arn)
    delete_instance_profile(arn, params::Dict{String,<:Any})

Deletes a profile that can be applied to one or more private device instances.

# Arguments
- `arn`: The Amazon Resource Name (ARN) of the instance profile you are requesting to
  delete.

"""
function delete_instance_profile(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return device_farm(
        "DeleteInstanceProfile",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_instance_profile(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "DeleteInstanceProfile",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_network_profile(arn)
    delete_network_profile(arn, params::Dict{String,<:Any})

Deletes a network profile.

# Arguments
- `arn`: The ARN of the network profile to delete.

"""
function delete_network_profile(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return device_farm(
        "DeleteNetworkProfile",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_network_profile(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "DeleteNetworkProfile",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_project(arn)
    delete_project(arn, params::Dict{String,<:Any})

Deletes an AWS Device Farm project, given the project ARN.  Deleting this resource does not
stop an in-progress run.

# Arguments
- `arn`: Represents the Amazon Resource Name (ARN) of the Device Farm project to delete.

"""
function delete_project(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return device_farm(
        "DeleteProject",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_project(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "DeleteProject",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_remote_access_session(arn)
    delete_remote_access_session(arn, params::Dict{String,<:Any})

Deletes a completed remote access session and its results.

# Arguments
- `arn`: The Amazon Resource Name (ARN) of the session for which you want to delete remote
  access.

"""
function delete_remote_access_session(
    arn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "DeleteRemoteAccessSession",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_remote_access_session(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "DeleteRemoteAccessSession",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_run(arn)
    delete_run(arn, params::Dict{String,<:Any})

Deletes the run, given the run ARN.  Deleting this resource does not stop an in-progress
run.

# Arguments
- `arn`: The Amazon Resource Name (ARN) for the run to delete.

"""
function delete_run(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return device_farm(
        "DeleteRun",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_run(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "DeleteRun",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_test_grid_project(project_arn)
    delete_test_grid_project(project_arn, params::Dict{String,<:Any})

 Deletes a Selenium testing project and all content generated under it.   You cannot undo
this operation.   You cannot delete a project if it has active sessions.

# Arguments
- `project_arn`: The ARN of the project to delete, from CreateTestGridProject or
  ListTestGridProjects.

"""
function delete_test_grid_project(
    projectArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "DeleteTestGridProject",
        Dict{String,Any}("projectArn" => projectArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_test_grid_project(
    projectArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return device_farm(
        "DeleteTestGridProject",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("projectArn" => projectArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_upload(arn)
    delete_upload(arn, params::Dict{String,<:Any})

Deletes an upload given the upload ARN.

# Arguments
- `arn`: Represents the Amazon Resource Name (ARN) of the Device Farm upload to delete.

"""
function delete_upload(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return device_farm(
        "DeleteUpload",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_upload(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "DeleteUpload",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_vpceconfiguration(arn)
    delete_vpceconfiguration(arn, params::Dict{String,<:Any})

Deletes a configuration for your Amazon Virtual Private Cloud (VPC) endpoint.

# Arguments
- `arn`: The Amazon Resource Name (ARN) of the VPC endpoint configuration you want to
  delete.

"""
function delete_vpceconfiguration(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return device_farm(
        "DeleteVPCEConfiguration",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_vpceconfiguration(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "DeleteVPCEConfiguration",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_account_settings()
    get_account_settings(params::Dict{String,<:Any})

Returns the number of unmetered iOS or unmetered Android devices that have been purchased
by the account.

"""
function get_account_settings(; aws_config::AbstractAWSConfig=current_aws_config())
    return device_farm(
        "GetAccountSettings"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_account_settings(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "GetAccountSettings", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_device(arn)
    get_device(arn, params::Dict{String,<:Any})

Gets information about a unique device type.

# Arguments
- `arn`: The device type's ARN.

"""
function get_device(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return device_farm(
        "GetDevice",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_device(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "GetDevice",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_device_instance(arn)
    get_device_instance(arn, params::Dict{String,<:Any})

Returns information about a device instance that belongs to a private device fleet.

# Arguments
- `arn`: The Amazon Resource Name (ARN) of the instance you're requesting information about.

"""
function get_device_instance(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return device_farm(
        "GetDeviceInstance",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_device_instance(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "GetDeviceInstance",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_device_pool(arn)
    get_device_pool(arn, params::Dict{String,<:Any})

Gets information about a device pool.

# Arguments
- `arn`: The device pool's ARN.

"""
function get_device_pool(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return device_farm(
        "GetDevicePool",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_device_pool(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "GetDevicePool",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_device_pool_compatibility(device_pool_arn)
    get_device_pool_compatibility(device_pool_arn, params::Dict{String,<:Any})

Gets information about compatibility with a device pool.

# Arguments
- `device_pool_arn`: The device pool's ARN.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"appArn"`: The ARN of the app that is associated with the specified device pool.
- `"configuration"`: An object that contains information about the settings for a run.
- `"test"`: Information about the uploaded test to be run against the device pool.
- `"testType"`: The test type for the specified device pool. Allowed values include the
  following:   BUILTIN_FUZZ.   BUILTIN_EXPLORER. For Android, an app explorer that traverses
  an Android app, interacting with it and capturing screenshots at the same time.
  APPIUM_JAVA_JUNIT.   APPIUM_JAVA_TESTNG.   APPIUM_PYTHON.   APPIUM_NODE.   APPIUM_RUBY.
  APPIUM_WEB_JAVA_JUNIT.   APPIUM_WEB_JAVA_TESTNG.   APPIUM_WEB_PYTHON.   APPIUM_WEB_NODE.
  APPIUM_WEB_RUBY.   CALABASH.   INSTRUMENTATION.   UIAUTOMATION.   UIAUTOMATOR.   XCTEST.
  XCTEST_UI.
"""
function get_device_pool_compatibility(
    devicePoolArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "GetDevicePoolCompatibility",
        Dict{String,Any}("devicePoolArn" => devicePoolArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_device_pool_compatibility(
    devicePoolArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return device_farm(
        "GetDevicePoolCompatibility",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("devicePoolArn" => devicePoolArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_instance_profile(arn)
    get_instance_profile(arn, params::Dict{String,<:Any})

Returns information about the specified instance profile.

# Arguments
- `arn`: The Amazon Resource Name (ARN) of an instance profile.

"""
function get_instance_profile(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return device_farm(
        "GetInstanceProfile",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_instance_profile(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "GetInstanceProfile",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_job(arn)
    get_job(arn, params::Dict{String,<:Any})

Gets information about a job.

# Arguments
- `arn`: The job's ARN.

"""
function get_job(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return device_farm(
        "GetJob",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_job(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "GetJob",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_network_profile(arn)
    get_network_profile(arn, params::Dict{String,<:Any})

Returns information about a network profile.

# Arguments
- `arn`: The ARN of the network profile to return information about.

"""
function get_network_profile(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return device_farm(
        "GetNetworkProfile",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_network_profile(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "GetNetworkProfile",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_offering_status()
    get_offering_status(params::Dict{String,<:Any})

Gets the current status and future status of all offerings purchased by an AWS account. The
response indicates how many offerings are currently available and the offerings that will
be available in the next period. The API returns a NotEligible error if the user is not
permitted to invoke the operation. If you must be able to invoke this operation, contact
aws-devicefarm-support@amazon.com.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: An identifier that was returned from the previous call to this operation,
  which can be used to return the next set of items in the list.
"""
function get_offering_status(; aws_config::AbstractAWSConfig=current_aws_config())
    return device_farm(
        "GetOfferingStatus"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_offering_status(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "GetOfferingStatus", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_project(arn)
    get_project(arn, params::Dict{String,<:Any})

Gets information about a project.

# Arguments
- `arn`: The project's ARN.

"""
function get_project(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return device_farm(
        "GetProject",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_project(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "GetProject",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_remote_access_session(arn)
    get_remote_access_session(arn, params::Dict{String,<:Any})

Returns a link to a currently running remote access session.

# Arguments
- `arn`: The Amazon Resource Name (ARN) of the remote access session about which you want
  to get session information.

"""
function get_remote_access_session(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return device_farm(
        "GetRemoteAccessSession",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_remote_access_session(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "GetRemoteAccessSession",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_run(arn)
    get_run(arn, params::Dict{String,<:Any})

Gets information about a run.

# Arguments
- `arn`: The run's ARN.

"""
function get_run(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return device_farm(
        "GetRun",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_run(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "GetRun",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_suite(arn)
    get_suite(arn, params::Dict{String,<:Any})

Gets information about a suite.

# Arguments
- `arn`: The suite's ARN.

"""
function get_suite(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return device_farm(
        "GetSuite",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_suite(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "GetSuite",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_test(arn)
    get_test(arn, params::Dict{String,<:Any})

Gets information about a test.

# Arguments
- `arn`: The test's ARN.

"""
function get_test(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return device_farm(
        "GetTest",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_test(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "GetTest",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_test_grid_project(project_arn)
    get_test_grid_project(project_arn, params::Dict{String,<:Any})

Retrieves information about a Selenium testing project.

# Arguments
- `project_arn`: The ARN of the Selenium testing project, from either CreateTestGridProject
  or ListTestGridProjects.

"""
function get_test_grid_project(
    projectArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "GetTestGridProject",
        Dict{String,Any}("projectArn" => projectArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_test_grid_project(
    projectArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return device_farm(
        "GetTestGridProject",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("projectArn" => projectArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_test_grid_session()
    get_test_grid_session(params::Dict{String,<:Any})

A session is an instance of a browser created through a RemoteWebDriver with the URL from
CreateTestGridUrlResulturl. You can use the following to look up sessions:   The session
ARN (GetTestGridSessionRequestsessionArn).   The project ARN and a session ID
(GetTestGridSessionRequestprojectArn and GetTestGridSessionRequestsessionId).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"projectArn"`: The ARN for the project that this session belongs to. See
  CreateTestGridProject and ListTestGridProjects.
- `"sessionArn"`: An ARN that uniquely identifies a TestGridSession.
- `"sessionId"`: An ID associated with this session.
"""
function get_test_grid_session(; aws_config::AbstractAWSConfig=current_aws_config())
    return device_farm(
        "GetTestGridSession"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_test_grid_session(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "GetTestGridSession", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_upload(arn)
    get_upload(arn, params::Dict{String,<:Any})

Gets information about an upload.

# Arguments
- `arn`: The upload's ARN.

"""
function get_upload(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return device_farm(
        "GetUpload",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_upload(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "GetUpload",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_vpceconfiguration(arn)
    get_vpceconfiguration(arn, params::Dict{String,<:Any})

Returns information about the configuration settings for your Amazon Virtual Private Cloud
(VPC) endpoint.

# Arguments
- `arn`: The Amazon Resource Name (ARN) of the VPC endpoint configuration you want to
  describe.

"""
function get_vpceconfiguration(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return device_farm(
        "GetVPCEConfiguration",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_vpceconfiguration(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "GetVPCEConfiguration",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    install_to_remote_access_session(app_arn, remote_access_session_arn)
    install_to_remote_access_session(app_arn, remote_access_session_arn, params::Dict{String,<:Any})

Installs an application to the device in a remote access session. For Android applications,
the file must be in .apk format. For iOS applications, the file must be in .ipa format.

# Arguments
- `app_arn`: The ARN of the app about which you are requesting information.
- `remote_access_session_arn`: The Amazon Resource Name (ARN) of the remote access session
  about which you are requesting information.

"""
function install_to_remote_access_session(
    appArn, remoteAccessSessionArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "InstallToRemoteAccessSession",
        Dict{String,Any}(
            "appArn" => appArn, "remoteAccessSessionArn" => remoteAccessSessionArn
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function install_to_remote_access_session(
    appArn,
    remoteAccessSessionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return device_farm(
        "InstallToRemoteAccessSession",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "appArn" => appArn, "remoteAccessSessionArn" => remoteAccessSessionArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_artifacts(arn, type)
    list_artifacts(arn, type, params::Dict{String,<:Any})

Gets information about artifacts.

# Arguments
- `arn`: The run, job, suite, or test ARN.
- `type`: The artifacts' type. Allowed values include:   FILE   LOG   SCREENSHOT

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: An identifier that was returned from the previous call to this operation,
  which can be used to return the next set of items in the list.
"""
function list_artifacts(arn, type; aws_config::AbstractAWSConfig=current_aws_config())
    return device_farm(
        "ListArtifacts",
        Dict{String,Any}("arn" => arn, "type" => type);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_artifacts(
    arn,
    type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return device_farm(
        "ListArtifacts",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("arn" => arn, "type" => type), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_device_instances()
    list_device_instances(params::Dict{String,<:Any})

Returns information about the private device instances associated with one or more AWS
accounts.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: An integer that specifies the maximum number of items you want to return
  in the API response.
- `"nextToken"`: An identifier that was returned from the previous call to this operation,
  which can be used to return the next set of items in the list.
"""
function list_device_instances(; aws_config::AbstractAWSConfig=current_aws_config())
    return device_farm(
        "ListDeviceInstances"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_device_instances(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "ListDeviceInstances",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_device_pools(arn)
    list_device_pools(arn, params::Dict{String,<:Any})

Gets information about device pools.

# Arguments
- `arn`: The project ARN.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: An identifier that was returned from the previous call to this operation,
  which can be used to return the next set of items in the list.
- `"type"`: The device pools' type. Allowed values include:   CURATED: A device pool that
  is created and managed by AWS Device Farm.   PRIVATE: A device pool that is created and
  managed by the device pool developer.
"""
function list_device_pools(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return device_farm(
        "ListDevicePools",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_device_pools(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "ListDevicePools",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_devices()
    list_devices(params::Dict{String,<:Any})

Gets information about unique device types.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"arn"`: The Amazon Resource Name (ARN) of the project.
- `"filters"`: Used to select a set of devices. A filter is made up of an attribute, an
  operator, and one or more values.   Attribute: The aspect of a device such as platform or
  model used as the selection criteria in a device filter. Allowed values include:   ARN: The
  Amazon Resource Name (ARN) of the device (for example,
  arn:aws:devicefarm:us-west-2::device:12345Example).   PLATFORM: The device platform. Valid
  values are ANDROID or IOS.   OS_VERSION: The operating system version (for example,
  10.3.2).   MODEL: The device model (for example, iPad 5th Gen).   AVAILABILITY: The current
  availability of the device. Valid values are AVAILABLE, HIGHLY_AVAILABLE, BUSY, or
  TEMPORARY_NOT_AVAILABLE.   FORM_FACTOR: The device form factor. Valid values are PHONE or
  TABLET.   MANUFACTURER: The device manufacturer (for example, Apple).
  REMOTE_ACCESS_ENABLED: Whether the device is enabled for remote access. Valid values are
  TRUE or FALSE.   REMOTE_DEBUG_ENABLED: Whether the device is enabled for remote debugging.
  Valid values are TRUE or FALSE. Because remote debugging is no longer supported, this
  attribute is ignored.   INSTANCE_ARN: The Amazon Resource Name (ARN) of the device
  instance.   INSTANCE_LABELS: The label of the device instance.   FLEET_TYPE: The fleet
  type. Valid values are PUBLIC or PRIVATE.     Operator: The filter operator.   The EQUALS
  operator is available for every attribute except INSTANCE_LABELS.   The CONTAINS operator
  is available for the INSTANCE_LABELS and MODEL attributes.   The IN and NOT_IN operators
  are available for the ARN, OS_VERSION, MODEL, MANUFACTURER, and INSTANCE_ARN attributes.
  The LESS_THAN, GREATER_THAN, LESS_THAN_OR_EQUALS, and GREATER_THAN_OR_EQUALS operators are
  also available for the OS_VERSION attribute.     Values: An array of one or more filter
  values.   The IN and NOT_IN operators take a values array that has one or more elements.
  The other operators require an array with a single element.   In a request, the
  AVAILABILITY attribute takes the following values: AVAILABLE, HIGHLY_AVAILABLE, BUSY, or
  TEMPORARY_NOT_AVAILABLE.
- `"nextToken"`: An identifier that was returned from the previous call to this operation,
  which can be used to return the next set of items in the list.
"""
function list_devices(; aws_config::AbstractAWSConfig=current_aws_config())
    return device_farm(
        "ListDevices"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_devices(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "ListDevices", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_instance_profiles()
    list_instance_profiles(params::Dict{String,<:Any})

Returns information about all the instance profiles in an AWS account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: An integer that specifies the maximum number of items you want to return
  in the API response.
- `"nextToken"`: An identifier that was returned from the previous call to this operation,
  which can be used to return the next set of items in the list.
"""
function list_instance_profiles(; aws_config::AbstractAWSConfig=current_aws_config())
    return device_farm(
        "ListInstanceProfiles"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_instance_profiles(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "ListInstanceProfiles",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_jobs(arn)
    list_jobs(arn, params::Dict{String,<:Any})

Gets information about jobs for a given test run.

# Arguments
- `arn`: The run's Amazon Resource Name (ARN).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: An identifier that was returned from the previous call to this operation,
  which can be used to return the next set of items in the list.
"""
function list_jobs(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return device_farm(
        "ListJobs",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_jobs(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "ListJobs",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_network_profiles(arn)
    list_network_profiles(arn, params::Dict{String,<:Any})

Returns the list of available network profiles.

# Arguments
- `arn`: The Amazon Resource Name (ARN) of the project for which you want to list network
  profiles.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: An identifier that was returned from the previous call to this operation,
  which can be used to return the next set of items in the list.
- `"type"`: The type of network profile to return information about. Valid values are
  listed here.
"""
function list_network_profiles(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return device_farm(
        "ListNetworkProfiles",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_network_profiles(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "ListNetworkProfiles",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_offering_promotions()
    list_offering_promotions(params::Dict{String,<:Any})

Returns a list of offering promotions. Each offering promotion record contains the ID and
description of the promotion. The API returns a NotEligible error if the caller is not
permitted to invoke the operation. Contact aws-devicefarm-support@amazon.com if you must be
able to invoke this operation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: An identifier that was returned from the previous call to this operation,
  which can be used to return the next set of items in the list.
"""
function list_offering_promotions(; aws_config::AbstractAWSConfig=current_aws_config())
    return device_farm(
        "ListOfferingPromotions"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_offering_promotions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "ListOfferingPromotions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_offering_transactions()
    list_offering_transactions(params::Dict{String,<:Any})

Returns a list of all historical purchases, renewals, and system renewal transactions for
an AWS account. The list is paginated and ordered by a descending timestamp (most recent
transactions are first). The API returns a NotEligible error if the user is not permitted
to invoke the operation. If you must be able to invoke this operation, contact
aws-devicefarm-support@amazon.com.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: An identifier that was returned from the previous call to this operation,
  which can be used to return the next set of items in the list.
"""
function list_offering_transactions(; aws_config::AbstractAWSConfig=current_aws_config())
    return device_farm(
        "ListOfferingTransactions"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_offering_transactions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "ListOfferingTransactions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_offerings()
    list_offerings(params::Dict{String,<:Any})

Returns a list of products or offerings that the user can manage through the API. Each
offering record indicates the recurring price per unit and the frequency for that offering.
The API returns a NotEligible error if the user is not permitted to invoke the operation.
If you must be able to invoke this operation, contact aws-devicefarm-support@amazon.com.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: An identifier that was returned from the previous call to this operation,
  which can be used to return the next set of items in the list.
"""
function list_offerings(; aws_config::AbstractAWSConfig=current_aws_config())
    return device_farm(
        "ListOfferings"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_offerings(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "ListOfferings", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_projects()
    list_projects(params::Dict{String,<:Any})

Gets information about projects.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"arn"`: Optional. If no Amazon Resource Name (ARN) is specified, then AWS Device Farm
  returns a list of all projects for the AWS account. You can also specify a project ARN.
- `"nextToken"`: An identifier that was returned from the previous call to this operation,
  which can be used to return the next set of items in the list.
"""
function list_projects(; aws_config::AbstractAWSConfig=current_aws_config())
    return device_farm(
        "ListProjects"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_projects(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "ListProjects", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_remote_access_sessions(arn)
    list_remote_access_sessions(arn, params::Dict{String,<:Any})

Returns a list of all currently running remote access sessions.

# Arguments
- `arn`: The Amazon Resource Name (ARN) of the project about which you are requesting
  information.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: An identifier that was returned from the previous call to this operation,
  which can be used to return the next set of items in the list.
"""
function list_remote_access_sessions(
    arn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "ListRemoteAccessSessions",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_remote_access_sessions(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "ListRemoteAccessSessions",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_runs(arn)
    list_runs(arn, params::Dict{String,<:Any})

Gets information about runs, given an AWS Device Farm project ARN.

# Arguments
- `arn`: The Amazon Resource Name (ARN) of the project for which you want to list runs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: An identifier that was returned from the previous call to this operation,
  which can be used to return the next set of items in the list.
"""
function list_runs(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return device_farm(
        "ListRuns",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_runs(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "ListRuns",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_samples(arn)
    list_samples(arn, params::Dict{String,<:Any})

Gets information about samples, given an AWS Device Farm job ARN.

# Arguments
- `arn`: The Amazon Resource Name (ARN) of the job used to list samples.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: An identifier that was returned from the previous call to this operation,
  which can be used to return the next set of items in the list.
"""
function list_samples(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return device_farm(
        "ListSamples",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_samples(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "ListSamples",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_suites(arn)
    list_suites(arn, params::Dict{String,<:Any})

Gets information about test suites for a given job.

# Arguments
- `arn`: The job's Amazon Resource Name (ARN).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: An identifier that was returned from the previous call to this operation,
  which can be used to return the next set of items in the list.
"""
function list_suites(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return device_farm(
        "ListSuites",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_suites(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "ListSuites",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

List the tags for an AWS Device Farm resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource or resources for which to
  list tags. You can associate tags with the following Device Farm resources: PROJECT, RUN,
  NETWORK_PROFILE, INSTANCE_PROFILE, DEVICE_INSTANCE, SESSION, DEVICE_POOL, DEVICE, and
  VPCE_CONFIGURATION.

"""
function list_tags_for_resource(
    ResourceARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "ListTagsForResource",
        Dict{String,Any}("ResourceARN" => ResourceARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return device_farm(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceARN" => ResourceARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_test_grid_projects()
    list_test_grid_projects(params::Dict{String,<:Any})

Gets a list of all Selenium testing projects in your account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResult"`: Return no more than this number of results.
- `"nextToken"`: From a response, used to continue a paginated listing.
"""
function list_test_grid_projects(; aws_config::AbstractAWSConfig=current_aws_config())
    return device_farm(
        "ListTestGridProjects"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_test_grid_projects(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "ListTestGridProjects",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_test_grid_session_actions(session_arn)
    list_test_grid_session_actions(session_arn, params::Dict{String,<:Any})

Returns a list of the actions taken in a TestGridSession.

# Arguments
- `session_arn`: The ARN of the session to retrieve.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResult"`: The maximum number of sessions to return per response.
- `"nextToken"`: Pagination token.
"""
function list_test_grid_session_actions(
    sessionArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "ListTestGridSessionActions",
        Dict{String,Any}("sessionArn" => sessionArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_test_grid_session_actions(
    sessionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return device_farm(
        "ListTestGridSessionActions",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("sessionArn" => sessionArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_test_grid_session_artifacts(session_arn)
    list_test_grid_session_artifacts(session_arn, params::Dict{String,<:Any})

Retrieves a list of artifacts created during the session.

# Arguments
- `session_arn`: The ARN of a TestGridSession.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResult"`: The maximum number of results to be returned by a request.
- `"nextToken"`: Pagination token.
- `"type"`: Limit results to a specified type of artifact.
"""
function list_test_grid_session_artifacts(
    sessionArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "ListTestGridSessionArtifacts",
        Dict{String,Any}("sessionArn" => sessionArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_test_grid_session_artifacts(
    sessionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return device_farm(
        "ListTestGridSessionArtifacts",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("sessionArn" => sessionArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_test_grid_sessions(project_arn)
    list_test_grid_sessions(project_arn, params::Dict{String,<:Any})

Retrieves a list of sessions for a TestGridProject.

# Arguments
- `project_arn`: ARN of a TestGridProject.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"creationTimeAfter"`: Return only sessions created after this time.
- `"creationTimeBefore"`: Return only sessions created before this time.
- `"endTimeAfter"`: Return only sessions that ended after this time.
- `"endTimeBefore"`: Return only sessions that ended before this time.
- `"maxResult"`: Return only this many results at a time.
- `"nextToken"`: Pagination token.
- `"status"`: Return only sessions in this state.
"""
function list_test_grid_sessions(
    projectArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "ListTestGridSessions",
        Dict{String,Any}("projectArn" => projectArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_test_grid_sessions(
    projectArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return device_farm(
        "ListTestGridSessions",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("projectArn" => projectArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tests(arn)
    list_tests(arn, params::Dict{String,<:Any})

Gets information about tests in a given test suite.

# Arguments
- `arn`: The test suite's Amazon Resource Name (ARN).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: An identifier that was returned from the previous call to this operation,
  which can be used to return the next set of items in the list.
"""
function list_tests(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return device_farm(
        "ListTests",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tests(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "ListTests",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_unique_problems(arn)
    list_unique_problems(arn, params::Dict{String,<:Any})

Gets information about unique problems, such as exceptions or crashes. Unique problems are
defined as a single instance of an error across a run, job, or suite. For example, if a
call in your application consistently raises an exception (OutOfBoundsException in
MyActivity.java:386), ListUniqueProblems returns a single entry instead of many individual
entries for that exception.

# Arguments
- `arn`: The unique problems' ARNs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: An identifier that was returned from the previous call to this operation,
  which can be used to return the next set of items in the list.
"""
function list_unique_problems(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return device_farm(
        "ListUniqueProblems",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_unique_problems(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "ListUniqueProblems",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_uploads(arn)
    list_uploads(arn, params::Dict{String,<:Any})

Gets information about uploads, given an AWS Device Farm project ARN.

# Arguments
- `arn`: The Amazon Resource Name (ARN) of the project for which you want to list uploads.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: An identifier that was returned from the previous call to this operation,
  which can be used to return the next set of items in the list.
- `"type"`: The type of upload. Must be one of the following values:   ANDROID_APP
  IOS_APP   WEB_APP   EXTERNAL_DATA   APPIUM_JAVA_JUNIT_TEST_PACKAGE
  APPIUM_JAVA_TESTNG_TEST_PACKAGE   APPIUM_PYTHON_TEST_PACKAGE   APPIUM_NODE_TEST_PACKAGE
  APPIUM_RUBY_TEST_PACKAGE   APPIUM_WEB_JAVA_JUNIT_TEST_PACKAGE
  APPIUM_WEB_JAVA_TESTNG_TEST_PACKAGE   APPIUM_WEB_PYTHON_TEST_PACKAGE
  APPIUM_WEB_NODE_TEST_PACKAGE   APPIUM_WEB_RUBY_TEST_PACKAGE   CALABASH_TEST_PACKAGE
  INSTRUMENTATION_TEST_PACKAGE   UIAUTOMATION_TEST_PACKAGE   UIAUTOMATOR_TEST_PACKAGE
  XCTEST_TEST_PACKAGE   XCTEST_UI_TEST_PACKAGE   APPIUM_JAVA_JUNIT_TEST_SPEC
  APPIUM_JAVA_TESTNG_TEST_SPEC   APPIUM_PYTHON_TEST_SPEC   APPIUM_NODE_TEST_SPEC
  APPIUM_RUBY_TEST_SPEC   APPIUM_WEB_JAVA_JUNIT_TEST_SPEC   APPIUM_WEB_JAVA_TESTNG_TEST_SPEC
   APPIUM_WEB_PYTHON_TEST_SPEC   APPIUM_WEB_NODE_TEST_SPEC   APPIUM_WEB_RUBY_TEST_SPEC
  INSTRUMENTATION_TEST_SPEC   XCTEST_UI_TEST_SPEC
"""
function list_uploads(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return device_farm(
        "ListUploads",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_uploads(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "ListUploads",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_vpceconfigurations()
    list_vpceconfigurations(params::Dict{String,<:Any})

Returns information about all Amazon Virtual Private Cloud (VPC) endpoint configurations in
the AWS account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: An integer that specifies the maximum number of items you want to return
  in the API response.
- `"nextToken"`: An identifier that was returned from the previous call to this operation,
  which can be used to return the next set of items in the list.
"""
function list_vpceconfigurations(; aws_config::AbstractAWSConfig=current_aws_config())
    return device_farm(
        "ListVPCEConfigurations"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_vpceconfigurations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "ListVPCEConfigurations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    purchase_offering(offering_id, quantity)
    purchase_offering(offering_id, quantity, params::Dict{String,<:Any})

Immediately purchases offerings for an AWS account. Offerings renew with the latest total
purchased quantity for an offering, unless the renewal was overridden. The API returns a
NotEligible error if the user is not permitted to invoke the operation. If you must be able
to invoke this operation, contact aws-devicefarm-support@amazon.com.

# Arguments
- `offering_id`: The ID of the offering.
- `quantity`: The number of device slots to purchase in an offering request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"offeringPromotionId"`: The ID of the offering promotion to be applied to the purchase.
"""
function purchase_offering(
    offeringId, quantity; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "PurchaseOffering",
        Dict{String,Any}("offeringId" => offeringId, "quantity" => quantity);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function purchase_offering(
    offeringId,
    quantity,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return device_farm(
        "PurchaseOffering",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("offeringId" => offeringId, "quantity" => quantity),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    renew_offering(offering_id, quantity)
    renew_offering(offering_id, quantity, params::Dict{String,<:Any})

Explicitly sets the quantity of devices to renew for an offering, starting from the
effectiveDate of the next period. The API returns a NotEligible error if the user is not
permitted to invoke the operation. If you must be able to invoke this operation, contact
aws-devicefarm-support@amazon.com.

# Arguments
- `offering_id`: The ID of a request to renew an offering.
- `quantity`: The quantity requested in an offering renewal.

"""
function renew_offering(
    offeringId, quantity; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "RenewOffering",
        Dict{String,Any}("offeringId" => offeringId, "quantity" => quantity);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function renew_offering(
    offeringId,
    quantity,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return device_farm(
        "RenewOffering",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("offeringId" => offeringId, "quantity" => quantity),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    schedule_run(project_arn, test)
    schedule_run(project_arn, test, params::Dict{String,<:Any})

Schedules a run.

# Arguments
- `project_arn`: The ARN of the project for the run to be scheduled.
- `test`: Information about the test for the run to be scheduled.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"appArn"`: The ARN of an application package to run tests against, created with
  CreateUpload. See ListUploads.
- `"configuration"`: Information about the settings for the run to be scheduled.
- `"devicePoolArn"`: The ARN of the device pool for the run to be scheduled.
- `"deviceSelectionConfiguration"`: The filter criteria used to dynamically select a set of
  devices for a test run and the maximum number of devices to be included in the run. Either
  devicePoolArn  or  deviceSelectionConfiguration  is required in a request.
- `"executionConfiguration"`: Specifies configuration information about a test run, such as
  the execution timeout (in minutes).
- `"name"`: The name for the run to be scheduled.
"""
function schedule_run(projectArn, test; aws_config::AbstractAWSConfig=current_aws_config())
    return device_farm(
        "ScheduleRun",
        Dict{String,Any}("projectArn" => projectArn, "test" => test);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function schedule_run(
    projectArn,
    test,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return device_farm(
        "ScheduleRun",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("projectArn" => projectArn, "test" => test), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_job(arn)
    stop_job(arn, params::Dict{String,<:Any})

Initiates a stop request for the current job. AWS Device Farm immediately stops the job on
the device where tests have not started. You are not billed for this device. On the device
where tests have started, setup suite and teardown suite tests run to completion on the
device. You are billed for setup, teardown, and any tests that were in progress or already
completed.

# Arguments
- `arn`: Represents the Amazon Resource Name (ARN) of the Device Farm job to stop.

"""
function stop_job(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return device_farm(
        "StopJob",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_job(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "StopJob",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_remote_access_session(arn)
    stop_remote_access_session(arn, params::Dict{String,<:Any})

Ends a specified remote access session.

# Arguments
- `arn`: The Amazon Resource Name (ARN) of the remote access session to stop.

"""
function stop_remote_access_session(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return device_farm(
        "StopRemoteAccessSession",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_remote_access_session(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "StopRemoteAccessSession",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_run(arn)
    stop_run(arn, params::Dict{String,<:Any})

Initiates a stop request for the current test run. AWS Device Farm immediately stops the
run on devices where tests have not started. You are not billed for these devices. On
devices where tests have started executing, setup suite and teardown suite tests run to
completion on those devices. You are billed for setup, teardown, and any tests that were in
progress or already completed.

# Arguments
- `arn`: Represents the Amazon Resource Name (ARN) of the Device Farm run to stop.

"""
function stop_run(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return device_farm(
        "StopRun",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_run(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "StopRun",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Associates the specified tags to a resource with the specified resourceArn. If existing
tags on a resource are not specified in the request parameters, they are not changed. When
a resource is deleted, the tags associated with that resource are also deleted.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource or resources to which to
  add tags. You can associate tags with the following Device Farm resources: PROJECT, RUN,
  NETWORK_PROFILE, INSTANCE_PROFILE, DEVICE_INSTANCE, SESSION, DEVICE_POOL, DEVICE, and
  VPCE_CONFIGURATION.
- `tags`: The tags to add to the resource. A tag is an array of key-value pairs. Tag keys
  can have a maximum character length of 128 characters. Tag values can have a maximum length
  of 256 characters.

"""
function tag_resource(ResourceARN, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return device_farm(
        "TagResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceARN,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return device_farm(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Deletes the specified tags from a resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource or resources from which to
  delete tags. You can associate tags with the following Device Farm resources: PROJECT, RUN,
  NETWORK_PROFILE, INSTANCE_PROFILE, DEVICE_INSTANCE, SESSION, DEVICE_POOL, DEVICE, and
  VPCE_CONFIGURATION.
- `tag_keys`: The keys of the tags to be removed.

"""
function untag_resource(
    ResourceARN, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "UntagResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceARN,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return device_farm(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_device_instance(arn)
    update_device_instance(arn, params::Dict{String,<:Any})

Updates information about a private device instance.

# Arguments
- `arn`: The Amazon Resource Name (ARN) of the device instance.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"labels"`: An array of strings that you want to associate with the device instance.
- `"profileArn"`: The ARN of the profile that you want to associate with the device
  instance.
"""
function update_device_instance(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return device_farm(
        "UpdateDeviceInstance",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_device_instance(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "UpdateDeviceInstance",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_device_pool(arn)
    update_device_pool(arn, params::Dict{String,<:Any})

Modifies the name, description, and rules in a device pool given the attributes and the
pool ARN. Rule updates are all-or-nothing, meaning they can only be updated as a whole (or
not at all).

# Arguments
- `arn`: The Amazon Resource Name (ARN) of the Device Farm device pool to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clearMaxDevices"`: Sets whether the maxDevices parameter applies to your device pool.
  If you set this parameter to true, the maxDevices parameter does not apply, and Device Farm
  does not limit the number of devices that it adds to your device pool. In this case, Device
  Farm adds all available devices that meet the criteria specified in the rules parameter. If
  you use this parameter in your request, you cannot use the maxDevices parameter in the same
  request.
- `"description"`: A description of the device pool to update.
- `"maxDevices"`: The number of devices that Device Farm can add to your device pool.
  Device Farm adds devices that are available and that meet the criteria that you assign for
  the rules parameter. Depending on how many devices meet these constraints, your device pool
  might contain fewer devices than the value for this parameter. By specifying the maximum
  number of devices, you can control the costs that you incur by running tests. If you use
  this parameter in your request, you cannot use the clearMaxDevices parameter in the same
  request.
- `"name"`: A string that represents the name of the device pool to update.
- `"rules"`: Represents the rules to modify for the device pool. Updating rules is
  optional. If you update rules for your request, the update replaces the existing rules.
"""
function update_device_pool(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return device_farm(
        "UpdateDevicePool",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_device_pool(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "UpdateDevicePool",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_instance_profile(arn)
    update_instance_profile(arn, params::Dict{String,<:Any})

Updates information about an existing private device instance profile.

# Arguments
- `arn`: The Amazon Resource Name (ARN) of the instance profile.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The updated description for your instance profile.
- `"excludeAppPackagesFromCleanup"`: An array of strings that specifies the list of app
  packages that should not be cleaned up from the device after a test run is over. The list
  of packages is only considered if you set packageCleanup to true.
- `"name"`: The updated name for your instance profile.
- `"packageCleanup"`: The updated choice for whether you want to specify package cleanup.
  The default value is false for private devices.
- `"rebootAfterUse"`: The updated choice for whether you want to reboot the device after
  use. The default value is true.
"""
function update_instance_profile(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return device_farm(
        "UpdateInstanceProfile",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_instance_profile(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "UpdateInstanceProfile",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_network_profile(arn)
    update_network_profile(arn, params::Dict{String,<:Any})

Updates the network profile.

# Arguments
- `arn`: The Amazon Resource Name (ARN) of the project for which you want to update network
  profile settings.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description of the network profile about which you are returning
  information.
- `"downlinkBandwidthBits"`: The data throughput rate in bits per second, as an integer
  from 0 to 104857600.
- `"downlinkDelayMs"`: Delay time for all packets to destination in milliseconds as an
  integer from 0 to 2000.
- `"downlinkJitterMs"`: Time variation in the delay of received packets in milliseconds as
  an integer from 0 to 2000.
- `"downlinkLossPercent"`: Proportion of received packets that fail to arrive from 0 to 100
  percent.
- `"name"`: The name of the network profile about which you are returning information.
- `"type"`: The type of network profile to return information about. Valid values are
  listed here.
- `"uplinkBandwidthBits"`: The data throughput rate in bits per second, as an integer from
  0 to 104857600.
- `"uplinkDelayMs"`: Delay time for all packets to destination in milliseconds as an
  integer from 0 to 2000.
- `"uplinkJitterMs"`: Time variation in the delay of received packets in milliseconds as an
  integer from 0 to 2000.
- `"uplinkLossPercent"`: Proportion of transmitted packets that fail to arrive from 0 to
  100 percent.
"""
function update_network_profile(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return device_farm(
        "UpdateNetworkProfile",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_network_profile(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "UpdateNetworkProfile",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_project(arn)
    update_project(arn, params::Dict{String,<:Any})

Modifies the specified project name, given the project ARN and a new name.

# Arguments
- `arn`: The Amazon Resource Name (ARN) of the project whose name to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"defaultJobTimeoutMinutes"`: The number of minutes a test run in the project executes
  before it times out.
- `"name"`: A string that represents the new name of the project that you are updating.
- `"vpcConfig"`: The VPC security groups and subnets that are attached to a project.
"""
function update_project(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return device_farm(
        "UpdateProject",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_project(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "UpdateProject",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_test_grid_project(project_arn)
    update_test_grid_project(project_arn, params::Dict{String,<:Any})

Change details of a project.

# Arguments
- `project_arn`: ARN of the project to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: Human-readable description for the project.
- `"name"`: Human-readable name for the project.
- `"vpcConfig"`: The VPC security groups and subnets that are attached to a project.
"""
function update_test_grid_project(
    projectArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "UpdateTestGridProject",
        Dict{String,Any}("projectArn" => projectArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_test_grid_project(
    projectArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return device_farm(
        "UpdateTestGridProject",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("projectArn" => projectArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_upload(arn)
    update_upload(arn, params::Dict{String,<:Any})

Updates an uploaded test spec.

# Arguments
- `arn`: The Amazon Resource Name (ARN) of the uploaded test spec.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"contentType"`: The upload's content type (for example, application/x-yaml).
- `"editContent"`: Set to true if the YAML file has changed and must be updated. Otherwise,
  set to false.
- `"name"`: The upload's test spec file name. The name must not contain any forward slashes
  (/). The test spec file name must end with the .yaml or .yml file extension.
"""
function update_upload(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return device_farm(
        "UpdateUpload",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_upload(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "UpdateUpload",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_vpceconfiguration(arn)
    update_vpceconfiguration(arn, params::Dict{String,<:Any})

Updates information about an Amazon Virtual Private Cloud (VPC) endpoint configuration.

# Arguments
- `arn`: The Amazon Resource Name (ARN) of the VPC endpoint configuration you want to
  update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"serviceDnsName"`: The DNS (domain) name used to connect to your private service in your
  VPC. The DNS name must not already be in use on the internet.
- `"vpceConfigurationDescription"`: An optional description that provides details about
  your VPC endpoint configuration.
- `"vpceConfigurationName"`: The friendly name you give to your VPC endpoint configuration
  to manage your configurations more easily.
- `"vpceServiceName"`: The name of the VPC endpoint service running in your AWS account
  that you want Device Farm to test.
"""
function update_vpceconfiguration(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return device_farm(
        "UpdateVPCEConfiguration",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_vpceconfiguration(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return device_farm(
        "UpdateVPCEConfiguration",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: devops_guru
using AWS.Compat
using AWS.UUIDs

"""
    add_notification_channel(config)
    add_notification_channel(config, params::Dict{String,<:Any})

 Adds a notification channel to DevOps Guru. A notification channel is used to notify you
about important DevOps Guru events, such as when an insight is generated.  If you use an
Amazon SNS topic in another account, you must attach a policy to it that grants DevOps Guru
permission to send it notifications. DevOps Guru adds the required policy on your behalf to
send notifications using Amazon SNS in your account. DevOps Guru only supports standard SNS
topics. For more information, see Permissions for Amazon SNS topics. If you use an Amazon
SNS topic that is encrypted by an Amazon Web Services Key Management Service
customer-managed key (CMK), then you must add permissions to the CMK. For more information,
see Permissions for Amazon Web Services KMS–encrypted Amazon SNS topics.

# Arguments
- `config`:  A NotificationChannelConfig object that specifies what type of notification
  channel to add. The one supported notification channel is Amazon Simple Notification
  Service (Amazon SNS).

"""
function add_notification_channel(
    Config; aws_config::AbstractAWSConfig=current_aws_config()
)
    return devops_guru(
        "PUT",
        "/channels",
        Dict{String,Any}("Config" => Config);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_notification_channel(
    Config, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return devops_guru(
        "PUT",
        "/channels",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Config" => Config), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_insight(id)
    delete_insight(id, params::Dict{String,<:Any})

Deletes the insight along with the associated anomalies, events and recommendations.

# Arguments
- `id`: The ID of the insight.

"""
function delete_insight(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return devops_guru(
        "DELETE", "/insights/$(Id)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function delete_insight(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return devops_guru(
        "DELETE",
        "/insights/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_account_health()
    describe_account_health(params::Dict{String,<:Any})

 Returns the number of open reactive insights, the number of open proactive insights, and
the number of metrics analyzed in your Amazon Web Services account. Use these numbers to
gauge the health of operations in your Amazon Web Services account.

"""
function describe_account_health(; aws_config::AbstractAWSConfig=current_aws_config())
    return devops_guru(
        "GET", "/accounts/health"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_account_health(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return devops_guru(
        "GET",
        "/accounts/health",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_account_overview(from_time)
    describe_account_overview(from_time, params::Dict{String,<:Any})

 For the time range passed in, returns the number of open reactive insight that were
created, the number of open proactive insights that were created, and the Mean Time to
Recover (MTTR) for all closed reactive insights.

# Arguments
- `from_time`:  The start of the time range passed in. The start time granularity is at the
  day level. The floor of the start time is used. Returned information occurred after this
  day.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ToTime"`:  The end of the time range passed in. The start time granularity is at the
  day level. The floor of the start time is used. Returned information occurred before this
  day. If this is not specified, then the current day is used.
"""
function describe_account_overview(
    FromTime; aws_config::AbstractAWSConfig=current_aws_config()
)
    return devops_guru(
        "POST",
        "/accounts/overview",
        Dict{String,Any}("FromTime" => FromTime);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_account_overview(
    FromTime,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return devops_guru(
        "POST",
        "/accounts/overview",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("FromTime" => FromTime), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_anomaly(id)
    describe_anomaly(id, params::Dict{String,<:Any})

 Returns details about an anomaly that you specify using its ID.

# Arguments
- `id`:  The ID of the anomaly.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccountId"`: The ID of the member account.
"""
function describe_anomaly(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return devops_guru(
        "GET", "/anomalies/$(Id)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_anomaly(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return devops_guru(
        "GET",
        "/anomalies/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_event_sources_config()
    describe_event_sources_config(params::Dict{String,<:Any})

Returns the integration status of services that are integrated with DevOps Guru as Consumer
via EventBridge. The one service that can be integrated with DevOps Guru is Amazon CodeGuru
Profiler, which can produce proactive recommendations which can be stored and viewed in
DevOps Guru.

"""
function describe_event_sources_config(; aws_config::AbstractAWSConfig=current_aws_config())
    return devops_guru(
        "POST", "/event-sources"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_event_sources_config(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return devops_guru(
        "POST",
        "/event-sources",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_feedback()
    describe_feedback(params::Dict{String,<:Any})

 Returns the most recent feedback submitted in the current Amazon Web Services account and
Region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"InsightId"`:  The ID of the insight for which the feedback was provided.
"""
function describe_feedback(; aws_config::AbstractAWSConfig=current_aws_config())
    return devops_guru(
        "POST", "/feedback"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_feedback(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return devops_guru(
        "POST", "/feedback", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_insight(id)
    describe_insight(id, params::Dict{String,<:Any})

 Returns details about an insight that you specify using its ID.

# Arguments
- `id`:  The ID of the insight.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccountId"`: The ID of the member account in the organization.
"""
function describe_insight(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return devops_guru(
        "GET", "/insights/$(Id)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_insight(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return devops_guru(
        "GET",
        "/insights/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_organization_health()
    describe_organization_health(params::Dict{String,<:Any})

Returns active insights, predictive insights, and resource hours analyzed in last hour.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccountIds"`: The ID of the Amazon Web Services account.
- `"OrganizationalUnitIds"`: The ID of the organizational unit.
"""
function describe_organization_health(; aws_config::AbstractAWSConfig=current_aws_config())
    return devops_guru(
        "POST",
        "/organization/health";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_organization_health(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return devops_guru(
        "POST",
        "/organization/health",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_organization_overview(from_time)
    describe_organization_overview(from_time, params::Dict{String,<:Any})

Returns an overview of your organization's history based on the specified time range. The
overview includes the total reactive and proactive insights.

# Arguments
- `from_time`:  The start of the time range passed in. The start time granularity is at the
  day level. The floor of the start time is used. Returned information occurred after this
  day.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccountIds"`: The ID of the Amazon Web Services account.
- `"OrganizationalUnitIds"`: The ID of the organizational unit.
- `"ToTime"`:  The end of the time range passed in. The start time granularity is at the
  day level. The floor of the start time is used. Returned information occurred before this
  day. If this is not specified, then the current day is used.
"""
function describe_organization_overview(
    FromTime; aws_config::AbstractAWSConfig=current_aws_config()
)
    return devops_guru(
        "POST",
        "/organization/overview",
        Dict{String,Any}("FromTime" => FromTime);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_organization_overview(
    FromTime,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return devops_guru(
        "POST",
        "/organization/overview",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("FromTime" => FromTime), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_organization_resource_collection_health(organization_resource_collection_type)
    describe_organization_resource_collection_health(organization_resource_collection_type, params::Dict{String,<:Any})

Provides an overview of your system's health. If additional member accounts are part of
your organization, you can filter those accounts using the AccountIds field.

# Arguments
- `organization_resource_collection_type`:  An Amazon Web Services resource collection
  type. This type specifies how analyzed Amazon Web Services resources are defined. The two
  types of Amazon Web Services resource collections supported are Amazon Web Services
  CloudFormation stacks and Amazon Web Services resources that contain the same Amazon Web
  Services tag. DevOps Guru can be configured to analyze the Amazon Web Services resources
  that are defined in the stacks or that are tagged using the same tag key. You can specify
  up to 500 Amazon Web Services CloudFormation stacks.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccountIds"`: The ID of the Amazon Web Services account.
- `"MaxResults"`: The maximum number of results to return with a single call. To retrieve
  the remaining results, make another call with the returned nextToken value.
- `"NextToken"`: The pagination token to use to retrieve the next page of results for this
  operation. If this value is null, it retrieves the first page.
- `"OrganizationalUnitIds"`: The ID of the organizational unit.
"""
function describe_organization_resource_collection_health(
    OrganizationResourceCollectionType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return devops_guru(
        "POST",
        "/organization/health/resource-collection",
        Dict{String,Any}(
            "OrganizationResourceCollectionType" => OrganizationResourceCollectionType
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_organization_resource_collection_health(
    OrganizationResourceCollectionType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return devops_guru(
        "POST",
        "/organization/health/resource-collection",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "OrganizationResourceCollectionType" =>
                        OrganizationResourceCollectionType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_resource_collection_health(resource_collection_type)
    describe_resource_collection_health(resource_collection_type, params::Dict{String,<:Any})

 Returns the number of open proactive insights, open reactive insights, and the Mean Time
to Recover (MTTR) for all closed insights in resource collections in your account. You
specify the type of Amazon Web Services resources collection. The two types of Amazon Web
Services resource collections supported are Amazon Web Services CloudFormation stacks and
Amazon Web Services resources that contain the same Amazon Web Services tag. DevOps Guru
can be configured to analyze the Amazon Web Services resources that are defined in the
stacks or that are tagged using the same tag key. You can specify up to 500 Amazon Web
Services CloudFormation stacks.

# Arguments
- `resource_collection_type`:  An Amazon Web Services resource collection type. This type
  specifies how analyzed Amazon Web Services resources are defined. The two types of Amazon
  Web Services resource collections supported are Amazon Web Services CloudFormation stacks
  and Amazon Web Services resources that contain the same Amazon Web Services tag. DevOps
  Guru can be configured to analyze the Amazon Web Services resources that are defined in the
  stacks or that are tagged using the same tag key. You can specify up to 500 Amazon Web
  Services CloudFormation stacks.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: The pagination token to use to retrieve the next page of results for this
  operation. If this value is null, it retrieves the first page.
"""
function describe_resource_collection_health(
    ResourceCollectionType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return devops_guru(
        "GET",
        "/accounts/health/resource-collection/$(ResourceCollectionType)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_resource_collection_health(
    ResourceCollectionType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return devops_guru(
        "GET",
        "/accounts/health/resource-collection/$(ResourceCollectionType)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_service_integration()
    describe_service_integration(params::Dict{String,<:Any})

 Returns the integration status of services that are integrated with DevOps Guru. The one
service that can be integrated with DevOps Guru is Amazon Web Services Systems Manager,
which can be used to create an OpsItem for each generated insight.

"""
function describe_service_integration(; aws_config::AbstractAWSConfig=current_aws_config())
    return devops_guru(
        "GET",
        "/service-integrations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_service_integration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return devops_guru(
        "GET",
        "/service-integrations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_cost_estimation()
    get_cost_estimation(params::Dict{String,<:Any})

Returns an estimate of the monthly cost for DevOps Guru to analyze your Amazon Web Services
resources. For more information, see Estimate your Amazon DevOps Guru costs and Amazon
DevOps Guru pricing.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: The pagination token to use to retrieve the next page of results for this
  operation. If this value is null, it retrieves the first page.
"""
function get_cost_estimation(; aws_config::AbstractAWSConfig=current_aws_config())
    return devops_guru(
        "GET", "/cost-estimation"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_cost_estimation(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return devops_guru(
        "GET",
        "/cost-estimation",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_resource_collection(resource_collection_type)
    get_resource_collection(resource_collection_type, params::Dict{String,<:Any})

 Returns lists Amazon Web Services resources that are of the specified resource collection
type. The two types of Amazon Web Services resource collections supported are Amazon Web
Services CloudFormation stacks and Amazon Web Services resources that contain the same
Amazon Web Services tag. DevOps Guru can be configured to analyze the Amazon Web Services
resources that are defined in the stacks or that are tagged using the same tag key. You can
specify up to 500 Amazon Web Services CloudFormation stacks.

# Arguments
- `resource_collection_type`:  The type of Amazon Web Services resource collections to
  return. The one valid value is CLOUD_FORMATION for Amazon Web Services CloudFormation
  stacks.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: The pagination token to use to retrieve the next page of results for this
  operation. If this value is null, it retrieves the first page.
"""
function get_resource_collection(
    ResourceCollectionType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return devops_guru(
        "GET",
        "/resource-collections/$(ResourceCollectionType)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_resource_collection(
    ResourceCollectionType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return devops_guru(
        "GET",
        "/resource-collections/$(ResourceCollectionType)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_anomalies_for_insight(insight_id)
    list_anomalies_for_insight(insight_id, params::Dict{String,<:Any})

 Returns a list of the anomalies that belong to an insight that you specify using its ID.

# Arguments
- `insight_id`:  The ID of the insight. The returned anomalies belong to this insight.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccountId"`: The ID of the Amazon Web Services account.
- `"Filters"`:  Specifies one or more service names that are used to list anomalies.
- `"MaxResults"`: The maximum number of results to return with a single call. To retrieve
  the remaining results, make another call with the returned nextToken value.
- `"NextToken"`: The pagination token to use to retrieve the next page of results for this
  operation. If this value is null, it retrieves the first page.
- `"StartTimeRange"`:  A time range used to specify when the requested anomalies started.
  All returned anomalies started during this time range.
"""
function list_anomalies_for_insight(
    InsightId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return devops_guru(
        "POST",
        "/anomalies/insight/$(InsightId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_anomalies_for_insight(
    InsightId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return devops_guru(
        "POST",
        "/anomalies/insight/$(InsightId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_anomalous_log_groups(insight_id)
    list_anomalous_log_groups(insight_id, params::Dict{String,<:Any})

 Returns the list of log groups that contain log anomalies.

# Arguments
- `insight_id`:  The ID of the insight containing the log groups.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to return with a single call. To retrieve
  the remaining results, make another call with the returned nextToken value.
- `"NextToken"`: The pagination token to use to retrieve the next page of results for this
  operation. If this value is null, it retrieves the first page.
"""
function list_anomalous_log_groups(
    InsightId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return devops_guru(
        "POST",
        "/list-log-anomalies",
        Dict{String,Any}("InsightId" => InsightId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_anomalous_log_groups(
    InsightId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return devops_guru(
        "POST",
        "/list-log-anomalies",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("InsightId" => InsightId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_events(filters)
    list_events(filters, params::Dict{String,<:Any})

 Returns a list of the events emitted by the resources that are evaluated by DevOps Guru.
You can use filters to specify which events are returned.

# Arguments
- `filters`:  A ListEventsFilters object used to specify which events to return.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccountId"`: The ID of the Amazon Web Services account.
- `"MaxResults"`: The maximum number of results to return with a single call. To retrieve
  the remaining results, make another call with the returned nextToken value.
- `"NextToken"`: The pagination token to use to retrieve the next page of results for this
  operation. If this value is null, it retrieves the first page.
"""
function list_events(Filters; aws_config::AbstractAWSConfig=current_aws_config())
    return devops_guru(
        "POST",
        "/events",
        Dict{String,Any}("Filters" => Filters);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_events(
    Filters,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return devops_guru(
        "POST",
        "/events",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Filters" => Filters), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_insights(status_filter)
    list_insights(status_filter, params::Dict{String,<:Any})

 Returns a list of insights in your Amazon Web Services account. You can specify which
insights are returned by their start time and status (ONGOING, CLOSED, or ANY).

# Arguments
- `status_filter`:  A filter used to filter the returned insights by their status. You can
  specify one status filter.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to return with a single call. To retrieve
  the remaining results, make another call with the returned nextToken value.
- `"NextToken"`: The pagination token to use to retrieve the next page of results for this
  operation. If this value is null, it retrieves the first page.
"""
function list_insights(StatusFilter; aws_config::AbstractAWSConfig=current_aws_config())
    return devops_guru(
        "POST",
        "/insights",
        Dict{String,Any}("StatusFilter" => StatusFilter);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_insights(
    StatusFilter,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return devops_guru(
        "POST",
        "/insights",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("StatusFilter" => StatusFilter), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_monitored_resources()
    list_monitored_resources(params::Dict{String,<:Any})

 Returns the list of all log groups that are being monitored and tagged by DevOps Guru.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`:  Filters to determine which monitored resources you want to retrieve. You
  can filter by resource type or resource permission status.
- `"MaxResults"`: The maximum number of results to return with a single call. To retrieve
  the remaining results, make another call with the returned nextToken value.
- `"NextToken"`: The pagination token to use to retrieve the next page of results for this
  operation. If this value is null, it retrieves the first page.
"""
function list_monitored_resources(; aws_config::AbstractAWSConfig=current_aws_config())
    return devops_guru(
        "POST",
        "/monitoredResources";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_monitored_resources(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return devops_guru(
        "POST",
        "/monitoredResources",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_notification_channels()
    list_notification_channels(params::Dict{String,<:Any})

 Returns a list of notification channels configured for DevOps Guru. Each notification
channel is used to notify you when DevOps Guru generates an insight that contains
information about how to improve your operations. The one supported notification channel is
Amazon Simple Notification Service (Amazon SNS).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: The pagination token to use to retrieve the next page of results for this
  operation. If this value is null, it retrieves the first page.
"""
function list_notification_channels(; aws_config::AbstractAWSConfig=current_aws_config())
    return devops_guru(
        "POST", "/channels"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_notification_channels(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return devops_guru(
        "POST", "/channels", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_organization_insights(status_filter)
    list_organization_insights(status_filter, params::Dict{String,<:Any})

Returns a list of insights associated with the account or OU Id.

# Arguments
- `status_filter`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccountIds"`: The ID of the Amazon Web Services account.
- `"MaxResults"`: The maximum number of results to return with a single call. To retrieve
  the remaining results, make another call with the returned nextToken value.
- `"NextToken"`: The pagination token to use to retrieve the next page of results for this
  operation. If this value is null, it retrieves the first page.
- `"OrganizationalUnitIds"`: The ID of the organizational unit.
"""
function list_organization_insights(
    StatusFilter; aws_config::AbstractAWSConfig=current_aws_config()
)
    return devops_guru(
        "POST",
        "/organization/insights",
        Dict{String,Any}("StatusFilter" => StatusFilter);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_organization_insights(
    StatusFilter,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return devops_guru(
        "POST",
        "/organization/insights",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("StatusFilter" => StatusFilter), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_recommendations(insight_id)
    list_recommendations(insight_id, params::Dict{String,<:Any})

 Returns a list of a specified insight's recommendations. Each recommendation includes a
list of related metrics and a list of related events.

# Arguments
- `insight_id`:  The ID of the requested insight.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccountId"`: The ID of the Amazon Web Services account.
- `"Locale"`: A locale that specifies the language to use for recommendations.
- `"NextToken"`: The pagination token to use to retrieve the next page of results for this
  operation. If this value is null, it retrieves the first page.
"""
function list_recommendations(InsightId; aws_config::AbstractAWSConfig=current_aws_config())
    return devops_guru(
        "POST",
        "/recommendations",
        Dict{String,Any}("InsightId" => InsightId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_recommendations(
    InsightId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return devops_guru(
        "POST",
        "/recommendations",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("InsightId" => InsightId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_feedback()
    put_feedback(params::Dict{String,<:Any})

 Collects customer feedback about the specified insight.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"InsightFeedback"`:  The feedback from customers is about the recommendations in this
  insight.
"""
function put_feedback(; aws_config::AbstractAWSConfig=current_aws_config())
    return devops_guru(
        "PUT", "/feedback"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function put_feedback(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return devops_guru(
        "PUT", "/feedback", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    remove_notification_channel(id)
    remove_notification_channel(id, params::Dict{String,<:Any})

 Removes a notification channel from DevOps Guru. A notification channel is used to notify
you when DevOps Guru generates an insight that contains information about how to improve
your operations.

# Arguments
- `id`:  The ID of the notification channel to be removed.

"""
function remove_notification_channel(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return devops_guru(
        "DELETE", "/channels/$(Id)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function remove_notification_channel(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return devops_guru(
        "DELETE",
        "/channels/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    search_insights(start_time_range, type)
    search_insights(start_time_range, type, params::Dict{String,<:Any})

 Returns a list of insights in your Amazon Web Services account. You can specify which
insights are returned by their start time, one or more statuses (ONGOING or CLOSED), one or
more severities (LOW, MEDIUM, and HIGH), and type (REACTIVE or PROACTIVE).   Use the
Filters parameter to specify status and severity search parameters. Use the Type parameter
to specify REACTIVE or PROACTIVE in your search.

# Arguments
- `start_time_range`:  The start of the time range passed in. Returned insights occurred
  after this time.
- `type`:  The type of insights you are searching for (REACTIVE or PROACTIVE).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`:  A SearchInsightsFilters object that is used to set the severity and status
  filters on your insight search.
- `"MaxResults"`: The maximum number of results to return with a single call. To retrieve
  the remaining results, make another call with the returned nextToken value.
- `"NextToken"`: The pagination token to use to retrieve the next page of results for this
  operation. If this value is null, it retrieves the first page.
"""
function search_insights(
    StartTimeRange, Type; aws_config::AbstractAWSConfig=current_aws_config()
)
    return devops_guru(
        "POST",
        "/insights/search",
        Dict{String,Any}("StartTimeRange" => StartTimeRange, "Type" => Type);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function search_insights(
    StartTimeRange,
    Type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return devops_guru(
        "POST",
        "/insights/search",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("StartTimeRange" => StartTimeRange, "Type" => Type),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    search_organization_insights(account_ids, start_time_range, type)
    search_organization_insights(account_ids, start_time_range, type, params::Dict{String,<:Any})

 Returns a list of insights in your organization. You can specify which insights are
returned by their start time, one or more statuses (ONGOING, CLOSED, and CLOSED), one or
more severities (LOW, MEDIUM, and HIGH), and type (REACTIVE or PROACTIVE).   Use the
Filters parameter to specify status and severity search parameters. Use the Type parameter
to specify REACTIVE or PROACTIVE in your search.

# Arguments
- `account_ids`: The ID of the Amazon Web Services account.
- `start_time_range`:
- `type`:  The type of insights you are searching for (REACTIVE or PROACTIVE).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`:  A SearchOrganizationInsightsFilters object that is used to set the severity
  and status filters on your insight search.
- `"MaxResults"`: The maximum number of results to return with a single call. To retrieve
  the remaining results, make another call with the returned nextToken value.
- `"NextToken"`: The pagination token to use to retrieve the next page of results for this
  operation. If this value is null, it retrieves the first page.
"""
function search_organization_insights(
    AccountIds, StartTimeRange, Type; aws_config::AbstractAWSConfig=current_aws_config()
)
    return devops_guru(
        "POST",
        "/organization/insights/search",
        Dict{String,Any}(
            "AccountIds" => AccountIds, "StartTimeRange" => StartTimeRange, "Type" => Type
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function search_organization_insights(
    AccountIds,
    StartTimeRange,
    Type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return devops_guru(
        "POST",
        "/organization/insights/search",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AccountIds" => AccountIds,
                    "StartTimeRange" => StartTimeRange,
                    "Type" => Type,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_cost_estimation(resource_collection)
    start_cost_estimation(resource_collection, params::Dict{String,<:Any})

Starts the creation of an estimate of the monthly cost to analyze your Amazon Web Services
resources.

# Arguments
- `resource_collection`: The collection of Amazon Web Services resources used to create a
  monthly DevOps Guru cost estimate.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: The idempotency token used to identify each cost estimate request.
"""
function start_cost_estimation(
    ResourceCollection; aws_config::AbstractAWSConfig=current_aws_config()
)
    return devops_guru(
        "PUT",
        "/cost-estimation",
        Dict{String,Any}(
            "ResourceCollection" => ResourceCollection, "ClientToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_cost_estimation(
    ResourceCollection,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return devops_guru(
        "PUT",
        "/cost-estimation",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ResourceCollection" => ResourceCollection,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_event_sources_config()
    update_event_sources_config(params::Dict{String,<:Any})

Enables or disables integration with a service that can be integrated with DevOps Guru. The
one service that can be integrated with DevOps Guru is Amazon CodeGuru Profiler, which can
produce proactive recommendations which can be stored and viewed in DevOps Guru.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EventSources"`: Configuration information about the integration of DevOps Guru as the
  Consumer via EventBridge with another AWS Service.
"""
function update_event_sources_config(; aws_config::AbstractAWSConfig=current_aws_config())
    return devops_guru(
        "PUT", "/event-sources"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function update_event_sources_config(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return devops_guru(
        "PUT",
        "/event-sources",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_resource_collection(action, resource_collection)
    update_resource_collection(action, resource_collection, params::Dict{String,<:Any})

 Updates the collection of resources that DevOps Guru analyzes. The two types of Amazon Web
Services resource collections supported are Amazon Web Services CloudFormation stacks and
Amazon Web Services resources that contain the same Amazon Web Services tag. DevOps Guru
can be configured to analyze the Amazon Web Services resources that are defined in the
stacks or that are tagged using the same tag key. You can specify up to 500 Amazon Web
Services CloudFormation stacks. This method also creates the IAM role required for you to
use DevOps Guru.

# Arguments
- `action`:  Specifies if the resource collection in the request is added or deleted to the
  resource collection.
- `resource_collection`:

"""
function update_resource_collection(
    Action, ResourceCollection; aws_config::AbstractAWSConfig=current_aws_config()
)
    return devops_guru(
        "PUT",
        "/resource-collections",
        Dict{String,Any}("Action" => Action, "ResourceCollection" => ResourceCollection);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_resource_collection(
    Action,
    ResourceCollection,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return devops_guru(
        "PUT",
        "/resource-collections",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Action" => Action, "ResourceCollection" => ResourceCollection
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_service_integration(service_integration)
    update_service_integration(service_integration, params::Dict{String,<:Any})

 Enables or disables integration with a service that can be integrated with DevOps Guru.
The one service that can be integrated with DevOps Guru is Amazon Web Services Systems
Manager, which can be used to create an OpsItem for each generated insight.

# Arguments
- `service_integration`:  An IntegratedServiceConfig object used to specify the integrated
  service you want to update, and whether you want to update it to enabled or disabled.

"""
function update_service_integration(
    ServiceIntegration; aws_config::AbstractAWSConfig=current_aws_config()
)
    return devops_guru(
        "PUT",
        "/service-integrations",
        Dict{String,Any}("ServiceIntegration" => ServiceIntegration);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_service_integration(
    ServiceIntegration,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return devops_guru(
        "PUT",
        "/service-integrations",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ServiceIntegration" => ServiceIntegration), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: license_manager
using AWS.Compat
using AWS.UUIDs

"""
    accept_grant(grant_arn)
    accept_grant(grant_arn, params::Dict{String,<:Any})

Accepts the specified grant.

# Arguments
- `grant_arn`: Amazon Resource Name (ARN) of the grant.

"""
function accept_grant(GrantArn; aws_config::AbstractAWSConfig=current_aws_config())
    return license_manager(
        "AcceptGrant",
        Dict{String,Any}("GrantArn" => GrantArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function accept_grant(
    GrantArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager(
        "AcceptGrant",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("GrantArn" => GrantArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    check_in_license(license_consumption_token)
    check_in_license(license_consumption_token, params::Dict{String,<:Any})

Checks in the specified license. Check in a license when it is no longer in use.

# Arguments
- `license_consumption_token`: License consumption token.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Beneficiary"`: License beneficiary.
"""
function check_in_license(
    LicenseConsumptionToken; aws_config::AbstractAWSConfig=current_aws_config()
)
    return license_manager(
        "CheckInLicense",
        Dict{String,Any}("LicenseConsumptionToken" => LicenseConsumptionToken);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function check_in_license(
    LicenseConsumptionToken,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager(
        "CheckInLicense",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("LicenseConsumptionToken" => LicenseConsumptionToken),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    checkout_borrow_license(client_token, digital_signature_method, entitlements, license_arn)
    checkout_borrow_license(client_token, digital_signature_method, entitlements, license_arn, params::Dict{String,<:Any})

Checks out the specified license for offline use.

# Arguments
- `client_token`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request.
- `digital_signature_method`: Digital signature method. The possible value is JSON Web
  Signature (JWS) algorithm PS384. For more information, see RFC 7518 Digital Signature with
  RSASSA-PSS.
- `entitlements`: License entitlements. Partial checkouts are not supported.
- `license_arn`: Amazon Resource Name (ARN) of the license. The license must use the borrow
  consumption configuration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CheckoutMetadata"`: Information about constraints.
- `"NodeId"`: Node ID.
"""
function checkout_borrow_license(
    ClientToken,
    DigitalSignatureMethod,
    Entitlements,
    LicenseArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager(
        "CheckoutBorrowLicense",
        Dict{String,Any}(
            "ClientToken" => ClientToken,
            "DigitalSignatureMethod" => DigitalSignatureMethod,
            "Entitlements" => Entitlements,
            "LicenseArn" => LicenseArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function checkout_borrow_license(
    ClientToken,
    DigitalSignatureMethod,
    Entitlements,
    LicenseArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager(
        "CheckoutBorrowLicense",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClientToken" => ClientToken,
                    "DigitalSignatureMethod" => DigitalSignatureMethod,
                    "Entitlements" => Entitlements,
                    "LicenseArn" => LicenseArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    checkout_license(checkout_type, client_token, entitlements, key_fingerprint, product_sku)
    checkout_license(checkout_type, client_token, entitlements, key_fingerprint, product_sku, params::Dict{String,<:Any})

Checks out the specified license.  If the account that created the license is the same that
is performing the check out, you must specify the account as the beneficiary.

# Arguments
- `checkout_type`: Checkout type.
- `client_token`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request.
- `entitlements`: License entitlements.
- `key_fingerprint`: Key fingerprint identifying the license.
- `product_sku`: Product SKU.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Beneficiary"`: License beneficiary.
- `"NodeId"`: Node ID.
"""
function checkout_license(
    CheckoutType,
    ClientToken,
    Entitlements,
    KeyFingerprint,
    ProductSKU;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager(
        "CheckoutLicense",
        Dict{String,Any}(
            "CheckoutType" => CheckoutType,
            "ClientToken" => ClientToken,
            "Entitlements" => Entitlements,
            "KeyFingerprint" => KeyFingerprint,
            "ProductSKU" => ProductSKU,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function checkout_license(
    CheckoutType,
    ClientToken,
    Entitlements,
    KeyFingerprint,
    ProductSKU,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager(
        "CheckoutLicense",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CheckoutType" => CheckoutType,
                    "ClientToken" => ClientToken,
                    "Entitlements" => Entitlements,
                    "KeyFingerprint" => KeyFingerprint,
                    "ProductSKU" => ProductSKU,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_grant(allowed_operations, client_token, grant_name, home_region, license_arn, principals)
    create_grant(allowed_operations, client_token, grant_name, home_region, license_arn, principals, params::Dict{String,<:Any})

Creates a grant for the specified license. A grant shares the use of license entitlements
with a specific Amazon Web Services account, an organization, or an organizational unit
(OU). For more information, see Granted licenses in License Manager in the License Manager
User Guide.

# Arguments
- `allowed_operations`: Allowed operations for the grant.
- `client_token`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request.
- `grant_name`: Grant name.
- `home_region`: Home Region of the grant.
- `license_arn`: Amazon Resource Name (ARN) of the license.
- `principals`: The grant principals. You can specify one of the following as an Amazon
  Resource Name (ARN):   An Amazon Web Services account, which includes only the account
  specified.     An organizational unit (OU), which includes all accounts in the OU.     An
  organization, which will include all accounts across your organization.

"""
function create_grant(
    AllowedOperations,
    ClientToken,
    GrantName,
    HomeRegion,
    LicenseArn,
    Principals;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager(
        "CreateGrant",
        Dict{String,Any}(
            "AllowedOperations" => AllowedOperations,
            "ClientToken" => ClientToken,
            "GrantName" => GrantName,
            "HomeRegion" => HomeRegion,
            "LicenseArn" => LicenseArn,
            "Principals" => Principals,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_grant(
    AllowedOperations,
    ClientToken,
    GrantName,
    HomeRegion,
    LicenseArn,
    Principals,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager(
        "CreateGrant",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AllowedOperations" => AllowedOperations,
                    "ClientToken" => ClientToken,
                    "GrantName" => GrantName,
                    "HomeRegion" => HomeRegion,
                    "LicenseArn" => LicenseArn,
                    "Principals" => Principals,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_grant_version(client_token, grant_arn)
    create_grant_version(client_token, grant_arn, params::Dict{String,<:Any})

Creates a new version of the specified grant. For more information, see Granted licenses in
License Manager in the License Manager User Guide.

# Arguments
- `client_token`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request.
- `grant_arn`: Amazon Resource Name (ARN) of the grant.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AllowedOperations"`: Allowed operations for the grant.
- `"GrantName"`: Grant name.
- `"Options"`: The options specified for the grant.
- `"SourceVersion"`: Current version of the grant.
- `"Status"`: Grant status.
- `"StatusReason"`: Grant status reason.
"""
function create_grant_version(
    ClientToken, GrantArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return license_manager(
        "CreateGrantVersion",
        Dict{String,Any}("ClientToken" => ClientToken, "GrantArn" => GrantArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_grant_version(
    ClientToken,
    GrantArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager(
        "CreateGrantVersion",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ClientToken" => ClientToken, "GrantArn" => GrantArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_license(beneficiary, client_token, consumption_configuration, entitlements, home_region, issuer, license_name, product_name, product_sku, validity)
    create_license(beneficiary, client_token, consumption_configuration, entitlements, home_region, issuer, license_name, product_name, product_sku, validity, params::Dict{String,<:Any})

Creates a license.

# Arguments
- `beneficiary`: License beneficiary.
- `client_token`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request.
- `consumption_configuration`: Configuration for consumption of the license. Choose a
  provisional configuration for workloads running with continuous connectivity. Choose a
  borrow configuration for workloads with offline usage.
- `entitlements`: License entitlements.
- `home_region`: Home Region for the license.
- `issuer`: License issuer.
- `license_name`: License name.
- `product_name`: Product name.
- `product_sku`: Product SKU.
- `validity`: Date and time range during which the license is valid, in ISO8601-UTC format.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"LicenseMetadata"`: Information about the license.
"""
function create_license(
    Beneficiary,
    ClientToken,
    ConsumptionConfiguration,
    Entitlements,
    HomeRegion,
    Issuer,
    LicenseName,
    ProductName,
    ProductSKU,
    Validity;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager(
        "CreateLicense",
        Dict{String,Any}(
            "Beneficiary" => Beneficiary,
            "ClientToken" => ClientToken,
            "ConsumptionConfiguration" => ConsumptionConfiguration,
            "Entitlements" => Entitlements,
            "HomeRegion" => HomeRegion,
            "Issuer" => Issuer,
            "LicenseName" => LicenseName,
            "ProductName" => ProductName,
            "ProductSKU" => ProductSKU,
            "Validity" => Validity,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_license(
    Beneficiary,
    ClientToken,
    ConsumptionConfiguration,
    Entitlements,
    HomeRegion,
    Issuer,
    LicenseName,
    ProductName,
    ProductSKU,
    Validity,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager(
        "CreateLicense",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Beneficiary" => Beneficiary,
                    "ClientToken" => ClientToken,
                    "ConsumptionConfiguration" => ConsumptionConfiguration,
                    "Entitlements" => Entitlements,
                    "HomeRegion" => HomeRegion,
                    "Issuer" => Issuer,
                    "LicenseName" => LicenseName,
                    "ProductName" => ProductName,
                    "ProductSKU" => ProductSKU,
                    "Validity" => Validity,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_license_configuration(license_counting_type, name)
    create_license_configuration(license_counting_type, name, params::Dict{String,<:Any})

Creates a license configuration. A license configuration is an abstraction of a customer
license agreement that can be consumed and enforced by License Manager. Components include
specifications for the license type (licensing by instance, socket, CPU, or vCPU), allowed
tenancy (shared tenancy, Dedicated Instance, Dedicated Host, or all of these), license
affinity to host (how long a license must be associated with a host), and the number of
licenses purchased and used.

# Arguments
- `license_counting_type`: Dimension used to track the license inventory.
- `name`: Name of the license configuration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: Description of the license configuration.
- `"DisassociateWhenNotFound"`: When true, disassociates a resource when software is
  uninstalled.
- `"LicenseCount"`: Number of licenses managed by the license configuration.
- `"LicenseCountHardLimit"`: Indicates whether hard or soft license enforcement is used.
  Exceeding a hard limit blocks the launch of new instances.
- `"LicenseRules"`: License rules. The syntax is #name=value (for example,
  #allowedTenancy=EC2-DedicatedHost). The available rules vary by dimension, as follows.
  Cores dimension: allowedTenancy | licenseAffinityToHost | maximumCores | minimumCores
  Instances dimension: allowedTenancy | maximumCores | minimumCores | maximumSockets |
  minimumSockets | maximumVcpus | minimumVcpus     Sockets dimension: allowedTenancy |
  licenseAffinityToHost | maximumSockets | minimumSockets     vCPUs dimension: allowedTenancy
  | honorVcpuOptimization | maximumVcpus | minimumVcpus    The unit for licenseAffinityToHost
  is days and the range is 1 to 180. The possible values for allowedTenancy are EC2-Default,
  EC2-DedicatedHost, and EC2-DedicatedInstance. The possible values for honorVcpuOptimization
  are True and False.
- `"ProductInformationList"`: Product information.
- `"Tags"`: Tags to add to the license configuration.
"""
function create_license_configuration(
    LicenseCountingType, Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return license_manager(
        "CreateLicenseConfiguration",
        Dict{String,Any}("LicenseCountingType" => LicenseCountingType, "Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_license_configuration(
    LicenseCountingType,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager(
        "CreateLicenseConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "LicenseCountingType" => LicenseCountingType, "Name" => Name
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_license_conversion_task_for_resource(destination_license_context, resource_arn, source_license_context)
    create_license_conversion_task_for_resource(destination_license_context, resource_arn, source_license_context, params::Dict{String,<:Any})

Creates a new license conversion task.

# Arguments
- `destination_license_context`: Information that identifies the license type you are
  converting to. For the structure of the destination license, see Convert a license type
  using the CLI  in the License Manager User Guide.
- `resource_arn`: Amazon Resource Name (ARN) of the resource you are converting the license
  type for.
- `source_license_context`: Information that identifies the license type you are converting
  from. For the structure of the source license, see Convert a license type using the CLI  in
  the License Manager User Guide.

"""
function create_license_conversion_task_for_resource(
    DestinationLicenseContext,
    ResourceArn,
    SourceLicenseContext;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager(
        "CreateLicenseConversionTaskForResource",
        Dict{String,Any}(
            "DestinationLicenseContext" => DestinationLicenseContext,
            "ResourceArn" => ResourceArn,
            "SourceLicenseContext" => SourceLicenseContext,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_license_conversion_task_for_resource(
    DestinationLicenseContext,
    ResourceArn,
    SourceLicenseContext,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager(
        "CreateLicenseConversionTaskForResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DestinationLicenseContext" => DestinationLicenseContext,
                    "ResourceArn" => ResourceArn,
                    "SourceLicenseContext" => SourceLicenseContext,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_license_manager_report_generator(client_token, report_context, report_frequency, report_generator_name, type)
    create_license_manager_report_generator(client_token, report_context, report_frequency, report_generator_name, type, params::Dict{String,<:Any})

Creates a report generator.

# Arguments
- `client_token`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request.
- `report_context`: Defines the type of license configuration the report generator tracks.
- `report_frequency`: Frequency by which reports are generated. Reports can be generated
  daily, monthly, or weekly.
- `report_generator_name`: Name of the report generator.
- `type`: Type of reports to generate. The following report types an be generated:
  License configuration report - Reports the number and details of consumed licenses for a
  license configuration.   Resource report - Reports the tracked licenses and resource
  consumption for a license configuration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: Description of the report generator.
- `"Tags"`: Tags to add to the report generator.
"""
function create_license_manager_report_generator(
    ClientToken,
    ReportContext,
    ReportFrequency,
    ReportGeneratorName,
    Type;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager(
        "CreateLicenseManagerReportGenerator",
        Dict{String,Any}(
            "ClientToken" => ClientToken,
            "ReportContext" => ReportContext,
            "ReportFrequency" => ReportFrequency,
            "ReportGeneratorName" => ReportGeneratorName,
            "Type" => Type,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_license_manager_report_generator(
    ClientToken,
    ReportContext,
    ReportFrequency,
    ReportGeneratorName,
    Type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager(
        "CreateLicenseManagerReportGenerator",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClientToken" => ClientToken,
                    "ReportContext" => ReportContext,
                    "ReportFrequency" => ReportFrequency,
                    "ReportGeneratorName" => ReportGeneratorName,
                    "Type" => Type,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_license_version(client_token, consumption_configuration, entitlements, home_region, issuer, license_arn, license_name, product_name, status, validity)
    create_license_version(client_token, consumption_configuration, entitlements, home_region, issuer, license_arn, license_name, product_name, status, validity, params::Dict{String,<:Any})

Creates a new version of the specified license.

# Arguments
- `client_token`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request.
- `consumption_configuration`: Configuration for consumption of the license. Choose a
  provisional configuration for workloads running with continuous connectivity. Choose a
  borrow configuration for workloads with offline usage.
- `entitlements`: License entitlements.
- `home_region`: Home Region of the license.
- `issuer`: License issuer.
- `license_arn`: Amazon Resource Name (ARN) of the license.
- `license_name`: License name.
- `product_name`: Product name.
- `status`: License status.
- `validity`: Date and time range during which the license is valid, in ISO8601-UTC format.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"LicenseMetadata"`: Information about the license.
- `"SourceVersion"`: Current version of the license.
"""
function create_license_version(
    ClientToken,
    ConsumptionConfiguration,
    Entitlements,
    HomeRegion,
    Issuer,
    LicenseArn,
    LicenseName,
    ProductName,
    Status,
    Validity;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager(
        "CreateLicenseVersion",
        Dict{String,Any}(
            "ClientToken" => ClientToken,
            "ConsumptionConfiguration" => ConsumptionConfiguration,
            "Entitlements" => Entitlements,
            "HomeRegion" => HomeRegion,
            "Issuer" => Issuer,
            "LicenseArn" => LicenseArn,
            "LicenseName" => LicenseName,
            "ProductName" => ProductName,
            "Status" => Status,
            "Validity" => Validity,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_license_version(
    ClientToken,
    ConsumptionConfiguration,
    Entitlements,
    HomeRegion,
    Issuer,
    LicenseArn,
    LicenseName,
    ProductName,
    Status,
    Validity,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager(
        "CreateLicenseVersion",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClientToken" => ClientToken,
                    "ConsumptionConfiguration" => ConsumptionConfiguration,
                    "Entitlements" => Entitlements,
                    "HomeRegion" => HomeRegion,
                    "Issuer" => Issuer,
                    "LicenseArn" => LicenseArn,
                    "LicenseName" => LicenseName,
                    "ProductName" => ProductName,
                    "Status" => Status,
                    "Validity" => Validity,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_token(client_token, license_arn)
    create_token(client_token, license_arn, params::Dict{String,<:Any})

Creates a long-lived token. A refresh token is a JWT token used to get an access token.
With an access token, you can call AssumeRoleWithWebIdentity to get role credentials that
you can use to call License Manager to manage the specified license.

# Arguments
- `client_token`: Idempotency token, valid for 10 minutes.
- `license_arn`: Amazon Resource Name (ARN) of the license. The ARN is mapped to the aud
  claim of the JWT token.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ExpirationInDays"`: Token expiration, in days, counted from token creation. The default
  is 365 days.
- `"RoleArns"`: Amazon Resource Name (ARN) of the IAM roles to embed in the token. License
  Manager does not check whether the roles are in use.
- `"TokenProperties"`: Data specified by the caller to be included in the JWT token. The
  data is mapped to the amr claim of the JWT token.
"""
function create_token(
    ClientToken, LicenseArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return license_manager(
        "CreateToken",
        Dict{String,Any}("ClientToken" => ClientToken, "LicenseArn" => LicenseArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_token(
    ClientToken,
    LicenseArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager(
        "CreateToken",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ClientToken" => ClientToken, "LicenseArn" => LicenseArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_grant(grant_arn, version)
    delete_grant(grant_arn, version, params::Dict{String,<:Any})

Deletes the specified grant.

# Arguments
- `grant_arn`: Amazon Resource Name (ARN) of the grant.
- `version`: Current version of the grant.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"StatusReason"`: The Status reason for the delete request.
"""
function delete_grant(GrantArn, Version; aws_config::AbstractAWSConfig=current_aws_config())
    return license_manager(
        "DeleteGrant",
        Dict{String,Any}("GrantArn" => GrantArn, "Version" => Version);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_grant(
    GrantArn,
    Version,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager(
        "DeleteGrant",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("GrantArn" => GrantArn, "Version" => Version),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_license(license_arn, source_version)
    delete_license(license_arn, source_version, params::Dict{String,<:Any})

Deletes the specified license.

# Arguments
- `license_arn`: Amazon Resource Name (ARN) of the license.
- `source_version`: Current version of the license.

"""
function delete_license(
    LicenseArn, SourceVersion; aws_config::AbstractAWSConfig=current_aws_config()
)
    return license_manager(
        "DeleteLicense",
        Dict{String,Any}("LicenseArn" => LicenseArn, "SourceVersion" => SourceVersion);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_license(
    LicenseArn,
    SourceVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager(
        "DeleteLicense",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "LicenseArn" => LicenseArn, "SourceVersion" => SourceVersion
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_license_configuration(license_configuration_arn)
    delete_license_configuration(license_configuration_arn, params::Dict{String,<:Any})

Deletes the specified license configuration. You cannot delete a license configuration that
is in use.

# Arguments
- `license_configuration_arn`: ID of the license configuration.

"""
function delete_license_configuration(
    LicenseConfigurationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return license_manager(
        "DeleteLicenseConfiguration",
        Dict{String,Any}("LicenseConfigurationArn" => LicenseConfigurationArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_license_configuration(
    LicenseConfigurationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager(
        "DeleteLicenseConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("LicenseConfigurationArn" => LicenseConfigurationArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_license_manager_report_generator(license_manager_report_generator_arn)
    delete_license_manager_report_generator(license_manager_report_generator_arn, params::Dict{String,<:Any})

Deletes the specified report generator. This action deletes the report generator, which
stops it from generating future reports. The action cannot be reversed. It has no effect on
the previous reports from this generator.

# Arguments
- `license_manager_report_generator_arn`: Amazon Resource Name (ARN) of the report
  generator to be deleted.

"""
function delete_license_manager_report_generator(
    LicenseManagerReportGeneratorArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return license_manager(
        "DeleteLicenseManagerReportGenerator",
        Dict{String,Any}(
            "LicenseManagerReportGeneratorArn" => LicenseManagerReportGeneratorArn
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_license_manager_report_generator(
    LicenseManagerReportGeneratorArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager(
        "DeleteLicenseManagerReportGenerator",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "LicenseManagerReportGeneratorArn" => LicenseManagerReportGeneratorArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_token(token_id)
    delete_token(token_id, params::Dict{String,<:Any})

Deletes the specified token. Must be called in the license home Region.

# Arguments
- `token_id`: Token ID.

"""
function delete_token(TokenId; aws_config::AbstractAWSConfig=current_aws_config())
    return license_manager(
        "DeleteToken",
        Dict{String,Any}("TokenId" => TokenId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_token(
    TokenId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager(
        "DeleteToken",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("TokenId" => TokenId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    extend_license_consumption(license_consumption_token)
    extend_license_consumption(license_consumption_token, params::Dict{String,<:Any})

Extends the expiration date for license consumption.

# Arguments
- `license_consumption_token`: License consumption token.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DryRun"`: Checks whether you have the required permissions for the action, without
  actually making the request. Provides an error response if you do not have the required
  permissions.
"""
function extend_license_consumption(
    LicenseConsumptionToken; aws_config::AbstractAWSConfig=current_aws_config()
)
    return license_manager(
        "ExtendLicenseConsumption",
        Dict{String,Any}("LicenseConsumptionToken" => LicenseConsumptionToken);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function extend_license_consumption(
    LicenseConsumptionToken,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager(
        "ExtendLicenseConsumption",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("LicenseConsumptionToken" => LicenseConsumptionToken),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_access_token(token)
    get_access_token(token, params::Dict{String,<:Any})

Gets a temporary access token to use with AssumeRoleWithWebIdentity. Access tokens are
valid for one hour.

# Arguments
- `token`: Refresh token, encoded as a JWT token.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"TokenProperties"`: Token properties to validate against those present in the JWT token.
"""
function get_access_token(Token; aws_config::AbstractAWSConfig=current_aws_config())
    return license_manager(
        "GetAccessToken",
        Dict{String,Any}("Token" => Token);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_access_token(
    Token, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return license_manager(
        "GetAccessToken",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Token" => Token), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_grant(grant_arn)
    get_grant(grant_arn, params::Dict{String,<:Any})

Gets detailed information about the specified grant.

# Arguments
- `grant_arn`: Amazon Resource Name (ARN) of the grant.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Version"`: Grant version.
"""
function get_grant(GrantArn; aws_config::AbstractAWSConfig=current_aws_config())
    return license_manager(
        "GetGrant",
        Dict{String,Any}("GrantArn" => GrantArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_grant(
    GrantArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager(
        "GetGrant",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("GrantArn" => GrantArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_license(license_arn)
    get_license(license_arn, params::Dict{String,<:Any})

Gets detailed information about the specified license.

# Arguments
- `license_arn`: Amazon Resource Name (ARN) of the license.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Version"`: License version.
"""
function get_license(LicenseArn; aws_config::AbstractAWSConfig=current_aws_config())
    return license_manager(
        "GetLicense",
        Dict{String,Any}("LicenseArn" => LicenseArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_license(
    LicenseArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager(
        "GetLicense",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("LicenseArn" => LicenseArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_license_configuration(license_configuration_arn)
    get_license_configuration(license_configuration_arn, params::Dict{String,<:Any})

Gets detailed information about the specified license configuration.

# Arguments
- `license_configuration_arn`: Amazon Resource Name (ARN) of the license configuration.

"""
function get_license_configuration(
    LicenseConfigurationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return license_manager(
        "GetLicenseConfiguration",
        Dict{String,Any}("LicenseConfigurationArn" => LicenseConfigurationArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_license_configuration(
    LicenseConfigurationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager(
        "GetLicenseConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("LicenseConfigurationArn" => LicenseConfigurationArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_license_conversion_task(license_conversion_task_id)
    get_license_conversion_task(license_conversion_task_id, params::Dict{String,<:Any})

Gets information about the specified license type conversion task.

# Arguments
- `license_conversion_task_id`: ID of the license type conversion task to retrieve
  information on.

"""
function get_license_conversion_task(
    LicenseConversionTaskId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return license_manager(
        "GetLicenseConversionTask",
        Dict{String,Any}("LicenseConversionTaskId" => LicenseConversionTaskId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_license_conversion_task(
    LicenseConversionTaskId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager(
        "GetLicenseConversionTask",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("LicenseConversionTaskId" => LicenseConversionTaskId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_license_manager_report_generator(license_manager_report_generator_arn)
    get_license_manager_report_generator(license_manager_report_generator_arn, params::Dict{String,<:Any})

Gets information about the specified report generator.

# Arguments
- `license_manager_report_generator_arn`: Amazon Resource Name (ARN) of the report
  generator.

"""
function get_license_manager_report_generator(
    LicenseManagerReportGeneratorArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return license_manager(
        "GetLicenseManagerReportGenerator",
        Dict{String,Any}(
            "LicenseManagerReportGeneratorArn" => LicenseManagerReportGeneratorArn
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_license_manager_report_generator(
    LicenseManagerReportGeneratorArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager(
        "GetLicenseManagerReportGenerator",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "LicenseManagerReportGeneratorArn" => LicenseManagerReportGeneratorArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_license_usage(license_arn)
    get_license_usage(license_arn, params::Dict{String,<:Any})

Gets detailed information about the usage of the specified license.

# Arguments
- `license_arn`: Amazon Resource Name (ARN) of the license.

"""
function get_license_usage(LicenseArn; aws_config::AbstractAWSConfig=current_aws_config())
    return license_manager(
        "GetLicenseUsage",
        Dict{String,Any}("LicenseArn" => LicenseArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_license_usage(
    LicenseArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager(
        "GetLicenseUsage",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("LicenseArn" => LicenseArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_service_settings()
    get_service_settings(params::Dict{String,<:Any})

Gets the License Manager settings for the current Region.

"""
function get_service_settings(; aws_config::AbstractAWSConfig=current_aws_config())
    return license_manager(
        "GetServiceSettings"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_service_settings(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return license_manager(
        "GetServiceSettings", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_associations_for_license_configuration(license_configuration_arn)
    list_associations_for_license_configuration(license_configuration_arn, params::Dict{String,<:Any})

Lists the resource associations for the specified license configuration. Resource
associations need not consume licenses from a license configuration. For example, an AMI or
a stopped instance might not consume a license (depending on the license rules).

# Arguments
- `license_configuration_arn`: Amazon Resource Name (ARN) of a license configuration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Maximum number of results to return in a single call.
- `"NextToken"`: Token for the next set of results.
"""
function list_associations_for_license_configuration(
    LicenseConfigurationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return license_manager(
        "ListAssociationsForLicenseConfiguration",
        Dict{String,Any}("LicenseConfigurationArn" => LicenseConfigurationArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_associations_for_license_configuration(
    LicenseConfigurationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager(
        "ListAssociationsForLicenseConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("LicenseConfigurationArn" => LicenseConfigurationArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_distributed_grants()
    list_distributed_grants(params::Dict{String,<:Any})

Lists the grants distributed for the specified license.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: Filters to scope the results. The following filters are supported:
  LicenseArn     GrantStatus     GranteePrincipalARN     ProductSKU     LicenseIssuerName
- `"GrantArns"`: Amazon Resource Names (ARNs) of the grants.
- `"MaxResults"`: Maximum number of results to return in a single call.
- `"NextToken"`: Token for the next set of results.
"""
function list_distributed_grants(; aws_config::AbstractAWSConfig=current_aws_config())
    return license_manager(
        "ListDistributedGrants"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_distributed_grants(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return license_manager(
        "ListDistributedGrants",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_failures_for_license_configuration_operations(license_configuration_arn)
    list_failures_for_license_configuration_operations(license_configuration_arn, params::Dict{String,<:Any})

Lists the license configuration operations that failed.

# Arguments
- `license_configuration_arn`: Amazon Resource Name of the license configuration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Maximum number of results to return in a single call.
- `"NextToken"`: Token for the next set of results.
"""
function list_failures_for_license_configuration_operations(
    LicenseConfigurationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return license_manager(
        "ListFailuresForLicenseConfigurationOperations",
        Dict{String,Any}("LicenseConfigurationArn" => LicenseConfigurationArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_failures_for_license_configuration_operations(
    LicenseConfigurationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager(
        "ListFailuresForLicenseConfigurationOperations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("LicenseConfigurationArn" => LicenseConfigurationArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_license_configurations()
    list_license_configurations(params::Dict{String,<:Any})

Lists the license configurations for your account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: Filters to scope the results. The following filters and logical operators
  are supported:    licenseCountingType - The dimension for which licenses are counted.
  Possible values are vCPU | Instance | Core | Socket. Logical operators are EQUALS |
  NOT_EQUALS.    enforceLicenseCount - A Boolean value that indicates whether hard license
  enforcement is used. Logical operators are EQUALS | NOT_EQUALS.    usagelimitExceeded - A
  Boolean value that indicates whether the available licenses have been exceeded. Logical
  operators are EQUALS | NOT_EQUALS.
- `"LicenseConfigurationArns"`: Amazon Resource Names (ARN) of the license configurations.
- `"MaxResults"`: Maximum number of results to return in a single call.
- `"NextToken"`: Token for the next set of results.
"""
function list_license_configurations(; aws_config::AbstractAWSConfig=current_aws_config())
    return license_manager(
        "ListLicenseConfigurations"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_license_configurations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return license_manager(
        "ListLicenseConfigurations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_license_conversion_tasks()
    list_license_conversion_tasks(params::Dict{String,<:Any})

Lists the license type conversion tasks for your account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`:  Filters to scope the results. Valid filters are ResourceArns and Status.
- `"MaxResults"`: Maximum number of results to return in a single call.
- `"NextToken"`: Token for the next set of results.
"""
function list_license_conversion_tasks(; aws_config::AbstractAWSConfig=current_aws_config())
    return license_manager(
        "ListLicenseConversionTasks"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_license_conversion_tasks(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return license_manager(
        "ListLicenseConversionTasks",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_license_manager_report_generators()
    list_license_manager_report_generators(params::Dict{String,<:Any})

Lists the report generators for your account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: Filters to scope the results. The following filters are supported:
  LicenseConfigurationArn
- `"MaxResults"`: Maximum number of results to return in a single call.
- `"NextToken"`: Token for the next set of results.
"""
function list_license_manager_report_generators(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return license_manager(
        "ListLicenseManagerReportGenerators";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_license_manager_report_generators(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return license_manager(
        "ListLicenseManagerReportGenerators",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_license_specifications_for_resource(resource_arn)
    list_license_specifications_for_resource(resource_arn, params::Dict{String,<:Any})

Describes the license configurations for the specified resource.

# Arguments
- `resource_arn`: Amazon Resource Name (ARN) of a resource that has an associated license
  configuration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Maximum number of results to return in a single call.
- `"NextToken"`: Token for the next set of results.
"""
function list_license_specifications_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return license_manager(
        "ListLicenseSpecificationsForResource",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_license_specifications_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager(
        "ListLicenseSpecificationsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_license_versions(license_arn)
    list_license_versions(license_arn, params::Dict{String,<:Any})

Lists all versions of the specified license.

# Arguments
- `license_arn`: Amazon Resource Name (ARN) of the license.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Maximum number of results to return in a single call.
- `"NextToken"`: Token for the next set of results.
"""
function list_license_versions(
    LicenseArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return license_manager(
        "ListLicenseVersions",
        Dict{String,Any}("LicenseArn" => LicenseArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_license_versions(
    LicenseArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager(
        "ListLicenseVersions",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("LicenseArn" => LicenseArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_licenses()
    list_licenses(params::Dict{String,<:Any})

Lists the licenses for your account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: Filters to scope the results. The following filters are supported:
  Beneficiary     ProductSKU     Fingerprint     Status
- `"LicenseArns"`: Amazon Resource Names (ARNs) of the licenses.
- `"MaxResults"`: Maximum number of results to return in a single call.
- `"NextToken"`: Token for the next set of results.
"""
function list_licenses(; aws_config::AbstractAWSConfig=current_aws_config())
    return license_manager(
        "ListLicenses"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_licenses(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return license_manager(
        "ListLicenses", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_received_grants()
    list_received_grants(params::Dict{String,<:Any})

Lists grants that are received. Received grants are grants created while specifying the
recipient as this Amazon Web Services account, your organization, or an organizational unit
(OU) to which this member account belongs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: Filters to scope the results. The following filters are supported:
  ProductSKU     LicenseIssuerName     LicenseArn     GrantStatus     GranterAccountId
- `"GrantArns"`: Amazon Resource Names (ARNs) of the grants.
- `"MaxResults"`: Maximum number of results to return in a single call.
- `"NextToken"`: Token for the next set of results.
"""
function list_received_grants(; aws_config::AbstractAWSConfig=current_aws_config())
    return license_manager(
        "ListReceivedGrants"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_received_grants(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return license_manager(
        "ListReceivedGrants", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_received_grants_for_organization(license_arn)
    list_received_grants_for_organization(license_arn, params::Dict{String,<:Any})

Lists the grants received for all accounts in the organization.

# Arguments
- `license_arn`: The Amazon Resource Name (ARN) of the received license.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: Filters to scope the results. The following filters are supported:
  ParentArn     GranteePrincipalArn
- `"MaxResults"`: Maximum number of results to return in a single call.
- `"NextToken"`: Token for the next set of results.
"""
function list_received_grants_for_organization(
    LicenseArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return license_manager(
        "ListReceivedGrantsForOrganization",
        Dict{String,Any}("LicenseArn" => LicenseArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_received_grants_for_organization(
    LicenseArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager(
        "ListReceivedGrantsForOrganization",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("LicenseArn" => LicenseArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_received_licenses()
    list_received_licenses(params::Dict{String,<:Any})

Lists received licenses.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: Filters to scope the results. The following filters are supported:
  ProductSKU     Status     Fingerprint     IssuerName     Beneficiary
- `"LicenseArns"`: Amazon Resource Names (ARNs) of the licenses.
- `"MaxResults"`: Maximum number of results to return in a single call.
- `"NextToken"`: Token for the next set of results.
"""
function list_received_licenses(; aws_config::AbstractAWSConfig=current_aws_config())
    return license_manager(
        "ListReceivedLicenses"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_received_licenses(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return license_manager(
        "ListReceivedLicenses",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_received_licenses_for_organization()
    list_received_licenses_for_organization(params::Dict{String,<:Any})

Lists the licenses received for all accounts in the organization.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: Filters to scope the results. The following filters are supported:
  Beneficiary     ProductSKU
- `"MaxResults"`: Maximum number of results to return in a single call.
- `"NextToken"`: Token for the next set of results.
"""
function list_received_licenses_for_organization(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return license_manager(
        "ListReceivedLicensesForOrganization";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_received_licenses_for_organization(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return license_manager(
        "ListReceivedLicensesForOrganization",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_resource_inventory()
    list_resource_inventory(params::Dict{String,<:Any})

Lists resources managed using Systems Manager inventory.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: Filters to scope the results. The following filters and logical operators
  are supported:    account_id - The ID of the Amazon Web Services account that owns the
  resource. Logical operators are EQUALS | NOT_EQUALS.    application_name - The name of the
  application. Logical operators are EQUALS | BEGINS_WITH.    license_included - The type of
  license included. Logical operators are EQUALS | NOT_EQUALS. Possible values are
  sql-server-enterprise | sql-server-standard | sql-server-web | windows-server-datacenter.
   platform - The platform of the resource. Logical operators are EQUALS | BEGINS_WITH.
  resource_id - The ID of the resource. Logical operators are EQUALS | NOT_EQUALS.
  tag:&lt;key&gt; - The key/value combination of a tag assigned to the resource. Logical
  operators are EQUALS (single account) or EQUALS | NOT_EQUALS (cross account).
- `"MaxResults"`: Maximum number of results to return in a single call.
- `"NextToken"`: Token for the next set of results.
"""
function list_resource_inventory(; aws_config::AbstractAWSConfig=current_aws_config())
    return license_manager(
        "ListResourceInventory"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_resource_inventory(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return license_manager(
        "ListResourceInventory",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists the tags for the specified license configuration.

# Arguments
- `resource_arn`: Amazon Resource Name (ARN) of the license configuration.

"""
function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return license_manager(
        "ListTagsForResource",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tokens()
    list_tokens(params::Dict{String,<:Any})

Lists your tokens.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: Filters to scope the results. The following filter is supported:
  LicenseArns
- `"MaxResults"`: Maximum number of results to return in a single call.
- `"NextToken"`: Token for the next set of results.
- `"TokenIds"`: Token IDs.
"""
function list_tokens(; aws_config::AbstractAWSConfig=current_aws_config())
    return license_manager(
        "ListTokens"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_tokens(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return license_manager(
        "ListTokens", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_usage_for_license_configuration(license_configuration_arn)
    list_usage_for_license_configuration(license_configuration_arn, params::Dict{String,<:Any})

Lists all license usage records for a license configuration, displaying license consumption
details by resource at a selected point in time. Use this action to audit the current
license consumption for any license inventory and configuration.

# Arguments
- `license_configuration_arn`: Amazon Resource Name (ARN) of the license configuration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: Filters to scope the results. The following filters and logical operators
  are supported:    resourceArn - The ARN of the license configuration resource. Logical
  operators are EQUALS | NOT_EQUALS.    resourceType - The resource type (EC2_INSTANCE |
  EC2_HOST | EC2_AMI | SYSTEMS_MANAGER_MANAGED_INSTANCE). Logical operators are EQUALS |
  NOT_EQUALS.    resourceAccount - The ID of the account that owns the resource. Logical
  operators are EQUALS | NOT_EQUALS.
- `"MaxResults"`: Maximum number of results to return in a single call.
- `"NextToken"`: Token for the next set of results.
"""
function list_usage_for_license_configuration(
    LicenseConfigurationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return license_manager(
        "ListUsageForLicenseConfiguration",
        Dict{String,Any}("LicenseConfigurationArn" => LicenseConfigurationArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_usage_for_license_configuration(
    LicenseConfigurationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager(
        "ListUsageForLicenseConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("LicenseConfigurationArn" => LicenseConfigurationArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    reject_grant(grant_arn)
    reject_grant(grant_arn, params::Dict{String,<:Any})

Rejects the specified grant.

# Arguments
- `grant_arn`: Amazon Resource Name (ARN) of the grant.

"""
function reject_grant(GrantArn; aws_config::AbstractAWSConfig=current_aws_config())
    return license_manager(
        "RejectGrant",
        Dict{String,Any}("GrantArn" => GrantArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function reject_grant(
    GrantArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager(
        "RejectGrant",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("GrantArn" => GrantArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds the specified tags to the specified license configuration.

# Arguments
- `resource_arn`: Amazon Resource Name (ARN) of the license configuration.
- `tags`: One or more tags.

"""
function tag_resource(ResourceArn, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return license_manager(
        "TagResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceArn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes the specified tags from the specified license configuration.

# Arguments
- `resource_arn`: Amazon Resource Name (ARN) of the license configuration.
- `tag_keys`: Keys identifying the tags to remove.

"""
function untag_resource(
    ResourceArn, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return license_manager(
        "UntagResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceArn,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_license_configuration(license_configuration_arn)
    update_license_configuration(license_configuration_arn, params::Dict{String,<:Any})

Modifies the attributes of an existing license configuration.

# Arguments
- `license_configuration_arn`: Amazon Resource Name (ARN) of the license configuration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: New description of the license configuration.
- `"DisassociateWhenNotFound"`: When true, disassociates a resource when software is
  uninstalled.
- `"LicenseConfigurationStatus"`: New status of the license configuration.
- `"LicenseCount"`: New number of licenses managed by the license configuration.
- `"LicenseCountHardLimit"`: New hard limit of the number of available licenses.
- `"LicenseRules"`: New license rule. The only rule that you can add after you create a
  license configuration is licenseAffinityToHost.
- `"Name"`: New name of the license configuration.
- `"ProductInformationList"`: New product information.
"""
function update_license_configuration(
    LicenseConfigurationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return license_manager(
        "UpdateLicenseConfiguration",
        Dict{String,Any}("LicenseConfigurationArn" => LicenseConfigurationArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_license_configuration(
    LicenseConfigurationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager(
        "UpdateLicenseConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("LicenseConfigurationArn" => LicenseConfigurationArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_license_manager_report_generator(client_token, license_manager_report_generator_arn, report_context, report_frequency, report_generator_name, type)
    update_license_manager_report_generator(client_token, license_manager_report_generator_arn, report_context, report_frequency, report_generator_name, type, params::Dict{String,<:Any})

Updates a report generator. After you make changes to a report generator, it starts
generating new reports within 60 minutes of being updated.

# Arguments
- `client_token`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request.
- `license_manager_report_generator_arn`: Amazon Resource Name (ARN) of the report
  generator to update.
- `report_context`: The report context.
- `report_frequency`: Frequency by which reports are generated.
- `report_generator_name`: Name of the report generator.
- `type`: Type of reports to generate. The following report types are supported:   License
  configuration report - Reports the number and details of consumed licenses for a license
  configuration.   Resource report - Reports the tracked licenses and resource consumption
  for a license configuration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: Description of the report generator.
"""
function update_license_manager_report_generator(
    ClientToken,
    LicenseManagerReportGeneratorArn,
    ReportContext,
    ReportFrequency,
    ReportGeneratorName,
    Type;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager(
        "UpdateLicenseManagerReportGenerator",
        Dict{String,Any}(
            "ClientToken" => ClientToken,
            "LicenseManagerReportGeneratorArn" => LicenseManagerReportGeneratorArn,
            "ReportContext" => ReportContext,
            "ReportFrequency" => ReportFrequency,
            "ReportGeneratorName" => ReportGeneratorName,
            "Type" => Type,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_license_manager_report_generator(
    ClientToken,
    LicenseManagerReportGeneratorArn,
    ReportContext,
    ReportFrequency,
    ReportGeneratorName,
    Type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager(
        "UpdateLicenseManagerReportGenerator",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClientToken" => ClientToken,
                    "LicenseManagerReportGeneratorArn" => LicenseManagerReportGeneratorArn,
                    "ReportContext" => ReportContext,
                    "ReportFrequency" => ReportFrequency,
                    "ReportGeneratorName" => ReportGeneratorName,
                    "Type" => Type,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_license_specifications_for_resource(resource_arn)
    update_license_specifications_for_resource(resource_arn, params::Dict{String,<:Any})

Adds or removes the specified license configurations for the specified Amazon Web Services
resource. You can update the license specifications of AMIs, instances, and hosts. You
cannot update the license specifications for launch templates and CloudFormation templates,
as they send license configurations to the operation that creates the resource.

# Arguments
- `resource_arn`: Amazon Resource Name (ARN) of the Amazon Web Services resource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AddLicenseSpecifications"`: ARNs of the license configurations to add.
- `"RemoveLicenseSpecifications"`: ARNs of the license configurations to remove.
"""
function update_license_specifications_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return license_manager(
        "UpdateLicenseSpecificationsForResource",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_license_specifications_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return license_manager(
        "UpdateLicenseSpecificationsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_service_settings()
    update_service_settings(params::Dict{String,<:Any})

Updates License Manager settings for the current Region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EnableCrossAccountsDiscovery"`: Activates cross-account discovery.
- `"OrganizationConfiguration"`: Enables integration with Organizations for cross-account
  discovery.
- `"S3BucketArn"`: Amazon Resource Name (ARN) of the Amazon S3 bucket where the License
  Manager information is stored.
- `"SnsTopicArn"`: Amazon Resource Name (ARN) of the Amazon SNS topic used for License
  Manager alerts.
"""
function update_service_settings(; aws_config::AbstractAWSConfig=current_aws_config())
    return license_manager(
        "UpdateServiceSettings"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function update_service_settings(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return license_manager(
        "UpdateServiceSettings",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: groundstation
using AWS.Compat
using AWS.UUIDs

"""
    cancel_contact(contact_id)
    cancel_contact(contact_id, params::Dict{String,<:Any})

Cancels a contact with a specified contact ID.

# Arguments
- `contact_id`: UUID of a contact.

"""
function cancel_contact(contactId; aws_config::AbstractAWSConfig=current_aws_config())
    return groundstation(
        "DELETE",
        "/contact/$(contactId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_contact(
    contactId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return groundstation(
        "DELETE",
        "/contact/$(contactId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_config(config_data, name)
    create_config(config_data, name, params::Dict{String,<:Any})

Creates a Config with the specified configData parameters. Only one type of configData can
be specified.

# Arguments
- `config_data`: Parameters of a Config.
- `name`: Name of a Config.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tags"`: Tags assigned to a Config.
"""
function create_config(configData, name; aws_config::AbstractAWSConfig=current_aws_config())
    return groundstation(
        "POST",
        "/config",
        Dict{String,Any}("configData" => configData, "name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_config(
    configData,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return groundstation(
        "POST",
        "/config",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("configData" => configData, "name" => name), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_dataflow_endpoint_group(endpoint_details)
    create_dataflow_endpoint_group(endpoint_details, params::Dict{String,<:Any})

Creates a DataflowEndpoint group containing the specified list of DataflowEndpoint objects.
The name field in each endpoint is used in your mission profile DataflowEndpointConfig to
specify which endpoints to use during a contact. When a contact uses multiple
DataflowEndpointConfig objects, each Config must match a DataflowEndpoint in the same group.

# Arguments
- `endpoint_details`: Endpoint details of each endpoint in the dataflow endpoint group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"contactPostPassDurationSeconds"`: Amount of time, in seconds, after a contact ends that
  the Ground Station Dataflow Endpoint Group will be in a POSTPASS state. A Ground Station
  Dataflow Endpoint Group State Change event will be emitted when the Dataflow Endpoint Group
  enters and exits the POSTPASS state.
- `"contactPrePassDurationSeconds"`: Amount of time, in seconds, before a contact starts
  that the Ground Station Dataflow Endpoint Group will be in a PREPASS state. A Ground
  Station Dataflow Endpoint Group State Change event will be emitted when the Dataflow
  Endpoint Group enters and exits the PREPASS state.
- `"tags"`: Tags of a dataflow endpoint group.
"""
function create_dataflow_endpoint_group(
    endpointDetails; aws_config::AbstractAWSConfig=current_aws_config()
)
    return groundstation(
        "POST",
        "/dataflowEndpointGroup",
        Dict{String,Any}("endpointDetails" => endpointDetails);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_dataflow_endpoint_group(
    endpointDetails,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return groundstation(
        "POST",
        "/dataflowEndpointGroup",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("endpointDetails" => endpointDetails), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_ephemeris(name, satellite_id)
    create_ephemeris(name, satellite_id, params::Dict{String,<:Any})

Creates an Ephemeris with the specified EphemerisData.

# Arguments
- `name`: A name string associated with the ephemeris. Used as a human-readable identifier
  for the ephemeris.
- `satellite_id`: AWS Ground Station satellite ID for this ephemeris.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"enabled"`: Whether to set the ephemeris status to ENABLED after validation. Setting
  this to false will set the ephemeris status to DISABLED after validation.
- `"ephemeris"`: Ephemeris data.
- `"expirationTime"`: An overall expiration time for the ephemeris in UTC, after which it
  will become EXPIRED.
- `"kmsKeyArn"`: The ARN of a KMS key used to encrypt the ephemeris in Ground Station.
- `"priority"`: Customer-provided priority score to establish the order in which
  overlapping ephemerides should be used. The default for customer-provided ephemeris
  priority is 1, and higher numbers take precedence. Priority must be 1 or greater
- `"tags"`: Tags assigned to an ephemeris.
"""
function create_ephemeris(
    name, satelliteId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return groundstation(
        "POST",
        "/ephemeris",
        Dict{String,Any}("name" => name, "satelliteId" => satelliteId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_ephemeris(
    name,
    satelliteId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return groundstation(
        "POST",
        "/ephemeris",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("name" => name, "satelliteId" => satelliteId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_mission_profile(dataflow_edges, minimum_viable_contact_duration_seconds, name, tracking_config_arn)
    create_mission_profile(dataflow_edges, minimum_viable_contact_duration_seconds, name, tracking_config_arn, params::Dict{String,<:Any})

Creates a mission profile.  dataflowEdges is a list of lists of strings. Each lower level
list of strings has two elements: a from ARN and a to ARN.

# Arguments
- `dataflow_edges`: A list of lists of ARNs. Each list of ARNs is an edge, with a from
  Config and a to Config.
- `minimum_viable_contact_duration_seconds`: Smallest amount of time in seconds that
  you’d like to see for an available contact. AWS Ground Station will not present you with
  contacts shorter than this duration.
- `name`: Name of a mission profile.
- `tracking_config_arn`: ARN of a tracking Config.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"contactPostPassDurationSeconds"`: Amount of time after a contact ends that you’d like
  to receive a Ground Station Contact State Change event indicating the pass has finished.
- `"contactPrePassDurationSeconds"`: Amount of time prior to contact start you’d like to
  receive a Ground Station Contact State Change event indicating an upcoming pass.
- `"streamsKmsKey"`: KMS key to use for encrypting streams.
- `"streamsKmsRole"`: Role to use for encrypting streams with KMS key.
- `"tags"`: Tags assigned to a mission profile.
"""
function create_mission_profile(
    dataflowEdges,
    minimumViableContactDurationSeconds,
    name,
    trackingConfigArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return groundstation(
        "POST",
        "/missionprofile",
        Dict{String,Any}(
            "dataflowEdges" => dataflowEdges,
            "minimumViableContactDurationSeconds" => minimumViableContactDurationSeconds,
            "name" => name,
            "trackingConfigArn" => trackingConfigArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_mission_profile(
    dataflowEdges,
    minimumViableContactDurationSeconds,
    name,
    trackingConfigArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return groundstation(
        "POST",
        "/missionprofile",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "dataflowEdges" => dataflowEdges,
                    "minimumViableContactDurationSeconds" =>
                        minimumViableContactDurationSeconds,
                    "name" => name,
                    "trackingConfigArn" => trackingConfigArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_config(config_id, config_type)
    delete_config(config_id, config_type, params::Dict{String,<:Any})

Deletes a Config.

# Arguments
- `config_id`: UUID of a Config.
- `config_type`: Type of a Config.

"""
function delete_config(
    configId, configType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return groundstation(
        "DELETE",
        "/config/$(configType)/$(configId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_config(
    configId,
    configType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return groundstation(
        "DELETE",
        "/config/$(configType)/$(configId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_dataflow_endpoint_group(dataflow_endpoint_group_id)
    delete_dataflow_endpoint_group(dataflow_endpoint_group_id, params::Dict{String,<:Any})

Deletes a dataflow endpoint group.

# Arguments
- `dataflow_endpoint_group_id`: UUID of a dataflow endpoint group.

"""
function delete_dataflow_endpoint_group(
    dataflowEndpointGroupId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return groundstation(
        "DELETE",
        "/dataflowEndpointGroup/$(dataflowEndpointGroupId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_dataflow_endpoint_group(
    dataflowEndpointGroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return groundstation(
        "DELETE",
        "/dataflowEndpointGroup/$(dataflowEndpointGroupId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_ephemeris(ephemeris_id)
    delete_ephemeris(ephemeris_id, params::Dict{String,<:Any})

Deletes an ephemeris

# Arguments
- `ephemeris_id`: The AWS Ground Station ephemeris ID.

"""
function delete_ephemeris(ephemerisId; aws_config::AbstractAWSConfig=current_aws_config())
    return groundstation(
        "DELETE",
        "/ephemeris/$(ephemerisId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_ephemeris(
    ephemerisId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return groundstation(
        "DELETE",
        "/ephemeris/$(ephemerisId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_mission_profile(mission_profile_id)
    delete_mission_profile(mission_profile_id, params::Dict{String,<:Any})

Deletes a mission profile.

# Arguments
- `mission_profile_id`: UUID of a mission profile.

"""
function delete_mission_profile(
    missionProfileId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return groundstation(
        "DELETE",
        "/missionprofile/$(missionProfileId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_mission_profile(
    missionProfileId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return groundstation(
        "DELETE",
        "/missionprofile/$(missionProfileId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_contact(contact_id)
    describe_contact(contact_id, params::Dict{String,<:Any})

Describes an existing contact.

# Arguments
- `contact_id`: UUID of a contact.

"""
function describe_contact(contactId; aws_config::AbstractAWSConfig=current_aws_config())
    return groundstation(
        "GET",
        "/contact/$(contactId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_contact(
    contactId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return groundstation(
        "GET",
        "/contact/$(contactId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_ephemeris(ephemeris_id)
    describe_ephemeris(ephemeris_id, params::Dict{String,<:Any})

Describes an existing ephemeris.

# Arguments
- `ephemeris_id`: The AWS Ground Station ephemeris ID.

"""
function describe_ephemeris(ephemerisId; aws_config::AbstractAWSConfig=current_aws_config())
    return groundstation(
        "GET",
        "/ephemeris/$(ephemerisId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_ephemeris(
    ephemerisId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return groundstation(
        "GET",
        "/ephemeris/$(ephemerisId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_agent_configuration(agent_id)
    get_agent_configuration(agent_id, params::Dict{String,<:Any})

  For use by AWS Ground Station Agent and shouldn't be called directly.  Gets the latest
configuration information for a registered agent.

# Arguments
- `agent_id`: UUID of agent to get configuration information for.

"""
function get_agent_configuration(
    agentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return groundstation(
        "GET",
        "/agent/$(agentId)/configuration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_agent_configuration(
    agentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return groundstation(
        "GET",
        "/agent/$(agentId)/configuration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_config(config_id, config_type)
    get_config(config_id, config_type, params::Dict{String,<:Any})

Returns Config information. Only one Config response can be returned.

# Arguments
- `config_id`: UUID of a Config.
- `config_type`: Type of a Config.

"""
function get_config(
    configId, configType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return groundstation(
        "GET",
        "/config/$(configType)/$(configId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_config(
    configId,
    configType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return groundstation(
        "GET",
        "/config/$(configType)/$(configId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_dataflow_endpoint_group(dataflow_endpoint_group_id)
    get_dataflow_endpoint_group(dataflow_endpoint_group_id, params::Dict{String,<:Any})

Returns the dataflow endpoint group.

# Arguments
- `dataflow_endpoint_group_id`: UUID of a dataflow endpoint group.

"""
function get_dataflow_endpoint_group(
    dataflowEndpointGroupId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return groundstation(
        "GET",
        "/dataflowEndpointGroup/$(dataflowEndpointGroupId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_dataflow_endpoint_group(
    dataflowEndpointGroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return groundstation(
        "GET",
        "/dataflowEndpointGroup/$(dataflowEndpointGroupId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_minute_usage(month, year)
    get_minute_usage(month, year, params::Dict{String,<:Any})

Returns the number of reserved minutes used by account.

# Arguments
- `month`: The month being requested, with a value of 1-12.
- `year`: The year being requested, in the format of YYYY.

"""
function get_minute_usage(month, year; aws_config::AbstractAWSConfig=current_aws_config())
    return groundstation(
        "POST",
        "/minute-usage",
        Dict{String,Any}("month" => month, "year" => year);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_minute_usage(
    month,
    year,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return groundstation(
        "POST",
        "/minute-usage",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("month" => month, "year" => year), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_mission_profile(mission_profile_id)
    get_mission_profile(mission_profile_id, params::Dict{String,<:Any})

Returns a mission profile.

# Arguments
- `mission_profile_id`: UUID of a mission profile.

"""
function get_mission_profile(
    missionProfileId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return groundstation(
        "GET",
        "/missionprofile/$(missionProfileId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_mission_profile(
    missionProfileId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return groundstation(
        "GET",
        "/missionprofile/$(missionProfileId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_satellite(satellite_id)
    get_satellite(satellite_id, params::Dict{String,<:Any})

Returns a satellite.

# Arguments
- `satellite_id`: UUID of a satellite.

"""
function get_satellite(satelliteId; aws_config::AbstractAWSConfig=current_aws_config())
    return groundstation(
        "GET",
        "/satellite/$(satelliteId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_satellite(
    satelliteId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return groundstation(
        "GET",
        "/satellite/$(satelliteId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_configs()
    list_configs(params::Dict{String,<:Any})

Returns a list of Config objects.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Maximum number of Configs returned.
- `"nextToken"`: Next token returned in the request of a previous ListConfigs call. Used to
  get the next page of results.
"""
function list_configs(; aws_config::AbstractAWSConfig=current_aws_config())
    return groundstation(
        "GET", "/config"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_configs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return groundstation(
        "GET", "/config", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_contacts(end_time, start_time, status_list)
    list_contacts(end_time, start_time, status_list, params::Dict{String,<:Any})

Returns a list of contacts. If statusList contains AVAILABLE, the request must include
groundStation, missionprofileArn, and satelliteArn.

# Arguments
- `end_time`: End time of a contact in UTC.
- `start_time`: Start time of a contact in UTC.
- `status_list`: Status of a contact reservation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"groundStation"`: Name of a ground station.
- `"maxResults"`: Maximum number of contacts returned.
- `"missionProfileArn"`: ARN of a mission profile.
- `"nextToken"`: Next token returned in the request of a previous ListContacts call. Used
  to get the next page of results.
- `"satelliteArn"`: ARN of a satellite.
"""
function list_contacts(
    endTime, startTime, statusList; aws_config::AbstractAWSConfig=current_aws_config()
)
    return groundstation(
        "POST",
        "/contacts",
        Dict{String,Any}(
            "endTime" => endTime, "startTime" => startTime, "statusList" => statusList
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_contacts(
    endTime,
    startTime,
    statusList,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return groundstation(
        "POST",
        "/contacts",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "endTime" => endTime,
                    "startTime" => startTime,
                    "statusList" => statusList,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_dataflow_endpoint_groups()
    list_dataflow_endpoint_groups(params::Dict{String,<:Any})

Returns a list of DataflowEndpoint groups.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Maximum number of dataflow endpoint groups returned.
- `"nextToken"`: Next token returned in the request of a previous
  ListDataflowEndpointGroups call. Used to get the next page of results.
"""
function list_dataflow_endpoint_groups(; aws_config::AbstractAWSConfig=current_aws_config())
    return groundstation(
        "GET",
        "/dataflowEndpointGroup";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_dataflow_endpoint_groups(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return groundstation(
        "GET",
        "/dataflowEndpointGroup",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_ephemerides(end_time, satellite_id, start_time)
    list_ephemerides(end_time, satellite_id, start_time, params::Dict{String,<:Any})

List existing ephemerides.

# Arguments
- `end_time`: The end time to list in UTC. The operation will return an ephemeris if its
  expiration time is within the time range defined by the startTime and endTime.
- `satellite_id`: The AWS Ground Station satellite ID to list ephemeris for.
- `start_time`: The start time to list in UTC. The operation will return an ephemeris if
  its expiration time is within the time range defined by the startTime and endTime.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Maximum number of ephemerides to return.
- `"nextToken"`: Pagination token.
- `"statusList"`: The list of ephemeris status to return.
"""
function list_ephemerides(
    endTime, satelliteId, startTime; aws_config::AbstractAWSConfig=current_aws_config()
)
    return groundstation(
        "POST",
        "/ephemerides",
        Dict{String,Any}(
            "endTime" => endTime, "satelliteId" => satelliteId, "startTime" => startTime
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_ephemerides(
    endTime,
    satelliteId,
    startTime,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return groundstation(
        "POST",
        "/ephemerides",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "endTime" => endTime,
                    "satelliteId" => satelliteId,
                    "startTime" => startTime,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_ground_stations()
    list_ground_stations(params::Dict{String,<:Any})

Returns a list of ground stations.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Maximum number of ground stations returned.
- `"nextToken"`: Next token that can be supplied in the next call to get the next page of
  ground stations.
- `"satelliteId"`: Satellite ID to retrieve on-boarded ground stations.
"""
function list_ground_stations(; aws_config::AbstractAWSConfig=current_aws_config())
    return groundstation(
        "GET", "/groundstation"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_ground_stations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return groundstation(
        "GET",
        "/groundstation",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_mission_profiles()
    list_mission_profiles(params::Dict{String,<:Any})

Returns a list of mission profiles.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Maximum number of mission profiles returned.
- `"nextToken"`: Next token returned in the request of a previous ListMissionProfiles call.
  Used to get the next page of results.
"""
function list_mission_profiles(; aws_config::AbstractAWSConfig=current_aws_config())
    return groundstation(
        "GET", "/missionprofile"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_mission_profiles(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return groundstation(
        "GET",
        "/missionprofile",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_satellites()
    list_satellites(params::Dict{String,<:Any})

Returns a list of satellites.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Maximum number of satellites returned.
- `"nextToken"`: Next token that can be supplied in the next call to get the next page of
  satellites.
"""
function list_satellites(; aws_config::AbstractAWSConfig=current_aws_config())
    return groundstation(
        "GET", "/satellite"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_satellites(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return groundstation(
        "GET", "/satellite", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Returns a list of tags for a specified resource.

# Arguments
- `resource_arn`: ARN of a resource.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return groundstation(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return groundstation(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    register_agent(agent_details, discovery_data)
    register_agent(agent_details, discovery_data, params::Dict{String,<:Any})

  For use by AWS Ground Station Agent and shouldn't be called directly.   Registers a new
agent with AWS Ground Station.

# Arguments
- `agent_details`: Detailed information about the agent being registered.
- `discovery_data`: Data for associating an agent with the capabilities it is managing.

"""
function register_agent(
    agentDetails, discoveryData; aws_config::AbstractAWSConfig=current_aws_config()
)
    return groundstation(
        "POST",
        "/agent",
        Dict{String,Any}("agentDetails" => agentDetails, "discoveryData" => discoveryData);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function register_agent(
    agentDetails,
    discoveryData,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return groundstation(
        "POST",
        "/agent",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "agentDetails" => agentDetails, "discoveryData" => discoveryData
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    reserve_contact(end_time, ground_station, mission_profile_arn, satellite_arn, start_time)
    reserve_contact(end_time, ground_station, mission_profile_arn, satellite_arn, start_time, params::Dict{String,<:Any})

Reserves a contact using specified parameters.

# Arguments
- `end_time`: End time of a contact in UTC.
- `ground_station`: Name of a ground station.
- `mission_profile_arn`: ARN of a mission profile.
- `satellite_arn`: ARN of a satellite
- `start_time`: Start time of a contact in UTC.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tags"`: Tags assigned to a contact.
"""
function reserve_contact(
    endTime,
    groundStation,
    missionProfileArn,
    satelliteArn,
    startTime;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return groundstation(
        "POST",
        "/contact",
        Dict{String,Any}(
            "endTime" => endTime,
            "groundStation" => groundStation,
            "missionProfileArn" => missionProfileArn,
            "satelliteArn" => satelliteArn,
            "startTime" => startTime,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function reserve_contact(
    endTime,
    groundStation,
    missionProfileArn,
    satelliteArn,
    startTime,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return groundstation(
        "POST",
        "/contact",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "endTime" => endTime,
                    "groundStation" => groundStation,
                    "missionProfileArn" => missionProfileArn,
                    "satelliteArn" => satelliteArn,
                    "startTime" => startTime,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Assigns a tag to a resource.

# Arguments
- `resource_arn`: ARN of a resource tag.
- `tags`: Tags assigned to a resource.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return groundstation(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return groundstation(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Deassigns a resource tag.

# Arguments
- `resource_arn`: ARN of a resource.
- `tag_keys`: Keys of a resource tag.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return groundstation(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return groundstation(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_agent_status(agent_id, aggregate_status, component_statuses, task_id)
    update_agent_status(agent_id, aggregate_status, component_statuses, task_id, params::Dict{String,<:Any})

  For use by AWS Ground Station Agent and shouldn't be called directly.  Update the status
of the agent.

# Arguments
- `agent_id`: UUID of agent to update.
- `aggregate_status`: Aggregate status for agent.
- `component_statuses`: List of component statuses for agent.
- `task_id`: GUID of agent task.

"""
function update_agent_status(
    agentId,
    aggregateStatus,
    componentStatuses,
    taskId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return groundstation(
        "PUT",
        "/agent/$(agentId)",
        Dict{String,Any}(
            "aggregateStatus" => aggregateStatus,
            "componentStatuses" => componentStatuses,
            "taskId" => taskId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_agent_status(
    agentId,
    aggregateStatus,
    componentStatuses,
    taskId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return groundstation(
        "PUT",
        "/agent/$(agentId)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "aggregateStatus" => aggregateStatus,
                    "componentStatuses" => componentStatuses,
                    "taskId" => taskId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_config(config_data, config_id, config_type, name)
    update_config(config_data, config_id, config_type, name, params::Dict{String,<:Any})

Updates the Config used when scheduling contacts. Updating a Config will not update the
execution parameters for existing future contacts scheduled with this Config.

# Arguments
- `config_data`: Parameters of a Config.
- `config_id`: UUID of a Config.
- `config_type`: Type of a Config.
- `name`: Name of a Config.

"""
function update_config(
    configData,
    configId,
    configType,
    name;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return groundstation(
        "PUT",
        "/config/$(configType)/$(configId)",
        Dict{String,Any}("configData" => configData, "name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_config(
    configData,
    configId,
    configType,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return groundstation(
        "PUT",
        "/config/$(configType)/$(configId)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("configData" => configData, "name" => name), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_ephemeris(enabled, ephemeris_id)
    update_ephemeris(enabled, ephemeris_id, params::Dict{String,<:Any})

Updates an existing ephemeris

# Arguments
- `enabled`: Whether the ephemeris is enabled or not. Changing this value will not require
  the ephemeris to be re-validated.
- `ephemeris_id`: The AWS Ground Station ephemeris ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"name"`: A name string associated with the ephemeris. Used as a human-readable
  identifier for the ephemeris.
- `"priority"`: Customer-provided priority score to establish the order in which
  overlapping ephemerides should be used. The default for customer-provided ephemeris
  priority is 1, and higher numbers take precedence. Priority must be 1 or greater
"""
function update_ephemeris(
    enabled, ephemerisId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return groundstation(
        "PUT",
        "/ephemeris/$(ephemerisId)",
        Dict{String,Any}("enabled" => enabled);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_ephemeris(
    enabled,
    ephemerisId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return groundstation(
        "PUT",
        "/ephemeris/$(ephemerisId)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("enabled" => enabled), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_mission_profile(mission_profile_id)
    update_mission_profile(mission_profile_id, params::Dict{String,<:Any})

Updates a mission profile. Updating a mission profile will not update the execution
parameters for existing future contacts.

# Arguments
- `mission_profile_id`: UUID of a mission profile.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"contactPostPassDurationSeconds"`: Amount of time after a contact ends that you’d like
  to receive a Ground Station Contact State Change event indicating the pass has finished.
- `"contactPrePassDurationSeconds"`: Amount of time after a contact ends that you’d like
  to receive a Ground Station Contact State Change event indicating the pass has finished.
- `"dataflowEdges"`: A list of lists of ARNs. Each list of ARNs is an edge, with a from
  Config and a to Config.
- `"minimumViableContactDurationSeconds"`: Smallest amount of time in seconds that you’d
  like to see for an available contact. AWS Ground Station will not present you with contacts
  shorter than this duration.
- `"name"`: Name of a mission profile.
- `"streamsKmsKey"`: KMS key to use for encrypting streams.
- `"streamsKmsRole"`: Role to use for encrypting streams with KMS key.
- `"trackingConfigArn"`: ARN of a tracking Config.
"""
function update_mission_profile(
    missionProfileId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return groundstation(
        "PUT",
        "/missionprofile/$(missionProfileId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_mission_profile(
    missionProfileId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return groundstation(
        "PUT",
        "/missionprofile/$(missionProfileId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: elasticache
using AWS.Compat
using AWS.UUIDs

"""
    add_tags_to_resource(resource_name, tag)
    add_tags_to_resource(resource_name, tag, params::Dict{String,<:Any})

A tag is a key-value pair where the key and value are case-sensitive. You can use tags to
categorize and track all your ElastiCache resources, with the exception of global
replication group. When you add or remove tags on replication groups, those actions will be
replicated to all nodes in the replication group. For more information, see Resource-level
permissions.  For example, you can use cost-allocation tags to your ElastiCache resources,
Amazon generates a cost allocation report as a comma-separated value (CSV) file with your
usage and costs aggregated by your tags. You can apply tags that represent business
categories (such as cost centers, application names, or owners) to organize your costs
across multiple services. For more information, see Using Cost Allocation Tags in Amazon
ElastiCache in the ElastiCache User Guide.

# Arguments
- `resource_name`: The Amazon Resource Name (ARN) of the resource to which the tags are to
  be added, for example arn:aws:elasticache:us-west-2:0123456789:cluster:myCluster or
  arn:aws:elasticache:us-west-2:0123456789:snapshot:mySnapshot. ElastiCache resources are
  cluster and snapshot. For more information about ARNs, see Amazon Resource Names (ARNs) and
  Amazon Service Namespaces.
- `tag`: A list of tags to be added to this resource. A tag is a key-value pair. A tag key
  must be accompanied by a tag value, although null is accepted.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: A list of tags to be added to this resource. A tag is a key-value pair. A tag
  key must be accompanied by a tag value, although null is accepted.
"""
function add_tags_to_resource(
    ResourceName, Tag; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticache(
        "AddTagsToResource",
        Dict{String,Any}("ResourceName" => ResourceName, "Tag" => Tag);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_tags_to_resource(
    ResourceName,
    Tag,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "AddTagsToResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceName" => ResourceName, "Tag" => Tag),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    authorize_cache_security_group_ingress(cache_security_group_name, ec2_security_group_name, ec2_security_group_owner_id)
    authorize_cache_security_group_ingress(cache_security_group_name, ec2_security_group_name, ec2_security_group_owner_id, params::Dict{String,<:Any})

Allows network ingress to a cache security group. Applications using ElastiCache must be
running on Amazon EC2, and Amazon EC2 security groups are used as the authorization
mechanism.  You cannot authorize ingress from an Amazon EC2 security group in one region to
an ElastiCache cluster in another region.

# Arguments
- `cache_security_group_name`: The cache security group that allows network ingress.
- `ec2_security_group_name`: The Amazon EC2 security group to be authorized for ingress to
  the cache security group.
- `ec2_security_group_owner_id`: The Amazon account number of the Amazon EC2 security group
  owner. Note that this is not the same thing as an Amazon access key ID - you must provide a
  valid Amazon account number for this parameter.

"""
function authorize_cache_security_group_ingress(
    CacheSecurityGroupName,
    EC2SecurityGroupName,
    EC2SecurityGroupOwnerId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "AuthorizeCacheSecurityGroupIngress",
        Dict{String,Any}(
            "CacheSecurityGroupName" => CacheSecurityGroupName,
            "EC2SecurityGroupName" => EC2SecurityGroupName,
            "EC2SecurityGroupOwnerId" => EC2SecurityGroupOwnerId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function authorize_cache_security_group_ingress(
    CacheSecurityGroupName,
    EC2SecurityGroupName,
    EC2SecurityGroupOwnerId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "AuthorizeCacheSecurityGroupIngress",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CacheSecurityGroupName" => CacheSecurityGroupName,
                    "EC2SecurityGroupName" => EC2SecurityGroupName,
                    "EC2SecurityGroupOwnerId" => EC2SecurityGroupOwnerId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_apply_update_action(service_update_name)
    batch_apply_update_action(service_update_name, params::Dict{String,<:Any})

Apply the service update. For more information on service updates and applying them, see
Applying Service Updates.

# Arguments
- `service_update_name`: The unique ID of the service update

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CacheClusterIds"`: The cache cluster IDs
- `"ReplicationGroupIds"`: The replication group IDs
"""
function batch_apply_update_action(
    ServiceUpdateName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticache(
        "BatchApplyUpdateAction",
        Dict{String,Any}("ServiceUpdateName" => ServiceUpdateName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_apply_update_action(
    ServiceUpdateName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "BatchApplyUpdateAction",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ServiceUpdateName" => ServiceUpdateName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_stop_update_action(service_update_name)
    batch_stop_update_action(service_update_name, params::Dict{String,<:Any})

Stop the service update. For more information on service updates and stopping them, see
Stopping Service Updates.

# Arguments
- `service_update_name`: The unique ID of the service update

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CacheClusterIds"`: The cache cluster IDs
- `"ReplicationGroupIds"`: The replication group IDs
"""
function batch_stop_update_action(
    ServiceUpdateName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticache(
        "BatchStopUpdateAction",
        Dict{String,Any}("ServiceUpdateName" => ServiceUpdateName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_stop_update_action(
    ServiceUpdateName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "BatchStopUpdateAction",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ServiceUpdateName" => ServiceUpdateName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    complete_migration(replication_group_id)
    complete_migration(replication_group_id, params::Dict{String,<:Any})

Complete the migration of data.

# Arguments
- `replication_group_id`: The ID of the replication group to which data is being migrated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Force"`: Forces the migration to stop without ensuring that data is in sync. It is
  recommended to use this option only to abort the migration and not recommended when
  application wants to continue migration to ElastiCache.
"""
function complete_migration(
    ReplicationGroupId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticache(
        "CompleteMigration",
        Dict{String,Any}("ReplicationGroupId" => ReplicationGroupId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function complete_migration(
    ReplicationGroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "CompleteMigration",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ReplicationGroupId" => ReplicationGroupId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    copy_serverless_cache_snapshot(source_serverless_cache_snapshot_name, target_serverless_cache_snapshot_name)
    copy_serverless_cache_snapshot(source_serverless_cache_snapshot_name, target_serverless_cache_snapshot_name, params::Dict{String,<:Any})

Creates a copy of an existing serverless cache’s snapshot. Available for Redis only.

# Arguments
- `source_serverless_cache_snapshot_name`: The identifier of the existing serverless
  cache’s snapshot to be copied. Available for Redis only.
- `target_serverless_cache_snapshot_name`: The identifier for the snapshot to be created.
  Available for Redis only.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"KmsKeyId"`: The identifier of the KMS key used to encrypt the target snapshot.
  Available for Redis only.
- `"Tags"`: A list of tags to be added to the target snapshot resource. A tag is a
  key-value pair. Available for Redis only. Default: NULL
"""
function copy_serverless_cache_snapshot(
    SourceServerlessCacheSnapshotName,
    TargetServerlessCacheSnapshotName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "CopyServerlessCacheSnapshot",
        Dict{String,Any}(
            "SourceServerlessCacheSnapshotName" => SourceServerlessCacheSnapshotName,
            "TargetServerlessCacheSnapshotName" => TargetServerlessCacheSnapshotName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function copy_serverless_cache_snapshot(
    SourceServerlessCacheSnapshotName,
    TargetServerlessCacheSnapshotName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "CopyServerlessCacheSnapshot",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "SourceServerlessCacheSnapshotName" =>
                        SourceServerlessCacheSnapshotName,
                    "TargetServerlessCacheSnapshotName" =>
                        TargetServerlessCacheSnapshotName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    copy_snapshot(source_snapshot_name, target_snapshot_name)
    copy_snapshot(source_snapshot_name, target_snapshot_name, params::Dict{String,<:Any})

Makes a copy of an existing snapshot.  This operation is valid for Redis only.   Users or
groups that have permissions to use the CopySnapshot operation can create their own Amazon
S3 buckets and copy snapshots to it. To control access to your snapshots, use an IAM policy
to control who has the ability to use the CopySnapshot operation. For more information
about using IAM to control the use of ElastiCache operations, see Exporting Snapshots and
Authentication &amp; Access Control.  You could receive the following error messages.
Error Messages     Error Message: The S3 bucket %s is outside of the region.  Solution:
Create an Amazon S3 bucket in the same region as your snapshot. For more information, see
Step 1: Create an Amazon S3 Bucket in the ElastiCache User Guide.    Error Message: The S3
bucket %s does not exist.  Solution: Create an Amazon S3 bucket in the same region as your
snapshot. For more information, see Step 1: Create an Amazon S3 Bucket in the ElastiCache
User Guide.    Error Message: The S3 bucket %s is not owned by the authenticated user.
Solution: Create an Amazon S3 bucket in the same region as your snapshot. For more
information, see Step 1: Create an Amazon S3 Bucket in the ElastiCache User Guide.    Error
Message: The authenticated user does not have sufficient permissions to perform the desired
activity.  Solution: Contact your system administrator to get the needed permissions.
Error Message: The S3 bucket %s already contains an object with key %s.  Solution: Give the
TargetSnapshotName a new and unique value. If exporting a snapshot, you could alternatively
create a new Amazon S3 bucket and use this same value for TargetSnapshotName.    Error
Message:  ElastiCache has not been granted READ permissions %s on the S3 Bucket.  Solution:
Add List and Read permissions on the bucket. For more information, see Step 2: Grant
ElastiCache Access to Your Amazon S3 Bucket in the ElastiCache User Guide.    Error
Message:  ElastiCache has not been granted WRITE permissions %s on the S3 Bucket.
Solution: Add Upload/Delete permissions on the bucket. For more information, see Step 2:
Grant ElastiCache Access to Your Amazon S3 Bucket in the ElastiCache User Guide.    Error
Message:  ElastiCache has not been granted READ_ACP permissions %s on the S3 Bucket.
Solution: Add View Permissions on the bucket. For more information, see Step 2: Grant
ElastiCache Access to Your Amazon S3 Bucket in the ElastiCache User Guide.

# Arguments
- `source_snapshot_name`: The name of an existing snapshot from which to make a copy.
- `target_snapshot_name`: A name for the snapshot copy. ElastiCache does not permit
  overwriting a snapshot, therefore this name must be unique within its context - ElastiCache
  or an Amazon S3 bucket if exporting.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"KmsKeyId"`: The ID of the KMS key used to encrypt the target snapshot.
- `"Tags"`: A list of tags to be added to this resource. A tag is a key-value pair. A tag
  key must be accompanied by a tag value, although null is accepted.
- `"TargetBucket"`: The Amazon S3 bucket to which the snapshot is exported. This parameter
  is used only when exporting a snapshot for external access. When using this parameter to
  export a snapshot, be sure Amazon ElastiCache has the needed permissions to this S3 bucket.
  For more information, see Step 2: Grant ElastiCache Access to Your Amazon S3 Bucket in the
  Amazon ElastiCache User Guide. For more information, see Exporting a Snapshot in the Amazon
  ElastiCache User Guide.
"""
function copy_snapshot(
    SourceSnapshotName,
    TargetSnapshotName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "CopySnapshot",
        Dict{String,Any}(
            "SourceSnapshotName" => SourceSnapshotName,
            "TargetSnapshotName" => TargetSnapshotName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function copy_snapshot(
    SourceSnapshotName,
    TargetSnapshotName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "CopySnapshot",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "SourceSnapshotName" => SourceSnapshotName,
                    "TargetSnapshotName" => TargetSnapshotName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_cache_cluster(cache_cluster_id)
    create_cache_cluster(cache_cluster_id, params::Dict{String,<:Any})

Creates a cluster. All nodes in the cluster run the same protocol-compliant cache engine
software, either Memcached or Redis. This operation is not supported for Redis (cluster
mode enabled) clusters.

# Arguments
- `cache_cluster_id`: The node group (shard) identifier. This parameter is stored as a
  lowercase string.  Constraints:    A name must contain from 1 to 50 alphanumeric characters
  or hyphens.   The first character must be a letter.   A name cannot end with a hyphen or
  contain two consecutive hyphens.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AZMode"`: Specifies whether the nodes in this Memcached cluster are created in a single
  Availability Zone or created across multiple Availability Zones in the cluster's region.
  This parameter is only supported for Memcached clusters. If the AZMode and
  PreferredAvailabilityZones are not specified, ElastiCache assumes single-az mode.
- `"AuthToken"`:  Reserved parameter. The password used to access a password protected
  server. Password constraints:   Must be only printable ASCII characters.   Must be at least
  16 characters and no more than 128 characters in length.   The only permitted printable
  special characters are !, &amp;, #, , ^, &lt;, &gt;, and -. Other printable special
  characters cannot be used in the AUTH token.   For more information, see AUTH password at
  http://redis.io/commands/AUTH.
- `"AutoMinorVersionUpgrade"`:  If you are running Redis engine version 6.0 or later, set
  this parameter to yes if you want to opt-in to the next auto minor version upgrade
  campaign. This parameter is disabled for previous versions.
- `"CacheNodeType"`: The compute and memory capacity of the nodes in the node group
  (shard). The following node types are supported by ElastiCache. Generally speaking, the
  current generation types provide more memory and computational power at lower cost when
  compared to their equivalent previous generation counterparts.   General purpose:   Current
  generation:   M7g node types: cache.m7g.large, cache.m7g.xlarge, cache.m7g.2xlarge,
  cache.m7g.4xlarge, cache.m7g.8xlarge, cache.m7g.12xlarge, cache.m7g.16xlarge   For region
  availability, see Supported Node Types    M6g node types (available only for Redis engine
  version 5.0.6 onward and for Memcached engine version 1.5.16 onward): cache.m6g.large,
  cache.m6g.xlarge, cache.m6g.2xlarge, cache.m6g.4xlarge, cache.m6g.8xlarge,
  cache.m6g.12xlarge, cache.m6g.16xlarge   M5 node types: cache.m5.large, cache.m5.xlarge,
  cache.m5.2xlarge, cache.m5.4xlarge, cache.m5.12xlarge, cache.m5.24xlarge   M4 node types:
  cache.m4.large, cache.m4.xlarge, cache.m4.2xlarge, cache.m4.4xlarge, cache.m4.10xlarge
  T4g node types (available only for Redis engine version 5.0.6 onward and Memcached engine
  version 1.5.16 onward): cache.t4g.micro, cache.t4g.small, cache.t4g.medium   T3 node types:
  cache.t3.micro, cache.t3.small, cache.t3.medium   T2 node types: cache.t2.micro,
  cache.t2.small, cache.t2.medium    Previous generation: (not recommended. Existing clusters
  are still supported but creation of new clusters is not supported for these types.)  T1
  node types: cache.t1.micro   M1 node types: cache.m1.small, cache.m1.medium,
  cache.m1.large, cache.m1.xlarge   M3 node types: cache.m3.medium, cache.m3.large,
  cache.m3.xlarge, cache.m3.2xlarge      Compute optimized:   Previous generation: (not
  recommended. Existing clusters are still supported but creation of new clusters is not
  supported for these types.)  C1 node types: cache.c1.xlarge      Memory optimized:
  Current generation:   R7g node types: cache.r7g.large, cache.r7g.xlarge, cache.r7g.2xlarge,
  cache.r7g.4xlarge, cache.r7g.8xlarge, cache.r7g.12xlarge, cache.r7g.16xlarge   For region
  availability, see Supported Node Types    R6g node types (available only for Redis engine
  version 5.0.6 onward and for Memcached engine version 1.5.16 onward): cache.r6g.large,
  cache.r6g.xlarge, cache.r6g.2xlarge, cache.r6g.4xlarge, cache.r6g.8xlarge,
  cache.r6g.12xlarge, cache.r6g.16xlarge   R5 node types: cache.r5.large, cache.r5.xlarge,
  cache.r5.2xlarge, cache.r5.4xlarge, cache.r5.12xlarge, cache.r5.24xlarge   R4 node types:
  cache.r4.large, cache.r4.xlarge, cache.r4.2xlarge, cache.r4.4xlarge, cache.r4.8xlarge,
  cache.r4.16xlarge    Previous generation: (not recommended. Existing clusters are still
  supported but creation of new clusters is not supported for these types.)  M2 node types:
  cache.m2.xlarge, cache.m2.2xlarge, cache.m2.4xlarge   R3 node types: cache.r3.large,
  cache.r3.xlarge, cache.r3.2xlarge, cache.r3.4xlarge, cache.r3.8xlarge       Additional node
  type info    All current generation instance types are created in Amazon VPC by default.
  Redis append-only files (AOF) are not supported for T1 or T2 instances.   Redis Multi-AZ
  with automatic failover is not supported on T1 instances.   Redis configuration variables
  appendonly and appendfsync are not supported on Redis version 2.8.22 and later.
- `"CacheParameterGroupName"`: The name of the parameter group to associate with this
  cluster. If this argument is omitted, the default parameter group for the specified engine
  is used. You cannot use any parameter group which has cluster-enabled='yes' when creating a
  cluster.
- `"CacheSecurityGroupNames"`: A list of security group names to associate with this
  cluster. Use this parameter only when you are creating a cluster outside of an Amazon
  Virtual Private Cloud (Amazon VPC).
- `"CacheSubnetGroupName"`: The name of the subnet group to be used for the cluster. Use
  this parameter only when you are creating a cluster in an Amazon Virtual Private Cloud
  (Amazon VPC).  If you're going to launch your cluster in an Amazon VPC, you need to create
  a subnet group before you start creating a cluster. For more information, see Subnets and
  Subnet Groups.
- `"Engine"`: The name of the cache engine to be used for this cluster. Valid values for
  this parameter are: memcached | redis
- `"EngineVersion"`: The version number of the cache engine to be used for this cluster. To
  view the supported cache engine versions, use the DescribeCacheEngineVersions operation.
  Important: You can upgrade to a newer engine version (see Selecting a Cache Engine and
  Version), but you cannot downgrade to an earlier engine version. If you want to use an
  earlier engine version, you must delete the existing cluster or replication group and
  create it anew with the earlier engine version.
- `"IpDiscovery"`: The network type you choose when modifying a cluster, either ipv4 |
  ipv6. IPv6 is supported for workloads using Redis engine version 6.2 onward or Memcached
  engine version 1.6.6 on all instances built on the Nitro system.
- `"LogDeliveryConfigurations"`: Specifies the destination, format and type of the logs.
- `"NetworkType"`: Must be either ipv4 | ipv6 | dual_stack. IPv6 is supported for workloads
  using Redis engine version 6.2 onward or Memcached engine version 1.6.6 on all instances
  built on the Nitro system.
- `"NotificationTopicArn"`: The Amazon Resource Name (ARN) of the Amazon Simple
  Notification Service (SNS) topic to which notifications are sent.  The Amazon SNS topic
  owner must be the same as the cluster owner.
- `"NumCacheNodes"`: The initial number of cache nodes that the cluster has. For clusters
  running Redis, this value must be 1. For clusters running Memcached, this value must be
  between 1 and 40. If you need more than 40 nodes for your Memcached cluster, please fill
  out the ElastiCache Limit Increase Request form at
  http://aws.amazon.com/contact-us/elasticache-node-limit-request/.
- `"OutpostMode"`: Specifies whether the nodes in the cluster are created in a single
  outpost or across multiple outposts.
- `"Port"`: The port number on which each of the cache nodes accepts connections.
- `"PreferredAvailabilityZone"`: The EC2 Availability Zone in which the cluster is created.
  All nodes belonging to this cluster are placed in the preferred Availability Zone. If you
  want to create your nodes across multiple Availability Zones, use
  PreferredAvailabilityZones. Default: System chosen Availability Zone.
- `"PreferredAvailabilityZones"`: A list of the Availability Zones in which cache nodes are
  created. The order of the zones in the list is not important. This option is only supported
  on Memcached.  If you are creating your cluster in an Amazon VPC (recommended) you can only
  locate nodes in Availability Zones that are associated with the subnets in the selected
  subnet group. The number of Availability Zones listed must equal the value of
  NumCacheNodes.  If you want all the nodes in the same Availability Zone, use
  PreferredAvailabilityZone instead, or repeat the Availability Zone multiple times in the
  list. Default: System chosen Availability Zones.
- `"PreferredMaintenanceWindow"`: Specifies the weekly time range during which maintenance
  on the cluster is performed. It is specified as a range in the format
  ddd:hh24:mi-ddd:hh24:mi (24H Clock UTC). The minimum maintenance window is a 60 minute
  period.
- `"PreferredOutpostArn"`: The outpost ARN in which the cache cluster is created.
- `"PreferredOutpostArns"`: The outpost ARNs in which the cache cluster is created.
- `"ReplicationGroupId"`: The ID of the replication group to which this cluster should
  belong. If this parameter is specified, the cluster is added to the specified replication
  group as a read replica; otherwise, the cluster is a standalone primary that is not part of
  any replication group. If the specified replication group is Multi-AZ enabled and the
  Availability Zone is not specified, the cluster is created in Availability Zones that
  provide the best spread of read replicas across Availability Zones.  This parameter is only
  valid if the Engine parameter is redis.
- `"SecurityGroupIds"`: One or more VPC security groups associated with the cluster. Use
  this parameter only when you are creating a cluster in an Amazon Virtual Private Cloud
  (Amazon VPC).
- `"SnapshotArns"`: A single-element string list containing an Amazon Resource Name (ARN)
  that uniquely identifies a Redis RDB snapshot file stored in Amazon S3. The snapshot file
  is used to populate the node group (shard). The Amazon S3 object name in the ARN cannot
  contain any commas.  This parameter is only valid if the Engine parameter is redis.
  Example of an Amazon S3 ARN: arn:aws:s3:::my_bucket/snapshot1.rdb
- `"SnapshotName"`: The name of a Redis snapshot from which to restore data into the new
  node group (shard). The snapshot status changes to restoring while the new node group
  (shard) is being created.  This parameter is only valid if the Engine parameter is redis.
- `"SnapshotRetentionLimit"`: The number of days for which ElastiCache retains automatic
  snapshots before deleting them. For example, if you set SnapshotRetentionLimit to 5, a
  snapshot taken today is retained for 5 days before being deleted.  This parameter is only
  valid if the Engine parameter is redis.  Default: 0 (i.e., automatic backups are disabled
  for this cache cluster).
- `"SnapshotWindow"`: The daily time range (in UTC) during which ElastiCache begins taking
  a daily snapshot of your node group (shard). Example: 05:00-09:00  If you do not specify
  this parameter, ElastiCache automatically chooses an appropriate time range.  This
  parameter is only valid if the Engine parameter is redis.
- `"Tags"`: A list of tags to be added to this resource.
- `"TransitEncryptionEnabled"`: A flag that enables in-transit encryption when set to true.
"""
function create_cache_cluster(
    CacheClusterId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticache(
        "CreateCacheCluster",
        Dict{String,Any}("CacheClusterId" => CacheClusterId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_cache_cluster(
    CacheClusterId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "CreateCacheCluster",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("CacheClusterId" => CacheClusterId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_cache_parameter_group(cache_parameter_group_family, cache_parameter_group_name, description)
    create_cache_parameter_group(cache_parameter_group_family, cache_parameter_group_name, description, params::Dict{String,<:Any})

Creates a new Amazon ElastiCache cache parameter group. An ElastiCache cache parameter
group is a collection of parameters and their values that are applied to all of the nodes
in any cluster or replication group using the CacheParameterGroup. A newly created
CacheParameterGroup is an exact duplicate of the default parameter group for the
CacheParameterGroupFamily. To customize the newly created CacheParameterGroup you can
change the values of specific parameters. For more information, see:
ModifyCacheParameterGroup in the ElastiCache API Reference.    Parameters and Parameter
Groups in the ElastiCache User Guide.

# Arguments
- `cache_parameter_group_family`: The name of the cache parameter group family that the
  cache parameter group can be used with. Valid values are: memcached1.4 | memcached1.5 |
  memcached1.6 | redis2.6 | redis2.8 | redis3.2 | redis4.0 | redis5.0 | redis6.x | redis7
- `cache_parameter_group_name`: A user-specified name for the cache parameter group.
- `description`: A user-specified description for the cache parameter group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: A list of tags to be added to this resource. A tag is a key-value pair. A tag
  key must be accompanied by a tag value, although null is accepted.
"""
function create_cache_parameter_group(
    CacheParameterGroupFamily,
    CacheParameterGroupName,
    Description;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "CreateCacheParameterGroup",
        Dict{String,Any}(
            "CacheParameterGroupFamily" => CacheParameterGroupFamily,
            "CacheParameterGroupName" => CacheParameterGroupName,
            "Description" => Description,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_cache_parameter_group(
    CacheParameterGroupFamily,
    CacheParameterGroupName,
    Description,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "CreateCacheParameterGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CacheParameterGroupFamily" => CacheParameterGroupFamily,
                    "CacheParameterGroupName" => CacheParameterGroupName,
                    "Description" => Description,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_cache_security_group(cache_security_group_name, description)
    create_cache_security_group(cache_security_group_name, description, params::Dict{String,<:Any})

Creates a new cache security group. Use a cache security group to control access to one or
more clusters. Cache security groups are only used when you are creating a cluster outside
of an Amazon Virtual Private Cloud (Amazon VPC). If you are creating a cluster inside of a
VPC, use a cache subnet group instead. For more information, see CreateCacheSubnetGroup.

# Arguments
- `cache_security_group_name`: A name for the cache security group. This value is stored as
  a lowercase string. Constraints: Must contain no more than 255 alphanumeric characters.
  Cannot be the word \"Default\". Example: mysecuritygroup
- `description`: A description for the cache security group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: A list of tags to be added to this resource. A tag is a key-value pair. A tag
  key must be accompanied by a tag value, although null is accepted.
"""
function create_cache_security_group(
    CacheSecurityGroupName, Description; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticache(
        "CreateCacheSecurityGroup",
        Dict{String,Any}(
            "CacheSecurityGroupName" => CacheSecurityGroupName, "Description" => Description
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_cache_security_group(
    CacheSecurityGroupName,
    Description,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "CreateCacheSecurityGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CacheSecurityGroupName" => CacheSecurityGroupName,
                    "Description" => Description,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_cache_subnet_group(cache_subnet_group_description, cache_subnet_group_name, subnet_identifier)
    create_cache_subnet_group(cache_subnet_group_description, cache_subnet_group_name, subnet_identifier, params::Dict{String,<:Any})

Creates a new cache subnet group. Use this parameter only when you are creating a cluster
in an Amazon Virtual Private Cloud (Amazon VPC).

# Arguments
- `cache_subnet_group_description`: A description for the cache subnet group.
- `cache_subnet_group_name`: A name for the cache subnet group. This value is stored as a
  lowercase string. Constraints: Must contain no more than 255 alphanumeric characters or
  hyphens. Example: mysubnetgroup
- `subnet_identifier`: A list of VPC subnet IDs for the cache subnet group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"SubnetIds"`: A list of VPC subnet IDs for the cache subnet group.
- `"Tags"`: A list of tags to be added to this resource. A tag is a key-value pair. A tag
  key must be accompanied by a tag value, although null is accepted.
"""
function create_cache_subnet_group(
    CacheSubnetGroupDescription,
    CacheSubnetGroupName,
    SubnetIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "CreateCacheSubnetGroup",
        Dict{String,Any}(
            "CacheSubnetGroupDescription" => CacheSubnetGroupDescription,
            "CacheSubnetGroupName" => CacheSubnetGroupName,
            "SubnetIdentifier" => SubnetIdentifier,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_cache_subnet_group(
    CacheSubnetGroupDescription,
    CacheSubnetGroupName,
    SubnetIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "CreateCacheSubnetGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CacheSubnetGroupDescription" => CacheSubnetGroupDescription,
                    "CacheSubnetGroupName" => CacheSubnetGroupName,
                    "SubnetIdentifier" => SubnetIdentifier,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_global_replication_group(global_replication_group_id_suffix, primary_replication_group_id)
    create_global_replication_group(global_replication_group_id_suffix, primary_replication_group_id, params::Dict{String,<:Any})

Global Datastore for Redis offers fully managed, fast, reliable and secure cross-region
replication. Using Global Datastore for Redis, you can create cross-region read replica
clusters for ElastiCache for Redis to enable low-latency reads and disaster recovery across
regions. For more information, see Replication Across Regions Using Global Datastore.
The GlobalReplicationGroupIdSuffix is the name of the Global datastore.   The
PrimaryReplicationGroupId represents the name of the primary cluster that accepts writes
and will replicate updates to the secondary cluster.

# Arguments
- `global_replication_group_id_suffix`: The suffix name of a Global datastore. Amazon
  ElastiCache automatically applies a prefix to the Global datastore ID when it is created.
  Each Amazon Region has its own prefix. For instance, a Global datastore ID created in the
  US-West-1 region will begin with \"dsdfu\" along with the suffix name you provide. The
  suffix, combined with the auto-generated prefix, guarantees uniqueness of the Global
  datastore name across multiple regions.  For a full list of Amazon Regions and their
  respective Global datastore iD prefixes, see Using the Amazon CLI with Global datastores .
- `primary_replication_group_id`: The name of the primary cluster that accepts writes and
  will replicate updates to the secondary cluster.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"GlobalReplicationGroupDescription"`: Provides details of the Global datastore
"""
function create_global_replication_group(
    GlobalReplicationGroupIdSuffix,
    PrimaryReplicationGroupId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "CreateGlobalReplicationGroup",
        Dict{String,Any}(
            "GlobalReplicationGroupIdSuffix" => GlobalReplicationGroupIdSuffix,
            "PrimaryReplicationGroupId" => PrimaryReplicationGroupId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_global_replication_group(
    GlobalReplicationGroupIdSuffix,
    PrimaryReplicationGroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "CreateGlobalReplicationGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "GlobalReplicationGroupIdSuffix" => GlobalReplicationGroupIdSuffix,
                    "PrimaryReplicationGroupId" => PrimaryReplicationGroupId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_replication_group(replication_group_description, replication_group_id)
    create_replication_group(replication_group_description, replication_group_id, params::Dict{String,<:Any})

Creates a Redis (cluster mode disabled) or a Redis (cluster mode enabled) replication
group. This API can be used to create a standalone regional replication group or a
secondary replication group associated with a Global datastore. A Redis (cluster mode
disabled) replication group is a collection of nodes, where one of the nodes is a
read/write primary and the others are read-only replicas. Writes to the primary are
asynchronously propagated to the replicas. A Redis cluster-mode enabled cluster is
comprised of from 1 to 90 shards (API/CLI: node groups). Each shard has a primary node and
up to 5 read-only replica nodes. The configuration can range from 90 shards and 0 replicas
to 15 shards and 5 replicas, which is the maximum number or replicas allowed.  The node or
shard limit can be increased to a maximum of 500 per cluster if the Redis engine version is
5.0.6 or higher. For example, you can choose to configure a 500 node cluster that ranges
between 83 shards (one primary and 5 replicas per shard) and 500 shards (single primary and
no replicas). Make sure there are enough available IP addresses to accommodate the
increase. Common pitfalls include the subnets in the subnet group have too small a CIDR
range or the subnets are shared and heavily used by other clusters. For more information,
see Creating a Subnet Group. For versions below 5.0.6, the limit is 250 per cluster. To
request a limit increase, see Amazon Service Limits and choose the limit type Nodes per
cluster per instance type.  When a Redis (cluster mode disabled) replication group has been
successfully created, you can add one or more read replicas to it, up to a total of 5 read
replicas. If you need to increase or decrease the number of node groups (console: shards),
you can avail yourself of ElastiCache for Redis' scaling. For more information, see Scaling
ElastiCache for Redis Clusters in the ElastiCache User Guide.  This operation is valid for
Redis only.

# Arguments
- `replication_group_description`: A user-created description for the replication group.
- `replication_group_id`: The replication group identifier. This parameter is stored as a
  lowercase string. Constraints:   A name must contain from 1 to 40 alphanumeric characters
  or hyphens.   The first character must be a letter.   A name cannot end with a hyphen or
  contain two consecutive hyphens.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AtRestEncryptionEnabled"`: A flag that enables encryption at rest when set to true. You
  cannot modify the value of AtRestEncryptionEnabled after the replication group is created.
  To enable encryption at rest on a replication group you must set AtRestEncryptionEnabled to
  true when you create the replication group.   Required: Only available when creating a
  replication group in an Amazon VPC using redis version 3.2.6, 4.x or later. Default: false
- `"AuthToken"`:  Reserved parameter. The password used to access a password protected
  server.  AuthToken can be specified only on replication groups where
  TransitEncryptionEnabled is true.  For HIPAA compliance, you must specify
  TransitEncryptionEnabled as true, an AuthToken, and a CacheSubnetGroup.  Password
  constraints:   Must be only printable ASCII characters.   Must be at least 16 characters
  and no more than 128 characters in length.   The only permitted printable special
  characters are !, &amp;, #, , ^, &lt;, &gt;, and -. Other printable special characters
  cannot be used in the AUTH token.   For more information, see AUTH password at
  http://redis.io/commands/AUTH.
- `"AutoMinorVersionUpgrade"`:  If you are running Redis engine version 6.0 or later, set
  this parameter to yes if you want to opt-in to the next auto minor version upgrade
  campaign. This parameter is disabled for previous versions.
- `"AutomaticFailoverEnabled"`: Specifies whether a read-only replica is automatically
  promoted to read/write primary if the existing primary fails.  AutomaticFailoverEnabled
  must be enabled for Redis (cluster mode enabled) replication groups. Default: false
- `"CacheNodeType"`: The compute and memory capacity of the nodes in the node group
  (shard). The following node types are supported by ElastiCache. Generally speaking, the
  current generation types provide more memory and computational power at lower cost when
  compared to their equivalent previous generation counterparts.   General purpose:   Current
  generation:   M7g node types: cache.m7g.large, cache.m7g.xlarge, cache.m7g.2xlarge,
  cache.m7g.4xlarge, cache.m7g.8xlarge, cache.m7g.12xlarge, cache.m7g.16xlarge   For region
  availability, see Supported Node Types    M6g node types (available only for Redis engine
  version 5.0.6 onward and for Memcached engine version 1.5.16 onward): cache.m6g.large,
  cache.m6g.xlarge, cache.m6g.2xlarge, cache.m6g.4xlarge, cache.m6g.8xlarge,
  cache.m6g.12xlarge, cache.m6g.16xlarge   M5 node types: cache.m5.large, cache.m5.xlarge,
  cache.m5.2xlarge, cache.m5.4xlarge, cache.m5.12xlarge, cache.m5.24xlarge   M4 node types:
  cache.m4.large, cache.m4.xlarge, cache.m4.2xlarge, cache.m4.4xlarge, cache.m4.10xlarge
  T4g node types (available only for Redis engine version 5.0.6 onward and Memcached engine
  version 1.5.16 onward): cache.t4g.micro, cache.t4g.small, cache.t4g.medium   T3 node types:
  cache.t3.micro, cache.t3.small, cache.t3.medium   T2 node types: cache.t2.micro,
  cache.t2.small, cache.t2.medium    Previous generation: (not recommended. Existing clusters
  are still supported but creation of new clusters is not supported for these types.)  T1
  node types: cache.t1.micro   M1 node types: cache.m1.small, cache.m1.medium,
  cache.m1.large, cache.m1.xlarge   M3 node types: cache.m3.medium, cache.m3.large,
  cache.m3.xlarge, cache.m3.2xlarge      Compute optimized:   Previous generation: (not
  recommended. Existing clusters are still supported but creation of new clusters is not
  supported for these types.)  C1 node types: cache.c1.xlarge      Memory optimized:
  Current generation:   R7g node types: cache.r7g.large, cache.r7g.xlarge, cache.r7g.2xlarge,
  cache.r7g.4xlarge, cache.r7g.8xlarge, cache.r7g.12xlarge, cache.r7g.16xlarge   For region
  availability, see Supported Node Types    R6g node types (available only for Redis engine
  version 5.0.6 onward and for Memcached engine version 1.5.16 onward): cache.r6g.large,
  cache.r6g.xlarge, cache.r6g.2xlarge, cache.r6g.4xlarge, cache.r6g.8xlarge,
  cache.r6g.12xlarge, cache.r6g.16xlarge   R5 node types: cache.r5.large, cache.r5.xlarge,
  cache.r5.2xlarge, cache.r5.4xlarge, cache.r5.12xlarge, cache.r5.24xlarge   R4 node types:
  cache.r4.large, cache.r4.xlarge, cache.r4.2xlarge, cache.r4.4xlarge, cache.r4.8xlarge,
  cache.r4.16xlarge    Previous generation: (not recommended. Existing clusters are still
  supported but creation of new clusters is not supported for these types.)  M2 node types:
  cache.m2.xlarge, cache.m2.2xlarge, cache.m2.4xlarge   R3 node types: cache.r3.large,
  cache.r3.xlarge, cache.r3.2xlarge, cache.r3.4xlarge, cache.r3.8xlarge       Additional node
  type info    All current generation instance types are created in Amazon VPC by default.
  Redis append-only files (AOF) are not supported for T1 or T2 instances.   Redis Multi-AZ
  with automatic failover is not supported on T1 instances.   Redis configuration variables
  appendonly and appendfsync are not supported on Redis version 2.8.22 and later.
- `"CacheParameterGroupName"`: The name of the parameter group to associate with this
  replication group. If this argument is omitted, the default cache parameter group for the
  specified engine is used. If you are running Redis version 3.2.4 or later, only one node
  group (shard), and want to use a default parameter group, we recommend that you specify the
  parameter group by name.    To create a Redis (cluster mode disabled) replication group,
  use CacheParameterGroupName=default.redis3.2.   To create a Redis (cluster mode enabled)
  replication group, use CacheParameterGroupName=default.redis3.2.cluster.on.
- `"CacheSecurityGroupNames"`: A list of cache security group names to associate with this
  replication group.
- `"CacheSubnetGroupName"`: The name of the cache subnet group to be used for the
  replication group.  If you're going to launch your cluster in an Amazon VPC, you need to
  create a subnet group before you start creating a cluster. For more information, see
  Subnets and Subnet Groups.
- `"ClusterMode"`: Enabled or Disabled. To modify cluster mode from Disabled to Enabled,
  you must first set the cluster mode to Compatible. Compatible mode allows your Redis
  clients to connect using both cluster mode enabled and cluster mode disabled. After you
  migrate all Redis clients to use cluster mode enabled, you can then complete cluster mode
  configuration and set the cluster mode to Enabled.
- `"DataTieringEnabled"`: Enables data tiering. Data tiering is only supported for
  replication groups using the r6gd node type. This parameter must be set to true when using
  r6gd nodes. For more information, see Data tiering.
- `"Engine"`: The name of the cache engine to be used for the clusters in this replication
  group. The value must be set to Redis.
- `"EngineVersion"`: The version number of the cache engine to be used for the clusters in
  this replication group. To view the supported cache engine versions, use the
  DescribeCacheEngineVersions operation.  Important: You can upgrade to a newer engine
  version (see Selecting a Cache Engine and Version) in the ElastiCache User Guide, but you
  cannot downgrade to an earlier engine version. If you want to use an earlier engine
  version, you must delete the existing cluster or replication group and create it anew with
  the earlier engine version.
- `"GlobalReplicationGroupId"`: The name of the Global datastore
- `"IpDiscovery"`: The network type you choose when creating a replication group, either
  ipv4 | ipv6. IPv6 is supported for workloads using Redis engine version 6.2 onward or
  Memcached engine version 1.6.6 on all instances built on the Nitro system.
- `"KmsKeyId"`: The ID of the KMS key used to encrypt the disk in the cluster.
- `"LogDeliveryConfigurations"`: Specifies the destination, format and type of the logs.
- `"MultiAZEnabled"`: A flag indicating if you have Multi-AZ enabled to enhance fault
  tolerance. For more information, see Minimizing Downtime: Multi-AZ.
- `"NetworkType"`: Must be either ipv4 | ipv6 | dual_stack. IPv6 is supported for workloads
  using Redis engine version 6.2 onward or Memcached engine version 1.6.6 on all instances
  built on the Nitro system.
- `"NodeGroupConfiguration"`: A list of node group (shard) configuration options. Each node
  group (shard) configuration has the following members: PrimaryAvailabilityZone,
  ReplicaAvailabilityZones, ReplicaCount, and Slots. If you're creating a Redis (cluster mode
  disabled) or a Redis (cluster mode enabled) replication group, you can use this parameter
  to individually configure each node group (shard), or you can omit this parameter. However,
  it is required when seeding a Redis (cluster mode enabled) cluster from a S3 rdb file. You
  must configure each node group (shard) using this parameter because you must specify the
  slots for each node group.
- `"NotificationTopicArn"`: The Amazon Resource Name (ARN) of the Amazon Simple
  Notification Service (SNS) topic to which notifications are sent.  The Amazon SNS topic
  owner must be the same as the cluster owner.
- `"NumCacheClusters"`: The number of clusters this replication group initially has. This
  parameter is not used if there is more than one node group (shard). You should use
  ReplicasPerNodeGroup instead. If AutomaticFailoverEnabled is true, the value of this
  parameter must be at least 2. If AutomaticFailoverEnabled is false you can omit this
  parameter (it will default to 1), or you can explicitly set it to a value between 2 and 6.
  The maximum permitted value for NumCacheClusters is 6 (1 primary plus 5 replicas).
- `"NumNodeGroups"`: An optional parameter that specifies the number of node groups
  (shards) for this Redis (cluster mode enabled) replication group. For Redis (cluster mode
  disabled) either omit this parameter or set it to 1. Default: 1
- `"Port"`: The port number on which each member of the replication group accepts
  connections.
- `"PreferredCacheClusterAZs"`: A list of EC2 Availability Zones in which the replication
  group's clusters are created. The order of the Availability Zones in the list is the order
  in which clusters are allocated. The primary cluster is created in the first AZ in the
  list. This parameter is not used if there is more than one node group (shard). You should
  use NodeGroupConfiguration instead.  If you are creating your replication group in an
  Amazon VPC (recommended), you can only locate clusters in Availability Zones associated
  with the subnets in the selected subnet group. The number of Availability Zones listed must
  equal the value of NumCacheClusters.  Default: system chosen Availability Zones.
- `"PreferredMaintenanceWindow"`: Specifies the weekly time range during which maintenance
  on the cluster is performed. It is specified as a range in the format
  ddd:hh24:mi-ddd:hh24:mi (24H Clock UTC). The minimum maintenance window is a 60 minute
  period. Valid values for ddd are:    sun     mon     tue     wed     thu     fri     sat
  Example: sun:23:00-mon:01:30
- `"PrimaryClusterId"`: The identifier of the cluster that serves as the primary for this
  replication group. This cluster must already exist and have a status of available. This
  parameter is not required if NumCacheClusters, NumNodeGroups, or ReplicasPerNodeGroup is
  specified.
- `"ReplicasPerNodeGroup"`: An optional parameter that specifies the number of replica
  nodes in each node group (shard). Valid values are 0 to 5.
- `"SecurityGroupIds"`: One or more Amazon VPC security groups associated with this
  replication group. Use this parameter only when you are creating a replication group in an
  Amazon Virtual Private Cloud (Amazon VPC).
- `"ServerlessCacheSnapshotName"`: The name of the snapshot used to create a replication
  group. Available for Redis only.
- `"SnapshotArns"`: A list of Amazon Resource Names (ARN) that uniquely identify the Redis
  RDB snapshot files stored in Amazon S3. The snapshot files are used to populate the new
  replication group. The Amazon S3 object name in the ARN cannot contain any commas. The new
  replication group will have the number of node groups (console: shards) specified by the
  parameter NumNodeGroups or the number of node groups configured by NodeGroupConfiguration
  regardless of the number of ARNs specified here. Example of an Amazon S3 ARN:
  arn:aws:s3:::my_bucket/snapshot1.rdb
- `"SnapshotName"`: The name of a snapshot from which to restore data into the new
  replication group. The snapshot status changes to restoring while the new replication group
  is being created.
- `"SnapshotRetentionLimit"`: The number of days for which ElastiCache retains automatic
  snapshots before deleting them. For example, if you set SnapshotRetentionLimit to 5, a
  snapshot that was taken today is retained for 5 days before being deleted. Default: 0
  (i.e., automatic backups are disabled for this cluster).
- `"SnapshotWindow"`: The daily time range (in UTC) during which ElastiCache begins taking
  a daily snapshot of your node group (shard). Example: 05:00-09:00  If you do not specify
  this parameter, ElastiCache automatically chooses an appropriate time range.
- `"Tags"`: A list of tags to be added to this resource. Tags are comma-separated key,value
  pairs (e.g. Key=myKey, Value=myKeyValue. You can include multiple tags as shown following:
  Key=myKey, Value=myKeyValue Key=mySecondKey, Value=mySecondKeyValue. Tags on replication
  groups will be replicated to all nodes.
- `"TransitEncryptionEnabled"`: A flag that enables in-transit encryption when set to true.
  This parameter is valid only if the Engine parameter is redis, the EngineVersion parameter
  is 3.2.6, 4.x or later, and the cluster is being created in an Amazon VPC. If you enable
  in-transit encryption, you must also specify a value for CacheSubnetGroup.  Required: Only
  available when creating a replication group in an Amazon VPC using redis version 3.2.6, 4.x
  or later. Default: false   For HIPAA compliance, you must specify TransitEncryptionEnabled
  as true, an AuthToken, and a CacheSubnetGroup.
- `"TransitEncryptionMode"`: A setting that allows you to migrate your clients to use
  in-transit encryption, with no downtime. When setting TransitEncryptionEnabled to true, you
  can set your TransitEncryptionMode to preferred in the same request, to allow both
  encrypted and unencrypted connections at the same time. Once you migrate all your Redis
  clients to use encrypted connections you can modify the value to required to allow
  encrypted connections only. Setting TransitEncryptionMode to required is a two-step process
  that requires you to first set the TransitEncryptionMode to preferred, after that you can
  set TransitEncryptionMode to required. This process will not trigger the replacement of the
  replication group.
- `"UserGroupIds"`: The user group to associate with the replication group.
"""
function create_replication_group(
    ReplicationGroupDescription,
    ReplicationGroupId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "CreateReplicationGroup",
        Dict{String,Any}(
            "ReplicationGroupDescription" => ReplicationGroupDescription,
            "ReplicationGroupId" => ReplicationGroupId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_replication_group(
    ReplicationGroupDescription,
    ReplicationGroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "CreateReplicationGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ReplicationGroupDescription" => ReplicationGroupDescription,
                    "ReplicationGroupId" => ReplicationGroupId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_serverless_cache(engine, serverless_cache_name)
    create_serverless_cache(engine, serverless_cache_name, params::Dict{String,<:Any})

Creates a serverless cache.

# Arguments
- `engine`: The name of the cache engine to be used for creating the serverless cache.
- `serverless_cache_name`: User-provided identifier for the serverless cache. This
  parameter is stored as a lowercase string.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CacheUsageLimits"`: Sets the cache usage limits for storage and ElastiCache Processing
  Units for the cache.
- `"DailySnapshotTime"`: The daily time that snapshots will be created from the new
  serverless cache. By default this number is populated with 0, i.e. no snapshots will be
  created on an automatic daily basis. Available for Redis only.
- `"Description"`: User-provided description for the serverless cache. The default is NULL,
  i.e. if no description is provided then an empty string will be returned. The maximum
  length is 255 characters.
- `"KmsKeyId"`: ARN of the customer managed key for encrypting the data at rest. If no KMS
  key is provided, a default service key is used.
- `"MajorEngineVersion"`: The version of the cache engine that will be used to create the
  serverless cache.
- `"SecurityGroupIds"`: A list of the one or more VPC security groups to be associated with
  the serverless cache. The security group will authorize traffic access for the VPC
  end-point (private-link). If no other information is given this will be the VPC’s Default
  Security Group that is associated with the cluster VPC end-point.
- `"SnapshotArnsToRestore"`: The ARN(s) of the snapshot that the new serverless cache will
  be created from. Available for Redis only.
- `"SnapshotRetentionLimit"`: The number of snapshots that will be retained for the
  serverless cache that is being created. As new snapshots beyond this limit are added, the
  oldest snapshots will be deleted on a rolling basis. Available for Redis only.
- `"SubnetIds"`: A list of the identifiers of the subnets where the VPC endpoint for the
  serverless cache will be deployed. All the subnetIds must belong to the same VPC.
- `"Tags"`: The list of tags (key, value) pairs to be added to the serverless cache
  resource. Default is NULL.
- `"UserGroupId"`: The identifier of the UserGroup to be associated with the serverless
  cache. Available for Redis only. Default is NULL.
"""
function create_serverless_cache(
    Engine, ServerlessCacheName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticache(
        "CreateServerlessCache",
        Dict{String,Any}("Engine" => Engine, "ServerlessCacheName" => ServerlessCacheName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_serverless_cache(
    Engine,
    ServerlessCacheName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "CreateServerlessCache",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Engine" => Engine, "ServerlessCacheName" => ServerlessCacheName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_serverless_cache_snapshot(serverless_cache_name, serverless_cache_snapshot_name)
    create_serverless_cache_snapshot(serverless_cache_name, serverless_cache_snapshot_name, params::Dict{String,<:Any})

This API creates a copy of an entire ServerlessCache at a specific moment in time.
Available for Redis only.

# Arguments
- `serverless_cache_name`: The name of an existing serverless cache. The snapshot is
  created from this cache. Available for Redis only.
- `serverless_cache_snapshot_name`: The name for the snapshot being created. Must be unique
  for the customer account. Available for Redis only. Must be between 1 and 255 characters.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"KmsKeyId"`: The ID of the KMS key used to encrypt the snapshot. Available for Redis
  only. Default: NULL
- `"Tags"`: A list of tags to be added to the snapshot resource. A tag is a key-value pair.
  Available for Redis only.
"""
function create_serverless_cache_snapshot(
    ServerlessCacheName,
    ServerlessCacheSnapshotName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "CreateServerlessCacheSnapshot",
        Dict{String,Any}(
            "ServerlessCacheName" => ServerlessCacheName,
            "ServerlessCacheSnapshotName" => ServerlessCacheSnapshotName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_serverless_cache_snapshot(
    ServerlessCacheName,
    ServerlessCacheSnapshotName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "CreateServerlessCacheSnapshot",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ServerlessCacheName" => ServerlessCacheName,
                    "ServerlessCacheSnapshotName" => ServerlessCacheSnapshotName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_snapshot(snapshot_name)
    create_snapshot(snapshot_name, params::Dict{String,<:Any})

Creates a copy of an entire cluster or replication group at a specific moment in time.
This operation is valid for Redis only.

# Arguments
- `snapshot_name`: A name for the snapshot being created.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CacheClusterId"`: The identifier of an existing cluster. The snapshot is created from
  this cluster.
- `"KmsKeyId"`: The ID of the KMS key used to encrypt the snapshot.
- `"ReplicationGroupId"`: The identifier of an existing replication group. The snapshot is
  created from this replication group.
- `"Tags"`: A list of tags to be added to this resource. A tag is a key-value pair. A tag
  key must be accompanied by a tag value, although null is accepted.
"""
function create_snapshot(SnapshotName; aws_config::AbstractAWSConfig=current_aws_config())
    return elasticache(
        "CreateSnapshot",
        Dict{String,Any}("SnapshotName" => SnapshotName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_snapshot(
    SnapshotName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "CreateSnapshot",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("SnapshotName" => SnapshotName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_user(access_string, engine, user_id, user_name)
    create_user(access_string, engine, user_id, user_name, params::Dict{String,<:Any})

For Redis engine version 6.0 onwards: Creates a Redis user. For more information, see Using
Role Based Access Control (RBAC).

# Arguments
- `access_string`: Access permissions string used for this user.
- `engine`: The current supported value is Redis.
- `user_id`: The ID of the user.
- `user_name`: The username of the user.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AuthenticationMode"`: Specifies how to authenticate the user.
- `"NoPasswordRequired"`: Indicates a password is not required for this user.
- `"Passwords"`: Passwords used for this user. You can create up to two passwords for each
  user.
- `"Tags"`: A list of tags to be added to this resource. A tag is a key-value pair. A tag
  key must be accompanied by a tag value, although null is accepted.
"""
function create_user(
    AccessString,
    Engine,
    UserId,
    UserName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "CreateUser",
        Dict{String,Any}(
            "AccessString" => AccessString,
            "Engine" => Engine,
            "UserId" => UserId,
            "UserName" => UserName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_user(
    AccessString,
    Engine,
    UserId,
    UserName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "CreateUser",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AccessString" => AccessString,
                    "Engine" => Engine,
                    "UserId" => UserId,
                    "UserName" => UserName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_user_group(engine, user_group_id)
    create_user_group(engine, user_group_id, params::Dict{String,<:Any})

For Redis engine version 6.0 onwards: Creates a Redis user group. For more information, see
Using Role Based Access Control (RBAC)

# Arguments
- `engine`: The current supported value is Redis.
- `user_group_id`: The ID of the user group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: A list of tags to be added to this resource. A tag is a key-value pair. A tag
  key must be accompanied by a tag value, although null is accepted. Available for Redis only.
- `"UserIds"`: The list of user IDs that belong to the user group.
"""
function create_user_group(
    Engine, UserGroupId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticache(
        "CreateUserGroup",
        Dict{String,Any}("Engine" => Engine, "UserGroupId" => UserGroupId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_user_group(
    Engine,
    UserGroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "CreateUserGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Engine" => Engine, "UserGroupId" => UserGroupId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    decrease_node_groups_in_global_replication_group(apply_immediately, global_replication_group_id, node_group_count)
    decrease_node_groups_in_global_replication_group(apply_immediately, global_replication_group_id, node_group_count, params::Dict{String,<:Any})

Decreases the number of node groups in a Global datastore

# Arguments
- `apply_immediately`: Indicates that the shard reconfiguration process begins immediately.
  At present, the only permitted value for this parameter is true.
- `global_replication_group_id`: The name of the Global datastore
- `node_group_count`: The number of node groups (shards) that results from the modification
  of the shard configuration

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"GlobalNodeGroupsToRemove"`: If the value of NodeGroupCount is less than the current
  number of node groups (shards), then either NodeGroupsToRemove or NodeGroupsToRetain is
  required. GlobalNodeGroupsToRemove is a list of NodeGroupIds to remove from the cluster.
  ElastiCache for Redis will attempt to remove all node groups listed by
  GlobalNodeGroupsToRemove from the cluster.
- `"GlobalNodeGroupsToRetain"`: If the value of NodeGroupCount is less than the current
  number of node groups (shards), then either NodeGroupsToRemove or NodeGroupsToRetain is
  required. GlobalNodeGroupsToRetain is a list of NodeGroupIds to retain from the cluster.
  ElastiCache for Redis will attempt to retain all node groups listed by
  GlobalNodeGroupsToRetain from the cluster.
"""
function decrease_node_groups_in_global_replication_group(
    ApplyImmediately,
    GlobalReplicationGroupId,
    NodeGroupCount;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "DecreaseNodeGroupsInGlobalReplicationGroup",
        Dict{String,Any}(
            "ApplyImmediately" => ApplyImmediately,
            "GlobalReplicationGroupId" => GlobalReplicationGroupId,
            "NodeGroupCount" => NodeGroupCount,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function decrease_node_groups_in_global_replication_group(
    ApplyImmediately,
    GlobalReplicationGroupId,
    NodeGroupCount,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "DecreaseNodeGroupsInGlobalReplicationGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplyImmediately" => ApplyImmediately,
                    "GlobalReplicationGroupId" => GlobalReplicationGroupId,
                    "NodeGroupCount" => NodeGroupCount,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    decrease_replica_count(apply_immediately, replication_group_id)
    decrease_replica_count(apply_immediately, replication_group_id, params::Dict{String,<:Any})

Dynamically decreases the number of replicas in a Redis (cluster mode disabled) replication
group or the number of replica nodes in one or more node groups (shards) of a Redis
(cluster mode enabled) replication group. This operation is performed with no cluster down
time.

# Arguments
- `apply_immediately`: If True, the number of replica nodes is decreased immediately.
  ApplyImmediately=False is not currently supported.
- `replication_group_id`: The id of the replication group from which you want to remove
  replica nodes.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NewReplicaCount"`: The number of read replica nodes you want at the completion of this
  operation. For Redis (cluster mode disabled) replication groups, this is the number of
  replica nodes in the replication group. For Redis (cluster mode enabled) replication
  groups, this is the number of replica nodes in each of the replication group's node groups.
  The minimum number of replicas in a shard or replication group is:   Redis (cluster mode
  disabled)   If Multi-AZ is enabled: 1   If Multi-AZ is not enabled: 0     Redis (cluster
  mode enabled): 0 (though you will not be able to failover to a replica if your primary node
  fails)
- `"ReplicaConfiguration"`: A list of ConfigureShard objects that can be used to configure
  each shard in a Redis (cluster mode enabled) replication group. The ConfigureShard has
  three members: NewReplicaCount, NodeGroupId, and PreferredAvailabilityZones.
- `"ReplicasToRemove"`: A list of the node ids to remove from the replication group or node
  group (shard).
"""
function decrease_replica_count(
    ApplyImmediately, ReplicationGroupId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticache(
        "DecreaseReplicaCount",
        Dict{String,Any}(
            "ApplyImmediately" => ApplyImmediately,
            "ReplicationGroupId" => ReplicationGroupId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function decrease_replica_count(
    ApplyImmediately,
    ReplicationGroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "DecreaseReplicaCount",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplyImmediately" => ApplyImmediately,
                    "ReplicationGroupId" => ReplicationGroupId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_cache_cluster(cache_cluster_id)
    delete_cache_cluster(cache_cluster_id, params::Dict{String,<:Any})

Deletes a previously provisioned cluster. DeleteCacheCluster deletes all associated cache
nodes, node endpoints and the cluster itself. When you receive a successful response from
this operation, Amazon ElastiCache immediately begins deleting the cluster; you cannot
cancel or revert this operation. This operation is not valid for:   Redis (cluster mode
enabled) clusters   Redis (cluster mode disabled) clusters   A cluster that is the last
read replica of a replication group   A cluster that is the primary node of a replication
group   A node group (shard) that has Multi-AZ mode enabled   A cluster from a Redis
(cluster mode enabled) replication group   A cluster that is not in the available state

# Arguments
- `cache_cluster_id`: The cluster identifier for the cluster to be deleted. This parameter
  is not case sensitive.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FinalSnapshotIdentifier"`: The user-supplied name of a final cluster snapshot. This is
  the unique name that identifies the snapshot. ElastiCache creates the snapshot, and then
  deletes the cluster immediately afterward.
"""
function delete_cache_cluster(
    CacheClusterId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticache(
        "DeleteCacheCluster",
        Dict{String,Any}("CacheClusterId" => CacheClusterId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_cache_cluster(
    CacheClusterId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "DeleteCacheCluster",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("CacheClusterId" => CacheClusterId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_cache_parameter_group(cache_parameter_group_name)
    delete_cache_parameter_group(cache_parameter_group_name, params::Dict{String,<:Any})

Deletes the specified cache parameter group. You cannot delete a cache parameter group if
it is associated with any cache clusters. You cannot delete the default cache parameter
groups in your account.

# Arguments
- `cache_parameter_group_name`: The name of the cache parameter group to delete.  The
  specified cache security group must not be associated with any clusters.

"""
function delete_cache_parameter_group(
    CacheParameterGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticache(
        "DeleteCacheParameterGroup",
        Dict{String,Any}("CacheParameterGroupName" => CacheParameterGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_cache_parameter_group(
    CacheParameterGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "DeleteCacheParameterGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("CacheParameterGroupName" => CacheParameterGroupName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_cache_security_group(cache_security_group_name)
    delete_cache_security_group(cache_security_group_name, params::Dict{String,<:Any})

Deletes a cache security group.  You cannot delete a cache security group if it is
associated with any clusters.

# Arguments
- `cache_security_group_name`: The name of the cache security group to delete.  You cannot
  delete the default security group.

"""
function delete_cache_security_group(
    CacheSecurityGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticache(
        "DeleteCacheSecurityGroup",
        Dict{String,Any}("CacheSecurityGroupName" => CacheSecurityGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_cache_security_group(
    CacheSecurityGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "DeleteCacheSecurityGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("CacheSecurityGroupName" => CacheSecurityGroupName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_cache_subnet_group(cache_subnet_group_name)
    delete_cache_subnet_group(cache_subnet_group_name, params::Dict{String,<:Any})

Deletes a cache subnet group.  You cannot delete a default cache subnet group or one that
is associated with any clusters.

# Arguments
- `cache_subnet_group_name`: The name of the cache subnet group to delete. Constraints:
  Must contain no more than 255 alphanumeric characters or hyphens.

"""
function delete_cache_subnet_group(
    CacheSubnetGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticache(
        "DeleteCacheSubnetGroup",
        Dict{String,Any}("CacheSubnetGroupName" => CacheSubnetGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_cache_subnet_group(
    CacheSubnetGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "DeleteCacheSubnetGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("CacheSubnetGroupName" => CacheSubnetGroupName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_global_replication_group(global_replication_group_id, retain_primary_replication_group)
    delete_global_replication_group(global_replication_group_id, retain_primary_replication_group, params::Dict{String,<:Any})

Deleting a Global datastore is a two-step process:    First, you must
DisassociateGlobalReplicationGroup to remove the secondary clusters in the Global
datastore.   Once the Global datastore contains only the primary cluster, you can use the
DeleteGlobalReplicationGroup API to delete the Global datastore while retainining the
primary cluster using RetainPrimaryReplicationGroup=true.   Since the Global Datastore has
only a primary cluster, you can delete the Global Datastore while retaining the primary by
setting RetainPrimaryReplicationGroup=true. The primary cluster is never deleted when
deleting a Global Datastore. It can only be deleted when it no longer is associated with
any Global Datastore. When you receive a successful response from this operation, Amazon
ElastiCache immediately begins deleting the selected resources; you cannot cancel or revert
this operation.

# Arguments
- `global_replication_group_id`: The name of the Global datastore
- `retain_primary_replication_group`: The primary replication group is retained as a
  standalone replication group.

"""
function delete_global_replication_group(
    GlobalReplicationGroupId,
    RetainPrimaryReplicationGroup;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "DeleteGlobalReplicationGroup",
        Dict{String,Any}(
            "GlobalReplicationGroupId" => GlobalReplicationGroupId,
            "RetainPrimaryReplicationGroup" => RetainPrimaryReplicationGroup,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_global_replication_group(
    GlobalReplicationGroupId,
    RetainPrimaryReplicationGroup,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "DeleteGlobalReplicationGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "GlobalReplicationGroupId" => GlobalReplicationGroupId,
                    "RetainPrimaryReplicationGroup" => RetainPrimaryReplicationGroup,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_replication_group(replication_group_id)
    delete_replication_group(replication_group_id, params::Dict{String,<:Any})

Deletes an existing replication group. By default, this operation deletes the entire
replication group, including the primary/primaries and all of the read replicas. If the
replication group has only one primary, you can optionally delete only the read replicas,
while retaining the primary by setting RetainPrimaryCluster=true. When you receive a
successful response from this operation, Amazon ElastiCache immediately begins deleting the
selected resources; you cannot cancel or revert this operation.  This operation is valid
for Redis only.

# Arguments
- `replication_group_id`: The identifier for the cluster to be deleted. This parameter is
  not case sensitive.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FinalSnapshotIdentifier"`: The name of a final node group (shard) snapshot. ElastiCache
  creates the snapshot from the primary node in the cluster, rather than one of the replicas;
  this is to ensure that it captures the freshest data. After the final snapshot is taken,
  the replication group is immediately deleted.
- `"RetainPrimaryCluster"`: If set to true, all of the read replicas are deleted, but the
  primary node is retained.
"""
function delete_replication_group(
    ReplicationGroupId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticache(
        "DeleteReplicationGroup",
        Dict{String,Any}("ReplicationGroupId" => ReplicationGroupId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_replication_group(
    ReplicationGroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "DeleteReplicationGroup",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ReplicationGroupId" => ReplicationGroupId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_serverless_cache(serverless_cache_name)
    delete_serverless_cache(serverless_cache_name, params::Dict{String,<:Any})

Deletes a specified existing serverless cache.

# Arguments
- `serverless_cache_name`: The identifier of the serverless cache to be deleted.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FinalSnapshotName"`: Name of the final snapshot to be taken before the serverless cache
  is deleted. Available for Redis only. Default: NULL, i.e. a final snapshot is not taken.
"""
function delete_serverless_cache(
    ServerlessCacheName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticache(
        "DeleteServerlessCache",
        Dict{String,Any}("ServerlessCacheName" => ServerlessCacheName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_serverless_cache(
    ServerlessCacheName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "DeleteServerlessCache",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ServerlessCacheName" => ServerlessCacheName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_serverless_cache_snapshot(serverless_cache_snapshot_name)
    delete_serverless_cache_snapshot(serverless_cache_snapshot_name, params::Dict{String,<:Any})

Deletes an existing serverless cache snapshot. Available for Redis only.

# Arguments
- `serverless_cache_snapshot_name`: Idenfitier of the snapshot to be deleted. Available for
  Redis only.

"""
function delete_serverless_cache_snapshot(
    ServerlessCacheSnapshotName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticache(
        "DeleteServerlessCacheSnapshot",
        Dict{String,Any}("ServerlessCacheSnapshotName" => ServerlessCacheSnapshotName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_serverless_cache_snapshot(
    ServerlessCacheSnapshotName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "DeleteServerlessCacheSnapshot",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ServerlessCacheSnapshotName" => ServerlessCacheSnapshotName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_snapshot(snapshot_name)
    delete_snapshot(snapshot_name, params::Dict{String,<:Any})

Deletes an existing snapshot. When you receive a successful response from this operation,
ElastiCache immediately begins deleting the snapshot; you cannot cancel or revert this
operation.  This operation is valid for Redis only.

# Arguments
- `snapshot_name`: The name of the snapshot to be deleted.

"""
function delete_snapshot(SnapshotName; aws_config::AbstractAWSConfig=current_aws_config())
    return elasticache(
        "DeleteSnapshot",
        Dict{String,Any}("SnapshotName" => SnapshotName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_snapshot(
    SnapshotName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "DeleteSnapshot",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("SnapshotName" => SnapshotName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_user(user_id)
    delete_user(user_id, params::Dict{String,<:Any})

For Redis engine version 6.0 onwards: Deletes a user. The user will be removed from all
user groups and in turn removed from all replication groups. For more information, see
Using Role Based Access Control (RBAC).

# Arguments
- `user_id`: The ID of the user.

"""
function delete_user(UserId; aws_config::AbstractAWSConfig=current_aws_config())
    return elasticache(
        "DeleteUser",
        Dict{String,Any}("UserId" => UserId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_user(
    UserId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticache(
        "DeleteUser",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("UserId" => UserId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_user_group(user_group_id)
    delete_user_group(user_group_id, params::Dict{String,<:Any})

For Redis engine version 6.0 onwards: Deletes a user group. The user group must first be
disassociated from the replication group before it can be deleted. For more information,
see Using Role Based Access Control (RBAC).

# Arguments
- `user_group_id`: The ID of the user group.

"""
function delete_user_group(UserGroupId; aws_config::AbstractAWSConfig=current_aws_config())
    return elasticache(
        "DeleteUserGroup",
        Dict{String,Any}("UserGroupId" => UserGroupId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_user_group(
    UserGroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "DeleteUserGroup",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("UserGroupId" => UserGroupId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_cache_clusters()
    describe_cache_clusters(params::Dict{String,<:Any})

Returns information about all provisioned clusters if no cluster identifier is specified,
or about a specific cache cluster if a cluster identifier is supplied. By default,
abbreviated information about the clusters is returned. You can use the optional
ShowCacheNodeInfo flag to retrieve detailed information about the cache nodes associated
with the clusters. These details include the DNS address and port for the cache node
endpoint. If the cluster is in the creating state, only cluster-level information is
displayed until all of the nodes are successfully provisioned. If the cluster is in the
deleting state, only cluster-level information is displayed. If cache nodes are currently
being added to the cluster, node endpoint information and creation time for the additional
nodes are not displayed until they are completely provisioned. When the cluster state is
available, the cluster is ready for use. If cache nodes are currently being removed from
the cluster, no endpoint information for the removed nodes is displayed.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CacheClusterId"`: The user-supplied cluster identifier. If this parameter is specified,
  only information about that specific cluster is returned. This parameter isn't case
  sensitive.
- `"Marker"`: An optional marker returned from a prior request. Use this marker for
  pagination of results from this operation. If this parameter is specified, the response
  includes only records beyond the marker, up to the value specified by MaxRecords.
- `"MaxRecords"`: The maximum number of records to include in the response. If more records
  exist than the specified MaxRecords value, a marker is included in the response so that the
  remaining results can be retrieved. Default: 100 Constraints: minimum 20; maximum 100.
- `"ShowCacheClustersNotInReplicationGroups"`: An optional flag that can be included in the
  DescribeCacheCluster request to show only nodes (API/CLI: clusters) that are not members of
  a replication group. In practice, this mean Memcached and single node Redis clusters.
- `"ShowCacheNodeInfo"`: An optional flag that can be included in the DescribeCacheCluster
  request to retrieve information about the individual cache nodes.
"""
function describe_cache_clusters(; aws_config::AbstractAWSConfig=current_aws_config())
    return elasticache(
        "DescribeCacheClusters"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_cache_clusters(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticache(
        "DescribeCacheClusters",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_cache_engine_versions()
    describe_cache_engine_versions(params::Dict{String,<:Any})

Returns a list of the available cache engines and their versions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CacheParameterGroupFamily"`: The name of a specific cache parameter group family to
  return details for. Valid values are: memcached1.4 | memcached1.5 | memcached1.6 | redis2.6
  | redis2.8 | redis3.2 | redis4.0 | redis5.0 | redis6.x | redis6.2 | redis7  Constraints:
  Must be 1 to 255 alphanumeric characters   First character must be a letter   Cannot end
  with a hyphen or contain two consecutive hyphens
- `"DefaultOnly"`: If true, specifies that only the default version of the specified engine
  or engine and major version combination is to be returned.
- `"Engine"`: The cache engine to return. Valid values: memcached | redis
- `"EngineVersion"`: The cache engine version to return. Example: 1.4.14
- `"Marker"`: An optional marker returned from a prior request. Use this marker for
  pagination of results from this operation. If this parameter is specified, the response
  includes only records beyond the marker, up to the value specified by MaxRecords.
- `"MaxRecords"`: The maximum number of records to include in the response. If more records
  exist than the specified MaxRecords value, a marker is included in the response so that the
  remaining results can be retrieved. Default: 100 Constraints: minimum 20; maximum 100.
"""
function describe_cache_engine_versions(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticache(
        "DescribeCacheEngineVersions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_cache_engine_versions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticache(
        "DescribeCacheEngineVersions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_cache_parameter_groups()
    describe_cache_parameter_groups(params::Dict{String,<:Any})

Returns a list of cache parameter group descriptions. If a cache parameter group name is
specified, the list contains only the descriptions for that group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CacheParameterGroupName"`: The name of a specific cache parameter group to return
  details for.
- `"Marker"`: An optional marker returned from a prior request. Use this marker for
  pagination of results from this operation. If this parameter is specified, the response
  includes only records beyond the marker, up to the value specified by MaxRecords.
- `"MaxRecords"`: The maximum number of records to include in the response. If more records
  exist than the specified MaxRecords value, a marker is included in the response so that the
  remaining results can be retrieved. Default: 100 Constraints: minimum 20; maximum 100.
"""
function describe_cache_parameter_groups(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticache(
        "DescribeCacheParameterGroups";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_cache_parameter_groups(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticache(
        "DescribeCacheParameterGroups",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_cache_parameters(cache_parameter_group_name)
    describe_cache_parameters(cache_parameter_group_name, params::Dict{String,<:Any})

Returns the detailed parameter list for a particular cache parameter group.

# Arguments
- `cache_parameter_group_name`: The name of a specific cache parameter group to return
  details for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Marker"`: An optional marker returned from a prior request. Use this marker for
  pagination of results from this operation. If this parameter is specified, the response
  includes only records beyond the marker, up to the value specified by MaxRecords.
- `"MaxRecords"`: The maximum number of records to include in the response. If more records
  exist than the specified MaxRecords value, a marker is included in the response so that the
  remaining results can be retrieved. Default: 100 Constraints: minimum 20; maximum 100.
- `"Source"`: The parameter types to return. Valid values: user | system | engine-default
"""
function describe_cache_parameters(
    CacheParameterGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticache(
        "DescribeCacheParameters",
        Dict{String,Any}("CacheParameterGroupName" => CacheParameterGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_cache_parameters(
    CacheParameterGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "DescribeCacheParameters",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("CacheParameterGroupName" => CacheParameterGroupName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_cache_security_groups()
    describe_cache_security_groups(params::Dict{String,<:Any})

Returns a list of cache security group descriptions. If a cache security group name is
specified, the list contains only the description of that group. This applicable only when
you have ElastiCache in Classic setup

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CacheSecurityGroupName"`: The name of the cache security group to return details for.
- `"Marker"`: An optional marker returned from a prior request. Use this marker for
  pagination of results from this operation. If this parameter is specified, the response
  includes only records beyond the marker, up to the value specified by MaxRecords.
- `"MaxRecords"`: The maximum number of records to include in the response. If more records
  exist than the specified MaxRecords value, a marker is included in the response so that the
  remaining results can be retrieved. Default: 100 Constraints: minimum 20; maximum 100.
"""
function describe_cache_security_groups(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticache(
        "DescribeCacheSecurityGroups";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_cache_security_groups(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticache(
        "DescribeCacheSecurityGroups",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_cache_subnet_groups()
    describe_cache_subnet_groups(params::Dict{String,<:Any})

Returns a list of cache subnet group descriptions. If a subnet group name is specified, the
list contains only the description of that group. This is applicable only when you have
ElastiCache in VPC setup. All ElastiCache clusters now launch in VPC by default.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CacheSubnetGroupName"`: The name of the cache subnet group to return details for.
- `"Marker"`: An optional marker returned from a prior request. Use this marker for
  pagination of results from this operation. If this parameter is specified, the response
  includes only records beyond the marker, up to the value specified by MaxRecords.
- `"MaxRecords"`: The maximum number of records to include in the response. If more records
  exist than the specified MaxRecords value, a marker is included in the response so that the
  remaining results can be retrieved. Default: 100 Constraints: minimum 20; maximum 100.
"""
function describe_cache_subnet_groups(; aws_config::AbstractAWSConfig=current_aws_config())
    return elasticache(
        "DescribeCacheSubnetGroups"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_cache_subnet_groups(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticache(
        "DescribeCacheSubnetGroups",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_engine_default_parameters(cache_parameter_group_family)
    describe_engine_default_parameters(cache_parameter_group_family, params::Dict{String,<:Any})

Returns the default engine and system parameter information for the specified cache engine.

# Arguments
- `cache_parameter_group_family`: The name of the cache parameter group family. Valid
  values are: memcached1.4 | memcached1.5 | memcached1.6 | redis2.6 | redis2.8 | redis3.2 |
  redis4.0 | redis5.0 | redis6.x | redis6.2 | redis7

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Marker"`: An optional marker returned from a prior request. Use this marker for
  pagination of results from this operation. If this parameter is specified, the response
  includes only records beyond the marker, up to the value specified by MaxRecords.
- `"MaxRecords"`: The maximum number of records to include in the response. If more records
  exist than the specified MaxRecords value, a marker is included in the response so that the
  remaining results can be retrieved. Default: 100 Constraints: minimum 20; maximum 100.
"""
function describe_engine_default_parameters(
    CacheParameterGroupFamily; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticache(
        "DescribeEngineDefaultParameters",
        Dict{String,Any}("CacheParameterGroupFamily" => CacheParameterGroupFamily);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_engine_default_parameters(
    CacheParameterGroupFamily,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "DescribeEngineDefaultParameters",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("CacheParameterGroupFamily" => CacheParameterGroupFamily),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_events()
    describe_events(params::Dict{String,<:Any})

Returns events related to clusters, cache security groups, and cache parameter groups. You
can obtain events specific to a particular cluster, cache security group, or cache
parameter group by providing the name as a parameter. By default, only the events occurring
within the last hour are returned; however, you can retrieve up to 14 days' worth of events
if necessary.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Duration"`: The number of minutes worth of events to retrieve.
- `"EndTime"`: The end of the time interval for which to retrieve events, specified in ISO
  8601 format.  Example: 2017-03-30T07:03:49.555Z
- `"Marker"`: An optional marker returned from a prior request. Use this marker for
  pagination of results from this operation. If this parameter is specified, the response
  includes only records beyond the marker, up to the value specified by MaxRecords.
- `"MaxRecords"`: The maximum number of records to include in the response. If more records
  exist than the specified MaxRecords value, a marker is included in the response so that the
  remaining results can be retrieved. Default: 100 Constraints: minimum 20; maximum 100.
- `"SourceIdentifier"`: The identifier of the event source for which events are returned.
  If not specified, all sources are included in the response.
- `"SourceType"`: The event source to retrieve events for. If no value is specified, all
  events are returned.
- `"StartTime"`: The beginning of the time interval to retrieve events for, specified in
  ISO 8601 format.  Example: 2017-03-30T07:03:49.555Z
"""
function describe_events(; aws_config::AbstractAWSConfig=current_aws_config())
    return elasticache(
        "DescribeEvents"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_events(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticache(
        "DescribeEvents", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_global_replication_groups()
    describe_global_replication_groups(params::Dict{String,<:Any})

Returns information about a particular global replication group. If no identifier is
specified, returns information about all Global datastores.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"GlobalReplicationGroupId"`: The name of the Global datastore
- `"Marker"`: An optional marker returned from a prior request. Use this marker for
  pagination of results from this operation. If this parameter is specified, the response
  includes only records beyond the marker, up to the value specified by MaxRecords.
- `"MaxRecords"`: The maximum number of records to include in the response. If more records
  exist than the specified MaxRecords value, a marker is included in the response so that the
  remaining results can be retrieved.
- `"ShowMemberInfo"`: Returns the list of members that comprise the Global datastore.
"""
function describe_global_replication_groups(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticache(
        "DescribeGlobalReplicationGroups";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_global_replication_groups(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticache(
        "DescribeGlobalReplicationGroups",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_replication_groups()
    describe_replication_groups(params::Dict{String,<:Any})

Returns information about a particular replication group. If no identifier is specified,
DescribeReplicationGroups returns information about all replication groups.  This operation
is valid for Redis only.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Marker"`: An optional marker returned from a prior request. Use this marker for
  pagination of results from this operation. If this parameter is specified, the response
  includes only records beyond the marker, up to the value specified by MaxRecords.
- `"MaxRecords"`: The maximum number of records to include in the response. If more records
  exist than the specified MaxRecords value, a marker is included in the response so that the
  remaining results can be retrieved. Default: 100 Constraints: minimum 20; maximum 100.
- `"ReplicationGroupId"`: The identifier for the replication group to be described. This
  parameter is not case sensitive. If you do not specify this parameter, information about
  all replication groups is returned.
"""
function describe_replication_groups(; aws_config::AbstractAWSConfig=current_aws_config())
    return elasticache(
        "DescribeReplicationGroups"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_replication_groups(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticache(
        "DescribeReplicationGroups",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_reserved_cache_nodes()
    describe_reserved_cache_nodes(params::Dict{String,<:Any})

Returns information about reserved cache nodes for this account, or about a specified
reserved cache node.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CacheNodeType"`: The cache node type filter value. Use this parameter to show only
  those reservations matching the specified cache node type. The following node types are
  supported by ElastiCache. Generally speaking, the current generation types provide more
  memory and computational power at lower cost when compared to their equivalent previous
  generation counterparts.   General purpose:   Current generation:   M7g node types:
  cache.m7g.large, cache.m7g.xlarge, cache.m7g.2xlarge, cache.m7g.4xlarge, cache.m7g.8xlarge,
  cache.m7g.12xlarge, cache.m7g.16xlarge   For region availability, see Supported Node Types
    M6g node types (available only for Redis engine version 5.0.6 onward and for Memcached
  engine version 1.5.16 onward): cache.m6g.large, cache.m6g.xlarge, cache.m6g.2xlarge,
  cache.m6g.4xlarge, cache.m6g.8xlarge, cache.m6g.12xlarge, cache.m6g.16xlarge   M5 node
  types: cache.m5.large, cache.m5.xlarge, cache.m5.2xlarge, cache.m5.4xlarge,
  cache.m5.12xlarge, cache.m5.24xlarge   M4 node types: cache.m4.large, cache.m4.xlarge,
  cache.m4.2xlarge, cache.m4.4xlarge, cache.m4.10xlarge   T4g node types (available only for
  Redis engine version 5.0.6 onward and Memcached engine version 1.5.16 onward):
  cache.t4g.micro, cache.t4g.small, cache.t4g.medium   T3 node types: cache.t3.micro,
  cache.t3.small, cache.t3.medium   T2 node types: cache.t2.micro, cache.t2.small,
  cache.t2.medium    Previous generation: (not recommended. Existing clusters are still
  supported but creation of new clusters is not supported for these types.)  T1 node types:
  cache.t1.micro   M1 node types: cache.m1.small, cache.m1.medium, cache.m1.large,
  cache.m1.xlarge   M3 node types: cache.m3.medium, cache.m3.large, cache.m3.xlarge,
  cache.m3.2xlarge      Compute optimized:   Previous generation: (not recommended. Existing
  clusters are still supported but creation of new clusters is not supported for these
  types.)  C1 node types: cache.c1.xlarge      Memory optimized:   Current generation:   R7g
  node types: cache.r7g.large, cache.r7g.xlarge, cache.r7g.2xlarge, cache.r7g.4xlarge,
  cache.r7g.8xlarge, cache.r7g.12xlarge, cache.r7g.16xlarge   For region availability, see
  Supported Node Types    R6g node types (available only for Redis engine version 5.0.6
  onward and for Memcached engine version 1.5.16 onward): cache.r6g.large, cache.r6g.xlarge,
  cache.r6g.2xlarge, cache.r6g.4xlarge, cache.r6g.8xlarge, cache.r6g.12xlarge,
  cache.r6g.16xlarge   R5 node types: cache.r5.large, cache.r5.xlarge, cache.r5.2xlarge,
  cache.r5.4xlarge, cache.r5.12xlarge, cache.r5.24xlarge   R4 node types: cache.r4.large,
  cache.r4.xlarge, cache.r4.2xlarge, cache.r4.4xlarge, cache.r4.8xlarge, cache.r4.16xlarge
  Previous generation: (not recommended. Existing clusters are still supported but creation
  of new clusters is not supported for these types.)  M2 node types: cache.m2.xlarge,
  cache.m2.2xlarge, cache.m2.4xlarge   R3 node types: cache.r3.large, cache.r3.xlarge,
  cache.r3.2xlarge, cache.r3.4xlarge, cache.r3.8xlarge       Additional node type info    All
  current generation instance types are created in Amazon VPC by default.   Redis append-only
  files (AOF) are not supported for T1 or T2 instances.   Redis Multi-AZ with automatic
  failover is not supported on T1 instances.   Redis configuration variables appendonly and
  appendfsync are not supported on Redis version 2.8.22 and later.
- `"Duration"`: The duration filter value, specified in years or seconds. Use this
  parameter to show only reservations for this duration. Valid Values: 1 | 3 | 31536000 |
  94608000
- `"Marker"`: An optional marker returned from a prior request. Use this marker for
  pagination of results from this operation. If this parameter is specified, the response
  includes only records beyond the marker, up to the value specified by MaxRecords.
- `"MaxRecords"`: The maximum number of records to include in the response. If more records
  exist than the specified MaxRecords value, a marker is included in the response so that the
  remaining results can be retrieved. Default: 100 Constraints: minimum 20; maximum 100.
- `"OfferingType"`: The offering type filter value. Use this parameter to show only the
  available offerings matching the specified offering type. Valid values: \"Light
  Utilization\"|\"Medium Utilization\"|\"Heavy Utilization\"|\"All Upfront\"|\"Partial
  Upfront\"| \"No Upfront\"
- `"ProductDescription"`: The product description filter value. Use this parameter to show
  only those reservations matching the specified product description.
- `"ReservedCacheNodeId"`: The reserved cache node identifier filter value. Use this
  parameter to show only the reservation that matches the specified reservation ID.
- `"ReservedCacheNodesOfferingId"`: The offering identifier filter value. Use this
  parameter to show only purchased reservations matching the specified offering identifier.
"""
function describe_reserved_cache_nodes(; aws_config::AbstractAWSConfig=current_aws_config())
    return elasticache(
        "DescribeReservedCacheNodes"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_reserved_cache_nodes(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticache(
        "DescribeReservedCacheNodes",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_reserved_cache_nodes_offerings()
    describe_reserved_cache_nodes_offerings(params::Dict{String,<:Any})

Lists available reserved cache node offerings.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CacheNodeType"`: The cache node type filter value. Use this parameter to show only the
  available offerings matching the specified cache node type. The following node types are
  supported by ElastiCache. Generally speaking, the current generation types provide more
  memory and computational power at lower cost when compared to their equivalent previous
  generation counterparts.   General purpose:   Current generation:   M7g node types:
  cache.m7g.large, cache.m7g.xlarge, cache.m7g.2xlarge, cache.m7g.4xlarge, cache.m7g.8xlarge,
  cache.m7g.12xlarge, cache.m7g.16xlarge   For region availability, see Supported Node Types
    M6g node types (available only for Redis engine version 5.0.6 onward and for Memcached
  engine version 1.5.16 onward): cache.m6g.large, cache.m6g.xlarge, cache.m6g.2xlarge,
  cache.m6g.4xlarge, cache.m6g.8xlarge, cache.m6g.12xlarge, cache.m6g.16xlarge   M5 node
  types: cache.m5.large, cache.m5.xlarge, cache.m5.2xlarge, cache.m5.4xlarge,
  cache.m5.12xlarge, cache.m5.24xlarge   M4 node types: cache.m4.large, cache.m4.xlarge,
  cache.m4.2xlarge, cache.m4.4xlarge, cache.m4.10xlarge   T4g node types (available only for
  Redis engine version 5.0.6 onward and Memcached engine version 1.5.16 onward):
  cache.t4g.micro, cache.t4g.small, cache.t4g.medium   T3 node types: cache.t3.micro,
  cache.t3.small, cache.t3.medium   T2 node types: cache.t2.micro, cache.t2.small,
  cache.t2.medium    Previous generation: (not recommended. Existing clusters are still
  supported but creation of new clusters is not supported for these types.)  T1 node types:
  cache.t1.micro   M1 node types: cache.m1.small, cache.m1.medium, cache.m1.large,
  cache.m1.xlarge   M3 node types: cache.m3.medium, cache.m3.large, cache.m3.xlarge,
  cache.m3.2xlarge      Compute optimized:   Previous generation: (not recommended. Existing
  clusters are still supported but creation of new clusters is not supported for these
  types.)  C1 node types: cache.c1.xlarge      Memory optimized:   Current generation:   R7g
  node types: cache.r7g.large, cache.r7g.xlarge, cache.r7g.2xlarge, cache.r7g.4xlarge,
  cache.r7g.8xlarge, cache.r7g.12xlarge, cache.r7g.16xlarge   For region availability, see
  Supported Node Types    R6g node types (available only for Redis engine version 5.0.6
  onward and for Memcached engine version 1.5.16 onward): cache.r6g.large, cache.r6g.xlarge,
  cache.r6g.2xlarge, cache.r6g.4xlarge, cache.r6g.8xlarge, cache.r6g.12xlarge,
  cache.r6g.16xlarge   R5 node types: cache.r5.large, cache.r5.xlarge, cache.r5.2xlarge,
  cache.r5.4xlarge, cache.r5.12xlarge, cache.r5.24xlarge   R4 node types: cache.r4.large,
  cache.r4.xlarge, cache.r4.2xlarge, cache.r4.4xlarge, cache.r4.8xlarge, cache.r4.16xlarge
  Previous generation: (not recommended. Existing clusters are still supported but creation
  of new clusters is not supported for these types.)  M2 node types: cache.m2.xlarge,
  cache.m2.2xlarge, cache.m2.4xlarge   R3 node types: cache.r3.large, cache.r3.xlarge,
  cache.r3.2xlarge, cache.r3.4xlarge, cache.r3.8xlarge       Additional node type info    All
  current generation instance types are created in Amazon VPC by default.   Redis append-only
  files (AOF) are not supported for T1 or T2 instances.   Redis Multi-AZ with automatic
  failover is not supported on T1 instances.   Redis configuration variables appendonly and
  appendfsync are not supported on Redis version 2.8.22 and later.
- `"Duration"`: Duration filter value, specified in years or seconds. Use this parameter to
  show only reservations for a given duration. Valid Values: 1 | 3 | 31536000 | 94608000
- `"Marker"`: An optional marker returned from a prior request. Use this marker for
  pagination of results from this operation. If this parameter is specified, the response
  includes only records beyond the marker, up to the value specified by MaxRecords.
- `"MaxRecords"`: The maximum number of records to include in the response. If more records
  exist than the specified MaxRecords value, a marker is included in the response so that the
  remaining results can be retrieved. Default: 100 Constraints: minimum 20; maximum 100.
- `"OfferingType"`: The offering type filter value. Use this parameter to show only the
  available offerings matching the specified offering type. Valid Values: \"Light
  Utilization\"|\"Medium Utilization\"|\"Heavy Utilization\" |\"All Upfront\"|\"Partial
  Upfront\"| \"No Upfront\"
- `"ProductDescription"`: The product description filter value. Use this parameter to show
  only the available offerings matching the specified product description.
- `"ReservedCacheNodesOfferingId"`: The offering identifier filter value. Use this
  parameter to show only the available offering that matches the specified reservation
  identifier. Example: 438012d3-4052-4cc7-b2e3-8d3372e0e706
"""
function describe_reserved_cache_nodes_offerings(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticache(
        "DescribeReservedCacheNodesOfferings";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_reserved_cache_nodes_offerings(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticache(
        "DescribeReservedCacheNodesOfferings",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_serverless_cache_snapshots()
    describe_serverless_cache_snapshots(params::Dict{String,<:Any})

Returns information about serverless cache snapshots. By default, this API lists all of the
customer’s serverless cache snapshots. It can also describe a single serverless cache
snapshot, or the snapshots associated with a particular serverless cache. Available for
Redis only.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of records to include in the response. If more records
  exist than the specified max-results value, a market is included in the response so that
  remaining results can be retrieved. Available for Redis only.The default is 50. The
  Validation Constraints are a maximum of 50.
- `"NextToken"`: An optional marker returned from a prior request to support pagination of
  results from this operation. If this parameter is specified, the response includes only
  records beyond the marker, up to the value specified by max-results. Available for Redis
  only.
- `"ServerlessCacheName"`: The identifier of serverless cache. If this parameter is
  specified, only snapshots associated with that specific serverless cache are described.
  Available for Redis only.
- `"ServerlessCacheSnapshotName"`: The identifier of the serverless cache’s snapshot. If
  this parameter is specified, only this snapshot is described. Available for Redis only.
- `"SnapshotType"`: The type of snapshot that is being described. Available for Redis only.
"""
function describe_serverless_cache_snapshots(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticache(
        "DescribeServerlessCacheSnapshots";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_serverless_cache_snapshots(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticache(
        "DescribeServerlessCacheSnapshots",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_serverless_caches()
    describe_serverless_caches(params::Dict{String,<:Any})

Returns information about a specific serverless cache. If no identifier is specified, then
the API returns information on all the serverless caches belonging to this Amazon Web
Services account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of records in the response. If more records exist than
  the specified max-records value, the next token is included in the response so that
  remaining results can be retrieved. The default is 50.
- `"NextToken"`: An optional marker returned from a prior request to support pagination of
  results from this operation. If this parameter is specified, the response includes only
  records beyond the marker, up to the value specified by MaxResults.
- `"ServerlessCacheName"`: The identifier for the serverless cache. If this parameter is
  specified, only information about that specific serverless cache is returned. Default: NULL
"""
function describe_serverless_caches(; aws_config::AbstractAWSConfig=current_aws_config())
    return elasticache(
        "DescribeServerlessCaches"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_serverless_caches(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticache(
        "DescribeServerlessCaches",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_service_updates()
    describe_service_updates(params::Dict{String,<:Any})

Returns details of the service updates

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Marker"`: An optional marker returned from a prior request. Use this marker for
  pagination of results from this operation. If this parameter is specified, the response
  includes only records beyond the marker, up to the value specified by MaxRecords.
- `"MaxRecords"`: The maximum number of records to include in the response
- `"ServiceUpdateName"`: The unique ID of the service update
- `"ServiceUpdateStatus"`: The status of the service update
"""
function describe_service_updates(; aws_config::AbstractAWSConfig=current_aws_config())
    return elasticache(
        "DescribeServiceUpdates"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_service_updates(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticache(
        "DescribeServiceUpdates",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_snapshots()
    describe_snapshots(params::Dict{String,<:Any})

Returns information about cluster or replication group snapshots. By default,
DescribeSnapshots lists all of your snapshots; it can optionally describe a single
snapshot, or just the snapshots associated with a particular cache cluster.  This operation
is valid for Redis only.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CacheClusterId"`: A user-supplied cluster identifier. If this parameter is specified,
  only snapshots associated with that specific cluster are described.
- `"Marker"`: An optional marker returned from a prior request. Use this marker for
  pagination of results from this operation. If this parameter is specified, the response
  includes only records beyond the marker, up to the value specified by MaxRecords.
- `"MaxRecords"`: The maximum number of records to include in the response. If more records
  exist than the specified MaxRecords value, a marker is included in the response so that the
  remaining results can be retrieved. Default: 50 Constraints: minimum 20; maximum 50.
- `"ReplicationGroupId"`: A user-supplied replication group identifier. If this parameter
  is specified, only snapshots associated with that specific replication group are described.
- `"ShowNodeGroupConfig"`: A Boolean value which if true, the node group (shard)
  configuration is included in the snapshot description.
- `"SnapshotName"`: A user-supplied name of the snapshot. If this parameter is specified,
  only this snapshot are described.
- `"SnapshotSource"`: If set to system, the output shows snapshots that were automatically
  created by ElastiCache. If set to user the output shows snapshots that were manually
  created. If omitted, the output shows both automatically and manually created snapshots.
"""
function describe_snapshots(; aws_config::AbstractAWSConfig=current_aws_config())
    return elasticache(
        "DescribeSnapshots"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_snapshots(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticache(
        "DescribeSnapshots", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_update_actions()
    describe_update_actions(params::Dict{String,<:Any})

Returns details of the update actions

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CacheClusterIds"`: The cache cluster IDs
- `"Engine"`: The Elasticache engine to which the update applies. Either Redis or Memcached
- `"Marker"`: An optional marker returned from a prior request. Use this marker for
  pagination of results from this operation. If this parameter is specified, the response
  includes only records beyond the marker, up to the value specified by MaxRecords.
- `"MaxRecords"`: The maximum number of records to include in the response
- `"ReplicationGroupIds"`: The replication group IDs
- `"ServiceUpdateName"`: The unique ID of the service update
- `"ServiceUpdateStatus"`: The status of the service update
- `"ServiceUpdateTimeRange"`: The range of time specified to search for service updates
  that are in available status
- `"ShowNodeLevelUpdateStatus"`: Dictates whether to include node level update status in
  the response
- `"UpdateActionStatus"`: The status of the update action.
"""
function describe_update_actions(; aws_config::AbstractAWSConfig=current_aws_config())
    return elasticache(
        "DescribeUpdateActions"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_update_actions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticache(
        "DescribeUpdateActions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_user_groups()
    describe_user_groups(params::Dict{String,<:Any})

Returns a list of user groups.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Marker"`: An optional marker returned from a prior request. Use this marker for
  pagination of results from this operation. If this parameter is specified, the response
  includes only records beyond the marker, up to the value specified by MaxRecords. &gt;
- `"MaxRecords"`: The maximum number of records to include in the response. If more records
  exist than the specified MaxRecords value, a marker is included in the response so that the
  remaining results can be retrieved.
- `"UserGroupId"`: The ID of the user group.
"""
function describe_user_groups(; aws_config::AbstractAWSConfig=current_aws_config())
    return elasticache(
        "DescribeUserGroups"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_user_groups(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticache(
        "DescribeUserGroups", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_users()
    describe_users(params::Dict{String,<:Any})

Returns a list of users.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Engine"`: The Redis engine.
- `"Filters"`: Filter to determine the list of User IDs to return.
- `"Marker"`: An optional marker returned from a prior request. Use this marker for
  pagination of results from this operation. If this parameter is specified, the response
  includes only records beyond the marker, up to the value specified by MaxRecords. &gt;
- `"MaxRecords"`: The maximum number of records to include in the response. If more records
  exist than the specified MaxRecords value, a marker is included in the response so that the
  remaining results can be retrieved.
- `"UserId"`: The ID of the user.
"""
function describe_users(; aws_config::AbstractAWSConfig=current_aws_config())
    return elasticache(
        "DescribeUsers"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_users(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticache(
        "DescribeUsers", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    disassociate_global_replication_group(global_replication_group_id, replication_group_id, replication_group_region)
    disassociate_global_replication_group(global_replication_group_id, replication_group_id, replication_group_region, params::Dict{String,<:Any})

Remove a secondary cluster from the Global datastore using the Global datastore name. The
secondary cluster will no longer receive updates from the primary cluster, but will remain
as a standalone cluster in that Amazon region.

# Arguments
- `global_replication_group_id`: The name of the Global datastore
- `replication_group_id`: The name of the secondary cluster you wish to remove from the
  Global datastore
- `replication_group_region`: The Amazon region of secondary cluster you wish to remove
  from the Global datastore

"""
function disassociate_global_replication_group(
    GlobalReplicationGroupId,
    ReplicationGroupId,
    ReplicationGroupRegion;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "DisassociateGlobalReplicationGroup",
        Dict{String,Any}(
            "GlobalReplicationGroupId" => GlobalReplicationGroupId,
            "ReplicationGroupId" => ReplicationGroupId,
            "ReplicationGroupRegion" => ReplicationGroupRegion,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_global_replication_group(
    GlobalReplicationGroupId,
    ReplicationGroupId,
    ReplicationGroupRegion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "DisassociateGlobalReplicationGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "GlobalReplicationGroupId" => GlobalReplicationGroupId,
                    "ReplicationGroupId" => ReplicationGroupId,
                    "ReplicationGroupRegion" => ReplicationGroupRegion,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    export_serverless_cache_snapshot(s3_bucket_name, serverless_cache_snapshot_name)
    export_serverless_cache_snapshot(s3_bucket_name, serverless_cache_snapshot_name, params::Dict{String,<:Any})

Provides the functionality to export the serverless cache snapshot data to Amazon S3.
Available for Redis only.

# Arguments
- `s3_bucket_name`: Name of the Amazon S3 bucket to export the snapshot to. The Amazon S3
  bucket must also be in same region as the snapshot. Available for Redis only.
- `serverless_cache_snapshot_name`: The identifier of the serverless cache snapshot to be
  exported to S3. Available for Redis only.

"""
function export_serverless_cache_snapshot(
    S3BucketName,
    ServerlessCacheSnapshotName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "ExportServerlessCacheSnapshot",
        Dict{String,Any}(
            "S3BucketName" => S3BucketName,
            "ServerlessCacheSnapshotName" => ServerlessCacheSnapshotName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function export_serverless_cache_snapshot(
    S3BucketName,
    ServerlessCacheSnapshotName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "ExportServerlessCacheSnapshot",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "S3BucketName" => S3BucketName,
                    "ServerlessCacheSnapshotName" => ServerlessCacheSnapshotName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    failover_global_replication_group(global_replication_group_id, primary_region, primary_replication_group_id)
    failover_global_replication_group(global_replication_group_id, primary_region, primary_replication_group_id, params::Dict{String,<:Any})

Used to failover the primary region to a secondary region. The secondary region will become
primary, and all other clusters will become secondary.

# Arguments
- `global_replication_group_id`: The name of the Global datastore
- `primary_region`: The Amazon region of the primary cluster of the Global datastore
- `primary_replication_group_id`: The name of the primary replication group

"""
function failover_global_replication_group(
    GlobalReplicationGroupId,
    PrimaryRegion,
    PrimaryReplicationGroupId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "FailoverGlobalReplicationGroup",
        Dict{String,Any}(
            "GlobalReplicationGroupId" => GlobalReplicationGroupId,
            "PrimaryRegion" => PrimaryRegion,
            "PrimaryReplicationGroupId" => PrimaryReplicationGroupId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function failover_global_replication_group(
    GlobalReplicationGroupId,
    PrimaryRegion,
    PrimaryReplicationGroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "FailoverGlobalReplicationGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "GlobalReplicationGroupId" => GlobalReplicationGroupId,
                    "PrimaryRegion" => PrimaryRegion,
                    "PrimaryReplicationGroupId" => PrimaryReplicationGroupId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    increase_node_groups_in_global_replication_group(apply_immediately, global_replication_group_id, node_group_count)
    increase_node_groups_in_global_replication_group(apply_immediately, global_replication_group_id, node_group_count, params::Dict{String,<:Any})

Increase the number of node groups in the Global datastore

# Arguments
- `apply_immediately`: Indicates that the process begins immediately. At present, the only
  permitted value for this parameter is true.
- `global_replication_group_id`: The name of the Global datastore
- `node_group_count`: Total number of node groups you want

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"RegionalConfigurations"`: Describes the replication group IDs, the Amazon regions where
  they are stored and the shard configuration for each that comprise the Global datastore
"""
function increase_node_groups_in_global_replication_group(
    ApplyImmediately,
    GlobalReplicationGroupId,
    NodeGroupCount;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "IncreaseNodeGroupsInGlobalReplicationGroup",
        Dict{String,Any}(
            "ApplyImmediately" => ApplyImmediately,
            "GlobalReplicationGroupId" => GlobalReplicationGroupId,
            "NodeGroupCount" => NodeGroupCount,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function increase_node_groups_in_global_replication_group(
    ApplyImmediately,
    GlobalReplicationGroupId,
    NodeGroupCount,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "IncreaseNodeGroupsInGlobalReplicationGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplyImmediately" => ApplyImmediately,
                    "GlobalReplicationGroupId" => GlobalReplicationGroupId,
                    "NodeGroupCount" => NodeGroupCount,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    increase_replica_count(apply_immediately, replication_group_id)
    increase_replica_count(apply_immediately, replication_group_id, params::Dict{String,<:Any})

Dynamically increases the number of replicas in a Redis (cluster mode disabled) replication
group or the number of replica nodes in one or more node groups (shards) of a Redis
(cluster mode enabled) replication group. This operation is performed with no cluster down
time.

# Arguments
- `apply_immediately`: If True, the number of replica nodes is increased immediately.
  ApplyImmediately=False is not currently supported.
- `replication_group_id`: The id of the replication group to which you want to add replica
  nodes.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NewReplicaCount"`: The number of read replica nodes you want at the completion of this
  operation. For Redis (cluster mode disabled) replication groups, this is the number of
  replica nodes in the replication group. For Redis (cluster mode enabled) replication
  groups, this is the number of replica nodes in each of the replication group's node groups.
- `"ReplicaConfiguration"`: A list of ConfigureShard objects that can be used to configure
  each shard in a Redis (cluster mode enabled) replication group. The ConfigureShard has
  three members: NewReplicaCount, NodeGroupId, and PreferredAvailabilityZones.
"""
function increase_replica_count(
    ApplyImmediately, ReplicationGroupId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticache(
        "IncreaseReplicaCount",
        Dict{String,Any}(
            "ApplyImmediately" => ApplyImmediately,
            "ReplicationGroupId" => ReplicationGroupId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function increase_replica_count(
    ApplyImmediately,
    ReplicationGroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "IncreaseReplicaCount",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplyImmediately" => ApplyImmediately,
                    "ReplicationGroupId" => ReplicationGroupId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_allowed_node_type_modifications()
    list_allowed_node_type_modifications(params::Dict{String,<:Any})

Lists all available node types that you can scale your Redis cluster's or replication
group's current node type. When you use the ModifyCacheCluster or ModifyReplicationGroup
operations to scale your cluster or replication group, the value of the CacheNodeType
parameter must be one of the node types returned by this operation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CacheClusterId"`: The name of the cluster you want to scale up to a larger node
  instanced type. ElastiCache uses the cluster id to identify the current node type of this
  cluster and from that to create a list of node types you can scale up to.  You must provide
  a value for either the CacheClusterId or the ReplicationGroupId.
- `"ReplicationGroupId"`: The name of the replication group want to scale up to a larger
  node type. ElastiCache uses the replication group id to identify the current node type
  being used by this replication group, and from that to create a list of node types you can
  scale up to.  You must provide a value for either the CacheClusterId or the
  ReplicationGroupId.
"""
function list_allowed_node_type_modifications(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticache(
        "ListAllowedNodeTypeModifications";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_allowed_node_type_modifications(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticache(
        "ListAllowedNodeTypeModifications",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_name)
    list_tags_for_resource(resource_name, params::Dict{String,<:Any})

Lists all tags currently on a named resource.  A tag is a key-value pair where the key and
value are case-sensitive. You can use tags to categorize and track all your ElastiCache
resources, with the exception of global replication group. When you add or remove tags on
replication groups, those actions will be replicated to all nodes in the replication group.
For more information, see Resource-level permissions. If the cluster is not in the
available state, ListTagsForResource returns an error.

# Arguments
- `resource_name`: The Amazon Resource Name (ARN) of the resource for which you want the
  list of tags, for example arn:aws:elasticache:us-west-2:0123456789:cluster:myCluster or
  arn:aws:elasticache:us-west-2:0123456789:snapshot:mySnapshot. For more information about
  ARNs, see Amazon Resource Names (ARNs) and Amazon Web Services Service Namespaces.

"""
function list_tags_for_resource(
    ResourceName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticache(
        "ListTagsForResource",
        Dict{String,Any}("ResourceName" => ResourceName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceName" => ResourceName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    modify_cache_cluster(cache_cluster_id)
    modify_cache_cluster(cache_cluster_id, params::Dict{String,<:Any})

Modifies the settings for a cluster. You can use this operation to change one or more
cluster configuration parameters by specifying the parameters and the new values.

# Arguments
- `cache_cluster_id`: The cluster identifier. This value is stored as a lowercase string.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AZMode"`: Specifies whether the new nodes in this Memcached cluster are all created in
  a single Availability Zone or created across multiple Availability Zones. Valid values:
  single-az | cross-az. This option is only supported for Memcached clusters.  You cannot
  specify single-az if the Memcached cluster already has cache nodes in different
  Availability Zones. If cross-az is specified, existing Memcached nodes remain in their
  current Availability Zone. Only newly created nodes are located in different Availability
  Zones.
- `"ApplyImmediately"`: If true, this parameter causes the modifications in this request
  and any pending modifications to be applied, asynchronously and as soon as possible,
  regardless of the PreferredMaintenanceWindow setting for the cluster. If false, changes to
  the cluster are applied on the next maintenance reboot, or the next failure reboot,
  whichever occurs first.  If you perform a ModifyCacheCluster before a pending modification
  is applied, the pending modification is replaced by the newer modification.  Valid values:
  true | false  Default: false
- `"AuthToken"`: Reserved parameter. The password used to access a password protected
  server. This parameter must be specified with the auth-token-update parameter. Password
  constraints:   Must be only printable ASCII characters   Must be at least 16 characters and
  no more than 128 characters in length   Cannot contain any of the following characters:
  '/', '\"', or '@', '%'    For more information, see AUTH password at AUTH.
- `"AuthTokenUpdateStrategy"`: Specifies the strategy to use to update the AUTH token. This
  parameter must be specified with the auth-token parameter. Possible values:   ROTATE -
  default, if no update strategy is provided   SET - allowed only after ROTATE   DELETE -
  allowed only when transitioning to RBAC    For more information, see Authenticating Users
  with Redis AUTH
- `"AutoMinorVersionUpgrade"`:  If you are running Redis engine version 6.0 or later, set
  this parameter to yes if you want to opt-in to the next auto minor version upgrade
  campaign. This parameter is disabled for previous versions.
- `"CacheNodeIdsToRemove"`: A list of cache node IDs to be removed. A node ID is a numeric
  identifier (0001, 0002, etc.). This parameter is only valid when NumCacheNodes is less than
  the existing number of cache nodes. The number of cache node IDs supplied in this parameter
  must match the difference between the existing number of cache nodes in the cluster or
  pending cache nodes, whichever is greater, and the value of NumCacheNodes in the request.
  For example: If you have 3 active cache nodes, 7 pending cache nodes, and the number of
  cache nodes in this ModifyCacheCluster call is 5, you must list 2 (7 - 5) cache node IDs to
  remove.
- `"CacheNodeType"`: A valid cache node type that you want to scale this cluster up to.
- `"CacheParameterGroupName"`: The name of the cache parameter group to apply to this
  cluster. This change is asynchronously applied as soon as possible for parameters when the
  ApplyImmediately parameter is specified as true for this request.
- `"CacheSecurityGroupNames"`: A list of cache security group names to authorize on this
  cluster. This change is asynchronously applied as soon as possible. You can use this
  parameter only with clusters that are created outside of an Amazon Virtual Private Cloud
  (Amazon VPC). Constraints: Must contain no more than 255 alphanumeric characters. Must not
  be \"Default\".
- `"EngineVersion"`: The upgraded version of the cache engine to be run on the cache nodes.
   Important: You can upgrade to a newer engine version (see Selecting a Cache Engine and
  Version), but you cannot downgrade to an earlier engine version. If you want to use an
  earlier engine version, you must delete the existing cluster and create it anew with the
  earlier engine version.
- `"IpDiscovery"`: The network type you choose when modifying a cluster, either ipv4 |
  ipv6. IPv6 is supported for workloads using Redis engine version 6.2 onward or Memcached
  engine version 1.6.6 on all instances built on the Nitro system.
- `"LogDeliveryConfigurations"`: Specifies the destination, format and type of the logs.
- `"NewAvailabilityZones"`:  This option is only supported on Memcached clusters.  The list
  of Availability Zones where the new Memcached cache nodes are created. This parameter is
  only valid when NumCacheNodes in the request is greater than the sum of the number of
  active cache nodes and the number of cache nodes pending creation (which may be zero). The
  number of Availability Zones supplied in this list must match the cache nodes being added
  in this request. Scenarios:    Scenario 1: You have 3 active nodes and wish to add 2 nodes.
  Specify NumCacheNodes=5 (3 + 2) and optionally specify two Availability Zones for the two
  new nodes.    Scenario 2: You have 3 active nodes and 2 nodes pending creation (from the
  scenario 1 call) and want to add 1 more node. Specify NumCacheNodes=6 ((3 + 2) + 1) and
  optionally specify an Availability Zone for the new node.    Scenario 3: You want to cancel
  all pending operations. Specify NumCacheNodes=3 to cancel all pending operations.   The
  Availability Zone placement of nodes pending creation cannot be modified. If you wish to
  cancel any nodes pending creation, add 0 nodes by setting NumCacheNodes to the number of
  current nodes. If cross-az is specified, existing Memcached nodes remain in their current
  Availability Zone. Only newly created nodes can be located in different Availability Zones.
  For guidance on how to move existing Memcached nodes to different Availability Zones, see
  the Availability Zone Considerations section of Cache Node Considerations for Memcached.
  Impact of new add/remove requests upon pending requests    Scenario-1   Pending Action:
  Delete   New Request: Delete   Result: The new delete, pending or immediate, replaces the
  pending delete.     Scenario-2   Pending Action: Delete   New Request: Create   Result: The
  new create, pending or immediate, replaces the pending delete.     Scenario-3   Pending
  Action: Create   New Request: Delete   Result: The new delete, pending or immediate,
  replaces the pending create.     Scenario-4   Pending Action: Create   New Request: Create
   Result: The new create is added to the pending create.   Important: If the new create
  request is Apply Immediately - Yes, all creates are performed immediately. If the new
  create request is Apply Immediately - No, all creates are pending.
- `"NotificationTopicArn"`: The Amazon Resource Name (ARN) of the Amazon SNS topic to which
  notifications are sent.  The Amazon SNS topic owner must be same as the cluster owner.
- `"NotificationTopicStatus"`: The status of the Amazon SNS notification topic.
  Notifications are sent only if the status is active. Valid values: active | inactive
- `"NumCacheNodes"`: The number of cache nodes that the cluster should have. If the value
  for NumCacheNodes is greater than the sum of the number of current cache nodes and the
  number of cache nodes pending creation (which may be zero), more nodes are added. If the
  value is less than the number of existing cache nodes, nodes are removed. If the value is
  equal to the number of current cache nodes, any pending add or remove requests are
  canceled. If you are removing cache nodes, you must use the CacheNodeIdsToRemove parameter
  to provide the IDs of the specific cache nodes to remove. For clusters running Redis, this
  value must be 1. For clusters running Memcached, this value must be between 1 and 40.
  Adding or removing Memcached cache nodes can be applied immediately or as a pending
  operation (see ApplyImmediately). A pending operation to modify the number of cache nodes
  in a cluster during its maintenance window, whether by adding or removing nodes in
  accordance with the scale out architecture, is not queued. The customer's latest request to
  add or remove nodes to the cluster overrides any previous pending operations to modify the
  number of cache nodes in the cluster. For example, a request to remove 2 nodes would
  override a previous pending operation to remove 3 nodes. Similarly, a request to add 2
  nodes would override a previous pending operation to remove 3 nodes and vice versa. As
  Memcached cache nodes may now be provisioned in different Availability Zones with flexible
  cache node placement, a request to add nodes does not automatically override a previous
  pending operation to add nodes. The customer can modify the previous pending operation to
  add more nodes or explicitly cancel the pending request and retry the new request. To
  cancel pending operations to modify the number of cache nodes in a cluster, use the
  ModifyCacheCluster request and set NumCacheNodes equal to the number of cache nodes
  currently in the cluster.
- `"PreferredMaintenanceWindow"`: Specifies the weekly time range during which maintenance
  on the cluster is performed. It is specified as a range in the format
  ddd:hh24:mi-ddd:hh24:mi (24H Clock UTC). The minimum maintenance window is a 60 minute
  period. Valid values for ddd are:    sun     mon     tue     wed     thu     fri     sat
  Example: sun:23:00-mon:01:30
- `"SecurityGroupIds"`: Specifies the VPC Security Groups associated with the cluster. This
  parameter can be used only with clusters that are created in an Amazon Virtual Private
  Cloud (Amazon VPC).
- `"SnapshotRetentionLimit"`: The number of days for which ElastiCache retains automatic
  cluster snapshots before deleting them. For example, if you set SnapshotRetentionLimit to
  5, a snapshot that was taken today is retained for 5 days before being deleted.  If the
  value of SnapshotRetentionLimit is set to zero (0), backups are turned off.
- `"SnapshotWindow"`: The daily time range (in UTC) during which ElastiCache begins taking
  a daily snapshot of your cluster.
"""
function modify_cache_cluster(
    CacheClusterId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticache(
        "ModifyCacheCluster",
        Dict{String,Any}("CacheClusterId" => CacheClusterId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function modify_cache_cluster(
    CacheClusterId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "ModifyCacheCluster",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("CacheClusterId" => CacheClusterId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    modify_cache_parameter_group(cache_parameter_group_name, parameter_name_value)
    modify_cache_parameter_group(cache_parameter_group_name, parameter_name_value, params::Dict{String,<:Any})

Modifies the parameters of a cache parameter group. You can modify up to 20 parameters in a
single request by submitting a list parameter name and value pairs.

# Arguments
- `cache_parameter_group_name`: The name of the cache parameter group to modify.
- `parameter_name_value`: An array of parameter names and values for the parameter update.
  You must supply at least one parameter name and value; subsequent arguments are optional. A
  maximum of 20 parameters may be modified per request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ParameterNameValues"`: An array of parameter names and values for the parameter update.
  You must supply at least one parameter name and value; subsequent arguments are optional. A
  maximum of 20 parameters may be modified per request.
"""
function modify_cache_parameter_group(
    CacheParameterGroupName,
    ParameterNameValue;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "ModifyCacheParameterGroup",
        Dict{String,Any}(
            "CacheParameterGroupName" => CacheParameterGroupName,
            "ParameterNameValue" => ParameterNameValue,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function modify_cache_parameter_group(
    CacheParameterGroupName,
    ParameterNameValue,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "ModifyCacheParameterGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CacheParameterGroupName" => CacheParameterGroupName,
                    "ParameterNameValue" => ParameterNameValue,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    modify_cache_subnet_group(cache_subnet_group_name)
    modify_cache_subnet_group(cache_subnet_group_name, params::Dict{String,<:Any})

Modifies an existing cache subnet group.

# Arguments
- `cache_subnet_group_name`: The name for the cache subnet group. This value is stored as a
  lowercase string. Constraints: Must contain no more than 255 alphanumeric characters or
  hyphens. Example: mysubnetgroup

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CacheSubnetGroupDescription"`: A description of the cache subnet group.
- `"SubnetIds"`: The EC2 subnet IDs for the cache subnet group.
"""
function modify_cache_subnet_group(
    CacheSubnetGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticache(
        "ModifyCacheSubnetGroup",
        Dict{String,Any}("CacheSubnetGroupName" => CacheSubnetGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function modify_cache_subnet_group(
    CacheSubnetGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "ModifyCacheSubnetGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("CacheSubnetGroupName" => CacheSubnetGroupName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    modify_global_replication_group(apply_immediately, global_replication_group_id)
    modify_global_replication_group(apply_immediately, global_replication_group_id, params::Dict{String,<:Any})

Modifies the settings for a Global datastore.

# Arguments
- `apply_immediately`: This parameter causes the modifications in this request and any
  pending modifications to be applied, asynchronously and as soon as possible. Modifications
  to Global Replication Groups cannot be requested to be applied in PreferredMaintenceWindow.
- `global_replication_group_id`: The name of the Global datastore

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AutomaticFailoverEnabled"`: Determines whether a read replica is automatically promoted
  to read/write primary if the existing primary encounters a failure.
- `"CacheNodeType"`: A valid cache node type that you want to scale this Global datastore
  to.
- `"CacheParameterGroupName"`: The name of the cache parameter group to use with the Global
  datastore. It must be compatible with the major engine version used by the Global datastore.
- `"EngineVersion"`: The upgraded version of the cache engine to be run on the clusters in
  the Global datastore.
- `"GlobalReplicationGroupDescription"`: A description of the Global datastore
"""
function modify_global_replication_group(
    ApplyImmediately,
    GlobalReplicationGroupId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "ModifyGlobalReplicationGroup",
        Dict{String,Any}(
            "ApplyImmediately" => ApplyImmediately,
            "GlobalReplicationGroupId" => GlobalReplicationGroupId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function modify_global_replication_group(
    ApplyImmediately,
    GlobalReplicationGroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "ModifyGlobalReplicationGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplyImmediately" => ApplyImmediately,
                    "GlobalReplicationGroupId" => GlobalReplicationGroupId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    modify_replication_group(replication_group_id)
    modify_replication_group(replication_group_id, params::Dict{String,<:Any})

Modifies the settings for a replication group. This is limited to Redis 7 and newer.
Scaling for Amazon ElastiCache for Redis (cluster mode enabled) in the ElastiCache User
Guide    ModifyReplicationGroupShardConfiguration in the ElastiCache API Reference    This
operation is valid for Redis only.

# Arguments
- `replication_group_id`: The identifier of the replication group to modify.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ApplyImmediately"`: If true, this parameter causes the modifications in this request
  and any pending modifications to be applied, asynchronously and as soon as possible,
  regardless of the PreferredMaintenanceWindow setting for the replication group. If false,
  changes to the nodes in the replication group are applied on the next maintenance reboot,
  or the next failure reboot, whichever occurs first. Valid values: true | false  Default:
  false
- `"AuthToken"`: Reserved parameter. The password used to access a password protected
  server. This parameter must be specified with the auth-token-update-strategy  parameter.
  Password constraints:   Must be only printable ASCII characters   Must be at least 16
  characters and no more than 128 characters in length   Cannot contain any of the following
  characters: '/', '\"', or '@', '%'    For more information, see AUTH password at AUTH.
- `"AuthTokenUpdateStrategy"`: Specifies the strategy to use to update the AUTH token. This
  parameter must be specified with the auth-token parameter. Possible values:   ROTATE -
  default, if no update strategy is provided   SET - allowed only after ROTATE   DELETE -
  allowed only when transitioning to RBAC    For more information, see Authenticating Users
  with Redis AUTH
- `"AutoMinorVersionUpgrade"`:  If you are running Redis engine version 6.0 or later, set
  this parameter to yes if you want to opt-in to the next auto minor version upgrade
  campaign. This parameter is disabled for previous versions.
- `"AutomaticFailoverEnabled"`: Determines whether a read replica is automatically promoted
  to read/write primary if the existing primary encounters a failure. Valid values: true |
  false
- `"CacheNodeType"`: A valid cache node type that you want to scale this replication group
  to.
- `"CacheParameterGroupName"`: The name of the cache parameter group to apply to all of the
  clusters in this replication group. This change is asynchronously applied as soon as
  possible for parameters when the ApplyImmediately parameter is specified as true for this
  request.
- `"CacheSecurityGroupNames"`: A list of cache security group names to authorize for the
  clusters in this replication group. This change is asynchronously applied as soon as
  possible. This parameter can be used only with replication group containing clusters
  running outside of an Amazon Virtual Private Cloud (Amazon VPC). Constraints: Must contain
  no more than 255 alphanumeric characters. Must not be Default.
- `"ClusterMode"`: Enabled or Disabled. To modify cluster mode from Disabled to Enabled,
  you must first set the cluster mode to Compatible. Compatible mode allows your Redis
  clients to connect using both cluster mode enabled and cluster mode disabled. After you
  migrate all Redis clients to use cluster mode enabled, you can then complete cluster mode
  configuration and set the cluster mode to Enabled.
- `"EngineVersion"`: The upgraded version of the cache engine to be run on the clusters in
  the replication group.  Important: You can upgrade to a newer engine version (see Selecting
  a Cache Engine and Version), but you cannot downgrade to an earlier engine version. If you
  want to use an earlier engine version, you must delete the existing replication group and
  create it anew with the earlier engine version.
- `"IpDiscovery"`: The network type you choose when modifying a cluster, either ipv4 |
  ipv6. IPv6 is supported for workloads using Redis engine version 6.2 onward or Memcached
  engine version 1.6.6 on all instances built on the Nitro system.
- `"LogDeliveryConfigurations"`: Specifies the destination, format and type of the logs.
- `"MultiAZEnabled"`: A flag to indicate MultiAZ is enabled.
- `"NodeGroupId"`: Deprecated. This parameter is not used.
- `"NotificationTopicArn"`: The Amazon Resource Name (ARN) of the Amazon SNS topic to which
  notifications are sent.  The Amazon SNS topic owner must be same as the replication group
  owner.
- `"NotificationTopicStatus"`: The status of the Amazon SNS notification topic for the
  replication group. Notifications are sent only if the status is active. Valid values:
  active | inactive
- `"PreferredMaintenanceWindow"`: Specifies the weekly time range during which maintenance
  on the cluster is performed. It is specified as a range in the format
  ddd:hh24:mi-ddd:hh24:mi (24H Clock UTC). The minimum maintenance window is a 60 minute
  period. Valid values for ddd are:    sun     mon     tue     wed     thu     fri     sat
  Example: sun:23:00-mon:01:30
- `"PrimaryClusterId"`: For replication groups with a single primary, if this parameter is
  specified, ElastiCache promotes the specified cluster in the specified replication group to
  the primary role. The nodes of all other clusters in the replication group are read
  replicas.
- `"RemoveUserGroups"`: Removes the user group associated with this replication group.
- `"ReplicationGroupDescription"`: A description for the replication group. Maximum length
  is 255 characters.
- `"SecurityGroupIds"`: Specifies the VPC Security Groups associated with the clusters in
  the replication group. This parameter can be used only with replication group containing
  clusters running in an Amazon Virtual Private Cloud (Amazon VPC).
- `"SnapshotRetentionLimit"`: The number of days for which ElastiCache retains automatic
  node group (shard) snapshots before deleting them. For example, if you set
  SnapshotRetentionLimit to 5, a snapshot that was taken today is retained for 5 days before
  being deleted.  Important If the value of SnapshotRetentionLimit is set to zero (0),
  backups are turned off.
- `"SnapshotWindow"`: The daily time range (in UTC) during which ElastiCache begins taking
  a daily snapshot of the node group (shard) specified by SnapshottingClusterId. Example:
  05:00-09:00  If you do not specify this parameter, ElastiCache automatically chooses an
  appropriate time range.
- `"SnapshottingClusterId"`: The cluster ID that is used as the daily snapshot source for
  the replication group. This parameter cannot be set for Redis (cluster mode enabled)
  replication groups.
- `"TransitEncryptionEnabled"`: A flag that enables in-transit encryption when set to true.
  If you are enabling in-transit encryption for an existing cluster, you must also set
  TransitEncryptionMode to preferred.
- `"TransitEncryptionMode"`: A setting that allows you to migrate your clients to use
  in-transit encryption, with no downtime. You must set TransitEncryptionEnabled to true, for
  your existing cluster, and set TransitEncryptionMode to preferred in the same request to
  allow both encrypted and unencrypted connections at the same time. Once you migrate all
  your Redis clients to use encrypted connections you can set the value to required to allow
  encrypted connections only. Setting TransitEncryptionMode to required is a two-step process
  that requires you to first set the TransitEncryptionMode to preferred, after that you can
  set TransitEncryptionMode to required.
- `"UserGroupIdsToAdd"`: The ID of the user group you are associating with the replication
  group.
- `"UserGroupIdsToRemove"`: The ID of the user group to disassociate from the replication
  group, meaning the users in the group no longer can access the replication group.
"""
function modify_replication_group(
    ReplicationGroupId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticache(
        "ModifyReplicationGroup",
        Dict{String,Any}("ReplicationGroupId" => ReplicationGroupId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function modify_replication_group(
    ReplicationGroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "ModifyReplicationGroup",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ReplicationGroupId" => ReplicationGroupId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    modify_replication_group_shard_configuration(apply_immediately, node_group_count, replication_group_id)
    modify_replication_group_shard_configuration(apply_immediately, node_group_count, replication_group_id, params::Dict{String,<:Any})

Modifies a replication group's shards (node groups) by allowing you to add shards, remove
shards, or rebalance the keyspaces among existing shards.

# Arguments
- `apply_immediately`: Indicates that the shard reconfiguration process begins immediately.
  At present, the only permitted value for this parameter is true. Value: true
- `node_group_count`: The number of node groups (shards) that results from the modification
  of the shard configuration.
- `replication_group_id`: The name of the Redis (cluster mode enabled) cluster (replication
  group) on which the shards are to be configured.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NodeGroupsToRemove"`: If the value of NodeGroupCount is less than the current number of
  node groups (shards), then either NodeGroupsToRemove or NodeGroupsToRetain is required.
  NodeGroupsToRemove is a list of NodeGroupIds to remove from the cluster. ElastiCache for
  Redis will attempt to remove all node groups listed by NodeGroupsToRemove from the cluster.
- `"NodeGroupsToRetain"`: If the value of NodeGroupCount is less than the current number of
  node groups (shards), then either NodeGroupsToRemove or NodeGroupsToRetain is required.
  NodeGroupsToRetain is a list of NodeGroupIds to retain in the cluster. ElastiCache for
  Redis will attempt to remove all node groups except those listed by NodeGroupsToRetain from
  the cluster.
- `"ReshardingConfiguration"`: Specifies the preferred availability zones for each node
  group in the cluster. If the value of NodeGroupCount is greater than the current number of
  node groups (shards), you can use this parameter to specify the preferred availability
  zones of the cluster's shards. If you omit this parameter ElastiCache selects availability
  zones for you. You can specify this parameter only if the value of NodeGroupCount is
  greater than the current number of node groups (shards).
"""
function modify_replication_group_shard_configuration(
    ApplyImmediately,
    NodeGroupCount,
    ReplicationGroupId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "ModifyReplicationGroupShardConfiguration",
        Dict{String,Any}(
            "ApplyImmediately" => ApplyImmediately,
            "NodeGroupCount" => NodeGroupCount,
            "ReplicationGroupId" => ReplicationGroupId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function modify_replication_group_shard_configuration(
    ApplyImmediately,
    NodeGroupCount,
    ReplicationGroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "ModifyReplicationGroupShardConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplyImmediately" => ApplyImmediately,
                    "NodeGroupCount" => NodeGroupCount,
                    "ReplicationGroupId" => ReplicationGroupId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    modify_serverless_cache(serverless_cache_name)
    modify_serverless_cache(serverless_cache_name, params::Dict{String,<:Any})

This API modifies the attributes of a serverless cache.

# Arguments
- `serverless_cache_name`: User-provided identifier for the serverless cache to be modified.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CacheUsageLimits"`: Modify the cache usage limit for the serverless cache.
- `"DailySnapshotTime"`: The daily time during which Elasticache begins taking a daily
  snapshot of the serverless cache. Available for Redis only. The default is NULL, i.e. the
  existing snapshot time configured for the cluster is not removed.
- `"Description"`: User provided description for the serverless cache. Default = NULL, i.e.
  the existing description is not removed/modified. The description has a maximum length of
  255 characters.
- `"RemoveUserGroup"`: The identifier of the UserGroup to be removed from association with
  the Redis serverless cache. Available for Redis only. Default is NULL.
- `"SecurityGroupIds"`: The new list of VPC security groups to be associated with the
  serverless cache. Populating this list means the current VPC security groups will be
  removed. This security group is used to authorize traffic access for the VPC end-point
  (private-link). Default = NULL - the existing list of VPC security groups is not removed.
- `"SnapshotRetentionLimit"`: The number of days for which Elasticache retains automatic
  snapshots before deleting them. Available for Redis only. Default = NULL, i.e. the existing
  snapshot-retention-limit will not be removed or modified. The maximum value allowed is 35
  days.
- `"UserGroupId"`: The identifier of the UserGroup to be associated with the serverless
  cache. Available for Redis only. Default is NULL - the existing UserGroup is not removed.
"""
function modify_serverless_cache(
    ServerlessCacheName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticache(
        "ModifyServerlessCache",
        Dict{String,Any}("ServerlessCacheName" => ServerlessCacheName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function modify_serverless_cache(
    ServerlessCacheName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "ModifyServerlessCache",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ServerlessCacheName" => ServerlessCacheName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    modify_user(user_id)
    modify_user(user_id, params::Dict{String,<:Any})

Changes user password(s) and/or access string.

# Arguments
- `user_id`: The ID of the user.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccessString"`: Access permissions string used for this user.
- `"AppendAccessString"`: Adds additional user permissions to the access string.
- `"AuthenticationMode"`: Specifies how to authenticate the user.
- `"NoPasswordRequired"`: Indicates no password is required for the user.
- `"Passwords"`: The passwords belonging to the user. You are allowed up to two.
"""
function modify_user(UserId; aws_config::AbstractAWSConfig=current_aws_config())
    return elasticache(
        "ModifyUser",
        Dict{String,Any}("UserId" => UserId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function modify_user(
    UserId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticache(
        "ModifyUser",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("UserId" => UserId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    modify_user_group(user_group_id)
    modify_user_group(user_group_id, params::Dict{String,<:Any})

Changes the list of users that belong to the user group.

# Arguments
- `user_group_id`: The ID of the user group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"UserIdsToAdd"`: The list of user IDs to add to the user group.
- `"UserIdsToRemove"`: The list of user IDs to remove from the user group.
"""
function modify_user_group(UserGroupId; aws_config::AbstractAWSConfig=current_aws_config())
    return elasticache(
        "ModifyUserGroup",
        Dict{String,Any}("UserGroupId" => UserGroupId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function modify_user_group(
    UserGroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "ModifyUserGroup",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("UserGroupId" => UserGroupId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    purchase_reserved_cache_nodes_offering(reserved_cache_nodes_offering_id)
    purchase_reserved_cache_nodes_offering(reserved_cache_nodes_offering_id, params::Dict{String,<:Any})

Allows you to purchase a reserved cache node offering. Reserved nodes are not eligible for
cancellation and are non-refundable. For more information, see Managing Costs with Reserved
Nodes for Redis or Managing Costs with Reserved Nodes for Memcached.

# Arguments
- `reserved_cache_nodes_offering_id`: The ID of the reserved cache node offering to
  purchase. Example: 438012d3-4052-4cc7-b2e3-8d3372e0e706

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CacheNodeCount"`: The number of cache node instances to reserve. Default: 1
- `"ReservedCacheNodeId"`: A customer-specified identifier to track this reservation.  The
  Reserved Cache Node ID is an unique customer-specified identifier to track this
  reservation. If this parameter is not specified, ElastiCache automatically generates an
  identifier for the reservation.  Example: myreservationID
- `"Tags"`: A list of tags to be added to this resource. A tag is a key-value pair. A tag
  key must be accompanied by a tag value, although null is accepted.
"""
function purchase_reserved_cache_nodes_offering(
    ReservedCacheNodesOfferingId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticache(
        "PurchaseReservedCacheNodesOffering",
        Dict{String,Any}("ReservedCacheNodesOfferingId" => ReservedCacheNodesOfferingId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function purchase_reserved_cache_nodes_offering(
    ReservedCacheNodesOfferingId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "PurchaseReservedCacheNodesOffering",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ReservedCacheNodesOfferingId" => ReservedCacheNodesOfferingId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    rebalance_slots_in_global_replication_group(apply_immediately, global_replication_group_id)
    rebalance_slots_in_global_replication_group(apply_immediately, global_replication_group_id, params::Dict{String,<:Any})

Redistribute slots to ensure uniform distribution across existing shards in the cluster.

# Arguments
- `apply_immediately`: If True, redistribution is applied immediately.
- `global_replication_group_id`: The name of the Global datastore

"""
function rebalance_slots_in_global_replication_group(
    ApplyImmediately,
    GlobalReplicationGroupId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "RebalanceSlotsInGlobalReplicationGroup",
        Dict{String,Any}(
            "ApplyImmediately" => ApplyImmediately,
            "GlobalReplicationGroupId" => GlobalReplicationGroupId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function rebalance_slots_in_global_replication_group(
    ApplyImmediately,
    GlobalReplicationGroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "RebalanceSlotsInGlobalReplicationGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplyImmediately" => ApplyImmediately,
                    "GlobalReplicationGroupId" => GlobalReplicationGroupId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    reboot_cache_cluster(cache_cluster_id, cache_node_id)
    reboot_cache_cluster(cache_cluster_id, cache_node_id, params::Dict{String,<:Any})

Reboots some, or all, of the cache nodes within a provisioned cluster. This operation
applies any modified cache parameter groups to the cluster. The reboot operation takes
place as soon as possible, and results in a momentary outage to the cluster. During the
reboot, the cluster status is set to REBOOTING. The reboot causes the contents of the cache
(for each cache node being rebooted) to be lost. When the reboot is complete, a cluster
event is created. Rebooting a cluster is currently supported on Memcached and Redis
(cluster mode disabled) clusters. Rebooting is not supported on Redis (cluster mode
enabled) clusters. If you make changes to parameters that require a Redis (cluster mode
enabled) cluster reboot for the changes to be applied, see Rebooting a Cluster for an
alternate process.

# Arguments
- `cache_cluster_id`: The cluster identifier. This parameter is stored as a lowercase
  string.
- `cache_node_id`: A list of cache node IDs to reboot. A node ID is a numeric identifier
  (0001, 0002, etc.). To reboot an entire cluster, specify all of the cache node IDs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CacheNodeIdsToReboot"`: A list of cache node IDs to reboot. A node ID is a numeric
  identifier (0001, 0002, etc.). To reboot an entire cluster, specify all of the cache node
  IDs.
"""
function reboot_cache_cluster(
    CacheClusterId, CacheNodeId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticache(
        "RebootCacheCluster",
        Dict{String,Any}("CacheClusterId" => CacheClusterId, "CacheNodeId" => CacheNodeId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function reboot_cache_cluster(
    CacheClusterId,
    CacheNodeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "RebootCacheCluster",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CacheClusterId" => CacheClusterId, "CacheNodeId" => CacheNodeId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_tags_from_resource(resource_name, tag_keys)
    remove_tags_from_resource(resource_name, tag_keys, params::Dict{String,<:Any})

Removes the tags identified by the TagKeys list from the named resource. A tag is a
key-value pair where the key and value are case-sensitive. You can use tags to categorize
and track all your ElastiCache resources, with the exception of global replication group.
When you add or remove tags on replication groups, those actions will be replicated to all
nodes in the replication group. For more information, see Resource-level permissions.

# Arguments
- `resource_name`: The Amazon Resource Name (ARN) of the resource from which you want the
  tags removed, for example arn:aws:elasticache:us-west-2:0123456789:cluster:myCluster or
  arn:aws:elasticache:us-west-2:0123456789:snapshot:mySnapshot. For more information about
  ARNs, see Amazon Resource Names (ARNs) and Amazon Service Namespaces.
- `tag_keys`: A list of TagKeys identifying the tags you want removed from the named
  resource.

"""
function remove_tags_from_resource(
    ResourceName, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticache(
        "RemoveTagsFromResource",
        Dict{String,Any}("ResourceName" => ResourceName, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_tags_from_resource(
    ResourceName,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "RemoveTagsFromResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceName" => ResourceName, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    reset_cache_parameter_group(cache_parameter_group_name)
    reset_cache_parameter_group(cache_parameter_group_name, params::Dict{String,<:Any})

Modifies the parameters of a cache parameter group to the engine or system default value.
You can reset specific parameters by submitting a list of parameter names. To reset the
entire cache parameter group, specify the ResetAllParameters and CacheParameterGroupName
parameters.

# Arguments
- `cache_parameter_group_name`: The name of the cache parameter group to reset.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ParameterNameValues"`: An array of parameter names to reset to their default values. If
  ResetAllParameters is true, do not use ParameterNameValues. If ResetAllParameters is false,
  you must specify the name of at least one parameter to reset.
- `"ResetAllParameters"`: If true, all parameters in the cache parameter group are reset to
  their default values. If false, only the parameters listed by ParameterNameValues are reset
  to their default values. Valid values: true | false
"""
function reset_cache_parameter_group(
    CacheParameterGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticache(
        "ResetCacheParameterGroup",
        Dict{String,Any}("CacheParameterGroupName" => CacheParameterGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function reset_cache_parameter_group(
    CacheParameterGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "ResetCacheParameterGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("CacheParameterGroupName" => CacheParameterGroupName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    revoke_cache_security_group_ingress(cache_security_group_name, ec2_security_group_name, ec2_security_group_owner_id)
    revoke_cache_security_group_ingress(cache_security_group_name, ec2_security_group_name, ec2_security_group_owner_id, params::Dict{String,<:Any})

Revokes ingress from a cache security group. Use this operation to disallow access from an
Amazon EC2 security group that had been previously authorized.

# Arguments
- `cache_security_group_name`: The name of the cache security group to revoke ingress from.
- `ec2_security_group_name`: The name of the Amazon EC2 security group to revoke access
  from.
- `ec2_security_group_owner_id`: The Amazon account number of the Amazon EC2 security group
  owner. Note that this is not the same thing as an Amazon access key ID - you must provide a
  valid Amazon account number for this parameter.

"""
function revoke_cache_security_group_ingress(
    CacheSecurityGroupName,
    EC2SecurityGroupName,
    EC2SecurityGroupOwnerId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "RevokeCacheSecurityGroupIngress",
        Dict{String,Any}(
            "CacheSecurityGroupName" => CacheSecurityGroupName,
            "EC2SecurityGroupName" => EC2SecurityGroupName,
            "EC2SecurityGroupOwnerId" => EC2SecurityGroupOwnerId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function revoke_cache_security_group_ingress(
    CacheSecurityGroupName,
    EC2SecurityGroupName,
    EC2SecurityGroupOwnerId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "RevokeCacheSecurityGroupIngress",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CacheSecurityGroupName" => CacheSecurityGroupName,
                    "EC2SecurityGroupName" => EC2SecurityGroupName,
                    "EC2SecurityGroupOwnerId" => EC2SecurityGroupOwnerId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_migration(customer_node_endpoint_list, replication_group_id)
    start_migration(customer_node_endpoint_list, replication_group_id, params::Dict{String,<:Any})

Start the migration of data.

# Arguments
- `customer_node_endpoint_list`: List of endpoints from which data should be migrated. For
  Redis (cluster mode disabled), list should have only one element.
- `replication_group_id`: The ID of the replication group to which data should be migrated.

"""
function start_migration(
    CustomerNodeEndpointList,
    ReplicationGroupId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "StartMigration",
        Dict{String,Any}(
            "CustomerNodeEndpointList" => CustomerNodeEndpointList,
            "ReplicationGroupId" => ReplicationGroupId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_migration(
    CustomerNodeEndpointList,
    ReplicationGroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "StartMigration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CustomerNodeEndpointList" => CustomerNodeEndpointList,
                    "ReplicationGroupId" => ReplicationGroupId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    test_failover(node_group_id, replication_group_id)
    test_failover(node_group_id, replication_group_id, params::Dict{String,<:Any})

Represents the input of a TestFailover operation which tests automatic failover on a
specified node group (called shard in the console) in a replication group (called cluster
in the console). This API is designed for testing the behavior of your application in case
of ElastiCache failover. It is not designed to be an operational tool for initiating a
failover to overcome a problem you may have with the cluster. Moreover, in certain
conditions such as large-scale operational events, Amazon may block this API.   Note the
following    A customer can use this operation to test automatic failover on up to 15
shards (called node groups in the ElastiCache API and Amazon CLI) in any rolling 24-hour
period.   If calling this operation on shards in different clusters (called replication
groups in the API and CLI), the calls can be made concurrently.     If calling this
operation multiple times on different shards in the same Redis (cluster mode enabled)
replication group, the first node replacement must complete before a subsequent call can be
made.   To determine whether the node replacement is complete you can check Events using
the Amazon ElastiCache console, the Amazon CLI, or the ElastiCache API. Look for the
following automatic failover related events, listed here in order of occurrance:
Replication group message: Test Failover API called for node group &lt;node-group-id&gt;
Cache cluster message: Failover from primary node &lt;primary-node-id&gt; to replica node
&lt;node-id&gt; completed    Replication group message: Failover from primary node
&lt;primary-node-id&gt; to replica node &lt;node-id&gt; completed    Cache cluster message:
Recovering cache nodes &lt;node-id&gt;    Cache cluster message: Finished recovery for
cache nodes &lt;node-id&gt;    For more information see:    Viewing ElastiCache Events in
the ElastiCache User Guide     DescribeEvents in the ElastiCache API Reference     Also
see, Testing Multi-AZ  in the ElastiCache User Guide.

# Arguments
- `node_group_id`: The name of the node group (called shard in the console) in this
  replication group on which automatic failover is to be tested. You may test automatic
  failover on up to 15 node groups in any rolling 24-hour period.
- `replication_group_id`: The name of the replication group (console: cluster) whose
  automatic failover is being tested by this operation.

"""
function test_failover(
    NodeGroupId, ReplicationGroupId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elasticache(
        "TestFailover",
        Dict{String,Any}(
            "NodeGroupId" => NodeGroupId, "ReplicationGroupId" => ReplicationGroupId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function test_failover(
    NodeGroupId,
    ReplicationGroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "TestFailover",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "NodeGroupId" => NodeGroupId, "ReplicationGroupId" => ReplicationGroupId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    test_migration(customer_node_endpoint_list, replication_group_id)
    test_migration(customer_node_endpoint_list, replication_group_id, params::Dict{String,<:Any})

 Async API to test connection between source and target replication group.

# Arguments
- `customer_node_endpoint_list`:  List of endpoints from which data should be migrated.
  List should have only one element.
- `replication_group_id`:  The ID of the replication group to which data is to be migrated.

"""
function test_migration(
    CustomerNodeEndpointList,
    ReplicationGroupId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "TestMigration",
        Dict{String,Any}(
            "CustomerNodeEndpointList" => CustomerNodeEndpointList,
            "ReplicationGroupId" => ReplicationGroupId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function test_migration(
    CustomerNodeEndpointList,
    ReplicationGroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elasticache(
        "TestMigration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CustomerNodeEndpointList" => CustomerNodeEndpointList,
                    "ReplicationGroupId" => ReplicationGroupId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: cloudwatch_logs
using AWS.Compat
using AWS.UUIDs

"""
    associate_kms_key(kms_key_id)
    associate_kms_key(kms_key_id, params::Dict{String,<:Any})

Associates the specified KMS key with either one log group in the account, or with all
stored CloudWatch Logs query insights results in the account. When you use AssociateKmsKey,
you specify either the logGroupName parameter or the resourceIdentifier parameter. You
can't specify both of those parameters in the same operation.   Specify the logGroupName
parameter to cause all log events stored in the log group to be encrypted with that key.
Only the log events ingested after the key is associated are encrypted with that key.
Associating a KMS key with a log group overrides any existing associations between the log
group and a KMS key. After a KMS key is associated with a log group, all newly ingested
data for the log group is encrypted using the KMS key. This association is stored as long
as the data encrypted with the KMS key is still within CloudWatch Logs. This enables
CloudWatch Logs to decrypt this data whenever it is requested. Associating a key with a log
group does not cause the results of queries of that log group to be encrypted with that
key. To have query results encrypted with a KMS key, you must use an AssociateKmsKey
operation with the resourceIdentifier parameter that specifies a query-result resource.
Specify the resourceIdentifier parameter with a query-result resource, to use that key to
encrypt the stored results of all future StartQuery operations in the account. The response
from a GetQueryResults operation will still return the query results in plain text. Even if
you have not associated a key with your query results, the query results are encrypted when
stored, using the default CloudWatch Logs method. If you run a query from a monitoring
account that queries logs in a source account, the query results key from the monitoring
account, if any, is used.    If you delete the key that is used to encrypt log events or
log group query results, then all the associated stored log events or query results that
were encrypted with that key will be unencryptable and unusable.   CloudWatch Logs supports
only symmetric KMS keys. Do not use an associate an asymmetric KMS key with your log group
or query results. For more information, see Using Symmetric and Asymmetric Keys.  It can
take up to 5 minutes for this operation to take effect. If you attempt to associate a KMS
key with a log group but the KMS key does not exist or the KMS key is disabled, you receive
an InvalidParameterException error.

# Arguments
- `kms_key_id`: The Amazon Resource Name (ARN) of the KMS key to use when encrypting log
  data. This must be a symmetric KMS key. For more information, see Amazon Resource Names and
  Using Symmetric and Asymmetric Keys.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"logGroupName"`: The name of the log group. In your AssociateKmsKey operation, you must
  specify either the resourceIdentifier parameter or the logGroup parameter, but you can't
  specify both.
- `"resourceIdentifier"`: Specifies the target for this operation. You must specify one of
  the following:   Specify the following ARN to have future GetQueryResults operations in
  this account encrypt the results with the specified KMS key. Replace REGION and ACCOUNT_ID
  with your Region and account ID.  arn:aws:logs:REGION:ACCOUNT_ID:query-result:*    Specify
  the ARN of a log group to have CloudWatch Logs use the KMS key to encrypt log events that
  are ingested and stored by that log group. The log group ARN must be in the following
  format. Replace REGION and ACCOUNT_ID with your Region and account ID.
  arn:aws:logs:REGION:ACCOUNT_ID:log-group:LOG_GROUP_NAME     In your AssociateKmsKey
  operation, you must specify either the resourceIdentifier parameter or the logGroup
  parameter, but you can't specify both.
"""
function associate_kms_key(kmsKeyId; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_logs(
        "AssociateKmsKey",
        Dict{String,Any}("kmsKeyId" => kmsKeyId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_kms_key(
    kmsKeyId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_logs(
        "AssociateKmsKey",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("kmsKeyId" => kmsKeyId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_export_task(task_id)
    cancel_export_task(task_id, params::Dict{String,<:Any})

Cancels the specified export task. The task must be in the PENDING or RUNNING state.

# Arguments
- `task_id`: The ID of the export task.

"""
function cancel_export_task(taskId; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_logs(
        "CancelExportTask",
        Dict{String,Any}("taskId" => taskId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_export_task(
    taskId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "CancelExportTask",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("taskId" => taskId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_delivery(delivery_destination_arn, delivery_source_name)
    create_delivery(delivery_destination_arn, delivery_source_name, params::Dict{String,<:Any})

Creates a delivery. A delivery is a connection between a logical delivery source and a
logical delivery destination that you have already created. Only some Amazon Web Services
services support being configured as a delivery source using this operation. These services
are listed as Supported [V2 Permissions] in the table at Enabling logging from Amazon Web
Services services.  A delivery destination can represent a log group in CloudWatch Logs, an
Amazon S3 bucket, or a delivery stream in Firehose. To configure logs delivery between a
supported Amazon Web Services service and a destination, you must do the following:
Create a delivery source, which is a logical object that represents the resource that is
actually sending the logs. For more information, see PutDeliverySource.   Create a delivery
destination, which is a logical object that represents the actual delivery destination. For
more information, see PutDeliveryDestination.   If you are delivering logs cross-account,
you must use PutDeliveryDestinationPolicy in the destination account to assign an IAM
policy to the destination. This policy allows delivery to that destination.    Use
CreateDelivery to create a delivery by pairing exactly one delivery source and one delivery
destination.    You can configure a single delivery source to send logs to multiple
destinations by creating multiple deliveries. You can also create multiple deliveries to
configure multiple delivery sources to send logs to the same delivery destination. You
can't update an existing delivery. You can only create and delete deliveries.

# Arguments
- `delivery_destination_arn`: The ARN of the delivery destination to use for this delivery.
- `delivery_source_name`: The name of the delivery source to use for this delivery.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tags"`: An optional list of key-value pairs to associate with the resource. For more
  information about tagging, see Tagging Amazon Web Services resources
"""
function create_delivery(
    deliveryDestinationArn,
    deliverySourceName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_logs(
        "CreateDelivery",
        Dict{String,Any}(
            "deliveryDestinationArn" => deliveryDestinationArn,
            "deliverySourceName" => deliverySourceName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_delivery(
    deliveryDestinationArn,
    deliverySourceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_logs(
        "CreateDelivery",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "deliveryDestinationArn" => deliveryDestinationArn,
                    "deliverySourceName" => deliverySourceName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_export_task(destination, from, log_group_name, to)
    create_export_task(destination, from, log_group_name, to, params::Dict{String,<:Any})

Creates an export task so that you can efficiently export data from a log group to an
Amazon S3 bucket. When you perform a CreateExportTask operation, you must use credentials
that have permission to write to the S3 bucket that you specify as the destination.
Exporting log data to S3 buckets that are encrypted by KMS is supported. Exporting log data
to Amazon S3 buckets that have S3 Object Lock enabled with a retention period is also
supported. Exporting to S3 buckets that are encrypted with AES-256 is supported.  This is
an asynchronous call. If all the required information is provided, this operation initiates
an export task and responds with the ID of the task. After the task has started, you can
use DescribeExportTasks to get the status of the export task. Each account can only have
one active (RUNNING or PENDING) export task at a time. To cancel an export task, use
CancelExportTask. You can export logs from multiple log groups or multiple time ranges to
the same S3 bucket. To separate log data for each export task, specify a prefix to be used
as the Amazon S3 key prefix for all exported objects.  Time-based sorting on chunks of log
data inside an exported file is not guaranteed. You can sort the exported log field data by
using Linux utilities.

# Arguments
- `destination`: The name of S3 bucket for the exported log data. The bucket must be in the
  same Amazon Web Services Region.
- `from`: The start time of the range for the request, expressed as the number of
  milliseconds after Jan 1, 1970 00:00:00 UTC. Events with a timestamp earlier than this time
  are not exported.
- `log_group_name`: The name of the log group.
- `to`: The end time of the range for the request, expressed as the number of milliseconds
  after Jan 1, 1970 00:00:00 UTC. Events with a timestamp later than this time are not
  exported. You must specify a time that is not earlier than when this log group was created.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"destinationPrefix"`: The prefix used as the start of the key for every object exported.
  If you don't specify a value, the default is exportedlogs.
- `"logStreamNamePrefix"`: Export only log streams that match the provided prefix. If you
  don't specify a value, no prefix filter is applied.
- `"taskName"`: The name of the export task.
"""
function create_export_task(
    destination, from, logGroupName, to; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "CreateExportTask",
        Dict{String,Any}(
            "destination" => destination,
            "from" => from,
            "logGroupName" => logGroupName,
            "to" => to,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_export_task(
    destination,
    from,
    logGroupName,
    to,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_logs(
        "CreateExportTask",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "destination" => destination,
                    "from" => from,
                    "logGroupName" => logGroupName,
                    "to" => to,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_log_anomaly_detector(log_group_arn_list)
    create_log_anomaly_detector(log_group_arn_list, params::Dict{String,<:Any})

Creates an anomaly detector that regularly scans one or more log groups and look for
patterns and anomalies in the logs. An anomaly detector can help surface issues by
automatically discovering anomalies in your log event traffic. An anomaly detector uses
machine learning algorithms to scan log events and find patterns. A pattern is a shared
text structure that recurs among your log fields. Patterns provide a useful tool for
analyzing large sets of logs because a large number of log events can often be compressed
into a few patterns. The anomaly detector uses pattern recognition to find anomalies, which
are unusual log events. It uses the evaluationFrequency to compare current log events and
patterns with trained baselines.  Fields within a pattern are called tokens. Fields that
vary within a pattern, such as a request ID or timestamp, are referred to as dynamic tokens
and represented by &lt;*&gt;.  The following is an example of a pattern:  [INFO] Request
time: &lt;*&gt; ms  This pattern represents log events like [INFO] Request time: 327 ms and
other similar log events that differ only by the number, in this csse 327. When the pattern
is displayed, the different numbers are replaced by &lt;*&gt;   Any parts of log events
that are masked as sensitive data are not scanned for anomalies. For more information about
masking sensitive data, see Help protect sensitive log data with masking.

# Arguments
- `log_group_arn_list`: An array containing the ARN of the log group that this anomaly
  detector will watch. You can specify only one log group ARN.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"anomalyVisibilityTime"`: The number of days to have visibility on an anomaly. After
  this time period has elapsed for an anomaly, it will be automatically baselined and the
  anomaly detector will treat new occurrences of a similar anomaly as normal. Therefore, if
  you do not correct the cause of an anomaly during the time period specified in
  anomalyVisibilityTime, it will be considered normal going forward and will not be detected
  as an anomaly.
- `"detectorName"`: A name for this anomaly detector.
- `"evaluationFrequency"`: Specifies how often the anomaly detector is to run and look for
  anomalies. Set this value according to the frequency that the log group receives new logs.
  For example, if the log group receives new log events every 10 minutes, then 15 minutes
  might be a good setting for evaluationFrequency .
- `"filterPattern"`: You can use this parameter to limit the anomaly detection model to
  examine only log events that match the pattern you specify here. For more information, see
  Filter and Pattern Syntax.
- `"kmsKeyId"`: Optionally assigns a KMS key to secure this anomaly detector and its
  findings. If a key is assigned, the anomalies found and the model used by this detector are
  encrypted at rest with the key. If a key is assigned to an anomaly detector, a user must
  have permissions for both this key and for the anomaly detector to retrieve information
  about the anomalies that it finds. For more information about using a KMS key and to see
  the required IAM policy, see Use a KMS key with an anomaly detector.
- `"tags"`: An optional list of key-value pairs to associate with the resource. For more
  information about tagging, see Tagging Amazon Web Services resources
"""
function create_log_anomaly_detector(
    logGroupArnList; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "CreateLogAnomalyDetector",
        Dict{String,Any}("logGroupArnList" => logGroupArnList);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_log_anomaly_detector(
    logGroupArnList,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_logs(
        "CreateLogAnomalyDetector",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("logGroupArnList" => logGroupArnList), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_log_group(log_group_name)
    create_log_group(log_group_name, params::Dict{String,<:Any})

Creates a log group with the specified name. You can create up to 1,000,000 log groups per
Region per account. You must use the following guidelines when naming a log group:   Log
group names must be unique within a Region for an Amazon Web Services account.   Log group
names can be between 1 and 512 characters long.   Log group names consist of the following
characters: a-z, A-Z, 0-9, '_' (underscore), '-' (hyphen), '/' (forward slash), '.'
(period), and '#' (number sign)   Log group names can't start with the string aws/    When
you create a log group, by default the log events in the log group do not expire. To set a
retention policy so that events expire and are deleted after a specified time, use
PutRetentionPolicy. If you associate an KMS key with the log group, ingested data is
encrypted using the KMS key. This association is stored as long as the data encrypted with
the KMS key is still within CloudWatch Logs. This enables CloudWatch Logs to decrypt this
data whenever it is requested. If you attempt to associate a KMS key with the log group but
the KMS key does not exist or the KMS key is disabled, you receive an
InvalidParameterException error.   CloudWatch Logs supports only symmetric KMS keys. Do not
associate an asymmetric KMS key with your log group. For more information, see Using
Symmetric and Asymmetric Keys.

# Arguments
- `log_group_name`: A name for the log group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"kmsKeyId"`: The Amazon Resource Name (ARN) of the KMS key to use when encrypting log
  data. For more information, see Amazon Resource Names.
- `"logGroupClass"`: Use this parameter to specify the log group class for this log group.
  There are two classes:   The Standard log class supports all CloudWatch Logs features.
  The Infrequent Access log class supports a subset of CloudWatch Logs features and incurs
  lower costs.   If you omit this parameter, the default of STANDARD is used.  The value of
  logGroupClass can't be changed after a log group is created.  For details about the
  features supported by each class, see Log classes
- `"tags"`: The key-value pairs to use for the tags. You can grant users access to certain
  log groups while preventing them from accessing other log groups. To do so, tag your groups
  and use IAM policies that refer to those tags. To assign tags when you create a log group,
  you must have either the logs:TagResource or logs:TagLogGroup permission. For more
  information about tagging, see Tagging Amazon Web Services resources. For more information
  about using tags to control access, see Controlling access to Amazon Web Services resources
  using tags.
"""
function create_log_group(logGroupName; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_logs(
        "CreateLogGroup",
        Dict{String,Any}("logGroupName" => logGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_log_group(
    logGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_logs(
        "CreateLogGroup",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("logGroupName" => logGroupName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_log_stream(log_group_name, log_stream_name)
    create_log_stream(log_group_name, log_stream_name, params::Dict{String,<:Any})

Creates a log stream for the specified log group. A log stream is a sequence of log events
that originate from a single source, such as an application instance or a resource that is
being monitored. There is no limit on the number of log streams that you can create for a
log group. There is a limit of 50 TPS on CreateLogStream operations, after which
transactions are throttled. You must use the following guidelines when naming a log stream:
  Log stream names must be unique within the log group.   Log stream names can be between 1
and 512 characters long.   Don't use ':' (colon) or '*' (asterisk) characters.

# Arguments
- `log_group_name`: The name of the log group.
- `log_stream_name`: The name of the log stream.

"""
function create_log_stream(
    logGroupName, logStreamName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "CreateLogStream",
        Dict{String,Any}("logGroupName" => logGroupName, "logStreamName" => logStreamName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_log_stream(
    logGroupName,
    logStreamName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_logs(
        "CreateLogStream",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "logGroupName" => logGroupName, "logStreamName" => logStreamName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_account_policy(policy_name, policy_type)
    delete_account_policy(policy_name, policy_type, params::Dict{String,<:Any})

Deletes a CloudWatch Logs account policy. This stops the policy from applying to all log
groups or a subset of log groups in the account. Log-group level policies will still be in
effect. To use this operation, you must be signed on with the correct permissions depending
on the type of policy that you are deleting.   To delete a data protection policy, you must
have the logs:DeleteDataProtectionPolicy and logs:DeleteAccountPolicy permissions.   To
delete a subscription filter policy, you must have the logs:DeleteSubscriptionFilter and
logs:DeleteAccountPolicy permissions.

# Arguments
- `policy_name`: The name of the policy to delete.
- `policy_type`: The type of policy to delete.

"""
function delete_account_policy(
    policyName, policyType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "DeleteAccountPolicy",
        Dict{String,Any}("policyName" => policyName, "policyType" => policyType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_account_policy(
    policyName,
    policyType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_logs(
        "DeleteAccountPolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("policyName" => policyName, "policyType" => policyType),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_data_protection_policy(log_group_identifier)
    delete_data_protection_policy(log_group_identifier, params::Dict{String,<:Any})

Deletes the data protection policy from the specified log group.  For more information
about data protection policies, see PutDataProtectionPolicy.

# Arguments
- `log_group_identifier`: The name or ARN of the log group that you want to delete the data
  protection policy for.

"""
function delete_data_protection_policy(
    logGroupIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "DeleteDataProtectionPolicy",
        Dict{String,Any}("logGroupIdentifier" => logGroupIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_data_protection_policy(
    logGroupIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_logs(
        "DeleteDataProtectionPolicy",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("logGroupIdentifier" => logGroupIdentifier), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_delivery(id)
    delete_delivery(id, params::Dict{String,<:Any})

Deletes s delivery. A delivery is a connection between a logical delivery source and a
logical delivery destination. Deleting a delivery only deletes the connection between the
delivery source and delivery destination. It does not delete the delivery destination or
the delivery source.

# Arguments
- `id`: The unique ID of the delivery to delete. You can find the ID of a delivery with the
  DescribeDeliveries operation.

"""
function delete_delivery(id; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_logs(
        "DeleteDelivery",
        Dict{String,Any}("id" => id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_delivery(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "DeleteDelivery",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("id" => id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_delivery_destination(name)
    delete_delivery_destination(name, params::Dict{String,<:Any})

Deletes a delivery destination. A delivery is a connection between a logical delivery
source and a logical delivery destination. You can't delete a delivery destination if any
current deliveries are associated with it. To find whether any deliveries are associated
with this delivery destination, use the DescribeDeliveries operation and check the
deliveryDestinationArn field in the results.

# Arguments
- `name`: The name of the delivery destination that you want to delete. You can find a list
  of delivery destionation names by using the DescribeDeliveryDestinations operation.

"""
function delete_delivery_destination(
    name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "DeleteDeliveryDestination",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_delivery_destination(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "DeleteDeliveryDestination",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_delivery_destination_policy(delivery_destination_name)
    delete_delivery_destination_policy(delivery_destination_name, params::Dict{String,<:Any})

Deletes a delivery destination policy. For more information about these policies, see
PutDeliveryDestinationPolicy.

# Arguments
- `delivery_destination_name`: The name of the delivery destination that you want to delete
  the policy for.

"""
function delete_delivery_destination_policy(
    deliveryDestinationName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "DeleteDeliveryDestinationPolicy",
        Dict{String,Any}("deliveryDestinationName" => deliveryDestinationName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_delivery_destination_policy(
    deliveryDestinationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_logs(
        "DeleteDeliveryDestinationPolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("deliveryDestinationName" => deliveryDestinationName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_delivery_source(name)
    delete_delivery_source(name, params::Dict{String,<:Any})

Deletes a delivery source. A delivery is a connection between a logical delivery source and
a logical delivery destination. You can't delete a delivery source if any current
deliveries are associated with it. To find whether any deliveries are associated with this
delivery source, use the DescribeDeliveries operation and check the deliverySourceName
field in the results.

# Arguments
- `name`: The name of the delivery source that you want to delete.

"""
function delete_delivery_source(name; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_logs(
        "DeleteDeliverySource",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_delivery_source(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "DeleteDeliverySource",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_destination(destination_name)
    delete_destination(destination_name, params::Dict{String,<:Any})

Deletes the specified destination, and eventually disables all the subscription filters
that publish to it. This operation does not delete the physical resource encapsulated by
the destination.

# Arguments
- `destination_name`: The name of the destination.

"""
function delete_destination(
    destinationName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "DeleteDestination",
        Dict{String,Any}("destinationName" => destinationName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_destination(
    destinationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_logs(
        "DeleteDestination",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("destinationName" => destinationName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_log_anomaly_detector(anomaly_detector_arn)
    delete_log_anomaly_detector(anomaly_detector_arn, params::Dict{String,<:Any})

Deletes the specified CloudWatch Logs anomaly detector.

# Arguments
- `anomaly_detector_arn`: The ARN of the anomaly detector to delete. You can find the ARNs
  of log anomaly detectors in your account by using the ListLogAnomalyDetectors operation.

"""
function delete_log_anomaly_detector(
    anomalyDetectorArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "DeleteLogAnomalyDetector",
        Dict{String,Any}("anomalyDetectorArn" => anomalyDetectorArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_log_anomaly_detector(
    anomalyDetectorArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_logs(
        "DeleteLogAnomalyDetector",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("anomalyDetectorArn" => anomalyDetectorArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_log_group(log_group_name)
    delete_log_group(log_group_name, params::Dict{String,<:Any})

Deletes the specified log group and permanently deletes all the archived log events
associated with the log group.

# Arguments
- `log_group_name`: The name of the log group.

"""
function delete_log_group(logGroupName; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_logs(
        "DeleteLogGroup",
        Dict{String,Any}("logGroupName" => logGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_log_group(
    logGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_logs(
        "DeleteLogGroup",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("logGroupName" => logGroupName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_log_stream(log_group_name, log_stream_name)
    delete_log_stream(log_group_name, log_stream_name, params::Dict{String,<:Any})

Deletes the specified log stream and permanently deletes all the archived log events
associated with the log stream.

# Arguments
- `log_group_name`: The name of the log group.
- `log_stream_name`: The name of the log stream.

"""
function delete_log_stream(
    logGroupName, logStreamName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "DeleteLogStream",
        Dict{String,Any}("logGroupName" => logGroupName, "logStreamName" => logStreamName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_log_stream(
    logGroupName,
    logStreamName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_logs(
        "DeleteLogStream",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "logGroupName" => logGroupName, "logStreamName" => logStreamName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_metric_filter(filter_name, log_group_name)
    delete_metric_filter(filter_name, log_group_name, params::Dict{String,<:Any})

Deletes the specified metric filter.

# Arguments
- `filter_name`: The name of the metric filter.
- `log_group_name`: The name of the log group.

"""
function delete_metric_filter(
    filterName, logGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "DeleteMetricFilter",
        Dict{String,Any}("filterName" => filterName, "logGroupName" => logGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_metric_filter(
    filterName,
    logGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_logs(
        "DeleteMetricFilter",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "filterName" => filterName, "logGroupName" => logGroupName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_query_definition(query_definition_id)
    delete_query_definition(query_definition_id, params::Dict{String,<:Any})

Deletes a saved CloudWatch Logs Insights query definition. A query definition contains
details about a saved CloudWatch Logs Insights query. Each DeleteQueryDefinition operation
can delete one query definition. You must have the logs:DeleteQueryDefinition permission to
be able to perform this operation.

# Arguments
- `query_definition_id`: The ID of the query definition that you want to delete. You can
  use DescribeQueryDefinitions to retrieve the IDs of your saved query definitions.

"""
function delete_query_definition(
    queryDefinitionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "DeleteQueryDefinition",
        Dict{String,Any}("queryDefinitionId" => queryDefinitionId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_query_definition(
    queryDefinitionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_logs(
        "DeleteQueryDefinition",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("queryDefinitionId" => queryDefinitionId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_resource_policy()
    delete_resource_policy(params::Dict{String,<:Any})

Deletes a resource policy from this account. This revokes the access of the identities in
that policy to put log events to this account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"policyName"`: The name of the policy to be revoked. This parameter is required.
"""
function delete_resource_policy(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_logs(
        "DeleteResourcePolicy"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function delete_resource_policy(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "DeleteResourcePolicy",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_retention_policy(log_group_name)
    delete_retention_policy(log_group_name, params::Dict{String,<:Any})

Deletes the specified retention policy. Log events do not expire if they belong to log
groups without a retention policy.

# Arguments
- `log_group_name`: The name of the log group.

"""
function delete_retention_policy(
    logGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "DeleteRetentionPolicy",
        Dict{String,Any}("logGroupName" => logGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_retention_policy(
    logGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_logs(
        "DeleteRetentionPolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("logGroupName" => logGroupName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_subscription_filter(filter_name, log_group_name)
    delete_subscription_filter(filter_name, log_group_name, params::Dict{String,<:Any})

Deletes the specified subscription filter.

# Arguments
- `filter_name`: The name of the subscription filter.
- `log_group_name`: The name of the log group.

"""
function delete_subscription_filter(
    filterName, logGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "DeleteSubscriptionFilter",
        Dict{String,Any}("filterName" => filterName, "logGroupName" => logGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_subscription_filter(
    filterName,
    logGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_logs(
        "DeleteSubscriptionFilter",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "filterName" => filterName, "logGroupName" => logGroupName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_account_policies(policy_type)
    describe_account_policies(policy_type, params::Dict{String,<:Any})

Returns a list of all CloudWatch Logs account policies in the account.

# Arguments
- `policy_type`: Use this parameter to limit the returned policies to only the policies
  that match the policy type that you specify.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountIdentifiers"`: If you are using an account that is set up as a monitoring
  account for CloudWatch unified cross-account observability, you can use this to specify the
  account ID of a source account. If you do, the operation returns the account policy for the
  specified account. Currently, you can specify only one account ID in this parameter. If you
  omit this parameter, only the policy in the current account is returned.
- `"policyName"`: Use this parameter to limit the returned policies to only the policy with
  the name that you specify.
"""
function describe_account_policies(
    policyType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "DescribeAccountPolicies",
        Dict{String,Any}("policyType" => policyType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_account_policies(
    policyType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_logs(
        "DescribeAccountPolicies",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("policyType" => policyType), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_deliveries()
    describe_deliveries(params::Dict{String,<:Any})

Retrieves a list of the deliveries that have been created in the account. A delivery is a
connection between a  delivery source  and a  delivery destination . A delivery source
represents an Amazon Web Services resource that sends logs to an logs delivery destination.
The destination can be CloudWatch Logs, Amazon S3, or Firehose. Only some Amazon Web
Services services support being configured as a delivery source. These services are listed
in Enable logging from Amazon Web Services services.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"limit"`: Optionally specify the maximum number of deliveries to return in the response.
- `"nextToken"`:
"""
function describe_deliveries(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_logs(
        "DescribeDeliveries"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_deliveries(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "DescribeDeliveries", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_delivery_destinations()
    describe_delivery_destinations(params::Dict{String,<:Any})

Retrieves a list of the delivery destinations that have been created in the account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"limit"`: Optionally specify the maximum number of delivery destinations to return in
  the response.
- `"nextToken"`:
"""
function describe_delivery_destinations(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "DescribeDeliveryDestinations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_delivery_destinations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "DescribeDeliveryDestinations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_delivery_sources()
    describe_delivery_sources(params::Dict{String,<:Any})

Retrieves a list of the delivery sources that have been created in the account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"limit"`: Optionally specify the maximum number of delivery sources to return in the
  response.
- `"nextToken"`:
"""
function describe_delivery_sources(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_logs(
        "DescribeDeliverySources"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_delivery_sources(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "DescribeDeliverySources",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_destinations()
    describe_destinations(params::Dict{String,<:Any})

Lists all your destinations. The results are ASCII-sorted by destination name.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DestinationNamePrefix"`: The prefix to match. If you don't specify a value, no prefix
  filter is applied.
- `"limit"`: The maximum number of items returned. If you don't specify a value, the
  default maximum value of 50 items is used.
- `"nextToken"`: The token for the next set of items to return. (You received this token
  from a previous call.)
"""
function describe_destinations(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_logs(
        "DescribeDestinations"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_destinations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "DescribeDestinations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_export_tasks()
    describe_export_tasks(params::Dict{String,<:Any})

Lists the specified export tasks. You can list all your export tasks or filter the results
based on task ID or task status.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"limit"`: The maximum number of items returned. If you don't specify a value, the
  default is up to 50 items.
- `"nextToken"`: The token for the next set of items to return. (You received this token
  from a previous call.)
- `"statusCode"`: The status code of the export task. Specifying a status code filters the
  results to zero or more export tasks.
- `"taskId"`: The ID of the export task. Specifying a task ID filters the results to one or
  zero export tasks.
"""
function describe_export_tasks(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_logs(
        "DescribeExportTasks"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_export_tasks(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "DescribeExportTasks",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_log_groups()
    describe_log_groups(params::Dict{String,<:Any})

Lists the specified log groups. You can list all your log groups or filter the results by
prefix. The results are ASCII-sorted by log group name. CloudWatch Logs doesn’t support
IAM policies that control access to the DescribeLogGroups action by using the
aws:ResourceTag/key-name  condition key. Other CloudWatch Logs actions do support the use
of the aws:ResourceTag/key-name  condition key to control access. For more information
about using tags to control access, see Controlling access to Amazon Web Services resources
using tags. If you are using CloudWatch cross-account observability, you can use this
operation in a monitoring account and view data from the linked source accounts. For more
information, see CloudWatch cross-account observability.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountIdentifiers"`: When includeLinkedAccounts is set to True, use this parameter to
  specify the list of accounts to search. You can specify as many as 20 account IDs in the
  array.
- `"includeLinkedAccounts"`: If you are using a monitoring account, set this to True to
  have the operation return log groups in the accounts listed in accountIdentifiers. If this
  parameter is set to true and accountIdentifiers contains a null value, the operation
  returns all log groups in the monitoring account and all log groups in all source accounts
  that are linked to the monitoring account.
- `"limit"`: The maximum number of items returned. If you don't specify a value, the
  default is up to 50 items.
- `"logGroupClass"`: Specifies the log group class for this log group. There are two
  classes:   The Standard log class supports all CloudWatch Logs features.   The Infrequent
  Access log class supports a subset of CloudWatch Logs features and incurs lower costs.
  For details about the features supported by each class, see Log classes
- `"logGroupNamePattern"`: If you specify a string for this parameter, the operation
  returns only log groups that have names that match the string based on a case-sensitive
  substring search. For example, if you specify Foo, log groups named FooBar, aws/Foo, and
  GroupFoo would match, but foo, F/o/o and Froo would not match. If you specify
  logGroupNamePattern in your request, then only arn, creationTime, and logGroupName are
  included in the response.    logGroupNamePattern and logGroupNamePrefix are mutually
  exclusive. Only one of these parameters can be passed.
- `"logGroupNamePrefix"`: The prefix to match.   logGroupNamePrefix and logGroupNamePattern
  are mutually exclusive. Only one of these parameters can be passed.
- `"nextToken"`: The token for the next set of items to return. (You received this token
  from a previous call.)
"""
function describe_log_groups(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_logs(
        "DescribeLogGroups"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_log_groups(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "DescribeLogGroups", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_log_streams()
    describe_log_streams(params::Dict{String,<:Any})

Lists the log streams for the specified log group. You can list all the log streams or
filter the results by prefix. You can also control how the results are ordered. You can
specify the log group to search by using either logGroupIdentifier or logGroupName. You
must include one of these two parameters, but you can't include both.  This operation has a
limit of five transactions per second, after which transactions are throttled. If you are
using CloudWatch cross-account observability, you can use this operation in a monitoring
account and view data from the linked source accounts. For more information, see CloudWatch
cross-account observability.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"descending"`: If the value is true, results are returned in descending order. If the
  value is to false, results are returned in ascending order. The default value is false.
- `"limit"`: The maximum number of items returned. If you don't specify a value, the
  default is up to 50 items.
- `"logGroupIdentifier"`: Specify either the name or ARN of the log group to view. If the
  log group is in a source account and you are using a monitoring account, you must use the
  log group ARN.   You must include either logGroupIdentifier or logGroupName, but not both.
- `"logGroupName"`: The name of the log group.   You must include either logGroupIdentifier
  or logGroupName, but not both.
- `"logStreamNamePrefix"`: The prefix to match. If orderBy is LastEventTime, you cannot
  specify this parameter.
- `"nextToken"`: The token for the next set of items to return. (You received this token
  from a previous call.)
- `"orderBy"`: If the value is LogStreamName, the results are ordered by log stream name.
  If the value is LastEventTime, the results are ordered by the event time. The default value
  is LogStreamName. If you order the results by event time, you cannot specify the
  logStreamNamePrefix parameter.  lastEventTimestamp represents the time of the most recent
  log event in the log stream in CloudWatch Logs. This number is expressed as the number of
  milliseconds after Jan 1, 1970 00:00:00 UTC. lastEventTimestamp updates on an eventual
  consistency basis. It typically updates in less than an hour from ingestion, but in rare
  situations might take longer.
"""
function describe_log_streams(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_logs(
        "DescribeLogStreams"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_log_streams(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "DescribeLogStreams", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_metric_filters()
    describe_metric_filters(params::Dict{String,<:Any})

Lists the specified metric filters. You can list all of the metric filters or filter the
results by log name, prefix, metric name, or metric namespace. The results are ASCII-sorted
by filter name.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filterNamePrefix"`: The prefix to match. CloudWatch Logs uses the value that you set
  here only if you also include the logGroupName parameter in your request.
- `"limit"`: The maximum number of items returned. If you don't specify a value, the
  default is up to 50 items.
- `"logGroupName"`: The name of the log group.
- `"metricName"`: Filters results to include only those with the specified metric name. If
  you include this parameter in your request, you must also include the metricNamespace
  parameter.
- `"metricNamespace"`: Filters results to include only those in the specified namespace. If
  you include this parameter in your request, you must also include the metricName parameter.
- `"nextToken"`: The token for the next set of items to return. (You received this token
  from a previous call.)
"""
function describe_metric_filters(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_logs(
        "DescribeMetricFilters"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_metric_filters(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "DescribeMetricFilters",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_queries()
    describe_queries(params::Dict{String,<:Any})

Returns a list of CloudWatch Logs Insights queries that are scheduled, running, or have
been run recently in this account. You can request all queries or limit it to queries of a
specific log group or queries with a certain status.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"logGroupName"`: Limits the returned queries to only those for the specified log group.
- `"maxResults"`: Limits the number of returned queries to the specified number.
- `"nextToken"`:
- `"status"`: Limits the returned queries to only those that have the specified status.
  Valid values are Cancelled, Complete, Failed, Running, and Scheduled.
"""
function describe_queries(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_logs(
        "DescribeQueries"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_queries(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "DescribeQueries", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_query_definitions()
    describe_query_definitions(params::Dict{String,<:Any})

This operation returns a paginated list of your saved CloudWatch Logs Insights query
definitions. You can retrieve query definitions from the current account or from a source
account that is linked to the current account. You can use the queryDefinitionNamePrefix
parameter to limit the results to only the query definitions that have names that start
with a certain string.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Limits the number of returned query definitions to the specified number.
- `"nextToken"`:
- `"queryDefinitionNamePrefix"`: Use this parameter to filter your results to only the
  query definitions that have names that start with the prefix you specify.
"""
function describe_query_definitions(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_logs(
        "DescribeQueryDefinitions"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_query_definitions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "DescribeQueryDefinitions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_resource_policies()
    describe_resource_policies(params::Dict{String,<:Any})

Lists the resource policies in this account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"limit"`: The maximum number of resource policies to be displayed with one call of this
  API.
- `"nextToken"`:
"""
function describe_resource_policies(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_logs(
        "DescribeResourcePolicies"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_resource_policies(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "DescribeResourcePolicies",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_subscription_filters(log_group_name)
    describe_subscription_filters(log_group_name, params::Dict{String,<:Any})

Lists the subscription filters for the specified log group. You can list all the
subscription filters or filter the results by prefix. The results are ASCII-sorted by
filter name.

# Arguments
- `log_group_name`: The name of the log group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filterNamePrefix"`: The prefix to match. If you don't specify a value, no prefix filter
  is applied.
- `"limit"`: The maximum number of items returned. If you don't specify a value, the
  default is up to 50 items.
- `"nextToken"`: The token for the next set of items to return. (You received this token
  from a previous call.)
"""
function describe_subscription_filters(
    logGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "DescribeSubscriptionFilters",
        Dict{String,Any}("logGroupName" => logGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_subscription_filters(
    logGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_logs(
        "DescribeSubscriptionFilters",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("logGroupName" => logGroupName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_kms_key()
    disassociate_kms_key(params::Dict{String,<:Any})

Disassociates the specified KMS key from the specified log group or from all CloudWatch
Logs Insights query results in the account. When you use DisassociateKmsKey, you specify
either the logGroupName parameter or the resourceIdentifier parameter. You can't specify
both of those parameters in the same operation.   Specify the logGroupName parameter to
stop using the KMS key to encrypt future log events ingested and stored in the log group.
Instead, they will be encrypted with the default CloudWatch Logs method. The log events
that were ingested while the key was associated with the log group are still encrypted with
that key. Therefore, CloudWatch Logs will need permissions for the key whenever that data
is accessed.   Specify the resourceIdentifier parameter with the query-result resource to
stop using the KMS key to encrypt the results of all future StartQuery operations in the
account. They will instead be encrypted with the default CloudWatch Logs method. The
results from queries that ran while the key was associated with the account are still
encrypted with that key. Therefore, CloudWatch Logs will need permissions for the key
whenever that data is accessed.   It can take up to 5 minutes for this operation to take
effect.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"logGroupName"`: The name of the log group. In your DisassociateKmsKey operation, you
  must specify either the resourceIdentifier parameter or the logGroup parameter, but you
  can't specify both.
- `"resourceIdentifier"`: Specifies the target for this operation. You must specify one of
  the following:   Specify the ARN of a log group to stop having CloudWatch Logs use the KMS
  key to encrypt log events that are ingested and stored by that log group. After you run
  this operation, CloudWatch Logs encrypts ingested log events with the default CloudWatch
  Logs method. The log group ARN must be in the following format. Replace REGION and
  ACCOUNT_ID with your Region and account ID.
  arn:aws:logs:REGION:ACCOUNT_ID:log-group:LOG_GROUP_NAME     Specify the following ARN to
  stop using this key to encrypt the results of future StartQuery operations in this account.
  Replace REGION and ACCOUNT_ID with your Region and account ID.
  arn:aws:logs:REGION:ACCOUNT_ID:query-result:*    In your DisssociateKmsKey operation, you
  must specify either the resourceIdentifier parameter or the logGroup parameter, but you
  can't specify both.
"""
function disassociate_kms_key(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_logs(
        "DisassociateKmsKey"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function disassociate_kms_key(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "DisassociateKmsKey", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    filter_log_events()
    filter_log_events(params::Dict{String,<:Any})

Lists log events from the specified log group. You can list all the log events or filter
the results using a filter pattern, a time range, and the name of the log stream. You must
have the logs:FilterLogEvents permission to perform this operation. You can specify the log
group to search by using either logGroupIdentifier or logGroupName. You must include one of
these two parameters, but you can't include both.  By default, this operation returns as
many log events as can fit in 1 MB (up to 10,000 log events) or all the events found within
the specified time range. If the results include a token, that means there are more log
events available. You can get additional results by specifying the token in a subsequent
call. This operation can return empty results while there are more log events available
through the token. The returned log events are sorted by event timestamp, the timestamp
when the event was ingested by CloudWatch Logs, and the ID of the PutLogEvents request. If
you are using CloudWatch cross-account observability, you can use this operation in a
monitoring account and view data from the linked source accounts. For more information, see
CloudWatch cross-account observability.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"endTime"`: The end of the time range, expressed as the number of milliseconds after Jan
  1, 1970 00:00:00 UTC. Events with a timestamp later than this time are not returned.
- `"filterPattern"`: The filter pattern to use. For more information, see Filter and
  Pattern Syntax. If not provided, all the events are matched.
- `"interleaved"`: If the value is true, the operation attempts to provide responses that
  contain events from multiple log streams within the log group, interleaved in a single
  response. If the value is false, all the matched log events in the first log stream are
  searched first, then those in the next log stream, and so on.  Important As of June 17,
  2019, this parameter is ignored and the value is assumed to be true. The response from this
  operation always interleaves events from multiple log streams within a log group.
- `"limit"`: The maximum number of events to return. The default is 10,000 events.
- `"logGroupIdentifier"`: Specify either the name or ARN of the log group to view log
  events from. If the log group is in a source account and you are using a monitoring
  account, you must use the log group ARN.   You must include either logGroupIdentifier or
  logGroupName, but not both.
- `"logGroupName"`: The name of the log group to search.   You must include either
  logGroupIdentifier or logGroupName, but not both.
- `"logStreamNamePrefix"`: Filters the results to include only events from log streams that
  have names starting with this prefix. If you specify a value for both logStreamNamePrefix
  and logStreamNames, but the value for logStreamNamePrefix does not match any log stream
  names specified in logStreamNames, the action returns an InvalidParameterException error.
- `"logStreamNames"`: Filters the results to only logs from the log streams in this list.
  If you specify a value for both logStreamNamePrefix and logStreamNames, the action returns
  an InvalidParameterException error.
- `"nextToken"`: The token for the next set of events to return. (You received this token
  from a previous call.)
- `"startTime"`: The start of the time range, expressed as the number of milliseconds after
  Jan 1, 1970 00:00:00 UTC. Events with a timestamp before this time are not returned.
- `"unmask"`: Specify true to display the log event fields with all sensitive data unmasked
  and visible. The default is false. To use this operation with this parameter, you must be
  signed into an account with the logs:Unmask permission.
"""
function filter_log_events(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_logs(
        "FilterLogEvents"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function filter_log_events(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "FilterLogEvents", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_data_protection_policy(log_group_identifier)
    get_data_protection_policy(log_group_identifier, params::Dict{String,<:Any})

Returns information about a log group data protection policy.

# Arguments
- `log_group_identifier`: The name or ARN of the log group that contains the data
  protection policy that you want to see.

"""
function get_data_protection_policy(
    logGroupIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "GetDataProtectionPolicy",
        Dict{String,Any}("logGroupIdentifier" => logGroupIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_data_protection_policy(
    logGroupIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_logs(
        "GetDataProtectionPolicy",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("logGroupIdentifier" => logGroupIdentifier), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_delivery(id)
    get_delivery(id, params::Dict{String,<:Any})

Returns complete information about one logical delivery. A delivery is a connection between
a  delivery source  and a  delivery destination . A delivery source represents an Amazon
Web Services resource that sends logs to an logs delivery destination. The destination can
be CloudWatch Logs, Amazon S3, or Firehose. Only some Amazon Web Services services support
being configured as a delivery source. These services are listed in Enable logging from
Amazon Web Services services.  You need to specify the delivery id in this operation. You
can find the IDs of the deliveries in your account with the DescribeDeliveries operation.

# Arguments
- `id`: The ID of the delivery that you want to retrieve.

"""
function get_delivery(id; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_logs(
        "GetDelivery",
        Dict{String,Any}("id" => id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_delivery(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "GetDelivery",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("id" => id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_delivery_destination(name)
    get_delivery_destination(name, params::Dict{String,<:Any})

Retrieves complete information about one delivery destination.

# Arguments
- `name`: The name of the delivery destination that you want to retrieve.

"""
function get_delivery_destination(name; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_logs(
        "GetDeliveryDestination",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_delivery_destination(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "GetDeliveryDestination",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_delivery_destination_policy(delivery_destination_name)
    get_delivery_destination_policy(delivery_destination_name, params::Dict{String,<:Any})

Retrieves the delivery destination policy assigned to the delivery destination that you
specify. For more information about delivery destinations and their policies, see
PutDeliveryDestinationPolicy.

# Arguments
- `delivery_destination_name`: The name of the delivery destination that you want to
  retrieve the policy of.

"""
function get_delivery_destination_policy(
    deliveryDestinationName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "GetDeliveryDestinationPolicy",
        Dict{String,Any}("deliveryDestinationName" => deliveryDestinationName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_delivery_destination_policy(
    deliveryDestinationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_logs(
        "GetDeliveryDestinationPolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("deliveryDestinationName" => deliveryDestinationName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_delivery_source(name)
    get_delivery_source(name, params::Dict{String,<:Any})

Retrieves complete information about one delivery source.

# Arguments
- `name`: The name of the delivery source that you want to retrieve.

"""
function get_delivery_source(name; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_logs(
        "GetDeliverySource",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_delivery_source(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "GetDeliverySource",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_log_anomaly_detector(anomaly_detector_arn)
    get_log_anomaly_detector(anomaly_detector_arn, params::Dict{String,<:Any})

Retrieves information about the log anomaly detector that you specify.

# Arguments
- `anomaly_detector_arn`: The ARN of the anomaly detector to retrieve information about.
  You can find the ARNs of log anomaly detectors in your account by using the
  ListLogAnomalyDetectors operation.

"""
function get_log_anomaly_detector(
    anomalyDetectorArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "GetLogAnomalyDetector",
        Dict{String,Any}("anomalyDetectorArn" => anomalyDetectorArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_log_anomaly_detector(
    anomalyDetectorArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_logs(
        "GetLogAnomalyDetector",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("anomalyDetectorArn" => anomalyDetectorArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_log_events(log_stream_name)
    get_log_events(log_stream_name, params::Dict{String,<:Any})

Lists log events from the specified log stream. You can list all of the log events or
filter using a time range. By default, this operation returns as many log events as can fit
in a response size of 1MB (up to 10,000 log events). You can get additional log events by
specifying one of the tokens in a subsequent call. This operation can return empty results
while there are more log events available through the token. If you are using CloudWatch
cross-account observability, you can use this operation in a monitoring account and view
data from the linked source accounts. For more information, see CloudWatch cross-account
observability. You can specify the log group to search by using either logGroupIdentifier
or logGroupName. You must include one of these two parameters, but you can't include both.

# Arguments
- `log_stream_name`: The name of the log stream.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"endTime"`: The end of the time range, expressed as the number of milliseconds after Jan
  1, 1970 00:00:00 UTC. Events with a timestamp equal to or later than this time are not
  included.
- `"limit"`: The maximum number of log events returned. If you don't specify a limit, the
  default is as many log events as can fit in a response size of 1 MB (up to 10,000 log
  events).
- `"logGroupIdentifier"`: Specify either the name or ARN of the log group to view events
  from. If the log group is in a source account and you are using a monitoring account, you
  must use the log group ARN.   You must include either logGroupIdentifier or logGroupName,
  but not both.
- `"logGroupName"`: The name of the log group.   You must include either logGroupIdentifier
  or logGroupName, but not both.
- `"nextToken"`: The token for the next set of items to return. (You received this token
  from a previous call.)
- `"startFromHead"`: If the value is true, the earliest log events are returned first. If
  the value is false, the latest log events are returned first. The default value is false.
  If you are using a previous nextForwardToken value as the nextToken in this operation, you
  must specify true for startFromHead.
- `"startTime"`: The start of the time range, expressed as the number of milliseconds after
  Jan 1, 1970 00:00:00 UTC. Events with a timestamp equal to this time or later than this
  time are included. Events with a timestamp earlier than this time are not included.
- `"unmask"`: Specify true to display the log event fields with all sensitive data unmasked
  and visible. The default is false. To use this operation with this parameter, you must be
  signed into an account with the logs:Unmask permission.
"""
function get_log_events(logStreamName; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_logs(
        "GetLogEvents",
        Dict{String,Any}("logStreamName" => logStreamName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_log_events(
    logStreamName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_logs(
        "GetLogEvents",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("logStreamName" => logStreamName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_log_group_fields()
    get_log_group_fields(params::Dict{String,<:Any})

Returns a list of the fields that are included in log events in the specified log group.
Includes the percentage of log events that contain each field. The search is limited to a
time period that you specify. You can specify the log group to search by using either
logGroupIdentifier or logGroupName. You must specify one of these parameters, but you can't
specify both.  In the results, fields that start with @ are fields generated by CloudWatch
Logs. For example, @timestamp is the timestamp of each log event. For more information
about the fields that are generated by CloudWatch logs, see Supported Logs and Discovered
Fields. The response results are sorted by the frequency percentage, starting with the
highest percentage. If you are using CloudWatch cross-account observability, you can use
this operation in a monitoring account and view data from the linked source accounts. For
more information, see CloudWatch cross-account observability.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"logGroupIdentifier"`: Specify either the name or ARN of the log group to view. If the
  log group is in a source account and you are using a monitoring account, you must specify
  the ARN.   You must include either logGroupIdentifier or logGroupName, but not both.
- `"logGroupName"`: The name of the log group to search.   You must include either
  logGroupIdentifier or logGroupName, but not both.
- `"time"`: The time to set as the center of the query. If you specify time, the 8 minutes
  before and 8 minutes after this time are searched. If you omit time, the most recent 15
  minutes up to the current time are searched. The time value is specified as epoch time,
  which is the number of seconds since January 1, 1970, 00:00:00 UTC.
"""
function get_log_group_fields(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_logs(
        "GetLogGroupFields"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_log_group_fields(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "GetLogGroupFields", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_log_record(log_record_pointer)
    get_log_record(log_record_pointer, params::Dict{String,<:Any})

Retrieves all of the fields and values of a single log event. All fields are retrieved,
even if the original query that produced the logRecordPointer retrieved only a subset of
fields. Fields are returned as field name/field value pairs. The full unparsed log event is
returned within @message.

# Arguments
- `log_record_pointer`: The pointer corresponding to the log event record you want to
  retrieve. You get this from the response of a GetQueryResults operation. In that response,
  the value of the @ptr field for a log event is the value to use as logRecordPointer to
  retrieve that complete log event record.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"unmask"`: Specify true to display the log event fields with all sensitive data unmasked
  and visible. The default is false. To use this operation with this parameter, you must be
  signed into an account with the logs:Unmask permission.
"""
function get_log_record(
    logRecordPointer; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "GetLogRecord",
        Dict{String,Any}("logRecordPointer" => logRecordPointer);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_log_record(
    logRecordPointer,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_logs(
        "GetLogRecord",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("logRecordPointer" => logRecordPointer), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_query_results(query_id)
    get_query_results(query_id, params::Dict{String,<:Any})

Returns the results from the specified query. Only the fields requested in the query are
returned, along with a @ptr field, which is the identifier for the log record. You can use
the value of @ptr in a GetLogRecord operation to get the full log record.  GetQueryResults
does not start running a query. To run a query, use StartQuery. For more information about
how long results of previous queries are available, see CloudWatch Logs quotas. If the
value of the Status field in the output is Running, this operation returns only partial
results. If you see a value of Scheduled or Running for the status, you can retry the
operation later to see the final results.  If you are using CloudWatch cross-account
observability, you can use this operation in a monitoring account to start queries in
linked source accounts. For more information, see CloudWatch cross-account observability.

# Arguments
- `query_id`: The ID number of the query.

"""
function get_query_results(queryId; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_logs(
        "GetQueryResults",
        Dict{String,Any}("queryId" => queryId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_query_results(
    queryId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_logs(
        "GetQueryResults",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("queryId" => queryId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_anomalies()
    list_anomalies(params::Dict{String,<:Any})

Returns a list of anomalies that log anomaly detectors have found. For details about the
structure format of each anomaly object that is returned, see the example in this section.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"anomalyDetectorArn"`: Use this to optionally limit the results to only the anomalies
  found by a certain anomaly detector.
- `"limit"`: The maximum number of items to return. If you don't specify a value, the
  default maximum value of 50 items is used.
- `"nextToken"`:
- `"suppressionState"`: You can specify this parameter if you want to the operation to
  return only anomalies that are currently either suppressed or unsuppressed.
"""
function list_anomalies(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_logs(
        "ListAnomalies"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_anomalies(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "ListAnomalies", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_log_anomaly_detectors()
    list_log_anomaly_detectors(params::Dict{String,<:Any})

Retrieves a list of the log anomaly detectors in the account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filterLogGroupArn"`: Use this to optionally filter the results to only include anomaly
  detectors that are associated with the specified log group.
- `"limit"`: The maximum number of items to return. If you don't specify a value, the
  default maximum value of 50 items is used.
- `"nextToken"`:
"""
function list_log_anomaly_detectors(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_logs(
        "ListLogAnomalyDetectors"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_log_anomaly_detectors(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "ListLogAnomalyDetectors",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Displays the tags associated with a CloudWatch Logs resource. Currently, log groups and
destinations support tagging.

# Arguments
- `resource_arn`: The ARN of the resource that you want to view tags for. The ARN format of
  a log group is arn:aws:logs:Region:account-id:log-group:log-group-name   The ARN format of
  a destination is arn:aws:logs:Region:account-id:destination:destination-name   For more
  information about ARN format, see CloudWatch Logs resources and operations.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "ListTagsForResource",
        Dict{String,Any}("resourceArn" => resourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_logs(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceArn" => resourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_log_group(log_group_name)
    list_tags_log_group(log_group_name, params::Dict{String,<:Any})

 The ListTagsLogGroup operation is on the path to deprecation. We recommend that you use
ListTagsForResource instead.  Lists the tags for the specified log group.

# Arguments
- `log_group_name`: The name of the log group.

"""
function list_tags_log_group(
    logGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "ListTagsLogGroup",
        Dict{String,Any}("logGroupName" => logGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_log_group(
    logGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_logs(
        "ListTagsLogGroup",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("logGroupName" => logGroupName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_account_policy(policy_document, policy_name, policy_type)
    put_account_policy(policy_document, policy_name, policy_type, params::Dict{String,<:Any})

Creates an account-level data protection policy or subscription filter policy that applies
to all log groups or a subset of log groups in the account.  Data protection policy  A data
protection policy can help safeguard sensitive data that's ingested by your log groups by
auditing and masking the sensitive log data. Each account can have only one account-level
data protection policy.  Sensitive data is detected and masked when it is ingested into a
log group. When you set a data protection policy, log events ingested into the log groups
before that time are not masked.  If you use PutAccountPolicy to create a data protection
policy for your whole account, it applies to both existing log groups and all log groups
that are created later in this account. The account-level policy is applied to existing log
groups with eventual consistency. It might take up to 5 minutes before sensitive data in
existing log groups begins to be masked. By default, when a user views a log event that
includes masked data, the sensitive data is replaced by asterisks. A user who has the
logs:Unmask permission can use a GetLogEvents or FilterLogEvents operation with the unmask
parameter set to true to view the unmasked log events. Users with the logs:Unmask can also
view unmasked data in the CloudWatch Logs console by running a CloudWatch Logs Insights
query with the unmask query command. For more information, including a list of types of
data that can be audited and masked, see Protect sensitive log data with masking. To use
the PutAccountPolicy operation for a data protection policy, you must be signed on with the
logs:PutDataProtectionPolicy and logs:PutAccountPolicy permissions. The PutAccountPolicy
operation applies to all log groups in the account. You can use PutDataProtectionPolicy to
create a data protection policy that applies to just one log group. If a log group has its
own data protection policy and the account also has an account-level data protection
policy, then the two policies are cumulative. Any sensitive term specified in either policy
is masked.  Subscription filter policy  A subscription filter policy sets up a real-time
feed of log events from CloudWatch Logs to other Amazon Web Services services.
Account-level subscription filter policies apply to both existing log groups and log groups
that are created later in this account. Supported destinations are Kinesis Data Streams,
Firehose, and Lambda. When log events are sent to the receiving service, they are Base64
encoded and compressed with the GZIP format. The following destinations are supported for
subscription filters:   An Kinesis Data Streams data stream in the same account as the
subscription policy, for same-account delivery.   An Firehose data stream in the same
account as the subscription policy, for same-account delivery.   A Lambda function in the
same account as the subscription policy, for same-account delivery.   A logical destination
in a different account created with PutDestination, for cross-account delivery. Kinesis
Data Streams and Firehose are supported as logical destinations.   Each account can have
one account-level subscription filter policy. If you are updating an existing filter, you
must specify the correct name in PolicyName. To perform a PutAccountPolicy subscription
filter operation for any destination except a Lambda function, you must also have the
iam:PassRole permission.

# Arguments
- `policy_document`: Specify the policy, in JSON.  Data protection policy  A data
  protection policy must include two JSON blocks:   The first block must include both a
  DataIdentifer array and an Operation property with an Audit action. The DataIdentifer array
  lists the types of sensitive data that you want to mask. For more information about the
  available options, see Types of data that you can mask. The Operation property with an
  Audit action is required to find the sensitive data terms. This Audit action must contain a
  FindingsDestination object. You can optionally use that FindingsDestination object to list
  one or more destinations to send audit findings to. If you specify destinations such as log
  groups, Firehose streams, and S3 buckets, they must already exist.   The second block must
  include both a DataIdentifer array and an Operation property with an Deidentify action. The
  DataIdentifer array must exactly match the DataIdentifer array in the first block of the
  policy. The Operation property with the Deidentify action is what actually masks the data,
  and it must contain the  \"MaskConfig\": {} object. The  \"MaskConfig\": {} object must be
  empty.   For an example data protection policy, see the Examples section on this page.  The
  contents of the two DataIdentifer arrays must match exactly.  In addition to the two JSON
  blocks, the policyDocument can also include Name, Description, and Version fields. The Name
  is different than the operation's policyName parameter, and is used as a dimension when
  CloudWatch Logs reports audit findings metrics to CloudWatch. The JSON specified in
  policyDocument can be up to 30,720 characters long.  Subscription filter policy  A
  subscription filter policy can include the following attributes in a JSON block:
  DestinationArn The ARN of the destination to deliver log events to. Supported destinations
  are:   An Kinesis Data Streams data stream in the same account as the subscription policy,
  for same-account delivery.   An Firehose data stream in the same account as the
  subscription policy, for same-account delivery.   A Lambda function in the same account as
  the subscription policy, for same-account delivery.   A logical destination in a different
  account created with PutDestination, for cross-account delivery. Kinesis Data Streams and
  Firehose are supported as logical destinations.      RoleArn The ARN of an IAM role that
  grants CloudWatch Logs permissions to deliver ingested log events to the destination
  stream. You don't need to provide the ARN when you are working with a logical destination
  for cross-account delivery.    FilterPattern A filter pattern for subscribing to a filtered
  stream of log events.    DistributionThe method used to distribute log data to the
  destination. By default, log data is grouped by log stream, but the grouping can be set to
  Random for a more even distribution. This property is only applicable when the destination
  is an Kinesis Data Streams data stream.
- `policy_name`: A name for the policy. This must be unique within the account.
- `policy_type`: The type of policy that you're creating or updating.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"scope"`: Currently the only valid value for this parameter is ALL, which specifies that
  the data protection policy applies to all log groups in the account. If you omit this
  parameter, the default of ALL is used.
- `"selectionCriteria"`: Use this parameter to apply the subscription filter policy to a
  subset of log groups in the account. Currently, the only supported filter is LogGroupName
  NOT IN []. The selectionCriteria string can be up to 25KB in length. The length is
  determined by using its UTF-8 bytes. Using the selectionCriteria parameter is useful to
  help prevent infinite loops. For more information, see Log recursion prevention. Specifing
  selectionCriteria is valid only when you specify  SUBSCRIPTION_FILTER_POLICY for policyType.
"""
function put_account_policy(
    policyDocument,
    policyName,
    policyType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_logs(
        "PutAccountPolicy",
        Dict{String,Any}(
            "policyDocument" => policyDocument,
            "policyName" => policyName,
            "policyType" => policyType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_account_policy(
    policyDocument,
    policyName,
    policyType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_logs(
        "PutAccountPolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "policyDocument" => policyDocument,
                    "policyName" => policyName,
                    "policyType" => policyType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_data_protection_policy(log_group_identifier, policy_document)
    put_data_protection_policy(log_group_identifier, policy_document, params::Dict{String,<:Any})

Creates a data protection policy for the specified log group. A data protection policy can
help safeguard sensitive data that's ingested by the log group by auditing and masking the
sensitive log data.  Sensitive data is detected and masked when it is ingested into the log
group. When you set a data protection policy, log events ingested into the log group before
that time are not masked.  By default, when a user views a log event that includes masked
data, the sensitive data is replaced by asterisks. A user who has the logs:Unmask
permission can use a GetLogEvents or FilterLogEvents operation with the unmask parameter
set to true to view the unmasked log events. Users with the logs:Unmask can also view
unmasked data in the CloudWatch Logs console by running a CloudWatch Logs Insights query
with the unmask query command. For more information, including a list of types of data that
can be audited and masked, see Protect sensitive log data with masking. The
PutDataProtectionPolicy operation applies to only the specified log group. You can also use
PutAccountPolicy to create an account-level data protection policy that applies to all log
groups in the account, including both existing log groups and log groups that are created
level. If a log group has its own data protection policy and the account also has an
account-level data protection policy, then the two policies are cumulative. Any sensitive
term specified in either policy is masked.

# Arguments
- `log_group_identifier`: Specify either the log group name or log group ARN.
- `policy_document`: Specify the data protection policy, in JSON. This policy must include
  two JSON blocks:   The first block must include both a DataIdentifer array and an Operation
  property with an Audit action. The DataIdentifer array lists the types of sensitive data
  that you want to mask. For more information about the available options, see Types of data
  that you can mask. The Operation property with an Audit action is required to find the
  sensitive data terms. This Audit action must contain a FindingsDestination object. You can
  optionally use that FindingsDestination object to list one or more destinations to send
  audit findings to. If you specify destinations such as log groups, Firehose streams, and S3
  buckets, they must already exist.   The second block must include both a DataIdentifer
  array and an Operation property with an Deidentify action. The DataIdentifer array must
  exactly match the DataIdentifer array in the first block of the policy. The Operation
  property with the Deidentify action is what actually masks the data, and it must contain
  the  \"MaskConfig\": {} object. The  \"MaskConfig\": {} object must be empty.   For an
  example data protection policy, see the Examples section on this page.  The contents of the
  two DataIdentifer arrays must match exactly.  In addition to the two JSON blocks, the
  policyDocument can also include Name, Description, and Version fields. The Name is used as
  a dimension when CloudWatch Logs reports audit findings metrics to CloudWatch. The JSON
  specified in policyDocument can be up to 30,720 characters.

"""
function put_data_protection_policy(
    logGroupIdentifier, policyDocument; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "PutDataProtectionPolicy",
        Dict{String,Any}(
            "logGroupIdentifier" => logGroupIdentifier, "policyDocument" => policyDocument
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_data_protection_policy(
    logGroupIdentifier,
    policyDocument,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_logs(
        "PutDataProtectionPolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "logGroupIdentifier" => logGroupIdentifier,
                    "policyDocument" => policyDocument,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_delivery_destination(delivery_destination_configuration, name)
    put_delivery_destination(delivery_destination_configuration, name, params::Dict{String,<:Any})

Creates or updates a logical delivery destination. A delivery destination is an Amazon Web
Services resource that represents an Amazon Web Services service that logs can be sent to.
CloudWatch Logs, Amazon S3, and Firehose are supported as logs delivery destinations. To
configure logs delivery between a supported Amazon Web Services service and a destination,
you must do the following:   Create a delivery source, which is a logical object that
represents the resource that is actually sending the logs. For more information, see
PutDeliverySource.   Use PutDeliveryDestination to create a delivery destination, which is
a logical object that represents the actual delivery destination.    If you are delivering
logs cross-account, you must use PutDeliveryDestinationPolicy in the destination account to
assign an IAM policy to the destination. This policy allows delivery to that destination.
 Use CreateDelivery to create a delivery by pairing exactly one delivery source and one
delivery destination. For more information, see CreateDelivery.    You can configure a
single delivery source to send logs to multiple destinations by creating multiple
deliveries. You can also create multiple deliveries to configure multiple delivery sources
to send logs to the same delivery destination. Only some Amazon Web Services services
support being configured as a delivery source. These services are listed as Supported [V2
Permissions] in the table at Enabling logging from Amazon Web Services services.  If you
use this operation to update an existing delivery destination, all the current delivery
destination parameters are overwritten with the new parameter values that you specify.

# Arguments
- `delivery_destination_configuration`: A structure that contains the ARN of the Amazon Web
  Services resource that will receive the logs.
- `name`: A name for this delivery destination. This name must be unique for all delivery
  destinations in your account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"outputFormat"`: The format for the logs that this delivery destination will receive.
- `"tags"`: An optional list of key-value pairs to associate with the resource. For more
  information about tagging, see Tagging Amazon Web Services resources
"""
function put_delivery_destination(
    deliveryDestinationConfiguration,
    name;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_logs(
        "PutDeliveryDestination",
        Dict{String,Any}(
            "deliveryDestinationConfiguration" => deliveryDestinationConfiguration,
            "name" => name,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_delivery_destination(
    deliveryDestinationConfiguration,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_logs(
        "PutDeliveryDestination",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "deliveryDestinationConfiguration" => deliveryDestinationConfiguration,
                    "name" => name,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_delivery_destination_policy(delivery_destination_name, delivery_destination_policy)
    put_delivery_destination_policy(delivery_destination_name, delivery_destination_policy, params::Dict{String,<:Any})

Creates and assigns an IAM policy that grants permissions to CloudWatch Logs to deliver
logs cross-account to a specified destination in this account. To configure the delivery of
logs from an Amazon Web Services service in another account to a logs delivery destination
in the current account, you must do the following:   Create a delivery source, which is a
logical object that represents the resource that is actually sending the logs. For more
information, see PutDeliverySource.   Create a delivery destination, which is a logical
object that represents the actual delivery destination. For more information, see
PutDeliveryDestination.   Use this operation in the destination account to assign an IAM
policy to the destination. This policy allows delivery to that destination.    Create a
delivery by pairing exactly one delivery source and one delivery destination. For more
information, see CreateDelivery.   Only some Amazon Web Services services support being
configured as a delivery source. These services are listed as Supported [V2 Permissions] in
the table at Enabling logging from Amazon Web Services services.  The contents of the
policy must include two statements. One statement enables general logs delivery, and the
other allows delivery to the chosen destination. See the examples for the needed policies.

# Arguments
- `delivery_destination_name`: The name of the delivery destination to assign this policy
  to.
- `delivery_destination_policy`: The contents of the policy.

"""
function put_delivery_destination_policy(
    deliveryDestinationName,
    deliveryDestinationPolicy;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_logs(
        "PutDeliveryDestinationPolicy",
        Dict{String,Any}(
            "deliveryDestinationName" => deliveryDestinationName,
            "deliveryDestinationPolicy" => deliveryDestinationPolicy,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_delivery_destination_policy(
    deliveryDestinationName,
    deliveryDestinationPolicy,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_logs(
        "PutDeliveryDestinationPolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "deliveryDestinationName" => deliveryDestinationName,
                    "deliveryDestinationPolicy" => deliveryDestinationPolicy,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_delivery_source(log_type, name, resource_arn)
    put_delivery_source(log_type, name, resource_arn, params::Dict{String,<:Any})

Creates or updates a logical delivery source. A delivery source represents an Amazon Web
Services resource that sends logs to an logs delivery destination. The destination can be
CloudWatch Logs, Amazon S3, or Firehose. To configure logs delivery between a delivery
destination and an Amazon Web Services service that is supported as a delivery source, you
must do the following:   Use PutDeliverySource to create a delivery source, which is a
logical object that represents the resource that is actually sending the logs.    Use
PutDeliveryDestination to create a delivery destination, which is a logical object that
represents the actual delivery destination. For more information, see
PutDeliveryDestination.   If you are delivering logs cross-account, you must use
PutDeliveryDestinationPolicy in the destination account to assign an IAM policy to the
destination. This policy allows delivery to that destination.    Use CreateDelivery to
create a delivery by pairing exactly one delivery source and one delivery destination. For
more information, see CreateDelivery.    You can configure a single delivery source to send
logs to multiple destinations by creating multiple deliveries. You can also create multiple
deliveries to configure multiple delivery sources to send logs to the same delivery
destination. Only some Amazon Web Services services support being configured as a delivery
source. These services are listed as Supported [V2 Permissions] in the table at Enabling
logging from Amazon Web Services services.  If you use this operation to update an existing
delivery source, all the current delivery source parameters are overwritten with the new
parameter values that you specify.

# Arguments
- `log_type`: Defines the type of log that the source is sending.   For Amazon
  CodeWhisperer, the valid value is EVENT_LOGS.   For IAM Identity Centerr, the valid value
  is ERROR_LOGS.   For Amazon WorkMail, the valid values are ACCESS_CONTROL_LOGS,
  AUTHENTICATION_LOGS, WORKMAIL_AVAILABILITY_PROVIDER_LOGS, and WORKMAIL_MAILBOX_ACCESS_LOGS.
  
- `name`: A name for this delivery source. This name must be unique for all delivery
  sources in your account.
- `resource_arn`: The ARN of the Amazon Web Services resource that is generating and
  sending logs. For example,
  arn:aws:workmail:us-east-1:123456789012:organization/m-1234EXAMPLEabcd1234abcd1234abcd1234

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tags"`: An optional list of key-value pairs to associate with the resource. For more
  information about tagging, see Tagging Amazon Web Services resources
"""
function put_delivery_source(
    logType, name, resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "PutDeliverySource",
        Dict{String,Any}(
            "logType" => logType, "name" => name, "resourceArn" => resourceArn
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_delivery_source(
    logType,
    name,
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_logs(
        "PutDeliverySource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "logType" => logType, "name" => name, "resourceArn" => resourceArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_destination(destination_name, role_arn, target_arn)
    put_destination(destination_name, role_arn, target_arn, params::Dict{String,<:Any})

Creates or updates a destination. This operation is used only to create destinations for
cross-account subscriptions. A destination encapsulates a physical resource (such as an
Amazon Kinesis stream). With a destination, you can subscribe to a real-time stream of log
events for a different account, ingested using PutLogEvents. Through an access policy, a
destination controls what is written to it. By default, PutDestination does not set any
access policy with the destination, which means a cross-account user cannot call
PutSubscriptionFilter against this destination. To enable this, the destination owner must
call PutDestinationPolicy after PutDestination. To perform a PutDestination operation, you
must also have the iam:PassRole permission.

# Arguments
- `destination_name`: A name for the destination.
- `role_arn`: The ARN of an IAM role that grants CloudWatch Logs permissions to call the
  Amazon Kinesis PutRecord operation on the destination stream.
- `target_arn`: The ARN of an Amazon Kinesis stream to which to deliver matching log events.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tags"`: An optional list of key-value pairs to associate with the resource. For more
  information about tagging, see Tagging Amazon Web Services resources
"""
function put_destination(
    destinationName, roleArn, targetArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "PutDestination",
        Dict{String,Any}(
            "destinationName" => destinationName,
            "roleArn" => roleArn,
            "targetArn" => targetArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_destination(
    destinationName,
    roleArn,
    targetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_logs(
        "PutDestination",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "destinationName" => destinationName,
                    "roleArn" => roleArn,
                    "targetArn" => targetArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_destination_policy(access_policy, destination_name)
    put_destination_policy(access_policy, destination_name, params::Dict{String,<:Any})

Creates or updates an access policy associated with an existing destination. An access
policy is an IAM policy document that is used to authorize claims to register a
subscription filter against a given destination.

# Arguments
- `access_policy`: An IAM policy document that authorizes cross-account users to deliver
  their log events to the associated destination. This can be up to 5120 bytes.
- `destination_name`: A name for an existing destination.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"forceUpdate"`: Specify true if you are updating an existing destination policy to grant
  permission to an organization ID instead of granting permission to individual Amazon Web
  Services accounts. Before you update a destination policy this way, you must first update
  the subscription filters in the accounts that send logs to this destination. If you do not,
  the subscription filters might stop working. By specifying true for forceUpdate, you are
  affirming that you have already updated the subscription filters. For more information, see
   Updating an existing cross-account subscription  If you omit this parameter, the default
  of false is used.
"""
function put_destination_policy(
    accessPolicy, destinationName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "PutDestinationPolicy",
        Dict{String,Any}(
            "accessPolicy" => accessPolicy, "destinationName" => destinationName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_destination_policy(
    accessPolicy,
    destinationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_logs(
        "PutDestinationPolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "accessPolicy" => accessPolicy, "destinationName" => destinationName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_log_events(log_events, log_group_name, log_stream_name)
    put_log_events(log_events, log_group_name, log_stream_name, params::Dict{String,<:Any})

Uploads a batch of log events to the specified log stream.  The sequence token is now
ignored in PutLogEvents actions. PutLogEvents actions are always accepted and never return
InvalidSequenceTokenException or DataAlreadyAcceptedException even if the sequence token is
not valid. You can use parallel PutLogEvents actions on the same log stream.   The batch of
events must satisfy the following constraints:   The maximum batch size is 1,048,576 bytes.
This size is calculated as the sum of all event messages in UTF-8, plus 26 bytes for each
log event.   None of the log events in the batch can be more than 2 hours in the future.
None of the log events in the batch can be more than 14 days in the past. Also, none of the
log events can be from earlier than the retention period of the log group.   The log events
in the batch must be in chronological order by their timestamp. The timestamp is the time
that the event occurred, expressed as the number of milliseconds after Jan 1, 1970 00:00:00
UTC. (In Amazon Web Services Tools for PowerShell and the Amazon Web Services SDK for .NET,
the timestamp is specified in .NET format: yyyy-mm-ddThh:mm:ss. For example,
2017-09-15T13:45:30.)    A batch of log events in a single request cannot span more than 24
hours. Otherwise, the operation fails.   Each log event can be no larger than 256 KB.   The
maximum number of log events in a batch is 10,000.    The quota of five requests per second
per log stream has been removed. Instead, PutLogEvents actions are throttled based on a
per-second per-account quota. You can request an increase to the per-second throttling
quota by using the Service Quotas service.    If a call to PutLogEvents returns
\"UnrecognizedClientException\" the most likely cause is a non-valid Amazon Web Services
access key ID or secret key.

# Arguments
- `log_events`: The log events.
- `log_group_name`: The name of the log group.
- `log_stream_name`: The name of the log stream.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"sequenceToken"`: The sequence token obtained from the response of the previous
  PutLogEvents call.  The sequenceToken parameter is now ignored in PutLogEvents actions.
  PutLogEvents actions are now accepted and never return InvalidSequenceTokenException or
  DataAlreadyAcceptedException even if the sequence token is not valid.
"""
function put_log_events(
    logEvents,
    logGroupName,
    logStreamName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_logs(
        "PutLogEvents",
        Dict{String,Any}(
            "logEvents" => logEvents,
            "logGroupName" => logGroupName,
            "logStreamName" => logStreamName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_log_events(
    logEvents,
    logGroupName,
    logStreamName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_logs(
        "PutLogEvents",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "logEvents" => logEvents,
                    "logGroupName" => logGroupName,
                    "logStreamName" => logStreamName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_metric_filter(filter_name, filter_pattern, log_group_name, metric_transformations)
    put_metric_filter(filter_name, filter_pattern, log_group_name, metric_transformations, params::Dict{String,<:Any})

Creates or updates a metric filter and associates it with the specified log group. With
metric filters, you can configure rules to extract metric data from log events ingested
through PutLogEvents. The maximum number of metric filters that can be associated with a
log group is 100. When you create a metric filter, you can also optionally assign a unit
and dimensions to the metric that is created.  Metrics extracted from log events are
charged as custom metrics. To prevent unexpected high charges, do not specify
high-cardinality fields such as IPAddress or requestID as dimensions. Each different value
found for a dimension is treated as a separate metric and accrues charges as a separate
custom metric.  CloudWatch Logs might disable a metric filter if it generates 1,000
different name/value pairs for your specified dimensions within one hour. You can also set
up a billing alarm to alert you if your charges are higher than expected. For more
information, see  Creating a Billing Alarm to Monitor Your Estimated Amazon Web Services
Charges.

# Arguments
- `filter_name`: A name for the metric filter.
- `filter_pattern`: A filter pattern for extracting metric data out of ingested log events.
- `log_group_name`: The name of the log group.
- `metric_transformations`: A collection of information that defines how metric data gets
  emitted.

"""
function put_metric_filter(
    filterName,
    filterPattern,
    logGroupName,
    metricTransformations;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_logs(
        "PutMetricFilter",
        Dict{String,Any}(
            "filterName" => filterName,
            "filterPattern" => filterPattern,
            "logGroupName" => logGroupName,
            "metricTransformations" => metricTransformations,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_metric_filter(
    filterName,
    filterPattern,
    logGroupName,
    metricTransformations,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_logs(
        "PutMetricFilter",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "filterName" => filterName,
                    "filterPattern" => filterPattern,
                    "logGroupName" => logGroupName,
                    "metricTransformations" => metricTransformations,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_query_definition(name, query_string)
    put_query_definition(name, query_string, params::Dict{String,<:Any})

Creates or updates a query definition for CloudWatch Logs Insights. For more information,
see Analyzing Log Data with CloudWatch Logs Insights. To update a query definition, specify
its queryDefinitionId in your request. The values of name, queryString, and logGroupNames
are changed to the values that you specify in your update operation. No current values are
retained from the current query definition. For example, imagine updating a current query
definition that includes log groups. If you don't specify the logGroupNames parameter in
your update operation, the query definition changes to contain no log groups. You must have
the logs:PutQueryDefinition permission to be able to perform this operation.

# Arguments
- `name`: A name for the query definition. If you are saving numerous query definitions, we
  recommend that you name them. This way, you can find the ones you want by using the first
  part of the name as a filter in the queryDefinitionNamePrefix parameter of
  DescribeQueryDefinitions.
- `query_string`: The query string to use for this definition. For more information, see
  CloudWatch Logs Insights Query Syntax.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Used as an idempotency token, to avoid returning an exception if the
  service receives the same request twice because of a network error.
- `"logGroupNames"`: Use this parameter to include specific log groups as part of your
  query definition. If you are updating a query definition and you omit this parameter, then
  the updated definition will contain no log groups.
- `"queryDefinitionId"`: If you are updating a query definition, use this parameter to
  specify the ID of the query definition that you want to update. You can use
  DescribeQueryDefinitions to retrieve the IDs of your saved query definitions. If you are
  creating a query definition, do not specify this parameter. CloudWatch generates a unique
  ID for the new query definition and include it in the response to this operation.
"""
function put_query_definition(
    name, queryString; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "PutQueryDefinition",
        Dict{String,Any}(
            "name" => name, "queryString" => queryString, "clientToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_query_definition(
    name,
    queryString,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_logs(
        "PutQueryDefinition",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "name" => name,
                    "queryString" => queryString,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_resource_policy()
    put_resource_policy(params::Dict{String,<:Any})

Creates or updates a resource policy allowing other Amazon Web Services services to put log
events to this account, such as Amazon Route 53. An account can have up to 10 resource
policies per Amazon Web Services Region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"policyDocument"`: Details of the new policy, including the identity of the principal
  that is enabled to put logs to this account. This is formatted as a JSON string. This
  parameter is required. The following example creates a resource policy enabling the Route
  53 service to put DNS query logs in to the specified log group. Replace \"logArn\" with the
  ARN of your CloudWatch Logs resource, such as a log group or log stream. CloudWatch Logs
  also supports aws:SourceArn and aws:SourceAccount condition context keys. In the example
  resource policy, you would replace the value of SourceArn with the resource making the call
  from Route 53 to CloudWatch Logs. You would also replace the value of SourceAccount with
  the Amazon Web Services account ID making that call.   { \"Version\": \"2012-10-17\",
  \"Statement\": [ { \"Sid\": \"Route53LogsToCloudWatchLogs\", \"Effect\": \"Allow\",
  \"Principal\": { \"Service\": [ \"route53.amazonaws.com\" ] }, \"Action\":
  \"logs:PutLogEvents\", \"Resource\": \"logArn\", \"Condition\": { \"ArnLike\": {
  \"aws:SourceArn\": \"myRoute53ResourceArn\" }, \"StringEquals\": { \"aws:SourceAccount\":
  \"myAwsAccountId\" } } } ] }
- `"policyName"`: Name of the new policy. This parameter is required.
"""
function put_resource_policy(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_logs(
        "PutResourcePolicy"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function put_resource_policy(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "PutResourcePolicy", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    put_retention_policy(log_group_name, retention_in_days)
    put_retention_policy(log_group_name, retention_in_days, params::Dict{String,<:Any})

Sets the retention of the specified log group. With a retention policy, you can configure
the number of days for which to retain log events in the specified log group.  CloudWatch
Logs doesn’t immediately delete log events when they reach their retention setting. It
typically takes up to 72 hours after that before log events are deleted, but in rare
situations might take longer. To illustrate, imagine that you change a log group to have a
longer retention setting when it contains log events that are past the expiration date, but
haven’t been deleted. Those log events will take up to 72 hours to be deleted after the
new retention date is reached. To make sure that log data is deleted permanently, keep a
log group at its lower retention setting until 72 hours after the previous retention period
ends. Alternatively, wait to change the retention setting until you confirm that the
earlier log events are deleted.  When log events reach their retention setting they are
marked for deletion. After they are marked for deletion, they do not add to your archival
storage costs anymore, even if they are not actually deleted until later. These log events
marked for deletion are also not included when you use an API to retrieve the storedBytes
value to see how many bytes a log group is storing.

# Arguments
- `log_group_name`: The name of the log group.
- `retention_in_days`:

"""
function put_retention_policy(
    logGroupName, retentionInDays; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "PutRetentionPolicy",
        Dict{String,Any}(
            "logGroupName" => logGroupName, "retentionInDays" => retentionInDays
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_retention_policy(
    logGroupName,
    retentionInDays,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_logs(
        "PutRetentionPolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "logGroupName" => logGroupName, "retentionInDays" => retentionInDays
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_subscription_filter(destination_arn, filter_name, filter_pattern, log_group_name)
    put_subscription_filter(destination_arn, filter_name, filter_pattern, log_group_name, params::Dict{String,<:Any})

Creates or updates a subscription filter and associates it with the specified log group.
With subscription filters, you can subscribe to a real-time stream of log events ingested
through PutLogEvents and have them delivered to a specific destination. When log events are
sent to the receiving service, they are Base64 encoded and compressed with the GZIP format.
The following destinations are supported for subscription filters:   An Amazon Kinesis data
stream belonging to the same account as the subscription filter, for same-account delivery.
  A logical destination created with PutDestination that belongs to a different account,
for cross-account delivery. We currently support Kinesis Data Streams and Firehose as
logical destinations.   An Amazon Kinesis Data Firehose delivery stream that belongs to the
same account as the subscription filter, for same-account delivery.   An Lambda function
that belongs to the same account as the subscription filter, for same-account delivery.
Each log group can have up to two subscription filters associated with it. If you are
updating an existing filter, you must specify the correct name in filterName.  To perform a
PutSubscriptionFilter operation for any destination except a Lambda function, you must also
have the iam:PassRole permission.

# Arguments
- `destination_arn`: The ARN of the destination to deliver matching log events to.
  Currently, the supported destinations are:   An Amazon Kinesis stream belonging to the same
  account as the subscription filter, for same-account delivery.   A logical destination
  (specified using an ARN) belonging to a different account, for cross-account delivery. If
  you're setting up a cross-account subscription, the destination must have an IAM policy
  associated with it. The IAM policy must allow the sender to send logs to the destination.
  For more information, see PutDestinationPolicy.   A Kinesis Data Firehose delivery stream
  belonging to the same account as the subscription filter, for same-account delivery.   A
  Lambda function belonging to the same account as the subscription filter, for same-account
  delivery.
- `filter_name`: A name for the subscription filter. If you are updating an existing
  filter, you must specify the correct name in filterName. To find the name of the filter
  currently associated with a log group, use DescribeSubscriptionFilters.
- `filter_pattern`: A filter pattern for subscribing to a filtered stream of log events.
- `log_group_name`: The name of the log group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"distribution"`: The method used to distribute log data to the destination. By default,
  log data is grouped by log stream, but the grouping can be set to random for a more even
  distribution. This property is only applicable when the destination is an Amazon Kinesis
  data stream.
- `"roleArn"`: The ARN of an IAM role that grants CloudWatch Logs permissions to deliver
  ingested log events to the destination stream. You don't need to provide the ARN when you
  are working with a logical destination for cross-account delivery.
"""
function put_subscription_filter(
    destinationArn,
    filterName,
    filterPattern,
    logGroupName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_logs(
        "PutSubscriptionFilter",
        Dict{String,Any}(
            "destinationArn" => destinationArn,
            "filterName" => filterName,
            "filterPattern" => filterPattern,
            "logGroupName" => logGroupName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_subscription_filter(
    destinationArn,
    filterName,
    filterPattern,
    logGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_logs(
        "PutSubscriptionFilter",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "destinationArn" => destinationArn,
                    "filterName" => filterName,
                    "filterPattern" => filterPattern,
                    "logGroupName" => logGroupName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_live_tail(log_group_identifiers)
    start_live_tail(log_group_identifiers, params::Dict{String,<:Any})

Starts a Live Tail streaming session for one or more log groups. A Live Tail session
returns a stream of log events that have been recently ingested in the log groups. For more
information, see Use Live Tail to view logs in near real time.  The response to this
operation is a response stream, over which the server sends live log events and the client
receives them. The following objects are sent over the stream:   A single
LiveTailSessionStart object is sent at the start of the session.   Every second, a
LiveTailSessionUpdate object is sent. Each of these objects contains an array of the actual
log events. If no new log events were ingested in the past second, the
LiveTailSessionUpdate object will contain an empty array. The array of log events contained
in a LiveTailSessionUpdate can include as many as 500 log events. If the number of log
events matching the request exceeds 500 per second, the log events are sampled down to 500
log events to be included in each LiveTailSessionUpdate object. If your client consumes the
log events slower than the server produces them, CloudWatch Logs buffers up to 10
LiveTailSessionUpdate events or 5000 log events, after which it starts dropping the oldest
events.   A SessionStreamingException object is returned if an unknown error occurs on the
server side.   A SessionTimeoutException object is returned when the session times out,
after it has been kept open for three hours.    You can end a session before it times out
by closing the session stream or by closing the client that is receiving the stream. The
session also ends if the established connection between the client and the server breaks.
For examples of using an SDK to start a Live Tail session, see  Start a Live Tail session
using an Amazon Web Services SDK.

# Arguments
- `log_group_identifiers`: An array where each item in the array is a log group to include
  in the Live Tail session. Specify each log group by its ARN.  If you specify an ARN, the
  ARN can't end with an asterisk (*).   You can include up to 10 log groups.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"logEventFilterPattern"`: An optional pattern to use to filter the results to include
  only log events that match the pattern. For example, a filter pattern of error 404 causes
  only log events that include both error and 404 to be included in the Live Tail stream.
  Regular expression filter patterns are supported. For more information about filter pattern
  syntax, see Filter and Pattern Syntax.
- `"logStreamNamePrefixes"`: If you specify this parameter, then only log events in the log
  streams that have names that start with the prefixes that you specify here are included in
  the Live Tail session. If you specify this field, you can't also specify the logStreamNames
  field.  You can specify this parameter only if you specify only one log group in
  logGroupIdentifiers.
- `"logStreamNames"`: If you specify this parameter, then only log events in the log
  streams that you specify here are included in the Live Tail session. If you specify this
  field, you can't also specify the logStreamNamePrefixes field.  You can specify this
  parameter only if you specify only one log group in logGroupIdentifiers.
"""
function start_live_tail(
    logGroupIdentifiers; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "StartLiveTail",
        Dict{String,Any}("logGroupIdentifiers" => logGroupIdentifiers);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_live_tail(
    logGroupIdentifiers,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_logs(
        "StartLiveTail",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("logGroupIdentifiers" => logGroupIdentifiers),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_query(end_time, query_string, start_time)
    start_query(end_time, query_string, start_time, params::Dict{String,<:Any})

Schedules a query of a log group using CloudWatch Logs Insights. You specify the log group
and time range to query and the query string to use. For more information, see CloudWatch
Logs Insights Query Syntax. After you run a query using StartQuery, the query results are
stored by CloudWatch Logs. You can use GetQueryResults to retrieve the results of a query,
using the queryId that StartQuery returns.  If you have associated a KMS key with the query
results in this account, then StartQuery uses that key to encrypt the results when it
stores them. If no key is associated with query results, the query results are encrypted
with the default CloudWatch Logs encryption method. Queries time out after 60 minutes of
runtime. If your queries are timing out, reduce the time range being searched or partition
your query into a number of queries. If you are using CloudWatch cross-account
observability, you can use this operation in a monitoring account to start a query in a
linked source account. For more information, see CloudWatch cross-account observability.
For a cross-account StartQuery operation, the query definition must be defined in the
monitoring account. You can have up to 30 concurrent CloudWatch Logs insights queries,
including queries that have been added to dashboards.

# Arguments
- `end_time`: The end of the time range to query. The range is inclusive, so the specified
  end time is included in the query. Specified as epoch time, the number of seconds since
  January 1, 1970, 00:00:00 UTC.
- `query_string`: The query string to use. For more information, see CloudWatch Logs
  Insights Query Syntax.
- `start_time`: The beginning of the time range to query. The range is inclusive, so the
  specified start time is included in the query. Specified as epoch time, the number of
  seconds since January 1, 1970, 00:00:00 UTC.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"limit"`: The maximum number of log events to return in the query. If the query string
  uses the fields command, only the specified fields and their values are returned. The
  default is 1000.
- `"logGroupIdentifiers"`: The list of log groups to query. You can include up to 50 log
  groups. You can specify them by the log group name or ARN. If a log group that you're
  querying is in a source account and you're using a monitoring account, you must specify the
  ARN of the log group here. The query definition must also be defined in the monitoring
  account. If you specify an ARN, the ARN can't end with an asterisk (*). A StartQuery
  operation must include exactly one of the following parameters: logGroupName,
  logGroupNames, or logGroupIdentifiers.
- `"logGroupName"`: The log group on which to perform the query.  A StartQuery operation
  must include exactly one of the following parameters: logGroupName, logGroupNames, or
  logGroupIdentifiers.
- `"logGroupNames"`: The list of log groups to be queried. You can include up to 50 log
  groups.  A StartQuery operation must include exactly one of the following parameters:
  logGroupName, logGroupNames, or logGroupIdentifiers.
"""
function start_query(
    endTime, queryString, startTime; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "StartQuery",
        Dict{String,Any}(
            "endTime" => endTime, "queryString" => queryString, "startTime" => startTime
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_query(
    endTime,
    queryString,
    startTime,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_logs(
        "StartQuery",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "endTime" => endTime,
                    "queryString" => queryString,
                    "startTime" => startTime,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_query(query_id)
    stop_query(query_id, params::Dict{String,<:Any})

Stops a CloudWatch Logs Insights query that is in progress. If the query has already ended,
the operation returns an error indicating that the specified query is not running.

# Arguments
- `query_id`: The ID number of the query to stop. To find this ID number, use
  DescribeQueries.

"""
function stop_query(queryId; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_logs(
        "StopQuery",
        Dict{String,Any}("queryId" => queryId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_query(
    queryId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_logs(
        "StopQuery",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("queryId" => queryId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_log_group(log_group_name, tags)
    tag_log_group(log_group_name, tags, params::Dict{String,<:Any})

 The TagLogGroup operation is on the path to deprecation. We recommend that you use
TagResource instead.  Adds or updates the specified tags for the specified log group. To
list the tags for a log group, use ListTagsForResource. To remove tags, use UntagResource.
For more information about tags, see Tag Log Groups in Amazon CloudWatch Logs in the Amazon
CloudWatch Logs User Guide. CloudWatch Logs doesn’t support IAM policies that prevent
users from assigning specified tags to log groups using the aws:Resource/key-name  or
aws:TagKeys condition keys. For more information about using tags to control access, see
Controlling access to Amazon Web Services resources using tags.

# Arguments
- `log_group_name`: The name of the log group.
- `tags`: The key-value pairs to use for the tags.

"""
function tag_log_group(
    logGroupName, tags; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "TagLogGroup",
        Dict{String,Any}("logGroupName" => logGroupName, "tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_log_group(
    logGroupName,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_logs(
        "TagLogGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("logGroupName" => logGroupName, "tags" => tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Assigns one or more tags (key-value pairs) to the specified CloudWatch Logs resource.
Currently, the only CloudWatch Logs resources that can be tagged are log groups and
destinations.  Tags can help you organize and categorize your resources. You can also use
them to scope user permissions by granting a user permission to access or change only
resources with certain tag values. Tags don't have any semantic meaning to Amazon Web
Services and are interpreted strictly as strings of characters. You can use the TagResource
action with a resource that already has tags. If you specify a new tag key for the alarm,
this tag is appended to the list of tags associated with the alarm. If you specify a tag
key that is already associated with the alarm, the new tag value that you specify replaces
the previous value for that tag. You can associate as many as 50 tags with a CloudWatch
Logs resource.

# Arguments
- `resource_arn`: The ARN of the resource that you're adding tags to. The ARN format of a
  log group is arn:aws:logs:Region:account-id:log-group:log-group-name   The ARN format of a
  destination is arn:aws:logs:Region:account-id:destination:destination-name   For more
  information about ARN format, see CloudWatch Logs resources and operations.
- `tags`: The list of key-value pairs to associate with the resource.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudwatch_logs(
        "TagResource",
        Dict{String,Any}("resourceArn" => resourceArn, "tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_logs(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceArn" => resourceArn, "tags" => tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    test_metric_filter(filter_pattern, log_event_messages)
    test_metric_filter(filter_pattern, log_event_messages, params::Dict{String,<:Any})

Tests the filter pattern of a metric filter against a sample of log event messages. You can
use this operation to validate the correctness of a metric filter pattern.

# Arguments
- `filter_pattern`:
- `log_event_messages`: The log event messages to test.

"""
function test_metric_filter(
    filterPattern, logEventMessages; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "TestMetricFilter",
        Dict{String,Any}(
            "filterPattern" => filterPattern, "logEventMessages" => logEventMessages
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function test_metric_filter(
    filterPattern,
    logEventMessages,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_logs(
        "TestMetricFilter",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "filterPattern" => filterPattern, "logEventMessages" => logEventMessages
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_log_group(log_group_name, tags)
    untag_log_group(log_group_name, tags, params::Dict{String,<:Any})

 The UntagLogGroup operation is on the path to deprecation. We recommend that you use
UntagResource instead.  Removes the specified tags from the specified log group. To list
the tags for a log group, use ListTagsForResource. To add tags, use TagResource. CloudWatch
Logs doesn’t support IAM policies that prevent users from assigning specified tags to log
groups using the aws:Resource/key-name  or aws:TagKeys condition keys.

# Arguments
- `log_group_name`: The name of the log group.
- `tags`: The tag keys. The corresponding tags are removed from the log group.

"""
function untag_log_group(
    logGroupName, tags; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "UntagLogGroup",
        Dict{String,Any}("logGroupName" => logGroupName, "tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_log_group(
    logGroupName,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_logs(
        "UntagLogGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("logGroupName" => logGroupName, "tags" => tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes one or more tags from the specified resource.

# Arguments
- `resource_arn`: The ARN of the CloudWatch Logs resource that you're removing tags from.
  The ARN format of a log group is arn:aws:logs:Region:account-id:log-group:log-group-name
  The ARN format of a destination is
  arn:aws:logs:Region:account-id:destination:destination-name   For more information about
  ARN format, see CloudWatch Logs resources and operations.
- `tag_keys`: The list of tag keys to remove from the resource.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "UntagResource",
        Dict{String,Any}("resourceArn" => resourceArn, "tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_logs(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceArn" => resourceArn, "tagKeys" => tagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_anomaly(anomaly_detector_arn)
    update_anomaly(anomaly_detector_arn, params::Dict{String,<:Any})

Use this operation to suppress anomaly detection for a specified anomaly or pattern. If you
suppress an anomaly, CloudWatch Logs won’t report new occurrences of that anomaly and
won't update that anomaly with new data. If you suppress a pattern, CloudWatch Logs won’t
report any anomalies related to that pattern. You must specify either anomalyId or
patternId, but you can't specify both parameters in the same operation. If you have
previously used this operation to suppress detection of a pattern or anomaly, you can use
it again to cause CloudWatch Logs to end the suppression. To do this, use this operation
and specify the anomaly or pattern to stop suppressing, and omit the suppressionType and
suppressionPeriod parameters.

# Arguments
- `anomaly_detector_arn`: The ARN of the anomaly detector that this operation is to act on.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"anomalyId"`: If you are suppressing or unsuppressing an anomaly, specify its unique ID
  here. You can find anomaly IDs by using the ListAnomalies operation.
- `"patternId"`: If you are suppressing or unsuppressing an pattern, specify its unique ID
  here. You can find pattern IDs by using the ListAnomalies operation.
- `"suppressionPeriod"`: If you are temporarily suppressing an anomaly or pattern, use this
  structure to specify how long the suppression is to last.
- `"suppressionType"`: Use this to specify whether the suppression to be temporary or
  infinite. If you specify LIMITED, you must also specify a suppressionPeriod. If you specify
  INFINITE, any value for suppressionPeriod is ignored.
"""
function update_anomaly(
    anomalyDetectorArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "UpdateAnomaly",
        Dict{String,Any}("anomalyDetectorArn" => anomalyDetectorArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_anomaly(
    anomalyDetectorArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_logs(
        "UpdateAnomaly",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("anomalyDetectorArn" => anomalyDetectorArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_log_anomaly_detector(anomaly_detector_arn, enabled)
    update_log_anomaly_detector(anomaly_detector_arn, enabled, params::Dict{String,<:Any})

Updates an existing log anomaly detector.

# Arguments
- `anomaly_detector_arn`: The ARN of the anomaly detector that you want to update.
- `enabled`: Use this parameter to pause or restart the anomaly detector.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"anomalyVisibilityTime"`: The number of days to use as the life cycle of anomalies.
  After this time, anomalies are automatically baselined and the anomaly detector model will
  treat new occurrences of similar event as normal. Therefore, if you do not correct the
  cause of an anomaly during this time, it will be considered normal going forward and will
  not be detected.
- `"evaluationFrequency"`: Specifies how often the anomaly detector runs and look for
  anomalies. Set this value according to the frequency that the log group receives new logs.
  For example, if the log group receives new log events every 10 minutes, then setting
  evaluationFrequency to FIFTEEN_MIN might be appropriate.
- `"filterPattern"`:
"""
function update_log_anomaly_detector(
    anomalyDetectorArn, enabled; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudwatch_logs(
        "UpdateLogAnomalyDetector",
        Dict{String,Any}("anomalyDetectorArn" => anomalyDetectorArn, "enabled" => enabled);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_log_anomaly_detector(
    anomalyDetectorArn,
    enabled,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudwatch_logs(
        "UpdateLogAnomalyDetector",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "anomalyDetectorArn" => anomalyDetectorArn, "enabled" => enabled
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: workdocs
using AWS.Compat
using AWS.UUIDs

"""
    abort_document_version_upload(document_id, version_id)
    abort_document_version_upload(document_id, version_id, params::Dict{String,<:Any})

Aborts the upload of the specified document version that was previously initiated by
InitiateDocumentVersionUpload. The client should make this call only when it no longer
intends to upload the document version, or fails to do so.

# Arguments
- `document_id`: The ID of the document.
- `version_id`: The ID of the version.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Authentication"`: Amazon WorkDocs authentication token. Not required when using Amazon
  Web Services administrator credentials to access the API.
"""
function abort_document_version_upload(
    DocumentId, VersionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workdocs(
        "DELETE",
        "/api/v1/documents/$(DocumentId)/versions/$(VersionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function abort_document_version_upload(
    DocumentId,
    VersionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workdocs(
        "DELETE",
        "/api/v1/documents/$(DocumentId)/versions/$(VersionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    activate_user(user_id)
    activate_user(user_id, params::Dict{String,<:Any})

Activates the specified user. Only active users can access Amazon WorkDocs.

# Arguments
- `user_id`: The ID of the user.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Authentication"`: Amazon WorkDocs authentication token. Not required when using Amazon
  Web Services administrator credentials to access the API.
"""
function activate_user(UserId; aws_config::AbstractAWSConfig=current_aws_config())
    return workdocs(
        "POST",
        "/api/v1/users/$(UserId)/activation";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function activate_user(
    UserId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workdocs(
        "POST",
        "/api/v1/users/$(UserId)/activation",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    add_resource_permissions(principals, resource_id)
    add_resource_permissions(principals, resource_id, params::Dict{String,<:Any})

Creates a set of permissions for the specified folder or document. The resource permissions
are overwritten if the principals already have different permissions.

# Arguments
- `principals`: The users, groups, or organization being granted permission.
- `resource_id`: The ID of the resource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Authentication"`: Amazon WorkDocs authentication token. Not required when using Amazon
  Web Services administrator credentials to access the API.
- `"NotificationOptions"`: The notification options.
"""
function add_resource_permissions(
    Principals, ResourceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workdocs(
        "POST",
        "/api/v1/resources/$(ResourceId)/permissions",
        Dict{String,Any}("Principals" => Principals);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_resource_permissions(
    Principals,
    ResourceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workdocs(
        "POST",
        "/api/v1/resources/$(ResourceId)/permissions",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Principals" => Principals), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_comment(document_id, text, version_id)
    create_comment(document_id, text, version_id, params::Dict{String,<:Any})

Adds a new comment to the specified document version.

# Arguments
- `document_id`: The ID of the document.
- `text`: The text of the comment.
- `version_id`: The ID of the document version.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Authentication"`: Amazon WorkDocs authentication token. Not required when using Amazon
  Web Services administrator credentials to access the API.
- `"NotifyCollaborators"`: Set this parameter to TRUE to send an email out to the document
  collaborators after the comment is created.
- `"ParentId"`: The ID of the parent comment.
- `"ThreadId"`: The ID of the root comment in the thread.
- `"Visibility"`: The visibility of the comment. Options are either PRIVATE, where the
  comment is visible only to the comment author and document owner and co-owners, or PUBLIC,
  where the comment is visible to document owners, co-owners, and contributors.
"""
function create_comment(
    DocumentId, Text, VersionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workdocs(
        "POST",
        "/api/v1/documents/$(DocumentId)/versions/$(VersionId)/comment",
        Dict{String,Any}("Text" => Text);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_comment(
    DocumentId,
    Text,
    VersionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workdocs(
        "POST",
        "/api/v1/documents/$(DocumentId)/versions/$(VersionId)/comment",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Text" => Text), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_custom_metadata(custom_metadata, resource_id)
    create_custom_metadata(custom_metadata, resource_id, params::Dict{String,<:Any})

Adds one or more custom properties to the specified resource (a folder, document, or
version).

# Arguments
- `custom_metadata`: Custom metadata in the form of name-value pairs.
- `resource_id`: The ID of the resource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Authentication"`: Amazon WorkDocs authentication token. Not required when using Amazon
  Web Services administrator credentials to access the API.
- `"versionid"`: The ID of the version, if the custom metadata is being added to a document
  version.
"""
function create_custom_metadata(
    CustomMetadata, ResourceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workdocs(
        "PUT",
        "/api/v1/resources/$(ResourceId)/customMetadata",
        Dict{String,Any}("CustomMetadata" => CustomMetadata);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_custom_metadata(
    CustomMetadata,
    ResourceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workdocs(
        "PUT",
        "/api/v1/resources/$(ResourceId)/customMetadata",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("CustomMetadata" => CustomMetadata), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_folder(parent_folder_id)
    create_folder(parent_folder_id, params::Dict{String,<:Any})

Creates a folder with the specified name and parent folder.

# Arguments
- `parent_folder_id`: The ID of the parent folder.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Authentication"`: Amazon WorkDocs authentication token. Not required when using Amazon
  Web Services administrator credentials to access the API.
- `"Name"`: The name of the new folder.
"""
function create_folder(ParentFolderId; aws_config::AbstractAWSConfig=current_aws_config())
    return workdocs(
        "POST",
        "/api/v1/folders",
        Dict{String,Any}("ParentFolderId" => ParentFolderId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_folder(
    ParentFolderId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workdocs(
        "POST",
        "/api/v1/folders",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ParentFolderId" => ParentFolderId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_labels(labels, resource_id)
    create_labels(labels, resource_id, params::Dict{String,<:Any})

Adds the specified list of labels to the given resource (a document or folder)

# Arguments
- `labels`: List of labels to add to the resource.
- `resource_id`: The ID of the resource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Authentication"`: Amazon WorkDocs authentication token. Not required when using Amazon
  Web Services administrator credentials to access the API.
"""
function create_labels(
    Labels, ResourceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workdocs(
        "PUT",
        "/api/v1/resources/$(ResourceId)/labels",
        Dict{String,Any}("Labels" => Labels);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_labels(
    Labels,
    ResourceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workdocs(
        "PUT",
        "/api/v1/resources/$(ResourceId)/labels",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Labels" => Labels), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_notification_subscription(endpoint, organization_id, protocol, subscription_type)
    create_notification_subscription(endpoint, organization_id, protocol, subscription_type, params::Dict{String,<:Any})

Configure Amazon WorkDocs to use Amazon SNS notifications. The endpoint receives a
confirmation message, and must confirm the subscription. For more information, see Setting
up notifications for an IAM user or role in the Amazon WorkDocs Developer Guide.

# Arguments
- `endpoint`: The endpoint to receive the notifications. If the protocol is HTTPS, the
  endpoint is a URL that begins with https.
- `organization_id`: The ID of the organization.
- `protocol`: The protocol to use. The supported value is https, which delivers
  JSON-encoded messages using HTTPS POST.
- `subscription_type`: The notification type.

"""
function create_notification_subscription(
    Endpoint,
    OrganizationId,
    Protocol,
    SubscriptionType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workdocs(
        "POST",
        "/api/v1/organizations/$(OrganizationId)/subscriptions",
        Dict{String,Any}(
            "Endpoint" => Endpoint,
            "Protocol" => Protocol,
            "SubscriptionType" => SubscriptionType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_notification_subscription(
    Endpoint,
    OrganizationId,
    Protocol,
    SubscriptionType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workdocs(
        "POST",
        "/api/v1/organizations/$(OrganizationId)/subscriptions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Endpoint" => Endpoint,
                    "Protocol" => Protocol,
                    "SubscriptionType" => SubscriptionType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_user(given_name, password, surname, username)
    create_user(given_name, password, surname, username, params::Dict{String,<:Any})

Creates a user in a Simple AD or Microsoft AD directory. The status of a newly created user
is \"ACTIVE\". New users can access Amazon WorkDocs.

# Arguments
- `given_name`: The given name of the user.
- `password`: The password of the user.
- `surname`: The surname of the user.
- `username`: The login name of the user.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Authentication"`: Amazon WorkDocs authentication token. Not required when using Amazon
  Web Services administrator credentials to access the API.
- `"EmailAddress"`: The email address of the user.
- `"OrganizationId"`: The ID of the organization.
- `"StorageRule"`: The amount of storage for the user.
- `"TimeZoneId"`: The time zone ID of the user.
"""
function create_user(
    GivenName,
    Password,
    Surname,
    Username;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workdocs(
        "POST",
        "/api/v1/users",
        Dict{String,Any}(
            "GivenName" => GivenName,
            "Password" => Password,
            "Surname" => Surname,
            "Username" => Username,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_user(
    GivenName,
    Password,
    Surname,
    Username,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workdocs(
        "POST",
        "/api/v1/users",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "GivenName" => GivenName,
                    "Password" => Password,
                    "Surname" => Surname,
                    "Username" => Username,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    deactivate_user(user_id)
    deactivate_user(user_id, params::Dict{String,<:Any})

Deactivates the specified user, which revokes the user's access to Amazon WorkDocs.

# Arguments
- `user_id`: The ID of the user.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Authentication"`: Amazon WorkDocs authentication token. Not required when using Amazon
  Web Services administrator credentials to access the API.
"""
function deactivate_user(UserId; aws_config::AbstractAWSConfig=current_aws_config())
    return workdocs(
        "DELETE",
        "/api/v1/users/$(UserId)/activation";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function deactivate_user(
    UserId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workdocs(
        "DELETE",
        "/api/v1/users/$(UserId)/activation",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_comment(comment_id, document_id, version_id)
    delete_comment(comment_id, document_id, version_id, params::Dict{String,<:Any})

Deletes the specified comment from the document version.

# Arguments
- `comment_id`: The ID of the comment.
- `document_id`: The ID of the document.
- `version_id`: The ID of the document version.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Authentication"`: Amazon WorkDocs authentication token. Not required when using Amazon
  Web Services administrator credentials to access the API.
"""
function delete_comment(
    CommentId, DocumentId, VersionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workdocs(
        "DELETE",
        "/api/v1/documents/$(DocumentId)/versions/$(VersionId)/comment/$(CommentId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_comment(
    CommentId,
    DocumentId,
    VersionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workdocs(
        "DELETE",
        "/api/v1/documents/$(DocumentId)/versions/$(VersionId)/comment/$(CommentId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_custom_metadata(resource_id)
    delete_custom_metadata(resource_id, params::Dict{String,<:Any})

Deletes custom metadata from the specified resource.

# Arguments
- `resource_id`: The ID of the resource, either a document or folder.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Authentication"`: Amazon WorkDocs authentication token. Not required when using Amazon
  Web Services administrator credentials to access the API.
- `"deleteAll"`: Flag to indicate removal of all custom metadata properties from the
  specified resource.
- `"keys"`: List of properties to remove.
- `"versionId"`: The ID of the version, if the custom metadata is being deleted from a
  document version.
"""
function delete_custom_metadata(
    ResourceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workdocs(
        "DELETE",
        "/api/v1/resources/$(ResourceId)/customMetadata";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_custom_metadata(
    ResourceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workdocs(
        "DELETE",
        "/api/v1/resources/$(ResourceId)/customMetadata",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_document(document_id)
    delete_document(document_id, params::Dict{String,<:Any})

Permanently deletes the specified document and its associated metadata.

# Arguments
- `document_id`: The ID of the document.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Authentication"`: Amazon WorkDocs authentication token. Not required when using Amazon
  Web Services administrator credentials to access the API.
"""
function delete_document(DocumentId; aws_config::AbstractAWSConfig=current_aws_config())
    return workdocs(
        "DELETE",
        "/api/v1/documents/$(DocumentId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_document(
    DocumentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workdocs(
        "DELETE",
        "/api/v1/documents/$(DocumentId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_document_version(document_id, version_id, delete_prior_versions)
    delete_document_version(document_id, version_id, delete_prior_versions, params::Dict{String,<:Any})

Deletes a specific version of a document.

# Arguments
- `document_id`: The ID of the document associated with the version being deleted.
- `version_id`: The ID of the version being deleted.
- `delete_prior_versions`: Deletes all versions of a document prior to the current version.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Authentication"`: Amazon WorkDocs authentication token. Not required when using Amazon
  Web Services administrator credentials to access the API.
"""
function delete_document_version(
    DocumentId,
    VersionId,
    deletePriorVersions;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workdocs(
        "DELETE",
        "/api/v1/documentVersions/$(DocumentId)/versions/$(VersionId)",
        Dict{String,Any}("deletePriorVersions" => deletePriorVersions);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_document_version(
    DocumentId,
    VersionId,
    deletePriorVersions,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workdocs(
        "DELETE",
        "/api/v1/documentVersions/$(DocumentId)/versions/$(VersionId)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("deletePriorVersions" => deletePriorVersions),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_folder(folder_id)
    delete_folder(folder_id, params::Dict{String,<:Any})

Permanently deletes the specified folder and its contents.

# Arguments
- `folder_id`: The ID of the folder.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Authentication"`: Amazon WorkDocs authentication token. Not required when using Amazon
  Web Services administrator credentials to access the API.
"""
function delete_folder(FolderId; aws_config::AbstractAWSConfig=current_aws_config())
    return workdocs(
        "DELETE",
        "/api/v1/folders/$(FolderId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_folder(
    FolderId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workdocs(
        "DELETE",
        "/api/v1/folders/$(FolderId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_folder_contents(folder_id)
    delete_folder_contents(folder_id, params::Dict{String,<:Any})

Deletes the contents of the specified folder.

# Arguments
- `folder_id`: The ID of the folder.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Authentication"`: Amazon WorkDocs authentication token. Not required when using Amazon
  Web Services administrator credentials to access the API.
"""
function delete_folder_contents(
    FolderId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workdocs(
        "DELETE",
        "/api/v1/folders/$(FolderId)/contents";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_folder_contents(
    FolderId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workdocs(
        "DELETE",
        "/api/v1/folders/$(FolderId)/contents",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_labels(resource_id)
    delete_labels(resource_id, params::Dict{String,<:Any})

Deletes the specified list of labels from a resource.

# Arguments
- `resource_id`: The ID of the resource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Authentication"`: Amazon WorkDocs authentication token. Not required when using Amazon
  Web Services administrator credentials to access the API.
- `"deleteAll"`: Flag to request removal of all labels from the specified resource.
- `"labels"`: List of labels to delete from the resource.
"""
function delete_labels(ResourceId; aws_config::AbstractAWSConfig=current_aws_config())
    return workdocs(
        "DELETE",
        "/api/v1/resources/$(ResourceId)/labels";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_labels(
    ResourceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workdocs(
        "DELETE",
        "/api/v1/resources/$(ResourceId)/labels",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_notification_subscription(organization_id, subscription_id)
    delete_notification_subscription(organization_id, subscription_id, params::Dict{String,<:Any})

Deletes the specified subscription from the specified organization.

# Arguments
- `organization_id`: The ID of the organization.
- `subscription_id`: The ID of the subscription.

"""
function delete_notification_subscription(
    OrganizationId, SubscriptionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workdocs(
        "DELETE",
        "/api/v1/organizations/$(OrganizationId)/subscriptions/$(SubscriptionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_notification_subscription(
    OrganizationId,
    SubscriptionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workdocs(
        "DELETE",
        "/api/v1/organizations/$(OrganizationId)/subscriptions/$(SubscriptionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_user(user_id)
    delete_user(user_id, params::Dict{String,<:Any})

Deletes the specified user from a Simple AD or Microsoft AD directory.  Deleting a user
immediately and permanently deletes all content in that user's folder structure. Site
retention policies do NOT apply to this type of deletion.

# Arguments
- `user_id`: The ID of the user.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Authentication"`: Amazon WorkDocs authentication token. Do not set this field when
  using administrative API actions, as in accessing the API using Amazon Web Services
  credentials.
"""
function delete_user(UserId; aws_config::AbstractAWSConfig=current_aws_config())
    return workdocs(
        "DELETE",
        "/api/v1/users/$(UserId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_user(
    UserId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workdocs(
        "DELETE",
        "/api/v1/users/$(UserId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_activities()
    describe_activities(params::Dict{String,<:Any})

Describes the user activities in a specified time period.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Authentication"`: Amazon WorkDocs authentication token. Not required when using Amazon
  Web Services administrator credentials to access the API.
- `"activityTypes"`: Specifies which activity types to include in the response. If this
  field is left empty, all activity types are returned.
- `"endTime"`: The timestamp that determines the end time of the activities. The response
  includes the activities performed before the specified timestamp.
- `"includeIndirectActivities"`: Includes indirect activities. An indirect activity results
  from a direct activity performed on a parent resource. For example, sharing a parent folder
  (the direct activity) shares all of the subfolders and documents within the parent folder
  (the indirect activity).
- `"limit"`: The maximum number of items to return.
- `"marker"`: The marker for the next set of results.
- `"organizationId"`: The ID of the organization. This is a mandatory parameter when using
  administrative API (SigV4) requests.
- `"resourceId"`: The document or folder ID for which to describe activity types.
- `"startTime"`: The timestamp that determines the starting time of the activities. The
  response includes the activities performed after the specified timestamp.
- `"userId"`: The ID of the user who performed the action. The response includes activities
  pertaining to this user. This is an optional parameter and is only applicable for
  administrative API (SigV4) requests.
"""
function describe_activities(; aws_config::AbstractAWSConfig=current_aws_config())
    return workdocs(
        "GET", "/api/v1/activities"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_activities(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workdocs(
        "GET",
        "/api/v1/activities",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_comments(document_id, version_id)
    describe_comments(document_id, version_id, params::Dict{String,<:Any})

List all the comments for the specified document version.

# Arguments
- `document_id`: The ID of the document.
- `version_id`: The ID of the document version.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Authentication"`: Amazon WorkDocs authentication token. Not required when using Amazon
  Web Services administrator credentials to access the API.
- `"limit"`: The maximum number of items to return.
- `"marker"`: The marker for the next set of results. This marker was received from a
  previous call.
"""
function describe_comments(
    DocumentId, VersionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workdocs(
        "GET",
        "/api/v1/documents/$(DocumentId)/versions/$(VersionId)/comments";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_comments(
    DocumentId,
    VersionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workdocs(
        "GET",
        "/api/v1/documents/$(DocumentId)/versions/$(VersionId)/comments",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_document_versions(document_id)
    describe_document_versions(document_id, params::Dict{String,<:Any})

Retrieves the document versions for the specified document. By default, only active
versions are returned.

# Arguments
- `document_id`: The ID of the document.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Authentication"`: Amazon WorkDocs authentication token. Not required when using Amazon
  Web Services administrator credentials to access the API.
- `"fields"`: Specify \"SOURCE\" to include initialized versions and a URL for the source
  document.
- `"include"`: A comma-separated list of values. Specify \"INITIALIZED\" to include
  incomplete versions.
- `"limit"`: The maximum number of versions to return with this call.
- `"marker"`: The marker for the next set of results. (You received this marker from a
  previous call.)
"""
function describe_document_versions(
    DocumentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workdocs(
        "GET",
        "/api/v1/documents/$(DocumentId)/versions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_document_versions(
    DocumentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workdocs(
        "GET",
        "/api/v1/documents/$(DocumentId)/versions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_folder_contents(folder_id)
    describe_folder_contents(folder_id, params::Dict{String,<:Any})

Describes the contents of the specified folder, including its documents and subfolders. By
default, Amazon WorkDocs returns the first 100 active document and folder metadata items.
If there are more results, the response includes a marker that you can use to request the
next set of results. You can also request initialized documents.

# Arguments
- `folder_id`: The ID of the folder.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Authentication"`: Amazon WorkDocs authentication token. Not required when using Amazon
  Web Services administrator credentials to access the API.
- `"include"`: The contents to include. Specify \"INITIALIZED\" to include initialized
  documents.
- `"limit"`: The maximum number of items to return with this call.
- `"marker"`: The marker for the next set of results. This marker was received from a
  previous call.
- `"order"`: The order for the contents of the folder.
- `"sort"`: The sorting criteria.
- `"type"`: The type of items.
"""
function describe_folder_contents(
    FolderId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workdocs(
        "GET",
        "/api/v1/folders/$(FolderId)/contents";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_folder_contents(
    FolderId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workdocs(
        "GET",
        "/api/v1/folders/$(FolderId)/contents",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_groups(search_query)
    describe_groups(search_query, params::Dict{String,<:Any})

Describes the groups specified by the query. Groups are defined by the underlying Active
Directory.

# Arguments
- `search_query`: A query to describe groups by group name.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Authentication"`: Amazon WorkDocs authentication token. Not required when using Amazon
  Web Services administrator credentials to access the API.
- `"limit"`: The maximum number of items to return with this call.
- `"marker"`: The marker for the next set of results. (You received this marker from a
  previous call.)
- `"organizationId"`: The ID of the organization.
"""
function describe_groups(searchQuery; aws_config::AbstractAWSConfig=current_aws_config())
    return workdocs(
        "GET",
        "/api/v1/groups",
        Dict{String,Any}("searchQuery" => searchQuery);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_groups(
    searchQuery,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workdocs(
        "GET",
        "/api/v1/groups",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("searchQuery" => searchQuery), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_notification_subscriptions(organization_id)
    describe_notification_subscriptions(organization_id, params::Dict{String,<:Any})

Lists the specified notification subscriptions.

# Arguments
- `organization_id`: The ID of the organization.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"limit"`: The maximum number of items to return with this call.
- `"marker"`: The marker for the next set of results. (You received this marker from a
  previous call.)
"""
function describe_notification_subscriptions(
    OrganizationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workdocs(
        "GET",
        "/api/v1/organizations/$(OrganizationId)/subscriptions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_notification_subscriptions(
    OrganizationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workdocs(
        "GET",
        "/api/v1/organizations/$(OrganizationId)/subscriptions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_resource_permissions(resource_id)
    describe_resource_permissions(resource_id, params::Dict{String,<:Any})

Describes the permissions of a specified resource.

# Arguments
- `resource_id`: The ID of the resource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Authentication"`: Amazon WorkDocs authentication token. Not required when using Amazon
  Web Services administrator credentials to access the API.
- `"limit"`: The maximum number of items to return with this call.
- `"marker"`: The marker for the next set of results. (You received this marker from a
  previous call)
- `"principalId"`: The ID of the principal to filter permissions by.
"""
function describe_resource_permissions(
    ResourceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workdocs(
        "GET",
        "/api/v1/resources/$(ResourceId)/permissions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_resource_permissions(
    ResourceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workdocs(
        "GET",
        "/api/v1/resources/$(ResourceId)/permissions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_root_folders(authentication)
    describe_root_folders(authentication, params::Dict{String,<:Any})

Describes the current user's special folders; the RootFolder and the RecycleBin. RootFolder
is the root of user's files and folders and RecycleBin is the root of recycled items. This
is not a valid action for SigV4 (administrative API) clients. This action requires an
authentication token. To get an authentication token, register an application with Amazon
WorkDocs. For more information, see Authentication and Access Control for User Applications
in the Amazon WorkDocs Developer Guide.

# Arguments
- `authentication`: Amazon WorkDocs authentication token.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"limit"`: The maximum number of items to return.
- `"marker"`: The marker for the next set of results. (You received this marker from a
  previous call.)
"""
function describe_root_folders(
    Authentication; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workdocs(
        "GET",
        "/api/v1/me/root",
        Dict{String,Any}("headers" => Dict{String,Any}("Authentication" => Authentication));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_root_folders(
    Authentication,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workdocs(
        "GET",
        "/api/v1/me/root",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "headers" => Dict{String,Any}("Authentication" => Authentication)
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_users()
    describe_users(params::Dict{String,<:Any})

Describes the specified users. You can describe all users or filter the results (for
example, by status or organization). By default, Amazon WorkDocs returns the first 24
active or pending users. If there are more results, the response includes a marker that you
can use to request the next set of results.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Authentication"`: Amazon WorkDocs authentication token. Not required when using Amazon
  Web Services administrator credentials to access the API.
- `"fields"`: A comma-separated list of values. Specify \"STORAGE_METADATA\" to include the
  user storage quota and utilization information.
- `"include"`: The state of the users. Specify \"ALL\" to include inactive users.
- `"limit"`: The maximum number of items to return.
- `"marker"`: The marker for the next set of results. (You received this marker from a
  previous call.)
- `"order"`: The order for the results.
- `"organizationId"`: The ID of the organization.
- `"query"`: A query to filter users by user name. Remember the following about the Userids
  and Query parameters:   If you don't use either parameter, the API returns a paginated list
  of all users on the site.   If you use both parameters, the API ignores the Query
  parameter.   The Userid parameter only returns user names that match a corresponding user
  ID.   The Query parameter runs a \"prefix\" search for users by the GivenName, SurName, or
  UserName fields included in a CreateUser API call. For example, querying on Ma returns
  Márcia Oliveira, María García, and Mateo Jackson. If you use multiple characters, the
  API only returns data that matches all characters. For example, querying on Ma J only
  returns Mateo Jackson.
- `"sort"`: The sorting criteria.
- `"userIds"`: The IDs of the users.
"""
function describe_users(; aws_config::AbstractAWSConfig=current_aws_config())
    return workdocs(
        "GET", "/api/v1/users"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_users(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workdocs(
        "GET",
        "/api/v1/users",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_current_user(authentication)
    get_current_user(authentication, params::Dict{String,<:Any})

Retrieves details of the current user for whom the authentication token was generated. This
is not a valid action for SigV4 (administrative API) clients. This action requires an
authentication token. To get an authentication token, register an application with Amazon
WorkDocs. For more information, see Authentication and Access Control for User Applications
in the Amazon WorkDocs Developer Guide.

# Arguments
- `authentication`: Amazon WorkDocs authentication token.

"""
function get_current_user(
    Authentication; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workdocs(
        "GET",
        "/api/v1/me",
        Dict{String,Any}("headers" => Dict{String,Any}("Authentication" => Authentication));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_current_user(
    Authentication,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workdocs(
        "GET",
        "/api/v1/me",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "headers" => Dict{String,Any}("Authentication" => Authentication)
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_document(document_id)
    get_document(document_id, params::Dict{String,<:Any})

Retrieves details of a document.

# Arguments
- `document_id`: The ID of the document.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Authentication"`: Amazon WorkDocs authentication token. Not required when using Amazon
  Web Services administrator credentials to access the API.
- `"includeCustomMetadata"`: Set this to TRUE to include custom metadata in the response.
"""
function get_document(DocumentId; aws_config::AbstractAWSConfig=current_aws_config())
    return workdocs(
        "GET",
        "/api/v1/documents/$(DocumentId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_document(
    DocumentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workdocs(
        "GET",
        "/api/v1/documents/$(DocumentId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_document_path(document_id)
    get_document_path(document_id, params::Dict{String,<:Any})

Retrieves the path information (the hierarchy from the root folder) for the requested
document. By default, Amazon WorkDocs returns a maximum of 100 levels upwards from the
requested document and only includes the IDs of the parent folders in the path. You can
limit the maximum number of levels. You can also request the names of the parent folders.

# Arguments
- `document_id`: The ID of the document.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Authentication"`: Amazon WorkDocs authentication token. Not required when using Amazon
  Web Services administrator credentials to access the API.
- `"fields"`: A comma-separated list of values. Specify NAME to include the names of the
  parent folders.
- `"limit"`: The maximum number of levels in the hierarchy to return.
- `"marker"`: This value is not supported.
"""
function get_document_path(DocumentId; aws_config::AbstractAWSConfig=current_aws_config())
    return workdocs(
        "GET",
        "/api/v1/documents/$(DocumentId)/path";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_document_path(
    DocumentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workdocs(
        "GET",
        "/api/v1/documents/$(DocumentId)/path",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_document_version(document_id, version_id)
    get_document_version(document_id, version_id, params::Dict{String,<:Any})

Retrieves version metadata for the specified document.

# Arguments
- `document_id`: The ID of the document.
- `version_id`: The version ID of the document.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Authentication"`: Amazon WorkDocs authentication token. Not required when using Amazon
  Web Services administrator credentials to access the API.
- `"fields"`: A comma-separated list of values. Specify \"SOURCE\" to include a URL for the
  source document.
- `"includeCustomMetadata"`: Set this to TRUE to include custom metadata in the response.
"""
function get_document_version(
    DocumentId, VersionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workdocs(
        "GET",
        "/api/v1/documents/$(DocumentId)/versions/$(VersionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_document_version(
    DocumentId,
    VersionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workdocs(
        "GET",
        "/api/v1/documents/$(DocumentId)/versions/$(VersionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_folder(folder_id)
    get_folder(folder_id, params::Dict{String,<:Any})

Retrieves the metadata of the specified folder.

# Arguments
- `folder_id`: The ID of the folder.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Authentication"`: Amazon WorkDocs authentication token. Not required when using Amazon
  Web Services administrator credentials to access the API.
- `"includeCustomMetadata"`: Set to TRUE to include custom metadata in the response.
"""
function get_folder(FolderId; aws_config::AbstractAWSConfig=current_aws_config())
    return workdocs(
        "GET",
        "/api/v1/folders/$(FolderId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_folder(
    FolderId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workdocs(
        "GET",
        "/api/v1/folders/$(FolderId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_folder_path(folder_id)
    get_folder_path(folder_id, params::Dict{String,<:Any})

Retrieves the path information (the hierarchy from the root folder) for the specified
folder. By default, Amazon WorkDocs returns a maximum of 100 levels upwards from the
requested folder and only includes the IDs of the parent folders in the path. You can limit
the maximum number of levels. You can also request the parent folder names.

# Arguments
- `folder_id`: The ID of the folder.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Authentication"`: Amazon WorkDocs authentication token. Not required when using Amazon
  Web Services administrator credentials to access the API.
- `"fields"`: A comma-separated list of values. Specify \"NAME\" to include the names of
  the parent folders.
- `"limit"`: The maximum number of levels in the hierarchy to return.
- `"marker"`: This value is not supported.
"""
function get_folder_path(FolderId; aws_config::AbstractAWSConfig=current_aws_config())
    return workdocs(
        "GET",
        "/api/v1/folders/$(FolderId)/path";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_folder_path(
    FolderId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workdocs(
        "GET",
        "/api/v1/folders/$(FolderId)/path",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_resources()
    get_resources(params::Dict{String,<:Any})

Retrieves a collection of resources, including folders and documents. The only
CollectionType supported is SHARED_WITH_ME.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Authentication"`: The Amazon WorkDocs authentication token. Not required when using
  Amazon Web Services administrator credentials to access the API.
- `"collectionType"`: The collection type.
- `"limit"`: The maximum number of resources to return.
- `"marker"`: The marker for the next set of results. This marker was received from a
  previous call.
- `"userId"`: The user ID for the resource collection. This is a required field for
  accessing the API operation using IAM credentials.
"""
function get_resources(; aws_config::AbstractAWSConfig=current_aws_config())
    return workdocs(
        "GET", "/api/v1/resources"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_resources(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workdocs(
        "GET",
        "/api/v1/resources",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    initiate_document_version_upload()
    initiate_document_version_upload(params::Dict{String,<:Any})

Creates a new document object and version object. The client specifies the parent folder ID
and name of the document to upload. The ID is optionally specified when creating a new
version of an existing document. This is the first step to upload a document. Next, upload
the document to the URL returned from the call, and then call UpdateDocumentVersion. To
cancel the document upload, call AbortDocumentVersionUpload.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Authentication"`: Amazon WorkDocs authentication token. Not required when using Amazon
  Web Services administrator credentials to access the API.
- `"ContentCreatedTimestamp"`: The timestamp when the content of the document was
  originally created.
- `"ContentModifiedTimestamp"`: The timestamp when the content of the document was modified.
- `"ContentType"`: The content type of the document.
- `"DocumentSizeInBytes"`: The size of the document, in bytes.
- `"Id"`: The ID of the document.
- `"Name"`: The name of the document.
- `"ParentFolderId"`: The ID of the parent folder.
"""
function initiate_document_version_upload(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return workdocs(
        "POST", "/api/v1/documents"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function initiate_document_version_upload(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workdocs(
        "POST",
        "/api/v1/documents",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_all_resource_permissions(resource_id)
    remove_all_resource_permissions(resource_id, params::Dict{String,<:Any})

Removes all the permissions from the specified resource.

# Arguments
- `resource_id`: The ID of the resource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Authentication"`: Amazon WorkDocs authentication token. Not required when using Amazon
  Web Services administrator credentials to access the API.
"""
function remove_all_resource_permissions(
    ResourceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workdocs(
        "DELETE",
        "/api/v1/resources/$(ResourceId)/permissions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_all_resource_permissions(
    ResourceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workdocs(
        "DELETE",
        "/api/v1/resources/$(ResourceId)/permissions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_resource_permission(principal_id, resource_id)
    remove_resource_permission(principal_id, resource_id, params::Dict{String,<:Any})

Removes the permission for the specified principal from the specified resource.

# Arguments
- `principal_id`: The principal ID of the resource.
- `resource_id`: The ID of the resource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Authentication"`: Amazon WorkDocs authentication token. Not required when using Amazon
  Web Services administrator credentials to access the API.
- `"type"`: The principal type of the resource.
"""
function remove_resource_permission(
    PrincipalId, ResourceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workdocs(
        "DELETE",
        "/api/v1/resources/$(ResourceId)/permissions/$(PrincipalId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_resource_permission(
    PrincipalId,
    ResourceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workdocs(
        "DELETE",
        "/api/v1/resources/$(ResourceId)/permissions/$(PrincipalId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    restore_document_versions(document_id)
    restore_document_versions(document_id, params::Dict{String,<:Any})

Recovers a deleted version of an Amazon WorkDocs document.

# Arguments
- `document_id`: The ID of the document.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Authentication"`: Amazon WorkDocs authentication token. Not required when using Amazon
  Web Services administrator credentials to access the API.
"""
function restore_document_versions(
    DocumentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workdocs(
        "POST",
        "/api/v1/documentVersions/restore/$(DocumentId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function restore_document_versions(
    DocumentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workdocs(
        "POST",
        "/api/v1/documentVersions/restore/$(DocumentId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    search_resources()
    search_resources(params::Dict{String,<:Any})

Searches metadata and the content of folders, documents, document versions, and comments.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AdditionalResponseFields"`: A list of attributes to include in the response. Used to
  request fields that are not normally returned in a standard response.
- `"Authentication"`: Amazon WorkDocs authentication token. Not required when using Amazon
  Web Services administrator credentials to access the API.
- `"Filters"`: Filters results based on entity metadata.
- `"Limit"`: Max results count per page.
- `"Marker"`: The marker for the next set of results.
- `"OrderBy"`: Order by results in one or more categories.
- `"OrganizationId"`: Filters based on the resource owner OrgId. This is a mandatory
  parameter when using Admin SigV4 credentials.
- `"QueryScopes"`: Filter based on the text field type. A Folder has only a name and no
  content. A Comment has only content and no name. A Document or Document Version has a name
  and content
- `"QueryText"`: The String to search for. Searches across different text fields based on
  request parameters. Use double quotes around the query string for exact phrase matches.
"""
function search_resources(; aws_config::AbstractAWSConfig=current_aws_config())
    return workdocs(
        "POST", "/api/v1/search"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function search_resources(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workdocs(
        "POST",
        "/api/v1/search",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_document(document_id)
    update_document(document_id, params::Dict{String,<:Any})

Updates the specified attributes of a document. The user must have access to both the
document and its parent folder, if applicable.

# Arguments
- `document_id`: The ID of the document.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Authentication"`: Amazon WorkDocs authentication token. Not required when using Amazon
  Web Services administrator credentials to access the API.
- `"Name"`: The name of the document.
- `"ParentFolderId"`: The ID of the parent folder.
- `"ResourceState"`: The resource state of the document. Only ACTIVE and RECYCLED are
  supported.
"""
function update_document(DocumentId; aws_config::AbstractAWSConfig=current_aws_config())
    return workdocs(
        "PATCH",
        "/api/v1/documents/$(DocumentId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_document(
    DocumentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workdocs(
        "PATCH",
        "/api/v1/documents/$(DocumentId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_document_version(document_id, version_id)
    update_document_version(document_id, version_id, params::Dict{String,<:Any})

Changes the status of the document version to ACTIVE.  Amazon WorkDocs also sets its
document container to ACTIVE. This is the last step in a document upload, after the client
uploads the document to an S3-presigned URL returned by InitiateDocumentVersionUpload.

# Arguments
- `document_id`: The ID of the document.
- `version_id`: The version ID of the document.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Authentication"`: Amazon WorkDocs authentication token. Not required when using Amazon
  Web Services administrator credentials to access the API.
- `"VersionStatus"`: The status of the version.
"""
function update_document_version(
    DocumentId, VersionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workdocs(
        "PATCH",
        "/api/v1/documents/$(DocumentId)/versions/$(VersionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_document_version(
    DocumentId,
    VersionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workdocs(
        "PATCH",
        "/api/v1/documents/$(DocumentId)/versions/$(VersionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_folder(folder_id)
    update_folder(folder_id, params::Dict{String,<:Any})

Updates the specified attributes of the specified folder. The user must have access to both
the folder and its parent folder, if applicable.

# Arguments
- `folder_id`: The ID of the folder.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Authentication"`: Amazon WorkDocs authentication token. Not required when using Amazon
  Web Services administrator credentials to access the API.
- `"Name"`: The name of the folder.
- `"ParentFolderId"`: The ID of the parent folder.
- `"ResourceState"`: The resource state of the folder. Only ACTIVE and RECYCLED are
  accepted values from the API.
"""
function update_folder(FolderId; aws_config::AbstractAWSConfig=current_aws_config())
    return workdocs(
        "PATCH",
        "/api/v1/folders/$(FolderId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_folder(
    FolderId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workdocs(
        "PATCH",
        "/api/v1/folders/$(FolderId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_user(user_id)
    update_user(user_id, params::Dict{String,<:Any})

Updates the specified attributes of the specified user, and grants or revokes
administrative privileges to the Amazon WorkDocs site.

# Arguments
- `user_id`: The ID of the user.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Authentication"`: Amazon WorkDocs authentication token. Not required when using Amazon
  Web Services administrator credentials to access the API.
- `"GivenName"`: The given name of the user.
- `"GrantPoweruserPrivileges"`: Boolean value to determine whether the user is granted
  Power user privileges.
- `"Locale"`: The locale of the user.
- `"StorageRule"`: The amount of storage for the user.
- `"Surname"`: The surname of the user.
- `"TimeZoneId"`: The time zone ID of the user.
- `"Type"`: The type of the user.
"""
function update_user(UserId; aws_config::AbstractAWSConfig=current_aws_config())
    return workdocs(
        "PATCH",
        "/api/v1/users/$(UserId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_user(
    UserId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workdocs(
        "PATCH",
        "/api/v1/users/$(UserId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: route53resolver
using AWS.Compat
using AWS.UUIDs

"""
    associate_firewall_rule_group(creator_request_id, firewall_rule_group_id, name, priority, vpc_id)
    associate_firewall_rule_group(creator_request_id, firewall_rule_group_id, name, priority, vpc_id, params::Dict{String,<:Any})

Associates a FirewallRuleGroup with a VPC, to provide DNS filtering for the VPC.

# Arguments
- `creator_request_id`: A unique string that identifies the request and that allows failed
  requests to be retried without the risk of running the operation twice. CreatorRequestId
  can be any unique string, for example, a date/time stamp.
- `firewall_rule_group_id`: The unique identifier of the firewall rule group.
- `name`: A name that lets you identify the association, to manage and use it.
- `priority`: The setting that determines the processing order of the rule group among the
  rule groups that you associate with the specified VPC. DNS Firewall filters VPC traffic
  starting from the rule group with the lowest numeric priority setting.  You must specify a
  unique priority for each rule group that you associate with a single VPC. To make it easier
  to insert rule groups later, leave space between the numbers, for example, use 101, 200,
  and so on. You can change the priority setting for a rule group association after you
  create it. The allowed values for Priority are between 100 and 9900.
- `vpc_id`: The unique identifier of the VPC that you want to associate with the rule
  group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MutationProtection"`: If enabled, this setting disallows modification or removal of the
  association, to help prevent against accidentally altering DNS firewall protections. When
  you create the association, the default setting is DISABLED.
- `"Tags"`: A list of the tag keys and values that you want to associate with the rule
  group association.
"""
function associate_firewall_rule_group(
    CreatorRequestId,
    FirewallRuleGroupId,
    Name,
    Priority,
    VpcId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53resolver(
        "AssociateFirewallRuleGroup",
        Dict{String,Any}(
            "CreatorRequestId" => CreatorRequestId,
            "FirewallRuleGroupId" => FirewallRuleGroupId,
            "Name" => Name,
            "Priority" => Priority,
            "VpcId" => VpcId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_firewall_rule_group(
    CreatorRequestId,
    FirewallRuleGroupId,
    Name,
    Priority,
    VpcId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53resolver(
        "AssociateFirewallRuleGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CreatorRequestId" => CreatorRequestId,
                    "FirewallRuleGroupId" => FirewallRuleGroupId,
                    "Name" => Name,
                    "Priority" => Priority,
                    "VpcId" => VpcId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_resolver_endpoint_ip_address(ip_address, resolver_endpoint_id)
    associate_resolver_endpoint_ip_address(ip_address, resolver_endpoint_id, params::Dict{String,<:Any})

Adds IP addresses to an inbound or an outbound Resolver endpoint. If you want to add more
than one IP address, submit one AssociateResolverEndpointIpAddress request for each IP
address. To remove an IP address from an endpoint, see
DisassociateResolverEndpointIpAddress.

# Arguments
- `ip_address`: Either the IPv4 address that you want to add to a Resolver endpoint or a
  subnet ID. If you specify a subnet ID, Resolver chooses an IP address for you from the
  available IPs in the specified subnet.
- `resolver_endpoint_id`: The ID of the Resolver endpoint that you want to associate IP
  addresses with.

"""
function associate_resolver_endpoint_ip_address(
    IpAddress, ResolverEndpointId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "AssociateResolverEndpointIpAddress",
        Dict{String,Any}(
            "IpAddress" => IpAddress, "ResolverEndpointId" => ResolverEndpointId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_resolver_endpoint_ip_address(
    IpAddress,
    ResolverEndpointId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53resolver(
        "AssociateResolverEndpointIpAddress",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "IpAddress" => IpAddress, "ResolverEndpointId" => ResolverEndpointId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_resolver_query_log_config(resolver_query_log_config_id, resource_id)
    associate_resolver_query_log_config(resolver_query_log_config_id, resource_id, params::Dict{String,<:Any})

Associates an Amazon VPC with a specified query logging configuration. Route 53 Resolver
logs DNS queries that originate in all of the Amazon VPCs that are associated with a
specified query logging configuration. To associate more than one VPC with a configuration,
submit one AssociateResolverQueryLogConfig request for each VPC.  The VPCs that you
associate with a query logging configuration must be in the same Region as the
configuration.  To remove a VPC from a query logging configuration, see
DisassociateResolverQueryLogConfig.

# Arguments
- `resolver_query_log_config_id`: The ID of the query logging configuration that you want
  to associate a VPC with.
- `resource_id`: The ID of an Amazon VPC that you want this query logging configuration to
  log queries for.  The VPCs and the query logging configuration must be in the same Region.

"""
function associate_resolver_query_log_config(
    ResolverQueryLogConfigId, ResourceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "AssociateResolverQueryLogConfig",
        Dict{String,Any}(
            "ResolverQueryLogConfigId" => ResolverQueryLogConfigId,
            "ResourceId" => ResourceId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_resolver_query_log_config(
    ResolverQueryLogConfigId,
    ResourceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53resolver(
        "AssociateResolverQueryLogConfig",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ResolverQueryLogConfigId" => ResolverQueryLogConfigId,
                    "ResourceId" => ResourceId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_resolver_rule(resolver_rule_id, vpcid)
    associate_resolver_rule(resolver_rule_id, vpcid, params::Dict{String,<:Any})

Associates a Resolver rule with a VPC. When you associate a rule with a VPC, Resolver
forwards all DNS queries for the domain name that is specified in the rule and that
originate in the VPC. The queries are forwarded to the IP addresses for the DNS resolvers
that are specified in the rule. For more information about rules, see CreateResolverRule.

# Arguments
- `resolver_rule_id`: The ID of the Resolver rule that you want to associate with the VPC.
  To list the existing Resolver rules, use ListResolverRules.
- `vpcid`: The ID of the VPC that you want to associate the Resolver rule with.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Name"`: A name for the association that you're creating between a Resolver rule and a
  VPC.
"""
function associate_resolver_rule(
    ResolverRuleId, VPCId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "AssociateResolverRule",
        Dict{String,Any}("ResolverRuleId" => ResolverRuleId, "VPCId" => VPCId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_resolver_rule(
    ResolverRuleId,
    VPCId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53resolver(
        "AssociateResolverRule",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResolverRuleId" => ResolverRuleId, "VPCId" => VPCId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_firewall_domain_list(creator_request_id, name)
    create_firewall_domain_list(creator_request_id, name, params::Dict{String,<:Any})

Creates an empty firewall domain list for use in DNS Firewall rules. You can populate the
domains for the new list with a file, using ImportFirewallDomains, or with domain strings,
using UpdateFirewallDomains.

# Arguments
- `creator_request_id`: A unique string that identifies the request and that allows you to
  retry failed requests without the risk of running the operation twice. CreatorRequestId can
  be any unique string, for example, a date/time stamp.
- `name`: A name that lets you identify the domain list to manage and use it.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: A list of the tag keys and values that you want to associate with the domain
  list.
"""
function create_firewall_domain_list(
    CreatorRequestId, Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "CreateFirewallDomainList",
        Dict{String,Any}("CreatorRequestId" => CreatorRequestId, "Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_firewall_domain_list(
    CreatorRequestId,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53resolver(
        "CreateFirewallDomainList",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("CreatorRequestId" => CreatorRequestId, "Name" => Name),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_firewall_rule(action, creator_request_id, firewall_domain_list_id, firewall_rule_group_id, name, priority)
    create_firewall_rule(action, creator_request_id, firewall_domain_list_id, firewall_rule_group_id, name, priority, params::Dict{String,<:Any})

Creates a single DNS Firewall rule in the specified rule group, using the specified domain
list.

# Arguments
- `action`: The action that DNS Firewall should take on a DNS query when it matches one of
  the domains in the rule's domain list:    ALLOW - Permit the request to go through.
  ALERT - Permit the request and send metrics and logs to Cloud Watch.    BLOCK - Disallow
  the request. This option requires additional details in the rule's BlockResponse.
- `creator_request_id`: A unique string that identifies the request and that allows you to
  retry failed requests without the risk of running the operation twice. CreatorRequestId can
  be any unique string, for example, a date/time stamp.
- `firewall_domain_list_id`: The ID of the domain list that you want to use in the rule.
- `firewall_rule_group_id`: The unique identifier of the firewall rule group where you want
  to create the rule.
- `name`: A name that lets you identify the rule in the rule group.
- `priority`: The setting that determines the processing order of the rule in the rule
  group. DNS Firewall processes the rules in a rule group by order of priority, starting from
  the lowest setting. You must specify a unique priority for each rule in a rule group. To
  make it easier to insert rules later, leave space between the numbers, for example, use
  100, 200, and so on. You can change the priority setting for the rules in a rule group at
  any time.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"BlockOverrideDnsType"`: The DNS record's type. This determines the format of the record
  value that you provided in BlockOverrideDomain. Used for the rule action BLOCK with a
  BlockResponse setting of OVERRIDE. This setting is required if the BlockResponse setting is
  OVERRIDE.
- `"BlockOverrideDomain"`: The custom DNS record to send back in response to the query.
  Used for the rule action BLOCK with a BlockResponse setting of OVERRIDE. This setting is
  required if the BlockResponse setting is OVERRIDE.
- `"BlockOverrideTtl"`: The recommended amount of time, in seconds, for the DNS resolver or
  web browser to cache the provided override record. Used for the rule action BLOCK with a
  BlockResponse setting of OVERRIDE. This setting is required if the BlockResponse setting is
  OVERRIDE.
- `"BlockResponse"`: The way that you want DNS Firewall to block the request, used with the
  rule action setting BLOCK.     NODATA - Respond indicating that the query was successful,
  but no response is available for it.    NXDOMAIN - Respond indicating that the domain name
  that's in the query doesn't exist.    OVERRIDE - Provide a custom override in the response.
  This option requires custom handling details in the rule's BlockOverride* settings.    This
  setting is required if the rule action setting is BLOCK.
- `"FirewallDomainRedirectionAction"`:  How you want the the rule to evaluate DNS
  redirection in the DNS redirection chain, such as CNAME or DNAME.
  Inspect_Redirection_Domain (Default) inspects all domains in the redirection chain. The
  individual domains in the redirection chain must be added to the domain list.
  Trust_Redirection_Domain  inspects only the first domain in the redirection chain. You
  don't need to add the subsequent domains in the domain in the redirection list to the
  domain list.
- `"Qtype"`:  The DNS query type you want the rule to evaluate. Allowed values are;     A:
  Returns an IPv4 address.   AAAA: Returns an Ipv6 address.   CAA: Restricts CAs that can
  create SSL/TLS certifications for the domain.   CNAME: Returns another domain name.   DS:
  Record that identifies the DNSSEC signing key of a delegated zone.   MX: Specifies mail
  servers.   NAPTR: Regular-expression-based rewriting of domain names.   NS: Authoritative
  name servers.   PTR: Maps an IP address to a domain name.   SOA: Start of authority record
  for the zone.   SPF: Lists the servers authorized to send emails from a domain.   SRV:
  Application specific values that identify servers.   TXT: Verifies email senders and
  application-specific values.   A query type you define by using the DNS type ID, for
  example 28 for AAAA. The values must be defined as TYPENUMBER, where the NUMBER can be
  1-65334, for example, TYPE28. For more information, see List of DNS record types.
"""
function create_firewall_rule(
    Action,
    CreatorRequestId,
    FirewallDomainListId,
    FirewallRuleGroupId,
    Name,
    Priority;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53resolver(
        "CreateFirewallRule",
        Dict{String,Any}(
            "Action" => Action,
            "CreatorRequestId" => CreatorRequestId,
            "FirewallDomainListId" => FirewallDomainListId,
            "FirewallRuleGroupId" => FirewallRuleGroupId,
            "Name" => Name,
            "Priority" => Priority,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_firewall_rule(
    Action,
    CreatorRequestId,
    FirewallDomainListId,
    FirewallRuleGroupId,
    Name,
    Priority,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53resolver(
        "CreateFirewallRule",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Action" => Action,
                    "CreatorRequestId" => CreatorRequestId,
                    "FirewallDomainListId" => FirewallDomainListId,
                    "FirewallRuleGroupId" => FirewallRuleGroupId,
                    "Name" => Name,
                    "Priority" => Priority,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_firewall_rule_group(creator_request_id, name)
    create_firewall_rule_group(creator_request_id, name, params::Dict{String,<:Any})

Creates an empty DNS Firewall rule group for filtering DNS network traffic in a VPC. You
can add rules to the new rule group by calling CreateFirewallRule.

# Arguments
- `creator_request_id`: A unique string defined by you to identify the request. This allows
  you to retry failed requests without the risk of running the operation twice. This can be
  any unique string, for example, a timestamp.
- `name`: A name that lets you identify the rule group, to manage and use it.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: A list of the tag keys and values that you want to associate with the rule
  group.
"""
function create_firewall_rule_group(
    CreatorRequestId, Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "CreateFirewallRuleGroup",
        Dict{String,Any}("CreatorRequestId" => CreatorRequestId, "Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_firewall_rule_group(
    CreatorRequestId,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53resolver(
        "CreateFirewallRuleGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("CreatorRequestId" => CreatorRequestId, "Name" => Name),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_outpost_resolver(creator_request_id, name, outpost_arn, preferred_instance_type)
    create_outpost_resolver(creator_request_id, name, outpost_arn, preferred_instance_type, params::Dict{String,<:Any})

Creates a Route 53 Resolver on an Outpost.

# Arguments
- `creator_request_id`: A unique string that identifies the request and that allows failed
  requests to be retried without the risk of running the operation twice.   CreatorRequestId
  can be any unique string, for example, a date/time stamp.
- `name`: A friendly name that lets you easily find a configuration in the Resolver
  dashboard in the Route 53 console.
- `outpost_arn`: The Amazon Resource Name (ARN) of the Outpost. If you specify this, you
  must also specify a value for the PreferredInstanceType.
- `preferred_instance_type`:  The Amazon EC2 instance type. If you specify this, you must
  also specify a value for the OutpostArn.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"InstanceCount"`: Number of Amazon EC2 instances for the Resolver on Outpost. The
  default and minimal value is 4.
- `"Tags"`:  A string that helps identify the Route 53 Resolvers on Outpost.
"""
function create_outpost_resolver(
    CreatorRequestId,
    Name,
    OutpostArn,
    PreferredInstanceType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53resolver(
        "CreateOutpostResolver",
        Dict{String,Any}(
            "CreatorRequestId" => CreatorRequestId,
            "Name" => Name,
            "OutpostArn" => OutpostArn,
            "PreferredInstanceType" => PreferredInstanceType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_outpost_resolver(
    CreatorRequestId,
    Name,
    OutpostArn,
    PreferredInstanceType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53resolver(
        "CreateOutpostResolver",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CreatorRequestId" => CreatorRequestId,
                    "Name" => Name,
                    "OutpostArn" => OutpostArn,
                    "PreferredInstanceType" => PreferredInstanceType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_resolver_endpoint(creator_request_id, direction, ip_addresses, security_group_ids)
    create_resolver_endpoint(creator_request_id, direction, ip_addresses, security_group_ids, params::Dict{String,<:Any})

Creates a Resolver endpoint. There are two types of Resolver endpoints, inbound and
outbound:   An inbound Resolver endpoint forwards DNS queries to the DNS service for a VPC
from your network.   An outbound Resolver endpoint forwards DNS queries from the DNS
service for a VPC to your network.

# Arguments
- `creator_request_id`: A unique string that identifies the request and that allows failed
  requests to be retried without the risk of running the operation twice. CreatorRequestId
  can be any unique string, for example, a date/time stamp.
- `direction`: Specify the applicable value:    INBOUND: Resolver forwards DNS queries to
  the DNS service for a VPC from your network    OUTBOUND: Resolver forwards DNS queries from
  the DNS service for a VPC to your network
- `ip_addresses`: The subnets and IP addresses in your VPC that DNS queries originate from
  (for outbound endpoints) or that you forward DNS queries to (for inbound endpoints). The
  subnet ID uniquely identifies a VPC.   Even though the minimum is 1, Route 53 requires
  that you create at least two.
- `security_group_ids`: The ID of one or more security groups that you want to use to
  control access to this VPC. The security group that you specify must include one or more
  inbound rules (for inbound Resolver endpoints) or outbound rules (for outbound Resolver
  endpoints). Inbound and outbound rules must allow TCP and UDP access. For inbound access,
  open port 53. For outbound access, open the port that you're using for DNS queries on your
  network. Some security group rules will cause your connection to be tracked. For outbound
  resolver endpoint, it can potentially impact the maximum queries per second from outbound
  endpoint to your target name server. For inbound resolver endpoint, it can bring down the
  overall maximum queries per second per IP address to as low as 1500. To avoid connection
  tracking caused by security group, see Untracked connections.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Name"`: A friendly name that lets you easily find a configuration in the Resolver
  dashboard in the Route 53 console.
- `"OutpostArn"`: The Amazon Resource Name (ARN) of the Outpost. If you specify this, you
  must also specify a value for the PreferredInstanceType.
- `"PreferredInstanceType"`: The instance type. If you specify this, you must also specify
  a value for the OutpostArn.
- `"Protocols"`:  The protocols you want to use for the endpoint. DoH-FIPS is applicable
  for inbound endpoints only.  For an inbound endpoint you can apply the protocols as
  follows:    Do53 and DoH in combination.   Do53 and DoH-FIPS in combination.   Do53 alone.
   DoH alone.   DoH-FIPS alone.   None, which is treated as Do53.   For an outbound endpoint
  you can apply the protocols as follows:    Do53 and DoH in combination.   Do53 alone.   DoH
  alone.   None, which is treated as Do53.
- `"ResolverEndpointType"`:  For the endpoint type you can choose either IPv4, IPv6, or
  dual-stack. A dual-stack endpoint means that it will resolve via both IPv4 and IPv6. This
  endpoint type is applied to all IP addresses.
- `"Tags"`: A list of the tag keys and values that you want to associate with the endpoint.
"""
function create_resolver_endpoint(
    CreatorRequestId,
    Direction,
    IpAddresses,
    SecurityGroupIds;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53resolver(
        "CreateResolverEndpoint",
        Dict{String,Any}(
            "CreatorRequestId" => CreatorRequestId,
            "Direction" => Direction,
            "IpAddresses" => IpAddresses,
            "SecurityGroupIds" => SecurityGroupIds,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_resolver_endpoint(
    CreatorRequestId,
    Direction,
    IpAddresses,
    SecurityGroupIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53resolver(
        "CreateResolverEndpoint",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CreatorRequestId" => CreatorRequestId,
                    "Direction" => Direction,
                    "IpAddresses" => IpAddresses,
                    "SecurityGroupIds" => SecurityGroupIds,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_resolver_query_log_config(creator_request_id, destination_arn, name)
    create_resolver_query_log_config(creator_request_id, destination_arn, name, params::Dict{String,<:Any})

Creates a Resolver query logging configuration, which defines where you want Resolver to
save DNS query logs that originate in your VPCs. Resolver can log queries only for VPCs
that are in the same Region as the query logging configuration. To specify which VPCs you
want to log queries for, you use AssociateResolverQueryLogConfig. For more information, see
AssociateResolverQueryLogConfig.  You can optionally use Resource Access Manager (RAM) to
share a query logging configuration with other Amazon Web Services accounts. The other
accounts can then associate VPCs with the configuration. The query logs that Resolver
creates for a configuration include all DNS queries that originate in all VPCs that are
associated with the configuration.

# Arguments
- `creator_request_id`: A unique string that identifies the request and that allows failed
  requests to be retried without the risk of running the operation twice. CreatorRequestId
  can be any unique string, for example, a date/time stamp.
- `destination_arn`: The ARN of the resource that you want Resolver to send query logs. You
  can send query logs to an S3 bucket, a CloudWatch Logs log group, or a Kinesis Data
  Firehose delivery stream. Examples of valid values include the following:    S3 bucket:
  arn:aws:s3:::examplebucket  You can optionally append a file prefix to the end of the ARN.
  arn:aws:s3:::examplebucket/development/     CloudWatch Logs log group:
  arn:aws:logs:us-west-1:123456789012:log-group:/mystack-testgroup-12ABC1AB12A1:*     Kinesis
  Data Firehose delivery stream:  arn:aws:kinesis:us-east-2:0123456789:stream/my_stream_name
  
- `name`: The name that you want to give the query logging configuration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: A list of the tag keys and values that you want to associate with the query
  logging configuration.
"""
function create_resolver_query_log_config(
    CreatorRequestId,
    DestinationArn,
    Name;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53resolver(
        "CreateResolverQueryLogConfig",
        Dict{String,Any}(
            "CreatorRequestId" => CreatorRequestId,
            "DestinationArn" => DestinationArn,
            "Name" => Name,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_resolver_query_log_config(
    CreatorRequestId,
    DestinationArn,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53resolver(
        "CreateResolverQueryLogConfig",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CreatorRequestId" => CreatorRequestId,
                    "DestinationArn" => DestinationArn,
                    "Name" => Name,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_resolver_rule(creator_request_id, rule_type)
    create_resolver_rule(creator_request_id, rule_type, params::Dict{String,<:Any})

For DNS queries that originate in your VPCs, specifies which Resolver endpoint the queries
pass through, one domain name that you want to forward to your network, and the IP
addresses of the DNS resolvers in your network.

# Arguments
- `creator_request_id`: A unique string that identifies the request and that allows failed
  requests to be retried without the risk of running the operation twice. CreatorRequestId
  can be any unique string, for example, a date/time stamp.
- `rule_type`: When you want to forward DNS queries for specified domain name to resolvers
  on your network, specify FORWARD. When you have a forwarding rule to forward DNS queries
  for a domain to your network and you want Resolver to process queries for a subdomain of
  that domain, specify SYSTEM. For example, to forward DNS queries for example.com to
  resolvers on your network, you create a rule and specify FORWARD for RuleType. To then have
  Resolver process queries for apex.example.com, you create a rule and specify SYSTEM for
  RuleType. Currently, only Resolver can create rules that have a value of RECURSIVE for
  RuleType.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DomainName"`: DNS queries for this domain name are forwarded to the IP addresses that
  you specify in TargetIps. If a query matches multiple Resolver rules (example.com and
  www.example.com), outbound DNS queries are routed using the Resolver rule that contains the
  most specific domain name (www.example.com).
- `"Name"`: A friendly name that lets you easily find a rule in the Resolver dashboard in
  the Route 53 console.
- `"ResolverEndpointId"`: The ID of the outbound Resolver endpoint that you want to use to
  route DNS queries to the IP addresses that you specify in TargetIps.
- `"Tags"`: A list of the tag keys and values that you want to associate with the endpoint.
- `"TargetIps"`: The IPs that you want Resolver to forward DNS queries to. You can specify
  either Ipv4 or Ipv6 addresses but not both in the same rule. Separate IP addresses with a
  space.  TargetIps is available only when the value of Rule type is FORWARD.
"""
function create_resolver_rule(
    CreatorRequestId, RuleType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "CreateResolverRule",
        Dict{String,Any}("CreatorRequestId" => CreatorRequestId, "RuleType" => RuleType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_resolver_rule(
    CreatorRequestId,
    RuleType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53resolver(
        "CreateResolverRule",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CreatorRequestId" => CreatorRequestId, "RuleType" => RuleType
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_firewall_domain_list(firewall_domain_list_id)
    delete_firewall_domain_list(firewall_domain_list_id, params::Dict{String,<:Any})

Deletes the specified domain list.

# Arguments
- `firewall_domain_list_id`: The ID of the domain list that you want to delete.

"""
function delete_firewall_domain_list(
    FirewallDomainListId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "DeleteFirewallDomainList",
        Dict{String,Any}("FirewallDomainListId" => FirewallDomainListId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_firewall_domain_list(
    FirewallDomainListId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53resolver(
        "DeleteFirewallDomainList",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("FirewallDomainListId" => FirewallDomainListId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_firewall_rule(firewall_domain_list_id, firewall_rule_group_id)
    delete_firewall_rule(firewall_domain_list_id, firewall_rule_group_id, params::Dict{String,<:Any})

Deletes the specified firewall rule.

# Arguments
- `firewall_domain_list_id`: The ID of the domain list that's used in the rule.
- `firewall_rule_group_id`: The unique identifier of the firewall rule group that you want
  to delete the rule from.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Qtype"`:  The DNS query type that the rule you are deleting evaluates. Allowed values
  are;     A: Returns an IPv4 address.   AAAA: Returns an Ipv6 address.   CAA: Restricts CAs
  that can create SSL/TLS certifications for the domain.   CNAME: Returns another domain
  name.   DS: Record that identifies the DNSSEC signing key of a delegated zone.   MX:
  Specifies mail servers.   NAPTR: Regular-expression-based rewriting of domain names.   NS:
  Authoritative name servers.   PTR: Maps an IP address to a domain name.   SOA: Start of
  authority record for the zone.   SPF: Lists the servers authorized to send emails from a
  domain.   SRV: Application specific values that identify servers.   TXT: Verifies email
  senders and application-specific values.   A query type you define by using the DNS type
  ID, for example 28 for AAAA. The values must be defined as TYPENUMBER, where the NUMBER can
  be 1-65334, for example, TYPE28. For more information, see List of DNS record types.
"""
function delete_firewall_rule(
    FirewallDomainListId,
    FirewallRuleGroupId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53resolver(
        "DeleteFirewallRule",
        Dict{String,Any}(
            "FirewallDomainListId" => FirewallDomainListId,
            "FirewallRuleGroupId" => FirewallRuleGroupId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_firewall_rule(
    FirewallDomainListId,
    FirewallRuleGroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53resolver(
        "DeleteFirewallRule",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "FirewallDomainListId" => FirewallDomainListId,
                    "FirewallRuleGroupId" => FirewallRuleGroupId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_firewall_rule_group(firewall_rule_group_id)
    delete_firewall_rule_group(firewall_rule_group_id, params::Dict{String,<:Any})

Deletes the specified firewall rule group.

# Arguments
- `firewall_rule_group_id`: The unique identifier of the firewall rule group that you want
  to delete.

"""
function delete_firewall_rule_group(
    FirewallRuleGroupId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "DeleteFirewallRuleGroup",
        Dict{String,Any}("FirewallRuleGroupId" => FirewallRuleGroupId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_firewall_rule_group(
    FirewallRuleGroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53resolver(
        "DeleteFirewallRuleGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("FirewallRuleGroupId" => FirewallRuleGroupId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_outpost_resolver(id)
    delete_outpost_resolver(id, params::Dict{String,<:Any})

Deletes a Resolver on the Outpost.

# Arguments
- `id`: A unique string that identifies the Resolver on the Outpost.

"""
function delete_outpost_resolver(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return route53resolver(
        "DeleteOutpostResolver",
        Dict{String,Any}("Id" => Id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_outpost_resolver(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "DeleteOutpostResolver",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Id" => Id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_resolver_endpoint(resolver_endpoint_id)
    delete_resolver_endpoint(resolver_endpoint_id, params::Dict{String,<:Any})

Deletes a Resolver endpoint. The effect of deleting a Resolver endpoint depends on whether
it's an inbound or an outbound Resolver endpoint:    Inbound: DNS queries from your network
are no longer routed to the DNS service for the specified VPC.    Outbound: DNS queries
from a VPC are no longer routed to your network.

# Arguments
- `resolver_endpoint_id`: The ID of the Resolver endpoint that you want to delete.

"""
function delete_resolver_endpoint(
    ResolverEndpointId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "DeleteResolverEndpoint",
        Dict{String,Any}("ResolverEndpointId" => ResolverEndpointId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_resolver_endpoint(
    ResolverEndpointId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53resolver(
        "DeleteResolverEndpoint",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ResolverEndpointId" => ResolverEndpointId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_resolver_query_log_config(resolver_query_log_config_id)
    delete_resolver_query_log_config(resolver_query_log_config_id, params::Dict{String,<:Any})

Deletes a query logging configuration. When you delete a configuration, Resolver stops
logging DNS queries for all of the Amazon VPCs that are associated with the configuration.
This also applies if the query logging configuration is shared with other Amazon Web
Services accounts, and the other accounts have associated VPCs with the shared
configuration. Before you can delete a query logging configuration, you must first
disassociate all VPCs from the configuration. See DisassociateResolverQueryLogConfig. If
you used Resource Access Manager (RAM) to share a query logging configuration with other
accounts, you must stop sharing the configuration before you can delete a configuration.
The accounts that you shared the configuration with can first disassociate VPCs that they
associated with the configuration, but that's not necessary. If you stop sharing the
configuration, those VPCs are automatically disassociated from the configuration.

# Arguments
- `resolver_query_log_config_id`: The ID of the query logging configuration that you want
  to delete.

"""
function delete_resolver_query_log_config(
    ResolverQueryLogConfigId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "DeleteResolverQueryLogConfig",
        Dict{String,Any}("ResolverQueryLogConfigId" => ResolverQueryLogConfigId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_resolver_query_log_config(
    ResolverQueryLogConfigId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53resolver(
        "DeleteResolverQueryLogConfig",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResolverQueryLogConfigId" => ResolverQueryLogConfigId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_resolver_rule(resolver_rule_id)
    delete_resolver_rule(resolver_rule_id, params::Dict{String,<:Any})

Deletes a Resolver rule. Before you can delete a Resolver rule, you must disassociate it
from all the VPCs that you associated the Resolver rule with. For more information, see
DisassociateResolverRule.

# Arguments
- `resolver_rule_id`: The ID of the Resolver rule that you want to delete.

"""
function delete_resolver_rule(
    ResolverRuleId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "DeleteResolverRule",
        Dict{String,Any}("ResolverRuleId" => ResolverRuleId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_resolver_rule(
    ResolverRuleId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53resolver(
        "DeleteResolverRule",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResolverRuleId" => ResolverRuleId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_firewall_rule_group(firewall_rule_group_association_id)
    disassociate_firewall_rule_group(firewall_rule_group_association_id, params::Dict{String,<:Any})

Disassociates a FirewallRuleGroup from a VPC, to remove DNS filtering from the VPC.

# Arguments
- `firewall_rule_group_association_id`: The identifier of the FirewallRuleGroupAssociation.

"""
function disassociate_firewall_rule_group(
    FirewallRuleGroupAssociationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "DisassociateFirewallRuleGroup",
        Dict{String,Any}(
            "FirewallRuleGroupAssociationId" => FirewallRuleGroupAssociationId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_firewall_rule_group(
    FirewallRuleGroupAssociationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53resolver(
        "DisassociateFirewallRuleGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "FirewallRuleGroupAssociationId" => FirewallRuleGroupAssociationId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_resolver_endpoint_ip_address(ip_address, resolver_endpoint_id)
    disassociate_resolver_endpoint_ip_address(ip_address, resolver_endpoint_id, params::Dict{String,<:Any})

Removes IP addresses from an inbound or an outbound Resolver endpoint. If you want to
remove more than one IP address, submit one DisassociateResolverEndpointIpAddress request
for each IP address. To add an IP address to an endpoint, see
AssociateResolverEndpointIpAddress.

# Arguments
- `ip_address`: The IPv4 address that you want to remove from a Resolver endpoint.
- `resolver_endpoint_id`: The ID of the Resolver endpoint that you want to disassociate an
  IP address from.

"""
function disassociate_resolver_endpoint_ip_address(
    IpAddress, ResolverEndpointId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "DisassociateResolverEndpointIpAddress",
        Dict{String,Any}(
            "IpAddress" => IpAddress, "ResolverEndpointId" => ResolverEndpointId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_resolver_endpoint_ip_address(
    IpAddress,
    ResolverEndpointId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53resolver(
        "DisassociateResolverEndpointIpAddress",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "IpAddress" => IpAddress, "ResolverEndpointId" => ResolverEndpointId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_resolver_query_log_config(resolver_query_log_config_id, resource_id)
    disassociate_resolver_query_log_config(resolver_query_log_config_id, resource_id, params::Dict{String,<:Any})

Disassociates a VPC from a query logging configuration.  Before you can delete a query
logging configuration, you must first disassociate all VPCs from the configuration. If you
used Resource Access Manager (RAM) to share a query logging configuration with other
accounts, VPCs can be disassociated from the configuration in the following ways:   The
accounts that you shared the configuration with can disassociate VPCs from the
configuration.   You can stop sharing the configuration.

# Arguments
- `resolver_query_log_config_id`: The ID of the query logging configuration that you want
  to disassociate a specified VPC from.
- `resource_id`: The ID of the Amazon VPC that you want to disassociate from a specified
  query logging configuration.

"""
function disassociate_resolver_query_log_config(
    ResolverQueryLogConfigId, ResourceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "DisassociateResolverQueryLogConfig",
        Dict{String,Any}(
            "ResolverQueryLogConfigId" => ResolverQueryLogConfigId,
            "ResourceId" => ResourceId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_resolver_query_log_config(
    ResolverQueryLogConfigId,
    ResourceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53resolver(
        "DisassociateResolverQueryLogConfig",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ResolverQueryLogConfigId" => ResolverQueryLogConfigId,
                    "ResourceId" => ResourceId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_resolver_rule(resolver_rule_id, vpcid)
    disassociate_resolver_rule(resolver_rule_id, vpcid, params::Dict{String,<:Any})

Removes the association between a specified Resolver rule and a specified VPC.  If you
disassociate a Resolver rule from a VPC, Resolver stops forwarding DNS queries for the
domain name that you specified in the Resolver rule.

# Arguments
- `resolver_rule_id`: The ID of the Resolver rule that you want to disassociate from the
  specified VPC.
- `vpcid`: The ID of the VPC that you want to disassociate the Resolver rule from.

"""
function disassociate_resolver_rule(
    ResolverRuleId, VPCId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "DisassociateResolverRule",
        Dict{String,Any}("ResolverRuleId" => ResolverRuleId, "VPCId" => VPCId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_resolver_rule(
    ResolverRuleId,
    VPCId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53resolver(
        "DisassociateResolverRule",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResolverRuleId" => ResolverRuleId, "VPCId" => VPCId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_firewall_config(resource_id)
    get_firewall_config(resource_id, params::Dict{String,<:Any})

Retrieves the configuration of the firewall behavior provided by DNS Firewall for a single
VPC from Amazon Virtual Private Cloud (Amazon VPC).

# Arguments
- `resource_id`: The ID of the VPC from Amazon VPC that the configuration is for.

"""
function get_firewall_config(ResourceId; aws_config::AbstractAWSConfig=current_aws_config())
    return route53resolver(
        "GetFirewallConfig",
        Dict{String,Any}("ResourceId" => ResourceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_firewall_config(
    ResourceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53resolver(
        "GetFirewallConfig",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceId" => ResourceId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_firewall_domain_list(firewall_domain_list_id)
    get_firewall_domain_list(firewall_domain_list_id, params::Dict{String,<:Any})

Retrieves the specified firewall domain list.

# Arguments
- `firewall_domain_list_id`: The ID of the domain list.

"""
function get_firewall_domain_list(
    FirewallDomainListId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "GetFirewallDomainList",
        Dict{String,Any}("FirewallDomainListId" => FirewallDomainListId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_firewall_domain_list(
    FirewallDomainListId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53resolver(
        "GetFirewallDomainList",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("FirewallDomainListId" => FirewallDomainListId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_firewall_rule_group(firewall_rule_group_id)
    get_firewall_rule_group(firewall_rule_group_id, params::Dict{String,<:Any})

Retrieves the specified firewall rule group.

# Arguments
- `firewall_rule_group_id`: The unique identifier of the firewall rule group.

"""
function get_firewall_rule_group(
    FirewallRuleGroupId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "GetFirewallRuleGroup",
        Dict{String,Any}("FirewallRuleGroupId" => FirewallRuleGroupId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_firewall_rule_group(
    FirewallRuleGroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53resolver(
        "GetFirewallRuleGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("FirewallRuleGroupId" => FirewallRuleGroupId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_firewall_rule_group_association(firewall_rule_group_association_id)
    get_firewall_rule_group_association(firewall_rule_group_association_id, params::Dict{String,<:Any})

Retrieves a firewall rule group association, which enables DNS filtering for a VPC with one
rule group. A VPC can have more than one firewall rule group association, and a rule group
can be associated with more than one VPC.

# Arguments
- `firewall_rule_group_association_id`: The identifier of the FirewallRuleGroupAssociation.

"""
function get_firewall_rule_group_association(
    FirewallRuleGroupAssociationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "GetFirewallRuleGroupAssociation",
        Dict{String,Any}(
            "FirewallRuleGroupAssociationId" => FirewallRuleGroupAssociationId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_firewall_rule_group_association(
    FirewallRuleGroupAssociationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53resolver(
        "GetFirewallRuleGroupAssociation",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "FirewallRuleGroupAssociationId" => FirewallRuleGroupAssociationId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_firewall_rule_group_policy(arn)
    get_firewall_rule_group_policy(arn, params::Dict{String,<:Any})

Returns the Identity and Access Management (Amazon Web Services IAM) policy for sharing the
specified rule group. You can use the policy to share the rule group using Resource Access
Manager (RAM).

# Arguments
- `arn`: The ARN (Amazon Resource Name) for the rule group.

"""
function get_firewall_rule_group_policy(
    Arn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "GetFirewallRuleGroupPolicy",
        Dict{String,Any}("Arn" => Arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_firewall_rule_group_policy(
    Arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "GetFirewallRuleGroupPolicy",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Arn" => Arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_outpost_resolver(id)
    get_outpost_resolver(id, params::Dict{String,<:Any})

Gets information about a specified Resolver on the Outpost, such as its instance count and
type, name, and the current status of the Resolver.

# Arguments
- `id`: The ID of the Resolver on the Outpost.

"""
function get_outpost_resolver(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return route53resolver(
        "GetOutpostResolver",
        Dict{String,Any}("Id" => Id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_outpost_resolver(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "GetOutpostResolver",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Id" => Id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_resolver_config(resource_id)
    get_resolver_config(resource_id, params::Dict{String,<:Any})

Retrieves the behavior configuration of Route 53 Resolver behavior for a single VPC from
Amazon Virtual Private Cloud.

# Arguments
- `resource_id`: Resource ID of the Amazon VPC that you want to get information about.

"""
function get_resolver_config(ResourceId; aws_config::AbstractAWSConfig=current_aws_config())
    return route53resolver(
        "GetResolverConfig",
        Dict{String,Any}("ResourceId" => ResourceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_resolver_config(
    ResourceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53resolver(
        "GetResolverConfig",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceId" => ResourceId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_resolver_dnssec_config(resource_id)
    get_resolver_dnssec_config(resource_id, params::Dict{String,<:Any})

Gets DNSSEC validation information for a specified resource.

# Arguments
- `resource_id`: The ID of the virtual private cloud (VPC) for the DNSSEC validation status.

"""
function get_resolver_dnssec_config(
    ResourceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "GetResolverDnssecConfig",
        Dict{String,Any}("ResourceId" => ResourceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_resolver_dnssec_config(
    ResourceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53resolver(
        "GetResolverDnssecConfig",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceId" => ResourceId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_resolver_endpoint(resolver_endpoint_id)
    get_resolver_endpoint(resolver_endpoint_id, params::Dict{String,<:Any})

Gets information about a specified Resolver endpoint, such as whether it's an inbound or an
outbound Resolver endpoint, and the current status of the endpoint.

# Arguments
- `resolver_endpoint_id`: The ID of the Resolver endpoint that you want to get information
  about.

"""
function get_resolver_endpoint(
    ResolverEndpointId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "GetResolverEndpoint",
        Dict{String,Any}("ResolverEndpointId" => ResolverEndpointId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_resolver_endpoint(
    ResolverEndpointId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53resolver(
        "GetResolverEndpoint",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ResolverEndpointId" => ResolverEndpointId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_resolver_query_log_config(resolver_query_log_config_id)
    get_resolver_query_log_config(resolver_query_log_config_id, params::Dict{String,<:Any})

Gets information about a specified Resolver query logging configuration, such as the number
of VPCs that the configuration is logging queries for and the location that logs are sent
to.

# Arguments
- `resolver_query_log_config_id`: The ID of the Resolver query logging configuration that
  you want to get information about.

"""
function get_resolver_query_log_config(
    ResolverQueryLogConfigId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "GetResolverQueryLogConfig",
        Dict{String,Any}("ResolverQueryLogConfigId" => ResolverQueryLogConfigId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_resolver_query_log_config(
    ResolverQueryLogConfigId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53resolver(
        "GetResolverQueryLogConfig",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResolverQueryLogConfigId" => ResolverQueryLogConfigId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_resolver_query_log_config_association(resolver_query_log_config_association_id)
    get_resolver_query_log_config_association(resolver_query_log_config_association_id, params::Dict{String,<:Any})

Gets information about a specified association between a Resolver query logging
configuration and an Amazon VPC. When you associate a VPC with a query logging
configuration, Resolver logs DNS queries that originate in that VPC.

# Arguments
- `resolver_query_log_config_association_id`: The ID of the Resolver query logging
  configuration association that you want to get information about.

"""
function get_resolver_query_log_config_association(
    ResolverQueryLogConfigAssociationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "GetResolverQueryLogConfigAssociation",
        Dict{String,Any}(
            "ResolverQueryLogConfigAssociationId" => ResolverQueryLogConfigAssociationId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_resolver_query_log_config_association(
    ResolverQueryLogConfigAssociationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53resolver(
        "GetResolverQueryLogConfigAssociation",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ResolverQueryLogConfigAssociationId" =>
                        ResolverQueryLogConfigAssociationId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_resolver_query_log_config_policy(arn)
    get_resolver_query_log_config_policy(arn, params::Dict{String,<:Any})

Gets information about a query logging policy. A query logging policy specifies the
Resolver query logging operations and resources that you want to allow another Amazon Web
Services account to be able to use.

# Arguments
- `arn`: The ARN of the query logging configuration that you want to get the query logging
  policy for.

"""
function get_resolver_query_log_config_policy(
    Arn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "GetResolverQueryLogConfigPolicy",
        Dict{String,Any}("Arn" => Arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_resolver_query_log_config_policy(
    Arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "GetResolverQueryLogConfigPolicy",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Arn" => Arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_resolver_rule(resolver_rule_id)
    get_resolver_rule(resolver_rule_id, params::Dict{String,<:Any})

Gets information about a specified Resolver rule, such as the domain name that the rule
forwards DNS queries for and the ID of the outbound Resolver endpoint that the rule is
associated with.

# Arguments
- `resolver_rule_id`: The ID of the Resolver rule that you want to get information about.

"""
function get_resolver_rule(
    ResolverRuleId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "GetResolverRule",
        Dict{String,Any}("ResolverRuleId" => ResolverRuleId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_resolver_rule(
    ResolverRuleId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53resolver(
        "GetResolverRule",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResolverRuleId" => ResolverRuleId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_resolver_rule_association(resolver_rule_association_id)
    get_resolver_rule_association(resolver_rule_association_id, params::Dict{String,<:Any})

Gets information about an association between a specified Resolver rule and a VPC. You
associate a Resolver rule and a VPC using AssociateResolverRule.

# Arguments
- `resolver_rule_association_id`: The ID of the Resolver rule association that you want to
  get information about.

"""
function get_resolver_rule_association(
    ResolverRuleAssociationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "GetResolverRuleAssociation",
        Dict{String,Any}("ResolverRuleAssociationId" => ResolverRuleAssociationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_resolver_rule_association(
    ResolverRuleAssociationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53resolver(
        "GetResolverRuleAssociation",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResolverRuleAssociationId" => ResolverRuleAssociationId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_resolver_rule_policy(arn)
    get_resolver_rule_policy(arn, params::Dict{String,<:Any})

Gets information about the Resolver rule policy for a specified rule. A Resolver rule
policy includes the rule that you want to share with another account, the account that you
want to share the rule with, and the Resolver operations that you want to allow the account
to use.

# Arguments
- `arn`: The ID of the Resolver rule that you want to get the Resolver rule policy for.

"""
function get_resolver_rule_policy(Arn; aws_config::AbstractAWSConfig=current_aws_config())
    return route53resolver(
        "GetResolverRulePolicy",
        Dict{String,Any}("Arn" => Arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_resolver_rule_policy(
    Arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "GetResolverRulePolicy",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Arn" => Arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    import_firewall_domains(domain_file_url, firewall_domain_list_id, operation)
    import_firewall_domains(domain_file_url, firewall_domain_list_id, operation, params::Dict{String,<:Any})

Imports domain names from a file into a domain list, for use in a DNS firewall rule group.
Each domain specification in your domain list must satisfy the following requirements:
It can optionally start with * (asterisk).   With the exception of the optional starting
asterisk, it must only contain the following characters: A-Z, a-z, 0-9, - (hyphen).   It
must be from 1-255 characters in length.

# Arguments
- `domain_file_url`: The fully qualified URL or URI of the file stored in Amazon Simple
  Storage Service (Amazon S3) that contains the list of domains to import. The file must be
  in an S3 bucket that's in the same Region as your DNS Firewall. The file must be a text
  file and must contain a single domain per line.
- `firewall_domain_list_id`: The ID of the domain list that you want to modify with the
  import operation.
- `operation`: What you want DNS Firewall to do with the domains that are listed in the
  file. This must be set to REPLACE, which updates the domain list to exactly match the list
  in the file.

"""
function import_firewall_domains(
    DomainFileUrl,
    FirewallDomainListId,
    Operation;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53resolver(
        "ImportFirewallDomains",
        Dict{String,Any}(
            "DomainFileUrl" => DomainFileUrl,
            "FirewallDomainListId" => FirewallDomainListId,
            "Operation" => Operation,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function import_firewall_domains(
    DomainFileUrl,
    FirewallDomainListId,
    Operation,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53resolver(
        "ImportFirewallDomains",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DomainFileUrl" => DomainFileUrl,
                    "FirewallDomainListId" => FirewallDomainListId,
                    "Operation" => Operation,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_firewall_configs()
    list_firewall_configs(params::Dict{String,<:Any})

Retrieves the firewall configurations that you have defined. DNS Firewall uses the
configurations to manage firewall behavior for your VPCs.  A single call might return only
a partial list of the configurations. For information, see MaxResults.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of objects that you want Resolver to return for this
  request. If more objects are available, in the response, Resolver provides a NextToken
  value that you can use in a subsequent call to get the next batch of objects. If you don't
  specify a value for MaxResults, Resolver returns up to 100 objects.
- `"NextToken"`: For the first call to this list request, omit this value. When you request
  a list of objects, Resolver returns at most the number of objects specified in MaxResults.
  If more objects are available for retrieval, Resolver returns a NextToken value in the
  response. To retrieve the next batch of objects, use the token that was returned for the
  prior request in your next request.
"""
function list_firewall_configs(; aws_config::AbstractAWSConfig=current_aws_config())
    return route53resolver(
        "ListFirewallConfigs"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_firewall_configs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "ListFirewallConfigs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_firewall_domain_lists()
    list_firewall_domain_lists(params::Dict{String,<:Any})

Retrieves the firewall domain lists that you have defined. For each firewall domain list,
you can retrieve the domains that are defined for a list by calling ListFirewallDomains.  A
single call to this list operation might return only a partial list of the domain lists.
For information, see MaxResults.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of objects that you want Resolver to return for this
  request. If more objects are available, in the response, Resolver provides a NextToken
  value that you can use in a subsequent call to get the next batch of objects. If you don't
  specify a value for MaxResults, Resolver returns up to 100 objects.
- `"NextToken"`: For the first call to this list request, omit this value. When you request
  a list of objects, Resolver returns at most the number of objects specified in MaxResults.
  If more objects are available for retrieval, Resolver returns a NextToken value in the
  response. To retrieve the next batch of objects, use the token that was returned for the
  prior request in your next request.
"""
function list_firewall_domain_lists(; aws_config::AbstractAWSConfig=current_aws_config())
    return route53resolver(
        "ListFirewallDomainLists"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_firewall_domain_lists(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "ListFirewallDomainLists",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_firewall_domains(firewall_domain_list_id)
    list_firewall_domains(firewall_domain_list_id, params::Dict{String,<:Any})

Retrieves the domains that you have defined for the specified firewall domain list.  A
single call might return only a partial list of the domains. For information, see
MaxResults.

# Arguments
- `firewall_domain_list_id`: The ID of the domain list whose domains you want to retrieve.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of objects that you want Resolver to return for this
  request. If more objects are available, in the response, Resolver provides a NextToken
  value that you can use in a subsequent call to get the next batch of objects. If you don't
  specify a value for MaxResults, Resolver returns up to 100 objects.
- `"NextToken"`: For the first call to this list request, omit this value. When you request
  a list of objects, Resolver returns at most the number of objects specified in MaxResults.
  If more objects are available for retrieval, Resolver returns a NextToken value in the
  response. To retrieve the next batch of objects, use the token that was returned for the
  prior request in your next request.
"""
function list_firewall_domains(
    FirewallDomainListId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "ListFirewallDomains",
        Dict{String,Any}("FirewallDomainListId" => FirewallDomainListId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_firewall_domains(
    FirewallDomainListId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53resolver(
        "ListFirewallDomains",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("FirewallDomainListId" => FirewallDomainListId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_firewall_rule_group_associations()
    list_firewall_rule_group_associations(params::Dict{String,<:Any})

Retrieves the firewall rule group associations that you have defined. Each association
enables DNS filtering for a VPC with one rule group.  A single call might return only a
partial list of the associations. For information, see MaxResults.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FirewallRuleGroupId"`: The unique identifier of the firewall rule group that you want
  to retrieve the associations for. Leave this blank to retrieve associations for any rule
  group.
- `"MaxResults"`: The maximum number of objects that you want Resolver to return for this
  request. If more objects are available, in the response, Resolver provides a NextToken
  value that you can use in a subsequent call to get the next batch of objects. If you don't
  specify a value for MaxResults, Resolver returns up to 100 objects.
- `"NextToken"`: For the first call to this list request, omit this value. When you request
  a list of objects, Resolver returns at most the number of objects specified in MaxResults.
  If more objects are available for retrieval, Resolver returns a NextToken value in the
  response. To retrieve the next batch of objects, use the token that was returned for the
  prior request in your next request.
- `"Priority"`: The setting that determines the processing order of the rule group among
  the rule groups that are associated with a single VPC. DNS Firewall filters VPC traffic
  starting from the rule group with the lowest numeric priority setting.
- `"Status"`: The association Status setting that you want DNS Firewall to filter on for
  the list. If you don't specify this, then DNS Firewall returns all associations, regardless
  of status.
- `"VpcId"`: The unique identifier of the VPC that you want to retrieve the associations
  for. Leave this blank to retrieve associations for any VPC.
"""
function list_firewall_rule_group_associations(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "ListFirewallRuleGroupAssociations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_firewall_rule_group_associations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "ListFirewallRuleGroupAssociations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_firewall_rule_groups()
    list_firewall_rule_groups(params::Dict{String,<:Any})

Retrieves the minimal high-level information for the rule groups that you have defined.  A
single call might return only a partial list of the rule groups. For information, see
MaxResults.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of objects that you want Resolver to return for this
  request. If more objects are available, in the response, Resolver provides a NextToken
  value that you can use in a subsequent call to get the next batch of objects. If you don't
  specify a value for MaxResults, Resolver returns up to 100 objects.
- `"NextToken"`: For the first call to this list request, omit this value. When you request
  a list of objects, Resolver returns at most the number of objects specified in MaxResults.
  If more objects are available for retrieval, Resolver returns a NextToken value in the
  response. To retrieve the next batch of objects, use the token that was returned for the
  prior request in your next request.
"""
function list_firewall_rule_groups(; aws_config::AbstractAWSConfig=current_aws_config())
    return route53resolver(
        "ListFirewallRuleGroups"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_firewall_rule_groups(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "ListFirewallRuleGroups",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_firewall_rules(firewall_rule_group_id)
    list_firewall_rules(firewall_rule_group_id, params::Dict{String,<:Any})

Retrieves the firewall rules that you have defined for the specified firewall rule group.
DNS Firewall uses the rules in a rule group to filter DNS network traffic for a VPC.  A
single call might return only a partial list of the rules. For information, see MaxResults.

# Arguments
- `firewall_rule_group_id`: The unique identifier of the firewall rule group that you want
  to retrieve the rules for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Action"`: Optional additional filter for the rules to retrieve. The action that DNS
  Firewall should take on a DNS query when it matches one of the domains in the rule's domain
  list:    ALLOW - Permit the request to go through.    ALERT - Permit the request to go
  through but send an alert to the logs.    BLOCK - Disallow the request. If this is
  specified, additional handling details are provided in the rule's BlockResponse setting.
- `"MaxResults"`: The maximum number of objects that you want Resolver to return for this
  request. If more objects are available, in the response, Resolver provides a NextToken
  value that you can use in a subsequent call to get the next batch of objects. If you don't
  specify a value for MaxResults, Resolver returns up to 100 objects.
- `"NextToken"`: For the first call to this list request, omit this value. When you request
  a list of objects, Resolver returns at most the number of objects specified in MaxResults.
  If more objects are available for retrieval, Resolver returns a NextToken value in the
  response. To retrieve the next batch of objects, use the token that was returned for the
  prior request in your next request.
- `"Priority"`: Optional additional filter for the rules to retrieve. The setting that
  determines the processing order of the rules in a rule group. DNS Firewall processes the
  rules in a rule group by order of priority, starting from the lowest setting.
"""
function list_firewall_rules(
    FirewallRuleGroupId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "ListFirewallRules",
        Dict{String,Any}("FirewallRuleGroupId" => FirewallRuleGroupId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_firewall_rules(
    FirewallRuleGroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53resolver(
        "ListFirewallRules",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("FirewallRuleGroupId" => FirewallRuleGroupId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_outpost_resolvers()
    list_outpost_resolvers(params::Dict{String,<:Any})

Lists all the Resolvers on Outposts that were created using the current Amazon Web Services
account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of Resolvers on the Outpost that you want to return in
  the response to a ListOutpostResolver request. If you don't specify a value for MaxResults,
  the request returns up to 100 Resolvers.
- `"NextToken"`: For the first ListOutpostResolver request, omit this value.
- `"OutpostArn"`: The Amazon Resource Name (ARN) of the Outpost.
"""
function list_outpost_resolvers(; aws_config::AbstractAWSConfig=current_aws_config())
    return route53resolver(
        "ListOutpostResolvers"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_outpost_resolvers(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "ListOutpostResolvers",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_resolver_configs()
    list_resolver_configs(params::Dict{String,<:Any})

Retrieves the Resolver configurations that you have defined. Route 53 Resolver uses the
configurations to manage DNS resolution behavior for your VPCs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of Resolver configurations that you want to return in
  the response to a ListResolverConfigs request. If you don't specify a value for MaxResults,
  up to 100 Resolver configurations are returned.
- `"NextToken"`: (Optional) If the current Amazon Web Services account has more than
  MaxResults Resolver configurations, use NextToken to get the second and subsequent pages of
  results. For the first ListResolverConfigs request, omit this value. For the second and
  subsequent requests, get the value of NextToken from the previous response and specify that
  value for NextToken in the request.
"""
function list_resolver_configs(; aws_config::AbstractAWSConfig=current_aws_config())
    return route53resolver(
        "ListResolverConfigs"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_resolver_configs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "ListResolverConfigs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_resolver_dnssec_configs()
    list_resolver_dnssec_configs(params::Dict{String,<:Any})

Lists the configurations for DNSSEC validation that are associated with the current Amazon
Web Services account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: An optional specification to return a subset of objects.
- `"MaxResults"`:  Optional: An integer that specifies the maximum number of DNSSEC
  configuration results that you want Amazon Route 53 to return. If you don't specify a value
  for MaxResults, Route 53 returns up to 100 configuration per page.
- `"NextToken"`: (Optional) If the current Amazon Web Services account has more than
  MaxResults DNSSEC configurations, use NextToken to get the second and subsequent pages of
  results. For the first ListResolverDnssecConfigs request, omit this value. For the second
  and subsequent requests, get the value of NextToken from the previous response and specify
  that value for NextToken in the request.
"""
function list_resolver_dnssec_configs(; aws_config::AbstractAWSConfig=current_aws_config())
    return route53resolver(
        "ListResolverDnssecConfigs"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_resolver_dnssec_configs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "ListResolverDnssecConfigs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_resolver_endpoint_ip_addresses(resolver_endpoint_id)
    list_resolver_endpoint_ip_addresses(resolver_endpoint_id, params::Dict{String,<:Any})

Gets the IP addresses for a specified Resolver endpoint.

# Arguments
- `resolver_endpoint_id`: The ID of the Resolver endpoint that you want to get IP addresses
  for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of IP addresses that you want to return in the
  response to a ListResolverEndpointIpAddresses request. If you don't specify a value for
  MaxResults, Resolver returns up to 100 IP addresses.
- `"NextToken"`: For the first ListResolverEndpointIpAddresses request, omit this value. If
  the specified Resolver endpoint has more than MaxResults IP addresses, you can submit
  another ListResolverEndpointIpAddresses request to get the next group of IP addresses. In
  the next request, specify the value of NextToken from the previous response.
"""
function list_resolver_endpoint_ip_addresses(
    ResolverEndpointId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "ListResolverEndpointIpAddresses",
        Dict{String,Any}("ResolverEndpointId" => ResolverEndpointId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_resolver_endpoint_ip_addresses(
    ResolverEndpointId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53resolver(
        "ListResolverEndpointIpAddresses",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ResolverEndpointId" => ResolverEndpointId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_resolver_endpoints()
    list_resolver_endpoints(params::Dict{String,<:Any})

Lists all the Resolver endpoints that were created using the current Amazon Web Services
account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: An optional specification to return a subset of Resolver endpoints, such as
  all inbound Resolver endpoints.  If you submit a second or subsequent ListResolverEndpoints
  request and specify the NextToken parameter, you must use the same values for Filters, if
  any, as in the previous request.
- `"MaxResults"`: The maximum number of Resolver endpoints that you want to return in the
  response to a ListResolverEndpoints request. If you don't specify a value for MaxResults,
  Resolver returns up to 100 Resolver endpoints.
- `"NextToken"`: For the first ListResolverEndpoints request, omit this value. If you have
  more than MaxResults Resolver endpoints, you can submit another ListResolverEndpoints
  request to get the next group of Resolver endpoints. In the next request, specify the value
  of NextToken from the previous response.
"""
function list_resolver_endpoints(; aws_config::AbstractAWSConfig=current_aws_config())
    return route53resolver(
        "ListResolverEndpoints"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_resolver_endpoints(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "ListResolverEndpoints",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_resolver_query_log_config_associations()
    list_resolver_query_log_config_associations(params::Dict{String,<:Any})

Lists information about associations between Amazon VPCs and query logging configurations.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: An optional specification to return a subset of query logging associations.
  If you submit a second or subsequent ListResolverQueryLogConfigAssociations request and
  specify the NextToken parameter, you must use the same values for Filters, if any, as in
  the previous request.
- `"MaxResults"`: The maximum number of query logging associations that you want to return
  in the response to a ListResolverQueryLogConfigAssociations request. If you don't specify a
  value for MaxResults, Resolver returns up to 100 query logging associations.
- `"NextToken"`: For the first ListResolverQueryLogConfigAssociations request, omit this
  value. If there are more than MaxResults query logging associations that match the values
  that you specify for Filters, you can submit another ListResolverQueryLogConfigAssociations
  request to get the next group of associations. In the next request, specify the value of
  NextToken from the previous response.
- `"SortBy"`: The element that you want Resolver to sort query logging associations by.
  If you submit a second or subsequent ListResolverQueryLogConfigAssociations request and
  specify the NextToken parameter, you must use the same value for SortBy, if any, as in the
  previous request.  Valid values include the following elements:    CreationTime: The ID of
  the query logging association.    Error: If the value of Status is FAILED, the value of
  Error indicates the cause:     DESTINATION_NOT_FOUND: The specified destination (for
  example, an Amazon S3 bucket) was deleted.    ACCESS_DENIED: Permissions don't allow
  sending logs to the destination.   If Status is a value other than FAILED, ERROR is null.
   Id: The ID of the query logging association    ResolverQueryLogConfigId: The ID of the
  query logging configuration    ResourceId: The ID of the VPC that is associated with the
  query logging configuration    Status: The current status of the configuration. Valid
  values include the following:    CREATING: Resolver is creating an association between an
  Amazon VPC and a query logging configuration.    CREATED: The association between an Amazon
  VPC and a query logging configuration was successfully created. Resolver is logging queries
  that originate in the specified VPC.    DELETING: Resolver is deleting this query logging
  association.    FAILED: Resolver either couldn't create or couldn't delete the query
  logging association. Here are two common causes:   The specified destination (for example,
  an Amazon S3 bucket) was deleted.   Permissions don't allow sending logs to the
  destination.
- `"SortOrder"`: If you specified a value for SortBy, the order that you want query logging
  associations to be listed in, ASCENDING or DESCENDING.  If you submit a second or
  subsequent ListResolverQueryLogConfigAssociations request and specify the NextToken
  parameter, you must use the same value for SortOrder, if any, as in the previous request.
"""
function list_resolver_query_log_config_associations(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "ListResolverQueryLogConfigAssociations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_resolver_query_log_config_associations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "ListResolverQueryLogConfigAssociations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_resolver_query_log_configs()
    list_resolver_query_log_configs(params::Dict{String,<:Any})

Lists information about the specified query logging configurations. Each configuration
defines where you want Resolver to save DNS query logs and specifies the VPCs that you want
to log queries for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: An optional specification to return a subset of query logging
  configurations.  If you submit a second or subsequent ListResolverQueryLogConfigs request
  and specify the NextToken parameter, you must use the same values for Filters, if any, as
  in the previous request.
- `"MaxResults"`: The maximum number of query logging configurations that you want to
  return in the response to a ListResolverQueryLogConfigs request. If you don't specify a
  value for MaxResults, Resolver returns up to 100 query logging configurations.
- `"NextToken"`: For the first ListResolverQueryLogConfigs request, omit this value. If
  there are more than MaxResults query logging configurations that match the values that you
  specify for Filters, you can submit another ListResolverQueryLogConfigs request to get the
  next group of configurations. In the next request, specify the value of NextToken from the
  previous response.
- `"SortBy"`: The element that you want Resolver to sort query logging configurations by.
  If you submit a second or subsequent ListResolverQueryLogConfigs request and specify the
  NextToken parameter, you must use the same value for SortBy, if any, as in the previous
  request.  Valid values include the following elements:    Arn: The ARN of the query logging
  configuration    AssociationCount: The number of VPCs that are associated with the
  specified configuration     CreationTime: The date and time that Resolver returned when the
  configuration was created    CreatorRequestId: The value that was specified for
  CreatorRequestId when the configuration was created    DestinationArn: The location that
  logs are sent to    Id: The ID of the configuration    Name: The name of the configuration
    OwnerId: The Amazon Web Services account number of the account that created the
  configuration    ShareStatus: Whether the configuration is shared with other Amazon Web
  Services accounts or shared with the current account by another Amazon Web Services
  account. Sharing is configured through Resource Access Manager (RAM).    Status: The
  current status of the configuration. Valid values include the following:    CREATING:
  Resolver is creating the query logging configuration.    CREATED: The query logging
  configuration was successfully created. Resolver is logging queries that originate in the
  specified VPC.    DELETING: Resolver is deleting this query logging configuration.
  FAILED: Resolver either couldn't create or couldn't delete the query logging configuration.
  Here are two common causes:   The specified destination (for example, an Amazon S3 bucket)
  was deleted.   Permissions don't allow sending logs to the destination.
- `"SortOrder"`: If you specified a value for SortBy, the order that you want query logging
  configurations to be listed in, ASCENDING or DESCENDING.  If you submit a second or
  subsequent ListResolverQueryLogConfigs request and specify the NextToken parameter, you
  must use the same value for SortOrder, if any, as in the previous request.
"""
function list_resolver_query_log_configs(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "ListResolverQueryLogConfigs";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_resolver_query_log_configs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "ListResolverQueryLogConfigs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_resolver_rule_associations()
    list_resolver_rule_associations(params::Dict{String,<:Any})

Lists the associations that were created between Resolver rules and VPCs using the current
Amazon Web Services account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: An optional specification to return a subset of Resolver rules, such as
  Resolver rules that are associated with the same VPC ID.  If you submit a second or
  subsequent ListResolverRuleAssociations request and specify the NextToken parameter, you
  must use the same values for Filters, if any, as in the previous request.
- `"MaxResults"`: The maximum number of rule associations that you want to return in the
  response to a ListResolverRuleAssociations request. If you don't specify a value for
  MaxResults, Resolver returns up to 100 rule associations.
- `"NextToken"`: For the first ListResolverRuleAssociation request, omit this value. If you
  have more than MaxResults rule associations, you can submit another
  ListResolverRuleAssociation request to get the next group of rule associations. In the next
  request, specify the value of NextToken from the previous response.
"""
function list_resolver_rule_associations(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "ListResolverRuleAssociations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_resolver_rule_associations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "ListResolverRuleAssociations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_resolver_rules()
    list_resolver_rules(params::Dict{String,<:Any})

Lists the Resolver rules that were created using the current Amazon Web Services account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: An optional specification to return a subset of Resolver rules, such as all
  Resolver rules that are associated with the same Resolver endpoint.  If you submit a second
  or subsequent ListResolverRules request and specify the NextToken parameter, you must use
  the same values for Filters, if any, as in the previous request.
- `"MaxResults"`: The maximum number of Resolver rules that you want to return in the
  response to a ListResolverRules request. If you don't specify a value for MaxResults,
  Resolver returns up to 100 Resolver rules.
- `"NextToken"`: For the first ListResolverRules request, omit this value. If you have more
  than MaxResults Resolver rules, you can submit another ListResolverRules request to get the
  next group of Resolver rules. In the next request, specify the value of NextToken from the
  previous response.
"""
function list_resolver_rules(; aws_config::AbstractAWSConfig=current_aws_config())
    return route53resolver(
        "ListResolverRules"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_resolver_rules(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "ListResolverRules", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists the tags that you associated with the specified resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) for the resource that you want to list
  tags for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of tags that you want to return in the response to a
  ListTagsForResource request. If you don't specify a value for MaxResults, Resolver returns
  up to 100 tags.
- `"NextToken"`: For the first ListTagsForResource request, omit this value. If you have
  more than MaxResults tags, you can submit another ListTagsForResource request to get the
  next group of tags for the resource. In the next request, specify the value of NextToken
  from the previous response.
"""
function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "ListTagsForResource",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53resolver(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_firewall_rule_group_policy(arn, firewall_rule_group_policy)
    put_firewall_rule_group_policy(arn, firewall_rule_group_policy, params::Dict{String,<:Any})

Attaches an Identity and Access Management (Amazon Web Services IAM) policy for sharing the
rule group. You can use the policy to share the rule group using Resource Access Manager
(RAM).

# Arguments
- `arn`: The ARN (Amazon Resource Name) for the rule group that you want to share.
- `firewall_rule_group_policy`: The Identity and Access Management (Amazon Web Services
  IAM) policy to attach to the rule group.

"""
function put_firewall_rule_group_policy(
    Arn, FirewallRuleGroupPolicy; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "PutFirewallRuleGroupPolicy",
        Dict{String,Any}(
            "Arn" => Arn, "FirewallRuleGroupPolicy" => FirewallRuleGroupPolicy
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_firewall_rule_group_policy(
    Arn,
    FirewallRuleGroupPolicy,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53resolver(
        "PutFirewallRuleGroupPolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Arn" => Arn, "FirewallRuleGroupPolicy" => FirewallRuleGroupPolicy
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_resolver_query_log_config_policy(arn, resolver_query_log_config_policy)
    put_resolver_query_log_config_policy(arn, resolver_query_log_config_policy, params::Dict{String,<:Any})

Specifies an Amazon Web Services account that you want to share a query logging
configuration with, the query logging configuration that you want to share, and the
operations that you want the account to be able to perform on the configuration.

# Arguments
- `arn`: The Amazon Resource Name (ARN) of the account that you want to share rules with.
- `resolver_query_log_config_policy`: An Identity and Access Management policy statement
  that lists the query logging configurations that you want to share with another Amazon Web
  Services account and the operations that you want the account to be able to perform. You
  can specify the following operations in the Actions section of the statement:
  route53resolver:AssociateResolverQueryLogConfig
  route53resolver:DisassociateResolverQueryLogConfig
  route53resolver:ListResolverQueryLogConfigs    In the Resource section of the statement,
  you specify the ARNs for the query logging configurations that you want to share with the
  account that you specified in Arn.

"""
function put_resolver_query_log_config_policy(
    Arn, ResolverQueryLogConfigPolicy; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "PutResolverQueryLogConfigPolicy",
        Dict{String,Any}(
            "Arn" => Arn, "ResolverQueryLogConfigPolicy" => ResolverQueryLogConfigPolicy
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_resolver_query_log_config_policy(
    Arn,
    ResolverQueryLogConfigPolicy,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53resolver(
        "PutResolverQueryLogConfigPolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Arn" => Arn,
                    "ResolverQueryLogConfigPolicy" => ResolverQueryLogConfigPolicy,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_resolver_rule_policy(arn, resolver_rule_policy)
    put_resolver_rule_policy(arn, resolver_rule_policy, params::Dict{String,<:Any})

Specifies an Amazon Web Services rule that you want to share with another account, the
account that you want to share the rule with, and the operations that you want the account
to be able to perform on the rule.

# Arguments
- `arn`: The Amazon Resource Name (ARN) of the rule that you want to share with another
  account.
- `resolver_rule_policy`: An Identity and Access Management policy statement that lists the
  rules that you want to share with another Amazon Web Services account and the operations
  that you want the account to be able to perform. You can specify the following operations
  in the Action section of the statement:    route53resolver:GetResolverRule
  route53resolver:AssociateResolverRule     route53resolver:DisassociateResolverRule
  route53resolver:ListResolverRules     route53resolver:ListResolverRuleAssociations    In
  the Resource section of the statement, specify the ARN for the rule that you want to share
  with another account. Specify the same ARN that you specified in Arn.

"""
function put_resolver_rule_policy(
    Arn, ResolverRulePolicy; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "PutResolverRulePolicy",
        Dict{String,Any}("Arn" => Arn, "ResolverRulePolicy" => ResolverRulePolicy);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_resolver_rule_policy(
    Arn,
    ResolverRulePolicy,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53resolver(
        "PutResolverRulePolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Arn" => Arn, "ResolverRulePolicy" => ResolverRulePolicy),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds one or more tags to a specified resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) for the resource that you want to add tags
  to. To get the ARN for a resource, use the applicable Get or List command:
  GetResolverEndpoint     GetResolverRule     GetResolverRuleAssociation
  ListResolverEndpoints     ListResolverRuleAssociations     ListResolverRules
- `tags`: The tags that you want to add to the specified resource.

"""
function tag_resource(ResourceArn, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return route53resolver(
        "TagResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceArn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53resolver(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes one or more tags from a specified resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) for the resource that you want to remove
  tags from. To get the ARN for a resource, use the applicable Get or List command:
  GetResolverEndpoint     GetResolverRule     GetResolverRuleAssociation
  ListResolverEndpoints     ListResolverRuleAssociations     ListResolverRules
- `tag_keys`: The tags that you want to remove to the specified resource.

"""
function untag_resource(
    ResourceArn, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "UntagResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceArn,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53resolver(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_firewall_config(firewall_fail_open, resource_id)
    update_firewall_config(firewall_fail_open, resource_id, params::Dict{String,<:Any})

Updates the configuration of the firewall behavior provided by DNS Firewall for a single
VPC from Amazon Virtual Private Cloud (Amazon VPC).

# Arguments
- `firewall_fail_open`: Determines how Route 53 Resolver handles queries during failures,
  for example when all traffic that is sent to DNS Firewall fails to receive a reply.    By
  default, fail open is disabled, which means the failure mode is closed. This approach
  favors security over availability. DNS Firewall blocks queries that it is unable to
  evaluate properly.    If you enable this option, the failure mode is open. This approach
  favors availability over security. DNS Firewall allows queries to proceed if it is unable
  to properly evaluate them.    This behavior is only enforced for VPCs that have at least
  one DNS Firewall rule group association.
- `resource_id`: The ID of the VPC that the configuration is for.

"""
function update_firewall_config(
    FirewallFailOpen, ResourceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "UpdateFirewallConfig",
        Dict{String,Any}(
            "FirewallFailOpen" => FirewallFailOpen, "ResourceId" => ResourceId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_firewall_config(
    FirewallFailOpen,
    ResourceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53resolver(
        "UpdateFirewallConfig",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "FirewallFailOpen" => FirewallFailOpen, "ResourceId" => ResourceId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_firewall_domains(domains, firewall_domain_list_id, operation)
    update_firewall_domains(domains, firewall_domain_list_id, operation, params::Dict{String,<:Any})

Updates the firewall domain list from an array of domain specifications.

# Arguments
- `domains`: A list of domains to use in the update operation.  There is a limit of 1000
  domains per request.  Each domain specification in your domain list must satisfy the
  following requirements:    It can optionally start with * (asterisk).   With the exception
  of the optional starting asterisk, it must only contain the following characters: A-Z, a-z,
  0-9, - (hyphen).   It must be from 1-255 characters in length.
- `firewall_domain_list_id`: The ID of the domain list whose domains you want to update.
- `operation`: What you want DNS Firewall to do with the domains that you are providing:
   ADD - Add the domains to the ones that are already in the domain list.     REMOVE - Search
  the domain list for the domains and remove them from the list.    REPLACE - Update the
  domain list to exactly match the list that you are providing.

"""
function update_firewall_domains(
    Domains,
    FirewallDomainListId,
    Operation;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53resolver(
        "UpdateFirewallDomains",
        Dict{String,Any}(
            "Domains" => Domains,
            "FirewallDomainListId" => FirewallDomainListId,
            "Operation" => Operation,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_firewall_domains(
    Domains,
    FirewallDomainListId,
    Operation,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53resolver(
        "UpdateFirewallDomains",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Domains" => Domains,
                    "FirewallDomainListId" => FirewallDomainListId,
                    "Operation" => Operation,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_firewall_rule(firewall_domain_list_id, firewall_rule_group_id)
    update_firewall_rule(firewall_domain_list_id, firewall_rule_group_id, params::Dict{String,<:Any})

Updates the specified firewall rule.

# Arguments
- `firewall_domain_list_id`: The ID of the domain list to use in the rule.
- `firewall_rule_group_id`: The unique identifier of the firewall rule group for the rule.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Action"`: The action that DNS Firewall should take on a DNS query when it matches one
  of the domains in the rule's domain list:    ALLOW - Permit the request to go through.
  ALERT - Permit the request to go through but send an alert to the logs.    BLOCK - Disallow
  the request. This option requires additional details in the rule's BlockResponse.
- `"BlockOverrideDnsType"`: The DNS record's type. This determines the format of the record
  value that you provided in BlockOverrideDomain. Used for the rule action BLOCK with a
  BlockResponse setting of OVERRIDE.
- `"BlockOverrideDomain"`: The custom DNS record to send back in response to the query.
  Used for the rule action BLOCK with a BlockResponse setting of OVERRIDE.
- `"BlockOverrideTtl"`: The recommended amount of time, in seconds, for the DNS resolver or
  web browser to cache the provided override record. Used for the rule action BLOCK with a
  BlockResponse setting of OVERRIDE.
- `"BlockResponse"`: The way that you want DNS Firewall to block the request. Used for the
  rule action setting BLOCK.    NODATA - Respond indicating that the query was successful,
  but no response is available for it.    NXDOMAIN - Respond indicating that the domain name
  that's in the query doesn't exist.    OVERRIDE - Provide a custom override in the response.
  This option requires custom handling details in the rule's BlockOverride* settings.
- `"FirewallDomainRedirectionAction"`:  How you want the the rule to evaluate DNS
  redirection in the DNS redirection chain, such as CNAME or DNAME.
  Inspect_Redirection_Domain (Default) inspects all domains in the redirection chain. The
  individual domains in the redirection chain must be added to the domain list.
  Trust_Redirection_Domain  inspects only the first domain in the redirection chain. You
  don't need to add the subsequent domains in the domain in the redirection list to the
  domain list.
- `"Name"`: The name of the rule.
- `"Priority"`: The setting that determines the processing order of the rule in the rule
  group. DNS Firewall processes the rules in a rule group by order of priority, starting from
  the lowest setting. You must specify a unique priority for each rule in a rule group. To
  make it easier to insert rules later, leave space between the numbers, for example, use
  100, 200, and so on. You can change the priority setting for the rules in a rule group at
  any time.
- `"Qtype"`:  The DNS query type you want the rule to evaluate. Allowed values are;     A:
  Returns an IPv4 address.   AAAA: Returns an Ipv6 address.   CAA: Restricts CAs that can
  create SSL/TLS certifications for the domain.   CNAME: Returns another domain name.   DS:
  Record that identifies the DNSSEC signing key of a delegated zone.   MX: Specifies mail
  servers.   NAPTR: Regular-expression-based rewriting of domain names.   NS: Authoritative
  name servers.   PTR: Maps an IP address to a domain name.   SOA: Start of authority record
  for the zone.   SPF: Lists the servers authorized to send emails from a domain.   SRV:
  Application specific values that identify servers.   TXT: Verifies email senders and
  application-specific values.   A query type you define by using the DNS type ID, for
  example 28 for AAAA. The values must be defined as TYPENUMBER, where the NUMBER can be
  1-65334, for example, TYPE28. For more information, see List of DNS record types.
"""
function update_firewall_rule(
    FirewallDomainListId,
    FirewallRuleGroupId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53resolver(
        "UpdateFirewallRule",
        Dict{String,Any}(
            "FirewallDomainListId" => FirewallDomainListId,
            "FirewallRuleGroupId" => FirewallRuleGroupId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_firewall_rule(
    FirewallDomainListId,
    FirewallRuleGroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53resolver(
        "UpdateFirewallRule",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "FirewallDomainListId" => FirewallDomainListId,
                    "FirewallRuleGroupId" => FirewallRuleGroupId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_firewall_rule_group_association(firewall_rule_group_association_id)
    update_firewall_rule_group_association(firewall_rule_group_association_id, params::Dict{String,<:Any})

Changes the association of a FirewallRuleGroup with a VPC. The association enables DNS
filtering for the VPC.

# Arguments
- `firewall_rule_group_association_id`: The identifier of the FirewallRuleGroupAssociation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MutationProtection"`: If enabled, this setting disallows modification or removal of the
  association, to help prevent against accidentally altering DNS firewall protections.
- `"Name"`: The name of the rule group association.
- `"Priority"`: The setting that determines the processing order of the rule group among
  the rule groups that you associate with the specified VPC. DNS Firewall filters VPC traffic
  starting from the rule group with the lowest numeric priority setting.  You must specify a
  unique priority for each rule group that you associate with a single VPC. To make it easier
  to insert rule groups later, leave space between the numbers, for example, use 100, 200,
  and so on. You can change the priority setting for a rule group association after you
  create it.
"""
function update_firewall_rule_group_association(
    FirewallRuleGroupAssociationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "UpdateFirewallRuleGroupAssociation",
        Dict{String,Any}(
            "FirewallRuleGroupAssociationId" => FirewallRuleGroupAssociationId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_firewall_rule_group_association(
    FirewallRuleGroupAssociationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53resolver(
        "UpdateFirewallRuleGroupAssociation",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "FirewallRuleGroupAssociationId" => FirewallRuleGroupAssociationId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_outpost_resolver(id)
    update_outpost_resolver(id, params::Dict{String,<:Any})

You can use UpdateOutpostResolver to update the instance count, type, or name of a Resolver
on an Outpost.

# Arguments
- `id`: A unique string that identifies Resolver on an Outpost.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"InstanceCount"`: The Amazon EC2 instance count for a Resolver on the Outpost.
- `"Name"`: Name of the Resolver on the Outpost.
- `"PreferredInstanceType"`:  Amazon EC2 instance type.
"""
function update_outpost_resolver(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return route53resolver(
        "UpdateOutpostResolver",
        Dict{String,Any}("Id" => Id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_outpost_resolver(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "UpdateOutpostResolver",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Id" => Id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_resolver_config(autodefined_reverse_flag, resource_id)
    update_resolver_config(autodefined_reverse_flag, resource_id, params::Dict{String,<:Any})

Updates the behavior configuration of Route 53 Resolver behavior for a single VPC from
Amazon Virtual Private Cloud.

# Arguments
- `autodefined_reverse_flag`: Indicates whether or not the Resolver will create autodefined
  rules for reverse DNS lookups. This is enabled by default. Disabling this option will also
  affect EC2-Classic instances using ClassicLink. For more information, see ClassicLink in
  the Amazon EC2 guide.  We are retiring EC2-Classic on August 15, 2022. We recommend that
  you migrate from EC2-Classic to a VPC. For more information, see Migrate from EC2-Classic
  to a VPC in the Amazon EC2 guide and the blog EC2-Classic Networking is Retiring –
  Here’s How to Prepare.   It can take some time for the status change to be completed.
- `resource_id`: Resource ID of the Amazon VPC that you want to update the Resolver
  configuration for.

"""
function update_resolver_config(
    AutodefinedReverseFlag, ResourceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "UpdateResolverConfig",
        Dict{String,Any}(
            "AutodefinedReverseFlag" => AutodefinedReverseFlag, "ResourceId" => ResourceId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_resolver_config(
    AutodefinedReverseFlag,
    ResourceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53resolver(
        "UpdateResolverConfig",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AutodefinedReverseFlag" => AutodefinedReverseFlag,
                    "ResourceId" => ResourceId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_resolver_dnssec_config(resource_id, validation)
    update_resolver_dnssec_config(resource_id, validation, params::Dict{String,<:Any})

Updates an existing DNSSEC validation configuration. If there is no existing DNSSEC
validation configuration, one is created.

# Arguments
- `resource_id`: The ID of the virtual private cloud (VPC) that you're updating the DNSSEC
  validation status for.
- `validation`: The new value that you are specifying for DNSSEC validation for the VPC.
  The value can be ENABLE or DISABLE. Be aware that it can take time for a validation status
  change to be completed.

"""
function update_resolver_dnssec_config(
    ResourceId, Validation; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "UpdateResolverDnssecConfig",
        Dict{String,Any}("ResourceId" => ResourceId, "Validation" => Validation);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_resolver_dnssec_config(
    ResourceId,
    Validation,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53resolver(
        "UpdateResolverDnssecConfig",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceId" => ResourceId, "Validation" => Validation),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_resolver_endpoint(resolver_endpoint_id)
    update_resolver_endpoint(resolver_endpoint_id, params::Dict{String,<:Any})

Updates the name, or endpoint type for an inbound or an outbound Resolver endpoint. You can
only update between IPV4 and DUALSTACK, IPV6 endpoint type can't be updated to other type.

# Arguments
- `resolver_endpoint_id`: The ID of the Resolver endpoint that you want to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Name"`: The name of the Resolver endpoint that you want to update.
- `"Protocols"`:  The protocols you want to use for the endpoint. DoH-FIPS is applicable
  for inbound endpoints only.  For an inbound endpoint you can apply the protocols as
  follows:    Do53 and DoH in combination.   Do53 and DoH-FIPS in combination.   Do53 alone.
   DoH alone.   DoH-FIPS alone.   None, which is treated as Do53.   For an outbound endpoint
  you can apply the protocols as follows:    Do53 and DoH in combination.   Do53 alone.   DoH
  alone.   None, which is treated as Do53.     You can't change the protocol of an inbound
  endpoint directly from only Do53 to only DoH, or DoH-FIPS. This is to prevent a sudden
  disruption to incoming traffic that relies on Do53. To change the protocol from Do53 to
  DoH, or DoH-FIPS, you must first enable both Do53 and DoH, or Do53 and DoH-FIPS, to make
  sure that all incoming traffic has transferred to using the DoH protocol, or DoH-FIPS, and
  then remove the Do53.
- `"ResolverEndpointType"`:  Specifies the endpoint type for what type of IP address the
  endpoint uses to forward DNS queries.  Updating to IPV6 type isn't currently supported.
- `"UpdateIpAddresses"`:  Specifies the IPv6 address when you update the Resolver endpoint
  from IPv4 to dual-stack. If you don't specify an IPv6 address, one will be automatically
  chosen from your subnet.
"""
function update_resolver_endpoint(
    ResolverEndpointId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "UpdateResolverEndpoint",
        Dict{String,Any}("ResolverEndpointId" => ResolverEndpointId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_resolver_endpoint(
    ResolverEndpointId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53resolver(
        "UpdateResolverEndpoint",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ResolverEndpointId" => ResolverEndpointId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_resolver_rule(config, resolver_rule_id)
    update_resolver_rule(config, resolver_rule_id, params::Dict{String,<:Any})

Updates settings for a specified Resolver rule. ResolverRuleId is required, and all other
parameters are optional. If you don't specify a parameter, it retains its current value.

# Arguments
- `config`: The new settings for the Resolver rule.
- `resolver_rule_id`: The ID of the Resolver rule that you want to update.

"""
function update_resolver_rule(
    Config, ResolverRuleId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53resolver(
        "UpdateResolverRule",
        Dict{String,Any}("Config" => Config, "ResolverRuleId" => ResolverRuleId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_resolver_rule(
    Config,
    ResolverRuleId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53resolver(
        "UpdateResolverRule",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Config" => Config, "ResolverRuleId" => ResolverRuleId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: inspector_scan
using AWS.Compat
using AWS.UUIDs

"""
    scan_sbom(sbom)
    scan_sbom(sbom, params::Dict{String,<:Any})

Scans a provided CycloneDX 1.5 SBOM and reports on any vulnerabilities discovered in that
SBOM. You can generate compatible SBOMs for your resources using the Amazon Inspector SBOM
generator.

# Arguments
- `sbom`: The JSON file for the SBOM you want to scan. The SBOM must be in CycloneDX 1.5
  format.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"outputFormat"`: The output format for the vulnerability report.
"""
function scan_sbom(sbom; aws_config::AbstractAWSConfig=current_aws_config())
    return inspector_scan(
        "POST",
        "/scan/sbom",
        Dict{String,Any}("sbom" => sbom);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function scan_sbom(
    sbom, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return inspector_scan(
        "POST",
        "/scan/sbom",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("sbom" => sbom), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: connectcampaigns
using AWS.Compat
using AWS.UUIDs

"""
    create_campaign(connect_instance_id, dialer_config, name, outbound_call_config)
    create_campaign(connect_instance_id, dialer_config, name, outbound_call_config, params::Dict{String,<:Any})

Creates a campaign for the specified Amazon Connect account. This API is idempotent.

# Arguments
- `connect_instance_id`:
- `dialer_config`:
- `name`:
- `outbound_call_config`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tags"`:
"""
function create_campaign(
    connectInstanceId,
    dialerConfig,
    name,
    outboundCallConfig;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return connectcampaigns(
        "PUT",
        "/campaigns",
        Dict{String,Any}(
            "connectInstanceId" => connectInstanceId,
            "dialerConfig" => dialerConfig,
            "name" => name,
            "outboundCallConfig" => outboundCallConfig,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_campaign(
    connectInstanceId,
    dialerConfig,
    name,
    outboundCallConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return connectcampaigns(
        "PUT",
        "/campaigns",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "connectInstanceId" => connectInstanceId,
                    "dialerConfig" => dialerConfig,
                    "name" => name,
                    "outboundCallConfig" => outboundCallConfig,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_campaign(id)
    delete_campaign(id, params::Dict{String,<:Any})

Deletes a campaign from the specified Amazon Connect account.

# Arguments
- `id`:

"""
function delete_campaign(id; aws_config::AbstractAWSConfig=current_aws_config())
    return connectcampaigns(
        "DELETE", "/campaigns/$(id)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function delete_campaign(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return connectcampaigns(
        "DELETE",
        "/campaigns/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_connect_instance_config(connect_instance_id)
    delete_connect_instance_config(connect_instance_id, params::Dict{String,<:Any})

Deletes a connect instance config from the specified AWS account.

# Arguments
- `connect_instance_id`:

"""
function delete_connect_instance_config(
    connectInstanceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return connectcampaigns(
        "DELETE",
        "/connect-instance/$(connectInstanceId)/config";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_connect_instance_config(
    connectInstanceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return connectcampaigns(
        "DELETE",
        "/connect-instance/$(connectInstanceId)/config",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_instance_onboarding_job(connect_instance_id)
    delete_instance_onboarding_job(connect_instance_id, params::Dict{String,<:Any})

Delete the Connect Campaigns onboarding job for the specified Amazon Connect instance.

# Arguments
- `connect_instance_id`:

"""
function delete_instance_onboarding_job(
    connectInstanceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return connectcampaigns(
        "DELETE",
        "/connect-instance/$(connectInstanceId)/onboarding";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_instance_onboarding_job(
    connectInstanceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return connectcampaigns(
        "DELETE",
        "/connect-instance/$(connectInstanceId)/onboarding",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_campaign(id)
    describe_campaign(id, params::Dict{String,<:Any})

Describes the specific campaign.

# Arguments
- `id`:

"""
function describe_campaign(id; aws_config::AbstractAWSConfig=current_aws_config())
    return connectcampaigns(
        "GET", "/campaigns/$(id)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_campaign(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return connectcampaigns(
        "GET",
        "/campaigns/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_campaign_state(id)
    get_campaign_state(id, params::Dict{String,<:Any})

Get state of a campaign for the specified Amazon Connect account.

# Arguments
- `id`:

"""
function get_campaign_state(id; aws_config::AbstractAWSConfig=current_aws_config())
    return connectcampaigns(
        "GET",
        "/campaigns/$(id)/state";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_campaign_state(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return connectcampaigns(
        "GET",
        "/campaigns/$(id)/state",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_campaign_state_batch(campaign_ids)
    get_campaign_state_batch(campaign_ids, params::Dict{String,<:Any})

Get state of campaigns for the specified Amazon Connect account.

# Arguments
- `campaign_ids`:

"""
function get_campaign_state_batch(
    campaignIds; aws_config::AbstractAWSConfig=current_aws_config()
)
    return connectcampaigns(
        "POST",
        "/campaigns-state",
        Dict{String,Any}("campaignIds" => campaignIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_campaign_state_batch(
    campaignIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return connectcampaigns(
        "POST",
        "/campaigns-state",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("campaignIds" => campaignIds), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_connect_instance_config(connect_instance_id)
    get_connect_instance_config(connect_instance_id, params::Dict{String,<:Any})

Get the specific Connect instance config.

# Arguments
- `connect_instance_id`:

"""
function get_connect_instance_config(
    connectInstanceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return connectcampaigns(
        "GET",
        "/connect-instance/$(connectInstanceId)/config";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_connect_instance_config(
    connectInstanceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return connectcampaigns(
        "GET",
        "/connect-instance/$(connectInstanceId)/config",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_instance_onboarding_job_status(connect_instance_id)
    get_instance_onboarding_job_status(connect_instance_id, params::Dict{String,<:Any})

Get the specific instance onboarding job status.

# Arguments
- `connect_instance_id`:

"""
function get_instance_onboarding_job_status(
    connectInstanceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return connectcampaigns(
        "GET",
        "/connect-instance/$(connectInstanceId)/onboarding";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_instance_onboarding_job_status(
    connectInstanceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return connectcampaigns(
        "GET",
        "/connect-instance/$(connectInstanceId)/onboarding",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_campaigns()
    list_campaigns(params::Dict{String,<:Any})

Provides summary information about the campaigns under the specified Amazon Connect account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`:
- `"maxResults"`:
- `"nextToken"`:
"""
function list_campaigns(; aws_config::AbstractAWSConfig=current_aws_config())
    return connectcampaigns(
        "POST", "/campaigns-summary"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_campaigns(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return connectcampaigns(
        "POST",
        "/campaigns-summary",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(arn)
    list_tags_for_resource(arn, params::Dict{String,<:Any})

List tags for a resource.

# Arguments
- `arn`:

"""
function list_tags_for_resource(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return connectcampaigns(
        "GET", "/tags/$(arn)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_tags_for_resource(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return connectcampaigns(
        "GET",
        "/tags/$(arn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    pause_campaign(id)
    pause_campaign(id, params::Dict{String,<:Any})

Pauses a campaign for the specified Amazon Connect account.

# Arguments
- `id`:

"""
function pause_campaign(id; aws_config::AbstractAWSConfig=current_aws_config())
    return connectcampaigns(
        "POST",
        "/campaigns/$(id)/pause";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function pause_campaign(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return connectcampaigns(
        "POST",
        "/campaigns/$(id)/pause",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_dial_request_batch(dial_requests, id)
    put_dial_request_batch(dial_requests, id, params::Dict{String,<:Any})

Creates dials requests for the specified campaign Amazon Connect account. This API is
idempotent.

# Arguments
- `dial_requests`:
- `id`:

"""
function put_dial_request_batch(
    dialRequests, id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return connectcampaigns(
        "PUT",
        "/campaigns/$(id)/dial-requests",
        Dict{String,Any}("dialRequests" => dialRequests);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_dial_request_batch(
    dialRequests,
    id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return connectcampaigns(
        "PUT",
        "/campaigns/$(id)/dial-requests",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("dialRequests" => dialRequests), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    resume_campaign(id)
    resume_campaign(id, params::Dict{String,<:Any})

Stops a campaign for the specified Amazon Connect account.

# Arguments
- `id`:

"""
function resume_campaign(id; aws_config::AbstractAWSConfig=current_aws_config())
    return connectcampaigns(
        "POST",
        "/campaigns/$(id)/resume";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function resume_campaign(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return connectcampaigns(
        "POST",
        "/campaigns/$(id)/resume",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_campaign(id)
    start_campaign(id, params::Dict{String,<:Any})

Starts a campaign for the specified Amazon Connect account.

# Arguments
- `id`:

"""
function start_campaign(id; aws_config::AbstractAWSConfig=current_aws_config())
    return connectcampaigns(
        "POST",
        "/campaigns/$(id)/start";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_campaign(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return connectcampaigns(
        "POST",
        "/campaigns/$(id)/start",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_instance_onboarding_job(connect_instance_id, encryption_config)
    start_instance_onboarding_job(connect_instance_id, encryption_config, params::Dict{String,<:Any})

Onboard the specific Amazon Connect instance to Connect Campaigns.

# Arguments
- `connect_instance_id`:
- `encryption_config`:

"""
function start_instance_onboarding_job(
    connectInstanceId, encryptionConfig; aws_config::AbstractAWSConfig=current_aws_config()
)
    return connectcampaigns(
        "PUT",
        "/connect-instance/$(connectInstanceId)/onboarding",
        Dict{String,Any}("encryptionConfig" => encryptionConfig);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_instance_onboarding_job(
    connectInstanceId,
    encryptionConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return connectcampaigns(
        "PUT",
        "/connect-instance/$(connectInstanceId)/onboarding",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("encryptionConfig" => encryptionConfig), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_campaign(id)
    stop_campaign(id, params::Dict{String,<:Any})

Stops a campaign for the specified Amazon Connect account.

# Arguments
- `id`:

"""
function stop_campaign(id; aws_config::AbstractAWSConfig=current_aws_config())
    return connectcampaigns(
        "POST",
        "/campaigns/$(id)/stop";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_campaign(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return connectcampaigns(
        "POST",
        "/campaigns/$(id)/stop",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(arn, tags)
    tag_resource(arn, tags, params::Dict{String,<:Any})

Tag a resource.

# Arguments
- `arn`:
- `tags`:

"""
function tag_resource(arn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return connectcampaigns(
        "POST",
        "/tags/$(arn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    arn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return connectcampaigns(
        "POST",
        "/tags/$(arn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(arn, tag_keys)
    untag_resource(arn, tag_keys, params::Dict{String,<:Any})

Untag a resource.

# Arguments
- `arn`:
- `tag_keys`:

"""
function untag_resource(arn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config())
    return connectcampaigns(
        "DELETE",
        "/tags/$(arn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    arn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return connectcampaigns(
        "DELETE",
        "/tags/$(arn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_campaign_dialer_config(dialer_config, id)
    update_campaign_dialer_config(dialer_config, id, params::Dict{String,<:Any})

Updates the dialer config of a campaign. This API is idempotent.

# Arguments
- `dialer_config`:
- `id`:

"""
function update_campaign_dialer_config(
    dialerConfig, id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return connectcampaigns(
        "POST",
        "/campaigns/$(id)/dialer-config",
        Dict{String,Any}("dialerConfig" => dialerConfig);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_campaign_dialer_config(
    dialerConfig,
    id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return connectcampaigns(
        "POST",
        "/campaigns/$(id)/dialer-config",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("dialerConfig" => dialerConfig), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_campaign_name(id, name)
    update_campaign_name(id, name, params::Dict{String,<:Any})

Updates the name of a campaign. This API is idempotent.

# Arguments
- `id`:
- `name`:

"""
function update_campaign_name(id, name; aws_config::AbstractAWSConfig=current_aws_config())
    return connectcampaigns(
        "POST",
        "/campaigns/$(id)/name",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_campaign_name(
    id,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return connectcampaigns(
        "POST",
        "/campaigns/$(id)/name",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_campaign_outbound_call_config(id)
    update_campaign_outbound_call_config(id, params::Dict{String,<:Any})

Updates the outbound call config of a campaign. This API is idempotent.

# Arguments
- `id`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"answerMachineDetectionConfig"`:
- `"connectContactFlowId"`:
- `"connectSourcePhoneNumber"`:
"""
function update_campaign_outbound_call_config(
    id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return connectcampaigns(
        "POST",
        "/campaigns/$(id)/outbound-call-config";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_campaign_outbound_call_config(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return connectcampaigns(
        "POST",
        "/campaigns/$(id)/outbound-call-config",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: rds_data
using AWS.Compat
using AWS.UUIDs

"""
    batch_execute_statement(resource_arn, secret_arn, sql)
    batch_execute_statement(resource_arn, secret_arn, sql, params::Dict{String,<:Any})

Runs a batch SQL statement over an array of data. You can run bulk update and insert
operations for multiple records using a DML statement with different parameter sets. Bulk
operations can provide a significant performance improvement over individual insert and
update operations.  If a call isn't part of a transaction because it doesn't include the
transactionID parameter, changes that result from the call are committed automatically.
There isn't a fixed upper limit on the number of parameter sets. However, the maximum size
of the HTTP request submitted through the Data API is 4 MiB. If the request exceeds this
limit, the Data API returns an error and doesn't process the request. This 4-MiB limit
includes the size of the HTTP headers and the JSON notation in the request. Thus, the
number of parameter sets that you can include depends on a combination of factors, such as
the size of the SQL statement and the size of each parameter set. The response size limit
is 1 MiB. If the call returns more than 1 MiB of response data, the call is terminated.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the Aurora Serverless DB cluster.
- `secret_arn`: The ARN of the secret that enables access to the DB cluster. Enter the
  database user name and password for the credentials in the secret. For information about
  creating the secret, see Create a database secret.
- `sql`: The SQL statement to run. Don't include a semicolon (;) at the end of the SQL
  statement.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"database"`: The name of the database.
- `"parameterSets"`: The parameter set for the batch operation. The SQL statement is
  executed as many times as the number of parameter sets provided. To execute a SQL statement
  with no parameters, use one of the following options:   Specify one or more empty parameter
  sets.   Use the ExecuteStatement operation instead of the BatchExecuteStatement operation.
    Array parameters are not supported.
- `"schema"`: The name of the database schema.  Currently, the schema parameter isn't
  supported.
- `"transactionId"`: The identifier of a transaction that was started by using the
  BeginTransaction operation. Specify the transaction ID of the transaction that you want to
  include the SQL statement in. If the SQL statement is not part of a transaction, don't set
  this parameter.
"""
function batch_execute_statement(
    resourceArn, secretArn, sql; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rds_data(
        "POST",
        "/BatchExecute",
        Dict{String,Any}(
            "resourceArn" => resourceArn, "secretArn" => secretArn, "sql" => sql
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_execute_statement(
    resourceArn,
    secretArn,
    sql,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rds_data(
        "POST",
        "/BatchExecute",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "resourceArn" => resourceArn, "secretArn" => secretArn, "sql" => sql
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    begin_transaction(resource_arn, secret_arn)
    begin_transaction(resource_arn, secret_arn, params::Dict{String,<:Any})

Starts a SQL transaction.  A transaction can run for a maximum of 24 hours. A transaction
is terminated and rolled back automatically after 24 hours. A transaction times out if no
calls use its transaction ID in three minutes. If a transaction times out before it's
committed, it's rolled back automatically. DDL statements inside a transaction cause an
implicit commit. We recommend that you run each DDL statement in a separate
ExecuteStatement call with continueAfterTimeout enabled.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the Aurora Serverless DB cluster.
- `secret_arn`: The name or ARN of the secret that enables access to the DB cluster.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"database"`: The name of the database.
- `"schema"`: The name of the database schema.
"""
function begin_transaction(
    resourceArn, secretArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rds_data(
        "POST",
        "/BeginTransaction",
        Dict{String,Any}("resourceArn" => resourceArn, "secretArn" => secretArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function begin_transaction(
    resourceArn,
    secretArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rds_data(
        "POST",
        "/BeginTransaction",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceArn" => resourceArn, "secretArn" => secretArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    commit_transaction(resource_arn, secret_arn, transaction_id)
    commit_transaction(resource_arn, secret_arn, transaction_id, params::Dict{String,<:Any})

Ends a SQL transaction started with the BeginTransaction operation and commits the changes.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the Aurora Serverless DB cluster.
- `secret_arn`: The name or ARN of the secret that enables access to the DB cluster.
- `transaction_id`: The identifier of the transaction to end and commit.

"""
function commit_transaction(
    resourceArn,
    secretArn,
    transactionId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rds_data(
        "POST",
        "/CommitTransaction",
        Dict{String,Any}(
            "resourceArn" => resourceArn,
            "secretArn" => secretArn,
            "transactionId" => transactionId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function commit_transaction(
    resourceArn,
    secretArn,
    transactionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rds_data(
        "POST",
        "/CommitTransaction",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "resourceArn" => resourceArn,
                    "secretArn" => secretArn,
                    "transactionId" => transactionId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    execute_sql(aws_secret_store_arn, db_cluster_or_instance_arn, sql_statements)
    execute_sql(aws_secret_store_arn, db_cluster_or_instance_arn, sql_statements, params::Dict{String,<:Any})

Runs one or more SQL statements.  This operation isn't supported for Aurora PostgreSQL
Serverless v2 and provisioned DB clusters, and for Aurora Serverless v1 DB clusters, the
operation is deprecated. Use the BatchExecuteStatement or ExecuteStatement operation.

# Arguments
- `aws_secret_store_arn`: The Amazon Resource Name (ARN) of the secret that enables access
  to the DB cluster. Enter the database user name and password for the credentials in the
  secret. For information about creating the secret, see Create a database secret.
- `db_cluster_or_instance_arn`: The ARN of the Aurora Serverless DB cluster.
- `sql_statements`: One or more SQL statements to run on the DB cluster. You can separate
  SQL statements from each other with a semicolon (;). Any valid SQL statement is permitted,
  including data definition, data manipulation, and commit statements.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"database"`: The name of the database.
- `"schema"`: The name of the database schema.
"""
function execute_sql(
    awsSecretStoreArn,
    dbClusterOrInstanceArn,
    sqlStatements;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rds_data(
        "POST",
        "/ExecuteSql",
        Dict{String,Any}(
            "awsSecretStoreArn" => awsSecretStoreArn,
            "dbClusterOrInstanceArn" => dbClusterOrInstanceArn,
            "sqlStatements" => sqlStatements,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function execute_sql(
    awsSecretStoreArn,
    dbClusterOrInstanceArn,
    sqlStatements,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rds_data(
        "POST",
        "/ExecuteSql",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "awsSecretStoreArn" => awsSecretStoreArn,
                    "dbClusterOrInstanceArn" => dbClusterOrInstanceArn,
                    "sqlStatements" => sqlStatements,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    execute_statement(resource_arn, secret_arn, sql)
    execute_statement(resource_arn, secret_arn, sql, params::Dict{String,<:Any})

Runs a SQL statement against a database.  If a call isn't part of a transaction because it
doesn't include the transactionID parameter, changes that result from the call are
committed automatically. If the binary response data from the database is more than 1 MB,
the call is terminated.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the Aurora Serverless DB cluster.
- `secret_arn`: The ARN of the secret that enables access to the DB cluster. Enter the
  database user name and password for the credentials in the secret. For information about
  creating the secret, see Create a database secret.
- `sql`: The SQL statement to run.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"continueAfterTimeout"`: A value that indicates whether to continue running the
  statement after the call times out. By default, the statement stops running when the call
  times out.  For DDL statements, we recommend continuing to run the statement after the call
  times out. When a DDL statement terminates before it is finished running, it can result in
  errors and possibly corrupted data structures.
- `"database"`: The name of the database.
- `"formatRecordsAs"`: A value that indicates whether to format the result set as a single
  JSON string. This parameter only applies to SELECT statements and is ignored for other
  types of statements. Allowed values are NONE and JSON. The default value is NONE. The
  result is returned in the formattedRecords field. For usage information about the JSON
  format for result sets, see Using the Data API in the Amazon Aurora User Guide.
- `"includeResultMetadata"`: A value that indicates whether to include metadata in the
  results.
- `"parameters"`: The parameters for the SQL statement.  Array parameters are not
  supported.
- `"resultSetOptions"`: Options that control how the result set is returned.
- `"schema"`: The name of the database schema.  Currently, the schema parameter isn't
  supported.
- `"transactionId"`: The identifier of a transaction that was started by using the
  BeginTransaction operation. Specify the transaction ID of the transaction that you want to
  include the SQL statement in. If the SQL statement is not part of a transaction, don't set
  this parameter.
"""
function execute_statement(
    resourceArn, secretArn, sql; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rds_data(
        "POST",
        "/Execute",
        Dict{String,Any}(
            "resourceArn" => resourceArn, "secretArn" => secretArn, "sql" => sql
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function execute_statement(
    resourceArn,
    secretArn,
    sql,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rds_data(
        "POST",
        "/Execute",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "resourceArn" => resourceArn, "secretArn" => secretArn, "sql" => sql
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    rollback_transaction(resource_arn, secret_arn, transaction_id)
    rollback_transaction(resource_arn, secret_arn, transaction_id, params::Dict{String,<:Any})

Performs a rollback of a transaction. Rolling back a transaction cancels its changes.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the Aurora Serverless DB cluster.
- `secret_arn`: The name or ARN of the secret that enables access to the DB cluster.
- `transaction_id`: The identifier of the transaction to roll back.

"""
function rollback_transaction(
    resourceArn,
    secretArn,
    transactionId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rds_data(
        "POST",
        "/RollbackTransaction",
        Dict{String,Any}(
            "resourceArn" => resourceArn,
            "secretArn" => secretArn,
            "transactionId" => transactionId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function rollback_transaction(
    resourceArn,
    secretArn,
    transactionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rds_data(
        "POST",
        "/RollbackTransaction",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "resourceArn" => resourceArn,
                    "secretArn" => secretArn,
                    "transactionId" => transactionId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: codeartifact
using AWS.Compat
using AWS.UUIDs

"""
    associate_external_connection(domain, external-connection, repository)
    associate_external_connection(domain, external-connection, repository, params::Dict{String,<:Any})

Adds an existing external connection to a repository. One external connection is allowed
per repository.  A repository can have one or more upstream repositories, or an external
connection.

# Arguments
- `domain`: The name of the domain that contains the repository.
- `external-connection`:  The name of the external connection to add to the repository. The
  following values are supported:     public:npmjs - for the npm public repository.
  public:nuget-org - for the NuGet Gallery.     public:pypi - for the Python Package Index.
    public:maven-central - for Maven Central.     public:maven-googleandroid - for the Google
  Android repository.     public:maven-gradleplugins - for the Gradle plugins repository.
  public:maven-commonsware - for the CommonsWare Android repository.     public:maven-clojars
  - for the Clojars repository.     public:ruby-gems-org - for RubyGems.org.
  public:crates-io - for Crates.io.
- `repository`:  The name of the repository to which the external connection is added.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"domain-owner"`:  The 12-digit account number of the Amazon Web Services account that
  owns the domain. It does not include dashes or spaces.
"""
function associate_external_connection(
    domain,
    external_connection,
    repository;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeartifact(
        "POST",
        "/v1/repository/external-connection",
        Dict{String,Any}(
            "domain" => domain,
            "external-connection" => external_connection,
            "repository" => repository,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_external_connection(
    domain,
    external_connection,
    repository,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeartifact(
        "POST",
        "/v1/repository/external-connection",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "domain" => domain,
                    "external-connection" => external_connection,
                    "repository" => repository,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    copy_package_versions(destination-repository, domain, format, package, source-repository)
    copy_package_versions(destination-repository, domain, format, package, source-repository, params::Dict{String,<:Any})

 Copies package versions from one repository to another repository in the same domain.
You must specify versions or versionRevisions. You cannot specify both.

# Arguments
- `destination-repository`:  The name of the repository into which package versions are
  copied.
- `domain`:  The name of the domain that contains the source and destination repositories.
- `format`:  The format of the package versions to be copied.
- `package`:  The name of the package that contains the versions to be copied.
- `source-repository`:  The name of the repository that contains the package versions to be
  copied.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"allowOverwrite"`:  Set to true to overwrite a package version that already exists in
  the destination repository. If set to false and the package version already exists in the
  destination repository, the package version is returned in the failedVersions field of the
  response with an ALREADY_EXISTS error code.
- `"domain-owner"`:  The 12-digit account number of the Amazon Web Services account that
  owns the domain. It does not include dashes or spaces.
- `"includeFromUpstream"`:  Set to true to copy packages from repositories that are
  upstream from the source repository to the destination repository. The default setting is
  false. For more information, see Working with upstream repositories.
- `"namespace"`: The namespace of the package versions to be copied. The package component
  that specifies its namespace depends on its type. For example:  The namespace is required
  when copying package versions of the following formats:   Maven   Swift   generic       The
  namespace of a Maven package version is its groupId.     The namespace of an npm or Swift
  package version is its scope.    The namespace of a generic package is its namespace.
  Python, NuGet, Ruby, and Cargo package versions do not contain a corresponding component,
  package versions of those formats do not have a namespace.
- `"versionRevisions"`:  A list of key-value pairs. The keys are package versions and the
  values are package version revisions. A CopyPackageVersion operation succeeds if the
  specified versions in the source repository match the specified package version revision.
   You must specify versions or versionRevisions. You cannot specify both.
- `"versions"`:  The versions of the package to be copied.    You must specify versions or
  versionRevisions. You cannot specify both.
"""
function copy_package_versions(
    destination_repository,
    domain,
    format,
    package,
    source_repository;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeartifact(
        "POST",
        "/v1/package/versions/copy",
        Dict{String,Any}(
            "destination-repository" => destination_repository,
            "domain" => domain,
            "format" => format,
            "package" => package,
            "source-repository" => source_repository,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function copy_package_versions(
    destination_repository,
    domain,
    format,
    package,
    source_repository,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeartifact(
        "POST",
        "/v1/package/versions/copy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "destination-repository" => destination_repository,
                    "domain" => domain,
                    "format" => format,
                    "package" => package,
                    "source-repository" => source_repository,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_domain(domain)
    create_domain(domain, params::Dict{String,<:Any})

 Creates a domain. CodeArtifact domains make it easier to manage multiple repositories
across an organization. You can use a domain to apply permissions across many repositories
owned by different Amazon Web Services accounts. An asset is stored only once in a domain,
even if it's in multiple repositories.  Although you can have multiple domains, we
recommend a single production domain that contains all published artifacts so that your
development teams can find and share packages. You can use a second pre-production domain
to test changes to the production domain configuration.

# Arguments
- `domain`:  The name of the domain to create. All domain names in an Amazon Web Services
  Region that are in the same Amazon Web Services account must be unique. The domain name is
  used as the prefix in DNS hostnames. Do not use sensitive information in a domain name
  because it is publicly discoverable.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"encryptionKey"`:  The encryption key for the domain. This is used to encrypt content
  stored in a domain. An encryption key can be a key ID, a key Amazon Resource Name (ARN), a
  key alias, or a key alias ARN. To specify an encryptionKey, your IAM role must have
  kms:DescribeKey and kms:CreateGrant permissions on the encryption key that is used. For
  more information, see DescribeKey in the Key Management Service API Reference and Key
  Management Service API Permissions Reference in the Key Management Service Developer Guide.
     CodeArtifact supports only symmetric CMKs. Do not associate an asymmetric CMK with your
  domain. For more information, see Using symmetric and asymmetric keys in the Key Management
  Service Developer Guide.
- `"tags"`: One or more tag key-value pairs for the domain.
"""
function create_domain(domain; aws_config::AbstractAWSConfig=current_aws_config())
    return codeartifact(
        "POST",
        "/v1/domain",
        Dict{String,Any}("domain" => domain);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_domain(
    domain, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeartifact(
        "POST",
        "/v1/domain",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("domain" => domain), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_package_group(domain, package_group)
    create_package_group(domain, package_group, params::Dict{String,<:Any})

 Creates a package group. For more information about creating package groups, including
example CLI commands, see Create a package group in the CodeArtifact User Guide.

# Arguments
- `domain`:  The name of the domain in which you want to create a package group.
- `package_group`: The pattern of the package group to create. The pattern is also the
  identifier of the package group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"contactInfo"`:  The contact information for the created package group.
- `"description"`:  A description of the package group.
- `"domain-owner"`:  The 12-digit account number of the Amazon Web Services account that
  owns the domain. It does not include dashes or spaces.
- `"tags"`: One or more tag key-value pairs for the package group.
"""
function create_package_group(
    domain, packageGroup; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeartifact(
        "POST",
        "/v1/package-group",
        Dict{String,Any}("domain" => domain, "packageGroup" => packageGroup);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_package_group(
    domain,
    packageGroup,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeartifact(
        "POST",
        "/v1/package-group",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("domain" => domain, "packageGroup" => packageGroup),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_repository(domain, repository)
    create_repository(domain, repository, params::Dict{String,<:Any})

 Creates a repository.

# Arguments
- `domain`:  The name of the domain that contains the created repository.
- `repository`: The name of the repository to create.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`:  A description of the created repository.
- `"domain-owner"`:  The 12-digit account number of the Amazon Web Services account that
  owns the domain. It does not include dashes or spaces.
- `"tags"`: One or more tag key-value pairs for the repository.
- `"upstreams"`:  A list of upstream repositories to associate with the repository. The
  order of the upstream repositories in the list determines their priority order when
  CodeArtifact looks for a requested package version. For more information, see Working with
  upstream repositories.
"""
function create_repository(
    domain, repository; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeartifact(
        "POST",
        "/v1/repository",
        Dict{String,Any}("domain" => domain, "repository" => repository);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_repository(
    domain,
    repository,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeartifact(
        "POST",
        "/v1/repository",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("domain" => domain, "repository" => repository),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_domain(domain)
    delete_domain(domain, params::Dict{String,<:Any})

 Deletes a domain. You cannot delete a domain that contains repositories. If you want to
delete a domain with repositories, first delete its repositories.

# Arguments
- `domain`:  The name of the domain to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"domain-owner"`:  The 12-digit account number of the Amazon Web Services account that
  owns the domain. It does not include dashes or spaces.
"""
function delete_domain(domain; aws_config::AbstractAWSConfig=current_aws_config())
    return codeartifact(
        "DELETE",
        "/v1/domain",
        Dict{String,Any}("domain" => domain);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_domain(
    domain, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeartifact(
        "DELETE",
        "/v1/domain",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("domain" => domain), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_domain_permissions_policy(domain)
    delete_domain_permissions_policy(domain, params::Dict{String,<:Any})

 Deletes the resource policy set on a domain.

# Arguments
- `domain`:  The name of the domain associated with the resource policy to be deleted.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"domain-owner"`:  The 12-digit account number of the Amazon Web Services account that
  owns the domain. It does not include dashes or spaces.
- `"policy-revision"`:  The current revision of the resource policy to be deleted. This
  revision is used for optimistic locking, which prevents others from overwriting your
  changes to the domain's resource policy.
"""
function delete_domain_permissions_policy(
    domain; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeartifact(
        "DELETE",
        "/v1/domain/permissions/policy",
        Dict{String,Any}("domain" => domain);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_domain_permissions_policy(
    domain, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeartifact(
        "DELETE",
        "/v1/domain/permissions/policy",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("domain" => domain), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_package(domain, format, package, repository)
    delete_package(domain, format, package, repository, params::Dict{String,<:Any})

Deletes a package and all associated package versions. A deleted package cannot be
restored. To delete one or more package versions, use the DeletePackageVersions API.

# Arguments
- `domain`: The name of the domain that contains the package to delete.
- `format`: The format of the requested package to delete.
- `package`: The name of the package to delete.
- `repository`: The name of the repository that contains the package to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"domain-owner"`:  The 12-digit account number of the Amazon Web Services account that
  owns the domain. It does not include dashes or spaces.
- `"namespace"`: The namespace of the package to delete. The package component that
  specifies its namespace depends on its type. For example:  The namespace is required when
  deleting packages of the following formats:   Maven   Swift   generic       The namespace
  of a Maven package version is its groupId.     The namespace of an npm or Swift package
  version is its scope.    The namespace of a generic package is its namespace.    Python,
  NuGet, Ruby, and Cargo package versions do not contain a corresponding component, package
  versions of those formats do not have a namespace.
"""
function delete_package(
    domain, format, package, repository; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeartifact(
        "DELETE",
        "/v1/package",
        Dict{String,Any}(
            "domain" => domain,
            "format" => format,
            "package" => package,
            "repository" => repository,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_package(
    domain,
    format,
    package,
    repository,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeartifact(
        "DELETE",
        "/v1/package",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "domain" => domain,
                    "format" => format,
                    "package" => package,
                    "repository" => repository,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_package_group(domain, package-group)
    delete_package_group(domain, package-group, params::Dict{String,<:Any})

Deletes a package group. Deleting a package group does not delete packages or package
versions associated with the package group. When a package group is deleted, the direct
child package groups will become children of the package group's direct parent package
group. Therefore, if any of the child groups are inheriting any settings from the parent,
those settings could change.

# Arguments
- `domain`:  The domain that contains the package group to be deleted.
- `package-group`: The pattern of the package group to be deleted.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"domain-owner"`:  The 12-digit account number of the Amazon Web Services account that
  owns the domain. It does not include dashes or spaces.
"""
function delete_package_group(
    domain, package_group; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeartifact(
        "DELETE",
        "/v1/package-group",
        Dict{String,Any}("domain" => domain, "package-group" => package_group);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_package_group(
    domain,
    package_group,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeartifact(
        "DELETE",
        "/v1/package-group",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("domain" => domain, "package-group" => package_group),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_package_versions(domain, format, package, repository, versions)
    delete_package_versions(domain, format, package, repository, versions, params::Dict{String,<:Any})

 Deletes one or more versions of a package. A deleted package version cannot be restored in
your repository. If you want to remove a package version from your repository and be able
to restore it later, set its status to Archived. Archived packages cannot be downloaded
from a repository and don't show up with list package APIs (for example,
ListPackageVersions), but you can restore them using UpdatePackageVersionsStatus.

# Arguments
- `domain`:  The name of the domain that contains the package to delete.
- `format`:  The format of the package versions to delete.
- `package`:  The name of the package with the versions to delete.
- `repository`:  The name of the repository that contains the package versions to delete.
- `versions`:  An array of strings that specify the versions of the package to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"domain-owner"`:  The 12-digit account number of the Amazon Web Services account that
  owns the domain. It does not include dashes or spaces.
- `"expectedStatus"`:  The expected status of the package version to delete.
- `"namespace"`: The namespace of the package versions to be deleted. The package component
  that specifies its namespace depends on its type. For example:  The namespace is required
  when deleting package versions of the following formats:   Maven   Swift   generic
  The namespace of a Maven package version is its groupId.     The namespace of an npm or
  Swift package version is its scope.    The namespace of a generic package is its namespace.
     Python, NuGet, Ruby, and Cargo package versions do not contain a corresponding
  component, package versions of those formats do not have a namespace.
"""
function delete_package_versions(
    domain,
    format,
    package,
    repository,
    versions;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeartifact(
        "POST",
        "/v1/package/versions/delete",
        Dict{String,Any}(
            "domain" => domain,
            "format" => format,
            "package" => package,
            "repository" => repository,
            "versions" => versions,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_package_versions(
    domain,
    format,
    package,
    repository,
    versions,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeartifact(
        "POST",
        "/v1/package/versions/delete",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "domain" => domain,
                    "format" => format,
                    "package" => package,
                    "repository" => repository,
                    "versions" => versions,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_repository(domain, repository)
    delete_repository(domain, repository, params::Dict{String,<:Any})

 Deletes a repository.

# Arguments
- `domain`:  The name of the domain that contains the repository to delete.
- `repository`:  The name of the repository to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"domain-owner"`:  The 12-digit account number of the Amazon Web Services account that
  owns the domain. It does not include dashes or spaces.
"""
function delete_repository(
    domain, repository; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeartifact(
        "DELETE",
        "/v1/repository",
        Dict{String,Any}("domain" => domain, "repository" => repository);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_repository(
    domain,
    repository,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeartifact(
        "DELETE",
        "/v1/repository",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("domain" => domain, "repository" => repository),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_repository_permissions_policy(domain, repository)
    delete_repository_permissions_policy(domain, repository, params::Dict{String,<:Any})

 Deletes the resource policy that is set on a repository. After a resource policy is
deleted, the permissions allowed and denied by the deleted policy are removed. The effect
of deleting a resource policy might not be immediate.    Use
DeleteRepositoryPermissionsPolicy with caution. After a policy is deleted, Amazon Web
Services users, roles, and accounts lose permissions to perform the repository actions
granted by the deleted policy.

# Arguments
- `domain`:  The name of the domain that contains the repository associated with the
  resource policy to be deleted.
- `repository`:  The name of the repository that is associated with the resource policy to
  be deleted

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"domain-owner"`:  The 12-digit account number of the Amazon Web Services account that
  owns the domain. It does not include dashes or spaces.
- `"policy-revision"`:  The revision of the repository's resource policy to be deleted.
  This revision is used for optimistic locking, which prevents others from accidentally
  overwriting your changes to the repository's resource policy.
"""
function delete_repository_permissions_policy(
    domain, repository; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeartifact(
        "DELETE",
        "/v1/repository/permissions/policies",
        Dict{String,Any}("domain" => domain, "repository" => repository);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_repository_permissions_policy(
    domain,
    repository,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeartifact(
        "DELETE",
        "/v1/repository/permissions/policies",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("domain" => domain, "repository" => repository),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_domain(domain)
    describe_domain(domain, params::Dict{String,<:Any})

 Returns a DomainDescription object that contains information about the requested domain.

# Arguments
- `domain`:  A string that specifies the name of the requested domain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"domain-owner"`:  The 12-digit account number of the Amazon Web Services account that
  owns the domain. It does not include dashes or spaces.
"""
function describe_domain(domain; aws_config::AbstractAWSConfig=current_aws_config())
    return codeartifact(
        "GET",
        "/v1/domain",
        Dict{String,Any}("domain" => domain);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_domain(
    domain, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeartifact(
        "GET",
        "/v1/domain",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("domain" => domain), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_package(domain, format, package, repository)
    describe_package(domain, format, package, repository, params::Dict{String,<:Any})

 Returns a PackageDescription object that contains information about the requested package.

# Arguments
- `domain`: The name of the domain that contains the repository that contains the package.
- `format`: A format that specifies the type of the requested package.
- `package`: The name of the requested package.
- `repository`: The name of the repository that contains the requested package.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"domain-owner"`:  The 12-digit account number of the Amazon Web Services account that
  owns the domain. It does not include dashes or spaces.
- `"namespace"`: The namespace of the requested package. The package component that
  specifies its namespace depends on its type. For example:  The namespace is required when
  requesting packages of the following formats:   Maven   Swift   generic       The namespace
  of a Maven package version is its groupId.     The namespace of an npm or Swift package
  version is its scope.    The namespace of a generic package is its namespace.    Python,
  NuGet, Ruby, and Cargo package versions do not contain a corresponding component, package
  versions of those formats do not have a namespace.
"""
function describe_package(
    domain, format, package, repository; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeartifact(
        "GET",
        "/v1/package",
        Dict{String,Any}(
            "domain" => domain,
            "format" => format,
            "package" => package,
            "repository" => repository,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_package(
    domain,
    format,
    package,
    repository,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeartifact(
        "GET",
        "/v1/package",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "domain" => domain,
                    "format" => format,
                    "package" => package,
                    "repository" => repository,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_package_group(domain, package-group)
    describe_package_group(domain, package-group, params::Dict{String,<:Any})

Returns a PackageGroupDescription object that contains information about the requested
package group.

# Arguments
- `domain`:  The name of the domain that contains the package group.
- `package-group`: The pattern of the requested package group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"domain-owner"`:  The 12-digit account number of the Amazon Web Services account that
  owns the domain. It does not include dashes or spaces.
"""
function describe_package_group(
    domain, package_group; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeartifact(
        "GET",
        "/v1/package-group",
        Dict{String,Any}("domain" => domain, "package-group" => package_group);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_package_group(
    domain,
    package_group,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeartifact(
        "GET",
        "/v1/package-group",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("domain" => domain, "package-group" => package_group),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_package_version(domain, format, package, repository, version)
    describe_package_version(domain, format, package, repository, version, params::Dict{String,<:Any})

 Returns a PackageVersionDescription object that contains information about the requested
package version.

# Arguments
- `domain`:  The name of the domain that contains the repository that contains the package
  version.
- `format`:  A format that specifies the type of the requested package version.
- `package`:  The name of the requested package version.
- `repository`:  The name of the repository that contains the package version.
- `version`:  A string that contains the package version (for example, 3.5.2).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"domain-owner"`:  The 12-digit account number of the Amazon Web Services account that
  owns the domain. It does not include dashes or spaces.
- `"namespace"`: The namespace of the requested package version. The package component that
  specifies its namespace depends on its type. For example:  The namespace is required when
  requesting package versions of the following formats:   Maven   Swift   generic       The
  namespace of a Maven package version is its groupId.     The namespace of an npm or Swift
  package version is its scope.    The namespace of a generic package is its namespace.
  Python, NuGet, Ruby, and Cargo package versions do not contain a corresponding component,
  package versions of those formats do not have a namespace.
"""
function describe_package_version(
    domain,
    format,
    package,
    repository,
    version;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeartifact(
        "GET",
        "/v1/package/version",
        Dict{String,Any}(
            "domain" => domain,
            "format" => format,
            "package" => package,
            "repository" => repository,
            "version" => version,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_package_version(
    domain,
    format,
    package,
    repository,
    version,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeartifact(
        "GET",
        "/v1/package/version",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "domain" => domain,
                    "format" => format,
                    "package" => package,
                    "repository" => repository,
                    "version" => version,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_repository(domain, repository)
    describe_repository(domain, repository, params::Dict{String,<:Any})

 Returns a RepositoryDescription object that contains detailed information about the
requested repository.

# Arguments
- `domain`:  The name of the domain that contains the repository to describe.
- `repository`:  A string that specifies the name of the requested repository.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"domain-owner"`:  The 12-digit account number of the Amazon Web Services account that
  owns the domain. It does not include dashes or spaces.
"""
function describe_repository(
    domain, repository; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeartifact(
        "GET",
        "/v1/repository",
        Dict{String,Any}("domain" => domain, "repository" => repository);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_repository(
    domain,
    repository,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeartifact(
        "GET",
        "/v1/repository",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("domain" => domain, "repository" => repository),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_external_connection(domain, external-connection, repository)
    disassociate_external_connection(domain, external-connection, repository, params::Dict{String,<:Any})

 Removes an existing external connection from a repository.

# Arguments
- `domain`: The name of the domain that contains the repository from which to remove the
  external repository.
- `external-connection`: The name of the external connection to be removed from the
  repository.
- `repository`: The name of the repository from which the external connection will be
  removed.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"domain-owner"`:  The 12-digit account number of the Amazon Web Services account that
  owns the domain. It does not include dashes or spaces.
"""
function disassociate_external_connection(
    domain,
    external_connection,
    repository;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeartifact(
        "DELETE",
        "/v1/repository/external-connection",
        Dict{String,Any}(
            "domain" => domain,
            "external-connection" => external_connection,
            "repository" => repository,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_external_connection(
    domain,
    external_connection,
    repository,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeartifact(
        "DELETE",
        "/v1/repository/external-connection",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "domain" => domain,
                    "external-connection" => external_connection,
                    "repository" => repository,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    dispose_package_versions(domain, format, package, repository, versions)
    dispose_package_versions(domain, format, package, repository, versions, params::Dict{String,<:Any})

 Deletes the assets in package versions and sets the package versions' status to Disposed.
A disposed package version cannot be restored in your repository because its assets are
deleted.   To view all disposed package versions in a repository, use ListPackageVersions
and set the status parameter to Disposed.   To view information about a disposed package
version, use DescribePackageVersion.

# Arguments
- `domain`:  The name of the domain that contains the repository you want to dispose.
- `format`:  A format that specifies the type of package versions you want to dispose.
- `package`:  The name of the package with the versions you want to dispose.
- `repository`:  The name of the repository that contains the package versions you want to
  dispose.
- `versions`:  The versions of the package you want to dispose.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"domain-owner"`:  The 12-digit account number of the Amazon Web Services account that
  owns the domain. It does not include dashes or spaces.
- `"expectedStatus"`:  The expected status of the package version to dispose.
- `"namespace"`: The namespace of the package versions to be disposed. The package
  component that specifies its namespace depends on its type. For example:  The namespace is
  required when disposing package versions of the following formats:   Maven   Swift
  generic       The namespace of a Maven package version is its groupId.     The namespace of
  an npm or Swift package version is its scope.    The namespace of a generic package is its
  namespace.    Python, NuGet, Ruby, and Cargo package versions do not contain a
  corresponding component, package versions of those formats do not have a namespace.
- `"versionRevisions"`:  The revisions of the package versions you want to dispose.
"""
function dispose_package_versions(
    domain,
    format,
    package,
    repository,
    versions;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeartifact(
        "POST",
        "/v1/package/versions/dispose",
        Dict{String,Any}(
            "domain" => domain,
            "format" => format,
            "package" => package,
            "repository" => repository,
            "versions" => versions,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function dispose_package_versions(
    domain,
    format,
    package,
    repository,
    versions,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeartifact(
        "POST",
        "/v1/package/versions/dispose",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "domain" => domain,
                    "format" => format,
                    "package" => package,
                    "repository" => repository,
                    "versions" => versions,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_associated_package_group(domain, format, package)
    get_associated_package_group(domain, format, package, params::Dict{String,<:Any})

Returns the most closely associated package group to the specified package. This API does
not require that the package exist in any repository in the domain. As such,
GetAssociatedPackageGroup can be used to see which package group's origin configuration
applies to a package before that package is in a repository. This can be helpful to check
if public packages are blocked without ingesting them. For information package group
association and matching, see Package group definition syntax and matching behavior in the
CodeArtifact User Guide.

# Arguments
- `domain`:  The name of the domain that contains the package from which to get the
  associated package group.
- `format`:  The format of the package from which to get the associated package group.
- `package`:  The package from which to get the associated package group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"domain-owner"`:  The 12-digit account number of the Amazon Web Services account that
  owns the domain. It does not include dashes or spaces.
- `"namespace"`: The namespace of the package from which to get the associated package
  group. The package component that specifies its namespace depends on its type. For example:
   The namespace is required when getting associated package groups from packages of the
  following formats:   Maven   Swift   generic       The namespace of a Maven package version
  is its groupId.     The namespace of an npm or Swift package version is its scope.    The
  namespace of a generic package is its namespace.    Python, NuGet, Ruby, and Cargo package
  versions do not contain a corresponding component, package versions of those formats do not
  have a namespace.
"""
function get_associated_package_group(
    domain, format, package; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeartifact(
        "GET",
        "/v1/get-associated-package-group",
        Dict{String,Any}("domain" => domain, "format" => format, "package" => package);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_associated_package_group(
    domain,
    format,
    package,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeartifact(
        "GET",
        "/v1/get-associated-package-group",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "domain" => domain, "format" => format, "package" => package
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_authorization_token(domain)
    get_authorization_token(domain, params::Dict{String,<:Any})

 Generates a temporary authorization token for accessing repositories in the domain. This
API requires the codeartifact:GetAuthorizationToken and sts:GetServiceBearerToken
permissions. For more information about authorization tokens, see CodeArtifact
authentication and tokens.   CodeArtifact authorization tokens are valid for a period of 12
hours when created with the login command. You can call login periodically to refresh the
token. When you create an authorization token with the GetAuthorizationToken API, you can
set a custom authorization period, up to a maximum of 12 hours, with the durationSeconds
parameter. The authorization period begins after login or GetAuthorizationToken is called.
If login or GetAuthorizationToken is called while assuming a role, the token lifetime is
independent of the maximum session duration of the role. For example, if you call sts
assume-role and specify a session duration of 15 minutes, then generate a CodeArtifact
authorization token, the token will be valid for the full authorization period even though
this is longer than the 15-minute session duration. See Using IAM Roles for more
information on controlling session duration.

# Arguments
- `domain`:  The name of the domain that is in scope for the generated authorization token.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"domain-owner"`:  The 12-digit account number of the Amazon Web Services account that
  owns the domain. It does not include dashes or spaces.
- `"duration"`: The time, in seconds, that the generated authorization token is valid.
  Valid values are 0 and any number between 900 (15 minutes) and 43200 (12 hours). A value of
  0 will set the expiration of the authorization token to the same expiration of the user's
  role's temporary credentials.
"""
function get_authorization_token(domain; aws_config::AbstractAWSConfig=current_aws_config())
    return codeartifact(
        "POST",
        "/v1/authorization-token",
        Dict{String,Any}("domain" => domain);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_authorization_token(
    domain, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeartifact(
        "POST",
        "/v1/authorization-token",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("domain" => domain), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_domain_permissions_policy(domain)
    get_domain_permissions_policy(domain, params::Dict{String,<:Any})

 Returns the resource policy attached to the specified domain.    The policy is a
resource-based policy, not an identity-based policy. For more information, see
Identity-based policies and resource-based policies  in the IAM User Guide.

# Arguments
- `domain`:  The name of the domain to which the resource policy is attached.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"domain-owner"`:  The 12-digit account number of the Amazon Web Services account that
  owns the domain. It does not include dashes or spaces.
"""
function get_domain_permissions_policy(
    domain; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeartifact(
        "GET",
        "/v1/domain/permissions/policy",
        Dict{String,Any}("domain" => domain);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_domain_permissions_policy(
    domain, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeartifact(
        "GET",
        "/v1/domain/permissions/policy",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("domain" => domain), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_package_version_asset(asset, domain, format, package, repository, version)
    get_package_version_asset(asset, domain, format, package, repository, version, params::Dict{String,<:Any})

 Returns an asset (or file) that is in a package. For example, for a Maven package version,
use GetPackageVersionAsset to download a JAR file, a POM file, or any other assets in the
package version.

# Arguments
- `asset`:  The name of the requested asset.
- `domain`:  The name of the domain that contains the repository that contains the package
  version with the requested asset.
- `format`:  A format that specifies the type of the package version with the requested
  asset file.
- `package`:  The name of the package that contains the requested asset.
- `repository`:  The repository that contains the package version with the requested asset.
- `version`:  A string that contains the package version (for example, 3.5.2).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"domain-owner"`:  The 12-digit account number of the Amazon Web Services account that
  owns the domain. It does not include dashes or spaces.
- `"namespace"`: The namespace of the package version with the requested asset file. The
  package component that specifies its namespace depends on its type. For example:  The
  namespace is required when requesting assets from package versions of the following
  formats:   Maven   Swift   generic       The namespace of a Maven package version is its
  groupId.     The namespace of an npm or Swift package version is its scope.    The
  namespace of a generic package is its namespace.    Python, NuGet, Ruby, and Cargo package
  versions do not contain a corresponding component, package versions of those formats do not
  have a namespace.
- `"revision"`:  The name of the package version revision that contains the requested
  asset.
"""
function get_package_version_asset(
    asset,
    domain,
    format,
    package,
    repository,
    version;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeartifact(
        "GET",
        "/v1/package/version/asset",
        Dict{String,Any}(
            "asset" => asset,
            "domain" => domain,
            "format" => format,
            "package" => package,
            "repository" => repository,
            "version" => version,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_package_version_asset(
    asset,
    domain,
    format,
    package,
    repository,
    version,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeartifact(
        "GET",
        "/v1/package/version/asset",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "asset" => asset,
                    "domain" => domain,
                    "format" => format,
                    "package" => package,
                    "repository" => repository,
                    "version" => version,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_package_version_readme(domain, format, package, repository, version)
    get_package_version_readme(domain, format, package, repository, version, params::Dict{String,<:Any})

 Gets the readme file or descriptive text for a package version.   The returned text might
contain formatting. For example, it might contain formatting for Markdown or
reStructuredText.

# Arguments
- `domain`:  The name of the domain that contains the repository that contains the package
  version with the requested readme file.
- `format`:  A format that specifies the type of the package version with the requested
  readme file.
- `package`:  The name of the package version that contains the requested readme file.
- `repository`:  The repository that contains the package with the requested readme file.
- `version`:  A string that contains the package version (for example, 3.5.2).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"domain-owner"`:  The 12-digit account number of the Amazon Web Services account that
  owns the domain. It does not include dashes or spaces.
- `"namespace"`: The namespace of the package version with the requested readme file. The
  package component that specifies its namespace depends on its type. For example:  The
  namespace is required when requesting the readme from package versions of the following
  formats:   Maven   Swift   generic       The namespace of a Maven package version is its
  groupId.     The namespace of an npm or Swift package version is its scope.    The
  namespace of a generic package is its namespace.    Python, NuGet, Ruby, and Cargo package
  versions do not contain a corresponding component, package versions of those formats do not
  have a namespace.
"""
function get_package_version_readme(
    domain,
    format,
    package,
    repository,
    version;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeartifact(
        "GET",
        "/v1/package/version/readme",
        Dict{String,Any}(
            "domain" => domain,
            "format" => format,
            "package" => package,
            "repository" => repository,
            "version" => version,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_package_version_readme(
    domain,
    format,
    package,
    repository,
    version,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeartifact(
        "GET",
        "/v1/package/version/readme",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "domain" => domain,
                    "format" => format,
                    "package" => package,
                    "repository" => repository,
                    "version" => version,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_repository_endpoint(domain, format, repository)
    get_repository_endpoint(domain, format, repository, params::Dict{String,<:Any})

 Returns the endpoint of a repository for a specific package format. A repository has one
endpoint for each package format:     cargo     generic     maven     npm     nuget
pypi     ruby     swift

# Arguments
- `domain`:  The name of the domain that contains the repository.
- `format`:  Returns which endpoint of a repository to return. A repository has one
  endpoint for each package format.
- `repository`:  The name of the repository.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"domain-owner"`:  The 12-digit account number of the Amazon Web Services account that
  owns the domain that contains the repository. It does not include dashes or spaces.
"""
function get_repository_endpoint(
    domain, format, repository; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeartifact(
        "GET",
        "/v1/repository/endpoint",
        Dict{String,Any}(
            "domain" => domain, "format" => format, "repository" => repository
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_repository_endpoint(
    domain,
    format,
    repository,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeartifact(
        "GET",
        "/v1/repository/endpoint",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "domain" => domain, "format" => format, "repository" => repository
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_repository_permissions_policy(domain, repository)
    get_repository_permissions_policy(domain, repository, params::Dict{String,<:Any})

 Returns the resource policy that is set on a repository.

# Arguments
- `domain`:  The name of the domain containing the repository whose associated resource
  policy is to be retrieved.
- `repository`:  The name of the repository whose associated resource policy is to be
  retrieved.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"domain-owner"`:  The 12-digit account number of the Amazon Web Services account that
  owns the domain. It does not include dashes or spaces.
"""
function get_repository_permissions_policy(
    domain, repository; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeartifact(
        "GET",
        "/v1/repository/permissions/policy",
        Dict{String,Any}("domain" => domain, "repository" => repository);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_repository_permissions_policy(
    domain,
    repository,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeartifact(
        "GET",
        "/v1/repository/permissions/policy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("domain" => domain, "repository" => repository),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_allowed_repositories_for_group(domain, origin_restriction_type, package-group)
    list_allowed_repositories_for_group(domain, origin_restriction_type, package-group, params::Dict{String,<:Any})

Lists the repositories in the added repositories list of the specified restriction type for
a package group. For more information about restriction types and added repository lists,
see Package group origin controls in the CodeArtifact User Guide.

# Arguments
- `domain`:  The name of the domain that contains the package group from which to list
  allowed repositories.
- `origin_restriction_type`: The origin configuration restriction type of which to list
  allowed repositories.
- `package-group`: The pattern of the package group from which to list allowed repositories.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"domain-owner"`:  The 12-digit account number of the Amazon Web Services account that
  owns the domain. It does not include dashes or spaces.
- `"max-results"`:  The maximum number of results to return per page.
- `"next-token"`:  The token for the next set of results. Use the value returned in the
  previous response in the next request to retrieve the next set of results.
"""
function list_allowed_repositories_for_group(
    domain,
    originRestrictionType,
    package_group;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeartifact(
        "GET",
        "/v1/package-group-allowed-repositories",
        Dict{String,Any}(
            "domain" => domain,
            "originRestrictionType" => originRestrictionType,
            "package-group" => package_group,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_allowed_repositories_for_group(
    domain,
    originRestrictionType,
    package_group,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeartifact(
        "GET",
        "/v1/package-group-allowed-repositories",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "domain" => domain,
                    "originRestrictionType" => originRestrictionType,
                    "package-group" => package_group,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_associated_packages(domain, package-group)
    list_associated_packages(domain, package-group, params::Dict{String,<:Any})

Returns a list of packages associated with the requested package group. For information
package group association and matching, see Package group definition syntax and matching
behavior in the CodeArtifact User Guide.

# Arguments
- `domain`:  The name of the domain that contains the package group from which to list
  associated packages.
- `package-group`:  The pattern of the package group from which to list associated
  packages.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"domain-owner"`:  The 12-digit account number of the Amazon Web Services account that
  owns the domain. It does not include dashes or spaces.
- `"max-results"`:  The maximum number of results to return per page.
- `"next-token"`:  The token for the next set of results. Use the value returned in the
  previous response in the next request to retrieve the next set of results.
- `"preview"`:  When this flag is included, ListAssociatedPackages will return a list of
  packages that would be associated with a package group, even if it does not exist.
"""
function list_associated_packages(
    domain, package_group; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeartifact(
        "GET",
        "/v1/list-associated-packages",
        Dict{String,Any}("domain" => domain, "package-group" => package_group);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_associated_packages(
    domain,
    package_group,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeartifact(
        "GET",
        "/v1/list-associated-packages",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("domain" => domain, "package-group" => package_group),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_domains()
    list_domains(params::Dict{String,<:Any})

 Returns a list of DomainSummary objects for all domains owned by the Amazon Web Services
account that makes this call. Each returned DomainSummary object contains information about
a domain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:  The maximum number of results to return per page.
- `"nextToken"`:  The token for the next set of results. Use the value returned in the
  previous response in the next request to retrieve the next set of results.
"""
function list_domains(; aws_config::AbstractAWSConfig=current_aws_config())
    return codeartifact(
        "POST", "/v1/domains"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_domains(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeartifact(
        "POST",
        "/v1/domains",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_package_groups(domain)
    list_package_groups(domain, params::Dict{String,<:Any})

Returns a list of package groups in the requested domain.

# Arguments
- `domain`:  The domain for which you want to list package groups.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"domain-owner"`:  The 12-digit account number of the Amazon Web Services account that
  owns the domain. It does not include dashes or spaces.
- `"max-results"`:  The maximum number of results to return per page.
- `"next-token"`:  The token for the next set of results. Use the value returned in the
  previous response in the next request to retrieve the next set of results.
- `"prefix"`:  A prefix for which to search package groups. When included,
  ListPackageGroups will return only package groups with patterns that match the prefix.
"""
function list_package_groups(domain; aws_config::AbstractAWSConfig=current_aws_config())
    return codeartifact(
        "POST",
        "/v1/package-groups",
        Dict{String,Any}("domain" => domain);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_package_groups(
    domain, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeartifact(
        "POST",
        "/v1/package-groups",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("domain" => domain), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_package_version_assets(domain, format, package, repository, version)
    list_package_version_assets(domain, format, package, repository, version, params::Dict{String,<:Any})

 Returns a list of AssetSummary objects for assets in a package version.

# Arguments
- `domain`:  The name of the domain that contains the repository associated with the
  package version assets.
- `format`:  The format of the package that contains the requested package version assets.
- `package`:  The name of the package that contains the requested package version assets.
- `repository`:  The name of the repository that contains the package that contains the
  requested package version assets.
- `version`:  A string that contains the package version (for example, 3.5.2).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"domain-owner"`:  The 12-digit account number of the Amazon Web Services account that
  owns the domain. It does not include dashes or spaces.
- `"max-results"`:  The maximum number of results to return per page.
- `"namespace"`: The namespace of the package version that contains the requested package
  version assets. The package component that specifies its namespace depends on its type. For
  example:  The namespace is required requesting assets from package versions of the
  following formats:   Maven   Swift   generic       The namespace of a Maven package version
  is its groupId.     The namespace of an npm or Swift package version is its scope.    The
  namespace of a generic package is its namespace.    Python, NuGet, Ruby, and Cargo package
  versions do not contain a corresponding component, package versions of those formats do not
  have a namespace.
- `"next-token"`:  The token for the next set of results. Use the value returned in the
  previous response in the next request to retrieve the next set of results.
"""
function list_package_version_assets(
    domain,
    format,
    package,
    repository,
    version;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeartifact(
        "POST",
        "/v1/package/version/assets",
        Dict{String,Any}(
            "domain" => domain,
            "format" => format,
            "package" => package,
            "repository" => repository,
            "version" => version,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_package_version_assets(
    domain,
    format,
    package,
    repository,
    version,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeartifact(
        "POST",
        "/v1/package/version/assets",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "domain" => domain,
                    "format" => format,
                    "package" => package,
                    "repository" => repository,
                    "version" => version,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_package_version_dependencies(domain, format, package, repository, version)
    list_package_version_dependencies(domain, format, package, repository, version, params::Dict{String,<:Any})

 Returns the direct dependencies for a package version. The dependencies are returned as
PackageDependency objects. CodeArtifact extracts the dependencies for a package version
from the metadata file for the package format (for example, the package.json file for npm
packages and the pom.xml file for Maven). Any package version dependencies that are not
listed in the configuration file are not returned.

# Arguments
- `domain`:  The name of the domain that contains the repository that contains the
  requested package version dependencies.
- `format`:  The format of the package with the requested dependencies.
- `package`:  The name of the package versions' package.
- `repository`:  The name of the repository that contains the requested package version.
- `version`:  A string that contains the package version (for example, 3.5.2).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"domain-owner"`:  The 12-digit account number of the Amazon Web Services account that
  owns the domain. It does not include dashes or spaces.
- `"namespace"`: The namespace of the package version with the requested dependencies. The
  package component that specifies its namespace depends on its type. For example:  The
  namespace is required when listing dependencies from package versions of the following
  formats:   Maven       The namespace of a Maven package version is its groupId.     The
  namespace of an npm package version is its scope.     Python and NuGet package versions do
  not contain a corresponding component, package versions of those formats do not have a
  namespace.
- `"next-token"`:  The token for the next set of results. Use the value returned in the
  previous response in the next request to retrieve the next set of results.
"""
function list_package_version_dependencies(
    domain,
    format,
    package,
    repository,
    version;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeartifact(
        "POST",
        "/v1/package/version/dependencies",
        Dict{String,Any}(
            "domain" => domain,
            "format" => format,
            "package" => package,
            "repository" => repository,
            "version" => version,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_package_version_dependencies(
    domain,
    format,
    package,
    repository,
    version,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeartifact(
        "POST",
        "/v1/package/version/dependencies",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "domain" => domain,
                    "format" => format,
                    "package" => package,
                    "repository" => repository,
                    "version" => version,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_package_versions(domain, format, package, repository)
    list_package_versions(domain, format, package, repository, params::Dict{String,<:Any})

 Returns a list of PackageVersionSummary objects for package versions in a repository that
match the request parameters. Package versions of all statuses will be returned by default
when calling list-package-versions with no --status parameter.

# Arguments
- `domain`:  The name of the domain that contains the repository that contains the
  requested package versions.
- `format`:  The format of the package versions you want to list.
- `package`:  The name of the package for which you want to request package versions.
- `repository`:  The name of the repository that contains the requested package versions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"domain-owner"`:  The 12-digit account number of the Amazon Web Services account that
  owns the domain. It does not include dashes or spaces.
- `"max-results"`:  The maximum number of results to return per page.
- `"namespace"`: The namespace of the package that contains the requested package versions.
  The package component that specifies its namespace depends on its type. For example:  The
  namespace is required when deleting package versions of the following formats:   Maven
  Swift   generic       The namespace of a Maven package version is its groupId.     The
  namespace of an npm or Swift package version is its scope.    The namespace of a generic
  package is its namespace.    Python, NuGet, Ruby, and Cargo package versions do not contain
  a corresponding component, package versions of those formats do not have a namespace.
- `"next-token"`:  The token for the next set of results. Use the value returned in the
  previous response in the next request to retrieve the next set of results.
- `"originType"`: The originType used to filter package versions. Only package versions
  with the provided originType will be returned.
- `"sortBy"`:  How to sort the requested list of package versions.
- `"status"`:  A string that filters the requested package versions by status.
"""
function list_package_versions(
    domain, format, package, repository; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeartifact(
        "POST",
        "/v1/package/versions",
        Dict{String,Any}(
            "domain" => domain,
            "format" => format,
            "package" => package,
            "repository" => repository,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_package_versions(
    domain,
    format,
    package,
    repository,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeartifact(
        "POST",
        "/v1/package/versions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "domain" => domain,
                    "format" => format,
                    "package" => package,
                    "repository" => repository,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_packages(domain, repository)
    list_packages(domain, repository, params::Dict{String,<:Any})

 Returns a list of PackageSummary objects for packages in a repository that match the
request parameters.

# Arguments
- `domain`:  The name of the domain that contains the repository that contains the
  requested packages.
- `repository`:  The name of the repository that contains the requested packages.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"domain-owner"`:  The 12-digit account number of the Amazon Web Services account that
  owns the domain. It does not include dashes or spaces.
- `"format"`: The format used to filter requested packages. Only packages from the provided
  format will be returned.
- `"max-results"`:  The maximum number of results to return per page.
- `"namespace"`: The namespace prefix used to filter requested packages. Only packages with
  a namespace that starts with the provided string value are returned. Note that although
  this option is called --namespace and not --namespace-prefix, it has prefix-matching
  behavior. Each package format uses namespace as follows:    The namespace of a Maven
  package version is its groupId.     The namespace of an npm or Swift package version is its
  scope.    The namespace of a generic package is its namespace.    Python, NuGet, Ruby, and
  Cargo package versions do not contain a corresponding component, package versions of those
  formats do not have a namespace.
- `"next-token"`:  The token for the next set of results. Use the value returned in the
  previous response in the next request to retrieve the next set of results.
- `"package-prefix"`:  A prefix used to filter requested packages. Only packages with names
  that start with packagePrefix are returned.
- `"publish"`: The value of the Publish package origin control restriction used to filter
  requested packages. Only packages with the provided restriction are returned. For more
  information, see PackageOriginRestrictions.
- `"upstream"`: The value of the Upstream package origin control restriction used to filter
  requested packages. Only packages with the provided restriction are returned. For more
  information, see PackageOriginRestrictions.
"""
function list_packages(
    domain, repository; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeartifact(
        "POST",
        "/v1/packages",
        Dict{String,Any}("domain" => domain, "repository" => repository);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_packages(
    domain,
    repository,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeartifact(
        "POST",
        "/v1/packages",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("domain" => domain, "repository" => repository),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_repositories()
    list_repositories(params::Dict{String,<:Any})

 Returns a list of RepositorySummary objects. Each RepositorySummary contains information
about a repository in the specified Amazon Web Services account and that matches the input
parameters.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"max-results"`:  The maximum number of results to return per page.
- `"next-token"`:  The token for the next set of results. Use the value returned in the
  previous response in the next request to retrieve the next set of results.
- `"repository-prefix"`:  A prefix used to filter returned repositories. Only repositories
  with names that start with repositoryPrefix are returned.
"""
function list_repositories(; aws_config::AbstractAWSConfig=current_aws_config())
    return codeartifact(
        "POST", "/v1/repositories"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_repositories(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeartifact(
        "POST",
        "/v1/repositories",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_repositories_in_domain(domain)
    list_repositories_in_domain(domain, params::Dict{String,<:Any})

 Returns a list of RepositorySummary objects. Each RepositorySummary contains information
about a repository in the specified domain and that matches the input parameters.

# Arguments
- `domain`:  The name of the domain that contains the returned list of repositories.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"administrator-account"`:  Filter the list of repositories to only include those that
  are managed by the Amazon Web Services account ID.
- `"domain-owner"`:  The 12-digit account number of the Amazon Web Services account that
  owns the domain. It does not include dashes or spaces.
- `"max-results"`:  The maximum number of results to return per page.
- `"next-token"`:  The token for the next set of results. Use the value returned in the
  previous response in the next request to retrieve the next set of results.
- `"repository-prefix"`:  A prefix used to filter returned repositories. Only repositories
  with names that start with repositoryPrefix are returned.
"""
function list_repositories_in_domain(
    domain; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeartifact(
        "POST",
        "/v1/domain/repositories",
        Dict{String,Any}("domain" => domain);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_repositories_in_domain(
    domain, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeartifact(
        "POST",
        "/v1/domain/repositories",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("domain" => domain), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_sub_package_groups(domain, package-group)
    list_sub_package_groups(domain, package-group, params::Dict{String,<:Any})

Returns a list of direct children of the specified package group. For information package
group hierarchy, see Package group definition syntax and matching behavior in the
CodeArtifact User Guide.

# Arguments
- `domain`:  The name of the domain which contains the package group from which to list sub
  package groups.
- `package-group`:  The pattern of the package group from which to list sub package groups.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"domain-owner"`:  The 12-digit account number of the Amazon Web Services account that
  owns the domain. It does not include dashes or spaces.
- `"max-results"`:  The maximum number of results to return per page.
- `"next-token"`:  The token for the next set of results. Use the value returned in the
  previous response in the next request to retrieve the next set of results.
"""
function list_sub_package_groups(
    domain, package_group; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeartifact(
        "POST",
        "/v1/package-groups/sub-groups",
        Dict{String,Any}("domain" => domain, "package-group" => package_group);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_sub_package_groups(
    domain,
    package_group,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeartifact(
        "POST",
        "/v1/package-groups/sub-groups",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("domain" => domain, "package-group" => package_group),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Gets information about Amazon Web Services tags for a specified Amazon Resource Name (ARN)
in CodeArtifact.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource to get tags for.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeartifact(
        "POST",
        "/v1/tags",
        Dict{String,Any}("resourceArn" => resourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeartifact(
        "POST",
        "/v1/tags",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceArn" => resourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    publish_package_version(asset, asset_content, domain, format, package, repository, version, x-amz-content-sha256)
    publish_package_version(asset, asset_content, domain, format, package, repository, version, x-amz-content-sha256, params::Dict{String,<:Any})

Creates a new package version containing one or more assets (or files). The unfinished flag
can be used to keep the package version in the Unfinished state until all of its assets
have been uploaded (see Package version status in the CodeArtifact user guide). To set the
package version’s status to Published, omit the unfinished flag when uploading the final
asset, or set the status using UpdatePackageVersionStatus. Once a package version’s
status is set to Published, it cannot change back to Unfinished.  Only generic packages can
be published using this API. For more information, see Using generic packages in the
CodeArtifact User Guide.

# Arguments
- `asset`: The name of the asset to publish. Asset names can include Unicode letters and
  numbers, and the following special characters: ~ ! @ ^ &amp; ( ) - ` _ + [ ] { } ; , . `
- `asset_content`: The content of the asset to publish.
- `domain`: The name of the domain that contains the repository that contains the package
  version to publish.
- `format`: A format that specifies the type of the package version with the requested
  asset file. The only supported value is generic.
- `package`: The name of the package version to publish.
- `repository`: The name of the repository that the package version will be published to.
- `version`: The package version to publish (for example, 3.5.2).
- `x-amz-content-sha256`: The SHA256 hash of the assetContent to publish. This value must
  be calculated by the caller and provided with the request (see Publishing a generic package
  in the CodeArtifact User Guide). This value is used as an integrity check to verify that
  the assetContent has not changed after it was originally sent.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"domain-owner"`: The 12-digit account number of the AWS account that owns the domain. It
  does not include dashes or spaces.
- `"namespace"`: The namespace of the package version to publish.
- `"unfinished"`: Specifies whether the package version should remain in the unfinished
  state. If omitted, the package version status will be set to Published (see Package version
  status in the CodeArtifact User Guide). Valid values: unfinished
"""
function publish_package_version(
    asset,
    assetContent,
    domain,
    format,
    package,
    repository,
    version,
    x_amz_content_sha256;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeartifact(
        "POST",
        "/v1/package/version/publish",
        Dict{String,Any}(
            "asset" => asset,
            "assetContent" => assetContent,
            "domain" => domain,
            "format" => format,
            "package" => package,
            "repository" => repository,
            "version" => version,
            "headers" => Dict{String,Any}("x-amz-content-sha256" => x_amz_content_sha256),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function publish_package_version(
    asset,
    assetContent,
    domain,
    format,
    package,
    repository,
    version,
    x_amz_content_sha256,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeartifact(
        "POST",
        "/v1/package/version/publish",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "asset" => asset,
                    "assetContent" => assetContent,
                    "domain" => domain,
                    "format" => format,
                    "package" => package,
                    "repository" => repository,
                    "version" => version,
                    "headers" =>
                        Dict{String,Any}("x-amz-content-sha256" => x_amz_content_sha256),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_domain_permissions_policy(domain, policy_document)
    put_domain_permissions_policy(domain, policy_document, params::Dict{String,<:Any})

 Sets a resource policy on a domain that specifies permissions to access it.   When you
call PutDomainPermissionsPolicy, the resource policy on the domain is ignored when
evaluting permissions. This ensures that the owner of a domain cannot lock themselves out
of the domain, which would prevent them from being able to update the resource policy.

# Arguments
- `domain`:  The name of the domain on which to set the resource policy.
- `policy_document`:  A valid displayable JSON Aspen policy string to be set as the access
  control resource policy on the provided domain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"domainOwner"`:  The 12-digit account number of the Amazon Web Services account that
  owns the domain. It does not include dashes or spaces.
- `"policyRevision"`:  The current revision of the resource policy to be set. This revision
  is used for optimistic locking, which prevents others from overwriting your changes to the
  domain's resource policy.
"""
function put_domain_permissions_policy(
    domain, policyDocument; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeartifact(
        "PUT",
        "/v1/domain/permissions/policy",
        Dict{String,Any}("domain" => domain, "policyDocument" => policyDocument);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_domain_permissions_policy(
    domain,
    policyDocument,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeartifact(
        "PUT",
        "/v1/domain/permissions/policy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("domain" => domain, "policyDocument" => policyDocument),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_package_origin_configuration(domain, format, package, repository, restrictions)
    put_package_origin_configuration(domain, format, package, repository, restrictions, params::Dict{String,<:Any})

Sets the package origin configuration for a package. The package origin configuration
determines how new versions of a package can be added to a repository. You can allow or
block direct publishing of new package versions, or ingestion and retaining of new package
versions from an external connection or upstream source. For more information about package
origin controls and configuration, see Editing package origin controls in the CodeArtifact
User Guide.  PutPackageOriginConfiguration can be called on a package that doesn't yet
exist in the repository. When called on a package that does not exist, a package is created
in the repository with no versions and the requested restrictions are set on the package.
This can be used to preemptively block ingesting or retaining any versions from external
connections or upstream repositories, or to block publishing any versions of the package
into the repository before connecting any package managers or publishers to the repository.

# Arguments
- `domain`: The name of the domain that contains the repository that contains the package.
- `format`: A format that specifies the type of the package to be updated.
- `package`: The name of the package to be updated.
- `repository`: The name of the repository that contains the package.
- `restrictions`: A PackageOriginRestrictions object that contains information about the
  upstream and publish package origin restrictions. The upstream restriction determines if
  new package versions can be ingested or retained from external connections or upstream
  repositories. The publish restriction determines if new package versions can be published
  directly to the repository. You must include both the desired upstream and publish
  restrictions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"domain-owner"`:  The 12-digit account number of the Amazon Web Services account that
  owns the domain. It does not include dashes or spaces.
- `"namespace"`: The namespace of the package to be updated. The package component that
  specifies its namespace depends on its type. For example:    The namespace of a Maven
  package version is its groupId.     The namespace of an npm or Swift package version is its
  scope.    The namespace of a generic package is its namespace.    Python, NuGet, Ruby, and
  Cargo package versions do not contain a corresponding component, package versions of those
  formats do not have a namespace.
"""
function put_package_origin_configuration(
    domain,
    format,
    package,
    repository,
    restrictions;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeartifact(
        "POST",
        "/v1/package",
        Dict{String,Any}(
            "domain" => domain,
            "format" => format,
            "package" => package,
            "repository" => repository,
            "restrictions" => restrictions,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_package_origin_configuration(
    domain,
    format,
    package,
    repository,
    restrictions,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeartifact(
        "POST",
        "/v1/package",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "domain" => domain,
                    "format" => format,
                    "package" => package,
                    "repository" => repository,
                    "restrictions" => restrictions,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_repository_permissions_policy(domain, policy_document, repository)
    put_repository_permissions_policy(domain, policy_document, repository, params::Dict{String,<:Any})

 Sets the resource policy on a repository that specifies permissions to access it.   When
you call PutRepositoryPermissionsPolicy, the resource policy on the repository is ignored
when evaluting permissions. This ensures that the owner of a repository cannot lock
themselves out of the repository, which would prevent them from being able to update the
resource policy.

# Arguments
- `domain`:  The name of the domain containing the repository to set the resource policy
  on.
- `policy_document`:  A valid displayable JSON Aspen policy string to be set as the access
  control resource policy on the provided repository.
- `repository`:  The name of the repository to set the resource policy on.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"domain-owner"`:  The 12-digit account number of the Amazon Web Services account that
  owns the domain. It does not include dashes or spaces.
- `"policyRevision"`:  Sets the revision of the resource policy that specifies permissions
  to access the repository. This revision is used for optimistic locking, which prevents
  others from overwriting your changes to the repository's resource policy.
"""
function put_repository_permissions_policy(
    domain, policyDocument, repository; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeartifact(
        "PUT",
        "/v1/repository/permissions/policy",
        Dict{String,Any}(
            "domain" => domain,
            "policyDocument" => policyDocument,
            "repository" => repository,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_repository_permissions_policy(
    domain,
    policyDocument,
    repository,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeartifact(
        "PUT",
        "/v1/repository/permissions/policy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "domain" => domain,
                    "policyDocument" => policyDocument,
                    "repository" => repository,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds or updates tags for a resource in CodeArtifact.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource that you want to add or
  update tags for.
- `tags`: The tags you want to modify or add to the resource.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return codeartifact(
        "POST",
        "/v1/tag",
        Dict{String,Any}("resourceArn" => resourceArn, "tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeartifact(
        "POST",
        "/v1/tag",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceArn" => resourceArn, "tags" => tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes tags from a resource in CodeArtifact.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource that you want to remove
  tags from.
- `tag_keys`: The tag key for each tag that you want to remove from the resource.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeartifact(
        "POST",
        "/v1/untag",
        Dict{String,Any}("resourceArn" => resourceArn, "tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeartifact(
        "POST",
        "/v1/untag",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceArn" => resourceArn, "tagKeys" => tagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_package_group(domain, package_group)
    update_package_group(domain, package_group, params::Dict{String,<:Any})

Updates a package group. This API cannot be used to update a package group's origin
configuration or pattern. To update a package group's origin configuration, use
UpdatePackageGroupOriginConfiguration.

# Arguments
- `domain`:  The name of the domain which contains the package group to be updated.
- `package_group`:  The pattern of the package group to be updated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"contactInfo"`:  Contact information which you want to update the requested package
  group with.
- `"description"`:  The description you want to update the requested package group with.
- `"domain-owner"`:  The 12-digit account number of the Amazon Web Services account that
  owns the domain. It does not include dashes or spaces.
"""
function update_package_group(
    domain, packageGroup; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeartifact(
        "PUT",
        "/v1/package-group",
        Dict{String,Any}("domain" => domain, "packageGroup" => packageGroup);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_package_group(
    domain,
    packageGroup,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeartifact(
        "PUT",
        "/v1/package-group",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("domain" => domain, "packageGroup" => packageGroup),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_package_group_origin_configuration(domain, package-group)
    update_package_group_origin_configuration(domain, package-group, params::Dict{String,<:Any})

Updates the package origin configuration for a package group. The package origin
configuration determines how new versions of a package can be added to a repository. You
can allow or block direct publishing of new package versions, or ingestion and retaining of
new package versions from an external connection or upstream source. For more information
about package group origin controls and configuration, see Package group origin controls in
the CodeArtifact User Guide.

# Arguments
- `domain`:  The name of the domain which contains the package group for which to update
  the origin configuration.
- `package-group`:  The pattern of the package group for which to update the origin
  configuration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"addAllowedRepositories"`: The repository name and restrictions to add to the allowed
  repository list of the specified package group.
- `"domain-owner"`:  The 12-digit account number of the Amazon Web Services account that
  owns the domain. It does not include dashes or spaces.
- `"removeAllowedRepositories"`: The repository name and restrictions to remove from the
  allowed repository list of the specified package group.
- `"restrictions"`:  The origin configuration settings that determine how package versions
  can enter repositories.
"""
function update_package_group_origin_configuration(
    domain, package_group; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeartifact(
        "PUT",
        "/v1/package-group-origin-configuration",
        Dict{String,Any}("domain" => domain, "package-group" => package_group);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_package_group_origin_configuration(
    domain,
    package_group,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeartifact(
        "PUT",
        "/v1/package-group-origin-configuration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("domain" => domain, "package-group" => package_group),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_package_versions_status(domain, format, package, repository, target_status, versions)
    update_package_versions_status(domain, format, package, repository, target_status, versions, params::Dict{String,<:Any})

 Updates the status of one or more versions of a package. Using
UpdatePackageVersionsStatus, you can update the status of package versions to Archived,
Published, or Unlisted. To set the status of a package version to Disposed, use
DisposePackageVersions.

# Arguments
- `domain`:  The name of the domain that contains the repository that contains the package
  versions with a status to be updated.
- `format`:  A format that specifies the type of the package with the statuses to update.
- `package`:  The name of the package with the version statuses to update.
- `repository`:  The repository that contains the package versions with the status you want
  to update.
- `target_status`:  The status you want to change the package version status to.
- `versions`:  An array of strings that specify the versions of the package with the
  statuses to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"domain-owner"`:  The 12-digit account number of the Amazon Web Services account that
  owns the domain. It does not include dashes or spaces.
- `"expectedStatus"`:  The package version’s expected status before it is updated. If
  expectedStatus is provided, the package version's status is updated only if its status at
  the time UpdatePackageVersionsStatus is called matches expectedStatus.
- `"namespace"`: The namespace of the package version to be updated. The package component
  that specifies its namespace depends on its type. For example:    The namespace of a Maven
  package version is its groupId.     The namespace of an npm or Swift package version is its
  scope.    The namespace of a generic package is its namespace.    Python, NuGet, Ruby, and
  Cargo package versions do not contain a corresponding component, package versions of those
  formats do not have a namespace.
- `"versionRevisions"`:  A map of package versions and package version revisions. The map
  key is the package version (for example, 3.5.2), and the map value is the package version
  revision.
"""
function update_package_versions_status(
    domain,
    format,
    package,
    repository,
    targetStatus,
    versions;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeartifact(
        "POST",
        "/v1/package/versions/update_status",
        Dict{String,Any}(
            "domain" => domain,
            "format" => format,
            "package" => package,
            "repository" => repository,
            "targetStatus" => targetStatus,
            "versions" => versions,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_package_versions_status(
    domain,
    format,
    package,
    repository,
    targetStatus,
    versions,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeartifact(
        "POST",
        "/v1/package/versions/update_status",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "domain" => domain,
                    "format" => format,
                    "package" => package,
                    "repository" => repository,
                    "targetStatus" => targetStatus,
                    "versions" => versions,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_repository(domain, repository)
    update_repository(domain, repository, params::Dict{String,<:Any})

 Update the properties of a repository.

# Arguments
- `domain`:  The name of the domain associated with the repository to update.
- `repository`:  The name of the repository to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`:  An updated repository description.
- `"domain-owner"`:  The 12-digit account number of the Amazon Web Services account that
  owns the domain. It does not include dashes or spaces.
- `"upstreams"`:  A list of upstream repositories to associate with the repository. The
  order of the upstream repositories in the list determines their priority order when
  CodeArtifact looks for a requested package version. For more information, see Working with
  upstream repositories.
"""
function update_repository(
    domain, repository; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeartifact(
        "PUT",
        "/v1/repository",
        Dict{String,Any}("domain" => domain, "repository" => repository);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_repository(
    domain,
    repository,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeartifact(
        "PUT",
        "/v1/repository",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("domain" => domain, "repository" => repository),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

module AWSExceptions

using HTTP
using JSON
using XMLDict
using XMLDict: XMLDictElement

export AWSException, IMDSUnavailable, InvalidAWSConfig, InvalidFileName, NoCredentials
export ProtocolNotDefined

struct IMDSUnavailable <: Exception end

function Base.show(io::IO, e::IMDSUnavailable)
    msg = "$IMDSUnavailable: The Instance Metadata Service is unavailable on the host"
    println(io, msg)
    return nothing
end

struct ProtocolNotDefined <: Exception
    message::String
end
Base.show(io::IO, e::ProtocolNotDefined) = println(io, e.message)

struct InvalidFileName <: Exception
    message::String
end
Base.show(io::IO, e::InvalidFileName) = println(io, e.message)

struct NoCredentials <: Exception
    message::String
end
Base.show(io::IO, e::NoCredentials) = println(io, e.message)

struct AWSException <: Exception
    code::String
    message::String
    info::Union{XMLDictElement,Dict,String,Nothing}
    cause::HTTP.StatusError
    streamed_body::Union{String,Nothing}
end

function AWSException(code, message, info, cause)
    return AWSException(code, message, info, cause, nothing)
end

function Base.show(io::IO, e::AWSException)
    print(io, AWSException, ": ", e.code)
    !isempty(e.message) && print(io, " -- ", e.message)
    print(io, "\n\n", e.cause)

    # When the response is streamed then `e.cause` will not show the response body
    if e.streamed_body !== nothing
        print(io, "\n\n")
        if isempty(e.streamed_body)
            printstyled(io, "(empty body)"; bold=true)
        else
            print(io, e.streamed_body)
        end
    end

    println(io)
    return nothing
end

AWSException(e::HTTP.StatusError) = AWSException(e, String(copy(e.response.body)))
AWSException(e::HTTP.StatusError, io::IOBuffer) = AWSException(e, String(take!(io)))

function AWSException(e::HTTP.StatusError, stream::IO)
    seekstart(stream)
    body = read(stream, String)
    return AWSException(e, body)
end

function AWSException(e::HTTP.StatusError, stream::Base.BufferStream)
    close(stream)
    body = read(stream, String)
    return AWSException(e, body)
end

function AWSException(e::HTTP.StatusError, body::AbstractString)
    content_type = HTTP.header(e.response, "Content-Type")
    code = string(e.status)
    message = "AWSException"
    info = Dict{String,Dict}()

    try
        if !isempty(body)
            # Extract API error code from Lambda-style JSON error message...
            if endswith(content_type, "json")
                info = JSON.parse(body)
            end

            # Extract API error code from JSON error message...
            if occursin(r"^application/x-amz-json-1\.[01]$", content_type)
                info = JSON.parse(body)
                if haskey(info, "__type")
                    code = rsplit(info["__type"], '#'; limit=2)[end]
                end
            end

            # Extract API error code from XML error message...
            if (
                endswith(content_type, "/xml") ||
                startswith(body, "<?xml") ||
                startswith(body, r"<\w+ xmlns=")
            )
                info = parse_xml(body)
            end
        elseif parse(Int, HTTP.header(e.response, "Content-Length", "0")) > 0
            # Should only occur streaming a response and error handling is improperly configured
            @error "Internal Error: provided body is empty while the reported content-length " *
                "is non-zero"
        end
    catch err
        # Avoid throwing internal exceptions when parsing the error as this will result
        # in the streamed content being hidden from the user.
        @error sprint() do io
            println(io, "Internal error: Failed to extract API error code:")
            Base.showerror(io, err)
            Base.show_backtrace(io, catch_backtrace())
            println(io)
        end
    end

    # Sometimes info is a string, in which case there is nothing else to do
    if info isa AbstractDict
        # There are times when Errors or Error are returned back
        info = get(info, "Errors", info)
        info = get(info, "Error", info)

        code = get(info, "Code", code)

        # There are also times when the response back is (M|m)essage
        message = get(info, "Message", message)
        message = get(info, "message", message)
    end

    streamed_body = !HTTP.isbytes(e.response.body) ? body : nothing

    return AWSException(code, message, info, e, streamed_body)
end

struct InvalidAWSConfig <: Exception
    message::String
end

function Base.show(io::IO, e::InvalidAWSConfig)
    println(io, "$InvalidAWSConfig: $(e.message)")
    return nothing
end

end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: amp
using AWS.Compat
using AWS.UUIDs

"""
    create_alert_manager_definition(data, workspace_id)
    create_alert_manager_definition(data, workspace_id, params::Dict{String,<:Any})

The CreateAlertManagerDefinition operation creates the alert manager definition in a
workspace. If a workspace already has an alert manager definition, don't use this operation
to update it. Instead, use PutAlertManagerDefinition.

# Arguments
- `data`: The alert manager definition to add. A base64-encoded version of the YAML alert
  manager definition file. For details about the alert manager definition, see
  AlertManagedDefinitionData.
- `workspace_id`: The ID of the workspace to add the alert manager definition to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique identifier that you can provide to ensure the idempotency of
  the request. Case-sensitive.
"""
function create_alert_manager_definition(
    data, workspaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amp(
        "POST",
        "/workspaces/$(workspaceId)/alertmanager/definition",
        Dict{String,Any}("data" => data, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_alert_manager_definition(
    data,
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amp(
        "POST",
        "/workspaces/$(workspaceId)/alertmanager/definition",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("data" => data, "clientToken" => string(uuid4())),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_logging_configuration(log_group_arn, workspace_id)
    create_logging_configuration(log_group_arn, workspace_id, params::Dict{String,<:Any})

The CreateLoggingConfiguration operation creates a logging configuration for the workspace.
Use this operation to set the CloudWatch log group to which the logs will be published to.

# Arguments
- `log_group_arn`: The ARN of the CloudWatch log group to which the vended log data will be
  published. This log group must exist prior to calling this API.
- `workspace_id`: The ID of the workspace to create the logging configuration for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique identifier that you can provide to ensure the idempotency of
  the request. Case-sensitive.
"""
function create_logging_configuration(
    logGroupArn, workspaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amp(
        "POST",
        "/workspaces/$(workspaceId)/logging",
        Dict{String,Any}("logGroupArn" => logGroupArn, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_logging_configuration(
    logGroupArn,
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amp(
        "POST",
        "/workspaces/$(workspaceId)/logging",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "logGroupArn" => logGroupArn, "clientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_rule_groups_namespace(data, name, workspace_id)
    create_rule_groups_namespace(data, name, workspace_id, params::Dict{String,<:Any})

The CreateRuleGroupsNamespace operation creates a rule groups namespace within a workspace.
A rule groups namespace is associated with exactly one rules file. A workspace can have
multiple rule groups namespaces. Use this operation only to create new rule groups
namespaces. To update an existing rule groups namespace, use PutRuleGroupsNamespace.

# Arguments
- `data`: The rules file to use in the new namespace. Contains the base64-encoded version
  of the YAML rules file. For details about the rule groups namespace structure, see
  RuleGroupsNamespaceData.
- `name`: The name for the new rule groups namespace.
- `workspace_id`: The ID of the workspace to add the rule groups namespace.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique identifier that you can provide to ensure the idempotency of
  the request. Case-sensitive.
- `"tags"`: The list of tag keys and values to associate with the rule groups namespace.
"""
function create_rule_groups_namespace(
    data, name, workspaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amp(
        "POST",
        "/workspaces/$(workspaceId)/rulegroupsnamespaces",
        Dict{String,Any}("data" => data, "name" => name, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_rule_groups_namespace(
    data,
    name,
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amp(
        "POST",
        "/workspaces/$(workspaceId)/rulegroupsnamespaces",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "data" => data, "name" => name, "clientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_scraper(destination, scrape_configuration, source)
    create_scraper(destination, scrape_configuration, source, params::Dict{String,<:Any})

The CreateScraper operation creates a scraper to collect metrics. A scraper pulls metrics
from Prometheus-compatible sources within an Amazon EKS cluster, and sends them to your
Amazon Managed Service for Prometheus workspace. You can configure the scraper to control
what metrics are collected, and what transformations are applied prior to sending them to
your workspace. If needed, an IAM role will be created for you that gives Amazon Managed
Service for Prometheus access to the metrics in your cluster. For more information, see
Using roles for scraping metrics from EKS in the Amazon Managed Service for Prometheus User
Guide. You cannot update a scraper. If you want to change the configuration of the scraper,
create a new scraper and delete the old one. The scrapeConfiguration parameter contains the
base64-encoded version of the YAML configuration file.  For more information about
collectors, including what metrics are collected, and how to configure the scraper, see
Amazon Web Services managed collectors in the Amazon Managed Service for Prometheus User
Guide.

# Arguments
- `destination`: The Amazon Managed Service for Prometheus workspace to send metrics to.
- `scrape_configuration`: The configuration file to use in the new scraper. For more
  information, see Scraper configuration in the Amazon Managed Service for Prometheus User
  Guide.
- `source`: The Amazon EKS cluster from which the scraper will collect metrics.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"alias"`: (optional) a name to associate with the scraper. This is for your use, and
  does not need to be unique.
- `"clientToken"`: (Optional) A unique, case-sensitive identifier that you can provide to
  ensure the idempotency of the request.
- `"tags"`: (Optional) The list of tag keys and values to associate with the scraper.
"""
function create_scraper(
    destination,
    scrapeConfiguration,
    source;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amp(
        "POST",
        "/scrapers",
        Dict{String,Any}(
            "destination" => destination,
            "scrapeConfiguration" => scrapeConfiguration,
            "source" => source,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_scraper(
    destination,
    scrapeConfiguration,
    source,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amp(
        "POST",
        "/scrapers",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "destination" => destination,
                    "scrapeConfiguration" => scrapeConfiguration,
                    "source" => source,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_workspace()
    create_workspace(params::Dict{String,<:Any})

Creates a Prometheus workspace. A workspace is a logical space dedicated to the storage and
querying of Prometheus metrics. You can have one or more workspaces in each Region in your
account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"alias"`: An alias that you assign to this workspace to help you identify it. It does
  not need to be unique. Blank spaces at the beginning or end of the alias that you specify
  will be trimmed from the value used.
- `"clientToken"`: A unique identifier that you can provide to ensure the idempotency of
  the request. Case-sensitive.
- `"kmsKeyArn"`: (optional) The ARN for a customer managed KMS key to use for encrypting
  data within your workspace. For more information about using your own key in your
  workspace, see Encryption at rest in the Amazon Managed Service for Prometheus User Guide.
- `"tags"`: The list of tag keys and values to associate with the workspace.
"""
function create_workspace(; aws_config::AbstractAWSConfig=current_aws_config())
    return amp(
        "POST",
        "/workspaces",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_workspace(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amp(
        "POST",
        "/workspaces",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_alert_manager_definition(workspace_id)
    delete_alert_manager_definition(workspace_id, params::Dict{String,<:Any})

Deletes the alert manager definition from a workspace.

# Arguments
- `workspace_id`: The ID of the workspace to delete the alert manager definition from.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique identifier that you can provide to ensure the idempotency of
  the request. Case-sensitive.
"""
function delete_alert_manager_definition(
    workspaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amp(
        "DELETE",
        "/workspaces/$(workspaceId)/alertmanager/definition",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_alert_manager_definition(
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amp(
        "DELETE",
        "/workspaces/$(workspaceId)/alertmanager/definition",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_logging_configuration(workspace_id)
    delete_logging_configuration(workspace_id, params::Dict{String,<:Any})

Deletes the logging configuration for a workspace.

# Arguments
- `workspace_id`: The ID of the workspace containing the logging configuration to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique identifier that you can provide to ensure the idempotency of
  the request. Case-sensitive.
"""
function delete_logging_configuration(
    workspaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amp(
        "DELETE",
        "/workspaces/$(workspaceId)/logging",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_logging_configuration(
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amp(
        "DELETE",
        "/workspaces/$(workspaceId)/logging",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_rule_groups_namespace(name, workspace_id)
    delete_rule_groups_namespace(name, workspace_id, params::Dict{String,<:Any})

Deletes one rule groups namespace and its associated rule groups definition.

# Arguments
- `name`: The name of the rule groups namespace to delete.
- `workspace_id`: The ID of the workspace containing the rule groups namespace and
  definition to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique identifier that you can provide to ensure the idempotency of
  the request. Case-sensitive.
"""
function delete_rule_groups_namespace(
    name, workspaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amp(
        "DELETE",
        "/workspaces/$(workspaceId)/rulegroupsnamespaces/$(name)",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_rule_groups_namespace(
    name,
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amp(
        "DELETE",
        "/workspaces/$(workspaceId)/rulegroupsnamespaces/$(name)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_scraper(scraper_id)
    delete_scraper(scraper_id, params::Dict{String,<:Any})

The DeleteScraper operation deletes one scraper, and stops any metrics collection that the
scraper performs.

# Arguments
- `scraper_id`: The ID of the scraper to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: (Optional) A unique, case-sensitive identifier that you can provide to
  ensure the idempotency of the request.
"""
function delete_scraper(scraperId; aws_config::AbstractAWSConfig=current_aws_config())
    return amp(
        "DELETE",
        "/scrapers/$(scraperId)",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_scraper(
    scraperId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amp(
        "DELETE",
        "/scrapers/$(scraperId)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_workspace(workspace_id)
    delete_workspace(workspace_id, params::Dict{String,<:Any})

Deletes an existing workspace.   When you delete a workspace, the data that has been
ingested into it is not immediately deleted. It will be permanently deleted within one
month.

# Arguments
- `workspace_id`: The ID of the workspace to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique identifier that you can provide to ensure the idempotency of
  the request. Case-sensitive.
"""
function delete_workspace(workspaceId; aws_config::AbstractAWSConfig=current_aws_config())
    return amp(
        "DELETE",
        "/workspaces/$(workspaceId)",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_workspace(
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amp(
        "DELETE",
        "/workspaces/$(workspaceId)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_alert_manager_definition(workspace_id)
    describe_alert_manager_definition(workspace_id, params::Dict{String,<:Any})

Retrieves the full information about the alert manager definition for a workspace.

# Arguments
- `workspace_id`: The ID of the workspace to retrieve the alert manager definition from.

"""
function describe_alert_manager_definition(
    workspaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amp(
        "GET",
        "/workspaces/$(workspaceId)/alertmanager/definition";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_alert_manager_definition(
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amp(
        "GET",
        "/workspaces/$(workspaceId)/alertmanager/definition",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_logging_configuration(workspace_id)
    describe_logging_configuration(workspace_id, params::Dict{String,<:Any})

Returns complete information about the current logging configuration of the workspace.

# Arguments
- `workspace_id`: The ID of the workspace to describe the logging configuration for.

"""
function describe_logging_configuration(
    workspaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amp(
        "GET",
        "/workspaces/$(workspaceId)/logging";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_logging_configuration(
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amp(
        "GET",
        "/workspaces/$(workspaceId)/logging",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_rule_groups_namespace(name, workspace_id)
    describe_rule_groups_namespace(name, workspace_id, params::Dict{String,<:Any})

Returns complete information about one rule groups namespace. To retrieve a list of rule
groups namespaces, use ListRuleGroupsNamespaces.

# Arguments
- `name`: The name of the rule groups namespace that you want information for.
- `workspace_id`: The ID of the workspace containing the rule groups namespace.

"""
function describe_rule_groups_namespace(
    name, workspaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amp(
        "GET",
        "/workspaces/$(workspaceId)/rulegroupsnamespaces/$(name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_rule_groups_namespace(
    name,
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amp(
        "GET",
        "/workspaces/$(workspaceId)/rulegroupsnamespaces/$(name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_scraper(scraper_id)
    describe_scraper(scraper_id, params::Dict{String,<:Any})

The DescribeScraper operation displays information about an existing scraper.

# Arguments
- `scraper_id`: The ID of the scraper to describe.

"""
function describe_scraper(scraperId; aws_config::AbstractAWSConfig=current_aws_config())
    return amp(
        "GET",
        "/scrapers/$(scraperId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_scraper(
    scraperId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amp(
        "GET",
        "/scrapers/$(scraperId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_workspace(workspace_id)
    describe_workspace(workspace_id, params::Dict{String,<:Any})

Returns information about an existing workspace.

# Arguments
- `workspace_id`: The ID of the workspace to describe.

"""
function describe_workspace(workspaceId; aws_config::AbstractAWSConfig=current_aws_config())
    return amp(
        "GET",
        "/workspaces/$(workspaceId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_workspace(
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amp(
        "GET",
        "/workspaces/$(workspaceId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_default_scraper_configuration()
    get_default_scraper_configuration(params::Dict{String,<:Any})

The GetDefaultScraperConfiguration operation returns the default scraper configuration used
when Amazon EKS creates a scraper for you.

"""
function get_default_scraper_configuration(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return amp(
        "GET",
        "/scraperconfiguration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_default_scraper_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amp(
        "GET",
        "/scraperconfiguration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_rule_groups_namespaces(workspace_id)
    list_rule_groups_namespaces(workspace_id, params::Dict{String,<:Any})

Returns a list of rule groups namespaces in a workspace.

# Arguments
- `workspace_id`: The ID of the workspace containing the rule groups namespaces.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return. The default is 100.
- `"name"`: Use this parameter to filter the rule groups namespaces that are returned. Only
  the namespaces with names that begin with the value that you specify are returned.
- `"nextToken"`: The token for the next set of items to return. You receive this token from
  a previous call, and use it to get the next page of results. The other parameters must be
  the same as the initial call. For example, if your initial request has maxResults of 10,
  and there are 12 rule groups namespaces to return, then your initial request will return 10
  and a nextToken. Using the next token in a subsequent call will return the remaining 2
  namespaces.
"""
function list_rule_groups_namespaces(
    workspaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amp(
        "GET",
        "/workspaces/$(workspaceId)/rulegroupsnamespaces";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_rule_groups_namespaces(
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amp(
        "GET",
        "/workspaces/$(workspaceId)/rulegroupsnamespaces",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_scrapers()
    list_scrapers(params::Dict{String,<:Any})

The ListScrapers operation lists all of the scrapers in your account. This includes
scrapers being created or deleted. You can optionally filter the returned list.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: (Optional) A list of key-value pairs to filter the list of scrapers
  returned. Keys include status, sourceArn, destinationArn, and alias. Filters on the same
  key are OR'd together, and filters on different keys are AND'd together. For example,
  status=ACTIVE&amp;status=CREATING&amp;alias=Test, will return all scrapers that have the
  alias Test, and are either in status ACTIVE or CREATING. To find all active scrapers that
  are sending metrics to a specific Amazon Managed Service for Prometheus workspace, you
  would use the ARN of the workspace in a query:
  status=ACTIVE&amp;destinationArn=arn:aws:aps:us-east-1:123456789012:workspace/ws-example1-12
  34-abcd-56ef-123456789012  If this is included, it filters the results to only the scrapers
  that match the filter.
- `"maxResults"`: Optional) The maximum number of scrapers to return in one ListScrapers
  operation. The range is 1-1000. If you omit this parameter, the default of 100 is used.
- `"nextToken"`: (Optional) The token for the next set of items to return. (You received
  this token from a previous call.)
"""
function list_scrapers(; aws_config::AbstractAWSConfig=current_aws_config())
    return amp("GET", "/scrapers"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_scrapers(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amp(
        "GET", "/scrapers", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

The ListTagsForResource operation returns the tags that are associated with an Amazon
Managed Service for Prometheus resource. Currently, the only resources that can be tagged
are workspaces and rule groups namespaces.

# Arguments
- `resource_arn`: The ARN of the resource to list tages for. Must be a workspace or rule
  groups namespace resource.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amp(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amp(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_workspaces()
    list_workspaces(params::Dict{String,<:Any})

Lists all of the Amazon Managed Service for Prometheus workspaces in your account. This
includes workspaces being created or deleted.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"alias"`: If this is included, it filters the results to only the workspaces with names
  that start with the value that you specify here. Amazon Managed Service for Prometheus will
  automatically strip any blank spaces from the beginning and end of the alias that you
  specify.
- `"maxResults"`: The maximum number of workspaces to return per request. The default is
  100.
- `"nextToken"`: The token for the next set of items to return. You receive this token from
  a previous call, and use it to get the next page of results. The other parameters must be
  the same as the initial call. For example, if your initial request has maxResults of 10,
  and there are 12 workspaces to return, then your initial request will return 10 and a
  nextToken. Using the next token in a subsequent call will return the remaining 2 workspaces.
"""
function list_workspaces(; aws_config::AbstractAWSConfig=current_aws_config())
    return amp("GET", "/workspaces"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_workspaces(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amp(
        "GET", "/workspaces", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    put_alert_manager_definition(data, workspace_id)
    put_alert_manager_definition(data, workspace_id, params::Dict{String,<:Any})

Updates an existing alert manager definition in a workspace. If the workspace does not
already have an alert manager definition, don't use this operation to create it. Instead,
use CreateAlertManagerDefinition.

# Arguments
- `data`: The alert manager definition to use. A base64-encoded version of the YAML alert
  manager definition file. For details about the alert manager definition, see
  AlertManagedDefinitionData.
- `workspace_id`: The ID of the workspace to update the alert manager definition in.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique identifier that you can provide to ensure the idempotency of
  the request. Case-sensitive.
"""
function put_alert_manager_definition(
    data, workspaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amp(
        "PUT",
        "/workspaces/$(workspaceId)/alertmanager/definition",
        Dict{String,Any}("data" => data, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_alert_manager_definition(
    data,
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amp(
        "PUT",
        "/workspaces/$(workspaceId)/alertmanager/definition",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("data" => data, "clientToken" => string(uuid4())),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_rule_groups_namespace(data, name, workspace_id)
    put_rule_groups_namespace(data, name, workspace_id, params::Dict{String,<:Any})

Updates an existing rule groups namespace within a workspace. A rule groups namespace is
associated with exactly one rules file. A workspace can have multiple rule groups
namespaces. Use this operation only to update existing rule groups namespaces. To create a
new rule groups namespace, use CreateRuleGroupsNamespace. You can't use this operation to
add tags to an existing rule groups namespace. Instead, use TagResource.

# Arguments
- `data`: The new rules file to use in the namespace. A base64-encoded version of the YAML
  rule groups file. For details about the rule groups namespace structure, see
  RuleGroupsNamespaceData.
- `name`: The name of the rule groups namespace that you are updating.
- `workspace_id`: The ID of the workspace where you are updating the rule groups namespace.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique identifier that you can provide to ensure the idempotency of
  the request. Case-sensitive.
"""
function put_rule_groups_namespace(
    data, name, workspaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amp(
        "PUT",
        "/workspaces/$(workspaceId)/rulegroupsnamespaces/$(name)",
        Dict{String,Any}("data" => data, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_rule_groups_namespace(
    data,
    name,
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amp(
        "PUT",
        "/workspaces/$(workspaceId)/rulegroupsnamespaces/$(name)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("data" => data, "clientToken" => string(uuid4())),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

The TagResource operation associates tags with an Amazon Managed Service for Prometheus
resource. The only resources that can be tagged are workspaces and rule groups namespaces.
If you specify a new tag key for the resource, this tag is appended to the list of tags
associated with the resource. If you specify a tag key that is already associated with the
resource, the new tag value that you specify replaces the previous value for that tag.

# Arguments
- `resource_arn`: The ARN of the workspace or rule groups namespace to apply tags to.
- `tags`: The list of tag keys and values to associate with the resource. Keys may not
  begin with aws:.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return amp(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amp(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes the specified tags from an Amazon Managed Service for Prometheus resource. The only
resources that can be tagged are workspaces and rule groups namespaces.

# Arguments
- `resource_arn`: The ARN of the workspace or rule groups namespace.
- `tag_keys`: The keys of the tags to remove.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amp(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amp(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_logging_configuration(log_group_arn, workspace_id)
    update_logging_configuration(log_group_arn, workspace_id, params::Dict{String,<:Any})

Updates the log group ARN or the workspace ID of the current logging configuration.

# Arguments
- `log_group_arn`: The ARN of the CloudWatch log group to which the vended log data will be
  published.
- `workspace_id`: The ID of the workspace to update the logging configuration for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique identifier that you can provide to ensure the idempotency of
  the request. Case-sensitive.
"""
function update_logging_configuration(
    logGroupArn, workspaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amp(
        "PUT",
        "/workspaces/$(workspaceId)/logging",
        Dict{String,Any}("logGroupArn" => logGroupArn, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_logging_configuration(
    logGroupArn,
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amp(
        "PUT",
        "/workspaces/$(workspaceId)/logging",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "logGroupArn" => logGroupArn, "clientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_workspace_alias(workspace_id)
    update_workspace_alias(workspace_id, params::Dict{String,<:Any})

Updates the alias of an existing workspace.

# Arguments
- `workspace_id`: The ID of the workspace to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"alias"`: The new alias for the workspace. It does not need to be unique. Amazon Managed
  Service for Prometheus will automatically strip any blank spaces from the beginning and end
  of the alias that you specify.
- `"clientToken"`: A unique identifier that you can provide to ensure the idempotency of
  the request. Case-sensitive.
"""
function update_workspace_alias(
    workspaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amp(
        "POST",
        "/workspaces/$(workspaceId)/alias",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_workspace_alias(
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amp(
        "POST",
        "/workspaces/$(workspaceId)/alias",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: backup_gateway
using AWS.Compat
using AWS.UUIDs

"""
    associate_gateway_to_server(gateway_arn, server_arn)
    associate_gateway_to_server(gateway_arn, server_arn, params::Dict{String,<:Any})

Associates a backup gateway with your server. After you complete the association process,
you can back up and restore your VMs through the gateway.

# Arguments
- `gateway_arn`: The Amazon Resource Name (ARN) of the gateway. Use the ListGateways
  operation to return a list of gateways for your account and Amazon Web Services Region.
- `server_arn`: The Amazon Resource Name (ARN) of the server that hosts your virtual
  machines.

"""
function associate_gateway_to_server(
    GatewayArn, ServerArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup_gateway(
        "AssociateGatewayToServer",
        Dict{String,Any}("GatewayArn" => GatewayArn, "ServerArn" => ServerArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_gateway_to_server(
    GatewayArn,
    ServerArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup_gateway(
        "AssociateGatewayToServer",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("GatewayArn" => GatewayArn, "ServerArn" => ServerArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_gateway(activation_key, gateway_display_name, gateway_type)
    create_gateway(activation_key, gateway_display_name, gateway_type, params::Dict{String,<:Any})

Creates a backup gateway. After you create a gateway, you can associate it with a server
using the AssociateGatewayToServer operation.

# Arguments
- `activation_key`: The activation key of the created gateway.
- `gateway_display_name`: The display name of the created gateway.
- `gateway_type`: The type of created gateway.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: A list of up to 50 tags to assign to the gateway. Each tag is a key-value pair.
"""
function create_gateway(
    ActivationKey,
    GatewayDisplayName,
    GatewayType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup_gateway(
        "CreateGateway",
        Dict{String,Any}(
            "ActivationKey" => ActivationKey,
            "GatewayDisplayName" => GatewayDisplayName,
            "GatewayType" => GatewayType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_gateway(
    ActivationKey,
    GatewayDisplayName,
    GatewayType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup_gateway(
        "CreateGateway",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ActivationKey" => ActivationKey,
                    "GatewayDisplayName" => GatewayDisplayName,
                    "GatewayType" => GatewayType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_gateway(gateway_arn)
    delete_gateway(gateway_arn, params::Dict{String,<:Any})

Deletes a backup gateway.

# Arguments
- `gateway_arn`: The Amazon Resource Name (ARN) of the gateway to delete.

"""
function delete_gateway(GatewayArn; aws_config::AbstractAWSConfig=current_aws_config())
    return backup_gateway(
        "DeleteGateway",
        Dict{String,Any}("GatewayArn" => GatewayArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_gateway(
    GatewayArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup_gateway(
        "DeleteGateway",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("GatewayArn" => GatewayArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_hypervisor(hypervisor_arn)
    delete_hypervisor(hypervisor_arn, params::Dict{String,<:Any})

Deletes a hypervisor.

# Arguments
- `hypervisor_arn`: The Amazon Resource Name (ARN) of the hypervisor to delete.

"""
function delete_hypervisor(
    HypervisorArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup_gateway(
        "DeleteHypervisor",
        Dict{String,Any}("HypervisorArn" => HypervisorArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_hypervisor(
    HypervisorArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup_gateway(
        "DeleteHypervisor",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("HypervisorArn" => HypervisorArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_gateway_from_server(gateway_arn)
    disassociate_gateway_from_server(gateway_arn, params::Dict{String,<:Any})

Disassociates a backup gateway from the specified server. After the disassociation process
finishes, the gateway can no longer access the virtual machines on the server.

# Arguments
- `gateway_arn`: The Amazon Resource Name (ARN) of the gateway to disassociate.

"""
function disassociate_gateway_from_server(
    GatewayArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup_gateway(
        "DisassociateGatewayFromServer",
        Dict{String,Any}("GatewayArn" => GatewayArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_gateway_from_server(
    GatewayArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup_gateway(
        "DisassociateGatewayFromServer",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("GatewayArn" => GatewayArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_bandwidth_rate_limit_schedule(gateway_arn)
    get_bandwidth_rate_limit_schedule(gateway_arn, params::Dict{String,<:Any})

Retrieves the bandwidth rate limit schedule for a specified gateway. By default, gateways
do not have bandwidth rate limit schedules, which means no bandwidth rate limiting is in
effect. Use this to get a gateway's bandwidth rate limit schedule.

# Arguments
- `gateway_arn`: The Amazon Resource Name (ARN) of the gateway. Use the  ListGateways
  operation to return a list of gateways for your account and Amazon Web Services Region.

"""
function get_bandwidth_rate_limit_schedule(
    GatewayArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup_gateway(
        "GetBandwidthRateLimitSchedule",
        Dict{String,Any}("GatewayArn" => GatewayArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_bandwidth_rate_limit_schedule(
    GatewayArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup_gateway(
        "GetBandwidthRateLimitSchedule",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("GatewayArn" => GatewayArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_gateway(gateway_arn)
    get_gateway(gateway_arn, params::Dict{String,<:Any})

By providing the ARN (Amazon Resource Name), this API returns the gateway.

# Arguments
- `gateway_arn`: The Amazon Resource Name (ARN) of the gateway.

"""
function get_gateway(GatewayArn; aws_config::AbstractAWSConfig=current_aws_config())
    return backup_gateway(
        "GetGateway",
        Dict{String,Any}("GatewayArn" => GatewayArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_gateway(
    GatewayArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup_gateway(
        "GetGateway",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("GatewayArn" => GatewayArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_hypervisor(hypervisor_arn)
    get_hypervisor(hypervisor_arn, params::Dict{String,<:Any})

This action requests information about the specified hypervisor to which the gateway will
connect. A hypervisor is hardware, software, or firmware that creates and manages virtual
machines, and allocates resources to them.

# Arguments
- `hypervisor_arn`: The Amazon Resource Name (ARN) of the hypervisor.

"""
function get_hypervisor(HypervisorArn; aws_config::AbstractAWSConfig=current_aws_config())
    return backup_gateway(
        "GetHypervisor",
        Dict{String,Any}("HypervisorArn" => HypervisorArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_hypervisor(
    HypervisorArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup_gateway(
        "GetHypervisor",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("HypervisorArn" => HypervisorArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_hypervisor_property_mappings(hypervisor_arn)
    get_hypervisor_property_mappings(hypervisor_arn, params::Dict{String,<:Any})

This action retrieves the property mappings for the specified hypervisor. A hypervisor
property mapping displays the relationship of entity properties available from the
on-premises hypervisor to the properties available in Amazon Web Services.

# Arguments
- `hypervisor_arn`: The Amazon Resource Name (ARN) of the hypervisor.

"""
function get_hypervisor_property_mappings(
    HypervisorArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup_gateway(
        "GetHypervisorPropertyMappings",
        Dict{String,Any}("HypervisorArn" => HypervisorArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_hypervisor_property_mappings(
    HypervisorArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup_gateway(
        "GetHypervisorPropertyMappings",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("HypervisorArn" => HypervisorArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_virtual_machine(resource_arn)
    get_virtual_machine(resource_arn, params::Dict{String,<:Any})

By providing the ARN (Amazon Resource Name), this API returns the virtual machine.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the virtual machine.

"""
function get_virtual_machine(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup_gateway(
        "GetVirtualMachine",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_virtual_machine(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup_gateway(
        "GetVirtualMachine",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    import_hypervisor_configuration(host, name)
    import_hypervisor_configuration(host, name, params::Dict{String,<:Any})

Connect to a hypervisor by importing its configuration.

# Arguments
- `host`: The server host of the hypervisor. This can be either an IP address or a
  fully-qualified domain name (FQDN).
- `name`: The name of the hypervisor.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"KmsKeyArn"`: The Key Management Service for the hypervisor.
- `"Password"`: The password for the hypervisor.
- `"Tags"`: The tags of the hypervisor configuration to import.
- `"Username"`: The username for the hypervisor.
"""
function import_hypervisor_configuration(
    Host, Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup_gateway(
        "ImportHypervisorConfiguration",
        Dict{String,Any}("Host" => Host, "Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function import_hypervisor_configuration(
    Host,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup_gateway(
        "ImportHypervisorConfiguration",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Host" => Host, "Name" => Name), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_gateways()
    list_gateways(params::Dict{String,<:Any})

Lists backup gateways owned by an Amazon Web Services account in an Amazon Web Services
Region. The returned list is ordered by gateway Amazon Resource Name (ARN).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of gateways to list.
- `"NextToken"`: The next item following a partial list of returned resources. For example,
  if a request is made to return MaxResults number of resources, NextToken allows you to
  return more items in your list starting at the location pointed to by the next token.
"""
function list_gateways(; aws_config::AbstractAWSConfig=current_aws_config())
    return backup_gateway(
        "ListGateways"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_gateways(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup_gateway(
        "ListGateways", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_hypervisors()
    list_hypervisors(params::Dict{String,<:Any})

Lists your hypervisors.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of hypervisors to list.
- `"NextToken"`: The next item following a partial list of returned resources. For example,
  if a request is made to return maxResults number of resources, NextToken allows you to
  return more items in your list starting at the location pointed to by the next token.
"""
function list_hypervisors(; aws_config::AbstractAWSConfig=current_aws_config())
    return backup_gateway(
        "ListHypervisors"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_hypervisors(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup_gateway(
        "ListHypervisors", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists the tags applied to the resource identified by its Amazon Resource Name (ARN).

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource's tags to list.

"""
function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup_gateway(
        "ListTagsForResource",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup_gateway(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_virtual_machines()
    list_virtual_machines(params::Dict{String,<:Any})

Lists your virtual machines.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"HypervisorArn"`: The Amazon Resource Name (ARN) of the hypervisor connected to your
  virtual machine.
- `"MaxResults"`: The maximum number of virtual machines to list.
- `"NextToken"`: The next item following a partial list of returned resources. For example,
  if a request is made to return maxResults number of resources, NextToken allows you to
  return more items in your list starting at the location pointed to by the next token.
"""
function list_virtual_machines(; aws_config::AbstractAWSConfig=current_aws_config())
    return backup_gateway(
        "ListVirtualMachines"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_virtual_machines(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup_gateway(
        "ListVirtualMachines",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_bandwidth_rate_limit_schedule(bandwidth_rate_limit_intervals, gateway_arn)
    put_bandwidth_rate_limit_schedule(bandwidth_rate_limit_intervals, gateway_arn, params::Dict{String,<:Any})

This action sets the bandwidth rate limit schedule for a specified gateway. By default,
gateways do not have a bandwidth rate limit schedule, which means no bandwidth rate
limiting is in effect. Use this to initiate a gateway's bandwidth rate limit schedule.

# Arguments
- `bandwidth_rate_limit_intervals`: An array containing bandwidth rate limit schedule
  intervals for a gateway. When no bandwidth rate limit intervals have been scheduled, the
  array is empty.
- `gateway_arn`: The Amazon Resource Name (ARN) of the gateway. Use the  ListGateways
  operation to return a list of gateways for your account and Amazon Web Services Region.

"""
function put_bandwidth_rate_limit_schedule(
    BandwidthRateLimitIntervals,
    GatewayArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup_gateway(
        "PutBandwidthRateLimitSchedule",
        Dict{String,Any}(
            "BandwidthRateLimitIntervals" => BandwidthRateLimitIntervals,
            "GatewayArn" => GatewayArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_bandwidth_rate_limit_schedule(
    BandwidthRateLimitIntervals,
    GatewayArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup_gateway(
        "PutBandwidthRateLimitSchedule",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "BandwidthRateLimitIntervals" => BandwidthRateLimitIntervals,
                    "GatewayArn" => GatewayArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_hypervisor_property_mappings(hypervisor_arn, iam_role_arn, vmware_to_aws_tag_mappings)
    put_hypervisor_property_mappings(hypervisor_arn, iam_role_arn, vmware_to_aws_tag_mappings, params::Dict{String,<:Any})

This action sets the property mappings for the specified hypervisor. A hypervisor property
mapping displays the relationship of entity properties available from the on-premises
hypervisor to the properties available in Amazon Web Services.

# Arguments
- `hypervisor_arn`: The Amazon Resource Name (ARN) of the hypervisor.
- `iam_role_arn`: The Amazon Resource Name (ARN) of the IAM role.
- `vmware_to_aws_tag_mappings`: This action requests the mappings of on-premises VMware
  tags to the Amazon Web Services tags.

"""
function put_hypervisor_property_mappings(
    HypervisorArn,
    IamRoleArn,
    VmwareToAwsTagMappings;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup_gateway(
        "PutHypervisorPropertyMappings",
        Dict{String,Any}(
            "HypervisorArn" => HypervisorArn,
            "IamRoleArn" => IamRoleArn,
            "VmwareToAwsTagMappings" => VmwareToAwsTagMappings,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_hypervisor_property_mappings(
    HypervisorArn,
    IamRoleArn,
    VmwareToAwsTagMappings,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup_gateway(
        "PutHypervisorPropertyMappings",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "HypervisorArn" => HypervisorArn,
                    "IamRoleArn" => IamRoleArn,
                    "VmwareToAwsTagMappings" => VmwareToAwsTagMappings,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_maintenance_start_time(gateway_arn, hour_of_day, minute_of_hour)
    put_maintenance_start_time(gateway_arn, hour_of_day, minute_of_hour, params::Dict{String,<:Any})

Set the maintenance start time for a gateway.

# Arguments
- `gateway_arn`: The Amazon Resource Name (ARN) for the gateway, used to specify its
  maintenance start time.
- `hour_of_day`: The hour of the day to start maintenance on a gateway.
- `minute_of_hour`: The minute of the hour to start maintenance on a gateway.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DayOfMonth"`: The day of the month start maintenance on a gateway. Valid values range
  from Sunday to Saturday.
- `"DayOfWeek"`: The day of the week to start maintenance on a gateway.
"""
function put_maintenance_start_time(
    GatewayArn, HourOfDay, MinuteOfHour; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup_gateway(
        "PutMaintenanceStartTime",
        Dict{String,Any}(
            "GatewayArn" => GatewayArn,
            "HourOfDay" => HourOfDay,
            "MinuteOfHour" => MinuteOfHour,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_maintenance_start_time(
    GatewayArn,
    HourOfDay,
    MinuteOfHour,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup_gateway(
        "PutMaintenanceStartTime",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "GatewayArn" => GatewayArn,
                    "HourOfDay" => HourOfDay,
                    "MinuteOfHour" => MinuteOfHour,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_virtual_machines_metadata_sync(hypervisor_arn)
    start_virtual_machines_metadata_sync(hypervisor_arn, params::Dict{String,<:Any})

This action sends a request to sync metadata across the specified virtual machines.

# Arguments
- `hypervisor_arn`: The Amazon Resource Name (ARN) of the hypervisor.

"""
function start_virtual_machines_metadata_sync(
    HypervisorArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup_gateway(
        "StartVirtualMachinesMetadataSync",
        Dict{String,Any}("HypervisorArn" => HypervisorArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_virtual_machines_metadata_sync(
    HypervisorArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup_gateway(
        "StartVirtualMachinesMetadataSync",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("HypervisorArn" => HypervisorArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Tag the resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource to tag.
- `tags`: A list of tags to assign to the resource.

"""
function tag_resource(ResourceARN, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return backup_gateway(
        "TagResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceARN,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup_gateway(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    test_hypervisor_configuration(gateway_arn, host)
    test_hypervisor_configuration(gateway_arn, host, params::Dict{String,<:Any})

Tests your hypervisor configuration to validate that backup gateway can connect with the
hypervisor and its resources.

# Arguments
- `gateway_arn`: The Amazon Resource Name (ARN) of the gateway to the hypervisor to test.
- `host`: The server host of the hypervisor. This can be either an IP address or a
  fully-qualified domain name (FQDN).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Password"`: The password for the hypervisor.
- `"Username"`: The username for the hypervisor.
"""
function test_hypervisor_configuration(
    GatewayArn, Host; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup_gateway(
        "TestHypervisorConfiguration",
        Dict{String,Any}("GatewayArn" => GatewayArn, "Host" => Host);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function test_hypervisor_configuration(
    GatewayArn,
    Host,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup_gateway(
        "TestHypervisorConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("GatewayArn" => GatewayArn, "Host" => Host), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes tags from the resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource from which to remove tags.
- `tag_keys`: The list of tag keys specifying which tags to remove.

"""
function untag_resource(
    ResourceARN, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup_gateway(
        "UntagResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceARN,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup_gateway(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_gateway_information(gateway_arn)
    update_gateway_information(gateway_arn, params::Dict{String,<:Any})

Updates a gateway's name. Specify which gateway to update using the Amazon Resource Name
(ARN) of the gateway in your request.

# Arguments
- `gateway_arn`: The Amazon Resource Name (ARN) of the gateway to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"GatewayDisplayName"`: The updated display name of the gateway.
"""
function update_gateway_information(
    GatewayArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup_gateway(
        "UpdateGatewayInformation",
        Dict{String,Any}("GatewayArn" => GatewayArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_gateway_information(
    GatewayArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup_gateway(
        "UpdateGatewayInformation",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("GatewayArn" => GatewayArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_gateway_software_now(gateway_arn)
    update_gateway_software_now(gateway_arn, params::Dict{String,<:Any})

Updates the gateway virtual machine (VM) software. The request immediately triggers the
software update.  When you make this request, you get a 200 OK success response
immediately. However, it might take some time for the update to complete.

# Arguments
- `gateway_arn`: The Amazon Resource Name (ARN) of the gateway to be updated.

"""
function update_gateway_software_now(
    GatewayArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup_gateway(
        "UpdateGatewaySoftwareNow",
        Dict{String,Any}("GatewayArn" => GatewayArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_gateway_software_now(
    GatewayArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup_gateway(
        "UpdateGatewaySoftwareNow",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("GatewayArn" => GatewayArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_hypervisor(hypervisor_arn)
    update_hypervisor(hypervisor_arn, params::Dict{String,<:Any})

Updates a hypervisor metadata, including its host, username, and password. Specify which
hypervisor to update using the Amazon Resource Name (ARN) of the hypervisor in your request.

# Arguments
- `hypervisor_arn`: The Amazon Resource Name (ARN) of the hypervisor to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Host"`: The updated host of the hypervisor. This can be either an IP address or a
  fully-qualified domain name (FQDN).
- `"LogGroupArn"`: The Amazon Resource Name (ARN) of the group of gateways within the
  requested log.
- `"Name"`: The updated name for the hypervisor
- `"Password"`: The updated password for the hypervisor.
- `"Username"`: The updated username for the hypervisor.
"""
function update_hypervisor(
    HypervisorArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return backup_gateway(
        "UpdateHypervisor",
        Dict{String,Any}("HypervisorArn" => HypervisorArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_hypervisor(
    HypervisorArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return backup_gateway(
        "UpdateHypervisor",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("HypervisorArn" => HypervisorArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: clouddirectory
using AWS.Compat
using AWS.UUIDs

"""
    add_facet_to_object(object_reference, schema_facet, x-amz-data-partition)
    add_facet_to_object(object_reference, schema_facet, x-amz-data-partition, params::Dict{String,<:Any})

Adds a new Facet to an object. An object can have more than one facet applied on it.

# Arguments
- `object_reference`: A reference to the object you are adding the specified facet to.
- `schema_facet`: Identifiers for the facet that you are adding to the object. See
  SchemaFacet for details.
- `x-amz-data-partition`: The Amazon Resource Name (ARN) that is associated with the
  Directory where the object resides. For more information, see arns.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ObjectAttributeList"`: Attributes on the facet that you are adding to the object.
"""
function add_facet_to_object(
    ObjectReference,
    SchemaFacet,
    x_amz_data_partition;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/object/facets",
        Dict{String,Any}(
            "ObjectReference" => ObjectReference,
            "SchemaFacet" => SchemaFacet,
            "headers" => Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_facet_to_object(
    ObjectReference,
    SchemaFacet,
    x_amz_data_partition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/object/facets",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ObjectReference" => ObjectReference,
                    "SchemaFacet" => SchemaFacet,
                    "headers" =>
                        Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    apply_schema(published_schema_arn, x-amz-data-partition)
    apply_schema(published_schema_arn, x-amz-data-partition, params::Dict{String,<:Any})

Copies the input published schema, at the specified version, into the Directory with the
same name and version as that of the published schema.

# Arguments
- `published_schema_arn`: Published schema Amazon Resource Name (ARN) that needs to be
  copied. For more information, see arns.
- `x-amz-data-partition`: The Amazon Resource Name (ARN) that is associated with the
  Directory into which the schema is copied. For more information, see arns.

"""
function apply_schema(
    PublishedSchemaArn,
    x_amz_data_partition;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/schema/apply",
        Dict{String,Any}(
            "PublishedSchemaArn" => PublishedSchemaArn,
            "headers" => Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function apply_schema(
    PublishedSchemaArn,
    x_amz_data_partition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/schema/apply",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "PublishedSchemaArn" => PublishedSchemaArn,
                    "headers" =>
                        Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    attach_object(child_reference, link_name, parent_reference, x-amz-data-partition)
    attach_object(child_reference, link_name, parent_reference, x-amz-data-partition, params::Dict{String,<:Any})

Attaches an existing object to another object. An object can be accessed in two ways:
Using the path   Using ObjectIdentifier

# Arguments
- `child_reference`: The child object reference to be attached to the object.
- `link_name`: The link name with which the child object is attached to the parent.
- `parent_reference`: The parent object reference.
- `x-amz-data-partition`: Amazon Resource Name (ARN) that is associated with the Directory
  where both objects reside. For more information, see arns.

"""
function attach_object(
    ChildReference,
    LinkName,
    ParentReference,
    x_amz_data_partition;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/object/attach",
        Dict{String,Any}(
            "ChildReference" => ChildReference,
            "LinkName" => LinkName,
            "ParentReference" => ParentReference,
            "headers" => Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function attach_object(
    ChildReference,
    LinkName,
    ParentReference,
    x_amz_data_partition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/object/attach",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ChildReference" => ChildReference,
                    "LinkName" => LinkName,
                    "ParentReference" => ParentReference,
                    "headers" =>
                        Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    attach_policy(object_reference, policy_reference, x-amz-data-partition)
    attach_policy(object_reference, policy_reference, x-amz-data-partition, params::Dict{String,<:Any})

Attaches a policy object to a regular object. An object can have a limited number of
attached policies.

# Arguments
- `object_reference`: The reference that identifies the object to which the policy will be
  attached.
- `policy_reference`: The reference that is associated with the policy object.
- `x-amz-data-partition`: The Amazon Resource Name (ARN) that is associated with the
  Directory where both objects reside. For more information, see arns.

"""
function attach_policy(
    ObjectReference,
    PolicyReference,
    x_amz_data_partition;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/policy/attach",
        Dict{String,Any}(
            "ObjectReference" => ObjectReference,
            "PolicyReference" => PolicyReference,
            "headers" => Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function attach_policy(
    ObjectReference,
    PolicyReference,
    x_amz_data_partition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/policy/attach",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ObjectReference" => ObjectReference,
                    "PolicyReference" => PolicyReference,
                    "headers" =>
                        Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    attach_to_index(index_reference, target_reference, x-amz-data-partition)
    attach_to_index(index_reference, target_reference, x-amz-data-partition, params::Dict{String,<:Any})

Attaches the specified object to the specified index.

# Arguments
- `index_reference`: A reference to the index that you are attaching the object to.
- `target_reference`: A reference to the object that you are attaching to the index.
- `x-amz-data-partition`: The Amazon Resource Name (ARN) of the directory where the object
  and index exist.

"""
function attach_to_index(
    IndexReference,
    TargetReference,
    x_amz_data_partition;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/index/attach",
        Dict{String,Any}(
            "IndexReference" => IndexReference,
            "TargetReference" => TargetReference,
            "headers" => Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function attach_to_index(
    IndexReference,
    TargetReference,
    x_amz_data_partition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/index/attach",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "IndexReference" => IndexReference,
                    "TargetReference" => TargetReference,
                    "headers" =>
                        Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    attach_typed_link(attributes, source_object_reference, target_object_reference, typed_link_facet, x-amz-data-partition)
    attach_typed_link(attributes, source_object_reference, target_object_reference, typed_link_facet, x-amz-data-partition, params::Dict{String,<:Any})

Attaches a typed link to a specified source and target object. For more information, see
Typed Links.

# Arguments
- `attributes`: A set of attributes that are associated with the typed link.
- `source_object_reference`: Identifies the source object that the typed link will attach
  to.
- `target_object_reference`: Identifies the target object that the typed link will attach
  to.
- `typed_link_facet`: Identifies the typed link facet that is associated with the typed
  link.
- `x-amz-data-partition`: The Amazon Resource Name (ARN) of the directory where you want to
  attach the typed link.

"""
function attach_typed_link(
    Attributes,
    SourceObjectReference,
    TargetObjectReference,
    TypedLinkFacet,
    x_amz_data_partition;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/typedlink/attach",
        Dict{String,Any}(
            "Attributes" => Attributes,
            "SourceObjectReference" => SourceObjectReference,
            "TargetObjectReference" => TargetObjectReference,
            "TypedLinkFacet" => TypedLinkFacet,
            "headers" => Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function attach_typed_link(
    Attributes,
    SourceObjectReference,
    TargetObjectReference,
    TypedLinkFacet,
    x_amz_data_partition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/typedlink/attach",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Attributes" => Attributes,
                    "SourceObjectReference" => SourceObjectReference,
                    "TargetObjectReference" => TargetObjectReference,
                    "TypedLinkFacet" => TypedLinkFacet,
                    "headers" =>
                        Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_read(operations, x-amz-data-partition)
    batch_read(operations, x-amz-data-partition, params::Dict{String,<:Any})

Performs all the read operations in a batch.

# Arguments
- `operations`: A list of operations that are part of the batch.
- `x-amz-data-partition`: The Amazon Resource Name (ARN) that is associated with the
  Directory. For more information, see arns.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"x-amz-consistency-level"`: Represents the manner and timing in which the successful
  write or update of an object is reflected in a subsequent read operation of that same
  object.
"""
function batch_read(
    Operations, x_amz_data_partition; aws_config::AbstractAWSConfig=current_aws_config()
)
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/batchread",
        Dict{String,Any}(
            "Operations" => Operations,
            "headers" => Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_read(
    Operations,
    x_amz_data_partition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/batchread",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Operations" => Operations,
                    "headers" =>
                        Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_write(operations, x-amz-data-partition)
    batch_write(operations, x-amz-data-partition, params::Dict{String,<:Any})

Performs all the write operations in a batch. Either all the operations succeed or none.

# Arguments
- `operations`: A list of operations that are part of the batch.
- `x-amz-data-partition`: The Amazon Resource Name (ARN) that is associated with the
  Directory. For more information, see arns.

"""
function batch_write(
    Operations, x_amz_data_partition; aws_config::AbstractAWSConfig=current_aws_config()
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/batchwrite",
        Dict{String,Any}(
            "Operations" => Operations,
            "headers" => Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_write(
    Operations,
    x_amz_data_partition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/batchwrite",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Operations" => Operations,
                    "headers" =>
                        Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_directory(name, x-amz-data-partition)
    create_directory(name, x-amz-data-partition, params::Dict{String,<:Any})

Creates a Directory by copying the published schema into the directory. A directory cannot
be created without a schema. You can also quickly create a directory using a managed
schema, called the QuickStartSchema. For more information, see Managed Schema in the Amazon
Cloud Directory Developer Guide.

# Arguments
- `name`: The name of the Directory. Should be unique per account, per region.
- `x-amz-data-partition`: The Amazon Resource Name (ARN) of the published schema that will
  be copied into the data Directory. For more information, see arns.

"""
function create_directory(
    Name, x_amz_data_partition; aws_config::AbstractAWSConfig=current_aws_config()
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/directory/create",
        Dict{String,Any}(
            "Name" => Name,
            "headers" => Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_directory(
    Name,
    x_amz_data_partition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/directory/create",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Name" => Name,
                    "headers" =>
                        Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_facet(name, x-amz-data-partition)
    create_facet(name, x-amz-data-partition, params::Dict{String,<:Any})

Creates a new Facet in a schema. Facet creation is allowed only in development or applied
schemas.

# Arguments
- `name`: The name of the Facet, which is unique for a given schema.
- `x-amz-data-partition`: The schema ARN in which the new Facet will be created. For more
  information, see arns.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Attributes"`: The attributes that are associated with the Facet.
- `"FacetStyle"`: There are two different styles that you can define on any given facet,
  Static and Dynamic. For static facets, all attributes must be defined in the schema. For
  dynamic facets, attributes can be defined during data plane operations.
- `"ObjectType"`: Specifies whether a given object created from this facet is of type node,
  leaf node, policy or index.   Node: Can have multiple children but one parent.     Leaf
  node: Cannot have children but can have multiple parents.     Policy: Allows you to store a
  policy document and policy type. For more information, see Policies.     Index: Can be
  created with the Index API.
"""
function create_facet(
    Name, x_amz_data_partition; aws_config::AbstractAWSConfig=current_aws_config()
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/facet/create",
        Dict{String,Any}(
            "Name" => Name,
            "headers" => Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_facet(
    Name,
    x_amz_data_partition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/facet/create",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Name" => Name,
                    "headers" =>
                        Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_index(is_unique, ordered_indexed_attribute_list, x-amz-data-partition)
    create_index(is_unique, ordered_indexed_attribute_list, x-amz-data-partition, params::Dict{String,<:Any})

Creates an index object. See Indexing and search for more information.

# Arguments
- `is_unique`: Indicates whether the attribute that is being indexed has unique values or
  not.
- `ordered_indexed_attribute_list`: Specifies the attributes that should be indexed on.
  Currently only a single attribute is supported.
- `x-amz-data-partition`: The ARN of the directory where the index should be created.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"LinkName"`: The name of the link between the parent object and the index object.
- `"ParentReference"`: A reference to the parent object that contains the index object.
"""
function create_index(
    IsUnique,
    OrderedIndexedAttributeList,
    x_amz_data_partition;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/index",
        Dict{String,Any}(
            "IsUnique" => IsUnique,
            "OrderedIndexedAttributeList" => OrderedIndexedAttributeList,
            "headers" => Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_index(
    IsUnique,
    OrderedIndexedAttributeList,
    x_amz_data_partition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/index",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "IsUnique" => IsUnique,
                    "OrderedIndexedAttributeList" => OrderedIndexedAttributeList,
                    "headers" =>
                        Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_object(schema_facets, x-amz-data-partition)
    create_object(schema_facets, x-amz-data-partition, params::Dict{String,<:Any})

Creates an object in a Directory. Additionally attaches the object to a parent, if a parent
reference and LinkName is specified. An object is simply a collection of Facet attributes.
You can also use this API call to create a policy object, if the facet from which you
create the object is a policy facet.

# Arguments
- `schema_facets`: A list of schema facets to be associated with the object. Do not provide
  minor version components. See SchemaFacet for details.
- `x-amz-data-partition`: The Amazon Resource Name (ARN) that is associated with the
  Directory in which the object will be created. For more information, see arns.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"LinkName"`: The name of link that is used to attach this object to a parent.
- `"ObjectAttributeList"`: The attribute map whose attribute ARN contains the key and
  attribute value as the map value.
- `"ParentReference"`: If specified, the parent reference to which this object will be
  attached.
"""
function create_object(
    SchemaFacets, x_amz_data_partition; aws_config::AbstractAWSConfig=current_aws_config()
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/object",
        Dict{String,Any}(
            "SchemaFacets" => SchemaFacets,
            "headers" => Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_object(
    SchemaFacets,
    x_amz_data_partition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/object",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "SchemaFacets" => SchemaFacets,
                    "headers" =>
                        Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_schema(name)
    create_schema(name, params::Dict{String,<:Any})

Creates a new schema in a development state. A schema can exist in three phases:
Development: This is a mutable phase of the schema. All new schemas are in the development
phase. Once the schema is finalized, it can be published.    Published: Published schemas
are immutable and have a version associated with them.    Applied: Applied schemas are
mutable in a way that allows you to add new schema facets. You can also add new,
nonrequired attributes to existing schema facets. You can apply only published schemas to
directories.

# Arguments
- `name`: The name that is associated with the schema. This is unique to each account and
  in each region.

"""
function create_schema(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/schema/create",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_schema(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/schema/create",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_typed_link_facet(facet, x-amz-data-partition)
    create_typed_link_facet(facet, x-amz-data-partition, params::Dict{String,<:Any})

Creates a TypedLinkFacet. For more information, see Typed Links.

# Arguments
- `facet`:  Facet structure that is associated with the typed link facet.
- `x-amz-data-partition`: The Amazon Resource Name (ARN) that is associated with the
  schema. For more information, see arns.

"""
function create_typed_link_facet(
    Facet, x_amz_data_partition; aws_config::AbstractAWSConfig=current_aws_config()
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/typedlink/facet/create",
        Dict{String,Any}(
            "Facet" => Facet,
            "headers" => Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_typed_link_facet(
    Facet,
    x_amz_data_partition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/typedlink/facet/create",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Facet" => Facet,
                    "headers" =>
                        Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_directory(x-amz-data-partition)
    delete_directory(x-amz-data-partition, params::Dict{String,<:Any})

Deletes a directory. Only disabled directories can be deleted. A deleted directory cannot
be undone. Exercise extreme caution when deleting directories.

# Arguments
- `x-amz-data-partition`: The ARN of the directory to delete.

"""
function delete_directory(
    x_amz_data_partition; aws_config::AbstractAWSConfig=current_aws_config()
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/directory",
        Dict{String,Any}(
            "headers" => Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_directory(
    x_amz_data_partition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/directory",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "headers" =>
                        Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_facet(name, x-amz-data-partition)
    delete_facet(name, x-amz-data-partition, params::Dict{String,<:Any})

Deletes a given Facet. All attributes and Rules that are associated with the facet will be
deleted. Only development schema facets are allowed deletion.

# Arguments
- `name`: The name of the facet to delete.
- `x-amz-data-partition`: The Amazon Resource Name (ARN) that is associated with the Facet.
  For more information, see arns.

"""
function delete_facet(
    Name, x_amz_data_partition; aws_config::AbstractAWSConfig=current_aws_config()
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/facet/delete",
        Dict{String,Any}(
            "Name" => Name,
            "headers" => Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_facet(
    Name,
    x_amz_data_partition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/facet/delete",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Name" => Name,
                    "headers" =>
                        Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_object(object_reference, x-amz-data-partition)
    delete_object(object_reference, x-amz-data-partition, params::Dict{String,<:Any})

Deletes an object and its associated attributes. Only objects with no children and no
parents can be deleted. The maximum number of attributes that can be deleted during an
object deletion is 30. For more information, see Amazon Cloud Directory Limits.

# Arguments
- `object_reference`: A reference that identifies the object.
- `x-amz-data-partition`: The Amazon Resource Name (ARN) that is associated with the
  Directory where the object resides. For more information, see arns.

"""
function delete_object(
    ObjectReference,
    x_amz_data_partition;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/object/delete",
        Dict{String,Any}(
            "ObjectReference" => ObjectReference,
            "headers" => Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_object(
    ObjectReference,
    x_amz_data_partition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/object/delete",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ObjectReference" => ObjectReference,
                    "headers" =>
                        Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_schema(x-amz-data-partition)
    delete_schema(x-amz-data-partition, params::Dict{String,<:Any})

Deletes a given schema. Schemas in a development and published state can only be deleted.

# Arguments
- `x-amz-data-partition`: The Amazon Resource Name (ARN) of the development schema. For
  more information, see arns.

"""
function delete_schema(
    x_amz_data_partition; aws_config::AbstractAWSConfig=current_aws_config()
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/schema",
        Dict{String,Any}(
            "headers" => Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_schema(
    x_amz_data_partition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/schema",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "headers" =>
                        Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_typed_link_facet(name, x-amz-data-partition)
    delete_typed_link_facet(name, x-amz-data-partition, params::Dict{String,<:Any})

Deletes a TypedLinkFacet. For more information, see Typed Links.

# Arguments
- `name`: The unique name of the typed link facet.
- `x-amz-data-partition`: The Amazon Resource Name (ARN) that is associated with the
  schema. For more information, see arns.

"""
function delete_typed_link_facet(
    Name, x_amz_data_partition; aws_config::AbstractAWSConfig=current_aws_config()
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/typedlink/facet/delete",
        Dict{String,Any}(
            "Name" => Name,
            "headers" => Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_typed_link_facet(
    Name,
    x_amz_data_partition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/typedlink/facet/delete",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Name" => Name,
                    "headers" =>
                        Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    detach_from_index(index_reference, target_reference, x-amz-data-partition)
    detach_from_index(index_reference, target_reference, x-amz-data-partition, params::Dict{String,<:Any})

Detaches the specified object from the specified index.

# Arguments
- `index_reference`: A reference to the index object.
- `target_reference`: A reference to the object being detached from the index.
- `x-amz-data-partition`: The Amazon Resource Name (ARN) of the directory the index and
  object exist in.

"""
function detach_from_index(
    IndexReference,
    TargetReference,
    x_amz_data_partition;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/index/detach",
        Dict{String,Any}(
            "IndexReference" => IndexReference,
            "TargetReference" => TargetReference,
            "headers" => Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function detach_from_index(
    IndexReference,
    TargetReference,
    x_amz_data_partition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/index/detach",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "IndexReference" => IndexReference,
                    "TargetReference" => TargetReference,
                    "headers" =>
                        Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    detach_object(link_name, parent_reference, x-amz-data-partition)
    detach_object(link_name, parent_reference, x-amz-data-partition, params::Dict{String,<:Any})

Detaches a given object from the parent object. The object that is to be detached from the
parent is specified by the link name.

# Arguments
- `link_name`: The link name associated with the object that needs to be detached.
- `parent_reference`: The parent reference from which the object with the specified link
  name is detached.
- `x-amz-data-partition`: The Amazon Resource Name (ARN) that is associated with the
  Directory where objects reside. For more information, see arns.

"""
function detach_object(
    LinkName,
    ParentReference,
    x_amz_data_partition;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/object/detach",
        Dict{String,Any}(
            "LinkName" => LinkName,
            "ParentReference" => ParentReference,
            "headers" => Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function detach_object(
    LinkName,
    ParentReference,
    x_amz_data_partition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/object/detach",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "LinkName" => LinkName,
                    "ParentReference" => ParentReference,
                    "headers" =>
                        Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    detach_policy(object_reference, policy_reference, x-amz-data-partition)
    detach_policy(object_reference, policy_reference, x-amz-data-partition, params::Dict{String,<:Any})

Detaches a policy from an object.

# Arguments
- `object_reference`: Reference that identifies the object whose policy object will be
  detached.
- `policy_reference`: Reference that identifies the policy object.
- `x-amz-data-partition`: The Amazon Resource Name (ARN) that is associated with the
  Directory where both objects reside. For more information, see arns.

"""
function detach_policy(
    ObjectReference,
    PolicyReference,
    x_amz_data_partition;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/policy/detach",
        Dict{String,Any}(
            "ObjectReference" => ObjectReference,
            "PolicyReference" => PolicyReference,
            "headers" => Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function detach_policy(
    ObjectReference,
    PolicyReference,
    x_amz_data_partition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/policy/detach",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ObjectReference" => ObjectReference,
                    "PolicyReference" => PolicyReference,
                    "headers" =>
                        Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    detach_typed_link(typed_link_specifier, x-amz-data-partition)
    detach_typed_link(typed_link_specifier, x-amz-data-partition, params::Dict{String,<:Any})

Detaches a typed link from a specified source and target object. For more information, see
Typed Links.

# Arguments
- `typed_link_specifier`: Used to accept a typed link specifier as input.
- `x-amz-data-partition`: The Amazon Resource Name (ARN) of the directory where you want to
  detach the typed link.

"""
function detach_typed_link(
    TypedLinkSpecifier,
    x_amz_data_partition;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/typedlink/detach",
        Dict{String,Any}(
            "TypedLinkSpecifier" => TypedLinkSpecifier,
            "headers" => Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function detach_typed_link(
    TypedLinkSpecifier,
    x_amz_data_partition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/typedlink/detach",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "TypedLinkSpecifier" => TypedLinkSpecifier,
                    "headers" =>
                        Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disable_directory(x-amz-data-partition)
    disable_directory(x-amz-data-partition, params::Dict{String,<:Any})

Disables the specified directory. Disabled directories cannot be read or written to. Only
enabled directories can be disabled. Disabled directories may be reenabled.

# Arguments
- `x-amz-data-partition`: The ARN of the directory to disable.

"""
function disable_directory(
    x_amz_data_partition; aws_config::AbstractAWSConfig=current_aws_config()
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/directory/disable",
        Dict{String,Any}(
            "headers" => Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disable_directory(
    x_amz_data_partition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/directory/disable",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "headers" =>
                        Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    enable_directory(x-amz-data-partition)
    enable_directory(x-amz-data-partition, params::Dict{String,<:Any})

Enables the specified directory. Only disabled directories can be enabled. Once enabled,
the directory can then be read and written to.

# Arguments
- `x-amz-data-partition`: The ARN of the directory to enable.

"""
function enable_directory(
    x_amz_data_partition; aws_config::AbstractAWSConfig=current_aws_config()
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/directory/enable",
        Dict{String,Any}(
            "headers" => Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function enable_directory(
    x_amz_data_partition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/directory/enable",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "headers" =>
                        Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_applied_schema_version(schema_arn)
    get_applied_schema_version(schema_arn, params::Dict{String,<:Any})

Returns current applied schema version ARN, including the minor version in use.

# Arguments
- `schema_arn`: The ARN of the applied schema.

"""
function get_applied_schema_version(
    SchemaArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/schema/getappliedschema",
        Dict{String,Any}("SchemaArn" => SchemaArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_applied_schema_version(
    SchemaArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/schema/getappliedschema",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("SchemaArn" => SchemaArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_directory(x-amz-data-partition)
    get_directory(x-amz-data-partition, params::Dict{String,<:Any})

Retrieves metadata about a directory.

# Arguments
- `x-amz-data-partition`: The ARN of the directory.

"""
function get_directory(
    x_amz_data_partition; aws_config::AbstractAWSConfig=current_aws_config()
)
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/directory/get",
        Dict{String,Any}(
            "headers" => Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_directory(
    x_amz_data_partition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/directory/get",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "headers" =>
                        Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_facet(name, x-amz-data-partition)
    get_facet(name, x-amz-data-partition, params::Dict{String,<:Any})

Gets details of the Facet, such as facet name, attributes, Rules, or ObjectType. You can
call this on all kinds of schema facets -- published, development, or applied.

# Arguments
- `name`: The name of the facet to retrieve.
- `x-amz-data-partition`: The Amazon Resource Name (ARN) that is associated with the Facet.
  For more information, see arns.

"""
function get_facet(
    Name, x_amz_data_partition; aws_config::AbstractAWSConfig=current_aws_config()
)
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/facet",
        Dict{String,Any}(
            "Name" => Name,
            "headers" => Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_facet(
    Name,
    x_amz_data_partition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/facet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Name" => Name,
                    "headers" =>
                        Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_link_attributes(attribute_names, typed_link_specifier, x-amz-data-partition)
    get_link_attributes(attribute_names, typed_link_specifier, x-amz-data-partition, params::Dict{String,<:Any})

Retrieves attributes that are associated with a typed link.

# Arguments
- `attribute_names`: A list of attribute names whose values will be retrieved.
- `typed_link_specifier`: Allows a typed link specifier to be accepted as input.
- `x-amz-data-partition`: The Amazon Resource Name (ARN) that is associated with the
  Directory where the typed link resides. For more information, see arns or Typed Links.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConsistencyLevel"`: The consistency level at which to retrieve the attributes on a
  typed link.
"""
function get_link_attributes(
    AttributeNames,
    TypedLinkSpecifier,
    x_amz_data_partition;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/typedlink/attributes/get",
        Dict{String,Any}(
            "AttributeNames" => AttributeNames,
            "TypedLinkSpecifier" => TypedLinkSpecifier,
            "headers" => Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_link_attributes(
    AttributeNames,
    TypedLinkSpecifier,
    x_amz_data_partition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/typedlink/attributes/get",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AttributeNames" => AttributeNames,
                    "TypedLinkSpecifier" => TypedLinkSpecifier,
                    "headers" =>
                        Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_object_attributes(attribute_names, object_reference, schema_facet, x-amz-data-partition)
    get_object_attributes(attribute_names, object_reference, schema_facet, x-amz-data-partition, params::Dict{String,<:Any})

Retrieves attributes within a facet that are associated with an object.

# Arguments
- `attribute_names`: List of attribute names whose values will be retrieved.
- `object_reference`: Reference that identifies the object whose attributes will be
  retrieved.
- `schema_facet`: Identifier for the facet whose attributes will be retrieved. See
  SchemaFacet for details.
- `x-amz-data-partition`: The Amazon Resource Name (ARN) that is associated with the
  Directory where the object resides.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"x-amz-consistency-level"`: The consistency level at which to retrieve the attributes on
  an object.
"""
function get_object_attributes(
    AttributeNames,
    ObjectReference,
    SchemaFacet,
    x_amz_data_partition;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/object/attributes/get",
        Dict{String,Any}(
            "AttributeNames" => AttributeNames,
            "ObjectReference" => ObjectReference,
            "SchemaFacet" => SchemaFacet,
            "headers" => Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_object_attributes(
    AttributeNames,
    ObjectReference,
    SchemaFacet,
    x_amz_data_partition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/object/attributes/get",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AttributeNames" => AttributeNames,
                    "ObjectReference" => ObjectReference,
                    "SchemaFacet" => SchemaFacet,
                    "headers" =>
                        Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_object_information(object_reference, x-amz-data-partition)
    get_object_information(object_reference, x-amz-data-partition, params::Dict{String,<:Any})

Retrieves metadata about an object.

# Arguments
- `object_reference`: A reference to the object.
- `x-amz-data-partition`: The ARN of the directory being retrieved.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"x-amz-consistency-level"`: The consistency level at which to retrieve the object
  information.
"""
function get_object_information(
    ObjectReference,
    x_amz_data_partition;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/object/information",
        Dict{String,Any}(
            "ObjectReference" => ObjectReference,
            "headers" => Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_object_information(
    ObjectReference,
    x_amz_data_partition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/object/information",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ObjectReference" => ObjectReference,
                    "headers" =>
                        Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_schema_as_json(x-amz-data-partition)
    get_schema_as_json(x-amz-data-partition, params::Dict{String,<:Any})

Retrieves a JSON representation of the schema. See JSON Schema Format for more information.

# Arguments
- `x-amz-data-partition`: The ARN of the schema to retrieve.

"""
function get_schema_as_json(
    x_amz_data_partition; aws_config::AbstractAWSConfig=current_aws_config()
)
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/schema/json",
        Dict{String,Any}(
            "headers" => Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_schema_as_json(
    x_amz_data_partition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/schema/json",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "headers" =>
                        Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_typed_link_facet_information(name, x-amz-data-partition)
    get_typed_link_facet_information(name, x-amz-data-partition, params::Dict{String,<:Any})

Returns the identity attribute order for a specific TypedLinkFacet. For more information,
see Typed Links.

# Arguments
- `name`: The unique name of the typed link facet.
- `x-amz-data-partition`: The Amazon Resource Name (ARN) that is associated with the
  schema. For more information, see arns.

"""
function get_typed_link_facet_information(
    Name, x_amz_data_partition; aws_config::AbstractAWSConfig=current_aws_config()
)
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/typedlink/facet/get",
        Dict{String,Any}(
            "Name" => Name,
            "headers" => Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_typed_link_facet_information(
    Name,
    x_amz_data_partition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/typedlink/facet/get",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Name" => Name,
                    "headers" =>
                        Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_applied_schema_arns(directory_arn)
    list_applied_schema_arns(directory_arn, params::Dict{String,<:Any})

Lists schema major versions applied to a directory. If SchemaArn is provided, lists the
minor version.

# Arguments
- `directory_arn`: The ARN of the directory you are listing.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to retrieve.
- `"NextToken"`: The pagination token.
- `"SchemaArn"`: The response for ListAppliedSchemaArns when this parameter is used will
  list all minor version ARNs for a major version.
"""
function list_applied_schema_arns(
    DirectoryArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/schema/applied",
        Dict{String,Any}("DirectoryArn" => DirectoryArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_applied_schema_arns(
    DirectoryArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/schema/applied",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DirectoryArn" => DirectoryArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_attached_indices(target_reference, x-amz-data-partition)
    list_attached_indices(target_reference, x-amz-data-partition, params::Dict{String,<:Any})

Lists indices attached to the specified object.

# Arguments
- `target_reference`: A reference to the object that has indices attached.
- `x-amz-data-partition`: The ARN of the directory.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to retrieve.
- `"NextToken"`: The pagination token.
- `"x-amz-consistency-level"`: The consistency level to use for this operation.
"""
function list_attached_indices(
    TargetReference,
    x_amz_data_partition;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/object/indices",
        Dict{String,Any}(
            "TargetReference" => TargetReference,
            "headers" => Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_attached_indices(
    TargetReference,
    x_amz_data_partition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/object/indices",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "TargetReference" => TargetReference,
                    "headers" =>
                        Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_development_schema_arns()
    list_development_schema_arns(params::Dict{String,<:Any})

Retrieves each Amazon Resource Name (ARN) of schemas in the development state.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to retrieve.
- `"NextToken"`: The pagination token.
"""
function list_development_schema_arns(; aws_config::AbstractAWSConfig=current_aws_config())
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/schema/development";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_development_schema_arns(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/schema/development",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_directories()
    list_directories(params::Dict{String,<:Any})

Lists directories created within an account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to retrieve.
- `"NextToken"`: The pagination token.
- `"state"`: The state of the directories in the list. Can be either Enabled, Disabled, or
  Deleted.
"""
function list_directories(; aws_config::AbstractAWSConfig=current_aws_config())
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/directory/list";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_directories(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/directory/list",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_facet_attributes(name, x-amz-data-partition)
    list_facet_attributes(name, x-amz-data-partition, params::Dict{String,<:Any})

Retrieves attributes attached to the facet.

# Arguments
- `name`: The name of the facet whose attributes will be retrieved.
- `x-amz-data-partition`: The ARN of the schema where the facet resides.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to retrieve.
- `"NextToken"`: The pagination token.
"""
function list_facet_attributes(
    Name, x_amz_data_partition; aws_config::AbstractAWSConfig=current_aws_config()
)
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/facet/attributes",
        Dict{String,Any}(
            "Name" => Name,
            "headers" => Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_facet_attributes(
    Name,
    x_amz_data_partition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/facet/attributes",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Name" => Name,
                    "headers" =>
                        Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_facet_names(x-amz-data-partition)
    list_facet_names(x-amz-data-partition, params::Dict{String,<:Any})

Retrieves the names of facets that exist in a schema.

# Arguments
- `x-amz-data-partition`: The Amazon Resource Name (ARN) to retrieve facet names from.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to retrieve.
- `"NextToken"`: The pagination token.
"""
function list_facet_names(
    x_amz_data_partition; aws_config::AbstractAWSConfig=current_aws_config()
)
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/facet/list",
        Dict{String,Any}(
            "headers" => Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_facet_names(
    x_amz_data_partition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/facet/list",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "headers" =>
                        Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_incoming_typed_links(object_reference, x-amz-data-partition)
    list_incoming_typed_links(object_reference, x-amz-data-partition, params::Dict{String,<:Any})

Returns a paginated list of all the incoming TypedLinkSpecifier information for an object.
It also supports filtering by typed link facet and identity attributes. For more
information, see Typed Links.

# Arguments
- `object_reference`: Reference that identifies the object whose attributes will be listed.
- `x-amz-data-partition`: The Amazon Resource Name (ARN) of the directory where you want to
  list the typed links.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConsistencyLevel"`: The consistency level to execute the request at.
- `"FilterAttributeRanges"`: Provides range filters for multiple attributes. When providing
  ranges to typed link selection, any inexact ranges must be specified at the end. Any
  attributes that do not have a range specified are presumed to match the entire range.
- `"FilterTypedLink"`: Filters are interpreted in the order of the attributes on the typed
  link facet, not the order in which they are supplied to any API calls.
- `"MaxResults"`: The maximum number of results to retrieve.
- `"NextToken"`: The pagination token.
"""
function list_incoming_typed_links(
    ObjectReference,
    x_amz_data_partition;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/typedlink/incoming",
        Dict{String,Any}(
            "ObjectReference" => ObjectReference,
            "headers" => Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_incoming_typed_links(
    ObjectReference,
    x_amz_data_partition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/typedlink/incoming",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ObjectReference" => ObjectReference,
                    "headers" =>
                        Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_index(index_reference, x-amz-data-partition)
    list_index(index_reference, x-amz-data-partition, params::Dict{String,<:Any})

Lists objects attached to the specified index.

# Arguments
- `index_reference`: The reference to the index to list.
- `x-amz-data-partition`: The ARN of the directory that the index exists in.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of objects in a single page to retrieve from the index
  during a request. For more information, see Amazon Cloud Directory Limits.
- `"NextToken"`: The pagination token.
- `"RangesOnIndexedValues"`: Specifies the ranges of indexed values that you want to query.
- `"x-amz-consistency-level"`: The consistency level to execute the request at.
"""
function list_index(
    IndexReference, x_amz_data_partition; aws_config::AbstractAWSConfig=current_aws_config()
)
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/index/targets",
        Dict{String,Any}(
            "IndexReference" => IndexReference,
            "headers" => Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_index(
    IndexReference,
    x_amz_data_partition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/index/targets",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "IndexReference" => IndexReference,
                    "headers" =>
                        Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_managed_schema_arns()
    list_managed_schema_arns(params::Dict{String,<:Any})

Lists the major version families of each managed schema. If a major version ARN is provided
as SchemaArn, the minor version revisions in that family are listed instead.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to retrieve.
- `"NextToken"`: The pagination token.
- `"SchemaArn"`: The response for ListManagedSchemaArns. When this parameter is used, all
  minor version ARNs for a major version are listed.
"""
function list_managed_schema_arns(; aws_config::AbstractAWSConfig=current_aws_config())
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/schema/managed";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_managed_schema_arns(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/schema/managed",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_object_attributes(object_reference, x-amz-data-partition)
    list_object_attributes(object_reference, x-amz-data-partition, params::Dict{String,<:Any})

Lists all attributes that are associated with an object.

# Arguments
- `object_reference`: The reference that identifies the object whose attributes will be
  listed.
- `x-amz-data-partition`: The Amazon Resource Name (ARN) that is associated with the
  Directory where the object resides. For more information, see arns.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FacetFilter"`: Used to filter the list of object attributes that are associated with a
  certain facet.
- `"MaxResults"`: The maximum number of items to be retrieved in a single call. This is an
  approximate number.
- `"NextToken"`: The pagination token.
- `"x-amz-consistency-level"`: Represents the manner and timing in which the successful
  write or update of an object is reflected in a subsequent read operation of that same
  object.
"""
function list_object_attributes(
    ObjectReference,
    x_amz_data_partition;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/object/attributes",
        Dict{String,Any}(
            "ObjectReference" => ObjectReference,
            "headers" => Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_object_attributes(
    ObjectReference,
    x_amz_data_partition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/object/attributes",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ObjectReference" => ObjectReference,
                    "headers" =>
                        Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_object_children(object_reference, x-amz-data-partition)
    list_object_children(object_reference, x-amz-data-partition, params::Dict{String,<:Any})

Returns a paginated list of child objects that are associated with a given object.

# Arguments
- `object_reference`: The reference that identifies the object for which child objects are
  being listed.
- `x-amz-data-partition`: The Amazon Resource Name (ARN) that is associated with the
  Directory where the object resides. For more information, see arns.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of items to be retrieved in a single call. This is an
  approximate number.
- `"NextToken"`: The pagination token.
- `"x-amz-consistency-level"`: Represents the manner and timing in which the successful
  write or update of an object is reflected in a subsequent read operation of that same
  object.
"""
function list_object_children(
    ObjectReference,
    x_amz_data_partition;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/object/children",
        Dict{String,Any}(
            "ObjectReference" => ObjectReference,
            "headers" => Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_object_children(
    ObjectReference,
    x_amz_data_partition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/object/children",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ObjectReference" => ObjectReference,
                    "headers" =>
                        Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_object_parent_paths(object_reference, x-amz-data-partition)
    list_object_parent_paths(object_reference, x-amz-data-partition, params::Dict{String,<:Any})

Retrieves all available parent paths for any object type such as node, leaf node, policy
node, and index node objects. For more information about objects, see Directory Structure.
Use this API to evaluate all parents for an object. The call returns all objects from the
root of the directory up to the requested object. The API returns the number of paths based
on user-defined MaxResults, in case there are multiple paths to the parent. The order of
the paths and nodes returned is consistent among multiple API calls unless the objects are
deleted or moved. Paths not leading to the directory root are ignored from the target
object.

# Arguments
- `object_reference`: The reference that identifies the object whose parent paths are
  listed.
- `x-amz-data-partition`: The ARN of the directory to which the parent path applies.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of items to be retrieved in a single call. This is an
  approximate number.
- `"NextToken"`: The pagination token.
"""
function list_object_parent_paths(
    ObjectReference,
    x_amz_data_partition;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/object/parentpaths",
        Dict{String,Any}(
            "ObjectReference" => ObjectReference,
            "headers" => Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_object_parent_paths(
    ObjectReference,
    x_amz_data_partition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/object/parentpaths",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ObjectReference" => ObjectReference,
                    "headers" =>
                        Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_object_parents(object_reference, x-amz-data-partition)
    list_object_parents(object_reference, x-amz-data-partition, params::Dict{String,<:Any})

Lists parent objects that are associated with a given object in pagination fashion.

# Arguments
- `object_reference`: The reference that identifies the object for which parent objects are
  being listed.
- `x-amz-data-partition`: The Amazon Resource Name (ARN) that is associated with the
  Directory where the object resides. For more information, see arns.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"IncludeAllLinksToEachParent"`: When set to True, returns all
  ListObjectParentsResponseParentLinks. There could be multiple links between a parent-child
  pair.
- `"MaxResults"`: The maximum number of items to be retrieved in a single call. This is an
  approximate number.
- `"NextToken"`: The pagination token.
- `"x-amz-consistency-level"`: Represents the manner and timing in which the successful
  write or update of an object is reflected in a subsequent read operation of that same
  object.
"""
function list_object_parents(
    ObjectReference,
    x_amz_data_partition;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/object/parent",
        Dict{String,Any}(
            "ObjectReference" => ObjectReference,
            "headers" => Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_object_parents(
    ObjectReference,
    x_amz_data_partition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/object/parent",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ObjectReference" => ObjectReference,
                    "headers" =>
                        Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_object_policies(object_reference, x-amz-data-partition)
    list_object_policies(object_reference, x-amz-data-partition, params::Dict{String,<:Any})

Returns policies attached to an object in pagination fashion.

# Arguments
- `object_reference`: Reference that identifies the object for which policies will be
  listed.
- `x-amz-data-partition`: The Amazon Resource Name (ARN) that is associated with the
  Directory where objects reside. For more information, see arns.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of items to be retrieved in a single call. This is an
  approximate number.
- `"NextToken"`: The pagination token.
- `"x-amz-consistency-level"`: Represents the manner and timing in which the successful
  write or update of an object is reflected in a subsequent read operation of that same
  object.
"""
function list_object_policies(
    ObjectReference,
    x_amz_data_partition;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/object/policy",
        Dict{String,Any}(
            "ObjectReference" => ObjectReference,
            "headers" => Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_object_policies(
    ObjectReference,
    x_amz_data_partition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/object/policy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ObjectReference" => ObjectReference,
                    "headers" =>
                        Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_outgoing_typed_links(object_reference, x-amz-data-partition)
    list_outgoing_typed_links(object_reference, x-amz-data-partition, params::Dict{String,<:Any})

Returns a paginated list of all the outgoing TypedLinkSpecifier information for an object.
It also supports filtering by typed link facet and identity attributes. For more
information, see Typed Links.

# Arguments
- `object_reference`: A reference that identifies the object whose attributes will be
  listed.
- `x-amz-data-partition`: The Amazon Resource Name (ARN) of the directory where you want to
  list the typed links.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConsistencyLevel"`: The consistency level to execute the request at.
- `"FilterAttributeRanges"`: Provides range filters for multiple attributes. When providing
  ranges to typed link selection, any inexact ranges must be specified at the end. Any
  attributes that do not have a range specified are presumed to match the entire range.
- `"FilterTypedLink"`: Filters are interpreted in the order of the attributes defined on
  the typed link facet, not the order they are supplied to any API calls.
- `"MaxResults"`: The maximum number of results to retrieve.
- `"NextToken"`: The pagination token.
"""
function list_outgoing_typed_links(
    ObjectReference,
    x_amz_data_partition;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/typedlink/outgoing",
        Dict{String,Any}(
            "ObjectReference" => ObjectReference,
            "headers" => Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_outgoing_typed_links(
    ObjectReference,
    x_amz_data_partition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/typedlink/outgoing",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ObjectReference" => ObjectReference,
                    "headers" =>
                        Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_policy_attachments(policy_reference, x-amz-data-partition)
    list_policy_attachments(policy_reference, x-amz-data-partition, params::Dict{String,<:Any})

Returns all of the ObjectIdentifiers to which a given policy is attached.

# Arguments
- `policy_reference`: The reference that identifies the policy object.
- `x-amz-data-partition`: The Amazon Resource Name (ARN) that is associated with the
  Directory where objects reside. For more information, see arns.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of items to be retrieved in a single call. This is an
  approximate number.
- `"NextToken"`: The pagination token.
- `"x-amz-consistency-level"`: Represents the manner and timing in which the successful
  write or update of an object is reflected in a subsequent read operation of that same
  object.
"""
function list_policy_attachments(
    PolicyReference,
    x_amz_data_partition;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/policy/attachment",
        Dict{String,Any}(
            "PolicyReference" => PolicyReference,
            "headers" => Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_policy_attachments(
    PolicyReference,
    x_amz_data_partition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/policy/attachment",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "PolicyReference" => PolicyReference,
                    "headers" =>
                        Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_published_schema_arns()
    list_published_schema_arns(params::Dict{String,<:Any})

Lists the major version families of each published schema. If a major version ARN is
provided as SchemaArn, the minor version revisions in that family are listed instead.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to retrieve.
- `"NextToken"`: The pagination token.
- `"SchemaArn"`: The response for ListPublishedSchemaArns when this parameter is used will
  list all minor version ARNs for a major version.
"""
function list_published_schema_arns(; aws_config::AbstractAWSConfig=current_aws_config())
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/schema/published";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_published_schema_arns(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/schema/published",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Returns tags for a resource. Tagging is currently supported only for directories with a
limit of 50 tags per directory. All 50 tags are returned for a given directory with this
API call.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource. Tagging is only supported
  for directories.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The MaxResults parameter sets the maximum number of results returned in a
  single page. This is for future use and is not supported currently.
- `"NextToken"`: The pagination token. This is for future use. Currently pagination is not
  supported for tagging.
"""
function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/tags",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/tags",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_typed_link_facet_attributes(name, x-amz-data-partition)
    list_typed_link_facet_attributes(name, x-amz-data-partition, params::Dict{String,<:Any})

Returns a paginated list of all attribute definitions for a particular TypedLinkFacet. For
more information, see Typed Links.

# Arguments
- `name`: The unique name of the typed link facet.
- `x-amz-data-partition`: The Amazon Resource Name (ARN) that is associated with the
  schema. For more information, see arns.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to retrieve.
- `"NextToken"`: The pagination token.
"""
function list_typed_link_facet_attributes(
    Name, x_amz_data_partition; aws_config::AbstractAWSConfig=current_aws_config()
)
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/typedlink/facet/attributes",
        Dict{String,Any}(
            "Name" => Name,
            "headers" => Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_typed_link_facet_attributes(
    Name,
    x_amz_data_partition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/typedlink/facet/attributes",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Name" => Name,
                    "headers" =>
                        Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_typed_link_facet_names(x-amz-data-partition)
    list_typed_link_facet_names(x-amz-data-partition, params::Dict{String,<:Any})

Returns a paginated list of TypedLink facet names for a particular schema. For more
information, see Typed Links.

# Arguments
- `x-amz-data-partition`: The Amazon Resource Name (ARN) that is associated with the
  schema. For more information, see arns.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to retrieve.
- `"NextToken"`: The pagination token.
"""
function list_typed_link_facet_names(
    x_amz_data_partition; aws_config::AbstractAWSConfig=current_aws_config()
)
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/typedlink/facet/list",
        Dict{String,Any}(
            "headers" => Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_typed_link_facet_names(
    x_amz_data_partition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/typedlink/facet/list",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "headers" =>
                        Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    lookup_policy(object_reference, x-amz-data-partition)
    lookup_policy(object_reference, x-amz-data-partition, params::Dict{String,<:Any})

Lists all policies from the root of the Directory to the object specified. If there are no
policies present, an empty list is returned. If policies are present, and if some objects
don't have the policies attached, it returns the ObjectIdentifier for such objects. If
policies are present, it returns ObjectIdentifier, policyId, and policyType. Paths that
don't lead to the root from the target object are ignored. For more information, see
Policies.

# Arguments
- `object_reference`: Reference that identifies the object whose policies will be looked up.
- `x-amz-data-partition`: The Amazon Resource Name (ARN) that is associated with the
  Directory. For more information, see arns.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of items to be retrieved in a single call. This is an
  approximate number.
- `"NextToken"`: The token to request the next page of results.
"""
function lookup_policy(
    ObjectReference,
    x_amz_data_partition;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/policy/lookup",
        Dict{String,Any}(
            "ObjectReference" => ObjectReference,
            "headers" => Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function lookup_policy(
    ObjectReference,
    x_amz_data_partition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/policy/lookup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ObjectReference" => ObjectReference,
                    "headers" =>
                        Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    publish_schema(version, x-amz-data-partition)
    publish_schema(version, x-amz-data-partition, params::Dict{String,<:Any})

Publishes a development schema with a major version and a recommended minor version.

# Arguments
- `version`: The major version under which the schema will be published. Schemas have both
  a major and minor version associated with them.
- `x-amz-data-partition`: The Amazon Resource Name (ARN) that is associated with the
  development schema. For more information, see arns.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MinorVersion"`: The minor version under which the schema will be published. This
  parameter is recommended. Schemas have both a major and minor version associated with them.
- `"Name"`: The new name under which the schema will be published. If this is not provided,
  the development schema is considered.
"""
function publish_schema(
    Version, x_amz_data_partition; aws_config::AbstractAWSConfig=current_aws_config()
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/schema/publish",
        Dict{String,Any}(
            "Version" => Version,
            "headers" => Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function publish_schema(
    Version,
    x_amz_data_partition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/schema/publish",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Version" => Version,
                    "headers" =>
                        Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_schema_from_json(document, x-amz-data-partition)
    put_schema_from_json(document, x-amz-data-partition, params::Dict{String,<:Any})

Allows a schema to be updated using JSON upload. Only available for development schemas.
See JSON Schema Format for more information.

# Arguments
- `document`: The replacement JSON schema.
- `x-amz-data-partition`: The ARN of the schema to update.

"""
function put_schema_from_json(
    Document, x_amz_data_partition; aws_config::AbstractAWSConfig=current_aws_config()
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/schema/json",
        Dict{String,Any}(
            "Document" => Document,
            "headers" => Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_schema_from_json(
    Document,
    x_amz_data_partition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/schema/json",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Document" => Document,
                    "headers" =>
                        Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_facet_from_object(object_reference, schema_facet, x-amz-data-partition)
    remove_facet_from_object(object_reference, schema_facet, x-amz-data-partition, params::Dict{String,<:Any})

Removes the specified facet from the specified object.

# Arguments
- `object_reference`: A reference to the object to remove the facet from.
- `schema_facet`: The facet to remove. See SchemaFacet for details.
- `x-amz-data-partition`: The ARN of the directory in which the object resides.

"""
function remove_facet_from_object(
    ObjectReference,
    SchemaFacet,
    x_amz_data_partition;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/object/facets/delete",
        Dict{String,Any}(
            "ObjectReference" => ObjectReference,
            "SchemaFacet" => SchemaFacet,
            "headers" => Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_facet_from_object(
    ObjectReference,
    SchemaFacet,
    x_amz_data_partition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/object/facets/delete",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ObjectReference" => ObjectReference,
                    "SchemaFacet" => SchemaFacet,
                    "headers" =>
                        Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

An API operation for adding tags to a resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource. Tagging is only supported
  for directories.
- `tags`: A list of tag key-value pairs.

"""
function tag_resource(ResourceArn, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/tags/add",
        Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceArn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/tags/add",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

An API operation for removing tags from a resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource. Tagging is only supported
  for directories.
- `tag_keys`: Keys of the tag that need to be removed from the resource.

"""
function untag_resource(
    ResourceArn, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/tags/remove",
        Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceArn,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/tags/remove",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_facet(name, x-amz-data-partition)
    update_facet(name, x-amz-data-partition, params::Dict{String,<:Any})

Does the following:   Adds new Attributes, Rules, or ObjectTypes.   Updates existing
Attributes, Rules, or ObjectTypes.   Deletes existing Attributes, Rules, or ObjectTypes.

# Arguments
- `name`: The name of the facet.
- `x-amz-data-partition`: The Amazon Resource Name (ARN) that is associated with the Facet.
  For more information, see arns.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AttributeUpdates"`: List of attributes that need to be updated in a given schema Facet.
  Each attribute is followed by AttributeAction, which specifies the type of update operation
  to perform.
- `"ObjectType"`: The object type that is associated with the facet. See
  CreateFacetRequestObjectType for more details.
"""
function update_facet(
    Name, x_amz_data_partition; aws_config::AbstractAWSConfig=current_aws_config()
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/facet",
        Dict{String,Any}(
            "Name" => Name,
            "headers" => Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_facet(
    Name,
    x_amz_data_partition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/facet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Name" => Name,
                    "headers" =>
                        Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_link_attributes(attribute_updates, typed_link_specifier, x-amz-data-partition)
    update_link_attributes(attribute_updates, typed_link_specifier, x-amz-data-partition, params::Dict{String,<:Any})

Updates a given typed link’s attributes. Attributes to be updated must not contribute to
the typed link’s identity, as defined by its IdentityAttributeOrder.

# Arguments
- `attribute_updates`: The attributes update structure.
- `typed_link_specifier`: Allows a typed link specifier to be accepted as input.
- `x-amz-data-partition`: The Amazon Resource Name (ARN) that is associated with the
  Directory where the updated typed link resides. For more information, see arns or Typed
  Links.

"""
function update_link_attributes(
    AttributeUpdates,
    TypedLinkSpecifier,
    x_amz_data_partition;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/typedlink/attributes/update",
        Dict{String,Any}(
            "AttributeUpdates" => AttributeUpdates,
            "TypedLinkSpecifier" => TypedLinkSpecifier,
            "headers" => Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_link_attributes(
    AttributeUpdates,
    TypedLinkSpecifier,
    x_amz_data_partition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "POST",
        "/amazonclouddirectory/2017-01-11/typedlink/attributes/update",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AttributeUpdates" => AttributeUpdates,
                    "TypedLinkSpecifier" => TypedLinkSpecifier,
                    "headers" =>
                        Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_object_attributes(attribute_updates, object_reference, x-amz-data-partition)
    update_object_attributes(attribute_updates, object_reference, x-amz-data-partition, params::Dict{String,<:Any})

Updates a given object's attributes.

# Arguments
- `attribute_updates`: The attributes update structure.
- `object_reference`: The reference that identifies the object.
- `x-amz-data-partition`: The Amazon Resource Name (ARN) that is associated with the
  Directory where the object resides. For more information, see arns.

"""
function update_object_attributes(
    AttributeUpdates,
    ObjectReference,
    x_amz_data_partition;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/object/update",
        Dict{String,Any}(
            "AttributeUpdates" => AttributeUpdates,
            "ObjectReference" => ObjectReference,
            "headers" => Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_object_attributes(
    AttributeUpdates,
    ObjectReference,
    x_amz_data_partition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/object/update",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AttributeUpdates" => AttributeUpdates,
                    "ObjectReference" => ObjectReference,
                    "headers" =>
                        Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_schema(name, x-amz-data-partition)
    update_schema(name, x-amz-data-partition, params::Dict{String,<:Any})

Updates the schema name with a new name. Only development schema names can be updated.

# Arguments
- `name`: The name of the schema.
- `x-amz-data-partition`: The Amazon Resource Name (ARN) of the development schema. For
  more information, see arns.

"""
function update_schema(
    Name, x_amz_data_partition; aws_config::AbstractAWSConfig=current_aws_config()
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/schema/update",
        Dict{String,Any}(
            "Name" => Name,
            "headers" => Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_schema(
    Name,
    x_amz_data_partition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/schema/update",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Name" => Name,
                    "headers" =>
                        Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_typed_link_facet(attribute_updates, identity_attribute_order, name, x-amz-data-partition)
    update_typed_link_facet(attribute_updates, identity_attribute_order, name, x-amz-data-partition, params::Dict{String,<:Any})

Updates a TypedLinkFacet. For more information, see Typed Links.

# Arguments
- `attribute_updates`: Attributes update structure.
- `identity_attribute_order`: The order of identity attributes for the facet, from most
  significant to least significant. The ability to filter typed links considers the order
  that the attributes are defined on the typed link facet. When providing ranges to a typed
  link selection, any inexact ranges must be specified at the end. Any attributes that do not
  have a range specified are presumed to match the entire range. Filters are interpreted in
  the order of the attributes on the typed link facet, not the order in which they are
  supplied to any API calls. For more information about identity attributes, see Typed Links.
- `name`: The unique name of the typed link facet.
- `x-amz-data-partition`: The Amazon Resource Name (ARN) that is associated with the
  schema. For more information, see arns.

"""
function update_typed_link_facet(
    AttributeUpdates,
    IdentityAttributeOrder,
    Name,
    x_amz_data_partition;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/typedlink/facet",
        Dict{String,Any}(
            "AttributeUpdates" => AttributeUpdates,
            "IdentityAttributeOrder" => IdentityAttributeOrder,
            "Name" => Name,
            "headers" => Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_typed_link_facet(
    AttributeUpdates,
    IdentityAttributeOrder,
    Name,
    x_amz_data_partition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/typedlink/facet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AttributeUpdates" => AttributeUpdates,
                    "IdentityAttributeOrder" => IdentityAttributeOrder,
                    "Name" => Name,
                    "headers" =>
                        Dict{String,Any}("x-amz-data-partition" => x_amz_data_partition),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    upgrade_applied_schema(directory_arn, published_schema_arn)
    upgrade_applied_schema(directory_arn, published_schema_arn, params::Dict{String,<:Any})

Upgrades a single directory in-place using the PublishedSchemaArn with schema updates found
in MinorVersion. Backwards-compatible minor version upgrades are instantaneously available
for readers on all objects in the directory. Note: This is a synchronous API call and
upgrades only one schema on a given directory per call. To upgrade multiple directories
from one schema, you would need to call this API on each directory.

# Arguments
- `directory_arn`: The ARN for the directory to which the upgraded schema will be applied.
- `published_schema_arn`: The revision of the published schema to upgrade the directory to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DryRun"`: Used for testing whether the major version schemas are backward compatible or
  not. If schema compatibility fails, an exception would be thrown else the call would
  succeed but no changes will be saved. This parameter is optional.
"""
function upgrade_applied_schema(
    DirectoryArn, PublishedSchemaArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/schema/upgradeapplied",
        Dict{String,Any}(
            "DirectoryArn" => DirectoryArn, "PublishedSchemaArn" => PublishedSchemaArn
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function upgrade_applied_schema(
    DirectoryArn,
    PublishedSchemaArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/schema/upgradeapplied",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DirectoryArn" => DirectoryArn,
                    "PublishedSchemaArn" => PublishedSchemaArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    upgrade_published_schema(development_schema_arn, minor_version, published_schema_arn)
    upgrade_published_schema(development_schema_arn, minor_version, published_schema_arn, params::Dict{String,<:Any})

Upgrades a published schema under a new minor version revision using the current contents
of DevelopmentSchemaArn.

# Arguments
- `development_schema_arn`: The ARN of the development schema with the changes used for the
  upgrade.
- `minor_version`: Identifies the minor version of the published schema that will be
  created. This parameter is NOT optional.
- `published_schema_arn`: The ARN of the published schema to be upgraded.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DryRun"`: Used for testing whether the Development schema provided is backwards
  compatible, or not, with the publish schema provided by the user to be upgraded. If schema
  compatibility fails, an exception would be thrown else the call would succeed. This
  parameter is optional and defaults to false.
"""
function upgrade_published_schema(
    DevelopmentSchemaArn,
    MinorVersion,
    PublishedSchemaArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/schema/upgradepublished",
        Dict{String,Any}(
            "DevelopmentSchemaArn" => DevelopmentSchemaArn,
            "MinorVersion" => MinorVersion,
            "PublishedSchemaArn" => PublishedSchemaArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function upgrade_published_schema(
    DevelopmentSchemaArn,
    MinorVersion,
    PublishedSchemaArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return clouddirectory(
        "PUT",
        "/amazonclouddirectory/2017-01-11/schema/upgradepublished",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DevelopmentSchemaArn" => DevelopmentSchemaArn,
                    "MinorVersion" => MinorVersion,
                    "PublishedSchemaArn" => PublishedSchemaArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: docdb
using AWS.Compat
using AWS.UUIDs

"""
    add_source_identifier_to_subscription(source_identifier, subscription_name)
    add_source_identifier_to_subscription(source_identifier, subscription_name, params::Dict{String,<:Any})

Adds a source identifier to an existing event notification subscription.

# Arguments
- `source_identifier`: The identifier of the event source to be added:   If the source type
  is an instance, a DBInstanceIdentifier must be provided.   If the source type is a security
  group, a DBSecurityGroupName must be provided.   If the source type is a parameter group, a
  DBParameterGroupName must be provided.   If the source type is a snapshot, a
  DBSnapshotIdentifier must be provided.
- `subscription_name`: The name of the Amazon DocumentDB event notification subscription
  that you want to add a source identifier to.

"""
function add_source_identifier_to_subscription(
    SourceIdentifier, SubscriptionName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return docdb(
        "AddSourceIdentifierToSubscription",
        Dict{String,Any}(
            "SourceIdentifier" => SourceIdentifier, "SubscriptionName" => SubscriptionName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_source_identifier_to_subscription(
    SourceIdentifier,
    SubscriptionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb(
        "AddSourceIdentifierToSubscription",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "SourceIdentifier" => SourceIdentifier,
                    "SubscriptionName" => SubscriptionName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    add_tags_to_resource(resource_name, tag)
    add_tags_to_resource(resource_name, tag, params::Dict{String,<:Any})

Adds metadata tags to an Amazon DocumentDB resource. You can use these tags with cost
allocation reporting to track costs that are associated with Amazon DocumentDB resources or
in a Condition statement in an Identity and Access Management (IAM) policy for Amazon
DocumentDB.

# Arguments
- `resource_name`: The Amazon DocumentDB resource that the tags are added to. This value is
  an Amazon Resource Name .
- `tag`: The tags to be assigned to the Amazon DocumentDB resource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: The tags to be assigned to the Amazon DocumentDB resource.
"""
function add_tags_to_resource(
    ResourceName, Tag; aws_config::AbstractAWSConfig=current_aws_config()
)
    return docdb(
        "AddTagsToResource",
        Dict{String,Any}("ResourceName" => ResourceName, "Tag" => Tag);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_tags_to_resource(
    ResourceName,
    Tag,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb(
        "AddTagsToResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceName" => ResourceName, "Tag" => Tag),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    apply_pending_maintenance_action(apply_action, opt_in_type, resource_identifier)
    apply_pending_maintenance_action(apply_action, opt_in_type, resource_identifier, params::Dict{String,<:Any})

Applies a pending maintenance action to a resource (for example, to an Amazon DocumentDB
instance).

# Arguments
- `apply_action`: The pending maintenance action to apply to this resource. Valid values:
  system-update, db-upgrade
- `opt_in_type`: A value that specifies the type of opt-in request or undoes an opt-in
  request. An opt-in request of type immediate can't be undone. Valid values:    immediate -
  Apply the maintenance action immediately.    next-maintenance - Apply the maintenance
  action during the next maintenance window for the resource.     undo-opt-in - Cancel any
  existing next-maintenance opt-in requests.
- `resource_identifier`: The Amazon Resource Name (ARN) of the resource that the pending
  maintenance action applies to.

"""
function apply_pending_maintenance_action(
    ApplyAction,
    OptInType,
    ResourceIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb(
        "ApplyPendingMaintenanceAction",
        Dict{String,Any}(
            "ApplyAction" => ApplyAction,
            "OptInType" => OptInType,
            "ResourceIdentifier" => ResourceIdentifier,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function apply_pending_maintenance_action(
    ApplyAction,
    OptInType,
    ResourceIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb(
        "ApplyPendingMaintenanceAction",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplyAction" => ApplyAction,
                    "OptInType" => OptInType,
                    "ResourceIdentifier" => ResourceIdentifier,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    copy_dbcluster_parameter_group(source_dbcluster_parameter_group_identifier, target_dbcluster_parameter_group_description, target_dbcluster_parameter_group_identifier)
    copy_dbcluster_parameter_group(source_dbcluster_parameter_group_identifier, target_dbcluster_parameter_group_description, target_dbcluster_parameter_group_identifier, params::Dict{String,<:Any})

Copies the specified cluster parameter group.

# Arguments
- `source_dbcluster_parameter_group_identifier`: The identifier or Amazon Resource Name
  (ARN) for the source cluster parameter group. Constraints:   Must specify a valid cluster
  parameter group.   If the source cluster parameter group is in the same Amazon Web Services
  Region as the copy, specify a valid parameter group identifier; for example,
  my-db-cluster-param-group, or a valid ARN.   If the source parameter group is in a
  different Amazon Web Services Region than the copy, specify a valid cluster parameter group
  ARN; for example, arn:aws:rds:us-east-1:123456789012:sample-cluster:sample-parameter-group.
  
- `target_dbcluster_parameter_group_description`: A description for the copied cluster
  parameter group.
- `target_dbcluster_parameter_group_identifier`: The identifier for the copied cluster
  parameter group. Constraints:   Cannot be null, empty, or blank.   Must contain from 1 to
  255 letters, numbers, or hyphens.    The first character must be a letter.   Cannot end
  with a hyphen or contain two consecutive hyphens.    Example: my-cluster-param-group1

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: The tags that are to be assigned to the parameter group.
"""
function copy_dbcluster_parameter_group(
    SourceDBClusterParameterGroupIdentifier,
    TargetDBClusterParameterGroupDescription,
    TargetDBClusterParameterGroupIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb(
        "CopyDBClusterParameterGroup",
        Dict{String,Any}(
            "SourceDBClusterParameterGroupIdentifier" =>
                SourceDBClusterParameterGroupIdentifier,
            "TargetDBClusterParameterGroupDescription" =>
                TargetDBClusterParameterGroupDescription,
            "TargetDBClusterParameterGroupIdentifier" =>
                TargetDBClusterParameterGroupIdentifier,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function copy_dbcluster_parameter_group(
    SourceDBClusterParameterGroupIdentifier,
    TargetDBClusterParameterGroupDescription,
    TargetDBClusterParameterGroupIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb(
        "CopyDBClusterParameterGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "SourceDBClusterParameterGroupIdentifier" =>
                        SourceDBClusterParameterGroupIdentifier,
                    "TargetDBClusterParameterGroupDescription" =>
                        TargetDBClusterParameterGroupDescription,
                    "TargetDBClusterParameterGroupIdentifier" =>
                        TargetDBClusterParameterGroupIdentifier,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    copy_dbcluster_snapshot(source_dbcluster_snapshot_identifier, target_dbcluster_snapshot_identifier)
    copy_dbcluster_snapshot(source_dbcluster_snapshot_identifier, target_dbcluster_snapshot_identifier, params::Dict{String,<:Any})

Copies a snapshot of a cluster. To copy a cluster snapshot from a shared manual cluster
snapshot, SourceDBClusterSnapshotIdentifier must be the Amazon Resource Name (ARN) of the
shared cluster snapshot. You can only copy a shared DB cluster snapshot, whether encrypted
or not, in the same Amazon Web Services Region. To cancel the copy operation after it is in
progress, delete the target cluster snapshot identified by
TargetDBClusterSnapshotIdentifier while that cluster snapshot is in the copying status.

# Arguments
- `source_dbcluster_snapshot_identifier`: The identifier of the cluster snapshot to copy.
  This parameter is not case sensitive. Constraints:   Must specify a valid system snapshot
  in the available state.   If the source snapshot is in the same Amazon Web Services Region
  as the copy, specify a valid snapshot identifier.   If the source snapshot is in a
  different Amazon Web Services Region than the copy, specify a valid cluster snapshot ARN.
  Example: my-cluster-snapshot1
- `target_dbcluster_snapshot_identifier`: The identifier of the new cluster snapshot to
  create from the source cluster snapshot. This parameter is not case sensitive. Constraints:
    Must contain from 1 to 63 letters, numbers, or hyphens.    The first character must be a
  letter.   Cannot end with a hyphen or contain two consecutive hyphens.    Example:
  my-cluster-snapshot2

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CopyTags"`: Set to true to copy all tags from the source cluster snapshot to the target
  cluster snapshot, and otherwise false. The default is false.
- `"KmsKeyId"`: The KMS key ID for an encrypted cluster snapshot. The KMS key ID is the
  Amazon Resource Name (ARN), KMS key identifier, or the KMS key alias for the KMS encryption
  key.  If you copy an encrypted cluster snapshot from your Amazon Web Services account, you
  can specify a value for KmsKeyId to encrypt the copy with a new KMS encryption key. If you
  don't specify a value for KmsKeyId, then the copy of the cluster snapshot is encrypted with
  the same KMS key as the source cluster snapshot. If you copy an encrypted cluster snapshot
  that is shared from another Amazon Web Services account, then you must specify a value for
  KmsKeyId. To copy an encrypted cluster snapshot to another Amazon Web Services Region, set
  KmsKeyId to the KMS key ID that you want to use to encrypt the copy of the cluster snapshot
  in the destination Region. KMS encryption keys are specific to the Amazon Web Services
  Region that they are created in, and you can't use encryption keys from one Amazon Web
  Services Region in another Amazon Web Services Region. If you copy an unencrypted cluster
  snapshot and specify a value for the KmsKeyId parameter, an error is returned.
- `"PreSignedUrl"`: The URL that contains a Signature Version 4 signed request for
  theCopyDBClusterSnapshot API action in the Amazon Web Services Region that contains the
  source cluster snapshot to copy. You must use the PreSignedUrl parameter when copying a
  cluster snapshot from another Amazon Web Services Region. If you are using an Amazon Web
  Services SDK tool or the CLI, you can specify SourceRegion (or --source-region for the CLI)
  instead of specifying PreSignedUrl manually. Specifying SourceRegion autogenerates a
  pre-signed URL that is a valid request for the operation that can be executed in the source
  Amazon Web Services Region. The presigned URL must be a valid request for the
  CopyDBClusterSnapshot API action that can be executed in the source Amazon Web Services
  Region that contains the cluster snapshot to be copied. The presigned URL request must
  contain the following parameter values:    SourceRegion - The ID of the region that
  contains the snapshot to be copied.    SourceDBClusterSnapshotIdentifier - The identifier
  for the the encrypted cluster snapshot to be copied. This identifier must be in the Amazon
  Resource Name (ARN) format for the source Amazon Web Services Region. For example, if you
  are copying an encrypted cluster snapshot from the us-east-1 Amazon Web Services Region,
  then your SourceDBClusterSnapshotIdentifier looks something like the following:
  arn:aws:rds:us-east-1:12345678012:sample-cluster:sample-cluster-snapshot.
  TargetDBClusterSnapshotIdentifier - The identifier for the new cluster snapshot to be
  created. This parameter isn't case sensitive.
- `"Tags"`: The tags to be assigned to the cluster snapshot.
"""
function copy_dbcluster_snapshot(
    SourceDBClusterSnapshotIdentifier,
    TargetDBClusterSnapshotIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb(
        "CopyDBClusterSnapshot",
        Dict{String,Any}(
            "SourceDBClusterSnapshotIdentifier" => SourceDBClusterSnapshotIdentifier,
            "TargetDBClusterSnapshotIdentifier" => TargetDBClusterSnapshotIdentifier,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function copy_dbcluster_snapshot(
    SourceDBClusterSnapshotIdentifier,
    TargetDBClusterSnapshotIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb(
        "CopyDBClusterSnapshot",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "SourceDBClusterSnapshotIdentifier" =>
                        SourceDBClusterSnapshotIdentifier,
                    "TargetDBClusterSnapshotIdentifier" =>
                        TargetDBClusterSnapshotIdentifier,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_dbcluster(dbcluster_identifier, engine)
    create_dbcluster(dbcluster_identifier, engine, params::Dict{String,<:Any})

Creates a new Amazon DocumentDB cluster.

# Arguments
- `dbcluster_identifier`: The cluster identifier. This parameter is stored as a lowercase
  string. Constraints:   Must contain from 1 to 63 letters, numbers, or hyphens.    The first
  character must be a letter.   Cannot end with a hyphen or contain two consecutive hyphens.
    Example: my-cluster
- `engine`: The name of the database engine to be used for this cluster. Valid values:
  docdb

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AvailabilityZones"`: A list of Amazon EC2 Availability Zones that instances in the
  cluster can be created in.
- `"BackupRetentionPeriod"`: The number of days for which automated backups are retained.
  You must specify a minimum value of 1. Default: 1 Constraints:   Must be a value from 1 to
  35.
- `"DBClusterParameterGroupName"`: The name of the cluster parameter group to associate
  with this cluster.
- `"DBSubnetGroupName"`: A subnet group to associate with this cluster. Constraints: Must
  match the name of an existing DBSubnetGroup. Must not be default. Example: mySubnetgroup
- `"DeletionProtection"`: Specifies whether this cluster can be deleted. If
  DeletionProtection is enabled, the cluster cannot be deleted unless it is modified and
  DeletionProtection is disabled. DeletionProtection protects clusters from being
  accidentally deleted.
- `"EnableCloudwatchLogsExports"`: A list of log types that need to be enabled for
  exporting to Amazon CloudWatch Logs. You can enable audit logs or profiler logs. For more
  information, see  Auditing Amazon DocumentDB Events and  Profiling Amazon DocumentDB
  Operations.
- `"EngineVersion"`: The version number of the database engine to use. The --engine-version
  will default to the latest major engine version. For production workloads, we recommend
  explicitly declaring this parameter with the intended major engine version.
- `"GlobalClusterIdentifier"`: The cluster identifier of the new global cluster.
- `"KmsKeyId"`: The KMS key identifier for an encrypted cluster. The KMS key identifier is
  the Amazon Resource Name (ARN) for the KMS encryption key. If you are creating a cluster
  using the same Amazon Web Services account that owns the KMS encryption key that is used to
  encrypt the new cluster, you can use the KMS key alias instead of the ARN for the KMS
  encryption key. If an encryption key is not specified in KmsKeyId:    If the
  StorageEncrypted parameter is true, Amazon DocumentDB uses your default encryption key.
  KMS creates the default encryption key for your Amazon Web Services account. Your Amazon
  Web Services account has a different default encryption key for each Amazon Web Services
  Regions.
- `"MasterUserPassword"`: The password for the master database user. This password can
  contain any printable ASCII character except forward slash (/), double quote (\"), or the
  \"at\" symbol (@). Constraints: Must contain from 8 to 100 characters.
- `"MasterUsername"`: The name of the master user for the cluster. Constraints:   Must be
  from 1 to 63 letters or numbers.   The first character must be a letter.   Cannot be a
  reserved word for the chosen database engine.
- `"Port"`: The port number on which the instances in the cluster accept connections.
- `"PreSignedUrl"`: Not currently supported.
- `"PreferredBackupWindow"`: The daily time range during which automated backups are
  created if automated backups are enabled using the BackupRetentionPeriod parameter.  The
  default is a 30-minute window selected at random from an 8-hour block of time for each
  Amazon Web Services Region.  Constraints:   Must be in the format hh24:mi-hh24:mi.   Must
  be in Universal Coordinated Time (UTC).   Must not conflict with the preferred maintenance
  window.    Must be at least 30 minutes.
- `"PreferredMaintenanceWindow"`: The weekly time range during which system maintenance can
  occur, in Universal Coordinated Time (UTC). Format: ddd:hh24:mi-ddd:hh24:mi  The default is
  a 30-minute window selected at random from an 8-hour block of time for each Amazon Web
  Services Region, occurring on a random day of the week. Valid days: Mon, Tue, Wed, Thu,
  Fri, Sat, Sun Constraints: Minimum 30-minute window.
- `"StorageEncrypted"`: Specifies whether the cluster is encrypted.
- `"StorageType"`: The storage type to associate with the DB cluster. For information on
  storage types for Amazon DocumentDB clusters, see Cluster storage configurations in the
  Amazon DocumentDB Developer Guide. Valid values for storage type - standard | iopt1
  Default value is standard    When you create a DocumentDB DB cluster with the storage type
  set to iopt1, the storage type is returned in the response. The storage type isn't returned
  when you set it to standard.
- `"Tags"`: The tags to be assigned to the cluster.
- `"VpcSecurityGroupIds"`: A list of EC2 VPC security groups to associate with this
  cluster.
"""
function create_dbcluster(
    DBClusterIdentifier, Engine; aws_config::AbstractAWSConfig=current_aws_config()
)
    return docdb(
        "CreateDBCluster",
        Dict{String,Any}("DBClusterIdentifier" => DBClusterIdentifier, "Engine" => Engine);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_dbcluster(
    DBClusterIdentifier,
    Engine,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb(
        "CreateDBCluster",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DBClusterIdentifier" => DBClusterIdentifier, "Engine" => Engine
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_dbcluster_parameter_group(dbcluster_parameter_group_name, dbparameter_group_family, description)
    create_dbcluster_parameter_group(dbcluster_parameter_group_name, dbparameter_group_family, description, params::Dict{String,<:Any})

Creates a new cluster parameter group. Parameters in a cluster parameter group apply to all
of the instances in a cluster. A cluster parameter group is initially created with the
default parameters for the database engine used by instances in the cluster. In Amazon
DocumentDB, you cannot make modifications directly to the default.docdb3.6 cluster
parameter group. If your Amazon DocumentDB cluster is using the default cluster parameter
group and you want to modify a value in it, you must first  create a new parameter group or
 copy an existing parameter group, modify it, and then apply the modified parameter group
to your cluster. For the new cluster parameter group and associated settings to take
effect, you must then reboot the instances in the cluster without failover. For more
information, see  Modifying Amazon DocumentDB Cluster Parameter Groups.

# Arguments
- `dbcluster_parameter_group_name`: The name of the cluster parameter group. Constraints:
  Must not match the name of an existing DBClusterParameterGroup.    This value is stored as
  a lowercase string.
- `dbparameter_group_family`: The cluster parameter group family name.
- `description`: The description for the cluster parameter group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: The tags to be assigned to the cluster parameter group.
"""
function create_dbcluster_parameter_group(
    DBClusterParameterGroupName,
    DBParameterGroupFamily,
    Description;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb(
        "CreateDBClusterParameterGroup",
        Dict{String,Any}(
            "DBClusterParameterGroupName" => DBClusterParameterGroupName,
            "DBParameterGroupFamily" => DBParameterGroupFamily,
            "Description" => Description,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_dbcluster_parameter_group(
    DBClusterParameterGroupName,
    DBParameterGroupFamily,
    Description,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb(
        "CreateDBClusterParameterGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DBClusterParameterGroupName" => DBClusterParameterGroupName,
                    "DBParameterGroupFamily" => DBParameterGroupFamily,
                    "Description" => Description,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_dbcluster_snapshot(dbcluster_identifier, dbcluster_snapshot_identifier)
    create_dbcluster_snapshot(dbcluster_identifier, dbcluster_snapshot_identifier, params::Dict{String,<:Any})

Creates a snapshot of a cluster.

# Arguments
- `dbcluster_identifier`: The identifier of the cluster to create a snapshot for. This
  parameter is not case sensitive. Constraints:   Must match the identifier of an existing
  DBCluster.   Example: my-cluster
- `dbcluster_snapshot_identifier`: The identifier of the cluster snapshot. This parameter
  is stored as a lowercase string. Constraints:   Must contain from 1 to 63 letters, numbers,
  or hyphens.   The first character must be a letter.   Cannot end with a hyphen or contain
  two consecutive hyphens.    Example: my-cluster-snapshot1

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: The tags to be assigned to the cluster snapshot.
"""
function create_dbcluster_snapshot(
    DBClusterIdentifier,
    DBClusterSnapshotIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb(
        "CreateDBClusterSnapshot",
        Dict{String,Any}(
            "DBClusterIdentifier" => DBClusterIdentifier,
            "DBClusterSnapshotIdentifier" => DBClusterSnapshotIdentifier,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_dbcluster_snapshot(
    DBClusterIdentifier,
    DBClusterSnapshotIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb(
        "CreateDBClusterSnapshot",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DBClusterIdentifier" => DBClusterIdentifier,
                    "DBClusterSnapshotIdentifier" => DBClusterSnapshotIdentifier,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_dbinstance(dbcluster_identifier, dbinstance_class, dbinstance_identifier, engine)
    create_dbinstance(dbcluster_identifier, dbinstance_class, dbinstance_identifier, engine, params::Dict{String,<:Any})

Creates a new instance.

# Arguments
- `dbcluster_identifier`: The identifier of the cluster that the instance will belong to.
- `dbinstance_class`: The compute and memory capacity of the instance; for example,
  db.r5.large.
- `dbinstance_identifier`: The instance identifier. This parameter is stored as a lowercase
  string. Constraints:   Must contain from 1 to 63 letters, numbers, or hyphens.   The first
  character must be a letter.   Cannot end with a hyphen or contain two consecutive hyphens.
   Example: mydbinstance
- `engine`: The name of the database engine to be used for this instance. Valid value:
  docdb

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AutoMinorVersionUpgrade"`: This parameter does not apply to Amazon DocumentDB. Amazon
  DocumentDB does not perform minor version upgrades regardless of the value set. Default:
  false
- `"AvailabilityZone"`: The Amazon EC2 Availability Zone that the instance is created in.
  Default: A random, system-chosen Availability Zone in the endpoint's Amazon Web Services
  Region. Example: us-east-1d
- `"CACertificateIdentifier"`: The CA certificate identifier to use for the DB instance's
  server certificate. For more information, see Updating Your Amazon DocumentDB TLS
  Certificates and  Encrypting Data in Transit in the Amazon DocumentDB Developer Guide.
- `"CopyTagsToSnapshot"`: A value that indicates whether to copy tags from the DB instance
  to snapshots of the DB instance. By default, tags are not copied.
- `"EnablePerformanceInsights"`: A value that indicates whether to enable Performance
  Insights for the DB Instance. For more information, see Using Amazon Performance Insights.
- `"PerformanceInsightsKMSKeyId"`: The KMS key identifier for encryption of Performance
  Insights data. The KMS key identifier is the key ARN, key ID, alias ARN, or alias name for
  the KMS key. If you do not specify a value for PerformanceInsightsKMSKeyId, then Amazon
  DocumentDB uses your default KMS key. There is a default KMS key for your Amazon Web
  Services account. Your Amazon Web Services account has a different default KMS key for each
  Amazon Web Services region.
- `"PreferredMaintenanceWindow"`: The time range each week during which system maintenance
  can occur, in Universal Coordinated Time (UTC).  Format: ddd:hh24:mi-ddd:hh24:mi  The
  default is a 30-minute window selected at random from an 8-hour block of time for each
  Amazon Web Services Region, occurring on a random day of the week.  Valid days: Mon, Tue,
  Wed, Thu, Fri, Sat, Sun Constraints: Minimum 30-minute window.
- `"PromotionTier"`: A value that specifies the order in which an Amazon DocumentDB replica
  is promoted to the primary instance after a failure of the existing primary instance.
  Default: 1 Valid values: 0-15
- `"Tags"`: The tags to be assigned to the instance. You can assign up to 10 tags to an
  instance.
"""
function create_dbinstance(
    DBClusterIdentifier,
    DBInstanceClass,
    DBInstanceIdentifier,
    Engine;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb(
        "CreateDBInstance",
        Dict{String,Any}(
            "DBClusterIdentifier" => DBClusterIdentifier,
            "DBInstanceClass" => DBInstanceClass,
            "DBInstanceIdentifier" => DBInstanceIdentifier,
            "Engine" => Engine,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_dbinstance(
    DBClusterIdentifier,
    DBInstanceClass,
    DBInstanceIdentifier,
    Engine,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb(
        "CreateDBInstance",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DBClusterIdentifier" => DBClusterIdentifier,
                    "DBInstanceClass" => DBInstanceClass,
                    "DBInstanceIdentifier" => DBInstanceIdentifier,
                    "Engine" => Engine,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_dbsubnet_group(dbsubnet_group_description, dbsubnet_group_name, subnet_identifier)
    create_dbsubnet_group(dbsubnet_group_description, dbsubnet_group_name, subnet_identifier, params::Dict{String,<:Any})

Creates a new subnet group. subnet groups must contain at least one subnet in at least two
Availability Zones in the Amazon Web Services Region.

# Arguments
- `dbsubnet_group_description`: The description for the subnet group.
- `dbsubnet_group_name`: The name for the subnet group. This value is stored as a lowercase
  string. Constraints: Must contain no more than 255 letters, numbers, periods, underscores,
  spaces, or hyphens. Must not be default. Example: mySubnetgroup
- `subnet_identifier`: The Amazon EC2 subnet IDs for the subnet group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"SubnetIds"`: The Amazon EC2 subnet IDs for the subnet group.
- `"Tags"`: The tags to be assigned to the subnet group.
"""
function create_dbsubnet_group(
    DBSubnetGroupDescription,
    DBSubnetGroupName,
    SubnetIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb(
        "CreateDBSubnetGroup",
        Dict{String,Any}(
            "DBSubnetGroupDescription" => DBSubnetGroupDescription,
            "DBSubnetGroupName" => DBSubnetGroupName,
            "SubnetIdentifier" => SubnetIdentifier,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_dbsubnet_group(
    DBSubnetGroupDescription,
    DBSubnetGroupName,
    SubnetIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb(
        "CreateDBSubnetGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DBSubnetGroupDescription" => DBSubnetGroupDescription,
                    "DBSubnetGroupName" => DBSubnetGroupName,
                    "SubnetIdentifier" => SubnetIdentifier,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_event_subscription(sns_topic_arn, subscription_name)
    create_event_subscription(sns_topic_arn, subscription_name, params::Dict{String,<:Any})

Creates an Amazon DocumentDB event notification subscription. This action requires a topic
Amazon Resource Name (ARN) created by using the Amazon DocumentDB console, the Amazon SNS
console, or the Amazon SNS API. To obtain an ARN with Amazon SNS, you must create a topic
in Amazon SNS and subscribe to the topic. The ARN is displayed in the Amazon SNS console.
You can specify the type of source (SourceType) that you want to be notified of. You can
also provide a list of Amazon DocumentDB sources (SourceIds) that trigger the events, and
you can provide a list of event categories (EventCategories) for events that you want to be
notified of. For example, you can specify SourceType = db-instance, SourceIds =
mydbinstance1, mydbinstance2 and EventCategories = Availability, Backup. If you specify
both the SourceType and SourceIds (such as SourceType = db-instance and SourceIdentifier =
myDBInstance1), you are notified of all the db-instance events for the specified source. If
you specify a SourceType but do not specify a SourceIdentifier, you receive notice of the
events for that source type for all your Amazon DocumentDB sources. If you do not specify
either the SourceType or the SourceIdentifier, you are notified of events generated from
all Amazon DocumentDB sources belonging to your customer account.

# Arguments
- `sns_topic_arn`: The Amazon Resource Name (ARN) of the SNS topic created for event
  notification. Amazon SNS creates the ARN when you create a topic and subscribe to it.
- `subscription_name`: The name of the subscription. Constraints: The name must be fewer
  than 255 characters.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Enabled"`:  A Boolean value; set to true to activate the subscription, set to false to
  create the subscription but not active it.
- `"EventCategories"`:  A list of event categories for a SourceType that you want to
  subscribe to.
- `"SourceIds"`: The list of identifiers of the event sources for which events are
  returned. If not specified, then all sources are included in the response. An identifier
  must begin with a letter and must contain only ASCII letters, digits, and hyphens; it can't
  end with a hyphen or contain two consecutive hyphens. Constraints:   If SourceIds are
  provided, SourceType must also be provided.   If the source type is an instance, a
  DBInstanceIdentifier must be provided.   If the source type is a security group, a
  DBSecurityGroupName must be provided.   If the source type is a parameter group, a
  DBParameterGroupName must be provided.   If the source type is a snapshot, a
  DBSnapshotIdentifier must be provided.
- `"SourceType"`: The type of source that is generating the events. For example, if you
  want to be notified of events generated by an instance, you would set this parameter to
  db-instance. If this value is not specified, all events are returned. Valid values:
  db-instance, db-cluster, db-parameter-group, db-security-group, db-cluster-snapshot
- `"Tags"`: The tags to be assigned to the event subscription.
"""
function create_event_subscription(
    SnsTopicArn, SubscriptionName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return docdb(
        "CreateEventSubscription",
        Dict{String,Any}(
            "SnsTopicArn" => SnsTopicArn, "SubscriptionName" => SubscriptionName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_event_subscription(
    SnsTopicArn,
    SubscriptionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb(
        "CreateEventSubscription",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "SnsTopicArn" => SnsTopicArn, "SubscriptionName" => SubscriptionName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_global_cluster(global_cluster_identifier)
    create_global_cluster(global_cluster_identifier, params::Dict{String,<:Any})

Creates an Amazon DocumentDB global cluster that can span multiple multiple Amazon Web
Services Regions. The global cluster contains one primary cluster with read-write
capability, and up-to give read-only secondary clusters. Global clusters uses storage-based
fast replication across regions with latencies less than one second, using dedicated
infrastructure with no impact to your workload’s performance.  You can create a global
cluster that is initially empty, and then add a primary and a secondary to it. Or you can
specify an existing cluster during the create operation, and this cluster becomes the
primary of the global cluster.   This action only applies to Amazon DocumentDB clusters.

# Arguments
- `global_cluster_identifier`: The cluster identifier of the new global cluster.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DatabaseName"`: The name for your database of up to 64 alpha-numeric characters. If you
  do not provide a name, Amazon DocumentDB will not create a database in the global cluster
  you are creating.
- `"DeletionProtection"`: The deletion protection setting for the new global cluster. The
  global cluster can't be deleted when deletion protection is enabled.
- `"Engine"`: The name of the database engine to be used for this cluster.
- `"EngineVersion"`: The engine version of the global cluster.
- `"SourceDBClusterIdentifier"`: The Amazon Resource Name (ARN) to use as the primary
  cluster of the global cluster. This parameter is optional.
- `"StorageEncrypted"`: The storage encryption setting for the new global cluster.
"""
function create_global_cluster(
    GlobalClusterIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return docdb(
        "CreateGlobalCluster",
        Dict{String,Any}("GlobalClusterIdentifier" => GlobalClusterIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_global_cluster(
    GlobalClusterIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb(
        "CreateGlobalCluster",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("GlobalClusterIdentifier" => GlobalClusterIdentifier),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_dbcluster(dbcluster_identifier)
    delete_dbcluster(dbcluster_identifier, params::Dict{String,<:Any})

Deletes a previously provisioned cluster. When you delete a cluster, all automated backups
for that cluster are deleted and can't be recovered. Manual DB cluster snapshots of the
specified cluster are not deleted.

# Arguments
- `dbcluster_identifier`: The cluster identifier for the cluster to be deleted. This
  parameter isn't case sensitive. Constraints:   Must match an existing DBClusterIdentifier.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FinalDBSnapshotIdentifier"`:  The cluster snapshot identifier of the new cluster
  snapshot created when SkipFinalSnapshot is set to false.    Specifying this parameter and
  also setting the SkipFinalShapshot parameter to true results in an error.   Constraints:
  Must be from 1 to 255 letters, numbers, or hyphens.   The first character must be a letter.
    Cannot end with a hyphen or contain two consecutive hyphens.
- `"SkipFinalSnapshot"`:  Determines whether a final cluster snapshot is created before the
  cluster is deleted. If true is specified, no cluster snapshot is created. If false is
  specified, a cluster snapshot is created before the DB cluster is deleted.   If
  SkipFinalSnapshot is false, you must specify a FinalDBSnapshotIdentifier parameter.
  Default: false
"""
function delete_dbcluster(
    DBClusterIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return docdb(
        "DeleteDBCluster",
        Dict{String,Any}("DBClusterIdentifier" => DBClusterIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_dbcluster(
    DBClusterIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb(
        "DeleteDBCluster",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DBClusterIdentifier" => DBClusterIdentifier),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_dbcluster_parameter_group(dbcluster_parameter_group_name)
    delete_dbcluster_parameter_group(dbcluster_parameter_group_name, params::Dict{String,<:Any})

Deletes a specified cluster parameter group. The cluster parameter group to be deleted
can't be associated with any clusters.

# Arguments
- `dbcluster_parameter_group_name`: The name of the cluster parameter group. Constraints:
  Must be the name of an existing cluster parameter group.   You can't delete a default
  cluster parameter group.   Cannot be associated with any clusters.

"""
function delete_dbcluster_parameter_group(
    DBClusterParameterGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return docdb(
        "DeleteDBClusterParameterGroup",
        Dict{String,Any}("DBClusterParameterGroupName" => DBClusterParameterGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_dbcluster_parameter_group(
    DBClusterParameterGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb(
        "DeleteDBClusterParameterGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DBClusterParameterGroupName" => DBClusterParameterGroupName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_dbcluster_snapshot(dbcluster_snapshot_identifier)
    delete_dbcluster_snapshot(dbcluster_snapshot_identifier, params::Dict{String,<:Any})

Deletes a cluster snapshot. If the snapshot is being copied, the copy operation is
terminated.  The cluster snapshot must be in the available state to be deleted.

# Arguments
- `dbcluster_snapshot_identifier`: The identifier of the cluster snapshot to delete.
  Constraints: Must be the name of an existing cluster snapshot in the available state.

"""
function delete_dbcluster_snapshot(
    DBClusterSnapshotIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return docdb(
        "DeleteDBClusterSnapshot",
        Dict{String,Any}("DBClusterSnapshotIdentifier" => DBClusterSnapshotIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_dbcluster_snapshot(
    DBClusterSnapshotIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb(
        "DeleteDBClusterSnapshot",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DBClusterSnapshotIdentifier" => DBClusterSnapshotIdentifier
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_dbinstance(dbinstance_identifier)
    delete_dbinstance(dbinstance_identifier, params::Dict{String,<:Any})

Deletes a previously provisioned instance.

# Arguments
- `dbinstance_identifier`: The instance identifier for the instance to be deleted. This
  parameter isn't case sensitive. Constraints:   Must match the name of an existing instance.
  

"""
function delete_dbinstance(
    DBInstanceIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return docdb(
        "DeleteDBInstance",
        Dict{String,Any}("DBInstanceIdentifier" => DBInstanceIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_dbinstance(
    DBInstanceIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb(
        "DeleteDBInstance",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DBInstanceIdentifier" => DBInstanceIdentifier),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_dbsubnet_group(dbsubnet_group_name)
    delete_dbsubnet_group(dbsubnet_group_name, params::Dict{String,<:Any})

Deletes a subnet group.  The specified database subnet group must not be associated with
any DB instances.

# Arguments
- `dbsubnet_group_name`: The name of the database subnet group to delete.  You can't delete
  the default subnet group.  Constraints: Must match the name of an existing DBSubnetGroup.
  Must not be default. Example: mySubnetgroup

"""
function delete_dbsubnet_group(
    DBSubnetGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return docdb(
        "DeleteDBSubnetGroup",
        Dict{String,Any}("DBSubnetGroupName" => DBSubnetGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_dbsubnet_group(
    DBSubnetGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb(
        "DeleteDBSubnetGroup",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("DBSubnetGroupName" => DBSubnetGroupName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_event_subscription(subscription_name)
    delete_event_subscription(subscription_name, params::Dict{String,<:Any})

Deletes an Amazon DocumentDB event notification subscription.

# Arguments
- `subscription_name`: The name of the Amazon DocumentDB event notification subscription
  that you want to delete.

"""
function delete_event_subscription(
    SubscriptionName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return docdb(
        "DeleteEventSubscription",
        Dict{String,Any}("SubscriptionName" => SubscriptionName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_event_subscription(
    SubscriptionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb(
        "DeleteEventSubscription",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("SubscriptionName" => SubscriptionName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_global_cluster(global_cluster_identifier)
    delete_global_cluster(global_cluster_identifier, params::Dict{String,<:Any})

Deletes a global cluster. The primary and secondary clusters must already be detached or
deleted before attempting to delete a global cluster.  This action only applies to Amazon
DocumentDB clusters.

# Arguments
- `global_cluster_identifier`: The cluster identifier of the global cluster being deleted.

"""
function delete_global_cluster(
    GlobalClusterIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return docdb(
        "DeleteGlobalCluster",
        Dict{String,Any}("GlobalClusterIdentifier" => GlobalClusterIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_global_cluster(
    GlobalClusterIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb(
        "DeleteGlobalCluster",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("GlobalClusterIdentifier" => GlobalClusterIdentifier),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_certificates()
    describe_certificates(params::Dict{String,<:Any})

Returns a list of certificate authority (CA) certificates provided by Amazon DocumentDB for
this Amazon Web Services account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CertificateIdentifier"`: The user-supplied certificate identifier. If this parameter is
  specified, information for only the specified certificate is returned. If this parameter is
  omitted, a list of up to MaxRecords certificates is returned. This parameter is not case
  sensitive. Constraints   Must match an existing CertificateIdentifier.
- `"Filters"`: This parameter is not currently supported.
- `"Marker"`: An optional pagination token provided by a previous DescribeCertificates
  request. If this parameter is specified, the response includes only records beyond the
  marker, up to the value specified by MaxRecords.
- `"MaxRecords"`: The maximum number of records to include in the response. If more records
  exist than the specified MaxRecords value, a pagination token called a marker is included
  in the response so that the remaining results can be retrieved. Default: 100 Constraints:
  Minimum: 20   Maximum: 100
"""
function describe_certificates(; aws_config::AbstractAWSConfig=current_aws_config())
    return docdb(
        "DescribeCertificates"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_certificates(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return docdb(
        "DescribeCertificates",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_dbcluster_parameter_groups()
    describe_dbcluster_parameter_groups(params::Dict{String,<:Any})

Returns a list of DBClusterParameterGroup descriptions. If a DBClusterParameterGroupName
parameter is specified, the list contains only the description of the specified cluster
parameter group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DBClusterParameterGroupName"`: The name of a specific cluster parameter group to return
  details for. Constraints:   If provided, must match the name of an existing
  DBClusterParameterGroup.
- `"Filters"`: This parameter is not currently supported.
- `"Marker"`: An optional pagination token provided by a previous request. If this
  parameter is specified, the response includes only records beyond the marker, up to the
  value specified by MaxRecords.
- `"MaxRecords"`:  The maximum number of records to include in the response. If more
  records exist than the specified MaxRecords value, a pagination token (marker) is included
  in the response so that the remaining results can be retrieved. Default: 100 Constraints:
  Minimum 20, maximum 100.
"""
function describe_dbcluster_parameter_groups(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return docdb(
        "DescribeDBClusterParameterGroups";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_dbcluster_parameter_groups(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return docdb(
        "DescribeDBClusterParameterGroups",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_dbcluster_parameters(dbcluster_parameter_group_name)
    describe_dbcluster_parameters(dbcluster_parameter_group_name, params::Dict{String,<:Any})

Returns the detailed parameter list for a particular cluster parameter group.

# Arguments
- `dbcluster_parameter_group_name`: The name of a specific cluster parameter group to
  return parameter details for. Constraints:   If provided, must match the name of an
  existing DBClusterParameterGroup.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: This parameter is not currently supported.
- `"Marker"`: An optional pagination token provided by a previous request. If this
  parameter is specified, the response includes only records beyond the marker, up to the
  value specified by MaxRecords.
- `"MaxRecords"`:  The maximum number of records to include in the response. If more
  records exist than the specified MaxRecords value, a pagination token (marker) is included
  in the response so that the remaining results can be retrieved. Default: 100 Constraints:
  Minimum 20, maximum 100.
- `"Source"`:  A value that indicates to return only parameters for a specific source.
  Parameter sources can be engine, service, or customer.
"""
function describe_dbcluster_parameters(
    DBClusterParameterGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return docdb(
        "DescribeDBClusterParameters",
        Dict{String,Any}("DBClusterParameterGroupName" => DBClusterParameterGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_dbcluster_parameters(
    DBClusterParameterGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb(
        "DescribeDBClusterParameters",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DBClusterParameterGroupName" => DBClusterParameterGroupName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_dbcluster_snapshot_attributes(dbcluster_snapshot_identifier)
    describe_dbcluster_snapshot_attributes(dbcluster_snapshot_identifier, params::Dict{String,<:Any})

Returns a list of cluster snapshot attribute names and values for a manual DB cluster
snapshot. When you share snapshots with other Amazon Web Services accounts,
DescribeDBClusterSnapshotAttributes returns the restore attribute and a list of IDs for the
Amazon Web Services accounts that are authorized to copy or restore the manual cluster
snapshot. If all is included in the list of values for the restore attribute, then the
manual cluster snapshot is public and can be copied or restored by all Amazon Web Services
accounts.

# Arguments
- `dbcluster_snapshot_identifier`: The identifier for the cluster snapshot to describe the
  attributes for.

"""
function describe_dbcluster_snapshot_attributes(
    DBClusterSnapshotIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return docdb(
        "DescribeDBClusterSnapshotAttributes",
        Dict{String,Any}("DBClusterSnapshotIdentifier" => DBClusterSnapshotIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_dbcluster_snapshot_attributes(
    DBClusterSnapshotIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb(
        "DescribeDBClusterSnapshotAttributes",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DBClusterSnapshotIdentifier" => DBClusterSnapshotIdentifier
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_dbcluster_snapshots()
    describe_dbcluster_snapshots(params::Dict{String,<:Any})

Returns information about cluster snapshots. This API operation supports pagination.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DBClusterIdentifier"`: The ID of the cluster to retrieve the list of cluster snapshots
  for. This parameter can't be used with the DBClusterSnapshotIdentifier parameter. This
  parameter is not case sensitive.  Constraints:   If provided, must match the identifier of
  an existing DBCluster.
- `"DBClusterSnapshotIdentifier"`: A specific cluster snapshot identifier to describe. This
  parameter can't be used with the DBClusterIdentifier parameter. This value is stored as a
  lowercase string.  Constraints:   If provided, must match the identifier of an existing
  DBClusterSnapshot.   If this identifier is for an automated snapshot, the SnapshotType
  parameter must also be specified.
- `"Filters"`: This parameter is not currently supported.
- `"IncludePublic"`: Set to true to include manual cluster snapshots that are public and
  can be copied or restored by any Amazon Web Services account, and otherwise false. The
  default is false.
- `"IncludeShared"`: Set to true to include shared manual cluster snapshots from other
  Amazon Web Services accounts that this Amazon Web Services account has been given
  permission to copy or restore, and otherwise false. The default is false.
- `"Marker"`: An optional pagination token provided by a previous request. If this
  parameter is specified, the response includes only records beyond the marker, up to the
  value specified by MaxRecords.
- `"MaxRecords"`:  The maximum number of records to include in the response. If more
  records exist than the specified MaxRecords value, a pagination token (marker) is included
  in the response so that the remaining results can be retrieved. Default: 100 Constraints:
  Minimum 20, maximum 100.
- `"SnapshotType"`: The type of cluster snapshots to be returned. You can specify one of
  the following values:    automated - Return all cluster snapshots that Amazon DocumentDB
  has automatically created for your Amazon Web Services account.    manual - Return all
  cluster snapshots that you have manually created for your Amazon Web Services account.
  shared - Return all manual cluster snapshots that have been shared to your Amazon Web
  Services account.    public - Return all cluster snapshots that have been marked as public.
    If you don't specify a SnapshotType value, then both automated and manual cluster
  snapshots are returned. You can include shared cluster snapshots with these results by
  setting the IncludeShared parameter to true. You can include public cluster snapshots with
  these results by setting theIncludePublic parameter to true. The IncludeShared and
  IncludePublic parameters don't apply for SnapshotType values of manual or automated. The
  IncludePublic parameter doesn't apply when SnapshotType is set to shared. The IncludeShared
  parameter doesn't apply when SnapshotType is set to public.
"""
function describe_dbcluster_snapshots(; aws_config::AbstractAWSConfig=current_aws_config())
    return docdb(
        "DescribeDBClusterSnapshots"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_dbcluster_snapshots(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return docdb(
        "DescribeDBClusterSnapshots",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_dbclusters()
    describe_dbclusters(params::Dict{String,<:Any})

Returns information about provisioned Amazon DocumentDB clusters. This API operation
supports pagination. For certain management features such as cluster and instance lifecycle
management, Amazon DocumentDB leverages operational technology that is shared with Amazon
RDS and Amazon Neptune. Use the filterName=engine,Values=docdb filter parameter to return
only Amazon DocumentDB clusters.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DBClusterIdentifier"`: The user-provided cluster identifier. If this parameter is
  specified, information from only the specific cluster is returned. This parameter isn't
  case sensitive. Constraints:   If provided, must match an existing DBClusterIdentifier.
- `"Filters"`: A filter that specifies one or more clusters to describe. Supported filters:
     db-cluster-id - Accepts cluster identifiers and cluster Amazon Resource Names (ARNs).
  The results list only includes information about the clusters identified by these ARNs.
- `"Marker"`: An optional pagination token provided by a previous request. If this
  parameter is specified, the response includes only records beyond the marker, up to the
  value specified by MaxRecords.
- `"MaxRecords"`:  The maximum number of records to include in the response. If more
  records exist than the specified MaxRecords value, a pagination token (marker) is included
  in the response so that the remaining results can be retrieved. Default: 100 Constraints:
  Minimum 20, maximum 100.
"""
function describe_dbclusters(; aws_config::AbstractAWSConfig=current_aws_config())
    return docdb(
        "DescribeDBClusters"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_dbclusters(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return docdb(
        "DescribeDBClusters", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_dbengine_versions()
    describe_dbengine_versions(params::Dict{String,<:Any})

Returns a list of the available engines.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DBParameterGroupFamily"`: The name of a specific parameter group family to return
  details for. Constraints:   If provided, must match an existing DBParameterGroupFamily.
- `"DefaultOnly"`: Indicates that only the default version of the specified engine or
  engine and major version combination is returned.
- `"Engine"`: The database engine to return.
- `"EngineVersion"`: The database engine version to return. Example: 3.6.0
- `"Filters"`: This parameter is not currently supported.
- `"ListSupportedCharacterSets"`: If this parameter is specified and the requested engine
  supports the CharacterSetName parameter for CreateDBInstance, the response includes a list
  of supported character sets for each engine version.
- `"ListSupportedTimezones"`: If this parameter is specified and the requested engine
  supports the TimeZone parameter for CreateDBInstance, the response includes a list of
  supported time zones for each engine version.
- `"Marker"`: An optional pagination token provided by a previous request. If this
  parameter is specified, the response includes only records beyond the marker, up to the
  value specified by MaxRecords.
- `"MaxRecords"`:  The maximum number of records to include in the response. If more
  records exist than the specified MaxRecords value, a pagination token (marker) is included
  in the response so that the remaining results can be retrieved. Default: 100 Constraints:
  Minimum 20, maximum 100.
"""
function describe_dbengine_versions(; aws_config::AbstractAWSConfig=current_aws_config())
    return docdb(
        "DescribeDBEngineVersions"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_dbengine_versions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return docdb(
        "DescribeDBEngineVersions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_dbinstances()
    describe_dbinstances(params::Dict{String,<:Any})

Returns information about provisioned Amazon DocumentDB instances. This API supports
pagination.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DBInstanceIdentifier"`: The user-provided instance identifier. If this parameter is
  specified, information from only the specific instance is returned. This parameter isn't
  case sensitive. Constraints:   If provided, must match the identifier of an existing
  DBInstance.
- `"Filters"`: A filter that specifies one or more instances to describe. Supported
  filters:    db-cluster-id - Accepts cluster identifiers and cluster Amazon Resource Names
  (ARNs). The results list includes only the information about the instances that are
  associated with the clusters that are identified by these ARNs.    db-instance-id - Accepts
  instance identifiers and instance ARNs. The results list includes only the information
  about the instances that are identified by these ARNs.
- `"Marker"`: An optional pagination token provided by a previous request. If this
  parameter is specified, the response includes only records beyond the marker, up to the
  value specified by MaxRecords.
- `"MaxRecords"`:  The maximum number of records to include in the response. If more
  records exist than the specified MaxRecords value, a pagination token (marker) is included
  in the response so that the remaining results can be retrieved. Default: 100 Constraints:
  Minimum 20, maximum 100.
"""
function describe_dbinstances(; aws_config::AbstractAWSConfig=current_aws_config())
    return docdb(
        "DescribeDBInstances"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_dbinstances(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return docdb(
        "DescribeDBInstances",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_dbsubnet_groups()
    describe_dbsubnet_groups(params::Dict{String,<:Any})

Returns a list of DBSubnetGroup descriptions. If a DBSubnetGroupName is specified, the list
will contain only the descriptions of the specified DBSubnetGroup.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DBSubnetGroupName"`: The name of the subnet group to return details for.
- `"Filters"`: This parameter is not currently supported.
- `"Marker"`: An optional pagination token provided by a previous request. If this
  parameter is specified, the response includes only records beyond the marker, up to the
  value specified by MaxRecords.
- `"MaxRecords"`:  The maximum number of records to include in the response. If more
  records exist than the specified MaxRecords value, a pagination token (marker) is included
  in the response so that the remaining results can be retrieved. Default: 100 Constraints:
  Minimum 20, maximum 100.
"""
function describe_dbsubnet_groups(; aws_config::AbstractAWSConfig=current_aws_config())
    return docdb(
        "DescribeDBSubnetGroups"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_dbsubnet_groups(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return docdb(
        "DescribeDBSubnetGroups",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_engine_default_cluster_parameters(dbparameter_group_family)
    describe_engine_default_cluster_parameters(dbparameter_group_family, params::Dict{String,<:Any})

Returns the default engine and system parameter information for the cluster database engine.

# Arguments
- `dbparameter_group_family`: The name of the cluster parameter group family to return the
  engine parameter information for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: This parameter is not currently supported.
- `"Marker"`: An optional pagination token provided by a previous request. If this
  parameter is specified, the response includes only records beyond the marker, up to the
  value specified by MaxRecords.
- `"MaxRecords"`:  The maximum number of records to include in the response. If more
  records exist than the specified MaxRecords value, a pagination token (marker) is included
  in the response so that the remaining results can be retrieved. Default: 100 Constraints:
  Minimum 20, maximum 100.
"""
function describe_engine_default_cluster_parameters(
    DBParameterGroupFamily; aws_config::AbstractAWSConfig=current_aws_config()
)
    return docdb(
        "DescribeEngineDefaultClusterParameters",
        Dict{String,Any}("DBParameterGroupFamily" => DBParameterGroupFamily);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_engine_default_cluster_parameters(
    DBParameterGroupFamily,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb(
        "DescribeEngineDefaultClusterParameters",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DBParameterGroupFamily" => DBParameterGroupFamily),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_event_categories()
    describe_event_categories(params::Dict{String,<:Any})

Displays a list of categories for all event source types, or, if specified, for a specified
source type.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: This parameter is not currently supported.
- `"SourceType"`: The type of source that is generating the events. Valid values:
  db-instance, db-parameter-group, db-security-group
"""
function describe_event_categories(; aws_config::AbstractAWSConfig=current_aws_config())
    return docdb(
        "DescribeEventCategories"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_event_categories(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return docdb(
        "DescribeEventCategories",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_event_subscriptions()
    describe_event_subscriptions(params::Dict{String,<:Any})

Lists all the subscription descriptions for a customer account. The description for a
subscription includes SubscriptionName, SNSTopicARN, CustomerID, SourceType, SourceID,
CreationTime, and Status. If you specify a SubscriptionName, lists the description for that
subscription.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: This parameter is not currently supported.
- `"Marker"`: An optional pagination token provided by a previous request. If this
  parameter is specified, the response includes only records beyond the marker, up to the
  value specified by MaxRecords.
- `"MaxRecords"`:  The maximum number of records to include in the response. If more
  records exist than the specified MaxRecords value, a pagination token (marker) is included
  in the response so that the remaining results can be retrieved. Default: 100 Constraints:
  Minimum 20, maximum 100.
- `"SubscriptionName"`: The name of the Amazon DocumentDB event notification subscription
  that you want to describe.
"""
function describe_event_subscriptions(; aws_config::AbstractAWSConfig=current_aws_config())
    return docdb(
        "DescribeEventSubscriptions"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_event_subscriptions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return docdb(
        "DescribeEventSubscriptions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_events()
    describe_events(params::Dict{String,<:Any})

Returns events related to instances, security groups, snapshots, and DB parameter groups
for the past 14 days. You can obtain events specific to a particular DB instance, security
group, snapshot, or parameter group by providing the name as a parameter. By default, the
events of the past hour are returned.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Duration"`: The number of minutes to retrieve events for. Default: 60
- `"EndTime"`:  The end of the time interval for which to retrieve events, specified in ISO
  8601 format.  Example: 2009-07-08T18:00Z
- `"EventCategories"`: A list of event categories that trigger notifications for an event
  notification subscription.
- `"Filters"`: This parameter is not currently supported.
- `"Marker"`: An optional pagination token provided by a previous request. If this
  parameter is specified, the response includes only records beyond the marker, up to the
  value specified by MaxRecords.
- `"MaxRecords"`:  The maximum number of records to include in the response. If more
  records exist than the specified MaxRecords value, a pagination token (marker) is included
  in the response so that the remaining results can be retrieved. Default: 100 Constraints:
  Minimum 20, maximum 100.
- `"SourceIdentifier"`: The identifier of the event source for which events are returned.
  If not specified, then all sources are included in the response. Constraints:   If
  SourceIdentifier is provided, SourceType must also be provided.   If the source type is
  DBInstance, a DBInstanceIdentifier must be provided.   If the source type is
  DBSecurityGroup, a DBSecurityGroupName must be provided.   If the source type is
  DBParameterGroup, a DBParameterGroupName must be provided.   If the source type is
  DBSnapshot, a DBSnapshotIdentifier must be provided.   Cannot end with a hyphen or contain
  two consecutive hyphens.
- `"SourceType"`: The event source to retrieve events for. If no value is specified, all
  events are returned.
- `"StartTime"`:  The beginning of the time interval to retrieve events for, specified in
  ISO 8601 format.  Example: 2009-07-08T18:00Z
"""
function describe_events(; aws_config::AbstractAWSConfig=current_aws_config())
    return docdb("DescribeEvents"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function describe_events(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return docdb(
        "DescribeEvents", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_global_clusters()
    describe_global_clusters(params::Dict{String,<:Any})

Returns information about Amazon DocumentDB global clusters. This API supports pagination.
This action only applies to Amazon DocumentDB clusters.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: A filter that specifies one or more global DB clusters to describe.
  Supported filters: db-cluster-id accepts cluster identifiers and cluster Amazon Resource
  Names (ARNs). The results list will only include information about the clusters identified
  by these ARNs.
- `"GlobalClusterIdentifier"`: The user-supplied cluster identifier. If this parameter is
  specified, information from only the specific cluster is returned. This parameter isn't
  case-sensitive.
- `"Marker"`: An optional pagination token provided by a previous DescribeGlobalClusters
  request. If this parameter is specified, the response includes only records beyond the
  marker, up to the value specified by MaxRecords.
- `"MaxRecords"`: The maximum number of records to include in the response. If more records
  exist than the specified MaxRecords value, a pagination token called a marker is included
  in the response so that you can retrieve the remaining results.
"""
function describe_global_clusters(; aws_config::AbstractAWSConfig=current_aws_config())
    return docdb(
        "DescribeGlobalClusters"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_global_clusters(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return docdb(
        "DescribeGlobalClusters",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_orderable_dbinstance_options(engine)
    describe_orderable_dbinstance_options(engine, params::Dict{String,<:Any})

Returns a list of orderable instance options for the specified engine.

# Arguments
- `engine`: The name of the engine to retrieve instance options for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DBInstanceClass"`: The instance class filter value. Specify this parameter to show only
  the available offerings that match the specified instance class.
- `"EngineVersion"`: The engine version filter value. Specify this parameter to show only
  the available offerings that match the specified engine version.
- `"Filters"`: This parameter is not currently supported.
- `"LicenseModel"`: The license model filter value. Specify this parameter to show only the
  available offerings that match the specified license model.
- `"Marker"`: An optional pagination token provided by a previous request. If this
  parameter is specified, the response includes only records beyond the marker, up to the
  value specified by MaxRecords.
- `"MaxRecords"`:  The maximum number of records to include in the response. If more
  records exist than the specified MaxRecords value, a pagination token (marker) is included
  in the response so that the remaining results can be retrieved. Default: 100 Constraints:
  Minimum 20, maximum 100.
- `"Vpc"`: The virtual private cloud (VPC) filter value. Specify this parameter to show
  only the available VPC or non-VPC offerings.
"""
function describe_orderable_dbinstance_options(
    Engine; aws_config::AbstractAWSConfig=current_aws_config()
)
    return docdb(
        "DescribeOrderableDBInstanceOptions",
        Dict{String,Any}("Engine" => Engine);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_orderable_dbinstance_options(
    Engine, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return docdb(
        "DescribeOrderableDBInstanceOptions",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Engine" => Engine), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_pending_maintenance_actions()
    describe_pending_maintenance_actions(params::Dict{String,<:Any})

Returns a list of resources (for example, instances) that have at least one pending
maintenance action.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: A filter that specifies one or more resources to return pending maintenance
  actions for. Supported filters:    db-cluster-id - Accepts cluster identifiers and cluster
  Amazon Resource Names (ARNs). The results list includes only pending maintenance actions
  for the clusters identified by these ARNs.    db-instance-id - Accepts instance identifiers
  and instance ARNs. The results list includes only pending maintenance actions for the DB
  instances identified by these ARNs.
- `"Marker"`: An optional pagination token provided by a previous request. If this
  parameter is specified, the response includes only records beyond the marker, up to the
  value specified by MaxRecords.
- `"MaxRecords"`:  The maximum number of records to include in the response. If more
  records exist than the specified MaxRecords value, a pagination token (marker) is included
  in the response so that the remaining results can be retrieved. Default: 100 Constraints:
  Minimum 20, maximum 100.
- `"ResourceIdentifier"`: The ARN of a resource to return pending maintenance actions for.
"""
function describe_pending_maintenance_actions(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return docdb(
        "DescribePendingMaintenanceActions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_pending_maintenance_actions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return docdb(
        "DescribePendingMaintenanceActions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    failover_dbcluster()
    failover_dbcluster(params::Dict{String,<:Any})

Forces a failover for a cluster. A failover for a cluster promotes one of the Amazon
DocumentDB replicas (read-only instances) in the cluster to be the primary instance (the
cluster writer). If the primary instance fails, Amazon DocumentDB automatically fails over
to an Amazon DocumentDB replica, if one exists. You can force a failover when you want to
simulate a failure of a primary instance for testing.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DBClusterIdentifier"`: A cluster identifier to force a failover for. This parameter is
  not case sensitive. Constraints:   Must match the identifier of an existing DBCluster.
- `"TargetDBInstanceIdentifier"`: The name of the instance to promote to the primary
  instance. You must specify the instance identifier for an Amazon DocumentDB replica in the
  cluster. For example, mydbcluster-replica1.
"""
function failover_dbcluster(; aws_config::AbstractAWSConfig=current_aws_config())
    return docdb(
        "FailoverDBCluster"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function failover_dbcluster(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return docdb(
        "FailoverDBCluster", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_name)
    list_tags_for_resource(resource_name, params::Dict{String,<:Any})

Lists all tags on an Amazon DocumentDB resource.

# Arguments
- `resource_name`: The Amazon DocumentDB resource with tags to be listed. This value is an
  Amazon Resource Name (ARN).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: This parameter is not currently supported.
"""
function list_tags_for_resource(
    ResourceName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return docdb(
        "ListTagsForResource",
        Dict{String,Any}("ResourceName" => ResourceName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceName" => ResourceName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    modify_dbcluster(dbcluster_identifier)
    modify_dbcluster(dbcluster_identifier, params::Dict{String,<:Any})

Modifies a setting for an Amazon DocumentDB cluster. You can change one or more database
configuration parameters by specifying these parameters and the new values in the request.

# Arguments
- `dbcluster_identifier`: The cluster identifier for the cluster that is being modified.
  This parameter is not case sensitive. Constraints:   Must match the identifier of an
  existing DBCluster.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AllowMajorVersionUpgrade"`: A value that indicates whether major version upgrades are
  allowed. Constraints: You must allow major version upgrades when specifying a value for the
  EngineVersion parameter that is a different major version than the DB cluster's current
  version.
- `"ApplyImmediately"`: A value that specifies whether the changes in this request and any
  pending changes are asynchronously applied as soon as possible, regardless of the
  PreferredMaintenanceWindow setting for the cluster. If this parameter is set to false,
  changes to the cluster are applied during the next maintenance window. The ApplyImmediately
  parameter affects only the NewDBClusterIdentifier and MasterUserPassword values. If you set
  this parameter value to false, the changes to the NewDBClusterIdentifier and
  MasterUserPassword values are applied during the next maintenance window. All other changes
  are applied immediately, regardless of the value of the ApplyImmediately parameter.
  Default: false
- `"BackupRetentionPeriod"`: The number of days for which automated backups are retained.
  You must specify a minimum value of 1. Default: 1 Constraints:   Must be a value from 1 to
  35.
- `"CloudwatchLogsExportConfiguration"`: The configuration setting for the log types to be
  enabled for export to Amazon CloudWatch Logs for a specific instance or cluster. The
  EnableLogTypes and DisableLogTypes arrays determine which logs are exported (or not
  exported) to CloudWatch Logs.
- `"DBClusterParameterGroupName"`: The name of the cluster parameter group to use for the
  cluster.
- `"DeletionProtection"`: Specifies whether this cluster can be deleted. If
  DeletionProtection is enabled, the cluster cannot be deleted unless it is modified and
  DeletionProtection is disabled. DeletionProtection protects clusters from being
  accidentally deleted.
- `"EngineVersion"`: The version number of the database engine to which you want to
  upgrade. Changing this parameter results in an outage. The change is applied during the
  next maintenance window unless ApplyImmediately is enabled. To list all of the available
  engine versions for Amazon DocumentDB use the following command:  aws docdb
  describe-db-engine-versions --engine docdb --query \"DBEngineVersions[].EngineVersion\"
- `"MasterUserPassword"`: The password for the master database user. This password can
  contain any printable ASCII character except forward slash (/), double quote (\"), or the
  \"at\" symbol (@). Constraints: Must contain from 8 to 100 characters.
- `"NewDBClusterIdentifier"`: The new cluster identifier for the cluster when renaming a
  cluster. This value is stored as a lowercase string. Constraints:   Must contain from 1 to
  63 letters, numbers, or hyphens.   The first character must be a letter.   Cannot end with
  a hyphen or contain two consecutive hyphens.   Example: my-cluster2
- `"Port"`: The port number on which the cluster accepts connections. Constraints: Must be
  a value from 1150 to 65535.  Default: The same port as the original cluster.
- `"PreferredBackupWindow"`: The daily time range during which automated backups are
  created if automated backups are enabled, using the BackupRetentionPeriod parameter.  The
  default is a 30-minute window selected at random from an 8-hour block of time for each
  Amazon Web Services Region.  Constraints:   Must be in the format hh24:mi-hh24:mi.   Must
  be in Universal Coordinated Time (UTC).   Must not conflict with the preferred maintenance
  window.   Must be at least 30 minutes.
- `"PreferredMaintenanceWindow"`: The weekly time range during which system maintenance can
  occur, in Universal Coordinated Time (UTC). Format: ddd:hh24:mi-ddd:hh24:mi  The default is
  a 30-minute window selected at random from an 8-hour block of time for each Amazon Web
  Services Region, occurring on a random day of the week.  Valid days: Mon, Tue, Wed, Thu,
  Fri, Sat, Sun Constraints: Minimum 30-minute window.
- `"StorageType"`: The storage type to associate with the DB cluster. For information on
  storage types for Amazon DocumentDB clusters, see Cluster storage configurations in the
  Amazon DocumentDB Developer Guide. Valid values for storage type - standard | iopt1
  Default value is standard
- `"VpcSecurityGroupIds"`: A list of virtual private cloud (VPC) security groups that the
  cluster will belong to.
"""
function modify_dbcluster(
    DBClusterIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return docdb(
        "ModifyDBCluster",
        Dict{String,Any}("DBClusterIdentifier" => DBClusterIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function modify_dbcluster(
    DBClusterIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb(
        "ModifyDBCluster",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DBClusterIdentifier" => DBClusterIdentifier),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    modify_dbcluster_parameter_group(dbcluster_parameter_group_name, parameter)
    modify_dbcluster_parameter_group(dbcluster_parameter_group_name, parameter, params::Dict{String,<:Any})

 Modifies the parameters of a cluster parameter group. To modify more than one parameter,
submit a list of the following: ParameterName, ParameterValue, and ApplyMethod. A maximum
of 20 parameters can be modified in a single request.   Changes to dynamic parameters are
applied immediately. Changes to static parameters require a reboot or maintenance window
before the change can take effect.   After you create a cluster parameter group, you should
wait at least 5 minutes before creating your first cluster that uses that cluster parameter
group as the default parameter group. This allows Amazon DocumentDB to fully complete the
create action before the parameter group is used as the default for a new cluster. This
step is especially important for parameters that are critical when creating the default
database for a cluster, such as the character set for the default database defined by the
character_set_database parameter.

# Arguments
- `dbcluster_parameter_group_name`: The name of the cluster parameter group to modify.
- `parameter`: A list of parameters in the cluster parameter group to modify.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Parameters"`: A list of parameters in the cluster parameter group to modify.
"""
function modify_dbcluster_parameter_group(
    DBClusterParameterGroupName,
    Parameter;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb(
        "ModifyDBClusterParameterGroup",
        Dict{String,Any}(
            "DBClusterParameterGroupName" => DBClusterParameterGroupName,
            "Parameter" => Parameter,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function modify_dbcluster_parameter_group(
    DBClusterParameterGroupName,
    Parameter,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb(
        "ModifyDBClusterParameterGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DBClusterParameterGroupName" => DBClusterParameterGroupName,
                    "Parameter" => Parameter,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    modify_dbcluster_snapshot_attribute(attribute_name, dbcluster_snapshot_identifier)
    modify_dbcluster_snapshot_attribute(attribute_name, dbcluster_snapshot_identifier, params::Dict{String,<:Any})

Adds an attribute and values to, or removes an attribute and values from, a manual cluster
snapshot. To share a manual cluster snapshot with other Amazon Web Services accounts,
specify restore as the AttributeName, and use the ValuesToAdd parameter to add a list of
IDs of the Amazon Web Services accounts that are authorized to restore the manual cluster
snapshot. Use the value all to make the manual cluster snapshot public, which means that it
can be copied or restored by all Amazon Web Services accounts. Do not add the all value for
any manual cluster snapshots that contain private information that you don't want available
to all Amazon Web Services accounts. If a manual cluster snapshot is encrypted, it can be
shared, but only by specifying a list of authorized Amazon Web Services account IDs for the
ValuesToAdd parameter. You can't use all as a value for that parameter in this case.

# Arguments
- `attribute_name`: The name of the cluster snapshot attribute to modify. To manage
  authorization for other Amazon Web Services accounts to copy or restore a manual cluster
  snapshot, set this value to restore.
- `dbcluster_snapshot_identifier`: The identifier for the cluster snapshot to modify the
  attributes for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ValuesToAdd"`: A list of cluster snapshot attributes to add to the attribute specified
  by AttributeName. To authorize other Amazon Web Services accounts to copy or restore a
  manual cluster snapshot, set this list to include one or more Amazon Web Services account
  IDs. To make the manual cluster snapshot restorable by any Amazon Web Services account, set
  it to all. Do not add the all value for any manual cluster snapshots that contain private
  information that you don't want to be available to all Amazon Web Services accounts.
- `"ValuesToRemove"`: A list of cluster snapshot attributes to remove from the attribute
  specified by AttributeName. To remove authorization for other Amazon Web Services accounts
  to copy or restore a manual cluster snapshot, set this list to include one or more Amazon
  Web Services account identifiers. To remove authorization for any Amazon Web Services
  account to copy or restore the cluster snapshot, set it to all . If you specify all, an
  Amazon Web Services account whose account ID is explicitly added to the restore attribute
  can still copy or restore a manual cluster snapshot.
"""
function modify_dbcluster_snapshot_attribute(
    AttributeName,
    DBClusterSnapshotIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb(
        "ModifyDBClusterSnapshotAttribute",
        Dict{String,Any}(
            "AttributeName" => AttributeName,
            "DBClusterSnapshotIdentifier" => DBClusterSnapshotIdentifier,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function modify_dbcluster_snapshot_attribute(
    AttributeName,
    DBClusterSnapshotIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb(
        "ModifyDBClusterSnapshotAttribute",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AttributeName" => AttributeName,
                    "DBClusterSnapshotIdentifier" => DBClusterSnapshotIdentifier,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    modify_dbinstance(dbinstance_identifier)
    modify_dbinstance(dbinstance_identifier, params::Dict{String,<:Any})

Modifies settings for an instance. You can change one or more database configuration
parameters by specifying these parameters and the new values in the request.

# Arguments
- `dbinstance_identifier`: The instance identifier. This value is stored as a lowercase
  string. Constraints:   Must match the identifier of an existing DBInstance.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ApplyImmediately"`: Specifies whether the modifications in this request and any pending
  modifications are asynchronously applied as soon as possible, regardless of the
  PreferredMaintenanceWindow setting for the instance.   If this parameter is set to false,
  changes to the instance are applied during the next maintenance window. Some parameter
  changes can cause an outage and are applied on the next reboot. Default: false
- `"AutoMinorVersionUpgrade"`: This parameter does not apply to Amazon DocumentDB. Amazon
  DocumentDB does not perform minor version upgrades regardless of the value set.
- `"CACertificateIdentifier"`: Indicates the certificate that needs to be associated with
  the instance.
- `"CertificateRotationRestart"`: Specifies whether the DB instance is restarted when you
  rotate your SSL/TLS certificate. By default, the DB instance is restarted when you rotate
  your SSL/TLS certificate. The certificate is not updated until the DB instance is
  restarted.  Set this parameter only if you are not using SSL/TLS to connect to the DB
  instance.  If you are using SSL/TLS to connect to the DB instance, see Updating Your Amazon
  DocumentDB TLS Certificates and  Encrypting Data in Transit in the Amazon DocumentDB
  Developer Guide.
- `"CopyTagsToSnapshot"`: A value that indicates whether to copy all tags from the DB
  instance to snapshots of the DB instance. By default, tags are not copied.
- `"DBInstanceClass"`: The new compute and memory capacity of the instance; for example,
  db.r5.large. Not all instance classes are available in all Amazon Web Services Regions.  If
  you modify the instance class, an outage occurs during the change. The change is applied
  during the next maintenance window, unless ApplyImmediately is specified as true for this
  request.  Default: Uses existing setting.
- `"EnablePerformanceInsights"`: A value that indicates whether to enable Performance
  Insights for the DB Instance. For more information, see Using Amazon Performance Insights.
- `"NewDBInstanceIdentifier"`:  The new instance identifier for the instance when renaming
  an instance. When you change the instance identifier, an instance reboot occurs immediately
  if you set Apply Immediately to true. It occurs during the next maintenance window if you
  set Apply Immediately to false. This value is stored as a lowercase string.  Constraints:
  Must contain from 1 to 63 letters, numbers, or hyphens.   The first character must be a
  letter.   Cannot end with a hyphen or contain two consecutive hyphens.   Example:
  mydbinstance
- `"PerformanceInsightsKMSKeyId"`: The KMS key identifier for encryption of Performance
  Insights data. The KMS key identifier is the key ARN, key ID, alias ARN, or alias name for
  the KMS key. If you do not specify a value for PerformanceInsightsKMSKeyId, then Amazon
  DocumentDB uses your default KMS key. There is a default KMS key for your Amazon Web
  Services account. Your Amazon Web Services account has a different default KMS key for each
  Amazon Web Services region.
- `"PreferredMaintenanceWindow"`: The weekly time range (in UTC) during which system
  maintenance can occur, which might result in an outage. Changing this parameter doesn't
  result in an outage except in the following situation, and the change is asynchronously
  applied as soon as possible. If there are pending actions that cause a reboot, and the
  maintenance window is changed to include the current time, changing this parameter causes a
  reboot of the instance. If you are moving this window to the current time, there must be at
  least 30 minutes between the current time and end of the window to ensure that pending
  changes are applied. Default: Uses existing setting. Format: ddd:hh24:mi-ddd:hh24:mi  Valid
  days: Mon, Tue, Wed, Thu, Fri, Sat, Sun Constraints: Must be at least 30 minutes.
- `"PromotionTier"`: A value that specifies the order in which an Amazon DocumentDB replica
  is promoted to the primary instance after a failure of the existing primary instance.
  Default: 1 Valid values: 0-15
"""
function modify_dbinstance(
    DBInstanceIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return docdb(
        "ModifyDBInstance",
        Dict{String,Any}("DBInstanceIdentifier" => DBInstanceIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function modify_dbinstance(
    DBInstanceIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb(
        "ModifyDBInstance",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DBInstanceIdentifier" => DBInstanceIdentifier),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    modify_dbsubnet_group(dbsubnet_group_name, subnet_identifier)
    modify_dbsubnet_group(dbsubnet_group_name, subnet_identifier, params::Dict{String,<:Any})

Modifies an existing subnet group. subnet groups must contain at least one subnet in at
least two Availability Zones in the Amazon Web Services Region.

# Arguments
- `dbsubnet_group_name`: The name for the subnet group. This value is stored as a lowercase
  string. You can't modify the default subnet group.  Constraints: Must match the name of an
  existing DBSubnetGroup. Must not be default. Example: mySubnetgroup
- `subnet_identifier`: The Amazon EC2 subnet IDs for the subnet group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DBSubnetGroupDescription"`: The description for the subnet group.
- `"SubnetIds"`: The Amazon EC2 subnet IDs for the subnet group.
"""
function modify_dbsubnet_group(
    DBSubnetGroupName, SubnetIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return docdb(
        "ModifyDBSubnetGroup",
        Dict{String,Any}(
            "DBSubnetGroupName" => DBSubnetGroupName, "SubnetIdentifier" => SubnetIdentifier
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function modify_dbsubnet_group(
    DBSubnetGroupName,
    SubnetIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb(
        "ModifyDBSubnetGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DBSubnetGroupName" => DBSubnetGroupName,
                    "SubnetIdentifier" => SubnetIdentifier,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    modify_event_subscription(subscription_name)
    modify_event_subscription(subscription_name, params::Dict{String,<:Any})

Modifies an existing Amazon DocumentDB event notification subscription.

# Arguments
- `subscription_name`: The name of the Amazon DocumentDB event notification subscription.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Enabled"`:  A Boolean value; set to true to activate the subscription.
- `"EventCategories"`:  A list of event categories for a SourceType that you want to
  subscribe to.
- `"SnsTopicArn"`: The Amazon Resource Name (ARN) of the SNS topic created for event
  notification. The ARN is created by Amazon SNS when you create a topic and subscribe to it.
- `"SourceType"`: The type of source that is generating the events. For example, if you
  want to be notified of events generated by an instance, set this parameter to db-instance.
  If this value is not specified, all events are returned. Valid values: db-instance,
  db-parameter-group, db-security-group
"""
function modify_event_subscription(
    SubscriptionName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return docdb(
        "ModifyEventSubscription",
        Dict{String,Any}("SubscriptionName" => SubscriptionName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function modify_event_subscription(
    SubscriptionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb(
        "ModifyEventSubscription",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("SubscriptionName" => SubscriptionName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    modify_global_cluster(global_cluster_identifier)
    modify_global_cluster(global_cluster_identifier, params::Dict{String,<:Any})

Modify a setting for an Amazon DocumentDB global cluster. You can change one or more
configuration parameters (for example: deletion protection), or the global cluster
identifier by specifying these parameters and the new values in the request.  This action
only applies to Amazon DocumentDB clusters.

# Arguments
- `global_cluster_identifier`: The identifier for the global cluster being modified. This
  parameter isn't case-sensitive. Constraints:   Must match the identifier of an existing
  global cluster.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DeletionProtection"`: Indicates if the global cluster has deletion protection enabled.
  The global cluster can't be deleted when deletion protection is enabled.
- `"NewGlobalClusterIdentifier"`: The new identifier for a global cluster when you modify a
  global cluster. This value is stored as a lowercase string.   Must contain from 1 to 63
  letters, numbers, or hyphens The first character must be a letter Can't end with a hyphen
  or contain two consecutive hyphens   Example: my-cluster2
"""
function modify_global_cluster(
    GlobalClusterIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return docdb(
        "ModifyGlobalCluster",
        Dict{String,Any}("GlobalClusterIdentifier" => GlobalClusterIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function modify_global_cluster(
    GlobalClusterIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb(
        "ModifyGlobalCluster",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("GlobalClusterIdentifier" => GlobalClusterIdentifier),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    reboot_dbinstance(dbinstance_identifier)
    reboot_dbinstance(dbinstance_identifier, params::Dict{String,<:Any})

You might need to reboot your instance, usually for maintenance reasons. For example, if
you make certain changes, or if you change the cluster parameter group that is associated
with the instance, you must reboot the instance for the changes to take effect.  Rebooting
an instance restarts the database engine service. Rebooting an instance results in a
momentary outage, during which the instance status is set to rebooting.

# Arguments
- `dbinstance_identifier`: The instance identifier. This parameter is stored as a lowercase
  string. Constraints:   Must match the identifier of an existing DBInstance.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ForceFailover"`:  When true, the reboot is conducted through a Multi-AZ failover.
  Constraint: You can't specify true if the instance is not configured for Multi-AZ.
"""
function reboot_dbinstance(
    DBInstanceIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return docdb(
        "RebootDBInstance",
        Dict{String,Any}("DBInstanceIdentifier" => DBInstanceIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function reboot_dbinstance(
    DBInstanceIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb(
        "RebootDBInstance",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DBInstanceIdentifier" => DBInstanceIdentifier),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_from_global_cluster(db_cluster_identifier, global_cluster_identifier)
    remove_from_global_cluster(db_cluster_identifier, global_cluster_identifier, params::Dict{String,<:Any})

Detaches an Amazon DocumentDB secondary cluster from a global cluster. The cluster becomes
a standalone cluster with read-write capability instead of being read-only and receiving
data from a primary in a different region.   This action only applies to Amazon DocumentDB
clusters.

# Arguments
- `db_cluster_identifier`: The Amazon Resource Name (ARN) identifying the cluster that was
  detached from the Amazon DocumentDB global cluster.
- `global_cluster_identifier`: The cluster identifier to detach from the Amazon DocumentDB
  global cluster.

"""
function remove_from_global_cluster(
    DbClusterIdentifier,
    GlobalClusterIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb(
        "RemoveFromGlobalCluster",
        Dict{String,Any}(
            "DbClusterIdentifier" => DbClusterIdentifier,
            "GlobalClusterIdentifier" => GlobalClusterIdentifier,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_from_global_cluster(
    DbClusterIdentifier,
    GlobalClusterIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb(
        "RemoveFromGlobalCluster",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DbClusterIdentifier" => DbClusterIdentifier,
                    "GlobalClusterIdentifier" => GlobalClusterIdentifier,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_source_identifier_from_subscription(source_identifier, subscription_name)
    remove_source_identifier_from_subscription(source_identifier, subscription_name, params::Dict{String,<:Any})

Removes a source identifier from an existing Amazon DocumentDB event notification
subscription.

# Arguments
- `source_identifier`:  The source identifier to be removed from the subscription, such as
  the instance identifier for an instance, or the name of a security group.
- `subscription_name`: The name of the Amazon DocumentDB event notification subscription
  that you want to remove a source identifier from.

"""
function remove_source_identifier_from_subscription(
    SourceIdentifier, SubscriptionName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return docdb(
        "RemoveSourceIdentifierFromSubscription",
        Dict{String,Any}(
            "SourceIdentifier" => SourceIdentifier, "SubscriptionName" => SubscriptionName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_source_identifier_from_subscription(
    SourceIdentifier,
    SubscriptionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb(
        "RemoveSourceIdentifierFromSubscription",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "SourceIdentifier" => SourceIdentifier,
                    "SubscriptionName" => SubscriptionName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_tags_from_resource(resource_name, tag_keys)
    remove_tags_from_resource(resource_name, tag_keys, params::Dict{String,<:Any})

Removes metadata tags from an Amazon DocumentDB resource.

# Arguments
- `resource_name`: The Amazon DocumentDB resource that the tags are removed from. This
  value is an Amazon Resource Name (ARN).
- `tag_keys`: The tag key (name) of the tag to be removed.

"""
function remove_tags_from_resource(
    ResourceName, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return docdb(
        "RemoveTagsFromResource",
        Dict{String,Any}("ResourceName" => ResourceName, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_tags_from_resource(
    ResourceName,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb(
        "RemoveTagsFromResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceName" => ResourceName, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    reset_dbcluster_parameter_group(dbcluster_parameter_group_name)
    reset_dbcluster_parameter_group(dbcluster_parameter_group_name, params::Dict{String,<:Any})

 Modifies the parameters of a cluster parameter group to the default value. To reset
specific parameters, submit a list of the following: ParameterName and ApplyMethod. To
reset the entire cluster parameter group, specify the DBClusterParameterGroupName and
ResetAllParameters parameters.   When you reset the entire group, dynamic parameters are
updated immediately and static parameters are set to pending-reboot to take effect on the
next DB instance reboot.

# Arguments
- `dbcluster_parameter_group_name`: The name of the cluster parameter group to reset.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Parameters"`: A list of parameter names in the cluster parameter group to reset to the
  default values. You can't use this parameter if the ResetAllParameters parameter is set to
  true.
- `"ResetAllParameters"`: A value that is set to true to reset all parameters in the
  cluster parameter group to their default values, and false otherwise. You can't use this
  parameter if there is a list of parameter names specified for the Parameters parameter.
"""
function reset_dbcluster_parameter_group(
    DBClusterParameterGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return docdb(
        "ResetDBClusterParameterGroup",
        Dict{String,Any}("DBClusterParameterGroupName" => DBClusterParameterGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function reset_dbcluster_parameter_group(
    DBClusterParameterGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb(
        "ResetDBClusterParameterGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DBClusterParameterGroupName" => DBClusterParameterGroupName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    restore_dbcluster_from_snapshot(dbcluster_identifier, engine, snapshot_identifier)
    restore_dbcluster_from_snapshot(dbcluster_identifier, engine, snapshot_identifier, params::Dict{String,<:Any})

Creates a new cluster from a snapshot or cluster snapshot. If a snapshot is specified, the
target cluster is created from the source DB snapshot with a default configuration and
default security group. If a cluster snapshot is specified, the target cluster is created
from the source cluster restore point with the same configuration as the original source DB
cluster, except that the new cluster is created with the default security group.

# Arguments
- `dbcluster_identifier`: The name of the cluster to create from the snapshot or cluster
  snapshot. This parameter isn't case sensitive. Constraints:   Must contain from 1 to 63
  letters, numbers, or hyphens.   The first character must be a letter.   Cannot end with a
  hyphen or contain two consecutive hyphens.   Example: my-snapshot-id
- `engine`: The database engine to use for the new cluster. Default: The same as source.
  Constraint: Must be compatible with the engine of the source.
- `snapshot_identifier`: The identifier for the snapshot or cluster snapshot to restore
  from. You can use either the name or the Amazon Resource Name (ARN) to specify a cluster
  snapshot. However, you can use only the ARN to specify a snapshot. Constraints:   Must
  match the identifier of an existing snapshot.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AvailabilityZones"`: Provides the list of Amazon EC2 Availability Zones that instances
  in the restored DB cluster can be created in.
- `"DBClusterParameterGroupName"`: The name of the DB cluster parameter group to associate
  with this DB cluster.  Type: String.       Required: No. If this argument is omitted,
  the default DB cluster parameter group is used. If supplied, must match the name of an
  existing default DB cluster parameter group. The string must consist of from 1 to 255
  letters, numbers or hyphens. Its first character must be a letter, and it cannot end with a
  hyphen or contain two consecutive hyphens.
- `"DBSubnetGroupName"`: The name of the subnet group to use for the new cluster.
  Constraints: If provided, must match the name of an existing DBSubnetGroup. Example:
  mySubnetgroup
- `"DeletionProtection"`: Specifies whether this cluster can be deleted. If
  DeletionProtection is enabled, the cluster cannot be deleted unless it is modified and
  DeletionProtection is disabled. DeletionProtection protects clusters from being
  accidentally deleted.
- `"EnableCloudwatchLogsExports"`: A list of log types that must be enabled for exporting
  to Amazon CloudWatch Logs.
- `"EngineVersion"`: The version of the database engine to use for the new cluster.
- `"KmsKeyId"`: The KMS key identifier to use when restoring an encrypted cluster from a DB
  snapshot or cluster snapshot. The KMS key identifier is the Amazon Resource Name (ARN) for
  the KMS encryption key. If you are restoring a cluster with the same Amazon Web Services
  account that owns the KMS encryption key used to encrypt the new cluster, then you can use
  the KMS key alias instead of the ARN for the KMS encryption key. If you do not specify a
  value for the KmsKeyId parameter, then the following occurs:   If the snapshot or cluster
  snapshot in SnapshotIdentifier is encrypted, then the restored cluster is encrypted using
  the KMS key that was used to encrypt the snapshot or the cluster snapshot.   If the
  snapshot or the cluster snapshot in SnapshotIdentifier is not encrypted, then the restored
  DB cluster is not encrypted.
- `"Port"`: The port number on which the new cluster accepts connections. Constraints: Must
  be a value from 1150 to 65535. Default: The same port as the original cluster.
- `"StorageType"`: The storage type to associate with the DB cluster. For information on
  storage types for Amazon DocumentDB clusters, see Cluster storage configurations in the
  Amazon DocumentDB Developer Guide. Valid values for storage type - standard | iopt1
  Default value is standard
- `"Tags"`: The tags to be assigned to the restored cluster.
- `"VpcSecurityGroupIds"`: A list of virtual private cloud (VPC) security groups that the
  new cluster will belong to.
"""
function restore_dbcluster_from_snapshot(
    DBClusterIdentifier,
    Engine,
    SnapshotIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb(
        "RestoreDBClusterFromSnapshot",
        Dict{String,Any}(
            "DBClusterIdentifier" => DBClusterIdentifier,
            "Engine" => Engine,
            "SnapshotIdentifier" => SnapshotIdentifier,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function restore_dbcluster_from_snapshot(
    DBClusterIdentifier,
    Engine,
    SnapshotIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb(
        "RestoreDBClusterFromSnapshot",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DBClusterIdentifier" => DBClusterIdentifier,
                    "Engine" => Engine,
                    "SnapshotIdentifier" => SnapshotIdentifier,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    restore_dbcluster_to_point_in_time(dbcluster_identifier, source_dbcluster_identifier)
    restore_dbcluster_to_point_in_time(dbcluster_identifier, source_dbcluster_identifier, params::Dict{String,<:Any})

Restores a cluster to an arbitrary point in time. Users can restore to any point in time
before LatestRestorableTime for up to BackupRetentionPeriod days. The target cluster is
created from the source cluster with the same configuration as the original cluster, except
that the new cluster is created with the default security group.

# Arguments
- `dbcluster_identifier`: The name of the new cluster to be created. Constraints:   Must
  contain from 1 to 63 letters, numbers, or hyphens.   The first character must be a letter.
   Cannot end with a hyphen or contain two consecutive hyphens.
- `source_dbcluster_identifier`: The identifier of the source cluster from which to
  restore. Constraints:   Must match the identifier of an existing DBCluster.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DBSubnetGroupName"`: The subnet group name to use for the new cluster. Constraints: If
  provided, must match the name of an existing DBSubnetGroup. Example: mySubnetgroup
- `"DeletionProtection"`: Specifies whether this cluster can be deleted. If
  DeletionProtection is enabled, the cluster cannot be deleted unless it is modified and
  DeletionProtection is disabled. DeletionProtection protects clusters from being
  accidentally deleted.
- `"EnableCloudwatchLogsExports"`: A list of log types that must be enabled for exporting
  to Amazon CloudWatch Logs.
- `"KmsKeyId"`: The KMS key identifier to use when restoring an encrypted cluster from an
  encrypted cluster. The KMS key identifier is the Amazon Resource Name (ARN) for the KMS
  encryption key. If you are restoring a cluster with the same Amazon Web Services account
  that owns the KMS encryption key used to encrypt the new cluster, then you can use the KMS
  key alias instead of the ARN for the KMS encryption key. You can restore to a new cluster
  and encrypt the new cluster with an KMS key that is different from the KMS key used to
  encrypt the source cluster. The new DB cluster is encrypted with the KMS key identified by
  the KmsKeyId parameter. If you do not specify a value for the KmsKeyId parameter, then the
  following occurs:   If the cluster is encrypted, then the restored cluster is encrypted
  using the KMS key that was used to encrypt the source cluster.   If the cluster is not
  encrypted, then the restored cluster is not encrypted.   If DBClusterIdentifier refers to a
  cluster that is not encrypted, then the restore request is rejected.
- `"Port"`: The port number on which the new cluster accepts connections. Constraints: Must
  be a value from 1150 to 65535.  Default: The default port for the engine.
- `"RestoreToTime"`: The date and time to restore the cluster to. Valid values: A time in
  Universal Coordinated Time (UTC) format. Constraints:   Must be before the latest
  restorable time for the instance.   Must be specified if the UseLatestRestorableTime
  parameter is not provided.   Cannot be specified if the UseLatestRestorableTime parameter
  is true.   Cannot be specified if the RestoreType parameter is copy-on-write.   Example:
  2015-03-07T23:45:00Z
- `"RestoreType"`: The type of restore to be performed. You can specify one of the
  following values:    full-copy - The new DB cluster is restored as a full copy of the
  source DB cluster.    copy-on-write - The new DB cluster is restored as a clone of the
  source DB cluster.   Constraints: You can't specify copy-on-write if the engine version of
  the source DB cluster is earlier than 1.11. If you don't specify a RestoreType value, then
  the new DB cluster is restored as a full copy of the source DB cluster.
- `"StorageType"`: The storage type to associate with the DB cluster. For information on
  storage types for Amazon DocumentDB clusters, see Cluster storage configurations in the
  Amazon DocumentDB Developer Guide. Valid values for storage type - standard | iopt1
  Default value is standard
- `"Tags"`: The tags to be assigned to the restored cluster.
- `"UseLatestRestorableTime"`: A value that is set to true to restore the cluster to the
  latest restorable backup time, and false otherwise.  Default: false  Constraints: Cannot be
  specified if the RestoreToTime parameter is provided.
- `"VpcSecurityGroupIds"`: A list of VPC security groups that the new cluster belongs to.
"""
function restore_dbcluster_to_point_in_time(
    DBClusterIdentifier,
    SourceDBClusterIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb(
        "RestoreDBClusterToPointInTime",
        Dict{String,Any}(
            "DBClusterIdentifier" => DBClusterIdentifier,
            "SourceDBClusterIdentifier" => SourceDBClusterIdentifier,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function restore_dbcluster_to_point_in_time(
    DBClusterIdentifier,
    SourceDBClusterIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb(
        "RestoreDBClusterToPointInTime",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DBClusterIdentifier" => DBClusterIdentifier,
                    "SourceDBClusterIdentifier" => SourceDBClusterIdentifier,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_dbcluster(dbcluster_identifier)
    start_dbcluster(dbcluster_identifier, params::Dict{String,<:Any})

Restarts the stopped cluster that is specified by DBClusterIdentifier. For more
information, see Stopping and Starting an Amazon DocumentDB Cluster.

# Arguments
- `dbcluster_identifier`: The identifier of the cluster to restart. Example:
  docdb-2019-05-28-15-24-52

"""
function start_dbcluster(
    DBClusterIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return docdb(
        "StartDBCluster",
        Dict{String,Any}("DBClusterIdentifier" => DBClusterIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_dbcluster(
    DBClusterIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb(
        "StartDBCluster",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DBClusterIdentifier" => DBClusterIdentifier),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_dbcluster(dbcluster_identifier)
    stop_dbcluster(dbcluster_identifier, params::Dict{String,<:Any})

Stops the running cluster that is specified by DBClusterIdentifier. The cluster must be in
the available state. For more information, see Stopping and Starting an Amazon DocumentDB
Cluster.

# Arguments
- `dbcluster_identifier`: The identifier of the cluster to stop. Example:
  docdb-2019-05-28-15-24-52

"""
function stop_dbcluster(
    DBClusterIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return docdb(
        "StopDBCluster",
        Dict{String,Any}("DBClusterIdentifier" => DBClusterIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_dbcluster(
    DBClusterIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb(
        "StopDBCluster",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DBClusterIdentifier" => DBClusterIdentifier),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    switchover_global_cluster(global_cluster_identifier, target_db_cluster_identifier)
    switchover_global_cluster(global_cluster_identifier, target_db_cluster_identifier, params::Dict{String,<:Any})

Switches over the specified secondary Amazon DocumentDB cluster to be the new primary
Amazon DocumentDB cluster in the global database cluster.

# Arguments
- `global_cluster_identifier`: The identifier of the Amazon DocumentDB global database
  cluster to switch over. The identifier is the unique key assigned by the user when the
  cluster is created. In other words, it's the name of the global cluster. This parameter
  isn’t case-sensitive. Constraints:   Must match the identifier of an existing global
  cluster (Amazon DocumentDB global database).   Minimum length of 1. Maximum length of 255.
   Pattern: [A-Za-z][0-9A-Za-z-:._]*
- `target_db_cluster_identifier`: The identifier of the secondary Amazon DocumentDB cluster
  to promote to the new primary for the global database cluster. Use the Amazon Resource Name
  (ARN) for the identifier so that Amazon DocumentDB can locate the cluster in its Amazon Web
  Services region. Constraints:   Must match the identifier of an existing secondary cluster.
    Minimum length of 1. Maximum length of 255.   Pattern: [A-Za-z][0-9A-Za-z-:._]*

"""
function switchover_global_cluster(
    GlobalClusterIdentifier,
    TargetDbClusterIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb(
        "SwitchoverGlobalCluster",
        Dict{String,Any}(
            "GlobalClusterIdentifier" => GlobalClusterIdentifier,
            "TargetDbClusterIdentifier" => TargetDbClusterIdentifier,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function switchover_global_cluster(
    GlobalClusterIdentifier,
    TargetDbClusterIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return docdb(
        "SwitchoverGlobalCluster",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "GlobalClusterIdentifier" => GlobalClusterIdentifier,
                    "TargetDbClusterIdentifier" => TargetDbClusterIdentifier,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: simpledb
using AWS.Compat
using AWS.UUIDs

"""
    batch_delete_attributes(domain_name, item)
    batch_delete_attributes(domain_name, item, params::Dict{String,<:Any})

 Performs multiple DeleteAttributes operations in a single call, which reduces round trips
and latencies. This enables Amazon SimpleDB to optimize requests, which generally yields
better throughput.    If you specify BatchDeleteAttributes without attributes or values,
all the attributes for the item are deleted.   BatchDeleteAttributes is an idempotent
operation; running it multiple times on the same item or attribute doesn't result in an
error.   The BatchDeleteAttributes operation succeeds or fails in its entirety. There are
no partial deletes. You can execute multiple BatchDeleteAttributes operations and other
operations in parallel. However, large numbers of concurrent BatchDeleteAttributes calls
can result in Service Unavailable (503) responses.   This operation is vulnerable to
exceeding the maximum URL size when making a REST request using the HTTP GET method.   This
operation does not support conditions using Expected.X.Name, Expected.X.Value, or
Expected.X.Exists.    The following limitations are enforced for this operation:  1 MB
request size 25 item limit per BatchDeleteAttributes operation

# Arguments
- `domain_name`: The name of the domain in which the attributes are being deleted.
- `item`: A list of items on which to perform the operation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Items"`: A list of items on which to perform the operation.
"""
function batch_delete_attributes(
    DomainName, Item; aws_config::AbstractAWSConfig=current_aws_config()
)
    return simpledb(
        "BatchDeleteAttributes",
        Dict{String,Any}("DomainName" => DomainName, "Item" => Item);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_delete_attributes(
    DomainName,
    Item,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return simpledb(
        "BatchDeleteAttributes",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("DomainName" => DomainName, "Item" => Item), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_put_attributes(domain_name, item)
    batch_put_attributes(domain_name, item, params::Dict{String,<:Any})

 The BatchPutAttributes operation creates or replaces attributes within one or more items.
By using this operation, the client can perform multiple PutAttribute operation with a
single call. This helps yield savings in round trips and latencies, enabling Amazon
SimpleDB to optimize requests and generally produce better throughput.   The client may
specify the item name with the Item.X.ItemName parameter. The client may specify new
attributes using a combination of the Item.X.Attribute.Y.Name and Item.X.Attribute.Y.Value
parameters. The client may specify the first attribute for the first item using the
parameters Item.0.Attribute.0.Name and Item.0.Attribute.0.Value, and for the second
attribute for the first item by the parameters Item.0.Attribute.1.Name and
Item.0.Attribute.1.Value, and so on.   Attributes are uniquely identified within an item by
their name/value combination. For example, a single item can have the attributes {
\"first_name\", \"first_value\" } and { \"first_name\", \"second_value\" }. However, it
cannot have two attribute instances where both the Item.X.Attribute.Y.Name and
Item.X.Attribute.Y.Value are the same.   Optionally, the requester can supply the Replace
parameter for each individual value. Setting this value to true will cause the new
attribute values to replace the existing attribute values. For example, if an item I has
the attributes { 'a', '1' }, { 'b', '2'} and { 'b', '3' } and the requester does a
BatchPutAttributes of {'I', 'b', '4' } with the Replace parameter set to true, the final
attributes of the item will be { 'a', '1' } and { 'b', '4' }, replacing the previous values
of the 'b' attribute with the new value.   You cannot specify an empty string as an item or
as an attribute name. The BatchPutAttributes operation succeeds or fails in its entirety.
There are no partial puts.   This operation is vulnerable to exceeding the maximum URL size
when making a REST request using the HTTP GET method. This operation does not support
conditions using Expected.X.Name, Expected.X.Value, or Expected.X.Exists.   You can execute
multiple BatchPutAttributes operations and other operations in parallel. However, large
numbers of concurrent BatchPutAttributes calls can result in Service Unavailable (503)
responses.   The following limitations are enforced for this operation:  256 attribute
name-value pairs per item 1 MB request size 1 billion attributes per domain 10 GB of total
user data storage per domain 25 item limit per BatchPutAttributes operation

# Arguments
- `domain_name`: The name of the domain in which the attributes are being stored.
- `item`: A list of items on which to perform the operation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Items"`: A list of items on which to perform the operation.
"""
function batch_put_attributes(
    DomainName, Item; aws_config::AbstractAWSConfig=current_aws_config()
)
    return simpledb(
        "BatchPutAttributes",
        Dict{String,Any}("DomainName" => DomainName, "Item" => Item);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_put_attributes(
    DomainName,
    Item,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return simpledb(
        "BatchPutAttributes",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("DomainName" => DomainName, "Item" => Item), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_domain(domain_name)
    create_domain(domain_name, params::Dict{String,<:Any})

 The CreateDomain operation creates a new domain. The domain name should be unique among
the domains associated with the Access Key ID provided in the request. The CreateDomain
operation may take 10 or more seconds to complete.   CreateDomain is an idempotent
operation; running it multiple times using the same domain name will not result in an error
response.   The client can create up to 100 domains per account.   If the client requires
additional domains, go to  http://aws.amazon.com/contact-us/simpledb-limit-request/.

# Arguments
- `domain_name`: The name of the domain to create. The name can range between 3 and 255
  characters and can contain the following characters: a-z, A-Z, 0-9, '_', '-', and '.'.

"""
function create_domain(DomainName; aws_config::AbstractAWSConfig=current_aws_config())
    return simpledb(
        "CreateDomain",
        Dict{String,Any}("DomainName" => DomainName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_domain(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return simpledb(
        "CreateDomain",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DomainName" => DomainName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_attributes(domain_name, item_name)
    delete_attributes(domain_name, item_name, params::Dict{String,<:Any})

 Deletes one or more attributes associated with an item. If all attributes of the item are
deleted, the item is deleted.   If DeleteAttributes is called without being passed any
attributes or values specified, all the attributes for the item are deleted.
DeleteAttributes is an idempotent operation; running it multiple times on the same item or
attribute does not result in an error response.   Because Amazon SimpleDB makes multiple
copies of item data and uses an eventual consistency update model, performing a
GetAttributes or Select operation (read) immediately after a DeleteAttributes or
PutAttributes operation (write) might not return updated item data.

# Arguments
- `domain_name`: The name of the domain in which to perform the operation.
- `item_name`: The name of the item. Similar to rows on a spreadsheet, items represent
  individual objects that contain one or more value-attribute pairs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Attributes"`: A list of Attributes. Similar to columns on a spreadsheet, attributes
  represent categories of data that can be assigned to items.
- `"Expected"`: The update condition which, if specified, determines whether the specified
  attributes will be deleted or not. The update condition must be satisfied in order for this
  request to be processed and the attributes to be deleted.
"""
function delete_attributes(
    DomainName, ItemName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return simpledb(
        "DeleteAttributes",
        Dict{String,Any}("DomainName" => DomainName, "ItemName" => ItemName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_attributes(
    DomainName,
    ItemName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return simpledb(
        "DeleteAttributes",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DomainName" => DomainName, "ItemName" => ItemName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_domain(domain_name)
    delete_domain(domain_name, params::Dict{String,<:Any})

 The DeleteDomain operation deletes a domain. Any items (and their attributes) in the
domain are deleted as well. The DeleteDomain operation might take 10 or more seconds to
complete.   Running DeleteDomain on a domain that does not exist or running the function
multiple times using the same domain name will not result in an error response.

# Arguments
- `domain_name`: The name of the domain to delete.

"""
function delete_domain(DomainName; aws_config::AbstractAWSConfig=current_aws_config())
    return simpledb(
        "DeleteDomain",
        Dict{String,Any}("DomainName" => DomainName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_domain(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return simpledb(
        "DeleteDomain",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DomainName" => DomainName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    domain_metadata(domain_name)
    domain_metadata(domain_name, params::Dict{String,<:Any})

 Returns information about the domain, including when the domain was created, the number of
items and attributes in the domain, and the size of the attribute names and values.

# Arguments
- `domain_name`: The name of the domain for which to display the metadata of.

"""
function domain_metadata(DomainName; aws_config::AbstractAWSConfig=current_aws_config())
    return simpledb(
        "DomainMetadata",
        Dict{String,Any}("DomainName" => DomainName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function domain_metadata(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return simpledb(
        "DomainMetadata",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DomainName" => DomainName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_attributes(domain_name, item_name)
    get_attributes(domain_name, item_name, params::Dict{String,<:Any})

 Returns all of the attributes associated with the specified item. Optionally, the
attributes returned can be limited to one or more attributes by specifying an attribute
name parameter.   If the item does not exist on the replica that was accessed for this
operation, an empty set is returned. The system does not return an error as it cannot
guarantee the item does not exist on other replicas.   If GetAttributes is called without
being passed any attribute names, all the attributes for the item are returned.

# Arguments
- `domain_name`: The name of the domain in which to perform the operation.
- `item_name`: The name of the item.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AttributeNames"`: The names of the attributes.
- `"ConsistentRead"`: Determines whether or not strong consistency should be enforced when
  data is read from SimpleDB. If true, any data previously written to SimpleDB will be
  returned. Otherwise, results will be consistent eventually, and the client may not see data
  that was written immediately before your read.
"""
function get_attributes(
    DomainName, ItemName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return simpledb(
        "GetAttributes",
        Dict{String,Any}("DomainName" => DomainName, "ItemName" => ItemName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_attributes(
    DomainName,
    ItemName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return simpledb(
        "GetAttributes",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DomainName" => DomainName, "ItemName" => ItemName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_domains()
    list_domains(params::Dict{String,<:Any})

 The ListDomains operation lists all domains associated with the Access Key ID. It returns
domain names up to the limit set by MaxNumberOfDomains. A NextToken is returned if there
are more than MaxNumberOfDomains domains. Calling ListDomains successive times with the
NextToken provided by the operation returns up to MaxNumberOfDomains more domain names with
each successive operation call.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxNumberOfDomains"`: The maximum number of domain names you want returned. The range
  is 1 to 100. The default setting is 100.
- `"NextToken"`: A string informing Amazon SimpleDB where to start the next list of domain
  names.
"""
function list_domains(; aws_config::AbstractAWSConfig=current_aws_config())
    return simpledb("ListDomains"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_domains(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return simpledb(
        "ListDomains", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    put_attributes(attribute, domain_name, item_name)
    put_attributes(attribute, domain_name, item_name, params::Dict{String,<:Any})

 The PutAttributes operation creates or replaces attributes in an item. The client may
specify new attributes using a combination of the Attribute.X.Name and Attribute.X.Value
parameters. The client specifies the first attribute by the parameters Attribute.0.Name and
Attribute.0.Value, the second attribute by the parameters Attribute.1.Name and
Attribute.1.Value, and so on.   Attributes are uniquely identified in an item by their
name/value combination. For example, a single item can have the attributes {
\"first_name\", \"first_value\" } and { \"first_name\", second_value\" }. However, it
cannot have two attribute instances where both the Attribute.X.Name and Attribute.X.Value
are the same.   Optionally, the requestor can supply the Replace parameter for each
individual attribute. Setting this value to true causes the new attribute value to replace
the existing attribute value(s). For example, if an item has the attributes { 'a', '1' }, {
'b', '2'} and { 'b', '3' } and the requestor calls PutAttributes using the attributes {
'b', '4' } with the Replace parameter set to true, the final attributes of the item are
changed to { 'a', '1' } and { 'b', '4' }, which replaces the previous values of the 'b'
attribute with the new value.   Using PutAttributes to replace attribute values that do not
exist will not result in an error response.   You cannot specify an empty string as an
attribute name.   Because Amazon SimpleDB makes multiple copies of client data and uses an
eventual consistency update model, an immediate GetAttributes or Select operation (read)
immediately after a PutAttributes or DeleteAttributes operation (write) might not return
the updated data.   The following limitations are enforced for this operation:  256 total
attribute name-value pairs per item One billion attributes per domain 10 GB of total user
data storage per domain

# Arguments
- `attribute`: The list of attributes.
- `domain_name`: The name of the domain in which to perform the operation.
- `item_name`: The name of the item.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Attributes"`: The list of attributes.
- `"Expected"`: The update condition which, if specified, determines whether the specified
  attributes will be updated or not. The update condition must be satisfied in order for this
  request to be processed and the attributes to be updated.
"""
function put_attributes(
    Attribute, DomainName, ItemName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return simpledb(
        "PutAttributes",
        Dict{String,Any}(
            "Attribute" => Attribute, "DomainName" => DomainName, "ItemName" => ItemName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_attributes(
    Attribute,
    DomainName,
    ItemName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return simpledb(
        "PutAttributes",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Attribute" => Attribute,
                    "DomainName" => DomainName,
                    "ItemName" => ItemName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    select(select_expression)
    select(select_expression, params::Dict{String,<:Any})

 The Select operation returns a set of attributes for ItemNames that match the select
expression. Select is similar to the standard SQL SELECT statement.   The total size of the
response cannot exceed 1 MB in total size. Amazon SimpleDB automatically adjusts the number
of items returned per page to enforce this limit. For example, if the client asks to
retrieve 2500 items, but each individual item is 10 kB in size, the system returns 100
items and an appropriate NextToken so the client can access the next page of results.   For
information on how to construct select expressions, see Using Select to Create Amazon
SimpleDB Queries in the Developer Guide.

# Arguments
- `select_expression`: The expression used to query the domain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConsistentRead"`: Determines whether or not strong consistency should be enforced when
  data is read from SimpleDB. If true, any data previously written to SimpleDB will be
  returned. Otherwise, results will be consistent eventually, and the client may not see data
  that was written immediately before your read.
- `"NextToken"`: A string informing Amazon SimpleDB where to start the next list of
  ItemNames.
"""
function select(SelectExpression; aws_config::AbstractAWSConfig=current_aws_config())
    return simpledb(
        "Select",
        Dict{String,Any}("SelectExpression" => SelectExpression);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function select(
    SelectExpression,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return simpledb(
        "Select",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("SelectExpression" => SelectExpression), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

module Patches

using AWS
using Dates
using Downloads: Downloads
using HTTP
using JSON
using GitHub
using Mocking
using OrderedCollections: LittleDict
using ...Main: http_header

version = v"1.1.0"
status = 200
headers = Pair[
    "x-amz-id-2" => "x-amz-id-2",
    "x-amz-request-id" => "x-amz-request-id",
    "Date" => "Tue, 16 Jun 2020 21:29:18 GMT",
    "x-amz-bucket-region" => "us-east-1",
    "Content-Type" => "application/xml",
    "Transfer-Encoding" => "chunked",
    "Server" => "AmazonS3",
]

body = """
    <?xml version=\"1.0\" encoding=\"UTF-8\"?>\n
    <ListBucketResult xmlns=\"http://s3.amazonaws.com/doc/2006-03-01/\">
        <Name>sample-bucket</Name>
        <Prefix></Prefix>
        <Marker></Marker>
        <MaxKeys>1000</MaxKeys>
        <IsTruncated>false</IsTruncated>
        <Contents>
            <Key>test.txt</Key>
            <LastModified>2020-06-16T21:37:34.000Z</LastModified>
            <ETag>&quot;d41d8cd98f00b204e9800998ecf8427e&quot;</ETag>
            <Size>0</Size>
            <Owner>
                <ID>id</ID>
                <DisplayName>matt.brzezinski</DisplayName>
            </Owner>
            <StorageClass>STANDARD</StorageClass>
        </Contents>
    </ListBucketResult>
    """

function _response(;
    version::VersionNumber=version,
    status::Int64=status,
    headers::Array=headers,
    body::String=body,
)
    response = HTTP.Messages.Response()

    response.version = version
    response.status = status
    response.headers = headers
    response.body = b"[Message Body was streamed]"

    b = IOBuffer(body)

    return AWS.Response(response, b)
end

function _aws_http_request_patch(response::AWS.Response=_response())
    p = @patch AWS._http_request(::AWS.AbstractBackend, request::Request, ::IO) = response
    return p
end

function _throttling_patch(retries::Ref{Int})
    status = 503
    body = """
        <?xml version=\"1.0\" encoding=\"UTF-8\"?>\n
        <Error>
          <Code>SlowDown</Code>
          <Message>Please reduce your request rate</Message>
          <Resource>/mybucket/myfoto.jpg</Resource>
          <RequestId>4442587FB7D0A2F9</RequestId>
        </Error>
        """

    p = @patch function AWS._http_request(::AWS.AbstractBackend, request::Request, ::IO)
        retries[] += 1
        resp = _response(; status=status, body=body).response
        err = HTTP.StatusError(status, request.request_method, request.resource, resp)
        throw(AWS.AWSException(err, body))
    end
    return p
end

_cred_file_patch = @patch function dot_aws_credentials_file()
    return ""
end

_config_file_patch = @patch function dot_aws_config_file()
    return ""
end

_assume_role_patch = function (
    op;
    access_key="access_key",
    secret_key="secret_key",
    session_token="token",
    role_arn="arn:aws:sts:::assumed-role/role-name",
    expiry=duration -> now(UTC) + duration,
    token_code_ref=nothing,
)
    @patch function AWSServices.sts(op, params; aws_config, feature_set)
        duration = Second(parse(Int, get(params, "DurationSeconds", "3600")))
        expiration = expiry(duration)
        if token_code_ref !== nothing
            token_code_ref[] = params["TokenCode"]
        end
        xml = """
            <$(op)Response xmlns="https://sts.amazonaws.com/doc/2011-06-15/">
              <$(op)Result>
                <AssumedRoleUser>
                  <Arn>$(role_arn)/$(params["RoleSessionName"])</Arn>
                </AssumedRoleUser>
                <Credentials>
                  <AccessKeyId>$access_key</AccessKeyId>
                  <SecretAccessKey>$secret_key</SecretAccessKey>
                  <SessionToken>$session_token</SessionToken>
                  <Expiration>$expiration</Expiration>
                </Credentials>
              </$(op)Result>
            </$(op)Response>
            """

        r = _response(; body=xml)
        return feature_set.use_response_type ? r : parse(r)::AbstractDict
    end
end

_getpass_patch = function (; secret="the_secret")
    @patch function Base.getpass(prompt)
        return Base.SecretBuffer(secret)
    end
end

_github_tree_patch = @patch function tree(repo, tree_obj; kwargs...)
    if tree_obj == "master"
        tree = [Dict("path" => "apis", "sha" => "apis-sha")]
        return Tree("test-sha", HTTP.URI(), tree, false)
    else
        tree = [Dict("path" => "test-2020-01-01.normal.json", "sha" => "test-sha")]
        return Tree("test-sha", HTTP.URI(), tree, false)
    end
end

# This patch causes `HTTP.request` to return all of its keyword arguments
# except `require_ssl_verification` and `response_stream`. This is used to
# test which other options are being passed to `HTTP.Request` inside of
# `_http_request`.
_http_options_patches = [
    @patch function HTTP.request(args...; kwargs...)
        options = Dict(kwargs)
        delete!(options, :redirect)
        delete!(options, :retry)
        delete!(options, :response_stream)
        return options
    end
    @patch AWS.Response(options, args...) = options
]

get_profile_settings_empty_patch = @patch function aws_get_profile_settings(profile, ini)
    return nothing
end

get_profile_settings_patch = @patch function aws_get_profile_settings(profile, ini)
    return Dict("foo" => "bar")
end

# Simulate the HTTP.request behaviour with a HTTP 400 response
function gen_http_options_400_patches(message)
    body = "{\"__type\":\"AccessDeniedException\",\"Message\":\"$message\"}"
    headers = [
        "Content-Type" => "application/x-amz-json-1.1",
        "Content-Length" => string(sizeof(body)),
    ]

    return [
        @patch function HTTP.request(
            args...; status_exception=true, response_stream=nothing, kwargs...
        )
            request = HTTP.Request("GET", "/")

            if response_stream !== nothing
                write(response_stream, body)
                close(response_stream)  # Simulating current HTTP.jl 0.9.14 behaviour
                body = IOBuffer()
            end

            response = HTTP.Response(400, headers; body=body, request=request)
            exception = AWS.statuserror(400, response)
            return !status_exception ? response : throw(exception)
        end
        @patch function Downloads.request(args...; output=nothing, kwargs...)
            if output !== nothing
                write(output, body)
            end

            return Downloads.Response(
                "https",
                "https://region.amazonaws.com/",
                400,
                "HTTP/1.1 400 Bad Request",
                headers,
            )
        end
    ]
end

# Pass the session name through which will be stored in the HTTP header:
# "x-amz-sso_bearer_token"
_sso_access_token_patch = @patch function AWS._sso_cache_access_token(session_name)
    return session_name
end

function sso_service_patches(access_key_id, secret_access_key)
    p = @patch function AWSServices.sso(method, uri, args; kwargs...)
        # Use the session token to identify through the type of SSO used.
        return Dict(
            "roleCredentials" => Dict(
                "accessKeyId" => access_key_id,
                "secretAccessKey" => secret_access_key,
                "sessionToken" =>
                    http_header(args["headers"], "x-amz-sso_bearer_token"),
                "expiration" =>
                    floor(Int, Dates.datetime2unix(Dates.now(UTC) + Dates.Hour(1))) * 1000,  # ms
            ),
        )
    end

    return [p, _sso_access_token_patch]
end

function _imds_region_patch(region)
    return @patch IMDS.region() = region
end

end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: rbin
using AWS.Compat
using AWS.UUIDs

"""
    create_rule(resource_type, retention_period)
    create_rule(resource_type, retention_period, params::Dict{String,<:Any})

Creates a Recycle Bin retention rule. For more information, see  Create Recycle Bin
retention rules in the Amazon Elastic Compute Cloud User Guide.

# Arguments
- `resource_type`: The resource type to be retained by the retention rule. Currently, only
  Amazon EBS snapshots and EBS-backed AMIs are supported. To retain snapshots, specify
  EBS_SNAPSHOT. To retain EBS-backed AMIs, specify EC2_IMAGE.
- `retention_period`: Information about the retention period for which the retention rule
  is to retain resources.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: The retention rule description.
- `"LockConfiguration"`: Information about the retention rule lock configuration.
- `"ResourceTags"`: Specifies the resource tags to use to identify resources that are to be
  retained by a tag-level retention rule. For tag-level retention rules, only deleted
  resources, of the specified resource type, that have one or more of the specified tag key
  and value pairs are retained. If a resource is deleted, but it does not have any of the
  specified tag key and value pairs, it is immediately deleted without being retained by the
  retention rule. You can add the same tag key and value pair to a maximum or five retention
  rules. To create a Region-level retention rule, omit this parameter. A Region-level
  retention rule does not have any resource tags specified. It retains all deleted resources
  of the specified resource type in the Region in which the rule is created, even if the
  resources are not tagged.
- `"Tags"`: Information about the tags to assign to the retention rule.
"""
function create_rule(
    ResourceType, RetentionPeriod; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rbin(
        "POST",
        "/rules",
        Dict{String,Any}(
            "ResourceType" => ResourceType, "RetentionPeriod" => RetentionPeriod
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_rule(
    ResourceType,
    RetentionPeriod,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rbin(
        "POST",
        "/rules",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ResourceType" => ResourceType, "RetentionPeriod" => RetentionPeriod
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_rule(identifier)
    delete_rule(identifier, params::Dict{String,<:Any})

Deletes a Recycle Bin retention rule. For more information, see  Delete Recycle Bin
retention rules in the Amazon Elastic Compute Cloud User Guide.

# Arguments
- `identifier`: The unique ID of the retention rule.

"""
function delete_rule(identifier; aws_config::AbstractAWSConfig=current_aws_config())
    return rbin(
        "DELETE",
        "/rules/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_rule(
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rbin(
        "DELETE",
        "/rules/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_rule(identifier)
    get_rule(identifier, params::Dict{String,<:Any})

Gets information about a Recycle Bin retention rule.

# Arguments
- `identifier`: The unique ID of the retention rule.

"""
function get_rule(identifier; aws_config::AbstractAWSConfig=current_aws_config())
    return rbin(
        "GET",
        "/rules/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_rule(
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rbin(
        "GET",
        "/rules/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_rules(resource_type)
    list_rules(resource_type, params::Dict{String,<:Any})

Lists the Recycle Bin retention rules in the Region.

# Arguments
- `resource_type`: The resource type retained by the retention rule. Only retention rules
  that retain the specified resource type are listed. Currently, only Amazon EBS snapshots
  and EBS-backed AMIs are supported. To list retention rules that retain snapshots, specify
  EBS_SNAPSHOT. To list retention rules that retain EBS-backed AMIs, specify EC2_IMAGE.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"LockState"`: The lock state of the retention rules to list. Only retention rules with
  the specified lock state are returned.
- `"MaxResults"`: The maximum number of results to return with a single call. To retrieve
  the remaining results, make another call with the returned NextToken value.
- `"NextToken"`: The token for the next page of results.
- `"ResourceTags"`: Information about the resource tags used to identify resources that are
  retained by the retention rule.
"""
function list_rules(ResourceType; aws_config::AbstractAWSConfig=current_aws_config())
    return rbin(
        "POST",
        "/list-rules",
        Dict{String,Any}("ResourceType" => ResourceType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_rules(
    ResourceType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rbin(
        "POST",
        "/list-rules",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceType" => ResourceType), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists the tags assigned to a retention rule.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the retention rule.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rbin(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rbin(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    lock_rule(lock_configuration, identifier)
    lock_rule(lock_configuration, identifier, params::Dict{String,<:Any})

Locks a retention rule. A locked retention rule can't be modified or deleted.

# Arguments
- `lock_configuration`: Information about the retention rule lock configuration.
- `identifier`: The unique ID of the retention rule.

"""
function lock_rule(
    LockConfiguration, identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rbin(
        "PATCH",
        "/rules/$(identifier)/lock",
        Dict{String,Any}("LockConfiguration" => LockConfiguration);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function lock_rule(
    LockConfiguration,
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rbin(
        "PATCH",
        "/rules/$(identifier)/lock",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("LockConfiguration" => LockConfiguration), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(tags, resource_arn)
    tag_resource(tags, resource_arn, params::Dict{String,<:Any})

Assigns tags to the specified retention rule.

# Arguments
- `tags`: Information about the tags to assign to the retention rule.
- `resource_arn`: The Amazon Resource Name (ARN) of the retention rule.

"""
function tag_resource(Tags, resourceArn; aws_config::AbstractAWSConfig=current_aws_config())
    return rbin(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    Tags,
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rbin(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Tags" => Tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    unlock_rule(identifier)
    unlock_rule(identifier, params::Dict{String,<:Any})

Unlocks a retention rule. After a retention rule is unlocked, it can be modified or deleted
only after the unlock delay period expires.

# Arguments
- `identifier`: The unique ID of the retention rule.

"""
function unlock_rule(identifier; aws_config::AbstractAWSConfig=current_aws_config())
    return rbin(
        "PATCH",
        "/rules/$(identifier)/unlock";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function unlock_rule(
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rbin(
        "PATCH",
        "/rules/$(identifier)/unlock",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Unassigns a tag from a retention rule.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the retention rule.
- `tag_keys`: The tag keys of the tags to unassign. All tags that have the specified tag
  key are unassigned.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rbin(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rbin(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_rule(identifier)
    update_rule(identifier, params::Dict{String,<:Any})

Updates an existing Recycle Bin retention rule. You can update a retention rule's
description, resource tags, and retention period at any time after creation. You can't
update a retention rule's resource type after creation. For more information, see  Update
Recycle Bin retention rules in the Amazon Elastic Compute Cloud User Guide.

# Arguments
- `identifier`: The unique ID of the retention rule.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: The retention rule description.
- `"ResourceTags"`: Specifies the resource tags to use to identify resources that are to be
  retained by a tag-level retention rule. For tag-level retention rules, only deleted
  resources, of the specified resource type, that have one or more of the specified tag key
  and value pairs are retained. If a resource is deleted, but it does not have any of the
  specified tag key and value pairs, it is immediately deleted without being retained by the
  retention rule. You can add the same tag key and value pair to a maximum or five retention
  rules. To create a Region-level retention rule, omit this parameter. A Region-level
  retention rule does not have any resource tags specified. It retains all deleted resources
  of the specified resource type in the Region in which the rule is created, even if the
  resources are not tagged.
- `"ResourceType"`:  This parameter is currently not supported. You can't update a
  retention rule's resource type after creation.
- `"RetentionPeriod"`: Information about the retention period for which the retention rule
  is to retain resources.
"""
function update_rule(identifier; aws_config::AbstractAWSConfig=current_aws_config())
    return rbin(
        "PATCH",
        "/rules/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_rule(
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rbin(
        "PATCH",
        "/rules/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: mq
using AWS.Compat
using AWS.UUIDs

"""
    create_broker(auto_minor_version_upgrade, broker_name, deployment_mode, engine_type, engine_version, host_instance_type, publicly_accessible, users)
    create_broker(auto_minor_version_upgrade, broker_name, deployment_mode, engine_type, engine_version, host_instance_type, publicly_accessible, users, params::Dict{String,<:Any})

Creates a broker. Note: This API is asynchronous. To create a broker, you must either use
the AmazonMQFullAccess IAM policy or include the following EC2 permissions in your IAM
policy. ec2:CreateNetworkInterface This permission is required to allow Amazon MQ to create
an elastic network interface (ENI) on behalf of your account.
ec2:CreateNetworkInterfacePermission This permission is required to attach the ENI to the
broker instance. ec2:DeleteNetworkInterface ec2:DeleteNetworkInterfacePermission
ec2:DetachNetworkInterface ec2:DescribeInternetGateways ec2:DescribeNetworkInterfaces
ec2:DescribeNetworkInterfacePermissions ec2:DescribeRouteTables ec2:DescribeSecurityGroups
ec2:DescribeSubnets ec2:DescribeVpcs For more information, see Create an IAM User and Get
Your Amazon Web Services Credentials and Never Modify or Delete the Amazon MQ Elastic
Network Interface in the Amazon MQ Developer Guide.

# Arguments
- `auto_minor_version_upgrade`: Enables automatic upgrades to new minor versions for
  brokers, as new versions are released and supported by Amazon MQ. Automatic upgrades occur
  during the scheduled maintenance window of the broker or after a manual broker reboot. Set
  to true by default, if no value is specified.
- `broker_name`: Required. The broker's name. This value must be unique in your Amazon Web
  Services account, 1-50 characters long, must contain only letters, numbers, dashes, and
  underscores, and must not contain white spaces, brackets, wildcard characters, or special
  characters. Do not add personally identifiable information (PII) or other confidential or
  sensitive information in broker names. Broker names are accessible to other Amazon Web
  Services services, including CloudWatch Logs. Broker names are not intended to be used for
  private or sensitive data.
- `deployment_mode`: Required. The broker's deployment mode.
- `engine_type`: Required. The type of broker engine. Currently, Amazon MQ supports
  ACTIVEMQ and RABBITMQ.
- `engine_version`: Required. The broker engine's version. For a list of supported engine
  versions, see Supported engines.
- `host_instance_type`: Required. The broker's instance type.
- `publicly_accessible`: Enables connections from applications outside of the VPC that
  hosts the broker's subnets. Set to false by default, if no value is provided.
- `users`: The list of broker users (persons or applications) who can access queues and
  topics. For Amazon MQ for RabbitMQ brokers, one and only one administrative user is
  accepted and created when a broker is first provisioned. All subsequent broker users are
  created by making RabbitMQ API calls directly to brokers or via the RabbitMQ web console.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"authenticationStrategy"`: Optional. The authentication strategy used to secure the
  broker. The default is SIMPLE.
- `"configuration"`: A list of information about the configuration.
- `"creatorRequestId"`: The unique ID that the requester receives for the created broker.
  Amazon MQ passes your ID with the API action. We recommend using a Universally Unique
  Identifier (UUID) for the creatorRequestId. You may omit the creatorRequestId if your
  application doesn't require idempotency.
- `"dataReplicationMode"`: Defines whether this broker is a part of a data replication pair.
- `"dataReplicationPrimaryBrokerArn"`: The Amazon Resource Name (ARN) of the primary broker
  that is used to replicate data from in a data replication pair, and is applied to the
  replica broker. Must be set when dataReplicationMode is set to CRDR.
- `"encryptionOptions"`: Encryption options for the broker.
- `"ldapServerMetadata"`: Optional. The metadata of the LDAP server used to authenticate
  and authorize connections to the broker. Does not apply to RabbitMQ brokers.
- `"logs"`: Enables Amazon CloudWatch logging for brokers.
- `"maintenanceWindowStartTime"`: The parameters that determine the WeeklyStartTime.
- `"securityGroups"`: The list of rules (1 minimum, 125 maximum) that authorize connections
  to brokers.
- `"storageType"`: The broker's storage type.
- `"subnetIds"`: The list of groups that define which subnets and IP ranges the broker can
  use from different Availability Zones. If you specify more than one subnet, the subnets
  must be in different Availability Zones. Amazon MQ will not be able to create VPC endpoints
  for your broker with multiple subnets in the same Availability Zone. A SINGLE_INSTANCE
  deployment requires one subnet (for example, the default subnet). An
  ACTIVE_STANDBY_MULTI_AZ Amazon MQ for ActiveMQ deployment requires two subnets. A
  CLUSTER_MULTI_AZ Amazon MQ for RabbitMQ deployment has no subnet requirements when deployed
  with public accessibility. Deployment without public accessibility requires at least one
  subnet. If you specify subnets in a shared VPC for a RabbitMQ broker, the associated VPC to
  which the specified subnets belong must be owned by your Amazon Web Services account.
  Amazon MQ will not be able to create VPC endpoints in VPCs that are not owned by your
  Amazon Web Services account.
- `"tags"`: Create tags when creating the broker.
"""
function create_broker(
    autoMinorVersionUpgrade,
    brokerName,
    deploymentMode,
    engineType,
    engineVersion,
    hostInstanceType,
    publiclyAccessible,
    users;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mq(
        "POST",
        "/v1/brokers",
        Dict{String,Any}(
            "autoMinorVersionUpgrade" => autoMinorVersionUpgrade,
            "brokerName" => brokerName,
            "deploymentMode" => deploymentMode,
            "engineType" => engineType,
            "engineVersion" => engineVersion,
            "hostInstanceType" => hostInstanceType,
            "publiclyAccessible" => publiclyAccessible,
            "users" => users,
            "creatorRequestId" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_broker(
    autoMinorVersionUpgrade,
    brokerName,
    deploymentMode,
    engineType,
    engineVersion,
    hostInstanceType,
    publiclyAccessible,
    users,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mq(
        "POST",
        "/v1/brokers",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "autoMinorVersionUpgrade" => autoMinorVersionUpgrade,
                    "brokerName" => brokerName,
                    "deploymentMode" => deploymentMode,
                    "engineType" => engineType,
                    "engineVersion" => engineVersion,
                    "hostInstanceType" => hostInstanceType,
                    "publiclyAccessible" => publiclyAccessible,
                    "users" => users,
                    "creatorRequestId" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_configuration(engine_type, engine_version, name)
    create_configuration(engine_type, engine_version, name, params::Dict{String,<:Any})

Creates a new configuration for the specified configuration name. Amazon MQ uses the
default configuration (the engine type and version).

# Arguments
- `engine_type`: Required. The type of broker engine. Currently, Amazon MQ supports
  ACTIVEMQ and RABBITMQ.
- `engine_version`: Required. The broker engine's version. For a list of supported engine
  versions, see Supported engines.
- `name`: Required. The name of the configuration. This value can contain only alphanumeric
  characters, dashes, periods, underscores, and tildes (- . _ ~). This value must be 1-150
  characters long.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"authenticationStrategy"`: Optional. The authentication strategy associated with the
  configuration. The default is SIMPLE.
- `"tags"`: Create tags when creating the configuration.
"""
function create_configuration(
    engineType, engineVersion, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mq(
        "POST",
        "/v1/configurations",
        Dict{String,Any}(
            "engineType" => engineType, "engineVersion" => engineVersion, "name" => name
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_configuration(
    engineType,
    engineVersion,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mq(
        "POST",
        "/v1/configurations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "engineType" => engineType,
                    "engineVersion" => engineVersion,
                    "name" => name,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_tags(resource-arn)
    create_tags(resource-arn, params::Dict{String,<:Any})

Add a tag to a resource.

# Arguments
- `resource-arn`: The Amazon Resource Name (ARN) of the resource tag.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tags"`: The key-value pair for the resource tag.
"""
function create_tags(resource_arn; aws_config::AbstractAWSConfig=current_aws_config())
    return mq(
        "POST",
        "/v1/tags/$(resource-arn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_tags(
    resource_arn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mq(
        "POST",
        "/v1/tags/$(resource-arn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_user(broker-id, password, username)
    create_user(broker-id, password, username, params::Dict{String,<:Any})

Creates an ActiveMQ user. Do not add personally identifiable information (PII) or other
confidential or sensitive information in broker usernames. Broker usernames are accessible
to other Amazon Web Services services, including CloudWatch Logs. Broker usernames are not
intended to be used for private or sensitive data.

# Arguments
- `broker-id`: The unique ID that Amazon MQ generates for the broker.
- `password`: Required. The password of the user. This value must be at least 12 characters
  long, must contain at least 4 unique characters, and must not contain commas, colons, or
  equal signs (,:=).
- `username`: The username of the ActiveMQ user. This value can contain only alphanumeric
  characters, dashes, periods, underscores, and tildes (- . _ ~). This value must be 2-100
  characters long.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"consoleAccess"`: Enables access to the ActiveMQ Web Console for the ActiveMQ user.
- `"groups"`: The list of groups (20 maximum) to which the ActiveMQ user belongs. This
  value can contain only alphanumeric characters, dashes, periods, underscores, and tildes (-
  . _ ~). This value must be 2-100 characters long.
- `"replicationUser"`: Defines if this user is intended for CRDR replication purposes.
"""
function create_user(
    broker_id, password, username; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mq(
        "POST",
        "/v1/brokers/$(broker-id)/users/$(username)",
        Dict{String,Any}("password" => password);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_user(
    broker_id,
    password,
    username,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mq(
        "POST",
        "/v1/brokers/$(broker-id)/users/$(username)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("password" => password), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_broker(broker-id)
    delete_broker(broker-id, params::Dict{String,<:Any})

Deletes a broker. Note: This API is asynchronous.

# Arguments
- `broker-id`: The unique ID that Amazon MQ generates for the broker.

"""
function delete_broker(broker_id; aws_config::AbstractAWSConfig=current_aws_config())
    return mq(
        "DELETE",
        "/v1/brokers/$(broker-id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_broker(
    broker_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mq(
        "DELETE",
        "/v1/brokers/$(broker-id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_tags(resource-arn, tag_keys)
    delete_tags(resource-arn, tag_keys, params::Dict{String,<:Any})

Removes a tag from a resource.

# Arguments
- `resource-arn`: The Amazon Resource Name (ARN) of the resource tag.
- `tag_keys`: An array of tag keys to delete

"""
function delete_tags(
    resource_arn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mq(
        "DELETE",
        "/v1/tags/$(resource-arn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_tags(
    resource_arn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mq(
        "DELETE",
        "/v1/tags/$(resource-arn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_user(broker-id, username)
    delete_user(broker-id, username, params::Dict{String,<:Any})

Deletes an ActiveMQ user.

# Arguments
- `broker-id`: The unique ID that Amazon MQ generates for the broker.
- `username`: The username of the ActiveMQ user. This value can contain only alphanumeric
  characters, dashes, periods, underscores, and tildes (- . _ ~). This value must be 2-100
  characters long.

"""
function delete_user(
    broker_id, username; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mq(
        "DELETE",
        "/v1/brokers/$(broker-id)/users/$(username)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_user(
    broker_id,
    username,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mq(
        "DELETE",
        "/v1/brokers/$(broker-id)/users/$(username)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_broker(broker-id)
    describe_broker(broker-id, params::Dict{String,<:Any})

Returns information about the specified broker.

# Arguments
- `broker-id`: The unique ID that Amazon MQ generates for the broker.

"""
function describe_broker(broker_id; aws_config::AbstractAWSConfig=current_aws_config())
    return mq(
        "GET",
        "/v1/brokers/$(broker-id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_broker(
    broker_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mq(
        "GET",
        "/v1/brokers/$(broker-id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_broker_engine_types()
    describe_broker_engine_types(params::Dict{String,<:Any})

Describe available engine types and versions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"engineType"`: Filter response by engine type.
- `"maxResults"`: The maximum number of brokers that Amazon MQ can return per page (20 by
  default). This value must be an integer from 5 to 100.
- `"nextToken"`: The token that specifies the next page of results Amazon MQ should return.
  To request the first page, leave nextToken empty.
"""
function describe_broker_engine_types(; aws_config::AbstractAWSConfig=current_aws_config())
    return mq(
        "GET",
        "/v1/broker-engine-types";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_broker_engine_types(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mq(
        "GET",
        "/v1/broker-engine-types",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_broker_instance_options()
    describe_broker_instance_options(params::Dict{String,<:Any})

Describe available broker instance options.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"engineType"`: Filter response by engine type.
- `"hostInstanceType"`: Filter response by host instance type.
- `"maxResults"`: The maximum number of brokers that Amazon MQ can return per page (20 by
  default). This value must be an integer from 5 to 100.
- `"nextToken"`: The token that specifies the next page of results Amazon MQ should return.
  To request the first page, leave nextToken empty.
- `"storageType"`: Filter response by storage type.
"""
function describe_broker_instance_options(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return mq(
        "GET",
        "/v1/broker-instance-options";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_broker_instance_options(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mq(
        "GET",
        "/v1/broker-instance-options",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_configuration(configuration-id)
    describe_configuration(configuration-id, params::Dict{String,<:Any})

Returns information about the specified configuration.

# Arguments
- `configuration-id`: The unique ID that Amazon MQ generates for the configuration.

"""
function describe_configuration(
    configuration_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mq(
        "GET",
        "/v1/configurations/$(configuration-id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_configuration(
    configuration_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mq(
        "GET",
        "/v1/configurations/$(configuration-id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_configuration_revision(configuration-id, configuration-revision)
    describe_configuration_revision(configuration-id, configuration-revision, params::Dict{String,<:Any})

Returns the specified configuration revision for the specified configuration.

# Arguments
- `configuration-id`: The unique ID that Amazon MQ generates for the configuration.
- `configuration-revision`: The revision of the configuration.

"""
function describe_configuration_revision(
    configuration_id,
    configuration_revision;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mq(
        "GET",
        "/v1/configurations/$(configuration-id)/revisions/$(configuration-revision)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_configuration_revision(
    configuration_id,
    configuration_revision,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mq(
        "GET",
        "/v1/configurations/$(configuration-id)/revisions/$(configuration-revision)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_user(broker-id, username)
    describe_user(broker-id, username, params::Dict{String,<:Any})

Returns information about an ActiveMQ user.

# Arguments
- `broker-id`: The unique ID that Amazon MQ generates for the broker.
- `username`: The username of the ActiveMQ user. This value can contain only alphanumeric
  characters, dashes, periods, underscores, and tildes (- . _ ~). This value must be 2-100
  characters long.

"""
function describe_user(
    broker_id, username; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mq(
        "GET",
        "/v1/brokers/$(broker-id)/users/$(username)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_user(
    broker_id,
    username,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mq(
        "GET",
        "/v1/brokers/$(broker-id)/users/$(username)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_brokers()
    list_brokers(params::Dict{String,<:Any})

Returns a list of all brokers.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of brokers that Amazon MQ can return per page (20 by
  default). This value must be an integer from 5 to 100.
- `"nextToken"`: The token that specifies the next page of results Amazon MQ should return.
  To request the first page, leave nextToken empty.
"""
function list_brokers(; aws_config::AbstractAWSConfig=current_aws_config())
    return mq("GET", "/v1/brokers"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_brokers(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mq(
        "GET", "/v1/brokers", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_configuration_revisions(configuration-id)
    list_configuration_revisions(configuration-id, params::Dict{String,<:Any})

Returns a list of all revisions for the specified configuration.

# Arguments
- `configuration-id`: The unique ID that Amazon MQ generates for the configuration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of brokers that Amazon MQ can return per page (20 by
  default). This value must be an integer from 5 to 100.
- `"nextToken"`: The token that specifies the next page of results Amazon MQ should return.
  To request the first page, leave nextToken empty.
"""
function list_configuration_revisions(
    configuration_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mq(
        "GET",
        "/v1/configurations/$(configuration-id)/revisions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_configuration_revisions(
    configuration_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mq(
        "GET",
        "/v1/configurations/$(configuration-id)/revisions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_configurations()
    list_configurations(params::Dict{String,<:Any})

Returns a list of all configurations.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of brokers that Amazon MQ can return per page (20 by
  default). This value must be an integer from 5 to 100.
- `"nextToken"`: The token that specifies the next page of results Amazon MQ should return.
  To request the first page, leave nextToken empty.
"""
function list_configurations(; aws_config::AbstractAWSConfig=current_aws_config())
    return mq(
        "GET", "/v1/configurations"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_configurations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mq(
        "GET",
        "/v1/configurations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags(resource-arn)
    list_tags(resource-arn, params::Dict{String,<:Any})

Lists tags for a resource.

# Arguments
- `resource-arn`: The Amazon Resource Name (ARN) of the resource tag.

"""
function list_tags(resource_arn; aws_config::AbstractAWSConfig=current_aws_config())
    return mq(
        "GET",
        "/v1/tags/$(resource-arn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags(
    resource_arn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mq(
        "GET",
        "/v1/tags/$(resource-arn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_users(broker-id)
    list_users(broker-id, params::Dict{String,<:Any})

Returns a list of all ActiveMQ users.

# Arguments
- `broker-id`: The unique ID that Amazon MQ generates for the broker.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of brokers that Amazon MQ can return per page (20 by
  default). This value must be an integer from 5 to 100.
- `"nextToken"`: The token that specifies the next page of results Amazon MQ should return.
  To request the first page, leave nextToken empty.
"""
function list_users(broker_id; aws_config::AbstractAWSConfig=current_aws_config())
    return mq(
        "GET",
        "/v1/brokers/$(broker-id)/users";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_users(
    broker_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mq(
        "GET",
        "/v1/brokers/$(broker-id)/users",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    promote(broker-id, mode)
    promote(broker-id, mode, params::Dict{String,<:Any})

Promotes a data replication replica broker to the primary broker role.

# Arguments
- `broker-id`: The unique ID that Amazon MQ generates for the broker.
- `mode`: The Promote mode requested. Note: Valid values for the parameter are SWITCHOVER,
  FAILOVER.

"""
function promote(broker_id, mode; aws_config::AbstractAWSConfig=current_aws_config())
    return mq(
        "POST",
        "/v1/brokers/$(broker-id)/promote",
        Dict{String,Any}("mode" => mode);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function promote(
    broker_id,
    mode,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mq(
        "POST",
        "/v1/brokers/$(broker-id)/promote",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("mode" => mode), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    reboot_broker(broker-id)
    reboot_broker(broker-id, params::Dict{String,<:Any})

Reboots a broker. Note: This API is asynchronous.

# Arguments
- `broker-id`: The unique ID that Amazon MQ generates for the broker.

"""
function reboot_broker(broker_id; aws_config::AbstractAWSConfig=current_aws_config())
    return mq(
        "POST",
        "/v1/brokers/$(broker-id)/reboot";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function reboot_broker(
    broker_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mq(
        "POST",
        "/v1/brokers/$(broker-id)/reboot",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_broker(broker-id)
    update_broker(broker-id, params::Dict{String,<:Any})

Adds a pending configuration change to a broker.

# Arguments
- `broker-id`: The unique ID that Amazon MQ generates for the broker.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"authenticationStrategy"`: Optional. The authentication strategy used to secure the
  broker. The default is SIMPLE.
- `"autoMinorVersionUpgrade"`: Enables automatic upgrades to new minor versions for
  brokers, as new versions are released and supported by Amazon MQ. Automatic upgrades occur
  during the scheduled maintenance window of the broker or after a manual broker reboot.
- `"configuration"`: A list of information about the configuration.
- `"dataReplicationMode"`: Defines whether this broker is a part of a data replication pair.
- `"engineVersion"`: The broker engine version. For a list of supported engine versions,
  see Supported engines.
- `"hostInstanceType"`: The broker's host instance type to upgrade to. For a list of
  supported instance types, see Broker instance types.
- `"ldapServerMetadata"`: Optional. The metadata of the LDAP server used to authenticate
  and authorize connections to the broker. Does not apply to RabbitMQ brokers.
- `"logs"`: Enables Amazon CloudWatch logging for brokers.
- `"maintenanceWindowStartTime"`: The parameters that determine the WeeklyStartTime.
- `"securityGroups"`: The list of security groups (1 minimum, 5 maximum) that authorizes
  connections to brokers.
"""
function update_broker(broker_id; aws_config::AbstractAWSConfig=current_aws_config())
    return mq(
        "PUT",
        "/v1/brokers/$(broker-id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_broker(
    broker_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mq(
        "PUT",
        "/v1/brokers/$(broker-id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_configuration(configuration-id, data)
    update_configuration(configuration-id, data, params::Dict{String,<:Any})

Updates the specified configuration.

# Arguments
- `configuration-id`: The unique ID that Amazon MQ generates for the configuration.
- `data`: Amazon MQ for Active MQ: The base64-encoded XML configuration. Amazon MQ for
  RabbitMQ: the base64-encoded Cuttlefish configuration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description of the configuration.
"""
function update_configuration(
    configuration_id, data; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mq(
        "PUT",
        "/v1/configurations/$(configuration-id)",
        Dict{String,Any}("data" => data);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_configuration(
    configuration_id,
    data,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mq(
        "PUT",
        "/v1/configurations/$(configuration-id)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("data" => data), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_user(broker-id, username)
    update_user(broker-id, username, params::Dict{String,<:Any})

Updates the information for an ActiveMQ user.

# Arguments
- `broker-id`: The unique ID that Amazon MQ generates for the broker.
- `username`: The username of the ActiveMQ user. This value can contain only alphanumeric
  characters, dashes, periods, underscores, and tildes (- . _ ~). This value must be 2-100
  characters long.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"consoleAccess"`: Enables access to the the ActiveMQ Web Console for the ActiveMQ user.
- `"groups"`: The list of groups (20 maximum) to which the ActiveMQ user belongs. This
  value can contain only alphanumeric characters, dashes, periods, underscores, and tildes (-
  . _ ~). This value must be 2-100 characters long.
- `"password"`: The password of the user. This value must be at least 12 characters long,
  must contain at least 4 unique characters, and must not contain commas, colons, or equal
  signs (,:=).
- `"replicationUser"`: Defines whether the user is intended for data replication.
"""
function update_user(
    broker_id, username; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mq(
        "PUT",
        "/v1/brokers/$(broker-id)/users/$(username)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_user(
    broker_id,
    username,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mq(
        "PUT",
        "/v1/brokers/$(broker-id)/users/$(username)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: iotanalytics
using AWS.Compat
using AWS.UUIDs

"""
    batch_put_message(channel_name, messages)
    batch_put_message(channel_name, messages, params::Dict{String,<:Any})

Sends messages to a channel.

# Arguments
- `channel_name`: The name of the channel where the messages are sent.
- `messages`: The list of messages to be sent. Each message has the format: {
  \"messageId\": \"string\", \"payload\": \"string\"}. The field names of message payloads
  (data) that you send to IoT Analytics:   Must contain only alphanumeric characters and
  undescores (_). No other special characters are allowed.   Must begin with an alphabetic
  character or single underscore (_).   Cannot contain hyphens (-).   In regular expression
  terms: \"^\\[A-Za-z_]([A-Za-z0-9]*|[A-Za-z0-9][A-Za-z0-9_]*)\".    Cannot be more than 255
  characters.   Are case insensitive. (Fields named foo and FOO in the same payload are
  considered duplicates.)   For example, {\"temp_01\": 29} or {\"_temp_01\": 29} are valid,
  but {\"temp-01\": 29}, {\"01_temp\": 29} or {\"__temp_01\": 29} are invalid in message
  payloads.

"""
function batch_put_message(
    channelName, messages; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotanalytics(
        "POST",
        "/messages/batch",
        Dict{String,Any}("channelName" => channelName, "messages" => messages);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_put_message(
    channelName,
    messages,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotanalytics(
        "POST",
        "/messages/batch",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("channelName" => channelName, "messages" => messages),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_pipeline_reprocessing(pipeline_name, reprocessing_id)
    cancel_pipeline_reprocessing(pipeline_name, reprocessing_id, params::Dict{String,<:Any})

Cancels the reprocessing of data through the pipeline.

# Arguments
- `pipeline_name`: The name of pipeline for which data reprocessing is canceled.
- `reprocessing_id`: The ID of the reprocessing task (returned by
  StartPipelineReprocessing).

"""
function cancel_pipeline_reprocessing(
    pipelineName, reprocessingId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotanalytics(
        "DELETE",
        "/pipelines/$(pipelineName)/reprocessing/$(reprocessingId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_pipeline_reprocessing(
    pipelineName,
    reprocessingId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotanalytics(
        "DELETE",
        "/pipelines/$(pipelineName)/reprocessing/$(reprocessingId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_channel(channel_name)
    create_channel(channel_name, params::Dict{String,<:Any})

Used to create a channel. A channel collects data from an MQTT topic and archives the raw,
unprocessed messages before publishing the data to a pipeline.

# Arguments
- `channel_name`: The name of the channel.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"channelStorage"`: Where channel data is stored. You can choose one of serviceManagedS3
  or customerManagedS3 storage. If not specified, the default is serviceManagedS3. You can't
  change this storage option after the channel is created.
- `"retentionPeriod"`: How long, in days, message data is kept for the channel. When
  customerManagedS3 storage is selected, this parameter is ignored.
- `"tags"`: Metadata which can be used to manage the channel.
"""
function create_channel(channelName; aws_config::AbstractAWSConfig=current_aws_config())
    return iotanalytics(
        "POST",
        "/channels",
        Dict{String,Any}("channelName" => channelName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_channel(
    channelName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotanalytics(
        "POST",
        "/channels",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("channelName" => channelName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_dataset(actions, dataset_name)
    create_dataset(actions, dataset_name, params::Dict{String,<:Any})

Used to create a dataset. A dataset stores data retrieved from a data store by applying a
queryAction (a SQL query) or a containerAction (executing a containerized application).
This operation creates the skeleton of a dataset. The dataset can be populated manually by
calling CreateDatasetContent or automatically according to a trigger you specify.

# Arguments
- `actions`: A list of actions that create the dataset contents.
- `dataset_name`: The name of the dataset.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"contentDeliveryRules"`: When dataset contents are created, they are delivered to
  destinations specified here.
- `"lateDataRules"`: A list of data rules that send notifications to CloudWatch, when data
  arrives late. To specify lateDataRules, the dataset must use a DeltaTimer filter.
- `"retentionPeriod"`: Optional. How long, in days, versions of dataset contents are kept
  for the dataset. If not specified or set to null, versions of dataset contents are retained
  for at most 90 days. The number of versions of dataset contents retained is determined by
  the versioningConfiguration parameter. For more information, see  Keeping Multiple Versions
  of IoT Analytics datasets in the IoT Analytics User Guide.
- `"tags"`: Metadata which can be used to manage the dataset.
- `"triggers"`: A list of triggers. A trigger causes dataset contents to be populated at a
  specified time interval or when another dataset's contents are created. The list of
  triggers can be empty or contain up to five DataSetTrigger objects.
- `"versioningConfiguration"`: Optional. How many versions of dataset contents are kept. If
  not specified or set to null, only the latest version plus the latest succeeded version (if
  they are different) are kept for the time period specified by the retentionPeriod
  parameter. For more information, see Keeping Multiple Versions of IoT Analytics datasets in
  the IoT Analytics User Guide.
"""
function create_dataset(
    actions, datasetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotanalytics(
        "POST",
        "/datasets",
        Dict{String,Any}("actions" => actions, "datasetName" => datasetName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_dataset(
    actions,
    datasetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotanalytics(
        "POST",
        "/datasets",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("actions" => actions, "datasetName" => datasetName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_dataset_content(dataset_name)
    create_dataset_content(dataset_name, params::Dict{String,<:Any})

Creates the content of a dataset by applying a queryAction (a SQL query) or a
containerAction (executing a containerized application).

# Arguments
- `dataset_name`: The name of the dataset.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"versionId"`: The version ID of the dataset content. To specify versionId for a dataset
  content, the dataset must use a DeltaTimer filter.
"""
function create_dataset_content(
    datasetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotanalytics(
        "POST",
        "/datasets/$(datasetName)/content";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_dataset_content(
    datasetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotanalytics(
        "POST",
        "/datasets/$(datasetName)/content",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_datastore(datastore_name)
    create_datastore(datastore_name, params::Dict{String,<:Any})

Creates a data store, which is a repository for messages.

# Arguments
- `datastore_name`: The name of the data store.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"datastorePartitions"`:  Contains information about the partition dimensions in a data
  store.
- `"datastoreStorage"`: Where data in a data store is stored.. You can choose
  serviceManagedS3 storage, customerManagedS3 storage, or iotSiteWiseMultiLayerStorage
  storage. The default is serviceManagedS3. You can't change the choice of Amazon S3 storage
  after your data store is created.
- `"fileFormatConfiguration"`: Contains the configuration information of file formats. IoT
  Analytics data stores support JSON and Parquet. The default file format is JSON. You can
  specify only one format. You can't change the file format after you create the data store.
- `"retentionPeriod"`: How long, in days, message data is kept for the data store. When
  customerManagedS3 storage is selected, this parameter is ignored.
- `"tags"`: Metadata which can be used to manage the data store.
"""
function create_datastore(datastoreName; aws_config::AbstractAWSConfig=current_aws_config())
    return iotanalytics(
        "POST",
        "/datastores",
        Dict{String,Any}("datastoreName" => datastoreName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_datastore(
    datastoreName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotanalytics(
        "POST",
        "/datastores",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("datastoreName" => datastoreName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_pipeline(pipeline_activities, pipeline_name)
    create_pipeline(pipeline_activities, pipeline_name, params::Dict{String,<:Any})

Creates a pipeline. A pipeline consumes messages from a channel and allows you to process
the messages before storing them in a data store. You must specify both a channel and a
datastore activity and, optionally, as many as 23 additional activities in the
pipelineActivities array.

# Arguments
- `pipeline_activities`: A list of PipelineActivity objects. Activities perform
  transformations on your messages, such as removing, renaming or adding message attributes;
  filtering messages based on attribute values; invoking your Lambda unctions on messages for
  advanced processing; or performing mathematical transformations to normalize device data.
  The list can be 2-25 PipelineActivity objects and must contain both a channel and a
  datastore activity. Each entry in the list must contain only one activity. For example:
  pipelineActivities = [ { \"channel\": { ... } }, { \"lambda\": { ... } }, ... ]
- `pipeline_name`: The name of the pipeline.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tags"`: Metadata which can be used to manage the pipeline.
"""
function create_pipeline(
    pipelineActivities, pipelineName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotanalytics(
        "POST",
        "/pipelines",
        Dict{String,Any}(
            "pipelineActivities" => pipelineActivities, "pipelineName" => pipelineName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_pipeline(
    pipelineActivities,
    pipelineName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotanalytics(
        "POST",
        "/pipelines",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "pipelineActivities" => pipelineActivities,
                    "pipelineName" => pipelineName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_channel(channel_name)
    delete_channel(channel_name, params::Dict{String,<:Any})

Deletes the specified channel.

# Arguments
- `channel_name`: The name of the channel to delete.

"""
function delete_channel(channelName; aws_config::AbstractAWSConfig=current_aws_config())
    return iotanalytics(
        "DELETE",
        "/channels/$(channelName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_channel(
    channelName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotanalytics(
        "DELETE",
        "/channels/$(channelName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_dataset(dataset_name)
    delete_dataset(dataset_name, params::Dict{String,<:Any})

Deletes the specified dataset. You do not have to delete the content of the dataset before
you perform this operation.

# Arguments
- `dataset_name`: The name of the dataset to delete.

"""
function delete_dataset(datasetName; aws_config::AbstractAWSConfig=current_aws_config())
    return iotanalytics(
        "DELETE",
        "/datasets/$(datasetName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_dataset(
    datasetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotanalytics(
        "DELETE",
        "/datasets/$(datasetName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_dataset_content(dataset_name)
    delete_dataset_content(dataset_name, params::Dict{String,<:Any})

Deletes the content of the specified dataset.

# Arguments
- `dataset_name`: The name of the dataset whose content is deleted.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"versionId"`: The version of the dataset whose content is deleted. You can also use the
  strings \"LATEST\" or \"LATEST_SUCCEEDED\" to delete the latest or latest successfully
  completed data set. If not specified, \"LATEST_SUCCEEDED\" is the default.
"""
function delete_dataset_content(
    datasetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotanalytics(
        "DELETE",
        "/datasets/$(datasetName)/content";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_dataset_content(
    datasetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotanalytics(
        "DELETE",
        "/datasets/$(datasetName)/content",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_datastore(datastore_name)
    delete_datastore(datastore_name, params::Dict{String,<:Any})

Deletes the specified data store.

# Arguments
- `datastore_name`: The name of the data store to delete.

"""
function delete_datastore(datastoreName; aws_config::AbstractAWSConfig=current_aws_config())
    return iotanalytics(
        "DELETE",
        "/datastores/$(datastoreName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_datastore(
    datastoreName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotanalytics(
        "DELETE",
        "/datastores/$(datastoreName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_pipeline(pipeline_name)
    delete_pipeline(pipeline_name, params::Dict{String,<:Any})

Deletes the specified pipeline.

# Arguments
- `pipeline_name`: The name of the pipeline to delete.

"""
function delete_pipeline(pipelineName; aws_config::AbstractAWSConfig=current_aws_config())
    return iotanalytics(
        "DELETE",
        "/pipelines/$(pipelineName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_pipeline(
    pipelineName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotanalytics(
        "DELETE",
        "/pipelines/$(pipelineName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_channel(channel_name)
    describe_channel(channel_name, params::Dict{String,<:Any})

Retrieves information about a channel.

# Arguments
- `channel_name`: The name of the channel whose information is retrieved.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"includeStatistics"`: If true, additional statistical information about the channel is
  included in the response. This feature can't be used with a channel whose S3 storage is
  customer-managed.
"""
function describe_channel(channelName; aws_config::AbstractAWSConfig=current_aws_config())
    return iotanalytics(
        "GET",
        "/channels/$(channelName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_channel(
    channelName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotanalytics(
        "GET",
        "/channels/$(channelName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_dataset(dataset_name)
    describe_dataset(dataset_name, params::Dict{String,<:Any})

Retrieves information about a dataset.

# Arguments
- `dataset_name`: The name of the dataset whose information is retrieved.

"""
function describe_dataset(datasetName; aws_config::AbstractAWSConfig=current_aws_config())
    return iotanalytics(
        "GET",
        "/datasets/$(datasetName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_dataset(
    datasetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotanalytics(
        "GET",
        "/datasets/$(datasetName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_datastore(datastore_name)
    describe_datastore(datastore_name, params::Dict{String,<:Any})

Retrieves information about a data store.

# Arguments
- `datastore_name`: The name of the data store

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"includeStatistics"`: If true, additional statistical information about the data store
  is included in the response. This feature can't be used with a data store whose S3 storage
  is customer-managed.
"""
function describe_datastore(
    datastoreName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotanalytics(
        "GET",
        "/datastores/$(datastoreName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_datastore(
    datastoreName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotanalytics(
        "GET",
        "/datastores/$(datastoreName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_logging_options()
    describe_logging_options(params::Dict{String,<:Any})

Retrieves the current settings of the IoT Analytics logging options.

"""
function describe_logging_options(; aws_config::AbstractAWSConfig=current_aws_config())
    return iotanalytics(
        "GET", "/logging"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_logging_options(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotanalytics(
        "GET", "/logging", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_pipeline(pipeline_name)
    describe_pipeline(pipeline_name, params::Dict{String,<:Any})

Retrieves information about a pipeline.

# Arguments
- `pipeline_name`: The name of the pipeline whose information is retrieved.

"""
function describe_pipeline(pipelineName; aws_config::AbstractAWSConfig=current_aws_config())
    return iotanalytics(
        "GET",
        "/pipelines/$(pipelineName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_pipeline(
    pipelineName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotanalytics(
        "GET",
        "/pipelines/$(pipelineName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_dataset_content(dataset_name)
    get_dataset_content(dataset_name, params::Dict{String,<:Any})

Retrieves the contents of a dataset as presigned URIs.

# Arguments
- `dataset_name`: The name of the dataset whose contents are retrieved.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"versionId"`: The version of the dataset whose contents are retrieved. You can also use
  the strings \"LATEST\" or \"LATEST_SUCCEEDED\" to retrieve the contents of the latest or
  latest successfully completed dataset. If not specified, \"LATEST_SUCCEEDED\" is the
  default.
"""
function get_dataset_content(
    datasetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotanalytics(
        "GET",
        "/datasets/$(datasetName)/content";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_dataset_content(
    datasetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotanalytics(
        "GET",
        "/datasets/$(datasetName)/content",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_channels()
    list_channels(params::Dict{String,<:Any})

Retrieves a list of channels.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in this request. The default
  value is 100.
- `"nextToken"`: The token for the next set of results.
"""
function list_channels(; aws_config::AbstractAWSConfig=current_aws_config())
    return iotanalytics(
        "GET", "/channels"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_channels(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotanalytics(
        "GET", "/channels", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_dataset_contents(dataset_name)
    list_dataset_contents(dataset_name, params::Dict{String,<:Any})

Lists information about dataset contents that have been created.

# Arguments
- `dataset_name`: The name of the dataset whose contents information you want to list.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in this request.
- `"nextToken"`: The token for the next set of results.
- `"scheduledBefore"`: A filter to limit results to those dataset contents whose creation
  is scheduled before the given time. See the field triggers.schedule in the CreateDataset
  request. (timestamp)
- `"scheduledOnOrAfter"`: A filter to limit results to those dataset contents whose
  creation is scheduled on or after the given time. See the field triggers.schedule in the
  CreateDataset request. (timestamp)
"""
function list_dataset_contents(
    datasetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotanalytics(
        "GET",
        "/datasets/$(datasetName)/contents";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_dataset_contents(
    datasetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotanalytics(
        "GET",
        "/datasets/$(datasetName)/contents",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_datasets()
    list_datasets(params::Dict{String,<:Any})

Retrieves information about datasets.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in this request. The default
  value is 100.
- `"nextToken"`: The token for the next set of results.
"""
function list_datasets(; aws_config::AbstractAWSConfig=current_aws_config())
    return iotanalytics(
        "GET", "/datasets"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_datasets(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotanalytics(
        "GET", "/datasets", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_datastores()
    list_datastores(params::Dict{String,<:Any})

Retrieves a list of data stores.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in this request. The default
  value is 100.
- `"nextToken"`: The token for the next set of results.
"""
function list_datastores(; aws_config::AbstractAWSConfig=current_aws_config())
    return iotanalytics(
        "GET", "/datastores"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_datastores(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotanalytics(
        "GET", "/datastores", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_pipelines()
    list_pipelines(params::Dict{String,<:Any})

Retrieves a list of pipelines.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in this request. The default
  value is 100.
- `"nextToken"`: The token for the next set of results.
"""
function list_pipelines(; aws_config::AbstractAWSConfig=current_aws_config())
    return iotanalytics(
        "GET", "/pipelines"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_pipelines(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotanalytics(
        "GET", "/pipelines", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists the tags (metadata) that you have assigned to the resource.

# Arguments
- `resource_arn`: The ARN of the resource whose tags you want to list.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotanalytics(
        "GET",
        "/tags",
        Dict{String,Any}("resourceArn" => resourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotanalytics(
        "GET",
        "/tags",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceArn" => resourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_logging_options(logging_options)
    put_logging_options(logging_options, params::Dict{String,<:Any})

Sets or updates the IoT Analytics logging options. If you update the value of any
loggingOptions field, it takes up to one minute for the change to take effect. Also, if you
change the policy attached to the role you specified in the roleArn field (for example, to
correct an invalid policy), it takes up to five minutes for that change to take effect.

# Arguments
- `logging_options`: The new values of the IoT Analytics logging options.

"""
function put_logging_options(
    loggingOptions; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotanalytics(
        "PUT",
        "/logging",
        Dict{String,Any}("loggingOptions" => loggingOptions);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_logging_options(
    loggingOptions,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotanalytics(
        "PUT",
        "/logging",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("loggingOptions" => loggingOptions), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    run_pipeline_activity(payloads, pipeline_activity)
    run_pipeline_activity(payloads, pipeline_activity, params::Dict{String,<:Any})

Simulates the results of running a pipeline activity on a message payload.

# Arguments
- `payloads`: The sample message payloads on which the pipeline activity is run.
- `pipeline_activity`: The pipeline activity that is run. This must not be a channel
  activity or a data store activity because these activities are used in a pipeline only to
  load the original message and to store the (possibly) transformed message. If a Lambda
  activity is specified, only short-running Lambda functions (those with a timeout of less
  than 30 seconds or less) can be used.

"""
function run_pipeline_activity(
    payloads, pipelineActivity; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotanalytics(
        "POST",
        "/pipelineactivities/run",
        Dict{String,Any}("payloads" => payloads, "pipelineActivity" => pipelineActivity);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function run_pipeline_activity(
    payloads,
    pipelineActivity,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotanalytics(
        "POST",
        "/pipelineactivities/run",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "payloads" => payloads, "pipelineActivity" => pipelineActivity
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    sample_channel_data(channel_name)
    sample_channel_data(channel_name, params::Dict{String,<:Any})

Retrieves a sample of messages from the specified channel ingested during the specified
timeframe. Up to 10 messages can be retrieved.

# Arguments
- `channel_name`: The name of the channel whose message samples are retrieved.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"endTime"`: The end of the time window from which sample messages are retrieved.
- `"maxMessages"`: The number of sample messages to be retrieved. The limit is 10. The
  default is also 10.
- `"startTime"`: The start of the time window from which sample messages are retrieved.
"""
function sample_channel_data(
    channelName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotanalytics(
        "GET",
        "/channels/$(channelName)/sample";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function sample_channel_data(
    channelName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotanalytics(
        "GET",
        "/channels/$(channelName)/sample",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_pipeline_reprocessing(pipeline_name)
    start_pipeline_reprocessing(pipeline_name, params::Dict{String,<:Any})

Starts the reprocessing of raw message data through the pipeline.

# Arguments
- `pipeline_name`: The name of the pipeline on which to start reprocessing.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"channelMessages"`: Specifies one or more sets of channel messages that you want to
  reprocess. If you use the channelMessages object, you must not specify a value for
  startTime and endTime.
- `"endTime"`: The end time (exclusive) of raw message data that is reprocessed. If you
  specify a value for the endTime parameter, you must not use the channelMessages object.
- `"startTime"`: The start time (inclusive) of raw message data that is reprocessed. If you
  specify a value for the startTime parameter, you must not use the channelMessages object.
"""
function start_pipeline_reprocessing(
    pipelineName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotanalytics(
        "POST",
        "/pipelines/$(pipelineName)/reprocessing";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_pipeline_reprocessing(
    pipelineName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotanalytics(
        "POST",
        "/pipelines/$(pipelineName)/reprocessing",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds to or modifies the tags of the given resource. Tags are metadata that can be used to
manage a resource.

# Arguments
- `resource_arn`: The ARN of the resource whose tags you want to modify.
- `tags`: The new or modified tags for the resource.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return iotanalytics(
        "POST",
        "/tags",
        Dict{String,Any}("resourceArn" => resourceArn, "tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotanalytics(
        "POST",
        "/tags",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceArn" => resourceArn, "tags" => tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes the given tags (metadata) from the resource.

# Arguments
- `resource_arn`: The ARN of the resource whose tags you want to remove.
- `tag_keys`: The keys of those tags which you want to remove.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotanalytics(
        "DELETE",
        "/tags",
        Dict{String,Any}("resourceArn" => resourceArn, "tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotanalytics(
        "DELETE",
        "/tags",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceArn" => resourceArn, "tagKeys" => tagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_channel(channel_name)
    update_channel(channel_name, params::Dict{String,<:Any})

Used to update the settings of a channel.

# Arguments
- `channel_name`: The name of the channel to be updated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"channelStorage"`: Where channel data is stored. You can choose one of serviceManagedS3
  or customerManagedS3 storage. If not specified, the default is serviceManagedS3. You can't
  change this storage option after the channel is created.
- `"retentionPeriod"`: How long, in days, message data is kept for the channel. The
  retention period can't be updated if the channel's Amazon S3 storage is customer-managed.
"""
function update_channel(channelName; aws_config::AbstractAWSConfig=current_aws_config())
    return iotanalytics(
        "PUT",
        "/channels/$(channelName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_channel(
    channelName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotanalytics(
        "PUT",
        "/channels/$(channelName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_dataset(actions, dataset_name)
    update_dataset(actions, dataset_name, params::Dict{String,<:Any})

Updates the settings of a dataset.

# Arguments
- `actions`: A list of DatasetAction objects.
- `dataset_name`: The name of the dataset to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"contentDeliveryRules"`: When dataset contents are created, they are delivered to
  destinations specified here.
- `"lateDataRules"`: A list of data rules that send notifications to CloudWatch, when data
  arrives late. To specify lateDataRules, the dataset must use a DeltaTimer filter.
- `"retentionPeriod"`: How long, in days, dataset contents are kept for the dataset.
- `"triggers"`: A list of DatasetTrigger objects. The list can be empty or can contain up
  to five DatasetTrigger objects.
- `"versioningConfiguration"`: Optional. How many versions of dataset contents are kept. If
  not specified or set to null, only the latest version plus the latest succeeded version (if
  they are different) are kept for the time period specified by the retentionPeriod
  parameter. For more information, see Keeping Multiple Versions of IoT Analytics datasets in
  the IoT Analytics User Guide.
"""
function update_dataset(
    actions, datasetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotanalytics(
        "PUT",
        "/datasets/$(datasetName)",
        Dict{String,Any}("actions" => actions);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_dataset(
    actions,
    datasetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotanalytics(
        "PUT",
        "/datasets/$(datasetName)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("actions" => actions), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_datastore(datastore_name)
    update_datastore(datastore_name, params::Dict{String,<:Any})

Used to update the settings of a data store.

# Arguments
- `datastore_name`: The name of the data store to be updated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"datastoreStorage"`: Where data in a data store is stored.. You can choose
  serviceManagedS3 storage, customerManagedS3 storage, or iotSiteWiseMultiLayerStorage
  storage. The default is serviceManagedS3. You can't change the choice of Amazon S3 storage
  after your data store is created.
- `"fileFormatConfiguration"`: Contains the configuration information of file formats. IoT
  Analytics data stores support JSON and Parquet. The default file format is JSON. You can
  specify only one format. You can't change the file format after you create the data store.
- `"retentionPeriod"`: How long, in days, message data is kept for the data store. The
  retention period can't be updated if the data store's Amazon S3 storage is customer-managed.
"""
function update_datastore(datastoreName; aws_config::AbstractAWSConfig=current_aws_config())
    return iotanalytics(
        "PUT",
        "/datastores/$(datastoreName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_datastore(
    datastoreName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotanalytics(
        "PUT",
        "/datastores/$(datastoreName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_pipeline(pipeline_activities, pipeline_name)
    update_pipeline(pipeline_activities, pipeline_name, params::Dict{String,<:Any})

Updates the settings of a pipeline. You must specify both a channel and a datastore
activity and, optionally, as many as 23 additional activities in the pipelineActivities
array.

# Arguments
- `pipeline_activities`: A list of PipelineActivity objects. Activities perform
  transformations on your messages, such as removing, renaming or adding message attributes;
  filtering messages based on attribute values; invoking your Lambda functions on messages
  for advanced processing; or performing mathematical transformations to normalize device
  data. The list can be 2-25 PipelineActivity objects and must contain both a channel and a
  datastore activity. Each entry in the list must contain only one activity. For example:
  pipelineActivities = [ { \"channel\": { ... } }, { \"lambda\": { ... } }, ... ]
- `pipeline_name`: The name of the pipeline to update.

"""
function update_pipeline(
    pipelineActivities, pipelineName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotanalytics(
        "PUT",
        "/pipelines/$(pipelineName)",
        Dict{String,Any}("pipelineActivities" => pipelineActivities);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_pipeline(
    pipelineActivities,
    pipelineName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotanalytics(
        "PUT",
        "/pipelines/$(pipelineName)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("pipelineActivities" => pipelineActivities), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: bcm_data_exports
using AWS.Compat
using AWS.UUIDs

"""
    create_export(export)
    create_export(export, params::Dict{String,<:Any})

Creates a data export and specifies the data query, the delivery preference, and any
optional resource tags. A DataQuery consists of both a QueryStatement and
TableConfigurations. The QueryStatement is an SQL statement. Data Exports only supports a
limited subset of the SQL syntax. For more information on the SQL syntax that is supported,
see Data query. To view the available tables and columns, see the Data Exports table
dictionary. The TableConfigurations is a collection of specified TableProperties for the
table being queried in the QueryStatement. TableProperties are additional configurations
you can provide to change the data and schema of a table. Each table can have different
TableProperties. However, tables are not required to have any TableProperties. Each table
property has a default value that it assumes if not specified. For more information on
table configurations, see Data query. To view the table properties available for each
table, see the Data Exports table dictionary or use the ListTables API to get a response of
all tables and their available properties.

# Arguments
- `export`: The details of the export, including data query, name, description, and
  destination configuration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ResourceTags"`: An optional list of tags to associate with the specified export. Each
  tag consists of a key and a value, and each key must be unique for the resource.
"""
function create_export(Export; aws_config::AbstractAWSConfig=current_aws_config())
    return bcm_data_exports(
        "CreateExport",
        Dict{String,Any}("Export" => Export);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_export(
    Export, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bcm_data_exports(
        "CreateExport",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Export" => Export), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_export(export_arn)
    delete_export(export_arn, params::Dict{String,<:Any})

Deletes an existing data export.

# Arguments
- `export_arn`: The Amazon Resource Name (ARN) for this export.

"""
function delete_export(ExportArn; aws_config::AbstractAWSConfig=current_aws_config())
    return bcm_data_exports(
        "DeleteExport",
        Dict{String,Any}("ExportArn" => ExportArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_export(
    ExportArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bcm_data_exports(
        "DeleteExport",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ExportArn" => ExportArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_execution(execution_id, export_arn)
    get_execution(execution_id, export_arn, params::Dict{String,<:Any})

Exports data based on the source data update.

# Arguments
- `execution_id`: The ID for this specific execution.
- `export_arn`: The Amazon Resource Name (ARN) of the Export object that generated this
  specific execution.

"""
function get_execution(
    ExecutionId, ExportArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bcm_data_exports(
        "GetExecution",
        Dict{String,Any}("ExecutionId" => ExecutionId, "ExportArn" => ExportArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_execution(
    ExecutionId,
    ExportArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bcm_data_exports(
        "GetExecution",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ExecutionId" => ExecutionId, "ExportArn" => ExportArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_export(export_arn)
    get_export(export_arn, params::Dict{String,<:Any})

Views the definition of an existing data export.

# Arguments
- `export_arn`: The Amazon Resource Name (ARN) for this export.

"""
function get_export(ExportArn; aws_config::AbstractAWSConfig=current_aws_config())
    return bcm_data_exports(
        "GetExport",
        Dict{String,Any}("ExportArn" => ExportArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_export(
    ExportArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bcm_data_exports(
        "GetExport",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ExportArn" => ExportArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_table(table_name)
    get_table(table_name, params::Dict{String,<:Any})

Returns the metadata for the specified table and table properties. This includes the list
of columns in the table schema, their data types, and column descriptions.

# Arguments
- `table_name`: The name of the table.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"TableProperties"`: TableProperties are additional configurations you can provide to
  change the data and schema of a table. Each table can have different TableProperties.
  Tables are not required to have any TableProperties. Each table property has a default
  value that it assumes if not specified.
"""
function get_table(TableName; aws_config::AbstractAWSConfig=current_aws_config())
    return bcm_data_exports(
        "GetTable",
        Dict{String,Any}("TableName" => TableName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_table(
    TableName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bcm_data_exports(
        "GetTable",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TableName" => TableName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_executions(export_arn)
    list_executions(export_arn, params::Dict{String,<:Any})

Lists the historical executions for the export.

# Arguments
- `export_arn`: The Amazon Resource Name (ARN) for this export.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of objects that are returned for the request.
- `"NextToken"`: The token to retrieve the next set of results.
"""
function list_executions(ExportArn; aws_config::AbstractAWSConfig=current_aws_config())
    return bcm_data_exports(
        "ListExecutions",
        Dict{String,Any}("ExportArn" => ExportArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_executions(
    ExportArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bcm_data_exports(
        "ListExecutions",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ExportArn" => ExportArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_exports()
    list_exports(params::Dict{String,<:Any})

Lists all data export definitions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of objects that are returned for the request.
- `"NextToken"`: The token to retrieve the next set of results.
"""
function list_exports(; aws_config::AbstractAWSConfig=current_aws_config())
    return bcm_data_exports(
        "ListExports"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_exports(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bcm_data_exports(
        "ListExports", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tables()
    list_tables(params::Dict{String,<:Any})

Lists all available tables in data exports.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of objects that are returned for the request.
- `"NextToken"`: The token to retrieve the next set of results.
"""
function list_tables(; aws_config::AbstractAWSConfig=current_aws_config())
    return bcm_data_exports(
        "ListTables"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_tables(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bcm_data_exports(
        "ListTables", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

List tags associated with an existing data export.

# Arguments
- `resource_arn`: The unique identifier for the resource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of objects that are returned for the request.
- `"NextToken"`: The token to retrieve the next set of results.
"""
function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bcm_data_exports(
        "ListTagsForResource",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bcm_data_exports(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, resource_tags)
    tag_resource(resource_arn, resource_tags, params::Dict{String,<:Any})

Adds tags for an existing data export definition.

# Arguments
- `resource_arn`: The unique identifier for the resource.
- `resource_tags`: The tags to associate with the resource. Each tag consists of a key and
  a value, and each key must be unique for the resource.

"""
function tag_resource(
    ResourceArn, ResourceTags; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bcm_data_exports(
        "TagResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "ResourceTags" => ResourceTags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceArn,
    ResourceTags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bcm_data_exports(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ResourceArn" => ResourceArn, "ResourceTags" => ResourceTags
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, resource_tag_keys)
    untag_resource(resource_arn, resource_tag_keys, params::Dict{String,<:Any})

Deletes tags associated with an existing data export definition.

# Arguments
- `resource_arn`: The unique identifier for the resource.
- `resource_tag_keys`: The tag keys that are associated with the resource ARN.

"""
function untag_resource(
    ResourceArn, ResourceTagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bcm_data_exports(
        "UntagResource",
        Dict{String,Any}(
            "ResourceArn" => ResourceArn, "ResourceTagKeys" => ResourceTagKeys
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceArn,
    ResourceTagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bcm_data_exports(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ResourceArn" => ResourceArn, "ResourceTagKeys" => ResourceTagKeys
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_export(export, export_arn)
    update_export(export, export_arn, params::Dict{String,<:Any})

Updates an existing data export by overwriting all export parameters. All export parameters
must be provided in the UpdateExport request.

# Arguments
- `export`: The name and query details for the export.
- `export_arn`: The Amazon Resource Name (ARN) for this export.

"""
function update_export(
    Export, ExportArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bcm_data_exports(
        "UpdateExport",
        Dict{String,Any}("Export" => Export, "ExportArn" => ExportArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_export(
    Export,
    ExportArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bcm_data_exports(
        "UpdateExport",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Export" => Export, "ExportArn" => ExportArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: personalize_runtime
using AWS.Compat
using AWS.UUIDs

"""
    get_action_recommendations()
    get_action_recommendations(params::Dict{String,<:Any})

Returns a list of recommended actions in sorted in descending order by prediction score.
Use the GetActionRecommendations API if you have a custom campaign that deploys a solution
version trained with a PERSONALIZED_ACTIONS recipe.  For more information about
PERSONALIZED_ACTIONS recipes, see PERSONALIZED_ACTIONS recipes. For more information about
getting action recommendations, see Getting action recommendations.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"campaignArn"`: The Amazon Resource Name (ARN) of the campaign to use for getting action
  recommendations. This campaign must deploy a solution version trained with a
  PERSONALIZED_ACTIONS recipe.
- `"filterArn"`: The ARN of the filter to apply to the returned recommendations. For more
  information, see Filtering Recommendations. When using this parameter, be sure the filter
  resource is ACTIVE.
- `"filterValues"`: The values to use when filtering recommendations. For each placeholder
  parameter in your filter expression, provide the parameter name (in matching case) as a key
  and the filter value(s) as the corresponding value. Separate multiple values for one
  parameter with a comma.  For filter expressions that use an INCLUDE element to include
  actions, you must provide values for all parameters that are defined in the expression. For
  filters with expressions that use an EXCLUDE element to exclude actions, you can omit the
  filter-values. In this case, Amazon Personalize doesn't use that portion of the expression
  to filter recommendations. For more information, see Filtering recommendations and user
  segments.
- `"numResults"`: The number of results to return. The default is 5. The maximum is 100.
- `"userId"`: The user ID of the user to provide action recommendations for.
"""
function get_action_recommendations(; aws_config::AbstractAWSConfig=current_aws_config())
    return personalize_runtime(
        "POST",
        "/action-recommendations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_action_recommendations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return personalize_runtime(
        "POST",
        "/action-recommendations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_personalized_ranking(campaign_arn, input_list, user_id)
    get_personalized_ranking(campaign_arn, input_list, user_id, params::Dict{String,<:Any})

Re-ranks a list of recommended items for the given user. The first item in the list is
deemed the most likely item to be of interest to the user.  The solution backing the
campaign must have been created using a recipe of type PERSONALIZED_RANKING.

# Arguments
- `campaign_arn`: The Amazon Resource Name (ARN) of the campaign to use for generating the
  personalized ranking.
- `input_list`: A list of items (by itemId) to rank. If an item was not included in the
  training dataset, the item is appended to the end of the reranked list. If you are
  including metadata in recommendations, the maximum is 50. Otherwise, the maximum is 500.
- `user_id`: The user for which you want the campaign to provide a personalized ranking.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"context"`: The contextual metadata to use when getting recommendations. Contextual
  metadata includes any interaction information that might be relevant when getting a user's
  recommendations, such as the user's current location or device type.
- `"filterArn"`: The Amazon Resource Name (ARN) of a filter you created to include items or
  exclude items from recommendations for a given user. For more information, see Filtering
  Recommendations.
- `"filterValues"`: The values to use when filtering recommendations. For each placeholder
  parameter in your filter expression, provide the parameter name (in matching case) as a key
  and the filter value(s) as the corresponding value. Separate multiple values for one
  parameter with a comma.  For filter expressions that use an INCLUDE element to include
  items, you must provide values for all parameters that are defined in the expression. For
  filters with expressions that use an EXCLUDE element to exclude items, you can omit the
  filter-values.In this case, Amazon Personalize doesn't use that portion of the expression
  to filter recommendations. For more information, see Filtering Recommendations.
- `"metadataColumns"`: If you enabled metadata in recommendations when you created or
  updated the campaign, specify metadata columns from your Items dataset to include in the
  personalized ranking. The map key is ITEMS and the value is a list of column names from
  your Items dataset. The maximum number of columns you can provide is 10.  For information
  about enabling metadata for a campaign, see Enabling metadata in recommendations for a
  campaign.
"""
function get_personalized_ranking(
    campaignArn, inputList, userId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return personalize_runtime(
        "POST",
        "/personalize-ranking",
        Dict{String,Any}(
            "campaignArn" => campaignArn, "inputList" => inputList, "userId" => userId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_personalized_ranking(
    campaignArn,
    inputList,
    userId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return personalize_runtime(
        "POST",
        "/personalize-ranking",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "campaignArn" => campaignArn,
                    "inputList" => inputList,
                    "userId" => userId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_recommendations()
    get_recommendations(params::Dict{String,<:Any})

Returns a list of recommended items. For campaigns, the campaign's Amazon Resource Name
(ARN) is required and the required user and item input depends on the recipe type used to
create the solution backing the campaign as follows:   USER_PERSONALIZATION - userId
required, itemId not used   RELATED_ITEMS - itemId required, userId not used    Campaigns
that are backed by a solution created using a recipe of type PERSONALIZED_RANKING use the
API.   For recommenders, the recommender's ARN is required and the required item and user
input depends on the use case (domain-based recipe) backing the recommender. For
information on use case requirements see Choosing recommender use cases.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"campaignArn"`: The Amazon Resource Name (ARN) of the campaign to use for getting
  recommendations.
- `"context"`: The contextual metadata to use when getting recommendations. Contextual
  metadata includes any interaction information that might be relevant when getting a user's
  recommendations, such as the user's current location or device type.
- `"filterArn"`: The ARN of the filter to apply to the returned recommendations. For more
  information, see Filtering Recommendations. When using this parameter, be sure the filter
  resource is ACTIVE.
- `"filterValues"`: The values to use when filtering recommendations. For each placeholder
  parameter in your filter expression, provide the parameter name (in matching case) as a key
  and the filter value(s) as the corresponding value. Separate multiple values for one
  parameter with a comma.  For filter expressions that use an INCLUDE element to include
  items, you must provide values for all parameters that are defined in the expression. For
  filters with expressions that use an EXCLUDE element to exclude items, you can omit the
  filter-values.In this case, Amazon Personalize doesn't use that portion of the expression
  to filter recommendations. For more information, see Filtering recommendations and user
  segments.
- `"itemId"`: The item ID to provide recommendations for. Required for RELATED_ITEMS recipe
  type.
- `"metadataColumns"`: If you enabled metadata in recommendations when you created or
  updated the campaign or recommender, specify the metadata columns from your Items dataset
  to include in item recommendations. The map key is ITEMS and the value is a list of column
  names from your Items dataset. The maximum number of columns you can provide is 10.  For
  information about enabling metadata for a campaign, see Enabling metadata in
  recommendations for a campaign. For information about enabling metadata for a recommender,
  see Enabling metadata in recommendations for a recommender.
- `"numResults"`: The number of results to return. The default is 25. If you are including
  metadata in recommendations, the maximum is 50. Otherwise, the maximum is 500.
- `"promotions"`: The promotions to apply to the recommendation request. A promotion
  defines additional business rules that apply to a configurable subset of recommended items.
- `"recommenderArn"`: The Amazon Resource Name (ARN) of the recommender to use to get
  recommendations. Provide a recommender ARN if you created a Domain dataset group with a
  recommender for a domain use case.
- `"userId"`: The user ID to provide recommendations for. Required for USER_PERSONALIZATION
  recipe type.
"""
function get_recommendations(; aws_config::AbstractAWSConfig=current_aws_config())
    return personalize_runtime(
        "POST", "/recommendations"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_recommendations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return personalize_runtime(
        "POST",
        "/recommendations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: lambda
using AWS.Compat
using AWS.UUIDs

"""
    add_layer_version_permission(action, layer_name, principal, statement_id, version_number)
    add_layer_version_permission(action, layer_name, principal, statement_id, version_number, params::Dict{String,<:Any})

Adds permissions to the resource-based policy of a version of an Lambda layer. Use this
action to grant layer usage permission to other accounts. You can grant permission to a
single account, all accounts in an organization, or all Amazon Web Services accounts.  To
revoke permission, call RemoveLayerVersionPermission with the statement ID that you
specified when you added it.

# Arguments
- `action`: The API action that grants access to the layer. For example,
  lambda:GetLayerVersion.
- `layer_name`: The name or Amazon Resource Name (ARN) of the layer.
- `principal`: An account ID, or * to grant layer usage permission to all accounts in an
  organization, or all Amazon Web Services accounts (if organizationId is not specified). For
  the last case, make sure that you really do want all Amazon Web Services accounts to have
  usage permission to this layer.
- `statement_id`: An identifier that distinguishes the policy from others on the same layer
  version.
- `version_number`: The version number.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"OrganizationId"`: With the principal set to *, grant permission to all accounts in the
  specified organization.
- `"RevisionId"`: Only update the policy if the revision ID matches the ID specified. Use
  this option to avoid modifying a policy that has changed since you last read it.
"""
function add_layer_version_permission(
    Action,
    LayerName,
    Principal,
    StatementId,
    VersionNumber;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "POST",
        "/2018-10-31/layers/$(LayerName)/versions/$(VersionNumber)/policy",
        Dict{String,Any}(
            "Action" => Action, "Principal" => Principal, "StatementId" => StatementId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_layer_version_permission(
    Action,
    LayerName,
    Principal,
    StatementId,
    VersionNumber,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "POST",
        "/2018-10-31/layers/$(LayerName)/versions/$(VersionNumber)/policy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Action" => Action,
                    "Principal" => Principal,
                    "StatementId" => StatementId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    add_permission(action, function_name, principal, statement_id)
    add_permission(action, function_name, principal, statement_id, params::Dict{String,<:Any})

Grants an Amazon Web Service, Amazon Web Services account, or Amazon Web Services
organization permission to use a function. You can apply the policy at the function level,
or specify a qualifier to restrict access to a single version or alias. If you use a
qualifier, the invoker must use the full Amazon Resource Name (ARN) of that version or
alias to invoke the function. Note: Lambda does not support adding policies to version
LATEST. To grant permission to another account, specify the account ID as the Principal. To
grant permission to an organization defined in Organizations, specify the organization ID
as the PrincipalOrgID. For Amazon Web Services, the principal is a domain-style identifier
that the service defines, such as s3.amazonaws.com or sns.amazonaws.com. For Amazon Web
Services, you can also specify the ARN of the associated resource as the SourceArn. If you
grant permission to a service principal without specifying the source, other accounts could
potentially configure resources in their account to invoke your Lambda function. This
operation adds a statement to a resource-based permissions policy for the function. For
more information about function policies, see Using resource-based policies for Lambda.

# Arguments
- `action`: The action that the principal can use on the function. For example,
  lambda:InvokeFunction or lambda:GetFunction.
- `function_name`: The name or ARN of the Lambda function, version, or alias.  Name formats
      Function name – my-function (name-only), my-function:v1 (with alias).    Function ARN
  – arn:aws:lambda:us-west-2:123456789012:function:my-function.    Partial ARN –
  123456789012:function:my-function.   You can append a version number or alias to any of the
  formats. The length constraint applies only to the full ARN. If you specify only the
  function name, it is limited to 64 characters in length.
- `principal`: The Amazon Web Service or Amazon Web Services account that invokes the
  function. If you specify a service, use SourceArn or SourceAccount to limit who can invoke
  the function through that service.
- `statement_id`: A statement identifier that differentiates the statement from others in
  the same policy.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EventSourceToken"`: For Alexa Smart Home functions, a token that the invoker must
  supply.
- `"FunctionUrlAuthType"`: The type of authentication that your function URL uses. Set to
  AWS_IAM if you want to restrict access to authenticated users only. Set to NONE if you want
  to bypass IAM authentication to create a public endpoint. For more information, see
  Security and auth model for Lambda function URLs.
- `"PrincipalOrgID"`: The identifier for your organization in Organizations. Use this to
  grant permissions to all the Amazon Web Services accounts under this organization.
- `"Qualifier"`: Specify a version or alias to add permissions to a published version of
  the function.
- `"RevisionId"`: Update the policy only if the revision ID matches the ID that's
  specified. Use this option to avoid modifying a policy that has changed since you last read
  it.
- `"SourceAccount"`: For Amazon Web Service, the ID of the Amazon Web Services account that
  owns the resource. Use this together with SourceArn to ensure that the specified account
  owns the resource. It is possible for an Amazon S3 bucket to be deleted by its owner and
  recreated by another account.
- `"SourceArn"`: For Amazon Web Services, the ARN of the Amazon Web Services resource that
  invokes the function. For example, an Amazon S3 bucket or Amazon SNS topic. Note that
  Lambda configures the comparison using the StringLike operator.
"""
function add_permission(
    Action,
    FunctionName,
    Principal,
    StatementId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "POST",
        "/2015-03-31/functions/$(FunctionName)/policy",
        Dict{String,Any}(
            "Action" => Action, "Principal" => Principal, "StatementId" => StatementId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_permission(
    Action,
    FunctionName,
    Principal,
    StatementId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "POST",
        "/2015-03-31/functions/$(FunctionName)/policy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Action" => Action,
                    "Principal" => Principal,
                    "StatementId" => StatementId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_alias(function_name, function_version, name)
    create_alias(function_name, function_version, name, params::Dict{String,<:Any})

Creates an alias for a Lambda function version. Use aliases to provide clients with a
function identifier that you can update to invoke a different version. You can also map an
alias to split invocation requests between two versions. Use the RoutingConfig parameter to
specify a second version and the percentage of invocation requests that it receives.

# Arguments
- `function_name`: The name or ARN of the Lambda function.  Name formats     Function name
  - MyFunction.    Function ARN - arn:aws:lambda:us-west-2:123456789012:function:MyFunction.
    Partial ARN - 123456789012:function:MyFunction.   The length constraint applies only to
  the full ARN. If you specify only the function name, it is limited to 64 characters in
  length.
- `function_version`: The function version that the alias invokes.
- `name`: The name of the alias.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description of the alias.
- `"RoutingConfig"`: The routing configuration of the alias.
"""
function create_alias(
    FunctionName, FunctionVersion, Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lambda(
        "POST",
        "/2015-03-31/functions/$(FunctionName)/aliases",
        Dict{String,Any}("FunctionVersion" => FunctionVersion, "Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_alias(
    FunctionName,
    FunctionVersion,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "POST",
        "/2015-03-31/functions/$(FunctionName)/aliases",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("FunctionVersion" => FunctionVersion, "Name" => Name),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_code_signing_config(allowed_publishers)
    create_code_signing_config(allowed_publishers, params::Dict{String,<:Any})

Creates a code signing configuration. A code signing configuration defines a list of
allowed signing profiles and defines the code-signing validation policy (action to be taken
if deployment validation checks fail).

# Arguments
- `allowed_publishers`: Signing profiles for this code signing configuration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CodeSigningPolicies"`: The code signing policies define the actions to take if the
  validation checks fail.
- `"Description"`: Descriptive name for this code signing configuration.
"""
function create_code_signing_config(
    AllowedPublishers; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lambda(
        "POST",
        "/2020-04-22/code-signing-configs/",
        Dict{String,Any}("AllowedPublishers" => AllowedPublishers);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_code_signing_config(
    AllowedPublishers,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "POST",
        "/2020-04-22/code-signing-configs/",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("AllowedPublishers" => AllowedPublishers), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_event_source_mapping(function_name)
    create_event_source_mapping(function_name, params::Dict{String,<:Any})

Creates a mapping between an event source and an Lambda function. Lambda reads items from
the event source and invokes the function. For details about how to configure different
event sources, see the following topics.      Amazon DynamoDB Streams      Amazon Kinesis
   Amazon SQS      Amazon MQ and RabbitMQ      Amazon MSK      Apache Kafka      Amazon
DocumentDB    The following error handling options are available only for stream sources
(DynamoDB and Kinesis):    BisectBatchOnFunctionError – If the function returns an error,
split the batch in two and retry.    DestinationConfig – Send discarded records to an
Amazon SQS queue or Amazon SNS topic.    MaximumRecordAgeInSeconds – Discard records
older than the specified age. The default value is infinite (-1). When set to infinite
(-1), failed records are retried until the record expires    MaximumRetryAttempts –
Discard records after the specified number of retries. The default value is infinite (-1).
When set to infinite (-1), failed records are retried until the record expires.
ParallelizationFactor – Process multiple batches from each shard concurrently.   For
information about which configuration parameters apply to each event source, see the
following topics.     Amazon DynamoDB Streams      Amazon Kinesis      Amazon SQS
Amazon MQ and RabbitMQ      Amazon MSK      Apache Kafka      Amazon DocumentDB

# Arguments
- `function_name`: The name or ARN of the Lambda function.  Name formats     Function name
  – MyFunction.    Function ARN –
  arn:aws:lambda:us-west-2:123456789012:function:MyFunction.    Version or Alias ARN –
  arn:aws:lambda:us-west-2:123456789012:function:MyFunction:PROD.    Partial ARN –
  123456789012:function:MyFunction.   The length constraint applies only to the full ARN. If
  you specify only the function name, it's limited to 64 characters in length.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AmazonManagedKafkaEventSourceConfig"`: Specific configuration settings for an Amazon
  Managed Streaming for Apache Kafka (Amazon MSK) event source.
- `"BatchSize"`: The maximum number of records in each batch that Lambda pulls from your
  stream or queue and sends to your function. Lambda passes all of the records in the batch
  to the function in a single call, up to the payload limit for synchronous invocation (6
  MB).    Amazon Kinesis – Default 100. Max 10,000.    Amazon DynamoDB Streams – Default
  100. Max 10,000.    Amazon Simple Queue Service – Default 10. For standard queues the max
  is 10,000. For FIFO queues the max is 10.    Amazon Managed Streaming for Apache Kafka –
  Default 100. Max 10,000.    Self-managed Apache Kafka – Default 100. Max 10,000.
  Amazon MQ (ActiveMQ and RabbitMQ) – Default 100. Max 10,000.    DocumentDB – Default
  100. Max 10,000.
- `"BisectBatchOnFunctionError"`: (Kinesis and DynamoDB Streams only) If the function
  returns an error, split the batch in two and retry.
- `"DestinationConfig"`: (Kinesis, DynamoDB Streams, Amazon MSK, and self-managed Kafka
  only) A configuration object that specifies the destination of an event after Lambda
  processes it.
- `"DocumentDBEventSourceConfig"`: Specific configuration settings for a DocumentDB event
  source.
- `"Enabled"`: When true, the event source mapping is active. When false, Lambda pauses
  polling and invocation. Default: True
- `"EventSourceArn"`: The Amazon Resource Name (ARN) of the event source.    Amazon Kinesis
  – The ARN of the data stream or a stream consumer.    Amazon DynamoDB Streams – The ARN
  of the stream.    Amazon Simple Queue Service – The ARN of the queue.    Amazon Managed
  Streaming for Apache Kafka – The ARN of the cluster or the ARN of the VPC connection (for
  cross-account event source mappings).    Amazon MQ – The ARN of the broker.    Amazon
  DocumentDB – The ARN of the DocumentDB change stream.
- `"FilterCriteria"`: An object that defines the filter criteria that determine whether
  Lambda should process an event. For more information, see Lambda event filtering.
- `"FunctionResponseTypes"`: (Kinesis, DynamoDB Streams, and Amazon SQS) A list of current
  response type enums applied to the event source mapping.
- `"MaximumBatchingWindowInSeconds"`: The maximum amount of time, in seconds, that Lambda
  spends gathering records before invoking the function. You can configure
  MaximumBatchingWindowInSeconds to any value from 0 seconds to 300 seconds in increments of
  seconds. For streams and Amazon SQS event sources, the default batching window is 0
  seconds. For Amazon MSK, Self-managed Apache Kafka, Amazon MQ, and DocumentDB event
  sources, the default batching window is 500 ms. Note that because you can only change
  MaximumBatchingWindowInSeconds in increments of seconds, you cannot revert back to the 500
  ms default batching window after you have changed it. To restore the default batching
  window, you must create a new event source mapping. Related setting: For streams and Amazon
  SQS event sources, when you set BatchSize to a value greater than 10, you must set
  MaximumBatchingWindowInSeconds to at least 1.
- `"MaximumRecordAgeInSeconds"`: (Kinesis and DynamoDB Streams only) Discard records older
  than the specified age. The default value is infinite (-1).
- `"MaximumRetryAttempts"`: (Kinesis and DynamoDB Streams only) Discard records after the
  specified number of retries. The default value is infinite (-1). When set to infinite (-1),
  failed records are retried until the record expires.
- `"ParallelizationFactor"`: (Kinesis and DynamoDB Streams only) The number of batches to
  process from each shard concurrently.
- `"Queues"`:  (MQ) The name of the Amazon MQ broker destination queue to consume.
- `"ScalingConfig"`: (Amazon SQS only) The scaling configuration for the event source. For
  more information, see Configuring maximum concurrency for Amazon SQS event sources.
- `"SelfManagedEventSource"`: The self-managed Apache Kafka cluster to receive records from.
- `"SelfManagedKafkaEventSourceConfig"`: Specific configuration settings for a self-managed
  Apache Kafka event source.
- `"SourceAccessConfigurations"`: An array of authentication protocols or VPC components
  required to secure your event source.
- `"StartingPosition"`: The position in a stream from which to start reading. Required for
  Amazon Kinesis and Amazon DynamoDB Stream event sources. AT_TIMESTAMP is supported only for
  Amazon Kinesis streams, Amazon DocumentDB, Amazon MSK, and self-managed Apache Kafka.
- `"StartingPositionTimestamp"`: With StartingPosition set to AT_TIMESTAMP, the time from
  which to start reading. StartingPositionTimestamp cannot be in the future.
- `"Topics"`: The name of the Kafka topic.
- `"TumblingWindowInSeconds"`: (Kinesis and DynamoDB Streams only) The duration in seconds
  of a processing window for DynamoDB and Kinesis Streams event sources. A value of 0 seconds
  indicates no tumbling window.
"""
function create_event_source_mapping(
    FunctionName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lambda(
        "POST",
        "/2015-03-31/event-source-mappings/",
        Dict{String,Any}("FunctionName" => FunctionName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_event_source_mapping(
    FunctionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "POST",
        "/2015-03-31/event-source-mappings/",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("FunctionName" => FunctionName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_function(code, function_name, role)
    create_function(code, function_name, role, params::Dict{String,<:Any})

Creates a Lambda function. To create a function, you need a deployment package and an
execution role. The deployment package is a .zip file archive or container image that
contains your function code. The execution role grants the function permission to use
Amazon Web Services, such as Amazon CloudWatch Logs for log streaming and X-Ray for request
tracing. If the deployment package is a container image, then you set the package type to
Image. For a container image, the code property must include the URI of a container image
in the Amazon ECR registry. You do not need to specify the handler and runtime properties.
If the deployment package is a .zip file archive, then you set the package type to Zip. For
a .zip file archive, the code property specifies the location of the .zip file. You must
also specify the handler and runtime properties. The code in the deployment package must be
compatible with the target instruction set architecture of the function (x86-64 or arm64).
If you do not specify the architecture, then the default value is x86-64. When you create a
function, Lambda provisions an instance of the function and its supporting resources. If
your function connects to a VPC, this process can take a minute or so. During this time,
you can't invoke or modify the function. The State, StateReason, and StateReasonCode fields
in the response from GetFunctionConfiguration indicate when the function is ready to
invoke. For more information, see Lambda function states. A function has an unpublished
version, and can have published versions and aliases. The unpublished version changes when
you update your function's code and configuration. A published version is a snapshot of
your function code and configuration that can't be changed. An alias is a named resource
that maps to a version, and can be changed to map to a different version. Use the Publish
parameter to create version 1 of your function from its initial configuration. The other
parameters let you configure version-specific and function-level settings. You can modify
version-specific settings later with UpdateFunctionConfiguration. Function-level settings
apply to both the unpublished and published versions of the function, and include tags
(TagResource) and per-function concurrency limits (PutFunctionConcurrency). You can use
code signing if your deployment package is a .zip file archive. To enable code signing for
this function, specify the ARN of a code-signing configuration. When a user attempts to
deploy a code package with UpdateFunctionCode, Lambda checks that the code package has a
valid signature from a trusted publisher. The code-signing configuration includes set of
signing profiles, which define the trusted publishers for this function. If another Amazon
Web Services account or an Amazon Web Service invokes your function, use AddPermission to
grant permission by creating a resource-based Identity and Access Management (IAM) policy.
You can grant permissions at the function level, on a version, or on an alias. To invoke
your function directly, use Invoke. To invoke your function in response to events in other
Amazon Web Services, create an event source mapping (CreateEventSourceMapping), or
configure a function trigger in the other service. For more information, see Invoking
Lambda functions.

# Arguments
- `code`: The code for the function.
- `function_name`: The name or ARN of the Lambda function.  Name formats     Function name
  – my-function.    Function ARN –
  arn:aws:lambda:us-west-2:123456789012:function:my-function.    Partial ARN –
  123456789012:function:my-function.   The length constraint applies only to the full ARN. If
  you specify only the function name, it is limited to 64 characters in length.
- `role`: The Amazon Resource Name (ARN) of the function's execution role.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Architectures"`: The instruction set architecture that the function supports. Enter a
  string array with one of the valid values (arm64 or x86_64). The default value is x86_64.
- `"CodeSigningConfigArn"`: To enable code signing for this function, specify the ARN of a
  code-signing configuration. A code-signing configuration includes a set of signing
  profiles, which define the trusted publishers for this function.
- `"DeadLetterConfig"`: A dead-letter queue configuration that specifies the queue or topic
  where Lambda sends asynchronous events when they fail processing. For more information, see
  Dead-letter queues.
- `"Description"`: A description of the function.
- `"Environment"`: Environment variables that are accessible from function code during
  execution.
- `"EphemeralStorage"`: The size of the function's /tmp directory in MB. The default value
  is 512, but can be any whole number between 512 and 10,240 MB. For more information, see
  Configuring ephemeral storage (console).
- `"FileSystemConfigs"`: Connection settings for an Amazon EFS file system.
- `"Handler"`: The name of the method within your code that Lambda calls to run your
  function. Handler is required if the deployment package is a .zip file archive. The format
  includes the file name. It can also include namespaces and other qualifiers, depending on
  the runtime. For more information, see Lambda programming model.
- `"ImageConfig"`: Container image configuration values that override the values in the
  container image Dockerfile.
- `"KMSKeyArn"`: The ARN of the Key Management Service (KMS) customer managed key that's
  used to encrypt your function's environment variables. When Lambda SnapStart is activated,
  Lambda also uses this key is to encrypt your function's snapshot. If you deploy your
  function using a container image, Lambda also uses this key to encrypt your function when
  it's deployed. Note that this is not the same key that's used to protect your container
  image in the Amazon Elastic Container Registry (Amazon ECR). If you don't provide a
  customer managed key, Lambda uses a default service key.
- `"Layers"`: A list of function layers to add to the function's execution environment.
  Specify each layer by its ARN, including the version.
- `"LoggingConfig"`: The function's Amazon CloudWatch Logs configuration settings.
- `"MemorySize"`: The amount of memory available to the function at runtime. Increasing the
  function memory also increases its CPU allocation. The default value is 128 MB. The value
  can be any multiple of 1 MB.
- `"PackageType"`: The type of deployment package. Set to Image for container image and set
  to Zip for .zip file archive.
- `"Publish"`: Set to true to publish the first version of the function during creation.
- `"Runtime"`: The identifier of the function's runtime. Runtime is required if the
  deployment package is a .zip file archive. The following list includes deprecated runtimes.
  For more information, see Runtime deprecation policy.
- `"SnapStart"`: The function's SnapStart setting.
- `"Tags"`: A list of tags to apply to the function.
- `"Timeout"`: The amount of time (in seconds) that Lambda allows a function to run before
  stopping it. The default is 3 seconds. The maximum allowed value is 900 seconds. For more
  information, see Lambda execution environment.
- `"TracingConfig"`: Set Mode to Active to sample and trace a subset of incoming requests
  with X-Ray.
- `"VpcConfig"`: For network connectivity to Amazon Web Services resources in a VPC,
  specify a list of security groups and subnets in the VPC. When you connect a function to a
  VPC, it can access resources and the internet only through that VPC. For more information,
  see Configuring a Lambda function to access resources in a VPC.
"""
function create_function(
    Code, FunctionName, Role; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lambda(
        "POST",
        "/2015-03-31/functions",
        Dict{String,Any}("Code" => Code, "FunctionName" => FunctionName, "Role" => Role);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_function(
    Code,
    FunctionName,
    Role,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "POST",
        "/2015-03-31/functions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Code" => Code, "FunctionName" => FunctionName, "Role" => Role
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_function_url_config(auth_type, function_name)
    create_function_url_config(auth_type, function_name, params::Dict{String,<:Any})

Creates a Lambda function URL with the specified configuration parameters. A function URL
is a dedicated HTTP(S) endpoint that you can use to invoke your function.

# Arguments
- `auth_type`: The type of authentication that your function URL uses. Set to AWS_IAM if
  you want to restrict access to authenticated users only. Set to NONE if you want to bypass
  IAM authentication to create a public endpoint. For more information, see Security and auth
  model for Lambda function URLs.
- `function_name`: The name or ARN of the Lambda function.  Name formats     Function name
  – my-function.    Function ARN –
  arn:aws:lambda:us-west-2:123456789012:function:my-function.    Partial ARN –
  123456789012:function:my-function.   The length constraint applies only to the full ARN. If
  you specify only the function name, it is limited to 64 characters in length.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Cors"`: The cross-origin resource sharing (CORS) settings for your function URL.
- `"InvokeMode"`: Use one of the following options:    BUFFERED – This is the default
  option. Lambda invokes your function using the Invoke API operation. Invocation results are
  available when the payload is complete. The maximum payload size is 6 MB.
  RESPONSE_STREAM – Your function streams payload results as they become available. Lambda
  invokes your function using the InvokeWithResponseStream API operation. The maximum
  response payload size is 20 MB, however, you can request a quota increase.
- `"Qualifier"`: The alias name.
"""
function create_function_url_config(
    AuthType, FunctionName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lambda(
        "POST",
        "/2021-10-31/functions/$(FunctionName)/url",
        Dict{String,Any}("AuthType" => AuthType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_function_url_config(
    AuthType,
    FunctionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "POST",
        "/2021-10-31/functions/$(FunctionName)/url",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AuthType" => AuthType), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_alias(function_name, name)
    delete_alias(function_name, name, params::Dict{String,<:Any})

Deletes a Lambda function alias.

# Arguments
- `function_name`: The name or ARN of the Lambda function.  Name formats     Function name
  - MyFunction.    Function ARN - arn:aws:lambda:us-west-2:123456789012:function:MyFunction.
    Partial ARN - 123456789012:function:MyFunction.   The length constraint applies only to
  the full ARN. If you specify only the function name, it is limited to 64 characters in
  length.
- `name`: The name of the alias.

"""
function delete_alias(
    FunctionName, Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lambda(
        "DELETE",
        "/2015-03-31/functions/$(FunctionName)/aliases/$(Name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_alias(
    FunctionName,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "DELETE",
        "/2015-03-31/functions/$(FunctionName)/aliases/$(Name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_code_signing_config(code_signing_config_arn)
    delete_code_signing_config(code_signing_config_arn, params::Dict{String,<:Any})

Deletes the code signing configuration. You can delete the code signing configuration only
if no function is using it.

# Arguments
- `code_signing_config_arn`: The The Amazon Resource Name (ARN) of the code signing
  configuration.

"""
function delete_code_signing_config(
    CodeSigningConfigArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lambda(
        "DELETE",
        "/2020-04-22/code-signing-configs/$(CodeSigningConfigArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_code_signing_config(
    CodeSigningConfigArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "DELETE",
        "/2020-04-22/code-signing-configs/$(CodeSigningConfigArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_event_source_mapping(uuid)
    delete_event_source_mapping(uuid, params::Dict{String,<:Any})

Deletes an event source mapping. You can get the identifier of a mapping from the output of
ListEventSourceMappings. When you delete an event source mapping, it enters a Deleting
state and might not be completely deleted for several seconds.

# Arguments
- `uuid`: The identifier of the event source mapping.

"""
function delete_event_source_mapping(
    UUID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lambda(
        "DELETE",
        "/2015-03-31/event-source-mappings/$(UUID)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_event_source_mapping(
    UUID, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lambda(
        "DELETE",
        "/2015-03-31/event-source-mappings/$(UUID)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_function(function_name)
    delete_function(function_name, params::Dict{String,<:Any})

Deletes a Lambda function. To delete a specific function version, use the Qualifier
parameter. Otherwise, all versions and aliases are deleted. This doesn't require the user
to have explicit permissions for DeleteAlias. To delete Lambda event source mappings that
invoke a function, use DeleteEventSourceMapping. For Amazon Web Services and resources that
invoke your function directly, delete the trigger in the service where you originally
configured it.

# Arguments
- `function_name`: The name or ARN of the Lambda function or version.  Name formats
  Function name – my-function (name-only), my-function:1 (with version).    Function ARN
  – arn:aws:lambda:us-west-2:123456789012:function:my-function.    Partial ARN –
  123456789012:function:my-function.   You can append a version number or alias to any of the
  formats. The length constraint applies only to the full ARN. If you specify only the
  function name, it is limited to 64 characters in length.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Qualifier"`: Specify a version to delete. You can't delete a version that an alias
  references.
"""
function delete_function(FunctionName; aws_config::AbstractAWSConfig=current_aws_config())
    return lambda(
        "DELETE",
        "/2015-03-31/functions/$(FunctionName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_function(
    FunctionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "DELETE",
        "/2015-03-31/functions/$(FunctionName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_function_code_signing_config(function_name)
    delete_function_code_signing_config(function_name, params::Dict{String,<:Any})

Removes the code signing configuration from the function.

# Arguments
- `function_name`: The name or ARN of the Lambda function.  Name formats     Function name
  - MyFunction.    Function ARN - arn:aws:lambda:us-west-2:123456789012:function:MyFunction.
    Partial ARN - 123456789012:function:MyFunction.   The length constraint applies only to
  the full ARN. If you specify only the function name, it is limited to 64 characters in
  length.

"""
function delete_function_code_signing_config(
    FunctionName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lambda(
        "DELETE",
        "/2020-06-30/functions/$(FunctionName)/code-signing-config";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_function_code_signing_config(
    FunctionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "DELETE",
        "/2020-06-30/functions/$(FunctionName)/code-signing-config",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_function_concurrency(function_name)
    delete_function_concurrency(function_name, params::Dict{String,<:Any})

Removes a concurrent execution limit from a function.

# Arguments
- `function_name`: The name or ARN of the Lambda function.  Name formats     Function name
  – my-function.    Function ARN –
  arn:aws:lambda:us-west-2:123456789012:function:my-function.    Partial ARN –
  123456789012:function:my-function.   The length constraint applies only to the full ARN. If
  you specify only the function name, it is limited to 64 characters in length.

"""
function delete_function_concurrency(
    FunctionName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lambda(
        "DELETE",
        "/2017-10-31/functions/$(FunctionName)/concurrency";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_function_concurrency(
    FunctionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "DELETE",
        "/2017-10-31/functions/$(FunctionName)/concurrency",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_function_event_invoke_config(function_name)
    delete_function_event_invoke_config(function_name, params::Dict{String,<:Any})

Deletes the configuration for asynchronous invocation for a function, version, or alias. To
configure options for asynchronous invocation, use PutFunctionEventInvokeConfig.

# Arguments
- `function_name`: The name or ARN of the Lambda function, version, or alias.  Name formats
      Function name - my-function (name-only), my-function:v1 (with alias).    Function ARN -
  arn:aws:lambda:us-west-2:123456789012:function:my-function.    Partial ARN -
  123456789012:function:my-function.   You can append a version number or alias to any of the
  formats. The length constraint applies only to the full ARN. If you specify only the
  function name, it is limited to 64 characters in length.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Qualifier"`: A version number or alias name.
"""
function delete_function_event_invoke_config(
    FunctionName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lambda(
        "DELETE",
        "/2019-09-25/functions/$(FunctionName)/event-invoke-config";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_function_event_invoke_config(
    FunctionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "DELETE",
        "/2019-09-25/functions/$(FunctionName)/event-invoke-config",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_function_url_config(function_name)
    delete_function_url_config(function_name, params::Dict{String,<:Any})

Deletes a Lambda function URL. When you delete a function URL, you can't recover it.
Creating a new function URL results in a different URL address.

# Arguments
- `function_name`: The name or ARN of the Lambda function.  Name formats     Function name
  – my-function.    Function ARN –
  arn:aws:lambda:us-west-2:123456789012:function:my-function.    Partial ARN –
  123456789012:function:my-function.   The length constraint applies only to the full ARN. If
  you specify only the function name, it is limited to 64 characters in length.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Qualifier"`: The alias name.
"""
function delete_function_url_config(
    FunctionName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lambda(
        "DELETE",
        "/2021-10-31/functions/$(FunctionName)/url";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_function_url_config(
    FunctionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "DELETE",
        "/2021-10-31/functions/$(FunctionName)/url",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_layer_version(layer_name, version_number)
    delete_layer_version(layer_name, version_number, params::Dict{String,<:Any})

Deletes a version of an Lambda layer. Deleted versions can no longer be viewed or added to
functions. To avoid breaking functions, a copy of the version remains in Lambda until no
functions refer to it.

# Arguments
- `layer_name`: The name or Amazon Resource Name (ARN) of the layer.
- `version_number`: The version number.

"""
function delete_layer_version(
    LayerName, VersionNumber; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lambda(
        "DELETE",
        "/2018-10-31/layers/$(LayerName)/versions/$(VersionNumber)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_layer_version(
    LayerName,
    VersionNumber,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "DELETE",
        "/2018-10-31/layers/$(LayerName)/versions/$(VersionNumber)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_provisioned_concurrency_config(function_name, qualifier)
    delete_provisioned_concurrency_config(function_name, qualifier, params::Dict{String,<:Any})

Deletes the provisioned concurrency configuration for a function.

# Arguments
- `function_name`: The name or ARN of the Lambda function.  Name formats     Function name
  – my-function.    Function ARN –
  arn:aws:lambda:us-west-2:123456789012:function:my-function.    Partial ARN –
  123456789012:function:my-function.   The length constraint applies only to the full ARN. If
  you specify only the function name, it is limited to 64 characters in length.
- `qualifier`: The version number or alias name.

"""
function delete_provisioned_concurrency_config(
    FunctionName, Qualifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lambda(
        "DELETE",
        "/2019-09-30/functions/$(FunctionName)/provisioned-concurrency",
        Dict{String,Any}("Qualifier" => Qualifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_provisioned_concurrency_config(
    FunctionName,
    Qualifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "DELETE",
        "/2019-09-30/functions/$(FunctionName)/provisioned-concurrency",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Qualifier" => Qualifier), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_account_settings()
    get_account_settings(params::Dict{String,<:Any})

Retrieves details about your account's limits and usage in an Amazon Web Services Region.

"""
function get_account_settings(; aws_config::AbstractAWSConfig=current_aws_config())
    return lambda(
        "GET",
        "/2016-08-19/account-settings/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_account_settings(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lambda(
        "GET",
        "/2016-08-19/account-settings/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_alias(function_name, name)
    get_alias(function_name, name, params::Dict{String,<:Any})

Returns details about a Lambda function alias.

# Arguments
- `function_name`: The name or ARN of the Lambda function.  Name formats     Function name
  - MyFunction.    Function ARN - arn:aws:lambda:us-west-2:123456789012:function:MyFunction.
    Partial ARN - 123456789012:function:MyFunction.   The length constraint applies only to
  the full ARN. If you specify only the function name, it is limited to 64 characters in
  length.
- `name`: The name of the alias.

"""
function get_alias(FunctionName, Name; aws_config::AbstractAWSConfig=current_aws_config())
    return lambda(
        "GET",
        "/2015-03-31/functions/$(FunctionName)/aliases/$(Name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_alias(
    FunctionName,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "GET",
        "/2015-03-31/functions/$(FunctionName)/aliases/$(Name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_code_signing_config(code_signing_config_arn)
    get_code_signing_config(code_signing_config_arn, params::Dict{String,<:Any})

Returns information about the specified code signing configuration.

# Arguments
- `code_signing_config_arn`: The The Amazon Resource Name (ARN) of the code signing
  configuration.

"""
function get_code_signing_config(
    CodeSigningConfigArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lambda(
        "GET",
        "/2020-04-22/code-signing-configs/$(CodeSigningConfigArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_code_signing_config(
    CodeSigningConfigArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "GET",
        "/2020-04-22/code-signing-configs/$(CodeSigningConfigArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_event_source_mapping(uuid)
    get_event_source_mapping(uuid, params::Dict{String,<:Any})

Returns details about an event source mapping. You can get the identifier of a mapping from
the output of ListEventSourceMappings.

# Arguments
- `uuid`: The identifier of the event source mapping.

"""
function get_event_source_mapping(UUID; aws_config::AbstractAWSConfig=current_aws_config())
    return lambda(
        "GET",
        "/2015-03-31/event-source-mappings/$(UUID)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_event_source_mapping(
    UUID, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lambda(
        "GET",
        "/2015-03-31/event-source-mappings/$(UUID)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_function(function_name)
    get_function(function_name, params::Dict{String,<:Any})

Returns information about the function or function version, with a link to download the
deployment package that's valid for 10 minutes. If you specify a function version, only
details that are specific to that version are returned.

# Arguments
- `function_name`: The name or ARN of the Lambda function, version, or alias.  Name formats
      Function name – my-function (name-only), my-function:v1 (with alias).    Function ARN
  – arn:aws:lambda:us-west-2:123456789012:function:my-function.    Partial ARN –
  123456789012:function:my-function.   You can append a version number or alias to any of the
  formats. The length constraint applies only to the full ARN. If you specify only the
  function name, it is limited to 64 characters in length.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Qualifier"`: Specify a version or alias to get details about a published version of the
  function.
"""
function get_function(FunctionName; aws_config::AbstractAWSConfig=current_aws_config())
    return lambda(
        "GET",
        "/2015-03-31/functions/$(FunctionName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_function(
    FunctionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "GET",
        "/2015-03-31/functions/$(FunctionName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_function_code_signing_config(function_name)
    get_function_code_signing_config(function_name, params::Dict{String,<:Any})

Returns the code signing configuration for the specified function.

# Arguments
- `function_name`: The name or ARN of the Lambda function.  Name formats     Function name
  - MyFunction.    Function ARN - arn:aws:lambda:us-west-2:123456789012:function:MyFunction.
    Partial ARN - 123456789012:function:MyFunction.   The length constraint applies only to
  the full ARN. If you specify only the function name, it is limited to 64 characters in
  length.

"""
function get_function_code_signing_config(
    FunctionName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lambda(
        "GET",
        "/2020-06-30/functions/$(FunctionName)/code-signing-config";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_function_code_signing_config(
    FunctionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "GET",
        "/2020-06-30/functions/$(FunctionName)/code-signing-config",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_function_concurrency(function_name)
    get_function_concurrency(function_name, params::Dict{String,<:Any})

Returns details about the reserved concurrency configuration for a function. To set a
concurrency limit for a function, use PutFunctionConcurrency.

# Arguments
- `function_name`: The name or ARN of the Lambda function.  Name formats     Function name
  – my-function.    Function ARN –
  arn:aws:lambda:us-west-2:123456789012:function:my-function.    Partial ARN –
  123456789012:function:my-function.   The length constraint applies only to the full ARN. If
  you specify only the function name, it is limited to 64 characters in length.

"""
function get_function_concurrency(
    FunctionName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lambda(
        "GET",
        "/2019-09-30/functions/$(FunctionName)/concurrency";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_function_concurrency(
    FunctionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "GET",
        "/2019-09-30/functions/$(FunctionName)/concurrency",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_function_configuration(function_name)
    get_function_configuration(function_name, params::Dict{String,<:Any})

Returns the version-specific settings of a Lambda function or version. The output includes
only options that can vary between versions of a function. To modify these settings, use
UpdateFunctionConfiguration. To get all of a function's details, including function-level
settings, use GetFunction.

# Arguments
- `function_name`: The name or ARN of the Lambda function, version, or alias.  Name formats
      Function name – my-function (name-only), my-function:v1 (with alias).    Function ARN
  – arn:aws:lambda:us-west-2:123456789012:function:my-function.    Partial ARN –
  123456789012:function:my-function.   You can append a version number or alias to any of the
  formats. The length constraint applies only to the full ARN. If you specify only the
  function name, it is limited to 64 characters in length.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Qualifier"`: Specify a version or alias to get details about a published version of the
  function.
"""
function get_function_configuration(
    FunctionName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lambda(
        "GET",
        "/2015-03-31/functions/$(FunctionName)/configuration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_function_configuration(
    FunctionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "GET",
        "/2015-03-31/functions/$(FunctionName)/configuration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_function_event_invoke_config(function_name)
    get_function_event_invoke_config(function_name, params::Dict{String,<:Any})

Retrieves the configuration for asynchronous invocation for a function, version, or alias.
To configure options for asynchronous invocation, use PutFunctionEventInvokeConfig.

# Arguments
- `function_name`: The name or ARN of the Lambda function, version, or alias.  Name formats
      Function name - my-function (name-only), my-function:v1 (with alias).    Function ARN -
  arn:aws:lambda:us-west-2:123456789012:function:my-function.    Partial ARN -
  123456789012:function:my-function.   You can append a version number or alias to any of the
  formats. The length constraint applies only to the full ARN. If you specify only the
  function name, it is limited to 64 characters in length.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Qualifier"`: A version number or alias name.
"""
function get_function_event_invoke_config(
    FunctionName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lambda(
        "GET",
        "/2019-09-25/functions/$(FunctionName)/event-invoke-config";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_function_event_invoke_config(
    FunctionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "GET",
        "/2019-09-25/functions/$(FunctionName)/event-invoke-config",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_function_url_config(function_name)
    get_function_url_config(function_name, params::Dict{String,<:Any})

Returns details about a Lambda function URL.

# Arguments
- `function_name`: The name or ARN of the Lambda function.  Name formats     Function name
  – my-function.    Function ARN –
  arn:aws:lambda:us-west-2:123456789012:function:my-function.    Partial ARN –
  123456789012:function:my-function.   The length constraint applies only to the full ARN. If
  you specify only the function name, it is limited to 64 characters in length.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Qualifier"`: The alias name.
"""
function get_function_url_config(
    FunctionName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lambda(
        "GET",
        "/2021-10-31/functions/$(FunctionName)/url";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_function_url_config(
    FunctionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "GET",
        "/2021-10-31/functions/$(FunctionName)/url",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_layer_version(layer_name, version_number)
    get_layer_version(layer_name, version_number, params::Dict{String,<:Any})

Returns information about a version of an Lambda layer, with a link to download the layer
archive that's valid for 10 minutes.

# Arguments
- `layer_name`: The name or Amazon Resource Name (ARN) of the layer.
- `version_number`: The version number.

"""
function get_layer_version(
    LayerName, VersionNumber; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lambda(
        "GET",
        "/2018-10-31/layers/$(LayerName)/versions/$(VersionNumber)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_layer_version(
    LayerName,
    VersionNumber,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "GET",
        "/2018-10-31/layers/$(LayerName)/versions/$(VersionNumber)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_layer_version_by_arn(arn)
    get_layer_version_by_arn(arn, params::Dict{String,<:Any})

Returns information about a version of an Lambda layer, with a link to download the layer
archive that's valid for 10 minutes.

# Arguments
- `arn`: The ARN of the layer version.

"""
function get_layer_version_by_arn(Arn; aws_config::AbstractAWSConfig=current_aws_config())
    return lambda(
        "GET",
        "/2018-10-31/layers?find=LayerVersion",
        Dict{String,Any}("Arn" => Arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_layer_version_by_arn(
    Arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lambda(
        "GET",
        "/2018-10-31/layers?find=LayerVersion",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Arn" => Arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_layer_version_policy(layer_name, version_number)
    get_layer_version_policy(layer_name, version_number, params::Dict{String,<:Any})

Returns the permission policy for a version of an Lambda layer. For more information, see
AddLayerVersionPermission.

# Arguments
- `layer_name`: The name or Amazon Resource Name (ARN) of the layer.
- `version_number`: The version number.

"""
function get_layer_version_policy(
    LayerName, VersionNumber; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lambda(
        "GET",
        "/2018-10-31/layers/$(LayerName)/versions/$(VersionNumber)/policy";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_layer_version_policy(
    LayerName,
    VersionNumber,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "GET",
        "/2018-10-31/layers/$(LayerName)/versions/$(VersionNumber)/policy",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_policy(function_name)
    get_policy(function_name, params::Dict{String,<:Any})

Returns the resource-based IAM policy for a function, version, or alias.

# Arguments
- `function_name`: The name or ARN of the Lambda function, version, or alias.  Name formats
      Function name – my-function (name-only), my-function:v1 (with alias).    Function ARN
  – arn:aws:lambda:us-west-2:123456789012:function:my-function.    Partial ARN –
  123456789012:function:my-function.   You can append a version number or alias to any of the
  formats. The length constraint applies only to the full ARN. If you specify only the
  function name, it is limited to 64 characters in length.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Qualifier"`: Specify a version or alias to get the policy for that resource.
"""
function get_policy(FunctionName; aws_config::AbstractAWSConfig=current_aws_config())
    return lambda(
        "GET",
        "/2015-03-31/functions/$(FunctionName)/policy";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_policy(
    FunctionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "GET",
        "/2015-03-31/functions/$(FunctionName)/policy",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_provisioned_concurrency_config(function_name, qualifier)
    get_provisioned_concurrency_config(function_name, qualifier, params::Dict{String,<:Any})

Retrieves the provisioned concurrency configuration for a function's alias or version.

# Arguments
- `function_name`: The name or ARN of the Lambda function.  Name formats     Function name
  – my-function.    Function ARN –
  arn:aws:lambda:us-west-2:123456789012:function:my-function.    Partial ARN –
  123456789012:function:my-function.   The length constraint applies only to the full ARN. If
  you specify only the function name, it is limited to 64 characters in length.
- `qualifier`: The version number or alias name.

"""
function get_provisioned_concurrency_config(
    FunctionName, Qualifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lambda(
        "GET",
        "/2019-09-30/functions/$(FunctionName)/provisioned-concurrency",
        Dict{String,Any}("Qualifier" => Qualifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_provisioned_concurrency_config(
    FunctionName,
    Qualifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "GET",
        "/2019-09-30/functions/$(FunctionName)/provisioned-concurrency",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Qualifier" => Qualifier), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_runtime_management_config(function_name)
    get_runtime_management_config(function_name, params::Dict{String,<:Any})

Retrieves the runtime management configuration for a function's version. If the runtime
update mode is Manual, this includes the ARN of the runtime version and the runtime update
mode. If the runtime update mode is Auto or Function update, this includes the runtime
update mode and null is returned for the ARN. For more information, see Runtime updates.

# Arguments
- `function_name`: The name or ARN of the Lambda function.  Name formats     Function name
  – my-function.    Function ARN –
  arn:aws:lambda:us-west-2:123456789012:function:my-function.    Partial ARN –
  123456789012:function:my-function.   The length constraint applies only to the full ARN. If
  you specify only the function name, it is limited to 64 characters in length.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Qualifier"`: Specify a version of the function. This can be LATEST or a published
  version number. If no value is specified, the configuration for the LATEST version is
  returned.
"""
function get_runtime_management_config(
    FunctionName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lambda(
        "GET",
        "/2021-07-20/functions/$(FunctionName)/runtime-management-config";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_runtime_management_config(
    FunctionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "GET",
        "/2021-07-20/functions/$(FunctionName)/runtime-management-config",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    invoke(function_name)
    invoke(function_name, params::Dict{String,<:Any})

Invokes a Lambda function. You can invoke a function synchronously (and wait for the
response), or asynchronously. By default, Lambda invokes your function synchronously (i.e.
theInvocationType is RequestResponse). To invoke a function asynchronously, set
InvocationType to Event. Lambda passes the ClientContext object to your function for
synchronous invocations only. For synchronous invocation, details about the function
response, including errors, are included in the response body and headers. For either
invocation type, you can find more information in the execution log and trace. When an
error occurs, your function may be invoked multiple times. Retry behavior varies by error
type, client, event source, and invocation type. For example, if you invoke a function
asynchronously and it returns an error, Lambda executes the function up to two more times.
For more information, see Error handling and automatic retries in Lambda. For asynchronous
invocation, Lambda adds events to a queue before sending them to your function. If your
function does not have enough capacity to keep up with the queue, events may be lost.
Occasionally, your function may receive the same event multiple times, even if no error
occurs. To retain events that were not processed, configure your function with a
dead-letter queue. The status code in the API response doesn't reflect function errors.
Error codes are reserved for errors that prevent your function from executing, such as
permissions errors, quota errors, or issues with your function's code and configuration.
For example, Lambda returns TooManyRequestsException if running the function would cause
you to exceed a concurrency limit at either the account level
(ConcurrentInvocationLimitExceeded) or function level
(ReservedFunctionConcurrentInvocationLimitExceeded). For functions with a long timeout,
your client might disconnect during synchronous invocation while it waits for a response.
Configure your HTTP client, SDK, firewall, proxy, or operating system to allow for long
connections with timeout or keep-alive settings. This operation requires permission for the
lambda:InvokeFunction action. For details on how to set up permissions for cross-account
invocations, see Granting function access to other accounts.

# Arguments
- `function_name`: The name or ARN of the Lambda function, version, or alias.  Name formats
      Function name – my-function (name-only), my-function:v1 (with alias).    Function ARN
  – arn:aws:lambda:us-west-2:123456789012:function:my-function.    Partial ARN –
  123456789012:function:my-function.   You can append a version number or alias to any of the
  formats. The length constraint applies only to the full ARN. If you specify only the
  function name, it is limited to 64 characters in length.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Payload"`: The JSON that you want to provide to your Lambda function as input. You can
  enter the JSON directly. For example, --payload '{ \"key\": \"value\" }'. You can also
  specify a file path. For example, --payload file://payload.json.
- `"Qualifier"`: Specify a version or alias to invoke a published version of the function.
- `"X-Amz-Client-Context"`: Up to 3,583 bytes of base64-encoded data about the invoking
  client to pass to the function in the context object. Lambda passes the ClientContext
  object to your function for synchronous invocations only.
- `"X-Amz-Invocation-Type"`: Choose from the following options.    RequestResponse
  (default) – Invoke the function synchronously. Keep the connection open until the
  function returns a response or times out. The API response includes the function response
  and additional data.    Event – Invoke the function asynchronously. Send events that fail
  multiple times to the function's dead-letter queue (if one is configured). The API response
  only includes a status code.    DryRun – Validate parameter values and verify that the
  user or role has permission to invoke the function.
- `"X-Amz-Log-Type"`: Set to Tail to include the execution log in the response. Applies to
  synchronously invoked functions only.
"""
function invoke(FunctionName; aws_config::AbstractAWSConfig=current_aws_config())
    return lambda(
        "POST",
        "/2015-03-31/functions/$(FunctionName)/invocations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function invoke(
    FunctionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "POST",
        "/2015-03-31/functions/$(FunctionName)/invocations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    invoke_async(function_name, invoke_args)
    invoke_async(function_name, invoke_args, params::Dict{String,<:Any})

 For asynchronous function invocation, use Invoke.  Invokes a function asynchronously.  If
you do use the InvokeAsync action, note that it doesn't support the use of X-Ray active
tracing. Trace ID is not propagated to the function, even if X-Ray active tracing is turned
on.

# Arguments
- `function_name`: The name or ARN of the Lambda function.  Name formats     Function name
  – my-function.    Function ARN –
  arn:aws:lambda:us-west-2:123456789012:function:my-function.    Partial ARN –
  123456789012:function:my-function.   The length constraint applies only to the full ARN. If
  you specify only the function name, it is limited to 64 characters in length.
- `invoke_args`: The JSON that you want to provide to your Lambda function as input.

"""
function invoke_async(
    FunctionName, InvokeArgs; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lambda(
        "POST",
        "/2014-11-13/functions/$(FunctionName)/invoke-async/",
        Dict{String,Any}("InvokeArgs" => InvokeArgs);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function invoke_async(
    FunctionName,
    InvokeArgs,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "POST",
        "/2014-11-13/functions/$(FunctionName)/invoke-async/",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("InvokeArgs" => InvokeArgs), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    invoke_with_response_stream(function_name)
    invoke_with_response_stream(function_name, params::Dict{String,<:Any})

Configure your Lambda functions to stream response payloads back to clients. For more
information, see Configuring a Lambda function to stream responses. This operation requires
permission for the lambda:InvokeFunction action. For details on how to set up permissions
for cross-account invocations, see Granting function access to other accounts.

# Arguments
- `function_name`: The name or ARN of the Lambda function.  Name formats     Function name
  – my-function.    Function ARN –
  arn:aws:lambda:us-west-2:123456789012:function:my-function.    Partial ARN –
  123456789012:function:my-function.   The length constraint applies only to the full ARN. If
  you specify only the function name, it is limited to 64 characters in length.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Payload"`: The JSON that you want to provide to your Lambda function as input. You can
  enter the JSON directly. For example, --payload '{ \"key\": \"value\" }'. You can also
  specify a file path. For example, --payload file://payload.json.
- `"Qualifier"`: The alias name.
- `"X-Amz-Client-Context"`: Up to 3,583 bytes of base64-encoded data about the invoking
  client to pass to the function in the context object.
- `"X-Amz-Invocation-Type"`: Use one of the following options:    RequestResponse (default)
  – Invoke the function synchronously. Keep the connection open until the function returns
  a response or times out. The API operation response includes the function response and
  additional data.    DryRun – Validate parameter values and verify that the IAM user or
  role has permission to invoke the function.
- `"X-Amz-Log-Type"`: Set to Tail to include the execution log in the response. Applies to
  synchronously invoked functions only.
"""
function invoke_with_response_stream(
    FunctionName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lambda(
        "POST",
        "/2021-11-15/functions/$(FunctionName)/response-streaming-invocations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function invoke_with_response_stream(
    FunctionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "POST",
        "/2021-11-15/functions/$(FunctionName)/response-streaming-invocations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_aliases(function_name)
    list_aliases(function_name, params::Dict{String,<:Any})

Returns a list of aliases for a Lambda function.

# Arguments
- `function_name`: The name or ARN of the Lambda function.  Name formats     Function name
  - MyFunction.    Function ARN - arn:aws:lambda:us-west-2:123456789012:function:MyFunction.
    Partial ARN - 123456789012:function:MyFunction.   The length constraint applies only to
  the full ARN. If you specify only the function name, it is limited to 64 characters in
  length.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FunctionVersion"`: Specify a function version to only list aliases that invoke that
  version.
- `"Marker"`: Specify the pagination token that's returned by a previous request to
  retrieve the next page of results.
- `"MaxItems"`: Limit the number of aliases returned.
"""
function list_aliases(FunctionName; aws_config::AbstractAWSConfig=current_aws_config())
    return lambda(
        "GET",
        "/2015-03-31/functions/$(FunctionName)/aliases";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_aliases(
    FunctionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "GET",
        "/2015-03-31/functions/$(FunctionName)/aliases",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_code_signing_configs()
    list_code_signing_configs(params::Dict{String,<:Any})

Returns a list of code signing configurations. A request returns up to 10,000
configurations per call. You can use the MaxItems parameter to return fewer configurations
per call.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Marker"`: Specify the pagination token that's returned by a previous request to
  retrieve the next page of results.
- `"MaxItems"`: Maximum number of items to return.
"""
function list_code_signing_configs(; aws_config::AbstractAWSConfig=current_aws_config())
    return lambda(
        "GET",
        "/2020-04-22/code-signing-configs/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_code_signing_configs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lambda(
        "GET",
        "/2020-04-22/code-signing-configs/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_event_source_mappings()
    list_event_source_mappings(params::Dict{String,<:Any})

Lists event source mappings. Specify an EventSourceArn to show only event source mappings
for a single event source.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EventSourceArn"`: The Amazon Resource Name (ARN) of the event source.    Amazon Kinesis
  – The ARN of the data stream or a stream consumer.    Amazon DynamoDB Streams – The ARN
  of the stream.    Amazon Simple Queue Service – The ARN of the queue.    Amazon Managed
  Streaming for Apache Kafka – The ARN of the cluster or the ARN of the VPC connection (for
  cross-account event source mappings).    Amazon MQ – The ARN of the broker.    Amazon
  DocumentDB – The ARN of the DocumentDB change stream.
- `"FunctionName"`: The name or ARN of the Lambda function.  Name formats     Function name
  – MyFunction.    Function ARN –
  arn:aws:lambda:us-west-2:123456789012:function:MyFunction.    Version or Alias ARN –
  arn:aws:lambda:us-west-2:123456789012:function:MyFunction:PROD.    Partial ARN –
  123456789012:function:MyFunction.   The length constraint applies only to the full ARN. If
  you specify only the function name, it's limited to 64 characters in length.
- `"Marker"`: A pagination token returned by a previous call.
- `"MaxItems"`: The maximum number of event source mappings to return. Note that
  ListEventSourceMappings returns a maximum of 100 items in each response, even if you set
  the number higher.
"""
function list_event_source_mappings(; aws_config::AbstractAWSConfig=current_aws_config())
    return lambda(
        "GET",
        "/2015-03-31/event-source-mappings/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_event_source_mappings(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lambda(
        "GET",
        "/2015-03-31/event-source-mappings/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_function_event_invoke_configs(function_name)
    list_function_event_invoke_configs(function_name, params::Dict{String,<:Any})

Retrieves a list of configurations for asynchronous invocation for a function. To configure
options for asynchronous invocation, use PutFunctionEventInvokeConfig.

# Arguments
- `function_name`: The name or ARN of the Lambda function.  Name formats     Function name
  - my-function.    Function ARN -
  arn:aws:lambda:us-west-2:123456789012:function:my-function.    Partial ARN -
  123456789012:function:my-function.   The length constraint applies only to the full ARN. If
  you specify only the function name, it is limited to 64 characters in length.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Marker"`: Specify the pagination token that's returned by a previous request to
  retrieve the next page of results.
- `"MaxItems"`: The maximum number of configurations to return.
"""
function list_function_event_invoke_configs(
    FunctionName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lambda(
        "GET",
        "/2019-09-25/functions/$(FunctionName)/event-invoke-config/list";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_function_event_invoke_configs(
    FunctionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "GET",
        "/2019-09-25/functions/$(FunctionName)/event-invoke-config/list",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_function_url_configs(function_name)
    list_function_url_configs(function_name, params::Dict{String,<:Any})

Returns a list of Lambda function URLs for the specified function.

# Arguments
- `function_name`: The name or ARN of the Lambda function.  Name formats     Function name
  – my-function.    Function ARN –
  arn:aws:lambda:us-west-2:123456789012:function:my-function.    Partial ARN –
  123456789012:function:my-function.   The length constraint applies only to the full ARN. If
  you specify only the function name, it is limited to 64 characters in length.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Marker"`: Specify the pagination token that's returned by a previous request to
  retrieve the next page of results.
- `"MaxItems"`: The maximum number of function URLs to return in the response. Note that
  ListFunctionUrlConfigs returns a maximum of 50 items in each response, even if you set the
  number higher.
"""
function list_function_url_configs(
    FunctionName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lambda(
        "GET",
        "/2021-10-31/functions/$(FunctionName)/urls";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_function_url_configs(
    FunctionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "GET",
        "/2021-10-31/functions/$(FunctionName)/urls",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_functions()
    list_functions(params::Dict{String,<:Any})

Returns a list of Lambda functions, with the version-specific configuration of each. Lambda
returns up to 50 functions per call. Set FunctionVersion to ALL to include all published
versions of each function in addition to the unpublished version.  The ListFunctions
operation returns a subset of the FunctionConfiguration fields. To get the additional
fields (State, StateReasonCode, StateReason, LastUpdateStatus, LastUpdateStatusReason,
LastUpdateStatusReasonCode, RuntimeVersionConfig) for a function or version, use
GetFunction.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FunctionVersion"`: Set to ALL to include entries for all published versions of each
  function.
- `"Marker"`: Specify the pagination token that's returned by a previous request to
  retrieve the next page of results.
- `"MasterRegion"`: For Lambda@Edge functions, the Amazon Web Services Region of the master
  function. For example, us-east-1 filters the list of functions to include only Lambda@Edge
  functions replicated from a master function in US East (N. Virginia). If specified, you
  must set FunctionVersion to ALL.
- `"MaxItems"`: The maximum number of functions to return in the response. Note that
  ListFunctions returns a maximum of 50 items in each response, even if you set the number
  higher.
"""
function list_functions(; aws_config::AbstractAWSConfig=current_aws_config())
    return lambda(
        "GET",
        "/2015-03-31/functions/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_functions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lambda(
        "GET",
        "/2015-03-31/functions/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_functions_by_code_signing_config(code_signing_config_arn)
    list_functions_by_code_signing_config(code_signing_config_arn, params::Dict{String,<:Any})

List the functions that use the specified code signing configuration. You can use this
method prior to deleting a code signing configuration, to verify that no functions are
using it.

# Arguments
- `code_signing_config_arn`: The The Amazon Resource Name (ARN) of the code signing
  configuration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Marker"`: Specify the pagination token that's returned by a previous request to
  retrieve the next page of results.
- `"MaxItems"`: Maximum number of items to return.
"""
function list_functions_by_code_signing_config(
    CodeSigningConfigArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lambda(
        "GET",
        "/2020-04-22/code-signing-configs/$(CodeSigningConfigArn)/functions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_functions_by_code_signing_config(
    CodeSigningConfigArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "GET",
        "/2020-04-22/code-signing-configs/$(CodeSigningConfigArn)/functions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_layer_versions(layer_name)
    list_layer_versions(layer_name, params::Dict{String,<:Any})

Lists the versions of an Lambda layer. Versions that have been deleted aren't listed.
Specify a runtime identifier to list only versions that indicate that they're compatible
with that runtime. Specify a compatible architecture to include only layer versions that
are compatible with that architecture.

# Arguments
- `layer_name`: The name or Amazon Resource Name (ARN) of the layer.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CompatibleArchitecture"`: The compatible instruction set architecture.
- `"CompatibleRuntime"`: A runtime identifier. For example, java21. The following list
  includes deprecated runtimes. For more information, see Runtime deprecation policy.
- `"Marker"`: A pagination token returned by a previous call.
- `"MaxItems"`: The maximum number of versions to return.
"""
function list_layer_versions(LayerName; aws_config::AbstractAWSConfig=current_aws_config())
    return lambda(
        "GET",
        "/2018-10-31/layers/$(LayerName)/versions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_layer_versions(
    LayerName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "GET",
        "/2018-10-31/layers/$(LayerName)/versions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_layers()
    list_layers(params::Dict{String,<:Any})

Lists Lambda layers and shows information about the latest version of each. Specify a
runtime identifier to list only layers that indicate that they're compatible with that
runtime. Specify a compatible architecture to include only layers that are compatible with
that instruction set architecture.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CompatibleArchitecture"`: The compatible instruction set architecture.
- `"CompatibleRuntime"`: A runtime identifier. For example, java21. The following list
  includes deprecated runtimes. For more information, see Runtime deprecation policy.
- `"Marker"`: A pagination token returned by a previous call.
- `"MaxItems"`: The maximum number of layers to return.
"""
function list_layers(; aws_config::AbstractAWSConfig=current_aws_config())
    return lambda(
        "GET", "/2018-10-31/layers"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_layers(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lambda(
        "GET",
        "/2018-10-31/layers",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_provisioned_concurrency_configs(function_name)
    list_provisioned_concurrency_configs(function_name, params::Dict{String,<:Any})

Retrieves a list of provisioned concurrency configurations for a function.

# Arguments
- `function_name`: The name or ARN of the Lambda function.  Name formats     Function name
  – my-function.    Function ARN –
  arn:aws:lambda:us-west-2:123456789012:function:my-function.    Partial ARN –
  123456789012:function:my-function.   The length constraint applies only to the full ARN. If
  you specify only the function name, it is limited to 64 characters in length.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Marker"`: Specify the pagination token that's returned by a previous request to
  retrieve the next page of results.
- `"MaxItems"`: Specify a number to limit the number of configurations returned.
"""
function list_provisioned_concurrency_configs(
    FunctionName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lambda(
        "GET",
        "/2019-09-30/functions/$(FunctionName)/provisioned-concurrency?List=ALL";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_provisioned_concurrency_configs(
    FunctionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "GET",
        "/2019-09-30/functions/$(FunctionName)/provisioned-concurrency?List=ALL",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags(arn)
    list_tags(arn, params::Dict{String,<:Any})

Returns a function's tags. You can also view tags with GetFunction.

# Arguments
- `arn`: The function's Amazon Resource Name (ARN). Note: Lambda does not support adding
  tags to aliases or versions.

"""
function list_tags(ARN; aws_config::AbstractAWSConfig=current_aws_config())
    return lambda(
        "GET",
        "/2017-03-31/tags/$(ARN)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags(
    ARN, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lambda(
        "GET",
        "/2017-03-31/tags/$(ARN)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_versions_by_function(function_name)
    list_versions_by_function(function_name, params::Dict{String,<:Any})

Returns a list of versions, with the version-specific configuration of each. Lambda returns
up to 50 versions per call.

# Arguments
- `function_name`: The name or ARN of the Lambda function.  Name formats     Function name
  - MyFunction.    Function ARN - arn:aws:lambda:us-west-2:123456789012:function:MyFunction.
    Partial ARN - 123456789012:function:MyFunction.   The length constraint applies only to
  the full ARN. If you specify only the function name, it is limited to 64 characters in
  length.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Marker"`: Specify the pagination token that's returned by a previous request to
  retrieve the next page of results.
- `"MaxItems"`: The maximum number of versions to return. Note that ListVersionsByFunction
  returns a maximum of 50 items in each response, even if you set the number higher.
"""
function list_versions_by_function(
    FunctionName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lambda(
        "GET",
        "/2015-03-31/functions/$(FunctionName)/versions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_versions_by_function(
    FunctionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "GET",
        "/2015-03-31/functions/$(FunctionName)/versions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    publish_layer_version(content, layer_name)
    publish_layer_version(content, layer_name, params::Dict{String,<:Any})

Creates an Lambda layer from a ZIP archive. Each time you call PublishLayerVersion with the
same layer name, a new version is created. Add layers to your function with CreateFunction
or UpdateFunctionConfiguration.

# Arguments
- `content`: The function layer archive.
- `layer_name`: The name or Amazon Resource Name (ARN) of the layer.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CompatibleArchitectures"`: A list of compatible instruction set architectures.
- `"CompatibleRuntimes"`: A list of compatible function runtimes. Used for filtering with
  ListLayers and ListLayerVersions. The following list includes deprecated runtimes. For more
  information, see Runtime deprecation policy.
- `"Description"`: The description of the version.
- `"LicenseInfo"`: The layer's software license. It can be any of the following:   An SPDX
  license identifier. For example, MIT.   The URL of a license hosted on the internet. For
  example, https://opensource.org/licenses/MIT.   The full text of the license.
"""
function publish_layer_version(
    Content, LayerName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lambda(
        "POST",
        "/2018-10-31/layers/$(LayerName)/versions",
        Dict{String,Any}("Content" => Content);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function publish_layer_version(
    Content,
    LayerName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "POST",
        "/2018-10-31/layers/$(LayerName)/versions",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Content" => Content), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    publish_version(function_name)
    publish_version(function_name, params::Dict{String,<:Any})

Creates a version from the current code and configuration of a function. Use versions to
create a snapshot of your function code and configuration that doesn't change. Lambda
doesn't publish a version if the function's configuration and code haven't changed since
the last version. Use UpdateFunctionCode or UpdateFunctionConfiguration to update the
function before publishing a version. Clients can invoke versions directly or with an
alias. To create an alias, use CreateAlias.

# Arguments
- `function_name`: The name or ARN of the Lambda function.  Name formats     Function name
  - MyFunction.    Function ARN - arn:aws:lambda:us-west-2:123456789012:function:MyFunction.
    Partial ARN - 123456789012:function:MyFunction.   The length constraint applies only to
  the full ARN. If you specify only the function name, it is limited to 64 characters in
  length.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CodeSha256"`: Only publish a version if the hash value matches the value that's
  specified. Use this option to avoid publishing a version if the function code has changed
  since you last updated it. You can get the hash for the version that you uploaded from the
  output of UpdateFunctionCode.
- `"Description"`: A description for the version to override the description in the
  function configuration.
- `"RevisionId"`: Only update the function if the revision ID matches the ID that's
  specified. Use this option to avoid publishing a version if the function configuration has
  changed since you last updated it.
"""
function publish_version(FunctionName; aws_config::AbstractAWSConfig=current_aws_config())
    return lambda(
        "POST",
        "/2015-03-31/functions/$(FunctionName)/versions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function publish_version(
    FunctionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "POST",
        "/2015-03-31/functions/$(FunctionName)/versions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_function_code_signing_config(code_signing_config_arn, function_name)
    put_function_code_signing_config(code_signing_config_arn, function_name, params::Dict{String,<:Any})

Update the code signing configuration for the function. Changes to the code signing
configuration take effect the next time a user tries to deploy a code package to the
function.

# Arguments
- `code_signing_config_arn`: The The Amazon Resource Name (ARN) of the code signing
  configuration.
- `function_name`: The name or ARN of the Lambda function.  Name formats     Function name
  - MyFunction.    Function ARN - arn:aws:lambda:us-west-2:123456789012:function:MyFunction.
    Partial ARN - 123456789012:function:MyFunction.   The length constraint applies only to
  the full ARN. If you specify only the function name, it is limited to 64 characters in
  length.

"""
function put_function_code_signing_config(
    CodeSigningConfigArn, FunctionName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lambda(
        "PUT",
        "/2020-06-30/functions/$(FunctionName)/code-signing-config",
        Dict{String,Any}("CodeSigningConfigArn" => CodeSigningConfigArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_function_code_signing_config(
    CodeSigningConfigArn,
    FunctionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "PUT",
        "/2020-06-30/functions/$(FunctionName)/code-signing-config",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("CodeSigningConfigArn" => CodeSigningConfigArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_function_concurrency(function_name, reserved_concurrent_executions)
    put_function_concurrency(function_name, reserved_concurrent_executions, params::Dict{String,<:Any})

Sets the maximum number of simultaneous executions for a function, and reserves capacity
for that concurrency level. Concurrency settings apply to the function as a whole,
including all published versions and the unpublished version. Reserving concurrency both
ensures that your function has capacity to process the specified number of events
simultaneously, and prevents it from scaling beyond that level. Use GetFunction to see the
current setting for a function. Use GetAccountSettings to see your Regional concurrency
limit. You can reserve concurrency for as many functions as you like, as long as you leave
at least 100 simultaneous executions unreserved for functions that aren't configured with a
per-function limit. For more information, see Lambda function scaling.

# Arguments
- `function_name`: The name or ARN of the Lambda function.  Name formats     Function name
  – my-function.    Function ARN –
  arn:aws:lambda:us-west-2:123456789012:function:my-function.    Partial ARN –
  123456789012:function:my-function.   The length constraint applies only to the full ARN. If
  you specify only the function name, it is limited to 64 characters in length.
- `reserved_concurrent_executions`: The number of simultaneous executions to reserve for
  the function.

"""
function put_function_concurrency(
    FunctionName,
    ReservedConcurrentExecutions;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "PUT",
        "/2017-10-31/functions/$(FunctionName)/concurrency",
        Dict{String,Any}("ReservedConcurrentExecutions" => ReservedConcurrentExecutions);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_function_concurrency(
    FunctionName,
    ReservedConcurrentExecutions,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "PUT",
        "/2017-10-31/functions/$(FunctionName)/concurrency",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ReservedConcurrentExecutions" => ReservedConcurrentExecutions
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_function_event_invoke_config(function_name)
    put_function_event_invoke_config(function_name, params::Dict{String,<:Any})

Configures options for asynchronous invocation on a function, version, or alias. If a
configuration already exists for a function, version, or alias, this operation overwrites
it. If you exclude any settings, they are removed. To set one option without affecting
existing settings for other options, use UpdateFunctionEventInvokeConfig. By default,
Lambda retries an asynchronous invocation twice if the function returns an error. It
retains events in a queue for up to six hours. When an event fails all processing attempts
or stays in the asynchronous invocation queue for too long, Lambda discards it. To retain
discarded events, configure a dead-letter queue with UpdateFunctionConfiguration. To send
an invocation record to a queue, topic, function, or event bus, specify a destination. You
can configure separate destinations for successful invocations (on-success) and events that
fail all processing attempts (on-failure). You can configure destinations in addition to or
instead of a dead-letter queue.

# Arguments
- `function_name`: The name or ARN of the Lambda function, version, or alias.  Name formats
      Function name - my-function (name-only), my-function:v1 (with alias).    Function ARN -
  arn:aws:lambda:us-west-2:123456789012:function:my-function.    Partial ARN -
  123456789012:function:my-function.   You can append a version number or alias to any of the
  formats. The length constraint applies only to the full ARN. If you specify only the
  function name, it is limited to 64 characters in length.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DestinationConfig"`: A destination for events after they have been sent to a function
  for processing.  Destinations     Function - The Amazon Resource Name (ARN) of a Lambda
  function.    Queue - The ARN of a standard SQS queue.    Topic - The ARN of a standard SNS
  topic.    Event Bus - The ARN of an Amazon EventBridge event bus.
- `"MaximumEventAgeInSeconds"`: The maximum age of a request that Lambda sends to a
  function for processing.
- `"MaximumRetryAttempts"`: The maximum number of times to retry when the function returns
  an error.
- `"Qualifier"`: A version number or alias name.
"""
function put_function_event_invoke_config(
    FunctionName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lambda(
        "PUT",
        "/2019-09-25/functions/$(FunctionName)/event-invoke-config";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_function_event_invoke_config(
    FunctionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "PUT",
        "/2019-09-25/functions/$(FunctionName)/event-invoke-config",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_provisioned_concurrency_config(function_name, provisioned_concurrent_executions, qualifier)
    put_provisioned_concurrency_config(function_name, provisioned_concurrent_executions, qualifier, params::Dict{String,<:Any})

Adds a provisioned concurrency configuration to a function's alias or version.

# Arguments
- `function_name`: The name or ARN of the Lambda function.  Name formats     Function name
  – my-function.    Function ARN –
  arn:aws:lambda:us-west-2:123456789012:function:my-function.    Partial ARN –
  123456789012:function:my-function.   The length constraint applies only to the full ARN. If
  you specify only the function name, it is limited to 64 characters in length.
- `provisioned_concurrent_executions`: The amount of provisioned concurrency to allocate
  for the version or alias.
- `qualifier`: The version number or alias name.

"""
function put_provisioned_concurrency_config(
    FunctionName,
    ProvisionedConcurrentExecutions,
    Qualifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "PUT",
        "/2019-09-30/functions/$(FunctionName)/provisioned-concurrency",
        Dict{String,Any}(
            "ProvisionedConcurrentExecutions" => ProvisionedConcurrentExecutions,
            "Qualifier" => Qualifier,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_provisioned_concurrency_config(
    FunctionName,
    ProvisionedConcurrentExecutions,
    Qualifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "PUT",
        "/2019-09-30/functions/$(FunctionName)/provisioned-concurrency",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ProvisionedConcurrentExecutions" => ProvisionedConcurrentExecutions,
                    "Qualifier" => Qualifier,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_runtime_management_config(function_name, update_runtime_on)
    put_runtime_management_config(function_name, update_runtime_on, params::Dict{String,<:Any})

Sets the runtime management configuration for a function's version. For more information,
see Runtime updates.

# Arguments
- `function_name`: The name or ARN of the Lambda function.  Name formats     Function name
  – my-function.    Function ARN –
  arn:aws:lambda:us-west-2:123456789012:function:my-function.    Partial ARN –
  123456789012:function:my-function.   The length constraint applies only to the full ARN. If
  you specify only the function name, it is limited to 64 characters in length.
- `update_runtime_on`: Specify the runtime update mode.    Auto (default) - Automatically
  update to the most recent and secure runtime version using a Two-phase runtime version
  rollout. This is the best choice for most customers to ensure they always benefit from
  runtime updates.    Function update - Lambda updates the runtime of your function to the
  most recent and secure runtime version when you update your function. This approach
  synchronizes runtime updates with function deployments, giving you control over when
  runtime updates are applied and allowing you to detect and mitigate rare runtime update
  incompatibilities early. When using this setting, you need to regularly update your
  functions to keep their runtime up-to-date.    Manual - You specify a runtime version in
  your function configuration. The function will use this runtime version indefinitely. In
  the rare case where a new runtime version is incompatible with an existing function, this
  allows you to roll back your function to an earlier runtime version. For more information,
  see Roll back a runtime version.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Qualifier"`: Specify a version of the function. This can be LATEST or a published
  version number. If no value is specified, the configuration for the LATEST version is
  returned.
- `"RuntimeVersionArn"`: The ARN of the runtime version you want the function to use.  This
  is only required if you're using the Manual runtime update mode.
"""
function put_runtime_management_config(
    FunctionName, UpdateRuntimeOn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lambda(
        "PUT",
        "/2021-07-20/functions/$(FunctionName)/runtime-management-config",
        Dict{String,Any}("UpdateRuntimeOn" => UpdateRuntimeOn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_runtime_management_config(
    FunctionName,
    UpdateRuntimeOn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "PUT",
        "/2021-07-20/functions/$(FunctionName)/runtime-management-config",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("UpdateRuntimeOn" => UpdateRuntimeOn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_layer_version_permission(layer_name, statement_id, version_number)
    remove_layer_version_permission(layer_name, statement_id, version_number, params::Dict{String,<:Any})

Removes a statement from the permissions policy for a version of an Lambda layer. For more
information, see AddLayerVersionPermission.

# Arguments
- `layer_name`: The name or Amazon Resource Name (ARN) of the layer.
- `statement_id`: The identifier that was specified when the statement was added.
- `version_number`: The version number.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"RevisionId"`: Only update the policy if the revision ID matches the ID specified. Use
  this option to avoid modifying a policy that has changed since you last read it.
"""
function remove_layer_version_permission(
    LayerName,
    StatementId,
    VersionNumber;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "DELETE",
        "/2018-10-31/layers/$(LayerName)/versions/$(VersionNumber)/policy/$(StatementId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_layer_version_permission(
    LayerName,
    StatementId,
    VersionNumber,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "DELETE",
        "/2018-10-31/layers/$(LayerName)/versions/$(VersionNumber)/policy/$(StatementId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_permission(function_name, statement_id)
    remove_permission(function_name, statement_id, params::Dict{String,<:Any})

Revokes function-use permission from an Amazon Web Service or another Amazon Web Services
account. You can get the ID of the statement from the output of GetPolicy.

# Arguments
- `function_name`: The name or ARN of the Lambda function, version, or alias.  Name formats
      Function name – my-function (name-only), my-function:v1 (with alias).    Function ARN
  – arn:aws:lambda:us-west-2:123456789012:function:my-function.    Partial ARN –
  123456789012:function:my-function.   You can append a version number or alias to any of the
  formats. The length constraint applies only to the full ARN. If you specify only the
  function name, it is limited to 64 characters in length.
- `statement_id`: Statement ID of the permission to remove.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Qualifier"`: Specify a version or alias to remove permissions from a published version
  of the function.
- `"RevisionId"`: Update the policy only if the revision ID matches the ID that's
  specified. Use this option to avoid modifying a policy that has changed since you last read
  it.
"""
function remove_permission(
    FunctionName, StatementId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lambda(
        "DELETE",
        "/2015-03-31/functions/$(FunctionName)/policy/$(StatementId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_permission(
    FunctionName,
    StatementId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "DELETE",
        "/2015-03-31/functions/$(FunctionName)/policy/$(StatementId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(arn, tags)
    tag_resource(arn, tags, params::Dict{String,<:Any})

Adds tags to a function.

# Arguments
- `arn`: The function's Amazon Resource Name (ARN).
- `tags`: A list of tags to apply to the function.

"""
function tag_resource(ARN, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return lambda(
        "POST",
        "/2017-03-31/tags/$(ARN)",
        Dict{String,Any}("Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ARN,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "POST",
        "/2017-03-31/tags/$(ARN)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Tags" => Tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(arn, tag_keys)
    untag_resource(arn, tag_keys, params::Dict{String,<:Any})

Removes tags from a function.

# Arguments
- `arn`: The function's Amazon Resource Name (ARN).
- `tag_keys`: A list of tag keys to remove from the function.

"""
function untag_resource(ARN, tagKeys; aws_config::AbstractAWSConfig=current_aws_config())
    return lambda(
        "DELETE",
        "/2017-03-31/tags/$(ARN)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ARN,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "DELETE",
        "/2017-03-31/tags/$(ARN)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_alias(function_name, name)
    update_alias(function_name, name, params::Dict{String,<:Any})

Updates the configuration of a Lambda function alias.

# Arguments
- `function_name`: The name or ARN of the Lambda function.  Name formats     Function name
  - MyFunction.    Function ARN - arn:aws:lambda:us-west-2:123456789012:function:MyFunction.
    Partial ARN - 123456789012:function:MyFunction.   The length constraint applies only to
  the full ARN. If you specify only the function name, it is limited to 64 characters in
  length.
- `name`: The name of the alias.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description of the alias.
- `"FunctionVersion"`: The function version that the alias invokes.
- `"RevisionId"`: Only update the alias if the revision ID matches the ID that's specified.
  Use this option to avoid modifying an alias that has changed since you last read it.
- `"RoutingConfig"`: The routing configuration of the alias.
"""
function update_alias(
    FunctionName, Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lambda(
        "PUT",
        "/2015-03-31/functions/$(FunctionName)/aliases/$(Name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_alias(
    FunctionName,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "PUT",
        "/2015-03-31/functions/$(FunctionName)/aliases/$(Name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_code_signing_config(code_signing_config_arn)
    update_code_signing_config(code_signing_config_arn, params::Dict{String,<:Any})

Update the code signing configuration. Changes to the code signing configuration take
effect the next time a user tries to deploy a code package to the function.

# Arguments
- `code_signing_config_arn`: The The Amazon Resource Name (ARN) of the code signing
  configuration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AllowedPublishers"`: Signing profiles for this code signing configuration.
- `"CodeSigningPolicies"`: The code signing policy.
- `"Description"`: Descriptive name for this code signing configuration.
"""
function update_code_signing_config(
    CodeSigningConfigArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lambda(
        "PUT",
        "/2020-04-22/code-signing-configs/$(CodeSigningConfigArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_code_signing_config(
    CodeSigningConfigArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "PUT",
        "/2020-04-22/code-signing-configs/$(CodeSigningConfigArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_event_source_mapping(uuid)
    update_event_source_mapping(uuid, params::Dict{String,<:Any})

Updates an event source mapping. You can change the function that Lambda invokes, or pause
invocation and resume later from the same location. For details about how to configure
different event sources, see the following topics.      Amazon DynamoDB Streams      Amazon
Kinesis      Amazon SQS      Amazon MQ and RabbitMQ      Amazon MSK      Apache Kafka
Amazon DocumentDB    The following error handling options are available only for stream
sources (DynamoDB and Kinesis):    BisectBatchOnFunctionError – If the function returns
an error, split the batch in two and retry.    DestinationConfig – Send discarded records
to an Amazon SQS queue or Amazon SNS topic.    MaximumRecordAgeInSeconds – Discard
records older than the specified age. The default value is infinite (-1). When set to
infinite (-1), failed records are retried until the record expires    MaximumRetryAttempts
– Discard records after the specified number of retries. The default value is infinite
(-1). When set to infinite (-1), failed records are retried until the record expires.
ParallelizationFactor – Process multiple batches from each shard concurrently.   For
information about which configuration parameters apply to each event source, see the
following topics.     Amazon DynamoDB Streams      Amazon Kinesis      Amazon SQS
Amazon MQ and RabbitMQ      Amazon MSK      Apache Kafka      Amazon DocumentDB

# Arguments
- `uuid`: The identifier of the event source mapping.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"BatchSize"`: The maximum number of records in each batch that Lambda pulls from your
  stream or queue and sends to your function. Lambda passes all of the records in the batch
  to the function in a single call, up to the payload limit for synchronous invocation (6
  MB).    Amazon Kinesis – Default 100. Max 10,000.    Amazon DynamoDB Streams – Default
  100. Max 10,000.    Amazon Simple Queue Service – Default 10. For standard queues the max
  is 10,000. For FIFO queues the max is 10.    Amazon Managed Streaming for Apache Kafka –
  Default 100. Max 10,000.    Self-managed Apache Kafka – Default 100. Max 10,000.
  Amazon MQ (ActiveMQ and RabbitMQ) – Default 100. Max 10,000.    DocumentDB – Default
  100. Max 10,000.
- `"BisectBatchOnFunctionError"`: (Kinesis and DynamoDB Streams only) If the function
  returns an error, split the batch in two and retry.
- `"DestinationConfig"`: (Kinesis, DynamoDB Streams, Amazon MSK, and self-managed Kafka
  only) A configuration object that specifies the destination of an event after Lambda
  processes it.
- `"DocumentDBEventSourceConfig"`: Specific configuration settings for a DocumentDB event
  source.
- `"Enabled"`: When true, the event source mapping is active. When false, Lambda pauses
  polling and invocation. Default: True
- `"FilterCriteria"`: An object that defines the filter criteria that determine whether
  Lambda should process an event. For more information, see Lambda event filtering.
- `"FunctionName"`: The name or ARN of the Lambda function.  Name formats     Function name
  – MyFunction.    Function ARN –
  arn:aws:lambda:us-west-2:123456789012:function:MyFunction.    Version or Alias ARN –
  arn:aws:lambda:us-west-2:123456789012:function:MyFunction:PROD.    Partial ARN –
  123456789012:function:MyFunction.   The length constraint applies only to the full ARN. If
  you specify only the function name, it's limited to 64 characters in length.
- `"FunctionResponseTypes"`: (Kinesis, DynamoDB Streams, and Amazon SQS) A list of current
  response type enums applied to the event source mapping.
- `"MaximumBatchingWindowInSeconds"`: The maximum amount of time, in seconds, that Lambda
  spends gathering records before invoking the function. You can configure
  MaximumBatchingWindowInSeconds to any value from 0 seconds to 300 seconds in increments of
  seconds. For streams and Amazon SQS event sources, the default batching window is 0
  seconds. For Amazon MSK, Self-managed Apache Kafka, Amazon MQ, and DocumentDB event
  sources, the default batching window is 500 ms. Note that because you can only change
  MaximumBatchingWindowInSeconds in increments of seconds, you cannot revert back to the 500
  ms default batching window after you have changed it. To restore the default batching
  window, you must create a new event source mapping. Related setting: For streams and Amazon
  SQS event sources, when you set BatchSize to a value greater than 10, you must set
  MaximumBatchingWindowInSeconds to at least 1.
- `"MaximumRecordAgeInSeconds"`: (Kinesis and DynamoDB Streams only) Discard records older
  than the specified age. The default value is infinite (-1).
- `"MaximumRetryAttempts"`: (Kinesis and DynamoDB Streams only) Discard records after the
  specified number of retries. The default value is infinite (-1). When set to infinite (-1),
  failed records are retried until the record expires.
- `"ParallelizationFactor"`: (Kinesis and DynamoDB Streams only) The number of batches to
  process from each shard concurrently.
- `"ScalingConfig"`: (Amazon SQS only) The scaling configuration for the event source. For
  more information, see Configuring maximum concurrency for Amazon SQS event sources.
- `"SourceAccessConfigurations"`: An array of authentication protocols or VPC components
  required to secure your event source.
- `"TumblingWindowInSeconds"`: (Kinesis and DynamoDB Streams only) The duration in seconds
  of a processing window for DynamoDB and Kinesis Streams event sources. A value of 0 seconds
  indicates no tumbling window.
"""
function update_event_source_mapping(
    UUID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lambda(
        "PUT",
        "/2015-03-31/event-source-mappings/$(UUID)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_event_source_mapping(
    UUID, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lambda(
        "PUT",
        "/2015-03-31/event-source-mappings/$(UUID)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_function_code(function_name)
    update_function_code(function_name, params::Dict{String,<:Any})

Updates a Lambda function's code. If code signing is enabled for the function, the code
package must be signed by a trusted publisher. For more information, see Configuring code
signing for Lambda. If the function's package type is Image, then you must specify the code
package in ImageUri as the URI of a container image in the Amazon ECR registry. If the
function's package type is Zip, then you must specify the deployment package as a .zip file
archive. Enter the Amazon S3 bucket and key of the code .zip file location. You can also
provide the function code inline using the ZipFile field. The code in the deployment
package must be compatible with the target instruction set architecture of the function
(x86-64 or arm64). The function's code is locked when you publish a version. You can't
modify the code of a published version, only the unpublished version.  For a function
defined as a container image, Lambda resolves the image tag to an image digest. In Amazon
ECR, if you update the image tag to a new image, Lambda does not automatically update the
function.

# Arguments
- `function_name`: The name or ARN of the Lambda function.  Name formats     Function name
  – my-function.    Function ARN –
  arn:aws:lambda:us-west-2:123456789012:function:my-function.    Partial ARN –
  123456789012:function:my-function.   The length constraint applies only to the full ARN. If
  you specify only the function name, it is limited to 64 characters in length.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Architectures"`: The instruction set architecture that the function supports. Enter a
  string array with one of the valid values (arm64 or x86_64). The default value is x86_64.
- `"DryRun"`: Set to true to validate the request parameters and access permissions without
  modifying the function code.
- `"ImageUri"`: URI of a container image in the Amazon ECR registry. Do not use for a
  function defined with a .zip file archive.
- `"Publish"`: Set to true to publish a new version of the function after updating the
  code. This has the same effect as calling PublishVersion separately.
- `"RevisionId"`: Update the function only if the revision ID matches the ID that's
  specified. Use this option to avoid modifying a function that has changed since you last
  read it.
- `"S3Bucket"`: An Amazon S3 bucket in the same Amazon Web Services Region as your
  function. The bucket can be in a different Amazon Web Services account. Use only with a
  function defined with a .zip file archive deployment package.
- `"S3Key"`: The Amazon S3 key of the deployment package. Use only with a function defined
  with a .zip file archive deployment package.
- `"S3ObjectVersion"`: For versioned objects, the version of the deployment package object
  to use.
- `"ZipFile"`: The base64-encoded contents of the deployment package. Amazon Web Services
  SDK and CLI clients handle the encoding for you. Use only with a function defined with a
  .zip file archive deployment package.
"""
function update_function_code(
    FunctionName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lambda(
        "PUT",
        "/2015-03-31/functions/$(FunctionName)/code";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_function_code(
    FunctionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "PUT",
        "/2015-03-31/functions/$(FunctionName)/code",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_function_configuration(function_name)
    update_function_configuration(function_name, params::Dict{String,<:Any})

Modify the version-specific settings of a Lambda function. When you update a function,
Lambda provisions an instance of the function and its supporting resources. If your
function connects to a VPC, this process can take a minute. During this time, you can't
modify the function, but you can still invoke it. The LastUpdateStatus,
LastUpdateStatusReason, and LastUpdateStatusReasonCode fields in the response from
GetFunctionConfiguration indicate when the update is complete and the function is
processing events with the new configuration. For more information, see Lambda function
states. These settings can vary between versions of a function and are locked when you
publish a version. You can't modify the configuration of a published version, only the
unpublished version. To configure function concurrency, use PutFunctionConcurrency. To
grant invoke permissions to an Amazon Web Services account or Amazon Web Service, use
AddPermission.

# Arguments
- `function_name`: The name or ARN of the Lambda function.  Name formats     Function name
  – my-function.    Function ARN –
  arn:aws:lambda:us-west-2:123456789012:function:my-function.    Partial ARN –
  123456789012:function:my-function.   The length constraint applies only to the full ARN. If
  you specify only the function name, it is limited to 64 characters in length.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DeadLetterConfig"`: A dead-letter queue configuration that specifies the queue or topic
  where Lambda sends asynchronous events when they fail processing. For more information, see
  Dead-letter queues.
- `"Description"`: A description of the function.
- `"Environment"`: Environment variables that are accessible from function code during
  execution.
- `"EphemeralStorage"`: The size of the function's /tmp directory in MB. The default value
  is 512, but can be any whole number between 512 and 10,240 MB. For more information, see
  Configuring ephemeral storage (console).
- `"FileSystemConfigs"`: Connection settings for an Amazon EFS file system.
- `"Handler"`: The name of the method within your code that Lambda calls to run your
  function. Handler is required if the deployment package is a .zip file archive. The format
  includes the file name. It can also include namespaces and other qualifiers, depending on
  the runtime. For more information, see Lambda programming model.
- `"ImageConfig"`:  Container image configuration values that override the values in the
  container image Docker file.
- `"KMSKeyArn"`: The ARN of the Key Management Service (KMS) customer managed key that's
  used to encrypt your function's environment variables. When Lambda SnapStart is activated,
  Lambda also uses this key is to encrypt your function's snapshot. If you deploy your
  function using a container image, Lambda also uses this key to encrypt your function when
  it's deployed. Note that this is not the same key that's used to protect your container
  image in the Amazon Elastic Container Registry (Amazon ECR). If you don't provide a
  customer managed key, Lambda uses a default service key.
- `"Layers"`: A list of function layers to add to the function's execution environment.
  Specify each layer by its ARN, including the version.
- `"LoggingConfig"`: The function's Amazon CloudWatch Logs configuration settings.
- `"MemorySize"`: The amount of memory available to the function at runtime. Increasing the
  function memory also increases its CPU allocation. The default value is 128 MB. The value
  can be any multiple of 1 MB.
- `"RevisionId"`: Update the function only if the revision ID matches the ID that's
  specified. Use this option to avoid modifying a function that has changed since you last
  read it.
- `"Role"`: The Amazon Resource Name (ARN) of the function's execution role.
- `"Runtime"`: The identifier of the function's runtime. Runtime is required if the
  deployment package is a .zip file archive. The following list includes deprecated runtimes.
  For more information, see Runtime deprecation policy.
- `"SnapStart"`: The function's SnapStart setting.
- `"Timeout"`: The amount of time (in seconds) that Lambda allows a function to run before
  stopping it. The default is 3 seconds. The maximum allowed value is 900 seconds. For more
  information, see Lambda execution environment.
- `"TracingConfig"`: Set Mode to Active to sample and trace a subset of incoming requests
  with X-Ray.
- `"VpcConfig"`: For network connectivity to Amazon Web Services resources in a VPC,
  specify a list of security groups and subnets in the VPC. When you connect a function to a
  VPC, it can access resources and the internet only through that VPC. For more information,
  see Configuring a Lambda function to access resources in a VPC.
"""
function update_function_configuration(
    FunctionName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lambda(
        "PUT",
        "/2015-03-31/functions/$(FunctionName)/configuration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_function_configuration(
    FunctionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "PUT",
        "/2015-03-31/functions/$(FunctionName)/configuration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_function_event_invoke_config(function_name)
    update_function_event_invoke_config(function_name, params::Dict{String,<:Any})

Updates the configuration for asynchronous invocation for a function, version, or alias. To
configure options for asynchronous invocation, use PutFunctionEventInvokeConfig.

# Arguments
- `function_name`: The name or ARN of the Lambda function, version, or alias.  Name formats
      Function name - my-function (name-only), my-function:v1 (with alias).    Function ARN -
  arn:aws:lambda:us-west-2:123456789012:function:my-function.    Partial ARN -
  123456789012:function:my-function.   You can append a version number or alias to any of the
  formats. The length constraint applies only to the full ARN. If you specify only the
  function name, it is limited to 64 characters in length.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DestinationConfig"`: A destination for events after they have been sent to a function
  for processing.  Destinations     Function - The Amazon Resource Name (ARN) of a Lambda
  function.    Queue - The ARN of a standard SQS queue.    Topic - The ARN of a standard SNS
  topic.    Event Bus - The ARN of an Amazon EventBridge event bus.
- `"MaximumEventAgeInSeconds"`: The maximum age of a request that Lambda sends to a
  function for processing.
- `"MaximumRetryAttempts"`: The maximum number of times to retry when the function returns
  an error.
- `"Qualifier"`: A version number or alias name.
"""
function update_function_event_invoke_config(
    FunctionName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lambda(
        "POST",
        "/2019-09-25/functions/$(FunctionName)/event-invoke-config";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_function_event_invoke_config(
    FunctionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "POST",
        "/2019-09-25/functions/$(FunctionName)/event-invoke-config",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_function_url_config(function_name)
    update_function_url_config(function_name, params::Dict{String,<:Any})

Updates the configuration for a Lambda function URL.

# Arguments
- `function_name`: The name or ARN of the Lambda function.  Name formats     Function name
  – my-function.    Function ARN –
  arn:aws:lambda:us-west-2:123456789012:function:my-function.    Partial ARN –
  123456789012:function:my-function.   The length constraint applies only to the full ARN. If
  you specify only the function name, it is limited to 64 characters in length.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AuthType"`: The type of authentication that your function URL uses. Set to AWS_IAM if
  you want to restrict access to authenticated users only. Set to NONE if you want to bypass
  IAM authentication to create a public endpoint. For more information, see Security and auth
  model for Lambda function URLs.
- `"Cors"`: The cross-origin resource sharing (CORS) settings for your function URL.
- `"InvokeMode"`: Use one of the following options:    BUFFERED – This is the default
  option. Lambda invokes your function using the Invoke API operation. Invocation results are
  available when the payload is complete. The maximum payload size is 6 MB.
  RESPONSE_STREAM – Your function streams payload results as they become available. Lambda
  invokes your function using the InvokeWithResponseStream API operation. The maximum
  response payload size is 20 MB, however, you can request a quota increase.
- `"Qualifier"`: The alias name.
"""
function update_function_url_config(
    FunctionName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lambda(
        "PUT",
        "/2021-10-31/functions/$(FunctionName)/url";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_function_url_config(
    FunctionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lambda(
        "PUT",
        "/2021-10-31/functions/$(FunctionName)/url",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: opensearchserverless
using AWS.Compat
using AWS.UUIDs

"""
    batch_get_collection()
    batch_get_collection(params::Dict{String,<:Any})

Returns attributes for one or more collections, including the collection endpoint and the
OpenSearch Dashboards endpoint. For more information, see Creating and managing Amazon
OpenSearch Serverless collections.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ids"`: A list of collection IDs. You can't provide names and IDs in the same request.
  The ID is part of the collection endpoint. You can also retrieve it using the
  ListCollections API.
- `"names"`: A list of collection names. You can't provide names and IDs in the same
  request.
"""
function batch_get_collection(; aws_config::AbstractAWSConfig=current_aws_config())
    return opensearchserverless(
        "BatchGetCollection"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function batch_get_collection(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearchserverless(
        "BatchGetCollection", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    batch_get_effective_lifecycle_policy(resource_identifiers)
    batch_get_effective_lifecycle_policy(resource_identifiers, params::Dict{String,<:Any})

Returns a list of successful and failed retrievals for the OpenSearch Serverless indexes.
For more information, see Viewing data lifecycle policies.

# Arguments
- `resource_identifiers`: The unique identifiers of policy types and resource names.

"""
function batch_get_effective_lifecycle_policy(
    resourceIdentifiers; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearchserverless(
        "BatchGetEffectiveLifecyclePolicy",
        Dict{String,Any}("resourceIdentifiers" => resourceIdentifiers);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_effective_lifecycle_policy(
    resourceIdentifiers,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearchserverless(
        "BatchGetEffectiveLifecyclePolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceIdentifiers" => resourceIdentifiers),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_get_lifecycle_policy(identifiers)
    batch_get_lifecycle_policy(identifiers, params::Dict{String,<:Any})

Returns one or more configured OpenSearch Serverless lifecycle policies. For more
information, see Viewing data lifecycle policies.

# Arguments
- `identifiers`: The unique identifiers of policy types and policy names.

"""
function batch_get_lifecycle_policy(
    identifiers; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearchserverless(
        "BatchGetLifecyclePolicy",
        Dict{String,Any}("identifiers" => identifiers);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_lifecycle_policy(
    identifiers,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearchserverless(
        "BatchGetLifecyclePolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("identifiers" => identifiers), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_get_vpc_endpoint(ids)
    batch_get_vpc_endpoint(ids, params::Dict{String,<:Any})

Returns attributes for one or more VPC endpoints associated with the current account. For
more information, see Access Amazon OpenSearch Serverless using an interface endpoint.

# Arguments
- `ids`: A list of VPC endpoint identifiers.

"""
function batch_get_vpc_endpoint(ids; aws_config::AbstractAWSConfig=current_aws_config())
    return opensearchserverless(
        "BatchGetVpcEndpoint",
        Dict{String,Any}("ids" => ids);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_vpc_endpoint(
    ids, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearchserverless(
        "BatchGetVpcEndpoint",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("ids" => ids), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_access_policy(name, policy, type)
    create_access_policy(name, policy, type, params::Dict{String,<:Any})

Creates a data access policy for OpenSearch Serverless. Access policies limit access to
collections and the resources within them, and allow a user to access that data
irrespective of the access mechanism or network source. For more information, see Data
access control for Amazon OpenSearch Serverless.

# Arguments
- `name`: The name of the policy.
- `policy`: The JSON policy document to use as the content for the policy.
- `type`: The type of policy.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Unique, case-sensitive identifier to ensure idempotency of the request.
- `"description"`: A description of the policy. Typically used to store information about
  the permissions defined in the policy.
"""
function create_access_policy(
    name, policy, type; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearchserverless(
        "CreateAccessPolicy",
        Dict{String,Any}(
            "name" => name,
            "policy" => policy,
            "type" => type,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_access_policy(
    name,
    policy,
    type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearchserverless(
        "CreateAccessPolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "name" => name,
                    "policy" => policy,
                    "type" => type,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_collection(name)
    create_collection(name, params::Dict{String,<:Any})

Creates a new OpenSearch Serverless collection. For more information, see Creating and
managing Amazon OpenSearch Serverless collections.

# Arguments
- `name`: Name of the collection.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Unique, case-sensitive identifier to ensure idempotency of the request.
- `"description"`: Description of the collection.
- `"standbyReplicas"`: Indicates whether standby replicas should be used for a collection.
- `"tags"`: An arbitrary set of tags (key–value pairs) to associate with the OpenSearch
  Serverless collection.
- `"type"`: The type of collection.
"""
function create_collection(name; aws_config::AbstractAWSConfig=current_aws_config())
    return opensearchserverless(
        "CreateCollection",
        Dict{String,Any}("name" => name, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_collection(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearchserverless(
        "CreateCollection",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("name" => name, "clientToken" => string(uuid4())),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_lifecycle_policy(name, policy, type)
    create_lifecycle_policy(name, policy, type, params::Dict{String,<:Any})

Creates a lifecyle policy to be applied to OpenSearch Serverless indexes. Lifecycle
policies define the number of days or hours to retain the data on an OpenSearch Serverless
index. For more information, see Creating data lifecycle policies.

# Arguments
- `name`: The name of the lifecycle policy.
- `policy`: The JSON policy document to use as the content for the lifecycle policy.
- `type`: The type of lifecycle policy.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier to ensure idempotency of the request.
- `"description"`: A description of the lifecycle policy.
"""
function create_lifecycle_policy(
    name, policy, type; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearchserverless(
        "CreateLifecyclePolicy",
        Dict{String,Any}(
            "name" => name,
            "policy" => policy,
            "type" => type,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_lifecycle_policy(
    name,
    policy,
    type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearchserverless(
        "CreateLifecyclePolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "name" => name,
                    "policy" => policy,
                    "type" => type,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_security_config(name, type)
    create_security_config(name, type, params::Dict{String,<:Any})

Specifies a security configuration for OpenSearch Serverless. For more information, see
SAML authentication for Amazon OpenSearch Serverless.

# Arguments
- `name`: The name of the security configuration.
- `type`: The type of security configuration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Unique, case-sensitive identifier to ensure idempotency of the request.
- `"description"`: A description of the security configuration.
- `"samlOptions"`: Describes SAML options in in the form of a key-value map. This field is
  required if you specify saml for the type parameter.
"""
function create_security_config(
    name, type; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearchserverless(
        "CreateSecurityConfig",
        Dict{String,Any}("name" => name, "type" => type, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_security_config(
    name,
    type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearchserverless(
        "CreateSecurityConfig",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "name" => name, "type" => type, "clientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_security_policy(name, policy, type)
    create_security_policy(name, policy, type, params::Dict{String,<:Any})

Creates a security policy to be used by one or more OpenSearch Serverless collections.
Security policies provide access to a collection and its OpenSearch Dashboards endpoint
from public networks or specific VPC endpoints. They also allow you to secure a collection
with a KMS encryption key. For more information, see Network access for Amazon OpenSearch
Serverless and Encryption at rest for Amazon OpenSearch Serverless.

# Arguments
- `name`: The name of the policy.
- `policy`: The JSON policy document to use as the content for the new policy.
- `type`: The type of security policy.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Unique, case-sensitive identifier to ensure idempotency of the request.
- `"description"`: A description of the policy. Typically used to store information about
  the permissions defined in the policy.
"""
function create_security_policy(
    name, policy, type; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearchserverless(
        "CreateSecurityPolicy",
        Dict{String,Any}(
            "name" => name,
            "policy" => policy,
            "type" => type,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_security_policy(
    name,
    policy,
    type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearchserverless(
        "CreateSecurityPolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "name" => name,
                    "policy" => policy,
                    "type" => type,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_vpc_endpoint(name, subnet_ids, vpc_id)
    create_vpc_endpoint(name, subnet_ids, vpc_id, params::Dict{String,<:Any})

Creates an OpenSearch Serverless-managed interface VPC endpoint. For more information, see
Access Amazon OpenSearch Serverless using an interface endpoint.

# Arguments
- `name`: The name of the interface endpoint.
- `subnet_ids`: The ID of one or more subnets from which you'll access OpenSearch
  Serverless.
- `vpc_id`: The ID of the VPC from which you'll access OpenSearch Serverless.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Unique, case-sensitive identifier to ensure idempotency of the request.
- `"securityGroupIds"`: The unique identifiers of the security groups that define the
  ports, protocols, and sources for inbound traffic that you are authorizing into your
  endpoint.
"""
function create_vpc_endpoint(
    name, subnetIds, vpcId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearchserverless(
        "CreateVpcEndpoint",
        Dict{String,Any}(
            "name" => name,
            "subnetIds" => subnetIds,
            "vpcId" => vpcId,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_vpc_endpoint(
    name,
    subnetIds,
    vpcId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearchserverless(
        "CreateVpcEndpoint",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "name" => name,
                    "subnetIds" => subnetIds,
                    "vpcId" => vpcId,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_access_policy(name, type)
    delete_access_policy(name, type, params::Dict{String,<:Any})

Deletes an OpenSearch Serverless access policy. For more information, see Data access
control for Amazon OpenSearch Serverless.

# Arguments
- `name`: The name of the policy to delete.
- `type`: The type of policy.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Unique, case-sensitive identifier to ensure idempotency of the request.
"""
function delete_access_policy(
    name, type; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearchserverless(
        "DeleteAccessPolicy",
        Dict{String,Any}("name" => name, "type" => type, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_access_policy(
    name,
    type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearchserverless(
        "DeleteAccessPolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "name" => name, "type" => type, "clientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_collection(id)
    delete_collection(id, params::Dict{String,<:Any})

Deletes an OpenSearch Serverless collection. For more information, see Creating and
managing Amazon OpenSearch Serverless collections.

# Arguments
- `id`: The unique identifier of the collection. For example, 1iu5usc406kd. The ID is part
  of the collection endpoint. You can also retrieve it using the ListCollections API.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier to ensure idempotency of the request.
"""
function delete_collection(id; aws_config::AbstractAWSConfig=current_aws_config())
    return opensearchserverless(
        "DeleteCollection",
        Dict{String,Any}("id" => id, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_collection(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearchserverless(
        "DeleteCollection",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("id" => id, "clientToken" => string(uuid4())),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_lifecycle_policy(name, type)
    delete_lifecycle_policy(name, type, params::Dict{String,<:Any})

Deletes an OpenSearch Serverless lifecycle policy. For more information, see Deleting data
lifecycle policies.

# Arguments
- `name`: The name of the policy to delete.
- `type`: The type of lifecycle policy.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Unique, case-sensitive identifier to ensure idempotency of the request.
"""
function delete_lifecycle_policy(
    name, type; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearchserverless(
        "DeleteLifecyclePolicy",
        Dict{String,Any}("name" => name, "type" => type, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_lifecycle_policy(
    name,
    type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearchserverless(
        "DeleteLifecyclePolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "name" => name, "type" => type, "clientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_security_config(id)
    delete_security_config(id, params::Dict{String,<:Any})

Deletes a security configuration for OpenSearch Serverless. For more information, see SAML
authentication for Amazon OpenSearch Serverless.

# Arguments
- `id`: The security configuration identifier. For SAML the ID will be
  saml/&lt;accountId&gt;/&lt;idpProviderName&gt;. For example, saml/123456789123/OKTADev.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Unique, case-sensitive identifier to ensure idempotency of the request.
"""
function delete_security_config(id; aws_config::AbstractAWSConfig=current_aws_config())
    return opensearchserverless(
        "DeleteSecurityConfig",
        Dict{String,Any}("id" => id, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_security_config(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearchserverless(
        "DeleteSecurityConfig",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("id" => id, "clientToken" => string(uuid4())),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_security_policy(name, type)
    delete_security_policy(name, type, params::Dict{String,<:Any})

Deletes an OpenSearch Serverless security policy.

# Arguments
- `name`: The name of the policy to delete.
- `type`: The type of policy.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Unique, case-sensitive identifier to ensure idempotency of the request.
"""
function delete_security_policy(
    name, type; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearchserverless(
        "DeleteSecurityPolicy",
        Dict{String,Any}("name" => name, "type" => type, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_security_policy(
    name,
    type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearchserverless(
        "DeleteSecurityPolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "name" => name, "type" => type, "clientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_vpc_endpoint(id)
    delete_vpc_endpoint(id, params::Dict{String,<:Any})

Deletes an OpenSearch Serverless-managed interface endpoint. For more information, see
Access Amazon OpenSearch Serverless using an interface endpoint.

# Arguments
- `id`: The VPC endpoint identifier.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Unique, case-sensitive identifier to ensure idempotency of the request.
"""
function delete_vpc_endpoint(id; aws_config::AbstractAWSConfig=current_aws_config())
    return opensearchserverless(
        "DeleteVpcEndpoint",
        Dict{String,Any}("id" => id, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_vpc_endpoint(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearchserverless(
        "DeleteVpcEndpoint",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("id" => id, "clientToken" => string(uuid4())),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_access_policy(name, type)
    get_access_policy(name, type, params::Dict{String,<:Any})

Returns an OpenSearch Serverless access policy. For more information, see Data access
control for Amazon OpenSearch Serverless.

# Arguments
- `name`: The name of the access policy.
- `type`: Tye type of policy. Currently, the only supported value is data.

"""
function get_access_policy(name, type; aws_config::AbstractAWSConfig=current_aws_config())
    return opensearchserverless(
        "GetAccessPolicy",
        Dict{String,Any}("name" => name, "type" => type);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_access_policy(
    name,
    type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearchserverless(
        "GetAccessPolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("name" => name, "type" => type), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_account_settings()
    get_account_settings(params::Dict{String,<:Any})

Returns account-level settings related to OpenSearch Serverless.

"""
function get_account_settings(; aws_config::AbstractAWSConfig=current_aws_config())
    return opensearchserverless(
        "GetAccountSettings"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_account_settings(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearchserverless(
        "GetAccountSettings", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_policies_stats()
    get_policies_stats(params::Dict{String,<:Any})

Returns statistical information about your OpenSearch Serverless access policies, security
configurations, and security policies.

"""
function get_policies_stats(; aws_config::AbstractAWSConfig=current_aws_config())
    return opensearchserverless(
        "GetPoliciesStats"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_policies_stats(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearchserverless(
        "GetPoliciesStats", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_security_config(id)
    get_security_config(id, params::Dict{String,<:Any})

Returns information about an OpenSearch Serverless security configuration. For more
information, see SAML authentication for Amazon OpenSearch Serverless.

# Arguments
- `id`: The unique identifier of the security configuration.

"""
function get_security_config(id; aws_config::AbstractAWSConfig=current_aws_config())
    return opensearchserverless(
        "GetSecurityConfig",
        Dict{String,Any}("id" => id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_security_config(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearchserverless(
        "GetSecurityConfig",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("id" => id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_security_policy(name, type)
    get_security_policy(name, type, params::Dict{String,<:Any})

Returns information about a configured OpenSearch Serverless security policy. For more
information, see Network access for Amazon OpenSearch Serverless and Encryption at rest for
Amazon OpenSearch Serverless.

# Arguments
- `name`: The name of the security policy.
- `type`: The type of security policy.

"""
function get_security_policy(name, type; aws_config::AbstractAWSConfig=current_aws_config())
    return opensearchserverless(
        "GetSecurityPolicy",
        Dict{String,Any}("name" => name, "type" => type);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_security_policy(
    name,
    type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearchserverless(
        "GetSecurityPolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("name" => name, "type" => type), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_access_policies(type)
    list_access_policies(type, params::Dict{String,<:Any})

Returns information about a list of OpenSearch Serverless access policies.

# Arguments
- `type`: The type of access policy.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: An optional parameter that specifies the maximum number of results to
  return. You can use nextToken to get the next page of results. The default is 20.
- `"nextToken"`: If your initial ListAccessPolicies operation returns a nextToken, you can
  include the returned nextToken in subsequent ListAccessPolicies operations, which returns
  results in the next page.
- `"resource"`: Resource filters (can be collections or indexes) that policies can apply to.
"""
function list_access_policies(type; aws_config::AbstractAWSConfig=current_aws_config())
    return opensearchserverless(
        "ListAccessPolicies",
        Dict{String,Any}("type" => type);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_access_policies(
    type, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearchserverless(
        "ListAccessPolicies",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("type" => type), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_collections()
    list_collections(params::Dict{String,<:Any})

Lists all OpenSearch Serverless collections. For more information, see Creating and
managing Amazon OpenSearch Serverless collections.  Make sure to include an empty request
body {} if you don't include any collection filters in the request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"collectionFilters"`:  A list of filter names and values that you can use for requests.
- `"maxResults"`: The maximum number of results to return. Default is 20. You can use
  nextToken to get the next page of results.
- `"nextToken"`: If your initial ListCollections operation returns a nextToken, you can
  include the returned nextToken in subsequent ListCollections operations, which returns
  results in the next page.
"""
function list_collections(; aws_config::AbstractAWSConfig=current_aws_config())
    return opensearchserverless(
        "ListCollections"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_collections(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearchserverless(
        "ListCollections", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_lifecycle_policies(type)
    list_lifecycle_policies(type, params::Dict{String,<:Any})

Returns a list of OpenSearch Serverless lifecycle policies. For more information, see
Viewing data lifecycle policies.

# Arguments
- `type`: The type of lifecycle policy.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: An optional parameter that specifies the maximum number of results to
  return. You can use use nextToken to get the next page of results. The default is 10.
- `"nextToken"`: If your initial ListLifecyclePolicies operation returns a nextToken, you
  can include the returned nextToken in subsequent ListLifecyclePolicies operations, which
  returns results in the next page.
- `"resources"`: Resource filters that policies can apply to. Currently, the only supported
  resource type is index.
"""
function list_lifecycle_policies(type; aws_config::AbstractAWSConfig=current_aws_config())
    return opensearchserverless(
        "ListLifecyclePolicies",
        Dict{String,Any}("type" => type);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_lifecycle_policies(
    type, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearchserverless(
        "ListLifecyclePolicies",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("type" => type), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_security_configs(type)
    list_security_configs(type, params::Dict{String,<:Any})

Returns information about configured OpenSearch Serverless security configurations. For
more information, see SAML authentication for Amazon OpenSearch Serverless.

# Arguments
- `type`: The type of security configuration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: An optional parameter that specifies the maximum number of results to
  return. You can use nextToken to get the next page of results. The default is 20.
- `"nextToken"`: If your initial ListSecurityConfigs operation returns a nextToken, you can
  include the returned nextToken in subsequent ListSecurityConfigs operations, which returns
  results in the next page.
"""
function list_security_configs(type; aws_config::AbstractAWSConfig=current_aws_config())
    return opensearchserverless(
        "ListSecurityConfigs",
        Dict{String,Any}("type" => type);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_security_configs(
    type, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearchserverless(
        "ListSecurityConfigs",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("type" => type), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_security_policies(type)
    list_security_policies(type, params::Dict{String,<:Any})

Returns information about configured OpenSearch Serverless security policies.

# Arguments
- `type`: The type of policy.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: An optional parameter that specifies the maximum number of results to
  return. You can use nextToken to get the next page of results. The default is 20.
- `"nextToken"`: If your initial ListSecurityPolicies operation returns a nextToken, you
  can include the returned nextToken in subsequent ListSecurityPolicies operations, which
  returns results in the next page.
- `"resource"`: Resource filters (can be collection or indexes) that policies can apply to.
"""
function list_security_policies(type; aws_config::AbstractAWSConfig=current_aws_config())
    return opensearchserverless(
        "ListSecurityPolicies",
        Dict{String,Any}("type" => type);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_security_policies(
    type, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearchserverless(
        "ListSecurityPolicies",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("type" => type), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Returns the tags for an OpenSearch Serverless resource. For more information, see Tagging
Amazon OpenSearch Serverless collections.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource. The resource must be
  active (not in the DELETING state), and must be owned by the account ID included in the
  request.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearchserverless(
        "ListTagsForResource",
        Dict{String,Any}("resourceArn" => resourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearchserverless(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceArn" => resourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_vpc_endpoints()
    list_vpc_endpoints(params::Dict{String,<:Any})

Returns the OpenSearch Serverless-managed interface VPC endpoints associated with the
current account. For more information, see Access Amazon OpenSearch Serverless using an
interface endpoint.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: An optional parameter that specifies the maximum number of results to
  return. You can use nextToken to get the next page of results. The default is 20.
- `"nextToken"`: If your initial ListVpcEndpoints operation returns a nextToken, you can
  include the returned nextToken in subsequent ListVpcEndpoints operations, which returns
  results in the next page.
- `"vpcEndpointFilters"`: Filter the results according to the current status of the VPC
  endpoint. Possible statuses are CREATING, DELETING, UPDATING, ACTIVE, and FAILED.
"""
function list_vpc_endpoints(; aws_config::AbstractAWSConfig=current_aws_config())
    return opensearchserverless(
        "ListVpcEndpoints"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_vpc_endpoints(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearchserverless(
        "ListVpcEndpoints", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Associates tags with an OpenSearch Serverless resource. For more information, see Tagging
Amazon OpenSearch Serverless collections.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource. The resource must be
  active (not in the DELETING state), and must be owned by the account ID included in the
  request.
- `tags`: A list of tags (key-value pairs) to add to the resource. All tag keys in the
  request must be unique.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return opensearchserverless(
        "TagResource",
        Dict{String,Any}("resourceArn" => resourceArn, "tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearchserverless(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceArn" => resourceArn, "tags" => tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes a tag or set of tags from an OpenSearch Serverless resource. For more information,
see Tagging Amazon OpenSearch Serverless collections.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource to remove tags from. The
  resource must be active (not in the DELETING state), and must be owned by the account ID
  included in the request.
- `tag_keys`: The tag or set of tags to remove from the resource. All tag keys in the
  request must be unique.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearchserverless(
        "UntagResource",
        Dict{String,Any}("resourceArn" => resourceArn, "tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearchserverless(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceArn" => resourceArn, "tagKeys" => tagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_access_policy(name, policy_version, type)
    update_access_policy(name, policy_version, type, params::Dict{String,<:Any})

Updates an OpenSearch Serverless access policy. For more information, see Data access
control for Amazon OpenSearch Serverless.

# Arguments
- `name`: The name of the policy.
- `policy_version`: The version of the policy being updated.
- `type`: The type of policy.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Unique, case-sensitive identifier to ensure idempotency of the request.
- `"description"`: A description of the policy. Typically used to store information about
  the permissions defined in the policy.
- `"policy"`: The JSON policy document to use as the content for the policy.
"""
function update_access_policy(
    name, policyVersion, type; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearchserverless(
        "UpdateAccessPolicy",
        Dict{String,Any}(
            "name" => name,
            "policyVersion" => policyVersion,
            "type" => type,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_access_policy(
    name,
    policyVersion,
    type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearchserverless(
        "UpdateAccessPolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "name" => name,
                    "policyVersion" => policyVersion,
                    "type" => type,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_account_settings()
    update_account_settings(params::Dict{String,<:Any})

Update the OpenSearch Serverless settings for the current Amazon Web Services account. For
more information, see Managing capacity limits for Amazon OpenSearch Serverless.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"capacityLimits"`:
"""
function update_account_settings(; aws_config::AbstractAWSConfig=current_aws_config())
    return opensearchserverless(
        "UpdateAccountSettings"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function update_account_settings(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearchserverless(
        "UpdateAccountSettings",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_collection(id)
    update_collection(id, params::Dict{String,<:Any})

Updates an OpenSearch Serverless collection.

# Arguments
- `id`: The unique identifier of the collection.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Unique, case-sensitive identifier to ensure idempotency of the request.
- `"description"`: A description of the collection.
"""
function update_collection(id; aws_config::AbstractAWSConfig=current_aws_config())
    return opensearchserverless(
        "UpdateCollection",
        Dict{String,Any}("id" => id, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_collection(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearchserverless(
        "UpdateCollection",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("id" => id, "clientToken" => string(uuid4())),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_lifecycle_policy(name, policy_version, type)
    update_lifecycle_policy(name, policy_version, type, params::Dict{String,<:Any})

Updates an OpenSearch Serverless access policy. For more information, see Updating data
lifecycle policies.

# Arguments
- `name`: The name of the policy.
- `policy_version`: The version of the policy being updated.
- `type`:  The type of lifecycle policy.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier to ensure idempotency of the request.
- `"description"`: A description of the lifecycle policy.
- `"policy"`: The JSON policy document to use as the content for the lifecycle policy.
"""
function update_lifecycle_policy(
    name, policyVersion, type; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearchserverless(
        "UpdateLifecyclePolicy",
        Dict{String,Any}(
            "name" => name,
            "policyVersion" => policyVersion,
            "type" => type,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_lifecycle_policy(
    name,
    policyVersion,
    type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearchserverless(
        "UpdateLifecyclePolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "name" => name,
                    "policyVersion" => policyVersion,
                    "type" => type,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_security_config(config_version, id)
    update_security_config(config_version, id, params::Dict{String,<:Any})

Updates a security configuration for OpenSearch Serverless. For more information, see SAML
authentication for Amazon OpenSearch Serverless.

# Arguments
- `config_version`: The version of the security configuration to be updated. You can find
  the most recent version of a security configuration using the GetSecurityPolicy command.
- `id`: The security configuration identifier. For SAML the ID will be
  saml/&lt;accountId&gt;/&lt;idpProviderName&gt;. For example, saml/123456789123/OKTADev.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Unique, case-sensitive identifier to ensure idempotency of the request.
- `"description"`: A description of the security configuration.
- `"samlOptions"`: SAML options in in the form of a key-value map.
"""
function update_security_config(
    configVersion, id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearchserverless(
        "UpdateSecurityConfig",
        Dict{String,Any}(
            "configVersion" => configVersion, "id" => id, "clientToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_security_config(
    configVersion,
    id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearchserverless(
        "UpdateSecurityConfig",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "configVersion" => configVersion,
                    "id" => id,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_security_policy(name, policy_version, type)
    update_security_policy(name, policy_version, type, params::Dict{String,<:Any})

Updates an OpenSearch Serverless security policy. For more information, see Network access
for Amazon OpenSearch Serverless and Encryption at rest for Amazon OpenSearch Serverless.

# Arguments
- `name`: The name of the policy.
- `policy_version`: The version of the policy being updated.
- `type`: The type of access policy.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Unique, case-sensitive identifier to ensure idempotency of the request.
- `"description"`: A description of the policy. Typically used to store information about
  the permissions defined in the policy.
- `"policy"`: The JSON policy document to use as the content for the new policy.
"""
function update_security_policy(
    name, policyVersion, type; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearchserverless(
        "UpdateSecurityPolicy",
        Dict{String,Any}(
            "name" => name,
            "policyVersion" => policyVersion,
            "type" => type,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_security_policy(
    name,
    policyVersion,
    type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opensearchserverless(
        "UpdateSecurityPolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "name" => name,
                    "policyVersion" => policyVersion,
                    "type" => type,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_vpc_endpoint(id)
    update_vpc_endpoint(id, params::Dict{String,<:Any})

Updates an OpenSearch Serverless-managed interface endpoint. For more information, see
Access Amazon OpenSearch Serverless using an interface endpoint.

# Arguments
- `id`: The unique identifier of the interface endpoint to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"addSecurityGroupIds"`: The unique identifiers of the security groups to add to the
  endpoint. Security groups define the ports, protocols, and sources for inbound traffic that
  you are authorizing into your endpoint.
- `"addSubnetIds"`: The ID of one or more subnets to add to the endpoint.
- `"clientToken"`: Unique, case-sensitive identifier to ensure idempotency of the request.
- `"removeSecurityGroupIds"`: The unique identifiers of the security groups to remove from
  the endpoint.
- `"removeSubnetIds"`: The unique identifiers of the subnets to remove from the endpoint.
"""
function update_vpc_endpoint(id; aws_config::AbstractAWSConfig=current_aws_config())
    return opensearchserverless(
        "UpdateVpcEndpoint",
        Dict{String,Any}("id" => id, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_vpc_endpoint(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opensearchserverless(
        "UpdateVpcEndpoint",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("id" => id, "clientToken" => string(uuid4())),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: mediastore
using AWS.Compat
using AWS.UUIDs

"""
    create_container(container_name)
    create_container(container_name, params::Dict{String,<:Any})

Creates a storage container to hold objects. A container is similar to a bucket in the
Amazon S3 service.

# Arguments
- `container_name`: The name for the container. The name must be from 1 to 255 characters.
  Container names must be unique to your AWS account within a specific region. As an example,
  you could create a container named movies in every region, as long as you don’t have an
  existing container with that name.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: An array of key:value pairs that you define. These values can be anything that
  you want. Typically, the tag key represents a category (such as \"environment\") and the
  tag value represents a specific value within that category (such as \"test,\"
  \"development,\" or \"production\"). You can add up to 50 tags to each container. For more
  information about tagging, including naming and usage conventions, see Tagging Resources in
  MediaStore.
"""
function create_container(ContainerName; aws_config::AbstractAWSConfig=current_aws_config())
    return mediastore(
        "CreateContainer",
        Dict{String,Any}("ContainerName" => ContainerName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_container(
    ContainerName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediastore(
        "CreateContainer",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ContainerName" => ContainerName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_container(container_name)
    delete_container(container_name, params::Dict{String,<:Any})

Deletes the specified container. Before you make a DeleteContainer request, delete any
objects in the container or in any folders in the container. You can delete only empty
containers.

# Arguments
- `container_name`: The name of the container to delete.

"""
function delete_container(ContainerName; aws_config::AbstractAWSConfig=current_aws_config())
    return mediastore(
        "DeleteContainer",
        Dict{String,Any}("ContainerName" => ContainerName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_container(
    ContainerName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediastore(
        "DeleteContainer",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ContainerName" => ContainerName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_container_policy(container_name)
    delete_container_policy(container_name, params::Dict{String,<:Any})

Deletes the access policy that is associated with the specified container.

# Arguments
- `container_name`: The name of the container that holds the policy.

"""
function delete_container_policy(
    ContainerName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediastore(
        "DeleteContainerPolicy",
        Dict{String,Any}("ContainerName" => ContainerName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_container_policy(
    ContainerName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediastore(
        "DeleteContainerPolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ContainerName" => ContainerName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_cors_policy(container_name)
    delete_cors_policy(container_name, params::Dict{String,<:Any})

Deletes the cross-origin resource sharing (CORS) configuration information that is set for
the container. To use this operation, you must have permission to perform the
MediaStore:DeleteCorsPolicy action. The container owner has this permission by default and
can grant this permission to others.

# Arguments
- `container_name`: The name of the container to remove the policy from.

"""
function delete_cors_policy(
    ContainerName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediastore(
        "DeleteCorsPolicy",
        Dict{String,Any}("ContainerName" => ContainerName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_cors_policy(
    ContainerName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediastore(
        "DeleteCorsPolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ContainerName" => ContainerName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_lifecycle_policy(container_name)
    delete_lifecycle_policy(container_name, params::Dict{String,<:Any})

Removes an object lifecycle policy from a container. It takes up to 20 minutes for the
change to take effect.

# Arguments
- `container_name`: The name of the container that holds the object lifecycle policy.

"""
function delete_lifecycle_policy(
    ContainerName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediastore(
        "DeleteLifecyclePolicy",
        Dict{String,Any}("ContainerName" => ContainerName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_lifecycle_policy(
    ContainerName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediastore(
        "DeleteLifecyclePolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ContainerName" => ContainerName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_metric_policy(container_name)
    delete_metric_policy(container_name, params::Dict{String,<:Any})

Deletes the metric policy that is associated with the specified container. If there is no
metric policy associated with the container, MediaStore doesn't send metrics to CloudWatch.

# Arguments
- `container_name`: The name of the container that is associated with the metric policy
  that you want to delete.

"""
function delete_metric_policy(
    ContainerName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediastore(
        "DeleteMetricPolicy",
        Dict{String,Any}("ContainerName" => ContainerName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_metric_policy(
    ContainerName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediastore(
        "DeleteMetricPolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ContainerName" => ContainerName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_container()
    describe_container(params::Dict{String,<:Any})

Retrieves the properties of the requested container. This request is commonly used to
retrieve the endpoint of a container. An endpoint is a value assigned by the service when a
new container is created. A container's endpoint does not change after it has been
assigned. The DescribeContainer request returns a single Container object based on
ContainerName. To return all Container objects that are associated with a specified AWS
account, use ListContainers.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ContainerName"`: The name of the container to query.
"""
function describe_container(; aws_config::AbstractAWSConfig=current_aws_config())
    return mediastore(
        "DescribeContainer"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_container(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediastore(
        "DescribeContainer", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_container_policy(container_name)
    get_container_policy(container_name, params::Dict{String,<:Any})

Retrieves the access policy for the specified container. For information about the data
that is included in an access policy, see the AWS Identity and Access Management User Guide.

# Arguments
- `container_name`: The name of the container.

"""
function get_container_policy(
    ContainerName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediastore(
        "GetContainerPolicy",
        Dict{String,Any}("ContainerName" => ContainerName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_container_policy(
    ContainerName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediastore(
        "GetContainerPolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ContainerName" => ContainerName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_cors_policy(container_name)
    get_cors_policy(container_name, params::Dict{String,<:Any})

Returns the cross-origin resource sharing (CORS) configuration information that is set for
the container. To use this operation, you must have permission to perform the
MediaStore:GetCorsPolicy action. By default, the container owner has this permission and
can grant it to others.

# Arguments
- `container_name`: The name of the container that the policy is assigned to.

"""
function get_cors_policy(ContainerName; aws_config::AbstractAWSConfig=current_aws_config())
    return mediastore(
        "GetCorsPolicy",
        Dict{String,Any}("ContainerName" => ContainerName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_cors_policy(
    ContainerName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediastore(
        "GetCorsPolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ContainerName" => ContainerName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_lifecycle_policy(container_name)
    get_lifecycle_policy(container_name, params::Dict{String,<:Any})

Retrieves the object lifecycle policy that is assigned to a container.

# Arguments
- `container_name`: The name of the container that the object lifecycle policy is assigned
  to.

"""
function get_lifecycle_policy(
    ContainerName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediastore(
        "GetLifecyclePolicy",
        Dict{String,Any}("ContainerName" => ContainerName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_lifecycle_policy(
    ContainerName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediastore(
        "GetLifecyclePolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ContainerName" => ContainerName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_metric_policy(container_name)
    get_metric_policy(container_name, params::Dict{String,<:Any})

Returns the metric policy for the specified container.

# Arguments
- `container_name`: The name of the container that is associated with the metric policy.

"""
function get_metric_policy(
    ContainerName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediastore(
        "GetMetricPolicy",
        Dict{String,Any}("ContainerName" => ContainerName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_metric_policy(
    ContainerName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediastore(
        "GetMetricPolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ContainerName" => ContainerName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_containers()
    list_containers(params::Dict{String,<:Any})

Lists the properties of all containers in AWS Elemental MediaStore.  You can query to
receive all the containers in one response. Or you can include the MaxResults parameter to
receive a limited number of containers in each response. In this case, the response
includes a token. To get the next set of containers, send the command again, this time with
the NextToken parameter (with the returned token as its value). The next set of responses
appears, with a token if there are still more containers to receive.  See also
DescribeContainer, which gets the properties of one container.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Enter the maximum number of containers in the response. Use from 1 to 255
  characters.
- `"NextToken"`: Only if you used MaxResults in the first command, enter the token (which
  was included in the previous response) to obtain the next set of containers. This token is
  included in a response only if there actually are more containers to list.
"""
function list_containers(; aws_config::AbstractAWSConfig=current_aws_config())
    return mediastore(
        "ListContainers"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_containers(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediastore(
        "ListContainers", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource)
    list_tags_for_resource(resource, params::Dict{String,<:Any})

Returns a list of the tags assigned to the specified container.

# Arguments
- `resource`: The Amazon Resource Name (ARN) for the container.

"""
function list_tags_for_resource(
    Resource; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediastore(
        "ListTagsForResource",
        Dict{String,Any}("Resource" => Resource);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    Resource,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediastore(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Resource" => Resource), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_container_policy(container_name, policy)
    put_container_policy(container_name, policy, params::Dict{String,<:Any})

Creates an access policy for the specified container to restrict the users and clients that
can access it. For information about the data that is included in an access policy, see the
AWS Identity and Access Management User Guide. For this release of the REST API, you can
create only one policy for a container. If you enter PutContainerPolicy twice, the second
command modifies the existing policy.

# Arguments
- `container_name`: The name of the container.
- `policy`: The contents of the policy, which includes the following:    One Version tag
  One Statement tag that contains the standard tags for the policy.

"""
function put_container_policy(
    ContainerName, Policy; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediastore(
        "PutContainerPolicy",
        Dict{String,Any}("ContainerName" => ContainerName, "Policy" => Policy);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_container_policy(
    ContainerName,
    Policy,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediastore(
        "PutContainerPolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ContainerName" => ContainerName, "Policy" => Policy),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_cors_policy(container_name, cors_policy)
    put_cors_policy(container_name, cors_policy, params::Dict{String,<:Any})

Sets the cross-origin resource sharing (CORS) configuration on a container so that the
container can service cross-origin requests. For example, you might want to enable a
request whose origin is http://www.example.com to access your AWS Elemental MediaStore
container at my.example.container.com by using the browser's XMLHttpRequest capability. To
enable CORS on a container, you attach a CORS policy to the container. In the CORS policy,
you configure rules that identify origins and the HTTP methods that can be executed on your
container. The policy can contain up to 398,000 characters. You can add up to 100 rules to
a CORS policy. If more than one rule applies, the service uses the first applicable rule
listed. To learn more about CORS, see Cross-Origin Resource Sharing (CORS) in AWS Elemental
MediaStore.

# Arguments
- `container_name`: The name of the container that you want to assign the CORS policy to.
- `cors_policy`: The CORS policy to apply to the container.

"""
function put_cors_policy(
    ContainerName, CorsPolicy; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediastore(
        "PutCorsPolicy",
        Dict{String,Any}("ContainerName" => ContainerName, "CorsPolicy" => CorsPolicy);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_cors_policy(
    ContainerName,
    CorsPolicy,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediastore(
        "PutCorsPolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ContainerName" => ContainerName, "CorsPolicy" => CorsPolicy
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_lifecycle_policy(container_name, lifecycle_policy)
    put_lifecycle_policy(container_name, lifecycle_policy, params::Dict{String,<:Any})

Writes an object lifecycle policy to a container. If the container already has an object
lifecycle policy, the service replaces the existing policy with the new policy. It takes up
to 20 minutes for the change to take effect. For information about how to construct an
object lifecycle policy, see Components of an Object Lifecycle Policy.

# Arguments
- `container_name`: The name of the container that you want to assign the object lifecycle
  policy to.
- `lifecycle_policy`: The object lifecycle policy to apply to the container.

"""
function put_lifecycle_policy(
    ContainerName, LifecyclePolicy; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediastore(
        "PutLifecyclePolicy",
        Dict{String,Any}(
            "ContainerName" => ContainerName, "LifecyclePolicy" => LifecyclePolicy
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_lifecycle_policy(
    ContainerName,
    LifecyclePolicy,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediastore(
        "PutLifecyclePolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ContainerName" => ContainerName, "LifecyclePolicy" => LifecyclePolicy
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_metric_policy(container_name, metric_policy)
    put_metric_policy(container_name, metric_policy, params::Dict{String,<:Any})

The metric policy that you want to add to the container. A metric policy allows AWS
Elemental MediaStore to send metrics to Amazon CloudWatch. It takes up to 20 minutes for
the new policy to take effect.

# Arguments
- `container_name`: The name of the container that you want to add the metric policy to.
- `metric_policy`: The metric policy that you want to associate with the container. In the
  policy, you must indicate whether you want MediaStore to send container-level metrics. You
  can also include up to five rules to define groups of objects that you want MediaStore to
  send object-level metrics for. If you include rules in the policy, construct each rule with
  both of the following:   An object group that defines which objects to include in the
  group. The definition can be a path or a file name, but it can't have more than 900
  characters. Valid characters are: a-z, A-Z, 0-9, _ (underscore), = (equal), : (colon), .
  (period), - (hyphen), ~ (tilde), / (forward slash), and * (asterisk). Wildcards (*) are
  acceptable.   An object group name that allows you to refer to the object group. The name
  can't have more than 30 characters. Valid characters are: a-z, A-Z, 0-9, and _
  (underscore).

"""
function put_metric_policy(
    ContainerName, MetricPolicy; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediastore(
        "PutMetricPolicy",
        Dict{String,Any}("ContainerName" => ContainerName, "MetricPolicy" => MetricPolicy);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_metric_policy(
    ContainerName,
    MetricPolicy,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediastore(
        "PutMetricPolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ContainerName" => ContainerName, "MetricPolicy" => MetricPolicy
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_access_logging(container_name)
    start_access_logging(container_name, params::Dict{String,<:Any})

Starts access logging on the specified container. When you enable access logging on a
container, MediaStore delivers access logs for objects stored in that container to Amazon
CloudWatch Logs.

# Arguments
- `container_name`: The name of the container that you want to start access logging on.

"""
function start_access_logging(
    ContainerName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediastore(
        "StartAccessLogging",
        Dict{String,Any}("ContainerName" => ContainerName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_access_logging(
    ContainerName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediastore(
        "StartAccessLogging",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ContainerName" => ContainerName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_access_logging(container_name)
    stop_access_logging(container_name, params::Dict{String,<:Any})

Stops access logging on the specified container. When you stop access logging on a
container, MediaStore stops sending access logs to Amazon CloudWatch Logs. These access
logs are not saved and are not retrievable.

# Arguments
- `container_name`: The name of the container that you want to stop access logging on.

"""
function stop_access_logging(
    ContainerName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediastore(
        "StopAccessLogging",
        Dict{String,Any}("ContainerName" => ContainerName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_access_logging(
    ContainerName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediastore(
        "StopAccessLogging",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ContainerName" => ContainerName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource, tags)
    tag_resource(resource, tags, params::Dict{String,<:Any})

Adds tags to the specified AWS Elemental MediaStore container. Tags are key:value pairs
that you can associate with AWS resources. For example, the tag key might be \"customer\"
and the tag value might be \"companyA.\" You can specify one or more tags to add to each
container. You can add up to 50 tags to each container. For more information about tagging,
including naming and usage conventions, see Tagging Resources in MediaStore.

# Arguments
- `resource`: The Amazon Resource Name (ARN) for the container.
- `tags`: An array of key:value pairs that you want to add to the container. You need to
  specify only the tags that you want to add or update. For example, suppose a container
  already has two tags (customer:CompanyA and priority:High). You want to change the priority
  tag and also add a third tag (type:Contract). For TagResource, you specify the following
  tags: priority:Medium, type:Contract. The result is that your container has three tags:
  customer:CompanyA, priority:Medium, and type:Contract.

"""
function tag_resource(Resource, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return mediastore(
        "TagResource",
        Dict{String,Any}("Resource" => Resource, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    Resource,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediastore(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("Resource" => Resource, "Tags" => Tags), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource, tag_keys)
    untag_resource(resource, tag_keys, params::Dict{String,<:Any})

Removes tags from the specified container. You can specify one or more tags to remove.

# Arguments
- `resource`: The Amazon Resource Name (ARN) for the container.
- `tag_keys`: A comma-separated list of keys for tags that you want to remove from the
  container. For example, if your container has two tags (customer:CompanyA and
  priority:High) and you want to remove one of the tags (priority:High), you specify the key
  for the tag that you want to remove (priority).

"""
function untag_resource(
    Resource, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediastore(
        "UntagResource",
        Dict{String,Any}("Resource" => Resource, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    Resource,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediastore(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Resource" => Resource, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: account
using AWS.Compat
using AWS.UUIDs

"""
    accept_primary_email_update(account_id, otp, primary_email)
    accept_primary_email_update(account_id, otp, primary_email, params::Dict{String,<:Any})

Accepts the request that originated from StartPrimaryEmailUpdate to update the primary
email address (also known as the root user email address) for the specified account.

# Arguments
- `account_id`: Specifies the 12-digit account ID number of the Amazon Web Services account
  that you want to access or modify with this operation. To use this parameter, the caller
  must be an identity in the organization's management account or a delegated administrator
  account. The specified account ID must be a member account in the same organization. The
  organization must have all features enabled, and the organization must have trusted access
  enabled for the Account Management service, and optionally a delegated admin account
  assigned. This operation can only be called from the management account or the delegated
  administrator account of an organization for a member account.  The management account
  can't specify its own AccountId.
- `otp`: The OTP code sent to the PrimaryEmail specified on the StartPrimaryEmailUpdate API
  call.
- `primary_email`: The new primary email address for use with the specified account. This
  must match the PrimaryEmail from the StartPrimaryEmailUpdate API call.

"""
function accept_primary_email_update(
    AccountId, Otp, PrimaryEmail; aws_config::AbstractAWSConfig=current_aws_config()
)
    return account(
        "POST",
        "/acceptPrimaryEmailUpdate",
        Dict{String,Any}(
            "AccountId" => AccountId, "Otp" => Otp, "PrimaryEmail" => PrimaryEmail
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function accept_primary_email_update(
    AccountId,
    Otp,
    PrimaryEmail,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return account(
        "POST",
        "/acceptPrimaryEmailUpdate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AccountId" => AccountId, "Otp" => Otp, "PrimaryEmail" => PrimaryEmail
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_alternate_contact(alternate_contact_type)
    delete_alternate_contact(alternate_contact_type, params::Dict{String,<:Any})

Deletes the specified alternate contact from an Amazon Web Services account. For complete
details about how to use the alternate contact operations, see Access or updating the
alternate contacts.  Before you can update the alternate contact information for an Amazon
Web Services account that is managed by Organizations, you must first enable integration
between Amazon Web Services Account Management and Organizations. For more information, see
Enabling trusted access for Amazon Web Services Account Management.

# Arguments
- `alternate_contact_type`: Specifies which of the alternate contacts to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccountId"`: Specifies the 12 digit account ID number of the Amazon Web Services
  account that you want to access or modify with this operation. If you do not specify this
  parameter, it defaults to the Amazon Web Services account of the identity used to call the
  operation. To use this parameter, the caller must be an identity in the organization's
  management account or a delegated administrator account, and the specified account ID must
  be a member account in the same organization. The organization must have all features
  enabled, and the organization must have trusted access enabled for the Account Management
  service, and optionally a delegated admin account assigned.  The management account can't
  specify its own AccountId; it must call the operation in standalone context by not
  including the AccountId parameter.  To call this operation on an account that is not a
  member of an organization, then don't specify this parameter, and call the operation using
  an identity belonging to the account whose contacts you wish to retrieve or modify.
"""
function delete_alternate_contact(
    AlternateContactType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return account(
        "POST",
        "/deleteAlternateContact",
        Dict{String,Any}("AlternateContactType" => AlternateContactType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_alternate_contact(
    AlternateContactType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return account(
        "POST",
        "/deleteAlternateContact",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("AlternateContactType" => AlternateContactType),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disable_region(region_name)
    disable_region(region_name, params::Dict{String,<:Any})

Disables (opts-out) a particular Region for an account.  The act of disabling a Region will
remove all IAM access to any resources that reside in that Region.

# Arguments
- `region_name`: Specifies the Region-code for a given Region name (for example,
  af-south-1). When you disable a Region, Amazon Web Services performs actions to deactivate
  that Region in your account, such as destroying IAM resources in the Region. This process
  takes a few minutes for most accounts, but this can take several hours. You cannot enable
  the Region until the disabling process is fully completed.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccountId"`: Specifies the 12-digit account ID number of the Amazon Web Services
  account that you want to access or modify with this operation. If you don't specify this
  parameter, it defaults to the Amazon Web Services account of the identity used to call the
  operation. To use this parameter, the caller must be an identity in the organization's
  management account or a delegated administrator account. The specified account ID must be a
  member account in the same organization. The organization must have all features enabled,
  and the organization must have trusted access enabled for the Account Management service,
  and optionally a delegated admin account assigned.  The management account can't specify
  its own AccountId. It must call the operation in standalone context by not including the
  AccountId parameter.  To call this operation on an account that is not a member of an
  organization, don't specify this parameter. Instead, call the operation using an identity
  belonging to the account whose contacts you wish to retrieve or modify.
"""
function disable_region(RegionName; aws_config::AbstractAWSConfig=current_aws_config())
    return account(
        "POST",
        "/disableRegion",
        Dict{String,Any}("RegionName" => RegionName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disable_region(
    RegionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return account(
        "POST",
        "/disableRegion",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("RegionName" => RegionName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    enable_region(region_name)
    enable_region(region_name, params::Dict{String,<:Any})

Enables (opts-in) a particular Region for an account.

# Arguments
- `region_name`: Specifies the Region-code for a given Region name (for example,
  af-south-1). When you enable a Region, Amazon Web Services performs actions to prepare your
  account in that Region, such as distributing your IAM resources to the Region. This process
  takes a few minutes for most accounts, but it can take several hours. You cannot use the
  Region until this process is complete. Furthermore, you cannot disable the Region until the
  enabling process is fully completed.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccountId"`: Specifies the 12-digit account ID number of the Amazon Web Services
  account that you want to access or modify with this operation. If you don't specify this
  parameter, it defaults to the Amazon Web Services account of the identity used to call the
  operation. To use this parameter, the caller must be an identity in the organization's
  management account or a delegated administrator account. The specified account ID must be a
  member account in the same organization. The organization must have all features enabled,
  and the organization must have trusted access enabled for the Account Management service,
  and optionally a delegated admin account assigned.  The management account can't specify
  its own AccountId. It must call the operation in standalone context by not including the
  AccountId parameter.  To call this operation on an account that is not a member of an
  organization, don't specify this parameter. Instead, call the operation using an identity
  belonging to the account whose contacts you wish to retrieve or modify.
"""
function enable_region(RegionName; aws_config::AbstractAWSConfig=current_aws_config())
    return account(
        "POST",
        "/enableRegion",
        Dict{String,Any}("RegionName" => RegionName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function enable_region(
    RegionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return account(
        "POST",
        "/enableRegion",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("RegionName" => RegionName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_alternate_contact(alternate_contact_type)
    get_alternate_contact(alternate_contact_type, params::Dict{String,<:Any})

Retrieves the specified alternate contact attached to an Amazon Web Services account. For
complete details about how to use the alternate contact operations, see Access or updating
the alternate contacts.  Before you can update the alternate contact information for an
Amazon Web Services account that is managed by Organizations, you must first enable
integration between Amazon Web Services Account Management and Organizations. For more
information, see Enabling trusted access for Amazon Web Services Account Management.

# Arguments
- `alternate_contact_type`: Specifies which alternate contact you want to retrieve.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccountId"`: Specifies the 12 digit account ID number of the Amazon Web Services
  account that you want to access or modify with this operation. If you do not specify this
  parameter, it defaults to the Amazon Web Services account of the identity used to call the
  operation. To use this parameter, the caller must be an identity in the organization's
  management account or a delegated administrator account, and the specified account ID must
  be a member account in the same organization. The organization must have all features
  enabled, and the organization must have trusted access enabled for the Account Management
  service, and optionally a delegated admin account assigned.  The management account can't
  specify its own AccountId; it must call the operation in standalone context by not
  including the AccountId parameter.  To call this operation on an account that is not a
  member of an organization, then don't specify this parameter, and call the operation using
  an identity belonging to the account whose contacts you wish to retrieve or modify.
"""
function get_alternate_contact(
    AlternateContactType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return account(
        "POST",
        "/getAlternateContact",
        Dict{String,Any}("AlternateContactType" => AlternateContactType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_alternate_contact(
    AlternateContactType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return account(
        "POST",
        "/getAlternateContact",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("AlternateContactType" => AlternateContactType),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_contact_information()
    get_contact_information(params::Dict{String,<:Any})

Retrieves the primary contact information of an Amazon Web Services account. For complete
details about how to use the primary contact operations, see Update the primary and
alternate contact information.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccountId"`: Specifies the 12-digit account ID number of the Amazon Web Services
  account that you want to access or modify with this operation. If you don't specify this
  parameter, it defaults to the Amazon Web Services account of the identity used to call the
  operation. To use this parameter, the caller must be an identity in the organization's
  management account or a delegated administrator account. The specified account ID must be a
  member account in the same organization. The organization must have all features enabled,
  and the organization must have trusted access enabled for the Account Management service,
  and optionally a delegated admin account assigned.  The management account can't specify
  its own AccountId. It must call the operation in standalone context by not including the
  AccountId parameter.  To call this operation on an account that is not a member of an
  organization, don't specify this parameter. Instead, call the operation using an identity
  belonging to the account whose contacts you wish to retrieve or modify.
"""
function get_contact_information(; aws_config::AbstractAWSConfig=current_aws_config())
    return account(
        "POST",
        "/getContactInformation";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_contact_information(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return account(
        "POST",
        "/getContactInformation",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_primary_email(account_id)
    get_primary_email(account_id, params::Dict{String,<:Any})

Retrieves the primary email address for the specified account.

# Arguments
- `account_id`: Specifies the 12-digit account ID number of the Amazon Web Services account
  that you want to access or modify with this operation. To use this parameter, the caller
  must be an identity in the organization's management account or a delegated administrator
  account. The specified account ID must be a member account in the same organization. The
  organization must have all features enabled, and the organization must have trusted access
  enabled for the Account Management service, and optionally a delegated admin account
  assigned. This operation can only be called from the management account or the delegated
  administrator account of an organization for a member account.  The management account
  can't specify its own AccountId.

"""
function get_primary_email(AccountId; aws_config::AbstractAWSConfig=current_aws_config())
    return account(
        "POST",
        "/getPrimaryEmail",
        Dict{String,Any}("AccountId" => AccountId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_primary_email(
    AccountId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return account(
        "POST",
        "/getPrimaryEmail",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AccountId" => AccountId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_region_opt_status(region_name)
    get_region_opt_status(region_name, params::Dict{String,<:Any})

Retrieves the opt-in status of a particular Region.

# Arguments
- `region_name`: Specifies the Region-code for a given Region name (for example,
  af-south-1). This function will return the status of whatever Region you pass into this
  parameter.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccountId"`: Specifies the 12-digit account ID number of the Amazon Web Services
  account that you want to access or modify with this operation. If you don't specify this
  parameter, it defaults to the Amazon Web Services account of the identity used to call the
  operation. To use this parameter, the caller must be an identity in the organization's
  management account or a delegated administrator account. The specified account ID must be a
  member account in the same organization. The organization must have all features enabled,
  and the organization must have trusted access enabled for the Account Management service,
  and optionally a delegated admin account assigned.  The management account can't specify
  its own AccountId. It must call the operation in standalone context by not including the
  AccountId parameter.  To call this operation on an account that is not a member of an
  organization, don't specify this parameter. Instead, call the operation using an identity
  belonging to the account whose contacts you wish to retrieve or modify.
"""
function get_region_opt_status(
    RegionName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return account(
        "POST",
        "/getRegionOptStatus",
        Dict{String,Any}("RegionName" => RegionName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_region_opt_status(
    RegionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return account(
        "POST",
        "/getRegionOptStatus",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("RegionName" => RegionName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_regions()
    list_regions(params::Dict{String,<:Any})

Lists all the Regions for a given account and their respective opt-in statuses. Optionally,
this list can be filtered by the region-opt-status-contains parameter.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccountId"`: Specifies the 12-digit account ID number of the Amazon Web Services
  account that you want to access or modify with this operation. If you don't specify this
  parameter, it defaults to the Amazon Web Services account of the identity used to call the
  operation. To use this parameter, the caller must be an identity in the organization's
  management account or a delegated administrator account. The specified account ID must be a
  member account in the same organization. The organization must have all features enabled,
  and the organization must have trusted access enabled for the Account Management service,
  and optionally a delegated admin account assigned.  The management account can't specify
  its own AccountId. It must call the operation in standalone context by not including the
  AccountId parameter.  To call this operation on an account that is not a member of an
  organization, don't specify this parameter. Instead, call the operation using an identity
  belonging to the account whose contacts you wish to retrieve or modify.
- `"MaxResults"`: The total number of items to return in the command’s output. If the
  total number of items available is more than the value specified, a NextToken is provided
  in the command’s output. To resume pagination, provide the NextToken value in the
  starting-token argument of a subsequent command. Do not use the NextToken response element
  directly outside of the Amazon Web Services CLI. For usage examples, see Pagination in the
  Amazon Web Services Command Line Interface User Guide.
- `"NextToken"`: A token used to specify where to start paginating. This is the NextToken
  from a previously truncated response. For usage examples, see Pagination in the Amazon Web
  Services Command Line Interface User Guide.
- `"RegionOptStatusContains"`: A list of Region statuses (Enabling, Enabled, Disabling,
  Disabled, Enabled_by_default) to use to filter the list of Regions for a given account. For
  example, passing in a value of ENABLING will only return a list of Regions with a Region
  status of ENABLING.
"""
function list_regions(; aws_config::AbstractAWSConfig=current_aws_config())
    return account(
        "POST", "/listRegions"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_regions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return account(
        "POST",
        "/listRegions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_alternate_contact(alternate_contact_type, email_address, name, phone_number, title)
    put_alternate_contact(alternate_contact_type, email_address, name, phone_number, title, params::Dict{String,<:Any})

Modifies the specified alternate contact attached to an Amazon Web Services account. For
complete details about how to use the alternate contact operations, see Access or updating
the alternate contacts.  Before you can update the alternate contact information for an
Amazon Web Services account that is managed by Organizations, you must first enable
integration between Amazon Web Services Account Management and Organizations. For more
information, see Enabling trusted access for Amazon Web Services Account Management.

# Arguments
- `alternate_contact_type`: Specifies which alternate contact you want to create or update.
- `email_address`: Specifies an email address for the alternate contact.
- `name`: Specifies a name for the alternate contact.
- `phone_number`: Specifies a phone number for the alternate contact.
- `title`: Specifies a title for the alternate contact.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccountId"`: Specifies the 12 digit account ID number of the Amazon Web Services
  account that you want to access or modify with this operation. If you do not specify this
  parameter, it defaults to the Amazon Web Services account of the identity used to call the
  operation. To use this parameter, the caller must be an identity in the organization's
  management account or a delegated administrator account, and the specified account ID must
  be a member account in the same organization. The organization must have all features
  enabled, and the organization must have trusted access enabled for the Account Management
  service, and optionally a delegated admin account assigned.  The management account can't
  specify its own AccountId; it must call the operation in standalone context by not
  including the AccountId parameter.  To call this operation on an account that is not a
  member of an organization, then don't specify this parameter, and call the operation using
  an identity belonging to the account whose contacts you wish to retrieve or modify.
"""
function put_alternate_contact(
    AlternateContactType,
    EmailAddress,
    Name,
    PhoneNumber,
    Title;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return account(
        "POST",
        "/putAlternateContact",
        Dict{String,Any}(
            "AlternateContactType" => AlternateContactType,
            "EmailAddress" => EmailAddress,
            "Name" => Name,
            "PhoneNumber" => PhoneNumber,
            "Title" => Title,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_alternate_contact(
    AlternateContactType,
    EmailAddress,
    Name,
    PhoneNumber,
    Title,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return account(
        "POST",
        "/putAlternateContact",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AlternateContactType" => AlternateContactType,
                    "EmailAddress" => EmailAddress,
                    "Name" => Name,
                    "PhoneNumber" => PhoneNumber,
                    "Title" => Title,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_contact_information(contact_information)
    put_contact_information(contact_information, params::Dict{String,<:Any})

Updates the primary contact information of an Amazon Web Services account. For complete
details about how to use the primary contact operations, see Update the primary and
alternate contact information.

# Arguments
- `contact_information`: Contains the details of the primary contact information associated
  with an Amazon Web Services account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccountId"`: Specifies the 12-digit account ID number of the Amazon Web Services
  account that you want to access or modify with this operation. If you don't specify this
  parameter, it defaults to the Amazon Web Services account of the identity used to call the
  operation. To use this parameter, the caller must be an identity in the organization's
  management account or a delegated administrator account. The specified account ID must be a
  member account in the same organization. The organization must have all features enabled,
  and the organization must have trusted access enabled for the Account Management service,
  and optionally a delegated admin account assigned.  The management account can't specify
  its own AccountId. It must call the operation in standalone context by not including the
  AccountId parameter.  To call this operation on an account that is not a member of an
  organization, don't specify this parameter. Instead, call the operation using an identity
  belonging to the account whose contacts you wish to retrieve or modify.
"""
function put_contact_information(
    ContactInformation; aws_config::AbstractAWSConfig=current_aws_config()
)
    return account(
        "POST",
        "/putContactInformation",
        Dict{String,Any}("ContactInformation" => ContactInformation);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_contact_information(
    ContactInformation,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return account(
        "POST",
        "/putContactInformation",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ContactInformation" => ContactInformation), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_primary_email_update(account_id, primary_email)
    start_primary_email_update(account_id, primary_email, params::Dict{String,<:Any})

Starts the process to update the primary email address for the specified account.

# Arguments
- `account_id`: Specifies the 12-digit account ID number of the Amazon Web Services account
  that you want to access or modify with this operation. To use this parameter, the caller
  must be an identity in the organization's management account or a delegated administrator
  account. The specified account ID must be a member account in the same organization. The
  organization must have all features enabled, and the organization must have trusted access
  enabled for the Account Management service, and optionally a delegated admin account
  assigned. This operation can only be called from the management account or the delegated
  administrator account of an organization for a member account.  The management account
  can't specify its own AccountId.
- `primary_email`: The new primary email address (also known as the root user email
  address) to use in the specified account.

"""
function start_primary_email_update(
    AccountId, PrimaryEmail; aws_config::AbstractAWSConfig=current_aws_config()
)
    return account(
        "POST",
        "/startPrimaryEmailUpdate",
        Dict{String,Any}("AccountId" => AccountId, "PrimaryEmail" => PrimaryEmail);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_primary_email_update(
    AccountId,
    PrimaryEmail,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return account(
        "POST",
        "/startPrimaryEmailUpdate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("AccountId" => AccountId, "PrimaryEmail" => PrimaryEmail),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: iottwinmaker
using AWS.Compat
using AWS.UUIDs

"""
    batch_put_property_values(entries, workspace_id)
    batch_put_property_values(entries, workspace_id, params::Dict{String,<:Any})

Sets values for multiple time series properties.

# Arguments
- `entries`: An object that maps strings to the property value entries to set. Each string
  in the mapping must be unique to this object.
- `workspace_id`: The ID of the workspace that contains the properties to set.

"""
function batch_put_property_values(
    entries, workspaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iottwinmaker(
        "POST",
        "/workspaces/$(workspaceId)/entity-properties",
        Dict{String,Any}("entries" => entries);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_put_property_values(
    entries,
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iottwinmaker(
        "POST",
        "/workspaces/$(workspaceId)/entity-properties",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("entries" => entries), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_metadata_transfer_job(metadata_transfer_job_id)
    cancel_metadata_transfer_job(metadata_transfer_job_id, params::Dict{String,<:Any})

Cancels the metadata transfer job.

# Arguments
- `metadata_transfer_job_id`: The metadata transfer job Id.

"""
function cancel_metadata_transfer_job(
    metadataTransferJobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iottwinmaker(
        "PUT",
        "/metadata-transfer-jobs/$(metadataTransferJobId)/cancel";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_metadata_transfer_job(
    metadataTransferJobId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iottwinmaker(
        "PUT",
        "/metadata-transfer-jobs/$(metadataTransferJobId)/cancel",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_component_type(component_type_id, workspace_id)
    create_component_type(component_type_id, workspace_id, params::Dict{String,<:Any})

Creates a component type.

# Arguments
- `component_type_id`: The ID of the component type.
- `workspace_id`: The ID of the workspace that contains the component type.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"componentTypeName"`: A friendly name for the component type.
- `"compositeComponentTypes"`: This is an object that maps strings to
  compositeComponentTypes of the componentType. CompositeComponentType is referenced by
  componentTypeId.
- `"description"`: The description of the component type.
- `"extendsFrom"`: Specifies the parent component type to extend.
- `"functions"`: An object that maps strings to the functions in the component type. Each
  string in the mapping must be unique to this object.
- `"isSingleton"`: A Boolean value that specifies whether an entity can have more than one
  component of this type.
- `"propertyDefinitions"`: An object that maps strings to the property definitions in the
  component type. Each string in the mapping must be unique to this object.
- `"propertyGroups"`:
- `"tags"`: Metadata that you can use to manage the component type.
"""
function create_component_type(
    componentTypeId, workspaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iottwinmaker(
        "POST",
        "/workspaces/$(workspaceId)/component-types/$(componentTypeId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_component_type(
    componentTypeId,
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iottwinmaker(
        "POST",
        "/workspaces/$(workspaceId)/component-types/$(componentTypeId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_entity(entity_name, workspace_id)
    create_entity(entity_name, workspace_id, params::Dict{String,<:Any})

Creates an entity.

# Arguments
- `entity_name`: The name of the entity.
- `workspace_id`: The ID of the workspace that contains the entity.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"components"`: An object that maps strings to the components in the entity. Each string
  in the mapping must be unique to this object.
- `"compositeComponents"`: This is an object that maps strings to compositeComponent
  updates in the request. Each key of the map represents the componentPath of the
  compositeComponent.
- `"description"`: The description of the entity.
- `"entityId"`: The ID of the entity.
- `"parentEntityId"`: The ID of the entity's parent entity.
- `"tags"`: Metadata that you can use to manage the entity.
"""
function create_entity(
    entityName, workspaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iottwinmaker(
        "POST",
        "/workspaces/$(workspaceId)/entities",
        Dict{String,Any}("entityName" => entityName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_entity(
    entityName,
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iottwinmaker(
        "POST",
        "/workspaces/$(workspaceId)/entities",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("entityName" => entityName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_metadata_transfer_job(destination, sources)
    create_metadata_transfer_job(destination, sources, params::Dict{String,<:Any})

Creates a new metadata transfer job.

# Arguments
- `destination`: The metadata transfer job destination.
- `sources`: The metadata transfer job sources.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The metadata transfer job description.
- `"metadataTransferJobId"`: The metadata transfer job Id.
"""
function create_metadata_transfer_job(
    destination, sources; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iottwinmaker(
        "POST",
        "/metadata-transfer-jobs",
        Dict{String,Any}("destination" => destination, "sources" => sources);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_metadata_transfer_job(
    destination,
    sources,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iottwinmaker(
        "POST",
        "/metadata-transfer-jobs",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("destination" => destination, "sources" => sources),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_scene(content_location, scene_id, workspace_id)
    create_scene(content_location, scene_id, workspace_id, params::Dict{String,<:Any})

Creates a scene.

# Arguments
- `content_location`: The relative path that specifies the location of the content
  definition file.
- `scene_id`: The ID of the scene.
- `workspace_id`: The ID of the workspace that contains the scene.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"capabilities"`: A list of capabilities that the scene uses to render itself.
- `"description"`: The description for this scene.
- `"sceneMetadata"`: The request metadata.
- `"tags"`: Metadata that you can use to manage the scene.
"""
function create_scene(
    contentLocation,
    sceneId,
    workspaceId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iottwinmaker(
        "POST",
        "/workspaces/$(workspaceId)/scenes",
        Dict{String,Any}("contentLocation" => contentLocation, "sceneId" => sceneId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_scene(
    contentLocation,
    sceneId,
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iottwinmaker(
        "POST",
        "/workspaces/$(workspaceId)/scenes",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "contentLocation" => contentLocation, "sceneId" => sceneId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_sync_job(sync_role, sync_source, workspace_id)
    create_sync_job(sync_role, sync_source, workspace_id, params::Dict{String,<:Any})

This action creates a SyncJob.

# Arguments
- `sync_role`: The SyncJob IAM role. This IAM role is used by the SyncJob to read from the
  syncSource, and create, update, or delete the corresponding resources.
- `sync_source`: The sync source.  Currently the only supported syncSoource is SITEWISE .
- `workspace_id`: The workspace ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tags"`: The SyncJob tags.
"""
function create_sync_job(
    syncRole, syncSource, workspaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iottwinmaker(
        "POST",
        "/workspaces/$(workspaceId)/sync-jobs/$(syncSource)",
        Dict{String,Any}("syncRole" => syncRole);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_sync_job(
    syncRole,
    syncSource,
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iottwinmaker(
        "POST",
        "/workspaces/$(workspaceId)/sync-jobs/$(syncSource)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("syncRole" => syncRole), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_workspace(workspace_id)
    create_workspace(workspace_id, params::Dict{String,<:Any})

Creates a workplace.

# Arguments
- `workspace_id`: The ID of the workspace.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description of the workspace.
- `"role"`: The ARN of the execution role associated with the workspace.
- `"s3Location"`: The ARN of the S3 bucket where resources associated with the workspace
  are stored.
- `"tags"`: Metadata that you can use to manage the workspace
"""
function create_workspace(workspaceId; aws_config::AbstractAWSConfig=current_aws_config())
    return iottwinmaker(
        "POST",
        "/workspaces/$(workspaceId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_workspace(
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iottwinmaker(
        "POST",
        "/workspaces/$(workspaceId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_component_type(component_type_id, workspace_id)
    delete_component_type(component_type_id, workspace_id, params::Dict{String,<:Any})

Deletes a component type.

# Arguments
- `component_type_id`: The ID of the component type to delete.
- `workspace_id`: The ID of the workspace that contains the component type.

"""
function delete_component_type(
    componentTypeId, workspaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iottwinmaker(
        "DELETE",
        "/workspaces/$(workspaceId)/component-types/$(componentTypeId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_component_type(
    componentTypeId,
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iottwinmaker(
        "DELETE",
        "/workspaces/$(workspaceId)/component-types/$(componentTypeId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_entity(entity_id, workspace_id)
    delete_entity(entity_id, workspace_id, params::Dict{String,<:Any})

Deletes an entity.

# Arguments
- `entity_id`: The ID of the entity to delete.
- `workspace_id`: The ID of the workspace that contains the entity to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"isRecursive"`: A Boolean value that specifies whether the operation deletes child
  entities.
"""
function delete_entity(
    entityId, workspaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iottwinmaker(
        "DELETE",
        "/workspaces/$(workspaceId)/entities/$(entityId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_entity(
    entityId,
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iottwinmaker(
        "DELETE",
        "/workspaces/$(workspaceId)/entities/$(entityId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_scene(scene_id, workspace_id)
    delete_scene(scene_id, workspace_id, params::Dict{String,<:Any})

Deletes a scene.

# Arguments
- `scene_id`: The ID of the scene to delete.
- `workspace_id`: The ID of the workspace.

"""
function delete_scene(
    sceneId, workspaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iottwinmaker(
        "DELETE",
        "/workspaces/$(workspaceId)/scenes/$(sceneId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_scene(
    sceneId,
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iottwinmaker(
        "DELETE",
        "/workspaces/$(workspaceId)/scenes/$(sceneId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_sync_job(sync_source, workspace_id)
    delete_sync_job(sync_source, workspace_id, params::Dict{String,<:Any})

Delete the SyncJob.

# Arguments
- `sync_source`: The sync source.  Currently the only supported syncSource is SITEWISE .
- `workspace_id`: The workspace ID.

"""
function delete_sync_job(
    syncSource, workspaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iottwinmaker(
        "DELETE",
        "/workspaces/$(workspaceId)/sync-jobs/$(syncSource)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_sync_job(
    syncSource,
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iottwinmaker(
        "DELETE",
        "/workspaces/$(workspaceId)/sync-jobs/$(syncSource)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_workspace(workspace_id)
    delete_workspace(workspace_id, params::Dict{String,<:Any})

Deletes a workspace.

# Arguments
- `workspace_id`: The ID of the workspace to delete.

"""
function delete_workspace(workspaceId; aws_config::AbstractAWSConfig=current_aws_config())
    return iottwinmaker(
        "DELETE",
        "/workspaces/$(workspaceId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_workspace(
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iottwinmaker(
        "DELETE",
        "/workspaces/$(workspaceId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    execute_query(query_statement, workspace_id)
    execute_query(query_statement, workspace_id, params::Dict{String,<:Any})

Run queries to access information from your knowledge graph of entities within individual
workspaces.  The ExecuteQuery action only works with Amazon Web Services Java SDK2.
ExecuteQuery will not work with any Amazon Web Services Java SDK version &lt; 2.x.

# Arguments
- `query_statement`: The query statement.
- `workspace_id`: The ID of the workspace.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return at one time. The default is 50.
- `"nextToken"`: The string that specifies the next page of results.
"""
function execute_query(
    queryStatement, workspaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iottwinmaker(
        "POST",
        "/queries/execution",
        Dict{String,Any}("queryStatement" => queryStatement, "workspaceId" => workspaceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function execute_query(
    queryStatement,
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iottwinmaker(
        "POST",
        "/queries/execution",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "queryStatement" => queryStatement, "workspaceId" => workspaceId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_component_type(component_type_id, workspace_id)
    get_component_type(component_type_id, workspace_id, params::Dict{String,<:Any})

Retrieves information about a component type.

# Arguments
- `component_type_id`: The ID of the component type.
- `workspace_id`: The ID of the workspace that contains the component type.

"""
function get_component_type(
    componentTypeId, workspaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iottwinmaker(
        "GET",
        "/workspaces/$(workspaceId)/component-types/$(componentTypeId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_component_type(
    componentTypeId,
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iottwinmaker(
        "GET",
        "/workspaces/$(workspaceId)/component-types/$(componentTypeId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_entity(entity_id, workspace_id)
    get_entity(entity_id, workspace_id, params::Dict{String,<:Any})

Retrieves information about an entity.

# Arguments
- `entity_id`: The ID of the entity.
- `workspace_id`: The ID of the workspace.

"""
function get_entity(
    entityId, workspaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iottwinmaker(
        "GET",
        "/workspaces/$(workspaceId)/entities/$(entityId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_entity(
    entityId,
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iottwinmaker(
        "GET",
        "/workspaces/$(workspaceId)/entities/$(entityId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_metadata_transfer_job(metadata_transfer_job_id)
    get_metadata_transfer_job(metadata_transfer_job_id, params::Dict{String,<:Any})

Gets a nmetadata transfer job.

# Arguments
- `metadata_transfer_job_id`: The metadata transfer job Id.

"""
function get_metadata_transfer_job(
    metadataTransferJobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iottwinmaker(
        "GET",
        "/metadata-transfer-jobs/$(metadataTransferJobId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_metadata_transfer_job(
    metadataTransferJobId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iottwinmaker(
        "GET",
        "/metadata-transfer-jobs/$(metadataTransferJobId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_pricing_plan()
    get_pricing_plan(params::Dict{String,<:Any})

Gets the pricing plan.

"""
function get_pricing_plan(; aws_config::AbstractAWSConfig=current_aws_config())
    return iottwinmaker(
        "GET", "/pricingplan"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_pricing_plan(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iottwinmaker(
        "GET",
        "/pricingplan",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_property_value(selected_properties, workspace_id)
    get_property_value(selected_properties, workspace_id, params::Dict{String,<:Any})

Gets the property values for a component, component type, entity, or workspace. You must
specify a value for either componentName, componentTypeId, entityId, or workspaceId.

# Arguments
- `selected_properties`: The properties whose values the operation returns.
- `workspace_id`: The ID of the workspace whose values the operation returns.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"componentName"`: The name of the component whose property values the operation returns.
- `"componentPath"`: This string specifies the path to the composite component, starting
  from the top-level component.
- `"componentTypeId"`: The ID of the component type whose property values the operation
  returns.
- `"entityId"`: The ID of the entity whose property values the operation returns.
- `"maxResults"`: The maximum number of results to return at one time. The default is 25.
  Valid Range: Minimum value of 1. Maximum value of 250.
- `"nextToken"`: The string that specifies the next page of results.
- `"propertyGroupName"`: The property group name.
- `"tabularConditions"`: The tabular conditions.
"""
function get_property_value(
    selectedProperties, workspaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iottwinmaker(
        "POST",
        "/workspaces/$(workspaceId)/entity-properties/value",
        Dict{String,Any}("selectedProperties" => selectedProperties);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_property_value(
    selectedProperties,
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iottwinmaker(
        "POST",
        "/workspaces/$(workspaceId)/entity-properties/value",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("selectedProperties" => selectedProperties), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_property_value_history(selected_properties, workspace_id)
    get_property_value_history(selected_properties, workspace_id, params::Dict{String,<:Any})

Retrieves information about the history of a time series property value for a component,
component type, entity, or workspace. You must specify a value for workspaceId. For
entity-specific queries, specify values for componentName and entityId. For cross-entity
quries, specify a value for componentTypeId.

# Arguments
- `selected_properties`: A list of properties whose value histories the request retrieves.
- `workspace_id`: The ID of the workspace.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"componentName"`: The name of the component.
- `"componentPath"`: This string specifies the path to the composite component, starting
  from the top-level component.
- `"componentTypeId"`: The ID of the component type.
- `"endDateTime"`: The date and time of the latest property value to return.
- `"endTime"`: The ISO8601 DateTime of the latest property value to return. For more
  information about the ISO8601 DateTime format, see the data type PropertyValue.
- `"entityId"`: The ID of the entity.
- `"interpolation"`: An object that specifies the interpolation type and the interval over
  which to interpolate data.
- `"maxResults"`: The maximum number of results to return at one time. The default is 25.
  Valid Range: Minimum value of 1. Maximum value of 250.
- `"nextToken"`: The string that specifies the next page of results.
- `"orderByTime"`: The time direction to use in the result order.
- `"propertyFilters"`: A list of objects that filter the property value history request.
- `"startDateTime"`: The date and time of the earliest property value to return.
- `"startTime"`: The ISO8601 DateTime of the earliest property value to return. For more
  information about the ISO8601 DateTime format, see the data type PropertyValue.
"""
function get_property_value_history(
    selectedProperties, workspaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iottwinmaker(
        "POST",
        "/workspaces/$(workspaceId)/entity-properties/history",
        Dict{String,Any}("selectedProperties" => selectedProperties);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_property_value_history(
    selectedProperties,
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iottwinmaker(
        "POST",
        "/workspaces/$(workspaceId)/entity-properties/history",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("selectedProperties" => selectedProperties), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_scene(scene_id, workspace_id)
    get_scene(scene_id, workspace_id, params::Dict{String,<:Any})

Retrieves information about a scene.

# Arguments
- `scene_id`: The ID of the scene.
- `workspace_id`: The ID of the workspace that contains the scene.

"""
function get_scene(sceneId, workspaceId; aws_config::AbstractAWSConfig=current_aws_config())
    return iottwinmaker(
        "GET",
        "/workspaces/$(workspaceId)/scenes/$(sceneId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_scene(
    sceneId,
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iottwinmaker(
        "GET",
        "/workspaces/$(workspaceId)/scenes/$(sceneId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_sync_job(sync_source)
    get_sync_job(sync_source, params::Dict{String,<:Any})

Gets the SyncJob.

# Arguments
- `sync_source`: The sync source.  Currently the only supported syncSource is SITEWISE .

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"workspace"`: The workspace ID.
"""
function get_sync_job(syncSource; aws_config::AbstractAWSConfig=current_aws_config())
    return iottwinmaker(
        "GET",
        "/sync-jobs/$(syncSource)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_sync_job(
    syncSource,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iottwinmaker(
        "GET",
        "/sync-jobs/$(syncSource)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_workspace(workspace_id)
    get_workspace(workspace_id, params::Dict{String,<:Any})

Retrieves information about a workspace.

# Arguments
- `workspace_id`: The ID of the workspace.

"""
function get_workspace(workspaceId; aws_config::AbstractAWSConfig=current_aws_config())
    return iottwinmaker(
        "GET",
        "/workspaces/$(workspaceId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_workspace(
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iottwinmaker(
        "GET",
        "/workspaces/$(workspaceId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_component_types(workspace_id)
    list_component_types(workspace_id, params::Dict{String,<:Any})

Lists all component types in a workspace.

# Arguments
- `workspace_id`: The ID of the workspace.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: A list of objects that filter the request.
- `"maxResults"`: The maximum number of results to return at one time. The default is 25.
  Valid Range: Minimum value of 1. Maximum value of 250.
- `"nextToken"`: The string that specifies the next page of results.
"""
function list_component_types(
    workspaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iottwinmaker(
        "POST",
        "/workspaces/$(workspaceId)/component-types-list";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_component_types(
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iottwinmaker(
        "POST",
        "/workspaces/$(workspaceId)/component-types-list",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_components(entity_id, workspace_id)
    list_components(entity_id, workspace_id, params::Dict{String,<:Any})

This API lists the components of an entity.

# Arguments
- `entity_id`: The ID for the entity whose metadata (component/properties) is returned by
  the operation.
- `workspace_id`: The workspace ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"componentPath"`: This string specifies the path to the composite component, starting
  from the top-level component.
- `"maxResults"`: The maximum number of results returned at one time. The default is 25.
- `"nextToken"`: The string that specifies the next page of results.
"""
function list_components(
    entityId, workspaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iottwinmaker(
        "POST",
        "/workspaces/$(workspaceId)/entities/$(entityId)/components-list";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_components(
    entityId,
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iottwinmaker(
        "POST",
        "/workspaces/$(workspaceId)/entities/$(entityId)/components-list",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_entities(workspace_id)
    list_entities(workspace_id, params::Dict{String,<:Any})

Lists all entities in a workspace.

# Arguments
- `workspace_id`: The ID of the workspace.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: A list of objects that filter the request.  Only one object is accepted as a
  valid input.
- `"maxResults"`: The maximum number of results to return at one time. The default is 25.
  Valid Range: Minimum value of 1. Maximum value of 250.
- `"nextToken"`: The string that specifies the next page of results.
"""
function list_entities(workspaceId; aws_config::AbstractAWSConfig=current_aws_config())
    return iottwinmaker(
        "POST",
        "/workspaces/$(workspaceId)/entities-list";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_entities(
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iottwinmaker(
        "POST",
        "/workspaces/$(workspaceId)/entities-list",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_metadata_transfer_jobs(destination_type, source_type)
    list_metadata_transfer_jobs(destination_type, source_type, params::Dict{String,<:Any})

Lists the metadata transfer jobs.

# Arguments
- `destination_type`: The metadata transfer job's destination type.
- `source_type`: The metadata transfer job's source type.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: An object that filters metadata transfer jobs.
- `"maxResults"`: The maximum number of results to return at one time.
- `"nextToken"`: The string that specifies the next page of results.
"""
function list_metadata_transfer_jobs(
    destinationType, sourceType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iottwinmaker(
        "POST",
        "/metadata-transfer-jobs-list",
        Dict{String,Any}("destinationType" => destinationType, "sourceType" => sourceType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_metadata_transfer_jobs(
    destinationType,
    sourceType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iottwinmaker(
        "POST",
        "/metadata-transfer-jobs-list",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "destinationType" => destinationType, "sourceType" => sourceType
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_properties(entity_id, workspace_id)
    list_properties(entity_id, workspace_id, params::Dict{String,<:Any})

This API lists the properties of a component.

# Arguments
- `entity_id`: The ID for the entity whose metadata (component/properties) is returned by
  the operation.
- `workspace_id`: The workspace ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"componentName"`: The name of the component whose properties are returned by the
  operation.
- `"componentPath"`: This string specifies the path to the composite component, starting
  from the top-level component.
- `"maxResults"`: The maximum number of results returned at one time. The default is 25.
- `"nextToken"`: The string that specifies the next page of results.
"""
function list_properties(
    entityId, workspaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iottwinmaker(
        "POST",
        "/workspaces/$(workspaceId)/properties-list",
        Dict{String,Any}("entityId" => entityId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_properties(
    entityId,
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iottwinmaker(
        "POST",
        "/workspaces/$(workspaceId)/properties-list",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("entityId" => entityId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_scenes(workspace_id)
    list_scenes(workspace_id, params::Dict{String,<:Any})

Lists all scenes in a workspace.

# Arguments
- `workspace_id`: The ID of the workspace that contains the scenes.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Specifies the maximum number of results to display.
- `"nextToken"`: The string that specifies the next page of results.
"""
function list_scenes(workspaceId; aws_config::AbstractAWSConfig=current_aws_config())
    return iottwinmaker(
        "POST",
        "/workspaces/$(workspaceId)/scenes-list";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_scenes(
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iottwinmaker(
        "POST",
        "/workspaces/$(workspaceId)/scenes-list",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_sync_jobs(workspace_id)
    list_sync_jobs(workspace_id, params::Dict{String,<:Any})

List all SyncJobs.

# Arguments
- `workspace_id`: The ID of the workspace that contains the sync job.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return at one time. The default is 50.
  Valid Range: Minimum value of 0. Maximum value of 200.
- `"nextToken"`: The string that specifies the next page of results.
"""
function list_sync_jobs(workspaceId; aws_config::AbstractAWSConfig=current_aws_config())
    return iottwinmaker(
        "POST",
        "/workspaces/$(workspaceId)/sync-jobs-list";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_sync_jobs(
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iottwinmaker(
        "POST",
        "/workspaces/$(workspaceId)/sync-jobs-list",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_sync_resources(sync_source, workspace_id)
    list_sync_resources(sync_source, workspace_id, params::Dict{String,<:Any})

Lists the sync resources.

# Arguments
- `sync_source`: The sync source.  Currently the only supported syncSource is SITEWISE .
- `workspace_id`: The ID of the workspace that contains the sync job.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: A list of objects that filter the request. The following filter combinations
  are supported:   Filter with state   Filter with ResourceType and ResourceId   Filter with
  ResourceType and ExternalId
- `"maxResults"`: The maximum number of results to return at one time. The default is 50.
  Valid Range: Minimum value of 0. Maximum value of 200.
- `"nextToken"`: The string that specifies the next page of results.
"""
function list_sync_resources(
    syncSource, workspaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iottwinmaker(
        "POST",
        "/workspaces/$(workspaceId)/sync-jobs/$(syncSource)/resources-list";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_sync_resources(
    syncSource,
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iottwinmaker(
        "POST",
        "/workspaces/$(workspaceId)/sync-jobs/$(syncSource)/resources-list",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists all tags associated with a resource.

# Arguments
- `resource_arn`: The ARN of the resource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return at one time. The default is 25.
  Valid Range: Minimum value of 1. Maximum value of 250.
- `"nextToken"`: The string that specifies the next page of results.
"""
function list_tags_for_resource(
    resourceARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iottwinmaker(
        "POST",
        "/tags-list",
        Dict{String,Any}("resourceARN" => resourceARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iottwinmaker(
        "POST",
        "/tags-list",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceARN" => resourceARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_workspaces()
    list_workspaces(params::Dict{String,<:Any})

Retrieves information about workspaces in the current account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return at one time. The default is 25.
  Valid Range: Minimum value of 1. Maximum value of 250.
- `"nextToken"`: The string that specifies the next page of results.
"""
function list_workspaces(; aws_config::AbstractAWSConfig=current_aws_config())
    return iottwinmaker(
        "POST", "/workspaces-list"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_workspaces(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iottwinmaker(
        "POST",
        "/workspaces-list",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds tags to a resource.

# Arguments
- `resource_arn`: The ARN of the resource.
- `tags`: Metadata to add to this resource.

"""
function tag_resource(resourceARN, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return iottwinmaker(
        "POST",
        "/tags",
        Dict{String,Any}("resourceARN" => resourceARN, "tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceARN,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iottwinmaker(
        "POST",
        "/tags",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceARN" => resourceARN, "tags" => tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes tags from a resource.

# Arguments
- `resource_arn`: The ARN of the resource.
- `tag_keys`: A list of tag key names to remove from the resource. You don't specify the
  value. Both the key and its associated value are removed.

"""
function untag_resource(
    resourceARN, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iottwinmaker(
        "DELETE",
        "/tags",
        Dict{String,Any}("resourceARN" => resourceARN, "tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceARN,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iottwinmaker(
        "DELETE",
        "/tags",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceARN" => resourceARN, "tagKeys" => tagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_component_type(component_type_id, workspace_id)
    update_component_type(component_type_id, workspace_id, params::Dict{String,<:Any})

Updates information in a component type.

# Arguments
- `component_type_id`: The ID of the component type.
- `workspace_id`: The ID of the workspace.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"componentTypeName"`: The component type name.
- `"compositeComponentTypes"`: This is an object that maps strings to
  compositeComponentTypes of the componentType. CompositeComponentType is referenced by
  componentTypeId.
- `"description"`: The description of the component type.
- `"extendsFrom"`: Specifies the component type that this component type extends.
- `"functions"`: An object that maps strings to the functions in the component type. Each
  string in the mapping must be unique to this object.
- `"isSingleton"`: A Boolean value that specifies whether an entity can have more than one
  component of this type.
- `"propertyDefinitions"`: An object that maps strings to the property definitions in the
  component type. Each string in the mapping must be unique to this object.
- `"propertyGroups"`: The property groups.
"""
function update_component_type(
    componentTypeId, workspaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iottwinmaker(
        "PUT",
        "/workspaces/$(workspaceId)/component-types/$(componentTypeId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_component_type(
    componentTypeId,
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iottwinmaker(
        "PUT",
        "/workspaces/$(workspaceId)/component-types/$(componentTypeId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_entity(entity_id, workspace_id)
    update_entity(entity_id, workspace_id, params::Dict{String,<:Any})

Updates an entity.

# Arguments
- `entity_id`: The ID of the entity.
- `workspace_id`: The ID of the workspace that contains the entity.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"componentUpdates"`: An object that maps strings to the component updates in the
  request. Each string in the mapping must be unique to this object.
- `"compositeComponentUpdates"`: This is an object that maps strings to compositeComponent
  updates in the request. Each key of the map represents the componentPath of the
  compositeComponent.
- `"description"`: The description of the entity.
- `"entityName"`: The name of the entity.
- `"parentEntityUpdate"`: An object that describes the update request for a parent entity.
"""
function update_entity(
    entityId, workspaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iottwinmaker(
        "PUT",
        "/workspaces/$(workspaceId)/entities/$(entityId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_entity(
    entityId,
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iottwinmaker(
        "PUT",
        "/workspaces/$(workspaceId)/entities/$(entityId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_pricing_plan(pricing_mode)
    update_pricing_plan(pricing_mode, params::Dict{String,<:Any})

Update the pricing plan.

# Arguments
- `pricing_mode`: The pricing mode.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"bundleNames"`: The bundle names.
"""
function update_pricing_plan(
    pricingMode; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iottwinmaker(
        "POST",
        "/pricingplan",
        Dict{String,Any}("pricingMode" => pricingMode);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_pricing_plan(
    pricingMode,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iottwinmaker(
        "POST",
        "/pricingplan",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("pricingMode" => pricingMode), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_scene(scene_id, workspace_id)
    update_scene(scene_id, workspace_id, params::Dict{String,<:Any})

Updates a scene.

# Arguments
- `scene_id`: The ID of the scene.
- `workspace_id`: The ID of the workspace that contains the scene.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"capabilities"`: A list of capabilities that the scene uses to render.
- `"contentLocation"`: The relative path that specifies the location of the content
  definition file.
- `"description"`: The description of this scene.
- `"sceneMetadata"`: The scene metadata.
"""
function update_scene(
    sceneId, workspaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iottwinmaker(
        "PUT",
        "/workspaces/$(workspaceId)/scenes/$(sceneId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_scene(
    sceneId,
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iottwinmaker(
        "PUT",
        "/workspaces/$(workspaceId)/scenes/$(sceneId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_workspace(workspace_id)
    update_workspace(workspace_id, params::Dict{String,<:Any})

Updates a workspace.

# Arguments
- `workspace_id`: The ID of the workspace.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description of the workspace.
- `"role"`: The ARN of the execution role associated with the workspace.
- `"s3Location"`: The ARN of the S3 bucket where resources associated with the workspace
  are stored.
"""
function update_workspace(workspaceId; aws_config::AbstractAWSConfig=current_aws_config())
    return iottwinmaker(
        "PUT",
        "/workspaces/$(workspaceId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_workspace(
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iottwinmaker(
        "PUT",
        "/workspaces/$(workspaceId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: redshift_serverless
using AWS.Compat
using AWS.UUIDs

"""
    convert_recovery_point_to_snapshot(recovery_point_id, snapshot_name)
    convert_recovery_point_to_snapshot(recovery_point_id, snapshot_name, params::Dict{String,<:Any})

Converts a recovery point to a snapshot. For more information about recovery points and
snapshots, see Working with snapshots and recovery points.

# Arguments
- `recovery_point_id`: The unique identifier of the recovery point.
- `snapshot_name`: The name of the snapshot.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"retentionPeriod"`: How long to retain the snapshot.
- `"tags"`: An array of Tag objects to associate with the created snapshot.
"""
function convert_recovery_point_to_snapshot(
    recoveryPointId, snapshotName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return redshift_serverless(
        "ConvertRecoveryPointToSnapshot",
        Dict{String,Any}(
            "recoveryPointId" => recoveryPointId, "snapshotName" => snapshotName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function convert_recovery_point_to_snapshot(
    recoveryPointId,
    snapshotName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return redshift_serverless(
        "ConvertRecoveryPointToSnapshot",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "recoveryPointId" => recoveryPointId, "snapshotName" => snapshotName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_custom_domain_association(custom_domain_certificate_arn, custom_domain_name, workgroup_name)
    create_custom_domain_association(custom_domain_certificate_arn, custom_domain_name, workgroup_name, params::Dict{String,<:Any})

Creates a custom domain association for Amazon Redshift Serverless.

# Arguments
- `custom_domain_certificate_arn`: The custom domain name’s certificate Amazon resource
  name (ARN).
- `custom_domain_name`: The custom domain name to associate with the workgroup.
- `workgroup_name`: The name of the workgroup associated with the database.

"""
function create_custom_domain_association(
    customDomainCertificateArn,
    customDomainName,
    workgroupName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return redshift_serverless(
        "CreateCustomDomainAssociation",
        Dict{String,Any}(
            "customDomainCertificateArn" => customDomainCertificateArn,
            "customDomainName" => customDomainName,
            "workgroupName" => workgroupName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_custom_domain_association(
    customDomainCertificateArn,
    customDomainName,
    workgroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return redshift_serverless(
        "CreateCustomDomainAssociation",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "customDomainCertificateArn" => customDomainCertificateArn,
                    "customDomainName" => customDomainName,
                    "workgroupName" => workgroupName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_endpoint_access(endpoint_name, subnet_ids, workgroup_name)
    create_endpoint_access(endpoint_name, subnet_ids, workgroup_name, params::Dict{String,<:Any})

Creates an Amazon Redshift Serverless managed VPC endpoint.

# Arguments
- `endpoint_name`: The name of the VPC endpoint. An endpoint name must contain 1-30
  characters. Valid characters are A-Z, a-z, 0-9, and hyphen(-). The first character must be
  a letter. The name can't contain two consecutive hyphens or end with a hyphen.
- `subnet_ids`: The unique identifers of subnets from which Amazon Redshift Serverless
  chooses one to deploy a VPC endpoint.
- `workgroup_name`: The name of the workgroup to associate with the VPC endpoint.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ownerAccount"`: The owner Amazon Web Services account for the Amazon Redshift
  Serverless workgroup.
- `"vpcSecurityGroupIds"`: The unique identifiers of the security group that defines the
  ports, protocols, and sources for inbound traffic that you are authorizing into your
  endpoint.
"""
function create_endpoint_access(
    endpointName,
    subnetIds,
    workgroupName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return redshift_serverless(
        "CreateEndpointAccess",
        Dict{String,Any}(
            "endpointName" => endpointName,
            "subnetIds" => subnetIds,
            "workgroupName" => workgroupName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_endpoint_access(
    endpointName,
    subnetIds,
    workgroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return redshift_serverless(
        "CreateEndpointAccess",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "endpointName" => endpointName,
                    "subnetIds" => subnetIds,
                    "workgroupName" => workgroupName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_namespace(namespace_name)
    create_namespace(namespace_name, params::Dict{String,<:Any})

Creates a namespace in Amazon Redshift Serverless.

# Arguments
- `namespace_name`: The name of the namespace.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"adminPasswordSecretKmsKeyId"`: The ID of the Key Management Service (KMS) key used to
  encrypt and store the namespace's admin credentials secret. You can only use this parameter
  if manageAdminPassword is true.
- `"adminUserPassword"`: The password of the administrator for the first database created
  in the namespace. You can't use adminUserPassword if manageAdminPassword is true.
- `"adminUsername"`: The username of the administrator for the first database created in
  the namespace.
- `"dbName"`: The name of the first database created in the namespace.
- `"defaultIamRoleArn"`: The Amazon Resource Name (ARN) of the IAM role to set as a default
  in the namespace.
- `"iamRoles"`: A list of IAM roles to associate with the namespace.
- `"kmsKeyId"`: The ID of the Amazon Web Services Key Management Service key used to
  encrypt your data.
- `"logExports"`: The types of logs the namespace can export. Available export types are
  userlog, connectionlog, and useractivitylog.
- `"manageAdminPassword"`: If true, Amazon Redshift uses Secrets Manager to manage the
  namespace's admin credentials. You can't use adminUserPassword if manageAdminPassword is
  true. If manageAdminPassword is false or not set, Amazon Redshift uses adminUserPassword
  for the admin user account's password.
- `"redshiftIdcApplicationArn"`: The ARN for the Redshift application that integrates with
  IAM Identity Center.
- `"tags"`: A list of tag instances.
"""
function create_namespace(namespaceName; aws_config::AbstractAWSConfig=current_aws_config())
    return redshift_serverless(
        "CreateNamespace",
        Dict{String,Any}("namespaceName" => namespaceName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_namespace(
    namespaceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return redshift_serverless(
        "CreateNamespace",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("namespaceName" => namespaceName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_scheduled_action(namespace_name, role_arn, schedule, scheduled_action_name, target_action)
    create_scheduled_action(namespace_name, role_arn, schedule, scheduled_action_name, target_action, params::Dict{String,<:Any})

Creates a scheduled action. A scheduled action contains a schedule and an Amazon Redshift
API action. For example, you can create a schedule of when to run the CreateSnapshot API
operation.

# Arguments
- `namespace_name`: The name of the namespace for which to create a scheduled action.
- `role_arn`: The ARN of the IAM role to assume to run the scheduled action. This IAM role
  must have permission to run the Amazon Redshift Serverless API operation in the scheduled
  action. This IAM role must allow the Amazon Redshift scheduler to schedule creating
  snapshots. (Principal scheduler.redshift.amazonaws.com) to assume permissions on your
  behalf. For more information about the IAM role to use with the Amazon Redshift scheduler,
  see Using Identity-Based Policies for Amazon Redshift in the Amazon Redshift Cluster
  Management Guide
- `schedule`: The schedule for a one-time (at timestamp format) or recurring (cron format)
  scheduled action. Schedule invocations must be separated by at least one hour. Times are in
  UTC.   Format of at timestamp is yyyy-mm-ddThh:mm:ss. For example, 2016-03-04T17:27:00.
  Format of cron expression is (Minutes Hours Day-of-month Month Day-of-week Year). For
  example, \"(0 10 ? * MON *)\". For more information, see Cron Expressions in the Amazon
  CloudWatch Events User Guide.
- `scheduled_action_name`: The name of the scheduled action.
- `target_action`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"enabled"`: Indicates whether the schedule is enabled. If false, the scheduled action
  does not trigger. For more information about state of the scheduled action, see
  ScheduledAction.
- `"endTime"`: The end time in UTC when the schedule is no longer active. After this time,
  the scheduled action does not trigger.
- `"scheduledActionDescription"`: The description of the scheduled action.
- `"startTime"`: The start time in UTC when the schedule is active. Before this time, the
  scheduled action does not trigger.
"""
function create_scheduled_action(
    namespaceName,
    roleArn,
    schedule,
    scheduledActionName,
    targetAction;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return redshift_serverless(
        "CreateScheduledAction",
        Dict{String,Any}(
            "namespaceName" => namespaceName,
            "roleArn" => roleArn,
            "schedule" => schedule,
            "scheduledActionName" => scheduledActionName,
            "targetAction" => targetAction,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_scheduled_action(
    namespaceName,
    roleArn,
    schedule,
    scheduledActionName,
    targetAction,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return redshift_serverless(
        "CreateScheduledAction",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "namespaceName" => namespaceName,
                    "roleArn" => roleArn,
                    "schedule" => schedule,
                    "scheduledActionName" => scheduledActionName,
                    "targetAction" => targetAction,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_snapshot(namespace_name, snapshot_name)
    create_snapshot(namespace_name, snapshot_name, params::Dict{String,<:Any})

Creates a snapshot of all databases in a namespace. For more information about snapshots,
see  Working with snapshots and recovery points.

# Arguments
- `namespace_name`: The namespace to create a snapshot for.
- `snapshot_name`: The name of the snapshot.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"retentionPeriod"`: How long to retain the created snapshot.
- `"tags"`: An array of Tag objects to associate with the snapshot.
"""
function create_snapshot(
    namespaceName, snapshotName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return redshift_serverless(
        "CreateSnapshot",
        Dict{String,Any}("namespaceName" => namespaceName, "snapshotName" => snapshotName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_snapshot(
    namespaceName,
    snapshotName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return redshift_serverless(
        "CreateSnapshot",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "namespaceName" => namespaceName, "snapshotName" => snapshotName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_snapshot_copy_configuration(destination_region, namespace_name)
    create_snapshot_copy_configuration(destination_region, namespace_name, params::Dict{String,<:Any})

Creates a snapshot copy configuration that lets you copy snapshots to another Amazon Web
Services Region.

# Arguments
- `destination_region`: The destination Amazon Web Services Region that you want to copy
  snapshots to.
- `namespace_name`: The name of the namespace to copy snapshots from.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"destinationKmsKeyId"`: The KMS key to use to encrypt your snapshots in the destination
  Amazon Web Services Region.
- `"snapshotRetentionPeriod"`: The retention period of the snapshots that you copy to the
  destination Amazon Web Services Region.
"""
function create_snapshot_copy_configuration(
    destinationRegion, namespaceName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return redshift_serverless(
        "CreateSnapshotCopyConfiguration",
        Dict{String,Any}(
            "destinationRegion" => destinationRegion, "namespaceName" => namespaceName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_snapshot_copy_configuration(
    destinationRegion,
    namespaceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return redshift_serverless(
        "CreateSnapshotCopyConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "destinationRegion" => destinationRegion,
                    "namespaceName" => namespaceName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_usage_limit(amount, resource_arn, usage_type)
    create_usage_limit(amount, resource_arn, usage_type, params::Dict{String,<:Any})

Creates a usage limit for a specified Amazon Redshift Serverless usage type. The usage
limit is identified by the returned usage limit identifier.

# Arguments
- `amount`: The limit amount. If time-based, this amount is in Redshift Processing Units
  (RPU) consumed per hour. If data-based, this amount is in terabytes (TB) of data
  transferred between Regions in cross-account sharing. The value must be a positive number.
- `resource_arn`: The Amazon Resource Name (ARN) of the Amazon Redshift Serverless resource
  to create the usage limit for.
- `usage_type`: The type of Amazon Redshift Serverless usage to create a usage limit for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"breachAction"`: The action that Amazon Redshift Serverless takes when the limit is
  reached. The default is log.
- `"period"`: The time period that the amount applies to. A weekly period begins on Sunday.
  The default is monthly.
"""
function create_usage_limit(
    amount, resourceArn, usageType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return redshift_serverless(
        "CreateUsageLimit",
        Dict{String,Any}(
            "amount" => amount, "resourceArn" => resourceArn, "usageType" => usageType
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_usage_limit(
    amount,
    resourceArn,
    usageType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return redshift_serverless(
        "CreateUsageLimit",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "amount" => amount,
                    "resourceArn" => resourceArn,
                    "usageType" => usageType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_workgroup(namespace_name, workgroup_name)
    create_workgroup(namespace_name, workgroup_name, params::Dict{String,<:Any})

Creates an workgroup in Amazon Redshift Serverless.

# Arguments
- `namespace_name`: The name of the namespace to associate with the workgroup.
- `workgroup_name`: The name of the created workgroup.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"baseCapacity"`: The base data warehouse capacity of the workgroup in Redshift
  Processing Units (RPUs).
- `"configParameters"`: An array of parameters to set for advanced control over a database.
  The options are auto_mv, datestyle, enable_case_sensitive_identifier,
  enable_user_activity_logging, query_group, search_path, require_ssl, use_fips_ssl, and
  query monitoring metrics that let you define performance boundaries. For more information
  about query monitoring rules and available metrics, see  Query monitoring metrics for
  Amazon Redshift Serverless.
- `"enhancedVpcRouting"`: The value that specifies whether to turn on enhanced virtual
  private cloud (VPC) routing, which forces Amazon Redshift Serverless to route traffic
  through your VPC instead of over the internet.
- `"maxCapacity"`: The maximum data-warehouse capacity Amazon Redshift Serverless uses to
  serve queries. The max capacity is specified in RPUs.
- `"port"`: The custom port to use when connecting to a workgroup. Valid port ranges are
  5431-5455 and 8191-8215. The default is 5439.
- `"publiclyAccessible"`: A value that specifies whether the workgroup can be accessed from
  a public network.
- `"securityGroupIds"`: An array of security group IDs to associate with the workgroup.
- `"subnetIds"`: An array of VPC subnet IDs to associate with the workgroup.
- `"tags"`: A array of tag instances.
"""
function create_workgroup(
    namespaceName, workgroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return redshift_serverless(
        "CreateWorkgroup",
        Dict{String,Any}(
            "namespaceName" => namespaceName, "workgroupName" => workgroupName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_workgroup(
    namespaceName,
    workgroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return redshift_serverless(
        "CreateWorkgroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "namespaceName" => namespaceName, "workgroupName" => workgroupName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_custom_domain_association(custom_domain_name, workgroup_name)
    delete_custom_domain_association(custom_domain_name, workgroup_name, params::Dict{String,<:Any})

Deletes a custom domain association for Amazon Redshift Serverless.

# Arguments
- `custom_domain_name`: The custom domain name associated with the workgroup.
- `workgroup_name`: The name of the workgroup associated with the database.

"""
function delete_custom_domain_association(
    customDomainName, workgroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return redshift_serverless(
        "DeleteCustomDomainAssociation",
        Dict{String,Any}(
            "customDomainName" => customDomainName, "workgroupName" => workgroupName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_custom_domain_association(
    customDomainName,
    workgroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return redshift_serverless(
        "DeleteCustomDomainAssociation",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "customDomainName" => customDomainName, "workgroupName" => workgroupName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_endpoint_access(endpoint_name)
    delete_endpoint_access(endpoint_name, params::Dict{String,<:Any})

Deletes an Amazon Redshift Serverless managed VPC endpoint.

# Arguments
- `endpoint_name`: The name of the VPC endpoint to delete.

"""
function delete_endpoint_access(
    endpointName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return redshift_serverless(
        "DeleteEndpointAccess",
        Dict{String,Any}("endpointName" => endpointName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_endpoint_access(
    endpointName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return redshift_serverless(
        "DeleteEndpointAccess",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("endpointName" => endpointName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_namespace(namespace_name)
    delete_namespace(namespace_name, params::Dict{String,<:Any})

Deletes a namespace from Amazon Redshift Serverless. Before you delete the namespace, you
can create a final snapshot that has all of the data within the namespace.

# Arguments
- `namespace_name`: The name of the namespace to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"finalSnapshotName"`: The name of the snapshot to be created before the namespace is
  deleted.
- `"finalSnapshotRetentionPeriod"`: How long to retain the final snapshot.
"""
function delete_namespace(namespaceName; aws_config::AbstractAWSConfig=current_aws_config())
    return redshift_serverless(
        "DeleteNamespace",
        Dict{String,Any}("namespaceName" => namespaceName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_namespace(
    namespaceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return redshift_serverless(
        "DeleteNamespace",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("namespaceName" => namespaceName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_resource_policy(resource_arn)
    delete_resource_policy(resource_arn, params::Dict{String,<:Any})

Deletes the specified resource policy.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the policy to delete.

"""
function delete_resource_policy(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return redshift_serverless(
        "DeleteResourcePolicy",
        Dict{String,Any}("resourceArn" => resourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_resource_policy(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return redshift_serverless(
        "DeleteResourcePolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceArn" => resourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_scheduled_action(scheduled_action_name)
    delete_scheduled_action(scheduled_action_name, params::Dict{String,<:Any})

Deletes a scheduled action.

# Arguments
- `scheduled_action_name`: The name of the scheduled action to delete.

"""
function delete_scheduled_action(
    scheduledActionName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return redshift_serverless(
        "DeleteScheduledAction",
        Dict{String,Any}("scheduledActionName" => scheduledActionName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_scheduled_action(
    scheduledActionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return redshift_serverless(
        "DeleteScheduledAction",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("scheduledActionName" => scheduledActionName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_snapshot(snapshot_name)
    delete_snapshot(snapshot_name, params::Dict{String,<:Any})

Deletes a snapshot from Amazon Redshift Serverless.

# Arguments
- `snapshot_name`: The name of the snapshot to be deleted.

"""
function delete_snapshot(snapshotName; aws_config::AbstractAWSConfig=current_aws_config())
    return redshift_serverless(
        "DeleteSnapshot",
        Dict{String,Any}("snapshotName" => snapshotName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_snapshot(
    snapshotName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return redshift_serverless(
        "DeleteSnapshot",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("snapshotName" => snapshotName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_snapshot_copy_configuration(snapshot_copy_configuration_id)
    delete_snapshot_copy_configuration(snapshot_copy_configuration_id, params::Dict{String,<:Any})

Deletes a snapshot copy configuration

# Arguments
- `snapshot_copy_configuration_id`: The ID of the snapshot copy configuration to delete.

"""
function delete_snapshot_copy_configuration(
    snapshotCopyConfigurationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return redshift_serverless(
        "DeleteSnapshotCopyConfiguration",
        Dict{String,Any}("snapshotCopyConfigurationId" => snapshotCopyConfigurationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_snapshot_copy_configuration(
    snapshotCopyConfigurationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return redshift_serverless(
        "DeleteSnapshotCopyConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "snapshotCopyConfigurationId" => snapshotCopyConfigurationId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_usage_limit(usage_limit_id)
    delete_usage_limit(usage_limit_id, params::Dict{String,<:Any})

Deletes a usage limit from Amazon Redshift Serverless.

# Arguments
- `usage_limit_id`: The unique identifier of the usage limit to delete.

"""
function delete_usage_limit(
    usageLimitId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return redshift_serverless(
        "DeleteUsageLimit",
        Dict{String,Any}("usageLimitId" => usageLimitId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_usage_limit(
    usageLimitId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return redshift_serverless(
        "DeleteUsageLimit",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("usageLimitId" => usageLimitId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_workgroup(workgroup_name)
    delete_workgroup(workgroup_name, params::Dict{String,<:Any})

Deletes a workgroup.

# Arguments
- `workgroup_name`: The name of the workgroup to be deleted.

"""
function delete_workgroup(workgroupName; aws_config::AbstractAWSConfig=current_aws_config())
    return redshift_serverless(
        "DeleteWorkgroup",
        Dict{String,Any}("workgroupName" => workgroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_workgroup(
    workgroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return redshift_serverless(
        "DeleteWorkgroup",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("workgroupName" => workgroupName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_credentials()
    get_credentials(params::Dict{String,<:Any})

Returns a database user name and temporary password with temporary authorization to log in
to Amazon Redshift Serverless. By default, the temporary credentials expire in 900 seconds.
You can optionally specify a duration between 900 seconds (15 minutes) and 3600 seconds (60
minutes).  &lt;p&gt;The Identity and Access Management (IAM) user or role that runs
GetCredentials must have an IAM policy attached that allows access to all necessary actions
and resources.&lt;/p&gt; &lt;p&gt;If the &lt;code&gt;DbName&lt;/code&gt; parameter is
specified, the IAM policy must allow access to the resource dbname for the specified
database name.&lt;/p&gt;

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"customDomainName"`: The custom domain name associated with the workgroup. The custom
  domain name or the workgroup name must be included in the request.
- `"dbName"`: The name of the database to get temporary authorization to log on to.
  Constraints:   Must be 1 to 64 alphanumeric characters or hyphens.   Must contain only
  uppercase or lowercase letters, numbers, underscore, plus sign, period (dot), at symbol
  (@), or hyphen.   The first character must be a letter.   Must not contain a colon ( : ) or
  slash ( / ).   Cannot be a reserved word. A list of reserved words can be found in Reserved
  Words  in the Amazon Redshift Database Developer Guide
- `"durationSeconds"`: The number of seconds until the returned temporary password expires.
  The minimum is 900 seconds, and the maximum is 3600 seconds.
- `"workgroupName"`: The name of the workgroup associated with the database.
"""
function get_credentials(; aws_config::AbstractAWSConfig=current_aws_config())
    return redshift_serverless(
        "GetCredentials"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_credentials(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return redshift_serverless(
        "GetCredentials", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_custom_domain_association(custom_domain_name, workgroup_name)
    get_custom_domain_association(custom_domain_name, workgroup_name, params::Dict{String,<:Any})

Gets information about a specific custom domain association.

# Arguments
- `custom_domain_name`: The custom domain name associated with the workgroup.
- `workgroup_name`: The name of the workgroup associated with the database.

"""
function get_custom_domain_association(
    customDomainName, workgroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return redshift_serverless(
        "GetCustomDomainAssociation",
        Dict{String,Any}(
            "customDomainName" => customDomainName, "workgroupName" => workgroupName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_custom_domain_association(
    customDomainName,
    workgroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return redshift_serverless(
        "GetCustomDomainAssociation",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "customDomainName" => customDomainName, "workgroupName" => workgroupName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_endpoint_access(endpoint_name)
    get_endpoint_access(endpoint_name, params::Dict{String,<:Any})

Returns information, such as the name, about a VPC endpoint.

# Arguments
- `endpoint_name`: The name of the VPC endpoint to return information for.

"""
function get_endpoint_access(
    endpointName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return redshift_serverless(
        "GetEndpointAccess",
        Dict{String,Any}("endpointName" => endpointName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_endpoint_access(
    endpointName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return redshift_serverless(
        "GetEndpointAccess",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("endpointName" => endpointName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_namespace(namespace_name)
    get_namespace(namespace_name, params::Dict{String,<:Any})

Returns information about a namespace in Amazon Redshift Serverless.

# Arguments
- `namespace_name`: The name of the namespace to retrieve information for.

"""
function get_namespace(namespaceName; aws_config::AbstractAWSConfig=current_aws_config())
    return redshift_serverless(
        "GetNamespace",
        Dict{String,Any}("namespaceName" => namespaceName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_namespace(
    namespaceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return redshift_serverless(
        "GetNamespace",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("namespaceName" => namespaceName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_recovery_point(recovery_point_id)
    get_recovery_point(recovery_point_id, params::Dict{String,<:Any})

Returns information about a recovery point.

# Arguments
- `recovery_point_id`: The unique identifier of the recovery point to return information
  for.

"""
function get_recovery_point(
    recoveryPointId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return redshift_serverless(
        "GetRecoveryPoint",
        Dict{String,Any}("recoveryPointId" => recoveryPointId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_recovery_point(
    recoveryPointId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return redshift_serverless(
        "GetRecoveryPoint",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("recoveryPointId" => recoveryPointId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_resource_policy(resource_arn)
    get_resource_policy(resource_arn, params::Dict{String,<:Any})

Returns a resource policy.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource to return.

"""
function get_resource_policy(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return redshift_serverless(
        "GetResourcePolicy",
        Dict{String,Any}("resourceArn" => resourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_resource_policy(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return redshift_serverless(
        "GetResourcePolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceArn" => resourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_scheduled_action(scheduled_action_name)
    get_scheduled_action(scheduled_action_name, params::Dict{String,<:Any})

Returns information about a scheduled action.

# Arguments
- `scheduled_action_name`: The name of the scheduled action.

"""
function get_scheduled_action(
    scheduledActionName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return redshift_serverless(
        "GetScheduledAction",
        Dict{String,Any}("scheduledActionName" => scheduledActionName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_scheduled_action(
    scheduledActionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return redshift_serverless(
        "GetScheduledAction",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("scheduledActionName" => scheduledActionName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_snapshot()
    get_snapshot(params::Dict{String,<:Any})

Returns information about a specific snapshot.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ownerAccount"`: The owner Amazon Web Services account of a snapshot shared with another
  user.
- `"snapshotArn"`: The Amazon Resource Name (ARN) of the snapshot to return.
- `"snapshotName"`: The name of the snapshot to return.
"""
function get_snapshot(; aws_config::AbstractAWSConfig=current_aws_config())
    return redshift_serverless(
        "GetSnapshot"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_snapshot(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return redshift_serverless(
        "GetSnapshot", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_table_restore_status(table_restore_request_id)
    get_table_restore_status(table_restore_request_id, params::Dict{String,<:Any})

Returns information about a TableRestoreStatus object.

# Arguments
- `table_restore_request_id`: The ID of the RestoreTableFromSnapshot request to return
  status for.

"""
function get_table_restore_status(
    tableRestoreRequestId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return redshift_serverless(
        "GetTableRestoreStatus",
        Dict{String,Any}("tableRestoreRequestId" => tableRestoreRequestId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_table_restore_status(
    tableRestoreRequestId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return redshift_serverless(
        "GetTableRestoreStatus",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("tableRestoreRequestId" => tableRestoreRequestId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_usage_limit(usage_limit_id)
    get_usage_limit(usage_limit_id, params::Dict{String,<:Any})

Returns information about a usage limit.

# Arguments
- `usage_limit_id`: The unique identifier of the usage limit to return information for.

"""
function get_usage_limit(usageLimitId; aws_config::AbstractAWSConfig=current_aws_config())
    return redshift_serverless(
        "GetUsageLimit",
        Dict{String,Any}("usageLimitId" => usageLimitId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_usage_limit(
    usageLimitId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return redshift_serverless(
        "GetUsageLimit",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("usageLimitId" => usageLimitId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_workgroup(workgroup_name)
    get_workgroup(workgroup_name, params::Dict{String,<:Any})

Returns information about a specific workgroup.

# Arguments
- `workgroup_name`: The name of the workgroup to return information for.

"""
function get_workgroup(workgroupName; aws_config::AbstractAWSConfig=current_aws_config())
    return redshift_serverless(
        "GetWorkgroup",
        Dict{String,Any}("workgroupName" => workgroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_workgroup(
    workgroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return redshift_serverless(
        "GetWorkgroup",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("workgroupName" => workgroupName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_custom_domain_associations()
    list_custom_domain_associations(params::Dict{String,<:Any})

 Lists custom domain associations for Amazon Redshift Serverless.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"customDomainCertificateArn"`: The custom domain name’s certificate Amazon resource
  name (ARN).
- `"customDomainName"`: The custom domain name associated with the workgroup.
- `"maxResults"`: An optional parameter that specifies the maximum number of results to
  return. You can use nextToken to display the next page of results.
- `"nextToken"`: When nextToken is returned, there are more results available. The value of
  nextToken is a unique pagination token for each page. Make the call again using the
  returned token to retrieve the next page.
"""
function list_custom_domain_associations(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return redshift_serverless(
        "ListCustomDomainAssociations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_custom_domain_associations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return redshift_serverless(
        "ListCustomDomainAssociations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_endpoint_access()
    list_endpoint_access(params::Dict{String,<:Any})

Returns an array of EndpointAccess objects and relevant information.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: An optional parameter that specifies the maximum number of results to
  return. You can use nextToken to display the next page of results.
- `"nextToken"`: If your initial ListEndpointAccess operation returns a nextToken, you can
  include the returned nextToken in following ListEndpointAccess operations, which returns
  results in the next page.
- `"ownerAccount"`: The owner Amazon Web Services account for the Amazon Redshift
  Serverless workgroup.
- `"vpcId"`: The unique identifier of the virtual private cloud with access to Amazon
  Redshift Serverless.
- `"workgroupName"`: The name of the workgroup associated with the VPC endpoint to return.
"""
function list_endpoint_access(; aws_config::AbstractAWSConfig=current_aws_config())
    return redshift_serverless(
        "ListEndpointAccess"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_endpoint_access(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return redshift_serverless(
        "ListEndpointAccess", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_namespaces()
    list_namespaces(params::Dict{String,<:Any})

Returns information about a list of specified namespaces.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: An optional parameter that specifies the maximum number of results to
  return. You can use nextToken to display the next page of results.
- `"nextToken"`: If your initial ListNamespaces operation returns a nextToken, you can
  include the returned nextToken in following ListNamespaces operations, which returns
  results in the next page.
"""
function list_namespaces(; aws_config::AbstractAWSConfig=current_aws_config())
    return redshift_serverless(
        "ListNamespaces"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_namespaces(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return redshift_serverless(
        "ListNamespaces", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_recovery_points()
    list_recovery_points(params::Dict{String,<:Any})

Returns an array of recovery points.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"endTime"`: The time when creation of the recovery point finished.
- `"maxResults"`: An optional parameter that specifies the maximum number of results to
  return. You can use nextToken to display the next page of results.
- `"namespaceArn"`: The Amazon Resource Name (ARN) of the namespace from which to list
  recovery points.
- `"namespaceName"`: The name of the namespace to list recovery points for.
- `"nextToken"`: If your initial ListRecoveryPoints operation returns a nextToken, you can
  include the returned nextToken in following ListRecoveryPoints operations, which returns
  results in the next page.
- `"startTime"`: The time when the recovery point's creation was initiated.
"""
function list_recovery_points(; aws_config::AbstractAWSConfig=current_aws_config())
    return redshift_serverless(
        "ListRecoveryPoints"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_recovery_points(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return redshift_serverless(
        "ListRecoveryPoints", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_scheduled_actions()
    list_scheduled_actions(params::Dict{String,<:Any})

Returns a list of scheduled actions. You can use the flags to filter the list of returned
scheduled actions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: An optional parameter that specifies the maximum number of results to
  return. Use nextToken to display the next page of results.
- `"namespaceName"`: The name of namespace associated with the scheduled action to retrieve.
- `"nextToken"`: If nextToken is returned, there are more results available. The value of
  nextToken is a unique pagination token for each page. Make the call again using the
  returned token to retrieve the next page.
"""
function list_scheduled_actions(; aws_config::AbstractAWSConfig=current_aws_config())
    return redshift_serverless(
        "ListScheduledActions"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_scheduled_actions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return redshift_serverless(
        "ListScheduledActions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_snapshot_copy_configurations()
    list_snapshot_copy_configurations(params::Dict{String,<:Any})

Returns a list of snapshot copy configurations.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: An optional parameter that specifies the maximum number of results to
  return. You can use nextToken to display the next page of results.
- `"namespaceName"`: The namespace from which to list all snapshot copy configurations.
- `"nextToken"`: If nextToken is returned, there are more results available. The value of
  nextToken is a unique pagination token for each page. Make the call again using the
  returned token to retrieve the next page.
"""
function list_snapshot_copy_configurations(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return redshift_serverless(
        "ListSnapshotCopyConfigurations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_snapshot_copy_configurations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return redshift_serverless(
        "ListSnapshotCopyConfigurations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_snapshots()
    list_snapshots(params::Dict{String,<:Any})

Returns a list of snapshots.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"endTime"`: The timestamp showing when the snapshot creation finished.
- `"maxResults"`: An optional parameter that specifies the maximum number of results to
  return. You can use nextToken to display the next page of results.
- `"namespaceArn"`: The Amazon Resource Name (ARN) of the namespace from which to list all
  snapshots.
- `"namespaceName"`: The namespace from which to list all snapshots.
- `"nextToken"`: If nextToken is returned, there are more results available. The value of
  nextToken is a unique pagination token for each page. Make the call again using the
  returned token to retrieve the next page.
- `"ownerAccount"`: The owner Amazon Web Services account of the snapshot.
- `"startTime"`: The time when the creation of the snapshot was initiated.
"""
function list_snapshots(; aws_config::AbstractAWSConfig=current_aws_config())
    return redshift_serverless(
        "ListSnapshots"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_snapshots(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return redshift_serverless(
        "ListSnapshots", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_table_restore_status()
    list_table_restore_status(params::Dict{String,<:Any})

Returns information about an array of TableRestoreStatus objects.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: An optional parameter that specifies the maximum number of results to
  return. You can use nextToken to display the next page of results.
- `"namespaceName"`: The namespace from which to list all of the statuses of
  RestoreTableFromSnapshot operations .
- `"nextToken"`: If your initial ListTableRestoreStatus operation returns a nextToken, you
  can include the returned nextToken in following ListTableRestoreStatus operations. This
  will return results on the next page.
- `"workgroupName"`: The workgroup from which to list all of the statuses of
  RestoreTableFromSnapshot operations.
"""
function list_table_restore_status(; aws_config::AbstractAWSConfig=current_aws_config())
    return redshift_serverless(
        "ListTableRestoreStatus"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_table_restore_status(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return redshift_serverless(
        "ListTableRestoreStatus",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists the tags assigned to a resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource to list tags for.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return redshift_serverless(
        "ListTagsForResource",
        Dict{String,Any}("resourceArn" => resourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return redshift_serverless(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceArn" => resourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_usage_limits()
    list_usage_limits(params::Dict{String,<:Any})

Lists all usage limits within Amazon Redshift Serverless.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: An optional parameter that specifies the maximum number of results to
  return. You can use nextToken to get the next page of results. The default is 100.
- `"nextToken"`: If your initial ListUsageLimits operation returns a nextToken, you can
  include the returned nextToken in following ListUsageLimits operations, which returns
  results in the next page.
- `"resourceArn"`: The Amazon Resource Name (ARN) associated with the resource whose usage
  limits you want to list.
- `"usageType"`: The Amazon Redshift Serverless feature whose limits you want to see.
"""
function list_usage_limits(; aws_config::AbstractAWSConfig=current_aws_config())
    return redshift_serverless(
        "ListUsageLimits"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_usage_limits(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return redshift_serverless(
        "ListUsageLimits", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_workgroups()
    list_workgroups(params::Dict{String,<:Any})

Returns information about a list of specified workgroups.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: An optional parameter that specifies the maximum number of results to
  return. You can use nextToken to display the next page of results.
- `"nextToken"`: If your initial ListWorkgroups operation returns a nextToken, you can
  include the returned nextToken in following ListNamespaces operations, which returns
  results in the next page.
- `"ownerAccount"`: The owner Amazon Web Services account for the Amazon Redshift
  Serverless workgroup.
"""
function list_workgroups(; aws_config::AbstractAWSConfig=current_aws_config())
    return redshift_serverless(
        "ListWorkgroups"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_workgroups(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return redshift_serverless(
        "ListWorkgroups", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    put_resource_policy(policy, resource_arn)
    put_resource_policy(policy, resource_arn, params::Dict{String,<:Any})

Creates or updates a resource policy. Currently, you can use policies to share snapshots
across Amazon Web Services accounts.

# Arguments
- `policy`: The policy to create or update. For example, the following policy grants a user
  authorization to restore a snapshot.  \"{\"Version\": \"2012-10-17\", \"Statement\" : [{
  \"Sid\": \"AllowUserRestoreFromSnapshot\", \"Principal\":{\"AWS\": [\"739247239426\"]},
  \"Action\": [\"redshift-serverless:RestoreFromSnapshot\"] , \"Effect\": \"Allow\" }]}\"
- `resource_arn`: The Amazon Resource Name (ARN) of the account to create or update a
  resource policy for.

"""
function put_resource_policy(
    policy, resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return redshift_serverless(
        "PutResourcePolicy",
        Dict{String,Any}("policy" => policy, "resourceArn" => resourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_resource_policy(
    policy,
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return redshift_serverless(
        "PutResourcePolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("policy" => policy, "resourceArn" => resourceArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    restore_from_recovery_point(namespace_name, recovery_point_id, workgroup_name)
    restore_from_recovery_point(namespace_name, recovery_point_id, workgroup_name, params::Dict{String,<:Any})

Restore the data from a recovery point.

# Arguments
- `namespace_name`: The name of the namespace to restore data into.
- `recovery_point_id`: The unique identifier of the recovery point to restore from.
- `workgroup_name`: The name of the workgroup used to restore data.

"""
function restore_from_recovery_point(
    namespaceName,
    recoveryPointId,
    workgroupName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return redshift_serverless(
        "RestoreFromRecoveryPoint",
        Dict{String,Any}(
            "namespaceName" => namespaceName,
            "recoveryPointId" => recoveryPointId,
            "workgroupName" => workgroupName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function restore_from_recovery_point(
    namespaceName,
    recoveryPointId,
    workgroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return redshift_serverless(
        "RestoreFromRecoveryPoint",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "namespaceName" => namespaceName,
                    "recoveryPointId" => recoveryPointId,
                    "workgroupName" => workgroupName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    restore_from_snapshot(namespace_name, workgroup_name)
    restore_from_snapshot(namespace_name, workgroup_name, params::Dict{String,<:Any})

Restores a namespace from a snapshot.

# Arguments
- `namespace_name`: The name of the namespace to restore the snapshot to.
- `workgroup_name`: The name of the workgroup used to restore the snapshot.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"adminPasswordSecretKmsKeyId"`: The ID of the Key Management Service (KMS) key used to
  encrypt and store the namespace's admin credentials secret.
- `"manageAdminPassword"`: If true, Amazon Redshift uses Secrets Manager to manage the
  restored snapshot's admin credentials. If MmanageAdminPassword is false or not set, Amazon
  Redshift uses the admin credentials that the namespace or cluster had at the time the
  snapshot was taken.
- `"ownerAccount"`: The Amazon Web Services account that owns the snapshot.
- `"snapshotArn"`: The Amazon Resource Name (ARN) of the snapshot to restore from. Required
  if restoring from Amazon Redshift Serverless to a provisioned cluster. Must not be
  specified at the same time as snapshotName. The format of the ARN is
  arn:aws:redshift:&lt;region&gt;:&lt;account_id&gt;:snapshot:&lt;cluster_identifier&gt;/&lt;s
  napshot_identifier&gt;.
- `"snapshotName"`: The name of the snapshot to restore from. Must not be specified at the
  same time as snapshotArn.
"""
function restore_from_snapshot(
    namespaceName, workgroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return redshift_serverless(
        "RestoreFromSnapshot",
        Dict{String,Any}(
            "namespaceName" => namespaceName, "workgroupName" => workgroupName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function restore_from_snapshot(
    namespaceName,
    workgroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return redshift_serverless(
        "RestoreFromSnapshot",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "namespaceName" => namespaceName, "workgroupName" => workgroupName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    restore_table_from_recovery_point(namespace_name, new_table_name, recovery_point_id, source_database_name, source_table_name, workgroup_name)
    restore_table_from_recovery_point(namespace_name, new_table_name, recovery_point_id, source_database_name, source_table_name, workgroup_name, params::Dict{String,<:Any})

Restores a table from a recovery point to your Amazon Redshift Serverless instance. You
can't use this operation to restore tables with interleaved sort keys.

# Arguments
- `namespace_name`: Namespace of the recovery point to restore from.
- `new_table_name`: The name of the table to create from the restore operation.
- `recovery_point_id`: The ID of the recovery point to restore the table from.
- `source_database_name`: The name of the source database that contains the table being
  restored.
- `source_table_name`: The name of the source table being restored.
- `workgroup_name`: The workgroup to restore the table to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"activateCaseSensitiveIdentifier"`: Indicates whether name identifiers for database,
  schema, and table are case sensitive. If true, the names are case sensitive. If false, the
  names are not case sensitive. The default is false.
- `"sourceSchemaName"`: The name of the source schema that contains the table being
  restored.
- `"targetDatabaseName"`: The name of the database to restore the table to.
- `"targetSchemaName"`: The name of the schema to restore the table to.
"""
function restore_table_from_recovery_point(
    namespaceName,
    newTableName,
    recoveryPointId,
    sourceDatabaseName,
    sourceTableName,
    workgroupName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return redshift_serverless(
        "RestoreTableFromRecoveryPoint",
        Dict{String,Any}(
            "namespaceName" => namespaceName,
            "newTableName" => newTableName,
            "recoveryPointId" => recoveryPointId,
            "sourceDatabaseName" => sourceDatabaseName,
            "sourceTableName" => sourceTableName,
            "workgroupName" => workgroupName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function restore_table_from_recovery_point(
    namespaceName,
    newTableName,
    recoveryPointId,
    sourceDatabaseName,
    sourceTableName,
    workgroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return redshift_serverless(
        "RestoreTableFromRecoveryPoint",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "namespaceName" => namespaceName,
                    "newTableName" => newTableName,
                    "recoveryPointId" => recoveryPointId,
                    "sourceDatabaseName" => sourceDatabaseName,
                    "sourceTableName" => sourceTableName,
                    "workgroupName" => workgroupName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    restore_table_from_snapshot(namespace_name, new_table_name, snapshot_name, source_database_name, source_table_name, workgroup_name)
    restore_table_from_snapshot(namespace_name, new_table_name, snapshot_name, source_database_name, source_table_name, workgroup_name, params::Dict{String,<:Any})

Restores a table from a snapshot to your Amazon Redshift Serverless instance. You can't use
this operation to restore tables with interleaved sort keys.

# Arguments
- `namespace_name`: The namespace of the snapshot to restore from.
- `new_table_name`: The name of the table to create from the restore operation.
- `snapshot_name`: The name of the snapshot to restore the table from.
- `source_database_name`: The name of the source database that contains the table being
  restored.
- `source_table_name`: The name of the source table being restored.
- `workgroup_name`: The workgroup to restore the table to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"activateCaseSensitiveIdentifier"`: Indicates whether name identifiers for database,
  schema, and table are case sensitive. If true, the names are case sensitive. If false, the
  names are not case sensitive. The default is false.
- `"sourceSchemaName"`: The name of the source schema that contains the table being
  restored.
- `"targetDatabaseName"`: The name of the database to restore the table to.
- `"targetSchemaName"`: The name of the schema to restore the table to.
"""
function restore_table_from_snapshot(
    namespaceName,
    newTableName,
    snapshotName,
    sourceDatabaseName,
    sourceTableName,
    workgroupName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return redshift_serverless(
        "RestoreTableFromSnapshot",
        Dict{String,Any}(
            "namespaceName" => namespaceName,
            "newTableName" => newTableName,
            "snapshotName" => snapshotName,
            "sourceDatabaseName" => sourceDatabaseName,
            "sourceTableName" => sourceTableName,
            "workgroupName" => workgroupName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function restore_table_from_snapshot(
    namespaceName,
    newTableName,
    snapshotName,
    sourceDatabaseName,
    sourceTableName,
    workgroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return redshift_serverless(
        "RestoreTableFromSnapshot",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "namespaceName" => namespaceName,
                    "newTableName" => newTableName,
                    "snapshotName" => snapshotName,
                    "sourceDatabaseName" => sourceDatabaseName,
                    "sourceTableName" => sourceTableName,
                    "workgroupName" => workgroupName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Assigns one or more tags to a resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource to tag.
- `tags`: The map of the key-value pairs used to tag the resource.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return redshift_serverless(
        "TagResource",
        Dict{String,Any}("resourceArn" => resourceArn, "tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return redshift_serverless(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceArn" => resourceArn, "tags" => tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes a tag or set of tags from a resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource to remove tags from.
- `tag_keys`: The tag or set of tags to remove from the resource.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return redshift_serverless(
        "UntagResource",
        Dict{String,Any}("resourceArn" => resourceArn, "tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return redshift_serverless(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceArn" => resourceArn, "tagKeys" => tagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_custom_domain_association(custom_domain_certificate_arn, custom_domain_name, workgroup_name)
    update_custom_domain_association(custom_domain_certificate_arn, custom_domain_name, workgroup_name, params::Dict{String,<:Any})

Updates an Amazon Redshift Serverless certificate associated with a custom domain.

# Arguments
- `custom_domain_certificate_arn`: The custom domain name’s certificate Amazon resource
  name (ARN). This is optional.
- `custom_domain_name`: The custom domain name associated with the workgroup.
- `workgroup_name`: The name of the workgroup associated with the database.

"""
function update_custom_domain_association(
    customDomainCertificateArn,
    customDomainName,
    workgroupName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return redshift_serverless(
        "UpdateCustomDomainAssociation",
        Dict{String,Any}(
            "customDomainCertificateArn" => customDomainCertificateArn,
            "customDomainName" => customDomainName,
            "workgroupName" => workgroupName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_custom_domain_association(
    customDomainCertificateArn,
    customDomainName,
    workgroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return redshift_serverless(
        "UpdateCustomDomainAssociation",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "customDomainCertificateArn" => customDomainCertificateArn,
                    "customDomainName" => customDomainName,
                    "workgroupName" => workgroupName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_endpoint_access(endpoint_name)
    update_endpoint_access(endpoint_name, params::Dict{String,<:Any})

Updates an Amazon Redshift Serverless managed endpoint.

# Arguments
- `endpoint_name`: The name of the VPC endpoint to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"vpcSecurityGroupIds"`: The list of VPC security groups associated with the endpoint
  after the endpoint is modified.
"""
function update_endpoint_access(
    endpointName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return redshift_serverless(
        "UpdateEndpointAccess",
        Dict{String,Any}("endpointName" => endpointName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_endpoint_access(
    endpointName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return redshift_serverless(
        "UpdateEndpointAccess",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("endpointName" => endpointName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_namespace(namespace_name)
    update_namespace(namespace_name, params::Dict{String,<:Any})

Updates a namespace with the specified settings. Unless required, you can't update multiple
parameters in one request. For example, you must specify both adminUsername and
adminUserPassword to update either field, but you can't update both kmsKeyId and logExports
in a single request.

# Arguments
- `namespace_name`: The name of the namespace to update. You can't update the name of a
  namespace once it is created.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"adminPasswordSecretKmsKeyId"`: The ID of the Key Management Service (KMS) key used to
  encrypt and store the namespace's admin credentials secret. You can only use this parameter
  if manageAdminPassword is true.
- `"adminUserPassword"`: The password of the administrator for the first database created
  in the namespace. This parameter must be updated together with adminUsername. You can't use
  adminUserPassword if manageAdminPassword is true.
- `"adminUsername"`: The username of the administrator for the first database created in
  the namespace. This parameter must be updated together with adminUserPassword.
- `"defaultIamRoleArn"`: The Amazon Resource Name (ARN) of the IAM role to set as a default
  in the namespace. This parameter must be updated together with iamRoles.
- `"iamRoles"`: A list of IAM roles to associate with the namespace. This parameter must be
  updated together with defaultIamRoleArn.
- `"kmsKeyId"`: The ID of the Amazon Web Services Key Management Service key used to
  encrypt your data.
- `"logExports"`: The types of logs the namespace can export. The export types are userlog,
  connectionlog, and useractivitylog.
- `"manageAdminPassword"`: If true, Amazon Redshift uses Secrets Manager to manage the
  namespace's admin credentials. You can't use adminUserPassword if manageAdminPassword is
  true. If manageAdminPassword is false or not set, Amazon Redshift uses adminUserPassword
  for the admin user account's password.
"""
function update_namespace(namespaceName; aws_config::AbstractAWSConfig=current_aws_config())
    return redshift_serverless(
        "UpdateNamespace",
        Dict{String,Any}("namespaceName" => namespaceName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_namespace(
    namespaceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return redshift_serverless(
        "UpdateNamespace",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("namespaceName" => namespaceName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_scheduled_action(scheduled_action_name)
    update_scheduled_action(scheduled_action_name, params::Dict{String,<:Any})

Updates a scheduled action.

# Arguments
- `scheduled_action_name`: The name of the scheduled action to update to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"enabled"`: Specifies whether to enable the scheduled action.
- `"endTime"`: The end time in UTC of the scheduled action to update.
- `"roleArn"`: The ARN of the IAM role to assume to run the scheduled action. This IAM role
  must have permission to run the Amazon Redshift Serverless API operation in the scheduled
  action. This IAM role must allow the Amazon Redshift scheduler to schedule creating
  snapshots (Principal scheduler.redshift.amazonaws.com) to assume permissions on your
  behalf. For more information about the IAM role to use with the Amazon Redshift scheduler,
  see Using Identity-Based Policies for Amazon Redshift in the Amazon Redshift Cluster
  Management Guide
- `"schedule"`: The schedule for a one-time (at timestamp format) or recurring (cron
  format) scheduled action. Schedule invocations must be separated by at least one hour.
  Times are in UTC.   Format of at timestamp is yyyy-mm-ddThh:mm:ss. For example,
  2016-03-04T17:27:00.   Format of cron expression is (Minutes Hours Day-of-month Month
  Day-of-week Year). For example, \"(0 10 ? * MON *)\". For more information, see Cron
  Expressions in the Amazon CloudWatch Events User Guide.
- `"scheduledActionDescription"`: The descripion of the scheduled action to update to.
- `"startTime"`: The start time in UTC of the scheduled action to update to.
- `"targetAction"`:
"""
function update_scheduled_action(
    scheduledActionName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return redshift_serverless(
        "UpdateScheduledAction",
        Dict{String,Any}("scheduledActionName" => scheduledActionName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_scheduled_action(
    scheduledActionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return redshift_serverless(
        "UpdateScheduledAction",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("scheduledActionName" => scheduledActionName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_snapshot(snapshot_name)
    update_snapshot(snapshot_name, params::Dict{String,<:Any})

Updates a snapshot.

# Arguments
- `snapshot_name`: The name of the snapshot.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"retentionPeriod"`: The new retention period of the snapshot.
"""
function update_snapshot(snapshotName; aws_config::AbstractAWSConfig=current_aws_config())
    return redshift_serverless(
        "UpdateSnapshot",
        Dict{String,Any}("snapshotName" => snapshotName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_snapshot(
    snapshotName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return redshift_serverless(
        "UpdateSnapshot",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("snapshotName" => snapshotName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_snapshot_copy_configuration(snapshot_copy_configuration_id)
    update_snapshot_copy_configuration(snapshot_copy_configuration_id, params::Dict{String,<:Any})

Updates a snapshot copy configuration.

# Arguments
- `snapshot_copy_configuration_id`: The ID of the snapshot copy configuration to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"snapshotRetentionPeriod"`: The new retention period of how long to keep a snapshot in
  the destination Amazon Web Services Region.
"""
function update_snapshot_copy_configuration(
    snapshotCopyConfigurationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return redshift_serverless(
        "UpdateSnapshotCopyConfiguration",
        Dict{String,Any}("snapshotCopyConfigurationId" => snapshotCopyConfigurationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_snapshot_copy_configuration(
    snapshotCopyConfigurationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return redshift_serverless(
        "UpdateSnapshotCopyConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "snapshotCopyConfigurationId" => snapshotCopyConfigurationId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_usage_limit(usage_limit_id)
    update_usage_limit(usage_limit_id, params::Dict{String,<:Any})

Update a usage limit in Amazon Redshift Serverless. You can't update the usage type or
period of a usage limit.

# Arguments
- `usage_limit_id`: The identifier of the usage limit to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"amount"`: The new limit amount. If time-based, this amount is in Redshift Processing
  Units (RPU) consumed per hour. If data-based, this amount is in terabytes (TB) of data
  transferred between Regions in cross-account sharing. The value must be a positive number.
- `"breachAction"`: The new action that Amazon Redshift Serverless takes when the limit is
  reached.
"""
function update_usage_limit(
    usageLimitId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return redshift_serverless(
        "UpdateUsageLimit",
        Dict{String,Any}("usageLimitId" => usageLimitId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_usage_limit(
    usageLimitId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return redshift_serverless(
        "UpdateUsageLimit",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("usageLimitId" => usageLimitId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_workgroup(workgroup_name)
    update_workgroup(workgroup_name, params::Dict{String,<:Any})

Updates a workgroup with the specified configuration settings. You can't update multiple
parameters in one request. For example, you can update baseCapacity or port in a single
request, but you can't update both in the same request.

# Arguments
- `workgroup_name`: The name of the workgroup to update. You can't update the name of a
  workgroup once it is created.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"baseCapacity"`: The new base data warehouse capacity in Redshift Processing Units
  (RPUs).
- `"configParameters"`: An array of parameters to set for advanced control over a database.
  The options are auto_mv, datestyle, enable_case_sensitive_identifier,
  enable_user_activity_logging, query_group, search_path, require_ssl, use_fips_ssl, and
  query monitoring metrics that let you define performance boundaries. For more information
  about query monitoring rules and available metrics, see  Query monitoring metrics for
  Amazon Redshift Serverless.
- `"enhancedVpcRouting"`: The value that specifies whether to turn on enhanced virtual
  private cloud (VPC) routing, which forces Amazon Redshift Serverless to route traffic
  through your VPC.
- `"maxCapacity"`: The maximum data-warehouse capacity Amazon Redshift Serverless uses to
  serve queries. The max capacity is specified in RPUs.
- `"port"`: The custom port to use when connecting to a workgroup. Valid port ranges are
  5431-5455 and 8191-8215. The default is 5439.
- `"publiclyAccessible"`: A value that specifies whether the workgroup can be accessible
  from a public network.
- `"securityGroupIds"`: An array of security group IDs to associate with the workgroup.
- `"subnetIds"`: An array of VPC subnet IDs to associate with the workgroup.
"""
function update_workgroup(workgroupName; aws_config::AbstractAWSConfig=current_aws_config())
    return redshift_serverless(
        "UpdateWorkgroup",
        Dict{String,Any}("workgroupName" => workgroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_workgroup(
    workgroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return redshift_serverless(
        "UpdateWorkgroup",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("workgroupName" => workgroupName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: application_auto_scaling
using AWS.Compat
using AWS.UUIDs

"""
    delete_scaling_policy(policy_name, resource_id, scalable_dimension, service_namespace)
    delete_scaling_policy(policy_name, resource_id, scalable_dimension, service_namespace, params::Dict{String,<:Any})

Deletes the specified scaling policy for an Application Auto Scaling scalable target.
Deleting a step scaling policy deletes the underlying alarm action, but does not delete the
CloudWatch alarm associated with the scaling policy, even if it no longer has an associated
action. For more information, see Delete a step scaling policy and Delete a target tracking
scaling policy in the Application Auto Scaling User Guide.

# Arguments
- `policy_name`: The name of the scaling policy.
- `resource_id`: The identifier of the resource associated with the scalable target. This
  string consists of the resource type and unique identifier.   ECS service - The resource
  type is service and the unique identifier is the cluster name and service name. Example:
  service/default/sample-webapp.   Spot Fleet - The resource type is spot-fleet-request and
  the unique identifier is the Spot Fleet request ID. Example:
  spot-fleet-request/sfr-73fbd2ce-aa30-494c-8788-1cee4EXAMPLE.   EMR cluster - The resource
  type is instancegroup and the unique identifier is the cluster ID and instance group ID.
  Example: instancegroup/j-2EEZNYKUA1NTV/ig-1791Y4E1L8YI0.   AppStream 2.0 fleet - The
  resource type is fleet and the unique identifier is the fleet name. Example:
  fleet/sample-fleet.   DynamoDB table - The resource type is table and the unique identifier
  is the table name. Example: table/my-table.   DynamoDB global secondary index - The
  resource type is index and the unique identifier is the index name. Example:
  table/my-table/index/my-table-index.   Aurora DB cluster - The resource type is cluster and
  the unique identifier is the cluster name. Example: cluster:my-db-cluster.   SageMaker
  endpoint variant - The resource type is variant and the unique identifier is the resource
  ID. Example: endpoint/my-end-point/variant/KMeansClustering.   Custom resources are not
  supported with a resource type. This parameter must specify the OutputValue from the
  CloudFormation template stack used to access the resources. The unique identifier is
  defined by the service provider. More information is available in our GitHub repository.
  Amazon Comprehend document classification endpoint - The resource type and unique
  identifier are specified using the endpoint ARN. Example:
  arn:aws:comprehend:us-west-2:123456789012:document-classifier-endpoint/EXAMPLE.   Amazon
  Comprehend entity recognizer endpoint - The resource type and unique identifier are
  specified using the endpoint ARN. Example:
  arn:aws:comprehend:us-west-2:123456789012:entity-recognizer-endpoint/EXAMPLE.   Lambda
  provisioned concurrency - The resource type is function and the unique identifier is the
  function name with a function version or alias name suffix that is not LATEST. Example:
  function:my-function:prod or function:my-function:1.   Amazon Keyspaces table - The
  resource type is table and the unique identifier is the table name. Example:
  keyspace/mykeyspace/table/mytable.   Amazon MSK cluster - The resource type and unique
  identifier are specified using the cluster ARN. Example:
  arn:aws:kafka:us-east-1:123456789012:cluster/demo-cluster-1/6357e0b2-0e6a-4b86-a0b4-70df934c
  2e31-5.   Amazon ElastiCache replication group - The resource type is replication-group and
  the unique identifier is the replication group name. Example: replication-group/mycluster.
   Neptune cluster - The resource type is cluster and the unique identifier is the cluster
  name. Example: cluster:mycluster.   SageMaker Serverless endpoint - The resource type is
  variant and the unique identifier is the resource ID. Example:
  endpoint/my-end-point/variant/KMeansClustering.   SageMaker inference component - The
  resource type is inference-component and the unique identifier is the resource ID. Example:
  inference-component/my-inference-component.
- `scalable_dimension`: The scalable dimension. This string consists of the service
  namespace, resource type, and scaling property.    ecs:service:DesiredCount - The desired
  task count of an ECS service.    elasticmapreduce:instancegroup:InstanceCount - The
  instance count of an EMR Instance Group.    ec2:spot-fleet-request:TargetCapacity - The
  target capacity of a Spot Fleet.    appstream:fleet:DesiredCapacity - The desired capacity
  of an AppStream 2.0 fleet.    dynamodb:table:ReadCapacityUnits - The provisioned read
  capacity for a DynamoDB table.    dynamodb:table:WriteCapacityUnits - The provisioned write
  capacity for a DynamoDB table.    dynamodb:index:ReadCapacityUnits - The provisioned read
  capacity for a DynamoDB global secondary index.    dynamodb:index:WriteCapacityUnits - The
  provisioned write capacity for a DynamoDB global secondary index.
  rds:cluster:ReadReplicaCount - The count of Aurora Replicas in an Aurora DB cluster.
  Available for Aurora MySQL-compatible edition and Aurora PostgreSQL-compatible edition.
  sagemaker:variant:DesiredInstanceCount - The number of EC2 instances for a SageMaker model
  endpoint variant.    custom-resource:ResourceType:Property - The scalable dimension for a
  custom resource provided by your own application or service.
  comprehend:document-classifier-endpoint:DesiredInferenceUnits - The number of inference
  units for an Amazon Comprehend document classification endpoint.
  comprehend:entity-recognizer-endpoint:DesiredInferenceUnits - The number of inference units
  for an Amazon Comprehend entity recognizer endpoint.
  lambda:function:ProvisionedConcurrency - The provisioned concurrency for a Lambda function.
     cassandra:table:ReadCapacityUnits - The provisioned read capacity for an Amazon
  Keyspaces table.    cassandra:table:WriteCapacityUnits - The provisioned write capacity for
  an Amazon Keyspaces table.    kafka:broker-storage:VolumeSize - The provisioned volume size
  (in GiB) for brokers in an Amazon MSK cluster.    elasticache:replication-group:NodeGroups
  - The number of node groups for an Amazon ElastiCache replication group.
  elasticache:replication-group:Replicas - The number of replicas per node group for an
  Amazon ElastiCache replication group.    neptune:cluster:ReadReplicaCount - The count of
  read replicas in an Amazon Neptune DB cluster.
  sagemaker:variant:DesiredProvisionedConcurrency - The provisioned concurrency for a
  SageMaker Serverless endpoint.    sagemaker:inference-component:DesiredCopyCount - The
  number of copies across an endpoint for a SageMaker inference component.
- `service_namespace`: The namespace of the Amazon Web Services service that provides the
  resource. For a resource provided by your own application or service, use custom-resource
  instead.

"""
function delete_scaling_policy(
    PolicyName,
    ResourceId,
    ScalableDimension,
    ServiceNamespace;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_auto_scaling(
        "DeleteScalingPolicy",
        Dict{String,Any}(
            "PolicyName" => PolicyName,
            "ResourceId" => ResourceId,
            "ScalableDimension" => ScalableDimension,
            "ServiceNamespace" => ServiceNamespace,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_scaling_policy(
    PolicyName,
    ResourceId,
    ScalableDimension,
    ServiceNamespace,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_auto_scaling(
        "DeleteScalingPolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "PolicyName" => PolicyName,
                    "ResourceId" => ResourceId,
                    "ScalableDimension" => ScalableDimension,
                    "ServiceNamespace" => ServiceNamespace,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_scheduled_action(resource_id, scalable_dimension, scheduled_action_name, service_namespace)
    delete_scheduled_action(resource_id, scalable_dimension, scheduled_action_name, service_namespace, params::Dict{String,<:Any})

Deletes the specified scheduled action for an Application Auto Scaling scalable target. For
more information, see Delete a scheduled action in the Application Auto Scaling User Guide.

# Arguments
- `resource_id`: The identifier of the resource associated with the scheduled action. This
  string consists of the resource type and unique identifier.   ECS service - The resource
  type is service and the unique identifier is the cluster name and service name. Example:
  service/default/sample-webapp.   Spot Fleet - The resource type is spot-fleet-request and
  the unique identifier is the Spot Fleet request ID. Example:
  spot-fleet-request/sfr-73fbd2ce-aa30-494c-8788-1cee4EXAMPLE.   EMR cluster - The resource
  type is instancegroup and the unique identifier is the cluster ID and instance group ID.
  Example: instancegroup/j-2EEZNYKUA1NTV/ig-1791Y4E1L8YI0.   AppStream 2.0 fleet - The
  resource type is fleet and the unique identifier is the fleet name. Example:
  fleet/sample-fleet.   DynamoDB table - The resource type is table and the unique identifier
  is the table name. Example: table/my-table.   DynamoDB global secondary index - The
  resource type is index and the unique identifier is the index name. Example:
  table/my-table/index/my-table-index.   Aurora DB cluster - The resource type is cluster and
  the unique identifier is the cluster name. Example: cluster:my-db-cluster.   SageMaker
  endpoint variant - The resource type is variant and the unique identifier is the resource
  ID. Example: endpoint/my-end-point/variant/KMeansClustering.   Custom resources are not
  supported with a resource type. This parameter must specify the OutputValue from the
  CloudFormation template stack used to access the resources. The unique identifier is
  defined by the service provider. More information is available in our GitHub repository.
  Amazon Comprehend document classification endpoint - The resource type and unique
  identifier are specified using the endpoint ARN. Example:
  arn:aws:comprehend:us-west-2:123456789012:document-classifier-endpoint/EXAMPLE.   Amazon
  Comprehend entity recognizer endpoint - The resource type and unique identifier are
  specified using the endpoint ARN. Example:
  arn:aws:comprehend:us-west-2:123456789012:entity-recognizer-endpoint/EXAMPLE.   Lambda
  provisioned concurrency - The resource type is function and the unique identifier is the
  function name with a function version or alias name suffix that is not LATEST. Example:
  function:my-function:prod or function:my-function:1.   Amazon Keyspaces table - The
  resource type is table and the unique identifier is the table name. Example:
  keyspace/mykeyspace/table/mytable.   Amazon MSK cluster - The resource type and unique
  identifier are specified using the cluster ARN. Example:
  arn:aws:kafka:us-east-1:123456789012:cluster/demo-cluster-1/6357e0b2-0e6a-4b86-a0b4-70df934c
  2e31-5.   Amazon ElastiCache replication group - The resource type is replication-group and
  the unique identifier is the replication group name. Example: replication-group/mycluster.
   Neptune cluster - The resource type is cluster and the unique identifier is the cluster
  name. Example: cluster:mycluster.   SageMaker Serverless endpoint - The resource type is
  variant and the unique identifier is the resource ID. Example:
  endpoint/my-end-point/variant/KMeansClustering.   SageMaker inference component - The
  resource type is inference-component and the unique identifier is the resource ID. Example:
  inference-component/my-inference-component.
- `scalable_dimension`: The scalable dimension. This string consists of the service
  namespace, resource type, and scaling property.    ecs:service:DesiredCount - The desired
  task count of an ECS service.    elasticmapreduce:instancegroup:InstanceCount - The
  instance count of an EMR Instance Group.    ec2:spot-fleet-request:TargetCapacity - The
  target capacity of a Spot Fleet.    appstream:fleet:DesiredCapacity - The desired capacity
  of an AppStream 2.0 fleet.    dynamodb:table:ReadCapacityUnits - The provisioned read
  capacity for a DynamoDB table.    dynamodb:table:WriteCapacityUnits - The provisioned write
  capacity for a DynamoDB table.    dynamodb:index:ReadCapacityUnits - The provisioned read
  capacity for a DynamoDB global secondary index.    dynamodb:index:WriteCapacityUnits - The
  provisioned write capacity for a DynamoDB global secondary index.
  rds:cluster:ReadReplicaCount - The count of Aurora Replicas in an Aurora DB cluster.
  Available for Aurora MySQL-compatible edition and Aurora PostgreSQL-compatible edition.
  sagemaker:variant:DesiredInstanceCount - The number of EC2 instances for a SageMaker model
  endpoint variant.    custom-resource:ResourceType:Property - The scalable dimension for a
  custom resource provided by your own application or service.
  comprehend:document-classifier-endpoint:DesiredInferenceUnits - The number of inference
  units for an Amazon Comprehend document classification endpoint.
  comprehend:entity-recognizer-endpoint:DesiredInferenceUnits - The number of inference units
  for an Amazon Comprehend entity recognizer endpoint.
  lambda:function:ProvisionedConcurrency - The provisioned concurrency for a Lambda function.
     cassandra:table:ReadCapacityUnits - The provisioned read capacity for an Amazon
  Keyspaces table.    cassandra:table:WriteCapacityUnits - The provisioned write capacity for
  an Amazon Keyspaces table.    kafka:broker-storage:VolumeSize - The provisioned volume size
  (in GiB) for brokers in an Amazon MSK cluster.    elasticache:replication-group:NodeGroups
  - The number of node groups for an Amazon ElastiCache replication group.
  elasticache:replication-group:Replicas - The number of replicas per node group for an
  Amazon ElastiCache replication group.    neptune:cluster:ReadReplicaCount - The count of
  read replicas in an Amazon Neptune DB cluster.
  sagemaker:variant:DesiredProvisionedConcurrency - The provisioned concurrency for a
  SageMaker Serverless endpoint.    sagemaker:inference-component:DesiredCopyCount - The
  number of copies across an endpoint for a SageMaker inference component.
- `scheduled_action_name`: The name of the scheduled action.
- `service_namespace`: The namespace of the Amazon Web Services service that provides the
  resource. For a resource provided by your own application or service, use custom-resource
  instead.

"""
function delete_scheduled_action(
    ResourceId,
    ScalableDimension,
    ScheduledActionName,
    ServiceNamespace;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_auto_scaling(
        "DeleteScheduledAction",
        Dict{String,Any}(
            "ResourceId" => ResourceId,
            "ScalableDimension" => ScalableDimension,
            "ScheduledActionName" => ScheduledActionName,
            "ServiceNamespace" => ServiceNamespace,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_scheduled_action(
    ResourceId,
    ScalableDimension,
    ScheduledActionName,
    ServiceNamespace,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_auto_scaling(
        "DeleteScheduledAction",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ResourceId" => ResourceId,
                    "ScalableDimension" => ScalableDimension,
                    "ScheduledActionName" => ScheduledActionName,
                    "ServiceNamespace" => ServiceNamespace,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    deregister_scalable_target(resource_id, scalable_dimension, service_namespace)
    deregister_scalable_target(resource_id, scalable_dimension, service_namespace, params::Dict{String,<:Any})

Deregisters an Application Auto Scaling scalable target when you have finished using it. To
see which resources have been registered, use DescribeScalableTargets.   Deregistering a
scalable target deletes the scaling policies and the scheduled actions that are associated
with it.

# Arguments
- `resource_id`: The identifier of the resource associated with the scalable target. This
  string consists of the resource type and unique identifier.   ECS service - The resource
  type is service and the unique identifier is the cluster name and service name. Example:
  service/default/sample-webapp.   Spot Fleet - The resource type is spot-fleet-request and
  the unique identifier is the Spot Fleet request ID. Example:
  spot-fleet-request/sfr-73fbd2ce-aa30-494c-8788-1cee4EXAMPLE.   EMR cluster - The resource
  type is instancegroup and the unique identifier is the cluster ID and instance group ID.
  Example: instancegroup/j-2EEZNYKUA1NTV/ig-1791Y4E1L8YI0.   AppStream 2.0 fleet - The
  resource type is fleet and the unique identifier is the fleet name. Example:
  fleet/sample-fleet.   DynamoDB table - The resource type is table and the unique identifier
  is the table name. Example: table/my-table.   DynamoDB global secondary index - The
  resource type is index and the unique identifier is the index name. Example:
  table/my-table/index/my-table-index.   Aurora DB cluster - The resource type is cluster and
  the unique identifier is the cluster name. Example: cluster:my-db-cluster.   SageMaker
  endpoint variant - The resource type is variant and the unique identifier is the resource
  ID. Example: endpoint/my-end-point/variant/KMeansClustering.   Custom resources are not
  supported with a resource type. This parameter must specify the OutputValue from the
  CloudFormation template stack used to access the resources. The unique identifier is
  defined by the service provider. More information is available in our GitHub repository.
  Amazon Comprehend document classification endpoint - The resource type and unique
  identifier are specified using the endpoint ARN. Example:
  arn:aws:comprehend:us-west-2:123456789012:document-classifier-endpoint/EXAMPLE.   Amazon
  Comprehend entity recognizer endpoint - The resource type and unique identifier are
  specified using the endpoint ARN. Example:
  arn:aws:comprehend:us-west-2:123456789012:entity-recognizer-endpoint/EXAMPLE.   Lambda
  provisioned concurrency - The resource type is function and the unique identifier is the
  function name with a function version or alias name suffix that is not LATEST. Example:
  function:my-function:prod or function:my-function:1.   Amazon Keyspaces table - The
  resource type is table and the unique identifier is the table name. Example:
  keyspace/mykeyspace/table/mytable.   Amazon MSK cluster - The resource type and unique
  identifier are specified using the cluster ARN. Example:
  arn:aws:kafka:us-east-1:123456789012:cluster/demo-cluster-1/6357e0b2-0e6a-4b86-a0b4-70df934c
  2e31-5.   Amazon ElastiCache replication group - The resource type is replication-group and
  the unique identifier is the replication group name. Example: replication-group/mycluster.
   Neptune cluster - The resource type is cluster and the unique identifier is the cluster
  name. Example: cluster:mycluster.   SageMaker Serverless endpoint - The resource type is
  variant and the unique identifier is the resource ID. Example:
  endpoint/my-end-point/variant/KMeansClustering.   SageMaker inference component - The
  resource type is inference-component and the unique identifier is the resource ID. Example:
  inference-component/my-inference-component.
- `scalable_dimension`: The scalable dimension associated with the scalable target. This
  string consists of the service namespace, resource type, and scaling property.
  ecs:service:DesiredCount - The desired task count of an ECS service.
  elasticmapreduce:instancegroup:InstanceCount - The instance count of an EMR Instance Group.
     ec2:spot-fleet-request:TargetCapacity - The target capacity of a Spot Fleet.
  appstream:fleet:DesiredCapacity - The desired capacity of an AppStream 2.0 fleet.
  dynamodb:table:ReadCapacityUnits - The provisioned read capacity for a DynamoDB table.
  dynamodb:table:WriteCapacityUnits - The provisioned write capacity for a DynamoDB table.
  dynamodb:index:ReadCapacityUnits - The provisioned read capacity for a DynamoDB global
  secondary index.    dynamodb:index:WriteCapacityUnits - The provisioned write capacity for
  a DynamoDB global secondary index.    rds:cluster:ReadReplicaCount - The count of Aurora
  Replicas in an Aurora DB cluster. Available for Aurora MySQL-compatible edition and Aurora
  PostgreSQL-compatible edition.    sagemaker:variant:DesiredInstanceCount - The number of
  EC2 instances for a SageMaker model endpoint variant.
  custom-resource:ResourceType:Property - The scalable dimension for a custom resource
  provided by your own application or service.
  comprehend:document-classifier-endpoint:DesiredInferenceUnits - The number of inference
  units for an Amazon Comprehend document classification endpoint.
  comprehend:entity-recognizer-endpoint:DesiredInferenceUnits - The number of inference units
  for an Amazon Comprehend entity recognizer endpoint.
  lambda:function:ProvisionedConcurrency - The provisioned concurrency for a Lambda function.
     cassandra:table:ReadCapacityUnits - The provisioned read capacity for an Amazon
  Keyspaces table.    cassandra:table:WriteCapacityUnits - The provisioned write capacity for
  an Amazon Keyspaces table.    kafka:broker-storage:VolumeSize - The provisioned volume size
  (in GiB) for brokers in an Amazon MSK cluster.    elasticache:replication-group:NodeGroups
  - The number of node groups for an Amazon ElastiCache replication group.
  elasticache:replication-group:Replicas - The number of replicas per node group for an
  Amazon ElastiCache replication group.    neptune:cluster:ReadReplicaCount - The count of
  read replicas in an Amazon Neptune DB cluster.
  sagemaker:variant:DesiredProvisionedConcurrency - The provisioned concurrency for a
  SageMaker Serverless endpoint.    sagemaker:inference-component:DesiredCopyCount - The
  number of copies across an endpoint for a SageMaker inference component.
- `service_namespace`: The namespace of the Amazon Web Services service that provides the
  resource. For a resource provided by your own application or service, use custom-resource
  instead.

"""
function deregister_scalable_target(
    ResourceId,
    ScalableDimension,
    ServiceNamespace;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_auto_scaling(
        "DeregisterScalableTarget",
        Dict{String,Any}(
            "ResourceId" => ResourceId,
            "ScalableDimension" => ScalableDimension,
            "ServiceNamespace" => ServiceNamespace,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function deregister_scalable_target(
    ResourceId,
    ScalableDimension,
    ServiceNamespace,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_auto_scaling(
        "DeregisterScalableTarget",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ResourceId" => ResourceId,
                    "ScalableDimension" => ScalableDimension,
                    "ServiceNamespace" => ServiceNamespace,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_scalable_targets(service_namespace)
    describe_scalable_targets(service_namespace, params::Dict{String,<:Any})

Gets information about the scalable targets in the specified namespace. You can filter the
results using ResourceIds and ScalableDimension.

# Arguments
- `service_namespace`: The namespace of the Amazon Web Services service that provides the
  resource. For a resource provided by your own application or service, use custom-resource
  instead.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of scalable targets. This value can be between 1 and
  50. The default value is 50. If this parameter is used, the operation returns up to
  MaxResults results at a time, along with a NextToken value. To get the next set of results,
  include the NextToken value in a subsequent call. If this parameter is not used, the
  operation returns up to 50 results and a NextToken value, if applicable.
- `"NextToken"`: The token for the next set of results.
- `"ResourceIds"`: The identifier of the resource associated with the scalable target. This
  string consists of the resource type and unique identifier.   ECS service - The resource
  type is service and the unique identifier is the cluster name and service name. Example:
  service/default/sample-webapp.   Spot Fleet - The resource type is spot-fleet-request and
  the unique identifier is the Spot Fleet request ID. Example:
  spot-fleet-request/sfr-73fbd2ce-aa30-494c-8788-1cee4EXAMPLE.   EMR cluster - The resource
  type is instancegroup and the unique identifier is the cluster ID and instance group ID.
  Example: instancegroup/j-2EEZNYKUA1NTV/ig-1791Y4E1L8YI0.   AppStream 2.0 fleet - The
  resource type is fleet and the unique identifier is the fleet name. Example:
  fleet/sample-fleet.   DynamoDB table - The resource type is table and the unique identifier
  is the table name. Example: table/my-table.   DynamoDB global secondary index - The
  resource type is index and the unique identifier is the index name. Example:
  table/my-table/index/my-table-index.   Aurora DB cluster - The resource type is cluster and
  the unique identifier is the cluster name. Example: cluster:my-db-cluster.   SageMaker
  endpoint variant - The resource type is variant and the unique identifier is the resource
  ID. Example: endpoint/my-end-point/variant/KMeansClustering.   Custom resources are not
  supported with a resource type. This parameter must specify the OutputValue from the
  CloudFormation template stack used to access the resources. The unique identifier is
  defined by the service provider. More information is available in our GitHub repository.
  Amazon Comprehend document classification endpoint - The resource type and unique
  identifier are specified using the endpoint ARN. Example:
  arn:aws:comprehend:us-west-2:123456789012:document-classifier-endpoint/EXAMPLE.   Amazon
  Comprehend entity recognizer endpoint - The resource type and unique identifier are
  specified using the endpoint ARN. Example:
  arn:aws:comprehend:us-west-2:123456789012:entity-recognizer-endpoint/EXAMPLE.   Lambda
  provisioned concurrency - The resource type is function and the unique identifier is the
  function name with a function version or alias name suffix that is not LATEST. Example:
  function:my-function:prod or function:my-function:1.   Amazon Keyspaces table - The
  resource type is table and the unique identifier is the table name. Example:
  keyspace/mykeyspace/table/mytable.   Amazon MSK cluster - The resource type and unique
  identifier are specified using the cluster ARN. Example:
  arn:aws:kafka:us-east-1:123456789012:cluster/demo-cluster-1/6357e0b2-0e6a-4b86-a0b4-70df934c
  2e31-5.   Amazon ElastiCache replication group - The resource type is replication-group and
  the unique identifier is the replication group name. Example: replication-group/mycluster.
   Neptune cluster - The resource type is cluster and the unique identifier is the cluster
  name. Example: cluster:mycluster.   SageMaker Serverless endpoint - The resource type is
  variant and the unique identifier is the resource ID. Example:
  endpoint/my-end-point/variant/KMeansClustering.   SageMaker inference component - The
  resource type is inference-component and the unique identifier is the resource ID. Example:
  inference-component/my-inference-component.
- `"ScalableDimension"`: The scalable dimension associated with the scalable target. This
  string consists of the service namespace, resource type, and scaling property. If you
  specify a scalable dimension, you must also specify a resource ID.
  ecs:service:DesiredCount - The desired task count of an ECS service.
  elasticmapreduce:instancegroup:InstanceCount - The instance count of an EMR Instance Group.
     ec2:spot-fleet-request:TargetCapacity - The target capacity of a Spot Fleet.
  appstream:fleet:DesiredCapacity - The desired capacity of an AppStream 2.0 fleet.
  dynamodb:table:ReadCapacityUnits - The provisioned read capacity for a DynamoDB table.
  dynamodb:table:WriteCapacityUnits - The provisioned write capacity for a DynamoDB table.
  dynamodb:index:ReadCapacityUnits - The provisioned read capacity for a DynamoDB global
  secondary index.    dynamodb:index:WriteCapacityUnits - The provisioned write capacity for
  a DynamoDB global secondary index.    rds:cluster:ReadReplicaCount - The count of Aurora
  Replicas in an Aurora DB cluster. Available for Aurora MySQL-compatible edition and Aurora
  PostgreSQL-compatible edition.    sagemaker:variant:DesiredInstanceCount - The number of
  EC2 instances for a SageMaker model endpoint variant.
  custom-resource:ResourceType:Property - The scalable dimension for a custom resource
  provided by your own application or service.
  comprehend:document-classifier-endpoint:DesiredInferenceUnits - The number of inference
  units for an Amazon Comprehend document classification endpoint.
  comprehend:entity-recognizer-endpoint:DesiredInferenceUnits - The number of inference units
  for an Amazon Comprehend entity recognizer endpoint.
  lambda:function:ProvisionedConcurrency - The provisioned concurrency for a Lambda function.
     cassandra:table:ReadCapacityUnits - The provisioned read capacity for an Amazon
  Keyspaces table.    cassandra:table:WriteCapacityUnits - The provisioned write capacity for
  an Amazon Keyspaces table.    kafka:broker-storage:VolumeSize - The provisioned volume size
  (in GiB) for brokers in an Amazon MSK cluster.    elasticache:replication-group:NodeGroups
  - The number of node groups for an Amazon ElastiCache replication group.
  elasticache:replication-group:Replicas - The number of replicas per node group for an
  Amazon ElastiCache replication group.    neptune:cluster:ReadReplicaCount - The count of
  read replicas in an Amazon Neptune DB cluster.
  sagemaker:variant:DesiredProvisionedConcurrency - The provisioned concurrency for a
  SageMaker Serverless endpoint.    sagemaker:inference-component:DesiredCopyCount - The
  number of copies across an endpoint for a SageMaker inference component.
"""
function describe_scalable_targets(
    ServiceNamespace; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_auto_scaling(
        "DescribeScalableTargets",
        Dict{String,Any}("ServiceNamespace" => ServiceNamespace);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_scalable_targets(
    ServiceNamespace,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_auto_scaling(
        "DescribeScalableTargets",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ServiceNamespace" => ServiceNamespace), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_scaling_activities(service_namespace)
    describe_scaling_activities(service_namespace, params::Dict{String,<:Any})

Provides descriptive information about the scaling activities in the specified namespace
from the previous six weeks. You can filter the results using ResourceId and
ScalableDimension. For information about viewing scaling activities using the Amazon Web
Services CLI, see Scaling activities for Application Auto Scaling.

# Arguments
- `service_namespace`: The namespace of the Amazon Web Services service that provides the
  resource. For a resource provided by your own application or service, use custom-resource
  instead.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"IncludeNotScaledActivities"`: Specifies whether to include activities that aren't
  scaled (not scaled activities) in the response. Not scaled activities are activities that
  aren't completed or started for various reasons, such as preventing infinite scaling loops.
  For help interpreting the not scaled reason details in the response, see Scaling activities
  for Application Auto Scaling.
- `"MaxResults"`: The maximum number of scalable targets. This value can be between 1 and
  50. The default value is 50. If this parameter is used, the operation returns up to
  MaxResults results at a time, along with a NextToken value. To get the next set of results,
  include the NextToken value in a subsequent call. If this parameter is not used, the
  operation returns up to 50 results and a NextToken value, if applicable.
- `"NextToken"`: The token for the next set of results.
- `"ResourceId"`: The identifier of the resource associated with the scaling activity. This
  string consists of the resource type and unique identifier.   ECS service - The resource
  type is service and the unique identifier is the cluster name and service name. Example:
  service/default/sample-webapp.   Spot Fleet - The resource type is spot-fleet-request and
  the unique identifier is the Spot Fleet request ID. Example:
  spot-fleet-request/sfr-73fbd2ce-aa30-494c-8788-1cee4EXAMPLE.   EMR cluster - The resource
  type is instancegroup and the unique identifier is the cluster ID and instance group ID.
  Example: instancegroup/j-2EEZNYKUA1NTV/ig-1791Y4E1L8YI0.   AppStream 2.0 fleet - The
  resource type is fleet and the unique identifier is the fleet name. Example:
  fleet/sample-fleet.   DynamoDB table - The resource type is table and the unique identifier
  is the table name. Example: table/my-table.   DynamoDB global secondary index - The
  resource type is index and the unique identifier is the index name. Example:
  table/my-table/index/my-table-index.   Aurora DB cluster - The resource type is cluster and
  the unique identifier is the cluster name. Example: cluster:my-db-cluster.   SageMaker
  endpoint variant - The resource type is variant and the unique identifier is the resource
  ID. Example: endpoint/my-end-point/variant/KMeansClustering.   Custom resources are not
  supported with a resource type. This parameter must specify the OutputValue from the
  CloudFormation template stack used to access the resources. The unique identifier is
  defined by the service provider. More information is available in our GitHub repository.
  Amazon Comprehend document classification endpoint - The resource type and unique
  identifier are specified using the endpoint ARN. Example:
  arn:aws:comprehend:us-west-2:123456789012:document-classifier-endpoint/EXAMPLE.   Amazon
  Comprehend entity recognizer endpoint - The resource type and unique identifier are
  specified using the endpoint ARN. Example:
  arn:aws:comprehend:us-west-2:123456789012:entity-recognizer-endpoint/EXAMPLE.   Lambda
  provisioned concurrency - The resource type is function and the unique identifier is the
  function name with a function version or alias name suffix that is not LATEST. Example:
  function:my-function:prod or function:my-function:1.   Amazon Keyspaces table - The
  resource type is table and the unique identifier is the table name. Example:
  keyspace/mykeyspace/table/mytable.   Amazon MSK cluster - The resource type and unique
  identifier are specified using the cluster ARN. Example:
  arn:aws:kafka:us-east-1:123456789012:cluster/demo-cluster-1/6357e0b2-0e6a-4b86-a0b4-70df934c
  2e31-5.   Amazon ElastiCache replication group - The resource type is replication-group and
  the unique identifier is the replication group name. Example: replication-group/mycluster.
   Neptune cluster - The resource type is cluster and the unique identifier is the cluster
  name. Example: cluster:mycluster.   SageMaker Serverless endpoint - The resource type is
  variant and the unique identifier is the resource ID. Example:
  endpoint/my-end-point/variant/KMeansClustering.   SageMaker inference component - The
  resource type is inference-component and the unique identifier is the resource ID. Example:
  inference-component/my-inference-component.
- `"ScalableDimension"`: The scalable dimension. This string consists of the service
  namespace, resource type, and scaling property. If you specify a scalable dimension, you
  must also specify a resource ID.    ecs:service:DesiredCount - The desired task count of an
  ECS service.    elasticmapreduce:instancegroup:InstanceCount - The instance count of an EMR
  Instance Group.    ec2:spot-fleet-request:TargetCapacity - The target capacity of a Spot
  Fleet.    appstream:fleet:DesiredCapacity - The desired capacity of an AppStream 2.0 fleet.
     dynamodb:table:ReadCapacityUnits - The provisioned read capacity for a DynamoDB table.
   dynamodb:table:WriteCapacityUnits - The provisioned write capacity for a DynamoDB table.
   dynamodb:index:ReadCapacityUnits - The provisioned read capacity for a DynamoDB global
  secondary index.    dynamodb:index:WriteCapacityUnits - The provisioned write capacity for
  a DynamoDB global secondary index.    rds:cluster:ReadReplicaCount - The count of Aurora
  Replicas in an Aurora DB cluster. Available for Aurora MySQL-compatible edition and Aurora
  PostgreSQL-compatible edition.    sagemaker:variant:DesiredInstanceCount - The number of
  EC2 instances for a SageMaker model endpoint variant.
  custom-resource:ResourceType:Property - The scalable dimension for a custom resource
  provided by your own application or service.
  comprehend:document-classifier-endpoint:DesiredInferenceUnits - The number of inference
  units for an Amazon Comprehend document classification endpoint.
  comprehend:entity-recognizer-endpoint:DesiredInferenceUnits - The number of inference units
  for an Amazon Comprehend entity recognizer endpoint.
  lambda:function:ProvisionedConcurrency - The provisioned concurrency for a Lambda function.
     cassandra:table:ReadCapacityUnits - The provisioned read capacity for an Amazon
  Keyspaces table.    cassandra:table:WriteCapacityUnits - The provisioned write capacity for
  an Amazon Keyspaces table.    kafka:broker-storage:VolumeSize - The provisioned volume size
  (in GiB) for brokers in an Amazon MSK cluster.    elasticache:replication-group:NodeGroups
  - The number of node groups for an Amazon ElastiCache replication group.
  elasticache:replication-group:Replicas - The number of replicas per node group for an
  Amazon ElastiCache replication group.    neptune:cluster:ReadReplicaCount - The count of
  read replicas in an Amazon Neptune DB cluster.
  sagemaker:variant:DesiredProvisionedConcurrency - The provisioned concurrency for a
  SageMaker Serverless endpoint.    sagemaker:inference-component:DesiredCopyCount - The
  number of copies across an endpoint for a SageMaker inference component.
"""
function describe_scaling_activities(
    ServiceNamespace; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_auto_scaling(
        "DescribeScalingActivities",
        Dict{String,Any}("ServiceNamespace" => ServiceNamespace);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_scaling_activities(
    ServiceNamespace,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_auto_scaling(
        "DescribeScalingActivities",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ServiceNamespace" => ServiceNamespace), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_scaling_policies(service_namespace)
    describe_scaling_policies(service_namespace, params::Dict{String,<:Any})

Describes the Application Auto Scaling scaling policies for the specified service
namespace. You can filter the results using ResourceId, ScalableDimension, and PolicyNames.
For more information, see Target tracking scaling policies and Step scaling policies in the
Application Auto Scaling User Guide.

# Arguments
- `service_namespace`: The namespace of the Amazon Web Services service that provides the
  resource. For a resource provided by your own application or service, use custom-resource
  instead.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of scalable targets. This value can be between 1 and
  10. The default value is 10. If this parameter is used, the operation returns up to
  MaxResults results at a time, along with a NextToken value. To get the next set of results,
  include the NextToken value in a subsequent call. If this parameter is not used, the
  operation returns up to 10 results and a NextToken value, if applicable.
- `"NextToken"`: The token for the next set of results.
- `"PolicyNames"`: The names of the scaling policies to describe.
- `"ResourceId"`: The identifier of the resource associated with the scaling policy. This
  string consists of the resource type and unique identifier.   ECS service - The resource
  type is service and the unique identifier is the cluster name and service name. Example:
  service/default/sample-webapp.   Spot Fleet - The resource type is spot-fleet-request and
  the unique identifier is the Spot Fleet request ID. Example:
  spot-fleet-request/sfr-73fbd2ce-aa30-494c-8788-1cee4EXAMPLE.   EMR cluster - The resource
  type is instancegroup and the unique identifier is the cluster ID and instance group ID.
  Example: instancegroup/j-2EEZNYKUA1NTV/ig-1791Y4E1L8YI0.   AppStream 2.0 fleet - The
  resource type is fleet and the unique identifier is the fleet name. Example:
  fleet/sample-fleet.   DynamoDB table - The resource type is table and the unique identifier
  is the table name. Example: table/my-table.   DynamoDB global secondary index - The
  resource type is index and the unique identifier is the index name. Example:
  table/my-table/index/my-table-index.   Aurora DB cluster - The resource type is cluster and
  the unique identifier is the cluster name. Example: cluster:my-db-cluster.   SageMaker
  endpoint variant - The resource type is variant and the unique identifier is the resource
  ID. Example: endpoint/my-end-point/variant/KMeansClustering.   Custom resources are not
  supported with a resource type. This parameter must specify the OutputValue from the
  CloudFormation template stack used to access the resources. The unique identifier is
  defined by the service provider. More information is available in our GitHub repository.
  Amazon Comprehend document classification endpoint - The resource type and unique
  identifier are specified using the endpoint ARN. Example:
  arn:aws:comprehend:us-west-2:123456789012:document-classifier-endpoint/EXAMPLE.   Amazon
  Comprehend entity recognizer endpoint - The resource type and unique identifier are
  specified using the endpoint ARN. Example:
  arn:aws:comprehend:us-west-2:123456789012:entity-recognizer-endpoint/EXAMPLE.   Lambda
  provisioned concurrency - The resource type is function and the unique identifier is the
  function name with a function version or alias name suffix that is not LATEST. Example:
  function:my-function:prod or function:my-function:1.   Amazon Keyspaces table - The
  resource type is table and the unique identifier is the table name. Example:
  keyspace/mykeyspace/table/mytable.   Amazon MSK cluster - The resource type and unique
  identifier are specified using the cluster ARN. Example:
  arn:aws:kafka:us-east-1:123456789012:cluster/demo-cluster-1/6357e0b2-0e6a-4b86-a0b4-70df934c
  2e31-5.   Amazon ElastiCache replication group - The resource type is replication-group and
  the unique identifier is the replication group name. Example: replication-group/mycluster.
   Neptune cluster - The resource type is cluster and the unique identifier is the cluster
  name. Example: cluster:mycluster.   SageMaker Serverless endpoint - The resource type is
  variant and the unique identifier is the resource ID. Example:
  endpoint/my-end-point/variant/KMeansClustering.   SageMaker inference component - The
  resource type is inference-component and the unique identifier is the resource ID. Example:
  inference-component/my-inference-component.
- `"ScalableDimension"`: The scalable dimension. This string consists of the service
  namespace, resource type, and scaling property. If you specify a scalable dimension, you
  must also specify a resource ID.    ecs:service:DesiredCount - The desired task count of an
  ECS service.    elasticmapreduce:instancegroup:InstanceCount - The instance count of an EMR
  Instance Group.    ec2:spot-fleet-request:TargetCapacity - The target capacity of a Spot
  Fleet.    appstream:fleet:DesiredCapacity - The desired capacity of an AppStream 2.0 fleet.
     dynamodb:table:ReadCapacityUnits - The provisioned read capacity for a DynamoDB table.
   dynamodb:table:WriteCapacityUnits - The provisioned write capacity for a DynamoDB table.
   dynamodb:index:ReadCapacityUnits - The provisioned read capacity for a DynamoDB global
  secondary index.    dynamodb:index:WriteCapacityUnits - The provisioned write capacity for
  a DynamoDB global secondary index.    rds:cluster:ReadReplicaCount - The count of Aurora
  Replicas in an Aurora DB cluster. Available for Aurora MySQL-compatible edition and Aurora
  PostgreSQL-compatible edition.    sagemaker:variant:DesiredInstanceCount - The number of
  EC2 instances for a SageMaker model endpoint variant.
  custom-resource:ResourceType:Property - The scalable dimension for a custom resource
  provided by your own application or service.
  comprehend:document-classifier-endpoint:DesiredInferenceUnits - The number of inference
  units for an Amazon Comprehend document classification endpoint.
  comprehend:entity-recognizer-endpoint:DesiredInferenceUnits - The number of inference units
  for an Amazon Comprehend entity recognizer endpoint.
  lambda:function:ProvisionedConcurrency - The provisioned concurrency for a Lambda function.
     cassandra:table:ReadCapacityUnits - The provisioned read capacity for an Amazon
  Keyspaces table.    cassandra:table:WriteCapacityUnits - The provisioned write capacity for
  an Amazon Keyspaces table.    kafka:broker-storage:VolumeSize - The provisioned volume size
  (in GiB) for brokers in an Amazon MSK cluster.    elasticache:replication-group:NodeGroups
  - The number of node groups for an Amazon ElastiCache replication group.
  elasticache:replication-group:Replicas - The number of replicas per node group for an
  Amazon ElastiCache replication group.    neptune:cluster:ReadReplicaCount - The count of
  read replicas in an Amazon Neptune DB cluster.
  sagemaker:variant:DesiredProvisionedConcurrency - The provisioned concurrency for a
  SageMaker Serverless endpoint.    sagemaker:inference-component:DesiredCopyCount - The
  number of copies across an endpoint for a SageMaker inference component.
"""
function describe_scaling_policies(
    ServiceNamespace; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_auto_scaling(
        "DescribeScalingPolicies",
        Dict{String,Any}("ServiceNamespace" => ServiceNamespace);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_scaling_policies(
    ServiceNamespace,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_auto_scaling(
        "DescribeScalingPolicies",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ServiceNamespace" => ServiceNamespace), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_scheduled_actions(service_namespace)
    describe_scheduled_actions(service_namespace, params::Dict{String,<:Any})

Describes the Application Auto Scaling scheduled actions for the specified service
namespace. You can filter the results using the ResourceId, ScalableDimension, and
ScheduledActionNames parameters. For more information, see Scheduled scaling and Managing
scheduled scaling in the Application Auto Scaling User Guide.

# Arguments
- `service_namespace`: The namespace of the Amazon Web Services service that provides the
  resource. For a resource provided by your own application or service, use custom-resource
  instead.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of scheduled action results. This value can be between
  1 and 50. The default value is 50. If this parameter is used, the operation returns up to
  MaxResults results at a time, along with a NextToken value. To get the next set of results,
  include the NextToken value in a subsequent call. If this parameter is not used, the
  operation returns up to 50 results and a NextToken value, if applicable.
- `"NextToken"`: The token for the next set of results.
- `"ResourceId"`: The identifier of the resource associated with the scheduled action. This
  string consists of the resource type and unique identifier.   ECS service - The resource
  type is service and the unique identifier is the cluster name and service name. Example:
  service/default/sample-webapp.   Spot Fleet - The resource type is spot-fleet-request and
  the unique identifier is the Spot Fleet request ID. Example:
  spot-fleet-request/sfr-73fbd2ce-aa30-494c-8788-1cee4EXAMPLE.   EMR cluster - The resource
  type is instancegroup and the unique identifier is the cluster ID and instance group ID.
  Example: instancegroup/j-2EEZNYKUA1NTV/ig-1791Y4E1L8YI0.   AppStream 2.0 fleet - The
  resource type is fleet and the unique identifier is the fleet name. Example:
  fleet/sample-fleet.   DynamoDB table - The resource type is table and the unique identifier
  is the table name. Example: table/my-table.   DynamoDB global secondary index - The
  resource type is index and the unique identifier is the index name. Example:
  table/my-table/index/my-table-index.   Aurora DB cluster - The resource type is cluster and
  the unique identifier is the cluster name. Example: cluster:my-db-cluster.   SageMaker
  endpoint variant - The resource type is variant and the unique identifier is the resource
  ID. Example: endpoint/my-end-point/variant/KMeansClustering.   Custom resources are not
  supported with a resource type. This parameter must specify the OutputValue from the
  CloudFormation template stack used to access the resources. The unique identifier is
  defined by the service provider. More information is available in our GitHub repository.
  Amazon Comprehend document classification endpoint - The resource type and unique
  identifier are specified using the endpoint ARN. Example:
  arn:aws:comprehend:us-west-2:123456789012:document-classifier-endpoint/EXAMPLE.   Amazon
  Comprehend entity recognizer endpoint - The resource type and unique identifier are
  specified using the endpoint ARN. Example:
  arn:aws:comprehend:us-west-2:123456789012:entity-recognizer-endpoint/EXAMPLE.   Lambda
  provisioned concurrency - The resource type is function and the unique identifier is the
  function name with a function version or alias name suffix that is not LATEST. Example:
  function:my-function:prod or function:my-function:1.   Amazon Keyspaces table - The
  resource type is table and the unique identifier is the table name. Example:
  keyspace/mykeyspace/table/mytable.   Amazon MSK cluster - The resource type and unique
  identifier are specified using the cluster ARN. Example:
  arn:aws:kafka:us-east-1:123456789012:cluster/demo-cluster-1/6357e0b2-0e6a-4b86-a0b4-70df934c
  2e31-5.   Amazon ElastiCache replication group - The resource type is replication-group and
  the unique identifier is the replication group name. Example: replication-group/mycluster.
   Neptune cluster - The resource type is cluster and the unique identifier is the cluster
  name. Example: cluster:mycluster.   SageMaker Serverless endpoint - The resource type is
  variant and the unique identifier is the resource ID. Example:
  endpoint/my-end-point/variant/KMeansClustering.   SageMaker inference component - The
  resource type is inference-component and the unique identifier is the resource ID. Example:
  inference-component/my-inference-component.
- `"ScalableDimension"`: The scalable dimension. This string consists of the service
  namespace, resource type, and scaling property. If you specify a scalable dimension, you
  must also specify a resource ID.    ecs:service:DesiredCount - The desired task count of an
  ECS service.    elasticmapreduce:instancegroup:InstanceCount - The instance count of an EMR
  Instance Group.    ec2:spot-fleet-request:TargetCapacity - The target capacity of a Spot
  Fleet.    appstream:fleet:DesiredCapacity - The desired capacity of an AppStream 2.0 fleet.
     dynamodb:table:ReadCapacityUnits - The provisioned read capacity for a DynamoDB table.
   dynamodb:table:WriteCapacityUnits - The provisioned write capacity for a DynamoDB table.
   dynamodb:index:ReadCapacityUnits - The provisioned read capacity for a DynamoDB global
  secondary index.    dynamodb:index:WriteCapacityUnits - The provisioned write capacity for
  a DynamoDB global secondary index.    rds:cluster:ReadReplicaCount - The count of Aurora
  Replicas in an Aurora DB cluster. Available for Aurora MySQL-compatible edition and Aurora
  PostgreSQL-compatible edition.    sagemaker:variant:DesiredInstanceCount - The number of
  EC2 instances for a SageMaker model endpoint variant.
  custom-resource:ResourceType:Property - The scalable dimension for a custom resource
  provided by your own application or service.
  comprehend:document-classifier-endpoint:DesiredInferenceUnits - The number of inference
  units for an Amazon Comprehend document classification endpoint.
  comprehend:entity-recognizer-endpoint:DesiredInferenceUnits - The number of inference units
  for an Amazon Comprehend entity recognizer endpoint.
  lambda:function:ProvisionedConcurrency - The provisioned concurrency for a Lambda function.
     cassandra:table:ReadCapacityUnits - The provisioned read capacity for an Amazon
  Keyspaces table.    cassandra:table:WriteCapacityUnits - The provisioned write capacity for
  an Amazon Keyspaces table.    kafka:broker-storage:VolumeSize - The provisioned volume size
  (in GiB) for brokers in an Amazon MSK cluster.    elasticache:replication-group:NodeGroups
  - The number of node groups for an Amazon ElastiCache replication group.
  elasticache:replication-group:Replicas - The number of replicas per node group for an
  Amazon ElastiCache replication group.    neptune:cluster:ReadReplicaCount - The count of
  read replicas in an Amazon Neptune DB cluster.
  sagemaker:variant:DesiredProvisionedConcurrency - The provisioned concurrency for a
  SageMaker Serverless endpoint.    sagemaker:inference-component:DesiredCopyCount - The
  number of copies across an endpoint for a SageMaker inference component.
- `"ScheduledActionNames"`: The names of the scheduled actions to describe.
"""
function describe_scheduled_actions(
    ServiceNamespace; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_auto_scaling(
        "DescribeScheduledActions",
        Dict{String,Any}("ServiceNamespace" => ServiceNamespace);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_scheduled_actions(
    ServiceNamespace,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_auto_scaling(
        "DescribeScheduledActions",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ServiceNamespace" => ServiceNamespace), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Returns all the tags on the specified Application Auto Scaling scalable target. For general
information about tags, including the format and syntax, see Tagging Amazon Web Services
resources in the Amazon Web Services General Reference.

# Arguments
- `resource_arn`: Specify the ARN of the scalable target. For example:
  arn:aws:application-autoscaling:us-east-1:123456789012:scalable-target/1234abcd56ab78cd901ef
  1234567890ab123  To get the ARN for a scalable target, use DescribeScalableTargets.

"""
function list_tags_for_resource(
    ResourceARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_auto_scaling(
        "ListTagsForResource",
        Dict{String,Any}("ResourceARN" => ResourceARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_auto_scaling(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceARN" => ResourceARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_scaling_policy(policy_name, resource_id, scalable_dimension, service_namespace)
    put_scaling_policy(policy_name, resource_id, scalable_dimension, service_namespace, params::Dict{String,<:Any})

Creates or updates a scaling policy for an Application Auto Scaling scalable target. Each
scalable target is identified by a service namespace, resource ID, and scalable dimension.
A scaling policy applies to the scalable target identified by those three attributes. You
cannot create a scaling policy until you have registered the resource as a scalable target.
Multiple scaling policies can be in force at the same time for the same scalable target.
You can have one or more target tracking scaling policies, one or more step scaling
policies, or both. However, there is a chance that multiple policies could conflict,
instructing the scalable target to scale out or in at the same time. Application Auto
Scaling gives precedence to the policy that provides the largest capacity for both scale
out and scale in. For example, if one policy increases capacity by 3, another policy
increases capacity by 200 percent, and the current capacity is 10, Application Auto Scaling
uses the policy with the highest calculated capacity (200% of 10 = 20) and scales out to
30.  We recommend caution, however, when using target tracking scaling policies with step
scaling policies because conflicts between these policies can cause undesirable behavior.
For example, if the step scaling policy initiates a scale-in activity before the target
tracking policy is ready to scale in, the scale-in activity will not be blocked. After the
scale-in activity completes, the target tracking policy could instruct the scalable target
to scale out again.  For more information, see Target tracking scaling policies and Step
scaling policies in the Application Auto Scaling User Guide.  If a scalable target is
deregistered, the scalable target is no longer available to use scaling policies. Any
scaling policies that were specified for the scalable target are deleted.

# Arguments
- `policy_name`: The name of the scaling policy. You cannot change the name of a scaling
  policy, but you can delete the original scaling policy and create a new scaling policy with
  the same settings and a different name.
- `resource_id`: The identifier of the resource associated with the scaling policy. This
  string consists of the resource type and unique identifier.   ECS service - The resource
  type is service and the unique identifier is the cluster name and service name. Example:
  service/default/sample-webapp.   Spot Fleet - The resource type is spot-fleet-request and
  the unique identifier is the Spot Fleet request ID. Example:
  spot-fleet-request/sfr-73fbd2ce-aa30-494c-8788-1cee4EXAMPLE.   EMR cluster - The resource
  type is instancegroup and the unique identifier is the cluster ID and instance group ID.
  Example: instancegroup/j-2EEZNYKUA1NTV/ig-1791Y4E1L8YI0.   AppStream 2.0 fleet - The
  resource type is fleet and the unique identifier is the fleet name. Example:
  fleet/sample-fleet.   DynamoDB table - The resource type is table and the unique identifier
  is the table name. Example: table/my-table.   DynamoDB global secondary index - The
  resource type is index and the unique identifier is the index name. Example:
  table/my-table/index/my-table-index.   Aurora DB cluster - The resource type is cluster and
  the unique identifier is the cluster name. Example: cluster:my-db-cluster.   SageMaker
  endpoint variant - The resource type is variant and the unique identifier is the resource
  ID. Example: endpoint/my-end-point/variant/KMeansClustering.   Custom resources are not
  supported with a resource type. This parameter must specify the OutputValue from the
  CloudFormation template stack used to access the resources. The unique identifier is
  defined by the service provider. More information is available in our GitHub repository.
  Amazon Comprehend document classification endpoint - The resource type and unique
  identifier are specified using the endpoint ARN. Example:
  arn:aws:comprehend:us-west-2:123456789012:document-classifier-endpoint/EXAMPLE.   Amazon
  Comprehend entity recognizer endpoint - The resource type and unique identifier are
  specified using the endpoint ARN. Example:
  arn:aws:comprehend:us-west-2:123456789012:entity-recognizer-endpoint/EXAMPLE.   Lambda
  provisioned concurrency - The resource type is function and the unique identifier is the
  function name with a function version or alias name suffix that is not LATEST. Example:
  function:my-function:prod or function:my-function:1.   Amazon Keyspaces table - The
  resource type is table and the unique identifier is the table name. Example:
  keyspace/mykeyspace/table/mytable.   Amazon MSK cluster - The resource type and unique
  identifier are specified using the cluster ARN. Example:
  arn:aws:kafka:us-east-1:123456789012:cluster/demo-cluster-1/6357e0b2-0e6a-4b86-a0b4-70df934c
  2e31-5.   Amazon ElastiCache replication group - The resource type is replication-group and
  the unique identifier is the replication group name. Example: replication-group/mycluster.
   Neptune cluster - The resource type is cluster and the unique identifier is the cluster
  name. Example: cluster:mycluster.   SageMaker Serverless endpoint - The resource type is
  variant and the unique identifier is the resource ID. Example:
  endpoint/my-end-point/variant/KMeansClustering.   SageMaker inference component - The
  resource type is inference-component and the unique identifier is the resource ID. Example:
  inference-component/my-inference-component.
- `scalable_dimension`: The scalable dimension. This string consists of the service
  namespace, resource type, and scaling property.    ecs:service:DesiredCount - The desired
  task count of an ECS service.    elasticmapreduce:instancegroup:InstanceCount - The
  instance count of an EMR Instance Group.    ec2:spot-fleet-request:TargetCapacity - The
  target capacity of a Spot Fleet.    appstream:fleet:DesiredCapacity - The desired capacity
  of an AppStream 2.0 fleet.    dynamodb:table:ReadCapacityUnits - The provisioned read
  capacity for a DynamoDB table.    dynamodb:table:WriteCapacityUnits - The provisioned write
  capacity for a DynamoDB table.    dynamodb:index:ReadCapacityUnits - The provisioned read
  capacity for a DynamoDB global secondary index.    dynamodb:index:WriteCapacityUnits - The
  provisioned write capacity for a DynamoDB global secondary index.
  rds:cluster:ReadReplicaCount - The count of Aurora Replicas in an Aurora DB cluster.
  Available for Aurora MySQL-compatible edition and Aurora PostgreSQL-compatible edition.
  sagemaker:variant:DesiredInstanceCount - The number of EC2 instances for a SageMaker model
  endpoint variant.    custom-resource:ResourceType:Property - The scalable dimension for a
  custom resource provided by your own application or service.
  comprehend:document-classifier-endpoint:DesiredInferenceUnits - The number of inference
  units for an Amazon Comprehend document classification endpoint.
  comprehend:entity-recognizer-endpoint:DesiredInferenceUnits - The number of inference units
  for an Amazon Comprehend entity recognizer endpoint.
  lambda:function:ProvisionedConcurrency - The provisioned concurrency for a Lambda function.
     cassandra:table:ReadCapacityUnits - The provisioned read capacity for an Amazon
  Keyspaces table.    cassandra:table:WriteCapacityUnits - The provisioned write capacity for
  an Amazon Keyspaces table.    kafka:broker-storage:VolumeSize - The provisioned volume size
  (in GiB) for brokers in an Amazon MSK cluster.    elasticache:replication-group:NodeGroups
  - The number of node groups for an Amazon ElastiCache replication group.
  elasticache:replication-group:Replicas - The number of replicas per node group for an
  Amazon ElastiCache replication group.    neptune:cluster:ReadReplicaCount - The count of
  read replicas in an Amazon Neptune DB cluster.
  sagemaker:variant:DesiredProvisionedConcurrency - The provisioned concurrency for a
  SageMaker Serverless endpoint.    sagemaker:inference-component:DesiredCopyCount - The
  number of copies across an endpoint for a SageMaker inference component.
- `service_namespace`: The namespace of the Amazon Web Services service that provides the
  resource. For a resource provided by your own application or service, use custom-resource
  instead.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"PolicyType"`: The scaling policy type. This parameter is required if you are creating a
  scaling policy. The following policy types are supported:   TargetTrackingScaling—Not
  supported for Amazon EMR.  StepScaling—Not supported for DynamoDB, Amazon Comprehend,
  Lambda, Amazon Keyspaces, Amazon MSK, Amazon ElastiCache, or Neptune. For more information,
  see Target tracking scaling policies and Step scaling policies in the Application Auto
  Scaling User Guide.
- `"StepScalingPolicyConfiguration"`: A step scaling policy. This parameter is required if
  you are creating a policy and the policy type is StepScaling.
- `"TargetTrackingScalingPolicyConfiguration"`: A target tracking scaling policy. Includes
  support for predefined or customized metrics. This parameter is required if you are
  creating a policy and the policy type is TargetTrackingScaling.
"""
function put_scaling_policy(
    PolicyName,
    ResourceId,
    ScalableDimension,
    ServiceNamespace;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_auto_scaling(
        "PutScalingPolicy",
        Dict{String,Any}(
            "PolicyName" => PolicyName,
            "ResourceId" => ResourceId,
            "ScalableDimension" => ScalableDimension,
            "ServiceNamespace" => ServiceNamespace,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_scaling_policy(
    PolicyName,
    ResourceId,
    ScalableDimension,
    ServiceNamespace,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_auto_scaling(
        "PutScalingPolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "PolicyName" => PolicyName,
                    "ResourceId" => ResourceId,
                    "ScalableDimension" => ScalableDimension,
                    "ServiceNamespace" => ServiceNamespace,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_scheduled_action(resource_id, scalable_dimension, scheduled_action_name, service_namespace)
    put_scheduled_action(resource_id, scalable_dimension, scheduled_action_name, service_namespace, params::Dict{String,<:Any})

Creates or updates a scheduled action for an Application Auto Scaling scalable target.
Each scalable target is identified by a service namespace, resource ID, and scalable
dimension. A scheduled action applies to the scalable target identified by those three
attributes. You cannot create a scheduled action until you have registered the resource as
a scalable target. When you specify start and end times with a recurring schedule using a
cron expression or rates, they form the boundaries for when the recurring action starts and
stops. To update a scheduled action, specify the parameters that you want to change. If you
don't specify start and end times, the old values are deleted. For more information, see
Scheduled scaling in the Application Auto Scaling User Guide.  If a scalable target is
deregistered, the scalable target is no longer available to run scheduled actions. Any
scheduled actions that were specified for the scalable target are deleted.

# Arguments
- `resource_id`: The identifier of the resource associated with the scheduled action. This
  string consists of the resource type and unique identifier.   ECS service - The resource
  type is service and the unique identifier is the cluster name and service name. Example:
  service/default/sample-webapp.   Spot Fleet - The resource type is spot-fleet-request and
  the unique identifier is the Spot Fleet request ID. Example:
  spot-fleet-request/sfr-73fbd2ce-aa30-494c-8788-1cee4EXAMPLE.   EMR cluster - The resource
  type is instancegroup and the unique identifier is the cluster ID and instance group ID.
  Example: instancegroup/j-2EEZNYKUA1NTV/ig-1791Y4E1L8YI0.   AppStream 2.0 fleet - The
  resource type is fleet and the unique identifier is the fleet name. Example:
  fleet/sample-fleet.   DynamoDB table - The resource type is table and the unique identifier
  is the table name. Example: table/my-table.   DynamoDB global secondary index - The
  resource type is index and the unique identifier is the index name. Example:
  table/my-table/index/my-table-index.   Aurora DB cluster - The resource type is cluster and
  the unique identifier is the cluster name. Example: cluster:my-db-cluster.   SageMaker
  endpoint variant - The resource type is variant and the unique identifier is the resource
  ID. Example: endpoint/my-end-point/variant/KMeansClustering.   Custom resources are not
  supported with a resource type. This parameter must specify the OutputValue from the
  CloudFormation template stack used to access the resources. The unique identifier is
  defined by the service provider. More information is available in our GitHub repository.
  Amazon Comprehend document classification endpoint - The resource type and unique
  identifier are specified using the endpoint ARN. Example:
  arn:aws:comprehend:us-west-2:123456789012:document-classifier-endpoint/EXAMPLE.   Amazon
  Comprehend entity recognizer endpoint - The resource type and unique identifier are
  specified using the endpoint ARN. Example:
  arn:aws:comprehend:us-west-2:123456789012:entity-recognizer-endpoint/EXAMPLE.   Lambda
  provisioned concurrency - The resource type is function and the unique identifier is the
  function name with a function version or alias name suffix that is not LATEST. Example:
  function:my-function:prod or function:my-function:1.   Amazon Keyspaces table - The
  resource type is table and the unique identifier is the table name. Example:
  keyspace/mykeyspace/table/mytable.   Amazon MSK cluster - The resource type and unique
  identifier are specified using the cluster ARN. Example:
  arn:aws:kafka:us-east-1:123456789012:cluster/demo-cluster-1/6357e0b2-0e6a-4b86-a0b4-70df934c
  2e31-5.   Amazon ElastiCache replication group - The resource type is replication-group and
  the unique identifier is the replication group name. Example: replication-group/mycluster.
   Neptune cluster - The resource type is cluster and the unique identifier is the cluster
  name. Example: cluster:mycluster.   SageMaker Serverless endpoint - The resource type is
  variant and the unique identifier is the resource ID. Example:
  endpoint/my-end-point/variant/KMeansClustering.   SageMaker inference component - The
  resource type is inference-component and the unique identifier is the resource ID. Example:
  inference-component/my-inference-component.
- `scalable_dimension`: The scalable dimension. This string consists of the service
  namespace, resource type, and scaling property.    ecs:service:DesiredCount - The desired
  task count of an ECS service.    elasticmapreduce:instancegroup:InstanceCount - The
  instance count of an EMR Instance Group.    ec2:spot-fleet-request:TargetCapacity - The
  target capacity of a Spot Fleet.    appstream:fleet:DesiredCapacity - The desired capacity
  of an AppStream 2.0 fleet.    dynamodb:table:ReadCapacityUnits - The provisioned read
  capacity for a DynamoDB table.    dynamodb:table:WriteCapacityUnits - The provisioned write
  capacity for a DynamoDB table.    dynamodb:index:ReadCapacityUnits - The provisioned read
  capacity for a DynamoDB global secondary index.    dynamodb:index:WriteCapacityUnits - The
  provisioned write capacity for a DynamoDB global secondary index.
  rds:cluster:ReadReplicaCount - The count of Aurora Replicas in an Aurora DB cluster.
  Available for Aurora MySQL-compatible edition and Aurora PostgreSQL-compatible edition.
  sagemaker:variant:DesiredInstanceCount - The number of EC2 instances for a SageMaker model
  endpoint variant.    custom-resource:ResourceType:Property - The scalable dimension for a
  custom resource provided by your own application or service.
  comprehend:document-classifier-endpoint:DesiredInferenceUnits - The number of inference
  units for an Amazon Comprehend document classification endpoint.
  comprehend:entity-recognizer-endpoint:DesiredInferenceUnits - The number of inference units
  for an Amazon Comprehend entity recognizer endpoint.
  lambda:function:ProvisionedConcurrency - The provisioned concurrency for a Lambda function.
     cassandra:table:ReadCapacityUnits - The provisioned read capacity for an Amazon
  Keyspaces table.    cassandra:table:WriteCapacityUnits - The provisioned write capacity for
  an Amazon Keyspaces table.    kafka:broker-storage:VolumeSize - The provisioned volume size
  (in GiB) for brokers in an Amazon MSK cluster.    elasticache:replication-group:NodeGroups
  - The number of node groups for an Amazon ElastiCache replication group.
  elasticache:replication-group:Replicas - The number of replicas per node group for an
  Amazon ElastiCache replication group.    neptune:cluster:ReadReplicaCount - The count of
  read replicas in an Amazon Neptune DB cluster.
  sagemaker:variant:DesiredProvisionedConcurrency - The provisioned concurrency for a
  SageMaker Serverless endpoint.    sagemaker:inference-component:DesiredCopyCount - The
  number of copies across an endpoint for a SageMaker inference component.
- `scheduled_action_name`: The name of the scheduled action. This name must be unique among
  all other scheduled actions on the specified scalable target.
- `service_namespace`: The namespace of the Amazon Web Services service that provides the
  resource. For a resource provided by your own application or service, use custom-resource
  instead.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EndTime"`: The date and time for the recurring schedule to end, in UTC.
- `"ScalableTargetAction"`: The new minimum and maximum capacity. You can set both values
  or just one. At the scheduled time, if the current capacity is below the minimum capacity,
  Application Auto Scaling scales out to the minimum capacity. If the current capacity is
  above the maximum capacity, Application Auto Scaling scales in to the maximum capacity.
- `"Schedule"`: The schedule for this action. The following formats are supported:   At
  expressions - \"at(yyyy-mm-ddThh:mm:ss)\"   Rate expressions - \"rate(value unit)\"   Cron
  expressions - \"cron(fields)\"   At expressions are useful for one-time schedules. Cron
  expressions are useful for scheduled actions that run periodically at a specified date and
  time, and rate expressions are useful for scheduled actions that run at a regular interval.
  At and cron expressions use Universal Coordinated Time (UTC) by default. The cron format
  consists of six fields separated by white spaces: [Minutes] [Hours] [Day_of_Month] [Month]
  [Day_of_Week] [Year]. For rate expressions, value is a positive integer and unit is minute
  | minutes | hour | hours | day | days. For more information and examples, see Example
  scheduled actions for Application Auto Scaling in the Application Auto Scaling User Guide.
- `"StartTime"`: The date and time for this scheduled action to start, in UTC.
- `"Timezone"`: Specifies the time zone used when setting a scheduled action by using an at
  or cron expression. If a time zone is not provided, UTC is used by default. Valid values
  are the canonical names of the IANA time zones supported by Joda-Time (such as Etc/GMT+9 or
  Pacific/Tahiti). For more information, see https://www.joda.org/joda-time/timezones.html.
"""
function put_scheduled_action(
    ResourceId,
    ScalableDimension,
    ScheduledActionName,
    ServiceNamespace;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_auto_scaling(
        "PutScheduledAction",
        Dict{String,Any}(
            "ResourceId" => ResourceId,
            "ScalableDimension" => ScalableDimension,
            "ScheduledActionName" => ScheduledActionName,
            "ServiceNamespace" => ServiceNamespace,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_scheduled_action(
    ResourceId,
    ScalableDimension,
    ScheduledActionName,
    ServiceNamespace,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_auto_scaling(
        "PutScheduledAction",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ResourceId" => ResourceId,
                    "ScalableDimension" => ScalableDimension,
                    "ScheduledActionName" => ScheduledActionName,
                    "ServiceNamespace" => ServiceNamespace,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    register_scalable_target(resource_id, scalable_dimension, service_namespace)
    register_scalable_target(resource_id, scalable_dimension, service_namespace, params::Dict{String,<:Any})

Registers or updates a scalable target, which is the resource that you want to scale.
Scalable targets are uniquely identified by the combination of resource ID, scalable
dimension, and namespace, which represents some capacity dimension of the underlying
service. When you register a new scalable target, you must specify values for the minimum
and maximum capacity. If the specified resource is not active in the target service, this
operation does not change the resource's current capacity. Otherwise, it changes the
resource's current capacity to a value that is inside of this range. If you add a scaling
policy, current capacity is adjustable within the specified range when scaling starts.
Application Auto Scaling scaling policies will not scale capacity to values that are
outside of the minimum and maximum range. After you register a scalable target, you do not
need to register it again to use other Application Auto Scaling operations. To see which
resources have been registered, use DescribeScalableTargets. You can also view the scaling
policies for a service namespace by using DescribeScalableTargets. If you no longer need a
scalable target, you can deregister it by using DeregisterScalableTarget. To update a
scalable target, specify the parameters that you want to change. Include the parameters
that identify the scalable target: resource ID, scalable dimension, and namespace. Any
parameters that you don't specify are not changed by this update request.   If you call the
RegisterScalableTarget API operation to create a scalable target, there might be a brief
delay until the operation achieves eventual consistency. You might become aware of this
brief delay if you get unexpected errors when performing sequential operations. The typical
strategy is to retry the request, and some Amazon Web Services SDKs include automatic
backoff and retry logic. If you call the RegisterScalableTarget API operation to update an
existing scalable target, Application Auto Scaling retrieves the current capacity of the
resource. If it's below the minimum capacity or above the maximum capacity, Application
Auto Scaling adjusts the capacity of the scalable target to place it within these bounds,
even if you don't include the MinCapacity or MaxCapacity request parameters.

# Arguments
- `resource_id`: The identifier of the resource that is associated with the scalable
  target. This string consists of the resource type and unique identifier.   ECS service -
  The resource type is service and the unique identifier is the cluster name and service
  name. Example: service/default/sample-webapp.   Spot Fleet - The resource type is
  spot-fleet-request and the unique identifier is the Spot Fleet request ID. Example:
  spot-fleet-request/sfr-73fbd2ce-aa30-494c-8788-1cee4EXAMPLE.   EMR cluster - The resource
  type is instancegroup and the unique identifier is the cluster ID and instance group ID.
  Example: instancegroup/j-2EEZNYKUA1NTV/ig-1791Y4E1L8YI0.   AppStream 2.0 fleet - The
  resource type is fleet and the unique identifier is the fleet name. Example:
  fleet/sample-fleet.   DynamoDB table - The resource type is table and the unique identifier
  is the table name. Example: table/my-table.   DynamoDB global secondary index - The
  resource type is index and the unique identifier is the index name. Example:
  table/my-table/index/my-table-index.   Aurora DB cluster - The resource type is cluster and
  the unique identifier is the cluster name. Example: cluster:my-db-cluster.   SageMaker
  endpoint variant - The resource type is variant and the unique identifier is the resource
  ID. Example: endpoint/my-end-point/variant/KMeansClustering.   Custom resources are not
  supported with a resource type. This parameter must specify the OutputValue from the
  CloudFormation template stack used to access the resources. The unique identifier is
  defined by the service provider. More information is available in our GitHub repository.
  Amazon Comprehend document classification endpoint - The resource type and unique
  identifier are specified using the endpoint ARN. Example:
  arn:aws:comprehend:us-west-2:123456789012:document-classifier-endpoint/EXAMPLE.   Amazon
  Comprehend entity recognizer endpoint - The resource type and unique identifier are
  specified using the endpoint ARN. Example:
  arn:aws:comprehend:us-west-2:123456789012:entity-recognizer-endpoint/EXAMPLE.   Lambda
  provisioned concurrency - The resource type is function and the unique identifier is the
  function name with a function version or alias name suffix that is not LATEST. Example:
  function:my-function:prod or function:my-function:1.   Amazon Keyspaces table - The
  resource type is table and the unique identifier is the table name. Example:
  keyspace/mykeyspace/table/mytable.   Amazon MSK cluster - The resource type and unique
  identifier are specified using the cluster ARN. Example:
  arn:aws:kafka:us-east-1:123456789012:cluster/demo-cluster-1/6357e0b2-0e6a-4b86-a0b4-70df934c
  2e31-5.   Amazon ElastiCache replication group - The resource type is replication-group and
  the unique identifier is the replication group name. Example: replication-group/mycluster.
   Neptune cluster - The resource type is cluster and the unique identifier is the cluster
  name. Example: cluster:mycluster.   SageMaker Serverless endpoint - The resource type is
  variant and the unique identifier is the resource ID. Example:
  endpoint/my-end-point/variant/KMeansClustering.   SageMaker inference component - The
  resource type is inference-component and the unique identifier is the resource ID. Example:
  inference-component/my-inference-component.
- `scalable_dimension`: The scalable dimension associated with the scalable target. This
  string consists of the service namespace, resource type, and scaling property.
  ecs:service:DesiredCount - The desired task count of an ECS service.
  elasticmapreduce:instancegroup:InstanceCount - The instance count of an EMR Instance Group.
     ec2:spot-fleet-request:TargetCapacity - The target capacity of a Spot Fleet.
  appstream:fleet:DesiredCapacity - The desired capacity of an AppStream 2.0 fleet.
  dynamodb:table:ReadCapacityUnits - The provisioned read capacity for a DynamoDB table.
  dynamodb:table:WriteCapacityUnits - The provisioned write capacity for a DynamoDB table.
  dynamodb:index:ReadCapacityUnits - The provisioned read capacity for a DynamoDB global
  secondary index.    dynamodb:index:WriteCapacityUnits - The provisioned write capacity for
  a DynamoDB global secondary index.    rds:cluster:ReadReplicaCount - The count of Aurora
  Replicas in an Aurora DB cluster. Available for Aurora MySQL-compatible edition and Aurora
  PostgreSQL-compatible edition.    sagemaker:variant:DesiredInstanceCount - The number of
  EC2 instances for a SageMaker model endpoint variant.
  custom-resource:ResourceType:Property - The scalable dimension for a custom resource
  provided by your own application or service.
  comprehend:document-classifier-endpoint:DesiredInferenceUnits - The number of inference
  units for an Amazon Comprehend document classification endpoint.
  comprehend:entity-recognizer-endpoint:DesiredInferenceUnits - The number of inference units
  for an Amazon Comprehend entity recognizer endpoint.
  lambda:function:ProvisionedConcurrency - The provisioned concurrency for a Lambda function.
     cassandra:table:ReadCapacityUnits - The provisioned read capacity for an Amazon
  Keyspaces table.    cassandra:table:WriteCapacityUnits - The provisioned write capacity for
  an Amazon Keyspaces table.    kafka:broker-storage:VolumeSize - The provisioned volume size
  (in GiB) for brokers in an Amazon MSK cluster.    elasticache:replication-group:NodeGroups
  - The number of node groups for an Amazon ElastiCache replication group.
  elasticache:replication-group:Replicas - The number of replicas per node group for an
  Amazon ElastiCache replication group.    neptune:cluster:ReadReplicaCount - The count of
  read replicas in an Amazon Neptune DB cluster.
  sagemaker:variant:DesiredProvisionedConcurrency - The provisioned concurrency for a
  SageMaker Serverless endpoint.    sagemaker:inference-component:DesiredCopyCount - The
  number of copies across an endpoint for a SageMaker inference component.
- `service_namespace`: The namespace of the Amazon Web Services service that provides the
  resource. For a resource provided by your own application or service, use custom-resource
  instead.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxCapacity"`: The maximum value that you plan to scale out to. When a scaling policy
  is in effect, Application Auto Scaling can scale out (expand) as needed to the maximum
  capacity limit in response to changing demand. This property is required when registering a
  new scalable target. Although you can specify a large maximum capacity, note that service
  quotas might impose lower limits. Each service has its own default quotas for the maximum
  capacity of the resource. If you want to specify a higher limit, you can request an
  increase. For more information, consult the documentation for that service. For information
  about the default quotas for each service, see Service endpoints and quotas in the Amazon
  Web Services General Reference.
- `"MinCapacity"`: The minimum value that you plan to scale in to. When a scaling policy is
  in effect, Application Auto Scaling can scale in (contract) as needed to the minimum
  capacity limit in response to changing demand. This property is required when registering a
  new scalable target. For the following resources, the minimum value allowed is 0.
  AppStream 2.0 fleets    Aurora DB clusters   ECS services   EMR clusters   Lambda
  provisioned concurrency   SageMaker endpoint variants   SageMaker Serverless endpoint
  provisioned concurrency   Spot Fleets   custom resources   It's strongly recommended that
  you specify a value greater than 0. A value greater than 0 means that data points are
  continuously reported to CloudWatch that scaling policies can use to scale on a metric like
  average CPU utilization. For all other resources, the minimum allowed value depends on the
  type of resource that you are using. If you provide a value that is lower than what a
  resource can accept, an error occurs. In which case, the error message will provide the
  minimum value that the resource can accept.
- `"RoleARN"`: This parameter is required for services that do not support service-linked
  roles (such as Amazon EMR), and it must specify the ARN of an IAM role that allows
  Application Auto Scaling to modify the scalable target on your behalf.  If the service
  supports service-linked roles, Application Auto Scaling uses a service-linked role, which
  it creates if it does not yet exist. For more information, see Application Auto Scaling IAM
  roles.
- `"SuspendedState"`: An embedded object that contains attributes and attribute values that
  are used to suspend and resume automatic scaling. Setting the value of an attribute to true
  suspends the specified scaling activities. Setting it to false (default) resumes the
  specified scaling activities.   Suspension Outcomes    For DynamicScalingInSuspended, while
  a suspension is in effect, all scale-in activities that are triggered by a scaling policy
  are suspended.   For DynamicScalingOutSuspended, while a suspension is in effect, all
  scale-out activities that are triggered by a scaling policy are suspended.   For
  ScheduledScalingSuspended, while a suspension is in effect, all scaling activities that
  involve scheduled actions are suspended.    For more information, see Suspending and
  resuming scaling in the Application Auto Scaling User Guide.
- `"Tags"`: Assigns one or more tags to the scalable target. Use this parameter to tag the
  scalable target when it is created. To tag an existing scalable target, use the TagResource
  operation. Each tag consists of a tag key and a tag value. Both the tag key and the tag
  value are required. You cannot have more than one tag on a scalable target with the same
  tag key. Use tags to control access to a scalable target. For more information, see Tagging
  support for Application Auto Scaling in the Application Auto Scaling User Guide.
"""
function register_scalable_target(
    ResourceId,
    ScalableDimension,
    ServiceNamespace;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_auto_scaling(
        "RegisterScalableTarget",
        Dict{String,Any}(
            "ResourceId" => ResourceId,
            "ScalableDimension" => ScalableDimension,
            "ServiceNamespace" => ServiceNamespace,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function register_scalable_target(
    ResourceId,
    ScalableDimension,
    ServiceNamespace,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_auto_scaling(
        "RegisterScalableTarget",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ResourceId" => ResourceId,
                    "ScalableDimension" => ScalableDimension,
                    "ServiceNamespace" => ServiceNamespace,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds or edits tags on an Application Auto Scaling scalable target. Each tag consists of a
tag key and a tag value, which are both case-sensitive strings. To add a tag, specify a new
tag key and a tag value. To edit a tag, specify an existing tag key and a new tag value.
You can use this operation to tag an Application Auto Scaling scalable target, but you
cannot tag a scaling policy or scheduled action. You can also add tags to an Application
Auto Scaling scalable target while creating it (RegisterScalableTarget). For general
information about tags, including the format and syntax, see Tagging Amazon Web Services
resources in the Amazon Web Services General Reference. Use tags to control access to a
scalable target. For more information, see Tagging support for Application Auto Scaling in
the Application Auto Scaling User Guide.

# Arguments
- `resource_arn`: Identifies the Application Auto Scaling scalable target that you want to
  apply tags to. For example:
  arn:aws:application-autoscaling:us-east-1:123456789012:scalable-target/1234abcd56ab78cd901ef
  1234567890ab123  To get the ARN for a scalable target, use DescribeScalableTargets.
- `tags`: The tags assigned to the resource. A tag is a label that you assign to an Amazon
  Web Services resource. Each tag consists of a tag key and a tag value. You cannot have more
  than one tag on an Application Auto Scaling scalable target with the same tag key. If you
  specify an existing tag key with a different tag value, Application Auto Scaling replaces
  the current tag value with the specified one. For information about the rules that apply to
  tag keys and tag values, see User-defined tag restrictions in the Amazon Web Services
  Billing and Cost Management User Guide.

"""
function tag_resource(ResourceARN, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return application_auto_scaling(
        "TagResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceARN,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_auto_scaling(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Deletes tags from an Application Auto Scaling scalable target. To delete a tag, specify the
tag key and the Application Auto Scaling scalable target.

# Arguments
- `resource_arn`: Identifies the Application Auto Scaling scalable target from which to
  remove tags. For example:
  arn:aws:application-autoscaling:us-east-1:123456789012:scalable-target/1234abcd56ab78cd901ef
  1234567890ab123  To get the ARN for a scalable target, use DescribeScalableTargets.
- `tag_keys`: One or more tag keys. Specify only the tag keys, not the tag values.

"""
function untag_resource(
    ResourceARN, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return application_auto_scaling(
        "UntagResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceARN,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return application_auto_scaling(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: cloudsearch_domain
using AWS.Compat
using AWS.UUIDs

"""
    search(q)
    search(q, params::Dict{String,<:Any})

Retrieves a list of documents that match the specified search criteria. How you specify the
search criteria depends on which query parser you use. Amazon CloudSearch supports four
query parsers:  simple: search all text and text-array fields for the specified string.
Search for phrases, individual terms, and prefixes.  structured: search specific fields,
construct compound queries using Boolean operators, and use advanced features such as term
boosting and proximity searching. lucene: specify search criteria using the Apache Lucene
query parser syntax. dismax: specify search criteria using the simplified subset of the
Apache Lucene query parser syntax defined by the DisMax query parser.  For more
information, see Searching Your Data in the Amazon CloudSearch Developer Guide. The
endpoint for submitting Search requests is domain-specific. You submit search requests to a
domain's search endpoint. To get the search endpoint for your domain, use the Amazon
CloudSearch configuration service DescribeDomains action. A domain's endpoints are also
displayed on the domain dashboard in the Amazon CloudSearch console.

# Arguments
- `q`: Specifies the search criteria for the request. How you specify the search criteria
  depends on the query parser used for the request and the parser options specified in the
  queryOptions parameter. By default, the simple query parser is used to process requests. To
  use the structured, lucene, or dismax query parser, you must also specify the queryParser
  parameter.  For more information about specifying search criteria, see Searching Your Data
  in the Amazon CloudSearch Developer Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"cursor"`: Retrieves a cursor value you can use to page through large result sets. Use
  the size parameter to control the number of hits to include in each response. You can
  specify either the cursor or start parameter in a request; they are mutually exclusive. To
  get the first cursor, set the cursor value to initial. In subsequent requests, specify the
  cursor value returned in the hits section of the response.  For more information, see
  Paginating Results in the Amazon CloudSearch Developer Guide.
- `"expr"`: Defines one or more numeric expressions that can be used to sort results or
  specify search or filter criteria. You can also specify expressions as return fields.  You
  specify the expressions in JSON using the form {\"EXPRESSIONNAME\":\"EXPRESSION\"}. You can
  define and use multiple expressions in a search request. For example:
  {\"expression1\":\"_score*rating\", \"expression2\":\"(1/rank)*year\"}   For information
  about the variables, operators, and functions you can use in expressions, see Writing
  Expressions in the Amazon CloudSearch Developer Guide.
- `"facet"`: Specifies one or more fields for which to get facet information, and options
  that control how the facet information is returned. Each specified field must be
  facet-enabled in the domain configuration. The fields and options are specified in JSON
  using the form
  {\"FIELD\":{\"OPTION\":VALUE,\"OPTION:\"STRING\"},\"FIELD\":{\"OPTION\":VALUE,\"OPTION\":\"S
  TRING\"}}. You can specify the following faceting options:   buckets specifies an array of
  the facet values or ranges to count. Ranges are specified using the same syntax that you
  use to search for a range of values. For more information, see  Searching for a Range of
  Values in the Amazon CloudSearch Developer Guide. Buckets are returned in the order they
  are specified in the request. The sort and size options are not valid if you specify
  buckets.   size specifies the maximum number of facets to include in the results. By
  default, Amazon CloudSearch returns counts for the top 10. The size parameter is only valid
  when you specify the sort option; it cannot be used in conjunction with buckets.   sort
  specifies how you want to sort the facets in the results: bucket or count. Specify bucket
  to sort alphabetically or numerically by facet value (in ascending order). Specify count to
  sort by the facet counts computed for each facet value (in descending order). To retrieve
  facet counts for particular values or ranges of values, use the buckets option instead of
  sort.    If no facet options are specified, facet counts are computed for all field values,
  the facets are sorted by facet count, and the top 10 facets are returned in the results. To
  count particular buckets of values, use the buckets option. For example, the following
  request uses the buckets option to calculate and return facet counts by decade.
  {\"year\":{\"buckets\":[\"[1970,1979]\",\"[1980,1989]\",\"[1990,1999]\",\"[2000,2009]\",\"[2
  010,}\"]}}  To sort facets by facet count, use the count option. For example, the following
  request sets the sort option to count to sort the facet values by facet count, with the
  facet values that have the most matching documents listed first. Setting the size option to
  3 returns only the top three facet values.  {\"year\":{\"sort\":\"count\",\"size\":3}}  To
  sort the facets by value, use the bucket option. For example, the following request sets
  the sort option to bucket to sort the facet values numerically by year, with earliest year
  listed first.   {\"year\":{\"sort\":\"bucket\"}}  For more information, see Getting and
  Using Facet Information in the Amazon CloudSearch Developer Guide.
- `"fq"`: Specifies a structured query that filters the results of a search without
  affecting how the results are scored and sorted. You use filterQuery in conjunction with
  the query parameter to filter the documents that match the constraints specified in the
  query parameter. Specifying a filter controls only which matching documents are included in
  the results, it has no effect on how they are scored and sorted. The filterQuery parameter
  supports the full structured query syntax.  For more information about using filters, see
  Filtering Matching Documents in the Amazon CloudSearch Developer Guide.
- `"highlight"`: Retrieves highlights for matches in the specified text or text-array
  fields. Each specified field must be highlight enabled in the domain configuration. The
  fields and options are specified in JSON using the form
  {\"FIELD\":{\"OPTION\":VALUE,\"OPTION:\"STRING\"},\"FIELD\":{\"OPTION\":VALUE,\"OPTION\":\"S
  TRING\"}}. You can specify the following highlight options:   format: specifies the format
  of the data in the text field: text or html. When data is returned as HTML, all
  non-alphanumeric characters are encoded. The default is html.   max_phrases: specifies the
  maximum number of occurrences of the search term(s) you want to highlight. By default, the
  first occurrence is highlighted.   pre_tag: specifies the string to prepend to an
  occurrence of a search term. The default for HTML highlights is &amp;lt;em&amp;gt;. The
  default for text highlights is *.   post_tag: specifies the string to append to an
  occurrence of a search term. The default for HTML highlights is &amp;lt;/em&amp;gt;. The
  default for text highlights is *.   If no highlight options are specified for a field, the
  returned field text is treated as HTML and the first match is highlighted with emphasis
  tags: &amp;lt;em&gt;search-term&amp;lt;/em&amp;gt;. For example, the following request
  retrieves highlights for the actors and title fields.  { \"actors\": {}, \"title\":
  {\"format\": \"text\",\"max_phrases\": 2,\"pre_tag\": \"\",\"post_tag\": \"\"} }
- `"partial"`: Enables partial results to be returned if one or more index partitions are
  unavailable. When your search index is partitioned across multiple search instances, by
  default Amazon CloudSearch only returns results if every partition can be queried. This
  means that the failure of a single search instance can result in 5xx (internal server)
  errors. When you enable partial results, Amazon CloudSearch returns whatever results are
  available and includes the percentage of documents searched in the search results
  (percent-searched). This enables you to more gracefully degrade your users' search
  experience. For example, rather than displaying no results, you could display the partial
  results and a message indicating that the results might be incomplete due to a temporary
  system outage.
- `"q.options"`: Configures options for the query parser specified in the queryParser
  parameter. You specify the options in JSON using the following form
  {\"OPTION1\":\"VALUE1\",\"OPTION2\":VALUE2\"...\"OPTIONN\":\"VALUEN\"}. The options you can
  configure vary according to which parser you use:  defaultOperator: The default operator
  used to combine individual terms in the search string. For example: defaultOperator: 'or'.
  For the dismax parser, you specify a percentage that represents the percentage of terms in
  the search string (rounded down) that must match, rather than a default operator. A value
  of 0% is the equivalent to OR, and a value of 100% is equivalent to AND. The percentage
  must be specified as a value in the range 0-100 followed by the percent (%) symbol. For
  example, defaultOperator: 50%. Valid values: and, or, a percentage in the range 0%-100%
  (dismax). Default: and (simple, structured, lucene) or 100 (dismax). Valid for: simple,
  structured, lucene, and dismax. fields: An array of the fields to search when no fields are
  specified in a search. If no fields are specified in a search and this option is not
  specified, all text and text-array fields are searched. You can specify a weight for each
  field to control the relative importance of each field when Amazon CloudSearch calculates
  relevance scores. To specify a field weight, append a caret (^) symbol and the weight to
  the field name. For example, to boost the importance of the title field over the
  description field you could specify: \"fields\":[\"title^5\",\"description\"]. Valid
  values: The name of any configured field and an optional numeric value greater than zero.
  Default: All text and text-array fields. Valid for: simple, structured, lucene, and dismax.
  operators: An array of the operators or special characters you want to disable for the
  simple query parser. If you disable the and, or, or not operators, the corresponding
  operators (+, |, -) have no special meaning and are dropped from the search string.
  Similarly, disabling prefix disables the wildcard operator (*) and disabling phrase
  disables the ability to search for phrases by enclosing phrases in double quotes. Disabling
  precedence disables the ability to control order of precedence using parentheses. Disabling
  near disables the ability to use the ~ operator to perform a sloppy phrase search.
  Disabling the fuzzy operator disables the ability to use the ~ operator to perform a fuzzy
  search. escape disables the ability to use a backslash () to escape special characters
  within the search string. Disabling whitespace is an advanced option that prevents the
  parser from tokenizing on whitespace, which can be useful for Vietnamese. (It prevents
  Vietnamese words from being split incorrectly.) For example, you could disable all
  operators other than the phrase operator to support just simple term and phrase queries:
  \"operators\":[\"and\",\"not\",\"or\", \"prefix\"]. Valid values: and, escape, fuzzy, near,
  not, or, phrase, precedence, prefix, whitespace. Default: All operators and special
  characters are enabled. Valid for: simple. phraseFields: An array of the text or text-array
  fields you want to use for phrase searches. When the terms in the search string appear in
  close proximity within a field, the field scores higher. You can specify a weight for each
  field to boost that score. The phraseSlop option controls how much the matches can deviate
  from the search string and still be boosted. To specify a field weight, append a caret (^)
  symbol and the weight to the field name. For example, to boost phrase matches in the title
  field over the abstract field, you could specify: \"phraseFields\":[\"title^3\", \"plot\"]
  Valid values: The name of any text or text-array field and an optional numeric value
  greater than zero. Default: No fields. If you don't specify any fields with phraseFields,
  proximity scoring is disabled even if phraseSlop is specified. Valid for: dismax.
  phraseSlop: An integer value that specifies how much matches can deviate from the search
  phrase and still be boosted according to the weights specified in the phraseFields option;
  for example, phraseSlop: 2. You must also specify phraseFields to enable proximity scoring.
  Valid values: positive integers. Default: 0. Valid for: dismax. explicitPhraseSlop: An
  integer value that specifies how much a match can deviate from the search phrase when the
  phrase is enclosed in double quotes in the search string. (Phrases that exceed this
  proximity distance are not considered a match.) For example, to specify a slop of three for
  dismax phrase queries, you would specify \"explicitPhraseSlop\":3. Valid values: positive
  integers. Default: 0. Valid for: dismax. tieBreaker: When a term in the search string is
  found in a document's field, a score is calculated for that field based on how common the
  word is in that field compared to other documents. If the term occurs in multiple fields
  within a document, by default only the highest scoring field contributes to the document's
  overall score. You can specify a tieBreaker value to enable the matches in lower-scoring
  fields to contribute to the document's score. That way, if two documents have the same max
  field score for a particular term, the score for the document that has matches in more
  fields will be higher. The formula for calculating the score with a tieBreaker is (max
  field score) + (tieBreaker) * (sum of the scores for the rest of the matching fields). Set
  tieBreaker to 0 to disregard all but the highest scoring field (pure max):
  \"tieBreaker\":0. Set to 1 to sum the scores from all fields (pure sum): \"tieBreaker\":1.
  Valid values: 0.0 to 1.0. Default: 0.0. Valid for: dismax.
- `"q.parser"`: Specifies which query parser to use to process the request. If queryParser
  is not specified, Amazon CloudSearch uses the simple query parser.  Amazon CloudSearch
  supports four query parsers:   simple: perform simple searches of text and text-array
  fields. By default, the simple query parser searches all text and text-array fields. You
  can specify which fields to search by with the queryOptions parameter. If you prefix a
  search term with a plus sign (+) documents must contain the term to be considered a match.
  (This is the default, unless you configure the default operator with the queryOptions
  parameter.) You can use the - (NOT), | (OR), and * (wildcard) operators to exclude
  particular terms, find results that match any of the specified terms, or search for a
  prefix. To search for a phrase rather than individual terms, enclose the phrase in double
  quotes. For more information, see Searching for Text in the Amazon CloudSearch Developer
  Guide.   structured: perform advanced searches by combining multiple expressions to define
  the search criteria. You can also search within particular fields, search for values and
  ranges of values, and use advanced options such as term boosting, matchall, and near. For
  more information, see Constructing Compound Queries in the Amazon CloudSearch Developer
  Guide.   lucene: search using the Apache Lucene query parser syntax. For more information,
  see Apache Lucene Query Parser Syntax.   dismax: search using the simplified subset of the
  Apache Lucene query parser syntax defined by the DisMax query parser. For more information,
  see DisMax Query Parser Syntax.
- `"return"`: Specifies the field and expression values to include in the response.
  Multiple fields or expressions are specified as a comma-separated list. By default, a
  search response includes all return enabled fields (_all_fields). To return only the
  document IDs for the matching documents, specify _no_fields. To retrieve the relevance
  score calculated for each document, specify _score.
- `"size"`: Specifies the maximum number of search hits to include in the response.
- `"sort"`: Specifies the fields or custom expressions to use to sort the search results.
  Multiple fields or expressions are specified as a comma-separated list. You must specify
  the sort direction (asc or desc) for each field; for example, year desc,title asc. To use a
  field to sort results, the field must be sort-enabled in the domain configuration. Array
  type fields cannot be used for sorting. If no sort parameter is specified, results are
  sorted by their default relevance scores in descending order: _score desc. You can also
  sort by document ID (_id asc) and version (_version desc). For more information, see
  Sorting Results in the Amazon CloudSearch Developer Guide.
- `"start"`: Specifies the offset of the first search hit you want to return. Note that the
  result set is zero-based; the first result is at index 0. You can specify either the start
  or cursor parameter in a request, they are mutually exclusive.  For more information, see
  Paginating Results in the Amazon CloudSearch Developer Guide.
- `"stats"`: Specifies one or more fields for which to get statistics information. Each
  specified field must be facet-enabled in the domain configuration. The fields are specified
  in JSON using the form: {\"FIELD-A\":{},\"FIELD-B\":{}} There are currently no options
  supported for statistics.
"""
function search(q; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudsearch_domain(
        "GET",
        "/2013-01-01/search?format=sdk&pretty=true",
        Dict{String,Any}("q" => q);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function search(
    q, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudsearch_domain(
        "GET",
        "/2013-01-01/search?format=sdk&pretty=true",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("q" => q), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    suggest(q, suggester)
    suggest(q, suggester, params::Dict{String,<:Any})

Retrieves autocomplete suggestions for a partial query string. You can use suggestions
enable you to display likely matches before users finish typing. In Amazon CloudSearch,
suggestions are based on the contents of a particular text field. When you request
suggestions, Amazon CloudSearch finds all of the documents whose values in the suggester
field start with the specified query string. The beginning of the field must match the
query string to be considered a match.  For more information about configuring suggesters
and retrieving suggestions, see Getting Suggestions in the Amazon CloudSearch Developer
Guide.  The endpoint for submitting Suggest requests is domain-specific. You submit suggest
requests to a domain's search endpoint. To get the search endpoint for your domain, use the
Amazon CloudSearch configuration service DescribeDomains action. A domain's endpoints are
also displayed on the domain dashboard in the Amazon CloudSearch console.

# Arguments
- `q`: Specifies the string for which you want to get suggestions.
- `suggester`: Specifies the name of the suggester to use to find suggested matches.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"size"`: Specifies the maximum number of suggestions to return.
"""
function suggest(q, suggester; aws_config::AbstractAWSConfig=current_aws_config())
    return cloudsearch_domain(
        "GET",
        "/2013-01-01/suggest?format=sdk&pretty=true",
        Dict{String,Any}("q" => q, "suggester" => suggester);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function suggest(
    q,
    suggester,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudsearch_domain(
        "GET",
        "/2013-01-01/suggest?format=sdk&pretty=true",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("q" => q, "suggester" => suggester), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    upload_documents(content-_type, documents)
    upload_documents(content-_type, documents, params::Dict{String,<:Any})

Posts a batch of documents to a search domain for indexing. A document batch is a
collection of add and delete operations that represent the documents you want to add,
update, or delete from your domain. Batches can be described in either JSON or XML. Each
item that you want Amazon CloudSearch to return as a search result (such as a product) is
represented as a document. Every document has a unique ID and one or more fields that
contain the data that you want to search and return in results. Individual documents cannot
contain more than 1 MB of data. The entire batch cannot exceed 5 MB. To get the best
possible upload performance, group add and delete operations in batches that are close the
5 MB limit. Submitting a large volume of single-document batches can overload a domain's
document service.  The endpoint for submitting UploadDocuments requests is domain-specific.
To get the document endpoint for your domain, use the Amazon CloudSearch configuration
service DescribeDomains action. A domain's endpoints are also displayed on the domain
dashboard in the Amazon CloudSearch console.  For more information about formatting your
data for Amazon CloudSearch, see Preparing Your Data in the Amazon CloudSearch Developer
Guide. For more information about uploading data for indexing, see Uploading Data in the
Amazon CloudSearch Developer Guide.

# Arguments
- `content-_type`: The format of the batch you are uploading. Amazon CloudSearch supports
  two document batch formats:  application/json application/xml
- `documents`: A batch of documents formatted in JSON or HTML.

"""
function upload_documents(
    Content_Type, documents; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudsearch_domain(
        "POST",
        "/2013-01-01/documents/batch?format=sdk",
        Dict{String,Any}(
            "documents" => documents,
            "headers" => Dict{String,Any}("Content-Type" => Content_Type),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function upload_documents(
    Content_Type,
    documents,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudsearch_domain(
        "POST",
        "/2013-01-01/documents/batch?format=sdk",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "documents" => documents,
                    "headers" => Dict{String,Any}("Content-Type" => Content_Type),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: translate
using AWS.Compat
using AWS.UUIDs

"""
    create_parallel_data(client_token, name, parallel_data_config)
    create_parallel_data(client_token, name, parallel_data_config, params::Dict{String,<:Any})

Creates a parallel data resource in Amazon Translate by importing an input file from Amazon
S3. Parallel data files contain examples that show how you want segments of text to be
translated. By adding parallel data, you can influence the style, tone, and word choice in
your translation output.

# Arguments
- `client_token`: A unique identifier for the request. This token is automatically
  generated when you use Amazon Translate through an AWS SDK.
- `name`: A custom name for the parallel data resource in Amazon Translate. You must assign
  a name that is unique in the account and region.
- `parallel_data_config`: Specifies the format and S3 location of the parallel data input
  file.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A custom description for the parallel data resource in Amazon Translate.
- `"EncryptionKey"`:
- `"Tags"`: Tags to be associated with this resource. A tag is a key-value pair that adds
  metadata to a resource. Each tag key for the resource must be unique. For more information,
  see  Tagging your resources.
"""
function create_parallel_data(
    ClientToken,
    Name,
    ParallelDataConfig;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return translate(
        "CreateParallelData",
        Dict{String,Any}(
            "ClientToken" => ClientToken,
            "Name" => Name,
            "ParallelDataConfig" => ParallelDataConfig,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_parallel_data(
    ClientToken,
    Name,
    ParallelDataConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return translate(
        "CreateParallelData",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClientToken" => ClientToken,
                    "Name" => Name,
                    "ParallelDataConfig" => ParallelDataConfig,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_parallel_data(name)
    delete_parallel_data(name, params::Dict{String,<:Any})

Deletes a parallel data resource in Amazon Translate.

# Arguments
- `name`: The name of the parallel data resource that is being deleted.

"""
function delete_parallel_data(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return translate(
        "DeleteParallelData",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_parallel_data(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return translate(
        "DeleteParallelData",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_terminology(name)
    delete_terminology(name, params::Dict{String,<:Any})

A synchronous action that deletes a custom terminology.

# Arguments
- `name`: The name of the custom terminology being deleted.

"""
function delete_terminology(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return translate(
        "DeleteTerminology",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_terminology(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return translate(
        "DeleteTerminology",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_text_translation_job(job_id)
    describe_text_translation_job(job_id, params::Dict{String,<:Any})

Gets the properties associated with an asynchronous batch translation job including name,
ID, status, source and target languages, input/output S3 buckets, and so on.

# Arguments
- `job_id`: The identifier that Amazon Translate generated for the job. The
  StartTextTranslationJob operation returns this identifier in its response.

"""
function describe_text_translation_job(
    JobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return translate(
        "DescribeTextTranslationJob",
        Dict{String,Any}("JobId" => JobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_text_translation_job(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return translate(
        "DescribeTextTranslationJob",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("JobId" => JobId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_parallel_data(name)
    get_parallel_data(name, params::Dict{String,<:Any})

Provides information about a parallel data resource.

# Arguments
- `name`: The name of the parallel data resource that is being retrieved.

"""
function get_parallel_data(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return translate(
        "GetParallelData",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_parallel_data(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return translate(
        "GetParallelData",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_terminology(name)
    get_terminology(name, params::Dict{String,<:Any})

Retrieves a custom terminology.

# Arguments
- `name`: The name of the custom terminology being retrieved.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"TerminologyDataFormat"`: The data format of the custom terminology being retrieved. If
  you don't specify this parameter, Amazon Translate returns a file with the same format as
  the file that was imported to create the terminology.  If you specify this parameter when
  you retrieve a multi-directional terminology resource, you must specify the same format as
  the input file that was imported to create it. Otherwise, Amazon Translate throws an error.
"""
function get_terminology(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return translate(
        "GetTerminology",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_terminology(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return translate(
        "GetTerminology",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    import_terminology(merge_strategy, name, terminology_data)
    import_terminology(merge_strategy, name, terminology_data, params::Dict{String,<:Any})

Creates or updates a custom terminology, depending on whether one already exists for the
given terminology name. Importing a terminology with the same name as an existing one will
merge the terminologies based on the chosen merge strategy. The only supported merge
strategy is OVERWRITE, where the imported terminology overwrites the existing terminology
of the same name. If you import a terminology that overwrites an existing one, the new
terminology takes up to 10 minutes to fully propagate. After that, translations have access
to the new terminology.

# Arguments
- `merge_strategy`: The merge strategy of the custom terminology being imported. Currently,
  only the OVERWRITE merge strategy is supported. In this case, the imported terminology will
  overwrite an existing terminology of the same name.
- `name`: The name of the custom terminology being imported.
- `terminology_data`: The terminology data for the custom terminology being imported.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: The description of the custom terminology being imported.
- `"EncryptionKey"`: The encryption key for the custom terminology being imported.
- `"Tags"`: Tags to be associated with this resource. A tag is a key-value pair that adds
  metadata to a resource. Each tag key for the resource must be unique. For more information,
  see  Tagging your resources.
"""
function import_terminology(
    MergeStrategy, Name, TerminologyData; aws_config::AbstractAWSConfig=current_aws_config()
)
    return translate(
        "ImportTerminology",
        Dict{String,Any}(
            "MergeStrategy" => MergeStrategy,
            "Name" => Name,
            "TerminologyData" => TerminologyData,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function import_terminology(
    MergeStrategy,
    Name,
    TerminologyData,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return translate(
        "ImportTerminology",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "MergeStrategy" => MergeStrategy,
                    "Name" => Name,
                    "TerminologyData" => TerminologyData,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_languages()
    list_languages(params::Dict{String,<:Any})

Provides a list of languages (RFC-5646 codes and names) that Amazon Translate supports.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DisplayLanguageCode"`: The language code for the language to use to display the
  language names in the response. The language code is en by default.
- `"MaxResults"`: The maximum number of results to return in each response.
- `"NextToken"`: Include the NextToken value to fetch the next group of supported
  languages.
"""
function list_languages(; aws_config::AbstractAWSConfig=current_aws_config())
    return translate(
        "ListLanguages"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_languages(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return translate(
        "ListLanguages", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_parallel_data()
    list_parallel_data(params::Dict{String,<:Any})

Provides a list of your parallel data resources in Amazon Translate.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of parallel data resources returned for each request.
- `"NextToken"`: A string that specifies the next page of results to return in a paginated
  response.
"""
function list_parallel_data(; aws_config::AbstractAWSConfig=current_aws_config())
    return translate(
        "ListParallelData"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_parallel_data(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return translate(
        "ListParallelData", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists all tags associated with a given Amazon Translate resource. For more information, see
 Tagging your resources.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the given Amazon Translate resource you
  are querying.

"""
function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return translate(
        "ListTagsForResource",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return translate(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_terminologies()
    list_terminologies(params::Dict{String,<:Any})

Provides a list of custom terminologies associated with your account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of custom terminologies returned per list request.
- `"NextToken"`: If the result of the request to ListTerminologies was truncated, include
  the NextToken to fetch the next group of custom terminologies.
"""
function list_terminologies(; aws_config::AbstractAWSConfig=current_aws_config())
    return translate(
        "ListTerminologies"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_terminologies(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return translate(
        "ListTerminologies", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_text_translation_jobs()
    list_text_translation_jobs(params::Dict{String,<:Any})

Gets a list of the batch translation jobs that you have submitted.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filter"`: The parameters that specify which batch translation jobs to retrieve. Filters
  include job name, job status, and submission time. You can only set one filter at a time.
- `"MaxResults"`: The maximum number of results to return in each page. The default value
  is 100.
- `"NextToken"`: The token to request the next page of results.
"""
function list_text_translation_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return translate(
        "ListTextTranslationJobs"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_text_translation_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return translate(
        "ListTextTranslationJobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_text_translation_job(client_token, data_access_role_arn, input_data_config, output_data_config, source_language_code, target_language_codes)
    start_text_translation_job(client_token, data_access_role_arn, input_data_config, output_data_config, source_language_code, target_language_codes, params::Dict{String,<:Any})

Starts an asynchronous batch translation job. Use batch translation jobs to translate large
volumes of text across multiple documents at once. For batch translation, you can input
documents with different source languages (specify auto as the source language). You can
specify one or more target languages. Batch translation translates each input document into
each of the target languages. For more information, see Asynchronous batch processing.
Batch translation jobs can be described with the DescribeTextTranslationJob operation,
listed with the ListTextTranslationJobs operation, and stopped with the
StopTextTranslationJob operation.

# Arguments
- `client_token`: A unique identifier for the request. This token is generated for you when
  using the Amazon Translate SDK.
- `data_access_role_arn`: The Amazon Resource Name (ARN) of an AWS Identity Access and
  Management (IAM) role that grants Amazon Translate read access to your input data. For more
  information, see Identity and access management .
- `input_data_config`: Specifies the format and location of the input documents for the
  translation job.
- `output_data_config`: Specifies the S3 folder to which your job output will be saved.
- `source_language_code`: The language code of the input language. Specify the language if
  all input documents share the same language. If you don't know the language of the source
  files, or your input documents contains different source languages, select auto. Amazon
  Translate auto detects the source language for each input document. For a list of supported
  language codes, see Supported languages.
- `target_language_codes`: The target languages of the translation job. Enter up to 10
  language codes. Each input file is translated into each target language. Each language code
  is 2 or 5 characters long. For a list of language codes, see Supported languages.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"JobName"`: The name of the batch translation job to be performed.
- `"ParallelDataNames"`: The name of a parallel data resource to add to the translation
  job. This resource consists of examples that show how you want segments of text to be
  translated. If you specify multiple target languages for the job, the parallel data file
  must include translations for all the target languages. When you add parallel data to a
  translation job, you create an Active Custom Translation job.  This parameter accepts only
  one parallel data resource.  Active Custom Translation jobs are priced at a higher rate
  than other jobs that don't use parallel data. For more information, see Amazon Translate
  pricing.  For a list of available parallel data resources, use the ListParallelData
  operation. For more information, see  Customizing your translations with parallel data.
- `"Settings"`: Settings to configure your translation output. You can configure the
  following options:   Brevity: not supported.   Formality: sets the formality level of the
  output text.   Profanity: masks profane words and phrases in your translation output.
- `"TerminologyNames"`: The name of a custom terminology resource to add to the translation
  job. This resource lists examples source terms and the desired translation for each term.
  This parameter accepts only one custom terminology resource. If you specify multiple target
  languages for the job, translate uses the designated terminology for each requested target
  language that has an entry for the source term in the terminology file. For a list of
  available custom terminology resources, use the ListTerminologies operation. For more
  information, see Custom terminology.
"""
function start_text_translation_job(
    ClientToken,
    DataAccessRoleArn,
    InputDataConfig,
    OutputDataConfig,
    SourceLanguageCode,
    TargetLanguageCodes;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return translate(
        "StartTextTranslationJob",
        Dict{String,Any}(
            "ClientToken" => ClientToken,
            "DataAccessRoleArn" => DataAccessRoleArn,
            "InputDataConfig" => InputDataConfig,
            "OutputDataConfig" => OutputDataConfig,
            "SourceLanguageCode" => SourceLanguageCode,
            "TargetLanguageCodes" => TargetLanguageCodes,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_text_translation_job(
    ClientToken,
    DataAccessRoleArn,
    InputDataConfig,
    OutputDataConfig,
    SourceLanguageCode,
    TargetLanguageCodes,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return translate(
        "StartTextTranslationJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClientToken" => ClientToken,
                    "DataAccessRoleArn" => DataAccessRoleArn,
                    "InputDataConfig" => InputDataConfig,
                    "OutputDataConfig" => OutputDataConfig,
                    "SourceLanguageCode" => SourceLanguageCode,
                    "TargetLanguageCodes" => TargetLanguageCodes,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_text_translation_job(job_id)
    stop_text_translation_job(job_id, params::Dict{String,<:Any})

Stops an asynchronous batch translation job that is in progress. If the job's state is
IN_PROGRESS, the job will be marked for termination and put into the STOP_REQUESTED state.
If the job completes before it can be stopped, it is put into the COMPLETED state.
Otherwise, the job is put into the STOPPED state. Asynchronous batch translation jobs are
started with the StartTextTranslationJob operation. You can use the
DescribeTextTranslationJob or ListTextTranslationJobs operations to get a batch translation
job's JobId.

# Arguments
- `job_id`: The job ID of the job to be stopped.

"""
function stop_text_translation_job(
    JobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return translate(
        "StopTextTranslationJob",
        Dict{String,Any}("JobId" => JobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_text_translation_job(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return translate(
        "StopTextTranslationJob",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("JobId" => JobId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Associates a specific tag with a resource. A tag is a key-value pair that adds as a
metadata to a resource. For more information, see  Tagging your resources.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the given Amazon Translate resource to
  which you want to associate the tags.
- `tags`: Tags being associated with a specific Amazon Translate resource. There can be a
  maximum of 50 tags (both existing and pending) associated with a specific resource.

"""
function tag_resource(ResourceArn, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return translate(
        "TagResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceArn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return translate(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    translate_document(document, source_language_code, target_language_code)
    translate_document(document, source_language_code, target_language_code, params::Dict{String,<:Any})

Translates the input document from the source language to the target language. This
synchronous operation supports text, HTML, or Word documents as the input document.
TranslateDocument supports translations from English to any supported language, and from
any supported language to English. Therefore, specify either the source language code or
the target language code as “en” (English).   If you set the Formality parameter, the
request will fail if the target language does not support formality. For a list of target
languages that support formality, see Setting formality.

# Arguments
- `document`: The content and content type for the document to be translated. The document
  size must not exceed 100 KB.
- `source_language_code`: The language code for the language of the source text. For a list
  of supported language codes, see Supported languages. To have Amazon Translate determine
  the source language of your text, you can specify auto in the SourceLanguageCode field. If
  you specify auto, Amazon Translate will call Amazon Comprehend to determine the source
  language.  If you specify auto, you must send the TranslateDocument request in a region
  that supports Amazon Comprehend. Otherwise, the request returns an error indicating that
  autodetect is not supported.
- `target_language_code`: The language code requested for the translated document. For a
  list of supported language codes, see Supported languages.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Settings"`: Settings to configure your translation output. You can configure the
  following options:   Brevity: not supported.   Formality: sets the formality level of the
  output text.   Profanity: masks profane words and phrases in your translation output.
- `"TerminologyNames"`: The name of a terminology list file to add to the translation job.
  This file provides source terms and the desired translation for each term. A terminology
  list can contain a maximum of 256 terms. You can use one custom terminology resource in
  your translation request. Use the ListTerminologies operation to get the available
  terminology lists. For more information about custom terminology lists, see Custom
  terminology.
"""
function translate_document(
    Document,
    SourceLanguageCode,
    TargetLanguageCode;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return translate(
        "TranslateDocument",
        Dict{String,Any}(
            "Document" => Document,
            "SourceLanguageCode" => SourceLanguageCode,
            "TargetLanguageCode" => TargetLanguageCode,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function translate_document(
    Document,
    SourceLanguageCode,
    TargetLanguageCode,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return translate(
        "TranslateDocument",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Document" => Document,
                    "SourceLanguageCode" => SourceLanguageCode,
                    "TargetLanguageCode" => TargetLanguageCode,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    translate_text(source_language_code, target_language_code, text)
    translate_text(source_language_code, target_language_code, text, params::Dict{String,<:Any})

Translates input text from the source language to the target language. For a list of
available languages and language codes, see Supported languages.

# Arguments
- `source_language_code`: The language code for the language of the source text. For a list
  of language codes, see Supported languages. To have Amazon Translate determine the source
  language of your text, you can specify auto in the SourceLanguageCode field. If you specify
  auto, Amazon Translate will call Amazon Comprehend to determine the source language.  If
  you specify auto, you must send the TranslateText request in a region that supports Amazon
  Comprehend. Otherwise, the request returns an error indicating that autodetect is not
  supported.
- `target_language_code`: The language code requested for the language of the target text.
  For a list of language codes, see Supported languages.
- `text`: The text to translate. The text string can be a maximum of 10,000 bytes long.
  Depending on your character set, this may be fewer than 10,000 characters.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Settings"`: Settings to configure your translation output. You can configure the
  following options:   Brevity: reduces the length of the translated output for most
  translations.   Formality: sets the formality level of the output text.   Profanity: masks
  profane words and phrases in your translation output.
- `"TerminologyNames"`: The name of a terminology list file to add to the translation job.
  This file provides source terms and the desired translation for each term. A terminology
  list can contain a maximum of 256 terms. You can use one custom terminology resource in
  your translation request. Use the ListTerminologies operation to get the available
  terminology lists. For more information about custom terminology lists, see Custom
  terminology.
"""
function translate_text(
    SourceLanguageCode,
    TargetLanguageCode,
    Text;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return translate(
        "TranslateText",
        Dict{String,Any}(
            "SourceLanguageCode" => SourceLanguageCode,
            "TargetLanguageCode" => TargetLanguageCode,
            "Text" => Text,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function translate_text(
    SourceLanguageCode,
    TargetLanguageCode,
    Text,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return translate(
        "TranslateText",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "SourceLanguageCode" => SourceLanguageCode,
                    "TargetLanguageCode" => TargetLanguageCode,
                    "Text" => Text,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes a specific tag associated with an Amazon Translate resource. For more information,
see  Tagging your resources.

# Arguments
- `resource_arn`:  The Amazon Resource Name (ARN) of the given Amazon Translate resource
  from which you want to remove the tags.
- `tag_keys`: The initial part of a key-value pair that forms a tag being removed from a
  given resource. Keys must be unique and cannot be duplicated for a particular resource.

"""
function untag_resource(
    ResourceArn, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return translate(
        "UntagResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceArn,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return translate(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_parallel_data(client_token, name, parallel_data_config)
    update_parallel_data(client_token, name, parallel_data_config, params::Dict{String,<:Any})

Updates a previously created parallel data resource by importing a new input file from
Amazon S3.

# Arguments
- `client_token`: A unique identifier for the request. This token is automatically
  generated when you use Amazon Translate through an AWS SDK.
- `name`: The name of the parallel data resource being updated.
- `parallel_data_config`: Specifies the format and S3 location of the parallel data input
  file.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A custom description for the parallel data resource in Amazon Translate.
"""
function update_parallel_data(
    ClientToken,
    Name,
    ParallelDataConfig;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return translate(
        "UpdateParallelData",
        Dict{String,Any}(
            "ClientToken" => ClientToken,
            "Name" => Name,
            "ParallelDataConfig" => ParallelDataConfig,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_parallel_data(
    ClientToken,
    Name,
    ParallelDataConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return translate(
        "UpdateParallelData",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClientToken" => ClientToken,
                    "Name" => Name,
                    "ParallelDataConfig" => ParallelDataConfig,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: codebuild
using AWS.Compat
using AWS.UUIDs

"""
    batch_delete_builds(ids)
    batch_delete_builds(ids, params::Dict{String,<:Any})

Deletes one or more builds.

# Arguments
- `ids`: The IDs of the builds to delete.

"""
function batch_delete_builds(ids; aws_config::AbstractAWSConfig=current_aws_config())
    return codebuild(
        "BatchDeleteBuilds",
        Dict{String,Any}("ids" => ids);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_delete_builds(
    ids, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codebuild(
        "BatchDeleteBuilds",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("ids" => ids), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_get_build_batches(ids)
    batch_get_build_batches(ids, params::Dict{String,<:Any})

Retrieves information about one or more batch builds.

# Arguments
- `ids`: An array that contains the batch build identifiers to retrieve.

"""
function batch_get_build_batches(ids; aws_config::AbstractAWSConfig=current_aws_config())
    return codebuild(
        "BatchGetBuildBatches",
        Dict{String,Any}("ids" => ids);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_build_batches(
    ids, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codebuild(
        "BatchGetBuildBatches",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("ids" => ids), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_get_builds(ids)
    batch_get_builds(ids, params::Dict{String,<:Any})

Gets information about one or more builds.

# Arguments
- `ids`: The IDs of the builds.

"""
function batch_get_builds(ids; aws_config::AbstractAWSConfig=current_aws_config())
    return codebuild(
        "BatchGetBuilds",
        Dict{String,Any}("ids" => ids);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_builds(
    ids, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codebuild(
        "BatchGetBuilds",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("ids" => ids), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_get_fleets(names)
    batch_get_fleets(names, params::Dict{String,<:Any})

Gets information about one or more compute fleets.

# Arguments
- `names`: The names or ARNs of the compute fleets.

"""
function batch_get_fleets(names; aws_config::AbstractAWSConfig=current_aws_config())
    return codebuild(
        "BatchGetFleets",
        Dict{String,Any}("names" => names);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_fleets(
    names, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codebuild(
        "BatchGetFleets",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("names" => names), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_get_projects(names)
    batch_get_projects(names, params::Dict{String,<:Any})

Gets information about one or more build projects.

# Arguments
- `names`: The names or ARNs of the build projects. To get information about a project
  shared with your Amazon Web Services account, its ARN must be specified. You cannot specify
  a shared project using its name.

"""
function batch_get_projects(names; aws_config::AbstractAWSConfig=current_aws_config())
    return codebuild(
        "BatchGetProjects",
        Dict{String,Any}("names" => names);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_projects(
    names, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codebuild(
        "BatchGetProjects",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("names" => names), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_get_report_groups(report_group_arns)
    batch_get_report_groups(report_group_arns, params::Dict{String,<:Any})

 Returns an array of report groups.

# Arguments
- `report_group_arns`:  An array of report group ARNs that identify the report groups to
  return.

"""
function batch_get_report_groups(
    reportGroupArns; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codebuild(
        "BatchGetReportGroups",
        Dict{String,Any}("reportGroupArns" => reportGroupArns);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_report_groups(
    reportGroupArns,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codebuild(
        "BatchGetReportGroups",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("reportGroupArns" => reportGroupArns), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_get_reports(report_arns)
    batch_get_reports(report_arns, params::Dict{String,<:Any})

 Returns an array of reports.

# Arguments
- `report_arns`:  An array of ARNs that identify the Report objects to return.

"""
function batch_get_reports(reportArns; aws_config::AbstractAWSConfig=current_aws_config())
    return codebuild(
        "BatchGetReports",
        Dict{String,Any}("reportArns" => reportArns);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_reports(
    reportArns,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codebuild(
        "BatchGetReports",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("reportArns" => reportArns), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_fleet(base_capacity, compute_type, environment_type, name)
    create_fleet(base_capacity, compute_type, environment_type, name, params::Dict{String,<:Any})

Creates a compute fleet.

# Arguments
- `base_capacity`: The initial number of machines allocated to the ﬂeet, which deﬁnes
  the number of builds that can run in parallel.
- `compute_type`: Information about the compute resources the compute fleet uses. Available
  values include:    BUILD_GENERAL1_SMALL: Use up to 3 GB memory and 2 vCPUs for builds.
  BUILD_GENERAL1_MEDIUM: Use up to 7 GB memory and 4 vCPUs for builds.
  BUILD_GENERAL1_LARGE: Use up to 16 GB memory and 8 vCPUs for builds, depending on your
  environment type.    BUILD_GENERAL1_XLARGE: Use up to 70 GB memory and 36 vCPUs for builds,
  depending on your environment type.    BUILD_GENERAL1_2XLARGE: Use up to 145 GB memory, 72
  vCPUs, and 824 GB of SSD storage for builds. This compute type supports Docker images up to
  100 GB uncompressed.    If you use BUILD_GENERAL1_SMALL:     For environment type
  LINUX_CONTAINER, you can use up to 3 GB memory and 2 vCPUs for builds.     For environment
  type LINUX_GPU_CONTAINER, you can use up to 16 GB memory, 4 vCPUs, and 1 NVIDIA A10G Tensor
  Core GPU for builds.    For environment type ARM_CONTAINER, you can use up to 4 GB memory
  and 2 vCPUs on ARM-based processors for builds.    If you use BUILD_GENERAL1_LARGE:     For
  environment type LINUX_CONTAINER, you can use up to 15 GB memory and 8 vCPUs for builds.
   For environment type LINUX_GPU_CONTAINER, you can use up to 255 GB memory, 32 vCPUs, and 4
  NVIDIA Tesla V100 GPUs for builds.    For environment type ARM_CONTAINER, you can use up to
  16 GB memory and 8 vCPUs on ARM-based processors for builds.   For more information, see
  Build environment compute types in the CodeBuild User Guide.
- `environment_type`: The environment type of the compute fleet.   The environment type
  ARM_CONTAINER is available only in regions US East (N. Virginia), US East (Ohio), US West
  (Oregon), EU (Ireland), Asia Pacific (Mumbai), Asia Pacific (Tokyo), Asia Pacific
  (Singapore), Asia Pacific (Sydney), EU (Frankfurt), and South America (São Paulo).   The
  environment type LINUX_CONTAINER is available only in regions US East (N. Virginia), US
  East (Ohio), US West (Oregon), EU (Ireland), EU (Frankfurt), Asia Pacific (Tokyo), Asia
  Pacific (Singapore), Asia Pacific (Sydney), South America (São Paulo), and Asia Pacific
  (Mumbai).   The environment type LINUX_GPU_CONTAINER is available only in regions US East
  (N. Virginia), US East (Ohio), US West (Oregon), EU (Ireland), EU (Frankfurt), Asia Pacific
  (Tokyo), and Asia Pacific (Sydney).   The environment type WINDOWS_SERVER_2019_CONTAINER is
  available only in regions US East (N. Virginia), US East (Ohio), US West (Oregon), Asia
  Pacific (Sydney), Asia Pacific (Tokyo), Asia Pacific (Mumbai) and EU (Ireland).   The
  environment type WINDOWS_SERVER_2022_CONTAINER is available only in regions US East (N.
  Virginia), US East (Ohio), US West (Oregon), EU (Ireland), EU (Frankfurt), Asia Pacific
  (Sydney), Asia Pacific (Singapore), Asia Pacific (Tokyo), South America (São Paulo) and
  Asia Pacific (Mumbai).   For more information, see Build environment compute types in the
  CodeBuild user guide.
- `name`: The name of the compute fleet.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"fleetServiceRole"`: The service role associated with the compute fleet. For more
  information, see  Allow a user to add a permission policy for a fleet service role in the
  CodeBuild User Guide.
- `"overflowBehavior"`: The compute fleet overflow behavior.   For overflow behavior QUEUE,
  your overflow builds need to wait on the existing fleet instance to become available.   For
  overflow behavior ON_DEMAND, your overflow builds run on CodeBuild on-demand.  If you
  choose to set your overflow behavior to on-demand while creating a VPC-connected fleet,
  make sure that you add the required VPC permissions to your project service role. For more
  information, see Example policy statement to allow CodeBuild access to Amazon Web Services
  services required to create a VPC network interface.
- `"scalingConfiguration"`: The scaling configuration of the compute fleet.
- `"tags"`: A list of tag key and value pairs associated with this compute fleet. These
  tags are available for use by Amazon Web Services services that support CodeBuild build
  project tags.
- `"vpcConfig"`:
"""
function create_fleet(
    baseCapacity,
    computeType,
    environmentType,
    name;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codebuild(
        "CreateFleet",
        Dict{String,Any}(
            "baseCapacity" => baseCapacity,
            "computeType" => computeType,
            "environmentType" => environmentType,
            "name" => name,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_fleet(
    baseCapacity,
    computeType,
    environmentType,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codebuild(
        "CreateFleet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "baseCapacity" => baseCapacity,
                    "computeType" => computeType,
                    "environmentType" => environmentType,
                    "name" => name,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_project(artifacts, environment, name, service_role, source)
    create_project(artifacts, environment, name, service_role, source, params::Dict{String,<:Any})

Creates a build project.

# Arguments
- `artifacts`: Information about the build output artifacts for the build project.
- `environment`: Information about the build environment for the build project.
- `name`: The name of the build project.
- `service_role`: The ARN of the IAM role that enables CodeBuild to interact with dependent
  Amazon Web Services services on behalf of the Amazon Web Services account.
- `source`: Information about the build input source code for the build project.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"badgeEnabled"`: Set this to true to generate a publicly accessible URL for your
  project's build badge.
- `"buildBatchConfig"`: A ProjectBuildBatchConfig object that defines the batch build
  options for the project.
- `"cache"`: Stores recently used information so that it can be quickly accessed at a later
  time.
- `"concurrentBuildLimit"`: The maximum number of concurrent builds that are allowed for
  this project. New builds are only started if the current number of builds is less than or
  equal to this limit. If the current build count meets this limit, new builds are throttled
  and are not run.
- `"description"`: A description that makes the build project easy to identify.
- `"encryptionKey"`: The Key Management Service customer master key (CMK) to be used for
  encrypting the build output artifacts.  You can use a cross-account KMS key to encrypt the
  build output artifacts if your service role has permission to that key.   You can specify
  either the Amazon Resource Name (ARN) of the CMK or, if available, the CMK's alias (using
  the format alias/&lt;alias-name&gt;).
- `"fileSystemLocations"`:  An array of ProjectFileSystemLocation objects for a CodeBuild
  build project. A ProjectFileSystemLocation object specifies the identifier, location,
  mountOptions, mountPoint, and type of a file system created using Amazon Elastic File
  System.
- `"logsConfig"`: Information about logs for the build project. These can be logs in
  CloudWatch Logs, logs uploaded to a specified S3 bucket, or both.
- `"queuedTimeoutInMinutes"`: The number of minutes a build is allowed to be queued before
  it times out.
- `"secondaryArtifacts"`: An array of ProjectArtifacts objects.
- `"secondarySourceVersions"`: An array of ProjectSourceVersion objects. If
  secondarySourceVersions is specified at the build level, then they take precedence over
  these secondarySourceVersions (at the project level).
- `"secondarySources"`: An array of ProjectSource objects.
- `"sourceVersion"`: A version of the build input to be built for this project. If not
  specified, the latest version is used. If specified, it must be one of:    For CodeCommit:
  the commit ID, branch, or Git tag to use.   For GitHub: the commit ID, pull request ID,
  branch name, or tag name that corresponds to the version of the source code you want to
  build. If a pull request ID is specified, it must use the format pr/pull-request-ID (for
  example pr/25). If a branch name is specified, the branch's HEAD commit ID is used. If not
  specified, the default branch's HEAD commit ID is used.   For GitLab: the commit ID,
  branch, or Git tag to use.   For Bitbucket: the commit ID, branch name, or tag name that
  corresponds to the version of the source code you want to build. If a branch name is
  specified, the branch's HEAD commit ID is used. If not specified, the default branch's HEAD
  commit ID is used.   For Amazon S3: the version ID of the object that represents the build
  input ZIP file to use.   If sourceVersion is specified at the build level, then that
  version takes precedence over this sourceVersion (at the project level).  For more
  information, see Source Version Sample with CodeBuild in the CodeBuild User Guide.
- `"tags"`: A list of tag key and value pairs associated with this build project. These
  tags are available for use by Amazon Web Services services that support CodeBuild build
  project tags.
- `"timeoutInMinutes"`: How long, in minutes, from 5 to 2160 (36 hours), for CodeBuild to
  wait before it times out any build that has not been marked as completed. The default is 60
  minutes.
- `"vpcConfig"`: VpcConfig enables CodeBuild to access resources in an Amazon VPC.  If
  you're using compute fleets during project creation, do not provide vpcConfig.
"""
function create_project(
    artifacts,
    environment,
    name,
    serviceRole,
    source;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codebuild(
        "CreateProject",
        Dict{String,Any}(
            "artifacts" => artifacts,
            "environment" => environment,
            "name" => name,
            "serviceRole" => serviceRole,
            "source" => source,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_project(
    artifacts,
    environment,
    name,
    serviceRole,
    source,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codebuild(
        "CreateProject",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "artifacts" => artifacts,
                    "environment" => environment,
                    "name" => name,
                    "serviceRole" => serviceRole,
                    "source" => source,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_report_group(export_config, name, type)
    create_report_group(export_config, name, type, params::Dict{String,<:Any})

 Creates a report group. A report group contains a collection of reports.

# Arguments
- `export_config`:  A ReportExportConfig object that contains information about where the
  report group test results are exported.
- `name`:  The name of the report group.
- `type`:  The type of report group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tags"`:  A list of tag key and value pairs associated with this report group.  These
  tags are available for use by Amazon Web Services services that support CodeBuild report
  group tags.
"""
function create_report_group(
    exportConfig, name, type; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codebuild(
        "CreateReportGroup",
        Dict{String,Any}("exportConfig" => exportConfig, "name" => name, "type" => type);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_report_group(
    exportConfig,
    name,
    type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codebuild(
        "CreateReportGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "exportConfig" => exportConfig, "name" => name, "type" => type
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_webhook(project_name)
    create_webhook(project_name, params::Dict{String,<:Any})

For an existing CodeBuild build project that has its source code stored in a GitHub or
Bitbucket repository, enables CodeBuild to start rebuilding the source code every time a
code change is pushed to the repository.  If you enable webhooks for an CodeBuild project,
and the project is used as a build step in CodePipeline, then two identical builds are
created for each commit. One build is triggered through webhooks, and one through
CodePipeline. Because billing is on a per-build basis, you are billed for both builds.
Therefore, if you are using CodePipeline, we recommend that you disable webhooks in
CodeBuild. In the CodeBuild console, clear the Webhook box. For more information, see step
5 in Change a Build Project's Settings.

# Arguments
- `project_name`: The name of the CodeBuild project.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"branchFilter"`: A regular expression used to determine which repository branches are
  built when a webhook is triggered. If the name of a branch matches the regular expression,
  then it is built. If branchFilter is empty, then all branches are built.  It is recommended
  that you use filterGroups instead of branchFilter.
- `"buildType"`: Specifies the type of build this webhook will trigger.
- `"filterGroups"`: An array of arrays of WebhookFilter objects used to determine which
  webhooks are triggered. At least one WebhookFilter in the array must specify EVENT as its
  type.  For a build to be triggered, at least one filter group in the filterGroups array
  must pass. For a filter group to pass, each of its filters must pass.
- `"manualCreation"`: If manualCreation is true, CodeBuild doesn't create a webhook in
  GitHub and instead returns payloadUrl and secret values for the webhook. The payloadUrl and
  secret values in the output can be used to manually create a webhook within GitHub.
  manualCreation is only available for GitHub webhooks.
- `"scopeConfiguration"`: The scope configuration for global or organization webhooks.
  Global or organization webhooks are only available for GitHub and Github Enterprise
  webhooks.
"""
function create_webhook(projectName; aws_config::AbstractAWSConfig=current_aws_config())
    return codebuild(
        "CreateWebhook",
        Dict{String,Any}("projectName" => projectName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_webhook(
    projectName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codebuild(
        "CreateWebhook",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("projectName" => projectName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_build_batch(id)
    delete_build_batch(id, params::Dict{String,<:Any})

Deletes a batch build.

# Arguments
- `id`: The identifier of the batch build to delete.

"""
function delete_build_batch(id; aws_config::AbstractAWSConfig=current_aws_config())
    return codebuild(
        "DeleteBuildBatch",
        Dict{String,Any}("id" => id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_build_batch(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codebuild(
        "DeleteBuildBatch",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("id" => id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_fleet(arn)
    delete_fleet(arn, params::Dict{String,<:Any})

Deletes a compute fleet. When you delete a compute fleet, its builds are not deleted.

# Arguments
- `arn`: The ARN of the compute fleet.

"""
function delete_fleet(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return codebuild(
        "DeleteFleet",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_fleet(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codebuild(
        "DeleteFleet",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_project(name)
    delete_project(name, params::Dict{String,<:Any})

 Deletes a build project. When you delete a project, its builds are not deleted.

# Arguments
- `name`: The name of the build project.

"""
function delete_project(name; aws_config::AbstractAWSConfig=current_aws_config())
    return codebuild(
        "DeleteProject",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_project(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codebuild(
        "DeleteProject",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_report(arn)
    delete_report(arn, params::Dict{String,<:Any})

 Deletes a report.

# Arguments
- `arn`:  The ARN of the report to delete.

"""
function delete_report(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return codebuild(
        "DeleteReport",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_report(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codebuild(
        "DeleteReport",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_report_group(arn)
    delete_report_group(arn, params::Dict{String,<:Any})

Deletes a report group. Before you delete a report group, you must delete its reports.

# Arguments
- `arn`: The ARN of the report group to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"deleteReports"`: If true, deletes any reports that belong to a report group before
  deleting the report group.  If false, you must delete any reports in the report group. Use
  ListReportsForReportGroup to get the reports in a report group. Use DeleteReport to delete
  the reports. If you call DeleteReportGroup for a report group that contains one or more
  reports, an exception is thrown.
"""
function delete_report_group(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return codebuild(
        "DeleteReportGroup",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_report_group(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codebuild(
        "DeleteReportGroup",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_resource_policy(resource_arn)
    delete_resource_policy(resource_arn, params::Dict{String,<:Any})

 Deletes a resource policy that is identified by its resource ARN.

# Arguments
- `resource_arn`:  The ARN of the resource that is associated with the resource policy.

"""
function delete_resource_policy(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codebuild(
        "DeleteResourcePolicy",
        Dict{String,Any}("resourceArn" => resourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_resource_policy(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codebuild(
        "DeleteResourcePolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceArn" => resourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_source_credentials(arn)
    delete_source_credentials(arn, params::Dict{String,<:Any})

 Deletes a set of GitHub, GitHub Enterprise, or Bitbucket source credentials.

# Arguments
- `arn`:  The Amazon Resource Name (ARN) of the token.

"""
function delete_source_credentials(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return codebuild(
        "DeleteSourceCredentials",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_source_credentials(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codebuild(
        "DeleteSourceCredentials",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_webhook(project_name)
    delete_webhook(project_name, params::Dict{String,<:Any})

For an existing CodeBuild build project that has its source code stored in a GitHub or
Bitbucket repository, stops CodeBuild from rebuilding the source code every time a code
change is pushed to the repository.

# Arguments
- `project_name`: The name of the CodeBuild project.

"""
function delete_webhook(projectName; aws_config::AbstractAWSConfig=current_aws_config())
    return codebuild(
        "DeleteWebhook",
        Dict{String,Any}("projectName" => projectName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_webhook(
    projectName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codebuild(
        "DeleteWebhook",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("projectName" => projectName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_code_coverages(report_arn)
    describe_code_coverages(report_arn, params::Dict{String,<:Any})

Retrieves one or more code coverage reports.

# Arguments
- `report_arn`:  The ARN of the report for which test cases are returned.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxLineCoveragePercentage"`: The maximum line coverage percentage to report.
- `"maxResults"`: The maximum number of results to return.
- `"minLineCoveragePercentage"`: The minimum line coverage percentage to report.
- `"nextToken"`: The nextToken value returned from a previous call to
  DescribeCodeCoverages. This specifies the next item to return. To return the beginning of
  the list, exclude this parameter.
- `"sortBy"`: Specifies how the results are sorted. Possible values are:  FILE_PATH  The
  results are sorted by file path.  LINE_COVERAGE_PERCENTAGE  The results are sorted by the
  percentage of lines that are covered.
- `"sortOrder"`: Specifies if the results are sorted in ascending or descending order.
"""
function describe_code_coverages(
    reportArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codebuild(
        "DescribeCodeCoverages",
        Dict{String,Any}("reportArn" => reportArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_code_coverages(
    reportArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codebuild(
        "DescribeCodeCoverages",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("reportArn" => reportArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_test_cases(report_arn)
    describe_test_cases(report_arn, params::Dict{String,<:Any})

 Returns a list of details about test cases for a report.

# Arguments
- `report_arn`:  The ARN of the report for which test cases are returned.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filter"`:  A TestCaseFilter object used to filter the returned reports.
- `"maxResults"`:  The maximum number of paginated test cases returned per response. Use
  nextToken to iterate pages in the list of returned TestCase objects. The default value is
  100.
- `"nextToken"`:  During a previous call, the maximum number of items that can be returned
  is the value specified in maxResults. If there more items in the list, then a unique string
  called a nextToken is returned. To get the next batch of items in the list, call this
  operation again, adding the next token to the call. To get all of the items in the list,
  keep calling this operation with each subsequent next token that is returned, until no more
  next tokens are returned.
"""
function describe_test_cases(reportArn; aws_config::AbstractAWSConfig=current_aws_config())
    return codebuild(
        "DescribeTestCases",
        Dict{String,Any}("reportArn" => reportArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_test_cases(
    reportArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codebuild(
        "DescribeTestCases",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("reportArn" => reportArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_report_group_trend(report_group_arn, trend_field)
    get_report_group_trend(report_group_arn, trend_field, params::Dict{String,<:Any})

Analyzes and accumulates test report values for the specified test reports.

# Arguments
- `report_group_arn`: The ARN of the report group that contains the reports to analyze.
- `trend_field`: The test report value to accumulate. This must be one of the following
  values:  Test reports:   DURATION  Accumulate the test run times for the specified reports.
   PASS_RATE  Accumulate the percentage of tests that passed for the specified test reports.
  TOTAL  Accumulate the total number of tests for the specified test reports.      Code
  coverage reports:   BRANCH_COVERAGE  Accumulate the branch coverage percentages for the
  specified test reports.  BRANCHES_COVERED  Accumulate the branches covered values for the
  specified test reports.  BRANCHES_MISSED  Accumulate the branches missed values for the
  specified test reports.  LINE_COVERAGE  Accumulate the line coverage percentages for the
  specified test reports.  LINES_COVERED  Accumulate the lines covered values for the
  specified test reports.  LINES_MISSED  Accumulate the lines not covered values for the
  specified test reports.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"numOfReports"`: The number of reports to analyze. This operation always retrieves the
  most recent reports. If this parameter is omitted, the most recent 100 reports are analyzed.
"""
function get_report_group_trend(
    reportGroupArn, trendField; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codebuild(
        "GetReportGroupTrend",
        Dict{String,Any}("reportGroupArn" => reportGroupArn, "trendField" => trendField);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_report_group_trend(
    reportGroupArn,
    trendField,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codebuild(
        "GetReportGroupTrend",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "reportGroupArn" => reportGroupArn, "trendField" => trendField
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_resource_policy(resource_arn)
    get_resource_policy(resource_arn, params::Dict{String,<:Any})

 Gets a resource policy that is identified by its resource ARN.

# Arguments
- `resource_arn`:  The ARN of the resource that is associated with the resource policy.

"""
function get_resource_policy(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codebuild(
        "GetResourcePolicy",
        Dict{String,Any}("resourceArn" => resourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_resource_policy(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codebuild(
        "GetResourcePolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceArn" => resourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    import_source_credentials(auth_type, server_type, token)
    import_source_credentials(auth_type, server_type, token, params::Dict{String,<:Any})

 Imports the source repository credentials for an CodeBuild project that has its source
code stored in a GitHub, GitHub Enterprise, or Bitbucket repository.

# Arguments
- `auth_type`:  The type of authentication used to connect to a GitHub, GitHub Enterprise,
  GitLab, GitLab Self Managed, or Bitbucket repository. An OAUTH connection is not supported
  by the API and must be created using the CodeBuild console. Note that CODECONNECTIONS is
  only valid for GitLab and GitLab Self Managed.
- `server_type`:  The source provider used for this project.
- `token`:  For GitHub or GitHub Enterprise, this is the personal access token. For
  Bitbucket, this is either the access token or the app password. For the authType
  CODECONNECTIONS, this is the connectionArn.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"shouldOverwrite"`:  Set to false to prevent overwriting the repository source
  credentials. Set to true to overwrite the repository source credentials. The default value
  is true.
- `"username"`:  The Bitbucket username when the authType is BASIC_AUTH. This parameter is
  not valid for other types of source providers or connections.
"""
function import_source_credentials(
    authType, serverType, token; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codebuild(
        "ImportSourceCredentials",
        Dict{String,Any}(
            "authType" => authType, "serverType" => serverType, "token" => token
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function import_source_credentials(
    authType,
    serverType,
    token,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codebuild(
        "ImportSourceCredentials",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "authType" => authType, "serverType" => serverType, "token" => token
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    invalidate_project_cache(project_name)
    invalidate_project_cache(project_name, params::Dict{String,<:Any})

Resets the cache for a project.

# Arguments
- `project_name`: The name of the CodeBuild build project that the cache is reset for.

"""
function invalidate_project_cache(
    projectName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codebuild(
        "InvalidateProjectCache",
        Dict{String,Any}("projectName" => projectName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function invalidate_project_cache(
    projectName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codebuild(
        "InvalidateProjectCache",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("projectName" => projectName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_build_batches()
    list_build_batches(params::Dict{String,<:Any})

Retrieves the identifiers of your build batches in the current region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filter"`: A BuildBatchFilter object that specifies the filters for the search.
- `"maxResults"`: The maximum number of results to return.
- `"nextToken"`: The nextToken value returned from a previous call to ListBuildBatches.
  This specifies the next item to return. To return the beginning of the list, exclude this
  parameter.
- `"sortOrder"`: Specifies the sort order of the returned items. Valid values include:
  ASCENDING: List the batch build identifiers in ascending order by identifier.
  DESCENDING: List the batch build identifiers in descending order by identifier.
"""
function list_build_batches(; aws_config::AbstractAWSConfig=current_aws_config())
    return codebuild(
        "ListBuildBatches"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_build_batches(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codebuild(
        "ListBuildBatches", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_build_batches_for_project()
    list_build_batches_for_project(params::Dict{String,<:Any})

Retrieves the identifiers of the build batches for a specific project.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filter"`: A BuildBatchFilter object that specifies the filters for the search.
- `"maxResults"`: The maximum number of results to return.
- `"nextToken"`: The nextToken value returned from a previous call to
  ListBuildBatchesForProject. This specifies the next item to return. To return the beginning
  of the list, exclude this parameter.
- `"projectName"`: The name of the project.
- `"sortOrder"`: Specifies the sort order of the returned items. Valid values include:
  ASCENDING: List the batch build identifiers in ascending order by identifier.
  DESCENDING: List the batch build identifiers in descending order by identifier.
"""
function list_build_batches_for_project(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return codebuild(
        "ListBuildBatchesForProject"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_build_batches_for_project(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codebuild(
        "ListBuildBatchesForProject",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_builds()
    list_builds(params::Dict{String,<:Any})

Gets a list of build IDs, with each build ID representing a single build.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: During a previous call, if there are more than 100 items in the list, only
  the first 100 items are returned, along with a unique string called a nextToken. To get the
  next batch of items in the list, call this operation again, adding the next token to the
  call. To get all of the items in the list, keep calling this operation with each subsequent
  next token that is returned, until no more next tokens are returned.
- `"sortOrder"`: The order to list build IDs. Valid values include:    ASCENDING: List the
  build IDs in ascending order by build ID.    DESCENDING: List the build IDs in descending
  order by build ID.
"""
function list_builds(; aws_config::AbstractAWSConfig=current_aws_config())
    return codebuild("ListBuilds"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_builds(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codebuild(
        "ListBuilds", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_builds_for_project(project_name)
    list_builds_for_project(project_name, params::Dict{String,<:Any})

Gets a list of build identifiers for the specified build project, with each build
identifier representing a single build.

# Arguments
- `project_name`: The name of the CodeBuild project.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: During a previous call, if there are more than 100 items in the list, only
  the first 100 items are returned, along with a unique string called a nextToken. To get the
  next batch of items in the list, call this operation again, adding the next token to the
  call. To get all of the items in the list, keep calling this operation with each subsequent
  next token that is returned, until no more next tokens are returned.
- `"sortOrder"`: The order to sort the results in. The results are sorted by build number,
  not the build identifier. If this is not specified, the results are sorted in descending
  order. Valid values include:    ASCENDING: List the build identifiers in ascending order,
  by build number.    DESCENDING: List the build identifiers in descending order, by build
  number.   If the project has more than 100 builds, setting the sort order will result in an
  error.
"""
function list_builds_for_project(
    projectName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codebuild(
        "ListBuildsForProject",
        Dict{String,Any}("projectName" => projectName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_builds_for_project(
    projectName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codebuild(
        "ListBuildsForProject",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("projectName" => projectName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_curated_environment_images()
    list_curated_environment_images(params::Dict{String,<:Any})

Gets information about Docker images that are managed by CodeBuild.

"""
function list_curated_environment_images(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return codebuild(
        "ListCuratedEnvironmentImages";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_curated_environment_images(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codebuild(
        "ListCuratedEnvironmentImages",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_fleets()
    list_fleets(params::Dict{String,<:Any})

Gets a list of compute fleet names with each compute fleet name representing a single
compute fleet.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of paginated compute fleets returned per response. Use
  nextToken to iterate pages in the list of returned compute fleets.
- `"nextToken"`: During a previous call, if there are more than 100 items in the list, only
  the first 100 items are returned, along with a unique string called a nextToken. To get the
  next batch of items in the list, call this operation again, adding the next token to the
  call. To get all of the items in the list, keep calling this operation with each subsequent
  next token that is returned, until no more next tokens are returned.
- `"sortBy"`: The criterion to be used to list compute fleet names. Valid values include:
   CREATED_TIME: List based on when each compute fleet was created.    LAST_MODIFIED_TIME:
  List based on when information about each compute fleet was last changed.    NAME: List
  based on each compute fleet's name.   Use sortOrder to specify in what order to list the
  compute fleet names based on the preceding criteria.
- `"sortOrder"`: The order in which to list compute fleets. Valid values include:
  ASCENDING: List in ascending order.    DESCENDING: List in descending order.   Use sortBy
  to specify the criterion to be used to list compute fleet names.
"""
function list_fleets(; aws_config::AbstractAWSConfig=current_aws_config())
    return codebuild("ListFleets"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_fleets(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codebuild(
        "ListFleets", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_projects()
    list_projects(params::Dict{String,<:Any})

Gets a list of build project names, with each build project name representing a single
build project.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: During a previous call, if there are more than 100 items in the list, only
  the first 100 items are returned, along with a unique string called a nextToken. To get the
  next batch of items in the list, call this operation again, adding the next token to the
  call. To get all of the items in the list, keep calling this operation with each subsequent
  next token that is returned, until no more next tokens are returned.
- `"sortBy"`: The criterion to be used to list build project names. Valid values include:
   CREATED_TIME: List based on when each build project was created.    LAST_MODIFIED_TIME:
  List based on when information about each build project was last changed.    NAME: List
  based on each build project's name.   Use sortOrder to specify in what order to list the
  build project names based on the preceding criteria.
- `"sortOrder"`: The order in which to list build projects. Valid values include:
  ASCENDING: List in ascending order.    DESCENDING: List in descending order.   Use sortBy
  to specify the criterion to be used to list build project names.
"""
function list_projects(; aws_config::AbstractAWSConfig=current_aws_config())
    return codebuild("ListProjects"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_projects(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codebuild(
        "ListProjects", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_report_groups()
    list_report_groups(params::Dict{String,<:Any})

 Gets a list ARNs for the report groups in the current Amazon Web Services account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:  The maximum number of paginated report groups returned per response. Use
  nextToken to iterate pages in the list of returned ReportGroup objects. The default value
  is 100.
- `"nextToken"`:  During a previous call, the maximum number of items that can be returned
  is the value specified in maxResults. If there more items in the list, then a unique string
  called a nextToken is returned. To get the next batch of items in the list, call this
  operation again, adding the next token to the call. To get all of the items in the list,
  keep calling this operation with each subsequent next token that is returned, until no more
  next tokens are returned.
- `"sortBy"`:  The criterion to be used to list build report groups. Valid values include:
     CREATED_TIME: List based on when each report group was created.    LAST_MODIFIED_TIME:
  List based on when each report group was last changed.    NAME: List based on each report
  group's name.
- `"sortOrder"`:  Used to specify the order to sort the list of returned report groups.
  Valid values are ASCENDING and DESCENDING.
"""
function list_report_groups(; aws_config::AbstractAWSConfig=current_aws_config())
    return codebuild(
        "ListReportGroups"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_report_groups(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codebuild(
        "ListReportGroups", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_reports()
    list_reports(params::Dict{String,<:Any})

 Returns a list of ARNs for the reports in the current Amazon Web Services account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filter"`:  A ReportFilter object used to filter the returned reports.
- `"maxResults"`:  The maximum number of paginated reports returned per response. Use
  nextToken to iterate pages in the list of returned Report objects. The default value is
  100.
- `"nextToken"`:  During a previous call, the maximum number of items that can be returned
  is the value specified in maxResults. If there more items in the list, then a unique string
  called a nextToken is returned. To get the next batch of items in the list, call this
  operation again, adding the next token to the call. To get all of the items in the list,
  keep calling this operation with each subsequent next token that is returned, until no more
  next tokens are returned.
- `"sortOrder"`:  Specifies the sort order for the list of returned reports. Valid values
  are:     ASCENDING: return reports in chronological order based on their creation date.
  DESCENDING: return reports in the reverse chronological order based on their creation date.
  
"""
function list_reports(; aws_config::AbstractAWSConfig=current_aws_config())
    return codebuild("ListReports"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_reports(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codebuild(
        "ListReports", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_reports_for_report_group(report_group_arn)
    list_reports_for_report_group(report_group_arn, params::Dict{String,<:Any})

 Returns a list of ARNs for the reports that belong to a ReportGroup.

# Arguments
- `report_group_arn`:  The ARN of the report group for which you want to return report
  ARNs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filter"`:  A ReportFilter object used to filter the returned reports.
- `"maxResults"`:  The maximum number of paginated reports in this report group returned
  per response. Use nextToken to iterate pages in the list of returned Report objects. The
  default value is 100.
- `"nextToken"`:  During a previous call, the maximum number of items that can be returned
  is the value specified in maxResults. If there more items in the list, then a unique string
  called a nextToken is returned. To get the next batch of items in the list, call this
  operation again, adding the next token to the call. To get all of the items in the list,
  keep calling this operation with each subsequent next token that is returned, until no more
  next tokens are returned.
- `"sortOrder"`:  Use to specify whether the results are returned in ascending or
  descending order.
"""
function list_reports_for_report_group(
    reportGroupArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codebuild(
        "ListReportsForReportGroup",
        Dict{String,Any}("reportGroupArn" => reportGroupArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_reports_for_report_group(
    reportGroupArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codebuild(
        "ListReportsForReportGroup",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("reportGroupArn" => reportGroupArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_shared_projects()
    list_shared_projects(params::Dict{String,<:Any})

 Gets a list of projects that are shared with other Amazon Web Services accounts or users.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:  The maximum number of paginated shared build projects returned per
  response. Use nextToken to iterate pages in the list of returned Project objects. The
  default value is 100.
- `"nextToken"`:  During a previous call, the maximum number of items that can be returned
  is the value specified in maxResults. If there more items in the list, then a unique string
  called a nextToken is returned. To get the next batch of items in the list, call this
  operation again, adding the next token to the call. To get all of the items in the list,
  keep calling this operation with each subsequent next token that is returned, until no more
  next tokens are returned.
- `"sortBy"`:  The criterion to be used to list build projects shared with the current
  Amazon Web Services account or user. Valid values include:     ARN: List based on the ARN.
     MODIFIED_TIME: List based on when information about the shared project was last changed.
  
- `"sortOrder"`: The order in which to list shared build projects. Valid values include:
  ASCENDING: List in ascending order.    DESCENDING: List in descending order.
"""
function list_shared_projects(; aws_config::AbstractAWSConfig=current_aws_config())
    return codebuild(
        "ListSharedProjects"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_shared_projects(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codebuild(
        "ListSharedProjects", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_shared_report_groups()
    list_shared_report_groups(params::Dict{String,<:Any})

 Gets a list of report groups that are shared with other Amazon Web Services accounts or
users.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:  The maximum number of paginated shared report groups per response. Use
  nextToken to iterate pages in the list of returned ReportGroup objects. The default value
  is 100.
- `"nextToken"`:  During a previous call, the maximum number of items that can be returned
  is the value specified in maxResults. If there more items in the list, then a unique string
  called a nextToken is returned. To get the next batch of items in the list, call this
  operation again, adding the next token to the call. To get all of the items in the list,
  keep calling this operation with each subsequent next token that is returned, until no more
  next tokens are returned.
- `"sortBy"`:  The criterion to be used to list report groups shared with the current
  Amazon Web Services account or user. Valid values include:     ARN: List based on the ARN.
     MODIFIED_TIME: List based on when information about the shared report group was last
  changed.
- `"sortOrder"`: The order in which to list shared report groups. Valid values include:
  ASCENDING: List in ascending order.    DESCENDING: List in descending order.
"""
function list_shared_report_groups(; aws_config::AbstractAWSConfig=current_aws_config())
    return codebuild(
        "ListSharedReportGroups"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_shared_report_groups(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codebuild(
        "ListSharedReportGroups",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_source_credentials()
    list_source_credentials(params::Dict{String,<:Any})

 Returns a list of SourceCredentialsInfo objects.

"""
function list_source_credentials(; aws_config::AbstractAWSConfig=current_aws_config())
    return codebuild(
        "ListSourceCredentials"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_source_credentials(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codebuild(
        "ListSourceCredentials",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_resource_policy(policy, resource_arn)
    put_resource_policy(policy, resource_arn, params::Dict{String,<:Any})

 Stores a resource policy for the ARN of a Project or ReportGroup object.

# Arguments
- `policy`:  A JSON-formatted resource policy. For more information, see Sharing a Project
  and Sharing a Report Group in the CodeBuild User Guide.
- `resource_arn`:  The ARN of the Project or ReportGroup resource you want to associate
  with a resource policy.

"""
function put_resource_policy(
    policy, resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codebuild(
        "PutResourcePolicy",
        Dict{String,Any}("policy" => policy, "resourceArn" => resourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_resource_policy(
    policy,
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codebuild(
        "PutResourcePolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("policy" => policy, "resourceArn" => resourceArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    retry_build()
    retry_build(params::Dict{String,<:Any})

Restarts a build.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"id"`: Specifies the identifier of the build to restart.
- `"idempotencyToken"`: A unique, case sensitive identifier you provide to ensure the
  idempotency of the RetryBuild request. The token is included in the RetryBuild request and
  is valid for five minutes. If you repeat the RetryBuild request with the same token, but
  change a parameter, CodeBuild returns a parameter mismatch error.
"""
function retry_build(; aws_config::AbstractAWSConfig=current_aws_config())
    return codebuild("RetryBuild"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function retry_build(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codebuild(
        "RetryBuild", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    retry_build_batch()
    retry_build_batch(params::Dict{String,<:Any})

Restarts a failed batch build. Only batch builds that have failed can be retried.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"id"`: Specifies the identifier of the batch build to restart.
- `"idempotencyToken"`: A unique, case sensitive identifier you provide to ensure the
  idempotency of the RetryBuildBatch request. The token is included in the RetryBuildBatch
  request and is valid for five minutes. If you repeat the RetryBuildBatch request with the
  same token, but change a parameter, CodeBuild returns a parameter mismatch error.
- `"retryType"`: Specifies the type of retry to perform.
"""
function retry_build_batch(; aws_config::AbstractAWSConfig=current_aws_config())
    return codebuild(
        "RetryBuildBatch"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function retry_build_batch(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codebuild(
        "RetryBuildBatch", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    start_build(project_name)
    start_build(project_name, params::Dict{String,<:Any})

Starts running a build with the settings defined in the project. These setting include: how
to run a build, where to get the source code, which build environment to use, which build
commands to run, and where to store the build output. You can also start a build run by
overriding some of the build settings in the project. The overrides only apply for that
specific start build request. The settings in the project are unaltered.

# Arguments
- `project_name`: The name of the CodeBuild build project to start running a build.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"artifactsOverride"`: Build output artifact settings that override, for this build only,
  the latest ones already defined in the build project.
- `"buildStatusConfigOverride"`: Contains information that defines how the build project
  reports the build status to the source provider. This option is only used when the source
  provider is GITHUB, GITHUB_ENTERPRISE, or BITBUCKET.
- `"buildspecOverride"`: A buildspec file declaration that overrides the latest one defined
  in the build project, for this build only. The buildspec defined on the project is not
  changed. If this value is set, it can be either an inline buildspec definition, the path to
  an alternate buildspec file relative to the value of the built-in CODEBUILD_SRC_DIR
  environment variable, or the path to an S3 bucket. The bucket must be in the same Amazon
  Web Services Region as the build project. Specify the buildspec file using its ARN (for
  example, arn:aws:s3:::my-codebuild-sample2/buildspec.yml). If this value is not provided or
  is set to an empty string, the source code must contain a buildspec file in its root
  directory. For more information, see Buildspec File Name and Storage Location.  Since this
  property allows you to change the build commands that will run in the container, you should
  note that an IAM principal with the ability to call this API and set this parameter can
  override the default settings. Moreover, we encourage that you use a trustworthy buildspec
  location like a file in your source repository or a Amazon S3 bucket.
- `"cacheOverride"`: A ProjectCache object specified for this build that overrides the one
  defined in the build project.
- `"certificateOverride"`: The name of a certificate for this build that overrides the one
  specified in the build project.
- `"computeTypeOverride"`: The name of a compute type for this build that overrides the one
  specified in the build project.
- `"debugSessionEnabled"`: Specifies if session debugging is enabled for this build. For
  more information, see Viewing a running build in Session Manager.
- `"encryptionKeyOverride"`: The Key Management Service customer master key (CMK) that
  overrides the one specified in the build project. The CMK key encrypts the build output
  artifacts.   You can use a cross-account KMS key to encrypt the build output artifacts if
  your service role has permission to that key.   You can specify either the Amazon Resource
  Name (ARN) of the CMK or, if available, the CMK's alias (using the format
  alias/&lt;alias-name&gt;).
- `"environmentTypeOverride"`: A container type for this build that overrides the one
  specified in the build project.
- `"environmentVariablesOverride"`: A set of environment variables that overrides, for this
  build only, the latest ones already defined in the build project.
- `"fleetOverride"`: A ProjectFleet object specified for this build that overrides the one
  defined in the build project.
- `"gitCloneDepthOverride"`: The user-defined depth of history, with a minimum value of 0,
  that overrides, for this build only, any previous depth of history defined in the build
  project.
- `"gitSubmodulesConfigOverride"`:  Information about the Git submodules configuration for
  this build of an CodeBuild build project.
- `"idempotencyToken"`: A unique, case sensitive identifier you provide to ensure the
  idempotency of the StartBuild request. The token is included in the StartBuild request and
  is valid for 5 minutes. If you repeat the StartBuild request with the same token, but
  change a parameter, CodeBuild returns a parameter mismatch error.
- `"imageOverride"`: The name of an image for this build that overrides the one specified
  in the build project.
- `"imagePullCredentialsTypeOverride"`: The type of credentials CodeBuild uses to pull
  images in your build. There are two valid values:   CODEBUILD  Specifies that CodeBuild
  uses its own credentials. This requires that you modify your ECR repository policy to trust
  CodeBuild's service principal.  SERVICE_ROLE  Specifies that CodeBuild uses your build
  project's service role.    When using a cross-account or private registry image, you must
  use SERVICE_ROLE credentials. When using an CodeBuild curated image, you must use CODEBUILD
  credentials.
- `"insecureSslOverride"`: Enable this flag to override the insecure SSL setting that is
  specified in the build project. The insecure SSL setting determines whether to ignore SSL
  warnings while connecting to the project source code. This override applies only if the
  build's source is GitHub Enterprise.
- `"logsConfigOverride"`:  Log settings for this build that override the log settings
  defined in the build project.
- `"privilegedModeOverride"`: Enable this flag to override privileged mode in the build
  project.
- `"queuedTimeoutInMinutesOverride"`:  The number of minutes a build is allowed to be
  queued before it times out.
- `"registryCredentialOverride"`:  The credentials for access to a private registry.
- `"reportBuildStatusOverride"`:  Set to true to report to your source provider the status
  of a build's start and completion. If you use this option with a source provider other than
  GitHub, GitHub Enterprise, or Bitbucket, an invalidInputException is thrown.  To be able to
  report the build status to the source provider, the user associated with the source
  provider must have write access to the repo. If the user does not have write access, the
  build status cannot be updated. For more information, see Source provider access in the
  CodeBuild User Guide.   The status of a build triggered by a webhook is always reported to
  your source provider.
- `"secondaryArtifactsOverride"`:  An array of ProjectArtifacts objects.
- `"secondarySourcesOverride"`:  An array of ProjectSource objects.
- `"secondarySourcesVersionOverride"`:  An array of ProjectSourceVersion objects that
  specify one or more versions of the project's secondary sources to be used for this build
  only.
- `"serviceRoleOverride"`: The name of a service role for this build that overrides the one
  specified in the build project.
- `"sourceAuthOverride"`: An authorization type for this build that overrides the one
  defined in the build project. This override applies only if the build project's source is
  BitBucket, GitHub, GitLab, or GitLab Self Managed.
- `"sourceLocationOverride"`: A location that overrides, for this build, the source
  location for the one defined in the build project.
- `"sourceTypeOverride"`: A source input type, for this build, that overrides the source
  input defined in the build project.
- `"sourceVersion"`: The version of the build input to be built, for this build only. If
  not specified, the latest version is used. If specified, the contents depends on the source
  provider:  CodeCommit  The commit ID, branch, or Git tag to use.  GitHub  The commit ID,
  pull request ID, branch name, or tag name that corresponds to the version of the source
  code you want to build. If a pull request ID is specified, it must use the format
  pr/pull-request-ID (for example pr/25). If a branch name is specified, the branch's HEAD
  commit ID is used. If not specified, the default branch's HEAD commit ID is used.  GitLab
  The commit ID, branch, or Git tag to use.  Bitbucket  The commit ID, branch name, or tag
  name that corresponds to the version of the source code you want to build. If a branch name
  is specified, the branch's HEAD commit ID is used. If not specified, the default branch's
  HEAD commit ID is used.  Amazon S3  The version ID of the object that represents the build
  input ZIP file to use.   If sourceVersion is specified at the project level, then this
  sourceVersion (at the build level) takes precedence.  For more information, see Source
  Version Sample with CodeBuild in the CodeBuild User Guide.
- `"timeoutInMinutesOverride"`: The number of build timeout minutes, from 5 to 2160 (36
  hours), that overrides, for this build only, the latest setting already defined in the
  build project.
"""
function start_build(projectName; aws_config::AbstractAWSConfig=current_aws_config())
    return codebuild(
        "StartBuild",
        Dict{String,Any}("projectName" => projectName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_build(
    projectName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codebuild(
        "StartBuild",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("projectName" => projectName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_build_batch(project_name)
    start_build_batch(project_name, params::Dict{String,<:Any})

Starts a batch build for a project.

# Arguments
- `project_name`: The name of the project.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"artifactsOverride"`: An array of ProjectArtifacts objects that contains information
  about the build output artifact overrides for the build project.
- `"buildBatchConfigOverride"`: A BuildBatchConfigOverride object that contains batch build
  configuration overrides.
- `"buildTimeoutInMinutesOverride"`: Overrides the build timeout specified in the batch
  build project.
- `"buildspecOverride"`: A buildspec file declaration that overrides, for this build only,
  the latest one already defined in the build project. If this value is set, it can be either
  an inline buildspec definition, the path to an alternate buildspec file relative to the
  value of the built-in CODEBUILD_SRC_DIR environment variable, or the path to an S3 bucket.
  The bucket must be in the same Amazon Web Services Region as the build project. Specify the
  buildspec file using its ARN (for example,
  arn:aws:s3:::my-codebuild-sample2/buildspec.yml). If this value is not provided or is set
  to an empty string, the source code must contain a buildspec file in its root directory.
  For more information, see Buildspec File Name and Storage Location.
- `"cacheOverride"`: A ProjectCache object that specifies cache overrides.
- `"certificateOverride"`: The name of a certificate for this batch build that overrides
  the one specified in the batch build project.
- `"computeTypeOverride"`: The name of a compute type for this batch build that overrides
  the one specified in the batch build project.
- `"debugSessionEnabled"`: Specifies if session debugging is enabled for this batch build.
  For more information, see Viewing a running build in Session Manager. Batch session
  debugging is not supported for matrix batch builds.
- `"encryptionKeyOverride"`: The Key Management Service customer master key (CMK) that
  overrides the one specified in the batch build project. The CMK key encrypts the build
  output artifacts.  You can use a cross-account KMS key to encrypt the build output
  artifacts if your service role has permission to that key.   You can specify either the
  Amazon Resource Name (ARN) of the CMK or, if available, the CMK's alias (using the format
  alias/&lt;alias-name&gt;).
- `"environmentTypeOverride"`: A container type for this batch build that overrides the one
  specified in the batch build project.
- `"environmentVariablesOverride"`: An array of EnvironmentVariable objects that override,
  or add to, the environment variables defined in the batch build project.
- `"gitCloneDepthOverride"`: The user-defined depth of history, with a minimum value of 0,
  that overrides, for this batch build only, any previous depth of history defined in the
  batch build project.
- `"gitSubmodulesConfigOverride"`: A GitSubmodulesConfig object that overrides the Git
  submodules configuration for this batch build.
- `"idempotencyToken"`: A unique, case sensitive identifier you provide to ensure the
  idempotency of the StartBuildBatch request. The token is included in the StartBuildBatch
  request and is valid for five minutes. If you repeat the StartBuildBatch request with the
  same token, but change a parameter, CodeBuild returns a parameter mismatch error.
- `"imageOverride"`: The name of an image for this batch build that overrides the one
  specified in the batch build project.
- `"imagePullCredentialsTypeOverride"`: The type of credentials CodeBuild uses to pull
  images in your batch build. There are two valid values:   CODEBUILD  Specifies that
  CodeBuild uses its own credentials. This requires that you modify your ECR repository
  policy to trust CodeBuild's service principal.  SERVICE_ROLE  Specifies that CodeBuild uses
  your build project's service role.    When using a cross-account or private registry image,
  you must use SERVICE_ROLE credentials. When using an CodeBuild curated image, you must use
  CODEBUILD credentials.
- `"insecureSslOverride"`: Enable this flag to override the insecure SSL setting that is
  specified in the batch build project. The insecure SSL setting determines whether to ignore
  SSL warnings while connecting to the project source code. This override applies only if the
  build's source is GitHub Enterprise.
- `"logsConfigOverride"`: A LogsConfig object that override the log settings defined in the
  batch build project.
- `"privilegedModeOverride"`: Enable this flag to override privileged mode in the batch
  build project.
- `"queuedTimeoutInMinutesOverride"`: The number of minutes a batch build is allowed to be
  queued before it times out.
- `"registryCredentialOverride"`: A RegistryCredential object that overrides credentials
  for access to a private registry.
- `"reportBuildBatchStatusOverride"`: Set to true to report to your source provider the
  status of a batch build's start and completion. If you use this option with a source
  provider other than GitHub, GitHub Enterprise, or Bitbucket, an invalidInputException is
  thrown.   The status of a build triggered by a webhook is always reported to your source
  provider.
- `"secondaryArtifactsOverride"`: An array of ProjectArtifacts objects that override the
  secondary artifacts defined in the batch build project.
- `"secondarySourcesOverride"`: An array of ProjectSource objects that override the
  secondary sources defined in the batch build project.
- `"secondarySourcesVersionOverride"`: An array of ProjectSourceVersion objects that
  override the secondary source versions in the batch build project.
- `"serviceRoleOverride"`: The name of a service role for this batch build that overrides
  the one specified in the batch build project.
- `"sourceAuthOverride"`: A SourceAuth object that overrides the one defined in the batch
  build project. This override applies only if the build project's source is BitBucket or
  GitHub.
- `"sourceLocationOverride"`: A location that overrides, for this batch build, the source
  location defined in the batch build project.
- `"sourceTypeOverride"`: The source input type that overrides the source input defined in
  the batch build project.
- `"sourceVersion"`: The version of the batch build input to be built, for this build only.
  If not specified, the latest version is used. If specified, the contents depends on the
  source provider:  CodeCommit  The commit ID, branch, or Git tag to use.  GitHub  The commit
  ID, pull request ID, branch name, or tag name that corresponds to the version of the source
  code you want to build. If a pull request ID is specified, it must use the format
  pr/pull-request-ID (for example pr/25). If a branch name is specified, the branch's HEAD
  commit ID is used. If not specified, the default branch's HEAD commit ID is used.
  Bitbucket  The commit ID, branch name, or tag name that corresponds to the version of the
  source code you want to build. If a branch name is specified, the branch's HEAD commit ID
  is used. If not specified, the default branch's HEAD commit ID is used.  Amazon S3  The
  version ID of the object that represents the build input ZIP file to use.   If
  sourceVersion is specified at the project level, then this sourceVersion (at the build
  level) takes precedence.  For more information, see Source Version Sample with CodeBuild in
  the CodeBuild User Guide.
"""
function start_build_batch(projectName; aws_config::AbstractAWSConfig=current_aws_config())
    return codebuild(
        "StartBuildBatch",
        Dict{String,Any}("projectName" => projectName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_build_batch(
    projectName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codebuild(
        "StartBuildBatch",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("projectName" => projectName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_build(id)
    stop_build(id, params::Dict{String,<:Any})

Attempts to stop running a build.

# Arguments
- `id`: The ID of the build.

"""
function stop_build(id; aws_config::AbstractAWSConfig=current_aws_config())
    return codebuild(
        "StopBuild",
        Dict{String,Any}("id" => id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_build(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codebuild(
        "StopBuild",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("id" => id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_build_batch(id)
    stop_build_batch(id, params::Dict{String,<:Any})

Stops a running batch build.

# Arguments
- `id`: The identifier of the batch build to stop.

"""
function stop_build_batch(id; aws_config::AbstractAWSConfig=current_aws_config())
    return codebuild(
        "StopBuildBatch",
        Dict{String,Any}("id" => id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_build_batch(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codebuild(
        "StopBuildBatch",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("id" => id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_fleet(arn)
    update_fleet(arn, params::Dict{String,<:Any})

Updates a compute fleet.

# Arguments
- `arn`: The ARN of the compute fleet.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"baseCapacity"`: The initial number of machines allocated to the compute ﬂeet, which
  deﬁnes the number of builds that can run in parallel.
- `"computeType"`: Information about the compute resources the compute fleet uses.
  Available values include:    BUILD_GENERAL1_SMALL: Use up to 3 GB memory and 2 vCPUs for
  builds.    BUILD_GENERAL1_MEDIUM: Use up to 7 GB memory and 4 vCPUs for builds.
  BUILD_GENERAL1_LARGE: Use up to 16 GB memory and 8 vCPUs for builds, depending on your
  environment type.    BUILD_GENERAL1_XLARGE: Use up to 70 GB memory and 36 vCPUs for builds,
  depending on your environment type.    BUILD_GENERAL1_2XLARGE: Use up to 145 GB memory, 72
  vCPUs, and 824 GB of SSD storage for builds. This compute type supports Docker images up to
  100 GB uncompressed.    If you use BUILD_GENERAL1_SMALL:     For environment type
  LINUX_CONTAINER, you can use up to 3 GB memory and 2 vCPUs for builds.     For environment
  type LINUX_GPU_CONTAINER, you can use up to 16 GB memory, 4 vCPUs, and 1 NVIDIA A10G Tensor
  Core GPU for builds.    For environment type ARM_CONTAINER, you can use up to 4 GB memory
  and 2 vCPUs on ARM-based processors for builds.    If you use BUILD_GENERAL1_LARGE:     For
  environment type LINUX_CONTAINER, you can use up to 15 GB memory and 8 vCPUs for builds.
   For environment type LINUX_GPU_CONTAINER, you can use up to 255 GB memory, 32 vCPUs, and 4
  NVIDIA Tesla V100 GPUs for builds.    For environment type ARM_CONTAINER, you can use up to
  16 GB memory and 8 vCPUs on ARM-based processors for builds.   For more information, see
  Build environment compute types in the CodeBuild User Guide.
- `"environmentType"`: The environment type of the compute fleet.   The environment type
  ARM_CONTAINER is available only in regions US East (N. Virginia), US East (Ohio), US West
  (Oregon), EU (Ireland), Asia Pacific (Mumbai), Asia Pacific (Tokyo), Asia Pacific
  (Singapore), Asia Pacific (Sydney), EU (Frankfurt), and South America (São Paulo).   The
  environment type LINUX_CONTAINER is available only in regions US East (N. Virginia), US
  East (Ohio), US West (Oregon), EU (Ireland), EU (Frankfurt), Asia Pacific (Tokyo), Asia
  Pacific (Singapore), Asia Pacific (Sydney), South America (São Paulo), and Asia Pacific
  (Mumbai).   The environment type LINUX_GPU_CONTAINER is available only in regions US East
  (N. Virginia), US East (Ohio), US West (Oregon), EU (Ireland), EU (Frankfurt), Asia Pacific
  (Tokyo), and Asia Pacific (Sydney).   The environment type WINDOWS_SERVER_2019_CONTAINER is
  available only in regions US East (N. Virginia), US East (Ohio), US West (Oregon), Asia
  Pacific (Sydney), Asia Pacific (Tokyo), Asia Pacific (Mumbai) and EU (Ireland).   The
  environment type WINDOWS_SERVER_2022_CONTAINER is available only in regions US East (N.
  Virginia), US East (Ohio), US West (Oregon), EU (Ireland), EU (Frankfurt), Asia Pacific
  (Sydney), Asia Pacific (Singapore), Asia Pacific (Tokyo), South America (São Paulo) and
  Asia Pacific (Mumbai).   For more information, see Build environment compute types in the
  CodeBuild user guide.
- `"fleetServiceRole"`: The service role associated with the compute fleet. For more
  information, see  Allow a user to add a permission policy for a fleet service role in the
  CodeBuild User Guide.
- `"overflowBehavior"`: The compute fleet overflow behavior.   For overflow behavior QUEUE,
  your overflow builds need to wait on the existing fleet instance to become available.   For
  overflow behavior ON_DEMAND, your overflow builds run on CodeBuild on-demand.  If you
  choose to set your overflow behavior to on-demand while creating a VPC-connected fleet,
  make sure that you add the required VPC permissions to your project service role. For more
  information, see Example policy statement to allow CodeBuild access to Amazon Web Services
  services required to create a VPC network interface.
- `"scalingConfiguration"`: The scaling configuration of the compute fleet.
- `"tags"`: A list of tag key and value pairs associated with this compute fleet. These
  tags are available for use by Amazon Web Services services that support CodeBuild build
  project tags.
- `"vpcConfig"`:
"""
function update_fleet(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return codebuild(
        "UpdateFleet",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_fleet(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codebuild(
        "UpdateFleet",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_project(name)
    update_project(name, params::Dict{String,<:Any})

Changes the settings of a build project.

# Arguments
- `name`: The name of the build project.  You cannot change a build project's name.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"artifacts"`: Information to be changed about the build output artifacts for the build
  project.
- `"badgeEnabled"`: Set this to true to generate a publicly accessible URL for your
  project's build badge.
- `"buildBatchConfig"`:
- `"cache"`: Stores recently used information so that it can be quickly accessed at a later
  time.
- `"concurrentBuildLimit"`: The maximum number of concurrent builds that are allowed for
  this project. New builds are only started if the current number of builds is less than or
  equal to this limit. If the current build count meets this limit, new builds are throttled
  and are not run. To remove this limit, set this value to -1.
- `"description"`: A new or replacement description of the build project.
- `"encryptionKey"`: The Key Management Service customer master key (CMK) to be used for
  encrypting the build output artifacts.   You can use a cross-account KMS key to encrypt the
  build output artifacts if your service role has permission to that key.   You can specify
  either the Amazon Resource Name (ARN) of the CMK or, if available, the CMK's alias (using
  the format alias/&lt;alias-name&gt;).
- `"environment"`: Information to be changed about the build environment for the build
  project.
- `"fileSystemLocations"`:  An array of ProjectFileSystemLocation objects for a CodeBuild
  build project. A ProjectFileSystemLocation object specifies the identifier, location,
  mountOptions, mountPoint, and type of a file system created using Amazon Elastic File
  System.
- `"logsConfig"`:  Information about logs for the build project. A project can create logs
  in CloudWatch Logs, logs in an S3 bucket, or both.
- `"queuedTimeoutInMinutes"`:  The number of minutes a build is allowed to be queued before
  it times out.
- `"secondaryArtifacts"`:  An array of ProjectArtifact objects.
- `"secondarySourceVersions"`:  An array of ProjectSourceVersion objects. If
  secondarySourceVersions is specified at the build level, then they take over these
  secondarySourceVersions (at the project level).
- `"secondarySources"`:  An array of ProjectSource objects.
- `"serviceRole"`: The replacement ARN of the IAM role that enables CodeBuild to interact
  with dependent Amazon Web Services services on behalf of the Amazon Web Services account.
- `"source"`: Information to be changed about the build input source code for the build
  project.
- `"sourceVersion"`:  A version of the build input to be built for this project. If not
  specified, the latest version is used. If specified, it must be one of:    For CodeCommit:
  the commit ID, branch, or Git tag to use.   For GitHub: the commit ID, pull request ID,
  branch name, or tag name that corresponds to the version of the source code you want to
  build. If a pull request ID is specified, it must use the format pr/pull-request-ID (for
  example pr/25). If a branch name is specified, the branch's HEAD commit ID is used. If not
  specified, the default branch's HEAD commit ID is used.   For GitLab: the commit ID,
  branch, or Git tag to use.   For Bitbucket: the commit ID, branch name, or tag name that
  corresponds to the version of the source code you want to build. If a branch name is
  specified, the branch's HEAD commit ID is used. If not specified, the default branch's HEAD
  commit ID is used.   For Amazon S3: the version ID of the object that represents the build
  input ZIP file to use.    If sourceVersion is specified at the build level, then that
  version takes precedence over this sourceVersion (at the project level).   For more
  information, see Source Version Sample with CodeBuild in the CodeBuild User Guide.
- `"tags"`: An updated list of tag key and value pairs associated with this build project.
  These tags are available for use by Amazon Web Services services that support CodeBuild
  build project tags.
- `"timeoutInMinutes"`: The replacement value in minutes, from 5 to 2160 (36 hours), for
  CodeBuild to wait before timing out any related build that did not get marked as completed.
- `"vpcConfig"`: VpcConfig enables CodeBuild to access resources in an Amazon VPC.
"""
function update_project(name; aws_config::AbstractAWSConfig=current_aws_config())
    return codebuild(
        "UpdateProject",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_project(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codebuild(
        "UpdateProject",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_project_visibility(project_arn, project_visibility)
    update_project_visibility(project_arn, project_visibility, params::Dict{String,<:Any})

Changes the public visibility for a project. The project's build results, logs, and
artifacts are available to the general public. For more information, see Public build
projects in the CodeBuild User Guide.  The following should be kept in mind when making
your projects public:   All of a project's build results, logs, and artifacts, including
builds that were run when the project was private, are available to the general public.
All build logs and artifacts are available to the public. Environment variables, source
code, and other sensitive information may have been output to the build logs and artifacts.
You must be careful about what information is output to the build logs. Some best practice
are:   Do not store sensitive values in environment variables. We recommend that you use an
Amazon EC2 Systems Manager Parameter Store or Secrets Manager to store sensitive values.
Follow Best practices for using webhooks in the CodeBuild User Guide to limit which
entities can trigger a build, and do not store the buildspec in the project itself, to
ensure that your webhooks are as secure as possible.     A malicious user can use public
builds to distribute malicious artifacts. We recommend that you review all pull requests to
verify that the pull request is a legitimate change. We also recommend that you validate
any artifacts with their checksums to make sure that the correct artifacts are being
downloaded.

# Arguments
- `project_arn`: The Amazon Resource Name (ARN) of the build project.
- `project_visibility`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"resourceAccessRole"`: The ARN of the IAM role that enables CodeBuild to access the
  CloudWatch Logs and Amazon S3 artifacts for the project's builds.
"""
function update_project_visibility(
    projectArn, projectVisibility; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codebuild(
        "UpdateProjectVisibility",
        Dict{String,Any}(
            "projectArn" => projectArn, "projectVisibility" => projectVisibility
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_project_visibility(
    projectArn,
    projectVisibility,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codebuild(
        "UpdateProjectVisibility",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "projectArn" => projectArn, "projectVisibility" => projectVisibility
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_report_group(arn)
    update_report_group(arn, params::Dict{String,<:Any})

 Updates a report group.

# Arguments
- `arn`:  The ARN of the report group to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"exportConfig"`:  Used to specify an updated export type. Valid values are:     S3: The
  report results are exported to an S3 bucket.     NO_EXPORT: The report results are not
  exported.
- `"tags"`:  An updated list of tag key and value pairs associated with this report group.
  These tags are available for use by Amazon Web Services services that support CodeBuild
  report group tags.
"""
function update_report_group(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return codebuild(
        "UpdateReportGroup",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_report_group(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codebuild(
        "UpdateReportGroup",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_webhook(project_name)
    update_webhook(project_name, params::Dict{String,<:Any})

 Updates the webhook associated with an CodeBuild build project.    If you use Bitbucket
for your repository, rotateSecret is ignored.

# Arguments
- `project_name`: The name of the CodeBuild project.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"branchFilter"`: A regular expression used to determine which repository branches are
  built when a webhook is triggered. If the name of a branch matches the regular expression,
  then it is built. If branchFilter is empty, then all branches are built.   It is
  recommended that you use filterGroups instead of branchFilter.
- `"buildType"`: Specifies the type of build this webhook will trigger.
- `"filterGroups"`:  An array of arrays of WebhookFilter objects used to determine if a
  webhook event can trigger a build. A filter group must contain at least one EVENT
  WebhookFilter.
- `"rotateSecret"`:  A boolean value that specifies whether the associated GitHub
  repository's secret token should be updated. If you use Bitbucket for your repository,
  rotateSecret is ignored.
"""
function update_webhook(projectName; aws_config::AbstractAWSConfig=current_aws_config())
    return codebuild(
        "UpdateWebhook",
        Dict{String,Any}("projectName" => projectName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_webhook(
    projectName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codebuild(
        "UpdateWebhook",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("projectName" => projectName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: s3outposts
using AWS.Compat
using AWS.UUIDs

"""
    create_endpoint(outpost_id, security_group_id, subnet_id)
    create_endpoint(outpost_id, security_group_id, subnet_id, params::Dict{String,<:Any})

Creates an endpoint and associates it with the specified Outpost.  It can take up to 5
minutes for this action to finish.   Related actions include:    DeleteEndpoint
ListEndpoints

# Arguments
- `outpost_id`: The ID of the Outposts.
- `security_group_id`: The ID of the security group to use with the endpoint.
- `subnet_id`: The ID of the subnet in the selected VPC. The endpoint subnet must belong to
  the Outpost that has Amazon S3 on Outposts provisioned.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccessType"`: The type of access for the network connectivity for the Amazon S3 on
  Outposts endpoint. To use the Amazon Web Services VPC, choose Private. To use the endpoint
  with an on-premises network, choose CustomerOwnedIp. If you choose CustomerOwnedIp, you
  must also provide the customer-owned IP address pool (CoIP pool).   Private is the default
  access type value.
- `"CustomerOwnedIpv4Pool"`: The ID of the customer-owned IPv4 address pool (CoIP pool) for
  the endpoint. IP addresses are allocated from this pool for the endpoint.
"""
function create_endpoint(
    OutpostId, SecurityGroupId, SubnetId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return s3outposts(
        "POST",
        "/S3Outposts/CreateEndpoint",
        Dict{String,Any}(
            "OutpostId" => OutpostId,
            "SecurityGroupId" => SecurityGroupId,
            "SubnetId" => SubnetId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_endpoint(
    OutpostId,
    SecurityGroupId,
    SubnetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return s3outposts(
        "POST",
        "/S3Outposts/CreateEndpoint",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "OutpostId" => OutpostId,
                    "SecurityGroupId" => SecurityGroupId,
                    "SubnetId" => SubnetId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_endpoint(endpoint_id, outpost_id)
    delete_endpoint(endpoint_id, outpost_id, params::Dict{String,<:Any})

Deletes an endpoint.  It can take up to 5 minutes for this action to finish.   Related
actions include:    CreateEndpoint     ListEndpoints

# Arguments
- `endpoint_id`: The ID of the endpoint.
- `outpost_id`: The ID of the Outposts.

"""
function delete_endpoint(
    endpointId, outpostId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return s3outposts(
        "DELETE",
        "/S3Outposts/DeleteEndpoint",
        Dict{String,Any}("endpointId" => endpointId, "outpostId" => outpostId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_endpoint(
    endpointId,
    outpostId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return s3outposts(
        "DELETE",
        "/S3Outposts/DeleteEndpoint",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("endpointId" => endpointId, "outpostId" => outpostId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_endpoints()
    list_endpoints(params::Dict{String,<:Any})

Lists endpoints associated with the specified Outpost.  Related actions include:
CreateEndpoint     DeleteEndpoint

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of endpoints that will be returned in the response.
- `"nextToken"`: If a previous response from this operation included a NextToken value,
  provide that value here to retrieve the next page of results.
"""
function list_endpoints(; aws_config::AbstractAWSConfig=current_aws_config())
    return s3outposts(
        "GET",
        "/S3Outposts/ListEndpoints";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_endpoints(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return s3outposts(
        "GET",
        "/S3Outposts/ListEndpoints",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_outposts_with_s3()
    list_outposts_with_s3(params::Dict{String,<:Any})

Lists the Outposts with S3 on Outposts capacity for your Amazon Web Services account.
Includes S3 on Outposts that you have access to as the Outposts owner, or as a shared user
from Resource Access Manager (RAM).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of Outposts to return. The limit is 100.
- `"nextToken"`: When you can get additional results from the ListOutpostsWithS3 call, a
  NextToken parameter is returned in the output. You can then pass in a subsequent command to
  the NextToken parameter to continue listing additional Outposts.
"""
function list_outposts_with_s3(; aws_config::AbstractAWSConfig=current_aws_config())
    return s3outposts(
        "GET",
        "/S3Outposts/ListOutpostsWithS3";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_outposts_with_s3(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return s3outposts(
        "GET",
        "/S3Outposts/ListOutpostsWithS3",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_shared_endpoints(outpost_id)
    list_shared_endpoints(outpost_id, params::Dict{String,<:Any})

Lists all endpoints associated with an Outpost that has been shared by Amazon Web Services
Resource Access Manager (RAM). Related actions include:    CreateEndpoint
DeleteEndpoint

# Arguments
- `outpost_id`: The ID of the Amazon Web Services Outpost.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of endpoints that will be returned in the response.
- `"nextToken"`: If a previous response from this operation included a NextToken value, you
  can provide that value here to retrieve the next page of results.
"""
function list_shared_endpoints(
    outpostId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return s3outposts(
        "GET",
        "/S3Outposts/ListSharedEndpoints",
        Dict{String,Any}("outpostId" => outpostId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_shared_endpoints(
    outpostId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return s3outposts(
        "GET",
        "/S3Outposts/ListSharedEndpoints",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("outpostId" => outpostId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: chime_sdk_identity
using AWS.Compat
using AWS.UUIDs

"""
    create_app_instance(client_request_token, name)
    create_app_instance(client_request_token, name, params::Dict{String,<:Any})

Creates an Amazon Chime SDK messaging AppInstance under an AWS account. Only SDK messaging
customers use this API. CreateAppInstance supports idempotency behavior as described in the
AWS API Standard. identity

# Arguments
- `client_request_token`: The unique ID of the request. Use different tokens to create
  different AppInstances.
- `name`: The name of the AppInstance.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Metadata"`: The metadata of the AppInstance. Limited to a 1KB string in UTF-8.
- `"Tags"`: Tags assigned to the AppInstance.
"""
function create_app_instance(
    ClientRequestToken, Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_identity(
        "POST",
        "/app-instances",
        Dict{String,Any}("ClientRequestToken" => ClientRequestToken, "Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_app_instance(
    ClientRequestToken,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_identity(
        "POST",
        "/app-instances",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClientRequestToken" => ClientRequestToken, "Name" => Name
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_app_instance_admin(app_instance_admin_arn, app_instance_arn)
    create_app_instance_admin(app_instance_admin_arn, app_instance_arn, params::Dict{String,<:Any})

Promotes an AppInstanceUser or AppInstanceBot to an AppInstanceAdmin. The promoted entity
can perform the following actions.     ChannelModerator actions across all channels in the
AppInstance.    DeleteChannelMessage actions.   Only an AppInstanceUser and AppInstanceBot
can be promoted to an AppInstanceAdmin role.

# Arguments
- `app_instance_admin_arn`: The ARN of the administrator of the current AppInstance.
- `app_instance_arn`: The ARN of the AppInstance.

"""
function create_app_instance_admin(
    AppInstanceAdminArn, appInstanceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_identity(
        "POST",
        "/app-instances/$(appInstanceArn)/admins",
        Dict{String,Any}("AppInstanceAdminArn" => AppInstanceAdminArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_app_instance_admin(
    AppInstanceAdminArn,
    appInstanceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_identity(
        "POST",
        "/app-instances/$(appInstanceArn)/admins",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("AppInstanceAdminArn" => AppInstanceAdminArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_app_instance_bot(app_instance_arn, client_request_token, configuration)
    create_app_instance_bot(app_instance_arn, client_request_token, configuration, params::Dict{String,<:Any})

Creates a bot under an Amazon Chime AppInstance. The request consists of a unique
Configuration and Name for that bot.

# Arguments
- `app_instance_arn`: The ARN of the AppInstance request.
- `client_request_token`: The unique ID for the client making the request. Use different
  tokens for different AppInstanceBots.
- `configuration`: Configuration information about the Amazon Lex V2 V2 bot.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Metadata"`: The request metadata. Limited to a 1KB string in UTF-8.
- `"Name"`: The user's name.
- `"Tags"`: The tags assigned to the AppInstanceBot.
"""
function create_app_instance_bot(
    AppInstanceArn,
    ClientRequestToken,
    Configuration;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_identity(
        "POST",
        "/app-instance-bots",
        Dict{String,Any}(
            "AppInstanceArn" => AppInstanceArn,
            "ClientRequestToken" => ClientRequestToken,
            "Configuration" => Configuration,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_app_instance_bot(
    AppInstanceArn,
    ClientRequestToken,
    Configuration,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_identity(
        "POST",
        "/app-instance-bots",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AppInstanceArn" => AppInstanceArn,
                    "ClientRequestToken" => ClientRequestToken,
                    "Configuration" => Configuration,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_app_instance_user(app_instance_arn, app_instance_user_id, client_request_token, name)
    create_app_instance_user(app_instance_arn, app_instance_user_id, client_request_token, name, params::Dict{String,<:Any})

Creates a user under an Amazon Chime AppInstance. The request consists of a unique
appInstanceUserId and Name for that user.

# Arguments
- `app_instance_arn`: The ARN of the AppInstance request.
- `app_instance_user_id`: The user ID of the AppInstance.
- `client_request_token`: The unique ID of the request. Use different tokens to request
  additional AppInstances.
- `name`: The user's name.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ExpirationSettings"`: Settings that control the interval after which the
  AppInstanceUser is automatically deleted.
- `"Metadata"`: The request's metadata. Limited to a 1KB string in UTF-8.
- `"Tags"`: Tags assigned to the AppInstanceUser.
"""
function create_app_instance_user(
    AppInstanceArn,
    AppInstanceUserId,
    ClientRequestToken,
    Name;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_identity(
        "POST",
        "/app-instance-users",
        Dict{String,Any}(
            "AppInstanceArn" => AppInstanceArn,
            "AppInstanceUserId" => AppInstanceUserId,
            "ClientRequestToken" => ClientRequestToken,
            "Name" => Name,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_app_instance_user(
    AppInstanceArn,
    AppInstanceUserId,
    ClientRequestToken,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_identity(
        "POST",
        "/app-instance-users",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AppInstanceArn" => AppInstanceArn,
                    "AppInstanceUserId" => AppInstanceUserId,
                    "ClientRequestToken" => ClientRequestToken,
                    "Name" => Name,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_app_instance(app_instance_arn)
    delete_app_instance(app_instance_arn, params::Dict{String,<:Any})

Deletes an AppInstance and all associated data asynchronously.

# Arguments
- `app_instance_arn`: The ARN of the AppInstance.

"""
function delete_app_instance(
    appInstanceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_identity(
        "DELETE",
        "/app-instances/$(appInstanceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_app_instance(
    appInstanceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_identity(
        "DELETE",
        "/app-instances/$(appInstanceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_app_instance_admin(app_instance_admin_arn, app_instance_arn)
    delete_app_instance_admin(app_instance_admin_arn, app_instance_arn, params::Dict{String,<:Any})

Demotes an AppInstanceAdmin to an AppInstanceUser or AppInstanceBot. This action does not
delete the user.

# Arguments
- `app_instance_admin_arn`: The ARN of the AppInstance's administrator.
- `app_instance_arn`: The ARN of the AppInstance.

"""
function delete_app_instance_admin(
    appInstanceAdminArn, appInstanceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_identity(
        "DELETE",
        "/app-instances/$(appInstanceArn)/admins/$(appInstanceAdminArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_app_instance_admin(
    appInstanceAdminArn,
    appInstanceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_identity(
        "DELETE",
        "/app-instances/$(appInstanceArn)/admins/$(appInstanceAdminArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_app_instance_bot(app_instance_bot_arn)
    delete_app_instance_bot(app_instance_bot_arn, params::Dict{String,<:Any})

Deletes an AppInstanceBot.

# Arguments
- `app_instance_bot_arn`: The ARN of the AppInstanceBot being deleted.

"""
function delete_app_instance_bot(
    appInstanceBotArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_identity(
        "DELETE",
        "/app-instance-bots/$(appInstanceBotArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_app_instance_bot(
    appInstanceBotArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_identity(
        "DELETE",
        "/app-instance-bots/$(appInstanceBotArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_app_instance_user(app_instance_user_arn)
    delete_app_instance_user(app_instance_user_arn, params::Dict{String,<:Any})

Deletes an AppInstanceUser.

# Arguments
- `app_instance_user_arn`: The ARN of the user request being deleted.

"""
function delete_app_instance_user(
    appInstanceUserArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_identity(
        "DELETE",
        "/app-instance-users/$(appInstanceUserArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_app_instance_user(
    appInstanceUserArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_identity(
        "DELETE",
        "/app-instance-users/$(appInstanceUserArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    deregister_app_instance_user_endpoint(app_instance_user_arn, endpoint_id)
    deregister_app_instance_user_endpoint(app_instance_user_arn, endpoint_id, params::Dict{String,<:Any})

Deregisters an AppInstanceUserEndpoint.

# Arguments
- `app_instance_user_arn`: The ARN of the AppInstanceUser.
- `endpoint_id`: The unique identifier of the AppInstanceUserEndpoint.

"""
function deregister_app_instance_user_endpoint(
    appInstanceUserArn, endpointId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_identity(
        "DELETE",
        "/app-instance-users/$(appInstanceUserArn)/endpoints/$(endpointId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function deregister_app_instance_user_endpoint(
    appInstanceUserArn,
    endpointId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_identity(
        "DELETE",
        "/app-instance-users/$(appInstanceUserArn)/endpoints/$(endpointId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_app_instance(app_instance_arn)
    describe_app_instance(app_instance_arn, params::Dict{String,<:Any})

Returns the full details of an AppInstance.

# Arguments
- `app_instance_arn`: The ARN of the AppInstance.

"""
function describe_app_instance(
    appInstanceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_identity(
        "GET",
        "/app-instances/$(appInstanceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_app_instance(
    appInstanceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_identity(
        "GET",
        "/app-instances/$(appInstanceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_app_instance_admin(app_instance_admin_arn, app_instance_arn)
    describe_app_instance_admin(app_instance_admin_arn, app_instance_arn, params::Dict{String,<:Any})

Returns the full details of an AppInstanceAdmin.

# Arguments
- `app_instance_admin_arn`: The ARN of the AppInstanceAdmin.
- `app_instance_arn`: The ARN of the AppInstance.

"""
function describe_app_instance_admin(
    appInstanceAdminArn, appInstanceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_identity(
        "GET",
        "/app-instances/$(appInstanceArn)/admins/$(appInstanceAdminArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_app_instance_admin(
    appInstanceAdminArn,
    appInstanceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_identity(
        "GET",
        "/app-instances/$(appInstanceArn)/admins/$(appInstanceAdminArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_app_instance_bot(app_instance_bot_arn)
    describe_app_instance_bot(app_instance_bot_arn, params::Dict{String,<:Any})

The AppInstanceBot's information.

# Arguments
- `app_instance_bot_arn`: The ARN of the AppInstanceBot.

"""
function describe_app_instance_bot(
    appInstanceBotArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_identity(
        "GET",
        "/app-instance-bots/$(appInstanceBotArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_app_instance_bot(
    appInstanceBotArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_identity(
        "GET",
        "/app-instance-bots/$(appInstanceBotArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_app_instance_user(app_instance_user_arn)
    describe_app_instance_user(app_instance_user_arn, params::Dict{String,<:Any})

Returns the full details of an AppInstanceUser.

# Arguments
- `app_instance_user_arn`: The ARN of the AppInstanceUser.

"""
function describe_app_instance_user(
    appInstanceUserArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_identity(
        "GET",
        "/app-instance-users/$(appInstanceUserArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_app_instance_user(
    appInstanceUserArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_identity(
        "GET",
        "/app-instance-users/$(appInstanceUserArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_app_instance_user_endpoint(app_instance_user_arn, endpoint_id)
    describe_app_instance_user_endpoint(app_instance_user_arn, endpoint_id, params::Dict{String,<:Any})

Returns the full details of an AppInstanceUserEndpoint.

# Arguments
- `app_instance_user_arn`: The ARN of the AppInstanceUser.
- `endpoint_id`: The unique identifier of the AppInstanceUserEndpoint.

"""
function describe_app_instance_user_endpoint(
    appInstanceUserArn, endpointId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_identity(
        "GET",
        "/app-instance-users/$(appInstanceUserArn)/endpoints/$(endpointId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_app_instance_user_endpoint(
    appInstanceUserArn,
    endpointId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_identity(
        "GET",
        "/app-instance-users/$(appInstanceUserArn)/endpoints/$(endpointId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_app_instance_retention_settings(app_instance_arn)
    get_app_instance_retention_settings(app_instance_arn, params::Dict{String,<:Any})

Gets the retention settings for an AppInstance.

# Arguments
- `app_instance_arn`: The ARN of the AppInstance.

"""
function get_app_instance_retention_settings(
    appInstanceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_identity(
        "GET",
        "/app-instances/$(appInstanceArn)/retention-settings";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_app_instance_retention_settings(
    appInstanceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_identity(
        "GET",
        "/app-instances/$(appInstanceArn)/retention-settings",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_app_instance_admins(app_instance_arn)
    list_app_instance_admins(app_instance_arn, params::Dict{String,<:Any})

Returns a list of the administrators in the AppInstance.

# Arguments
- `app_instance_arn`: The ARN of the AppInstance.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"max-results"`: The maximum number of administrators that you want to return.
- `"next-token"`: The token returned from previous API requests until the number of
  administrators is reached.
"""
function list_app_instance_admins(
    appInstanceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_identity(
        "GET",
        "/app-instances/$(appInstanceArn)/admins";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_app_instance_admins(
    appInstanceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_identity(
        "GET",
        "/app-instances/$(appInstanceArn)/admins",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_app_instance_bots(app-instance-arn)
    list_app_instance_bots(app-instance-arn, params::Dict{String,<:Any})

Lists all AppInstanceBots created under a single AppInstance.

# Arguments
- `app-instance-arn`: The ARN of the AppInstance.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"max-results"`: The maximum number of requests to return.
- `"next-token"`: The token passed by previous API calls until all requested bots are
  returned.
"""
function list_app_instance_bots(
    app_instance_arn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_identity(
        "GET",
        "/app-instance-bots",
        Dict{String,Any}("app-instance-arn" => app_instance_arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_app_instance_bots(
    app_instance_arn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_identity(
        "GET",
        "/app-instance-bots",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("app-instance-arn" => app_instance_arn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_app_instance_user_endpoints(app_instance_user_arn)
    list_app_instance_user_endpoints(app_instance_user_arn, params::Dict{String,<:Any})

Lists all the AppInstanceUserEndpoints created under a single AppInstanceUser.

# Arguments
- `app_instance_user_arn`: The ARN of the AppInstanceUser.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"max-results"`: The maximum number of endpoints that you want to return.
- `"next-token"`: The token passed by previous API calls until all requested endpoints are
  returned.
"""
function list_app_instance_user_endpoints(
    appInstanceUserArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_identity(
        "GET",
        "/app-instance-users/$(appInstanceUserArn)/endpoints";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_app_instance_user_endpoints(
    appInstanceUserArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_identity(
        "GET",
        "/app-instance-users/$(appInstanceUserArn)/endpoints",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_app_instance_users(app-instance-arn)
    list_app_instance_users(app-instance-arn, params::Dict{String,<:Any})

List all AppInstanceUsers created under a single AppInstance.

# Arguments
- `app-instance-arn`: The ARN of the AppInstance.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"max-results"`: The maximum number of requests that you want returned.
- `"next-token"`: The token passed by previous API calls until all requested users are
  returned.
"""
function list_app_instance_users(
    app_instance_arn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_identity(
        "GET",
        "/app-instance-users",
        Dict{String,Any}("app-instance-arn" => app_instance_arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_app_instance_users(
    app_instance_arn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_identity(
        "GET",
        "/app-instance-users",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("app-instance-arn" => app_instance_arn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_app_instances()
    list_app_instances(params::Dict{String,<:Any})

Lists all Amazon Chime AppInstances created under a single AWS account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"max-results"`: The maximum number of AppInstances that you want to return.
- `"next-token"`: The token passed by previous API requests until you reach the maximum
  number of AppInstances.
"""
function list_app_instances(; aws_config::AbstractAWSConfig=current_aws_config())
    return chime_sdk_identity(
        "GET", "/app-instances"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_app_instances(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_identity(
        "GET",
        "/app-instances",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(arn)
    list_tags_for_resource(arn, params::Dict{String,<:Any})

Lists the tags applied to an Amazon Chime SDK identity resource.

# Arguments
- `arn`: The ARN of the resource.

"""
function list_tags_for_resource(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return chime_sdk_identity(
        "GET",
        "/tags",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_identity(
        "GET",
        "/tags",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_app_instance_retention_settings(app_instance_retention_settings, app_instance_arn)
    put_app_instance_retention_settings(app_instance_retention_settings, app_instance_arn, params::Dict{String,<:Any})

Sets the amount of time in days that a given AppInstance retains data.

# Arguments
- `app_instance_retention_settings`: The time in days to retain data. Data type: number.
- `app_instance_arn`: The ARN of the AppInstance.

"""
function put_app_instance_retention_settings(
    AppInstanceRetentionSettings,
    appInstanceArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_identity(
        "PUT",
        "/app-instances/$(appInstanceArn)/retention-settings",
        Dict{String,Any}("AppInstanceRetentionSettings" => AppInstanceRetentionSettings);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_app_instance_retention_settings(
    AppInstanceRetentionSettings,
    appInstanceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_identity(
        "PUT",
        "/app-instances/$(appInstanceArn)/retention-settings",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AppInstanceRetentionSettings" => AppInstanceRetentionSettings
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_app_instance_user_expiration_settings(app_instance_user_arn)
    put_app_instance_user_expiration_settings(app_instance_user_arn, params::Dict{String,<:Any})

Sets the number of days before the AppInstanceUser is automatically deleted.  A background
process deletes expired AppInstanceUsers within 6 hours of expiration. Actual deletion
times may vary. Expired AppInstanceUsers that have not yet been deleted appear as active,
and you can update their expiration settings. The system honors the new settings.

# Arguments
- `app_instance_user_arn`: The ARN of the AppInstanceUser.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ExpirationSettings"`: Settings that control the interval after which an AppInstanceUser
  is automatically deleted.
"""
function put_app_instance_user_expiration_settings(
    appInstanceUserArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_identity(
        "PUT",
        "/app-instance-users/$(appInstanceUserArn)/expiration-settings";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_app_instance_user_expiration_settings(
    appInstanceUserArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_identity(
        "PUT",
        "/app-instance-users/$(appInstanceUserArn)/expiration-settings",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    register_app_instance_user_endpoint(client_request_token, endpoint_attributes, resource_arn, type, app_instance_user_arn)
    register_app_instance_user_endpoint(client_request_token, endpoint_attributes, resource_arn, type, app_instance_user_arn, params::Dict{String,<:Any})

Registers an endpoint under an Amazon Chime AppInstanceUser. The endpoint receives messages
for a user. For push notifications, the endpoint is a mobile device used to receive mobile
push notifications for a user.

# Arguments
- `client_request_token`: The unique ID assigned to the request. Use different tokens to
  register other endpoints.
- `endpoint_attributes`: The attributes of an Endpoint.
- `resource_arn`: The ARN of the resource to which the endpoint belongs.
- `type`: The type of the AppInstanceUserEndpoint. Supported types:    APNS: The mobile
  notification service for an Apple device.    APNS_SANDBOX: The sandbox environment of the
  mobile notification service for an Apple device.    GCM: The mobile notification service
  for an Android device.   Populate the ResourceArn value of each type as PinpointAppArn.
- `app_instance_user_arn`: The ARN of the AppInstanceUser.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AllowMessages"`: Boolean that controls whether the AppInstanceUserEndpoint is opted in
  to receive messages. ALL indicates the endpoint receives all messages. NONE indicates the
  endpoint receives no messages.
- `"Name"`: The name of the AppInstanceUserEndpoint.
"""
function register_app_instance_user_endpoint(
    ClientRequestToken,
    EndpointAttributes,
    ResourceArn,
    Type,
    appInstanceUserArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_identity(
        "POST",
        "/app-instance-users/$(appInstanceUserArn)/endpoints",
        Dict{String,Any}(
            "ClientRequestToken" => ClientRequestToken,
            "EndpointAttributes" => EndpointAttributes,
            "ResourceArn" => ResourceArn,
            "Type" => Type,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function register_app_instance_user_endpoint(
    ClientRequestToken,
    EndpointAttributes,
    ResourceArn,
    Type,
    appInstanceUserArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_identity(
        "POST",
        "/app-instance-users/$(appInstanceUserArn)/endpoints",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClientRequestToken" => ClientRequestToken,
                    "EndpointAttributes" => EndpointAttributes,
                    "ResourceArn" => ResourceArn,
                    "Type" => Type,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Applies the specified tags to the specified Amazon Chime SDK identity resource.

# Arguments
- `resource_arn`: The resource ARN.
- `tags`: The tag key-value pairs.

"""
function tag_resource(ResourceARN, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return chime_sdk_identity(
        "POST",
        "/tags?operation=tag-resource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceARN,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_identity(
        "POST",
        "/tags?operation=tag-resource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes the specified tags from the specified Amazon Chime SDK identity resource.

# Arguments
- `resource_arn`: The resource ARN.
- `tag_keys`: The tag keys.

"""
function untag_resource(
    ResourceARN, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_identity(
        "POST",
        "/tags?operation=untag-resource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceARN,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_identity(
        "POST",
        "/tags?operation=untag-resource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_app_instance(metadata, name, app_instance_arn)
    update_app_instance(metadata, name, app_instance_arn, params::Dict{String,<:Any})

Updates AppInstance metadata.

# Arguments
- `metadata`: The metadata that you want to change.
- `name`: The name that you want to change.
- `app_instance_arn`: The ARN of the AppInstance.

"""
function update_app_instance(
    Metadata, Name, appInstanceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_identity(
        "PUT",
        "/app-instances/$(appInstanceArn)",
        Dict{String,Any}("Metadata" => Metadata, "Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_app_instance(
    Metadata,
    Name,
    appInstanceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_identity(
        "PUT",
        "/app-instances/$(appInstanceArn)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("Metadata" => Metadata, "Name" => Name), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_app_instance_bot(metadata, name, app_instance_bot_arn)
    update_app_instance_bot(metadata, name, app_instance_bot_arn, params::Dict{String,<:Any})

Updates the name and metadata of an AppInstanceBot.

# Arguments
- `metadata`: The metadata of the AppInstanceBot.
- `name`: The name of the AppInstanceBot.
- `app_instance_bot_arn`: The ARN of the AppInstanceBot.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Configuration"`: The configuration for the bot update.
"""
function update_app_instance_bot(
    Metadata, Name, appInstanceBotArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_identity(
        "PUT",
        "/app-instance-bots/$(appInstanceBotArn)",
        Dict{String,Any}("Metadata" => Metadata, "Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_app_instance_bot(
    Metadata,
    Name,
    appInstanceBotArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_identity(
        "PUT",
        "/app-instance-bots/$(appInstanceBotArn)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("Metadata" => Metadata, "Name" => Name), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_app_instance_user(metadata, name, app_instance_user_arn)
    update_app_instance_user(metadata, name, app_instance_user_arn, params::Dict{String,<:Any})

Updates the details of an AppInstanceUser. You can update names and metadata.

# Arguments
- `metadata`: The metadata of the AppInstanceUser.
- `name`: The name of the AppInstanceUser.
- `app_instance_user_arn`: The ARN of the AppInstanceUser.

"""
function update_app_instance_user(
    Metadata, Name, appInstanceUserArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_identity(
        "PUT",
        "/app-instance-users/$(appInstanceUserArn)",
        Dict{String,Any}("Metadata" => Metadata, "Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_app_instance_user(
    Metadata,
    Name,
    appInstanceUserArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_identity(
        "PUT",
        "/app-instance-users/$(appInstanceUserArn)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("Metadata" => Metadata, "Name" => Name), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_app_instance_user_endpoint(app_instance_user_arn, endpoint_id)
    update_app_instance_user_endpoint(app_instance_user_arn, endpoint_id, params::Dict{String,<:Any})

Updates the details of an AppInstanceUserEndpoint. You can update the name and AllowMessage
values.

# Arguments
- `app_instance_user_arn`: The ARN of the AppInstanceUser.
- `endpoint_id`: The unique identifier of the AppInstanceUserEndpoint.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AllowMessages"`: Boolean that controls whether the AppInstanceUserEndpoint is opted in
  to receive messages. ALL indicates the endpoint will receive all messages. NONE indicates
  the endpoint will receive no messages.
- `"Name"`: The name of the AppInstanceUserEndpoint.
"""
function update_app_instance_user_endpoint(
    appInstanceUserArn, endpointId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_identity(
        "PUT",
        "/app-instance-users/$(appInstanceUserArn)/endpoints/$(endpointId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_app_instance_user_endpoint(
    appInstanceUserArn,
    endpointId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_identity(
        "PUT",
        "/app-instance-users/$(appInstanceUserArn)/endpoints/$(endpointId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: customer_profiles
using AWS.Compat
using AWS.UUIDs

"""
    add_profile_key(domain_name, key_name, profile_id, values)
    add_profile_key(domain_name, key_name, profile_id, values, params::Dict{String,<:Any})

Associates a new key value with a specific profile, such as a Contact Record ContactId. A
profile object can have a single unique key and any number of additional keys that can be
used to identify the profile that it belongs to.

# Arguments
- `domain_name`: The unique name of the domain.
- `key_name`: A searchable identifier of a customer profile. The predefined keys you can
  use include: _account, _profileId, _assetId, _caseId, _orderId, _fullName, _phone, _email,
  _ctrContactId, _marketoLeadId, _salesforceAccountId, _salesforceContactId,
  _salesforceAssetId, _zendeskUserId, _zendeskExternalId, _zendeskTicketId,
  _serviceNowSystemId, _serviceNowIncidentId, _segmentUserId, _shopifyCustomerId,
  _shopifyOrderId.
- `profile_id`: The unique identifier of a customer profile.
- `values`: A list of key values.

"""
function add_profile_key(
    DomainName,
    KeyName,
    ProfileId,
    Values;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "POST",
        "/domains/$(DomainName)/profiles/keys",
        Dict{String,Any}(
            "KeyName" => KeyName, "ProfileId" => ProfileId, "Values" => Values
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_profile_key(
    DomainName,
    KeyName,
    ProfileId,
    Values,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "POST",
        "/domains/$(DomainName)/profiles/keys",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "KeyName" => KeyName, "ProfileId" => ProfileId, "Values" => Values
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_calculated_attribute_definition(attribute_details, calculated_attribute_name, domain_name, statistic)
    create_calculated_attribute_definition(attribute_details, calculated_attribute_name, domain_name, statistic, params::Dict{String,<:Any})

Creates a new calculated attribute definition. After creation, new object data ingested
into Customer Profiles will be included in the calculated attribute, which can be retrieved
for a profile using the GetCalculatedAttributeForProfile API. Defining a calculated
attribute makes it available for all profiles within a domain. Each calculated attribute
can only reference one ObjectType and at most, two fields from that ObjectType.

# Arguments
- `attribute_details`: Mathematical expression and a list of attribute items specified in
  that expression.
- `calculated_attribute_name`: The unique name of the calculated attribute.
- `domain_name`: The unique name of the domain.
- `statistic`: The aggregation operation to perform for the calculated attribute.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Conditions"`: The conditions including range, object count, and threshold for the
  calculated attribute.
- `"Description"`: The description of the calculated attribute.
- `"DisplayName"`: The display name of the calculated attribute.
- `"Tags"`: The tags used to organize, track, or control access for this resource.
"""
function create_calculated_attribute_definition(
    AttributeDetails,
    CalculatedAttributeName,
    DomainName,
    Statistic;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "POST",
        "/domains/$(DomainName)/calculated-attributes/$(CalculatedAttributeName)",
        Dict{String,Any}("AttributeDetails" => AttributeDetails, "Statistic" => Statistic);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_calculated_attribute_definition(
    AttributeDetails,
    CalculatedAttributeName,
    DomainName,
    Statistic,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "POST",
        "/domains/$(DomainName)/calculated-attributes/$(CalculatedAttributeName)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AttributeDetails" => AttributeDetails, "Statistic" => Statistic
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_domain(default_expiration_days, domain_name)
    create_domain(default_expiration_days, domain_name, params::Dict{String,<:Any})

Creates a domain, which is a container for all customer data, such as customer profile
attributes, object types, profile keys, and encryption keys. You can create multiple
domains, and each domain can have multiple third-party integrations. Each Amazon Connect
instance can be associated with only one domain. Multiple Amazon Connect instances can be
associated with one domain. Use this API or UpdateDomain to enable identity resolution: set
Matching to true. To prevent cross-service impersonation when you call this API, see
Cross-service confused deputy prevention for sample policies that you should apply.   It is
not possible to associate a Customer Profiles domain with an Amazon Connect Instance
directly from the API. If you would like to create a domain and associate a Customer
Profiles domain, use the Amazon Connect admin website. For more information, see Enable
Customer Profiles. Each Amazon Connect instance can be associated with only one domain.
Multiple Amazon Connect instances can be associated with one domain.

# Arguments
- `default_expiration_days`: The default number of days until the data within the domain
  expires.
- `domain_name`: The unique name of the domain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DeadLetterQueueUrl"`: The URL of the SQS dead letter queue, which is used for reporting
  errors associated with ingesting data from third party applications. You must set up a
  policy on the DeadLetterQueue for the SendMessage operation to enable Amazon Connect
  Customer Profiles to send messages to the DeadLetterQueue.
- `"DefaultEncryptionKey"`: The default encryption key, which is an AWS managed key, is
  used when no specific type of encryption key is specified. It is used to encrypt all data
  before it is placed in permanent or semi-permanent storage.
- `"Matching"`: The process of matching duplicate profiles. If Matching = true, Amazon
  Connect Customer Profiles starts a weekly batch process called Identity Resolution Job. If
  you do not specify a date and time for Identity Resolution Job to run, by default it runs
  every Saturday at 12AM UTC to detect duplicate profiles in your domains.  After the
  Identity Resolution Job completes, use the GetMatches API to return and review the results.
  Or, if you have configured ExportingConfig in the MatchingRequest, you can download the
  results from S3.
- `"RuleBasedMatching"`: The process of matching duplicate profiles using the Rule-Based
  matching. If RuleBasedMatching = true, Amazon Connect Customer Profiles will start to match
  and merge your profiles according to your configuration in the RuleBasedMatchingRequest.
  You can use the ListRuleBasedMatches and GetSimilarProfiles API to return and review the
  results. Also, if you have configured ExportingConfig in the RuleBasedMatchingRequest, you
  can download the results from S3.
- `"Tags"`: The tags used to organize, track, or control access for this resource.
"""
function create_domain(
    DefaultExpirationDays, DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return customer_profiles(
        "POST",
        "/domains/$(DomainName)",
        Dict{String,Any}("DefaultExpirationDays" => DefaultExpirationDays);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_domain(
    DefaultExpirationDays,
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "POST",
        "/domains/$(DomainName)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DefaultExpirationDays" => DefaultExpirationDays),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_event_stream(domain_name, event_stream_name, uri)
    create_event_stream(domain_name, event_stream_name, uri, params::Dict{String,<:Any})

Creates an event stream, which is a subscription to real-time events, such as when profiles
are created and updated through Amazon Connect Customer Profiles. Each event stream can be
associated with only one Kinesis Data Stream destination in the same region and Amazon Web
Services account as the customer profiles domain

# Arguments
- `domain_name`: The unique name of the domain.
- `event_stream_name`: The name of the event stream.
- `uri`: The StreamARN of the destination to deliver profile events to. For example,
  arn:aws:kinesis:region:account-id:stream/stream-name

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: The tags used to organize, track, or control access for this resource.
"""
function create_event_stream(
    DomainName, EventStreamName, Uri; aws_config::AbstractAWSConfig=current_aws_config()
)
    return customer_profiles(
        "POST",
        "/domains/$(DomainName)/event-streams/$(EventStreamName)",
        Dict{String,Any}("Uri" => Uri);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_event_stream(
    DomainName,
    EventStreamName,
    Uri,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "POST",
        "/domains/$(DomainName)/event-streams/$(EventStreamName)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Uri" => Uri), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_integration_workflow(domain_name, integration_config, object_type_name, role_arn, workflow_type)
    create_integration_workflow(domain_name, integration_config, object_type_name, role_arn, workflow_type, params::Dict{String,<:Any})

 Creates an integration workflow. An integration workflow is an async process which ingests
historic data and sets up an integration for ongoing updates. The supported Amazon AppFlow
sources are Salesforce, ServiceNow, and Marketo.

# Arguments
- `domain_name`: The unique name of the domain.
- `integration_config`: Configuration data for integration workflow.
- `object_type_name`: The name of the profile object type.
- `role_arn`: The Amazon Resource Name (ARN) of the IAM role. Customer Profiles assumes
  this role to create resources on your behalf as part of workflow execution.
- `workflow_type`: The type of workflow. The only supported value is APPFLOW_INTEGRATION.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: The tags used to organize, track, or control access for this resource.
"""
function create_integration_workflow(
    DomainName,
    IntegrationConfig,
    ObjectTypeName,
    RoleArn,
    WorkflowType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "POST",
        "/domains/$(DomainName)/workflows/integrations",
        Dict{String,Any}(
            "IntegrationConfig" => IntegrationConfig,
            "ObjectTypeName" => ObjectTypeName,
            "RoleArn" => RoleArn,
            "WorkflowType" => WorkflowType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_integration_workflow(
    DomainName,
    IntegrationConfig,
    ObjectTypeName,
    RoleArn,
    WorkflowType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "POST",
        "/domains/$(DomainName)/workflows/integrations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "IntegrationConfig" => IntegrationConfig,
                    "ObjectTypeName" => ObjectTypeName,
                    "RoleArn" => RoleArn,
                    "WorkflowType" => WorkflowType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_profile(domain_name)
    create_profile(domain_name, params::Dict{String,<:Any})

Creates a standard profile. A standard profile represents the following attributes for a
customer profile in a domain.

# Arguments
- `domain_name`: The unique name of the domain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccountNumber"`: An account number that you have given to the customer.
- `"AdditionalInformation"`: Any additional information relevant to the customer’s
  profile.
- `"Address"`: A generic address associated with the customer that is not mailing,
  shipping, or billing.
- `"Attributes"`: A key value pair of attributes of a customer profile.
- `"BillingAddress"`: The customer’s billing address.
- `"BirthDate"`: The customer’s birth date.
- `"BusinessEmailAddress"`: The customer’s business email address.
- `"BusinessName"`: The name of the customer’s business.
- `"BusinessPhoneNumber"`: The customer’s business phone number.
- `"EmailAddress"`: The customer’s email address, which has not been specified as a
  personal or business address.
- `"FirstName"`: The customer’s first name.
- `"Gender"`: The gender with which the customer identifies.
- `"GenderString"`: An alternative to Gender which accepts any string as input.
- `"HomePhoneNumber"`: The customer’s home phone number.
- `"LastName"`: The customer’s last name.
- `"MailingAddress"`: The customer’s mailing address.
- `"MiddleName"`: The customer’s middle name.
- `"MobilePhoneNumber"`: The customer’s mobile phone number.
- `"PartyType"`: The type of profile used to describe the customer.
- `"PartyTypeString"`: An alternative to PartyType which accepts any string as input.
- `"PersonalEmailAddress"`: The customer’s personal email address.
- `"PhoneNumber"`: The customer’s phone number, which has not been specified as a mobile,
  home, or business number.
- `"ShippingAddress"`: The customer’s shipping address.
"""
function create_profile(DomainName; aws_config::AbstractAWSConfig=current_aws_config())
    return customer_profiles(
        "POST",
        "/domains/$(DomainName)/profiles";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_profile(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "POST",
        "/domains/$(DomainName)/profiles",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_calculated_attribute_definition(calculated_attribute_name, domain_name)
    delete_calculated_attribute_definition(calculated_attribute_name, domain_name, params::Dict{String,<:Any})

Deletes an existing calculated attribute definition. Note that deleting a default
calculated attribute is possible, however once deleted, you will be unable to undo that
action and will need to recreate it on your own using the
CreateCalculatedAttributeDefinition API if you want it back.

# Arguments
- `calculated_attribute_name`: The unique name of the calculated attribute.
- `domain_name`: The unique name of the domain.

"""
function delete_calculated_attribute_definition(
    CalculatedAttributeName, DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return customer_profiles(
        "DELETE",
        "/domains/$(DomainName)/calculated-attributes/$(CalculatedAttributeName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_calculated_attribute_definition(
    CalculatedAttributeName,
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "DELETE",
        "/domains/$(DomainName)/calculated-attributes/$(CalculatedAttributeName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_domain(domain_name)
    delete_domain(domain_name, params::Dict{String,<:Any})

Deletes a specific domain and all of its customer data, such as customer profile attributes
and their related objects.

# Arguments
- `domain_name`: The unique name of the domain.

"""
function delete_domain(DomainName; aws_config::AbstractAWSConfig=current_aws_config())
    return customer_profiles(
        "DELETE",
        "/domains/$(DomainName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_domain(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "DELETE",
        "/domains/$(DomainName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_event_stream(domain_name, event_stream_name)
    delete_event_stream(domain_name, event_stream_name, params::Dict{String,<:Any})

Disables and deletes the specified event stream.

# Arguments
- `domain_name`: The unique name of the domain.
- `event_stream_name`: The name of the event stream

"""
function delete_event_stream(
    DomainName, EventStreamName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return customer_profiles(
        "DELETE",
        "/domains/$(DomainName)/event-streams/$(EventStreamName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_event_stream(
    DomainName,
    EventStreamName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "DELETE",
        "/domains/$(DomainName)/event-streams/$(EventStreamName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_integration(domain_name, uri)
    delete_integration(domain_name, uri, params::Dict{String,<:Any})

Removes an integration from a specific domain.

# Arguments
- `domain_name`: The unique name of the domain.
- `uri`: The URI of the S3 bucket or any other type of data source.

"""
function delete_integration(
    DomainName, Uri; aws_config::AbstractAWSConfig=current_aws_config()
)
    return customer_profiles(
        "POST",
        "/domains/$(DomainName)/integrations/delete",
        Dict{String,Any}("Uri" => Uri);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_integration(
    DomainName,
    Uri,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "POST",
        "/domains/$(DomainName)/integrations/delete",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Uri" => Uri), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_profile(domain_name, profile_id)
    delete_profile(domain_name, profile_id, params::Dict{String,<:Any})

Deletes the standard customer profile and all data pertaining to the profile.

# Arguments
- `domain_name`: The unique name of the domain.
- `profile_id`: The unique identifier of a customer profile.

"""
function delete_profile(
    DomainName, ProfileId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return customer_profiles(
        "POST",
        "/domains/$(DomainName)/profiles/delete",
        Dict{String,Any}("ProfileId" => ProfileId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_profile(
    DomainName,
    ProfileId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "POST",
        "/domains/$(DomainName)/profiles/delete",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ProfileId" => ProfileId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_profile_key(domain_name, key_name, profile_id, values)
    delete_profile_key(domain_name, key_name, profile_id, values, params::Dict{String,<:Any})

Removes a searchable key from a customer profile.

# Arguments
- `domain_name`: The unique name of the domain.
- `key_name`: A searchable identifier of a customer profile.
- `profile_id`: The unique identifier of a customer profile.
- `values`: A list of key values.

"""
function delete_profile_key(
    DomainName,
    KeyName,
    ProfileId,
    Values;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "POST",
        "/domains/$(DomainName)/profiles/keys/delete",
        Dict{String,Any}(
            "KeyName" => KeyName, "ProfileId" => ProfileId, "Values" => Values
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_profile_key(
    DomainName,
    KeyName,
    ProfileId,
    Values,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "POST",
        "/domains/$(DomainName)/profiles/keys/delete",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "KeyName" => KeyName, "ProfileId" => ProfileId, "Values" => Values
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_profile_object(domain_name, object_type_name, profile_id, profile_object_unique_key)
    delete_profile_object(domain_name, object_type_name, profile_id, profile_object_unique_key, params::Dict{String,<:Any})

Removes an object associated with a profile of a given ProfileObjectType.

# Arguments
- `domain_name`: The unique name of the domain.
- `object_type_name`: The name of the profile object type.
- `profile_id`: The unique identifier of a customer profile.
- `profile_object_unique_key`: The unique identifier of the profile object generated by the
  service.

"""
function delete_profile_object(
    DomainName,
    ObjectTypeName,
    ProfileId,
    ProfileObjectUniqueKey;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "POST",
        "/domains/$(DomainName)/profiles/objects/delete",
        Dict{String,Any}(
            "ObjectTypeName" => ObjectTypeName,
            "ProfileId" => ProfileId,
            "ProfileObjectUniqueKey" => ProfileObjectUniqueKey,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_profile_object(
    DomainName,
    ObjectTypeName,
    ProfileId,
    ProfileObjectUniqueKey,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "POST",
        "/domains/$(DomainName)/profiles/objects/delete",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ObjectTypeName" => ObjectTypeName,
                    "ProfileId" => ProfileId,
                    "ProfileObjectUniqueKey" => ProfileObjectUniqueKey,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_profile_object_type(domain_name, object_type_name)
    delete_profile_object_type(domain_name, object_type_name, params::Dict{String,<:Any})

Removes a ProfileObjectType from a specific domain as well as removes all the
ProfileObjects of that type. It also disables integrations from this specific
ProfileObjectType. In addition, it scrubs all of the fields of the standard profile that
were populated from this ProfileObjectType.

# Arguments
- `domain_name`: The unique name of the domain.
- `object_type_name`: The name of the profile object type.

"""
function delete_profile_object_type(
    DomainName, ObjectTypeName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return customer_profiles(
        "DELETE",
        "/domains/$(DomainName)/object-types/$(ObjectTypeName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_profile_object_type(
    DomainName,
    ObjectTypeName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "DELETE",
        "/domains/$(DomainName)/object-types/$(ObjectTypeName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_workflow(domain_name, workflow_id)
    delete_workflow(domain_name, workflow_id, params::Dict{String,<:Any})

Deletes the specified workflow and all its corresponding resources. This is an async
process.

# Arguments
- `domain_name`: The unique name of the domain.
- `workflow_id`: Unique identifier for the workflow.

"""
function delete_workflow(
    DomainName, WorkflowId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return customer_profiles(
        "DELETE",
        "/domains/$(DomainName)/workflows/$(WorkflowId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_workflow(
    DomainName,
    WorkflowId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "DELETE",
        "/domains/$(DomainName)/workflows/$(WorkflowId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    detect_profile_object_type(domain_name, objects)
    detect_profile_object_type(domain_name, objects, params::Dict{String,<:Any})

The process of detecting profile object type mapping by using given objects.

# Arguments
- `domain_name`: The unique name of the domain.
- `objects`: A string that is serialized from a JSON object.

"""
function detect_profile_object_type(
    DomainName, Objects; aws_config::AbstractAWSConfig=current_aws_config()
)
    return customer_profiles(
        "POST",
        "/domains/$(DomainName)/detect/object-types",
        Dict{String,Any}("Objects" => Objects);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function detect_profile_object_type(
    DomainName,
    Objects,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "POST",
        "/domains/$(DomainName)/detect/object-types",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Objects" => Objects), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_auto_merging_preview(conflict_resolution, consolidation, domain_name)
    get_auto_merging_preview(conflict_resolution, consolidation, domain_name, params::Dict{String,<:Any})

Tests the auto-merging settings of your Identity Resolution Job without merging your data.
It randomly selects a sample of matching groups from the existing matching results, and
applies the automerging settings that you provided. You can then view the number of
profiles in the sample, the number of matches, and the number of profiles identified to be
merged. This enables you to evaluate the accuracy of the attributes in your matching list.
You can't view which profiles are matched and would be merged.  We strongly recommend you
use this API to do a dry run of the automerging process before running the Identity
Resolution Job. Include at least two matching attributes. If your matching list includes
too few attributes (such as only FirstName or only LastName), there may be a large number
of matches. This increases the chances of erroneous merges.

# Arguments
- `conflict_resolution`: How the auto-merging process should resolve conflicts between
  different profiles.
- `consolidation`: A list of matching attributes that represent matching criteria.
- `domain_name`: The unique name of the domain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MinAllowedConfidenceScoreForMerging"`: Minimum confidence score required for profiles
  within a matching group to be merged during the auto-merge process.
"""
function get_auto_merging_preview(
    ConflictResolution,
    Consolidation,
    DomainName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "POST",
        "/domains/$(DomainName)/identity-resolution-jobs/auto-merging-preview",
        Dict{String,Any}(
            "ConflictResolution" => ConflictResolution, "Consolidation" => Consolidation
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_auto_merging_preview(
    ConflictResolution,
    Consolidation,
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "POST",
        "/domains/$(DomainName)/identity-resolution-jobs/auto-merging-preview",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ConflictResolution" => ConflictResolution,
                    "Consolidation" => Consolidation,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_calculated_attribute_definition(calculated_attribute_name, domain_name)
    get_calculated_attribute_definition(calculated_attribute_name, domain_name, params::Dict{String,<:Any})

Provides more information on a calculated attribute definition for Customer Profiles.

# Arguments
- `calculated_attribute_name`: The unique name of the calculated attribute.
- `domain_name`: The unique name of the domain.

"""
function get_calculated_attribute_definition(
    CalculatedAttributeName, DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return customer_profiles(
        "GET",
        "/domains/$(DomainName)/calculated-attributes/$(CalculatedAttributeName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_calculated_attribute_definition(
    CalculatedAttributeName,
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "GET",
        "/domains/$(DomainName)/calculated-attributes/$(CalculatedAttributeName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_calculated_attribute_for_profile(calculated_attribute_name, domain_name, profile_id)
    get_calculated_attribute_for_profile(calculated_attribute_name, domain_name, profile_id, params::Dict{String,<:Any})

Retrieve a calculated attribute for a customer profile.

# Arguments
- `calculated_attribute_name`: The unique name of the calculated attribute.
- `domain_name`: The unique name of the domain.
- `profile_id`: The unique identifier of a customer profile.

"""
function get_calculated_attribute_for_profile(
    CalculatedAttributeName,
    DomainName,
    ProfileId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "GET",
        "/domains/$(DomainName)/profile/$(ProfileId)/calculated-attributes/$(CalculatedAttributeName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_calculated_attribute_for_profile(
    CalculatedAttributeName,
    DomainName,
    ProfileId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "GET",
        "/domains/$(DomainName)/profile/$(ProfileId)/calculated-attributes/$(CalculatedAttributeName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_domain(domain_name)
    get_domain(domain_name, params::Dict{String,<:Any})

Returns information about a specific domain.

# Arguments
- `domain_name`: The unique name of the domain.

"""
function get_domain(DomainName; aws_config::AbstractAWSConfig=current_aws_config())
    return customer_profiles(
        "GET",
        "/domains/$(DomainName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_domain(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "GET",
        "/domains/$(DomainName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_event_stream(domain_name, event_stream_name)
    get_event_stream(domain_name, event_stream_name, params::Dict{String,<:Any})

Returns information about the specified event stream in a specific domain.

# Arguments
- `domain_name`: The unique name of the domain.
- `event_stream_name`: The name of the event stream provided during create operations.

"""
function get_event_stream(
    DomainName, EventStreamName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return customer_profiles(
        "GET",
        "/domains/$(DomainName)/event-streams/$(EventStreamName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_event_stream(
    DomainName,
    EventStreamName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "GET",
        "/domains/$(DomainName)/event-streams/$(EventStreamName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_identity_resolution_job(domain_name, job_id)
    get_identity_resolution_job(domain_name, job_id, params::Dict{String,<:Any})

Returns information about an Identity Resolution Job in a specific domain.  Identity
Resolution Jobs are set up using the Amazon Connect admin console. For more information,
see Use Identity Resolution to consolidate similar profiles.

# Arguments
- `domain_name`: The unique name of the domain.
- `job_id`: The unique identifier of the Identity Resolution Job.

"""
function get_identity_resolution_job(
    DomainName, JobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return customer_profiles(
        "GET",
        "/domains/$(DomainName)/identity-resolution-jobs/$(JobId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_identity_resolution_job(
    DomainName,
    JobId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "GET",
        "/domains/$(DomainName)/identity-resolution-jobs/$(JobId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_integration(domain_name, uri)
    get_integration(domain_name, uri, params::Dict{String,<:Any})

Returns an integration for a domain.

# Arguments
- `domain_name`: The unique name of the domain.
- `uri`: The URI of the S3 bucket or any other type of data source.

"""
function get_integration(
    DomainName, Uri; aws_config::AbstractAWSConfig=current_aws_config()
)
    return customer_profiles(
        "POST",
        "/domains/$(DomainName)/integrations",
        Dict{String,Any}("Uri" => Uri);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_integration(
    DomainName,
    Uri,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "POST",
        "/domains/$(DomainName)/integrations",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Uri" => Uri), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_matches(domain_name)
    get_matches(domain_name, params::Dict{String,<:Any})

Before calling this API, use CreateDomain or UpdateDomain to enable identity resolution:
set Matching to true. GetMatches returns potentially matching profiles, based on the
results of the latest run of a machine learning process.   The process of matching
duplicate profiles. If Matching = true, Amazon Connect Customer Profiles starts a weekly
batch process called Identity Resolution Job. If you do not specify a date and time for
Identity Resolution Job to run, by default it runs every Saturday at 12AM UTC to detect
duplicate profiles in your domains.  After the Identity Resolution Job completes, use the
GetMatches API to return and review the results. Or, if you have configured ExportingConfig
in the MatchingRequest, you can download the results from S3.  Amazon Connect uses the
following profile attributes to identify matches:   PhoneNumber   HomePhoneNumber
BusinessPhoneNumber   MobilePhoneNumber   EmailAddress   PersonalEmailAddress
BusinessEmailAddress   FullName   For example, two or more profiles—with spelling
mistakes such as John Doe and Jhn Doe, or different casing email addresses such as
JOHN_DOE@ANYCOMPANY.COM and johndoe@anycompany.com, or different phone number formats such
as 555-010-0000 and +1-555-010-0000—can be detected as belonging to the same customer
John Doe and merged into a unified profile.

# Arguments
- `domain_name`: The unique name of the domain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"max-results"`: The maximum number of results to return per page.
- `"next-token"`: The token for the next set of results. Use the value returned in the
  previous response in the next request to retrieve the next set of results.
"""
function get_matches(DomainName; aws_config::AbstractAWSConfig=current_aws_config())
    return customer_profiles(
        "GET",
        "/domains/$(DomainName)/matches";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_matches(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "GET",
        "/domains/$(DomainName)/matches",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_profile_object_type(domain_name, object_type_name)
    get_profile_object_type(domain_name, object_type_name, params::Dict{String,<:Any})

Returns the object types for a specific domain.

# Arguments
- `domain_name`: The unique name of the domain.
- `object_type_name`: The name of the profile object type.

"""
function get_profile_object_type(
    DomainName, ObjectTypeName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return customer_profiles(
        "GET",
        "/domains/$(DomainName)/object-types/$(ObjectTypeName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_profile_object_type(
    DomainName,
    ObjectTypeName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "GET",
        "/domains/$(DomainName)/object-types/$(ObjectTypeName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_profile_object_type_template(template_id)
    get_profile_object_type_template(template_id, params::Dict{String,<:Any})

Returns the template information for a specific object type. A template is a predefined
ProfileObjectType, such as “Salesforce-Account” or “Salesforce-Contact.” When a
user sends a ProfileObject, using the PutProfileObject API, with an ObjectTypeName that
matches one of the TemplateIds, it uses the mappings from the template.

# Arguments
- `template_id`: A unique identifier for the object template.

"""
function get_profile_object_type_template(
    TemplateId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return customer_profiles(
        "GET",
        "/templates/$(TemplateId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_profile_object_type_template(
    TemplateId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "GET",
        "/templates/$(TemplateId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_similar_profiles(domain_name, match_type, search_key, search_value)
    get_similar_profiles(domain_name, match_type, search_key, search_value, params::Dict{String,<:Any})

Returns a set of profiles that belong to the same matching group using the matchId or
profileId. You can also specify the type of matching that you want for finding similar
profiles using either RULE_BASED_MATCHING or ML_BASED_MATCHING.

# Arguments
- `domain_name`: The unique name of the domain.
- `match_type`: Specify the type of matching to get similar profiles for.
- `search_key`: The string indicating the search key to be used.
- `search_value`: The string based on SearchKey to be searched for similar profiles.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"max-results"`: The maximum number of objects returned per page.
- `"next-token"`: The pagination token from the previous GetSimilarProfiles API call.
"""
function get_similar_profiles(
    DomainName,
    MatchType,
    SearchKey,
    SearchValue;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "POST",
        "/domains/$(DomainName)/matches",
        Dict{String,Any}(
            "MatchType" => MatchType, "SearchKey" => SearchKey, "SearchValue" => SearchValue
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_similar_profiles(
    DomainName,
    MatchType,
    SearchKey,
    SearchValue,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "POST",
        "/domains/$(DomainName)/matches",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "MatchType" => MatchType,
                    "SearchKey" => SearchKey,
                    "SearchValue" => SearchValue,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_workflow(domain_name, workflow_id)
    get_workflow(domain_name, workflow_id, params::Dict{String,<:Any})

Get details of specified workflow.

# Arguments
- `domain_name`: The unique name of the domain.
- `workflow_id`: Unique identifier for the workflow.

"""
function get_workflow(
    DomainName, WorkflowId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return customer_profiles(
        "GET",
        "/domains/$(DomainName)/workflows/$(WorkflowId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_workflow(
    DomainName,
    WorkflowId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "GET",
        "/domains/$(DomainName)/workflows/$(WorkflowId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_workflow_steps(domain_name, workflow_id)
    get_workflow_steps(domain_name, workflow_id, params::Dict{String,<:Any})

Get granular list of steps in workflow.

# Arguments
- `domain_name`: The unique name of the domain.
- `workflow_id`: Unique identifier for the workflow.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"max-results"`: The maximum number of results to return per page.
- `"next-token"`: The token for the next set of results. Use the value returned in the
  previous response in the next request to retrieve the next set of results.
"""
function get_workflow_steps(
    DomainName, WorkflowId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return customer_profiles(
        "GET",
        "/domains/$(DomainName)/workflows/$(WorkflowId)/steps";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_workflow_steps(
    DomainName,
    WorkflowId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "GET",
        "/domains/$(DomainName)/workflows/$(WorkflowId)/steps",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_account_integrations(uri)
    list_account_integrations(uri, params::Dict{String,<:Any})

Lists all of the integrations associated to a specific URI in the AWS account.

# Arguments
- `uri`: The URI of the S3 bucket or any other type of data source.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"include-hidden"`: Boolean to indicate if hidden integration should be returned.
  Defaults to False.
- `"max-results"`: The maximum number of objects returned per page.
- `"next-token"`: The pagination token from the previous ListAccountIntegrations API call.
"""
function list_account_integrations(Uri; aws_config::AbstractAWSConfig=current_aws_config())
    return customer_profiles(
        "POST",
        "/integrations",
        Dict{String,Any}("Uri" => Uri);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_account_integrations(
    Uri, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return customer_profiles(
        "POST",
        "/integrations",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Uri" => Uri), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_calculated_attribute_definitions(domain_name)
    list_calculated_attribute_definitions(domain_name, params::Dict{String,<:Any})

Lists calculated attribute definitions for Customer Profiles

# Arguments
- `domain_name`: The unique name of the domain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"max-results"`: The maximum number of calculated attribute definitions returned per page.
- `"next-token"`: The pagination token from the previous call to
  ListCalculatedAttributeDefinitions.
"""
function list_calculated_attribute_definitions(
    DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return customer_profiles(
        "GET",
        "/domains/$(DomainName)/calculated-attributes";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_calculated_attribute_definitions(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "GET",
        "/domains/$(DomainName)/calculated-attributes",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_calculated_attributes_for_profile(domain_name, profile_id)
    list_calculated_attributes_for_profile(domain_name, profile_id, params::Dict{String,<:Any})

Retrieve a list of calculated attributes for a customer profile.

# Arguments
- `domain_name`: The unique name of the domain.
- `profile_id`: The unique identifier of a customer profile.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"max-results"`: The maximum number of calculated attributes returned per page.
- `"next-token"`: The pagination token from the previous call to
  ListCalculatedAttributesForProfile.
"""
function list_calculated_attributes_for_profile(
    DomainName, ProfileId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return customer_profiles(
        "GET",
        "/domains/$(DomainName)/profile/$(ProfileId)/calculated-attributes";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_calculated_attributes_for_profile(
    DomainName,
    ProfileId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "GET",
        "/domains/$(DomainName)/profile/$(ProfileId)/calculated-attributes",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_domains()
    list_domains(params::Dict{String,<:Any})

Returns a list of all the domains for an AWS account that have been created.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"max-results"`: The maximum number of objects returned per page.
- `"next-token"`: The pagination token from the previous ListDomain API call.
"""
function list_domains(; aws_config::AbstractAWSConfig=current_aws_config())
    return customer_profiles(
        "GET", "/domains"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_domains(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return customer_profiles(
        "GET", "/domains", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_event_streams(domain_name)
    list_event_streams(domain_name, params::Dict{String,<:Any})

Returns a list of all the event streams in a specific domain.

# Arguments
- `domain_name`: The unique name of the domain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"max-results"`: The maximum number of objects returned per page.
- `"next-token"`: Identifies the next page of results to return.
"""
function list_event_streams(DomainName; aws_config::AbstractAWSConfig=current_aws_config())
    return customer_profiles(
        "GET",
        "/domains/$(DomainName)/event-streams";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_event_streams(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "GET",
        "/domains/$(DomainName)/event-streams",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_identity_resolution_jobs(domain_name)
    list_identity_resolution_jobs(domain_name, params::Dict{String,<:Any})

Lists all of the Identity Resolution Jobs in your domain. The response sorts the list by
JobStartTime.

# Arguments
- `domain_name`: The unique name of the domain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"max-results"`: The maximum number of results to return per page.
- `"next-token"`: The token for the next set of results. Use the value returned in the
  previous response in the next request to retrieve the next set of results.
"""
function list_identity_resolution_jobs(
    DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return customer_profiles(
        "GET",
        "/domains/$(DomainName)/identity-resolution-jobs";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_identity_resolution_jobs(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "GET",
        "/domains/$(DomainName)/identity-resolution-jobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_integrations(domain_name)
    list_integrations(domain_name, params::Dict{String,<:Any})

Lists all of the integrations in your domain.

# Arguments
- `domain_name`: The unique name of the domain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"include-hidden"`: Boolean to indicate if hidden integration should be returned.
  Defaults to False.
- `"max-results"`: The maximum number of objects returned per page.
- `"next-token"`: The pagination token from the previous ListIntegrations API call.
"""
function list_integrations(DomainName; aws_config::AbstractAWSConfig=current_aws_config())
    return customer_profiles(
        "GET",
        "/domains/$(DomainName)/integrations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_integrations(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "GET",
        "/domains/$(DomainName)/integrations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_profile_object_type_templates()
    list_profile_object_type_templates(params::Dict{String,<:Any})

Lists all of the template information for object types.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"max-results"`: The maximum number of objects returned per page.
- `"next-token"`: The pagination token from the previous ListObjectTypeTemplates API call.
"""
function list_profile_object_type_templates(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return customer_profiles(
        "GET", "/templates"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_profile_object_type_templates(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return customer_profiles(
        "GET", "/templates", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_profile_object_types(domain_name)
    list_profile_object_types(domain_name, params::Dict{String,<:Any})

Lists all of the templates available within the service.

# Arguments
- `domain_name`: The unique name of the domain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"max-results"`: The maximum number of objects returned per page.
- `"next-token"`: Identifies the next page of results to return.
"""
function list_profile_object_types(
    DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return customer_profiles(
        "GET",
        "/domains/$(DomainName)/object-types";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_profile_object_types(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "GET",
        "/domains/$(DomainName)/object-types",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_profile_objects(domain_name, object_type_name, profile_id)
    list_profile_objects(domain_name, object_type_name, profile_id, params::Dict{String,<:Any})

Returns a list of objects associated with a profile of a given ProfileObjectType.

# Arguments
- `domain_name`: The unique name of the domain.
- `object_type_name`: The name of the profile object type.
- `profile_id`: The unique identifier of a customer profile.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ObjectFilter"`: Applies a filter to the response to include profile objects with the
  specified index values.
- `"max-results"`: The maximum number of objects returned per page.
- `"next-token"`: The pagination token from the previous call to ListProfileObjects.
"""
function list_profile_objects(
    DomainName,
    ObjectTypeName,
    ProfileId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "POST",
        "/domains/$(DomainName)/profiles/objects",
        Dict{String,Any}("ObjectTypeName" => ObjectTypeName, "ProfileId" => ProfileId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_profile_objects(
    DomainName,
    ObjectTypeName,
    ProfileId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "POST",
        "/domains/$(DomainName)/profiles/objects",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ObjectTypeName" => ObjectTypeName, "ProfileId" => ProfileId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_rule_based_matches(domain_name)
    list_rule_based_matches(domain_name, params::Dict{String,<:Any})

Returns a set of MatchIds that belong to the given domain.

# Arguments
- `domain_name`: The unique name of the domain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"max-results"`: The maximum number of MatchIds returned per page.
- `"next-token"`: The pagination token from the previous ListRuleBasedMatches API call.
"""
function list_rule_based_matches(
    DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return customer_profiles(
        "GET",
        "/domains/$(DomainName)/profiles/ruleBasedMatches";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_rule_based_matches(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "GET",
        "/domains/$(DomainName)/profiles/ruleBasedMatches",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Displays the tags associated with an Amazon Connect Customer Profiles resource. In Connect
Customer Profiles, domains, profile object types, and integrations can be tagged.

# Arguments
- `resource_arn`: The ARN of the resource for which you want to view tags.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return customer_profiles(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_workflows(domain_name)
    list_workflows(domain_name, params::Dict{String,<:Any})

Query to list all workflows.

# Arguments
- `domain_name`: The unique name of the domain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"QueryEndDate"`: Retrieve workflows ended after timestamp.
- `"QueryStartDate"`: Retrieve workflows started after timestamp.
- `"Status"`: Status of workflow execution.
- `"WorkflowType"`: The type of workflow. The only supported value is APPFLOW_INTEGRATION.
- `"max-results"`: The maximum number of results to return per page.
- `"next-token"`: The token for the next set of results. Use the value returned in the
  previous response in the next request to retrieve the next set of results.
"""
function list_workflows(DomainName; aws_config::AbstractAWSConfig=current_aws_config())
    return customer_profiles(
        "POST",
        "/domains/$(DomainName)/workflows";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_workflows(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "POST",
        "/domains/$(DomainName)/workflows",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    merge_profiles(domain_name, main_profile_id, profile_ids_to_be_merged)
    merge_profiles(domain_name, main_profile_id, profile_ids_to_be_merged, params::Dict{String,<:Any})

Runs an AWS Lambda job that does the following:   All the profileKeys in the
ProfileToBeMerged will be moved to the main profile.   All the objects in the
ProfileToBeMerged will be moved to the main profile.   All the ProfileToBeMerged will be
deleted at the end.   All the profileKeys in the ProfileIdsToBeMerged will be moved to the
main profile.   Standard fields are merged as follows:   Fields are always \"union\"-ed if
there are no conflicts in standard fields or attributeKeys.   When there are conflicting
fields:   If no SourceProfileIds entry is specified, the main Profile value is always
taken.    If a SourceProfileIds entry is specified, the specified profileId is always
taken, even if it is a NULL value.       You can use MergeProfiles together with
GetMatches, which returns potentially matching profiles, or use it with the results of
another matching system. After profiles have been merged, they cannot be separated
(unmerged).

# Arguments
- `domain_name`: The unique name of the domain.
- `main_profile_id`: The identifier of the profile to be taken.
- `profile_ids_to_be_merged`: The identifier of the profile to be merged into MainProfileId.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FieldSourceProfileIds"`: The identifiers of the fields in the profile that has the
  information you want to apply to the merge. For example, say you want to merge EmailAddress
  from Profile1 into MainProfile. This would be the identifier of the EmailAddress field in
  Profile1.
"""
function merge_profiles(
    DomainName,
    MainProfileId,
    ProfileIdsToBeMerged;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "POST",
        "/domains/$(DomainName)/profiles/objects/merge",
        Dict{String,Any}(
            "MainProfileId" => MainProfileId, "ProfileIdsToBeMerged" => ProfileIdsToBeMerged
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function merge_profiles(
    DomainName,
    MainProfileId,
    ProfileIdsToBeMerged,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "POST",
        "/domains/$(DomainName)/profiles/objects/merge",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "MainProfileId" => MainProfileId,
                    "ProfileIdsToBeMerged" => ProfileIdsToBeMerged,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_integration(domain_name)
    put_integration(domain_name, params::Dict{String,<:Any})

Adds an integration between the service and a third-party service, which includes Amazon
AppFlow and Amazon Connect. An integration can belong to only one domain. To add or remove
tags on an existing Integration, see  TagResource / UntagResource.

# Arguments
- `domain_name`: The unique name of the domain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FlowDefinition"`: The configuration that controls how Customer Profiles retrieves data
  from the source.
- `"ObjectTypeName"`: The name of the profile object type.
- `"ObjectTypeNames"`: A map in which each key is an event type from an external
  application such as Segment or Shopify, and each value is an ObjectTypeName (template) used
  to ingest the event. It supports the following event types: SegmentIdentify,
  ShopifyCreateCustomers, ShopifyUpdateCustomers, ShopifyCreateDraftOrders,
  ShopifyUpdateDraftOrders, ShopifyCreateOrders, and ShopifyUpdatedOrders.
- `"Tags"`: The tags used to organize, track, or control access for this resource.
- `"Uri"`: The URI of the S3 bucket or any other type of data source.
"""
function put_integration(DomainName; aws_config::AbstractAWSConfig=current_aws_config())
    return customer_profiles(
        "PUT",
        "/domains/$(DomainName)/integrations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_integration(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "PUT",
        "/domains/$(DomainName)/integrations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_profile_object(domain_name, object, object_type_name)
    put_profile_object(domain_name, object, object_type_name, params::Dict{String,<:Any})

Adds additional objects to customer profiles of a given ObjectType. When adding a specific
profile object, like a Contact Record, an inferred profile can get created if it is not
mapped to an existing profile. The resulting profile will only have a phone number
populated in the standard ProfileObject. Any additional Contact Records with the same phone
number will be mapped to the same inferred profile. When a ProfileObject is created and if
a ProfileObjectType already exists for the ProfileObject, it will provide data to a
standard profile depending on the ProfileObjectType definition. PutProfileObject needs an
ObjectType, which can be created using PutProfileObjectType.

# Arguments
- `domain_name`: The unique name of the domain.
- `object`: A string that is serialized from a JSON object.
- `object_type_name`: The name of the profile object type.

"""
function put_profile_object(
    DomainName, Object, ObjectTypeName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return customer_profiles(
        "PUT",
        "/domains/$(DomainName)/profiles/objects",
        Dict{String,Any}("Object" => Object, "ObjectTypeName" => ObjectTypeName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_profile_object(
    DomainName,
    Object,
    ObjectTypeName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "PUT",
        "/domains/$(DomainName)/profiles/objects",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Object" => Object, "ObjectTypeName" => ObjectTypeName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_profile_object_type(description, domain_name, object_type_name)
    put_profile_object_type(description, domain_name, object_type_name, params::Dict{String,<:Any})

Defines a ProfileObjectType. To add or remove tags on an existing ObjectType, see
TagResource/UntagResource.

# Arguments
- `description`: Description of the profile object type.
- `domain_name`: The unique name of the domain.
- `object_type_name`: The name of the profile object type.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AllowProfileCreation"`: Indicates whether a profile should be created when data is
  received if one doesn’t exist for an object of this type. The default is FALSE. If the
  AllowProfileCreation flag is set to FALSE, then the service tries to fetch a standard
  profile and associate this object with the profile. If it is set to TRUE, and if no match
  is found, then the service creates a new standard profile.
- `"EncryptionKey"`: The customer-provided key to encrypt the profile object that will be
  created in this profile object type.
- `"ExpirationDays"`: The number of days until the data in the object expires.
- `"Fields"`: A map of the name and ObjectType field.
- `"Keys"`: A list of unique keys that can be used to map data to the profile.
- `"MaxProfileObjectCount"`: The amount of profile object max count assigned to the object
  type
- `"SourceLastUpdatedTimestampFormat"`: The format of your sourceLastUpdatedTimestamp that
  was previously set up.
- `"Tags"`: The tags used to organize, track, or control access for this resource.
- `"TemplateId"`: A unique identifier for the object template. For some attributes in the
  request, the service will use the default value from the object template when TemplateId is
  present. If these attributes are present in the request, the service may return a
  BadRequestException. These attributes include: AllowProfileCreation,
  SourceLastUpdatedTimestampFormat, Fields, and Keys. For example, if AllowProfileCreation is
  set to true when TemplateId is set, the service may return a BadRequestException.
"""
function put_profile_object_type(
    Description,
    DomainName,
    ObjectTypeName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "PUT",
        "/domains/$(DomainName)/object-types/$(ObjectTypeName)",
        Dict{String,Any}("Description" => Description);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_profile_object_type(
    Description,
    DomainName,
    ObjectTypeName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "PUT",
        "/domains/$(DomainName)/object-types/$(ObjectTypeName)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Description" => Description), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    search_profiles(domain_name, key_name, values)
    search_profiles(domain_name, key_name, values, params::Dict{String,<:Any})

Searches for profiles within a specific domain using one or more predefined search keys
(e.g., _fullName, _phone, _email, _account, etc.) and/or custom-defined search keys. A
search key is a data type pair that consists of a KeyName and Values list. This operation
supports searching for profiles with a minimum of 1 key-value(s) pair and up to 5
key-value(s) pairs using either AND or OR logic.

# Arguments
- `domain_name`: The unique name of the domain.
- `key_name`: A searchable identifier of a customer profile. The predefined keys you can
  use to search include: _account, _profileId, _assetId, _caseId, _orderId, _fullName,
  _phone, _email, _ctrContactId, _marketoLeadId, _salesforceAccountId, _salesforceContactId,
  _salesforceAssetId, _zendeskUserId, _zendeskExternalId, _zendeskTicketId,
  _serviceNowSystemId, _serviceNowIncidentId, _segmentUserId, _shopifyCustomerId,
  _shopifyOrderId.
- `values`: A list of key values.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AdditionalSearchKeys"`: A list of AdditionalSearchKey objects that are each searchable
  identifiers of a profile. Each AdditionalSearchKey object contains a KeyName and a list of
  Values associated with that specific key (i.e., a key-value(s) pair). These additional
  search keys will be used in conjunction with the LogicalOperator and the required KeyName
  and Values parameters to search for profiles that satisfy the search criteria.
- `"LogicalOperator"`: Relationship between all specified search keys that will be used to
  search for profiles. This includes the required KeyName and Values parameters as well as
  any key-value(s) pairs specified in the AdditionalSearchKeys list. This parameter
  influences which profiles will be returned in the response in the following manner:    AND
  - The response only includes profiles that match all of the search keys.    OR - The
  response includes profiles that match at least one of the search keys.   The OR
  relationship is the default behavior if this parameter is not included in the request.
- `"max-results"`: The maximum number of objects returned per page. The default is 20 if
  this parameter is not included in the request.
- `"next-token"`: The pagination token from the previous SearchProfiles API call.
"""
function search_profiles(
    DomainName, KeyName, Values; aws_config::AbstractAWSConfig=current_aws_config()
)
    return customer_profiles(
        "POST",
        "/domains/$(DomainName)/profiles/search",
        Dict{String,Any}("KeyName" => KeyName, "Values" => Values);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function search_profiles(
    DomainName,
    KeyName,
    Values,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "POST",
        "/domains/$(DomainName)/profiles/search",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("KeyName" => KeyName, "Values" => Values), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Assigns one or more tags (key-value pairs) to the specified Amazon Connect Customer
Profiles resource. Tags can help you organize and categorize your resources. You can also
use them to scope user permissions by granting a user permission to access or change only
resources with certain tag values. In Connect Customer Profiles, domains, profile object
types, and integrations can be tagged. Tags don't have any semantic meaning to AWS and are
interpreted strictly as strings of characters. You can use the TagResource action with a
resource that already has tags. If you specify a new tag key, this tag is appended to the
list of tags associated with the resource. If you specify a tag key that is already
associated with the resource, the new tag value that you specify replaces the previous
value for that tag. You can associate as many as 50 tags with a resource.

# Arguments
- `resource_arn`: The ARN of the resource that you're adding tags to.
- `tags`: The tags used to organize, track, or control access for this resource.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return customer_profiles(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes one or more tags from the specified Amazon Connect Customer Profiles resource. In
Connect Customer Profiles, domains, profile object types, and integrations can be tagged.

# Arguments
- `resource_arn`: The ARN of the resource from which you are removing tags.
- `tag_keys`: The list of tag keys to remove from the resource.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return customer_profiles(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_calculated_attribute_definition(calculated_attribute_name, domain_name)
    update_calculated_attribute_definition(calculated_attribute_name, domain_name, params::Dict{String,<:Any})

Updates an existing calculated attribute definition. When updating the Conditions, note
that increasing the date range of a calculated attribute will not trigger inclusion of
historical data greater than the current date range.

# Arguments
- `calculated_attribute_name`: The unique name of the calculated attribute.
- `domain_name`: The unique name of the domain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Conditions"`: The conditions including range, object count, and threshold for the
  calculated attribute.
- `"Description"`: The description of the calculated attribute.
- `"DisplayName"`: The display name of the calculated attribute.
"""
function update_calculated_attribute_definition(
    CalculatedAttributeName, DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return customer_profiles(
        "PUT",
        "/domains/$(DomainName)/calculated-attributes/$(CalculatedAttributeName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_calculated_attribute_definition(
    CalculatedAttributeName,
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "PUT",
        "/domains/$(DomainName)/calculated-attributes/$(CalculatedAttributeName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_domain(domain_name)
    update_domain(domain_name, params::Dict{String,<:Any})

Updates the properties of a domain, including creating or selecting a dead letter queue or
an encryption key. After a domain is created, the name can’t be changed. Use this API or
CreateDomain to enable identity resolution: set Matching to true. To prevent cross-service
impersonation when you call this API, see Cross-service confused deputy prevention for
sample policies that you should apply.  To add or remove tags on an existing Domain, see
TagResource/UntagResource.

# Arguments
- `domain_name`: The unique name of the domain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DeadLetterQueueUrl"`: The URL of the SQS dead letter queue, which is used for reporting
  errors associated with ingesting data from third party applications. If specified as an
  empty string, it will clear any existing value. You must set up a policy on the
  DeadLetterQueue for the SendMessage operation to enable Amazon Connect Customer Profiles to
  send messages to the DeadLetterQueue.
- `"DefaultEncryptionKey"`: The default encryption key, which is an AWS managed key, is
  used when no specific type of encryption key is specified. It is used to encrypt all data
  before it is placed in permanent or semi-permanent storage. If specified as an empty
  string, it will clear any existing value.
- `"DefaultExpirationDays"`: The default number of days until the data within the domain
  expires.
- `"Matching"`: The process of matching duplicate profiles. If Matching = true, Amazon
  Connect Customer Profiles starts a weekly batch process called Identity Resolution Job. If
  you do not specify a date and time for Identity Resolution Job to run, by default it runs
  every Saturday at 12AM UTC to detect duplicate profiles in your domains.  After the
  Identity Resolution Job completes, use the GetMatches API to return and review the results.
  Or, if you have configured ExportingConfig in the MatchingRequest, you can download the
  results from S3.
- `"RuleBasedMatching"`: The process of matching duplicate profiles using the rule-Based
  matching. If RuleBasedMatching = true, Amazon Connect Customer Profiles will start to match
  and merge your profiles according to your configuration in the RuleBasedMatchingRequest.
  You can use the ListRuleBasedMatches and GetSimilarProfiles API to return and review the
  results. Also, if you have configured ExportingConfig in the RuleBasedMatchingRequest, you
  can download the results from S3.
- `"Tags"`: The tags used to organize, track, or control access for this resource.
"""
function update_domain(DomainName; aws_config::AbstractAWSConfig=current_aws_config())
    return customer_profiles(
        "PUT",
        "/domains/$(DomainName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_domain(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "PUT",
        "/domains/$(DomainName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_profile(domain_name, profile_id)
    update_profile(domain_name, profile_id, params::Dict{String,<:Any})

Updates the properties of a profile. The ProfileId is required for updating a customer
profile. When calling the UpdateProfile API, specifying an empty string value means that
any existing value will be removed. Not specifying a string value means that any value
already there will be kept.

# Arguments
- `domain_name`: The unique name of the domain.
- `profile_id`: The unique identifier of a customer profile.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccountNumber"`: An account number that you have given to the customer.
- `"AdditionalInformation"`: Any additional information relevant to the customer’s
  profile.
- `"Address"`: A generic address associated with the customer that is not mailing,
  shipping, or billing.
- `"Attributes"`: A key value pair of attributes of a customer profile.
- `"BillingAddress"`: The customer’s billing address.
- `"BirthDate"`: The customer’s birth date.
- `"BusinessEmailAddress"`: The customer’s business email address.
- `"BusinessName"`: The name of the customer’s business.
- `"BusinessPhoneNumber"`: The customer’s business phone number.
- `"EmailAddress"`: The customer’s email address, which has not been specified as a
  personal or business address.
- `"FirstName"`: The customer’s first name.
- `"Gender"`: The gender with which the customer identifies.
- `"GenderString"`: An alternative to Gender which accepts any string as input.
- `"HomePhoneNumber"`: The customer’s home phone number.
- `"LastName"`: The customer’s last name.
- `"MailingAddress"`: The customer’s mailing address.
- `"MiddleName"`: The customer’s middle name.
- `"MobilePhoneNumber"`: The customer’s mobile phone number.
- `"PartyType"`: The type of profile used to describe the customer.
- `"PartyTypeString"`: An alternative to PartyType which accepts any string as input.
- `"PersonalEmailAddress"`: The customer’s personal email address.
- `"PhoneNumber"`: The customer’s phone number, which has not been specified as a mobile,
  home, or business number.
- `"ShippingAddress"`: The customer’s shipping address.
"""
function update_profile(
    DomainName, ProfileId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return customer_profiles(
        "PUT",
        "/domains/$(DomainName)/profiles",
        Dict{String,Any}("ProfileId" => ProfileId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_profile(
    DomainName,
    ProfileId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return customer_profiles(
        "PUT",
        "/domains/$(DomainName)/profiles",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ProfileId" => ProfileId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: marketplace_metering
using AWS.Compat
using AWS.UUIDs

"""
    batch_meter_usage(product_code, usage_records)
    batch_meter_usage(product_code, usage_records, params::Dict{String,<:Any})

 BatchMeterUsage is called from a SaaS application listed on AWS Marketplace to post
metering records for a set of customers. For identical requests, the API is idempotent;
requests can be retried with the same records or a subset of the input records. Every
request to BatchMeterUsage is for one product. If you need to meter usage for multiple
products, you must make multiple calls to BatchMeterUsage. Usage records are expected to be
submitted as quickly as possible after the event that is being recorded, and are not
accepted more than 6 hours after the event.  BatchMeterUsage can process up to 25
UsageRecords at a time. A UsageRecord can optionally include multiple usage allocations, to
provide customers with usage data split into buckets by tags that you define (or allow the
customer to define).  BatchMeterUsage returns a list of UsageRecordResult objects, showing
the result for each UsageRecord, as well as a list of UnprocessedRecords, indicating errors
in the service side that you should retry.  BatchMeterUsage requests must be less than 1MB
in size.  For an example of using BatchMeterUsage, see  BatchMeterUsage code example in the
AWS Marketplace Seller Guide.

# Arguments
- `product_code`: Product code is used to uniquely identify a product in AWS Marketplace.
  The product code should be the same as the one used during the publishing of a new product.
- `usage_records`: The set of UsageRecords to submit. BatchMeterUsage accepts up to 25
  UsageRecords at a time.

"""
function batch_meter_usage(
    ProductCode, UsageRecords; aws_config::AbstractAWSConfig=current_aws_config()
)
    return marketplace_metering(
        "BatchMeterUsage",
        Dict{String,Any}("ProductCode" => ProductCode, "UsageRecords" => UsageRecords);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_meter_usage(
    ProductCode,
    UsageRecords,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return marketplace_metering(
        "BatchMeterUsage",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ProductCode" => ProductCode, "UsageRecords" => UsageRecords
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    meter_usage(product_code, timestamp, usage_dimension)
    meter_usage(product_code, timestamp, usage_dimension, params::Dict{String,<:Any})

API to emit metering records. For identical requests, the API is idempotent. It simply
returns the metering record ID.  MeterUsage is authenticated on the buyer's AWS account
using credentials from the EC2 instance, ECS task, or EKS pod.  MeterUsage can optionally
include multiple usage allocations, to provide customers with usage data split into buckets
by tags that you define (or allow the customer to define). Usage records are expected to be
submitted as quickly as possible after the event that is being recorded, and are not
accepted more than 6 hours after the event.

# Arguments
- `product_code`: Product code is used to uniquely identify a product in AWS Marketplace.
  The product code should be the same as the one used during the publishing of a new product.
- `timestamp`: Timestamp, in UTC, for which the usage is being reported. Your application
  can meter usage for up to one hour in the past. Make sure the timestamp value is not before
  the start of the software usage.
- `usage_dimension`: It will be one of the fcp dimension name provided during the
  publishing of the product.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DryRun"`: Checks whether you have the permissions required for the action, but does not
  make the request. If you have the permissions, the request returns DryRunOperation;
  otherwise, it returns UnauthorizedException. Defaults to false if not specified.
- `"UsageAllocations"`: The set of UsageAllocations to submit. The sum of all
  UsageAllocation quantities must equal the UsageQuantity of the MeterUsage request, and each
  UsageAllocation must have a unique set of tags (include no tags).
- `"UsageQuantity"`: Consumption value for the hour. Defaults to 0 if not specified.
"""
function meter_usage(
    ProductCode,
    Timestamp,
    UsageDimension;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return marketplace_metering(
        "MeterUsage",
        Dict{String,Any}(
            "ProductCode" => ProductCode,
            "Timestamp" => Timestamp,
            "UsageDimension" => UsageDimension,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function meter_usage(
    ProductCode,
    Timestamp,
    UsageDimension,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return marketplace_metering(
        "MeterUsage",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ProductCode" => ProductCode,
                    "Timestamp" => Timestamp,
                    "UsageDimension" => UsageDimension,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    register_usage(product_code, public_key_version)
    register_usage(product_code, public_key_version, params::Dict{String,<:Any})

Paid container software products sold through AWS Marketplace must integrate with the AWS
Marketplace Metering Service and call the RegisterUsage operation for software entitlement
and metering. Free and BYOL products for Amazon ECS or Amazon EKS aren't required to call
RegisterUsage, but you may choose to do so if you would like to receive usage data in your
seller reports. The sections below explain the behavior of RegisterUsage. RegisterUsage
performs two primary functions: metering and entitlement.    Entitlement: RegisterUsage
allows you to verify that the customer running your paid software is subscribed to your
product on AWS Marketplace, enabling you to guard against unauthorized use. Your container
image that integrates with RegisterUsage is only required to guard against unauthorized use
at container startup, as such a CustomerNotSubscribedException or
PlatformNotSupportedException will only be thrown on the initial call to RegisterUsage.
Subsequent calls from the same Amazon ECS task instance (e.g. task-id) or Amazon EKS pod
will not throw a CustomerNotSubscribedException, even if the customer unsubscribes while
the Amazon ECS task or Amazon EKS pod is still running.    Metering: RegisterUsage meters
software use per ECS task, per hour, or per pod for Amazon EKS with usage prorated to the
second. A minimum of 1 minute of usage applies to tasks that are short lived. For example,
if a customer has a 10 node Amazon ECS or Amazon EKS cluster and a service configured as a
Daemon Set, then Amazon ECS or Amazon EKS will launch a task on all 10 cluster nodes and
the customer will be charged: (10 * hourly_rate). Metering for software use is
automatically handled by the AWS Marketplace Metering Control Plane -- your software is not
required to perform any metering specific actions, other than call RegisterUsage once for
metering of software use to commence. The AWS Marketplace Metering Control Plane will also
continue to bill customers for running ECS tasks and Amazon EKS pods, regardless of the
customers subscription state, removing the need for your software to perform entitlement
checks at runtime.

# Arguments
- `product_code`: Product code is used to uniquely identify a product in AWS Marketplace.
  The product code should be the same as the one used during the publishing of a new product.
- `public_key_version`: Public Key Version provided by AWS Marketplace

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Nonce"`: (Optional) To scope down the registration to a specific running software
  instance and guard against replay attacks.
"""
function register_usage(
    ProductCode, PublicKeyVersion; aws_config::AbstractAWSConfig=current_aws_config()
)
    return marketplace_metering(
        "RegisterUsage",
        Dict{String,Any}(
            "ProductCode" => ProductCode, "PublicKeyVersion" => PublicKeyVersion
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function register_usage(
    ProductCode,
    PublicKeyVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return marketplace_metering(
        "RegisterUsage",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ProductCode" => ProductCode, "PublicKeyVersion" => PublicKeyVersion
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    resolve_customer(registration_token)
    resolve_customer(registration_token, params::Dict{String,<:Any})

 ResolveCustomer is called by a SaaS application during the registration process. When a
buyer visits your website during the registration process, the buyer submits a registration
token through their browser. The registration token is resolved through this API to obtain
a CustomerIdentifier along with the CustomerAWSAccountId and ProductCode.  The API needs to
called from the seller account id used to publish the SaaS application to successfully
resolve the token. For an example of using ResolveCustomer, see  ResolveCustomer code
example in the AWS Marketplace Seller Guide.

# Arguments
- `registration_token`: When a buyer visits your website during the registration process,
  the buyer submits a registration token through the browser. The registration token is
  resolved to obtain a CustomerIdentifier along with the CustomerAWSAccountId and ProductCode.

"""
function resolve_customer(
    RegistrationToken; aws_config::AbstractAWSConfig=current_aws_config()
)
    return marketplace_metering(
        "ResolveCustomer",
        Dict{String,Any}("RegistrationToken" => RegistrationToken);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function resolve_customer(
    RegistrationToken,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return marketplace_metering(
        "ResolveCustomer",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("RegistrationToken" => RegistrationToken), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: networkmanager
using AWS.Compat
using AWS.UUIDs

"""
    accept_attachment(attachment_id)
    accept_attachment(attachment_id, params::Dict{String,<:Any})

Accepts a core network attachment request.  Once the attachment request is accepted by a
core network owner, the attachment is created and connected to a core network.

# Arguments
- `attachment_id`: The ID of the attachment.

"""
function accept_attachment(attachmentId; aws_config::AbstractAWSConfig=current_aws_config())
    return networkmanager(
        "POST",
        "/attachments/$(attachmentId)/accept";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function accept_attachment(
    attachmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "POST",
        "/attachments/$(attachmentId)/accept",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_connect_peer(connect_peer_id, device_id, global_network_id)
    associate_connect_peer(connect_peer_id, device_id, global_network_id, params::Dict{String,<:Any})

Associates a core network Connect peer with a device and optionally, with a link.  If you
specify a link, it must be associated with the specified device. You can only associate
core network Connect peers that have been created on a core network Connect attachment on a
core network.

# Arguments
- `connect_peer_id`: The ID of the Connect peer.
- `device_id`: The ID of the device.
- `global_network_id`: The ID of your global network.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"LinkId"`: The ID of the link.
"""
function associate_connect_peer(
    ConnectPeerId,
    DeviceId,
    globalNetworkId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "POST",
        "/global-networks/$(globalNetworkId)/connect-peer-associations",
        Dict{String,Any}("ConnectPeerId" => ConnectPeerId, "DeviceId" => DeviceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_connect_peer(
    ConnectPeerId,
    DeviceId,
    globalNetworkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "POST",
        "/global-networks/$(globalNetworkId)/connect-peer-associations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ConnectPeerId" => ConnectPeerId, "DeviceId" => DeviceId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_customer_gateway(customer_gateway_arn, device_id, global_network_id)
    associate_customer_gateway(customer_gateway_arn, device_id, global_network_id, params::Dict{String,<:Any})

Associates a customer gateway with a device and optionally, with a link. If you specify a
link, it must be associated with the specified device.  You can only associate customer
gateways that are connected to a VPN attachment on a transit gateway or core network
registered in your global network. When you register a transit gateway or core network,
customer gateways that are connected to the transit gateway are automatically included in
the global network. To list customer gateways that are connected to a transit gateway, use
the DescribeVpnConnections EC2 API and filter by transit-gateway-id. You cannot associate a
customer gateway with more than one device and link.

# Arguments
- `customer_gateway_arn`: The Amazon Resource Name (ARN) of the customer gateway.
- `device_id`: The ID of the device.
- `global_network_id`: The ID of the global network.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"LinkId"`: The ID of the link.
"""
function associate_customer_gateway(
    CustomerGatewayArn,
    DeviceId,
    globalNetworkId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "POST",
        "/global-networks/$(globalNetworkId)/customer-gateway-associations",
        Dict{String,Any}(
            "CustomerGatewayArn" => CustomerGatewayArn, "DeviceId" => DeviceId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_customer_gateway(
    CustomerGatewayArn,
    DeviceId,
    globalNetworkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "POST",
        "/global-networks/$(globalNetworkId)/customer-gateway-associations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CustomerGatewayArn" => CustomerGatewayArn, "DeviceId" => DeviceId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_link(device_id, link_id, global_network_id)
    associate_link(device_id, link_id, global_network_id, params::Dict{String,<:Any})

Associates a link to a device. A device can be associated to multiple links and a link can
be associated to multiple devices. The device and link must be in the same global network
and the same site.

# Arguments
- `device_id`: The ID of the device.
- `link_id`: The ID of the link.
- `global_network_id`: The ID of the global network.

"""
function associate_link(
    DeviceId, LinkId, globalNetworkId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "POST",
        "/global-networks/$(globalNetworkId)/link-associations",
        Dict{String,Any}("DeviceId" => DeviceId, "LinkId" => LinkId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_link(
    DeviceId,
    LinkId,
    globalNetworkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "POST",
        "/global-networks/$(globalNetworkId)/link-associations",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("DeviceId" => DeviceId, "LinkId" => LinkId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_transit_gateway_connect_peer(device_id, transit_gateway_connect_peer_arn, global_network_id)
    associate_transit_gateway_connect_peer(device_id, transit_gateway_connect_peer_arn, global_network_id, params::Dict{String,<:Any})

Associates a transit gateway Connect peer with a device, and optionally, with a link. If
you specify a link, it must be associated with the specified device.  You can only
associate transit gateway Connect peers that have been created on a transit gateway that's
registered in your global network. You cannot associate a transit gateway Connect peer with
more than one device and link.

# Arguments
- `device_id`: The ID of the device.
- `transit_gateway_connect_peer_arn`: The Amazon Resource Name (ARN) of the Connect peer.
- `global_network_id`: The ID of the global network.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"LinkId"`: The ID of the link.
"""
function associate_transit_gateway_connect_peer(
    DeviceId,
    TransitGatewayConnectPeerArn,
    globalNetworkId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "POST",
        "/global-networks/$(globalNetworkId)/transit-gateway-connect-peer-associations",
        Dict{String,Any}(
            "DeviceId" => DeviceId,
            "TransitGatewayConnectPeerArn" => TransitGatewayConnectPeerArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_transit_gateway_connect_peer(
    DeviceId,
    TransitGatewayConnectPeerArn,
    globalNetworkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "POST",
        "/global-networks/$(globalNetworkId)/transit-gateway-connect-peer-associations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DeviceId" => DeviceId,
                    "TransitGatewayConnectPeerArn" => TransitGatewayConnectPeerArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_connect_attachment(core_network_id, edge_location, options, transport_attachment_id)
    create_connect_attachment(core_network_id, edge_location, options, transport_attachment_id, params::Dict{String,<:Any})

Creates a core network Connect attachment from a specified core network attachment.  A core
network Connect attachment is a GRE-based tunnel attachment that you can use to establish a
connection between a core network and an appliance. A core network Connect attachment uses
an existing VPC attachment as the underlying transport mechanism.

# Arguments
- `core_network_id`: The ID of a core network where you want to create the attachment.
- `edge_location`: The Region where the edge is located.
- `options`: Options for creating an attachment.
- `transport_attachment_id`: The ID of the attachment between the two connections.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: The client token associated with the request.
- `"Tags"`: The list of key-value tags associated with the request.
"""
function create_connect_attachment(
    CoreNetworkId,
    EdgeLocation,
    Options,
    TransportAttachmentId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "POST",
        "/connect-attachments",
        Dict{String,Any}(
            "CoreNetworkId" => CoreNetworkId,
            "EdgeLocation" => EdgeLocation,
            "Options" => Options,
            "TransportAttachmentId" => TransportAttachmentId,
            "ClientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_connect_attachment(
    CoreNetworkId,
    EdgeLocation,
    Options,
    TransportAttachmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "POST",
        "/connect-attachments",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CoreNetworkId" => CoreNetworkId,
                    "EdgeLocation" => EdgeLocation,
                    "Options" => Options,
                    "TransportAttachmentId" => TransportAttachmentId,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_connect_peer(connect_attachment_id, peer_address)
    create_connect_peer(connect_attachment_id, peer_address, params::Dict{String,<:Any})

Creates a core network Connect peer for a specified core network connect attachment between
a core network and an appliance. The peer address and transit gateway address must be the
same IP address family (IPv4 or IPv6).

# Arguments
- `connect_attachment_id`: The ID of the connection attachment.
- `peer_address`: The Connect peer address.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"BgpOptions"`: The Connect peer BGP options. This only applies only when the protocol is
  GRE.
- `"ClientToken"`: The client token associated with the request.
- `"CoreNetworkAddress"`: A Connect peer core network address. This only applies only when
  the protocol is GRE.
- `"InsideCidrBlocks"`: The inside IP addresses used for BGP peering.
- `"SubnetArn"`: The subnet ARN for the Connect peer. This only applies only when the
  protocol is NO_ENCAP.
- `"Tags"`: The tags associated with the peer request.
"""
function create_connect_peer(
    ConnectAttachmentId, PeerAddress; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "POST",
        "/connect-peers",
        Dict{String,Any}(
            "ConnectAttachmentId" => ConnectAttachmentId,
            "PeerAddress" => PeerAddress,
            "ClientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_connect_peer(
    ConnectAttachmentId,
    PeerAddress,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "POST",
        "/connect-peers",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ConnectAttachmentId" => ConnectAttachmentId,
                    "PeerAddress" => PeerAddress,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_connection(connected_device_id, device_id, global_network_id)
    create_connection(connected_device_id, device_id, global_network_id, params::Dict{String,<:Any})

Creates a connection between two devices. The devices can be a physical or virtual
appliance that connects to a third-party appliance in a VPC, or a physical appliance that
connects to another physical appliance in an on-premises network.

# Arguments
- `connected_device_id`: The ID of the second device in the connection.
- `device_id`: The ID of the first device in the connection.
- `global_network_id`: The ID of the global network.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConnectedLinkId"`: The ID of the link for the second device.
- `"Description"`: A description of the connection. Length Constraints: Maximum length of
  256 characters.
- `"LinkId"`: The ID of the link for the first device.
- `"Tags"`: The tags to apply to the resource during creation.
"""
function create_connection(
    ConnectedDeviceId,
    DeviceId,
    globalNetworkId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "POST",
        "/global-networks/$(globalNetworkId)/connections",
        Dict{String,Any}("ConnectedDeviceId" => ConnectedDeviceId, "DeviceId" => DeviceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_connection(
    ConnectedDeviceId,
    DeviceId,
    globalNetworkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "POST",
        "/global-networks/$(globalNetworkId)/connections",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ConnectedDeviceId" => ConnectedDeviceId, "DeviceId" => DeviceId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_core_network(global_network_id)
    create_core_network(global_network_id, params::Dict{String,<:Any})

Creates a core network as part of your global network, and optionally, with a core network
policy.

# Arguments
- `global_network_id`: The ID of the global network that a core network will be a part of.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: The client token associated with a core network request.
- `"Description"`: The description of a core network.
- `"PolicyDocument"`: The policy document for creating a core network.
- `"Tags"`: Key-value tags associated with a core network request.
"""
function create_core_network(
    GlobalNetworkId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "POST",
        "/core-networks",
        Dict{String,Any}(
            "GlobalNetworkId" => GlobalNetworkId, "ClientToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_core_network(
    GlobalNetworkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "POST",
        "/core-networks",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "GlobalNetworkId" => GlobalNetworkId, "ClientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_device(global_network_id)
    create_device(global_network_id, params::Dict{String,<:Any})

Creates a new device in a global network. If you specify both a site ID and a location, the
location of the site is used for visualization in the Network Manager console.

# Arguments
- `global_network_id`: The ID of the global network.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AWSLocation"`: The Amazon Web Services location of the device, if applicable. For an
  on-premises device, you can omit this parameter.
- `"Description"`: A description of the device. Constraints: Maximum length of 256
  characters.
- `"Location"`: The location of the device.
- `"Model"`: The model of the device. Constraints: Maximum length of 128 characters.
- `"SerialNumber"`: The serial number of the device. Constraints: Maximum length of 128
  characters.
- `"SiteId"`: The ID of the site.
- `"Tags"`: The tags to apply to the resource during creation.
- `"Type"`: The type of the device.
- `"Vendor"`: The vendor of the device. Constraints: Maximum length of 128 characters.
"""
function create_device(globalNetworkId; aws_config::AbstractAWSConfig=current_aws_config())
    return networkmanager(
        "POST",
        "/global-networks/$(globalNetworkId)/devices";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_device(
    globalNetworkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "POST",
        "/global-networks/$(globalNetworkId)/devices",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_global_network()
    create_global_network(params::Dict{String,<:Any})

Creates a new, empty global network.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description of the global network. Constraints: Maximum length of 256
  characters.
- `"Tags"`: The tags to apply to the resource during creation.
"""
function create_global_network(; aws_config::AbstractAWSConfig=current_aws_config())
    return networkmanager(
        "POST", "/global-networks"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function create_global_network(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "POST",
        "/global-networks",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_link(bandwidth, site_id, global_network_id)
    create_link(bandwidth, site_id, global_network_id, params::Dict{String,<:Any})

Creates a new link for a specified site.

# Arguments
- `bandwidth`:  The upload speed and download speed in Mbps.
- `site_id`: The ID of the site.
- `global_network_id`: The ID of the global network.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description of the link. Constraints: Maximum length of 256 characters.
- `"Provider"`: The provider of the link. Constraints: Maximum length of 128 characters.
  Cannot include the following characters: |  ^
- `"Tags"`: The tags to apply to the resource during creation.
- `"Type"`: The type of the link. Constraints: Maximum length of 128 characters. Cannot
  include the following characters: |  ^
"""
function create_link(
    Bandwidth, SiteId, globalNetworkId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "POST",
        "/global-networks/$(globalNetworkId)/links",
        Dict{String,Any}("Bandwidth" => Bandwidth, "SiteId" => SiteId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_link(
    Bandwidth,
    SiteId,
    globalNetworkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "POST",
        "/global-networks/$(globalNetworkId)/links",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Bandwidth" => Bandwidth, "SiteId" => SiteId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_site(global_network_id)
    create_site(global_network_id, params::Dict{String,<:Any})

Creates a new site in a global network.

# Arguments
- `global_network_id`: The ID of the global network.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description of your site. Constraints: Maximum length of 256
  characters.
- `"Location"`: The site location. This information is used for visualization in the
  Network Manager console. If you specify the address, the latitude and longitude are
  automatically calculated.    Address: The physical address of the site.    Latitude: The
  latitude of the site.     Longitude: The longitude of the site.
- `"Tags"`: The tags to apply to the resource during creation.
"""
function create_site(globalNetworkId; aws_config::AbstractAWSConfig=current_aws_config())
    return networkmanager(
        "POST",
        "/global-networks/$(globalNetworkId)/sites";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_site(
    globalNetworkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "POST",
        "/global-networks/$(globalNetworkId)/sites",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_site_to_site_vpn_attachment(core_network_id, vpn_connection_arn)
    create_site_to_site_vpn_attachment(core_network_id, vpn_connection_arn, params::Dict{String,<:Any})

Creates an Amazon Web Services site-to-site VPN attachment on an edge location of a core
network.

# Arguments
- `core_network_id`: The ID of a core network where you're creating a site-to-site VPN
  attachment.
- `vpn_connection_arn`: The ARN identifying the VPN attachment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: The client token associated with the request.
- `"Tags"`: The tags associated with the request.
"""
function create_site_to_site_vpn_attachment(
    CoreNetworkId, VpnConnectionArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "POST",
        "/site-to-site-vpn-attachments",
        Dict{String,Any}(
            "CoreNetworkId" => CoreNetworkId,
            "VpnConnectionArn" => VpnConnectionArn,
            "ClientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_site_to_site_vpn_attachment(
    CoreNetworkId,
    VpnConnectionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "POST",
        "/site-to-site-vpn-attachments",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CoreNetworkId" => CoreNetworkId,
                    "VpnConnectionArn" => VpnConnectionArn,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_transit_gateway_peering(core_network_id, transit_gateway_arn)
    create_transit_gateway_peering(core_network_id, transit_gateway_arn, params::Dict{String,<:Any})

Creates a transit gateway peering connection.

# Arguments
- `core_network_id`: The ID of a core network.
- `transit_gateway_arn`: The ARN of the transit gateway for the peering request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: The client token associated with the request.
- `"Tags"`: The list of key-value tags associated with the request.
"""
function create_transit_gateway_peering(
    CoreNetworkId, TransitGatewayArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "POST",
        "/transit-gateway-peerings",
        Dict{String,Any}(
            "CoreNetworkId" => CoreNetworkId,
            "TransitGatewayArn" => TransitGatewayArn,
            "ClientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_transit_gateway_peering(
    CoreNetworkId,
    TransitGatewayArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "POST",
        "/transit-gateway-peerings",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CoreNetworkId" => CoreNetworkId,
                    "TransitGatewayArn" => TransitGatewayArn,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_transit_gateway_route_table_attachment(peering_id, transit_gateway_route_table_arn)
    create_transit_gateway_route_table_attachment(peering_id, transit_gateway_route_table_arn, params::Dict{String,<:Any})

Creates a transit gateway route table attachment.

# Arguments
- `peering_id`: The ID of the peer for the
- `transit_gateway_route_table_arn`: The ARN of the transit gateway route table for the
  attachment request. For example, \"TransitGatewayRouteTableArn\":
  \"arn:aws:ec2:us-west-2:123456789012:transit-gateway-route-table/tgw-rtb-9876543210123456\".

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: The client token associated with the request.
- `"Tags"`: The list of key-value tags associated with the request.
"""
function create_transit_gateway_route_table_attachment(
    PeeringId,
    TransitGatewayRouteTableArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "POST",
        "/transit-gateway-route-table-attachments",
        Dict{String,Any}(
            "PeeringId" => PeeringId,
            "TransitGatewayRouteTableArn" => TransitGatewayRouteTableArn,
            "ClientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_transit_gateway_route_table_attachment(
    PeeringId,
    TransitGatewayRouteTableArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "POST",
        "/transit-gateway-route-table-attachments",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "PeeringId" => PeeringId,
                    "TransitGatewayRouteTableArn" => TransitGatewayRouteTableArn,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_vpc_attachment(core_network_id, subnet_arns, vpc_arn)
    create_vpc_attachment(core_network_id, subnet_arns, vpc_arn, params::Dict{String,<:Any})

Creates a VPC attachment on an edge location of a core network.

# Arguments
- `core_network_id`: The ID of a core network for the VPC attachment.
- `subnet_arns`: The subnet ARN of the VPC attachment.
- `vpc_arn`: The ARN of the VPC.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: The client token associated with the request.
- `"Options"`: Options for the VPC attachment.
- `"Tags"`: The key-value tags associated with the request.
"""
function create_vpc_attachment(
    CoreNetworkId, SubnetArns, VpcArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "POST",
        "/vpc-attachments",
        Dict{String,Any}(
            "CoreNetworkId" => CoreNetworkId,
            "SubnetArns" => SubnetArns,
            "VpcArn" => VpcArn,
            "ClientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_vpc_attachment(
    CoreNetworkId,
    SubnetArns,
    VpcArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "POST",
        "/vpc-attachments",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CoreNetworkId" => CoreNetworkId,
                    "SubnetArns" => SubnetArns,
                    "VpcArn" => VpcArn,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_attachment(attachment_id)
    delete_attachment(attachment_id, params::Dict{String,<:Any})

Deletes an attachment. Supports all attachment types.

# Arguments
- `attachment_id`: The ID of the attachment to delete.

"""
function delete_attachment(attachmentId; aws_config::AbstractAWSConfig=current_aws_config())
    return networkmanager(
        "DELETE",
        "/attachments/$(attachmentId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_attachment(
    attachmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "DELETE",
        "/attachments/$(attachmentId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_connect_peer(connect_peer_id)
    delete_connect_peer(connect_peer_id, params::Dict{String,<:Any})

Deletes a Connect peer.

# Arguments
- `connect_peer_id`: The ID of the deleted Connect peer.

"""
function delete_connect_peer(
    connectPeerId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "DELETE",
        "/connect-peers/$(connectPeerId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_connect_peer(
    connectPeerId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "DELETE",
        "/connect-peers/$(connectPeerId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_connection(connection_id, global_network_id)
    delete_connection(connection_id, global_network_id, params::Dict{String,<:Any})

Deletes the specified connection in your global network.

# Arguments
- `connection_id`: The ID of the connection.
- `global_network_id`: The ID of the global network.

"""
function delete_connection(
    connectionId, globalNetworkId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "DELETE",
        "/global-networks/$(globalNetworkId)/connections/$(connectionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_connection(
    connectionId,
    globalNetworkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "DELETE",
        "/global-networks/$(globalNetworkId)/connections/$(connectionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_core_network(core_network_id)
    delete_core_network(core_network_id, params::Dict{String,<:Any})

Deletes a core network along with all core network policies. This can only be done if there
are no attachments on a core network.

# Arguments
- `core_network_id`: The network ID of the deleted core network.

"""
function delete_core_network(
    coreNetworkId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "DELETE",
        "/core-networks/$(coreNetworkId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_core_network(
    coreNetworkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "DELETE",
        "/core-networks/$(coreNetworkId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_core_network_policy_version(core_network_id, policy_version_id)
    delete_core_network_policy_version(core_network_id, policy_version_id, params::Dict{String,<:Any})

Deletes a policy version from a core network. You can't delete the current LIVE policy.

# Arguments
- `core_network_id`: The ID of a core network for the deleted policy.
- `policy_version_id`: The version ID of the deleted policy.

"""
function delete_core_network_policy_version(
    coreNetworkId, policyVersionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "DELETE",
        "/core-networks/$(coreNetworkId)/core-network-policy-versions/$(policyVersionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_core_network_policy_version(
    coreNetworkId,
    policyVersionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "DELETE",
        "/core-networks/$(coreNetworkId)/core-network-policy-versions/$(policyVersionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_device(device_id, global_network_id)
    delete_device(device_id, global_network_id, params::Dict{String,<:Any})

Deletes an existing device. You must first disassociate the device from any links and
customer gateways.

# Arguments
- `device_id`: The ID of the device.
- `global_network_id`: The ID of the global network.

"""
function delete_device(
    deviceId, globalNetworkId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "DELETE",
        "/global-networks/$(globalNetworkId)/devices/$(deviceId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_device(
    deviceId,
    globalNetworkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "DELETE",
        "/global-networks/$(globalNetworkId)/devices/$(deviceId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_global_network(global_network_id)
    delete_global_network(global_network_id, params::Dict{String,<:Any})

Deletes an existing global network. You must first delete all global network objects
(devices, links, and sites), deregister all transit gateways, and delete any core networks.

# Arguments
- `global_network_id`: The ID of the global network.

"""
function delete_global_network(
    globalNetworkId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "DELETE",
        "/global-networks/$(globalNetworkId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_global_network(
    globalNetworkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "DELETE",
        "/global-networks/$(globalNetworkId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_link(global_network_id, link_id)
    delete_link(global_network_id, link_id, params::Dict{String,<:Any})

Deletes an existing link. You must first disassociate the link from any devices and
customer gateways.

# Arguments
- `global_network_id`: The ID of the global network.
- `link_id`: The ID of the link.

"""
function delete_link(
    globalNetworkId, linkId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "DELETE",
        "/global-networks/$(globalNetworkId)/links/$(linkId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_link(
    globalNetworkId,
    linkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "DELETE",
        "/global-networks/$(globalNetworkId)/links/$(linkId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_peering(peering_id)
    delete_peering(peering_id, params::Dict{String,<:Any})

Deletes an existing peering connection.

# Arguments
- `peering_id`: The ID of the peering connection to delete.

"""
function delete_peering(peeringId; aws_config::AbstractAWSConfig=current_aws_config())
    return networkmanager(
        "DELETE",
        "/peerings/$(peeringId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_peering(
    peeringId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "DELETE",
        "/peerings/$(peeringId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_resource_policy(resource_arn)
    delete_resource_policy(resource_arn, params::Dict{String,<:Any})

Deletes a resource policy for the specified resource. This revokes the access of the
principals specified in the resource policy.

# Arguments
- `resource_arn`: The ARN of the policy to delete.

"""
function delete_resource_policy(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "DELETE",
        "/resource-policy/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_resource_policy(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "DELETE",
        "/resource-policy/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_site(global_network_id, site_id)
    delete_site(global_network_id, site_id, params::Dict{String,<:Any})

Deletes an existing site. The site cannot be associated with any device or link.

# Arguments
- `global_network_id`: The ID of the global network.
- `site_id`: The ID of the site.

"""
function delete_site(
    globalNetworkId, siteId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "DELETE",
        "/global-networks/$(globalNetworkId)/sites/$(siteId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_site(
    globalNetworkId,
    siteId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "DELETE",
        "/global-networks/$(globalNetworkId)/sites/$(siteId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    deregister_transit_gateway(global_network_id, transit_gateway_arn)
    deregister_transit_gateway(global_network_id, transit_gateway_arn, params::Dict{String,<:Any})

Deregisters a transit gateway from your global network. This action does not delete your
transit gateway, or modify any of its attachments. This action removes any customer gateway
associations.

# Arguments
- `global_network_id`: The ID of the global network.
- `transit_gateway_arn`: The Amazon Resource Name (ARN) of the transit gateway.

"""
function deregister_transit_gateway(
    globalNetworkId, transitGatewayArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "DELETE",
        "/global-networks/$(globalNetworkId)/transit-gateway-registrations/$(transitGatewayArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function deregister_transit_gateway(
    globalNetworkId,
    transitGatewayArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "DELETE",
        "/global-networks/$(globalNetworkId)/transit-gateway-registrations/$(transitGatewayArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_global_networks()
    describe_global_networks(params::Dict{String,<:Any})

Describes one or more global networks. By default, all global networks are described. To
describe the objects in your global network, you must use the appropriate Get* action. For
example, to list the transit gateways in your global network, use
GetTransitGatewayRegistrations.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"globalNetworkIds"`: The IDs of one or more global networks. The maximum is 10.
- `"maxResults"`: The maximum number of results to return.
- `"nextToken"`: The token for the next page of results.
"""
function describe_global_networks(; aws_config::AbstractAWSConfig=current_aws_config())
    return networkmanager(
        "GET", "/global-networks"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_global_networks(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "GET",
        "/global-networks",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_connect_peer(connect_peer_id, global_network_id)
    disassociate_connect_peer(connect_peer_id, global_network_id, params::Dict{String,<:Any})

Disassociates a core network Connect peer from a device and a link.

# Arguments
- `connect_peer_id`: The ID of the Connect peer to disassociate from a device.
- `global_network_id`: The ID of the global network.

"""
function disassociate_connect_peer(
    connectPeerId, globalNetworkId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "DELETE",
        "/global-networks/$(globalNetworkId)/connect-peer-associations/$(connectPeerId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_connect_peer(
    connectPeerId,
    globalNetworkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "DELETE",
        "/global-networks/$(globalNetworkId)/connect-peer-associations/$(connectPeerId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_customer_gateway(customer_gateway_arn, global_network_id)
    disassociate_customer_gateway(customer_gateway_arn, global_network_id, params::Dict{String,<:Any})

Disassociates a customer gateway from a device and a link.

# Arguments
- `customer_gateway_arn`: The Amazon Resource Name (ARN) of the customer gateway.
- `global_network_id`: The ID of the global network.

"""
function disassociate_customer_gateway(
    customerGatewayArn, globalNetworkId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "DELETE",
        "/global-networks/$(globalNetworkId)/customer-gateway-associations/$(customerGatewayArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_customer_gateway(
    customerGatewayArn,
    globalNetworkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "DELETE",
        "/global-networks/$(globalNetworkId)/customer-gateway-associations/$(customerGatewayArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_link(device_id, global_network_id, link_id)
    disassociate_link(device_id, global_network_id, link_id, params::Dict{String,<:Any})

Disassociates an existing device from a link. You must first disassociate any customer
gateways that are associated with the link.

# Arguments
- `device_id`: The ID of the device.
- `global_network_id`: The ID of the global network.
- `link_id`: The ID of the link.

"""
function disassociate_link(
    deviceId, globalNetworkId, linkId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "DELETE",
        "/global-networks/$(globalNetworkId)/link-associations",
        Dict{String,Any}("deviceId" => deviceId, "linkId" => linkId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_link(
    deviceId,
    globalNetworkId,
    linkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "DELETE",
        "/global-networks/$(globalNetworkId)/link-associations",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("deviceId" => deviceId, "linkId" => linkId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_transit_gateway_connect_peer(global_network_id, transit_gateway_connect_peer_arn)
    disassociate_transit_gateway_connect_peer(global_network_id, transit_gateway_connect_peer_arn, params::Dict{String,<:Any})

Disassociates a transit gateway Connect peer from a device and link.

# Arguments
- `global_network_id`: The ID of the global network.
- `transit_gateway_connect_peer_arn`: The Amazon Resource Name (ARN) of the transit gateway
  Connect peer.

"""
function disassociate_transit_gateway_connect_peer(
    globalNetworkId,
    transitGatewayConnectPeerArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "DELETE",
        "/global-networks/$(globalNetworkId)/transit-gateway-connect-peer-associations/$(transitGatewayConnectPeerArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_transit_gateway_connect_peer(
    globalNetworkId,
    transitGatewayConnectPeerArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "DELETE",
        "/global-networks/$(globalNetworkId)/transit-gateway-connect-peer-associations/$(transitGatewayConnectPeerArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    execute_core_network_change_set(core_network_id, policy_version_id)
    execute_core_network_change_set(core_network_id, policy_version_id, params::Dict{String,<:Any})

Executes a change set on your core network. Deploys changes globally based on the policy
submitted..

# Arguments
- `core_network_id`: The ID of a core network.
- `policy_version_id`: The ID of the policy version.

"""
function execute_core_network_change_set(
    coreNetworkId, policyVersionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "POST",
        "/core-networks/$(coreNetworkId)/core-network-change-sets/$(policyVersionId)/execute";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function execute_core_network_change_set(
    coreNetworkId,
    policyVersionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "POST",
        "/core-networks/$(coreNetworkId)/core-network-change-sets/$(policyVersionId)/execute",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_connect_attachment(attachment_id)
    get_connect_attachment(attachment_id, params::Dict{String,<:Any})

Returns information about a core network Connect attachment.

# Arguments
- `attachment_id`: The ID of the attachment.

"""
function get_connect_attachment(
    attachmentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "GET",
        "/connect-attachments/$(attachmentId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_connect_attachment(
    attachmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "GET",
        "/connect-attachments/$(attachmentId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_connect_peer(connect_peer_id)
    get_connect_peer(connect_peer_id, params::Dict{String,<:Any})

Returns information about a core network Connect peer.

# Arguments
- `connect_peer_id`: The ID of the Connect peer.

"""
function get_connect_peer(connectPeerId; aws_config::AbstractAWSConfig=current_aws_config())
    return networkmanager(
        "GET",
        "/connect-peers/$(connectPeerId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_connect_peer(
    connectPeerId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "GET",
        "/connect-peers/$(connectPeerId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_connect_peer_associations(global_network_id)
    get_connect_peer_associations(global_network_id, params::Dict{String,<:Any})

Returns information about a core network Connect peer associations.

# Arguments
- `global_network_id`: The ID of the global network.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"connectPeerIds"`: The IDs of the Connect peers.
- `"maxResults"`: The maximum number of results to return.
- `"nextToken"`: The token for the next page of results.
"""
function get_connect_peer_associations(
    globalNetworkId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "GET",
        "/global-networks/$(globalNetworkId)/connect-peer-associations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_connect_peer_associations(
    globalNetworkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "GET",
        "/global-networks/$(globalNetworkId)/connect-peer-associations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_connections(global_network_id)
    get_connections(global_network_id, params::Dict{String,<:Any})

Gets information about one or more of your connections in a global network.

# Arguments
- `global_network_id`: The ID of the global network.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"connectionIds"`: One or more connection IDs.
- `"deviceId"`: The ID of the device.
- `"maxResults"`: The maximum number of results to return.
- `"nextToken"`: The token for the next page of results.
"""
function get_connections(
    globalNetworkId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "GET",
        "/global-networks/$(globalNetworkId)/connections";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_connections(
    globalNetworkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "GET",
        "/global-networks/$(globalNetworkId)/connections",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_core_network(core_network_id)
    get_core_network(core_network_id, params::Dict{String,<:Any})

Returns information about the LIVE policy for a core network.

# Arguments
- `core_network_id`: The ID of a core network.

"""
function get_core_network(coreNetworkId; aws_config::AbstractAWSConfig=current_aws_config())
    return networkmanager(
        "GET",
        "/core-networks/$(coreNetworkId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_core_network(
    coreNetworkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "GET",
        "/core-networks/$(coreNetworkId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_core_network_change_events(core_network_id, policy_version_id)
    get_core_network_change_events(core_network_id, policy_version_id, params::Dict{String,<:Any})

Returns information about a core network change event.

# Arguments
- `core_network_id`: The ID of a core network.
- `policy_version_id`: The ID of the policy version.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return.
- `"nextToken"`: The token for the next page of results.
"""
function get_core_network_change_events(
    coreNetworkId, policyVersionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "GET",
        "/core-networks/$(coreNetworkId)/core-network-change-events/$(policyVersionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_core_network_change_events(
    coreNetworkId,
    policyVersionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "GET",
        "/core-networks/$(coreNetworkId)/core-network-change-events/$(policyVersionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_core_network_change_set(core_network_id, policy_version_id)
    get_core_network_change_set(core_network_id, policy_version_id, params::Dict{String,<:Any})

Returns a change set between the LIVE core network policy and a submitted policy.

# Arguments
- `core_network_id`: The ID of a core network.
- `policy_version_id`: The ID of the policy version.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return.
- `"nextToken"`: The token for the next page of results.
"""
function get_core_network_change_set(
    coreNetworkId, policyVersionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "GET",
        "/core-networks/$(coreNetworkId)/core-network-change-sets/$(policyVersionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_core_network_change_set(
    coreNetworkId,
    policyVersionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "GET",
        "/core-networks/$(coreNetworkId)/core-network-change-sets/$(policyVersionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_core_network_policy(core_network_id)
    get_core_network_policy(core_network_id, params::Dict{String,<:Any})

Returns details about a core network policy. You can get details about your current live
policy or any previous policy version.

# Arguments
- `core_network_id`: The ID of a core network.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"alias"`: The alias of a core network policy
- `"policyVersionId"`: The ID of a core network policy version.
"""
function get_core_network_policy(
    coreNetworkId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "GET",
        "/core-networks/$(coreNetworkId)/core-network-policy";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_core_network_policy(
    coreNetworkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "GET",
        "/core-networks/$(coreNetworkId)/core-network-policy",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_customer_gateway_associations(global_network_id)
    get_customer_gateway_associations(global_network_id, params::Dict{String,<:Any})

Gets the association information for customer gateways that are associated with devices and
links in your global network.

# Arguments
- `global_network_id`: The ID of the global network.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"customerGatewayArns"`: One or more customer gateway Amazon Resource Names (ARNs). The
  maximum is 10.
- `"maxResults"`: The maximum number of results to return.
- `"nextToken"`: The token for the next page of results.
"""
function get_customer_gateway_associations(
    globalNetworkId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "GET",
        "/global-networks/$(globalNetworkId)/customer-gateway-associations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_customer_gateway_associations(
    globalNetworkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "GET",
        "/global-networks/$(globalNetworkId)/customer-gateway-associations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_devices(global_network_id)
    get_devices(global_network_id, params::Dict{String,<:Any})

Gets information about one or more of your devices in a global network.

# Arguments
- `global_network_id`: The ID of the global network.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"deviceIds"`: One or more device IDs. The maximum is 10.
- `"maxResults"`: The maximum number of results to return.
- `"nextToken"`: The token for the next page of results.
- `"siteId"`: The ID of the site.
"""
function get_devices(globalNetworkId; aws_config::AbstractAWSConfig=current_aws_config())
    return networkmanager(
        "GET",
        "/global-networks/$(globalNetworkId)/devices";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_devices(
    globalNetworkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "GET",
        "/global-networks/$(globalNetworkId)/devices",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_link_associations(global_network_id)
    get_link_associations(global_network_id, params::Dict{String,<:Any})

Gets the link associations for a device or a link. Either the device ID or the link ID must
be specified.

# Arguments
- `global_network_id`: The ID of the global network.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"deviceId"`: The ID of the device.
- `"linkId"`: The ID of the link.
- `"maxResults"`: The maximum number of results to return.
- `"nextToken"`: The token for the next page of results.
"""
function get_link_associations(
    globalNetworkId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "GET",
        "/global-networks/$(globalNetworkId)/link-associations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_link_associations(
    globalNetworkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "GET",
        "/global-networks/$(globalNetworkId)/link-associations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_links(global_network_id)
    get_links(global_network_id, params::Dict{String,<:Any})

Gets information about one or more links in a specified global network. If you specify the
site ID, you cannot specify the type or provider in the same request. You can specify the
type and provider in the same request.

# Arguments
- `global_network_id`: The ID of the global network.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"linkIds"`: One or more link IDs. The maximum is 10.
- `"maxResults"`: The maximum number of results to return.
- `"nextToken"`: The token for the next page of results.
- `"provider"`: The link provider.
- `"siteId"`: The ID of the site.
- `"type"`: The link type.
"""
function get_links(globalNetworkId; aws_config::AbstractAWSConfig=current_aws_config())
    return networkmanager(
        "GET",
        "/global-networks/$(globalNetworkId)/links";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_links(
    globalNetworkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "GET",
        "/global-networks/$(globalNetworkId)/links",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_network_resource_counts(global_network_id)
    get_network_resource_counts(global_network_id, params::Dict{String,<:Any})

Gets the count of network resources, by resource type, for the specified global network.

# Arguments
- `global_network_id`: The ID of the global network.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return.
- `"nextToken"`: The token for the next page of results.
- `"resourceType"`: The resource type. The following are the supported resource types for
  Direct Connect:    dxcon     dx-gateway     dx-vif    The following are the supported
  resource types for Network Manager:    attachment     connect-peer     connection
  core-network     device     link     peering     site    The following are the supported
  resource types for Amazon VPC:    customer-gateway     transit-gateway
  transit-gateway-attachment     transit-gateway-connect-peer     transit-gateway-route-table
      vpn-connection
"""
function get_network_resource_counts(
    globalNetworkId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "GET",
        "/global-networks/$(globalNetworkId)/network-resource-count";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_network_resource_counts(
    globalNetworkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "GET",
        "/global-networks/$(globalNetworkId)/network-resource-count",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_network_resource_relationships(global_network_id)
    get_network_resource_relationships(global_network_id, params::Dict{String,<:Any})

Gets the network resource relationships for the specified global network.

# Arguments
- `global_network_id`: The ID of the global network.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountId"`: The Amazon Web Services account ID.
- `"awsRegion"`: The Amazon Web Services Region.
- `"coreNetworkId"`: The ID of a core network.
- `"maxResults"`: The maximum number of results to return.
- `"nextToken"`: The token for the next page of results.
- `"registeredGatewayArn"`: The ARN of the registered gateway.
- `"resourceArn"`: The ARN of the gateway.
- `"resourceType"`: The resource type. The following are the supported resource types for
  Direct Connect:    dxcon     dx-gateway     dx-vif    The following are the supported
  resource types for Network Manager:    attachment     connect-peer     connection
  core-network     device     link     peering     site    The following are the supported
  resource types for Amazon VPC:    customer-gateway     transit-gateway
  transit-gateway-attachment     transit-gateway-connect-peer     transit-gateway-route-table
      vpn-connection
"""
function get_network_resource_relationships(
    globalNetworkId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "GET",
        "/global-networks/$(globalNetworkId)/network-resource-relationships";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_network_resource_relationships(
    globalNetworkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "GET",
        "/global-networks/$(globalNetworkId)/network-resource-relationships",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_network_resources(global_network_id)
    get_network_resources(global_network_id, params::Dict{String,<:Any})

Describes the network resources for the specified global network. The results include
information from the corresponding Describe call for the resource, minus any sensitive
information such as pre-shared keys.

# Arguments
- `global_network_id`: The ID of the global network.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountId"`: The Amazon Web Services account ID.
- `"awsRegion"`: The Amazon Web Services Region.
- `"coreNetworkId"`: The ID of a core network.
- `"maxResults"`: The maximum number of results to return.
- `"nextToken"`: The token for the next page of results.
- `"registeredGatewayArn"`: The ARN of the gateway.
- `"resourceArn"`: The ARN of the resource.
- `"resourceType"`: The resource type. The following are the supported resource types for
  Direct Connect:    dxcon     dx-gateway     dx-vif    The following are the supported
  resource types for Network Manager:    attachment     connect-peer     connection
  core-network     device     link     peering     site    The following are the supported
  resource types for Amazon VPC:    customer-gateway     transit-gateway
  transit-gateway-attachment     transit-gateway-connect-peer     transit-gateway-route-table
      vpn-connection
"""
function get_network_resources(
    globalNetworkId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "GET",
        "/global-networks/$(globalNetworkId)/network-resources";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_network_resources(
    globalNetworkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "GET",
        "/global-networks/$(globalNetworkId)/network-resources",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_network_routes(route_table_identifier, global_network_id)
    get_network_routes(route_table_identifier, global_network_id, params::Dict{String,<:Any})

Gets the network routes of the specified global network.

# Arguments
- `route_table_identifier`: The ID of the route table.
- `global_network_id`: The ID of the global network.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DestinationFilters"`: Filter by route table destination. Possible Values:
  TRANSIT_GATEWAY_ATTACHMENT_ID, RESOURCE_ID, or RESOURCE_TYPE.
- `"ExactCidrMatches"`: An exact CIDR block.
- `"LongestPrefixMatches"`: The most specific route that matches the traffic (longest
  prefix match).
- `"PrefixListIds"`: The IDs of the prefix lists.
- `"States"`: The route states.
- `"SubnetOfMatches"`: The routes with a subnet that match the specified CIDR filter.
- `"SupernetOfMatches"`: The routes with a CIDR that encompasses the CIDR filter. Example:
  If you specify 10.0.1.0/30, then the result returns 10.0.1.0/29.
- `"Types"`: The route types.
"""
function get_network_routes(
    RouteTableIdentifier,
    globalNetworkId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "POST",
        "/global-networks/$(globalNetworkId)/network-routes",
        Dict{String,Any}("RouteTableIdentifier" => RouteTableIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_network_routes(
    RouteTableIdentifier,
    globalNetworkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "POST",
        "/global-networks/$(globalNetworkId)/network-routes",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("RouteTableIdentifier" => RouteTableIdentifier),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_network_telemetry(global_network_id)
    get_network_telemetry(global_network_id, params::Dict{String,<:Any})

Gets the network telemetry of the specified global network.

# Arguments
- `global_network_id`: The ID of the global network.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountId"`: The Amazon Web Services account ID.
- `"awsRegion"`: The Amazon Web Services Region.
- `"coreNetworkId"`: The ID of a core network.
- `"maxResults"`: The maximum number of results to return.
- `"nextToken"`: The token for the next page of results.
- `"registeredGatewayArn"`: The ARN of the gateway.
- `"resourceArn"`: The ARN of the resource.
- `"resourceType"`: The resource type. The following are the supported resource types:
  connect-peer     transit-gateway-connect-peer     vpn-connection
"""
function get_network_telemetry(
    globalNetworkId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "GET",
        "/global-networks/$(globalNetworkId)/network-telemetry";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_network_telemetry(
    globalNetworkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "GET",
        "/global-networks/$(globalNetworkId)/network-telemetry",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_resource_policy(resource_arn)
    get_resource_policy(resource_arn, params::Dict{String,<:Any})

Returns information about a resource policy.

# Arguments
- `resource_arn`: The ARN of the resource.

"""
function get_resource_policy(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "GET",
        "/resource-policy/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_resource_policy(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "GET",
        "/resource-policy/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_route_analysis(global_network_id, route_analysis_id)
    get_route_analysis(global_network_id, route_analysis_id, params::Dict{String,<:Any})

Gets information about the specified route analysis.

# Arguments
- `global_network_id`: The ID of the global network.
- `route_analysis_id`: The ID of the route analysis.

"""
function get_route_analysis(
    globalNetworkId, routeAnalysisId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "GET",
        "/global-networks/$(globalNetworkId)/route-analyses/$(routeAnalysisId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_route_analysis(
    globalNetworkId,
    routeAnalysisId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "GET",
        "/global-networks/$(globalNetworkId)/route-analyses/$(routeAnalysisId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_site_to_site_vpn_attachment(attachment_id)
    get_site_to_site_vpn_attachment(attachment_id, params::Dict{String,<:Any})

Returns information about a site-to-site VPN attachment.

# Arguments
- `attachment_id`: The ID of the attachment.

"""
function get_site_to_site_vpn_attachment(
    attachmentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "GET",
        "/site-to-site-vpn-attachments/$(attachmentId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_site_to_site_vpn_attachment(
    attachmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "GET",
        "/site-to-site-vpn-attachments/$(attachmentId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_sites(global_network_id)
    get_sites(global_network_id, params::Dict{String,<:Any})

Gets information about one or more of your sites in a global network.

# Arguments
- `global_network_id`: The ID of the global network.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return.
- `"nextToken"`: The token for the next page of results.
- `"siteIds"`: One or more site IDs. The maximum is 10.
"""
function get_sites(globalNetworkId; aws_config::AbstractAWSConfig=current_aws_config())
    return networkmanager(
        "GET",
        "/global-networks/$(globalNetworkId)/sites";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_sites(
    globalNetworkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "GET",
        "/global-networks/$(globalNetworkId)/sites",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_transit_gateway_connect_peer_associations(global_network_id)
    get_transit_gateway_connect_peer_associations(global_network_id, params::Dict{String,<:Any})

Gets information about one or more of your transit gateway Connect peer associations in a
global network.

# Arguments
- `global_network_id`: The ID of the global network.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return.
- `"nextToken"`: The token for the next page of results.
- `"transitGatewayConnectPeerArns"`: One or more transit gateway Connect peer Amazon
  Resource Names (ARNs).
"""
function get_transit_gateway_connect_peer_associations(
    globalNetworkId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "GET",
        "/global-networks/$(globalNetworkId)/transit-gateway-connect-peer-associations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_transit_gateway_connect_peer_associations(
    globalNetworkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "GET",
        "/global-networks/$(globalNetworkId)/transit-gateway-connect-peer-associations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_transit_gateway_peering(peering_id)
    get_transit_gateway_peering(peering_id, params::Dict{String,<:Any})

Returns information about a transit gateway peer.

# Arguments
- `peering_id`: The ID of the peering request.

"""
function get_transit_gateway_peering(
    peeringId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "GET",
        "/transit-gateway-peerings/$(peeringId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_transit_gateway_peering(
    peeringId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "GET",
        "/transit-gateway-peerings/$(peeringId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_transit_gateway_registrations(global_network_id)
    get_transit_gateway_registrations(global_network_id, params::Dict{String,<:Any})

Gets information about the transit gateway registrations in a specified global network.

# Arguments
- `global_network_id`: The ID of the global network.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return.
- `"nextToken"`: The token for the next page of results.
- `"transitGatewayArns"`: The Amazon Resource Names (ARNs) of one or more transit gateways.
  The maximum is 10.
"""
function get_transit_gateway_registrations(
    globalNetworkId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "GET",
        "/global-networks/$(globalNetworkId)/transit-gateway-registrations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_transit_gateway_registrations(
    globalNetworkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "GET",
        "/global-networks/$(globalNetworkId)/transit-gateway-registrations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_transit_gateway_route_table_attachment(attachment_id)
    get_transit_gateway_route_table_attachment(attachment_id, params::Dict{String,<:Any})

Returns information about a transit gateway route table attachment.

# Arguments
- `attachment_id`: The ID of the transit gateway route table attachment.

"""
function get_transit_gateway_route_table_attachment(
    attachmentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "GET",
        "/transit-gateway-route-table-attachments/$(attachmentId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_transit_gateway_route_table_attachment(
    attachmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "GET",
        "/transit-gateway-route-table-attachments/$(attachmentId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_vpc_attachment(attachment_id)
    get_vpc_attachment(attachment_id, params::Dict{String,<:Any})

Returns information about a VPC attachment.

# Arguments
- `attachment_id`: The ID of the attachment.

"""
function get_vpc_attachment(
    attachmentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "GET",
        "/vpc-attachments/$(attachmentId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_vpc_attachment(
    attachmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "GET",
        "/vpc-attachments/$(attachmentId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_attachments()
    list_attachments(params::Dict{String,<:Any})

Returns a list of core network attachments.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"attachmentType"`: The type of attachment.
- `"coreNetworkId"`: The ID of a core network.
- `"edgeLocation"`: The Region where the edge is located.
- `"maxResults"`: The maximum number of results to return.
- `"nextToken"`: The token for the next page of results.
- `"state"`: The state of the attachment.
"""
function list_attachments(; aws_config::AbstractAWSConfig=current_aws_config())
    return networkmanager(
        "GET", "/attachments"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_attachments(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "GET",
        "/attachments",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_connect_peers()
    list_connect_peers(params::Dict{String,<:Any})

Returns a list of core network Connect peers.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"connectAttachmentId"`: The ID of the attachment.
- `"coreNetworkId"`: The ID of a core network.
- `"maxResults"`: The maximum number of results to return.
- `"nextToken"`: The token for the next page of results.
"""
function list_connect_peers(; aws_config::AbstractAWSConfig=current_aws_config())
    return networkmanager(
        "GET", "/connect-peers"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_connect_peers(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "GET",
        "/connect-peers",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_core_network_policy_versions(core_network_id)
    list_core_network_policy_versions(core_network_id, params::Dict{String,<:Any})

Returns a list of core network policy versions.

# Arguments
- `core_network_id`: The ID of a core network.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return.
- `"nextToken"`: The token for the next page of results.
"""
function list_core_network_policy_versions(
    coreNetworkId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "GET",
        "/core-networks/$(coreNetworkId)/core-network-policy-versions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_core_network_policy_versions(
    coreNetworkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "GET",
        "/core-networks/$(coreNetworkId)/core-network-policy-versions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_core_networks()
    list_core_networks(params::Dict{String,<:Any})

Returns a list of owned and shared core networks.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return.
- `"nextToken"`: The token for the next page of results.
"""
function list_core_networks(; aws_config::AbstractAWSConfig=current_aws_config())
    return networkmanager(
        "GET", "/core-networks"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_core_networks(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "GET",
        "/core-networks",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_organization_service_access_status()
    list_organization_service_access_status(params::Dict{String,<:Any})

Gets the status of the Service Linked Role (SLR) deployment for the accounts in a given
Amazon Web Services Organization.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return.
- `"nextToken"`: The token for the next page of results.
"""
function list_organization_service_access_status(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "GET",
        "/organizations/service-access";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_organization_service_access_status(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "GET",
        "/organizations/service-access",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_peerings()
    list_peerings(params::Dict{String,<:Any})

Lists the peerings for a core network.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"coreNetworkId"`: The ID of a core network.
- `"edgeLocation"`: Returns a list edge locations for the
- `"maxResults"`: The maximum number of results to return.
- `"nextToken"`: The token for the next page of results.
- `"peeringType"`: Returns a list of a peering requests.
- `"state"`: Returns a list of the peering request states.
"""
function list_peerings(; aws_config::AbstractAWSConfig=current_aws_config())
    return networkmanager(
        "GET", "/peerings"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_peerings(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "GET", "/peerings", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists the tags for a specified resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_core_network_policy(policy_document, core_network_id)
    put_core_network_policy(policy_document, core_network_id, params::Dict{String,<:Any})

Creates a new, immutable version of a core network policy. A subsequent change set is
created showing the differences between the LIVE policy and the submitted policy.

# Arguments
- `policy_document`: The policy document.
- `core_network_id`: The ID of a core network.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: The client token associated with the request.
- `"Description"`: a core network policy description.
- `"LatestVersionId"`: The ID of a core network policy.
"""
function put_core_network_policy(
    PolicyDocument, coreNetworkId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "POST",
        "/core-networks/$(coreNetworkId)/core-network-policy",
        Dict{String,Any}(
            "PolicyDocument" => PolicyDocument, "ClientToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_core_network_policy(
    PolicyDocument,
    coreNetworkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "POST",
        "/core-networks/$(coreNetworkId)/core-network-policy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "PolicyDocument" => PolicyDocument, "ClientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_resource_policy(policy_document, resource_arn)
    put_resource_policy(policy_document, resource_arn, params::Dict{String,<:Any})

Creates or updates a resource policy.

# Arguments
- `policy_document`: The JSON resource policy document.
- `resource_arn`: The ARN of the resource policy.

"""
function put_resource_policy(
    PolicyDocument, resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "POST",
        "/resource-policy/$(resourceArn)",
        Dict{String,Any}("PolicyDocument" => PolicyDocument);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_resource_policy(
    PolicyDocument,
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "POST",
        "/resource-policy/$(resourceArn)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("PolicyDocument" => PolicyDocument), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    register_transit_gateway(transit_gateway_arn, global_network_id)
    register_transit_gateway(transit_gateway_arn, global_network_id, params::Dict{String,<:Any})

Registers a transit gateway in your global network. Not all Regions support transit
gateways for global networks. For a list of the supported Regions, see Region Availability
in the Amazon Web Services Transit Gateways for Global Networks User Guide. The transit
gateway can be in any of the supported Amazon Web Services Regions, but it must be owned by
the same Amazon Web Services account that owns the global network. You cannot register a
transit gateway in more than one global network.

# Arguments
- `transit_gateway_arn`: The Amazon Resource Name (ARN) of the transit gateway.
- `global_network_id`: The ID of the global network.

"""
function register_transit_gateway(
    TransitGatewayArn, globalNetworkId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "POST",
        "/global-networks/$(globalNetworkId)/transit-gateway-registrations",
        Dict{String,Any}("TransitGatewayArn" => TransitGatewayArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function register_transit_gateway(
    TransitGatewayArn,
    globalNetworkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "POST",
        "/global-networks/$(globalNetworkId)/transit-gateway-registrations",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("TransitGatewayArn" => TransitGatewayArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    reject_attachment(attachment_id)
    reject_attachment(attachment_id, params::Dict{String,<:Any})

Rejects a core network attachment request.

# Arguments
- `attachment_id`: The ID of the attachment.

"""
function reject_attachment(attachmentId; aws_config::AbstractAWSConfig=current_aws_config())
    return networkmanager(
        "POST",
        "/attachments/$(attachmentId)/reject";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function reject_attachment(
    attachmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "POST",
        "/attachments/$(attachmentId)/reject",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    restore_core_network_policy_version(core_network_id, policy_version_id)
    restore_core_network_policy_version(core_network_id, policy_version_id, params::Dict{String,<:Any})

Restores a previous policy version as a new, immutable version of a core network policy. A
subsequent change set is created showing the differences between the LIVE policy and
restored policy.

# Arguments
- `core_network_id`: The ID of a core network.
- `policy_version_id`: The ID of the policy version to restore.

"""
function restore_core_network_policy_version(
    coreNetworkId, policyVersionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "POST",
        "/core-networks/$(coreNetworkId)/core-network-policy-versions/$(policyVersionId)/restore";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function restore_core_network_policy_version(
    coreNetworkId,
    policyVersionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "POST",
        "/core-networks/$(coreNetworkId)/core-network-policy-versions/$(policyVersionId)/restore",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_organization_service_access_update(action)
    start_organization_service_access_update(action, params::Dict{String,<:Any})

Enables the Network Manager service for an Amazon Web Services Organization. This can only
be called by a management account within the organization.

# Arguments
- `action`: The action to take for the update request. This can be either ENABLE or DISABLE.

"""
function start_organization_service_access_update(
    Action; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "POST",
        "/organizations/service-access",
        Dict{String,Any}("Action" => Action);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_organization_service_access_update(
    Action, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "POST",
        "/organizations/service-access",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Action" => Action), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_route_analysis(destination, source, global_network_id)
    start_route_analysis(destination, source, global_network_id, params::Dict{String,<:Any})

Starts analyzing the routing path between the specified source and destination. For more
information, see Route Analyzer.

# Arguments
- `destination`: The destination.
- `source`: The source from which traffic originates.
- `global_network_id`: The ID of the global network.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"IncludeReturnPath"`: Indicates whether to analyze the return path. The default is false.
- `"UseMiddleboxes"`: Indicates whether to include the location of middlebox appliances in
  the route analysis. The default is false.
"""
function start_route_analysis(
    Destination, Source, globalNetworkId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "POST",
        "/global-networks/$(globalNetworkId)/route-analyses",
        Dict{String,Any}("Destination" => Destination, "Source" => Source);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_route_analysis(
    Destination,
    Source,
    globalNetworkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "POST",
        "/global-networks/$(globalNetworkId)/route-analyses",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Destination" => Destination, "Source" => Source),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(tags, resource_arn)
    tag_resource(tags, resource_arn, params::Dict{String,<:Any})

Tags a specified resource.

# Arguments
- `tags`: The tags to apply to the specified resource.
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.

"""
function tag_resource(Tags, resourceArn; aws_config::AbstractAWSConfig=current_aws_config())
    return networkmanager(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    Tags,
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Tags" => Tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes tags from a specified resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.
- `tag_keys`: The tag keys to remove from the specified resource.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_connection(connection_id, global_network_id)
    update_connection(connection_id, global_network_id, params::Dict{String,<:Any})

Updates the information for an existing connection. To remove information for any of the
parameters, specify an empty string.

# Arguments
- `connection_id`: The ID of the connection.
- `global_network_id`: The ID of the global network.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConnectedLinkId"`: The ID of the link for the second device in the connection.
- `"Description"`: A description of the connection. Length Constraints: Maximum length of
  256 characters.
- `"LinkId"`: The ID of the link for the first device in the connection.
"""
function update_connection(
    connectionId, globalNetworkId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "PATCH",
        "/global-networks/$(globalNetworkId)/connections/$(connectionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_connection(
    connectionId,
    globalNetworkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "PATCH",
        "/global-networks/$(globalNetworkId)/connections/$(connectionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_core_network(core_network_id)
    update_core_network(core_network_id, params::Dict{String,<:Any})

Updates the description of a core network.

# Arguments
- `core_network_id`: The ID of a core network.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: The description of the update.
"""
function update_core_network(
    coreNetworkId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "PATCH",
        "/core-networks/$(coreNetworkId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_core_network(
    coreNetworkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "PATCH",
        "/core-networks/$(coreNetworkId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_device(device_id, global_network_id)
    update_device(device_id, global_network_id, params::Dict{String,<:Any})

Updates the details for an existing device. To remove information for any of the
parameters, specify an empty string.

# Arguments
- `device_id`: The ID of the device.
- `global_network_id`: The ID of the global network.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AWSLocation"`: The Amazon Web Services location of the device, if applicable. For an
  on-premises device, you can omit this parameter.
- `"Description"`: A description of the device. Constraints: Maximum length of 256
  characters.
- `"Location"`:
- `"Model"`: The model of the device. Constraints: Maximum length of 128 characters.
- `"SerialNumber"`: The serial number of the device. Constraints: Maximum length of 128
  characters.
- `"SiteId"`: The ID of the site.
- `"Type"`: The type of the device.
- `"Vendor"`: The vendor of the device. Constraints: Maximum length of 128 characters.
"""
function update_device(
    deviceId, globalNetworkId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "PATCH",
        "/global-networks/$(globalNetworkId)/devices/$(deviceId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_device(
    deviceId,
    globalNetworkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "PATCH",
        "/global-networks/$(globalNetworkId)/devices/$(deviceId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_global_network(global_network_id)
    update_global_network(global_network_id, params::Dict{String,<:Any})

Updates an existing global network. To remove information for any of the parameters,
specify an empty string.

# Arguments
- `global_network_id`: The ID of your global network.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description of the global network. Constraints: Maximum length of 256
  characters.
"""
function update_global_network(
    globalNetworkId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "PATCH",
        "/global-networks/$(globalNetworkId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_global_network(
    globalNetworkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "PATCH",
        "/global-networks/$(globalNetworkId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_link(global_network_id, link_id)
    update_link(global_network_id, link_id, params::Dict{String,<:Any})

Updates the details for an existing link. To remove information for any of the parameters,
specify an empty string.

# Arguments
- `global_network_id`: The ID of the global network.
- `link_id`: The ID of the link.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Bandwidth"`: The upload and download speed in Mbps.
- `"Description"`: A description of the link. Constraints: Maximum length of 256 characters.
- `"Provider"`: The provider of the link. Constraints: Maximum length of 128 characters.
- `"Type"`: The type of the link. Constraints: Maximum length of 128 characters.
"""
function update_link(
    globalNetworkId, linkId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "PATCH",
        "/global-networks/$(globalNetworkId)/links/$(linkId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_link(
    globalNetworkId,
    linkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "PATCH",
        "/global-networks/$(globalNetworkId)/links/$(linkId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_network_resource_metadata(metadata, global_network_id, resource_arn)
    update_network_resource_metadata(metadata, global_network_id, resource_arn, params::Dict{String,<:Any})

Updates the resource metadata for the specified global network.

# Arguments
- `metadata`: The resource metadata.
- `global_network_id`: The ID of the global network.
- `resource_arn`: The ARN of the resource.

"""
function update_network_resource_metadata(
    Metadata,
    globalNetworkId,
    resourceArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "PATCH",
        "/global-networks/$(globalNetworkId)/network-resources/$(resourceArn)/metadata",
        Dict{String,Any}("Metadata" => Metadata);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_network_resource_metadata(
    Metadata,
    globalNetworkId,
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "PATCH",
        "/global-networks/$(globalNetworkId)/network-resources/$(resourceArn)/metadata",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Metadata" => Metadata), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_site(global_network_id, site_id)
    update_site(global_network_id, site_id, params::Dict{String,<:Any})

Updates the information for an existing site. To remove information for any of the
parameters, specify an empty string.

# Arguments
- `global_network_id`: The ID of the global network.
- `site_id`: The ID of your site.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description of your site. Constraints: Maximum length of 256
  characters.
- `"Location"`: The site location:    Address: The physical address of the site.
  Latitude: The latitude of the site.     Longitude: The longitude of the site.
"""
function update_site(
    globalNetworkId, siteId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "PATCH",
        "/global-networks/$(globalNetworkId)/sites/$(siteId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_site(
    globalNetworkId,
    siteId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "PATCH",
        "/global-networks/$(globalNetworkId)/sites/$(siteId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_vpc_attachment(attachment_id)
    update_vpc_attachment(attachment_id, params::Dict{String,<:Any})

Updates a VPC attachment.

# Arguments
- `attachment_id`: The ID of the attachment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AddSubnetArns"`: Adds a subnet ARN to the VPC attachment.
- `"Options"`: Additional options for updating the VPC attachment.
- `"RemoveSubnetArns"`: Removes a subnet ARN from the attachment.
"""
function update_vpc_attachment(
    attachmentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmanager(
        "PATCH",
        "/vpc-attachments/$(attachmentId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_vpc_attachment(
    attachmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmanager(
        "PATCH",
        "/vpc-attachments/$(attachmentId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: chime_sdk_messaging
using AWS.Compat
using AWS.UUIDs

"""
    associate_channel_flow(channel_flow_arn, channel_arn, x-amz-chime-bearer)
    associate_channel_flow(channel_flow_arn, channel_arn, x-amz-chime-bearer, params::Dict{String,<:Any})

Associates a channel flow with a channel. Once associated, all messages to that channel go
through channel flow processors. To stop processing, use the DisassociateChannelFlow API.
Only administrators or channel moderators can associate a channel flow. The
x-amz-chime-bearer request header is mandatory. Use the ARN of the AppInstanceUser or
AppInstanceBot that makes the API call as the value in the header.

# Arguments
- `channel_flow_arn`: The ARN of the channel flow.
- `channel_arn`: The ARN of the channel.
- `x-amz-chime-bearer`: The AppInstanceUserArn of the user making the API call.

"""
function associate_channel_flow(
    ChannelFlowArn,
    channelArn,
    x_amz_chime_bearer;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "PUT",
        "/channels/$(channelArn)/channel-flow",
        Dict{String,Any}(
            "ChannelFlowArn" => ChannelFlowArn,
            "headers" => Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_channel_flow(
    ChannelFlowArn,
    channelArn,
    x_amz_chime_bearer,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "PUT",
        "/channels/$(channelArn)/channel-flow",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ChannelFlowArn" => ChannelFlowArn,
                    "headers" =>
                        Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_create_channel_membership(member_arns, channel_arn, x-amz-chime-bearer)
    batch_create_channel_membership(member_arns, channel_arn, x-amz-chime-bearer, params::Dict{String,<:Any})

Adds a specified number of users and bots to a channel.

# Arguments
- `member_arns`: The ARNs of the members you want to add to the channel. Only
  AppInstanceUsers and AppInstanceBots can be added as a channel member.
- `channel_arn`: The ARN of the channel to which you're adding users or bots.
- `x-amz-chime-bearer`: The ARN of the AppInstanceUser or AppInstanceBot that makes the API
  call.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"SubChannelId"`: The ID of the SubChannel in the request.   Only required when creating
  membership in a SubChannel for a moderator in an elastic channel.
- `"Type"`: The membership type of a user, DEFAULT or HIDDEN. Default members are always
  returned as part of ListChannelMemberships. Hidden members are only returned if the type
  filter in ListChannelMemberships equals HIDDEN. Otherwise hidden members are not returned.
  This is only supported by moderators.
"""
function batch_create_channel_membership(
    MemberArns,
    channelArn,
    x_amz_chime_bearer;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "POST",
        "/channels/$(channelArn)/memberships?operation=batch-create",
        Dict{String,Any}(
            "MemberArns" => MemberArns,
            "headers" => Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_create_channel_membership(
    MemberArns,
    channelArn,
    x_amz_chime_bearer,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "POST",
        "/channels/$(channelArn)/memberships?operation=batch-create",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "MemberArns" => MemberArns,
                    "headers" =>
                        Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    channel_flow_callback(callback_id, channel_message, channel_arn)
    channel_flow_callback(callback_id, channel_message, channel_arn, params::Dict{String,<:Any})

Calls back Amazon Chime SDK messaging with a processing response message. This should be
invoked from the processor Lambda. This is a developer API. You can return one of the
following processing responses:   Update message content or metadata   Deny a message
Make no changes to the message

# Arguments
- `callback_id`: The identifier passed to the processor by the service when invoked. Use
  the identifier to call back the service.
- `channel_message`: Stores information about the processed message.
- `channel_arn`: The ARN of the channel.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DeleteResource"`: When a processor determines that a message needs to be DENIED, pass
  this parameter with a value of true.
"""
function channel_flow_callback(
    CallbackId,
    ChannelMessage,
    channelArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "POST",
        "/channels/$(channelArn)?operation=channel-flow-callback",
        Dict{String,Any}("CallbackId" => CallbackId, "ChannelMessage" => ChannelMessage);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function channel_flow_callback(
    CallbackId,
    ChannelMessage,
    channelArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "POST",
        "/channels/$(channelArn)?operation=channel-flow-callback",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CallbackId" => CallbackId, "ChannelMessage" => ChannelMessage
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_channel(app_instance_arn, client_request_token, name, x-amz-chime-bearer)
    create_channel(app_instance_arn, client_request_token, name, x-amz-chime-bearer, params::Dict{String,<:Any})

Creates a channel to which you can add users and send messages.  Restriction: You can't
change a channel's privacy.  The x-amz-chime-bearer request header is mandatory. Use the
ARN of the AppInstanceUser or AppInstanceBot that makes the API call as the value in the
header.

# Arguments
- `app_instance_arn`: The ARN of the channel request.
- `client_request_token`: The client token for the request. An Idempotency token.
- `name`: The name of the channel.
- `x-amz-chime-bearer`: The ARN of the AppInstanceUser or AppInstanceBot that makes the API
  call.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ChannelId"`: The ID of the channel in the request.
- `"ElasticChannelConfiguration"`: The attributes required to configure and create an
  elastic channel. An elastic channel can support a maximum of 1-million users, excluding
  moderators.
- `"ExpirationSettings"`: Settings that control the interval after which the channel is
  automatically deleted.
- `"MemberArns"`: The ARNs of the channel members in the request.
- `"Metadata"`: The metadata of the creation request. Limited to 1KB and UTF-8.
- `"Mode"`: The channel mode: UNRESTRICTED or RESTRICTED. Administrators, moderators, and
  channel members can add themselves and other members to unrestricted channels. Only
  administrators and moderators can add members to restricted channels.
- `"ModeratorArns"`: The ARNs of the channel moderators in the request.
- `"Privacy"`: The channel's privacy level: PUBLIC or PRIVATE. Private channels aren't
  discoverable by users outside the channel. Public channels are discoverable by anyone in
  the AppInstance.
- `"Tags"`: The tags for the creation request.
"""
function create_channel(
    AppInstanceArn,
    ClientRequestToken,
    Name,
    x_amz_chime_bearer;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "POST",
        "/channels",
        Dict{String,Any}(
            "AppInstanceArn" => AppInstanceArn,
            "ClientRequestToken" => ClientRequestToken,
            "Name" => Name,
            "headers" => Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_channel(
    AppInstanceArn,
    ClientRequestToken,
    Name,
    x_amz_chime_bearer,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "POST",
        "/channels",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AppInstanceArn" => AppInstanceArn,
                    "ClientRequestToken" => ClientRequestToken,
                    "Name" => Name,
                    "headers" =>
                        Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_channel_ban(member_arn, channel_arn, x-amz-chime-bearer)
    create_channel_ban(member_arn, channel_arn, x-amz-chime-bearer, params::Dict{String,<:Any})

Permanently bans a member from a channel. Moderators can't add banned members to a channel.
To undo a ban, you first have to DeleteChannelBan, and then CreateChannelMembership. Bans
are cleaned up when you delete users or channels. If you ban a user who is already part of
a channel, that user is automatically kicked from the channel.  The x-amz-chime-bearer
request header is mandatory. Use the ARN of the AppInstanceUser or AppInstanceBot that
makes the API call as the value in the header.

# Arguments
- `member_arn`: The AppInstanceUserArn of the member being banned.
- `channel_arn`: The ARN of the ban request.
- `x-amz-chime-bearer`: The ARN of the AppInstanceUser or AppInstanceBot that makes the API
  call.

"""
function create_channel_ban(
    MemberArn,
    channelArn,
    x_amz_chime_bearer;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "POST",
        "/channels/$(channelArn)/bans",
        Dict{String,Any}(
            "MemberArn" => MemberArn,
            "headers" => Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_channel_ban(
    MemberArn,
    channelArn,
    x_amz_chime_bearer,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "POST",
        "/channels/$(channelArn)/bans",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "MemberArn" => MemberArn,
                    "headers" =>
                        Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_channel_flow(app_instance_arn, client_request_token, name, processors)
    create_channel_flow(app_instance_arn, client_request_token, name, processors, params::Dict{String,<:Any})

Creates a channel flow, a container for processors. Processors are AWS Lambda functions
that perform actions on chat messages, such as stripping out profanity. You can associate
channel flows with channels, and the processors in the channel flow then take action on all
messages sent to that channel. This is a developer API. Channel flows process the following
items:   New and updated messages   Persistent and non-persistent messages   The Standard
message type    Channel flows don't process Control or System messages. For more
information about the message types provided by Chime SDK messaging, refer to Message types
in the Amazon Chime developer guide.

# Arguments
- `app_instance_arn`: The ARN of the channel flow request.
- `client_request_token`: The client token for the request. An Idempotency token.
- `name`: The name of the channel flow.
- `processors`: Information about the processor Lambda functions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: The tags for the creation request.
"""
function create_channel_flow(
    AppInstanceArn,
    ClientRequestToken,
    Name,
    Processors;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "POST",
        "/channel-flows",
        Dict{String,Any}(
            "AppInstanceArn" => AppInstanceArn,
            "ClientRequestToken" => ClientRequestToken,
            "Name" => Name,
            "Processors" => Processors,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_channel_flow(
    AppInstanceArn,
    ClientRequestToken,
    Name,
    Processors,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "POST",
        "/channel-flows",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AppInstanceArn" => AppInstanceArn,
                    "ClientRequestToken" => ClientRequestToken,
                    "Name" => Name,
                    "Processors" => Processors,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_channel_membership(member_arn, type, channel_arn, x-amz-chime-bearer)
    create_channel_membership(member_arn, type, channel_arn, x-amz-chime-bearer, params::Dict{String,<:Any})

Adds a member to a channel. The InvitedBy field in ChannelMembership is derived from the
request header. A channel member can:   List messages   Send messages   Receive messages
Edit their own messages   Leave the channel   Privacy settings impact this action as
follows:   Public Channels: You do not need to be a member to list messages, but you must
be a member to send messages.   Private Channels: You must be a member to list or send
messages.    The x-amz-chime-bearer request header is mandatory. Use the ARN of the
AppInstanceUserArn or AppInstanceBot that makes the API call as the value in the header.

# Arguments
- `member_arn`: The AppInstanceUserArn of the member you want to add to the channel.
- `type`: The membership type of a user, DEFAULT or HIDDEN. Default members are always
  returned as part of ListChannelMemberships. Hidden members are only returned if the type
  filter in ListChannelMemberships equals HIDDEN. Otherwise hidden members are not returned.
  This is only supported by moderators.
- `channel_arn`: The ARN of the channel to which you're adding users.
- `x-amz-chime-bearer`: The ARN of the AppInstanceUser or AppInstanceBot that makes the API
  call.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"SubChannelId"`: The ID of the SubChannel in the request.  Only required when creating
  membership in a SubChannel for a moderator in an elastic channel.
"""
function create_channel_membership(
    MemberArn,
    Type,
    channelArn,
    x_amz_chime_bearer;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "POST",
        "/channels/$(channelArn)/memberships",
        Dict{String,Any}(
            "MemberArn" => MemberArn,
            "Type" => Type,
            "headers" => Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_channel_membership(
    MemberArn,
    Type,
    channelArn,
    x_amz_chime_bearer,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "POST",
        "/channels/$(channelArn)/memberships",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "MemberArn" => MemberArn,
                    "Type" => Type,
                    "headers" =>
                        Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_channel_moderator(channel_moderator_arn, channel_arn, x-amz-chime-bearer)
    create_channel_moderator(channel_moderator_arn, channel_arn, x-amz-chime-bearer, params::Dict{String,<:Any})

Creates a new ChannelModerator. A channel moderator can:   Add and remove other members of
the channel.   Add and remove other moderators of the channel.   Add and remove user bans
for the channel.   Redact messages in the channel.   List messages in the channel.    The
x-amz-chime-bearer request header is mandatory. Use the ARN of the AppInstanceUser or
AppInstanceBotof the user that makes the API call as the value in the header.

# Arguments
- `channel_moderator_arn`: The AppInstanceUserArn of the moderator.
- `channel_arn`: The ARN of the channel.
- `x-amz-chime-bearer`: The ARN of the AppInstanceUser or AppInstanceBot that makes the API
  call.

"""
function create_channel_moderator(
    ChannelModeratorArn,
    channelArn,
    x_amz_chime_bearer;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "POST",
        "/channels/$(channelArn)/moderators",
        Dict{String,Any}(
            "ChannelModeratorArn" => ChannelModeratorArn,
            "headers" => Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_channel_moderator(
    ChannelModeratorArn,
    channelArn,
    x_amz_chime_bearer,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "POST",
        "/channels/$(channelArn)/moderators",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ChannelModeratorArn" => ChannelModeratorArn,
                    "headers" =>
                        Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_channel(channel_arn, x-amz-chime-bearer)
    delete_channel(channel_arn, x-amz-chime-bearer, params::Dict{String,<:Any})

Immediately makes a channel and its memberships inaccessible and marks them for deletion.
This is an irreversible process.  The x-amz-chime-bearer request header is mandatory. Use
the ARN of the AppInstanceUserArn or AppInstanceBot that makes the API call as the value in
the header.

# Arguments
- `channel_arn`: The ARN of the channel being deleted.
- `x-amz-chime-bearer`: The ARN of the AppInstanceUser or AppInstanceBot that makes the API
  call.

"""
function delete_channel(
    channelArn, x_amz_chime_bearer; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_messaging(
        "DELETE",
        "/channels/$(channelArn)",
        Dict{String,Any}(
            "headers" => Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_channel(
    channelArn,
    x_amz_chime_bearer,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "DELETE",
        "/channels/$(channelArn)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "headers" =>
                        Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_channel_ban(channel_arn, member_arn, x-amz-chime-bearer)
    delete_channel_ban(channel_arn, member_arn, x-amz-chime-bearer, params::Dict{String,<:Any})

Removes a member from a channel's ban list.  The x-amz-chime-bearer request header is
mandatory. Use the ARN of the AppInstanceUser or AppInstanceBot that makes the API call as
the value in the header.

# Arguments
- `channel_arn`: The ARN of the channel from which the AppInstanceUser was banned.
- `member_arn`: The ARN of the AppInstanceUser that you want to reinstate.
- `x-amz-chime-bearer`: The ARN of the AppInstanceUser or AppInstanceBot that makes the API
  call.

"""
function delete_channel_ban(
    channelArn,
    memberArn,
    x_amz_chime_bearer;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "DELETE",
        "/channels/$(channelArn)/bans/$(memberArn)",
        Dict{String,Any}(
            "headers" => Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_channel_ban(
    channelArn,
    memberArn,
    x_amz_chime_bearer,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "DELETE",
        "/channels/$(channelArn)/bans/$(memberArn)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "headers" =>
                        Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_channel_flow(channel_flow_arn)
    delete_channel_flow(channel_flow_arn, params::Dict{String,<:Any})

Deletes a channel flow, an irreversible process. This is a developer API.   This API works
only when the channel flow is not associated with any channel. To get a list of all
channels that a channel flow is associated with, use the
ListChannelsAssociatedWithChannelFlow API. Use the DisassociateChannelFlow API to
disassociate a channel flow from all channels.

# Arguments
- `channel_flow_arn`: The ARN of the channel flow.

"""
function delete_channel_flow(
    channelFlowArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_messaging(
        "DELETE",
        "/channel-flows/$(channelFlowArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_channel_flow(
    channelFlowArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "DELETE",
        "/channel-flows/$(channelFlowArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_channel_membership(channel_arn, member_arn, x-amz-chime-bearer)
    delete_channel_membership(channel_arn, member_arn, x-amz-chime-bearer, params::Dict{String,<:Any})

Removes a member from a channel.  The x-amz-chime-bearer request header is mandatory. Use
the AppInstanceUserArn of the user that makes the API call as the value in the header.

# Arguments
- `channel_arn`: The ARN of the channel from which you want to remove the user.
- `member_arn`: The AppInstanceUserArn of the member that you're removing from the channel.
- `x-amz-chime-bearer`: The ARN of the AppInstanceUser or AppInstanceBot that makes the API
  call.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"sub-channel-id"`: The ID of the SubChannel in the request.  Only for use by moderators.
"""
function delete_channel_membership(
    channelArn,
    memberArn,
    x_amz_chime_bearer;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "DELETE",
        "/channels/$(channelArn)/memberships/$(memberArn)",
        Dict{String,Any}(
            "headers" => Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_channel_membership(
    channelArn,
    memberArn,
    x_amz_chime_bearer,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "DELETE",
        "/channels/$(channelArn)/memberships/$(memberArn)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "headers" =>
                        Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_channel_message(channel_arn, message_id, x-amz-chime-bearer)
    delete_channel_message(channel_arn, message_id, x-amz-chime-bearer, params::Dict{String,<:Any})

Deletes a channel message. Only admins can perform this action. Deletion makes messages
inaccessible immediately. A background process deletes any revisions created by
UpdateChannelMessage.  The x-amz-chime-bearer request header is mandatory. Use the ARN of
the AppInstanceUser or AppInstanceBot that makes the API call as the value in the header.

# Arguments
- `channel_arn`: The ARN of the channel.
- `message_id`: The ID of the message being deleted.
- `x-amz-chime-bearer`: The ARN of the AppInstanceUser or AppInstanceBot that makes the API
  call.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"sub-channel-id"`: The ID of the SubChannel in the request.  Only required when deleting
  messages in a SubChannel that the user belongs to.
"""
function delete_channel_message(
    channelArn,
    messageId,
    x_amz_chime_bearer;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "DELETE",
        "/channels/$(channelArn)/messages/$(messageId)",
        Dict{String,Any}(
            "headers" => Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_channel_message(
    channelArn,
    messageId,
    x_amz_chime_bearer,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "DELETE",
        "/channels/$(channelArn)/messages/$(messageId)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "headers" =>
                        Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_channel_moderator(channel_arn, channel_moderator_arn, x-amz-chime-bearer)
    delete_channel_moderator(channel_arn, channel_moderator_arn, x-amz-chime-bearer, params::Dict{String,<:Any})

Deletes a channel moderator.  The x-amz-chime-bearer request header is mandatory. Use the
ARN of the AppInstanceUser or AppInstanceBot that makes the API call as the value in the
header.

# Arguments
- `channel_arn`: The ARN of the channel.
- `channel_moderator_arn`: The AppInstanceUserArn of the moderator being deleted.
- `x-amz-chime-bearer`: The ARN of the AppInstanceUser or AppInstanceBot that makes the API
  call.

"""
function delete_channel_moderator(
    channelArn,
    channelModeratorArn,
    x_amz_chime_bearer;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "DELETE",
        "/channels/$(channelArn)/moderators/$(channelModeratorArn)",
        Dict{String,Any}(
            "headers" => Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_channel_moderator(
    channelArn,
    channelModeratorArn,
    x_amz_chime_bearer,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "DELETE",
        "/channels/$(channelArn)/moderators/$(channelModeratorArn)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "headers" =>
                        Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_messaging_streaming_configurations(app_instance_arn)
    delete_messaging_streaming_configurations(app_instance_arn, params::Dict{String,<:Any})

Deletes the streaming configurations for an AppInstance. For more information, see
Streaming messaging data in the Amazon Chime SDK Developer Guide.

# Arguments
- `app_instance_arn`: The ARN of the streaming configurations being deleted.

"""
function delete_messaging_streaming_configurations(
    appInstanceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_messaging(
        "DELETE",
        "/app-instances/$(appInstanceArn)/streaming-configurations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_messaging_streaming_configurations(
    appInstanceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "DELETE",
        "/app-instances/$(appInstanceArn)/streaming-configurations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_channel(channel_arn, x-amz-chime-bearer)
    describe_channel(channel_arn, x-amz-chime-bearer, params::Dict{String,<:Any})

Returns the full details of a channel in an Amazon Chime AppInstance.  The
x-amz-chime-bearer request header is mandatory. Use the ARN of the AppInstanceUser or
AppInstanceBot that makes the API call as the value in the header.

# Arguments
- `channel_arn`: The ARN of the channel.
- `x-amz-chime-bearer`: The ARN of the AppInstanceUser or AppInstanceBot that makes the API
  call.

"""
function describe_channel(
    channelArn, x_amz_chime_bearer; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_messaging(
        "GET",
        "/channels/$(channelArn)",
        Dict{String,Any}(
            "headers" => Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_channel(
    channelArn,
    x_amz_chime_bearer,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "GET",
        "/channels/$(channelArn)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "headers" =>
                        Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_channel_ban(channel_arn, member_arn, x-amz-chime-bearer)
    describe_channel_ban(channel_arn, member_arn, x-amz-chime-bearer, params::Dict{String,<:Any})

Returns the full details of a channel ban.  The x-amz-chime-bearer request header is
mandatory. Use the ARN of the AppInstanceUser or AppInstanceBot that makes the API call as
the value in the header.

# Arguments
- `channel_arn`: The ARN of the channel from which the user is banned.
- `member_arn`: The AppInstanceUserArn of the member being banned.
- `x-amz-chime-bearer`: The ARN of the AppInstanceUser or AppInstanceBot that makes the API
  call.

"""
function describe_channel_ban(
    channelArn,
    memberArn,
    x_amz_chime_bearer;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "GET",
        "/channels/$(channelArn)/bans/$(memberArn)",
        Dict{String,Any}(
            "headers" => Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_channel_ban(
    channelArn,
    memberArn,
    x_amz_chime_bearer,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "GET",
        "/channels/$(channelArn)/bans/$(memberArn)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "headers" =>
                        Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_channel_flow(channel_flow_arn)
    describe_channel_flow(channel_flow_arn, params::Dict{String,<:Any})

Returns the full details of a channel flow in an Amazon Chime AppInstance. This is a
developer API.

# Arguments
- `channel_flow_arn`: The ARN of the channel flow.

"""
function describe_channel_flow(
    channelFlowArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_messaging(
        "GET",
        "/channel-flows/$(channelFlowArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_channel_flow(
    channelFlowArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "GET",
        "/channel-flows/$(channelFlowArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_channel_membership(channel_arn, member_arn, x-amz-chime-bearer)
    describe_channel_membership(channel_arn, member_arn, x-amz-chime-bearer, params::Dict{String,<:Any})

Returns the full details of a user's channel membership.  The x-amz-chime-bearer request
header is mandatory. Use the ARN of the AppInstanceUser or AppInstanceBot that makes the
API call as the value in the header.

# Arguments
- `channel_arn`: The ARN of the channel.
- `member_arn`: The AppInstanceUserArn of the member.
- `x-amz-chime-bearer`: The ARN of the AppInstanceUser or AppInstanceBot that makes the API
  call.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"sub-channel-id"`: The ID of the SubChannel in the request. The response contains an
  ElasticChannelConfiguration object.  Only required to get a user’s SubChannel membership
  details.
"""
function describe_channel_membership(
    channelArn,
    memberArn,
    x_amz_chime_bearer;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "GET",
        "/channels/$(channelArn)/memberships/$(memberArn)",
        Dict{String,Any}(
            "headers" => Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_channel_membership(
    channelArn,
    memberArn,
    x_amz_chime_bearer,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "GET",
        "/channels/$(channelArn)/memberships/$(memberArn)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "headers" =>
                        Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_channel_membership_for_app_instance_user(app-instance-user-arn, channel_arn, x-amz-chime-bearer)
    describe_channel_membership_for_app_instance_user(app-instance-user-arn, channel_arn, x-amz-chime-bearer, params::Dict{String,<:Any})

 Returns the details of a channel based on the membership of the specified AppInstanceUser
or AppInstanceBot.  The x-amz-chime-bearer request header is mandatory. Use the ARN of the
AppInstanceUser or AppInstanceBot that makes the API call as the value in the header.

# Arguments
- `app-instance-user-arn`: The ARN of the user or bot in a channel.
- `channel_arn`: The ARN of the channel to which the user belongs.
- `x-amz-chime-bearer`: The ARN of the AppInstanceUser or AppInstanceBot that makes the API
  call.

"""
function describe_channel_membership_for_app_instance_user(
    app_instance_user_arn,
    channelArn,
    x_amz_chime_bearer;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "GET",
        "/channels/$(channelArn)?scope=app-instance-user-membership",
        Dict{String,Any}(
            "app-instance-user-arn" => app_instance_user_arn,
            "headers" => Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_channel_membership_for_app_instance_user(
    app_instance_user_arn,
    channelArn,
    x_amz_chime_bearer,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "GET",
        "/channels/$(channelArn)?scope=app-instance-user-membership",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "app-instance-user-arn" => app_instance_user_arn,
                    "headers" =>
                        Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_channel_moderated_by_app_instance_user(app-instance-user-arn, channel_arn, x-amz-chime-bearer)
    describe_channel_moderated_by_app_instance_user(app-instance-user-arn, channel_arn, x-amz-chime-bearer, params::Dict{String,<:Any})

Returns the full details of a channel moderated by the specified AppInstanceUser or
AppInstanceBot.  The x-amz-chime-bearer request header is mandatory. Use the ARN of the
AppInstanceUser or AppInstanceBot that makes the API call as the value in the header.

# Arguments
- `app-instance-user-arn`: The ARN of the user or bot in the moderated channel.
- `channel_arn`: The ARN of the moderated channel.
- `x-amz-chime-bearer`: The ARN of the AppInstanceUser or AppInstanceBot that makes the API
  call.

"""
function describe_channel_moderated_by_app_instance_user(
    app_instance_user_arn,
    channelArn,
    x_amz_chime_bearer;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "GET",
        "/channels/$(channelArn)?scope=app-instance-user-moderated-channel",
        Dict{String,Any}(
            "app-instance-user-arn" => app_instance_user_arn,
            "headers" => Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_channel_moderated_by_app_instance_user(
    app_instance_user_arn,
    channelArn,
    x_amz_chime_bearer,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "GET",
        "/channels/$(channelArn)?scope=app-instance-user-moderated-channel",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "app-instance-user-arn" => app_instance_user_arn,
                    "headers" =>
                        Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_channel_moderator(channel_arn, channel_moderator_arn, x-amz-chime-bearer)
    describe_channel_moderator(channel_arn, channel_moderator_arn, x-amz-chime-bearer, params::Dict{String,<:Any})

Returns the full details of a single ChannelModerator.  The x-amz-chime-bearer request
header is mandatory. Use the AppInstanceUserArn of the user that makes the API call as the
value in the header.

# Arguments
- `channel_arn`: The ARN of the channel.
- `channel_moderator_arn`: The AppInstanceUserArn of the channel moderator.
- `x-amz-chime-bearer`: The ARN of the AppInstanceUser or AppInstanceBot that makes the API
  call.

"""
function describe_channel_moderator(
    channelArn,
    channelModeratorArn,
    x_amz_chime_bearer;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "GET",
        "/channels/$(channelArn)/moderators/$(channelModeratorArn)",
        Dict{String,Any}(
            "headers" => Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_channel_moderator(
    channelArn,
    channelModeratorArn,
    x_amz_chime_bearer,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "GET",
        "/channels/$(channelArn)/moderators/$(channelModeratorArn)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "headers" =>
                        Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_channel_flow(channel_arn, channel_flow_arn, x-amz-chime-bearer)
    disassociate_channel_flow(channel_arn, channel_flow_arn, x-amz-chime-bearer, params::Dict{String,<:Any})

Disassociates a channel flow from all its channels. Once disassociated, all messages to
that channel stop going through the channel flow processor.  Only administrators or channel
moderators can disassociate a channel flow. The x-amz-chime-bearer request header is
mandatory. Use the ARN of the AppInstanceUser or AppInstanceBot that makes the API call as
the value in the header.

# Arguments
- `channel_arn`: The ARN of the channel.
- `channel_flow_arn`: The ARN of the channel flow.
- `x-amz-chime-bearer`: The AppInstanceUserArn of the user making the API call.

"""
function disassociate_channel_flow(
    channelArn,
    channelFlowArn,
    x_amz_chime_bearer;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "DELETE",
        "/channels/$(channelArn)/channel-flow/$(channelFlowArn)",
        Dict{String,Any}(
            "headers" => Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_channel_flow(
    channelArn,
    channelFlowArn,
    x_amz_chime_bearer,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "DELETE",
        "/channels/$(channelArn)/channel-flow/$(channelFlowArn)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "headers" =>
                        Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_channel_membership_preferences(channel_arn, member_arn, x-amz-chime-bearer)
    get_channel_membership_preferences(channel_arn, member_arn, x-amz-chime-bearer, params::Dict{String,<:Any})

Gets the membership preferences of an AppInstanceUser or AppInstanceBot for the specified
channel. A user or a bot must be a member of the channel and own the membership in order to
retrieve membership preferences. Users or bots in the AppInstanceAdmin and channel
moderator roles can't retrieve preferences for other users or bots. Banned users or bots
can't retrieve membership preferences for the channel from which they are banned.  The
x-amz-chime-bearer request header is mandatory. Use the ARN of the AppInstanceUser or
AppInstanceBot that makes the API call as the value in the header.

# Arguments
- `channel_arn`: The ARN of the channel.
- `member_arn`: The AppInstanceUserArn of the member retrieving the preferences.
- `x-amz-chime-bearer`: The ARN of the AppInstanceUser or AppInstanceBot that makes the API
  call.

"""
function get_channel_membership_preferences(
    channelArn,
    memberArn,
    x_amz_chime_bearer;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "GET",
        "/channels/$(channelArn)/memberships/$(memberArn)/preferences",
        Dict{String,Any}(
            "headers" => Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_channel_membership_preferences(
    channelArn,
    memberArn,
    x_amz_chime_bearer,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "GET",
        "/channels/$(channelArn)/memberships/$(memberArn)/preferences",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "headers" =>
                        Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_channel_message(channel_arn, message_id, x-amz-chime-bearer)
    get_channel_message(channel_arn, message_id, x-amz-chime-bearer, params::Dict{String,<:Any})

Gets the full details of a channel message.  The x-amz-chime-bearer request header is
mandatory. Use the ARN of the AppInstanceUser or AppInstanceBot that makes the API call as
the value in the header.

# Arguments
- `channel_arn`: The ARN of the channel.
- `message_id`: The ID of the message.
- `x-amz-chime-bearer`: The ARN of the AppInstanceUser or AppInstanceBot that makes the API
  call.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"sub-channel-id"`: The ID of the SubChannel in the request.  Only required when getting
  messages in a SubChannel that the user belongs to.
"""
function get_channel_message(
    channelArn,
    messageId,
    x_amz_chime_bearer;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "GET",
        "/channels/$(channelArn)/messages/$(messageId)",
        Dict{String,Any}(
            "headers" => Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_channel_message(
    channelArn,
    messageId,
    x_amz_chime_bearer,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "GET",
        "/channels/$(channelArn)/messages/$(messageId)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "headers" =>
                        Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_channel_message_status(channel_arn, message_id, x-amz-chime-bearer)
    get_channel_message_status(channel_arn, message_id, x-amz-chime-bearer, params::Dict{String,<:Any})

Gets message status for a specified messageId. Use this API to determine the intermediate
status of messages going through channel flow processing. The API provides an alternative
to retrieving message status if the event was not received because a client wasn't
connected to a websocket.  Messages can have any one of these statuses.  SENT  Message
processed successfully  PENDING  Ongoing processing  FAILED  Processing failed  DENIED
Message denied by the processor      This API does not return statuses for denied messages,
because we don't store them once the processor denies them.    Only the message sender can
invoke this API.   The x-amz-chime-bearer request header is mandatory. Use the ARN of the
AppInstanceUser or AppInstanceBot that makes the API call as the value in the header.

# Arguments
- `channel_arn`: The ARN of the channel
- `message_id`: The ID of the message.
- `x-amz-chime-bearer`: The AppInstanceUserArn of the user making the API call.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"sub-channel-id"`: The ID of the SubChannel in the request.  Only required when getting
  message status in a SubChannel that the user belongs to.
"""
function get_channel_message_status(
    channelArn,
    messageId,
    x_amz_chime_bearer;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "GET",
        "/channels/$(channelArn)/messages/$(messageId)?scope=message-status",
        Dict{String,Any}(
            "headers" => Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_channel_message_status(
    channelArn,
    messageId,
    x_amz_chime_bearer,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "GET",
        "/channels/$(channelArn)/messages/$(messageId)?scope=message-status",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "headers" =>
                        Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_messaging_session_endpoint()
    get_messaging_session_endpoint(params::Dict{String,<:Any})

The details of the endpoint for the messaging session.

"""
function get_messaging_session_endpoint(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_messaging(
        "GET",
        "/endpoints/messaging-session";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_messaging_session_endpoint(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_messaging(
        "GET",
        "/endpoints/messaging-session",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_messaging_streaming_configurations(app_instance_arn)
    get_messaging_streaming_configurations(app_instance_arn, params::Dict{String,<:Any})

Retrieves the data streaming configuration for an AppInstance. For more information, see
Streaming messaging data in the Amazon Chime SDK Developer Guide.

# Arguments
- `app_instance_arn`: The ARN of the streaming configurations.

"""
function get_messaging_streaming_configurations(
    appInstanceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_messaging(
        "GET",
        "/app-instances/$(appInstanceArn)/streaming-configurations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_messaging_streaming_configurations(
    appInstanceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "GET",
        "/app-instances/$(appInstanceArn)/streaming-configurations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_channel_bans(channel_arn, x-amz-chime-bearer)
    list_channel_bans(channel_arn, x-amz-chime-bearer, params::Dict{String,<:Any})

Lists all the users and bots banned from a particular channel.  The x-amz-chime-bearer
request header is mandatory. Use the ARN of the AppInstanceUser or AppInstanceBot that
makes the API call as the value in the header.

# Arguments
- `channel_arn`: The ARN of the channel.
- `x-amz-chime-bearer`: The ARN of the AppInstanceUser or AppInstanceBot that makes the API
  call.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"max-results"`: The maximum number of bans that you want returned.
- `"next-token"`: The token passed by previous API calls until all requested bans are
  returned.
"""
function list_channel_bans(
    channelArn, x_amz_chime_bearer; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_messaging(
        "GET",
        "/channels/$(channelArn)/bans",
        Dict{String,Any}(
            "headers" => Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_channel_bans(
    channelArn,
    x_amz_chime_bearer,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "GET",
        "/channels/$(channelArn)/bans",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "headers" =>
                        Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_channel_flows(app-instance-arn)
    list_channel_flows(app-instance-arn, params::Dict{String,<:Any})

Returns a paginated lists of all the channel flows created under a single Chime. This is a
developer API.

# Arguments
- `app-instance-arn`: The ARN of the app instance.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"max-results"`: The maximum number of channel flows that you want to return.
- `"next-token"`: The token passed by previous API calls until all requested channel flows
  are returned.
"""
function list_channel_flows(
    app_instance_arn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_messaging(
        "GET",
        "/channel-flows",
        Dict{String,Any}("app-instance-arn" => app_instance_arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_channel_flows(
    app_instance_arn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "GET",
        "/channel-flows",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("app-instance-arn" => app_instance_arn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_channel_memberships(channel_arn, x-amz-chime-bearer)
    list_channel_memberships(channel_arn, x-amz-chime-bearer, params::Dict{String,<:Any})

Lists all channel memberships in a channel.  The x-amz-chime-bearer request header is
mandatory. Use the ARN of the AppInstanceUser or AppInstanceBot that makes the API call as
the value in the header.  If you want to list the channels to which a specific app instance
user belongs, see the ListChannelMembershipsForAppInstanceUser API.

# Arguments
- `channel_arn`: The maximum number of channel memberships that you want returned.
- `x-amz-chime-bearer`: The ARN of the AppInstanceUser or AppInstanceBot that makes the API
  call.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"max-results"`: The maximum number of channel memberships that you want returned.
- `"next-token"`: The token passed by previous API calls until all requested channel
  memberships are returned.
- `"sub-channel-id"`: The ID of the SubChannel in the request.  Only required when listing
  a user's memberships in a particular sub-channel of an elastic channel.
- `"type"`: The membership type of a user, DEFAULT or HIDDEN. Default members are returned
  as part of ListChannelMemberships if no type is specified. Hidden members are only returned
  if the type filter in ListChannelMemberships equals HIDDEN.
"""
function list_channel_memberships(
    channelArn, x_amz_chime_bearer; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_messaging(
        "GET",
        "/channels/$(channelArn)/memberships",
        Dict{String,Any}(
            "headers" => Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_channel_memberships(
    channelArn,
    x_amz_chime_bearer,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "GET",
        "/channels/$(channelArn)/memberships",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "headers" =>
                        Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_channel_memberships_for_app_instance_user(x-amz-chime-bearer)
    list_channel_memberships_for_app_instance_user(x-amz-chime-bearer, params::Dict{String,<:Any})

 Lists all channels that an AppInstanceUser or AppInstanceBot is a part of. Only an
AppInstanceAdmin can call the API with a user ARN that is not their own.   The
x-amz-chime-bearer request header is mandatory. Use the ARN of the AppInstanceUser or
AppInstanceBot that makes the API call as the value in the header.

# Arguments
- `x-amz-chime-bearer`: The ARN of the AppInstanceUser or AppInstanceBot that makes the API
  call.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"app-instance-user-arn"`: The ARN of the user or bot.
- `"max-results"`: The maximum number of users that you want returned.
- `"next-token"`: The token returned from previous API requests until the number of channel
  memberships is reached.
"""
function list_channel_memberships_for_app_instance_user(
    x_amz_chime_bearer; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_messaging(
        "GET",
        "/channels?scope=app-instance-user-memberships",
        Dict{String,Any}(
            "headers" => Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_channel_memberships_for_app_instance_user(
    x_amz_chime_bearer,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "GET",
        "/channels?scope=app-instance-user-memberships",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "headers" =>
                        Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_channel_messages(channel_arn, x-amz-chime-bearer)
    list_channel_messages(channel_arn, x-amz-chime-bearer, params::Dict{String,<:Any})

List all the messages in a channel. Returns a paginated list of ChannelMessages. By
default, sorted by creation timestamp in descending order.  Redacted messages appear in the
results as empty, since they are only redacted, not deleted. Deleted messages do not appear
in the results. This action always returns the latest version of an edited message. Also,
the x-amz-chime-bearer request header is mandatory. Use the ARN of the AppInstanceUser or
AppInstanceBot that makes the API call as the value in the header.

# Arguments
- `channel_arn`: The ARN of the channel.
- `x-amz-chime-bearer`: The ARN of the AppInstanceUser or AppInstanceBot that makes the API
  call.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"max-results"`: The maximum number of messages that you want returned.
- `"next-token"`: The token passed by previous API calls until all requested messages are
  returned.
- `"not-after"`: The final or ending time stamp for your requested messages.
- `"not-before"`: The initial or starting time stamp for your requested messages.
- `"sort-order"`: The order in which you want messages sorted. Default is Descending, based
  on time created.
- `"sub-channel-id"`: The ID of the SubChannel in the request.  Only required when listing
  the messages in a SubChannel that the user belongs to.
"""
function list_channel_messages(
    channelArn, x_amz_chime_bearer; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_messaging(
        "GET",
        "/channels/$(channelArn)/messages",
        Dict{String,Any}(
            "headers" => Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_channel_messages(
    channelArn,
    x_amz_chime_bearer,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "GET",
        "/channels/$(channelArn)/messages",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "headers" =>
                        Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_channel_moderators(channel_arn, x-amz-chime-bearer)
    list_channel_moderators(channel_arn, x-amz-chime-bearer, params::Dict{String,<:Any})

Lists all the moderators for a channel.  The x-amz-chime-bearer request header is
mandatory. Use the ARN of the AppInstanceUser or AppInstanceBot that makes the API call as
the value in the header.

# Arguments
- `channel_arn`: The ARN of the channel.
- `x-amz-chime-bearer`: The ARN of the AppInstanceUser or AppInstanceBot that makes the API
  call.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"max-results"`: The maximum number of moderators that you want returned.
- `"next-token"`: The token passed by previous API calls until all requested moderators are
  returned.
"""
function list_channel_moderators(
    channelArn, x_amz_chime_bearer; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_messaging(
        "GET",
        "/channels/$(channelArn)/moderators",
        Dict{String,Any}(
            "headers" => Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_channel_moderators(
    channelArn,
    x_amz_chime_bearer,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "GET",
        "/channels/$(channelArn)/moderators",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "headers" =>
                        Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_channels(app-instance-arn, x-amz-chime-bearer)
    list_channels(app-instance-arn, x-amz-chime-bearer, params::Dict{String,<:Any})

Lists all Channels created under a single Chime App as a paginated list. You can specify
filters to narrow results.  Functionality &amp; restrictions    Use privacy = PUBLIC to
retrieve all public channels in the account.   Only an AppInstanceAdmin can set privacy =
PRIVATE to list the private channels in an account.    The x-amz-chime-bearer request
header is mandatory. Use the ARN of the AppInstanceUser or AppInstanceBot that makes the
API call as the value in the header.

# Arguments
- `app-instance-arn`: The ARN of the AppInstance.
- `x-amz-chime-bearer`: The ARN of the AppInstanceUser or AppInstanceBot that makes the API
  call.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"max-results"`: The maximum number of channels that you want to return.
- `"next-token"`: The token passed by previous API calls until all requested channels are
  returned.
- `"privacy"`: The privacy setting. PUBLIC retrieves all the public channels. PRIVATE
  retrieves private channels. Only an AppInstanceAdmin can retrieve private channels.
"""
function list_channels(
    app_instance_arn, x_amz_chime_bearer; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_messaging(
        "GET",
        "/channels",
        Dict{String,Any}(
            "app-instance-arn" => app_instance_arn,
            "headers" => Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_channels(
    app_instance_arn,
    x_amz_chime_bearer,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "GET",
        "/channels",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "app-instance-arn" => app_instance_arn,
                    "headers" =>
                        Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_channels_associated_with_channel_flow(channel-flow-arn)
    list_channels_associated_with_channel_flow(channel-flow-arn, params::Dict{String,<:Any})

Lists all channels associated with a specified channel flow. You can associate a channel
flow with multiple channels, but you can only associate a channel with one channel flow.
This is a developer API.

# Arguments
- `channel-flow-arn`: The ARN of the channel flow.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"max-results"`: The maximum number of channels that you want to return.
- `"next-token"`: The token passed by previous API calls until all requested channels are
  returned.
"""
function list_channels_associated_with_channel_flow(
    channel_flow_arn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_messaging(
        "GET",
        "/channels?scope=channel-flow-associations",
        Dict{String,Any}("channel-flow-arn" => channel_flow_arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_channels_associated_with_channel_flow(
    channel_flow_arn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "GET",
        "/channels?scope=channel-flow-associations",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("channel-flow-arn" => channel_flow_arn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_channels_moderated_by_app_instance_user(x-amz-chime-bearer)
    list_channels_moderated_by_app_instance_user(x-amz-chime-bearer, params::Dict{String,<:Any})

A list of the channels moderated by an AppInstanceUser.  The x-amz-chime-bearer request
header is mandatory. Use the ARN of the AppInstanceUser or AppInstanceBot that makes the
API call as the value in the header.

# Arguments
- `x-amz-chime-bearer`: The ARN of the AppInstanceUser or AppInstanceBot that makes the API
  call.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"app-instance-user-arn"`: The ARN of the user or bot in the moderated channel.
- `"max-results"`: The maximum number of channels in the request.
- `"next-token"`: The token returned from previous API requests until the number of
  channels moderated by the user is reached.
"""
function list_channels_moderated_by_app_instance_user(
    x_amz_chime_bearer; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_messaging(
        "GET",
        "/channels?scope=app-instance-user-moderated-channels",
        Dict{String,Any}(
            "headers" => Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_channels_moderated_by_app_instance_user(
    x_amz_chime_bearer,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "GET",
        "/channels?scope=app-instance-user-moderated-channels",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "headers" =>
                        Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_sub_channels(channel_arn, x-amz-chime-bearer)
    list_sub_channels(channel_arn, x-amz-chime-bearer, params::Dict{String,<:Any})

Lists all the SubChannels in an elastic channel when given a channel ID. Available only to
the app instance admins and channel moderators of elastic channels.

# Arguments
- `channel_arn`: The ARN of elastic channel.
- `x-amz-chime-bearer`: The AppInstanceUserArn of the user making the API call.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"max-results"`: The maximum number of sub-channels that you want to return.
- `"next-token"`: The token passed by previous API calls until all requested sub-channels
  are returned.
"""
function list_sub_channels(
    channelArn, x_amz_chime_bearer; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_messaging(
        "GET",
        "/channels/$(channelArn)/subchannels",
        Dict{String,Any}(
            "headers" => Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_sub_channels(
    channelArn,
    x_amz_chime_bearer,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "GET",
        "/channels/$(channelArn)/subchannels",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "headers" =>
                        Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(arn)
    list_tags_for_resource(arn, params::Dict{String,<:Any})

Lists the tags applied to an Amazon Chime SDK messaging resource.

# Arguments
- `arn`: The ARN of the resource.

"""
function list_tags_for_resource(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return chime_sdk_messaging(
        "GET",
        "/tags",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_messaging(
        "GET",
        "/tags",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_channel_expiration_settings(channel_arn)
    put_channel_expiration_settings(channel_arn, params::Dict{String,<:Any})

Sets the number of days before the channel is automatically deleted.    A background
process deletes expired channels within 6 hours of expiration. Actual deletion times may
vary.   Expired channels that have not yet been deleted appear as active, and you can
update their expiration settings. The system honors the new settings.   The
x-amz-chime-bearer request header is mandatory. Use the ARN of the AppInstanceUser or
AppInstanceBot that makes the API call as the value in the header.

# Arguments
- `channel_arn`: The ARN of the channel.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ExpirationSettings"`: Settings that control the interval after which a channel is
  deleted.
- `"x-amz-chime-bearer"`: The ARN of the AppInstanceUser or AppInstanceBot that makes the
  API call.
"""
function put_channel_expiration_settings(
    channelArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_messaging(
        "PUT",
        "/channels/$(channelArn)/expiration-settings";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_channel_expiration_settings(
    channelArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "PUT",
        "/channels/$(channelArn)/expiration-settings",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_channel_membership_preferences(preferences, channel_arn, member_arn, x-amz-chime-bearer)
    put_channel_membership_preferences(preferences, channel_arn, member_arn, x-amz-chime-bearer, params::Dict{String,<:Any})

Sets the membership preferences of an AppInstanceUser or AppInstanceBot for the specified
channel. The user or bot must be a member of the channel. Only the user or bot who owns the
membership can set preferences. Users or bots in the AppInstanceAdmin and channel moderator
roles can't set preferences for other users. Banned users or bots can't set membership
preferences for the channel from which they are banned.  The x-amz-chime-bearer request
header is mandatory. Use the ARN of an AppInstanceUser or AppInstanceBot that makes the API
call as the value in the header.

# Arguments
- `preferences`: The channel membership preferences of an AppInstanceUser .
- `channel_arn`: The ARN of the channel.
- `member_arn`: The ARN of the member setting the preferences.
- `x-amz-chime-bearer`: The ARN of the AppInstanceUser or AppInstanceBot that makes the API
  call.

"""
function put_channel_membership_preferences(
    Preferences,
    channelArn,
    memberArn,
    x_amz_chime_bearer;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "PUT",
        "/channels/$(channelArn)/memberships/$(memberArn)/preferences",
        Dict{String,Any}(
            "Preferences" => Preferences,
            "headers" => Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_channel_membership_preferences(
    Preferences,
    channelArn,
    memberArn,
    x_amz_chime_bearer,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "PUT",
        "/channels/$(channelArn)/memberships/$(memberArn)/preferences",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Preferences" => Preferences,
                    "headers" =>
                        Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_messaging_streaming_configurations(streaming_configurations, app_instance_arn)
    put_messaging_streaming_configurations(streaming_configurations, app_instance_arn, params::Dict{String,<:Any})

Sets the data streaming configuration for an AppInstance. For more information, see
Streaming messaging data in the Amazon Chime SDK Developer Guide.

# Arguments
- `streaming_configurations`: The streaming configurations.
- `app_instance_arn`: The ARN of the streaming configuration.

"""
function put_messaging_streaming_configurations(
    StreamingConfigurations,
    appInstanceArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "PUT",
        "/app-instances/$(appInstanceArn)/streaming-configurations",
        Dict{String,Any}("StreamingConfigurations" => StreamingConfigurations);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_messaging_streaming_configurations(
    StreamingConfigurations,
    appInstanceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "PUT",
        "/app-instances/$(appInstanceArn)/streaming-configurations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("StreamingConfigurations" => StreamingConfigurations),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    redact_channel_message(channel_arn, message_id, x-amz-chime-bearer)
    redact_channel_message(channel_arn, message_id, x-amz-chime-bearer, params::Dict{String,<:Any})

Redacts message content, but not metadata. The message exists in the back end, but the
action returns null content, and the state shows as redacted.  The x-amz-chime-bearer
request header is mandatory. Use the ARN of the AppInstanceUser or AppInstanceBot that
makes the API call as the value in the header.

# Arguments
- `channel_arn`: The ARN of the channel containing the messages that you want to redact.
- `message_id`: The ID of the message being redacted.
- `x-amz-chime-bearer`: The ARN of the AppInstanceUser or AppInstanceBot that makes the API
  call.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"SubChannelId"`: The ID of the SubChannel in the request.
"""
function redact_channel_message(
    channelArn,
    messageId,
    x_amz_chime_bearer;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "POST",
        "/channels/$(channelArn)/messages/$(messageId)?operation=redact",
        Dict{String,Any}(
            "headers" => Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function redact_channel_message(
    channelArn,
    messageId,
    x_amz_chime_bearer,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "POST",
        "/channels/$(channelArn)/messages/$(messageId)?operation=redact",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "headers" =>
                        Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    search_channels(fields)
    search_channels(fields, params::Dict{String,<:Any})

Allows the ChimeBearer to search channels by channel members. Users or bots can search
across the channels that they belong to. Users in the AppInstanceAdmin role can search
across all channels. The x-amz-chime-bearer request header is mandatory. Use the ARN of the
AppInstanceUser or AppInstanceBot that makes the API call as the value in the header.

# Arguments
- `fields`: A list of the Field objects in the channel being searched.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"max-results"`: The maximum number of channels that you want returned.
- `"next-token"`: The token returned from previous API requests until the number of
  channels is reached.
- `"x-amz-chime-bearer"`: The AppInstanceUserArn of the user making the API call.
"""
function search_channels(Fields; aws_config::AbstractAWSConfig=current_aws_config())
    return chime_sdk_messaging(
        "POST",
        "/channels?operation=search",
        Dict{String,Any}("Fields" => Fields);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function search_channels(
    Fields, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_messaging(
        "POST",
        "/channels?operation=search",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Fields" => Fields), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    send_channel_message(client_request_token, content, persistence, type, channel_arn, x-amz-chime-bearer)
    send_channel_message(client_request_token, content, persistence, type, channel_arn, x-amz-chime-bearer, params::Dict{String,<:Any})

Sends a message to a particular channel that the member is a part of.  The
x-amz-chime-bearer request header is mandatory. Use the ARN of the AppInstanceUser or
AppInstanceBot that makes the API call as the value in the header. Also, STANDARD messages
can be up to 4KB in size and contain metadata. Metadata is arbitrary, and you can use it in
a variety of ways, such as containing a link to an attachment.  CONTROL messages are
limited to 30 bytes and do not contain metadata.

# Arguments
- `client_request_token`: The Idempotency token for each client request.
- `content`: The content of the channel message.
- `persistence`: Boolean that controls whether the message is persisted on the back end.
  Required.
- `type`: The type of message, STANDARD or CONTROL.  STANDARD messages can be up to 4KB in
  size and contain metadata. Metadata is arbitrary, and you can use it in a variety of ways,
  such as containing a link to an attachment.  CONTROL messages are limited to 30 bytes and
  do not contain metadata.
- `channel_arn`: The ARN of the channel.
- `x-amz-chime-bearer`: The ARN of the AppInstanceUser or AppInstanceBot that makes the API
  call.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ContentType"`: The content type of the channel message.
- `"MessageAttributes"`: The attributes for the message, used for message filtering along
  with a FilterRule defined in the PushNotificationPreferences.
- `"Metadata"`: The optional metadata for each message.
- `"PushNotification"`: The push notification configuration of the message.
- `"SubChannelId"`: The ID of the SubChannel in the request.
- `"Target"`: The target of a message. Must be a member of the channel, such as another
  user, a bot, or the sender. Only the target and the sender can view targeted messages. Only
  users who can see targeted messages can take actions on them. However, administrators can
  delete targeted messages that they can’t see.
"""
function send_channel_message(
    ClientRequestToken,
    Content,
    Persistence,
    Type,
    channelArn,
    x_amz_chime_bearer;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "POST",
        "/channels/$(channelArn)/messages",
        Dict{String,Any}(
            "ClientRequestToken" => ClientRequestToken,
            "Content" => Content,
            "Persistence" => Persistence,
            "Type" => Type,
            "headers" => Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function send_channel_message(
    ClientRequestToken,
    Content,
    Persistence,
    Type,
    channelArn,
    x_amz_chime_bearer,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "POST",
        "/channels/$(channelArn)/messages",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClientRequestToken" => ClientRequestToken,
                    "Content" => Content,
                    "Persistence" => Persistence,
                    "Type" => Type,
                    "headers" =>
                        Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Applies the specified tags to the specified Amazon Chime SDK messaging resource.

# Arguments
- `resource_arn`: The resource ARN.
- `tags`: The tag key-value pairs.

"""
function tag_resource(ResourceARN, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return chime_sdk_messaging(
        "POST",
        "/tags?operation=tag-resource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceARN,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "POST",
        "/tags?operation=tag-resource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes the specified tags from the specified Amazon Chime SDK messaging resource.

# Arguments
- `resource_arn`: The resource ARN.
- `tag_keys`: The tag keys.

"""
function untag_resource(
    ResourceARN, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_messaging(
        "POST",
        "/tags?operation=untag-resource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceARN,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "POST",
        "/tags?operation=untag-resource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_channel(channel_arn, x-amz-chime-bearer)
    update_channel(channel_arn, x-amz-chime-bearer, params::Dict{String,<:Any})

Update a channel's attributes.  Restriction: You can't change a channel's privacy.   The
x-amz-chime-bearer request header is mandatory. Use the ARN of the AppInstanceUser or
AppInstanceBot that makes the API call as the value in the header.

# Arguments
- `channel_arn`: The ARN of the channel.
- `x-amz-chime-bearer`: The ARN of the AppInstanceUser or AppInstanceBot that makes the API
  call.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Metadata"`: The metadata for the update request.
- `"Mode"`: The mode of the update request.
- `"Name"`: The name of the channel.
"""
function update_channel(
    channelArn, x_amz_chime_bearer; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_messaging(
        "PUT",
        "/channels/$(channelArn)",
        Dict{String,Any}(
            "headers" => Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_channel(
    channelArn,
    x_amz_chime_bearer,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "PUT",
        "/channels/$(channelArn)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "headers" =>
                        Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_channel_flow(name, processors, channel_flow_arn)
    update_channel_flow(name, processors, channel_flow_arn, params::Dict{String,<:Any})

Updates channel flow attributes. This is a developer API.

# Arguments
- `name`: The name of the channel flow.
- `processors`: Information about the processor Lambda functions
- `channel_flow_arn`: The ARN of the channel flow.

"""
function update_channel_flow(
    Name, Processors, channelFlowArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_messaging(
        "PUT",
        "/channel-flows/$(channelFlowArn)",
        Dict{String,Any}("Name" => Name, "Processors" => Processors);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_channel_flow(
    Name,
    Processors,
    channelFlowArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "PUT",
        "/channel-flows/$(channelFlowArn)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("Name" => Name, "Processors" => Processors), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_channel_message(content, channel_arn, message_id, x-amz-chime-bearer)
    update_channel_message(content, channel_arn, message_id, x-amz-chime-bearer, params::Dict{String,<:Any})

Updates the content of a message.  The x-amz-chime-bearer request header is mandatory. Use
the ARN of the AppInstanceUser or AppInstanceBot that makes the API call as the value in
the header.

# Arguments
- `content`: The content of the channel message.
- `channel_arn`: The ARN of the channel.
- `message_id`: The ID string of the message being updated.
- `x-amz-chime-bearer`: The ARN of the AppInstanceUser or AppInstanceBot that makes the API
  call.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ContentType"`: The content type of the channel message.
- `"Metadata"`: The metadata of the message being updated.
- `"SubChannelId"`: The ID of the SubChannel in the request.  Only required when updating
  messages in a SubChannel that the user belongs to.
"""
function update_channel_message(
    Content,
    channelArn,
    messageId,
    x_amz_chime_bearer;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "PUT",
        "/channels/$(channelArn)/messages/$(messageId)",
        Dict{String,Any}(
            "Content" => Content,
            "headers" => Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_channel_message(
    Content,
    channelArn,
    messageId,
    x_amz_chime_bearer,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "PUT",
        "/channels/$(channelArn)/messages/$(messageId)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Content" => Content,
                    "headers" =>
                        Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_channel_read_marker(channel_arn, x-amz-chime-bearer)
    update_channel_read_marker(channel_arn, x-amz-chime-bearer, params::Dict{String,<:Any})

The details of the time when a user last read messages in a channel.  The
x-amz-chime-bearer request header is mandatory. Use the ARN of the AppInstanceUser or
AppInstanceBot that makes the API call as the value in the header.

# Arguments
- `channel_arn`: The ARN of the channel.
- `x-amz-chime-bearer`: The ARN of the AppInstanceUser or AppInstanceBot that makes the API
  call.

"""
function update_channel_read_marker(
    channelArn, x_amz_chime_bearer; aws_config::AbstractAWSConfig=current_aws_config()
)
    return chime_sdk_messaging(
        "PUT",
        "/channels/$(channelArn)/readMarker",
        Dict{String,Any}(
            "headers" => Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_channel_read_marker(
    channelArn,
    x_amz_chime_bearer,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return chime_sdk_messaging(
        "PUT",
        "/channels/$(channelArn)/readMarker",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "headers" =>
                        Dict{String,Any}("x-amz-chime-bearer" => x_amz_chime_bearer),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: service_catalog
using AWS.Compat
using AWS.UUIDs

"""
    accept_portfolio_share(portfolio_id)
    accept_portfolio_share(portfolio_id, params::Dict{String,<:Any})

Accepts an offer to share the specified portfolio.

# Arguments
- `portfolio_id`: The portfolio identifier.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
- `"PortfolioShareType"`: The type of shared portfolios to accept. The default is to accept
  imported portfolios.    AWS_ORGANIZATIONS - Accept portfolios shared by the management
  account of your organization.    IMPORTED - Accept imported portfolios.
  AWS_SERVICECATALOG - Not supported. (Throws ResourceNotFoundException.)   For example, aws
  servicecatalog accept-portfolio-share --portfolio-id \"port-2qwzkwxt3y5fk\"
  --portfolio-share-type AWS_ORGANIZATIONS
"""
function accept_portfolio_share(
    PortfolioId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "AcceptPortfolioShare",
        Dict{String,Any}("PortfolioId" => PortfolioId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function accept_portfolio_share(
    PortfolioId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "AcceptPortfolioShare",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("PortfolioId" => PortfolioId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_budget_with_resource(budget_name, resource_id)
    associate_budget_with_resource(budget_name, resource_id, params::Dict{String,<:Any})

Associates the specified budget with the specified resource.

# Arguments
- `budget_name`: The name of the budget you want to associate.
- `resource_id`:  The resource identifier. Either a portfolio-id or a product-id.

"""
function associate_budget_with_resource(
    BudgetName, ResourceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "AssociateBudgetWithResource",
        Dict{String,Any}("BudgetName" => BudgetName, "ResourceId" => ResourceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_budget_with_resource(
    BudgetName,
    ResourceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "AssociateBudgetWithResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("BudgetName" => BudgetName, "ResourceId" => ResourceId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_principal_with_portfolio(portfolio_id, principal_arn, principal_type)
    associate_principal_with_portfolio(portfolio_id, principal_arn, principal_type, params::Dict{String,<:Any})

Associates the specified principal ARN with the specified portfolio. If you share the
portfolio with principal name sharing enabled, the PrincipalARN association is included in
the share.  The PortfolioID, PrincipalARN, and PrincipalType parameters are required.  You
can associate a maximum of 10 Principals with a portfolio using PrincipalType as
IAM_PATTERN.   When you associate a principal with portfolio, a potential privilege
escalation path may occur when that portfolio is then shared with other accounts. For a
user in a recipient account who is not an Service Catalog Admin, but still has the ability
to create Principals (Users/Groups/Roles), that user could create a role that matches a
principal name association for the portfolio. Although this user may not know which
principal names are associated through Service Catalog, they may be able to guess the user.
If this potential escalation path is a concern, then Service Catalog recommends using
PrincipalType as IAM. With this configuration, the PrincipalARN must already exist in the
recipient account before it can be associated.

# Arguments
- `portfolio_id`: The portfolio identifier.
- `principal_arn`: The ARN of the principal (user, role, or group). If the PrincipalType is
  IAM, the supported value is a fully defined IAM Amazon Resource Name (ARN). If the
  PrincipalType is IAM_PATTERN, the supported value is an IAM ARN without an AccountID in the
  following format:  arn:partition:iam:::resource-type/resource-id  The ARN resource-id can
  be either:   A fully formed resource-id. For example, arn:aws:iam:::role/resource-name or
  arn:aws:iam:::role/resource-path/resource-name    A wildcard ARN. The wildcard ARN accepts
  IAM_PATTERN values with a \"*\" or \"?\" in the resource-id segment of the ARN. For example
  arn:partition:service:::resource-type/resource-path/resource-name. The new symbols are
  exclusive to the resource-path and resource-name and cannot replace the resource-type or
  other ARN values.  The ARN path and principal name allow unlimited wildcard characters.
  Examples of an acceptable wildcard ARN:   arn:aws:iam:::role/ResourceName_*
  arn:aws:iam:::role/*/ResourceName_?   Examples of an unacceptable wildcard ARN:
  arn:aws:iam:::*/ResourceName   You can associate multiple IAM_PATTERNs even if the account
  has no principal with that name.  The \"?\" wildcard character matches zero or one of any
  character. This is similar to \".?\" in regular regex context. The \"*\" wildcard character
  matches any number of any characters. This is similar to \".*\" in regular regex context.
  In the IAM Principal ARN format
  (arn:partition:iam:::resource-type/resource-path/resource-name), valid resource-type values
  include user/, group/, or role/. The \"?\" and \"*\" characters are allowed only after the
  resource-type in the resource-id segment. You can use special characters anywhere within
  the resource-id.  The \"*\" character also matches the \"/\" character, allowing paths to
  be formed within the resource-id. For example, arn:aws:iam:::role/*/ResourceName_? matches
  both arn:aws:iam:::role/pathA/pathB/ResourceName_1 and
  arn:aws:iam:::role/pathA/ResourceName_1.
- `principal_type`: The principal type. The supported value is IAM if you use a fully
  defined Amazon Resource Name (ARN), or IAM_PATTERN if you use an ARN with no accountID,
  with or without wildcard characters.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
"""
function associate_principal_with_portfolio(
    PortfolioId,
    PrincipalARN,
    PrincipalType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "AssociatePrincipalWithPortfolio",
        Dict{String,Any}(
            "PortfolioId" => PortfolioId,
            "PrincipalARN" => PrincipalARN,
            "PrincipalType" => PrincipalType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_principal_with_portfolio(
    PortfolioId,
    PrincipalARN,
    PrincipalType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "AssociatePrincipalWithPortfolio",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "PortfolioId" => PortfolioId,
                    "PrincipalARN" => PrincipalARN,
                    "PrincipalType" => PrincipalType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_product_with_portfolio(portfolio_id, product_id)
    associate_product_with_portfolio(portfolio_id, product_id, params::Dict{String,<:Any})

Associates the specified product with the specified portfolio. A delegated admin is
authorized to invoke this command.

# Arguments
- `portfolio_id`: The portfolio identifier.
- `product_id`: The product identifier.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
- `"SourcePortfolioId"`: The identifier of the source portfolio.
"""
function associate_product_with_portfolio(
    PortfolioId, ProductId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "AssociateProductWithPortfolio",
        Dict{String,Any}("PortfolioId" => PortfolioId, "ProductId" => ProductId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_product_with_portfolio(
    PortfolioId,
    ProductId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "AssociateProductWithPortfolio",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("PortfolioId" => PortfolioId, "ProductId" => ProductId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_service_action_with_provisioning_artifact(product_id, provisioning_artifact_id, service_action_id)
    associate_service_action_with_provisioning_artifact(product_id, provisioning_artifact_id, service_action_id, params::Dict{String,<:Any})

Associates a self-service action with a provisioning artifact.

# Arguments
- `product_id`: The product identifier. For example, prod-abcdzk7xy33qa.
- `provisioning_artifact_id`: The identifier of the provisioning artifact. For example,
  pa-4abcdjnxjj6ne.
- `service_action_id`: The self-service action identifier. For example, act-fs7abcd89wxyz.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
- `"IdempotencyToken"`: A unique identifier that you provide to ensure idempotency. If
  multiple requests from the same Amazon Web Services account use the same idempotency token,
  the same response is returned for each repeated request.
"""
function associate_service_action_with_provisioning_artifact(
    ProductId,
    ProvisioningArtifactId,
    ServiceActionId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "AssociateServiceActionWithProvisioningArtifact",
        Dict{String,Any}(
            "ProductId" => ProductId,
            "ProvisioningArtifactId" => ProvisioningArtifactId,
            "ServiceActionId" => ServiceActionId,
            "IdempotencyToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_service_action_with_provisioning_artifact(
    ProductId,
    ProvisioningArtifactId,
    ServiceActionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "AssociateServiceActionWithProvisioningArtifact",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ProductId" => ProductId,
                    "ProvisioningArtifactId" => ProvisioningArtifactId,
                    "ServiceActionId" => ServiceActionId,
                    "IdempotencyToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_tag_option_with_resource(resource_id, tag_option_id)
    associate_tag_option_with_resource(resource_id, tag_option_id, params::Dict{String,<:Any})

Associate the specified TagOption with the specified portfolio or product.

# Arguments
- `resource_id`: The resource identifier.
- `tag_option_id`: The TagOption identifier.

"""
function associate_tag_option_with_resource(
    ResourceId, TagOptionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "AssociateTagOptionWithResource",
        Dict{String,Any}("ResourceId" => ResourceId, "TagOptionId" => TagOptionId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_tag_option_with_resource(
    ResourceId,
    TagOptionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "AssociateTagOptionWithResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceId" => ResourceId, "TagOptionId" => TagOptionId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_associate_service_action_with_provisioning_artifact(service_action_associations)
    batch_associate_service_action_with_provisioning_artifact(service_action_associations, params::Dict{String,<:Any})

Associates multiple self-service actions with provisioning artifacts.

# Arguments
- `service_action_associations`: One or more associations, each consisting of the Action
  ID, the Product ID, and the Provisioning Artifact ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
"""
function batch_associate_service_action_with_provisioning_artifact(
    ServiceActionAssociations; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "BatchAssociateServiceActionWithProvisioningArtifact",
        Dict{String,Any}("ServiceActionAssociations" => ServiceActionAssociations);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_associate_service_action_with_provisioning_artifact(
    ServiceActionAssociations,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "BatchAssociateServiceActionWithProvisioningArtifact",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ServiceActionAssociations" => ServiceActionAssociations),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_disassociate_service_action_from_provisioning_artifact(service_action_associations)
    batch_disassociate_service_action_from_provisioning_artifact(service_action_associations, params::Dict{String,<:Any})

Disassociates a batch of self-service actions from the specified provisioning artifact.

# Arguments
- `service_action_associations`: One or more associations, each consisting of the Action
  ID, the Product ID, and the Provisioning Artifact ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
"""
function batch_disassociate_service_action_from_provisioning_artifact(
    ServiceActionAssociations; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "BatchDisassociateServiceActionFromProvisioningArtifact",
        Dict{String,Any}("ServiceActionAssociations" => ServiceActionAssociations);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_disassociate_service_action_from_provisioning_artifact(
    ServiceActionAssociations,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "BatchDisassociateServiceActionFromProvisioningArtifact",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ServiceActionAssociations" => ServiceActionAssociations),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    copy_product(idempotency_token, source_product_arn)
    copy_product(idempotency_token, source_product_arn, params::Dict{String,<:Any})

Copies the specified source product to the specified target product or a new product. You
can copy a product to the same account or another account. You can copy a product to the
same Region or another Region. If you copy a product to another account, you must first
share the product in a portfolio using CreatePortfolioShare. This operation is performed
asynchronously. To track the progress of the operation, use DescribeCopyProductStatus.

# Arguments
- `idempotency_token`:  A unique identifier that you provide to ensure idempotency. If
  multiple requests differ only by the idempotency token, the same response is returned for
  each repeated request.
- `source_product_arn`: The Amazon Resource Name (ARN) of the source product.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
- `"CopyOptions"`: The copy options. If the value is CopyTags, the tags from the source
  product are copied to the target product.
- `"SourceProvisioningArtifactIdentifiers"`: The identifiers of the provisioning artifacts
  (also known as versions) of the product to copy. By default, all provisioning artifacts are
  copied.
- `"TargetProductId"`: The identifier of the target product. By default, a new product is
  created.
- `"TargetProductName"`: A name for the target product. The default is the name of the
  source product.
"""
function copy_product(
    IdempotencyToken, SourceProductArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "CopyProduct",
        Dict{String,Any}(
            "IdempotencyToken" => IdempotencyToken, "SourceProductArn" => SourceProductArn
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function copy_product(
    IdempotencyToken,
    SourceProductArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "CopyProduct",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "IdempotencyToken" => IdempotencyToken,
                    "SourceProductArn" => SourceProductArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_constraint(idempotency_token, parameters, portfolio_id, product_id, type)
    create_constraint(idempotency_token, parameters, portfolio_id, product_id, type, params::Dict{String,<:Any})

Creates a constraint. A delegated admin is authorized to invoke this command.

# Arguments
- `idempotency_token`: A unique identifier that you provide to ensure idempotency. If
  multiple requests differ only by the idempotency token, the same response is returned for
  each repeated request.
- `parameters`: The constraint parameters, in JSON format. The syntax depends on the
  constraint type as follows:  LAUNCH  You are required to specify either the RoleArn or the
  LocalRoleName but can't use both. Specify the RoleArn property as follows:  {\"RoleArn\" :
  \"arn:aws:iam::123456789012:role/LaunchRole\"}  Specify the LocalRoleName property as
  follows:  {\"LocalRoleName\": \"SCBasicLaunchRole\"}  If you specify the LocalRoleName
  property, when an account uses the launch constraint, the IAM role with that name in the
  account will be used. This allows launch-role constraints to be account-agnostic so the
  administrator can create fewer resources per shared account.  The given role name must
  exist in the account used to create the launch constraint and the account of the user who
  launches a product with this launch constraint.  You cannot have both a LAUNCH and a
  STACKSET constraint. You also cannot have more than one LAUNCH constraint on a product and
  portfolio.  NOTIFICATION  Specify the NotificationArns property as follows:
  {\"NotificationArns\" : [\"arn:aws:sns:us-east-1:123456789012:Topic\"]}   RESOURCE_UPDATE
  Specify the TagUpdatesOnProvisionedProduct property as follows:
  {\"Version\":\"2.0\",\"Properties\":{\"TagUpdateOnProvisionedProduct\":\"String\"}}  The
  TagUpdatesOnProvisionedProduct property accepts a string value of ALLOWED or NOT_ALLOWED.
  STACKSET  Specify the Parameters property as follows:  {\"Version\": \"String\",
  \"Properties\": {\"AccountList\": [ \"String\" ], \"RegionList\": [ \"String\" ],
  \"AdminRole\": \"String\", \"ExecutionRole\": \"String\"}}  You cannot have both a LAUNCH
  and a STACKSET constraint. You also cannot have more than one STACKSET constraint on a
  product and portfolio. Products with a STACKSET constraint will launch an CloudFormation
  stack set.  TEMPLATE  Specify the Rules property. For more information, see Template
  Constraint Rules.
- `portfolio_id`: The portfolio identifier.
- `product_id`: The product identifier.
- `type`: The type of constraint.    LAUNCH     NOTIFICATION     RESOURCE_UPDATE
  STACKSET     TEMPLATE

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
- `"Description"`: The description of the constraint.
"""
function create_constraint(
    IdempotencyToken,
    Parameters,
    PortfolioId,
    ProductId,
    Type;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "CreateConstraint",
        Dict{String,Any}(
            "IdempotencyToken" => IdempotencyToken,
            "Parameters" => Parameters,
            "PortfolioId" => PortfolioId,
            "ProductId" => ProductId,
            "Type" => Type,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_constraint(
    IdempotencyToken,
    Parameters,
    PortfolioId,
    ProductId,
    Type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "CreateConstraint",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "IdempotencyToken" => IdempotencyToken,
                    "Parameters" => Parameters,
                    "PortfolioId" => PortfolioId,
                    "ProductId" => ProductId,
                    "Type" => Type,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_portfolio(display_name, idempotency_token, provider_name)
    create_portfolio(display_name, idempotency_token, provider_name, params::Dict{String,<:Any})

Creates a portfolio. A delegated admin is authorized to invoke this command.

# Arguments
- `display_name`: The name to use for display purposes.
- `idempotency_token`: A unique identifier that you provide to ensure idempotency. If
  multiple requests differ only by the idempotency token, the same response is returned for
  each repeated request.
- `provider_name`: The name of the portfolio provider.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
- `"Description"`: The description of the portfolio.
- `"Tags"`: One or more tags.
"""
function create_portfolio(
    DisplayName,
    IdempotencyToken,
    ProviderName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "CreatePortfolio",
        Dict{String,Any}(
            "DisplayName" => DisplayName,
            "IdempotencyToken" => IdempotencyToken,
            "ProviderName" => ProviderName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_portfolio(
    DisplayName,
    IdempotencyToken,
    ProviderName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "CreatePortfolio",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DisplayName" => DisplayName,
                    "IdempotencyToken" => IdempotencyToken,
                    "ProviderName" => ProviderName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_portfolio_share(portfolio_id)
    create_portfolio_share(portfolio_id, params::Dict{String,<:Any})

Shares the specified portfolio with the specified account or organization node. Shares to
an organization node can only be created by the management account of an organization or by
a delegated administrator. You can share portfolios to an organization, an organizational
unit, or a specific account. Note that if a delegated admin is de-registered, they can no
longer create portfolio shares.  AWSOrganizationsAccess must be enabled in order to create
a portfolio share to an organization node. You can't share a shared resource, including
portfolios that contain a shared product. If the portfolio share with the specified account
or organization node already exists, this action will have no effect and will not return an
error. To update an existing share, you must use the  UpdatePortfolioShare API instead.
When you associate a principal with portfolio, a potential privilege escalation path may
occur when that portfolio is then shared with other accounts. For a user in a recipient
account who is not an Service Catalog Admin, but still has the ability to create Principals
(Users/Groups/Roles), that user could create a role that matches a principal name
association for the portfolio. Although this user may not know which principal names are
associated through Service Catalog, they may be able to guess the user. If this potential
escalation path is a concern, then Service Catalog recommends using PrincipalType as IAM.
With this configuration, the PrincipalARN must already exist in the recipient account
before it can be associated.

# Arguments
- `portfolio_id`: The portfolio identifier.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
- `"AccountId"`: The Amazon Web Services account ID. For example, 123456789012.
- `"OrganizationNode"`: The organization node to whom you are going to share. When you pass
  OrganizationNode, it creates PortfolioShare for all of the Amazon Web Services accounts
  that are associated to the OrganizationNode. The output returns a PortfolioShareToken,
  which enables the administrator to monitor the status of the PortfolioShare creation
  process.
- `"SharePrincipals"`: This parameter is only supported for portfolios with an
  OrganizationalNode Type of ORGANIZATION or ORGANIZATIONAL_UNIT.  Enables or disables
  Principal sharing when creating the portfolio share. If you do not provide this flag,
  principal sharing is disabled.  When you enable Principal Name Sharing for a portfolio
  share, the share recipient account end users with a principal that matches any of the
  associated IAM patterns can provision products from the portfolio. Once shared, the share
  recipient can view associations of PrincipalType: IAM_PATTERN on their portfolio. You can
  create the principals in the recipient account before or after creating the share.
- `"ShareTagOptions"`: Enables or disables TagOptions  sharing when creating the portfolio
  share. If this flag is not provided, TagOptions sharing is disabled.
"""
function create_portfolio_share(
    PortfolioId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "CreatePortfolioShare",
        Dict{String,Any}("PortfolioId" => PortfolioId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_portfolio_share(
    PortfolioId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "CreatePortfolioShare",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("PortfolioId" => PortfolioId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_product(idempotency_token, name, owner, product_type)
    create_product(idempotency_token, name, owner, product_type, params::Dict{String,<:Any})

Creates a product. A delegated admin is authorized to invoke this command. The user or role
that performs this operation must have the cloudformation:GetTemplate IAM policy
permission. This policy permission is required when using the ImportFromPhysicalId template
source in the information data section.

# Arguments
- `idempotency_token`: A unique identifier that you provide to ensure idempotency. If
  multiple requests differ only by the idempotency token, the same response is returned for
  each repeated request.
- `name`: The name of the product.
- `owner`: The owner of the product.
- `product_type`: The type of product.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
- `"Description"`: The description of the product.
- `"Distributor"`: The distributor of the product.
- `"ProvisioningArtifactParameters"`: The configuration of the provisioning artifact.
- `"SourceConnection"`: Specifies connection details for the created product and syncs the
  product to the connection source artifact. This automatically manages the product's
  artifacts based on changes to the source. The SourceConnection parameter consists of the
  following sub-fields.    Type     ConnectionParamters
- `"SupportDescription"`: The support information about the product.
- `"SupportEmail"`: The contact email for product support.
- `"SupportUrl"`: The contact URL for product support.  ^https?:/// / is the pattern used
  to validate SupportUrl.
- `"Tags"`: One or more tags.
"""
function create_product(
    IdempotencyToken,
    Name,
    Owner,
    ProductType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "CreateProduct",
        Dict{String,Any}(
            "IdempotencyToken" => IdempotencyToken,
            "Name" => Name,
            "Owner" => Owner,
            "ProductType" => ProductType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_product(
    IdempotencyToken,
    Name,
    Owner,
    ProductType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "CreateProduct",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "IdempotencyToken" => IdempotencyToken,
                    "Name" => Name,
                    "Owner" => Owner,
                    "ProductType" => ProductType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_provisioned_product_plan(idempotency_token, plan_name, plan_type, product_id, provisioned_product_name, provisioning_artifact_id)
    create_provisioned_product_plan(idempotency_token, plan_name, plan_type, product_id, provisioned_product_name, provisioning_artifact_id, params::Dict{String,<:Any})

Creates a plan. A plan includes the list of resources to be created (when provisioning a
new product) or modified (when updating a provisioned product) when the plan is executed.
You can create one plan for each provisioned product. To create a plan for an existing
provisioned product, the product status must be AVAILABLE or TAINTED. To view the resource
changes in the change set, use DescribeProvisionedProductPlan. To create or modify the
provisioned product, use ExecuteProvisionedProductPlan.

# Arguments
- `idempotency_token`: A unique identifier that you provide to ensure idempotency. If
  multiple requests differ only by the idempotency token, the same response is returned for
  each repeated request.
- `plan_name`: The name of the plan.
- `plan_type`: The plan type.
- `product_id`: The product identifier.
- `provisioned_product_name`: A user-friendly name for the provisioned product. This value
  must be unique for the Amazon Web Services account and cannot be updated after the product
  is provisioned.
- `provisioning_artifact_id`: The identifier of the provisioning artifact.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
- `"NotificationArns"`: Passed to CloudFormation. The SNS topic ARNs to which to publish
  stack-related events.
- `"PathId"`: The path identifier of the product. This value is optional if the product has
  a default path, and required if the product has more than one path. To list the paths for a
  product, use ListLaunchPaths.
- `"ProvisioningParameters"`: Parameters specified by the administrator that are required
  for provisioning the product.
- `"Tags"`: One or more tags. If the plan is for an existing provisioned product, the
  product must have a RESOURCE_UPDATE constraint with TagUpdatesOnProvisionedProduct set to
  ALLOWED to allow tag updates.
"""
function create_provisioned_product_plan(
    IdempotencyToken,
    PlanName,
    PlanType,
    ProductId,
    ProvisionedProductName,
    ProvisioningArtifactId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "CreateProvisionedProductPlan",
        Dict{String,Any}(
            "IdempotencyToken" => IdempotencyToken,
            "PlanName" => PlanName,
            "PlanType" => PlanType,
            "ProductId" => ProductId,
            "ProvisionedProductName" => ProvisionedProductName,
            "ProvisioningArtifactId" => ProvisioningArtifactId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_provisioned_product_plan(
    IdempotencyToken,
    PlanName,
    PlanType,
    ProductId,
    ProvisionedProductName,
    ProvisioningArtifactId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "CreateProvisionedProductPlan",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "IdempotencyToken" => IdempotencyToken,
                    "PlanName" => PlanName,
                    "PlanType" => PlanType,
                    "ProductId" => ProductId,
                    "ProvisionedProductName" => ProvisionedProductName,
                    "ProvisioningArtifactId" => ProvisioningArtifactId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_provisioning_artifact(idempotency_token, parameters, product_id)
    create_provisioning_artifact(idempotency_token, parameters, product_id, params::Dict{String,<:Any})

Creates a provisioning artifact (also known as a version) for the specified product. You
cannot create a provisioning artifact for a product that was shared with you. The user or
role that performs this operation must have the cloudformation:GetTemplate IAM policy
permission. This policy permission is required when using the ImportFromPhysicalId template
source in the information data section.

# Arguments
- `idempotency_token`: A unique identifier that you provide to ensure idempotency. If
  multiple requests differ only by the idempotency token, the same response is returned for
  each repeated request.
- `parameters`: The configuration for the provisioning artifact.
- `product_id`: The product identifier.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
"""
function create_provisioning_artifact(
    IdempotencyToken,
    Parameters,
    ProductId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "CreateProvisioningArtifact",
        Dict{String,Any}(
            "IdempotencyToken" => IdempotencyToken,
            "Parameters" => Parameters,
            "ProductId" => ProductId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_provisioning_artifact(
    IdempotencyToken,
    Parameters,
    ProductId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "CreateProvisioningArtifact",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "IdempotencyToken" => IdempotencyToken,
                    "Parameters" => Parameters,
                    "ProductId" => ProductId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_service_action(definition, definition_type, idempotency_token, name)
    create_service_action(definition, definition_type, idempotency_token, name, params::Dict{String,<:Any})

Creates a self-service action.

# Arguments
- `definition`: The self-service action definition. Can be one of the following:  Name  The
  name of the Amazon Web Services Systems Manager document (SSM document). For example,
  AWS-RestartEC2Instance. If you are using a shared SSM document, you must provide the ARN
  instead of the name.  Version  The Amazon Web Services Systems Manager automation document
  version. For example, \"Version\": \"1\"   AssumeRole  The Amazon Resource Name (ARN) of
  the role that performs the self-service actions on your behalf. For example,
  \"AssumeRole\": \"arn:aws:iam::12345678910:role/ActionRole\". To reuse the provisioned
  product launch role, set to \"AssumeRole\": \"LAUNCH_ROLE\".  Parameters  The list of
  parameters in JSON format. For example: [{\"Name\":\"InstanceId\",\"Type\":\"TARGET\"}] or
  [{\"Name\":\"InstanceId\",\"Type\":\"TEXT_VALUE\"}].
- `definition_type`: The service action definition type. For example, SSM_AUTOMATION.
- `idempotency_token`: A unique identifier that you provide to ensure idempotency. If
  multiple requests differ only by the idempotency token, the same response is returned for
  each repeated request.
- `name`: The self-service action name.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
- `"Description"`: The self-service action description.
"""
function create_service_action(
    Definition,
    DefinitionType,
    IdempotencyToken,
    Name;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "CreateServiceAction",
        Dict{String,Any}(
            "Definition" => Definition,
            "DefinitionType" => DefinitionType,
            "IdempotencyToken" => IdempotencyToken,
            "Name" => Name,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_service_action(
    Definition,
    DefinitionType,
    IdempotencyToken,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "CreateServiceAction",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Definition" => Definition,
                    "DefinitionType" => DefinitionType,
                    "IdempotencyToken" => IdempotencyToken,
                    "Name" => Name,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_tag_option(key, value)
    create_tag_option(key, value, params::Dict{String,<:Any})

Creates a TagOption.

# Arguments
- `key`: The TagOption key.
- `value`: The TagOption value.

"""
function create_tag_option(Key, Value; aws_config::AbstractAWSConfig=current_aws_config())
    return service_catalog(
        "CreateTagOption",
        Dict{String,Any}("Key" => Key, "Value" => Value);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_tag_option(
    Key,
    Value,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "CreateTagOption",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Key" => Key, "Value" => Value), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_constraint(id)
    delete_constraint(id, params::Dict{String,<:Any})

Deletes the specified constraint. A delegated admin is authorized to invoke this command.

# Arguments
- `id`: The identifier of the constraint.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
"""
function delete_constraint(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return service_catalog(
        "DeleteConstraint",
        Dict{String,Any}("Id" => Id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_constraint(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "DeleteConstraint",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Id" => Id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_portfolio(id)
    delete_portfolio(id, params::Dict{String,<:Any})

Deletes the specified portfolio. You cannot delete a portfolio if it was shared with you or
if it has associated products, users, constraints, or shared accounts. A delegated admin is
authorized to invoke this command.

# Arguments
- `id`: The portfolio identifier.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
"""
function delete_portfolio(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return service_catalog(
        "DeletePortfolio",
        Dict{String,Any}("Id" => Id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_portfolio(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "DeletePortfolio",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Id" => Id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_portfolio_share(portfolio_id)
    delete_portfolio_share(portfolio_id, params::Dict{String,<:Any})

Stops sharing the specified portfolio with the specified account or organization node.
Shares to an organization node can only be deleted by the management account of an
organization or by a delegated administrator. Note that if a delegated admin is
de-registered, portfolio shares created from that account are removed.

# Arguments
- `portfolio_id`: The portfolio identifier.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
- `"AccountId"`: The Amazon Web Services account ID.
- `"OrganizationNode"`: The organization node to whom you are going to stop sharing.
"""
function delete_portfolio_share(
    PortfolioId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "DeletePortfolioShare",
        Dict{String,Any}("PortfolioId" => PortfolioId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_portfolio_share(
    PortfolioId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "DeletePortfolioShare",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("PortfolioId" => PortfolioId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_product(id)
    delete_product(id, params::Dict{String,<:Any})

Deletes the specified product. You cannot delete a product if it was shared with you or is
associated with a portfolio. A delegated admin is authorized to invoke this command.

# Arguments
- `id`: The product identifier.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
"""
function delete_product(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return service_catalog(
        "DeleteProduct",
        Dict{String,Any}("Id" => Id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_product(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "DeleteProduct",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Id" => Id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_provisioned_product_plan(plan_id)
    delete_provisioned_product_plan(plan_id, params::Dict{String,<:Any})

Deletes the specified plan.

# Arguments
- `plan_id`: The plan identifier.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
- `"IgnoreErrors"`: If set to true, Service Catalog stops managing the specified
  provisioned product even if it cannot delete the underlying resources.
"""
function delete_provisioned_product_plan(
    PlanId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "DeleteProvisionedProductPlan",
        Dict{String,Any}("PlanId" => PlanId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_provisioned_product_plan(
    PlanId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "DeleteProvisionedProductPlan",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("PlanId" => PlanId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_provisioning_artifact(product_id, provisioning_artifact_id)
    delete_provisioning_artifact(product_id, provisioning_artifact_id, params::Dict{String,<:Any})

Deletes the specified provisioning artifact (also known as a version) for the specified
product. You cannot delete a provisioning artifact associated with a product that was
shared with you. You cannot delete the last provisioning artifact for a product, because a
product must have at least one provisioning artifact.

# Arguments
- `product_id`: The product identifier.
- `provisioning_artifact_id`: The identifier of the provisioning artifact.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
"""
function delete_provisioning_artifact(
    ProductId, ProvisioningArtifactId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "DeleteProvisioningArtifact",
        Dict{String,Any}(
            "ProductId" => ProductId, "ProvisioningArtifactId" => ProvisioningArtifactId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_provisioning_artifact(
    ProductId,
    ProvisioningArtifactId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "DeleteProvisioningArtifact",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ProductId" => ProductId,
                    "ProvisioningArtifactId" => ProvisioningArtifactId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_service_action(id)
    delete_service_action(id, params::Dict{String,<:Any})

Deletes a self-service action.

# Arguments
- `id`: The self-service action identifier. For example, act-fs7abcd89wxyz.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
- `"IdempotencyToken"`: A unique identifier that you provide to ensure idempotency. If
  multiple requests from the same Amazon Web Services account use the same idempotency token,
  the same response is returned for each repeated request.
"""
function delete_service_action(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return service_catalog(
        "DeleteServiceAction",
        Dict{String,Any}("Id" => Id, "IdempotencyToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_service_action(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "DeleteServiceAction",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Id" => Id, "IdempotencyToken" => string(uuid4())),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_tag_option(id)
    delete_tag_option(id, params::Dict{String,<:Any})

Deletes the specified TagOption. You cannot delete a TagOption if it is associated with a
product or portfolio.

# Arguments
- `id`: The TagOption identifier.

"""
function delete_tag_option(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return service_catalog(
        "DeleteTagOption",
        Dict{String,Any}("Id" => Id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_tag_option(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "DeleteTagOption",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Id" => Id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_constraint(id)
    describe_constraint(id, params::Dict{String,<:Any})

Gets information about the specified constraint.

# Arguments
- `id`: The identifier of the constraint.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
"""
function describe_constraint(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return service_catalog(
        "DescribeConstraint",
        Dict{String,Any}("Id" => Id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_constraint(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "DescribeConstraint",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Id" => Id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_copy_product_status(copy_product_token)
    describe_copy_product_status(copy_product_token, params::Dict{String,<:Any})

Gets the status of the specified copy product operation.

# Arguments
- `copy_product_token`: The token for the copy product operation. This token is returned by
  CopyProduct.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
"""
function describe_copy_product_status(
    CopyProductToken; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "DescribeCopyProductStatus",
        Dict{String,Any}("CopyProductToken" => CopyProductToken);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_copy_product_status(
    CopyProductToken,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "DescribeCopyProductStatus",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("CopyProductToken" => CopyProductToken), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_portfolio(id)
    describe_portfolio(id, params::Dict{String,<:Any})

Gets information about the specified portfolio. A delegated admin is authorized to invoke
this command.

# Arguments
- `id`: The portfolio identifier.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
"""
function describe_portfolio(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return service_catalog(
        "DescribePortfolio",
        Dict{String,Any}("Id" => Id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_portfolio(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "DescribePortfolio",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Id" => Id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_portfolio_share_status(portfolio_share_token)
    describe_portfolio_share_status(portfolio_share_token, params::Dict{String,<:Any})

Gets the status of the specified portfolio share operation. This API can only be called by
the management account in the organization or by a delegated admin.

# Arguments
- `portfolio_share_token`: The token for the portfolio share operation. This token is
  returned either by CreatePortfolioShare or by DeletePortfolioShare.

"""
function describe_portfolio_share_status(
    PortfolioShareToken; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "DescribePortfolioShareStatus",
        Dict{String,Any}("PortfolioShareToken" => PortfolioShareToken);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_portfolio_share_status(
    PortfolioShareToken,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "DescribePortfolioShareStatus",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("PortfolioShareToken" => PortfolioShareToken),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_portfolio_shares(portfolio_id, type)
    describe_portfolio_shares(portfolio_id, type, params::Dict{String,<:Any})

Returns a summary of each of the portfolio shares that were created for the specified
portfolio. You can use this API to determine which accounts or organizational nodes this
portfolio have been shared, whether the recipient entity has imported the share, and
whether TagOptions are included with the share. The PortfolioId and Type parameters are
both required.

# Arguments
- `portfolio_id`: The unique identifier of the portfolio for which shares will be retrieved.
- `type`: The type of portfolio share to summarize. This field acts as a filter on the type
  of portfolio share, which can be one of the following: 1. ACCOUNT - Represents an external
  account to account share. 2. ORGANIZATION - Represents a share to an organization. This
  share is available to every account in the organization. 3. ORGANIZATIONAL_UNIT -
  Represents a share to an organizational unit. 4. ORGANIZATION_MEMBER_ACCOUNT - Represents a
  share to an account in the organization.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"PageSize"`: The maximum number of items to return with this call.
- `"PageToken"`: The page token for the next set of results. To retrieve the first set of
  results, use null.
"""
function describe_portfolio_shares(
    PortfolioId, Type; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "DescribePortfolioShares",
        Dict{String,Any}("PortfolioId" => PortfolioId, "Type" => Type);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_portfolio_shares(
    PortfolioId,
    Type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "DescribePortfolioShares",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("PortfolioId" => PortfolioId, "Type" => Type),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_product()
    describe_product(params::Dict{String,<:Any})

Gets information about the specified product.   Running this operation with administrator
access results in a failure. DescribeProductAsAdmin should be used instead.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
- `"Id"`: The product identifier.
- `"Name"`: The product name.
"""
function describe_product(; aws_config::AbstractAWSConfig=current_aws_config())
    return service_catalog(
        "DescribeProduct"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_product(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "DescribeProduct", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_product_as_admin()
    describe_product_as_admin(params::Dict{String,<:Any})

Gets information about the specified product. This operation is run with administrator
access.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
- `"Id"`: The product identifier.
- `"Name"`: The product name.
- `"SourcePortfolioId"`: The unique identifier of the shared portfolio that the specified
  product is associated with. You can provide this parameter to retrieve the shared
  TagOptions associated with the product. If this parameter is provided and if TagOptions
  sharing is enabled in the portfolio share, the API returns both local and shared TagOptions
  associated with the product. Otherwise only local TagOptions will be returned.
"""
function describe_product_as_admin(; aws_config::AbstractAWSConfig=current_aws_config())
    return service_catalog(
        "DescribeProductAsAdmin"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_product_as_admin(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "DescribeProductAsAdmin",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_product_view(id)
    describe_product_view(id, params::Dict{String,<:Any})

Gets information about the specified product.

# Arguments
- `id`: The product view identifier.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
"""
function describe_product_view(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return service_catalog(
        "DescribeProductView",
        Dict{String,Any}("Id" => Id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_product_view(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "DescribeProductView",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Id" => Id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_provisioned_product()
    describe_provisioned_product(params::Dict{String,<:Any})

Gets information about the specified provisioned product.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
- `"Id"`: The provisioned product identifier. You must provide the name or ID, but not
  both. If you do not provide a name or ID, or you provide both name and ID, an
  InvalidParametersException will occur.
- `"Name"`: The name of the provisioned product. You must provide the name or ID, but not
  both. If you do not provide a name or ID, or you provide both name and ID, an
  InvalidParametersException will occur.
"""
function describe_provisioned_product(; aws_config::AbstractAWSConfig=current_aws_config())
    return service_catalog(
        "DescribeProvisionedProduct"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_provisioned_product(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "DescribeProvisionedProduct",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_provisioned_product_plan(plan_id)
    describe_provisioned_product_plan(plan_id, params::Dict{String,<:Any})

Gets information about the resource changes for the specified plan.

# Arguments
- `plan_id`: The plan identifier.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
- `"PageSize"`: The maximum number of items to return with this call.
- `"PageToken"`: The page token for the next set of results. To retrieve the first set of
  results, use null.
"""
function describe_provisioned_product_plan(
    PlanId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "DescribeProvisionedProductPlan",
        Dict{String,Any}("PlanId" => PlanId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_provisioned_product_plan(
    PlanId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "DescribeProvisionedProductPlan",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("PlanId" => PlanId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_provisioning_artifact()
    describe_provisioning_artifact(params::Dict{String,<:Any})

Gets information about the specified provisioning artifact (also known as a version) for
the specified product.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
- `"IncludeProvisioningArtifactParameters"`: Indicates if the API call response does or
  does not include additional details about the provisioning parameters.
- `"ProductId"`: The product identifier.
- `"ProductName"`: The product name.
- `"ProvisioningArtifactId"`: The identifier of the provisioning artifact.
- `"ProvisioningArtifactName"`: The provisioning artifact name.
- `"Verbose"`: Indicates whether a verbose level of detail is enabled.
"""
function describe_provisioning_artifact(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "DescribeProvisioningArtifact";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_provisioning_artifact(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "DescribeProvisioningArtifact",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_provisioning_parameters()
    describe_provisioning_parameters(params::Dict{String,<:Any})

Gets information about the configuration required to provision the specified product using
the specified provisioning artifact. If the output contains a TagOption key with an empty
list of values, there is a TagOption conflict for that key. The end user cannot take action
to fix the conflict, and launch is not blocked. In subsequent calls to ProvisionProduct, do
not include conflicted TagOption keys as tags, or this causes the error \"Parameter
validation failed: Missing required parameter in Tags[N]:Value\". Tag the provisioned
product with the value sc-tagoption-conflict-portfolioId-productId.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
- `"PathId"`: The path identifier of the product. This value is optional if the product has
  a default path, and required if the product has more than one path. To list the paths for a
  product, use ListLaunchPaths. You must provide the name or ID, but not both.
- `"PathName"`: The name of the path. You must provide the name or ID, but not both.
- `"ProductId"`: The product identifier. You must provide the product name or ID, but not
  both.
- `"ProductName"`: The name of the product. You must provide the name or ID, but not both.
- `"ProvisioningArtifactId"`: The identifier of the provisioning artifact. You must provide
  the name or ID, but not both.
- `"ProvisioningArtifactName"`: The name of the provisioning artifact. You must provide the
  name or ID, but not both.
"""
function describe_provisioning_parameters(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "DescribeProvisioningParameters";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_provisioning_parameters(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "DescribeProvisioningParameters",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_record(id)
    describe_record(id, params::Dict{String,<:Any})

Gets information about the specified request operation. Use this operation after calling a
request operation (for example, ProvisionProduct, TerminateProvisionedProduct, or
UpdateProvisionedProduct).   If a provisioned product was transferred to a new owner using
UpdateProvisionedProductProperties, the new owner will be able to describe all past records
for that product. The previous owner will no longer be able to describe the records, but
will be able to use ListRecordHistory to see the product's history from when he was the
owner.

# Arguments
- `id`: The record identifier of the provisioned product. This identifier is returned by
  the request operation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
- `"PageSize"`: The maximum number of items to return with this call.
- `"PageToken"`: The page token for the next set of results. To retrieve the first set of
  results, use null.
"""
function describe_record(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return service_catalog(
        "DescribeRecord",
        Dict{String,Any}("Id" => Id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_record(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "DescribeRecord",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Id" => Id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_service_action(id)
    describe_service_action(id, params::Dict{String,<:Any})

Describes a self-service action.

# Arguments
- `id`: The self-service action identifier.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
"""
function describe_service_action(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return service_catalog(
        "DescribeServiceAction",
        Dict{String,Any}("Id" => Id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_service_action(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "DescribeServiceAction",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Id" => Id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_service_action_execution_parameters(provisioned_product_id, service_action_id)
    describe_service_action_execution_parameters(provisioned_product_id, service_action_id, params::Dict{String,<:Any})

Finds the default parameters for a specific self-service action on a specific provisioned
product and returns a map of the results to the user.

# Arguments
- `provisioned_product_id`: The identifier of the provisioned product.
- `service_action_id`: The self-service action identifier.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
"""
function describe_service_action_execution_parameters(
    ProvisionedProductId,
    ServiceActionId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "DescribeServiceActionExecutionParameters",
        Dict{String,Any}(
            "ProvisionedProductId" => ProvisionedProductId,
            "ServiceActionId" => ServiceActionId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_service_action_execution_parameters(
    ProvisionedProductId,
    ServiceActionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "DescribeServiceActionExecutionParameters",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ProvisionedProductId" => ProvisionedProductId,
                    "ServiceActionId" => ServiceActionId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_tag_option(id)
    describe_tag_option(id, params::Dict{String,<:Any})

Gets information about the specified TagOption.

# Arguments
- `id`: The TagOption identifier.

"""
function describe_tag_option(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return service_catalog(
        "DescribeTagOption",
        Dict{String,Any}("Id" => Id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_tag_option(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "DescribeTagOption",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Id" => Id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disable_awsorganizations_access()
    disable_awsorganizations_access(params::Dict{String,<:Any})

Disable portfolio sharing through the Organizations service. This command will not delete
your current shares, but prevents you from creating new shares throughout your
organization. Current shares are not kept in sync with your organization structure if the
structure changes after calling this API. Only the management account in the organization
can call this API. You cannot call this API if there are active delegated administrators in
the organization. Note that a delegated administrator is not authorized to invoke
DisableAWSOrganizationsAccess.  If you share an Service Catalog portfolio in an
organization within Organizations, and then disable Organizations access for Service
Catalog, the portfolio access permissions will not sync with the latest changes to the
organization structure. Specifically, accounts that you removed from the organization after
disabling Service Catalog access will retain access to the previously shared portfolio.

"""
function disable_awsorganizations_access(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "DisableAWSOrganizationsAccess";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disable_awsorganizations_access(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "DisableAWSOrganizationsAccess",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_budget_from_resource(budget_name, resource_id)
    disassociate_budget_from_resource(budget_name, resource_id, params::Dict{String,<:Any})

Disassociates the specified budget from the specified resource.

# Arguments
- `budget_name`: The name of the budget you want to disassociate.
- `resource_id`: The resource identifier you want to disassociate from. Either a
  portfolio-id or a product-id.

"""
function disassociate_budget_from_resource(
    BudgetName, ResourceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "DisassociateBudgetFromResource",
        Dict{String,Any}("BudgetName" => BudgetName, "ResourceId" => ResourceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_budget_from_resource(
    BudgetName,
    ResourceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "DisassociateBudgetFromResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("BudgetName" => BudgetName, "ResourceId" => ResourceId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_principal_from_portfolio(portfolio_id, principal_arn)
    disassociate_principal_from_portfolio(portfolio_id, principal_arn, params::Dict{String,<:Any})

Disassociates a previously associated principal ARN from a specified portfolio. The
PrincipalType and PrincipalARN must match the AssociatePrincipalWithPortfolio call request
details. For example, to disassociate an association created with a PrincipalARN of
PrincipalType IAM you must use the PrincipalType IAM when calling
DisassociatePrincipalFromPortfolio.  For portfolios that have been shared with principal
name sharing enabled: after disassociating a principal, share recipient accounts will no
longer be able to provision products in this portfolio using a role matching the name of
the associated principal.  For more information, review associate-principal-with-portfolio
in the Amazon Web Services CLI Command Reference.   If you disassociate a principal from a
portfolio, with PrincipalType as IAM, the same principal will still have access to the
portfolio if it matches one of the associated principals of type IAM_PATTERN. To fully
remove access for a principal, verify all the associated Principals of type IAM_PATTERN,
and then ensure you disassociate any IAM_PATTERN principals that match the principal whose
access you are removing.

# Arguments
- `portfolio_id`: The portfolio identifier.
- `principal_arn`: The ARN of the principal (user, role, or group). This field allows an
  ARN with no accountID with or without wildcard characters if PrincipalType is IAM_PATTERN.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
- `"PrincipalType"`: The supported value is IAM if you use a fully defined ARN, or
  IAM_PATTERN if you specify an IAM ARN with no AccountId, with or without wildcard
  characters.
"""
function disassociate_principal_from_portfolio(
    PortfolioId, PrincipalARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "DisassociatePrincipalFromPortfolio",
        Dict{String,Any}("PortfolioId" => PortfolioId, "PrincipalARN" => PrincipalARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_principal_from_portfolio(
    PortfolioId,
    PrincipalARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "DisassociatePrincipalFromPortfolio",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "PortfolioId" => PortfolioId, "PrincipalARN" => PrincipalARN
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_product_from_portfolio(portfolio_id, product_id)
    disassociate_product_from_portfolio(portfolio_id, product_id, params::Dict{String,<:Any})

Disassociates the specified product from the specified portfolio.  A delegated admin is
authorized to invoke this command.

# Arguments
- `portfolio_id`: The portfolio identifier.
- `product_id`: The product identifier.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
"""
function disassociate_product_from_portfolio(
    PortfolioId, ProductId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "DisassociateProductFromPortfolio",
        Dict{String,Any}("PortfolioId" => PortfolioId, "ProductId" => ProductId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_product_from_portfolio(
    PortfolioId,
    ProductId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "DisassociateProductFromPortfolio",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("PortfolioId" => PortfolioId, "ProductId" => ProductId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_service_action_from_provisioning_artifact(product_id, provisioning_artifact_id, service_action_id)
    disassociate_service_action_from_provisioning_artifact(product_id, provisioning_artifact_id, service_action_id, params::Dict{String,<:Any})

Disassociates the specified self-service action association from the specified provisioning
artifact.

# Arguments
- `product_id`: The product identifier. For example, prod-abcdzk7xy33qa.
- `provisioning_artifact_id`: The identifier of the provisioning artifact. For example,
  pa-4abcdjnxjj6ne.
- `service_action_id`: The self-service action identifier. For example, act-fs7abcd89wxyz.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
- `"IdempotencyToken"`: A unique identifier that you provide to ensure idempotency. If
  multiple requests from the same Amazon Web Services account use the same idempotency token,
  the same response is returned for each repeated request.
"""
function disassociate_service_action_from_provisioning_artifact(
    ProductId,
    ProvisioningArtifactId,
    ServiceActionId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "DisassociateServiceActionFromProvisioningArtifact",
        Dict{String,Any}(
            "ProductId" => ProductId,
            "ProvisioningArtifactId" => ProvisioningArtifactId,
            "ServiceActionId" => ServiceActionId,
            "IdempotencyToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_service_action_from_provisioning_artifact(
    ProductId,
    ProvisioningArtifactId,
    ServiceActionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "DisassociateServiceActionFromProvisioningArtifact",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ProductId" => ProductId,
                    "ProvisioningArtifactId" => ProvisioningArtifactId,
                    "ServiceActionId" => ServiceActionId,
                    "IdempotencyToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_tag_option_from_resource(resource_id, tag_option_id)
    disassociate_tag_option_from_resource(resource_id, tag_option_id, params::Dict{String,<:Any})

Disassociates the specified TagOption from the specified resource.

# Arguments
- `resource_id`: The resource identifier.
- `tag_option_id`: The TagOption identifier.

"""
function disassociate_tag_option_from_resource(
    ResourceId, TagOptionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "DisassociateTagOptionFromResource",
        Dict{String,Any}("ResourceId" => ResourceId, "TagOptionId" => TagOptionId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_tag_option_from_resource(
    ResourceId,
    TagOptionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "DisassociateTagOptionFromResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceId" => ResourceId, "TagOptionId" => TagOptionId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    enable_awsorganizations_access()
    enable_awsorganizations_access(params::Dict{String,<:Any})

Enable portfolio sharing feature through Organizations. This API will allow Service Catalog
to receive updates on your organization in order to sync your shares with the current
structure. This API can only be called by the management account in the organization. When
you call this API, Service Catalog calls organizations:EnableAWSServiceAccess on your
behalf so that your shares stay in sync with any changes in your Organizations structure.
Note that a delegated administrator is not authorized to invoke
EnableAWSOrganizationsAccess.  If you have previously disabled Organizations access for
Service Catalog, and then enable access again, the portfolio access permissions might not
sync with the latest changes to the organization structure. Specifically, accounts that you
removed from the organization after disabling Service Catalog access, and before you
enabled access again, can retain access to the previously shared portfolio. As a result, an
account that has been removed from the organization might still be able to create or manage
Amazon Web Services resources when it is no longer authorized to do so. Amazon Web Services
is working to resolve this issue.

"""
function enable_awsorganizations_access(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "EnableAWSOrganizationsAccess";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function enable_awsorganizations_access(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "EnableAWSOrganizationsAccess",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    execute_provisioned_product_plan(idempotency_token, plan_id)
    execute_provisioned_product_plan(idempotency_token, plan_id, params::Dict{String,<:Any})

Provisions or modifies a product based on the resource changes for the specified plan.

# Arguments
- `idempotency_token`: A unique identifier that you provide to ensure idempotency. If
  multiple requests differ only by the idempotency token, the same response is returned for
  each repeated request.
- `plan_id`: The plan identifier.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
"""
function execute_provisioned_product_plan(
    IdempotencyToken, PlanId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "ExecuteProvisionedProductPlan",
        Dict{String,Any}("IdempotencyToken" => IdempotencyToken, "PlanId" => PlanId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function execute_provisioned_product_plan(
    IdempotencyToken,
    PlanId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "ExecuteProvisionedProductPlan",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "IdempotencyToken" => IdempotencyToken, "PlanId" => PlanId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    execute_provisioned_product_service_action(execute_token, provisioned_product_id, service_action_id)
    execute_provisioned_product_service_action(execute_token, provisioned_product_id, service_action_id, params::Dict{String,<:Any})

Executes a self-service action against a provisioned product.

# Arguments
- `execute_token`: An idempotency token that uniquely identifies the execute request.
- `provisioned_product_id`: The identifier of the provisioned product.
- `service_action_id`: The self-service action identifier. For example, act-fs7abcd89wxyz.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
- `"Parameters"`: A map of all self-service action parameters and their values. If a
  provided parameter is of a special type, such as TARGET, the provided value will override
  the default value generated by Service Catalog. If the parameters field is not provided, no
  additional parameters are passed and default values will be used for any special parameters
  such as TARGET.
"""
function execute_provisioned_product_service_action(
    ExecuteToken,
    ProvisionedProductId,
    ServiceActionId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "ExecuteProvisionedProductServiceAction",
        Dict{String,Any}(
            "ExecuteToken" => ExecuteToken,
            "ProvisionedProductId" => ProvisionedProductId,
            "ServiceActionId" => ServiceActionId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function execute_provisioned_product_service_action(
    ExecuteToken,
    ProvisionedProductId,
    ServiceActionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "ExecuteProvisionedProductServiceAction",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ExecuteToken" => ExecuteToken,
                    "ProvisionedProductId" => ProvisionedProductId,
                    "ServiceActionId" => ServiceActionId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_awsorganizations_access_status()
    get_awsorganizations_access_status(params::Dict{String,<:Any})

Get the Access Status for Organizations portfolio share feature. This API can only be
called by the management account in the organization or by a delegated admin.

"""
function get_awsorganizations_access_status(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "GetAWSOrganizationsAccessStatus";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_awsorganizations_access_status(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "GetAWSOrganizationsAccessStatus",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_provisioned_product_outputs()
    get_provisioned_product_outputs(params::Dict{String,<:Any})

This API takes either a ProvisonedProductId or a ProvisionedProductName, along with a list
of one or more output keys, and responds with the key/value pairs of those outputs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
- `"OutputKeys"`: The list of keys that the API should return with their values. If none
  are provided, the API will return all outputs of the provisioned product.
- `"PageSize"`: The maximum number of items to return with this call.
- `"PageToken"`: The page token for the next set of results. To retrieve the first set of
  results, use null.
- `"ProvisionedProductId"`: The identifier of the provisioned product that you want the
  outputs from.
- `"ProvisionedProductName"`: The name of the provisioned product that you want the outputs
  from.
"""
function get_provisioned_product_outputs(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "GetProvisionedProductOutputs";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_provisioned_product_outputs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "GetProvisionedProductOutputs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    import_as_provisioned_product(idempotency_token, physical_id, product_id, provisioned_product_name, provisioning_artifact_id)
    import_as_provisioned_product(idempotency_token, physical_id, product_id, provisioned_product_name, provisioning_artifact_id, params::Dict{String,<:Any})

 Requests the import of a resource as an Service Catalog provisioned product that is
associated to an Service Catalog product and provisioning artifact. Once imported, all
supported governance actions are supported on the provisioned product.   Resource import
only supports CloudFormation stack ARNs. CloudFormation StackSets, and non-root nested
stacks, are not supported.   The CloudFormation stack must have one of the following
statuses to be imported: CREATE_COMPLETE, UPDATE_COMPLETE, UPDATE_ROLLBACK_COMPLETE,
IMPORT_COMPLETE, and IMPORT_ROLLBACK_COMPLETE.   Import of the resource requires that the
CloudFormation stack template matches the associated Service Catalog product provisioning
artifact.    When you import an existing CloudFormation stack into a portfolio, Service
Catalog does not apply the product's associated constraints during the import process.
Service Catalog applies the constraints after you call UpdateProvisionedProduct for the
provisioned product.    The user or role that performs this operation must have the
cloudformation:GetTemplate and cloudformation:DescribeStacks IAM policy permissions.  You
can only import one provisioned product at a time. The product's CloudFormation stack must
have the IMPORT_COMPLETE status before you import another.

# Arguments
- `idempotency_token`: A unique identifier that you provide to ensure idempotency. If
  multiple requests differ only by the idempotency token, the same response is returned for
  each repeated request.
- `physical_id`: The unique identifier of the resource to be imported. It only currently
  supports CloudFormation stack IDs.
- `product_id`: The product identifier.
- `provisioned_product_name`: The user-friendly name of the provisioned product. The value
  must be unique for the Amazon Web Services account. The name cannot be updated after the
  product is provisioned.
- `provisioning_artifact_id`: The identifier of the provisioning artifact.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
"""
function import_as_provisioned_product(
    IdempotencyToken,
    PhysicalId,
    ProductId,
    ProvisionedProductName,
    ProvisioningArtifactId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "ImportAsProvisionedProduct",
        Dict{String,Any}(
            "IdempotencyToken" => IdempotencyToken,
            "PhysicalId" => PhysicalId,
            "ProductId" => ProductId,
            "ProvisionedProductName" => ProvisionedProductName,
            "ProvisioningArtifactId" => ProvisioningArtifactId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function import_as_provisioned_product(
    IdempotencyToken,
    PhysicalId,
    ProductId,
    ProvisionedProductName,
    ProvisioningArtifactId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "ImportAsProvisionedProduct",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "IdempotencyToken" => IdempotencyToken,
                    "PhysicalId" => PhysicalId,
                    "ProductId" => ProductId,
                    "ProvisionedProductName" => ProvisionedProductName,
                    "ProvisioningArtifactId" => ProvisioningArtifactId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_accepted_portfolio_shares()
    list_accepted_portfolio_shares(params::Dict{String,<:Any})

Lists all imported portfolios for which account-to-account shares were accepted by this
account. By specifying the PortfolioShareType, you can list portfolios for which
organizational shares were accepted by this account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
- `"PageSize"`: The maximum number of items to return with this call.
- `"PageToken"`: The page token for the next set of results. To retrieve the first set of
  results, use null.
- `"PortfolioShareType"`: The type of shared portfolios to list. The default is to list
  imported portfolios.    AWS_ORGANIZATIONS - List portfolios accepted and shared via
  organizational sharing by the management account or delegated administrator of your
  organization.    AWS_SERVICECATALOG - Deprecated type.    IMPORTED - List imported
  portfolios that have been accepted and shared through account-to-account sharing.
"""
function list_accepted_portfolio_shares(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "ListAcceptedPortfolioShares";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_accepted_portfolio_shares(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "ListAcceptedPortfolioShares",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_budgets_for_resource(resource_id)
    list_budgets_for_resource(resource_id, params::Dict{String,<:Any})

Lists all the budgets associated to the specified resource.

# Arguments
- `resource_id`: The resource identifier.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
- `"PageSize"`: The maximum number of items to return with this call.
- `"PageToken"`: The page token for the next set of results. To retrieve the first set of
  results, use null.
"""
function list_budgets_for_resource(
    ResourceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "ListBudgetsForResource",
        Dict{String,Any}("ResourceId" => ResourceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_budgets_for_resource(
    ResourceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "ListBudgetsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceId" => ResourceId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_constraints_for_portfolio(portfolio_id)
    list_constraints_for_portfolio(portfolio_id, params::Dict{String,<:Any})

Lists the constraints for the specified portfolio and product.

# Arguments
- `portfolio_id`: The portfolio identifier.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
- `"PageSize"`: The maximum number of items to return with this call.
- `"PageToken"`: The page token for the next set of results. To retrieve the first set of
  results, use null.
- `"ProductId"`: The product identifier.
"""
function list_constraints_for_portfolio(
    PortfolioId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "ListConstraintsForPortfolio",
        Dict{String,Any}("PortfolioId" => PortfolioId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_constraints_for_portfolio(
    PortfolioId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "ListConstraintsForPortfolio",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("PortfolioId" => PortfolioId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_launch_paths(product_id)
    list_launch_paths(product_id, params::Dict{String,<:Any})

 Lists the paths to the specified product. A path describes how the user gets access to a
specified product and is necessary when provisioning a product. A path also determines the
constraints that are put on a product. A path is dependent on a specific product, porfolio,
and principal.    When provisioning a product that's been added to a portfolio, you must
grant your user, group, or role access to the portfolio. For more information, see Granting
users access in the Service Catalog User Guide.

# Arguments
- `product_id`: The product identifier.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
- `"PageSize"`: The maximum number of items to return with this call.
- `"PageToken"`: The page token for the next set of results. To retrieve the first set of
  results, use null.
"""
function list_launch_paths(ProductId; aws_config::AbstractAWSConfig=current_aws_config())
    return service_catalog(
        "ListLaunchPaths",
        Dict{String,Any}("ProductId" => ProductId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_launch_paths(
    ProductId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "ListLaunchPaths",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ProductId" => ProductId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_organization_portfolio_access(organization_node_type, portfolio_id)
    list_organization_portfolio_access(organization_node_type, portfolio_id, params::Dict{String,<:Any})

Lists the organization nodes that have access to the specified portfolio. This API can only
be called by the management account in the organization or by a delegated admin. If a
delegated admin is de-registered, they can no longer perform this operation.

# Arguments
- `organization_node_type`: The organization node type that will be returned in the output.
     ORGANIZATION - Organization that has access to the portfolio.     ORGANIZATIONAL_UNIT -
  Organizational unit that has access to the portfolio within your organization.    ACCOUNT -
  Account that has access to the portfolio within your organization.
- `portfolio_id`: The portfolio identifier. For example, port-2abcdext3y5fk.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
- `"PageSize"`: The maximum number of items to return with this call.
- `"PageToken"`: The page token for the next set of results. To retrieve the first set of
  results, use null.
"""
function list_organization_portfolio_access(
    OrganizationNodeType, PortfolioId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "ListOrganizationPortfolioAccess",
        Dict{String,Any}(
            "OrganizationNodeType" => OrganizationNodeType, "PortfolioId" => PortfolioId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_organization_portfolio_access(
    OrganizationNodeType,
    PortfolioId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "ListOrganizationPortfolioAccess",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "OrganizationNodeType" => OrganizationNodeType,
                    "PortfolioId" => PortfolioId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_portfolio_access(portfolio_id)
    list_portfolio_access(portfolio_id, params::Dict{String,<:Any})

Lists the account IDs that have access to the specified portfolio. A delegated admin can
list the accounts that have access to the shared portfolio. Note that if a delegated admin
is de-registered, they can no longer perform this operation.

# Arguments
- `portfolio_id`: The portfolio identifier.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
- `"OrganizationParentId"`: The ID of an organization node the portfolio is shared with.
  All children of this node with an inherited portfolio share will be returned.
- `"PageSize"`: The maximum number of items to return with this call.
- `"PageToken"`: The page token for the next set of results. To retrieve the first set of
  results, use null.
"""
function list_portfolio_access(
    PortfolioId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "ListPortfolioAccess",
        Dict{String,Any}("PortfolioId" => PortfolioId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_portfolio_access(
    PortfolioId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "ListPortfolioAccess",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("PortfolioId" => PortfolioId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_portfolios()
    list_portfolios(params::Dict{String,<:Any})

Lists all portfolios in the catalog.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
- `"PageSize"`: The maximum number of items to return with this call.
- `"PageToken"`: The page token for the next set of results. To retrieve the first set of
  results, use null.
"""
function list_portfolios(; aws_config::AbstractAWSConfig=current_aws_config())
    return service_catalog(
        "ListPortfolios"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_portfolios(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "ListPortfolios", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_portfolios_for_product(product_id)
    list_portfolios_for_product(product_id, params::Dict{String,<:Any})

Lists all portfolios that the specified product is associated with.

# Arguments
- `product_id`: The product identifier.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
- `"PageSize"`: The maximum number of items to return with this call.
- `"PageToken"`: The page token for the next set of results. To retrieve the first set of
  results, use null.
"""
function list_portfolios_for_product(
    ProductId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "ListPortfoliosForProduct",
        Dict{String,Any}("ProductId" => ProductId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_portfolios_for_product(
    ProductId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "ListPortfoliosForProduct",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ProductId" => ProductId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_principals_for_portfolio(portfolio_id)
    list_principals_for_portfolio(portfolio_id, params::Dict{String,<:Any})

Lists all PrincipalARNs and corresponding PrincipalTypes associated with the specified
portfolio.

# Arguments
- `portfolio_id`: The portfolio identifier.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
- `"PageSize"`: The maximum number of items to return with this call.
- `"PageToken"`: The page token for the next set of results. To retrieve the first set of
  results, use null.
"""
function list_principals_for_portfolio(
    PortfolioId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "ListPrincipalsForPortfolio",
        Dict{String,Any}("PortfolioId" => PortfolioId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_principals_for_portfolio(
    PortfolioId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "ListPrincipalsForPortfolio",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("PortfolioId" => PortfolioId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_provisioned_product_plans()
    list_provisioned_product_plans(params::Dict{String,<:Any})

Lists the plans for the specified provisioned product or all plans to which the user has
access.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
- `"AccessLevelFilter"`: The access level to use to obtain results. The default is User.
- `"PageSize"`: The maximum number of items to return with this call.
- `"PageToken"`: The page token for the next set of results. To retrieve the first set of
  results, use null.
- `"ProvisionProductId"`: The product identifier.
"""
function list_provisioned_product_plans(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "ListProvisionedProductPlans";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_provisioned_product_plans(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "ListProvisionedProductPlans",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_provisioning_artifacts(product_id)
    list_provisioning_artifacts(product_id, params::Dict{String,<:Any})

Lists all provisioning artifacts (also known as versions) for the specified product.

# Arguments
- `product_id`: The product identifier.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
"""
function list_provisioning_artifacts(
    ProductId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "ListProvisioningArtifacts",
        Dict{String,Any}("ProductId" => ProductId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_provisioning_artifacts(
    ProductId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "ListProvisioningArtifacts",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ProductId" => ProductId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_provisioning_artifacts_for_service_action(service_action_id)
    list_provisioning_artifacts_for_service_action(service_action_id, params::Dict{String,<:Any})

Lists all provisioning artifacts (also known as versions) for the specified self-service
action.

# Arguments
- `service_action_id`: The self-service action identifier. For example, act-fs7abcd89wxyz.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
- `"PageSize"`: The maximum number of items to return with this call.
- `"PageToken"`: The page token for the next set of results. To retrieve the first set of
  results, use null.
"""
function list_provisioning_artifacts_for_service_action(
    ServiceActionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "ListProvisioningArtifactsForServiceAction",
        Dict{String,Any}("ServiceActionId" => ServiceActionId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_provisioning_artifacts_for_service_action(
    ServiceActionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "ListProvisioningArtifactsForServiceAction",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ServiceActionId" => ServiceActionId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_record_history()
    list_record_history(params::Dict{String,<:Any})

Lists the specified requests or all performed requests.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
- `"AccessLevelFilter"`: The access level to use to obtain results. The default is User.
- `"PageSize"`: The maximum number of items to return with this call.
- `"PageToken"`: The page token for the next set of results. To retrieve the first set of
  results, use null.
- `"SearchFilter"`: The search filter to scope the results.
"""
function list_record_history(; aws_config::AbstractAWSConfig=current_aws_config())
    return service_catalog(
        "ListRecordHistory"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_record_history(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "ListRecordHistory", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_resources_for_tag_option(tag_option_id)
    list_resources_for_tag_option(tag_option_id, params::Dict{String,<:Any})

Lists the resources associated with the specified TagOption.

# Arguments
- `tag_option_id`: The TagOption identifier.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"PageSize"`: The maximum number of items to return with this call.
- `"PageToken"`: The page token for the next set of results. To retrieve the first set of
  results, use null.
- `"ResourceType"`: The resource type.    Portfolio     Product
"""
function list_resources_for_tag_option(
    TagOptionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "ListResourcesForTagOption",
        Dict{String,Any}("TagOptionId" => TagOptionId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_resources_for_tag_option(
    TagOptionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "ListResourcesForTagOption",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TagOptionId" => TagOptionId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_service_actions()
    list_service_actions(params::Dict{String,<:Any})

Lists all self-service actions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
- `"PageSize"`: The maximum number of items to return with this call.
- `"PageToken"`: The page token for the next set of results. To retrieve the first set of
  results, use null.
"""
function list_service_actions(; aws_config::AbstractAWSConfig=current_aws_config())
    return service_catalog(
        "ListServiceActions"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_service_actions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "ListServiceActions", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_service_actions_for_provisioning_artifact(product_id, provisioning_artifact_id)
    list_service_actions_for_provisioning_artifact(product_id, provisioning_artifact_id, params::Dict{String,<:Any})

Returns a paginated list of self-service actions associated with the specified Product ID
and Provisioning Artifact ID.

# Arguments
- `product_id`: The product identifier. For example, prod-abcdzk7xy33qa.
- `provisioning_artifact_id`: The identifier of the provisioning artifact. For example,
  pa-4abcdjnxjj6ne.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
- `"PageSize"`: The maximum number of items to return with this call.
- `"PageToken"`: The page token for the next set of results. To retrieve the first set of
  results, use null.
"""
function list_service_actions_for_provisioning_artifact(
    ProductId, ProvisioningArtifactId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "ListServiceActionsForProvisioningArtifact",
        Dict{String,Any}(
            "ProductId" => ProductId, "ProvisioningArtifactId" => ProvisioningArtifactId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_service_actions_for_provisioning_artifact(
    ProductId,
    ProvisioningArtifactId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "ListServiceActionsForProvisioningArtifact",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ProductId" => ProductId,
                    "ProvisioningArtifactId" => ProvisioningArtifactId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_stack_instances_for_provisioned_product(provisioned_product_id)
    list_stack_instances_for_provisioned_product(provisioned_product_id, params::Dict{String,<:Any})

Returns summary information about stack instances that are associated with the specified
CFN_STACKSET type provisioned product. You can filter for stack instances that are
associated with a specific Amazon Web Services account name or Region.

# Arguments
- `provisioned_product_id`: The identifier of the provisioned product.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
- `"PageSize"`: The maximum number of items to return with this call.
- `"PageToken"`: The page token for the next set of results. To retrieve the first set of
  results, use null.
"""
function list_stack_instances_for_provisioned_product(
    ProvisionedProductId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "ListStackInstancesForProvisionedProduct",
        Dict{String,Any}("ProvisionedProductId" => ProvisionedProductId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_stack_instances_for_provisioned_product(
    ProvisionedProductId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "ListStackInstancesForProvisionedProduct",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ProvisionedProductId" => ProvisionedProductId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tag_options()
    list_tag_options(params::Dict{String,<:Any})

Lists the specified TagOptions or all TagOptions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: The search filters. If no search filters are specified, the output includes
  all TagOptions.
- `"PageSize"`: The maximum number of items to return with this call.
- `"PageToken"`: The page token for the next set of results. To retrieve the first set of
  results, use null.
"""
function list_tag_options(; aws_config::AbstractAWSConfig=current_aws_config())
    return service_catalog(
        "ListTagOptions"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_tag_options(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "ListTagOptions", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    notify_provision_product_engine_workflow_result(idempotency_token, record_id, status, workflow_token)
    notify_provision_product_engine_workflow_result(idempotency_token, record_id, status, workflow_token, params::Dict{String,<:Any})

 Notifies the result of the provisioning engine execution.

# Arguments
- `idempotency_token`:  The idempotency token that identifies the provisioning engine
  execution.
- `record_id`:  The identifier of the record.
- `status`:  The status of the provisioning engine execution.
- `workflow_token`:  The encrypted contents of the provisioning engine execution payload
  that Service Catalog sends after the Terraform product provisioning workflow starts.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FailureReason"`:  The reason why the provisioning engine execution failed.
- `"Outputs"`:  The output of the provisioning engine execution.
- `"ResourceIdentifier"`:  The ID for the provisioned product resources that are part of a
  resource group.
"""
function notify_provision_product_engine_workflow_result(
    IdempotencyToken,
    RecordId,
    Status,
    WorkflowToken;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "NotifyProvisionProductEngineWorkflowResult",
        Dict{String,Any}(
            "IdempotencyToken" => IdempotencyToken,
            "RecordId" => RecordId,
            "Status" => Status,
            "WorkflowToken" => WorkflowToken,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function notify_provision_product_engine_workflow_result(
    IdempotencyToken,
    RecordId,
    Status,
    WorkflowToken,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "NotifyProvisionProductEngineWorkflowResult",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "IdempotencyToken" => IdempotencyToken,
                    "RecordId" => RecordId,
                    "Status" => Status,
                    "WorkflowToken" => WorkflowToken,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    notify_terminate_provisioned_product_engine_workflow_result(idempotency_token, record_id, status, workflow_token)
    notify_terminate_provisioned_product_engine_workflow_result(idempotency_token, record_id, status, workflow_token, params::Dict{String,<:Any})

 Notifies the result of the terminate engine execution.

# Arguments
- `idempotency_token`:  The idempotency token that identifies the terminate engine
  execution.
- `record_id`:  The identifier of the record.
- `status`:  The status of the terminate engine execution.
- `workflow_token`:  The encrypted contents of the terminate engine execution payload that
  Service Catalog sends after the Terraform product terminate workflow starts.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FailureReason"`:  The reason why the terminate engine execution failed.
"""
function notify_terminate_provisioned_product_engine_workflow_result(
    IdempotencyToken,
    RecordId,
    Status,
    WorkflowToken;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "NotifyTerminateProvisionedProductEngineWorkflowResult",
        Dict{String,Any}(
            "IdempotencyToken" => IdempotencyToken,
            "RecordId" => RecordId,
            "Status" => Status,
            "WorkflowToken" => WorkflowToken,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function notify_terminate_provisioned_product_engine_workflow_result(
    IdempotencyToken,
    RecordId,
    Status,
    WorkflowToken,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "NotifyTerminateProvisionedProductEngineWorkflowResult",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "IdempotencyToken" => IdempotencyToken,
                    "RecordId" => RecordId,
                    "Status" => Status,
                    "WorkflowToken" => WorkflowToken,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    notify_update_provisioned_product_engine_workflow_result(idempotency_token, record_id, status, workflow_token)
    notify_update_provisioned_product_engine_workflow_result(idempotency_token, record_id, status, workflow_token, params::Dict{String,<:Any})

 Notifies the result of the update engine execution.

# Arguments
- `idempotency_token`:  The idempotency token that identifies the update engine execution.
- `record_id`:  The identifier of the record.
- `status`:  The status of the update engine execution.
- `workflow_token`:  The encrypted contents of the update engine execution payload that
  Service Catalog sends after the Terraform product update workflow starts.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FailureReason"`:  The reason why the update engine execution failed.
- `"Outputs"`:  The output of the update engine execution.
"""
function notify_update_provisioned_product_engine_workflow_result(
    IdempotencyToken,
    RecordId,
    Status,
    WorkflowToken;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "NotifyUpdateProvisionedProductEngineWorkflowResult",
        Dict{String,Any}(
            "IdempotencyToken" => IdempotencyToken,
            "RecordId" => RecordId,
            "Status" => Status,
            "WorkflowToken" => WorkflowToken,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function notify_update_provisioned_product_engine_workflow_result(
    IdempotencyToken,
    RecordId,
    Status,
    WorkflowToken,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "NotifyUpdateProvisionedProductEngineWorkflowResult",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "IdempotencyToken" => IdempotencyToken,
                    "RecordId" => RecordId,
                    "Status" => Status,
                    "WorkflowToken" => WorkflowToken,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    provision_product(provision_token, provisioned_product_name)
    provision_product(provision_token, provisioned_product_name, params::Dict{String,<:Any})

 Provisions the specified product.   A provisioned product is a resourced instance of a
product. For example, provisioning a product that's based on an CloudFormation template
launches an CloudFormation stack and its underlying resources. You can check the status of
this request using DescribeRecord.   If the request contains a tag key with an empty list
of values, there's a tag conflict for that key. Don't include conflicted keys as tags, or
this will cause the error \"Parameter validation failed: Missing required parameter in
Tags[N]:Value\".    When provisioning a product that's been added to a portfolio, you must
grant your user, group, or role access to the portfolio. For more information, see Granting
users access in the Service Catalog User Guide.

# Arguments
- `provision_token`: An idempotency token that uniquely identifies the provisioning request.
- `provisioned_product_name`: A user-friendly name for the provisioned product. This value
  must be unique for the Amazon Web Services account and cannot be updated after the product
  is provisioned.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
- `"NotificationArns"`: Passed to CloudFormation. The SNS topic ARNs to which to publish
  stack-related events.
- `"PathId"`: The path identifier of the product. This value is optional if the product has
  a default path, and required if the product has more than one path. To list the paths for a
  product, use ListLaunchPaths. You must provide the name or ID, but not both.
- `"PathName"`: The name of the path. You must provide the name or ID, but not both.
- `"ProductId"`: The product identifier. You must provide the name or ID, but not both.
- `"ProductName"`: The name of the product. You must provide the name or ID, but not both.
- `"ProvisioningArtifactId"`: The identifier of the provisioning artifact. You must provide
  the name or ID, but not both.
- `"ProvisioningArtifactName"`: The name of the provisioning artifact. You must provide the
  name or ID, but not both.
- `"ProvisioningParameters"`: Parameters specified by the administrator that are required
  for provisioning the product.
- `"ProvisioningPreferences"`: An object that contains information about the provisioning
  preferences for a stack set.
- `"Tags"`: One or more tags.
"""
function provision_product(
    ProvisionToken,
    ProvisionedProductName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "ProvisionProduct",
        Dict{String,Any}(
            "ProvisionToken" => ProvisionToken,
            "ProvisionedProductName" => ProvisionedProductName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function provision_product(
    ProvisionToken,
    ProvisionedProductName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "ProvisionProduct",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ProvisionToken" => ProvisionToken,
                    "ProvisionedProductName" => ProvisionedProductName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    reject_portfolio_share(portfolio_id)
    reject_portfolio_share(portfolio_id, params::Dict{String,<:Any})

Rejects an offer to share the specified portfolio.

# Arguments
- `portfolio_id`: The portfolio identifier.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
- `"PortfolioShareType"`: The type of shared portfolios to reject. The default is to reject
  imported portfolios.    AWS_ORGANIZATIONS - Reject portfolios shared by the management
  account of your organization.    IMPORTED - Reject imported portfolios.
  AWS_SERVICECATALOG - Not supported. (Throws ResourceNotFoundException.)   For example, aws
  servicecatalog reject-portfolio-share --portfolio-id \"port-2qwzkwxt3y5fk\"
  --portfolio-share-type AWS_ORGANIZATIONS
"""
function reject_portfolio_share(
    PortfolioId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "RejectPortfolioShare",
        Dict{String,Any}("PortfolioId" => PortfolioId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function reject_portfolio_share(
    PortfolioId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "RejectPortfolioShare",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("PortfolioId" => PortfolioId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    scan_provisioned_products()
    scan_provisioned_products(params::Dict{String,<:Any})

Lists the provisioned products that are available (not terminated). To use additional
filtering, see SearchProvisionedProducts.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
- `"AccessLevelFilter"`: The access level to use to obtain results. The default is User.
- `"PageSize"`: The maximum number of items to return with this call.
- `"PageToken"`: The page token for the next set of results. To retrieve the first set of
  results, use null.
"""
function scan_provisioned_products(; aws_config::AbstractAWSConfig=current_aws_config())
    return service_catalog(
        "ScanProvisionedProducts"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function scan_provisioned_products(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "ScanProvisionedProducts",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    search_products()
    search_products(params::Dict{String,<:Any})

Gets information about the products to which the caller has access.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
- `"Filters"`: The search filters. If no search filters are specified, the output includes
  all products to which the caller has access.
- `"PageSize"`: The maximum number of items to return with this call.
- `"PageToken"`: The page token for the next set of results. To retrieve the first set of
  results, use null.
- `"SortBy"`: The sort field. If no value is specified, the results are not sorted.
- `"SortOrder"`: The sort order. If no value is specified, the results are not sorted.
"""
function search_products(; aws_config::AbstractAWSConfig=current_aws_config())
    return service_catalog(
        "SearchProducts"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function search_products(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "SearchProducts", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    search_products_as_admin()
    search_products_as_admin(params::Dict{String,<:Any})

Gets information about the products for the specified portfolio or all products.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
- `"Filters"`: The search filters. If no search filters are specified, the output includes
  all products to which the administrator has access.
- `"PageSize"`: The maximum number of items to return with this call.
- `"PageToken"`: The page token for the next set of results. To retrieve the first set of
  results, use null.
- `"PortfolioId"`: The portfolio identifier.
- `"ProductSource"`: Access level of the source of the product.
- `"SortBy"`: The sort field. If no value is specified, the results are not sorted.
- `"SortOrder"`: The sort order. If no value is specified, the results are not sorted.
"""
function search_products_as_admin(; aws_config::AbstractAWSConfig=current_aws_config())
    return service_catalog(
        "SearchProductsAsAdmin"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function search_products_as_admin(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "SearchProductsAsAdmin",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    search_provisioned_products()
    search_provisioned_products(params::Dict{String,<:Any})

Gets information about the provisioned products that meet the specified criteria.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
- `"AccessLevelFilter"`: The access level to use to obtain results. The default is User.
- `"Filters"`: The search filters. When the key is SearchQuery, the searchable fields are
  arn, createdTime, id, lastRecordId, idempotencyToken, name, physicalId, productId,
  provisioningArtifactId, type, status, tags, userArn, userArnSession,
  lastProvisioningRecordId, lastSuccessfulProvisioningRecordId, productName, and
  provisioningArtifactName. Example: \"SearchQuery\":[\"status:AVAILABLE\"]
- `"PageSize"`: The maximum number of items to return with this call.
- `"PageToken"`: The page token for the next set of results. To retrieve the first set of
  results, use null.
- `"SortBy"`: The sort field. If no value is specified, the results are not sorted. The
  valid values are arn, id, name, and lastRecordId.
- `"SortOrder"`: The sort order. If no value is specified, the results are not sorted.
"""
function search_provisioned_products(; aws_config::AbstractAWSConfig=current_aws_config())
    return service_catalog(
        "SearchProvisionedProducts"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function search_provisioned_products(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "SearchProvisionedProducts",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    terminate_provisioned_product(terminate_token)
    terminate_provisioned_product(terminate_token, params::Dict{String,<:Any})

Terminates the specified provisioned product. This operation does not delete any records
associated with the provisioned product. You can check the status of this request using
DescribeRecord.

# Arguments
- `terminate_token`: An idempotency token that uniquely identifies the termination request.
  This token is only valid during the termination process. After the provisioned product is
  terminated, subsequent requests to terminate the same provisioned product always return
  ResourceNotFound.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
- `"IgnoreErrors"`: If set to true, Service Catalog stops managing the specified
  provisioned product even if it cannot delete the underlying resources.
- `"ProvisionedProductId"`: The identifier of the provisioned product. You cannot specify
  both ProvisionedProductName and ProvisionedProductId.
- `"ProvisionedProductName"`: The name of the provisioned product. You cannot specify both
  ProvisionedProductName and ProvisionedProductId.
- `"RetainPhysicalResources"`: When this boolean parameter is set to true, the
  TerminateProvisionedProduct API deletes the Service Catalog provisioned product. However,
  it does not remove the CloudFormation stack, stack set, or the underlying resources of the
  deleted provisioned product. The default value is false.
"""
function terminate_provisioned_product(
    TerminateToken; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "TerminateProvisionedProduct",
        Dict{String,Any}("TerminateToken" => TerminateToken);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function terminate_provisioned_product(
    TerminateToken,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "TerminateProvisionedProduct",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TerminateToken" => TerminateToken), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_constraint(id)
    update_constraint(id, params::Dict{String,<:Any})

Updates the specified constraint.

# Arguments
- `id`: The identifier of the constraint.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
- `"Description"`: The updated description of the constraint.
- `"Parameters"`: The constraint parameters, in JSON format. The syntax depends on the
  constraint type as follows:  LAUNCH  You are required to specify either the RoleArn or the
  LocalRoleName but can't use both. Specify the RoleArn property as follows:  {\"RoleArn\" :
  \"arn:aws:iam::123456789012:role/LaunchRole\"}  Specify the LocalRoleName property as
  follows:  {\"LocalRoleName\": \"SCBasicLaunchRole\"}  If you specify the LocalRoleName
  property, when an account uses the launch constraint, the IAM role with that name in the
  account will be used. This allows launch-role constraints to be account-agnostic so the
  administrator can create fewer resources per shared account.  The given role name must
  exist in the account used to create the launch constraint and the account of the user who
  launches a product with this launch constraint.  You cannot have both a LAUNCH and a
  STACKSET constraint. You also cannot have more than one LAUNCH constraint on a product and
  portfolio.  NOTIFICATION  Specify the NotificationArns property as follows:
  {\"NotificationArns\" : [\"arn:aws:sns:us-east-1:123456789012:Topic\"]}   RESOURCE_UPDATE
  Specify the TagUpdatesOnProvisionedProduct property as follows:
  {\"Version\":\"2.0\",\"Properties\":{\"TagUpdateOnProvisionedProduct\":\"String\"}}  The
  TagUpdatesOnProvisionedProduct property accepts a string value of ALLOWED or NOT_ALLOWED.
  STACKSET  Specify the Parameters property as follows:  {\"Version\": \"String\",
  \"Properties\": {\"AccountList\": [ \"String\" ], \"RegionList\": [ \"String\" ],
  \"AdminRole\": \"String\", \"ExecutionRole\": \"String\"}}  You cannot have both a LAUNCH
  and a STACKSET constraint. You also cannot have more than one STACKSET constraint on a
  product and portfolio. Products with a STACKSET constraint will launch an CloudFormation
  stack set.  TEMPLATE  Specify the Rules property. For more information, see Template
  Constraint Rules.
"""
function update_constraint(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return service_catalog(
        "UpdateConstraint",
        Dict{String,Any}("Id" => Id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_constraint(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "UpdateConstraint",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Id" => Id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_portfolio(id)
    update_portfolio(id, params::Dict{String,<:Any})

Updates the specified portfolio. You cannot update a product that was shared with you.

# Arguments
- `id`: The portfolio identifier.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
- `"AddTags"`: The tags to add.
- `"Description"`: The updated description of the portfolio.
- `"DisplayName"`: The name to use for display purposes.
- `"ProviderName"`: The updated name of the portfolio provider.
- `"RemoveTags"`: The tags to remove.
"""
function update_portfolio(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return service_catalog(
        "UpdatePortfolio",
        Dict{String,Any}("Id" => Id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_portfolio(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "UpdatePortfolio",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Id" => Id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_portfolio_share(portfolio_id)
    update_portfolio_share(portfolio_id, params::Dict{String,<:Any})

Updates the specified portfolio share. You can use this API to enable or disable TagOptions
sharing or Principal sharing for an existing portfolio share.  The portfolio share cannot
be updated if the CreatePortfolioShare operation is IN_PROGRESS, as the share is not
available to recipient entities. In this case, you must wait for the portfolio share to be
completed. You must provide the accountId or organization node in the input, but not both.
If the portfolio is shared to both an external account and an organization node, and both
shares need to be updated, you must invoke UpdatePortfolioShare separately for each share
type.  This API cannot be used for removing the portfolio share. You must use
DeletePortfolioShare API for that action.   When you associate a principal with portfolio,
a potential privilege escalation path may occur when that portfolio is then shared with
other accounts. For a user in a recipient account who is not an Service Catalog Admin, but
still has the ability to create Principals (Users/Groups/Roles), that user could create a
role that matches a principal name association for the portfolio. Although this user may
not know which principal names are associated through Service Catalog, they may be able to
guess the user. If this potential escalation path is a concern, then Service Catalog
recommends using PrincipalType as IAM. With this configuration, the PrincipalARN must
already exist in the recipient account before it can be associated.

# Arguments
- `portfolio_id`: The unique identifier of the portfolio for which the share will be
  updated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
- `"AccountId"`: The Amazon Web Services account Id of the recipient account. This field is
  required when updating an external account to account type share.
- `"OrganizationNode"`:
- `"SharePrincipals"`: A flag to enables or disables Principals sharing in the portfolio.
  If this field is not provided, the current state of the Principals sharing on the portfolio
  share will not be modified.
- `"ShareTagOptions"`: Enables or disables TagOptions sharing for the portfolio share. If
  this field is not provided, the current state of TagOptions sharing on the portfolio share
  will not be modified.
"""
function update_portfolio_share(
    PortfolioId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "UpdatePortfolioShare",
        Dict{String,Any}("PortfolioId" => PortfolioId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_portfolio_share(
    PortfolioId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "UpdatePortfolioShare",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("PortfolioId" => PortfolioId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_product(id)
    update_product(id, params::Dict{String,<:Any})

Updates the specified product.

# Arguments
- `id`: The product identifier.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
- `"AddTags"`: The tags to add to the product.
- `"Description"`: The updated description of the product.
- `"Distributor"`: The updated distributor of the product.
- `"Name"`: The updated product name.
- `"Owner"`: The updated owner of the product.
- `"RemoveTags"`: The tags to remove from the product.
- `"SourceConnection"`: Specifies connection details for the updated product and syncs the
  product to the connection source artifact. This automatically manages the product's
  artifacts based on changes to the source. The SourceConnection parameter consists of the
  following sub-fields.    Type     ConnectionParamters
- `"SupportDescription"`: The updated support description for the product.
- `"SupportEmail"`: The updated support email for the product.
- `"SupportUrl"`: The updated support URL for the product.
"""
function update_product(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return service_catalog(
        "UpdateProduct",
        Dict{String,Any}("Id" => Id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_product(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "UpdateProduct",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Id" => Id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_provisioned_product(update_token)
    update_provisioned_product(update_token, params::Dict{String,<:Any})

Requests updates to the configuration of the specified provisioned product. If there are
tags associated with the object, they cannot be updated or added. Depending on the specific
updates requested, this operation can update with no interruption, with some interruption,
or replace the provisioned product entirely. You can check the status of this request using
DescribeRecord.

# Arguments
- `update_token`: The idempotency token that uniquely identifies the provisioning update
  request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
- `"PathId"`: The path identifier. This value is optional if the product has a default
  path, and required if the product has more than one path. You must provide the name or ID,
  but not both.
- `"PathName"`: The name of the path. You must provide the name or ID, but not both.
- `"ProductId"`: The identifier of the product. You must provide the name or ID, but not
  both.
- `"ProductName"`: The name of the product. You must provide the name or ID, but not both.
- `"ProvisionedProductId"`: The identifier of the provisioned product. You must provide the
  name or ID, but not both.
- `"ProvisionedProductName"`: The name of the provisioned product. You cannot specify both
  ProvisionedProductName and ProvisionedProductId.
- `"ProvisioningArtifactId"`: The identifier of the provisioning artifact.
- `"ProvisioningArtifactName"`: The name of the provisioning artifact. You must provide the
  name or ID, but not both.
- `"ProvisioningParameters"`: The new parameters.
- `"ProvisioningPreferences"`: An object that contains information about the provisioning
  preferences for a stack set.
- `"Tags"`: One or more tags. Requires the product to have RESOURCE_UPDATE constraint with
  TagUpdatesOnProvisionedProduct set to ALLOWED to allow tag updates.
"""
function update_provisioned_product(
    UpdateToken; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "UpdateProvisionedProduct",
        Dict{String,Any}("UpdateToken" => UpdateToken);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_provisioned_product(
    UpdateToken,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "UpdateProvisionedProduct",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("UpdateToken" => UpdateToken), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_provisioned_product_properties(idempotency_token, provisioned_product_id, provisioned_product_properties)
    update_provisioned_product_properties(idempotency_token, provisioned_product_id, provisioned_product_properties, params::Dict{String,<:Any})

Requests updates to the properties of the specified provisioned product.

# Arguments
- `idempotency_token`: The idempotency token that uniquely identifies the provisioning
  product update request.
- `provisioned_product_id`: The identifier of the provisioned product.
- `provisioned_product_properties`: A map that contains the provisioned product properties
  to be updated. The LAUNCH_ROLE key accepts role ARNs. This key allows an administrator to
  call UpdateProvisionedProductProperties to update the launch role that is associated with a
  provisioned product. This role is used when an end user calls a provisioning operation such
  as UpdateProvisionedProduct, TerminateProvisionedProduct, or
  ExecuteProvisionedProductServiceAction. Only a role ARN is valid. A user ARN is invalid.
  The OWNER key accepts user ARNs, IAM role ARNs, and STS assumed-role ARNs. The owner is the
  user that has permission to see, update, terminate, and execute service actions in the
  provisioned product. The administrator can change the owner of a provisioned product to
  another IAM or STS entity within the same account. Both end user owners and administrators
  can see ownership history of the provisioned product using the ListRecordHistory API. The
  new owner can describe all past records for the provisioned product using the
  DescribeRecord API. The previous owner can no longer use DescribeRecord, but can still see
  the product's history from when he was an owner using ListRecordHistory. If a provisioned
  product ownership is assigned to an end user, they can see and perform any action through
  the API or Service Catalog console such as update, terminate, and execute service actions.
  If an end user provisions a product and the owner is updated to someone else, they will no
  longer be able to see or perform any actions through API or the Service Catalog console on
  that provisioned product.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
"""
function update_provisioned_product_properties(
    IdempotencyToken,
    ProvisionedProductId,
    ProvisionedProductProperties;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "UpdateProvisionedProductProperties",
        Dict{String,Any}(
            "IdempotencyToken" => IdempotencyToken,
            "ProvisionedProductId" => ProvisionedProductId,
            "ProvisionedProductProperties" => ProvisionedProductProperties,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_provisioned_product_properties(
    IdempotencyToken,
    ProvisionedProductId,
    ProvisionedProductProperties,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "UpdateProvisionedProductProperties",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "IdempotencyToken" => IdempotencyToken,
                    "ProvisionedProductId" => ProvisionedProductId,
                    "ProvisionedProductProperties" => ProvisionedProductProperties,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_provisioning_artifact(product_id, provisioning_artifact_id)
    update_provisioning_artifact(product_id, provisioning_artifact_id, params::Dict{String,<:Any})

Updates the specified provisioning artifact (also known as a version) for the specified
product. You cannot update a provisioning artifact for a product that was shared with you.

# Arguments
- `product_id`: The product identifier.
- `provisioning_artifact_id`: The identifier of the provisioning artifact.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
- `"Active"`: Indicates whether the product version is active. Inactive provisioning
  artifacts are invisible to end users. End users cannot launch or update a provisioned
  product from an inactive provisioning artifact.
- `"Description"`: The updated description of the provisioning artifact.
- `"Guidance"`: Information set by the administrator to provide guidance to end users about
  which provisioning artifacts to use. The DEFAULT value indicates that the product version
  is active. The administrator can set the guidance to DEPRECATED to inform users that the
  product version is deprecated. Users are able to make updates to a provisioned product of a
  deprecated version but cannot launch new provisioned products using a deprecated version.
- `"Name"`: The updated name of the provisioning artifact.
"""
function update_provisioning_artifact(
    ProductId, ProvisioningArtifactId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "UpdateProvisioningArtifact",
        Dict{String,Any}(
            "ProductId" => ProductId, "ProvisioningArtifactId" => ProvisioningArtifactId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_provisioning_artifact(
    ProductId,
    ProvisioningArtifactId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return service_catalog(
        "UpdateProvisioningArtifact",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ProductId" => ProductId,
                    "ProvisioningArtifactId" => ProvisioningArtifactId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_service_action(id)
    update_service_action(id, params::Dict{String,<:Any})

Updates a self-service action.

# Arguments
- `id`: The self-service action identifier.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The language code.    jp - Japanese    zh - Chinese
- `"Definition"`: A map that defines the self-service action.
- `"Description"`: The self-service action description.
- `"Name"`: The self-service action name.
"""
function update_service_action(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return service_catalog(
        "UpdateServiceAction",
        Dict{String,Any}("Id" => Id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_service_action(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "UpdateServiceAction",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Id" => Id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_tag_option(id)
    update_tag_option(id, params::Dict{String,<:Any})

Updates the specified TagOption.

# Arguments
- `id`: The TagOption identifier.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Active"`: The updated active state.
- `"Value"`: The updated value.
"""
function update_tag_option(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return service_catalog(
        "UpdateTagOption",
        Dict{String,Any}("Id" => Id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_tag_option(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return service_catalog(
        "UpdateTagOption",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Id" => Id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: codecatalyst
using AWS.Compat
using AWS.UUIDs

"""
    create_access_token(name)
    create_access_token(name, params::Dict{String,<:Any})

Creates a personal access token (PAT) for the current user. A personal access token (PAT)
is similar to a password. It is associated with your user identity for use across all
spaces and projects in Amazon CodeCatalyst. You use PATs to access CodeCatalyst from
resources that include integrated development environments (IDEs) and Git-based source
repositories. PATs represent you in Amazon CodeCatalyst and you can manage them in your
user settings.For more information, see Managing personal access tokens in Amazon
CodeCatalyst.

# Arguments
- `name`: The friendly name of the personal access token.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"expiresTime"`: The date and time the personal access token expires, in coordinated
  universal time (UTC) timestamp format as specified in RFC 3339.
"""
function create_access_token(name; aws_config::AbstractAWSConfig=current_aws_config())
    return codecatalyst(
        "PUT",
        "/v1/accessTokens",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_access_token(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecatalyst(
        "PUT",
        "/v1/accessTokens",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_dev_environment(instance_type, persistent_storage, project_name, space_name)
    create_dev_environment(instance_type, persistent_storage, project_name, space_name, params::Dict{String,<:Any})

Creates a Dev Environment in Amazon CodeCatalyst, a cloud-based development environment
that you can use to quickly work on the code stored in the source repositories of your
project.   When created in the Amazon CodeCatalyst console, by default a Dev Environment is
configured to have a 2 core processor, 4GB of RAM, and 16GB of persistent storage. None of
these defaults apply to a Dev Environment created programmatically.

# Arguments
- `instance_type`: The Amazon EC2 instace type to use for the Dev Environment.
- `persistent_storage`: Information about the amount of storage allocated to the Dev
  Environment.   By default, a Dev Environment is configured to have 16GB of persistent
  storage when created from the Amazon CodeCatalyst console, but there is no default when
  programmatically creating a Dev Environment. Valid values for persistent storage are based
  on memory sizes in 16GB increments. Valid values are 16, 32, and 64.
- `project_name`: The name of the project in the space.
- `space_name`: The name of the space.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"alias"`: The user-defined alias for a Dev Environment.
- `"clientToken"`: A user-specified idempotency token. Idempotency ensures that an API
  request completes only once. With an idempotent request, if the original request completes
  successfully, the subsequent retries return the result from the original successful request
  and have no additional effect.
- `"ides"`: Information about the integrated development environment (IDE) configured for a
  Dev Environment.  An IDE is required to create a Dev Environment. For Dev Environment
  creation, this field contains configuration information and must be provided.
- `"inactivityTimeoutMinutes"`: The amount of time the Dev Environment will run without any
  activity detected before stopping, in minutes. Only whole integers are allowed. Dev
  Environments consume compute minutes when running.
- `"repositories"`: The source repository that contains the branch to clone into the Dev
  Environment.
- `"vpcConnectionName"`: The name of the connection that will be used to connect to Amazon
  VPC, if any.
"""
function create_dev_environment(
    instanceType,
    persistentStorage,
    projectName,
    spaceName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecatalyst(
        "PUT",
        "/v1/spaces/$(spaceName)/projects/$(projectName)/devEnvironments",
        Dict{String,Any}(
            "instanceType" => instanceType, "persistentStorage" => persistentStorage
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_dev_environment(
    instanceType,
    persistentStorage,
    projectName,
    spaceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecatalyst(
        "PUT",
        "/v1/spaces/$(spaceName)/projects/$(projectName)/devEnvironments",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "instanceType" => instanceType, "persistentStorage" => persistentStorage
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_project(display_name, space_name)
    create_project(display_name, space_name, params::Dict{String,<:Any})

Creates a project in a specified space.

# Arguments
- `display_name`: The friendly name of the project that will be displayed to users.
- `space_name`: The name of the space.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description of the project. This description will be displayed to
  all users of the project. We recommend providing a brief description of the project and its
  intended purpose.
"""
function create_project(
    displayName, spaceName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecatalyst(
        "PUT",
        "/v1/spaces/$(spaceName)/projects",
        Dict{String,Any}("displayName" => displayName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_project(
    displayName,
    spaceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecatalyst(
        "PUT",
        "/v1/spaces/$(spaceName)/projects",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("displayName" => displayName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_source_repository(name, project_name, space_name)
    create_source_repository(name, project_name, space_name, params::Dict{String,<:Any})

Creates an empty Git-based source repository in a specified project. The repository is
created with an initial empty commit with a default branch named main.

# Arguments
- `name`: The name of the source repository. For more information about name requirements,
  see Quotas for source repositories.
- `project_name`: The name of the project in the space.
- `space_name`: The name of the space.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description of the source repository.
"""
function create_source_repository(
    name, projectName, spaceName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecatalyst(
        "PUT",
        "/v1/spaces/$(spaceName)/projects/$(projectName)/sourceRepositories/$(name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_source_repository(
    name,
    projectName,
    spaceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecatalyst(
        "PUT",
        "/v1/spaces/$(spaceName)/projects/$(projectName)/sourceRepositories/$(name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_source_repository_branch(name, project_name, source_repository_name, space_name)
    create_source_repository_branch(name, project_name, source_repository_name, space_name, params::Dict{String,<:Any})

Creates a branch in a specified source repository in Amazon CodeCatalyst.   This API only
creates a branch in a source repository hosted in Amazon CodeCatalyst. You cannot use this
API to create a branch in a linked repository.

# Arguments
- `name`: The name for the branch you're creating.
- `project_name`: The name of the project in the space.
- `source_repository_name`: The name of the repository where you want to create a branch.
- `space_name`: The name of the space.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"headCommitId"`: The commit ID in an existing branch from which you want to create the
  new branch.
"""
function create_source_repository_branch(
    name,
    projectName,
    sourceRepositoryName,
    spaceName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecatalyst(
        "PUT",
        "/v1/spaces/$(spaceName)/projects/$(projectName)/sourceRepositories/$(sourceRepositoryName)/branches/$(name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_source_repository_branch(
    name,
    projectName,
    sourceRepositoryName,
    spaceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecatalyst(
        "PUT",
        "/v1/spaces/$(spaceName)/projects/$(projectName)/sourceRepositories/$(sourceRepositoryName)/branches/$(name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_access_token(id)
    delete_access_token(id, params::Dict{String,<:Any})

Deletes a specified personal access token (PAT). A personal access token can only be
deleted by the user who created it.

# Arguments
- `id`: The ID of the personal access token to delete. You can find the IDs of all PATs
  associated with your Amazon Web Services Builder ID in a space by calling ListAccessTokens.

"""
function delete_access_token(id; aws_config::AbstractAWSConfig=current_aws_config())
    return codecatalyst(
        "DELETE",
        "/v1/accessTokens/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_access_token(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecatalyst(
        "DELETE",
        "/v1/accessTokens/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_dev_environment(id, project_name, space_name)
    delete_dev_environment(id, project_name, space_name, params::Dict{String,<:Any})

Deletes a Dev Environment.

# Arguments
- `id`: The system-generated unique ID of the Dev Environment you want to delete. To
  retrieve a list of Dev Environment IDs, use ListDevEnvironments.
- `project_name`: The name of the project in the space.
- `space_name`: The name of the space.

"""
function delete_dev_environment(
    id, projectName, spaceName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecatalyst(
        "DELETE",
        "/v1/spaces/$(spaceName)/projects/$(projectName)/devEnvironments/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_dev_environment(
    id,
    projectName,
    spaceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecatalyst(
        "DELETE",
        "/v1/spaces/$(spaceName)/projects/$(projectName)/devEnvironments/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_project(name, space_name)
    delete_project(name, space_name, params::Dict{String,<:Any})

Deletes a project in a space.

# Arguments
- `name`: The name of the project in the space. To retrieve a list of project names, use
  ListProjects.
- `space_name`: The name of the space.

"""
function delete_project(name, spaceName; aws_config::AbstractAWSConfig=current_aws_config())
    return codecatalyst(
        "DELETE",
        "/v1/spaces/$(spaceName)/projects/$(name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_project(
    name,
    spaceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecatalyst(
        "DELETE",
        "/v1/spaces/$(spaceName)/projects/$(name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_source_repository(name, project_name, space_name)
    delete_source_repository(name, project_name, space_name, params::Dict{String,<:Any})

Deletes a source repository in Amazon CodeCatalyst. You cannot use this API to delete a
linked repository. It can only be used to delete a Amazon CodeCatalyst source repository.

# Arguments
- `name`: The name of the source repository.
- `project_name`: The name of the project in the space.
- `space_name`: The name of the space.

"""
function delete_source_repository(
    name, projectName, spaceName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecatalyst(
        "DELETE",
        "/v1/spaces/$(spaceName)/projects/$(projectName)/sourceRepositories/$(name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_source_repository(
    name,
    projectName,
    spaceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecatalyst(
        "DELETE",
        "/v1/spaces/$(spaceName)/projects/$(projectName)/sourceRepositories/$(name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_space(name)
    delete_space(name, params::Dict{String,<:Any})

Deletes a space.  Deleting a space cannot be undone. Additionally, since space names must
be unique across Amazon CodeCatalyst, you cannot reuse names of deleted spaces.

# Arguments
- `name`: The name of the space. To retrieve a list of space names, use ListSpaces.

"""
function delete_space(name; aws_config::AbstractAWSConfig=current_aws_config())
    return codecatalyst(
        "DELETE",
        "/v1/spaces/$(name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_space(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecatalyst(
        "DELETE",
        "/v1/spaces/$(name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_dev_environment(id, project_name, space_name)
    get_dev_environment(id, project_name, space_name, params::Dict{String,<:Any})

Returns information about a Dev Environment for a source repository in a project. Dev
Environments are specific to the user who creates them.

# Arguments
- `id`: The system-generated unique ID of the Dev Environment for which you want to view
  information. To retrieve a list of Dev Environment IDs, use ListDevEnvironments.
- `project_name`: The name of the project in the space.
- `space_name`: The name of the space.

"""
function get_dev_environment(
    id, projectName, spaceName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecatalyst(
        "GET",
        "/v1/spaces/$(spaceName)/projects/$(projectName)/devEnvironments/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_dev_environment(
    id,
    projectName,
    spaceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecatalyst(
        "GET",
        "/v1/spaces/$(spaceName)/projects/$(projectName)/devEnvironments/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_project(name, space_name)
    get_project(name, space_name, params::Dict{String,<:Any})

Returns information about a project.

# Arguments
- `name`: The name of the project in the space.
- `space_name`: The name of the space.

"""
function get_project(name, spaceName; aws_config::AbstractAWSConfig=current_aws_config())
    return codecatalyst(
        "GET",
        "/v1/spaces/$(spaceName)/projects/$(name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_project(
    name,
    spaceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecatalyst(
        "GET",
        "/v1/spaces/$(spaceName)/projects/$(name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_source_repository(name, project_name, space_name)
    get_source_repository(name, project_name, space_name, params::Dict{String,<:Any})

Returns information about a source repository.

# Arguments
- `name`: The name of the source repository.
- `project_name`: The name of the project in the space.
- `space_name`: The name of the space.

"""
function get_source_repository(
    name, projectName, spaceName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecatalyst(
        "GET",
        "/v1/spaces/$(spaceName)/projects/$(projectName)/sourceRepositories/$(name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_source_repository(
    name,
    projectName,
    spaceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecatalyst(
        "GET",
        "/v1/spaces/$(spaceName)/projects/$(projectName)/sourceRepositories/$(name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_source_repository_clone_urls(project_name, source_repository_name, space_name)
    get_source_repository_clone_urls(project_name, source_repository_name, space_name, params::Dict{String,<:Any})

Returns information about the URLs that can be used with a Git client to clone a source
repository.

# Arguments
- `project_name`: The name of the project in the space.
- `source_repository_name`: The name of the source repository.
- `space_name`: The name of the space.

"""
function get_source_repository_clone_urls(
    projectName,
    sourceRepositoryName,
    spaceName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecatalyst(
        "GET",
        "/v1/spaces/$(spaceName)/projects/$(projectName)/sourceRepositories/$(sourceRepositoryName)/cloneUrls";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_source_repository_clone_urls(
    projectName,
    sourceRepositoryName,
    spaceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecatalyst(
        "GET",
        "/v1/spaces/$(spaceName)/projects/$(projectName)/sourceRepositories/$(sourceRepositoryName)/cloneUrls",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_space(name)
    get_space(name, params::Dict{String,<:Any})

Returns information about an space.

# Arguments
- `name`: The name of the space.

"""
function get_space(name; aws_config::AbstractAWSConfig=current_aws_config())
    return codecatalyst(
        "GET", "/v1/spaces/$(name)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_space(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecatalyst(
        "GET",
        "/v1/spaces/$(name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_subscription(space_name)
    get_subscription(space_name, params::Dict{String,<:Any})

Returns information about the Amazon Web Services account used for billing purposes and the
billing plan for the space.

# Arguments
- `space_name`: The name of the space.

"""
function get_subscription(spaceName; aws_config::AbstractAWSConfig=current_aws_config())
    return codecatalyst(
        "GET",
        "/v1/spaces/$(spaceName)/subscription";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_subscription(
    spaceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecatalyst(
        "GET",
        "/v1/spaces/$(spaceName)/subscription",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_user_details()
    get_user_details(params::Dict{String,<:Any})

Returns information about a user.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"id"`: The system-generated unique ID of the user.
- `"userName"`: The name of the user as displayed in Amazon CodeCatalyst.
"""
function get_user_details(; aws_config::AbstractAWSConfig=current_aws_config())
    return codecatalyst(
        "GET", "/userDetails"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_user_details(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecatalyst(
        "GET",
        "/userDetails",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_workflow(id, project_name, space_name)
    get_workflow(id, project_name, space_name, params::Dict{String,<:Any})

Returns information about a workflow.

# Arguments
- `id`: The ID of the workflow. To rerieve a list of workflow IDs, use ListWorkflows.
- `project_name`: The name of the project in the space.
- `space_name`: The name of the space.

"""
function get_workflow(
    id, projectName, spaceName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecatalyst(
        "GET",
        "/v1/spaces/$(spaceName)/projects/$(projectName)/workflows/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_workflow(
    id,
    projectName,
    spaceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecatalyst(
        "GET",
        "/v1/spaces/$(spaceName)/projects/$(projectName)/workflows/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_workflow_run(id, project_name, space_name)
    get_workflow_run(id, project_name, space_name, params::Dict{String,<:Any})

Returns information about a specified run of a workflow.

# Arguments
- `id`: The ID of the workflow run. To retrieve a list of workflow run IDs, use
  ListWorkflowRuns.
- `project_name`: The name of the project in the space.
- `space_name`: The name of the space.

"""
function get_workflow_run(
    id, projectName, spaceName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecatalyst(
        "GET",
        "/v1/spaces/$(spaceName)/projects/$(projectName)/workflowRuns/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_workflow_run(
    id,
    projectName,
    spaceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecatalyst(
        "GET",
        "/v1/spaces/$(spaceName)/projects/$(projectName)/workflowRuns/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_access_tokens()
    list_access_tokens(params::Dict{String,<:Any})

Lists all personal access tokens (PATs) associated with the user who calls the API. You can
only list PATs associated with your Amazon Web Services Builder ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to show in a single call to this API. If
  the number of results is larger than the number you specified, the response will include a
  NextToken element, which you can use to obtain additional results.
- `"nextToken"`: A token returned from a call to this API to indicate the next batch of
  results to return, if any.
"""
function list_access_tokens(; aws_config::AbstractAWSConfig=current_aws_config())
    return codecatalyst(
        "POST", "/v1/accessTokens"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_access_tokens(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecatalyst(
        "POST",
        "/v1/accessTokens",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_dev_environment_sessions(dev_environment_id, project_name, space_name)
    list_dev_environment_sessions(dev_environment_id, project_name, space_name, params::Dict{String,<:Any})

Retrieves a list of active sessions for a Dev Environment in a project.

# Arguments
- `dev_environment_id`: The system-generated unique ID of the Dev Environment.
- `project_name`: The name of the project in the space.
- `space_name`: The name of the space.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to show in a single call to this API. If
  the number of results is larger than the number you specified, the response will include a
  NextToken element, which you can use to obtain additional results.
- `"nextToken"`: A token returned from a call to this API to indicate the next batch of
  results to return, if any.
"""
function list_dev_environment_sessions(
    devEnvironmentId,
    projectName,
    spaceName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecatalyst(
        "POST",
        "/v1/spaces/$(spaceName)/projects/$(projectName)/devEnvironments/$(devEnvironmentId)/sessions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_dev_environment_sessions(
    devEnvironmentId,
    projectName,
    spaceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecatalyst(
        "POST",
        "/v1/spaces/$(spaceName)/projects/$(projectName)/devEnvironments/$(devEnvironmentId)/sessions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_dev_environments(space_name)
    list_dev_environments(space_name, params::Dict{String,<:Any})

Retrieves a list of Dev Environments in a project.

# Arguments
- `space_name`: The name of the space.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: Information about filters to apply to narrow the results returned in the
  list.
- `"maxResults"`: The maximum number of results to show in a single call to this API. If
  the number of results is larger than the number you specified, the response will include a
  NextToken element, which you can use to obtain additional results.
- `"nextToken"`: A token returned from a call to this API to indicate the next batch of
  results to return, if any.
- `"projectName"`: The name of the project in the space.
"""
function list_dev_environments(
    spaceName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecatalyst(
        "POST",
        "/v1/spaces/$(spaceName)/devEnvironments";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_dev_environments(
    spaceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecatalyst(
        "POST",
        "/v1/spaces/$(spaceName)/devEnvironments",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_event_logs(end_time, space_name, start_time)
    list_event_logs(end_time, space_name, start_time, params::Dict{String,<:Any})

Retrieves a list of events that occurred during a specific time in a space. You can use
these events to audit user and system activity in a space. For more information, see
Monitoring in the Amazon CodeCatalyst User Guide.  ListEventLogs guarantees events for the
last 30 days in a given space. You can also view and retrieve a list of management events
over the last 90 days for Amazon CodeCatalyst in the CloudTrail console by viewing Event
history, or by creating a trail to create and maintain a record of events that extends past
90 days. For more information, see Working with CloudTrail Event History and Working with
CloudTrail trails.

# Arguments
- `end_time`: The time after which you do not want any events retrieved, in coordinated
  universal time (UTC) timestamp format as specified in RFC 3339.
- `space_name`: The name of the space.
- `start_time`: The date and time when you want to start retrieving events, in coordinated
  universal time (UTC) timestamp format as specified in RFC 3339.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"eventName"`: The name of the event.
- `"maxResults"`: The maximum number of results to show in a single call to this API. If
  the number of results is larger than the number you specified, the response will include a
  NextToken element, which you can use to obtain additional results.
- `"nextToken"`: A token returned from a call to this API to indicate the next batch of
  results to return, if any.
"""
function list_event_logs(
    endTime, spaceName, startTime; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecatalyst(
        "POST",
        "/v1/spaces/$(spaceName)/eventLogs",
        Dict{String,Any}("endTime" => endTime, "startTime" => startTime);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_event_logs(
    endTime,
    spaceName,
    startTime,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecatalyst(
        "POST",
        "/v1/spaces/$(spaceName)/eventLogs",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("endTime" => endTime, "startTime" => startTime),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_projects(space_name)
    list_projects(space_name, params::Dict{String,<:Any})

Retrieves a list of projects.

# Arguments
- `space_name`: The name of the space.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: Information about filters to apply to narrow the results returned in the
  list.
- `"maxResults"`: The maximum number of results to show in a single call to this API. If
  the number of results is larger than the number you specified, the response will include a
  NextToken element, which you can use to obtain additional results.
- `"nextToken"`: A token returned from a call to this API to indicate the next batch of
  results to return, if any.
"""
function list_projects(spaceName; aws_config::AbstractAWSConfig=current_aws_config())
    return codecatalyst(
        "POST",
        "/v1/spaces/$(spaceName)/projects";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_projects(
    spaceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecatalyst(
        "POST",
        "/v1/spaces/$(spaceName)/projects",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_source_repositories(project_name, space_name)
    list_source_repositories(project_name, space_name, params::Dict{String,<:Any})

Retrieves a list of source repositories in a project.

# Arguments
- `project_name`: The name of the project in the space.
- `space_name`: The name of the space.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to show in a single call to this API. If
  the number of results is larger than the number you specified, the response will include a
  NextToken element, which you can use to obtain additional results.
- `"nextToken"`: A token returned from a call to this API to indicate the next batch of
  results to return, if any.
"""
function list_source_repositories(
    projectName, spaceName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecatalyst(
        "POST",
        "/v1/spaces/$(spaceName)/projects/$(projectName)/sourceRepositories";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_source_repositories(
    projectName,
    spaceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecatalyst(
        "POST",
        "/v1/spaces/$(spaceName)/projects/$(projectName)/sourceRepositories",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_source_repository_branches(project_name, source_repository_name, space_name)
    list_source_repository_branches(project_name, source_repository_name, space_name, params::Dict{String,<:Any})

Retrieves a list of branches in a specified source repository.

# Arguments
- `project_name`: The name of the project in the space.
- `source_repository_name`: The name of the source repository.
- `space_name`: The name of the space.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to show in a single call to this API. If
  the number of results is larger than the number you specified, the response will include a
  NextToken element, which you can use to obtain additional results.
- `"nextToken"`: A token returned from a call to this API to indicate the next batch of
  results to return, if any.
"""
function list_source_repository_branches(
    projectName,
    sourceRepositoryName,
    spaceName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecatalyst(
        "POST",
        "/v1/spaces/$(spaceName)/projects/$(projectName)/sourceRepositories/$(sourceRepositoryName)/branches";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_source_repository_branches(
    projectName,
    sourceRepositoryName,
    spaceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecatalyst(
        "POST",
        "/v1/spaces/$(spaceName)/projects/$(projectName)/sourceRepositories/$(sourceRepositoryName)/branches",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_spaces()
    list_spaces(params::Dict{String,<:Any})

Retrieves a list of spaces.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: A token returned from a call to this API to indicate the next batch of
  results to return, if any.
"""
function list_spaces(; aws_config::AbstractAWSConfig=current_aws_config())
    return codecatalyst(
        "POST", "/v1/spaces"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_spaces(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecatalyst(
        "POST", "/v1/spaces", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_workflow_runs(project_name, space_name)
    list_workflow_runs(project_name, space_name, params::Dict{String,<:Any})

Retrieves a list of workflow runs of a specified workflow.

# Arguments
- `project_name`: The name of the project in the space.
- `space_name`: The name of the space.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to show in a single call to this API. If
  the number of results is larger than the number you specified, the response will include a
  NextToken element, which you can use to obtain additional results.
- `"nextToken"`: A token returned from a call to this API to indicate the next batch of
  results to return, if any.
- `"sortBy"`: Information used to sort the items in the returned list.
- `"workflowId"`: The ID of the workflow. To retrieve a list of workflow IDs, use
  ListWorkflows.
"""
function list_workflow_runs(
    projectName, spaceName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecatalyst(
        "POST",
        "/v1/spaces/$(spaceName)/projects/$(projectName)/workflowRuns";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_workflow_runs(
    projectName,
    spaceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecatalyst(
        "POST",
        "/v1/spaces/$(spaceName)/projects/$(projectName)/workflowRuns",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_workflows(project_name, space_name)
    list_workflows(project_name, space_name, params::Dict{String,<:Any})

Retrieves a list of workflows in a specified project.

# Arguments
- `project_name`: The name of the project in the space.
- `space_name`: The name of the space.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to show in a single call to this API. If
  the number of results is larger than the number you specified, the response will include a
  NextToken element, which you can use to obtain additional results.
- `"nextToken"`: A token returned from a call to this API to indicate the next batch of
  results to return, if any.
- `"sortBy"`: Information used to sort the items in the returned list.
"""
function list_workflows(
    projectName, spaceName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecatalyst(
        "POST",
        "/v1/spaces/$(spaceName)/projects/$(projectName)/workflows";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_workflows(
    projectName,
    spaceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecatalyst(
        "POST",
        "/v1/spaces/$(spaceName)/projects/$(projectName)/workflows",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_dev_environment(id, project_name, space_name)
    start_dev_environment(id, project_name, space_name, params::Dict{String,<:Any})

Starts a specified Dev Environment and puts it into an active state.

# Arguments
- `id`: The system-generated unique ID of the Dev Environment.
- `project_name`: The name of the project in the space.
- `space_name`: The name of the space.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ides"`: Information about the integrated development environment (IDE) configured for a
  Dev Environment.
- `"inactivityTimeoutMinutes"`: The amount of time the Dev Environment will run without any
  activity detected before stopping, in minutes. Only whole integers are allowed. Dev
  Environments consume compute minutes when running.
- `"instanceType"`: The Amazon EC2 instace type to use for the Dev Environment.
"""
function start_dev_environment(
    id, projectName, spaceName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecatalyst(
        "PUT",
        "/v1/spaces/$(spaceName)/projects/$(projectName)/devEnvironments/$(id)/start";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_dev_environment(
    id,
    projectName,
    spaceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecatalyst(
        "PUT",
        "/v1/spaces/$(spaceName)/projects/$(projectName)/devEnvironments/$(id)/start",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_dev_environment_session(id, project_name, session_configuration, space_name)
    start_dev_environment_session(id, project_name, session_configuration, space_name, params::Dict{String,<:Any})

Starts a session for a specified Dev Environment.

# Arguments
- `id`: The system-generated unique ID of the Dev Environment.
- `project_name`: The name of the project in the space.
- `session_configuration`:
- `space_name`: The name of the space.

"""
function start_dev_environment_session(
    id,
    projectName,
    sessionConfiguration,
    spaceName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecatalyst(
        "PUT",
        "/v1/spaces/$(spaceName)/projects/$(projectName)/devEnvironments/$(id)/session",
        Dict{String,Any}("sessionConfiguration" => sessionConfiguration);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_dev_environment_session(
    id,
    projectName,
    sessionConfiguration,
    spaceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecatalyst(
        "PUT",
        "/v1/spaces/$(spaceName)/projects/$(projectName)/devEnvironments/$(id)/session",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("sessionConfiguration" => sessionConfiguration),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_workflow_run(project_name, space_name, workflow_id)
    start_workflow_run(project_name, space_name, workflow_id, params::Dict{String,<:Any})

Begins a run of a specified workflow.

# Arguments
- `project_name`: The name of the project in the space.
- `space_name`: The name of the space.
- `workflow_id`: The system-generated unique ID of the workflow. To retrieve a list of
  workflow IDs, use ListWorkflows.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A user-specified idempotency token. Idempotency ensures that an API
  request completes only once. With an idempotent request, if the original request completes
  successfully, the subsequent retries return the result from the original successful request
  and have no additional effect.
"""
function start_workflow_run(
    projectName, spaceName, workflowId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecatalyst(
        "PUT",
        "/v1/spaces/$(spaceName)/projects/$(projectName)/workflowRuns",
        Dict{String,Any}("workflowId" => workflowId, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_workflow_run(
    projectName,
    spaceName,
    workflowId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecatalyst(
        "PUT",
        "/v1/spaces/$(spaceName)/projects/$(projectName)/workflowRuns",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "workflowId" => workflowId, "clientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_dev_environment(id, project_name, space_name)
    stop_dev_environment(id, project_name, space_name, params::Dict{String,<:Any})

Pauses a specified Dev Environment and places it in a non-running state. Stopped Dev
Environments do not consume compute minutes.

# Arguments
- `id`: The system-generated unique ID of the Dev Environment.
- `project_name`: The name of the project in the space.
- `space_name`: The name of the space.

"""
function stop_dev_environment(
    id, projectName, spaceName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecatalyst(
        "PUT",
        "/v1/spaces/$(spaceName)/projects/$(projectName)/devEnvironments/$(id)/stop";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_dev_environment(
    id,
    projectName,
    spaceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecatalyst(
        "PUT",
        "/v1/spaces/$(spaceName)/projects/$(projectName)/devEnvironments/$(id)/stop",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_dev_environment_session(id, project_name, session_id, space_name)
    stop_dev_environment_session(id, project_name, session_id, space_name, params::Dict{String,<:Any})

Stops a session for a specified Dev Environment.

# Arguments
- `id`: The system-generated unique ID of the Dev Environment. To obtain this ID, use
  ListDevEnvironments.
- `project_name`: The name of the project in the space.
- `session_id`: The system-generated unique ID of the Dev Environment session. This ID is
  returned by StartDevEnvironmentSession.
- `space_name`: The name of the space.

"""
function stop_dev_environment_session(
    id,
    projectName,
    sessionId,
    spaceName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecatalyst(
        "DELETE",
        "/v1/spaces/$(spaceName)/projects/$(projectName)/devEnvironments/$(id)/session/$(sessionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_dev_environment_session(
    id,
    projectName,
    sessionId,
    spaceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecatalyst(
        "DELETE",
        "/v1/spaces/$(spaceName)/projects/$(projectName)/devEnvironments/$(id)/session/$(sessionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_dev_environment(id, project_name, space_name)
    update_dev_environment(id, project_name, space_name, params::Dict{String,<:Any})

Changes one or more values for a Dev Environment. Updating certain values of the Dev
Environment will cause a restart.

# Arguments
- `id`: The system-generated unique ID of the Dev Environment.
- `project_name`: The name of the project in the space.
- `space_name`: The name of the space.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"alias"`: The user-specified alias for the Dev Environment. Changing this value will not
  cause a restart.
- `"clientToken"`: A user-specified idempotency token. Idempotency ensures that an API
  request completes only once. With an idempotent request, if the original request completes
  successfully, the subsequent retries return the result from the original successful request
  and have no additional effect.
- `"ides"`: Information about the integrated development environment (IDE) configured for a
  Dev Environment.
- `"inactivityTimeoutMinutes"`: The amount of time the Dev Environment will run without any
  activity detected before stopping, in minutes. Only whole integers are allowed. Dev
  Environments consume compute minutes when running.  Changing this value will cause a
  restart of the Dev Environment if it is running.
- `"instanceType"`: The Amazon EC2 instace type to use for the Dev Environment.   Changing
  this value will cause a restart of the Dev Environment if it is running.
"""
function update_dev_environment(
    id, projectName, spaceName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecatalyst(
        "PATCH",
        "/v1/spaces/$(spaceName)/projects/$(projectName)/devEnvironments/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_dev_environment(
    id,
    projectName,
    spaceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecatalyst(
        "PATCH",
        "/v1/spaces/$(spaceName)/projects/$(projectName)/devEnvironments/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_project(name, space_name)
    update_project(name, space_name, params::Dict{String,<:Any})

Changes one or more values for a project.

# Arguments
- `name`: The name of the project.
- `space_name`: The name of the space.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description of the project.
"""
function update_project(name, spaceName; aws_config::AbstractAWSConfig=current_aws_config())
    return codecatalyst(
        "PATCH",
        "/v1/spaces/$(spaceName)/projects/$(name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_project(
    name,
    spaceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecatalyst(
        "PATCH",
        "/v1/spaces/$(spaceName)/projects/$(name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_space(name)
    update_space(name, params::Dict{String,<:Any})

Changes one or more values for a space.

# Arguments
- `name`: The name of the space.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description of the space.
"""
function update_space(name; aws_config::AbstractAWSConfig=current_aws_config())
    return codecatalyst(
        "PATCH",
        "/v1/spaces/$(name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_space(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecatalyst(
        "PATCH",
        "/v1/spaces/$(name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    verify_session()
    verify_session(params::Dict{String,<:Any})

Verifies whether the calling user has a valid Amazon CodeCatalyst login and session. If
successful, this returns the ID of the user in Amazon CodeCatalyst.

"""
function verify_session(; aws_config::AbstractAWSConfig=current_aws_config())
    return codecatalyst(
        "GET", "/session"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function verify_session(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecatalyst(
        "GET", "/session", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: route53_recovery_control_config
using AWS.Compat
using AWS.UUIDs

"""
    create_cluster(cluster_name)
    create_cluster(cluster_name, params::Dict{String,<:Any})

Create a new cluster. A cluster is a set of redundant Regional endpoints against which you
can run API calls to update or get the state of one or more routing controls. Each cluster
has a name, status, Amazon Resource Name (ARN), and an array of the five cluster endpoints
(one for each supported Amazon Web Services Region) that you can use with API calls to the
cluster data plane.

# Arguments
- `cluster_name`: The name of the cluster.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: A unique, case-sensitive string of up to 64 ASCII characters. To make an
  idempotent API request with an action, specify a client token in the request.
- `"Tags"`: The tags associated with the cluster.
"""
function create_cluster(ClusterName; aws_config::AbstractAWSConfig=current_aws_config())
    return route53_recovery_control_config(
        "POST",
        "/cluster",
        Dict{String,Any}("ClusterName" => ClusterName, "ClientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_cluster(
    ClusterName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53_recovery_control_config(
        "POST",
        "/cluster",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClusterName" => ClusterName, "ClientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_control_panel(cluster_arn, control_panel_name)
    create_control_panel(cluster_arn, control_panel_name, params::Dict{String,<:Any})

Creates a new control panel. A control panel represents a group of routing controls that
can be changed together in a single transaction. You can use a control panel to centrally
view the operational status of applications across your organization, and trigger multi-app
failovers in a single transaction, for example, to fail over an Availability Zone or Amazon
Web Services Region.

# Arguments
- `cluster_arn`: The Amazon Resource Name (ARN) of the cluster for the control panel.
- `control_panel_name`: The name of the control panel.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: A unique, case-sensitive string of up to 64 ASCII characters. To make an
  idempotent API request with an action, specify a client token in the request.
- `"Tags"`: The tags associated with the control panel.
"""
function create_control_panel(
    ClusterArn, ControlPanelName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53_recovery_control_config(
        "POST",
        "/controlpanel",
        Dict{String,Any}(
            "ClusterArn" => ClusterArn,
            "ControlPanelName" => ControlPanelName,
            "ClientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_control_panel(
    ClusterArn,
    ControlPanelName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53_recovery_control_config(
        "POST",
        "/controlpanel",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClusterArn" => ClusterArn,
                    "ControlPanelName" => ControlPanelName,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_routing_control(cluster_arn, routing_control_name)
    create_routing_control(cluster_arn, routing_control_name, params::Dict{String,<:Any})

Creates a new routing control. A routing control has one of two states: ON and OFF. You can
map the routing control state to the state of an Amazon Route 53 health check, which can be
used to control traffic routing. To get or update the routing control state, see the
Recovery Cluster (data plane) API actions for Amazon Route 53 Application Recovery
Controller.

# Arguments
- `cluster_arn`: The Amazon Resource Name (ARN) of the cluster that includes the routing
  control.
- `routing_control_name`: The name of the routing control.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: A unique, case-sensitive string of up to 64 ASCII characters. To make an
  idempotent API request with an action, specify a client token in the request.
- `"ControlPanelArn"`: The Amazon Resource Name (ARN) of the control panel that includes
  the routing control.
"""
function create_routing_control(
    ClusterArn, RoutingControlName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53_recovery_control_config(
        "POST",
        "/routingcontrol",
        Dict{String,Any}(
            "ClusterArn" => ClusterArn,
            "RoutingControlName" => RoutingControlName,
            "ClientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_routing_control(
    ClusterArn,
    RoutingControlName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53_recovery_control_config(
        "POST",
        "/routingcontrol",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClusterArn" => ClusterArn,
                    "RoutingControlName" => RoutingControlName,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_safety_rule()
    create_safety_rule(params::Dict{String,<:Any})

Creates a safety rule in a control panel. Safety rules let you add safeguards around
changing routing control states, and for enabling and disabling routing controls, to help
prevent unexpected outcomes. There are two types of safety rules: assertion rules and
gating rules. Assertion rule: An assertion rule enforces that, when you change a routing
control state, that a certain criteria is met. For example, the criteria might be that at
least one routing control state is On after the transaction so that traffic continues to
flow to at least one cell for the application. This ensures that you avoid a fail-open
scenario. Gating rule: A gating rule lets you configure a gating routing control as an
overall \"on/off\" switch for a group of routing controls. Or, you can configure more
complex gating scenarios, for example by configuring multiple gating routing controls. For
more information, see Safety rules in the Amazon Route 53 Application Recovery Controller
Developer Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AssertionRule"`: The assertion rule requested.
- `"ClientToken"`: A unique, case-sensitive string of up to 64 ASCII characters. To make an
  idempotent API request with an action, specify a client token in the request.
- `"GatingRule"`: The gating rule requested.
- `"Tags"`: The tags associated with the safety rule.
"""
function create_safety_rule(; aws_config::AbstractAWSConfig=current_aws_config())
    return route53_recovery_control_config(
        "POST",
        "/safetyrule",
        Dict{String,Any}("ClientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_safety_rule(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53_recovery_control_config(
        "POST",
        "/safetyrule",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ClientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_cluster(cluster_arn)
    delete_cluster(cluster_arn, params::Dict{String,<:Any})

Delete a cluster.

# Arguments
- `cluster_arn`: The Amazon Resource Name (ARN) of the cluster that you're deleting.

"""
function delete_cluster(ClusterArn; aws_config::AbstractAWSConfig=current_aws_config())
    return route53_recovery_control_config(
        "DELETE",
        "/cluster/$(ClusterArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_cluster(
    ClusterArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53_recovery_control_config(
        "DELETE",
        "/cluster/$(ClusterArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_control_panel(control_panel_arn)
    delete_control_panel(control_panel_arn, params::Dict{String,<:Any})

Deletes a control panel.

# Arguments
- `control_panel_arn`: The Amazon Resource Name (ARN) of the control panel.

"""
function delete_control_panel(
    ControlPanelArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53_recovery_control_config(
        "DELETE",
        "/controlpanel/$(ControlPanelArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_control_panel(
    ControlPanelArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53_recovery_control_config(
        "DELETE",
        "/controlpanel/$(ControlPanelArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_routing_control(routing_control_arn)
    delete_routing_control(routing_control_arn, params::Dict{String,<:Any})

Deletes a routing control.

# Arguments
- `routing_control_arn`: The Amazon Resource Name (ARN) of the routing control that you're
  deleting.

"""
function delete_routing_control(
    RoutingControlArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53_recovery_control_config(
        "DELETE",
        "/routingcontrol/$(RoutingControlArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_routing_control(
    RoutingControlArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53_recovery_control_config(
        "DELETE",
        "/routingcontrol/$(RoutingControlArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_safety_rule(safety_rule_arn)
    delete_safety_rule(safety_rule_arn, params::Dict{String,<:Any})

Deletes a safety rule./&gt;

# Arguments
- `safety_rule_arn`: The ARN of the safety rule.

"""
function delete_safety_rule(
    SafetyRuleArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53_recovery_control_config(
        "DELETE",
        "/safetyrule/$(SafetyRuleArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_safety_rule(
    SafetyRuleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53_recovery_control_config(
        "DELETE",
        "/safetyrule/$(SafetyRuleArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_cluster(cluster_arn)
    describe_cluster(cluster_arn, params::Dict{String,<:Any})

Display the details about a cluster. The response includes the cluster name, endpoints,
status, and Amazon Resource Name (ARN).

# Arguments
- `cluster_arn`: The Amazon Resource Name (ARN) of the cluster.

"""
function describe_cluster(ClusterArn; aws_config::AbstractAWSConfig=current_aws_config())
    return route53_recovery_control_config(
        "GET",
        "/cluster/$(ClusterArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_cluster(
    ClusterArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53_recovery_control_config(
        "GET",
        "/cluster/$(ClusterArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_control_panel(control_panel_arn)
    describe_control_panel(control_panel_arn, params::Dict{String,<:Any})

Displays details about a control panel.

# Arguments
- `control_panel_arn`: The Amazon Resource Name (ARN) of the control panel.

"""
function describe_control_panel(
    ControlPanelArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53_recovery_control_config(
        "GET",
        "/controlpanel/$(ControlPanelArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_control_panel(
    ControlPanelArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53_recovery_control_config(
        "GET",
        "/controlpanel/$(ControlPanelArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_routing_control(routing_control_arn)
    describe_routing_control(routing_control_arn, params::Dict{String,<:Any})

Displays details about a routing control. A routing control has one of two states: ON and
OFF. You can map the routing control state to the state of an Amazon Route 53 health check,
which can be used to control routing. To get or update the routing control state, see the
Recovery Cluster (data plane) API actions for Amazon Route 53 Application Recovery
Controller.

# Arguments
- `routing_control_arn`: The Amazon Resource Name (ARN) of the routing control.

"""
function describe_routing_control(
    RoutingControlArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53_recovery_control_config(
        "GET",
        "/routingcontrol/$(RoutingControlArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_routing_control(
    RoutingControlArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53_recovery_control_config(
        "GET",
        "/routingcontrol/$(RoutingControlArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_safety_rule(safety_rule_arn)
    describe_safety_rule(safety_rule_arn, params::Dict{String,<:Any})

Returns information about a safety rule.

# Arguments
- `safety_rule_arn`: The ARN of the safety rule.

"""
function describe_safety_rule(
    SafetyRuleArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53_recovery_control_config(
        "GET",
        "/safetyrule/$(SafetyRuleArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_safety_rule(
    SafetyRuleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53_recovery_control_config(
        "GET",
        "/safetyrule/$(SafetyRuleArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_resource_policy(resource_arn)
    get_resource_policy(resource_arn, params::Dict{String,<:Any})

Get information about the resource policy for a cluster.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.

"""
function get_resource_policy(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53_recovery_control_config(
        "GET",
        "/resourcePolicy/$(ResourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_resource_policy(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53_recovery_control_config(
        "GET",
        "/resourcePolicy/$(ResourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_associated_route53_health_checks(routing_control_arn)
    list_associated_route53_health_checks(routing_control_arn, params::Dict{String,<:Any})

Returns an array of all Amazon Route 53 health checks associated with a specific routing
control.

# Arguments
- `routing_control_arn`: The Amazon Resource Name (ARN) of the routing control.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The number of objects that you want to return with this call.
- `"NextToken"`: The token that identifies which batch of results you want to see.
"""
function list_associated_route53_health_checks(
    RoutingControlArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53_recovery_control_config(
        "GET",
        "/routingcontrol/$(RoutingControlArn)/associatedRoute53HealthChecks";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_associated_route53_health_checks(
    RoutingControlArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53_recovery_control_config(
        "GET",
        "/routingcontrol/$(RoutingControlArn)/associatedRoute53HealthChecks",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_clusters()
    list_clusters(params::Dict{String,<:Any})

Returns an array of all the clusters in an account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The number of objects that you want to return with this call.
- `"NextToken"`: The token that identifies which batch of results you want to see.
"""
function list_clusters(; aws_config::AbstractAWSConfig=current_aws_config())
    return route53_recovery_control_config(
        "GET", "/cluster"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_clusters(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53_recovery_control_config(
        "GET", "/cluster", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_control_panels()
    list_control_panels(params::Dict{String,<:Any})

Returns an array of control panels in an account or in a cluster.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClusterArn"`: The Amazon Resource Name (ARN) of a cluster.
- `"MaxResults"`: The number of objects that you want to return with this call.
- `"NextToken"`: The token that identifies which batch of results you want to see.
"""
function list_control_panels(; aws_config::AbstractAWSConfig=current_aws_config())
    return route53_recovery_control_config(
        "GET", "/controlpanels"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_control_panels(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53_recovery_control_config(
        "GET",
        "/controlpanels",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_routing_controls(control_panel_arn)
    list_routing_controls(control_panel_arn, params::Dict{String,<:Any})

Returns an array of routing controls for a control panel. A routing control is an Amazon
Route 53 Application Recovery Controller construct that has one of two states: ON and OFF.
You can map the routing control state to the state of an Amazon Route 53 health check,
which can be used to control routing.

# Arguments
- `control_panel_arn`: The Amazon Resource Name (ARN) of the control panel.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The number of objects that you want to return with this call.
- `"NextToken"`: The token that identifies which batch of results you want to see.
"""
function list_routing_controls(
    ControlPanelArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53_recovery_control_config(
        "GET",
        "/controlpanel/$(ControlPanelArn)/routingcontrols";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_routing_controls(
    ControlPanelArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53_recovery_control_config(
        "GET",
        "/controlpanel/$(ControlPanelArn)/routingcontrols",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_safety_rules(control_panel_arn)
    list_safety_rules(control_panel_arn, params::Dict{String,<:Any})

List the safety rules (the assertion rules and gating rules) that you've defined for the
routing controls in a control panel.

# Arguments
- `control_panel_arn`: The Amazon Resource Name (ARN) of the control panel.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The number of objects that you want to return with this call.
- `"NextToken"`: The token that identifies which batch of results you want to see.
"""
function list_safety_rules(
    ControlPanelArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53_recovery_control_config(
        "GET",
        "/controlpanel/$(ControlPanelArn)/safetyrules";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_safety_rules(
    ControlPanelArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53_recovery_control_config(
        "GET",
        "/controlpanel/$(ControlPanelArn)/safetyrules",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists the tags for a resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) for the resource that's tagged.

"""
function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53_recovery_control_config(
        "GET",
        "/tags/$(ResourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53_recovery_control_config(
        "GET",
        "/tags/$(ResourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds a tag to a resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) for the resource that's tagged.
- `tags`: The tags associated with the resource.

"""
function tag_resource(ResourceArn, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return route53_recovery_control_config(
        "POST",
        "/tags/$(ResourceArn)",
        Dict{String,Any}("Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceArn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53_recovery_control_config(
        "POST",
        "/tags/$(ResourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Tags" => Tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes a tag from a resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) for the resource that's tagged.
- `tag_keys`: Keys for the tags to be removed.

"""
function untag_resource(
    ResourceArn, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53_recovery_control_config(
        "DELETE",
        "/tags/$(ResourceArn)",
        Dict{String,Any}("TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceArn,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53_recovery_control_config(
        "DELETE",
        "/tags/$(ResourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("TagKeys" => TagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_control_panel(control_panel_arn, control_panel_name)
    update_control_panel(control_panel_arn, control_panel_name, params::Dict{String,<:Any})

Updates a control panel. The only update you can make to a control panel is to change the
name of the control panel.

# Arguments
- `control_panel_arn`: The Amazon Resource Name (ARN) of the control panel.
- `control_panel_name`: The name of the control panel.

"""
function update_control_panel(
    ControlPanelArn, ControlPanelName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53_recovery_control_config(
        "PUT",
        "/controlpanel",
        Dict{String,Any}(
            "ControlPanelArn" => ControlPanelArn, "ControlPanelName" => ControlPanelName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_control_panel(
    ControlPanelArn,
    ControlPanelName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53_recovery_control_config(
        "PUT",
        "/controlpanel",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ControlPanelArn" => ControlPanelArn,
                    "ControlPanelName" => ControlPanelName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_routing_control(routing_control_arn, routing_control_name)
    update_routing_control(routing_control_arn, routing_control_name, params::Dict{String,<:Any})

Updates a routing control. You can only update the name of the routing control. To get or
update the routing control state, see the Recovery Cluster (data plane) API actions for
Amazon Route 53 Application Recovery Controller.

# Arguments
- `routing_control_arn`: The Amazon Resource Name (ARN) of the routing control.
- `routing_control_name`: The name of the routing control.

"""
function update_routing_control(
    RoutingControlArn,
    RoutingControlName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53_recovery_control_config(
        "PUT",
        "/routingcontrol",
        Dict{String,Any}(
            "RoutingControlArn" => RoutingControlArn,
            "RoutingControlName" => RoutingControlName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_routing_control(
    RoutingControlArn,
    RoutingControlName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53_recovery_control_config(
        "PUT",
        "/routingcontrol",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "RoutingControlArn" => RoutingControlArn,
                    "RoutingControlName" => RoutingControlName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_safety_rule()
    update_safety_rule(params::Dict{String,<:Any})

Update a safety rule (an assertion rule or gating rule). You can only update the name and
the waiting period for a safety rule. To make other updates, delete the safety rule and
create a new one.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AssertionRuleUpdate"`: The assertion rule to update.
- `"GatingRuleUpdate"`: The gating rule to update.
"""
function update_safety_rule(; aws_config::AbstractAWSConfig=current_aws_config())
    return route53_recovery_control_config(
        "PUT", "/safetyrule"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function update_safety_rule(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53_recovery_control_config(
        "PUT", "/safetyrule", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: simspaceweaver
using AWS.Compat
using AWS.UUIDs

"""
    create_snapshot(destination, simulation)
    create_snapshot(destination, simulation, params::Dict{String,<:Any})

Creates a snapshot of the specified simulation. A snapshot is a file that contains
simulation state data at a specific time. The state data saved in a snapshot includes
entity data from the State Fabric, the simulation configuration specified in the schema,
and the clock tick number. You can use the snapshot to initialize a new simulation. For
more information about snapshots, see Snapshots in the SimSpace Weaver User Guide.  You
specify a Destination when you create a snapshot. The Destination is the name of an Amazon
S3 bucket and an optional ObjectKeyPrefix. The ObjectKeyPrefix is usually the name of a
folder in the bucket. SimSpace Weaver creates a snapshot folder inside the Destination and
places the snapshot file there. The snapshot file is an Amazon S3 object. It has an object
key with the form:  object-key-prefix/snapshot/simulation-name-YYMMdd-HHmm-ss.zip, where:
   YY  is the 2-digit year     MM  is the 2-digit month     dd  is the 2-digit day of the
month     HH  is the 2-digit hour (24-hour clock)     mm  is the 2-digit minutes     ss  is
the 2-digit seconds

# Arguments
- `destination`: The Amazon S3 bucket and optional folder (object key prefix) where
  SimSpace Weaver creates the snapshot file. The Amazon S3 bucket must be in the same Amazon
  Web Services Region as the simulation.
- `simulation`: The name of the simulation.

"""
function create_snapshot(
    Destination, Simulation; aws_config::AbstractAWSConfig=current_aws_config()
)
    return simspaceweaver(
        "POST",
        "/createsnapshot",
        Dict{String,Any}("Destination" => Destination, "Simulation" => Simulation);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_snapshot(
    Destination,
    Simulation,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return simspaceweaver(
        "POST",
        "/createsnapshot",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Destination" => Destination, "Simulation" => Simulation),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_app(app, domain, simulation)
    delete_app(app, domain, simulation, params::Dict{String,<:Any})

Deletes the instance of the given custom app.

# Arguments
- `app`: The name of the app.
- `domain`: The name of the domain of the app.
- `simulation`: The name of the simulation of the app.

"""
function delete_app(
    app, domain, simulation; aws_config::AbstractAWSConfig=current_aws_config()
)
    return simspaceweaver(
        "DELETE",
        "/deleteapp",
        Dict{String,Any}("app" => app, "domain" => domain, "simulation" => simulation);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_app(
    app,
    domain,
    simulation,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return simspaceweaver(
        "DELETE",
        "/deleteapp",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "app" => app, "domain" => domain, "simulation" => simulation
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_simulation(simulation)
    delete_simulation(simulation, params::Dict{String,<:Any})

Deletes all SimSpace Weaver resources assigned to the given simulation.  Your simulation
uses resources in other Amazon Web Services. This API operation doesn't delete resources in
other Amazon Web Services.

# Arguments
- `simulation`: The name of the simulation.

"""
function delete_simulation(simulation; aws_config::AbstractAWSConfig=current_aws_config())
    return simspaceweaver(
        "DELETE",
        "/deletesimulation",
        Dict{String,Any}("simulation" => simulation);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_simulation(
    simulation,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return simspaceweaver(
        "DELETE",
        "/deletesimulation",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("simulation" => simulation), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_app(app, domain, simulation)
    describe_app(app, domain, simulation, params::Dict{String,<:Any})

Returns the state of the given custom app.

# Arguments
- `app`: The name of the app.
- `domain`: The name of the domain of the app.
- `simulation`: The name of the simulation of the app.

"""
function describe_app(
    app, domain, simulation; aws_config::AbstractAWSConfig=current_aws_config()
)
    return simspaceweaver(
        "GET",
        "/describeapp",
        Dict{String,Any}("app" => app, "domain" => domain, "simulation" => simulation);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_app(
    app,
    domain,
    simulation,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return simspaceweaver(
        "GET",
        "/describeapp",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "app" => app, "domain" => domain, "simulation" => simulation
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_simulation(simulation)
    describe_simulation(simulation, params::Dict{String,<:Any})

Returns the current state of the given simulation.

# Arguments
- `simulation`: The name of the simulation.

"""
function describe_simulation(simulation; aws_config::AbstractAWSConfig=current_aws_config())
    return simspaceweaver(
        "GET",
        "/describesimulation",
        Dict{String,Any}("simulation" => simulation);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_simulation(
    simulation,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return simspaceweaver(
        "GET",
        "/describesimulation",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("simulation" => simulation), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_apps(simulation)
    list_apps(simulation, params::Dict{String,<:Any})

Lists all custom apps or service apps for the given simulation and domain.

# Arguments
- `simulation`: The name of the simulation that you want to list apps for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"domain"`: The name of the domain that you want to list apps for.
- `"maxResults"`: The maximum number of apps to list.
- `"nextToken"`: If SimSpace Weaver returns nextToken, then there are more results
  available. The value of nextToken is a unique pagination token for each page. To retrieve
  the next page, call the operation again using the returned token. Keep all other arguments
  unchanged. If no results remain, then nextToken is set to null. Each pagination token
  expires after 24 hours. If you provide a token that isn't valid, then you receive an HTTP
  400 ValidationException error.
"""
function list_apps(simulation; aws_config::AbstractAWSConfig=current_aws_config())
    return simspaceweaver(
        "GET",
        "/listapps",
        Dict{String,Any}("simulation" => simulation);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_apps(
    simulation,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return simspaceweaver(
        "GET",
        "/listapps",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("simulation" => simulation), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_simulations()
    list_simulations(params::Dict{String,<:Any})

Lists the SimSpace Weaver simulations in the Amazon Web Services account used to make the
API call.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of simulations to list.
- `"nextToken"`: If SimSpace Weaver returns nextToken, then there are more results
  available. The value of nextToken is a unique pagination token for each page. To retrieve
  the next page, call the operation again using the returned token. Keep all other arguments
  unchanged. If no results remain, then nextToken is set to null. Each pagination token
  expires after 24 hours. If you provide a token that isn't valid, then you receive an HTTP
  400 ValidationException error.
"""
function list_simulations(; aws_config::AbstractAWSConfig=current_aws_config())
    return simspaceweaver(
        "GET", "/listsimulations"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_simulations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return simspaceweaver(
        "GET",
        "/listsimulations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists all tags on a SimSpace Weaver resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource. For more information
  about ARNs, see Amazon Resource Names (ARNs) in the Amazon Web Services General Reference.

"""
function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return simspaceweaver(
        "GET",
        "/tags/$(ResourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return simspaceweaver(
        "GET",
        "/tags/$(ResourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_app(domain, name, simulation)
    start_app(domain, name, simulation, params::Dict{String,<:Any})

Starts a custom app with the configuration specified in the simulation schema.

# Arguments
- `domain`: The name of the domain of the app.
- `name`: The name of the app.
- `simulation`: The name of the simulation of the app.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: A value that you provide to ensure that repeated calls to this API
  operation using the same parameters complete only once. A ClientToken is also known as an
  idempotency token. A ClientToken expires after 24 hours.
- `"Description"`: The description of the app.
- `"LaunchOverrides"`:
"""
function start_app(
    Domain, Name, Simulation; aws_config::AbstractAWSConfig=current_aws_config()
)
    return simspaceweaver(
        "POST",
        "/startapp",
        Dict{String,Any}(
            "Domain" => Domain,
            "Name" => Name,
            "Simulation" => Simulation,
            "ClientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_app(
    Domain,
    Name,
    Simulation,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return simspaceweaver(
        "POST",
        "/startapp",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Domain" => Domain,
                    "Name" => Name,
                    "Simulation" => Simulation,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_clock(simulation)
    start_clock(simulation, params::Dict{String,<:Any})

Starts the simulation clock.

# Arguments
- `simulation`: The name of the simulation.

"""
function start_clock(Simulation; aws_config::AbstractAWSConfig=current_aws_config())
    return simspaceweaver(
        "POST",
        "/startclock",
        Dict{String,Any}("Simulation" => Simulation);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_clock(
    Simulation,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return simspaceweaver(
        "POST",
        "/startclock",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Simulation" => Simulation), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_simulation(name, role_arn)
    start_simulation(name, role_arn, params::Dict{String,<:Any})

Starts a simulation with the given name. You must choose to start your simulation from a
schema or from a snapshot. For more information about the schema, see the schema reference
in the SimSpace Weaver User Guide. For more information about snapshots, see Snapshots in
the SimSpace Weaver User Guide.

# Arguments
- `name`: The name of the simulation.
- `role_arn`: The Amazon Resource Name (ARN) of the Identity and Access Management (IAM)
  role that the simulation assumes to perform actions. For more information about ARNs, see
  Amazon Resource Names (ARNs) in the Amazon Web Services General Reference. For more
  information about IAM roles, see IAM roles in the Identity and Access Management User Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: A value that you provide to ensure that repeated calls to this API
  operation using the same parameters complete only once. A ClientToken is also known as an
  idempotency token. A ClientToken expires after 24 hours.
- `"Description"`: The description of the simulation.
- `"MaximumDuration"`: The maximum running time of the simulation, specified as a number of
  minutes (m or M), hours (h or H), or days (d or D). The simulation stops when it reaches
  this limit. The maximum value is 14D, or its equivalent in the other units. The default
  value is 14D. A value equivalent to 0 makes the simulation immediately transition to
  Stopping as soon as it reaches Started.
- `"SchemaS3Location"`: The location of the simulation schema in Amazon Simple Storage
  Service (Amazon S3). For more information about Amazon S3, see the  Amazon Simple Storage
  Service User Guide . Provide a SchemaS3Location to start your simulation from a schema. If
  you provide a SchemaS3Location then you can't provide a SnapshotS3Location.
- `"SnapshotS3Location"`: The location of the snapshot .zip file in Amazon Simple Storage
  Service (Amazon S3). For more information about Amazon S3, see the  Amazon Simple Storage
  Service User Guide . Provide a SnapshotS3Location to start your simulation from a snapshot.
  The Amazon S3 bucket must be in the same Amazon Web Services Region as the simulation. If
  you provide a SnapshotS3Location then you can't provide a SchemaS3Location.
- `"Tags"`: A list of tags for the simulation. For more information about tags, see Tagging
  Amazon Web Services resources in the Amazon Web Services General Reference.
"""
function start_simulation(Name, RoleArn; aws_config::AbstractAWSConfig=current_aws_config())
    return simspaceweaver(
        "POST",
        "/startsimulation",
        Dict{String,Any}(
            "Name" => Name, "RoleArn" => RoleArn, "ClientToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_simulation(
    Name,
    RoleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return simspaceweaver(
        "POST",
        "/startsimulation",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Name" => Name, "RoleArn" => RoleArn, "ClientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_app(app, domain, simulation)
    stop_app(app, domain, simulation, params::Dict{String,<:Any})

Stops the given custom app and shuts down all of its allocated compute resources.

# Arguments
- `app`: The name of the app.
- `domain`: The name of the domain of the app.
- `simulation`: The name of the simulation of the app.

"""
function stop_app(
    App, Domain, Simulation; aws_config::AbstractAWSConfig=current_aws_config()
)
    return simspaceweaver(
        "POST",
        "/stopapp",
        Dict{String,Any}("App" => App, "Domain" => Domain, "Simulation" => Simulation);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_app(
    App,
    Domain,
    Simulation,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return simspaceweaver(
        "POST",
        "/stopapp",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "App" => App, "Domain" => Domain, "Simulation" => Simulation
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_clock(simulation)
    stop_clock(simulation, params::Dict{String,<:Any})

Stops the simulation clock.

# Arguments
- `simulation`: The name of the simulation.

"""
function stop_clock(Simulation; aws_config::AbstractAWSConfig=current_aws_config())
    return simspaceweaver(
        "POST",
        "/stopclock",
        Dict{String,Any}("Simulation" => Simulation);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_clock(
    Simulation,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return simspaceweaver(
        "POST",
        "/stopclock",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Simulation" => Simulation), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_simulation(simulation)
    stop_simulation(simulation, params::Dict{String,<:Any})

Stops the given simulation.  You can't restart a simulation after you stop it. If you want
to restart a simulation, then you must stop it, delete it, and start a new instance of it.

# Arguments
- `simulation`: The name of the simulation.

"""
function stop_simulation(Simulation; aws_config::AbstractAWSConfig=current_aws_config())
    return simspaceweaver(
        "POST",
        "/stopsimulation",
        Dict{String,Any}("Simulation" => Simulation);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_simulation(
    Simulation,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return simspaceweaver(
        "POST",
        "/stopsimulation",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Simulation" => Simulation), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds tags to a SimSpace Weaver resource. For more information about tags, see Tagging
Amazon Web Services resources in the Amazon Web Services General Reference.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource that you want to add tags
  to. For more information about ARNs, see Amazon Resource Names (ARNs) in the Amazon Web
  Services General Reference.
- `tags`: A list of tags to apply to the resource.

"""
function tag_resource(ResourceArn, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return simspaceweaver(
        "POST",
        "/tags/$(ResourceArn)",
        Dict{String,Any}("Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceArn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return simspaceweaver(
        "POST",
        "/tags/$(ResourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Tags" => Tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes tags from a SimSpace Weaver resource. For more information about tags, see Tagging
Amazon Web Services resources in the Amazon Web Services General Reference.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource that you want to remove
  tags from. For more information about ARNs, see Amazon Resource Names (ARNs) in the Amazon
  Web Services General Reference.
- `tag_keys`: A list of tag keys to remove from the resource.

"""
function untag_resource(
    ResourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return simspaceweaver(
        "DELETE",
        "/tags/$(ResourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return simspaceweaver(
        "DELETE",
        "/tags/$(ResourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: identitystore
using AWS.Compat
using AWS.UUIDs

"""
    create_group(identity_store_id)
    create_group(identity_store_id, params::Dict{String,<:Any})

Creates a group within the specified identity store.

# Arguments
- `identity_store_id`: The globally unique identifier for the identity store.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A string containing the description of the group.
- `"DisplayName"`: A string containing the name of the group. This value is commonly
  displayed when the group is referenced. Administrator and AWSAdministrators are reserved
  names and can't be used for users or groups.
"""
function create_group(IdentityStoreId; aws_config::AbstractAWSConfig=current_aws_config())
    return identitystore(
        "CreateGroup",
        Dict{String,Any}("IdentityStoreId" => IdentityStoreId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_group(
    IdentityStoreId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return identitystore(
        "CreateGroup",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("IdentityStoreId" => IdentityStoreId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_group_membership(group_id, identity_store_id, member_id)
    create_group_membership(group_id, identity_store_id, member_id, params::Dict{String,<:Any})

Creates a relationship between a member and a group. The following identifiers must be
specified: GroupId, IdentityStoreId, and MemberId.

# Arguments
- `group_id`: The identifier for a group in the identity store.
- `identity_store_id`: The globally unique identifier for the identity store.
- `member_id`: An object that contains the identifier of a group member. Setting the UserID
  field to the specific identifier for a user indicates that the user is a member of the
  group.

"""
function create_group_membership(
    GroupId, IdentityStoreId, MemberId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return identitystore(
        "CreateGroupMembership",
        Dict{String,Any}(
            "GroupId" => GroupId,
            "IdentityStoreId" => IdentityStoreId,
            "MemberId" => MemberId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_group_membership(
    GroupId,
    IdentityStoreId,
    MemberId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return identitystore(
        "CreateGroupMembership",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "GroupId" => GroupId,
                    "IdentityStoreId" => IdentityStoreId,
                    "MemberId" => MemberId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_user(identity_store_id)
    create_user(identity_store_id, params::Dict{String,<:Any})

Creates a user within the specified identity store.

# Arguments
- `identity_store_id`: The globally unique identifier for the identity store.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Addresses"`: A list of Address objects containing addresses associated with the user.
- `"DisplayName"`: A string containing the name of the user. This value is typically
  formatted for display when the user is referenced. For example, \"John Doe.\"
- `"Emails"`: A list of Email objects containing email addresses associated with the user.
- `"Locale"`: A string containing the geographical region or location of the user.
- `"Name"`: An object containing the name of the user.
- `"NickName"`: A string containing an alternate name for the user.
- `"PhoneNumbers"`: A list of PhoneNumber objects containing phone numbers associated with
  the user.
- `"PreferredLanguage"`: A string containing the preferred language of the user. For
  example, \"American English\" or \"en-us.\"
- `"ProfileUrl"`: A string containing a URL that might be associated with the user.
- `"Timezone"`: A string containing the time zone of the user.
- `"Title"`: A string containing the title of the user. Possible values are left
  unspecified. The value can vary based on your specific use case.
- `"UserName"`: A unique string used to identify the user. The length limit is 128
  characters. This value can consist of letters, accented characters, symbols, numbers, and
  punctuation. This value is specified at the time the user is created and stored as an
  attribute of the user object in the identity store. Administrator and AWSAdministrators are
  reserved names and can't be used for users or groups.
- `"UserType"`: A string indicating the type of user. Possible values are left unspecified.
  The value can vary based on your specific use case.
"""
function create_user(IdentityStoreId; aws_config::AbstractAWSConfig=current_aws_config())
    return identitystore(
        "CreateUser",
        Dict{String,Any}("IdentityStoreId" => IdentityStoreId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_user(
    IdentityStoreId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return identitystore(
        "CreateUser",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("IdentityStoreId" => IdentityStoreId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_group(group_id, identity_store_id)
    delete_group(group_id, identity_store_id, params::Dict{String,<:Any})

Delete a group within an identity store given GroupId.

# Arguments
- `group_id`: The identifier for a group in the identity store.
- `identity_store_id`: The globally unique identifier for the identity store.

"""
function delete_group(
    GroupId, IdentityStoreId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return identitystore(
        "DeleteGroup",
        Dict{String,Any}("GroupId" => GroupId, "IdentityStoreId" => IdentityStoreId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_group(
    GroupId,
    IdentityStoreId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return identitystore(
        "DeleteGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "GroupId" => GroupId, "IdentityStoreId" => IdentityStoreId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_group_membership(identity_store_id, membership_id)
    delete_group_membership(identity_store_id, membership_id, params::Dict{String,<:Any})

Delete a membership within a group given MembershipId.

# Arguments
- `identity_store_id`: The globally unique identifier for the identity store.
- `membership_id`: The identifier for a GroupMembership in an identity store.

"""
function delete_group_membership(
    IdentityStoreId, MembershipId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return identitystore(
        "DeleteGroupMembership",
        Dict{String,Any}(
            "IdentityStoreId" => IdentityStoreId, "MembershipId" => MembershipId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_group_membership(
    IdentityStoreId,
    MembershipId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return identitystore(
        "DeleteGroupMembership",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "IdentityStoreId" => IdentityStoreId, "MembershipId" => MembershipId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_user(identity_store_id, user_id)
    delete_user(identity_store_id, user_id, params::Dict{String,<:Any})

Deletes a user within an identity store given UserId.

# Arguments
- `identity_store_id`: The globally unique identifier for the identity store.
- `user_id`: The identifier for a user in the identity store.

"""
function delete_user(
    IdentityStoreId, UserId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return identitystore(
        "DeleteUser",
        Dict{String,Any}("IdentityStoreId" => IdentityStoreId, "UserId" => UserId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_user(
    IdentityStoreId,
    UserId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return identitystore(
        "DeleteUser",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("IdentityStoreId" => IdentityStoreId, "UserId" => UserId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_group(group_id, identity_store_id)
    describe_group(group_id, identity_store_id, params::Dict{String,<:Any})

Retrieves the group metadata and attributes from GroupId in an identity store.  If you have
administrator access to a member account, you can use this API from the member account.
Read about member accounts in the Organizations User Guide.

# Arguments
- `group_id`: The identifier for a group in the identity store.
- `identity_store_id`: The globally unique identifier for the identity store, such as
  d-1234567890. In this example, d- is a fixed prefix, and 1234567890 is a randomly generated
  string that contains numbers and lower case letters. This value is generated at the time
  that a new identity store is created.

"""
function describe_group(
    GroupId, IdentityStoreId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return identitystore(
        "DescribeGroup",
        Dict{String,Any}("GroupId" => GroupId, "IdentityStoreId" => IdentityStoreId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_group(
    GroupId,
    IdentityStoreId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return identitystore(
        "DescribeGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "GroupId" => GroupId, "IdentityStoreId" => IdentityStoreId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_group_membership(identity_store_id, membership_id)
    describe_group_membership(identity_store_id, membership_id, params::Dict{String,<:Any})

Retrieves membership metadata and attributes from MembershipId in an identity store.  If
you have administrator access to a member account, you can use this API from the member
account. Read about member accounts in the Organizations User Guide.

# Arguments
- `identity_store_id`: The globally unique identifier for the identity store.
- `membership_id`: The identifier for a GroupMembership in an identity store.

"""
function describe_group_membership(
    IdentityStoreId, MembershipId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return identitystore(
        "DescribeGroupMembership",
        Dict{String,Any}(
            "IdentityStoreId" => IdentityStoreId, "MembershipId" => MembershipId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_group_membership(
    IdentityStoreId,
    MembershipId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return identitystore(
        "DescribeGroupMembership",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "IdentityStoreId" => IdentityStoreId, "MembershipId" => MembershipId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_user(identity_store_id, user_id)
    describe_user(identity_store_id, user_id, params::Dict{String,<:Any})

Retrieves the user metadata and attributes from the UserId in an identity store.  If you
have administrator access to a member account, you can use this API from the member
account. Read about member accounts in the Organizations User Guide.

# Arguments
- `identity_store_id`: The globally unique identifier for the identity store, such as
  d-1234567890. In this example, d- is a fixed prefix, and 1234567890 is a randomly generated
  string that contains numbers and lower case letters. This value is generated at the time
  that a new identity store is created.
- `user_id`: The identifier for a user in the identity store.

"""
function describe_user(
    IdentityStoreId, UserId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return identitystore(
        "DescribeUser",
        Dict{String,Any}("IdentityStoreId" => IdentityStoreId, "UserId" => UserId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_user(
    IdentityStoreId,
    UserId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return identitystore(
        "DescribeUser",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("IdentityStoreId" => IdentityStoreId, "UserId" => UserId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_group_id(alternate_identifier, identity_store_id)
    get_group_id(alternate_identifier, identity_store_id, params::Dict{String,<:Any})

Retrieves GroupId in an identity store.  If you have administrator access to a member
account, you can use this API from the member account. Read about member accounts in the
Organizations User Guide.

# Arguments
- `alternate_identifier`: A unique identifier for a user or group that is not the primary
  identifier. This value can be an identifier from an external identity provider (IdP) that
  is associated with the user, the group, or a unique attribute. For the unique attribute,
  the only valid path is displayName.
- `identity_store_id`: The globally unique identifier for the identity store.

"""
function get_group_id(
    AlternateIdentifier, IdentityStoreId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return identitystore(
        "GetGroupId",
        Dict{String,Any}(
            "AlternateIdentifier" => AlternateIdentifier,
            "IdentityStoreId" => IdentityStoreId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_group_id(
    AlternateIdentifier,
    IdentityStoreId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return identitystore(
        "GetGroupId",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AlternateIdentifier" => AlternateIdentifier,
                    "IdentityStoreId" => IdentityStoreId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_group_membership_id(group_id, identity_store_id, member_id)
    get_group_membership_id(group_id, identity_store_id, member_id, params::Dict{String,<:Any})

Retrieves the MembershipId in an identity store.  If you have administrator access to a
member account, you can use this API from the member account. Read about member accounts in
the Organizations User Guide.

# Arguments
- `group_id`: The identifier for a group in the identity store.
- `identity_store_id`: The globally unique identifier for the identity store.
- `member_id`: An object that contains the identifier of a group member. Setting the UserID
  field to the specific identifier for a user indicates that the user is a member of the
  group.

"""
function get_group_membership_id(
    GroupId, IdentityStoreId, MemberId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return identitystore(
        "GetGroupMembershipId",
        Dict{String,Any}(
            "GroupId" => GroupId,
            "IdentityStoreId" => IdentityStoreId,
            "MemberId" => MemberId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_group_membership_id(
    GroupId,
    IdentityStoreId,
    MemberId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return identitystore(
        "GetGroupMembershipId",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "GroupId" => GroupId,
                    "IdentityStoreId" => IdentityStoreId,
                    "MemberId" => MemberId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_user_id(alternate_identifier, identity_store_id)
    get_user_id(alternate_identifier, identity_store_id, params::Dict{String,<:Any})

Retrieves the UserId in an identity store.  If you have administrator access to a member
account, you can use this API from the member account. Read about member accounts in the
Organizations User Guide.

# Arguments
- `alternate_identifier`: A unique identifier for a user or group that is not the primary
  identifier. This value can be an identifier from an external identity provider (IdP) that
  is associated with the user, the group, or a unique attribute. For the unique attribute,
  the only valid paths are userName and emails.value.
- `identity_store_id`: The globally unique identifier for the identity store.

"""
function get_user_id(
    AlternateIdentifier, IdentityStoreId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return identitystore(
        "GetUserId",
        Dict{String,Any}(
            "AlternateIdentifier" => AlternateIdentifier,
            "IdentityStoreId" => IdentityStoreId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_user_id(
    AlternateIdentifier,
    IdentityStoreId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return identitystore(
        "GetUserId",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AlternateIdentifier" => AlternateIdentifier,
                    "IdentityStoreId" => IdentityStoreId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    is_member_in_groups(group_ids, identity_store_id, member_id)
    is_member_in_groups(group_ids, identity_store_id, member_id, params::Dict{String,<:Any})

Checks the user's membership in all requested groups and returns if the member exists in
all queried groups.  If you have administrator access to a member account, you can use this
API from the member account. Read about member accounts in the Organizations User Guide.

# Arguments
- `group_ids`: A list of identifiers for groups in the identity store.
- `identity_store_id`: The globally unique identifier for the identity store.
- `member_id`: An object containing the identifier of a group member.

"""
function is_member_in_groups(
    GroupIds, IdentityStoreId, MemberId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return identitystore(
        "IsMemberInGroups",
        Dict{String,Any}(
            "GroupIds" => GroupIds,
            "IdentityStoreId" => IdentityStoreId,
            "MemberId" => MemberId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function is_member_in_groups(
    GroupIds,
    IdentityStoreId,
    MemberId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return identitystore(
        "IsMemberInGroups",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "GroupIds" => GroupIds,
                    "IdentityStoreId" => IdentityStoreId,
                    "MemberId" => MemberId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_group_memberships(group_id, identity_store_id)
    list_group_memberships(group_id, identity_store_id, params::Dict{String,<:Any})

For the specified group in the specified identity store, returns the list of all
GroupMembership objects and returns results in paginated form.  If you have administrator
access to a member account, you can use this API from the member account. Read about member
accounts in the Organizations User Guide.

# Arguments
- `group_id`: The identifier for a group in the identity store.
- `identity_store_id`: The globally unique identifier for the identity store.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to be returned per request. This parameter
  is used in all List requests to specify how many results to return in one page.
- `"NextToken"`: The pagination token used for the ListUsers, ListGroups and
  ListGroupMemberships API operations. This value is generated by the identity store service.
  It is returned in the API response if the total results are more than the size of one page.
  This token is also returned when it is used in the API request to search for the next page.
"""
function list_group_memberships(
    GroupId, IdentityStoreId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return identitystore(
        "ListGroupMemberships",
        Dict{String,Any}("GroupId" => GroupId, "IdentityStoreId" => IdentityStoreId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_group_memberships(
    GroupId,
    IdentityStoreId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return identitystore(
        "ListGroupMemberships",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "GroupId" => GroupId, "IdentityStoreId" => IdentityStoreId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_group_memberships_for_member(identity_store_id, member_id)
    list_group_memberships_for_member(identity_store_id, member_id, params::Dict{String,<:Any})

For the specified member in the specified identity store, returns the list of all
GroupMembership objects and returns results in paginated form.  If you have administrator
access to a member account, you can use this API from the member account. Read about member
accounts in the Organizations User Guide.

# Arguments
- `identity_store_id`: The globally unique identifier for the identity store.
- `member_id`: An object that contains the identifier of a group member. Setting the UserID
  field to the specific identifier for a user indicates that the user is a member of the
  group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to be returned per request. This parameter
  is used in the ListUsers and ListGroups requests to specify how many results to return in
  one page. The length limit is 50 characters.
- `"NextToken"`: The pagination token used for the ListUsers, ListGroups, and
  ListGroupMemberships API operations. This value is generated by the identity store service.
  It is returned in the API response if the total results are more than the size of one page.
  This token is also returned when it is used in the API request to search for the next page.
"""
function list_group_memberships_for_member(
    IdentityStoreId, MemberId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return identitystore(
        "ListGroupMembershipsForMember",
        Dict{String,Any}("IdentityStoreId" => IdentityStoreId, "MemberId" => MemberId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_group_memberships_for_member(
    IdentityStoreId,
    MemberId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return identitystore(
        "ListGroupMembershipsForMember",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "IdentityStoreId" => IdentityStoreId, "MemberId" => MemberId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_groups(identity_store_id)
    list_groups(identity_store_id, params::Dict{String,<:Any})

Lists all groups in the identity store. Returns a paginated list of complete Group objects.
Filtering for a Group by the DisplayName attribute is deprecated. Instead, use the
GetGroupId API action.  If you have administrator access to a member account, you can use
this API from the member account. Read about member accounts in the Organizations User
Guide.

# Arguments
- `identity_store_id`: The globally unique identifier for the identity store, such as
  d-1234567890. In this example, d- is a fixed prefix, and 1234567890 is a randomly generated
  string that contains numbers and lower case letters. This value is generated at the time
  that a new identity store is created.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: A list of Filter objects, which is used in the ListUsers and ListGroups
  requests.
- `"MaxResults"`: The maximum number of results to be returned per request. This parameter
  is used in the ListUsers and ListGroups requests to specify how many results to return in
  one page. The length limit is 50 characters.
- `"NextToken"`: The pagination token used for the ListUsers and ListGroups API operations.
  This value is generated by the identity store service. It is returned in the API response
  if the total results are more than the size of one page. This token is also returned when
  it is used in the API request to search for the next page.
"""
function list_groups(IdentityStoreId; aws_config::AbstractAWSConfig=current_aws_config())
    return identitystore(
        "ListGroups",
        Dict{String,Any}("IdentityStoreId" => IdentityStoreId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_groups(
    IdentityStoreId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return identitystore(
        "ListGroups",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("IdentityStoreId" => IdentityStoreId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_users(identity_store_id)
    list_users(identity_store_id, params::Dict{String,<:Any})

Lists all users in the identity store. Returns a paginated list of complete User objects.
Filtering for a User by the UserName attribute is deprecated. Instead, use the GetUserId
API action.  If you have administrator access to a member account, you can use this API
from the member account. Read about member accounts in the Organizations User Guide.

# Arguments
- `identity_store_id`: The globally unique identifier for the identity store, such as
  d-1234567890. In this example, d- is a fixed prefix, and 1234567890 is a randomly generated
  string that contains numbers and lower case letters. This value is generated at the time
  that a new identity store is created.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: A list of Filter objects, which is used in the ListUsers and ListGroups
  requests.
- `"MaxResults"`: The maximum number of results to be returned per request. This parameter
  is used in the ListUsers and ListGroups requests to specify how many results to return in
  one page. The length limit is 50 characters.
- `"NextToken"`: The pagination token used for the ListUsers and ListGroups API operations.
  This value is generated by the identity store service. It is returned in the API response
  if the total results are more than the size of one page. This token is also returned when
  it is used in the API request to search for the next page.
"""
function list_users(IdentityStoreId; aws_config::AbstractAWSConfig=current_aws_config())
    return identitystore(
        "ListUsers",
        Dict{String,Any}("IdentityStoreId" => IdentityStoreId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_users(
    IdentityStoreId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return identitystore(
        "ListUsers",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("IdentityStoreId" => IdentityStoreId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_group(group_id, identity_store_id, operations)
    update_group(group_id, identity_store_id, operations, params::Dict{String,<:Any})

For the specified group in the specified identity store, updates the group metadata and
attributes.

# Arguments
- `group_id`: The identifier for a group in the identity store.
- `identity_store_id`: The globally unique identifier for the identity store.
- `operations`: A list of AttributeOperation objects to apply to the requested group. These
  operations might add, replace, or remove an attribute.

"""
function update_group(
    GroupId, IdentityStoreId, Operations; aws_config::AbstractAWSConfig=current_aws_config()
)
    return identitystore(
        "UpdateGroup",
        Dict{String,Any}(
            "GroupId" => GroupId,
            "IdentityStoreId" => IdentityStoreId,
            "Operations" => Operations,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_group(
    GroupId,
    IdentityStoreId,
    Operations,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return identitystore(
        "UpdateGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "GroupId" => GroupId,
                    "IdentityStoreId" => IdentityStoreId,
                    "Operations" => Operations,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_user(identity_store_id, operations, user_id)
    update_user(identity_store_id, operations, user_id, params::Dict{String,<:Any})

For the specified user in the specified identity store, updates the user metadata and
attributes.

# Arguments
- `identity_store_id`: The globally unique identifier for the identity store.
- `operations`: A list of AttributeOperation objects to apply to the requested user. These
  operations might add, replace, or remove an attribute.
- `user_id`: The identifier for a user in the identity store.

"""
function update_user(
    IdentityStoreId, Operations, UserId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return identitystore(
        "UpdateUser",
        Dict{String,Any}(
            "IdentityStoreId" => IdentityStoreId,
            "Operations" => Operations,
            "UserId" => UserId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_user(
    IdentityStoreId,
    Operations,
    UserId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return identitystore(
        "UpdateUser",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "IdentityStoreId" => IdentityStoreId,
                    "Operations" => Operations,
                    "UserId" => UserId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: iotthingsgraph
using AWS.Compat
using AWS.UUIDs

"""
    associate_entity_to_thing(entity_id, thing_name)
    associate_entity_to_thing(entity_id, thing_name, params::Dict{String,<:Any})

Associates a device with a concrete thing that is in the user's registry. A thing can be
associated with only one device at a time. If you associate a thing with a new device id,
its previous association will be removed.

# Arguments
- `entity_id`: The ID of the device to be associated with the thing. The ID should be in
  the following format.  urn:tdm:REGION/ACCOUNT ID/default:device:DEVICENAME
- `thing_name`: The name of the thing to which the entity is to be associated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"namespaceVersion"`: The version of the user's namespace. Defaults to the latest version
  of the user's namespace.
"""
function associate_entity_to_thing(
    entityId, thingName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotthingsgraph(
        "AssociateEntityToThing",
        Dict{String,Any}("entityId" => entityId, "thingName" => thingName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_entity_to_thing(
    entityId,
    thingName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotthingsgraph(
        "AssociateEntityToThing",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("entityId" => entityId, "thingName" => thingName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_flow_template(definition)
    create_flow_template(definition, params::Dict{String,<:Any})

Creates a workflow template. Workflows can be created only in the user's namespace. (The
public namespace contains only entities.) The workflow can contain only entities in the
specified namespace. The workflow is validated against the entities in the latest version
of the user's namespace unless another namespace version is specified in the request.

# Arguments
- `definition`: The workflow DefinitionDocument.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"compatibleNamespaceVersion"`: The namespace version in which the workflow is to be
  created. If no value is specified, the latest version is used by default.
"""
function create_flow_template(
    definition; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotthingsgraph(
        "CreateFlowTemplate",
        Dict{String,Any}("definition" => definition);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_flow_template(
    definition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotthingsgraph(
        "CreateFlowTemplate",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("definition" => definition), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_system_instance(definition, target)
    create_system_instance(definition, target, params::Dict{String,<:Any})

Creates a system instance.  This action validates the system instance, prepares the
deployment-related resources. For Greengrass deployments, it updates the Greengrass group
that is specified by the greengrassGroupName parameter. It also adds a file to the S3
bucket specified by the s3BucketName parameter. You need to call DeploySystemInstance after
running this action. For Greengrass deployments, since this action modifies and adds
resources to a Greengrass group and an S3 bucket on the caller's behalf, the calling
identity must have write permissions to both the specified Greengrass group and S3 bucket.
Otherwise, the call will fail with an authorization error. For cloud deployments, this
action requires a flowActionsRoleArn value. This is an IAM role that has permissions to
access AWS services, such as AWS Lambda and AWS IoT, that the flow uses when it executes.
If the definition document doesn't specify a version of the user's namespace, the latest
version will be used by default.

# Arguments
- `definition`:
- `target`: The target type of the deployment. Valid values are GREENGRASS and CLOUD.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"flowActionsRoleArn"`: The ARN of the IAM role that AWS IoT Things Graph will assume
  when it executes the flow. This role must have read and write access to AWS Lambda and AWS
  IoT and any other AWS services that the flow uses when it executes. This value is required
  if the value of the target parameter is CLOUD.
- `"greengrassGroupName"`: The name of the Greengrass group where the system instance will
  be deployed. This value is required if the value of the target parameter is GREENGRASS.
- `"metricsConfiguration"`:
- `"s3BucketName"`: The name of the Amazon Simple Storage Service bucket that will be used
  to store and deploy the system instance's resource file. This value is required if the
  value of the target parameter is GREENGRASS.
- `"tags"`: Metadata, consisting of key-value pairs, that can be used to categorize your
  system instances.
"""
function create_system_instance(
    definition, target; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotthingsgraph(
        "CreateSystemInstance",
        Dict{String,Any}("definition" => definition, "target" => target);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_system_instance(
    definition,
    target,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotthingsgraph(
        "CreateSystemInstance",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("definition" => definition, "target" => target),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_system_template(definition)
    create_system_template(definition, params::Dict{String,<:Any})

Creates a system. The system is validated against the entities in the latest version of the
user's namespace unless another namespace version is specified in the request.

# Arguments
- `definition`: The DefinitionDocument used to create the system.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"compatibleNamespaceVersion"`: The namespace version in which the system is to be
  created. If no value is specified, the latest version is used by default.
"""
function create_system_template(
    definition; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotthingsgraph(
        "CreateSystemTemplate",
        Dict{String,Any}("definition" => definition);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_system_template(
    definition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotthingsgraph(
        "CreateSystemTemplate",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("definition" => definition), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_flow_template(id)
    delete_flow_template(id, params::Dict{String,<:Any})

Deletes a workflow. Any new system or deployment that contains this workflow will fail to
update or deploy. Existing deployments that contain the workflow will continue to run
(since they use a snapshot of the workflow taken at the time of deployment).

# Arguments
- `id`: The ID of the workflow to be deleted. The ID should be in the following format.
  urn:tdm:REGION/ACCOUNT ID/default:workflow:WORKFLOWNAME

"""
function delete_flow_template(id; aws_config::AbstractAWSConfig=current_aws_config())
    return iotthingsgraph(
        "DeleteFlowTemplate",
        Dict{String,Any}("id" => id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_flow_template(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotthingsgraph(
        "DeleteFlowTemplate",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("id" => id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_namespace()
    delete_namespace(params::Dict{String,<:Any})

Deletes the specified namespace. This action deletes all of the entities in the namespace.
Delete the systems and flows that use entities in the namespace before performing this
action. This action takes no request parameters.

"""
function delete_namespace(; aws_config::AbstractAWSConfig=current_aws_config())
    return iotthingsgraph(
        "DeleteNamespace"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function delete_namespace(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotthingsgraph(
        "DeleteNamespace", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    delete_system_instance()
    delete_system_instance(params::Dict{String,<:Any})

Deletes a system instance. Only system instances that have never been deployed, or that
have been undeployed can be deleted. Users can create a new system instance that has the
same ID as a deleted system instance.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"id"`: The ID of the system instance to be deleted.
"""
function delete_system_instance(; aws_config::AbstractAWSConfig=current_aws_config())
    return iotthingsgraph(
        "DeleteSystemInstance"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function delete_system_instance(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotthingsgraph(
        "DeleteSystemInstance",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_system_template(id)
    delete_system_template(id, params::Dict{String,<:Any})

Deletes a system. New deployments can't contain the system after its deletion. Existing
deployments that contain the system will continue to work because they use a snapshot of
the system that is taken when it is deployed.

# Arguments
- `id`: The ID of the system to be deleted. The ID should be in the following format.
  urn:tdm:REGION/ACCOUNT ID/default:system:SYSTEMNAME

"""
function delete_system_template(id; aws_config::AbstractAWSConfig=current_aws_config())
    return iotthingsgraph(
        "DeleteSystemTemplate",
        Dict{String,Any}("id" => id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_system_template(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotthingsgraph(
        "DeleteSystemTemplate",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("id" => id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    deploy_system_instance()
    deploy_system_instance(params::Dict{String,<:Any})

 Greengrass and Cloud Deployments  Deploys the system instance to the target specified in
CreateSystemInstance.   Greengrass Deployments  If the system or any workflows and entities
have been updated before this action is called, then the deployment will create a new
Amazon Simple Storage Service resource file and then deploy it. Since this action creates a
Greengrass deployment on the caller's behalf, the calling identity must have write
permissions to the specified Greengrass group. Otherwise, the call will fail with an
authorization error. For information about the artifacts that get added to your Greengrass
core device when you use this API, see AWS IoT Things Graph and AWS IoT Greengrass.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"id"`: The ID of the system instance. This value is returned by the CreateSystemInstance
  action. The ID should be in the following format.  urn:tdm:REGION/ACCOUNT
  ID/default:deployment:DEPLOYMENTNAME
"""
function deploy_system_instance(; aws_config::AbstractAWSConfig=current_aws_config())
    return iotthingsgraph(
        "DeploySystemInstance"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function deploy_system_instance(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotthingsgraph(
        "DeploySystemInstance",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    deprecate_flow_template(id)
    deprecate_flow_template(id, params::Dict{String,<:Any})

Deprecates the specified workflow. This action marks the workflow for deletion. Deprecated
flows can't be deployed, but existing deployments will continue to run.

# Arguments
- `id`: The ID of the workflow to be deleted. The ID should be in the following format.
  urn:tdm:REGION/ACCOUNT ID/default:workflow:WORKFLOWNAME

"""
function deprecate_flow_template(id; aws_config::AbstractAWSConfig=current_aws_config())
    return iotthingsgraph(
        "DeprecateFlowTemplate",
        Dict{String,Any}("id" => id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function deprecate_flow_template(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotthingsgraph(
        "DeprecateFlowTemplate",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("id" => id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    deprecate_system_template(id)
    deprecate_system_template(id, params::Dict{String,<:Any})

Deprecates the specified system.

# Arguments
- `id`: The ID of the system to delete. The ID should be in the following format.
  urn:tdm:REGION/ACCOUNT ID/default:system:SYSTEMNAME

"""
function deprecate_system_template(id; aws_config::AbstractAWSConfig=current_aws_config())
    return iotthingsgraph(
        "DeprecateSystemTemplate",
        Dict{String,Any}("id" => id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function deprecate_system_template(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotthingsgraph(
        "DeprecateSystemTemplate",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("id" => id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_namespace()
    describe_namespace(params::Dict{String,<:Any})

Gets the latest version of the user's namespace and the public version that it is tracking.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"namespaceName"`: The name of the user's namespace. Set this to aws to get the public
  namespace.
"""
function describe_namespace(; aws_config::AbstractAWSConfig=current_aws_config())
    return iotthingsgraph(
        "DescribeNamespace"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_namespace(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotthingsgraph(
        "DescribeNamespace", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    dissociate_entity_from_thing(entity_type, thing_name)
    dissociate_entity_from_thing(entity_type, thing_name, params::Dict{String,<:Any})

Dissociates a device entity from a concrete thing. The action takes only the type of the
entity that you need to dissociate because only one entity of a particular type can be
associated with a thing.

# Arguments
- `entity_type`: The entity type from which to disassociate the thing.
- `thing_name`: The name of the thing to disassociate.

"""
function dissociate_entity_from_thing(
    entityType, thingName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotthingsgraph(
        "DissociateEntityFromThing",
        Dict{String,Any}("entityType" => entityType, "thingName" => thingName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function dissociate_entity_from_thing(
    entityType,
    thingName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotthingsgraph(
        "DissociateEntityFromThing",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("entityType" => entityType, "thingName" => thingName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_entities(ids)
    get_entities(ids, params::Dict{String,<:Any})

Gets definitions of the specified entities. Uses the latest version of the user's namespace
by default. This API returns the following TDM entities.   Properties   States   Events
Actions   Capabilities   Mappings   Devices   Device Models   Services   This action
doesn't return definitions for systems, flows, and deployments.

# Arguments
- `ids`: An array of entity IDs. The IDs should be in the following format.
  urn:tdm:REGION/ACCOUNT ID/default:device:DEVICENAME

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"namespaceVersion"`: The version of the user's namespace. Defaults to the latest version
  of the user's namespace.
"""
function get_entities(ids; aws_config::AbstractAWSConfig=current_aws_config())
    return iotthingsgraph(
        "GetEntities",
        Dict{String,Any}("ids" => ids);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_entities(
    ids, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotthingsgraph(
        "GetEntities",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("ids" => ids), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_flow_template(id)
    get_flow_template(id, params::Dict{String,<:Any})

Gets the latest version of the DefinitionDocument and FlowTemplateSummary for the specified
workflow.

# Arguments
- `id`: The ID of the workflow. The ID should be in the following format.
  urn:tdm:REGION/ACCOUNT ID/default:workflow:WORKFLOWNAME

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"revisionNumber"`: The number of the workflow revision to retrieve.
"""
function get_flow_template(id; aws_config::AbstractAWSConfig=current_aws_config())
    return iotthingsgraph(
        "GetFlowTemplate",
        Dict{String,Any}("id" => id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_flow_template(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotthingsgraph(
        "GetFlowTemplate",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("id" => id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_flow_template_revisions(id)
    get_flow_template_revisions(id, params::Dict{String,<:Any})

Gets revisions of the specified workflow. Only the last 100 revisions are stored. If the
workflow has been deprecated, this action will return revisions that occurred before the
deprecation. This action won't work for workflows that have been deleted.

# Arguments
- `id`: The ID of the workflow. The ID should be in the following format.
  urn:tdm:REGION/ACCOUNT ID/default:workflow:WORKFLOWNAME

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in the response.
- `"nextToken"`: The string that specifies the next page of results. Use this when you're
  paginating results.
"""
function get_flow_template_revisions(id; aws_config::AbstractAWSConfig=current_aws_config())
    return iotthingsgraph(
        "GetFlowTemplateRevisions",
        Dict{String,Any}("id" => id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_flow_template_revisions(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotthingsgraph(
        "GetFlowTemplateRevisions",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("id" => id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_namespace_deletion_status()
    get_namespace_deletion_status(params::Dict{String,<:Any})

Gets the status of a namespace deletion task.

"""
function get_namespace_deletion_status(; aws_config::AbstractAWSConfig=current_aws_config())
    return iotthingsgraph(
        "GetNamespaceDeletionStatus"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_namespace_deletion_status(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotthingsgraph(
        "GetNamespaceDeletionStatus",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_system_instance(id)
    get_system_instance(id, params::Dict{String,<:Any})

Gets a system instance.

# Arguments
- `id`: The ID of the system deployment instance. This value is returned by
  CreateSystemInstance. The ID should be in the following format.  urn:tdm:REGION/ACCOUNT
  ID/default:deployment:DEPLOYMENTNAME

"""
function get_system_instance(id; aws_config::AbstractAWSConfig=current_aws_config())
    return iotthingsgraph(
        "GetSystemInstance",
        Dict{String,Any}("id" => id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_system_instance(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotthingsgraph(
        "GetSystemInstance",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("id" => id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_system_template(id)
    get_system_template(id, params::Dict{String,<:Any})

Gets a system.

# Arguments
- `id`: The ID of the system to get. This ID must be in the user's namespace. The ID should
  be in the following format.  urn:tdm:REGION/ACCOUNT ID/default:system:SYSTEMNAME

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"revisionNumber"`: The number that specifies the revision of the system to get.
"""
function get_system_template(id; aws_config::AbstractAWSConfig=current_aws_config())
    return iotthingsgraph(
        "GetSystemTemplate",
        Dict{String,Any}("id" => id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_system_template(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotthingsgraph(
        "GetSystemTemplate",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("id" => id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_system_template_revisions(id)
    get_system_template_revisions(id, params::Dict{String,<:Any})

Gets revisions made to the specified system template. Only the previous 100 revisions are
stored. If the system has been deprecated, this action will return the revisions that
occurred before its deprecation. This action won't work with systems that have been deleted.

# Arguments
- `id`: The ID of the system template. The ID should be in the following format.
  urn:tdm:REGION/ACCOUNT ID/default:system:SYSTEMNAME

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in the response.
- `"nextToken"`: The string that specifies the next page of results. Use this when you're
  paginating results.
"""
function get_system_template_revisions(
    id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotthingsgraph(
        "GetSystemTemplateRevisions",
        Dict{String,Any}("id" => id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_system_template_revisions(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotthingsgraph(
        "GetSystemTemplateRevisions",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("id" => id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_upload_status(upload_id)
    get_upload_status(upload_id, params::Dict{String,<:Any})

Gets the status of the specified upload.

# Arguments
- `upload_id`: The ID of the upload. This value is returned by the UploadEntityDefinitions
  action.

"""
function get_upload_status(uploadId; aws_config::AbstractAWSConfig=current_aws_config())
    return iotthingsgraph(
        "GetUploadStatus",
        Dict{String,Any}("uploadId" => uploadId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_upload_status(
    uploadId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotthingsgraph(
        "GetUploadStatus",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("uploadId" => uploadId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_flow_execution_messages(flow_execution_id)
    list_flow_execution_messages(flow_execution_id, params::Dict{String,<:Any})

Returns a list of objects that contain information about events in a flow execution.

# Arguments
- `flow_execution_id`: The ID of the flow execution.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in the response.
- `"nextToken"`: The string that specifies the next page of results. Use this when you're
  paginating results.
"""
function list_flow_execution_messages(
    flowExecutionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotthingsgraph(
        "ListFlowExecutionMessages",
        Dict{String,Any}("flowExecutionId" => flowExecutionId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_flow_execution_messages(
    flowExecutionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotthingsgraph(
        "ListFlowExecutionMessages",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("flowExecutionId" => flowExecutionId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists all tags on an AWS IoT Things Graph resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource whose tags are to be
  returned.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of tags to return.
- `"nextToken"`: The token that specifies the next page of results to return.
"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotthingsgraph(
        "ListTagsForResource",
        Dict{String,Any}("resourceArn" => resourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotthingsgraph(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceArn" => resourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    search_entities(entity_types)
    search_entities(entity_types, params::Dict{String,<:Any})

Searches for entities of the specified type. You can search for entities in your namespace
and the public namespace that you're tracking.

# Arguments
- `entity_types`: The entity types for which to search.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: Optional filter to apply to the search. Valid filters are NAME NAMESPACE,
  SEMANTIC_TYPE_PATH and REFERENCED_ENTITY_ID. REFERENCED_ENTITY_ID filters on entities that
  are used by the entity in the result set. For example, you can filter on the ID of a
  property that is used in a state. Multiple filters function as OR criteria in the query.
  Multiple values passed inside the filter function as AND criteria.
- `"maxResults"`: The maximum number of results to return in the response.
- `"namespaceVersion"`: The version of the user's namespace. Defaults to the latest version
  of the user's namespace.
- `"nextToken"`: The string that specifies the next page of results. Use this when you're
  paginating results.
"""
function search_entities(entityTypes; aws_config::AbstractAWSConfig=current_aws_config())
    return iotthingsgraph(
        "SearchEntities",
        Dict{String,Any}("entityTypes" => entityTypes);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function search_entities(
    entityTypes,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotthingsgraph(
        "SearchEntities",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("entityTypes" => entityTypes), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    search_flow_executions(system_instance_id)
    search_flow_executions(system_instance_id, params::Dict{String,<:Any})

Searches for AWS IoT Things Graph workflow execution instances.

# Arguments
- `system_instance_id`: The ID of the system instance that contains the flow.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"endTime"`: The date and time of the latest flow execution to return.
- `"flowExecutionId"`: The ID of a flow execution.
- `"maxResults"`: The maximum number of results to return in the response.
- `"nextToken"`: The string that specifies the next page of results. Use this when you're
  paginating results.
- `"startTime"`: The date and time of the earliest flow execution to return.
"""
function search_flow_executions(
    systemInstanceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotthingsgraph(
        "SearchFlowExecutions",
        Dict{String,Any}("systemInstanceId" => systemInstanceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function search_flow_executions(
    systemInstanceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotthingsgraph(
        "SearchFlowExecutions",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("systemInstanceId" => systemInstanceId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    search_flow_templates()
    search_flow_templates(params::Dict{String,<:Any})

Searches for summary information about workflows.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: An array of objects that limit the result set. The only valid filter is
  DEVICE_MODEL_ID.
- `"maxResults"`: The maximum number of results to return in the response.
- `"nextToken"`: The string that specifies the next page of results. Use this when you're
  paginating results.
"""
function search_flow_templates(; aws_config::AbstractAWSConfig=current_aws_config())
    return iotthingsgraph(
        "SearchFlowTemplates"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function search_flow_templates(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotthingsgraph(
        "SearchFlowTemplates",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    search_system_instances()
    search_system_instances(params::Dict{String,<:Any})

Searches for system instances in the user's account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: Optional filter to apply to the search. Valid filters are
  SYSTEM_TEMPLATE_ID, STATUS, and GREENGRASS_GROUP_NAME. Multiple filters function as OR
  criteria in the query. Multiple values passed inside the filter function as AND criteria.
- `"maxResults"`: The maximum number of results to return in the response.
- `"nextToken"`: The string that specifies the next page of results. Use this when you're
  paginating results.
"""
function search_system_instances(; aws_config::AbstractAWSConfig=current_aws_config())
    return iotthingsgraph(
        "SearchSystemInstances"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function search_system_instances(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotthingsgraph(
        "SearchSystemInstances",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    search_system_templates()
    search_system_templates(params::Dict{String,<:Any})

Searches for summary information about systems in the user's account. You can filter by the
ID of a workflow to return only systems that use the specified workflow.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: An array of filters that limit the result set. The only valid filter is
  FLOW_TEMPLATE_ID.
- `"maxResults"`: The maximum number of results to return in the response.
- `"nextToken"`: The string that specifies the next page of results. Use this when you're
  paginating results.
"""
function search_system_templates(; aws_config::AbstractAWSConfig=current_aws_config())
    return iotthingsgraph(
        "SearchSystemTemplates"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function search_system_templates(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotthingsgraph(
        "SearchSystemTemplates",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    search_things(entity_id)
    search_things(entity_id, params::Dict{String,<:Any})

Searches for things associated with the specified entity. You can search by both device and
device model. For example, if two different devices, camera1 and camera2, implement the
camera device model, the user can associate thing1 to camera1 and thing2 to camera2.
SearchThings(camera2) will return only thing2, but SearchThings(camera) will return both
thing1 and thing2. This action searches for exact matches and doesn't perform partial text
matching.

# Arguments
- `entity_id`: The ID of the entity to which the things are associated. The IDs should be
  in the following format.  urn:tdm:REGION/ACCOUNT ID/default:device:DEVICENAME

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in the response.
- `"namespaceVersion"`: The version of the user's namespace. Defaults to the latest version
  of the user's namespace.
- `"nextToken"`: The string that specifies the next page of results. Use this when you're
  paginating results.
"""
function search_things(entityId; aws_config::AbstractAWSConfig=current_aws_config())
    return iotthingsgraph(
        "SearchThings",
        Dict{String,Any}("entityId" => entityId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function search_things(
    entityId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotthingsgraph(
        "SearchThings",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("entityId" => entityId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Creates a tag for the specified resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource whose tags are returned.
- `tags`: A list of tags to add to the resource.&gt;

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return iotthingsgraph(
        "TagResource",
        Dict{String,Any}("resourceArn" => resourceArn, "tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotthingsgraph(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceArn" => resourceArn, "tags" => tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    undeploy_system_instance()
    undeploy_system_instance(params::Dict{String,<:Any})

Removes a system instance from its target (Cloud or Greengrass).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"id"`: The ID of the system instance to remove from its target.
"""
function undeploy_system_instance(; aws_config::AbstractAWSConfig=current_aws_config())
    return iotthingsgraph(
        "UndeploySystemInstance"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function undeploy_system_instance(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotthingsgraph(
        "UndeploySystemInstance",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes a tag from the specified resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource whose tags are to be
  removed.
- `tag_keys`: A list of tag key names to remove from the resource. You don't specify the
  value. Both the key and its associated value are removed.  This parameter to the API
  requires a JSON text string argument. For information on how to format a JSON parameter for
  the various command line tool environments, see Using JSON for Parameters in the AWS CLI
  User Guide.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotthingsgraph(
        "UntagResource",
        Dict{String,Any}("resourceArn" => resourceArn, "tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotthingsgraph(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceArn" => resourceArn, "tagKeys" => tagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_flow_template(definition, id)
    update_flow_template(definition, id, params::Dict{String,<:Any})

Updates the specified workflow. All deployed systems and system instances that use the
workflow will see the changes in the flow when it is redeployed. If you don't want this
behavior, copy the workflow (creating a new workflow with a different ID), and update the
copy. The workflow can contain only entities in the specified namespace.

# Arguments
- `definition`: The DefinitionDocument that contains the updated workflow definition.
- `id`: The ID of the workflow to be updated. The ID should be in the following format.
  urn:tdm:REGION/ACCOUNT ID/default:workflow:WORKFLOWNAME

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"compatibleNamespaceVersion"`: The version of the user's namespace. If no value is
  specified, the latest version is used by default. Use the GetFlowTemplateRevisions if you
  want to find earlier revisions of the flow to update.
"""
function update_flow_template(
    definition, id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotthingsgraph(
        "UpdateFlowTemplate",
        Dict{String,Any}("definition" => definition, "id" => id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_flow_template(
    definition,
    id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotthingsgraph(
        "UpdateFlowTemplate",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("definition" => definition, "id" => id), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_system_template(definition, id)
    update_system_template(definition, id, params::Dict{String,<:Any})

Updates the specified system. You don't need to run this action after updating a workflow.
Any deployment that uses the system will see the changes in the system when it is
redeployed.

# Arguments
- `definition`: The DefinitionDocument that contains the updated system definition.
- `id`: The ID of the system to be updated. The ID should be in the following format.
  urn:tdm:REGION/ACCOUNT ID/default:system:SYSTEMNAME

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"compatibleNamespaceVersion"`: The version of the user's namespace. Defaults to the
  latest version of the user's namespace. If no value is specified, the latest version is
  used by default.
"""
function update_system_template(
    definition, id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotthingsgraph(
        "UpdateSystemTemplate",
        Dict{String,Any}("definition" => definition, "id" => id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_system_template(
    definition,
    id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotthingsgraph(
        "UpdateSystemTemplate",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("definition" => definition, "id" => id), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    upload_entity_definitions()
    upload_entity_definitions(params::Dict{String,<:Any})

Asynchronously uploads one or more entity definitions to the user's namespace. The document
parameter is required if syncWithPublicNamespace and deleteExistingEntites are false. If
the syncWithPublicNamespace parameter is set to true, the user's namespace will synchronize
with the latest version of the public namespace. If deprecateExistingEntities is set to
true, all entities in the latest version will be deleted before the new DefinitionDocument
is uploaded. When a user uploads entity definitions for the first time, the service creates
a new namespace for the user. The new namespace tracks the public namespace. Currently
users can have only one namespace. The namespace version increments whenever a user uploads
entity definitions that are backwards-incompatible and whenever a user sets the
syncWithPublicNamespace parameter or the deprecateExistingEntities parameter to true. The
IDs for all of the entities should be in URN format. Each entity must be in the user's
namespace. Users can't create entities in the public namespace, but entity definitions can
refer to entities in the public namespace. Valid entities are Device, DeviceModel, Service,
Capability, State, Action, Event, Property, Mapping, Enum.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"deprecateExistingEntities"`: A Boolean that specifies whether to deprecate all entities
  in the latest version before uploading the new DefinitionDocument. If set to true, the
  upload will create a new namespace version.
- `"document"`: The DefinitionDocument that defines the updated entities.
- `"syncWithPublicNamespace"`: A Boolean that specifies whether to synchronize with the
  latest version of the public namespace. If set to true, the upload will create a new
  namespace version.
"""
function upload_entity_definitions(; aws_config::AbstractAWSConfig=current_aws_config())
    return iotthingsgraph(
        "UploadEntityDefinitions"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function upload_entity_definitions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotthingsgraph(
        "UploadEntityDefinitions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: kinesis_video_signaling
using AWS.Compat
using AWS.UUIDs

"""
    get_ice_server_config(channel_arn)
    get_ice_server_config(channel_arn, params::Dict{String,<:Any})

Gets the Interactive Connectivity Establishment (ICE) server configuration information,
including URIs, username, and password which can be used to configure the WebRTC
connection. The ICE component uses this configuration information to setup the WebRTC
connection, including authenticating with the Traversal Using Relays around NAT (TURN)
relay server.  TURN is a protocol that is used to improve the connectivity of peer-to-peer
applications. By providing a cloud-based relay service, TURN ensures that a connection can
be established even when one or more peers are incapable of a direct peer-to-peer
connection. For more information, see A REST API For Access To TURN Services.  You can
invoke this API to establish a fallback mechanism in case either of the peers is unable to
establish a direct peer-to-peer connection over a signaling channel. You must specify
either a signaling channel ARN or the client ID in order to invoke this API.

# Arguments
- `channel_arn`: The ARN of the signaling channel to be used for the peer-to-peer
  connection between configured peers.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientId"`: Unique identifier for the viewer. Must be unique within the signaling
  channel.
- `"Service"`: Specifies the desired service. Currently, TURN is the only valid value.
- `"Username"`: An optional user ID to be associated with the credentials.
"""
function get_ice_server_config(
    ChannelARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_video_signaling(
        "POST",
        "/v1/get-ice-server-config",
        Dict{String,Any}("ChannelARN" => ChannelARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_ice_server_config(
    ChannelARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_video_signaling(
        "POST",
        "/v1/get-ice-server-config",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ChannelARN" => ChannelARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    send_alexa_offer_to_master(channel_arn, message_payload, sender_client_id)
    send_alexa_offer_to_master(channel_arn, message_payload, sender_client_id, params::Dict{String,<:Any})

This API allows you to connect WebRTC-enabled devices with Alexa display devices. When
invoked, it sends the Alexa Session Description Protocol (SDP) offer to the master peer.
The offer is delivered as soon as the master is connected to the specified signaling
channel. This API returns the SDP answer from the connected master. If the master is not
connected to the signaling channel, redelivery requests are made until the message expires.

# Arguments
- `channel_arn`: The ARN of the signaling channel by which Alexa and the master peer
  communicate.
- `message_payload`: The base64-encoded SDP offer content.
- `sender_client_id`: The unique identifier for the sender client.

"""
function send_alexa_offer_to_master(
    ChannelARN,
    MessagePayload,
    SenderClientId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_video_signaling(
        "POST",
        "/v1/send-alexa-offer-to-master",
        Dict{String,Any}(
            "ChannelARN" => ChannelARN,
            "MessagePayload" => MessagePayload,
            "SenderClientId" => SenderClientId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function send_alexa_offer_to_master(
    ChannelARN,
    MessagePayload,
    SenderClientId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_video_signaling(
        "POST",
        "/v1/send-alexa-offer-to-master",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ChannelARN" => ChannelARN,
                    "MessagePayload" => MessagePayload,
                    "SenderClientId" => SenderClientId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function _can_read_file(file_name::String)
    return isfile(file_name) && try
        isreadable(open(file_name, "r"))
    catch e
        false
    end
end
_begins_with_ec2(file_name::String) = uppercase(String(read(file_name, 3))) == "EC2"
function _ends_with_ec2(file_name::String)
    return endswith(strip(uppercase(read(file_name, String))), "EC2")
end

"""
Generate a valid role session name. Currently only ensures that the session name is
64-characters or less.
"""
function _role_session_name(prefix, name, suffix)
    b = IOBuffer()
    write(b, prefix, name)
    truncate(b, min(64 - length(suffix), b.size))  # Assumes ASCII
    write(b, suffix)
    return String(take!(b))
end

"""
Get the value for `key` in the `ini` file for a given `profile`.
"""
function _get_profile_value(ini::Inifile, profile, key; kwargs...)
    return _get_ini_value(ini, "profile" => profile, key; kwargs...)
end

"""
Get the value for `key` in the `ini` file for a given `sso_session`.
"""
function _get_sso_session_value(ini::Inifile, sso_session, key; kwargs...)
    return _get_ini_value(ini, "sso-session" => sso_session, key; kwargs...)
end

function _get_ini_value(
    ini::Inifile,
    section::Pair{<:AbstractString,<:AbstractString},
    key::AbstractString;
    default_value=nothing,
)
    section_type, section_name = section
    value = get(ini, "$section_type $section_name", key)
    value === :notfound && (value = get(ini, section_name, key))
    value === :notfound && (value = default_value)

    return value
end

function _aws_profile_config(ini::Inifile, profile::AbstractString)
    # Prefer using "profile default" over "default"
    section_name = if profile != "default" || haskey(sections(ini), "profile default")
        "profile $profile"
    else
        "default"
    end

    return copy(get(sections(ini), section_name, IniFile.HTSS()))
end

function _aws_profile_config(ini::Inifile, profile::Nothing)
    return _aws_profile_config(ini, _aws_get_profile())
end

function _aws_profile_config(config_file::AbstractString, profile)
    isfile(config_file) || return Dict()
    return _aws_profile_config(read(Inifile(), config_file), profile)
end

function _aws_profile_config(config_file::Nothing, profile)
    return _aws_profile_config(dot_aws_config_file(), profile)
end

"""
Retrieve the `AWSCredentials` for a given role from Security Token Services (STS).
"""
function _aws_get_role(role::AbstractString, ini::Inifile)
    settings = @mock _aws_profile_config(ini, role)
    settings === nothing && return nothing

    source_profile = get(settings, "source_profile", nothing)
    source_profile === nothing && return nothing

    role_arn = get(settings, "role_arn", nothing)
    mfa_serial = get(settings, "mfa_serial", nothing)
    duration_seconds = get(settings, "duration_seconds", nothing)

    credentials = nothing
    for f in (sso_credentials, dot_aws_credentials, dot_aws_config)
        credentials = f(source_profile)
        credentials === nothing || break
    end

    credentials === nothing && return nothing
    config = AWSConfig(;
        creds=credentials, region=aws_get_region(; config=ini, profile=source_profile)
    )

    params = LittleDict(
        "RoleArn" => role_arn, "RoleSessionName" => replace(role, r"[^\w+=,.@-]" => s"-")
    )

    if mfa_serial !== nothing
        params["SerialNumber"] = mfa_serial
        token = @mock Base.getpass("Enter MFA code for $mfa_serial")
        params["TokenCode"] = read(token, String)
        Base.shred!(token)
    end

    if duration_seconds !== nothing
        params["DurationSeconds"] = duration_seconds
    end

    # RoleSessionName Documentation
    # https://docs.aws.amazon.com/STS/latest/APIReference/API_AssumeRole.html
    response = @mock AWSServices.sts(
        "AssumeRole",
        params;
        aws_config=config,
        feature_set=FeatureSet(; use_response_type=true),
    )
    role = parse(response)
    role_creds = role["AssumeRoleResult"]["Credentials"]

    return AWSCredentials(
        role_creds["AccessKeyId"],
        role_creds["SecretAccessKey"],
        role_creds["SessionToken"];
        expiry=DateTime(rstrip(role_creds["Expiration"], 'Z')),
    )
end

"""
Get `AWSCredentials` for the specified `profile` from the `inifile`. If targeting the
`~/.aws/config` file, with a non-default `profile`, you must specify `config=true` otherwise
the default credentials will be returned.
"""
function _aws_get_credential_details(profile::AbstractString, ini::Inifile)
    access_key = _get_profile_value(ini, profile, "aws_access_key_id")
    secret_key = _get_profile_value(ini, profile, "aws_secret_access_key")
    token = _get_profile_value(ini, profile, "aws_session_token"; default_value="")

    return (access_key, secret_key, token)
end

"""
Get the default AWS profile
"""
function _aws_get_profile(; default="default")
    @something(
        get(ENV, "AWS_PROFILE", nothing),
        get(ENV, "AWS_DEFAULT_PROFILE", nothing),
        Some(default),
    )
end

"""
Check if credentials will expire within 5 minutes
"""
function _will_expire(aws_creds::AWSCredentials)
    return aws_creds.expiry - now(UTC) <= Minute(5)
end

"""
Retrieve the EC2 meta data from the local AWS endpoint. Return the EC2 metadata request
body, or `nothing` if not running on an EC2 instance.
"""
function _ec2_metadata(metadata_endpoint::String)
    try
        request = @mock HTTP.request(
            "GET", "http://169.254.169.254/latest/meta-data/$metadata_endpoint"
        )

        return request === nothing ? nothing : String(request.body)
    catch e
        e isa HTTP.RequestError || e isa HTTP.StatusError && e.status == 404 || rethrow(e)
    end

    return nothing
end

"""
Retrieve the existing SSO access token from AWS CLI cache using the SSO session name.
"""
function _sso_cache_access_token(session_name::AbstractString)
    cache_path = joinpath(homedir(), ".aws", "sso", "cache")
    cache_file = joinpath(cache_path, bytes2hex(sha1(session_name)) * ".json")

    !isfile(cache_file) && return nothing

    _cache = JSON.parsefile(cache_file)
    token = get(_cache, "accessToken", nothing)

    return token
end

"""
Retrieve sso-specific details for the given `profile`.
"""
function _aws_get_sso_credential_details(profile::AbstractString, ini::Inifile)
    sso_session = _get_profile_value(ini, profile, "sso_session")

    # > Typically, `sso_account_id` and `sso_role_name` must be set in the profile section
    # > so that the SDK can request SSO credentials.
    # – https://docs.aws.amazon.com/cli/latest/userguide/cli-configure-sso.html#cli-configure-sso-manual
    sso_account_id = _get_profile_value(ini, profile, "sso_account_id")
    sso_role_name = _get_profile_value(ini, profile, "sso_role_name")

    if isnothing(sso_account_id)
        throw(
            InvalidAWSConfig(
                "Profile \"$profile\" must define `sso_account_id` in order to request " *
                "SSO credentials.",
            ),
        )
    elseif isnothing(sso_role_name)
        throw(
            InvalidAWSConfig(
                "Profile \"$profile\" must define `sso_role_name` in order to request " *
                "SSO credentials.",
            ),
        )
    end

    if !isnothing(sso_session)
        # IAM identity center authentication
        # https://docs.aws.amazon.com/cli/latest/userguide/cli-configure-sso.html#cli-configure-sso-manual
        sso_start_url = _get_sso_session_value(ini, sso_session, "sso_start_url")
        sso_region = _get_sso_session_value(ini, sso_session, "sso_region")

        # The AWS documentation documents the `sso_start_url` and `sso_region` keys as
        # required. AWS.jl doesn't actually require `sso_start_url` in this case but we'll
        # still validate this key is set.
        if isnothing(sso_start_url)
            throw(
                InvalidAWSConfig(
                    "The SSO session \"$sso_session\" section must define `sso_start_url`."
                ),
            )
        elseif isnothing(sso_region)
            throw(
                InvalidAWSConfig(
                    "The SSO session \"$sso_session\" section must define `sso_region`."
                ),
            )
        end

        # The AWS CLI requires that these settings which be set on the profile and
        # sso-session are at least consistent:
        # - "The value for sso_start_url is inconsistent between profile (https://my-legacy-sso-portal.awsapps.com/start) and sso-session (https://my-legacy-sso-portal.awsapps.com/start)."
        # - "The value for sso_region is inconsistent between profile (us-legacy-1) and sso-session (us-east-1)."
        legacy_sso_start_url = _get_profile_value(ini, profile, "sso_start_url")
        legacy_sso_region = _get_profile_value(ini, profile, "sso_region")

        if !isnothing(legacy_sso_start_url) && sso_start_url != legacy_sso_start_url
            throw(
                InvalidAWSConfig(
                    "The value for `sso_start_url` is inconsistent between the profile " *
                    "($legacy_sso_start_url) and the sso-session ($sso_start_url).",
                ),
            )
        elseif !isnothing(legacy_sso_region) && sso_region != legacy_sso_region
            throw(
                InvalidAWSConfig(
                    "The value for `sso_region` is inconsistent between the profile " *
                    "($legacy_sso_region) and the sso-session ($sso_region).",
                ),
            )
        end

        access_token = @mock _sso_cache_access_token(sso_session)
    else
        # Legacy IAM identity center authentication
        # https://docs.aws.amazon.com/cli/latest/userguide/sso-configure-profile-legacy.html#sso-configure-profile-manual

        # > To manually add IAM Identity Center support to a named profile, you must add the
        # > following keys and values to the profile definition in the config file.
        # > - `sso_start_url`
        # > - `sso_region`
        # > - `sso_account_id`
        # > - `sso_role_name`

        sso_start_url = _get_profile_value(ini, profile, "sso_start_url")
        sso_region = _get_profile_value(ini, profile, "sso_region")

        if isnothing(sso_start_url)
            throw(
                InvalidAWSConfig(
                    "Profile \"$profile\" must define `sso_start_url` in order to " *
                    "request SSO credentials.",
                ),
            )
        elseif isnothing(sso_region)
            throw(
                InvalidAWSConfig(
                    "Profile \"$profile\" must define `sso_region` in order to " *
                    "request SSO credentials.",
                ),
            )
        end

        access_token = @mock _sso_cache_access_token(sso_start_url)
    end

    if isnothing(access_token)
        help_url = "https://docs.aws.amazon.com/cli/latest/userguide/cli-configure-sso.html#cli-configure-sso-login"
        error(
            "You must first sign in to a IAM Identity Center session via " *
            "`aws sso login --profile $profile`. See $help_url for more details.",
        )
    end

    headers = Dict{String,String}("x-amz-sso_bearer_token" => access_token)
    tmp_config = AWSConfig(; creds=nothing, region=sso_region)

    # https://docs.aws.amazon.com/singlesignon/latest/PortalAPIReference/API_GetRoleCredentials.html
    sso_creds = @mock AWSServices.sso(
        "GET",
        "/federation/credentials?account_id=$(sso_account_id)&role_name=$(sso_role_name)",
        Dict{String,Any}("headers" => headers),
        aws_config=tmp_config,
    )

    access_key = sso_creds["roleCredentials"]["accessKeyId"]
    secret_key = sso_creds["roleCredentials"]["secretAccessKey"]
    token = sso_creds["roleCredentials"]["sessionToken"]
    expiry = DateTime(
        Dates.UTM(Dates.UNIXEPOCH + sso_creds["roleCredentials"]["expiration"])
    )

    return (access_key, secret_key, token, expiry)
end

"""
    _read_credential_process(io::IO) -> NamedTuple

Parse the AWS CLI external process output out as defined in:
https://docs.aws.amazon.com/cli/latest/userguide/cli-configure-sourcing-external.html
"""
function _read_credential_process(io::IO)
    # `JSON.parse` chokes on `Base.Process` I/O streams.
    json = JSON.parse(read(io, String))

    version = json["Version"]
    if version != 1
        error(
            "Credential process returned unhandled version $version:\n",
            sprint(JSON.print, json, 2),
        )
    end

    access_key_id = json["AccessKeyId"]
    secret_access_key = json["SecretAccessKey"]

    # The presence of the "Expiration" key determines if the provided credentials are
    # long-term credentials or temporary credentials. Temporary credentials must include a
    # session token (https://docs.aws.amazon.com/IAM/latest/UserGuide/id_credentials_temp_use-resources.html)
    if haskey(json, "Expiration") || haskey(json, "SessionToken")
        expiration = parse(DateTime, json["Expiration"], dateformat"yyyy-mm-dd\THH:MM:SS\Z")
        session_token = json["SessionToken"]
    else
        expiration = nothing
        session_token = nothing
    end

    return @compat (; access_key_id, secret_access_key, session_token, expiration)
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: cognito_sync
using AWS.Compat
using AWS.UUIDs

"""
    bulk_publish(identity_pool_id)
    bulk_publish(identity_pool_id, params::Dict{String,<:Any})

Initiates a bulk publish of all existing datasets for an Identity Pool to the configured
stream. Customers are limited to one successful bulk publish per 24 hours. Bulk publish is
an asynchronous request, customers can see the status of the request via the
GetBulkPublishDetails operation.This API can only be called with developer credentials. You
cannot call this API with the temporary user credentials provided by Cognito Identity.

# Arguments
- `identity_pool_id`: A name-spaced GUID (for example,
  us-east-1:23EC4050-6AEA-7089-A2DD-08002EXAMPLE) created by Amazon Cognito. GUID generation
  is unique within a region.

"""
function bulk_publish(IdentityPoolId; aws_config::AbstractAWSConfig=current_aws_config())
    return cognito_sync(
        "POST",
        "/identitypools/$(IdentityPoolId)/bulkpublish";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function bulk_publish(
    IdentityPoolId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cognito_sync(
        "POST",
        "/identitypools/$(IdentityPoolId)/bulkpublish",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_dataset(dataset_name, identity_id, identity_pool_id)
    delete_dataset(dataset_name, identity_id, identity_pool_id, params::Dict{String,<:Any})

Deletes the specific dataset. The dataset will be deleted permanently, and the action can't
be undone. Datasets that this dataset was merged with will no longer report the merge. Any
subsequent operation on this dataset will result in a ResourceNotFoundException. This API
can be called with temporary user credentials provided by Cognito Identity or with
developer credentials.

# Arguments
- `dataset_name`: A string of up to 128 characters. Allowed characters are a-z, A-Z, 0-9,
  '_' (underscore), '-' (dash), and '.' (dot).
- `identity_id`: A name-spaced GUID (for example,
  us-east-1:23EC4050-6AEA-7089-A2DD-08002EXAMPLE) created by Amazon Cognito. GUID generation
  is unique within a region.
- `identity_pool_id`: A name-spaced GUID (for example,
  us-east-1:23EC4050-6AEA-7089-A2DD-08002EXAMPLE) created by Amazon Cognito. GUID generation
  is unique within a region.

"""
function delete_dataset(
    DatasetName,
    IdentityId,
    IdentityPoolId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cognito_sync(
        "DELETE",
        "/identitypools/$(IdentityPoolId)/identities/$(IdentityId)/datasets/$(DatasetName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_dataset(
    DatasetName,
    IdentityId,
    IdentityPoolId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cognito_sync(
        "DELETE",
        "/identitypools/$(IdentityPoolId)/identities/$(IdentityId)/datasets/$(DatasetName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_dataset(dataset_name, identity_id, identity_pool_id)
    describe_dataset(dataset_name, identity_id, identity_pool_id, params::Dict{String,<:Any})

Gets meta data about a dataset by identity and dataset name. With Amazon Cognito Sync, each
identity has access only to its own data. Thus, the credentials used to make this API call
need to have access to the identity data. This API can be called with temporary user
credentials provided by Cognito Identity or with developer credentials. You should use
Cognito Identity credentials to make this API call.

# Arguments
- `dataset_name`: A string of up to 128 characters. Allowed characters are a-z, A-Z, 0-9,
  '_' (underscore), '-' (dash), and '.' (dot).
- `identity_id`: A name-spaced GUID (for example,
  us-east-1:23EC4050-6AEA-7089-A2DD-08002EXAMPLE) created by Amazon Cognito. GUID generation
  is unique within a region.
- `identity_pool_id`: A name-spaced GUID (for example,
  us-east-1:23EC4050-6AEA-7089-A2DD-08002EXAMPLE) created by Amazon Cognito. GUID generation
  is unique within a region.

"""
function describe_dataset(
    DatasetName,
    IdentityId,
    IdentityPoolId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cognito_sync(
        "GET",
        "/identitypools/$(IdentityPoolId)/identities/$(IdentityId)/datasets/$(DatasetName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_dataset(
    DatasetName,
    IdentityId,
    IdentityPoolId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cognito_sync(
        "GET",
        "/identitypools/$(IdentityPoolId)/identities/$(IdentityId)/datasets/$(DatasetName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_identity_pool_usage(identity_pool_id)
    describe_identity_pool_usage(identity_pool_id, params::Dict{String,<:Any})

Gets usage details (for example, data storage) about a particular identity pool. This API
can only be called with developer credentials. You cannot call this API with the temporary
user credentials provided by Cognito Identity.

# Arguments
- `identity_pool_id`: A name-spaced GUID (for example,
  us-east-1:23EC4050-6AEA-7089-A2DD-08002EXAMPLE) created by Amazon Cognito. GUID generation
  is unique within a region.

"""
function describe_identity_pool_usage(
    IdentityPoolId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cognito_sync(
        "GET",
        "/identitypools/$(IdentityPoolId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_identity_pool_usage(
    IdentityPoolId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cognito_sync(
        "GET",
        "/identitypools/$(IdentityPoolId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_identity_usage(identity_id, identity_pool_id)
    describe_identity_usage(identity_id, identity_pool_id, params::Dict{String,<:Any})

Gets usage information for an identity, including number of datasets and data usage. This
API can be called with temporary user credentials provided by Cognito Identity or with
developer credentials.

# Arguments
- `identity_id`: A name-spaced GUID (for example,
  us-east-1:23EC4050-6AEA-7089-A2DD-08002EXAMPLE) created by Amazon Cognito. GUID generation
  is unique within a region.
- `identity_pool_id`: A name-spaced GUID (for example,
  us-east-1:23EC4050-6AEA-7089-A2DD-08002EXAMPLE) created by Amazon Cognito. GUID generation
  is unique within a region.

"""
function describe_identity_usage(
    IdentityId, IdentityPoolId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cognito_sync(
        "GET",
        "/identitypools/$(IdentityPoolId)/identities/$(IdentityId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_identity_usage(
    IdentityId,
    IdentityPoolId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cognito_sync(
        "GET",
        "/identitypools/$(IdentityPoolId)/identities/$(IdentityId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_bulk_publish_details(identity_pool_id)
    get_bulk_publish_details(identity_pool_id, params::Dict{String,<:Any})

Get the status of the last BulkPublish operation for an identity pool.This API can only be
called with developer credentials. You cannot call this API with the temporary user
credentials provided by Cognito Identity.

# Arguments
- `identity_pool_id`: A name-spaced GUID (for example,
  us-east-1:23EC4050-6AEA-7089-A2DD-08002EXAMPLE) created by Amazon Cognito. GUID generation
  is unique within a region.

"""
function get_bulk_publish_details(
    IdentityPoolId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cognito_sync(
        "POST",
        "/identitypools/$(IdentityPoolId)/getBulkPublishDetails";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_bulk_publish_details(
    IdentityPoolId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cognito_sync(
        "POST",
        "/identitypools/$(IdentityPoolId)/getBulkPublishDetails",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_cognito_events(identity_pool_id)
    get_cognito_events(identity_pool_id, params::Dict{String,<:Any})

Gets the events and the corresponding Lambda functions associated with an identity
pool.This API can only be called with developer credentials. You cannot call this API with
the temporary user credentials provided by Cognito Identity.

# Arguments
- `identity_pool_id`: The Cognito Identity Pool ID for the request

"""
function get_cognito_events(
    IdentityPoolId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cognito_sync(
        "GET",
        "/identitypools/$(IdentityPoolId)/events";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_cognito_events(
    IdentityPoolId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cognito_sync(
        "GET",
        "/identitypools/$(IdentityPoolId)/events",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_identity_pool_configuration(identity_pool_id)
    get_identity_pool_configuration(identity_pool_id, params::Dict{String,<:Any})

Gets the configuration settings of an identity pool.This API can only be called with
developer credentials. You cannot call this API with the temporary user credentials
provided by Cognito Identity.

# Arguments
- `identity_pool_id`: A name-spaced GUID (for example,
  us-east-1:23EC4050-6AEA-7089-A2DD-08002EXAMPLE) created by Amazon Cognito. This is the ID
  of the pool for which to return a configuration.

"""
function get_identity_pool_configuration(
    IdentityPoolId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cognito_sync(
        "GET",
        "/identitypools/$(IdentityPoolId)/configuration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_identity_pool_configuration(
    IdentityPoolId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cognito_sync(
        "GET",
        "/identitypools/$(IdentityPoolId)/configuration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_datasets(identity_id, identity_pool_id)
    list_datasets(identity_id, identity_pool_id, params::Dict{String,<:Any})

Lists datasets for an identity. With Amazon Cognito Sync, each identity has access only to
its own data. Thus, the credentials used to make this API call need to have access to the
identity data. ListDatasets can be called with temporary user credentials provided by
Cognito Identity or with developer credentials. You should use the Cognito Identity
credentials to make this API call.

# Arguments
- `identity_id`: A name-spaced GUID (for example,
  us-east-1:23EC4050-6AEA-7089-A2DD-08002EXAMPLE) created by Amazon Cognito. GUID generation
  is unique within a region.
- `identity_pool_id`: A name-spaced GUID (for example,
  us-east-1:23EC4050-6AEA-7089-A2DD-08002EXAMPLE) created by Amazon Cognito. GUID generation
  is unique within a region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to be returned.
- `"nextToken"`: A pagination token for obtaining the next page of results.
"""
function list_datasets(
    IdentityId, IdentityPoolId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cognito_sync(
        "GET",
        "/identitypools/$(IdentityPoolId)/identities/$(IdentityId)/datasets";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_datasets(
    IdentityId,
    IdentityPoolId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cognito_sync(
        "GET",
        "/identitypools/$(IdentityPoolId)/identities/$(IdentityId)/datasets",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_identity_pool_usage()
    list_identity_pool_usage(params::Dict{String,<:Any})

Gets a list of identity pools registered with Cognito. ListIdentityPoolUsage can only be
called with developer credentials. You cannot make this API call with the temporary user
credentials provided by Cognito Identity.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to be returned.
- `"nextToken"`: A pagination token for obtaining the next page of results.
"""
function list_identity_pool_usage(; aws_config::AbstractAWSConfig=current_aws_config())
    return cognito_sync(
        "GET", "/identitypools"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_identity_pool_usage(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cognito_sync(
        "GET",
        "/identitypools",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_records(dataset_name, identity_id, identity_pool_id)
    list_records(dataset_name, identity_id, identity_pool_id, params::Dict{String,<:Any})

Gets paginated records, optionally changed after a particular sync count for a dataset and
identity. With Amazon Cognito Sync, each identity has access only to its own data. Thus,
the credentials used to make this API call need to have access to the identity data.
ListRecords can be called with temporary user credentials provided by Cognito Identity or
with developer credentials. You should use Cognito Identity credentials to make this API
call.

# Arguments
- `dataset_name`: A string of up to 128 characters. Allowed characters are a-z, A-Z, 0-9,
  '_' (underscore), '-' (dash), and '.' (dot).
- `identity_id`: A name-spaced GUID (for example,
  us-east-1:23EC4050-6AEA-7089-A2DD-08002EXAMPLE) created by Amazon Cognito. GUID generation
  is unique within a region.
- `identity_pool_id`: A name-spaced GUID (for example,
  us-east-1:23EC4050-6AEA-7089-A2DD-08002EXAMPLE) created by Amazon Cognito. GUID generation
  is unique within a region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"lastSyncCount"`: The last server sync count for this record.
- `"maxResults"`: The maximum number of results to be returned.
- `"nextToken"`: A pagination token for obtaining the next page of results.
- `"syncSessionToken"`: A token containing a session ID, identity ID, and expiration.
"""
function list_records(
    DatasetName,
    IdentityId,
    IdentityPoolId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cognito_sync(
        "GET",
        "/identitypools/$(IdentityPoolId)/identities/$(IdentityId)/datasets/$(DatasetName)/records";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_records(
    DatasetName,
    IdentityId,
    IdentityPoolId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cognito_sync(
        "GET",
        "/identitypools/$(IdentityPoolId)/identities/$(IdentityId)/datasets/$(DatasetName)/records",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    register_device(identity_id, identity_pool_id, platform, token)
    register_device(identity_id, identity_pool_id, platform, token, params::Dict{String,<:Any})

Registers a device to receive push sync notifications.This API can only be called with
temporary credentials provided by Cognito Identity. You cannot call this API with developer
credentials.

# Arguments
- `identity_id`: The unique ID for this identity.
- `identity_pool_id`: A name-spaced GUID (for example,
  us-east-1:23EC4050-6AEA-7089-A2DD-08002EXAMPLE) created by Amazon Cognito. Here, the ID of
  the pool that the identity belongs to.
- `platform`: The SNS platform type (e.g. GCM, SDM, APNS, APNS_SANDBOX).
- `token`: The push token.

"""
function register_device(
    IdentityId,
    IdentityPoolId,
    Platform,
    Token;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cognito_sync(
        "POST",
        "/identitypools/$(IdentityPoolId)/identity/$(IdentityId)/device",
        Dict{String,Any}("Platform" => Platform, "Token" => Token);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function register_device(
    IdentityId,
    IdentityPoolId,
    Platform,
    Token,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cognito_sync(
        "POST",
        "/identitypools/$(IdentityPoolId)/identity/$(IdentityId)/device",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("Platform" => Platform, "Token" => Token), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    set_cognito_events(events, identity_pool_id)
    set_cognito_events(events, identity_pool_id, params::Dict{String,<:Any})

Sets the AWS Lambda function for a given event type for an identity pool. This request only
updates the key/value pair specified. Other key/values pairs are not updated. To remove a
key value pair, pass a empty value for the particular key.This API can only be called with
developer credentials. You cannot call this API with the temporary user credentials
provided by Cognito Identity.

# Arguments
- `events`: The events to configure
- `identity_pool_id`: The Cognito Identity Pool to use when configuring Cognito Events

"""
function set_cognito_events(
    Events, IdentityPoolId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cognito_sync(
        "POST",
        "/identitypools/$(IdentityPoolId)/events",
        Dict{String,Any}("Events" => Events);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function set_cognito_events(
    Events,
    IdentityPoolId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cognito_sync(
        "POST",
        "/identitypools/$(IdentityPoolId)/events",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Events" => Events), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    set_identity_pool_configuration(identity_pool_id)
    set_identity_pool_configuration(identity_pool_id, params::Dict{String,<:Any})

Sets the necessary configuration for push sync.This API can only be called with developer
credentials. You cannot call this API with the temporary user credentials provided by
Cognito Identity.

# Arguments
- `identity_pool_id`: A name-spaced GUID (for example,
  us-east-1:23EC4050-6AEA-7089-A2DD-08002EXAMPLE) created by Amazon Cognito. This is the ID
  of the pool to modify.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CognitoStreams"`: Options to apply to this identity pool for Amazon Cognito streams.
- `"PushSync"`: Options to apply to this identity pool for push synchronization.
"""
function set_identity_pool_configuration(
    IdentityPoolId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cognito_sync(
        "POST",
        "/identitypools/$(IdentityPoolId)/configuration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function set_identity_pool_configuration(
    IdentityPoolId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cognito_sync(
        "POST",
        "/identitypools/$(IdentityPoolId)/configuration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    subscribe_to_dataset(dataset_name, device_id, identity_id, identity_pool_id)
    subscribe_to_dataset(dataset_name, device_id, identity_id, identity_pool_id, params::Dict{String,<:Any})

Subscribes to receive notifications when a dataset is modified by another device.This API
can only be called with temporary credentials provided by Cognito Identity. You cannot call
this API with developer credentials.

# Arguments
- `dataset_name`: The name of the dataset to subcribe to.
- `device_id`: The unique ID generated for this device by Cognito.
- `identity_id`: Unique ID for this identity.
- `identity_pool_id`: A name-spaced GUID (for example,
  us-east-1:23EC4050-6AEA-7089-A2DD-08002EXAMPLE) created by Amazon Cognito. The ID of the
  pool to which the identity belongs.

"""
function subscribe_to_dataset(
    DatasetName,
    DeviceId,
    IdentityId,
    IdentityPoolId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cognito_sync(
        "POST",
        "/identitypools/$(IdentityPoolId)/identities/$(IdentityId)/datasets/$(DatasetName)/subscriptions/$(DeviceId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function subscribe_to_dataset(
    DatasetName,
    DeviceId,
    IdentityId,
    IdentityPoolId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cognito_sync(
        "POST",
        "/identitypools/$(IdentityPoolId)/identities/$(IdentityId)/datasets/$(DatasetName)/subscriptions/$(DeviceId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    unsubscribe_from_dataset(dataset_name, device_id, identity_id, identity_pool_id)
    unsubscribe_from_dataset(dataset_name, device_id, identity_id, identity_pool_id, params::Dict{String,<:Any})

Unsubscribes from receiving notifications when a dataset is modified by another device.This
API can only be called with temporary credentials provided by Cognito Identity. You cannot
call this API with developer credentials.

# Arguments
- `dataset_name`: The name of the dataset from which to unsubcribe.
- `device_id`: The unique ID generated for this device by Cognito.
- `identity_id`: Unique ID for this identity.
- `identity_pool_id`: A name-spaced GUID (for example,
  us-east-1:23EC4050-6AEA-7089-A2DD-08002EXAMPLE) created by Amazon Cognito. The ID of the
  pool to which this identity belongs.

"""
function unsubscribe_from_dataset(
    DatasetName,
    DeviceId,
    IdentityId,
    IdentityPoolId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cognito_sync(
        "DELETE",
        "/identitypools/$(IdentityPoolId)/identities/$(IdentityId)/datasets/$(DatasetName)/subscriptions/$(DeviceId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function unsubscribe_from_dataset(
    DatasetName,
    DeviceId,
    IdentityId,
    IdentityPoolId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cognito_sync(
        "DELETE",
        "/identitypools/$(IdentityPoolId)/identities/$(IdentityId)/datasets/$(DatasetName)/subscriptions/$(DeviceId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_records(dataset_name, identity_id, identity_pool_id, sync_session_token)
    update_records(dataset_name, identity_id, identity_pool_id, sync_session_token, params::Dict{String,<:Any})

Posts updates to records and adds and deletes records for a dataset and user. The sync
count in the record patch is your last known sync count for that record. The server will
reject an UpdateRecords request with a ResourceConflictException if you try to patch a
record with a new value but a stale sync count.For example, if the sync count on the server
is 5 for a key called highScore and you try and submit a new highScore with sync count of
4, the request will be rejected. To obtain the current sync count for a record, call
ListRecords. On a successful update of the record, the response returns the new sync count
for that record. You should present that sync count the next time you try to update that
same record. When the record does not exist, specify the sync count as 0. This API can be
called with temporary user credentials provided by Cognito Identity or with developer
credentials.

# Arguments
- `dataset_name`: A string of up to 128 characters. Allowed characters are a-z, A-Z, 0-9,
  '_' (underscore), '-' (dash), and '.' (dot).
- `identity_id`: A name-spaced GUID (for example,
  us-east-1:23EC4050-6AEA-7089-A2DD-08002EXAMPLE) created by Amazon Cognito. GUID generation
  is unique within a region.
- `identity_pool_id`: A name-spaced GUID (for example,
  us-east-1:23EC4050-6AEA-7089-A2DD-08002EXAMPLE) created by Amazon Cognito. GUID generation
  is unique within a region.
- `sync_session_token`: The SyncSessionToken returned by a previous call to ListRecords for
  this dataset and identity.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DeviceId"`: The unique ID generated for this device by Cognito.
- `"RecordPatches"`: A list of patch operations.
- `"x-amz-Client-Context"`: Intended to supply a device ID that will populate the
  lastModifiedBy field referenced in other methods. The ClientContext field is not yet
  implemented.
"""
function update_records(
    DatasetName,
    IdentityId,
    IdentityPoolId,
    SyncSessionToken;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cognito_sync(
        "POST",
        "/identitypools/$(IdentityPoolId)/identities/$(IdentityId)/datasets/$(DatasetName)",
        Dict{String,Any}("SyncSessionToken" => SyncSessionToken);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_records(
    DatasetName,
    IdentityId,
    IdentityPoolId,
    SyncSessionToken,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cognito_sync(
        "POST",
        "/identitypools/$(IdentityPoolId)/identities/$(IdentityId)/datasets/$(DatasetName)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("SyncSessionToken" => SyncSessionToken), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: osis
using AWS.Compat
using AWS.UUIDs

"""
    create_pipeline(max_units, min_units, pipeline_configuration_body, pipeline_name)
    create_pipeline(max_units, min_units, pipeline_configuration_body, pipeline_name, params::Dict{String,<:Any})

Creates an OpenSearch Ingestion pipeline. For more information, see Creating Amazon
OpenSearch Ingestion pipelines.

# Arguments
- `max_units`: The maximum pipeline capacity, in Ingestion Compute Units (ICUs).
- `min_units`: The minimum pipeline capacity, in Ingestion Compute Units (ICUs).
- `pipeline_configuration_body`: The pipeline configuration in YAML format. The command
  accepts the pipeline configuration as a string or within a .yaml file. If you provide the
  configuration as a string, each new line must be escaped with n.
- `pipeline_name`: The name of the OpenSearch Ingestion pipeline to create. Pipeline names
  are unique across the pipelines owned by an account within an Amazon Web Services Region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"BufferOptions"`: Key-value pairs to configure persistent buffering for the pipeline.
- `"EncryptionAtRestOptions"`: Key-value pairs to configure encryption for data that is
  written to a persistent buffer.
- `"LogPublishingOptions"`: Key-value pairs to configure log publishing.
- `"Tags"`: List of tags to add to the pipeline upon creation.
- `"VpcOptions"`: Container for the values required to configure VPC access for the
  pipeline. If you don't specify these values, OpenSearch Ingestion creates the pipeline with
  a public endpoint.
"""
function create_pipeline(
    MaxUnits,
    MinUnits,
    PipelineConfigurationBody,
    PipelineName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return osis(
        "POST",
        "/2022-01-01/osis/createPipeline",
        Dict{String,Any}(
            "MaxUnits" => MaxUnits,
            "MinUnits" => MinUnits,
            "PipelineConfigurationBody" => PipelineConfigurationBody,
            "PipelineName" => PipelineName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_pipeline(
    MaxUnits,
    MinUnits,
    PipelineConfigurationBody,
    PipelineName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return osis(
        "POST",
        "/2022-01-01/osis/createPipeline",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "MaxUnits" => MaxUnits,
                    "MinUnits" => MinUnits,
                    "PipelineConfigurationBody" => PipelineConfigurationBody,
                    "PipelineName" => PipelineName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_pipeline(pipeline_name)
    delete_pipeline(pipeline_name, params::Dict{String,<:Any})

Deletes an OpenSearch Ingestion pipeline. For more information, see Deleting Amazon
OpenSearch Ingestion pipelines.

# Arguments
- `pipeline_name`: The name of the pipeline to delete.

"""
function delete_pipeline(PipelineName; aws_config::AbstractAWSConfig=current_aws_config())
    return osis(
        "DELETE",
        "/2022-01-01/osis/deletePipeline/$(PipelineName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_pipeline(
    PipelineName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return osis(
        "DELETE",
        "/2022-01-01/osis/deletePipeline/$(PipelineName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_pipeline(pipeline_name)
    get_pipeline(pipeline_name, params::Dict{String,<:Any})

Retrieves information about an OpenSearch Ingestion pipeline.

# Arguments
- `pipeline_name`: The name of the pipeline.

"""
function get_pipeline(PipelineName; aws_config::AbstractAWSConfig=current_aws_config())
    return osis(
        "GET",
        "/2022-01-01/osis/getPipeline/$(PipelineName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_pipeline(
    PipelineName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return osis(
        "GET",
        "/2022-01-01/osis/getPipeline/$(PipelineName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_pipeline_blueprint(blueprint_name)
    get_pipeline_blueprint(blueprint_name, params::Dict{String,<:Any})

Retrieves information about a specific blueprint for OpenSearch Ingestion. Blueprints are
templates for the configuration needed for a CreatePipeline request. For more information,
see Using blueprints to create a pipeline.

# Arguments
- `blueprint_name`: The name of the blueprint to retrieve.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"format"`: The format format of the blueprint to retrieve.
"""
function get_pipeline_blueprint(
    BlueprintName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return osis(
        "GET",
        "/2022-01-01/osis/getPipelineBlueprint/$(BlueprintName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_pipeline_blueprint(
    BlueprintName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return osis(
        "GET",
        "/2022-01-01/osis/getPipelineBlueprint/$(BlueprintName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_pipeline_change_progress(pipeline_name)
    get_pipeline_change_progress(pipeline_name, params::Dict{String,<:Any})

Returns progress information for the current change happening on an OpenSearch Ingestion
pipeline. Currently, this operation only returns information when a pipeline is being
created. For more information, see Tracking the status of pipeline creation.

# Arguments
- `pipeline_name`: The name of the pipeline.

"""
function get_pipeline_change_progress(
    PipelineName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return osis(
        "GET",
        "/2022-01-01/osis/getPipelineChangeProgress/$(PipelineName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_pipeline_change_progress(
    PipelineName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return osis(
        "GET",
        "/2022-01-01/osis/getPipelineChangeProgress/$(PipelineName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_pipeline_blueprints()
    list_pipeline_blueprints(params::Dict{String,<:Any})

Retrieves a list of all available blueprints for Data Prepper. For more information, see
Using blueprints to create a pipeline.

"""
function list_pipeline_blueprints(; aws_config::AbstractAWSConfig=current_aws_config())
    return osis(
        "POST",
        "/2022-01-01/osis/listPipelineBlueprints";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_pipeline_blueprints(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return osis(
        "POST",
        "/2022-01-01/osis/listPipelineBlueprints",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_pipelines()
    list_pipelines(params::Dict{String,<:Any})

Lists all OpenSearch Ingestion pipelines in the current Amazon Web Services account and
Region. For more information, see Viewing Amazon OpenSearch Ingestion pipelines.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: An optional parameter that specifies the maximum number of results to
  return. You can use nextToken to get the next page of results.
- `"nextToken"`: If your initial ListPipelines operation returns a nextToken, you can
  include the returned nextToken in subsequent ListPipelines operations, which returns
  results in the next page.
"""
function list_pipelines(; aws_config::AbstractAWSConfig=current_aws_config())
    return osis(
        "GET",
        "/2022-01-01/osis/listPipelines";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_pipelines(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return osis(
        "GET",
        "/2022-01-01/osis/listPipelines",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(arn)
    list_tags_for_resource(arn, params::Dict{String,<:Any})

Lists all resource tags associated with an OpenSearch Ingestion pipeline. For more
information, see Tagging Amazon OpenSearch Ingestion pipelines.

# Arguments
- `arn`: The Amazon Resource Name (ARN) of the pipeline to retrieve tags for.

"""
function list_tags_for_resource(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return osis(
        "GET",
        "/2022-01-01/osis/listTagsForResource/",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return osis(
        "GET",
        "/2022-01-01/osis/listTagsForResource/",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_pipeline(pipeline_name)
    start_pipeline(pipeline_name, params::Dict{String,<:Any})

Starts an OpenSearch Ingestion pipeline. For more information, see Starting an OpenSearch
Ingestion pipeline.

# Arguments
- `pipeline_name`: The name of the pipeline to start.

"""
function start_pipeline(PipelineName; aws_config::AbstractAWSConfig=current_aws_config())
    return osis(
        "PUT",
        "/2022-01-01/osis/startPipeline/$(PipelineName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_pipeline(
    PipelineName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return osis(
        "PUT",
        "/2022-01-01/osis/startPipeline/$(PipelineName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_pipeline(pipeline_name)
    stop_pipeline(pipeline_name, params::Dict{String,<:Any})

Stops an OpenSearch Ingestion pipeline. For more information, see Stopping an OpenSearch
Ingestion pipeline.

# Arguments
- `pipeline_name`: The name of the pipeline to stop.

"""
function stop_pipeline(PipelineName; aws_config::AbstractAWSConfig=current_aws_config())
    return osis(
        "PUT",
        "/2022-01-01/osis/stopPipeline/$(PipelineName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_pipeline(
    PipelineName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return osis(
        "PUT",
        "/2022-01-01/osis/stopPipeline/$(PipelineName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(tags, arn)
    tag_resource(tags, arn, params::Dict{String,<:Any})

Tags an OpenSearch Ingestion pipeline. For more information, see Tagging Amazon OpenSearch
Ingestion pipelines.

# Arguments
- `tags`: The list of key-value tags to add to the pipeline.
- `arn`: The Amazon Resource Name (ARN) of the pipeline to tag.

"""
function tag_resource(Tags, arn; aws_config::AbstractAWSConfig=current_aws_config())
    return osis(
        "POST",
        "/2022-01-01/osis/tagResource/",
        Dict{String,Any}("Tags" => Tags, "arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    Tags,
    arn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return osis(
        "POST",
        "/2022-01-01/osis/tagResource/",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Tags" => Tags, "arn" => arn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(tag_keys, arn)
    untag_resource(tag_keys, arn, params::Dict{String,<:Any})

Removes one or more tags from an OpenSearch Ingestion pipeline. For more information, see
Tagging Amazon OpenSearch Ingestion pipelines.

# Arguments
- `tag_keys`: The tag keys to remove.
- `arn`: The Amazon Resource Name (ARN) of the pipeline to remove tags from.

"""
function untag_resource(TagKeys, arn; aws_config::AbstractAWSConfig=current_aws_config())
    return osis(
        "POST",
        "/2022-01-01/osis/untagResource/",
        Dict{String,Any}("TagKeys" => TagKeys, "arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    TagKeys,
    arn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return osis(
        "POST",
        "/2022-01-01/osis/untagResource/",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TagKeys" => TagKeys, "arn" => arn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_pipeline(pipeline_name)
    update_pipeline(pipeline_name, params::Dict{String,<:Any})

Updates an OpenSearch Ingestion pipeline. For more information, see Updating Amazon
OpenSearch Ingestion pipelines.

# Arguments
- `pipeline_name`: The name of the pipeline to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"BufferOptions"`: Key-value pairs to configure persistent buffering for the pipeline.
- `"EncryptionAtRestOptions"`: Key-value pairs to configure encryption for data that is
  written to a persistent buffer.
- `"LogPublishingOptions"`: Key-value pairs to configure log publishing.
- `"MaxUnits"`: The maximum pipeline capacity, in Ingestion Compute Units (ICUs)
- `"MinUnits"`: The minimum pipeline capacity, in Ingestion Compute Units (ICUs).
- `"PipelineConfigurationBody"`: The pipeline configuration in YAML format. The command
  accepts the pipeline configuration as a string or within a .yaml file. If you provide the
  configuration as a string, each new line must be escaped with n.
"""
function update_pipeline(PipelineName; aws_config::AbstractAWSConfig=current_aws_config())
    return osis(
        "PUT",
        "/2022-01-01/osis/updatePipeline/$(PipelineName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_pipeline(
    PipelineName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return osis(
        "PUT",
        "/2022-01-01/osis/updatePipeline/$(PipelineName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    validate_pipeline(pipeline_configuration_body)
    validate_pipeline(pipeline_configuration_body, params::Dict{String,<:Any})

Checks whether an OpenSearch Ingestion pipeline configuration is valid prior to creation.
For more information, see Creating Amazon OpenSearch Ingestion pipelines.

# Arguments
- `pipeline_configuration_body`: The pipeline configuration in YAML format. The command
  accepts the pipeline configuration as a string or within a .yaml file. If you provide the
  configuration as a string, each new line must be escaped with n.

"""
function validate_pipeline(
    PipelineConfigurationBody; aws_config::AbstractAWSConfig=current_aws_config()
)
    return osis(
        "POST",
        "/2022-01-01/osis/validatePipeline",
        Dict{String,Any}("PipelineConfigurationBody" => PipelineConfigurationBody);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function validate_pipeline(
    PipelineConfigurationBody,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return osis(
        "POST",
        "/2022-01-01/osis/validatePipeline",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("PipelineConfigurationBody" => PipelineConfigurationBody),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: managedblockchain
using AWS.Compat
using AWS.UUIDs

"""
    create_accessor(accessor_type, client_request_token)
    create_accessor(accessor_type, client_request_token, params::Dict{String,<:Any})

Creates a new accessor for use with Amazon Managed Blockchain service that supports token
based access. The accessor contains information required for token based access.

# Arguments
- `accessor_type`: The type of accessor.  Currently, accessor type is restricted to
  BILLING_TOKEN.
- `client_request_token`: This is a unique, case-sensitive identifier that you provide to
  ensure the idempotency of the operation. An idempotent operation completes no more than
  once. This identifier is required only if you make a service request directly using an HTTP
  client. It is generated automatically if you use an Amazon Web Services SDK or the Amazon
  Web Services CLI.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NetworkType"`: The blockchain network that the Accessor token is created for.    Use
  the actual networkType value for the blockchain network that you are creating the Accessor
  token for.   With the shut down of the Ethereum Goerli and Polygon Mumbai Testnet networks
  the following networkType values are no longer available for selection and use.
  ETHEREUM_MAINNET_AND_GOERLI     ETHEREUM_GOERLI     POLYGON_MUMBAI    However, your
  existing Accessor tokens with these networkType values will remain unchanged.
- `"Tags"`: Tags to assign to the Accessor.  Each tag consists of a key and an optional
  value. You can specify multiple key-value pairs in a single request with an overall maximum
  of 50 tags allowed per resource. For more information about tags, see Tagging Resources in
  the Amazon Managed Blockchain Ethereum Developer Guide, or Tagging Resources in the Amazon
  Managed Blockchain Hyperledger Fabric Developer Guide.
"""
function create_accessor(
    AccessorType, ClientRequestToken; aws_config::AbstractAWSConfig=current_aws_config()
)
    return managedblockchain(
        "POST",
        "/accessors",
        Dict{String,Any}(
            "AccessorType" => AccessorType, "ClientRequestToken" => ClientRequestToken
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_accessor(
    AccessorType,
    ClientRequestToken,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return managedblockchain(
        "POST",
        "/accessors",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AccessorType" => AccessorType,
                    "ClientRequestToken" => ClientRequestToken,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_member(client_request_token, invitation_id, member_configuration, network_id)
    create_member(client_request_token, invitation_id, member_configuration, network_id, params::Dict{String,<:Any})

Creates a member within a Managed Blockchain network. Applies only to Hyperledger Fabric.

# Arguments
- `client_request_token`: A unique, case-sensitive identifier that you provide to ensure
  the idempotency of the operation. An idempotent operation completes no more than one time.
  This identifier is required only if you make a service request directly using an HTTP
  client. It is generated automatically if you use an Amazon Web Services SDK or the CLI.
- `invitation_id`: The unique identifier of the invitation that is sent to the member to
  join the network.
- `member_configuration`: Member configuration parameters.
- `network_id`: The unique identifier of the network in which the member is created.

"""
function create_member(
    ClientRequestToken,
    InvitationId,
    MemberConfiguration,
    networkId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return managedblockchain(
        "POST",
        "/networks/$(networkId)/members",
        Dict{String,Any}(
            "ClientRequestToken" => ClientRequestToken,
            "InvitationId" => InvitationId,
            "MemberConfiguration" => MemberConfiguration,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_member(
    ClientRequestToken,
    InvitationId,
    MemberConfiguration,
    networkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return managedblockchain(
        "POST",
        "/networks/$(networkId)/members",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClientRequestToken" => ClientRequestToken,
                    "InvitationId" => InvitationId,
                    "MemberConfiguration" => MemberConfiguration,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_network(client_request_token, framework, framework_version, member_configuration, name, voting_policy)
    create_network(client_request_token, framework, framework_version, member_configuration, name, voting_policy, params::Dict{String,<:Any})

Creates a new blockchain network using Amazon Managed Blockchain. Applies only to
Hyperledger Fabric.

# Arguments
- `client_request_token`: This is a unique, case-sensitive identifier that you provide to
  ensure the idempotency of the operation. An idempotent operation completes no more than
  once. This identifier is required only if you make a service request directly using an HTTP
  client. It is generated automatically if you use an Amazon Web Services SDK or the Amazon
  Web Services CLI.
- `framework`: The blockchain framework that the network uses.
- `framework_version`: The version of the blockchain framework that the network uses.
- `member_configuration`: Configuration properties for the first member within the network.
- `name`: The name of the network.
- `voting_policy`:  The voting rules used by the network to determine if a proposal is
  approved.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: An optional description for the network.
- `"FrameworkConfiguration"`:  Configuration properties of the blockchain framework
  relevant to the network configuration.
- `"Tags"`: Tags to assign to the network.  Each tag consists of a key and an optional
  value. You can specify multiple key-value pairs in a single request with an overall maximum
  of 50 tags allowed per resource. For more information about tags, see Tagging Resources in
  the Amazon Managed Blockchain Ethereum Developer Guide, or Tagging Resources in the Amazon
  Managed Blockchain Hyperledger Fabric Developer Guide.
"""
function create_network(
    ClientRequestToken,
    Framework,
    FrameworkVersion,
    MemberConfiguration,
    Name,
    VotingPolicy;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return managedblockchain(
        "POST",
        "/networks",
        Dict{String,Any}(
            "ClientRequestToken" => ClientRequestToken,
            "Framework" => Framework,
            "FrameworkVersion" => FrameworkVersion,
            "MemberConfiguration" => MemberConfiguration,
            "Name" => Name,
            "VotingPolicy" => VotingPolicy,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_network(
    ClientRequestToken,
    Framework,
    FrameworkVersion,
    MemberConfiguration,
    Name,
    VotingPolicy,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return managedblockchain(
        "POST",
        "/networks",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClientRequestToken" => ClientRequestToken,
                    "Framework" => Framework,
                    "FrameworkVersion" => FrameworkVersion,
                    "MemberConfiguration" => MemberConfiguration,
                    "Name" => Name,
                    "VotingPolicy" => VotingPolicy,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_node(client_request_token, node_configuration, network_id)
    create_node(client_request_token, node_configuration, network_id, params::Dict{String,<:Any})

Creates a node on the specified blockchain network. Applies to Hyperledger Fabric and
Ethereum.

# Arguments
- `client_request_token`: A unique, case-sensitive identifier that you provide to ensure
  the idempotency of the operation. An idempotent operation completes no more than one time.
  This identifier is required only if you make a service request directly using an HTTP
  client. It is generated automatically if you use an Amazon Web Services SDK or the CLI.
- `node_configuration`: The properties of a node configuration.
- `network_id`: The unique identifier of the network for the node. Ethereum public networks
  have the following NetworkIds:    n-ethereum-mainnet

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MemberId"`: The unique identifier of the member that owns this node. Applies only to
  Hyperledger Fabric.
- `"Tags"`: Tags to assign to the node.  Each tag consists of a key and an optional value.
  You can specify multiple key-value pairs in a single request with an overall maximum of 50
  tags allowed per resource. For more information about tags, see Tagging Resources in the
  Amazon Managed Blockchain Ethereum Developer Guide, or Tagging Resources in the Amazon
  Managed Blockchain Hyperledger Fabric Developer Guide.
"""
function create_node(
    ClientRequestToken,
    NodeConfiguration,
    networkId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return managedblockchain(
        "POST",
        "/networks/$(networkId)/nodes",
        Dict{String,Any}(
            "ClientRequestToken" => ClientRequestToken,
            "NodeConfiguration" => NodeConfiguration,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_node(
    ClientRequestToken,
    NodeConfiguration,
    networkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return managedblockchain(
        "POST",
        "/networks/$(networkId)/nodes",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClientRequestToken" => ClientRequestToken,
                    "NodeConfiguration" => NodeConfiguration,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_proposal(actions, client_request_token, member_id, network_id)
    create_proposal(actions, client_request_token, member_id, network_id, params::Dict{String,<:Any})

Creates a proposal for a change to the network that other members of the network can vote
on, for example, a proposal to add a new member to the network. Any member can create a
proposal. Applies only to Hyperledger Fabric.

# Arguments
- `actions`: The type of actions proposed, such as inviting a member or removing a member.
  The types of Actions in a proposal are mutually exclusive. For example, a proposal with
  Invitations actions cannot also contain Removals actions.
- `client_request_token`: A unique, case-sensitive identifier that you provide to ensure
  the idempotency of the operation. An idempotent operation completes no more than one time.
  This identifier is required only if you make a service request directly using an HTTP
  client. It is generated automatically if you use an Amazon Web Services SDK or the CLI.
- `member_id`: The unique identifier of the member that is creating the proposal. This
  identifier is especially useful for identifying the member making the proposal when
  multiple members exist in a single Amazon Web Services account.
- `network_id`:  The unique identifier of the network for which the proposal is made.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description for the proposal that is visible to voting members, for
  example, \"Proposal to add Example Corp. as member.\"
- `"Tags"`: Tags to assign to the proposal.  Each tag consists of a key and an optional
  value. You can specify multiple key-value pairs in a single request with an overall maximum
  of 50 tags allowed per resource. For more information about tags, see Tagging Resources in
  the Amazon Managed Blockchain Ethereum Developer Guide, or Tagging Resources in the Amazon
  Managed Blockchain Hyperledger Fabric Developer Guide.
"""
function create_proposal(
    Actions,
    ClientRequestToken,
    MemberId,
    networkId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return managedblockchain(
        "POST",
        "/networks/$(networkId)/proposals",
        Dict{String,Any}(
            "Actions" => Actions,
            "ClientRequestToken" => ClientRequestToken,
            "MemberId" => MemberId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_proposal(
    Actions,
    ClientRequestToken,
    MemberId,
    networkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return managedblockchain(
        "POST",
        "/networks/$(networkId)/proposals",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Actions" => Actions,
                    "ClientRequestToken" => ClientRequestToken,
                    "MemberId" => MemberId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_accessor(accessor_id)
    delete_accessor(accessor_id, params::Dict{String,<:Any})

Deletes an accessor that your Amazon Web Services account owns. An accessor object is a
container that has the information required for token based access to your Ethereum nodes
including, the BILLING_TOKEN. After an accessor is deleted, the status of the accessor
changes from AVAILABLE to PENDING_DELETION. An accessor in the PENDING_DELETION state
can’t be used for new WebSocket requests or HTTP requests. However, WebSocket connections
that were initiated while the accessor was in the AVAILABLE state remain open until they
expire (up to 2 hours).

# Arguments
- `accessor_id`: The unique identifier of the accessor.

"""
function delete_accessor(AccessorId; aws_config::AbstractAWSConfig=current_aws_config())
    return managedblockchain(
        "DELETE",
        "/accessors/$(AccessorId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_accessor(
    AccessorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return managedblockchain(
        "DELETE",
        "/accessors/$(AccessorId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_member(member_id, network_id)
    delete_member(member_id, network_id, params::Dict{String,<:Any})

Deletes a member. Deleting a member removes the member and all associated resources from
the network. DeleteMember can only be called for a specified MemberId if the principal
performing the action is associated with the Amazon Web Services account that owns the
member. In all other cases, the DeleteMember action is carried out as the result of an
approved proposal to remove a member. If MemberId is the last member in a network specified
by the last Amazon Web Services account, the network is deleted also. Applies only to
Hyperledger Fabric.

# Arguments
- `member_id`: The unique identifier of the member to remove.
- `network_id`: The unique identifier of the network from which the member is removed.

"""
function delete_member(
    memberId, networkId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return managedblockchain(
        "DELETE",
        "/networks/$(networkId)/members/$(memberId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_member(
    memberId,
    networkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return managedblockchain(
        "DELETE",
        "/networks/$(networkId)/members/$(memberId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_node(network_id, node_id)
    delete_node(network_id, node_id, params::Dict{String,<:Any})

Deletes a node that your Amazon Web Services account owns. All data on the node is lost and
cannot be recovered. Applies to Hyperledger Fabric and Ethereum.

# Arguments
- `network_id`: The unique identifier of the network that the node is on. Ethereum public
  networks have the following NetworkIds:    n-ethereum-mainnet
- `node_id`: The unique identifier of the node.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"memberId"`: The unique identifier of the member that owns this node. Applies only to
  Hyperledger Fabric and is required for Hyperledger Fabric.
"""
function delete_node(networkId, nodeId; aws_config::AbstractAWSConfig=current_aws_config())
    return managedblockchain(
        "DELETE",
        "/networks/$(networkId)/nodes/$(nodeId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_node(
    networkId,
    nodeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return managedblockchain(
        "DELETE",
        "/networks/$(networkId)/nodes/$(nodeId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_accessor(accessor_id)
    get_accessor(accessor_id, params::Dict{String,<:Any})

Returns detailed information about an accessor. An accessor object is a container that has
the information required for token based access to your Ethereum nodes.

# Arguments
- `accessor_id`: The unique identifier of the accessor.

"""
function get_accessor(AccessorId; aws_config::AbstractAWSConfig=current_aws_config())
    return managedblockchain(
        "GET",
        "/accessors/$(AccessorId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_accessor(
    AccessorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return managedblockchain(
        "GET",
        "/accessors/$(AccessorId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_member(member_id, network_id)
    get_member(member_id, network_id, params::Dict{String,<:Any})

Returns detailed information about a member. Applies only to Hyperledger Fabric.

# Arguments
- `member_id`: The unique identifier of the member.
- `network_id`: The unique identifier of the network to which the member belongs.

"""
function get_member(memberId, networkId; aws_config::AbstractAWSConfig=current_aws_config())
    return managedblockchain(
        "GET",
        "/networks/$(networkId)/members/$(memberId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_member(
    memberId,
    networkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return managedblockchain(
        "GET",
        "/networks/$(networkId)/members/$(memberId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_network(network_id)
    get_network(network_id, params::Dict{String,<:Any})

Returns detailed information about a network. Applies to Hyperledger Fabric and Ethereum.

# Arguments
- `network_id`: The unique identifier of the network to get information about.

"""
function get_network(networkId; aws_config::AbstractAWSConfig=current_aws_config())
    return managedblockchain(
        "GET",
        "/networks/$(networkId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_network(
    networkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return managedblockchain(
        "GET",
        "/networks/$(networkId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_node(network_id, node_id)
    get_node(network_id, node_id, params::Dict{String,<:Any})

Returns detailed information about a node. Applies to Hyperledger Fabric and Ethereum.

# Arguments
- `network_id`: The unique identifier of the network that the node is on.
- `node_id`: The unique identifier of the node.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"memberId"`: The unique identifier of the member that owns the node. Applies only to
  Hyperledger Fabric and is required for Hyperledger Fabric.
"""
function get_node(networkId, nodeId; aws_config::AbstractAWSConfig=current_aws_config())
    return managedblockchain(
        "GET",
        "/networks/$(networkId)/nodes/$(nodeId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_node(
    networkId,
    nodeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return managedblockchain(
        "GET",
        "/networks/$(networkId)/nodes/$(nodeId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_proposal(network_id, proposal_id)
    get_proposal(network_id, proposal_id, params::Dict{String,<:Any})

Returns detailed information about a proposal. Applies only to Hyperledger Fabric.

# Arguments
- `network_id`: The unique identifier of the network for which the proposal is made.
- `proposal_id`: The unique identifier of the proposal.

"""
function get_proposal(
    networkId, proposalId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return managedblockchain(
        "GET",
        "/networks/$(networkId)/proposals/$(proposalId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_proposal(
    networkId,
    proposalId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return managedblockchain(
        "GET",
        "/networks/$(networkId)/proposals/$(proposalId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_accessors()
    list_accessors(params::Dict{String,<:Any})

Returns a list of the accessors and their properties. Accessor objects are containers that
have the information required for token based access to your Ethereum nodes.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:  The maximum number of accessors to list.
- `"networkType"`: The blockchain network that the Accessor token is created for.  Use the
  value ETHEREUM_MAINNET_AND_GOERLI for all existing Accessors tokens that were created
  before the networkType property was introduced.
- `"nextToken"`:  The pagination token that indicates the next set of results to retrieve.
"""
function list_accessors(; aws_config::AbstractAWSConfig=current_aws_config())
    return managedblockchain(
        "GET", "/accessors"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_accessors(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return managedblockchain(
        "GET", "/accessors", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_invitations()
    list_invitations(params::Dict{String,<:Any})

Returns a list of all invitations for the current Amazon Web Services account. Applies only
to Hyperledger Fabric.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of invitations to return.
- `"nextToken"`: The pagination token that indicates the next set of results to retrieve.
"""
function list_invitations(; aws_config::AbstractAWSConfig=current_aws_config())
    return managedblockchain(
        "GET", "/invitations"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_invitations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return managedblockchain(
        "GET",
        "/invitations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_members(network_id)
    list_members(network_id, params::Dict{String,<:Any})

Returns a list of the members in a network and properties of their configurations. Applies
only to Hyperledger Fabric.

# Arguments
- `network_id`: The unique identifier of the network for which to list members.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"isOwned"`: An optional Boolean value. If provided, the request is limited either to
  members that the current Amazon Web Services account owns (true) or that other Amazon Web
  Services accountsn own (false). If omitted, all members are listed.
- `"maxResults"`: The maximum number of members to return in the request.
- `"name"`: The optional name of the member to list.
- `"nextToken"`: The pagination token that indicates the next set of results to retrieve.
- `"status"`: An optional status specifier. If provided, only members currently in this
  status are listed.
"""
function list_members(networkId; aws_config::AbstractAWSConfig=current_aws_config())
    return managedblockchain(
        "GET",
        "/networks/$(networkId)/members";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_members(
    networkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return managedblockchain(
        "GET",
        "/networks/$(networkId)/members",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_networks()
    list_networks(params::Dict{String,<:Any})

Returns information about the networks in which the current Amazon Web Services account
participates. Applies to Hyperledger Fabric and Ethereum.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"framework"`: An optional framework specifier. If provided, only networks of this
  framework type are listed.
- `"maxResults"`: The maximum number of networks to list.
- `"name"`: The name of the network.
- `"nextToken"`: The pagination token that indicates the next set of results to retrieve.
- `"status"`: An optional status specifier. If provided, only networks currently in this
  status are listed. Applies only to Hyperledger Fabric.
"""
function list_networks(; aws_config::AbstractAWSConfig=current_aws_config())
    return managedblockchain(
        "GET", "/networks"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_networks(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return managedblockchain(
        "GET", "/networks", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_nodes(network_id)
    list_nodes(network_id, params::Dict{String,<:Any})

Returns information about the nodes within a network. Applies to Hyperledger Fabric and
Ethereum.

# Arguments
- `network_id`: The unique identifier of the network for which to list nodes.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of nodes to list.
- `"memberId"`: The unique identifier of the member who owns the nodes to list. Applies
  only to Hyperledger Fabric and is required for Hyperledger Fabric.
- `"nextToken"`: The pagination token that indicates the next set of results to retrieve.
- `"status"`: An optional status specifier. If provided, only nodes currently in this
  status are listed.
"""
function list_nodes(networkId; aws_config::AbstractAWSConfig=current_aws_config())
    return managedblockchain(
        "GET",
        "/networks/$(networkId)/nodes";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_nodes(
    networkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return managedblockchain(
        "GET",
        "/networks/$(networkId)/nodes",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_proposal_votes(network_id, proposal_id)
    list_proposal_votes(network_id, proposal_id, params::Dict{String,<:Any})

Returns the list of votes for a specified proposal, including the value of each vote and
the unique identifier of the member that cast the vote. Applies only to Hyperledger Fabric.

# Arguments
- `network_id`:  The unique identifier of the network.
- `proposal_id`:  The unique identifier of the proposal.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:  The maximum number of votes to return.
- `"nextToken"`:  The pagination token that indicates the next set of results to retrieve.
"""
function list_proposal_votes(
    networkId, proposalId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return managedblockchain(
        "GET",
        "/networks/$(networkId)/proposals/$(proposalId)/votes";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_proposal_votes(
    networkId,
    proposalId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return managedblockchain(
        "GET",
        "/networks/$(networkId)/proposals/$(proposalId)/votes",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_proposals(network_id)
    list_proposals(network_id, params::Dict{String,<:Any})

Returns a list of proposals for the network. Applies only to Hyperledger Fabric.

# Arguments
- `network_id`:  The unique identifier of the network.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:  The maximum number of proposals to return.
- `"nextToken"`:  The pagination token that indicates the next set of results to retrieve.
"""
function list_proposals(networkId; aws_config::AbstractAWSConfig=current_aws_config())
    return managedblockchain(
        "GET",
        "/networks/$(networkId)/proposals";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_proposals(
    networkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return managedblockchain(
        "GET",
        "/networks/$(networkId)/proposals",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Returns a list of tags for the specified resource. Each tag consists of a key and optional
value. For more information about tags, see Tagging Resources in the Amazon Managed
Blockchain Ethereum Developer Guide, or Tagging Resources in the Amazon Managed Blockchain
Hyperledger Fabric Developer Guide.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource. For more information
  about ARNs and their format, see Amazon Resource Names (ARNs) in the Amazon Web Services
  General Reference.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return managedblockchain(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return managedblockchain(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    reject_invitation(invitation_id)
    reject_invitation(invitation_id, params::Dict{String,<:Any})

Rejects an invitation to join a network. This action can be called by a principal in an
Amazon Web Services account that has received an invitation to create a member and join a
network. Applies only to Hyperledger Fabric.

# Arguments
- `invitation_id`: The unique identifier of the invitation to reject.

"""
function reject_invitation(invitationId; aws_config::AbstractAWSConfig=current_aws_config())
    return managedblockchain(
        "DELETE",
        "/invitations/$(invitationId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function reject_invitation(
    invitationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return managedblockchain(
        "DELETE",
        "/invitations/$(invitationId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(tags, resource_arn)
    tag_resource(tags, resource_arn, params::Dict{String,<:Any})

Adds or overwrites the specified tags for the specified Amazon Managed Blockchain resource.
Each tag consists of a key and optional value. When you specify a tag key that already
exists, the tag value is overwritten with the new value. Use UntagResource to remove tag
keys. A resource can have up to 50 tags. If you try to create more than 50 tags for a
resource, your request fails and returns an error. For more information about tags, see
Tagging Resources in the Amazon Managed Blockchain Ethereum Developer Guide, or Tagging
Resources in the Amazon Managed Blockchain Hyperledger Fabric Developer Guide.

# Arguments
- `tags`: The tags to assign to the specified resource. Tag values can be empty, for
  example, \"MyTagKey\" : \"\". You can specify multiple key-value pairs in a single request,
  with an overall maximum of 50 tags added to each resource.
- `resource_arn`: The Amazon Resource Name (ARN) of the resource. For more information
  about ARNs and their format, see Amazon Resource Names (ARNs) in the Amazon Web Services
  General Reference.

"""
function tag_resource(Tags, resourceArn; aws_config::AbstractAWSConfig=current_aws_config())
    return managedblockchain(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    Tags,
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return managedblockchain(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Tags" => Tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes the specified tags from the Amazon Managed Blockchain resource. For more
information about tags, see Tagging Resources in the Amazon Managed Blockchain Ethereum
Developer Guide, or Tagging Resources in the Amazon Managed Blockchain Hyperledger Fabric
Developer Guide.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource. For more information
  about ARNs and their format, see Amazon Resource Names (ARNs) in the Amazon Web Services
  General Reference.
- `tag_keys`: The tag keys.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return managedblockchain(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return managedblockchain(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_member(member_id, network_id)
    update_member(member_id, network_id, params::Dict{String,<:Any})

Updates a member configuration with new parameters. Applies only to Hyperledger Fabric.

# Arguments
- `member_id`: The unique identifier of the member.
- `network_id`: The unique identifier of the Managed Blockchain network to which the member
  belongs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"LogPublishingConfiguration"`: Configuration properties for publishing to Amazon
  CloudWatch Logs.
"""
function update_member(
    memberId, networkId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return managedblockchain(
        "PATCH",
        "/networks/$(networkId)/members/$(memberId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_member(
    memberId,
    networkId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return managedblockchain(
        "PATCH",
        "/networks/$(networkId)/members/$(memberId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_node(network_id, node_id)
    update_node(network_id, node_id, params::Dict{String,<:Any})

Updates a node configuration with new parameters. Applies only to Hyperledger Fabric.

# Arguments
- `network_id`: The unique identifier of the network that the node is on.
- `node_id`: The unique identifier of the node.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"LogPublishingConfiguration"`: Configuration properties for publishing to Amazon
  CloudWatch Logs.
- `"MemberId"`: The unique identifier of the member that owns the node. Applies only to
  Hyperledger Fabric.
"""
function update_node(networkId, nodeId; aws_config::AbstractAWSConfig=current_aws_config())
    return managedblockchain(
        "PATCH",
        "/networks/$(networkId)/nodes/$(nodeId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_node(
    networkId,
    nodeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return managedblockchain(
        "PATCH",
        "/networks/$(networkId)/nodes/$(nodeId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    vote_on_proposal(vote, voter_member_id, network_id, proposal_id)
    vote_on_proposal(vote, voter_member_id, network_id, proposal_id, params::Dict{String,<:Any})

Casts a vote for a specified ProposalId on behalf of a member. The member to vote as,
specified by VoterMemberId, must be in the same Amazon Web Services account as the
principal that calls the action. Applies only to Hyperledger Fabric.

# Arguments
- `vote`:  The value of the vote.
- `voter_member_id`: The unique identifier of the member casting the vote.
- `network_id`:  The unique identifier of the network.
- `proposal_id`:  The unique identifier of the proposal.

"""
function vote_on_proposal(
    Vote,
    VoterMemberId,
    networkId,
    proposalId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return managedblockchain(
        "POST",
        "/networks/$(networkId)/proposals/$(proposalId)/votes",
        Dict{String,Any}("Vote" => Vote, "VoterMemberId" => VoterMemberId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function vote_on_proposal(
    Vote,
    VoterMemberId,
    networkId,
    proposalId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return managedblockchain(
        "POST",
        "/networks/$(networkId)/proposals/$(proposalId)/votes",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Vote" => Vote, "VoterMemberId" => VoterMemberId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: macie2
using AWS.Compat
using AWS.UUIDs

"""
    accept_invitation(invitation_id)
    accept_invitation(invitation_id, params::Dict{String,<:Any})

Accepts an Amazon Macie membership invitation that was received from a specific account.

# Arguments
- `invitation_id`: The unique identifier for the invitation to accept.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"administratorAccountId"`: The Amazon Web Services account ID for the account that sent
  the invitation.
- `"masterAccount"`: (Deprecated) The Amazon Web Services account ID for the account that
  sent the invitation. This property has been replaced by the administratorAccountId property
  and is retained only for backward compatibility.
"""
function accept_invitation(invitationId; aws_config::AbstractAWSConfig=current_aws_config())
    return macie2(
        "POST",
        "/invitations/accept",
        Dict{String,Any}("invitationId" => invitationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function accept_invitation(
    invitationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return macie2(
        "POST",
        "/invitations/accept",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("invitationId" => invitationId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_get_custom_data_identifiers()
    batch_get_custom_data_identifiers(params::Dict{String,<:Any})

Retrieves information about one or more custom data identifiers.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ids"`: An array of custom data identifier IDs, one for each custom data identifier to
  retrieve information about.
"""
function batch_get_custom_data_identifiers(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "POST",
        "/custom-data-identifiers/get";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_custom_data_identifiers(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "POST",
        "/custom-data-identifiers/get",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_update_automated_discovery_accounts()
    batch_update_automated_discovery_accounts(params::Dict{String,<:Any})

Changes the status of automated sensitive data discovery for one or more accounts.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accounts"`: An array of objects, one for each account to change the status of automated
  sensitive data discovery for. Each object specifies the Amazon Web Services account ID for
  an account and a new status for that account.
"""
function batch_update_automated_discovery_accounts(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "PATCH",
        "/automated-discovery/accounts";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_update_automated_discovery_accounts(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "PATCH",
        "/automated-discovery/accounts",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_allow_list(client_token, criteria, name)
    create_allow_list(client_token, criteria, name, params::Dict{String,<:Any})

Creates and defines the settings for an allow list.

# Arguments
- `client_token`: A unique, case-sensitive token that you provide to ensure the idempotency
  of the request.
- `criteria`: The criteria that specify the text or text pattern to ignore. The criteria
  can be the location and name of an S3 object that lists specific text to ignore
  (s3WordsList), or a regular expression (regex) that defines a text pattern to ignore.
- `name`: A custom name for the allow list. The name can contain as many as 128 characters.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A custom description of the allow list. The description can contain as
  many as 512 characters.
- `"tags"`: A map of key-value pairs that specifies the tags to associate with the allow
  list. An allow list can have a maximum of 50 tags. Each tag consists of a tag key and an
  associated tag value. The maximum length of a tag key is 128 characters. The maximum length
  of a tag value is 256 characters.
"""
function create_allow_list(
    clientToken, criteria, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "POST",
        "/allow-lists",
        Dict{String,Any}(
            "clientToken" => clientToken, "criteria" => criteria, "name" => name
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_allow_list(
    clientToken,
    criteria,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return macie2(
        "POST",
        "/allow-lists",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "clientToken" => clientToken, "criteria" => criteria, "name" => name
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_classification_job(client_token, job_type, name, s3_job_definition)
    create_classification_job(client_token, job_type, name, s3_job_definition, params::Dict{String,<:Any})

Creates and defines the settings for a classification job.

# Arguments
- `client_token`: A unique, case-sensitive token that you provide to ensure the idempotency
  of the request.
- `job_type`: The schedule for running the job. Valid values are: ONE_TIME - Run the job
  only once. If you specify this value, don't specify a value for the scheduleFrequency
  property. SCHEDULED - Run the job on a daily, weekly, or monthly basis. If you specify this
  value, use the scheduleFrequency property to specify the recurrence pattern for the job.
- `name`: A custom name for the job. The name can contain as many as 500 characters.
- `s3_job_definition`: The S3 buckets that contain the objects to analyze, and the scope of
  that analysis.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"allowListIds"`: An array of unique identifiers, one for each allow list for the job to
  use when it analyzes data.
- `"customDataIdentifierIds"`: An array of unique identifiers, one for each custom data
  identifier for the job to use when it analyzes data. To use only managed data identifiers,
  don't specify a value for this property and specify a value other than NONE for the
  managedDataIdentifierSelector property.
- `"description"`: A custom description of the job. The description can contain as many as
  200 characters.
- `"initialRun"`: For a recurring job, specifies whether to analyze all existing, eligible
  objects immediately after the job is created (true). To analyze only those objects that are
  created or changed after you create the job and before the job's first scheduled run, set
  this value to false. If you configure the job to run only once, don't specify a value for
  this property.
- `"managedDataIdentifierIds"`: An array of unique identifiers, one for each managed data
  identifier for the job to include (use) or exclude (not use) when it analyzes data.
  Inclusion or exclusion depends on the managed data identifier selection type that you
  specify for the job (managedDataIdentifierSelector). To retrieve a list of valid values for
  this property, use the ListManagedDataIdentifiers operation.
- `"managedDataIdentifierSelector"`: The selection type to apply when determining which
  managed data identifiers the job uses to analyze data. Valid values are: ALL - Use all
  managed data identifiers. If you specify this value, don't specify any values for the
  managedDataIdentifierIds property. EXCLUDE - Use all managed data identifiers except the
  ones specified by the managedDataIdentifierIds property. INCLUDE - Use only the managed
  data identifiers specified by the managedDataIdentifierIds property. NONE - Don't use any
  managed data identifiers. If you specify this value, specify at least one value for the
  customDataIdentifierIds property and don't specify any values for the
  managedDataIdentifierIds property. RECOMMENDED (default) - Use the recommended set of
  managed data identifiers. If you specify this value, don't specify any values for the
  managedDataIdentifierIds property. If you don't specify a value for this property, the job
  uses the recommended set of managed data identifiers. If the job is a recurring job and you
  specify ALL or EXCLUDE, each job run automatically uses new managed data identifiers that
  are released. If you don't specify a value for this property or you specify RECOMMENDED for
  a recurring job, each job run automatically uses all the managed data identifiers that are
  in the recommended set when the run starts. To learn about individual managed data
  identifiers or determine which ones are in the recommended set, see Using managed data
  identifiers or Recommended managed data identifiers in the Amazon Macie User Guide.
- `"samplingPercentage"`: The sampling depth, as a percentage, for the job to apply when
  processing objects. This value determines the percentage of eligible objects that the job
  analyzes. If this value is less than 100, Amazon Macie selects the objects to analyze at
  random, up to the specified percentage, and analyzes all the data in those objects.
- `"scheduleFrequency"`: The recurrence pattern for running the job. To run the job only
  once, don't specify a value for this property and set the value for the jobType property to
  ONE_TIME.
- `"tags"`: A map of key-value pairs that specifies the tags to associate with the job. A
  job can have a maximum of 50 tags. Each tag consists of a tag key and an associated tag
  value. The maximum length of a tag key is 128 characters. The maximum length of a tag value
  is 256 characters.
"""
function create_classification_job(
    clientToken,
    jobType,
    name,
    s3JobDefinition;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return macie2(
        "POST",
        "/jobs",
        Dict{String,Any}(
            "clientToken" => clientToken,
            "jobType" => jobType,
            "name" => name,
            "s3JobDefinition" => s3JobDefinition,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_classification_job(
    clientToken,
    jobType,
    name,
    s3JobDefinition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return macie2(
        "POST",
        "/jobs",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "clientToken" => clientToken,
                    "jobType" => jobType,
                    "name" => name,
                    "s3JobDefinition" => s3JobDefinition,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_custom_data_identifier(name, regex)
    create_custom_data_identifier(name, regex, params::Dict{String,<:Any})

Creates and defines the criteria and other settings for a custom data identifier.

# Arguments
- `name`: A custom name for the custom data identifier. The name can contain as many as 128
  characters. We strongly recommend that you avoid including any sensitive data in the name
  of a custom data identifier. Other users of your account might be able to see this name,
  depending on the actions that they're allowed to perform in Amazon Macie.
- `regex`: The regular expression (regex) that defines the pattern to match. The expression
  can contain as many as 512 characters.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive token that you provide to ensure the
  idempotency of the request.
- `"description"`: A custom description of the custom data identifier. The description can
  contain as many as 512 characters. We strongly recommend that you avoid including any
  sensitive data in the description of a custom data identifier. Other users of your account
  might be able to see this description, depending on the actions that they're allowed to
  perform in Amazon Macie.
- `"ignoreWords"`: An array that lists specific character sequences (ignore words) to
  exclude from the results. If the text matched by the regular expression contains any string
  in this array, Amazon Macie ignores it. The array can contain as many as 10 ignore words.
  Each ignore word can contain 4-90 UTF-8 characters. Ignore words are case sensitive.
- `"keywords"`: An array that lists specific character sequences (keywords), one of which
  must precede and be within proximity (maximumMatchDistance) of the regular expression to
  match. The array can contain as many as 50 keywords. Each keyword can contain 3-90 UTF-8
  characters. Keywords aren't case sensitive.
- `"maximumMatchDistance"`: The maximum number of characters that can exist between the end
  of at least one complete character sequence specified by the keywords array and the end of
  the text that matches the regex pattern. If a complete keyword precedes all the text that
  matches the pattern and the keyword is within the specified distance, Amazon Macie includes
  the result. The distance can be 1-300 characters. The default value is 50.
- `"severityLevels"`: The severity to assign to findings that the custom data identifier
  produces, based on the number of occurrences of text that match the custom data
  identifier's detection criteria. You can specify as many as three SeverityLevel objects in
  this array, one for each severity: LOW, MEDIUM, or HIGH. If you specify more than one, the
  occurrences thresholds must be in ascending order by severity, moving from LOW to HIGH. For
  example, 1 for LOW, 50 for MEDIUM, and 100 for HIGH. If an S3 object contains fewer
  occurrences than the lowest specified threshold, Amazon Macie doesn't create a finding. If
  you don't specify any values for this array, Macie creates findings for S3 objects that
  contain at least one occurrence of text that matches the detection criteria, and Macie
  assigns the MEDIUM severity to those findings.
- `"tags"`: A map of key-value pairs that specifies the tags to associate with the custom
  data identifier. A custom data identifier can have a maximum of 50 tags. Each tag consists
  of a tag key and an associated tag value. The maximum length of a tag key is 128
  characters. The maximum length of a tag value is 256 characters.
"""
function create_custom_data_identifier(
    name, regex; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "POST",
        "/custom-data-identifiers",
        Dict{String,Any}(
            "name" => name, "regex" => regex, "clientToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_custom_data_identifier(
    name,
    regex,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return macie2(
        "POST",
        "/custom-data-identifiers",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "name" => name, "regex" => regex, "clientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_findings_filter(action, finding_criteria, name)
    create_findings_filter(action, finding_criteria, name, params::Dict{String,<:Any})

Creates and defines the criteria and other settings for a findings filter.

# Arguments
- `action`: The action to perform on findings that match the filter criteria
  (findingCriteria). Valid values are: ARCHIVE, suppress (automatically archive) the
  findings; and, NOOP, don't perform any action on the findings.
- `finding_criteria`: The criteria to use to filter findings.
- `name`: A custom name for the filter. The name must contain at least 3 characters and can
  contain as many as 64 characters. We strongly recommend that you avoid including any
  sensitive data in the name of a filter. Other users of your account might be able to see
  this name, depending on the actions that they're allowed to perform in Amazon Macie.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive token that you provide to ensure the
  idempotency of the request.
- `"description"`: A custom description of the filter. The description can contain as many
  as 512 characters. We strongly recommend that you avoid including any sensitive data in the
  description of a filter. Other users of your account might be able to see this description,
  depending on the actions that they're allowed to perform in Amazon Macie.
- `"position"`: The position of the filter in the list of saved filters on the Amazon Macie
  console. This value also determines the order in which the filter is applied to findings,
  relative to other filters that are also applied to the findings.
- `"tags"`: A map of key-value pairs that specifies the tags to associate with the filter.
  A findings filter can have a maximum of 50 tags. Each tag consists of a tag key and an
  associated tag value. The maximum length of a tag key is 128 characters. The maximum length
  of a tag value is 256 characters.
"""
function create_findings_filter(
    action, findingCriteria, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "POST",
        "/findingsfilters",
        Dict{String,Any}(
            "action" => action,
            "findingCriteria" => findingCriteria,
            "name" => name,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_findings_filter(
    action,
    findingCriteria,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return macie2(
        "POST",
        "/findingsfilters",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "action" => action,
                    "findingCriteria" => findingCriteria,
                    "name" => name,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_invitations(account_ids)
    create_invitations(account_ids, params::Dict{String,<:Any})

Sends an Amazon Macie membership invitation to one or more accounts.

# Arguments
- `account_ids`: An array that lists Amazon Web Services account IDs, one for each account
  to send the invitation to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"disableEmailNotification"`: Specifies whether to send the invitation as an email
  message. If this value is false, Amazon Macie sends the invitation (as an email message) to
  the email address that you specified for the recipient's account when you associated the
  account with your account. The default value is false.
- `"message"`: Custom text to include in the email message that contains the invitation.
  The text can contain as many as 80 alphanumeric characters.
"""
function create_invitations(accountIds; aws_config::AbstractAWSConfig=current_aws_config())
    return macie2(
        "POST",
        "/invitations",
        Dict{String,Any}("accountIds" => accountIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_invitations(
    accountIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return macie2(
        "POST",
        "/invitations",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("accountIds" => accountIds), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_member(account)
    create_member(account, params::Dict{String,<:Any})

Associates an account with an Amazon Macie administrator account.

# Arguments
- `account`: The details of the account to associate with the administrator account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tags"`: A map of key-value pairs that specifies the tags to associate with the account
  in Amazon Macie. An account can have a maximum of 50 tags. Each tag consists of a tag key
  and an associated tag value. The maximum length of a tag key is 128 characters. The maximum
  length of a tag value is 256 characters.
"""
function create_member(account; aws_config::AbstractAWSConfig=current_aws_config())
    return macie2(
        "POST",
        "/members",
        Dict{String,Any}("account" => account);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_member(
    account,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return macie2(
        "POST",
        "/members",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("account" => account), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_sample_findings()
    create_sample_findings(params::Dict{String,<:Any})

Creates sample findings.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"findingTypes"`: An array of finding types, one for each type of sample finding to
  create. To create a sample of every type of finding that Amazon Macie supports, don't
  include this array in your request.
"""
function create_sample_findings(; aws_config::AbstractAWSConfig=current_aws_config())
    return macie2(
        "POST", "/findings/sample"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function create_sample_findings(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "POST",
        "/findings/sample",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    decline_invitations(account_ids)
    decline_invitations(account_ids, params::Dict{String,<:Any})

Declines Amazon Macie membership invitations that were received from specific accounts.

# Arguments
- `account_ids`: An array that lists Amazon Web Services account IDs, one for each account
  that sent an invitation to decline.

"""
function decline_invitations(accountIds; aws_config::AbstractAWSConfig=current_aws_config())
    return macie2(
        "POST",
        "/invitations/decline",
        Dict{String,Any}("accountIds" => accountIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function decline_invitations(
    accountIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return macie2(
        "POST",
        "/invitations/decline",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("accountIds" => accountIds), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_allow_list(id)
    delete_allow_list(id, params::Dict{String,<:Any})

Deletes an allow list.

# Arguments
- `id`: The unique identifier for the Amazon Macie resource that the request applies to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ignoreJobChecks"`: Specifies whether to force deletion of the allow list, even if
  active classification jobs are configured to use the list. When you try to delete an allow
  list, Amazon Macie checks for classification jobs that use the list and have a status other
  than COMPLETE or CANCELLED. By default, Macie rejects your request if any jobs meet these
  criteria. To skip these checks and delete the list, set this value to true. To delete the
  list only if no active jobs are configured to use it, set this value to false.
"""
function delete_allow_list(id; aws_config::AbstractAWSConfig=current_aws_config())
    return macie2(
        "DELETE",
        "/allow-lists/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_allow_list(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "DELETE",
        "/allow-lists/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_custom_data_identifier(id)
    delete_custom_data_identifier(id, params::Dict{String,<:Any})

Soft deletes a custom data identifier.

# Arguments
- `id`: The unique identifier for the Amazon Macie resource that the request applies to.

"""
function delete_custom_data_identifier(
    id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "DELETE",
        "/custom-data-identifiers/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_custom_data_identifier(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "DELETE",
        "/custom-data-identifiers/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_findings_filter(id)
    delete_findings_filter(id, params::Dict{String,<:Any})

Deletes a findings filter.

# Arguments
- `id`: The unique identifier for the Amazon Macie resource that the request applies to.

"""
function delete_findings_filter(id; aws_config::AbstractAWSConfig=current_aws_config())
    return macie2(
        "DELETE",
        "/findingsfilters/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_findings_filter(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "DELETE",
        "/findingsfilters/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_invitations(account_ids)
    delete_invitations(account_ids, params::Dict{String,<:Any})

Deletes Amazon Macie membership invitations that were received from specific accounts.

# Arguments
- `account_ids`: An array that lists Amazon Web Services account IDs, one for each account
  that sent an invitation to delete.

"""
function delete_invitations(accountIds; aws_config::AbstractAWSConfig=current_aws_config())
    return macie2(
        "POST",
        "/invitations/delete",
        Dict{String,Any}("accountIds" => accountIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_invitations(
    accountIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return macie2(
        "POST",
        "/invitations/delete",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("accountIds" => accountIds), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_member(id)
    delete_member(id, params::Dict{String,<:Any})

Deletes the association between an Amazon Macie administrator account and an account.

# Arguments
- `id`: The unique identifier for the Amazon Macie resource that the request applies to.

"""
function delete_member(id; aws_config::AbstractAWSConfig=current_aws_config())
    return macie2(
        "DELETE", "/members/$(id)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function delete_member(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "DELETE",
        "/members/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_buckets()
    describe_buckets(params::Dict{String,<:Any})

Retrieves (queries) statistical data and other information about one or more S3 buckets
that Amazon Macie monitors and analyzes for an account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"criteria"`: The criteria to use to filter the query results.
- `"maxResults"`: The maximum number of items to include in each page of the response. The
  default value is 50.
- `"nextToken"`: The nextToken string that specifies which page of results to return in a
  paginated response.
- `"sortCriteria"`: The criteria to use to sort the query results.
"""
function describe_buckets(; aws_config::AbstractAWSConfig=current_aws_config())
    return macie2(
        "POST", "/datasources/s3"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_buckets(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "POST",
        "/datasources/s3",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_classification_job(job_id)
    describe_classification_job(job_id, params::Dict{String,<:Any})

Retrieves the status and settings for a classification job.

# Arguments
- `job_id`: The unique identifier for the classification job.

"""
function describe_classification_job(
    jobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "GET", "/jobs/$(jobId)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_classification_job(
    jobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "GET",
        "/jobs/$(jobId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_organization_configuration()
    describe_organization_configuration(params::Dict{String,<:Any})

Retrieves the Amazon Macie configuration settings for an organization in Organizations.

"""
function describe_organization_configuration(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "GET",
        "/admin/configuration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_organization_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "GET",
        "/admin/configuration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disable_macie()
    disable_macie(params::Dict{String,<:Any})

Disables Amazon Macie and deletes all settings and resources for a Macie account.

"""
function disable_macie(; aws_config::AbstractAWSConfig=current_aws_config())
    return macie2(
        "DELETE", "/macie"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function disable_macie(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "DELETE", "/macie", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    disable_organization_admin_account(admin_account_id)
    disable_organization_admin_account(admin_account_id, params::Dict{String,<:Any})

Disables an account as the delegated Amazon Macie administrator account for an organization
in Organizations.

# Arguments
- `admin_account_id`: The Amazon Web Services account ID of the delegated Amazon Macie
  administrator account.

"""
function disable_organization_admin_account(
    adminAccountId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "DELETE",
        "/admin",
        Dict{String,Any}("adminAccountId" => adminAccountId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disable_organization_admin_account(
    adminAccountId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return macie2(
        "DELETE",
        "/admin",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("adminAccountId" => adminAccountId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_from_administrator_account()
    disassociate_from_administrator_account(params::Dict{String,<:Any})

Disassociates a member account from its Amazon Macie administrator account.

"""
function disassociate_from_administrator_account(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "POST",
        "/administrator/disassociate";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_from_administrator_account(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "POST",
        "/administrator/disassociate",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_from_master_account()
    disassociate_from_master_account(params::Dict{String,<:Any})

(Deprecated) Disassociates a member account from its Amazon Macie administrator account.
This operation has been replaced by the DisassociateFromAdministratorAccount operation.

"""
function disassociate_from_master_account(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "POST",
        "/master/disassociate";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_from_master_account(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "POST",
        "/master/disassociate",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_member(id)
    disassociate_member(id, params::Dict{String,<:Any})

Disassociates an Amazon Macie administrator account from a member account.

# Arguments
- `id`: The unique identifier for the Amazon Macie resource that the request applies to.

"""
function disassociate_member(id; aws_config::AbstractAWSConfig=current_aws_config())
    return macie2(
        "POST",
        "/members/disassociate/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_member(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "POST",
        "/members/disassociate/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    enable_macie()
    enable_macie(params::Dict{String,<:Any})

Enables Amazon Macie and specifies the configuration settings for a Macie account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive token that you provide to ensure the
  idempotency of the request.
- `"findingPublishingFrequency"`: Specifies how often to publish updates to policy findings
  for the account. This includes publishing updates to Security Hub and Amazon EventBridge
  (formerly Amazon CloudWatch Events).
- `"status"`: Specifies the new status for the account. To enable Amazon Macie and start
  all Macie activities for the account, set this value to ENABLED.
"""
function enable_macie(; aws_config::AbstractAWSConfig=current_aws_config())
    return macie2(
        "POST",
        "/macie",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function enable_macie(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "POST",
        "/macie",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    enable_organization_admin_account(admin_account_id)
    enable_organization_admin_account(admin_account_id, params::Dict{String,<:Any})

Designates an account as the delegated Amazon Macie administrator account for an
organization in Organizations.

# Arguments
- `admin_account_id`: The Amazon Web Services account ID for the account to designate as
  the delegated Amazon Macie administrator account for the organization.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive token that you provide to ensure the
  idempotency of the request.
"""
function enable_organization_admin_account(
    adminAccountId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "POST",
        "/admin",
        Dict{String,Any}(
            "adminAccountId" => adminAccountId, "clientToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function enable_organization_admin_account(
    adminAccountId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return macie2(
        "POST",
        "/admin",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "adminAccountId" => adminAccountId, "clientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_administrator_account()
    get_administrator_account(params::Dict{String,<:Any})

Retrieves information about the Amazon Macie administrator account for an account.

"""
function get_administrator_account(; aws_config::AbstractAWSConfig=current_aws_config())
    return macie2(
        "GET", "/administrator"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_administrator_account(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "GET",
        "/administrator",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_allow_list(id)
    get_allow_list(id, params::Dict{String,<:Any})

Retrieves the settings and status of an allow list.

# Arguments
- `id`: The unique identifier for the Amazon Macie resource that the request applies to.

"""
function get_allow_list(id; aws_config::AbstractAWSConfig=current_aws_config())
    return macie2(
        "GET", "/allow-lists/$(id)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_allow_list(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "GET",
        "/allow-lists/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_automated_discovery_configuration()
    get_automated_discovery_configuration(params::Dict{String,<:Any})

Retrieves the configuration settings and status of automated sensitive data discovery for
an organization or standalone account.

"""
function get_automated_discovery_configuration(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "GET",
        "/automated-discovery/configuration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_automated_discovery_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "GET",
        "/automated-discovery/configuration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_bucket_statistics()
    get_bucket_statistics(params::Dict{String,<:Any})

Retrieves (queries) aggregated statistical data about all the S3 buckets that Amazon Macie
monitors and analyzes for an account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountId"`: The unique identifier for the Amazon Web Services account.
"""
function get_bucket_statistics(; aws_config::AbstractAWSConfig=current_aws_config())
    return macie2(
        "POST",
        "/datasources/s3/statistics";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_bucket_statistics(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "POST",
        "/datasources/s3/statistics",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_classification_export_configuration()
    get_classification_export_configuration(params::Dict{String,<:Any})

Retrieves the configuration settings for storing data classification results.

"""
function get_classification_export_configuration(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "GET",
        "/classification-export-configuration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_classification_export_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "GET",
        "/classification-export-configuration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_classification_scope(id)
    get_classification_scope(id, params::Dict{String,<:Any})

Retrieves the classification scope settings for an account.

# Arguments
- `id`: The unique identifier for the Amazon Macie resource that the request applies to.

"""
function get_classification_scope(id; aws_config::AbstractAWSConfig=current_aws_config())
    return macie2(
        "GET",
        "/classification-scopes/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_classification_scope(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "GET",
        "/classification-scopes/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_custom_data_identifier(id)
    get_custom_data_identifier(id, params::Dict{String,<:Any})

Retrieves the criteria and other settings for a custom data identifier.

# Arguments
- `id`: The unique identifier for the Amazon Macie resource that the request applies to.

"""
function get_custom_data_identifier(id; aws_config::AbstractAWSConfig=current_aws_config())
    return macie2(
        "GET",
        "/custom-data-identifiers/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_custom_data_identifier(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "GET",
        "/custom-data-identifiers/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_finding_statistics(group_by)
    get_finding_statistics(group_by, params::Dict{String,<:Any})

Retrieves (queries) aggregated statistical data about findings.

# Arguments
- `group_by`: The finding property to use to group the query results. Valid values are:
  classificationDetails.jobId - The unique identifier for the classification job that
  produced the finding. resourcesAffected.s3Bucket.name - The name of the S3 bucket that the
  finding applies to. severity.description - The severity level of the finding, such as High
  or Medium. type - The type of finding, such as Policy:IAMUser/S3BucketPublic and
  SensitiveData:S3Object/Personal.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"findingCriteria"`: The criteria to use to filter the query results.
- `"size"`: The maximum number of items to include in each page of the response.
- `"sortCriteria"`: The criteria to use to sort the query results.
"""
function get_finding_statistics(groupBy; aws_config::AbstractAWSConfig=current_aws_config())
    return macie2(
        "POST",
        "/findings/statistics",
        Dict{String,Any}("groupBy" => groupBy);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_finding_statistics(
    groupBy,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return macie2(
        "POST",
        "/findings/statistics",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("groupBy" => groupBy), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_findings(finding_ids)
    get_findings(finding_ids, params::Dict{String,<:Any})

Retrieves the details of one or more findings.

# Arguments
- `finding_ids`: An array of strings that lists the unique identifiers for the findings to
  retrieve. You can specify as many as 50 unique identifiers in this array.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"sortCriteria"`: The criteria for sorting the results of the request.
"""
function get_findings(findingIds; aws_config::AbstractAWSConfig=current_aws_config())
    return macie2(
        "POST",
        "/findings/describe",
        Dict{String,Any}("findingIds" => findingIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_findings(
    findingIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return macie2(
        "POST",
        "/findings/describe",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("findingIds" => findingIds), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_findings_filter(id)
    get_findings_filter(id, params::Dict{String,<:Any})

Retrieves the criteria and other settings for a findings filter.

# Arguments
- `id`: The unique identifier for the Amazon Macie resource that the request applies to.

"""
function get_findings_filter(id; aws_config::AbstractAWSConfig=current_aws_config())
    return macie2(
        "GET",
        "/findingsfilters/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_findings_filter(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "GET",
        "/findingsfilters/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_findings_publication_configuration()
    get_findings_publication_configuration(params::Dict{String,<:Any})

Retrieves the configuration settings for publishing findings to Security Hub.

"""
function get_findings_publication_configuration(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "GET",
        "/findings-publication-configuration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_findings_publication_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "GET",
        "/findings-publication-configuration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_invitations_count()
    get_invitations_count(params::Dict{String,<:Any})

Retrieves the count of Amazon Macie membership invitations that were received by an account.

"""
function get_invitations_count(; aws_config::AbstractAWSConfig=current_aws_config())
    return macie2(
        "GET", "/invitations/count"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_invitations_count(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "GET",
        "/invitations/count",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_macie_session()
    get_macie_session(params::Dict{String,<:Any})

Retrieves the status and configuration settings for an Amazon Macie account.

"""
function get_macie_session(; aws_config::AbstractAWSConfig=current_aws_config())
    return macie2("GET", "/macie"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function get_macie_session(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "GET", "/macie", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_master_account()
    get_master_account(params::Dict{String,<:Any})

(Deprecated) Retrieves information about the Amazon Macie administrator account for an
account. This operation has been replaced by the GetAdministratorAccount operation.

"""
function get_master_account(; aws_config::AbstractAWSConfig=current_aws_config())
    return macie2("GET", "/master"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function get_master_account(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "GET", "/master", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_member(id)
    get_member(id, params::Dict{String,<:Any})

Retrieves information about an account that's associated with an Amazon Macie administrator
account.

# Arguments
- `id`: The unique identifier for the Amazon Macie resource that the request applies to.

"""
function get_member(id; aws_config::AbstractAWSConfig=current_aws_config())
    return macie2(
        "GET", "/members/$(id)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_member(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "GET",
        "/members/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_resource_profile(resource_arn)
    get_resource_profile(resource_arn, params::Dict{String,<:Any})

Retrieves (queries) sensitive data discovery statistics and the sensitivity score for an S3
bucket.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the S3 bucket that the request applies
  to.

"""
function get_resource_profile(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "GET",
        "/resource-profiles",
        Dict{String,Any}("resourceArn" => resourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_resource_profile(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return macie2(
        "GET",
        "/resource-profiles",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceArn" => resourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_reveal_configuration()
    get_reveal_configuration(params::Dict{String,<:Any})

Retrieves the status and configuration settings for retrieving occurrences of sensitive
data reported by findings.

"""
function get_reveal_configuration(; aws_config::AbstractAWSConfig=current_aws_config())
    return macie2(
        "GET",
        "/reveal-configuration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_reveal_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "GET",
        "/reveal-configuration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_sensitive_data_occurrences(finding_id)
    get_sensitive_data_occurrences(finding_id, params::Dict{String,<:Any})

Retrieves occurrences of sensitive data reported by a finding.

# Arguments
- `finding_id`: The unique identifier for the finding.

"""
function get_sensitive_data_occurrences(
    findingId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "GET",
        "/findings/$(findingId)/reveal";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_sensitive_data_occurrences(
    findingId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return macie2(
        "GET",
        "/findings/$(findingId)/reveal",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_sensitive_data_occurrences_availability(finding_id)
    get_sensitive_data_occurrences_availability(finding_id, params::Dict{String,<:Any})

Checks whether occurrences of sensitive data can be retrieved for a finding.

# Arguments
- `finding_id`: The unique identifier for the finding.

"""
function get_sensitive_data_occurrences_availability(
    findingId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "GET",
        "/findings/$(findingId)/reveal/availability";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_sensitive_data_occurrences_availability(
    findingId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return macie2(
        "GET",
        "/findings/$(findingId)/reveal/availability",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_sensitivity_inspection_template(id)
    get_sensitivity_inspection_template(id, params::Dict{String,<:Any})

 Retrieves the settings for the sensitivity inspection template for an account.

# Arguments
- `id`: The unique identifier for the Amazon Macie resource that the request applies to.

"""
function get_sensitivity_inspection_template(
    id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "GET",
        "/templates/sensitivity-inspections/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_sensitivity_inspection_template(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "GET",
        "/templates/sensitivity-inspections/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_usage_statistics()
    get_usage_statistics(params::Dict{String,<:Any})

Retrieves (queries) quotas and aggregated usage data for one or more accounts.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filterBy"`: An array of objects, one for each condition to use to filter the query
  results. If you specify more than one condition, Amazon Macie uses an AND operator to join
  the conditions.
- `"maxResults"`: The maximum number of items to include in each page of the response.
- `"nextToken"`: The nextToken string that specifies which page of results to return in a
  paginated response.
- `"sortBy"`: The criteria to use to sort the query results.
- `"timeRange"`: The inclusive time period to query usage data for. Valid values are:
  MONTH_TO_DATE, for the current calendar month to date; and, PAST_30_DAYS, for the preceding
  30 days. If you don't specify a value, Amazon Macie provides usage data for the preceding
  30 days.
"""
function get_usage_statistics(; aws_config::AbstractAWSConfig=current_aws_config())
    return macie2(
        "POST", "/usage/statistics"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_usage_statistics(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "POST",
        "/usage/statistics",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_usage_totals()
    get_usage_totals(params::Dict{String,<:Any})

Retrieves (queries) aggregated usage data for an account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"timeRange"`: The inclusive time period to retrieve the data for. Valid values are:
  MONTH_TO_DATE, for the current calendar month to date; and, PAST_30_DAYS, for the preceding
  30 days. If you don't specify a value for this parameter, Amazon Macie provides aggregated
  usage data for the preceding 30 days.
"""
function get_usage_totals(; aws_config::AbstractAWSConfig=current_aws_config())
    return macie2("GET", "/usage"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function get_usage_totals(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "GET", "/usage", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_allow_lists()
    list_allow_lists(params::Dict{String,<:Any})

Retrieves a subset of information about all the allow lists for an account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of items to include in each page of a paginated
  response.
- `"nextToken"`: The nextToken string that specifies which page of results to return in a
  paginated response.
"""
function list_allow_lists(; aws_config::AbstractAWSConfig=current_aws_config())
    return macie2(
        "GET", "/allow-lists"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_allow_lists(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "GET",
        "/allow-lists",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_automated_discovery_accounts()
    list_automated_discovery_accounts(params::Dict{String,<:Any})

Retrieves the status of automated sensitive data discovery for one or more accounts.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountIds"`: The Amazon Web Services account ID for each account, for as many as 50
  accounts. To retrieve the status for multiple accounts, append the accountIds parameter and
  argument for each account, separated by an ampersand (&amp;). To retrieve the status for
  all the accounts in an organization, omit this parameter.
- `"maxResults"`: The maximum number of items to include in each page of a paginated
  response.
- `"nextToken"`: The nextToken string that specifies which page of results to return in a
  paginated response.
"""
function list_automated_discovery_accounts(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "GET",
        "/automated-discovery/accounts";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_automated_discovery_accounts(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "GET",
        "/automated-discovery/accounts",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_classification_jobs()
    list_classification_jobs(params::Dict{String,<:Any})

Retrieves a subset of information about one or more classification jobs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filterCriteria"`: The criteria to use to filter the results.
- `"maxResults"`: The maximum number of items to include in each page of the response.
- `"nextToken"`: The nextToken string that specifies which page of results to return in a
  paginated response.
- `"sortCriteria"`: The criteria to use to sort the results.
"""
function list_classification_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return macie2(
        "POST", "/jobs/list"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_classification_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "POST", "/jobs/list", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_classification_scopes()
    list_classification_scopes(params::Dict{String,<:Any})

Retrieves a subset of information about the classification scope for an account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"name"`: The name of the classification scope to retrieve the unique identifier for.
- `"nextToken"`: The nextToken string that specifies which page of results to return in a
  paginated response.
"""
function list_classification_scopes(; aws_config::AbstractAWSConfig=current_aws_config())
    return macie2(
        "GET",
        "/classification-scopes";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_classification_scopes(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "GET",
        "/classification-scopes",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_custom_data_identifiers()
    list_custom_data_identifiers(params::Dict{String,<:Any})

Retrieves a subset of information about all the custom data identifiers for an account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of items to include in each page of the response.
- `"nextToken"`: The nextToken string that specifies which page of results to return in a
  paginated response.
"""
function list_custom_data_identifiers(; aws_config::AbstractAWSConfig=current_aws_config())
    return macie2(
        "POST",
        "/custom-data-identifiers/list";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_custom_data_identifiers(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "POST",
        "/custom-data-identifiers/list",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_findings()
    list_findings(params::Dict{String,<:Any})

Retrieves a subset of information about one or more findings.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"findingCriteria"`: The criteria to use to filter the results.
- `"maxResults"`: The maximum number of items to include in each page of the response.
- `"nextToken"`: The nextToken string that specifies which page of results to return in a
  paginated response.
- `"sortCriteria"`: The criteria to use to sort the results.
"""
function list_findings(; aws_config::AbstractAWSConfig=current_aws_config())
    return macie2(
        "POST", "/findings"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_findings(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "POST", "/findings", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_findings_filters()
    list_findings_filters(params::Dict{String,<:Any})

Retrieves a subset of information about all the findings filters for an account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of items to include in each page of a paginated
  response.
- `"nextToken"`: The nextToken string that specifies which page of results to return in a
  paginated response.
"""
function list_findings_filters(; aws_config::AbstractAWSConfig=current_aws_config())
    return macie2(
        "GET", "/findingsfilters"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_findings_filters(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "GET",
        "/findingsfilters",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_invitations()
    list_invitations(params::Dict{String,<:Any})

Retrieves information about Amazon Macie membership invitations that were received by an
account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of items to include in each page of a paginated
  response.
- `"nextToken"`: The nextToken string that specifies which page of results to return in a
  paginated response.
"""
function list_invitations(; aws_config::AbstractAWSConfig=current_aws_config())
    return macie2(
        "GET", "/invitations"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_invitations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "GET",
        "/invitations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_managed_data_identifiers()
    list_managed_data_identifiers(params::Dict{String,<:Any})

Retrieves information about all the managed data identifiers that Amazon Macie currently
provides.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: The nextToken string that specifies which page of results to return in a
  paginated response.
"""
function list_managed_data_identifiers(; aws_config::AbstractAWSConfig=current_aws_config())
    return macie2(
        "POST",
        "/managed-data-identifiers/list";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_managed_data_identifiers(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "POST",
        "/managed-data-identifiers/list",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_members()
    list_members(params::Dict{String,<:Any})

Retrieves information about the accounts that are associated with an Amazon Macie
administrator account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of items to include in each page of a paginated
  response.
- `"nextToken"`: The nextToken string that specifies which page of results to return in a
  paginated response.
- `"onlyAssociated"`: Specifies which accounts to include in the response, based on the
  status of an account's relationship with the administrator account. By default, the
  response includes only current member accounts. To include all accounts, set this value to
  false.
"""
function list_members(; aws_config::AbstractAWSConfig=current_aws_config())
    return macie2("GET", "/members"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_members(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "GET", "/members", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_organization_admin_accounts()
    list_organization_admin_accounts(params::Dict{String,<:Any})

Retrieves information about the delegated Amazon Macie administrator account for an
organization in Organizations.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of items to include in each page of a paginated
  response.
- `"nextToken"`: The nextToken string that specifies which page of results to return in a
  paginated response.
"""
function list_organization_admin_accounts(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2("GET", "/admin"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_organization_admin_accounts(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "GET", "/admin", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_resource_profile_artifacts(resource_arn)
    list_resource_profile_artifacts(resource_arn, params::Dict{String,<:Any})

Retrieves information about objects that Amazon Macie selected from an S3 bucket for
automated sensitive data discovery.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the S3 bucket that the request applies
  to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: The nextToken string that specifies which page of results to return in a
  paginated response.
"""
function list_resource_profile_artifacts(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "GET",
        "/resource-profiles/artifacts",
        Dict{String,Any}("resourceArn" => resourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_resource_profile_artifacts(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return macie2(
        "GET",
        "/resource-profiles/artifacts",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceArn" => resourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_resource_profile_detections(resource_arn)
    list_resource_profile_detections(resource_arn, params::Dict{String,<:Any})

Retrieves information about the types and amount of sensitive data that Amazon Macie found
in an S3 bucket.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the S3 bucket that the request applies
  to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of items to include in each page of a paginated
  response.
- `"nextToken"`: The nextToken string that specifies which page of results to return in a
  paginated response.
"""
function list_resource_profile_detections(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "GET",
        "/resource-profiles/detections",
        Dict{String,Any}("resourceArn" => resourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_resource_profile_detections(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return macie2(
        "GET",
        "/resource-profiles/detections",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceArn" => resourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_sensitivity_inspection_templates()
    list_sensitivity_inspection_templates(params::Dict{String,<:Any})

 Retrieves a subset of information about the sensitivity inspection template for an account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of items to include in each page of a paginated
  response.
- `"nextToken"`: The nextToken string that specifies which page of results to return in a
  paginated response.
"""
function list_sensitivity_inspection_templates(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "GET",
        "/templates/sensitivity-inspections";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_sensitivity_inspection_templates(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "GET",
        "/templates/sensitivity-inspections",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Retrieves the tags (keys and values) that are associated with an Amazon Macie resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return macie2(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_classification_export_configuration(configuration)
    put_classification_export_configuration(configuration, params::Dict{String,<:Any})

Adds or updates the configuration settings for storing data classification results.

# Arguments
- `configuration`: The location to store data classification results in, and the encryption
  settings to use when storing results in that location.

"""
function put_classification_export_configuration(
    configuration; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "PUT",
        "/classification-export-configuration",
        Dict{String,Any}("configuration" => configuration);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_classification_export_configuration(
    configuration,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return macie2(
        "PUT",
        "/classification-export-configuration",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("configuration" => configuration), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_findings_publication_configuration()
    put_findings_publication_configuration(params::Dict{String,<:Any})

Updates the configuration settings for publishing findings to Security Hub.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive token that you provide to ensure the
  idempotency of the request.
- `"securityHubConfiguration"`: The configuration settings that determine which findings to
  publish to Security Hub.
"""
function put_findings_publication_configuration(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "PUT",
        "/findings-publication-configuration",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_findings_publication_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "PUT",
        "/findings-publication-configuration",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    search_resources()
    search_resources(params::Dict{String,<:Any})

Retrieves (queries) statistical data and other information about Amazon Web Services
resources that Amazon Macie monitors and analyzes.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"bucketCriteria"`: The filter conditions that determine which S3 buckets to include or
  exclude from the query results.
- `"maxResults"`: The maximum number of items to include in each page of the response. The
  default value is 50.
- `"nextToken"`: The nextToken string that specifies which page of results to return in a
  paginated response.
- `"sortCriteria"`: The criteria to use to sort the results.
"""
function search_resources(; aws_config::AbstractAWSConfig=current_aws_config())
    return macie2(
        "POST",
        "/datasources/search-resources";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function search_resources(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "POST",
        "/datasources/search-resources",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds or updates one or more tags (keys and values) that are associated with an Amazon Macie
resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.
- `tags`: A map of key-value pairs that specifies the tags to associate with the resource.
  A resource can have a maximum of 50 tags. Each tag consists of a tag key and an associated
  tag value. The maximum length of a tag key is 128 characters. The maximum length of a tag
  value is 256 characters.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return macie2(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return macie2(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    test_custom_data_identifier(regex, sample_text)
    test_custom_data_identifier(regex, sample_text, params::Dict{String,<:Any})

Tests criteria for a custom data identifier.

# Arguments
- `regex`: The regular expression (regex) that defines the pattern to match. The expression
  can contain as many as 512 characters.
- `sample_text`: The sample text to inspect by using the custom data identifier. The text
  can contain as many as 1,000 characters.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ignoreWords"`: An array that lists specific character sequences (ignore words) to
  exclude from the results. If the text matched by the regular expression contains any string
  in this array, Amazon Macie ignores it. The array can contain as many as 10 ignore words.
  Each ignore word can contain 4-90 UTF-8 characters. Ignore words are case sensitive.
- `"keywords"`: An array that lists specific character sequences (keywords), one of which
  must precede and be within proximity (maximumMatchDistance) of the regular expression to
  match. The array can contain as many as 50 keywords. Each keyword can contain 3-90 UTF-8
  characters. Keywords aren't case sensitive.
- `"maximumMatchDistance"`: The maximum number of characters that can exist between the end
  of at least one complete character sequence specified by the keywords array and the end of
  the text that matches the regex pattern. If a complete keyword precedes all the text that
  matches the pattern and the keyword is within the specified distance, Amazon Macie includes
  the result. The distance can be 1-300 characters. The default value is 50.
"""
function test_custom_data_identifier(
    regex, sampleText; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "POST",
        "/custom-data-identifiers/test",
        Dict{String,Any}("regex" => regex, "sampleText" => sampleText);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function test_custom_data_identifier(
    regex,
    sampleText,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return macie2(
        "POST",
        "/custom-data-identifiers/test",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("regex" => regex, "sampleText" => sampleText),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes one or more tags (keys and values) from an Amazon Macie resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.
- `tag_keys`: One or more tags (keys) to remove from the resource. In an HTTP request to
  remove multiple tags, append the tagKeys parameter and argument for each tag to remove,
  separated by an ampersand (&amp;).

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return macie2(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_allow_list(criteria, id, name)
    update_allow_list(criteria, id, name, params::Dict{String,<:Any})

Updates the settings for an allow list.

# Arguments
- `criteria`: The criteria that specify the text or text pattern to ignore. The criteria
  can be the location and name of an S3 object that lists specific text to ignore
  (s3WordsList), or a regular expression that defines a text pattern to ignore (regex). You
  can change a list's underlying criteria, such as the name of the S3 object or the regular
  expression to use. However, you can't change the type from s3WordsList to regex or the
  other way around.
- `id`: The unique identifier for the Amazon Macie resource that the request applies to.
- `name`: A custom name for the allow list. The name can contain as many as 128 characters.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A custom description of the allow list. The description can contain as
  many as 512 characters.
"""
function update_allow_list(
    criteria, id, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "PUT",
        "/allow-lists/$(id)",
        Dict{String,Any}("criteria" => criteria, "name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_allow_list(
    criteria,
    id,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return macie2(
        "PUT",
        "/allow-lists/$(id)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("criteria" => criteria, "name" => name), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_automated_discovery_configuration(status)
    update_automated_discovery_configuration(status, params::Dict{String,<:Any})

Changes the configuration settings and status of automated sensitive data discovery for an
organization or standalone account.

# Arguments
- `status`: The new status of automated sensitive data discovery for the organization or
  account. Valid values are: ENABLED, start or resume all automated sensitive data discovery
  activities; and, DISABLED, stop performing all automated sensitive data discovery
  activities. If you specify DISABLED for an administrator account, you also disable
  automated sensitive data discovery for all member accounts in the organization.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"autoEnableOrganizationMembers"`: Specifies whether to automatically enable automated
  sensitive data discovery for accounts in the organization. Valid values are: ALL (default),
  enable it for all existing accounts and new member accounts; NEW, enable it only for new
  member accounts; and, NONE, don't enable it for any accounts. If you specify NEW or NONE,
  automated sensitive data discovery continues to be enabled for any existing accounts that
  it's currently enabled for. To enable or disable it for individual member accounts, specify
  NEW or NONE, and then enable or disable it for each account by using the
  BatchUpdateAutomatedDiscoveryAccounts operation.
"""
function update_automated_discovery_configuration(
    status; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "PUT",
        "/automated-discovery/configuration",
        Dict{String,Any}("status" => status);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_automated_discovery_configuration(
    status, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "PUT",
        "/automated-discovery/configuration",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("status" => status), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_classification_job(job_id, job_status)
    update_classification_job(job_id, job_status, params::Dict{String,<:Any})

Changes the status of a classification job.

# Arguments
- `job_id`: The unique identifier for the classification job.
- `job_status`: The new status for the job. Valid values are: CANCELLED - Stops the job
  permanently and cancels it. This value is valid only if the job's current status is IDLE,
  PAUSED, RUNNING, or USER_PAUSED. If you specify this value and the job's current status is
  RUNNING, Amazon Macie immediately begins to stop all processing tasks for the job. You
  can't resume or restart a job after you cancel it. RUNNING - Resumes the job. This value is
  valid only if the job's current status is USER_PAUSED. If you paused the job while it was
  actively running and you specify this value less than 30 days after you paused the job,
  Macie immediately resumes processing from the point where you paused the job. Otherwise,
  Macie resumes the job according to the schedule and other settings for the job. USER_PAUSED
  - Pauses the job temporarily. This value is valid only if the job's current status is IDLE,
  PAUSED, or RUNNING. If you specify this value and the job's current status is RUNNING,
  Macie immediately begins to pause all processing tasks for the job. If you pause a one-time
  job and you don't resume it within 30 days, the job expires and Macie cancels the job. If
  you pause a recurring job when its status is RUNNING and you don't resume it within 30
  days, the job run expires and Macie cancels the run. To check the expiration date, refer to
  the UserPausedDetails.jobExpiresAt property.

"""
function update_classification_job(
    jobId, jobStatus; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "PATCH",
        "/jobs/$(jobId)",
        Dict{String,Any}("jobStatus" => jobStatus);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_classification_job(
    jobId,
    jobStatus,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return macie2(
        "PATCH",
        "/jobs/$(jobId)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("jobStatus" => jobStatus), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_classification_scope(id)
    update_classification_scope(id, params::Dict{String,<:Any})

Updates the classification scope settings for an account.

# Arguments
- `id`: The unique identifier for the Amazon Macie resource that the request applies to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"s3"`: The S3 buckets to add or remove from the exclusion list defined by the
  classification scope.
"""
function update_classification_scope(id; aws_config::AbstractAWSConfig=current_aws_config())
    return macie2(
        "PATCH",
        "/classification-scopes/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_classification_scope(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "PATCH",
        "/classification-scopes/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_findings_filter(id)
    update_findings_filter(id, params::Dict{String,<:Any})

Updates the criteria and other settings for a findings filter.

# Arguments
- `id`: The unique identifier for the Amazon Macie resource that the request applies to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"action"`: The action to perform on findings that match the filter criteria
  (findingCriteria). Valid values are: ARCHIVE, suppress (automatically archive) the
  findings; and, NOOP, don't perform any action on the findings.
- `"clientToken"`: A unique, case-sensitive token that you provide to ensure the
  idempotency of the request.
- `"description"`: A custom description of the filter. The description can contain as many
  as 512 characters. We strongly recommend that you avoid including any sensitive data in the
  description of a filter. Other users of your account might be able to see this description,
  depending on the actions that they're allowed to perform in Amazon Macie.
- `"findingCriteria"`: The criteria to use to filter findings.
- `"name"`: A custom name for the filter. The name must contain at least 3 characters and
  can contain as many as 64 characters. We strongly recommend that you avoid including any
  sensitive data in the name of a filter. Other users of your account might be able to see
  this name, depending on the actions that they're allowed to perform in Amazon Macie.
- `"position"`: The position of the filter in the list of saved filters on the Amazon Macie
  console. This value also determines the order in which the filter is applied to findings,
  relative to other filters that are also applied to the findings.
"""
function update_findings_filter(id; aws_config::AbstractAWSConfig=current_aws_config())
    return macie2(
        "PATCH",
        "/findingsfilters/$(id)",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_findings_filter(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "PATCH",
        "/findingsfilters/$(id)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_macie_session()
    update_macie_session(params::Dict{String,<:Any})

Suspends or re-enables Amazon Macie, or updates the configuration settings for a Macie
account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"findingPublishingFrequency"`: Specifies how often to publish updates to policy findings
  for the account. This includes publishing updates to Security Hub and Amazon EventBridge
  (formerly Amazon CloudWatch Events).
- `"status"`: Specifies a new status for the account. Valid values are: ENABLED, resume all
  Amazon Macie activities for the account; and, PAUSED, suspend all Macie activities for the
  account.
"""
function update_macie_session(; aws_config::AbstractAWSConfig=current_aws_config())
    return macie2("PATCH", "/macie"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function update_macie_session(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "PATCH", "/macie", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    update_member_session(id, status)
    update_member_session(id, status, params::Dict{String,<:Any})

Enables an Amazon Macie administrator to suspend or re-enable Macie for a member account.

# Arguments
- `id`: The unique identifier for the Amazon Macie resource that the request applies to.
- `status`: Specifies the new status for the account. Valid values are: ENABLED, resume all
  Amazon Macie activities for the account; and, PAUSED, suspend all Macie activities for the
  account.

"""
function update_member_session(
    id, status; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "PATCH",
        "/macie/members/$(id)",
        Dict{String,Any}("status" => status);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_member_session(
    id,
    status,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return macie2(
        "PATCH",
        "/macie/members/$(id)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("status" => status), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_organization_configuration(auto_enable)
    update_organization_configuration(auto_enable, params::Dict{String,<:Any})

Updates the Amazon Macie configuration settings for an organization in Organizations.

# Arguments
- `auto_enable`: Specifies whether to enable Amazon Macie automatically for accounts that
  are added to the organization in Organizations.

"""
function update_organization_configuration(
    autoEnable; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "PATCH",
        "/admin/configuration",
        Dict{String,Any}("autoEnable" => autoEnable);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_organization_configuration(
    autoEnable,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return macie2(
        "PATCH",
        "/admin/configuration",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("autoEnable" => autoEnable), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_resource_profile(resource_arn)
    update_resource_profile(resource_arn, params::Dict{String,<:Any})

Updates the sensitivity score for an S3 bucket.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the S3 bucket that the request applies
  to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"sensitivityScoreOverride"`: The new sensitivity score for the bucket. Valid values are:
  100, assign the maximum score and apply the Sensitive label to the bucket; and, null
  (empty), assign a score that Amazon Macie calculates automatically after you submit the
  request.
"""
function update_resource_profile(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "PATCH",
        "/resource-profiles",
        Dict{String,Any}("resourceArn" => resourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_resource_profile(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return macie2(
        "PATCH",
        "/resource-profiles",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceArn" => resourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_resource_profile_detections(resource_arn)
    update_resource_profile_detections(resource_arn, params::Dict{String,<:Any})

Updates the sensitivity scoring settings for an S3 bucket.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the S3 bucket that the request applies
  to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"suppressDataIdentifiers"`: An array of objects, one for each custom data identifier or
  managed data identifier that detected the type of sensitive data to start excluding or
  including in the bucket's score. To start including all sensitive data types in the score,
  don't specify any values for this array.
"""
function update_resource_profile_detections(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "PATCH",
        "/resource-profiles/detections",
        Dict{String,Any}("resourceArn" => resourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_resource_profile_detections(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return macie2(
        "PATCH",
        "/resource-profiles/detections",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceArn" => resourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_reveal_configuration(configuration)
    update_reveal_configuration(configuration, params::Dict{String,<:Any})

Updates the status and configuration settings for retrieving occurrences of sensitive data
reported by findings.

# Arguments
- `configuration`: The KMS key to use to encrypt the sensitive data, and the status of the
  configuration for the Amazon Macie account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"retrievalConfiguration"`: The access method and settings to use when retrieving the
  sensitive data.
"""
function update_reveal_configuration(
    configuration; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "PUT",
        "/reveal-configuration",
        Dict{String,Any}("configuration" => configuration);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_reveal_configuration(
    configuration,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return macie2(
        "PUT",
        "/reveal-configuration",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("configuration" => configuration), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_sensitivity_inspection_template(id)
    update_sensitivity_inspection_template(id, params::Dict{String,<:Any})

 Updates the settings for the sensitivity inspection template for an account.

# Arguments
- `id`: The unique identifier for the Amazon Macie resource that the request applies to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A custom description of the template. The description can contain as
  many as 200 characters.
- `"excludes"`:  The managed data identifiers to explicitly exclude (not use) when
  performing automated sensitive data discovery. To exclude an allow list or custom data
  identifier that's currently included by the template, update the values for the
  SensitivityInspectionTemplateIncludes.allowListIds and
  SensitivityInspectionTemplateIncludes.customDataIdentifierIds properties, respectively.
- `"includes"`: The allow lists, custom data identifiers, and managed data identifiers to
  explicitly include (use) when performing automated sensitive data discovery.
"""
function update_sensitivity_inspection_template(
    id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "PUT",
        "/templates/sensitivity-inspections/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_sensitivity_inspection_template(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return macie2(
        "PUT",
        "/templates/sensitivity-inspections/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: kendra
using AWS.Compat
using AWS.UUIDs

"""
    associate_entities_to_experience(entity_list, id, index_id)
    associate_entities_to_experience(entity_list, id, index_id, params::Dict{String,<:Any})

Grants users or groups in your IAM Identity Center identity source access to your Amazon
Kendra experience. You can create an Amazon Kendra experience such as a search application.
For more information on creating a search application experience, see Building a search
experience with no code.

# Arguments
- `entity_list`: Lists users or groups in your IAM Identity Center identity source.
- `id`: The identifier of your Amazon Kendra experience.
- `index_id`: The identifier of the index for your Amazon Kendra experience.

"""
function associate_entities_to_experience(
    EntityList, Id, IndexId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra(
        "AssociateEntitiesToExperience",
        Dict{String,Any}("EntityList" => EntityList, "Id" => Id, "IndexId" => IndexId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_entities_to_experience(
    EntityList,
    Id,
    IndexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "AssociateEntitiesToExperience",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EntityList" => EntityList, "Id" => Id, "IndexId" => IndexId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_personas_to_entities(id, index_id, personas)
    associate_personas_to_entities(id, index_id, personas, params::Dict{String,<:Any})

Defines the specific permissions of users or groups in your IAM Identity Center identity
source with access to your Amazon Kendra experience. You can create an Amazon Kendra
experience such as a search application. For more information on creating a search
application experience, see Building a search experience with no code.

# Arguments
- `id`: The identifier of your Amazon Kendra experience.
- `index_id`: The identifier of the index for your Amazon Kendra experience.
- `personas`: The personas that define the specific permissions of users or groups in your
  IAM Identity Center identity source. The available personas or access roles are Owner and
  Viewer. For more information on these personas, see Providing access to your search page.

"""
function associate_personas_to_entities(
    Id, IndexId, Personas; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra(
        "AssociatePersonasToEntities",
        Dict{String,Any}("Id" => Id, "IndexId" => IndexId, "Personas" => Personas);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_personas_to_entities(
    Id,
    IndexId,
    Personas,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "AssociatePersonasToEntities",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Id" => Id, "IndexId" => IndexId, "Personas" => Personas),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_delete_document(document_id_list, index_id)
    batch_delete_document(document_id_list, index_id, params::Dict{String,<:Any})

Removes one or more documents from an index. The documents must have been added with the
BatchPutDocument API. The documents are deleted asynchronously. You can see the progress of
the deletion by using Amazon Web Services CloudWatch. Any error messages related to the
processing of the batch are sent to your Amazon Web Services CloudWatch log. You can also
use the BatchGetDocumentStatus API to monitor the progress of deleting your documents.
Deleting documents from an index using BatchDeleteDocument could take up to an hour or
more, depending on the number of documents you want to delete.

# Arguments
- `document_id_list`: One or more identifiers for documents to delete from the index.
- `index_id`: The identifier of the index that contains the documents to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DataSourceSyncJobMetricTarget"`:
"""
function batch_delete_document(
    DocumentIdList, IndexId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra(
        "BatchDeleteDocument",
        Dict{String,Any}("DocumentIdList" => DocumentIdList, "IndexId" => IndexId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_delete_document(
    DocumentIdList,
    IndexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "BatchDeleteDocument",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DocumentIdList" => DocumentIdList, "IndexId" => IndexId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_delete_featured_results_set(featured_results_set_ids, index_id)
    batch_delete_featured_results_set(featured_results_set_ids, index_id, params::Dict{String,<:Any})

Removes one or more sets of featured results. Features results are placed above all other
results for certain queries. If there's an exact match of a query, then one or more
specific documents are featured in the search results.

# Arguments
- `featured_results_set_ids`: The identifiers of the featured results sets that you want to
  delete.
- `index_id`: The identifier of the index used for featuring results.

"""
function batch_delete_featured_results_set(
    FeaturedResultsSetIds, IndexId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra(
        "BatchDeleteFeaturedResultsSet",
        Dict{String,Any}(
            "FeaturedResultsSetIds" => FeaturedResultsSetIds, "IndexId" => IndexId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_delete_featured_results_set(
    FeaturedResultsSetIds,
    IndexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "BatchDeleteFeaturedResultsSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "FeaturedResultsSetIds" => FeaturedResultsSetIds, "IndexId" => IndexId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_get_document_status(document_info_list, index_id)
    batch_get_document_status(document_info_list, index_id, params::Dict{String,<:Any})

Returns the indexing status for one or more documents submitted with the  BatchPutDocument
API. When you use the BatchPutDocument API, documents are indexed asynchronously. You can
use the BatchGetDocumentStatus API to get the current status of a list of documents so that
you can determine if they have been successfully indexed. You can also use the
BatchGetDocumentStatus API to check the status of the  BatchDeleteDocument API. When a
document is deleted from the index, Amazon Kendra returns NOT_FOUND as the status.

# Arguments
- `document_info_list`: A list of DocumentInfo objects that identify the documents for
  which to get the status. You identify the documents by their document ID and optional
  attributes.
- `index_id`: The identifier of the index to add documents to. The index ID is returned by
  the CreateIndex  API.

"""
function batch_get_document_status(
    DocumentInfoList, IndexId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra(
        "BatchGetDocumentStatus",
        Dict{String,Any}("DocumentInfoList" => DocumentInfoList, "IndexId" => IndexId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_document_status(
    DocumentInfoList,
    IndexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "BatchGetDocumentStatus",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DocumentInfoList" => DocumentInfoList, "IndexId" => IndexId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_put_document(documents, index_id)
    batch_put_document(documents, index_id, params::Dict{String,<:Any})

Adds one or more documents to an index. The BatchPutDocument API enables you to ingest
inline documents or a set of documents stored in an Amazon S3 bucket. Use this API to
ingest your text and unstructured text into an index, add custom attributes to the
documents, and to attach an access control list to the documents added to the index. The
documents are indexed asynchronously. You can see the progress of the batch using Amazon
Web Services CloudWatch. Any error messages related to processing the batch are sent to
your Amazon Web Services CloudWatch log. You can also use the BatchGetDocumentStatus API to
monitor the progress of indexing your documents. For an example of ingesting inline
documents using Python and Java SDKs, see Adding files directly to an index.

# Arguments
- `documents`: One or more documents to add to the index. Documents have the following file
  size limits.   50 MB total size for any file   5 MB extracted text for any file   For more
  information, see Quotas.
- `index_id`: The identifier of the index to add the documents to. You need to create the
  index first using the CreateIndex API.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CustomDocumentEnrichmentConfiguration"`: Configuration information for altering your
  document metadata and content during the document ingestion process when you use the
  BatchPutDocument API. For more information on how to create, modify and delete document
  metadata, or make other content alterations when you ingest documents into Amazon Kendra,
  see Customizing document metadata during the ingestion process.
- `"RoleArn"`: The Amazon Resource Name (ARN) of an IAM role with permission to access your
  S3 bucket. For more information, see IAM access roles for Amazon Kendra.
"""
function batch_put_document(
    Documents, IndexId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra(
        "BatchPutDocument",
        Dict{String,Any}("Documents" => Documents, "IndexId" => IndexId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_put_document(
    Documents,
    IndexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "BatchPutDocument",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Documents" => Documents, "IndexId" => IndexId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    clear_query_suggestions(index_id)
    clear_query_suggestions(index_id, params::Dict{String,<:Any})

Clears existing query suggestions from an index. This deletes existing suggestions only,
not the queries in the query log. After you clear suggestions, Amazon Kendra learns new
suggestions based on new queries added to the query log from the time you cleared
suggestions. If you do not see any new suggestions, then please allow Amazon Kendra to
collect enough queries to learn new suggestions.  ClearQuerySuggestions is currently not
supported in the Amazon Web Services GovCloud (US-West) region.

# Arguments
- `index_id`: The identifier of the index you want to clear query suggestions from.

"""
function clear_query_suggestions(
    IndexId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra(
        "ClearQuerySuggestions",
        Dict{String,Any}("IndexId" => IndexId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function clear_query_suggestions(
    IndexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "ClearQuerySuggestions",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("IndexId" => IndexId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_access_control_configuration(index_id, name)
    create_access_control_configuration(index_id, name, params::Dict{String,<:Any})

Creates an access configuration for your documents. This includes user and group access
information for your documents. This is useful for user context filtering, where search
results are filtered based on the user or their group access to documents. You can use this
to re-configure your existing document level access control without indexing all of your
documents again. For example, your index contains top-secret company documents that only
certain employees or users should access. One of these users leaves the company or switches
to a team that should be blocked from accessing top-secret documents. The user still has
access to top-secret documents because the user had access when your documents were
previously indexed. You can create a specific access control configuration for the user
with deny access. You can later update the access control configuration to allow access if
the user returns to the company and re-joins the 'top-secret' team. You can re-configure
access control for your documents as circumstances change. To apply your access control
configuration to certain documents, you call the BatchPutDocument API with the
AccessControlConfigurationId included in the Document object. If you use an S3 bucket as a
data source, you update the .metadata.json with the AccessControlConfigurationId and
synchronize your data source. Amazon Kendra currently only supports access control
configuration for S3 data sources and documents indexed using the BatchPutDocument API.

# Arguments
- `index_id`: The identifier of the index to create an access control configuration for
  your documents.
- `name`: A name for the access control configuration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccessControlList"`: Information on principals (users and/or groups) and which
  documents they should have access to. This is useful for user context filtering, where
  search results are filtered based on the user or their group access to documents.
- `"ClientToken"`: A token that you provide to identify the request to create an access
  control configuration. Multiple calls to the CreateAccessControlConfiguration API with the
  same client token will create only one access control configuration.
- `"Description"`: A description for the access control configuration.
- `"HierarchicalAccessControlList"`: The list of principal lists that define the hierarchy
  for which documents users should have access to.
"""
function create_access_control_configuration(
    IndexId, Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra(
        "CreateAccessControlConfiguration",
        Dict{String,Any}(
            "IndexId" => IndexId, "Name" => Name, "ClientToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_access_control_configuration(
    IndexId,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "CreateAccessControlConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "IndexId" => IndexId, "Name" => Name, "ClientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_data_source(index_id, name, type)
    create_data_source(index_id, name, type, params::Dict{String,<:Any})

Creates a data source connector that you want to use with an Amazon Kendra index. You
specify a name, data source connector type and description for your data source. You also
specify configuration information for the data source connector.  CreateDataSource is a
synchronous operation. The operation returns 200 if the data source was successfully
created. Otherwise, an exception is raised. For an example of creating an index and data
source using the Python SDK, see Getting started with Python SDK. For an example of
creating an index and data source using the Java SDK, see Getting started with Java SDK.

# Arguments
- `index_id`: The identifier of the index you want to use with the data source connector.
- `name`: A name for the data source connector.
- `type`: The type of data source repository. For example, SHAREPOINT.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: A token that you provide to identify the request to create a data source
  connector. Multiple calls to the CreateDataSource API with the same client token will
  create only one data source connector.
- `"Configuration"`: Configuration information to connect to your data source repository.
  You can't specify the Configuration parameter when the Type parameter is set to CUSTOM. If
  you do, you receive a ValidationException exception. The Configuration parameter is
  required for all other data sources.
- `"CustomDocumentEnrichmentConfiguration"`: Configuration information for altering
  document metadata and content during the document ingestion process. For more information
  on how to create, modify and delete document metadata, or make other content alterations
  when you ingest documents into Amazon Kendra, see Customizing document metadata during the
  ingestion process.
- `"Description"`: A description for the data source connector.
- `"LanguageCode"`: The code for a language. This allows you to support a language for all
  documents when creating the data source connector. English is supported by default. For
  more information on supported languages, including their codes, see Adding documents in
  languages other than English.
- `"RoleArn"`: The Amazon Resource Name (ARN) of an IAM role with permission to access the
  data source and required resources. For more information, see IAM access roles for Amazon
  Kendra.. You can't specify the RoleArn parameter when the Type parameter is set to CUSTOM.
  If you do, you receive a ValidationException exception. The RoleArn parameter is required
  for all other data sources.
- `"Schedule"`: Sets the frequency for Amazon Kendra to check the documents in your data
  source repository and update the index. If you don't set a schedule Amazon Kendra will not
  periodically update the index. You can call the StartDataSourceSyncJob API to update the
  index. Specify a cron- format schedule string or an empty string to indicate that the index
  is updated on demand. You can't specify the Schedule parameter when the Type parameter is
  set to CUSTOM. If you do, you receive a ValidationException exception.
- `"Tags"`: A list of key-value pairs that identify or categorize the data source
  connector. You can also use tags to help control access to the data source connector. Tag
  keys and values can consist of Unicode letters, digits, white space, and any of the
  following symbols: _ . : / = + - @.
- `"VpcConfiguration"`: Configuration information for an Amazon Virtual Private Cloud to
  connect to your data source. For more information, see Configuring a VPC.
"""
function create_data_source(
    IndexId, Name, Type; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra(
        "CreateDataSource",
        Dict{String,Any}(
            "IndexId" => IndexId,
            "Name" => Name,
            "Type" => Type,
            "ClientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_data_source(
    IndexId,
    Name,
    Type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "CreateDataSource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "IndexId" => IndexId,
                    "Name" => Name,
                    "Type" => Type,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_experience(index_id, name)
    create_experience(index_id, name, params::Dict{String,<:Any})

Creates an Amazon Kendra experience such as a search application. For more information on
creating a search application experience, including using the Python and Java SDKs, see
Building a search experience with no code.

# Arguments
- `index_id`: The identifier of the index for your Amazon Kendra experience.
- `name`: A name for your Amazon Kendra experience.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: A token that you provide to identify the request to create your Amazon
  Kendra experience. Multiple calls to the CreateExperience API with the same client token
  creates only one Amazon Kendra experience.
- `"Configuration"`: Configuration information for your Amazon Kendra experience. This
  includes ContentSourceConfiguration, which specifies the data source IDs and/or FAQ IDs,
  and UserIdentityConfiguration, which specifies the user or group information to grant
  access to your Amazon Kendra experience.
- `"Description"`: A description for your Amazon Kendra experience.
- `"RoleArn"`: The Amazon Resource Name (ARN) of an IAM role with permission to access
  Query API, GetQuerySuggestions API, and other required APIs. The role also must include
  permission to access IAM Identity Center that stores your user and group information. For
  more information, see IAM access roles for Amazon Kendra.
"""
function create_experience(
    IndexId, Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra(
        "CreateExperience",
        Dict{String,Any}(
            "IndexId" => IndexId, "Name" => Name, "ClientToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_experience(
    IndexId,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "CreateExperience",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "IndexId" => IndexId, "Name" => Name, "ClientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_faq(index_id, name, role_arn, s3_path)
    create_faq(index_id, name, role_arn, s3_path, params::Dict{String,<:Any})

Creates a set of frequently ask questions (FAQs) using a specified FAQ file stored in an
Amazon S3 bucket. Adding FAQs to an index is an asynchronous operation. For an example of
adding an FAQ to an index using Python and Java SDKs, see Using your FAQ file.

# Arguments
- `index_id`: The identifier of the index for the FAQ.
- `name`: A name for the FAQ.
- `role_arn`: The Amazon Resource Name (ARN) of an IAM role with permission to access the
  S3 bucket that contains the FAQs. For more information, see IAM access roles for Amazon
  Kendra.
- `s3_path`: The path to the FAQ file in S3.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: A token that you provide to identify the request to create a FAQ.
  Multiple calls to the CreateFaqRequest API with the same client token will create only one
  FAQ.
- `"Description"`: A description for the FAQ.
- `"FileFormat"`: The format of the FAQ input file. You can choose between a basic CSV
  format, a CSV format that includes customs attributes in a header, and a JSON format that
  includes custom attributes. The default format is CSV. The format must match the format of
  the file stored in the S3 bucket identified in the S3Path parameter. For more information,
  see Adding questions and answers.
- `"LanguageCode"`: The code for a language. This allows you to support a language for the
  FAQ document. English is supported by default. For more information on supported languages,
  including their codes, see Adding documents in languages other than English.
- `"Tags"`: A list of key-value pairs that identify the FAQ. You can use the tags to
  identify and organize your resources and to control access to resources.
"""
function create_faq(
    IndexId, Name, RoleArn, S3Path; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra(
        "CreateFaq",
        Dict{String,Any}(
            "IndexId" => IndexId,
            "Name" => Name,
            "RoleArn" => RoleArn,
            "S3Path" => S3Path,
            "ClientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_faq(
    IndexId,
    Name,
    RoleArn,
    S3Path,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "CreateFaq",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "IndexId" => IndexId,
                    "Name" => Name,
                    "RoleArn" => RoleArn,
                    "S3Path" => S3Path,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_featured_results_set(featured_results_set_name, index_id)
    create_featured_results_set(featured_results_set_name, index_id, params::Dict{String,<:Any})

Creates a set of featured results to display at the top of the search results page.
Featured results are placed above all other results for certain queries. You map specific
queries to specific documents for featuring in the results. If a query contains an exact
match, then one or more specific documents are featured in the search results. You can
create up to 50 sets of featured results per index. You can request to increase this limit
by contacting Support.

# Arguments
- `featured_results_set_name`: A name for the set of featured results.
- `index_id`: The identifier of the index that you want to use for featuring results.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: A token that you provide to identify the request to create a set of
  featured results. Multiple calls to the CreateFeaturedResultsSet API with the same client
  token will create only one featured results set.
- `"Description"`: A description for the set of featured results.
- `"FeaturedDocuments"`: A list of document IDs for the documents you want to feature at
  the top of the search results page. For more information on the list of documents, see
  FeaturedResultsSet.
- `"QueryTexts"`: A list of queries for featuring results. For more information on the list
  of queries, see FeaturedResultsSet.
- `"Status"`: The current status of the set of featured results. When the value is ACTIVE,
  featured results are ready for use. You can still configure your settings before setting
  the status to ACTIVE. You can set the status to ACTIVE or INACTIVE using the
  UpdateFeaturedResultsSet API. The queries you specify for featured results must be unique
  per featured results set for each index, whether the status is ACTIVE or INACTIVE.
- `"Tags"`: A list of key-value pairs that identify or categorize the featured results set.
  You can also use tags to help control access to the featured results set. Tag keys and
  values can consist of Unicode letters, digits, white space, and any of the following
  symbols:_ . : / = + - @.
"""
function create_featured_results_set(
    FeaturedResultsSetName, IndexId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra(
        "CreateFeaturedResultsSet",
        Dict{String,Any}(
            "FeaturedResultsSetName" => FeaturedResultsSetName, "IndexId" => IndexId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_featured_results_set(
    FeaturedResultsSetName,
    IndexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "CreateFeaturedResultsSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "FeaturedResultsSetName" => FeaturedResultsSetName, "IndexId" => IndexId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_index(name, role_arn)
    create_index(name, role_arn, params::Dict{String,<:Any})

Creates an Amazon Kendra index. Index creation is an asynchronous API. To determine if
index creation has completed, check the Status field returned from a call to DescribeIndex.
The Status field is set to ACTIVE when the index is ready to use. Once the index is active,
you can index your documents using the BatchPutDocument API or using one of the supported
data sources. For an example of creating an index and data source using the Python SDK, see
Getting started with Python SDK. For an example of creating an index and data source using
the Java SDK, see Getting started with Java SDK.

# Arguments
- `name`: A name for the index.
- `role_arn`: The Amazon Resource Name (ARN) of an IAM role with permission to access your
  Amazon CloudWatch logs and metrics. For more information, see IAM access roles for Amazon
  Kendra.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: A token that you provide to identify the request to create an index.
  Multiple calls to the CreateIndex API with the same client token will create only one index.
- `"Description"`: A description for the index.
- `"Edition"`: The Amazon Kendra edition to use for the index. Choose DEVELOPER_EDITION for
  indexes intended for development, testing, or proof of concept. Use ENTERPRISE_EDITION for
  production. Once you set the edition for an index, it can't be changed. The Edition
  parameter is optional. If you don't supply a value, the default is ENTERPRISE_EDITION. For
  more information on quota limits for Enterprise and Developer editions, see Quotas.
- `"ServerSideEncryptionConfiguration"`: The identifier of the KMS customer managed key
  (CMK) that's used to encrypt data indexed by Amazon Kendra. Amazon Kendra doesn't support
  asymmetric CMKs.
- `"Tags"`: A list of key-value pairs that identify or categorize the index. You can also
  use tags to help control access to the index. Tag keys and values can consist of Unicode
  letters, digits, white space, and any of the following symbols: _ . : / = + - @.
- `"UserContextPolicy"`: The user context policy.  ATTRIBUTE_FILTER  All indexed content is
  searchable and displayable for all users. If you want to filter search results on user
  context, you can use the attribute filters of _user_id and _group_ids or you can provide
  user and group information in UserContext.   USER_TOKEN  Enables token-based user access
  control to filter search results on user context. All documents with no access control and
  all documents accessible to the user will be searchable and displayable.
- `"UserGroupResolutionConfiguration"`: Gets users and groups from IAM Identity Center
  identity source. To configure this, see UserGroupResolutionConfiguration. This is useful
  for user context filtering, where search results are filtered based on the user or their
  group access to documents.
- `"UserTokenConfigurations"`: The user token configuration.
"""
function create_index(Name, RoleArn; aws_config::AbstractAWSConfig=current_aws_config())
    return kendra(
        "CreateIndex",
        Dict{String,Any}(
            "Name" => Name, "RoleArn" => RoleArn, "ClientToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_index(
    Name,
    RoleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "CreateIndex",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Name" => Name, "RoleArn" => RoleArn, "ClientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_query_suggestions_block_list(index_id, name, role_arn, source_s3_path)
    create_query_suggestions_block_list(index_id, name, role_arn, source_s3_path, params::Dict{String,<:Any})

Creates a block list to exlcude certain queries from suggestions. Any query that contains
words or phrases specified in the block list is blocked or filtered out from being shown as
a suggestion. You need to provide the file location of your block list text file in your S3
bucket. In your text file, enter each block word or phrase on a separate line. For
information on the current quota limits for block lists, see Quotas for Amazon Kendra.
CreateQuerySuggestionsBlockList is currently not supported in the Amazon Web Services
GovCloud (US-West) region. For an example of creating a block list for query suggestions
using the Python SDK, see Query suggestions block list.

# Arguments
- `index_id`: The identifier of the index you want to create a query suggestions block list
  for.
- `name`: A name for the block list. For example, the name 'offensive-words', which
  includes all offensive words that could appear in user queries and need to be blocked from
  suggestions.
- `role_arn`: The Amazon Resource Name (ARN) of an IAM role with permission to access your
  S3 bucket that contains the block list text file. For more information, see IAM access
  roles for Amazon Kendra.
- `source_s3_path`: The S3 path to your block list text file in your S3 bucket. Each block
  word or phrase should be on a separate line in a text file. For information on the current
  quota limits for block lists, see Quotas for Amazon Kendra.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: A token that you provide to identify the request to create a query
  suggestions block list.
- `"Description"`: A description for the block list. For example, the description \"List of
  all offensive words that can appear in user queries and need to be blocked from
  suggestions.\"
- `"Tags"`: A list of key-value pairs that identify or categorize the block list. Tag keys
  and values can consist of Unicode letters, digits, white space, and any of the following
  symbols: _ . : / = + - @.
"""
function create_query_suggestions_block_list(
    IndexId, Name, RoleArn, SourceS3Path; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra(
        "CreateQuerySuggestionsBlockList",
        Dict{String,Any}(
            "IndexId" => IndexId,
            "Name" => Name,
            "RoleArn" => RoleArn,
            "SourceS3Path" => SourceS3Path,
            "ClientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_query_suggestions_block_list(
    IndexId,
    Name,
    RoleArn,
    SourceS3Path,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "CreateQuerySuggestionsBlockList",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "IndexId" => IndexId,
                    "Name" => Name,
                    "RoleArn" => RoleArn,
                    "SourceS3Path" => SourceS3Path,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_thesaurus(index_id, name, role_arn, source_s3_path)
    create_thesaurus(index_id, name, role_arn, source_s3_path, params::Dict{String,<:Any})

Creates a thesaurus for an index. The thesaurus contains a list of synonyms in Solr format.
For an example of adding a thesaurus file to an index, see Adding custom synonyms to an
index.

# Arguments
- `index_id`: The identifier of the index for the thesaurus.
- `name`: A name for the thesaurus.
- `role_arn`: The Amazon Resource Name (ARN) of an IAM role with permission to access your
  S3 bucket that contains the thesaurus file. For more information, see IAM access roles for
  Amazon Kendra.
- `source_s3_path`: The path to the thesaurus file in S3.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: A token that you provide to identify the request to create a thesaurus.
  Multiple calls to the CreateThesaurus API with the same client token will create only one
  thesaurus.
- `"Description"`: A description for the thesaurus.
- `"Tags"`: A list of key-value pairs that identify or categorize the thesaurus. You can
  also use tags to help control access to the thesaurus. Tag keys and values can consist of
  Unicode letters, digits, white space, and any of the following symbols: _ . : / = + - @.
"""
function create_thesaurus(
    IndexId, Name, RoleArn, SourceS3Path; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra(
        "CreateThesaurus",
        Dict{String,Any}(
            "IndexId" => IndexId,
            "Name" => Name,
            "RoleArn" => RoleArn,
            "SourceS3Path" => SourceS3Path,
            "ClientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_thesaurus(
    IndexId,
    Name,
    RoleArn,
    SourceS3Path,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "CreateThesaurus",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "IndexId" => IndexId,
                    "Name" => Name,
                    "RoleArn" => RoleArn,
                    "SourceS3Path" => SourceS3Path,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_access_control_configuration(id, index_id)
    delete_access_control_configuration(id, index_id, params::Dict{String,<:Any})

Deletes an access control configuration that you created for your documents in an index.
This includes user and group access information for your documents. This is useful for user
context filtering, where search results are filtered based on the user or their group
access to documents.

# Arguments
- `id`: The identifier of the access control configuration you want to delete.
- `index_id`: The identifier of the index for an access control configuration.

"""
function delete_access_control_configuration(
    Id, IndexId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra(
        "DeleteAccessControlConfiguration",
        Dict{String,Any}("Id" => Id, "IndexId" => IndexId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_access_control_configuration(
    Id,
    IndexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "DeleteAccessControlConfiguration",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Id" => Id, "IndexId" => IndexId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_data_source(id, index_id)
    delete_data_source(id, index_id, params::Dict{String,<:Any})

Deletes an Amazon Kendra data source connector. An exception is not thrown if the data
source is already being deleted. While the data source is being deleted, the Status field
returned by a call to the DescribeDataSource API is set to DELETING. For more information,
see Deleting Data Sources. Deleting an entire data source or re-syncing your index after
deleting specific documents from a data source could take up to an hour or more, depending
on the number of documents you want to delete.

# Arguments
- `id`: The identifier of the data source connector you want to delete.
- `index_id`: The identifier of the index used with the data source connector.

"""
function delete_data_source(Id, IndexId; aws_config::AbstractAWSConfig=current_aws_config())
    return kendra(
        "DeleteDataSource",
        Dict{String,Any}("Id" => Id, "IndexId" => IndexId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_data_source(
    Id,
    IndexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "DeleteDataSource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Id" => Id, "IndexId" => IndexId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_experience(id, index_id)
    delete_experience(id, index_id, params::Dict{String,<:Any})

Deletes your Amazon Kendra experience such as a search application. For more information on
creating a search application experience, see Building a search experience with no code.

# Arguments
- `id`: The identifier of your Amazon Kendra experience you want to delete.
- `index_id`: The identifier of the index for your Amazon Kendra experience.

"""
function delete_experience(Id, IndexId; aws_config::AbstractAWSConfig=current_aws_config())
    return kendra(
        "DeleteExperience",
        Dict{String,Any}("Id" => Id, "IndexId" => IndexId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_experience(
    Id,
    IndexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "DeleteExperience",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Id" => Id, "IndexId" => IndexId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_faq(id, index_id)
    delete_faq(id, index_id, params::Dict{String,<:Any})

Removes an FAQ from an index.

# Arguments
- `id`: The identifier of the FAQ you want to remove.
- `index_id`: The identifier of the index for the FAQ.

"""
function delete_faq(Id, IndexId; aws_config::AbstractAWSConfig=current_aws_config())
    return kendra(
        "DeleteFaq",
        Dict{String,Any}("Id" => Id, "IndexId" => IndexId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_faq(
    Id,
    IndexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "DeleteFaq",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Id" => Id, "IndexId" => IndexId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_index(id)
    delete_index(id, params::Dict{String,<:Any})

Deletes an Amazon Kendra index. An exception is not thrown if the index is already being
deleted. While the index is being deleted, the Status field returned by a call to the
DescribeIndex API is set to DELETING.

# Arguments
- `id`: The identifier of the index you want to delete.

"""
function delete_index(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return kendra(
        "DeleteIndex",
        Dict{String,Any}("Id" => Id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_index(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra(
        "DeleteIndex",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Id" => Id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_principal_mapping(group_id, index_id)
    delete_principal_mapping(group_id, index_id, params::Dict{String,<:Any})

Deletes a group so that all users and sub groups that belong to the group can no longer
access documents only available to that group. For example, after deleting the group
\"Summer Interns\", all interns who belonged to that group no longer see intern-only
documents in their search results. If you want to delete or replace users or sub groups of
a group, you need to use the PutPrincipalMapping operation. For example, if a user in the
group \"Engineering\" leaves the engineering team and another user takes their place, you
provide an updated list of users or sub groups that belong to the \"Engineering\" group
when calling PutPrincipalMapping. You can update your internal list of users or sub groups
and input this list when calling PutPrincipalMapping.  DeletePrincipalMapping is currently
not supported in the Amazon Web Services GovCloud (US-West) region.

# Arguments
- `group_id`: The identifier of the group you want to delete.
- `index_id`: The identifier of the index you want to delete a group from.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DataSourceId"`: The identifier of the data source you want to delete a group from. A
  group can be tied to multiple data sources. You can delete a group from accessing documents
  in a certain data source. For example, the groups \"Research\", \"Engineering\", and
  \"Sales and Marketing\" are all tied to the company's documents stored in the data sources
  Confluence and Salesforce. You want to delete \"Research\" and \"Engineering\" groups from
  Salesforce, so that these groups cannot access customer-related documents stored in
  Salesforce. Only \"Sales and Marketing\" should access documents in the Salesforce data
  source.
- `"OrderingId"`: The timestamp identifier you specify to ensure Amazon Kendra does not
  override the latest DELETE action with previous actions. The highest number ID, which is
  the ordering ID, is the latest action you want to process and apply on top of other actions
  with lower number IDs. This prevents previous actions with lower number IDs from possibly
  overriding the latest action. The ordering ID can be the Unix time of the last update you
  made to a group members list. You would then provide this list when calling
  PutPrincipalMapping. This ensures your DELETE action for that updated group with the latest
  members list doesn't get overwritten by earlier DELETE actions for the same group which are
  yet to be processed. The default ordering ID is the current Unix time in milliseconds that
  the action was received by Amazon Kendra.
"""
function delete_principal_mapping(
    GroupId, IndexId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra(
        "DeletePrincipalMapping",
        Dict{String,Any}("GroupId" => GroupId, "IndexId" => IndexId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_principal_mapping(
    GroupId,
    IndexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "DeletePrincipalMapping",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("GroupId" => GroupId, "IndexId" => IndexId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_query_suggestions_block_list(id, index_id)
    delete_query_suggestions_block_list(id, index_id, params::Dict{String,<:Any})

Deletes a block list used for query suggestions for an index. A deleted block list might
not take effect right away. Amazon Kendra needs to refresh the entire suggestions list to
add back the queries that were previously blocked.  DeleteQuerySuggestionsBlockList is
currently not supported in the Amazon Web Services GovCloud (US-West) region.

# Arguments
- `id`: The identifier of the block list you want to delete.
- `index_id`: The identifier of the index for the block list.

"""
function delete_query_suggestions_block_list(
    Id, IndexId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra(
        "DeleteQuerySuggestionsBlockList",
        Dict{String,Any}("Id" => Id, "IndexId" => IndexId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_query_suggestions_block_list(
    Id,
    IndexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "DeleteQuerySuggestionsBlockList",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Id" => Id, "IndexId" => IndexId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_thesaurus(id, index_id)
    delete_thesaurus(id, index_id, params::Dict{String,<:Any})

Deletes an Amazon Kendra thesaurus.

# Arguments
- `id`: The identifier of the thesaurus you want to delete.
- `index_id`: The identifier of the index for the thesaurus.

"""
function delete_thesaurus(Id, IndexId; aws_config::AbstractAWSConfig=current_aws_config())
    return kendra(
        "DeleteThesaurus",
        Dict{String,Any}("Id" => Id, "IndexId" => IndexId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_thesaurus(
    Id,
    IndexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "DeleteThesaurus",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Id" => Id, "IndexId" => IndexId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_access_control_configuration(id, index_id)
    describe_access_control_configuration(id, index_id, params::Dict{String,<:Any})

Gets information about an access control configuration that you created for your documents
in an index. This includes user and group access information for your documents. This is
useful for user context filtering, where search results are filtered based on the user or
their group access to documents.

# Arguments
- `id`: The identifier of the access control configuration you want to get information on.
- `index_id`: The identifier of the index for an access control configuration.

"""
function describe_access_control_configuration(
    Id, IndexId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra(
        "DescribeAccessControlConfiguration",
        Dict{String,Any}("Id" => Id, "IndexId" => IndexId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_access_control_configuration(
    Id,
    IndexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "DescribeAccessControlConfiguration",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Id" => Id, "IndexId" => IndexId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_data_source(id, index_id)
    describe_data_source(id, index_id, params::Dict{String,<:Any})

Gets information about an Amazon Kendra data source connector.

# Arguments
- `id`: The identifier of the data source connector.
- `index_id`: The identifier of the index used with the data source connector.

"""
function describe_data_source(
    Id, IndexId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra(
        "DescribeDataSource",
        Dict{String,Any}("Id" => Id, "IndexId" => IndexId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_data_source(
    Id,
    IndexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "DescribeDataSource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Id" => Id, "IndexId" => IndexId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_experience(id, index_id)
    describe_experience(id, index_id, params::Dict{String,<:Any})

Gets information about your Amazon Kendra experience such as a search application. For more
information on creating a search application experience, see Building a search experience
with no code.

# Arguments
- `id`: The identifier of your Amazon Kendra experience you want to get information on.
- `index_id`: The identifier of the index for your Amazon Kendra experience.

"""
function describe_experience(
    Id, IndexId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra(
        "DescribeExperience",
        Dict{String,Any}("Id" => Id, "IndexId" => IndexId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_experience(
    Id,
    IndexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "DescribeExperience",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Id" => Id, "IndexId" => IndexId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_faq(id, index_id)
    describe_faq(id, index_id, params::Dict{String,<:Any})

Gets information about an FAQ list.

# Arguments
- `id`: The identifier of the FAQ you want to get information on.
- `index_id`: The identifier of the index for the FAQ.

"""
function describe_faq(Id, IndexId; aws_config::AbstractAWSConfig=current_aws_config())
    return kendra(
        "DescribeFaq",
        Dict{String,Any}("Id" => Id, "IndexId" => IndexId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_faq(
    Id,
    IndexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "DescribeFaq",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Id" => Id, "IndexId" => IndexId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_featured_results_set(featured_results_set_id, index_id)
    describe_featured_results_set(featured_results_set_id, index_id, params::Dict{String,<:Any})

Gets information about a set of featured results. Features results are placed above all
other results for certain queries. If there's an exact match of a query, then one or more
specific documents are featured in the search results.

# Arguments
- `featured_results_set_id`: The identifier of the set of featured results that you want to
  get information on.
- `index_id`: The identifier of the index used for featuring results.

"""
function describe_featured_results_set(
    FeaturedResultsSetId, IndexId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra(
        "DescribeFeaturedResultsSet",
        Dict{String,Any}(
            "FeaturedResultsSetId" => FeaturedResultsSetId, "IndexId" => IndexId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_featured_results_set(
    FeaturedResultsSetId,
    IndexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "DescribeFeaturedResultsSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "FeaturedResultsSetId" => FeaturedResultsSetId, "IndexId" => IndexId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_index(id)
    describe_index(id, params::Dict{String,<:Any})

Gets information about an Amazon Kendra index.

# Arguments
- `id`: The identifier of the index you want to get information on.

"""
function describe_index(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return kendra(
        "DescribeIndex",
        Dict{String,Any}("Id" => Id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_index(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra(
        "DescribeIndex",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Id" => Id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_principal_mapping(group_id, index_id)
    describe_principal_mapping(group_id, index_id, params::Dict{String,<:Any})

Describes the processing of PUT and DELETE actions for mapping users to their groups. This
includes information on the status of actions currently processing or yet to be processed,
when actions were last updated, when actions were received by Amazon Kendra, the latest
action that should process and apply after other actions, and useful error messages if an
action could not be processed.  DescribePrincipalMapping is currently not supported in the
Amazon Web Services GovCloud (US-West) region.

# Arguments
- `group_id`: The identifier of the group required to check the processing of PUT and
  DELETE actions for mapping users to their groups.
- `index_id`: The identifier of the index required to check the processing of PUT and
  DELETE actions for mapping users to their groups.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DataSourceId"`: The identifier of the data source to check the processing of PUT and
  DELETE actions for mapping users to their groups.
"""
function describe_principal_mapping(
    GroupId, IndexId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra(
        "DescribePrincipalMapping",
        Dict{String,Any}("GroupId" => GroupId, "IndexId" => IndexId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_principal_mapping(
    GroupId,
    IndexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "DescribePrincipalMapping",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("GroupId" => GroupId, "IndexId" => IndexId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_query_suggestions_block_list(id, index_id)
    describe_query_suggestions_block_list(id, index_id, params::Dict{String,<:Any})

Gets information about a block list used for query suggestions for an index. This is used
to check the current settings that are applied to a block list.
DescribeQuerySuggestionsBlockList is currently not supported in the Amazon Web Services
GovCloud (US-West) region.

# Arguments
- `id`: The identifier of the block list you want to get information on.
- `index_id`: The identifier of the index for the block list.

"""
function describe_query_suggestions_block_list(
    Id, IndexId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra(
        "DescribeQuerySuggestionsBlockList",
        Dict{String,Any}("Id" => Id, "IndexId" => IndexId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_query_suggestions_block_list(
    Id,
    IndexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "DescribeQuerySuggestionsBlockList",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Id" => Id, "IndexId" => IndexId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_query_suggestions_config(index_id)
    describe_query_suggestions_config(index_id, params::Dict{String,<:Any})

Gets information on the settings of query suggestions for an index. This is used to check
the current settings applied to query suggestions.  DescribeQuerySuggestionsConfig is
currently not supported in the Amazon Web Services GovCloud (US-West) region.

# Arguments
- `index_id`: The identifier of the index with query suggestions that you want to get
  information on.

"""
function describe_query_suggestions_config(
    IndexId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra(
        "DescribeQuerySuggestionsConfig",
        Dict{String,Any}("IndexId" => IndexId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_query_suggestions_config(
    IndexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "DescribeQuerySuggestionsConfig",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("IndexId" => IndexId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_thesaurus(id, index_id)
    describe_thesaurus(id, index_id, params::Dict{String,<:Any})

Gets information about an Amazon Kendra thesaurus.

# Arguments
- `id`: The identifier of the thesaurus you want to get information on.
- `index_id`: The identifier of the index for the thesaurus.

"""
function describe_thesaurus(Id, IndexId; aws_config::AbstractAWSConfig=current_aws_config())
    return kendra(
        "DescribeThesaurus",
        Dict{String,Any}("Id" => Id, "IndexId" => IndexId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_thesaurus(
    Id,
    IndexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "DescribeThesaurus",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Id" => Id, "IndexId" => IndexId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_entities_from_experience(entity_list, id, index_id)
    disassociate_entities_from_experience(entity_list, id, index_id, params::Dict{String,<:Any})

Prevents users or groups in your IAM Identity Center identity source from accessing your
Amazon Kendra experience. You can create an Amazon Kendra experience such as a search
application. For more information on creating a search application experience, see Building
a search experience with no code.

# Arguments
- `entity_list`: Lists users or groups in your IAM Identity Center identity source.
- `id`: The identifier of your Amazon Kendra experience.
- `index_id`: The identifier of the index for your Amazon Kendra experience.

"""
function disassociate_entities_from_experience(
    EntityList, Id, IndexId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra(
        "DisassociateEntitiesFromExperience",
        Dict{String,Any}("EntityList" => EntityList, "Id" => Id, "IndexId" => IndexId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_entities_from_experience(
    EntityList,
    Id,
    IndexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "DisassociateEntitiesFromExperience",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EntityList" => EntityList, "Id" => Id, "IndexId" => IndexId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_personas_from_entities(entity_ids, id, index_id)
    disassociate_personas_from_entities(entity_ids, id, index_id, params::Dict{String,<:Any})

Removes the specific permissions of users or groups in your IAM Identity Center identity
source with access to your Amazon Kendra experience. You can create an Amazon Kendra
experience such as a search application. For more information on creating a search
application experience, see Building a search experience with no code.

# Arguments
- `entity_ids`: The identifiers of users or groups in your IAM Identity Center identity
  source. For example, user IDs could be user emails.
- `id`: The identifier of your Amazon Kendra experience.
- `index_id`: The identifier of the index for your Amazon Kendra experience.

"""
function disassociate_personas_from_entities(
    EntityIds, Id, IndexId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra(
        "DisassociatePersonasFromEntities",
        Dict{String,Any}("EntityIds" => EntityIds, "Id" => Id, "IndexId" => IndexId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_personas_from_entities(
    EntityIds,
    Id,
    IndexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "DisassociatePersonasFromEntities",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EntityIds" => EntityIds, "Id" => Id, "IndexId" => IndexId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_query_suggestions(index_id, query_text)
    get_query_suggestions(index_id, query_text, params::Dict{String,<:Any})

Fetches the queries that are suggested to your users.  GetQuerySuggestions is currently not
supported in the Amazon Web Services GovCloud (US-West) region.

# Arguments
- `index_id`: The identifier of the index you want to get query suggestions from.
- `query_text`: The text of a user's query to generate query suggestions. A query is
  suggested if the query prefix matches what a user starts to type as their query. Amazon
  Kendra does not show any suggestions if a user types fewer than two characters or more than
  60 characters. A query must also have at least one search result and contain at least one
  word of more than four characters.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AttributeSuggestionsConfig"`: Configuration information for the document
  fields/attributes that you want to base query suggestions on.
- `"MaxSuggestionsCount"`: The maximum number of query suggestions you want to show to your
  users.
- `"SuggestionTypes"`: The suggestions type to base query suggestions on. The suggestion
  types are query history or document fields/attributes. You can set one type or the other.
  If you set query history as your suggestions type, Amazon Kendra suggests queries relevant
  to your users based on popular queries in the query history. If you set document
  fields/attributes as your suggestions type, Amazon Kendra suggests queries relevant to your
  users based on the contents of document fields.
"""
function get_query_suggestions(
    IndexId, QueryText; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra(
        "GetQuerySuggestions",
        Dict{String,Any}("IndexId" => IndexId, "QueryText" => QueryText);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_query_suggestions(
    IndexId,
    QueryText,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "GetQuerySuggestions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("IndexId" => IndexId, "QueryText" => QueryText),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_snapshots(index_id, interval, metric_type)
    get_snapshots(index_id, interval, metric_type, params::Dict{String,<:Any})

Retrieves search metrics data. The data provides a snapshot of how your users interact with
your search application and how effective the application is.

# Arguments
- `index_id`: The identifier of the index to get search metrics data.
- `interval`: The time interval or time window to get search metrics data. The time
  interval uses the time zone of your index. You can view data in the following time windows:
     THIS_WEEK: The current week, starting on the Sunday and ending on the day before the
  current date.    ONE_WEEK_AGO: The previous week, starting on the Sunday and ending on the
  following Saturday.    TWO_WEEKS_AGO: The week before the previous week, starting on the
  Sunday and ending on the following Saturday.    THIS_MONTH: The current month, starting on
  the first day of the month and ending on the day before the current date.    ONE_MONTH_AGO:
  The previous month, starting on the first day of the month and ending on the last day of
  the month.    TWO_MONTHS_AGO: The month before the previous month, starting on the first
  day of the month and ending on last day of the month.
- `metric_type`: The metric you want to retrieve. You can specify only one metric per call.
  For more information about the metrics you can view, see Gaining insights with search
  analytics.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of returned data for the metric.
- `"NextToken"`: If the previous response was incomplete (because there is more data to
  retrieve), Amazon Kendra returns a pagination token in the response. You can use this
  pagination token to retrieve the next set of search metrics data.
"""
function get_snapshots(
    IndexId, Interval, MetricType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra(
        "GetSnapshots",
        Dict{String,Any}(
            "IndexId" => IndexId, "Interval" => Interval, "MetricType" => MetricType
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_snapshots(
    IndexId,
    Interval,
    MetricType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "GetSnapshots",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "IndexId" => IndexId, "Interval" => Interval, "MetricType" => MetricType
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_access_control_configurations(index_id)
    list_access_control_configurations(index_id, params::Dict{String,<:Any})

Lists one or more access control configurations for an index. This includes user and group
access information for your documents. This is useful for user context filtering, where
search results are filtered based on the user or their group access to documents.

# Arguments
- `index_id`: The identifier of the index for the access control configuration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of access control configurations to return.
- `"NextToken"`: If the previous response was incomplete (because there's more data to
  retrieve), Amazon Kendra returns a pagination token in the response. You can use this
  pagination token to retrieve the next set of access control configurations.
"""
function list_access_control_configurations(
    IndexId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra(
        "ListAccessControlConfigurations",
        Dict{String,Any}("IndexId" => IndexId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_access_control_configurations(
    IndexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "ListAccessControlConfigurations",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("IndexId" => IndexId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_data_source_sync_jobs(id, index_id)
    list_data_source_sync_jobs(id, index_id, params::Dict{String,<:Any})

Gets statistics about synchronizing a data source connector.

# Arguments
- `id`: The identifier of the data source connector.
- `index_id`: The identifier of the index used with the data source connector.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of synchronization jobs to return in the response. If
  there are fewer results in the list, this response contains only the actual results.
- `"NextToken"`: If the previous response was incomplete (because there is more data to
  retrieve), Amazon Kendra returns a pagination token in the response. You can use this
  pagination token to retrieve the next set of jobs.
- `"StartTimeFilter"`: When specified, the synchronization jobs returned in the list are
  limited to jobs between the specified dates.
- `"StatusFilter"`: Only returns synchronization jobs with the Status field equal to the
  specified status.
"""
function list_data_source_sync_jobs(
    Id, IndexId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra(
        "ListDataSourceSyncJobs",
        Dict{String,Any}("Id" => Id, "IndexId" => IndexId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_data_source_sync_jobs(
    Id,
    IndexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "ListDataSourceSyncJobs",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Id" => Id, "IndexId" => IndexId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_data_sources(index_id)
    list_data_sources(index_id, params::Dict{String,<:Any})

Lists the data source connectors that you have created.

# Arguments
- `index_id`: The identifier of the index used with one or more data source connectors.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of data source connectors to return.
- `"NextToken"`: If the previous response was incomplete (because there is more data to
  retrieve), Amazon Kendra returns a pagination token in the response. You can use this
  pagination token to retrieve the next set of data source connectors.
"""
function list_data_sources(IndexId; aws_config::AbstractAWSConfig=current_aws_config())
    return kendra(
        "ListDataSources",
        Dict{String,Any}("IndexId" => IndexId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_data_sources(
    IndexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "ListDataSources",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("IndexId" => IndexId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_entity_personas(id, index_id)
    list_entity_personas(id, index_id, params::Dict{String,<:Any})

Lists specific permissions of users and groups with access to your Amazon Kendra experience.

# Arguments
- `id`: The identifier of your Amazon Kendra experience.
- `index_id`: The identifier of the index for your Amazon Kendra experience.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of returned users or groups.
- `"NextToken"`: If the previous response was incomplete (because there is more data to
  retrieve), Amazon Kendra returns a pagination token in the response. You can use this
  pagination token to retrieve the next set of users or groups.
"""
function list_entity_personas(
    Id, IndexId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra(
        "ListEntityPersonas",
        Dict{String,Any}("Id" => Id, "IndexId" => IndexId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_entity_personas(
    Id,
    IndexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "ListEntityPersonas",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Id" => Id, "IndexId" => IndexId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_experience_entities(id, index_id)
    list_experience_entities(id, index_id, params::Dict{String,<:Any})

Lists users or groups in your IAM Identity Center identity source that are granted access
to your Amazon Kendra experience. You can create an Amazon Kendra experience such as a
search application. For more information on creating a search application experience, see
Building a search experience with no code.

# Arguments
- `id`: The identifier of your Amazon Kendra experience.
- `index_id`: The identifier of the index for your Amazon Kendra experience.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: If the previous response was incomplete (because there is more data to
  retrieve), Amazon Kendra returns a pagination token in the response. You can use this
  pagination token to retrieve the next set of users or groups.
"""
function list_experience_entities(
    Id, IndexId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra(
        "ListExperienceEntities",
        Dict{String,Any}("Id" => Id, "IndexId" => IndexId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_experience_entities(
    Id,
    IndexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "ListExperienceEntities",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Id" => Id, "IndexId" => IndexId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_experiences(index_id)
    list_experiences(index_id, params::Dict{String,<:Any})

Lists one or more Amazon Kendra experiences. You can create an Amazon Kendra experience
such as a search application. For more information on creating a search application
experience, see Building a search experience with no code.

# Arguments
- `index_id`: The identifier of the index for your Amazon Kendra experience.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of returned Amazon Kendra experiences.
- `"NextToken"`: If the previous response was incomplete (because there is more data to
  retrieve), Amazon Kendra returns a pagination token in the response. You can use this
  pagination token to retrieve the next set of Amazon Kendra experiences.
"""
function list_experiences(IndexId; aws_config::AbstractAWSConfig=current_aws_config())
    return kendra(
        "ListExperiences",
        Dict{String,Any}("IndexId" => IndexId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_experiences(
    IndexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "ListExperiences",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("IndexId" => IndexId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_faqs(index_id)
    list_faqs(index_id, params::Dict{String,<:Any})

Gets a list of FAQ lists associated with an index.

# Arguments
- `index_id`: The index that contains the FAQ lists.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of FAQs to return in the response. If there are fewer
  results in the list, this response contains only the actual results.
- `"NextToken"`: If the previous response was incomplete (because there is more data to
  retrieve), Amazon Kendra returns a pagination token in the response. You can use this
  pagination token to retrieve the next set of FAQs.
"""
function list_faqs(IndexId; aws_config::AbstractAWSConfig=current_aws_config())
    return kendra(
        "ListFaqs",
        Dict{String,Any}("IndexId" => IndexId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_faqs(
    IndexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "ListFaqs",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("IndexId" => IndexId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_featured_results_sets(index_id)
    list_featured_results_sets(index_id, params::Dict{String,<:Any})

Lists all your sets of featured results for a given index. Features results are placed
above all other results for certain queries. If there's an exact match of a query, then one
or more specific documents are featured in the search results.

# Arguments
- `index_id`: The identifier of the index used for featuring results.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of featured results sets to return.
- `"NextToken"`: If the response is truncated, Amazon Kendra returns a pagination token in
  the response. You can use this pagination token to retrieve the next set of featured
  results sets.
"""
function list_featured_results_sets(
    IndexId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra(
        "ListFeaturedResultsSets",
        Dict{String,Any}("IndexId" => IndexId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_featured_results_sets(
    IndexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "ListFeaturedResultsSets",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("IndexId" => IndexId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_groups_older_than_ordering_id(index_id, ordering_id)
    list_groups_older_than_ordering_id(index_id, ordering_id, params::Dict{String,<:Any})

Provides a list of groups that are mapped to users before a given ordering or timestamp
identifier.  ListGroupsOlderThanOrderingId is currently not supported in the Amazon Web
Services GovCloud (US-West) region.

# Arguments
- `index_id`: The identifier of the index for getting a list of groups mapped to users
  before a given ordering or timestamp identifier.
- `ordering_id`: The timestamp identifier used for the latest PUT or DELETE action for
  mapping users to their groups.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DataSourceId"`: The identifier of the data source for getting a list of groups mapped
  to users before a given ordering timestamp identifier.
- `"MaxResults"`:  The maximum number of returned groups that are mapped to users before a
  given ordering or timestamp identifier.
- `"NextToken"`:  If the previous response was incomplete (because there is more data to
  retrieve), Amazon Kendra returns a pagination token in the response. You can use this
  pagination token to retrieve the next set of groups that are mapped to users before a given
  ordering or timestamp identifier.
"""
function list_groups_older_than_ordering_id(
    IndexId, OrderingId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra(
        "ListGroupsOlderThanOrderingId",
        Dict{String,Any}("IndexId" => IndexId, "OrderingId" => OrderingId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_groups_older_than_ordering_id(
    IndexId,
    OrderingId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "ListGroupsOlderThanOrderingId",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("IndexId" => IndexId, "OrderingId" => OrderingId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_indices()
    list_indices(params::Dict{String,<:Any})

Lists the Amazon Kendra indexes that you created.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of indices to return.
- `"NextToken"`: If the previous response was incomplete (because there is more data to
  retrieve), Amazon Kendra returns a pagination token in the response. You can use this
  pagination token to retrieve the next set of indexes.
"""
function list_indices(; aws_config::AbstractAWSConfig=current_aws_config())
    return kendra("ListIndices"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_indices(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra(
        "ListIndices", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_query_suggestions_block_lists(index_id)
    list_query_suggestions_block_lists(index_id, params::Dict{String,<:Any})

Lists the block lists used for query suggestions for an index. For information on the
current quota limits for block lists, see Quotas for Amazon Kendra.
ListQuerySuggestionsBlockLists is currently not supported in the Amazon Web Services
GovCloud (US-West) region.

# Arguments
- `index_id`: The identifier of the index for a list of all block lists that exist for that
  index. For information on the current quota limits for block lists, see Quotas for Amazon
  Kendra.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of block lists to return.
- `"NextToken"`: If the previous response was incomplete (because there is more data to
  retrieve), Amazon Kendra returns a pagination token in the response. You can use this
  pagination token to retrieve the next set of block lists (BlockListSummaryItems).
"""
function list_query_suggestions_block_lists(
    IndexId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra(
        "ListQuerySuggestionsBlockLists",
        Dict{String,Any}("IndexId" => IndexId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_query_suggestions_block_lists(
    IndexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "ListQuerySuggestionsBlockLists",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("IndexId" => IndexId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Gets a list of tags associated with a specified resource. Indexes, FAQs, and data sources
can have tags associated with them.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the index, FAQ, or data source to get a
  list of tags for.

"""
function list_tags_for_resource(
    ResourceARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra(
        "ListTagsForResource",
        Dict{String,Any}("ResourceARN" => ResourceARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceARN" => ResourceARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_thesauri(index_id)
    list_thesauri(index_id, params::Dict{String,<:Any})

Lists the thesauri for an index.

# Arguments
- `index_id`: The identifier of the index with one or more thesauri.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of thesauri to return.
- `"NextToken"`: If the previous response was incomplete (because there is more data to
  retrieve), Amazon Kendra returns a pagination token in the response. You can use this
  pagination token to retrieve the next set of thesauri (ThesaurusSummaryItems).
"""
function list_thesauri(IndexId; aws_config::AbstractAWSConfig=current_aws_config())
    return kendra(
        "ListThesauri",
        Dict{String,Any}("IndexId" => IndexId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_thesauri(
    IndexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "ListThesauri",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("IndexId" => IndexId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_principal_mapping(group_id, group_members, index_id)
    put_principal_mapping(group_id, group_members, index_id, params::Dict{String,<:Any})

Maps users to their groups so that you only need to provide the user ID when you issue the
query. You can also map sub groups to groups. For example, the group \"Company Intellectual
Property Teams\" includes sub groups \"Research\" and \"Engineering\". These sub groups
include their own list of users or people who work in these teams. Only users who work in
research and engineering, and therefore belong in the intellectual property group, can see
top-secret company documents in their search results. This is useful for user context
filtering, where search results are filtered based on the user or their group access to
documents. For more information, see Filtering on user context. If more than five PUT
actions for a group are currently processing, a validation exception is thrown.

# Arguments
- `group_id`: The identifier of the group you want to map its users to.
- `group_members`: The list that contains your users or sub groups that belong the same
  group. For example, the group \"Company\" includes the user \"CEO\" and the sub groups
  \"Research\", \"Engineering\", and \"Sales and Marketing\". If you have more than 1000
  users and/or sub groups for a single group, you need to provide the path to the S3 file
  that lists your users and sub groups for a group. Your sub groups can contain more than
  1000 users, but the list of sub groups that belong to a group (and/or users) must be no
  more than 1000.
- `index_id`: The identifier of the index you want to map users to their groups.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DataSourceId"`: The identifier of the data source you want to map users to their
  groups. This is useful if a group is tied to multiple data sources, but you only want the
  group to access documents of a certain data source. For example, the groups \"Research\",
  \"Engineering\", and \"Sales and Marketing\" are all tied to the company's documents stored
  in the data sources Confluence and Salesforce. However, \"Sales and Marketing\" team only
  needs access to customer-related documents stored in Salesforce.
- `"OrderingId"`: The timestamp identifier you specify to ensure Amazon Kendra does not
  override the latest PUT action with previous actions. The highest number ID, which is the
  ordering ID, is the latest action you want to process and apply on top of other actions
  with lower number IDs. This prevents previous actions with lower number IDs from possibly
  overriding the latest action. The ordering ID can be the Unix time of the last update you
  made to a group members list. You would then provide this list when calling
  PutPrincipalMapping. This ensures your PUT action for that updated group with the latest
  members list doesn't get overwritten by earlier PUT actions for the same group which are
  yet to be processed. The default ordering ID is the current Unix time in milliseconds that
  the action was received by Amazon Kendra.
- `"RoleArn"`: The Amazon Resource Name (ARN) of a role that has access to the S3 file that
  contains your list of users or sub groups that belong to a group. For more information, see
  IAM roles for Amazon Kendra.
"""
function put_principal_mapping(
    GroupId, GroupMembers, IndexId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra(
        "PutPrincipalMapping",
        Dict{String,Any}(
            "GroupId" => GroupId, "GroupMembers" => GroupMembers, "IndexId" => IndexId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_principal_mapping(
    GroupId,
    GroupMembers,
    IndexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "PutPrincipalMapping",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "GroupId" => GroupId,
                    "GroupMembers" => GroupMembers,
                    "IndexId" => IndexId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    query(index_id)
    query(index_id, params::Dict{String,<:Any})

Searches an index given an input query.  If you are working with large language models
(LLMs) or implementing retrieval augmented generation (RAG) systems, you can use Amazon
Kendra's Retrieve API, which can return longer semantically relevant passages. We recommend
using the Retrieve API instead of filing a service limit increase to increase the Query API
document excerpt length.  You can configure boosting or relevance tuning at the query level
to override boosting at the index level, filter based on document fields/attributes and
faceted search, and filter based on the user or their group access to documents. You can
also include certain fields in the response that might provide useful additional
information. A query response contains three types of results.   Relevant suggested
answers. The answers can be either a text excerpt or table excerpt. The answer can be
highlighted in the excerpt.   Matching FAQs or questions-answer from your FAQ file.
Relevant documents. This result type includes an excerpt of the document with the document
title. The searched terms can be highlighted in the excerpt.   You can specify that the
query return only one type of result using the QueryResultTypeFilter parameter. Each query
returns the 100 most relevant results. If you filter result type to only question-answers,
a maximum of four results are returned. If you filter result type to only answers, a
maximum of three results are returned.

# Arguments
- `index_id`: The identifier of the index for the search.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AttributeFilter"`: Filters search results by document fields/attributes. You can only
  provide one attribute filter; however, the AndAllFilters, NotFilter, and OrAllFilters
  parameters contain a list of other filters. The AttributeFilter parameter means you can
  create a set of filtering rules that a document must satisfy to be included in the query
  results.
- `"CollapseConfiguration"`: Provides configuration to determine how to group results by
  document attribute value, and how to display them (collapsed or expanded) under a
  designated primary document for each group.
- `"DocumentRelevanceOverrideConfigurations"`: Overrides relevance tuning configurations of
  fields/attributes set at the index level. If you use this API to override the relevance
  tuning configured at the index level, but there is no relevance tuning configured at the
  index level, then Amazon Kendra does not apply any relevance tuning. If there is relevance
  tuning configured for fields at the index level, and you use this API to override only some
  of these fields, then for the fields you did not override, the importance is set to 1.
- `"Facets"`: An array of documents fields/attributes for faceted search. Amazon Kendra
  returns a count for each field key specified. This helps your users narrow their search.
- `"PageNumber"`: Query results are returned in pages the size of the PageSize parameter.
  By default, Amazon Kendra returns the first page of results. Use this parameter to get
  result pages after the first one.
- `"PageSize"`: Sets the number of results that are returned in each page of results. The
  default page size is 10. The maximum number of results returned is 100. If you ask for more
  than 100 results, only 100 are returned.
- `"QueryResultTypeFilter"`: Sets the type of query result or response. Only results for
  the specified type are returned.
- `"QueryText"`: The input query text for the search. Amazon Kendra truncates queries at 30
  token words, which excludes punctuation and stop words. Truncation still applies if you use
  Boolean or more advanced, complex queries. For example, Timeoff AND October AND Category:HR
  is counted as 3 tokens: timeoff, october, hr. For more information, see Searching with
  advanced query syntax in the Amazon Kendra Developer Guide.
- `"RequestedDocumentAttributes"`: An array of document fields/attributes to include in the
  response. You can limit the response to include certain document fields. By default, all
  document attributes are included in the response.
- `"SortingConfiguration"`: Provides information that determines how the results of the
  query are sorted. You can set the field that Amazon Kendra should sort the results on, and
  specify whether the results should be sorted in ascending or descending order. In the case
  of ties in sorting the results, the results are sorted by relevance. If you don't provide
  sorting configuration, the results are sorted by the relevance that Amazon Kendra
  determines for the result.
- `"SortingConfigurations"`: Provides configuration information to determine how the
  results of a query are sorted. You can set upto 3 fields that Amazon Kendra should sort the
  results on, and specify whether the results should be sorted in ascending or descending
  order. The sort field quota can be increased. If you don't provide a sorting configuration,
  the results are sorted by the relevance that Amazon Kendra determines for the result. In
  the case of ties in sorting the results, the results are sorted by relevance.
- `"SpellCorrectionConfiguration"`: Enables suggested spell corrections for queries.
- `"UserContext"`: The user context token or user and group information.
- `"VisitorId"`: Provides an identifier for a specific user. The VisitorId should be a
  unique identifier, such as a GUID. Don't use personally identifiable information, such as
  the user's email address, as the VisitorId.
"""
function query(IndexId; aws_config::AbstractAWSConfig=current_aws_config())
    return kendra(
        "Query",
        Dict{String,Any}("IndexId" => IndexId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function query(
    IndexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "Query",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("IndexId" => IndexId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    retrieve(index_id, query_text)
    retrieve(index_id, query_text, params::Dict{String,<:Any})

Retrieves relevant passages or text excerpts given an input query. This API is similar to
the Query API. However, by default, the Query API only returns excerpt passages of up to
100 token words. With the Retrieve API, you can retrieve longer passages of up to 200 token
words and up to 100 semantically relevant passages. This doesn't include question-answer or
FAQ type responses from your index. The passages are text excerpts that can be semantically
extracted from multiple documents and multiple parts of the same document. If in extreme
cases your documents produce zero passages using the Retrieve API, you can alternatively
use the Query API and its types of responses. You can also do the following:   Override
boosting at the index level   Filter based on document fields or attributes   Filter based
on the user or their group access to documents   View the confidence score bucket for a
retrieved passage result. The confidence bucket provides a relative ranking that indicates
how confident Amazon Kendra is that the response is relevant to the query.  Confidence
score buckets are currently available only for English.    You can also include certain
fields in the response that might provide useful additional information. The Retrieve API
shares the number of query capacity units that you set for your index. For more information
on what's included in a single capacity unit and the default base capacity for an index,
see Adjusting capacity.

# Arguments
- `index_id`: The identifier of the index to retrieve relevant passages for the search.
- `query_text`: The input query text to retrieve relevant passages for the search. Amazon
  Kendra truncates queries at 30 token words, which excludes punctuation and stop words.
  Truncation still applies if you use Boolean or more advanced, complex queries. For example,
  Timeoff AND October AND Category:HR is counted as 3 tokens: timeoff, october, hr. For more
  information, see Searching with advanced query syntax in the Amazon Kendra Developer Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AttributeFilter"`: Filters search results by document fields/attributes. You can only
  provide one attribute filter; however, the AndAllFilters, NotFilter, and OrAllFilters
  parameters contain a list of other filters. The AttributeFilter parameter means you can
  create a set of filtering rules that a document must satisfy to be included in the query
  results.
- `"DocumentRelevanceOverrideConfigurations"`: Overrides relevance tuning configurations of
  fields/attributes set at the index level. If you use this API to override the relevance
  tuning configured at the index level, but there is no relevance tuning configured at the
  index level, then Amazon Kendra does not apply any relevance tuning. If there is relevance
  tuning configured for fields at the index level, and you use this API to override only some
  of these fields, then for the fields you did not override, the importance is set to 1.
- `"PageNumber"`: Retrieved relevant passages are returned in pages the size of the
  PageSize parameter. By default, Amazon Kendra returns the first page of results. Use this
  parameter to get result pages after the first one.
- `"PageSize"`: Sets the number of retrieved relevant passages that are returned in each
  page of results. The default page size is 10. The maximum number of results returned is
  100. If you ask for more than 100 results, only 100 are returned.
- `"RequestedDocumentAttributes"`: A list of document fields/attributes to include in the
  response. You can limit the response to include certain document fields. By default, all
  document fields are included in the response.
- `"UserContext"`: The user context token or user and group information.
"""
function retrieve(IndexId, QueryText; aws_config::AbstractAWSConfig=current_aws_config())
    return kendra(
        "Retrieve",
        Dict{String,Any}("IndexId" => IndexId, "QueryText" => QueryText);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function retrieve(
    IndexId,
    QueryText,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "Retrieve",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("IndexId" => IndexId, "QueryText" => QueryText),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_data_source_sync_job(id, index_id)
    start_data_source_sync_job(id, index_id, params::Dict{String,<:Any})

Starts a synchronization job for a data source connector. If a synchronization job is
already in progress, Amazon Kendra returns a ResourceInUseException exception. Re-syncing
your data source with your index after modifying, adding, or deleting documents from your
data source respository could take up to an hour or more, depending on the number of
documents to sync.

# Arguments
- `id`: The identifier of the data source connector to synchronize.
- `index_id`: The identifier of the index used with the data source connector.

"""
function start_data_source_sync_job(
    Id, IndexId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra(
        "StartDataSourceSyncJob",
        Dict{String,Any}("Id" => Id, "IndexId" => IndexId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_data_source_sync_job(
    Id,
    IndexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "StartDataSourceSyncJob",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Id" => Id, "IndexId" => IndexId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_data_source_sync_job(id, index_id)
    stop_data_source_sync_job(id, index_id, params::Dict{String,<:Any})

Stops a synchronization job that is currently running. You can't stop a scheduled
synchronization job.

# Arguments
- `id`: The identifier of the data source connector for which to stop the synchronization
  jobs.
- `index_id`: The identifier of the index used with the data source connector.

"""
function stop_data_source_sync_job(
    Id, IndexId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra(
        "StopDataSourceSyncJob",
        Dict{String,Any}("Id" => Id, "IndexId" => IndexId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_data_source_sync_job(
    Id,
    IndexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "StopDataSourceSyncJob",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Id" => Id, "IndexId" => IndexId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    submit_feedback(index_id, query_id)
    submit_feedback(index_id, query_id, params::Dict{String,<:Any})

Enables you to provide feedback to Amazon Kendra to improve the performance of your index.
SubmitFeedback is currently not supported in the Amazon Web Services GovCloud (US-West)
region.

# Arguments
- `index_id`: The identifier of the index that was queried.
- `query_id`: The identifier of the specific query for which you are submitting feedback.
  The query ID is returned in the response to the Query API.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClickFeedbackItems"`: Tells Amazon Kendra that a particular search result link was
  chosen by the user.
- `"RelevanceFeedbackItems"`: Provides Amazon Kendra with relevant or not relevant feedback
  for whether a particular item was relevant to the search.
"""
function submit_feedback(
    IndexId, QueryId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra(
        "SubmitFeedback",
        Dict{String,Any}("IndexId" => IndexId, "QueryId" => QueryId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function submit_feedback(
    IndexId,
    QueryId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "SubmitFeedback",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("IndexId" => IndexId, "QueryId" => QueryId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds the specified tag to the specified index, FAQ, or data source resource. If the tag
already exists, the existing value is replaced with the new value.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the index, FAQ, or data source to tag.
- `tags`: A list of tag keys to add to the index, FAQ, or data source. If a tag already
  exists, the existing value is replaced with the new value.

"""
function tag_resource(ResourceARN, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return kendra(
        "TagResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceARN,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes a tag from an index, FAQ, or a data source.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the index, FAQ, or data source to
  remove the tag from.
- `tag_keys`: A list of tag keys to remove from the index, FAQ, or data source. If a tag
  key does not exist on the resource, it is ignored.

"""
function untag_resource(
    ResourceARN, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra(
        "UntagResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceARN,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_access_control_configuration(id, index_id)
    update_access_control_configuration(id, index_id, params::Dict{String,<:Any})

Updates an access control configuration for your documents in an index. This includes user
and group access information for your documents. This is useful for user context filtering,
where search results are filtered based on the user or their group access to documents. You
can update an access control configuration you created without indexing all of your
documents again. For example, your index contains top-secret company documents that only
certain employees or users should access. You created an 'allow' access control
configuration for one user who recently joined the 'top-secret' team, switching from a team
with 'deny' access to top-secret documents. However, the user suddenly returns to their
previous team and should no longer have access to top secret documents. You can update the
access control configuration to re-configure access control for your documents as
circumstances change. You call the BatchPutDocument API to apply the updated access control
configuration, with the AccessControlConfigurationId included in the Document object. If
you use an S3 bucket as a data source, you synchronize your data source to apply the
AccessControlConfigurationId in the .metadata.json file. Amazon Kendra currently only
supports access control configuration for S3 data sources and documents indexed using the
BatchPutDocument API.

# Arguments
- `id`: The identifier of the access control configuration you want to update.
- `index_id`: The identifier of the index for an access control configuration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccessControlList"`: Information you want to update on principals (users and/or groups)
  and which documents they should have access to. This is useful for user context filtering,
  where search results are filtered based on the user or their group access to documents.
- `"Description"`: A new description for the access control configuration.
- `"HierarchicalAccessControlList"`: The updated list of principal lists that define the
  hierarchy for which documents users should have access to.
- `"Name"`: A new name for the access control configuration.
"""
function update_access_control_configuration(
    Id, IndexId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra(
        "UpdateAccessControlConfiguration",
        Dict{String,Any}("Id" => Id, "IndexId" => IndexId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_access_control_configuration(
    Id,
    IndexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "UpdateAccessControlConfiguration",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Id" => Id, "IndexId" => IndexId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_data_source(id, index_id)
    update_data_source(id, index_id, params::Dict{String,<:Any})

Updates an Amazon Kendra data source connector.

# Arguments
- `id`: The identifier of the data source connector you want to update.
- `index_id`: The identifier of the index used with the data source connector.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Configuration"`: Configuration information you want to update for the data source
  connector.
- `"CustomDocumentEnrichmentConfiguration"`: Configuration information you want to update
  for altering document metadata and content during the document ingestion process. For more
  information on how to create, modify and delete document metadata, or make other content
  alterations when you ingest documents into Amazon Kendra, see Customizing document metadata
  during the ingestion process.
- `"Description"`: A new description for the data source connector.
- `"LanguageCode"`: The code for a language you want to update for the data source
  connector. This allows you to support a language for all documents when updating the data
  source. English is supported by default. For more information on supported languages,
  including their codes, see Adding documents in languages other than English.
- `"Name"`: A new name for the data source connector.
- `"RoleArn"`: The Amazon Resource Name (ARN) of a role with permission to access the data
  source and required resources. For more information, see IAM roles for Amazon Kendra.
- `"Schedule"`: The sync schedule you want to update for the data source connector.
- `"VpcConfiguration"`: Configuration information for an Amazon Virtual Private Cloud to
  connect to your data source. For more information, see Configuring a VPC.
"""
function update_data_source(Id, IndexId; aws_config::AbstractAWSConfig=current_aws_config())
    return kendra(
        "UpdateDataSource",
        Dict{String,Any}("Id" => Id, "IndexId" => IndexId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_data_source(
    Id,
    IndexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "UpdateDataSource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Id" => Id, "IndexId" => IndexId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_experience(id, index_id)
    update_experience(id, index_id, params::Dict{String,<:Any})

Updates your Amazon Kendra experience such as a search application. For more information on
creating a search application experience, see Building a search experience with no code.

# Arguments
- `id`: The identifier of your Amazon Kendra experience you want to update.
- `index_id`: The identifier of the index for your Amazon Kendra experience.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Configuration"`: Configuration information you want to update for your Amazon Kendra
  experience.
- `"Description"`: A new description for your Amazon Kendra experience.
- `"Name"`: A new name for your Amazon Kendra experience.
- `"RoleArn"`: The Amazon Resource Name (ARN) of a role with permission to access Query
  API, QuerySuggestions API, SubmitFeedback API, and IAM Identity Center that stores your
  user and group information. For more information, see IAM roles for Amazon Kendra.
"""
function update_experience(Id, IndexId; aws_config::AbstractAWSConfig=current_aws_config())
    return kendra(
        "UpdateExperience",
        Dict{String,Any}("Id" => Id, "IndexId" => IndexId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_experience(
    Id,
    IndexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "UpdateExperience",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Id" => Id, "IndexId" => IndexId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_featured_results_set(featured_results_set_id, index_id)
    update_featured_results_set(featured_results_set_id, index_id, params::Dict{String,<:Any})

Updates a set of featured results. Features results are placed above all other results for
certain queries. You map specific queries to specific documents for featuring in the
results. If a query contains an exact match of a query, then one or more specific documents
are featured in the search results.

# Arguments
- `featured_results_set_id`: The identifier of the set of featured results that you want to
  update.
- `index_id`: The identifier of the index used for featuring results.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A new description for the set of featured results.
- `"FeaturedDocuments"`: A list of document IDs for the documents you want to feature at
  the top of the search results page. For more information on the list of featured documents,
  see FeaturedResultsSet.
- `"FeaturedResultsSetName"`: A new name for the set of featured results.
- `"QueryTexts"`: A list of queries for featuring results. For more information on the list
  of queries, see FeaturedResultsSet.
- `"Status"`: You can set the status to ACTIVE or INACTIVE. When the value is ACTIVE,
  featured results are ready for use. You can still configure your settings before setting
  the status to ACTIVE. The queries you specify for featured results must be unique per
  featured results set for each index, whether the status is ACTIVE or INACTIVE.
"""
function update_featured_results_set(
    FeaturedResultsSetId, IndexId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra(
        "UpdateFeaturedResultsSet",
        Dict{String,Any}(
            "FeaturedResultsSetId" => FeaturedResultsSetId, "IndexId" => IndexId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_featured_results_set(
    FeaturedResultsSetId,
    IndexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "UpdateFeaturedResultsSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "FeaturedResultsSetId" => FeaturedResultsSetId, "IndexId" => IndexId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_index(id)
    update_index(id, params::Dict{String,<:Any})

Updates an Amazon Kendra index.

# Arguments
- `id`: The identifier of the index you want to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CapacityUnits"`: Sets the number of additional document storage and query capacity
  units that should be used by the index. You can change the capacity of the index up to 5
  times per day, or make 5 API calls. If you are using extra storage units, you can't reduce
  the storage capacity below what is required to meet the storage needs for your index.
- `"Description"`: A new description for the index.
- `"DocumentMetadataConfigurationUpdates"`: The document metadata configuration you want to
  update for the index. Document metadata are fields or attributes associated with your
  documents. For example, the company department name associated with each document.
- `"Name"`: A new name for the index.
- `"RoleArn"`: An Identity and Access Management (IAM) role that gives Amazon Kendra
  permission to access Amazon CloudWatch logs and metrics.
- `"UserContextPolicy"`: The user context policy.
- `"UserGroupResolutionConfiguration"`: Gets users and groups from IAM Identity Center
  identity source. To configure this, see UserGroupResolutionConfiguration. This is useful
  for user context filtering, where search results are filtered based on the user or their
  group access to documents.
- `"UserTokenConfigurations"`: The user token configuration.
"""
function update_index(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return kendra(
        "UpdateIndex",
        Dict{String,Any}("Id" => Id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_index(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra(
        "UpdateIndex",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Id" => Id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_query_suggestions_block_list(id, index_id)
    update_query_suggestions_block_list(id, index_id, params::Dict{String,<:Any})

Updates a block list used for query suggestions for an index. Updates to a block list might
not take effect right away. Amazon Kendra needs to refresh the entire suggestions list to
apply any updates to the block list. Other changes not related to the block list apply
immediately. If a block list is updating, then you need to wait for the first update to
finish before submitting another update. Amazon Kendra supports partial updates, so you
only need to provide the fields you want to update.  UpdateQuerySuggestionsBlockList is
currently not supported in the Amazon Web Services GovCloud (US-West) region.

# Arguments
- `id`: The identifier of the block list you want to update.
- `index_id`: The identifier of the index for the block list.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A new description for the block list.
- `"Name"`: A new name for the block list.
- `"RoleArn"`: The IAM (Identity and Access Management) role used to access the block list
  text file in S3.
- `"SourceS3Path"`: The S3 path where your block list text file sits in S3. If you update
  your block list and provide the same path to the block list text file in S3, then Amazon
  Kendra reloads the file to refresh the block list. Amazon Kendra does not automatically
  refresh your block list. You need to call the UpdateQuerySuggestionsBlockList API to
  refresh you block list. If you update your block list, then Amazon Kendra asynchronously
  refreshes all query suggestions with the latest content in the S3 file. This means changes
  might not take effect immediately.
"""
function update_query_suggestions_block_list(
    Id, IndexId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra(
        "UpdateQuerySuggestionsBlockList",
        Dict{String,Any}("Id" => Id, "IndexId" => IndexId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_query_suggestions_block_list(
    Id,
    IndexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "UpdateQuerySuggestionsBlockList",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Id" => Id, "IndexId" => IndexId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_query_suggestions_config(index_id)
    update_query_suggestions_config(index_id, params::Dict{String,<:Any})

Updates the settings of query suggestions for an index. Amazon Kendra supports partial
updates, so you only need to provide the fields you want to update. If an update is
currently processing, you need to wait for the update to finish before making another
update. Updates to query suggestions settings might not take effect right away. The time
for your updated settings to take effect depends on the updates made and the number of
search queries in your index. You can still enable/disable query suggestions at any time.
UpdateQuerySuggestionsConfig is currently not supported in the Amazon Web Services GovCloud
(US-West) region.

# Arguments
- `index_id`:  The identifier of the index with query suggestions you want to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AttributeSuggestionsConfig"`: Configuration information for the document
  fields/attributes that you want to base query suggestions on.
- `"IncludeQueriesWithoutUserInformation"`:  TRUE to include queries without user
  information (i.e. all queries, irrespective of the user), otherwise FALSE to only include
  queries with user information. If you pass user information to Amazon Kendra along with the
  queries, you can set this flag to FALSE and instruct Amazon Kendra to only consider queries
  with user information. If you set to FALSE, Amazon Kendra only considers queries searched
  at least MinimumQueryCount times across MinimumNumberOfQueryingUsers unique users for
  suggestions. If you set to TRUE, Amazon Kendra ignores all user information and learns from
  all queries.
- `"MinimumNumberOfQueryingUsers"`: The minimum number of unique users who must search a
  query in order for the query to be eligible to suggest to your users. Increasing this
  number might decrease the number of suggestions. However, this ensures a query is searched
  by many users and is truly popular to suggest to users. How you tune this setting depends
  on your specific needs.
- `"MinimumQueryCount"`: The the minimum number of times a query must be searched in order
  to be eligible to suggest to your users. Decreasing this number increases the number of
  suggestions. However, this affects the quality of suggestions as it sets a low bar for a
  query to be considered popular to suggest to users. How you tune this setting depends on
  your specific needs.
- `"Mode"`: Set the mode to ENABLED or LEARN_ONLY. By default, Amazon Kendra enables query
  suggestions. LEARN_ONLY mode allows you to turn off query suggestions. You can to update
  this at any time. In LEARN_ONLY mode, Amazon Kendra continues to learn from new queries to
  keep suggestions up to date for when you are ready to switch to ENABLED mode again.
- `"QueryLogLookBackWindowInDays"`: How recent your queries are in your query log time
  window. The time window is the number of days from current day to past days. By default,
  Amazon Kendra sets this to 180.
"""
function update_query_suggestions_config(
    IndexId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kendra(
        "UpdateQuerySuggestionsConfig",
        Dict{String,Any}("IndexId" => IndexId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_query_suggestions_config(
    IndexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "UpdateQuerySuggestionsConfig",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("IndexId" => IndexId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_thesaurus(id, index_id)
    update_thesaurus(id, index_id, params::Dict{String,<:Any})

Updates a thesaurus for an index.

# Arguments
- `id`: The identifier of the thesaurus you want to update.
- `index_id`: The identifier of the index for the thesaurus.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A new description for the thesaurus.
- `"Name"`: A new name for the thesaurus.
- `"RoleArn"`: An IAM role that gives Amazon Kendra permissions to access thesaurus file
  specified in SourceS3Path.
- `"SourceS3Path"`:
"""
function update_thesaurus(Id, IndexId; aws_config::AbstractAWSConfig=current_aws_config())
    return kendra(
        "UpdateThesaurus",
        Dict{String,Any}("Id" => Id, "IndexId" => IndexId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_thesaurus(
    Id,
    IndexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kendra(
        "UpdateThesaurus",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Id" => Id, "IndexId" => IndexId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: guardduty
using AWS.Compat
using AWS.UUIDs

"""
    accept_administrator_invitation(administrator_id, detector_id, invitation_id)
    accept_administrator_invitation(administrator_id, detector_id, invitation_id, params::Dict{String,<:Any})

Accepts the invitation to be a member account and get monitored by a GuardDuty
administrator account that sent the invitation.

# Arguments
- `administrator_id`: The account ID of the GuardDuty administrator account whose
  invitation you're accepting.
- `detector_id`: The unique ID of the detector of the GuardDuty member account.
- `invitation_id`: The value that is used to validate the administrator account to the
  member account.

"""
function accept_administrator_invitation(
    administratorId,
    detectorId,
    invitationId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/administrator",
        Dict{String,Any}(
            "administratorId" => administratorId, "invitationId" => invitationId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function accept_administrator_invitation(
    administratorId,
    detectorId,
    invitationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/administrator",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "administratorId" => administratorId, "invitationId" => invitationId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    accept_invitation(detector_id, invitation_id, master_id)
    accept_invitation(detector_id, invitation_id, master_id, params::Dict{String,<:Any})

Accepts the invitation to be monitored by a GuardDuty administrator account.

# Arguments
- `detector_id`: The unique ID of the detector of the GuardDuty member account.
- `invitation_id`: The value that is used to validate the administrator account to the
  member account.
- `master_id`: The account ID of the GuardDuty administrator account whose invitation
  you're accepting.

"""
function accept_invitation(
    detectorId, invitationId, masterId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/master",
        Dict{String,Any}("invitationId" => invitationId, "masterId" => masterId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function accept_invitation(
    detectorId,
    invitationId,
    masterId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/master",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("invitationId" => invitationId, "masterId" => masterId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    archive_findings(detector_id, finding_ids)
    archive_findings(detector_id, finding_ids, params::Dict{String,<:Any})

Archives GuardDuty findings that are specified by the list of finding IDs.  Only the
administrator account can archive findings. Member accounts don't have permission to
archive findings from their accounts.

# Arguments
- `detector_id`: The ID of the detector that specifies the GuardDuty service whose findings
  you want to archive.
- `finding_ids`: The IDs of the findings that you want to archive.

"""
function archive_findings(
    detectorId, findingIds; aws_config::AbstractAWSConfig=current_aws_config()
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/findings/archive",
        Dict{String,Any}("findingIds" => findingIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function archive_findings(
    detectorId,
    findingIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/findings/archive",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("findingIds" => findingIds), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_detector(enable)
    create_detector(enable, params::Dict{String,<:Any})

Creates a single GuardDuty detector. A detector is a resource that represents the GuardDuty
service. To start using GuardDuty, you must create a detector in each Region where you
enable the service. You can have only one detector per account per Region. All data sources
are enabled in a new detector by default.   When you don't specify any features, with an
exception to RUNTIME_MONITORING, all the optional features are enabled by default.   When
you specify some of the features, any feature that is not specified in the API call gets
enabled by default, with an exception to RUNTIME_MONITORING.    Specifying both EKS Runtime
Monitoring (EKS_RUNTIME_MONITORING) and Runtime Monitoring (RUNTIME_MONITORING) will cause
an error. You can add only one of these two features because Runtime Monitoring already
includes the threat detection for Amazon EKS resources. For more information, see Runtime
Monitoring. There might be regional differences because some data sources might not be
available in all the Amazon Web Services Regions where GuardDuty is presently supported.
For more information, see Regions and endpoints.

# Arguments
- `enable`: A Boolean value that specifies whether the detector is to be enabled.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: The idempotency token for the create request.
- `"dataSources"`: Describes which data sources will be enabled for the detector. There
  might be regional differences because some data sources might not be available in all the
  Amazon Web Services Regions where GuardDuty is presently supported. For more information,
  see Regions and endpoints.
- `"features"`: A list of features that will be configured for the detector.
- `"findingPublishingFrequency"`: A value that specifies how frequently updated findings
  are exported.
- `"tags"`: The tags to be added to a new detector resource.
"""
function create_detector(enable; aws_config::AbstractAWSConfig=current_aws_config())
    return guardduty(
        "POST",
        "/detector",
        Dict{String,Any}("enable" => enable, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_detector(
    enable, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return guardduty(
        "POST",
        "/detector",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("enable" => enable, "clientToken" => string(uuid4())),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_filter(detector_id, finding_criteria, name)
    create_filter(detector_id, finding_criteria, name, params::Dict{String,<:Any})

Creates a filter using the specified finding criteria. The maximum number of saved filters
per Amazon Web Services account per Region is 100. For more information, see Quotas for
GuardDuty.

# Arguments
- `detector_id`: The ID of the detector belonging to the GuardDuty account that you want to
  create a filter for.
- `finding_criteria`: Represents the criteria to be used in the filter for querying
  findings. You can only use the following attributes to query findings:   accountId   id
  region   severity To filter on the basis of severity, the API and CLI use the following
  input list for the FindingCriteria condition:    Low: [\"1\", \"2\", \"3\"]     Medium:
  [\"4\", \"5\", \"6\"]     High: [\"7\", \"8\", \"9\"]    For more information, see Severity
  levels for GuardDuty findings.   type   updatedAt Type: ISO 8601 string format:
  YYYY-MM-DDTHH:MM:SS.SSSZ or YYYY-MM-DDTHH:MM:SSZ depending on whether the value contains
  milliseconds.   resource.accessKeyDetails.accessKeyId
  resource.accessKeyDetails.principalId   resource.accessKeyDetails.userName
  resource.accessKeyDetails.userType   resource.instanceDetails.iamInstanceProfile.id
  resource.instanceDetails.imageId   resource.instanceDetails.instanceId
  resource.instanceDetails.tags.key   resource.instanceDetails.tags.value
  resource.instanceDetails.networkInterfaces.ipv6Addresses
  resource.instanceDetails.networkInterfaces.privateIpAddresses.privateIpAddress
  resource.instanceDetails.networkInterfaces.publicDnsName
  resource.instanceDetails.networkInterfaces.publicIp
  resource.instanceDetails.networkInterfaces.securityGroups.groupId
  resource.instanceDetails.networkInterfaces.securityGroups.groupName
  resource.instanceDetails.networkInterfaces.subnetId
  resource.instanceDetails.networkInterfaces.vpcId   resource.instanceDetails.outpostArn
  resource.resourceType   resource.s3BucketDetails.publicAccess.effectivePermissions
  resource.s3BucketDetails.name   resource.s3BucketDetails.tags.key
  resource.s3BucketDetails.tags.value   resource.s3BucketDetails.type
  service.action.actionType   service.action.awsApiCallAction.api
  service.action.awsApiCallAction.callerType   service.action.awsApiCallAction.errorCode
  service.action.awsApiCallAction.remoteIpDetails.city.cityName
  service.action.awsApiCallAction.remoteIpDetails.country.countryName
  service.action.awsApiCallAction.remoteIpDetails.ipAddressV4
  service.action.awsApiCallAction.remoteIpDetails.ipAddressV6
  service.action.awsApiCallAction.remoteIpDetails.organization.asn
  service.action.awsApiCallAction.remoteIpDetails.organization.asnOrg
  service.action.awsApiCallAction.serviceName   service.action.dnsRequestAction.domain
  service.action.dnsRequestAction.domainWithSuffix
  service.action.networkConnectionAction.blocked
  service.action.networkConnectionAction.connectionDirection
  service.action.networkConnectionAction.localPortDetails.port
  service.action.networkConnectionAction.protocol
  service.action.networkConnectionAction.remoteIpDetails.city.cityName
  service.action.networkConnectionAction.remoteIpDetails.country.countryName
  service.action.networkConnectionAction.remoteIpDetails.ipAddressV4
  service.action.networkConnectionAction.remoteIpDetails.ipAddressV6
  service.action.networkConnectionAction.remoteIpDetails.organization.asn
  service.action.networkConnectionAction.remoteIpDetails.organization.asnOrg
  service.action.networkConnectionAction.remotePortDetails.port
  service.action.awsApiCallAction.remoteAccountDetails.affiliated
  service.action.kubernetesApiCallAction.remoteIpDetails.ipAddressV4
  service.action.kubernetesApiCallAction.remoteIpDetails.ipAddressV6
  service.action.kubernetesApiCallAction.namespace
  service.action.kubernetesApiCallAction.remoteIpDetails.organization.asn
  service.action.kubernetesApiCallAction.requestUri
  service.action.kubernetesApiCallAction.statusCode
  service.action.networkConnectionAction.localIpDetails.ipAddressV4
  service.action.networkConnectionAction.localIpDetails.ipAddressV6
  service.action.networkConnectionAction.protocol
  service.action.awsApiCallAction.serviceName
  service.action.awsApiCallAction.remoteAccountDetails.accountId
  service.additionalInfo.threatListName   service.resourceRole
  resource.eksClusterDetails.name   resource.kubernetesDetails.kubernetesWorkloadDetails.name
    resource.kubernetesDetails.kubernetesWorkloadDetails.namespace
  resource.kubernetesDetails.kubernetesUserDetails.username
  resource.kubernetesDetails.kubernetesWorkloadDetails.containers.image
  resource.kubernetesDetails.kubernetesWorkloadDetails.containers.imagePrefix
  service.ebsVolumeScanDetails.scanId
  service.ebsVolumeScanDetails.scanDetections.threatDetectedByName.threatNames.name
  service.ebsVolumeScanDetails.scanDetections.threatDetectedByName.threatNames.severity
  service.ebsVolumeScanDetails.scanDetections.threatDetectedByName.threatNames.filePaths.hash
    resource.ecsClusterDetails.name   resource.ecsClusterDetails.taskDetails.containers.image
    resource.ecsClusterDetails.taskDetails.definitionArn   resource.containerDetails.image
  resource.rdsDbInstanceDetails.dbInstanceIdentifier
  resource.rdsDbInstanceDetails.dbClusterIdentifier   resource.rdsDbInstanceDetails.engine
  resource.rdsDbUserDetails.user   resource.rdsDbInstanceDetails.tags.key
  resource.rdsDbInstanceDetails.tags.value   service.runtimeDetails.process.executableSha256
   service.runtimeDetails.process.name   service.runtimeDetails.process.name
  resource.lambdaDetails.functionName   resource.lambdaDetails.functionArn
  resource.lambdaDetails.tags.key   resource.lambdaDetails.tags.value
- `name`: The name of the filter. Valid characters include period (.), underscore (_), dash
  (-), and alphanumeric characters. A whitespace is considered to be an invalid character.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"action"`: Specifies the action that is to be applied to the findings that match the
  filter.
- `"clientToken"`: The idempotency token for the create request.
- `"description"`: The description of the filter. Valid characters include alphanumeric
  characters, and special characters such as hyphen, period, colon, underscore, parentheses
  ({ }, [ ], and ( )), forward slash, horizontal tab, vertical tab, newline, form feed,
  return, and whitespace.
- `"rank"`: Specifies the position of the filter in the list of current filters. Also
  specifies the order in which this filter is applied to the findings.
- `"tags"`: The tags to be added to a new filter resource.
"""
function create_filter(
    detectorId, findingCriteria, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/filter",
        Dict{String,Any}(
            "findingCriteria" => findingCriteria,
            "name" => name,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_filter(
    detectorId,
    findingCriteria,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/filter",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "findingCriteria" => findingCriteria,
                    "name" => name,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_ipset(activate, detector_id, format, location, name)
    create_ipset(activate, detector_id, format, location, name, params::Dict{String,<:Any})

Creates a new IPSet, which is called a trusted IP list in the console user interface. An
IPSet is a list of IP addresses that are trusted for secure communication with Amazon Web
Services infrastructure and applications. GuardDuty doesn't generate findings for IP
addresses that are included in IPSets. Only users from the administrator account can use
this operation.

# Arguments
- `activate`: A Boolean value that indicates whether GuardDuty is to start using the
  uploaded IPSet.
- `detector_id`: The unique ID of the detector of the GuardDuty account that you want to
  create an IPSet for.
- `format`: The format of the file that contains the IPSet.
- `location`: The URI of the file that contains the IPSet.
- `name`: The user-friendly name to identify the IPSet.  Allowed characters are
  alphanumeric, whitespace, dash (-), and underscores (_).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: The idempotency token for the create request.
- `"tags"`: The tags to be added to a new IP set resource.
"""
function create_ipset(
    activate,
    detectorId,
    format,
    location,
    name;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/ipset",
        Dict{String,Any}(
            "activate" => activate,
            "format" => format,
            "location" => location,
            "name" => name,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_ipset(
    activate,
    detectorId,
    format,
    location,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/ipset",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "activate" => activate,
                    "format" => format,
                    "location" => location,
                    "name" => name,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_malware_protection_plan(protected_resource, role)
    create_malware_protection_plan(protected_resource, role, params::Dict{String,<:Any})

Creates a new Malware Protection plan for the protected resource. When you create a Malware
Protection plan, the Amazon Web Services service terms for GuardDuty Malware Protection
apply. For more information, see Amazon Web Services service terms for GuardDuty Malware
Protection.

# Arguments
- `protected_resource`: Information about the protected resource that is associated with
  the created Malware Protection plan. Presently, S3Bucket is the only supported protected
  resource.
- `role`: IAM role with permissions required to scan and add tags to the associated
  protected resource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"actions"`: Information about whether the tags will be added to the S3 object after
  scanning.
- `"clientToken"`: The idempotency token for the create request.
- `"tags"`: Tags added to the Malware Protection plan resource.
"""
function create_malware_protection_plan(
    protectedResource, role; aws_config::AbstractAWSConfig=current_aws_config()
)
    return guardduty(
        "POST",
        "/malware-protection-plan",
        Dict{String,Any}(
            "protectedResource" => protectedResource,
            "role" => role,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_malware_protection_plan(
    protectedResource,
    role,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "POST",
        "/malware-protection-plan",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "protectedResource" => protectedResource,
                    "role" => role,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_members(account_details, detector_id)
    create_members(account_details, detector_id, params::Dict{String,<:Any})

Creates member accounts of the current Amazon Web Services account by specifying a list of
Amazon Web Services account IDs. This step is a prerequisite for managing the associated
member accounts either by invitation or through an organization. As a delegated
administrator, using CreateMembers will enable GuardDuty in the added member accounts, with
the exception of the organization delegated administrator account. A delegated
administrator must enable GuardDuty prior to being added as a member. When you use
CreateMembers as an Organizations delegated administrator, GuardDuty applies your
organization's auto-enable settings to the member accounts in this request, irrespective of
the accounts being new or existing members. For more information about the existing
auto-enable settings for your organization, see DescribeOrganizationConfiguration. If you
disassociate a member account that was added by invitation, the member account details
obtained from this API, including the associated email addresses, will be retained. This is
done so that the delegated administrator can invoke the InviteMembers API without the need
to invoke the CreateMembers API again. To remove the details associated with a member
account, the delegated administrator must invoke the DeleteMembers API.  When the member
accounts added through Organizations are later disassociated, you (administrator) can't
invite them by calling the InviteMembers API. You can create an association with these
member accounts again only by calling the CreateMembers API.

# Arguments
- `account_details`: A list of account ID and email address pairs of the accounts that you
  want to associate with the GuardDuty administrator account.
- `detector_id`: The unique ID of the detector of the GuardDuty account that you want to
  associate member accounts with.

"""
function create_members(
    accountDetails, detectorId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/member",
        Dict{String,Any}("accountDetails" => accountDetails);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_members(
    accountDetails,
    detectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/member",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("accountDetails" => accountDetails), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_publishing_destination(destination_properties, destination_type, detector_id)
    create_publishing_destination(destination_properties, destination_type, detector_id, params::Dict{String,<:Any})

Creates a publishing destination to export findings to. The resource to export findings to
must exist before you use this operation.

# Arguments
- `destination_properties`: The properties of the publishing destination, including the
  ARNs for the destination and the KMS key used for encryption.
- `destination_type`: The type of resource for the publishing destination. Currently only
  Amazon S3 buckets are supported.
- `detector_id`: The ID of the GuardDuty detector associated with the publishing
  destination.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: The idempotency token for the request.
"""
function create_publishing_destination(
    destinationProperties,
    destinationType,
    detectorId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/publishingDestination",
        Dict{String,Any}(
            "destinationProperties" => destinationProperties,
            "destinationType" => destinationType,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_publishing_destination(
    destinationProperties,
    destinationType,
    detectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/publishingDestination",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "destinationProperties" => destinationProperties,
                    "destinationType" => destinationType,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_sample_findings(detector_id)
    create_sample_findings(detector_id, params::Dict{String,<:Any})

Generates sample findings of types specified by the list of finding types. If 'NULL' is
specified for findingTypes, the API generates sample findings of all supported finding
types.

# Arguments
- `detector_id`: The ID of the detector to create sample findings for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"findingTypes"`: The types of sample findings to generate.
"""
function create_sample_findings(
    detectorId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/findings/create";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_sample_findings(
    detectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/findings/create",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_threat_intel_set(activate, detector_id, format, location, name)
    create_threat_intel_set(activate, detector_id, format, location, name, params::Dict{String,<:Any})

Creates a new ThreatIntelSet. ThreatIntelSets consist of known malicious IP addresses.
GuardDuty generates findings based on ThreatIntelSets. Only users of the administrator
account can use this operation.

# Arguments
- `activate`: A Boolean value that indicates whether GuardDuty is to start using the
  uploaded ThreatIntelSet.
- `detector_id`: The unique ID of the detector of the GuardDuty account that you want to
  create a threatIntelSet for.
- `format`: The format of the file that contains the ThreatIntelSet.
- `location`: The URI of the file that contains the ThreatIntelSet.
- `name`: A user-friendly ThreatIntelSet name displayed in all findings that are generated
  by activity that involves IP addresses included in this ThreatIntelSet.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: The idempotency token for the create request.
- `"tags"`: The tags to be added to a new threat list resource.
"""
function create_threat_intel_set(
    activate,
    detectorId,
    format,
    location,
    name;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/threatintelset",
        Dict{String,Any}(
            "activate" => activate,
            "format" => format,
            "location" => location,
            "name" => name,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_threat_intel_set(
    activate,
    detectorId,
    format,
    location,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/threatintelset",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "activate" => activate,
                    "format" => format,
                    "location" => location,
                    "name" => name,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    decline_invitations(account_ids)
    decline_invitations(account_ids, params::Dict{String,<:Any})

Declines invitations sent to the current member account by Amazon Web Services accounts
specified by their account IDs.

# Arguments
- `account_ids`: A list of account IDs of the Amazon Web Services accounts that sent
  invitations to the current member account that you want to decline invitations from.

"""
function decline_invitations(accountIds; aws_config::AbstractAWSConfig=current_aws_config())
    return guardduty(
        "POST",
        "/invitation/decline",
        Dict{String,Any}("accountIds" => accountIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function decline_invitations(
    accountIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "POST",
        "/invitation/decline",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("accountIds" => accountIds), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_detector(detector_id)
    delete_detector(detector_id, params::Dict{String,<:Any})

Deletes an Amazon GuardDuty detector that is specified by the detector ID.

# Arguments
- `detector_id`: The unique ID of the detector that you want to delete.

"""
function delete_detector(detectorId; aws_config::AbstractAWSConfig=current_aws_config())
    return guardduty(
        "DELETE",
        "/detector/$(detectorId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_detector(
    detectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "DELETE",
        "/detector/$(detectorId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_filter(detector_id, filter_name)
    delete_filter(detector_id, filter_name, params::Dict{String,<:Any})

Deletes the filter specified by the filter name.

# Arguments
- `detector_id`: The unique ID of the detector that the filter is associated with.
- `filter_name`: The name of the filter that you want to delete.

"""
function delete_filter(
    detectorId, filterName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return guardduty(
        "DELETE",
        "/detector/$(detectorId)/filter/$(filterName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_filter(
    detectorId,
    filterName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "DELETE",
        "/detector/$(detectorId)/filter/$(filterName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_invitations(account_ids)
    delete_invitations(account_ids, params::Dict{String,<:Any})

Deletes invitations sent to the current member account by Amazon Web Services accounts
specified by their account IDs.

# Arguments
- `account_ids`: A list of account IDs of the Amazon Web Services accounts that sent
  invitations to the current member account that you want to delete invitations from.

"""
function delete_invitations(accountIds; aws_config::AbstractAWSConfig=current_aws_config())
    return guardduty(
        "POST",
        "/invitation/delete",
        Dict{String,Any}("accountIds" => accountIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_invitations(
    accountIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "POST",
        "/invitation/delete",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("accountIds" => accountIds), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_ipset(detector_id, ip_set_id)
    delete_ipset(detector_id, ip_set_id, params::Dict{String,<:Any})

Deletes the IPSet specified by the ipSetId. IPSets are called trusted IP lists in the
console user interface.

# Arguments
- `detector_id`: The unique ID of the detector associated with the IPSet.
- `ip_set_id`: The unique ID of the IPSet to delete.

"""
function delete_ipset(
    detectorId, ipSetId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return guardduty(
        "DELETE",
        "/detector/$(detectorId)/ipset/$(ipSetId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_ipset(
    detectorId,
    ipSetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "DELETE",
        "/detector/$(detectorId)/ipset/$(ipSetId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_malware_protection_plan(malware_protection_plan_id)
    delete_malware_protection_plan(malware_protection_plan_id, params::Dict{String,<:Any})

Deletes the Malware Protection plan ID associated with the Malware Protection plan
resource. Use this API only when you no longer want to protect the resource associated with
this Malware Protection plan ID.

# Arguments
- `malware_protection_plan_id`: A unique identifier associated with Malware Protection plan
  resource.

"""
function delete_malware_protection_plan(
    malwareProtectionPlanId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return guardduty(
        "DELETE",
        "/malware-protection-plan/$(malwareProtectionPlanId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_malware_protection_plan(
    malwareProtectionPlanId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "DELETE",
        "/malware-protection-plan/$(malwareProtectionPlanId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_members(account_ids, detector_id)
    delete_members(account_ids, detector_id, params::Dict{String,<:Any})

Deletes GuardDuty member accounts (to the current GuardDuty administrator account)
specified by the account IDs. With autoEnableOrganizationMembers configuration for your
organization set to ALL, you'll receive an error if you attempt to disable GuardDuty for a
member account in your organization.

# Arguments
- `account_ids`: A list of account IDs of the GuardDuty member accounts that you want to
  delete.
- `detector_id`: The unique ID of the detector of the GuardDuty account whose members you
  want to delete.

"""
function delete_members(
    accountIds, detectorId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/member/delete",
        Dict{String,Any}("accountIds" => accountIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_members(
    accountIds,
    detectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/member/delete",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("accountIds" => accountIds), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_publishing_destination(destination_id, detector_id)
    delete_publishing_destination(destination_id, detector_id, params::Dict{String,<:Any})

Deletes the publishing definition with the specified destinationId.

# Arguments
- `destination_id`: The ID of the publishing destination to delete.
- `detector_id`: The unique ID of the detector associated with the publishing destination
  to delete.

"""
function delete_publishing_destination(
    destinationId, detectorId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return guardduty(
        "DELETE",
        "/detector/$(detectorId)/publishingDestination/$(destinationId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_publishing_destination(
    destinationId,
    detectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "DELETE",
        "/detector/$(detectorId)/publishingDestination/$(destinationId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_threat_intel_set(detector_id, threat_intel_set_id)
    delete_threat_intel_set(detector_id, threat_intel_set_id, params::Dict{String,<:Any})

Deletes the ThreatIntelSet specified by the ThreatIntelSet ID.

# Arguments
- `detector_id`: The unique ID of the detector that the threatIntelSet is associated with.
- `threat_intel_set_id`: The unique ID of the threatIntelSet that you want to delete.

"""
function delete_threat_intel_set(
    detectorId, threatIntelSetId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return guardduty(
        "DELETE",
        "/detector/$(detectorId)/threatintelset/$(threatIntelSetId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_threat_intel_set(
    detectorId,
    threatIntelSetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "DELETE",
        "/detector/$(detectorId)/threatintelset/$(threatIntelSetId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_malware_scans(detector_id)
    describe_malware_scans(detector_id, params::Dict{String,<:Any})

Returns a list of malware scans. Each member account can view the malware scans for their
own accounts. An administrator can view the malware scans for all the member accounts.
There might be regional differences because some data sources might not be available in all
the Amazon Web Services Regions where GuardDuty is presently supported. For more
information, see Regions and endpoints.

# Arguments
- `detector_id`: The unique ID of the detector that the request is associated with.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filterCriteria"`: Represents the criteria to be used in the filter for describing scan
  entries.
- `"maxResults"`: You can use this parameter to indicate the maximum number of items that
  you want in the response. The default value is 50. The maximum value is 50.
- `"nextToken"`: You can use this parameter when paginating results. Set the value of this
  parameter to null on your first call to the list action. For subsequent calls to the
  action, fill nextToken in the request with the value of NextToken from the previous
  response to continue listing data.
- `"sortCriteria"`: Represents the criteria used for sorting scan entries. The
  attributeName  is required and it must be scanStartTime.
"""
function describe_malware_scans(
    detectorId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/malware-scans";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_malware_scans(
    detectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/malware-scans",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_organization_configuration(detector_id)
    describe_organization_configuration(detector_id, params::Dict{String,<:Any})

Returns information about the account selected as the delegated administrator for
GuardDuty. There might be regional differences because some data sources might not be
available in all the Amazon Web Services Regions where GuardDuty is presently supported.
For more information, see Regions and endpoints.

# Arguments
- `detector_id`: The ID of the detector to retrieve information about the delegated
  administrator from.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: You can use this parameter to indicate the maximum number of items that
  you want in the response.
- `"nextToken"`: You can use this parameter when paginating results. Set the value of this
  parameter to null on your first call to the list action. For subsequent calls to the
  action, fill nextToken in the request with the value of NextToken from the previous
  response to continue listing data.
"""
function describe_organization_configuration(
    detectorId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return guardduty(
        "GET",
        "/detector/$(detectorId)/admin";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_organization_configuration(
    detectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "GET",
        "/detector/$(detectorId)/admin",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_publishing_destination(destination_id, detector_id)
    describe_publishing_destination(destination_id, detector_id, params::Dict{String,<:Any})

Returns information about the publishing destination specified by the provided
destinationId.

# Arguments
- `destination_id`: The ID of the publishing destination to retrieve.
- `detector_id`: The unique ID of the detector associated with the publishing destination
  to retrieve.

"""
function describe_publishing_destination(
    destinationId, detectorId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return guardduty(
        "GET",
        "/detector/$(detectorId)/publishingDestination/$(destinationId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_publishing_destination(
    destinationId,
    detectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "GET",
        "/detector/$(detectorId)/publishingDestination/$(destinationId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disable_organization_admin_account(admin_account_id)
    disable_organization_admin_account(admin_account_id, params::Dict{String,<:Any})

Removes the existing GuardDuty delegated administrator of the organization. Only the
organization's management account can run this API operation.

# Arguments
- `admin_account_id`: The Amazon Web Services Account ID for the organizations account to
  be disabled as a GuardDuty delegated administrator.

"""
function disable_organization_admin_account(
    adminAccountId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return guardduty(
        "POST",
        "/admin/disable",
        Dict{String,Any}("adminAccountId" => adminAccountId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disable_organization_admin_account(
    adminAccountId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "POST",
        "/admin/disable",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("adminAccountId" => adminAccountId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_from_administrator_account(detector_id)
    disassociate_from_administrator_account(detector_id, params::Dict{String,<:Any})

Disassociates the current GuardDuty member account from its administrator account. When you
disassociate an invited member from a GuardDuty delegated administrator, the member account
details obtained from the CreateMembers API, including the associated email addresses, are
retained. This is done so that the delegated administrator can invoke the InviteMembers API
without the need to invoke the CreateMembers API again. To remove the details associated
with a member account, the delegated administrator must invoke the DeleteMembers API.  With
autoEnableOrganizationMembers configuration for your organization set to ALL, you'll
receive an error if you attempt to disable GuardDuty in a member account.

# Arguments
- `detector_id`: The unique ID of the detector of the GuardDuty member account.

"""
function disassociate_from_administrator_account(
    detectorId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/administrator/disassociate";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_from_administrator_account(
    detectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/administrator/disassociate",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_from_master_account(detector_id)
    disassociate_from_master_account(detector_id, params::Dict{String,<:Any})

Disassociates the current GuardDuty member account from its administrator account. When you
disassociate an invited member from a GuardDuty delegated administrator, the member account
details obtained from the CreateMembers API, including the associated email addresses, are
retained. This is done so that the delegated administrator can invoke the InviteMembers API
without the need to invoke the CreateMembers API again. To remove the details associated
with a member account, the delegated administrator must invoke the DeleteMembers API.

# Arguments
- `detector_id`: The unique ID of the detector of the GuardDuty member account.

"""
function disassociate_from_master_account(
    detectorId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/master/disassociate";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_from_master_account(
    detectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/master/disassociate",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_members(account_ids, detector_id)
    disassociate_members(account_ids, detector_id, params::Dict{String,<:Any})

Disassociates GuardDuty member accounts (from the current administrator account) specified
by the account IDs. When you disassociate an invited member from a GuardDuty delegated
administrator, the member account details obtained from the CreateMembers API, including
the associated email addresses, are retained. This is done so that the delegated
administrator can invoke the InviteMembers API without the need to invoke the CreateMembers
API again. To remove the details associated with a member account, the delegated
administrator must invoke the DeleteMembers API.  With autoEnableOrganizationMembers
configuration for your organization set to ALL, you'll receive an error if you attempt to
disassociate a member account before removing them from your organization. If you
disassociate a member account that was added by invitation, the member account details
obtained from this API, including the associated email addresses, will be retained. This is
done so that the delegated administrator can invoke the InviteMembers API without the need
to invoke the CreateMembers API again. To remove the details associated with a member
account, the delegated administrator must invoke the DeleteMembers API.  When the member
accounts added through Organizations are later disassociated, you (administrator) can't
invite them by calling the InviteMembers API. You can create an association with these
member accounts again only by calling the CreateMembers API.

# Arguments
- `account_ids`: A list of account IDs of the GuardDuty member accounts that you want to
  disassociate from the administrator account.
- `detector_id`: The unique ID of the detector of the GuardDuty account whose members you
  want to disassociate from the administrator account.

"""
function disassociate_members(
    accountIds, detectorId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/member/disassociate",
        Dict{String,Any}("accountIds" => accountIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_members(
    accountIds,
    detectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/member/disassociate",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("accountIds" => accountIds), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    enable_organization_admin_account(admin_account_id)
    enable_organization_admin_account(admin_account_id, params::Dict{String,<:Any})

Designates an Amazon Web Services account within the organization as your GuardDuty
delegated administrator. Only the organization's management account can run this API
operation.

# Arguments
- `admin_account_id`: The Amazon Web Services account ID for the organization account to be
  enabled as a GuardDuty delegated administrator.

"""
function enable_organization_admin_account(
    adminAccountId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return guardduty(
        "POST",
        "/admin/enable",
        Dict{String,Any}("adminAccountId" => adminAccountId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function enable_organization_admin_account(
    adminAccountId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "POST",
        "/admin/enable",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("adminAccountId" => adminAccountId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_administrator_account(detector_id)
    get_administrator_account(detector_id, params::Dict{String,<:Any})

Provides the details of the GuardDuty administrator account associated with the current
GuardDuty member account.  If the organization's management account or a delegated
administrator runs this API, it will return success (HTTP 200) but no content.

# Arguments
- `detector_id`: The unique ID of the detector of the GuardDuty member account.

"""
function get_administrator_account(
    detectorId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return guardduty(
        "GET",
        "/detector/$(detectorId)/administrator";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_administrator_account(
    detectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "GET",
        "/detector/$(detectorId)/administrator",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_coverage_statistics(detector_id, statistics_type)
    get_coverage_statistics(detector_id, statistics_type, params::Dict{String,<:Any})

Retrieves aggregated statistics for your account. If you are a GuardDuty administrator, you
can retrieve the statistics for all the resources associated with the active member
accounts in your organization who have enabled Runtime Monitoring and have the GuardDuty
security agent running on their resources.

# Arguments
- `detector_id`: The unique ID of the GuardDuty detector associated to the coverage
  statistics.
- `statistics_type`: Represents the statistics type used to aggregate the coverage details.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filterCriteria"`: Represents the criteria used to filter the coverage statistics
"""
function get_coverage_statistics(
    detectorId, statisticsType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/coverage/statistics",
        Dict{String,Any}("statisticsType" => statisticsType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_coverage_statistics(
    detectorId,
    statisticsType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/coverage/statistics",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("statisticsType" => statisticsType), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_detector(detector_id)
    get_detector(detector_id, params::Dict{String,<:Any})

Retrieves an Amazon GuardDuty detector specified by the detectorId. There might be regional
differences because some data sources might not be available in all the Amazon Web Services
Regions where GuardDuty is presently supported. For more information, see Regions and
endpoints.

# Arguments
- `detector_id`: The unique ID of the detector that you want to get.

"""
function get_detector(detectorId; aws_config::AbstractAWSConfig=current_aws_config())
    return guardduty(
        "GET",
        "/detector/$(detectorId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_detector(
    detectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "GET",
        "/detector/$(detectorId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_filter(detector_id, filter_name)
    get_filter(detector_id, filter_name, params::Dict{String,<:Any})

Returns the details of the filter specified by the filter name.

# Arguments
- `detector_id`: The unique ID of the detector that the filter is associated with.
- `filter_name`: The name of the filter you want to get.

"""
function get_filter(
    detectorId, filterName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return guardduty(
        "GET",
        "/detector/$(detectorId)/filter/$(filterName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_filter(
    detectorId,
    filterName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "GET",
        "/detector/$(detectorId)/filter/$(filterName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_findings(detector_id, finding_ids)
    get_findings(detector_id, finding_ids, params::Dict{String,<:Any})

Describes Amazon GuardDuty findings specified by finding IDs.

# Arguments
- `detector_id`: The ID of the detector that specifies the GuardDuty service whose findings
  you want to retrieve.
- `finding_ids`: The IDs of the findings that you want to retrieve.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"sortCriteria"`: Represents the criteria used for sorting findings.
"""
function get_findings(
    detectorId, findingIds; aws_config::AbstractAWSConfig=current_aws_config()
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/findings/get",
        Dict{String,Any}("findingIds" => findingIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_findings(
    detectorId,
    findingIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/findings/get",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("findingIds" => findingIds), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_findings_statistics(detector_id, finding_statistic_types)
    get_findings_statistics(detector_id, finding_statistic_types, params::Dict{String,<:Any})

Lists Amazon GuardDuty findings statistics for the specified detector ID. There might be
regional differences because some flags might not be available in all the Regions where
GuardDuty is currently supported. For more information, see Regions and endpoints.

# Arguments
- `detector_id`: The ID of the detector that specifies the GuardDuty service whose
  findings' statistics you want to retrieve.
- `finding_statistic_types`: The types of finding statistics to retrieve.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"findingCriteria"`: Represents the criteria that is used for querying findings.
"""
function get_findings_statistics(
    detectorId, findingStatisticTypes; aws_config::AbstractAWSConfig=current_aws_config()
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/findings/statistics",
        Dict{String,Any}("findingStatisticTypes" => findingStatisticTypes);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_findings_statistics(
    detectorId,
    findingStatisticTypes,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/findings/statistics",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("findingStatisticTypes" => findingStatisticTypes),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_invitations_count()
    get_invitations_count(params::Dict{String,<:Any})

Returns the count of all GuardDuty membership invitations that were sent to the current
member account except the currently accepted invitation.

"""
function get_invitations_count(; aws_config::AbstractAWSConfig=current_aws_config())
    return guardduty(
        "GET", "/invitation/count"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_invitations_count(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return guardduty(
        "GET",
        "/invitation/count",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_ipset(detector_id, ip_set_id)
    get_ipset(detector_id, ip_set_id, params::Dict{String,<:Any})

Retrieves the IPSet specified by the ipSetId.

# Arguments
- `detector_id`: The unique ID of the detector that the IPSet is associated with.
- `ip_set_id`: The unique ID of the IPSet to retrieve.

"""
function get_ipset(detectorId, ipSetId; aws_config::AbstractAWSConfig=current_aws_config())
    return guardduty(
        "GET",
        "/detector/$(detectorId)/ipset/$(ipSetId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_ipset(
    detectorId,
    ipSetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "GET",
        "/detector/$(detectorId)/ipset/$(ipSetId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_malware_protection_plan(malware_protection_plan_id)
    get_malware_protection_plan(malware_protection_plan_id, params::Dict{String,<:Any})

Retrieves the Malware Protection plan details associated with a Malware Protection plan ID.

# Arguments
- `malware_protection_plan_id`: A unique identifier associated with Malware Protection plan
  resource.

"""
function get_malware_protection_plan(
    malwareProtectionPlanId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return guardduty(
        "GET",
        "/malware-protection-plan/$(malwareProtectionPlanId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_malware_protection_plan(
    malwareProtectionPlanId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "GET",
        "/malware-protection-plan/$(malwareProtectionPlanId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_malware_scan_settings(detector_id)
    get_malware_scan_settings(detector_id, params::Dict{String,<:Any})

Returns the details of the malware scan settings. There might be regional differences
because some data sources might not be available in all the Amazon Web Services Regions
where GuardDuty is presently supported. For more information, see Regions and endpoints.

# Arguments
- `detector_id`: The unique ID of the detector that the scan setting is associated with.

"""
function get_malware_scan_settings(
    detectorId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return guardduty(
        "GET",
        "/detector/$(detectorId)/malware-scan-settings";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_malware_scan_settings(
    detectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "GET",
        "/detector/$(detectorId)/malware-scan-settings",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_master_account(detector_id)
    get_master_account(detector_id, params::Dict{String,<:Any})

Provides the details for the GuardDuty administrator account associated with the current
GuardDuty member account.

# Arguments
- `detector_id`: The unique ID of the detector of the GuardDuty member account.

"""
function get_master_account(detectorId; aws_config::AbstractAWSConfig=current_aws_config())
    return guardduty(
        "GET",
        "/detector/$(detectorId)/master";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_master_account(
    detectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "GET",
        "/detector/$(detectorId)/master",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_member_detectors(account_ids, detector_id)
    get_member_detectors(account_ids, detector_id, params::Dict{String,<:Any})

Describes which data sources are enabled for the member account's detector. There might be
regional differences because some data sources might not be available in all the Amazon Web
Services Regions where GuardDuty is presently supported. For more information, see Regions
and endpoints.

# Arguments
- `account_ids`: The account ID of the member account.
- `detector_id`: The detector ID for the administrator account.

"""
function get_member_detectors(
    accountIds, detectorId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/member/detector/get",
        Dict{String,Any}("accountIds" => accountIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_member_detectors(
    accountIds,
    detectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/member/detector/get",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("accountIds" => accountIds), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_members(account_ids, detector_id)
    get_members(account_ids, detector_id, params::Dict{String,<:Any})

Retrieves GuardDuty member accounts (of the current GuardDuty administrator account)
specified by the account IDs.

# Arguments
- `account_ids`: A list of account IDs of the GuardDuty member accounts that you want to
  describe.
- `detector_id`: The unique ID of the detector of the GuardDuty account whose members you
  want to retrieve.

"""
function get_members(
    accountIds, detectorId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/member/get",
        Dict{String,Any}("accountIds" => accountIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_members(
    accountIds,
    detectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/member/get",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("accountIds" => accountIds), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_organization_statistics()
    get_organization_statistics(params::Dict{String,<:Any})

Retrieves how many active member accounts have each feature enabled within GuardDuty. Only
a delegated GuardDuty administrator of an organization can run this API. When you create a
new organization, it might take up to 24 hours to generate the statistics for the entire
organization.

"""
function get_organization_statistics(; aws_config::AbstractAWSConfig=current_aws_config())
    return guardduty(
        "GET",
        "/organization/statistics";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_organization_statistics(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return guardduty(
        "GET",
        "/organization/statistics",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_remaining_free_trial_days(detector_id)
    get_remaining_free_trial_days(detector_id, params::Dict{String,<:Any})

Provides the number of days left for each data source used in the free trial period.

# Arguments
- `detector_id`: The unique ID of the detector of the GuardDuty member account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountIds"`: A list of account identifiers of the GuardDuty member account.
"""
function get_remaining_free_trial_days(
    detectorId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/freeTrial/daysRemaining";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_remaining_free_trial_days(
    detectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/freeTrial/daysRemaining",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_threat_intel_set(detector_id, threat_intel_set_id)
    get_threat_intel_set(detector_id, threat_intel_set_id, params::Dict{String,<:Any})

Retrieves the ThreatIntelSet that is specified by the ThreatIntelSet ID.

# Arguments
- `detector_id`: The unique ID of the detector that the threatIntelSet is associated with.
- `threat_intel_set_id`: The unique ID of the threatIntelSet that you want to get.

"""
function get_threat_intel_set(
    detectorId, threatIntelSetId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return guardduty(
        "GET",
        "/detector/$(detectorId)/threatintelset/$(threatIntelSetId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_threat_intel_set(
    detectorId,
    threatIntelSetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "GET",
        "/detector/$(detectorId)/threatintelset/$(threatIntelSetId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_usage_statistics(detector_id, usage_criteria, usage_statistics_type)
    get_usage_statistics(detector_id, usage_criteria, usage_statistics_type, params::Dict{String,<:Any})

Lists Amazon GuardDuty usage statistics over the last 30 days for the specified detector
ID. For newly enabled detectors or data sources, the cost returned will include only the
usage so far under 30 days. This may differ from the cost metrics in the console, which
project usage over 30 days to provide a monthly cost estimate. For more information, see
Understanding How Usage Costs are Calculated.

# Arguments
- `detector_id`: The ID of the detector that specifies the GuardDuty service whose usage
  statistics you want to retrieve.
- `usage_criteria`: Represents the criteria used for querying usage.
- `usage_statistics_type`: The type of usage statistics to retrieve.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in the response.
- `"nextToken"`: A token to use for paginating results that are returned in the response.
  Set the value of this parameter to null for the first request to a list action. For
  subsequent calls, use the NextToken value returned from the previous request to continue
  listing results after the first page.
- `"unit"`: The currency unit you would like to view your usage statistics in. Current
  valid values are USD.
"""
function get_usage_statistics(
    detectorId,
    usageCriteria,
    usageStatisticsType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/usage/statistics",
        Dict{String,Any}(
            "usageCriteria" => usageCriteria, "usageStatisticsType" => usageStatisticsType
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_usage_statistics(
    detectorId,
    usageCriteria,
    usageStatisticsType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/usage/statistics",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "usageCriteria" => usageCriteria,
                    "usageStatisticsType" => usageStatisticsType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    invite_members(account_ids, detector_id)
    invite_members(account_ids, detector_id, params::Dict{String,<:Any})

Invites Amazon Web Services accounts to become members of an organization administered by
the Amazon Web Services account that invokes this API. If you are using Amazon Web Services
Organizations to manage your GuardDuty environment, this step is not needed. For more
information, see Managing accounts with organizations. To invite Amazon Web Services
accounts, the first step is to ensure that GuardDuty has been enabled in the potential
member accounts. You can now invoke this API to add accounts by invitation. The invited
accounts can either accept or decline the invitation from their GuardDuty accounts. Each
invited Amazon Web Services account can choose to accept the invitation from only one
Amazon Web Services account. For more information, see Managing GuardDuty accounts by
invitation. After the invite has been accepted and you choose to disassociate a member
account (by using DisassociateMembers) from your account, the details of the member account
obtained by invoking CreateMembers, including the associated email addresses, will be
retained. This is done so that you can invoke InviteMembers without the need to invoke
CreateMembers again. To remove the details associated with a member account, you must also
invoke DeleteMembers.  If you disassociate a member account that was added by invitation,
the member account details obtained from this API, including the associated email
addresses, will be retained. This is done so that the delegated administrator can invoke
the InviteMembers API without the need to invoke the CreateMembers API again. To remove the
details associated with a member account, the delegated administrator must invoke the
DeleteMembers API.  When the member accounts added through Organizations are later
disassociated, you (administrator) can't invite them by calling the InviteMembers API. You
can create an association with these member accounts again only by calling the
CreateMembers API.

# Arguments
- `account_ids`: A list of account IDs of the accounts that you want to invite to GuardDuty
  as members.
- `detector_id`: The unique ID of the detector of the GuardDuty account that you want to
  invite members with.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"disableEmailNotification"`: A Boolean value that specifies whether you want to disable
  email notification to the accounts that you are inviting to GuardDuty as members.
- `"message"`: The invitation message that you want to send to the accounts that you're
  inviting to GuardDuty as members.
"""
function invite_members(
    accountIds, detectorId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/member/invite",
        Dict{String,Any}("accountIds" => accountIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function invite_members(
    accountIds,
    detectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/member/invite",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("accountIds" => accountIds), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_coverage(detector_id)
    list_coverage(detector_id, params::Dict{String,<:Any})

Lists coverage details for your GuardDuty account. If you're a GuardDuty administrator, you
can retrieve all resources associated with the active member accounts in your organization.
Make sure the accounts have Runtime Monitoring enabled and GuardDuty agent running on their
resources.

# Arguments
- `detector_id`: The unique ID of the detector whose coverage details you want to retrieve.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filterCriteria"`: Represents the criteria used to filter the coverage details.
- `"maxResults"`: The maximum number of results to return in the response.
- `"nextToken"`: A token to use for paginating results that are returned in the response.
  Set the value of this parameter to null for the first request to a list action. For
  subsequent calls, use the NextToken value returned from the previous request to continue
  listing results after the first page.
- `"sortCriteria"`: Represents the criteria used to sort the coverage details.
"""
function list_coverage(detectorId; aws_config::AbstractAWSConfig=current_aws_config())
    return guardduty(
        "POST",
        "/detector/$(detectorId)/coverage";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_coverage(
    detectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/coverage",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_detectors()
    list_detectors(params::Dict{String,<:Any})

Lists detectorIds of all the existing Amazon GuardDuty detector resources.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: You can use this parameter to indicate the maximum number of items that
  you want in the response. The default value is 50. The maximum value is 50.
- `"nextToken"`: You can use this parameter when paginating results. Set the value of this
  parameter to null on your first call to the list action. For subsequent calls to the
  action, fill nextToken in the request with the value of NextToken from the previous
  response to continue listing data.
"""
function list_detectors(; aws_config::AbstractAWSConfig=current_aws_config())
    return guardduty(
        "GET", "/detector"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_detectors(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return guardduty(
        "GET", "/detector", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_filters(detector_id)
    list_filters(detector_id, params::Dict{String,<:Any})

Returns a paginated list of the current filters.

# Arguments
- `detector_id`: The unique ID of the detector that the filter is associated with.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: You can use this parameter to indicate the maximum number of items that
  you want in the response. The default value is 50. The maximum value is 50.
- `"nextToken"`: You can use this parameter when paginating results. Set the value of this
  parameter to null on your first call to the list action. For subsequent calls to the
  action, fill nextToken in the request with the value of NextToken from the previous
  response to continue listing data.
"""
function list_filters(detectorId; aws_config::AbstractAWSConfig=current_aws_config())
    return guardduty(
        "GET",
        "/detector/$(detectorId)/filter";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_filters(
    detectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "GET",
        "/detector/$(detectorId)/filter",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_findings(detector_id)
    list_findings(detector_id, params::Dict{String,<:Any})

Lists GuardDuty findings for the specified detector ID. There might be regional differences
because some flags might not be available in all the Regions where GuardDuty is currently
supported. For more information, see Regions and endpoints.

# Arguments
- `detector_id`: The ID of the detector that specifies the GuardDuty service whose findings
  you want to list.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"findingCriteria"`: Represents the criteria used for querying findings. Valid values
  include:   JSON field name   accountId   region   confidence   id
  resource.accessKeyDetails.accessKeyId   resource.accessKeyDetails.principalId
  resource.accessKeyDetails.userName   resource.accessKeyDetails.userType
  resource.instanceDetails.iamInstanceProfile.id   resource.instanceDetails.imageId
  resource.instanceDetails.instanceId
  resource.instanceDetails.networkInterfaces.ipv6Addresses
  resource.instanceDetails.networkInterfaces.privateIpAddresses.privateIpAddress
  resource.instanceDetails.networkInterfaces.publicDnsName
  resource.instanceDetails.networkInterfaces.publicIp
  resource.instanceDetails.networkInterfaces.securityGroups.groupId
  resource.instanceDetails.networkInterfaces.securityGroups.groupName
  resource.instanceDetails.networkInterfaces.subnetId
  resource.instanceDetails.networkInterfaces.vpcId   resource.instanceDetails.tags.key
  resource.instanceDetails.tags.value   resource.resourceType   service.action.actionType
  service.action.awsApiCallAction.api   service.action.awsApiCallAction.callerType
  service.action.awsApiCallAction.remoteIpDetails.city.cityName
  service.action.awsApiCallAction.remoteIpDetails.country.countryName
  service.action.awsApiCallAction.remoteIpDetails.ipAddressV4
  service.action.awsApiCallAction.remoteIpDetails.organization.asn
  service.action.awsApiCallAction.remoteIpDetails.organization.asnOrg
  service.action.awsApiCallAction.serviceName   service.action.dnsRequestAction.domain
  service.action.dnsRequestAction.domainWithSuffix
  service.action.networkConnectionAction.blocked
  service.action.networkConnectionAction.connectionDirection
  service.action.networkConnectionAction.localPortDetails.port
  service.action.networkConnectionAction.protocol
  service.action.networkConnectionAction.remoteIpDetails.country.countryName
  service.action.networkConnectionAction.remoteIpDetails.ipAddressV4
  service.action.networkConnectionAction.remoteIpDetails.organization.asn
  service.action.networkConnectionAction.remoteIpDetails.organization.asnOrg
  service.action.networkConnectionAction.remotePortDetails.port
  service.additionalInfo.threatListName   service.archived When this attribute is set to
  'true', only archived findings are listed. When it's set to 'false', only unarchived
  findings are listed. When this attribute is not set, all existing findings are listed.
  service.resourceRole   severity   type   updatedAt Type: Timestamp in Unix Epoch
  millisecond format: 1486685375000
- `"maxResults"`: You can use this parameter to indicate the maximum number of items you
  want in the response. The default value is 50. The maximum value is 50.
- `"nextToken"`: You can use this parameter when paginating results. Set the value of this
  parameter to null on your first call to the list action. For subsequent calls to the
  action, fill nextToken in the request with the value of NextToken from the previous
  response to continue listing data.
- `"sortCriteria"`: Represents the criteria used for sorting findings.
"""
function list_findings(detectorId; aws_config::AbstractAWSConfig=current_aws_config())
    return guardduty(
        "POST",
        "/detector/$(detectorId)/findings";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_findings(
    detectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/findings",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_invitations()
    list_invitations(params::Dict{String,<:Any})

Lists all GuardDuty membership invitations that were sent to the current Amazon Web
Services account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: You can use this parameter to indicate the maximum number of items that
  you want in the response. The default value is 50. The maximum value is 50.
- `"nextToken"`: You can use this parameter when paginating results. Set the value of this
  parameter to null on your first call to the list action. For subsequent calls to the
  action, fill nextToken in the request with the value of NextToken from the previous
  response to continue listing data.
"""
function list_invitations(; aws_config::AbstractAWSConfig=current_aws_config())
    return guardduty(
        "GET", "/invitation"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_invitations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return guardduty(
        "GET", "/invitation", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_ipsets(detector_id)
    list_ipsets(detector_id, params::Dict{String,<:Any})

Lists the IPSets of the GuardDuty service specified by the detector ID. If you use this
operation from a member account, the IPSets returned are the IPSets from the associated
administrator account.

# Arguments
- `detector_id`: The unique ID of the detector that the IPSet is associated with.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: You can use this parameter to indicate the maximum number of items you
  want in the response. The default value is 50. The maximum value is 50.
- `"nextToken"`: You can use this parameter when paginating results. Set the value of this
  parameter to null on your first call to the list action. For subsequent calls to the
  action, fill nextToken in the request with the value of NextToken from the previous
  response to continue listing data.
"""
function list_ipsets(detectorId; aws_config::AbstractAWSConfig=current_aws_config())
    return guardduty(
        "GET",
        "/detector/$(detectorId)/ipset";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_ipsets(
    detectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "GET",
        "/detector/$(detectorId)/ipset",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_malware_protection_plans()
    list_malware_protection_plans(params::Dict{String,<:Any})

Lists the Malware Protection plan IDs associated with the protected resources in your
Amazon Web Services account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: You can use this parameter when paginating results. Set the value of this
  parameter to null on your first call to the list action. For subsequent calls to the
  action, fill nextToken in the request with the value of NextToken from the previous
  response to continue listing data.
"""
function list_malware_protection_plans(; aws_config::AbstractAWSConfig=current_aws_config())
    return guardduty(
        "GET",
        "/malware-protection-plan";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_malware_protection_plans(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return guardduty(
        "GET",
        "/malware-protection-plan",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_members(detector_id)
    list_members(detector_id, params::Dict{String,<:Any})

Lists details about all member accounts for the current GuardDuty administrator account.

# Arguments
- `detector_id`: The unique ID of the detector the member is associated with.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: You can use this parameter to indicate the maximum number of items you
  want in the response. The default value is 50. The maximum value is 50.
- `"nextToken"`: You can use this parameter when paginating results. Set the value of this
  parameter to null on your first call to the list action. For subsequent calls to the
  action, fill nextToken in the request with the value of NextToken from the previous
  response to continue listing data.
- `"onlyAssociated"`: Specifies whether to only return associated members or to return all
  members (including members who haven't been invited yet or have been disassociated). Member
  accounts must have been previously associated with the GuardDuty administrator account
  using  Create Members .
"""
function list_members(detectorId; aws_config::AbstractAWSConfig=current_aws_config())
    return guardduty(
        "GET",
        "/detector/$(detectorId)/member";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_members(
    detectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "GET",
        "/detector/$(detectorId)/member",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_organization_admin_accounts()
    list_organization_admin_accounts(params::Dict{String,<:Any})

Lists the accounts designated as GuardDuty delegated administrators. Only the
organization's management account can run this API operation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in the response.
- `"nextToken"`: A token to use for paginating results that are returned in the response.
  Set the value of this parameter to null for the first request to a list action. For
  subsequent calls, use the NextToken value returned from the previous request to continue
  listing results after the first page.
"""
function list_organization_admin_accounts(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return guardduty(
        "GET", "/admin"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_organization_admin_accounts(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return guardduty(
        "GET", "/admin", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_publishing_destinations(detector_id)
    list_publishing_destinations(detector_id, params::Dict{String,<:Any})

Returns a list of publishing destinations associated with the specified detectorId.

# Arguments
- `detector_id`: The ID of the detector to retrieve publishing destinations for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in the response.
- `"nextToken"`: A token to use for paginating results that are returned in the response.
  Set the value of this parameter to null for the first request to a list action. For
  subsequent calls, use the NextToken value returned from the previous request to continue
  listing results after the first page.
"""
function list_publishing_destinations(
    detectorId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return guardduty(
        "GET",
        "/detector/$(detectorId)/publishingDestination";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_publishing_destinations(
    detectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "GET",
        "/detector/$(detectorId)/publishingDestination",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists tags for a resource. Tagging is currently supported for detectors, finding filters,
IP sets, threat intel sets, and publishing destination, with a limit of 50 tags per
resource. When invoked, this operation returns all assigned tags for a given resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) for the given GuardDuty resource.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return guardduty(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_threat_intel_sets(detector_id)
    list_threat_intel_sets(detector_id, params::Dict{String,<:Any})

Lists the ThreatIntelSets of the GuardDuty service specified by the detector ID. If you use
this operation from a member account, the ThreatIntelSets associated with the administrator
account are returned.

# Arguments
- `detector_id`: The unique ID of the detector that the threatIntelSet is associated with.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: You can use this parameter to indicate the maximum number of items that
  you want in the response. The default value is 50. The maximum value is 50.
- `"nextToken"`: You can use this parameter to paginate results in the response. Set the
  value of this parameter to null on your first call to the list action. For subsequent calls
  to the action, fill nextToken in the request with the value of NextToken from the previous
  response to continue listing data.
"""
function list_threat_intel_sets(
    detectorId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return guardduty(
        "GET",
        "/detector/$(detectorId)/threatintelset";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_threat_intel_sets(
    detectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "GET",
        "/detector/$(detectorId)/threatintelset",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_malware_scan(resource_arn)
    start_malware_scan(resource_arn, params::Dict{String,<:Any})

Initiates the malware scan. Invoking this API will automatically create the Service-linked
role in the corresponding account. When the malware scan starts, you can use the associated
scan ID to track the status of the scan. For more information, see DescribeMalwareScans.

# Arguments
- `resource_arn`: Amazon Resource Name (ARN) of the resource for which you invoked the API.

"""
function start_malware_scan(resourceArn; aws_config::AbstractAWSConfig=current_aws_config())
    return guardduty(
        "POST",
        "/malware-scan/start",
        Dict{String,Any}("resourceArn" => resourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_malware_scan(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "POST",
        "/malware-scan/start",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceArn" => resourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_monitoring_members(account_ids, detector_id)
    start_monitoring_members(account_ids, detector_id, params::Dict{String,<:Any})

Turns on GuardDuty monitoring of the specified member accounts. Use this operation to
restart monitoring of accounts that you stopped monitoring with the StopMonitoringMembers
operation.

# Arguments
- `account_ids`: A list of account IDs of the GuardDuty member accounts to start monitoring.
- `detector_id`: The unique ID of the detector of the GuardDuty administrator account
  associated with the member accounts to monitor.

"""
function start_monitoring_members(
    accountIds, detectorId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/member/start",
        Dict{String,Any}("accountIds" => accountIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_monitoring_members(
    accountIds,
    detectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/member/start",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("accountIds" => accountIds), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_monitoring_members(account_ids, detector_id)
    stop_monitoring_members(account_ids, detector_id, params::Dict{String,<:Any})

Stops GuardDuty monitoring for the specified member accounts. Use the
StartMonitoringMembers operation to restart monitoring for those accounts. With
autoEnableOrganizationMembers configuration for your organization set to ALL, you'll
receive an error if you attempt to stop monitoring the member accounts in your organization.

# Arguments
- `account_ids`: A list of account IDs for the member accounts to stop monitoring.
- `detector_id`: The unique ID of the detector associated with the GuardDuty administrator
  account that is monitoring member accounts.

"""
function stop_monitoring_members(
    accountIds, detectorId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/member/stop",
        Dict{String,Any}("accountIds" => accountIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_monitoring_members(
    accountIds,
    detectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/member/stop",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("accountIds" => accountIds), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds tags to a resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) for the GuardDuty resource to apply a tag
  to.
- `tags`: The tags to be added to a resource.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return guardduty(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    unarchive_findings(detector_id, finding_ids)
    unarchive_findings(detector_id, finding_ids, params::Dict{String,<:Any})

Unarchives GuardDuty findings specified by the findingIds.

# Arguments
- `detector_id`: The ID of the detector associated with the findings to unarchive.
- `finding_ids`: The IDs of the findings to unarchive.

"""
function unarchive_findings(
    detectorId, findingIds; aws_config::AbstractAWSConfig=current_aws_config()
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/findings/unarchive",
        Dict{String,Any}("findingIds" => findingIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function unarchive_findings(
    detectorId,
    findingIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/findings/unarchive",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("findingIds" => findingIds), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes tags from a resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) for the resource to remove tags from.
- `tag_keys`: The tag keys to remove from the resource.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return guardduty(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_detector(detector_id)
    update_detector(detector_id, params::Dict{String,<:Any})

Updates the GuardDuty detector specified by the detector ID. Specifying both EKS Runtime
Monitoring (EKS_RUNTIME_MONITORING) and Runtime Monitoring (RUNTIME_MONITORING) will cause
an error. You can add only one of these two features because Runtime Monitoring already
includes the threat detection for Amazon EKS resources. For more information, see Runtime
Monitoring. There might be regional differences because some data sources might not be
available in all the Amazon Web Services Regions where GuardDuty is presently supported.
For more information, see Regions and endpoints.

# Arguments
- `detector_id`: The unique ID of the detector to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"dataSources"`: Describes which data sources will be updated. There might be regional
  differences because some data sources might not be available in all the Amazon Web Services
  Regions where GuardDuty is presently supported. For more information, see Regions and
  endpoints.
- `"enable"`: Specifies whether the detector is enabled or not enabled.
- `"features"`: Provides the features that will be updated for the detector.
- `"findingPublishingFrequency"`: An enum value that specifies how frequently findings are
  exported, such as to CloudWatch Events.
"""
function update_detector(detectorId; aws_config::AbstractAWSConfig=current_aws_config())
    return guardduty(
        "POST",
        "/detector/$(detectorId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_detector(
    detectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_filter(detector_id, filter_name)
    update_filter(detector_id, filter_name, params::Dict{String,<:Any})

Updates the filter specified by the filter name.

# Arguments
- `detector_id`: The unique ID of the detector that specifies the GuardDuty service where
  you want to update a filter.
- `filter_name`: The name of the filter.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"action"`: Specifies the action that is to be applied to the findings that match the
  filter.
- `"description"`: The description of the filter. Valid characters include alphanumeric
  characters, and special characters such as hyphen, period, colon, underscore, parentheses
  ({ }, [ ], and ( )), forward slash, horizontal tab, vertical tab, newline, form feed,
  return, and whitespace.
- `"findingCriteria"`: Represents the criteria to be used in the filter for querying
  findings.
- `"rank"`: Specifies the position of the filter in the list of current filters. Also
  specifies the order in which this filter is applied to the findings.
"""
function update_filter(
    detectorId, filterName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/filter/$(filterName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_filter(
    detectorId,
    filterName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/filter/$(filterName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_findings_feedback(detector_id, feedback, finding_ids)
    update_findings_feedback(detector_id, feedback, finding_ids, params::Dict{String,<:Any})

Marks the specified GuardDuty findings as useful or not useful.

# Arguments
- `detector_id`: The ID of the detector associated with the findings to update feedback for.
- `feedback`: The feedback for the finding.
- `finding_ids`: The IDs of the findings that you want to mark as useful or not useful.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"comments"`: Additional feedback about the GuardDuty findings.
"""
function update_findings_feedback(
    detectorId, feedback, findingIds; aws_config::AbstractAWSConfig=current_aws_config()
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/findings/feedback",
        Dict{String,Any}("feedback" => feedback, "findingIds" => findingIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_findings_feedback(
    detectorId,
    feedback,
    findingIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/findings/feedback",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("feedback" => feedback, "findingIds" => findingIds),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_ipset(detector_id, ip_set_id)
    update_ipset(detector_id, ip_set_id, params::Dict{String,<:Any})

Updates the IPSet specified by the IPSet ID.

# Arguments
- `detector_id`: The detectorID that specifies the GuardDuty service whose IPSet you want
  to update.
- `ip_set_id`: The unique ID that specifies the IPSet that you want to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"activate"`: The updated Boolean value that specifies whether the IPSet is active or not.
- `"location"`: The updated URI of the file that contains the IPSet.
- `"name"`: The unique ID that specifies the IPSet that you want to update.
"""
function update_ipset(
    detectorId, ipSetId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/ipset/$(ipSetId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_ipset(
    detectorId,
    ipSetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/ipset/$(ipSetId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_malware_protection_plan(malware_protection_plan_id)
    update_malware_protection_plan(malware_protection_plan_id, params::Dict{String,<:Any})

Updates an existing Malware Protection plan resource.

# Arguments
- `malware_protection_plan_id`: A unique identifier associated with the Malware Protection
  plan.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"actions"`: Information about whether the tags will be added to the S3 object after
  scanning.
- `"protectedResource"`: Information about the protected resource that is associated with
  the created Malware Protection plan. Presently, S3Bucket is the only supported protected
  resource.
- `"role"`: IAM role with permissions required to scan and add tags to the associated
  protected resource.
"""
function update_malware_protection_plan(
    malwareProtectionPlanId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return guardduty(
        "PATCH",
        "/malware-protection-plan/$(malwareProtectionPlanId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_malware_protection_plan(
    malwareProtectionPlanId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "PATCH",
        "/malware-protection-plan/$(malwareProtectionPlanId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_malware_scan_settings(detector_id)
    update_malware_scan_settings(detector_id, params::Dict{String,<:Any})

Updates the malware scan settings. There might be regional differences because some data
sources might not be available in all the Amazon Web Services Regions where GuardDuty is
presently supported. For more information, see Regions and endpoints.

# Arguments
- `detector_id`: The unique ID of the detector that specifies the GuardDuty service where
  you want to update scan settings.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ebsSnapshotPreservation"`: An enum value representing possible snapshot preservation
  settings.
- `"scanResourceCriteria"`: Represents the criteria to be used in the filter for selecting
  resources to scan.
"""
function update_malware_scan_settings(
    detectorId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/malware-scan-settings";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_malware_scan_settings(
    detectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/malware-scan-settings",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_member_detectors(account_ids, detector_id)
    update_member_detectors(account_ids, detector_id, params::Dict{String,<:Any})

Contains information on member accounts to be updated. Specifying both EKS Runtime
Monitoring (EKS_RUNTIME_MONITORING) and Runtime Monitoring (RUNTIME_MONITORING) will cause
an error. You can add only one of these two features because Runtime Monitoring already
includes the threat detection for Amazon EKS resources. For more information, see Runtime
Monitoring. There might be regional differences because some data sources might not be
available in all the Amazon Web Services Regions where GuardDuty is presently supported.
For more information, see Regions and endpoints.

# Arguments
- `account_ids`: A list of member account IDs to be updated.
- `detector_id`: The detector ID of the administrator account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"dataSources"`: Describes which data sources will be updated.
- `"features"`: A list of features that will be updated for the specified member accounts.
"""
function update_member_detectors(
    accountIds, detectorId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/member/detector/update",
        Dict{String,Any}("accountIds" => accountIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_member_detectors(
    accountIds,
    detectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/member/detector/update",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("accountIds" => accountIds), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_organization_configuration(detector_id)
    update_organization_configuration(detector_id, params::Dict{String,<:Any})

Configures the delegated administrator account with the provided values. You must provide a
value for either autoEnableOrganizationMembers or autoEnable, but not both.  Specifying
both EKS Runtime Monitoring (EKS_RUNTIME_MONITORING) and Runtime Monitoring
(RUNTIME_MONITORING) will cause an error. You can add only one of these two features
because Runtime Monitoring already includes the threat detection for Amazon EKS resources.
For more information, see Runtime Monitoring. There might be regional differences because
some data sources might not be available in all the Amazon Web Services Regions where
GuardDuty is presently supported. For more information, see Regions and endpoints.

# Arguments
- `detector_id`: The ID of the detector that configures the delegated administrator.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"autoEnable"`: Represents whether or not to automatically enable member accounts in the
  organization. Even though this is still supported, we recommend using
  AutoEnableOrganizationMembers to achieve the similar results. You must provide a value for
  either autoEnableOrganizationMembers or autoEnable.
- `"autoEnableOrganizationMembers"`: Indicates the auto-enablement configuration of
  GuardDuty for the member accounts in the organization. You must provide a value for either
  autoEnableOrganizationMembers or autoEnable.  Use one of the following configuration values
  for autoEnableOrganizationMembers:    NEW: Indicates that when a new account joins the
  organization, they will have GuardDuty enabled automatically.     ALL: Indicates that all
  accounts in the organization have GuardDuty enabled automatically. This includes NEW
  accounts that join the organization and accounts that may have been suspended or removed
  from the organization in GuardDuty. It may take up to 24 hours to update the configuration
  for all the member accounts.    NONE: Indicates that GuardDuty will not be automatically
  enabled for any account in the organization. The administrator must manage GuardDuty for
  each account in the organization individually. When you update the auto-enable setting from
  ALL or NEW to NONE, this action doesn't disable the corresponding option for your existing
  accounts. This configuration will apply to the new accounts that join the organization.
  After you update the auto-enable settings, no new account will have the corresponding
  option as enabled.
- `"dataSources"`: Describes which data sources will be updated.
- `"features"`: A list of features that will be configured for the organization.
"""
function update_organization_configuration(
    detectorId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/admin";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_organization_configuration(
    detectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/admin",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_publishing_destination(destination_id, detector_id)
    update_publishing_destination(destination_id, detector_id, params::Dict{String,<:Any})

Updates information about the publishing destination specified by the destinationId.

# Arguments
- `destination_id`: The ID of the publishing destination to update.
- `detector_id`: The ID of the detector associated with the publishing destinations to
  update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"destinationProperties"`: A DestinationProperties object that includes the
  DestinationArn and KmsKeyArn of the publishing destination.
"""
function update_publishing_destination(
    destinationId, detectorId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/publishingDestination/$(destinationId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_publishing_destination(
    destinationId,
    detectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/publishingDestination/$(destinationId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_threat_intel_set(detector_id, threat_intel_set_id)
    update_threat_intel_set(detector_id, threat_intel_set_id, params::Dict{String,<:Any})

Updates the ThreatIntelSet specified by the ThreatIntelSet ID.

# Arguments
- `detector_id`: The detectorID that specifies the GuardDuty service whose ThreatIntelSet
  you want to update.
- `threat_intel_set_id`: The unique ID that specifies the ThreatIntelSet that you want to
  update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"activate"`: The updated Boolean value that specifies whether the ThreateIntelSet is
  active or not.
- `"location"`: The updated URI of the file that contains the ThreateIntelSet.
- `"name"`: The unique ID that specifies the ThreatIntelSet that you want to update.
"""
function update_threat_intel_set(
    detectorId, threatIntelSetId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/threatintelset/$(threatIntelSetId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_threat_intel_set(
    detectorId,
    threatIntelSetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return guardduty(
        "POST",
        "/detector/$(detectorId)/threatintelset/$(threatIntelSetId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: mediaconvert
using AWS.Compat
using AWS.UUIDs

"""
    associate_certificate(arn)
    associate_certificate(arn, params::Dict{String,<:Any})

Associates an AWS Certificate Manager (ACM) Amazon Resource Name (ARN) with AWS Elemental
MediaConvert.

# Arguments
- `arn`: The ARN of the ACM certificate that you want to associate with your MediaConvert
  resource.

"""
function associate_certificate(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return mediaconvert(
        "POST",
        "/2017-08-29/certificates",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_certificate(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconvert(
        "POST",
        "/2017-08-29/certificates",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_job(id)
    cancel_job(id, params::Dict{String,<:Any})

Permanently cancel a job. Once you have canceled a job, you can't start it again.

# Arguments
- `id`: The Job ID of the job to be cancelled.

"""
function cancel_job(id; aws_config::AbstractAWSConfig=current_aws_config())
    return mediaconvert(
        "DELETE",
        "/2017-08-29/jobs/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_job(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconvert(
        "DELETE",
        "/2017-08-29/jobs/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_job(role, settings)
    create_job(role, settings, params::Dict{String,<:Any})

Create a new transcoding job. For information about jobs and job settings, see the User
Guide at http://docs.aws.amazon.com/mediaconvert/latest/ug/what-is.html

# Arguments
- `role`: Required. The IAM role you use for creating this job. For details about
  permissions, see the User Guide topic at the User Guide at
  https://docs.aws.amazon.com/mediaconvert/latest/ug/iam-role.html.
- `settings`: JobSettings contains all the transcode settings for a job.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accelerationSettings"`: Optional. Accelerated transcoding can significantly speed up
  jobs with long, visually complex content. Outputs that use this feature incur pro-tier
  pricing. For information about feature limitations, see the AWS Elemental MediaConvert User
  Guide.
- `"billingTagsSource"`: Optional. Choose a tag type that AWS Billing and Cost Management
  will use to sort your AWS Elemental MediaConvert costs on any billing report that you set
  up. Any transcoding outputs that don't have an associated tag will appear in your billing
  report unsorted. If you don't choose a valid value for this field, your job outputs will
  appear on the billing report unsorted.
- `"clientRequestToken"`: Prevent duplicate jobs from being created and ensure idempotency
  for your requests. A client request token can be any string that includes up to 64 ASCII
  characters. If you reuse a client request token within one minute of a successful request,
  the API returns the job details of the original request instead. For more information see
  https://docs.aws.amazon.com/mediaconvert/latest/apireference/idempotency.html.
- `"hopDestinations"`: Optional. Use queue hopping to avoid overly long waits in the
  backlog of the queue that you submit your job to. Specify an alternate queue and the
  maximum time that your job will wait in the initial queue before hopping. For more
  information about this feature, see the AWS Elemental MediaConvert User Guide.
- `"jobTemplate"`: Optional. When you create a job, you can either specify a job template
  or specify the transcoding settings individually.
- `"priority"`: Optional. Specify the relative priority for this job. In any given queue,
  the service begins processing the job with the highest value first. When more than one job
  has the same priority, the service begins processing the job that you submitted first. If
  you don't specify a priority, the service uses the default value 0.
- `"queue"`: Optional. When you create a job, you can specify a queue to send it to. If you
  don't specify, the job will go to the default queue. For more about queues, see the User
  Guide topic at https://docs.aws.amazon.com/mediaconvert/latest/ug/what-is.html.
- `"simulateReservedQueue"`: Optional. Enable this setting when you run a test job to
  estimate how many reserved transcoding slots (RTS) you need. When this is enabled,
  MediaConvert runs your job from an on-demand queue with similar performance to what you
  will see with one RTS in a reserved queue. This setting is disabled by default.
- `"statusUpdateInterval"`: Optional. Specify how often MediaConvert sends STATUS_UPDATE
  events to Amazon CloudWatch Events. Set the interval, in seconds, between status updates.
  MediaConvert sends an update at this interval from the time the service begins processing
  your job to the time it completes the transcode or encounters an error.
- `"tags"`: Optional. The tags that you want to add to the resource. You can tag resources
  with a key-value pair or with only a key.  Use standard AWS tags on your job for automatic
  integration with AWS services and for custom integrations and workflows.
- `"userMetadata"`: Optional. User-defined metadata that you want to associate with an
  MediaConvert job. You specify metadata in key/value pairs.  Use only for existing
  integrations or workflows that rely on job metadata tags. Otherwise, we recommend that you
  use standard AWS tags.
"""
function create_job(role, settings; aws_config::AbstractAWSConfig=current_aws_config())
    return mediaconvert(
        "POST",
        "/2017-08-29/jobs",
        Dict{String,Any}(
            "role" => role, "settings" => settings, "clientRequestToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_job(
    role,
    settings,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediaconvert(
        "POST",
        "/2017-08-29/jobs",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "role" => role,
                    "settings" => settings,
                    "clientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_job_template(name, settings)
    create_job_template(name, settings, params::Dict{String,<:Any})

Create a new job template. For information about job templates see the User Guide at
http://docs.aws.amazon.com/mediaconvert/latest/ug/what-is.html

# Arguments
- `name`: The name of the job template you are creating.
- `settings`: JobTemplateSettings contains all the transcode settings saved in the template
  that will be applied to jobs created from it.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accelerationSettings"`: Accelerated transcoding can significantly speed up jobs with
  long, visually complex content. Outputs that use this feature incur pro-tier pricing. For
  information about feature limitations, see the AWS Elemental MediaConvert User Guide.
- `"category"`: Optional. A category for the job template you are creating
- `"description"`: Optional. A description of the job template you are creating.
- `"hopDestinations"`: Optional. Use queue hopping to avoid overly long waits in the
  backlog of the queue that you submit your job to. Specify an alternate queue and the
  maximum time that your job will wait in the initial queue before hopping. For more
  information about this feature, see the AWS Elemental MediaConvert User Guide.
- `"priority"`: Specify the relative priority for this job. In any given queue, the service
  begins processing the job with the highest value first. When more than one job has the same
  priority, the service begins processing the job that you submitted first. If you don't
  specify a priority, the service uses the default value 0.
- `"queue"`: Optional. The queue that jobs created from this template are assigned to. If
  you don't specify this, jobs will go to the default queue.
- `"statusUpdateInterval"`: Specify how often MediaConvert sends STATUS_UPDATE events to
  Amazon CloudWatch Events. Set the interval, in seconds, between status updates.
  MediaConvert sends an update at this interval from the time the service begins processing
  your job to the time it completes the transcode or encounters an error.
- `"tags"`: The tags that you want to add to the resource. You can tag resources with a
  key-value pair or with only a key.
"""
function create_job_template(
    name, settings; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconvert(
        "POST",
        "/2017-08-29/jobTemplates",
        Dict{String,Any}("name" => name, "settings" => settings);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_job_template(
    name,
    settings,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediaconvert(
        "POST",
        "/2017-08-29/jobTemplates",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("name" => name, "settings" => settings), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_preset(name, settings)
    create_preset(name, settings, params::Dict{String,<:Any})

Create a new preset. For information about job templates see the User Guide at
http://docs.aws.amazon.com/mediaconvert/latest/ug/what-is.html

# Arguments
- `name`: The name of the preset you are creating.
- `settings`: Settings for preset

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"category"`: Optional. A category for the preset you are creating.
- `"description"`: Optional. A description of the preset you are creating.
- `"tags"`: The tags that you want to add to the resource. You can tag resources with a
  key-value pair or with only a key.
"""
function create_preset(name, settings; aws_config::AbstractAWSConfig=current_aws_config())
    return mediaconvert(
        "POST",
        "/2017-08-29/presets",
        Dict{String,Any}("name" => name, "settings" => settings);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_preset(
    name,
    settings,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediaconvert(
        "POST",
        "/2017-08-29/presets",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("name" => name, "settings" => settings), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_queue(name)
    create_queue(name, params::Dict{String,<:Any})

Create a new transcoding queue. For information about queues, see Working With Queues in
the User Guide at
https://docs.aws.amazon.com/mediaconvert/latest/ug/working-with-queues.html

# Arguments
- `name`: The name of the queue that you are creating.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: Optional. A description of the queue that you are creating.
- `"pricingPlan"`: Specifies whether the pricing plan for the queue is on-demand or
  reserved. For on-demand, you pay per minute, billed in increments of .01 minute. For
  reserved, you pay for the transcoding capacity of the entire queue, regardless of how much
  or how little you use it. Reserved pricing requires a 12-month commitment. When you use the
  API to create a queue, the default is on-demand.
- `"reservationPlanSettings"`: Details about the pricing plan for your reserved queue.
  Required for reserved queues and not applicable to on-demand queues.
- `"status"`: Initial state of the queue. If you create a paused queue, then jobs in that
  queue won't begin.
- `"tags"`: The tags that you want to add to the resource. You can tag resources with a
  key-value pair or with only a key.
"""
function create_queue(name; aws_config::AbstractAWSConfig=current_aws_config())
    return mediaconvert(
        "POST",
        "/2017-08-29/queues",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_queue(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconvert(
        "POST",
        "/2017-08-29/queues",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_job_template(name)
    delete_job_template(name, params::Dict{String,<:Any})

Permanently delete a job template you have created.

# Arguments
- `name`: The name of the job template to be deleted.

"""
function delete_job_template(name; aws_config::AbstractAWSConfig=current_aws_config())
    return mediaconvert(
        "DELETE",
        "/2017-08-29/jobTemplates/$(name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_job_template(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconvert(
        "DELETE",
        "/2017-08-29/jobTemplates/$(name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_policy()
    delete_policy(params::Dict{String,<:Any})

Permanently delete a policy that you created.

"""
function delete_policy(; aws_config::AbstractAWSConfig=current_aws_config())
    return mediaconvert(
        "DELETE",
        "/2017-08-29/policy";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_policy(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconvert(
        "DELETE",
        "/2017-08-29/policy",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_preset(name)
    delete_preset(name, params::Dict{String,<:Any})

Permanently delete a preset you have created.

# Arguments
- `name`: The name of the preset to be deleted.

"""
function delete_preset(name; aws_config::AbstractAWSConfig=current_aws_config())
    return mediaconvert(
        "DELETE",
        "/2017-08-29/presets/$(name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_preset(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconvert(
        "DELETE",
        "/2017-08-29/presets/$(name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_queue(name)
    delete_queue(name, params::Dict{String,<:Any})

Permanently delete a queue you have created.

# Arguments
- `name`: The name of the queue that you want to delete.

"""
function delete_queue(name; aws_config::AbstractAWSConfig=current_aws_config())
    return mediaconvert(
        "DELETE",
        "/2017-08-29/queues/$(name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_queue(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconvert(
        "DELETE",
        "/2017-08-29/queues/$(name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_endpoints()
    describe_endpoints(params::Dict{String,<:Any})

Send a request with an empty body to the regional API endpoint to get your account API
endpoint. Note that DescribeEndpoints is no longer required. We recommend that you send
your requests directly to the regional endpoint instead.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Optional. Max number of endpoints, up to twenty, that will be returned at
  one time.
- `"mode"`: Optional field, defaults to DEFAULT. Specify DEFAULT for this operation to
  return your endpoints if any exist, or to create an endpoint for you and return it if one
  doesn't already exist. Specify GET_ONLY to return your endpoints if any exist, or an empty
  list if none exist.
- `"nextToken"`: Use this string, provided with the response to a previous request, to
  request the next batch of endpoints.
"""
function describe_endpoints(; aws_config::AbstractAWSConfig=current_aws_config())
    return mediaconvert(
        "POST",
        "/2017-08-29/endpoints";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_endpoints(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconvert(
        "POST",
        "/2017-08-29/endpoints",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_certificate(arn)
    disassociate_certificate(arn, params::Dict{String,<:Any})

Removes an association between the Amazon Resource Name (ARN) of an AWS Certificate Manager
(ACM) certificate and an AWS Elemental MediaConvert resource.

# Arguments
- `arn`: The ARN of the ACM certificate that you want to disassociate from your
  MediaConvert resource.

"""
function disassociate_certificate(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return mediaconvert(
        "DELETE",
        "/2017-08-29/certificates/$(arn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_certificate(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconvert(
        "DELETE",
        "/2017-08-29/certificates/$(arn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_job(id)
    get_job(id, params::Dict{String,<:Any})

Retrieve the JSON for a specific transcoding job.

# Arguments
- `id`: the job ID of the job.

"""
function get_job(id; aws_config::AbstractAWSConfig=current_aws_config())
    return mediaconvert(
        "GET",
        "/2017-08-29/jobs/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_job(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconvert(
        "GET",
        "/2017-08-29/jobs/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_job_template(name)
    get_job_template(name, params::Dict{String,<:Any})

Retrieve the JSON for a specific job template.

# Arguments
- `name`: The name of the job template.

"""
function get_job_template(name; aws_config::AbstractAWSConfig=current_aws_config())
    return mediaconvert(
        "GET",
        "/2017-08-29/jobTemplates/$(name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_job_template(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconvert(
        "GET",
        "/2017-08-29/jobTemplates/$(name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_policy()
    get_policy(params::Dict{String,<:Any})

Retrieve the JSON for your policy.

"""
function get_policy(; aws_config::AbstractAWSConfig=current_aws_config())
    return mediaconvert(
        "GET", "/2017-08-29/policy"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_policy(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconvert(
        "GET",
        "/2017-08-29/policy",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_preset(name)
    get_preset(name, params::Dict{String,<:Any})

Retrieve the JSON for a specific preset.

# Arguments
- `name`: The name of the preset.

"""
function get_preset(name; aws_config::AbstractAWSConfig=current_aws_config())
    return mediaconvert(
        "GET",
        "/2017-08-29/presets/$(name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_preset(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconvert(
        "GET",
        "/2017-08-29/presets/$(name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_queue(name)
    get_queue(name, params::Dict{String,<:Any})

Retrieve the JSON for a specific queue.

# Arguments
- `name`: The name of the queue that you want information about.

"""
function get_queue(name; aws_config::AbstractAWSConfig=current_aws_config())
    return mediaconvert(
        "GET",
        "/2017-08-29/queues/$(name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_queue(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconvert(
        "GET",
        "/2017-08-29/queues/$(name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_job_templates()
    list_job_templates(params::Dict{String,<:Any})

Retrieve a JSON array of up to twenty of your job templates. This will return the templates
themselves, not just a list of them. To retrieve the next twenty templates, use the
nextToken string returned with the array

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"category"`: Optionally, specify a job template category to limit responses to only job
  templates from that category.
- `"listBy"`: Optional. When you request a list of job templates, you can choose to list
  them alphabetically by NAME or chronologically by CREATION_DATE. If you don't specify, the
  service will list them by name.
- `"maxResults"`: Optional. Number of job templates, up to twenty, that will be returned at
  one time.
- `"nextToken"`: Use this string, provided with the response to a previous request, to
  request the next batch of job templates.
- `"order"`: Optional. When you request lists of resources, you can specify whether they
  are sorted in ASCENDING or DESCENDING order. Default varies by resource.
"""
function list_job_templates(; aws_config::AbstractAWSConfig=current_aws_config())
    return mediaconvert(
        "GET",
        "/2017-08-29/jobTemplates";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_job_templates(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconvert(
        "GET",
        "/2017-08-29/jobTemplates",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_jobs()
    list_jobs(params::Dict{String,<:Any})

Retrieve a JSON array of up to twenty of your most recently created jobs. This array
includes in-process, completed, and errored jobs. This will return the jobs themselves, not
just a list of the jobs. To retrieve the twenty next most recent jobs, use the nextToken
string returned with the array.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Optional. Number of jobs, up to twenty, that will be returned at one time.
- `"nextToken"`: Optional. Use this string, provided with the response to a previous
  request, to request the next batch of jobs.
- `"order"`: Optional. When you request lists of resources, you can specify whether they
  are sorted in ASCENDING or DESCENDING order. Default varies by resource.
- `"queue"`: Optional. Provide a queue name to get back only jobs from that queue.
- `"status"`: Optional. A job's status can be SUBMITTED, PROGRESSING, COMPLETE, CANCELED,
  or ERROR.
"""
function list_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return mediaconvert(
        "GET", "/2017-08-29/jobs"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconvert(
        "GET",
        "/2017-08-29/jobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_presets()
    list_presets(params::Dict{String,<:Any})

Retrieve a JSON array of up to twenty of your presets. This will return the presets
themselves, not just a list of them. To retrieve the next twenty presets, use the nextToken
string returned with the array.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"category"`: Optionally, specify a preset category to limit responses to only presets
  from that category.
- `"listBy"`: Optional. When you request a list of presets, you can choose to list them
  alphabetically by NAME or chronologically by CREATION_DATE. If you don't specify, the
  service will list them by name.
- `"maxResults"`: Optional. Number of presets, up to twenty, that will be returned at one
  time
- `"nextToken"`: Use this string, provided with the response to a previous request, to
  request the next batch of presets.
- `"order"`: Optional. When you request lists of resources, you can specify whether they
  are sorted in ASCENDING or DESCENDING order. Default varies by resource.
"""
function list_presets(; aws_config::AbstractAWSConfig=current_aws_config())
    return mediaconvert(
        "GET", "/2017-08-29/presets"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_presets(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconvert(
        "GET",
        "/2017-08-29/presets",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_queues()
    list_queues(params::Dict{String,<:Any})

Retrieve a JSON array of up to twenty of your queues. This will return the queues
themselves, not just a list of them. To retrieve the next twenty queues, use the nextToken
string returned with the array.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"listBy"`: Optional. When you request a list of queues, you can choose to list them
  alphabetically by NAME or chronologically by CREATION_DATE. If you don't specify, the
  service will list them by creation date.
- `"maxResults"`: Optional. Number of queues, up to twenty, that will be returned at one
  time.
- `"nextToken"`: Use this string, provided with the response to a previous request, to
  request the next batch of queues.
- `"order"`: Optional. When you request lists of resources, you can specify whether they
  are sorted in ASCENDING or DESCENDING order. Default varies by resource.
"""
function list_queues(; aws_config::AbstractAWSConfig=current_aws_config())
    return mediaconvert(
        "GET", "/2017-08-29/queues"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_queues(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconvert(
        "GET",
        "/2017-08-29/queues",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(arn)
    list_tags_for_resource(arn, params::Dict{String,<:Any})

Retrieve the tags for a MediaConvert resource.

# Arguments
- `arn`: The Amazon Resource Name (ARN) of the resource that you want to list tags for. To
  get the ARN, send a GET request with the resource name.

"""
function list_tags_for_resource(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return mediaconvert(
        "GET",
        "/2017-08-29/tags/$(arn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconvert(
        "GET",
        "/2017-08-29/tags/$(arn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_policy(policy)
    put_policy(policy, params::Dict{String,<:Any})

Create or change your policy. For more information about policies, see the user guide at
http://docs.aws.amazon.com/mediaconvert/latest/ug/what-is.html

# Arguments
- `policy`: A policy configures behavior that you allow or disallow for your account. For
  information about MediaConvert policies, see the user guide at
  http://docs.aws.amazon.com/mediaconvert/latest/ug/what-is.html

"""
function put_policy(policy; aws_config::AbstractAWSConfig=current_aws_config())
    return mediaconvert(
        "PUT",
        "/2017-08-29/policy",
        Dict{String,Any}("policy" => policy);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_policy(
    policy, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconvert(
        "PUT",
        "/2017-08-29/policy",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("policy" => policy), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    search_jobs()
    search_jobs(params::Dict{String,<:Any})

Retrieve a JSON array that includes job details for up to twenty of your most recent jobs.
Optionally filter results further according to input file, queue, or status. To retrieve
the twenty next most recent jobs, use the nextToken string returned with the array.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"inputFile"`: Optional. Provide your input file URL or your partial input file name. The
  maximum length for an input file is 300 characters.
- `"maxResults"`: Optional. Number of jobs, up to twenty, that will be returned at one time.
- `"nextToken"`: Optional. Use this string, provided with the response to a previous
  request, to request the next batch of jobs.
- `"order"`: Optional. When you request lists of resources, you can specify whether they
  are sorted in ASCENDING or DESCENDING order. Default varies by resource.
- `"queue"`: Optional. Provide a queue name, or a queue ARN, to return only jobs from that
  queue.
- `"status"`: Optional. A job's status can be SUBMITTED, PROGRESSING, COMPLETE, CANCELED,
  or ERROR.
"""
function search_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return mediaconvert(
        "GET", "/2017-08-29/search"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function search_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconvert(
        "GET",
        "/2017-08-29/search",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(arn, tags)
    tag_resource(arn, tags, params::Dict{String,<:Any})

Add tags to a MediaConvert queue, preset, or job template. For information about tagging,
see the User Guide at
https://docs.aws.amazon.com/mediaconvert/latest/ug/tagging-resources.html

# Arguments
- `arn`: The Amazon Resource Name (ARN) of the resource that you want to tag. To get the
  ARN, send a GET request with the resource name.
- `tags`: The tags that you want to add to the resource. You can tag resources with a
  key-value pair or with only a key.

"""
function tag_resource(arn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return mediaconvert(
        "POST",
        "/2017-08-29/tags",
        Dict{String,Any}("arn" => arn, "tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    arn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediaconvert(
        "POST",
        "/2017-08-29/tags",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("arn" => arn, "tags" => tags), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(arn)
    untag_resource(arn, params::Dict{String,<:Any})

Remove tags from a MediaConvert queue, preset, or job template. For information about
tagging, see the User Guide at
https://docs.aws.amazon.com/mediaconvert/latest/ug/tagging-resources.html

# Arguments
- `arn`: The Amazon Resource Name (ARN) of the resource that you want to remove tags from.
  To get the ARN, send a GET request with the resource name.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tagKeys"`: The keys of the tags that you want to remove from the resource.
"""
function untag_resource(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return mediaconvert(
        "PUT",
        "/2017-08-29/tags/$(arn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconvert(
        "PUT",
        "/2017-08-29/tags/$(arn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_job_template(name)
    update_job_template(name, params::Dict{String,<:Any})

Modify one of your existing job templates.

# Arguments
- `name`: The name of the job template you are modifying

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accelerationSettings"`: Accelerated transcoding can significantly speed up jobs with
  long, visually complex content. Outputs that use this feature incur pro-tier pricing. For
  information about feature limitations, see the AWS Elemental MediaConvert User Guide.
- `"category"`: The new category for the job template, if you are changing it.
- `"description"`: The new description for the job template, if you are changing it.
- `"hopDestinations"`: Optional list of hop destinations.
- `"priority"`: Specify the relative priority for this job. In any given queue, the service
  begins processing the job with the highest value first. When more than one job has the same
  priority, the service begins processing the job that you submitted first. If you don't
  specify a priority, the service uses the default value 0.
- `"queue"`: The new queue for the job template, if you are changing it.
- `"settings"`: JobTemplateSettings contains all the transcode settings saved in the
  template that will be applied to jobs created from it.
- `"statusUpdateInterval"`: Specify how often MediaConvert sends STATUS_UPDATE events to
  Amazon CloudWatch Events. Set the interval, in seconds, between status updates.
  MediaConvert sends an update at this interval from the time the service begins processing
  your job to the time it completes the transcode or encounters an error.
"""
function update_job_template(name; aws_config::AbstractAWSConfig=current_aws_config())
    return mediaconvert(
        "PUT",
        "/2017-08-29/jobTemplates/$(name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_job_template(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconvert(
        "PUT",
        "/2017-08-29/jobTemplates/$(name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_preset(name)
    update_preset(name, params::Dict{String,<:Any})

Modify one of your existing presets.

# Arguments
- `name`: The name of the preset you are modifying.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"category"`: The new category for the preset, if you are changing it.
- `"description"`: The new description for the preset, if you are changing it.
- `"settings"`: Settings for preset
"""
function update_preset(name; aws_config::AbstractAWSConfig=current_aws_config())
    return mediaconvert(
        "PUT",
        "/2017-08-29/presets/$(name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_preset(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconvert(
        "PUT",
        "/2017-08-29/presets/$(name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_queue(name)
    update_queue(name, params::Dict{String,<:Any})

Modify one of your existing queues.

# Arguments
- `name`: The name of the queue that you are modifying.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The new description for the queue, if you are changing it.
- `"reservationPlanSettings"`: The new details of your pricing plan for your reserved
  queue. When you set up a new pricing plan to replace an expired one, you enter into another
  12-month commitment. When you add capacity to your queue by increasing the number of RTS,
  you extend the term of your commitment to 12 months from when you add capacity. After you
  make these commitments, you can't cancel them.
- `"status"`: Pause or activate a queue by changing its status between ACTIVE and PAUSED.
  If you pause a queue, jobs in that queue won't begin. Jobs that are running when you pause
  the queue continue to run until they finish or result in an error.
"""
function update_queue(name; aws_config::AbstractAWSConfig=current_aws_config())
    return mediaconvert(
        "PUT",
        "/2017-08-29/queues/$(name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_queue(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediaconvert(
        "PUT",
        "/2017-08-29/queues/$(name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: api_gateway
using AWS.Compat
using AWS.UUIDs

"""
    create_api_key()
    create_api_key(params::Dict{String,<:Any})

Create an ApiKey resource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"customerId"`: An Amazon Web Services Marketplace customer identifier, when integrating
  with the Amazon Web Services SaaS Marketplace.
- `"description"`: The description of the ApiKey.
- `"enabled"`: Specifies whether the ApiKey can be used by callers.
- `"generateDistinctId"`: Specifies whether (true) or not (false) the key identifier is
  distinct from the created API key value. This parameter is deprecated and should not be
  used.
- `"name"`: The name of the ApiKey.
- `"stageKeys"`: DEPRECATED FOR USAGE PLANS - Specifies stages associated with the API key.
- `"tags"`: The key-value map of strings. The valid character set is [a-zA-Z+-=._:/]. The
  tag key can be up to 128 characters and must not start with aws:. The tag value can be up
  to 256 characters.
- `"value"`: Specifies a value of the API key.
"""
function create_api_key(; aws_config::AbstractAWSConfig=current_aws_config())
    return api_gateway(
        "POST", "/apikeys"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function create_api_key(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "POST", "/apikeys", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    create_authorizer(name, restapi_id, type)
    create_authorizer(name, restapi_id, type, params::Dict{String,<:Any})

Adds a new Authorizer resource to an existing RestApi resource.

# Arguments
- `name`: The name of the authorizer.
- `restapi_id`: The string identifier of the associated RestApi.
- `type`: The authorizer type. Valid values are TOKEN for a Lambda function using a single
  authorization token submitted in a custom header, REQUEST for a Lambda function using
  incoming request parameters, and COGNITO_USER_POOLS for using an Amazon Cognito user pool.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"authType"`: Optional customer-defined field, used in OpenAPI imports and exports
  without functional impact.
- `"authorizerCredentials"`: Specifies the required credentials as an IAM role for API
  Gateway to invoke the authorizer. To specify an IAM role for API Gateway to assume, use the
  role's Amazon Resource Name (ARN). To use resource-based permissions on the Lambda
  function, specify null.
- `"authorizerResultTtlInSeconds"`: The TTL in seconds of cached authorizer results. If it
  equals 0, authorization caching is disabled. If it is greater than 0, API Gateway will
  cache authorizer responses. If this field is not set, the default value is 300. The maximum
  value is 3600, or 1 hour.
- `"authorizerUri"`: Specifies the authorizer's Uniform Resource Identifier (URI). For
  TOKEN or REQUEST authorizers, this must be a well-formed Lambda function URI, for example,
  arn:aws:apigateway:us-west-2:lambda:path/2015-03-31/functions/arn:aws:lambda:us-west-2:{acco
  unt_id}:function:{lambda_function_name}/invocations. In general, the URI has this form
  arn:aws:apigateway:{region}:lambda:path/{service_api}, where {region} is the same as the
  region hosting the Lambda function, path indicates that the remaining substring in the URI
  should be treated as the path to the resource, including the initial /. For Lambda
  functions, this is usually of the form /2015-03-31/functions/[FunctionARN]/invocations.
- `"identitySource"`: The identity source for which authorization is requested. For a TOKEN
  or COGNITO_USER_POOLS authorizer, this is required and specifies the request header mapping
  expression for the custom header holding the authorization token submitted by the client.
  For example, if the token header name is Auth, the header mapping expression is
  method.request.header.Auth. For the REQUEST authorizer, this is required when authorization
  caching is enabled. The value is a comma-separated string of one or more mapping
  expressions of the specified request parameters. For example, if an Auth header, a Name
  query string parameter are defined as identity sources, this value is
  method.request.header.Auth, method.request.querystring.Name. These parameters will be used
  to derive the authorization caching key and to perform runtime validation of the REQUEST
  authorizer by verifying all of the identity-related request parameters are present, not
  null and non-empty. Only when this is true does the authorizer invoke the authorizer Lambda
  function, otherwise, it returns a 401 Unauthorized response without calling the Lambda
  function. The valid value is a string of comma-separated mapping expressions of the
  specified request parameters. When the authorization caching is not enabled, this property
  is optional.
- `"identityValidationExpression"`: A validation expression for the incoming identity
  token. For TOKEN authorizers, this value is a regular expression. For COGNITO_USER_POOLS
  authorizers, API Gateway will match the aud field of the incoming token from the client
  against the specified regular expression. It will invoke the authorizer's Lambda function
  when there is a match. Otherwise, it will return a 401 Unauthorized response without
  calling the Lambda function. The validation expression does not apply to the REQUEST
  authorizer.
- `"providerARNs"`: A list of the Amazon Cognito user pool ARNs for the COGNITO_USER_POOLS
  authorizer. Each element is of this format:
  arn:aws:cognito-idp:{region}:{account_id}:userpool/{user_pool_id}. For a TOKEN or REQUEST
  authorizer, this is not defined.
"""
function create_authorizer(
    name, restapi_id, type; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "POST",
        "/restapis/$(restapi_id)/authorizers",
        Dict{String,Any}("name" => name, "type" => type);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_authorizer(
    name,
    restapi_id,
    type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "POST",
        "/restapis/$(restapi_id)/authorizers",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("name" => name, "type" => type), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_base_path_mapping(domain_name, rest_api_id)
    create_base_path_mapping(domain_name, rest_api_id, params::Dict{String,<:Any})

Creates a new BasePathMapping resource.

# Arguments
- `domain_name`: The domain name of the BasePathMapping resource to create.
- `rest_api_id`: The string identifier of the associated RestApi.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"basePath"`: The base path name that callers of the API must provide as part of the URL
  after the domain name. This value must be unique for all of the mappings across a single
  API. Specify '(none)' if you do not want callers to specify a base path name after the
  domain name.
- `"stage"`: The name of the API's stage that you want to use for this mapping. Specify
  '(none)' if you want callers to explicitly specify the stage name after any base path name.
"""
function create_base_path_mapping(
    domain_name, restApiId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "POST",
        "/domainnames/$(domain_name)/basepathmappings",
        Dict{String,Any}("restApiId" => restApiId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_base_path_mapping(
    domain_name,
    restApiId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "POST",
        "/domainnames/$(domain_name)/basepathmappings",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("restApiId" => restApiId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_deployment(restapi_id)
    create_deployment(restapi_id, params::Dict{String,<:Any})

Creates a Deployment resource, which makes a specified RestApi callable over the internet.

# Arguments
- `restapi_id`: The string identifier of the associated RestApi.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"cacheClusterEnabled"`: Enables a cache cluster for the Stage resource specified in the
  input.
- `"cacheClusterSize"`: The stage's cache capacity in GB. For more information about
  choosing a cache size, see Enabling API caching to enhance responsiveness.
- `"canarySettings"`: The input configuration for the canary deployment when the deployment
  is a canary release deployment.
- `"description"`: The description for the Deployment resource to create.
- `"stageDescription"`: The description of the Stage resource for the Deployment resource
  to create.
- `"stageName"`: The name of the Stage resource for the Deployment resource to create.
- `"tracingEnabled"`: Specifies whether active tracing with X-ray is enabled for the Stage.
- `"variables"`: A map that defines the stage variables for the Stage resource that is
  associated with the new deployment. Variable names can have alphanumeric and underscore
  characters, and the values must match [A-Za-z0-9-._~:/?#&amp;=,]+.
"""
function create_deployment(restapi_id; aws_config::AbstractAWSConfig=current_aws_config())
    return api_gateway(
        "POST",
        "/restapis/$(restapi_id)/deployments";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_deployment(
    restapi_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "POST",
        "/restapis/$(restapi_id)/deployments",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_documentation_part(location, properties, restapi_id)
    create_documentation_part(location, properties, restapi_id, params::Dict{String,<:Any})

Creates a documentation part.

# Arguments
- `location`: The location of the targeted API entity of the to-be-created documentation
  part.
- `properties`: The new documentation content map of the targeted API entity. Enclosed
  key-value pairs are API-specific, but only OpenAPI-compliant key-value pairs can be
  exported and, hence, published.
- `restapi_id`: The string identifier of the associated RestApi.

"""
function create_documentation_part(
    location, properties, restapi_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "POST",
        "/restapis/$(restapi_id)/documentation/parts",
        Dict{String,Any}("location" => location, "properties" => properties);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_documentation_part(
    location,
    properties,
    restapi_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "POST",
        "/restapis/$(restapi_id)/documentation/parts",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("location" => location, "properties" => properties),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_documentation_version(documentation_version, restapi_id)
    create_documentation_version(documentation_version, restapi_id, params::Dict{String,<:Any})

Creates a documentation version

# Arguments
- `documentation_version`: The version identifier of the new snapshot.
- `restapi_id`: The string identifier of the associated RestApi.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A description about the new documentation snapshot.
- `"stageName"`: The stage name to be associated with the new documentation snapshot.
"""
function create_documentation_version(
    documentationVersion, restapi_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "POST",
        "/restapis/$(restapi_id)/documentation/versions",
        Dict{String,Any}("documentationVersion" => documentationVersion);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_documentation_version(
    documentationVersion,
    restapi_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "POST",
        "/restapis/$(restapi_id)/documentation/versions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("documentationVersion" => documentationVersion),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_domain_name(domain_name)
    create_domain_name(domain_name, params::Dict{String,<:Any})

Creates a new domain name.

# Arguments
- `domain_name`: The name of the DomainName resource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"certificateArn"`: The reference to an Amazon Web Services-managed certificate that will
  be used by edge-optimized endpoint for this domain name. Certificate Manager is the only
  supported source.
- `"certificateBody"`: [Deprecated] The body of the server certificate that will be used by
  edge-optimized endpoint for this domain name provided by your certificate authority.
- `"certificateChain"`: [Deprecated] The intermediate certificates and optionally the root
  certificate, one after the other without any blank lines, used by an edge-optimized
  endpoint for this domain name. If you include the root certificate, your certificate chain
  must start with intermediate certificates and end with the root certificate. Use the
  intermediate certificates that were provided by your certificate authority. Do not include
  any intermediaries that are not in the chain of trust path.
- `"certificateName"`: The user-friendly name of the certificate that will be used by
  edge-optimized endpoint for this domain name.
- `"certificatePrivateKey"`: [Deprecated] Your edge-optimized endpoint's domain name
  certificate's private key.
- `"endpointConfiguration"`: The endpoint configuration of this DomainName showing the
  endpoint types of the domain name.
- `"mutualTlsAuthentication"`:
- `"ownershipVerificationCertificateArn"`: The ARN of the public certificate issued by ACM
  to validate ownership of your custom domain. Only required when configuring mutual TLS and
  using an ACM imported or private CA certificate ARN as the regionalCertificateArn.
- `"regionalCertificateArn"`: The reference to an Amazon Web Services-managed certificate
  that will be used by regional endpoint for this domain name. Certificate Manager is the
  only supported source.
- `"regionalCertificateName"`: The user-friendly name of the certificate that will be used
  by regional endpoint for this domain name.
- `"securityPolicy"`: The Transport Layer Security (TLS) version + cipher suite for this
  DomainName. The valid values are TLS_1_0 and TLS_1_2.
- `"tags"`: The key-value map of strings. The valid character set is [a-zA-Z+-=._:/]. The
  tag key can be up to 128 characters and must not start with aws:. The tag value can be up
  to 256 characters.
"""
function create_domain_name(domainName; aws_config::AbstractAWSConfig=current_aws_config())
    return api_gateway(
        "POST",
        "/domainnames",
        Dict{String,Any}("domainName" => domainName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_domain_name(
    domainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "POST",
        "/domainnames",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("domainName" => domainName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_model(content_type, name, restapi_id)
    create_model(content_type, name, restapi_id, params::Dict{String,<:Any})

Adds a new Model resource to an existing RestApi resource.

# Arguments
- `content_type`: The content-type for the model.
- `name`: The name of the model. Must be alphanumeric.
- `restapi_id`: The RestApi identifier under which the Model will be created.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description of the model.
- `"schema"`: The schema for the model. For application/json models, this should be JSON
  schema draft 4 model. The maximum size of the model is 400 KB.
"""
function create_model(
    contentType, name, restapi_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "POST",
        "/restapis/$(restapi_id)/models",
        Dict{String,Any}("contentType" => contentType, "name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_model(
    contentType,
    name,
    restapi_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "POST",
        "/restapis/$(restapi_id)/models",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("contentType" => contentType, "name" => name),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_request_validator(restapi_id)
    create_request_validator(restapi_id, params::Dict{String,<:Any})

Creates a RequestValidator of a given RestApi.

# Arguments
- `restapi_id`: The string identifier of the associated RestApi.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"name"`: The name of the to-be-created RequestValidator.
- `"validateRequestBody"`: A Boolean flag to indicate whether to validate request body
  according to the configured model schema for the method (true) or not (false).
- `"validateRequestParameters"`: A Boolean flag to indicate whether to validate request
  parameters, true, or not false.
"""
function create_request_validator(
    restapi_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "POST",
        "/restapis/$(restapi_id)/requestvalidators";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_request_validator(
    restapi_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "POST",
        "/restapis/$(restapi_id)/requestvalidators",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_resource(parent_id, path_part, restapi_id)
    create_resource(parent_id, path_part, restapi_id, params::Dict{String,<:Any})

Creates a Resource resource.

# Arguments
- `parent_id`: The parent resource's identifier.
- `path_part`: The last path segment for this resource.
- `restapi_id`: The string identifier of the associated RestApi.

"""
function create_resource(
    parent_id, pathPart, restapi_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "POST",
        "/restapis/$(restapi_id)/resources/$(parent_id)",
        Dict{String,Any}("pathPart" => pathPart);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_resource(
    parent_id,
    pathPart,
    restapi_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "POST",
        "/restapis/$(restapi_id)/resources/$(parent_id)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("pathPart" => pathPart), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_rest_api(name)
    create_rest_api(name, params::Dict{String,<:Any})

Creates a new RestApi resource.

# Arguments
- `name`: The name of the RestApi.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"apiKeySource"`: The source of the API key for metering requests according to a usage
  plan. Valid values are: HEADER to read the API key from the X-API-Key header of a request.
  AUTHORIZER to read the API key from the UsageIdentifierKey from a custom authorizer.
- `"binaryMediaTypes"`: The list of binary media types supported by the RestApi. By
  default, the RestApi supports only UTF-8-encoded text payloads.
- `"cloneFrom"`: The ID of the RestApi that you want to clone from.
- `"description"`: The description of the RestApi.
- `"disableExecuteApiEndpoint"`: Specifies whether clients can invoke your API by using the
  default execute-api endpoint. By default, clients can invoke your API with the default
  https://{api_id}.execute-api.{region}.amazonaws.com endpoint. To require that clients use a
  custom domain name to invoke your API, disable the default endpoint
- `"endpointConfiguration"`: The endpoint configuration of this RestApi showing the
  endpoint types of the API.
- `"minimumCompressionSize"`: A nullable integer that is used to enable compression (with
  non-negative between 0 and 10485760 (10M) bytes, inclusive) or disable compression (with a
  null value) on an API. When compression is enabled, compression or decompression is not
  applied on the payload if the payload size is smaller than this value. Setting it to zero
  allows compression for any payload size.
- `"policy"`: A stringified JSON policy document that applies to this RestApi regardless of
  the caller and Method configuration.
- `"tags"`: The key-value map of strings. The valid character set is [a-zA-Z+-=._:/]. The
  tag key can be up to 128 characters and must not start with aws:. The tag value can be up
  to 256 characters.
- `"version"`: A version identifier for the API.
"""
function create_rest_api(name; aws_config::AbstractAWSConfig=current_aws_config())
    return api_gateway(
        "POST",
        "/restapis",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_rest_api(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "POST",
        "/restapis",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_stage(deployment_id, restapi_id, stage_name)
    create_stage(deployment_id, restapi_id, stage_name, params::Dict{String,<:Any})

Creates a new Stage resource that references a pre-existing Deployment for the API.

# Arguments
- `deployment_id`: The identifier of the Deployment resource for the Stage resource.
- `restapi_id`: The string identifier of the associated RestApi.
- `stage_name`: The name for the Stage resource. Stage names can only contain alphanumeric
  characters, hyphens, and underscores. Maximum length is 128 characters.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"cacheClusterEnabled"`: Whether cache clustering is enabled for the stage.
- `"cacheClusterSize"`: The stage's cache capacity in GB. For more information about
  choosing a cache size, see Enabling API caching to enhance responsiveness.
- `"canarySettings"`: The canary deployment settings of this stage.
- `"description"`: The description of the Stage resource.
- `"documentationVersion"`: The version of the associated API documentation.
- `"tags"`: The key-value map of strings. The valid character set is [a-zA-Z+-=._:/]. The
  tag key can be up to 128 characters and must not start with aws:. The tag value can be up
  to 256 characters.
- `"tracingEnabled"`: Specifies whether active tracing with X-ray is enabled for the Stage.
- `"variables"`: A map that defines the stage variables for the new Stage resource.
  Variable names can have alphanumeric and underscore characters, and the values must match
  [A-Za-z0-9-._~:/?#&amp;=,]+.
"""
function create_stage(
    deploymentId, restapi_id, stageName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "POST",
        "/restapis/$(restapi_id)/stages",
        Dict{String,Any}("deploymentId" => deploymentId, "stageName" => stageName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_stage(
    deploymentId,
    restapi_id,
    stageName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "POST",
        "/restapis/$(restapi_id)/stages",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("deploymentId" => deploymentId, "stageName" => stageName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_usage_plan(name)
    create_usage_plan(name, params::Dict{String,<:Any})

Creates a usage plan with the throttle and quota limits, as well as the associated API
stages, specified in the payload.

# Arguments
- `name`: The name of the usage plan.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"apiStages"`: The associated API stages of the usage plan.
- `"description"`: The description of the usage plan.
- `"quota"`: The quota of the usage plan.
- `"tags"`: The key-value map of strings. The valid character set is [a-zA-Z+-=._:/]. The
  tag key can be up to 128 characters and must not start with aws:. The tag value can be up
  to 256 characters.
- `"throttle"`: The throttling limits of the usage plan.
"""
function create_usage_plan(name; aws_config::AbstractAWSConfig=current_aws_config())
    return api_gateway(
        "POST",
        "/usageplans",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_usage_plan(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "POST",
        "/usageplans",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_usage_plan_key(key_id, key_type, usageplan_id)
    create_usage_plan_key(key_id, key_type, usageplan_id, params::Dict{String,<:Any})

Creates a usage plan key for adding an existing API key to a usage plan.

# Arguments
- `key_id`: The identifier of a UsagePlanKey resource for a plan customer.
- `key_type`: The type of a UsagePlanKey resource for a plan customer.
- `usageplan_id`: The Id of the UsagePlan resource representing the usage plan containing
  the to-be-created UsagePlanKey resource representing a plan customer.

"""
function create_usage_plan_key(
    keyId, keyType, usageplanId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "POST",
        "/usageplans/$(usageplanId)/keys",
        Dict{String,Any}("keyId" => keyId, "keyType" => keyType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_usage_plan_key(
    keyId,
    keyType,
    usageplanId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "POST",
        "/usageplans/$(usageplanId)/keys",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("keyId" => keyId, "keyType" => keyType), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_vpc_link(name, target_arns)
    create_vpc_link(name, target_arns, params::Dict{String,<:Any})

Creates a VPC link, under the caller's account in a selected region, in an asynchronous
operation that typically takes 2-4 minutes to complete and become operational. The caller
must have permissions to create and update VPC Endpoint services.

# Arguments
- `name`: The name used to label and identify the VPC link.
- `target_arns`: The ARN of the network load balancer of the VPC targeted by the VPC link.
  The network load balancer must be owned by the same Amazon Web Services account of the API
  owner.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description of the VPC link.
- `"tags"`: The key-value map of strings. The valid character set is [a-zA-Z+-=._:/]. The
  tag key can be up to 128 characters and must not start with aws:. The tag value can be up
  to 256 characters.
"""
function create_vpc_link(
    name, targetArns; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "POST",
        "/vpclinks",
        Dict{String,Any}("name" => name, "targetArns" => targetArns);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_vpc_link(
    name,
    targetArns,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "POST",
        "/vpclinks",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("name" => name, "targetArns" => targetArns), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_api_key(api__key)
    delete_api_key(api__key, params::Dict{String,<:Any})

Deletes the ApiKey resource.

# Arguments
- `api__key`: The identifier of the ApiKey resource to be deleted.

"""
function delete_api_key(api_Key; aws_config::AbstractAWSConfig=current_aws_config())
    return api_gateway(
        "DELETE",
        "/apikeys/$(api_Key)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_api_key(
    api_Key,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "DELETE",
        "/apikeys/$(api_Key)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_authorizer(authorizer_id, restapi_id)
    delete_authorizer(authorizer_id, restapi_id, params::Dict{String,<:Any})

Deletes an existing Authorizer resource.

# Arguments
- `authorizer_id`: The identifier of the Authorizer resource.
- `restapi_id`: The string identifier of the associated RestApi.

"""
function delete_authorizer(
    authorizer_id, restapi_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "DELETE",
        "/restapis/$(restapi_id)/authorizers/$(authorizer_id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_authorizer(
    authorizer_id,
    restapi_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "DELETE",
        "/restapis/$(restapi_id)/authorizers/$(authorizer_id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_base_path_mapping(base_path, domain_name)
    delete_base_path_mapping(base_path, domain_name, params::Dict{String,<:Any})

Deletes the BasePathMapping resource.

# Arguments
- `base_path`: The base path name of the BasePathMapping resource to delete. To specify an
  empty base path, set this parameter to '(none)'.
- `domain_name`: The domain name of the BasePathMapping resource to delete.

"""
function delete_base_path_mapping(
    base_path, domain_name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "DELETE",
        "/domainnames/$(domain_name)/basepathmappings/$(base_path)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_base_path_mapping(
    base_path,
    domain_name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "DELETE",
        "/domainnames/$(domain_name)/basepathmappings/$(base_path)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_client_certificate(clientcertificate_id)
    delete_client_certificate(clientcertificate_id, params::Dict{String,<:Any})

Deletes the ClientCertificate resource.

# Arguments
- `clientcertificate_id`: The identifier of the ClientCertificate resource to be deleted.

"""
function delete_client_certificate(
    clientcertificate_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "DELETE",
        "/clientcertificates/$(clientcertificate_id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_client_certificate(
    clientcertificate_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "DELETE",
        "/clientcertificates/$(clientcertificate_id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_deployment(deployment_id, restapi_id)
    delete_deployment(deployment_id, restapi_id, params::Dict{String,<:Any})

Deletes a Deployment resource. Deleting a deployment will only succeed if there are no
Stage resources associated with it.

# Arguments
- `deployment_id`: The identifier of the Deployment resource to delete.
- `restapi_id`: The string identifier of the associated RestApi.

"""
function delete_deployment(
    deployment_id, restapi_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "DELETE",
        "/restapis/$(restapi_id)/deployments/$(deployment_id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_deployment(
    deployment_id,
    restapi_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "DELETE",
        "/restapis/$(restapi_id)/deployments/$(deployment_id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_documentation_part(part_id, restapi_id)
    delete_documentation_part(part_id, restapi_id, params::Dict{String,<:Any})

Deletes a documentation part

# Arguments
- `part_id`: The identifier of the to-be-deleted documentation part.
- `restapi_id`: The string identifier of the associated RestApi.

"""
function delete_documentation_part(
    part_id, restapi_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "DELETE",
        "/restapis/$(restapi_id)/documentation/parts/$(part_id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_documentation_part(
    part_id,
    restapi_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "DELETE",
        "/restapis/$(restapi_id)/documentation/parts/$(part_id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_documentation_version(doc_version, restapi_id)
    delete_documentation_version(doc_version, restapi_id, params::Dict{String,<:Any})

Deletes a documentation version.

# Arguments
- `doc_version`: The version identifier of a to-be-deleted documentation snapshot.
- `restapi_id`: The string identifier of the associated RestApi.

"""
function delete_documentation_version(
    doc_version, restapi_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "DELETE",
        "/restapis/$(restapi_id)/documentation/versions/$(doc_version)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_documentation_version(
    doc_version,
    restapi_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "DELETE",
        "/restapis/$(restapi_id)/documentation/versions/$(doc_version)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_domain_name(domain_name)
    delete_domain_name(domain_name, params::Dict{String,<:Any})

Deletes the DomainName resource.

# Arguments
- `domain_name`: The name of the DomainName resource to be deleted.

"""
function delete_domain_name(domain_name; aws_config::AbstractAWSConfig=current_aws_config())
    return api_gateway(
        "DELETE",
        "/domainnames/$(domain_name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_domain_name(
    domain_name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "DELETE",
        "/domainnames/$(domain_name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_gateway_response(response_type, restapi_id)
    delete_gateway_response(response_type, restapi_id, params::Dict{String,<:Any})

Clears any customization of a GatewayResponse of a specified response type on the given
RestApi and resets it with the default settings.

# Arguments
- `response_type`: The response type of the associated GatewayResponse.
- `restapi_id`: The string identifier of the associated RestApi.

"""
function delete_gateway_response(
    response_type, restapi_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "DELETE",
        "/restapis/$(restapi_id)/gatewayresponses/$(response_type)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_gateway_response(
    response_type,
    restapi_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "DELETE",
        "/restapis/$(restapi_id)/gatewayresponses/$(response_type)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_integration(http_method, resource_id, restapi_id)
    delete_integration(http_method, resource_id, restapi_id, params::Dict{String,<:Any})

Represents a delete integration.

# Arguments
- `http_method`: Specifies a delete integration request's HTTP method.
- `resource_id`: Specifies a delete integration request's resource identifier.
- `restapi_id`: The string identifier of the associated RestApi.

"""
function delete_integration(
    http_method, resource_id, restapi_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "DELETE",
        "/restapis/$(restapi_id)/resources/$(resource_id)/methods/$(http_method)/integration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_integration(
    http_method,
    resource_id,
    restapi_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "DELETE",
        "/restapis/$(restapi_id)/resources/$(resource_id)/methods/$(http_method)/integration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_integration_response(http_method, resource_id, restapi_id, status_code)
    delete_integration_response(http_method, resource_id, restapi_id, status_code, params::Dict{String,<:Any})

Represents a delete integration response.

# Arguments
- `http_method`: Specifies a delete integration response request's HTTP method.
- `resource_id`: Specifies a delete integration response request's resource identifier.
- `restapi_id`: The string identifier of the associated RestApi.
- `status_code`: Specifies a delete integration response request's status code.

"""
function delete_integration_response(
    http_method,
    resource_id,
    restapi_id,
    status_code;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "DELETE",
        "/restapis/$(restapi_id)/resources/$(resource_id)/methods/$(http_method)/integration/responses/$(status_code)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_integration_response(
    http_method,
    resource_id,
    restapi_id,
    status_code,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "DELETE",
        "/restapis/$(restapi_id)/resources/$(resource_id)/methods/$(http_method)/integration/responses/$(status_code)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_method(http_method, resource_id, restapi_id)
    delete_method(http_method, resource_id, restapi_id, params::Dict{String,<:Any})

Deletes an existing Method resource.

# Arguments
- `http_method`: The HTTP verb of the Method resource.
- `resource_id`: The Resource identifier for the Method resource.
- `restapi_id`: The string identifier of the associated RestApi.

"""
function delete_method(
    http_method, resource_id, restapi_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "DELETE",
        "/restapis/$(restapi_id)/resources/$(resource_id)/methods/$(http_method)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_method(
    http_method,
    resource_id,
    restapi_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "DELETE",
        "/restapis/$(restapi_id)/resources/$(resource_id)/methods/$(http_method)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_method_response(http_method, resource_id, restapi_id, status_code)
    delete_method_response(http_method, resource_id, restapi_id, status_code, params::Dict{String,<:Any})

Deletes an existing MethodResponse resource.

# Arguments
- `http_method`: The HTTP verb of the Method resource.
- `resource_id`: The Resource identifier for the MethodResponse resource.
- `restapi_id`: The string identifier of the associated RestApi.
- `status_code`: The status code identifier for the MethodResponse resource.

"""
function delete_method_response(
    http_method,
    resource_id,
    restapi_id,
    status_code;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "DELETE",
        "/restapis/$(restapi_id)/resources/$(resource_id)/methods/$(http_method)/responses/$(status_code)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_method_response(
    http_method,
    resource_id,
    restapi_id,
    status_code,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "DELETE",
        "/restapis/$(restapi_id)/resources/$(resource_id)/methods/$(http_method)/responses/$(status_code)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_model(model_name, restapi_id)
    delete_model(model_name, restapi_id, params::Dict{String,<:Any})

Deletes a model.

# Arguments
- `model_name`: The name of the model to delete.
- `restapi_id`: The string identifier of the associated RestApi.

"""
function delete_model(
    model_name, restapi_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "DELETE",
        "/restapis/$(restapi_id)/models/$(model_name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_model(
    model_name,
    restapi_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "DELETE",
        "/restapis/$(restapi_id)/models/$(model_name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_request_validator(requestvalidator_id, restapi_id)
    delete_request_validator(requestvalidator_id, restapi_id, params::Dict{String,<:Any})

Deletes a RequestValidator of a given RestApi.

# Arguments
- `requestvalidator_id`: The identifier of the RequestValidator to be deleted.
- `restapi_id`: The string identifier of the associated RestApi.

"""
function delete_request_validator(
    requestvalidator_id, restapi_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "DELETE",
        "/restapis/$(restapi_id)/requestvalidators/$(requestvalidator_id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_request_validator(
    requestvalidator_id,
    restapi_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "DELETE",
        "/restapis/$(restapi_id)/requestvalidators/$(requestvalidator_id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_resource(resource_id, restapi_id)
    delete_resource(resource_id, restapi_id, params::Dict{String,<:Any})

Deletes a Resource resource.

# Arguments
- `resource_id`: The identifier of the Resource resource.
- `restapi_id`: The string identifier of the associated RestApi.

"""
function delete_resource(
    resource_id, restapi_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "DELETE",
        "/restapis/$(restapi_id)/resources/$(resource_id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_resource(
    resource_id,
    restapi_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "DELETE",
        "/restapis/$(restapi_id)/resources/$(resource_id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_rest_api(restapi_id)
    delete_rest_api(restapi_id, params::Dict{String,<:Any})

Deletes the specified API.

# Arguments
- `restapi_id`: The string identifier of the associated RestApi.

"""
function delete_rest_api(restapi_id; aws_config::AbstractAWSConfig=current_aws_config())
    return api_gateway(
        "DELETE",
        "/restapis/$(restapi_id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_rest_api(
    restapi_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "DELETE",
        "/restapis/$(restapi_id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_stage(restapi_id, stage_name)
    delete_stage(restapi_id, stage_name, params::Dict{String,<:Any})

Deletes a Stage resource.

# Arguments
- `restapi_id`: The string identifier of the associated RestApi.
- `stage_name`: The name of the Stage resource to delete.

"""
function delete_stage(
    restapi_id, stage_name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "DELETE",
        "/restapis/$(restapi_id)/stages/$(stage_name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_stage(
    restapi_id,
    stage_name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "DELETE",
        "/restapis/$(restapi_id)/stages/$(stage_name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_usage_plan(usageplan_id)
    delete_usage_plan(usageplan_id, params::Dict{String,<:Any})

Deletes a usage plan of a given plan Id.

# Arguments
- `usageplan_id`: The Id of the to-be-deleted usage plan.

"""
function delete_usage_plan(usageplanId; aws_config::AbstractAWSConfig=current_aws_config())
    return api_gateway(
        "DELETE",
        "/usageplans/$(usageplanId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_usage_plan(
    usageplanId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "DELETE",
        "/usageplans/$(usageplanId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_usage_plan_key(key_id, usageplan_id)
    delete_usage_plan_key(key_id, usageplan_id, params::Dict{String,<:Any})

Deletes a usage plan key and remove the underlying API key from the associated usage plan.

# Arguments
- `key_id`: The Id of the UsagePlanKey resource to be deleted.
- `usageplan_id`: The Id of the UsagePlan resource representing the usage plan containing
  the to-be-deleted UsagePlanKey resource representing a plan customer.

"""
function delete_usage_plan_key(
    keyId, usageplanId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "DELETE",
        "/usageplans/$(usageplanId)/keys/$(keyId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_usage_plan_key(
    keyId,
    usageplanId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "DELETE",
        "/usageplans/$(usageplanId)/keys/$(keyId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_vpc_link(vpclink_id)
    delete_vpc_link(vpclink_id, params::Dict{String,<:Any})

Deletes an existing VpcLink of a specified identifier.

# Arguments
- `vpclink_id`: The identifier of the VpcLink. It is used in an Integration to reference
  this VpcLink.

"""
function delete_vpc_link(vpclink_id; aws_config::AbstractAWSConfig=current_aws_config())
    return api_gateway(
        "DELETE",
        "/vpclinks/$(vpclink_id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_vpc_link(
    vpclink_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "DELETE",
        "/vpclinks/$(vpclink_id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    flush_stage_authorizers_cache(restapi_id, stage_name)
    flush_stage_authorizers_cache(restapi_id, stage_name, params::Dict{String,<:Any})

Flushes all authorizer cache entries on a stage.

# Arguments
- `restapi_id`: The string identifier of the associated RestApi.
- `stage_name`: The name of the stage to flush.

"""
function flush_stage_authorizers_cache(
    restapi_id, stage_name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "DELETE",
        "/restapis/$(restapi_id)/stages/$(stage_name)/cache/authorizers";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function flush_stage_authorizers_cache(
    restapi_id,
    stage_name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "DELETE",
        "/restapis/$(restapi_id)/stages/$(stage_name)/cache/authorizers",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    flush_stage_cache(restapi_id, stage_name)
    flush_stage_cache(restapi_id, stage_name, params::Dict{String,<:Any})

Flushes a stage's cache.

# Arguments
- `restapi_id`: The string identifier of the associated RestApi.
- `stage_name`: The name of the stage to flush its cache.

"""
function flush_stage_cache(
    restapi_id, stage_name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "DELETE",
        "/restapis/$(restapi_id)/stages/$(stage_name)/cache/data";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function flush_stage_cache(
    restapi_id,
    stage_name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "DELETE",
        "/restapis/$(restapi_id)/stages/$(stage_name)/cache/data",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    generate_client_certificate()
    generate_client_certificate(params::Dict{String,<:Any})

Generates a ClientCertificate resource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description of the ClientCertificate.
- `"tags"`: The key-value map of strings. The valid character set is [a-zA-Z+-=._:/]. The
  tag key can be up to 128 characters and must not start with aws:. The tag value can be up
  to 256 characters.
"""
function generate_client_certificate(; aws_config::AbstractAWSConfig=current_aws_config())
    return api_gateway(
        "POST",
        "/clientcertificates";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function generate_client_certificate(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "POST",
        "/clientcertificates",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_account()
    get_account(params::Dict{String,<:Any})

Gets information about the current Account resource.

"""
function get_account(; aws_config::AbstractAWSConfig=current_aws_config())
    return api_gateway(
        "GET", "/account"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_account(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "GET", "/account", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_api_key(api__key)
    get_api_key(api__key, params::Dict{String,<:Any})

Gets information about the current ApiKey resource.

# Arguments
- `api__key`: The identifier of the ApiKey resource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"includeValue"`: A boolean flag to specify whether (true) or not (false) the result
  contains the key value.
"""
function get_api_key(api_Key; aws_config::AbstractAWSConfig=current_aws_config())
    return api_gateway(
        "GET", "/apikeys/$(api_Key)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_api_key(
    api_Key,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "GET",
        "/apikeys/$(api_Key)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_api_keys()
    get_api_keys(params::Dict{String,<:Any})

Gets information about the current ApiKeys resource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"customerId"`: The identifier of a customer in Amazon Web Services Marketplace or an
  external system, such as a developer portal.
- `"includeValues"`: A boolean flag to specify whether (true) or not (false) the result
  contains key values.
- `"limit"`: The maximum number of returned results per page. The default value is 25 and
  the maximum value is 500.
- `"name"`: The name of queried API keys.
- `"position"`: The current pagination position in the paged result set.
"""
function get_api_keys(; aws_config::AbstractAWSConfig=current_aws_config())
    return api_gateway(
        "GET", "/apikeys"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_api_keys(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "GET", "/apikeys", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_authorizer(authorizer_id, restapi_id)
    get_authorizer(authorizer_id, restapi_id, params::Dict{String,<:Any})

Describe an existing Authorizer resource.

# Arguments
- `authorizer_id`: The identifier of the Authorizer resource.
- `restapi_id`: The string identifier of the associated RestApi.

"""
function get_authorizer(
    authorizer_id, restapi_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "GET",
        "/restapis/$(restapi_id)/authorizers/$(authorizer_id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_authorizer(
    authorizer_id,
    restapi_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "GET",
        "/restapis/$(restapi_id)/authorizers/$(authorizer_id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_authorizers(restapi_id)
    get_authorizers(restapi_id, params::Dict{String,<:Any})

Describe an existing Authorizers resource.

# Arguments
- `restapi_id`: The string identifier of the associated RestApi.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"limit"`: The maximum number of returned results per page. The default value is 25 and
  the maximum value is 500.
- `"position"`: The current pagination position in the paged result set.
"""
function get_authorizers(restapi_id; aws_config::AbstractAWSConfig=current_aws_config())
    return api_gateway(
        "GET",
        "/restapis/$(restapi_id)/authorizers";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_authorizers(
    restapi_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "GET",
        "/restapis/$(restapi_id)/authorizers",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_base_path_mapping(base_path, domain_name)
    get_base_path_mapping(base_path, domain_name, params::Dict{String,<:Any})

Describe a BasePathMapping resource.

# Arguments
- `base_path`: The base path name that callers of the API must provide as part of the URL
  after the domain name. This value must be unique for all of the mappings across a single
  API. Specify '(none)' if you do not want callers to specify any base path name after the
  domain name.
- `domain_name`: The domain name of the BasePathMapping resource to be described.

"""
function get_base_path_mapping(
    base_path, domain_name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "GET",
        "/domainnames/$(domain_name)/basepathmappings/$(base_path)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_base_path_mapping(
    base_path,
    domain_name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "GET",
        "/domainnames/$(domain_name)/basepathmappings/$(base_path)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_base_path_mappings(domain_name)
    get_base_path_mappings(domain_name, params::Dict{String,<:Any})

Represents a collection of BasePathMapping resources.

# Arguments
- `domain_name`: The domain name of a BasePathMapping resource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"limit"`: The maximum number of returned results per page. The default value is 25 and
  the maximum value is 500.
- `"position"`: The current pagination position in the paged result set.
"""
function get_base_path_mappings(
    domain_name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "GET",
        "/domainnames/$(domain_name)/basepathmappings";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_base_path_mappings(
    domain_name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "GET",
        "/domainnames/$(domain_name)/basepathmappings",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_client_certificate(clientcertificate_id)
    get_client_certificate(clientcertificate_id, params::Dict{String,<:Any})

Gets information about the current ClientCertificate resource.

# Arguments
- `clientcertificate_id`: The identifier of the ClientCertificate resource to be described.

"""
function get_client_certificate(
    clientcertificate_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "GET",
        "/clientcertificates/$(clientcertificate_id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_client_certificate(
    clientcertificate_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "GET",
        "/clientcertificates/$(clientcertificate_id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_client_certificates()
    get_client_certificates(params::Dict{String,<:Any})

Gets a collection of ClientCertificate resources.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"limit"`: The maximum number of returned results per page. The default value is 25 and
  the maximum value is 500.
- `"position"`: The current pagination position in the paged result set.
"""
function get_client_certificates(; aws_config::AbstractAWSConfig=current_aws_config())
    return api_gateway(
        "GET", "/clientcertificates"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_client_certificates(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "GET",
        "/clientcertificates",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_deployment(deployment_id, restapi_id)
    get_deployment(deployment_id, restapi_id, params::Dict{String,<:Any})

Gets information about a Deployment resource.

# Arguments
- `deployment_id`: The identifier of the Deployment resource to get information about.
- `restapi_id`: The string identifier of the associated RestApi.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"embed"`: A query parameter to retrieve the specified embedded resources of the returned
  Deployment resource in the response. In a REST API call, this embed parameter value is a
  list of comma-separated strings, as in GET
  /restapis/{restapi_id}/deployments/{deployment_id}?embed=var1,var2. The SDK and other
  platform-dependent libraries might use a different format for the list. Currently, this
  request supports only retrieval of the embedded API summary this way. Hence, the parameter
  value must be a single-valued list containing only the \"apisummary\" string. For example,
  GET /restapis/{restapi_id}/deployments/{deployment_id}?embed=apisummary.
"""
function get_deployment(
    deployment_id, restapi_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "GET",
        "/restapis/$(restapi_id)/deployments/$(deployment_id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_deployment(
    deployment_id,
    restapi_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "GET",
        "/restapis/$(restapi_id)/deployments/$(deployment_id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_deployments(restapi_id)
    get_deployments(restapi_id, params::Dict{String,<:Any})

Gets information about a Deployments collection.

# Arguments
- `restapi_id`: The string identifier of the associated RestApi.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"limit"`: The maximum number of returned results per page. The default value is 25 and
  the maximum value is 500.
- `"position"`: The current pagination position in the paged result set.
"""
function get_deployments(restapi_id; aws_config::AbstractAWSConfig=current_aws_config())
    return api_gateway(
        "GET",
        "/restapis/$(restapi_id)/deployments";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_deployments(
    restapi_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "GET",
        "/restapis/$(restapi_id)/deployments",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_documentation_part(part_id, restapi_id)
    get_documentation_part(part_id, restapi_id, params::Dict{String,<:Any})

Gets a documentation part.

# Arguments
- `part_id`: The string identifier of the associated RestApi.
- `restapi_id`: The string identifier of the associated RestApi.

"""
function get_documentation_part(
    part_id, restapi_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "GET",
        "/restapis/$(restapi_id)/documentation/parts/$(part_id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_documentation_part(
    part_id,
    restapi_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "GET",
        "/restapis/$(restapi_id)/documentation/parts/$(part_id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_documentation_parts(restapi_id)
    get_documentation_parts(restapi_id, params::Dict{String,<:Any})

Gets documentation parts.

# Arguments
- `restapi_id`: The string identifier of the associated RestApi.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"limit"`: The maximum number of returned results per page. The default value is 25 and
  the maximum value is 500.
- `"locationStatus"`: The status of the API documentation parts to retrieve. Valid values
  are DOCUMENTED for retrieving DocumentationPart resources with content and UNDOCUMENTED for
  DocumentationPart resources without content.
- `"name"`: The name of API entities of the to-be-retrieved documentation parts.
- `"path"`: The path of API entities of the to-be-retrieved documentation parts.
- `"position"`: The current pagination position in the paged result set.
- `"type"`: The type of API entities of the to-be-retrieved documentation parts.
"""
function get_documentation_parts(
    restapi_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "GET",
        "/restapis/$(restapi_id)/documentation/parts";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_documentation_parts(
    restapi_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "GET",
        "/restapis/$(restapi_id)/documentation/parts",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_documentation_version(doc_version, restapi_id)
    get_documentation_version(doc_version, restapi_id, params::Dict{String,<:Any})

Gets a documentation version.

# Arguments
- `doc_version`: The version identifier of the to-be-retrieved documentation snapshot.
- `restapi_id`: The string identifier of the associated RestApi.

"""
function get_documentation_version(
    doc_version, restapi_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "GET",
        "/restapis/$(restapi_id)/documentation/versions/$(doc_version)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_documentation_version(
    doc_version,
    restapi_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "GET",
        "/restapis/$(restapi_id)/documentation/versions/$(doc_version)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_documentation_versions(restapi_id)
    get_documentation_versions(restapi_id, params::Dict{String,<:Any})

Gets documentation versions.

# Arguments
- `restapi_id`: The string identifier of the associated RestApi.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"limit"`: The maximum number of returned results per page. The default value is 25 and
  the maximum value is 500.
- `"position"`: The current pagination position in the paged result set.
"""
function get_documentation_versions(
    restapi_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "GET",
        "/restapis/$(restapi_id)/documentation/versions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_documentation_versions(
    restapi_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "GET",
        "/restapis/$(restapi_id)/documentation/versions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_domain_name(domain_name)
    get_domain_name(domain_name, params::Dict{String,<:Any})

Represents a domain name that is contained in a simpler, more intuitive URL that can be
called.

# Arguments
- `domain_name`: The name of the DomainName resource.

"""
function get_domain_name(domain_name; aws_config::AbstractAWSConfig=current_aws_config())
    return api_gateway(
        "GET",
        "/domainnames/$(domain_name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_domain_name(
    domain_name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "GET",
        "/domainnames/$(domain_name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_domain_names()
    get_domain_names(params::Dict{String,<:Any})

Represents a collection of DomainName resources.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"limit"`: The maximum number of returned results per page. The default value is 25 and
  the maximum value is 500.
- `"position"`: The current pagination position in the paged result set.
"""
function get_domain_names(; aws_config::AbstractAWSConfig=current_aws_config())
    return api_gateway(
        "GET", "/domainnames"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_domain_names(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "GET",
        "/domainnames",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_export(export_type, restapi_id, stage_name)
    get_export(export_type, restapi_id, stage_name, params::Dict{String,<:Any})

Exports a deployed version of a RestApi in a specified format.

# Arguments
- `export_type`: The type of export. Acceptable values are 'oas30' for OpenAPI 3.0.x and
  'swagger' for Swagger/OpenAPI 2.0.
- `restapi_id`: The string identifier of the associated RestApi.
- `stage_name`: The name of the Stage that will be exported.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Accept"`: The content-type of the export, for example application/json. Currently
  application/json and application/yaml are supported for exportType ofoas30 and swagger.
  This should be specified in the Accept header for direct API requests.
- `"parameters"`: A key-value map of query string parameters that specify properties of the
  export, depending on the requested exportType. For exportType oas30 and swagger, any
  combination of the following parameters are supported: extensions='integrations' or
  extensions='apigateway' will export the API with x-amazon-apigateway-integration
  extensions. extensions='authorizers' will export the API with
  x-amazon-apigateway-authorizer extensions. postman will export the API with Postman
  extensions, allowing for import to the Postman tool
"""
function get_export(
    export_type, restapi_id, stage_name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "GET",
        "/restapis/$(restapi_id)/stages/$(stage_name)/exports/$(export_type)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_export(
    export_type,
    restapi_id,
    stage_name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "GET",
        "/restapis/$(restapi_id)/stages/$(stage_name)/exports/$(export_type)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_gateway_response(response_type, restapi_id)
    get_gateway_response(response_type, restapi_id, params::Dict{String,<:Any})

Gets a GatewayResponse of a specified response type on the given RestApi.

# Arguments
- `response_type`: The response type of the associated GatewayResponse.
- `restapi_id`: The string identifier of the associated RestApi.

"""
function get_gateway_response(
    response_type, restapi_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "GET",
        "/restapis/$(restapi_id)/gatewayresponses/$(response_type)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_gateway_response(
    response_type,
    restapi_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "GET",
        "/restapis/$(restapi_id)/gatewayresponses/$(response_type)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_gateway_responses(restapi_id)
    get_gateway_responses(restapi_id, params::Dict{String,<:Any})

Gets the GatewayResponses collection on the given RestApi. If an API developer has not
added any definitions for gateway responses, the result will be the API Gateway-generated
default GatewayResponses collection for the supported response types.

# Arguments
- `restapi_id`: The string identifier of the associated RestApi.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"limit"`: The maximum number of returned results per page. The default value is 25 and
  the maximum value is 500. The GatewayResponses collection does not support pagination and
  the limit does not apply here.
- `"position"`: The current pagination position in the paged result set. The
  GatewayResponse collection does not support pagination and the position does not apply here.
"""
function get_gateway_responses(
    restapi_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "GET",
        "/restapis/$(restapi_id)/gatewayresponses";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_gateway_responses(
    restapi_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "GET",
        "/restapis/$(restapi_id)/gatewayresponses",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_integration(http_method, resource_id, restapi_id)
    get_integration(http_method, resource_id, restapi_id, params::Dict{String,<:Any})

Get the integration settings.

# Arguments
- `http_method`: Specifies a get integration request's HTTP method.
- `resource_id`: Specifies a get integration request's resource identifier
- `restapi_id`: The string identifier of the associated RestApi.

"""
function get_integration(
    http_method, resource_id, restapi_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "GET",
        "/restapis/$(restapi_id)/resources/$(resource_id)/methods/$(http_method)/integration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_integration(
    http_method,
    resource_id,
    restapi_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "GET",
        "/restapis/$(restapi_id)/resources/$(resource_id)/methods/$(http_method)/integration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_integration_response(http_method, resource_id, restapi_id, status_code)
    get_integration_response(http_method, resource_id, restapi_id, status_code, params::Dict{String,<:Any})

Represents a get integration response.

# Arguments
- `http_method`: Specifies a get integration response request's HTTP method.
- `resource_id`: Specifies a get integration response request's resource identifier.
- `restapi_id`: The string identifier of the associated RestApi.
- `status_code`: Specifies a get integration response request's status code.

"""
function get_integration_response(
    http_method,
    resource_id,
    restapi_id,
    status_code;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "GET",
        "/restapis/$(restapi_id)/resources/$(resource_id)/methods/$(http_method)/integration/responses/$(status_code)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_integration_response(
    http_method,
    resource_id,
    restapi_id,
    status_code,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "GET",
        "/restapis/$(restapi_id)/resources/$(resource_id)/methods/$(http_method)/integration/responses/$(status_code)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_method(http_method, resource_id, restapi_id)
    get_method(http_method, resource_id, restapi_id, params::Dict{String,<:Any})

Describe an existing Method resource.

# Arguments
- `http_method`: Specifies the method request's HTTP method type.
- `resource_id`: The Resource identifier for the Method resource.
- `restapi_id`: The string identifier of the associated RestApi.

"""
function get_method(
    http_method, resource_id, restapi_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "GET",
        "/restapis/$(restapi_id)/resources/$(resource_id)/methods/$(http_method)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_method(
    http_method,
    resource_id,
    restapi_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "GET",
        "/restapis/$(restapi_id)/resources/$(resource_id)/methods/$(http_method)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_method_response(http_method, resource_id, restapi_id, status_code)
    get_method_response(http_method, resource_id, restapi_id, status_code, params::Dict{String,<:Any})

Describes a MethodResponse resource.

# Arguments
- `http_method`: The HTTP verb of the Method resource.
- `resource_id`: The Resource identifier for the MethodResponse resource.
- `restapi_id`: The string identifier of the associated RestApi.
- `status_code`: The status code for the MethodResponse resource.

"""
function get_method_response(
    http_method,
    resource_id,
    restapi_id,
    status_code;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "GET",
        "/restapis/$(restapi_id)/resources/$(resource_id)/methods/$(http_method)/responses/$(status_code)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_method_response(
    http_method,
    resource_id,
    restapi_id,
    status_code,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "GET",
        "/restapis/$(restapi_id)/resources/$(resource_id)/methods/$(http_method)/responses/$(status_code)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_model(model_name, restapi_id)
    get_model(model_name, restapi_id, params::Dict{String,<:Any})

Describes an existing model defined for a RestApi resource.

# Arguments
- `model_name`: The name of the model as an identifier.
- `restapi_id`: The RestApi identifier under which the Model exists.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"flatten"`: A query parameter of a Boolean value to resolve (true) all external model
  references and returns a flattened model schema or not (false) The default is false.
"""
function get_model(
    model_name, restapi_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "GET",
        "/restapis/$(restapi_id)/models/$(model_name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_model(
    model_name,
    restapi_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "GET",
        "/restapis/$(restapi_id)/models/$(model_name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_model_template(model_name, restapi_id)
    get_model_template(model_name, restapi_id, params::Dict{String,<:Any})

Generates a sample mapping template that can be used to transform a payload into the
structure of a model.

# Arguments
- `model_name`: The name of the model for which to generate a template.
- `restapi_id`: The string identifier of the associated RestApi.

"""
function get_model_template(
    model_name, restapi_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "GET",
        "/restapis/$(restapi_id)/models/$(model_name)/default_template";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_model_template(
    model_name,
    restapi_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "GET",
        "/restapis/$(restapi_id)/models/$(model_name)/default_template",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_models(restapi_id)
    get_models(restapi_id, params::Dict{String,<:Any})

Describes existing Models defined for a RestApi resource.

# Arguments
- `restapi_id`: The string identifier of the associated RestApi.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"limit"`: The maximum number of returned results per page. The default value is 25 and
  the maximum value is 500.
- `"position"`: The current pagination position in the paged result set.
"""
function get_models(restapi_id; aws_config::AbstractAWSConfig=current_aws_config())
    return api_gateway(
        "GET",
        "/restapis/$(restapi_id)/models";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_models(
    restapi_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "GET",
        "/restapis/$(restapi_id)/models",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_request_validator(requestvalidator_id, restapi_id)
    get_request_validator(requestvalidator_id, restapi_id, params::Dict{String,<:Any})

Gets a RequestValidator of a given RestApi.

# Arguments
- `requestvalidator_id`: The identifier of the RequestValidator to be retrieved.
- `restapi_id`: The string identifier of the associated RestApi.

"""
function get_request_validator(
    requestvalidator_id, restapi_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "GET",
        "/restapis/$(restapi_id)/requestvalidators/$(requestvalidator_id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_request_validator(
    requestvalidator_id,
    restapi_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "GET",
        "/restapis/$(restapi_id)/requestvalidators/$(requestvalidator_id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_request_validators(restapi_id)
    get_request_validators(restapi_id, params::Dict{String,<:Any})

Gets the RequestValidators collection of a given RestApi.

# Arguments
- `restapi_id`: The string identifier of the associated RestApi.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"limit"`: The maximum number of returned results per page. The default value is 25 and
  the maximum value is 500.
- `"position"`: The current pagination position in the paged result set.
"""
function get_request_validators(
    restapi_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "GET",
        "/restapis/$(restapi_id)/requestvalidators";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_request_validators(
    restapi_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "GET",
        "/restapis/$(restapi_id)/requestvalidators",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_resource(resource_id, restapi_id)
    get_resource(resource_id, restapi_id, params::Dict{String,<:Any})

Lists information about a resource.

# Arguments
- `resource_id`: The identifier for the Resource resource.
- `restapi_id`: The string identifier of the associated RestApi.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"embed"`: A query parameter to retrieve the specified resources embedded in the returned
  Resource representation in the response. This embed parameter value is a list of
  comma-separated strings. Currently, the request supports only retrieval of the embedded
  Method resources this way. The query parameter value must be a single-valued list and
  contain the \"methods\" string. For example, GET
  /restapis/{restapi_id}/resources/{resource_id}?embed=methods.
"""
function get_resource(
    resource_id, restapi_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "GET",
        "/restapis/$(restapi_id)/resources/$(resource_id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_resource(
    resource_id,
    restapi_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "GET",
        "/restapis/$(restapi_id)/resources/$(resource_id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_resources(restapi_id)
    get_resources(restapi_id, params::Dict{String,<:Any})

Lists information about a collection of Resource resources.

# Arguments
- `restapi_id`: The string identifier of the associated RestApi.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"embed"`: A query parameter used to retrieve the specified resources embedded in the
  returned Resources resource in the response. This embed parameter value is a list of
  comma-separated strings. Currently, the request supports only retrieval of the embedded
  Method resources this way. The query parameter value must be a single-valued list and
  contain the \"methods\" string. For example, GET
  /restapis/{restapi_id}/resources?embed=methods.
- `"limit"`: The maximum number of returned results per page. The default value is 25 and
  the maximum value is 500.
- `"position"`: The current pagination position in the paged result set.
"""
function get_resources(restapi_id; aws_config::AbstractAWSConfig=current_aws_config())
    return api_gateway(
        "GET",
        "/restapis/$(restapi_id)/resources";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_resources(
    restapi_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "GET",
        "/restapis/$(restapi_id)/resources",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_rest_api(restapi_id)
    get_rest_api(restapi_id, params::Dict{String,<:Any})

Lists the RestApi resource in the collection.

# Arguments
- `restapi_id`: The string identifier of the associated RestApi.

"""
function get_rest_api(restapi_id; aws_config::AbstractAWSConfig=current_aws_config())
    return api_gateway(
        "GET",
        "/restapis/$(restapi_id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_rest_api(
    restapi_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "GET",
        "/restapis/$(restapi_id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_rest_apis()
    get_rest_apis(params::Dict{String,<:Any})

Lists the RestApis resources for your collection.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"limit"`: The maximum number of returned results per page. The default value is 25 and
  the maximum value is 500.
- `"position"`: The current pagination position in the paged result set.
"""
function get_rest_apis(; aws_config::AbstractAWSConfig=current_aws_config())
    return api_gateway(
        "GET", "/restapis"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_rest_apis(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "GET", "/restapis", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_sdk(restapi_id, sdk_type, stage_name)
    get_sdk(restapi_id, sdk_type, stage_name, params::Dict{String,<:Any})

Generates a client SDK for a RestApi and Stage.

# Arguments
- `restapi_id`: The string identifier of the associated RestApi.
- `sdk_type`: The language for the generated SDK. Currently java, javascript, android,
  objectivec (for iOS), swift (for iOS), and ruby are supported.
- `stage_name`: The name of the Stage that the SDK will use.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"parameters"`: A string-to-string key-value map of query parameters sdkType-dependent
  properties of the SDK. For sdkType of objectivec or swift, a parameter named classPrefix is
  required. For sdkType of android, parameters named groupId, artifactId, artifactVersion,
  and invokerPackage are required. For sdkType of java, parameters named serviceName and
  javaPackageName are required.
"""
function get_sdk(
    restapi_id, sdk_type, stage_name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "GET",
        "/restapis/$(restapi_id)/stages/$(stage_name)/sdks/$(sdk_type)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_sdk(
    restapi_id,
    sdk_type,
    stage_name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "GET",
        "/restapis/$(restapi_id)/stages/$(stage_name)/sdks/$(sdk_type)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_sdk_type(sdktype_id)
    get_sdk_type(sdktype_id, params::Dict{String,<:Any})

Gets an SDK type.

# Arguments
- `sdktype_id`: The identifier of the queried SdkType instance.

"""
function get_sdk_type(sdktype_id; aws_config::AbstractAWSConfig=current_aws_config())
    return api_gateway(
        "GET",
        "/sdktypes/$(sdktype_id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_sdk_type(
    sdktype_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "GET",
        "/sdktypes/$(sdktype_id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_sdk_types()
    get_sdk_types(params::Dict{String,<:Any})

Gets SDK types

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"limit"`: The maximum number of returned results per page. The default value is 25 and
  the maximum value is 500.
- `"position"`: The current pagination position in the paged result set.
"""
function get_sdk_types(; aws_config::AbstractAWSConfig=current_aws_config())
    return api_gateway(
        "GET", "/sdktypes"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_sdk_types(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "GET", "/sdktypes", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_stage(restapi_id, stage_name)
    get_stage(restapi_id, stage_name, params::Dict{String,<:Any})

Gets information about a Stage resource.

# Arguments
- `restapi_id`: The string identifier of the associated RestApi.
- `stage_name`: The name of the Stage resource to get information about.

"""
function get_stage(
    restapi_id, stage_name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "GET",
        "/restapis/$(restapi_id)/stages/$(stage_name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_stage(
    restapi_id,
    stage_name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "GET",
        "/restapis/$(restapi_id)/stages/$(stage_name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_stages(restapi_id)
    get_stages(restapi_id, params::Dict{String,<:Any})

Gets information about one or more Stage resources.

# Arguments
- `restapi_id`: The string identifier of the associated RestApi.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"deploymentId"`: The stages' deployment identifiers.
"""
function get_stages(restapi_id; aws_config::AbstractAWSConfig=current_aws_config())
    return api_gateway(
        "GET",
        "/restapis/$(restapi_id)/stages";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_stages(
    restapi_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "GET",
        "/restapis/$(restapi_id)/stages",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_tags(resource_arn)
    get_tags(resource_arn, params::Dict{String,<:Any})

Gets the Tags collection for a given resource.

# Arguments
- `resource_arn`: The ARN of a resource that can be tagged.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"limit"`: (Not currently supported) The maximum number of returned results per page. The
  default value is 25 and the maximum value is 500.
- `"position"`: (Not currently supported) The current pagination position in the paged
  result set.
"""
function get_tags(resource_arn; aws_config::AbstractAWSConfig=current_aws_config())
    return api_gateway(
        "GET",
        "/tags/$(resource_arn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_tags(
    resource_arn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "GET",
        "/tags/$(resource_arn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_usage(end_date, start_date, usageplan_id)
    get_usage(end_date, start_date, usageplan_id, params::Dict{String,<:Any})

Gets the usage data of a usage plan in a specified time interval.

# Arguments
- `end_date`: The ending date (e.g., 2016-12-31) of the usage data.
- `start_date`: The starting date (e.g., 2016-01-01) of the usage data.
- `usageplan_id`: The Id of the usage plan associated with the usage data.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"keyId"`: The Id of the API key associated with the resultant usage data.
- `"limit"`: The maximum number of returned results per page. The default value is 25 and
  the maximum value is 500.
- `"position"`: The current pagination position in the paged result set.
"""
function get_usage(
    endDate, startDate, usageplanId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "GET",
        "/usageplans/$(usageplanId)/usage",
        Dict{String,Any}("endDate" => endDate, "startDate" => startDate);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_usage(
    endDate,
    startDate,
    usageplanId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "GET",
        "/usageplans/$(usageplanId)/usage",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("endDate" => endDate, "startDate" => startDate),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_usage_plan(usageplan_id)
    get_usage_plan(usageplan_id, params::Dict{String,<:Any})

Gets a usage plan of a given plan identifier.

# Arguments
- `usageplan_id`: The identifier of the UsagePlan resource to be retrieved.

"""
function get_usage_plan(usageplanId; aws_config::AbstractAWSConfig=current_aws_config())
    return api_gateway(
        "GET",
        "/usageplans/$(usageplanId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_usage_plan(
    usageplanId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "GET",
        "/usageplans/$(usageplanId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_usage_plan_key(key_id, usageplan_id)
    get_usage_plan_key(key_id, usageplan_id, params::Dict{String,<:Any})

Gets a usage plan key of a given key identifier.

# Arguments
- `key_id`: The key Id of the to-be-retrieved UsagePlanKey resource representing a plan
  customer.
- `usageplan_id`: The Id of the UsagePlan resource representing the usage plan containing
  the to-be-retrieved UsagePlanKey resource representing a plan customer.

"""
function get_usage_plan_key(
    keyId, usageplanId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "GET",
        "/usageplans/$(usageplanId)/keys/$(keyId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_usage_plan_key(
    keyId,
    usageplanId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "GET",
        "/usageplans/$(usageplanId)/keys/$(keyId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_usage_plan_keys(usageplan_id)
    get_usage_plan_keys(usageplan_id, params::Dict{String,<:Any})

Gets all the usage plan keys representing the API keys added to a specified usage plan.

# Arguments
- `usageplan_id`: The Id of the UsagePlan resource representing the usage plan containing
  the to-be-retrieved UsagePlanKey resource representing a plan customer.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"limit"`: The maximum number of returned results per page. The default value is 25 and
  the maximum value is 500.
- `"name"`: A query parameter specifying the name of the to-be-returned usage plan keys.
- `"position"`: The current pagination position in the paged result set.
"""
function get_usage_plan_keys(
    usageplanId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "GET",
        "/usageplans/$(usageplanId)/keys";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_usage_plan_keys(
    usageplanId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "GET",
        "/usageplans/$(usageplanId)/keys",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_usage_plans()
    get_usage_plans(params::Dict{String,<:Any})

Gets all the usage plans of the caller's account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"keyId"`: The identifier of the API key associated with the usage plans.
- `"limit"`: The maximum number of returned results per page. The default value is 25 and
  the maximum value is 500.
- `"position"`: The current pagination position in the paged result set.
"""
function get_usage_plans(; aws_config::AbstractAWSConfig=current_aws_config())
    return api_gateway(
        "GET", "/usageplans"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_usage_plans(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "GET", "/usageplans", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_vpc_link(vpclink_id)
    get_vpc_link(vpclink_id, params::Dict{String,<:Any})

Gets a specified VPC link under the caller's account in a region.

# Arguments
- `vpclink_id`: The identifier of the VpcLink. It is used in an Integration to reference
  this VpcLink.

"""
function get_vpc_link(vpclink_id; aws_config::AbstractAWSConfig=current_aws_config())
    return api_gateway(
        "GET",
        "/vpclinks/$(vpclink_id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_vpc_link(
    vpclink_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "GET",
        "/vpclinks/$(vpclink_id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_vpc_links()
    get_vpc_links(params::Dict{String,<:Any})

Gets the VpcLinks collection under the caller's account in a selected region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"limit"`: The maximum number of returned results per page. The default value is 25 and
  the maximum value is 500.
- `"position"`: The current pagination position in the paged result set.
"""
function get_vpc_links(; aws_config::AbstractAWSConfig=current_aws_config())
    return api_gateway(
        "GET", "/vpclinks"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_vpc_links(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "GET", "/vpclinks", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    import_api_keys(body, format)
    import_api_keys(body, format, params::Dict{String,<:Any})

Import API keys from an external source, such as a CSV-formatted file.

# Arguments
- `body`: The payload of the POST request to import API keys. For the payload format, see
  API Key File Format.
- `format`: A query parameter to specify the input format to imported API keys. Currently,
  only the csv format is supported.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"failonwarnings"`: A query parameter to indicate whether to rollback ApiKey importation
  (true) or not (false) when error is encountered.
"""
function import_api_keys(body, format; aws_config::AbstractAWSConfig=current_aws_config())
    return api_gateway(
        "POST",
        "/apikeys?mode=import",
        Dict{String,Any}("body" => body, "format" => format);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function import_api_keys(
    body,
    format,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "POST",
        "/apikeys?mode=import",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("body" => body, "format" => format), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    import_documentation_parts(body, restapi_id)
    import_documentation_parts(body, restapi_id, params::Dict{String,<:Any})

Imports documentation parts

# Arguments
- `body`: Raw byte array representing the to-be-imported documentation parts. To import
  from an OpenAPI file, this is a JSON object.
- `restapi_id`: The string identifier of the associated RestApi.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"failonwarnings"`: A query parameter to specify whether to rollback the documentation
  importation (true) or not (false) when a warning is encountered. The default value is false.
- `"mode"`: A query parameter to indicate whether to overwrite (overwrite) any existing
  DocumentationParts definition or to merge (merge) the new definition into the existing one.
  The default value is merge.
"""
function import_documentation_parts(
    body, restapi_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "PUT",
        "/restapis/$(restapi_id)/documentation/parts",
        Dict{String,Any}("body" => body);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function import_documentation_parts(
    body,
    restapi_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "PUT",
        "/restapis/$(restapi_id)/documentation/parts",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("body" => body), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    import_rest_api(body)
    import_rest_api(body, params::Dict{String,<:Any})

A feature of the API Gateway control service for creating a new API from an external API
definition file.

# Arguments
- `body`: The POST request body containing external API definitions. Currently, only
  OpenAPI definition JSON/YAML files are supported. The maximum size of the API definition
  file is 6MB.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"failonwarnings"`: A query parameter to indicate whether to rollback the API creation
  (true) or not (false) when a warning is encountered. The default value is false.
- `"parameters"`: A key-value map of context-specific query string parameters specifying
  the behavior of different API importing operations. The following shows operation-specific
  parameters and their supported values.  To exclude DocumentationParts from the import, set
  parameters as ignore=documentation.  To configure the endpoint type, set parameters as
  endpointConfigurationTypes=EDGE, endpointConfigurationTypes=REGIONAL, or
  endpointConfigurationTypes=PRIVATE. The default endpoint type is EDGE.  To handle imported
  basepath, set parameters as basepath=ignore, basepath=prepend or basepath=split.
"""
function import_rest_api(body; aws_config::AbstractAWSConfig=current_aws_config())
    return api_gateway(
        "POST",
        "/restapis?mode=import",
        Dict{String,Any}("body" => body);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function import_rest_api(
    body, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "POST",
        "/restapis?mode=import",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("body" => body), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_gateway_response(response_type, restapi_id)
    put_gateway_response(response_type, restapi_id, params::Dict{String,<:Any})

Creates a customization of a GatewayResponse of a specified response type and status code
on the given RestApi.

# Arguments
- `response_type`: The response type of the associated GatewayResponse
- `restapi_id`: The string identifier of the associated RestApi.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"responseParameters"`: Response parameters (paths, query strings and headers) of the
  GatewayResponse as a string-to-string map of key-value pairs.
- `"responseTemplates"`: Response templates of the GatewayResponse as a string-to-string
  map of key-value pairs.
- `"statusCode"`: The HTTP status code of the GatewayResponse.
"""
function put_gateway_response(
    response_type, restapi_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "PUT",
        "/restapis/$(restapi_id)/gatewayresponses/$(response_type)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_gateway_response(
    response_type,
    restapi_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "PUT",
        "/restapis/$(restapi_id)/gatewayresponses/$(response_type)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_integration(http_method, resource_id, restapi_id, type)
    put_integration(http_method, resource_id, restapi_id, type, params::Dict{String,<:Any})

Sets up a method's integration.

# Arguments
- `http_method`: Specifies the HTTP method for the integration.
- `resource_id`: Specifies a put integration request's resource ID.
- `restapi_id`: The string identifier of the associated RestApi.
- `type`: Specifies a put integration input's type.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"cacheKeyParameters"`: A list of request parameters whose values API Gateway caches. To
  be valid values for cacheKeyParameters, these parameters must also be specified for Method
  requestParameters.
- `"cacheNamespace"`: Specifies a group of related cached parameters. By default, API
  Gateway uses the resource ID as the cacheNamespace. You can specify the same cacheNamespace
  across resources to return the same cached data for requests to different resources.
- `"connectionId"`: The ID of the VpcLink used for the integration. Specify this value only
  if you specify VPC_LINK as the connection type.
- `"connectionType"`: The type of the network connection to the integration endpoint. The
  valid value is INTERNET for connections through the public routable internet or VPC_LINK
  for private connections between API Gateway and a network load balancer in a VPC. The
  default value is INTERNET.
- `"contentHandling"`: Specifies how to handle request payload content type conversions.
  Supported values are CONVERT_TO_BINARY and CONVERT_TO_TEXT, with the following behaviors:
  If this property is not defined, the request payload will be passed through from the method
  request to integration request without modification, provided that the passthroughBehavior
  is configured to support payload pass-through.
- `"credentials"`: Specifies whether credentials are required for a put integration.
- `"httpMethod"`: The HTTP method for the integration.
- `"passthroughBehavior"`: Specifies the pass-through behavior for incoming requests based
  on the Content-Type header in the request, and the available mapping templates specified as
  the requestTemplates property on the Integration resource. There are three valid values:
  WHEN_NO_MATCH, WHEN_NO_TEMPLATES, and NEVER.
- `"requestParameters"`: A key-value map specifying request parameters that are passed from
  the method request to the back end. The key is an integration request parameter name and
  the associated value is a method request parameter value or static value that must be
  enclosed within single quotes and pre-encoded as required by the back end. The method
  request parameter value must match the pattern of method.request.{location}.{name}, where
  location is querystring, path, or header and name must be a valid and unique method request
  parameter name.
- `"requestTemplates"`: Represents a map of Velocity templates that are applied on the
  request payload based on the value of the Content-Type header sent by the client. The
  content type value is the key in this map, and the template (as a String) is the value.
- `"timeoutInMillis"`: Custom timeout between 50 and 29,000 milliseconds. The default value
  is 29,000 milliseconds or 29 seconds.
- `"tlsConfig"`:
- `"uri"`: Specifies Uniform Resource Identifier (URI) of the integration endpoint. For
  HTTP or HTTP_PROXY integrations, the URI must be a fully formed, encoded HTTP(S) URL
  according to the RFC-3986 specification, for either standard integration, where
  connectionType is not VPC_LINK, or private integration, where connectionType is VPC_LINK.
  For a private HTTP integration, the URI is not used for routing. For AWS or AWS_PROXY
  integrations, the URI is of the form
  arn:aws:apigateway:{region}:{subdomain.service|service}:path|action/{service_api}. Here,
  {Region} is the API Gateway region (e.g., us-east-1); {service} is the name of the
  integrated Amazon Web Services service (e.g., s3); and {subdomain} is a designated
  subdomain supported by certain Amazon Web Services service for fast host-name lookup.
  action can be used for an Amazon Web Services service action-based API, using an
  Action={name}&amp;{p1}={v1}&amp;p2={v2}... query string. The ensuing {service_api} refers
  to a supported action {name} plus any required input parameters. Alternatively, path can be
  used for an Amazon Web Services service path-based API. The ensuing service_api refers to
  the path to an Amazon Web Services service resource, including the region of the integrated
  Amazon Web Services service, if applicable. For example, for integration with the S3 API of
  GetObject, the uri can be either
  arn:aws:apigateway:us-west-2:s3:action/GetObject&amp;Bucket={bucket}&amp;Key={key} or
  arn:aws:apigateway:us-west-2:s3:path/{bucket}/{key}.
"""
function put_integration(
    http_method,
    resource_id,
    restapi_id,
    type;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "PUT",
        "/restapis/$(restapi_id)/resources/$(resource_id)/methods/$(http_method)/integration",
        Dict{String,Any}("type" => type);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_integration(
    http_method,
    resource_id,
    restapi_id,
    type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "PUT",
        "/restapis/$(restapi_id)/resources/$(resource_id)/methods/$(http_method)/integration",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("type" => type), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_integration_response(http_method, resource_id, restapi_id, status_code)
    put_integration_response(http_method, resource_id, restapi_id, status_code, params::Dict{String,<:Any})

Represents a put integration.

# Arguments
- `http_method`: Specifies a put integration response request's HTTP method.
- `resource_id`: Specifies a put integration response request's resource identifier.
- `restapi_id`: The string identifier of the associated RestApi.
- `status_code`: Specifies the status code that is used to map the integration response to
  an existing MethodResponse.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"contentHandling"`: Specifies how to handle response payload content type conversions.
  Supported values are CONVERT_TO_BINARY and CONVERT_TO_TEXT, with the following behaviors:
  If this property is not defined, the response payload will be passed through from the
  integration response to the method response without modification.
- `"responseParameters"`: A key-value map specifying response parameters that are passed to
  the method response from the back end. The key is a method response header parameter name
  and the mapped value is an integration response header value, a static value enclosed
  within a pair of single quotes, or a JSON expression from the integration response body.
  The mapping key must match the pattern of method.response.header.{name}, where name is a
  valid and unique header name. The mapped non-static value must match the pattern of
  integration.response.header.{name} or integration.response.body.{JSON-expression}, where
  name must be a valid and unique response header name and JSON-expression a valid JSON
  expression without the  prefix.
- `"responseTemplates"`: Specifies a put integration response's templates.
- `"selectionPattern"`: Specifies the selection pattern of a put integration response.
"""
function put_integration_response(
    http_method,
    resource_id,
    restapi_id,
    status_code;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "PUT",
        "/restapis/$(restapi_id)/resources/$(resource_id)/methods/$(http_method)/integration/responses/$(status_code)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_integration_response(
    http_method,
    resource_id,
    restapi_id,
    status_code,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "PUT",
        "/restapis/$(restapi_id)/resources/$(resource_id)/methods/$(http_method)/integration/responses/$(status_code)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_method(authorization_type, http_method, resource_id, restapi_id)
    put_method(authorization_type, http_method, resource_id, restapi_id, params::Dict{String,<:Any})

Add a method to an existing Resource resource.

# Arguments
- `authorization_type`: The method's authorization type. Valid values are NONE for open
  access, AWS_IAM for using AWS IAM permissions, CUSTOM for using a custom authorizer, or
  COGNITO_USER_POOLS for using a Cognito user pool.
- `http_method`: Specifies the method request's HTTP method type.
- `resource_id`: The Resource identifier for the new Method resource.
- `restapi_id`: The string identifier of the associated RestApi.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"apiKeyRequired"`: Specifies whether the method required a valid ApiKey.
- `"authorizationScopes"`: A list of authorization scopes configured on the method. The
  scopes are used with a COGNITO_USER_POOLS authorizer to authorize the method invocation.
  The authorization works by matching the method scopes against the scopes parsed from the
  access token in the incoming request. The method invocation is authorized if any method
  scopes matches a claimed scope in the access token. Otherwise, the invocation is not
  authorized. When the method scope is configured, the client must provide an access token
  instead of an identity token for authorization purposes.
- `"authorizerId"`: Specifies the identifier of an Authorizer to use on this Method, if the
  type is CUSTOM or COGNITO_USER_POOLS. The authorizer identifier is generated by API Gateway
  when you created the authorizer.
- `"operationName"`: A human-friendly operation identifier for the method. For example, you
  can assign the operationName of ListPets for the GET /pets method in the PetStore example.
- `"requestModels"`: Specifies the Model resources used for the request's content type.
  Request models are represented as a key/value map, with a content type as the key and a
  Model name as the value.
- `"requestParameters"`: A key-value map defining required or optional method request
  parameters that can be accepted by API Gateway. A key defines a method request parameter
  name matching the pattern of method.request.{location}.{name}, where location is
  querystring, path, or header and name is a valid and unique parameter name. The value
  associated with the key is a Boolean flag indicating whether the parameter is required
  (true) or optional (false). The method request parameter names defined here are available
  in Integration to be mapped to integration request parameters or body-mapping templates.
- `"requestValidatorId"`: The identifier of a RequestValidator for validating the method
  request.
"""
function put_method(
    authorizationType,
    http_method,
    resource_id,
    restapi_id;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "PUT",
        "/restapis/$(restapi_id)/resources/$(resource_id)/methods/$(http_method)",
        Dict{String,Any}("authorizationType" => authorizationType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_method(
    authorizationType,
    http_method,
    resource_id,
    restapi_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "PUT",
        "/restapis/$(restapi_id)/resources/$(resource_id)/methods/$(http_method)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("authorizationType" => authorizationType), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_method_response(http_method, resource_id, restapi_id, status_code)
    put_method_response(http_method, resource_id, restapi_id, status_code, params::Dict{String,<:Any})

Adds a MethodResponse to an existing Method resource.

# Arguments
- `http_method`: The HTTP verb of the Method resource.
- `resource_id`: The Resource identifier for the Method resource.
- `restapi_id`: The string identifier of the associated RestApi.
- `status_code`: The method response's status code.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"responseModels"`: Specifies the Model resources used for the response's content type.
  Response models are represented as a key/value map, with a content type as the key and a
  Model name as the value.
- `"responseParameters"`: A key-value map specifying required or optional response
  parameters that API Gateway can send back to the caller. A key defines a method response
  header name and the associated value is a Boolean flag indicating whether the method
  response parameter is required or not. The method response header names must match the
  pattern of method.response.header.{name}, where name is a valid and unique header name. The
  response parameter names defined here are available in the integration response to be
  mapped from an integration response header expressed in integration.response.header.{name},
  a static value enclosed within a pair of single quotes (e.g., 'application/json'), or a
  JSON expression from the back-end response payload in the form of
  integration.response.body.{JSON-expression}, where JSON-expression is a valid JSON
  expression without the  prefix.)
"""
function put_method_response(
    http_method,
    resource_id,
    restapi_id,
    status_code;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "PUT",
        "/restapis/$(restapi_id)/resources/$(resource_id)/methods/$(http_method)/responses/$(status_code)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_method_response(
    http_method,
    resource_id,
    restapi_id,
    status_code,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "PUT",
        "/restapis/$(restapi_id)/resources/$(resource_id)/methods/$(http_method)/responses/$(status_code)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_rest_api(body, restapi_id)
    put_rest_api(body, restapi_id, params::Dict{String,<:Any})

A feature of the API Gateway control service for updating an existing API with an input of
external API definitions. The update can take the form of merging the supplied definition
into the existing API or overwriting the existing API.

# Arguments
- `body`: The PUT request body containing external API definitions. Currently, only OpenAPI
  definition JSON/YAML files are supported. The maximum size of the API definition file is
  6MB.
- `restapi_id`: The string identifier of the associated RestApi.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"failonwarnings"`: A query parameter to indicate whether to rollback the API update
  (true) or not (false) when a warning is encountered. The default value is false.
- `"mode"`: The mode query parameter to specify the update mode. Valid values are \"merge\"
  and \"overwrite\". By default, the update mode is \"merge\".
- `"parameters"`: Custom header parameters as part of the request. For example, to exclude
  DocumentationParts from an imported API, set ignore=documentation as a parameters value, as
  in the AWS CLI command of aws apigateway import-rest-api --parameters ignore=documentation
  --body 'file:///path/to/imported-api-body.json'.
"""
function put_rest_api(body, restapi_id; aws_config::AbstractAWSConfig=current_aws_config())
    return api_gateway(
        "PUT",
        "/restapis/$(restapi_id)",
        Dict{String,Any}("body" => body);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_rest_api(
    body,
    restapi_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "PUT",
        "/restapis/$(restapi_id)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("body" => body), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds or updates a tag on a given resource.

# Arguments
- `resource_arn`: The ARN of a resource that can be tagged.
- `tags`: The key-value map of strings. The valid character set is [a-zA-Z+-=._:/]. The tag
  key can be up to 128 characters and must not start with aws:. The tag value can be up to
  256 characters.

"""
function tag_resource(
    resource_arn, tags; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "PUT",
        "/tags/$(resource_arn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resource_arn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "PUT",
        "/tags/$(resource_arn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    test_invoke_authorizer(authorizer_id, restapi_id)
    test_invoke_authorizer(authorizer_id, restapi_id, params::Dict{String,<:Any})

Simulate the execution of an Authorizer in your RestApi with headers, parameters, and an
incoming request body.

# Arguments
- `authorizer_id`: Specifies a test invoke authorizer request's Authorizer ID.
- `restapi_id`: The string identifier of the associated RestApi.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"additionalContext"`: A key-value map of additional context variables.
- `"body"`: The simulated request body of an incoming invocation request.
- `"headers"`: A key-value map of headers to simulate an incoming invocation request. This
  is where the incoming authorization token, or identity source, should be specified.
- `"multiValueHeaders"`: The headers as a map from string to list of values to simulate an
  incoming invocation request. This is where the incoming authorization token, or identity
  source, may be specified.
- `"pathWithQueryString"`: The URI path, including query string, of the simulated
  invocation request. Use this to specify path parameters and query string parameters.
- `"stageVariables"`: A key-value map of stage variables to simulate an invocation on a
  deployed Stage.
"""
function test_invoke_authorizer(
    authorizer_id, restapi_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "POST",
        "/restapis/$(restapi_id)/authorizers/$(authorizer_id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function test_invoke_authorizer(
    authorizer_id,
    restapi_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "POST",
        "/restapis/$(restapi_id)/authorizers/$(authorizer_id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    test_invoke_method(http_method, resource_id, restapi_id)
    test_invoke_method(http_method, resource_id, restapi_id, params::Dict{String,<:Any})

Simulate the invocation of a Method in your RestApi with headers, parameters, and an
incoming request body.

# Arguments
- `http_method`: Specifies a test invoke method request's HTTP method.
- `resource_id`: Specifies a test invoke method request's resource ID.
- `restapi_id`: The string identifier of the associated RestApi.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"body"`: The simulated request body of an incoming invocation request.
- `"clientCertificateId"`: A ClientCertificate identifier to use in the test invocation.
  API Gateway will use the certificate when making the HTTPS request to the defined back-end
  endpoint.
- `"headers"`: A key-value map of headers to simulate an incoming invocation request.
- `"multiValueHeaders"`: The headers as a map from string to list of values to simulate an
  incoming invocation request.
- `"pathWithQueryString"`: The URI path, including query string, of the simulated
  invocation request. Use this to specify path parameters and query string parameters.
- `"stageVariables"`: A key-value map of stage variables to simulate an invocation on a
  deployed Stage.
"""
function test_invoke_method(
    http_method, resource_id, restapi_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "POST",
        "/restapis/$(restapi_id)/resources/$(resource_id)/methods/$(http_method)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function test_invoke_method(
    http_method,
    resource_id,
    restapi_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "POST",
        "/restapis/$(restapi_id)/resources/$(resource_id)/methods/$(http_method)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes a tag from a given resource.

# Arguments
- `resource_arn`: The ARN of a resource that can be tagged.
- `tag_keys`: The Tag keys to delete.

"""
function untag_resource(
    resource_arn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "DELETE",
        "/tags/$(resource_arn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resource_arn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "DELETE",
        "/tags/$(resource_arn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_account()
    update_account(params::Dict{String,<:Any})

Changes information about the current Account resource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"patchOperations"`: For more information about supported patch operations, see Patch
  Operations.
"""
function update_account(; aws_config::AbstractAWSConfig=current_aws_config())
    return api_gateway(
        "PATCH", "/account"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function update_account(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "PATCH", "/account", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    update_api_key(api__key)
    update_api_key(api__key, params::Dict{String,<:Any})

Changes information about an ApiKey resource.

# Arguments
- `api__key`: The identifier of the ApiKey resource to be updated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"patchOperations"`: For more information about supported patch operations, see Patch
  Operations.
"""
function update_api_key(api_Key; aws_config::AbstractAWSConfig=current_aws_config())
    return api_gateway(
        "PATCH",
        "/apikeys/$(api_Key)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_api_key(
    api_Key,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "PATCH",
        "/apikeys/$(api_Key)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_authorizer(authorizer_id, restapi_id)
    update_authorizer(authorizer_id, restapi_id, params::Dict{String,<:Any})

Updates an existing Authorizer resource.

# Arguments
- `authorizer_id`: The identifier of the Authorizer resource.
- `restapi_id`: The string identifier of the associated RestApi.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"patchOperations"`: For more information about supported patch operations, see Patch
  Operations.
"""
function update_authorizer(
    authorizer_id, restapi_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "PATCH",
        "/restapis/$(restapi_id)/authorizers/$(authorizer_id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_authorizer(
    authorizer_id,
    restapi_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "PATCH",
        "/restapis/$(restapi_id)/authorizers/$(authorizer_id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_base_path_mapping(base_path, domain_name)
    update_base_path_mapping(base_path, domain_name, params::Dict{String,<:Any})

Changes information about the BasePathMapping resource.

# Arguments
- `base_path`: The base path of the BasePathMapping resource to change. To specify an empty
  base path, set this parameter to '(none)'.
- `domain_name`: The domain name of the BasePathMapping resource to change.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"patchOperations"`: For more information about supported patch operations, see Patch
  Operations.
"""
function update_base_path_mapping(
    base_path, domain_name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "PATCH",
        "/domainnames/$(domain_name)/basepathmappings/$(base_path)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_base_path_mapping(
    base_path,
    domain_name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "PATCH",
        "/domainnames/$(domain_name)/basepathmappings/$(base_path)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_client_certificate(clientcertificate_id)
    update_client_certificate(clientcertificate_id, params::Dict{String,<:Any})

Changes information about an ClientCertificate resource.

# Arguments
- `clientcertificate_id`: The identifier of the ClientCertificate resource to be updated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"patchOperations"`: For more information about supported patch operations, see Patch
  Operations.
"""
function update_client_certificate(
    clientcertificate_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "PATCH",
        "/clientcertificates/$(clientcertificate_id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_client_certificate(
    clientcertificate_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "PATCH",
        "/clientcertificates/$(clientcertificate_id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_deployment(deployment_id, restapi_id)
    update_deployment(deployment_id, restapi_id, params::Dict{String,<:Any})

Changes information about a Deployment resource.

# Arguments
- `deployment_id`: The replacement identifier for the Deployment resource to change
  information about.
- `restapi_id`: The string identifier of the associated RestApi.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"patchOperations"`: For more information about supported patch operations, see Patch
  Operations.
"""
function update_deployment(
    deployment_id, restapi_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "PATCH",
        "/restapis/$(restapi_id)/deployments/$(deployment_id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_deployment(
    deployment_id,
    restapi_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "PATCH",
        "/restapis/$(restapi_id)/deployments/$(deployment_id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_documentation_part(part_id, restapi_id)
    update_documentation_part(part_id, restapi_id, params::Dict{String,<:Any})

Updates a documentation part.

# Arguments
- `part_id`: The identifier of the to-be-updated documentation part.
- `restapi_id`: The string identifier of the associated RestApi.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"patchOperations"`: For more information about supported patch operations, see Patch
  Operations.
"""
function update_documentation_part(
    part_id, restapi_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "PATCH",
        "/restapis/$(restapi_id)/documentation/parts/$(part_id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_documentation_part(
    part_id,
    restapi_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "PATCH",
        "/restapis/$(restapi_id)/documentation/parts/$(part_id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_documentation_version(doc_version, restapi_id)
    update_documentation_version(doc_version, restapi_id, params::Dict{String,<:Any})

Updates a documentation version.

# Arguments
- `doc_version`: The version identifier of the to-be-updated documentation version.
- `restapi_id`: The string identifier of the associated RestApi.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"patchOperations"`: For more information about supported patch operations, see Patch
  Operations.
"""
function update_documentation_version(
    doc_version, restapi_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "PATCH",
        "/restapis/$(restapi_id)/documentation/versions/$(doc_version)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_documentation_version(
    doc_version,
    restapi_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "PATCH",
        "/restapis/$(restapi_id)/documentation/versions/$(doc_version)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_domain_name(domain_name)
    update_domain_name(domain_name, params::Dict{String,<:Any})

Changes information about the DomainName resource.

# Arguments
- `domain_name`: The name of the DomainName resource to be changed.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"patchOperations"`: For more information about supported patch operations, see Patch
  Operations.
"""
function update_domain_name(domain_name; aws_config::AbstractAWSConfig=current_aws_config())
    return api_gateway(
        "PATCH",
        "/domainnames/$(domain_name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_domain_name(
    domain_name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "PATCH",
        "/domainnames/$(domain_name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_gateway_response(response_type, restapi_id)
    update_gateway_response(response_type, restapi_id, params::Dict{String,<:Any})

Updates a GatewayResponse of a specified response type on the given RestApi.

# Arguments
- `response_type`: The response type of the associated GatewayResponse.
- `restapi_id`: The string identifier of the associated RestApi.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"patchOperations"`: For more information about supported patch operations, see Patch
  Operations.
"""
function update_gateway_response(
    response_type, restapi_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "PATCH",
        "/restapis/$(restapi_id)/gatewayresponses/$(response_type)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_gateway_response(
    response_type,
    restapi_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "PATCH",
        "/restapis/$(restapi_id)/gatewayresponses/$(response_type)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_integration(http_method, resource_id, restapi_id)
    update_integration(http_method, resource_id, restapi_id, params::Dict{String,<:Any})

Represents an update integration.

# Arguments
- `http_method`: Represents an update integration request's HTTP method.
- `resource_id`: Represents an update integration request's resource identifier.
- `restapi_id`: The string identifier of the associated RestApi.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"patchOperations"`: For more information about supported patch operations, see Patch
  Operations.
"""
function update_integration(
    http_method, resource_id, restapi_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "PATCH",
        "/restapis/$(restapi_id)/resources/$(resource_id)/methods/$(http_method)/integration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_integration(
    http_method,
    resource_id,
    restapi_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "PATCH",
        "/restapis/$(restapi_id)/resources/$(resource_id)/methods/$(http_method)/integration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_integration_response(http_method, resource_id, restapi_id, status_code)
    update_integration_response(http_method, resource_id, restapi_id, status_code, params::Dict{String,<:Any})

Represents an update integration response.

# Arguments
- `http_method`: Specifies an update integration response request's HTTP method.
- `resource_id`: Specifies an update integration response request's resource identifier.
- `restapi_id`: The string identifier of the associated RestApi.
- `status_code`: Specifies an update integration response request's status code.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"patchOperations"`: For more information about supported patch operations, see Patch
  Operations.
"""
function update_integration_response(
    http_method,
    resource_id,
    restapi_id,
    status_code;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "PATCH",
        "/restapis/$(restapi_id)/resources/$(resource_id)/methods/$(http_method)/integration/responses/$(status_code)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_integration_response(
    http_method,
    resource_id,
    restapi_id,
    status_code,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "PATCH",
        "/restapis/$(restapi_id)/resources/$(resource_id)/methods/$(http_method)/integration/responses/$(status_code)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_method(http_method, resource_id, restapi_id)
    update_method(http_method, resource_id, restapi_id, params::Dict{String,<:Any})

Updates an existing Method resource.

# Arguments
- `http_method`: The HTTP verb of the Method resource.
- `resource_id`: The Resource identifier for the Method resource.
- `restapi_id`: The string identifier of the associated RestApi.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"patchOperations"`: For more information about supported patch operations, see Patch
  Operations.
"""
function update_method(
    http_method, resource_id, restapi_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "PATCH",
        "/restapis/$(restapi_id)/resources/$(resource_id)/methods/$(http_method)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_method(
    http_method,
    resource_id,
    restapi_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "PATCH",
        "/restapis/$(restapi_id)/resources/$(resource_id)/methods/$(http_method)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_method_response(http_method, resource_id, restapi_id, status_code)
    update_method_response(http_method, resource_id, restapi_id, status_code, params::Dict{String,<:Any})

Updates an existing MethodResponse resource.

# Arguments
- `http_method`: The HTTP verb of the Method resource.
- `resource_id`: The Resource identifier for the MethodResponse resource.
- `restapi_id`: The string identifier of the associated RestApi.
- `status_code`: The status code for the MethodResponse resource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"patchOperations"`: For more information about supported patch operations, see Patch
  Operations.
"""
function update_method_response(
    http_method,
    resource_id,
    restapi_id,
    status_code;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "PATCH",
        "/restapis/$(restapi_id)/resources/$(resource_id)/methods/$(http_method)/responses/$(status_code)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_method_response(
    http_method,
    resource_id,
    restapi_id,
    status_code,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "PATCH",
        "/restapis/$(restapi_id)/resources/$(resource_id)/methods/$(http_method)/responses/$(status_code)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_model(model_name, restapi_id)
    update_model(model_name, restapi_id, params::Dict{String,<:Any})

Changes information about a model. The maximum size of the model is 400 KB.

# Arguments
- `model_name`: The name of the model to update.
- `restapi_id`: The string identifier of the associated RestApi.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"patchOperations"`: For more information about supported patch operations, see Patch
  Operations.
"""
function update_model(
    model_name, restapi_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "PATCH",
        "/restapis/$(restapi_id)/models/$(model_name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_model(
    model_name,
    restapi_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "PATCH",
        "/restapis/$(restapi_id)/models/$(model_name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_request_validator(requestvalidator_id, restapi_id)
    update_request_validator(requestvalidator_id, restapi_id, params::Dict{String,<:Any})

Updates a RequestValidator of a given RestApi.

# Arguments
- `requestvalidator_id`: The identifier of RequestValidator to be updated.
- `restapi_id`: The string identifier of the associated RestApi.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"patchOperations"`: For more information about supported patch operations, see Patch
  Operations.
"""
function update_request_validator(
    requestvalidator_id, restapi_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "PATCH",
        "/restapis/$(restapi_id)/requestvalidators/$(requestvalidator_id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_request_validator(
    requestvalidator_id,
    restapi_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "PATCH",
        "/restapis/$(restapi_id)/requestvalidators/$(requestvalidator_id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_resource(resource_id, restapi_id)
    update_resource(resource_id, restapi_id, params::Dict{String,<:Any})

Changes information about a Resource resource.

# Arguments
- `resource_id`: The identifier of the Resource resource.
- `restapi_id`: The string identifier of the associated RestApi.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"patchOperations"`: For more information about supported patch operations, see Patch
  Operations.
"""
function update_resource(
    resource_id, restapi_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "PATCH",
        "/restapis/$(restapi_id)/resources/$(resource_id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_resource(
    resource_id,
    restapi_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "PATCH",
        "/restapis/$(restapi_id)/resources/$(resource_id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_rest_api(restapi_id)
    update_rest_api(restapi_id, params::Dict{String,<:Any})

Changes information about the specified API.

# Arguments
- `restapi_id`: The string identifier of the associated RestApi.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"patchOperations"`: For more information about supported patch operations, see Patch
  Operations.
"""
function update_rest_api(restapi_id; aws_config::AbstractAWSConfig=current_aws_config())
    return api_gateway(
        "PATCH",
        "/restapis/$(restapi_id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_rest_api(
    restapi_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "PATCH",
        "/restapis/$(restapi_id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_stage(restapi_id, stage_name)
    update_stage(restapi_id, stage_name, params::Dict{String,<:Any})

Changes information about a Stage resource.

# Arguments
- `restapi_id`: The string identifier of the associated RestApi.
- `stage_name`: The name of the Stage resource to change information about.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"patchOperations"`: For more information about supported patch operations, see Patch
  Operations.
"""
function update_stage(
    restapi_id, stage_name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "PATCH",
        "/restapis/$(restapi_id)/stages/$(stage_name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_stage(
    restapi_id,
    stage_name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "PATCH",
        "/restapis/$(restapi_id)/stages/$(stage_name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_usage(key_id, usageplan_id)
    update_usage(key_id, usageplan_id, params::Dict{String,<:Any})

Grants a temporary extension to the remaining quota of a usage plan associated with a
specified API key.

# Arguments
- `key_id`: The identifier of the API key associated with the usage plan in which a
  temporary extension is granted to the remaining quota.
- `usageplan_id`: The Id of the usage plan associated with the usage data.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"patchOperations"`: For more information about supported patch operations, see Patch
  Operations.
"""
function update_usage(
    keyId, usageplanId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return api_gateway(
        "PATCH",
        "/usageplans/$(usageplanId)/keys/$(keyId)/usage";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_usage(
    keyId,
    usageplanId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "PATCH",
        "/usageplans/$(usageplanId)/keys/$(keyId)/usage",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_usage_plan(usageplan_id)
    update_usage_plan(usageplan_id, params::Dict{String,<:Any})

Updates a usage plan of a given plan Id.

# Arguments
- `usageplan_id`: The Id of the to-be-updated usage plan.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"patchOperations"`: For more information about supported patch operations, see Patch
  Operations.
"""
function update_usage_plan(usageplanId; aws_config::AbstractAWSConfig=current_aws_config())
    return api_gateway(
        "PATCH",
        "/usageplans/$(usageplanId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_usage_plan(
    usageplanId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "PATCH",
        "/usageplans/$(usageplanId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_vpc_link(vpclink_id)
    update_vpc_link(vpclink_id, params::Dict{String,<:Any})

Updates an existing VpcLink of a specified identifier.

# Arguments
- `vpclink_id`: The identifier of the VpcLink. It is used in an Integration to reference
  this VpcLink.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"patchOperations"`: For more information about supported patch operations, see Patch
  Operations.
"""
function update_vpc_link(vpclink_id; aws_config::AbstractAWSConfig=current_aws_config())
    return api_gateway(
        "PATCH",
        "/vpclinks/$(vpclink_id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_vpc_link(
    vpclink_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return api_gateway(
        "PATCH",
        "/vpclinks/$(vpclink_id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

@testset "query service" begin
    @testset "STS" begin
        @test AWSServices.sts isa AWS.QueryService

        @testset "high-level" begin
            response = STS.get_caller_identity()
            d = response["GetCallerIdentityResult"]

            @test Set(keys(d)) == Set(["Arn", "UserId", "Account"])
            @test occursin(r"^arn:aws:(iam|sts):", d["Arn"])
            @test all(isdigit, d["Account"])
        end

        @testset "low-level" begin
            response = AWSServices.sts("GetCallerIdentity")
            d = response["GetCallerIdentityResult"]

            @test Set(keys(d)) == Set(["Arn", "UserId", "Account"])
            @test occursin(r"^arn:aws:(iam|sts):", d["Arn"])
            @test all(isdigit, d["Account"])
        end
    end

    @testset "IAM" begin
        @test AWSServices.iam isa AWS.QueryService

        @testset "high-level" begin
            policy_arn = ""
            expected_policy_name = "aws-jl-test---" * _now_formatted()
            expected_policy_document = LittleDict(
                "Version" => "2012-10-17",
                "Statement" => [
                    LittleDict(
                        "Effect" => "Allow",
                        "Action" => ["s3:Get*", "s3:List*"],
                        "Resource" => ["arn:aws:s3:::my-bucket/shared/*"],
                    ),
                ],
            )
            expected_policy_document = JSON.json(expected_policy_document)

            response = IAM.create_policy(expected_policy_document, expected_policy_name)
            policy_arn = response["CreatePolicyResult"]["Policy"]["Arn"]

            try
                response_policy_version = IAM.get_policy_version(policy_arn, "v1")
                response_document = response_policy_version["GetPolicyVersionResult"]["PolicyVersion"]["Document"]
                @test HTTP.unescapeuri(response_document) == expected_policy_document
            finally
                IAM.delete_policy(policy_arn)
            end

            @test_throws AWSException IAM.get_policy(policy_arn)
        end

        @testset "low-level" begin
            policy_arn = ""
            expected_policy_name = "aws-jl-test---" * _now_formatted()
            expected_policy_document = LittleDict(
                "Version" => "2012-10-17",
                "Statement" => [
                    LittleDict(
                        "Effect" => "Allow",
                        "Action" => ["s3:Get*", "s3:List*"],
                        "Resource" => ["arn:aws:s3:::my-bucket/shared/*"],
                    ),
                ],
            )
            expected_policy_document = JSON.json(expected_policy_document)

            response = AWSServices.iam(
                "CreatePolicy",
                LittleDict(
                    "PolicyName" => expected_policy_name,
                    "PolicyDocument" => expected_policy_document,
                ),
            )
            policy_arn = response["CreatePolicyResult"]["Policy"]["Arn"]

            try
                response_policy_version = AWSServices.iam(
                    "GetPolicyVersion",
                    LittleDict("PolicyArn" => policy_arn, "VersionId" => "v1"),
                )
                response_document = response_policy_version["GetPolicyVersionResult"]["PolicyVersion"]["Document"]
                @test HTTP.unescapeuri(response_document) == expected_policy_document
            finally
                AWSServices.iam("DeletePolicy", LittleDict("PolicyArn" => policy_arn))
            end

            @test_throws AWSException AWSServices.iam(
                "GetPolicy", LittleDict("PolicyArn" => policy_arn)
            )
        end
    end
end

@testset "JSON service" begin
    @testset "Secrets Manager" begin
        @test AWSServices.secrets_manager isa AWS.JSONService

        @testset "high-level" begin
            secret_name = "aws-jl-test---" * _now_formatted()
            secret_string = "sshhh it is a secret!"

            function _get_secret_string(secret_name)
                response = Secrets_Manager.get_secret_value(secret_name)

                return response["SecretString"]
            end

            Secrets_Manager.create_secret(
                secret_name,
                LittleDict(
                    "SecretString" => secret_string, "ClientRequestToken" => string(uuid4())
                ),
            )

            try
                @test _get_secret_string(secret_name) == secret_string
            finally
                Secrets_Manager.delete_secret(
                    secret_name, LittleDict("ForceDeleteWithoutRecovery" => "true")
                )
            end

            @test_throws AWSException _get_secret_string(secret_name)
        end

        @testset "low-level" begin
            secret_name = "aws-jl-test---" * _now_formatted()
            secret_string = "sshhh it is a secret!"

            function _get_secret_string(secret_name)
                response = AWSServices.secrets_manager(
                    "GetSecretValue", LittleDict("SecretId" => secret_name)
                )

                return response["SecretString"]
            end

            resp = AWSServices.secrets_manager(
                "CreateSecret",
                LittleDict(
                    "Name" => secret_name,
                    "SecretString" => secret_string,
                    "ClientRequestToken" => string(uuid4()),
                ),
            )

            try
                @test _get_secret_string(secret_name) == secret_string
            finally
                AWSServices.secrets_manager(
                    "DeleteSecret",
                    LittleDict(
                        "SecretId" => secret_name, "ForceDeleteWithoutRecovery" => "true"
                    ),
                )
            end

            @test_throws AWSException _get_secret_string(secret_name)
        end
    end

    @testset "SQS" begin
        @test AWSServices.sqs isa AWS.JSONService

        @testset "high-level" begin
            queue_name = "aws-jl-test---" * _now_formatted()
            expected_message = "Hello for AWS.jl"

            function _get_queue_url(queue_name)
                result = SQS.get_queue_url(queue_name)

                return result["QueueUrl"]
            end

            # Create Queue
            SQS.create_queue(queue_name)
            queue_url = _get_queue_url(queue_name)

            try
                # Get Queues
                @test !isempty(queue_url)

                # Change Message Visibility Batch Request
                expected_message_id = "aws-jl-test"

                SQS.send_message(expected_message, queue_url)

                response = SQS.receive_message(queue_url)
                receipt_handle = only(response["Messages"])["ReceiptHandle"]

                response = SQS.delete_message_batch(
                    [
                        LittleDict(
                            "Id" => expected_message_id, "ReceiptHandle" => receipt_handle
                        ),
                    ],
                    queue_url,
                )

                message_id = only(response["Successful"])["Id"]
                @test message_id == expected_message_id

                SQS.send_message(expected_message, queue_url)

                result = SQS.receive_message(queue_url)
                message = only(result["Messages"])["Body"]
                @test message == expected_message
            finally
                SQS.delete_queue(queue_url)
            end

            @test_throws AWSException _get_queue_url(queue_name)
        end

        @testset "low-level" begin
            queue_name = "aws-jl-test---" * _now_formatted()
            expected_message = "Hello for AWS.jl"

            function _get_queue_url(queue_name)
                result = AWSServices.sqs(
                    "GetQueueUrl", LittleDict("QueueName" => queue_name)
                )

                return result["QueueUrl"]
            end

            # Create Queue
            AWSServices.sqs("CreateQueue", LittleDict("QueueName" => queue_name))

            queue_url = _get_queue_url(queue_name)
            @test !isempty(queue_url)

            try
                # Change Message Visibility Batch Request
                expected_message_id = "aws-jl-test"

                AWSServices.sqs(
                    "SendMessage",
                    LittleDict("QueueUrl" => queue_url, "MessageBody" => expected_message),
                )

                response = AWSServices.sqs(
                    "ReceiveMessage", LittleDict("QueueUrl" => queue_url)
                )
                receipt_handle = only(response["Messages"])["ReceiptHandle"]

                response = AWSServices.sqs(
                    "DeleteMessageBatch",
                    LittleDict(
                        "QueueUrl" => queue_url,
                        "Entries" => [
                            LittleDict(
                                "Id" => expected_message_id,
                                "ReceiptHandle" => receipt_handle,
                            ),
                        ],
                    ),
                )

                message_id = only(response["Successful"])["Id"]
                @test message_id == expected_message_id

                # Send message
                AWSServices.sqs(
                    "SendMessage",
                    LittleDict("QueueUrl" => queue_url, "MessageBody" => expected_message),
                )

                # Receive Message
                result = AWSServices.sqs(
                    "ReceiveMessage", LittleDict("QueueUrl" => queue_url)
                )
                message = only(result["Messages"])["Body"]
                @test message == expected_message
            finally
                AWSServices.sqs("DeleteQueue", LittleDict("QueueUrl" => queue_url))
            end

            @test_throws AWSException _get_queue_url(queue_name)
        end
    end
end

@testset "Rest XML" begin
    @testset "S3" begin
        @test AWSServices.s3 isa RestXMLService

        @testset "high-level" begin
            bucket_name = "aws-jl-test---" * _now_formatted()
            file_name = string(uuid4())

            function _bucket_exists(bucket_name)
                try
                    S3.head_bucket(bucket_name)
                    return true
                catch e
                    if e isa AWSException && e.cause.status == 404
                        return false
                    else
                        rethrow(e)
                    end
                end
            end

            # HEAD operation
            @test _bucket_exists(bucket_name) == false

            # PUT operation
            S3.create_bucket(bucket_name)
            @test _bucket_exists(bucket_name)

            try
                # PUT with parameters operation
                body = "sample-file-body"
                S3.put_object(bucket_name, file_name, Dict("body" => body))
                @test !isempty(S3.get_object(bucket_name, file_name))

                # GET operation
                result = S3.list_objects(bucket_name)
                @test result["Contents"]["Key"] == file_name

                # GET with parameters operation
                max_keys = 1
                result = S3.list_objects(bucket_name, Dict("max_keys" => max_keys))
                @test length([result["Contents"]]) == max_keys

                # GET with an IO target
                mktemp() do f, io
                    S3.get_object(bucket_name, file_name, Dict("response_stream" => io))
                    flush(io)
                    @test read(f, String) == body
                end
            finally
                # DELETE with parameters operation
                S3.delete_object(bucket_name, file_name)
                @test_throws AWSException S3.get_object(bucket_name, file_name)

                # DELETE operation
                S3.delete_bucket(bucket_name)

                sleep(2)
            end

            @test _bucket_exists(bucket_name) == false
        end

        @testset "low-level" begin
            bucket_name = "aws-jl-test---" * _now_formatted()
            file_name = "*)=('! +@,:.txt"  # Special characters which S3 allows

            function _bucket_exists(bucket_name)
                try
                    AWSServices.s3("HEAD", "/$bucket_name")
                    return true
                catch e
                    if e isa AWSException && e.cause.status == 404
                        return false
                    else
                        rethrow(e)
                    end
                end
            end

            # HEAD operation
            @test _bucket_exists(bucket_name) == false

            # PUT operation
            AWSServices.s3("PUT", "/$bucket_name")
            @test _bucket_exists(bucket_name)

            try
                # PUT with parameters operation
                body = Array{UInt8}("sample-file-body")
                AWSServices.s3("PUT", "/$bucket_name/$file_name", Dict("body" => body))
                @test AWSServices.s3("GET", "/$bucket_name/$file_name") == body

                # GET operation
                result = AWSServices.s3("GET", "/$bucket_name")
                @test result["Contents"]["Key"] == file_name

                # GET with parameters operation
                max_keys = 1
                result = AWSServices.s3(
                    "GET", "/$bucket_name", Dict("max_keys" => max_keys)
                )
                @test length([result["Contents"]]) == max_keys

                # POST with parameters operation
                body = """
                    <Delete xmlns="http://s3.amazonaws.com/doc/2006-03-01/">
                        <Object>
                            <Key>$file_name</Key>
                        </Object>
                    </Delete>
                    """

                AWSServices.s3("POST", "/$bucket_name?delete", Dict("body" => body))
                @test_throws AWSException AWSServices.s3("GET", "/$bucket_name/$file_name")
            finally
                # DELETE operation
                AWSServices.s3("DELETE", "/$bucket_name")

                sleep(2)
            end

            @test _bucket_exists(bucket_name) == false
        end

        @testset "additional operations" begin
            bucket_name = "aws-jl-test---" * _now_formatted()

            # Testing a file name with various special & Unicode characters
            file_name = "$(uuid4())/📁!!/@ +*"

            function _bucket_exists(bucket_name)
                try
                    S3.head_bucket(bucket_name)
                    return true
                catch e
                    if e isa AWSException && e.cause.status == 404
                        return false
                    else
                        rethrow(e)
                    end
                end
            end

            # HEAD operation
            @test _bucket_exists(bucket_name) == false

            # PUT operation
            S3.create_bucket(bucket_name)
            @test _bucket_exists(bucket_name)

            try
                # PUT with parameters operation
                body = "sample-file-body"
                S3.put_object(bucket_name, file_name, Dict("body" => body))
                @test !isempty(S3.get_object(bucket_name, file_name))

                # GET operation
                result = S3.list_objects(bucket_name)
                @test result["Contents"]["Key"] == file_name
            finally
                # DELETE the file, check that it's gone, and then DELETE the bucket
                S3.delete_object(bucket_name, file_name)
                @test_throws AWSException S3.get_object(bucket_name, file_name)
                S3.delete_bucket(bucket_name)
                sleep(2)
            end

            @test _bucket_exists(bucket_name) == false
        end
    end
end

@testset "Rest JSON" begin
    @testset "Glacier" begin
        @test AWSServices.glacier isa RestJSONService

        function wait_for_vault_deletion(vault_name)
            timedwait(60; pollint=5) do
                result = Glacier.list_vaults("-")
                available_vault_names = [v["VaultName"] for v in result["VaultList"]]
                return !(vault_name in available_vault_names)
            end
        end

        @testset "high-level" begin
            timestamp = _now_formatted()
            vault_names = ["aws-jl-test-01---$timestamp", "aws-jl-test-02---$timestamp"]

            # PUT
            for vault in vault_names
                Glacier.create_vault("-", vault)
            end

            try
                # POST
                tags = Dict(
                    "Tags" => LittleDict("Tag-01" => "Tag-01", "Tag-02" => "Tag-02")
                )

                for vault in vault_names
                    Glacier.add_tags_to_vault("-", vault, tags)
                end

                for vault in vault_names
                    result_tags = Glacier.list_tags_for_vault("-", vault)
                    @test result_tags == tags
                end

                # GET
                # If this is an Integer AWS Coral cannot convert it to a String
                # "class com.amazon.coral.value.json.numbers.TruncatingBigNumber can not be converted to an String"
                limit = "1"
                args = LittleDict("limit" => limit)
                result = Glacier.list_vaults("-", args)
                @test length(result["VaultList"]) == parse(Int, limit)
            finally
                # DELETE
                for vault in vault_names
                    Glacier.delete_vault("-", vault)
                end
            end

            for vault_name in vault_names
                @test wait_for_vault_deletion(vault_name) === :ok
            end
        end

        @testset "low-level" begin
            timestamp = _now_formatted()
            vault_names = ["aws-jl-test-01---$timestamp", "aws-jl-test-02---$timestamp"]

            # PUT
            for vault in vault_names
                AWSServices.glacier("PUT", "/-/vaults/$vault")
            end

            try
                # POST
                tags = Dict(
                    "Tags" => LittleDict("Tag-01" => "Tag-01", "Tag-02" => "Tag-02")
                )

                for vault in vault_names
                    AWSServices.glacier("POST", "/-/vaults/$vault/tags?operation=add", tags)
                end

                for vault in vault_names
                    result_tags = AWSServices.glacier("GET", "/-/vaults/$vault/tags")

                    @test result_tags == tags
                end

                # GET
                # If this is an Integer AWS Coral cannot convert it to a String
                # "class com.amazon.coral.value.json.numbers.TruncatingBigNumber can not be converted to an String"
                limit = "1"
                params = LittleDict("limit" => limit)
                result = AWSServices.glacier("GET", "/-/vaults/", params)

                @test length(result["VaultList"]) == parse(Int, limit)
            finally
                # DELETE
                for vault in vault_names
                    AWSServices.glacier("DELETE", "/-/vaults/$vault")
                end
            end

            for vault_name in vault_names
                @test wait_for_vault_deletion(vault_name) === :ok
            end
        end
    end
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: fis
using AWS.Compat
using AWS.UUIDs

"""
    create_experiment_template(actions, client_token, description, role_arn, stop_conditions)
    create_experiment_template(actions, client_token, description, role_arn, stop_conditions, params::Dict{String,<:Any})

Creates an experiment template.  An experiment template includes the following components:
  Targets: A target can be a specific resource in your Amazon Web Services environment, or
one or more resources that match criteria that you specify, for example, resources that
have specific tags.    Actions: The actions to carry out on the target. You can specify
multiple actions, the duration of each action, and when to start each action during an
experiment.    Stop conditions: If a stop condition is triggered while an experiment is
running, the experiment is automatically stopped. You can define a stop condition as a
CloudWatch alarm.   For more information, see experiment templates in the Fault Injection
Service User Guide.

# Arguments
- `actions`: The actions for the experiment.
- `client_token`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request.
- `description`: A description for the experiment template.
- `role_arn`: The Amazon Resource Name (ARN) of an IAM role that grants the FIS service
  permission to perform service actions on your behalf.
- `stop_conditions`: The stop conditions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"experimentOptions"`: The experiment options for the experiment template.
- `"logConfiguration"`: The configuration for experiment logging.
- `"tags"`: The tags to apply to the experiment template.
- `"targets"`: The targets for the experiment.
"""
function create_experiment_template(
    actions,
    clientToken,
    description,
    roleArn,
    stopConditions;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fis(
        "POST",
        "/experimentTemplates",
        Dict{String,Any}(
            "actions" => actions,
            "clientToken" => clientToken,
            "description" => description,
            "roleArn" => roleArn,
            "stopConditions" => stopConditions,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_experiment_template(
    actions,
    clientToken,
    description,
    roleArn,
    stopConditions,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fis(
        "POST",
        "/experimentTemplates",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "actions" => actions,
                    "clientToken" => clientToken,
                    "description" => description,
                    "roleArn" => roleArn,
                    "stopConditions" => stopConditions,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_target_account_configuration(account_id, id, role_arn)
    create_target_account_configuration(account_id, id, role_arn, params::Dict{String,<:Any})

Creates a target account configuration for the experiment template. A target account
configuration is required when accountTargeting of experimentOptions is set to
multi-account. For more information, see experiment options in the Fault Injection Service
User Guide.

# Arguments
- `account_id`: The Amazon Web Services account ID of the target account.
- `id`: The experiment template ID.
- `role_arn`: The Amazon Resource Name (ARN) of an IAM role for the target account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request.
- `"description"`: The description of the target account.
"""
function create_target_account_configuration(
    accountId, id, roleArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fis(
        "POST",
        "/experimentTemplates/$(id)/targetAccountConfigurations/$(accountId)",
        Dict{String,Any}("roleArn" => roleArn, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_target_account_configuration(
    accountId,
    id,
    roleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fis(
        "POST",
        "/experimentTemplates/$(id)/targetAccountConfigurations/$(accountId)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("roleArn" => roleArn, "clientToken" => string(uuid4())),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_experiment_template(id)
    delete_experiment_template(id, params::Dict{String,<:Any})

Deletes the specified experiment template.

# Arguments
- `id`: The ID of the experiment template.

"""
function delete_experiment_template(id; aws_config::AbstractAWSConfig=current_aws_config())
    return fis(
        "DELETE",
        "/experimentTemplates/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_experiment_template(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fis(
        "DELETE",
        "/experimentTemplates/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_target_account_configuration(account_id, id)
    delete_target_account_configuration(account_id, id, params::Dict{String,<:Any})

Deletes the specified target account configuration of the experiment template.

# Arguments
- `account_id`: The Amazon Web Services account ID of the target account.
- `id`: The ID of the experiment template.

"""
function delete_target_account_configuration(
    accountId, id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fis(
        "DELETE",
        "/experimentTemplates/$(id)/targetAccountConfigurations/$(accountId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_target_account_configuration(
    accountId,
    id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fis(
        "DELETE",
        "/experimentTemplates/$(id)/targetAccountConfigurations/$(accountId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_action(id)
    get_action(id, params::Dict{String,<:Any})

Gets information about the specified FIS action.

# Arguments
- `id`: The ID of the action.

"""
function get_action(id; aws_config::AbstractAWSConfig=current_aws_config())
    return fis(
        "GET", "/actions/$(id)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_action(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fis(
        "GET",
        "/actions/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_experiment(id)
    get_experiment(id, params::Dict{String,<:Any})

Gets information about the specified experiment.

# Arguments
- `id`: The ID of the experiment.

"""
function get_experiment(id; aws_config::AbstractAWSConfig=current_aws_config())
    return fis(
        "GET", "/experiments/$(id)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_experiment(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fis(
        "GET",
        "/experiments/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_experiment_target_account_configuration(account_id, id)
    get_experiment_target_account_configuration(account_id, id, params::Dict{String,<:Any})

Gets information about the specified target account configuration of the experiment.

# Arguments
- `account_id`: The Amazon Web Services account ID of the target account.
- `id`: The ID of the experiment.

"""
function get_experiment_target_account_configuration(
    accountId, id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fis(
        "GET",
        "/experiments/$(id)/targetAccountConfigurations/$(accountId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_experiment_target_account_configuration(
    accountId,
    id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fis(
        "GET",
        "/experiments/$(id)/targetAccountConfigurations/$(accountId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_experiment_template(id)
    get_experiment_template(id, params::Dict{String,<:Any})

Gets information about the specified experiment template.

# Arguments
- `id`: The ID of the experiment template.

"""
function get_experiment_template(id; aws_config::AbstractAWSConfig=current_aws_config())
    return fis(
        "GET",
        "/experimentTemplates/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_experiment_template(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fis(
        "GET",
        "/experimentTemplates/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_target_account_configuration(account_id, id)
    get_target_account_configuration(account_id, id, params::Dict{String,<:Any})

Gets information about the specified target account configuration of the experiment
template.

# Arguments
- `account_id`: The Amazon Web Services account ID of the target account.
- `id`: The ID of the experiment template.

"""
function get_target_account_configuration(
    accountId, id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fis(
        "GET",
        "/experimentTemplates/$(id)/targetAccountConfigurations/$(accountId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_target_account_configuration(
    accountId,
    id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fis(
        "GET",
        "/experimentTemplates/$(id)/targetAccountConfigurations/$(accountId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_target_resource_type(resource_type)
    get_target_resource_type(resource_type, params::Dict{String,<:Any})

Gets information about the specified resource type.

# Arguments
- `resource_type`: The resource type.

"""
function get_target_resource_type(
    resourceType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fis(
        "GET",
        "/targetResourceTypes/$(resourceType)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_target_resource_type(
    resourceType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fis(
        "GET",
        "/targetResourceTypes/$(resourceType)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_actions()
    list_actions(params::Dict{String,<:Any})

Lists the available FIS actions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return with a single call. To retrieve
  the remaining results, make another call with the returned nextToken value.
- `"nextToken"`: The token for the next page of results.
"""
function list_actions(; aws_config::AbstractAWSConfig=current_aws_config())
    return fis("GET", "/actions"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_actions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fis(
        "GET", "/actions", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_experiment_resolved_targets(id)
    list_experiment_resolved_targets(id, params::Dict{String,<:Any})

Lists the resolved targets information of the specified experiment.

# Arguments
- `id`: The ID of the experiment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return with a single call. To retrieve
  the remaining results, make another call with the returned nextToken value.
- `"nextToken"`: The token for the next page of results.
- `"targetName"`: The name of the target.
"""
function list_experiment_resolved_targets(
    id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fis(
        "GET",
        "/experiments/$(id)/resolvedTargets";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_experiment_resolved_targets(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fis(
        "GET",
        "/experiments/$(id)/resolvedTargets",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_experiment_target_account_configurations(id)
    list_experiment_target_account_configurations(id, params::Dict{String,<:Any})

Lists the target account configurations of the specified experiment.

# Arguments
- `id`: The ID of the experiment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: The token for the next page of results.
"""
function list_experiment_target_account_configurations(
    id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fis(
        "GET",
        "/experiments/$(id)/targetAccountConfigurations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_experiment_target_account_configurations(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fis(
        "GET",
        "/experiments/$(id)/targetAccountConfigurations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_experiment_templates()
    list_experiment_templates(params::Dict{String,<:Any})

Lists your experiment templates.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return with a single call. To retrieve
  the remaining results, make another call with the returned nextToken value.
- `"nextToken"`: The token for the next page of results.
"""
function list_experiment_templates(; aws_config::AbstractAWSConfig=current_aws_config())
    return fis(
        "GET",
        "/experimentTemplates";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_experiment_templates(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fis(
        "GET",
        "/experimentTemplates",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_experiments()
    list_experiments(params::Dict{String,<:Any})

Lists your experiments.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"experimentTemplateId"`: The ID of the experiment template.
- `"maxResults"`: The maximum number of results to return with a single call. To retrieve
  the remaining results, make another call with the returned nextToken value.
- `"nextToken"`: The token for the next page of results.
"""
function list_experiments(; aws_config::AbstractAWSConfig=current_aws_config())
    return fis(
        "GET", "/experiments"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_experiments(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fis(
        "GET",
        "/experiments",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists the tags for the specified resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fis(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fis(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_target_account_configurations(id)
    list_target_account_configurations(id, params::Dict{String,<:Any})

Lists the target account configurations of the specified experiment template.

# Arguments
- `id`: The ID of the experiment template.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return with a single call. To retrieve
  the remaining results, make another call with the returned nextToken value.
- `"nextToken"`: The token for the next page of results.
"""
function list_target_account_configurations(
    id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fis(
        "GET",
        "/experimentTemplates/$(id)/targetAccountConfigurations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_target_account_configurations(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fis(
        "GET",
        "/experimentTemplates/$(id)/targetAccountConfigurations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_target_resource_types()
    list_target_resource_types(params::Dict{String,<:Any})

Lists the target resource types.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return with a single call. To retrieve
  the remaining results, make another call with the returned nextToken value.
- `"nextToken"`: The token for the next page of results.
"""
function list_target_resource_types(; aws_config::AbstractAWSConfig=current_aws_config())
    return fis(
        "GET",
        "/targetResourceTypes";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_target_resource_types(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fis(
        "GET",
        "/targetResourceTypes",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_experiment(client_token, experiment_template_id)
    start_experiment(client_token, experiment_template_id, params::Dict{String,<:Any})

Starts running an experiment from the specified experiment template.

# Arguments
- `client_token`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request.
- `experiment_template_id`: The ID of the experiment template.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"experimentOptions"`: The experiment options for running the experiment.
- `"tags"`: The tags to apply to the experiment.
"""
function start_experiment(
    clientToken, experimentTemplateId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fis(
        "POST",
        "/experiments",
        Dict{String,Any}(
            "clientToken" => clientToken, "experimentTemplateId" => experimentTemplateId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_experiment(
    clientToken,
    experimentTemplateId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fis(
        "POST",
        "/experiments",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "clientToken" => clientToken,
                    "experimentTemplateId" => experimentTemplateId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_experiment(id)
    stop_experiment(id, params::Dict{String,<:Any})

Stops the specified experiment.

# Arguments
- `id`: The ID of the experiment.

"""
function stop_experiment(id; aws_config::AbstractAWSConfig=current_aws_config())
    return fis(
        "DELETE",
        "/experiments/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_experiment(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fis(
        "DELETE",
        "/experiments/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Applies the specified tags to the specified resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.
- `tags`: The tags for the resource.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return fis(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fis(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn)
    untag_resource(resource_arn, params::Dict{String,<:Any})

Removes the specified tags from the specified resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tagKeys"`: The tag keys to remove.
"""
function untag_resource(resourceArn; aws_config::AbstractAWSConfig=current_aws_config())
    return fis(
        "DELETE",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fis(
        "DELETE",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_experiment_template(id)
    update_experiment_template(id, params::Dict{String,<:Any})

Updates the specified experiment template.

# Arguments
- `id`: The ID of the experiment template.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"actions"`: The actions for the experiment.
- `"description"`: A description for the template.
- `"experimentOptions"`: The experiment options for the experiment template.
- `"logConfiguration"`: The configuration for experiment logging.
- `"roleArn"`: The Amazon Resource Name (ARN) of an IAM role that grants the FIS service
  permission to perform service actions on your behalf.
- `"stopConditions"`: The stop conditions for the experiment.
- `"targets"`: The targets for the experiment.
"""
function update_experiment_template(id; aws_config::AbstractAWSConfig=current_aws_config())
    return fis(
        "PATCH",
        "/experimentTemplates/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_experiment_template(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fis(
        "PATCH",
        "/experimentTemplates/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_target_account_configuration(account_id, id)
    update_target_account_configuration(account_id, id, params::Dict{String,<:Any})

Updates the target account configuration for the specified experiment template.

# Arguments
- `account_id`: The Amazon Web Services account ID of the target account.
- `id`: The ID of the experiment template.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description of the target account.
- `"roleArn"`: The Amazon Resource Name (ARN) of an IAM role for the target account.
"""
function update_target_account_configuration(
    accountId, id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return fis(
        "PATCH",
        "/experimentTemplates/$(id)/targetAccountConfigurations/$(accountId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_target_account_configuration(
    accountId,
    id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return fis(
        "PATCH",
        "/experimentTemplates/$(id)/targetAccountConfigurations/$(accountId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: cleanroomsml
using AWS.Compat
using AWS.UUIDs

"""
    create_audience_model(name, training_dataset_arn)
    create_audience_model(name, training_dataset_arn, params::Dict{String,<:Any})

Defines the information necessary to create an audience model. An audience model is a
machine learning model that Clean Rooms ML trains to measure similarity between users.
Clean Rooms ML manages training and storing the audience model. The audience model can be
used in multiple calls to the StartAudienceGenerationJob API.

# Arguments
- `name`: The name of the audience model resource.
- `training_dataset_arn`: The Amazon Resource Name (ARN) of the training dataset for this
  audience model.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description of the audience model.
- `"kmsKeyArn"`: The Amazon Resource Name (ARN) of the KMS key. This key is used to encrypt
  and decrypt customer-owned data in the trained ML model and the associated data.
- `"tags"`: The optional metadata that you apply to the resource to help you categorize and
  organize them. Each tag consists of a key and an optional value, both of which you define.
  The following basic restrictions apply to tags:   Maximum number of tags per resource - 50.
    For each resource, each tag key must be unique, and each tag key can have only one value.
    Maximum key length - 128 Unicode characters in UTF-8.   Maximum value length - 256
  Unicode characters in UTF-8.   If your tagging schema is used across multiple services and
  resources, remember that other services may have restrictions on allowed characters.
  Generally allowed characters are: letters, numbers, and spaces representable in UTF-8, and
  the following characters: + - = . _ : / @.   Tag keys and values are case sensitive.   Do
  not use aws:, AWS:, or any upper or lowercase combination of such as a prefix for keys as
  it is reserved for AWS use. You cannot edit or delete tag keys with this prefix. Values can
  have this prefix. If a tag value has aws as its prefix but the key does not, then Clean
  Rooms ML considers it to be a user tag and will count against the limit of 50 tags. Tags
  with only the key prefix of aws do not count against your tags per resource limit.
- `"trainingDataEndTime"`: The end date and time of the training window.
- `"trainingDataStartTime"`: The start date and time of the training window.
"""
function create_audience_model(
    name, trainingDatasetArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cleanroomsml(
        "POST",
        "/audience-model",
        Dict{String,Any}("name" => name, "trainingDatasetArn" => trainingDatasetArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_audience_model(
    name,
    trainingDatasetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanroomsml(
        "POST",
        "/audience-model",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "name" => name, "trainingDatasetArn" => trainingDatasetArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_configured_audience_model(audience_model_arn, name, output_config, shared_audience_metrics)
    create_configured_audience_model(audience_model_arn, name, output_config, shared_audience_metrics, params::Dict{String,<:Any})

Defines the information necessary to create a configured audience model.

# Arguments
- `audience_model_arn`: The Amazon Resource Name (ARN) of the audience model to use for the
  configured audience model.
- `name`: The name of the configured audience model.
- `output_config`: Configure the Amazon S3 location and IAM Role for audiences created
  using this configured audience model. Each audience will have a unique location. The IAM
  Role must have s3:PutObject permission on the destination Amazon S3 location. If the
  destination is protected with Amazon S3 KMS-SSE, then the Role must also have the required
  KMS permissions.
- `shared_audience_metrics`: Whether audience metrics are shared.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"audienceSizeConfig"`: Configure the list of output sizes of audiences that can be
  created using this configured audience model. A request to StartAudienceGenerationJob that
  uses this configured audience model must have an audienceSize selected from this list. You
  can use the ABSOLUTE AudienceSize to configure out audience sizes using the count of
  identifiers in the output. You can use the Percentage AudienceSize to configure sizes in
  the range 1-100 percent.
- `"childResourceTagOnCreatePolicy"`: Configure how the service tags audience generation
  jobs created using this configured audience model. If you specify NONE, the tags from the
  StartAudienceGenerationJob request determine the tags of the audience generation job. If
  you specify FROM_PARENT_RESOURCE, the audience generation job inherits the tags from the
  configured audience model, by default. Tags in the StartAudienceGenerationJob will override
  the default. When the client is in a different account than the configured audience model,
  the tags from the client are never applied to a resource in the caller's account.
- `"description"`: The description of the configured audience model.
- `"minMatchingSeedSize"`: The minimum number of users from the seed audience that must
  match with users in the training data of the audience model. The default value is 500.
- `"tags"`: The optional metadata that you apply to the resource to help you categorize and
  organize them. Each tag consists of a key and an optional value, both of which you define.
  The following basic restrictions apply to tags:   Maximum number of tags per resource - 50.
    For each resource, each tag key must be unique, and each tag key can have only one value.
    Maximum key length - 128 Unicode characters in UTF-8.   Maximum value length - 256
  Unicode characters in UTF-8.   If your tagging schema is used across multiple services and
  resources, remember that other services may have restrictions on allowed characters.
  Generally allowed characters are: letters, numbers, and spaces representable in UTF-8, and
  the following characters: + - = . _ : / @.   Tag keys and values are case sensitive.   Do
  not use aws:, AWS:, or any upper or lowercase combination of such as a prefix for keys as
  it is reserved for AWS use. You cannot edit or delete tag keys with this prefix. Values can
  have this prefix. If a tag value has aws as its prefix but the key does not, then Clean
  Rooms ML considers it to be a user tag and will count against the limit of 50 tags. Tags
  with only the key prefix of aws do not count against your tags per resource limit.
"""
function create_configured_audience_model(
    audienceModelArn,
    name,
    outputConfig,
    sharedAudienceMetrics;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanroomsml(
        "POST",
        "/configured-audience-model",
        Dict{String,Any}(
            "audienceModelArn" => audienceModelArn,
            "name" => name,
            "outputConfig" => outputConfig,
            "sharedAudienceMetrics" => sharedAudienceMetrics,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_configured_audience_model(
    audienceModelArn,
    name,
    outputConfig,
    sharedAudienceMetrics,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanroomsml(
        "POST",
        "/configured-audience-model",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "audienceModelArn" => audienceModelArn,
                    "name" => name,
                    "outputConfig" => outputConfig,
                    "sharedAudienceMetrics" => sharedAudienceMetrics,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_training_dataset(name, role_arn, training_data)
    create_training_dataset(name, role_arn, training_data, params::Dict{String,<:Any})

Defines the information necessary to create a training dataset. In Clean Rooms ML, the
TrainingDataset is metadata that points to a Glue table, which is read only during
AudienceModel creation.

# Arguments
- `name`: The name of the training dataset. This name must be unique in your account and
  region.
- `role_arn`: The ARN of the IAM role that Clean Rooms ML can assume to read the data
  referred to in the dataSource field of each dataset. Passing a role across AWS accounts is
  not allowed. If you pass a role that isn't in your account, you get an
  AccessDeniedException error.
- `training_data`: An array of information that lists the Dataset objects, which specifies
  the dataset type and details on its location and schema. You must provide a role that has
  read access to these tables.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description of the training dataset.
- `"tags"`: The optional metadata that you apply to the resource to help you categorize and
  organize them. Each tag consists of a key and an optional value, both of which you define.
  The following basic restrictions apply to tags:   Maximum number of tags per resource - 50.
    For each resource, each tag key must be unique, and each tag key can have only one value.
    Maximum key length - 128 Unicode characters in UTF-8.   Maximum value length - 256
  Unicode characters in UTF-8.   If your tagging schema is used across multiple services and
  resources, remember that other services may have restrictions on allowed characters.
  Generally allowed characters are: letters, numbers, and spaces representable in UTF-8, and
  the following characters: + - = . _ : / @.   Tag keys and values are case sensitive.   Do
  not use aws:, AWS:, or any upper or lowercase combination of such as a prefix for keys as
  it is reserved for AWS use. You cannot edit or delete tag keys with this prefix. Values can
  have this prefix. If a tag value has aws as its prefix but the key does not, then Clean
  Rooms ML considers it to be a user tag and will count against the limit of 50 tags. Tags
  with only the key prefix of aws do not count against your tags per resource limit.
"""
function create_training_dataset(
    name, roleArn, trainingData; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cleanroomsml(
        "POST",
        "/training-dataset",
        Dict{String,Any}(
            "name" => name, "roleArn" => roleArn, "trainingData" => trainingData
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_training_dataset(
    name,
    roleArn,
    trainingData,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanroomsml(
        "POST",
        "/training-dataset",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "name" => name, "roleArn" => roleArn, "trainingData" => trainingData
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_audience_generation_job(audience_generation_job_arn)
    delete_audience_generation_job(audience_generation_job_arn, params::Dict{String,<:Any})

Deletes the specified audience generation job, and removes all data associated with the job.

# Arguments
- `audience_generation_job_arn`: The Amazon Resource Name (ARN) of the audience generation
  job that you want to delete.

"""
function delete_audience_generation_job(
    audienceGenerationJobArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cleanroomsml(
        "DELETE",
        "/audience-generation-job/$(audienceGenerationJobArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_audience_generation_job(
    audienceGenerationJobArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanroomsml(
        "DELETE",
        "/audience-generation-job/$(audienceGenerationJobArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_audience_model(audience_model_arn)
    delete_audience_model(audience_model_arn, params::Dict{String,<:Any})

Specifies an audience model that you want to delete. You can't delete an audience model if
there are any configured audience models that depend on the audience model.

# Arguments
- `audience_model_arn`: The Amazon Resource Name (ARN) of the audience model that you want
  to delete.

"""
function delete_audience_model(
    audienceModelArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cleanroomsml(
        "DELETE",
        "/audience-model/$(audienceModelArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_audience_model(
    audienceModelArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanroomsml(
        "DELETE",
        "/audience-model/$(audienceModelArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_configured_audience_model(configured_audience_model_arn)
    delete_configured_audience_model(configured_audience_model_arn, params::Dict{String,<:Any})

Deletes the specified configured audience model. You can't delete a configured audience
model if there are any lookalike models that use the configured audience model. If you
delete a configured audience model, it will be removed from any collaborations that it is
associated to.

# Arguments
- `configured_audience_model_arn`: The Amazon Resource Name (ARN) of the configured
  audience model that you want to delete.

"""
function delete_configured_audience_model(
    configuredAudienceModelArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cleanroomsml(
        "DELETE",
        "/configured-audience-model/$(configuredAudienceModelArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_configured_audience_model(
    configuredAudienceModelArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanroomsml(
        "DELETE",
        "/configured-audience-model/$(configuredAudienceModelArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_configured_audience_model_policy(configured_audience_model_arn)
    delete_configured_audience_model_policy(configured_audience_model_arn, params::Dict{String,<:Any})

Deletes the specified configured audience model policy.

# Arguments
- `configured_audience_model_arn`: The Amazon Resource Name (ARN) of the configured
  audience model policy that you want to delete.

"""
function delete_configured_audience_model_policy(
    configuredAudienceModelArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cleanroomsml(
        "DELETE",
        "/configured-audience-model/$(configuredAudienceModelArn)/policy";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_configured_audience_model_policy(
    configuredAudienceModelArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanroomsml(
        "DELETE",
        "/configured-audience-model/$(configuredAudienceModelArn)/policy",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_training_dataset(training_dataset_arn)
    delete_training_dataset(training_dataset_arn, params::Dict{String,<:Any})

Specifies a training dataset that you want to delete. You can't delete a training dataset
if there are any audience models that depend on the training dataset. In Clean Rooms ML,
the TrainingDataset is metadata that points to a Glue table, which is read only during
AudienceModel creation. This action deletes the metadata.

# Arguments
- `training_dataset_arn`: The Amazon Resource Name (ARN) of the training dataset that you
  want to delete.

"""
function delete_training_dataset(
    trainingDatasetArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cleanroomsml(
        "DELETE",
        "/training-dataset/$(trainingDatasetArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_training_dataset(
    trainingDatasetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanroomsml(
        "DELETE",
        "/training-dataset/$(trainingDatasetArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_audience_generation_job(audience_generation_job_arn)
    get_audience_generation_job(audience_generation_job_arn, params::Dict{String,<:Any})

Returns information about an audience generation job.

# Arguments
- `audience_generation_job_arn`: The Amazon Resource Name (ARN) of the audience generation
  job that you are interested in.

"""
function get_audience_generation_job(
    audienceGenerationJobArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cleanroomsml(
        "GET",
        "/audience-generation-job/$(audienceGenerationJobArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_audience_generation_job(
    audienceGenerationJobArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanroomsml(
        "GET",
        "/audience-generation-job/$(audienceGenerationJobArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_audience_model(audience_model_arn)
    get_audience_model(audience_model_arn, params::Dict{String,<:Any})

Returns information about an audience model

# Arguments
- `audience_model_arn`: The Amazon Resource Name (ARN) of the audience model that you are
  interested in.

"""
function get_audience_model(
    audienceModelArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cleanroomsml(
        "GET",
        "/audience-model/$(audienceModelArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_audience_model(
    audienceModelArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanroomsml(
        "GET",
        "/audience-model/$(audienceModelArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_configured_audience_model(configured_audience_model_arn)
    get_configured_audience_model(configured_audience_model_arn, params::Dict{String,<:Any})

Returns information about a specified configured audience model.

# Arguments
- `configured_audience_model_arn`: The Amazon Resource Name (ARN) of the configured
  audience model that you are interested in.

"""
function get_configured_audience_model(
    configuredAudienceModelArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cleanroomsml(
        "GET",
        "/configured-audience-model/$(configuredAudienceModelArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_configured_audience_model(
    configuredAudienceModelArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanroomsml(
        "GET",
        "/configured-audience-model/$(configuredAudienceModelArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_configured_audience_model_policy(configured_audience_model_arn)
    get_configured_audience_model_policy(configured_audience_model_arn, params::Dict{String,<:Any})

Returns information about a configured audience model policy.

# Arguments
- `configured_audience_model_arn`: The Amazon Resource Name (ARN) of the configured
  audience model that you are interested in.

"""
function get_configured_audience_model_policy(
    configuredAudienceModelArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cleanroomsml(
        "GET",
        "/configured-audience-model/$(configuredAudienceModelArn)/policy";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_configured_audience_model_policy(
    configuredAudienceModelArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanroomsml(
        "GET",
        "/configured-audience-model/$(configuredAudienceModelArn)/policy",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_training_dataset(training_dataset_arn)
    get_training_dataset(training_dataset_arn, params::Dict{String,<:Any})

Returns information about a training dataset.

# Arguments
- `training_dataset_arn`: The Amazon Resource Name (ARN) of the training dataset that you
  are interested in.

"""
function get_training_dataset(
    trainingDatasetArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cleanroomsml(
        "GET",
        "/training-dataset/$(trainingDatasetArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_training_dataset(
    trainingDatasetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanroomsml(
        "GET",
        "/training-dataset/$(trainingDatasetArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_audience_export_jobs()
    list_audience_export_jobs(params::Dict{String,<:Any})

Returns a list of the audience export jobs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"audienceGenerationJobArn"`: The Amazon Resource Name (ARN) of the audience generation
  job that you are interested in.
- `"maxResults"`: The maximum size of the results that is returned per call.
- `"nextToken"`: The token value retrieved from a previous call to access the next page of
  results.
"""
function list_audience_export_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return cleanroomsml(
        "GET",
        "/audience-export-job";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_audience_export_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cleanroomsml(
        "GET",
        "/audience-export-job",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_audience_generation_jobs()
    list_audience_generation_jobs(params::Dict{String,<:Any})

Returns a list of audience generation jobs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"collaborationId"`: The identifier of the collaboration that contains the audience
  generation jobs that you are interested in.
- `"configuredAudienceModelArn"`: The Amazon Resource Name (ARN) of the configured audience
  model that was used for the audience generation jobs that you are interested in.
- `"maxResults"`: The maximum size of the results that is returned per call.
- `"nextToken"`: The token value retrieved from a previous call to access the next page of
  results.
"""
function list_audience_generation_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return cleanroomsml(
        "GET",
        "/audience-generation-job";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_audience_generation_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cleanroomsml(
        "GET",
        "/audience-generation-job",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_audience_models()
    list_audience_models(params::Dict{String,<:Any})

Returns a list of audience models.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum size of the results that is returned per call.
- `"nextToken"`: The token value retrieved from a previous call to access the next page of
  results.
"""
function list_audience_models(; aws_config::AbstractAWSConfig=current_aws_config())
    return cleanroomsml(
        "GET", "/audience-model"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_audience_models(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cleanroomsml(
        "GET",
        "/audience-model",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_configured_audience_models()
    list_configured_audience_models(params::Dict{String,<:Any})

Returns a list of the configured audience models.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum size of the results that is returned per call.
- `"nextToken"`: The token value retrieved from a previous call to access the next page of
  results.
"""
function list_configured_audience_models(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return cleanroomsml(
        "GET",
        "/configured-audience-model";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_configured_audience_models(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cleanroomsml(
        "GET",
        "/configured-audience-model",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Returns a list of tags for a provided resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource that you are interested in.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cleanroomsml(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanroomsml(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_training_datasets()
    list_training_datasets(params::Dict{String,<:Any})

Returns a list of training datasets.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum size of the results that is returned per call.
- `"nextToken"`: The token value retrieved from a previous call to access the next page of
  results.
"""
function list_training_datasets(; aws_config::AbstractAWSConfig=current_aws_config())
    return cleanroomsml(
        "GET", "/training-dataset"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_training_datasets(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cleanroomsml(
        "GET",
        "/training-dataset",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_configured_audience_model_policy(configured_audience_model_arn, configured_audience_model_policy)
    put_configured_audience_model_policy(configured_audience_model_arn, configured_audience_model_policy, params::Dict{String,<:Any})

Create or update the resource policy for a configured audience model.

# Arguments
- `configured_audience_model_arn`: The Amazon Resource Name (ARN) of the configured
  audience model that the resource policy will govern.
- `configured_audience_model_policy`: The IAM resource policy.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"policyExistenceCondition"`: Use this to prevent unexpected concurrent modification of
  the policy.
- `"previousPolicyHash"`: A cryptographic hash of the contents of the policy used to
  prevent unexpected concurrent modification of the policy.
"""
function put_configured_audience_model_policy(
    configuredAudienceModelArn,
    configuredAudienceModelPolicy;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanroomsml(
        "PUT",
        "/configured-audience-model/$(configuredAudienceModelArn)/policy",
        Dict{String,Any}("configuredAudienceModelPolicy" => configuredAudienceModelPolicy);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_configured_audience_model_policy(
    configuredAudienceModelArn,
    configuredAudienceModelPolicy,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanroomsml(
        "PUT",
        "/configured-audience-model/$(configuredAudienceModelArn)/policy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "configuredAudienceModelPolicy" => configuredAudienceModelPolicy
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_audience_export_job(audience_generation_job_arn, audience_size, name)
    start_audience_export_job(audience_generation_job_arn, audience_size, name, params::Dict{String,<:Any})

Export an audience of a specified size after you have generated an audience.

# Arguments
- `audience_generation_job_arn`: The Amazon Resource Name (ARN) of the audience generation
  job that you want to export.
- `audience_size`:
- `name`: The name of the audience export job.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description of the audience export job.
"""
function start_audience_export_job(
    audienceGenerationJobArn,
    audienceSize,
    name;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanroomsml(
        "POST",
        "/audience-export-job",
        Dict{String,Any}(
            "audienceGenerationJobArn" => audienceGenerationJobArn,
            "audienceSize" => audienceSize,
            "name" => name,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_audience_export_job(
    audienceGenerationJobArn,
    audienceSize,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanroomsml(
        "POST",
        "/audience-export-job",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "audienceGenerationJobArn" => audienceGenerationJobArn,
                    "audienceSize" => audienceSize,
                    "name" => name,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_audience_generation_job(configured_audience_model_arn, name, seed_audience)
    start_audience_generation_job(configured_audience_model_arn, name, seed_audience, params::Dict{String,<:Any})

Information necessary to start the audience generation job.

# Arguments
- `configured_audience_model_arn`: The Amazon Resource Name (ARN) of the configured
  audience model that is used for this audience generation job.
- `name`: The name of the audience generation job.
- `seed_audience`: The seed audience that is used to generate the audience.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"collaborationId"`: The identifier of the collaboration that contains the audience
  generation job.
- `"description"`: The description of the audience generation job.
- `"includeSeedInOutput"`: Whether the seed audience is included in the audience generation
  output.
- `"tags"`: The optional metadata that you apply to the resource to help you categorize and
  organize them. Each tag consists of a key and an optional value, both of which you define.
  The following basic restrictions apply to tags:   Maximum number of tags per resource - 50.
    For each resource, each tag key must be unique, and each tag key can have only one value.
    Maximum key length - 128 Unicode characters in UTF-8.   Maximum value length - 256
  Unicode characters in UTF-8.   If your tagging schema is used across multiple services and
  resources, remember that other services may have restrictions on allowed characters.
  Generally allowed characters are: letters, numbers, and spaces representable in UTF-8, and
  the following characters: + - = . _ : / @.   Tag keys and values are case sensitive.   Do
  not use aws:, AWS:, or any upper or lowercase combination of such as a prefix for keys as
  it is reserved for AWS use. You cannot edit or delete tag keys with this prefix. Values can
  have this prefix. If a tag value has aws as its prefix but the key does not, then Clean
  Rooms ML considers it to be a user tag and will count against the limit of 50 tags. Tags
  with only the key prefix of aws do not count against your tags per resource limit.
"""
function start_audience_generation_job(
    configuredAudienceModelArn,
    name,
    seedAudience;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanroomsml(
        "POST",
        "/audience-generation-job",
        Dict{String,Any}(
            "configuredAudienceModelArn" => configuredAudienceModelArn,
            "name" => name,
            "seedAudience" => seedAudience,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_audience_generation_job(
    configuredAudienceModelArn,
    name,
    seedAudience,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanroomsml(
        "POST",
        "/audience-generation-job",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "configuredAudienceModelArn" => configuredAudienceModelArn,
                    "name" => name,
                    "seedAudience" => seedAudience,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds metadata tags to a specified resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource that you want to assign
  tags.
- `tags`: The optional metadata that you apply to the resource to help you categorize and
  organize them. Each tag consists of a key and an optional value, both of which you define.
  The following basic restrictions apply to tags:   Maximum number of tags per resource - 50.
    For each resource, each tag key must be unique, and each tag key can have only one value.
    Maximum key length - 128 Unicode characters in UTF-8.   Maximum value length - 256
  Unicode characters in UTF-8.   If your tagging schema is used across multiple services and
  resources, remember that other services may have restrictions on allowed characters.
  Generally allowed characters are: letters, numbers, and spaces representable in UTF-8, and
  the following characters: + - = . _ : / @.   Tag keys and values are case sensitive.   Do
  not use aws:, AWS:, or any upper or lowercase combination of such as a prefix for keys as
  it is reserved for AWS use. You cannot edit or delete tag keys with this prefix. Values can
  have this prefix. If a tag value has aws as its prefix but the key does not, then Clean
  Rooms considers it to be a user tag and will count against the limit of 50 tags. Tags with
  only the key prefix of aws do not count against your tags per resource limit.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return cleanroomsml(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanroomsml(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes metadata tags from a specified resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource that you want to remove
  tags from.
- `tag_keys`: The key values of tags that you want to remove.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cleanroomsml(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanroomsml(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_configured_audience_model(configured_audience_model_arn)
    update_configured_audience_model(configured_audience_model_arn, params::Dict{String,<:Any})

Provides the information necessary to update a configured audience model. Updates that
impact audience generation jobs take effect when a new job starts, but do not impact
currently running jobs.

# Arguments
- `configured_audience_model_arn`: The Amazon Resource Name (ARN) of the configured
  audience model that you want to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"audienceModelArn"`: The Amazon Resource Name (ARN) of the new audience model that you
  want to use.
- `"audienceSizeConfig"`: The new audience size configuration.
- `"description"`: The new description of the configured audience model.
- `"minMatchingSeedSize"`: The minimum number of users from the seed audience that must
  match with users in the training data of the audience model.
- `"outputConfig"`: The new output configuration.
- `"sharedAudienceMetrics"`: The new value for whether to share audience metrics.
"""
function update_configured_audience_model(
    configuredAudienceModelArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cleanroomsml(
        "PATCH",
        "/configured-audience-model/$(configuredAudienceModelArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_configured_audience_model(
    configuredAudienceModelArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanroomsml(
        "PATCH",
        "/configured-audience-model/$(configuredAudienceModelArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: mediapackage_vod
using AWS.Compat
using AWS.UUIDs

"""
    configure_logs(id)
    configure_logs(id, params::Dict{String,<:Any})

Changes the packaging group's properities to configure log subscription

# Arguments
- `id`: The ID of a MediaPackage VOD PackagingGroup resource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"egressAccessLogs"`:
"""
function configure_logs(id; aws_config::AbstractAWSConfig=current_aws_config())
    return mediapackage_vod(
        "PUT",
        "/packaging_groups/$(id)/configure_logs";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function configure_logs(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediapackage_vod(
        "PUT",
        "/packaging_groups/$(id)/configure_logs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_asset(id, packaging_group_id, source_arn, source_role_arn)
    create_asset(id, packaging_group_id, source_arn, source_role_arn, params::Dict{String,<:Any})

Creates a new MediaPackage VOD Asset resource.

# Arguments
- `id`: The unique identifier for the Asset.
- `packaging_group_id`: The ID of the PackagingGroup for the Asset.
- `source_arn`: ARN of the source object in S3.
- `source_role_arn`: The IAM role ARN used to access the source S3 bucket.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"resourceId"`: The resource ID to include in SPEKE key requests.
- `"tags"`:
"""
function create_asset(
    id,
    packagingGroupId,
    sourceArn,
    sourceRoleArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediapackage_vod(
        "POST",
        "/assets",
        Dict{String,Any}(
            "id" => id,
            "packagingGroupId" => packagingGroupId,
            "sourceArn" => sourceArn,
            "sourceRoleArn" => sourceRoleArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_asset(
    id,
    packagingGroupId,
    sourceArn,
    sourceRoleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediapackage_vod(
        "POST",
        "/assets",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "id" => id,
                    "packagingGroupId" => packagingGroupId,
                    "sourceArn" => sourceArn,
                    "sourceRoleArn" => sourceRoleArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_packaging_configuration(id, packaging_group_id)
    create_packaging_configuration(id, packaging_group_id, params::Dict{String,<:Any})

Creates a new MediaPackage VOD PackagingConfiguration resource.

# Arguments
- `id`: The ID of the PackagingConfiguration.
- `packaging_group_id`: The ID of a PackagingGroup.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"cmafPackage"`:
- `"dashPackage"`:
- `"hlsPackage"`:
- `"mssPackage"`:
- `"tags"`:
"""
function create_packaging_configuration(
    id, packagingGroupId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediapackage_vod(
        "POST",
        "/packaging_configurations",
        Dict{String,Any}("id" => id, "packagingGroupId" => packagingGroupId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_packaging_configuration(
    id,
    packagingGroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediapackage_vod(
        "POST",
        "/packaging_configurations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("id" => id, "packagingGroupId" => packagingGroupId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_packaging_group(id)
    create_packaging_group(id, params::Dict{String,<:Any})

Creates a new MediaPackage VOD PackagingGroup resource.

# Arguments
- `id`: The ID of the PackagingGroup.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"authorization"`:
- `"egressAccessLogs"`:
- `"tags"`:
"""
function create_packaging_group(id; aws_config::AbstractAWSConfig=current_aws_config())
    return mediapackage_vod(
        "POST",
        "/packaging_groups",
        Dict{String,Any}("id" => id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_packaging_group(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediapackage_vod(
        "POST",
        "/packaging_groups",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("id" => id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_asset(id)
    delete_asset(id, params::Dict{String,<:Any})

Deletes an existing MediaPackage VOD Asset resource.

# Arguments
- `id`: The ID of the MediaPackage VOD Asset resource to delete.

"""
function delete_asset(id; aws_config::AbstractAWSConfig=current_aws_config())
    return mediapackage_vod(
        "DELETE", "/assets/$(id)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function delete_asset(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediapackage_vod(
        "DELETE",
        "/assets/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_packaging_configuration(id)
    delete_packaging_configuration(id, params::Dict{String,<:Any})

Deletes a MediaPackage VOD PackagingConfiguration resource.

# Arguments
- `id`: The ID of the MediaPackage VOD PackagingConfiguration resource to delete.

"""
function delete_packaging_configuration(
    id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediapackage_vod(
        "DELETE",
        "/packaging_configurations/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_packaging_configuration(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediapackage_vod(
        "DELETE",
        "/packaging_configurations/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_packaging_group(id)
    delete_packaging_group(id, params::Dict{String,<:Any})

Deletes a MediaPackage VOD PackagingGroup resource.

# Arguments
- `id`: The ID of the MediaPackage VOD PackagingGroup resource to delete.

"""
function delete_packaging_group(id; aws_config::AbstractAWSConfig=current_aws_config())
    return mediapackage_vod(
        "DELETE",
        "/packaging_groups/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_packaging_group(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediapackage_vod(
        "DELETE",
        "/packaging_groups/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_asset(id)
    describe_asset(id, params::Dict{String,<:Any})

Returns a description of a MediaPackage VOD Asset resource.

# Arguments
- `id`: The ID of an MediaPackage VOD Asset resource.

"""
function describe_asset(id; aws_config::AbstractAWSConfig=current_aws_config())
    return mediapackage_vod(
        "GET", "/assets/$(id)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_asset(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediapackage_vod(
        "GET",
        "/assets/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_packaging_configuration(id)
    describe_packaging_configuration(id, params::Dict{String,<:Any})

Returns a description of a MediaPackage VOD PackagingConfiguration resource.

# Arguments
- `id`: The ID of a MediaPackage VOD PackagingConfiguration resource.

"""
function describe_packaging_configuration(
    id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediapackage_vod(
        "GET",
        "/packaging_configurations/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_packaging_configuration(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediapackage_vod(
        "GET",
        "/packaging_configurations/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_packaging_group(id)
    describe_packaging_group(id, params::Dict{String,<:Any})

Returns a description of a MediaPackage VOD PackagingGroup resource.

# Arguments
- `id`: The ID of a MediaPackage VOD PackagingGroup resource.

"""
function describe_packaging_group(id; aws_config::AbstractAWSConfig=current_aws_config())
    return mediapackage_vod(
        "GET",
        "/packaging_groups/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_packaging_group(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediapackage_vod(
        "GET",
        "/packaging_groups/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_assets()
    list_assets(params::Dict{String,<:Any})

Returns a collection of MediaPackage VOD Asset resources.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Upper bound on number of records to return.
- `"nextToken"`: A token used to resume pagination from the end of a previous request.
- `"packagingGroupId"`: Returns Assets associated with the specified PackagingGroup.
"""
function list_assets(; aws_config::AbstractAWSConfig=current_aws_config())
    return mediapackage_vod(
        "GET", "/assets"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_assets(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediapackage_vod(
        "GET", "/assets", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_packaging_configurations()
    list_packaging_configurations(params::Dict{String,<:Any})

Returns a collection of MediaPackage VOD PackagingConfiguration resources.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Upper bound on number of records to return.
- `"nextToken"`: A token used to resume pagination from the end of a previous request.
- `"packagingGroupId"`: Returns MediaPackage VOD PackagingConfigurations associated with
  the specified PackagingGroup.
"""
function list_packaging_configurations(; aws_config::AbstractAWSConfig=current_aws_config())
    return mediapackage_vod(
        "GET",
        "/packaging_configurations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_packaging_configurations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediapackage_vod(
        "GET",
        "/packaging_configurations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_packaging_groups()
    list_packaging_groups(params::Dict{String,<:Any})

Returns a collection of MediaPackage VOD PackagingGroup resources.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Upper bound on number of records to return.
- `"nextToken"`: A token used to resume pagination from the end of a previous request.
"""
function list_packaging_groups(; aws_config::AbstractAWSConfig=current_aws_config())
    return mediapackage_vod(
        "GET", "/packaging_groups"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_packaging_groups(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediapackage_vod(
        "GET",
        "/packaging_groups",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource-arn)
    list_tags_for_resource(resource-arn, params::Dict{String,<:Any})

Returns a list of the tags assigned to the specified resource.

# Arguments
- `resource-arn`: The Amazon Resource Name (ARN) for the resource. You can get this from
  the response to any request to the resource.

"""
function list_tags_for_resource(
    resource_arn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediapackage_vod(
        "GET",
        "/tags/$(resource-arn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resource_arn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediapackage_vod(
        "GET",
        "/tags/$(resource-arn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource-arn, tags)
    tag_resource(resource-arn, tags, params::Dict{String,<:Any})

Adds tags to the specified resource. You can specify one or more tags to add.

# Arguments
- `resource-arn`: The Amazon Resource Name (ARN) for the resource. You can get this from
  the response to any request to the resource.
- `tags`: A collection of tags associated with a resource

"""
function tag_resource(
    resource_arn, tags; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediapackage_vod(
        "POST",
        "/tags/$(resource-arn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resource_arn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediapackage_vod(
        "POST",
        "/tags/$(resource-arn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource-arn, tag_keys)
    untag_resource(resource-arn, tag_keys, params::Dict{String,<:Any})

Removes tags from the specified resource. You can specify one or more tags to remove.

# Arguments
- `resource-arn`: The Amazon Resource Name (ARN) for the resource. You can get this from
  the response to any request to the resource.
- `tag_keys`: A comma-separated list of the tag keys to remove from the resource.

"""
function untag_resource(
    resource_arn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediapackage_vod(
        "DELETE",
        "/tags/$(resource-arn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resource_arn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediapackage_vod(
        "DELETE",
        "/tags/$(resource-arn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_packaging_group(id)
    update_packaging_group(id, params::Dict{String,<:Any})

Updates a specific packaging group. You can't change the id attribute or any other
system-generated attributes.

# Arguments
- `id`: The ID of a MediaPackage VOD PackagingGroup resource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"authorization"`:
"""
function update_packaging_group(id; aws_config::AbstractAWSConfig=current_aws_config())
    return mediapackage_vod(
        "PUT",
        "/packaging_groups/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_packaging_group(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediapackage_vod(
        "PUT",
        "/packaging_groups/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: billingconductor
using AWS.Compat
using AWS.UUIDs

"""
    associate_accounts(account_ids, arn)
    associate_accounts(account_ids, arn, params::Dict{String,<:Any})

Connects an array of account IDs in a consolidated billing family to a predefined billing
group. The account IDs must be a part of the consolidated billing family during the current
month, and not already associated with another billing group. The maximum number of
accounts that can be associated in one call is 30.

# Arguments
- `account_ids`:  The associating array of account IDs.
- `arn`:  The Amazon Resource Name (ARN) of the billing group that associates the array of
  account IDs.

"""
function associate_accounts(
    AccountIds, Arn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return billingconductor(
        "POST",
        "/associate-accounts",
        Dict{String,Any}("AccountIds" => AccountIds, "Arn" => Arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_accounts(
    AccountIds,
    Arn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return billingconductor(
        "POST",
        "/associate-accounts",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("AccountIds" => AccountIds, "Arn" => Arn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_pricing_rules(arn, pricing_rule_arns)
    associate_pricing_rules(arn, pricing_rule_arns, params::Dict{String,<:Any})

Connects an array of PricingRuleArns to a defined PricingPlan. The maximum number
PricingRuleArn that can be associated in one call is 30.

# Arguments
- `arn`:  The PricingPlanArn that the PricingRuleArns are associated with.
- `pricing_rule_arns`:  The PricingRuleArns that are associated with the Pricing Plan.

"""
function associate_pricing_rules(
    Arn, PricingRuleArns; aws_config::AbstractAWSConfig=current_aws_config()
)
    return billingconductor(
        "PUT",
        "/associate-pricing-rules",
        Dict{String,Any}("Arn" => Arn, "PricingRuleArns" => PricingRuleArns);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_pricing_rules(
    Arn,
    PricingRuleArns,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return billingconductor(
        "PUT",
        "/associate-pricing-rules",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Arn" => Arn, "PricingRuleArns" => PricingRuleArns),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_associate_resources_to_custom_line_item(resource_arns, target_arn)
    batch_associate_resources_to_custom_line_item(resource_arns, target_arn, params::Dict{String,<:Any})

 Associates a batch of resources to a percentage custom line item.

# Arguments
- `resource_arns`:  A list containing the ARNs of the resources to be associated.
- `target_arn`:  A percentage custom line item ARN to associate the resources to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"BillingPeriodRange"`:
"""
function batch_associate_resources_to_custom_line_item(
    ResourceArns, TargetArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return billingconductor(
        "PUT",
        "/batch-associate-resources-to-custom-line-item",
        Dict{String,Any}("ResourceArns" => ResourceArns, "TargetArn" => TargetArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_associate_resources_to_custom_line_item(
    ResourceArns,
    TargetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return billingconductor(
        "PUT",
        "/batch-associate-resources-to-custom-line-item",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArns" => ResourceArns, "TargetArn" => TargetArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_disassociate_resources_from_custom_line_item(resource_arns, target_arn)
    batch_disassociate_resources_from_custom_line_item(resource_arns, target_arn, params::Dict{String,<:Any})

 Disassociates a batch of resources from a percentage custom line item.

# Arguments
- `resource_arns`:  A list containing the ARNs of resources to be disassociated.
- `target_arn`:  A percentage custom line item ARN to disassociate the resources from.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"BillingPeriodRange"`:
"""
function batch_disassociate_resources_from_custom_line_item(
    ResourceArns, TargetArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return billingconductor(
        "PUT",
        "/batch-disassociate-resources-from-custom-line-item",
        Dict{String,Any}("ResourceArns" => ResourceArns, "TargetArn" => TargetArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_disassociate_resources_from_custom_line_item(
    ResourceArns,
    TargetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return billingconductor(
        "PUT",
        "/batch-disassociate-resources-from-custom-line-item",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArns" => ResourceArns, "TargetArn" => TargetArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_billing_group(account_grouping, computation_preference, name)
    create_billing_group(account_grouping, computation_preference, name, params::Dict{String,<:Any})

 Creates a billing group that resembles a consolidated billing family that Amazon Web
Services charges, based off of the predefined pricing plan computation.

# Arguments
- `account_grouping`:  The set of accounts that will be under the billing group. The set of
  accounts resemble the linked accounts in a consolidated billing family.
- `computation_preference`:  The preferences and settings that will be used to compute the
  Amazon Web Services charges for a billing group.
- `name`:  The billing group name. The names must be unique.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: The description of the billing group.
- `"PrimaryAccountId"`:  The account ID that serves as the main account in a billing group.
- `"Tags"`:  A map that contains tag keys and tag values that are attached to a billing
  group. This feature isn't available during the beta.
- `"X-Amzn-Client-Token"`:  The token that is needed to support idempotency. Idempotency
  isn't currently supported, but will be implemented in a future update.
"""
function create_billing_group(
    AccountGrouping,
    ComputationPreference,
    Name;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return billingconductor(
        "POST",
        "/create-billing-group",
        Dict{String,Any}(
            "AccountGrouping" => AccountGrouping,
            "ComputationPreference" => ComputationPreference,
            "Name" => Name,
            "X-Amzn-Client-Token" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_billing_group(
    AccountGrouping,
    ComputationPreference,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return billingconductor(
        "POST",
        "/create-billing-group",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AccountGrouping" => AccountGrouping,
                    "ComputationPreference" => ComputationPreference,
                    "Name" => Name,
                    "X-Amzn-Client-Token" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_custom_line_item(billing_group_arn, charge_details, description, name)
    create_custom_line_item(billing_group_arn, charge_details, description, name, params::Dict{String,<:Any})

Creates a custom line item that can be used to create a one-time fixed charge that can be
applied to a single billing group for the current or previous billing period. The one-time
fixed charge is either a fee or discount.

# Arguments
- `billing_group_arn`:  The Amazon Resource Name (ARN) that references the billing group
  where the custom line item applies to.
- `charge_details`:  A CustomLineItemChargeDetails that describes the charge details for a
  custom line item.
- `description`:  The description of the custom line item. This is shown on the Bills page
  in association with the charge value.
- `name`:  The name of the custom line item.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccountId"`: The Amazon Web Services account in which this custom line item will be
  applied to.
- `"BillingPeriodRange"`:  A time range for which the custom line item is effective.
- `"Tags"`:  A map that contains tag keys and tag values that are attached to a custom line
  item.
- `"X-Amzn-Client-Token"`:  The token that is needed to support idempotency. Idempotency
  isn't currently supported, but will be implemented in a future update.
"""
function create_custom_line_item(
    BillingGroupArn,
    ChargeDetails,
    Description,
    Name;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return billingconductor(
        "POST",
        "/create-custom-line-item",
        Dict{String,Any}(
            "BillingGroupArn" => BillingGroupArn,
            "ChargeDetails" => ChargeDetails,
            "Description" => Description,
            "Name" => Name,
            "X-Amzn-Client-Token" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_custom_line_item(
    BillingGroupArn,
    ChargeDetails,
    Description,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return billingconductor(
        "POST",
        "/create-custom-line-item",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "BillingGroupArn" => BillingGroupArn,
                    "ChargeDetails" => ChargeDetails,
                    "Description" => Description,
                    "Name" => Name,
                    "X-Amzn-Client-Token" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_pricing_plan(name)
    create_pricing_plan(name, params::Dict{String,<:Any})

Creates a pricing plan that is used for computing Amazon Web Services charges for billing
groups.

# Arguments
- `name`: The name of the pricing plan. The names must be unique to each pricing plan.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: The description of the pricing plan.
- `"PricingRuleArns"`:  A list of Amazon Resource Names (ARNs) that define the pricing plan
  parameters.
- `"Tags"`:  A map that contains tag keys and tag values that are attached to a pricing
  plan.
- `"X-Amzn-Client-Token"`:  The token that is needed to support idempotency. Idempotency
  isn't currently supported, but will be implemented in a future update.
"""
function create_pricing_plan(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return billingconductor(
        "POST",
        "/create-pricing-plan",
        Dict{String,Any}("Name" => Name, "X-Amzn-Client-Token" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_pricing_plan(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return billingconductor(
        "POST",
        "/create-pricing-plan",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Name" => Name, "X-Amzn-Client-Token" => string(uuid4())),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_pricing_rule(name, scope, type)
    create_pricing_rule(name, scope, type, params::Dict{String,<:Any})

 Creates a pricing rule can be associated to a pricing plan, or a set of pricing plans.

# Arguments
- `name`:  The pricing rule name. The names must be unique to each pricing rule.
- `scope`:  The scope of pricing rule that indicates if it's globally applicable, or it's
  service-specific.
- `type`:  The type of pricing rule.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"BillingEntity"`:  The seller of services provided by Amazon Web Services, their
  affiliates, or third-party providers selling services via Amazon Web Services Marketplace.
- `"Description"`:  The pricing rule description.
- `"ModifierPercentage"`:  A percentage modifier that's applied on the public pricing
  rates.
- `"Operation"`:  Operation is the specific Amazon Web Services action covered by this line
  item. This describes the specific usage of the line item.  If the Scope attribute is set to
  SKU, this attribute indicates which operation the PricingRule is modifying. For example, a
  value of RunInstances:0202 indicates the operation of running an Amazon EC2 instance.
- `"Service"`:  If the Scope attribute is set to SERVICE or SKU, the attribute indicates
  which service the PricingRule is applicable for.
- `"Tags"`:  A map that contains tag keys and tag values that are attached to a pricing
  rule.
- `"Tiering"`:  The set of tiering configurations for the pricing rule.
- `"UsageType"`:  Usage type is the unit that each service uses to measure the usage of a
  specific type of resource. If the Scope attribute is set to SKU, this attribute indicates
  which usage type the PricingRule is modifying. For example, USW2-BoxUsage:m2.2xlarge
  describes an M2 High Memory Double Extra Large instance in the US West (Oregon) Region.
  &lt;/p&gt;
- `"X-Amzn-Client-Token"`:  The token that's needed to support idempotency. Idempotency
  isn't currently supported, but will be implemented in a future update.
"""
function create_pricing_rule(
    Name, Scope, Type; aws_config::AbstractAWSConfig=current_aws_config()
)
    return billingconductor(
        "POST",
        "/create-pricing-rule",
        Dict{String,Any}(
            "Name" => Name,
            "Scope" => Scope,
            "Type" => Type,
            "X-Amzn-Client-Token" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_pricing_rule(
    Name,
    Scope,
    Type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return billingconductor(
        "POST",
        "/create-pricing-rule",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Name" => Name,
                    "Scope" => Scope,
                    "Type" => Type,
                    "X-Amzn-Client-Token" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_billing_group(arn)
    delete_billing_group(arn, params::Dict{String,<:Any})

 Deletes a billing group.

# Arguments
- `arn`: The Amazon Resource Name (ARN) of the billing group that you're deleting.

"""
function delete_billing_group(Arn; aws_config::AbstractAWSConfig=current_aws_config())
    return billingconductor(
        "POST",
        "/delete-billing-group",
        Dict{String,Any}("Arn" => Arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_billing_group(
    Arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return billingconductor(
        "POST",
        "/delete-billing-group",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Arn" => Arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_custom_line_item(arn)
    delete_custom_line_item(arn, params::Dict{String,<:Any})

 Deletes the custom line item identified by the given ARN in the current, or previous
billing period.

# Arguments
- `arn`:  The ARN of the custom line item to be deleted.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"BillingPeriodRange"`:
"""
function delete_custom_line_item(Arn; aws_config::AbstractAWSConfig=current_aws_config())
    return billingconductor(
        "POST",
        "/delete-custom-line-item",
        Dict{String,Any}("Arn" => Arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_custom_line_item(
    Arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return billingconductor(
        "POST",
        "/delete-custom-line-item",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Arn" => Arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_pricing_plan(arn)
    delete_pricing_plan(arn, params::Dict{String,<:Any})

Deletes a pricing plan. The pricing plan must not be associated with any billing groups to
delete successfully.

# Arguments
- `arn`: The Amazon Resource Name (ARN) of the pricing plan that you're deleting.

"""
function delete_pricing_plan(Arn; aws_config::AbstractAWSConfig=current_aws_config())
    return billingconductor(
        "POST",
        "/delete-pricing-plan",
        Dict{String,Any}("Arn" => Arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_pricing_plan(
    Arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return billingconductor(
        "POST",
        "/delete-pricing-plan",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Arn" => Arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_pricing_rule(arn)
    delete_pricing_rule(arn, params::Dict{String,<:Any})

 Deletes the pricing rule that's identified by the input Amazon Resource Name (ARN).

# Arguments
- `arn`:  The Amazon Resource Name (ARN) of the pricing rule that you are deleting.

"""
function delete_pricing_rule(Arn; aws_config::AbstractAWSConfig=current_aws_config())
    return billingconductor(
        "POST",
        "/delete-pricing-rule",
        Dict{String,Any}("Arn" => Arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_pricing_rule(
    Arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return billingconductor(
        "POST",
        "/delete-pricing-rule",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Arn" => Arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_accounts(account_ids, arn)
    disassociate_accounts(account_ids, arn, params::Dict{String,<:Any})

Removes the specified list of account IDs from the given billing group.

# Arguments
- `account_ids`: The array of account IDs to disassociate.
- `arn`: The Amazon Resource Name (ARN) of the billing group that the array of account IDs
  will disassociate from.

"""
function disassociate_accounts(
    AccountIds, Arn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return billingconductor(
        "POST",
        "/disassociate-accounts",
        Dict{String,Any}("AccountIds" => AccountIds, "Arn" => Arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_accounts(
    AccountIds,
    Arn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return billingconductor(
        "POST",
        "/disassociate-accounts",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("AccountIds" => AccountIds, "Arn" => Arn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_pricing_rules(arn, pricing_rule_arns)
    disassociate_pricing_rules(arn, pricing_rule_arns, params::Dict{String,<:Any})

 Disassociates a list of pricing rules from a pricing plan.

# Arguments
- `arn`:  The pricing plan Amazon Resource Name (ARN) to disassociate pricing rules from.
- `pricing_rule_arns`:  A list containing the Amazon Resource Name (ARN) of the pricing
  rules that will be disassociated.

"""
function disassociate_pricing_rules(
    Arn, PricingRuleArns; aws_config::AbstractAWSConfig=current_aws_config()
)
    return billingconductor(
        "PUT",
        "/disassociate-pricing-rules",
        Dict{String,Any}("Arn" => Arn, "PricingRuleArns" => PricingRuleArns);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_pricing_rules(
    Arn,
    PricingRuleArns,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return billingconductor(
        "PUT",
        "/disassociate-pricing-rules",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Arn" => Arn, "PricingRuleArns" => PricingRuleArns),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_billing_group_cost_report(arn)
    get_billing_group_cost_report(arn, params::Dict{String,<:Any})

Retrieves the margin summary report, which includes the Amazon Web Services cost and
charged amount (pro forma cost) by Amazon Web Service for a specific billing group.

# Arguments
- `arn`: The Amazon Resource Number (ARN) that uniquely identifies the billing group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"BillingPeriodRange"`: A time range for which the margin summary is effective. You can
  specify up to 12 months.
- `"GroupBy"`: A list of strings that specify the attributes that are used to break down
  costs in the margin summary reports for the billing group. For example, you can view your
  costs by the Amazon Web Service name or the billing period.
- `"MaxResults"`: The maximum number of margin summary reports to retrieve.
- `"NextToken"`: The pagination token used on subsequent calls to get reports.
"""
function get_billing_group_cost_report(
    Arn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return billingconductor(
        "POST",
        "/get-billing-group-cost-report",
        Dict{String,Any}("Arn" => Arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_billing_group_cost_report(
    Arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return billingconductor(
        "POST",
        "/get-billing-group-cost-report",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Arn" => Arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_account_associations()
    list_account_associations(params::Dict{String,<:Any})

 This is a paginated call to list linked accounts that are linked to the payer account for
the specified time period. If no information is provided, the current billing period is
used. The response will optionally include the billing group that's associated with the
linked account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"BillingPeriod"`:  The preferred billing period to get account associations.
- `"Filters"`: The filter on the account ID of the linked account, or any of the following:
   MONITORED: linked accounts that are associated to billing groups.  UNMONITORED: linked
  accounts that aren't associated to billing groups.  Billing Group Arn: linked accounts that
  are associated to the provided billing group Arn.
- `"NextToken"`:  The pagination token that's used on subsequent calls to retrieve
  accounts.
"""
function list_account_associations(; aws_config::AbstractAWSConfig=current_aws_config())
    return billingconductor(
        "POST",
        "/list-account-associations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_account_associations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return billingconductor(
        "POST",
        "/list-account-associations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_billing_group_cost_reports()
    list_billing_group_cost_reports(params::Dict{String,<:Any})

A paginated call to retrieve a summary report of actual Amazon Web Services charges and the
calculated Amazon Web Services charges based on the associated pricing plan of a billing
group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"BillingPeriod"`: The preferred billing period for your report.
- `"Filters"`: A ListBillingGroupCostReportsFilter to specify billing groups to retrieve
  reports from.
- `"MaxResults"`: The maximum number of reports to retrieve.
- `"NextToken"`: The pagination token that's used on subsequent calls to get reports.
"""
function list_billing_group_cost_reports(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return billingconductor(
        "POST",
        "/list-billing-group-cost-reports";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_billing_group_cost_reports(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return billingconductor(
        "POST",
        "/list-billing-group-cost-reports",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_billing_groups()
    list_billing_groups(params::Dict{String,<:Any})

A paginated call to retrieve a list of billing groups for the given billing period. If you
don't provide a billing group, the current billing period is used.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"BillingPeriod"`: The preferred billing period to get billing groups.
- `"Filters"`: A ListBillingGroupsFilter that specifies the billing group and pricing plan
  to retrieve billing group information.
- `"MaxResults"`: The maximum number of billing groups to retrieve.
- `"NextToken"`: The pagination token that's used on subsequent calls to get billing
  groups.
"""
function list_billing_groups(; aws_config::AbstractAWSConfig=current_aws_config())
    return billingconductor(
        "POST",
        "/list-billing-groups";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_billing_groups(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return billingconductor(
        "POST",
        "/list-billing-groups",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_custom_line_item_versions(arn)
    list_custom_line_item_versions(arn, params::Dict{String,<:Any})

A paginated call to get a list of all custom line item versions.

# Arguments
- `arn`: The Amazon Resource Name (ARN) for the custom line item.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: A ListCustomLineItemVersionsFilter that specifies the billing period range
  in which the custom line item versions are applied.
- `"MaxResults"`: The maximum number of custom line item versions to retrieve.
- `"NextToken"`: The pagination token that's used on subsequent calls to retrieve custom
  line item versions.
"""
function list_custom_line_item_versions(
    Arn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return billingconductor(
        "POST",
        "/list-custom-line-item-versions",
        Dict{String,Any}("Arn" => Arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_custom_line_item_versions(
    Arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return billingconductor(
        "POST",
        "/list-custom-line-item-versions",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Arn" => Arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_custom_line_items()
    list_custom_line_items(params::Dict{String,<:Any})

 A paginated call to get a list of all custom line items (FFLIs) for the given billing
period. If you don't provide a billing period, the current billing period is used.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"BillingPeriod"`:  The preferred billing period to get custom line items (FFLIs).
- `"Filters"`: A ListCustomLineItemsFilter that specifies the custom line item names and/or
  billing group Amazon Resource Names (ARNs) to retrieve FFLI information.
- `"MaxResults"`:  The maximum number of billing groups to retrieve.
- `"NextToken"`:  The pagination token that's used on subsequent calls to get custom line
  items (FFLIs).
"""
function list_custom_line_items(; aws_config::AbstractAWSConfig=current_aws_config())
    return billingconductor(
        "POST",
        "/list-custom-line-items";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_custom_line_items(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return billingconductor(
        "POST",
        "/list-custom-line-items",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_pricing_plans()
    list_pricing_plans(params::Dict{String,<:Any})

A paginated call to get pricing plans for the given billing period. If you don't provide a
billing period, the current billing period is used.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"BillingPeriod"`: The preferred billing period to get pricing plan.
- `"Filters"`: A ListPricingPlansFilter that specifies the Amazon Resource Name (ARNs) of
  pricing plans to retrieve pricing plans information.
- `"MaxResults"`: The maximum number of pricing plans to retrieve.
- `"NextToken"`: The pagination token that's used on subsequent call to get pricing plans.
"""
function list_pricing_plans(; aws_config::AbstractAWSConfig=current_aws_config())
    return billingconductor(
        "POST",
        "/list-pricing-plans";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_pricing_plans(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return billingconductor(
        "POST",
        "/list-pricing-plans",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_pricing_plans_associated_with_pricing_rule(pricing_rule_arn)
    list_pricing_plans_associated_with_pricing_rule(pricing_rule_arn, params::Dict{String,<:Any})

 A list of the pricing plans that are associated with a pricing rule.

# Arguments
- `pricing_rule_arn`:  The pricing rule Amazon Resource Name (ARN) for which associations
  will be listed.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"BillingPeriod"`:  The pricing plan billing period for which associations will be
  listed.
- `"MaxResults"`:  The optional maximum number of pricing rule associations to retrieve.
- `"NextToken"`:  The optional pagination token returned by a previous call.
"""
function list_pricing_plans_associated_with_pricing_rule(
    PricingRuleArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return billingconductor(
        "POST",
        "/list-pricing-plans-associated-with-pricing-rule",
        Dict{String,Any}("PricingRuleArn" => PricingRuleArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_pricing_plans_associated_with_pricing_rule(
    PricingRuleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return billingconductor(
        "POST",
        "/list-pricing-plans-associated-with-pricing-rule",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("PricingRuleArn" => PricingRuleArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_pricing_rules()
    list_pricing_rules(params::Dict{String,<:Any})

 Describes a pricing rule that can be associated to a pricing plan, or set of pricing
plans.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"BillingPeriod"`:  The preferred billing period to get the pricing plan.
- `"Filters"`:  A DescribePricingRuleFilter that specifies the Amazon Resource Name (ARNs)
  of pricing rules to retrieve pricing rules information.
- `"MaxResults"`:  The maximum number of pricing rules to retrieve.
- `"NextToken"`:  The pagination token that's used on subsequent call to get pricing rules.
"""
function list_pricing_rules(; aws_config::AbstractAWSConfig=current_aws_config())
    return billingconductor(
        "POST",
        "/list-pricing-rules";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_pricing_rules(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return billingconductor(
        "POST",
        "/list-pricing-rules",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_pricing_rules_associated_to_pricing_plan(pricing_plan_arn)
    list_pricing_rules_associated_to_pricing_plan(pricing_plan_arn, params::Dict{String,<:Any})

 Lists the pricing rules that are associated with a pricing plan.

# Arguments
- `pricing_plan_arn`:  The Amazon Resource Name (ARN) of the pricing plan for which
  associations are to be listed.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"BillingPeriod"`:  The billing period for which the pricing rule associations are to be
  listed.
- `"MaxResults"`: The optional maximum number of pricing rule associations to retrieve.
- `"NextToken"`:  The optional pagination token returned by a previous call.
"""
function list_pricing_rules_associated_to_pricing_plan(
    PricingPlanArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return billingconductor(
        "POST",
        "/list-pricing-rules-associated-to-pricing-plan",
        Dict{String,Any}("PricingPlanArn" => PricingPlanArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_pricing_rules_associated_to_pricing_plan(
    PricingPlanArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return billingconductor(
        "POST",
        "/list-pricing-rules-associated-to-pricing-plan",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("PricingPlanArn" => PricingPlanArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_resources_associated_to_custom_line_item(arn)
    list_resources_associated_to_custom_line_item(arn, params::Dict{String,<:Any})

 List the resources that are associated to a custom line item.

# Arguments
- `arn`:  The ARN of the custom line item for which the resource associations will be
  listed.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"BillingPeriod"`:  The billing period for which the resource associations will be
  listed.
- `"Filters"`:  (Optional) A ListResourcesAssociatedToCustomLineItemFilter that can specify
  the types of resources that should be retrieved.
- `"MaxResults"`:  (Optional) The maximum number of resource associations to be retrieved.
- `"NextToken"`:  (Optional) The pagination token that's returned by a previous request.
"""
function list_resources_associated_to_custom_line_item(
    Arn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return billingconductor(
        "POST",
        "/list-resources-associated-to-custom-line-item",
        Dict{String,Any}("Arn" => Arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_resources_associated_to_custom_line_item(
    Arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return billingconductor(
        "POST",
        "/list-resources-associated-to-custom-line-item",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Arn" => Arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

 A list the tags for a resource.

# Arguments
- `resource_arn`:  The Amazon Resource Name (ARN) that identifies the resource to list the
  tags.

"""
function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return billingconductor(
        "GET",
        "/tags/$(ResourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return billingconductor(
        "GET",
        "/tags/$(ResourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

 Associates the specified tags to a resource with the specified resourceArn. If existing
tags on a resource are not specified in the request parameters, they are not changed.

# Arguments
- `resource_arn`:  The Amazon Resource Name (ARN) of the resource to which to add tags.
- `tags`:  The tags to add to the resource as a list of key-value pairs.

"""
function tag_resource(ResourceArn, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return billingconductor(
        "POST",
        "/tags/$(ResourceArn)",
        Dict{String,Any}("Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceArn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return billingconductor(
        "POST",
        "/tags/$(ResourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Tags" => Tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

 Deletes specified tags from a resource.

# Arguments
- `resource_arn`:  The Amazon Resource Name (ARN) of the resource to which to delete tags.
- `tag_keys`:  The tags to delete from the resource as a list of key-value pairs.

"""
function untag_resource(
    ResourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return billingconductor(
        "DELETE",
        "/tags/$(ResourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return billingconductor(
        "DELETE",
        "/tags/$(ResourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_billing_group(arn)
    update_billing_group(arn, params::Dict{String,<:Any})

This updates an existing billing group.

# Arguments
- `arn`: The Amazon Resource Name (ARN) of the billing group being updated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccountGrouping"`: Specifies if the billing group has automatic account association
  (AutoAssociate) enabled.
- `"ComputationPreference"`:  The preferences and settings that will be used to compute the
  Amazon Web Services charges for a billing group.
- `"Description"`: A description of the billing group.
- `"Name"`: The name of the billing group. The names must be unique to each billing group.
- `"Status"`: The status of the billing group. Only one of the valid values can be used.
"""
function update_billing_group(Arn; aws_config::AbstractAWSConfig=current_aws_config())
    return billingconductor(
        "POST",
        "/update-billing-group",
        Dict{String,Any}("Arn" => Arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_billing_group(
    Arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return billingconductor(
        "POST",
        "/update-billing-group",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Arn" => Arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_custom_line_item(arn)
    update_custom_line_item(arn, params::Dict{String,<:Any})

 Update an existing custom line item in the current or previous billing period.

# Arguments
- `arn`:  The ARN of the custom line item to be updated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"BillingPeriodRange"`:
- `"ChargeDetails"`:  A ListCustomLineItemChargeDetails containing the new charge details
  for the custom line item.
- `"Description"`:  The new line item description of the custom line item.
- `"Name"`:  The new name for the custom line item.
"""
function update_custom_line_item(Arn; aws_config::AbstractAWSConfig=current_aws_config())
    return billingconductor(
        "POST",
        "/update-custom-line-item",
        Dict{String,Any}("Arn" => Arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_custom_line_item(
    Arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return billingconductor(
        "POST",
        "/update-custom-line-item",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Arn" => Arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_pricing_plan(arn)
    update_pricing_plan(arn, params::Dict{String,<:Any})

This updates an existing pricing plan.

# Arguments
- `arn`: The Amazon Resource Name (ARN) of the pricing plan that you're updating.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: The description of the pricing plan.
- `"Name"`: The name of the pricing plan. The name must be unique to each pricing plan.
"""
function update_pricing_plan(Arn; aws_config::AbstractAWSConfig=current_aws_config())
    return billingconductor(
        "PUT",
        "/update-pricing-plan",
        Dict{String,Any}("Arn" => Arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_pricing_plan(
    Arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return billingconductor(
        "PUT",
        "/update-pricing-plan",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Arn" => Arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_pricing_rule(arn)
    update_pricing_rule(arn, params::Dict{String,<:Any})

 Updates an existing pricing rule.

# Arguments
- `arn`:  The Amazon Resource Name (ARN) of the pricing rule to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`:  The new description for the pricing rule.
- `"ModifierPercentage"`:  The new modifier to show pricing plan rates as a percentage.
- `"Name"`:  The new name of the pricing rule. The name must be unique to each pricing
  rule.
- `"Tiering"`:  The set of tiering configurations for the pricing rule.
- `"Type"`:  The new pricing rule type.
"""
function update_pricing_rule(Arn; aws_config::AbstractAWSConfig=current_aws_config())
    return billingconductor(
        "PUT",
        "/update-pricing-rule",
        Dict{String,Any}("Arn" => Arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_pricing_rule(
    Arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return billingconductor(
        "PUT",
        "/update-pricing-rule",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Arn" => Arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: verifiedpermissions
using AWS.Compat
using AWS.UUIDs

"""
    batch_is_authorized(policy_store_id, requests)
    batch_is_authorized(policy_store_id, requests, params::Dict{String,<:Any})

Makes a series of decisions about multiple authorization requests for one principal or
resource. Each request contains the equivalent content of an IsAuthorized request:
principal, action, resource, and context. Either the principal or the resource parameter
must be identical across all requests. For example, Verified Permissions won't evaluate a
pair of requests where bob views photo1 and alice views photo2. Authorization of bob to
view photo1 and photo2, or bob and alice to view photo1, are valid batches.  The request is
evaluated against all policies in the specified policy store that match the entities that
you declare. The result of the decisions is a series of Allow or Deny responses, along with
the IDs of the policies that produced each decision. The entities of a BatchIsAuthorized
API request can contain up to 100 principals and up to 100 resources. The requests of a
BatchIsAuthorized API request can contain up to 30 requests.  The BatchIsAuthorized
operation doesn't have its own IAM permission. To authorize this operation for Amazon Web
Services principals, include the permission verifiedpermissions:IsAuthorized in their IAM
policies.

# Arguments
- `policy_store_id`: Specifies the ID of the policy store. Policies in this policy store
  will be used to make the authorization decisions for the input.
- `requests`: An array of up to 30 requests that you want Verified Permissions to evaluate.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"entities"`: Specifies the list of resources and principals and their associated
  attributes that Verified Permissions can examine when evaluating the policies.   You can
  include only principal and resource entities in this parameter; you can't include actions.
  You must specify actions in the schema.
"""
function batch_is_authorized(
    policyStoreId, requests; aws_config::AbstractAWSConfig=current_aws_config()
)
    return verifiedpermissions(
        "BatchIsAuthorized",
        Dict{String,Any}("policyStoreId" => policyStoreId, "requests" => requests);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_is_authorized(
    policyStoreId,
    requests,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return verifiedpermissions(
        "BatchIsAuthorized",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("policyStoreId" => policyStoreId, "requests" => requests),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_is_authorized_with_token(policy_store_id, requests)
    batch_is_authorized_with_token(policy_store_id, requests, params::Dict{String,<:Any})

Makes a series of decisions about multiple authorization requests for one token. The
principal in this request comes from an external identity source in the form of an identity
or access token, formatted as a JSON web token (JWT). The information in the parameters can
also define additional context that Verified Permissions can include in the evaluations.
The request is evaluated against all policies in the specified policy store that match the
entities that you provide in the entities declaration and in the token. The result of the
decisions is a series of Allow or Deny responses, along with the IDs of the policies that
produced each decision. The entities of a BatchIsAuthorizedWithToken API request can
contain up to 100 resources and up to 99 user groups. The requests of a
BatchIsAuthorizedWithToken API request can contain up to 30 requests.  The
BatchIsAuthorizedWithToken operation doesn't have its own IAM permission. To authorize this
operation for Amazon Web Services principals, include the permission
verifiedpermissions:IsAuthorizedWithToken in their IAM policies.

# Arguments
- `policy_store_id`: Specifies the ID of the policy store. Policies in this policy store
  will be used to make an authorization decision for the input.
- `requests`: An array of up to 30 requests that you want Verified Permissions to evaluate.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accessToken"`: Specifies an access token for the principal that you want to authorize
  in each request. This token is provided to you by the identity provider (IdP) associated
  with the specified identity source. You must specify either an accessToken, an
  identityToken, or both. Must be an access token. Verified Permissions returns an error if
  the token_use claim in the submitted token isn't access.
- `"entities"`: Specifies the list of resources and their associated attributes that
  Verified Permissions can examine when evaluating the policies.   You can't include
  principals in this parameter, only resource and action entities. This parameter can't
  include any entities of a type that matches the user or group entity types that you defined
  in your identity source.   The BatchIsAuthorizedWithToken operation takes principal
  attributes from  only  the identityToken or accessToken passed to the operation.   For
  action entities, you can include only their Identifier and EntityType.
- `"identityToken"`: Specifies an identity (ID) token for the principal that you want to
  authorize in each request. This token is provided to you by the identity provider (IdP)
  associated with the specified identity source. You must specify either an accessToken, an
  identityToken, or both. Must be an ID token. Verified Permissions returns an error if the
  token_use claim in the submitted token isn't id.
"""
function batch_is_authorized_with_token(
    policyStoreId, requests; aws_config::AbstractAWSConfig=current_aws_config()
)
    return verifiedpermissions(
        "BatchIsAuthorizedWithToken",
        Dict{String,Any}("policyStoreId" => policyStoreId, "requests" => requests);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_is_authorized_with_token(
    policyStoreId,
    requests,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return verifiedpermissions(
        "BatchIsAuthorizedWithToken",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("policyStoreId" => policyStoreId, "requests" => requests),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_identity_source(configuration, policy_store_id)
    create_identity_source(configuration, policy_store_id, params::Dict{String,<:Any})

Adds an identity source to a policy store–an Amazon Cognito user pool or OpenID Connect
(OIDC) identity provider (IdP).  After you create an identity source, you can use the
identities provided by the IdP as proxies for the principal in authorization queries that
use the IsAuthorizedWithToken or BatchIsAuthorizedWithToken API operations. These
identities take the form of tokens that contain claims about the user, such as IDs,
attributes and group memberships. Identity sources provide identity (ID) tokens and access
tokens. Verified Permissions derives information about your user and session from token
claims. Access tokens provide action context to your policies, and ID tokens provide
principal Attributes.  Tokens from an identity source user continue to be usable until they
expire. Token revocation and resource deletion have no effect on the validity of a token in
your policy store   To reference a user from this identity source in your Cedar policies,
refer to the following syntax examples.   Amazon Cognito user pool: Namespace::[Entity
type]::[User pool ID]|[user principal attribute], for example
MyCorp::User::us-east-1_EXAMPLE|a1b2c3d4-5678-90ab-cdef-EXAMPLE11111.   OpenID Connect
(OIDC) provider: Namespace::[Entity type]::[principalIdClaim]|[user principal attribute],
for example MyCorp::User::MyOIDCProvider|a1b2c3d4-5678-90ab-cdef-EXAMPLE22222.     Verified
Permissions is  eventually consistent . It can take a few seconds for a new or changed
element to propagate through the service and be visible in the results of other Verified
Permissions operations.

# Arguments
- `configuration`: Specifies the details required to communicate with the identity provider
  (IdP) associated with this identity source.
- `policy_store_id`: Specifies the ID of the policy store in which you want to store this
  identity source. Only policies and requests made using this policy store can reference
  identities from the identity provider configured in the new identity source.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Specifies a unique, case-sensitive ID that you provide to ensure the
  idempotency of the request. This lets you safely retry the request without accidentally
  performing the same operation a second time. Passing the same value to a later call to an
  operation requires that you also pass the same value for all other parameters. We recommend
  that you use a UUID type of value.. If you don't provide this value, then Amazon Web
  Services generates a random one for you. If you retry the operation with the same
  ClientToken, but with different parameters, the retry fails with an ConflictException
  error. Verified Permissions recognizes a ClientToken for eight hours. After eight hours,
  the next request with the same parameters performs the operation again regardless of the
  value of ClientToken.
- `"principalEntityType"`: Specifies the namespace and data type of the principals
  generated for identities authenticated by the new identity source.
"""
function create_identity_source(
    configuration, policyStoreId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return verifiedpermissions(
        "CreateIdentitySource",
        Dict{String,Any}(
            "configuration" => configuration,
            "policyStoreId" => policyStoreId,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_identity_source(
    configuration,
    policyStoreId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return verifiedpermissions(
        "CreateIdentitySource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "configuration" => configuration,
                    "policyStoreId" => policyStoreId,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_policy(definition, policy_store_id)
    create_policy(definition, policy_store_id, params::Dict{String,<:Any})

Creates a Cedar policy and saves it in the specified policy store. You can create either a
static policy or a policy linked to a policy template.   To create a static policy, provide
the Cedar policy text in the StaticPolicy section of the PolicyDefinition.   To create a
policy that is dynamically linked to a policy template, specify the policy template ID and
the principal and resource to associate with this policy in the templateLinked section of
the PolicyDefinition. If the policy template is ever updated, any policies linked to the
policy template automatically use the updated template.    Creating a policy causes it to
be validated against the schema in the policy store. If the policy doesn't pass validation,
the operation fails and the policy isn't stored.   Verified Permissions is  eventually
consistent . It can take a few seconds for a new or changed element to propagate through
the service and be visible in the results of other Verified Permissions operations.

# Arguments
- `definition`: A structure that specifies the policy type and content to use for the new
  policy. You must include either a static or a templateLinked element. The policy content
  must be written in the Cedar policy language.
- `policy_store_id`: Specifies the PolicyStoreId of the policy store you want to store the
  policy in.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Specifies a unique, case-sensitive ID that you provide to ensure the
  idempotency of the request. This lets you safely retry the request without accidentally
  performing the same operation a second time. Passing the same value to a later call to an
  operation requires that you also pass the same value for all other parameters. We recommend
  that you use a UUID type of value.. If you don't provide this value, then Amazon Web
  Services generates a random one for you. If you retry the operation with the same
  ClientToken, but with different parameters, the retry fails with an ConflictException
  error. Verified Permissions recognizes a ClientToken for eight hours. After eight hours,
  the next request with the same parameters performs the operation again regardless of the
  value of ClientToken.
"""
function create_policy(
    definition, policyStoreId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return verifiedpermissions(
        "CreatePolicy",
        Dict{String,Any}(
            "definition" => definition,
            "policyStoreId" => policyStoreId,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_policy(
    definition,
    policyStoreId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return verifiedpermissions(
        "CreatePolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "definition" => definition,
                    "policyStoreId" => policyStoreId,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_policy_store(validation_settings)
    create_policy_store(validation_settings, params::Dict{String,<:Any})

Creates a policy store. A policy store is a container for policy resources.  Although Cedar
supports multiple namespaces, Verified Permissions currently supports only one namespace
per policy store.   Verified Permissions is  eventually consistent . It can take a few
seconds for a new or changed element to propagate through the service and be visible in the
results of other Verified Permissions operations.

# Arguments
- `validation_settings`: Specifies the validation setting for this policy store. Currently,
  the only valid and required value is Mode.  We recommend that you turn on STRICT mode only
  after you define a schema. If a schema doesn't exist, then STRICT mode causes any policy to
  fail validation, and Verified Permissions rejects the policy. You can turn off validation
  by using the UpdatePolicyStore. Then, when you have a schema defined, use UpdatePolicyStore
  again to turn validation back on.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Specifies a unique, case-sensitive ID that you provide to ensure the
  idempotency of the request. This lets you safely retry the request without accidentally
  performing the same operation a second time. Passing the same value to a later call to an
  operation requires that you also pass the same value for all other parameters. We recommend
  that you use a UUID type of value.. If you don't provide this value, then Amazon Web
  Services generates a random one for you. If you retry the operation with the same
  ClientToken, but with different parameters, the retry fails with an ConflictException
  error. Verified Permissions recognizes a ClientToken for eight hours. After eight hours,
  the next request with the same parameters performs the operation again regardless of the
  value of ClientToken.
- `"description"`: Descriptive text that you can provide to help with identification of the
  current policy store.
"""
function create_policy_store(
    validationSettings; aws_config::AbstractAWSConfig=current_aws_config()
)
    return verifiedpermissions(
        "CreatePolicyStore",
        Dict{String,Any}(
            "validationSettings" => validationSettings, "clientToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_policy_store(
    validationSettings,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return verifiedpermissions(
        "CreatePolicyStore",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "validationSettings" => validationSettings,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_policy_template(policy_store_id, statement)
    create_policy_template(policy_store_id, statement, params::Dict{String,<:Any})

Creates a policy template. A template can use placeholders for the principal and resource.
A template must be instantiated into a policy by associating it with specific principals
and resources to use for the placeholders. That instantiated policy can then be considered
in authorization decisions. The instantiated policy works identically to any other policy,
except that it is dynamically linked to the template. If the template changes, then any
policies that are linked to that template are immediately updated as well.  Verified
Permissions is  eventually consistent . It can take a few seconds for a new or changed
element to propagate through the service and be visible in the results of other Verified
Permissions operations.

# Arguments
- `policy_store_id`: The ID of the policy store in which to create the policy template.
- `statement`: Specifies the content that you want to use for the new policy template,
  written in the Cedar policy language.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Specifies a unique, case-sensitive ID that you provide to ensure the
  idempotency of the request. This lets you safely retry the request without accidentally
  performing the same operation a second time. Passing the same value to a later call to an
  operation requires that you also pass the same value for all other parameters. We recommend
  that you use a UUID type of value.. If you don't provide this value, then Amazon Web
  Services generates a random one for you. If you retry the operation with the same
  ClientToken, but with different parameters, the retry fails with an ConflictException
  error. Verified Permissions recognizes a ClientToken for eight hours. After eight hours,
  the next request with the same parameters performs the operation again regardless of the
  value of ClientToken.
- `"description"`: Specifies a description for the policy template.
"""
function create_policy_template(
    policyStoreId, statement; aws_config::AbstractAWSConfig=current_aws_config()
)
    return verifiedpermissions(
        "CreatePolicyTemplate",
        Dict{String,Any}(
            "policyStoreId" => policyStoreId,
            "statement" => statement,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_policy_template(
    policyStoreId,
    statement,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return verifiedpermissions(
        "CreatePolicyTemplate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "policyStoreId" => policyStoreId,
                    "statement" => statement,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_identity_source(identity_source_id, policy_store_id)
    delete_identity_source(identity_source_id, policy_store_id, params::Dict{String,<:Any})

Deletes an identity source that references an identity provider (IdP) such as Amazon
Cognito. After you delete the identity source, you can no longer use tokens for identities
from that identity source to represent principals in authorization queries made using
IsAuthorizedWithToken. operations.

# Arguments
- `identity_source_id`: Specifies the ID of the identity source that you want to delete.
- `policy_store_id`: Specifies the ID of the policy store that contains the identity source
  that you want to delete.

"""
function delete_identity_source(
    identitySourceId, policyStoreId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return verifiedpermissions(
        "DeleteIdentitySource",
        Dict{String,Any}(
            "identitySourceId" => identitySourceId, "policyStoreId" => policyStoreId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_identity_source(
    identitySourceId,
    policyStoreId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return verifiedpermissions(
        "DeleteIdentitySource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "identitySourceId" => identitySourceId, "policyStoreId" => policyStoreId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_policy(policy_id, policy_store_id)
    delete_policy(policy_id, policy_store_id, params::Dict{String,<:Any})

Deletes the specified policy from the policy store. This operation is idempotent; if you
specify a policy that doesn't exist, the request response returns a successful HTTP 200
status code.

# Arguments
- `policy_id`: Specifies the ID of the policy that you want to delete.
- `policy_store_id`: Specifies the ID of the policy store that contains the policy that you
  want to delete.

"""
function delete_policy(
    policyId, policyStoreId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return verifiedpermissions(
        "DeletePolicy",
        Dict{String,Any}("policyId" => policyId, "policyStoreId" => policyStoreId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_policy(
    policyId,
    policyStoreId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return verifiedpermissions(
        "DeletePolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("policyId" => policyId, "policyStoreId" => policyStoreId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_policy_store(policy_store_id)
    delete_policy_store(policy_store_id, params::Dict{String,<:Any})

Deletes the specified policy store. This operation is idempotent. If you specify a policy
store that does not exist, the request response will still return a successful HTTP 200
status code.

# Arguments
- `policy_store_id`: Specifies the ID of the policy store that you want to delete.

"""
function delete_policy_store(
    policyStoreId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return verifiedpermissions(
        "DeletePolicyStore",
        Dict{String,Any}("policyStoreId" => policyStoreId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_policy_store(
    policyStoreId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return verifiedpermissions(
        "DeletePolicyStore",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("policyStoreId" => policyStoreId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_policy_template(policy_store_id, policy_template_id)
    delete_policy_template(policy_store_id, policy_template_id, params::Dict{String,<:Any})

Deletes the specified policy template from the policy store.  This operation also deletes
any policies that were created from the specified policy template. Those policies are
immediately removed from all future API responses, and are asynchronously deleted from the
policy store.

# Arguments
- `policy_store_id`: Specifies the ID of the policy store that contains the policy template
  that you want to delete.
- `policy_template_id`: Specifies the ID of the policy template that you want to delete.

"""
function delete_policy_template(
    policyStoreId, policyTemplateId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return verifiedpermissions(
        "DeletePolicyTemplate",
        Dict{String,Any}(
            "policyStoreId" => policyStoreId, "policyTemplateId" => policyTemplateId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_policy_template(
    policyStoreId,
    policyTemplateId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return verifiedpermissions(
        "DeletePolicyTemplate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "policyStoreId" => policyStoreId, "policyTemplateId" => policyTemplateId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_identity_source(identity_source_id, policy_store_id)
    get_identity_source(identity_source_id, policy_store_id, params::Dict{String,<:Any})

Retrieves the details about the specified identity source.

# Arguments
- `identity_source_id`: Specifies the ID of the identity source you want information about.
- `policy_store_id`: Specifies the ID of the policy store that contains the identity source
  you want information about.

"""
function get_identity_source(
    identitySourceId, policyStoreId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return verifiedpermissions(
        "GetIdentitySource",
        Dict{String,Any}(
            "identitySourceId" => identitySourceId, "policyStoreId" => policyStoreId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_identity_source(
    identitySourceId,
    policyStoreId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return verifiedpermissions(
        "GetIdentitySource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "identitySourceId" => identitySourceId, "policyStoreId" => policyStoreId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_policy(policy_id, policy_store_id)
    get_policy(policy_id, policy_store_id, params::Dict{String,<:Any})

Retrieves information about the specified policy.

# Arguments
- `policy_id`: Specifies the ID of the policy you want information about.
- `policy_store_id`: Specifies the ID of the policy store that contains the policy that you
  want information about.

"""
function get_policy(
    policyId, policyStoreId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return verifiedpermissions(
        "GetPolicy",
        Dict{String,Any}("policyId" => policyId, "policyStoreId" => policyStoreId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_policy(
    policyId,
    policyStoreId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return verifiedpermissions(
        "GetPolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("policyId" => policyId, "policyStoreId" => policyStoreId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_policy_store(policy_store_id)
    get_policy_store(policy_store_id, params::Dict{String,<:Any})

Retrieves details about a policy store.

# Arguments
- `policy_store_id`: Specifies the ID of the policy store that you want information about.

"""
function get_policy_store(policyStoreId; aws_config::AbstractAWSConfig=current_aws_config())
    return verifiedpermissions(
        "GetPolicyStore",
        Dict{String,Any}("policyStoreId" => policyStoreId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_policy_store(
    policyStoreId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return verifiedpermissions(
        "GetPolicyStore",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("policyStoreId" => policyStoreId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_policy_template(policy_store_id, policy_template_id)
    get_policy_template(policy_store_id, policy_template_id, params::Dict{String,<:Any})

Retrieve the details for the specified policy template in the specified policy store.

# Arguments
- `policy_store_id`: Specifies the ID of the policy store that contains the policy template
  that you want information about.
- `policy_template_id`: Specifies the ID of the policy template that you want information
  about.

"""
function get_policy_template(
    policyStoreId, policyTemplateId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return verifiedpermissions(
        "GetPolicyTemplate",
        Dict{String,Any}(
            "policyStoreId" => policyStoreId, "policyTemplateId" => policyTemplateId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_policy_template(
    policyStoreId,
    policyTemplateId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return verifiedpermissions(
        "GetPolicyTemplate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "policyStoreId" => policyStoreId, "policyTemplateId" => policyTemplateId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_schema(policy_store_id)
    get_schema(policy_store_id, params::Dict{String,<:Any})

Retrieve the details for the specified schema in the specified policy store.

# Arguments
- `policy_store_id`: Specifies the ID of the policy store that contains the schema.

"""
function get_schema(policyStoreId; aws_config::AbstractAWSConfig=current_aws_config())
    return verifiedpermissions(
        "GetSchema",
        Dict{String,Any}("policyStoreId" => policyStoreId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_schema(
    policyStoreId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return verifiedpermissions(
        "GetSchema",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("policyStoreId" => policyStoreId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    is_authorized(policy_store_id)
    is_authorized(policy_store_id, params::Dict{String,<:Any})

Makes an authorization decision about a service request described in the parameters. The
information in the parameters can also define additional context that Verified Permissions
can include in the evaluation. The request is evaluated against all matching policies in
the specified policy store. The result of the decision is either Allow or Deny, along with
a list of the policies that resulted in the decision.

# Arguments
- `policy_store_id`: Specifies the ID of the policy store. Policies in this policy store
  will be used to make an authorization decision for the input.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"action"`: Specifies the requested action to be authorized. For example, is the
  principal authorized to perform this action on the resource?
- `"context"`: Specifies additional context that can be used to make more granular
  authorization decisions.
- `"entities"`: Specifies the list of resources and principals and their associated
  attributes that Verified Permissions can examine when evaluating the policies.   You can
  include only principal and resource entities in this parameter; you can't include actions.
  You must specify actions in the schema.
- `"principal"`: Specifies the principal for which the authorization decision is to be made.
- `"resource"`: Specifies the resource for which the authorization decision is to be made.
"""
function is_authorized(policyStoreId; aws_config::AbstractAWSConfig=current_aws_config())
    return verifiedpermissions(
        "IsAuthorized",
        Dict{String,Any}("policyStoreId" => policyStoreId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function is_authorized(
    policyStoreId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return verifiedpermissions(
        "IsAuthorized",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("policyStoreId" => policyStoreId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    is_authorized_with_token(policy_store_id)
    is_authorized_with_token(policy_store_id, params::Dict{String,<:Any})

Makes an authorization decision about a service request described in the parameters. The
principal in this request comes from an external identity source in the form of an identity
token formatted as a JSON web token (JWT). The information in the parameters can also
define additional context that Verified Permissions can include in the evaluation. The
request is evaluated against all matching policies in the specified policy store. The
result of the decision is either Allow or Deny, along with a list of the policies that
resulted in the decision. At this time, Verified Permissions accepts tokens from only
Amazon Cognito. Verified Permissions validates each token that is specified in a request by
checking its expiration date and its signature.  Tokens from an identity source user
continue to be usable until they expire. Token revocation and resource deletion have no
effect on the validity of a token in your policy store

# Arguments
- `policy_store_id`: Specifies the ID of the policy store. Policies in this policy store
  will be used to make an authorization decision for the input.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accessToken"`: Specifies an access token for the principal to be authorized. This token
  is provided to you by the identity provider (IdP) associated with the specified identity
  source. You must specify either an accessToken, an identityToken, or both. Must be an
  access token. Verified Permissions returns an error if the token_use claim in the submitted
  token isn't access.
- `"action"`: Specifies the requested action to be authorized. Is the specified principal
  authorized to perform this action on the specified resource.
- `"context"`: Specifies additional context that can be used to make more granular
  authorization decisions.
- `"entities"`: Specifies the list of resources and their associated attributes that
  Verified Permissions can examine when evaluating the policies.   You can't include
  principals in this parameter, only resource and action entities. This parameter can't
  include any entities of a type that matches the user or group entity types that you defined
  in your identity source.   The IsAuthorizedWithToken operation takes principal attributes
  from  only  the identityToken or accessToken passed to the operation.   For action
  entities, you can include only their Identifier and EntityType.
- `"identityToken"`: Specifies an identity token for the principal to be authorized. This
  token is provided to you by the identity provider (IdP) associated with the specified
  identity source. You must specify either an accessToken, an identityToken, or both. Must be
  an ID token. Verified Permissions returns an error if the token_use claim in the submitted
  token isn't id.
- `"resource"`: Specifies the resource for which the authorization decision is made. For
  example, is the principal allowed to perform the action on the resource?
"""
function is_authorized_with_token(
    policyStoreId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return verifiedpermissions(
        "IsAuthorizedWithToken",
        Dict{String,Any}("policyStoreId" => policyStoreId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function is_authorized_with_token(
    policyStoreId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return verifiedpermissions(
        "IsAuthorizedWithToken",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("policyStoreId" => policyStoreId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_identity_sources(policy_store_id)
    list_identity_sources(policy_store_id, params::Dict{String,<:Any})

Returns a paginated list of all of the identity sources defined in the specified policy
store.

# Arguments
- `policy_store_id`: Specifies the ID of the policy store that contains the identity
  sources that you want to list.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: Specifies characteristics of an identity source that you can use to limit
  the output to matching identity sources.
- `"maxResults"`: Specifies the total number of results that you want included in each
  response. If additional items exist beyond the number you specify, the NextToken response
  element is returned with a value (not null). Include the specified value as the NextToken
  request parameter in the next call to the operation to get the next set of results. Note
  that the service might return fewer results than the maximum even when there are more
  results available. You should check NextToken after every operation to ensure that you
  receive all of the results. If you do not specify this parameter, the operation defaults to
  10 identity sources per response. You can specify a maximum of 50 identity sources per
  response.
- `"nextToken"`: Specifies that you want to receive the next page of results. Valid only if
  you received a NextToken response in the previous request. If you did, it indicates that
  more output is available. Set this parameter to the value provided by the previous call's
  NextToken response to request the next page of results.
"""
function list_identity_sources(
    policyStoreId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return verifiedpermissions(
        "ListIdentitySources",
        Dict{String,Any}("policyStoreId" => policyStoreId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_identity_sources(
    policyStoreId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return verifiedpermissions(
        "ListIdentitySources",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("policyStoreId" => policyStoreId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_policies(policy_store_id)
    list_policies(policy_store_id, params::Dict{String,<:Any})

Returns a paginated list of all policies stored in the specified policy store.

# Arguments
- `policy_store_id`: Specifies the ID of the policy store you want to list policies from.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filter"`: Specifies a filter that limits the response to only policies that match the
  specified criteria. For example, you list only the policies that reference a specified
  principal.
- `"maxResults"`: Specifies the total number of results that you want included in each
  response. If additional items exist beyond the number you specify, the NextToken response
  element is returned with a value (not null). Include the specified value as the NextToken
  request parameter in the next call to the operation to get the next set of results. Note
  that the service might return fewer results than the maximum even when there are more
  results available. You should check NextToken after every operation to ensure that you
  receive all of the results. If you do not specify this parameter, the operation defaults to
  10 policies per response. You can specify a maximum of 50 policies per response.
- `"nextToken"`: Specifies that you want to receive the next page of results. Valid only if
  you received a NextToken response in the previous request. If you did, it indicates that
  more output is available. Set this parameter to the value provided by the previous call's
  NextToken response to request the next page of results.
"""
function list_policies(policyStoreId; aws_config::AbstractAWSConfig=current_aws_config())
    return verifiedpermissions(
        "ListPolicies",
        Dict{String,Any}("policyStoreId" => policyStoreId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_policies(
    policyStoreId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return verifiedpermissions(
        "ListPolicies",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("policyStoreId" => policyStoreId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_policy_stores()
    list_policy_stores(params::Dict{String,<:Any})

Returns a paginated list of all policy stores in the calling Amazon Web Services account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Specifies the total number of results that you want included in each
  response. If additional items exist beyond the number you specify, the NextToken response
  element is returned with a value (not null). Include the specified value as the NextToken
  request parameter in the next call to the operation to get the next set of results. Note
  that the service might return fewer results than the maximum even when there are more
  results available. You should check NextToken after every operation to ensure that you
  receive all of the results. If you do not specify this parameter, the operation defaults to
  10 policy stores per response. You can specify a maximum of 50 policy stores per response.
- `"nextToken"`: Specifies that you want to receive the next page of results. Valid only if
  you received a NextToken response in the previous request. If you did, it indicates that
  more output is available. Set this parameter to the value provided by the previous call's
  NextToken response to request the next page of results.
"""
function list_policy_stores(; aws_config::AbstractAWSConfig=current_aws_config())
    return verifiedpermissions(
        "ListPolicyStores"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_policy_stores(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return verifiedpermissions(
        "ListPolicyStores", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_policy_templates(policy_store_id)
    list_policy_templates(policy_store_id, params::Dict{String,<:Any})

Returns a paginated list of all policy templates in the specified policy store.

# Arguments
- `policy_store_id`: Specifies the ID of the policy store that contains the policy
  templates you want to list.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Specifies the total number of results that you want included in each
  response. If additional items exist beyond the number you specify, the NextToken response
  element is returned with a value (not null). Include the specified value as the NextToken
  request parameter in the next call to the operation to get the next set of results. Note
  that the service might return fewer results than the maximum even when there are more
  results available. You should check NextToken after every operation to ensure that you
  receive all of the results. If you do not specify this parameter, the operation defaults to
  10 policy templates per response. You can specify a maximum of 50 policy templates per
  response.
- `"nextToken"`: Specifies that you want to receive the next page of results. Valid only if
  you received a NextToken response in the previous request. If you did, it indicates that
  more output is available. Set this parameter to the value provided by the previous call's
  NextToken response to request the next page of results.
"""
function list_policy_templates(
    policyStoreId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return verifiedpermissions(
        "ListPolicyTemplates",
        Dict{String,Any}("policyStoreId" => policyStoreId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_policy_templates(
    policyStoreId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return verifiedpermissions(
        "ListPolicyTemplates",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("policyStoreId" => policyStoreId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_schema(definition, policy_store_id)
    put_schema(definition, policy_store_id, params::Dict{String,<:Any})

Creates or updates the policy schema in the specified policy store. The schema is used to
validate any Cedar policies and policy templates submitted to the policy store. Any changes
to the schema validate only policies and templates submitted after the schema change.
Existing policies and templates are not re-evaluated against the changed schema. If you
later update a policy, then it is evaluated against the new schema at that time.  Verified
Permissions is  eventually consistent . It can take a few seconds for a new or changed
element to propagate through the service and be visible in the results of other Verified
Permissions operations.

# Arguments
- `definition`: Specifies the definition of the schema to be stored. The schema definition
  must be written in Cedar schema JSON.
- `policy_store_id`: Specifies the ID of the policy store in which to place the schema.

"""
function put_schema(
    definition, policyStoreId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return verifiedpermissions(
        "PutSchema",
        Dict{String,Any}("definition" => definition, "policyStoreId" => policyStoreId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_schema(
    definition,
    policyStoreId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return verifiedpermissions(
        "PutSchema",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "definition" => definition, "policyStoreId" => policyStoreId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_identity_source(identity_source_id, policy_store_id, update_configuration)
    update_identity_source(identity_source_id, policy_store_id, update_configuration, params::Dict{String,<:Any})

Updates the specified identity source to use a new identity provider (IdP), or to change
the mapping of identities from the IdP to a different principal entity type.  Verified
Permissions is  eventually consistent . It can take a few seconds for a new or changed
element to propagate through the service and be visible in the results of other Verified
Permissions operations.

# Arguments
- `identity_source_id`: Specifies the ID of the identity source that you want to update.
- `policy_store_id`: Specifies the ID of the policy store that contains the identity source
  that you want to update.
- `update_configuration`: Specifies the details required to communicate with the identity
  provider (IdP) associated with this identity source.  At this time, the only valid member
  of this structure is a Amazon Cognito user pool configuration. You must specify a
  userPoolArn, and optionally, a ClientId.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"principalEntityType"`: Specifies the data type of principals generated for identities
  authenticated by the identity source.
"""
function update_identity_source(
    identitySourceId,
    policyStoreId,
    updateConfiguration;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return verifiedpermissions(
        "UpdateIdentitySource",
        Dict{String,Any}(
            "identitySourceId" => identitySourceId,
            "policyStoreId" => policyStoreId,
            "updateConfiguration" => updateConfiguration,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_identity_source(
    identitySourceId,
    policyStoreId,
    updateConfiguration,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return verifiedpermissions(
        "UpdateIdentitySource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "identitySourceId" => identitySourceId,
                    "policyStoreId" => policyStoreId,
                    "updateConfiguration" => updateConfiguration,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_policy(definition, policy_id, policy_store_id)
    update_policy(definition, policy_id, policy_store_id, params::Dict{String,<:Any})

Modifies a Cedar static policy in the specified policy store. You can change only certain
elements of the UpdatePolicyDefinition parameter. You can directly update only static
policies. To change a template-linked policy, you must update the template instead, using
UpdatePolicyTemplate.    If policy validation is enabled in the policy store, then updating
a static policy causes Verified Permissions to validate the policy against the schema in
the policy store. If the updated static policy doesn't pass validation, the operation fails
and the update isn't stored.   When you edit a static policy, you can change only certain
elements of a static policy:   The action referenced by the policy.    A condition clause,
such as when and unless.    You can't change these elements of a static policy:    Changing
a policy from a static policy to a template-linked policy.    Changing the effect of a
static policy from permit or forbid.    The principal referenced by a static policy.    The
resource referenced by a static policy.      To update a template-linked policy, you must
update the template instead.      Verified Permissions is  eventually consistent . It can
take a few seconds for a new or changed element to propagate through the service and be
visible in the results of other Verified Permissions operations.

# Arguments
- `definition`: Specifies the updated policy content that you want to replace on the
  specified policy. The content must be valid Cedar policy language text. You can change only
  the following elements from the policy definition:   The action referenced by the policy.
  Any conditional clauses, such as when or unless clauses.   You can't change the following
  elements:   Changing from static to templateLinked.   Changing the effect of the policy
  from permit or forbid.   The principal referenced by the policy.   The resource referenced
  by the policy.
- `policy_id`: Specifies the ID of the policy that you want to update. To find this value,
  you can use ListPolicies.
- `policy_store_id`: Specifies the ID of the policy store that contains the policy that you
  want to update.

"""
function update_policy(
    definition, policyId, policyStoreId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return verifiedpermissions(
        "UpdatePolicy",
        Dict{String,Any}(
            "definition" => definition,
            "policyId" => policyId,
            "policyStoreId" => policyStoreId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_policy(
    definition,
    policyId,
    policyStoreId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return verifiedpermissions(
        "UpdatePolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "definition" => definition,
                    "policyId" => policyId,
                    "policyStoreId" => policyStoreId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_policy_store(policy_store_id, validation_settings)
    update_policy_store(policy_store_id, validation_settings, params::Dict{String,<:Any})

Modifies the validation setting for a policy store.  Verified Permissions is  eventually
consistent . It can take a few seconds for a new or changed element to propagate through
the service and be visible in the results of other Verified Permissions operations.

# Arguments
- `policy_store_id`: Specifies the ID of the policy store that you want to update
- `validation_settings`: A structure that defines the validation settings that want to
  enable for the policy store.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: Descriptive text that you can provide to help with identification of the
  current policy store.
"""
function update_policy_store(
    policyStoreId, validationSettings; aws_config::AbstractAWSConfig=current_aws_config()
)
    return verifiedpermissions(
        "UpdatePolicyStore",
        Dict{String,Any}(
            "policyStoreId" => policyStoreId, "validationSettings" => validationSettings
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_policy_store(
    policyStoreId,
    validationSettings,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return verifiedpermissions(
        "UpdatePolicyStore",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "policyStoreId" => policyStoreId,
                    "validationSettings" => validationSettings,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_policy_template(policy_store_id, policy_template_id, statement)
    update_policy_template(policy_store_id, policy_template_id, statement, params::Dict{String,<:Any})

Updates the specified policy template. You can update only the description and the some
elements of the policyBody.   Changes you make to the policy template content are
immediately (within the constraints of eventual consistency) reflected in authorization
decisions that involve all template-linked policies instantiated from this template.
Verified Permissions is  eventually consistent . It can take a few seconds for a new or
changed element to propagate through the service and be visible in the results of other
Verified Permissions operations.

# Arguments
- `policy_store_id`: Specifies the ID of the policy store that contains the policy template
  that you want to update.
- `policy_template_id`: Specifies the ID of the policy template that you want to update.
- `statement`: Specifies new statement content written in Cedar policy language to replace
  the current body of the policy template. You can change only the following elements of the
  policy body:   The action referenced by the policy template.   Any conditional clauses,
  such as when or unless clauses.   You can't change the following elements:   The effect
  (permit or forbid) of the policy template.   The principal referenced by the policy
  template.   The resource referenced by the policy template.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: Specifies a new description to apply to the policy template.
"""
function update_policy_template(
    policyStoreId,
    policyTemplateId,
    statement;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return verifiedpermissions(
        "UpdatePolicyTemplate",
        Dict{String,Any}(
            "policyStoreId" => policyStoreId,
            "policyTemplateId" => policyTemplateId,
            "statement" => statement,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_policy_template(
    policyStoreId,
    policyTemplateId,
    statement,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return verifiedpermissions(
        "UpdatePolicyTemplate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "policyStoreId" => policyStoreId,
                    "policyTemplateId" => policyTemplateId,
                    "statement" => statement,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: signer
using AWS.Compat
using AWS.UUIDs

"""
    add_profile_permission(action, principal, profile_name, statement_id)
    add_profile_permission(action, principal, profile_name, statement_id, params::Dict{String,<:Any})

Adds cross-account permissions to a signing profile.

# Arguments
- `action`: For cross-account signing. Grant a designated account permission to perform one
  or more of the following actions. Each action is associated with a specific API's
  operations. For more information about cross-account signing, see Using cross-account
  signing with signing profiles in the AWS Signer Developer Guide. You can designate the
  following actions to an account.    signer:StartSigningJob. This action isn't supported for
  container image workflows. For details, see StartSigningJob.    signer:SignPayload. This
  action isn't supported for AWS Lambda workflows. For details, see SignPayload
  signer:GetSigningProfile. For details, see GetSigningProfile.    signer:RevokeSignature.
  For details, see RevokeSignature.
- `principal`: The AWS principal receiving cross-account permissions. This may be an IAM
  role or another AWS account ID.
- `profile_name`: The human-readable name of the signing profile.
- `statement_id`: A unique identifier for the cross-account permission statement.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"profileVersion"`: The version of the signing profile.
- `"revisionId"`: A unique identifier for the current profile revision.
"""
function add_profile_permission(
    action,
    principal,
    profileName,
    statementId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return signer(
        "POST",
        "/signing-profiles/$(profileName)/permissions",
        Dict{String,Any}(
            "action" => action, "principal" => principal, "statementId" => statementId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_profile_permission(
    action,
    principal,
    profileName,
    statementId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return signer(
        "POST",
        "/signing-profiles/$(profileName)/permissions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "action" => action,
                    "principal" => principal,
                    "statementId" => statementId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_signing_profile(profile_name)
    cancel_signing_profile(profile_name, params::Dict{String,<:Any})

Changes the state of an ACTIVE signing profile to CANCELED. A canceled profile is still
viewable with the ListSigningProfiles operation, but it cannot perform new signing jobs,
and is deleted two years after cancelation.

# Arguments
- `profile_name`: The name of the signing profile to be canceled.

"""
function cancel_signing_profile(
    profileName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return signer(
        "DELETE",
        "/signing-profiles/$(profileName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_signing_profile(
    profileName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return signer(
        "DELETE",
        "/signing-profiles/$(profileName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_signing_job(job_id)
    describe_signing_job(job_id, params::Dict{String,<:Any})

Returns information about a specific code signing job. You specify the job by using the
jobId value that is returned by the StartSigningJob operation.

# Arguments
- `job_id`: The ID of the signing job on input.

"""
function describe_signing_job(jobId; aws_config::AbstractAWSConfig=current_aws_config())
    return signer(
        "GET",
        "/signing-jobs/$(jobId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_signing_job(
    jobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return signer(
        "GET",
        "/signing-jobs/$(jobId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_revocation_status(certificate_hashes, job_arn, platform_id, profile_version_arn, signature_timestamp)
    get_revocation_status(certificate_hashes, job_arn, platform_id, profile_version_arn, signature_timestamp, params::Dict{String,<:Any})

Retrieves the revocation status of one or more of the signing profile, signing job, and
signing certificate.

# Arguments
- `certificate_hashes`: A list of composite signed hashes that identify certificates. A
  certificate identifier consists of a subject certificate TBS hash (signed by the parent CA)
  combined with a parent CA TBS hash (signed by the parent CA’s CA). Root certificates are
  defined as their own CA. The following example shows how to calculate a hash for this
  parameter using OpenSSL commands:   openssl asn1parse -in childCert.pem -strparse 4 -out
  childCert.tbs   openssl sha384 &lt; childCert.tbs -binary &gt; childCertTbsHash   openssl
  asn1parse -in parentCert.pem -strparse 4 -out parentCert.tbs   openssl sha384 &lt;
  parentCert.tbs -binary &gt; parentCertTbsHash xxd -p childCertTbsHash &gt;
  certificateHash.hex xxd -p parentCertTbsHash &gt;&gt; certificateHash.hex   cat
  certificateHash.hex | tr -d 'n'
- `job_arn`: The ARN of a signing job.
- `platform_id`: The ID of a signing platform.
- `profile_version_arn`: The version of a signing profile.
- `signature_timestamp`: The timestamp of the signature that validates the profile or job.

"""
function get_revocation_status(
    certificateHashes,
    jobArn,
    platformId,
    profileVersionArn,
    signatureTimestamp;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return signer(
        "GET",
        "/revocations",
        Dict{String,Any}(
            "certificateHashes" => certificateHashes,
            "jobArn" => jobArn,
            "platformId" => platformId,
            "profileVersionArn" => profileVersionArn,
            "signatureTimestamp" => signatureTimestamp,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_revocation_status(
    certificateHashes,
    jobArn,
    platformId,
    profileVersionArn,
    signatureTimestamp,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return signer(
        "GET",
        "/revocations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "certificateHashes" => certificateHashes,
                    "jobArn" => jobArn,
                    "platformId" => platformId,
                    "profileVersionArn" => profileVersionArn,
                    "signatureTimestamp" => signatureTimestamp,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_signing_platform(platform_id)
    get_signing_platform(platform_id, params::Dict{String,<:Any})

Returns information on a specific signing platform.

# Arguments
- `platform_id`: The ID of the target signing platform.

"""
function get_signing_platform(
    platformId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return signer(
        "GET",
        "/signing-platforms/$(platformId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_signing_platform(
    platformId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return signer(
        "GET",
        "/signing-platforms/$(platformId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_signing_profile(profile_name)
    get_signing_profile(profile_name, params::Dict{String,<:Any})

Returns information on a specific signing profile.

# Arguments
- `profile_name`: The name of the target signing profile.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"profileOwner"`: The AWS account ID of the profile owner.
"""
function get_signing_profile(
    profileName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return signer(
        "GET",
        "/signing-profiles/$(profileName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_signing_profile(
    profileName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return signer(
        "GET",
        "/signing-profiles/$(profileName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_profile_permissions(profile_name)
    list_profile_permissions(profile_name, params::Dict{String,<:Any})

Lists the cross-account permissions associated with a signing profile.

# Arguments
- `profile_name`: Name of the signing profile containing the cross-account permissions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: String for specifying the next set of paginated results.
"""
function list_profile_permissions(
    profileName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return signer(
        "GET",
        "/signing-profiles/$(profileName)/permissions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_profile_permissions(
    profileName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return signer(
        "GET",
        "/signing-profiles/$(profileName)/permissions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_signing_jobs()
    list_signing_jobs(params::Dict{String,<:Any})

Lists all your signing jobs. You can use the maxResults parameter to limit the number of
signing jobs that are returned in the response. If additional jobs remain to be listed, AWS
Signer returns a nextToken value. Use this value in subsequent calls to ListSigningJobs to
fetch the remaining values. You can continue calling ListSigningJobs with your maxResults
parameter and with new values that Signer returns in the nextToken parameter until all of
your signing jobs have been returned.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"isRevoked"`: Filters results to return only signing jobs with revoked signatures.
- `"jobInvoker"`: Filters results to return only signing jobs initiated by a specified IAM
  entity.
- `"maxResults"`: Specifies the maximum number of items to return in the response. Use this
  parameter when paginating results. If additional items exist beyond the number you specify,
  the nextToken element is set in the response. Use the nextToken value in a subsequent
  request to retrieve additional items.
- `"nextToken"`: String for specifying the next set of paginated results to return. After
  you receive a response with truncated results, use this parameter in a subsequent request.
  Set it to the value of nextToken from the response that you just received.
- `"platformId"`: The ID of microcontroller platform that you specified for the
  distribution of your code image.
- `"requestedBy"`: The IAM principal that requested the signing job.
- `"signatureExpiresAfter"`: Filters results to return only signing jobs with signatures
  expiring after a specified timestamp.
- `"signatureExpiresBefore"`: Filters results to return only signing jobs with signatures
  expiring before a specified timestamp.
- `"status"`: A status value with which to filter your results.
"""
function list_signing_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return signer(
        "GET", "/signing-jobs"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_signing_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return signer(
        "GET",
        "/signing-jobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_signing_platforms()
    list_signing_platforms(params::Dict{String,<:Any})

Lists all signing platforms available in AWS Signer that match the request parameters. If
additional jobs remain to be listed, Signer returns a nextToken value. Use this value in
subsequent calls to ListSigningJobs to fetch the remaining values. You can continue calling
ListSigningJobs with your maxResults parameter and with new values that Signer returns in
the nextToken parameter until all of your signing jobs have been returned.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"category"`: The category type of a signing platform.
- `"maxResults"`: The maximum number of results to be returned by this operation.
- `"nextToken"`: Value for specifying the next set of paginated results to return. After
  you receive a response with truncated results, use this parameter in a subsequent request.
  Set it to the value of nextToken from the response that you just received.
- `"partner"`: Any partner entities connected to a signing platform.
- `"target"`: The validation template that is used by the target signing platform.
"""
function list_signing_platforms(; aws_config::AbstractAWSConfig=current_aws_config())
    return signer(
        "GET", "/signing-platforms"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_signing_platforms(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return signer(
        "GET",
        "/signing-platforms",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_signing_profiles()
    list_signing_profiles(params::Dict{String,<:Any})

Lists all available signing profiles in your AWS account. Returns only profiles with an
ACTIVE status unless the includeCanceled request field is set to true. If additional jobs
remain to be listed, AWS Signer returns a nextToken value. Use this value in subsequent
calls to ListSigningJobs to fetch the remaining values. You can continue calling
ListSigningJobs with your maxResults parameter and with new values that Signer returns in
the nextToken parameter until all of your signing jobs have been returned.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"includeCanceled"`: Designates whether to include profiles with the status of CANCELED.
- `"maxResults"`: The maximum number of profiles to be returned.
- `"nextToken"`: Value for specifying the next set of paginated results to return. After
  you receive a response with truncated results, use this parameter in a subsequent request.
  Set it to the value of nextToken from the response that you just received.
- `"platformId"`: Filters results to return only signing jobs initiated for a specified
  signing platform.
- `"statuses"`: Filters results to return only signing jobs with statuses in the specified
  list.
"""
function list_signing_profiles(; aws_config::AbstractAWSConfig=current_aws_config())
    return signer(
        "GET", "/signing-profiles"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_signing_profiles(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return signer(
        "GET",
        "/signing-profiles",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Returns a list of the tags associated with a signing profile resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) for the signing profile.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return signer(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return signer(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_signing_profile(platform_id, profile_name)
    put_signing_profile(platform_id, profile_name, params::Dict{String,<:Any})

Creates a signing profile. A signing profile is a code-signing template that can be used to
carry out a pre-defined signing job.

# Arguments
- `platform_id`: The ID of the signing platform to be created.
- `profile_name`: The name of the signing profile to be created.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"overrides"`: A subfield of platform. This specifies any different configuration options
  that you want to apply to the chosen platform (such as a different hash-algorithm or
  signing-algorithm).
- `"signatureValidityPeriod"`: The default validity period override for any signature
  generated using this signing profile. If unspecified, the default is 135 months.
- `"signingMaterial"`: The AWS Certificate Manager certificate that will be used to sign
  code with the new signing profile.
- `"signingParameters"`: Map of key-value pairs for signing. These can include any
  information that you want to use during signing.
- `"tags"`: Tags to be associated with the signing profile that is being created.
"""
function put_signing_profile(
    platformId, profileName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return signer(
        "PUT",
        "/signing-profiles/$(profileName)",
        Dict{String,Any}("platformId" => platformId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_signing_profile(
    platformId,
    profileName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return signer(
        "PUT",
        "/signing-profiles/$(profileName)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("platformId" => platformId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_profile_permission(profile_name, revision_id, statement_id)
    remove_profile_permission(profile_name, revision_id, statement_id, params::Dict{String,<:Any})

Removes cross-account permissions from a signing profile.

# Arguments
- `profile_name`: A human-readable name for the signing profile with permissions to be
  removed.
- `revision_id`: An identifier for the current revision of the signing profile permissions.
- `statement_id`: A unique identifier for the cross-account permissions statement.

"""
function remove_profile_permission(
    profileName, revisionId, statementId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return signer(
        "DELETE",
        "/signing-profiles/$(profileName)/permissions/$(statementId)",
        Dict{String,Any}("revisionId" => revisionId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_profile_permission(
    profileName,
    revisionId,
    statementId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return signer(
        "DELETE",
        "/signing-profiles/$(profileName)/permissions/$(statementId)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("revisionId" => revisionId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    revoke_signature(job_id, reason)
    revoke_signature(job_id, reason, params::Dict{String,<:Any})

Changes the state of a signing job to REVOKED. This indicates that the signature is no
longer valid.

# Arguments
- `job_id`: ID of the signing job to be revoked.
- `reason`: The reason for revoking the signing job.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"jobOwner"`: AWS account ID of the job owner.
"""
function revoke_signature(jobId, reason; aws_config::AbstractAWSConfig=current_aws_config())
    return signer(
        "PUT",
        "/signing-jobs/$(jobId)/revoke",
        Dict{String,Any}("reason" => reason);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function revoke_signature(
    jobId,
    reason,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return signer(
        "PUT",
        "/signing-jobs/$(jobId)/revoke",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("reason" => reason), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    revoke_signing_profile(effective_time, profile_name, profile_version, reason)
    revoke_signing_profile(effective_time, profile_name, profile_version, reason, params::Dict{String,<:Any})

Changes the state of a signing profile to REVOKED. This indicates that signatures generated
using the signing profile after an effective start date are no longer valid.

# Arguments
- `effective_time`: A timestamp for when revocation of a Signing Profile should become
  effective. Signatures generated using the signing profile after this timestamp are not
  trusted.
- `profile_name`: The name of the signing profile to be revoked.
- `profile_version`: The version of the signing profile to be revoked.
- `reason`: The reason for revoking a signing profile.

"""
function revoke_signing_profile(
    effectiveTime,
    profileName,
    profileVersion,
    reason;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return signer(
        "PUT",
        "/signing-profiles/$(profileName)/revoke",
        Dict{String,Any}(
            "effectiveTime" => effectiveTime,
            "profileVersion" => profileVersion,
            "reason" => reason,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function revoke_signing_profile(
    effectiveTime,
    profileName,
    profileVersion,
    reason,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return signer(
        "PUT",
        "/signing-profiles/$(profileName)/revoke",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "effectiveTime" => effectiveTime,
                    "profileVersion" => profileVersion,
                    "reason" => reason,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    sign_payload(payload, payload_format, profile_name)
    sign_payload(payload, payload_format, profile_name, params::Dict{String,<:Any})

Signs a binary payload and returns a signature envelope.

# Arguments
- `payload`: Specifies the object digest (hash) to sign.
- `payload_format`: Payload content type. The single valid type is
  application/vnd.cncf.notary.payload.v1+json.
- `profile_name`: The name of the signing profile.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"profileOwner"`: The AWS account ID of the profile owner.
"""
function sign_payload(
    payload, payloadFormat, profileName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return signer(
        "POST",
        "/signing-jobs/with-payload",
        Dict{String,Any}(
            "payload" => payload,
            "payloadFormat" => payloadFormat,
            "profileName" => profileName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function sign_payload(
    payload,
    payloadFormat,
    profileName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return signer(
        "POST",
        "/signing-jobs/with-payload",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "payload" => payload,
                    "payloadFormat" => payloadFormat,
                    "profileName" => profileName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_signing_job(client_request_token, destination, profile_name, source)
    start_signing_job(client_request_token, destination, profile_name, source, params::Dict{String,<:Any})

Initiates a signing job to be performed on the code provided. Signing jobs are viewable by
the ListSigningJobs operation for two years after they are performed. Note the following
requirements:     You must create an Amazon S3 source bucket. For more information, see
Creating a Bucket in the Amazon S3 Getting Started Guide.    Your S3 source bucket must be
version enabled.   You must create an S3 destination bucket. AWS Signer uses your S3
destination bucket to write your signed code.   You specify the name of the source and
destination buckets when calling the StartSigningJob operation.   You must ensure the S3
buckets are from the same Region as the signing profile. Cross-Region signing isn't
supported.   You must also specify a request token that identifies your request to Signer.
 You can call the DescribeSigningJob and the ListSigningJobs actions after you call
StartSigningJob. For a Java example that shows how to use this action, see StartSigningJob.

# Arguments
- `client_request_token`: String that identifies the signing request. All calls after the
  first that use this token return the same response as the first call.
- `destination`: The S3 bucket in which to save your signed object. The destination
  contains the name of your bucket and an optional prefix.
- `profile_name`: The name of the signing profile.
- `source`: The S3 bucket that contains the object to sign or a BLOB that contains your raw
  code.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"profileOwner"`: The AWS account ID of the signing profile owner.
"""
function start_signing_job(
    clientRequestToken,
    destination,
    profileName,
    source;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return signer(
        "POST",
        "/signing-jobs",
        Dict{String,Any}(
            "clientRequestToken" => clientRequestToken,
            "destination" => destination,
            "profileName" => profileName,
            "source" => source,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_signing_job(
    clientRequestToken,
    destination,
    profileName,
    source,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return signer(
        "POST",
        "/signing-jobs",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "clientRequestToken" => clientRequestToken,
                    "destination" => destination,
                    "profileName" => profileName,
                    "source" => source,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds one or more tags to a signing profile. Tags are labels that you can use to identify
and organize your AWS resources. Each tag consists of a key and an optional value. To
specify the signing profile, use its Amazon Resource Name (ARN). To specify the tag, use a
key-value pair.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) for the signing profile.
- `tags`: One or more tags to be associated with the signing profile.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return signer(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return signer(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes one or more tags from a signing profile. To remove the tags, specify a list of tag
keys.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) for the signing profile.
- `tag_keys`: A list of tag keys to be removed from the signing profile.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return signer(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return signer(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: codeguru_security
using AWS.Compat
using AWS.UUIDs

"""
    batch_get_findings(finding_identifiers)
    batch_get_findings(finding_identifiers, params::Dict{String,<:Any})

Returns a list of requested findings from standard scans.

# Arguments
- `finding_identifiers`: A list of finding identifiers. Each identifier consists of a
  scanName and a findingId. You retrieve the findingId when you call GetFindings.

"""
function batch_get_findings(
    findingIdentifiers; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeguru_security(
        "POST",
        "/batchGetFindings",
        Dict{String,Any}("findingIdentifiers" => findingIdentifiers);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_findings(
    findingIdentifiers,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeguru_security(
        "POST",
        "/batchGetFindings",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("findingIdentifiers" => findingIdentifiers), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_scan(resource_id, scan_name)
    create_scan(resource_id, scan_name, params::Dict{String,<:Any})

Use to create a scan using code uploaded to an Amazon S3 bucket.

# Arguments
- `resource_id`: The identifier for the resource object to be scanned.
- `scan_name`: The unique name that CodeGuru Security uses to track revisions across
  multiple scans of the same resource. Only allowed for a STANDARD scan type.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"analysisType"`: The type of analysis you want CodeGuru Security to perform in the scan,
  either Security or All. The Security type only generates findings related to security. The
  All type generates both security findings and quality findings. Defaults to Security type
  if missing.
- `"clientToken"`: The idempotency token for the request. Amazon CodeGuru Security uses
  this value to prevent the accidental creation of duplicate scans if there are failures and
  retries.
- `"scanType"`: The type of scan, either Standard or Express. Defaults to Standard type if
  missing.  Express scans run on limited resources and use a limited set of detectors to
  analyze your code in near-real time. Standard scans have standard resource limits and use
  the full set of detectors to analyze your code.
- `"tags"`: An array of key-value pairs used to tag a scan. A tag is a custom attribute
  label with two parts:   A tag key. For example, CostCenter, Environment, or Secret. Tag
  keys are case sensitive.   An optional tag value field. For example, 111122223333,
  Production, or a team name. Omitting the tag value is the same as using an empty string.
  Tag values are case sensitive.
"""
function create_scan(
    resourceId, scanName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeguru_security(
        "POST",
        "/scans",
        Dict{String,Any}(
            "resourceId" => resourceId,
            "scanName" => scanName,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_scan(
    resourceId,
    scanName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeguru_security(
        "POST",
        "/scans",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "resourceId" => resourceId,
                    "scanName" => scanName,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_upload_url(scan_name)
    create_upload_url(scan_name, params::Dict{String,<:Any})

Generates a pre-signed URL, request headers used to upload a code resource, and code
artifact identifier for the uploaded resource. You can upload your code resource to the URL
with the request headers using any HTTP client.

# Arguments
- `scan_name`: The name of the scan that will use the uploaded resource. CodeGuru Security
  uses the unique scan name to track revisions across multiple scans of the same resource.
  Use this scanName when you call CreateScan on the code resource you upload to this URL.

"""
function create_upload_url(scanName; aws_config::AbstractAWSConfig=current_aws_config())
    return codeguru_security(
        "POST",
        "/uploadUrl",
        Dict{String,Any}("scanName" => scanName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_upload_url(
    scanName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeguru_security(
        "POST",
        "/uploadUrl",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("scanName" => scanName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_account_configuration()
    get_account_configuration(params::Dict{String,<:Any})

Use to get the encryption configuration for an account.

"""
function get_account_configuration(; aws_config::AbstractAWSConfig=current_aws_config())
    return codeguru_security(
        "GET",
        "/accountConfiguration/get";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_account_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeguru_security(
        "GET",
        "/accountConfiguration/get",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_findings(scan_name)
    get_findings(scan_name, params::Dict{String,<:Any})

Returns a list of all findings generated by a particular scan.

# Arguments
- `scan_name`: The name of the scan you want to retrieve findings from.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in the response. Use this
  parameter when paginating results. If additional results exist beyond the number you
  specify, the nextToken element is returned in the response. Use nextToken in a subsequent
  request to retrieve additional results. If not specified, returns 1000 results.
- `"nextToken"`: A token to use for paginating results that are returned in the response.
  Set the value of this parameter to null for the first request. For subsequent calls, use
  the nextToken value returned from the previous request to continue listing results after
  the first page.
- `"status"`: The status of the findings you want to get. Pass either Open, Closed, or All.
"""
function get_findings(scanName; aws_config::AbstractAWSConfig=current_aws_config())
    return codeguru_security(
        "GET",
        "/findings/$(scanName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_findings(
    scanName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeguru_security(
        "GET",
        "/findings/$(scanName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_metrics_summary(date)
    get_metrics_summary(date, params::Dict{String,<:Any})

Returns a summary of metrics for an account from a specified date, including number of open
findings, the categories with most findings, the scans with most open findings, and scans
with most open critical findings.

# Arguments
- `date`: The date you want to retrieve summary metrics from, rounded to the nearest day.
  The date must be within the past two years.

"""
function get_metrics_summary(date; aws_config::AbstractAWSConfig=current_aws_config())
    return codeguru_security(
        "GET",
        "/metrics/summary",
        Dict{String,Any}("date" => date);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_metrics_summary(
    date, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeguru_security(
        "GET",
        "/metrics/summary",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("date" => date), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_scan(scan_name)
    get_scan(scan_name, params::Dict{String,<:Any})

Returns details about a scan, including whether or not a scan has completed.

# Arguments
- `scan_name`: The name of the scan you want to view details about.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"runId"`: UUID that identifies the individual scan run you want to view details about.
  You retrieve this when you call the CreateScan operation. Defaults to the latest scan run
  if missing.
"""
function get_scan(scanName; aws_config::AbstractAWSConfig=current_aws_config())
    return codeguru_security(
        "GET", "/scans/$(scanName)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_scan(
    scanName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeguru_security(
        "GET",
        "/scans/$(scanName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_findings_metrics(end_date, start_date)
    list_findings_metrics(end_date, start_date, params::Dict{String,<:Any})

Returns metrics about all findings in an account within a specified time range.

# Arguments
- `end_date`: The end date of the interval which you want to retrieve metrics from. Round
  to the nearest day.
- `start_date`: The start date of the interval which you want to retrieve metrics from.
  Rounds to the nearest day.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in the response. Use this
  parameter when paginating results. If additional results exist beyond the number you
  specify, the nextToken element is returned in the response. Use nextToken in a subsequent
  request to retrieve additional results. If not specified, returns 1000 results.
- `"nextToken"`: A token to use for paginating results that are returned in the response.
  Set the value of this parameter to null for the first request. For subsequent calls, use
  the nextToken value returned from the previous request to continue listing results after
  the first page.
"""
function list_findings_metrics(
    endDate, startDate; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeguru_security(
        "GET",
        "/metrics/findings",
        Dict{String,Any}("endDate" => endDate, "startDate" => startDate);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_findings_metrics(
    endDate,
    startDate,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeguru_security(
        "GET",
        "/metrics/findings",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("endDate" => endDate, "startDate" => startDate),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_scans()
    list_scans(params::Dict{String,<:Any})

Returns a list of all scans in an account. Does not return EXPRESS scans.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in the response. Use this
  parameter when paginating results. If additional results exist beyond the number you
  specify, the nextToken element is returned in the response. Use nextToken in a subsequent
  request to retrieve additional results. If not specified, returns 100 results.
- `"nextToken"`: A token to use for paginating results that are returned in the response.
  Set the value of this parameter to null for the first request. For subsequent calls, use
  the nextToken value returned from the previous request to continue listing results after
  the first page.
"""
function list_scans(; aws_config::AbstractAWSConfig=current_aws_config())
    return codeguru_security(
        "GET", "/scans"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_scans(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeguru_security(
        "GET", "/scans", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Returns a list of all tags associated with a scan.

# Arguments
- `resource_arn`: The ARN of the ScanName object. You can retrieve this ARN by calling
  CreateScan, ListScans, or GetScan.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeguru_security(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeguru_security(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Use to add one or more tags to an existing scan.

# Arguments
- `resource_arn`: The ARN of the ScanName object. You can retrieve this ARN by calling
  CreateScan, ListScans, or GetScan.
- `tags`: An array of key-value pairs used to tag an existing scan. A tag is a custom
  attribute label with two parts:   A tag key. For example, CostCenter, Environment, or
  Secret. Tag keys are case sensitive.   An optional tag value field. For example,
  111122223333, Production, or a team name. Omitting the tag value is the same as using an
  empty string. Tag values are case sensitive.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return codeguru_security(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeguru_security(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Use to remove one or more tags from an existing scan.

# Arguments
- `resource_arn`: The ARN of the ScanName object. You can retrieve this ARN by calling
  CreateScan, ListScans, or GetScan.
- `tag_keys`: A list of keys for each tag you want to remove from a scan.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeguru_security(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeguru_security(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_account_configuration(encryption_config)
    update_account_configuration(encryption_config, params::Dict{String,<:Any})

Use to update the encryption configuration for an account.

# Arguments
- `encryption_config`: The customer-managed KMS key ARN you want to use for encryption. If
  not specified, CodeGuru Security will use an AWS-managed key for encryption. If you
  previously specified a customer-managed KMS key and want CodeGuru Security to use an
  AWS-managed key for encryption instead, pass nothing.

"""
function update_account_configuration(
    encryptionConfig; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeguru_security(
        "PUT",
        "/updateAccountConfiguration",
        Dict{String,Any}("encryptionConfig" => encryptionConfig);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_account_configuration(
    encryptionConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeguru_security(
        "PUT",
        "/updateAccountConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("encryptionConfig" => encryptionConfig), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: pca_connector_ad
using AWS.Compat
using AWS.UUIDs

"""
    create_connector(certificate_authority_arn, directory_id, vpc_information)
    create_connector(certificate_authority_arn, directory_id, vpc_information, params::Dict{String,<:Any})

Creates a connector between Amazon Web Services Private CA and an Active Directory. You
must specify the private CA, directory ID, and security groups.

# Arguments
- `certificate_authority_arn`:  The Amazon Resource Name (ARN) of the certificate authority
  being used.
- `directory_id`: The identifier of the Active Directory.
- `vpc_information`: Security group IDs that describe the inbound and outbound rules.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: Idempotency token.
- `"Tags"`: Metadata assigned to a connector consisting of a key-value pair.
"""
function create_connector(
    CertificateAuthorityArn,
    DirectoryId,
    VpcInformation;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pca_connector_ad(
        "POST",
        "/connectors",
        Dict{String,Any}(
            "CertificateAuthorityArn" => CertificateAuthorityArn,
            "DirectoryId" => DirectoryId,
            "VpcInformation" => VpcInformation,
            "ClientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_connector(
    CertificateAuthorityArn,
    DirectoryId,
    VpcInformation,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pca_connector_ad(
        "POST",
        "/connectors",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CertificateAuthorityArn" => CertificateAuthorityArn,
                    "DirectoryId" => DirectoryId,
                    "VpcInformation" => VpcInformation,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_directory_registration(directory_id)
    create_directory_registration(directory_id, params::Dict{String,<:Any})

Creates a directory registration that authorizes communication between Amazon Web Services
Private CA and an Active Directory

# Arguments
- `directory_id`:  The identifier of the Active Directory.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: Idempotency token.
- `"Tags"`: Metadata assigned to a directory registration consisting of a key-value pair.
"""
function create_directory_registration(
    DirectoryId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pca_connector_ad(
        "POST",
        "/directoryRegistrations",
        Dict{String,Any}("DirectoryId" => DirectoryId, "ClientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_directory_registration(
    DirectoryId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pca_connector_ad(
        "POST",
        "/directoryRegistrations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DirectoryId" => DirectoryId, "ClientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_service_principal_name(connector_arn, directory_registration_arn)
    create_service_principal_name(connector_arn, directory_registration_arn, params::Dict{String,<:Any})

Creates a service principal name (SPN) for the service account in Active Directory.
Kerberos authentication uses SPNs to associate a service instance with a service sign-in
account.

# Arguments
- `connector_arn`:  The Amazon Resource Name (ARN) that was returned when you called
  CreateConnector.
- `directory_registration_arn`: The Amazon Resource Name (ARN) that was returned when you
  called CreateDirectoryRegistration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: Idempotency token.
"""
function create_service_principal_name(
    ConnectorArn,
    DirectoryRegistrationArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pca_connector_ad(
        "POST",
        "/directoryRegistrations/$(DirectoryRegistrationArn)/servicePrincipalNames/$(ConnectorArn)",
        Dict{String,Any}("ClientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_service_principal_name(
    ConnectorArn,
    DirectoryRegistrationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pca_connector_ad(
        "POST",
        "/directoryRegistrations/$(DirectoryRegistrationArn)/servicePrincipalNames/$(ConnectorArn)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ClientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_template(connector_arn, definition, name)
    create_template(connector_arn, definition, name, params::Dict{String,<:Any})

Creates an Active Directory compatible certificate template. The connectors issues
certificates using these templates based on the requester’s Active Directory group
membership.

# Arguments
- `connector_arn`: The Amazon Resource Name (ARN) that was returned when you called
  CreateConnector.
- `definition`: Template configuration to define the information included in certificates.
  Define certificate validity and renewal periods, certificate request handling and
  enrollment options, key usage extensions, application policies, and cryptography settings.
- `name`: Name of the template. The template name must be unique.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: Idempotency token.
- `"Tags"`: Metadata assigned to a template consisting of a key-value pair.
"""
function create_template(
    ConnectorArn, Definition, Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pca_connector_ad(
        "POST",
        "/templates",
        Dict{String,Any}(
            "ConnectorArn" => ConnectorArn,
            "Definition" => Definition,
            "Name" => Name,
            "ClientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_template(
    ConnectorArn,
    Definition,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pca_connector_ad(
        "POST",
        "/templates",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ConnectorArn" => ConnectorArn,
                    "Definition" => Definition,
                    "Name" => Name,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_template_group_access_control_entry(access_rights, group_display_name, group_security_identifier, template_arn)
    create_template_group_access_control_entry(access_rights, group_display_name, group_security_identifier, template_arn, params::Dict{String,<:Any})

Create a group access control entry. Allow or deny Active Directory groups from enrolling
and/or autoenrolling with the template based on the group security identifiers (SIDs).

# Arguments
- `access_rights`:  Allow or deny permissions for an Active Directory group to enroll or
  autoenroll certificates for a template.
- `group_display_name`: Name of the Active Directory group. This name does not need to
  match the group name in Active Directory.
- `group_security_identifier`: Security identifier (SID) of the group object from Active
  Directory. The SID starts with \"S-\".
- `template_arn`: The Amazon Resource Name (ARN) that was returned when you called
  CreateTemplate.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: Idempotency token.
"""
function create_template_group_access_control_entry(
    AccessRights,
    GroupDisplayName,
    GroupSecurityIdentifier,
    TemplateArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pca_connector_ad(
        "POST",
        "/templates/$(TemplateArn)/accessControlEntries",
        Dict{String,Any}(
            "AccessRights" => AccessRights,
            "GroupDisplayName" => GroupDisplayName,
            "GroupSecurityIdentifier" => GroupSecurityIdentifier,
            "ClientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_template_group_access_control_entry(
    AccessRights,
    GroupDisplayName,
    GroupSecurityIdentifier,
    TemplateArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pca_connector_ad(
        "POST",
        "/templates/$(TemplateArn)/accessControlEntries",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AccessRights" => AccessRights,
                    "GroupDisplayName" => GroupDisplayName,
                    "GroupSecurityIdentifier" => GroupSecurityIdentifier,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_connector(connector_arn)
    delete_connector(connector_arn, params::Dict{String,<:Any})

Deletes a connector for Active Directory. You must provide the Amazon Resource Name (ARN)
of the connector that you want to delete. You can find the ARN by calling the
https://docs.aws.amazon.com/pca-connector-ad/latest/APIReference/API_ListConnectors action.
Deleting a connector does not deregister your directory with Amazon Web Services Private
CA. You can deregister your directory by calling the
https://docs.aws.amazon.com/pca-connector-ad/latest/APIReference/API_DeleteDirectoryRegistra
tion action.

# Arguments
- `connector_arn`:  The Amazon Resource Name (ARN) that was returned when you called
  CreateConnector.

"""
function delete_connector(ConnectorArn; aws_config::AbstractAWSConfig=current_aws_config())
    return pca_connector_ad(
        "DELETE",
        "/connectors/$(ConnectorArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_connector(
    ConnectorArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pca_connector_ad(
        "DELETE",
        "/connectors/$(ConnectorArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_directory_registration(directory_registration_arn)
    delete_directory_registration(directory_registration_arn, params::Dict{String,<:Any})

Deletes a directory registration. Deleting a directory registration deauthorizes Amazon Web
Services Private CA with the directory.

# Arguments
- `directory_registration_arn`: The Amazon Resource Name (ARN) that was returned when you
  called CreateDirectoryRegistration.

"""
function delete_directory_registration(
    DirectoryRegistrationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pca_connector_ad(
        "DELETE",
        "/directoryRegistrations/$(DirectoryRegistrationArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_directory_registration(
    DirectoryRegistrationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pca_connector_ad(
        "DELETE",
        "/directoryRegistrations/$(DirectoryRegistrationArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_service_principal_name(connector_arn, directory_registration_arn)
    delete_service_principal_name(connector_arn, directory_registration_arn, params::Dict{String,<:Any})

Deletes the service principal name (SPN) used by a connector to authenticate with your
Active Directory.

# Arguments
- `connector_arn`:  The Amazon Resource Name (ARN) that was returned when you called
  CreateConnector.
- `directory_registration_arn`: The Amazon Resource Name (ARN) that was returned when you
  called CreateDirectoryRegistration.

"""
function delete_service_principal_name(
    ConnectorArn,
    DirectoryRegistrationArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pca_connector_ad(
        "DELETE",
        "/directoryRegistrations/$(DirectoryRegistrationArn)/servicePrincipalNames/$(ConnectorArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_service_principal_name(
    ConnectorArn,
    DirectoryRegistrationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pca_connector_ad(
        "DELETE",
        "/directoryRegistrations/$(DirectoryRegistrationArn)/servicePrincipalNames/$(ConnectorArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_template(template_arn)
    delete_template(template_arn, params::Dict{String,<:Any})

Deletes a template. Certificates issued using the template are still valid until they are
revoked or expired.

# Arguments
- `template_arn`: The Amazon Resource Name (ARN) that was returned when you called
  CreateTemplate.

"""
function delete_template(TemplateArn; aws_config::AbstractAWSConfig=current_aws_config())
    return pca_connector_ad(
        "DELETE",
        "/templates/$(TemplateArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_template(
    TemplateArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pca_connector_ad(
        "DELETE",
        "/templates/$(TemplateArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_template_group_access_control_entry(group_security_identifier, template_arn)
    delete_template_group_access_control_entry(group_security_identifier, template_arn, params::Dict{String,<:Any})

Deletes a group access control entry.

# Arguments
- `group_security_identifier`: Security identifier (SID) of the group object from Active
  Directory. The SID starts with \"S-\".
- `template_arn`: The Amazon Resource Name (ARN) that was returned when you called
  CreateTemplate.

"""
function delete_template_group_access_control_entry(
    GroupSecurityIdentifier, TemplateArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pca_connector_ad(
        "DELETE",
        "/templates/$(TemplateArn)/accessControlEntries/$(GroupSecurityIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_template_group_access_control_entry(
    GroupSecurityIdentifier,
    TemplateArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pca_connector_ad(
        "DELETE",
        "/templates/$(TemplateArn)/accessControlEntries/$(GroupSecurityIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_connector(connector_arn)
    get_connector(connector_arn, params::Dict{String,<:Any})

Lists information about your connector. You specify the connector on input by its ARN
(Amazon Resource Name).

# Arguments
- `connector_arn`:  The Amazon Resource Name (ARN) that was returned when you called
  CreateConnector.

"""
function get_connector(ConnectorArn; aws_config::AbstractAWSConfig=current_aws_config())
    return pca_connector_ad(
        "GET",
        "/connectors/$(ConnectorArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_connector(
    ConnectorArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pca_connector_ad(
        "GET",
        "/connectors/$(ConnectorArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_directory_registration(directory_registration_arn)
    get_directory_registration(directory_registration_arn, params::Dict{String,<:Any})

A structure that contains information about your directory registration.

# Arguments
- `directory_registration_arn`: The Amazon Resource Name (ARN) that was returned when you
  called CreateDirectoryRegistration.

"""
function get_directory_registration(
    DirectoryRegistrationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pca_connector_ad(
        "GET",
        "/directoryRegistrations/$(DirectoryRegistrationArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_directory_registration(
    DirectoryRegistrationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pca_connector_ad(
        "GET",
        "/directoryRegistrations/$(DirectoryRegistrationArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_service_principal_name(connector_arn, directory_registration_arn)
    get_service_principal_name(connector_arn, directory_registration_arn, params::Dict{String,<:Any})

Lists the service principal name that the connector uses to authenticate with Active
Directory.

# Arguments
- `connector_arn`: The Amazon Resource Name (ARN) that was returned when you called
  CreateConnector.
- `directory_registration_arn`: The Amazon Resource Name (ARN) that was returned when you
  called CreateDirectoryRegistration.

"""
function get_service_principal_name(
    ConnectorArn,
    DirectoryRegistrationArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pca_connector_ad(
        "GET",
        "/directoryRegistrations/$(DirectoryRegistrationArn)/servicePrincipalNames/$(ConnectorArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_service_principal_name(
    ConnectorArn,
    DirectoryRegistrationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pca_connector_ad(
        "GET",
        "/directoryRegistrations/$(DirectoryRegistrationArn)/servicePrincipalNames/$(ConnectorArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_template(template_arn)
    get_template(template_arn, params::Dict{String,<:Any})

Retrieves a certificate template that the connector uses to issue certificates from a
private CA.

# Arguments
- `template_arn`: The Amazon Resource Name (ARN) that was returned when you called
  CreateTemplate.

"""
function get_template(TemplateArn; aws_config::AbstractAWSConfig=current_aws_config())
    return pca_connector_ad(
        "GET",
        "/templates/$(TemplateArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_template(
    TemplateArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pca_connector_ad(
        "GET",
        "/templates/$(TemplateArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_template_group_access_control_entry(group_security_identifier, template_arn)
    get_template_group_access_control_entry(group_security_identifier, template_arn, params::Dict{String,<:Any})

Retrieves the group access control entries for a template.

# Arguments
- `group_security_identifier`: Security identifier (SID) of the group object from Active
  Directory. The SID starts with \"S-\".
- `template_arn`: The Amazon Resource Name (ARN) that was returned when you called
  CreateTemplate.

"""
function get_template_group_access_control_entry(
    GroupSecurityIdentifier, TemplateArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pca_connector_ad(
        "GET",
        "/templates/$(TemplateArn)/accessControlEntries/$(GroupSecurityIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_template_group_access_control_entry(
    GroupSecurityIdentifier,
    TemplateArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pca_connector_ad(
        "GET",
        "/templates/$(TemplateArn)/accessControlEntries/$(GroupSecurityIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_connectors()
    list_connectors(params::Dict{String,<:Any})

Lists the connectors that you created by using the
https://docs.aws.amazon.com/pca-connector-ad/latest/APIReference/API_CreateConnector action.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Use this parameter when paginating results to specify the maximum number
  of items to return in the response on each page. If additional items exist beyond the
  number you specify, the NextToken element is sent in the response. Use this NextToken value
  in a subsequent request to retrieve additional items.
- `"NextToken"`: Use this parameter when paginating results in a subsequent request after
  you receive a response with truncated results. Set it to the value of the NextToken
  parameter from the response you just received.
"""
function list_connectors(; aws_config::AbstractAWSConfig=current_aws_config())
    return pca_connector_ad(
        "GET", "/connectors"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_connectors(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pca_connector_ad(
        "GET", "/connectors", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_directory_registrations()
    list_directory_registrations(params::Dict{String,<:Any})

Lists the directory registrations that you created by using the
https://docs.aws.amazon.com/pca-connector-ad/latest/APIReference/API_CreateDirectoryRegistra
tion action.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Use this parameter when paginating results to specify the maximum number
  of items to return in the response on each page. If additional items exist beyond the
  number you specify, the NextToken element is sent in the response. Use this NextToken value
  in a subsequent request to retrieve additional items.
- `"NextToken"`: Use this parameter when paginating results in a subsequent request after
  you receive a response with truncated results. Set it to the value of the NextToken
  parameter from the response you just received.
"""
function list_directory_registrations(; aws_config::AbstractAWSConfig=current_aws_config())
    return pca_connector_ad(
        "GET",
        "/directoryRegistrations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_directory_registrations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pca_connector_ad(
        "GET",
        "/directoryRegistrations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_service_principal_names(directory_registration_arn)
    list_service_principal_names(directory_registration_arn, params::Dict{String,<:Any})

Lists the service principal names that the connector uses to authenticate with Active
Directory.

# Arguments
- `directory_registration_arn`: The Amazon Resource Name (ARN) that was returned when you
  called CreateDirectoryRegistration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Use this parameter when paginating results to specify the maximum number
  of items to return in the response on each page. If additional items exist beyond the
  number you specify, the NextToken element is sent in the response. Use this NextToken value
  in a subsequent request to retrieve additional items.
- `"NextToken"`: Use this parameter when paginating results in a subsequent request after
  you receive a response with truncated results. Set it to the value of the NextToken
  parameter from the response you just received.
"""
function list_service_principal_names(
    DirectoryRegistrationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pca_connector_ad(
        "GET",
        "/directoryRegistrations/$(DirectoryRegistrationArn)/servicePrincipalNames";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_service_principal_names(
    DirectoryRegistrationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pca_connector_ad(
        "GET",
        "/directoryRegistrations/$(DirectoryRegistrationArn)/servicePrincipalNames",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists the tags, if any, that are associated with your resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) that was returned when you created the
  resource.

"""
function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pca_connector_ad(
        "GET",
        "/tags/$(ResourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pca_connector_ad(
        "GET",
        "/tags/$(ResourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_template_group_access_control_entries(template_arn)
    list_template_group_access_control_entries(template_arn, params::Dict{String,<:Any})

Lists group access control entries you created.

# Arguments
- `template_arn`: The Amazon Resource Name (ARN) that was returned when you called
  CreateTemplate.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Use this parameter when paginating results to specify the maximum number
  of items to return in the response on each page. If additional items exist beyond the
  number you specify, the NextToken element is sent in the response. Use this NextToken value
  in a subsequent request to retrieve additional items.
- `"NextToken"`: Use this parameter when paginating results in a subsequent request after
  you receive a response with truncated results. Set it to the value of the NextToken
  parameter from the response you just received.
"""
function list_template_group_access_control_entries(
    TemplateArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pca_connector_ad(
        "GET",
        "/templates/$(TemplateArn)/accessControlEntries";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_template_group_access_control_entries(
    TemplateArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pca_connector_ad(
        "GET",
        "/templates/$(TemplateArn)/accessControlEntries",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_templates(connector_arn)
    list_templates(connector_arn, params::Dict{String,<:Any})

Lists the templates, if any, that are associated with a connector.

# Arguments
- `connector_arn`: The Amazon Resource Name (ARN) that was returned when you called
  CreateConnector.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Use this parameter when paginating results to specify the maximum number
  of items to return in the response on each page. If additional items exist beyond the
  number you specify, the NextToken element is sent in the response. Use this NextToken value
  in a subsequent request to retrieve additional items.
- `"NextToken"`: Use this parameter when paginating results in a subsequent request after
  you receive a response with truncated results. Set it to the value of the NextToken
  parameter from the response you just received.
"""
function list_templates(ConnectorArn; aws_config::AbstractAWSConfig=current_aws_config())
    return pca_connector_ad(
        "GET",
        "/templates",
        Dict{String,Any}("ConnectorArn" => ConnectorArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_templates(
    ConnectorArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pca_connector_ad(
        "GET",
        "/templates",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ConnectorArn" => ConnectorArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds one or more tags to your resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) that was returned when you created the
  resource.
- `tags`: Metadata assigned to a directory registration consisting of a key-value pair.

"""
function tag_resource(ResourceArn, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return pca_connector_ad(
        "POST",
        "/tags/$(ResourceArn)",
        Dict{String,Any}("Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceArn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pca_connector_ad(
        "POST",
        "/tags/$(ResourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Tags" => Tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes one or more tags from your resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) that was returned when you created the
  resource.
- `tag_keys`: Specifies a list of tag keys that you want to remove from the specified
  resources.

"""
function untag_resource(
    ResourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pca_connector_ad(
        "DELETE",
        "/tags/$(ResourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pca_connector_ad(
        "DELETE",
        "/tags/$(ResourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_template(template_arn)
    update_template(template_arn, params::Dict{String,<:Any})

Update template configuration to define the information included in certificates.

# Arguments
- `template_arn`: The Amazon Resource Name (ARN) that was returned when you called
  CreateTemplate.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Definition"`: Template configuration to define the information included in
  certificates. Define certificate validity and renewal periods, certificate request handling
  and enrollment options, key usage extensions, application policies, and cryptography
  settings.
- `"ReenrollAllCertificateHolders"`: This setting allows the major version of a template to
  be increased automatically. All members of Active Directory groups that are allowed to
  enroll with a template will receive a new certificate issued using that template.
"""
function update_template(TemplateArn; aws_config::AbstractAWSConfig=current_aws_config())
    return pca_connector_ad(
        "PATCH",
        "/templates/$(TemplateArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_template(
    TemplateArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pca_connector_ad(
        "PATCH",
        "/templates/$(TemplateArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_template_group_access_control_entry(group_security_identifier, template_arn)
    update_template_group_access_control_entry(group_security_identifier, template_arn, params::Dict{String,<:Any})

Update a group access control entry you created using
CreateTemplateGroupAccessControlEntry.

# Arguments
- `group_security_identifier`: Security identifier (SID) of the group object from Active
  Directory. The SID starts with \"S-\".
- `template_arn`: The Amazon Resource Name (ARN) that was returned when you called
  CreateTemplate.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccessRights"`: Allow or deny permissions for an Active Directory group to enroll or
  autoenroll certificates for a template.
- `"GroupDisplayName"`: Name of the Active Directory group. This name does not need to
  match the group name in Active Directory.
"""
function update_template_group_access_control_entry(
    GroupSecurityIdentifier, TemplateArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pca_connector_ad(
        "PATCH",
        "/templates/$(TemplateArn)/accessControlEntries/$(GroupSecurityIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_template_group_access_control_entry(
    GroupSecurityIdentifier,
    TemplateArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pca_connector_ad(
        "PATCH",
        "/templates/$(TemplateArn)/accessControlEntries/$(GroupSecurityIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: sms
using AWS.Compat
using AWS.UUIDs

"""
    create_app()
    create_app(params::Dict{String,<:Any})

Creates an application. An application consists of one or more server groups. Each server
group contain one or more servers.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of application creation.
- `"description"`: The description of the new application
- `"name"`: The name of the new application.
- `"roleName"`: The name of the service role in the customer's account to be used by Server
  Migration Service.
- `"serverGroups"`: The server groups to include in the application.
- `"tags"`: The tags to be associated with the application.
"""
function create_app(; aws_config::AbstractAWSConfig=current_aws_config())
    return sms("CreateApp"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function create_app(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sms("CreateApp", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end

"""
    create_replication_job(seed_replication_time, server_id)
    create_replication_job(seed_replication_time, server_id, params::Dict{String,<:Any})

Creates a replication job. The replication job schedules periodic replication runs to
replicate your server to Amazon Web Services. Each replication run creates an Amazon
Machine Image (AMI).

# Arguments
- `seed_replication_time`: The seed replication time.
- `server_id`: The ID of the server.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description of the replication job.
- `"encrypted"`: Indicates whether the replication job produces encrypted AMIs.
- `"frequency"`: The time between consecutive replication runs, in hours.
- `"kmsKeyId"`: The ID of the KMS key for replication jobs that produce encrypted AMIs.
  This value can be any of the following:   KMS key ID   KMS key alias   ARN referring to the
  KMS key ID   ARN referring to the KMS key alias    If encrypted is true but a KMS key ID is
  not specified, the customer's default KMS key for Amazon EBS is used.
- `"licenseType"`: The license type to be used for the AMI created by a successful
  replication run.
- `"numberOfRecentAmisToKeep"`: The maximum number of SMS-created AMIs to retain. The
  oldest is deleted after the maximum number is reached and a new AMI is created.
- `"roleName"`: The name of the IAM role to be used by the Server Migration Service.
- `"runOnce"`: Indicates whether to run the replication job one time.
"""
function create_replication_job(
    seedReplicationTime, serverId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sms(
        "CreateReplicationJob",
        Dict{String,Any}(
            "seedReplicationTime" => seedReplicationTime, "serverId" => serverId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_replication_job(
    seedReplicationTime,
    serverId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sms(
        "CreateReplicationJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "seedReplicationTime" => seedReplicationTime, "serverId" => serverId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_app()
    delete_app(params::Dict{String,<:Any})

Deletes the specified application. Optionally deletes the launched stack associated with
the application and all Server Migration Service replication jobs for servers in the
application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"appId"`: The ID of the application.
- `"forceStopAppReplication"`: Indicates whether to stop all replication jobs corresponding
  to the servers in the application while deleting the application.
- `"forceTerminateApp"`: Indicates whether to terminate the stack corresponding to the
  application while deleting the application.
"""
function delete_app(; aws_config::AbstractAWSConfig=current_aws_config())
    return sms("DeleteApp"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function delete_app(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sms("DeleteApp", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end

"""
    delete_app_launch_configuration()
    delete_app_launch_configuration(params::Dict{String,<:Any})

Deletes the launch configuration for the specified application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"appId"`: The ID of the application.
"""
function delete_app_launch_configuration(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return sms(
        "DeleteAppLaunchConfiguration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_app_launch_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sms(
        "DeleteAppLaunchConfiguration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_app_replication_configuration()
    delete_app_replication_configuration(params::Dict{String,<:Any})

Deletes the replication configuration for the specified application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"appId"`: The ID of the application.
"""
function delete_app_replication_configuration(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return sms(
        "DeleteAppReplicationConfiguration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_app_replication_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sms(
        "DeleteAppReplicationConfiguration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_app_validation_configuration(app_id)
    delete_app_validation_configuration(app_id, params::Dict{String,<:Any})

Deletes the validation configuration for the specified application.

# Arguments
- `app_id`: The ID of the application.

"""
function delete_app_validation_configuration(
    appId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sms(
        "DeleteAppValidationConfiguration",
        Dict{String,Any}("appId" => appId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_app_validation_configuration(
    appId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sms(
        "DeleteAppValidationConfiguration",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("appId" => appId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_replication_job(replication_job_id)
    delete_replication_job(replication_job_id, params::Dict{String,<:Any})

Deletes the specified replication job. After you delete a replication job, there are no
further replication runs. Amazon Web Services deletes the contents of the Amazon S3 bucket
used to store Server Migration Service artifacts. The AMIs created by the replication runs
are not deleted.

# Arguments
- `replication_job_id`: The ID of the replication job.

"""
function delete_replication_job(
    replicationJobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sms(
        "DeleteReplicationJob",
        Dict{String,Any}("replicationJobId" => replicationJobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_replication_job(
    replicationJobId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sms(
        "DeleteReplicationJob",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("replicationJobId" => replicationJobId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_server_catalog()
    delete_server_catalog(params::Dict{String,<:Any})

Deletes all servers from your server catalog.

"""
function delete_server_catalog(; aws_config::AbstractAWSConfig=current_aws_config())
    return sms(
        "DeleteServerCatalog"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function delete_server_catalog(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sms(
        "DeleteServerCatalog",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_connector(connector_id)
    disassociate_connector(connector_id, params::Dict{String,<:Any})

Disassociates the specified connector from Server Migration Service. After you disassociate
a connector, it is no longer available to support replication jobs.

# Arguments
- `connector_id`: The ID of the connector.

"""
function disassociate_connector(
    connectorId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sms(
        "DisassociateConnector",
        Dict{String,Any}("connectorId" => connectorId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_connector(
    connectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sms(
        "DisassociateConnector",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("connectorId" => connectorId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    generate_change_set()
    generate_change_set(params::Dict{String,<:Any})

Generates a target change set for a currently launched stack and writes it to an Amazon S3
object in the customer’s Amazon S3 bucket.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"appId"`: The ID of the application associated with the change set.
- `"changesetFormat"`: The format for the change set.
"""
function generate_change_set(; aws_config::AbstractAWSConfig=current_aws_config())
    return sms("GenerateChangeSet"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function generate_change_set(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sms(
        "GenerateChangeSet", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    generate_template()
    generate_template(params::Dict{String,<:Any})

Generates an CloudFormation template based on the current launch configuration and writes
it to an Amazon S3 object in the customer’s Amazon S3 bucket.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"appId"`: The ID of the application associated with the CloudFormation template.
- `"templateFormat"`: The format for generating the CloudFormation template.
"""
function generate_template(; aws_config::AbstractAWSConfig=current_aws_config())
    return sms("GenerateTemplate"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function generate_template(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sms(
        "GenerateTemplate", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_app()
    get_app(params::Dict{String,<:Any})

Retrieve information about the specified application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"appId"`: The ID of the application.
"""
function get_app(; aws_config::AbstractAWSConfig=current_aws_config())
    return sms("GetApp"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function get_app(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sms("GetApp", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end

"""
    get_app_launch_configuration()
    get_app_launch_configuration(params::Dict{String,<:Any})

Retrieves the application launch configuration associated with the specified application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"appId"`: The ID of the application.
"""
function get_app_launch_configuration(; aws_config::AbstractAWSConfig=current_aws_config())
    return sms(
        "GetAppLaunchConfiguration"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_app_launch_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sms(
        "GetAppLaunchConfiguration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_app_replication_configuration()
    get_app_replication_configuration(params::Dict{String,<:Any})

Retrieves the application replication configuration associated with the specified
application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"appId"`: The ID of the application.
"""
function get_app_replication_configuration(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return sms(
        "GetAppReplicationConfiguration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_app_replication_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sms(
        "GetAppReplicationConfiguration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_app_validation_configuration(app_id)
    get_app_validation_configuration(app_id, params::Dict{String,<:Any})

Retrieves information about a configuration for validating an application.

# Arguments
- `app_id`: The ID of the application.

"""
function get_app_validation_configuration(
    appId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sms(
        "GetAppValidationConfiguration",
        Dict{String,Any}("appId" => appId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_app_validation_configuration(
    appId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sms(
        "GetAppValidationConfiguration",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("appId" => appId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_app_validation_output(app_id)
    get_app_validation_output(app_id, params::Dict{String,<:Any})

Retrieves output from validating an application.

# Arguments
- `app_id`: The ID of the application.

"""
function get_app_validation_output(
    appId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sms(
        "GetAppValidationOutput",
        Dict{String,Any}("appId" => appId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_app_validation_output(
    appId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sms(
        "GetAppValidationOutput",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("appId" => appId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_connectors()
    get_connectors(params::Dict{String,<:Any})

Describes the connectors registered with the Server Migration Service.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in a single call. The default
  value is 50. To retrieve the remaining results, make another call with the returned
  NextToken value.
- `"nextToken"`: The token for the next set of results.
"""
function get_connectors(; aws_config::AbstractAWSConfig=current_aws_config())
    return sms("GetConnectors"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function get_connectors(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sms(
        "GetConnectors", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_replication_jobs()
    get_replication_jobs(params::Dict{String,<:Any})

Describes the specified replication job or all of your replication jobs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in a single call. The default
  value is 50. To retrieve the remaining results, make another call with the returned
  NextToken value.
- `"nextToken"`: The token for the next set of results.
- `"replicationJobId"`: The ID of the replication job.
"""
function get_replication_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return sms("GetReplicationJobs"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function get_replication_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sms(
        "GetReplicationJobs", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_replication_runs(replication_job_id)
    get_replication_runs(replication_job_id, params::Dict{String,<:Any})

Describes the replication runs for the specified replication job.

# Arguments
- `replication_job_id`: The ID of the replication job.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in a single call. The default
  value is 50. To retrieve the remaining results, make another call with the returned
  NextToken value.
- `"nextToken"`: The token for the next set of results.
"""
function get_replication_runs(
    replicationJobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sms(
        "GetReplicationRuns",
        Dict{String,Any}("replicationJobId" => replicationJobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_replication_runs(
    replicationJobId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sms(
        "GetReplicationRuns",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("replicationJobId" => replicationJobId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_servers()
    get_servers(params::Dict{String,<:Any})

Describes the servers in your server catalog. Before you can describe your servers, you
must import them using ImportServerCatalog.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in a single call. The default
  value is 50. To retrieve the remaining results, make another call with the returned
  NextToken value.
- `"nextToken"`: The token for the next set of results.
- `"vmServerAddressList"`: The server addresses.
"""
function get_servers(; aws_config::AbstractAWSConfig=current_aws_config())
    return sms("GetServers"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function get_servers(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sms("GetServers", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end

"""
    import_app_catalog()
    import_app_catalog(params::Dict{String,<:Any})

Allows application import from Migration Hub.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"roleName"`: The name of the service role. If you omit this parameter, we create a
  service-linked role for Migration Hub in your account. Otherwise, the role that you provide
  must have the policy and trust policy described in the Migration Hub User Guide.
"""
function import_app_catalog(; aws_config::AbstractAWSConfig=current_aws_config())
    return sms("ImportAppCatalog"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function import_app_catalog(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sms(
        "ImportAppCatalog", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    import_server_catalog()
    import_server_catalog(params::Dict{String,<:Any})

Gathers a complete list of on-premises servers. Connectors must be installed and monitoring
all servers to import. This call returns immediately, but might take additional time to
retrieve all the servers.

"""
function import_server_catalog(; aws_config::AbstractAWSConfig=current_aws_config())
    return sms(
        "ImportServerCatalog"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function import_server_catalog(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sms(
        "ImportServerCatalog",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    launch_app()
    launch_app(params::Dict{String,<:Any})

Launches the specified application as a stack in CloudFormation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"appId"`: The ID of the application.
"""
function launch_app(; aws_config::AbstractAWSConfig=current_aws_config())
    return sms("LaunchApp"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function launch_app(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sms("LaunchApp", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end

"""
    list_apps()
    list_apps(params::Dict{String,<:Any})

Retrieves summaries for all applications.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"appIds"`: The unique application IDs.
- `"maxResults"`: The maximum number of results to return in a single call. The default
  value is 100. To retrieve the remaining results, make another call with the returned
  NextToken value.
- `"nextToken"`: The token for the next set of results.
"""
function list_apps(; aws_config::AbstractAWSConfig=current_aws_config())
    return sms("ListApps"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_apps(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sms("ListApps", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end

"""
    notify_app_validation_output(app_id)
    notify_app_validation_output(app_id, params::Dict{String,<:Any})

Provides information to Server Migration Service about whether application validation is
successful.

# Arguments
- `app_id`: The ID of the application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"notificationContext"`: The notification information.
"""
function notify_app_validation_output(
    appId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sms(
        "NotifyAppValidationOutput",
        Dict{String,Any}("appId" => appId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function notify_app_validation_output(
    appId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sms(
        "NotifyAppValidationOutput",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("appId" => appId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_app_launch_configuration()
    put_app_launch_configuration(params::Dict{String,<:Any})

Creates or updates the launch configuration for the specified application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"appId"`: The ID of the application.
- `"autoLaunch"`: Indicates whether the application is configured to launch automatically
  after replication is complete.
- `"roleName"`: The name of service role in the customer's account that CloudFormation uses
  to launch the application.
- `"serverGroupLaunchConfigurations"`: Information about the launch configurations for
  server groups in the application.
"""
function put_app_launch_configuration(; aws_config::AbstractAWSConfig=current_aws_config())
    return sms(
        "PutAppLaunchConfiguration"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function put_app_launch_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sms(
        "PutAppLaunchConfiguration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_app_replication_configuration()
    put_app_replication_configuration(params::Dict{String,<:Any})

Creates or updates the replication configuration for the specified application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"appId"`: The ID of the application.
- `"serverGroupReplicationConfigurations"`: Information about the replication
  configurations for server groups in the application.
"""
function put_app_replication_configuration(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return sms(
        "PutAppReplicationConfiguration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_app_replication_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sms(
        "PutAppReplicationConfiguration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_app_validation_configuration(app_id)
    put_app_validation_configuration(app_id, params::Dict{String,<:Any})

Creates or updates a validation configuration for the specified application.

# Arguments
- `app_id`: The ID of the application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"appValidationConfigurations"`: The configuration for application validation.
- `"serverGroupValidationConfigurations"`: The configuration for instance validation.
"""
function put_app_validation_configuration(
    appId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sms(
        "PutAppValidationConfiguration",
        Dict{String,Any}("appId" => appId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_app_validation_configuration(
    appId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sms(
        "PutAppValidationConfiguration",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("appId" => appId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_app_replication()
    start_app_replication(params::Dict{String,<:Any})

Starts replicating the specified application by creating replication jobs for each server
in the application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"appId"`: The ID of the application.
"""
function start_app_replication(; aws_config::AbstractAWSConfig=current_aws_config())
    return sms(
        "StartAppReplication"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function start_app_replication(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sms(
        "StartAppReplication",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_on_demand_app_replication(app_id)
    start_on_demand_app_replication(app_id, params::Dict{String,<:Any})

Starts an on-demand replication run for the specified application.

# Arguments
- `app_id`: The ID of the application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description of the replication run.
"""
function start_on_demand_app_replication(
    appId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sms(
        "StartOnDemandAppReplication",
        Dict{String,Any}("appId" => appId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_on_demand_app_replication(
    appId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sms(
        "StartOnDemandAppReplication",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("appId" => appId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_on_demand_replication_run(replication_job_id)
    start_on_demand_replication_run(replication_job_id, params::Dict{String,<:Any})

Starts an on-demand replication run for the specified replication job. This replication run
starts immediately. This replication run is in addition to the ones already scheduled.
There is a limit on the number of on-demand replications runs that you can request in a
24-hour period.

# Arguments
- `replication_job_id`: The ID of the replication job.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description of the replication run.
"""
function start_on_demand_replication_run(
    replicationJobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sms(
        "StartOnDemandReplicationRun",
        Dict{String,Any}("replicationJobId" => replicationJobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_on_demand_replication_run(
    replicationJobId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sms(
        "StartOnDemandReplicationRun",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("replicationJobId" => replicationJobId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_app_replication()
    stop_app_replication(params::Dict{String,<:Any})

Stops replicating the specified application by deleting the replication job for each server
in the application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"appId"`: The ID of the application.
"""
function stop_app_replication(; aws_config::AbstractAWSConfig=current_aws_config())
    return sms("StopAppReplication"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function stop_app_replication(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sms(
        "StopAppReplication", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    terminate_app()
    terminate_app(params::Dict{String,<:Any})

Terminates the stack for the specified application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"appId"`: The ID of the application.
"""
function terminate_app(; aws_config::AbstractAWSConfig=current_aws_config())
    return sms("TerminateApp"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function terminate_app(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sms(
        "TerminateApp", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    update_app()
    update_app(params::Dict{String,<:Any})

Updates the specified application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"appId"`: The ID of the application.
- `"description"`: The new description of the application.
- `"name"`: The new name of the application.
- `"roleName"`: The name of the service role in the customer's account used by Server
  Migration Service.
- `"serverGroups"`: The server groups in the application to update.
- `"tags"`: The tags to associate with the application.
"""
function update_app(; aws_config::AbstractAWSConfig=current_aws_config())
    return sms("UpdateApp"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function update_app(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sms("UpdateApp", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end

"""
    update_replication_job(replication_job_id)
    update_replication_job(replication_job_id, params::Dict{String,<:Any})

Updates the specified settings for the specified replication job.

# Arguments
- `replication_job_id`: The ID of the replication job.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description of the replication job.
- `"encrypted"`: When true, the replication job produces encrypted AMIs. For more
  information, KmsKeyId.
- `"frequency"`: The time between consecutive replication runs, in hours.
- `"kmsKeyId"`: The ID of the KMS key for replication jobs that produce encrypted AMIs.
  This value can be any of the following:   KMS key ID   KMS key alias   ARN referring to the
  KMS key ID   ARN referring to the KMS key alias   If encrypted is enabled but a KMS key ID
  is not specified, the customer's default KMS key for Amazon EBS is used.
- `"licenseType"`: The license type to be used for the AMI created by a successful
  replication run.
- `"nextReplicationRunStartTime"`: The start time of the next replication run.
- `"numberOfRecentAmisToKeep"`: The maximum number of SMS-created AMIs to retain. The
  oldest is deleted after the maximum number is reached and a new AMI is created.
- `"roleName"`: The name of the IAM role to be used by Server Migration Service.
"""
function update_replication_job(
    replicationJobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sms(
        "UpdateReplicationJob",
        Dict{String,Any}("replicationJobId" => replicationJobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_replication_job(
    replicationJobId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sms(
        "UpdateReplicationJob",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("replicationJobId" => replicationJobId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWS.jl
using AWS
using AWS.AWSServices: bedrock
using AWS.Compat
using AWS.UUIDs

"""
    batch_delete_evaluation_job(job_identifiers)
    batch_delete_evaluation_job(job_identifiers, params::Dict{String,<:Any})

Creates a batch deletion job. A model evaluation job can only be deleted if it has
following status FAILED, COMPLETED, and STOPPED. You can request up to 25 model evaluation
jobs be deleted in a single request.

# Arguments
- `job_identifiers`: An array of model evaluation job ARNs to be deleted.

"""
function batch_delete_evaluation_job end

function batch_delete_evaluation_job(
    jobIdentifiers; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock(
        "POST",
        "/evaluation-jobs/batch-delete",
        Dict{String,Any}("jobIdentifiers" => jobIdentifiers);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function batch_delete_evaluation_job(
    jobIdentifiers,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock(
        "POST",
        "/evaluation-jobs/batch-delete",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("jobIdentifiers" => jobIdentifiers), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_evaluation_job(evaluation_config, inference_config, job_name, output_data_config, role_arn)
    create_evaluation_job(evaluation_config, inference_config, job_name, output_data_config, role_arn, params::Dict{String,<:Any})

API operation for creating and managing Amazon Bedrock automatic model evaluation jobs and
model evaluation jobs that use human workers. To learn more about the requirements for
creating a model evaluation job see, Model evaluation.

# Arguments
- `evaluation_config`: Specifies whether the model evaluation job is automatic or uses
  human worker.
- `inference_config`: Specify the models you want to use in your model evaluation job.
  Automatic model evaluation jobs support a single model, and model evaluation job that use
  human workers support two models.
- `job_name`: The name of the model evaluation job. Model evaluation job names must unique
  with your AWS account, and your account's AWS region.
- `output_data_config`: An object that defines where the results of model evaluation job
  will be saved in Amazon S3.
- `role_arn`: The Amazon Resource Name (ARN) of an IAM service role that Amazon Bedrock can
  assume to perform tasks on your behalf. The service role must have Amazon Bedrock as the
  service principal, and provide access to any Amazon S3 buckets specified in the
  EvaluationConfig object. To pass this role to Amazon Bedrock, the caller of this API must
  have the iam:PassRole permission. To learn more about the required permissions, see
  Required permissions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientRequestToken"`: A unique, case-sensitive identifier to ensure that the API
  request completes no more than one time. If this token matches a previous request, Amazon
  Bedrock ignores the request, but does not return an error. For more information, see
  Ensuring idempotency.
- `"customerEncryptionKeyId"`: Specify your customer managed key ARN that will be used to
  encrypt your model evaluation job.
- `"jobDescription"`: A description of the model evaluation job.
- `"jobTags"`: Tags to attach to the model evaluation job.
"""
function create_evaluation_job end

function create_evaluation_job(
    evaluationConfig,
    inferenceConfig,
    jobName,
    outputDataConfig,
    roleArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock(
        "POST",
        "/evaluation-jobs",
        Dict{String,Any}(
            "evaluationConfig" => evaluationConfig,
            "inferenceConfig" => inferenceConfig,
            "jobName" => jobName,
            "outputDataConfig" => outputDataConfig,
            "roleArn" => roleArn,
            "clientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function create_evaluation_job(
    evaluationConfig,
    inferenceConfig,
    jobName,
    outputDataConfig,
    roleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock(
        "POST",
        "/evaluation-jobs",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "evaluationConfig" => evaluationConfig,
                    "inferenceConfig" => inferenceConfig,
                    "jobName" => jobName,
                    "outputDataConfig" => outputDataConfig,
                    "roleArn" => roleArn,
                    "clientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_guardrail(blocked_input_messaging, blocked_outputs_messaging, name)
    create_guardrail(blocked_input_messaging, blocked_outputs_messaging, name, params::Dict{String,<:Any})

Creates a guardrail to block topics and to implement safeguards for your generative AI
applications. You can configure the following policies in a guardrail to avoid undesirable
and harmful content, filter out denied topics and words, and remove sensitive information
for privacy protection.    Content filters - Adjust filter strengths to block input prompts
or model responses containing harmful content.    Denied topics - Define a set of topics
that are undesirable in the context of your application. These topics will be blocked if
detected in user queries or model responses.    Word filters - Configure filters to block
undesirable words, phrases, and profanity. Such words can include offensive terms,
competitor names etc.    Sensitive information filters - Block or mask sensitive
information such as personally identifiable information (PII) or custom regex in user
inputs and model responses.   In addition to the above policies, you can also configure the
messages to be returned to the user if a user input or model response is in violation of
the policies defined in the guardrail. For more information, see Guardrails for Amazon
Bedrock in the Amazon Bedrock User Guide.

# Arguments
- `blocked_input_messaging`: The message to return when the guardrail blocks a prompt.
- `blocked_outputs_messaging`: The message to return when the guardrail blocks a model
  response.
- `name`: The name to give the guardrail.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientRequestToken"`: A unique, case-sensitive identifier to ensure that the API
  request completes no more than once. If this token matches a previous request, Amazon
  Bedrock ignores the request, but does not return an error. For more information, see
  Ensuring idempotency in the Amazon S3 User Guide.
- `"contentPolicyConfig"`: The content filter policies to configure for the guardrail.
- `"contextualGroundingPolicyConfig"`: The contextual grounding policy configuration used
  to create a guardrail.
- `"description"`: A description of the guardrail.
- `"kmsKeyId"`: The ARN of the KMS key that you use to encrypt the guardrail.
- `"sensitiveInformationPolicyConfig"`: The sensitive information policy to configure for
  the guardrail.
- `"tags"`: The tags that you want to attach to the guardrail.
- `"topicPolicyConfig"`: The topic policies to configure for the guardrail.
- `"wordPolicyConfig"`: The word policy you configure for the guardrail.
"""
function create_guardrail end

function create_guardrail(
    blockedInputMessaging,
    blockedOutputsMessaging,
    name;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock(
        "POST",
        "/guardrails",
        Dict{String,Any}(
            "blockedInputMessaging" => blockedInputMessaging,
            "blockedOutputsMessaging" => blockedOutputsMessaging,
            "name" => name,
            "clientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function create_guardrail(
    blockedInputMessaging,
    blockedOutputsMessaging,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock(
        "POST",
        "/guardrails",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "blockedInputMessaging" => blockedInputMessaging,
                    "blockedOutputsMessaging" => blockedOutputsMessaging,
                    "name" => name,
                    "clientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_guardrail_version(guardrail_identifier)
    create_guardrail_version(guardrail_identifier, params::Dict{String,<:Any})

Creates a version of the guardrail. Use this API to create a snapshot of the guardrail when
you are satisfied with a configuration, or to compare the configuration with another
version.

# Arguments
- `guardrail_identifier`: The unique identifier of the guardrail. This can be an ID or the
  ARN.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientRequestToken"`: A unique, case-sensitive identifier to ensure that the API
  request completes no more than once. If this token matches a previous request, Amazon
  Bedrock ignores the request, but does not return an error. For more information, see
  Ensuring idempotency in the Amazon S3 User Guide.
- `"description"`: A description of the guardrail version.
"""
function create_guardrail_version end

function create_guardrail_version(
    guardrailIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock(
        "POST",
        "/guardrails/$(guardrailIdentifier)",
        Dict{String,Any}("clientRequestToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function create_guardrail_version(
    guardrailIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock(
        "POST",
        "/guardrails/$(guardrailIdentifier)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("clientRequestToken" => string(uuid4())), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_model_copy_job(source_model_arn, target_model_name)
    create_model_copy_job(source_model_arn, target_model_name, params::Dict{String,<:Any})

Copies a model to another region so that it can be used there. For more information, see
Copy models to be used in other regions in the Amazon Bedrock User Guide.

# Arguments
- `source_model_arn`: The Amazon Resource Name (ARN) of the model to be copied.
- `target_model_name`: A name for the copied model.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientRequestToken"`: A unique, case-sensitive identifier to ensure that the API
  request completes no more than one time. If this token matches a previous request, Amazon
  Bedrock ignores the request, but does not return an error. For more information, see
  Ensuring idempotency.
- `"modelKmsKeyId"`: The ARN of the KMS key that you use to encrypt the model copy.
- `"targetModelTags"`: Tags to associate with the target model. For more information, see
  Tag resources in the Amazon Bedrock User Guide.
"""
function create_model_copy_job end

function create_model_copy_job(
    sourceModelArn, targetModelName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock(
        "POST",
        "/model-copy-jobs",
        Dict{String,Any}(
            "sourceModelArn" => sourceModelArn,
            "targetModelName" => targetModelName,
            "clientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function create_model_copy_job(
    sourceModelArn,
    targetModelName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock(
        "POST",
        "/model-copy-jobs",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "sourceModelArn" => sourceModelArn,
                    "targetModelName" => targetModelName,
                    "clientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_model_customization_job(base_model_identifier, custom_model_name, hyper_parameters, job_name, output_data_config, role_arn, training_data_config)
    create_model_customization_job(base_model_identifier, custom_model_name, hyper_parameters, job_name, output_data_config, role_arn, training_data_config, params::Dict{String,<:Any})

Creates a fine-tuning job to customize a base model. You specify the base foundation model
and the location of the training data. After the model-customization job completes
successfully, your custom model resource will be ready to use. Amazon Bedrock returns
validation loss metrics and output generations after the job completes.  For information on
the format of training and validation data, see Prepare the datasets.  Model-customization
jobs are asynchronous and the completion time depends on the base model and the
training/validation data size. To monitor a job, use the GetModelCustomizationJob operation
to retrieve the job status. For more information, see Custom models in the Amazon Bedrock
User Guide.

# Arguments
- `base_model_identifier`: Name of the base model.
- `custom_model_name`: A name for the resulting custom model.
- `hyper_parameters`: Parameters related to tuning the model. For details on the format for
  different models, see Custom model hyperparameters.
- `job_name`: A name for the fine-tuning job.
- `output_data_config`: S3 location for the output data.
- `role_arn`: The Amazon Resource Name (ARN) of an IAM service role that Amazon Bedrock can
  assume to perform tasks on your behalf. For example, during model training, Amazon Bedrock
  needs your permission to read input data from an S3 bucket, write model artifacts to an S3
  bucket. To pass this role to Amazon Bedrock, the caller of this API must have the
  iam:PassRole permission.
- `training_data_config`: Information about the training dataset.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientRequestToken"`: A unique, case-sensitive identifier to ensure that the API
  request completes no more than one time. If this token matches a previous request, Amazon
  Bedrock ignores the request, but does not return an error. For more information, see
  Ensuring idempotency.
- `"customModelKmsKeyId"`: The custom model is encrypted at rest using this key.
- `"customModelTags"`: Tags to attach to the resulting custom model.
- `"customizationType"`: The customization type.
- `"jobTags"`: Tags to attach to the job.
- `"validationDataConfig"`: Information about the validation dataset.
- `"vpcConfig"`: VPC configuration (optional). Configuration parameters for the private
  Virtual Private Cloud (VPC) that contains the resources you are using for this job.
"""
function create_model_customization_job end

function create_model_customization_job(
    baseModelIdentifier,
    customModelName,
    hyperParameters,
    jobName,
    outputDataConfig,
    roleArn,
    trainingDataConfig;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock(
        "POST",
        "/model-customization-jobs",
        Dict{String,Any}(
            "baseModelIdentifier" => baseModelIdentifier,
            "customModelName" => customModelName,
            "hyperParameters" => hyperParameters,
            "jobName" => jobName,
            "outputDataConfig" => outputDataConfig,
            "roleArn" => roleArn,
            "trainingDataConfig" => trainingDataConfig,
            "clientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function create_model_customization_job(
    baseModelIdentifier,
    customModelName,
    hyperParameters,
    jobName,
    outputDataConfig,
    roleArn,
    trainingDataConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock(
        "POST",
        "/model-customization-jobs",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "baseModelIdentifier" => baseModelIdentifier,
                    "customModelName" => customModelName,
                    "hyperParameters" => hyperParameters,
                    "jobName" => jobName,
                    "outputDataConfig" => outputDataConfig,
                    "roleArn" => roleArn,
                    "trainingDataConfig" => trainingDataConfig,
                    "clientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_model_import_job(imported_model_name, job_name, model_data_source, role_arn)
    create_model_import_job(imported_model_name, job_name, model_data_source, role_arn, params::Dict{String,<:Any})

Creates a model import job to import model that you have customized in other environments,
such as Amazon SageMaker. For more information, see Import a customized model

# Arguments
- `imported_model_name`: The name of the imported model.
- `job_name`: The name of the import job.
- `model_data_source`: The data source for the imported model.
- `role_arn`: The Amazon Resource Name (ARN) of the model import job.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientRequestToken"`: A unique, case-sensitive identifier to ensure that the API
  request completes no more than one time. If this token matches a previous request, Amazon
  Bedrock ignores the request, but does not return an error. For more information, see
  Ensuring idempotency.
- `"importedModelKmsKeyId"`: The imported model is encrypted at rest using this key.
- `"importedModelTags"`: Tags to attach to the imported model.
- `"jobTags"`: Tags to attach to this import job.
- `"vpcConfig"`: VPC configuration parameters for the private Virtual Private Cloud (VPC)
  that contains the resources you are using for the import job.
"""
function create_model_import_job end

function create_model_import_job(
    importedModelName,
    jobName,
    modelDataSource,
    roleArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock(
        "POST",
        "/model-import-jobs",
        Dict{String,Any}(
            "importedModelName" => importedModelName,
            "jobName" => jobName,
            "modelDataSource" => modelDataSource,
            "roleArn" => roleArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function create_model_import_job(
    importedModelName,
    jobName,
    modelDataSource,
    roleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock(
        "POST",
        "/model-import-jobs",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "importedModelName" => importedModelName,
                    "jobName" => jobName,
                    "modelDataSource" => modelDataSource,
                    "roleArn" => roleArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_model_invocation_job(input_data_config, job_name, model_id, output_data_config, role_arn)
    create_model_invocation_job(input_data_config, job_name, model_id, output_data_config, role_arn, params::Dict{String,<:Any})

Creates a batch inference job to invoke a model on multiple prompts. Format your data
according to Format your inference data and upload it to an Amazon S3 bucket. For more
information, see Process multiple prompts with batch inference. The response returns a
jobArn that you can use to stop or get details about the job.

# Arguments
- `input_data_config`: Details about the location of the input to the batch inference job.
- `job_name`: A name to give the batch inference job.
- `model_id`: The unique identifier of the foundation model to use for the batch inference
  job.
- `output_data_config`: Details about the location of the output of the batch inference job.
- `role_arn`: The Amazon Resource Name (ARN) of the service role with permissions to carry
  out and manage batch inference. You can use the console to create a default service role or
  follow the steps at Create a service role for batch inference.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientRequestToken"`: A unique, case-sensitive identifier to ensure that the API
  request completes no more than one time. If this token matches a previous request, Amazon
  Bedrock ignores the request, but does not return an error. For more information, see
  Ensuring idempotency.
- `"tags"`: Any tags to associate with the batch inference job. For more information, see
  Tagging Amazon Bedrock resources.
- `"timeoutDurationInHours"`: The number of hours after which to force the batch inference
  job to time out.
"""
function create_model_invocation_job end

function create_model_invocation_job(
    inputDataConfig,
    jobName,
    modelId,
    outputDataConfig,
    roleArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock(
        "POST",
        "/model-invocation-job",
        Dict{String,Any}(
            "inputDataConfig" => inputDataConfig,
            "jobName" => jobName,
            "modelId" => modelId,
            "outputDataConfig" => outputDataConfig,
            "roleArn" => roleArn,
            "clientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function create_model_invocation_job(
    inputDataConfig,
    jobName,
    modelId,
    outputDataConfig,
    roleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock(
        "POST",
        "/model-invocation-job",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "inputDataConfig" => inputDataConfig,
                    "jobName" => jobName,
                    "modelId" => modelId,
                    "outputDataConfig" => outputDataConfig,
                    "roleArn" => roleArn,
                    "clientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_provisioned_model_throughput(model_id, model_units, provisioned_model_name)
    create_provisioned_model_throughput(model_id, model_units, provisioned_model_name, params::Dict{String,<:Any})

Creates dedicated throughput for a base or custom model with the model units and for the
duration that you specify. For pricing details, see Amazon Bedrock Pricing. For more
information, see Provisioned Throughput in the Amazon Bedrock User Guide.

# Arguments
- `model_id`: The Amazon Resource Name (ARN) or name of the model to associate with this
  Provisioned Throughput. For a list of models for which you can purchase Provisioned
  Throughput, see Amazon Bedrock model IDs for purchasing Provisioned Throughput in the
  Amazon Bedrock User Guide.
- `model_units`: Number of model units to allocate. A model unit delivers a specific
  throughput level for the specified model. The throughput level of a model unit specifies
  the total number of input and output tokens that it can process and generate within a span
  of one minute. By default, your account has no model units for purchasing Provisioned
  Throughputs with commitment. You must first visit the Amazon Web Services support center to
  request MUs. For model unit quotas, see Provisioned Throughput quotas in the Amazon Bedrock
  User Guide. For more information about what an MU specifies, contact your Amazon Web
  Services account manager.
- `provisioned_model_name`: The name for this Provisioned Throughput.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientRequestToken"`: A unique, case-sensitive identifier to ensure that the API
  request completes no more than one time. If this token matches a previous request, Amazon
  Bedrock ignores the request, but does not return an error. For more information, see
  Ensuring idempotency in the Amazon S3 User Guide.
- `"commitmentDuration"`: The commitment duration requested for the Provisioned Throughput.
  Billing occurs hourly and is discounted for longer commitment terms. To request a no-commit
  Provisioned Throughput, omit this field. Custom models support all levels of commitment. To
  see which base models support no commitment, see Supported regions and models for
  Provisioned Throughput in the Amazon Bedrock User Guide
- `"tags"`: Tags to associate with this Provisioned Throughput.
"""
function create_provisioned_model_throughput end

function create_provisioned_model_throughput(
    modelId,
    modelUnits,
    provisionedModelName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock(
        "POST",
        "/provisioned-model-throughput",
        Dict{String,Any}(
            "modelId" => modelId,
            "modelUnits" => modelUnits,
            "provisionedModelName" => provisionedModelName,
            "clientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function create_provisioned_model_throughput(
    modelId,
    modelUnits,
    provisionedModelName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock(
        "POST",
        "/provisioned-model-throughput",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "modelId" => modelId,
                    "modelUnits" => modelUnits,
                    "provisionedModelName" => provisionedModelName,
                    "clientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_custom_model(model_identifier)
    delete_custom_model(model_identifier, params::Dict{String,<:Any})

Deletes a custom model that you created earlier. For more information, see Custom models in
the Amazon Bedrock User Guide.

# Arguments
- `model_identifier`: Name of the model to delete.

"""
function delete_custom_model end

function delete_custom_model(
    modelIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock(
        "DELETE",
        "/custom-models/$(modelIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function delete_custom_model(
    modelIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock(
        "DELETE",
        "/custom-models/$(modelIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_guardrail(guardrail_identifier)
    delete_guardrail(guardrail_identifier, params::Dict{String,<:Any})

Deletes a guardrail.   To delete a guardrail, only specify the ARN of the guardrail in the
guardrailIdentifier field. If you delete a guardrail, all of its versions will be deleted.
 To delete a version of a guardrail, specify the ARN of the guardrail in the
guardrailIdentifier field and the version in the guardrailVersion field.

# Arguments
- `guardrail_identifier`: The unique identifier of the guardrail. This can be an ID or the
  ARN.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"guardrailVersion"`: The version of the guardrail.
"""
function delete_guardrail end

function delete_guardrail(
    guardrailIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock(
        "DELETE",
        "/guardrails/$(guardrailIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function delete_guardrail(
    guardrailIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock(
        "DELETE",
        "/guardrails/$(guardrailIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_imported_model(model_identifier)
    delete_imported_model(model_identifier, params::Dict{String,<:Any})

Deletes a custom model that you imported earlier. For more information, see Import a
customized model in the Amazon Bedrock User Guide.

# Arguments
- `model_identifier`: Name of the imported model to delete.

"""
function delete_imported_model end

function delete_imported_model(
    modelIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock(
        "DELETE",
        "/imported-models/$(modelIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function delete_imported_model(
    modelIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock(
        "DELETE",
        "/imported-models/$(modelIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_model_invocation_logging_configuration()
    delete_model_invocation_logging_configuration(params::Dict{String,<:Any})

Delete the invocation logging.

"""
function delete_model_invocation_logging_configuration end

function delete_model_invocation_logging_configuration(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock(
        "DELETE",
        "/logging/modelinvocations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function delete_model_invocation_logging_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock(
        "DELETE",
        "/logging/modelinvocations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_provisioned_model_throughput(provisioned_model_id)
    delete_provisioned_model_throughput(provisioned_model_id, params::Dict{String,<:Any})

Deletes a Provisioned Throughput. You can't delete a Provisioned Throughput before the
commitment term is over. For more information, see Provisioned Throughput in the Amazon
Bedrock User Guide.

# Arguments
- `provisioned_model_id`: The Amazon Resource Name (ARN) or name of the Provisioned
  Throughput.

"""
function delete_provisioned_model_throughput end

function delete_provisioned_model_throughput(
    provisionedModelId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock(
        "DELETE",
        "/provisioned-model-throughput/$(provisionedModelId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function delete_provisioned_model_throughput(
    provisionedModelId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock(
        "DELETE",
        "/provisioned-model-throughput/$(provisionedModelId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_custom_model(model_identifier)
    get_custom_model(model_identifier, params::Dict{String,<:Any})

Get the properties associated with a Amazon Bedrock custom model that you have created.For
more information, see Custom models in the Amazon Bedrock User Guide.

# Arguments
- `model_identifier`: Name or Amazon Resource Name (ARN) of the custom model.

"""
function get_custom_model end

function get_custom_model(
    modelIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock(
        "GET",
        "/custom-models/$(modelIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function get_custom_model(
    modelIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock(
        "GET",
        "/custom-models/$(modelIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_evaluation_job(job_identifier)
    get_evaluation_job(job_identifier, params::Dict{String,<:Any})

Retrieves the properties associated with a model evaluation job, including the status of
the job. For more information, see Model evaluation.

# Arguments
- `job_identifier`: The Amazon Resource Name (ARN) of the model evaluation job.

"""
function get_evaluation_job end

function get_evaluation_job(
    jobIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock(
        "GET",
        "/evaluation-jobs/$(jobIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function get_evaluation_job(
    jobIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock(
        "GET",
        "/evaluation-jobs/$(jobIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_foundation_model(model_identifier)
    get_foundation_model(model_identifier, params::Dict{String,<:Any})

Get details about a Amazon Bedrock foundation model.

# Arguments
- `model_identifier`: The model identifier.

"""
function get_foundation_model end

function get_foundation_model(
    modelIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock(
        "GET",
        "/foundation-models/$(modelIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function get_foundation_model(
    modelIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock(
        "GET",
        "/foundation-models/$(modelIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_guardrail(guardrail_identifier)
    get_guardrail(guardrail_identifier, params::Dict{String,<:Any})

Gets details about a guardrail. If you don't specify a version, the response returns
details for the DRAFT version.

# Arguments
- `guardrail_identifier`: The unique identifier of the guardrail for which to get details.
  This can be an ID or the ARN.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"guardrailVersion"`: The version of the guardrail for which to get details. If you don't
  specify a version, the response returns details for the DRAFT version.
"""
function get_guardrail end

function get_guardrail(
    guardrailIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock(
        "GET",
        "/guardrails/$(guardrailIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function get_guardrail(
    guardrailIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock(
        "GET",
        "/guardrails/$(guardrailIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_imported_model(model_identifier)
    get_imported_model(model_identifier, params::Dict{String,<:Any})

Gets properties associated with a customized model you imported.

# Arguments
- `model_identifier`: Name or Amazon Resource Name (ARN) of the imported model.

"""
function get_imported_model end

function get_imported_model(
    modelIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock(
        "GET",
        "/imported-models/$(modelIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function get_imported_model(
    modelIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock(
        "GET",
        "/imported-models/$(modelIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_inference_profile(inference_profile_identifier)
    get_inference_profile(inference_profile_identifier, params::Dict{String,<:Any})

Gets information about an inference profile. For more information, see the Amazon Bedrock
User Guide.

# Arguments
- `inference_profile_identifier`: The unique identifier of the inference profile.

"""
function get_inference_profile end

function get_inference_profile(
    inferenceProfileIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock(
        "GET",
        "/inference-profiles/$(inferenceProfileIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function get_inference_profile(
    inferenceProfileIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock(
        "GET",
        "/inference-profiles/$(inferenceProfileIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_model_copy_job(job_arn)
    get_model_copy_job(job_arn, params::Dict{String,<:Any})

Retrieves information about a model copy job. For more information, see Copy models to be
used in other regions in the Amazon Bedrock User Guide.

# Arguments
- `job_arn`: The Amazon Resource Name (ARN) of the model copy job.

"""
function get_model_copy_job end

function get_model_copy_job(jobArn; aws_config::AbstractAWSConfig=current_aws_config())
    return bedrock(
        "GET",
        "/model-copy-jobs/$(jobArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function get_model_copy_job(
    jobArn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock(
        "GET",
        "/model-copy-jobs/$(jobArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_model_customization_job(job_identifier)
    get_model_customization_job(job_identifier, params::Dict{String,<:Any})

Retrieves the properties associated with a model-customization job, including the status of
the job. For more information, see Custom models in the Amazon Bedrock User Guide.

# Arguments
- `job_identifier`: Identifier for the customization job.

"""
function get_model_customization_job end

function get_model_customization_job(
    jobIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock(
        "GET",
        "/model-customization-jobs/$(jobIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function get_model_customization_job(
    jobIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock(
        "GET",
        "/model-customization-jobs/$(jobIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_model_import_job(job_identifier)
    get_model_import_job(job_identifier, params::Dict{String,<:Any})

Retrieves the properties associated with import model job, including the status of the job.
For more information, see Import a customized model in the Amazon Bedrock User Guide.

# Arguments
- `job_identifier`: The identifier of the import job.

"""
function get_model_import_job end

function get_model_import_job(
    jobIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock(
        "GET",
        "/model-import-jobs/$(jobIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function get_model_import_job(
    jobIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock(
        "GET",
        "/model-import-jobs/$(jobIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_model_invocation_job(job_identifier)
    get_model_invocation_job(job_identifier, params::Dict{String,<:Any})

Gets details about a batch inference job. For more information, see View details about a
batch inference job

# Arguments
- `job_identifier`: The Amazon Resource Name (ARN) of the batch inference job.

"""
function get_model_invocation_job end

function get_model_invocation_job(
    jobIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock(
        "GET",
        "/model-invocation-job/$(jobIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function get_model_invocation_job(
    jobIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock(
        "GET",
        "/model-invocation-job/$(jobIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_model_invocation_logging_configuration()
    get_model_invocation_logging_configuration(params::Dict{String,<:Any})

Get the current configuration values for model invocation logging.

"""
function get_model_invocation_logging_configuration end

function get_model_invocation_logging_configuration(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock(
        "GET",
        "/logging/modelinvocations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function get_model_invocation_logging_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock(
        "GET",
        "/logging/modelinvocations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_provisioned_model_throughput(provisioned_model_id)
    get_provisioned_model_throughput(provisioned_model_id, params::Dict{String,<:Any})

Returns details for a Provisioned Throughput. For more information, see Provisioned
Throughput in the Amazon Bedrock User Guide.

# Arguments
- `provisioned_model_id`: The Amazon Resource Name (ARN) or name of the Provisioned
  Throughput.

"""
function get_provisioned_model_throughput end

function get_provisioned_model_throughput(
    provisionedModelId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock(
        "GET",
        "/provisioned-model-throughput/$(provisionedModelId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function get_provisioned_model_throughput(
    provisionedModelId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock(
        "GET",
        "/provisioned-model-throughput/$(provisionedModelId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_custom_models()
    list_custom_models(params::Dict{String,<:Any})

Returns a list of the custom models that you have created with the
CreateModelCustomizationJob operation. For more information, see Custom models in the
Amazon Bedrock User Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"baseModelArnEquals"`: Return custom models only if the base model Amazon Resource Name
  (ARN) matches this parameter.
- `"creationTimeAfter"`: Return custom models created after the specified time.
- `"creationTimeBefore"`: Return custom models created before the specified time.
- `"foundationModelArnEquals"`: Return custom models only if the foundation model Amazon
  Resource Name (ARN) matches this parameter.
- `"isOwned"`: Return custom models depending on if the current account owns them (true) or
  if they were shared with the current account (false).
- `"maxResults"`: The maximum number of results to return in the response. If the total
  number of results is greater than this value, use the token returned in the response in the
  nextToken field when making another request to return the next batch of results.
- `"nameContains"`: Return custom models only if the job name contains these characters.
- `"nextToken"`: If the total number of results is greater than the maxResults value
  provided in the request, enter the token returned in the nextToken field in the response in
  this field to return the next batch of results.
- `"sortBy"`: The field to sort by in the returned list of models.
- `"sortOrder"`: The sort order of the results.
"""
function list_custom_models end

function list_custom_models(; aws_config::AbstractAWSConfig=current_aws_config())
    return bedrock(
        "GET", "/custom-models"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

function list_custom_models(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock(
        "GET",
        "/custom-models",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_evaluation_jobs()
    list_evaluation_jobs(params::Dict{String,<:Any})

Lists model evaluation jobs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"creationTimeAfter"`: A filter that includes model evaluation jobs created after the
  time specified.
- `"creationTimeBefore"`: A filter that includes model evaluation jobs created prior to the
  time specified.
- `"maxResults"`: The maximum number of results to return.
- `"nameContains"`: Query parameter string for model evaluation job names.
- `"nextToken"`: Continuation token from the previous response, for Amazon Bedrock to list
  the next set of results.
- `"sortBy"`: Allows you to sort model evaluation jobs by when they were created.
- `"sortOrder"`: How you want the order of jobs sorted.
- `"statusEquals"`: Only return jobs where the status condition is met.
"""
function list_evaluation_jobs end

function list_evaluation_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return bedrock(
        "GET", "/evaluation-jobs"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

function list_evaluation_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock(
        "GET",
        "/evaluation-jobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_foundation_models()
    list_foundation_models(params::Dict{String,<:Any})

Lists Amazon Bedrock foundation models that you can use. You can filter the results with
the request parameters. For more information, see Foundation models in the Amazon Bedrock
User Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"byCustomizationType"`: Return models that support the customization type that you
  specify. For more information, see Custom models in the Amazon Bedrock User Guide.
- `"byInferenceType"`: Return models that support the inference type that you specify. For
  more information, see Provisioned Throughput in the Amazon Bedrock User Guide.
- `"byOutputModality"`: Return models that support the output modality that you specify.
- `"byProvider"`: Return models belonging to the model provider that you specify.
"""
function list_foundation_models end

function list_foundation_models(; aws_config::AbstractAWSConfig=current_aws_config())
    return bedrock(
        "GET", "/foundation-models"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

function list_foundation_models(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock(
        "GET",
        "/foundation-models",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_guardrails()
    list_guardrails(params::Dict{String,<:Any})

Lists details about all the guardrails in an account. To list the DRAFT version of all your
guardrails, don't specify the guardrailIdentifier field. To list all versions of a
guardrail, specify the ARN of the guardrail in the guardrailIdentifier field. You can set
the maximum number of results to return in a response in the maxResults field. If there are
more results than the number you set, the response returns a nextToken that you can send in
another ListGuardrails request to see the next batch of results.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"guardrailIdentifier"`: The unique identifier of the guardrail. This can be an ID or the
  ARN.
- `"maxResults"`: The maximum number of results to return in the response.
- `"nextToken"`: If there are more results than were returned in the response, the response
  returns a nextToken that you can send in another ListGuardrails request to see the next
  batch of results.
"""
function list_guardrails end

function list_guardrails(; aws_config::AbstractAWSConfig=current_aws_config())
    return bedrock(
        "GET", "/guardrails"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

function list_guardrails(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock(
        "GET", "/guardrails", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_imported_models()
    list_imported_models(params::Dict{String,<:Any})

Returns a list of models you've imported. You can filter the results to return based on one
or more criteria. For more information, see Import a customized model in the Amazon Bedrock
User Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"creationTimeAfter"`: Return imported models that were created after the specified time.
- `"creationTimeBefore"`: Return imported models that created before the specified time.
- `"maxResults"`: The maximum number of results to return in the response. If the total
  number of results is greater than this value, use the token returned in the response in the
  nextToken field when making another request to return the next batch of results.
- `"nameContains"`: Return imported models only if the model name contains these characters.
- `"nextToken"`: If the total number of results is greater than the maxResults value
  provided in the request, enter the token returned in the nextToken field in the response in
  this field to return the next batch of results.
- `"sortBy"`: The field to sort by in the returned list of imported models.
- `"sortOrder"`: Specifies whetehr to sort the results in ascending or descending order.
"""
function list_imported_models end

function list_imported_models(; aws_config::AbstractAWSConfig=current_aws_config())
    return bedrock(
        "GET", "/imported-models"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

function list_imported_models(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock(
        "GET",
        "/imported-models",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_inference_profiles()
    list_inference_profiles(params::Dict{String,<:Any})

Returns a list of inference profiles that you can use.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in the response. If the total
  number of results is greater than this value, use the token returned in the response in the
  nextToken field when making another request to return the next batch of results.
- `"nextToken"`: If the total number of results is greater than the maxResults value
  provided in the request, enter the token returned in the nextToken field in the response in
  this field to return the next batch of results.
"""
function list_inference_profiles end

function list_inference_profiles(; aws_config::AbstractAWSConfig=current_aws_config())
    return bedrock(
        "GET", "/inference-profiles"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

function list_inference_profiles(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock(
        "GET",
        "/inference-profiles",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_model_copy_jobs()
    list_model_copy_jobs(params::Dict{String,<:Any})

Returns a list of model copy jobs that you have submitted. You can filter the jobs to
return based on one or more criteria. For more information, see Copy models to be used in
other regions in the Amazon Bedrock User Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"creationTimeAfter"`: Filters for model copy jobs created after the specified time.
- `"creationTimeBefore"`: Filters for model copy jobs created before the specified time.
- `"maxResults"`: The maximum number of results to return in the response. If the total
  number of results is greater than this value, use the token returned in the response in the
  nextToken field when making another request to return the next batch of results.
- `"nextToken"`: If the total number of results is greater than the maxResults value
  provided in the request, enter the token returned in the nextToken field in the response in
  this field to return the next batch of results.
- `"outputModelNameContains"`: Filters for model copy jobs in which the name of the copied
  model contains the string that you specify.
- `"sortBy"`: The field to sort by in the returned list of model copy jobs.
- `"sortOrder"`: Specifies whether to sort the results in ascending or descending order.
- `"sourceAccountEquals"`: Filters for model copy jobs in which the account that the source
  model belongs to is equal to the value that you specify.
- `"sourceModelArnEquals"`: Filters for model copy jobs in which the Amazon Resource Name
  (ARN) of the source model to is equal to the value that you specify.
- `"statusEquals"`: Filters for model copy jobs whose status matches the value that you
  specify.
"""
function list_model_copy_jobs end

function list_model_copy_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return bedrock(
        "GET", "/model-copy-jobs"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

function list_model_copy_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock(
        "GET",
        "/model-copy-jobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_model_customization_jobs()
    list_model_customization_jobs(params::Dict{String,<:Any})

Returns a list of model customization jobs that you have submitted. You can filter the jobs
to return based on one or more criteria. For more information, see Custom models in the
Amazon Bedrock User Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"creationTimeAfter"`: Return customization jobs created after the specified time.
- `"creationTimeBefore"`: Return customization jobs created before the specified time.
- `"maxResults"`: The maximum number of results to return in the response. If the total
  number of results is greater than this value, use the token returned in the response in the
  nextToken field when making another request to return the next batch of results.
- `"nameContains"`: Return customization jobs only if the job name contains these
  characters.
- `"nextToken"`: If the total number of results is greater than the maxResults value
  provided in the request, enter the token returned in the nextToken field in the response in
  this field to return the next batch of results.
- `"sortBy"`: The field to sort by in the returned list of jobs.
- `"sortOrder"`: The sort order of the results.
- `"statusEquals"`: Return customization jobs with the specified status.
"""
function list_model_customization_jobs end

function list_model_customization_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return bedrock(
        "GET",
        "/model-customization-jobs";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function list_model_customization_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock(
        "GET",
        "/model-customization-jobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_model_import_jobs()
    list_model_import_jobs(params::Dict{String,<:Any})

Returns a list of import jobs you've submitted. You can filter the results to return based
on one or more criteria. For more information, see Import a customized model in the Amazon
Bedrock User Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"creationTimeAfter"`: Return import jobs that were created after the specified time.
- `"creationTimeBefore"`: Return import jobs that were created before the specified time.
- `"maxResults"`: The maximum number of results to return in the response. If the total
  number of results is greater than this value, use the token returned in the response in the
  nextToken field when making another request to return the next batch of results.
- `"nameContains"`: Return imported jobs only if the job name contains these characters.
- `"nextToken"`: If the total number of results is greater than the maxResults value
  provided in the request, enter the token returned in the nextToken field in the response in
  this field to return the next batch of results.
- `"sortBy"`: The field to sort by in the returned list of imported jobs.
- `"sortOrder"`: Specifies whether to sort the results in ascending or descending order.
- `"statusEquals"`: Return imported jobs with the specified status.
"""
function list_model_import_jobs end

function list_model_import_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return bedrock(
        "GET", "/model-import-jobs"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

function list_model_import_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock(
        "GET",
        "/model-import-jobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_model_invocation_jobs()
    list_model_invocation_jobs(params::Dict{String,<:Any})

Lists all batch inference jobs in the account. For more information, see View details about
a batch inference job.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return. If there are more results than
  the number that you specify, a nextToken value is returned. Use the nextToken in a request
  to return the next batch of results.
- `"nameContains"`: Specify a string to filter for batch inference jobs whose names contain
  the string.
- `"nextToken"`: If there were more results than the value you specified in the maxResults
  field in a previous ListModelInvocationJobs request, the response would have returned a
  nextToken value. To see the next batch of results, send the nextToken value in another
  request.
- `"sortBy"`: An attribute by which to sort the results.
- `"sortOrder"`: Specifies whether to sort the results by ascending or descending order.
- `"statusEquals"`: Specify a status to filter for batch inference jobs whose statuses
  match the string you specify.
- `"submitTimeAfter"`: Specify a time to filter for batch inference jobs that were
  submitted after the time you specify.
- `"submitTimeBefore"`: Specify a time to filter for batch inference jobs that were
  submitted before the time you specify.
"""
function list_model_invocation_jobs end

function list_model_invocation_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return bedrock(
        "GET",
        "/model-invocation-jobs";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function list_model_invocation_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock(
        "GET",
        "/model-invocation-jobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_provisioned_model_throughputs()
    list_provisioned_model_throughputs(params::Dict{String,<:Any})

Lists the Provisioned Throughputs in the account. For more information, see Provisioned
Throughput in the Amazon Bedrock User Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"creationTimeAfter"`: A filter that returns Provisioned Throughputs created after the
  specified time.
- `"creationTimeBefore"`: A filter that returns Provisioned Throughputs created before the
  specified time.
- `"maxResults"`: THe maximum number of results to return in the response. If there are
  more results than the number you specified, the response returns a nextToken value. To see
  the next batch of results, send the nextToken value in another list request.
- `"modelArnEquals"`: A filter that returns Provisioned Throughputs whose model Amazon
  Resource Name (ARN) is equal to the value that you specify.
- `"nameContains"`: A filter that returns Provisioned Throughputs if their name contains
  the expression that you specify.
- `"nextToken"`: If there are more results than the number you specified in the maxResults
  field, the response returns a nextToken value. To see the next batch of results, specify
  the nextToken value in this field.
- `"sortBy"`: The field by which to sort the returned list of Provisioned Throughputs.
- `"sortOrder"`: The sort order of the results.
- `"statusEquals"`: A filter that returns Provisioned Throughputs if their statuses matches
  the value that you specify.
"""
function list_provisioned_model_throughputs end

function list_provisioned_model_throughputs(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock(
        "GET",
        "/provisioned-model-throughputs";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function list_provisioned_model_throughputs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock(
        "GET",
        "/provisioned-model-throughputs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

List the tags associated with the specified resource. For more information, see Tagging
resources in the Amazon Bedrock User Guide.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.

"""
function list_tags_for_resource end

function list_tags_for_resource(
    resourceARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock(
        "POST",
        "/listTagsForResource",
        Dict{String,Any}("resourceARN" => resourceARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function list_tags_for_resource(
    resourceARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock(
        "POST",
        "/listTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceARN" => resourceARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_model_invocation_logging_configuration(logging_config)
    put_model_invocation_logging_configuration(logging_config, params::Dict{String,<:Any})

Set the configuration values for model invocation logging.

# Arguments
- `logging_config`: The logging configuration values to set.

"""
function put_model_invocation_logging_configuration end

function put_model_invocation_logging_configuration(
    loggingConfig; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock(
        "PUT",
        "/logging/modelinvocations",
        Dict{String,Any}("loggingConfig" => loggingConfig);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function put_model_invocation_logging_configuration(
    loggingConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock(
        "PUT",
        "/logging/modelinvocations",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("loggingConfig" => loggingConfig), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_evaluation_job(job_identifier)
    stop_evaluation_job(job_identifier, params::Dict{String,<:Any})

Stops an in progress model evaluation job.

# Arguments
- `job_identifier`: The ARN of the model evaluation job you want to stop.

"""
function stop_evaluation_job end

function stop_evaluation_job(
    jobIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock(
        "POST",
        "/evaluation-job/$(jobIdentifier)/stop";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function stop_evaluation_job(
    jobIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock(
        "POST",
        "/evaluation-job/$(jobIdentifier)/stop",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_model_customization_job(job_identifier)
    stop_model_customization_job(job_identifier, params::Dict{String,<:Any})

Stops an active model customization job. For more information, see Custom models in the
Amazon Bedrock User Guide.

# Arguments
- `job_identifier`: Job identifier of the job to stop.

"""
function stop_model_customization_job end

function stop_model_customization_job(
    jobIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock(
        "POST",
        "/model-customization-jobs/$(jobIdentifier)/stop";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function stop_model_customization_job(
    jobIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock(
        "POST",
        "/model-customization-jobs/$(jobIdentifier)/stop",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_model_invocation_job(job_identifier)
    stop_model_invocation_job(job_identifier, params::Dict{String,<:Any})

Stops a batch inference job. You're only charged for tokens that were already processed.
For more information, see Stop a batch inference job.

# Arguments
- `job_identifier`: The Amazon Resource Name (ARN) of the batch inference job to stop.

"""
function stop_model_invocation_job end

function stop_model_invocation_job(
    jobIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock(
        "POST",
        "/model-invocation-job/$(jobIdentifier)/stop";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function stop_model_invocation_job(
    jobIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock(
        "POST",
        "/model-invocation-job/$(jobIdentifier)/stop",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Associate tags with a resource. For more information, see Tagging resources in the Amazon
Bedrock User Guide.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource to tag.
- `tags`: Tags to associate with the resource.

"""
function tag_resource end

function tag_resource(resourceARN, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return bedrock(
        "POST",
        "/tagResource",
        Dict{String,Any}("resourceARN" => resourceARN, "tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function tag_resource(
    resourceARN,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock(
        "POST",
        "/tagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceARN" => resourceARN, "tags" => tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Remove one or more tags from a resource. For more information, see Tagging resources in the
Amazon Bedrock User Guide.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource to untag.
- `tag_keys`: Tag keys of the tags to remove from the resource.

"""
function untag_resource end

function untag_resource(
    resourceARN, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock(
        "POST",
        "/untagResource",
        Dict{String,Any}("resourceARN" => resourceARN, "tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function untag_resource(
    resourceARN,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock(
        "POST",
        "/untagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceARN" => resourceARN, "tagKeys" => tagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_guardrail(blocked_input_messaging, blocked_outputs_messaging, guardrail_identifier, name)
    update_guardrail(blocked_input_messaging, blocked_outputs_messaging, guardrail_identifier, name, params::Dict{String,<:Any})

Updates a guardrail with the values you specify.   Specify a name and optional description.
  Specify messages for when the guardrail successfully blocks a prompt or a model response
in the blockedInputMessaging and blockedOutputsMessaging fields.   Specify topics for the
guardrail to deny in the topicPolicyConfig object. Each GuardrailTopicConfig object in the
topicsConfig list pertains to one topic.   Give a name and description so that the
guardrail can properly identify the topic.   Specify DENY in the type field.   (Optional)
Provide up to five prompts that you would categorize as belonging to the topic in the
examples list.     Specify filter strengths for the harmful categories defined in Amazon
Bedrock in the contentPolicyConfig object. Each GuardrailContentFilterConfig object in the
filtersConfig list pertains to a harmful category. For more information, see Content
filters. For more information about the fields in a content filter, see
GuardrailContentFilterConfig.   Specify the category in the type field.   Specify the
strength of the filter for prompts in the inputStrength field and for model responses in
the strength field of the GuardrailContentFilterConfig.     (Optional) For security,
include the ARN of a KMS key in the kmsKeyId field.

# Arguments
- `blocked_input_messaging`: The message to return when the guardrail blocks a prompt.
- `blocked_outputs_messaging`: The message to return when the guardrail blocks a model
  response.
- `guardrail_identifier`: The unique identifier of the guardrail. This can be an ID or the
  ARN.
- `name`: A name for the guardrail.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"contentPolicyConfig"`: The content policy to configure for the guardrail.
- `"contextualGroundingPolicyConfig"`: The contextual grounding policy configuration used
  to update a guardrail.
- `"description"`: A description of the guardrail.
- `"kmsKeyId"`: The ARN of the KMS key with which to encrypt the guardrail.
- `"sensitiveInformationPolicyConfig"`: The sensitive information policy to configure for
  the guardrail.
- `"topicPolicyConfig"`: The topic policy to configure for the guardrail.
- `"wordPolicyConfig"`: The word policy to configure for the guardrail.
"""
function update_guardrail end

function update_guardrail(
    blockedInputMessaging,
    blockedOutputsMessaging,
    guardrailIdentifier,
    name;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock(
        "PUT",
        "/guardrails/$(guardrailIdentifier)",
        Dict{String,Any}(
            "blockedInputMessaging" => blockedInputMessaging,
            "blockedOutputsMessaging" => blockedOutputsMessaging,
            "name" => name,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function update_guardrail(
    blockedInputMessaging,
    blockedOutputsMessaging,
    guardrailIdentifier,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock(
        "PUT",
        "/guardrails/$(guardrailIdentifier)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "blockedInputMessaging" => blockedInputMessaging,
                    "blockedOutputsMessaging" => blockedOutputsMessaging,
                    "name" => name,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_provisioned_model_throughput(provisioned_model_id)
    update_provisioned_model_throughput(provisioned_model_id, params::Dict{String,<:Any})

Updates the name or associated model for a Provisioned Throughput. For more information,
see Provisioned Throughput in the Amazon Bedrock User Guide.

# Arguments
- `provisioned_model_id`: The Amazon Resource Name (ARN) or name of the Provisioned
  Throughput to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"desiredModelId"`: The Amazon Resource Name (ARN) of the new model to associate with
  this Provisioned Throughput. You can't specify this field if this Provisioned Throughput is
  associated with a base model. If this Provisioned Throughput is associated with a custom
  model, you can specify one of the following options:   The base model from which the custom
  model was customized.   Another custom model that was customized from the same base model
  as the custom model.
- `"desiredProvisionedModelName"`: The new name for this Provisioned Throughput.
"""
function update_provisioned_model_throughput end

function update_provisioned_model_throughput(
    provisionedModelId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock(
        "PATCH",
        "/provisioned-model-throughput/$(provisionedModelId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function update_provisioned_model_throughput(
    provisionedModelId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock(
        "PATCH",
        "/provisioned-model-throughput/$(provisionedModelId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

using Dates
using HTTP
using IniFile
using JSON
using Mocking

using ..AWSExceptions

export AWSCredentials,
    aws_account_number,
    aws_get_profile_settings,
    aws_get_region,
    aws_user_arn,
    check_credentials,
    credentials_from_webtoken,
    dot_aws_config,
    dot_aws_config_file,
    dot_aws_credentials,
    dot_aws_credentials_file,
    ec2_instance_credentials,
    ecs_instance_credentials,
    env_var_credentials,
    external_process_credentials,
    localhost_is_ec2,
    localhost_is_lambda,
    localhost_maybe_ec2,
    sso_credentials

function localhost_maybe_ec2()
    return localhost_is_ec2() || isfile("/sys/devices/virtual/dmi/id/product_uuid")
end
localhost_is_lambda() = haskey(ENV, "LAMBDA_TASK_ROOT")

"""
    AWSCredentials

When you interact with AWS, you specify your [AWS Security Credentials](http://docs.aws.amazon.com/general/latest/gr/aws-security-credentials.html)
to verify who you are and whether you have permission to access the resources that you are requesting.
AWS uses the security credentials to authenticate and authorize your requests.
The fields `access_key_id` and `secret_key` hold the access keys used to authenticate API requests
(see [Creating, Modifying, and Viewing Access Keys](http://docs.aws.amazon.com/IAM/latest/UserGuide/id_credentials_access-keys.html#Using_CreateAccessKey)).
[Temporary Security Credentials](http://docs.aws.amazon.com/IAM/latest/UserGuide/id_credentials_temp.html) require the extra session `token` field.
The `user_arn` and `account_number` fields are used to cache the result of the [`aws_user_arn`](@ref) and [`aws_account_number`](@ref) functions.

AWS.jl searches for credentials in multiple locations and stops once any credentials are found.
The credential preference order mostly [mirrors the AWS CLI](https://docs.aws.amazon.com/cli/latest/userguide/cli-chap-authentication.html#cli-chap-authentication-precedence)
and is as follows:

1. Credentials or a profile passed directly to the `AWSCredentials`
2. [Environment variables](https://docs.aws.amazon.com/cli/latest/userguide/cli-configure-envvars.html)
3. [Web Identity](https://docs.aws.amazon.com/cli/latest/userguide/cli-configure-role.html#cli-configure-role-oidc)
4. [AWS Single Sign-On (SSO)](http://docs.aws.amazon.com/cli/latest/userguide/cli-configure-sso.html) provided via the AWS configuration file
5. [AWS credentials file](https://docs.aws.amazon.com/cli/latest/userguide/cli-configure-files.html) (e.g. "~/.aws/credentials")
6. [External process](https://docs.aws.amazon.com/cli/latest/userguide/cli-configure-sourcing-external.html) set via `credential_process` in the AWS configuration file
7. [AWS configuration file](http://docs.aws.amazon.com/cli/latest/userguide/cli-config-files.html) set via `aws_access_key_id` in the AWS configuration file
8. [Amazon ECS container credentials](https://docs.aws.amazon.com/AmazonECS/latest/developerguide/task-iam-roles.html)
9. [Amazon EC2 instance metadata](https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/iam-roles-for-amazon-ec2.html)

Once the credentials are found, the method by which they were accessed is stored in the `renew` field
and the `DateTime` at which they will expire is stored in the `expiry` field.
This allows the credentials to be refreshed as needed using [`check_credentials`](@ref).
If `renew` is set to `nothing`, no attempt will be made to refresh the credentials.
Any renewal function is expected to return `nothing` on failure or a populated `AWSCredentials` object on success.
The `renew` field of the returned `AWSCredentials` will be discarded and does not need to be set.

To specify the profile to use from `~/.aws/credentials`, do, for example, `AWSCredentials(profile="profile-name")`.
"""
mutable struct AWSCredentials
    access_key_id::String
    secret_key::String
    token::String
    user_arn::String
    account_number::String
    expiry::DateTime
    renew::Union{Function,Nothing}  # Function which can be used to refresh credentials

    function AWSCredentials(
        access_key_id,
        secret_key,
        token="",
        user_arn="",
        account_number="";
        expiry=typemax(DateTime),
        renew=nothing,
    )
        return new(
            access_key_id, secret_key, token, user_arn, account_number, expiry, renew
        )
    end
end

# Needs to be included after struct AWSCredentials for compilation
include(joinpath("utilities", "credentials.jl"))

"""
    AWSCredentials(; profile=nothing) -> Union{AWSCredentials, Nothing}

Create an AWSCredentials object, given a provided profile (if not provided "default" will be
used).

Checks credential locations in the order:
    1. Environment Variables
    2. ~/.aws/credentials
    3. ~/.aws/config
    4. EC2 or ECS metadata

# Keywords
- `profile::AbstractString`: Specific profile used to search for AWSCredentials

# Throws
- `error("Can't find AWS Credentials")`: AWSCredentials could not be found
"""
function AWSCredentials(; profile=nothing, throw_cred_error=true)
    creds = nothing
    credential_function = () -> nothing
    explicit_profile = !isnothing(profile)
    profile = @something profile _aws_get_profile()

    # Define the credential preference order:
    # https://docs.aws.amazon.com/cli/latest/userguide/cli-chap-authentication.html#cli-chap-authentication-precedence
    #
    # Note that the AWS CLI documentation states that EC2 instance credentials are preferred
    # over ECS container credentials. However, in practice when `AWS_CONTAINER_*`
    # environmental variables are set the ECS container credentials are prefered instead.
    functions = [
        () -> env_var_credentials(explicit_profile),
        credentials_from_webtoken,
        () -> sso_credentials(profile),
        () -> dot_aws_credentials(profile),
        () -> dot_aws_config(profile),
        ecs_instance_credentials,
        () -> ec2_instance_credentials(profile),
    ]

    # Loop through our search locations until we get credentials back
    for f in functions
        credential_function = f
        creds = credential_function()
        creds === nothing || break
    end

    # If credentials are nothing, default to throwing an error, otherwise return nothing
    if creds === nothing
        if throw_cred_error
            throw(NoCredentials("Can't find AWS credentials!"))
        else
            return nothing
        end
    end

    creds.renew = credential_function

    return creds
end

function Base.show(io::IO, c::AWSCredentials)
    return print(
        io,
        c.user_arn,
        isempty(c.user_arn) ? "" : " ",
        "(",
        c.account_number,
        isempty(c.account_number) ? "" : ", ",
        c.access_key_id,
        isempty(c.secret_key) ? "" : ", $(c.secret_key[1:3])...",
        isempty(c.token) ? "" : ", $(c.token[1:3])...",
        ", ",
        c.expiry,
        ")",
    )
end

function Base.copyto!(dest::AWSCredentials, src::AWSCredentials)
    for f in fieldnames(typeof(dest))
        setfield!(dest, f, getfield(src, f))
    end
end

"""
    check_credentials(
        aws_creds::AWSCredentials, force_refresh::Bool=false
    ) -> AWSCredentials

Checks current AWSCredentials, refreshing them if they are soon to expire. If
`force_refresh` is `true` the credentials will be renewed immediately

# Arguments
- `aws_creds::AWSCredentials`: AWSCredentials to be checked / refreshed

# Keywords
- `force_refresh::Bool=false`: `true` to refresh the credentials

# Throws
- `error("Can't find AWS credentials!")`: If no credentials can be found
"""
function check_credentials(aws_creds::AWSCredentials; force_refresh::Bool=false)
    if force_refresh || _will_expire(aws_creds)
        credential_method = aws_creds.renew

        if credential_method !== nothing
            new_aws_creds = credential_method()

            new_aws_creds === nothing && throw(NoCredentials("Can't find AWS credentials!"))
            copyto!(aws_creds, new_aws_creds)

            # Ensure credential_method is not overwritten by the new credentials
            aws_creds.renew = credential_method
        end
    end

    return aws_creds
end
check_credentials(aws_creds::Nothing) = aws_creds

"""
    ec2_instance_credentials(profile::AbstractString) -> AWSCredentials

Parse the EC2 metadata to retrieve AWSCredentials.
"""
function ec2_instance_credentials(profile::AbstractString)
    path = dot_aws_config_file()
    ini = Inifile()
    if isfile(path)
        ini = read(ini, path)
    end

    # Any profile except default must specify the credential_source as Ec2InstanceMetadata.
    if profile != "default"
        source = _get_profile_value(ini, profile, "credential_source")
        source == "Ec2InstanceMetadata" || return nothing
    end

    info = IMDS.get("/latest/meta-data/iam/info")
    info === nothing && return nothing
    info = JSON.parse(info)

    # Get credentials for the role associated to the instance via instance profile.
    name = IMDS.get("/latest/meta-data/iam/security-credentials/")
    creds = IMDS.get("/latest/meta-data/iam/security-credentials/$name")
    parsed = JSON.parse(creds)
    instance_profile_creds = AWSCredentials(
        parsed["AccessKeyId"],
        parsed["SecretAccessKey"],
        parsed["Token"],
        info["InstanceProfileArn"];
        expiry=DateTime(rstrip(parsed["Expiration"], 'Z')),
        renew=() -> ec2_instance_credentials(profile),
    )

    # Look for a role to assume and return instance profile credentials if there is none.
    role_arn = _get_profile_value(ini, profile, "role_arn")
    role_arn === nothing && return instance_profile_creds

    # Assume the role.
    role_session = get(ENV, "AWS_ROLE_SESSION_NAME") do
        _role_session_name(
            "AWS.jl-role-",
            basename(role_arn),
            "-" * Dates.format(@mock(now(UTC)), dateformat"yyyymmdd\THHMMSS\Z"),
        )
    end
    params = Dict{String,Any}("RoleArn" => role_arn, "RoleSessionName" => role_session)
    duration = _get_profile_value(ini, profile, "duration_seconds")
    if duration !== nothing
        params["DurationSeconds"] = parse(Int, duration)
    end
    response = @mock AWSServices.sts(
        "AssumeRole",
        params;
        aws_config=AWSConfig(; creds=instance_profile_creds),
        feature_set=FeatureSet(; use_response_type=true),
    )
    dict = parse(response)
    role_creds = dict["AssumeRoleResult"]["Credentials"]
    role_user = dict["AssumeRoleResult"]["AssumedRoleUser"]
    return AWSCredentials(
        role_creds["AccessKeyId"],
        role_creds["SecretAccessKey"],
        role_creds["SessionToken"],
        role_user["Arn"];
        expiry=DateTime(rstrip(role_creds["Expiration"], 'Z')),
        renew=() -> ec2_instance_credentials(profile),
    )
end

"""
    ecs_instance_credentials() -> Union{AWSCredentials, Nothing}

Retrieve credentials from the ECS credential endpoint. If the ECS credential endpoint is
unavailable then `nothing` will be returned.

More information can be found at:
- https://docs.aws.amazon.com/AmazonECS/latest/developerguide/task-iam-roles.html
- https://docs.aws.amazon.com/sdkref/latest/guide/feature-container-credentials.html

# Returns
- `AWSCredentials`: AWSCredentials from `ECS` credentials URI, `nothing` if the Env Var is
    not set (not running on an ECS container instance)

# Throws
- `StatusError`: If the response status is >= 300
- `ParsingError`: Invalid HTTP request target
"""
function ecs_instance_credentials()
    # The Amazon ECS agent will automatically populate the environmental variable
    # `AWS_CONTAINER_CREDENTIALS_RELATIVE_URI` when running inside of an ECS task. We're
    # interpreting this to mean than ECS credential provider should only be used if any of
    # the `AWS_CONTAINER_CREDENTIALS_*_URI` variables are set.
    # – https://docs.aws.amazon.com/AmazonECS/latest/developerguide/task-iam-roles.html
    #
    # > Note: This setting (`AWS_CONTAINER_CREDENTIALS_FULL_URI`) is an alternative to
    # > `AWS_CONTAINER_CREDENTIALS_RELATIVE_URI` and will only be used if
    # > `AWS_CONTAINER_CREDENTIALS_RELATIVE_URI` is not set.
    # – https://docs.aws.amazon.com/sdkref/latest/guide/feature-container-credentials.html
    if haskey(ENV, "AWS_CONTAINER_CREDENTIALS_RELATIVE_URI")
        endpoint = "http://169.254.170.2" * ENV["AWS_CONTAINER_CREDENTIALS_RELATIVE_URI"]
    elseif haskey(ENV, "AWS_CONTAINER_CREDENTIALS_FULL_URI")
        endpoint = ENV["AWS_CONTAINER_CREDENTIALS_FULL_URI"]
    else
        return nothing
    end

    headers = Pair{String,String}[]
    if haskey(ENV, "AWS_CONTAINER_AUTHORIZATION_TOKEN")
        push!(headers, "Authorization" => ENV["AWS_CONTAINER_AUTHORIZATION_TOKEN"])
    end

    response = try
        @mock HTTP.request("GET", endpoint, headers; retry=false, connect_timeout=5)
    catch e
        e isa HTTP.Exceptions.ConnectError && return nothing
        rethrow()
    end
    new_creds = String(response.body)
    new_creds = JSON.parse(new_creds)

    expiry = DateTime(rstrip(new_creds["Expiration"], 'Z'))

    return AWSCredentials(
        new_creds["AccessKeyId"],
        new_creds["SecretAccessKey"],
        new_creds["Token"],
        # The RoleArn field may not be present for Amazon SageMaker jobs
        get(new_creds, "RoleArn", "");
        expiry=expiry,
        renew=ecs_instance_credentials,
    )
end

"""
    env_var_credentials(explicit_profile::Bool=false) -> Union{AWSCredentials, Nothing}

Use AWS environmental variables (e.g. AWS_ACCESS_KEY_ID, AWS_SECRET_ACCESS_KEY, etc.)
to create AWSCredentials.
"""
function env_var_credentials(explicit_profile::Bool=false)
    # Skip using environmental variables when a profile has been explicitly set
    explicit_profile && return nothing

    if haskey(ENV, "AWS_ACCESS_KEY_ID") && haskey(ENV, "AWS_SECRET_ACCESS_KEY")
        return AWSCredentials(
            ENV["AWS_ACCESS_KEY_ID"],
            ENV["AWS_SECRET_ACCESS_KEY"],
            get(ENV, "AWS_SESSION_TOKEN", ""),
            get(ENV, "AWS_USER_ARN", "");
            renew=env_var_credentials,
        )
    end

    return nothing
end

"""
    dot_aws_credentials(profile=nothing) -> Union{AWSCredentials, Nothing}

Retrieve `AWSCredentials` from the AWS CLI credentials file. The credential file defaults to
"~/.aws/credentials" but can be specified using the env variable
`AWS_SHARED_CREDENTIALS_FILE`.

# Arguments
- `profile`: Specific profile used to get AWSCredentials, default is `nothing`
"""
function dot_aws_credentials(profile=nothing)
    credential_file = @mock dot_aws_credentials_file()

    if isfile(credential_file)
        ini = read(Inifile(), credential_file)
        p = @something profile _aws_get_profile()
        access_key, secret_key, token = _aws_get_credential_details(p, ini)

        if access_key !== nothing
            return AWSCredentials(access_key, secret_key, token)
        end
    end

    return nothing
end

function dot_aws_credentials_file()
    get(ENV, "AWS_SHARED_CREDENTIALS_FILE") do
        joinpath(homedir(), ".aws", "credentials")
    end
end

"""
    sso_credentials(profile=nothing) -> Union{AWSCredentials, Nothing}

Retrieve credentials via AWS single sign-on (SSO) settings defined in the `profile` within
the AWS configuration file. If no SSO settings are found for the `profile` `nothing` is
returned.

# Arguments
- `profile`: Specific profile used to get `AWSCredentials`, default is `nothing`
"""
function sso_credentials(profile=nothing)
    config_file = @mock dot_aws_config_file()

    if isfile(config_file)
        ini = read(Inifile(), config_file)
        p = @something profile _aws_get_profile()

        # get all the fields for that profile
        settings = _aws_profile_config(ini, p)
        isempty(settings) && return nothing

        # IAM identity center authentication
        # https://docs.aws.amazon.com/cli/latest/userguide/cli-configure-sso.html#cli-configure-sso-manual
        sso_session = get(settings, "sso_session", nothing)

        # Legacy IAM identity center authentication
        # https://docs.aws.amazon.com/cli/latest/userguide/sso-configure-profile-legacy.html#sso-configure-profile-manual
        sso_start_url = get(settings, "sso_start_url", nothing)

        if !isnothing(sso_start_url) || !isnothing(sso_session)
            access_key, secret_key, token, expiry = _aws_get_sso_credential_details(p, ini)
            return AWSCredentials(access_key, secret_key, token; expiry=expiry)
        end
    end

    return nothing
end

"""
    dot_aws_config(profile=nothing) -> Union{AWSCredentials, Nothing}

Retrieve `AWSCredentials` from the AWS CLI configuration file. The configuration file
defaults to "~/.aws/config" but can be specified using the env variable  `AWS_CONFIG_FILE`.
When no credentials are found for the given `profile` then the associated `source_profile`
will be used to recursively look up credentials of source profiles. If still no credentials
can be found then `nothing` will be returned.

# Arguments
- `profile`: Specific profile used to get AWSCredentials, default is `nothing`
"""
function dot_aws_config(profile=nothing)
    config_file = @mock dot_aws_config_file()

    if isfile(config_file)
        ini = read(Inifile(), config_file)
        p = @something profile _aws_get_profile()

        # get all the fields for that profile
        settings = _aws_profile_config(ini, p)
        isempty(settings) && return nothing

        credential_process = get(settings, "credential_process", nothing)
        access_key = get(settings, "aws_access_key_id", nothing)
        sso_start_url = get(settings, "sso_start_url", nothing)

        if !isnothing(credential_process)
            cmd = Cmd(Base.shell_split(credential_process))
            return external_process_credentials(cmd)
        elseif !isnothing(access_key)
            access_key, secret_key, token = _aws_get_credential_details(p, ini)
            return AWSCredentials(access_key, secret_key, token)
        elseif !isnothing(sso_start_url)
            # Deprecation should only appear if `dot_aws_config` is called directly
            Base.depwarn(
                "SSO support in `dot_aws_config` is deprecated, use `sso_credentials` instead.",
                :dot_aws_config,
            )
            access_key, secret_key, token, expiry = _aws_get_sso_credential_details(p, ini)
            return AWSCredentials(access_key, secret_key, token; expiry=expiry)
        else
            return _aws_get_role(p, ini)
        end
    end

    return nothing
end

function dot_aws_config_file()
    get(ENV, "AWS_CONFIG_FILE") do
        joinpath(homedir(), ".aws", "config")
    end
end

"""
    localhost_is_ec2() -> Bool

Determine if the machine executing this code is running on an EC2 instance.
"""
function localhost_is_ec2()
    # Checking to see if you are running on an EC2 instance is a complicated problem due to
    # a large amount of caveats. Below is a list of methods to implement to work through
    # most of these problems:
    #
    # 1. Check the `hostname -d`; this will not work if using non-Amazon DNS
    # 2. Check metadata with EC2 internal domain name `curl -s
    # http://instance-data.ec2.internal`; this will not work with a VPC (legacy EC2 only)
    # 3. Check `sudo dmidecode -s bios-version`; this requires `dmidecode` on the instance
    # 4. Check `/sys/devices/virtual/dmi/id/bios_version`; this may not work depending on
    # the instance, Amazon does not document this file however so it's quite unreliable
    # 5. Check `http://169.254.169.254`; This is a link-local address for metadata,
    # apparently other cloud providers make this metadata URL available now as well so it's
    # not guaranteed that you're on an EC2 instance
    #    Or check a specific endpoint of the instance metadata such as:
    #         ims_local_hostname = String(HTTP.get("http://169.254.169.254/latest/meta-data/local-hostname").body)
    #    but with a fast timeout and cache the result.
    #    See https://docs.aws.amazon.com/en_us/AWSEC2/latest/UserGuide/instancedata-data-retrieval.html
    # 6. When checking the UUID, check for little-endian representation,
    # https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/identify_ec2_instances.html

    # This is not guarenteed to work on Windows as RNG can make the UUID begin with EC2 on a
    # non-EC2 instance
    if @mock Sys.iswindows()
        command = `wmic path win32_computersystemproduct get uuid`
        result = @mock read(command, String)
        instance_uuid = strip(split(result, "\n")[2])

        return instance_uuid[1:3] == "EC2"
    end

    # Note: try catch required for open calls on files of mode 400 (-r--------)
    # Note: This will not work on new m5 and c5 instances because they use a new hypervisor
    # stack and the kernel does not create files in sysfs
    hypervisor_uuid = "/sys/hypervisor/uuid"
    if _can_read_file(hypervisor_uuid)
        return true
    end

    # Note: Works if you are running as root
    product_uuid = "/sys/devices/virtual/dmi/id/product_uuid"
    if _can_read_file(product_uuid) && _begins_with_ec2(product_uuid)
        return true
    end

    # Check additional values under /sys/devices/virtual/dmi/id for the key "EC2"
    # These work for the new m5 and c5 (nitro hypervisor) when root isn't available
    # filenames = ["bios_vendor", "board_vendor", "chassis_asset_tag", "chassis_version", "sys_vendor", "uevent", "modalias"]
    # all return "Amazon EC2" except the last two
    sys_vendor = "/sys/devices/virtual/dmi/id/sys_vendor"
    if _can_read_file(sys_vendor) && _ends_with_ec2(sys_vendor)
        return true
    end

    return false
end

"""
    credentials_from_webtoken()

Assume role via web identity.
https://docs.aws.amazon.com/cli/latest/userguide/cli-configure-role.html#cli-configure-role-oidc
"""
function credentials_from_webtoken()
    token_role_arn = "AWS_ROLE_ARN"
    token_web_identity_file = "AWS_WEB_IDENTITY_TOKEN_FILE"
    token_role_session = "AWS_ROLE_SESSION_NAME"  # Optional session name

    if !(haskey(ENV, token_role_arn) && haskey(ENV, token_web_identity_file))
        return nothing
    end

    role_arn = ENV[token_role_arn]
    web_identity = read(ENV["AWS_WEB_IDENTITY_TOKEN_FILE"], String)
    role_session = get(ENV, token_role_session) do
        _role_session_name(
            "AWS.jl-role-",
            basename(role_arn),
            "-" * Dates.format(@mock(now(UTC)), dateformat"yyyymmdd\THHMMSS\Z"),
        )
    end

    response = @mock AWSServices.sts(
        "AssumeRoleWithWebIdentity",
        Dict(
            "RoleArn" => role_arn,
            "RoleSessionName" => role_session,  # Required by AssumeRoleWithWebIdentity
            "WebIdentityToken" => web_identity,
        );
        aws_config=AWSConfig(; creds=nothing),
        feature_set=FeatureSet(; use_response_type=true),
    )
    dict = parse(response)

    role_creds = dict["AssumeRoleWithWebIdentityResult"]["Credentials"]
    assumed_role_user = dict["AssumeRoleWithWebIdentityResult"]["AssumedRoleUser"]

    return AWSCredentials(
        role_creds["AccessKeyId"],
        role_creds["SecretAccessKey"],
        role_creds["SessionToken"],
        assumed_role_user["Arn"];
        expiry=DateTime(rstrip(role_creds["Expiration"], 'Z')),
        renew=credentials_from_webtoken,
    )
end

"""
    external_process_credentials(cmd::Base.AbstractCmd) -> AWSCredentials

Sources AWS credentials from an external process as defined in the AWS CLI config file.
See https://docs.aws.amazon.com/cli/latest/userguide/cli-configure-sourcing-external.html
for details.
"""
function external_process_credentials(cmd::Base.AbstractCmd)
    nt = open(cmd, "r") do io
        _read_credential_process(io)
    end
    return AWSCredentials(
        nt.access_key_id,
        nt.secret_access_key,
        @something(nt.session_token, "");
        expiry=@something(nt.expiration, typemax(DateTime)),
        renew=() -> external_process_credentials(cmd),
    )
end

"""
    aws_get_region(; profile=nothing, config=nothing, default="$DEFAULT_REGION")

Determine the current AWS region that should be used for AWS requests. The order of
precedence mirrors what is [used by the AWS CLI](https://docs.aws.amazon.com/cli/latest/userguide/cli-configure-quickstart.html#cli-configure-quickstart-precedence):

1. Environment variable: `AWS_REGION`.
2. Environment variable: `AWS_DEFAULT_REGION`
3. AWS configuration file: `region` as specified by the `profile` in the configuration
   file, typically "~/.aws/config".
4. Instance metadata service on an Amazon EC2 instance that has an IAM role configured.
5. Default region: use the specified `default`, typically "$DEFAULT_REGION".

# Keywords
- `profile`: Name of the AWS configuration profile, if any. Defaults to `nothing` which
  falls back to using `AWS._aws_get_profile()`
- `config`: AWS configuration loaded as an `Inifile` or a path to a configuration file.
  Defaults to `nothing` which falls back to using `dot_aws_config_file()`
- `default`: The region to return if no high-precedence was found. Can be useful to set
  this to `nothing` if you want to know that no current AWS region was defined.
"""
function aws_get_region(; profile=nothing, config=nothing, default=DEFAULT_REGION)
    @something(
        get(ENV, "AWS_REGION", nothing),
        get(ENV, "AWS_DEFAULT_REGION", nothing),
        get(_aws_profile_config(config, profile), "region", nothing),
        @mock(IMDS.region()),
        Some(default),
    )
end

@deprecate aws_get_region(profile::AbstractString, ini::Inifile) aws_get_region(;
    profile=profile, config=ini
)

"""
    aws_get_profile_settings(profile::AbstractString, ini::Inifile) -> Dict

Return a `Dict` containing all of the settings for the specified profile.

# Arguments
- `profile::AbstractString`: Profile to retrieve settings from
- `ini::Inifile`: Configuration file read the settings from
"""
function aws_get_profile_settings(profile::AbstractString, ini::Inifile)
    section = get(sections(ini), "profile $profile", nothing)

    # Internals of IniFile.jl always return strings for keys/values even though the returned
    # Dict uses more generic type parameters
    return section !== nothing ? Dict{String,String}(section) : nothing
end

@deprecate(
    aws_get_role_details(profile::AbstractString, ini::Inifile),
    get.(
        Ref(aws_get_profile_settings(profile, ini)), ("source_profile", "role_arn"), nothing
    ),
)

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: acm_pca
using AWS.Compat
using AWS.UUIDs

"""
    create_certificate_authority(certificate_authority_configuration, certificate_authority_type)
    create_certificate_authority(certificate_authority_configuration, certificate_authority_type, params::Dict{String,<:Any})

Creates a root or subordinate private certificate authority (CA). You must specify the CA
configuration, an optional configuration for Online Certificate Status Protocol (OCSP)
and/or a certificate revocation list (CRL), the CA type, and an optional idempotency token
to avoid accidental creation of multiple CAs. The CA configuration specifies the name of
the algorithm and key size to be used to create the CA private key, the type of signing
algorithm that the CA uses, and X.500 subject information. The OCSP configuration can
optionally specify a custom URL for the OCSP responder. The CRL configuration specifies the
CRL expiration period in days (the validity period of the CRL), the Amazon S3 bucket that
will contain the CRL, and a CNAME alias for the S3 bucket that is included in certificates
issued by the CA. If successful, this action returns the Amazon Resource Name (ARN) of the
CA.  Both Amazon Web Services Private CA and the IAM principal must have permission to
write to the S3 bucket that you specify. If the IAM principal making the call does not have
permission to write to the bucket, then an exception is thrown. For more information, see
Access policies for CRLs in Amazon S3.  Amazon Web Services Private CA assets that are
stored in Amazon S3 can be protected with encryption. For more information, see Encrypting
Your CRLs.

# Arguments
- `certificate_authority_configuration`: Name and bit size of the private key algorithm,
  the name of the signing algorithm, and X.500 certificate subject information.
- `certificate_authority_type`: The type of the certificate authority.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"IdempotencyToken"`: Custom string that can be used to distinguish between calls to the
  CreateCertificateAuthority action. Idempotency tokens for CreateCertificateAuthority time
  out after five minutes. Therefore, if you call CreateCertificateAuthority multiple times
  with the same idempotency token within five minutes, Amazon Web Services Private CA
  recognizes that you are requesting only certificate authority and will issue only one. If
  you change the idempotency token for each call, Amazon Web Services Private CA recognizes
  that you are requesting multiple certificate authorities.
- `"KeyStorageSecurityStandard"`: Specifies a cryptographic key management compliance
  standard used for handling CA keys. Default: FIPS_140_2_LEVEL_3_OR_HIGHER  Some Amazon Web
  Services Regions do not support the default. When creating a CA in these Regions, you must
  provide FIPS_140_2_LEVEL_2_OR_HIGHER as the argument for KeyStorageSecurityStandard.
  Failure to do this results in an InvalidArgsException with the message, \"A certificate
  authority cannot be created in this region with the specified security standard.\" For
  information about security standard support in various Regions, see Storage and security
  compliance of Amazon Web Services Private CA private keys.
- `"RevocationConfiguration"`: Contains information to enable Online Certificate Status
  Protocol (OCSP) support, to enable a certificate revocation list (CRL), to enable both, or
  to enable neither. The default is for both certificate validation mechanisms to be
  disabled.   The following requirements apply to revocation configurations.   A
  configuration disabling CRLs or OCSP must contain only the Enabled=False parameter, and
  will fail if other parameters such as CustomCname or ExpirationInDays are included.   In a
  CRL configuration, the S3BucketName parameter must conform to Amazon S3 bucket naming
  rules.   A configuration containing a custom Canonical Name (CNAME) parameter for CRLs or
  OCSP must conform to RFC2396 restrictions on the use of special characters in a CNAME.
  In a CRL or OCSP configuration, the value of a CNAME parameter must not include a protocol
  prefix such as \"http://\" or \"https://\".     For more information, see the
  OcspConfiguration and CrlConfiguration types.
- `"Tags"`: Key-value pairs that will be attached to the new private CA. You can associate
  up to 50 tags with a private CA. For information using tags with IAM to manage permissions,
  see Controlling Access Using IAM Tags.
- `"UsageMode"`: Specifies whether the CA issues general-purpose certificates that
  typically require a revocation mechanism, or short-lived certificates that may optionally
  omit revocation because they expire quickly. Short-lived certificate validity is limited to
  seven days. The default value is GENERAL_PURPOSE.
"""
function create_certificate_authority(
    CertificateAuthorityConfiguration,
    CertificateAuthorityType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return acm_pca(
        "CreateCertificateAuthority",
        Dict{String,Any}(
            "CertificateAuthorityConfiguration" => CertificateAuthorityConfiguration,
            "CertificateAuthorityType" => CertificateAuthorityType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_certificate_authority(
    CertificateAuthorityConfiguration,
    CertificateAuthorityType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return acm_pca(
        "CreateCertificateAuthority",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CertificateAuthorityConfiguration" =>
                        CertificateAuthorityConfiguration,
                    "CertificateAuthorityType" => CertificateAuthorityType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_certificate_authority_audit_report(audit_report_response_format, certificate_authority_arn, s3_bucket_name)
    create_certificate_authority_audit_report(audit_report_response_format, certificate_authority_arn, s3_bucket_name, params::Dict{String,<:Any})

Creates an audit report that lists every time that your CA private key is used. The report
is saved in the Amazon S3 bucket that you specify on input. The IssueCertificate and
RevokeCertificate actions use the private key.   Both Amazon Web Services Private CA and
the IAM principal must have permission to write to the S3 bucket that you specify. If the
IAM principal making the call does not have permission to write to the bucket, then an
exception is thrown. For more information, see Access policies for CRLs in Amazon S3.
Amazon Web Services Private CA assets that are stored in Amazon S3 can be protected with
encryption. For more information, see Encrypting Your Audit Reports.  You can generate a
maximum of one report every 30 minutes.

# Arguments
- `audit_report_response_format`: The format in which to create the report. This can be
  either JSON or CSV.
- `certificate_authority_arn`: The Amazon Resource Name (ARN) of the CA to be audited. This
  is of the form:
  arn:aws:acm-pca:region:account:certificate-authority/12345678-1234-1234-1234-123456789012 .
- `s3_bucket_name`: The name of the S3 bucket that will contain the audit report.

"""
function create_certificate_authority_audit_report(
    AuditReportResponseFormat,
    CertificateAuthorityArn,
    S3BucketName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return acm_pca(
        "CreateCertificateAuthorityAuditReport",
        Dict{String,Any}(
            "AuditReportResponseFormat" => AuditReportResponseFormat,
            "CertificateAuthorityArn" => CertificateAuthorityArn,
            "S3BucketName" => S3BucketName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_certificate_authority_audit_report(
    AuditReportResponseFormat,
    CertificateAuthorityArn,
    S3BucketName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return acm_pca(
        "CreateCertificateAuthorityAuditReport",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AuditReportResponseFormat" => AuditReportResponseFormat,
                    "CertificateAuthorityArn" => CertificateAuthorityArn,
                    "S3BucketName" => S3BucketName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_permission(actions, certificate_authority_arn, principal)
    create_permission(actions, certificate_authority_arn, principal, params::Dict{String,<:Any})

Grants one or more permissions on a private CA to the Certificate Manager (ACM) service
principal (acm.amazonaws.com). These permissions allow ACM to issue and renew ACM
certificates that reside in the same Amazon Web Services account as the CA. You can list
current permissions with the ListPermissions action and revoke them with the
DeletePermission action.  About Permissions    If the private CA and the certificates it
issues reside in the same account, you can use CreatePermission to grant permissions for
ACM to carry out automatic certificate renewals.   For automatic certificate renewal to
succeed, the ACM service principal needs permissions to create, retrieve, and list
certificates.   If the private CA and the ACM certificates reside in different accounts,
then permissions cannot be used to enable automatic renewals. Instead, the ACM certificate
owner must set up a resource-based policy to enable cross-account issuance and renewals.
For more information, see Using a Resource Based Policy with Amazon Web Services Private
CA.

# Arguments
- `actions`: The actions that the specified Amazon Web Services service principal can use.
  These include IssueCertificate, GetCertificate, and ListPermissions.
- `certificate_authority_arn`: The Amazon Resource Name (ARN) of the CA that grants the
  permissions. You can find the ARN by calling the ListCertificateAuthorities action. This
  must have the following form:
  arn:aws:acm-pca:region:account:certificate-authority/12345678-1234-1234-1234-123456789012 .
- `principal`: The Amazon Web Services service or identity that receives the permission. At
  this time, the only valid principal is acm.amazonaws.com.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"SourceAccount"`: The ID of the calling account.
"""
function create_permission(
    Actions,
    CertificateAuthorityArn,
    Principal;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return acm_pca(
        "CreatePermission",
        Dict{String,Any}(
            "Actions" => Actions,
            "CertificateAuthorityArn" => CertificateAuthorityArn,
            "Principal" => Principal,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_permission(
    Actions,
    CertificateAuthorityArn,
    Principal,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return acm_pca(
        "CreatePermission",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Actions" => Actions,
                    "CertificateAuthorityArn" => CertificateAuthorityArn,
                    "Principal" => Principal,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_certificate_authority(certificate_authority_arn)
    delete_certificate_authority(certificate_authority_arn, params::Dict{String,<:Any})

Deletes a private certificate authority (CA). You must provide the Amazon Resource Name
(ARN) of the private CA that you want to delete. You can find the ARN by calling the
ListCertificateAuthorities action.   Deleting a CA will invalidate other CAs and
certificates below it in your CA hierarchy.  Before you can delete a CA that you have
created and activated, you must disable it. To do this, call the UpdateCertificateAuthority
action and set the CertificateAuthorityStatus parameter to DISABLED.  Additionally, you can
delete a CA if you are waiting for it to be created (that is, the status of the CA is
CREATING). You can also delete it if the CA has been created but you haven't yet imported
the signed certificate into Amazon Web Services Private CA (that is, the status of the CA
is PENDING_CERTIFICATE).  When you successfully call DeleteCertificateAuthority, the CA's
status changes to DELETED. However, the CA won't be permanently deleted until the
restoration period has passed. By default, if you do not set the
PermanentDeletionTimeInDays parameter, the CA remains restorable for 30 days. You can set
the parameter from 7 to 30 days. The DescribeCertificateAuthority action returns the time
remaining in the restoration window of a private CA in the DELETED state. To restore an
eligible CA, call the RestoreCertificateAuthority action.

# Arguments
- `certificate_authority_arn`: The Amazon Resource Name (ARN) that was returned when you
  called CreateCertificateAuthority. This must have the following form:
  arn:aws:acm-pca:region:account:certificate-authority/12345678-1234-1234-1234-123456789012 .

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"PermanentDeletionTimeInDays"`: The number of days to make a CA restorable after it has
  been deleted. This can be anywhere from 7 to 30 days, with 30 being the default.
"""
function delete_certificate_authority(
    CertificateAuthorityArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return acm_pca(
        "DeleteCertificateAuthority",
        Dict{String,Any}("CertificateAuthorityArn" => CertificateAuthorityArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_certificate_authority(
    CertificateAuthorityArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return acm_pca(
        "DeleteCertificateAuthority",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("CertificateAuthorityArn" => CertificateAuthorityArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_permission(certificate_authority_arn, principal)
    delete_permission(certificate_authority_arn, principal, params::Dict{String,<:Any})

Revokes permissions on a private CA granted to the Certificate Manager (ACM) service
principal (acm.amazonaws.com).  These permissions allow ACM to issue and renew ACM
certificates that reside in the same Amazon Web Services account as the CA. If you revoke
these permissions, ACM will no longer renew the affected certificates automatically.
Permissions can be granted with the CreatePermission action and listed with the
ListPermissions action.   About Permissions    If the private CA and the certificates it
issues reside in the same account, you can use CreatePermission to grant permissions for
ACM to carry out automatic certificate renewals.   For automatic certificate renewal to
succeed, the ACM service principal needs permissions to create, retrieve, and list
certificates.   If the private CA and the ACM certificates reside in different accounts,
then permissions cannot be used to enable automatic renewals. Instead, the ACM certificate
owner must set up a resource-based policy to enable cross-account issuance and renewals.
For more information, see Using a Resource Based Policy with Amazon Web Services Private
CA.

# Arguments
- `certificate_authority_arn`: The Amazon Resource Number (ARN) of the private CA that
  issued the permissions. You can find the CA's ARN by calling the ListCertificateAuthorities
  action. This must have the following form:
  arn:aws:acm-pca:region:account:certificate-authority/12345678-1234-1234-1234-123456789012 .
- `principal`: The Amazon Web Services service or identity that will have its CA
  permissions revoked. At this time, the only valid service principal is acm.amazonaws.com

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"SourceAccount"`: The Amazon Web Services account that calls this action.
"""
function delete_permission(
    CertificateAuthorityArn, Principal; aws_config::AbstractAWSConfig=current_aws_config()
)
    return acm_pca(
        "DeletePermission",
        Dict{String,Any}(
            "CertificateAuthorityArn" => CertificateAuthorityArn, "Principal" => Principal
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_permission(
    CertificateAuthorityArn,
    Principal,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return acm_pca(
        "DeletePermission",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CertificateAuthorityArn" => CertificateAuthorityArn,
                    "Principal" => Principal,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_policy(resource_arn)
    delete_policy(resource_arn, params::Dict{String,<:Any})

Deletes the resource-based policy attached to a private CA. Deletion will remove any access
that the policy has granted. If there is no policy attached to the private CA, this action
will return successful. If you delete a policy that was applied through Amazon Web Services
Resource Access Manager (RAM), the CA will be removed from all shares in which it was
included.  The Certificate Manager Service Linked Role that the policy supports is not
affected when you delete the policy.  The current policy can be shown with GetPolicy and
updated with PutPolicy.  About Policies    A policy grants access on a private CA to an
Amazon Web Services customer account, to Amazon Web Services Organizations, or to an Amazon
Web Services Organizations unit. Policies are under the control of a CA administrator. For
more information, see Using a Resource Based Policy with Amazon Web Services Private CA.
A policy permits a user of Certificate Manager (ACM) to issue ACM certificates signed by a
CA in another account.   For ACM to manage automatic renewal of these certificates, the ACM
user must configure a Service Linked Role (SLR). The SLR allows the ACM service to assume
the identity of the user, subject to confirmation against the Amazon Web Services Private
CA policy. For more information, see Using a Service Linked Role with ACM.   Updates made
in Amazon Web Services Resource Manager (RAM) are reflected in policies. For more
information, see Attach a Policy for Cross-Account Access.

# Arguments
- `resource_arn`: The Amazon Resource Number (ARN) of the private CA that will have its
  policy deleted. You can find the CA's ARN by calling the ListCertificateAuthorities action.
  The ARN value must have the form
  arn:aws:acm-pca:region:account:certificate-authority/01234567-89ab-cdef-0123-0123456789ab.

"""
function delete_policy(ResourceArn; aws_config::AbstractAWSConfig=current_aws_config())
    return acm_pca(
        "DeletePolicy",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_policy(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return acm_pca(
        "DeletePolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_certificate_authority(certificate_authority_arn)
    describe_certificate_authority(certificate_authority_arn, params::Dict{String,<:Any})

Lists information about your private certificate authority (CA) or one that has been shared
with you. You specify the private CA on input by its ARN (Amazon Resource Name). The output
contains the status of your CA. This can be any of the following:     CREATING - Amazon Web
Services Private CA is creating your private certificate authority.    PENDING_CERTIFICATE
- The certificate is pending. You must use your Amazon Web Services Private CA-hosted or
on-premises root or subordinate CA to sign your private CA CSR and then import it into
Amazon Web Services Private CA.     ACTIVE - Your private CA is active.    DISABLED - Your
private CA has been disabled.    EXPIRED - Your private CA certificate has expired.
FAILED - Your private CA has failed. Your CA can fail because of problems such a network
outage or back-end Amazon Web Services failure or other errors. A failed CA can never
return to the pending state. You must create a new CA.     DELETED - Your private CA is
within the restoration period, after which it is permanently deleted. The length of time
remaining in the CA's restoration period is also included in this action's output.

# Arguments
- `certificate_authority_arn`: The Amazon Resource Name (ARN) that was returned when you
  called CreateCertificateAuthority. This must be of the form:
  arn:aws:acm-pca:region:account:certificate-authority/12345678-1234-1234-1234-123456789012 .

"""
function describe_certificate_authority(
    CertificateAuthorityArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return acm_pca(
        "DescribeCertificateAuthority",
        Dict{String,Any}("CertificateAuthorityArn" => CertificateAuthorityArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_certificate_authority(
    CertificateAuthorityArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return acm_pca(
        "DescribeCertificateAuthority",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("CertificateAuthorityArn" => CertificateAuthorityArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_certificate_authority_audit_report(audit_report_id, certificate_authority_arn)
    describe_certificate_authority_audit_report(audit_report_id, certificate_authority_arn, params::Dict{String,<:Any})

Lists information about a specific audit report created by calling the
CreateCertificateAuthorityAuditReport action. Audit information is created every time the
certificate authority (CA) private key is used. The private key is used when you call the
IssueCertificate action or the RevokeCertificate action.

# Arguments
- `audit_report_id`: The report ID returned by calling the
  CreateCertificateAuthorityAuditReport action.
- `certificate_authority_arn`: The Amazon Resource Name (ARN) of the private CA. This must
  be of the form:
  arn:aws:acm-pca:region:account:certificate-authority/12345678-1234-1234-1234-123456789012 .

"""
function describe_certificate_authority_audit_report(
    AuditReportId,
    CertificateAuthorityArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return acm_pca(
        "DescribeCertificateAuthorityAuditReport",
        Dict{String,Any}(
            "AuditReportId" => AuditReportId,
            "CertificateAuthorityArn" => CertificateAuthorityArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_certificate_authority_audit_report(
    AuditReportId,
    CertificateAuthorityArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return acm_pca(
        "DescribeCertificateAuthorityAuditReport",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AuditReportId" => AuditReportId,
                    "CertificateAuthorityArn" => CertificateAuthorityArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_certificate(certificate_arn, certificate_authority_arn)
    get_certificate(certificate_arn, certificate_authority_arn, params::Dict{String,<:Any})

Retrieves a certificate from your private CA or one that has been shared with you. The ARN
of the certificate is returned when you call the IssueCertificate action. You must specify
both the ARN of your private CA and the ARN of the issued certificate when calling the
GetCertificate action. You can retrieve the certificate if it is in the ISSUED state. You
can call the CreateCertificateAuthorityAuditReport action to create a report that contains
information about all of the certificates issued and revoked by your private CA.

# Arguments
- `certificate_arn`: The ARN of the issued certificate. The ARN contains the certificate
  serial number and must be in the following form:
  arn:aws:acm-pca:region:account:certificate-authority/12345678-1234-1234-1234-123456789012/ce
  rtificate/286535153982981100925020015808220737245
- `certificate_authority_arn`: The Amazon Resource Name (ARN) that was returned when you
  called CreateCertificateAuthority. This must be of the form:
  arn:aws:acm-pca:region:account:certificate-authority/12345678-1234-1234-1234-123456789012 .

"""
function get_certificate(
    CertificateArn,
    CertificateAuthorityArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return acm_pca(
        "GetCertificate",
        Dict{String,Any}(
            "CertificateArn" => CertificateArn,
            "CertificateAuthorityArn" => CertificateAuthorityArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_certificate(
    CertificateArn,
    CertificateAuthorityArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return acm_pca(
        "GetCertificate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CertificateArn" => CertificateArn,
                    "CertificateAuthorityArn" => CertificateAuthorityArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_certificate_authority_certificate(certificate_authority_arn)
    get_certificate_authority_certificate(certificate_authority_arn, params::Dict{String,<:Any})

Retrieves the certificate and certificate chain for your private certificate authority (CA)
or one that has been shared with you. Both the certificate and the chain are base64
PEM-encoded. The chain does not include the CA certificate. Each certificate in the chain
signs the one before it.

# Arguments
- `certificate_authority_arn`: The Amazon Resource Name (ARN) of your private CA. This is
  of the form:
  arn:aws:acm-pca:region:account:certificate-authority/12345678-1234-1234-1234-123456789012 .

"""
function get_certificate_authority_certificate(
    CertificateAuthorityArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return acm_pca(
        "GetCertificateAuthorityCertificate",
        Dict{String,Any}("CertificateAuthorityArn" => CertificateAuthorityArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_certificate_authority_certificate(
    CertificateAuthorityArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return acm_pca(
        "GetCertificateAuthorityCertificate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("CertificateAuthorityArn" => CertificateAuthorityArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_certificate_authority_csr(certificate_authority_arn)
    get_certificate_authority_csr(certificate_authority_arn, params::Dict{String,<:Any})

Retrieves the certificate signing request (CSR) for your private certificate authority
(CA). The CSR is created when you call the CreateCertificateAuthority action. Sign the CSR
with your Amazon Web Services Private CA-hosted or on-premises root or subordinate CA. Then
import the signed certificate back into Amazon Web Services Private CA by calling the
ImportCertificateAuthorityCertificate action. The CSR is returned as a base64 PEM-encoded
string.

# Arguments
- `certificate_authority_arn`: The Amazon Resource Name (ARN) that was returned when you
  called the CreateCertificateAuthority action. This must be of the form:
  arn:aws:acm-pca:region:account:certificate-authority/12345678-1234-1234-1234-123456789012

"""
function get_certificate_authority_csr(
    CertificateAuthorityArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return acm_pca(
        "GetCertificateAuthorityCsr",
        Dict{String,Any}("CertificateAuthorityArn" => CertificateAuthorityArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_certificate_authority_csr(
    CertificateAuthorityArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return acm_pca(
        "GetCertificateAuthorityCsr",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("CertificateAuthorityArn" => CertificateAuthorityArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_policy(resource_arn)
    get_policy(resource_arn, params::Dict{String,<:Any})

Retrieves the resource-based policy attached to a private CA. If either the private CA
resource or the policy cannot be found, this action returns a ResourceNotFoundException.
The policy can be attached or updated with PutPolicy and removed with DeletePolicy.  About
Policies    A policy grants access on a private CA to an Amazon Web Services customer
account, to Amazon Web Services Organizations, or to an Amazon Web Services Organizations
unit. Policies are under the control of a CA administrator. For more information, see Using
a Resource Based Policy with Amazon Web Services Private CA.   A policy permits a user of
Certificate Manager (ACM) to issue ACM certificates signed by a CA in another account.
For ACM to manage automatic renewal of these certificates, the ACM user must configure a
Service Linked Role (SLR). The SLR allows the ACM service to assume the identity of the
user, subject to confirmation against the Amazon Web Services Private CA policy. For more
information, see Using a Service Linked Role with ACM.   Updates made in Amazon Web
Services Resource Manager (RAM) are reflected in policies. For more information, see Attach
a Policy for Cross-Account Access.

# Arguments
- `resource_arn`: The Amazon Resource Number (ARN) of the private CA that will have its
  policy retrieved. You can find the CA's ARN by calling the ListCertificateAuthorities
  action.

"""
function get_policy(ResourceArn; aws_config::AbstractAWSConfig=current_aws_config())
    return acm_pca(
        "GetPolicy",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_policy(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return acm_pca(
        "GetPolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    import_certificate_authority_certificate(certificate, certificate_authority_arn)
    import_certificate_authority_certificate(certificate, certificate_authority_arn, params::Dict{String,<:Any})

Imports a signed private CA certificate into Amazon Web Services Private CA. This action is
used when you are using a chain of trust whose root is located outside Amazon Web Services
Private CA. Before you can call this action, the following preparations must in place:   In
Amazon Web Services Private CA, call the CreateCertificateAuthority action to create the
private CA that you plan to back with the imported certificate.   Call the
GetCertificateAuthorityCsr action to generate a certificate signing request (CSR).   Sign
the CSR using a root or intermediate CA hosted by either an on-premises PKI hierarchy or by
a commercial CA.   Create a certificate chain and copy the signed certificate and the
certificate chain to your working directory.   Amazon Web Services Private CA supports
three scenarios for installing a CA certificate:   Installing a certificate for a root CA
hosted by Amazon Web Services Private CA.   Installing a subordinate CA certificate whose
parent authority is hosted by Amazon Web Services Private CA.   Installing a subordinate CA
certificate whose parent authority is externally hosted.   The following additional
requirements apply when you import a CA certificate.   Only a self-signed certificate can
be imported as a root CA.   A self-signed certificate cannot be imported as a subordinate
CA.   Your certificate chain must not include the private CA certificate that you are
importing.   Your root CA must be the last certificate in your chain. The subordinate
certificate, if any, that your root CA signed must be next to last. The subordinate
certificate signed by the preceding subordinate CA must come next, and so on until your
chain is built.    The chain must be PEM-encoded.   The maximum allowed size of a
certificate is 32 KB.   The maximum allowed size of a certificate chain is 2 MB.
Enforcement of Critical Constraints  Amazon Web Services Private CA allows the following
extensions to be marked critical in the imported CA certificate or chain.   Authority key
identifier   Basic constraints (must be marked critical)   Certificate policies   Extended
key usage   Inhibit anyPolicy   Issuer alternative name   Key usage   Name constraints
Policy mappings   Subject alternative name   Subject directory attributes   Subject key
identifier   Subject information access   Amazon Web Services Private CA rejects the
following extensions when they are marked critical in an imported CA certificate or chain.
 Authority information access   CRL distribution points   Freshest CRL   Policy constraints
  Amazon Web Services Private Certificate Authority will also reject any other extension
marked as critical not contained on the preceding list of allowed extensions.

# Arguments
- `certificate`: The PEM-encoded certificate for a private CA. This may be a self-signed
  certificate in the case of a root CA, or it may be signed by another CA that you control.
- `certificate_authority_arn`: The Amazon Resource Name (ARN) that was returned when you
  called CreateCertificateAuthority. This must be of the form:
  arn:aws:acm-pca:region:account:certificate-authority/12345678-1234-1234-1234-123456789012

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CertificateChain"`: A PEM-encoded file that contains all of your certificates, other
  than the certificate you're importing, chaining up to your root CA. Your Amazon Web
  Services Private CA-hosted or on-premises root certificate is the last in the chain, and
  each certificate in the chain signs the one preceding.  This parameter must be supplied
  when you import a subordinate CA. When you import a root CA, there is no chain.
"""
function import_certificate_authority_certificate(
    Certificate, CertificateAuthorityArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return acm_pca(
        "ImportCertificateAuthorityCertificate",
        Dict{String,Any}(
            "Certificate" => Certificate,
            "CertificateAuthorityArn" => CertificateAuthorityArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function import_certificate_authority_certificate(
    Certificate,
    CertificateAuthorityArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return acm_pca(
        "ImportCertificateAuthorityCertificate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Certificate" => Certificate,
                    "CertificateAuthorityArn" => CertificateAuthorityArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    issue_certificate(certificate_authority_arn, csr, signing_algorithm, validity)
    issue_certificate(certificate_authority_arn, csr, signing_algorithm, validity, params::Dict{String,<:Any})

Uses your private certificate authority (CA), or one that has been shared with you, to
issue a client certificate. This action returns the Amazon Resource Name (ARN) of the
certificate. You can retrieve the certificate by calling the GetCertificate action and
specifying the ARN.   You cannot use the ACM ListCertificateAuthorities action to retrieve
the ARNs of the certificates that you issue by using Amazon Web Services Private CA.

# Arguments
- `certificate_authority_arn`: The Amazon Resource Name (ARN) that was returned when you
  called CreateCertificateAuthority. This must be of the form:
  arn:aws:acm-pca:region:account:certificate-authority/12345678-1234-1234-1234-123456789012
- `csr`: The certificate signing request (CSR) for the certificate you want to issue. As an
  example, you can use the following OpenSSL command to create the CSR and a 2048 bit RSA
  private key.   openssl req -new -newkey rsa:2048 -days 365 -keyout
  private/test_cert_priv_key.pem -out csr/test_cert_.csr  If you have a configuration file,
  you can then use the following OpenSSL command. The usr_cert block in the configuration
  file contains your X509 version 3 extensions.   openssl req -new -config openssl_rsa.cnf
  -extensions usr_cert -newkey rsa:2048 -days 365 -keyout private/test_cert_priv_key.pem -out
  csr/test_cert_.csr  Note: A CSR must provide either a subject name or a subject alternative
  name or the request will be rejected.
- `signing_algorithm`: The name of the algorithm that will be used to sign the certificate
  to be issued.  This parameter should not be confused with the SigningAlgorithm parameter
  used to sign a CSR in the CreateCertificateAuthority action.  The specified signing
  algorithm family (RSA or ECDSA) must match the algorithm family of the CA's secret key.
- `validity`: Information describing the end of the validity period of the certificate.
  This parameter sets the “Not After” date for the certificate. Certificate validity is
  the period of time during which a certificate is valid. Validity can be expressed as an
  explicit date and time when the certificate expires, or as a span of time after issuance,
  stated in days, months, or years. For more information, see Validity in RFC 5280.  This
  value is unaffected when ValidityNotBefore is also specified. For example, if Validity is
  set to 20 days in the future, the certificate will expire 20 days from issuance time
  regardless of the ValidityNotBefore value. The end of the validity period configured on a
  certificate must not exceed the limit set on its parents in the CA hierarchy.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ApiPassthrough"`: Specifies X.509 certificate information to be included in the issued
  certificate. An APIPassthrough or APICSRPassthrough template variant must be selected, or
  else this parameter is ignored. For more information about using these templates, see
  Understanding Certificate Templates. If conflicting or duplicate certificate information is
  supplied during certificate issuance, Amazon Web Services Private CA applies order of
  operation rules to determine what information is used.
- `"IdempotencyToken"`: Alphanumeric string that can be used to distinguish between calls
  to the IssueCertificate action. Idempotency tokens for IssueCertificate time out after five
  minutes. Therefore, if you call IssueCertificate multiple times with the same idempotency
  token within five minutes, Amazon Web Services Private CA recognizes that you are
  requesting only one certificate and will issue only one. If you change the idempotency
  token for each call, Amazon Web Services Private CA recognizes that you are requesting
  multiple certificates.
- `"TemplateArn"`: Specifies a custom configuration template to use when issuing a
  certificate. If this parameter is not provided, Amazon Web Services Private CA defaults to
  the EndEntityCertificate/V1 template. For CA certificates, you should choose the shortest
  path length that meets your needs. The path length is indicated by the PathLenN portion of
  the ARN, where N is the CA depth. Note: The CA depth configured on a subordinate CA
  certificate must not exceed the limit set by its parents in the CA hierarchy. For a list of
  TemplateArn values supported by Amazon Web Services Private CA, see Understanding
  Certificate Templates.
- `"ValidityNotBefore"`: Information describing the start of the validity period of the
  certificate. This parameter sets the “Not Before\" date for the certificate. By default,
  when issuing a certificate, Amazon Web Services Private CA sets the \"Not Before\" date to
  the issuance time minus 60 minutes. This compensates for clock inconsistencies across
  computer systems. The ValidityNotBefore parameter can be used to customize the “Not
  Before” value.  Unlike the Validity parameter, the ValidityNotBefore parameter is
  optional. The ValidityNotBefore value is expressed as an explicit date and time, using the
  Validity type value ABSOLUTE. For more information, see Validity in this API reference and
  Validity in RFC 5280.
"""
function issue_certificate(
    CertificateAuthorityArn,
    Csr,
    SigningAlgorithm,
    Validity;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return acm_pca(
        "IssueCertificate",
        Dict{String,Any}(
            "CertificateAuthorityArn" => CertificateAuthorityArn,
            "Csr" => Csr,
            "SigningAlgorithm" => SigningAlgorithm,
            "Validity" => Validity,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function issue_certificate(
    CertificateAuthorityArn,
    Csr,
    SigningAlgorithm,
    Validity,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return acm_pca(
        "IssueCertificate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CertificateAuthorityArn" => CertificateAuthorityArn,
                    "Csr" => Csr,
                    "SigningAlgorithm" => SigningAlgorithm,
                    "Validity" => Validity,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_certificate_authorities()
    list_certificate_authorities(params::Dict{String,<:Any})

Lists the private certificate authorities that you created by using the
CreateCertificateAuthority action.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Use this parameter when paginating results to specify the maximum number
  of items to return in the response on each page. If additional items exist beyond the
  number you specify, the NextToken element is sent in the response. Use this NextToken value
  in a subsequent request to retrieve additional items. Although the maximum value is 1000,
  the action only returns a maximum of 100 items.
- `"NextToken"`: Use this parameter when paginating results in a subsequent request after
  you receive a response with truncated results. Set it to the value of the NextToken
  parameter from the response you just received.
- `"ResourceOwner"`: Use this parameter to filter the returned set of certificate
  authorities based on their owner. The default is SELF.
"""
function list_certificate_authorities(; aws_config::AbstractAWSConfig=current_aws_config())
    return acm_pca(
        "ListCertificateAuthorities"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_certificate_authorities(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return acm_pca(
        "ListCertificateAuthorities",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_permissions(certificate_authority_arn)
    list_permissions(certificate_authority_arn, params::Dict{String,<:Any})

List all permissions on a private CA, if any, granted to the Certificate Manager (ACM)
service principal (acm.amazonaws.com).  These permissions allow ACM to issue and renew ACM
certificates that reside in the same Amazon Web Services account as the CA.  Permissions
can be granted with the CreatePermission action and revoked with the DeletePermission
action.  About Permissions    If the private CA and the certificates it issues reside in
the same account, you can use CreatePermission to grant permissions for ACM to carry out
automatic certificate renewals.   For automatic certificate renewal to succeed, the ACM
service principal needs permissions to create, retrieve, and list certificates.   If the
private CA and the ACM certificates reside in different accounts, then permissions cannot
be used to enable automatic renewals. Instead, the ACM certificate owner must set up a
resource-based policy to enable cross-account issuance and renewals. For more information,
see Using a Resource Based Policy with Amazon Web Services Private CA.

# Arguments
- `certificate_authority_arn`: The Amazon Resource Number (ARN) of the private CA to
  inspect. You can find the ARN by calling the ListCertificateAuthorities action. This must
  be of the form:
  arn:aws:acm-pca:region:account:certificate-authority/12345678-1234-1234-1234-123456789012
  You can get a private CA's ARN by running the ListCertificateAuthorities action.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: When paginating results, use this parameter to specify the maximum number
  of items to return in the response. If additional items exist beyond the number you
  specify, the NextToken element is sent in the response. Use this NextToken value in a
  subsequent request to retrieve additional items.
- `"NextToken"`: When paginating results, use this parameter in a subsequent request after
  you receive a response with truncated results. Set it to the value of NextToken from the
  response you just received.
"""
function list_permissions(
    CertificateAuthorityArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return acm_pca(
        "ListPermissions",
        Dict{String,Any}("CertificateAuthorityArn" => CertificateAuthorityArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_permissions(
    CertificateAuthorityArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return acm_pca(
        "ListPermissions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("CertificateAuthorityArn" => CertificateAuthorityArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags(certificate_authority_arn)
    list_tags(certificate_authority_arn, params::Dict{String,<:Any})

Lists the tags, if any, that are associated with your private CA or one that has been
shared with you. Tags are labels that you can use to identify and organize your CAs. Each
tag consists of a key and an optional value. Call the TagCertificateAuthority action to add
one or more tags to your CA. Call the UntagCertificateAuthority action to remove tags.

# Arguments
- `certificate_authority_arn`: The Amazon Resource Name (ARN) that was returned when you
  called the CreateCertificateAuthority action. This must be of the form:
  arn:aws:acm-pca:region:account:certificate-authority/12345678-1234-1234-1234-123456789012

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Use this parameter when paginating results to specify the maximum number
  of items to return in the response. If additional items exist beyond the number you
  specify, the NextToken element is sent in the response. Use this NextToken value in a
  subsequent request to retrieve additional items.
- `"NextToken"`: Use this parameter when paginating results in a subsequent request after
  you receive a response with truncated results. Set it to the value of NextToken from the
  response you just received.
"""
function list_tags(
    CertificateAuthorityArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return acm_pca(
        "ListTags",
        Dict{String,Any}("CertificateAuthorityArn" => CertificateAuthorityArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags(
    CertificateAuthorityArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return acm_pca(
        "ListTags",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("CertificateAuthorityArn" => CertificateAuthorityArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_policy(policy, resource_arn)
    put_policy(policy, resource_arn, params::Dict{String,<:Any})

Attaches a resource-based policy to a private CA.  A policy can also be applied by sharing
a private CA through Amazon Web Services Resource Access Manager (RAM). For more
information, see Attach a Policy for Cross-Account Access. The policy can be displayed with
GetPolicy and removed with DeletePolicy.  About Policies    A policy grants access on a
private CA to an Amazon Web Services customer account, to Amazon Web Services
Organizations, or to an Amazon Web Services Organizations unit. Policies are under the
control of a CA administrator. For more information, see Using a Resource Based Policy with
Amazon Web Services Private CA.   A policy permits a user of Certificate Manager (ACM) to
issue ACM certificates signed by a CA in another account.   For ACM to manage automatic
renewal of these certificates, the ACM user must configure a Service Linked Role (SLR). The
SLR allows the ACM service to assume the identity of the user, subject to confirmation
against the Amazon Web Services Private CA policy. For more information, see Using a
Service Linked Role with ACM.   Updates made in Amazon Web Services Resource Manager (RAM)
are reflected in policies. For more information, see Attach a Policy for Cross-Account
Access.

# Arguments
- `policy`: The path and file name of a JSON-formatted IAM policy to attach to the
  specified private CA resource. If this policy does not contain all required statements or
  if it includes any statement that is not allowed, the PutPolicy action returns an
  InvalidPolicyException. For information about IAM policy and statement structure, see
  Overview of JSON Policies.
- `resource_arn`: The Amazon Resource Number (ARN) of the private CA to associate with the
  policy. The ARN of the CA can be found by calling the ListCertificateAuthorities action.

"""
function put_policy(Policy, ResourceArn; aws_config::AbstractAWSConfig=current_aws_config())
    return acm_pca(
        "PutPolicy",
        Dict{String,Any}("Policy" => Policy, "ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_policy(
    Policy,
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return acm_pca(
        "PutPolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Policy" => Policy, "ResourceArn" => ResourceArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    restore_certificate_authority(certificate_authority_arn)
    restore_certificate_authority(certificate_authority_arn, params::Dict{String,<:Any})

Restores a certificate authority (CA) that is in the DELETED state. You can restore a CA
during the period that you defined in the PermanentDeletionTimeInDays parameter of the
DeleteCertificateAuthority action. Currently, you can specify 7 to 30 days. If you did not
specify a PermanentDeletionTimeInDays value, by default you can restore the CA at any time
in a 30 day period. You can check the time remaining in the restoration period of a private
CA in the DELETED state by calling the DescribeCertificateAuthority or
ListCertificateAuthorities actions. The status of a restored CA is set to its pre-deletion
status when the RestoreCertificateAuthority action returns. To change its status to ACTIVE,
call the UpdateCertificateAuthority action. If the private CA was in the
PENDING_CERTIFICATE state at deletion, you must use the
ImportCertificateAuthorityCertificate action to import a certificate authority into the
private CA before it can be activated. You cannot restore a CA after the restoration period
has ended.

# Arguments
- `certificate_authority_arn`: The Amazon Resource Name (ARN) that was returned when you
  called the CreateCertificateAuthority action. This must be of the form:
  arn:aws:acm-pca:region:account:certificate-authority/12345678-1234-1234-1234-123456789012

"""
function restore_certificate_authority(
    CertificateAuthorityArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return acm_pca(
        "RestoreCertificateAuthority",
        Dict{String,Any}("CertificateAuthorityArn" => CertificateAuthorityArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function restore_certificate_authority(
    CertificateAuthorityArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return acm_pca(
        "RestoreCertificateAuthority",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("CertificateAuthorityArn" => CertificateAuthorityArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    revoke_certificate(certificate_authority_arn, certificate_serial, revocation_reason)
    revoke_certificate(certificate_authority_arn, certificate_serial, revocation_reason, params::Dict{String,<:Any})

Revokes a certificate that was issued inside Amazon Web Services Private CA. If you enable
a certificate revocation list (CRL) when you create or update your private CA, information
about the revoked certificates will be included in the CRL. Amazon Web Services Private CA
writes the CRL to an S3 bucket that you specify. A CRL is typically updated approximately
30 minutes after a certificate is revoked. If for any reason the CRL update fails, Amazon
Web Services Private CA attempts makes further attempts every 15 minutes. With Amazon
CloudWatch, you can create alarms for the metrics CRLGenerated and MisconfiguredCRLBucket.
For more information, see Supported CloudWatch Metrics.  Both Amazon Web Services Private
CA and the IAM principal must have permission to write to the S3 bucket that you specify.
If the IAM principal making the call does not have permission to write to the bucket, then
an exception is thrown. For more information, see Access policies for CRLs in Amazon S3.
Amazon Web Services Private CA also writes revocation information to the audit report. For
more information, see CreateCertificateAuthorityAuditReport.  You cannot revoke a root CA
self-signed certificate.

# Arguments
- `certificate_authority_arn`: Amazon Resource Name (ARN) of the private CA that issued the
  certificate to be revoked. This must be of the form:
  arn:aws:acm-pca:region:account:certificate-authority/12345678-1234-1234-1234-123456789012
- `certificate_serial`: Serial number of the certificate to be revoked. This must be in
  hexadecimal format. You can retrieve the serial number by calling GetCertificate with the
  Amazon Resource Name (ARN) of the certificate you want and the ARN of your private CA. The
  GetCertificate action retrieves the certificate in the PEM format. You can use the
  following OpenSSL command to list the certificate in text format and copy the hexadecimal
  serial number.   openssl x509 -in file_path -text -noout  You can also copy the serial
  number from the console or use the DescribeCertificate action in the Certificate Manager
  API Reference.
- `revocation_reason`: Specifies why you revoked the certificate.

"""
function revoke_certificate(
    CertificateAuthorityArn,
    CertificateSerial,
    RevocationReason;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return acm_pca(
        "RevokeCertificate",
        Dict{String,Any}(
            "CertificateAuthorityArn" => CertificateAuthorityArn,
            "CertificateSerial" => CertificateSerial,
            "RevocationReason" => RevocationReason,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function revoke_certificate(
    CertificateAuthorityArn,
    CertificateSerial,
    RevocationReason,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return acm_pca(
        "RevokeCertificate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CertificateAuthorityArn" => CertificateAuthorityArn,
                    "CertificateSerial" => CertificateSerial,
                    "RevocationReason" => RevocationReason,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_certificate_authority(certificate_authority_arn, tags)
    tag_certificate_authority(certificate_authority_arn, tags, params::Dict{String,<:Any})

Adds one or more tags to your private CA. Tags are labels that you can use to identify and
organize your Amazon Web Services resources. Each tag consists of a key and an optional
value. You specify the private CA on input by its Amazon Resource Name (ARN). You specify
the tag by using a key-value pair. You can apply a tag to just one private CA if you want
to identify a specific characteristic of that CA, or you can apply the same tag to multiple
private CAs if you want to filter for a common relationship among those CAs. To remove one
or more tags, use the UntagCertificateAuthority action. Call the ListTags action to see
what tags are associated with your CA.   To attach tags to a private CA during the creation
procedure, a CA administrator must first associate an inline IAM policy with the
CreateCertificateAuthority action and explicitly allow tagging. For more information, see
Attaching tags to a CA at the time of creation.

# Arguments
- `certificate_authority_arn`: The Amazon Resource Name (ARN) that was returned when you
  called CreateCertificateAuthority. This must be of the form:
  arn:aws:acm-pca:region:account:certificate-authority/12345678-1234-1234-1234-123456789012
- `tags`: List of tags to be associated with the CA.

"""
function tag_certificate_authority(
    CertificateAuthorityArn, Tags; aws_config::AbstractAWSConfig=current_aws_config()
)
    return acm_pca(
        "TagCertificateAuthority",
        Dict{String,Any}(
            "CertificateAuthorityArn" => CertificateAuthorityArn, "Tags" => Tags
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_certificate_authority(
    CertificateAuthorityArn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return acm_pca(
        "TagCertificateAuthority",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CertificateAuthorityArn" => CertificateAuthorityArn, "Tags" => Tags
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_certificate_authority(certificate_authority_arn, tags)
    untag_certificate_authority(certificate_authority_arn, tags, params::Dict{String,<:Any})

Remove one or more tags from your private CA. A tag consists of a key-value pair. If you do
not specify the value portion of the tag when calling this action, the tag will be removed
regardless of value. If you specify a value, the tag is removed only if it is associated
with the specified value. To add tags to a private CA, use the TagCertificateAuthority.
Call the ListTags action to see what tags are associated with your CA.

# Arguments
- `certificate_authority_arn`: The Amazon Resource Name (ARN) that was returned when you
  called CreateCertificateAuthority. This must be of the form:
  arn:aws:acm-pca:region:account:certificate-authority/12345678-1234-1234-1234-123456789012
- `tags`: List of tags to be removed from the CA.

"""
function untag_certificate_authority(
    CertificateAuthorityArn, Tags; aws_config::AbstractAWSConfig=current_aws_config()
)
    return acm_pca(
        "UntagCertificateAuthority",
        Dict{String,Any}(
            "CertificateAuthorityArn" => CertificateAuthorityArn, "Tags" => Tags
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_certificate_authority(
    CertificateAuthorityArn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return acm_pca(
        "UntagCertificateAuthority",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CertificateAuthorityArn" => CertificateAuthorityArn, "Tags" => Tags
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_certificate_authority(certificate_authority_arn)
    update_certificate_authority(certificate_authority_arn, params::Dict{String,<:Any})

Updates the status or configuration of a private certificate authority (CA). Your private
CA must be in the ACTIVE or DISABLED state before you can update it. You can disable a
private CA that is in the ACTIVE state or make a CA that is in the DISABLED state active
again.  Both Amazon Web Services Private CA and the IAM principal must have permission to
write to the S3 bucket that you specify. If the IAM principal making the call does not have
permission to write to the bucket, then an exception is thrown. For more information, see
Access policies for CRLs in Amazon S3.

# Arguments
- `certificate_authority_arn`: Amazon Resource Name (ARN) of the private CA that issued the
  certificate to be revoked. This must be of the form:
  arn:aws:acm-pca:region:account:certificate-authority/12345678-1234-1234-1234-123456789012

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"RevocationConfiguration"`: Contains information to enable Online Certificate Status
  Protocol (OCSP) support, to enable a certificate revocation list (CRL), to enable both, or
  to enable neither. If this parameter is not supplied, existing capibilites remain
  unchanged. For more information, see the OcspConfiguration and CrlConfiguration types.  The
  following requirements apply to revocation configurations.   A configuration disabling CRLs
  or OCSP must contain only the Enabled=False parameter, and will fail if other parameters
  such as CustomCname or ExpirationInDays are included.   In a CRL configuration, the
  S3BucketName parameter must conform to Amazon S3 bucket naming rules.   A configuration
  containing a custom Canonical Name (CNAME) parameter for CRLs or OCSP must conform to
  RFC2396 restrictions on the use of special characters in a CNAME.    In a CRL or OCSP
  configuration, the value of a CNAME parameter must not include a protocol prefix such as
  \"http://\" or \"https://\".
- `"Status"`: Status of your private CA.
"""
function update_certificate_authority(
    CertificateAuthorityArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return acm_pca(
        "UpdateCertificateAuthority",
        Dict{String,Any}("CertificateAuthorityArn" => CertificateAuthorityArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_certificate_authority(
    CertificateAuthorityArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return acm_pca(
        "UpdateCertificateAuthority",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("CertificateAuthorityArn" => CertificateAuthorityArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: rum
using AWS.Compat
using AWS.UUIDs

"""
    batch_create_rum_metric_definitions(app_monitor_name, destination, metric_definitions)
    batch_create_rum_metric_definitions(app_monitor_name, destination, metric_definitions, params::Dict{String,<:Any})

Specifies the extended metrics and custom metrics that you want a CloudWatch RUM app
monitor to send to a destination. Valid destinations include CloudWatch and Evidently. By
default, RUM app monitors send some metrics to CloudWatch. These default metrics are listed
in CloudWatch metrics that you can collect with CloudWatch RUM. In addition to these
default metrics, you can choose to send extended metrics, custom metrics, or both.
Extended metrics let you send metrics with additional dimensions that aren't included in
the default metrics. You can also send extended metrics to both Evidently and CloudWatch.
The valid dimension names for the additional dimensions for extended metrics are
BrowserName, CountryCode, DeviceType, FileType, OSName, and PageId. For more information,
see  Extended metrics that you can send to CloudWatch and CloudWatch Evidently.   Custom
metrics are metrics that you define. You can send custom metrics to CloudWatch. CloudWatch
Evidently, or both. With custom metrics, you can use any metric name and namespace. To
derive the metrics, you can use any custom events, built-in events, custom attributes, or
default attributes.  You can't send custom metrics to the AWS/RUM namespace. You must send
custom metrics to a custom namespace that you define. The namespace that you use can't
start with AWS/. CloudWatch RUM prepends RUM/CustomMetrics/ to the custom namespace that
you define, so the final namespace for your metrics in CloudWatch is
RUM/CustomMetrics/your-custom-namespace .   The maximum number of metric definitions that
you can specify in one BatchCreateRumMetricDefinitions operation is 200. The maximum number
of metric definitions that one destination can contain is 2000. Extended metrics sent to
CloudWatch and RUM custom metrics are charged as CloudWatch custom metrics. Each
combination of additional dimension name and dimension value counts as a custom metric. For
more information, see Amazon CloudWatch Pricing. You must have already created a
destination for the metrics before you send them. For more information, see
PutRumMetricsDestination. If some metric definitions specified in a
BatchCreateRumMetricDefinitions operations are not valid, those metric definitions fail and
return errors, but all valid metric definitions in the same operation still succeed.

# Arguments
- `app_monitor_name`: The name of the CloudWatch RUM app monitor that is to send the
  metrics.
- `destination`: The destination to send the metrics to. Valid values are CloudWatch and
  Evidently. If you specify Evidently, you must also specify the Amazon Resource Name (ARN)
  of the CloudWatchEvidently experiment that will receive the metrics and an IAM role that
  has permission to write to the experiment.
- `metric_definitions`: An array of structures which define the metrics that you want to
  send.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DestinationArn"`: This parameter is required if Destination is Evidently. If
  Destination is CloudWatch, do not use this parameter. This parameter specifies the ARN of
  the Evidently experiment that is to receive the metrics. You must have already defined this
  experiment as a valid destination. For more information, see PutRumMetricsDestination.
"""
function batch_create_rum_metric_definitions(
    AppMonitorName,
    Destination,
    MetricDefinitions;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rum(
        "POST",
        "/rummetrics/$(AppMonitorName)/metrics",
        Dict{String,Any}(
            "Destination" => Destination, "MetricDefinitions" => MetricDefinitions
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_create_rum_metric_definitions(
    AppMonitorName,
    Destination,
    MetricDefinitions,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rum(
        "POST",
        "/rummetrics/$(AppMonitorName)/metrics",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Destination" => Destination, "MetricDefinitions" => MetricDefinitions
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_delete_rum_metric_definitions(app_monitor_name, destination, metric_definition_ids)
    batch_delete_rum_metric_definitions(app_monitor_name, destination, metric_definition_ids, params::Dict{String,<:Any})

Removes the specified metrics from being sent to an extended metrics destination. If some
metric definition IDs specified in a BatchDeleteRumMetricDefinitions operations are not
valid, those metric definitions fail and return errors, but all valid metric definition IDs
in the same operation are still deleted. The maximum number of metric definitions that you
can specify in one BatchDeleteRumMetricDefinitions operation is 200.

# Arguments
- `app_monitor_name`: The name of the CloudWatch RUM app monitor that is sending these
  metrics.
- `destination`: Defines the destination where you want to stop sending the specified
  metrics. Valid values are CloudWatch and Evidently. If you specify Evidently, you must also
  specify the ARN of the CloudWatchEvidently experiment that is to be the destination and an
  IAM role that has permission to write to the experiment.
- `metric_definition_ids`: An array of structures which define the metrics that you want to
  stop sending.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"destinationArn"`: This parameter is required if Destination is Evidently. If
  Destination is CloudWatch, do not use this parameter.  This parameter specifies the ARN of
  the Evidently experiment that was receiving the metrics that are being deleted.
"""
function batch_delete_rum_metric_definitions(
    AppMonitorName,
    destination,
    metricDefinitionIds;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rum(
        "DELETE",
        "/rummetrics/$(AppMonitorName)/metrics",
        Dict{String,Any}(
            "destination" => destination, "metricDefinitionIds" => metricDefinitionIds
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_delete_rum_metric_definitions(
    AppMonitorName,
    destination,
    metricDefinitionIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rum(
        "DELETE",
        "/rummetrics/$(AppMonitorName)/metrics",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "destination" => destination,
                    "metricDefinitionIds" => metricDefinitionIds,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_get_rum_metric_definitions(app_monitor_name, destination)
    batch_get_rum_metric_definitions(app_monitor_name, destination, params::Dict{String,<:Any})

Retrieves the list of metrics and dimensions that a RUM app monitor is sending to a single
destination.

# Arguments
- `app_monitor_name`: The name of the CloudWatch RUM app monitor that is sending the
  metrics.
- `destination`: The type of destination that you want to view metrics for. Valid values
  are CloudWatch and Evidently.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"destinationArn"`: This parameter is required if Destination is Evidently. If
  Destination is CloudWatch, do not use this parameter. This parameter specifies the ARN of
  the Evidently experiment that corresponds to the destination.
- `"maxResults"`: The maximum number of results to return in one operation. The default is
  50. The maximum that you can specify is 100. To retrieve the remaining results, make
  another call with the returned NextToken value.
- `"nextToken"`: Use the token returned by the previous operation to request the next page
  of results.
"""
function batch_get_rum_metric_definitions(
    AppMonitorName, destination; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rum(
        "GET",
        "/rummetrics/$(AppMonitorName)/metrics",
        Dict{String,Any}("destination" => destination);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_rum_metric_definitions(
    AppMonitorName,
    destination,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rum(
        "GET",
        "/rummetrics/$(AppMonitorName)/metrics",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("destination" => destination), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_app_monitor(domain, name)
    create_app_monitor(domain, name, params::Dict{String,<:Any})

Creates a Amazon CloudWatch RUM app monitor, which collects telemetry data from your
application and sends that data to RUM. The data includes performance and reliability
information such as page load time, client-side errors, and user behavior. You use this
operation only to create a new app monitor. To update an existing app monitor, use
UpdateAppMonitor instead. After you create an app monitor, sign in to the CloudWatch RUM
console to get the JavaScript code snippet to add to your web application. For more
information, see How do I find a code snippet that I've already generated?

# Arguments
- `domain`: The top-level internet domain name for which your application has
  administrative authority.
- `name`: A name for the app monitor.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AppMonitorConfiguration"`: A structure that contains much of the configuration data for
  the app monitor. If you are using Amazon Cognito for authorization, you must include this
  structure in your request, and it must include the ID of the Amazon Cognito identity pool
  to use for authorization. If you don't include AppMonitorConfiguration, you must set up
  your own authorization method. For more information, see Authorize your application to send
  data to Amazon Web Services. If you omit this argument, the sample rate used for RUM is set
  to 10% of the user sessions.
- `"CustomEvents"`: Specifies whether this app monitor allows the web client to define and
  send custom events. If you omit this parameter, custom events are DISABLED. For more
  information about custom events, see Send custom events.
- `"CwLogEnabled"`: Data collected by RUM is kept by RUM for 30 days and then deleted. This
  parameter specifies whether RUM sends a copy of this telemetry data to Amazon CloudWatch
  Logs in your account. This enables you to keep the telemetry data for more than 30 days,
  but it does incur Amazon CloudWatch Logs charges. If you omit this parameter, the default
  is false.
- `"Tags"`: Assigns one or more tags (key-value pairs) to the app monitor. Tags can help
  you organize and categorize your resources. You can also use them to scope user permissions
  by granting a user permission to access or change only resources with certain tag values.
  Tags don't have any semantic meaning to Amazon Web Services and are interpreted strictly as
  strings of characters. You can associate as many as 50 tags with an app monitor. For more
  information, see Tagging Amazon Web Services resources.
"""
function create_app_monitor(
    Domain, Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rum(
        "POST",
        "/appmonitor",
        Dict{String,Any}("Domain" => Domain, "Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_app_monitor(
    Domain,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rum(
        "POST",
        "/appmonitor",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Domain" => Domain, "Name" => Name), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_app_monitor(name)
    delete_app_monitor(name, params::Dict{String,<:Any})

Deletes an existing app monitor. This immediately stops the collection of data.

# Arguments
- `name`: The name of the app monitor to delete.

"""
function delete_app_monitor(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return rum(
        "DELETE",
        "/appmonitor/$(Name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_app_monitor(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rum(
        "DELETE",
        "/appmonitor/$(Name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_rum_metrics_destination(app_monitor_name, destination)
    delete_rum_metrics_destination(app_monitor_name, destination, params::Dict{String,<:Any})

Deletes a destination for CloudWatch RUM extended metrics, so that the specified app
monitor stops sending extended metrics to that destination.

# Arguments
- `app_monitor_name`: The name of the app monitor that is sending metrics to the
  destination that you want to delete.
- `destination`: The type of destination to delete. Valid values are CloudWatch and
  Evidently.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"destinationArn"`: This parameter is required if Destination is Evidently. If
  Destination is CloudWatch, do not use this parameter. This parameter specifies the ARN of
  the Evidently experiment that corresponds to the destination to delete.
"""
function delete_rum_metrics_destination(
    AppMonitorName, destination; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rum(
        "DELETE",
        "/rummetrics/$(AppMonitorName)/metricsdestination",
        Dict{String,Any}("destination" => destination);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_rum_metrics_destination(
    AppMonitorName,
    destination,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rum(
        "DELETE",
        "/rummetrics/$(AppMonitorName)/metricsdestination",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("destination" => destination), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_app_monitor(name)
    get_app_monitor(name, params::Dict{String,<:Any})

Retrieves the complete configuration information for one app monitor.

# Arguments
- `name`: The app monitor to retrieve information for.

"""
function get_app_monitor(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return rum(
        "GET", "/appmonitor/$(Name)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_app_monitor(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rum(
        "GET",
        "/appmonitor/$(Name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_app_monitor_data(name, time_range)
    get_app_monitor_data(name, time_range, params::Dict{String,<:Any})

Retrieves the raw performance events that RUM has collected from your web application, so
that you can do your own processing or analysis of this data.

# Arguments
- `name`: The name of the app monitor that collected the data that you want to retrieve.
- `time_range`: A structure that defines the time range that you want to retrieve results
  from.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: An array of structures that you can use to filter the results to those that
  match one or more sets of key-value pairs that you specify.
- `"MaxResults"`: The maximum number of results to return in one operation.
- `"NextToken"`: Use the token returned by the previous operation to request the next page
  of results.
"""
function get_app_monitor_data(
    Name, TimeRange; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rum(
        "POST",
        "/appmonitor/$(Name)/data",
        Dict{String,Any}("TimeRange" => TimeRange);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_app_monitor_data(
    Name,
    TimeRange,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rum(
        "POST",
        "/appmonitor/$(Name)/data",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TimeRange" => TimeRange), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_app_monitors()
    list_app_monitors(params::Dict{String,<:Any})

Returns a list of the Amazon CloudWatch RUM app monitors in the account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in one operation. The default is
  50. The maximum that you can specify is 100.
- `"nextToken"`: Use the token returned by the previous operation to request the next page
  of results.
"""
function list_app_monitors(; aws_config::AbstractAWSConfig=current_aws_config())
    return rum(
        "POST", "/appmonitors"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_app_monitors(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rum(
        "POST",
        "/appmonitors",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_rum_metrics_destinations(app_monitor_name)
    list_rum_metrics_destinations(app_monitor_name, params::Dict{String,<:Any})

Returns a list of destinations that you have created to receive RUM extended metrics, for
the specified app monitor. For more information about extended metrics, see AddRumMetrics.

# Arguments
- `app_monitor_name`: The name of the app monitor associated with the destinations that you
  want to retrieve.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in one operation. The default is
  50. The maximum that you can specify is 100. To retrieve the remaining results, make
  another call with the returned NextToken value.
- `"nextToken"`: Use the token returned by the previous operation to request the next page
  of results.
"""
function list_rum_metrics_destinations(
    AppMonitorName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rum(
        "GET",
        "/rummetrics/$(AppMonitorName)/metricsdestination";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_rum_metrics_destinations(
    AppMonitorName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rum(
        "GET",
        "/rummetrics/$(AppMonitorName)/metricsdestination",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Displays the tags associated with a CloudWatch RUM resource.

# Arguments
- `resource_arn`: The ARN of the resource that you want to see the tags of.

"""
function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rum(
        "GET",
        "/tags/$(ResourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rum(
        "GET",
        "/tags/$(ResourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_rum_events(app_monitor_details, batch_id, id, rum_events, user_details)
    put_rum_events(app_monitor_details, batch_id, id, rum_events, user_details, params::Dict{String,<:Any})

Sends telemetry events about your application performance and user behavior to CloudWatch
RUM. The code snippet that RUM generates for you to add to your application includes
PutRumEvents operations to send this data to RUM. Each PutRumEvents operation can send a
batch of events from one user session.

# Arguments
- `app_monitor_details`: A structure that contains information about the app monitor that
  collected this telemetry information.
- `batch_id`: A unique identifier for this batch of RUM event data.
- `id`: The ID of the app monitor that is sending this data.
- `rum_events`: An array of structures that contain the telemetry event data.
- `user_details`: A structure that contains information about the user session that this
  batch of events was collected from.

"""
function put_rum_events(
    AppMonitorDetails,
    BatchId,
    Id,
    RumEvents,
    UserDetails;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rum(
        "POST",
        "/appmonitors/$(Id)/",
        Dict{String,Any}(
            "AppMonitorDetails" => AppMonitorDetails,
            "BatchId" => BatchId,
            "RumEvents" => RumEvents,
            "UserDetails" => UserDetails,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_rum_events(
    AppMonitorDetails,
    BatchId,
    Id,
    RumEvents,
    UserDetails,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rum(
        "POST",
        "/appmonitors/$(Id)/",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AppMonitorDetails" => AppMonitorDetails,
                    "BatchId" => BatchId,
                    "RumEvents" => RumEvents,
                    "UserDetails" => UserDetails,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_rum_metrics_destination(app_monitor_name, destination)
    put_rum_metrics_destination(app_monitor_name, destination, params::Dict{String,<:Any})

Creates or updates a destination to receive extended metrics from CloudWatch RUM. You can
send extended metrics to CloudWatch or to a CloudWatch Evidently experiment. For more
information about extended metrics, see BatchCreateRumMetricDefinitions.

# Arguments
- `app_monitor_name`: The name of the CloudWatch RUM app monitor that will send the metrics.
- `destination`: Defines the destination to send the metrics to. Valid values are
  CloudWatch and Evidently. If you specify Evidently, you must also specify the ARN of the
  CloudWatchEvidently experiment that is to be the destination and an IAM role that has
  permission to write to the experiment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DestinationArn"`: Use this parameter only if Destination is Evidently. This parameter
  specifies the ARN of the Evidently experiment that will receive the extended metrics.
- `"IamRoleArn"`: This parameter is required if Destination is Evidently. If Destination is
  CloudWatch, don't use this parameter. This parameter specifies the ARN of an IAM role that
  RUM will assume to write to the Evidently experiment that you are sending metrics to. This
  role must have permission to write to that experiment. If you specify this parameter, you
  must be signed on to a role that has PassRole permissions attached to it, to allow the role
  to be passed. The  CloudWatchAmazonCloudWatchRUMFullAccess policy doesn't include PassRole
  permissions.
"""
function put_rum_metrics_destination(
    AppMonitorName, Destination; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rum(
        "POST",
        "/rummetrics/$(AppMonitorName)/metricsdestination",
        Dict{String,Any}("Destination" => Destination);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_rum_metrics_destination(
    AppMonitorName,
    Destination,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rum(
        "POST",
        "/rummetrics/$(AppMonitorName)/metricsdestination",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Destination" => Destination), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Assigns one or more tags (key-value pairs) to the specified CloudWatch RUM resource.
Currently, the only resources that can be tagged app monitors. Tags can help you organize
and categorize your resources. You can also use them to scope user permissions by granting
a user permission to access or change only resources with certain tag values. Tags don't
have any semantic meaning to Amazon Web Services and are interpreted strictly as strings of
characters. You can use the TagResource action with a resource that already has tags. If
you specify a new tag key for the resource, this tag is appended to the list of tags
associated with the alarm. If you specify a tag key that is already associated with the
resource, the new tag value that you specify replaces the previous value for that tag. You
can associate as many as 50 tags with a resource. For more information, see Tagging Amazon
Web Services resources.

# Arguments
- `resource_arn`: The ARN of the CloudWatch RUM resource that you're adding tags to.
- `tags`: The list of key-value pairs to associate with the resource.

"""
function tag_resource(ResourceArn, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return rum(
        "POST",
        "/tags/$(ResourceArn)",
        Dict{String,Any}("Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceArn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rum(
        "POST",
        "/tags/$(ResourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Tags" => Tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes one or more tags from the specified resource.

# Arguments
- `resource_arn`: The ARN of the CloudWatch RUM resource that you're removing tags from.
- `tag_keys`: The list of tag keys to remove from the resource.

"""
function untag_resource(
    ResourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rum(
        "DELETE",
        "/tags/$(ResourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rum(
        "DELETE",
        "/tags/$(ResourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_app_monitor(name)
    update_app_monitor(name, params::Dict{String,<:Any})

Updates the configuration of an existing app monitor. When you use this operation, only the
parts of the app monitor configuration that you specify in this operation are changed. For
any parameters that you omit, the existing values are kept. You can't use this operation to
change the tags of an existing app monitor. To change the tags of an existing app monitor,
use TagResource. To create a new app monitor, use CreateAppMonitor. After you update an app
monitor, sign in to the CloudWatch RUM console to get the updated JavaScript code snippet
to add to your web application. For more information, see How do I find a code snippet that
I've already generated?

# Arguments
- `name`: The name of the app monitor to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AppMonitorConfiguration"`: A structure that contains much of the configuration data for
  the app monitor. If you are using Amazon Cognito for authorization, you must include this
  structure in your request, and it must include the ID of the Amazon Cognito identity pool
  to use for authorization. If you don't include AppMonitorConfiguration, you must set up
  your own authorization method. For more information, see Authorize your application to send
  data to Amazon Web Services.
- `"CustomEvents"`: Specifies whether this app monitor allows the web client to define and
  send custom events. The default is for custom events to be DISABLED. For more information
  about custom events, see Send custom events.
- `"CwLogEnabled"`: Data collected by RUM is kept by RUM for 30 days and then deleted. This
  parameter specifies whether RUM sends a copy of this telemetry data to Amazon CloudWatch
  Logs in your account. This enables you to keep the telemetry data for more than 30 days,
  but it does incur Amazon CloudWatch Logs charges.
- `"Domain"`: The top-level internet domain name for which your application has
  administrative authority.
"""
function update_app_monitor(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return rum(
        "PATCH",
        "/appmonitor/$(Name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_app_monitor(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rum(
        "PATCH",
        "/appmonitor/$(Name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_rum_metric_definition(app_monitor_name, destination, metric_definition, metric_definition_id)
    update_rum_metric_definition(app_monitor_name, destination, metric_definition, metric_definition_id, params::Dict{String,<:Any})

Modifies one existing metric definition for CloudWatch RUM extended metrics. For more
information about extended metrics, see BatchCreateRumMetricsDefinitions.

# Arguments
- `app_monitor_name`: The name of the CloudWatch RUM app monitor that sends these metrics.
- `destination`: The destination to send the metrics to. Valid values are CloudWatch and
  Evidently. If you specify Evidently, you must also specify the ARN of the
  CloudWatchEvidently experiment that will receive the metrics and an IAM role that has
  permission to write to the experiment.
- `metric_definition`: A structure that contains the new definition that you want to use
  for this metric.
- `metric_definition_id`: The ID of the metric definition to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DestinationArn"`: This parameter is required if Destination is Evidently. If
  Destination is CloudWatch, do not use this parameter. This parameter specifies the ARN of
  the Evidently experiment that is to receive the metrics. You must have already defined this
  experiment as a valid destination. For more information, see PutRumMetricsDestination.
"""
function update_rum_metric_definition(
    AppMonitorName,
    Destination,
    MetricDefinition,
    MetricDefinitionId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rum(
        "PATCH",
        "/rummetrics/$(AppMonitorName)/metrics",
        Dict{String,Any}(
            "Destination" => Destination,
            "MetricDefinition" => MetricDefinition,
            "MetricDefinitionId" => MetricDefinitionId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_rum_metric_definition(
    AppMonitorName,
    Destination,
    MetricDefinition,
    MetricDefinitionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rum(
        "PATCH",
        "/rummetrics/$(AppMonitorName)/metrics",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Destination" => Destination,
                    "MetricDefinition" => MetricDefinition,
                    "MetricDefinitionId" => MetricDefinitionId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: mgn
using AWS.Compat
using AWS.UUIDs

"""
    archive_application(application_id)
    archive_application(application_id, params::Dict{String,<:Any})

Archive application.

# Arguments
- `application_id`: Application ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountID"`: Account ID.
"""
function archive_application(
    applicationID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "POST",
        "/ArchiveApplication",
        Dict{String,Any}("applicationID" => applicationID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function archive_application(
    applicationID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mgn(
        "POST",
        "/ArchiveApplication",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("applicationID" => applicationID), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    archive_wave(wave_id)
    archive_wave(wave_id, params::Dict{String,<:Any})

Archive wave.

# Arguments
- `wave_id`: Wave ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountID"`: Account ID.
"""
function archive_wave(waveID; aws_config::AbstractAWSConfig=current_aws_config())
    return mgn(
        "POST",
        "/ArchiveWave",
        Dict{String,Any}("waveID" => waveID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function archive_wave(
    waveID, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "POST",
        "/ArchiveWave",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("waveID" => waveID), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_applications(application_ids, wave_id)
    associate_applications(application_ids, wave_id, params::Dict{String,<:Any})

Associate applications to wave.

# Arguments
- `application_ids`: Application IDs list.
- `wave_id`: Wave ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountID"`: Account ID.
"""
function associate_applications(
    applicationIDs, waveID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "POST",
        "/AssociateApplications",
        Dict{String,Any}("applicationIDs" => applicationIDs, "waveID" => waveID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_applications(
    applicationIDs,
    waveID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mgn(
        "POST",
        "/AssociateApplications",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("applicationIDs" => applicationIDs, "waveID" => waveID),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_source_servers(application_id, source_server_ids)
    associate_source_servers(application_id, source_server_ids, params::Dict{String,<:Any})

Associate source servers to application.

# Arguments
- `application_id`: Application ID.
- `source_server_ids`: Source server IDs list.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountID"`: Account ID.
"""
function associate_source_servers(
    applicationID, sourceServerIDs; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "POST",
        "/AssociateSourceServers",
        Dict{String,Any}(
            "applicationID" => applicationID, "sourceServerIDs" => sourceServerIDs
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_source_servers(
    applicationID,
    sourceServerIDs,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mgn(
        "POST",
        "/AssociateSourceServers",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "applicationID" => applicationID, "sourceServerIDs" => sourceServerIDs
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    change_server_life_cycle_state(life_cycle, source_server_id)
    change_server_life_cycle_state(life_cycle, source_server_id, params::Dict{String,<:Any})

Allows the user to set the SourceServer.LifeCycle.state property for specific Source Server
IDs to one of the following: READY_FOR_TEST or READY_FOR_CUTOVER. This command only works
if the Source Server is already launchable (dataReplicationInfo.lagDuration is not null.)

# Arguments
- `life_cycle`: The request to change the source server migration lifecycle state.
- `source_server_id`: The request to change the source server migration lifecycle state by
  source server ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountID"`: The request to change the source server migration account ID.
"""
function change_server_life_cycle_state(
    lifeCycle, sourceServerID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "POST",
        "/ChangeServerLifeCycleState",
        Dict{String,Any}("lifeCycle" => lifeCycle, "sourceServerID" => sourceServerID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function change_server_life_cycle_state(
    lifeCycle,
    sourceServerID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mgn(
        "POST",
        "/ChangeServerLifeCycleState",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "lifeCycle" => lifeCycle, "sourceServerID" => sourceServerID
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_application(name)
    create_application(name, params::Dict{String,<:Any})

Create application.

# Arguments
- `name`: Application name.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountID"`: Account ID.
- `"description"`: Application description.
- `"tags"`: Application tags.
"""
function create_application(name; aws_config::AbstractAWSConfig=current_aws_config())
    return mgn(
        "POST",
        "/CreateApplication",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_application(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "POST",
        "/CreateApplication",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_connector(name, ssm_instance_id)
    create_connector(name, ssm_instance_id, params::Dict{String,<:Any})

Create Connector.

# Arguments
- `name`: Create Connector request name.
- `ssm_instance_id`: Create Connector request SSM instance ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ssmCommandConfig"`: Create Connector request SSM command config.
- `"tags"`: Create Connector request tags.
"""
function create_connector(
    name, ssmInstanceID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "POST",
        "/CreateConnector",
        Dict{String,Any}("name" => name, "ssmInstanceID" => ssmInstanceID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_connector(
    name,
    ssmInstanceID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mgn(
        "POST",
        "/CreateConnector",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("name" => name, "ssmInstanceID" => ssmInstanceID),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_launch_configuration_template()
    create_launch_configuration_template(params::Dict{String,<:Any})

Creates a new Launch Configuration Template.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"associatePublicIpAddress"`: Associate public Ip address.
- `"bootMode"`: Launch configuration template boot mode.
- `"copyPrivateIp"`: Copy private Ip.
- `"copyTags"`: Copy tags.
- `"enableMapAutoTagging"`: Enable map auto tagging.
- `"largeVolumeConf"`: Large volume config.
- `"launchDisposition"`: Launch disposition.
- `"licensing"`:
- `"mapAutoTaggingMpeID"`: Launch configuration template map auto tagging MPE ID.
- `"postLaunchActions"`: Launch configuration template post launch actions.
- `"smallVolumeConf"`: Small volume config.
- `"smallVolumeMaxSize"`: Small volume maximum size.
- `"tags"`: Request to associate tags during creation of a Launch Configuration Template.
- `"targetInstanceTypeRightSizingMethod"`: Target instance type right-sizing method.
"""
function create_launch_configuration_template(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "POST",
        "/CreateLaunchConfigurationTemplate";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_launch_configuration_template(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "POST",
        "/CreateLaunchConfigurationTemplate",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_replication_configuration_template(associate_default_security_group, bandwidth_throttling, create_public_ip, data_plane_routing, default_large_staging_disk_type, ebs_encryption, replication_server_instance_type, replication_servers_security_groups_ids, staging_area_subnet_id, staging_area_tags, use_dedicated_replication_server)
    create_replication_configuration_template(associate_default_security_group, bandwidth_throttling, create_public_ip, data_plane_routing, default_large_staging_disk_type, ebs_encryption, replication_server_instance_type, replication_servers_security_groups_ids, staging_area_subnet_id, staging_area_tags, use_dedicated_replication_server, params::Dict{String,<:Any})

Creates a new ReplicationConfigurationTemplate.

# Arguments
- `associate_default_security_group`: Request to associate the default Application
  Migration Service Security group with the Replication Settings template.
- `bandwidth_throttling`: Request to configure bandwidth throttling during Replication
  Settings template creation.
- `create_public_ip`: Request to create Public IP during Replication Settings template
  creation.
- `data_plane_routing`: Request to configure data plane routing during Replication Settings
  template creation.
- `default_large_staging_disk_type`: Request to configure the default large staging disk
  EBS volume type during Replication Settings template creation.
- `ebs_encryption`: Request to configure EBS encryption during Replication Settings
  template creation.
- `replication_server_instance_type`: Request to configure the Replication Server instance
  type during Replication Settings template creation.
- `replication_servers_security_groups_ids`: Request to configure the Replication Server
  Security group ID during Replication Settings template creation.
- `staging_area_subnet_id`: Request to configure the Staging Area subnet ID during
  Replication Settings template creation.
- `staging_area_tags`: Request to configure Staging Area tags during Replication Settings
  template creation.
- `use_dedicated_replication_server`: Request to use Dedicated Replication Servers during
  Replication Settings template creation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ebsEncryptionKeyArn"`: Request to configure an EBS encryption key during Replication
  Settings template creation.
- `"tags"`: Request to configure tags during Replication Settings template creation.
- `"useFipsEndpoint"`: Request to use Fips Endpoint during Replication Settings template
  creation.
"""
function create_replication_configuration_template(
    associateDefaultSecurityGroup,
    bandwidthThrottling,
    createPublicIP,
    dataPlaneRouting,
    defaultLargeStagingDiskType,
    ebsEncryption,
    replicationServerInstanceType,
    replicationServersSecurityGroupsIDs,
    stagingAreaSubnetId,
    stagingAreaTags,
    useDedicatedReplicationServer;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mgn(
        "POST",
        "/CreateReplicationConfigurationTemplate",
        Dict{String,Any}(
            "associateDefaultSecurityGroup" => associateDefaultSecurityGroup,
            "bandwidthThrottling" => bandwidthThrottling,
            "createPublicIP" => createPublicIP,
            "dataPlaneRouting" => dataPlaneRouting,
            "defaultLargeStagingDiskType" => defaultLargeStagingDiskType,
            "ebsEncryption" => ebsEncryption,
            "replicationServerInstanceType" => replicationServerInstanceType,
            "replicationServersSecurityGroupsIDs" => replicationServersSecurityGroupsIDs,
            "stagingAreaSubnetId" => stagingAreaSubnetId,
            "stagingAreaTags" => stagingAreaTags,
            "useDedicatedReplicationServer" => useDedicatedReplicationServer,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_replication_configuration_template(
    associateDefaultSecurityGroup,
    bandwidthThrottling,
    createPublicIP,
    dataPlaneRouting,
    defaultLargeStagingDiskType,
    ebsEncryption,
    replicationServerInstanceType,
    replicationServersSecurityGroupsIDs,
    stagingAreaSubnetId,
    stagingAreaTags,
    useDedicatedReplicationServer,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mgn(
        "POST",
        "/CreateReplicationConfigurationTemplate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "associateDefaultSecurityGroup" => associateDefaultSecurityGroup,
                    "bandwidthThrottling" => bandwidthThrottling,
                    "createPublicIP" => createPublicIP,
                    "dataPlaneRouting" => dataPlaneRouting,
                    "defaultLargeStagingDiskType" => defaultLargeStagingDiskType,
                    "ebsEncryption" => ebsEncryption,
                    "replicationServerInstanceType" => replicationServerInstanceType,
                    "replicationServersSecurityGroupsIDs" =>
                        replicationServersSecurityGroupsIDs,
                    "stagingAreaSubnetId" => stagingAreaSubnetId,
                    "stagingAreaTags" => stagingAreaTags,
                    "useDedicatedReplicationServer" => useDedicatedReplicationServer,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_wave(name)
    create_wave(name, params::Dict{String,<:Any})

Create wave.

# Arguments
- `name`: Wave name.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountID"`: Account ID.
- `"description"`: Wave description.
- `"tags"`: Wave tags.
"""
function create_wave(name; aws_config::AbstractAWSConfig=current_aws_config())
    return mgn(
        "POST",
        "/CreateWave",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_wave(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "POST",
        "/CreateWave",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_application(application_id)
    delete_application(application_id, params::Dict{String,<:Any})

Delete application.

# Arguments
- `application_id`: Application ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountID"`: Account ID.
"""
function delete_application(
    applicationID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "POST",
        "/DeleteApplication",
        Dict{String,Any}("applicationID" => applicationID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_application(
    applicationID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mgn(
        "POST",
        "/DeleteApplication",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("applicationID" => applicationID), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_connector(connector_id)
    delete_connector(connector_id, params::Dict{String,<:Any})

Delete Connector.

# Arguments
- `connector_id`: Delete Connector request connector ID.

"""
function delete_connector(connectorID; aws_config::AbstractAWSConfig=current_aws_config())
    return mgn(
        "POST",
        "/DeleteConnector",
        Dict{String,Any}("connectorID" => connectorID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_connector(
    connectorID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mgn(
        "POST",
        "/DeleteConnector",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("connectorID" => connectorID), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_job(job_id)
    delete_job(job_id, params::Dict{String,<:Any})

Deletes a single Job by ID.

# Arguments
- `job_id`: Request to delete Job from service by Job ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountID"`: Request to delete Job from service by Account ID.
"""
function delete_job(jobID; aws_config::AbstractAWSConfig=current_aws_config())
    return mgn(
        "POST",
        "/DeleteJob",
        Dict{String,Any}("jobID" => jobID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_job(
    jobID, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "POST",
        "/DeleteJob",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("jobID" => jobID), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_launch_configuration_template(launch_configuration_template_id)
    delete_launch_configuration_template(launch_configuration_template_id, params::Dict{String,<:Any})

Deletes a single Launch Configuration Template by ID.

# Arguments
- `launch_configuration_template_id`: ID of resource to be deleted.

"""
function delete_launch_configuration_template(
    launchConfigurationTemplateID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "POST",
        "/DeleteLaunchConfigurationTemplate",
        Dict{String,Any}("launchConfigurationTemplateID" => launchConfigurationTemplateID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_launch_configuration_template(
    launchConfigurationTemplateID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mgn(
        "POST",
        "/DeleteLaunchConfigurationTemplate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "launchConfigurationTemplateID" => launchConfigurationTemplateID
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_replication_configuration_template(replication_configuration_template_id)
    delete_replication_configuration_template(replication_configuration_template_id, params::Dict{String,<:Any})

Deletes a single Replication Configuration Template by ID

# Arguments
- `replication_configuration_template_id`: Request to delete Replication Configuration
  Template from service by Replication Configuration Template ID.

"""
function delete_replication_configuration_template(
    replicationConfigurationTemplateID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "POST",
        "/DeleteReplicationConfigurationTemplate",
        Dict{String,Any}(
            "replicationConfigurationTemplateID" => replicationConfigurationTemplateID
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_replication_configuration_template(
    replicationConfigurationTemplateID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mgn(
        "POST",
        "/DeleteReplicationConfigurationTemplate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "replicationConfigurationTemplateID" =>
                        replicationConfigurationTemplateID,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_source_server(source_server_id)
    delete_source_server(source_server_id, params::Dict{String,<:Any})

Deletes a single source server by ID.

# Arguments
- `source_server_id`: Request to delete Source Server from service by Server ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountID"`: Request to delete Source Server from service by Account ID.
"""
function delete_source_server(
    sourceServerID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "POST",
        "/DeleteSourceServer",
        Dict{String,Any}("sourceServerID" => sourceServerID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_source_server(
    sourceServerID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mgn(
        "POST",
        "/DeleteSourceServer",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("sourceServerID" => sourceServerID), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_vcenter_client(vcenter_client_id)
    delete_vcenter_client(vcenter_client_id, params::Dict{String,<:Any})

Deletes a given vCenter client by ID.

# Arguments
- `vcenter_client_id`: ID of resource to be deleted.

"""
function delete_vcenter_client(
    vcenterClientID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "POST",
        "/DeleteVcenterClient",
        Dict{String,Any}("vcenterClientID" => vcenterClientID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_vcenter_client(
    vcenterClientID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mgn(
        "POST",
        "/DeleteVcenterClient",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("vcenterClientID" => vcenterClientID), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_wave(wave_id)
    delete_wave(wave_id, params::Dict{String,<:Any})

Delete wave.

# Arguments
- `wave_id`: Wave ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountID"`: Account ID.
"""
function delete_wave(waveID; aws_config::AbstractAWSConfig=current_aws_config())
    return mgn(
        "POST",
        "/DeleteWave",
        Dict{String,Any}("waveID" => waveID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_wave(
    waveID, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "POST",
        "/DeleteWave",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("waveID" => waveID), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_job_log_items(job_id)
    describe_job_log_items(job_id, params::Dict{String,<:Any})

Retrieves detailed job log items with paging.

# Arguments
- `job_id`: Request to describe Job log job ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountID"`: Request to describe Job log Account ID.
- `"maxResults"`: Request to describe Job log item maximum results.
- `"nextToken"`: Request to describe Job log next token.
"""
function describe_job_log_items(jobID; aws_config::AbstractAWSConfig=current_aws_config())
    return mgn(
        "POST",
        "/DescribeJobLogItems",
        Dict{String,Any}("jobID" => jobID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_job_log_items(
    jobID, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "POST",
        "/DescribeJobLogItems",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("jobID" => jobID), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_jobs()
    describe_jobs(params::Dict{String,<:Any})

Returns a list of Jobs. Use the JobsID and fromDate and toData filters to limit which jobs
are returned. The response is sorted by creationDataTime - latest date first. Jobs are
normally created by the StartTest, StartCutover, and TerminateTargetInstances APIs. Jobs
are also created by DiagnosticLaunch and TerminateDiagnosticInstances, which are APIs
available only to *Support* and only used in response to relevant support tickets.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountID"`: Request to describe job log items by Account ID.
- `"filters"`: Request to describe Job log filters.
- `"maxResults"`: Request to describe job log items by max results.
- `"nextToken"`: Request to describe job log items by next token.
"""
function describe_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return mgn(
        "POST", "/DescribeJobs"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "POST",
        "/DescribeJobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_launch_configuration_templates()
    describe_launch_configuration_templates(params::Dict{String,<:Any})

Lists all Launch Configuration Templates, filtered by Launch Configuration Template IDs

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"launchConfigurationTemplateIDs"`: Request to filter Launch Configuration Templates list
  by Launch Configuration Template ID.
- `"maxResults"`: Maximum results to be returned in DescribeLaunchConfigurationTemplates.
- `"nextToken"`: Next pagination token returned from DescribeLaunchConfigurationTemplates.
"""
function describe_launch_configuration_templates(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "POST",
        "/DescribeLaunchConfigurationTemplates";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_launch_configuration_templates(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "POST",
        "/DescribeLaunchConfigurationTemplates",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_replication_configuration_templates()
    describe_replication_configuration_templates(params::Dict{String,<:Any})

Lists all ReplicationConfigurationTemplates, filtered by Source Server IDs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Request to describe Replication Configuration template by max results.
- `"nextToken"`: Request to describe Replication Configuration template by next token.
- `"replicationConfigurationTemplateIDs"`: Request to describe Replication Configuration
  template by template IDs.
"""
function describe_replication_configuration_templates(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "POST",
        "/DescribeReplicationConfigurationTemplates";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_replication_configuration_templates(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "POST",
        "/DescribeReplicationConfigurationTemplates",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_source_servers()
    describe_source_servers(params::Dict{String,<:Any})

Retrieves all SourceServers or multiple SourceServers by ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountID"`: Request to filter Source Servers list by Accoun ID.
- `"filters"`: Request to filter Source Servers list.
- `"maxResults"`: Request to filter Source Servers list by maximum results.
- `"nextToken"`: Request to filter Source Servers list by next token.
"""
function describe_source_servers(; aws_config::AbstractAWSConfig=current_aws_config())
    return mgn(
        "POST",
        "/DescribeSourceServers";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_source_servers(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "POST",
        "/DescribeSourceServers",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_vcenter_clients()
    describe_vcenter_clients(params::Dict{String,<:Any})

Returns a list of the installed vCenter clients.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Maximum results to be returned in DescribeVcenterClients.
- `"nextToken"`: Next pagination token to be provided for DescribeVcenterClients.
"""
function describe_vcenter_clients(; aws_config::AbstractAWSConfig=current_aws_config())
    return mgn(
        "GET",
        "/DescribeVcenterClients";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_vcenter_clients(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "GET",
        "/DescribeVcenterClients",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_applications(application_ids, wave_id)
    disassociate_applications(application_ids, wave_id, params::Dict{String,<:Any})

Disassociate applications from wave.

# Arguments
- `application_ids`: Application IDs list.
- `wave_id`: Wave ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountID"`: Account ID.
"""
function disassociate_applications(
    applicationIDs, waveID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "POST",
        "/DisassociateApplications",
        Dict{String,Any}("applicationIDs" => applicationIDs, "waveID" => waveID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_applications(
    applicationIDs,
    waveID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mgn(
        "POST",
        "/DisassociateApplications",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("applicationIDs" => applicationIDs, "waveID" => waveID),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_source_servers(application_id, source_server_ids)
    disassociate_source_servers(application_id, source_server_ids, params::Dict{String,<:Any})

Disassociate source servers from application.

# Arguments
- `application_id`: Application ID.
- `source_server_ids`: Source server IDs list.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountID"`: Account ID.
"""
function disassociate_source_servers(
    applicationID, sourceServerIDs; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "POST",
        "/DisassociateSourceServers",
        Dict{String,Any}(
            "applicationID" => applicationID, "sourceServerIDs" => sourceServerIDs
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_source_servers(
    applicationID,
    sourceServerIDs,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mgn(
        "POST",
        "/DisassociateSourceServers",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "applicationID" => applicationID, "sourceServerIDs" => sourceServerIDs
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disconnect_from_service(source_server_id)
    disconnect_from_service(source_server_id, params::Dict{String,<:Any})

Disconnects specific Source Servers from Application Migration Service. Data replication is
stopped immediately. All AWS resources created by Application Migration Service for
enabling the replication of these source servers will be terminated / deleted within 90
minutes. Launched Test or Cutover instances will NOT be terminated. If the agent on the
source server has not been prevented from communicating with the Application Migration
Service service, then it will receive a command to uninstall itself (within approximately
10 minutes). The following properties of the SourceServer will be changed immediately:
dataReplicationInfo.dataReplicationState will be set to DISCONNECTED; The totalStorageBytes
property for each of dataReplicationInfo.replicatedDisks will be set to zero;
dataReplicationInfo.lagDuration and dataReplicationInfo.lagDuration will be nullified.

# Arguments
- `source_server_id`: Request to disconnect Source Server from service by Server ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountID"`: Request to disconnect Source Server from service by Account ID.
"""
function disconnect_from_service(
    sourceServerID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "POST",
        "/DisconnectFromService",
        Dict{String,Any}("sourceServerID" => sourceServerID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disconnect_from_service(
    sourceServerID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mgn(
        "POST",
        "/DisconnectFromService",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("sourceServerID" => sourceServerID), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    finalize_cutover(source_server_id)
    finalize_cutover(source_server_id, params::Dict{String,<:Any})

Finalizes the cutover immediately for specific Source Servers. All AWS resources created by
Application Migration Service for enabling the replication of these source servers will be
terminated / deleted within 90 minutes. Launched Test or Cutover instances will NOT be
terminated. The AWS Replication Agent will receive a command to uninstall itself (within 10
minutes). The following properties of the SourceServer will be changed immediately:
dataReplicationInfo.dataReplicationState will be changed to DISCONNECTED; The
SourceServer.lifeCycle.state will be changed to CUTOVER; The totalStorageBytes property fo
each of dataReplicationInfo.replicatedDisks will be set to zero;
dataReplicationInfo.lagDuration and dataReplicationInfo.lagDuration will be nullified.

# Arguments
- `source_server_id`: Request to finalize Cutover by Source Server ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountID"`: Request to finalize Cutover by Source Account ID.
"""
function finalize_cutover(
    sourceServerID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "POST",
        "/FinalizeCutover",
        Dict{String,Any}("sourceServerID" => sourceServerID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function finalize_cutover(
    sourceServerID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mgn(
        "POST",
        "/FinalizeCutover",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("sourceServerID" => sourceServerID), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_launch_configuration(source_server_id)
    get_launch_configuration(source_server_id, params::Dict{String,<:Any})

Lists all LaunchConfigurations available, filtered by Source Server IDs.

# Arguments
- `source_server_id`: Request to get Launch Configuration information by Source Server ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountID"`: Request to get Launch Configuration information by Account ID.
"""
function get_launch_configuration(
    sourceServerID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "POST",
        "/GetLaunchConfiguration",
        Dict{String,Any}("sourceServerID" => sourceServerID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_launch_configuration(
    sourceServerID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mgn(
        "POST",
        "/GetLaunchConfiguration",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("sourceServerID" => sourceServerID), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_replication_configuration(source_server_id)
    get_replication_configuration(source_server_id, params::Dict{String,<:Any})

Lists all ReplicationConfigurations, filtered by Source Server ID.

# Arguments
- `source_server_id`: Request to get Replication Configuration by Source Server ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountID"`: Request to get Replication Configuration by Account ID.
"""
function get_replication_configuration(
    sourceServerID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "POST",
        "/GetReplicationConfiguration",
        Dict{String,Any}("sourceServerID" => sourceServerID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_replication_configuration(
    sourceServerID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mgn(
        "POST",
        "/GetReplicationConfiguration",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("sourceServerID" => sourceServerID), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    initialize_service()
    initialize_service(params::Dict{String,<:Any})

Initialize Application Migration Service.

"""
function initialize_service(; aws_config::AbstractAWSConfig=current_aws_config())
    return mgn(
        "POST", "/InitializeService"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function initialize_service(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "POST",
        "/InitializeService",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_applications()
    list_applications(params::Dict{String,<:Any})

Retrieves all applications or multiple applications by ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountID"`: Applications list Account ID.
- `"filters"`: Applications list filters.
- `"maxResults"`: Maximum results to return when listing applications.
- `"nextToken"`: Request next token.
"""
function list_applications(; aws_config::AbstractAWSConfig=current_aws_config())
    return mgn(
        "POST", "/ListApplications"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_applications(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "POST",
        "/ListApplications",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_connectors()
    list_connectors(params::Dict{String,<:Any})

List Connectors.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: List Connectors Request filters.
- `"maxResults"`: List Connectors Request max results.
- `"nextToken"`: List Connectors Request next token.
"""
function list_connectors(; aws_config::AbstractAWSConfig=current_aws_config())
    return mgn(
        "POST", "/ListConnectors"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_connectors(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "POST",
        "/ListConnectors",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_export_errors(export_id)
    list_export_errors(export_id, params::Dict{String,<:Any})

List export errors.

# Arguments
- `export_id`: List export errors request export id.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: List export errors request max results.
- `"nextToken"`: List export errors request next token.
"""
function list_export_errors(exportID; aws_config::AbstractAWSConfig=current_aws_config())
    return mgn(
        "POST",
        "/ListExportErrors",
        Dict{String,Any}("exportID" => exportID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_export_errors(
    exportID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mgn(
        "POST",
        "/ListExportErrors",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("exportID" => exportID), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_exports()
    list_exports(params::Dict{String,<:Any})

List exports.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`:
- `"maxResults"`: List export request max results.
- `"nextToken"`: List export request next token.
"""
function list_exports(; aws_config::AbstractAWSConfig=current_aws_config())
    return mgn(
        "POST", "/ListExports"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_exports(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "POST",
        "/ListExports",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_import_errors(import_id)
    list_import_errors(import_id, params::Dict{String,<:Any})

List import errors.

# Arguments
- `import_id`: List import errors request import id.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: List import errors request max results.
- `"nextToken"`: List import errors request next token.
"""
function list_import_errors(importID; aws_config::AbstractAWSConfig=current_aws_config())
    return mgn(
        "POST",
        "/ListImportErrors",
        Dict{String,Any}("importID" => importID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_import_errors(
    importID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mgn(
        "POST",
        "/ListImportErrors",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("importID" => importID), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_imports()
    list_imports(params::Dict{String,<:Any})

List imports.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: List imports request filters.
- `"maxResults"`: List imports request max results.
- `"nextToken"`: List imports request next token.
"""
function list_imports(; aws_config::AbstractAWSConfig=current_aws_config())
    return mgn(
        "POST", "/ListImports"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_imports(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "POST",
        "/ListImports",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_managed_accounts()
    list_managed_accounts(params::Dict{String,<:Any})

List Managed Accounts.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: List managed accounts request max results.
- `"nextToken"`: List managed accounts request next token.
"""
function list_managed_accounts(; aws_config::AbstractAWSConfig=current_aws_config())
    return mgn(
        "POST",
        "/ListManagedAccounts";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_managed_accounts(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "POST",
        "/ListManagedAccounts",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_source_server_actions(source_server_id)
    list_source_server_actions(source_server_id, params::Dict{String,<:Any})

List source server post migration custom actions.

# Arguments
- `source_server_id`: Source server ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountID"`: Account ID to return when listing source server post migration custom
  actions.
- `"filters"`: Filters to apply when listing source server post migration custom actions.
- `"maxResults"`: Maximum amount of items to return when listing source server post
  migration custom actions.
- `"nextToken"`: Next token to use when listing source server post migration custom actions.
"""
function list_source_server_actions(
    sourceServerID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "POST",
        "/ListSourceServerActions",
        Dict{String,Any}("sourceServerID" => sourceServerID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_source_server_actions(
    sourceServerID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mgn(
        "POST",
        "/ListSourceServerActions",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("sourceServerID" => sourceServerID), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

List all tags for your Application Migration Service resources.

# Arguments
- `resource_arn`: List tags for resource request by ARN.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mgn(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_template_actions(launch_configuration_template_id)
    list_template_actions(launch_configuration_template_id, params::Dict{String,<:Any})

List template post migration custom actions.

# Arguments
- `launch_configuration_template_id`: Launch configuration template ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: Filters to apply when listing template post migration custom actions.
- `"maxResults"`: Maximum amount of items to return when listing template post migration
  custom actions.
- `"nextToken"`: Next token to use when listing template post migration custom actions.
"""
function list_template_actions(
    launchConfigurationTemplateID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "POST",
        "/ListTemplateActions",
        Dict{String,Any}("launchConfigurationTemplateID" => launchConfigurationTemplateID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_template_actions(
    launchConfigurationTemplateID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mgn(
        "POST",
        "/ListTemplateActions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "launchConfigurationTemplateID" => launchConfigurationTemplateID
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_waves()
    list_waves(params::Dict{String,<:Any})

Retrieves all waves or multiple waves by ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountID"`: Request account ID.
- `"filters"`: Waves list filters.
- `"maxResults"`: Maximum results to return when listing waves.
- `"nextToken"`: Request next token.
"""
function list_waves(; aws_config::AbstractAWSConfig=current_aws_config())
    return mgn("POST", "/ListWaves"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_waves(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "POST", "/ListWaves", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    mark_as_archived(source_server_id)
    mark_as_archived(source_server_id, params::Dict{String,<:Any})

Archives specific Source Servers by setting the SourceServer.isArchived property to true
for specified SourceServers by ID. This command only works for SourceServers with a
lifecycle. state which equals DISCONNECTED or CUTOVER.

# Arguments
- `source_server_id`: Mark as archived by Source Server ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountID"`: Mark as archived by Account ID.
"""
function mark_as_archived(
    sourceServerID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "POST",
        "/MarkAsArchived",
        Dict{String,Any}("sourceServerID" => sourceServerID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function mark_as_archived(
    sourceServerID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mgn(
        "POST",
        "/MarkAsArchived",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("sourceServerID" => sourceServerID), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    pause_replication(source_server_id)
    pause_replication(source_server_id, params::Dict{String,<:Any})

Pause Replication.

# Arguments
- `source_server_id`: Pause Replication Request source server ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountID"`: Pause Replication Request account ID.
"""
function pause_replication(
    sourceServerID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "POST",
        "/PauseReplication",
        Dict{String,Any}("sourceServerID" => sourceServerID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function pause_replication(
    sourceServerID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mgn(
        "POST",
        "/PauseReplication",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("sourceServerID" => sourceServerID), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_source_server_action(action_id, action_name, document_identifier, order, source_server_id)
    put_source_server_action(action_id, action_name, document_identifier, order, source_server_id, params::Dict{String,<:Any})

Put source server post migration custom action.

# Arguments
- `action_id`: Source server post migration custom action ID.
- `action_name`: Source server post migration custom action name.
- `document_identifier`: Source server post migration custom action document identifier.
- `order`: Source server post migration custom action order.
- `source_server_id`: Source server ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountID"`: Source server post migration custom account ID.
- `"active"`: Source server post migration custom action active status.
- `"category"`: Source server post migration custom action category.
- `"description"`: Source server post migration custom action description.
- `"documentVersion"`: Source server post migration custom action document version.
- `"externalParameters"`: Source server post migration custom action external parameters.
- `"mustSucceedForCutover"`: Source server post migration custom action must succeed for
  cutover.
- `"parameters"`: Source server post migration custom action parameters.
- `"timeoutSeconds"`: Source server post migration custom action timeout in seconds.
"""
function put_source_server_action(
    actionID,
    actionName,
    documentIdentifier,
    order,
    sourceServerID;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mgn(
        "POST",
        "/PutSourceServerAction",
        Dict{String,Any}(
            "actionID" => actionID,
            "actionName" => actionName,
            "documentIdentifier" => documentIdentifier,
            "order" => order,
            "sourceServerID" => sourceServerID,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_source_server_action(
    actionID,
    actionName,
    documentIdentifier,
    order,
    sourceServerID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mgn(
        "POST",
        "/PutSourceServerAction",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "actionID" => actionID,
                    "actionName" => actionName,
                    "documentIdentifier" => documentIdentifier,
                    "order" => order,
                    "sourceServerID" => sourceServerID,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_template_action(action_id, action_name, document_identifier, launch_configuration_template_id, order)
    put_template_action(action_id, action_name, document_identifier, launch_configuration_template_id, order, params::Dict{String,<:Any})

Put template post migration custom action.

# Arguments
- `action_id`: Template post migration custom action ID.
- `action_name`: Template post migration custom action name.
- `document_identifier`: Template post migration custom action document identifier.
- `launch_configuration_template_id`: Launch configuration template ID.
- `order`: Template post migration custom action order.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"active"`: Template post migration custom action active status.
- `"category"`: Template post migration custom action category.
- `"description"`: Template post migration custom action description.
- `"documentVersion"`: Template post migration custom action document version.
- `"externalParameters"`: Template post migration custom action external parameters.
- `"mustSucceedForCutover"`: Template post migration custom action must succeed for cutover.
- `"operatingSystem"`: Operating system eligible for this template post migration custom
  action.
- `"parameters"`: Template post migration custom action parameters.
- `"timeoutSeconds"`: Template post migration custom action timeout in seconds.
"""
function put_template_action(
    actionID,
    actionName,
    documentIdentifier,
    launchConfigurationTemplateID,
    order;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mgn(
        "POST",
        "/PutTemplateAction",
        Dict{String,Any}(
            "actionID" => actionID,
            "actionName" => actionName,
            "documentIdentifier" => documentIdentifier,
            "launchConfigurationTemplateID" => launchConfigurationTemplateID,
            "order" => order,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_template_action(
    actionID,
    actionName,
    documentIdentifier,
    launchConfigurationTemplateID,
    order,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mgn(
        "POST",
        "/PutTemplateAction",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "actionID" => actionID,
                    "actionName" => actionName,
                    "documentIdentifier" => documentIdentifier,
                    "launchConfigurationTemplateID" => launchConfigurationTemplateID,
                    "order" => order,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_source_server_action(action_id, source_server_id)
    remove_source_server_action(action_id, source_server_id, params::Dict{String,<:Any})

Remove source server post migration custom action.

# Arguments
- `action_id`: Source server post migration custom action ID to remove.
- `source_server_id`: Source server ID of the post migration custom action to remove.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountID"`: Source server post migration account ID.
"""
function remove_source_server_action(
    actionID, sourceServerID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "POST",
        "/RemoveSourceServerAction",
        Dict{String,Any}("actionID" => actionID, "sourceServerID" => sourceServerID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_source_server_action(
    actionID,
    sourceServerID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mgn(
        "POST",
        "/RemoveSourceServerAction",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "actionID" => actionID, "sourceServerID" => sourceServerID
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_template_action(action_id, launch_configuration_template_id)
    remove_template_action(action_id, launch_configuration_template_id, params::Dict{String,<:Any})

Remove template post migration custom action.

# Arguments
- `action_id`: Template post migration custom action ID to remove.
- `launch_configuration_template_id`: Launch configuration template ID of the post
  migration custom action to remove.

"""
function remove_template_action(
    actionID,
    launchConfigurationTemplateID;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mgn(
        "POST",
        "/RemoveTemplateAction",
        Dict{String,Any}(
            "actionID" => actionID,
            "launchConfigurationTemplateID" => launchConfigurationTemplateID,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_template_action(
    actionID,
    launchConfigurationTemplateID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mgn(
        "POST",
        "/RemoveTemplateAction",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "actionID" => actionID,
                    "launchConfigurationTemplateID" => launchConfigurationTemplateID,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    resume_replication(source_server_id)
    resume_replication(source_server_id, params::Dict{String,<:Any})

Resume Replication.

# Arguments
- `source_server_id`: Resume Replication Request source server ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountID"`: Resume Replication Request account ID.
"""
function resume_replication(
    sourceServerID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "POST",
        "/ResumeReplication",
        Dict{String,Any}("sourceServerID" => sourceServerID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function resume_replication(
    sourceServerID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mgn(
        "POST",
        "/ResumeReplication",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("sourceServerID" => sourceServerID), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    retry_data_replication(source_server_id)
    retry_data_replication(source_server_id, params::Dict{String,<:Any})

Causes the data replication initiation sequence to begin immediately upon next Handshake
for specified SourceServer IDs, regardless of when the previous initiation started. This
command will not work if the SourceServer is not stalled or is in a DISCONNECTED or STOPPED
state.

# Arguments
- `source_server_id`: Retry data replication for Source Server ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountID"`: Retry data replication for Account ID.
"""
function retry_data_replication(
    sourceServerID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "POST",
        "/RetryDataReplication",
        Dict{String,Any}("sourceServerID" => sourceServerID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function retry_data_replication(
    sourceServerID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mgn(
        "POST",
        "/RetryDataReplication",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("sourceServerID" => sourceServerID), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_cutover(source_server_ids)
    start_cutover(source_server_ids, params::Dict{String,<:Any})

Launches a Cutover Instance for specific Source Servers. This command starts a LAUNCH job
whose initiatedBy property is StartCutover and changes the SourceServer.lifeCycle.state
property to CUTTING_OVER.

# Arguments
- `source_server_ids`: Start Cutover by Source Server IDs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountID"`: Start Cutover by Account IDs
- `"tags"`: Start Cutover by Tags.
"""
function start_cutover(sourceServerIDs; aws_config::AbstractAWSConfig=current_aws_config())
    return mgn(
        "POST",
        "/StartCutover",
        Dict{String,Any}("sourceServerIDs" => sourceServerIDs);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_cutover(
    sourceServerIDs,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mgn(
        "POST",
        "/StartCutover",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("sourceServerIDs" => sourceServerIDs), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_export(s3_bucket, s3_key)
    start_export(s3_bucket, s3_key, params::Dict{String,<:Any})

Start export.

# Arguments
- `s3_bucket`: Start export request s3 bucket.
- `s3_key`: Start export request s3key.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"s3BucketOwner"`: Start export request s3 bucket owner.
"""
function start_export(s3Bucket, s3Key; aws_config::AbstractAWSConfig=current_aws_config())
    return mgn(
        "POST",
        "/StartExport",
        Dict{String,Any}("s3Bucket" => s3Bucket, "s3Key" => s3Key);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_export(
    s3Bucket,
    s3Key,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mgn(
        "POST",
        "/StartExport",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("s3Bucket" => s3Bucket, "s3Key" => s3Key), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_import(s3_bucket_source)
    start_import(s3_bucket_source, params::Dict{String,<:Any})

Start import.

# Arguments
- `s3_bucket_source`: Start import request s3 bucket source.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Start import request client token.
"""
function start_import(s3BucketSource; aws_config::AbstractAWSConfig=current_aws_config())
    return mgn(
        "POST",
        "/StartImport",
        Dict{String,Any}(
            "s3BucketSource" => s3BucketSource, "clientToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_import(
    s3BucketSource,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mgn(
        "POST",
        "/StartImport",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "s3BucketSource" => s3BucketSource, "clientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_replication(source_server_id)
    start_replication(source_server_id, params::Dict{String,<:Any})

Starts replication for SNAPSHOT_SHIPPING agents.

# Arguments
- `source_server_id`: ID of source server on which to start replication.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountID"`: Account ID on which to start replication.
"""
function start_replication(
    sourceServerID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "POST",
        "/StartReplication",
        Dict{String,Any}("sourceServerID" => sourceServerID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_replication(
    sourceServerID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mgn(
        "POST",
        "/StartReplication",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("sourceServerID" => sourceServerID), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_test(source_server_ids)
    start_test(source_server_ids, params::Dict{String,<:Any})

Launches a Test Instance for specific Source Servers. This command starts a LAUNCH job
whose initiatedBy property is StartTest and changes the SourceServer.lifeCycle.state
property to TESTING.

# Arguments
- `source_server_ids`: Start Test for Source Server IDs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountID"`: Start Test for Account ID.
- `"tags"`: Start Test by Tags.
"""
function start_test(sourceServerIDs; aws_config::AbstractAWSConfig=current_aws_config())
    return mgn(
        "POST",
        "/StartTest",
        Dict{String,Any}("sourceServerIDs" => sourceServerIDs);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_test(
    sourceServerIDs,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mgn(
        "POST",
        "/StartTest",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("sourceServerIDs" => sourceServerIDs), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_replication(source_server_id)
    stop_replication(source_server_id, params::Dict{String,<:Any})

Stop Replication.

# Arguments
- `source_server_id`: Stop Replication Request source server ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountID"`: Stop Replication Request account ID.
"""
function stop_replication(
    sourceServerID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "POST",
        "/StopReplication",
        Dict{String,Any}("sourceServerID" => sourceServerID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_replication(
    sourceServerID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mgn(
        "POST",
        "/StopReplication",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("sourceServerID" => sourceServerID), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds or overwrites only the specified tags for the specified Application Migration Service
resource or resources. When you specify an existing tag key, the value is overwritten with
the new value. Each resource can have a maximum of 50 tags. Each tag consists of a key and
optional value.

# Arguments
- `resource_arn`: Tag resource by ARN.
- `tags`: Tag resource by Tags.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return mgn(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mgn(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    terminate_target_instances(source_server_ids)
    terminate_target_instances(source_server_ids, params::Dict{String,<:Any})

Starts a job that terminates specific launched EC2 Test and Cutover instances. This command
will not work for any Source Server with a lifecycle.state of TESTING, CUTTING_OVER, or
CUTOVER.

# Arguments
- `source_server_ids`: Terminate Target instance by Source Server IDs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountID"`: Terminate Target instance by Account ID
- `"tags"`: Terminate Target instance by Tags.
"""
function terminate_target_instances(
    sourceServerIDs; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "POST",
        "/TerminateTargetInstances",
        Dict{String,Any}("sourceServerIDs" => sourceServerIDs);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function terminate_target_instances(
    sourceServerIDs,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mgn(
        "POST",
        "/TerminateTargetInstances",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("sourceServerIDs" => sourceServerIDs), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    unarchive_application(application_id)
    unarchive_application(application_id, params::Dict{String,<:Any})

Unarchive application.

# Arguments
- `application_id`: Application ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountID"`: Account ID.
"""
function unarchive_application(
    applicationID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "POST",
        "/UnarchiveApplication",
        Dict{String,Any}("applicationID" => applicationID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function unarchive_application(
    applicationID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mgn(
        "POST",
        "/UnarchiveApplication",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("applicationID" => applicationID), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    unarchive_wave(wave_id)
    unarchive_wave(wave_id, params::Dict{String,<:Any})

Unarchive wave.

# Arguments
- `wave_id`: Wave ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountID"`: Account ID.
"""
function unarchive_wave(waveID; aws_config::AbstractAWSConfig=current_aws_config())
    return mgn(
        "POST",
        "/UnarchiveWave",
        Dict{String,Any}("waveID" => waveID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function unarchive_wave(
    waveID, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "POST",
        "/UnarchiveWave",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("waveID" => waveID), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Deletes the specified set of tags from the specified set of Application Migration Service
resources.

# Arguments
- `resource_arn`: Untag resource by ARN.
- `tag_keys`: Untag resource by Keys.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mgn(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_application(application_id)
    update_application(application_id, params::Dict{String,<:Any})

Update application.

# Arguments
- `application_id`: Application ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountID"`: Account ID.
- `"description"`: Application description.
- `"name"`: Application name.
"""
function update_application(
    applicationID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "POST",
        "/UpdateApplication",
        Dict{String,Any}("applicationID" => applicationID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_application(
    applicationID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mgn(
        "POST",
        "/UpdateApplication",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("applicationID" => applicationID), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_connector(connector_id)
    update_connector(connector_id, params::Dict{String,<:Any})

Update Connector.

# Arguments
- `connector_id`: Update Connector request connector ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"name"`: Update Connector request name.
- `"ssmCommandConfig"`: Update Connector request SSM command config.
"""
function update_connector(connectorID; aws_config::AbstractAWSConfig=current_aws_config())
    return mgn(
        "POST",
        "/UpdateConnector",
        Dict{String,Any}("connectorID" => connectorID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_connector(
    connectorID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mgn(
        "POST",
        "/UpdateConnector",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("connectorID" => connectorID), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_launch_configuration(source_server_id)
    update_launch_configuration(source_server_id, params::Dict{String,<:Any})

Updates multiple LaunchConfigurations by Source Server ID.  bootMode valid values are
LEGACY_BIOS | UEFI

# Arguments
- `source_server_id`: Update Launch configuration by Source Server ID request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountID"`: Update Launch configuration Account ID.
- `"bootMode"`: Update Launch configuration boot mode request.
- `"copyPrivateIp"`: Update Launch configuration copy Private IP request.
- `"copyTags"`: Update Launch configuration copy Tags request.
- `"enableMapAutoTagging"`: Enable map auto tagging.
- `"launchDisposition"`: Update Launch configuration launch disposition request.
- `"licensing"`: Update Launch configuration licensing request.
- `"mapAutoTaggingMpeID"`: Launch configuration map auto tagging MPE ID.
- `"name"`: Update Launch configuration name request.
- `"postLaunchActions"`:
- `"targetInstanceTypeRightSizingMethod"`: Update Launch configuration Target instance
  right sizing request.
"""
function update_launch_configuration(
    sourceServerID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "POST",
        "/UpdateLaunchConfiguration",
        Dict{String,Any}("sourceServerID" => sourceServerID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_launch_configuration(
    sourceServerID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mgn(
        "POST",
        "/UpdateLaunchConfiguration",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("sourceServerID" => sourceServerID), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_launch_configuration_template(launch_configuration_template_id)
    update_launch_configuration_template(launch_configuration_template_id, params::Dict{String,<:Any})

Updates an existing Launch Configuration Template by ID.

# Arguments
- `launch_configuration_template_id`: Launch Configuration Template ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"associatePublicIpAddress"`: Associate public Ip address.
- `"bootMode"`: Launch configuration template boot mode.
- `"copyPrivateIp"`: Copy private Ip.
- `"copyTags"`: Copy tags.
- `"enableMapAutoTagging"`: Enable map auto tagging.
- `"largeVolumeConf"`: Large volume config.
- `"launchDisposition"`: Launch disposition.
- `"licensing"`:
- `"mapAutoTaggingMpeID"`: Launch configuration template map auto tagging MPE ID.
- `"postLaunchActions"`: Post Launch Action to execute on the Test or Cutover instance.
- `"smallVolumeConf"`: Small volume config.
- `"smallVolumeMaxSize"`: Small volume maximum size.
- `"targetInstanceTypeRightSizingMethod"`: Target instance type right-sizing method.
"""
function update_launch_configuration_template(
    launchConfigurationTemplateID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "POST",
        "/UpdateLaunchConfigurationTemplate",
        Dict{String,Any}("launchConfigurationTemplateID" => launchConfigurationTemplateID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_launch_configuration_template(
    launchConfigurationTemplateID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mgn(
        "POST",
        "/UpdateLaunchConfigurationTemplate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "launchConfigurationTemplateID" => launchConfigurationTemplateID
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_replication_configuration(source_server_id)
    update_replication_configuration(source_server_id, params::Dict{String,<:Any})

Allows you to update multiple ReplicationConfigurations by Source Server ID.

# Arguments
- `source_server_id`: Update replication configuration Source Server ID request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountID"`: Update replication configuration Account ID request.
- `"associateDefaultSecurityGroup"`: Update replication configuration associate default
  Application Migration Service Security group request.
- `"bandwidthThrottling"`: Update replication configuration bandwidth throttling request.
- `"createPublicIP"`: Update replication configuration create Public IP request.
- `"dataPlaneRouting"`: Update replication configuration data plane routing request.
- `"defaultLargeStagingDiskType"`: Update replication configuration use default large
  Staging Disk type request.
- `"ebsEncryption"`: Update replication configuration EBS encryption request.
- `"ebsEncryptionKeyArn"`: Update replication configuration EBS encryption key ARN request.
- `"name"`: Update replication configuration name request.
- `"replicatedDisks"`: Update replication configuration replicated disks request.
- `"replicationServerInstanceType"`: Update replication configuration Replication Server
  instance type request.
- `"replicationServersSecurityGroupsIDs"`: Update replication configuration Replication
  Server Security Groups IDs request.
- `"stagingAreaSubnetId"`: Update replication configuration Staging Area subnet request.
- `"stagingAreaTags"`: Update replication configuration Staging Area Tags request.
- `"useDedicatedReplicationServer"`: Update replication configuration use dedicated
  Replication Server request.
- `"useFipsEndpoint"`: Update replication configuration use Fips Endpoint.
"""
function update_replication_configuration(
    sourceServerID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "POST",
        "/UpdateReplicationConfiguration",
        Dict{String,Any}("sourceServerID" => sourceServerID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_replication_configuration(
    sourceServerID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mgn(
        "POST",
        "/UpdateReplicationConfiguration",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("sourceServerID" => sourceServerID), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_replication_configuration_template(replication_configuration_template_id)
    update_replication_configuration_template(replication_configuration_template_id, params::Dict{String,<:Any})

Updates multiple ReplicationConfigurationTemplates by ID.

# Arguments
- `replication_configuration_template_id`: Update replication configuration template
  template ID request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"arn"`: Update replication configuration template ARN request.
- `"associateDefaultSecurityGroup"`: Update replication configuration template associate
  default Application Migration Service Security group request.
- `"bandwidthThrottling"`: Update replication configuration template bandwidth throttling
  request.
- `"createPublicIP"`: Update replication configuration template create Public IP request.
- `"dataPlaneRouting"`: Update replication configuration template data plane routing
  request.
- `"defaultLargeStagingDiskType"`: Update replication configuration template use default
  large Staging Disk type request.
- `"ebsEncryption"`: Update replication configuration template EBS encryption request.
- `"ebsEncryptionKeyArn"`: Update replication configuration template EBS encryption key ARN
  request.
- `"replicationServerInstanceType"`: Update replication configuration template Replication
  Server instance type request.
- `"replicationServersSecurityGroupsIDs"`: Update replication configuration template
  Replication Server Security groups IDs request.
- `"stagingAreaSubnetId"`: Update replication configuration template Staging Area subnet ID
  request.
- `"stagingAreaTags"`: Update replication configuration template Staging Area Tags request.
- `"useDedicatedReplicationServer"`: Update replication configuration template use
  dedicated Replication Server request.
- `"useFipsEndpoint"`: Update replication configuration template use Fips Endpoint request.
"""
function update_replication_configuration_template(
    replicationConfigurationTemplateID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "POST",
        "/UpdateReplicationConfigurationTemplate",
        Dict{String,Any}(
            "replicationConfigurationTemplateID" => replicationConfigurationTemplateID
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_replication_configuration_template(
    replicationConfigurationTemplateID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mgn(
        "POST",
        "/UpdateReplicationConfigurationTemplate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "replicationConfigurationTemplateID" =>
                        replicationConfigurationTemplateID,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_source_server(source_server_id)
    update_source_server(source_server_id, params::Dict{String,<:Any})

Update Source Server.

# Arguments
- `source_server_id`: Update Source Server request source server ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountID"`: Update Source Server request account ID.
- `"connectorAction"`: Update Source Server request connector action.
"""
function update_source_server(
    sourceServerID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "POST",
        "/UpdateSourceServer",
        Dict{String,Any}("sourceServerID" => sourceServerID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_source_server(
    sourceServerID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mgn(
        "POST",
        "/UpdateSourceServer",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("sourceServerID" => sourceServerID), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_source_server_replication_type(replication_type, source_server_id)
    update_source_server_replication_type(replication_type, source_server_id, params::Dict{String,<:Any})

Allows you to change between the AGENT_BASED replication type and the SNAPSHOT_SHIPPING
replication type.

# Arguments
- `replication_type`: Replication type to which to update source server.
- `source_server_id`: ID of source server on which to update replication type.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountID"`: Account ID on which to update replication type.
"""
function update_source_server_replication_type(
    replicationType, sourceServerID; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "POST",
        "/UpdateSourceServerReplicationType",
        Dict{String,Any}(
            "replicationType" => replicationType, "sourceServerID" => sourceServerID
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_source_server_replication_type(
    replicationType,
    sourceServerID,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mgn(
        "POST",
        "/UpdateSourceServerReplicationType",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "replicationType" => replicationType, "sourceServerID" => sourceServerID
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_wave(wave_id)
    update_wave(wave_id, params::Dict{String,<:Any})

Update wave.

# Arguments
- `wave_id`: Wave ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountID"`: Account ID.
- `"description"`: Wave description.
- `"name"`: Wave name.
"""
function update_wave(waveID; aws_config::AbstractAWSConfig=current_aws_config())
    return mgn(
        "POST",
        "/UpdateWave",
        Dict{String,Any}("waveID" => waveID);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_wave(
    waveID, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mgn(
        "POST",
        "/UpdateWave",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("waveID" => waveID), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: pinpoint_sms_voice
using AWS.Compat
using AWS.UUIDs

"""
    create_configuration_set()
    create_configuration_set(params::Dict{String,<:Any})

Create a new configuration set. After you create the configuration set, you can add one or
more event destinations to it.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConfigurationSetName"`: The name that you want to give the configuration set.
"""
function create_configuration_set(; aws_config::AbstractAWSConfig=current_aws_config())
    return pinpoint_sms_voice(
        "POST",
        "/v1/sms-voice/configuration-sets";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_configuration_set(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice(
        "POST",
        "/v1/sms-voice/configuration-sets",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_configuration_set_event_destination(configuration_set_name)
    create_configuration_set_event_destination(configuration_set_name, params::Dict{String,<:Any})

Create a new event destination in a configuration set.

# Arguments
- `configuration_set_name`: ConfigurationSetName

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EventDestination"`:
- `"EventDestinationName"`: A name that identifies the event destination.
"""
function create_configuration_set_event_destination(
    ConfigurationSetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice(
        "POST",
        "/v1/sms-voice/configuration-sets/$(ConfigurationSetName)/event-destinations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_configuration_set_event_destination(
    ConfigurationSetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice(
        "POST",
        "/v1/sms-voice/configuration-sets/$(ConfigurationSetName)/event-destinations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_configuration_set(configuration_set_name)
    delete_configuration_set(configuration_set_name, params::Dict{String,<:Any})

Deletes an existing configuration set.

# Arguments
- `configuration_set_name`: ConfigurationSetName

"""
function delete_configuration_set(
    ConfigurationSetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice(
        "DELETE",
        "/v1/sms-voice/configuration-sets/$(ConfigurationSetName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_configuration_set(
    ConfigurationSetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice(
        "DELETE",
        "/v1/sms-voice/configuration-sets/$(ConfigurationSetName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_configuration_set_event_destination(configuration_set_name, event_destination_name)
    delete_configuration_set_event_destination(configuration_set_name, event_destination_name, params::Dict{String,<:Any})

Deletes an event destination in a configuration set.

# Arguments
- `configuration_set_name`: ConfigurationSetName
- `event_destination_name`: EventDestinationName

"""
function delete_configuration_set_event_destination(
    ConfigurationSetName,
    EventDestinationName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice(
        "DELETE",
        "/v1/sms-voice/configuration-sets/$(ConfigurationSetName)/event-destinations/$(EventDestinationName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_configuration_set_event_destination(
    ConfigurationSetName,
    EventDestinationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice(
        "DELETE",
        "/v1/sms-voice/configuration-sets/$(ConfigurationSetName)/event-destinations/$(EventDestinationName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_configuration_set_event_destinations(configuration_set_name)
    get_configuration_set_event_destinations(configuration_set_name, params::Dict{String,<:Any})

Obtain information about an event destination, including the types of events it reports,
the Amazon Resource Name (ARN) of the destination, and the name of the event destination.

# Arguments
- `configuration_set_name`: ConfigurationSetName

"""
function get_configuration_set_event_destinations(
    ConfigurationSetName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice(
        "GET",
        "/v1/sms-voice/configuration-sets/$(ConfigurationSetName)/event-destinations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_configuration_set_event_destinations(
    ConfigurationSetName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice(
        "GET",
        "/v1/sms-voice/configuration-sets/$(ConfigurationSetName)/event-destinations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_configuration_sets()
    list_configuration_sets(params::Dict{String,<:Any})

List all of the configuration sets associated with your Amazon Pinpoint account in the
current region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: A token returned from a previous call to the API that indicates the
  position in the list of results.
- `"PageSize"`: Used to specify the number of items that should be returned in the response.
"""
function list_configuration_sets(; aws_config::AbstractAWSConfig=current_aws_config())
    return pinpoint_sms_voice(
        "GET",
        "/v1/sms-voice/configuration-sets";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_configuration_sets(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice(
        "GET",
        "/v1/sms-voice/configuration-sets",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    send_voice_message()
    send_voice_message(params::Dict{String,<:Any})

Create a new voice message and send it to a recipient's phone number.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CallerId"`: The phone number that appears on recipients' devices when they receive the
  message.
- `"ConfigurationSetName"`: The name of the configuration set that you want to use to send
  the message.
- `"Content"`:
- `"DestinationPhoneNumber"`: The phone number that you want to send the voice message to.
- `"OriginationPhoneNumber"`: The phone number that Amazon Pinpoint should use to send the
  voice message. This isn't necessarily the phone number that appears on recipients' devices
  when they receive the message, because you can specify a CallerId parameter in the request.
"""
function send_voice_message(; aws_config::AbstractAWSConfig=current_aws_config())
    return pinpoint_sms_voice(
        "POST",
        "/v1/sms-voice/voice/message";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function send_voice_message(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pinpoint_sms_voice(
        "POST",
        "/v1/sms-voice/voice/message",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_configuration_set_event_destination(configuration_set_name, event_destination_name)
    update_configuration_set_event_destination(configuration_set_name, event_destination_name, params::Dict{String,<:Any})

Update an event destination in a configuration set. An event destination is a location that
you publish information about your voice calls to. For example, you can log an event to an
Amazon CloudWatch destination when a call fails.

# Arguments
- `configuration_set_name`: ConfigurationSetName
- `event_destination_name`: EventDestinationName

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EventDestination"`:
"""
function update_configuration_set_event_destination(
    ConfigurationSetName,
    EventDestinationName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice(
        "PUT",
        "/v1/sms-voice/configuration-sets/$(ConfigurationSetName)/event-destinations/$(EventDestinationName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_configuration_set_event_destination(
    ConfigurationSetName,
    EventDestinationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pinpoint_sms_voice(
        "PUT",
        "/v1/sms-voice/configuration-sets/$(ConfigurationSetName)/event-destinations/$(EventDestinationName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: outposts
using AWS.Compat
using AWS.UUIDs

"""
    cancel_capacity_task(capacity_task_id, outpost_id)
    cancel_capacity_task(capacity_task_id, outpost_id, params::Dict{String,<:Any})

Cancels the capacity task.

# Arguments
- `capacity_task_id`: ID of the capacity task that you want to cancel.
- `outpost_id`: ID or ARN of the Outpost associated with the capacity task that you want to
  cancel.

"""
function cancel_capacity_task(
    CapacityTaskId, OutpostId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return outposts(
        "POST",
        "/outposts/$(OutpostId)/capacity/$(CapacityTaskId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_capacity_task(
    CapacityTaskId,
    OutpostId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return outposts(
        "POST",
        "/outposts/$(OutpostId)/capacity/$(CapacityTaskId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_order(order_id)
    cancel_order(order_id, params::Dict{String,<:Any})

Cancels the specified order for an Outpost.

# Arguments
- `order_id`:  The ID of the order.

"""
function cancel_order(OrderId; aws_config::AbstractAWSConfig=current_aws_config())
    return outposts(
        "POST",
        "/orders/$(OrderId)/cancel";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_order(
    OrderId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return outposts(
        "POST",
        "/orders/$(OrderId)/cancel",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_order(line_items, outpost_identifier, payment_option)
    create_order(line_items, outpost_identifier, payment_option, params::Dict{String,<:Any})

Creates an order for an Outpost.

# Arguments
- `line_items`: The line items that make up the order.
- `outpost_identifier`:  The ID or the Amazon Resource Name (ARN) of the Outpost.
- `payment_option`: The payment option.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"PaymentTerm"`: The payment terms.
"""
function create_order(
    LineItems,
    OutpostIdentifier,
    PaymentOption;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return outposts(
        "POST",
        "/orders",
        Dict{String,Any}(
            "LineItems" => LineItems,
            "OutpostIdentifier" => OutpostIdentifier,
            "PaymentOption" => PaymentOption,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_order(
    LineItems,
    OutpostIdentifier,
    PaymentOption,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return outposts(
        "POST",
        "/orders",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "LineItems" => LineItems,
                    "OutpostIdentifier" => OutpostIdentifier,
                    "PaymentOption" => PaymentOption,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_outpost(name, site_id)
    create_outpost(name, site_id, params::Dict{String,<:Any})

Creates an Outpost. You can specify either an Availability one or an AZ ID.

# Arguments
- `name`:
- `site_id`:  The ID or the Amazon Resource Name (ARN) of the site.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AvailabilityZone"`:
- `"AvailabilityZoneId"`:
- `"Description"`:
- `"SupportedHardwareType"`:  The type of hardware for this Outpost.
- `"Tags"`: The tags to apply to the Outpost.
"""
function create_outpost(Name, SiteId; aws_config::AbstractAWSConfig=current_aws_config())
    return outposts(
        "POST",
        "/outposts",
        Dict{String,Any}("Name" => Name, "SiteId" => SiteId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_outpost(
    Name,
    SiteId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return outposts(
        "POST",
        "/outposts",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Name" => Name, "SiteId" => SiteId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_site(name)
    create_site(name, params::Dict{String,<:Any})

 Creates a site for an Outpost.

# Arguments
- `name`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`:
- `"Notes"`: Additional information that you provide about site access requirements,
  electrician scheduling, personal protective equipment, or regulation of equipment materials
  that could affect your installation process.
- `"OperatingAddress"`:  The location to install and power on the hardware. This address
  might be different from the shipping address.
- `"RackPhysicalProperties"`:  Information about the physical and logistical details for
  the rack at this site. For more information about hardware requirements for racks, see
  Network readiness checklist in the Amazon Web Services Outposts User Guide.
- `"ShippingAddress"`:  The location to ship the hardware. This address might be different
  from the operating address.
- `"Tags"`:  The tags to apply to a site.
"""
function create_site(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return outposts(
        "POST",
        "/sites",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_site(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return outposts(
        "POST",
        "/sites",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_outpost(outpost_id)
    delete_outpost(outpost_id, params::Dict{String,<:Any})

Deletes the specified Outpost.

# Arguments
- `outpost_id`:  The ID or ARN of the Outpost.

"""
function delete_outpost(OutpostId; aws_config::AbstractAWSConfig=current_aws_config())
    return outposts(
        "DELETE",
        "/outposts/$(OutpostId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_outpost(
    OutpostId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return outposts(
        "DELETE",
        "/outposts/$(OutpostId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_site(site_id)
    delete_site(site_id, params::Dict{String,<:Any})

Deletes the specified site.

# Arguments
- `site_id`:  The ID or the Amazon Resource Name (ARN) of the site.

"""
function delete_site(SiteId; aws_config::AbstractAWSConfig=current_aws_config())
    return outposts(
        "DELETE", "/sites/$(SiteId)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function delete_site(
    SiteId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return outposts(
        "DELETE",
        "/sites/$(SiteId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_capacity_task(capacity_task_id, outpost_id)
    get_capacity_task(capacity_task_id, outpost_id, params::Dict{String,<:Any})

Gets details of the specified capacity task.

# Arguments
- `capacity_task_id`: ID of the capacity task.
- `outpost_id`: ID or ARN of the Outpost associated with the specified capacity task.

"""
function get_capacity_task(
    CapacityTaskId, OutpostId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return outposts(
        "GET",
        "/outposts/$(OutpostId)/capacity/$(CapacityTaskId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_capacity_task(
    CapacityTaskId,
    OutpostId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return outposts(
        "GET",
        "/outposts/$(OutpostId)/capacity/$(CapacityTaskId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_catalog_item(catalog_item_id)
    get_catalog_item(catalog_item_id, params::Dict{String,<:Any})

Gets information about the specified catalog item.

# Arguments
- `catalog_item_id`: The ID of the catalog item.

"""
function get_catalog_item(CatalogItemId; aws_config::AbstractAWSConfig=current_aws_config())
    return outposts(
        "GET",
        "/catalog/item/$(CatalogItemId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_catalog_item(
    CatalogItemId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return outposts(
        "GET",
        "/catalog/item/$(CatalogItemId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_connection(connection_id)
    get_connection(connection_id, params::Dict{String,<:Any})

  Amazon Web Services uses this action to install Outpost servers.   Gets information about
the specified connection.   Use CloudTrail to monitor this action or Amazon Web Services
managed policy for Amazon Web Services Outposts to secure it. For more information, see
Amazon Web Services managed policies for Amazon Web Services Outposts and  Logging Amazon
Web Services Outposts API calls with Amazon Web Services CloudTrail in the Amazon Web
Services Outposts User Guide.

# Arguments
- `connection_id`:  The ID of the connection.

"""
function get_connection(ConnectionId; aws_config::AbstractAWSConfig=current_aws_config())
    return outposts(
        "GET",
        "/connections/$(ConnectionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_connection(
    ConnectionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return outposts(
        "GET",
        "/connections/$(ConnectionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_order(order_id)
    get_order(order_id, params::Dict{String,<:Any})

Gets information about the specified order.

# Arguments
- `order_id`: The ID of the order.

"""
function get_order(OrderId; aws_config::AbstractAWSConfig=current_aws_config())
    return outposts(
        "GET", "/orders/$(OrderId)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_order(
    OrderId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return outposts(
        "GET",
        "/orders/$(OrderId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_outpost(outpost_id)
    get_outpost(outpost_id, params::Dict{String,<:Any})

Gets information about the specified Outpost.

# Arguments
- `outpost_id`:  The ID or ARN of the Outpost.

"""
function get_outpost(OutpostId; aws_config::AbstractAWSConfig=current_aws_config())
    return outposts(
        "GET",
        "/outposts/$(OutpostId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_outpost(
    OutpostId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return outposts(
        "GET",
        "/outposts/$(OutpostId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_outpost_instance_types(outpost_id)
    get_outpost_instance_types(outpost_id, params::Dict{String,<:Any})

Gets the instance types for the specified Outpost.

# Arguments
- `outpost_id`:  The ID or ARN of the Outpost.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`:
- `"NextToken"`:
"""
function get_outpost_instance_types(
    OutpostId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return outposts(
        "GET",
        "/outposts/$(OutpostId)/instanceTypes";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_outpost_instance_types(
    OutpostId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return outposts(
        "GET",
        "/outposts/$(OutpostId)/instanceTypes",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_outpost_supported_instance_types(order_id, outpost_id)
    get_outpost_supported_instance_types(order_id, outpost_id, params::Dict{String,<:Any})

Gets the instance types that an Outpost can support in InstanceTypeCapacity. This will
generally include instance types that are not currently configured and therefore cannot be
launched with the current Outpost capacity configuration.

# Arguments
- `order_id`: The ID for the Amazon Web Services Outposts order.
- `outpost_id`: The ID or ARN of the Outpost.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`:
- `"NextToken"`:
"""
function get_outpost_supported_instance_types(
    OrderId, OutpostId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return outposts(
        "GET",
        "/outposts/$(OutpostId)/supportedInstanceTypes",
        Dict{String,Any}("OrderId" => OrderId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_outpost_supported_instance_types(
    OrderId,
    OutpostId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return outposts(
        "GET",
        "/outposts/$(OutpostId)/supportedInstanceTypes",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("OrderId" => OrderId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_site(site_id)
    get_site(site_id, params::Dict{String,<:Any})

Gets information about the specified Outpost site.

# Arguments
- `site_id`:  The ID or the Amazon Resource Name (ARN) of the site.

"""
function get_site(SiteId; aws_config::AbstractAWSConfig=current_aws_config())
    return outposts(
        "GET", "/sites/$(SiteId)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_site(
    SiteId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return outposts(
        "GET",
        "/sites/$(SiteId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_site_address(address_type, site_id)
    get_site_address(address_type, site_id, params::Dict{String,<:Any})

 Gets the site address of the specified site.

# Arguments
- `address_type`: The type of the address you request.
- `site_id`:  The ID or the Amazon Resource Name (ARN) of the site.

"""
function get_site_address(
    AddressType, SiteId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return outposts(
        "GET",
        "/sites/$(SiteId)/address",
        Dict{String,Any}("AddressType" => AddressType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_site_address(
    AddressType,
    SiteId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return outposts(
        "GET",
        "/sites/$(SiteId)/address",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AddressType" => AddressType), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_assets(outpost_id)
    list_assets(outpost_id, params::Dict{String,<:Any})

Lists the hardware assets for the specified Outpost. Use filters to return specific
results. If you specify multiple filters, the results include only the resources that match
all of the specified filters. For a filter where you can specify multiple values, the
results include items that match any of the values that you specify for the filter.

# Arguments
- `outpost_id`:  The ID or the Amazon Resource Name (ARN) of the Outpost.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"HostIdFilter"`: Filters the results by the host ID of a Dedicated Host.
- `"MaxResults"`:
- `"NextToken"`:
- `"StatusFilter"`: Filters the results by state.
"""
function list_assets(OutpostId; aws_config::AbstractAWSConfig=current_aws_config())
    return outposts(
        "GET",
        "/outposts/$(OutpostId)/assets";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_assets(
    OutpostId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return outposts(
        "GET",
        "/outposts/$(OutpostId)/assets",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_capacity_tasks()
    list_capacity_tasks(params::Dict{String,<:Any})

Lists the capacity tasks for your Amazon Web Services account. Use filters to return
specific results. If you specify multiple filters, the results include only the resources
that match all of the specified filters. For a filter where you can specify multiple
values, the results include items that match any of the values that you specify for the
filter.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CapacityTaskStatusFilter"`: A list of statuses. For example, REQUESTED or
  WAITING_FOR_EVACUATION.
- `"MaxResults"`:
- `"NextToken"`:
- `"OutpostIdentifierFilter"`: Filters the results by an Outpost ID or an Outpost ARN.
"""
function list_capacity_tasks(; aws_config::AbstractAWSConfig=current_aws_config())
    return outposts(
        "GET", "/capacity/tasks"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_capacity_tasks(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return outposts(
        "GET",
        "/capacity/tasks",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_catalog_items()
    list_catalog_items(params::Dict{String,<:Any})

Lists the items in the catalog. Use filters to return specific results. If you specify
multiple filters, the results include only the resources that match all of the specified
filters. For a filter where you can specify multiple values, the results include items that
match any of the values that you specify for the filter.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EC2FamilyFilter"`: Filters the results by EC2 family (for example, M5).
- `"ItemClassFilter"`: Filters the results by item class.
- `"MaxResults"`:
- `"NextToken"`:
- `"SupportedStorageFilter"`: Filters the results by storage option.
"""
function list_catalog_items(; aws_config::AbstractAWSConfig=current_aws_config())
    return outposts(
        "GET", "/catalog/items"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_catalog_items(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return outposts(
        "GET",
        "/catalog/items",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_orders()
    list_orders(params::Dict{String,<:Any})

Lists the Outpost orders for your Amazon Web Services account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`:
- `"NextToken"`:
- `"OutpostIdentifierFilter"`:  The ID or the Amazon Resource Name (ARN) of the Outpost.
"""
function list_orders(; aws_config::AbstractAWSConfig=current_aws_config())
    return outposts(
        "GET", "/list-orders"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_orders(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return outposts(
        "GET",
        "/list-orders",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_outposts()
    list_outposts(params::Dict{String,<:Any})

Lists the Outposts for your Amazon Web Services account. Use filters to return specific
results. If you specify multiple filters, the results include only the resources that match
all of the specified filters. For a filter where you can specify multiple values, the
results include items that match any of the values that you specify for the filter.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AvailabilityZoneFilter"`: Filters the results by Availability Zone (for example,
  us-east-1a).
- `"AvailabilityZoneIdFilter"`: Filters the results by AZ ID (for example, use1-az1).
- `"LifeCycleStatusFilter"`: Filters the results by the lifecycle status.
- `"MaxResults"`:
- `"NextToken"`:
"""
function list_outposts(; aws_config::AbstractAWSConfig=current_aws_config())
    return outposts(
        "GET", "/outposts"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_outposts(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return outposts(
        "GET", "/outposts", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_sites()
    list_sites(params::Dict{String,<:Any})

Lists the Outpost sites for your Amazon Web Services account. Use filters to return
specific results. Use filters to return specific results. If you specify multiple filters,
the results include only the resources that match all of the specified filters. For a
filter where you can specify multiple values, the results include items that match any of
the values that you specify for the filter.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`:
- `"NextToken"`:
- `"OperatingAddressCityFilter"`: Filters the results by city.
- `"OperatingAddressCountryCodeFilter"`: Filters the results by country code.
- `"OperatingAddressStateOrRegionFilter"`: Filters the results by state or region.
"""
function list_sites(; aws_config::AbstractAWSConfig=current_aws_config())
    return outposts("GET", "/sites"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_sites(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return outposts(
        "GET", "/sites", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists the tags for the specified resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.

"""
function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return outposts(
        "GET",
        "/tags/$(ResourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return outposts(
        "GET",
        "/tags/$(ResourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_capacity_task(instance_pools, order_id, outpost_id)
    start_capacity_task(instance_pools, order_id, outpost_id, params::Dict{String,<:Any})

Starts the specified capacity task. You can have one active capacity task for an order.

# Arguments
- `instance_pools`: The instance pools specified in the capacity task.
- `order_id`: The ID of the Amazon Web Services Outposts order associated with the
  specified capacity task.
- `outpost_id`: The ID or ARN of the Outposts associated with the specified capacity task.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DryRun"`: You can request a dry run to determine if the instance type and instance size
  changes is above or below available instance capacity. Requesting a dry run does not make
  any changes to your plan.
"""
function start_capacity_task(
    InstancePools, OrderId, OutpostId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return outposts(
        "POST",
        "/outposts/$(OutpostId)/capacity",
        Dict{String,Any}("InstancePools" => InstancePools, "OrderId" => OrderId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_capacity_task(
    InstancePools,
    OrderId,
    OutpostId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return outposts(
        "POST",
        "/outposts/$(OutpostId)/capacity",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("InstancePools" => InstancePools, "OrderId" => OrderId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_connection(asset_id, client_public_key, network_interface_device_index)
    start_connection(asset_id, client_public_key, network_interface_device_index, params::Dict{String,<:Any})

  Amazon Web Services uses this action to install Outpost servers.   Starts the connection
required for Outpost server installation.   Use CloudTrail to monitor this action or Amazon
Web Services managed policy for Amazon Web Services Outposts to secure it. For more
information, see  Amazon Web Services managed policies for Amazon Web Services Outposts and
 Logging Amazon Web Services Outposts API calls with Amazon Web Services CloudTrail in the
Amazon Web Services Outposts User Guide.

# Arguments
- `asset_id`:  The ID of the Outpost server.
- `client_public_key`:  The public key of the client.
- `network_interface_device_index`:  The device index of the network interface on the
  Outpost server.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DeviceSerialNumber"`:  The serial number of the dongle.
"""
function start_connection(
    AssetId,
    ClientPublicKey,
    NetworkInterfaceDeviceIndex;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return outposts(
        "POST",
        "/connections",
        Dict{String,Any}(
            "AssetId" => AssetId,
            "ClientPublicKey" => ClientPublicKey,
            "NetworkInterfaceDeviceIndex" => NetworkInterfaceDeviceIndex,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_connection(
    AssetId,
    ClientPublicKey,
    NetworkInterfaceDeviceIndex,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return outposts(
        "POST",
        "/connections",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AssetId" => AssetId,
                    "ClientPublicKey" => ClientPublicKey,
                    "NetworkInterfaceDeviceIndex" => NetworkInterfaceDeviceIndex,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds tags to the specified resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.
- `tags`: The tags to add to the resource.

"""
function tag_resource(ResourceArn, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return outposts(
        "POST",
        "/tags/$(ResourceArn)",
        Dict{String,Any}("Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceArn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return outposts(
        "POST",
        "/tags/$(ResourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Tags" => Tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes tags from the specified resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.
- `tag_keys`: The tag keys.

"""
function untag_resource(
    ResourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return outposts(
        "DELETE",
        "/tags/$(ResourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return outposts(
        "DELETE",
        "/tags/$(ResourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_outpost(outpost_id)
    update_outpost(outpost_id, params::Dict{String,<:Any})

 Updates an Outpost.

# Arguments
- `outpost_id`:  The ID or ARN of the Outpost.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`:
- `"Name"`:
- `"SupportedHardwareType"`:  The type of hardware for this Outpost.
"""
function update_outpost(OutpostId; aws_config::AbstractAWSConfig=current_aws_config())
    return outposts(
        "PATCH",
        "/outposts/$(OutpostId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_outpost(
    OutpostId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return outposts(
        "PATCH",
        "/outposts/$(OutpostId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_site(site_id)
    update_site(site_id, params::Dict{String,<:Any})

Updates the specified site.

# Arguments
- `site_id`:  The ID or the Amazon Resource Name (ARN) of the site.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`:
- `"Name"`:
- `"Notes"`: Notes about a site.
"""
function update_site(SiteId; aws_config::AbstractAWSConfig=current_aws_config())
    return outposts(
        "PATCH", "/sites/$(SiteId)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function update_site(
    SiteId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return outposts(
        "PATCH",
        "/sites/$(SiteId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_site_address(address, address_type, site_id)
    update_site_address(address, address_type, site_id, params::Dict{String,<:Any})

Updates the address of the specified site. You can't update a site address if there is an
order in progress. You must wait for the order to complete or cancel the order. You can
update the operating address before you place an order at the site, or after all Outposts
that belong to the site have been deactivated.

# Arguments
- `address`:  The address for the site.
- `address_type`:  The type of the address.
- `site_id`:  The ID or the Amazon Resource Name (ARN) of the site.

"""
function update_site_address(
    Address, AddressType, SiteId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return outposts(
        "PUT",
        "/sites/$(SiteId)/address",
        Dict{String,Any}("Address" => Address, "AddressType" => AddressType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_site_address(
    Address,
    AddressType,
    SiteId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return outposts(
        "PUT",
        "/sites/$(SiteId)/address",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Address" => Address, "AddressType" => AddressType),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_site_rack_physical_properties(site_id)
    update_site_rack_physical_properties(site_id, params::Dict{String,<:Any})

Update the physical and logistical details for a rack at a site. For more information about
hardware requirements for racks, see Network readiness checklist in the Amazon Web Services
Outposts User Guide.  To update a rack at a site with an order of IN_PROGRESS, you must
wait for the order to complete or cancel the order.

# Arguments
- `site_id`:  The ID or the Amazon Resource Name (ARN) of the site.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FiberOpticCableType"`: The type of fiber that you will use to attach the Outpost to
  your network.
- `"MaximumSupportedWeightLbs"`: The maximum rack weight that this site can support.
  NO_LIMIT is over 2000lbs.
- `"OpticalStandard"`: The type of optical standard that you will use to attach the Outpost
  to your network. This field is dependent on uplink speed, fiber type, and distance to the
  upstream device. For more information about networking requirements for racks, see Network
  in the Amazon Web Services Outposts User Guide.     OPTIC_10GBASE_SR: 10GBASE-SR
  OPTIC_10GBASE_IR: 10GBASE-IR    OPTIC_10GBASE_LR: 10GBASE-LR    OPTIC_40GBASE_SR:
  40GBASE-SR    OPTIC_40GBASE_ESR: 40GBASE-ESR    OPTIC_40GBASE_IR4_LR4L: 40GBASE-IR (LR4L)
   OPTIC_40GBASE_LR4: 40GBASE-LR4    OPTIC_100GBASE_SR4: 100GBASE-SR4
  OPTIC_100GBASE_CWDM4: 100GBASE-CWDM4    OPTIC_100GBASE_LR4: 100GBASE-LR4
  OPTIC_100G_PSM4_MSA: 100G PSM4 MSA    OPTIC_1000BASE_LX: 1000Base-LX    OPTIC_1000BASE_SX :
  1000Base-SX
- `"PowerConnector"`: The power connector that Amazon Web Services should plan to provide
  for connections to the hardware. Note the correlation between PowerPhase and
  PowerConnector.    Single-phase AC feed    L6-30P – (common in US); 30A; single phase
  IEC309 (blue) – P+N+E, 6hr; 32 A; single phase     Three-phase AC feed    AH530P7W (red)
  – 3P+N+E, 7hr; 30A; three phase    AH532P6W (red) – 3P+N+E, 6hr; 32A; three phase
- `"PowerDrawKva"`: The power draw, in kVA, available at the hardware placement position
  for the rack.
- `"PowerFeedDrop"`: Indicates whether the power feed comes above or below the rack.
- `"PowerPhase"`: The power option that you can provide for hardware.    Single-phase AC
  feed: 200 V to 277 V, 50 Hz or 60 Hz   Three-phase AC feed: 346 V to 480 V, 50 Hz or 60 Hz
- `"UplinkCount"`: Racks come with two Outpost network devices. Depending on the supported
  uplink speed at the site, the Outpost network devices provide a variable number of uplinks.
  Specify the number of uplinks for each Outpost network device that you intend to use to
  connect the rack to your network. Note the correlation between UplinkGbps and UplinkCount.
    1Gbps - Uplinks available: 1, 2, 4, 6, 8   10Gbps - Uplinks available: 1, 2, 4, 8, 12, 16
    40 and 100 Gbps- Uplinks available: 1, 2, 4
- `"UplinkGbps"`: The uplink speed the rack should support for the connection to the
  Region.
"""
function update_site_rack_physical_properties(
    SiteId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return outposts(
        "PATCH",
        "/sites/$(SiteId)/rackPhysicalProperties";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_site_rack_physical_properties(
    SiteId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return outposts(
        "PATCH",
        "/sites/$(SiteId)/rackPhysicalProperties",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: neptunedata
using AWS.Compat
using AWS.UUIDs

"""
    cancel_gremlin_query(query_id)
    cancel_gremlin_query(query_id, params::Dict{String,<:Any})

Cancels a Gremlin query. See Gremlin query cancellation for more information. When invoking
this operation in a Neptune cluster that has IAM authentication enabled, the IAM user or
role making the request must have a policy attached that allows the neptune-db:CancelQuery
IAM action in that cluster.

# Arguments
- `query_id`: The unique identifier that identifies the query to be canceled.

"""
function cancel_gremlin_query(queryId; aws_config::AbstractAWSConfig=current_aws_config())
    return neptunedata(
        "DELETE",
        "/gremlin/status/$(queryId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_gremlin_query(
    queryId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptunedata(
        "DELETE",
        "/gremlin/status/$(queryId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_loader_job(load_id)
    cancel_loader_job(load_id, params::Dict{String,<:Any})

Cancels a specified load job. This is an HTTP DELETE request. See Neptune Loader Get-Status
API for more information. When invoking this operation in a Neptune cluster that has IAM
authentication enabled, the IAM user or role making the request must have a policy attached
that allows the neptune-db:CancelLoaderJob IAM action in that cluster..

# Arguments
- `load_id`: The ID of the load job to be deleted.

"""
function cancel_loader_job(loadId; aws_config::AbstractAWSConfig=current_aws_config())
    return neptunedata(
        "DELETE",
        "/loader/$(loadId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_loader_job(
    loadId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptunedata(
        "DELETE",
        "/loader/$(loadId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_mldata_processing_job(id)
    cancel_mldata_processing_job(id, params::Dict{String,<:Any})

Cancels a Neptune ML data processing job. See The dataprocessing command. When invoking
this operation in a Neptune cluster that has IAM authentication enabled, the IAM user or
role making the request must have a policy attached that allows the
neptune-db:CancelMLDataProcessingJob IAM action in that cluster.

# Arguments
- `id`: The unique identifier of the data-processing job.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clean"`: If set to TRUE, this flag specifies that all Neptune ML S3 artifacts should be
  deleted when the job is stopped. The default is FALSE.
- `"neptuneIamRoleArn"`: The ARN of an IAM role that provides Neptune access to SageMaker
  and Amazon S3 resources. This must be listed in your DB cluster parameter group or an error
  will occur.
"""
function cancel_mldata_processing_job(
    id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptunedata(
        "DELETE",
        "/ml/dataprocessing/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_mldata_processing_job(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptunedata(
        "DELETE",
        "/ml/dataprocessing/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_mlmodel_training_job(id)
    cancel_mlmodel_training_job(id, params::Dict{String,<:Any})

Cancels a Neptune ML model training job. See Model training using the modeltraining
command. When invoking this operation in a Neptune cluster that has IAM authentication
enabled, the IAM user or role making the request must have a policy attached that allows
the neptune-db:CancelMLModelTrainingJob IAM action in that cluster.

# Arguments
- `id`: The unique identifier of the model-training job to be canceled.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clean"`: If set to TRUE, this flag specifies that all Amazon S3 artifacts should be
  deleted when the job is stopped. The default is FALSE.
- `"neptuneIamRoleArn"`: The ARN of an IAM role that provides Neptune access to SageMaker
  and Amazon S3 resources. This must be listed in your DB cluster parameter group or an error
  will occur.
"""
function cancel_mlmodel_training_job(id; aws_config::AbstractAWSConfig=current_aws_config())
    return neptunedata(
        "DELETE",
        "/ml/modeltraining/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_mlmodel_training_job(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptunedata(
        "DELETE",
        "/ml/modeltraining/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_mlmodel_transform_job(id)
    cancel_mlmodel_transform_job(id, params::Dict{String,<:Any})

Cancels a specified model transform job. See Use a trained model to generate new model
artifacts. When invoking this operation in a Neptune cluster that has IAM authentication
enabled, the IAM user or role making the request must have a policy attached that allows
the neptune-db:CancelMLModelTransformJob IAM action in that cluster.

# Arguments
- `id`: The unique ID of the model transform job to be canceled.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clean"`: If this flag is set to TRUE, all Neptune ML S3 artifacts should be deleted
  when the job is stopped. The default is FALSE.
- `"neptuneIamRoleArn"`: The ARN of an IAM role that provides Neptune access to SageMaker
  and Amazon S3 resources. This must be listed in your DB cluster parameter group or an error
  will occur.
"""
function cancel_mlmodel_transform_job(
    id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptunedata(
        "DELETE",
        "/ml/modeltransform/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_mlmodel_transform_job(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptunedata(
        "DELETE",
        "/ml/modeltransform/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_open_cypher_query(query_id)
    cancel_open_cypher_query(query_id, params::Dict{String,<:Any})

Cancels a specified openCypher query. See Neptune openCypher status endpoint for more
information. When invoking this operation in a Neptune cluster that has IAM authentication
enabled, the IAM user or role making the request must have a policy attached that allows
the neptune-db:CancelQuery IAM action in that cluster.

# Arguments
- `query_id`: The unique ID of the openCypher query to cancel.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"silent"`: If set to TRUE, causes the cancelation of the openCypher query to happen
  silently.
"""
function cancel_open_cypher_query(
    queryId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptunedata(
        "DELETE",
        "/opencypher/status/$(queryId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_open_cypher_query(
    queryId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptunedata(
        "DELETE",
        "/opencypher/status/$(queryId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_mlendpoint()
    create_mlendpoint(params::Dict{String,<:Any})

Creates a new Neptune ML inference endpoint that lets you query one specific model that the
model-training process constructed. See Managing inference endpoints using the endpoints
command. When invoking this operation in a Neptune cluster that has IAM authentication
enabled, the IAM user or role making the request must have a policy attached that allows
the neptune-db:CreateMLEndpoint IAM action in that cluster.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"id"`: A unique identifier for the new inference endpoint. The default is an
  autogenerated timestamped name.
- `"instanceCount"`: The minimum number of Amazon EC2 instances to deploy to an endpoint
  for prediction. The default is 1
- `"instanceType"`: The type of Neptune ML instance to use for online servicing. The
  default is ml.m5.xlarge. Choosing the ML instance for an inference endpoint depends on the
  task type, the graph size, and your budget.
- `"mlModelTrainingJobId"`: The job Id of the completed model-training job that has created
  the model that the inference endpoint will point to. You must supply either the
  mlModelTrainingJobId or the mlModelTransformJobId.
- `"mlModelTransformJobId"`: The job Id of the completed model-transform job. You must
  supply either the mlModelTrainingJobId or the mlModelTransformJobId.
- `"modelName"`: Model type for training. By default the Neptune ML model is automatically
  based on the modelType used in data processing, but you can specify a different model type
  here. The default is rgcn for heterogeneous graphs and kge for knowledge graphs. The only
  valid value for heterogeneous graphs is rgcn. Valid values for knowledge graphs are: kge,
  transe, distmult, and rotate.
- `"neptuneIamRoleArn"`: The ARN of an IAM role providing Neptune access to SageMaker and
  Amazon S3 resources. This must be listed in your DB cluster parameter group or an error
  will be thrown.
- `"update"`: If set to true, update indicates that this is an update request. The default
  is false. You must supply either the mlModelTrainingJobId or the mlModelTransformJobId.
- `"volumeEncryptionKMSKey"`: The Amazon Key Management Service (Amazon KMS) key that
  SageMaker uses to encrypt data on the storage volume attached to the ML compute instances
  that run the training job. The default is None.
"""
function create_mlendpoint(; aws_config::AbstractAWSConfig=current_aws_config())
    return neptunedata(
        "POST", "/ml/endpoints"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function create_mlendpoint(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptunedata(
        "POST",
        "/ml/endpoints",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_mlendpoint(id)
    delete_mlendpoint(id, params::Dict{String,<:Any})

Cancels the creation of a Neptune ML inference endpoint. See Managing inference endpoints
using the endpoints command. When invoking this operation in a Neptune cluster that has IAM
authentication enabled, the IAM user or role making the request must have a policy attached
that allows the neptune-db:DeleteMLEndpoint IAM action in that cluster.

# Arguments
- `id`: The unique identifier of the inference endpoint.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clean"`: If this flag is set to TRUE, all Neptune ML S3 artifacts should be deleted
  when the job is stopped. The default is FALSE.
- `"neptuneIamRoleArn"`: The ARN of an IAM role providing Neptune access to SageMaker and
  Amazon S3 resources. This must be listed in your DB cluster parameter group or an error
  will be thrown.
"""
function delete_mlendpoint(id; aws_config::AbstractAWSConfig=current_aws_config())
    return neptunedata(
        "DELETE",
        "/ml/endpoints/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_mlendpoint(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptunedata(
        "DELETE",
        "/ml/endpoints/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_propertygraph_statistics()
    delete_propertygraph_statistics(params::Dict{String,<:Any})

Deletes statistics for Gremlin and openCypher (property graph) data. When invoking this
operation in a Neptune cluster that has IAM authentication enabled, the IAM user or role
making the request must have a policy attached that allows the neptune-db:DeleteStatistics
IAM action in that cluster.

"""
function delete_propertygraph_statistics(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptunedata(
        "DELETE",
        "/propertygraph/statistics";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_propertygraph_statistics(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptunedata(
        "DELETE",
        "/propertygraph/statistics",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_sparql_statistics()
    delete_sparql_statistics(params::Dict{String,<:Any})

Deletes SPARQL statistics When invoking this operation in a Neptune cluster that has IAM
authentication enabled, the IAM user or role making the request must have a policy attached
that allows the neptune-db:DeleteStatistics IAM action in that cluster.

"""
function delete_sparql_statistics(; aws_config::AbstractAWSConfig=current_aws_config())
    return neptunedata(
        "DELETE",
        "/sparql/statistics";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_sparql_statistics(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptunedata(
        "DELETE",
        "/sparql/statistics",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    execute_fast_reset(action)
    execute_fast_reset(action, params::Dict{String,<:Any})

The fast reset REST API lets you reset a Neptune graph quicky and easily, removing all of
its data. Neptune fast reset is a two-step process. First you call ExecuteFastReset with
action set to initiateDatabaseReset. This returns a UUID token which you then include when
calling ExecuteFastReset again with action set to performDatabaseReset. See Empty an Amazon
Neptune DB cluster using the fast reset API. When invoking this operation in a Neptune
cluster that has IAM authentication enabled, the IAM user or role making the request must
have a policy attached that allows the neptune-db:ResetDatabase IAM action in that cluster.

# Arguments
- `action`: The fast reset action. One of the following values:     initiateDatabaseReset
    –   This action generates a unique token needed to actually perform the fast reset.
    performDatabaseReset    –   This action uses the token generated by the
  initiateDatabaseReset action to actually perform the fast reset.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"token"`: The fast-reset token to initiate the reset.
"""
function execute_fast_reset(action; aws_config::AbstractAWSConfig=current_aws_config())
    return neptunedata(
        "POST",
        "/system",
        Dict{String,Any}("action" => action);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function execute_fast_reset(
    action, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptunedata(
        "POST",
        "/system",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("action" => action), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    execute_gremlin_explain_query(gremlin)
    execute_gremlin_explain_query(gremlin, params::Dict{String,<:Any})

Executes a Gremlin Explain query. Amazon Neptune has added a Gremlin feature named explain
that provides is a self-service tool for understanding the execution approach being taken
by the Neptune engine for the query. You invoke it by adding an explain parameter to an
HTTP call that submits a Gremlin query. The explain feature provides information about the
logical structure of query execution plans. You can use this information to identify
potential evaluation and execution bottlenecks and to tune your query, as explained in
Tuning Gremlin queries. You can also use query hints to improve query execution plans. When
invoking this operation in a Neptune cluster that has IAM authentication enabled, the IAM
user or role making the request must have a policy attached that allows one of the
following IAM actions in that cluster, depending on the query:
neptune-db:ReadDataViaQuery     neptune-db:WriteDataViaQuery
neptune-db:DeleteDataViaQuery    Note that the neptune-db:QueryLanguage:Gremlin IAM
condition key can be used in the policy document to restrict the use of Gremlin queries
(see Condition keys available in Neptune IAM data-access policy statements).

# Arguments
- `gremlin`: The Gremlin explain query string.

"""
function execute_gremlin_explain_query(
    gremlin; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptunedata(
        "POST",
        "/gremlin/explain",
        Dict{String,Any}("gremlin" => gremlin);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function execute_gremlin_explain_query(
    gremlin,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptunedata(
        "POST",
        "/gremlin/explain",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("gremlin" => gremlin), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    execute_gremlin_profile_query(gremlin)
    execute_gremlin_profile_query(gremlin, params::Dict{String,<:Any})

Executes a Gremlin Profile query, which runs a specified traversal, collects various
metrics about the run, and produces a profile report as output. See Gremlin profile API in
Neptune for details. When invoking this operation in a Neptune cluster that has IAM
authentication enabled, the IAM user or role making the request must have a policy attached
that allows the neptune-db:ReadDataViaQuery IAM action in that cluster. Note that the
neptune-db:QueryLanguage:Gremlin IAM condition key can be used in the policy document to
restrict the use of Gremlin queries (see Condition keys available in Neptune IAM
data-access policy statements).

# Arguments
- `gremlin`: The Gremlin query string to profile.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"profile.chop"`: If non-zero, causes the results string to be truncated at that number
  of characters. If set to zero, the string contains all the results.
- `"profile.indexOps"`: If this flag is set to TRUE, the results include a detailed report
  of all index operations that took place during query execution and serialization.
- `"profile.results"`: If this flag is set to TRUE, the query results are gathered and
  displayed as part of the profile report. If FALSE, only the result count is displayed.
- `"profile.serializer"`: If non-null, the gathered results are returned in a serialized
  response message in the format specified by this parameter. See Gremlin profile API in
  Neptune for more information.
"""
function execute_gremlin_profile_query(
    gremlin; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptunedata(
        "POST",
        "/gremlin/profile",
        Dict{String,Any}("gremlin" => gremlin);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function execute_gremlin_profile_query(
    gremlin,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptunedata(
        "POST",
        "/gremlin/profile",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("gremlin" => gremlin), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    execute_gremlin_query(gremlin)
    execute_gremlin_query(gremlin, params::Dict{String,<:Any})

This commands executes a Gremlin query. Amazon Neptune is compatible with Apache TinkerPop3
and Gremlin, so you can use the Gremlin traversal language to query the graph, as described
under The Graph in the Apache TinkerPop3 documentation. More details can also be found in
Accessing a Neptune graph with Gremlin. When invoking this operation in a Neptune cluster
that has IAM authentication enabled, the IAM user or role making the request must have a
policy attached that enables one of the following IAM actions in that cluster, depending on
the query:    neptune-db:ReadDataViaQuery     neptune-db:WriteDataViaQuery
neptune-db:DeleteDataViaQuery    Note that the neptune-db:QueryLanguage:Gremlin IAM
condition key can be used in the policy document to restrict the use of Gremlin queries
(see Condition keys available in Neptune IAM data-access policy statements).

# Arguments
- `gremlin`: Using this API, you can run Gremlin queries in string format much as you can
  using the HTTP endpoint. The interface is compatible with whatever Gremlin version your DB
  cluster is using (see the Tinkerpop client section to determine which Gremlin releases your
  engine version supports).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accept"`: If non-null, the query results are returned in a serialized response message
  in the format specified by this parameter. See the GraphSON section in the TinkerPop
  documentation for a list of the formats that are currently supported.
"""
function execute_gremlin_query(gremlin; aws_config::AbstractAWSConfig=current_aws_config())
    return neptunedata(
        "POST",
        "/gremlin",
        Dict{String,Any}("gremlin" => gremlin);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function execute_gremlin_query(
    gremlin,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptunedata(
        "POST",
        "/gremlin",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("gremlin" => gremlin), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    execute_open_cypher_explain_query(explain, query)
    execute_open_cypher_explain_query(explain, query, params::Dict{String,<:Any})

Executes an openCypher explain request. See The openCypher explain feature for more
information. When invoking this operation in a Neptune cluster that has IAM authentication
enabled, the IAM user or role making the request must have a policy attached that allows
the neptune-db:ReadDataViaQuery IAM action in that cluster. Note that the
neptune-db:QueryLanguage:OpenCypher IAM condition key can be used in the policy document to
restrict the use of openCypher queries (see Condition keys available in Neptune IAM
data-access policy statements).

# Arguments
- `explain`: The openCypher explain mode. Can be one of: static, dynamic, or details.
- `query`: The openCypher query string.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"parameters"`: The openCypher query parameters.
"""
function execute_open_cypher_explain_query(
    explain, query; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptunedata(
        "POST",
        "/opencypher/explain",
        Dict{String,Any}("explain" => explain, "query" => query);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function execute_open_cypher_explain_query(
    explain,
    query,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptunedata(
        "POST",
        "/opencypher/explain",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("explain" => explain, "query" => query), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    execute_open_cypher_query(query)
    execute_open_cypher_query(query, params::Dict{String,<:Any})

Executes an openCypher query. See Accessing the Neptune Graph with openCypher for more
information. Neptune supports building graph applications using openCypher, which is
currently one of the most popular query languages among developers working with graph
databases. Developers, business analysts, and data scientists like openCypher's
declarative, SQL-inspired syntax because it provides a familiar structure in which to
querying property graphs. The openCypher language was originally developed by Neo4j, then
open-sourced in 2015 and contributed to the openCypher project under an Apache 2
open-source license. Note that when invoking this operation in a Neptune cluster that has
IAM authentication enabled, the IAM user or role making the request must have a policy
attached that allows one of the following IAM actions in that cluster, depending on the
query:    neptune-db:ReadDataViaQuery     neptune-db:WriteDataViaQuery
neptune-db:DeleteDataViaQuery    Note also that the neptune-db:QueryLanguage:OpenCypher IAM
condition key can be used in the policy document to restrict the use of openCypher queries
(see Condition keys available in Neptune IAM data-access policy statements).

# Arguments
- `query`: The openCypher query string to be executed.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"parameters"`: The openCypher query parameters for query execution. See Examples of
  openCypher parameterized queries for more information.
"""
function execute_open_cypher_query(
    query; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptunedata(
        "POST",
        "/opencypher",
        Dict{String,Any}("query" => query);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function execute_open_cypher_query(
    query, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptunedata(
        "POST",
        "/opencypher",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("query" => query), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_engine_status()
    get_engine_status(params::Dict{String,<:Any})

Retrieves the status of the graph database on the host. When invoking this operation in a
Neptune cluster that has IAM authentication enabled, the IAM user or role making the
request must have a policy attached that allows the neptune-db:GetEngineStatus IAM action
in that cluster.

"""
function get_engine_status(; aws_config::AbstractAWSConfig=current_aws_config())
    return neptunedata(
        "GET", "/status"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_engine_status(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptunedata(
        "GET", "/status", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_gremlin_query_status(query_id)
    get_gremlin_query_status(query_id, params::Dict{String,<:Any})

Gets the status of a specified Gremlin query. When invoking this operation in a Neptune
cluster that has IAM authentication enabled, the IAM user or role making the request must
have a policy attached that allows the neptune-db:GetQueryStatus IAM action in that
cluster. Note that the neptune-db:QueryLanguage:Gremlin IAM condition key can be used in
the policy document to restrict the use of Gremlin queries (see Condition keys available in
Neptune IAM data-access policy statements).

# Arguments
- `query_id`: The unique identifier that identifies the Gremlin query.

"""
function get_gremlin_query_status(
    queryId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptunedata(
        "GET",
        "/gremlin/status/$(queryId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_gremlin_query_status(
    queryId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptunedata(
        "GET",
        "/gremlin/status/$(queryId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_loader_job_status(load_id)
    get_loader_job_status(load_id, params::Dict{String,<:Any})

Gets status information about a specified load job. Neptune keeps track of the most recent
1,024 bulk load jobs, and stores the last 10,000 error details per job. See Neptune Loader
Get-Status API for more information. When invoking this operation in a Neptune cluster that
has IAM authentication enabled, the IAM user or role making the request must have a policy
attached that allows the neptune-db:GetLoaderJobStatus IAM action in that cluster..

# Arguments
- `load_id`: The load ID of the load job to get the status of.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"details"`: Flag indicating whether or not to include details beyond the overall status
  (TRUE or FALSE; the default is FALSE).
- `"errors"`: Flag indicating whether or not to include a list of errors encountered (TRUE
  or FALSE; the default is FALSE). The list of errors is paged. The page and errorsPerPage
  parameters allow you to page through all the errors.
- `"errorsPerPage"`: The number of errors returned in each page (a positive integer; the
  default is 10). Only valid when the errors parameter set to TRUE.
- `"page"`: The error page number (a positive integer; the default is 1). Only valid when
  the errors parameter is set to TRUE.
"""
function get_loader_job_status(loadId; aws_config::AbstractAWSConfig=current_aws_config())
    return neptunedata(
        "GET", "/loader/$(loadId)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_loader_job_status(
    loadId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptunedata(
        "GET",
        "/loader/$(loadId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_mldata_processing_job(id)
    get_mldata_processing_job(id, params::Dict{String,<:Any})

Retrieves information about a specified data processing job. See The dataprocessing
command. When invoking this operation in a Neptune cluster that has IAM authentication
enabled, the IAM user or role making the request must have a policy attached that allows
the neptune-db:neptune-db:GetMLDataProcessingJobStatus IAM action in that cluster.

# Arguments
- `id`: The unique identifier of the data-processing job to be retrieved.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"neptuneIamRoleArn"`: The ARN of an IAM role that provides Neptune access to SageMaker
  and Amazon S3 resources. This must be listed in your DB cluster parameter group or an error
  will occur.
"""
function get_mldata_processing_job(id; aws_config::AbstractAWSConfig=current_aws_config())
    return neptunedata(
        "GET",
        "/ml/dataprocessing/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_mldata_processing_job(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptunedata(
        "GET",
        "/ml/dataprocessing/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_mlendpoint(id)
    get_mlendpoint(id, params::Dict{String,<:Any})

Retrieves details about an inference endpoint. See Managing inference endpoints using the
endpoints command. When invoking this operation in a Neptune cluster that has IAM
authentication enabled, the IAM user or role making the request must have a policy attached
that allows the neptune-db:GetMLEndpointStatus IAM action in that cluster.

# Arguments
- `id`: The unique identifier of the inference endpoint.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"neptuneIamRoleArn"`: The ARN of an IAM role that provides Neptune access to SageMaker
  and Amazon S3 resources. This must be listed in your DB cluster parameter group or an error
  will occur.
"""
function get_mlendpoint(id; aws_config::AbstractAWSConfig=current_aws_config())
    return neptunedata(
        "GET", "/ml/endpoints/$(id)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_mlendpoint(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptunedata(
        "GET",
        "/ml/endpoints/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_mlmodel_training_job(id)
    get_mlmodel_training_job(id, params::Dict{String,<:Any})

Retrieves information about a Neptune ML model training job. See Model training using the
modeltraining command. When invoking this operation in a Neptune cluster that has IAM
authentication enabled, the IAM user or role making the request must have a policy attached
that allows the neptune-db:GetMLModelTrainingJobStatus IAM action in that cluster.

# Arguments
- `id`: The unique identifier of the model-training job to retrieve.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"neptuneIamRoleArn"`: The ARN of an IAM role that provides Neptune access to SageMaker
  and Amazon S3 resources. This must be listed in your DB cluster parameter group or an error
  will occur.
"""
function get_mlmodel_training_job(id; aws_config::AbstractAWSConfig=current_aws_config())
    return neptunedata(
        "GET",
        "/ml/modeltraining/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_mlmodel_training_job(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptunedata(
        "GET",
        "/ml/modeltraining/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_mlmodel_transform_job(id)
    get_mlmodel_transform_job(id, params::Dict{String,<:Any})

Gets information about a specified model transform job. See Use a trained model to generate
new model artifacts. When invoking this operation in a Neptune cluster that has IAM
authentication enabled, the IAM user or role making the request must have a policy attached
that allows the neptune-db:GetMLModelTransformJobStatus IAM action in that cluster.

# Arguments
- `id`: The unique identifier of the model-transform job to be reetrieved.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"neptuneIamRoleArn"`: The ARN of an IAM role that provides Neptune access to SageMaker
  and Amazon S3 resources. This must be listed in your DB cluster parameter group or an error
  will occur.
"""
function get_mlmodel_transform_job(id; aws_config::AbstractAWSConfig=current_aws_config())
    return neptunedata(
        "GET",
        "/ml/modeltransform/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_mlmodel_transform_job(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptunedata(
        "GET",
        "/ml/modeltransform/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_open_cypher_query_status(query_id)
    get_open_cypher_query_status(query_id, params::Dict{String,<:Any})

Retrieves the status of a specified openCypher query. When invoking this operation in a
Neptune cluster that has IAM authentication enabled, the IAM user or role making the
request must have a policy attached that allows the neptune-db:GetQueryStatus IAM action in
that cluster. Note that the neptune-db:QueryLanguage:OpenCypher IAM condition key can be
used in the policy document to restrict the use of openCypher queries (see Condition keys
available in Neptune IAM data-access policy statements).

# Arguments
- `query_id`: The unique ID of the openCypher query for which to retrieve the query status.

"""
function get_open_cypher_query_status(
    queryId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptunedata(
        "GET",
        "/opencypher/status/$(queryId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_open_cypher_query_status(
    queryId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptunedata(
        "GET",
        "/opencypher/status/$(queryId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_propertygraph_statistics()
    get_propertygraph_statistics(params::Dict{String,<:Any})

Gets property graph statistics (Gremlin and openCypher). When invoking this operation in a
Neptune cluster that has IAM authentication enabled, the IAM user or role making the
request must have a policy attached that allows the neptune-db:GetStatisticsStatus IAM
action in that cluster.

"""
function get_propertygraph_statistics(; aws_config::AbstractAWSConfig=current_aws_config())
    return neptunedata(
        "GET",
        "/propertygraph/statistics";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_propertygraph_statistics(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptunedata(
        "GET",
        "/propertygraph/statistics",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_propertygraph_stream()
    get_propertygraph_stream(params::Dict{String,<:Any})

Gets a stream for a property graph. With the Neptune Streams feature, you can generate a
complete sequence of change-log entries that record every change made to your graph data as
it happens. GetPropertygraphStream lets you collect these change-log entries for a property
graph. The Neptune streams feature needs to be enabled on your Neptune DBcluster. To enable
streams, set the neptune_streams DB cluster parameter to 1. See Capturing graph changes in
real time using Neptune streams. When invoking this operation in a Neptune cluster that has
IAM authentication enabled, the IAM user or role making the request must have a policy
attached that allows the neptune-db:GetStreamRecords IAM action in that cluster. When
invoking this operation in a Neptune cluster that has IAM authentication enabled, the IAM
user or role making the request must have a policy attached that enables one of the
following IAM actions, depending on the query: Note that you can restrict property-graph
queries using the following IAM context keys:    neptune-db:QueryLanguage:Gremlin
neptune-db:QueryLanguage:OpenCypher    See Condition keys available in Neptune IAM
data-access policy statements).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Accept-Encoding"`: If set to TRUE, Neptune compresses the response using gzip encoding.
- `"commitNum"`: The commit number of the starting record to read from the change-log
  stream. This parameter is required when iteratorType isAT_SEQUENCE_NUMBER or
  AFTER_SEQUENCE_NUMBER, and ignored when iteratorType is TRIM_HORIZON or LATEST.
- `"iteratorType"`: Can be one of:    AT_SEQUENCE_NUMBER   –   Indicates that reading
  should start from the event sequence number specified jointly by the commitNum and opNum
  parameters.    AFTER_SEQUENCE_NUMBER   –   Indicates that reading should start right
  after the event sequence number specified jointly by the commitNum and opNum parameters.
  TRIM_HORIZON   –   Indicates that reading should start at the last untrimmed record in
  the system, which is the oldest unexpired (not yet deleted) record in the change-log
  stream.    LATEST   –   Indicates that reading should start at the most recent record
  in the system, which is the latest unexpired (not yet deleted) record in the change-log
  stream.
- `"limit"`: Specifies the maximum number of records to return. There is also a size limit
  of 10 MB on the response that can't be modified and that takes precedence over the number
  of records specified in the limit parameter. The response does include a
  threshold-breaching record if the 10 MB limit was reached. The range for limit is 1 to
  100,000, with a default of 10.
- `"opNum"`: The operation sequence number within the specified commit to start reading
  from in the change-log stream data. The default is 1.
"""
function get_propertygraph_stream(; aws_config::AbstractAWSConfig=current_aws_config())
    return neptunedata(
        "GET",
        "/propertygraph/stream";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_propertygraph_stream(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptunedata(
        "GET",
        "/propertygraph/stream",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_propertygraph_summary()
    get_propertygraph_summary(params::Dict{String,<:Any})

Gets a graph summary for a property graph. When invoking this operation in a Neptune
cluster that has IAM authentication enabled, the IAM user or role making the request must
have a policy attached that allows the neptune-db:GetGraphSummary IAM action in that
cluster.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"mode"`: Mode can take one of two values: BASIC (the default), and DETAILED.
"""
function get_propertygraph_summary(; aws_config::AbstractAWSConfig=current_aws_config())
    return neptunedata(
        "GET",
        "/propertygraph/statistics/summary";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_propertygraph_summary(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptunedata(
        "GET",
        "/propertygraph/statistics/summary",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_rdfgraph_summary()
    get_rdfgraph_summary(params::Dict{String,<:Any})

Gets a graph summary for an RDF graph. When invoking this operation in a Neptune cluster
that has IAM authentication enabled, the IAM user or role making the request must have a
policy attached that allows the neptune-db:GetGraphSummary IAM action in that cluster.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"mode"`: Mode can take one of two values: BASIC (the default), and DETAILED.
"""
function get_rdfgraph_summary(; aws_config::AbstractAWSConfig=current_aws_config())
    return neptunedata(
        "GET",
        "/rdf/statistics/summary";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_rdfgraph_summary(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptunedata(
        "GET",
        "/rdf/statistics/summary",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_sparql_statistics()
    get_sparql_statistics(params::Dict{String,<:Any})

Gets RDF statistics (SPARQL).

"""
function get_sparql_statistics(; aws_config::AbstractAWSConfig=current_aws_config())
    return neptunedata(
        "GET", "/sparql/statistics"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_sparql_statistics(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptunedata(
        "GET",
        "/sparql/statistics",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_sparql_stream()
    get_sparql_stream(params::Dict{String,<:Any})

Gets a stream for an RDF graph. With the Neptune Streams feature, you can generate a
complete sequence of change-log entries that record every change made to your graph data as
it happens. GetSparqlStream lets you collect these change-log entries for an RDF graph. The
Neptune streams feature needs to be enabled on your Neptune DBcluster. To enable streams,
set the neptune_streams DB cluster parameter to 1. See Capturing graph changes in real time
using Neptune streams. When invoking this operation in a Neptune cluster that has IAM
authentication enabled, the IAM user or role making the request must have a policy attached
that allows the neptune-db:GetStreamRecords IAM action in that cluster. Note that the
neptune-db:QueryLanguage:Sparql IAM condition key can be used in the policy document to
restrict the use of SPARQL queries (see Condition keys available in Neptune IAM data-access
policy statements).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Accept-Encoding"`: If set to TRUE, Neptune compresses the response using gzip encoding.
- `"commitNum"`: The commit number of the starting record to read from the change-log
  stream. This parameter is required when iteratorType isAT_SEQUENCE_NUMBER or
  AFTER_SEQUENCE_NUMBER, and ignored when iteratorType is TRIM_HORIZON or LATEST.
- `"iteratorType"`: Can be one of:    AT_SEQUENCE_NUMBER   –   Indicates that reading
  should start from the event sequence number specified jointly by the commitNum and opNum
  parameters.    AFTER_SEQUENCE_NUMBER   –   Indicates that reading should start right
  after the event sequence number specified jointly by the commitNum and opNum parameters.
  TRIM_HORIZON   –   Indicates that reading should start at the last untrimmed record in
  the system, which is the oldest unexpired (not yet deleted) record in the change-log
  stream.    LATEST   –   Indicates that reading should start at the most recent record
  in the system, which is the latest unexpired (not yet deleted) record in the change-log
  stream.
- `"limit"`: Specifies the maximum number of records to return. There is also a size limit
  of 10 MB on the response that can't be modified and that takes precedence over the number
  of records specified in the limit parameter. The response does include a
  threshold-breaching record if the 10 MB limit was reached. The range for limit is 1 to
  100,000, with a default of 10.
- `"opNum"`: The operation sequence number within the specified commit to start reading
  from in the change-log stream data. The default is 1.
"""
function get_sparql_stream(; aws_config::AbstractAWSConfig=current_aws_config())
    return neptunedata(
        "GET", "/sparql/stream"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_sparql_stream(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptunedata(
        "GET",
        "/sparql/stream",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_gremlin_queries()
    list_gremlin_queries(params::Dict{String,<:Any})

Lists active Gremlin queries. See Gremlin query status API for details about the output.
When invoking this operation in a Neptune cluster that has IAM authentication enabled, the
IAM user or role making the request must have a policy attached that allows the
neptune-db:GetQueryStatus IAM action in that cluster. Note that the
neptune-db:QueryLanguage:Gremlin IAM condition key can be used in the policy document to
restrict the use of Gremlin queries (see Condition keys available in Neptune IAM
data-access policy statements).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"includeWaiting"`: If set to TRUE, the list returned includes waiting queries. The
  default is FALSE;
"""
function list_gremlin_queries(; aws_config::AbstractAWSConfig=current_aws_config())
    return neptunedata(
        "GET", "/gremlin/status"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_gremlin_queries(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptunedata(
        "GET",
        "/gremlin/status",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_loader_jobs()
    list_loader_jobs(params::Dict{String,<:Any})

Retrieves a list of the loadIds for all active loader jobs. When invoking this operation in
a Neptune cluster that has IAM authentication enabled, the IAM user or role making the
request must have a policy attached that allows the neptune-db:ListLoaderJobs IAM action in
that cluster..

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"includeQueuedLoads"`: An optional parameter that can be used to exclude the load IDs of
  queued load requests when requesting a list of load IDs by setting the parameter to FALSE.
  The default value is TRUE.
- `"limit"`: The number of load IDs to list. Must be a positive integer greater than zero
  and not more than 100 (which is the default).
"""
function list_loader_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return neptunedata(
        "GET", "/loader"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_loader_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptunedata(
        "GET", "/loader", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_mldata_processing_jobs()
    list_mldata_processing_jobs(params::Dict{String,<:Any})

Returns a list of Neptune ML data processing jobs. See Listing active data-processing jobs
using the Neptune ML dataprocessing command. When invoking this operation in a Neptune
cluster that has IAM authentication enabled, the IAM user or role making the request must
have a policy attached that allows the neptune-db:ListMLDataProcessingJobs IAM action in
that cluster.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxItems"`: The maximum number of items to return (from 1 to 1024; the default is 10).
- `"neptuneIamRoleArn"`: The ARN of an IAM role that provides Neptune access to SageMaker
  and Amazon S3 resources. This must be listed in your DB cluster parameter group or an error
  will occur.
"""
function list_mldata_processing_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return neptunedata(
        "GET", "/ml/dataprocessing"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_mldata_processing_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptunedata(
        "GET",
        "/ml/dataprocessing",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_mlendpoints()
    list_mlendpoints(params::Dict{String,<:Any})

Lists existing inference endpoints. See Managing inference endpoints using the endpoints
command. When invoking this operation in a Neptune cluster that has IAM authentication
enabled, the IAM user or role making the request must have a policy attached that allows
the neptune-db:ListMLEndpoints IAM action in that cluster.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxItems"`: The maximum number of items to return (from 1 to 1024; the default is 10.
- `"neptuneIamRoleArn"`: The ARN of an IAM role that provides Neptune access to SageMaker
  and Amazon S3 resources. This must be listed in your DB cluster parameter group or an error
  will occur.
"""
function list_mlendpoints(; aws_config::AbstractAWSConfig=current_aws_config())
    return neptunedata(
        "GET", "/ml/endpoints"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_mlendpoints(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptunedata(
        "GET",
        "/ml/endpoints",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_mlmodel_training_jobs()
    list_mlmodel_training_jobs(params::Dict{String,<:Any})

Lists Neptune ML model-training jobs. See Model training using the modeltraining command.
When invoking this operation in a Neptune cluster that has IAM authentication enabled, the
IAM user or role making the request must have a policy attached that allows the
neptune-db:neptune-db:ListMLModelTrainingJobs IAM action in that cluster.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxItems"`: The maximum number of items to return (from 1 to 1024; the default is 10).
- `"neptuneIamRoleArn"`: The ARN of an IAM role that provides Neptune access to SageMaker
  and Amazon S3 resources. This must be listed in your DB cluster parameter group or an error
  will occur.
"""
function list_mlmodel_training_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return neptunedata(
        "GET", "/ml/modeltraining"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_mlmodel_training_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptunedata(
        "GET",
        "/ml/modeltraining",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_mlmodel_transform_jobs()
    list_mlmodel_transform_jobs(params::Dict{String,<:Any})

Returns a list of model transform job IDs. See Use a trained model to generate new model
artifacts. When invoking this operation in a Neptune cluster that has IAM authentication
enabled, the IAM user or role making the request must have a policy attached that allows
the neptune-db:ListMLModelTransformJobs IAM action in that cluster.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxItems"`: The maximum number of items to return (from 1 to 1024; the default is 10).
- `"neptuneIamRoleArn"`: The ARN of an IAM role that provides Neptune access to SageMaker
  and Amazon S3 resources. This must be listed in your DB cluster parameter group or an error
  will occur.
"""
function list_mlmodel_transform_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return neptunedata(
        "GET", "/ml/modeltransform"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_mlmodel_transform_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptunedata(
        "GET",
        "/ml/modeltransform",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_open_cypher_queries()
    list_open_cypher_queries(params::Dict{String,<:Any})

Lists active openCypher queries. See Neptune openCypher status endpoint for more
information. When invoking this operation in a Neptune cluster that has IAM authentication
enabled, the IAM user or role making the request must have a policy attached that allows
the neptune-db:GetQueryStatus IAM action in that cluster. Note that the
neptune-db:QueryLanguage:OpenCypher IAM condition key can be used in the policy document to
restrict the use of openCypher queries (see Condition keys available in Neptune IAM
data-access policy statements).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"includeWaiting"`:  When set to TRUE and other parameters are not present, causes status
  information to be returned for waiting queries as well as for running queries.
"""
function list_open_cypher_queries(; aws_config::AbstractAWSConfig=current_aws_config())
    return neptunedata(
        "GET", "/opencypher/status"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_open_cypher_queries(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptunedata(
        "GET",
        "/opencypher/status",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    manage_propertygraph_statistics()
    manage_propertygraph_statistics(params::Dict{String,<:Any})

Manages the generation and use of property graph statistics. When invoking this operation
in a Neptune cluster that has IAM authentication enabled, the IAM user or role making the
request must have a policy attached that allows the neptune-db:ManageStatistics IAM action
in that cluster.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"mode"`: The statistics generation mode. One of: DISABLE_AUTOCOMPUTE,
  ENABLE_AUTOCOMPUTE, or REFRESH, the last of which manually triggers DFE statistics
  generation.
"""
function manage_propertygraph_statistics(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptunedata(
        "POST",
        "/propertygraph/statistics";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function manage_propertygraph_statistics(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptunedata(
        "POST",
        "/propertygraph/statistics",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    manage_sparql_statistics()
    manage_sparql_statistics(params::Dict{String,<:Any})

Manages the generation and use of RDF graph statistics. When invoking this operation in a
Neptune cluster that has IAM authentication enabled, the IAM user or role making the
request must have a policy attached that allows the neptune-db:ManageStatistics IAM action
in that cluster.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"mode"`: The statistics generation mode. One of: DISABLE_AUTOCOMPUTE,
  ENABLE_AUTOCOMPUTE, or REFRESH, the last of which manually triggers DFE statistics
  generation.
"""
function manage_sparql_statistics(; aws_config::AbstractAWSConfig=current_aws_config())
    return neptunedata(
        "POST", "/sparql/statistics"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function manage_sparql_statistics(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptunedata(
        "POST",
        "/sparql/statistics",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_loader_job(format, iam_role_arn, region, source)
    start_loader_job(format, iam_role_arn, region, source, params::Dict{String,<:Any})

Starts a Neptune bulk loader job to load data from an Amazon S3 bucket into a Neptune DB
instance. See Using the Amazon Neptune Bulk Loader to Ingest Data. When invoking this
operation in a Neptune cluster that has IAM authentication enabled, the IAM user or role
making the request must have a policy attached that allows the neptune-db:StartLoaderJob
IAM action in that cluster.

# Arguments
- `format`: The format of the data. For more information about data formats for the Neptune
  Loader command, see Load Data Formats.  Allowed values      csv  for the Gremlin CSV data
  format.     opencypher  for the openCypher CSV data format.     ntriples  for the N-Triples
  RDF data format.     nquads  for the N-Quads RDF data format.     rdfxml  for the RDFXML
  RDF data format.     turtle  for the Turtle RDF data format.
- `iam_role_arn`: The Amazon Resource Name (ARN) for an IAM role to be assumed by the
  Neptune DB instance for access to the S3 bucket. The IAM role ARN provided here should be
  attached to the DB cluster (see Adding the IAM Role to an Amazon Neptune Cluster.
- `region`: The Amazon region of the S3 bucket. This must match the Amazon Region of the DB
  cluster.
- `source`: The source parameter accepts an S3 URI that identifies a single file, multiple
  files, a folder, or multiple folders. Neptune loads every data file in any folder that is
  specified. The URI can be in any of the following formats.
  s3://(bucket_name)/(object-key-name)
  https://s3.amazonaws.com/(bucket_name)/(object-key-name)
  https://s3.us-east-1.amazonaws.com/(bucket_name)/(object-key-name)    The object-key-name
  element of the URI is equivalent to the prefix parameter in an S3 ListObjects API call. It
  identifies all the objects in the specified S3 bucket whose names begin with that prefix.
  That can be a single file or folder, or multiple files and/or folders. The specified folder
  or folders can contain multiple vertex files and multiple edge files.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"dependencies"`: This is an optional parameter that can make a queued load request
  contingent on the successful completion of one or more previous jobs in the queue. Neptune
  can queue up as many as 64 load requests at a time, if their queueRequest parameters are
  set to \"TRUE\". The dependencies parameter lets you make execution of such a queued
  request dependent on the successful completion of one or more specified previous requests
  in the queue. For example, if load Job-A and Job-B are independent of each other, but load
  Job-C needs Job-A and Job-B to be finished before it begins, proceed as follows:   Submit
  load-job-A and load-job-B one after another in any order, and save their load-ids.   Submit
  load-job-C with the load-ids of the two jobs in its dependencies field:   Because of the
  dependencies parameter, the bulk loader will not start Job-C until Job-A and Job-B have
  completed successfully. If either one of them fails, Job-C will not be executed, and its
  status will be set to LOAD_FAILED_BECAUSE_DEPENDENCY_NOT_SATISFIED. You can set up multiple
  levels of dependency in this way, so that the failure of one job will cause all requests
  that are directly or indirectly dependent on it to be cancelled.
- `"failOnError"`:   failOnError    –   A flag to toggle a complete stop on an error.
  Allowed values: \"TRUE\", \"FALSE\".  Default value: \"TRUE\". When this parameter is set
  to \"FALSE\", the loader tries to load all the data in the location specified, skipping any
  entries with errors. When this parameter is set to \"TRUE\", the loader stops as soon as it
  encounters an error. Data loaded up to that point persists.
- `"mode"`: The load job mode.  Allowed values: RESUME, NEW, AUTO.  Default value: AUTO.
     RESUME   –   In RESUME mode, the loader looks for a previous load from this source,
  and if it finds one, resumes that load job. If no previous load job is found, the loader
  stops. The loader avoids reloading files that were successfully loaded in a previous job.
  It only tries to process failed files. If you dropped previously loaded data from your
  Neptune cluster, that data is not reloaded in this mode. If a previous load job loaded all
  files from the same source successfully, nothing is reloaded, and the loader returns
  success.    NEW   –   In NEW mode, the creates a new load request regardless of any
  previous loads. You can use this mode to reload all the data from a source after dropping
  previously loaded data from your Neptune cluster, or to load new data available at the same
  source.    AUTO   –   In AUTO mode, the loader looks for a previous load job from the
  same source, and if it finds one, resumes that job, just as in RESUME mode. If the loader
  doesn't find a previous load job from the same source, it loads all data from the source,
  just as in NEW mode.
- `"parallelism"`: The optional parallelism parameter can be set to reduce the number of
  threads used by the bulk load process.  Allowed values:    LOW –   The number of threads
  used is the number of available vCPUs divided by 8.    MEDIUM –   The number of threads
  used is the number of available vCPUs divided by 2.    HIGH –   The number of threads
  used is the same as the number of available vCPUs.    OVERSUBSCRIBE –   The number of
  threads used is the number of available vCPUs multiplied by 2. If this value is used, the
  bulk loader takes up all available resources. This does not mean, however, that the
  OVERSUBSCRIBE setting results in 100% CPU utilization. Because the load operation is I/O
  bound, the highest CPU utilization to expect is in the 60% to 70% range.    Default value:
  HIGH  The parallelism setting can sometimes result in a deadlock between threads when
  loading openCypher data. When this happens, Neptune returns the LOAD_DATA_DEADLOCK error.
  You can generally fix the issue by setting parallelism to a lower setting and retrying the
  load command.
- `"parserConfiguration"`:   parserConfiguration    –   An optional object with
  additional parser configuration values. Each of the child parameters is also optional:
    namedGraphUri    –   The default graph for all RDF formats when no graph is specified
  (for non-quads formats and NQUAD entries with no graph). The default is
  https://aws.amazon.com/neptune/vocab/v01/DefaultNamedGraph.     baseUri    –   The base
  URI for RDF/XML and Turtle formats. The default is https://aws.amazon.com/neptune/default.
     allowEmptyStrings    –   Gremlin users need to be able to pass empty string
  values(\"\") as node and edge properties when loading CSV data. If allowEmptyStrings is set
  to false (the default), such empty strings are treated as nulls and are not loaded. If
  allowEmptyStrings is set to true, the loader treats empty strings as valid property values
  and loads them accordingly.
- `"queueRequest"`: This is an optional flag parameter that indicates whether the load
  request can be queued up or not.  You don't have to wait for one load job to complete
  before issuing the next one, because Neptune can queue up as many as 64 jobs at a time,
  provided that their queueRequest parameters are all set to \"TRUE\". The queue order of the
  jobs will be first-in-first-out (FIFO). If the queueRequest parameter is omitted or set to
  \"FALSE\", the load request will fail if another load job is already running.  Allowed
  values: \"TRUE\", \"FALSE\".  Default value: \"FALSE\".
- `"updateSingleCardinalityProperties"`:  updateSingleCardinalityProperties is an optional
  parameter that controls how the bulk loader treats a new value for single-cardinality
  vertex or edge properties. This is not supported for loading openCypher data.  Allowed
  values: \"TRUE\", \"FALSE\".  Default value: \"FALSE\". By default, or when
  updateSingleCardinalityProperties is explicitly set to \"FALSE\", the loader treats a new
  value as an error, because it violates single cardinality. When
  updateSingleCardinalityProperties is set to \"TRUE\", on the other hand, the bulk loader
  replaces the existing value with the new one. If multiple edge or single-cardinality vertex
  property values are provided in the source file(s) being loaded, the final value at the end
  of the bulk load could be any one of those new values. The loader only guarantees that the
  existing value has been replaced by one of the new ones.
- `"userProvidedEdgeIds"`: This parameter is required only when loading openCypher data
  that contains relationship IDs. It must be included and set to True when openCypher
  relationship IDs are explicitly provided in the load data (recommended). When
  userProvidedEdgeIds is absent or set to True, an :ID column must be present in every
  relationship file in the load. When userProvidedEdgeIds is present and set to False,
  relationship files in the load must not contain an :ID column. Instead, the Neptune loader
  automatically generates an ID for each relationship. It's useful to provide relationship
  IDs explicitly so that the loader can resume loading after error in the CSV data have been
  fixed, without having to reload any relationships that have already been loaded. If
  relationship IDs have not been explicitly assigned, the loader cannot resume a failed load
  if any relationship file has had to be corrected, and must instead reload all the
  relationships.
"""
function start_loader_job(
    format, iamRoleArn, region, source; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptunedata(
        "POST",
        "/loader",
        Dict{String,Any}(
            "format" => format,
            "iamRoleArn" => iamRoleArn,
            "region" => region,
            "source" => source,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_loader_job(
    format,
    iamRoleArn,
    region,
    source,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptunedata(
        "POST",
        "/loader",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "format" => format,
                    "iamRoleArn" => iamRoleArn,
                    "region" => region,
                    "source" => source,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_mldata_processing_job(input_data_s3_location, processed_data_s3_location)
    start_mldata_processing_job(input_data_s3_location, processed_data_s3_location, params::Dict{String,<:Any})

Creates a new Neptune ML data processing job for processing the graph data exported from
Neptune for training. See The dataprocessing command. When invoking this operation in a
Neptune cluster that has IAM authentication enabled, the IAM user or role making the
request must have a policy attached that allows the
neptune-db:StartMLModelDataProcessingJob IAM action in that cluster.

# Arguments
- `input_data_s3_location`: The URI of the Amazon S3 location where you want SageMaker to
  download the data needed to run the data processing job.
- `processed_data_s3_location`: The URI of the Amazon S3 location where you want SageMaker
  to save the results of a data processing job.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"configFileName"`: A data specification file that describes how to load the exported
  graph data for training. The file is automatically generated by the Neptune export toolkit.
  The default is training-data-configuration.json.
- `"id"`: A unique identifier for the new job. The default is an autogenerated UUID.
- `"modelType"`: One of the two model types that Neptune ML currently supports:
  heterogeneous graph models (heterogeneous), and knowledge graph (kge). The default is none.
  If not specified, Neptune ML chooses the model type automatically based on the data.
- `"neptuneIamRoleArn"`: The Amazon Resource Name (ARN) of an IAM role that SageMaker can
  assume to perform tasks on your behalf. This must be listed in your DB cluster parameter
  group or an error will occur.
- `"previousDataProcessingJobId"`: The job ID of a completed data processing job run on an
  earlier version of the data.
- `"processingInstanceType"`: The type of ML instance used during data processing. Its
  memory should be large enough to hold the processed dataset. The default is the smallest
  ml.r5 type whose memory is ten times larger than the size of the exported graph data on
  disk.
- `"processingInstanceVolumeSizeInGB"`: The disk volume size of the processing instance.
  Both input data and processed data are stored on disk, so the volume size must be large
  enough to hold both data sets. The default is 0. If not specified or 0, Neptune ML chooses
  the volume size automatically based on the data size.
- `"processingTimeOutInSeconds"`: Timeout in seconds for the data processing job. The
  default is 86,400 (1 day).
- `"s3OutputEncryptionKMSKey"`: The Amazon Key Management Service (Amazon KMS) key that
  SageMaker uses to encrypt the output of the processing job. The default is none.
- `"sagemakerIamRoleArn"`: The ARN of an IAM role for SageMaker execution. This must be
  listed in your DB cluster parameter group or an error will occur.
- `"securityGroupIds"`: The VPC security group IDs. The default is None.
- `"subnets"`: The IDs of the subnets in the Neptune VPC. The default is None.
- `"volumeEncryptionKMSKey"`: The Amazon Key Management Service (Amazon KMS) key that
  SageMaker uses to encrypt data on the storage volume attached to the ML compute instances
  that run the training job. The default is None.
"""
function start_mldata_processing_job(
    inputDataS3Location,
    processedDataS3Location;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptunedata(
        "POST",
        "/ml/dataprocessing",
        Dict{String,Any}(
            "inputDataS3Location" => inputDataS3Location,
            "processedDataS3Location" => processedDataS3Location,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_mldata_processing_job(
    inputDataS3Location,
    processedDataS3Location,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptunedata(
        "POST",
        "/ml/dataprocessing",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "inputDataS3Location" => inputDataS3Location,
                    "processedDataS3Location" => processedDataS3Location,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_mlmodel_training_job(data_processing_job_id, train_model_s3_location)
    start_mlmodel_training_job(data_processing_job_id, train_model_s3_location, params::Dict{String,<:Any})

Creates a new Neptune ML model training job. See Model training using the modeltraining
command. When invoking this operation in a Neptune cluster that has IAM authentication
enabled, the IAM user or role making the request must have a policy attached that allows
the neptune-db:StartMLModelTrainingJob IAM action in that cluster.

# Arguments
- `data_processing_job_id`: The job ID of the completed data-processing job that has
  created the data that the training will work with.
- `train_model_s3_location`: The location in Amazon S3 where the model artifacts are to be
  stored.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"baseProcessingInstanceType"`: The type of ML instance used in preparing and managing
  training of ML models. This is a CPU instance chosen based on memory requirements for
  processing the training data and model.
- `"customModelTrainingParameters"`: The configuration for custom model training. This is a
  JSON object.
- `"enableManagedSpotTraining"`: Optimizes the cost of training machine-learning models by
  using Amazon Elastic Compute Cloud spot instances. The default is False.
- `"id"`: A unique identifier for the new job. The default is An autogenerated UUID.
- `"maxHPONumberOfTrainingJobs"`: Maximum total number of training jobs to start for the
  hyperparameter tuning job. The default is 2. Neptune ML automatically tunes the
  hyperparameters of the machine learning model. To obtain a model that performs well, use at
  least 10 jobs (in other words, set maxHPONumberOfTrainingJobs to 10). In general, the more
  tuning runs, the better the results.
- `"maxHPOParallelTrainingJobs"`: Maximum number of parallel training jobs to start for the
  hyperparameter tuning job. The default is 2. The number of parallel jobs you can run is
  limited by the available resources on your training instance.
- `"neptuneIamRoleArn"`: The ARN of an IAM role that provides Neptune access to SageMaker
  and Amazon S3 resources. This must be listed in your DB cluster parameter group or an error
  will occur.
- `"previousModelTrainingJobId"`: The job ID of a completed model-training job that you
  want to update incrementally based on updated data.
- `"s3OutputEncryptionKMSKey"`: The Amazon Key Management Service (KMS) key that SageMaker
  uses to encrypt the output of the processing job. The default is none.
- `"sagemakerIamRoleArn"`: The ARN of an IAM role for SageMaker execution.This must be
  listed in your DB cluster parameter group or an error will occur.
- `"securityGroupIds"`: The VPC security group IDs. The default is None.
- `"subnets"`: The IDs of the subnets in the Neptune VPC. The default is None.
- `"trainingInstanceType"`: The type of ML instance used for model training. All Neptune ML
  models support CPU, GPU, and multiGPU training. The default is ml.p3.2xlarge. Choosing the
  right instance type for training depends on the task type, graph size, and your budget.
- `"trainingInstanceVolumeSizeInGB"`: The disk volume size of the training instance. Both
  input data and the output model are stored on disk, so the volume size must be large enough
  to hold both data sets. The default is 0. If not specified or 0, Neptune ML selects a disk
  volume size based on the recommendation generated in the data processing step.
- `"trainingTimeOutInSeconds"`: Timeout in seconds for the training job. The default is
  86,400 (1 day).
- `"volumeEncryptionKMSKey"`: The Amazon Key Management Service (KMS) key that SageMaker
  uses to encrypt data on the storage volume attached to the ML compute instances that run
  the training job. The default is None.
"""
function start_mlmodel_training_job(
    dataProcessingJobId,
    trainModelS3Location;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptunedata(
        "POST",
        "/ml/modeltraining",
        Dict{String,Any}(
            "dataProcessingJobId" => dataProcessingJobId,
            "trainModelS3Location" => trainModelS3Location,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_mlmodel_training_job(
    dataProcessingJobId,
    trainModelS3Location,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptunedata(
        "POST",
        "/ml/modeltraining",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "dataProcessingJobId" => dataProcessingJobId,
                    "trainModelS3Location" => trainModelS3Location,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_mlmodel_transform_job(model_transform_output_s3_location)
    start_mlmodel_transform_job(model_transform_output_s3_location, params::Dict{String,<:Any})

Creates a new model transform job. See Use a trained model to generate new model artifacts.
When invoking this operation in a Neptune cluster that has IAM authentication enabled, the
IAM user or role making the request must have a policy attached that allows the
neptune-db:StartMLModelTransformJob IAM action in that cluster.

# Arguments
- `model_transform_output_s3_location`: The location in Amazon S3 where the model artifacts
  are to be stored.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"baseProcessingInstanceType"`: The type of ML instance used in preparing and managing
  training of ML models. This is an ML compute instance chosen based on memory requirements
  for processing the training data and model.
- `"baseProcessingInstanceVolumeSizeInGB"`: The disk volume size of the training instance
  in gigabytes. The default is 0. Both input data and the output model are stored on disk, so
  the volume size must be large enough to hold both data sets. If not specified or 0, Neptune
  ML selects a disk volume size based on the recommendation generated in the data processing
  step.
- `"customModelTransformParameters"`: Configuration information for a model transform using
  a custom model. The customModelTransformParameters object contains the following fields,
  which must have values compatible with the saved model parameters from the training job:
- `"dataProcessingJobId"`: The job ID of a completed data-processing job. You must include
  either dataProcessingJobId and a mlModelTrainingJobId, or a trainingJobName.
- `"id"`: A unique identifier for the new job. The default is an autogenerated UUID.
- `"mlModelTrainingJobId"`: The job ID of a completed model-training job. You must include
  either dataProcessingJobId and a mlModelTrainingJobId, or a trainingJobName.
- `"neptuneIamRoleArn"`: The ARN of an IAM role that provides Neptune access to SageMaker
  and Amazon S3 resources. This must be listed in your DB cluster parameter group or an error
  will occur.
- `"s3OutputEncryptionKMSKey"`: The Amazon Key Management Service (KMS) key that SageMaker
  uses to encrypt the output of the processing job. The default is none.
- `"sagemakerIamRoleArn"`: The ARN of an IAM role for SageMaker execution. This must be
  listed in your DB cluster parameter group or an error will occur.
- `"securityGroupIds"`: The VPC security group IDs. The default is None.
- `"subnets"`: The IDs of the subnets in the Neptune VPC. The default is None.
- `"trainingJobName"`: The name of a completed SageMaker training job. You must include
  either dataProcessingJobId and a mlModelTrainingJobId, or a trainingJobName.
- `"volumeEncryptionKMSKey"`: The Amazon Key Management Service (KMS) key that SageMaker
  uses to encrypt data on the storage volume attached to the ML compute instances that run
  the training job. The default is None.
"""
function start_mlmodel_transform_job(
    modelTransformOutputS3Location; aws_config::AbstractAWSConfig=current_aws_config()
)
    return neptunedata(
        "POST",
        "/ml/modeltransform",
        Dict{String,Any}(
            "modelTransformOutputS3Location" => modelTransformOutputS3Location
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_mlmodel_transform_job(
    modelTransformOutputS3Location,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return neptunedata(
        "POST",
        "/ml/modeltransform",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "modelTransformOutputS3Location" => modelTransformOutputS3Location
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

module AWSMetadata

using Base64
using ..AWSExceptions
using GitHub
using HTTP
using JSON
using Mocking
using OrderedCollections: LittleDict, OrderedDict

const services_path = joinpath(@__DIR__, "AWSServices.jl")

include(joinpath("api_generation", "utilities.jl"))
include(joinpath("api_generation", "high_level.jl"))
include(joinpath("api_generation", "low_level.jl"))

"""
    parse_aws_metadata()

Generate low and high level wrappers for each AWS Service based on their definitions in the
[aws-sdk-js GitHub Repository](https://github.com/aws/aws-sdk-js/tree/master/apis).

Low level wrappers are written into `src/AWSServices.jl`, while high level wrappers API
wrappers are written into their respective files in `src/services/{service}.jl`.
"""
function parse_aws_metadata()
    auth = GitHub.authenticate(ENV["GITHUB_AUTH"])
    repo_name = "aws/aws-sdk-js"

    service_files = _get_service_files(repo_name, auth)

    _generate_low_level_wrappers(service_files, auth)
    _generate_high_level_wrapper(service_files, auth)
    return nothing
end

end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: marketplace_agreement
using AWS.Compat
using AWS.UUIDs

"""
    describe_agreement(agreement_id)
    describe_agreement(agreement_id, params::Dict{String,<:Any})

Provides details about an agreement, such as the proposer, acceptor, start date, and end
date.

# Arguments
- `agreement_id`: The unique identifier of the agreement.

"""
function describe_agreement(agreementId; aws_config::AbstractAWSConfig=current_aws_config())
    return marketplace_agreement(
        "DescribeAgreement",
        Dict{String,Any}("agreementId" => agreementId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_agreement(
    agreementId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return marketplace_agreement(
        "DescribeAgreement",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("agreementId" => agreementId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_agreement_terms(agreement_id)
    get_agreement_terms(agreement_id, params::Dict{String,<:Any})

Obtains details about the terms in an agreement that you participated in as proposer or
acceptor. The details include:    TermType – The type of term, such as LegalTerm,
RenewalTerm, or ConfigurableUpfrontPricingTerm.    TermID – The ID of the particular
term, which is common between offer and agreement.    TermPayload – The key information
contained in the term, such as the EULA for LegalTerm or pricing and dimensions for various
pricing terms, such as ConfigurableUpfrontPricingTerm or UsageBasedPricingTerm.
Configuration – The buyer/acceptor's selection at the time of agreement creation, such as
the number of units purchased for a dimension or setting the EnableAutoRenew flag.

# Arguments
- `agreement_id`: The unique identifier of the agreement.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of agreements to return in the response.
- `"nextToken"`: A token to specify where to start pagination
"""
function get_agreement_terms(
    agreementId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return marketplace_agreement(
        "GetAgreementTerms",
        Dict{String,Any}("agreementId" => agreementId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_agreement_terms(
    agreementId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return marketplace_agreement(
        "GetAgreementTerms",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("agreementId" => agreementId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    search_agreements()
    search_agreements(params::Dict{String,<:Any})

Searches across all agreements that a proposer or an acceptor has in AWS Marketplace. The
search returns a list of agreements with basic agreement information. The following filter
combinations are supported:    PartyType as Proposer + AgreementType + ResourceIdentifier
  PartyType as Proposer + AgreementType + OfferId     PartyType as Proposer + AgreementType
+ AcceptorAccountId     PartyType as Proposer + AgreementType + Status     PartyType as
Proposer + AgreementType + ResourceIdentifier + Status     PartyType as Proposer +
AgreementType + OfferId + Status     PartyType as Proposer + AgreementType +
AcceptorAccountId + Status     PartyType as Proposer + AgreementType + ResourceType +
Status     PartyType as Proposer + AgreementType + AcceptorAccountId + ResourceType +
Status     PartyType as Proposer + AgreementType + AcceptorAccountId + OfferId
PartyType as Proposer + AgreementType + AcceptorAccountId + OfferId + Status     PartyType
as Proposer + AgreementType + AcceptorAccountId + ResourceIdentifier     PartyType as
Proposer + AgreementType + AcceptorAccountId + ResourceIdentifier + Status     PartyType as
Proposer + AgreementType + AcceptorAccountId + ResourceType

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"catalog"`: The catalog in which the agreement was created.
- `"filters"`: The filter name and value pair used to return a specific list of results.
  The following filters are supported:    ResourceIdentifier – The unique identifier of the
  resource.    ResourceType – Type of the resource, which is the product (AmiProduct,
  ContainerProduct, or SaaSProduct).    PartyType – The party type (either Acceptor or
  Proposer) of the caller. For agreements where the caller is the proposer, use the Proposer
  filter. For agreements where the caller is the acceptor, use the Acceptor filter.
  AcceptorAccountId – The AWS account ID of the party accepting the agreement terms.
  OfferId – The unique identifier of the offer in which the terms are registered in the
  agreement token.    Status – The current status of the agreement. Values include ACTIVE,
  ARCHIVED, CANCELLED, EXPIRED, RENEWED, REPLACED, and TERMINATED.    BeforeEndTime – A
  date used to filter agreements with a date before the endTime of an agreement.
  AfterEndTime – A date used to filter agreements with a date after the endTime of an
  agreement.    AgreementType – The type of agreement. Values include PurchaseAgreement or
  VendorInsightsAgreement.
- `"maxResults"`: The maximum number of agreements to return in the response.
- `"nextToken"`: A token to specify where to start pagination.
- `"sort"`: An object that contains the SortBy and SortOrder attributes.
"""
function search_agreements(; aws_config::AbstractAWSConfig=current_aws_config())
    return marketplace_agreement(
        "SearchAgreements"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function search_agreements(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return marketplace_agreement(
        "SearchAgreements", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: mturk
using AWS.Compat
using AWS.UUIDs

"""
    accept_qualification_request(qualification_request_id)
    accept_qualification_request(qualification_request_id, params::Dict{String,<:Any})

 The AcceptQualificationRequest operation approves a Worker's request for a Qualification.
 Only the owner of the Qualification type can grant a Qualification request for that type.
 A successful request for the AcceptQualificationRequest operation returns with no errors
and an empty body.

# Arguments
- `qualification_request_id`: The ID of the Qualification request, as returned by the
  GetQualificationRequests operation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"IntegerValue"`:  The value of the Qualification. You can omit this value if you are
  using the presence or absence of the Qualification as the basis for a HIT requirement.
"""
function accept_qualification_request(
    QualificationRequestId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mturk(
        "AcceptQualificationRequest",
        Dict{String,Any}("QualificationRequestId" => QualificationRequestId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function accept_qualification_request(
    QualificationRequestId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mturk(
        "AcceptQualificationRequest",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("QualificationRequestId" => QualificationRequestId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    approve_assignment(assignment_id)
    approve_assignment(assignment_id, params::Dict{String,<:Any})

 The ApproveAssignment operation approves the results of a completed assignment.
Approving an assignment initiates two payments from the Requester's Amazon.com account
The Worker who submitted the results is paid the reward specified in the HIT.     Amazon
Mechanical Turk fees are debited.     If the Requester's account does not have adequate
funds for these payments, the call to ApproveAssignment returns an exception, and the
approval is not processed. You can include an optional feedback message with the approval,
which the Worker can see in the Status section of the web site.   You can also call this
operation for assignments that were previous rejected and approve them by explicitly
overriding the previous rejection. This only works on rejected assignments that were
submitted within the previous 30 days and only if the assignment's related HIT has not been
deleted.

# Arguments
- `assignment_id`:  The ID of the assignment. The assignment must correspond to a HIT
  created by the Requester.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"OverrideRejection"`:  A flag indicating that an assignment should be approved even if
  it was previously rejected. Defaults to False.
- `"RequesterFeedback"`:  A message for the Worker, which the Worker can see in the Status
  section of the web site.
"""
function approve_assignment(
    AssignmentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mturk(
        "ApproveAssignment",
        Dict{String,Any}("AssignmentId" => AssignmentId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function approve_assignment(
    AssignmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mturk(
        "ApproveAssignment",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AssignmentId" => AssignmentId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_qualification_with_worker(qualification_type_id, worker_id)
    associate_qualification_with_worker(qualification_type_id, worker_id, params::Dict{String,<:Any})

 The AssociateQualificationWithWorker operation gives a Worker a Qualification.
AssociateQualificationWithWorker does not require that the Worker submit a Qualification
request. It gives the Qualification directly to the Worker.   You can only assign a
Qualification of a Qualification type that you created (using the CreateQualificationType
operation).    Note: AssociateQualificationWithWorker does not affect any pending
Qualification requests for the Qualification by the Worker. If you assign a Qualification
to a Worker, then later grant a Qualification request made by the Worker, the granting of
the request may modify the Qualification score. To resolve a pending Qualification request
without affecting the Qualification the Worker already has, reject the request with the
RejectQualificationRequest operation.

# Arguments
- `qualification_type_id`: The ID of the Qualification type to use for the assigned
  Qualification.
- `worker_id`:  The ID of the Worker to whom the Qualification is being assigned. Worker
  IDs are included with submitted HIT assignments and Qualification requests.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"IntegerValue"`: The value of the Qualification to assign.
- `"SendNotification"`:  Specifies whether to send a notification email message to the
  Worker saying that the qualification was assigned to the Worker. Note: this is true by
  default.
"""
function associate_qualification_with_worker(
    QualificationTypeId, WorkerId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mturk(
        "AssociateQualificationWithWorker",
        Dict{String,Any}(
            "QualificationTypeId" => QualificationTypeId, "WorkerId" => WorkerId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_qualification_with_worker(
    QualificationTypeId,
    WorkerId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mturk(
        "AssociateQualificationWithWorker",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "QualificationTypeId" => QualificationTypeId, "WorkerId" => WorkerId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_additional_assignments_for_hit(hitid, number_of_additional_assignments)
    create_additional_assignments_for_hit(hitid, number_of_additional_assignments, params::Dict{String,<:Any})

 The CreateAdditionalAssignmentsForHIT operation increases the maximum number of
assignments of an existing HIT.   To extend the maximum number of assignments, specify the
number of additional assignments.    HITs created with fewer than 10 assignments cannot be
extended to have 10 or more assignments. Attempting to add assignments in a way that brings
the total number of assignments for a HIT from fewer than 10 assignments to 10 or more
assignments will result in an AWS.MechanicalTurk.InvalidMaximumAssignmentsIncrease
exception.   HITs that were created before July 22, 2015 cannot be extended. Attempting to
extend HITs that were created before July 22, 2015 will result in an
AWS.MechanicalTurk.HITTooOldForExtension exception.

# Arguments
- `hitid`: The ID of the HIT to extend.
- `number_of_additional_assignments`: The number of additional assignments to request for
  this HIT.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"UniqueRequestToken"`:  A unique identifier for this request, which allows you to retry
  the call on error without extending the HIT multiple times. This is useful in cases such as
  network timeouts where it is unclear whether or not the call succeeded on the server. If
  the extend HIT already exists in the system from a previous call using the same
  UniqueRequestToken, subsequent calls will return an error with a message containing the
  request ID.
"""
function create_additional_assignments_for_hit(
    HITId, NumberOfAdditionalAssignments; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mturk(
        "CreateAdditionalAssignmentsForHIT",
        Dict{String,Any}(
            "HITId" => HITId,
            "NumberOfAdditionalAssignments" => NumberOfAdditionalAssignments,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_additional_assignments_for_hit(
    HITId,
    NumberOfAdditionalAssignments,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mturk(
        "CreateAdditionalAssignmentsForHIT",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "HITId" => HITId,
                    "NumberOfAdditionalAssignments" => NumberOfAdditionalAssignments,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_hit(assignment_duration_in_seconds, description, lifetime_in_seconds, reward, title)
    create_hit(assignment_duration_in_seconds, description, lifetime_in_seconds, reward, title, params::Dict{String,<:Any})

The CreateHIT operation creates a new Human Intelligence Task (HIT). The new HIT is made
available for Workers to find and accept on the Amazon Mechanical Turk website.   This
operation allows you to specify a new HIT by passing in values for the properties of the
HIT, such as its title, reward amount and number of assignments. When you pass these values
to CreateHIT, a new HIT is created for you, with a new HITTypeID. The HITTypeID can be used
to create additional HITs in the future without needing to specify common parameters such
as the title, description and reward amount each time.  An alternative way to create HITs
is to first generate a HITTypeID using the CreateHITType operation and then call the
CreateHITWithHITType operation. This is the recommended best practice for Requesters who
are creating large numbers of HITs.  CreateHIT also supports several ways to provide
question data: by providing a value for the Question parameter that fully specifies the
contents of the HIT, or by providing a HitLayoutId and associated HitLayoutParameters.
If a HIT is created with 10 or more maximum assignments, there is an additional fee. For
more information, see Amazon Mechanical Turk Pricing.

# Arguments
- `assignment_duration_in_seconds`:  The amount of time, in seconds, that a Worker has to
  complete the HIT after accepting it. If a Worker does not complete the assignment within
  the specified duration, the assignment is considered abandoned. If the HIT is still active
  (that is, its lifetime has not elapsed), the assignment becomes available for other users
  to find and accept.
- `description`:  A general description of the HIT. A description includes detailed
  information about the kind of task the HIT contains. On the Amazon Mechanical Turk web
  site, the HIT description appears in the expanded view of search results, and in the HIT
  and assignment screens. A good description gives the user enough information to evaluate
  the HIT before accepting it.
- `lifetime_in_seconds`:  An amount of time, in seconds, after which the HIT is no longer
  available for users to accept. After the lifetime of the HIT elapses, the HIT no longer
  appears in HIT searches, even if not all of the assignments for the HIT have been accepted.
- `reward`:  The amount of money the Requester will pay a Worker for successfully
  completing the HIT.
- `title`:  The title of the HIT. A title should be short and descriptive about the kind of
  task the HIT contains. On the Amazon Mechanical Turk web site, the HIT title appears in
  search results, and everywhere the HIT is mentioned.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AssignmentReviewPolicy"`:  The Assignment-level Review Policy applies to the
  assignments under the HIT. You can specify for Mechanical Turk to take various actions
  based on the policy.
- `"AutoApprovalDelayInSeconds"`:  The number of seconds after an assignment for the HIT
  has been submitted, after which the assignment is considered Approved automatically unless
  the Requester explicitly rejects it.
- `"HITLayoutId"`:  The HITLayoutId allows you to use a pre-existing HIT design with
  placeholder values and create an additional HIT by providing those values as
  HITLayoutParameters.   Constraints: Either a Question parameter or a HITLayoutId parameter
  must be provided.
- `"HITLayoutParameters"`:  If the HITLayoutId is provided, any placeholder values must be
  filled in with values using the HITLayoutParameter structure. For more information, see
  HITLayout.
- `"HITReviewPolicy"`:  The HIT-level Review Policy applies to the HIT. You can specify for
  Mechanical Turk to take various actions based on the policy.
- `"Keywords"`:  One or more words or phrases that describe the HIT, separated by commas.
  These words are used in searches to find HITs.
- `"MaxAssignments"`:  The number of times the HIT can be accepted and completed before the
  HIT becomes unavailable.
- `"QualificationRequirements"`:  Conditions that a Worker's Qualifications must meet in
  order to accept the HIT. A HIT can have between zero and ten Qualification requirements.
  All requirements must be met in order for a Worker to accept the HIT. Additionally, other
  actions can be restricted using the ActionsGuarded field on each QualificationRequirement
  structure.
- `"Question"`:  The data the person completing the HIT uses to produce the results.
  Constraints: Must be a QuestionForm data structure, an ExternalQuestion data structure, or
  an HTMLQuestion data structure. The XML question data must not be larger than 64 kilobytes
  (65,535 bytes) in size, including whitespace.  Either a Question parameter or a HITLayoutId
  parameter must be provided.
- `"RequesterAnnotation"`:  An arbitrary data field. The RequesterAnnotation parameter lets
  your application attach arbitrary data to the HIT for tracking purposes. For example, this
  parameter could be an identifier internal to the Requester's application that corresponds
  with the HIT.   The RequesterAnnotation parameter for a HIT is only visible to the
  Requester who created the HIT. It is not shown to the Worker, or any other Requester.   The
  RequesterAnnotation parameter may be different for each HIT you submit. It does not affect
  how your HITs are grouped.
- `"UniqueRequestToken"`:  A unique identifier for this request which allows you to retry
  the call on error without creating duplicate HITs. This is useful in cases such as network
  timeouts where it is unclear whether or not the call succeeded on the server. If the HIT
  already exists in the system from a previous call using the same UniqueRequestToken,
  subsequent calls will return a AWS.MechanicalTurk.HitAlreadyExists error with a message
  containing the HITId.    Note: It is your responsibility to ensure uniqueness of the token.
  The unique token expires after 24 hours. Subsequent calls using the same UniqueRequestToken
  made after the 24 hour limit could create duplicate HITs.
"""
function create_hit(
    AssignmentDurationInSeconds,
    Description,
    LifetimeInSeconds,
    Reward,
    Title;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mturk(
        "CreateHIT",
        Dict{String,Any}(
            "AssignmentDurationInSeconds" => AssignmentDurationInSeconds,
            "Description" => Description,
            "LifetimeInSeconds" => LifetimeInSeconds,
            "Reward" => Reward,
            "Title" => Title,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_hit(
    AssignmentDurationInSeconds,
    Description,
    LifetimeInSeconds,
    Reward,
    Title,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mturk(
        "CreateHIT",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AssignmentDurationInSeconds" => AssignmentDurationInSeconds,
                    "Description" => Description,
                    "LifetimeInSeconds" => LifetimeInSeconds,
                    "Reward" => Reward,
                    "Title" => Title,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_hittype(assignment_duration_in_seconds, description, reward, title)
    create_hittype(assignment_duration_in_seconds, description, reward, title, params::Dict{String,<:Any})

 The CreateHITType operation creates a new HIT type. This operation allows you to define a
standard set of HIT properties to use when creating HITs. If you register a HIT type with
values that match an existing HIT type, the HIT type ID of the existing type will be
returned.

# Arguments
- `assignment_duration_in_seconds`:  The amount of time, in seconds, that a Worker has to
  complete the HIT after accepting it. If a Worker does not complete the assignment within
  the specified duration, the assignment is considered abandoned. If the HIT is still active
  (that is, its lifetime has not elapsed), the assignment becomes available for other users
  to find and accept.
- `description`:  A general description of the HIT. A description includes detailed
  information about the kind of task the HIT contains. On the Amazon Mechanical Turk web
  site, the HIT description appears in the expanded view of search results, and in the HIT
  and assignment screens. A good description gives the user enough information to evaluate
  the HIT before accepting it.
- `reward`:  The amount of money the Requester will pay a Worker for successfully
  completing the HIT.
- `title`:  The title of the HIT. A title should be short and descriptive about the kind of
  task the HIT contains. On the Amazon Mechanical Turk web site, the HIT title appears in
  search results, and everywhere the HIT is mentioned.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AutoApprovalDelayInSeconds"`:  The number of seconds after an assignment for the HIT
  has been submitted, after which the assignment is considered Approved automatically unless
  the Requester explicitly rejects it.
- `"Keywords"`:  One or more words or phrases that describe the HIT, separated by commas.
  These words are used in searches to find HITs.
- `"QualificationRequirements"`:  Conditions that a Worker's Qualifications must meet in
  order to accept the HIT. A HIT can have between zero and ten Qualification requirements.
  All requirements must be met in order for a Worker to accept the HIT. Additionally, other
  actions can be restricted using the ActionsGuarded field on each QualificationRequirement
  structure.
"""
function create_hittype(
    AssignmentDurationInSeconds,
    Description,
    Reward,
    Title;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mturk(
        "CreateHITType",
        Dict{String,Any}(
            "AssignmentDurationInSeconds" => AssignmentDurationInSeconds,
            "Description" => Description,
            "Reward" => Reward,
            "Title" => Title,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_hittype(
    AssignmentDurationInSeconds,
    Description,
    Reward,
    Title,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mturk(
        "CreateHITType",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AssignmentDurationInSeconds" => AssignmentDurationInSeconds,
                    "Description" => Description,
                    "Reward" => Reward,
                    "Title" => Title,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_hitwith_hittype(hittype_id, lifetime_in_seconds)
    create_hitwith_hittype(hittype_id, lifetime_in_seconds, params::Dict{String,<:Any})

 The CreateHITWithHITType operation creates a new Human Intelligence Task (HIT) using an
existing HITTypeID generated by the CreateHITType operation.   This is an alternative way
to create HITs from the CreateHIT operation. This is the recommended best practice for
Requesters who are creating large numbers of HITs.  CreateHITWithHITType also supports
several ways to provide question data: by providing a value for the Question parameter that
fully specifies the contents of the HIT, or by providing a HitLayoutId and associated
HitLayoutParameters.    If a HIT is created with 10 or more maximum assignments, there is
an additional fee. For more information, see Amazon Mechanical Turk Pricing.

# Arguments
- `hittype_id`: The HIT type ID you want to create this HIT with.
- `lifetime_in_seconds`:  An amount of time, in seconds, after which the HIT is no longer
  available for users to accept. After the lifetime of the HIT elapses, the HIT no longer
  appears in HIT searches, even if not all of the assignments for the HIT have been accepted.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AssignmentReviewPolicy"`:  The Assignment-level Review Policy applies to the
  assignments under the HIT. You can specify for Mechanical Turk to take various actions
  based on the policy.
- `"HITLayoutId"`:  The HITLayoutId allows you to use a pre-existing HIT design with
  placeholder values and create an additional HIT by providing those values as
  HITLayoutParameters.   Constraints: Either a Question parameter or a HITLayoutId parameter
  must be provided.
- `"HITLayoutParameters"`:  If the HITLayoutId is provided, any placeholder values must be
  filled in with values using the HITLayoutParameter structure. For more information, see
  HITLayout.
- `"HITReviewPolicy"`:  The HIT-level Review Policy applies to the HIT. You can specify for
  Mechanical Turk to take various actions based on the policy.
- `"MaxAssignments"`:  The number of times the HIT can be accepted and completed before the
  HIT becomes unavailable.
- `"Question"`:  The data the person completing the HIT uses to produce the results.
  Constraints: Must be a QuestionForm data structure, an ExternalQuestion data structure, or
  an HTMLQuestion data structure. The XML question data must not be larger than 64 kilobytes
  (65,535 bytes) in size, including whitespace.  Either a Question parameter or a HITLayoutId
  parameter must be provided.
- `"RequesterAnnotation"`:  An arbitrary data field. The RequesterAnnotation parameter lets
  your application attach arbitrary data to the HIT for tracking purposes. For example, this
  parameter could be an identifier internal to the Requester's application that corresponds
  with the HIT.   The RequesterAnnotation parameter for a HIT is only visible to the
  Requester who created the HIT. It is not shown to the Worker, or any other Requester.   The
  RequesterAnnotation parameter may be different for each HIT you submit. It does not affect
  how your HITs are grouped.
- `"UniqueRequestToken"`:  A unique identifier for this request which allows you to retry
  the call on error without creating duplicate HITs. This is useful in cases such as network
  timeouts where it is unclear whether or not the call succeeded on the server. If the HIT
  already exists in the system from a previous call using the same UniqueRequestToken,
  subsequent calls will return a AWS.MechanicalTurk.HitAlreadyExists error with a message
  containing the HITId.    Note: It is your responsibility to ensure uniqueness of the token.
  The unique token expires after 24 hours. Subsequent calls using the same UniqueRequestToken
  made after the 24 hour limit could create duplicate HITs.
"""
function create_hitwith_hittype(
    HITTypeId, LifetimeInSeconds; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mturk(
        "CreateHITWithHITType",
        Dict{String,Any}(
            "HITTypeId" => HITTypeId, "LifetimeInSeconds" => LifetimeInSeconds
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_hitwith_hittype(
    HITTypeId,
    LifetimeInSeconds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mturk(
        "CreateHITWithHITType",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "HITTypeId" => HITTypeId, "LifetimeInSeconds" => LifetimeInSeconds
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_qualification_type(description, name, qualification_type_status)
    create_qualification_type(description, name, qualification_type_status, params::Dict{String,<:Any})

 The CreateQualificationType operation creates a new Qualification type, which is
represented by a QualificationType data structure.

# Arguments
- `description`: A long description for the Qualification type. On the Amazon Mechanical
  Turk website, the long description is displayed when a Worker examines a Qualification type.
- `name`:  The name you give to the Qualification type. The type name is used to represent
  the Qualification to Workers, and to find the type using a Qualification type search. It
  must be unique across all of your Qualification types.
- `qualification_type_status`: The initial status of the Qualification type. Constraints:
  Valid values are: Active | Inactive

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AnswerKey"`: The answers to the Qualification test specified in the Test parameter, in
  the form of an AnswerKey data structure. Constraints: Must not be longer than 65535 bytes.
  Constraints: None. If not specified, you must process Qualification requests manually.
- `"AutoGranted"`: Specifies whether requests for the Qualification type are granted
  immediately, without prompting the Worker with a Qualification test. Constraints: If the
  Test parameter is specified, this parameter cannot be true.
- `"AutoGrantedValue"`: The Qualification value to use for automatically granted
  Qualifications. This parameter is used only if the AutoGranted parameter is true.
- `"Keywords"`: One or more words or phrases that describe the Qualification type,
  separated by commas. The keywords of a type make the type easier to find during a search.
- `"RetryDelayInSeconds"`: The number of seconds that a Worker must wait after requesting a
  Qualification of the Qualification type before the worker can retry the Qualification
  request. Constraints: None. If not specified, retries are disabled and Workers can request
  a Qualification of this type only once, even if the Worker has not been granted the
  Qualification. It is not possible to disable retries for a Qualification type after it has
  been created with retries enabled. If you want to disable retries, you must delete existing
  retry-enabled Qualification type and then create a new Qualification type with retries
  disabled.
- `"Test"`:  The questions for the Qualification test a Worker must answer correctly to
  obtain a Qualification of this type. If this parameter is specified, TestDurationInSeconds
  must also be specified.  Constraints: Must not be longer than 65535 bytes. Must be a
  QuestionForm data structure. This parameter cannot be specified if AutoGranted is true.
  Constraints: None. If not specified, the Worker may request the Qualification without
  answering any questions.
- `"TestDurationInSeconds"`: The number of seconds the Worker has to complete the
  Qualification test, starting from the time the Worker requests the Qualification.
"""
function create_qualification_type(
    Description,
    Name,
    QualificationTypeStatus;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mturk(
        "CreateQualificationType",
        Dict{String,Any}(
            "Description" => Description,
            "Name" => Name,
            "QualificationTypeStatus" => QualificationTypeStatus,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_qualification_type(
    Description,
    Name,
    QualificationTypeStatus,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mturk(
        "CreateQualificationType",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Description" => Description,
                    "Name" => Name,
                    "QualificationTypeStatus" => QualificationTypeStatus,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_worker_block(reason, worker_id)
    create_worker_block(reason, worker_id, params::Dict{String,<:Any})

The CreateWorkerBlock operation allows you to prevent a Worker from working on your HITs.
For example, you can block a Worker who is producing poor quality work. You can block up to
100,000 Workers.

# Arguments
- `reason`: A message explaining the reason for blocking the Worker. This parameter enables
  you to keep track of your Workers. The Worker does not see this message.
- `worker_id`: The ID of the Worker to block.

"""
function create_worker_block(
    Reason, WorkerId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mturk(
        "CreateWorkerBlock",
        Dict{String,Any}("Reason" => Reason, "WorkerId" => WorkerId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_worker_block(
    Reason,
    WorkerId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mturk(
        "CreateWorkerBlock",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("Reason" => Reason, "WorkerId" => WorkerId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_hit(hitid)
    delete_hit(hitid, params::Dict{String,<:Any})

 The DeleteHIT operation is used to delete HIT that is no longer needed. Only the Requester
who created the HIT can delete it.   You can only dispose of HITs that are in the
Reviewable state, with all of their submitted assignments already either approved or
rejected. If you call the DeleteHIT operation on a HIT that is not in the Reviewable state
(for example, that has not expired, or still has active assignments), or on a HIT that is
Reviewable but without all of its submitted assignments already approved or rejected, the
service will return an error.      HITs are automatically disposed of after 120 days.
After you dispose of a HIT, you can no longer approve the HIT's rejected assignments.
Disposed HITs are not returned in results for the ListHITs operation.     Disposing HITs
can improve the performance of operations such as ListReviewableHITs and ListHITs.

# Arguments
- `hitid`: The ID of the HIT to be deleted.

"""
function delete_hit(HITId; aws_config::AbstractAWSConfig=current_aws_config())
    return mturk(
        "DeleteHIT",
        Dict{String,Any}("HITId" => HITId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_hit(
    HITId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mturk(
        "DeleteHIT",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("HITId" => HITId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_qualification_type(qualification_type_id)
    delete_qualification_type(qualification_type_id, params::Dict{String,<:Any})

 The DeleteQualificationType deletes a Qualification type and deletes any HIT types that
are associated with the Qualification type.  This operation does not revoke Qualifications
already assigned to Workers because the Qualifications might be needed for active HITs. If
there are any pending requests for the Qualification type, Amazon Mechanical Turk rejects
those requests. After you delete a Qualification type, you can no longer use it to create
HITs or HIT types.  DeleteQualificationType must wait for all the HITs that use the deleted
Qualification type to be deleted before completing. It may take up to 48 hours before
DeleteQualificationType completes and the unique name of the Qualification type is
available for reuse with CreateQualificationType.

# Arguments
- `qualification_type_id`: The ID of the QualificationType to dispose.

"""
function delete_qualification_type(
    QualificationTypeId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mturk(
        "DeleteQualificationType",
        Dict{String,Any}("QualificationTypeId" => QualificationTypeId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_qualification_type(
    QualificationTypeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mturk(
        "DeleteQualificationType",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("QualificationTypeId" => QualificationTypeId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_worker_block(worker_id)
    delete_worker_block(worker_id, params::Dict{String,<:Any})

The DeleteWorkerBlock operation allows you to reinstate a blocked Worker to work on your
HITs. This operation reverses the effects of the CreateWorkerBlock operation. You need the
Worker ID to use this operation. If the Worker ID is missing or invalid, this operation
fails and returns the message “WorkerId is invalid.” If the specified Worker is not
blocked, this operation returns successfully.

# Arguments
- `worker_id`: The ID of the Worker to unblock.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Reason"`: A message that explains the reason for unblocking the Worker. The Worker does
  not see this message.
"""
function delete_worker_block(WorkerId; aws_config::AbstractAWSConfig=current_aws_config())
    return mturk(
        "DeleteWorkerBlock",
        Dict{String,Any}("WorkerId" => WorkerId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_worker_block(
    WorkerId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mturk(
        "DeleteWorkerBlock",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("WorkerId" => WorkerId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_qualification_from_worker(qualification_type_id, worker_id)
    disassociate_qualification_from_worker(qualification_type_id, worker_id, params::Dict{String,<:Any})

 The DisassociateQualificationFromWorker revokes a previously granted Qualification from a
user.   You can provide a text message explaining why the Qualification was revoked. The
user who had the Qualification can see this message.

# Arguments
- `qualification_type_id`: The ID of the Qualification type of the Qualification to be
  revoked.
- `worker_id`: The ID of the Worker who possesses the Qualification to be revoked.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Reason"`: A text message that explains why the Qualification was revoked. The user who
  had the Qualification sees this message.
"""
function disassociate_qualification_from_worker(
    QualificationTypeId, WorkerId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mturk(
        "DisassociateQualificationFromWorker",
        Dict{String,Any}(
            "QualificationTypeId" => QualificationTypeId, "WorkerId" => WorkerId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_qualification_from_worker(
    QualificationTypeId,
    WorkerId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mturk(
        "DisassociateQualificationFromWorker",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "QualificationTypeId" => QualificationTypeId, "WorkerId" => WorkerId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_account_balance()
    get_account_balance(params::Dict{String,<:Any})

The GetAccountBalance operation retrieves the Prepaid HITs balance in your Amazon
Mechanical Turk account if you are a Prepaid Requester. Alternatively, this operation will
retrieve the remaining available AWS Billing usage if you have enabled AWS Billing. Note:
If you have enabled AWS Billing and still have a remaining Prepaid HITs balance, this
balance can be viewed on the My Account page in the Requester console.

"""
function get_account_balance(; aws_config::AbstractAWSConfig=current_aws_config())
    return mturk(
        "GetAccountBalance"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_account_balance(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mturk(
        "GetAccountBalance", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_assignment(assignment_id)
    get_assignment(assignment_id, params::Dict{String,<:Any})

 The GetAssignment operation retrieves the details of the specified Assignment.

# Arguments
- `assignment_id`: The ID of the Assignment to be retrieved.

"""
function get_assignment(AssignmentId; aws_config::AbstractAWSConfig=current_aws_config())
    return mturk(
        "GetAssignment",
        Dict{String,Any}("AssignmentId" => AssignmentId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_assignment(
    AssignmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mturk(
        "GetAssignment",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AssignmentId" => AssignmentId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_file_upload_url(assignment_id, question_identifier)
    get_file_upload_url(assignment_id, question_identifier, params::Dict{String,<:Any})

 The GetFileUploadURL operation generates and returns a temporary URL. You use the
temporary URL to retrieve a file uploaded by a Worker as an answer to a FileUploadAnswer
question for a HIT. The temporary URL is generated the instant the GetFileUploadURL
operation is called, and is valid for 60 seconds. You can get a temporary file upload URL
any time until the HIT is disposed. After the HIT is disposed, any uploaded files are
deleted, and cannot be retrieved. Pending Deprecation on December 12, 2017. The Answer
Specification structure will no longer support the FileUploadAnswer element to be used for
the QuestionForm data structure. Instead, we recommend that Requesters who want to create
HITs asking Workers to upload files to use Amazon S3.

# Arguments
- `assignment_id`: The ID of the assignment that contains the question with a
  FileUploadAnswer.
- `question_identifier`: The identifier of the question with a FileUploadAnswer, as
  specified in the QuestionForm of the HIT.

"""
function get_file_upload_url(
    AssignmentId, QuestionIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mturk(
        "GetFileUploadURL",
        Dict{String,Any}(
            "AssignmentId" => AssignmentId, "QuestionIdentifier" => QuestionIdentifier
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_file_upload_url(
    AssignmentId,
    QuestionIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mturk(
        "GetFileUploadURL",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AssignmentId" => AssignmentId,
                    "QuestionIdentifier" => QuestionIdentifier,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_hit(hitid)
    get_hit(hitid, params::Dict{String,<:Any})

 The GetHIT operation retrieves the details of the specified HIT.

# Arguments
- `hitid`: The ID of the HIT to be retrieved.

"""
function get_hit(HITId; aws_config::AbstractAWSConfig=current_aws_config())
    return mturk(
        "GetHIT",
        Dict{String,Any}("HITId" => HITId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_hit(
    HITId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mturk(
        "GetHIT",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("HITId" => HITId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_qualification_score(qualification_type_id, worker_id)
    get_qualification_score(qualification_type_id, worker_id, params::Dict{String,<:Any})

 The GetQualificationScore operation returns the value of a Worker's Qualification for a
given Qualification type.   To get a Worker's Qualification, you must know the Worker's ID.
The Worker's ID is included in the assignment data returned by the ListAssignmentsForHIT
operation.  Only the owner of a Qualification type can query the value of a Worker's
Qualification of that type.

# Arguments
- `qualification_type_id`: The ID of the QualificationType.
- `worker_id`: The ID of the Worker whose Qualification is being updated.

"""
function get_qualification_score(
    QualificationTypeId, WorkerId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mturk(
        "GetQualificationScore",
        Dict{String,Any}(
            "QualificationTypeId" => QualificationTypeId, "WorkerId" => WorkerId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_qualification_score(
    QualificationTypeId,
    WorkerId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mturk(
        "GetQualificationScore",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "QualificationTypeId" => QualificationTypeId, "WorkerId" => WorkerId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_qualification_type(qualification_type_id)
    get_qualification_type(qualification_type_id, params::Dict{String,<:Any})

 The GetQualificationTypeoperation retrieves information about a Qualification type using
its ID.

# Arguments
- `qualification_type_id`: The ID of the QualificationType.

"""
function get_qualification_type(
    QualificationTypeId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mturk(
        "GetQualificationType",
        Dict{String,Any}("QualificationTypeId" => QualificationTypeId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_qualification_type(
    QualificationTypeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mturk(
        "GetQualificationType",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("QualificationTypeId" => QualificationTypeId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_assignments_for_hit(hitid)
    list_assignments_for_hit(hitid, params::Dict{String,<:Any})

 The ListAssignmentsForHIT operation retrieves completed assignments for a HIT. You can use
this operation to retrieve the results for a HIT.   You can get assignments for a HIT at
any time, even if the HIT is not yet Reviewable. If a HIT requested multiple assignments,
and has received some results but has not yet become Reviewable, you can still retrieve the
partial results with this operation.   Use the AssignmentStatus parameter to control which
set of assignments for a HIT are returned. The ListAssignmentsForHIT operation can return
submitted assignments awaiting approval, or it can return assignments that have already
been approved or rejected. You can set AssignmentStatus=Approved,Rejected to get
assignments that have already been approved and rejected together in one result set.   Only
the Requester who created the HIT can retrieve the assignments for that HIT.   Results are
sorted and divided into numbered pages and the operation returns a single page of results.
You can use the parameters of the operation to control sorting and pagination.

# Arguments
- `hitid`: The ID of the HIT.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AssignmentStatuses"`: The status of the assignments to return: Submitted | Approved |
  Rejected
- `"MaxResults"`:
- `"NextToken"`: Pagination token
"""
function list_assignments_for_hit(HITId; aws_config::AbstractAWSConfig=current_aws_config())
    return mturk(
        "ListAssignmentsForHIT",
        Dict{String,Any}("HITId" => HITId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_assignments_for_hit(
    HITId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mturk(
        "ListAssignmentsForHIT",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("HITId" => HITId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_bonus_payments()
    list_bonus_payments(params::Dict{String,<:Any})

 The ListBonusPayments operation retrieves the amounts of bonuses you have paid to Workers
for a given HIT or assignment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AssignmentId"`: The ID of the assignment associated with the bonus payments to
  retrieve. If specified, only bonus payments for the given assignment are returned. Either
  the HITId parameter or the AssignmentId parameter must be specified
- `"HITId"`: The ID of the HIT associated with the bonus payments to retrieve. If not
  specified, all bonus payments for all assignments for the given HIT are returned. Either
  the HITId parameter or the AssignmentId parameter must be specified
- `"MaxResults"`:
- `"NextToken"`: Pagination token
"""
function list_bonus_payments(; aws_config::AbstractAWSConfig=current_aws_config())
    return mturk(
        "ListBonusPayments"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_bonus_payments(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mturk(
        "ListBonusPayments", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_hits()
    list_hits(params::Dict{String,<:Any})

 The ListHITs operation returns all of a Requester's HITs. The operation returns HITs of
any status, except for HITs that have been deleted of with the DeleteHIT operation or that
have been auto-deleted.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`:
- `"NextToken"`: Pagination token
"""
function list_hits(; aws_config::AbstractAWSConfig=current_aws_config())
    return mturk("ListHITs"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_hits(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mturk("ListHITs", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end

"""
    list_hits_for_qualification_type(qualification_type_id)
    list_hits_for_qualification_type(qualification_type_id, params::Dict{String,<:Any})

 The ListHITsForQualificationType operation returns the HITs that use the given
Qualification type for a Qualification requirement. The operation returns HITs of any
status, except for HITs that have been deleted with the DeleteHIT operation or that have
been auto-deleted.

# Arguments
- `qualification_type_id`:  The ID of the Qualification type to use when querying HITs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`:  Limit the number of results returned.
- `"NextToken"`: Pagination Token
"""
function list_hits_for_qualification_type(
    QualificationTypeId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mturk(
        "ListHITsForQualificationType",
        Dict{String,Any}("QualificationTypeId" => QualificationTypeId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_hits_for_qualification_type(
    QualificationTypeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mturk(
        "ListHITsForQualificationType",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("QualificationTypeId" => QualificationTypeId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_qualification_requests()
    list_qualification_requests(params::Dict{String,<:Any})

 The ListQualificationRequests operation retrieves requests for Qualifications of a
particular Qualification type. The owner of the Qualification type calls this operation to
poll for pending requests, and accepts them using the AcceptQualification operation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`:  The maximum number of results to return in a single call.
- `"NextToken"`:
- `"QualificationTypeId"`: The ID of the QualificationType.
"""
function list_qualification_requests(; aws_config::AbstractAWSConfig=current_aws_config())
    return mturk(
        "ListQualificationRequests"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_qualification_requests(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mturk(
        "ListQualificationRequests",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_qualification_types(must_be_requestable)
    list_qualification_types(must_be_requestable, params::Dict{String,<:Any})

 The ListQualificationTypes operation returns a list of Qualification types, filtered by an
optional search term.

# Arguments
- `must_be_requestable`: Specifies that only Qualification types that a user can request
  through the Amazon Mechanical Turk web site, such as by taking a Qualification test, are
  returned as results of the search. Some Qualification types, such as those assigned
  automatically by the system, cannot be requested directly by users. If false, all
  Qualification types, including those managed by the system, are considered. Valid values
  are True | False.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`:  The maximum number of results to return in a single call.
- `"MustBeOwnedByCaller"`:  Specifies that only Qualification types that the Requester
  created are returned. If false, the operation returns all Qualification types.
- `"NextToken"`:
- `"Query"`:  A text query against all of the searchable attributes of Qualification types.
"""
function list_qualification_types(
    MustBeRequestable; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mturk(
        "ListQualificationTypes",
        Dict{String,Any}("MustBeRequestable" => MustBeRequestable);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_qualification_types(
    MustBeRequestable,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mturk(
        "ListQualificationTypes",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("MustBeRequestable" => MustBeRequestable), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_review_policy_results_for_hit(hitid)
    list_review_policy_results_for_hit(hitid, params::Dict{String,<:Any})

 The ListReviewPolicyResultsForHIT operation retrieves the computed results and the actions
taken in the course of executing your Review Policies for a given HIT. For information
about how to specify Review Policies when you call CreateHIT, see Review Policies. The
ListReviewPolicyResultsForHIT operation can return results for both Assignment-level and
HIT-level review results.

# Arguments
- `hitid`: The unique identifier of the HIT to retrieve review results for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Limit the number of results returned.
- `"NextToken"`: Pagination token
- `"PolicyLevels"`:  The Policy Level(s) to retrieve review results for - HIT or
  Assignment. If omitted, the default behavior is to retrieve all data for both policy
  levels. For a list of all the described policies, see Review Policies.
- `"RetrieveActions"`:  Specify if the operation should retrieve a list of the actions
  taken executing the Review Policies and their outcomes.
- `"RetrieveResults"`:  Specify if the operation should retrieve a list of the results
  computed by the Review Policies.
"""
function list_review_policy_results_for_hit(
    HITId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mturk(
        "ListReviewPolicyResultsForHIT",
        Dict{String,Any}("HITId" => HITId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_review_policy_results_for_hit(
    HITId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mturk(
        "ListReviewPolicyResultsForHIT",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("HITId" => HITId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_reviewable_hits()
    list_reviewable_hits(params::Dict{String,<:Any})

 The ListReviewableHITs operation retrieves the HITs with Status equal to Reviewable or
Status equal to Reviewing that belong to the Requester calling the operation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"HITTypeId"`:  The ID of the HIT type of the HITs to consider for the query. If not
  specified, all HITs for the Reviewer are considered
- `"MaxResults"`:  Limit the number of results returned.
- `"NextToken"`: Pagination Token
- `"Status"`:  Can be either Reviewable or Reviewing. Reviewable is the default value.
"""
function list_reviewable_hits(; aws_config::AbstractAWSConfig=current_aws_config())
    return mturk(
        "ListReviewableHITs"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_reviewable_hits(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mturk(
        "ListReviewableHITs", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_worker_blocks()
    list_worker_blocks(params::Dict{String,<:Any})

The ListWorkersBlocks operation retrieves a list of Workers who are blocked from working on
your HITs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`:
- `"NextToken"`: Pagination token
"""
function list_worker_blocks(; aws_config::AbstractAWSConfig=current_aws_config())
    return mturk("ListWorkerBlocks"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_worker_blocks(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mturk(
        "ListWorkerBlocks", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_workers_with_qualification_type(qualification_type_id)
    list_workers_with_qualification_type(qualification_type_id, params::Dict{String,<:Any})

 The ListWorkersWithQualificationType operation returns all of the Workers that have been
associated with a given Qualification type.

# Arguments
- `qualification_type_id`: The ID of the Qualification type of the Qualifications to return.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`:  Limit the number of results returned.
- `"NextToken"`: Pagination Token
- `"Status"`:  The status of the Qualifications to return. Can be Granted | Revoked.
"""
function list_workers_with_qualification_type(
    QualificationTypeId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mturk(
        "ListWorkersWithQualificationType",
        Dict{String,Any}("QualificationTypeId" => QualificationTypeId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_workers_with_qualification_type(
    QualificationTypeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mturk(
        "ListWorkersWithQualificationType",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("QualificationTypeId" => QualificationTypeId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    notify_workers(message_text, subject, worker_ids)
    notify_workers(message_text, subject, worker_ids, params::Dict{String,<:Any})

 The NotifyWorkers operation sends an email to one or more Workers that you specify with
the Worker ID. You can specify up to 100 Worker IDs to send the same message with a single
call to the NotifyWorkers operation. The NotifyWorkers operation will send a notification
email to a Worker only if you have previously approved or rejected work from the Worker.

# Arguments
- `message_text`: The text of the email message to send. Can include up to 4,096 characters
- `subject`: The subject line of the email message to send. Can include up to 200
  characters.
- `worker_ids`: A list of Worker IDs you wish to notify. You can notify upto 100 Workers at
  a time.

"""
function notify_workers(
    MessageText, Subject, WorkerIds; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mturk(
        "NotifyWorkers",
        Dict{String,Any}(
            "MessageText" => MessageText, "Subject" => Subject, "WorkerIds" => WorkerIds
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function notify_workers(
    MessageText,
    Subject,
    WorkerIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mturk(
        "NotifyWorkers",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "MessageText" => MessageText,
                    "Subject" => Subject,
                    "WorkerIds" => WorkerIds,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    reject_assignment(assignment_id, requester_feedback)
    reject_assignment(assignment_id, requester_feedback, params::Dict{String,<:Any})

 The RejectAssignment operation rejects the results of a completed assignment.   You can
include an optional feedback message with the rejection, which the Worker can see in the
Status section of the web site. When you include a feedback message with the rejection, it
helps the Worker understand why the assignment was rejected, and can improve the quality of
the results the Worker submits in the future.   Only the Requester who created the HIT can
reject an assignment for the HIT.

# Arguments
- `assignment_id`:  The ID of the assignment. The assignment must correspond to a HIT
  created by the Requester.
- `requester_feedback`:  A message for the Worker, which the Worker can see in the Status
  section of the web site.

"""
function reject_assignment(
    AssignmentId, RequesterFeedback; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mturk(
        "RejectAssignment",
        Dict{String,Any}(
            "AssignmentId" => AssignmentId, "RequesterFeedback" => RequesterFeedback
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function reject_assignment(
    AssignmentId,
    RequesterFeedback,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mturk(
        "RejectAssignment",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AssignmentId" => AssignmentId, "RequesterFeedback" => RequesterFeedback
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    reject_qualification_request(qualification_request_id)
    reject_qualification_request(qualification_request_id, params::Dict{String,<:Any})

 The RejectQualificationRequest operation rejects a user's request for a Qualification.
You can provide a text message explaining why the request was rejected. The Worker who made
the request can see this message.

# Arguments
- `qualification_request_id`:  The ID of the Qualification request, as returned by the
  ListQualificationRequests operation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Reason"`: A text message explaining why the request was rejected, to be shown to the
  Worker who made the request.
"""
function reject_qualification_request(
    QualificationRequestId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mturk(
        "RejectQualificationRequest",
        Dict{String,Any}("QualificationRequestId" => QualificationRequestId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function reject_qualification_request(
    QualificationRequestId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mturk(
        "RejectQualificationRequest",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("QualificationRequestId" => QualificationRequestId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    send_bonus(assignment_id, bonus_amount, reason, worker_id)
    send_bonus(assignment_id, bonus_amount, reason, worker_id, params::Dict{String,<:Any})

 The SendBonus operation issues a payment of money from your account to a Worker. This
payment happens separately from the reward you pay to the Worker when you approve the
Worker's assignment. The SendBonus operation requires the Worker's ID and the assignment ID
as parameters to initiate payment of the bonus. You must include a message that explains
the reason for the bonus payment, as the Worker may not be expecting the payment. Amazon
Mechanical Turk collects a fee for bonus payments, similar to the HIT listing fee. This
operation fails if your account does not have enough funds to pay for both the bonus and
the fees.

# Arguments
- `assignment_id`: The ID of the assignment for which this bonus is paid.
- `bonus_amount`:  The Bonus amount is a US Dollar amount specified using a string (for
  example, \"5\" represents 5.00 USD and \"101.42\" represents 101.42 USD). Do not include
  currency symbols or currency codes.
- `reason`: A message that explains the reason for the bonus payment. The Worker receiving
  the bonus can see this message.
- `worker_id`: The ID of the Worker being paid the bonus.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"UniqueRequestToken"`: A unique identifier for this request, which allows you to retry
  the call on error without granting multiple bonuses. This is useful in cases such as
  network timeouts where it is unclear whether or not the call succeeded on the server. If
  the bonus already exists in the system from a previous call using the same
  UniqueRequestToken, subsequent calls will return an error with a message containing the
  request ID.
"""
function send_bonus(
    AssignmentId,
    BonusAmount,
    Reason,
    WorkerId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mturk(
        "SendBonus",
        Dict{String,Any}(
            "AssignmentId" => AssignmentId,
            "BonusAmount" => BonusAmount,
            "Reason" => Reason,
            "WorkerId" => WorkerId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function send_bonus(
    AssignmentId,
    BonusAmount,
    Reason,
    WorkerId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mturk(
        "SendBonus",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AssignmentId" => AssignmentId,
                    "BonusAmount" => BonusAmount,
                    "Reason" => Reason,
                    "WorkerId" => WorkerId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    send_test_event_notification(notification, test_event_type)
    send_test_event_notification(notification, test_event_type, params::Dict{String,<:Any})

 The SendTestEventNotification operation causes Amazon Mechanical Turk to send a
notification message as if a HIT event occurred, according to the provided notification
specification. This allows you to test notifications without setting up notifications for a
real HIT type and trying to trigger them using the website. When you call this operation,
the service attempts to send the test notification immediately.

# Arguments
- `notification`:  The notification specification to test. This value is identical to the
  value you would provide to the UpdateNotificationSettings operation when you establish the
  notification specification for a HIT type.
- `test_event_type`:  The event to simulate to test the notification specification. This
  event is included in the test message even if the notification specification does not
  include the event type. The notification specification does not filter out the test event.

"""
function send_test_event_notification(
    Notification, TestEventType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mturk(
        "SendTestEventNotification",
        Dict{String,Any}("Notification" => Notification, "TestEventType" => TestEventType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function send_test_event_notification(
    Notification,
    TestEventType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mturk(
        "SendTestEventNotification",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Notification" => Notification, "TestEventType" => TestEventType
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_expiration_for_hit(expire_at, hitid)
    update_expiration_for_hit(expire_at, hitid, params::Dict{String,<:Any})

 The UpdateExpirationForHIT operation allows you update the expiration time of a HIT. If
you update it to a time in the past, the HIT will be immediately expired.

# Arguments
- `expire_at`:  The date and time at which you want the HIT to expire
- `hitid`:  The HIT to update.

"""
function update_expiration_for_hit(
    ExpireAt, HITId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mturk(
        "UpdateExpirationForHIT",
        Dict{String,Any}("ExpireAt" => ExpireAt, "HITId" => HITId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_expiration_for_hit(
    ExpireAt,
    HITId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mturk(
        "UpdateExpirationForHIT",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ExpireAt" => ExpireAt, "HITId" => HITId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_hitreview_status(hitid)
    update_hitreview_status(hitid, params::Dict{String,<:Any})

 The UpdateHITReviewStatus operation updates the status of a HIT. If the status is
Reviewable, this operation can update the status to Reviewing, or it can revert a Reviewing
HIT back to the Reviewable status.

# Arguments
- `hitid`:  The ID of the HIT to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Revert"`:  Specifies how to update the HIT status. Default is False.     Setting this
  to false will only transition a HIT from Reviewable to Reviewing     Setting this to true
  will only transition a HIT from Reviewing to Reviewable
"""
function update_hitreview_status(HITId; aws_config::AbstractAWSConfig=current_aws_config())
    return mturk(
        "UpdateHITReviewStatus",
        Dict{String,Any}("HITId" => HITId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_hitreview_status(
    HITId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mturk(
        "UpdateHITReviewStatus",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("HITId" => HITId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_hittype_of_hit(hitid, hittype_id)
    update_hittype_of_hit(hitid, hittype_id, params::Dict{String,<:Any})

 The UpdateHITTypeOfHIT operation allows you to change the HITType properties of a HIT.
This operation disassociates the HIT from its old HITType properties and associates it with
the new HITType properties. The HIT takes on the properties of the new HITType in place of
the old ones.

# Arguments
- `hitid`: The HIT to update.
- `hittype_id`: The ID of the new HIT type.

"""
function update_hittype_of_hit(
    HITId, HITTypeId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mturk(
        "UpdateHITTypeOfHIT",
        Dict{String,Any}("HITId" => HITId, "HITTypeId" => HITTypeId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_hittype_of_hit(
    HITId,
    HITTypeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mturk(
        "UpdateHITTypeOfHIT",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("HITId" => HITId, "HITTypeId" => HITTypeId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_notification_settings(hittype_id)
    update_notification_settings(hittype_id, params::Dict{String,<:Any})

 The UpdateNotificationSettings operation creates, updates, disables or re-enables
notifications for a HIT type. If you call the UpdateNotificationSettings operation for a
HIT type that already has a notification specification, the operation replaces the old
specification with a new one. You can call the UpdateNotificationSettings operation to
enable or disable notifications for the HIT type, without having to modify the notification
specification itself by providing updates to the Active status without specifying a new
notification specification. To change the Active status of a HIT type's notifications, the
HIT type must already have a notification specification, or one must be provided in the
same call to UpdateNotificationSettings.

# Arguments
- `hittype_id`:  The ID of the HIT type whose notification specification is being updated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Active"`:  Specifies whether notifications are sent for HITs of this HIT type,
  according to the notification specification. You must specify either the Notification
  parameter or the Active parameter for the call to UpdateNotificationSettings to succeed.
- `"Notification"`:  The notification specification for the HIT type.
"""
function update_notification_settings(
    HITTypeId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mturk(
        "UpdateNotificationSettings",
        Dict{String,Any}("HITTypeId" => HITTypeId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_notification_settings(
    HITTypeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mturk(
        "UpdateNotificationSettings",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("HITTypeId" => HITTypeId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_qualification_type(qualification_type_id)
    update_qualification_type(qualification_type_id, params::Dict{String,<:Any})

 The UpdateQualificationType operation modifies the attributes of an existing Qualification
type, which is represented by a QualificationType data structure. Only the owner of a
Qualification type can modify its attributes.   Most attributes of a Qualification type can
be changed after the type has been created. However, the Name and Keywords fields cannot be
modified. The RetryDelayInSeconds parameter can be modified or added to change the delay or
to enable retries, but RetryDelayInSeconds cannot be used to disable retries.   You can use
this operation to update the test for a Qualification type. The test is updated based on
the values specified for the Test, TestDurationInSeconds and AnswerKey parameters. All
three parameters specify the updated test. If you are updating the test for a type, you
must specify the Test and TestDurationInSeconds parameters. The AnswerKey parameter is
optional; omitting it specifies that the updated test does not have an answer key.   If you
omit the Test parameter, the test for the Qualification type is unchanged. There is no way
to remove a test from a Qualification type that has one. If the type already has a test,
you cannot update it to be AutoGranted. If the Qualification type does not have a test and
one is provided by an update, the type will henceforth have a test.   If you want to update
the test duration or answer key for an existing test without changing the questions, you
must specify a Test parameter with the original questions, along with the updated values.
If you provide an updated Test but no AnswerKey, the new test will not have an answer key.
Requests for such Qualifications must be granted manually.   You can also update the
AutoGranted and AutoGrantedValue attributes of the Qualification type.

# Arguments
- `qualification_type_id`: The ID of the Qualification type to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AnswerKey"`: The answers to the Qualification test specified in the Test parameter, in
  the form of an AnswerKey data structure.
- `"AutoGranted"`: Specifies whether requests for the Qualification type are granted
  immediately, without prompting the Worker with a Qualification test. Constraints: If the
  Test parameter is specified, this parameter cannot be true.
- `"AutoGrantedValue"`: The Qualification value to use for automatically granted
  Qualifications. This parameter is used only if the AutoGranted parameter is true.
- `"Description"`: The new description of the Qualification type.
- `"QualificationTypeStatus"`: The new status of the Qualification type - Active | Inactive
- `"RetryDelayInSeconds"`: The amount of time, in seconds, that Workers must wait after
  requesting a Qualification of the specified Qualification type before they can retry the
  Qualification request. It is not possible to disable retries for a Qualification type after
  it has been created with retries enabled. If you want to disable retries, you must dispose
  of the existing retry-enabled Qualification type using DisposeQualificationType and then
  create a new Qualification type with retries disabled using CreateQualificationType.
- `"Test"`: The questions for the Qualification test a Worker must answer correctly to
  obtain a Qualification of this type. If this parameter is specified, TestDurationInSeconds
  must also be specified. Constraints: Must not be longer than 65535 bytes. Must be a
  QuestionForm data structure. This parameter cannot be specified if AutoGranted is true.
  Constraints: None. If not specified, the Worker may request the Qualification without
  answering any questions.
- `"TestDurationInSeconds"`: The number of seconds the Worker has to complete the
  Qualification test, starting from the time the Worker requests the Qualification.
"""
function update_qualification_type(
    QualificationTypeId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mturk(
        "UpdateQualificationType",
        Dict{String,Any}("QualificationTypeId" => QualificationTypeId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_qualification_type(
    QualificationTypeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mturk(
        "UpdateQualificationType",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("QualificationTypeId" => QualificationTypeId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

path = joinpath(@__DIR__, "..", "resource", "TestPkg")

Pkg.develop(; path=path)
VERSION >= v"1.9.4" && Pkg.precompile("TestPkg")

# Check to see if we get any warnings when using AWS.jl inside of another package.
out = @capture_out begin
    err = @capture_err begin
        @eval using TestPkg
    end

    @test isempty(err)
end

@test isempty(out)

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: qconnect
using AWS.Compat
using AWS.UUIDs

"""
    create_assistant(name, type)
    create_assistant(name, type, params::Dict{String,<:Any})

Creates an Amazon Q in Connect assistant.

# Arguments
- `name`: The name of the assistant.
- `type`: The type of assistant.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If not provided, the Amazon Web Services SDK populates this
  field. For more information about idempotency, see Making retries safe with idempotent APIs.
- `"description"`: The description of the assistant.
- `"serverSideEncryptionConfiguration"`: The configuration information for the customer
  managed key used for encryption.  The customer managed key must have a policy that allows
  kms:CreateGrant,  kms:DescribeKey, kms:Decrypt, and kms:GenerateDataKey* permissions to the
  IAM identity using the key to invoke Amazon Q in Connect. To use Amazon Q in Connect with
  chat, the key policy must also allow kms:Decrypt, kms:GenerateDataKey*, and kms:DescribeKey
  permissions to the connect.amazonaws.com service principal.  For more information about
  setting up a customer managed key for Amazon Q in Connect, see Enable Amazon Q in Connect
  for your instance.
- `"tags"`: The tags used to organize, track, or control access for this resource.
"""
function create_assistant(name, type; aws_config::AbstractAWSConfig=current_aws_config())
    return qconnect(
        "POST",
        "/assistants",
        Dict{String,Any}("name" => name, "type" => type, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_assistant(
    name,
    type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qconnect(
        "POST",
        "/assistants",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "name" => name, "type" => type, "clientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_assistant_association(assistant_id, association, association_type)
    create_assistant_association(assistant_id, association, association_type, params::Dict{String,<:Any})

Creates an association between an Amazon Q in Connect assistant and another resource.
Currently, the only supported association is with a knowledge base. An assistant can have
only a single association.

# Arguments
- `assistant_id`: The identifier of the Amazon Q in Connect assistant. Can be either the ID
  or the ARN. URLs cannot contain the ARN.
- `association`: The identifier of the associated resource.
- `association_type`: The type of association.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If not provided, the Amazon Web Services SDK populates this
  field. For more information about idempotency, see Making retries safe with idempotent APIs.
- `"tags"`: The tags used to organize, track, or control access for this resource.
"""
function create_assistant_association(
    assistantId,
    association,
    associationType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qconnect(
        "POST",
        "/assistants/$(assistantId)/associations",
        Dict{String,Any}(
            "association" => association,
            "associationType" => associationType,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_assistant_association(
    assistantId,
    association,
    associationType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qconnect(
        "POST",
        "/assistants/$(assistantId)/associations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "association" => association,
                    "associationType" => associationType,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_content(knowledge_base_id, name, upload_id)
    create_content(knowledge_base_id, name, upload_id, params::Dict{String,<:Any})

Creates Amazon Q in Connect content. Before to calling this API, use StartContentUpload to
upload an asset.

# Arguments
- `knowledge_base_id`: The identifier of the knowledge base. This should not be a
  QUICK_RESPONSES type knowledge base. Can be either the ID or the ARN. URLs cannot contain
  the ARN.
- `name`: The name of the content. Each piece of content in a knowledge base must have a
  unique name. You can retrieve a piece of content using only its knowledge base and its name
  with the SearchContent API.
- `upload_id`: A pointer to the uploaded asset. This value is returned by
  StartContentUpload.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If not provided, the Amazon Web Services SDK populates this
  field. For more information about idempotency, see Making retries safe with idempotent APIs.
- `"metadata"`: A key/value map to store attributes without affecting tagging or
  recommendations. For example, when synchronizing data between an external system and Amazon
  Q in Connect, you can store an external version identifier as metadata to utilize for
  determining drift.
- `"overrideLinkOutUri"`: The URI you want to use for the article. If the knowledge base
  has a templateUri, setting this argument overrides it for this piece of content.
- `"tags"`: The tags used to organize, track, or control access for this resource.
- `"title"`: The title of the content. If not set, the title is equal to the name.
"""
function create_content(
    knowledgeBaseId, name, uploadId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qconnect(
        "POST",
        "/knowledgeBases/$(knowledgeBaseId)/contents",
        Dict{String,Any}(
            "name" => name, "uploadId" => uploadId, "clientToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_content(
    knowledgeBaseId,
    name,
    uploadId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qconnect(
        "POST",
        "/knowledgeBases/$(knowledgeBaseId)/contents",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "name" => name, "uploadId" => uploadId, "clientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_knowledge_base(knowledge_base_type, name)
    create_knowledge_base(knowledge_base_type, name, params::Dict{String,<:Any})

Creates a knowledge base.  When using this API, you cannot reuse Amazon AppIntegrations
DataIntegrations with external knowledge bases such as Salesforce and ServiceNow. If you
do, you'll get an InvalidRequestException error.  For example, you're programmatically
managing your external knowledge base, and you want to add or remove one of the fields that
is being ingested from Salesforce. Do the following:   Call DeleteKnowledgeBase.   Call
DeleteDataIntegration.   Call CreateDataIntegration to recreate the DataIntegration or a
create different one.   Call CreateKnowledgeBase.

# Arguments
- `knowledge_base_type`: The type of knowledge base. Only CUSTOM knowledge bases allow you
  to upload your own content. EXTERNAL knowledge bases support integrations with third-party
  systems whose content is synchronized automatically.
- `name`: The name of the knowledge base.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If not provided, the Amazon Web Services SDK populates this
  field. For more information about idempotency, see Making retries safe with idempotent APIs.
- `"description"`: The description.
- `"renderingConfiguration"`: Information about how to render the content.
- `"serverSideEncryptionConfiguration"`: The configuration information for the customer
  managed key used for encryption.  This KMS key must have a policy that allows
  kms:CreateGrant, kms:DescribeKey, kms:Decrypt, and kms:GenerateDataKey* permissions to the
  IAM identity using the key to invoke Amazon Q in Connect. For more information about
  setting up a customer managed key for Amazon Q in Connect, see Enable Amazon Q in Connect
  for your instance.
- `"sourceConfiguration"`: The source of the knowledge base content. Only set this argument
  for EXTERNAL knowledge bases.
- `"tags"`: The tags used to organize, track, or control access for this resource.
"""
function create_knowledge_base(
    knowledgeBaseType, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qconnect(
        "POST",
        "/knowledgeBases",
        Dict{String,Any}(
            "knowledgeBaseType" => knowledgeBaseType,
            "name" => name,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_knowledge_base(
    knowledgeBaseType,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qconnect(
        "POST",
        "/knowledgeBases",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "knowledgeBaseType" => knowledgeBaseType,
                    "name" => name,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_quick_response(content, knowledge_base_id, name)
    create_quick_response(content, knowledge_base_id, name, params::Dict{String,<:Any})

Creates an Amazon Q in Connect quick response.

# Arguments
- `content`: The content of the quick response.
- `knowledge_base_id`: The identifier of the knowledge base. Can be either the ID or the
  ARN. URLs cannot contain the ARN.
- `name`: The name of the quick response.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"channels"`: The Amazon Connect channels this quick response applies to.
- `"clientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If not provided, the Amazon Web Services SDK populates this
  field. For more information about idempotency, see Making retries safe with idempotent APIs.
- `"contentType"`: The media type of the quick response content.   Use
  application/x.quickresponse;format=plain for a quick response written in plain text.   Use
  application/x.quickresponse;format=markdown for a quick response written in richtext.
- `"description"`: The description of the quick response.
- `"groupingConfiguration"`: The configuration information of the user groups that the
  quick response is accessible to.
- `"isActive"`: Whether the quick response is active.
- `"language"`: The language code value for the language in which the quick response is
  written. The supported language codes include de_DE, en_US, es_ES, fr_FR, id_ID, it_IT,
  ja_JP, ko_KR, pt_BR, zh_CN, zh_TW
- `"shortcutKey"`: The shortcut key of the quick response. The value should be unique
  across the knowledge base.
- `"tags"`: The tags used to organize, track, or control access for this resource.
"""
function create_quick_response(
    content, knowledgeBaseId, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qconnect(
        "POST",
        "/knowledgeBases/$(knowledgeBaseId)/quickResponses",
        Dict{String,Any}(
            "content" => content, "name" => name, "clientToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_quick_response(
    content,
    knowledgeBaseId,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qconnect(
        "POST",
        "/knowledgeBases/$(knowledgeBaseId)/quickResponses",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "content" => content, "name" => name, "clientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_session(assistant_id, name)
    create_session(assistant_id, name, params::Dict{String,<:Any})

Creates a session. A session is a contextual container used for generating recommendations.
Amazon Connect creates a new Amazon Q in Connect session for each contact on which Amazon Q
in Connect is enabled.

# Arguments
- `assistant_id`: The identifier of the Amazon Q in Connect assistant. Can be either the ID
  or the ARN. URLs cannot contain the ARN.
- `name`: The name of the session.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If not provided, the Amazon Web Services SDK populates this
  field. For more information about idempotency, see Making retries safe with idempotent APIs.
- `"description"`: The description.
- `"tagFilter"`: An object that can be used to specify Tag conditions.
- `"tags"`: The tags used to organize, track, or control access for this resource.
"""
function create_session(
    assistantId, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qconnect(
        "POST",
        "/assistants/$(assistantId)/sessions",
        Dict{String,Any}("name" => name, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_session(
    assistantId,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qconnect(
        "POST",
        "/assistants/$(assistantId)/sessions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("name" => name, "clientToken" => string(uuid4())),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_assistant(assistant_id)
    delete_assistant(assistant_id, params::Dict{String,<:Any})

Deletes an assistant.

# Arguments
- `assistant_id`: The identifier of the Amazon Q in Connect assistant. Can be either the ID
  or the ARN. URLs cannot contain the ARN.

"""
function delete_assistant(assistantId; aws_config::AbstractAWSConfig=current_aws_config())
    return qconnect(
        "DELETE",
        "/assistants/$(assistantId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_assistant(
    assistantId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qconnect(
        "DELETE",
        "/assistants/$(assistantId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_assistant_association(assistant_association_id, assistant_id)
    delete_assistant_association(assistant_association_id, assistant_id, params::Dict{String,<:Any})

Deletes an assistant association.

# Arguments
- `assistant_association_id`: The identifier of the assistant association. Can be either
  the ID or the ARN. URLs cannot contain the ARN.
- `assistant_id`: The identifier of the Amazon Q in Connect assistant. Can be either the ID
  or the ARN. URLs cannot contain the ARN.

"""
function delete_assistant_association(
    assistantAssociationId, assistantId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qconnect(
        "DELETE",
        "/assistants/$(assistantId)/associations/$(assistantAssociationId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_assistant_association(
    assistantAssociationId,
    assistantId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qconnect(
        "DELETE",
        "/assistants/$(assistantId)/associations/$(assistantAssociationId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_content(content_id, knowledge_base_id)
    delete_content(content_id, knowledge_base_id, params::Dict{String,<:Any})

Deletes the content.

# Arguments
- `content_id`: The identifier of the content. Can be either the ID or the ARN. URLs cannot
  contain the ARN.
- `knowledge_base_id`: The identifier of the knowledge base. Can be either the ID or the
  ARN. URLs cannot contain the ARN.

"""
function delete_content(
    contentId, knowledgeBaseId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qconnect(
        "DELETE",
        "/knowledgeBases/$(knowledgeBaseId)/contents/$(contentId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_content(
    contentId,
    knowledgeBaseId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qconnect(
        "DELETE",
        "/knowledgeBases/$(knowledgeBaseId)/contents/$(contentId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_import_job(import_job_id, knowledge_base_id)
    delete_import_job(import_job_id, knowledge_base_id, params::Dict{String,<:Any})

Deletes the quick response import job.

# Arguments
- `import_job_id`: The identifier of the import job to be deleted.
- `knowledge_base_id`: The identifier of the knowledge base.

"""
function delete_import_job(
    importJobId, knowledgeBaseId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qconnect(
        "DELETE",
        "/knowledgeBases/$(knowledgeBaseId)/importJobs/$(importJobId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_import_job(
    importJobId,
    knowledgeBaseId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qconnect(
        "DELETE",
        "/knowledgeBases/$(knowledgeBaseId)/importJobs/$(importJobId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_knowledge_base(knowledge_base_id)
    delete_knowledge_base(knowledge_base_id, params::Dict{String,<:Any})

Deletes the knowledge base.  When you use this API to delete an external knowledge base
such as Salesforce or ServiceNow, you must also delete the Amazon AppIntegrations
DataIntegration. This is because you can't reuse the DataIntegration after it's been
associated with an external knowledge base. However, you can delete and recreate it. See
DeleteDataIntegration and CreateDataIntegration in the Amazon AppIntegrations API
Reference.

# Arguments
- `knowledge_base_id`: The knowledge base to delete content from. Can be either the ID or
  the ARN. URLs cannot contain the ARN.

"""
function delete_knowledge_base(
    knowledgeBaseId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qconnect(
        "DELETE",
        "/knowledgeBases/$(knowledgeBaseId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_knowledge_base(
    knowledgeBaseId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qconnect(
        "DELETE",
        "/knowledgeBases/$(knowledgeBaseId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_quick_response(knowledge_base_id, quick_response_id)
    delete_quick_response(knowledge_base_id, quick_response_id, params::Dict{String,<:Any})

Deletes a quick response.

# Arguments
- `knowledge_base_id`: The knowledge base from which the quick response is deleted. The
  identifier of the knowledge base.
- `quick_response_id`: The identifier of the quick response to delete.

"""
function delete_quick_response(
    knowledgeBaseId, quickResponseId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qconnect(
        "DELETE",
        "/knowledgeBases/$(knowledgeBaseId)/quickResponses/$(quickResponseId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_quick_response(
    knowledgeBaseId,
    quickResponseId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qconnect(
        "DELETE",
        "/knowledgeBases/$(knowledgeBaseId)/quickResponses/$(quickResponseId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_assistant(assistant_id)
    get_assistant(assistant_id, params::Dict{String,<:Any})

Retrieves information about an assistant.

# Arguments
- `assistant_id`: The identifier of the Amazon Q in Connect assistant. Can be either the ID
  or the ARN. URLs cannot contain the ARN.

"""
function get_assistant(assistantId; aws_config::AbstractAWSConfig=current_aws_config())
    return qconnect(
        "GET",
        "/assistants/$(assistantId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_assistant(
    assistantId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qconnect(
        "GET",
        "/assistants/$(assistantId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_assistant_association(assistant_association_id, assistant_id)
    get_assistant_association(assistant_association_id, assistant_id, params::Dict{String,<:Any})

Retrieves information about an assistant association.

# Arguments
- `assistant_association_id`: The identifier of the assistant association. Can be either
  the ID or the ARN. URLs cannot contain the ARN.
- `assistant_id`: The identifier of the Amazon Q in Connect assistant. Can be either the ID
  or the ARN. URLs cannot contain the ARN.

"""
function get_assistant_association(
    assistantAssociationId, assistantId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qconnect(
        "GET",
        "/assistants/$(assistantId)/associations/$(assistantAssociationId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_assistant_association(
    assistantAssociationId,
    assistantId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qconnect(
        "GET",
        "/assistants/$(assistantId)/associations/$(assistantAssociationId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_content(content_id, knowledge_base_id)
    get_content(content_id, knowledge_base_id, params::Dict{String,<:Any})

Retrieves content, including a pre-signed URL to download the content.

# Arguments
- `content_id`: The identifier of the content. Can be either the ID or the ARN. URLs cannot
  contain the ARN.
- `knowledge_base_id`: The identifier of the knowledge base. This should not be a
  QUICK_RESPONSES type knowledge base. Can be either the ID or the ARN. URLs cannot contain
  the ARN.

"""
function get_content(
    contentId, knowledgeBaseId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qconnect(
        "GET",
        "/knowledgeBases/$(knowledgeBaseId)/contents/$(contentId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_content(
    contentId,
    knowledgeBaseId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qconnect(
        "GET",
        "/knowledgeBases/$(knowledgeBaseId)/contents/$(contentId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_content_summary(content_id, knowledge_base_id)
    get_content_summary(content_id, knowledge_base_id, params::Dict{String,<:Any})

Retrieves summary information about the content.

# Arguments
- `content_id`: The identifier of the content. Can be either the ID or the ARN. URLs cannot
  contain the ARN.
- `knowledge_base_id`: The identifier of the knowledge base. Can be either the ID or the
  ARN. URLs cannot contain the ARN.

"""
function get_content_summary(
    contentId, knowledgeBaseId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qconnect(
        "GET",
        "/knowledgeBases/$(knowledgeBaseId)/contents/$(contentId)/summary";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_content_summary(
    contentId,
    knowledgeBaseId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qconnect(
        "GET",
        "/knowledgeBases/$(knowledgeBaseId)/contents/$(contentId)/summary",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_import_job(import_job_id, knowledge_base_id)
    get_import_job(import_job_id, knowledge_base_id, params::Dict{String,<:Any})

Retrieves the started import job.

# Arguments
- `import_job_id`: The identifier of the import job to retrieve.
- `knowledge_base_id`: The identifier of the knowledge base that the import job belongs to.

"""
function get_import_job(
    importJobId, knowledgeBaseId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qconnect(
        "GET",
        "/knowledgeBases/$(knowledgeBaseId)/importJobs/$(importJobId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_import_job(
    importJobId,
    knowledgeBaseId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qconnect(
        "GET",
        "/knowledgeBases/$(knowledgeBaseId)/importJobs/$(importJobId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_knowledge_base(knowledge_base_id)
    get_knowledge_base(knowledge_base_id, params::Dict{String,<:Any})

Retrieves information about the knowledge base.

# Arguments
- `knowledge_base_id`: The identifier of the knowledge base. Can be either the ID or the
  ARN. URLs cannot contain the ARN.

"""
function get_knowledge_base(
    knowledgeBaseId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qconnect(
        "GET",
        "/knowledgeBases/$(knowledgeBaseId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_knowledge_base(
    knowledgeBaseId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qconnect(
        "GET",
        "/knowledgeBases/$(knowledgeBaseId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_quick_response(knowledge_base_id, quick_response_id)
    get_quick_response(knowledge_base_id, quick_response_id, params::Dict{String,<:Any})

Retrieves the quick response.

# Arguments
- `knowledge_base_id`: The identifier of the knowledge base. This should be a
  QUICK_RESPONSES type knowledge base.
- `quick_response_id`: The identifier of the quick response.

"""
function get_quick_response(
    knowledgeBaseId, quickResponseId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qconnect(
        "GET",
        "/knowledgeBases/$(knowledgeBaseId)/quickResponses/$(quickResponseId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_quick_response(
    knowledgeBaseId,
    quickResponseId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qconnect(
        "GET",
        "/knowledgeBases/$(knowledgeBaseId)/quickResponses/$(quickResponseId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_recommendations(assistant_id, session_id)
    get_recommendations(assistant_id, session_id, params::Dict{String,<:Any})

 This API will be discontinued starting June 1, 2024. To receive generative responses after
March 1, 2024, you will need to create a new Assistant in the Amazon Connect console and
integrate the Amazon Q in Connect JavaScript library (amazon-q-connectjs) into your
applications.  Retrieves recommendations for the specified session. To avoid retrieving the
same recommendations in subsequent calls, use NotifyRecommendationsReceived. This API
supports long-polling behavior with the waitTimeSeconds parameter. Short poll is the
default behavior and only returns recommendations already available. To perform a manual
query against an assistant, use QueryAssistant.

# Arguments
- `assistant_id`: The identifier of the Amazon Q in Connect assistant. Can be either the ID
  or the ARN. URLs cannot contain the ARN.
- `session_id`: The identifier of the session. Can be either the ID or the ARN. URLs cannot
  contain the ARN.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return per page.
- `"waitTimeSeconds"`: The duration (in seconds) for which the call waits for a
  recommendation to be made available before returning. If a recommendation is available, the
  call returns sooner than WaitTimeSeconds. If no messages are available and the wait time
  expires, the call returns successfully with an empty list.
"""
function get_recommendations(
    assistantId, sessionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qconnect(
        "GET",
        "/assistants/$(assistantId)/sessions/$(sessionId)/recommendations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_recommendations(
    assistantId,
    sessionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qconnect(
        "GET",
        "/assistants/$(assistantId)/sessions/$(sessionId)/recommendations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_session(assistant_id, session_id)
    get_session(assistant_id, session_id, params::Dict{String,<:Any})

Retrieves information for a specified session.

# Arguments
- `assistant_id`: The identifier of the Amazon Q in Connect assistant. Can be either the ID
  or the ARN. URLs cannot contain the ARN.
- `session_id`: The identifier of the session. Can be either the ID or the ARN. URLs cannot
  contain the ARN.

"""
function get_session(
    assistantId, sessionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qconnect(
        "GET",
        "/assistants/$(assistantId)/sessions/$(sessionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_session(
    assistantId,
    sessionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qconnect(
        "GET",
        "/assistants/$(assistantId)/sessions/$(sessionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_assistant_associations(assistant_id)
    list_assistant_associations(assistant_id, params::Dict{String,<:Any})

Lists information about assistant associations.

# Arguments
- `assistant_id`: The identifier of the Amazon Q in Connect assistant. Can be either the ID
  or the ARN. URLs cannot contain the ARN.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return per page.
- `"nextToken"`: The token for the next set of results. Use the value returned in the
  previous response in the next request to retrieve the next set of results.
"""
function list_assistant_associations(
    assistantId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qconnect(
        "GET",
        "/assistants/$(assistantId)/associations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_assistant_associations(
    assistantId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qconnect(
        "GET",
        "/assistants/$(assistantId)/associations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_assistants()
    list_assistants(params::Dict{String,<:Any})

Lists information about assistants.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return per page.
- `"nextToken"`: The token for the next set of results. Use the value returned in the
  previous response in the next request to retrieve the next set of results.
"""
function list_assistants(; aws_config::AbstractAWSConfig=current_aws_config())
    return qconnect(
        "GET", "/assistants"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_assistants(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qconnect(
        "GET", "/assistants", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_contents(knowledge_base_id)
    list_contents(knowledge_base_id, params::Dict{String,<:Any})

Lists the content.

# Arguments
- `knowledge_base_id`: The identifier of the knowledge base. This should not be a
  QUICK_RESPONSES type knowledge base. Can be either the ID or the ARN. URLs cannot contain
  the ARN.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return per page.
- `"nextToken"`: The token for the next set of results. Use the value returned in the
  previous response in the next request to retrieve the next set of results.
"""
function list_contents(knowledgeBaseId; aws_config::AbstractAWSConfig=current_aws_config())
    return qconnect(
        "GET",
        "/knowledgeBases/$(knowledgeBaseId)/contents";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_contents(
    knowledgeBaseId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qconnect(
        "GET",
        "/knowledgeBases/$(knowledgeBaseId)/contents",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_import_jobs(knowledge_base_id)
    list_import_jobs(knowledge_base_id, params::Dict{String,<:Any})

Lists information about import jobs.

# Arguments
- `knowledge_base_id`: The identifier of the knowledge base. Can be either the ID or the
  ARN. URLs cannot contain the ARN.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return per page.
- `"nextToken"`: The token for the next set of results. Use the value returned in the
  previous response in the next request to retrieve the next set of results.
"""
function list_import_jobs(
    knowledgeBaseId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qconnect(
        "GET",
        "/knowledgeBases/$(knowledgeBaseId)/importJobs";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_import_jobs(
    knowledgeBaseId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qconnect(
        "GET",
        "/knowledgeBases/$(knowledgeBaseId)/importJobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_knowledge_bases()
    list_knowledge_bases(params::Dict{String,<:Any})

Lists the knowledge bases.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return per page.
- `"nextToken"`: The token for the next set of results. Use the value returned in the
  previous response in the next request to retrieve the next set of results.
"""
function list_knowledge_bases(; aws_config::AbstractAWSConfig=current_aws_config())
    return qconnect(
        "GET", "/knowledgeBases"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_knowledge_bases(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qconnect(
        "GET",
        "/knowledgeBases",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_quick_responses(knowledge_base_id)
    list_quick_responses(knowledge_base_id, params::Dict{String,<:Any})

Lists information about quick response.

# Arguments
- `knowledge_base_id`: The identifier of the knowledge base. Can be either the ID or the
  ARN. URLs cannot contain the ARN.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return per page.
- `"nextToken"`: The token for the next set of results. Use the value returned in the
  previous response in the next request to retrieve the next set of results.
"""
function list_quick_responses(
    knowledgeBaseId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qconnect(
        "GET",
        "/knowledgeBases/$(knowledgeBaseId)/quickResponses";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_quick_responses(
    knowledgeBaseId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qconnect(
        "GET",
        "/knowledgeBases/$(knowledgeBaseId)/quickResponses",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists the tags for the specified resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qconnect(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qconnect(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    notify_recommendations_received(assistant_id, recommendation_ids, session_id)
    notify_recommendations_received(assistant_id, recommendation_ids, session_id, params::Dict{String,<:Any})

Removes the specified recommendations from the specified assistant's queue of newly
available recommendations. You can use this API in conjunction with GetRecommendations and
a waitTimeSeconds input for long-polling behavior and avoiding duplicate recommendations.

# Arguments
- `assistant_id`: The identifier of the Amazon Q in Connect assistant. Can be either the ID
  or the ARN. URLs cannot contain the ARN.
- `recommendation_ids`: The identifiers of the recommendations.
- `session_id`: The identifier of the session. Can be either the ID or the ARN. URLs cannot
  contain the ARN.

"""
function notify_recommendations_received(
    assistantId,
    recommendationIds,
    sessionId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qconnect(
        "POST",
        "/assistants/$(assistantId)/sessions/$(sessionId)/recommendations/notify",
        Dict{String,Any}("recommendationIds" => recommendationIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function notify_recommendations_received(
    assistantId,
    recommendationIds,
    sessionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qconnect(
        "POST",
        "/assistants/$(assistantId)/sessions/$(sessionId)/recommendations/notify",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("recommendationIds" => recommendationIds), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_feedback(assistant_id, content_feedback, target_id, target_type)
    put_feedback(assistant_id, content_feedback, target_id, target_type, params::Dict{String,<:Any})

Provides feedback against the specified assistant for the specified target. This API only
supports generative targets.

# Arguments
- `assistant_id`: The identifier of the Amazon Q in Connect assistant.
- `content_feedback`: Information about the feedback provided.
- `target_id`: The identifier of the feedback target.
- `target_type`: The type of the feedback target.

"""
function put_feedback(
    assistantId,
    contentFeedback,
    targetId,
    targetType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qconnect(
        "PUT",
        "/assistants/$(assistantId)/feedback",
        Dict{String,Any}(
            "contentFeedback" => contentFeedback,
            "targetId" => targetId,
            "targetType" => targetType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_feedback(
    assistantId,
    contentFeedback,
    targetId,
    targetType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qconnect(
        "PUT",
        "/assistants/$(assistantId)/feedback",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "contentFeedback" => contentFeedback,
                    "targetId" => targetId,
                    "targetType" => targetType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    query_assistant(assistant_id, query_text)
    query_assistant(assistant_id, query_text, params::Dict{String,<:Any})

 This API will be discontinued starting June 1, 2024. To receive generative responses after
March 1, 2024, you will need to create a new Assistant in the Amazon Connect console and
integrate the Amazon Q in Connect JavaScript library (amazon-q-connectjs) into your
applications.  Performs a manual search against the specified assistant. To retrieve
recommendations for an assistant, use GetRecommendations.

# Arguments
- `assistant_id`: The identifier of the Amazon Q in Connect assistant. Can be either the ID
  or the ARN. URLs cannot contain the ARN.
- `query_text`: The text to search for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return per page.
- `"nextToken"`: The token for the next set of results. Use the value returned in the
  previous response in the next request to retrieve the next set of results.
- `"queryCondition"`: Information about how to query content.
- `"sessionId"`: The identifier of the Amazon Q in Connect session. Can be either the ID or
  the ARN. URLs cannot contain the ARN.
"""
function query_assistant(
    assistantId, queryText; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qconnect(
        "POST",
        "/assistants/$(assistantId)/query",
        Dict{String,Any}("queryText" => queryText);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function query_assistant(
    assistantId,
    queryText,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qconnect(
        "POST",
        "/assistants/$(assistantId)/query",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("queryText" => queryText), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_knowledge_base_template_uri(knowledge_base_id)
    remove_knowledge_base_template_uri(knowledge_base_id, params::Dict{String,<:Any})

Removes a URI template from a knowledge base.

# Arguments
- `knowledge_base_id`: The identifier of the knowledge base. Can be either the ID or the
  ARN. URLs cannot contain the ARN.

"""
function remove_knowledge_base_template_uri(
    knowledgeBaseId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qconnect(
        "DELETE",
        "/knowledgeBases/$(knowledgeBaseId)/templateUri";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_knowledge_base_template_uri(
    knowledgeBaseId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qconnect(
        "DELETE",
        "/knowledgeBases/$(knowledgeBaseId)/templateUri",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    search_content(knowledge_base_id, search_expression)
    search_content(knowledge_base_id, search_expression, params::Dict{String,<:Any})

Searches for content in a specified knowledge base. Can be used to get a specific content
resource by its name.

# Arguments
- `knowledge_base_id`: The identifier of the knowledge base. This should not be a
  QUICK_RESPONSES type knowledge base. Can be either the ID or the ARN. URLs cannot contain
  the ARN.
- `search_expression`: The search expression to filter results.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return per page.
- `"nextToken"`: The token for the next set of results. Use the value returned in the
  previous response in the next request to retrieve the next set of results.
"""
function search_content(
    knowledgeBaseId, searchExpression; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qconnect(
        "POST",
        "/knowledgeBases/$(knowledgeBaseId)/search",
        Dict{String,Any}("searchExpression" => searchExpression);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function search_content(
    knowledgeBaseId,
    searchExpression,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qconnect(
        "POST",
        "/knowledgeBases/$(knowledgeBaseId)/search",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("searchExpression" => searchExpression), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    search_quick_responses(knowledge_base_id, search_expression)
    search_quick_responses(knowledge_base_id, search_expression, params::Dict{String,<:Any})

Searches existing Amazon Q in Connect quick responses in an Amazon Q in Connect knowledge
base.

# Arguments
- `knowledge_base_id`: The identifier of the knowledge base. This should be a
  QUICK_RESPONSES type knowledge base. Can be either the ID or the ARN. URLs cannot contain
  the ARN.
- `search_expression`: The search expression for querying the quick response.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"attributes"`: The user-defined Amazon Connect contact attributes to be resolved when
  search results are returned.
- `"maxResults"`: The maximum number of results to return per page.
- `"nextToken"`: The token for the next set of results. Use the value returned in the
  previous response in the next request to retrieve the next set of results.
"""
function search_quick_responses(
    knowledgeBaseId, searchExpression; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qconnect(
        "POST",
        "/knowledgeBases/$(knowledgeBaseId)/search/quickResponses",
        Dict{String,Any}("searchExpression" => searchExpression);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function search_quick_responses(
    knowledgeBaseId,
    searchExpression,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qconnect(
        "POST",
        "/knowledgeBases/$(knowledgeBaseId)/search/quickResponses",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("searchExpression" => searchExpression), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    search_sessions(assistant_id, search_expression)
    search_sessions(assistant_id, search_expression, params::Dict{String,<:Any})

Searches for sessions.

# Arguments
- `assistant_id`: The identifier of the Amazon Q in Connect assistant. Can be either the ID
  or the ARN. URLs cannot contain the ARN.
- `search_expression`: The search expression to filter results.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return per page.
- `"nextToken"`: The token for the next set of results. Use the value returned in the
  previous response in the next request to retrieve the next set of results.
"""
function search_sessions(
    assistantId, searchExpression; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qconnect(
        "POST",
        "/assistants/$(assistantId)/searchSessions",
        Dict{String,Any}("searchExpression" => searchExpression);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function search_sessions(
    assistantId,
    searchExpression,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qconnect(
        "POST",
        "/assistants/$(assistantId)/searchSessions",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("searchExpression" => searchExpression), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_content_upload(content_type, knowledge_base_id)
    start_content_upload(content_type, knowledge_base_id, params::Dict{String,<:Any})

Get a URL to upload content to a knowledge base. To upload content, first make a PUT
request to the returned URL with your file, making sure to include the required headers.
Then use CreateContent to finalize the content creation process or UpdateContent to modify
an existing resource. You can only upload content to a knowledge base of type CUSTOM.

# Arguments
- `content_type`: The type of content to upload.
- `knowledge_base_id`: The identifier of the knowledge base. Can be either the ID or the
  ARN. URLs cannot contain the ARN.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"presignedUrlTimeToLive"`: The expected expiration time of the generated presigned URL,
  specified in minutes.
"""
function start_content_upload(
    contentType, knowledgeBaseId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qconnect(
        "POST",
        "/knowledgeBases/$(knowledgeBaseId)/upload",
        Dict{String,Any}("contentType" => contentType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_content_upload(
    contentType,
    knowledgeBaseId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qconnect(
        "POST",
        "/knowledgeBases/$(knowledgeBaseId)/upload",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("contentType" => contentType), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_import_job(import_job_type, knowledge_base_id, upload_id)
    start_import_job(import_job_type, knowledge_base_id, upload_id, params::Dict{String,<:Any})

Start an asynchronous job to import Amazon Q in Connect resources from an uploaded source
file. Before calling this API, use StartContentUpload to upload an asset that contains the
resource data.   For importing Amazon Q in Connect quick responses, you need to upload a
csv file including the quick responses. For information about how to format the csv file
for importing quick responses, see Import quick responses.

# Arguments
- `import_job_type`: The type of the import job.   For importing quick response resource,
  set the value to QUICK_RESPONSES.
- `knowledge_base_id`: The identifier of the knowledge base. Can be either the ID or the
  ARN. URLs cannot contain the ARN.   For importing Amazon Q in Connect quick responses, this
  should be a QUICK_RESPONSES type knowledge base.
- `upload_id`: A pointer to the uploaded asset. This value is returned by
  StartContentUpload.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: The tags used to organize, track, or control access for this resource.
- `"externalSourceConfiguration"`: The configuration information of the external source
  that the resource data are imported from.
- `"metadata"`: The metadata fields of the imported Amazon Q in Connect resources.
"""
function start_import_job(
    importJobType,
    knowledgeBaseId,
    uploadId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qconnect(
        "POST",
        "/knowledgeBases/$(knowledgeBaseId)/importJobs",
        Dict{String,Any}(
            "importJobType" => importJobType,
            "uploadId" => uploadId,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_import_job(
    importJobType,
    knowledgeBaseId,
    uploadId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qconnect(
        "POST",
        "/knowledgeBases/$(knowledgeBaseId)/importJobs",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "importJobType" => importJobType,
                    "uploadId" => uploadId,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds the specified tags to the specified resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.
- `tags`: The tags used to organize, track, or control access for this resource.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return qconnect(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qconnect(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes the specified tags from the specified resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.
- `tag_keys`: The tag keys.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qconnect(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qconnect(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_content(content_id, knowledge_base_id)
    update_content(content_id, knowledge_base_id, params::Dict{String,<:Any})

Updates information about the content.

# Arguments
- `content_id`: The identifier of the content. Can be either the ID or the ARN. URLs cannot
  contain the ARN.
- `knowledge_base_id`: The identifier of the knowledge base. This should not be a
  QUICK_RESPONSES type knowledge base. Can be either the ID or the ARN

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"metadata"`: A key/value map to store attributes without affecting tagging or
  recommendations. For example, when synchronizing data between an external system and Amazon
  Q in Connect, you can store an external version identifier as metadata to utilize for
  determining drift.
- `"overrideLinkOutUri"`: The URI for the article. If the knowledge base has a templateUri,
  setting this argument overrides it for this piece of content. To remove an existing
  overrideLinkOurUri, exclude this argument and set removeOverrideLinkOutUri to true.
- `"removeOverrideLinkOutUri"`: Unset the existing overrideLinkOutUri if it exists.
- `"revisionId"`: The revisionId of the content resource to update, taken from an earlier
  call to GetContent, GetContentSummary, SearchContent, or ListContents. If included, this
  argument acts as an optimistic lock to ensure content was not modified since it was last
  read. If it has been modified, this API throws a PreconditionFailedException.
- `"title"`: The title of the content.
- `"uploadId"`: A pointer to the uploaded asset. This value is returned by
  StartContentUpload.
"""
function update_content(
    contentId, knowledgeBaseId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qconnect(
        "POST",
        "/knowledgeBases/$(knowledgeBaseId)/contents/$(contentId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_content(
    contentId,
    knowledgeBaseId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qconnect(
        "POST",
        "/knowledgeBases/$(knowledgeBaseId)/contents/$(contentId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_knowledge_base_template_uri(knowledge_base_id, template_uri)
    update_knowledge_base_template_uri(knowledge_base_id, template_uri, params::Dict{String,<:Any})

Updates the template URI of a knowledge base. This is only supported for knowledge bases of
type EXTERNAL. Include a single variable in {variable} format; this interpolated by Amazon
Q in Connect using ingested content. For example, if you ingest a Salesforce article, it
has an Id value, and you can set the template URI to
https://myInstanceName.lightning.force.com/lightning/r/Knowledge__kav/*{Id}*/view.

# Arguments
- `knowledge_base_id`: The identifier of the knowledge base. This should not be a
  QUICK_RESPONSES type knowledge base. Can be either the ID or the ARN. URLs cannot contain
  the ARN.
- `template_uri`: The template URI to update.

"""
function update_knowledge_base_template_uri(
    knowledgeBaseId, templateUri; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qconnect(
        "POST",
        "/knowledgeBases/$(knowledgeBaseId)/templateUri",
        Dict{String,Any}("templateUri" => templateUri);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_knowledge_base_template_uri(
    knowledgeBaseId,
    templateUri,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qconnect(
        "POST",
        "/knowledgeBases/$(knowledgeBaseId)/templateUri",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("templateUri" => templateUri), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_quick_response(knowledge_base_id, quick_response_id)
    update_quick_response(knowledge_base_id, quick_response_id, params::Dict{String,<:Any})

Updates an existing Amazon Q in Connect quick response.

# Arguments
- `knowledge_base_id`: The identifier of the knowledge base. Can be either the ID or the
  ARN. URLs cannot contain the ARN.
- `quick_response_id`: The identifier of the quick response.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"channels"`: The Amazon Connect contact channels this quick response applies to. The
  supported contact channel types include Chat.
- `"content"`: The updated content of the quick response.
- `"contentType"`: The media type of the quick response content.   Use
  application/x.quickresponse;format=plain for quick response written in plain text.   Use
  application/x.quickresponse;format=markdown for quick response written in richtext.
- `"description"`: The updated description of the quick response.
- `"groupingConfiguration"`: The updated grouping configuration of the quick response.
- `"isActive"`: Whether the quick response is active.
- `"language"`: The language code value for the language in which the quick response is
  written. The supported language codes include de_DE, en_US, es_ES, fr_FR, id_ID, it_IT,
  ja_JP, ko_KR, pt_BR, zh_CN, zh_TW
- `"name"`: The name of the quick response.
- `"removeDescription"`: Whether to remove the description from the quick response.
- `"removeGroupingConfiguration"`: Whether to remove the grouping configuration of the
  quick response.
- `"removeShortcutKey"`: Whether to remove the shortcut key of the quick response.
- `"shortcutKey"`: The shortcut key of the quick response. The value should be unique
  across the knowledge base.
"""
function update_quick_response(
    knowledgeBaseId, quickResponseId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qconnect(
        "POST",
        "/knowledgeBases/$(knowledgeBaseId)/quickResponses/$(quickResponseId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_quick_response(
    knowledgeBaseId,
    quickResponseId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qconnect(
        "POST",
        "/knowledgeBases/$(knowledgeBaseId)/quickResponses/$(quickResponseId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_session(assistant_id, session_id)
    update_session(assistant_id, session_id, params::Dict{String,<:Any})

Updates a session. A session is a contextual container used for generating recommendations.
Amazon Connect updates the existing Amazon Q in Connect session for each contact on which
Amazon Q in Connect is enabled.

# Arguments
- `assistant_id`: The identifier of the Amazon Q in Connect assistant. Can be either the ID
  or the ARN. URLs cannot contain the ARN.
- `session_id`: The identifier of the session. Can be either the ID or the ARN. URLs cannot
  contain the ARN.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description.
- `"tagFilter"`: An object that can be used to specify Tag conditions.
"""
function update_session(
    assistantId, sessionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qconnect(
        "POST",
        "/assistants/$(assistantId)/sessions/$(sessionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_session(
    assistantId,
    sessionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qconnect(
        "POST",
        "/assistants/$(assistantId)/sessions/$(sessionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: swf
using AWS.Compat
using AWS.UUIDs

"""
    count_closed_workflow_executions(domain)
    count_closed_workflow_executions(domain, params::Dict{String,<:Any})

Returns the number of closed workflow executions within the given domain that meet the
specified filtering criteria.  This operation is eventually consistent. The results are
best effort and may not exactly reflect recent updates and changes.   Access Control  You
can use IAM policies to control this action's access to Amazon SWF resources as follows:
Use a Resource element with the domain name to limit the action to only specified domains.
 Use an Action element to allow or deny permission to call this action.   Constrain the
following parameters by using a Condition element with the appropriate keys.
tagFilter.tag: String constraint. The key is swf:tagFilter.tag.    typeFilter.name: String
constraint. The key is swf:typeFilter.name.    typeFilter.version: String constraint. The
key is swf:typeFilter.version.     If the caller doesn't have sufficient permissions to
invoke the action, or the parameter values fall outside the specified constraints, the
action fails. The associated event attribute's cause parameter is set to
OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage
Access to Amazon SWF Workflows in the Amazon SWF Developer Guide.

# Arguments
- `domain`: The name of the domain containing the workflow executions to count.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"closeStatusFilter"`: If specified, only workflow executions that match this close
  status are counted. This filter has an affect only if executionStatus is specified as
  CLOSED.   closeStatusFilter, executionFilter, typeFilter and tagFilter are mutually
  exclusive. You can specify at most one of these in a request.
- `"closeTimeFilter"`: If specified, only workflow executions that meet the close time
  criteria of the filter are counted.   startTimeFilter and closeTimeFilter are mutually
  exclusive. You must specify one of these in a request but not both.
- `"executionFilter"`: If specified, only workflow executions matching the WorkflowId in
  the filter are counted.   closeStatusFilter, executionFilter, typeFilter and tagFilter are
  mutually exclusive. You can specify at most one of these in a request.
- `"startTimeFilter"`: If specified, only workflow executions that meet the start time
  criteria of the filter are counted.   startTimeFilter and closeTimeFilter are mutually
  exclusive. You must specify one of these in a request but not both.
- `"tagFilter"`: If specified, only executions that have a tag that matches the filter are
  counted.   closeStatusFilter, executionFilter, typeFilter and tagFilter are mutually
  exclusive. You can specify at most one of these in a request.
- `"typeFilter"`: If specified, indicates the type of the workflow executions to be
  counted.   closeStatusFilter, executionFilter, typeFilter and tagFilter are mutually
  exclusive. You can specify at most one of these in a request.
"""
function count_closed_workflow_executions(
    domain; aws_config::AbstractAWSConfig=current_aws_config()
)
    return swf(
        "CountClosedWorkflowExecutions",
        Dict{String,Any}("domain" => domain);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function count_closed_workflow_executions(
    domain, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return swf(
        "CountClosedWorkflowExecutions",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("domain" => domain), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    count_open_workflow_executions(domain, start_time_filter)
    count_open_workflow_executions(domain, start_time_filter, params::Dict{String,<:Any})

Returns the number of open workflow executions within the given domain that meet the
specified filtering criteria.  This operation is eventually consistent. The results are
best effort and may not exactly reflect recent updates and changes.   Access Control  You
can use IAM policies to control this action's access to Amazon SWF resources as follows:
Use a Resource element with the domain name to limit the action to only specified domains.
 Use an Action element to allow or deny permission to call this action.   Constrain the
following parameters by using a Condition element with the appropriate keys.
tagFilter.tag: String constraint. The key is swf:tagFilter.tag.    typeFilter.name: String
constraint. The key is swf:typeFilter.name.    typeFilter.version: String constraint. The
key is swf:typeFilter.version.     If the caller doesn't have sufficient permissions to
invoke the action, or the parameter values fall outside the specified constraints, the
action fails. The associated event attribute's cause parameter is set to
OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage
Access to Amazon SWF Workflows in the Amazon SWF Developer Guide.

# Arguments
- `domain`: The name of the domain containing the workflow executions to count.
- `start_time_filter`: Specifies the start time criteria that workflow executions must meet
  in order to be counted.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"executionFilter"`: If specified, only workflow executions matching the WorkflowId in
  the filter are counted.   executionFilter, typeFilter and tagFilter are mutually exclusive.
  You can specify at most one of these in a request.
- `"tagFilter"`: If specified, only executions that have a tag that matches the filter are
  counted.   executionFilter, typeFilter and tagFilter are mutually exclusive. You can
  specify at most one of these in a request.
- `"typeFilter"`: Specifies the type of the workflow executions to be counted.
  executionFilter, typeFilter and tagFilter are mutually exclusive. You can specify at most
  one of these in a request.
"""
function count_open_workflow_executions(
    domain, startTimeFilter; aws_config::AbstractAWSConfig=current_aws_config()
)
    return swf(
        "CountOpenWorkflowExecutions",
        Dict{String,Any}("domain" => domain, "startTimeFilter" => startTimeFilter);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function count_open_workflow_executions(
    domain,
    startTimeFilter,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return swf(
        "CountOpenWorkflowExecutions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("domain" => domain, "startTimeFilter" => startTimeFilter),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    count_pending_activity_tasks(domain, task_list)
    count_pending_activity_tasks(domain, task_list, params::Dict{String,<:Any})

Returns the estimated number of activity tasks in the specified task list. The count
returned is an approximation and isn't guaranteed to be exact. If you specify a task list
that no activity task was ever scheduled in then 0 is returned.  Access Control  You can
use IAM policies to control this action's access to Amazon SWF resources as follows:   Use
a Resource element with the domain name to limit the action to only specified domains.
Use an Action element to allow or deny permission to call this action.   Constrain the
taskList.name parameter by using a Condition element with the swf:taskList.name key to
allow the action to access only certain task lists.   If the caller doesn't have sufficient
permissions to invoke the action, or the parameter values fall outside the specified
constraints, the action fails. The associated event attribute's cause parameter is set to
OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage
Access to Amazon SWF Workflows in the Amazon SWF Developer Guide.

# Arguments
- `domain`: The name of the domain that contains the task list.
- `task_list`: The name of the task list.

"""
function count_pending_activity_tasks(
    domain, taskList; aws_config::AbstractAWSConfig=current_aws_config()
)
    return swf(
        "CountPendingActivityTasks",
        Dict{String,Any}("domain" => domain, "taskList" => taskList);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function count_pending_activity_tasks(
    domain,
    taskList,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return swf(
        "CountPendingActivityTasks",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("domain" => domain, "taskList" => taskList), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    count_pending_decision_tasks(domain, task_list)
    count_pending_decision_tasks(domain, task_list, params::Dict{String,<:Any})

Returns the estimated number of decision tasks in the specified task list. The count
returned is an approximation and isn't guaranteed to be exact. If you specify a task list
that no decision task was ever scheduled in then 0 is returned.  Access Control  You can
use IAM policies to control this action's access to Amazon SWF resources as follows:   Use
a Resource element with the domain name to limit the action to only specified domains.
Use an Action element to allow or deny permission to call this action.   Constrain the
taskList.name parameter by using a Condition element with the swf:taskList.name key to
allow the action to access only certain task lists.   If the caller doesn't have sufficient
permissions to invoke the action, or the parameter values fall outside the specified
constraints, the action fails. The associated event attribute's cause parameter is set to
OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage
Access to Amazon SWF Workflows in the Amazon SWF Developer Guide.

# Arguments
- `domain`: The name of the domain that contains the task list.
- `task_list`: The name of the task list.

"""
function count_pending_decision_tasks(
    domain, taskList; aws_config::AbstractAWSConfig=current_aws_config()
)
    return swf(
        "CountPendingDecisionTasks",
        Dict{String,Any}("domain" => domain, "taskList" => taskList);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function count_pending_decision_tasks(
    domain,
    taskList,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return swf(
        "CountPendingDecisionTasks",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("domain" => domain, "taskList" => taskList), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_activity_type(activity_type, domain)
    delete_activity_type(activity_type, domain, params::Dict{String,<:Any})

Deletes the specified activity type. Note: Prior to deletion, activity types must first be
deprecated.   After an activity type has been deleted, you cannot schedule new activities
of that type. Activities that started before the type was deleted will continue to run.
Access Control  You can use IAM policies to control this action's access to Amazon SWF
resources as follows:   Use a Resource element with the domain name to limit the action to
only specified domains.   Use an Action element to allow or deny permission to call this
action.   Constrain the following parameters by using a Condition element with the
appropriate keys.    activityType.name: String constraint. The key is
swf:activityType.name.    activityType.version: String constraint. The key is
swf:activityType.version.     If the caller doesn't have sufficient permissions to invoke
the action, or the parameter values fall outside the specified constraints, the action
fails. The associated event attribute's cause parameter is set to OPERATION_NOT_PERMITTED.
For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF
Workflows in the Amazon SWF Developer Guide.

# Arguments
- `activity_type`: The activity type to delete.
- `domain`: The name of the domain in which the activity type is registered.

"""
function delete_activity_type(
    activityType, domain; aws_config::AbstractAWSConfig=current_aws_config()
)
    return swf(
        "DeleteActivityType",
        Dict{String,Any}("activityType" => activityType, "domain" => domain);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_activity_type(
    activityType,
    domain,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return swf(
        "DeleteActivityType",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("activityType" => activityType, "domain" => domain),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_workflow_type(domain, workflow_type)
    delete_workflow_type(domain, workflow_type, params::Dict{String,<:Any})

Deletes the specified workflow type. Note: Prior to deletion, workflow types must first be
deprecated.  After a workflow type has been deleted, you cannot create new executions of
that type. Executions that started before the type was deleted will continue to run.
Access Control  You can use IAM policies to control this action's access to Amazon SWF
resources as follows:   Use a Resource element with the domain name to limit the action to
only specified domains.   Use an Action element to allow or deny permission to call this
action.   Constrain the following parameters by using a Condition element with the
appropriate keys.    workflowType.name: String constraint. The key is
swf:workflowType.name.    workflowType.version: String constraint. The key is
swf:workflowType.version.     If the caller doesn't have sufficient permissions to invoke
the action, or the parameter values fall outside the specified constraints, the action
fails. The associated event attribute's cause parameter is set to OPERATION_NOT_PERMITTED.
For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF
Workflows in the Amazon SWF Developer Guide.

# Arguments
- `domain`: The name of the domain in which the workflow type is registered.
- `workflow_type`: The workflow type to delete.

"""
function delete_workflow_type(
    domain, workflowType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return swf(
        "DeleteWorkflowType",
        Dict{String,Any}("domain" => domain, "workflowType" => workflowType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_workflow_type(
    domain,
    workflowType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return swf(
        "DeleteWorkflowType",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("domain" => domain, "workflowType" => workflowType),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    deprecate_activity_type(activity_type, domain)
    deprecate_activity_type(activity_type, domain, params::Dict{String,<:Any})

Deprecates the specified activity type. After an activity type has been deprecated, you
cannot create new tasks of that activity type. Tasks of this type that were scheduled
before the type was deprecated continue to run.  Access Control  You can use IAM policies
to control this action's access to Amazon SWF resources as follows:   Use a Resource
element with the domain name to limit the action to only specified domains.   Use an Action
element to allow or deny permission to call this action.   Constrain the following
parameters by using a Condition element with the appropriate keys.    activityType.name:
String constraint. The key is swf:activityType.name.    activityType.version: String
constraint. The key is swf:activityType.version.     If the caller doesn't have sufficient
permissions to invoke the action, or the parameter values fall outside the specified
constraints, the action fails. The associated event attribute's cause parameter is set to
OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage
Access to Amazon SWF Workflows in the Amazon SWF Developer Guide.

# Arguments
- `activity_type`: The activity type to deprecate.
- `domain`: The name of the domain in which the activity type is registered.

"""
function deprecate_activity_type(
    activityType, domain; aws_config::AbstractAWSConfig=current_aws_config()
)
    return swf(
        "DeprecateActivityType",
        Dict{String,Any}("activityType" => activityType, "domain" => domain);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function deprecate_activity_type(
    activityType,
    domain,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return swf(
        "DeprecateActivityType",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("activityType" => activityType, "domain" => domain),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    deprecate_domain(name)
    deprecate_domain(name, params::Dict{String,<:Any})

Deprecates the specified domain. After a domain has been deprecated it cannot be used to
create new workflow executions or register new types. However, you can still use visibility
actions on this domain. Deprecating a domain also deprecates all activity and workflow
types registered in the domain. Executions that were started before the domain was
deprecated continues to run.  This operation is eventually consistent. The results are best
effort and may not exactly reflect recent updates and changes.   Access Control  You can
use IAM policies to control this action's access to Amazon SWF resources as follows:   Use
a Resource element with the domain name to limit the action to only specified domains.
Use an Action element to allow or deny permission to call this action.   You cannot use an
IAM policy to constrain this action's parameters.   If the caller doesn't have sufficient
permissions to invoke the action, or the parameter values fall outside the specified
constraints, the action fails. The associated event attribute's cause parameter is set to
OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage
Access to Amazon SWF Workflows in the Amazon SWF Developer Guide.

# Arguments
- `name`: The name of the domain to deprecate.

"""
function deprecate_domain(name; aws_config::AbstractAWSConfig=current_aws_config())
    return swf(
        "DeprecateDomain",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function deprecate_domain(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return swf(
        "DeprecateDomain",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    deprecate_workflow_type(domain, workflow_type)
    deprecate_workflow_type(domain, workflow_type, params::Dict{String,<:Any})

Deprecates the specified workflow type. After a workflow type has been deprecated, you
cannot create new executions of that type. Executions that were started before the type was
deprecated continues to run. A deprecated workflow type may still be used when calling
visibility actions.  This operation is eventually consistent. The results are best effort
and may not exactly reflect recent updates and changes.   Access Control  You can use IAM
policies to control this action's access to Amazon SWF resources as follows:   Use a
Resource element with the domain name to limit the action to only specified domains.   Use
an Action element to allow or deny permission to call this action.   Constrain the
following parameters by using a Condition element with the appropriate keys.
workflowType.name: String constraint. The key is swf:workflowType.name.
workflowType.version: String constraint. The key is swf:workflowType.version.     If the
caller doesn't have sufficient permissions to invoke the action, or the parameter values
fall outside the specified constraints, the action fails. The associated event attribute's
cause parameter is set to OPERATION_NOT_PERMITTED. For details and example IAM policies,
see Using IAM to Manage Access to Amazon SWF Workflows in the Amazon SWF Developer Guide.

# Arguments
- `domain`: The name of the domain in which the workflow type is registered.
- `workflow_type`: The workflow type to deprecate.

"""
function deprecate_workflow_type(
    domain, workflowType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return swf(
        "DeprecateWorkflowType",
        Dict{String,Any}("domain" => domain, "workflowType" => workflowType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function deprecate_workflow_type(
    domain,
    workflowType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return swf(
        "DeprecateWorkflowType",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("domain" => domain, "workflowType" => workflowType),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_activity_type(activity_type, domain)
    describe_activity_type(activity_type, domain, params::Dict{String,<:Any})

Returns information about the specified activity type. This includes configuration settings
provided when the type was registered and other general information about the type.  Access
Control  You can use IAM policies to control this action's access to Amazon SWF resources
as follows:   Use a Resource element with the domain name to limit the action to only
specified domains.   Use an Action element to allow or deny permission to call this action.
  Constrain the following parameters by using a Condition element with the appropriate
keys.    activityType.name: String constraint. The key is swf:activityType.name.
activityType.version: String constraint. The key is swf:activityType.version.     If the
caller doesn't have sufficient permissions to invoke the action, or the parameter values
fall outside the specified constraints, the action fails. The associated event attribute's
cause parameter is set to OPERATION_NOT_PERMITTED. For details and example IAM policies,
see Using IAM to Manage Access to Amazon SWF Workflows in the Amazon SWF Developer Guide.

# Arguments
- `activity_type`: The activity type to get information about. Activity types are
  identified by the name and version that were supplied when the activity was registered.
- `domain`: The name of the domain in which the activity type is registered.

"""
function describe_activity_type(
    activityType, domain; aws_config::AbstractAWSConfig=current_aws_config()
)
    return swf(
        "DescribeActivityType",
        Dict{String,Any}("activityType" => activityType, "domain" => domain);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_activity_type(
    activityType,
    domain,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return swf(
        "DescribeActivityType",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("activityType" => activityType, "domain" => domain),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_domain(name)
    describe_domain(name, params::Dict{String,<:Any})

Returns information about the specified domain, including description and status.  Access
Control  You can use IAM policies to control this action's access to Amazon SWF resources
as follows:   Use a Resource element with the domain name to limit the action to only
specified domains.   Use an Action element to allow or deny permission to call this action.
  You cannot use an IAM policy to constrain this action's parameters.   If the caller
doesn't have sufficient permissions to invoke the action, or the parameter values fall
outside the specified constraints, the action fails. The associated event attribute's cause
parameter is set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see
Using IAM to Manage Access to Amazon SWF Workflows in the Amazon SWF Developer Guide.

# Arguments
- `name`: The name of the domain to describe.

"""
function describe_domain(name; aws_config::AbstractAWSConfig=current_aws_config())
    return swf(
        "DescribeDomain",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_domain(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return swf(
        "DescribeDomain",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_workflow_execution(domain, execution)
    describe_workflow_execution(domain, execution, params::Dict{String,<:Any})

Returns information about the specified workflow execution including its type and some
statistics.  This operation is eventually consistent. The results are best effort and may
not exactly reflect recent updates and changes.   Access Control  You can use IAM policies
to control this action's access to Amazon SWF resources as follows:   Use a Resource
element with the domain name to limit the action to only specified domains.   Use an Action
element to allow or deny permission to call this action.   You cannot use an IAM policy to
constrain this action's parameters.   If the caller doesn't have sufficient permissions to
invoke the action, or the parameter values fall outside the specified constraints, the
action fails. The associated event attribute's cause parameter is set to
OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage
Access to Amazon SWF Workflows in the Amazon SWF Developer Guide.

# Arguments
- `domain`: The name of the domain containing the workflow execution.
- `execution`: The workflow execution to describe.

"""
function describe_workflow_execution(
    domain, execution; aws_config::AbstractAWSConfig=current_aws_config()
)
    return swf(
        "DescribeWorkflowExecution",
        Dict{String,Any}("domain" => domain, "execution" => execution);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_workflow_execution(
    domain,
    execution,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return swf(
        "DescribeWorkflowExecution",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("domain" => domain, "execution" => execution),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_workflow_type(domain, workflow_type)
    describe_workflow_type(domain, workflow_type, params::Dict{String,<:Any})

Returns information about the specified workflow type. This includes configuration settings
specified when the type was registered and other information such as creation date, current
status, etc.  Access Control  You can use IAM policies to control this action's access to
Amazon SWF resources as follows:   Use a Resource element with the domain name to limit the
action to only specified domains.   Use an Action element to allow or deny permission to
call this action.   Constrain the following parameters by using a Condition element with
the appropriate keys.    workflowType.name: String constraint. The key is
swf:workflowType.name.    workflowType.version: String constraint. The key is
swf:workflowType.version.     If the caller doesn't have sufficient permissions to invoke
the action, or the parameter values fall outside the specified constraints, the action
fails. The associated event attribute's cause parameter is set to OPERATION_NOT_PERMITTED.
For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF
Workflows in the Amazon SWF Developer Guide.

# Arguments
- `domain`: The name of the domain in which this workflow type is registered.
- `workflow_type`: The workflow type to describe.

"""
function describe_workflow_type(
    domain, workflowType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return swf(
        "DescribeWorkflowType",
        Dict{String,Any}("domain" => domain, "workflowType" => workflowType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_workflow_type(
    domain,
    workflowType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return swf(
        "DescribeWorkflowType",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("domain" => domain, "workflowType" => workflowType),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_workflow_execution_history(domain, execution)
    get_workflow_execution_history(domain, execution, params::Dict{String,<:Any})

Returns the history of the specified workflow execution. The results may be split into
multiple pages. To retrieve subsequent pages, make the call again using the nextPageToken
returned by the initial call.  This operation is eventually consistent. The results are
best effort and may not exactly reflect recent updates and changes.   Access Control  You
can use IAM policies to control this action's access to Amazon SWF resources as follows:
Use a Resource element with the domain name to limit the action to only specified domains.
 Use an Action element to allow or deny permission to call this action.   You cannot use an
IAM policy to constrain this action's parameters.   If the caller doesn't have sufficient
permissions to invoke the action, or the parameter values fall outside the specified
constraints, the action fails. The associated event attribute's cause parameter is set to
OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage
Access to Amazon SWF Workflows in the Amazon SWF Developer Guide.

# Arguments
- `domain`: The name of the domain containing the workflow execution.
- `execution`: Specifies the workflow execution for which to return the history.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maximumPageSize"`: The maximum number of results that are returned per call. Use
  nextPageToken to obtain further pages of results.
- `"nextPageToken"`: If NextPageToken is returned there are more results available. The
  value of NextPageToken is a unique pagination token for each page. Make the call again
  using the returned token to retrieve the next page. Keep all other arguments unchanged.
  Each pagination token expires after 24 hours. Using an expired pagination token will return
  a 400 error: \"Specified token has exceeded its maximum lifetime\".  The configured
  maximumPageSize determines how many results can be returned in a single call.
- `"reverseOrder"`: When set to true, returns the events in reverse order. By default the
  results are returned in ascending order of the eventTimeStamp of the events.
"""
function get_workflow_execution_history(
    domain, execution; aws_config::AbstractAWSConfig=current_aws_config()
)
    return swf(
        "GetWorkflowExecutionHistory",
        Dict{String,Any}("domain" => domain, "execution" => execution);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_workflow_execution_history(
    domain,
    execution,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return swf(
        "GetWorkflowExecutionHistory",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("domain" => domain, "execution" => execution),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_activity_types(domain, registration_status)
    list_activity_types(domain, registration_status, params::Dict{String,<:Any})

Returns information about all activities registered in the specified domain that match the
specified name and registration status. The result includes information like creation date,
current status of the activity, etc. The results may be split into multiple pages. To
retrieve subsequent pages, make the call again using the nextPageToken returned by the
initial call.  Access Control  You can use IAM policies to control this action's access to
Amazon SWF resources as follows:   Use a Resource element with the domain name to limit the
action to only specified domains.   Use an Action element to allow or deny permission to
call this action.   You cannot use an IAM policy to constrain this action's parameters.
If the caller doesn't have sufficient permissions to invoke the action, or the parameter
values fall outside the specified constraints, the action fails. The associated event
attribute's cause parameter is set to OPERATION_NOT_PERMITTED. For details and example IAM
policies, see Using IAM to Manage Access to Amazon SWF Workflows in the Amazon SWF
Developer Guide.

# Arguments
- `domain`: The name of the domain in which the activity types have been registered.
- `registration_status`: Specifies the registration status of the activity types to list.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maximumPageSize"`: The maximum number of results that are returned per call. Use
  nextPageToken to obtain further pages of results.
- `"name"`: If specified, only lists the activity types that have this name.
- `"nextPageToken"`: If NextPageToken is returned there are more results available. The
  value of NextPageToken is a unique pagination token for each page. Make the call again
  using the returned token to retrieve the next page. Keep all other arguments unchanged.
  Each pagination token expires after 24 hours. Using an expired pagination token will return
  a 400 error: \"Specified token has exceeded its maximum lifetime\".  The configured
  maximumPageSize determines how many results can be returned in a single call.
- `"reverseOrder"`: When set to true, returns the results in reverse order. By default, the
  results are returned in ascending alphabetical order by name of the activity types.
"""
function list_activity_types(
    domain, registrationStatus; aws_config::AbstractAWSConfig=current_aws_config()
)
    return swf(
        "ListActivityTypes",
        Dict{String,Any}("domain" => domain, "registrationStatus" => registrationStatus);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_activity_types(
    domain,
    registrationStatus,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return swf(
        "ListActivityTypes",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "domain" => domain, "registrationStatus" => registrationStatus
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_closed_workflow_executions(domain)
    list_closed_workflow_executions(domain, params::Dict{String,<:Any})

Returns a list of closed workflow executions in the specified domain that meet the
filtering criteria. The results may be split into multiple pages. To retrieve subsequent
pages, make the call again using the nextPageToken returned by the initial call.  This
operation is eventually consistent. The results are best effort and may not exactly reflect
recent updates and changes.   Access Control  You can use IAM policies to control this
action's access to Amazon SWF resources as follows:   Use a Resource element with the
domain name to limit the action to only specified domains.   Use an Action element to allow
or deny permission to call this action.   Constrain the following parameters by using a
Condition element with the appropriate keys.    tagFilter.tag: String constraint. The key
is swf:tagFilter.tag.    typeFilter.name: String constraint. The key is
swf:typeFilter.name.    typeFilter.version: String constraint. The key is
swf:typeFilter.version.     If the caller doesn't have sufficient permissions to invoke the
action, or the parameter values fall outside the specified constraints, the action fails.
The associated event attribute's cause parameter is set to OPERATION_NOT_PERMITTED. For
details and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows in
the Amazon SWF Developer Guide.

# Arguments
- `domain`: The name of the domain that contains the workflow executions to list.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"closeStatusFilter"`: If specified, only workflow executions that match this close
  status are listed. For example, if TERMINATED is specified, then only TERMINATED workflow
  executions are listed.   closeStatusFilter, executionFilter, typeFilter and tagFilter are
  mutually exclusive. You can specify at most one of these in a request.
- `"closeTimeFilter"`: If specified, the workflow executions are included in the returned
  results based on whether their close times are within the range specified by this filter.
  Also, if this parameter is specified, the returned results are ordered by their close
  times.   startTimeFilter and closeTimeFilter are mutually exclusive. You must specify one
  of these in a request but not both.
- `"executionFilter"`: If specified, only workflow executions matching the workflow ID
  specified in the filter are returned.   closeStatusFilter, executionFilter, typeFilter and
  tagFilter are mutually exclusive. You can specify at most one of these in a request.
- `"maximumPageSize"`: The maximum number of results that are returned per call. Use
  nextPageToken to obtain further pages of results.
- `"nextPageToken"`: If NextPageToken is returned there are more results available. The
  value of NextPageToken is a unique pagination token for each page. Make the call again
  using the returned token to retrieve the next page. Keep all other arguments unchanged.
  Each pagination token expires after 24 hours. Using an expired pagination token will return
  a 400 error: \"Specified token has exceeded its maximum lifetime\".  The configured
  maximumPageSize determines how many results can be returned in a single call.
- `"reverseOrder"`: When set to true, returns the results in reverse order. By default the
  results are returned in descending order of the start or the close time of the executions.
- `"startTimeFilter"`: If specified, the workflow executions are included in the returned
  results based on whether their start times are within the range specified by this filter.
  Also, if this parameter is specified, the returned results are ordered by their start
  times.   startTimeFilter and closeTimeFilter are mutually exclusive. You must specify one
  of these in a request but not both.
- `"tagFilter"`: If specified, only executions that have the matching tag are listed.
  closeStatusFilter, executionFilter, typeFilter and tagFilter are mutually exclusive. You
  can specify at most one of these in a request.
- `"typeFilter"`: If specified, only executions of the type specified in the filter are
  returned.   closeStatusFilter, executionFilter, typeFilter and tagFilter are mutually
  exclusive. You can specify at most one of these in a request.
"""
function list_closed_workflow_executions(
    domain; aws_config::AbstractAWSConfig=current_aws_config()
)
    return swf(
        "ListClosedWorkflowExecutions",
        Dict{String,Any}("domain" => domain);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_closed_workflow_executions(
    domain, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return swf(
        "ListClosedWorkflowExecutions",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("domain" => domain), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_domains(registration_status)
    list_domains(registration_status, params::Dict{String,<:Any})

Returns the list of domains registered in the account. The results may be split into
multiple pages. To retrieve subsequent pages, make the call again using the nextPageToken
returned by the initial call.  This operation is eventually consistent. The results are
best effort and may not exactly reflect recent updates and changes.   Access Control  You
can use IAM policies to control this action's access to Amazon SWF resources as follows:
Use a Resource element with the domain name to limit the action to only specified domains.
The element must be set to arn:aws:swf::AccountID:domain/*, where AccountID is the account
ID, with no dashes.   Use an Action element to allow or deny permission to call this
action.   You cannot use an IAM policy to constrain this action's parameters.   If the
caller doesn't have sufficient permissions to invoke the action, or the parameter values
fall outside the specified constraints, the action fails. The associated event attribute's
cause parameter is set to OPERATION_NOT_PERMITTED. For details and example IAM policies,
see Using IAM to Manage Access to Amazon SWF Workflows in the Amazon SWF Developer Guide.

# Arguments
- `registration_status`: Specifies the registration status of the domains to list.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maximumPageSize"`: The maximum number of results that are returned per call. Use
  nextPageToken to obtain further pages of results.
- `"nextPageToken"`: If NextPageToken is returned there are more results available. The
  value of NextPageToken is a unique pagination token for each page. Make the call again
  using the returned token to retrieve the next page. Keep all other arguments unchanged.
  Each pagination token expires after 24 hours. Using an expired pagination token will return
  a 400 error: \"Specified token has exceeded its maximum lifetime\".  The configured
  maximumPageSize determines how many results can be returned in a single call.
- `"reverseOrder"`: When set to true, returns the results in reverse order. By default, the
  results are returned in ascending alphabetical order by name of the domains.
"""
function list_domains(
    registrationStatus; aws_config::AbstractAWSConfig=current_aws_config()
)
    return swf(
        "ListDomains",
        Dict{String,Any}("registrationStatus" => registrationStatus);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_domains(
    registrationStatus,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return swf(
        "ListDomains",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("registrationStatus" => registrationStatus), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_open_workflow_executions(domain, start_time_filter)
    list_open_workflow_executions(domain, start_time_filter, params::Dict{String,<:Any})

Returns a list of open workflow executions in the specified domain that meet the filtering
criteria. The results may be split into multiple pages. To retrieve subsequent pages, make
the call again using the nextPageToken returned by the initial call.  This operation is
eventually consistent. The results are best effort and may not exactly reflect recent
updates and changes.   Access Control  You can use IAM policies to control this action's
access to Amazon SWF resources as follows:   Use a Resource element with the domain name to
limit the action to only specified domains.   Use an Action element to allow or deny
permission to call this action.   Constrain the following parameters by using a Condition
element with the appropriate keys.    tagFilter.tag: String constraint. The key is
swf:tagFilter.tag.    typeFilter.name: String constraint. The key is swf:typeFilter.name.
 typeFilter.version: String constraint. The key is swf:typeFilter.version.     If the
caller doesn't have sufficient permissions to invoke the action, or the parameter values
fall outside the specified constraints, the action fails. The associated event attribute's
cause parameter is set to OPERATION_NOT_PERMITTED. For details and example IAM policies,
see Using IAM to Manage Access to Amazon SWF Workflows in the Amazon SWF Developer Guide.

# Arguments
- `domain`: The name of the domain that contains the workflow executions to list.
- `start_time_filter`: Workflow executions are included in the returned results based on
  whether their start times are within the range specified by this filter.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"executionFilter"`: If specified, only workflow executions matching the workflow ID
  specified in the filter are returned.   executionFilter, typeFilter and tagFilter are
  mutually exclusive. You can specify at most one of these in a request.
- `"maximumPageSize"`: The maximum number of results that are returned per call. Use
  nextPageToken to obtain further pages of results.
- `"nextPageToken"`: If NextPageToken is returned there are more results available. The
  value of NextPageToken is a unique pagination token for each page. Make the call again
  using the returned token to retrieve the next page. Keep all other arguments unchanged.
  Each pagination token expires after 24 hours. Using an expired pagination token will return
  a 400 error: \"Specified token has exceeded its maximum lifetime\".  The configured
  maximumPageSize determines how many results can be returned in a single call.
- `"reverseOrder"`: When set to true, returns the results in reverse order. By default the
  results are returned in descending order of the start time of the executions.
- `"tagFilter"`: If specified, only executions that have the matching tag are listed.
  executionFilter, typeFilter and tagFilter are mutually exclusive. You can specify at most
  one of these in a request.
- `"typeFilter"`: If specified, only executions of the type specified in the filter are
  returned.   executionFilter, typeFilter and tagFilter are mutually exclusive. You can
  specify at most one of these in a request.
"""
function list_open_workflow_executions(
    domain, startTimeFilter; aws_config::AbstractAWSConfig=current_aws_config()
)
    return swf(
        "ListOpenWorkflowExecutions",
        Dict{String,Any}("domain" => domain, "startTimeFilter" => startTimeFilter);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_open_workflow_executions(
    domain,
    startTimeFilter,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return swf(
        "ListOpenWorkflowExecutions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("domain" => domain, "startTimeFilter" => startTimeFilter),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

List tags for a given domain.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) for the Amazon SWF domain.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return swf(
        "ListTagsForResource",
        Dict{String,Any}("resourceArn" => resourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return swf(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceArn" => resourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_workflow_types(domain, registration_status)
    list_workflow_types(domain, registration_status, params::Dict{String,<:Any})

Returns information about workflow types in the specified domain. The results may be split
into multiple pages that can be retrieved by making the call repeatedly.  Access Control
You can use IAM policies to control this action's access to Amazon SWF resources as
follows:   Use a Resource element with the domain name to limit the action to only
specified domains.   Use an Action element to allow or deny permission to call this action.
  You cannot use an IAM policy to constrain this action's parameters.   If the caller
doesn't have sufficient permissions to invoke the action, or the parameter values fall
outside the specified constraints, the action fails. The associated event attribute's cause
parameter is set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see
Using IAM to Manage Access to Amazon SWF Workflows in the Amazon SWF Developer Guide.

# Arguments
- `domain`: The name of the domain in which the workflow types have been registered.
- `registration_status`: Specifies the registration status of the workflow types to list.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maximumPageSize"`: The maximum number of results that are returned per call. Use
  nextPageToken to obtain further pages of results.
- `"name"`: If specified, lists the workflow type with this name.
- `"nextPageToken"`: If NextPageToken is returned there are more results available. The
  value of NextPageToken is a unique pagination token for each page. Make the call again
  using the returned token to retrieve the next page. Keep all other arguments unchanged.
  Each pagination token expires after 24 hours. Using an expired pagination token will return
  a 400 error: \"Specified token has exceeded its maximum lifetime\".  The configured
  maximumPageSize determines how many results can be returned in a single call.
- `"reverseOrder"`: When set to true, returns the results in reverse order. By default the
  results are returned in ascending alphabetical order of the name of the workflow types.
"""
function list_workflow_types(
    domain, registrationStatus; aws_config::AbstractAWSConfig=current_aws_config()
)
    return swf(
        "ListWorkflowTypes",
        Dict{String,Any}("domain" => domain, "registrationStatus" => registrationStatus);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_workflow_types(
    domain,
    registrationStatus,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return swf(
        "ListWorkflowTypes",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "domain" => domain, "registrationStatus" => registrationStatus
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    poll_for_activity_task(domain, task_list)
    poll_for_activity_task(domain, task_list, params::Dict{String,<:Any})

Used by workers to get an ActivityTask from the specified activity taskList. This initiates
a long poll, where the service holds the HTTP connection open and responds as soon as a
task becomes available. The maximum time the service holds on to the request before
responding is 60 seconds. If no task is available within 60 seconds, the poll returns an
empty result. An empty result, in this context, means that an ActivityTask is returned, but
that the value of taskToken is an empty string. If a task is returned, the worker should
use its type to identify and process it correctly.  Workers should set their client side
socket timeout to at least 70 seconds (10 seconds higher than the maximum time service may
hold the poll request).   Access Control  You can use IAM policies to control this action's
access to Amazon SWF resources as follows:   Use a Resource element with the domain name to
limit the action to only specified domains.   Use an Action element to allow or deny
permission to call this action.   Constrain the taskList.name parameter by using a
Condition element with the swf:taskList.name key to allow the action to access only certain
task lists.   If the caller doesn't have sufficient permissions to invoke the action, or
the parameter values fall outside the specified constraints, the action fails. The
associated event attribute's cause parameter is set to OPERATION_NOT_PERMITTED. For details
and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows in the
Amazon SWF Developer Guide.

# Arguments
- `domain`: The name of the domain that contains the task lists being polled.
- `task_list`: Specifies the task list to poll for activity tasks. The specified string
  must not start or end with whitespace. It must not contain a : (colon), / (slash), |
  (vertical bar), or any control characters (u0000-u001f | u007f-u009f). Also, it must not be
  the literal string arn.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"identity"`: Identity of the worker making the request, recorded in the
  ActivityTaskStarted event in the workflow history. This enables diagnostic tracing when
  problems arise. The form of this identity is user defined.
"""
function poll_for_activity_task(
    domain, taskList; aws_config::AbstractAWSConfig=current_aws_config()
)
    return swf(
        "PollForActivityTask",
        Dict{String,Any}("domain" => domain, "taskList" => taskList);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function poll_for_activity_task(
    domain,
    taskList,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return swf(
        "PollForActivityTask",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("domain" => domain, "taskList" => taskList), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    poll_for_decision_task(domain, task_list)
    poll_for_decision_task(domain, task_list, params::Dict{String,<:Any})

Used by deciders to get a DecisionTask from the specified decision taskList. A decision
task may be returned for any open workflow execution that is using the specified task list.
The task includes a paginated view of the history of the workflow execution. The decider
should use the workflow type and the history to determine how to properly handle the task.
This action initiates a long poll, where the service holds the HTTP connection open and
responds as soon a task becomes available. If no decision task is available in the
specified task list before the timeout of 60 seconds expires, an empty result is returned.
An empty result, in this context, means that a DecisionTask is returned, but that the value
of taskToken is an empty string.  Deciders should set their client side socket timeout to
at least 70 seconds (10 seconds higher than the timeout).   Because the number of workflow
history events for a single workflow execution might be very large, the result returned
might be split up across a number of pages. To retrieve subsequent pages, make additional
calls to PollForDecisionTask using the nextPageToken returned by the initial call. Note
that you do not call GetWorkflowExecutionHistory with this nextPageToken. Instead, call
PollForDecisionTask again.   Access Control  You can use IAM policies to control this
action's access to Amazon SWF resources as follows:   Use a Resource element with the
domain name to limit the action to only specified domains.   Use an Action element to allow
or deny permission to call this action.   Constrain the taskList.name parameter by using a
Condition element with the swf:taskList.name key to allow the action to access only certain
task lists.   If the caller doesn't have sufficient permissions to invoke the action, or
the parameter values fall outside the specified constraints, the action fails. The
associated event attribute's cause parameter is set to OPERATION_NOT_PERMITTED. For details
and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows in the
Amazon SWF Developer Guide.

# Arguments
- `domain`: The name of the domain containing the task lists to poll.
- `task_list`: Specifies the task list to poll for decision tasks. The specified string
  must not contain a : (colon), / (slash), | (vertical bar), or any control characters
  (u0000-u001f | u007f-u009f). Also, it must not be the literal string arn.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"identity"`: Identity of the decider making the request, which is recorded in the
  DecisionTaskStarted event in the workflow history. This enables diagnostic tracing when
  problems arise. The form of this identity is user defined.
- `"maximumPageSize"`: The maximum number of results that are returned per call. Use
  nextPageToken to obtain further pages of results.  This is an upper limit only; the actual
  number of results returned per call may be fewer than the specified maximum.
- `"nextPageToken"`: If NextPageToken is returned there are more results available. The
  value of NextPageToken is a unique pagination token for each page. Make the call again
  using the returned token to retrieve the next page. Keep all other arguments unchanged.
  Each pagination token expires after 24 hours. Using an expired pagination token will return
  a 400 error: \"Specified token has exceeded its maximum lifetime\".  The configured
  maximumPageSize determines how many results can be returned in a single call.   The
  nextPageToken returned by this action cannot be used with GetWorkflowExecutionHistory to
  get the next page. You must call PollForDecisionTask again (with the nextPageToken) to
  retrieve the next page of history records. Calling PollForDecisionTask with a nextPageToken
  doesn't return a new decision task.
- `"reverseOrder"`: When set to true, returns the events in reverse order. By default the
  results are returned in ascending order of the eventTimestamp of the events.
- `"startAtPreviousStartedEvent"`: When set to true, returns the events with eventTimestamp
  greater than or equal to eventTimestamp of the most recent DecisionTaskStarted event. By
  default, this parameter is set to false.
"""
function poll_for_decision_task(
    domain, taskList; aws_config::AbstractAWSConfig=current_aws_config()
)
    return swf(
        "PollForDecisionTask",
        Dict{String,Any}("domain" => domain, "taskList" => taskList);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function poll_for_decision_task(
    domain,
    taskList,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return swf(
        "PollForDecisionTask",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("domain" => domain, "taskList" => taskList), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    record_activity_task_heartbeat(task_token)
    record_activity_task_heartbeat(task_token, params::Dict{String,<:Any})

Used by activity workers to report to the service that the ActivityTask represented by the
specified taskToken is still making progress. The worker can also specify details of the
progress, for example percent complete, using the details parameter. This action can also
be used by the worker as a mechanism to check if cancellation is being requested for the
activity task. If a cancellation is being attempted for the specified task, then the
boolean cancelRequested flag returned by the service is set to true. This action resets the
taskHeartbeatTimeout clock. The taskHeartbeatTimeout is specified in RegisterActivityType.
This action doesn't in itself create an event in the workflow execution history. However,
if the task times out, the workflow execution history contains a ActivityTaskTimedOut event
that contains the information from the last heartbeat generated by the activity worker.
The taskStartToCloseTimeout of an activity type is the maximum duration of an activity
task, regardless of the number of RecordActivityTaskHeartbeat requests received. The
taskStartToCloseTimeout is also specified in RegisterActivityType.   This operation is only
useful for long-lived activities to report liveliness of the task and to determine if a
cancellation is being attempted.   If the cancelRequested flag returns true, a cancellation
is being attempted. If the worker can cancel the activity, it should respond with
RespondActivityTaskCanceled. Otherwise, it should ignore the cancellation request.   Access
Control  You can use IAM policies to control this action's access to Amazon SWF resources
as follows:   Use a Resource element with the domain name to limit the action to only
specified domains.   Use an Action element to allow or deny permission to call this action.
  You cannot use an IAM policy to constrain this action's parameters.   If the caller
doesn't have sufficient permissions to invoke the action, or the parameter values fall
outside the specified constraints, the action fails. The associated event attribute's cause
parameter is set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see
Using IAM to Manage Access to Amazon SWF Workflows in the Amazon SWF Developer Guide.

# Arguments
- `task_token`: The taskToken of the ActivityTask.   taskToken is generated by the service
  and should be treated as an opaque value. If the task is passed to another process, its
  taskToken must also be passed. This enables it to provide its progress and respond with
  results.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"details"`: If specified, contains details about the progress of the task.
"""
function record_activity_task_heartbeat(
    taskToken; aws_config::AbstractAWSConfig=current_aws_config()
)
    return swf(
        "RecordActivityTaskHeartbeat",
        Dict{String,Any}("taskToken" => taskToken);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function record_activity_task_heartbeat(
    taskToken,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return swf(
        "RecordActivityTaskHeartbeat",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("taskToken" => taskToken), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    register_activity_type(domain, name, version)
    register_activity_type(domain, name, version, params::Dict{String,<:Any})

Registers a new activity type along with its configuration settings in the specified
domain.  A TypeAlreadyExists fault is returned if the type already exists in the domain.
You cannot change any configuration settings of the type after its registration, and it
must be registered as a new version.   Access Control  You can use IAM policies to control
this action's access to Amazon SWF resources as follows:   Use a Resource element with the
domain name to limit the action to only specified domains.   Use an Action element to allow
or deny permission to call this action.   Constrain the following parameters by using a
Condition element with the appropriate keys.    defaultTaskList.name: String constraint.
The key is swf:defaultTaskList.name.    name: String constraint. The key is swf:name.
version: String constraint. The key is swf:version.     If the caller doesn't have
sufficient permissions to invoke the action, or the parameter values fall outside the
specified constraints, the action fails. The associated event attribute's cause parameter
is set to OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to
Manage Access to Amazon SWF Workflows in the Amazon SWF Developer Guide.

# Arguments
- `domain`: The name of the domain in which this activity is to be registered.
- `name`: The name of the activity type within the domain. The specified string must not
  contain a : (colon), / (slash), | (vertical bar), or any control characters (u0000-u001f |
  u007f-u009f). Also, it must not be the literal string arn.
- `version`: The version of the activity type.  The activity type consists of the name and
  version, the combination of which must be unique within the domain.  The specified string
  must not contain a : (colon), / (slash), | (vertical bar), or any control characters
  (u0000-u001f | u007f-u009f). Also, it must not be the literal string arn.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"defaultTaskHeartbeatTimeout"`: If set, specifies the default maximum time before which
  a worker processing a task of this type must report progress by calling
  RecordActivityTaskHeartbeat. If the timeout is exceeded, the activity task is automatically
  timed out. This default can be overridden when scheduling an activity task using the
  ScheduleActivityTask Decision. If the activity worker subsequently attempts to record a
  heartbeat or returns a result, the activity worker receives an UnknownResource fault. In
  this case, Amazon SWF no longer considers the activity task to be valid; the activity
  worker should clean up the activity task. The duration is specified in seconds, an integer
  greater than or equal to 0. You can use NONE to specify unlimited duration.
- `"defaultTaskList"`: If set, specifies the default task list to use for scheduling tasks
  of this activity type. This default task list is used if a task list isn't provided when a
  task is scheduled through the ScheduleActivityTask Decision.
- `"defaultTaskPriority"`: The default task priority to assign to the activity type. If not
  assigned, then 0 is used. Valid values are integers that range from Java's
  Integer.MIN_VALUE (-2147483648) to Integer.MAX_VALUE (2147483647). Higher numbers indicate
  higher priority. For more information about setting task priority, see Setting Task
  Priority in the in the Amazon SWF Developer Guide..
- `"defaultTaskScheduleToCloseTimeout"`: If set, specifies the default maximum duration for
  a task of this activity type. This default can be overridden when scheduling an activity
  task using the ScheduleActivityTask Decision. The duration is specified in seconds, an
  integer greater than or equal to 0. You can use NONE to specify unlimited duration.
- `"defaultTaskScheduleToStartTimeout"`: If set, specifies the default maximum duration
  that a task of this activity type can wait before being assigned to a worker. This default
  can be overridden when scheduling an activity task using the ScheduleActivityTask Decision.
  The duration is specified in seconds, an integer greater than or equal to 0. You can use
  NONE to specify unlimited duration.
- `"defaultTaskStartToCloseTimeout"`: If set, specifies the default maximum duration that a
  worker can take to process tasks of this activity type. This default can be overridden when
  scheduling an activity task using the ScheduleActivityTask Decision. The duration is
  specified in seconds, an integer greater than or equal to 0. You can use NONE to specify
  unlimited duration.
- `"description"`: A textual description of the activity type.
"""
function register_activity_type(
    domain, name, version; aws_config::AbstractAWSConfig=current_aws_config()
)
    return swf(
        "RegisterActivityType",
        Dict{String,Any}("domain" => domain, "name" => name, "version" => version);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function register_activity_type(
    domain,
    name,
    version,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return swf(
        "RegisterActivityType",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("domain" => domain, "name" => name, "version" => version),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    register_domain(name, workflow_execution_retention_period_in_days)
    register_domain(name, workflow_execution_retention_period_in_days, params::Dict{String,<:Any})

Registers a new domain.  Access Control  You can use IAM policies to control this action's
access to Amazon SWF resources as follows:   You cannot use an IAM policy to control domain
access for this action. The name of the domain being registered is available as the
resource of this action.   Use an Action element to allow or deny permission to call this
action.   You cannot use an IAM policy to constrain this action's parameters.   If the
caller doesn't have sufficient permissions to invoke the action, or the parameter values
fall outside the specified constraints, the action fails. The associated event attribute's
cause parameter is set to OPERATION_NOT_PERMITTED. For details and example IAM policies,
see Using IAM to Manage Access to Amazon SWF Workflows in the Amazon SWF Developer Guide.

# Arguments
- `name`: Name of the domain to register. The name must be unique in the region that the
  domain is registered in. The specified string must not start or end with whitespace. It
  must not contain a : (colon), / (slash), | (vertical bar), or any control characters
  (u0000-u001f | u007f-u009f). Also, it must not be the literal string arn.
- `workflow_execution_retention_period_in_days`: The duration (in days) that records and
  histories of workflow executions on the domain should be kept by the service. After the
  retention period, the workflow execution isn't available in the results of visibility
  calls. If you pass the value NONE or 0 (zero), then the workflow execution history isn't
  retained. As soon as the workflow execution completes, the execution record and its history
  are deleted. The maximum workflow execution retention period is 90 days. For more
  information about Amazon SWF service limits, see: Amazon SWF Service Limits in the Amazon
  SWF Developer Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A text description of the domain.
- `"tags"`: Tags to be added when registering a domain. Tags may only contain unicode
  letters, digits, whitespace, or these symbols: _ . : / = + - @.
"""
function register_domain(
    name,
    workflowExecutionRetentionPeriodInDays;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return swf(
        "RegisterDomain",
        Dict{String,Any}(
            "name" => name,
            "workflowExecutionRetentionPeriodInDays" =>
                workflowExecutionRetentionPeriodInDays,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function register_domain(
    name,
    workflowExecutionRetentionPeriodInDays,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return swf(
        "RegisterDomain",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "name" => name,
                    "workflowExecutionRetentionPeriodInDays" =>
                        workflowExecutionRetentionPeriodInDays,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    register_workflow_type(domain, name, version)
    register_workflow_type(domain, name, version, params::Dict{String,<:Any})

Registers a new workflow type and its configuration settings in the specified domain. The
retention period for the workflow history is set by the RegisterDomain action.  If the type
already exists, then a TypeAlreadyExists fault is returned. You cannot change the
configuration settings of a workflow type once it is registered and it must be registered
as a new version.   Access Control  You can use IAM policies to control this action's
access to Amazon SWF resources as follows:   Use a Resource element with the domain name to
limit the action to only specified domains.   Use an Action element to allow or deny
permission to call this action.   Constrain the following parameters by using a Condition
element with the appropriate keys.    defaultTaskList.name: String constraint. The key is
swf:defaultTaskList.name.    name: String constraint. The key is swf:name.    version:
String constraint. The key is swf:version.     If the caller doesn't have sufficient
permissions to invoke the action, or the parameter values fall outside the specified
constraints, the action fails. The associated event attribute's cause parameter is set to
OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage
Access to Amazon SWF Workflows in the Amazon SWF Developer Guide.

# Arguments
- `domain`: The name of the domain in which to register the workflow type.
- `name`: The name of the workflow type. The specified string must not contain a : (colon),
  / (slash), | (vertical bar), or any control characters (u0000-u001f | u007f-u009f). Also,
  it must not be the literal string arn.
- `version`: The version of the workflow type.  The workflow type consists of the name and
  version, the combination of which must be unique within the domain. To get a list of all
  currently registered workflow types, use the ListWorkflowTypes action.  The specified
  string must not contain a : (colon), / (slash), | (vertical bar), or any control characters
  (u0000-u001f | u007f-u009f). Also, it must not be the literal string arn.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"defaultChildPolicy"`: If set, specifies the default policy to use for the child
  workflow executions when a workflow execution of this type is terminated, by calling the
  TerminateWorkflowExecution action explicitly or due to an expired timeout. This default can
  be overridden when starting a workflow execution using the StartWorkflowExecution action or
  the StartChildWorkflowExecution Decision. The supported child policies are:    TERMINATE
  – The child executions are terminated.    REQUEST_CANCEL – A request to cancel is
  attempted for each child execution by recording a WorkflowExecutionCancelRequested event in
  its history. It is up to the decider to take appropriate actions when it receives an
  execution history with this event.    ABANDON – No action is taken. The child executions
  continue to run.
- `"defaultExecutionStartToCloseTimeout"`: If set, specifies the default maximum duration
  for executions of this workflow type. You can override this default when starting an
  execution through the StartWorkflowExecution Action or StartChildWorkflowExecution
  Decision. The duration is specified in seconds; an integer greater than or equal to 0.
  Unlike some of the other timeout parameters in Amazon SWF, you cannot specify a value of
  \"NONE\" for defaultExecutionStartToCloseTimeout; there is a one-year max limit on the time
  that a workflow execution can run. Exceeding this limit always causes the workflow
  execution to time out.
- `"defaultLambdaRole"`: The default IAM role attached to this workflow type.  Executions
  of this workflow type need IAM roles to invoke Lambda functions. If you don't specify an
  IAM role when you start this workflow type, the default Lambda role is attached to the
  execution. For more information, see
  https://docs.aws.amazon.com/amazonswf/latest/developerguide/lambda-task.html in the Amazon
  SWF Developer Guide.
- `"defaultTaskList"`: If set, specifies the default task list to use for scheduling
  decision tasks for executions of this workflow type. This default is used only if a task
  list isn't provided when starting the execution through the StartWorkflowExecution Action
  or StartChildWorkflowExecution Decision.
- `"defaultTaskPriority"`: The default task priority to assign to the workflow type. If not
  assigned, then 0 is used. Valid values are integers that range from Java's
  Integer.MIN_VALUE (-2147483648) to Integer.MAX_VALUE (2147483647). Higher numbers indicate
  higher priority. For more information about setting task priority, see Setting Task
  Priority in the Amazon SWF Developer Guide.
- `"defaultTaskStartToCloseTimeout"`: If set, specifies the default maximum duration of
  decision tasks for this workflow type. This default can be overridden when starting a
  workflow execution using the StartWorkflowExecution action or the
  StartChildWorkflowExecution Decision. The duration is specified in seconds, an integer
  greater than or equal to 0. You can use NONE to specify unlimited duration.
- `"description"`: Textual description of the workflow type.
"""
function register_workflow_type(
    domain, name, version; aws_config::AbstractAWSConfig=current_aws_config()
)
    return swf(
        "RegisterWorkflowType",
        Dict{String,Any}("domain" => domain, "name" => name, "version" => version);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function register_workflow_type(
    domain,
    name,
    version,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return swf(
        "RegisterWorkflowType",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("domain" => domain, "name" => name, "version" => version),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    request_cancel_workflow_execution(domain, workflow_id)
    request_cancel_workflow_execution(domain, workflow_id, params::Dict{String,<:Any})

Records a WorkflowExecutionCancelRequested event in the currently running workflow
execution identified by the given domain, workflowId, and runId. This logically requests
the cancellation of the workflow execution as a whole. It is up to the decider to take
appropriate actions when it receives an execution history with this event.  If the runId
isn't specified, the WorkflowExecutionCancelRequested event is recorded in the history of
the current open workflow execution with the specified workflowId in the domain.   Because
this action allows the workflow to properly clean up and gracefully close, it should be
used instead of TerminateWorkflowExecution when possible.   Access Control  You can use IAM
policies to control this action's access to Amazon SWF resources as follows:   Use a
Resource element with the domain name to limit the action to only specified domains.   Use
an Action element to allow or deny permission to call this action.   You cannot use an IAM
policy to constrain this action's parameters.   If the caller doesn't have sufficient
permissions to invoke the action, or the parameter values fall outside the specified
constraints, the action fails. The associated event attribute's cause parameter is set to
OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage
Access to Amazon SWF Workflows in the Amazon SWF Developer Guide.

# Arguments
- `domain`: The name of the domain containing the workflow execution to cancel.
- `workflow_id`: The workflowId of the workflow execution to cancel.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"runId"`: The runId of the workflow execution to cancel.
"""
function request_cancel_workflow_execution(
    domain, workflowId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return swf(
        "RequestCancelWorkflowExecution",
        Dict{String,Any}("domain" => domain, "workflowId" => workflowId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function request_cancel_workflow_execution(
    domain,
    workflowId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return swf(
        "RequestCancelWorkflowExecution",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("domain" => domain, "workflowId" => workflowId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    respond_activity_task_canceled(task_token)
    respond_activity_task_canceled(task_token, params::Dict{String,<:Any})

Used by workers to tell the service that the ActivityTask identified by the taskToken was
successfully canceled. Additional details can be provided using the details argument. These
details (if provided) appear in the ActivityTaskCanceled event added to the workflow
history.  Only use this operation if the canceled flag of a RecordActivityTaskHeartbeat
request returns true and if the activity can be safely undone or abandoned.  A task is
considered open from the time that it is scheduled until it is closed. Therefore a task is
reported as open while a worker is processing it. A task is closed after it has been
specified in a call to RespondActivityTaskCompleted, RespondActivityTaskCanceled,
RespondActivityTaskFailed, or the task has timed out.  Access Control  You can use IAM
policies to control this action's access to Amazon SWF resources as follows:   Use a
Resource element with the domain name to limit the action to only specified domains.   Use
an Action element to allow or deny permission to call this action.   You cannot use an IAM
policy to constrain this action's parameters.   If the caller doesn't have sufficient
permissions to invoke the action, or the parameter values fall outside the specified
constraints, the action fails. The associated event attribute's cause parameter is set to
OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage
Access to Amazon SWF Workflows in the Amazon SWF Developer Guide.

# Arguments
- `task_token`: The taskToken of the ActivityTask.   taskToken is generated by the service
  and should be treated as an opaque value. If the task is passed to another process, its
  taskToken must also be passed. This enables it to provide its progress and respond with
  results.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"details"`:  Information about the cancellation.
"""
function respond_activity_task_canceled(
    taskToken; aws_config::AbstractAWSConfig=current_aws_config()
)
    return swf(
        "RespondActivityTaskCanceled",
        Dict{String,Any}("taskToken" => taskToken);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function respond_activity_task_canceled(
    taskToken,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return swf(
        "RespondActivityTaskCanceled",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("taskToken" => taskToken), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    respond_activity_task_completed(task_token)
    respond_activity_task_completed(task_token, params::Dict{String,<:Any})

Used by workers to tell the service that the ActivityTask identified by the taskToken
completed successfully with a result (if provided). The result appears in the
ActivityTaskCompleted event in the workflow history.  If the requested task doesn't
complete successfully, use RespondActivityTaskFailed instead. If the worker finds that the
task is canceled through the canceled flag returned by RecordActivityTaskHeartbeat, it
should cancel the task, clean up and then call RespondActivityTaskCanceled.  A task is
considered open from the time that it is scheduled until it is closed. Therefore a task is
reported as open while a worker is processing it. A task is closed after it has been
specified in a call to RespondActivityTaskCompleted, RespondActivityTaskCanceled,
RespondActivityTaskFailed, or the task has timed out.  Access Control  You can use IAM
policies to control this action's access to Amazon SWF resources as follows:   Use a
Resource element with the domain name to limit the action to only specified domains.   Use
an Action element to allow or deny permission to call this action.   You cannot use an IAM
policy to constrain this action's parameters.   If the caller doesn't have sufficient
permissions to invoke the action, or the parameter values fall outside the specified
constraints, the action fails. The associated event attribute's cause parameter is set to
OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage
Access to Amazon SWF Workflows in the Amazon SWF Developer Guide.

# Arguments
- `task_token`: The taskToken of the ActivityTask.   taskToken is generated by the service
  and should be treated as an opaque value. If the task is passed to another process, its
  taskToken must also be passed. This enables it to provide its progress and respond with
  results.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"result"`: The result of the activity task. It is a free form string that is
  implementation specific.
"""
function respond_activity_task_completed(
    taskToken; aws_config::AbstractAWSConfig=current_aws_config()
)
    return swf(
        "RespondActivityTaskCompleted",
        Dict{String,Any}("taskToken" => taskToken);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function respond_activity_task_completed(
    taskToken,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return swf(
        "RespondActivityTaskCompleted",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("taskToken" => taskToken), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    respond_activity_task_failed(task_token)
    respond_activity_task_failed(task_token, params::Dict{String,<:Any})

Used by workers to tell the service that the ActivityTask identified by the taskToken has
failed with reason (if specified). The reason and details appear in the ActivityTaskFailed
event added to the workflow history. A task is considered open from the time that it is
scheduled until it is closed. Therefore a task is reported as open while a worker is
processing it. A task is closed after it has been specified in a call to
RespondActivityTaskCompleted, RespondActivityTaskCanceled, RespondActivityTaskFailed, or
the task has timed out.  Access Control  You can use IAM policies to control this action's
access to Amazon SWF resources as follows:   Use a Resource element with the domain name to
limit the action to only specified domains.   Use an Action element to allow or deny
permission to call this action.   You cannot use an IAM policy to constrain this action's
parameters.   If the caller doesn't have sufficient permissions to invoke the action, or
the parameter values fall outside the specified constraints, the action fails. The
associated event attribute's cause parameter is set to OPERATION_NOT_PERMITTED. For details
and example IAM policies, see Using IAM to Manage Access to Amazon SWF Workflows in the
Amazon SWF Developer Guide.

# Arguments
- `task_token`: The taskToken of the ActivityTask.   taskToken is generated by the service
  and should be treated as an opaque value. If the task is passed to another process, its
  taskToken must also be passed. This enables it to provide its progress and respond with
  results.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"details"`:  Detailed information about the failure.
- `"reason"`: Description of the error that may assist in diagnostics.
"""
function respond_activity_task_failed(
    taskToken; aws_config::AbstractAWSConfig=current_aws_config()
)
    return swf(
        "RespondActivityTaskFailed",
        Dict{String,Any}("taskToken" => taskToken);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function respond_activity_task_failed(
    taskToken,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return swf(
        "RespondActivityTaskFailed",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("taskToken" => taskToken), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    respond_decision_task_completed(task_token)
    respond_decision_task_completed(task_token, params::Dict{String,<:Any})

Used by deciders to tell the service that the DecisionTask identified by the taskToken has
successfully completed. The decisions argument specifies the list of decisions made while
processing the task. A DecisionTaskCompleted event is added to the workflow history. The
executionContext specified is attached to the event in the workflow execution history.
Access Control  If an IAM policy grants permission to use RespondDecisionTaskCompleted, it
can express permissions for the list of decisions in the decisions parameter. Each of the
decisions has one or more parameters, much like a regular API call. To allow for policies
to be as readable as possible, you can express permissions on decisions as if they were
actual API calls, including applying conditions to some parameters. For more information,
see Using IAM to Manage Access to Amazon SWF Workflows in the Amazon SWF Developer Guide.

# Arguments
- `task_token`: The taskToken from the DecisionTask.   taskToken is generated by the
  service and should be treated as an opaque value. If the task is passed to another process,
  its taskToken must also be passed. This enables it to provide its progress and respond with
  results.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"decisions"`: The list of decisions (possibly empty) made by the decider while
  processing this decision task. See the docs for the Decision structure for details.
- `"executionContext"`: User defined context to add to workflow execution.
- `"taskList"`: The task list to use for the future decision tasks of this workflow
  execution. This list overrides the original task list you specified while starting the
  workflow execution.
- `"taskListScheduleToStartTimeout"`: Specifies a timeout (in seconds) for the task list
  override. When this parameter is missing, the task list override is permanent. This
  parameter makes it possible to temporarily override the task list. If a decision task
  scheduled on the override task list is not started within the timeout, the decision task
  will time out. Amazon SWF will revert the override and schedule a new decision task to the
  original task list. If a decision task scheduled on the override task list is started
  within the timeout, but not completed within the start-to-close timeout, Amazon SWF will
  also revert the override and schedule a new decision task to the original task list.
"""
function respond_decision_task_completed(
    taskToken; aws_config::AbstractAWSConfig=current_aws_config()
)
    return swf(
        "RespondDecisionTaskCompleted",
        Dict{String,Any}("taskToken" => taskToken);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function respond_decision_task_completed(
    taskToken,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return swf(
        "RespondDecisionTaskCompleted",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("taskToken" => taskToken), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    signal_workflow_execution(domain, signal_name, workflow_id)
    signal_workflow_execution(domain, signal_name, workflow_id, params::Dict{String,<:Any})

Records a WorkflowExecutionSignaled event in the workflow execution history and creates a
decision task for the workflow execution identified by the given domain, workflowId and
runId. The event is recorded with the specified user defined signalName and input (if
provided).  If a runId isn't specified, then the WorkflowExecutionSignaled event is
recorded in the history of the current open workflow with the matching workflowId in the
domain.   If the specified workflow execution isn't open, this method fails with
UnknownResource.   Access Control  You can use IAM policies to control this action's access
to Amazon SWF resources as follows:   Use a Resource element with the domain name to limit
the action to only specified domains.   Use an Action element to allow or deny permission
to call this action.   You cannot use an IAM policy to constrain this action's parameters.
 If the caller doesn't have sufficient permissions to invoke the action, or the parameter
values fall outside the specified constraints, the action fails. The associated event
attribute's cause parameter is set to OPERATION_NOT_PERMITTED. For details and example IAM
policies, see Using IAM to Manage Access to Amazon SWF Workflows in the Amazon SWF
Developer Guide.

# Arguments
- `domain`: The name of the domain containing the workflow execution to signal.
- `signal_name`: The name of the signal. This name must be meaningful to the target
  workflow.
- `workflow_id`: The workflowId of the workflow execution to signal.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"input"`: Data to attach to the WorkflowExecutionSignaled event in the target workflow
  execution's history.
- `"runId"`: The runId of the workflow execution to signal.
"""
function signal_workflow_execution(
    domain, signalName, workflowId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return swf(
        "SignalWorkflowExecution",
        Dict{String,Any}(
            "domain" => domain, "signalName" => signalName, "workflowId" => workflowId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function signal_workflow_execution(
    domain,
    signalName,
    workflowId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return swf(
        "SignalWorkflowExecution",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "domain" => domain,
                    "signalName" => signalName,
                    "workflowId" => workflowId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_workflow_execution(domain, workflow_id, workflow_type)
    start_workflow_execution(domain, workflow_id, workflow_type, params::Dict{String,<:Any})

Starts an execution of the workflow type in the specified domain using the provided
workflowId and input data. This action returns the newly started workflow execution.
Access Control  You can use IAM policies to control this action's access to Amazon SWF
resources as follows:   Use a Resource element with the domain name to limit the action to
only specified domains.   Use an Action element to allow or deny permission to call this
action.   Constrain the following parameters by using a Condition element with the
appropriate keys.    tagList.member.0: The key is swf:tagList.member.0.
tagList.member.1: The key is swf:tagList.member.1.    tagList.member.2: The key is
swf:tagList.member.2.    tagList.member.3: The key is swf:tagList.member.3.
tagList.member.4: The key is swf:tagList.member.4.    taskList: String constraint. The key
is swf:taskList.name.    workflowType.name: String constraint. The key is
swf:workflowType.name.    workflowType.version: String constraint. The key is
swf:workflowType.version.     If the caller doesn't have sufficient permissions to invoke
the action, or the parameter values fall outside the specified constraints, the action
fails. The associated event attribute's cause parameter is set to OPERATION_NOT_PERMITTED.
For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF
Workflows in the Amazon SWF Developer Guide.

# Arguments
- `domain`: The name of the domain in which the workflow execution is created. The
  specified string must not contain a : (colon), / (slash), | (vertical bar), or any control
  characters (u0000-u001f | u007f-u009f). Also, it must not be the literal string arn.
- `workflow_id`: The user defined identifier associated with the workflow execution. You
  can use this to associate a custom identifier with the workflow execution. You may specify
  the same identifier if a workflow execution is logically a restart of a previous execution.
  You cannot have two open workflow executions with the same workflowId at the same time
  within the same domain. The specified string must not contain a : (colon), / (slash), |
  (vertical bar), or any control characters (u0000-u001f | u007f-u009f). Also, it must not be
  the literal string arn.
- `workflow_type`: The type of the workflow to start.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"childPolicy"`: If set, specifies the policy to use for the child workflow executions of
  this workflow execution if it is terminated, by calling the TerminateWorkflowExecution
  action explicitly or due to an expired timeout. This policy overrides the default child
  policy specified when registering the workflow type using RegisterWorkflowType. The
  supported child policies are:    TERMINATE – The child executions are terminated.
  REQUEST_CANCEL – A request to cancel is attempted for each child execution by recording a
  WorkflowExecutionCancelRequested event in its history. It is up to the decider to take
  appropriate actions when it receives an execution history with this event.    ABANDON –
  No action is taken. The child executions continue to run.    A child policy for this
  workflow execution must be specified either as a default for the workflow type or through
  this parameter. If neither this parameter is set nor a default child policy was specified
  at registration time then a fault is returned.
- `"executionStartToCloseTimeout"`: The total duration for this workflow execution. This
  overrides the defaultExecutionStartToCloseTimeout specified when registering the workflow
  type. The duration is specified in seconds; an integer greater than or equal to 0.
  Exceeding this limit causes the workflow execution to time out. Unlike some of the other
  timeout parameters in Amazon SWF, you cannot specify a value of \"NONE\" for this timeout;
  there is a one-year max limit on the time that a workflow execution can run.  An execution
  start-to-close timeout must be specified either through this parameter or as a default when
  the workflow type is registered. If neither this parameter nor a default execution
  start-to-close timeout is specified, a fault is returned.
- `"input"`: The input for the workflow execution. This is a free form string which should
  be meaningful to the workflow you are starting. This input is made available to the new
  workflow execution in the WorkflowExecutionStarted history event.
- `"lambdaRole"`: The IAM role to attach to this workflow execution.  Executions of this
  workflow type need IAM roles to invoke Lambda functions. If you don't attach an IAM role,
  any attempt to schedule a Lambda task fails. This results in a ScheduleLambdaFunctionFailed
  history event. For more information, see
  https://docs.aws.amazon.com/amazonswf/latest/developerguide/lambda-task.html in the Amazon
  SWF Developer Guide.
- `"tagList"`: The list of tags to associate with the workflow execution. You can specify a
  maximum of 5 tags. You can list workflow executions with a specific tag by calling
  ListOpenWorkflowExecutions or ListClosedWorkflowExecutions and specifying a TagFilter.
- `"taskList"`: The task list to use for the decision tasks generated for this workflow
  execution. This overrides the defaultTaskList specified when registering the workflow type.
   A task list for this workflow execution must be specified either as a default for the
  workflow type or through this parameter. If neither this parameter is set nor a default
  task list was specified at registration time then a fault is returned.  The specified
  string must not contain a : (colon), / (slash), | (vertical bar), or any control characters
  (u0000-u001f | u007f-u009f). Also, it must not be the literal string arn.
- `"taskPriority"`: The task priority to use for this workflow execution. This overrides
  any default priority that was assigned when the workflow type was registered. If not set,
  then the default task priority for the workflow type is used. Valid values are integers
  that range from Java's Integer.MIN_VALUE (-2147483648) to Integer.MAX_VALUE (2147483647).
  Higher numbers indicate higher priority. For more information about setting task priority,
  see Setting Task Priority in the Amazon SWF Developer Guide.
- `"taskStartToCloseTimeout"`: Specifies the maximum duration of decision tasks for this
  workflow execution. This parameter overrides the defaultTaskStartToCloseTimout specified
  when registering the workflow type using RegisterWorkflowType. The duration is specified in
  seconds, an integer greater than or equal to 0. You can use NONE to specify unlimited
  duration.  A task start-to-close timeout for this workflow execution must be specified
  either as a default for the workflow type or through this parameter. If neither this
  parameter is set nor a default task start-to-close timeout was specified at registration
  time then a fault is returned.
"""
function start_workflow_execution(
    domain, workflowId, workflowType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return swf(
        "StartWorkflowExecution",
        Dict{String,Any}(
            "domain" => domain, "workflowId" => workflowId, "workflowType" => workflowType
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_workflow_execution(
    domain,
    workflowId,
    workflowType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return swf(
        "StartWorkflowExecution",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "domain" => domain,
                    "workflowId" => workflowId,
                    "workflowType" => workflowType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Add a tag to a Amazon SWF domain.  Amazon SWF supports a maximum of 50 tags per resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) for the Amazon SWF domain.
- `tags`: The list of tags to add to a domain.  Tags may only contain unicode letters,
  digits, whitespace, or these symbols: _ . : / = + - @.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return swf(
        "TagResource",
        Dict{String,Any}("resourceArn" => resourceArn, "tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return swf(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceArn" => resourceArn, "tags" => tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    terminate_workflow_execution(domain, workflow_id)
    terminate_workflow_execution(domain, workflow_id, params::Dict{String,<:Any})

Records a WorkflowExecutionTerminated event and forces closure of the workflow execution
identified by the given domain, runId, and workflowId. The child policy, registered with
the workflow type or specified when starting this execution, is applied to any open child
workflow executions of this workflow execution.  If the identified workflow execution was
in progress, it is terminated immediately.   If a runId isn't specified, then the
WorkflowExecutionTerminated event is recorded in the history of the current open workflow
with the matching workflowId in the domain.   You should consider using
RequestCancelWorkflowExecution action instead because it allows the workflow to gracefully
close while TerminateWorkflowExecution doesn't.   Access Control  You can use IAM policies
to control this action's access to Amazon SWF resources as follows:   Use a Resource
element with the domain name to limit the action to only specified domains.   Use an Action
element to allow or deny permission to call this action.   You cannot use an IAM policy to
constrain this action's parameters.   If the caller doesn't have sufficient permissions to
invoke the action, or the parameter values fall outside the specified constraints, the
action fails. The associated event attribute's cause parameter is set to
OPERATION_NOT_PERMITTED. For details and example IAM policies, see Using IAM to Manage
Access to Amazon SWF Workflows in the Amazon SWF Developer Guide.

# Arguments
- `domain`: The domain of the workflow execution to terminate.
- `workflow_id`: The workflowId of the workflow execution to terminate.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"childPolicy"`: If set, specifies the policy to use for the child workflow executions of
  the workflow execution being terminated. This policy overrides the child policy specified
  for the workflow execution at registration time or when starting the execution. The
  supported child policies are:    TERMINATE – The child executions are terminated.
  REQUEST_CANCEL – A request to cancel is attempted for each child execution by recording a
  WorkflowExecutionCancelRequested event in its history. It is up to the decider to take
  appropriate actions when it receives an execution history with this event.    ABANDON –
  No action is taken. The child executions continue to run.    A child policy for this
  workflow execution must be specified either as a default for the workflow type or through
  this parameter. If neither this parameter is set nor a default child policy was specified
  at registration time then a fault is returned.
- `"details"`:  Details for terminating the workflow execution.
- `"reason"`:  A descriptive reason for terminating the workflow execution.
- `"runId"`: The runId of the workflow execution to terminate.
"""
function terminate_workflow_execution(
    domain, workflowId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return swf(
        "TerminateWorkflowExecution",
        Dict{String,Any}("domain" => domain, "workflowId" => workflowId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function terminate_workflow_execution(
    domain,
    workflowId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return swf(
        "TerminateWorkflowExecution",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("domain" => domain, "workflowId" => workflowId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    undeprecate_activity_type(activity_type, domain)
    undeprecate_activity_type(activity_type, domain, params::Dict{String,<:Any})

Undeprecates a previously deprecated activity type. After an activity type has been
undeprecated, you can create new tasks of that activity type.  This operation is eventually
consistent. The results are best effort and may not exactly reflect recent updates and
changes.   Access Control  You can use IAM policies to control this action's access to
Amazon SWF resources as follows:   Use a Resource element with the domain name to limit the
action to only specified domains.   Use an Action element to allow or deny permission to
call this action.   Constrain the following parameters by using a Condition element with
the appropriate keys.    activityType.name: String constraint. The key is
swf:activityType.name.    activityType.version: String constraint. The key is
swf:activityType.version.     If the caller doesn't have sufficient permissions to invoke
the action, or the parameter values fall outside the specified constraints, the action
fails. The associated event attribute's cause parameter is set to OPERATION_NOT_PERMITTED.
For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF
Workflows in the Amazon SWF Developer Guide.

# Arguments
- `activity_type`: The activity type to undeprecate.
- `domain`: The name of the domain of the deprecated activity type.

"""
function undeprecate_activity_type(
    activityType, domain; aws_config::AbstractAWSConfig=current_aws_config()
)
    return swf(
        "UndeprecateActivityType",
        Dict{String,Any}("activityType" => activityType, "domain" => domain);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function undeprecate_activity_type(
    activityType,
    domain,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return swf(
        "UndeprecateActivityType",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("activityType" => activityType, "domain" => domain),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    undeprecate_domain(name)
    undeprecate_domain(name, params::Dict{String,<:Any})

Undeprecates a previously deprecated domain. After a domain has been undeprecated it can be
used to create new workflow executions or register new types.  This operation is eventually
consistent. The results are best effort and may not exactly reflect recent updates and
changes.   Access Control  You can use IAM policies to control this action's access to
Amazon SWF resources as follows:   Use a Resource element with the domain name to limit the
action to only specified domains.   Use an Action element to allow or deny permission to
call this action.   You cannot use an IAM policy to constrain this action's parameters.
If the caller doesn't have sufficient permissions to invoke the action, or the parameter
values fall outside the specified constraints, the action fails. The associated event
attribute's cause parameter is set to OPERATION_NOT_PERMITTED. For details and example IAM
policies, see Using IAM to Manage Access to Amazon SWF Workflows in the Amazon SWF
Developer Guide.

# Arguments
- `name`: The name of the domain of the deprecated workflow type.

"""
function undeprecate_domain(name; aws_config::AbstractAWSConfig=current_aws_config())
    return swf(
        "UndeprecateDomain",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function undeprecate_domain(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return swf(
        "UndeprecateDomain",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    undeprecate_workflow_type(domain, workflow_type)
    undeprecate_workflow_type(domain, workflow_type, params::Dict{String,<:Any})

Undeprecates a previously deprecated workflow type. After a workflow type has been
undeprecated, you can create new executions of that type.   This operation is eventually
consistent. The results are best effort and may not exactly reflect recent updates and
changes.   Access Control  You can use IAM policies to control this action's access to
Amazon SWF resources as follows:   Use a Resource element with the domain name to limit the
action to only specified domains.   Use an Action element to allow or deny permission to
call this action.   Constrain the following parameters by using a Condition element with
the appropriate keys.    workflowType.name: String constraint. The key is
swf:workflowType.name.    workflowType.version: String constraint. The key is
swf:workflowType.version.     If the caller doesn't have sufficient permissions to invoke
the action, or the parameter values fall outside the specified constraints, the action
fails. The associated event attribute's cause parameter is set to OPERATION_NOT_PERMITTED.
For details and example IAM policies, see Using IAM to Manage Access to Amazon SWF
Workflows in the Amazon SWF Developer Guide.

# Arguments
- `domain`: The name of the domain of the deprecated workflow type.
- `workflow_type`: The name of the domain of the deprecated workflow type.

"""
function undeprecate_workflow_type(
    domain, workflowType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return swf(
        "UndeprecateWorkflowType",
        Dict{String,Any}("domain" => domain, "workflowType" => workflowType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function undeprecate_workflow_type(
    domain,
    workflowType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return swf(
        "UndeprecateWorkflowType",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("domain" => domain, "workflowType" => workflowType),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Remove a tag from a Amazon SWF domain.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) for the Amazon SWF domain.
- `tag_keys`: The list of tags to remove from the Amazon SWF domain.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return swf(
        "UntagResource",
        Dict{String,Any}("resourceArn" => resourceArn, "tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return swf(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceArn" => resourceArn, "tagKeys" => tagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: kinesis_video
using AWS.Compat
using AWS.UUIDs

"""
    create_signaling_channel(channel_name)
    create_signaling_channel(channel_name, params::Dict{String,<:Any})

Creates a signaling channel.   CreateSignalingChannel is an asynchronous operation.

# Arguments
- `channel_name`: A name for the signaling channel that you are creating. It must be unique
  for each Amazon Web Services account and Amazon Web Services Region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ChannelType"`: A type of the signaling channel that you are creating. Currently,
  SINGLE_MASTER is the only supported channel type.
- `"SingleMasterConfiguration"`: A structure containing the configuration for the
  SINGLE_MASTER channel type.
- `"Tags"`: A set of tags (key-value pairs) that you want to associate with this channel.
"""
function create_signaling_channel(
    ChannelName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_video(
        "POST",
        "/createSignalingChannel",
        Dict{String,Any}("ChannelName" => ChannelName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_signaling_channel(
    ChannelName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_video(
        "POST",
        "/createSignalingChannel",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ChannelName" => ChannelName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_stream(stream_name)
    create_stream(stream_name, params::Dict{String,<:Any})

Creates a new Kinesis video stream.  When you create a new stream, Kinesis Video Streams
assigns it a version number. When you change the stream's metadata, Kinesis Video Streams
updates the version.   CreateStream is an asynchronous operation. For information about how
the service works, see How it Works.  You must have permissions for the
KinesisVideo:CreateStream action.

# Arguments
- `stream_name`: A name for the stream that you are creating. The stream name is an
  identifier for the stream, and must be unique for each account and region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DataRetentionInHours"`: The number of hours that you want to retain the data in the
  stream. Kinesis Video Streams retains the data in a data store that is associated with the
  stream. The default value is 0, indicating that the stream does not persist data. When the
  DataRetentionInHours value is 0, consumers can still consume the fragments that remain in
  the service host buffer, which has a retention time limit of 5 minutes and a retention
  memory limit of 200 MB. Fragments are removed from the buffer when either limit is reached.
- `"DeviceName"`: The name of the device that is writing to the stream.   In the current
  implementation, Kinesis Video Streams does not use this name.
- `"KmsKeyId"`: The ID of the Key Management Service (KMS) key that you want Kinesis Video
  Streams to use to encrypt stream data. If no key ID is specified, the default, Kinesis
  Video-managed key (Amazon Web Services/kinesisvideo) is used.  For more information, see
  DescribeKey.
- `"MediaType"`: The media type of the stream. Consumers of the stream can use this
  information when processing the stream. For more information about media types, see Media
  Types. If you choose to specify the MediaType, see Naming Requirements for guidelines.
  Example valid values include \"video/h264\" and \"video/h264,audio/aac\". This parameter is
  optional; the default value is null (or empty in JSON).
- `"Tags"`: A list of tags to associate with the specified stream. Each tag is a key-value
  pair (the value is optional).
"""
function create_stream(StreamName; aws_config::AbstractAWSConfig=current_aws_config())
    return kinesis_video(
        "POST",
        "/createStream",
        Dict{String,Any}("StreamName" => StreamName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_stream(
    StreamName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_video(
        "POST",
        "/createStream",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("StreamName" => StreamName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_edge_configuration()
    delete_edge_configuration(params::Dict{String,<:Any})

An asynchronous API that deletes a stream’s existing edge configuration, as well as the
corresponding media from the Edge Agent. When you invoke this API, the sync status is set
to DELETING. A deletion process starts, in which active edge jobs are stopped and all media
is deleted from the edge device. The time to delete varies, depending on the total amount
of stored media. If the deletion process fails, the sync status changes to DELETE_FAILED.
You will need to re-try the deletion. When the deletion process has completed successfully,
the edge configuration is no longer accessible.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"StreamARN"`: The Amazon Resource Name (ARN) of the stream. Specify either the
  StreamName or the StreamARN.
- `"StreamName"`: The name of the stream from which to delete the edge configuration.
  Specify either the StreamName or the StreamARN.
"""
function delete_edge_configuration(; aws_config::AbstractAWSConfig=current_aws_config())
    return kinesis_video(
        "POST",
        "/deleteEdgeConfiguration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_edge_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_video(
        "POST",
        "/deleteEdgeConfiguration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_signaling_channel(channel_arn)
    delete_signaling_channel(channel_arn, params::Dict{String,<:Any})

Deletes a specified signaling channel. DeleteSignalingChannel is an asynchronous operation.
If you don't specify the channel's current version, the most recent version is deleted.

# Arguments
- `channel_arn`: The Amazon Resource Name (ARN) of the signaling channel that you want to
  delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CurrentVersion"`: The current version of the signaling channel that you want to delete.
  You can obtain the current version by invoking the DescribeSignalingChannel or
  ListSignalingChannels API operations.
"""
function delete_signaling_channel(
    ChannelARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_video(
        "POST",
        "/deleteSignalingChannel",
        Dict{String,Any}("ChannelARN" => ChannelARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_signaling_channel(
    ChannelARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_video(
        "POST",
        "/deleteSignalingChannel",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ChannelARN" => ChannelARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_stream(stream_arn)
    delete_stream(stream_arn, params::Dict{String,<:Any})

Deletes a Kinesis video stream and the data contained in the stream.  This method marks the
stream for deletion, and makes the data in the stream inaccessible immediately.    To
ensure that you have the latest version of the stream before deleting it, you can specify
the stream version. Kinesis Video Streams assigns a version to each stream. When you update
a stream, Kinesis Video Streams assigns a new version number. To get the latest stream
version, use the DescribeStream API.  This operation requires permission for the
KinesisVideo:DeleteStream action.

# Arguments
- `stream_arn`: The Amazon Resource Name (ARN) of the stream that you want to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CurrentVersion"`: Optional: The version of the stream that you want to delete.  Specify
  the version as a safeguard to ensure that your are deleting the correct stream. To get the
  stream version, use the DescribeStream API. If not specified, only the CreationTime is
  checked before deleting the stream.
"""
function delete_stream(StreamARN; aws_config::AbstractAWSConfig=current_aws_config())
    return kinesis_video(
        "POST",
        "/deleteStream",
        Dict{String,Any}("StreamARN" => StreamARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_stream(
    StreamARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_video(
        "POST",
        "/deleteStream",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("StreamARN" => StreamARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_edge_configuration()
    describe_edge_configuration(params::Dict{String,<:Any})

Describes a stream’s edge configuration that was set using the
StartEdgeConfigurationUpdate API and the latest status of the edge agent's recorder and
uploader jobs. Use this API to get the status of the configuration to determine if the
configuration is in sync with the Edge Agent. Use this API to evaluate the health of the
Edge Agent.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"StreamARN"`: The Amazon Resource Name (ARN) of the stream. Specify either the
  StreamNameor the StreamARN.
- `"StreamName"`: The name of the stream whose edge configuration you want to update.
  Specify either the StreamName or the StreamARN.
"""
function describe_edge_configuration(; aws_config::AbstractAWSConfig=current_aws_config())
    return kinesis_video(
        "POST",
        "/describeEdgeConfiguration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_edge_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_video(
        "POST",
        "/describeEdgeConfiguration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_image_generation_configuration()
    describe_image_generation_configuration(params::Dict{String,<:Any})

Gets the ImageGenerationConfiguration for a given Kinesis video stream.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"StreamARN"`: The Amazon Resource Name (ARN) of the Kinesis video stream from which to
  retrieve the image generation configuration. You must specify either the StreamName or the
  StreamARN.
- `"StreamName"`: The name of the stream from which to retrieve the image generation
  configuration. You must specify either the StreamName or the StreamARN.
"""
function describe_image_generation_configuration(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_video(
        "POST",
        "/describeImageGenerationConfiguration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_image_generation_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_video(
        "POST",
        "/describeImageGenerationConfiguration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_mapped_resource_configuration()
    describe_mapped_resource_configuration(params::Dict{String,<:Any})

Returns the most current information about the stream. The streamName or streamARN should
be provided in the input.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to return in the response.
- `"NextToken"`: The token to provide in your next request, to get another batch of results.
- `"StreamARN"`: The Amazon Resource Name (ARN) of the stream.
- `"StreamName"`: The name of the stream.
"""
function describe_mapped_resource_configuration(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_video(
        "POST",
        "/describeMappedResourceConfiguration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_mapped_resource_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_video(
        "POST",
        "/describeMappedResourceConfiguration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_media_storage_configuration()
    describe_media_storage_configuration(params::Dict{String,<:Any})

Returns the most current information about the channel. Specify the ChannelName or
ChannelARN in the input.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ChannelARN"`: The Amazon Resource Name (ARN) of the channel.
- `"ChannelName"`: The name of the channel.
"""
function describe_media_storage_configuration(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_video(
        "POST",
        "/describeMediaStorageConfiguration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_media_storage_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_video(
        "POST",
        "/describeMediaStorageConfiguration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_notification_configuration()
    describe_notification_configuration(params::Dict{String,<:Any})

Gets the NotificationConfiguration for a given Kinesis video stream.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"StreamARN"`: The Amazon Resource Name (ARN) of the Kinesis video stream from where you
  want to retrieve the notification configuration. You must specify either the StreamName or
  the StreamARN.
- `"StreamName"`: The name of the stream from which to retrieve the notification
  configuration. You must specify either the StreamName or the StreamARN.
"""
function describe_notification_configuration(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_video(
        "POST",
        "/describeNotificationConfiguration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_notification_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_video(
        "POST",
        "/describeNotificationConfiguration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_signaling_channel()
    describe_signaling_channel(params::Dict{String,<:Any})

Returns the most current information about the signaling channel. You must specify either
the name or the Amazon Resource Name (ARN) of the channel that you want to describe.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ChannelARN"`: The ARN of the signaling channel that you want to describe.
- `"ChannelName"`: The name of the signaling channel that you want to describe.
"""
function describe_signaling_channel(; aws_config::AbstractAWSConfig=current_aws_config())
    return kinesis_video(
        "POST",
        "/describeSignalingChannel";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_signaling_channel(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_video(
        "POST",
        "/describeSignalingChannel",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_stream()
    describe_stream(params::Dict{String,<:Any})

Returns the most current information about the specified stream. You must specify either
the StreamName or the StreamARN.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"StreamARN"`: The Amazon Resource Name (ARN) of the stream.
- `"StreamName"`: The name of the stream.
"""
function describe_stream(; aws_config::AbstractAWSConfig=current_aws_config())
    return kinesis_video(
        "POST", "/describeStream"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_stream(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_video(
        "POST",
        "/describeStream",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_data_endpoint(apiname)
    get_data_endpoint(apiname, params::Dict{String,<:Any})

Gets an endpoint for a specified stream for either reading or writing. Use this endpoint in
your application to read from the specified stream (using the GetMedia or
GetMediaForFragmentList operations) or write to it (using the PutMedia operation).   The
returned endpoint does not have the API name appended. The client needs to add the API name
to the returned endpoint.  In the request, specify the stream either by StreamName or
StreamARN.

# Arguments
- `apiname`: The name of the API action for which to get an endpoint.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"StreamARN"`: The Amazon Resource Name (ARN) of the stream that you want to get the
  endpoint for. You must specify either this parameter or a StreamName in the request.
- `"StreamName"`: The name of the stream that you want to get the endpoint for. You must
  specify either this parameter or a StreamARN in the request.
"""
function get_data_endpoint(APIName; aws_config::AbstractAWSConfig=current_aws_config())
    return kinesis_video(
        "POST",
        "/getDataEndpoint",
        Dict{String,Any}("APIName" => APIName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_data_endpoint(
    APIName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_video(
        "POST",
        "/getDataEndpoint",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("APIName" => APIName), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_signaling_channel_endpoint(channel_arn)
    get_signaling_channel_endpoint(channel_arn, params::Dict{String,<:Any})

Provides an endpoint for the specified signaling channel to send and receive messages. This
API uses the SingleMasterChannelEndpointConfiguration input parameter, which consists of
the Protocols and Role properties.  Protocols is used to determine the communication
mechanism. For example, if you specify WSS as the protocol, this API produces a secure
websocket endpoint. If you specify HTTPS as the protocol, this API generates an HTTPS
endpoint.   Role determines the messaging permissions. A MASTER role results in this API
generating an endpoint that a client can use to communicate with any of the viewers on the
channel. A VIEWER role results in this API generating an endpoint that a client can use to
communicate only with a MASTER.

# Arguments
- `channel_arn`: The Amazon Resource Name (ARN) of the signalling channel for which you
  want to get an endpoint.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"SingleMasterChannelEndpointConfiguration"`: A structure containing the endpoint
  configuration for the SINGLE_MASTER channel type.
"""
function get_signaling_channel_endpoint(
    ChannelARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_video(
        "POST",
        "/getSignalingChannelEndpoint",
        Dict{String,Any}("ChannelARN" => ChannelARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_signaling_channel_endpoint(
    ChannelARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_video(
        "POST",
        "/getSignalingChannelEndpoint",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ChannelARN" => ChannelARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_edge_agent_configurations(hub_device_arn)
    list_edge_agent_configurations(hub_device_arn, params::Dict{String,<:Any})

Returns an array of edge configurations associated with the specified Edge Agent. In the
request, you must specify the Edge Agent HubDeviceArn.

# Arguments
- `hub_device_arn`: The \"Internet of Things (IoT) Thing\" Arn of the edge agent.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of edge configurations to return in the response. The
  default is 5.
- `"NextToken"`: If you specify this parameter, when the result of a
  ListEdgeAgentConfigurations operation is truncated, the call returns the NextToken in the
  response. To get another batch of edge configurations, provide this token in your next
  request.
"""
function list_edge_agent_configurations(
    HubDeviceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_video(
        "POST",
        "/listEdgeAgentConfigurations",
        Dict{String,Any}("HubDeviceArn" => HubDeviceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_edge_agent_configurations(
    HubDeviceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_video(
        "POST",
        "/listEdgeAgentConfigurations",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("HubDeviceArn" => HubDeviceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_signaling_channels()
    list_signaling_channels(params::Dict{String,<:Any})

Returns an array of ChannelInfo objects. Each object describes a signaling channel. To
retrieve only those channels that satisfy a specific condition, you can specify a
ChannelNameCondition.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ChannelNameCondition"`: Optional: Returns only the channels that satisfy a specific
  condition.
- `"MaxResults"`: The maximum number of channels to return in the response. The default is
  500.
- `"NextToken"`: If you specify this parameter, when the result of a ListSignalingChannels
  operation is truncated, the call returns the NextToken in the response. To get another
  batch of channels, provide this token in your next request.
"""
function list_signaling_channels(; aws_config::AbstractAWSConfig=current_aws_config())
    return kinesis_video(
        "POST",
        "/listSignalingChannels";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_signaling_channels(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_video(
        "POST",
        "/listSignalingChannels",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_streams()
    list_streams(params::Dict{String,<:Any})

Returns an array of StreamInfo objects. Each object describes a stream. To retrieve only
streams that satisfy a specific condition, you can specify a StreamNameCondition.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of streams to return in the response. The default is
  10,000.
- `"NextToken"`: If you specify this parameter, when the result of a ListStreams operation
  is truncated, the call returns the NextToken in the response. To get another batch of
  streams, provide this token in your next request.
- `"StreamNameCondition"`: Optional: Returns only streams that satisfy a specific
  condition. Currently, you can specify only the prefix of a stream name as a condition.
"""
function list_streams(; aws_config::AbstractAWSConfig=current_aws_config())
    return kinesis_video(
        "POST", "/listStreams"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_streams(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_video(
        "POST",
        "/listStreams",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Returns a list of tags associated with the specified signaling channel.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the signaling channel for which you
  want to list tags.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: If you specify this parameter and the result of a ListTagsForResource call
  is truncated, the response includes a token that you can use in the next request to fetch
  the next batch of tags.
"""
function list_tags_for_resource(
    ResourceARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_video(
        "POST",
        "/ListTagsForResource",
        Dict{String,Any}("ResourceARN" => ResourceARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_video(
        "POST",
        "/ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceARN" => ResourceARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_stream()
    list_tags_for_stream(params::Dict{String,<:Any})

Returns a list of tags associated with the specified stream. In the request, you must
specify either the StreamName or the StreamARN.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: If you specify this parameter and the result of a ListTagsForStream call
  is truncated, the response includes a token that you can use in the next request to fetch
  the next batch of tags.
- `"StreamARN"`: The Amazon Resource Name (ARN) of the stream that you want to list tags
  for.
- `"StreamName"`: The name of the stream that you want to list tags for.
"""
function list_tags_for_stream(; aws_config::AbstractAWSConfig=current_aws_config())
    return kinesis_video(
        "POST", "/listTagsForStream"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_tags_for_stream(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_video(
        "POST",
        "/listTagsForStream",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_edge_configuration_update(edge_config)
    start_edge_configuration_update(edge_config, params::Dict{String,<:Any})

An asynchronous API that updates a stream’s existing edge configuration. The Kinesis
Video Stream will sync the stream’s edge configuration with the Edge Agent IoT Greengrass
component that runs on an IoT Hub Device, setup at your premise. The time to sync can vary
and depends on the connectivity of the Hub Device. The SyncStatus will be updated as the
edge configuration is acknowledged, and synced with the Edge Agent.  If this API is invoked
for the first time, a new edge configuration will be created for the stream, and the sync
status will be set to SYNCING. You will have to wait for the sync status to reach a
terminal state such as: IN_SYNC, or SYNC_FAILED, before using this API again. If you invoke
this API during the syncing process, a ResourceInUseException will be thrown. The
connectivity of the stream’s edge configuration and the Edge Agent will be retried for 15
minutes. After 15 minutes, the status will transition into the SYNC_FAILED state. To move
an edge configuration from one device to another, use DeleteEdgeConfiguration to delete the
current edge configuration. You can then invoke StartEdgeConfigurationUpdate with an
updated Hub Device ARN.

# Arguments
- `edge_config`: The edge configuration details required to invoke the update process.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"StreamARN"`:  The Amazon Resource Name (ARN) of the stream. Specify either the
  StreamName or the StreamARN.
- `"StreamName"`: The name of the stream whose edge configuration you want to update.
  Specify either the StreamName or the StreamARN.
"""
function start_edge_configuration_update(
    EdgeConfig; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_video(
        "POST",
        "/startEdgeConfigurationUpdate",
        Dict{String,Any}("EdgeConfig" => EdgeConfig);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_edge_configuration_update(
    EdgeConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_video(
        "POST",
        "/startEdgeConfigurationUpdate",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("EdgeConfig" => EdgeConfig), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds one or more tags to a signaling channel. A tag is a key-value pair (the value is
optional) that you can define and assign to Amazon Web Services resources. If you specify a
tag that already exists, the tag value is replaced with the value that you specify in the
request. For more information, see Using Cost Allocation Tags in the Billing and Cost
Management and Cost Management User Guide.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the signaling channel to which you want
  to add tags.
- `tags`: A list of tags to associate with the specified signaling channel. Each tag is a
  key-value pair.

"""
function tag_resource(ResourceARN, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return kinesis_video(
        "POST",
        "/TagResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceARN,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_video(
        "POST",
        "/TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_stream(tags)
    tag_stream(tags, params::Dict{String,<:Any})

Adds one or more tags to a stream. A tag is a key-value pair (the value is optional) that
you can define and assign to Amazon Web Services resources. If you specify a tag that
already exists, the tag value is replaced with the value that you specify in the request.
For more information, see Using Cost Allocation Tags in the Billing and Cost Management and
Cost Management User Guide.  You must provide either the StreamName or the StreamARN. This
operation requires permission for the KinesisVideo:TagStream action. A Kinesis video stream
can support up to 50 tags.

# Arguments
- `tags`: A list of tags to associate with the specified stream. Each tag is a key-value
  pair (the value is optional).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"StreamARN"`: The Amazon Resource Name (ARN) of the resource that you want to add the
  tag or tags to.
- `"StreamName"`: The name of the stream that you want to add the tag or tags to.
"""
function tag_stream(Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return kinesis_video(
        "POST",
        "/tagStream",
        Dict{String,Any}("Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_stream(
    Tags, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_video(
        "POST",
        "/tagStream",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Tags" => Tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_key_list)
    untag_resource(resource_arn, tag_key_list, params::Dict{String,<:Any})

Removes one or more tags from a signaling channel. In the request, specify only a tag key
or keys; don't specify the value. If you specify a tag key that does not exist, it's
ignored.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the signaling channel from which you
  want to remove tags.
- `tag_key_list`: A list of the keys of the tags that you want to remove.

"""
function untag_resource(
    ResourceARN, TagKeyList; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_video(
        "POST",
        "/UntagResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeyList" => TagKeyList);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceARN,
    TagKeyList,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_video(
        "POST",
        "/UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeyList" => TagKeyList),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_stream(tag_key_list)
    untag_stream(tag_key_list, params::Dict{String,<:Any})

Removes one or more tags from a stream. In the request, specify only a tag key or keys;
don't specify the value. If you specify a tag key that does not exist, it's ignored. In the
request, you must provide the StreamName or StreamARN.

# Arguments
- `tag_key_list`: A list of the keys of the tags that you want to remove.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"StreamARN"`: The Amazon Resource Name (ARN) of the stream that you want to remove tags
  from.
- `"StreamName"`: The name of the stream that you want to remove tags from.
"""
function untag_stream(TagKeyList; aws_config::AbstractAWSConfig=current_aws_config())
    return kinesis_video(
        "POST",
        "/untagStream",
        Dict{String,Any}("TagKeyList" => TagKeyList);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_stream(
    TagKeyList,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_video(
        "POST",
        "/untagStream",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TagKeyList" => TagKeyList), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_data_retention(current_version, data_retention_change_in_hours, operation)
    update_data_retention(current_version, data_retention_change_in_hours, operation, params::Dict{String,<:Any})

Increases or decreases the stream's data retention period by the value that you specify. To
indicate whether you want to increase or decrease the data retention period, specify the
Operation parameter in the request body. In the request, you must specify either the
StreamName or the StreamARN.  This operation requires permission for the
KinesisVideo:UpdateDataRetention action. Changing the data retention period affects the
data in the stream as follows:   If the data retention period is increased, existing data
is retained for the new retention period. For example, if the data retention period is
increased from one hour to seven hours, all existing data is retained for seven hours.   If
the data retention period is decreased, existing data is retained for the new retention
period. For example, if the data retention period is decreased from seven hours to one
hour, all existing data is retained for one hour, and any data older than one hour is
deleted immediately.

# Arguments
- `current_version`: The version of the stream whose retention period you want to change.
  To get the version, call either the DescribeStream or the ListStreams API.
- `data_retention_change_in_hours`: The number of hours to adjust the current retention by.
  The value you specify is added to or subtracted from the current value, depending on the
  operation. The minimum value for data retention is 0 and the maximum value is 87600 (ten
  years).
- `operation`: Indicates whether you want to increase or decrease the retention period.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"StreamARN"`: The Amazon Resource Name (ARN) of the stream whose retention period you
  want to change.
- `"StreamName"`: The name of the stream whose retention period you want to change.
"""
function update_data_retention(
    CurrentVersion,
    DataRetentionChangeInHours,
    Operation;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_video(
        "POST",
        "/updateDataRetention",
        Dict{String,Any}(
            "CurrentVersion" => CurrentVersion,
            "DataRetentionChangeInHours" => DataRetentionChangeInHours,
            "Operation" => Operation,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_data_retention(
    CurrentVersion,
    DataRetentionChangeInHours,
    Operation,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_video(
        "POST",
        "/updateDataRetention",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CurrentVersion" => CurrentVersion,
                    "DataRetentionChangeInHours" => DataRetentionChangeInHours,
                    "Operation" => Operation,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_image_generation_configuration()
    update_image_generation_configuration(params::Dict{String,<:Any})

Updates the StreamInfo and ImageProcessingConfiguration fields.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ImageGenerationConfiguration"`: The structure that contains the information required
  for the KVS images delivery. If the structure is null, the configuration will be deleted
  from the stream.
- `"StreamARN"`: The Amazon Resource Name (ARN) of the Kinesis video stream from where you
  want to update the image generation configuration. You must specify either the StreamName
  or the StreamARN.
- `"StreamName"`: The name of the stream from which to update the image generation
  configuration. You must specify either the StreamName or the StreamARN.
"""
function update_image_generation_configuration(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_video(
        "POST",
        "/updateImageGenerationConfiguration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_image_generation_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_video(
        "POST",
        "/updateImageGenerationConfiguration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_media_storage_configuration(channel_arn, media_storage_configuration)
    update_media_storage_configuration(channel_arn, media_storage_configuration, params::Dict{String,<:Any})

Associates a SignalingChannel to a stream to store the media. There are two signaling modes
that you can specify :   If StorageStatus is enabled, the data will be stored in the
StreamARN provided. In order for WebRTC Ingestion to work, the stream must have data
retention enabled.   If StorageStatus is disabled, no data will be stored, and the
StreamARN parameter will not be needed.     If StorageStatus is enabled, direct
peer-to-peer (master-viewer) connections no longer occur. Peers connect directly to the
storage session. You must call the JoinStorageSession API to trigger an SDP offer send and
establish a connection between a peer and the storage session.

# Arguments
- `channel_arn`: The Amazon Resource Name (ARN) of the channel.
- `media_storage_configuration`: A structure that encapsulates, or contains, the media
  storage configuration properties.

"""
function update_media_storage_configuration(
    ChannelARN,
    MediaStorageConfiguration;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_video(
        "POST",
        "/updateMediaStorageConfiguration",
        Dict{String,Any}(
            "ChannelARN" => ChannelARN,
            "MediaStorageConfiguration" => MediaStorageConfiguration,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_media_storage_configuration(
    ChannelARN,
    MediaStorageConfiguration,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_video(
        "POST",
        "/updateMediaStorageConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ChannelARN" => ChannelARN,
                    "MediaStorageConfiguration" => MediaStorageConfiguration,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_notification_configuration()
    update_notification_configuration(params::Dict{String,<:Any})

Updates the notification information for a stream.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NotificationConfiguration"`: The structure containing the information required for
  notifications. If the structure is null, the configuration will be deleted from the stream.
- `"StreamARN"`: The Amazon Resource Name (ARN) of the Kinesis video stream from where you
  want to update the notification configuration. You must specify either the StreamName or
  the StreamARN.
- `"StreamName"`: The name of the stream from which to update the notification
  configuration. You must specify either the StreamName or the StreamARN.
"""
function update_notification_configuration(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_video(
        "POST",
        "/updateNotificationConfiguration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_notification_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_video(
        "POST",
        "/updateNotificationConfiguration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_signaling_channel(channel_arn, current_version)
    update_signaling_channel(channel_arn, current_version, params::Dict{String,<:Any})

Updates the existing signaling channel. This is an asynchronous operation and takes time to
complete.  If the MessageTtlSeconds value is updated (either increased or reduced), it only
applies to new messages sent via this channel after it's been updated. Existing messages
are still expired as per the previous MessageTtlSeconds value.

# Arguments
- `channel_arn`: The Amazon Resource Name (ARN) of the signaling channel that you want to
  update.
- `current_version`: The current version of the signaling channel that you want to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"SingleMasterConfiguration"`: The structure containing the configuration for the
  SINGLE_MASTER type of the signaling channel that you want to update.
"""
function update_signaling_channel(
    ChannelARN, CurrentVersion; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_video(
        "POST",
        "/updateSignalingChannel",
        Dict{String,Any}("ChannelARN" => ChannelARN, "CurrentVersion" => CurrentVersion);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_signaling_channel(
    ChannelARN,
    CurrentVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_video(
        "POST",
        "/updateSignalingChannel",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ChannelARN" => ChannelARN, "CurrentVersion" => CurrentVersion
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_stream(current_version)
    update_stream(current_version, params::Dict{String,<:Any})

Updates stream metadata, such as the device name and media type. You must provide the
stream name or the Amazon Resource Name (ARN) of the stream. To make sure that you have the
latest version of the stream before updating it, you can specify the stream version.
Kinesis Video Streams assigns a version to each stream. When you update a stream, Kinesis
Video Streams assigns a new version number. To get the latest stream version, use the
DescribeStream API.   UpdateStream is an asynchronous operation, and takes time to complete.

# Arguments
- `current_version`: The version of the stream whose metadata you want to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DeviceName"`: The name of the device that is writing to the stream.    In the current
  implementation, Kinesis Video Streams does not use this name.
- `"MediaType"`: The stream's media type. Use MediaType to specify the type of content that
  the stream contains to the consumers of the stream. For more information about media types,
  see Media Types. If you choose to specify the MediaType, see Naming Requirements. To play
  video on the console, you must specify the correct video type. For example, if the video in
  the stream is H.264, specify video/h264 as the MediaType.
- `"StreamARN"`: The ARN of the stream whose metadata you want to update.
- `"StreamName"`: The name of the stream whose metadata you want to update. The stream name
  is an identifier for the stream, and must be unique for each account and region.
"""
function update_stream(CurrentVersion; aws_config::AbstractAWSConfig=current_aws_config())
    return kinesis_video(
        "POST",
        "/updateStream",
        Dict{String,Any}("CurrentVersion" => CurrentVersion);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_stream(
    CurrentVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_video(
        "POST",
        "/updateStream",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("CurrentVersion" => CurrentVersion), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: mediatailor
using AWS.Compat
using AWS.UUIDs

"""
    configure_logs_for_channel(channel_name, log_types)
    configure_logs_for_channel(channel_name, log_types, params::Dict{String,<:Any})

Configures Amazon CloudWatch log settings for a channel.

# Arguments
- `channel_name`: The name of the channel.
- `log_types`: The types of logs to collect.

"""
function configure_logs_for_channel(
    ChannelName, LogTypes; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediatailor(
        "PUT",
        "/configureLogs/channel",
        Dict{String,Any}("ChannelName" => ChannelName, "LogTypes" => LogTypes);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function configure_logs_for_channel(
    ChannelName,
    LogTypes,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediatailor(
        "PUT",
        "/configureLogs/channel",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ChannelName" => ChannelName, "LogTypes" => LogTypes),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    configure_logs_for_playback_configuration(percent_enabled, playback_configuration_name)
    configure_logs_for_playback_configuration(percent_enabled, playback_configuration_name, params::Dict{String,<:Any})

Amazon CloudWatch log settings for a playback configuration.

# Arguments
- `percent_enabled`: The percentage of session logs that MediaTailor sends to your
  Cloudwatch Logs account. For example, if your playback configuration has 1000 sessions and
  percentEnabled is set to 60, MediaTailor sends logs for 600 of the sessions to CloudWatch
  Logs. MediaTailor decides at random which of the playback configuration sessions to send
  logs for. If you want to view logs for a specific session, you can use the debug log mode.
  Valid values: 0 - 100
- `playback_configuration_name`: The name of the playback configuration.

"""
function configure_logs_for_playback_configuration(
    PercentEnabled,
    PlaybackConfigurationName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediatailor(
        "PUT",
        "/configureLogs/playbackConfiguration",
        Dict{String,Any}(
            "PercentEnabled" => PercentEnabled,
            "PlaybackConfigurationName" => PlaybackConfigurationName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function configure_logs_for_playback_configuration(
    PercentEnabled,
    PlaybackConfigurationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediatailor(
        "PUT",
        "/configureLogs/playbackConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "PercentEnabled" => PercentEnabled,
                    "PlaybackConfigurationName" => PlaybackConfigurationName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_channel(channel_name, outputs, playback_mode)
    create_channel(channel_name, outputs, playback_mode, params::Dict{String,<:Any})

Creates a channel. For information about MediaTailor channels, see Working with channels in
the MediaTailor User Guide.

# Arguments
- `channel_name`: The name of the channel.
- `outputs`: The channel's output properties.
- `playback_mode`: The type of playback mode to use for this channel.  LINEAR - The
  programs in the schedule play once back-to-back in the schedule.  LOOP - The programs in
  the schedule play back-to-back in an endless loop. When the last program in the schedule
  stops playing, playback loops back to the first program in the schedule.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Audiences"`: The list of audiences defined in channel.
- `"FillerSlate"`: The slate used to fill gaps between programs in the schedule. You must
  configure filler slate if your channel uses the LINEAR PlaybackMode. MediaTailor doesn't
  support filler slate for channels using the LOOP PlaybackMode.
- `"Tier"`: The tier of the channel.
- `"TimeShiftConfiguration"`:  The time-shifted viewing configuration you want to associate
  to the channel.
- `"tags"`: The tags to assign to the channel. Tags are key-value pairs that you can
  associate with Amazon resources to help with organization, access control, and cost
  tracking. For more information, see Tagging AWS Elemental MediaTailor Resources.
"""
function create_channel(
    ChannelName, Outputs, PlaybackMode; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediatailor(
        "POST",
        "/channel/$(ChannelName)",
        Dict{String,Any}("Outputs" => Outputs, "PlaybackMode" => PlaybackMode);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_channel(
    ChannelName,
    Outputs,
    PlaybackMode,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediatailor(
        "POST",
        "/channel/$(ChannelName)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Outputs" => Outputs, "PlaybackMode" => PlaybackMode),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_live_source(http_package_configurations, live_source_name, source_location_name)
    create_live_source(http_package_configurations, live_source_name, source_location_name, params::Dict{String,<:Any})

The live source configuration.

# Arguments
- `http_package_configurations`: A list of HTTP package configuration parameters for this
  live source.
- `live_source_name`: The name of the live source.
- `source_location_name`: The name of the source location.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tags"`: The tags to assign to the live source. Tags are key-value pairs that you can
  associate with Amazon resources to help with organization, access control, and cost
  tracking. For more information, see Tagging AWS Elemental MediaTailor Resources.
"""
function create_live_source(
    HttpPackageConfigurations,
    LiveSourceName,
    SourceLocationName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediatailor(
        "POST",
        "/sourceLocation/$(SourceLocationName)/liveSource/$(LiveSourceName)",
        Dict{String,Any}("HttpPackageConfigurations" => HttpPackageConfigurations);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_live_source(
    HttpPackageConfigurations,
    LiveSourceName,
    SourceLocationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediatailor(
        "POST",
        "/sourceLocation/$(SourceLocationName)/liveSource/$(LiveSourceName)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("HttpPackageConfigurations" => HttpPackageConfigurations),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_prefetch_schedule(consumption, name, playback_configuration_name, retrieval)
    create_prefetch_schedule(consumption, name, playback_configuration_name, retrieval, params::Dict{String,<:Any})

Creates a prefetch schedule for a playback configuration. A prefetch schedule allows you to
tell MediaTailor to fetch and prepare certain ads before an ad break happens. For more
information about ad prefetching, see Using ad prefetching in the MediaTailor User Guide.

# Arguments
- `consumption`: The configuration settings for MediaTailor's consumption of the prefetched
  ads from the ad decision server. Each consumption configuration contains an end time and an
  optional start time that define the consumption window. Prefetch schedules automatically
  expire no earlier than seven days after the end time.
- `name`: The name to assign to the schedule request.
- `playback_configuration_name`: The name to assign to the playback configuration.
- `retrieval`: The configuration settings for retrieval of prefetched ads from the ad
  decision server. Only one set of prefetched ads will be retrieved and subsequently consumed
  for each ad break.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"StreamId"`: An optional stream identifier that MediaTailor uses to prefetch ads for
  multiple streams that use the same playback configuration. If StreamId is specified,
  MediaTailor returns all of the prefetch schedules with an exact match on StreamId. If not
  specified, MediaTailor returns all of the prefetch schedules for the playback
  configuration, regardless of StreamId.
"""
function create_prefetch_schedule(
    Consumption,
    Name,
    PlaybackConfigurationName,
    Retrieval;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediatailor(
        "POST",
        "/prefetchSchedule/$(PlaybackConfigurationName)/$(Name)",
        Dict{String,Any}("Consumption" => Consumption, "Retrieval" => Retrieval);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_prefetch_schedule(
    Consumption,
    Name,
    PlaybackConfigurationName,
    Retrieval,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediatailor(
        "POST",
        "/prefetchSchedule/$(PlaybackConfigurationName)/$(Name)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Consumption" => Consumption, "Retrieval" => Retrieval),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_program(channel_name, program_name, schedule_configuration, source_location_name)
    create_program(channel_name, program_name, schedule_configuration, source_location_name, params::Dict{String,<:Any})

Creates a program within a channel. For information about programs, see Working with
programs in the MediaTailor User Guide.

# Arguments
- `channel_name`: The name of the channel for this Program.
- `program_name`: The name of the Program.
- `schedule_configuration`: The schedule configuration settings.
- `source_location_name`: The name of the source location.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AdBreaks"`: The ad break configuration settings.
- `"AudienceMedia"`: The list of AudienceMedia defined in program.
- `"LiveSourceName"`: The name of the LiveSource for this Program.
- `"VodSourceName"`: The name that's used to refer to a VOD source.
"""
function create_program(
    ChannelName,
    ProgramName,
    ScheduleConfiguration,
    SourceLocationName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediatailor(
        "POST",
        "/channel/$(ChannelName)/program/$(ProgramName)",
        Dict{String,Any}(
            "ScheduleConfiguration" => ScheduleConfiguration,
            "SourceLocationName" => SourceLocationName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_program(
    ChannelName,
    ProgramName,
    ScheduleConfiguration,
    SourceLocationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediatailor(
        "POST",
        "/channel/$(ChannelName)/program/$(ProgramName)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ScheduleConfiguration" => ScheduleConfiguration,
                    "SourceLocationName" => SourceLocationName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_source_location(http_configuration, source_location_name)
    create_source_location(http_configuration, source_location_name, params::Dict{String,<:Any})

Creates a source location. A source location is a container for sources. For more
information about source locations, see Working with source locations in the MediaTailor
User Guide.

# Arguments
- `http_configuration`: The source's HTTP package configurations.
- `source_location_name`: The name associated with the source location.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccessConfiguration"`: Access configuration parameters. Configures the type of
  authentication used to access content from your source location.
- `"DefaultSegmentDeliveryConfiguration"`: The optional configuration for the server that
  serves segments.
- `"SegmentDeliveryConfigurations"`: A list of the segment delivery configurations
  associated with this resource.
- `"tags"`: The tags to assign to the source location. Tags are key-value pairs that you
  can associate with Amazon resources to help with organization, access control, and cost
  tracking. For more information, see Tagging AWS Elemental MediaTailor Resources.
"""
function create_source_location(
    HttpConfiguration,
    SourceLocationName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediatailor(
        "POST",
        "/sourceLocation/$(SourceLocationName)",
        Dict{String,Any}("HttpConfiguration" => HttpConfiguration);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_source_location(
    HttpConfiguration,
    SourceLocationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediatailor(
        "POST",
        "/sourceLocation/$(SourceLocationName)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("HttpConfiguration" => HttpConfiguration), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_vod_source(http_package_configurations, source_location_name, vod_source_name)
    create_vod_source(http_package_configurations, source_location_name, vod_source_name, params::Dict{String,<:Any})

The VOD source configuration parameters.

# Arguments
- `http_package_configurations`: A list of HTTP package configuration parameters for this
  VOD source.
- `source_location_name`: The name of the source location for this VOD source.
- `vod_source_name`: The name associated with the VOD source.&gt;

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tags"`: The tags to assign to the VOD source. Tags are key-value pairs that you can
  associate with Amazon resources to help with organization, access control, and cost
  tracking. For more information, see Tagging AWS Elemental MediaTailor Resources.
"""
function create_vod_source(
    HttpPackageConfigurations,
    SourceLocationName,
    VodSourceName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediatailor(
        "POST",
        "/sourceLocation/$(SourceLocationName)/vodSource/$(VodSourceName)",
        Dict{String,Any}("HttpPackageConfigurations" => HttpPackageConfigurations);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_vod_source(
    HttpPackageConfigurations,
    SourceLocationName,
    VodSourceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediatailor(
        "POST",
        "/sourceLocation/$(SourceLocationName)/vodSource/$(VodSourceName)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("HttpPackageConfigurations" => HttpPackageConfigurations),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_channel(channel_name)
    delete_channel(channel_name, params::Dict{String,<:Any})

Deletes a channel. For information about MediaTailor channels, see Working with channels in
the MediaTailor User Guide.

# Arguments
- `channel_name`: The name of the channel.

"""
function delete_channel(ChannelName; aws_config::AbstractAWSConfig=current_aws_config())
    return mediatailor(
        "DELETE",
        "/channel/$(ChannelName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_channel(
    ChannelName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediatailor(
        "DELETE",
        "/channel/$(ChannelName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_channel_policy(channel_name)
    delete_channel_policy(channel_name, params::Dict{String,<:Any})

The channel policy to delete.

# Arguments
- `channel_name`: The name of the channel associated with this channel policy.

"""
function delete_channel_policy(
    ChannelName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediatailor(
        "DELETE",
        "/channel/$(ChannelName)/policy";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_channel_policy(
    ChannelName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediatailor(
        "DELETE",
        "/channel/$(ChannelName)/policy",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_live_source(live_source_name, source_location_name)
    delete_live_source(live_source_name, source_location_name, params::Dict{String,<:Any})

The live source to delete.

# Arguments
- `live_source_name`: The name of the live source.
- `source_location_name`: The name of the source location associated with this Live Source.

"""
function delete_live_source(
    LiveSourceName, SourceLocationName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediatailor(
        "DELETE",
        "/sourceLocation/$(SourceLocationName)/liveSource/$(LiveSourceName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_live_source(
    LiveSourceName,
    SourceLocationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediatailor(
        "DELETE",
        "/sourceLocation/$(SourceLocationName)/liveSource/$(LiveSourceName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_playback_configuration(name)
    delete_playback_configuration(name, params::Dict{String,<:Any})

Deletes a playback configuration. For information about MediaTailor configurations, see
Working with configurations in AWS Elemental MediaTailor.

# Arguments
- `name`: The name of the playback configuration.

"""
function delete_playback_configuration(
    Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediatailor(
        "DELETE",
        "/playbackConfiguration/$(Name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_playback_configuration(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediatailor(
        "DELETE",
        "/playbackConfiguration/$(Name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_prefetch_schedule(name, playback_configuration_name)
    delete_prefetch_schedule(name, playback_configuration_name, params::Dict{String,<:Any})

Deletes a prefetch schedule for a specific playback configuration. If you call
DeletePrefetchSchedule on an expired prefetch schedule, MediaTailor returns an HTTP 404
status code. For more information about ad prefetching, see Using ad prefetching in the
MediaTailor User Guide.

# Arguments
- `name`: The name of the prefetch schedule. If the action is successful, the service sends
  back an HTTP 204 response with an empty HTTP body.
- `playback_configuration_name`: The name of the playback configuration for this prefetch
  schedule.

"""
function delete_prefetch_schedule(
    Name, PlaybackConfigurationName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediatailor(
        "DELETE",
        "/prefetchSchedule/$(PlaybackConfigurationName)/$(Name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_prefetch_schedule(
    Name,
    PlaybackConfigurationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediatailor(
        "DELETE",
        "/prefetchSchedule/$(PlaybackConfigurationName)/$(Name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_program(channel_name, program_name)
    delete_program(channel_name, program_name, params::Dict{String,<:Any})

Deletes a program within a channel. For information about programs, see Working with
programs in the MediaTailor User Guide.

# Arguments
- `channel_name`: The name of the channel.
- `program_name`: The name of the program.

"""
function delete_program(
    ChannelName, ProgramName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediatailor(
        "DELETE",
        "/channel/$(ChannelName)/program/$(ProgramName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_program(
    ChannelName,
    ProgramName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediatailor(
        "DELETE",
        "/channel/$(ChannelName)/program/$(ProgramName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_source_location(source_location_name)
    delete_source_location(source_location_name, params::Dict{String,<:Any})

Deletes a source location. A source location is a container for sources. For more
information about source locations, see Working with source locations in the MediaTailor
User Guide.

# Arguments
- `source_location_name`: The name of the source location.

"""
function delete_source_location(
    SourceLocationName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediatailor(
        "DELETE",
        "/sourceLocation/$(SourceLocationName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_source_location(
    SourceLocationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediatailor(
        "DELETE",
        "/sourceLocation/$(SourceLocationName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_vod_source(source_location_name, vod_source_name)
    delete_vod_source(source_location_name, vod_source_name, params::Dict{String,<:Any})

The video on demand (VOD) source to delete.

# Arguments
- `source_location_name`: The name of the source location associated with this VOD Source.
- `vod_source_name`: The name of the VOD source.

"""
function delete_vod_source(
    SourceLocationName, VodSourceName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediatailor(
        "DELETE",
        "/sourceLocation/$(SourceLocationName)/vodSource/$(VodSourceName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_vod_source(
    SourceLocationName,
    VodSourceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediatailor(
        "DELETE",
        "/sourceLocation/$(SourceLocationName)/vodSource/$(VodSourceName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_channel(channel_name)
    describe_channel(channel_name, params::Dict{String,<:Any})

Describes a channel. For information about MediaTailor channels, see Working with channels
in the MediaTailor User Guide.

# Arguments
- `channel_name`: The name of the channel.

"""
function describe_channel(ChannelName; aws_config::AbstractAWSConfig=current_aws_config())
    return mediatailor(
        "GET",
        "/channel/$(ChannelName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_channel(
    ChannelName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediatailor(
        "GET",
        "/channel/$(ChannelName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_live_source(live_source_name, source_location_name)
    describe_live_source(live_source_name, source_location_name, params::Dict{String,<:Any})

The live source to describe.

# Arguments
- `live_source_name`: The name of the live source.
- `source_location_name`: The name of the source location associated with this Live Source.

"""
function describe_live_source(
    LiveSourceName, SourceLocationName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediatailor(
        "GET",
        "/sourceLocation/$(SourceLocationName)/liveSource/$(LiveSourceName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_live_source(
    LiveSourceName,
    SourceLocationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediatailor(
        "GET",
        "/sourceLocation/$(SourceLocationName)/liveSource/$(LiveSourceName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_program(channel_name, program_name)
    describe_program(channel_name, program_name, params::Dict{String,<:Any})

Describes a program within a channel. For information about programs, see Working with
programs in the MediaTailor User Guide.

# Arguments
- `channel_name`: The name of the channel associated with this Program.
- `program_name`: The name of the program.

"""
function describe_program(
    ChannelName, ProgramName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediatailor(
        "GET",
        "/channel/$(ChannelName)/program/$(ProgramName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_program(
    ChannelName,
    ProgramName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediatailor(
        "GET",
        "/channel/$(ChannelName)/program/$(ProgramName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_source_location(source_location_name)
    describe_source_location(source_location_name, params::Dict{String,<:Any})

Describes a source location. A source location is a container for sources. For more
information about source locations, see Working with source locations in the MediaTailor
User Guide.

# Arguments
- `source_location_name`: The name of the source location.

"""
function describe_source_location(
    SourceLocationName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediatailor(
        "GET",
        "/sourceLocation/$(SourceLocationName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_source_location(
    SourceLocationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediatailor(
        "GET",
        "/sourceLocation/$(SourceLocationName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_vod_source(source_location_name, vod_source_name)
    describe_vod_source(source_location_name, vod_source_name, params::Dict{String,<:Any})

Provides details about a specific video on demand (VOD) source in a specific source
location.

# Arguments
- `source_location_name`: The name of the source location associated with this VOD Source.
- `vod_source_name`: The name of the VOD Source.

"""
function describe_vod_source(
    SourceLocationName, VodSourceName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediatailor(
        "GET",
        "/sourceLocation/$(SourceLocationName)/vodSource/$(VodSourceName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_vod_source(
    SourceLocationName,
    VodSourceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediatailor(
        "GET",
        "/sourceLocation/$(SourceLocationName)/vodSource/$(VodSourceName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_channel_policy(channel_name)
    get_channel_policy(channel_name, params::Dict{String,<:Any})

Returns the channel's IAM policy. IAM policies are used to control access to your channel.

# Arguments
- `channel_name`: The name of the channel associated with this Channel Policy.

"""
function get_channel_policy(ChannelName; aws_config::AbstractAWSConfig=current_aws_config())
    return mediatailor(
        "GET",
        "/channel/$(ChannelName)/policy";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_channel_policy(
    ChannelName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediatailor(
        "GET",
        "/channel/$(ChannelName)/policy",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_channel_schedule(channel_name)
    get_channel_schedule(channel_name, params::Dict{String,<:Any})

Retrieves information about your channel's schedule.

# Arguments
- `channel_name`: The name of the channel associated with this Channel Schedule.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"audience"`: The single audience for GetChannelScheduleRequest.
- `"durationMinutes"`: The duration in minutes of the channel schedule.
- `"maxResults"`: The maximum number of channel schedules that you want MediaTailor to
  return in response to the current request. If there are more than MaxResults channel
  schedules, use the value of NextToken in the response to get the next page of results.
- `"nextToken"`: (Optional) If the playback configuration has more than MaxResults channel
  schedules, use NextToken to get the second and subsequent pages of results. For the first
  GetChannelScheduleRequest request, omit this value. For the second and subsequent requests,
  get the value of NextToken from the previous response and specify that value for NextToken
  in the request. If the previous response didn't include a NextToken element, there are no
  more channel schedules to get.
"""
function get_channel_schedule(
    ChannelName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediatailor(
        "GET",
        "/channel/$(ChannelName)/schedule";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_channel_schedule(
    ChannelName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediatailor(
        "GET",
        "/channel/$(ChannelName)/schedule",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_playback_configuration(name)
    get_playback_configuration(name, params::Dict{String,<:Any})

Retrieves a playback configuration. For information about MediaTailor configurations, see
Working with configurations in AWS Elemental MediaTailor.

# Arguments
- `name`: The identifier for the playback configuration.

"""
function get_playback_configuration(
    Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediatailor(
        "GET",
        "/playbackConfiguration/$(Name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_playback_configuration(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediatailor(
        "GET",
        "/playbackConfiguration/$(Name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_prefetch_schedule(name, playback_configuration_name)
    get_prefetch_schedule(name, playback_configuration_name, params::Dict{String,<:Any})

Retrieves a prefetch schedule for a playback configuration. A prefetch schedule allows you
to tell MediaTailor to fetch and prepare certain ads before an ad break happens. For more
information about ad prefetching, see Using ad prefetching in the MediaTailor User Guide.

# Arguments
- `name`: The name of the prefetch schedule. The name must be unique among all prefetch
  schedules that are associated with the specified playback configuration.
- `playback_configuration_name`: Returns information about the prefetch schedule for a
  specific playback configuration. If you call GetPrefetchSchedule on an expired prefetch
  schedule, MediaTailor returns an HTTP 404 status code.

"""
function get_prefetch_schedule(
    Name, PlaybackConfigurationName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediatailor(
        "GET",
        "/prefetchSchedule/$(PlaybackConfigurationName)/$(Name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_prefetch_schedule(
    Name,
    PlaybackConfigurationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediatailor(
        "GET",
        "/prefetchSchedule/$(PlaybackConfigurationName)/$(Name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_alerts(resource_arn)
    list_alerts(resource_arn, params::Dict{String,<:Any})

Lists the alerts that are associated with a MediaTailor channel assembly resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of alerts that you want MediaTailor to return in
  response to the current request. If there are more than MaxResults alerts, use the value of
  NextToken in the response to get the next page of results.
- `"nextToken"`: Pagination token returned by the list request when results exceed the
  maximum allowed. Use the token to fetch the next page of results.
"""
function list_alerts(resourceArn; aws_config::AbstractAWSConfig=current_aws_config())
    return mediatailor(
        "GET",
        "/alerts",
        Dict{String,Any}("resourceArn" => resourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_alerts(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediatailor(
        "GET",
        "/alerts",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceArn" => resourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_channels()
    list_channels(params::Dict{String,<:Any})

Retrieves information about the channels that are associated with the current AWS account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of channels that you want MediaTailor to return in
  response to the current request. If there are more than MaxResults channels, use the value
  of NextToken in the response to get the next page of results.
- `"nextToken"`: Pagination token returned by the list request when results exceed the
  maximum allowed. Use the token to fetch the next page of results.
"""
function list_channels(; aws_config::AbstractAWSConfig=current_aws_config())
    return mediatailor(
        "GET", "/channels"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_channels(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediatailor(
        "GET", "/channels", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_live_sources(source_location_name)
    list_live_sources(source_location_name, params::Dict{String,<:Any})

Lists the live sources contained in a source location. A source represents a piece of
content.

# Arguments
- `source_location_name`: The name of the source location associated with this Live Sources
  list.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of live sources that you want MediaTailor to return in
  response to the current request. If there are more than MaxResults live sources, use the
  value of NextToken in the response to get the next page of results.
- `"nextToken"`: Pagination token returned by the list request when results exceed the
  maximum allowed. Use the token to fetch the next page of results.
"""
function list_live_sources(
    SourceLocationName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediatailor(
        "GET",
        "/sourceLocation/$(SourceLocationName)/liveSources";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_live_sources(
    SourceLocationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediatailor(
        "GET",
        "/sourceLocation/$(SourceLocationName)/liveSources",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_playback_configurations()
    list_playback_configurations(params::Dict{String,<:Any})

Retrieves existing playback configurations. For information about MediaTailor
configurations, see Working with Configurations in AWS Elemental MediaTailor.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of playback configurations that you want MediaTailor
  to return in response to the current request. If there are more than MaxResults playback
  configurations, use the value of NextToken in the response to get the next page of results.
- `"NextToken"`: Pagination token returned by the list request when results exceed the
  maximum allowed. Use the token to fetch the next page of results.
"""
function list_playback_configurations(; aws_config::AbstractAWSConfig=current_aws_config())
    return mediatailor(
        "GET",
        "/playbackConfigurations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_playback_configurations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediatailor(
        "GET",
        "/playbackConfigurations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_prefetch_schedules(playback_configuration_name)
    list_prefetch_schedules(playback_configuration_name, params::Dict{String,<:Any})

Lists the prefetch schedules for a playback configuration.

# Arguments
- `playback_configuration_name`: Retrieves the prefetch schedule(s) for a specific playback
  configuration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of prefetch schedules that you want MediaTailor to
  return in response to the current request. If there are more than MaxResults prefetch
  schedules, use the value of NextToken in the response to get the next page of results.
- `"NextToken"`: (Optional) If the playback configuration has more than MaxResults prefetch
  schedules, use NextToken to get the second and subsequent pages of results.  For the first
  ListPrefetchSchedulesRequest request, omit this value.  For the second and subsequent
  requests, get the value of NextToken from the previous response and specify that value for
  NextToken in the request.  If the previous response didn't include a NextToken element,
  there are no more prefetch schedules to get.
- `"StreamId"`: An optional filtering parameter whereby MediaTailor filters the prefetch
  schedules to include only specific streams.
"""
function list_prefetch_schedules(
    PlaybackConfigurationName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediatailor(
        "POST",
        "/prefetchSchedule/$(PlaybackConfigurationName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_prefetch_schedules(
    PlaybackConfigurationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediatailor(
        "POST",
        "/prefetchSchedule/$(PlaybackConfigurationName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_source_locations()
    list_source_locations(params::Dict{String,<:Any})

Lists the source locations for a channel. A source location defines the host server URL,
and contains a list of sources.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:  The maximum number of source locations that you want MediaTailor to
  return in response to the current request. If there are more than MaxResults source
  locations, use the value of NextToken in the response to get the next page of results.
- `"nextToken"`: Pagination token returned by the list request when results exceed the
  maximum allowed. Use the token to fetch the next page of results.
"""
function list_source_locations(; aws_config::AbstractAWSConfig=current_aws_config())
    return mediatailor(
        "GET", "/sourceLocations"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_source_locations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediatailor(
        "GET",
        "/sourceLocations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

A list of tags that are associated with this resource. Tags are key-value pairs that you
can associate with Amazon resources to help with organization, access control, and cost
tracking. For more information, see Tagging AWS Elemental MediaTailor Resources.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) associated with this resource.

"""
function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediatailor(
        "GET",
        "/tags/$(ResourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediatailor(
        "GET",
        "/tags/$(ResourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_vod_sources(source_location_name)
    list_vod_sources(source_location_name, params::Dict{String,<:Any})

Lists the VOD sources contained in a source location. A source represents a piece of
content.

# Arguments
- `source_location_name`: The name of the source location associated with this VOD Source
  list.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:  The maximum number of VOD sources that you want MediaTailor to return in
  response to the current request. If there are more than MaxResults VOD sources, use the
  value of NextToken in the response to get the next page of results.
- `"nextToken"`: Pagination token returned by the list request when results exceed the
  maximum allowed. Use the token to fetch the next page of results.
"""
function list_vod_sources(
    SourceLocationName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediatailor(
        "GET",
        "/sourceLocation/$(SourceLocationName)/vodSources";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_vod_sources(
    SourceLocationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediatailor(
        "GET",
        "/sourceLocation/$(SourceLocationName)/vodSources",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_channel_policy(channel_name, policy)
    put_channel_policy(channel_name, policy, params::Dict{String,<:Any})

Creates an IAM policy for the channel. IAM policies are used to control access to your
channel.

# Arguments
- `channel_name`: The channel name associated with this Channel Policy.
- `policy`: Adds an IAM role that determines the permissions of your channel.

"""
function put_channel_policy(
    ChannelName, Policy; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediatailor(
        "PUT",
        "/channel/$(ChannelName)/policy",
        Dict{String,Any}("Policy" => Policy);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_channel_policy(
    ChannelName,
    Policy,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediatailor(
        "PUT",
        "/channel/$(ChannelName)/policy",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Policy" => Policy), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_playback_configuration(name)
    put_playback_configuration(name, params::Dict{String,<:Any})

Creates a playback configuration. For information about MediaTailor configurations, see
Working with configurations in AWS Elemental MediaTailor.

# Arguments
- `name`: The identifier for the playback configuration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AdDecisionServerUrl"`: The URL for the ad decision server (ADS). This includes the
  specification of static parameters and placeholders for dynamic parameters. AWS Elemental
  MediaTailor substitutes player-specific and session-specific parameters as needed when
  calling the ADS. Alternately, for testing you can provide a static VAST URL. The maximum
  length is 25,000 characters.
- `"AvailSuppression"`: The configuration for avail suppression, also known as ad
  suppression. For more information about ad suppression, see Ad Suppression.
- `"Bumper"`: The configuration for bumpers. Bumpers are short audio or video clips that
  play at the start or before the end of an ad break. To learn more about bumpers, see
  Bumpers.
- `"CdnConfiguration"`: The configuration for using a content delivery network (CDN), like
  Amazon CloudFront, for content and ad segment management.
- `"ConfigurationAliases"`: The player parameters and aliases used as dynamic variables
  during session initialization. For more information, see Domain Variables.
- `"DashConfiguration"`: The configuration for DASH content.
- `"InsertionMode"`: The setting that controls whether players can use stitched or guided
  ad insertion. The default, STITCHED_ONLY, forces all player sessions to use stitched
  (server-side) ad insertion. Choosing PLAYER_SELECT allows players to select either stitched
  or guided ad insertion at session-initialization time. The default for players that do not
  specify an insertion mode is stitched.
- `"LivePreRollConfiguration"`: The configuration for pre-roll ad insertion.
- `"ManifestProcessingRules"`: The configuration for manifest processing rules. Manifest
  processing rules enable customization of the personalized manifests created by MediaTailor.
- `"PersonalizationThresholdSeconds"`: Defines the maximum duration of underfilled ad time
  (in seconds) allowed in an ad break. If the duration of underfilled ad time exceeds the
  personalization threshold, then the personalization of the ad break is abandoned and the
  underlying content is shown. This feature applies to ad replacement in live and VOD
  streams, rather than ad insertion, because it relies on an underlying content stream. For
  more information about ad break behavior, including ad replacement and insertion, see Ad
  Behavior in AWS Elemental MediaTailor.
- `"SlateAdUrl"`: The URL for a high-quality video asset to transcode and use to fill in
  time that's not used by ads. AWS Elemental MediaTailor shows the slate to fill in gaps in
  media content. Configuring the slate is optional for non-VPAID configurations. For VPAID,
  the slate is required because MediaTailor provides it in the slots that are designated for
  dynamic ad content. The slate must be a high-quality asset that contains both audio and
  video.
- `"TranscodeProfileName"`: The name that is used to associate this playback configuration
  with a custom transcode profile. This overrides the dynamic transcoding defaults of
  MediaTailor. Use this only if you have already set up custom profiles with the help of AWS
  Support.
- `"VideoContentSourceUrl"`: The URL prefix for the parent manifest for the stream, minus
  the asset ID. The maximum length is 512 characters.
- `"tags"`: The tags to assign to the playback configuration. Tags are key-value pairs that
  you can associate with Amazon resources to help with organization, access control, and cost
  tracking. For more information, see Tagging AWS Elemental MediaTailor Resources.
"""
function put_playback_configuration(
    Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediatailor(
        "PUT",
        "/playbackConfiguration",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_playback_configuration(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediatailor(
        "PUT",
        "/playbackConfiguration",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_channel(channel_name)
    start_channel(channel_name, params::Dict{String,<:Any})

Starts a channel. For information about MediaTailor channels, see Working with channels in
the MediaTailor User Guide.

# Arguments
- `channel_name`: The name of the channel.

"""
function start_channel(ChannelName; aws_config::AbstractAWSConfig=current_aws_config())
    return mediatailor(
        "PUT",
        "/channel/$(ChannelName)/start";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_channel(
    ChannelName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediatailor(
        "PUT",
        "/channel/$(ChannelName)/start",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_channel(channel_name)
    stop_channel(channel_name, params::Dict{String,<:Any})

Stops a channel. For information about MediaTailor channels, see Working with channels in
the MediaTailor User Guide.

# Arguments
- `channel_name`: The name of the channel.

"""
function stop_channel(ChannelName; aws_config::AbstractAWSConfig=current_aws_config())
    return mediatailor(
        "PUT",
        "/channel/$(ChannelName)/stop";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_channel(
    ChannelName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediatailor(
        "PUT",
        "/channel/$(ChannelName)/stop",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

The resource to tag. Tags are key-value pairs that you can associate with Amazon resources
to help with organization, access control, and cost tracking. For more information, see
Tagging AWS Elemental MediaTailor Resources.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) associated with the resource.
- `tags`: The tags to assign to the resource. Tags are key-value pairs that you can
  associate with Amazon resources to help with organization, access control, and cost
  tracking. For more information, see Tagging AWS Elemental MediaTailor Resources.

"""
function tag_resource(ResourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return mediatailor(
        "POST",
        "/tags/$(ResourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediatailor(
        "POST",
        "/tags/$(ResourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

The resource to untag.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource to untag.
- `tag_keys`: The tag keys associated with the resource.

"""
function untag_resource(
    ResourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediatailor(
        "DELETE",
        "/tags/$(ResourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediatailor(
        "DELETE",
        "/tags/$(ResourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_channel(channel_name, outputs)
    update_channel(channel_name, outputs, params::Dict{String,<:Any})

Updates a channel. For information about MediaTailor channels, see Working with channels in
the MediaTailor User Guide.

# Arguments
- `channel_name`: The name of the channel.
- `outputs`: The channel's output properties.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Audiences"`: The list of audiences defined in channel.
- `"FillerSlate"`: The slate used to fill gaps between programs in the schedule. You must
  configure filler slate if your channel uses the LINEAR PlaybackMode. MediaTailor doesn't
  support filler slate for channels using the LOOP PlaybackMode.
- `"TimeShiftConfiguration"`:  The time-shifted viewing configuration you want to associate
  to the channel.
"""
function update_channel(
    ChannelName, Outputs; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediatailor(
        "PUT",
        "/channel/$(ChannelName)",
        Dict{String,Any}("Outputs" => Outputs);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_channel(
    ChannelName,
    Outputs,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediatailor(
        "PUT",
        "/channel/$(ChannelName)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Outputs" => Outputs), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_live_source(http_package_configurations, live_source_name, source_location_name)
    update_live_source(http_package_configurations, live_source_name, source_location_name, params::Dict{String,<:Any})

Updates a live source's configuration.

# Arguments
- `http_package_configurations`: A list of HTTP package configurations for the live source
  on this account.
- `live_source_name`: The name of the live source.
- `source_location_name`: The name of the source location associated with this Live Source.

"""
function update_live_source(
    HttpPackageConfigurations,
    LiveSourceName,
    SourceLocationName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediatailor(
        "PUT",
        "/sourceLocation/$(SourceLocationName)/liveSource/$(LiveSourceName)",
        Dict{String,Any}("HttpPackageConfigurations" => HttpPackageConfigurations);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_live_source(
    HttpPackageConfigurations,
    LiveSourceName,
    SourceLocationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediatailor(
        "PUT",
        "/sourceLocation/$(SourceLocationName)/liveSource/$(LiveSourceName)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("HttpPackageConfigurations" => HttpPackageConfigurations),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_program(channel_name, program_name, schedule_configuration)
    update_program(channel_name, program_name, schedule_configuration, params::Dict{String,<:Any})

Updates a program within a channel.

# Arguments
- `channel_name`: The name of the channel for this Program.
- `program_name`: The name of the Program.
- `schedule_configuration`: The schedule configuration settings.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AdBreaks"`: The ad break configuration settings.
- `"AudienceMedia"`: The list of AudienceMedia defined in program.
"""
function update_program(
    ChannelName,
    ProgramName,
    ScheduleConfiguration;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediatailor(
        "PUT",
        "/channel/$(ChannelName)/program/$(ProgramName)",
        Dict{String,Any}("ScheduleConfiguration" => ScheduleConfiguration);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_program(
    ChannelName,
    ProgramName,
    ScheduleConfiguration,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediatailor(
        "PUT",
        "/channel/$(ChannelName)/program/$(ProgramName)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ScheduleConfiguration" => ScheduleConfiguration),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_source_location(http_configuration, source_location_name)
    update_source_location(http_configuration, source_location_name, params::Dict{String,<:Any})

Updates a source location. A source location is a container for sources. For more
information about source locations, see Working with source locations in the MediaTailor
User Guide.

# Arguments
- `http_configuration`: The HTTP configuration for the source location.
- `source_location_name`: The name of the source location.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccessConfiguration"`: Access configuration parameters. Configures the type of
  authentication used to access content from your source location.
- `"DefaultSegmentDeliveryConfiguration"`: The optional configuration for the host server
  that serves segments.
- `"SegmentDeliveryConfigurations"`: A list of the segment delivery configurations
  associated with this resource.
"""
function update_source_location(
    HttpConfiguration,
    SourceLocationName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediatailor(
        "PUT",
        "/sourceLocation/$(SourceLocationName)",
        Dict{String,Any}("HttpConfiguration" => HttpConfiguration);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_source_location(
    HttpConfiguration,
    SourceLocationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediatailor(
        "PUT",
        "/sourceLocation/$(SourceLocationName)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("HttpConfiguration" => HttpConfiguration), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_vod_source(http_package_configurations, source_location_name, vod_source_name)
    update_vod_source(http_package_configurations, source_location_name, vod_source_name, params::Dict{String,<:Any})

Updates a VOD source's configuration.

# Arguments
- `http_package_configurations`: A list of HTTP package configurations for the VOD source
  on this account.
- `source_location_name`: The name of the source location associated with this VOD Source.
- `vod_source_name`: The name of the VOD source.

"""
function update_vod_source(
    HttpPackageConfigurations,
    SourceLocationName,
    VodSourceName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediatailor(
        "PUT",
        "/sourceLocation/$(SourceLocationName)/vodSource/$(VodSourceName)",
        Dict{String,Any}("HttpPackageConfigurations" => HttpPackageConfigurations);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_vod_source(
    HttpPackageConfigurations,
    SourceLocationName,
    VodSourceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediatailor(
        "PUT",
        "/sourceLocation/$(SourceLocationName)/vodSource/$(VodSourceName)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("HttpPackageConfigurations" => HttpPackageConfigurations),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: health
using AWS.Compat
using AWS.UUIDs

"""
    describe_affected_accounts_for_organization(event_arn)
    describe_affected_accounts_for_organization(event_arn, params::Dict{String,<:Any})

Returns a list of accounts in the organization from Organizations that are affected by the
provided event. For more information about the different types of Health events, see Event.
 Before you can call this operation, you must first enable Health to work with
Organizations. To do this, call the EnableHealthServiceAccessForOrganization operation from
your organization's management account.  This API operation uses pagination. Specify the
nextToken parameter in the next request to return more results.

# Arguments
- `event_arn`: The unique identifier for the event. The event ARN has the
  arn:aws:health:event-region::event/SERVICE/EVENT_TYPE_CODE/EVENT_TYPE_PLUS_ID  format. For
  example, an event ARN might look like the following:
  arn:aws:health:us-east-1::event/EC2/EC2_INSTANCE_RETIREMENT_SCHEDULED/EC2_INSTANCE_RETIREMEN
  T_SCHEDULED_ABC123-DEF456

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of items to return in one batch, between 10 and 100,
  inclusive.
- `"nextToken"`: If the results of a search are large, only a portion of the results are
  returned, and a nextToken pagination token is returned in the response. To retrieve the
  next batch of results, reissue the search request and include the returned token. When all
  results have been returned, the response does not contain a pagination token value.
"""
function describe_affected_accounts_for_organization(
    eventArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return health(
        "DescribeAffectedAccountsForOrganization",
        Dict{String,Any}("eventArn" => eventArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_affected_accounts_for_organization(
    eventArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return health(
        "DescribeAffectedAccountsForOrganization",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("eventArn" => eventArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_affected_entities(filter)
    describe_affected_entities(filter, params::Dict{String,<:Any})

Returns a list of entities that have been affected by the specified events, based on the
specified filter criteria. Entities can refer to individual customer resources, groups of
customer resources, or any other construct, depending on the Amazon Web Service. Events
that have impact beyond that of the affected entities, or where the extent of impact is
unknown, include at least one entity indicating this. At least one event ARN is required.
 This API operation uses pagination. Specify the nextToken parameter in the next request to
return more results.   This operation supports resource-level permissions. You can use this
operation to allow or deny access to specific Health events. For more information, see
Resource- and action-based conditions in the Health User Guide.

# Arguments
- `filter`: Values to narrow the results returned. At least one event ARN is required.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"locale"`: The locale (language) to return information in. English (en) is the default
  and the only supported value at this time.
- `"maxResults"`: The maximum number of items to return in one batch, between 10 and 100,
  inclusive.
- `"nextToken"`: If the results of a search are large, only a portion of the results are
  returned, and a nextToken pagination token is returned in the response. To retrieve the
  next batch of results, reissue the search request and include the returned token. When all
  results have been returned, the response does not contain a pagination token value.
"""
function describe_affected_entities(
    filter; aws_config::AbstractAWSConfig=current_aws_config()
)
    return health(
        "DescribeAffectedEntities",
        Dict{String,Any}("filter" => filter);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_affected_entities(
    filter, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return health(
        "DescribeAffectedEntities",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("filter" => filter), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_affected_entities_for_organization()
    describe_affected_entities_for_organization(params::Dict{String,<:Any})

Returns a list of entities that have been affected by one or more events for one or more
accounts in your organization in Organizations, based on the filter criteria. Entities can
refer to individual customer resources, groups of customer resources, or any other
construct, depending on the Amazon Web Service. At least one event Amazon Resource Name
(ARN) and account ID are required. Before you can call this operation, you must first
enable Health to work with Organizations. To do this, call the
EnableHealthServiceAccessForOrganization operation from your organization's management
account.    This API operation uses pagination. Specify the nextToken parameter in the next
request to return more results.   This operation doesn't support resource-level
permissions. You can't use this operation to allow or deny access to specific Health
events. For more information, see Resource- and action-based conditions in the Health User
Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"locale"`: The locale (language) to return information in. English (en) is the default
  and the only supported value at this time.
- `"maxResults"`: The maximum number of items to return in one batch, between 10 and 100,
  inclusive.
- `"nextToken"`: If the results of a search are large, only a portion of the results are
  returned, and a nextToken pagination token is returned in the response. To retrieve the
  next batch of results, reissue the search request and include the returned token. When all
  results have been returned, the response does not contain a pagination token value.
- `"organizationEntityAccountFilters"`: A JSON set of elements including the awsAccountId,
  eventArn and a set of statusCodes.
- `"organizationEntityFilters"`: A JSON set of elements including the awsAccountId and the
  eventArn.
"""
function describe_affected_entities_for_organization(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return health(
        "DescribeAffectedEntitiesForOrganization";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_affected_entities_for_organization(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return health(
        "DescribeAffectedEntitiesForOrganization",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_entity_aggregates()
    describe_entity_aggregates(params::Dict{String,<:Any})

Returns the number of entities that are affected by each of the specified events.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"eventArns"`: A list of event ARNs (unique identifiers). For example:
  \"arn:aws:health:us-east-1::event/EC2/EC2_INSTANCE_RETIREMENT_SCHEDULED/EC2_INSTANCE_RETIREM
  ENT_SCHEDULED_ABC123-CDE456\",
  \"arn:aws:health:us-west-1::event/EBS/AWS_EBS_LOST_VOLUME/AWS_EBS_LOST_VOLUME_CHI789_JKL101
  \"
"""
function describe_entity_aggregates(; aws_config::AbstractAWSConfig=current_aws_config())
    return health(
        "DescribeEntityAggregates"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_entity_aggregates(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return health(
        "DescribeEntityAggregates",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_entity_aggregates_for_organization(event_arns)
    describe_entity_aggregates_for_organization(event_arns, params::Dict{String,<:Any})

Returns a list of entity aggregates for your Organizations that are affected by each of the
specified events.

# Arguments
- `event_arns`: A list of event ARNs (unique identifiers). For example:
  \"arn:aws:health:us-east-1::event/EC2/EC2_INSTANCE_RETIREMENT_SCHEDULED/EC2_INSTANCE_RETIREM
  ENT_SCHEDULED_ABC123-CDE456\",
  \"arn:aws:health:us-west-1::event/EBS/AWS_EBS_LOST_VOLUME/AWS_EBS_LOST_VOLUME_CHI789_JKL101
  \"

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"awsAccountIds"`: A list of 12-digit Amazon Web Services account numbers that contains
  the affected entities.
"""
function describe_entity_aggregates_for_organization(
    eventArns; aws_config::AbstractAWSConfig=current_aws_config()
)
    return health(
        "DescribeEntityAggregatesForOrganization",
        Dict{String,Any}("eventArns" => eventArns);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_entity_aggregates_for_organization(
    eventArns,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return health(
        "DescribeEntityAggregatesForOrganization",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("eventArns" => eventArns), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_event_aggregates(aggregate_field)
    describe_event_aggregates(aggregate_field, params::Dict{String,<:Any})

Returns the number of events of each event type (issue, scheduled change, and account
notification). If no filter is specified, the counts of all events in each category are
returned.  This API operation uses pagination. Specify the nextToken parameter in the next
request to return more results.

# Arguments
- `aggregate_field`: The only currently supported value is eventTypeCategory.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filter"`: Values to narrow the results returned.
- `"maxResults"`: The maximum number of items to return in one batch, between 10 and 100,
  inclusive.
- `"nextToken"`: If the results of a search are large, only a portion of the results are
  returned, and a nextToken pagination token is returned in the response. To retrieve the
  next batch of results, reissue the search request and include the returned token. When all
  results have been returned, the response does not contain a pagination token value.
"""
function describe_event_aggregates(
    aggregateField; aws_config::AbstractAWSConfig=current_aws_config()
)
    return health(
        "DescribeEventAggregates",
        Dict{String,Any}("aggregateField" => aggregateField);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_event_aggregates(
    aggregateField,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return health(
        "DescribeEventAggregates",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("aggregateField" => aggregateField), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_event_details(event_arns)
    describe_event_details(event_arns, params::Dict{String,<:Any})

Returns detailed information about one or more specified events. Information includes
standard event data (Amazon Web Services Region, service, and so on, as returned by
DescribeEvents), a detailed event description, and possible additional metadata that
depends upon the nature of the event. Affected entities are not included. To retrieve the
entities, use the DescribeAffectedEntities operation. If a specified event can't be
retrieved, an error message is returned for that event.  This operation supports
resource-level permissions. You can use this operation to allow or deny access to specific
Health events. For more information, see Resource- and action-based conditions in the
Health User Guide.

# Arguments
- `event_arns`: A list of event ARNs (unique identifiers). For example:
  \"arn:aws:health:us-east-1::event/EC2/EC2_INSTANCE_RETIREMENT_SCHEDULED/EC2_INSTANCE_RETIREM
  ENT_SCHEDULED_ABC123-CDE456\",
  \"arn:aws:health:us-west-1::event/EBS/AWS_EBS_LOST_VOLUME/AWS_EBS_LOST_VOLUME_CHI789_JKL101
  \"

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"locale"`: The locale (language) to return information in. English (en) is the default
  and the only supported value at this time.
"""
function describe_event_details(
    eventArns; aws_config::AbstractAWSConfig=current_aws_config()
)
    return health(
        "DescribeEventDetails",
        Dict{String,Any}("eventArns" => eventArns);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_event_details(
    eventArns,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return health(
        "DescribeEventDetails",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("eventArns" => eventArns), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_event_details_for_organization(organization_event_detail_filters)
    describe_event_details_for_organization(organization_event_detail_filters, params::Dict{String,<:Any})

Returns detailed information about one or more specified events for one or more Amazon Web
Services accounts in your organization. This information includes standard event data (such
as the Amazon Web Services Region and service), an event description, and (depending on the
event) possible metadata. This operation doesn't return affected entities, such as the
resources related to the event. To return affected entities, use the
DescribeAffectedEntitiesForOrganization operation.  Before you can call this operation, you
must first enable Health to work with Organizations. To do this, call the
EnableHealthServiceAccessForOrganization operation from your organization's management
account.  When you call the DescribeEventDetailsForOrganization operation, specify the
organizationEventDetailFilters object in the request. Depending on the Health event type,
note the following differences:   To return event details for a public event, you must
specify a null value for the awsAccountId parameter. If you specify an account ID for a
public event, Health returns an error message because public events aren't specific to an
account.   To return event details for an event that is specific to an account in your
organization, you must specify the awsAccountId parameter in the request. If you don't
specify an account ID, Health returns an error message because the event is specific to an
account in your organization.    For more information, see Event.  This operation doesn't
support resource-level permissions. You can't use this operation to allow or deny access to
specific Health events. For more information, see Resource- and action-based conditions in
the Health User Guide.

# Arguments
- `organization_event_detail_filters`: A set of JSON elements that includes the
  awsAccountId and the eventArn.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"locale"`: The locale (language) to return information in. English (en) is the default
  and the only supported value at this time.
"""
function describe_event_details_for_organization(
    organizationEventDetailFilters; aws_config::AbstractAWSConfig=current_aws_config()
)
    return health(
        "DescribeEventDetailsForOrganization",
        Dict{String,Any}(
            "organizationEventDetailFilters" => organizationEventDetailFilters
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_event_details_for_organization(
    organizationEventDetailFilters,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return health(
        "DescribeEventDetailsForOrganization",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "organizationEventDetailFilters" => organizationEventDetailFilters
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_event_types()
    describe_event_types(params::Dict{String,<:Any})

Returns the event types that meet the specified filter criteria. You can use this API
operation to find information about the Health event, such as the category, Amazon Web
Service, and event code. The metadata for each event appears in the EventType object.  If
you don't specify a filter criteria, the API operation returns all event types, in no
particular order.   This API operation uses pagination. Specify the nextToken parameter in
the next request to return more results.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filter"`: Values to narrow the results returned.
- `"locale"`: The locale (language) to return information in. English (en) is the default
  and the only supported value at this time.
- `"maxResults"`: The maximum number of items to return in one batch, between 10 and 100,
  inclusive.  If you don't specify the maxResults parameter, this operation returns a maximum
  of 30 items by default.
- `"nextToken"`: If the results of a search are large, only a portion of the results are
  returned, and a nextToken pagination token is returned in the response. To retrieve the
  next batch of results, reissue the search request and include the returned token. When all
  results have been returned, the response does not contain a pagination token value.
"""
function describe_event_types(; aws_config::AbstractAWSConfig=current_aws_config())
    return health(
        "DescribeEventTypes"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_event_types(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return health(
        "DescribeEventTypes", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_events()
    describe_events(params::Dict{String,<:Any})

 Returns information about events that meet the specified filter criteria. Events are
returned in a summary form and do not include the detailed description, any additional
metadata that depends on the event type, or any affected resources. To retrieve that
information, use the DescribeEventDetails and DescribeAffectedEntities operations. If no
filter criteria are specified, all events are returned. Results are sorted by
lastModifiedTime, starting with the most recent event.    When you call the DescribeEvents
operation and specify an entity for the entityValues parameter, Health might return public
events that aren't specific to that resource. For example, if you call DescribeEvents and
specify an ID for an Amazon Elastic Compute Cloud (Amazon EC2) instance, Health might
return events that aren't specific to that resource or service. To get events that are
specific to a service, use the services parameter in the filter object. For more
information, see Event.   This API operation uses pagination. Specify the nextToken
parameter in the next request to return more results.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filter"`: Values to narrow the results returned.
- `"locale"`: The locale (language) to return information in. English (en) is the default
  and the only supported value at this time.
- `"maxResults"`: The maximum number of items to return in one batch, between 10 and 100,
  inclusive.
- `"nextToken"`: If the results of a search are large, only a portion of the results are
  returned, and a nextToken pagination token is returned in the response. To retrieve the
  next batch of results, reissue the search request and include the returned token. When all
  results have been returned, the response does not contain a pagination token value.
"""
function describe_events(; aws_config::AbstractAWSConfig=current_aws_config())
    return health("DescribeEvents"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function describe_events(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return health(
        "DescribeEvents", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_events_for_organization()
    describe_events_for_organization(params::Dict{String,<:Any})

Returns information about events across your organization in Organizations. You can use
thefilters parameter to specify the events that you want to return. Events are returned in
a summary form and don't include the affected accounts, detailed description, any
additional metadata that depends on the event type, or any affected resources. To retrieve
that information, use the following operations:    DescribeAffectedAccountsForOrganization
   DescribeEventDetailsForOrganization     DescribeAffectedEntitiesForOrganization    If
you don't specify a filter, the DescribeEventsForOrganizations returns all events across
your organization. Results are sorted by lastModifiedTime, starting with the most recent
event.  For more information about the different types of Health events, see Event. Before
you can call this operation, you must first enable Health to work with Organizations. To do
this, call the EnableHealthServiceAccessForOrganization operation from your organization's
management account.  This API operation uses pagination. Specify the nextToken parameter in
the next request to return more results.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filter"`: Values to narrow the results returned.
- `"locale"`: The locale (language) to return information in. English (en) is the default
  and the only supported value at this time.
- `"maxResults"`: The maximum number of items to return in one batch, between 10 and 100,
  inclusive.
- `"nextToken"`: If the results of a search are large, only a portion of the results are
  returned, and a nextToken pagination token is returned in the response. To retrieve the
  next batch of results, reissue the search request and include the returned token. When all
  results have been returned, the response does not contain a pagination token value.
"""
function describe_events_for_organization(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return health(
        "DescribeEventsForOrganization";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_events_for_organization(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return health(
        "DescribeEventsForOrganization",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_health_service_status_for_organization()
    describe_health_service_status_for_organization(params::Dict{String,<:Any})

This operation provides status information on enabling or disabling Health to work with
your organization. To call this operation, you must use the organization's management
account.

"""
function describe_health_service_status_for_organization(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return health(
        "DescribeHealthServiceStatusForOrganization";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_health_service_status_for_organization(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return health(
        "DescribeHealthServiceStatusForOrganization",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disable_health_service_access_for_organization()
    disable_health_service_access_for_organization(params::Dict{String,<:Any})

Disables Health from working with Organizations. To call this operation, you must sign in
to the organization's management account. For more information, see Aggregating Health
events in the Health User Guide. This operation doesn't remove the service-linked role from
the management account in your organization. You must use the IAM console, API, or Command
Line Interface (CLI) to remove the service-linked role. For more information, see Deleting
a Service-Linked Role in the IAM User Guide.  You can also disable the organizational
feature by using the Organizations DisableAWSServiceAccess API operation. After you call
this operation, Health stops aggregating events for all other Amazon Web Services accounts
in your organization. If you call the Health API operations for organizational view, Health
returns an error. Health continues to aggregate health events for your Amazon Web Services
account.

"""
function disable_health_service_access_for_organization(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return health(
        "DisableHealthServiceAccessForOrganization";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disable_health_service_access_for_organization(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return health(
        "DisableHealthServiceAccessForOrganization",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    enable_health_service_access_for_organization()
    enable_health_service_access_for_organization(params::Dict{String,<:Any})

Enables Health to work with Organizations. You can use the organizational view feature to
aggregate events from all Amazon Web Services accounts in your organization in a
centralized location.  This operation also creates a service-linked role for the management
account in the organization.   To call this operation, you must meet the following
requirements:   You must have a Business, Enterprise On-Ramp, or Enterprise Support plan
from Amazon Web Services Support to use the Health API. If you call the Health API from an
Amazon Web Services account that doesn't have a Business, Enterprise On-Ramp, or Enterprise
Support plan, you receive a SubscriptionRequiredException error.   You must have permission
to call this operation from the organization's management account. For example IAM
policies, see Health identity-based policy examples.    If you don't have the required
support plan, you can instead use the Health console to enable the organizational view
feature. For more information, see Aggregating Health events in the Health User Guide.

"""
function enable_health_service_access_for_organization(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return health(
        "EnableHealthServiceAccessForOrganization";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function enable_health_service_access_for_organization(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return health(
        "EnableHealthServiceAccessForOrganization",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: snowball
using AWS.Compat
using AWS.UUIDs

"""
    cancel_cluster(cluster_id)
    cancel_cluster(cluster_id, params::Dict{String,<:Any})

Cancels a cluster job. You can only cancel a cluster job while it's in the AwaitingQuorum
status. You'll have at least an hour after creating a cluster job to cancel it.

# Arguments
- `cluster_id`: The 39-character ID for the cluster that you want to cancel, for example
  CID123e4567-e89b-12d3-a456-426655440000.

"""
function cancel_cluster(ClusterId; aws_config::AbstractAWSConfig=current_aws_config())
    return snowball(
        "CancelCluster",
        Dict{String,Any}("ClusterId" => ClusterId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_cluster(
    ClusterId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return snowball(
        "CancelCluster",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ClusterId" => ClusterId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_job(job_id)
    cancel_job(job_id, params::Dict{String,<:Any})

Cancels the specified job. You can only cancel a job before its JobState value changes to
PreparingAppliance. Requesting the ListJobs or DescribeJob action returns a job's JobState
as part of the response element data returned.

# Arguments
- `job_id`: The 39-character job ID for the job that you want to cancel, for example
  JID123e4567-e89b-12d3-a456-426655440000.

"""
function cancel_job(JobId; aws_config::AbstractAWSConfig=current_aws_config())
    return snowball(
        "CancelJob",
        Dict{String,Any}("JobId" => JobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_job(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return snowball(
        "CancelJob",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("JobId" => JobId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_address(address)
    create_address(address, params::Dict{String,<:Any})

Creates an address for a Snow device to be shipped to. In most regions, addresses are
validated at the time of creation. The address you provide must be located within the
serviceable area of your region. If the address is invalid or unsupported, then an
exception is thrown. If providing an address as a JSON file through the cli-input-json
option, include the full file path. For example, --cli-input-json
file://create-address.json.

# Arguments
- `address`: The address that you want the Snow device shipped to.

"""
function create_address(Address; aws_config::AbstractAWSConfig=current_aws_config())
    return snowball(
        "CreateAddress",
        Dict{String,Any}("Address" => Address);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_address(
    Address,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return snowball(
        "CreateAddress",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Address" => Address), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_cluster(address_id, job_type, shipping_option, snowball_type)
    create_cluster(address_id, job_type, shipping_option, snowball_type, params::Dict{String,<:Any})

Creates an empty cluster. Each cluster supports five nodes. You use the CreateJob action
separately to create the jobs for each of these nodes. The cluster does not ship until
these five node jobs have been created.

# Arguments
- `address_id`: The ID for the address that you want the cluster shipped to.
- `job_type`: The type of job for this cluster. Currently, the only job type supported for
  clusters is LOCAL_USE. For more information, see
  \"https://docs.aws.amazon.com/snowball/latest/snowcone-guide/snow-device-types.html\" (Snow
  Family Devices and Capacity) in the Snowcone User Guide or
  \"https://docs.aws.amazon.com/snowball/latest/developer-guide/snow-device-types.html\"
  (Snow Family Devices and Capacity) in the Snowcone User Guide.
- `shipping_option`: The shipping speed for each node in this cluster. This speed doesn't
  dictate how soon you'll get each Snowball Edge device, rather it represents how quickly
  each device moves to its destination while in transit. Regional shipping speeds are as
  follows:    In Australia, you have access to express shipping. Typically, Snow devices
  shipped express are delivered in about a day.   In the European Union (EU), you have access
  to express shipping. Typically, Snow devices shipped express are delivered in about a day.
  In addition, most countries in the EU have access to standard shipping, which typically
  takes less than a week, one way.   In India, Snow devices are delivered in one to seven
  days.   In the United States of America (US), you have access to one-day shipping and
  two-day shipping.     In Australia, you have access to express shipping. Typically, devices
  shipped express are delivered in about a day.   In the European Union (EU), you have access
  to express shipping. Typically, Snow devices shipped express are delivered in about a day.
  In addition, most countries in the EU have access to standard shipping, which typically
  takes less than a week, one way.   In India, Snow devices are delivered in one to seven
  days.   In the US, you have access to one-day shipping and two-day shipping.
- `snowball_type`: The type of Snow Family devices to use for this cluster.   For cluster
  jobs, Amazon Web Services Snow Family currently supports only the EDGE device type.  For
  more information, see
  \"https://docs.aws.amazon.com/snowball/latest/snowcone-guide/snow-device-types.html\" (Snow
  Family Devices and Capacity) in the Snowcone User Guide or
  \"https://docs.aws.amazon.com/snowball/latest/developer-guide/snow-device-types.html\"
  (Snow Family Devices and Capacity) in the Snowcone User Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: An optional description of this specific cluster, for example
  Environmental Data Cluster-01.
- `"ForceCreateJobs"`: Force to create cluster when user attempts to overprovision or
  underprovision a cluster. A cluster is overprovisioned or underprovisioned if the initial
  size of the cluster is more (overprovisioned) or less (underprovisioned) than what needed
  to meet capacity requirement specified with OnDeviceServiceConfiguration.
- `"ForwardingAddressId"`: The forwarding address ID for a cluster. This field is not
  supported in most regions.
- `"InitialClusterSize"`: If provided, each job will be automatically created and
  associated with the new cluster. If not provided, will be treated as 0.
- `"KmsKeyARN"`: The KmsKeyARN value that you want to associate with this cluster.
  KmsKeyARN values are created by using the CreateKey API action in Key Management Service
  (KMS).
- `"LongTermPricingIds"`: Lists long-term pricing id that will be used to associate with
  jobs automatically created for the new cluster.
- `"Notification"`: The Amazon Simple Notification Service (Amazon SNS) notification
  settings for this cluster.
- `"OnDeviceServiceConfiguration"`: Specifies the service or services on the Snow Family
  device that your transferred data will be exported from or imported into. Amazon Web
  Services Snow Family device clusters support Amazon S3 and NFS (Network File System).
- `"RemoteManagement"`: Allows you to securely operate and manage Snow devices in a cluster
  remotely from outside of your internal network. When set to INSTALLED_AUTOSTART, remote
  management will automatically be available when the device arrives at your location.
  Otherwise, you need to use the Snowball Client to manage the device.
- `"Resources"`: The resources associated with the cluster job. These resources include
  Amazon S3 buckets and optional Lambda functions written in the Python language.
- `"RoleARN"`: The RoleARN that you want to associate with this cluster. RoleArn values are
  created by using the CreateRole API action in Identity and Access Management (IAM).
- `"SnowballCapacityPreference"`: If your job is being created in one of the US regions,
  you have the option of specifying what size Snow device you'd like for this job. In all
  other regions, Snowballs come with 80 TB in storage capacity. For more information, see
  \"https://docs.aws.amazon.com/snowball/latest/snowcone-guide/snow-device-types.html\" (Snow
  Family Devices and Capacity) in the Snowcone User Guide or
  \"https://docs.aws.amazon.com/snowball/latest/developer-guide/snow-device-types.html\"
  (Snow Family Devices and Capacity) in the Snowcone User Guide.
- `"TaxDocuments"`: The tax documents required in your Amazon Web Services Region.
"""
function create_cluster(
    AddressId,
    JobType,
    ShippingOption,
    SnowballType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return snowball(
        "CreateCluster",
        Dict{String,Any}(
            "AddressId" => AddressId,
            "JobType" => JobType,
            "ShippingOption" => ShippingOption,
            "SnowballType" => SnowballType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_cluster(
    AddressId,
    JobType,
    ShippingOption,
    SnowballType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return snowball(
        "CreateCluster",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AddressId" => AddressId,
                    "JobType" => JobType,
                    "ShippingOption" => ShippingOption,
                    "SnowballType" => SnowballType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_job()
    create_job(params::Dict{String,<:Any})

Creates a job to import or export data between Amazon S3 and your on-premises data center.
Your Amazon Web Services account must have the right trust policies and permissions in
place to create a job for a Snow device. If you're creating a job for a node in a cluster,
you only need to provide the clusterId value; the other job attributes are inherited from
the cluster.   Only the Snowball; Edge device type is supported when ordering clustered
jobs. The device capacity is optional. Availability of device types differ by Amazon Web
Services Region. For more information about Region availability, see Amazon Web Services
Regional Services.    Snow Family devices and their capacities.    Device type: SNC1_SSD
Capacity: T14   Description: Snowcone       Device type: SNC1_HDD    Capacity: T8
Description: Snowcone       Device type: EDGE_S    Capacity: T98   Description: Snowball
Edge Storage Optimized for data transfer only       Device type: EDGE_CG    Capacity: T42
Description: Snowball Edge Compute Optimized with GPU      Device type: EDGE_C    Capacity:
T42   Description: Snowball Edge Compute Optimized without GPU      Device type: EDGE
Capacity: T100   Description: Snowball Edge Storage Optimized with EC2 Compute    This
device is replaced with T98.     Device type: STANDARD    Capacity: T50   Description:
Original Snowball device  This device is only available in the Ningxia, Beijing, and
Singapore Amazon Web Services Region        Device type: STANDARD    Capacity: T80
Description: Original Snowball device  This device is only available in the Ningxia,
Beijing, and Singapore Amazon Web Services Region.        Snow Family device type:
RACK_5U_C    Capacity: T13    Description: Snowblade.     Device type: V3_5S    Capacity:
T240   Description: Snowball Edge Storage Optimized 210TB

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AddressId"`: The ID for the address that you want the Snow device shipped to.
- `"ClusterId"`: The ID of a cluster. If you're creating a job for a node in a cluster, you
  need to provide only this clusterId value. The other job attributes are inherited from the
  cluster.
- `"Description"`: Defines an optional description of this specific job, for example
  Important Photos 2016-08-11.
- `"DeviceConfiguration"`: Defines the device configuration for an Snowcone job. For more
  information, see
  \"https://docs.aws.amazon.com/snowball/latest/snowcone-guide/snow-device-types.html\" (Snow
  Family Devices and Capacity) in the Snowcone User Guide or
  \"https://docs.aws.amazon.com/snowball/latest/developer-guide/snow-device-types.html\"
  (Snow Family Devices and Capacity) in the Snowcone User Guide.
- `"ForwardingAddressId"`: The forwarding address ID for a job. This field is not supported
  in most Regions.
- `"ImpactLevel"`: The highest impact level of data that will be stored or processed on the
  device, provided at job creation.
- `"JobType"`: Defines the type of job that you're creating.
- `"KmsKeyARN"`: The KmsKeyARN that you want to associate with this job. KmsKeyARNs are
  created using the CreateKey Key Management Service (KMS) API action.
- `"LongTermPricingId"`: The ID of the long-term pricing type for the device.
- `"Notification"`: Defines the Amazon Simple Notification Service (Amazon SNS)
  notification settings for this job.
- `"OnDeviceServiceConfiguration"`: Specifies the service or services on the Snow Family
  device that your transferred data will be exported from or imported into. Amazon Web
  Services Snow Family supports Amazon S3 and NFS (Network File System) and the Amazon Web
  Services Storage Gateway service Tape Gateway type.
- `"PickupDetails"`: Information identifying the person picking up the device.
- `"RemoteManagement"`: Allows you to securely operate and manage Snowcone devices remotely
  from outside of your internal network. When set to INSTALLED_AUTOSTART, remote management
  will automatically be available when the device arrives at your location. Otherwise, you
  need to use the Snowball Edge client to manage the device. When set to NOT_INSTALLED,
  remote management will not be available on the device.
- `"Resources"`: Defines the Amazon S3 buckets associated with this job. With IMPORT jobs,
  you specify the bucket or buckets that your transferred data will be imported into. With
  EXPORT jobs, you specify the bucket or buckets that your transferred data will be exported
  from. Optionally, you can also specify a KeyRange value. If you choose to export a range,
  you define the length of the range by providing either an inclusive BeginMarker value, an
  inclusive EndMarker value, or both. Ranges are UTF-8 binary sorted.
- `"RoleARN"`: The RoleARN that you want to associate with this job. RoleArns are created
  using the CreateRole Identity and Access Management (IAM) API action.
- `"ShippingOption"`: The shipping speed for this job. This speed doesn't dictate how soon
  you'll get the Snow device, rather it represents how quickly the Snow device moves to its
  destination while in transit. Regional shipping speeds are as follows:   In Australia, you
  have access to express shipping. Typically, Snow devices shipped express are delivered in
  about a day.   In the European Union (EU), you have access to express shipping. Typically,
  Snow devices shipped express are delivered in about a day. In addition, most countries in
  the EU have access to standard shipping, which typically takes less than a week, one way.
  In India, Snow devices are delivered in one to seven days.   In the US, you have access to
  one-day shipping and two-day shipping.
- `"SnowballCapacityPreference"`: If your job is being created in one of the US regions,
  you have the option of specifying what size Snow device you'd like for this job. In all
  other regions, Snowballs come with 80 TB in storage capacity. For more information, see
  \"https://docs.aws.amazon.com/snowball/latest/snowcone-guide/snow-device-types.html\" (Snow
  Family Devices and Capacity) in the Snowcone User Guide or
  \"https://docs.aws.amazon.com/snowball/latest/developer-guide/snow-device-types.html\"
  (Snow Family Devices and Capacity) in the Snowcone User Guide.
- `"SnowballType"`: The type of Snow Family devices to use for this job.   For cluster
  jobs, Amazon Web Services Snow Family currently supports only the EDGE device type.  The
  type of Amazon Web Services Snow device to use for this job. Currently, the only supported
  device type for cluster jobs is EDGE. For more information, see Snowball Edge Device
  Options in the Snowball Edge Developer Guide. For more information, see
  \"https://docs.aws.amazon.com/snowball/latest/snowcone-guide/snow-device-types.html\" (Snow
  Family Devices and Capacity) in the Snowcone User Guide or
  \"https://docs.aws.amazon.com/snowball/latest/developer-guide/snow-device-types.html\"
  (Snow Family Devices and Capacity) in the Snowcone User Guide.
- `"TaxDocuments"`: The tax documents required in your Amazon Web Services Region.
"""
function create_job(; aws_config::AbstractAWSConfig=current_aws_config())
    return snowball("CreateJob"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function create_job(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return snowball(
        "CreateJob", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    create_long_term_pricing(long_term_pricing_type, snowball_type)
    create_long_term_pricing(long_term_pricing_type, snowball_type, params::Dict{String,<:Any})

Creates a job with the long-term usage option for a device. The long-term usage is a 1-year
or 3-year long-term pricing type for the device. You are billed upfront, and Amazon Web
Services provides discounts for long-term pricing.

# Arguments
- `long_term_pricing_type`: The type of long-term pricing option you want for the device,
  either 1-year or 3-year long-term pricing.
- `snowball_type`: The type of Snow Family devices to use for the long-term pricing job.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"IsLongTermPricingAutoRenew"`: Specifies whether the current long-term pricing type for
  the device should be renewed.
"""
function create_long_term_pricing(
    LongTermPricingType, SnowballType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return snowball(
        "CreateLongTermPricing",
        Dict{String,Any}(
            "LongTermPricingType" => LongTermPricingType, "SnowballType" => SnowballType
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_long_term_pricing(
    LongTermPricingType,
    SnowballType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return snowball(
        "CreateLongTermPricing",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "LongTermPricingType" => LongTermPricingType,
                    "SnowballType" => SnowballType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_return_shipping_label(job_id)
    create_return_shipping_label(job_id, params::Dict{String,<:Any})

Creates a shipping label that will be used to return the Snow device to Amazon Web Services.

# Arguments
- `job_id`: The ID for a job that you want to create the return shipping label for; for
  example, JID123e4567-e89b-12d3-a456-426655440000.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ShippingOption"`: The shipping speed for a particular job. This speed doesn't dictate
  how soon the device is returned to Amazon Web Services. This speed represents how quickly
  it moves to its destination while in transit. Regional shipping speeds are as follows:
"""
function create_return_shipping_label(
    JobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return snowball(
        "CreateReturnShippingLabel",
        Dict{String,Any}("JobId" => JobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_return_shipping_label(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return snowball(
        "CreateReturnShippingLabel",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("JobId" => JobId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_address(address_id)
    describe_address(address_id, params::Dict{String,<:Any})

Takes an AddressId and returns specific details about that address in the form of an
Address object.

# Arguments
- `address_id`: The automatically generated ID for a specific address.

"""
function describe_address(AddressId; aws_config::AbstractAWSConfig=current_aws_config())
    return snowball(
        "DescribeAddress",
        Dict{String,Any}("AddressId" => AddressId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_address(
    AddressId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return snowball(
        "DescribeAddress",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AddressId" => AddressId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_addresses()
    describe_addresses(params::Dict{String,<:Any})

Returns a specified number of ADDRESS objects. Calling this API in one of the US regions
will return addresses from the list of all addresses associated with this account in all US
regions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The number of ADDRESS objects to return.
- `"NextToken"`: HTTP requests are stateless. To identify what object comes \"next\" in the
  list of ADDRESS objects, you have the option of specifying a value for NextToken as the
  starting point for your list of returned addresses.
"""
function describe_addresses(; aws_config::AbstractAWSConfig=current_aws_config())
    return snowball(
        "DescribeAddresses"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_addresses(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return snowball(
        "DescribeAddresses", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_cluster(cluster_id)
    describe_cluster(cluster_id, params::Dict{String,<:Any})

Returns information about a specific cluster including shipping information, cluster
status, and other important metadata.

# Arguments
- `cluster_id`: The automatically generated ID for a cluster.

"""
function describe_cluster(ClusterId; aws_config::AbstractAWSConfig=current_aws_config())
    return snowball(
        "DescribeCluster",
        Dict{String,Any}("ClusterId" => ClusterId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_cluster(
    ClusterId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return snowball(
        "DescribeCluster",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ClusterId" => ClusterId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_job(job_id)
    describe_job(job_id, params::Dict{String,<:Any})

Returns information about a specific job including shipping information, job status, and
other important metadata.

# Arguments
- `job_id`: The automatically generated ID for a job, for example
  JID123e4567-e89b-12d3-a456-426655440000.

"""
function describe_job(JobId; aws_config::AbstractAWSConfig=current_aws_config())
    return snowball(
        "DescribeJob",
        Dict{String,Any}("JobId" => JobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_job(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return snowball(
        "DescribeJob",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("JobId" => JobId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_return_shipping_label(job_id)
    describe_return_shipping_label(job_id, params::Dict{String,<:Any})

Information on the shipping label of a Snow device that is being returned to Amazon Web
Services.

# Arguments
- `job_id`: The automatically generated ID for a job, for example
  JID123e4567-e89b-12d3-a456-426655440000.

"""
function describe_return_shipping_label(
    JobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return snowball(
        "DescribeReturnShippingLabel",
        Dict{String,Any}("JobId" => JobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_return_shipping_label(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return snowball(
        "DescribeReturnShippingLabel",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("JobId" => JobId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_job_manifest(job_id)
    get_job_manifest(job_id, params::Dict{String,<:Any})

Returns a link to an Amazon S3 presigned URL for the manifest file associated with the
specified JobId value. You can access the manifest file for up to 60 minutes after this
request has been made. To access the manifest file after 60 minutes have passed, you'll
have to make another call to the GetJobManifest action. The manifest is an encrypted file
that you can download after your job enters the WithCustomer status. This is the only valid
status for calling this API as the manifest and UnlockCode code value are used for securing
your device and should only be used when you have the device. The manifest is decrypted by
using the UnlockCode code value, when you pass both values to the Snow device through the
Snowball client when the client is started for the first time.  As a best practice, we
recommend that you don't save a copy of an UnlockCode value in the same location as the
manifest file for that job. Saving these separately helps prevent unauthorized parties from
gaining access to the Snow device associated with that job. The credentials of a given job,
including its manifest file and unlock code, expire 360 days after the job is created.

# Arguments
- `job_id`: The ID for a job that you want to get the manifest file for, for example
  JID123e4567-e89b-12d3-a456-426655440000.

"""
function get_job_manifest(JobId; aws_config::AbstractAWSConfig=current_aws_config())
    return snowball(
        "GetJobManifest",
        Dict{String,Any}("JobId" => JobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_job_manifest(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return snowball(
        "GetJobManifest",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("JobId" => JobId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_job_unlock_code(job_id)
    get_job_unlock_code(job_id, params::Dict{String,<:Any})

Returns the UnlockCode code value for the specified job. A particular UnlockCode value can
be accessed for up to 360 days after the associated job has been created. The UnlockCode
value is a 29-character code with 25 alphanumeric characters and 4 hyphens. This code is
used to decrypt the manifest file when it is passed along with the manifest to the Snow
device through the Snowball client when the client is started for the first time. The only
valid status for calling this API is WithCustomer as the manifest and Unlock code values
are used for securing your device and should only be used when you have the device. As a
best practice, we recommend that you don't save a copy of the UnlockCode in the same
location as the manifest file for that job. Saving these separately helps prevent
unauthorized parties from gaining access to the Snow device associated with that job.

# Arguments
- `job_id`: The ID for the job that you want to get the UnlockCode value for, for example
  JID123e4567-e89b-12d3-a456-426655440000.

"""
function get_job_unlock_code(JobId; aws_config::AbstractAWSConfig=current_aws_config())
    return snowball(
        "GetJobUnlockCode",
        Dict{String,Any}("JobId" => JobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_job_unlock_code(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return snowball(
        "GetJobUnlockCode",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("JobId" => JobId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_snowball_usage()
    get_snowball_usage(params::Dict{String,<:Any})

Returns information about the Snow Family service limit for your account, and also the
number of Snow devices your account has in use. The default service limit for the number of
Snow devices that you can have at one time is 1. If you want to increase your service
limit, contact Amazon Web Services Support.

"""
function get_snowball_usage(; aws_config::AbstractAWSConfig=current_aws_config())
    return snowball(
        "GetSnowballUsage"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_snowball_usage(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return snowball(
        "GetSnowballUsage", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_software_updates(job_id)
    get_software_updates(job_id, params::Dict{String,<:Any})

Returns an Amazon S3 presigned URL for an update file associated with a specified JobId.

# Arguments
- `job_id`: The ID for a job that you want to get the software update file for, for example
  JID123e4567-e89b-12d3-a456-426655440000.

"""
function get_software_updates(JobId; aws_config::AbstractAWSConfig=current_aws_config())
    return snowball(
        "GetSoftwareUpdates",
        Dict{String,Any}("JobId" => JobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_software_updates(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return snowball(
        "GetSoftwareUpdates",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("JobId" => JobId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_cluster_jobs(cluster_id)
    list_cluster_jobs(cluster_id, params::Dict{String,<:Any})

Returns an array of JobListEntry objects of the specified length. Each JobListEntry object
is for a job in the specified cluster and contains a job's state, a job's ID, and other
information.

# Arguments
- `cluster_id`: The 39-character ID for the cluster that you want to list, for example
  CID123e4567-e89b-12d3-a456-426655440000.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The number of JobListEntry objects to return.
- `"NextToken"`: HTTP requests are stateless. To identify what object comes \"next\" in the
  list of JobListEntry objects, you have the option of specifying NextToken as the starting
  point for your returned list.
"""
function list_cluster_jobs(ClusterId; aws_config::AbstractAWSConfig=current_aws_config())
    return snowball(
        "ListClusterJobs",
        Dict{String,Any}("ClusterId" => ClusterId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_cluster_jobs(
    ClusterId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return snowball(
        "ListClusterJobs",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ClusterId" => ClusterId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_clusters()
    list_clusters(params::Dict{String,<:Any})

Returns an array of ClusterListEntry objects of the specified length. Each ClusterListEntry
object contains a cluster's state, a cluster's ID, and other important status information.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The number of ClusterListEntry objects to return.
- `"NextToken"`: HTTP requests are stateless. To identify what object comes \"next\" in the
  list of ClusterListEntry objects, you have the option of specifying NextToken as the
  starting point for your returned list.
"""
function list_clusters(; aws_config::AbstractAWSConfig=current_aws_config())
    return snowball("ListClusters"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_clusters(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return snowball(
        "ListClusters", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_compatible_images()
    list_compatible_images(params::Dict{String,<:Any})

This action returns a list of the different Amazon EC2-compatible Amazon Machine Images
(AMIs) that are owned by your Amazon Web Services accountthat would be supported for use on
a Snow device. Currently, supported AMIs are based on the Amazon Linux-2, Ubuntu 20.04 LTS
- Focal, or Ubuntu 22.04 LTS - Jammy images, available on the Amazon Web Services
Marketplace. Ubuntu 16.04 LTS - Xenial (HVM) images are no longer supported in the Market,
but still supported for use on devices through Amazon EC2 VM Import/Export and running
locally in AMIs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results for the list of compatible images.
  Currently, a Snowball Edge device can store 10 AMIs.
- `"NextToken"`: HTTP requests are stateless. To identify what object comes \"next\" in the
  list of compatible images, you can specify a value for NextToken as the starting point for
  your list of returned images.
"""
function list_compatible_images(; aws_config::AbstractAWSConfig=current_aws_config())
    return snowball(
        "ListCompatibleImages"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_compatible_images(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return snowball(
        "ListCompatibleImages",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_jobs()
    list_jobs(params::Dict{String,<:Any})

Returns an array of JobListEntry objects of the specified length. Each JobListEntry object
contains a job's state, a job's ID, and a value that indicates whether the job is a job
part, in the case of export jobs. Calling this API action in one of the US regions will
return jobs from the list of all jobs associated with this account in all US regions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The number of JobListEntry objects to return.
- `"NextToken"`: HTTP requests are stateless. To identify what object comes \"next\" in the
  list of JobListEntry objects, you have the option of specifying NextToken as the starting
  point for your returned list.
"""
function list_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return snowball("ListJobs"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return snowball(
        "ListJobs", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_long_term_pricing()
    list_long_term_pricing(params::Dict{String,<:Any})

Lists all long-term pricing types.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of ListLongTermPricing objects to return.
- `"NextToken"`: Because HTTP requests are stateless, this is the starting point for your
  next list of ListLongTermPricing to return.
"""
function list_long_term_pricing(; aws_config::AbstractAWSConfig=current_aws_config())
    return snowball(
        "ListLongTermPricing"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_long_term_pricing(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return snowball(
        "ListLongTermPricing",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_pickup_locations()
    list_pickup_locations(params::Dict{String,<:Any})

A list of locations from which the customer can choose to pickup a device.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of locations to list per page.
- `"NextToken"`: HTTP requests are stateless. To identify what object comes \"next\" in the
  list of ListPickupLocationsRequest objects, you have the option of specifying NextToken as
  the starting point for your returned list.
"""
function list_pickup_locations(; aws_config::AbstractAWSConfig=current_aws_config())
    return snowball(
        "ListPickupLocations"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_pickup_locations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return snowball(
        "ListPickupLocations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_service_versions(service_name)
    list_service_versions(service_name, params::Dict{String,<:Any})

Lists all supported versions for Snow on-device services. Returns an array of
ServiceVersion object containing the supported versions for a particular service.

# Arguments
- `service_name`: The name of the service for which you're requesting supported versions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DependentServices"`: A list of names and versions of dependant services of the
  requested service.
- `"MaxResults"`: The maximum number of ListServiceVersions objects to return.
- `"NextToken"`: Because HTTP requests are stateless, this is the starting point for the
  next list of returned ListServiceVersionsRequest versions.
"""
function list_service_versions(
    ServiceName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return snowball(
        "ListServiceVersions",
        Dict{String,Any}("ServiceName" => ServiceName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_service_versions(
    ServiceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return snowball(
        "ListServiceVersions",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ServiceName" => ServiceName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_cluster(cluster_id)
    update_cluster(cluster_id, params::Dict{String,<:Any})

While a cluster's ClusterState value is in the AwaitingQuorum state, you can update some of
the information associated with a cluster. Once the cluster changes to a different job
state, usually 60 minutes after the cluster being created, this action is no longer
available.

# Arguments
- `cluster_id`: The cluster ID of the cluster that you want to update, for example
  CID123e4567-e89b-12d3-a456-426655440000.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AddressId"`: The ID of the updated Address object.
- `"Description"`: The updated description of this cluster.
- `"ForwardingAddressId"`: The updated ID for the forwarding address for a cluster. This
  field is not supported in most regions.
- `"Notification"`: The new or updated Notification object.
- `"OnDeviceServiceConfiguration"`: Specifies the service or services on the Snow Family
  device that your transferred data will be exported from or imported into. Amazon Web
  Services Snow Family device clusters support Amazon S3 and NFS (Network File System).
- `"Resources"`: The updated arrays of JobResource objects that can include updated
  S3Resource objects or LambdaResource objects.
- `"RoleARN"`: The new role Amazon Resource Name (ARN) that you want to associate with this
  cluster. To create a role ARN, use the CreateRole API action in Identity and Access
  Management (IAM).
- `"ShippingOption"`: The updated shipping option value of this cluster's ShippingDetails
  object.
"""
function update_cluster(ClusterId; aws_config::AbstractAWSConfig=current_aws_config())
    return snowball(
        "UpdateCluster",
        Dict{String,Any}("ClusterId" => ClusterId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_cluster(
    ClusterId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return snowball(
        "UpdateCluster",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ClusterId" => ClusterId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_job(job_id)
    update_job(job_id, params::Dict{String,<:Any})

While a job's JobState value is New, you can update some of the information associated with
a job. Once the job changes to a different job state, usually within 60 minutes of the job
being created, this action is no longer available.

# Arguments
- `job_id`: The job ID of the job that you want to update, for example
  JID123e4567-e89b-12d3-a456-426655440000.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AddressId"`: The ID of the updated Address object.
- `"Description"`: The updated description of this job's JobMetadata object.
- `"ForwardingAddressId"`: The updated ID for the forwarding address for a job. This field
  is not supported in most regions.
- `"Notification"`: The new or updated Notification object.
- `"OnDeviceServiceConfiguration"`: Specifies the service or services on the Snow Family
  device that your transferred data will be exported from or imported into. Amazon Web
  Services Snow Family supports Amazon S3 and NFS (Network File System) and the Amazon Web
  Services Storage Gateway service Tape Gateway type.
- `"PickupDetails"`:
- `"Resources"`: The updated JobResource object, or the updated JobResource object.
- `"RoleARN"`: The new role Amazon Resource Name (ARN) that you want to associate with this
  job. To create a role ARN, use the CreateRoleIdentity and Access Management (IAM) API
  action.
- `"ShippingOption"`: The updated shipping option value of this job's ShippingDetails
  object.
- `"SnowballCapacityPreference"`: The updated SnowballCapacityPreference of this job's
  JobMetadata object. The 50 TB Snowballs are only available in the US regions. For more
  information, see
  \"https://docs.aws.amazon.com/snowball/latest/snowcone-guide/snow-device-types.html\" (Snow
  Family Devices and Capacity) in the Snowcone User Guide or
  \"https://docs.aws.amazon.com/snowball/latest/developer-guide/snow-device-types.html\"
  (Snow Family Devices and Capacity) in the Snowcone User Guide.
"""
function update_job(JobId; aws_config::AbstractAWSConfig=current_aws_config())
    return snowball(
        "UpdateJob",
        Dict{String,Any}("JobId" => JobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_job(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return snowball(
        "UpdateJob",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("JobId" => JobId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_job_shipment_state(job_id, shipment_state)
    update_job_shipment_state(job_id, shipment_state, params::Dict{String,<:Any})

Updates the state when a shipment state changes to a different state.

# Arguments
- `job_id`: The job ID of the job whose shipment date you want to update, for example
  JID123e4567-e89b-12d3-a456-426655440000.
- `shipment_state`: The state of a device when it is being shipped.  Set to RECEIVED when
  the device arrives at your location. Set to RETURNED when you have returned the device to
  Amazon Web Services.

"""
function update_job_shipment_state(
    JobId, ShipmentState; aws_config::AbstractAWSConfig=current_aws_config()
)
    return snowball(
        "UpdateJobShipmentState",
        Dict{String,Any}("JobId" => JobId, "ShipmentState" => ShipmentState);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_job_shipment_state(
    JobId,
    ShipmentState,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return snowball(
        "UpdateJobShipmentState",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("JobId" => JobId, "ShipmentState" => ShipmentState),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_long_term_pricing(long_term_pricing_id)
    update_long_term_pricing(long_term_pricing_id, params::Dict{String,<:Any})

Updates the long-term pricing type.

# Arguments
- `long_term_pricing_id`: The ID of the long-term pricing type for the device.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"IsLongTermPricingAutoRenew"`: If set to true, specifies that the current long-term
  pricing type for the device should be automatically renewed before the long-term pricing
  contract expires.
- `"ReplacementJob"`: Specifies that a device that is ordered with long-term pricing should
  be replaced with a new device.
"""
function update_long_term_pricing(
    LongTermPricingId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return snowball(
        "UpdateLongTermPricing",
        Dict{String,Any}("LongTermPricingId" => LongTermPricingId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_long_term_pricing(
    LongTermPricingId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return snowball(
        "UpdateLongTermPricing",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("LongTermPricingId" => LongTermPricingId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: launch_wizard
using AWS.Compat
using AWS.UUIDs

"""
    create_deployment(deployment_pattern_name, name, specifications, workload_name)
    create_deployment(deployment_pattern_name, name, specifications, workload_name, params::Dict{String,<:Any})

Creates a deployment for the given workload. Deployments created by this operation are not
available in the Launch Wizard console to use the Clone deployment action on.

# Arguments
- `deployment_pattern_name`: The name of the deployment pattern supported by a given
  workload. You can use the  ListWorkloadDeploymentPatterns  operation to discover supported
  values for this parameter.
- `name`: The name of the deployment.
- `specifications`: The settings specified for the deployment. These settings define how to
  deploy and configure your resources created by the deployment. For more information about
  the specifications required for creating a deployment for a SAP workload, see SAP
  deployment specifications. To retrieve the specifications required to create a deployment
  for other workloads, use the  GetWorkloadDeploymentPattern  operation.
- `workload_name`: The name of the workload. You can use the  ListWorkloads  operation to
  discover supported values for this parameter.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"dryRun"`: Checks whether you have the required permissions for the action, without
  actually making the request, and provides an error response. If you have the required
  permissions, the error response is DryRunOperation. Otherwise, it is UnauthorizedOperation.
- `"tags"`: The tags to add to the deployment.
"""
function create_deployment(
    deploymentPatternName,
    name,
    specifications,
    workloadName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return launch_wizard(
        "POST",
        "/createDeployment",
        Dict{String,Any}(
            "deploymentPatternName" => deploymentPatternName,
            "name" => name,
            "specifications" => specifications,
            "workloadName" => workloadName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_deployment(
    deploymentPatternName,
    name,
    specifications,
    workloadName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return launch_wizard(
        "POST",
        "/createDeployment",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "deploymentPatternName" => deploymentPatternName,
                    "name" => name,
                    "specifications" => specifications,
                    "workloadName" => workloadName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_deployment(deployment_id)
    delete_deployment(deployment_id, params::Dict{String,<:Any})

Deletes a deployment.

# Arguments
- `deployment_id`: The ID of the deployment.

"""
function delete_deployment(deploymentId; aws_config::AbstractAWSConfig=current_aws_config())
    return launch_wizard(
        "POST",
        "/deleteDeployment",
        Dict{String,Any}("deploymentId" => deploymentId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_deployment(
    deploymentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return launch_wizard(
        "POST",
        "/deleteDeployment",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("deploymentId" => deploymentId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_deployment(deployment_id)
    get_deployment(deployment_id, params::Dict{String,<:Any})

Returns information about the deployment.

# Arguments
- `deployment_id`: The ID of the deployment.

"""
function get_deployment(deploymentId; aws_config::AbstractAWSConfig=current_aws_config())
    return launch_wizard(
        "POST",
        "/getDeployment",
        Dict{String,Any}("deploymentId" => deploymentId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_deployment(
    deploymentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return launch_wizard(
        "POST",
        "/getDeployment",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("deploymentId" => deploymentId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_workload(workload_name)
    get_workload(workload_name, params::Dict{String,<:Any})

Returns information about a workload.

# Arguments
- `workload_name`: The name of the workload.

"""
function get_workload(workloadName; aws_config::AbstractAWSConfig=current_aws_config())
    return launch_wizard(
        "POST",
        "/getWorkload",
        Dict{String,Any}("workloadName" => workloadName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_workload(
    workloadName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return launch_wizard(
        "POST",
        "/getWorkload",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("workloadName" => workloadName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_workload_deployment_pattern(deployment_pattern_name, workload_name)
    get_workload_deployment_pattern(deployment_pattern_name, workload_name, params::Dict{String,<:Any})

Returns details for a given workload and deployment pattern, including the available
specifications. You can use the ListWorkloads operation to discover the available workload
names and the ListWorkloadDeploymentPatterns operation to discover the available deployment
pattern names of a given workload.

# Arguments
- `deployment_pattern_name`: The name of the deployment pattern.
- `workload_name`: The name of the workload.

"""
function get_workload_deployment_pattern(
    deploymentPatternName, workloadName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return launch_wizard(
        "POST",
        "/getWorkloadDeploymentPattern",
        Dict{String,Any}(
            "deploymentPatternName" => deploymentPatternName, "workloadName" => workloadName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_workload_deployment_pattern(
    deploymentPatternName,
    workloadName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return launch_wizard(
        "POST",
        "/getWorkloadDeploymentPattern",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "deploymentPatternName" => deploymentPatternName,
                    "workloadName" => workloadName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_deployment_events(deployment_id)
    list_deployment_events(deployment_id, params::Dict{String,<:Any})

Lists the events of a deployment.

# Arguments
- `deployment_id`: The ID of the deployment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of items to return for this request. To get the next
  page of items, make another request with the token returned in the output.
- `"nextToken"`: The token returned from a previous paginated request. Pagination continues
  from the end of the items returned by the previous request.
"""
function list_deployment_events(
    deploymentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return launch_wizard(
        "POST",
        "/listDeploymentEvents",
        Dict{String,Any}("deploymentId" => deploymentId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_deployment_events(
    deploymentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return launch_wizard(
        "POST",
        "/listDeploymentEvents",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("deploymentId" => deploymentId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_deployments()
    list_deployments(params::Dict{String,<:Any})

Lists the deployments that have been created.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: Filters to scope the results. The following filters are supported:
  WORKLOAD_NAME - The name used in deployments.    DEPLOYMENT_STATUS - COMPLETED | CREATING |
  DELETE_IN_PROGRESS | DELETE_INITIATING | DELETE_FAILED | DELETED | FAILED | IN_PROGRESS |
  VALIDATING
- `"maxResults"`: The maximum number of items to return for this request. To get the next
  page of items, make another request with the token returned in the output.
- `"nextToken"`: The token returned from a previous paginated request. Pagination continues
  from the end of the items returned by the previous request.
"""
function list_deployments(; aws_config::AbstractAWSConfig=current_aws_config())
    return launch_wizard(
        "POST", "/listDeployments"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_deployments(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return launch_wizard(
        "POST",
        "/listDeployments",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists the tags associated with a specified resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return launch_wizard(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return launch_wizard(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_workload_deployment_patterns(workload_name)
    list_workload_deployment_patterns(workload_name, params::Dict{String,<:Any})

Lists the workload deployment patterns for a given workload name. You can use the
ListWorkloads operation to discover the available workload names.

# Arguments
- `workload_name`: The name of the workload.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of items to return for this request. To get the next
  page of items, make another request with the token returned in the output.
- `"nextToken"`: The token returned from a previous paginated request. Pagination continues
  from the end of the items returned by the previous request.
"""
function list_workload_deployment_patterns(
    workloadName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return launch_wizard(
        "POST",
        "/listWorkloadDeploymentPatterns",
        Dict{String,Any}("workloadName" => workloadName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_workload_deployment_patterns(
    workloadName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return launch_wizard(
        "POST",
        "/listWorkloadDeploymentPatterns",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("workloadName" => workloadName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_workloads()
    list_workloads(params::Dict{String,<:Any})

Lists the available workload names. You can use the ListWorkloadDeploymentPatterns
operation to discover the available deployment patterns for a given workload.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of items to return for this request. To get the next
  page of items, make another request with the token returned in the output.
- `"nextToken"`: The token returned from a previous paginated request. Pagination continues
  from the end of the items returned by the previous request.
"""
function list_workloads(; aws_config::AbstractAWSConfig=current_aws_config())
    return launch_wizard(
        "POST", "/listWorkloads"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_workloads(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return launch_wizard(
        "POST",
        "/listWorkloads",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds the specified tags to the given resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.
- `tags`: One or more tags to attach to the resource.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return launch_wizard(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return launch_wizard(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes the specified tags from the given resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.
- `tag_keys`: Keys identifying the tags to remove.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return launch_wizard(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return launch_wizard(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: datasync
using AWS.Compat
using AWS.UUIDs

"""
    add_storage_system(agent_arns, client_token, credentials, server_configuration, system_type)
    add_storage_system(agent_arns, client_token, credentials, server_configuration, system_type, params::Dict{String,<:Any})

Creates an Amazon Web Services resource for an on-premises storage system that you want
DataSync Discovery to collect information about.

# Arguments
- `agent_arns`: Specifies the Amazon Resource Name (ARN) of the DataSync agent that
  connects to and reads from your on-premises storage system's management interface. You can
  only specify one ARN.
- `client_token`: Specifies a client token to make sure requests with this API operation
  are idempotent. If you don't specify a client token, DataSync generates one for you
  automatically.
- `credentials`: Specifies the user name and password for accessing your on-premises
  storage system's management interface.
- `server_configuration`: Specifies the server name and network port required to connect
  with the management interface of your on-premises storage system.
- `system_type`: Specifies the type of on-premises storage system that you want DataSync
  Discovery to collect information about.  DataSync Discovery currently supports NetApp
  Fabric-Attached Storage (FAS) and All Flash FAS (AFF) systems running ONTAP 9.7 or later.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CloudWatchLogGroupArn"`: Specifies the ARN of the Amazon CloudWatch log group for
  monitoring and logging discovery job events.
- `"Name"`: Specifies a familiar name for your on-premises storage system.
- `"Tags"`: Specifies labels that help you categorize, filter, and search for your Amazon
  Web Services resources. We recommend creating at least a name tag for your on-premises
  storage system.
"""
function add_storage_system(
    AgentArns,
    ClientToken,
    Credentials,
    ServerConfiguration,
    SystemType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "AddStorageSystem",
        Dict{String,Any}(
            "AgentArns" => AgentArns,
            "ClientToken" => ClientToken,
            "Credentials" => Credentials,
            "ServerConfiguration" => ServerConfiguration,
            "SystemType" => SystemType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_storage_system(
    AgentArns,
    ClientToken,
    Credentials,
    ServerConfiguration,
    SystemType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "AddStorageSystem",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AgentArns" => AgentArns,
                    "ClientToken" => ClientToken,
                    "Credentials" => Credentials,
                    "ServerConfiguration" => ServerConfiguration,
                    "SystemType" => SystemType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_task_execution(task_execution_arn)
    cancel_task_execution(task_execution_arn, params::Dict{String,<:Any})

Stops an DataSync task execution that's in progress. The transfer of some files are
abruptly interrupted. File contents that're transferred to the destination might be
incomplete or inconsistent with the source files. However, if you start a new task
execution using the same task and allow it to finish, file content on the destination will
be complete and consistent. This applies to other unexpected failures that interrupt a task
execution. In all of these cases, DataSync successfully completes the transfer when you
start the next task execution.

# Arguments
- `task_execution_arn`: The Amazon Resource Name (ARN) of the task execution to stop.

"""
function cancel_task_execution(
    TaskExecutionArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datasync(
        "CancelTaskExecution",
        Dict{String,Any}("TaskExecutionArn" => TaskExecutionArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_task_execution(
    TaskExecutionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "CancelTaskExecution",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("TaskExecutionArn" => TaskExecutionArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_agent(activation_key)
    create_agent(activation_key, params::Dict{String,<:Any})

Activates an DataSync agent that you've deployed in your storage environment. The
activation process associates the agent with your Amazon Web Services account. If you
haven't deployed an agent yet, see the following topics to learn more:    Agent
requirements     Create an agent     If you're transferring between Amazon Web Services
storage services, you don't need a DataSync agent.

# Arguments
- `activation_key`: Specifies your DataSync agent's activation key. If you don't have an
  activation key, see Activate your agent.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AgentName"`: Specifies a name for your agent. You can see this name in the DataSync
  console.
- `"SecurityGroupArns"`: Specifies the Amazon Resource Name (ARN) of the security group
  that protects your task's network interfaces when using a virtual private cloud (VPC)
  endpoint. You can only specify one ARN.
- `"SubnetArns"`: Specifies the ARN of the subnet where you want to run your DataSync task
  when using a VPC endpoint. This is the subnet where DataSync creates and manages the
  network interfaces for your transfer. You can only specify one ARN.
- `"Tags"`: Specifies labels that help you categorize, filter, and search for your Amazon
  Web Services resources. We recommend creating at least one tag for your agent.
- `"VpcEndpointId"`: Specifies the ID of the VPC endpoint that you want your agent to
  connect to. For example, a VPC endpoint ID looks like vpce-01234d5aff67890e1.  The VPC
  endpoint you use must include the DataSync service name (for example,
  com.amazonaws.us-east-2.datasync).
"""
function create_agent(ActivationKey; aws_config::AbstractAWSConfig=current_aws_config())
    return datasync(
        "CreateAgent",
        Dict{String,Any}("ActivationKey" => ActivationKey);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_agent(
    ActivationKey,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "CreateAgent",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ActivationKey" => ActivationKey), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_location_azure_blob(agent_arns, authentication_type, container_url)
    create_location_azure_blob(agent_arns, authentication_type, container_url, params::Dict{String,<:Any})

Creates a transfer location for a Microsoft Azure Blob Storage container. DataSync can use
this location as a transfer source or destination. Before you begin, make sure you know how
DataSync accesses Azure Blob Storage and works with access tiers and blob types. You also
need a DataSync agent that can connect to your container.

# Arguments
- `agent_arns`: Specifies the Amazon Resource Name (ARN) of the DataSync agent that can
  connect with your Azure Blob Storage container. You can specify more than one agent. For
  more information, see Using multiple agents for your transfer.
- `authentication_type`: Specifies the authentication method DataSync uses to access your
  Azure Blob Storage. DataSync can access blob storage using a shared access signature (SAS).
- `container_url`: Specifies the URL of the Azure Blob Storage container involved in your
  transfer.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccessTier"`: Specifies the access tier that you want your objects or files transferred
  into. This only applies when using the location as a transfer destination. For more
  information, see Access tiers.
- `"BlobType"`: Specifies the type of blob that you want your objects or files to be when
  transferring them into Azure Blob Storage. Currently, DataSync only supports moving data
  into Azure Blob Storage as block blobs. For more information on blob types, see the Azure
  Blob Storage documentation.
- `"SasConfiguration"`: Specifies the SAS configuration that allows DataSync to access your
  Azure Blob Storage.
- `"Subdirectory"`: Specifies path segments if you want to limit your transfer to a virtual
  directory in your container (for example, /my/images).
- `"Tags"`: Specifies labels that help you categorize, filter, and search for your Amazon
  Web Services resources. We recommend creating at least a name tag for your transfer
  location.
"""
function create_location_azure_blob(
    AgentArns,
    AuthenticationType,
    ContainerUrl;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "CreateLocationAzureBlob",
        Dict{String,Any}(
            "AgentArns" => AgentArns,
            "AuthenticationType" => AuthenticationType,
            "ContainerUrl" => ContainerUrl,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_location_azure_blob(
    AgentArns,
    AuthenticationType,
    ContainerUrl,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "CreateLocationAzureBlob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AgentArns" => AgentArns,
                    "AuthenticationType" => AuthenticationType,
                    "ContainerUrl" => ContainerUrl,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_location_efs(ec2_config, efs_filesystem_arn)
    create_location_efs(ec2_config, efs_filesystem_arn, params::Dict{String,<:Any})

Creates a transfer location for an Amazon EFS file system. DataSync can use this location
as a source or destination for transferring data. Before you begin, make sure that you
understand how DataSync accesses Amazon EFS file systems.

# Arguments
- `ec2_config`: Specifies the subnet and security groups DataSync uses to access your
  Amazon EFS file system.
- `efs_filesystem_arn`: Specifies the ARN for the Amazon EFS file system.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccessPointArn"`: Specifies the Amazon Resource Name (ARN) of the access point that
  DataSync uses to access the Amazon EFS file system.
- `"FileSystemAccessRoleArn"`: Specifies an Identity and Access Management (IAM) role that
  DataSync assumes when mounting the Amazon EFS file system.
- `"InTransitEncryption"`: Specifies whether you want DataSync to use Transport Layer
  Security (TLS) 1.2 encryption when it copies data to or from the Amazon EFS file system. If
  you specify an access point using AccessPointArn or an IAM role using
  FileSystemAccessRoleArn, you must set this parameter to TLS1_2.
- `"Subdirectory"`: Specifies a mount path for your Amazon EFS file system. This is where
  DataSync reads or writes data (depending on if this is a source or destination location).
  By default, DataSync uses the root directory, but you can also include subdirectories.  You
  must specify a value with forward slashes (for example, /path/to/folder).
- `"Tags"`: Specifies the key-value pair that represents a tag that you want to add to the
  resource. The value can be an empty string. This value helps you manage, filter, and search
  for your resources. We recommend that you create a name tag for your location.
"""
function create_location_efs(
    Ec2Config, EfsFilesystemArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datasync(
        "CreateLocationEfs",
        Dict{String,Any}("Ec2Config" => Ec2Config, "EfsFilesystemArn" => EfsFilesystemArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_location_efs(
    Ec2Config,
    EfsFilesystemArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "CreateLocationEfs",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Ec2Config" => Ec2Config, "EfsFilesystemArn" => EfsFilesystemArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_location_fsx_lustre(fsx_filesystem_arn, security_group_arns)
    create_location_fsx_lustre(fsx_filesystem_arn, security_group_arns, params::Dict{String,<:Any})

Creates a transfer location for an Amazon FSx for Lustre file system. DataSync can use this
location as a source or destination for transferring data. Before you begin, make sure that
you understand how DataSync accesses FSx for Lustre file systems.

# Arguments
- `fsx_filesystem_arn`: The Amazon Resource Name (ARN) for the FSx for Lustre file system.
- `security_group_arns`: The Amazon Resource Names (ARNs) of the security groups that are
  used to configure the FSx for Lustre file system.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Subdirectory"`: A subdirectory in the location's path. This subdirectory in the FSx for
  Lustre file system is used to read data from the FSx for Lustre source location or write
  data to the FSx for Lustre destination.
- `"Tags"`: The key-value pair that represents a tag that you want to add to the resource.
  The value can be an empty string. This value helps you manage, filter, and search for your
  resources. We recommend that you create a name tag for your location.
"""
function create_location_fsx_lustre(
    FsxFilesystemArn, SecurityGroupArns; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datasync(
        "CreateLocationFsxLustre",
        Dict{String,Any}(
            "FsxFilesystemArn" => FsxFilesystemArn, "SecurityGroupArns" => SecurityGroupArns
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_location_fsx_lustre(
    FsxFilesystemArn,
    SecurityGroupArns,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "CreateLocationFsxLustre",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "FsxFilesystemArn" => FsxFilesystemArn,
                    "SecurityGroupArns" => SecurityGroupArns,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_location_fsx_ontap(protocol, security_group_arns, storage_virtual_machine_arn)
    create_location_fsx_ontap(protocol, security_group_arns, storage_virtual_machine_arn, params::Dict{String,<:Any})

Creates a transfer location for an Amazon FSx for NetApp ONTAP file system. DataSync can
use this location as a source or destination for transferring data. Before you begin, make
sure that you understand how DataSync accesses FSx for ONTAP file systems.

# Arguments
- `protocol`:
- `security_group_arns`: Specifies the Amazon EC2 security groups that provide access to
  your file system's preferred subnet. The security groups must allow outbound traffic on the
  following ports (depending on the protocol you use):    Network File System (NFS): TCP
  ports 111, 635, and 2049    Server Message Block (SMB): TCP port 445   Your file system's
  security groups must also allow inbound traffic on the same ports.
- `storage_virtual_machine_arn`: Specifies the ARN of the storage virtual machine (SVM) in
  your file system where you want to copy data to or from.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Subdirectory"`: Specifies a path to the file share in the SVM where you'll copy your
  data. You can specify a junction path (also known as a mount point), qtree path (for NFS
  file shares), or share name (for SMB file shares). For example, your mount path might be
  /vol1, /vol1/tree1, or /share1.  Don't specify a junction path in the SVM's root volume.
  For more information, see Managing FSx for ONTAP storage virtual machines in the Amazon FSx
  for NetApp ONTAP User Guide.
- `"Tags"`: Specifies labels that help you categorize, filter, and search for your Amazon
  Web Services resources. We recommend creating at least a name tag for your location.
"""
function create_location_fsx_ontap(
    Protocol,
    SecurityGroupArns,
    StorageVirtualMachineArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "CreateLocationFsxOntap",
        Dict{String,Any}(
            "Protocol" => Protocol,
            "SecurityGroupArns" => SecurityGroupArns,
            "StorageVirtualMachineArn" => StorageVirtualMachineArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_location_fsx_ontap(
    Protocol,
    SecurityGroupArns,
    StorageVirtualMachineArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "CreateLocationFsxOntap",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Protocol" => Protocol,
                    "SecurityGroupArns" => SecurityGroupArns,
                    "StorageVirtualMachineArn" => StorageVirtualMachineArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_location_fsx_open_zfs(fsx_filesystem_arn, protocol, security_group_arns)
    create_location_fsx_open_zfs(fsx_filesystem_arn, protocol, security_group_arns, params::Dict{String,<:Any})

Creates a transfer location for an Amazon FSx for OpenZFS file system. DataSync can use
this location as a source or destination for transferring data. Before you begin, make sure
that you understand how DataSync accesses FSx for OpenZFS file systems.  Request parameters
related to SMB aren't supported with the CreateLocationFsxOpenZfs operation.

# Arguments
- `fsx_filesystem_arn`: The Amazon Resource Name (ARN) of the FSx for OpenZFS file system.
- `protocol`: The type of protocol that DataSync uses to access your file system.
- `security_group_arns`: The ARNs of the security groups that are used to configure the FSx
  for OpenZFS file system.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Subdirectory"`: A subdirectory in the location's path that must begin with /fsx.
  DataSync uses this subdirectory to read or write data (depending on whether the file system
  is a source or destination location).
- `"Tags"`: The key-value pair that represents a tag that you want to add to the resource.
  The value can be an empty string. This value helps you manage, filter, and search for your
  resources. We recommend that you create a name tag for your location.
"""
function create_location_fsx_open_zfs(
    FsxFilesystemArn,
    Protocol,
    SecurityGroupArns;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "CreateLocationFsxOpenZfs",
        Dict{String,Any}(
            "FsxFilesystemArn" => FsxFilesystemArn,
            "Protocol" => Protocol,
            "SecurityGroupArns" => SecurityGroupArns,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_location_fsx_open_zfs(
    FsxFilesystemArn,
    Protocol,
    SecurityGroupArns,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "CreateLocationFsxOpenZfs",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "FsxFilesystemArn" => FsxFilesystemArn,
                    "Protocol" => Protocol,
                    "SecurityGroupArns" => SecurityGroupArns,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_location_fsx_windows(fsx_filesystem_arn, password, security_group_arns, user)
    create_location_fsx_windows(fsx_filesystem_arn, password, security_group_arns, user, params::Dict{String,<:Any})

Creates a transfer location for an Amazon FSx for Windows File Server file system. DataSync
can use this location as a source or destination for transferring data. Before you begin,
make sure that you understand how DataSync accesses FSx for Windows File Server file
systems.

# Arguments
- `fsx_filesystem_arn`: Specifies the Amazon Resource Name (ARN) for the FSx for Windows
  File Server file system.
- `password`: Specifies the password of the user with the permissions to mount and access
  the files, folders, and file metadata in your FSx for Windows File Server file system.
- `security_group_arns`: Specifies the ARNs of the security groups that provide access to
  your file system's preferred subnet.  If you choose a security group that doesn't allow
  connections from within itself, do one of the following:   Configure the security group to
  allow it to communicate within itself.   Choose a different security group that can
  communicate with the mount target's security group.
- `user`: Specifies the user with the permissions to mount and access the files, folders,
  and file metadata in your FSx for Windows File Server file system. For information about
  choosing a user with the right level of access for your transfer, see required permissions
  for FSx for Windows File Server locations.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Domain"`: Specifies the name of the Microsoft Active Directory domain that the FSx for
  Windows File Server file system belongs to. If you have multiple Active Directory domains
  in your environment, configuring this parameter makes sure that DataSync connects to the
  right file system.
- `"Subdirectory"`: Specifies a mount path for your file system using forward slashes. This
  is where DataSync reads or writes data (depending on if this is a source or destination
  location).
- `"Tags"`: Specifies labels that help you categorize, filter, and search for your Amazon
  Web Services resources. We recommend creating at least a name tag for your location.
"""
function create_location_fsx_windows(
    FsxFilesystemArn,
    Password,
    SecurityGroupArns,
    User;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "CreateLocationFsxWindows",
        Dict{String,Any}(
            "FsxFilesystemArn" => FsxFilesystemArn,
            "Password" => Password,
            "SecurityGroupArns" => SecurityGroupArns,
            "User" => User,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_location_fsx_windows(
    FsxFilesystemArn,
    Password,
    SecurityGroupArns,
    User,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "CreateLocationFsxWindows",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "FsxFilesystemArn" => FsxFilesystemArn,
                    "Password" => Password,
                    "SecurityGroupArns" => SecurityGroupArns,
                    "User" => User,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_location_hdfs(agent_arns, authentication_type, name_nodes)
    create_location_hdfs(agent_arns, authentication_type, name_nodes, params::Dict{String,<:Any})

Creates a transfer location for a Hadoop Distributed File System (HDFS). DataSync can use
this location as a source or destination for transferring data. Before you begin, make sure
that you understand how DataSync accesses HDFS clusters.

# Arguments
- `agent_arns`: The Amazon Resource Names (ARNs) of the agents that are used to connect to
  the HDFS cluster.
- `authentication_type`: The type of authentication used to determine the identity of the
  user.
- `name_nodes`: The NameNode that manages the HDFS namespace. The NameNode performs
  operations such as opening, closing, and renaming files and directories. The NameNode
  contains the information to map blocks of data to the DataNodes. You can use only one
  NameNode.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"BlockSize"`: The size of data blocks to write into the HDFS cluster. The block size
  must be a multiple of 512 bytes. The default block size is 128 mebibytes (MiB).
- `"KerberosKeytab"`: The Kerberos key table (keytab) that contains mappings between the
  defined Kerberos principal and the encrypted keys. You can load the keytab from a file by
  providing the file's address. If you're using the CLI, it performs base64 encoding for you.
  Otherwise, provide the base64-encoded text.   If KERBEROS is specified for
  AuthenticationType, this parameter is required.
- `"KerberosKrb5Conf"`: The krb5.conf file that contains the Kerberos configuration
  information. You can load the krb5.conf file by providing the file's address. If you're
  using the CLI, it performs the base64 encoding for you. Otherwise, provide the
  base64-encoded text.   If KERBEROS is specified for AuthenticationType, this parameter is
  required.
- `"KerberosPrincipal"`: The Kerberos principal with access to the files and folders on the
  HDFS cluster.   If KERBEROS is specified for AuthenticationType, this parameter is
  required.
- `"KmsKeyProviderUri"`: The URI of the HDFS cluster's Key Management Server (KMS).
- `"QopConfiguration"`: The Quality of Protection (QOP) configuration specifies the Remote
  Procedure Call (RPC) and data transfer protection settings configured on the Hadoop
  Distributed File System (HDFS) cluster. If QopConfiguration isn't specified, RpcProtection
  and DataTransferProtection default to PRIVACY. If you set RpcProtection or
  DataTransferProtection, the other parameter assumes the same value.
- `"ReplicationFactor"`: The number of DataNodes to replicate the data to when writing to
  the HDFS cluster. By default, data is replicated to three DataNodes.
- `"SimpleUser"`: The user name used to identify the client on the host operating system.
  If SIMPLE is specified for AuthenticationType, this parameter is required.
- `"Subdirectory"`: A subdirectory in the HDFS cluster. This subdirectory is used to read
  data from or write data to the HDFS cluster. If the subdirectory isn't specified, it will
  default to /.
- `"Tags"`: The key-value pair that represents the tag that you want to add to the
  location. The value can be an empty string. We recommend using tags to name your resources.
"""
function create_location_hdfs(
    AgentArns,
    AuthenticationType,
    NameNodes;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "CreateLocationHdfs",
        Dict{String,Any}(
            "AgentArns" => AgentArns,
            "AuthenticationType" => AuthenticationType,
            "NameNodes" => NameNodes,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_location_hdfs(
    AgentArns,
    AuthenticationType,
    NameNodes,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "CreateLocationHdfs",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AgentArns" => AgentArns,
                    "AuthenticationType" => AuthenticationType,
                    "NameNodes" => NameNodes,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_location_nfs(on_prem_config, server_hostname, subdirectory)
    create_location_nfs(on_prem_config, server_hostname, subdirectory, params::Dict{String,<:Any})

Creates a transfer location for a Network File System (NFS) file server. DataSync can use
this location as a source or destination for transferring data. Before you begin, make sure
that you understand how DataSync accesses NFS file servers.  If you're copying data to or
from an Snowcone device, you can also use CreateLocationNfs to create your transfer
location. For more information, see Configuring transfers with Snowcone.

# Arguments
- `on_prem_config`: Specifies the Amazon Resource Name (ARN) of the DataSync agent that
  want to connect to your NFS file server. You can specify more than one agent. For more
  information, see Using multiple agents for transfers.
- `server_hostname`: Specifies the Domain Name System (DNS) name or IP version 4 address of
  the NFS file server that your DataSync agent connects to.
- `subdirectory`: Specifies the export path in your NFS file server that you want DataSync
  to mount. This path (or a subdirectory of the path) is where DataSync transfers data to or
  from. For information on configuring an export for DataSync, see Accessing NFS file servers.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MountOptions"`: Specifies the options that DataSync can use to mount your NFS file
  server.
- `"Tags"`: Specifies labels that help you categorize, filter, and search for your Amazon
  Web Services resources. We recommend creating at least a name tag for your location.
"""
function create_location_nfs(
    OnPremConfig,
    ServerHostname,
    Subdirectory;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "CreateLocationNfs",
        Dict{String,Any}(
            "OnPremConfig" => OnPremConfig,
            "ServerHostname" => ServerHostname,
            "Subdirectory" => Subdirectory,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_location_nfs(
    OnPremConfig,
    ServerHostname,
    Subdirectory,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "CreateLocationNfs",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "OnPremConfig" => OnPremConfig,
                    "ServerHostname" => ServerHostname,
                    "Subdirectory" => Subdirectory,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_location_object_storage(agent_arns, bucket_name, server_hostname)
    create_location_object_storage(agent_arns, bucket_name, server_hostname, params::Dict{String,<:Any})

Creates a transfer location for an object storage system. DataSync can use this location as
a source or destination for transferring data. Before you begin, make sure that you
understand the prerequisites for DataSync to work with object storage systems.

# Arguments
- `agent_arns`: Specifies the Amazon Resource Names (ARNs) of the DataSync agents that can
  securely connect with your location.
- `bucket_name`: Specifies the name of the object storage bucket involved in the transfer.
- `server_hostname`: Specifies the domain name or IP address of the object storage server.
  A DataSync agent uses this hostname to mount the object storage server in a network.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccessKey"`: Specifies the access key (for example, a user name) if credentials are
  required to authenticate with the object storage server.
- `"SecretKey"`: Specifies the secret key (for example, a password) if credentials are
  required to authenticate with the object storage server.
- `"ServerCertificate"`: Specifies a certificate chain for DataSync to authenticate with
  your object storage system if the system uses a private or self-signed certificate
  authority (CA). You must specify a single .pem file with a full certificate chain (for
  example, file:///home/user/.ssh/object_storage_certificates.pem). The certificate chain
  might include:   The object storage system's certificate   All intermediate certificates
  (if there are any)   The root certificate of the signing CA   You can concatenate your
  certificates into a .pem file (which can be up to 32768 bytes before base64 encoding). The
  following example cat command creates an object_storage_certificates.pem file that includes
  three certificates:  cat object_server_certificate.pem intermediate_certificate.pem
  ca_root_certificate.pem &gt; object_storage_certificates.pem  To use this parameter,
  configure ServerProtocol to HTTPS.
- `"ServerPort"`: Specifies the port that your object storage server accepts inbound
  network traffic on (for example, port 443).
- `"ServerProtocol"`: Specifies the protocol that your object storage server uses to
  communicate.
- `"Subdirectory"`: Specifies the object prefix for your object storage server. If this is
  a source location, DataSync only copies objects with this prefix. If this is a destination
  location, DataSync writes all objects with this prefix.
- `"Tags"`: Specifies the key-value pair that represents a tag that you want to add to the
  resource. Tags can help you manage, filter, and search for your resources. We recommend
  creating a name tag for your location.
"""
function create_location_object_storage(
    AgentArns,
    BucketName,
    ServerHostname;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "CreateLocationObjectStorage",
        Dict{String,Any}(
            "AgentArns" => AgentArns,
            "BucketName" => BucketName,
            "ServerHostname" => ServerHostname,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_location_object_storage(
    AgentArns,
    BucketName,
    ServerHostname,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "CreateLocationObjectStorage",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AgentArns" => AgentArns,
                    "BucketName" => BucketName,
                    "ServerHostname" => ServerHostname,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_location_s3(s3_bucket_arn, s3_config)
    create_location_s3(s3_bucket_arn, s3_config, params::Dict{String,<:Any})

Creates a transfer location for an Amazon S3 bucket. DataSync can use this location as a
source or destination for transferring data.  Before you begin, make sure that you read the
following topics:    Storage class considerations with Amazon S3 locations     Evaluating
S3 request costs when using DataSync      For more information, see Configuring transfers
with Amazon S3.

# Arguments
- `s3_bucket_arn`: Specifies the ARN of the S3 bucket that you want to use as a location.
  (When creating your DataSync task later, you specify whether this location is a transfer
  source or destination.)  If your S3 bucket is located on an Outposts resource, you must
  specify an Amazon S3 access point. For more information, see Managing data access with
  Amazon S3 access points in the Amazon S3 User Guide.
- `s3_config`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AgentArns"`: (Amazon S3 on Outposts only) Specifies the Amazon Resource Name (ARN) of
  the DataSync agent on your Outpost. For more information, see Deploy your DataSync agent on
  Outposts.
- `"S3StorageClass"`: Specifies the storage class that you want your objects to use when
  Amazon S3 is a transfer destination. For buckets in Amazon Web Services Regions, the
  storage class defaults to STANDARD. For buckets on Outposts, the storage class defaults to
  OUTPOSTS. For more information, see Storage class considerations with Amazon S3 transfers.
- `"Subdirectory"`: Specifies a prefix in the S3 bucket that DataSync reads from or writes
  to (depending on whether the bucket is a source or destination location).  DataSync can't
  transfer objects with a prefix that begins with a slash (/) or includes //, /./, or /../
  patterns. For example:    /photos     photos//2006/January     photos/./2006/February
  photos/../2006/March
- `"Tags"`: Specifies labels that help you categorize, filter, and search for your Amazon
  Web Services resources. We recommend creating at least a name tag for your transfer
  location.
"""
function create_location_s3(
    S3BucketArn, S3Config; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datasync(
        "CreateLocationS3",
        Dict{String,Any}("S3BucketArn" => S3BucketArn, "S3Config" => S3Config);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_location_s3(
    S3BucketArn,
    S3Config,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "CreateLocationS3",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("S3BucketArn" => S3BucketArn, "S3Config" => S3Config),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_location_smb(agent_arns, password, server_hostname, subdirectory, user)
    create_location_smb(agent_arns, password, server_hostname, subdirectory, user, params::Dict{String,<:Any})

Creates a transfer location for a Server Message Block (SMB) file server. DataSync can use
this location as a source or destination for transferring data. Before you begin, make sure
that you understand how DataSync accesses SMB file servers.

# Arguments
- `agent_arns`: Specifies the DataSync agent (or agents) which you want to connect to your
  SMB file server. You specify an agent by using its Amazon Resource Name (ARN).
- `password`: Specifies the password of the user who can mount your SMB file server and has
  permission to access the files and folders involved in your transfer. For more information,
  see required permissions for SMB locations.
- `server_hostname`: Specifies the Domain Name Service (DNS) name or IP address of the SMB
  file server that your DataSync agent will mount.  You can't specify an IP version 6 (IPv6)
  address.
- `subdirectory`: Specifies the name of the share exported by your SMB file server where
  DataSync will read or write data. You can include a subdirectory in the share path (for
  example, /path/to/subdirectory). Make sure that other SMB clients in your network can also
  mount this path. To copy all data in the subdirectory, DataSync must be able to mount the
  SMB share and access all of its data. For more information, see required permissions for
  SMB locations.
- `user`: Specifies the user that can mount and access the files, folders, and file
  metadata in your SMB file server. For information about choosing a user with the right
  level of access for your transfer, see required permissions for SMB locations.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Domain"`: Specifies the name of the Active Directory domain that your SMB file server
  belongs to.  If you have multiple Active Directory domains in your environment, configuring
  this parameter makes sure that DataSync connects to the right file server.
- `"MountOptions"`: Specifies the version of the SMB protocol that DataSync uses to access
  your SMB file server.
- `"Tags"`: Specifies labels that help you categorize, filter, and search for your Amazon
  Web Services resources. We recommend creating at least a name tag for your location.
"""
function create_location_smb(
    AgentArns,
    Password,
    ServerHostname,
    Subdirectory,
    User;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "CreateLocationSmb",
        Dict{String,Any}(
            "AgentArns" => AgentArns,
            "Password" => Password,
            "ServerHostname" => ServerHostname,
            "Subdirectory" => Subdirectory,
            "User" => User,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_location_smb(
    AgentArns,
    Password,
    ServerHostname,
    Subdirectory,
    User,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "CreateLocationSmb",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AgentArns" => AgentArns,
                    "Password" => Password,
                    "ServerHostname" => ServerHostname,
                    "Subdirectory" => Subdirectory,
                    "User" => User,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_task(destination_location_arn, source_location_arn)
    create_task(destination_location_arn, source_location_arn, params::Dict{String,<:Any})

Configures a task, which defines where and how DataSync transfers your data. A task
includes a source location, destination location, and transfer options (such as bandwidth
limits, scheduling, and more).  If you're planning to transfer data to or from an Amazon S3
location, review how DataSync can affect your S3 request charges and the DataSync pricing
page before you begin.

# Arguments
- `destination_location_arn`: Specifies the ARN of your transfer's destination location.
- `source_location_arn`: Specifies the ARN of your transfer's source location.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CloudWatchLogGroupArn"`: Specifies the Amazon Resource Name (ARN) of an Amazon
  CloudWatch log group for monitoring your task.
- `"Excludes"`: Specifies exclude filters that define the files, objects, and folders in
  your source location that you don't want DataSync to transfer. For more information and
  examples, see Specifying what DataSync transfers by using filters.
- `"Includes"`: Specifies include filters define the files, objects, and folders in your
  source location that you want DataSync to transfer. For more information and examples, see
  Specifying what DataSync transfers by using filters.
- `"ManifestConfig"`: Configures a manifest, which is a list of files or objects that you
  want DataSync to transfer. For more information and configuration examples, see Specifying
  what DataSync transfers by using a manifest. When using this parameter, your caller
  identity (the role that you're using DataSync with) must have the iam:PassRole permission.
  The AWSDataSyncFullAccess policy includes this permission.
- `"Name"`: Specifies the name of your task.
- `"Options"`: Specifies your task's settings, such as preserving file metadata, verifying
  data integrity, among other options.
- `"Schedule"`: Specifies a schedule for when you want your task to run. For more
  information, see Scheduling your task.
- `"Tags"`: Specifies the tags that you want to apply to your task.  Tags are key-value
  pairs that help you manage, filter, and search for your DataSync resources.
- `"TaskReportConfig"`: Specifies how you want to configure a task report, which provides
  detailed information about your DataSync transfer. For more information, see Monitoring
  your DataSync transfers with task reports. When using this parameter, your caller identity
  (the role that you're using DataSync with) must have the iam:PassRole permission. The
  AWSDataSyncFullAccess policy includes this permission.
"""
function create_task(
    DestinationLocationArn,
    SourceLocationArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "CreateTask",
        Dict{String,Any}(
            "DestinationLocationArn" => DestinationLocationArn,
            "SourceLocationArn" => SourceLocationArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_task(
    DestinationLocationArn,
    SourceLocationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "CreateTask",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DestinationLocationArn" => DestinationLocationArn,
                    "SourceLocationArn" => SourceLocationArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_agent(agent_arn)
    delete_agent(agent_arn, params::Dict{String,<:Any})

Removes an DataSync agent resource from your Amazon Web Services account. Keep in mind that
this operation (which can't be undone) doesn't remove the agent's virtual machine (VM) or
Amazon EC2 instance from your storage environment. For next steps, you can delete the VM or
instance from your storage environment or reuse it to activate a new agent.

# Arguments
- `agent_arn`: The Amazon Resource Name (ARN) of the agent to delete. Use the ListAgents
  operation to return a list of agents for your account and Amazon Web Services Region.

"""
function delete_agent(AgentArn; aws_config::AbstractAWSConfig=current_aws_config())
    return datasync(
        "DeleteAgent",
        Dict{String,Any}("AgentArn" => AgentArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_agent(
    AgentArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "DeleteAgent",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AgentArn" => AgentArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_location(location_arn)
    delete_location(location_arn, params::Dict{String,<:Any})

Deletes a transfer location resource from DataSync.

# Arguments
- `location_arn`: The Amazon Resource Name (ARN) of the location to delete.

"""
function delete_location(LocationArn; aws_config::AbstractAWSConfig=current_aws_config())
    return datasync(
        "DeleteLocation",
        Dict{String,Any}("LocationArn" => LocationArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_location(
    LocationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "DeleteLocation",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("LocationArn" => LocationArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_task(task_arn)
    delete_task(task_arn, params::Dict{String,<:Any})

Deletes a transfer task resource from DataSync.

# Arguments
- `task_arn`: Specifies the Amazon Resource Name (ARN) of the task that you want to delete.

"""
function delete_task(TaskArn; aws_config::AbstractAWSConfig=current_aws_config())
    return datasync(
        "DeleteTask",
        Dict{String,Any}("TaskArn" => TaskArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_task(
    TaskArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "DeleteTask",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("TaskArn" => TaskArn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_agent(agent_arn)
    describe_agent(agent_arn, params::Dict{String,<:Any})

Returns information about an DataSync agent, such as its name, service endpoint type, and
status.

# Arguments
- `agent_arn`: Specifies the Amazon Resource Name (ARN) of the DataSync agent that you want
  information about.

"""
function describe_agent(AgentArn; aws_config::AbstractAWSConfig=current_aws_config())
    return datasync(
        "DescribeAgent",
        Dict{String,Any}("AgentArn" => AgentArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_agent(
    AgentArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "DescribeAgent",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AgentArn" => AgentArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_discovery_job(discovery_job_arn)
    describe_discovery_job(discovery_job_arn, params::Dict{String,<:Any})

Returns information about a DataSync discovery job.

# Arguments
- `discovery_job_arn`: Specifies the Amazon Resource Name (ARN) of the discovery job that
  you want information about.

"""
function describe_discovery_job(
    DiscoveryJobArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datasync(
        "DescribeDiscoveryJob",
        Dict{String,Any}("DiscoveryJobArn" => DiscoveryJobArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_discovery_job(
    DiscoveryJobArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "DescribeDiscoveryJob",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("DiscoveryJobArn" => DiscoveryJobArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_location_azure_blob(location_arn)
    describe_location_azure_blob(location_arn, params::Dict{String,<:Any})

Provides details about how an DataSync transfer location for Microsoft Azure Blob Storage
is configured.

# Arguments
- `location_arn`: Specifies the Amazon Resource Name (ARN) of your Azure Blob Storage
  transfer location.

"""
function describe_location_azure_blob(
    LocationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datasync(
        "DescribeLocationAzureBlob",
        Dict{String,Any}("LocationArn" => LocationArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_location_azure_blob(
    LocationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "DescribeLocationAzureBlob",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("LocationArn" => LocationArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_location_efs(location_arn)
    describe_location_efs(location_arn, params::Dict{String,<:Any})

Provides details about how an DataSync transfer location for an Amazon EFS file system is
configured.

# Arguments
- `location_arn`: The Amazon Resource Name (ARN) of the Amazon EFS file system location
  that you want information about.

"""
function describe_location_efs(
    LocationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datasync(
        "DescribeLocationEfs",
        Dict{String,Any}("LocationArn" => LocationArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_location_efs(
    LocationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "DescribeLocationEfs",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("LocationArn" => LocationArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_location_fsx_lustre(location_arn)
    describe_location_fsx_lustre(location_arn, params::Dict{String,<:Any})

Provides details about how an DataSync transfer location for an Amazon FSx for Lustre file
system is configured.

# Arguments
- `location_arn`: The Amazon Resource Name (ARN) of the FSx for Lustre location to
  describe.

"""
function describe_location_fsx_lustre(
    LocationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datasync(
        "DescribeLocationFsxLustre",
        Dict{String,Any}("LocationArn" => LocationArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_location_fsx_lustre(
    LocationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "DescribeLocationFsxLustre",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("LocationArn" => LocationArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_location_fsx_ontap(location_arn)
    describe_location_fsx_ontap(location_arn, params::Dict{String,<:Any})

Provides details about how an DataSync transfer location for an Amazon FSx for NetApp ONTAP
file system is configured.  If your location uses SMB, the DescribeLocationFsxOntap
operation doesn't actually return a Password.

# Arguments
- `location_arn`: Specifies the Amazon Resource Name (ARN) of the FSx for ONTAP file system
  location that you want information about.

"""
function describe_location_fsx_ontap(
    LocationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datasync(
        "DescribeLocationFsxOntap",
        Dict{String,Any}("LocationArn" => LocationArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_location_fsx_ontap(
    LocationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "DescribeLocationFsxOntap",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("LocationArn" => LocationArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_location_fsx_open_zfs(location_arn)
    describe_location_fsx_open_zfs(location_arn, params::Dict{String,<:Any})

Provides details about how an DataSync transfer location for an Amazon FSx for OpenZFS file
system is configured.  Response elements related to SMB aren't supported with the
DescribeLocationFsxOpenZfs operation.

# Arguments
- `location_arn`: The Amazon Resource Name (ARN) of the FSx for OpenZFS location to
  describe.

"""
function describe_location_fsx_open_zfs(
    LocationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datasync(
        "DescribeLocationFsxOpenZfs",
        Dict{String,Any}("LocationArn" => LocationArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_location_fsx_open_zfs(
    LocationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "DescribeLocationFsxOpenZfs",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("LocationArn" => LocationArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_location_fsx_windows(location_arn)
    describe_location_fsx_windows(location_arn, params::Dict{String,<:Any})

Provides details about how an DataSync transfer location for an Amazon FSx for Windows File
Server file system is configured.

# Arguments
- `location_arn`: Specifies the Amazon Resource Name (ARN) of the FSx for Windows File
  Server location.

"""
function describe_location_fsx_windows(
    LocationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datasync(
        "DescribeLocationFsxWindows",
        Dict{String,Any}("LocationArn" => LocationArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_location_fsx_windows(
    LocationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "DescribeLocationFsxWindows",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("LocationArn" => LocationArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_location_hdfs(location_arn)
    describe_location_hdfs(location_arn, params::Dict{String,<:Any})

Provides details about how an DataSync transfer location for a Hadoop Distributed File
System (HDFS) is configured.

# Arguments
- `location_arn`: Specifies the Amazon Resource Name (ARN) of the HDFS location.

"""
function describe_location_hdfs(
    LocationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datasync(
        "DescribeLocationHdfs",
        Dict{String,Any}("LocationArn" => LocationArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_location_hdfs(
    LocationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "DescribeLocationHdfs",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("LocationArn" => LocationArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_location_nfs(location_arn)
    describe_location_nfs(location_arn, params::Dict{String,<:Any})

Provides details about how an DataSync transfer location for a Network File System (NFS)
file server is configured.

# Arguments
- `location_arn`: Specifies the Amazon Resource Name (ARN) of the NFS location that you
  want information about.

"""
function describe_location_nfs(
    LocationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datasync(
        "DescribeLocationNfs",
        Dict{String,Any}("LocationArn" => LocationArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_location_nfs(
    LocationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "DescribeLocationNfs",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("LocationArn" => LocationArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_location_object_storage(location_arn)
    describe_location_object_storage(location_arn, params::Dict{String,<:Any})

Provides details about how an DataSync transfer location for an object storage system is
configured.

# Arguments
- `location_arn`: Specifies the Amazon Resource Name (ARN) of the object storage system
  location.

"""
function describe_location_object_storage(
    LocationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datasync(
        "DescribeLocationObjectStorage",
        Dict{String,Any}("LocationArn" => LocationArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_location_object_storage(
    LocationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "DescribeLocationObjectStorage",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("LocationArn" => LocationArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_location_s3(location_arn)
    describe_location_s3(location_arn, params::Dict{String,<:Any})

Provides details about how an DataSync transfer location for an S3 bucket is configured.

# Arguments
- `location_arn`: Specifies the Amazon Resource Name (ARN) of the Amazon S3 location.

"""
function describe_location_s3(
    LocationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datasync(
        "DescribeLocationS3",
        Dict{String,Any}("LocationArn" => LocationArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_location_s3(
    LocationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "DescribeLocationS3",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("LocationArn" => LocationArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_location_smb(location_arn)
    describe_location_smb(location_arn, params::Dict{String,<:Any})

Provides details about how an DataSync transfer location for a Server Message Block (SMB)
file server is configured.

# Arguments
- `location_arn`: Specifies the Amazon Resource Name (ARN) of the SMB location that you
  want information about.

"""
function describe_location_smb(
    LocationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datasync(
        "DescribeLocationSmb",
        Dict{String,Any}("LocationArn" => LocationArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_location_smb(
    LocationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "DescribeLocationSmb",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("LocationArn" => LocationArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_storage_system(storage_system_arn)
    describe_storage_system(storage_system_arn, params::Dict{String,<:Any})

Returns information about an on-premises storage system that you're using with DataSync
Discovery.

# Arguments
- `storage_system_arn`: Specifies the Amazon Resource Name (ARN) of an on-premises storage
  system that you're using with DataSync Discovery.

"""
function describe_storage_system(
    StorageSystemArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datasync(
        "DescribeStorageSystem",
        Dict{String,Any}("StorageSystemArn" => StorageSystemArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_storage_system(
    StorageSystemArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "DescribeStorageSystem",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("StorageSystemArn" => StorageSystemArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_storage_system_resource_metrics(discovery_job_arn, resource_id, resource_type)
    describe_storage_system_resource_metrics(discovery_job_arn, resource_id, resource_type, params::Dict{String,<:Any})

Returns information, including performance data and capacity usage, which DataSync
Discovery collects about a specific resource in your-premises storage system.

# Arguments
- `discovery_job_arn`: Specifies the Amazon Resource Name (ARN) of the discovery job that
  collects information about your on-premises storage system.
- `resource_id`: Specifies the universally unique identifier (UUID) of the storage system
  resource that you want information about.
- `resource_type`: Specifies the kind of storage system resource that you want information
  about.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EndTime"`: Specifies a time within the total duration that the discovery job ran. To
  see information gathered during a certain time frame, use this parameter with StartTime.
- `"MaxResults"`: Specifies how many results that you want in the response.
- `"NextToken"`: Specifies an opaque string that indicates the position to begin the next
  list of results in the response.
- `"StartTime"`: Specifies a time within the total duration that the discovery job ran. To
  see information gathered during a certain time frame, use this parameter with EndTime.
"""
function describe_storage_system_resource_metrics(
    DiscoveryJobArn,
    ResourceId,
    ResourceType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "DescribeStorageSystemResourceMetrics",
        Dict{String,Any}(
            "DiscoveryJobArn" => DiscoveryJobArn,
            "ResourceId" => ResourceId,
            "ResourceType" => ResourceType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_storage_system_resource_metrics(
    DiscoveryJobArn,
    ResourceId,
    ResourceType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "DescribeStorageSystemResourceMetrics",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DiscoveryJobArn" => DiscoveryJobArn,
                    "ResourceId" => ResourceId,
                    "ResourceType" => ResourceType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_storage_system_resources(discovery_job_arn, resource_type)
    describe_storage_system_resources(discovery_job_arn, resource_type, params::Dict{String,<:Any})

Returns information that DataSync Discovery collects about resources in your on-premises
storage system.

# Arguments
- `discovery_job_arn`: Specifies the Amazon Resource Name (ARN) of the discovery job that's
  collecting data from your on-premises storage system.
- `resource_type`: Specifies what kind of storage system resources that you want
  information about.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filter"`: Filters the storage system resources that you want returned. For example,
  this might be volumes associated with a specific storage virtual machine (SVM).
- `"MaxResults"`: Specifies the maximum number of storage system resources that you want to
  list in a response.
- `"NextToken"`: Specifies an opaque string that indicates the position to begin the next
  list of results in the response.
- `"ResourceIds"`: Specifies the universally unique identifiers (UUIDs) of the storage
  system resources that you want information about. You can't use this parameter in
  combination with the Filter parameter.
"""
function describe_storage_system_resources(
    DiscoveryJobArn, ResourceType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datasync(
        "DescribeStorageSystemResources",
        Dict{String,Any}(
            "DiscoveryJobArn" => DiscoveryJobArn, "ResourceType" => ResourceType
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_storage_system_resources(
    DiscoveryJobArn,
    ResourceType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "DescribeStorageSystemResources",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DiscoveryJobArn" => DiscoveryJobArn, "ResourceType" => ResourceType
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_task(task_arn)
    describe_task(task_arn, params::Dict{String,<:Any})

Provides information about a task, which defines where and how DataSync transfers your data.

# Arguments
- `task_arn`: Specifies the Amazon Resource Name (ARN) of the transfer task that you want
  information about.

"""
function describe_task(TaskArn; aws_config::AbstractAWSConfig=current_aws_config())
    return datasync(
        "DescribeTask",
        Dict{String,Any}("TaskArn" => TaskArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_task(
    TaskArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "DescribeTask",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("TaskArn" => TaskArn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_task_execution(task_execution_arn)
    describe_task_execution(task_execution_arn, params::Dict{String,<:Any})

Provides information about an execution of your DataSync task. You can use this operation
to help monitor the progress of an ongoing transfer or check the results of the transfer.

# Arguments
- `task_execution_arn`: Specifies the Amazon Resource Name (ARN) of the task execution that
  you want information about.

"""
function describe_task_execution(
    TaskExecutionArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datasync(
        "DescribeTaskExecution",
        Dict{String,Any}("TaskExecutionArn" => TaskExecutionArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_task_execution(
    TaskExecutionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "DescribeTaskExecution",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("TaskExecutionArn" => TaskExecutionArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    generate_recommendations(discovery_job_arn, resource_ids, resource_type)
    generate_recommendations(discovery_job_arn, resource_ids, resource_type, params::Dict{String,<:Any})

Creates recommendations about where to migrate your data to in Amazon Web Services.
Recommendations are generated based on information that DataSync Discovery collects about
your on-premises storage system's resources. For more information, see Recommendations
provided by DataSync Discovery. Once generated, you can view your recommendations by using
the DescribeStorageSystemResources operation.

# Arguments
- `discovery_job_arn`: Specifies the Amazon Resource Name (ARN) of the discovery job that
  collects information about your on-premises storage system.
- `resource_ids`: Specifies the universally unique identifiers (UUIDs) of the resources in
  your storage system that you want recommendations on.
- `resource_type`: Specifies the type of resource in your storage system that you want
  recommendations on.

"""
function generate_recommendations(
    DiscoveryJobArn,
    ResourceIds,
    ResourceType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "GenerateRecommendations",
        Dict{String,Any}(
            "DiscoveryJobArn" => DiscoveryJobArn,
            "ResourceIds" => ResourceIds,
            "ResourceType" => ResourceType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function generate_recommendations(
    DiscoveryJobArn,
    ResourceIds,
    ResourceType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "GenerateRecommendations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DiscoveryJobArn" => DiscoveryJobArn,
                    "ResourceIds" => ResourceIds,
                    "ResourceType" => ResourceType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_agents()
    list_agents(params::Dict{String,<:Any})

Returns a list of DataSync agents that belong to an Amazon Web Services account in the
Amazon Web Services Region specified in the request. With pagination, you can reduce the
number of agents returned in a response. If you get a truncated list of agents in a
response, the response contains a marker that you can specify in your next request to fetch
the next page of agents.  ListAgents is eventually consistent. This means the result of
running the operation might not reflect that you just created or deleted an agent. For
example, if you create an agent with CreateAgent and then immediately run ListAgents, that
agent might not show up in the list right away. In situations like this, you can always
confirm whether an agent has been created (or deleted) by using DescribeAgent.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Specifies the maximum number of DataSync agents to list in a response. By
  default, a response shows a maximum of 100 agents.
- `"NextToken"`: Specifies an opaque string that indicates the position to begin the next
  list of results in the response.
"""
function list_agents(; aws_config::AbstractAWSConfig=current_aws_config())
    return datasync("ListAgents"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_agents(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datasync(
        "ListAgents", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_discovery_jobs()
    list_discovery_jobs(params::Dict{String,<:Any})

Provides a list of the existing discovery jobs in the Amazon Web Services Region and Amazon
Web Services account where you're using DataSync Discovery.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Specifies how many results you want in the response.
- `"NextToken"`: Specifies an opaque string that indicates the position to begin the next
  list of results in the response.
- `"StorageSystemArn"`: Specifies the Amazon Resource Name (ARN) of an on-premises storage
  system. Use this parameter if you only want to list the discovery jobs that are associated
  with a specific storage system.
"""
function list_discovery_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return datasync(
        "ListDiscoveryJobs"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_discovery_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datasync(
        "ListDiscoveryJobs", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_locations()
    list_locations(params::Dict{String,<:Any})

Returns a list of source and destination locations. If you have more locations than are
returned in a response (that is, the response returns only a truncated list of your
agents), the response contains a token that you can specify in your next request to fetch
the next page of locations.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: You can use API filters to narrow down the list of resources returned by
  ListLocations. For example, to retrieve all tasks on a specific source location, you can
  use ListLocations with filter name LocationType S3 and Operator Equals.
- `"MaxResults"`: The maximum number of locations to return.
- `"NextToken"`: An opaque string that indicates the position at which to begin the next
  list of locations.
"""
function list_locations(; aws_config::AbstractAWSConfig=current_aws_config())
    return datasync("ListLocations"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_locations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datasync(
        "ListLocations", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_storage_systems()
    list_storage_systems(params::Dict{String,<:Any})

Lists the on-premises storage systems that you're using with DataSync Discovery.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Specifies how many results you want in the response.
- `"NextToken"`: Specifies an opaque string that indicates the position to begin the next
  list of results in the response.
"""
function list_storage_systems(; aws_config::AbstractAWSConfig=current_aws_config())
    return datasync(
        "ListStorageSystems"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_storage_systems(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datasync(
        "ListStorageSystems", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Returns all the tags associated with an Amazon Web Services resource.

# Arguments
- `resource_arn`: Specifies the Amazon Resource Name (ARN) of the resource that you want
  tag information on.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Specifies how many results that you want in the response.
- `"NextToken"`: Specifies an opaque string that indicates the position to begin the next
  list of results in the response.
"""
function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datasync(
        "ListTagsForResource",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_task_executions()
    list_task_executions(params::Dict{String,<:Any})

Returns a list of executions for an DataSync transfer task.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Specifies how many results you want in the response.
- `"NextToken"`: Specifies an opaque string that indicates the position at which to begin
  the next list of results in the response.
- `"TaskArn"`: Specifies the Amazon Resource Name (ARN) of the task that you want execution
  information about.
"""
function list_task_executions(; aws_config::AbstractAWSConfig=current_aws_config())
    return datasync(
        "ListTaskExecutions"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_task_executions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datasync(
        "ListTaskExecutions", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tasks()
    list_tasks(params::Dict{String,<:Any})

Returns a list of the DataSync tasks you created.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: You can use API filters to narrow down the list of resources returned by
  ListTasks. For example, to retrieve all tasks on a specific source location, you can use
  ListTasks with filter name LocationId and Operator Equals with the ARN for the location.
- `"MaxResults"`: The maximum number of tasks to return.
- `"NextToken"`: An opaque string that indicates the position at which to begin the next
  list of tasks.
"""
function list_tasks(; aws_config::AbstractAWSConfig=current_aws_config())
    return datasync("ListTasks"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_tasks(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datasync(
        "ListTasks", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    remove_storage_system(storage_system_arn)
    remove_storage_system(storage_system_arn, params::Dict{String,<:Any})

Permanently removes a storage system resource from DataSync Discovery, including the
associated discovery jobs, collected data, and recommendations.

# Arguments
- `storage_system_arn`: Specifies the Amazon Resource Name (ARN) of the storage system that
  you want to permanently remove from DataSync Discovery.

"""
function remove_storage_system(
    StorageSystemArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datasync(
        "RemoveStorageSystem",
        Dict{String,Any}("StorageSystemArn" => StorageSystemArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_storage_system(
    StorageSystemArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "RemoveStorageSystem",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("StorageSystemArn" => StorageSystemArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_discovery_job(client_token, collection_duration_minutes, storage_system_arn)
    start_discovery_job(client_token, collection_duration_minutes, storage_system_arn, params::Dict{String,<:Any})

Runs a DataSync discovery job on your on-premises storage system. If you haven't added the
storage system to DataSync Discovery yet, do this first by using the AddStorageSystem
operation.

# Arguments
- `client_token`: Specifies a client token to make sure requests with this API operation
  are idempotent. If you don't specify a client token, DataSync generates one for you
  automatically.
- `collection_duration_minutes`: Specifies in minutes how long you want the discovery job
  to run.  For more accurate recommendations, we recommend a duration of at least 14 days.
  Longer durations allow time to collect a sufficient number of data points and provide a
  realistic representation of storage performance and utilization.
- `storage_system_arn`: Specifies the Amazon Resource Name (ARN) of the on-premises storage
  system that you want to run the discovery job on.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: Specifies labels that help you categorize, filter, and search for your Amazon
  Web Services resources.
"""
function start_discovery_job(
    ClientToken,
    CollectionDurationMinutes,
    StorageSystemArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "StartDiscoveryJob",
        Dict{String,Any}(
            "ClientToken" => ClientToken,
            "CollectionDurationMinutes" => CollectionDurationMinutes,
            "StorageSystemArn" => StorageSystemArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_discovery_job(
    ClientToken,
    CollectionDurationMinutes,
    StorageSystemArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "StartDiscoveryJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClientToken" => ClientToken,
                    "CollectionDurationMinutes" => CollectionDurationMinutes,
                    "StorageSystemArn" => StorageSystemArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_task_execution(task_arn)
    start_task_execution(task_arn, params::Dict{String,<:Any})

Starts an DataSync transfer task. For each task, you can only run one task execution at a
time. There are several phases to a task execution. For more information, see Task
execution statuses.  If you're planning to transfer data to or from an Amazon S3 location,
review how DataSync can affect your S3 request charges and the DataSync pricing page before
you begin.

# Arguments
- `task_arn`: Specifies the Amazon Resource Name (ARN) of the task that you want to start.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Excludes"`: Specifies a list of filter rules that determines which files to exclude
  from a task. The list contains a single filter string that consists of the patterns to
  exclude. The patterns are delimited by \"|\" (that is, a pipe), for example,
  \"/folder1|/folder2\".
- `"Includes"`: Specifies a list of filter rules that determines which files to include
  when running a task. The pattern should contain a single filter string that consists of the
  patterns to include. The patterns are delimited by \"|\" (that is, a pipe), for example,
  \"/folder1|/folder2\".
- `"ManifestConfig"`: Configures a manifest, which is a list of files or objects that you
  want DataSync to transfer. For more information and configuration examples, see Specifying
  what DataSync transfers by using a manifest. When using this parameter, your caller
  identity (the role that you're using DataSync with) must have the iam:PassRole permission.
  The AWSDataSyncFullAccess policy includes this permission. To remove a manifest
  configuration, specify this parameter with an empty value.
- `"OverrideOptions"`:
- `"Tags"`: Specifies the tags that you want to apply to the Amazon Resource Name (ARN)
  representing the task execution.  Tags are key-value pairs that help you manage, filter,
  and search for your DataSync resources.
- `"TaskReportConfig"`: Specifies how you want to configure a task report, which provides
  detailed information about your DataSync transfer. For more information, see Monitoring
  your DataSync transfers with task reports. When using this parameter, your caller identity
  (the role that you're using DataSync with) must have the iam:PassRole permission. The
  AWSDataSyncFullAccess policy includes this permission. To remove a task report
  configuration, specify this parameter as empty.
"""
function start_task_execution(TaskArn; aws_config::AbstractAWSConfig=current_aws_config())
    return datasync(
        "StartTaskExecution",
        Dict{String,Any}("TaskArn" => TaskArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_task_execution(
    TaskArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "StartTaskExecution",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("TaskArn" => TaskArn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_discovery_job(discovery_job_arn)
    stop_discovery_job(discovery_job_arn, params::Dict{String,<:Any})

Stops a running DataSync discovery job. You can stop a discovery job anytime. A job that's
stopped before it's scheduled to end likely will provide you some information about your
on-premises storage system resources. To get recommendations for a stopped job, you must
use the GenerateRecommendations operation.

# Arguments
- `discovery_job_arn`: Specifies the Amazon Resource Name (ARN) of the discovery job that
  you want to stop.

"""
function stop_discovery_job(
    DiscoveryJobArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datasync(
        "StopDiscoveryJob",
        Dict{String,Any}("DiscoveryJobArn" => DiscoveryJobArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_discovery_job(
    DiscoveryJobArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "StopDiscoveryJob",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("DiscoveryJobArn" => DiscoveryJobArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Applies a tag to an Amazon Web Services resource. Tags are key-value pairs that can help
you manage, filter, and search for your resources. These include DataSync resources, such
as locations, tasks, and task executions.

# Arguments
- `resource_arn`: Specifies the Amazon Resource Name (ARN) of the resource to apply the tag
  to.
- `tags`: Specifies the tags that you want to apply to the resource.

"""
function tag_resource(ResourceArn, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return datasync(
        "TagResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceArn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(keys, resource_arn)
    untag_resource(keys, resource_arn, params::Dict{String,<:Any})

Removes tags from an Amazon Web Services resource.

# Arguments
- `keys`: Specifies the keys in the tags that you want to remove.
- `resource_arn`: Specifies the Amazon Resource Name (ARN) of the resource to remove the
  tags from.

"""
function untag_resource(
    Keys, ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datasync(
        "UntagResource",
        Dict{String,Any}("Keys" => Keys, "ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    Keys,
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Keys" => Keys, "ResourceArn" => ResourceArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_agent(agent_arn)
    update_agent(agent_arn, params::Dict{String,<:Any})

Updates the name of an DataSync agent.

# Arguments
- `agent_arn`: The Amazon Resource Name (ARN) of the agent to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Name"`: The name that you want to use to configure the agent.
"""
function update_agent(AgentArn; aws_config::AbstractAWSConfig=current_aws_config())
    return datasync(
        "UpdateAgent",
        Dict{String,Any}("AgentArn" => AgentArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_agent(
    AgentArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "UpdateAgent",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AgentArn" => AgentArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_discovery_job(collection_duration_minutes, discovery_job_arn)
    update_discovery_job(collection_duration_minutes, discovery_job_arn, params::Dict{String,<:Any})

Edits a DataSync discovery job configuration.

# Arguments
- `collection_duration_minutes`: Specifies in minutes how long that you want the discovery
  job to run. (You can't set this parameter to less than the number of minutes that the job
  has already run for.)
- `discovery_job_arn`: Specifies the Amazon Resource Name (ARN) of the discovery job that
  you want to update.

"""
function update_discovery_job(
    CollectionDurationMinutes,
    DiscoveryJobArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "UpdateDiscoveryJob",
        Dict{String,Any}(
            "CollectionDurationMinutes" => CollectionDurationMinutes,
            "DiscoveryJobArn" => DiscoveryJobArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_discovery_job(
    CollectionDurationMinutes,
    DiscoveryJobArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "UpdateDiscoveryJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CollectionDurationMinutes" => CollectionDurationMinutes,
                    "DiscoveryJobArn" => DiscoveryJobArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_location_azure_blob(location_arn)
    update_location_azure_blob(location_arn, params::Dict{String,<:Any})

Modifies some configurations of the Microsoft Azure Blob Storage transfer location that
you're using with DataSync.

# Arguments
- `location_arn`: Specifies the ARN of the Azure Blob Storage transfer location that you're
  updating.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccessTier"`: Specifies the access tier that you want your objects or files transferred
  into. This only applies when using the location as a transfer destination. For more
  information, see Access tiers.
- `"AgentArns"`: Specifies the Amazon Resource Name (ARN) of the DataSync agent that can
  connect with your Azure Blob Storage container. You can specify more than one agent. For
  more information, see Using multiple agents for your transfer.
- `"AuthenticationType"`: Specifies the authentication method DataSync uses to access your
  Azure Blob Storage. DataSync can access blob storage using a shared access signature (SAS).
- `"BlobType"`: Specifies the type of blob that you want your objects or files to be when
  transferring them into Azure Blob Storage. Currently, DataSync only supports moving data
  into Azure Blob Storage as block blobs. For more information on blob types, see the Azure
  Blob Storage documentation.
- `"SasConfiguration"`: Specifies the SAS configuration that allows DataSync to access your
  Azure Blob Storage.
- `"Subdirectory"`: Specifies path segments if you want to limit your transfer to a virtual
  directory in your container (for example, /my/images).
"""
function update_location_azure_blob(
    LocationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datasync(
        "UpdateLocationAzureBlob",
        Dict{String,Any}("LocationArn" => LocationArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_location_azure_blob(
    LocationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "UpdateLocationAzureBlob",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("LocationArn" => LocationArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_location_hdfs(location_arn)
    update_location_hdfs(location_arn, params::Dict{String,<:Any})

Updates some parameters of a previously created location for a Hadoop Distributed File
System cluster.

# Arguments
- `location_arn`: The Amazon Resource Name (ARN) of the source HDFS cluster location.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AgentArns"`: The ARNs of the agents that are used to connect to the HDFS cluster.
- `"AuthenticationType"`: The type of authentication used to determine the identity of the
  user.
- `"BlockSize"`: The size of the data blocks to write into the HDFS cluster.
- `"KerberosKeytab"`: The Kerberos key table (keytab) that contains mappings between the
  defined Kerberos principal and the encrypted keys. You can load the keytab from a file by
  providing the file's address. If you use the CLI, it performs base64 encoding for you.
  Otherwise, provide the base64-encoded text.
- `"KerberosKrb5Conf"`: The krb5.conf file that contains the Kerberos configuration
  information. You can load the krb5.conf file by providing the file's address. If you're
  using the CLI, it performs the base64 encoding for you. Otherwise, provide the
  base64-encoded text.
- `"KerberosPrincipal"`: The Kerberos principal with access to the files and folders on the
  HDFS cluster.
- `"KmsKeyProviderUri"`: The URI of the HDFS cluster's Key Management Server (KMS).
- `"NameNodes"`: The NameNode that manages the HDFS namespace. The NameNode performs
  operations such as opening, closing, and renaming files and directories. The NameNode
  contains the information to map blocks of data to the DataNodes. You can use only one
  NameNode.
- `"QopConfiguration"`: The Quality of Protection (QOP) configuration specifies the Remote
  Procedure Call (RPC) and data transfer privacy settings configured on the Hadoop
  Distributed File System (HDFS) cluster.
- `"ReplicationFactor"`: The number of DataNodes to replicate the data to when writing to
  the HDFS cluster.
- `"SimpleUser"`: The user name used to identify the client on the host operating system.
- `"Subdirectory"`: A subdirectory in the HDFS cluster. This subdirectory is used to read
  data from or write data to the HDFS cluster.
"""
function update_location_hdfs(
    LocationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datasync(
        "UpdateLocationHdfs",
        Dict{String,Any}("LocationArn" => LocationArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_location_hdfs(
    LocationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "UpdateLocationHdfs",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("LocationArn" => LocationArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_location_nfs(location_arn)
    update_location_nfs(location_arn, params::Dict{String,<:Any})

Modifies some configurations of the Network File System (NFS) transfer location that you're
using with DataSync. For more information, see Configuring transfers to or from an NFS file
server.

# Arguments
- `location_arn`: Specifies the Amazon Resource Name (ARN) of the NFS transfer location
  that you want to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MountOptions"`:
- `"OnPremConfig"`:
- `"Subdirectory"`: Specifies the export path in your NFS file server that you want
  DataSync to mount. This path (or a subdirectory of the path) is where DataSync transfers
  data to or from. For information on configuring an export for DataSync, see Accessing NFS
  file servers.
"""
function update_location_nfs(
    LocationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datasync(
        "UpdateLocationNfs",
        Dict{String,Any}("LocationArn" => LocationArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_location_nfs(
    LocationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "UpdateLocationNfs",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("LocationArn" => LocationArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_location_object_storage(location_arn)
    update_location_object_storage(location_arn, params::Dict{String,<:Any})

Updates some parameters of an existing DataSync location for an object storage system.

# Arguments
- `location_arn`: Specifies the ARN of the object storage system location that you're
  updating.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccessKey"`: Specifies the access key (for example, a user name) if credentials are
  required to authenticate with the object storage server.
- `"AgentArns"`: Specifies the Amazon Resource Names (ARNs) of the DataSync agents that can
  securely connect with your location.
- `"SecretKey"`: Specifies the secret key (for example, a password) if credentials are
  required to authenticate with the object storage server.
- `"ServerCertificate"`: Specifies a certificate chain for DataSync to authenticate with
  your object storage system if the system uses a private or self-signed certificate
  authority (CA). You must specify a single .pem file with a full certificate chain (for
  example, file:///home/user/.ssh/object_storage_certificates.pem). The certificate chain
  might include:   The object storage system's certificate   All intermediate certificates
  (if there are any)   The root certificate of the signing CA   You can concatenate your
  certificates into a .pem file (which can be up to 32768 bytes before base64 encoding). The
  following example cat command creates an object_storage_certificates.pem file that includes
  three certificates:  cat object_server_certificate.pem intermediate_certificate.pem
  ca_root_certificate.pem &gt; object_storage_certificates.pem  To use this parameter,
  configure ServerProtocol to HTTPS. Updating this parameter doesn't interfere with tasks
  that you have in progress.
- `"ServerPort"`: Specifies the port that your object storage server accepts inbound
  network traffic on (for example, port 443).
- `"ServerProtocol"`: Specifies the protocol that your object storage server uses to
  communicate.
- `"Subdirectory"`: Specifies the object prefix for your object storage server. If this is
  a source location, DataSync only copies objects with this prefix. If this is a destination
  location, DataSync writes all objects with this prefix.
"""
function update_location_object_storage(
    LocationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datasync(
        "UpdateLocationObjectStorage",
        Dict{String,Any}("LocationArn" => LocationArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_location_object_storage(
    LocationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "UpdateLocationObjectStorage",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("LocationArn" => LocationArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_location_smb(location_arn)
    update_location_smb(location_arn, params::Dict{String,<:Any})

Updates some of the parameters of a Server Message Block (SMB) file server location that
you can use for DataSync transfers.

# Arguments
- `location_arn`: Specifies the ARN of the SMB location that you want to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AgentArns"`: Specifies the DataSync agent (or agents) which you want to connect to your
  SMB file server. You specify an agent by using its Amazon Resource Name (ARN).
- `"Domain"`: Specifies the Windows domain name that your SMB file server belongs to.  If
  you have multiple domains in your environment, configuring this parameter makes sure that
  DataSync connects to the right file server. For more information, see required permissions
  for SMB locations.
- `"MountOptions"`:
- `"Password"`: Specifies the password of the user who can mount your SMB file server and
  has permission to access the files and folders involved in your transfer. For more
  information, see required permissions for SMB locations.
- `"Subdirectory"`: Specifies the name of the share exported by your SMB file server where
  DataSync will read or write data. You can include a subdirectory in the share path (for
  example, /path/to/subdirectory). Make sure that other SMB clients in your network can also
  mount this path. To copy all data in the specified subdirectory, DataSync must be able to
  mount the SMB share and access all of its data. For more information, see required
  permissions for SMB locations.
- `"User"`: Specifies the user name that can mount your SMB file server and has permission
  to access the files and folders involved in your transfer. For information about choosing a
  user with the right level of access for your transfer, see required permissions for SMB
  locations.
"""
function update_location_smb(
    LocationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datasync(
        "UpdateLocationSmb",
        Dict{String,Any}("LocationArn" => LocationArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_location_smb(
    LocationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "UpdateLocationSmb",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("LocationArn" => LocationArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_storage_system(storage_system_arn)
    update_storage_system(storage_system_arn, params::Dict{String,<:Any})

Modifies some configurations of an on-premises storage system resource that you're using
with DataSync Discovery.

# Arguments
- `storage_system_arn`: Specifies the ARN of the on-premises storage system that you want
  reconfigure.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AgentArns"`: Specifies the Amazon Resource Name (ARN) of the DataSync agent that
  connects to and reads your on-premises storage system. You can only specify one ARN.
- `"CloudWatchLogGroupArn"`: Specifies the ARN of the Amazon CloudWatch log group for
  monitoring and logging discovery job events.
- `"Credentials"`: Specifies the user name and password for accessing your on-premises
  storage system's management interface.
- `"Name"`: Specifies a familiar name for your on-premises storage system.
- `"ServerConfiguration"`: Specifies the server name and network port required to connect
  with your on-premises storage system's management interface.
"""
function update_storage_system(
    StorageSystemArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datasync(
        "UpdateStorageSystem",
        Dict{String,Any}("StorageSystemArn" => StorageSystemArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_storage_system(
    StorageSystemArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "UpdateStorageSystem",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("StorageSystemArn" => StorageSystemArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_task(task_arn)
    update_task(task_arn, params::Dict{String,<:Any})

Updates the configuration of a task, which defines where and how DataSync transfers your
data.

# Arguments
- `task_arn`: Specifies the ARN of the task that you want to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CloudWatchLogGroupArn"`: Specifies the Amazon Resource Name (ARN) of an Amazon
  CloudWatch log group for monitoring your task.
- `"Excludes"`: Specifies exclude filters that define the files, objects, and folders in
  your source location that you don't want DataSync to transfer. For more information and
  examples, see Specifying what DataSync transfers by using filters.
- `"Includes"`: Specifies include filters define the files, objects, and folders in your
  source location that you want DataSync to transfer. For more information and examples, see
  Specifying what DataSync transfers by using filters.
- `"ManifestConfig"`: Configures a manifest, which is a list of files or objects that you
  want DataSync to transfer. For more information and configuration examples, see Specifying
  what DataSync transfers by using a manifest. When using this parameter, your caller
  identity (the IAM role that you're using DataSync with) must have the iam:PassRole
  permission. The AWSDataSyncFullAccess policy includes this permission. To remove a manifest
  configuration, specify this parameter as empty.
- `"Name"`: Specifies the name of your task.
- `"Options"`:
- `"Schedule"`: Specifies a schedule for when you want your task to run. For more
  information, see Scheduling your task.
- `"TaskReportConfig"`: Specifies how you want to configure a task report, which provides
  detailed information about your DataSync transfer. For more information, see Monitoring
  your DataSync transfers with task reports. When using this parameter, your caller identity
  (the IAM role that you're using DataSync with) must have the iam:PassRole permission. The
  AWSDataSyncFullAccess policy includes this permission. To remove a task report
  configuration, specify this parameter as empty.
"""
function update_task(TaskArn; aws_config::AbstractAWSConfig=current_aws_config())
    return datasync(
        "UpdateTask",
        Dict{String,Any}("TaskArn" => TaskArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_task(
    TaskArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "UpdateTask",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("TaskArn" => TaskArn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_task_execution(options, task_execution_arn)
    update_task_execution(options, task_execution_arn, params::Dict{String,<:Any})

Updates the configuration of a running DataSync task execution.  Currently, the only Option
that you can modify with UpdateTaskExecution is  BytesPerSecond , which throttles bandwidth
for a running or queued task execution.

# Arguments
- `options`:
- `task_execution_arn`: Specifies the Amazon Resource Name (ARN) of the task execution that
  you're updating.

"""
function update_task_execution(
    Options, TaskExecutionArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return datasync(
        "UpdateTaskExecution",
        Dict{String,Any}("Options" => Options, "TaskExecutionArn" => TaskExecutionArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_task_execution(
    Options,
    TaskExecutionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return datasync(
        "UpdateTaskExecution",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Options" => Options, "TaskExecutionArn" => TaskExecutionArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: lakeformation
using AWS.Compat
using AWS.UUIDs

"""
    add_lftags_to_resource(lftags, resource)
    add_lftags_to_resource(lftags, resource, params::Dict{String,<:Any})

Attaches one or more LF-tags to an existing resource.

# Arguments
- `lftags`: The LF-tags to attach to the resource.
- `resource`: The database, table, or column resource to which to attach an LF-tag.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CatalogId"`: The identifier for the Data Catalog. By default, the account ID. The Data
  Catalog is the persistent metadata store. It contains database definitions, table
  definitions, and other control information to manage your Lake Formation environment.
"""
function add_lftags_to_resource(
    LFTags, Resource; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lakeformation(
        "POST",
        "/AddLFTagsToResource",
        Dict{String,Any}("LFTags" => LFTags, "Resource" => Resource);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_lftags_to_resource(
    LFTags,
    Resource,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lakeformation(
        "POST",
        "/AddLFTagsToResource",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("LFTags" => LFTags, "Resource" => Resource), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    assume_decorated_role_with_saml(principal_arn, role_arn, samlassertion)
    assume_decorated_role_with_saml(principal_arn, role_arn, samlassertion, params::Dict{String,<:Any})

Allows a caller to assume an IAM role decorated as the SAML user specified in the SAML
assertion included in the request. This decoration allows Lake Formation to enforce access
policies against the SAML users and groups. This API operation requires SAML federation
setup in the caller’s account as it can only be called with valid SAML assertions. Lake
Formation does not scope down the permission of the assumed role. All permissions attached
to the role via the SAML federation setup will be included in the role session.   This
decorated role is expected to access data in Amazon S3 by getting temporary access from
Lake Formation which is authorized via the virtual API GetDataAccess. Therefore, all SAML
roles that can be assumed via AssumeDecoratedRoleWithSAML must at a minimum include
lakeformation:GetDataAccess in their role policies. A typical IAM policy attached to such a
role would look as follows:

# Arguments
- `principal_arn`: The Amazon Resource Name (ARN) of the SAML provider in IAM that
  describes the IdP.
- `role_arn`: The role that represents an IAM principal whose scope down policy allows it
  to call credential vending APIs such as GetTemporaryTableCredentials. The caller must also
  have iam:PassRole permission on this role.
- `samlassertion`: A SAML assertion consisting of an assertion statement for the user who
  needs temporary credentials. This must match the SAML assertion that was issued to IAM.
  This must be Base64 encoded.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DurationSeconds"`: The time period, between 900 and 43,200 seconds, for the timeout of
  the temporary credentials.
"""
function assume_decorated_role_with_saml(
    PrincipalArn, RoleArn, SAMLAssertion; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lakeformation(
        "POST",
        "/AssumeDecoratedRoleWithSAML",
        Dict{String,Any}(
            "PrincipalArn" => PrincipalArn,
            "RoleArn" => RoleArn,
            "SAMLAssertion" => SAMLAssertion,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function assume_decorated_role_with_saml(
    PrincipalArn,
    RoleArn,
    SAMLAssertion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lakeformation(
        "POST",
        "/AssumeDecoratedRoleWithSAML",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "PrincipalArn" => PrincipalArn,
                    "RoleArn" => RoleArn,
                    "SAMLAssertion" => SAMLAssertion,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_grant_permissions(entries)
    batch_grant_permissions(entries, params::Dict{String,<:Any})

Batch operation to grant permissions to the principal.

# Arguments
- `entries`: A list of up to 20 entries for resource permissions to be granted by batch
  operation to the principal.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CatalogId"`: The identifier for the Data Catalog. By default, the account ID. The Data
  Catalog is the persistent metadata store. It contains database definitions, table
  definitions, and other control information to manage your Lake Formation environment.
"""
function batch_grant_permissions(
    Entries; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lakeformation(
        "POST",
        "/BatchGrantPermissions",
        Dict{String,Any}("Entries" => Entries);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_grant_permissions(
    Entries,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lakeformation(
        "POST",
        "/BatchGrantPermissions",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Entries" => Entries), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_revoke_permissions(entries)
    batch_revoke_permissions(entries, params::Dict{String,<:Any})

Batch operation to revoke permissions from the principal.

# Arguments
- `entries`: A list of up to 20 entries for resource permissions to be revoked by batch
  operation to the principal.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CatalogId"`: The identifier for the Data Catalog. By default, the account ID. The Data
  Catalog is the persistent metadata store. It contains database definitions, table
  definitions, and other control information to manage your Lake Formation environment.
"""
function batch_revoke_permissions(
    Entries; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lakeformation(
        "POST",
        "/BatchRevokePermissions",
        Dict{String,Any}("Entries" => Entries);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_revoke_permissions(
    Entries,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lakeformation(
        "POST",
        "/BatchRevokePermissions",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Entries" => Entries), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_transaction(transaction_id)
    cancel_transaction(transaction_id, params::Dict{String,<:Any})

Attempts to cancel the specified transaction. Returns an exception if the transaction was
previously committed.

# Arguments
- `transaction_id`: The transaction to cancel.

"""
function cancel_transaction(
    TransactionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lakeformation(
        "POST",
        "/CancelTransaction",
        Dict{String,Any}("TransactionId" => TransactionId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_transaction(
    TransactionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lakeformation(
        "POST",
        "/CancelTransaction",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TransactionId" => TransactionId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    commit_transaction(transaction_id)
    commit_transaction(transaction_id, params::Dict{String,<:Any})

Attempts to commit the specified transaction. Returns an exception if the transaction was
previously aborted. This API action is idempotent if called multiple times for the same
transaction.

# Arguments
- `transaction_id`: The transaction to commit.

"""
function commit_transaction(
    TransactionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lakeformation(
        "POST",
        "/CommitTransaction",
        Dict{String,Any}("TransactionId" => TransactionId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function commit_transaction(
    TransactionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lakeformation(
        "POST",
        "/CommitTransaction",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TransactionId" => TransactionId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_data_cells_filter(table_data)
    create_data_cells_filter(table_data, params::Dict{String,<:Any})

Creates a data cell filter to allow one to grant access to certain columns on certain rows.

# Arguments
- `table_data`: A DataCellsFilter structure containing information about the data cells
  filter.

"""
function create_data_cells_filter(
    TableData; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lakeformation(
        "POST",
        "/CreateDataCellsFilter",
        Dict{String,Any}("TableData" => TableData);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_data_cells_filter(
    TableData,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lakeformation(
        "POST",
        "/CreateDataCellsFilter",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TableData" => TableData), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_lake_formation_identity_center_configuration()
    create_lake_formation_identity_center_configuration(params::Dict{String,<:Any})

Creates an IAM Identity Center connection with Lake Formation to allow IAM Identity Center
users and groups to access Data Catalog resources.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CatalogId"`: The identifier for the Data Catalog. By default, the account ID. The Data
  Catalog is the persistent metadata store. It contains database definitions, table
  definitions, view definitions, and other control information to manage your Lake Formation
  environment.
- `"ExternalFiltering"`: A list of the account IDs of Amazon Web Services accounts of
  third-party applications that are allowed to access data managed by Lake Formation.
- `"InstanceArn"`: The ARN of the IAM Identity Center instance for which the operation will
  be executed. For more information about ARNs, see Amazon Resource Names (ARNs) and Amazon
  Web Services Service Namespaces in the Amazon Web Services General Reference.
- `"ShareRecipients"`: A list of Amazon Web Services account IDs and/or Amazon Web Services
  organization/organizational unit ARNs that are allowed to access data managed by Lake
  Formation.  If the ShareRecipients list includes valid values, a resource share is created
  with the principals you want to have access to the resources. If the ShareRecipients value
  is null or the list is empty, no resource share is created.
"""
function create_lake_formation_identity_center_configuration(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return lakeformation(
        "POST",
        "/CreateLakeFormationIdentityCenterConfiguration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_lake_formation_identity_center_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lakeformation(
        "POST",
        "/CreateLakeFormationIdentityCenterConfiguration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_lake_formation_opt_in(principal, resource)
    create_lake_formation_opt_in(principal, resource, params::Dict{String,<:Any})

Enforce Lake Formation permissions for the given databases, tables, and principals.

# Arguments
- `principal`:
- `resource`:

"""
function create_lake_formation_opt_in(
    Principal, Resource; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lakeformation(
        "POST",
        "/CreateLakeFormationOptIn",
        Dict{String,Any}("Principal" => Principal, "Resource" => Resource);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_lake_formation_opt_in(
    Principal,
    Resource,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lakeformation(
        "POST",
        "/CreateLakeFormationOptIn",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Principal" => Principal, "Resource" => Resource),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_lftag(tag_key, tag_values)
    create_lftag(tag_key, tag_values, params::Dict{String,<:Any})

Creates an LF-tag with the specified name and values.

# Arguments
- `tag_key`: The key-name for the LF-tag.
- `tag_values`: A list of possible values an attribute can take.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CatalogId"`: The identifier for the Data Catalog. By default, the account ID. The Data
  Catalog is the persistent metadata store. It contains database definitions, table
  definitions, and other control information to manage your Lake Formation environment.
"""
function create_lftag(TagKey, TagValues; aws_config::AbstractAWSConfig=current_aws_config())
    return lakeformation(
        "POST",
        "/CreateLFTag",
        Dict{String,Any}("TagKey" => TagKey, "TagValues" => TagValues);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_lftag(
    TagKey,
    TagValues,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lakeformation(
        "POST",
        "/CreateLFTag",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("TagKey" => TagKey, "TagValues" => TagValues),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_data_cells_filter()
    delete_data_cells_filter(params::Dict{String,<:Any})

Deletes a data cell filter.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DatabaseName"`: A database in the Glue Data Catalog.
- `"Name"`: The name given by the user to the data filter cell.
- `"TableCatalogId"`: The ID of the catalog to which the table belongs.
- `"TableName"`: A table in the database.
"""
function delete_data_cells_filter(; aws_config::AbstractAWSConfig=current_aws_config())
    return lakeformation(
        "POST",
        "/DeleteDataCellsFilter";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_data_cells_filter(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lakeformation(
        "POST",
        "/DeleteDataCellsFilter",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_lake_formation_identity_center_configuration()
    delete_lake_formation_identity_center_configuration(params::Dict{String,<:Any})

Deletes an IAM Identity Center connection with Lake Formation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CatalogId"`: The identifier for the Data Catalog. By default, the account ID. The Data
  Catalog is the persistent metadata store. It contains database definitions, table
  definitions, view definition, and other control information to manage your Lake Formation
  environment.
"""
function delete_lake_formation_identity_center_configuration(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return lakeformation(
        "POST",
        "/DeleteLakeFormationIdentityCenterConfiguration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_lake_formation_identity_center_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lakeformation(
        "POST",
        "/DeleteLakeFormationIdentityCenterConfiguration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_lake_formation_opt_in(principal, resource)
    delete_lake_formation_opt_in(principal, resource, params::Dict{String,<:Any})

Remove the Lake Formation permissions enforcement of the given databases, tables, and
principals.

# Arguments
- `principal`:
- `resource`:

"""
function delete_lake_formation_opt_in(
    Principal, Resource; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lakeformation(
        "POST",
        "/DeleteLakeFormationOptIn",
        Dict{String,Any}("Principal" => Principal, "Resource" => Resource);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_lake_formation_opt_in(
    Principal,
    Resource,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lakeformation(
        "POST",
        "/DeleteLakeFormationOptIn",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Principal" => Principal, "Resource" => Resource),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_lftag(tag_key)
    delete_lftag(tag_key, params::Dict{String,<:Any})

Deletes the specified LF-tag given a key name. If the input parameter tag key was not
found, then the operation will throw an exception. When you delete an LF-tag, the
LFTagPolicy attached to the LF-tag becomes invalid. If the deleted LF-tag was still
assigned to any resource, the tag policy attach to the deleted LF-tag will no longer be
applied to the resource.

# Arguments
- `tag_key`: The key-name for the LF-tag to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CatalogId"`: The identifier for the Data Catalog. By default, the account ID. The Data
  Catalog is the persistent metadata store. It contains database definitions, table
  definitions, and other control information to manage your Lake Formation environment.
"""
function delete_lftag(TagKey; aws_config::AbstractAWSConfig=current_aws_config())
    return lakeformation(
        "POST",
        "/DeleteLFTag",
        Dict{String,Any}("TagKey" => TagKey);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_lftag(
    TagKey, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lakeformation(
        "POST",
        "/DeleteLFTag",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("TagKey" => TagKey), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_objects_on_cancel(database_name, objects, table_name, transaction_id)
    delete_objects_on_cancel(database_name, objects, table_name, transaction_id, params::Dict{String,<:Any})

For a specific governed table, provides a list of Amazon S3 objects that will be written
during the current transaction and that can be automatically deleted if the transaction is
canceled. Without this call, no Amazon S3 objects are automatically deleted when a
transaction cancels.   The Glue ETL library function write_dynamic_frame.from_catalog()
includes an option to automatically call DeleteObjectsOnCancel before writes. For more
information, see Rolling Back Amazon S3 Writes.

# Arguments
- `database_name`: The database that contains the governed table.
- `objects`: A list of VirtualObject structures, which indicates the Amazon S3 objects to
  be deleted if the transaction cancels.
- `table_name`: The name of the governed table.
- `transaction_id`: ID of the transaction that the writes occur in.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CatalogId"`: The Glue data catalog that contains the governed table. Defaults to the
  current account ID.
"""
function delete_objects_on_cancel(
    DatabaseName,
    Objects,
    TableName,
    TransactionId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lakeformation(
        "POST",
        "/DeleteObjectsOnCancel",
        Dict{String,Any}(
            "DatabaseName" => DatabaseName,
            "Objects" => Objects,
            "TableName" => TableName,
            "TransactionId" => TransactionId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_objects_on_cancel(
    DatabaseName,
    Objects,
    TableName,
    TransactionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lakeformation(
        "POST",
        "/DeleteObjectsOnCancel",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DatabaseName" => DatabaseName,
                    "Objects" => Objects,
                    "TableName" => TableName,
                    "TransactionId" => TransactionId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    deregister_resource(resource_arn)
    deregister_resource(resource_arn, params::Dict{String,<:Any})

Deregisters the resource as managed by the Data Catalog. When you deregister a path, Lake
Formation removes the path from the inline policy attached to your service-linked role.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource that you want to
  deregister.

"""
function deregister_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lakeformation(
        "POST",
        "/DeregisterResource",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function deregister_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lakeformation(
        "POST",
        "/DeregisterResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_lake_formation_identity_center_configuration()
    describe_lake_formation_identity_center_configuration(params::Dict{String,<:Any})

Retrieves the instance ARN and application ARN for the connection.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CatalogId"`: The identifier for the Data Catalog. By default, the account ID. The Data
  Catalog is the persistent metadata store. It contains database definitions, table
  definitions, and other control information to manage your Lake Formation environment.
"""
function describe_lake_formation_identity_center_configuration(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return lakeformation(
        "POST",
        "/DescribeLakeFormationIdentityCenterConfiguration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_lake_formation_identity_center_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lakeformation(
        "POST",
        "/DescribeLakeFormationIdentityCenterConfiguration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_resource(resource_arn)
    describe_resource(resource_arn, params::Dict{String,<:Any})

Retrieves the current data access role for the given resource registered in Lake Formation.

# Arguments
- `resource_arn`: The resource ARN.

"""
function describe_resource(ResourceArn; aws_config::AbstractAWSConfig=current_aws_config())
    return lakeformation(
        "POST",
        "/DescribeResource",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lakeformation(
        "POST",
        "/DescribeResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_transaction(transaction_id)
    describe_transaction(transaction_id, params::Dict{String,<:Any})

Returns the details of a single transaction.

# Arguments
- `transaction_id`: The transaction for which to return status.

"""
function describe_transaction(
    TransactionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lakeformation(
        "POST",
        "/DescribeTransaction",
        Dict{String,Any}("TransactionId" => TransactionId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_transaction(
    TransactionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lakeformation(
        "POST",
        "/DescribeTransaction",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TransactionId" => TransactionId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    extend_transaction()
    extend_transaction(params::Dict{String,<:Any})

Indicates to the service that the specified transaction is still active and should not be
treated as idle and aborted. Write transactions that remain idle for a long period are
automatically aborted unless explicitly extended.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"TransactionId"`: The transaction to extend.
"""
function extend_transaction(; aws_config::AbstractAWSConfig=current_aws_config())
    return lakeformation(
        "POST", "/ExtendTransaction"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function extend_transaction(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lakeformation(
        "POST",
        "/ExtendTransaction",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_data_cells_filter(database_name, name, table_catalog_id, table_name)
    get_data_cells_filter(database_name, name, table_catalog_id, table_name, params::Dict{String,<:Any})

Returns a data cells filter.

# Arguments
- `database_name`: A database in the Glue Data Catalog.
- `name`: The name given by the user to the data filter cell.
- `table_catalog_id`: The ID of the catalog to which the table belongs.
- `table_name`: A table in the database.

"""
function get_data_cells_filter(
    DatabaseName,
    Name,
    TableCatalogId,
    TableName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lakeformation(
        "POST",
        "/GetDataCellsFilter",
        Dict{String,Any}(
            "DatabaseName" => DatabaseName,
            "Name" => Name,
            "TableCatalogId" => TableCatalogId,
            "TableName" => TableName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_data_cells_filter(
    DatabaseName,
    Name,
    TableCatalogId,
    TableName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lakeformation(
        "POST",
        "/GetDataCellsFilter",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DatabaseName" => DatabaseName,
                    "Name" => Name,
                    "TableCatalogId" => TableCatalogId,
                    "TableName" => TableName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_data_lake_principal()
    get_data_lake_principal(params::Dict{String,<:Any})

Returns the identity of the invoking principal.

"""
function get_data_lake_principal(; aws_config::AbstractAWSConfig=current_aws_config())
    return lakeformation(
        "POST",
        "/GetDataLakePrincipal";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_data_lake_principal(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lakeformation(
        "POST",
        "/GetDataLakePrincipal",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_data_lake_settings()
    get_data_lake_settings(params::Dict{String,<:Any})

Retrieves the list of the data lake administrators of a Lake Formation-managed data lake.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CatalogId"`: The identifier for the Data Catalog. By default, the account ID. The Data
  Catalog is the persistent metadata store. It contains database definitions, table
  definitions, and other control information to manage your Lake Formation environment.
"""
function get_data_lake_settings(; aws_config::AbstractAWSConfig=current_aws_config())
    return lakeformation(
        "POST",
        "/GetDataLakeSettings";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_data_lake_settings(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lakeformation(
        "POST",
        "/GetDataLakeSettings",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_effective_permissions_for_path(resource_arn)
    get_effective_permissions_for_path(resource_arn, params::Dict{String,<:Any})

Returns the Lake Formation permissions for a specified table or database resource located
at a path in Amazon S3. GetEffectivePermissionsForPath will not return databases and tables
if the catalog is encrypted.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource for which you want to get
  permissions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CatalogId"`: The identifier for the Data Catalog. By default, the account ID. The Data
  Catalog is the persistent metadata store. It contains database definitions, table
  definitions, and other control information to manage your Lake Formation environment.
- `"MaxResults"`: The maximum number of results to return.
- `"NextToken"`: A continuation token, if this is not the first call to retrieve this list.
"""
function get_effective_permissions_for_path(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lakeformation(
        "POST",
        "/GetEffectivePermissionsForPath",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_effective_permissions_for_path(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lakeformation(
        "POST",
        "/GetEffectivePermissionsForPath",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_lftag(tag_key)
    get_lftag(tag_key, params::Dict{String,<:Any})

Returns an LF-tag definition.

# Arguments
- `tag_key`: The key-name for the LF-tag.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CatalogId"`: The identifier for the Data Catalog. By default, the account ID. The Data
  Catalog is the persistent metadata store. It contains database definitions, table
  definitions, and other control information to manage your Lake Formation environment.
"""
function get_lftag(TagKey; aws_config::AbstractAWSConfig=current_aws_config())
    return lakeformation(
        "POST",
        "/GetLFTag",
        Dict{String,Any}("TagKey" => TagKey);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_lftag(
    TagKey, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lakeformation(
        "POST",
        "/GetLFTag",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("TagKey" => TagKey), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_query_state(query_id)
    get_query_state(query_id, params::Dict{String,<:Any})

Returns the state of a query previously submitted. Clients are expected to poll
GetQueryState to monitor the current state of the planning before retrieving the work
units. A query state is only visible to the principal that made the initial call to
StartQueryPlanning.

# Arguments
- `query_id`: The ID of the plan query operation.

"""
function get_query_state(QueryId; aws_config::AbstractAWSConfig=current_aws_config())
    return lakeformation(
        "POST",
        "/GetQueryState",
        Dict{String,Any}("QueryId" => QueryId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_query_state(
    QueryId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lakeformation(
        "POST",
        "/GetQueryState",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("QueryId" => QueryId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_query_statistics(query_id)
    get_query_statistics(query_id, params::Dict{String,<:Any})

Retrieves statistics on the planning and execution of a query.

# Arguments
- `query_id`: The ID of the plan query operation.

"""
function get_query_statistics(QueryId; aws_config::AbstractAWSConfig=current_aws_config())
    return lakeformation(
        "POST",
        "/GetQueryStatistics",
        Dict{String,Any}("QueryId" => QueryId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_query_statistics(
    QueryId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lakeformation(
        "POST",
        "/GetQueryStatistics",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("QueryId" => QueryId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_resource_lftags(resource)
    get_resource_lftags(resource, params::Dict{String,<:Any})

Returns the LF-tags applied to a resource.

# Arguments
- `resource`: The database, table, or column resource for which you want to return LF-tags.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CatalogId"`: The identifier for the Data Catalog. By default, the account ID. The Data
  Catalog is the persistent metadata store. It contains database definitions, table
  definitions, and other control information to manage your Lake Formation environment.
- `"ShowAssignedLFTags"`: Indicates whether to show the assigned LF-tags.
"""
function get_resource_lftags(Resource; aws_config::AbstractAWSConfig=current_aws_config())
    return lakeformation(
        "POST",
        "/GetResourceLFTags",
        Dict{String,Any}("Resource" => Resource);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_resource_lftags(
    Resource,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lakeformation(
        "POST",
        "/GetResourceLFTags",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Resource" => Resource), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_table_objects(database_name, table_name)
    get_table_objects(database_name, table_name, params::Dict{String,<:Any})

Returns the set of Amazon S3 objects that make up the specified governed table. A
transaction ID or timestamp can be specified for time-travel queries.

# Arguments
- `database_name`: The database containing the governed table.
- `table_name`: The governed table for which to retrieve objects.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CatalogId"`: The catalog containing the governed table. Defaults to the caller’s
  account.
- `"MaxResults"`: Specifies how many values to return in a page.
- `"NextToken"`: A continuation token if this is not the first call to retrieve these
  objects.
- `"PartitionPredicate"`: A predicate to filter the objects returned based on the partition
  keys defined in the governed table.   The comparison operators supported are: =, &gt;,
  &lt;, &gt;=, &lt;=   The logical operators supported are: AND   The data types supported
  are integer, long, date(yyyy-MM-dd), timestamp(yyyy-MM-dd HH:mm:ssXXX or yyyy-MM-dd
  HH:mm:ss\"), string and decimal.
- `"QueryAsOfTime"`: The time as of when to read the governed table contents. If not set,
  the most recent transaction commit time is used. Cannot be specified along with
  TransactionId.
- `"TransactionId"`: The transaction ID at which to read the governed table contents. If
  this transaction has aborted, an error is returned. If not set, defaults to the most recent
  committed transaction. Cannot be specified along with QueryAsOfTime.
"""
function get_table_objects(
    DatabaseName, TableName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lakeformation(
        "POST",
        "/GetTableObjects",
        Dict{String,Any}("DatabaseName" => DatabaseName, "TableName" => TableName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_table_objects(
    DatabaseName,
    TableName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lakeformation(
        "POST",
        "/GetTableObjects",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DatabaseName" => DatabaseName, "TableName" => TableName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_temporary_glue_partition_credentials(partition, table_arn)
    get_temporary_glue_partition_credentials(partition, table_arn, params::Dict{String,<:Any})

This API is identical to GetTemporaryTableCredentials except that this is used when the
target Data Catalog resource is of type Partition. Lake Formation restricts the permission
of the vended credentials with the same scope down policy which restricts access to a
single Amazon S3 prefix.

# Arguments
- `partition`: A list of partition values identifying a single partition.
- `table_arn`: The ARN of the partitions' table.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AuditContext"`: A structure representing context to access a resource (column names,
  query ID, etc).
- `"DurationSeconds"`: The time period, between 900 and 21,600 seconds, for the timeout of
  the temporary credentials.
- `"Permissions"`: Filters the request based on the user having been granted a list of
  specified permissions on the requested resource(s).
- `"SupportedPermissionTypes"`: A list of supported permission types for the partition.
  Valid values are COLUMN_PERMISSION and CELL_FILTER_PERMISSION.
"""
function get_temporary_glue_partition_credentials(
    Partition, TableArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lakeformation(
        "POST",
        "/GetTemporaryGluePartitionCredentials",
        Dict{String,Any}("Partition" => Partition, "TableArn" => TableArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_temporary_glue_partition_credentials(
    Partition,
    TableArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lakeformation(
        "POST",
        "/GetTemporaryGluePartitionCredentials",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Partition" => Partition, "TableArn" => TableArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_temporary_glue_table_credentials(table_arn)
    get_temporary_glue_table_credentials(table_arn, params::Dict{String,<:Any})

Allows a caller in a secure environment to assume a role with permission to access Amazon
S3. In order to vend such credentials, Lake Formation assumes the role associated with a
registered location, for example an Amazon S3 bucket, with a scope down policy which
restricts the access to a single prefix.

# Arguments
- `table_arn`: The ARN identifying a table in the Data Catalog for the temporary
  credentials request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AuditContext"`: A structure representing context to access a resource (column names,
  query ID, etc).
- `"DurationSeconds"`: The time period, between 900 and 21,600 seconds, for the timeout of
  the temporary credentials.
- `"Permissions"`: Filters the request based on the user having been granted a list of
  specified permissions on the requested resource(s).
- `"QuerySessionContext"`: A structure used as a protocol between query engines and Lake
  Formation or Glue. Contains both a Lake Formation generated authorization identifier and
  information from the request's authorization context.
- `"S3Path"`: The Amazon S3 path for the table.
- `"SupportedPermissionTypes"`: A list of supported permission types for the table. Valid
  values are COLUMN_PERMISSION and CELL_FILTER_PERMISSION.
"""
function get_temporary_glue_table_credentials(
    TableArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lakeformation(
        "POST",
        "/GetTemporaryGlueTableCredentials",
        Dict{String,Any}("TableArn" => TableArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_temporary_glue_table_credentials(
    TableArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lakeformation(
        "POST",
        "/GetTemporaryGlueTableCredentials",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TableArn" => TableArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_work_unit_results(query_id, work_unit_id, work_unit_token)
    get_work_unit_results(query_id, work_unit_id, work_unit_token, params::Dict{String,<:Any})

Returns the work units resulting from the query. Work units can be executed in any order
and in parallel.

# Arguments
- `query_id`: The ID of the plan query operation for which to get results.
- `work_unit_id`: The work unit ID for which to get results. Value generated by enumerating
  WorkUnitIdMin to WorkUnitIdMax (inclusive) from the WorkUnitRange in the output of
  GetWorkUnits.
- `work_unit_token`: A work token used to query the execution service. Token output from
  GetWorkUnits.

"""
function get_work_unit_results(
    QueryId, WorkUnitId, WorkUnitToken; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lakeformation(
        "POST",
        "/GetWorkUnitResults",
        Dict{String,Any}(
            "QueryId" => QueryId,
            "WorkUnitId" => WorkUnitId,
            "WorkUnitToken" => WorkUnitToken,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_work_unit_results(
    QueryId,
    WorkUnitId,
    WorkUnitToken,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lakeformation(
        "POST",
        "/GetWorkUnitResults",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "QueryId" => QueryId,
                    "WorkUnitId" => WorkUnitId,
                    "WorkUnitToken" => WorkUnitToken,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_work_units(query_id)
    get_work_units(query_id, params::Dict{String,<:Any})

Retrieves the work units generated by the StartQueryPlanning operation.

# Arguments
- `query_id`: The ID of the plan query operation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: A continuation token, if this is a continuation call.
- `"PageSize"`: The size of each page to get in the Amazon Web Services service call. This
  does not affect the number of items returned in the command's output. Setting a smaller
  page size results in more calls to the Amazon Web Services service, retrieving fewer items
  in each call. This can help prevent the Amazon Web Services service calls from timing out.
"""
function get_work_units(QueryId; aws_config::AbstractAWSConfig=current_aws_config())
    return lakeformation(
        "POST",
        "/GetWorkUnits",
        Dict{String,Any}("QueryId" => QueryId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_work_units(
    QueryId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lakeformation(
        "POST",
        "/GetWorkUnits",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("QueryId" => QueryId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    grant_permissions(permissions, principal, resource)
    grant_permissions(permissions, principal, resource, params::Dict{String,<:Any})

Grants permissions to the principal to access metadata in the Data Catalog and data
organized in underlying data storage such as Amazon S3. For information about permissions,
see Security and Access Control to Metadata and Data.

# Arguments
- `permissions`: The permissions granted to the principal on the resource. Lake Formation
  defines privileges to grant and revoke access to metadata in the Data Catalog and data
  organized in underlying data storage such as Amazon S3. Lake Formation requires that each
  principal be authorized to perform a specific task on Lake Formation resources.
- `principal`: The principal to be granted the permissions on the resource. Supported
  principals are IAM users or IAM roles, and they are defined by their principal type and
  their ARN. Note that if you define a resource with a particular ARN, then later delete, and
  recreate a resource with that same ARN, the resource maintains the permissions already
  granted.
- `resource`: The resource to which permissions are to be granted. Resources in Lake
  Formation are the Data Catalog, databases, and tables.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CatalogId"`: The identifier for the Data Catalog. By default, the account ID. The Data
  Catalog is the persistent metadata store. It contains database definitions, table
  definitions, and other control information to manage your Lake Formation environment.
- `"PermissionsWithGrantOption"`: Indicates a list of the granted permissions that the
  principal may pass to other users. These permissions may only be a subset of the
  permissions granted in the Privileges.
"""
function grant_permissions(
    Permissions, Principal, Resource; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lakeformation(
        "POST",
        "/GrantPermissions",
        Dict{String,Any}(
            "Permissions" => Permissions, "Principal" => Principal, "Resource" => Resource
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function grant_permissions(
    Permissions,
    Principal,
    Resource,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lakeformation(
        "POST",
        "/GrantPermissions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Permissions" => Permissions,
                    "Principal" => Principal,
                    "Resource" => Resource,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_data_cells_filter()
    list_data_cells_filter(params::Dict{String,<:Any})

Lists all the data cell filters on a table.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum size of the response.
- `"NextToken"`: A continuation token, if this is a continuation call.
- `"Table"`: A table in the Glue Data Catalog.
"""
function list_data_cells_filter(; aws_config::AbstractAWSConfig=current_aws_config())
    return lakeformation(
        "POST",
        "/ListDataCellsFilter";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_data_cells_filter(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lakeformation(
        "POST",
        "/ListDataCellsFilter",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_lake_formation_opt_ins()
    list_lake_formation_opt_ins(params::Dict{String,<:Any})

Retrieve the current list of resources and principals that are opt in to enforce Lake
Formation permissions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to return.
- `"NextToken"`: A continuation token, if this is not the first call to retrieve this list.
- `"Principal"`:
- `"Resource"`: A structure for the resource.
"""
function list_lake_formation_opt_ins(; aws_config::AbstractAWSConfig=current_aws_config())
    return lakeformation(
        "POST",
        "/ListLakeFormationOptIns";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_lake_formation_opt_ins(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lakeformation(
        "POST",
        "/ListLakeFormationOptIns",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_lftags()
    list_lftags(params::Dict{String,<:Any})

Lists LF-tags that the requester has permission to view.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CatalogId"`: The identifier for the Data Catalog. By default, the account ID. The Data
  Catalog is the persistent metadata store. It contains database definitions, table
  definitions, and other control information to manage your Lake Formation environment.
- `"MaxResults"`: The maximum number of results to return.
- `"NextToken"`: A continuation token, if this is not the first call to retrieve this list.
- `"ResourceShareType"`: If resource share type is ALL, returns both in-account LF-tags and
  shared LF-tags that the requester has permission to view. If resource share type is
  FOREIGN, returns all share LF-tags that the requester can view. If no resource share type
  is passed, lists LF-tags in the given catalog ID that the requester has permission to view.
"""
function list_lftags(; aws_config::AbstractAWSConfig=current_aws_config())
    return lakeformation(
        "POST", "/ListLFTags"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_lftags(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lakeformation(
        "POST",
        "/ListLFTags",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_permissions()
    list_permissions(params::Dict{String,<:Any})

Returns a list of the principal permissions on the resource, filtered by the permissions of
the caller. For example, if you are granted an ALTER permission, you are able to see only
the principal permissions for ALTER. This operation returns only those permissions that
have been explicitly granted. For information about permissions, see Security and Access
Control to Metadata and Data.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CatalogId"`: The identifier for the Data Catalog. By default, the account ID. The Data
  Catalog is the persistent metadata store. It contains database definitions, table
  definitions, and other control information to manage your Lake Formation environment.
- `"IncludeRelated"`: Indicates that related permissions should be included in the results.
- `"MaxResults"`: The maximum number of results to return.
- `"NextToken"`: A continuation token, if this is not the first call to retrieve this list.
- `"Principal"`: Specifies a principal to filter the permissions returned.
- `"Resource"`: A resource where you will get a list of the principal permissions. This
  operation does not support getting privileges on a table with columns. Instead, call this
  operation on the table, and the operation returns the table and the table w columns.
- `"ResourceType"`: Specifies a resource type to filter the permissions returned.
"""
function list_permissions(; aws_config::AbstractAWSConfig=current_aws_config())
    return lakeformation(
        "POST", "/ListPermissions"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_permissions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lakeformation(
        "POST",
        "/ListPermissions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_resources()
    list_resources(params::Dict{String,<:Any})

Lists the resources registered to be managed by the Data Catalog.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FilterConditionList"`: Any applicable row-level and/or column-level filtering
  conditions for the resources.
- `"MaxResults"`: The maximum number of resource results.
- `"NextToken"`: A continuation token, if this is not the first call to retrieve these
  resources.
"""
function list_resources(; aws_config::AbstractAWSConfig=current_aws_config())
    return lakeformation(
        "POST", "/ListResources"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_resources(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lakeformation(
        "POST",
        "/ListResources",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_table_storage_optimizers(database_name, table_name)
    list_table_storage_optimizers(database_name, table_name, params::Dict{String,<:Any})

Returns the configuration of all storage optimizers associated with a specified table.

# Arguments
- `database_name`: Name of the database where the table is present.
- `table_name`: Name of the table.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CatalogId"`: The Catalog ID of the table.
- `"MaxResults"`: The number of storage optimizers to return on each call.
- `"NextToken"`: A continuation token, if this is a continuation call.
- `"StorageOptimizerType"`: The specific type of storage optimizers to list. The supported
  value is compaction.
"""
function list_table_storage_optimizers(
    DatabaseName, TableName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lakeformation(
        "POST",
        "/ListTableStorageOptimizers",
        Dict{String,Any}("DatabaseName" => DatabaseName, "TableName" => TableName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_table_storage_optimizers(
    DatabaseName,
    TableName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lakeformation(
        "POST",
        "/ListTableStorageOptimizers",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DatabaseName" => DatabaseName, "TableName" => TableName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_transactions()
    list_transactions(params::Dict{String,<:Any})

Returns metadata about transactions and their status. To prevent the response from growing
indefinitely, only uncommitted transactions and those available for time-travel queries are
returned. This operation can help you identify uncommitted transactions or to get
information about transactions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CatalogId"`: The catalog for which to list transactions. Defaults to the account ID of
  the caller.
- `"MaxResults"`: The maximum number of transactions to return in a single call.
- `"NextToken"`: A continuation token if this is not the first call to retrieve
  transactions.
- `"StatusFilter"`:  A filter indicating the status of transactions to return. Options are
  ALL | COMPLETED | COMMITTED | ABORTED | ACTIVE. The default is ALL.
"""
function list_transactions(; aws_config::AbstractAWSConfig=current_aws_config())
    return lakeformation(
        "POST", "/ListTransactions"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_transactions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lakeformation(
        "POST",
        "/ListTransactions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_data_lake_settings(data_lake_settings)
    put_data_lake_settings(data_lake_settings, params::Dict{String,<:Any})

Sets the list of data lake administrators who have admin privileges on all resources
managed by Lake Formation. For more information on admin privileges, see Granting Lake
Formation Permissions. This API replaces the current list of data lake admins with the new
list being passed. To add an admin, fetch the current list and add the new admin to that
list and pass that list in this API.

# Arguments
- `data_lake_settings`: A structure representing a list of Lake Formation principals
  designated as data lake administrators.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CatalogId"`: The identifier for the Data Catalog. By default, the account ID. The Data
  Catalog is the persistent metadata store. It contains database definitions, table
  definitions, and other control information to manage your Lake Formation environment.
"""
function put_data_lake_settings(
    DataLakeSettings; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lakeformation(
        "POST",
        "/PutDataLakeSettings",
        Dict{String,Any}("DataLakeSettings" => DataLakeSettings);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_data_lake_settings(
    DataLakeSettings,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lakeformation(
        "POST",
        "/PutDataLakeSettings",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("DataLakeSettings" => DataLakeSettings), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    register_resource(resource_arn)
    register_resource(resource_arn, params::Dict{String,<:Any})

Registers the resource as managed by the Data Catalog. To add or update data, Lake
Formation needs read/write access to the chosen Amazon S3 path. Choose a role that you know
has permission to do this, or choose the AWSServiceRoleForLakeFormationDataAccess
service-linked role. When you register the first Amazon S3 path, the service-linked role
and a new inline policy are created on your behalf. Lake Formation adds the first path to
the inline policy and attaches it to the service-linked role. When you register subsequent
paths, Lake Formation adds the path to the existing policy. The following request registers
a new location and gives Lake Formation permission to use the service-linked role to access
that location.  ResourceArn = arn:aws:s3:::my-bucket UseServiceLinkedRole = true  If
UseServiceLinkedRole is not set to true, you must provide or set the RoleArn:
arn:aws:iam::12345:role/my-data-access-role

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource that you want to register.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"HybridAccessEnabled"`:  Specifies whether the data access of tables pointing to the
  location can be managed by both Lake Formation permissions as well as Amazon S3 bucket
  policies.
- `"RoleArn"`: The identifier for the role that registers the resource.
- `"UseServiceLinkedRole"`: Designates an Identity and Access Management (IAM)
  service-linked role by registering this role with the Data Catalog. A service-linked role
  is a unique type of IAM role that is linked directly to Lake Formation. For more
  information, see Using Service-Linked Roles for Lake Formation.
- `"WithFederation"`: Whether or not the resource is a federated resource.
"""
function register_resource(ResourceArn; aws_config::AbstractAWSConfig=current_aws_config())
    return lakeformation(
        "POST",
        "/RegisterResource",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function register_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lakeformation(
        "POST",
        "/RegisterResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_lftags_from_resource(lftags, resource)
    remove_lftags_from_resource(lftags, resource, params::Dict{String,<:Any})

Removes an LF-tag from the resource. Only database, table, or tableWithColumns resource are
allowed. To tag columns, use the column inclusion list in tableWithColumns to specify
column input.

# Arguments
- `lftags`: The LF-tags to be removed from the resource.
- `resource`: The database, table, or column resource where you want to remove an LF-tag.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CatalogId"`: The identifier for the Data Catalog. By default, the account ID. The Data
  Catalog is the persistent metadata store. It contains database definitions, table
  definitions, and other control information to manage your Lake Formation environment.
"""
function remove_lftags_from_resource(
    LFTags, Resource; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lakeformation(
        "POST",
        "/RemoveLFTagsFromResource",
        Dict{String,Any}("LFTags" => LFTags, "Resource" => Resource);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_lftags_from_resource(
    LFTags,
    Resource,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lakeformation(
        "POST",
        "/RemoveLFTagsFromResource",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("LFTags" => LFTags, "Resource" => Resource), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    revoke_permissions(permissions, principal, resource)
    revoke_permissions(permissions, principal, resource, params::Dict{String,<:Any})

Revokes permissions to the principal to access metadata in the Data Catalog and data
organized in underlying data storage such as Amazon S3.

# Arguments
- `permissions`: The permissions revoked to the principal on the resource. For information
  about permissions, see Security and Access Control to Metadata and Data.
- `principal`: The principal to be revoked permissions on the resource.
- `resource`: The resource to which permissions are to be revoked.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CatalogId"`: The identifier for the Data Catalog. By default, the account ID. The Data
  Catalog is the persistent metadata store. It contains database definitions, table
  definitions, and other control information to manage your Lake Formation environment.
- `"PermissionsWithGrantOption"`: Indicates a list of permissions for which to revoke the
  grant option allowing the principal to pass permissions to other principals.
"""
function revoke_permissions(
    Permissions, Principal, Resource; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lakeformation(
        "POST",
        "/RevokePermissions",
        Dict{String,Any}(
            "Permissions" => Permissions, "Principal" => Principal, "Resource" => Resource
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function revoke_permissions(
    Permissions,
    Principal,
    Resource,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lakeformation(
        "POST",
        "/RevokePermissions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Permissions" => Permissions,
                    "Principal" => Principal,
                    "Resource" => Resource,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    search_databases_by_lftags(expression)
    search_databases_by_lftags(expression, params::Dict{String,<:Any})

This operation allows a search on DATABASE resources by TagCondition. This operation is
used by admins who want to grant user permissions on certain TagConditions. Before making a
grant, the admin can use SearchDatabasesByTags to find all resources where the given
TagConditions are valid to verify whether the returned resources can be shared.

# Arguments
- `expression`: A list of conditions (LFTag structures) to search for in database resources.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CatalogId"`: The identifier for the Data Catalog. By default, the account ID. The Data
  Catalog is the persistent metadata store. It contains database definitions, table
  definitions, and other control information to manage your Lake Formation environment.
- `"MaxResults"`: The maximum number of results to return.
- `"NextToken"`: A continuation token, if this is not the first call to retrieve this list.
"""
function search_databases_by_lftags(
    Expression; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lakeformation(
        "POST",
        "/SearchDatabasesByLFTags",
        Dict{String,Any}("Expression" => Expression);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function search_databases_by_lftags(
    Expression,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lakeformation(
        "POST",
        "/SearchDatabasesByLFTags",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Expression" => Expression), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    search_tables_by_lftags(expression)
    search_tables_by_lftags(expression, params::Dict{String,<:Any})

This operation allows a search on TABLE resources by LFTags. This will be used by admins
who want to grant user permissions on certain LF-tags. Before making a grant, the admin can
use SearchTablesByLFTags to find all resources where the given LFTags are valid to verify
whether the returned resources can be shared.

# Arguments
- `expression`: A list of conditions (LFTag structures) to search for in table resources.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CatalogId"`: The identifier for the Data Catalog. By default, the account ID. The Data
  Catalog is the persistent metadata store. It contains database definitions, table
  definitions, and other control information to manage your Lake Formation environment.
- `"MaxResults"`: The maximum number of results to return.
- `"NextToken"`: A continuation token, if this is not the first call to retrieve this list.
"""
function search_tables_by_lftags(
    Expression; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lakeformation(
        "POST",
        "/SearchTablesByLFTags",
        Dict{String,Any}("Expression" => Expression);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function search_tables_by_lftags(
    Expression,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lakeformation(
        "POST",
        "/SearchTablesByLFTags",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Expression" => Expression), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_query_planning(query_planning_context, query_string)
    start_query_planning(query_planning_context, query_string, params::Dict{String,<:Any})

Submits a request to process a query statement. This operation generates work units that
can be retrieved with the GetWorkUnits operation as soon as the query state is
WORKUNITS_AVAILABLE or FINISHED.

# Arguments
- `query_planning_context`: A structure containing information about the query plan.
- `query_string`: A PartiQL query statement used as an input to the planner service.

"""
function start_query_planning(
    QueryPlanningContext, QueryString; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lakeformation(
        "POST",
        "/StartQueryPlanning",
        Dict{String,Any}(
            "QueryPlanningContext" => QueryPlanningContext, "QueryString" => QueryString
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_query_planning(
    QueryPlanningContext,
    QueryString,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lakeformation(
        "POST",
        "/StartQueryPlanning",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "QueryPlanningContext" => QueryPlanningContext,
                    "QueryString" => QueryString,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_transaction()
    start_transaction(params::Dict{String,<:Any})

Starts a new transaction and returns its transaction ID. Transaction IDs are opaque objects
that you can use to identify a transaction.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"TransactionType"`: Indicates whether this transaction should be read only or read and
  write. Writes made using a read-only transaction ID will be rejected. Read-only
  transactions do not need to be committed.
"""
function start_transaction(; aws_config::AbstractAWSConfig=current_aws_config())
    return lakeformation(
        "POST", "/StartTransaction"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function start_transaction(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lakeformation(
        "POST",
        "/StartTransaction",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_data_cells_filter(table_data)
    update_data_cells_filter(table_data, params::Dict{String,<:Any})

Updates a data cell filter.

# Arguments
- `table_data`: A DataCellsFilter structure containing information about the data cells
  filter.

"""
function update_data_cells_filter(
    TableData; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lakeformation(
        "POST",
        "/UpdateDataCellsFilter",
        Dict{String,Any}("TableData" => TableData);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_data_cells_filter(
    TableData,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lakeformation(
        "POST",
        "/UpdateDataCellsFilter",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TableData" => TableData), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_lake_formation_identity_center_configuration()
    update_lake_formation_identity_center_configuration(params::Dict{String,<:Any})

Updates the IAM Identity Center connection parameters.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ApplicationStatus"`: Allows to enable or disable the IAM Identity Center connection.
- `"CatalogId"`: The identifier for the Data Catalog. By default, the account ID. The Data
  Catalog is the persistent metadata store. It contains database definitions, table
  definitions, view definitions, and other control information to manage your Lake Formation
  environment.
- `"ExternalFiltering"`: A list of the account IDs of Amazon Web Services accounts of
  third-party applications that are allowed to access data managed by Lake Formation.
- `"ShareRecipients"`: A list of Amazon Web Services account IDs or Amazon Web Services
  organization/organizational unit ARNs that are allowed to access to access data managed by
  Lake Formation.  If the ShareRecipients list includes valid values, then the resource share
  is updated with the principals you want to have access to the resources. If the
  ShareRecipients value is null, both the list of share recipients and the resource share
  remain unchanged. If the ShareRecipients value is an empty list, then the existing share
  recipients list will be cleared, and the resource share will be deleted.
"""
function update_lake_formation_identity_center_configuration(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return lakeformation(
        "POST",
        "/UpdateLakeFormationIdentityCenterConfiguration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_lake_formation_identity_center_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lakeformation(
        "POST",
        "/UpdateLakeFormationIdentityCenterConfiguration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_lftag(tag_key)
    update_lftag(tag_key, params::Dict{String,<:Any})

Updates the list of possible values for the specified LF-tag key. If the LF-tag does not
exist, the operation throws an EntityNotFoundException. The values in the delete key values
will be deleted from list of possible values. If any value in the delete key values is
attached to a resource, then API errors out with a 400 Exception - \"Update not allowed\".
Untag the attribute before deleting the LF-tag key's value.

# Arguments
- `tag_key`: The key-name for the LF-tag for which to add or delete values.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CatalogId"`: The identifier for the Data Catalog. By default, the account ID. The Data
  Catalog is the persistent metadata store. It contains database definitions, table
  definitions, and other control information to manage your Lake Formation environment.
- `"TagValuesToAdd"`: A list of LF-tag values to add from the LF-tag.
- `"TagValuesToDelete"`: A list of LF-tag values to delete from the LF-tag.
"""
function update_lftag(TagKey; aws_config::AbstractAWSConfig=current_aws_config())
    return lakeformation(
        "POST",
        "/UpdateLFTag",
        Dict{String,Any}("TagKey" => TagKey);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_lftag(
    TagKey, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lakeformation(
        "POST",
        "/UpdateLFTag",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("TagKey" => TagKey), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_resource(resource_arn, role_arn)
    update_resource(resource_arn, role_arn, params::Dict{String,<:Any})

Updates the data access role used for vending access to the given (registered) resource in
Lake Formation.

# Arguments
- `resource_arn`: The resource ARN.
- `role_arn`: The new role to use for the given resource registered in Lake Formation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"HybridAccessEnabled"`:  Specifies whether the data access of tables pointing to the
  location can be managed by both Lake Formation permissions as well as Amazon S3 bucket
  policies.
- `"WithFederation"`: Whether or not the resource is a federated resource.
"""
function update_resource(
    ResourceArn, RoleArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lakeformation(
        "POST",
        "/UpdateResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "RoleArn" => RoleArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_resource(
    ResourceArn,
    RoleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lakeformation(
        "POST",
        "/UpdateResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "RoleArn" => RoleArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_table_objects(database_name, table_name, write_operations)
    update_table_objects(database_name, table_name, write_operations, params::Dict{String,<:Any})

Updates the manifest of Amazon S3 objects that make up the specified governed table.

# Arguments
- `database_name`: The database containing the governed table to update.
- `table_name`: The governed table to update.
- `write_operations`: A list of WriteOperation objects that define an object to add to or
  delete from the manifest for a governed table.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CatalogId"`: The catalog containing the governed table to update. Defaults to the
  caller’s account ID.
- `"TransactionId"`: The transaction at which to do the write.
"""
function update_table_objects(
    DatabaseName,
    TableName,
    WriteOperations;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lakeformation(
        "POST",
        "/UpdateTableObjects",
        Dict{String,Any}(
            "DatabaseName" => DatabaseName,
            "TableName" => TableName,
            "WriteOperations" => WriteOperations,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_table_objects(
    DatabaseName,
    TableName,
    WriteOperations,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lakeformation(
        "POST",
        "/UpdateTableObjects",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DatabaseName" => DatabaseName,
                    "TableName" => TableName,
                    "WriteOperations" => WriteOperations,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_table_storage_optimizer(database_name, storage_optimizer_config, table_name)
    update_table_storage_optimizer(database_name, storage_optimizer_config, table_name, params::Dict{String,<:Any})

Updates the configuration of the storage optimizers for a table.

# Arguments
- `database_name`: Name of the database where the table is present.
- `storage_optimizer_config`: Name of the table for which to enable the storage optimizer.
- `table_name`: Name of the table for which to enable the storage optimizer.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CatalogId"`: The Catalog ID of the table.
"""
function update_table_storage_optimizer(
    DatabaseName,
    StorageOptimizerConfig,
    TableName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lakeformation(
        "POST",
        "/UpdateTableStorageOptimizer",
        Dict{String,Any}(
            "DatabaseName" => DatabaseName,
            "StorageOptimizerConfig" => StorageOptimizerConfig,
            "TableName" => TableName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_table_storage_optimizer(
    DatabaseName,
    StorageOptimizerConfig,
    TableName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lakeformation(
        "POST",
        "/UpdateTableStorageOptimizer",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DatabaseName" => DatabaseName,
                    "StorageOptimizerConfig" => StorageOptimizerConfig,
                    "TableName" => TableName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: rekognition
using AWS.Compat
using AWS.UUIDs

"""
    associate_faces(collection_id, face_ids, user_id)
    associate_faces(collection_id, face_ids, user_id, params::Dict{String,<:Any})

Associates one or more faces with an existing UserID. Takes an array of FaceIds. Each
FaceId that are present in the FaceIds list is associated with the provided UserID. The
maximum number of total FaceIds per UserID is 100.  The UserMatchThreshold parameter
specifies the minimum user match confidence required for the face to be associated with a
UserID that has at least one FaceID already associated. This ensures that the FaceIds are
associated with the right UserID. The value ranges from 0-100 and default value is 75.  If
successful, an array of AssociatedFace objects containing the associated FaceIds is
returned. If a given face is already associated with the given UserID, it will be ignored
and will not be returned in the response. If a given face is already associated to a
different UserID, isn't found in the collection, doesn’t meet the UserMatchThreshold, or
there are already 100 faces associated with the UserID, it will be returned as part of an
array of UnsuccessfulFaceAssociations.  The UserStatus reflects the status of an operation
which updates a UserID representation with a list of given faces. The UserStatus can be:
ACTIVE - All associations or disassociations of FaceID(s) for a UserID are complete.
CREATED - A UserID has been created, but has no FaceID(s) associated with it.   UPDATING -
A UserID is being updated and there are current associations or disassociations of
FaceID(s) taking place.

# Arguments
- `collection_id`: The ID of an existing collection containing the UserID.
- `face_ids`: An array of FaceIDs to associate with the UserID.
- `user_id`: The ID for the existing UserID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: Idempotent token used to identify the request to AssociateFaces.
  If you use the same token with multiple AssociateFaces requests, the same response is
  returned. Use ClientRequestToken to prevent the same request from being processed more than
  once.
- `"UserMatchThreshold"`: An optional value specifying the minimum confidence in the UserID
  match to return. The default value is 75.
"""
function associate_faces(
    CollectionId, FaceIds, UserId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "AssociateFaces",
        Dict{String,Any}(
            "CollectionId" => CollectionId,
            "FaceIds" => FaceIds,
            "UserId" => UserId,
            "ClientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_faces(
    CollectionId,
    FaceIds,
    UserId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rekognition(
        "AssociateFaces",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CollectionId" => CollectionId,
                    "FaceIds" => FaceIds,
                    "UserId" => UserId,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    compare_faces(source_image, target_image)
    compare_faces(source_image, target_image, params::Dict{String,<:Any})

Compares a face in the source input image with each of the 100 largest faces detected in
the target input image.   If the source image contains multiple faces, the service detects
the largest face and compares it with each face detected in the target image.
CompareFaces uses machine learning algorithms, which are probabilistic. A false negative is
an incorrect prediction that a face in the target image has a low similarity confidence
score when compared to the face in the source image. To reduce the probability of false
negatives, we recommend that you compare the target image against multiple source images.
If you plan to use CompareFaces to make a decision that impacts an individual's rights,
privacy, or access to services, we recommend that you pass the result to a human for review
and further validation before taking action.  You pass the input and target images either
as base64-encoded image bytes or as references to images in an Amazon S3 bucket. If you use
the AWS CLI to call Amazon Rekognition operations, passing image bytes isn't supported. The
image must be formatted as a PNG or JPEG file.  In response, the operation returns an array
of face matches ordered by similarity score in descending order. For each face match, the
response provides a bounding box of the face, facial landmarks, pose details (pitch, roll,
and yaw), quality (brightness and sharpness), and confidence value (indicating the level of
confidence that the bounding box contains a face). The response also provides a similarity
score, which indicates how closely the faces match.   By default, only faces with a
similarity score of greater than or equal to 80% are returned in the response. You can
change this value by specifying the SimilarityThreshold parameter.   CompareFaces also
returns an array of faces that don't match the source image. For each face, it returns a
bounding box, confidence value, landmarks, pose details, and quality. The response also
returns information about the face in the source image, including the bounding box of the
face and confidence value. The QualityFilter input parameter allows you to filter out
detected faces that don’t meet a required quality bar. The quality bar is based on a
variety of common use cases. Use QualityFilter to set the quality bar by specifying LOW,
MEDIUM, or HIGH. If you do not want to filter detected faces, specify NONE. The default
value is NONE.  If the image doesn't contain Exif metadata, CompareFaces returns
orientation information for the source and target images. Use these values to display the
images with the correct image orientation. If no faces are detected in the source or target
images, CompareFaces returns an InvalidParameterException error.    This is a stateless API
operation. That is, data returned by this operation doesn't persist.  For an example, see
Comparing Faces in Images in the Amazon Rekognition Developer Guide. This operation
requires permissions to perform the rekognition:CompareFaces action.

# Arguments
- `source_image`: The input image as base64-encoded bytes or an S3 object. If you use the
  AWS CLI to call Amazon Rekognition operations, passing base64-encoded image bytes is not
  supported.  If you are using an AWS SDK to call Amazon Rekognition, you might not need to
  base64-encode image bytes passed using the Bytes field. For more information, see Images in
  the Amazon Rekognition developer guide.
- `target_image`: The target image as base64-encoded bytes or an S3 object. If you use the
  AWS CLI to call Amazon Rekognition operations, passing base64-encoded image bytes is not
  supported.  If you are using an AWS SDK to call Amazon Rekognition, you might not need to
  base64-encode image bytes passed using the Bytes field. For more information, see Images in
  the Amazon Rekognition developer guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"QualityFilter"`: A filter that specifies a quality bar for how much filtering is done
  to identify faces. Filtered faces aren't compared. If you specify AUTO, Amazon Rekognition
  chooses the quality bar. If you specify LOW, MEDIUM, or HIGH, filtering removes all faces
  that don’t meet the chosen quality bar. The quality bar is based on a variety of common
  use cases. Low-quality detections can occur for a number of reasons. Some examples are an
  object that's misidentified as a face, a face that's too blurry, or a face with a pose
  that's too extreme to use. If you specify NONE, no filtering is performed. The default
  value is NONE.  To use quality filtering, the collection you are using must be associated
  with version 3 of the face model or higher.
- `"SimilarityThreshold"`: The minimum level of confidence in the face matches that a match
  must meet to be included in the FaceMatches array.
"""
function compare_faces(
    SourceImage, TargetImage; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "CompareFaces",
        Dict{String,Any}("SourceImage" => SourceImage, "TargetImage" => TargetImage);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function compare_faces(
    SourceImage,
    TargetImage,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rekognition(
        "CompareFaces",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "SourceImage" => SourceImage, "TargetImage" => TargetImage
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    copy_project_version(destination_project_arn, output_config, source_project_arn, source_project_version_arn, version_name)
    copy_project_version(destination_project_arn, output_config, source_project_arn, source_project_version_arn, version_name, params::Dict{String,<:Any})

 This operation applies only to Amazon Rekognition Custom Labels.  Copies a version of an
Amazon Rekognition Custom Labels model from a source project to a destination project. The
source and destination projects can be in different AWS accounts but must be in the same
AWS Region. You can't copy a model to another AWS service.  To copy a model version to a
different AWS account, you need to create a resource-based policy known as a project
policy. You attach the project policy to the source project by calling PutProjectPolicy.
The project policy gives permission to copy the model version from a trusting AWS account
to a trusted account. For more information creating and attaching a project policy, see
Attaching a project policy (SDK) in the Amazon Rekognition Custom Labels Developer Guide.
If you are copying a model version to a project in the same AWS account, you don't need to
create a project policy.  Copying project versions is supported only for Custom Labels
models.  To copy a model, the destination project, source project, and source model version
must already exist.  Copying a model version takes a while to complete. To get the current
status, call DescribeProjectVersions and check the value of Status in the
ProjectVersionDescription object. The copy operation has finished when the value of Status
is COPYING_COMPLETED. This operation requires permissions to perform the
rekognition:CopyProjectVersion action.

# Arguments
- `destination_project_arn`: The ARN of the project in the trusted AWS account that you
  want to copy the model version to.
- `output_config`: The S3 bucket and folder location where the training output for the
  source model version is placed.
- `source_project_arn`: The ARN of the source project in the trusting AWS account.
- `source_project_version_arn`: The ARN of the model version in the source project that you
  want to copy to a destination project.
- `version_name`: A name for the version of the model that's copied to the destination
  project.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"KmsKeyId"`: The identifier for your AWS Key Management Service key (AWS KMS key). You
  can supply the Amazon Resource Name (ARN) of your KMS key, the ID of your KMS key, an alias
  for your KMS key, or an alias ARN. The key is used to encrypt training results and manifest
  files written to the output Amazon S3 bucket (OutputConfig). If you choose to use your own
  KMS key, you need the following permissions on the KMS key.   kms:CreateGrant
  kms:DescribeKey   kms:GenerateDataKey   kms:Decrypt   If you don't specify a value for
  KmsKeyId, images copied into the service are encrypted using a key that AWS owns and
  manages.
- `"Tags"`: The key-value tags to assign to the model version.
"""
function copy_project_version(
    DestinationProjectArn,
    OutputConfig,
    SourceProjectArn,
    SourceProjectVersionArn,
    VersionName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rekognition(
        "CopyProjectVersion",
        Dict{String,Any}(
            "DestinationProjectArn" => DestinationProjectArn,
            "OutputConfig" => OutputConfig,
            "SourceProjectArn" => SourceProjectArn,
            "SourceProjectVersionArn" => SourceProjectVersionArn,
            "VersionName" => VersionName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function copy_project_version(
    DestinationProjectArn,
    OutputConfig,
    SourceProjectArn,
    SourceProjectVersionArn,
    VersionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rekognition(
        "CopyProjectVersion",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DestinationProjectArn" => DestinationProjectArn,
                    "OutputConfig" => OutputConfig,
                    "SourceProjectArn" => SourceProjectArn,
                    "SourceProjectVersionArn" => SourceProjectVersionArn,
                    "VersionName" => VersionName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_collection(collection_id)
    create_collection(collection_id, params::Dict{String,<:Any})

Creates a collection in an AWS Region. You can add faces to the collection using the
IndexFaces operation.  For example, you might create collections, one for each of your
application users. A user can then index faces using the IndexFaces operation and persist
results in a specific collection. Then, a user can search the collection for faces in the
user-specific container.  When you create a collection, it is associated with the latest
version of the face model version.  Collection names are case-sensitive.  This operation
requires permissions to perform the rekognition:CreateCollection action. If you want to tag
your collection, you also require permission to perform the rekognition:TagResource
operation.

# Arguments
- `collection_id`: ID for the collection that you are creating.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`:  A set of tags (key-value pairs) that you want to attach to the collection.
"""
function create_collection(CollectionId; aws_config::AbstractAWSConfig=current_aws_config())
    return rekognition(
        "CreateCollection",
        Dict{String,Any}("CollectionId" => CollectionId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_collection(
    CollectionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rekognition(
        "CreateCollection",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("CollectionId" => CollectionId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_dataset(dataset_type, project_arn)
    create_dataset(dataset_type, project_arn, params::Dict{String,<:Any})

 This operation applies only to Amazon Rekognition Custom Labels.  Creates a new Amazon
Rekognition Custom Labels dataset. You can create a dataset by using an Amazon Sagemaker
format manifest file or by copying an existing Amazon Rekognition Custom Labels dataset. To
create a training dataset for a project, specify TRAIN for the value of DatasetType. To
create the test dataset for a project, specify TEST for the value of DatasetType.  The
response from CreateDataset is the Amazon Resource Name (ARN) for the dataset. Creating a
dataset takes a while to complete. Use DescribeDataset to check the current status. The
dataset created successfully if the value of Status is CREATE_COMPLETE.  To check if any
non-terminal errors occurred, call ListDatasetEntries and check for the presence of errors
lists in the JSON Lines. Dataset creation fails if a terminal error occurs (Status =
CREATE_FAILED). Currently, you can't access the terminal error information.  For more
information, see Creating dataset in the Amazon Rekognition Custom Labels Developer Guide.
This operation requires permissions to perform the rekognition:CreateDataset action. If you
want to copy an existing dataset, you also require permission to perform the
rekognition:ListDatasetEntries action.

# Arguments
- `dataset_type`:  The type of the dataset. Specify TRAIN to create a training dataset.
  Specify TEST to create a test dataset.
- `project_arn`:  The ARN of the Amazon Rekognition Custom Labels project to which you want
  to asssign the dataset.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DatasetSource"`:  The source files for the dataset. You can specify the ARN of an
  existing dataset or specify the Amazon S3 bucket location of an Amazon Sagemaker format
  manifest file. If you don't specify datasetSource, an empty dataset is created. To add
  labeled images to the dataset, You can use the console or call UpdateDatasetEntries.
"""
function create_dataset(
    DatasetType, ProjectArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "CreateDataset",
        Dict{String,Any}("DatasetType" => DatasetType, "ProjectArn" => ProjectArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_dataset(
    DatasetType,
    ProjectArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rekognition(
        "CreateDataset",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DatasetType" => DatasetType, "ProjectArn" => ProjectArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_face_liveness_session()
    create_face_liveness_session(params::Dict{String,<:Any})

This API operation initiates a Face Liveness session. It returns a SessionId, which you can
use to start streaming Face Liveness video and get the results for a Face Liveness session.
 You can use the OutputConfig option in the Settings parameter to provide an Amazon S3
bucket location. The Amazon S3 bucket stores reference images and audit images. If no
Amazon S3 bucket is defined, raw bytes are sent instead.  You can use AuditImagesLimit to
limit the number of audit images returned when GetFaceLivenessSessionResults is called.
This number is between 0 and 4. By default, it is set to 0. The limit is best effort and
based on the duration of the selfie-video.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: Idempotent token is used to recognize the Face Liveness request.
  If the same token is used with multiple CreateFaceLivenessSession requests, the same
  session is returned. This token is employed to avoid unintentionally creating the same
  session multiple times.
- `"KmsKeyId"`:  The identifier for your AWS Key Management Service key (AWS KMS key). Used
  to encrypt audit images and reference images.
- `"Settings"`: A session settings object. It contains settings for the operation to be
  performed. For Face Liveness, it accepts OutputConfig and AuditImagesLimit.
"""
function create_face_liveness_session(; aws_config::AbstractAWSConfig=current_aws_config())
    return rekognition(
        "CreateFaceLivenessSession"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function create_face_liveness_session(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "CreateFaceLivenessSession",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_project(project_name)
    create_project(project_name, params::Dict{String,<:Any})

Creates a new Amazon Rekognition project. A project is a group of resources (datasets,
model versions) that you use to create and manage a Amazon Rekognition Custom Labels Model
or custom adapter. You can specify a feature to create the project with, if no feature is
specified then Custom Labels is used by default. For adapters, you can also choose whether
or not to have the project auto update by using the AutoUpdate argument. This operation
requires permissions to perform the rekognition:CreateProject action.

# Arguments
- `project_name`: The name of the project to create.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AutoUpdate"`: Specifies whether automatic retraining should be attempted for the
  versions of the project. Automatic retraining is done as a best effort. Required argument
  for Content Moderation. Applicable only to adapters.
- `"Feature"`: Specifies feature that is being customized. If no value is provided
  CUSTOM_LABELS is used as a default.
"""
function create_project(ProjectName; aws_config::AbstractAWSConfig=current_aws_config())
    return rekognition(
        "CreateProject",
        Dict{String,Any}("ProjectName" => ProjectName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_project(
    ProjectName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rekognition(
        "CreateProject",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ProjectName" => ProjectName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_project_version(output_config, project_arn, version_name)
    create_project_version(output_config, project_arn, version_name, params::Dict{String,<:Any})

Creates a new version of Amazon Rekognition project (like a Custom Labels model or a custom
adapter) and begins training. Models and adapters are managed as part of a Rekognition
project. The response from CreateProjectVersion is an Amazon Resource Name (ARN) for the
project version.  The FeatureConfig operation argument allows you to configure specific
model or adapter settings. You can provide a description to the project version by using
the VersionDescription argment. Training can take a while to complete. You can get the
current status by calling DescribeProjectVersions. Training completed successfully if the
value of the Status field is TRAINING_COMPLETED. Once training has successfully completed,
call DescribeProjectVersions to get the training results and evaluate the model. This
operation requires permissions to perform the rekognition:CreateProjectVersion action.
The following applies only to projects with Amazon Rekognition Custom Labels as the chosen
feature:  You can train a model in a project that doesn't have associated datasets by
specifying manifest files in the TrainingData and TestingData fields.  If you open the
console after training a model with manifest files, Amazon Rekognition Custom Labels
creates the datasets for you using the most recent manifest files. You can no longer train
a model version for the project by specifying manifest files.  Instead of training with a
project without associated datasets, we recommend that you use the manifest files to create
training and test datasets for the project.

# Arguments
- `output_config`: The Amazon S3 bucket location to store the results of training. The
  bucket can be any S3 bucket in your AWS account. You need s3:PutObject permission on the
  bucket.
- `project_arn`: The ARN of the Amazon Rekognition project that will manage the project
  version you want to train.
- `version_name`: A name for the version of the project version. This value must be unique.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FeatureConfig"`: Feature-specific configuration of the training job. If the job
  configuration does not match the feature type associated with the project, an
  InvalidParameterException is returned.
- `"KmsKeyId"`: The identifier for your AWS Key Management Service key (AWS KMS key). You
  can supply the Amazon Resource Name (ARN) of your KMS key, the ID of your KMS key, an alias
  for your KMS key, or an alias ARN. The key is used to encrypt training images, test images,
  and manifest files copied into the service for the project version. Your source images are
  unaffected. The key is also used to encrypt training results and manifest files written to
  the output Amazon S3 bucket (OutputConfig). If you choose to use your own KMS key, you need
  the following permissions on the KMS key.   kms:CreateGrant   kms:DescribeKey
  kms:GenerateDataKey   kms:Decrypt   If you don't specify a value for KmsKeyId, images
  copied into the service are encrypted using a key that AWS owns and manages.
- `"Tags"`:  A set of tags (key-value pairs) that you want to attach to the project
  version.
- `"TestingData"`: Specifies an external manifest that the service uses to test the project
  version. If you specify TestingData you must also specify TrainingData. The project must
  not have any associated datasets.
- `"TrainingData"`: Specifies an external manifest that the services uses to train the
  project version. If you specify TrainingData you must also specify TestingData. The project
  must not have any associated datasets.
- `"VersionDescription"`: A description applied to the project version being created.
"""
function create_project_version(
    OutputConfig,
    ProjectArn,
    VersionName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rekognition(
        "CreateProjectVersion",
        Dict{String,Any}(
            "OutputConfig" => OutputConfig,
            "ProjectArn" => ProjectArn,
            "VersionName" => VersionName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_project_version(
    OutputConfig,
    ProjectArn,
    VersionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rekognition(
        "CreateProjectVersion",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "OutputConfig" => OutputConfig,
                    "ProjectArn" => ProjectArn,
                    "VersionName" => VersionName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_stream_processor(input, name, output, role_arn, settings)
    create_stream_processor(input, name, output, role_arn, settings, params::Dict{String,<:Any})

Creates an Amazon Rekognition stream processor that you can use to detect and recognize
faces or to detect labels in a streaming video. Amazon Rekognition Video is a consumer of
live video from Amazon Kinesis Video Streams. There are two different settings for stream
processors in Amazon Rekognition: detecting faces and detecting labels.   If you are
creating a stream processor for detecting faces, you provide as input a Kinesis video
stream (Input) and a Kinesis data stream (Output) stream for receiving the output. You must
use the FaceSearch option in Settings, specifying the collection that contains the faces
you want to recognize. After you have finished analyzing a streaming video, use
StopStreamProcessor to stop processing.   If you are creating a stream processor to detect
labels, you provide as input a Kinesis video stream (Input), Amazon S3 bucket information
(Output), and an Amazon SNS topic ARN (NotificationChannel). You can also provide a KMS key
ID to encrypt the data sent to your Amazon S3 bucket. You specify what you want to detect
by using the ConnectedHome option in settings, and selecting one of the following: PERSON,
PET, PACKAGE, ALL You can also specify where in the frame you want Amazon Rekognition to
monitor with RegionsOfInterest. When you run the StartStreamProcessor operation on a label
detection stream processor, you input start and stop information to determine the length of
the processing time.    Use Name to assign an identifier for the stream processor. You use
Name to manage the stream processor. For example, you can start processing the source video
by calling StartStreamProcessor with the Name field.  This operation requires permissions
to perform the rekognition:CreateStreamProcessor action. If you want to tag your stream
processor, you also require permission to perform the rekognition:TagResource operation.

# Arguments
- `input`: Kinesis video stream stream that provides the source streaming video. If you are
  using the AWS CLI, the parameter name is StreamProcessorInput. This is required for both
  face search and label detection stream processors.
- `name`: An identifier you assign to the stream processor. You can use Name to manage the
  stream processor. For example, you can get the current status of the stream processor by
  calling DescribeStreamProcessor. Name is idempotent. This is required for both face search
  and label detection stream processors.
- `output`: Kinesis data stream stream or Amazon S3 bucket location to which Amazon
  Rekognition Video puts the analysis results. If you are using the AWS CLI, the parameter
  name is StreamProcessorOutput. This must be a S3Destination of an Amazon S3 bucket that you
  own for a label detection stream processor or a Kinesis data stream ARN for a face search
  stream processor.
- `role_arn`: The Amazon Resource Number (ARN) of the IAM role that allows access to the
  stream processor. The IAM role provides Rekognition read permissions for a Kinesis stream.
  It also provides write permissions to an Amazon S3 bucket and Amazon Simple Notification
  Service topic for a label detection stream processor. This is required for both face search
  and label detection stream processors.
- `settings`: Input parameters used in a streaming video analyzed by a stream processor.
  You can use FaceSearch to recognize faces in a streaming video, or you can use
  ConnectedHome to detect labels.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DataSharingPreference"`:  Shows whether you are sharing data with Rekognition to
  improve model performance. You can choose this option at the account level or on a
  per-stream basis. Note that if you opt out at the account level this setting is ignored on
  individual streams.
- `"KmsKeyId"`:  The identifier for your AWS Key Management Service key (AWS KMS key). This
  is an optional parameter for label detection stream processors and should not be used to
  create a face search stream processor. You can supply the Amazon Resource Name (ARN) of
  your KMS key, the ID of your KMS key, an alias for your KMS key, or an alias ARN. The key
  is used to encrypt results and data published to your Amazon S3 bucket, which includes
  image frames and hero images. Your source images are unaffected.
- `"NotificationChannel"`:
- `"RegionsOfInterest"`:  Specifies locations in the frames where Amazon Rekognition checks
  for objects or people. You can specify up to 10 regions of interest, and each region has
  either a polygon or a bounding box. This is an optional parameter for label detection
  stream processors and should not be used to create a face search stream processor.
- `"Tags"`:  A set of tags (key-value pairs) that you want to attach to the stream
  processor.
"""
function create_stream_processor(
    Input,
    Name,
    Output,
    RoleArn,
    Settings;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rekognition(
        "CreateStreamProcessor",
        Dict{String,Any}(
            "Input" => Input,
            "Name" => Name,
            "Output" => Output,
            "RoleArn" => RoleArn,
            "Settings" => Settings,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_stream_processor(
    Input,
    Name,
    Output,
    RoleArn,
    Settings,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rekognition(
        "CreateStreamProcessor",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Input" => Input,
                    "Name" => Name,
                    "Output" => Output,
                    "RoleArn" => RoleArn,
                    "Settings" => Settings,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_user(collection_id, user_id)
    create_user(collection_id, user_id, params::Dict{String,<:Any})

Creates a new User within a collection specified by CollectionId. Takes UserId as a
parameter, which is a user provided ID which should be unique within the collection. The
provided UserId will alias the system generated UUID to make the UserId more user friendly.
 Uses a ClientToken, an idempotency token that ensures a call to CreateUser completes only
once. If the value is not supplied, the AWS SDK generates an idempotency token for the
requests. This prevents retries after a network error results from making multiple
CreateUser calls.

# Arguments
- `collection_id`: The ID of an existing collection to which the new UserID needs to be
  created.
- `user_id`: ID for the UserID to be created. This ID needs to be unique within the
  collection.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: Idempotent token used to identify the request to CreateUser. If
  you use the same token with multiple CreateUser requests, the same response is returned.
  Use ClientRequestToken to prevent the same request from being processed more than once.
"""
function create_user(
    CollectionId, UserId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "CreateUser",
        Dict{String,Any}(
            "CollectionId" => CollectionId,
            "UserId" => UserId,
            "ClientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_user(
    CollectionId,
    UserId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rekognition(
        "CreateUser",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CollectionId" => CollectionId,
                    "UserId" => UserId,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_collection(collection_id)
    delete_collection(collection_id, params::Dict{String,<:Any})

Deletes the specified collection. Note that this operation removes all faces in the
collection. For an example, see Deleting a collection. This operation requires permissions
to perform the rekognition:DeleteCollection action.

# Arguments
- `collection_id`: ID of the collection to delete.

"""
function delete_collection(CollectionId; aws_config::AbstractAWSConfig=current_aws_config())
    return rekognition(
        "DeleteCollection",
        Dict{String,Any}("CollectionId" => CollectionId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_collection(
    CollectionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rekognition(
        "DeleteCollection",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("CollectionId" => CollectionId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_dataset(dataset_arn)
    delete_dataset(dataset_arn, params::Dict{String,<:Any})

 This operation applies only to Amazon Rekognition Custom Labels.  Deletes an existing
Amazon Rekognition Custom Labels dataset. Deleting a dataset might take while. Use
DescribeDataset to check the current status. The dataset is still deleting if the value of
Status is DELETE_IN_PROGRESS. If you try to access the dataset after it is deleted, you get
a ResourceNotFoundException exception.  You can't delete a dataset while it is creating
(Status = CREATE_IN_PROGRESS) or if the dataset is updating (Status = UPDATE_IN_PROGRESS).
This operation requires permissions to perform the rekognition:DeleteDataset action.

# Arguments
- `dataset_arn`:  The ARN of the Amazon Rekognition Custom Labels dataset that you want to
  delete.

"""
function delete_dataset(DatasetArn; aws_config::AbstractAWSConfig=current_aws_config())
    return rekognition(
        "DeleteDataset",
        Dict{String,Any}("DatasetArn" => DatasetArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_dataset(
    DatasetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rekognition(
        "DeleteDataset",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DatasetArn" => DatasetArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_faces(collection_id, face_ids)
    delete_faces(collection_id, face_ids, params::Dict{String,<:Any})

Deletes faces from a collection. You specify a collection ID and an array of face IDs to
remove from the collection. This operation requires permissions to perform the
rekognition:DeleteFaces action.

# Arguments
- `collection_id`: Collection from which to remove the specific faces.
- `face_ids`: An array of face IDs to delete.

"""
function delete_faces(
    CollectionId, FaceIds; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "DeleteFaces",
        Dict{String,Any}("CollectionId" => CollectionId, "FaceIds" => FaceIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_faces(
    CollectionId,
    FaceIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rekognition(
        "DeleteFaces",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("CollectionId" => CollectionId, "FaceIds" => FaceIds),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_project(project_arn)
    delete_project(project_arn, params::Dict{String,<:Any})

Deletes a Amazon Rekognition project. To delete a project you must first delete all models
or adapters associated with the project. To delete a model or adapter, see
DeleteProjectVersion.  DeleteProject is an asynchronous operation. To check if the project
is deleted, call DescribeProjects. The project is deleted when the project no longer
appears in the response. Be aware that deleting a given project will also delete any
ProjectPolicies associated with that project. This operation requires permissions to
perform the rekognition:DeleteProject action.

# Arguments
- `project_arn`: The Amazon Resource Name (ARN) of the project that you want to delete.

"""
function delete_project(ProjectArn; aws_config::AbstractAWSConfig=current_aws_config())
    return rekognition(
        "DeleteProject",
        Dict{String,Any}("ProjectArn" => ProjectArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_project(
    ProjectArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rekognition(
        "DeleteProject",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ProjectArn" => ProjectArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_project_policy(policy_name, project_arn)
    delete_project_policy(policy_name, project_arn, params::Dict{String,<:Any})

 This operation applies only to Amazon Rekognition Custom Labels.  Deletes an existing
project policy. To get a list of project policies attached to a project, call
ListProjectPolicies. To attach a project policy to a project, call PutProjectPolicy. This
operation requires permissions to perform the rekognition:DeleteProjectPolicy action.

# Arguments
- `policy_name`: The name of the policy that you want to delete.
- `project_arn`: The Amazon Resource Name (ARN) of the project that the project policy you
  want to delete is attached to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"PolicyRevisionId"`: The ID of the project policy revision that you want to delete.
"""
function delete_project_policy(
    PolicyName, ProjectArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "DeleteProjectPolicy",
        Dict{String,Any}("PolicyName" => PolicyName, "ProjectArn" => ProjectArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_project_policy(
    PolicyName,
    ProjectArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rekognition(
        "DeleteProjectPolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("PolicyName" => PolicyName, "ProjectArn" => ProjectArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_project_version(project_version_arn)
    delete_project_version(project_version_arn, params::Dict{String,<:Any})

Deletes a Rekognition project model or project version, like a Amazon Rekognition Custom
Labels model or a custom adapter. You can't delete a project version if it is running or if
it is training. To check the status of a project version, use the Status field returned
from DescribeProjectVersions. To stop a project version call StopProjectVersion. If the
project version is training, wait until it finishes. This operation requires permissions to
perform the rekognition:DeleteProjectVersion action.

# Arguments
- `project_version_arn`: The Amazon Resource Name (ARN) of the project version that you
  want to delete.

"""
function delete_project_version(
    ProjectVersionArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "DeleteProjectVersion",
        Dict{String,Any}("ProjectVersionArn" => ProjectVersionArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_project_version(
    ProjectVersionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rekognition(
        "DeleteProjectVersion",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ProjectVersionArn" => ProjectVersionArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_stream_processor(name)
    delete_stream_processor(name, params::Dict{String,<:Any})

Deletes the stream processor identified by Name. You assign the value for Name when you
create the stream processor with CreateStreamProcessor. You might not be able to use the
same name for a stream processor for a few seconds after calling DeleteStreamProcessor.

# Arguments
- `name`: The name of the stream processor you want to delete.

"""
function delete_stream_processor(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return rekognition(
        "DeleteStreamProcessor",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_stream_processor(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "DeleteStreamProcessor",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_user(collection_id, user_id)
    delete_user(collection_id, user_id, params::Dict{String,<:Any})

Deletes the specified UserID within the collection. Faces that are associated with the
UserID are disassociated from the UserID before deleting the specified UserID. If the
specified Collection or UserID is already deleted or not found, a ResourceNotFoundException
will be thrown. If the action is successful with a 200 response, an empty HTTP body is
returned.

# Arguments
- `collection_id`: The ID of an existing collection from which the UserID needs to be
  deleted.
- `user_id`: ID for the UserID to be deleted.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: Idempotent token used to identify the request to DeleteUser. If
  you use the same token with multiple DeleteUser requests, the same response is returned.
  Use ClientRequestToken to prevent the same request from being processed more than once.
"""
function delete_user(
    CollectionId, UserId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "DeleteUser",
        Dict{String,Any}(
            "CollectionId" => CollectionId,
            "UserId" => UserId,
            "ClientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_user(
    CollectionId,
    UserId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rekognition(
        "DeleteUser",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CollectionId" => CollectionId,
                    "UserId" => UserId,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_collection(collection_id)
    describe_collection(collection_id, params::Dict{String,<:Any})

Describes the specified collection. You can use DescribeCollection to get information, such
as the number of faces indexed into a collection and the version of the model used by the
collection for face detection. For more information, see Describing a Collection in the
Amazon Rekognition Developer Guide.

# Arguments
- `collection_id`: The ID of the collection to describe.

"""
function describe_collection(
    CollectionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "DescribeCollection",
        Dict{String,Any}("CollectionId" => CollectionId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_collection(
    CollectionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rekognition(
        "DescribeCollection",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("CollectionId" => CollectionId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_dataset(dataset_arn)
    describe_dataset(dataset_arn, params::Dict{String,<:Any})

 This operation applies only to Amazon Rekognition Custom Labels.   Describes an Amazon
Rekognition Custom Labels dataset. You can get information such as the current status of a
dataset and statistics about the images and labels in a dataset.  This operation requires
permissions to perform the rekognition:DescribeDataset action.

# Arguments
- `dataset_arn`:  The Amazon Resource Name (ARN) of the dataset that you want to describe.

"""
function describe_dataset(DatasetArn; aws_config::AbstractAWSConfig=current_aws_config())
    return rekognition(
        "DescribeDataset",
        Dict{String,Any}("DatasetArn" => DatasetArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_dataset(
    DatasetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rekognition(
        "DescribeDataset",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DatasetArn" => DatasetArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_project_versions(project_arn)
    describe_project_versions(project_arn, params::Dict{String,<:Any})

Lists and describes the versions of an Amazon Rekognition project. You can specify up to 10
model or adapter versions in ProjectVersionArns. If you don't specify a value, descriptions
for all model/adapter versions in the project are returned. This operation requires
permissions to perform the rekognition:DescribeProjectVersions action.

# Arguments
- `project_arn`: The Amazon Resource Name (ARN) of the project that contains the
  model/adapter you want to describe.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to return per paginated call. The largest
  value you can specify is 100. If you specify a value greater than 100, a
  ValidationException error occurs. The default value is 100.
- `"NextToken"`: If the previous response was incomplete (because there is more results to
  retrieve), Amazon Rekognition returns a pagination token in the response. You can use this
  pagination token to retrieve the next set of results.
- `"VersionNames"`: A list of model or project version names that you want to describe. You
  can add up to 10 model or project version names to the list. If you don't specify a value,
  all project version descriptions are returned. A version name is part of a project version
  ARN. For example, my-model.2020-01-21T09.10.15 is the version name in the following ARN.
  arn:aws:rekognition:us-east-1:123456789012:project/getting-started/version/my-model.2020-01
  -21T09.10.15/1234567890123.
"""
function describe_project_versions(
    ProjectArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "DescribeProjectVersions",
        Dict{String,Any}("ProjectArn" => ProjectArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_project_versions(
    ProjectArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rekognition(
        "DescribeProjectVersions",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ProjectArn" => ProjectArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_projects()
    describe_projects(params::Dict{String,<:Any})

Gets information about your Rekognition projects. This operation requires permissions to
perform the rekognition:DescribeProjects action.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Features"`: Specifies the type of customization to filter projects by. If no value is
  specified, CUSTOM_LABELS is used as a default.
- `"MaxResults"`: The maximum number of results to return per paginated call. The largest
  value you can specify is 100. If you specify a value greater than 100, a
  ValidationException error occurs. The default value is 100.
- `"NextToken"`: If the previous response was incomplete (because there is more results to
  retrieve), Rekognition returns a pagination token in the response. You can use this
  pagination token to retrieve the next set of results.
- `"ProjectNames"`: A list of the projects that you want Rekognition to describe. If you
  don't specify a value, the response includes descriptions for all the projects in your AWS
  account.
"""
function describe_projects(; aws_config::AbstractAWSConfig=current_aws_config())
    return rekognition(
        "DescribeProjects"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_projects(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "DescribeProjects", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_stream_processor(name)
    describe_stream_processor(name, params::Dict{String,<:Any})

Provides information about a stream processor created by CreateStreamProcessor. You can get
information about the input and output streams, the input parameters for the face
recognition being performed, and the current status of the stream processor.

# Arguments
- `name`: Name of the stream processor for which you want information.

"""
function describe_stream_processor(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return rekognition(
        "DescribeStreamProcessor",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_stream_processor(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "DescribeStreamProcessor",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    detect_custom_labels(image, project_version_arn)
    detect_custom_labels(image, project_version_arn, params::Dict{String,<:Any})

 This operation applies only to Amazon Rekognition Custom Labels.  Detects custom labels in
a supplied image by using an Amazon Rekognition Custom Labels model.  You specify which
version of a model version to use by using the ProjectVersionArn input parameter.  You pass
the input image as base64-encoded image bytes or as a reference to an image in an Amazon S3
bucket. If you use the AWS CLI to call Amazon Rekognition operations, passing image bytes
is not supported. The image must be either a PNG or JPEG formatted file.   For each object
that the model version detects on an image, the API returns a (CustomLabel) object in an
array (CustomLabels). Each CustomLabel object provides the label name (Name), the level of
confidence that the image contains the object (Confidence), and object location
information, if it exists, for the label on the image (Geometry). Note that for the
DetectCustomLabelsLabels operation, Polygons are not returned in the Geometry section of
the response. To filter labels that are returned, specify a value for MinConfidence.
DetectCustomLabelsLabels only returns labels with a confidence that's higher than the
specified value. The value of MinConfidence maps to the assumed threshold values created
during training. For more information, see Assumed threshold in the Amazon Rekognition
Custom Labels Developer Guide. Amazon Rekognition Custom Labels metrics expresses an
assumed threshold as a floating point value between 0-1. The range of MinConfidence
normalizes the threshold value to a percentage value (0-100). Confidence responses from
DetectCustomLabels are also returned as a percentage. You can use MinConfidence to change
the precision and recall or your model. For more information, see Analyzing an image in the
Amazon Rekognition Custom Labels Developer Guide.  If you don't specify a value for
MinConfidence, DetectCustomLabels returns labels based on the assumed threshold of each
label. This is a stateless API operation. That is, the operation does not persist any data.
This operation requires permissions to perform the rekognition:DetectCustomLabels action.
For more information, see Analyzing an image in the Amazon Rekognition Custom Labels
Developer Guide.

# Arguments
- `image`:
- `project_version_arn`: The ARN of the model version that you want to use. Only models
  associated with Custom Labels projects accepted by the operation. If a provided ARN refers
  to a model version associated with a project for a different feature type, then an
  InvalidParameterException is returned.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Maximum number of results you want the service to return in the response.
  The service returns the specified number of highest confidence labels ranked from highest
  confidence to lowest.
- `"MinConfidence"`: Specifies the minimum confidence level for the labels to return.
  DetectCustomLabels doesn't return any labels with a confidence value that's lower than this
  specified value. If you specify a value of 0, DetectCustomLabels returns all labels,
  regardless of the assumed threshold applied to each label. If you don't specify a value for
  MinConfidence, DetectCustomLabels returns labels based on the assumed threshold of each
  label.
"""
function detect_custom_labels(
    Image, ProjectVersionArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "DetectCustomLabels",
        Dict{String,Any}("Image" => Image, "ProjectVersionArn" => ProjectVersionArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function detect_custom_labels(
    Image,
    ProjectVersionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rekognition(
        "DetectCustomLabels",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Image" => Image, "ProjectVersionArn" => ProjectVersionArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    detect_faces(image)
    detect_faces(image, params::Dict{String,<:Any})

Detects faces within an image that is provided as input.  DetectFaces detects the 100
largest faces in the image. For each face detected, the operation returns face details.
These details include a bounding box of the face, a confidence value (that the bounding box
contains a face), and a fixed set of attributes such as facial landmarks (for example,
coordinates of eye and mouth), pose, presence of facial occlusion, and so on. The
face-detection algorithm is most effective on frontal faces. For non-frontal or obscured
faces, the algorithm might not detect the faces or might detect faces with lower
confidence.  You pass the input image either as base64-encoded image bytes or as a
reference to an image in an Amazon S3 bucket. If you use the AWS CLI to call Amazon
Rekognition operations, passing image bytes is not supported. The image must be either a
PNG or JPEG formatted file.   This is a stateless API operation. That is, the operation
does not persist any data.  This operation requires permissions to perform the
rekognition:DetectFaces action.

# Arguments
- `image`: The input image as base64-encoded bytes or an S3 object. If you use the AWS CLI
  to call Amazon Rekognition operations, passing base64-encoded image bytes is not supported.
   If you are using an AWS SDK to call Amazon Rekognition, you might not need to
  base64-encode image bytes passed using the Bytes field. For more information, see Images in
  the Amazon Rekognition developer guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Attributes"`: An array of facial attributes you want to be returned. A DEFAULT subset
  of facial attributes - BoundingBox, Confidence, Pose, Quality, and Landmarks - will always
  be returned. You can request for specific facial attributes (in addition to the default
  list) - by using [\"DEFAULT\", \"FACE_OCCLUDED\"] or just [\"FACE_OCCLUDED\"]. You can
  request for all facial attributes by using [\"ALL\"]. Requesting more attributes may
  increase response time. If you provide both, [\"ALL\", \"DEFAULT\"], the service uses a
  logical \"AND\" operator to determine which attributes to return (in this case, all
  attributes).  Note that while the FaceOccluded and EyeDirection attributes are supported
  when using DetectFaces, they aren't supported when analyzing videos with StartFaceDetection
  and GetFaceDetection.
"""
function detect_faces(Image; aws_config::AbstractAWSConfig=current_aws_config())
    return rekognition(
        "DetectFaces",
        Dict{String,Any}("Image" => Image);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function detect_faces(
    Image, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "DetectFaces",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Image" => Image), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    detect_labels(image)
    detect_labels(image, params::Dict{String,<:Any})

Detects instances of real-world entities within an image (JPEG or PNG) provided as input.
This includes objects like flower, tree, and table; events like wedding, graduation, and
birthday party; and concepts like landscape, evening, and nature.  For an example, see
Analyzing images stored in an Amazon S3 bucket in the Amazon Rekognition Developer Guide.
You pass the input image as base64-encoded image bytes or as a reference to an image in an
Amazon S3 bucket. If you use the AWS CLI to call Amazon Rekognition operations, passing
image bytes is not supported. The image must be either a PNG or JPEG formatted file.
Optional Parameters  You can specify one or both of the GENERAL_LABELS and IMAGE_PROPERTIES
feature types when calling the DetectLabels API. Including GENERAL_LABELS will ensure the
response includes the labels detected in the input image, while including IMAGE_PROPERTIES
will ensure the response includes information about the image quality and color. When using
GENERAL_LABELS and/or IMAGE_PROPERTIES you can provide filtering criteria to the Settings
parameter. You can filter with sets of individual labels or with label categories. You can
specify inclusive filters, exclusive filters, or a combination of inclusive and exclusive
filters. For more information on filtering see Detecting Labels in an Image. When getting
labels, you can specify MinConfidence to control the confidence threshold for the labels
returned. The default is 55%. You can also add the MaxLabels parameter to limit the number
of labels returned. The default and upper limit is 1000 labels. These arguments are only
valid when supplying GENERAL_LABELS as a feature type.  Response Elements   For each
object, scene, and concept the API returns one or more labels. The API returns the
following types of information about labels:    Name - The name of the detected label.
Confidence - The level of confidence in the label assigned to a detected object.
Parents - The ancestor labels for a detected label. DetectLabels returns a hierarchical
taxonomy of detected labels. For example, a detected car might be assigned the label car.
The label car has two parent labels: Vehicle (its parent) and Transportation (its
grandparent). The response includes the all ancestors for a label, where every ancestor is
a unique label. In the previous example, Car, Vehicle, and Transportation are returned as
unique labels in the response.     Aliases - Possible Aliases for the label.     Categories
- The label categories that the detected label belongs to.     BoundingBox — Bounding
boxes are described for all instances of detected common object labels, returned in an
array of Instance objects. An Instance object contains a BoundingBox object, describing the
location of the label on the input image. It also includes the confidence for the accuracy
of the detected bounding box.     The API returns the following information regarding the
image, as part of the ImageProperties structure:   Quality - Information about the
Sharpness, Brightness, and Contrast of the input image, scored between 0 to 100. Image
quality is returned for the entire image, as well as the background and the foreground.
Dominant Color - An array of the dominant colors in the image.    Foreground - Information
about the sharpness, brightness, and dominant colors of the input image’s foreground.
Background - Information about the sharpness, brightness, and dominant colors of the input
image’s background.   The list of returned labels will include at least one label for
every detected object, along with information about that label. In the following example,
suppose the input image has a lighthouse, the sea, and a rock. The response includes all
three labels, one for each object, as well as the confidence in the label:  {Name:
lighthouse, Confidence: 98.4629}   {Name: rock,Confidence: 79.2097}    {Name:
sea,Confidence: 75.061}  The list of labels can include multiple labels for the same
object. For example, if the input image shows a flower (for example, a tulip), the
operation might return the following three labels.   {Name: flower,Confidence: 99.0562}
{Name: plant,Confidence: 99.0562}   {Name: tulip,Confidence: 99.0562}  In this example, the
detection algorithm more precisely identifies the flower as a tulip.  If the object
detected is a person, the operation doesn't provide the same facial details that the
DetectFaces operation provides.  This is a stateless API operation that doesn't return any
data. This operation requires permissions to perform the rekognition:DetectLabels action.

# Arguments
- `image`: The input image as base64-encoded bytes or an S3 object. If you use the AWS CLI
  to call Amazon Rekognition operations, passing image bytes is not supported. Images stored
  in an S3 Bucket do not need to be base64-encoded. If you are using an AWS SDK to call
  Amazon Rekognition, you might not need to base64-encode image bytes passed using the Bytes
  field. For more information, see Images in the Amazon Rekognition developer guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Features"`: A list of the types of analysis to perform. Specifying GENERAL_LABELS uses
  the label detection feature, while specifying IMAGE_PROPERTIES returns information
  regarding image color and quality. If no option is specified GENERAL_LABELS is used by
  default.
- `"MaxLabels"`: Maximum number of labels you want the service to return in the response.
  The service returns the specified number of highest confidence labels. Only valid when
  GENERAL_LABELS is specified as a feature type in the Feature input parameter.
- `"MinConfidence"`: Specifies the minimum confidence level for the labels to return.
  Amazon Rekognition doesn't return any labels with confidence lower than this specified
  value. If MinConfidence is not specified, the operation returns labels with a confidence
  values greater than or equal to 55 percent. Only valid when GENERAL_LABELS is specified as
  a feature type in the Feature input parameter.
- `"Settings"`: A list of the filters to be applied to returned detected labels and image
  properties. Specified filters can be inclusive, exclusive, or a combination of both.
  Filters can be used for individual labels or label categories. The exact label names or
  label categories must be supplied. For a full list of labels and label categories, see
  Detecting labels.
"""
function detect_labels(Image; aws_config::AbstractAWSConfig=current_aws_config())
    return rekognition(
        "DetectLabels",
        Dict{String,Any}("Image" => Image);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function detect_labels(
    Image, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "DetectLabels",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Image" => Image), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    detect_moderation_labels(image)
    detect_moderation_labels(image, params::Dict{String,<:Any})

Detects unsafe content in a specified JPEG or PNG format image. Use DetectModerationLabels
to moderate images depending on your requirements. For example, you might want to filter
images that contain nudity, but not images containing suggestive content. To filter images,
use the labels returned by DetectModerationLabels to determine which types of content are
appropriate. For information about moderation labels, see Detecting Unsafe Content in the
Amazon Rekognition Developer Guide. You pass the input image either as base64-encoded image
bytes or as a reference to an image in an Amazon S3 bucket. If you use the AWS CLI to call
Amazon Rekognition operations, passing image bytes is not supported. The image must be
either a PNG or JPEG formatted file.  You can specify an adapter to use when retrieving
label predictions by providing a ProjectVersionArn to the ProjectVersion argument.

# Arguments
- `image`: The input image as base64-encoded bytes or an S3 object. If you use the AWS CLI
  to call Amazon Rekognition operations, passing base64-encoded image bytes is not supported.
   If you are using an AWS SDK to call Amazon Rekognition, you might not need to
  base64-encode image bytes passed using the Bytes field. For more information, see Images in
  the Amazon Rekognition developer guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"HumanLoopConfig"`: Sets up the configuration for human evaluation, including the
  FlowDefinition the image will be sent to.
- `"MinConfidence"`: Specifies the minimum confidence level for the labels to return.
  Amazon Rekognition doesn't return any labels with a confidence level lower than this
  specified value. If you don't specify MinConfidence, the operation returns labels with
  confidence values greater than or equal to 50 percent.
- `"ProjectVersion"`: Identifier for the custom adapter. Expects the ProjectVersionArn as a
  value. Use the CreateProject or CreateProjectVersion APIs to create a custom adapter.
"""
function detect_moderation_labels(Image; aws_config::AbstractAWSConfig=current_aws_config())
    return rekognition(
        "DetectModerationLabels",
        Dict{String,Any}("Image" => Image);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function detect_moderation_labels(
    Image, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "DetectModerationLabels",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Image" => Image), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    detect_protective_equipment(image)
    detect_protective_equipment(image, params::Dict{String,<:Any})

Detects Personal Protective Equipment (PPE) worn by people detected in an image. Amazon
Rekognition can detect the following types of PPE.   Face cover   Hand cover   Head cover
You pass the input image as base64-encoded image bytes or as a reference to an image in an
Amazon S3 bucket. The image must be either a PNG or JPG formatted file.
DetectProtectiveEquipment detects PPE worn by up to 15 persons detected in an image. For
each person detected in the image the API returns an array of body parts (face, head,
left-hand, right-hand). For each body part, an array of detected items of PPE is returned,
including an indicator of whether or not the PPE covers the body part. The API returns the
confidence it has in each detection (person, PPE, body part and body part coverage). It
also returns a bounding box (BoundingBox) for each detected person and each detected item
of PPE.  You can optionally request a summary of detected PPE items with the
SummarizationAttributes input parameter. The summary provides the following information.
The persons detected as wearing all of the types of PPE that you specify.   The persons
detected as not wearing all of the types PPE that you specify.   The persons detected where
PPE adornment could not be determined.    This is a stateless API operation. That is, the
operation does not persist any data. This operation requires permissions to perform the
rekognition:DetectProtectiveEquipment action.

# Arguments
- `image`: The image in which you want to detect PPE on detected persons. The image can be
  passed as image bytes or you can reference an image stored in an Amazon S3 bucket.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"SummarizationAttributes"`: An array of PPE types that you want to summarize.
"""
function detect_protective_equipment(
    Image; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "DetectProtectiveEquipment",
        Dict{String,Any}("Image" => Image);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function detect_protective_equipment(
    Image, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "DetectProtectiveEquipment",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Image" => Image), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    detect_text(image)
    detect_text(image, params::Dict{String,<:Any})

Detects text in the input image and converts it into machine-readable text. Pass the input
image as base64-encoded image bytes or as a reference to an image in an Amazon S3 bucket.
If you use the AWS CLI to call Amazon Rekognition operations, you must pass it as a
reference to an image in an Amazon S3 bucket. For the AWS CLI, passing image bytes is not
supported. The image must be either a .png or .jpeg formatted file.  The DetectText
operation returns text in an array of TextDetection elements, TextDetections. Each
TextDetection element provides information about a single word or line of text that was
detected in the image.  A word is one or more script characters that are not separated by
spaces. DetectText can detect up to 100 words in an image. A line is a string of equally
spaced words. A line isn't necessarily a complete sentence. For example, a driver's license
number is detected as a line. A line ends when there is no aligned text after it. Also, a
line ends when there is a large gap between words, relative to the length of the words.
This means, depending on the gap between words, Amazon Rekognition may detect multiple
lines in text aligned in the same direction. Periods don't represent the end of a line. If
a sentence spans multiple lines, the DetectText operation returns multiple lines. To
determine whether a TextDetection element is a line of text or a word, use the
TextDetection object Type field.  To be detected, text must be within +/- 90 degrees
orientation of the horizontal axis. For more information, see Detecting text in the Amazon
Rekognition Developer Guide.

# Arguments
- `image`: The input image as base64-encoded bytes or an Amazon S3 object. If you use the
  AWS CLI to call Amazon Rekognition operations, you can't pass image bytes.  If you are
  using an AWS SDK to call Amazon Rekognition, you might not need to base64-encode image
  bytes passed using the Bytes field. For more information, see Images in the Amazon
  Rekognition developer guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: Optional parameters that let you set the criteria that the text must meet to
  be included in your response.
"""
function detect_text(Image; aws_config::AbstractAWSConfig=current_aws_config())
    return rekognition(
        "DetectText",
        Dict{String,Any}("Image" => Image);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function detect_text(
    Image, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "DetectText",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Image" => Image), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_faces(collection_id, face_ids, user_id)
    disassociate_faces(collection_id, face_ids, user_id, params::Dict{String,<:Any})

Removes the association between a Face supplied in an array of FaceIds and the User. If the
User is not present already, then a ResourceNotFound exception is thrown. If successful, an
array of faces that are disassociated from the User is returned. If a given face is already
disassociated from the given UserID, it will be ignored and not be returned in the
response. If a given face is already associated with a different User or not found in the
collection it will be returned as part of UnsuccessfulDisassociations. You can remove 1 -
100 face IDs from a user at one time.

# Arguments
- `collection_id`: The ID of an existing collection containing the UserID.
- `face_ids`: An array of face IDs to disassociate from the UserID.
- `user_id`: ID for the existing UserID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: Idempotent token used to identify the request to
  DisassociateFaces. If you use the same token with multiple DisassociateFaces requests, the
  same response is returned. Use ClientRequestToken to prevent the same request from being
  processed more than once.
"""
function disassociate_faces(
    CollectionId, FaceIds, UserId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "DisassociateFaces",
        Dict{String,Any}(
            "CollectionId" => CollectionId,
            "FaceIds" => FaceIds,
            "UserId" => UserId,
            "ClientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_faces(
    CollectionId,
    FaceIds,
    UserId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rekognition(
        "DisassociateFaces",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CollectionId" => CollectionId,
                    "FaceIds" => FaceIds,
                    "UserId" => UserId,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    distribute_dataset_entries(datasets)
    distribute_dataset_entries(datasets, params::Dict{String,<:Any})

 This operation applies only to Amazon Rekognition Custom Labels.  Distributes the entries
(images) in a training dataset across the training dataset and the test dataset for a
project. DistributeDatasetEntries moves 20% of the training dataset images to the test
dataset. An entry is a JSON Line that describes an image.  You supply the Amazon Resource
Names (ARN) of a project's training dataset and test dataset. The training dataset must
contain the images that you want to split. The test dataset must be empty. The datasets
must belong to the same project. To create training and test datasets for a project, call
CreateDataset. Distributing a dataset takes a while to complete. To check the status call
DescribeDataset. The operation is complete when the Status field for the training dataset
and the test dataset is UPDATE_COMPLETE. If the dataset split fails, the value of Status is
UPDATE_FAILED. This operation requires permissions to perform the
rekognition:DistributeDatasetEntries action.

# Arguments
- `datasets`: The ARNS for the training dataset and test dataset that you want to use. The
  datasets must belong to the same project. The test dataset must be empty.

"""
function distribute_dataset_entries(
    Datasets; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "DistributeDatasetEntries",
        Dict{String,Any}("Datasets" => Datasets);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function distribute_dataset_entries(
    Datasets,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rekognition(
        "DistributeDatasetEntries",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Datasets" => Datasets), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_celebrity_info(id)
    get_celebrity_info(id, params::Dict{String,<:Any})

Gets the name and additional information about a celebrity based on their Amazon
Rekognition ID. The additional information is returned as an array of URLs. If there is no
additional information about the celebrity, this list is empty. For more information, see
Getting information about a celebrity in the Amazon Rekognition Developer Guide. This
operation requires permissions to perform the rekognition:GetCelebrityInfo action.

# Arguments
- `id`: The ID for the celebrity. You get the celebrity ID from a call to the
  RecognizeCelebrities operation, which recognizes celebrities in an image.

"""
function get_celebrity_info(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return rekognition(
        "GetCelebrityInfo",
        Dict{String,Any}("Id" => Id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_celebrity_info(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "GetCelebrityInfo",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Id" => Id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_celebrity_recognition(job_id)
    get_celebrity_recognition(job_id, params::Dict{String,<:Any})

Gets the celebrity recognition results for a Amazon Rekognition Video analysis started by
StartCelebrityRecognition. Celebrity recognition in a video is an asynchronous operation.
Analysis is started by a call to StartCelebrityRecognition which returns a job identifier
(JobId).  When the celebrity recognition operation finishes, Amazon Rekognition Video
publishes a completion status to the Amazon Simple Notification Service topic registered in
the initial call to StartCelebrityRecognition. To get the results of the celebrity
recognition analysis, first check that the status value published to the Amazon SNS topic
is SUCCEEDED. If so, call GetCelebrityDetection and pass the job identifier (JobId) from
the initial call to StartCelebrityDetection.  For more information, see Working With Stored
Videos in the Amazon Rekognition Developer Guide.  GetCelebrityRecognition returns detected
celebrities and the time(s) they are detected in an array (Celebrities) of
CelebrityRecognition objects. Each CelebrityRecognition contains information about the
celebrity in a CelebrityDetail object and the time, Timestamp, the celebrity was detected.
This CelebrityDetail object stores information about the detected celebrity's face
attributes, a face bounding box, known gender, the celebrity's name, and a confidence
estimate.   GetCelebrityRecognition only returns the default facial attributes
(BoundingBox, Confidence, Landmarks, Pose, and Quality). The BoundingBox field only applies
to the detected face instance. The other facial attributes listed in the Face object of the
following response syntax are not returned. For more information, see FaceDetail in the
Amazon Rekognition Developer Guide.   By default, the Celebrities array is sorted by time
(milliseconds from the start of the video). You can also sort the array by celebrity by
specifying the value ID in the SortBy input parameter. The CelebrityDetail object includes
the celebrity identifer and additional information urls. If you don't store the additional
information urls, you can get them later by calling GetCelebrityInfo with the celebrity
identifer. No information is returned for faces not recognized as celebrities. Use
MaxResults parameter to limit the number of labels returned. If there are more results than
specified in MaxResults, the value of NextToken in the operation response contains a
pagination token for getting the next set of results. To get the next page of results, call
GetCelebrityDetection and populate the NextToken request parameter with the token value
returned from the previous call to GetCelebrityRecognition.

# Arguments
- `job_id`: Job identifier for the required celebrity recognition analysis. You can get the
  job identifer from a call to StartCelebrityRecognition.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Maximum number of results to return per paginated call. The largest value
  you can specify is 1000. If you specify a value greater than 1000, a maximum of 1000
  results is returned. The default value is 1000.
- `"NextToken"`: If the previous response was incomplete (because there is more recognized
  celebrities to retrieve), Amazon Rekognition Video returns a pagination token in the
  response. You can use this pagination token to retrieve the next set of celebrities.
- `"SortBy"`: Sort to use for celebrities returned in Celebrities field. Specify ID to sort
  by the celebrity identifier, specify TIMESTAMP to sort by the time the celebrity was
  recognized.
"""
function get_celebrity_recognition(
    JobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "GetCelebrityRecognition",
        Dict{String,Any}("JobId" => JobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_celebrity_recognition(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "GetCelebrityRecognition",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("JobId" => JobId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_content_moderation(job_id)
    get_content_moderation(job_id, params::Dict{String,<:Any})

Gets the inappropriate, unwanted, or offensive content analysis results for a Amazon
Rekognition Video analysis started by StartContentModeration. For a list of moderation
labels in Amazon Rekognition, see Using the image and video moderation APIs. Amazon
Rekognition Video inappropriate or offensive content detection in a stored video is an
asynchronous operation. You start analysis by calling StartContentModeration which returns
a job identifier (JobId). When analysis finishes, Amazon Rekognition Video publishes a
completion status to the Amazon Simple Notification Service topic registered in the initial
call to StartContentModeration. To get the results of the content analysis, first check
that the status value published to the Amazon SNS topic is SUCCEEDED. If so, call
GetContentModeration and pass the job identifier (JobId) from the initial call to
StartContentModeration.  For more information, see Working with Stored Videos in the Amazon
Rekognition Devlopers Guide.  GetContentModeration returns detected inappropriate,
unwanted, or offensive content moderation labels, and the time they are detected, in an
array, ModerationLabels, of ContentModerationDetection objects.  By default, the moderated
labels are returned sorted by time, in milliseconds from the start of the video. You can
also sort them by moderated label by specifying NAME for the SortBy input parameter.  Since
video analysis can return a large number of results, use the MaxResults parameter to limit
the number of labels returned in a single call to GetContentModeration. If there are more
results than specified in MaxResults, the value of NextToken in the operation response
contains a pagination token for getting the next set of results. To get the next page of
results, call GetContentModeration and populate the NextToken request parameter with the
value of NextToken returned from the previous call to GetContentModeration. For more
information, see moderating content in the Amazon Rekognition Developer Guide.

# Arguments
- `job_id`: The identifier for the inappropriate, unwanted, or offensive content moderation
  job. Use JobId to identify the job in a subsequent call to GetContentModeration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AggregateBy"`: Defines how to aggregate results of the StartContentModeration request.
  Default aggregation option is TIMESTAMPS. SEGMENTS mode aggregates moderation labels over
  time.
- `"MaxResults"`: Maximum number of results to return per paginated call. The largest value
  you can specify is 1000. If you specify a value greater than 1000, a maximum of 1000
  results is returned. The default value is 1000.
- `"NextToken"`: If the previous response was incomplete (because there is more data to
  retrieve), Amazon Rekognition returns a pagination token in the response. You can use this
  pagination token to retrieve the next set of content moderation labels.
- `"SortBy"`: Sort to use for elements in the ModerationLabelDetections array. Use
  TIMESTAMP to sort array elements by the time labels are detected. Use NAME to
  alphabetically group elements for a label together. Within each label group, the array
  element are sorted by detection confidence. The default sort is by TIMESTAMP.
"""
function get_content_moderation(JobId; aws_config::AbstractAWSConfig=current_aws_config())
    return rekognition(
        "GetContentModeration",
        Dict{String,Any}("JobId" => JobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_content_moderation(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "GetContentModeration",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("JobId" => JobId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_face_detection(job_id)
    get_face_detection(job_id, params::Dict{String,<:Any})

Gets face detection results for a Amazon Rekognition Video analysis started by
StartFaceDetection. Face detection with Amazon Rekognition Video is an asynchronous
operation. You start face detection by calling StartFaceDetection which returns a job
identifier (JobId). When the face detection operation finishes, Amazon Rekognition Video
publishes a completion status to the Amazon Simple Notification Service topic registered in
the initial call to StartFaceDetection. To get the results of the face detection operation,
first check that the status value published to the Amazon SNS topic is SUCCEEDED. If so,
call GetFaceDetection and pass the job identifier (JobId) from the initial call to
StartFaceDetection.  GetFaceDetection returns an array of detected faces (Faces) sorted by
the time the faces were detected.  Use MaxResults parameter to limit the number of labels
returned. If there are more results than specified in MaxResults, the value of NextToken in
the operation response contains a pagination token for getting the next set of results. To
get the next page of results, call GetFaceDetection and populate the NextToken request
parameter with the token value returned from the previous call to GetFaceDetection. Note
that for the GetFaceDetection operation, the returned values for FaceOccluded and
EyeDirection will always be \"null\".

# Arguments
- `job_id`: Unique identifier for the face detection job. The JobId is returned from
  StartFaceDetection.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Maximum number of results to return per paginated call. The largest value
  you can specify is 1000. If you specify a value greater than 1000, a maximum of 1000
  results is returned. The default value is 1000.
- `"NextToken"`: If the previous response was incomplete (because there are more faces to
  retrieve), Amazon Rekognition Video returns a pagination token in the response. You can use
  this pagination token to retrieve the next set of faces.
"""
function get_face_detection(JobId; aws_config::AbstractAWSConfig=current_aws_config())
    return rekognition(
        "GetFaceDetection",
        Dict{String,Any}("JobId" => JobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_face_detection(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "GetFaceDetection",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("JobId" => JobId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_face_liveness_session_results(session_id)
    get_face_liveness_session_results(session_id, params::Dict{String,<:Any})

Retrieves the results of a specific Face Liveness session. It requires the sessionId as
input, which was created using CreateFaceLivenessSession. Returns the corresponding Face
Liveness confidence score, a reference image that includes a face bounding box, and audit
images that also contain face bounding boxes. The Face Liveness confidence score ranges
from 0 to 100.  The number of audit images returned by GetFaceLivenessSessionResults is
defined by the AuditImagesLimit paramater when calling CreateFaceLivenessSession. Reference
images are always returned when possible.

# Arguments
- `session_id`: A unique 128-bit UUID. This is used to uniquely identify the session and
  also acts as an idempotency token for all operations associated with the session.

"""
function get_face_liveness_session_results(
    SessionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "GetFaceLivenessSessionResults",
        Dict{String,Any}("SessionId" => SessionId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_face_liveness_session_results(
    SessionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rekognition(
        "GetFaceLivenessSessionResults",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("SessionId" => SessionId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_face_search(job_id)
    get_face_search(job_id, params::Dict{String,<:Any})

Gets the face search results for Amazon Rekognition Video face search started by
StartFaceSearch. The search returns faces in a collection that match the faces of persons
detected in a video. It also includes the time(s) that faces are matched in the video. Face
search in a video is an asynchronous operation. You start face search by calling to
StartFaceSearch which returns a job identifier (JobId). When the search operation finishes,
Amazon Rekognition Video publishes a completion status to the Amazon Simple Notification
Service topic registered in the initial call to StartFaceSearch. To get the search results,
first check that the status value published to the Amazon SNS topic is SUCCEEDED. If so,
call GetFaceSearch and pass the job identifier (JobId) from the initial call to
StartFaceSearch. For more information, see Searching Faces in a Collection in the Amazon
Rekognition Developer Guide. The search results are retured in an array, Persons, of
PersonMatch objects. EachPersonMatch element contains details about the matching faces in
the input collection, person information (facial attributes, bounding boxes, and person
identifer) for the matched person, and the time the person was matched in the video.
GetFaceSearch only returns the default facial attributes (BoundingBox, Confidence,
Landmarks, Pose, and Quality). The other facial attributes listed in the Face object of the
following response syntax are not returned. For more information, see FaceDetail in the
Amazon Rekognition Developer Guide.   By default, the Persons array is sorted by the time,
in milliseconds from the start of the video, persons are matched. You can also sort by
persons by specifying INDEX for the SORTBY input parameter.

# Arguments
- `job_id`: The job identifer for the search request. You get the job identifier from an
  initial call to StartFaceSearch.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Maximum number of results to return per paginated call. The largest value
  you can specify is 1000. If you specify a value greater than 1000, a maximum of 1000
  results is returned. The default value is 1000.
- `"NextToken"`: If the previous response was incomplete (because there is more search
  results to retrieve), Amazon Rekognition Video returns a pagination token in the response.
  You can use this pagination token to retrieve the next set of search results.
- `"SortBy"`: Sort to use for grouping faces in the response. Use TIMESTAMP to group faces
  by the time that they are recognized. Use INDEX to sort by recognized faces.
"""
function get_face_search(JobId; aws_config::AbstractAWSConfig=current_aws_config())
    return rekognition(
        "GetFaceSearch",
        Dict{String,Any}("JobId" => JobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_face_search(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "GetFaceSearch",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("JobId" => JobId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_label_detection(job_id)
    get_label_detection(job_id, params::Dict{String,<:Any})

Gets the label detection results of a Amazon Rekognition Video analysis started by
StartLabelDetection.  The label detection operation is started by a call to
StartLabelDetection which returns a job identifier (JobId). When the label detection
operation finishes, Amazon Rekognition publishes a completion status to the Amazon Simple
Notification Service topic registered in the initial call to StartlabelDetection.  To get
the results of the label detection operation, first check that the status value published
to the Amazon SNS topic is SUCCEEDED. If so, call GetLabelDetection and pass the job
identifier (JobId) from the initial call to StartLabelDetection.  GetLabelDetection returns
an array of detected labels (Labels) sorted by the time the labels were detected. You can
also sort by the label name by specifying NAME for the SortBy input parameter. If there is
no NAME specified, the default sort is by timestamp. You can select how results are
aggregated by using the AggregateBy input parameter. The default aggregation method is
TIMESTAMPS. You can also aggregate by SEGMENTS, which aggregates all instances of labels
detected in a given segment.  The returned Labels array may include the following
attributes:   Name - The name of the detected label.   Confidence - The level of confidence
in the label assigned to a detected object.    Parents - The ancestor labels for a detected
label. GetLabelDetection returns a hierarchical taxonomy of detected labels. For example, a
detected car might be assigned the label car. The label car has two parent labels: Vehicle
(its parent) and Transportation (its grandparent). The response includes the all ancestors
for a label, where every ancestor is a unique label. In the previous example, Car, Vehicle,
and Transportation are returned as unique labels in the response.     Aliases - Possible
Aliases for the label.    Categories - The label categories that the detected label belongs
to.   BoundingBox — Bounding boxes are described for all instances of detected common
object labels, returned in an array of Instance objects. An Instance object contains a
BoundingBox object, describing the location of the label on the input image. It also
includes the confidence for the accuracy of the detected bounding box.   Timestamp - Time,
in milliseconds from the start of the video, that the label was detected. For aggregation
by SEGMENTS, the StartTimestampMillis, EndTimestampMillis, and DurationMillis structures
are what define a segment. Although the “Timestamp” structure is still returned with
each label, its value is set to be the same as StartTimestampMillis.   Timestamp and
Bounding box information are returned for detected Instances, only if aggregation is done
by TIMESTAMPS. If aggregating by SEGMENTS, information about detected instances isn’t
returned.  The version of the label model used for the detection is also returned.  Note
DominantColors isn't returned for Instances, although it is shown as part of the response
in the sample seen below.  Use MaxResults parameter to limit the number of labels returned.
If there are more results than specified in MaxResults, the value of NextToken in the
operation response contains a pagination token for getting the next set of results. To get
the next page of results, call GetlabelDetection and populate the NextToken request
parameter with the token value returned from the previous call to GetLabelDetection.

# Arguments
- `job_id`: Job identifier for the label detection operation for which you want results
  returned. You get the job identifer from an initial call to StartlabelDetection.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AggregateBy"`: Defines how to aggregate the returned results. Results can be aggregated
  by timestamps or segments.
- `"MaxResults"`: Maximum number of results to return per paginated call. The largest value
  you can specify is 1000. If you specify a value greater than 1000, a maximum of 1000
  results is returned. The default value is 1000.
- `"NextToken"`: If the previous response was incomplete (because there are more labels to
  retrieve), Amazon Rekognition Video returns a pagination token in the response. You can use
  this pagination token to retrieve the next set of labels.
- `"SortBy"`: Sort to use for elements in the Labels array. Use TIMESTAMP to sort array
  elements by the time labels are detected. Use NAME to alphabetically group elements for a
  label together. Within each label group, the array element are sorted by detection
  confidence. The default sort is by TIMESTAMP.
"""
function get_label_detection(JobId; aws_config::AbstractAWSConfig=current_aws_config())
    return rekognition(
        "GetLabelDetection",
        Dict{String,Any}("JobId" => JobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_label_detection(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "GetLabelDetection",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("JobId" => JobId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_media_analysis_job(job_id)
    get_media_analysis_job(job_id, params::Dict{String,<:Any})

Retrieves the results for a given media analysis job. Takes a JobId returned by
StartMediaAnalysisJob.

# Arguments
- `job_id`: Unique identifier for the media analysis job for which you want to retrieve
  results.

"""
function get_media_analysis_job(JobId; aws_config::AbstractAWSConfig=current_aws_config())
    return rekognition(
        "GetMediaAnalysisJob",
        Dict{String,Any}("JobId" => JobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_media_analysis_job(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "GetMediaAnalysisJob",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("JobId" => JobId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_person_tracking(job_id)
    get_person_tracking(job_id, params::Dict{String,<:Any})

Gets the path tracking results of a Amazon Rekognition Video analysis started by
StartPersonTracking. The person path tracking operation is started by a call to
StartPersonTracking which returns a job identifier (JobId). When the operation finishes,
Amazon Rekognition Video publishes a completion status to the Amazon Simple Notification
Service topic registered in the initial call to StartPersonTracking. To get the results of
the person path tracking operation, first check that the status value published to the
Amazon SNS topic is SUCCEEDED. If so, call GetPersonTracking and pass the job identifier
(JobId) from the initial call to StartPersonTracking.  GetPersonTracking returns an array,
Persons, of tracked persons and the time(s) their paths were tracked in the video.
GetPersonTracking only returns the default facial attributes (BoundingBox, Confidence,
Landmarks, Pose, and Quality). The other facial attributes listed in the Face object of the
following response syntax are not returned.  For more information, see FaceDetail in the
Amazon Rekognition Developer Guide.  By default, the array is sorted by the time(s) a
person's path is tracked in the video. You can sort by tracked persons by specifying INDEX
for the SortBy input parameter. Use the MaxResults parameter to limit the number of items
returned. If there are more results than specified in MaxResults, the value of NextToken in
the operation response contains a pagination token for getting the next set of results. To
get the next page of results, call GetPersonTracking and populate the NextToken request
parameter with the token value returned from the previous call to GetPersonTracking.

# Arguments
- `job_id`: The identifier for a job that tracks persons in a video. You get the JobId from
  a call to StartPersonTracking.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Maximum number of results to return per paginated call. The largest value
  you can specify is 1000. If you specify a value greater than 1000, a maximum of 1000
  results is returned. The default value is 1000.
- `"NextToken"`: If the previous response was incomplete (because there are more persons to
  retrieve), Amazon Rekognition Video returns a pagination token in the response. You can use
  this pagination token to retrieve the next set of persons.
- `"SortBy"`: Sort to use for elements in the Persons array. Use TIMESTAMP to sort array
  elements by the time persons are detected. Use INDEX to sort by the tracked persons. If you
  sort by INDEX, the array elements for each person are sorted by detection confidence. The
  default sort is by TIMESTAMP.
"""
function get_person_tracking(JobId; aws_config::AbstractAWSConfig=current_aws_config())
    return rekognition(
        "GetPersonTracking",
        Dict{String,Any}("JobId" => JobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_person_tracking(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "GetPersonTracking",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("JobId" => JobId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_segment_detection(job_id)
    get_segment_detection(job_id, params::Dict{String,<:Any})

Gets the segment detection results of a Amazon Rekognition Video analysis started by
StartSegmentDetection. Segment detection with Amazon Rekognition Video is an asynchronous
operation. You start segment detection by calling StartSegmentDetection which returns a job
identifier (JobId). When the segment detection operation finishes, Amazon Rekognition
publishes a completion status to the Amazon Simple Notification Service topic registered in
the initial call to StartSegmentDetection. To get the results of the segment detection
operation, first check that the status value published to the Amazon SNS topic is
SUCCEEDED. if so, call GetSegmentDetection and pass the job identifier (JobId) from the
initial call of StartSegmentDetection.  GetSegmentDetection returns detected segments in an
array (Segments) of SegmentDetection objects. Segments is sorted by the segment types
specified in the SegmentTypes input parameter of StartSegmentDetection. Each element of the
array includes the detected segment, the precentage confidence in the acuracy of the
detected segment, the type of the segment, and the frame in which the segment was detected.
Use SelectedSegmentTypes to find out the type of segment detection requested in the call to
StartSegmentDetection. Use the MaxResults parameter to limit the number of segment
detections returned. If there are more results than specified in MaxResults, the value of
NextToken in the operation response contains a pagination token for getting the next set of
results. To get the next page of results, call GetSegmentDetection and populate the
NextToken request parameter with the token value returned from the previous call to
GetSegmentDetection. For more information, see Detecting video segments in stored video in
the Amazon Rekognition Developer Guide.

# Arguments
- `job_id`: Job identifier for the text detection operation for which you want results
  returned. You get the job identifer from an initial call to StartSegmentDetection.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Maximum number of results to return per paginated call. The largest value
  you can specify is 1000.
- `"NextToken"`: If the response is truncated, Amazon Rekognition Video returns this token
  that you can use in the subsequent request to retrieve the next set of text.
"""
function get_segment_detection(JobId; aws_config::AbstractAWSConfig=current_aws_config())
    return rekognition(
        "GetSegmentDetection",
        Dict{String,Any}("JobId" => JobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_segment_detection(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "GetSegmentDetection",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("JobId" => JobId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_text_detection(job_id)
    get_text_detection(job_id, params::Dict{String,<:Any})

Gets the text detection results of a Amazon Rekognition Video analysis started by
StartTextDetection. Text detection with Amazon Rekognition Video is an asynchronous
operation. You start text detection by calling StartTextDetection which returns a job
identifier (JobId) When the text detection operation finishes, Amazon Rekognition publishes
a completion status to the Amazon Simple Notification Service topic registered in the
initial call to StartTextDetection. To get the results of the text detection operation,
first check that the status value published to the Amazon SNS topic is SUCCEEDED. if so,
call GetTextDetection and pass the job identifier (JobId) from the initial call of
StartLabelDetection.  GetTextDetection returns an array of detected text (TextDetections)
sorted by the time the text was detected, up to 100 words per frame of video. Each element
of the array includes the detected text, the precentage confidence in the acuracy of the
detected text, the time the text was detected, bounding box information for where the text
was located, and unique identifiers for words and their lines. Use MaxResults parameter to
limit the number of text detections returned. If there are more results than specified in
MaxResults, the value of NextToken in the operation response contains a pagination token
for getting the next set of results. To get the next page of results, call GetTextDetection
and populate the NextToken request parameter with the token value returned from the
previous call to GetTextDetection.

# Arguments
- `job_id`: Job identifier for the text detection operation for which you want results
  returned. You get the job identifer from an initial call to StartTextDetection.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Maximum number of results to return per paginated call. The largest value
  you can specify is 1000.
- `"NextToken"`: If the previous response was incomplete (because there are more labels to
  retrieve), Amazon Rekognition Video returns a pagination token in the response. You can use
  this pagination token to retrieve the next set of text.
"""
function get_text_detection(JobId; aws_config::AbstractAWSConfig=current_aws_config())
    return rekognition(
        "GetTextDetection",
        Dict{String,Any}("JobId" => JobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_text_detection(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "GetTextDetection",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("JobId" => JobId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    index_faces(collection_id, image)
    index_faces(collection_id, image, params::Dict{String,<:Any})

Detects faces in the input image and adds them to the specified collection.  Amazon
Rekognition doesn't save the actual faces that are detected. Instead, the underlying
detection algorithm first detects the faces in the input image. For each face, the
algorithm extracts facial features into a feature vector, and stores it in the backend
database. Amazon Rekognition uses feature vectors when it performs face match and search
operations using the SearchFaces and SearchFacesByImage operations. For more information,
see Adding faces to a collection in the Amazon Rekognition Developer Guide. To get the
number of faces in a collection, call DescribeCollection.  If you're using version 1.0 of
the face detection model, IndexFaces indexes the 15 largest faces in the input image. Later
versions of the face detection model index the 100 largest faces in the input image.  If
you're using version 4 or later of the face model, image orientation information is not
returned in the OrientationCorrection field.  To determine which version of the model
you're using, call DescribeCollection and supply the collection ID. You can also get the
model version from the value of FaceModelVersion in the response from IndexFaces  For more
information, see Model Versioning in the Amazon Rekognition Developer Guide. If you provide
the optional ExternalImageId for the input image you provided, Amazon Rekognition
associates this ID with all faces that it detects. When you call the ListFaces operation,
the response returns the external ID. You can use this external image ID to create a
client-side index to associate the faces with each image. You can then use the index to
find all faces in an image. You can specify the maximum number of faces to index with the
MaxFaces input parameter. This is useful when you want to index the largest faces in an
image and don't want to index smaller faces, such as those belonging to people standing in
the background. The QualityFilter input parameter allows you to filter out detected faces
that don’t meet a required quality bar. The quality bar is based on a variety of common
use cases. By default, IndexFaces chooses the quality bar that's used to filter faces. You
can also explicitly choose the quality bar. Use QualityFilter, to set the quality bar by
specifying LOW, MEDIUM, or HIGH. If you do not want to filter detected faces, specify NONE.
  To use quality filtering, you need a collection associated with version 3 of the face
model or higher. To get the version of the face model associated with a collection, call
DescribeCollection.   Information about faces detected in an image, but not indexed, is
returned in an array of UnindexedFace objects, UnindexedFaces. Faces aren't indexed for
reasons such as:   The number of faces detected exceeds the value of the MaxFaces request
parameter.   The face is too small compared to the image dimensions.   The face is too
blurry.   The image is too dark.   The face has an extreme pose.   The face doesn’t have
enough detail to be suitable for face search.   In response, the IndexFaces operation
returns an array of metadata for all detected faces, FaceRecords. This includes:    The
bounding box, BoundingBox, of the detected face.    A confidence value, Confidence, which
indicates the confidence that the bounding box contains a face.   A face ID, FaceId,
assigned by the service for each face that's detected and stored.   An image ID, ImageId,
assigned by the service for the input image.   If you request ALL or specific facial
attributes (e.g., FACE_OCCLUDED) by using the detectionAttributes parameter, Amazon
Rekognition returns detailed facial attributes, such as facial landmarks (for example,
location of eye and mouth), facial occlusion, and other facial attributes. If you provide
the same image, specify the same collection, and use the same external ID in the IndexFaces
operation, Amazon Rekognition doesn't save duplicate face metadata.  The input image is
passed either as base64-encoded image bytes, or as a reference to an image in an Amazon S3
bucket. If you use the AWS CLI to call Amazon Rekognition operations, passing image bytes
isn't supported. The image must be formatted as a PNG or JPEG file.  This operation
requires permissions to perform the rekognition:IndexFaces action.

# Arguments
- `collection_id`: The ID of an existing collection to which you want to add the faces that
  are detected in the input images.
- `image`: The input image as base64-encoded bytes or an S3 object. If you use the AWS CLI
  to call Amazon Rekognition operations, passing base64-encoded image bytes isn't supported.
  If you are using an AWS SDK to call Amazon Rekognition, you might not need to base64-encode
  image bytes passed using the Bytes field. For more information, see Images in the Amazon
  Rekognition developer guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DetectionAttributes"`: An array of facial attributes you want to be returned. A DEFAULT
  subset of facial attributes - BoundingBox, Confidence, Pose, Quality, and Landmarks - will
  always be returned. You can request for specific facial attributes (in addition to the
  default list) - by using [\"DEFAULT\", \"FACE_OCCLUDED\"] or just [\"FACE_OCCLUDED\"]. You
  can request for all facial attributes by using [\"ALL\"]. Requesting more attributes may
  increase response time. If you provide both, [\"ALL\", \"DEFAULT\"], the service uses a
  logical AND operator to determine which attributes to return (in this case, all
  attributes).
- `"ExternalImageId"`: The ID you want to assign to all the faces detected in the image.
- `"MaxFaces"`: The maximum number of faces to index. The value of MaxFaces must be greater
  than or equal to 1. IndexFaces returns no more than 100 detected faces in an image, even if
  you specify a larger value for MaxFaces. If IndexFaces detects more faces than the value of
  MaxFaces, the faces with the lowest quality are filtered out first. If there are still more
  faces than the value of MaxFaces, the faces with the smallest bounding boxes are filtered
  out (up to the number that's needed to satisfy the value of MaxFaces). Information about
  the unindexed faces is available in the UnindexedFaces array.  The faces that are returned
  by IndexFaces are sorted by the largest face bounding box size to the smallest size, in
  descending order.  MaxFaces can be used with a collection associated with any version of
  the face model.
- `"QualityFilter"`: A filter that specifies a quality bar for how much filtering is done
  to identify faces. Filtered faces aren't indexed. If you specify AUTO, Amazon Rekognition
  chooses the quality bar. If you specify LOW, MEDIUM, or HIGH, filtering removes all faces
  that don’t meet the chosen quality bar. The default value is AUTO. The quality bar is
  based on a variety of common use cases. Low-quality detections can occur for a number of
  reasons. Some examples are an object that's misidentified as a face, a face that's too
  blurry, or a face with a pose that's too extreme to use. If you specify NONE, no filtering
  is performed.  To use quality filtering, the collection you are using must be associated
  with version 3 of the face model or higher.
"""
function index_faces(
    CollectionId, Image; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "IndexFaces",
        Dict{String,Any}("CollectionId" => CollectionId, "Image" => Image);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function index_faces(
    CollectionId,
    Image,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rekognition(
        "IndexFaces",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("CollectionId" => CollectionId, "Image" => Image),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_collections()
    list_collections(params::Dict{String,<:Any})

Returns list of collection IDs in your account. If the result is truncated, the response
also provides a NextToken that you can use in the subsequent request to fetch the next set
of collection IDs. For an example, see Listing collections in the Amazon Rekognition
Developer Guide. This operation requires permissions to perform the
rekognition:ListCollections action.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Maximum number of collection IDs to return.
- `"NextToken"`: Pagination token from the previous response.
"""
function list_collections(; aws_config::AbstractAWSConfig=current_aws_config())
    return rekognition(
        "ListCollections"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_collections(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "ListCollections", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_dataset_entries(dataset_arn)
    list_dataset_entries(dataset_arn, params::Dict{String,<:Any})

 This operation applies only to Amazon Rekognition Custom Labels.   Lists the entries
(images) within a dataset. An entry is a JSON Line that contains the information for a
single image, including the image location, assigned labels, and object location bounding
boxes. For more information, see Creating a manifest file. JSON Lines in the response
include information about non-terminal errors found in the dataset. Non terminal errors are
reported in errors lists within each JSON Line. The same information is reported in the
training and testing validation result manifests that Amazon Rekognition Custom Labels
creates during model training.  You can filter the response in variety of ways, such as
choosing which labels to return and returning JSON Lines created after a specific date.
This operation requires permissions to perform the rekognition:ListDatasetEntries action.

# Arguments
- `dataset_arn`:  The Amazon Resource Name (ARN) for the dataset that you want to use.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ContainsLabels"`: Specifies a label filter for the response. The response includes an
  entry only if one or more of the labels in ContainsLabels exist in the entry.
- `"HasErrors"`: Specifies an error filter for the response. Specify True to only include
  entries that have errors.
- `"Labeled"`:  Specify true to get only the JSON Lines where the image is labeled. Specify
  false to get only the JSON Lines where the image isn't labeled. If you don't specify
  Labeled, ListDatasetEntries returns JSON Lines for labeled and unlabeled images.
- `"MaxResults"`: The maximum number of results to return per paginated call. The largest
  value you can specify is 100. If you specify a value greater than 100, a
  ValidationException error occurs. The default value is 100.
- `"NextToken"`: If the previous response was incomplete (because there is more results to
  retrieve), Amazon Rekognition Custom Labels returns a pagination token in the response. You
  can use this pagination token to retrieve the next set of results.
- `"SourceRefContains"`: If specified, ListDatasetEntries only returns JSON Lines where the
  value of SourceRefContains is part of the source-ref field. The source-ref field contains
  the Amazon S3 location of the image. You can use SouceRefContains for tasks such as getting
  the JSON Line for a single image, or gettting JSON Lines for all images within a specific
  folder.
"""
function list_dataset_entries(
    DatasetArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "ListDatasetEntries",
        Dict{String,Any}("DatasetArn" => DatasetArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_dataset_entries(
    DatasetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rekognition(
        "ListDatasetEntries",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DatasetArn" => DatasetArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_dataset_labels(dataset_arn)
    list_dataset_labels(dataset_arn, params::Dict{String,<:Any})

 This operation applies only to Amazon Rekognition Custom Labels.  Lists the labels in a
dataset. Amazon Rekognition Custom Labels uses labels to describe images. For more
information, see Labeling images.   Lists the labels in a dataset. Amazon Rekognition
Custom Labels uses labels to describe images. For more information, see Labeling images in
the Amazon Rekognition Custom Labels Developer Guide.

# Arguments
- `dataset_arn`:  The Amazon Resource Name (ARN) of the dataset that you want to use.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to return per paginated call. The largest
  value you can specify is 100. If you specify a value greater than 100, a
  ValidationException error occurs. The default value is 100.
- `"NextToken"`: If the previous response was incomplete (because there is more results to
  retrieve), Amazon Rekognition Custom Labels returns a pagination token in the response. You
  can use this pagination token to retrieve the next set of results.
"""
function list_dataset_labels(DatasetArn; aws_config::AbstractAWSConfig=current_aws_config())
    return rekognition(
        "ListDatasetLabels",
        Dict{String,Any}("DatasetArn" => DatasetArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_dataset_labels(
    DatasetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rekognition(
        "ListDatasetLabels",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DatasetArn" => DatasetArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_faces(collection_id)
    list_faces(collection_id, params::Dict{String,<:Any})

Returns metadata for faces in the specified collection. This metadata includes information
such as the bounding box coordinates, the confidence (that the bounding box contains a
face), and face ID. For an example, see Listing Faces in a Collection in the Amazon
Rekognition Developer Guide. This operation requires permissions to perform the
rekognition:ListFaces action.

# Arguments
- `collection_id`: ID of the collection from which to list the faces.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FaceIds"`: An array of face IDs to filter results with when listing faces in a
  collection.
- `"MaxResults"`: Maximum number of faces to return.
- `"NextToken"`: If the previous response was incomplete (because there is more data to
  retrieve), Amazon Rekognition returns a pagination token in the response. You can use this
  pagination token to retrieve the next set of faces.
- `"UserId"`: An array of user IDs to filter results with when listing faces in a
  collection.
"""
function list_faces(CollectionId; aws_config::AbstractAWSConfig=current_aws_config())
    return rekognition(
        "ListFaces",
        Dict{String,Any}("CollectionId" => CollectionId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_faces(
    CollectionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rekognition(
        "ListFaces",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("CollectionId" => CollectionId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_media_analysis_jobs()
    list_media_analysis_jobs(params::Dict{String,<:Any})

Returns a list of media analysis jobs. Results are sorted by CreationTimestamp in
descending order.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to return per paginated call. The largest
  value user can specify is 100. If user specifies a value greater than 100, an
  InvalidParameterException error occurs. The default value is 100.
- `"NextToken"`: Pagination token, if the previous response was incomplete.
"""
function list_media_analysis_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return rekognition(
        "ListMediaAnalysisJobs"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_media_analysis_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "ListMediaAnalysisJobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_project_policies(project_arn)
    list_project_policies(project_arn, params::Dict{String,<:Any})

 This operation applies only to Amazon Rekognition Custom Labels.  Gets a list of the
project policies attached to a project. To attach a project policy to a project, call
PutProjectPolicy. To remove a project policy from a project, call DeleteProjectPolicy. This
operation requires permissions to perform the rekognition:ListProjectPolicies action.

# Arguments
- `project_arn`: The ARN of the project for which you want to list the project policies.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to return per paginated call. The largest
  value you can specify is 5. If you specify a value greater than 5, a ValidationException
  error occurs. The default value is 5.
- `"NextToken"`: If the previous response was incomplete (because there is more results to
  retrieve), Amazon Rekognition Custom Labels returns a pagination token in the response. You
  can use this pagination token to retrieve the next set of results.
"""
function list_project_policies(
    ProjectArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "ListProjectPolicies",
        Dict{String,Any}("ProjectArn" => ProjectArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_project_policies(
    ProjectArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rekognition(
        "ListProjectPolicies",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ProjectArn" => ProjectArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_stream_processors()
    list_stream_processors(params::Dict{String,<:Any})

Gets a list of stream processors that you have created with CreateStreamProcessor.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Maximum number of stream processors you want Amazon Rekognition Video to
  return in the response. The default is 1000.
- `"NextToken"`: If the previous response was incomplete (because there are more stream
  processors to retrieve), Amazon Rekognition Video returns a pagination token in the
  response. You can use this pagination token to retrieve the next set of stream processors.
"""
function list_stream_processors(; aws_config::AbstractAWSConfig=current_aws_config())
    return rekognition(
        "ListStreamProcessors"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_stream_processors(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "ListStreamProcessors",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

 Returns a list of tags in an Amazon Rekognition collection, stream processor, or Custom
Labels model.  This operation requires permissions to perform the
rekognition:ListTagsForResource action.

# Arguments
- `resource_arn`:  Amazon Resource Name (ARN) of the model, collection, or stream processor
  that contains the tags that you want a list of.

"""
function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "ListTagsForResource",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rekognition(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_users(collection_id)
    list_users(collection_id, params::Dict{String,<:Any})

Returns metadata of the User such as UserID in the specified collection. Anonymous User (to
reserve faces without any identity) is not returned as part of this request. The results
are sorted by system generated primary key ID. If the response is truncated, NextToken is
returned in the response that can be used in the subsequent request to retrieve the next
set of identities.

# Arguments
- `collection_id`: The ID of an existing collection.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Maximum number of UsersID to return.
- `"NextToken"`: Pagingation token to receive the next set of UsersID.
"""
function list_users(CollectionId; aws_config::AbstractAWSConfig=current_aws_config())
    return rekognition(
        "ListUsers",
        Dict{String,Any}("CollectionId" => CollectionId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_users(
    CollectionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rekognition(
        "ListUsers",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("CollectionId" => CollectionId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_project_policy(policy_document, policy_name, project_arn)
    put_project_policy(policy_document, policy_name, project_arn, params::Dict{String,<:Any})

 This operation applies only to Amazon Rekognition Custom Labels.  Attaches a project
policy to a Amazon Rekognition Custom Labels project in a trusting AWS account. A project
policy specifies that a trusted AWS account can copy a model version from a trusting AWS
account to a project in the trusted AWS account. To copy a model version you use the
CopyProjectVersion operation. Only applies to Custom Labels projects. For more information
about the format of a project policy document, see Attaching a project policy (SDK) in the
Amazon Rekognition Custom Labels Developer Guide.  The response from PutProjectPolicy is a
revision ID for the project policy. You can attach multiple project policies to a project.
You can also update an existing project policy by specifying the policy revision ID of the
existing policy. To remove a project policy from a project, call DeleteProjectPolicy. To
get a list of project policies attached to a project, call ListProjectPolicies.  You copy a
model version by calling CopyProjectVersion. This operation requires permissions to perform
the rekognition:PutProjectPolicy action.

# Arguments
- `policy_document`: A resource policy to add to the model. The policy is a JSON structure
  that contains one or more statements that define the policy. The policy must follow the IAM
  syntax. For more information about the contents of a JSON policy document, see IAM JSON
  policy reference.
- `policy_name`: A name for the policy.
- `project_arn`: The Amazon Resource Name (ARN) of the project that the project policy is
  attached to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"PolicyRevisionId"`: The revision ID for the Project Policy. Each time you modify a
  policy, Amazon Rekognition Custom Labels generates and assigns a new PolicyRevisionId and
  then deletes the previous version of the policy.
"""
function put_project_policy(
    PolicyDocument,
    PolicyName,
    ProjectArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rekognition(
        "PutProjectPolicy",
        Dict{String,Any}(
            "PolicyDocument" => PolicyDocument,
            "PolicyName" => PolicyName,
            "ProjectArn" => ProjectArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_project_policy(
    PolicyDocument,
    PolicyName,
    ProjectArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rekognition(
        "PutProjectPolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "PolicyDocument" => PolicyDocument,
                    "PolicyName" => PolicyName,
                    "ProjectArn" => ProjectArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    recognize_celebrities(image)
    recognize_celebrities(image, params::Dict{String,<:Any})

Returns an array of celebrities recognized in the input image. For more information, see
Recognizing celebrities in the Amazon Rekognition Developer Guide.   RecognizeCelebrities
returns the 64 largest faces in the image. It lists the recognized celebrities in the
CelebrityFaces array and any unrecognized faces in the UnrecognizedFaces array.
RecognizeCelebrities doesn't return celebrities whose faces aren't among the largest 64
faces in the image. For each celebrity recognized, RecognizeCelebrities returns a Celebrity
object. The Celebrity object contains the celebrity name, ID, URL links to additional
information, match confidence, and a ComparedFace object that you can use to locate the
celebrity's face on the image. Amazon Rekognition doesn't retain information about which
images a celebrity has been recognized in. Your application must store this information and
use the Celebrity ID property as a unique identifier for the celebrity. If you don't store
the celebrity name or additional information URLs returned by RecognizeCelebrities, you
will need the ID to identify the celebrity in a call to the GetCelebrityInfo operation. You
pass the input image either as base64-encoded image bytes or as a reference to an image in
an Amazon S3 bucket. If you use the AWS CLI to call Amazon Rekognition operations, passing
image bytes is not supported. The image must be either a PNG or JPEG formatted file.  For
an example, see Recognizing celebrities in an image in the Amazon Rekognition Developer
Guide. This operation requires permissions to perform the rekognition:RecognizeCelebrities
operation.

# Arguments
- `image`: The input image as base64-encoded bytes or an S3 object. If you use the AWS CLI
  to call Amazon Rekognition operations, passing base64-encoded image bytes is not supported.
   If you are using an AWS SDK to call Amazon Rekognition, you might not need to
  base64-encode image bytes passed using the Bytes field. For more information, see Images in
  the Amazon Rekognition developer guide.

"""
function recognize_celebrities(Image; aws_config::AbstractAWSConfig=current_aws_config())
    return rekognition(
        "RecognizeCelebrities",
        Dict{String,Any}("Image" => Image);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function recognize_celebrities(
    Image, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "RecognizeCelebrities",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Image" => Image), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    search_faces(collection_id, face_id)
    search_faces(collection_id, face_id, params::Dict{String,<:Any})

For a given input face ID, searches for matching faces in the collection the face belongs
to. You get a face ID when you add a face to the collection using the IndexFaces operation.
The operation compares the features of the input face with faces in the specified
collection.   You can also search faces without indexing faces by using the
SearchFacesByImage operation.   The operation response returns an array of faces that
match, ordered by similarity score with the highest similarity first. More specifically, it
is an array of metadata for each face match that is found. Along with the metadata, the
response also includes a confidence value for each face match, indicating the confidence
that the specific face matches the input face.  For an example, see Searching for a face
using its face ID in the Amazon Rekognition Developer Guide. This operation requires
permissions to perform the rekognition:SearchFaces action.

# Arguments
- `collection_id`: ID of the collection the face belongs to.
- `face_id`: ID of a face to find matches for in the collection.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FaceMatchThreshold"`: Optional value specifying the minimum confidence in the face
  match to return. For example, don't return any matches where confidence in matches is less
  than 70%. The default value is 80%.
- `"MaxFaces"`: Maximum number of faces to return. The operation returns the maximum number
  of faces with the highest confidence in the match.
"""
function search_faces(
    CollectionId, FaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "SearchFaces",
        Dict{String,Any}("CollectionId" => CollectionId, "FaceId" => FaceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function search_faces(
    CollectionId,
    FaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rekognition(
        "SearchFaces",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("CollectionId" => CollectionId, "FaceId" => FaceId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    search_faces_by_image(collection_id, image)
    search_faces_by_image(collection_id, image, params::Dict{String,<:Any})

For a given input image, first detects the largest face in the image, and then searches the
specified collection for matching faces. The operation compares the features of the input
face with faces in the specified collection.   To search for all faces in an input image,
you might first call the IndexFaces operation, and then use the face IDs returned in
subsequent calls to the SearchFaces operation.   You can also call the DetectFaces
operation and use the bounding boxes in the response to make face crops, which then you can
pass in to the SearchFacesByImage operation.   You pass the input image either as
base64-encoded image bytes or as a reference to an image in an Amazon S3 bucket. If you use
the AWS CLI to call Amazon Rekognition operations, passing image bytes is not supported.
The image must be either a PNG or JPEG formatted file.   The response returns an array of
faces that match, ordered by similarity score with the highest similarity first. More
specifically, it is an array of metadata for each face match found. Along with the
metadata, the response also includes a similarity indicating how similar the face is to the
input face. In the response, the operation also returns the bounding box (and a confidence
level that the bounding box contains a face) of the face that Amazon Rekognition used for
the input image.  If no faces are detected in the input image, SearchFacesByImage returns
an InvalidParameterException error.  For an example, Searching for a Face Using an Image in
the Amazon Rekognition Developer Guide. The QualityFilter input parameter allows you to
filter out detected faces that don’t meet a required quality bar. The quality bar is
based on a variety of common use cases. Use QualityFilter to set the quality bar for
filtering by specifying LOW, MEDIUM, or HIGH. If you do not want to filter detected faces,
specify NONE. The default value is NONE.  To use quality filtering, you need a collection
associated with version 3 of the face model or higher. To get the version of the face model
associated with a collection, call DescribeCollection.   This operation requires
permissions to perform the rekognition:SearchFacesByImage action.

# Arguments
- `collection_id`: ID of the collection to search.
- `image`: The input image as base64-encoded bytes or an S3 object. If you use the AWS CLI
  to call Amazon Rekognition operations, passing base64-encoded image bytes is not supported.
   If you are using an AWS SDK to call Amazon Rekognition, you might not need to
  base64-encode image bytes passed using the Bytes field. For more information, see Images in
  the Amazon Rekognition developer guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FaceMatchThreshold"`: (Optional) Specifies the minimum confidence in the face match to
  return. For example, don't return any matches where confidence in matches is less than 70%.
  The default value is 80%.
- `"MaxFaces"`: Maximum number of faces to return. The operation returns the maximum number
  of faces with the highest confidence in the match.
- `"QualityFilter"`: A filter that specifies a quality bar for how much filtering is done
  to identify faces. Filtered faces aren't searched for in the collection. If you specify
  AUTO, Amazon Rekognition chooses the quality bar. If you specify LOW, MEDIUM, or HIGH,
  filtering removes all faces that don’t meet the chosen quality bar. The quality bar is
  based on a variety of common use cases. Low-quality detections can occur for a number of
  reasons. Some examples are an object that's misidentified as a face, a face that's too
  blurry, or a face with a pose that's too extreme to use. If you specify NONE, no filtering
  is performed. The default value is NONE.  To use quality filtering, the collection you are
  using must be associated with version 3 of the face model or higher.
"""
function search_faces_by_image(
    CollectionId, Image; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "SearchFacesByImage",
        Dict{String,Any}("CollectionId" => CollectionId, "Image" => Image);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function search_faces_by_image(
    CollectionId,
    Image,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rekognition(
        "SearchFacesByImage",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("CollectionId" => CollectionId, "Image" => Image),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    search_users(collection_id)
    search_users(collection_id, params::Dict{String,<:Any})

Searches for UserIDs within a collection based on a FaceId or UserId. This API can be used
to find the closest UserID (with a highest similarity) to associate a face. The request
must be provided with either FaceId or UserId. The operation returns an array of UserID
that match the FaceId or UserId, ordered by similarity score with the highest similarity
first.

# Arguments
- `collection_id`: The ID of an existing collection containing the UserID, used with a
  UserId or FaceId. If a FaceId is provided, UserId isn’t required to be present in the
  Collection.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FaceId"`: ID for the existing face.
- `"MaxUsers"`: Maximum number of identities to return.
- `"UserId"`: ID for the existing User.
- `"UserMatchThreshold"`: Optional value that specifies the minimum confidence in the
  matched UserID to return. Default value of 80.
"""
function search_users(CollectionId; aws_config::AbstractAWSConfig=current_aws_config())
    return rekognition(
        "SearchUsers",
        Dict{String,Any}("CollectionId" => CollectionId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function search_users(
    CollectionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rekognition(
        "SearchUsers",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("CollectionId" => CollectionId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    search_users_by_image(collection_id, image)
    search_users_by_image(collection_id, image, params::Dict{String,<:Any})

Searches for UserIDs using a supplied image. It first detects the largest face in the
image, and then searches a specified collection for matching UserIDs.  The operation
returns an array of UserIDs that match the face in the supplied image, ordered by
similarity score with the highest similarity first. It also returns a bounding box for the
face found in the input image.  Information about faces detected in the supplied image, but
not used for the search, is returned in an array of UnsearchedFace objects. If no valid
face is detected in the image, the response will contain an empty UserMatches list and no
SearchedFace object.

# Arguments
- `collection_id`: The ID of an existing collection containing the UserID.
- `image`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxUsers"`: Maximum number of UserIDs to return.
- `"QualityFilter"`: A filter that specifies a quality bar for how much filtering is done
  to identify faces. Filtered faces aren't searched for in the collection. The default value
  is NONE.
- `"UserMatchThreshold"`: Specifies the minimum confidence in the UserID match to return.
  Default value is 80.
"""
function search_users_by_image(
    CollectionId, Image; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "SearchUsersByImage",
        Dict{String,Any}("CollectionId" => CollectionId, "Image" => Image);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function search_users_by_image(
    CollectionId,
    Image,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rekognition(
        "SearchUsersByImage",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("CollectionId" => CollectionId, "Image" => Image),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_celebrity_recognition(video)
    start_celebrity_recognition(video, params::Dict{String,<:Any})

Starts asynchronous recognition of celebrities in a stored video. Amazon Rekognition Video
can detect celebrities in a video must be stored in an Amazon S3 bucket. Use Video to
specify the bucket name and the filename of the video. StartCelebrityRecognition returns a
job identifier (JobId) which you use to get the results of the analysis. When celebrity
recognition analysis is finished, Amazon Rekognition Video publishes a completion status to
the Amazon Simple Notification Service topic that you specify in NotificationChannel. To
get the results of the celebrity recognition analysis, first check that the status value
published to the Amazon SNS topic is SUCCEEDED. If so, call GetCelebrityRecognition and
pass the job identifier (JobId) from the initial call to StartCelebrityRecognition.  For
more information, see Recognizing celebrities in the Amazon Rekognition Developer Guide.

# Arguments
- `video`: The video in which you want to recognize celebrities. The video must be stored
  in an Amazon S3 bucket.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: Idempotent token used to identify the start request. If you use
  the same token with multiple StartCelebrityRecognition requests, the same JobId is
  returned. Use ClientRequestToken to prevent the same job from being accidently started more
  than once.
- `"JobTag"`: An identifier you specify that's returned in the completion notification
  that's published to your Amazon Simple Notification Service topic. For example, you can use
  JobTag to group related jobs and identify them in the completion notification.
- `"NotificationChannel"`: The Amazon SNS topic ARN that you want Amazon Rekognition Video
  to publish the completion status of the celebrity recognition analysis to. The Amazon SNS
  topic must have a topic name that begins with AmazonRekognition if you are using the
  AmazonRekognitionServiceRole permissions policy.
"""
function start_celebrity_recognition(
    Video; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "StartCelebrityRecognition",
        Dict{String,Any}("Video" => Video);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_celebrity_recognition(
    Video, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "StartCelebrityRecognition",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Video" => Video), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_content_moderation(video)
    start_content_moderation(video, params::Dict{String,<:Any})

 Starts asynchronous detection of inappropriate, unwanted, or offensive content in a stored
video. For a list of moderation labels in Amazon Rekognition, see Using the image and video
moderation APIs. Amazon Rekognition Video can moderate content in a video stored in an
Amazon S3 bucket. Use Video to specify the bucket name and the filename of the video.
StartContentModeration returns a job identifier (JobId) which you use to get the results of
the analysis. When content analysis is finished, Amazon Rekognition Video publishes a
completion status to the Amazon Simple Notification Service topic that you specify in
NotificationChannel. To get the results of the content analysis, first check that the
status value published to the Amazon SNS topic is SUCCEEDED. If so, call
GetContentModeration and pass the job identifier (JobId) from the initial call to
StartContentModeration.  For more information, see Moderating content in the Amazon
Rekognition Developer Guide.

# Arguments
- `video`: The video in which you want to detect inappropriate, unwanted, or offensive
  content. The video must be stored in an Amazon S3 bucket.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: Idempotent token used to identify the start request. If you use
  the same token with multiple StartContentModeration requests, the same JobId is returned.
  Use ClientRequestToken to prevent the same job from being accidently started more than
  once.
- `"JobTag"`: An identifier you specify that's returned in the completion notification
  that's published to your Amazon Simple Notification Service topic. For example, you can use
  JobTag to group related jobs and identify them in the completion notification.
- `"MinConfidence"`: Specifies the minimum confidence that Amazon Rekognition must have in
  order to return a moderated content label. Confidence represents how certain Amazon
  Rekognition is that the moderated content is correctly identified. 0 is the lowest
  confidence. 100 is the highest confidence. Amazon Rekognition doesn't return any moderated
  content labels with a confidence level lower than this specified value. If you don't
  specify MinConfidence, GetContentModeration returns labels with confidence values greater
  than or equal to 50 percent.
- `"NotificationChannel"`: The Amazon SNS topic ARN that you want Amazon Rekognition Video
  to publish the completion status of the content analysis to. The Amazon SNS topic must have
  a topic name that begins with AmazonRekognition if you are using the
  AmazonRekognitionServiceRole permissions policy to access the topic.
"""
function start_content_moderation(Video; aws_config::AbstractAWSConfig=current_aws_config())
    return rekognition(
        "StartContentModeration",
        Dict{String,Any}("Video" => Video);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_content_moderation(
    Video, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "StartContentModeration",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Video" => Video), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_face_detection(video)
    start_face_detection(video, params::Dict{String,<:Any})

Starts asynchronous detection of faces in a stored video. Amazon Rekognition Video can
detect faces in a video stored in an Amazon S3 bucket. Use Video to specify the bucket name
and the filename of the video. StartFaceDetection returns a job identifier (JobId) that you
use to get the results of the operation. When face detection is finished, Amazon
Rekognition Video publishes a completion status to the Amazon Simple Notification Service
topic that you specify in NotificationChannel. To get the results of the face detection
operation, first check that the status value published to the Amazon SNS topic is
SUCCEEDED. If so, call GetFaceDetection and pass the job identifier (JobId) from the
initial call to StartFaceDetection. For more information, see Detecting faces in a stored
video in the Amazon Rekognition Developer Guide.

# Arguments
- `video`: The video in which you want to detect faces. The video must be stored in an
  Amazon S3 bucket.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: Idempotent token used to identify the start request. If you use
  the same token with multiple StartFaceDetection requests, the same JobId is returned. Use
  ClientRequestToken to prevent the same job from being accidently started more than once.
- `"FaceAttributes"`: The face attributes you want returned.  DEFAULT - The following
  subset of facial attributes are returned: BoundingBox, Confidence, Pose, Quality and
  Landmarks.   ALL - All facial attributes are returned.
- `"JobTag"`: An identifier you specify that's returned in the completion notification
  that's published to your Amazon Simple Notification Service topic. For example, you can use
  JobTag to group related jobs and identify them in the completion notification.
- `"NotificationChannel"`: The ARN of the Amazon SNS topic to which you want Amazon
  Rekognition Video to publish the completion status of the face detection operation. The
  Amazon SNS topic must have a topic name that begins with AmazonRekognition if you are using
  the AmazonRekognitionServiceRole permissions policy.
"""
function start_face_detection(Video; aws_config::AbstractAWSConfig=current_aws_config())
    return rekognition(
        "StartFaceDetection",
        Dict{String,Any}("Video" => Video);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_face_detection(
    Video, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "StartFaceDetection",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Video" => Video), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_face_search(collection_id, video)
    start_face_search(collection_id, video, params::Dict{String,<:Any})

Starts the asynchronous search for faces in a collection that match the faces of persons
detected in a stored video. The video must be stored in an Amazon S3 bucket. Use Video to
specify the bucket name and the filename of the video. StartFaceSearch returns a job
identifier (JobId) which you use to get the search results once the search has completed.
When searching is finished, Amazon Rekognition Video publishes a completion status to the
Amazon Simple Notification Service topic that you specify in NotificationChannel. To get
the search results, first check that the status value published to the Amazon SNS topic is
SUCCEEDED. If so, call GetFaceSearch and pass the job identifier (JobId) from the initial
call to StartFaceSearch. For more information, see Searching stored videos for faces.

# Arguments
- `collection_id`: ID of the collection that contains the faces you want to search for.
- `video`: The video you want to search. The video must be stored in an Amazon S3 bucket.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: Idempotent token used to identify the start request. If you use
  the same token with multiple StartFaceSearch requests, the same JobId is returned. Use
  ClientRequestToken to prevent the same job from being accidently started more than once.
- `"FaceMatchThreshold"`: The minimum confidence in the person match to return. For
  example, don't return any matches where confidence in matches is less than 70%. The default
  value is 80%.
- `"JobTag"`: An identifier you specify that's returned in the completion notification
  that's published to your Amazon Simple Notification Service topic. For example, you can use
  JobTag to group related jobs and identify them in the completion notification.
- `"NotificationChannel"`: The ARN of the Amazon SNS topic to which you want Amazon
  Rekognition Video to publish the completion status of the search. The Amazon SNS topic must
  have a topic name that begins with AmazonRekognition if you are using the
  AmazonRekognitionServiceRole permissions policy to access the topic.
"""
function start_face_search(
    CollectionId, Video; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "StartFaceSearch",
        Dict{String,Any}("CollectionId" => CollectionId, "Video" => Video);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_face_search(
    CollectionId,
    Video,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rekognition(
        "StartFaceSearch",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("CollectionId" => CollectionId, "Video" => Video),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_label_detection(video)
    start_label_detection(video, params::Dict{String,<:Any})

Starts asynchronous detection of labels in a stored video. Amazon Rekognition Video can
detect labels in a video. Labels are instances of real-world entities. This includes
objects like flower, tree, and table; events like wedding, graduation, and birthday party;
concepts like landscape, evening, and nature; and activities like a person getting out of a
car or a person skiing. The video must be stored in an Amazon S3 bucket. Use Video to
specify the bucket name and the filename of the video. StartLabelDetection returns a job
identifier (JobId) which you use to get the results of the operation. When label detection
is finished, Amazon Rekognition Video publishes a completion status to the Amazon Simple
Notification Service topic that you specify in NotificationChannel. To get the results of
the label detection operation, first check that the status value published to the Amazon
SNS topic is SUCCEEDED. If so, call GetLabelDetection and pass the job identifier (JobId)
from the initial call to StartLabelDetection.  Optional Parameters   StartLabelDetection
has the GENERAL_LABELS Feature applied by default. This feature allows you to provide
filtering criteria to the Settings parameter. You can filter with sets of individual labels
or with label categories. You can specify inclusive filters, exclusive filters, or a
combination of inclusive and exclusive filters. For more information on filtering, see
Detecting labels in a video. You can specify MinConfidence to control the confidence
threshold for the labels returned. The default is 50.

# Arguments
- `video`: The video in which you want to detect labels. The video must be stored in an
  Amazon S3 bucket.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: Idempotent token used to identify the start request. If you use
  the same token with multiple StartLabelDetection requests, the same JobId is returned. Use
  ClientRequestToken to prevent the same job from being accidently started more than once.
- `"Features"`: The features to return after video analysis. You can specify that
  GENERAL_LABELS are returned.
- `"JobTag"`: An identifier you specify that's returned in the completion notification
  that's published to your Amazon Simple Notification Service topic. For example, you can use
  JobTag to group related jobs and identify them in the completion notification.
- `"MinConfidence"`: Specifies the minimum confidence that Amazon Rekognition Video must
  have in order to return a detected label. Confidence represents how certain Amazon
  Rekognition is that a label is correctly identified.0 is the lowest confidence. 100 is the
  highest confidence. Amazon Rekognition Video doesn't return any labels with a confidence
  level lower than this specified value. If you don't specify MinConfidence, the operation
  returns labels and bounding boxes (if detected) with confidence values greater than or
  equal to 50 percent.
- `"NotificationChannel"`: The Amazon SNS topic ARN you want Amazon Rekognition Video to
  publish the completion status of the label detection operation to. The Amazon SNS topic
  must have a topic name that begins with AmazonRekognition if you are using the
  AmazonRekognitionServiceRole permissions policy.
- `"Settings"`: The settings for a StartLabelDetection request.Contains the specified
  parameters for the label detection request of an asynchronous label analysis operation.
  Settings can include filters for GENERAL_LABELS.
"""
function start_label_detection(Video; aws_config::AbstractAWSConfig=current_aws_config())
    return rekognition(
        "StartLabelDetection",
        Dict{String,Any}("Video" => Video);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_label_detection(
    Video, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "StartLabelDetection",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Video" => Video), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_media_analysis_job(input, operations_config, output_config)
    start_media_analysis_job(input, operations_config, output_config, params::Dict{String,<:Any})

Initiates a new media analysis job. Accepts a manifest file in an Amazon S3 bucket. The
output is a manifest file and a summary of the manifest stored in the Amazon S3 bucket.

# Arguments
- `input`: Input data to be analyzed by the job.
- `operations_config`: Configuration options for the media analysis job to be created.
- `output_config`: The Amazon S3 bucket location to store the results.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: Idempotency token used to prevent the accidental creation of
  duplicate versions. If you use the same token with multiple StartMediaAnalysisJobRequest
  requests, the same response is returned. Use ClientRequestToken to prevent the same request
  from being processed more than once.
- `"JobName"`: The name of the job. Does not have to be unique.
- `"KmsKeyId"`: The identifier of customer managed AWS KMS key (name or ARN). The key is
  used to encrypt images copied into the service. The key is also used to encrypt results and
  manifest files written to the output Amazon S3 bucket.
"""
function start_media_analysis_job(
    Input,
    OperationsConfig,
    OutputConfig;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rekognition(
        "StartMediaAnalysisJob",
        Dict{String,Any}(
            "Input" => Input,
            "OperationsConfig" => OperationsConfig,
            "OutputConfig" => OutputConfig,
            "ClientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_media_analysis_job(
    Input,
    OperationsConfig,
    OutputConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rekognition(
        "StartMediaAnalysisJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Input" => Input,
                    "OperationsConfig" => OperationsConfig,
                    "OutputConfig" => OutputConfig,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_person_tracking(video)
    start_person_tracking(video, params::Dict{String,<:Any})

Starts the asynchronous tracking of a person's path in a stored video. Amazon Rekognition
Video can track the path of people in a video stored in an Amazon S3 bucket. Use Video to
specify the bucket name and the filename of the video. StartPersonTracking returns a job
identifier (JobId) which you use to get the results of the operation. When label detection
is finished, Amazon Rekognition publishes a completion status to the Amazon Simple
Notification Service topic that you specify in NotificationChannel.  To get the results of
the person detection operation, first check that the status value published to the Amazon
SNS topic is SUCCEEDED. If so, call GetPersonTracking and pass the job identifier (JobId)
from the initial call to StartPersonTracking.

# Arguments
- `video`: The video in which you want to detect people. The video must be stored in an
  Amazon S3 bucket.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: Idempotent token used to identify the start request. If you use
  the same token with multiple StartPersonTracking requests, the same JobId is returned. Use
  ClientRequestToken to prevent the same job from being accidently started more than once.
- `"JobTag"`: An identifier you specify that's returned in the completion notification
  that's published to your Amazon Simple Notification Service topic. For example, you can use
  JobTag to group related jobs and identify them in the completion notification.
- `"NotificationChannel"`: The Amazon SNS topic ARN you want Amazon Rekognition Video to
  publish the completion status of the people detection operation to. The Amazon SNS topic
  must have a topic name that begins with AmazonRekognition if you are using the
  AmazonRekognitionServiceRole permissions policy.
"""
function start_person_tracking(Video; aws_config::AbstractAWSConfig=current_aws_config())
    return rekognition(
        "StartPersonTracking",
        Dict{String,Any}("Video" => Video);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_person_tracking(
    Video, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "StartPersonTracking",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Video" => Video), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_project_version(min_inference_units, project_version_arn)
    start_project_version(min_inference_units, project_version_arn, params::Dict{String,<:Any})

 This operation applies only to Amazon Rekognition Custom Labels.  Starts the running of
the version of a model. Starting a model takes a while to complete. To check the current
state of the model, use DescribeProjectVersions.  Once the model is running, you can detect
custom labels in new images by calling DetectCustomLabels.  You are charged for the amount
of time that the model is running. To stop a running model, call StopProjectVersion.  This
operation requires permissions to perform the rekognition:StartProjectVersion action.

# Arguments
- `min_inference_units`: The minimum number of inference units to use. A single inference
  unit represents 1 hour of processing.  Use a higher number to increase the TPS throughput
  of your model. You are charged for the number of inference units that you use.
- `project_version_arn`: The Amazon Resource Name(ARN) of the model version that you want
  to start.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxInferenceUnits"`: The maximum number of inference units to use for auto-scaling the
  model. If you don't specify a value, Amazon Rekognition Custom Labels doesn't auto-scale
  the model.
"""
function start_project_version(
    MinInferenceUnits, ProjectVersionArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "StartProjectVersion",
        Dict{String,Any}(
            "MinInferenceUnits" => MinInferenceUnits,
            "ProjectVersionArn" => ProjectVersionArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_project_version(
    MinInferenceUnits,
    ProjectVersionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rekognition(
        "StartProjectVersion",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "MinInferenceUnits" => MinInferenceUnits,
                    "ProjectVersionArn" => ProjectVersionArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_segment_detection(segment_types, video)
    start_segment_detection(segment_types, video, params::Dict{String,<:Any})

Starts asynchronous detection of segment detection in a stored video. Amazon Rekognition
Video can detect segments in a video stored in an Amazon S3 bucket. Use Video to specify
the bucket name and the filename of the video. StartSegmentDetection returns a job
identifier (JobId) which you use to get the results of the operation. When segment
detection is finished, Amazon Rekognition Video publishes a completion status to the Amazon
Simple Notification Service topic that you specify in NotificationChannel. You can use the
Filters (StartSegmentDetectionFilters) input parameter to specify the minimum detection
confidence returned in the response. Within Filters, use ShotFilter
(StartShotDetectionFilter) to filter detected shots. Use TechnicalCueFilter
(StartTechnicalCueDetectionFilter) to filter technical cues.  To get the results of the
segment detection operation, first check that the status value published to the Amazon SNS
topic is SUCCEEDED. if so, call GetSegmentDetection and pass the job identifier (JobId)
from the initial call to StartSegmentDetection.  For more information, see Detecting video
segments in stored video in the Amazon Rekognition Developer Guide.

# Arguments
- `segment_types`: An array of segment types to detect in the video. Valid values are
  TECHNICAL_CUE and SHOT.
- `video`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: Idempotent token used to identify the start request. If you use
  the same token with multiple StartSegmentDetection requests, the same JobId is returned.
  Use ClientRequestToken to prevent the same job from being accidently started more than
  once.
- `"Filters"`: Filters for technical cue or shot detection.
- `"JobTag"`: An identifier you specify that's returned in the completion notification
  that's published to your Amazon Simple Notification Service topic. For example, you can use
  JobTag to group related jobs and identify them in the completion notification.
- `"NotificationChannel"`: The ARN of the Amazon SNS topic to which you want Amazon
  Rekognition Video to publish the completion status of the segment detection operation. Note
  that the Amazon SNS topic must have a topic name that begins with AmazonRekognition if you
  are using the AmazonRekognitionServiceRole permissions policy to access the topic.
"""
function start_segment_detection(
    SegmentTypes, Video; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "StartSegmentDetection",
        Dict{String,Any}("SegmentTypes" => SegmentTypes, "Video" => Video);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_segment_detection(
    SegmentTypes,
    Video,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rekognition(
        "StartSegmentDetection",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("SegmentTypes" => SegmentTypes, "Video" => Video),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_stream_processor(name)
    start_stream_processor(name, params::Dict{String,<:Any})

Starts processing a stream processor. You create a stream processor by calling
CreateStreamProcessor. To tell StartStreamProcessor which stream processor to start, use
the value of the Name field specified in the call to CreateStreamProcessor. If you are
using a label detection stream processor to detect labels, you need to provide a Start
selector and a Stop selector to determine the length of the stream processing time.

# Arguments
- `name`: The name of the stream processor to start processing.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"StartSelector"`:  Specifies the starting point in the Kinesis stream to start
  processing. You can use the producer timestamp or the fragment number. If you use the
  producer timestamp, you must put the time in milliseconds. For more information about
  fragment numbers, see Fragment.  This is a required parameter for label detection stream
  processors and should not be used to start a face search stream processor.
- `"StopSelector"`:  Specifies when to stop processing the stream. You can specify a
  maximum amount of time to process the video.  This is a required parameter for label
  detection stream processors and should not be used to start a face search stream processor.
"""
function start_stream_processor(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return rekognition(
        "StartStreamProcessor",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_stream_processor(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "StartStreamProcessor",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_text_detection(video)
    start_text_detection(video, params::Dict{String,<:Any})

Starts asynchronous detection of text in a stored video. Amazon Rekognition Video can
detect text in a video stored in an Amazon S3 bucket. Use Video to specify the bucket name
and the filename of the video. StartTextDetection returns a job identifier (JobId) which
you use to get the results of the operation. When text detection is finished, Amazon
Rekognition Video publishes a completion status to the Amazon Simple Notification Service
topic that you specify in NotificationChannel. To get the results of the text detection
operation, first check that the status value published to the Amazon SNS topic is
SUCCEEDED. if so, call GetTextDetection and pass the job identifier (JobId) from the
initial call to StartTextDetection.

# Arguments
- `video`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: Idempotent token used to identify the start request. If you use
  the same token with multiple StartTextDetection requests, the same JobId is returned. Use
  ClientRequestToken to prevent the same job from being accidentaly started more than once.
- `"Filters"`: Optional parameters that let you set criteria the text must meet to be
  included in your response.
- `"JobTag"`: An identifier returned in the completion status published by your Amazon
  Simple Notification Service topic. For example, you can use JobTag to group related jobs
  and identify them in the completion notification.
- `"NotificationChannel"`:
"""
function start_text_detection(Video; aws_config::AbstractAWSConfig=current_aws_config())
    return rekognition(
        "StartTextDetection",
        Dict{String,Any}("Video" => Video);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_text_detection(
    Video, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "StartTextDetection",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Video" => Video), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_project_version(project_version_arn)
    stop_project_version(project_version_arn, params::Dict{String,<:Any})

 This operation applies only to Amazon Rekognition Custom Labels.  Stops a running model.
The operation might take a while to complete. To check the current status, call
DescribeProjectVersions. Only applies to Custom Labels projects. This operation requires
permissions to perform the rekognition:StopProjectVersion action.

# Arguments
- `project_version_arn`: The Amazon Resource Name (ARN) of the model version that you want
  to stop. This operation requires permissions to perform the rekognition:StopProjectVersion
  action.

"""
function stop_project_version(
    ProjectVersionArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "StopProjectVersion",
        Dict{String,Any}("ProjectVersionArn" => ProjectVersionArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_project_version(
    ProjectVersionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rekognition(
        "StopProjectVersion",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ProjectVersionArn" => ProjectVersionArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_stream_processor(name)
    stop_stream_processor(name, params::Dict{String,<:Any})

Stops a running stream processor that was created by CreateStreamProcessor.

# Arguments
- `name`: The name of a stream processor created by CreateStreamProcessor.

"""
function stop_stream_processor(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return rekognition(
        "StopStreamProcessor",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_stream_processor(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "StopStreamProcessor",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

 Adds one or more key-value tags to an Amazon Rekognition collection, stream processor, or
Custom Labels model. For more information, see Tagging AWS Resources.  This operation
requires permissions to perform the rekognition:TagResource action.

# Arguments
- `resource_arn`:  Amazon Resource Name (ARN) of the model, collection, or stream processor
  that you want to assign the tags to.
- `tags`:  The key-value tags to assign to the resource.

"""
function tag_resource(ResourceArn, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return rekognition(
        "TagResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceArn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rekognition(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

 Removes one or more tags from an Amazon Rekognition collection, stream processor, or
Custom Labels model.  This operation requires permissions to perform the
rekognition:UntagResource action.

# Arguments
- `resource_arn`:  Amazon Resource Name (ARN) of the model, collection, or stream processor
  that you want to remove the tags from.
- `tag_keys`:  A list of the tags that you want to remove.

"""
function untag_resource(
    ResourceArn, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "UntagResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceArn,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rekognition(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_dataset_entries(changes, dataset_arn)
    update_dataset_entries(changes, dataset_arn, params::Dict{String,<:Any})

 This operation applies only to Amazon Rekognition Custom Labels.  Adds or updates one or
more entries (images) in a dataset. An entry is a JSON Line which contains the information
for a single image, including the image location, assigned labels, and object location
bounding boxes. For more information, see Image-Level labels in manifest files and Object
localization in manifest files in the Amazon Rekognition Custom Labels Developer Guide.  If
the source-ref field in the JSON line references an existing image, the existing image in
the dataset is updated. If source-ref field doesn't reference an existing image, the image
is added as a new image to the dataset.  You specify the changes that you want to make in
the Changes input parameter. There isn't a limit to the number JSON Lines that you can
change, but the size of Changes must be less than 5MB.  UpdateDatasetEntries returns
immediatly, but the dataset update might take a while to complete. Use DescribeDataset to
check the current status. The dataset updated successfully if the value of Status is
UPDATE_COMPLETE.  To check if any non-terminal errors occured, call ListDatasetEntries and
check for the presence of errors lists in the JSON Lines. Dataset update fails if a
terminal error occurs (Status = UPDATE_FAILED). Currently, you can't access the terminal
error information from the Amazon Rekognition Custom Labels SDK.  This operation requires
permissions to perform the rekognition:UpdateDatasetEntries action.

# Arguments
- `changes`:  The changes that you want to make to the dataset.
- `dataset_arn`:  The Amazon Resource Name (ARN) of the dataset that you want to update.

"""
function update_dataset_entries(
    Changes, DatasetArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "UpdateDatasetEntries",
        Dict{String,Any}("Changes" => Changes, "DatasetArn" => DatasetArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_dataset_entries(
    Changes,
    DatasetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return rekognition(
        "UpdateDatasetEntries",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Changes" => Changes, "DatasetArn" => DatasetArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_stream_processor(name)
    update_stream_processor(name, params::Dict{String,<:Any})

 Allows you to update a stream processor. You can change some settings and regions of
interest and delete certain parameters.

# Arguments
- `name`:  Name of the stream processor that you want to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DataSharingPreferenceForUpdate"`:  Shows whether you are sharing data with Rekognition
  to improve model performance. You can choose this option at the account level or on a
  per-stream basis. Note that if you opt out at the account level this setting is ignored on
  individual streams.
- `"ParametersToDelete"`:  A list of parameters you want to delete from the stream
  processor.
- `"RegionsOfInterestForUpdate"`:  Specifies locations in the frames where Amazon
  Rekognition checks for objects or people. This is an optional parameter for label detection
  stream processors.
- `"SettingsForUpdate"`:  The stream processor settings that you want to update. Label
  detection settings can be updated to detect different labels with a different minimum
  confidence.
"""
function update_stream_processor(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return rekognition(
        "UpdateStreamProcessor",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_stream_processor(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return rekognition(
        "UpdateStreamProcessor",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: cleanrooms
using AWS.Compat
using AWS.UUIDs

"""
    batch_get_collaboration_analysis_template(analysis_template_arns, collaboration_identifier)
    batch_get_collaboration_analysis_template(analysis_template_arns, collaboration_identifier, params::Dict{String,<:Any})

Retrieves multiple analysis templates within a collaboration by their Amazon Resource Names
(ARNs).

# Arguments
- `analysis_template_arns`: The Amazon Resource Name (ARN) associated with the analysis
  template within a collaboration.
- `collaboration_identifier`: A unique identifier for the collaboration that the analysis
  templates belong to. Currently accepts collaboration ID.

"""
function batch_get_collaboration_analysis_template(
    analysisTemplateArns,
    collaborationIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "POST",
        "/collaborations/$(collaborationIdentifier)/batch-analysistemplates",
        Dict{String,Any}("analysisTemplateArns" => analysisTemplateArns);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_collaboration_analysis_template(
    analysisTemplateArns,
    collaborationIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "POST",
        "/collaborations/$(collaborationIdentifier)/batch-analysistemplates",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("analysisTemplateArns" => analysisTemplateArns),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_get_schema(collaboration_identifier, names)
    batch_get_schema(collaboration_identifier, names, params::Dict{String,<:Any})

Retrieves multiple schemas by their identifiers.

# Arguments
- `collaboration_identifier`: A unique identifier for the collaboration that the schemas
  belong to. Currently accepts collaboration ID.
- `names`: The names for the schema objects to retrieve.

"""
function batch_get_schema(
    collaborationIdentifier, names; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cleanrooms(
        "POST",
        "/collaborations/$(collaborationIdentifier)/batch-schema",
        Dict{String,Any}("names" => names);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_schema(
    collaborationIdentifier,
    names,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "POST",
        "/collaborations/$(collaborationIdentifier)/batch-schema",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("names" => names), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_get_schema_analysis_rule(collaboration_identifier, schema_analysis_rule_requests)
    batch_get_schema_analysis_rule(collaboration_identifier, schema_analysis_rule_requests, params::Dict{String,<:Any})

Retrieves multiple analysis rule schemas.

# Arguments
- `collaboration_identifier`: The unique identifier of the collaboration that contains the
  schema analysis rule.
- `schema_analysis_rule_requests`: The information that's necessary to retrieve a schema
  analysis rule.

"""
function batch_get_schema_analysis_rule(
    collaborationIdentifier,
    schemaAnalysisRuleRequests;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "POST",
        "/collaborations/$(collaborationIdentifier)/batch-schema-analysis-rule",
        Dict{String,Any}("schemaAnalysisRuleRequests" => schemaAnalysisRuleRequests);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_schema_analysis_rule(
    collaborationIdentifier,
    schemaAnalysisRuleRequests,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "POST",
        "/collaborations/$(collaborationIdentifier)/batch-schema-analysis-rule",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "schemaAnalysisRuleRequests" => schemaAnalysisRuleRequests
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_analysis_template(format, membership_identifier, name, source)
    create_analysis_template(format, membership_identifier, name, source, params::Dict{String,<:Any})

Creates a new analysis template.

# Arguments
- `format`: The format of the analysis template.
- `membership_identifier`: The identifier for a membership resource.
- `name`: The name of the analysis template.
- `source`: The information in the analysis template. Currently supports text, the query
  text for the analysis template.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"analysisParameters"`: The parameters of the analysis template.
- `"description"`: The description of the analysis template.
- `"tags"`: An optional label that you can assign to a resource when you create it. Each
  tag consists of a key and an optional value, both of which you define. When you use
  tagging, you can also use tag-based access control in IAM policies to control access to
  this resource.
"""
function create_analysis_template(
    format,
    membershipIdentifier,
    name,
    source;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "POST",
        "/memberships/$(membershipIdentifier)/analysistemplates",
        Dict{String,Any}("format" => format, "name" => name, "source" => source);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_analysis_template(
    format,
    membershipIdentifier,
    name,
    source,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "POST",
        "/memberships/$(membershipIdentifier)/analysistemplates",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("format" => format, "name" => name, "source" => source),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_collaboration(creator_display_name, creator_member_abilities, description, members, name, query_log_status)
    create_collaboration(creator_display_name, creator_member_abilities, description, members, name, query_log_status, params::Dict{String,<:Any})

Creates a new collaboration.

# Arguments
- `creator_display_name`: The display name of the collaboration creator.
- `creator_member_abilities`: The abilities granted to the collaboration creator.
- `description`: A description of the collaboration provided by the collaboration owner.
- `members`: A list of initial members, not including the creator. This list is immutable.
- `name`: The display name for a collaboration.
- `query_log_status`: An indicator as to whether query logging has been enabled or disabled
  for the collaboration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"creatorPaymentConfiguration"`: The collaboration creator's payment responsibilities set
  by the collaboration creator.  If the collaboration creator hasn't specified anyone as the
  member paying for query compute costs, then the member who can query is the default payer.
- `"dataEncryptionMetadata"`: The settings for client-side encryption with Cryptographic
  Computing for Clean Rooms.
- `"tags"`: An optional label that you can assign to a resource when you create it. Each
  tag consists of a key and an optional value, both of which you define. When you use
  tagging, you can also use tag-based access control in IAM policies to control access to
  this resource.
"""
function create_collaboration(
    creatorDisplayName,
    creatorMemberAbilities,
    description,
    members,
    name,
    queryLogStatus;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "POST",
        "/collaborations",
        Dict{String,Any}(
            "creatorDisplayName" => creatorDisplayName,
            "creatorMemberAbilities" => creatorMemberAbilities,
            "description" => description,
            "members" => members,
            "name" => name,
            "queryLogStatus" => queryLogStatus,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_collaboration(
    creatorDisplayName,
    creatorMemberAbilities,
    description,
    members,
    name,
    queryLogStatus,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "POST",
        "/collaborations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "creatorDisplayName" => creatorDisplayName,
                    "creatorMemberAbilities" => creatorMemberAbilities,
                    "description" => description,
                    "members" => members,
                    "name" => name,
                    "queryLogStatus" => queryLogStatus,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_configured_audience_model_association(configured_audience_model_arn, configured_audience_model_association_name, manage_resource_policies, membership_identifier)
    create_configured_audience_model_association(configured_audience_model_arn, configured_audience_model_association_name, manage_resource_policies, membership_identifier, params::Dict{String,<:Any})

Provides the details necessary to create a configured audience model association.

# Arguments
- `configured_audience_model_arn`: A unique identifier for the configured audience model
  that you want to associate.
- `configured_audience_model_association_name`: The name of the configured audience model
  association.
- `manage_resource_policies`: When TRUE, indicates that the resource policy for the
  configured audience model resource being associated is configured for Clean Rooms to manage
  permissions related to the given collaboration. When FALSE, indicates that the configured
  audience model resource owner will manage permissions related to the given collaboration.
  Setting this to TRUE requires you to have permissions to create, update, and delete the
  resource policy for the cleanrooms-ml resource when you call the
  DeleteConfiguredAudienceModelAssociation resource. In addition, if you are the
  collaboration creator and specify TRUE, you must have the same permissions when you call
  the DeleteMember and DeleteCollaboration APIs.
- `membership_identifier`: A unique identifier for one of your memberships for a
  collaboration. The configured audience model is associated to the collaboration that this
  membership belongs to. Accepts a membership ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A description of the configured audience model association.
- `"tags"`: An optional label that you can assign to a resource when you create it. Each
  tag consists of a key and an optional value, both of which you define. When you use
  tagging, you can also use tag-based access control in IAM policies to control access to
  this resource.
"""
function create_configured_audience_model_association(
    configuredAudienceModelArn,
    configuredAudienceModelAssociationName,
    manageResourcePolicies,
    membershipIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "POST",
        "/memberships/$(membershipIdentifier)/configuredaudiencemodelassociations",
        Dict{String,Any}(
            "configuredAudienceModelArn" => configuredAudienceModelArn,
            "configuredAudienceModelAssociationName" =>
                configuredAudienceModelAssociationName,
            "manageResourcePolicies" => manageResourcePolicies,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_configured_audience_model_association(
    configuredAudienceModelArn,
    configuredAudienceModelAssociationName,
    manageResourcePolicies,
    membershipIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "POST",
        "/memberships/$(membershipIdentifier)/configuredaudiencemodelassociations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "configuredAudienceModelArn" => configuredAudienceModelArn,
                    "configuredAudienceModelAssociationName" =>
                        configuredAudienceModelAssociationName,
                    "manageResourcePolicies" => manageResourcePolicies,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_configured_table(allowed_columns, analysis_method, name, table_reference)
    create_configured_table(allowed_columns, analysis_method, name, table_reference, params::Dict{String,<:Any})

Creates a new configured table resource.

# Arguments
- `allowed_columns`: The columns of the underlying table that can be used by collaborations
  or analysis rules.
- `analysis_method`: The analysis method for the configured tables. The only valid value is
  currently `DIRECT_QUERY`.
- `name`: The name of the configured table.
- `table_reference`: A reference to the Glue table being configured.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A description for the configured table.
- `"tags"`: An optional label that you can assign to a resource when you create it. Each
  tag consists of a key and an optional value, both of which you define. When you use
  tagging, you can also use tag-based access control in IAM policies to control access to
  this resource.
"""
function create_configured_table(
    allowedColumns,
    analysisMethod,
    name,
    tableReference;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "POST",
        "/configuredTables",
        Dict{String,Any}(
            "allowedColumns" => allowedColumns,
            "analysisMethod" => analysisMethod,
            "name" => name,
            "tableReference" => tableReference,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_configured_table(
    allowedColumns,
    analysisMethod,
    name,
    tableReference,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "POST",
        "/configuredTables",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "allowedColumns" => allowedColumns,
                    "analysisMethod" => analysisMethod,
                    "name" => name,
                    "tableReference" => tableReference,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_configured_table_analysis_rule(analysis_rule_policy, analysis_rule_type, configured_table_identifier)
    create_configured_table_analysis_rule(analysis_rule_policy, analysis_rule_type, configured_table_identifier, params::Dict{String,<:Any})

Creates a new analysis rule for a configured table. Currently, only one analysis rule can
be created for a given configured table.

# Arguments
- `analysis_rule_policy`: The entire created configured table analysis rule object.
- `analysis_rule_type`: The type of analysis rule.
- `configured_table_identifier`: The identifier for the configured table to create the
  analysis rule for. Currently accepts the configured table ID.

"""
function create_configured_table_analysis_rule(
    analysisRulePolicy,
    analysisRuleType,
    configuredTableIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "POST",
        "/configuredTables/$(configuredTableIdentifier)/analysisRule",
        Dict{String,Any}(
            "analysisRulePolicy" => analysisRulePolicy,
            "analysisRuleType" => analysisRuleType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_configured_table_analysis_rule(
    analysisRulePolicy,
    analysisRuleType,
    configuredTableIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "POST",
        "/configuredTables/$(configuredTableIdentifier)/analysisRule",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "analysisRulePolicy" => analysisRulePolicy,
                    "analysisRuleType" => analysisRuleType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_configured_table_association(configured_table_identifier, membership_identifier, name, role_arn)
    create_configured_table_association(configured_table_identifier, membership_identifier, name, role_arn, params::Dict{String,<:Any})

Creates a configured table association. A configured table association links a configured
table with a collaboration.

# Arguments
- `configured_table_identifier`: A unique identifier for the configured table to be
  associated to. Currently accepts a configured table ID.
- `membership_identifier`: A unique identifier for one of your memberships for a
  collaboration. The configured table is associated to the collaboration that this membership
  belongs to. Currently accepts a membership ID.
- `name`: The name of the configured table association. This name is used to query the
  underlying configured table.
- `role_arn`: The service will assume this role to access catalog metadata and query the
  table.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A description for the configured table association.
- `"tags"`: An optional label that you can assign to a resource when you create it. Each
  tag consists of a key and an optional value, both of which you define. When you use
  tagging, you can also use tag-based access control in IAM policies to control access to
  this resource.
"""
function create_configured_table_association(
    configuredTableIdentifier,
    membershipIdentifier,
    name,
    roleArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "POST",
        "/memberships/$(membershipIdentifier)/configuredTableAssociations",
        Dict{String,Any}(
            "configuredTableIdentifier" => configuredTableIdentifier,
            "name" => name,
            "roleArn" => roleArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_configured_table_association(
    configuredTableIdentifier,
    membershipIdentifier,
    name,
    roleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "POST",
        "/memberships/$(membershipIdentifier)/configuredTableAssociations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "configuredTableIdentifier" => configuredTableIdentifier,
                    "name" => name,
                    "roleArn" => roleArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_membership(collaboration_identifier, query_log_status)
    create_membership(collaboration_identifier, query_log_status, params::Dict{String,<:Any})

Creates a membership for a specific collaboration identifier and joins the collaboration.

# Arguments
- `collaboration_identifier`: The unique ID for the associated collaboration.
- `query_log_status`: An indicator as to whether query logging has been enabled or disabled
  for the membership.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"defaultResultConfiguration"`: The default protected query result configuration as
  specified by the member who can receive results.
- `"paymentConfiguration"`: The payment responsibilities accepted by the collaboration
  member. Not required if the collaboration member has the member ability to run queries.
  Required if the collaboration member doesn't have the member ability to run queries but is
  configured as a payer by the collaboration creator.
- `"tags"`: An optional label that you can assign to a resource when you create it. Each
  tag consists of a key and an optional value, both of which you define. When you use
  tagging, you can also use tag-based access control in IAM policies to control access to
  this resource.
"""
function create_membership(
    collaborationIdentifier,
    queryLogStatus;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "POST",
        "/memberships",
        Dict{String,Any}(
            "collaborationIdentifier" => collaborationIdentifier,
            "queryLogStatus" => queryLogStatus,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_membership(
    collaborationIdentifier,
    queryLogStatus,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "POST",
        "/memberships",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "collaborationIdentifier" => collaborationIdentifier,
                    "queryLogStatus" => queryLogStatus,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_privacy_budget_template(auto_refresh, membership_identifier, parameters, privacy_budget_type)
    create_privacy_budget_template(auto_refresh, membership_identifier, parameters, privacy_budget_type, params::Dict{String,<:Any})

Creates a privacy budget template for a specified membership. Each membership can have only
one privacy budget template, but it can be deleted and recreated. If you need to change the
privacy budget template for a membership, use the UpdatePrivacyBudgetTemplate operation.

# Arguments
- `auto_refresh`: How often the privacy budget refreshes.  If you plan to regularly bring
  new data into the collaboration, you can use CALENDAR_MONTH to automatically get a new
  privacy budget for the collaboration every calendar month. Choosing this option allows
  arbitrary amounts of information to be revealed about rows of the data when repeatedly
  queries across refreshes. Avoid choosing this if the same rows will be repeatedly queried
  between privacy budget refreshes.
- `membership_identifier`: A unique identifier for one of your memberships for a
  collaboration. The privacy budget template is created in the collaboration that this
  membership belongs to. Accepts a membership ID.
- `parameters`: Specifies your parameters for the privacy budget template.
- `privacy_budget_type`: Specifies the type of the privacy budget template.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tags"`: An optional label that you can assign to a resource when you create it. Each
  tag consists of a key and an optional value, both of which you define. When you use
  tagging, you can also use tag-based access control in IAM policies to control access to
  this resource.
"""
function create_privacy_budget_template(
    autoRefresh,
    membershipIdentifier,
    parameters,
    privacyBudgetType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "POST",
        "/memberships/$(membershipIdentifier)/privacybudgettemplates",
        Dict{String,Any}(
            "autoRefresh" => autoRefresh,
            "parameters" => parameters,
            "privacyBudgetType" => privacyBudgetType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_privacy_budget_template(
    autoRefresh,
    membershipIdentifier,
    parameters,
    privacyBudgetType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "POST",
        "/memberships/$(membershipIdentifier)/privacybudgettemplates",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "autoRefresh" => autoRefresh,
                    "parameters" => parameters,
                    "privacyBudgetType" => privacyBudgetType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_analysis_template(analysis_template_identifier, membership_identifier)
    delete_analysis_template(analysis_template_identifier, membership_identifier, params::Dict{String,<:Any})

Deletes an analysis template.

# Arguments
- `analysis_template_identifier`: The identifier for the analysis template resource.
- `membership_identifier`: The identifier for a membership resource.

"""
function delete_analysis_template(
    analysisTemplateIdentifier,
    membershipIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "DELETE",
        "/memberships/$(membershipIdentifier)/analysistemplates/$(analysisTemplateIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_analysis_template(
    analysisTemplateIdentifier,
    membershipIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "DELETE",
        "/memberships/$(membershipIdentifier)/analysistemplates/$(analysisTemplateIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_collaboration(collaboration_identifier)
    delete_collaboration(collaboration_identifier, params::Dict{String,<:Any})

Deletes a collaboration. It can only be called by the collaboration owner.

# Arguments
- `collaboration_identifier`: The identifier for the collaboration.

"""
function delete_collaboration(
    collaborationIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cleanrooms(
        "DELETE",
        "/collaborations/$(collaborationIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_collaboration(
    collaborationIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "DELETE",
        "/collaborations/$(collaborationIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_configured_audience_model_association(configured_audience_model_association_identifier, membership_identifier)
    delete_configured_audience_model_association(configured_audience_model_association_identifier, membership_identifier, params::Dict{String,<:Any})

Provides the information necessary to delete a configured audience model association.

# Arguments
- `configured_audience_model_association_identifier`: A unique identifier of the configured
  audience model association that you want to delete.
- `membership_identifier`: A unique identifier of the membership that contains the audience
  model association that you want to delete.

"""
function delete_configured_audience_model_association(
    configuredAudienceModelAssociationIdentifier,
    membershipIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "DELETE",
        "/memberships/$(membershipIdentifier)/configuredaudiencemodelassociations/$(configuredAudienceModelAssociationIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_configured_audience_model_association(
    configuredAudienceModelAssociationIdentifier,
    membershipIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "DELETE",
        "/memberships/$(membershipIdentifier)/configuredaudiencemodelassociations/$(configuredAudienceModelAssociationIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_configured_table(configured_table_identifier)
    delete_configured_table(configured_table_identifier, params::Dict{String,<:Any})

Deletes a configured table.

# Arguments
- `configured_table_identifier`: The unique ID for the configured table to delete.

"""
function delete_configured_table(
    configuredTableIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cleanrooms(
        "DELETE",
        "/configuredTables/$(configuredTableIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_configured_table(
    configuredTableIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "DELETE",
        "/configuredTables/$(configuredTableIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_configured_table_analysis_rule(analysis_rule_type, configured_table_identifier)
    delete_configured_table_analysis_rule(analysis_rule_type, configured_table_identifier, params::Dict{String,<:Any})

Deletes a configured table analysis rule.

# Arguments
- `analysis_rule_type`: The analysis rule type to be deleted. Configured table analysis
  rules are uniquely identified by their configured table identifier and analysis rule type.
- `configured_table_identifier`: The unique identifier for the configured table that the
  analysis rule applies to. Currently accepts the configured table ID.

"""
function delete_configured_table_analysis_rule(
    analysisRuleType,
    configuredTableIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "DELETE",
        "/configuredTables/$(configuredTableIdentifier)/analysisRule/$(analysisRuleType)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_configured_table_analysis_rule(
    analysisRuleType,
    configuredTableIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "DELETE",
        "/configuredTables/$(configuredTableIdentifier)/analysisRule/$(analysisRuleType)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_configured_table_association(configured_table_association_identifier, membership_identifier)
    delete_configured_table_association(configured_table_association_identifier, membership_identifier, params::Dict{String,<:Any})

Deletes a configured table association.

# Arguments
- `configured_table_association_identifier`: The unique ID for the configured table
  association to be deleted. Currently accepts the configured table ID.
- `membership_identifier`: A unique identifier for the membership that the configured table
  association belongs to. Currently accepts the membership ID.

"""
function delete_configured_table_association(
    configuredTableAssociationIdentifier,
    membershipIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "DELETE",
        "/memberships/$(membershipIdentifier)/configuredTableAssociations/$(configuredTableAssociationIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_configured_table_association(
    configuredTableAssociationIdentifier,
    membershipIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "DELETE",
        "/memberships/$(membershipIdentifier)/configuredTableAssociations/$(configuredTableAssociationIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_member(account_id, collaboration_identifier)
    delete_member(account_id, collaboration_identifier, params::Dict{String,<:Any})

Removes the specified member from a collaboration. The removed member is placed in the
Removed status and can't interact with the collaboration. The removed member's data is
inaccessible to active members of the collaboration.

# Arguments
- `account_id`: The account ID of the member to remove.
- `collaboration_identifier`: The unique identifier for the associated collaboration.

"""
function delete_member(
    accountId, collaborationIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cleanrooms(
        "DELETE",
        "/collaborations/$(collaborationIdentifier)/member/$(accountId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_member(
    accountId,
    collaborationIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "DELETE",
        "/collaborations/$(collaborationIdentifier)/member/$(accountId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_membership(membership_identifier)
    delete_membership(membership_identifier, params::Dict{String,<:Any})

Deletes a specified membership. All resources under a membership must be deleted.

# Arguments
- `membership_identifier`: The identifier for a membership resource.

"""
function delete_membership(
    membershipIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cleanrooms(
        "DELETE",
        "/memberships/$(membershipIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_membership(
    membershipIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "DELETE",
        "/memberships/$(membershipIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_privacy_budget_template(membership_identifier, privacy_budget_template_identifier)
    delete_privacy_budget_template(membership_identifier, privacy_budget_template_identifier, params::Dict{String,<:Any})

Deletes a privacy budget template for a specified membership.

# Arguments
- `membership_identifier`: A unique identifier for one of your memberships for a
  collaboration. The privacy budget template is deleted from the collaboration that this
  membership belongs to. Accepts a membership ID.
- `privacy_budget_template_identifier`: A unique identifier for your privacy budget
  template.

"""
function delete_privacy_budget_template(
    membershipIdentifier,
    privacyBudgetTemplateIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "DELETE",
        "/memberships/$(membershipIdentifier)/privacybudgettemplates/$(privacyBudgetTemplateIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_privacy_budget_template(
    membershipIdentifier,
    privacyBudgetTemplateIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "DELETE",
        "/memberships/$(membershipIdentifier)/privacybudgettemplates/$(privacyBudgetTemplateIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_analysis_template(analysis_template_identifier, membership_identifier)
    get_analysis_template(analysis_template_identifier, membership_identifier, params::Dict{String,<:Any})

Retrieves an analysis template.

# Arguments
- `analysis_template_identifier`: The identifier for the analysis template resource.
- `membership_identifier`: The identifier for a membership resource.

"""
function get_analysis_template(
    analysisTemplateIdentifier,
    membershipIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "GET",
        "/memberships/$(membershipIdentifier)/analysistemplates/$(analysisTemplateIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_analysis_template(
    analysisTemplateIdentifier,
    membershipIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "GET",
        "/memberships/$(membershipIdentifier)/analysistemplates/$(analysisTemplateIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_collaboration(collaboration_identifier)
    get_collaboration(collaboration_identifier, params::Dict{String,<:Any})

Returns metadata about a collaboration.

# Arguments
- `collaboration_identifier`: The identifier for the collaboration.

"""
function get_collaboration(
    collaborationIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cleanrooms(
        "GET",
        "/collaborations/$(collaborationIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_collaboration(
    collaborationIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "GET",
        "/collaborations/$(collaborationIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_collaboration_analysis_template(analysis_template_arn, collaboration_identifier)
    get_collaboration_analysis_template(analysis_template_arn, collaboration_identifier, params::Dict{String,<:Any})

Retrieves an analysis template within a collaboration.

# Arguments
- `analysis_template_arn`: The Amazon Resource Name (ARN) associated with the analysis
  template within a collaboration.
- `collaboration_identifier`: A unique identifier for the collaboration that the analysis
  templates belong to. Currently accepts collaboration ID.

"""
function get_collaboration_analysis_template(
    analysisTemplateArn,
    collaborationIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "GET",
        "/collaborations/$(collaborationIdentifier)/analysistemplates/$(analysisTemplateArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_collaboration_analysis_template(
    analysisTemplateArn,
    collaborationIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "GET",
        "/collaborations/$(collaborationIdentifier)/analysistemplates/$(analysisTemplateArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_collaboration_configured_audience_model_association(collaboration_identifier, configured_audience_model_association_identifier)
    get_collaboration_configured_audience_model_association(collaboration_identifier, configured_audience_model_association_identifier, params::Dict{String,<:Any})

Retrieves a configured audience model association within a collaboration.

# Arguments
- `collaboration_identifier`: A unique identifier for the collaboration that the configured
  audience model association belongs to. Accepts a collaboration ID.
- `configured_audience_model_association_identifier`: A unique identifier for the
  configured audience model association that you want to retrieve.

"""
function get_collaboration_configured_audience_model_association(
    collaborationIdentifier,
    configuredAudienceModelAssociationIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "GET",
        "/collaborations/$(collaborationIdentifier)/configuredaudiencemodelassociations/$(configuredAudienceModelAssociationIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_collaboration_configured_audience_model_association(
    collaborationIdentifier,
    configuredAudienceModelAssociationIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "GET",
        "/collaborations/$(collaborationIdentifier)/configuredaudiencemodelassociations/$(configuredAudienceModelAssociationIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_collaboration_privacy_budget_template(collaboration_identifier, privacy_budget_template_identifier)
    get_collaboration_privacy_budget_template(collaboration_identifier, privacy_budget_template_identifier, params::Dict{String,<:Any})

Returns details about a specified privacy budget template.

# Arguments
- `collaboration_identifier`: A unique identifier for one of your collaborations.
- `privacy_budget_template_identifier`: A unique identifier for one of your privacy budget
  templates.

"""
function get_collaboration_privacy_budget_template(
    collaborationIdentifier,
    privacyBudgetTemplateIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "GET",
        "/collaborations/$(collaborationIdentifier)/privacybudgettemplates/$(privacyBudgetTemplateIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_collaboration_privacy_budget_template(
    collaborationIdentifier,
    privacyBudgetTemplateIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "GET",
        "/collaborations/$(collaborationIdentifier)/privacybudgettemplates/$(privacyBudgetTemplateIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_configured_audience_model_association(configured_audience_model_association_identifier, membership_identifier)
    get_configured_audience_model_association(configured_audience_model_association_identifier, membership_identifier, params::Dict{String,<:Any})

Returns information about a configured audience model association.

# Arguments
- `configured_audience_model_association_identifier`: A unique identifier for the
  configured audience model association that you want to retrieve.
- `membership_identifier`: A unique identifier for the membership that contains the
  configured audience model association that you want to retrieve.

"""
function get_configured_audience_model_association(
    configuredAudienceModelAssociationIdentifier,
    membershipIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "GET",
        "/memberships/$(membershipIdentifier)/configuredaudiencemodelassociations/$(configuredAudienceModelAssociationIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_configured_audience_model_association(
    configuredAudienceModelAssociationIdentifier,
    membershipIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "GET",
        "/memberships/$(membershipIdentifier)/configuredaudiencemodelassociations/$(configuredAudienceModelAssociationIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_configured_table(configured_table_identifier)
    get_configured_table(configured_table_identifier, params::Dict{String,<:Any})

Retrieves a configured table.

# Arguments
- `configured_table_identifier`: The unique ID for the configured table to retrieve.

"""
function get_configured_table(
    configuredTableIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cleanrooms(
        "GET",
        "/configuredTables/$(configuredTableIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_configured_table(
    configuredTableIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "GET",
        "/configuredTables/$(configuredTableIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_configured_table_analysis_rule(analysis_rule_type, configured_table_identifier)
    get_configured_table_analysis_rule(analysis_rule_type, configured_table_identifier, params::Dict{String,<:Any})

Retrieves a configured table analysis rule.

# Arguments
- `analysis_rule_type`: The analysis rule to be retrieved. Configured table analysis rules
  are uniquely identified by their configured table identifier and analysis rule type.
- `configured_table_identifier`: The unique identifier for the configured table to
  retrieve. Currently accepts the configured table ID.

"""
function get_configured_table_analysis_rule(
    analysisRuleType,
    configuredTableIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "GET",
        "/configuredTables/$(configuredTableIdentifier)/analysisRule/$(analysisRuleType)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_configured_table_analysis_rule(
    analysisRuleType,
    configuredTableIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "GET",
        "/configuredTables/$(configuredTableIdentifier)/analysisRule/$(analysisRuleType)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_configured_table_association(configured_table_association_identifier, membership_identifier)
    get_configured_table_association(configured_table_association_identifier, membership_identifier, params::Dict{String,<:Any})

Retrieves a configured table association.

# Arguments
- `configured_table_association_identifier`: The unique ID for the configured table
  association to retrieve. Currently accepts the configured table ID.
- `membership_identifier`: A unique identifier for the membership that the configured table
  association belongs to. Currently accepts the membership ID.

"""
function get_configured_table_association(
    configuredTableAssociationIdentifier,
    membershipIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "GET",
        "/memberships/$(membershipIdentifier)/configuredTableAssociations/$(configuredTableAssociationIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_configured_table_association(
    configuredTableAssociationIdentifier,
    membershipIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "GET",
        "/memberships/$(membershipIdentifier)/configuredTableAssociations/$(configuredTableAssociationIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_membership(membership_identifier)
    get_membership(membership_identifier, params::Dict{String,<:Any})

Retrieves a specified membership for an identifier.

# Arguments
- `membership_identifier`: The identifier for a membership resource.

"""
function get_membership(
    membershipIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cleanrooms(
        "GET",
        "/memberships/$(membershipIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_membership(
    membershipIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "GET",
        "/memberships/$(membershipIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_privacy_budget_template(membership_identifier, privacy_budget_template_identifier)
    get_privacy_budget_template(membership_identifier, privacy_budget_template_identifier, params::Dict{String,<:Any})

Returns details for a specified privacy budget template.

# Arguments
- `membership_identifier`: A unique identifier for one of your memberships for a
  collaboration. The privacy budget template is retrieved from the collaboration that this
  membership belongs to. Accepts a membership ID.
- `privacy_budget_template_identifier`: A unique identifier for your privacy budget
  template.

"""
function get_privacy_budget_template(
    membershipIdentifier,
    privacyBudgetTemplateIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "GET",
        "/memberships/$(membershipIdentifier)/privacybudgettemplates/$(privacyBudgetTemplateIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_privacy_budget_template(
    membershipIdentifier,
    privacyBudgetTemplateIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "GET",
        "/memberships/$(membershipIdentifier)/privacybudgettemplates/$(privacyBudgetTemplateIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_protected_query(membership_identifier, protected_query_identifier)
    get_protected_query(membership_identifier, protected_query_identifier, params::Dict{String,<:Any})

Returns query processing metadata.

# Arguments
- `membership_identifier`: The identifier for a membership in a protected query instance.
- `protected_query_identifier`: The identifier for a protected query instance.

"""
function get_protected_query(
    membershipIdentifier,
    protectedQueryIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "GET",
        "/memberships/$(membershipIdentifier)/protectedQueries/$(protectedQueryIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_protected_query(
    membershipIdentifier,
    protectedQueryIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "GET",
        "/memberships/$(membershipIdentifier)/protectedQueries/$(protectedQueryIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_schema(collaboration_identifier, name)
    get_schema(collaboration_identifier, name, params::Dict{String,<:Any})

Retrieves the schema for a relation within a collaboration.

# Arguments
- `collaboration_identifier`: A unique identifier for the collaboration that the schema
  belongs to. Currently accepts a collaboration ID.
- `name`: The name of the relation to retrieve the schema for.

"""
function get_schema(
    collaborationIdentifier, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cleanrooms(
        "GET",
        "/collaborations/$(collaborationIdentifier)/schemas/$(name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_schema(
    collaborationIdentifier,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "GET",
        "/collaborations/$(collaborationIdentifier)/schemas/$(name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_schema_analysis_rule(collaboration_identifier, name, type)
    get_schema_analysis_rule(collaboration_identifier, name, type, params::Dict{String,<:Any})

Retrieves a schema analysis rule.

# Arguments
- `collaboration_identifier`: A unique identifier for the collaboration that the schema
  belongs to. Currently accepts a collaboration ID.
- `name`: The name of the schema to retrieve the analysis rule for.
- `type`: The type of the schema analysis rule to retrieve. Schema analysis rules are
  uniquely identified by a combination of the collaboration, the schema name, and their type.

"""
function get_schema_analysis_rule(
    collaborationIdentifier, name, type; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cleanrooms(
        "GET",
        "/collaborations/$(collaborationIdentifier)/schemas/$(name)/analysisRule/$(type)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_schema_analysis_rule(
    collaborationIdentifier,
    name,
    type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "GET",
        "/collaborations/$(collaborationIdentifier)/schemas/$(name)/analysisRule/$(type)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_analysis_templates(membership_identifier)
    list_analysis_templates(membership_identifier, params::Dict{String,<:Any})

Lists analysis templates that the caller owns.

# Arguments
- `membership_identifier`: The identifier for a membership resource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum size of the results that is returned per call.
- `"nextToken"`: The token value retrieved from a previous call to access the next page of
  results.
"""
function list_analysis_templates(
    membershipIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cleanrooms(
        "GET",
        "/memberships/$(membershipIdentifier)/analysistemplates";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_analysis_templates(
    membershipIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "GET",
        "/memberships/$(membershipIdentifier)/analysistemplates",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_collaboration_analysis_templates(collaboration_identifier)
    list_collaboration_analysis_templates(collaboration_identifier, params::Dict{String,<:Any})

Lists analysis templates within a collaboration.

# Arguments
- `collaboration_identifier`: A unique identifier for the collaboration that the analysis
  templates belong to. Currently accepts collaboration ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum size of the results that is returned per call.
- `"nextToken"`: The token value retrieved from a previous call to access the next page of
  results.
"""
function list_collaboration_analysis_templates(
    collaborationIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cleanrooms(
        "GET",
        "/collaborations/$(collaborationIdentifier)/analysistemplates";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_collaboration_analysis_templates(
    collaborationIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "GET",
        "/collaborations/$(collaborationIdentifier)/analysistemplates",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_collaboration_configured_audience_model_associations(collaboration_identifier)
    list_collaboration_configured_audience_model_associations(collaboration_identifier, params::Dict{String,<:Any})

Lists configured audience model associations within a collaboration.

# Arguments
- `collaboration_identifier`: A unique identifier for the collaboration that the configured
  audience model association belongs to. Accepts a collaboration ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum size of the results that is returned per call.
- `"nextToken"`: The token value retrieved from a previous call to access the next page of
  results.
"""
function list_collaboration_configured_audience_model_associations(
    collaborationIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cleanrooms(
        "GET",
        "/collaborations/$(collaborationIdentifier)/configuredaudiencemodelassociations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_collaboration_configured_audience_model_associations(
    collaborationIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "GET",
        "/collaborations/$(collaborationIdentifier)/configuredaudiencemodelassociations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_collaboration_privacy_budget_templates(collaboration_identifier)
    list_collaboration_privacy_budget_templates(collaboration_identifier, params::Dict{String,<:Any})

Returns an array that summarizes each privacy budget template in a specified collaboration.

# Arguments
- `collaboration_identifier`: A unique identifier for one of your collaborations.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum size of the results that is returned per call. Service
  chooses a default if it has not been set. Service may return a nextToken even if the
  maximum results has not been met.
- `"nextToken"`: The token value retrieved from a previous call to access the next page of
  results.
"""
function list_collaboration_privacy_budget_templates(
    collaborationIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cleanrooms(
        "GET",
        "/collaborations/$(collaborationIdentifier)/privacybudgettemplates";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_collaboration_privacy_budget_templates(
    collaborationIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "GET",
        "/collaborations/$(collaborationIdentifier)/privacybudgettemplates",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_collaboration_privacy_budgets(collaboration_identifier, privacy_budget_type)
    list_collaboration_privacy_budgets(collaboration_identifier, privacy_budget_type, params::Dict{String,<:Any})

Returns an array that summarizes each privacy budget in a specified collaboration. The
summary includes the collaboration ARN, creation time, creating account, and privacy budget
details.

# Arguments
- `collaboration_identifier`: A unique identifier for one of your collaborations.
- `privacy_budget_type`: Specifies the type of the privacy budget.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum size of the results that is returned per call. Service
  chooses a default if it has not been set. Service may return a nextToken even if the
  maximum results has not been met.
- `"nextToken"`: The token value retrieved from a previous call to access the next page of
  results.
"""
function list_collaboration_privacy_budgets(
    collaborationIdentifier,
    privacyBudgetType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "GET",
        "/collaborations/$(collaborationIdentifier)/privacybudgets",
        Dict{String,Any}("privacyBudgetType" => privacyBudgetType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_collaboration_privacy_budgets(
    collaborationIdentifier,
    privacyBudgetType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "GET",
        "/collaborations/$(collaborationIdentifier)/privacybudgets",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("privacyBudgetType" => privacyBudgetType), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_collaborations()
    list_collaborations(params::Dict{String,<:Any})

Lists collaborations the caller owns, is active in, or has been invited to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum size of the results that is returned per call. Service
  chooses a default if it has not been set. Service may return a nextToken even if the
  maximum results has not been met.
- `"memberStatus"`: The caller's status in a collaboration.
- `"nextToken"`: The token value retrieved from a previous call to access the next page of
  results.
"""
function list_collaborations(; aws_config::AbstractAWSConfig=current_aws_config())
    return cleanrooms(
        "GET", "/collaborations"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_collaborations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cleanrooms(
        "GET",
        "/collaborations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_configured_audience_model_associations(membership_identifier)
    list_configured_audience_model_associations(membership_identifier, params::Dict{String,<:Any})

Lists information about requested configured audience model associations.

# Arguments
- `membership_identifier`: A unique identifier for a membership that contains the
  configured audience model associations that you want to retrieve.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum size of the results that is returned per call. Service
  chooses a default if it has not been set. Service may return a nextToken even if the
  maximum results has not been met.
- `"nextToken"`: The token value retrieved from a previous call to access the next page of
  results.
"""
function list_configured_audience_model_associations(
    membershipIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cleanrooms(
        "GET",
        "/memberships/$(membershipIdentifier)/configuredaudiencemodelassociations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_configured_audience_model_associations(
    membershipIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "GET",
        "/memberships/$(membershipIdentifier)/configuredaudiencemodelassociations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_configured_table_associations(membership_identifier)
    list_configured_table_associations(membership_identifier, params::Dict{String,<:Any})

Lists configured table associations for a membership.

# Arguments
- `membership_identifier`: A unique identifier for the membership to list configured table
  associations for. Currently accepts the membership ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum size of the results that is returned per call.
- `"nextToken"`: The token value retrieved from a previous call to access the next page of
  results.
"""
function list_configured_table_associations(
    membershipIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cleanrooms(
        "GET",
        "/memberships/$(membershipIdentifier)/configuredTableAssociations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_configured_table_associations(
    membershipIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "GET",
        "/memberships/$(membershipIdentifier)/configuredTableAssociations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_configured_tables()
    list_configured_tables(params::Dict{String,<:Any})

Lists configured tables.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum size of the results that is returned per call.
- `"nextToken"`: The token value retrieved from a previous call to access the next page of
  results.
"""
function list_configured_tables(; aws_config::AbstractAWSConfig=current_aws_config())
    return cleanrooms(
        "GET", "/configuredTables"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_configured_tables(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cleanrooms(
        "GET",
        "/configuredTables",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_members(collaboration_identifier)
    list_members(collaboration_identifier, params::Dict{String,<:Any})

Lists all members within a collaboration.

# Arguments
- `collaboration_identifier`: The identifier of the collaboration in which the members are
  listed.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum size of the results that is returned per call.
- `"nextToken"`: The token value retrieved from a previous call to access the next page of
  results.
"""
function list_members(
    collaborationIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cleanrooms(
        "GET",
        "/collaborations/$(collaborationIdentifier)/members";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_members(
    collaborationIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "GET",
        "/collaborations/$(collaborationIdentifier)/members",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_memberships()
    list_memberships(params::Dict{String,<:Any})

Lists all memberships resources within the caller's account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum size of the results that is returned per call.
- `"nextToken"`: The token value retrieved from a previous call to access the next page of
  results.
- `"status"`: A filter which will return only memberships in the specified status.
"""
function list_memberships(; aws_config::AbstractAWSConfig=current_aws_config())
    return cleanrooms(
        "GET", "/memberships"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_memberships(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cleanrooms(
        "GET",
        "/memberships",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_privacy_budget_templates(membership_identifier)
    list_privacy_budget_templates(membership_identifier, params::Dict{String,<:Any})

Returns detailed information about the privacy budget templates in a specified membership.

# Arguments
- `membership_identifier`: A unique identifier for one of your memberships for a
  collaboration. The privacy budget templates are retrieved from the collaboration that this
  membership belongs to. Accepts a membership ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum size of the results that is returned per call. Service
  chooses a default if it has not been set. Service may return a nextToken even if the
  maximum results has not been met.
- `"nextToken"`: The token value retrieved from a previous call to access the next page of
  results.
"""
function list_privacy_budget_templates(
    membershipIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cleanrooms(
        "GET",
        "/memberships/$(membershipIdentifier)/privacybudgettemplates";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_privacy_budget_templates(
    membershipIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "GET",
        "/memberships/$(membershipIdentifier)/privacybudgettemplates",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_privacy_budgets(membership_identifier, privacy_budget_type)
    list_privacy_budgets(membership_identifier, privacy_budget_type, params::Dict{String,<:Any})

Returns detailed information about the privacy budgets in a specified membership.

# Arguments
- `membership_identifier`: A unique identifier for one of your memberships for a
  collaboration. The privacy budget is retrieved from the collaboration that this membership
  belongs to. Accepts a membership ID.
- `privacy_budget_type`: The privacy budget type.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum size of the results that is returned per call. Service
  chooses a default if it has not been set. Service may return a nextToken even if the
  maximum results has not been met.
- `"nextToken"`: The token value retrieved from a previous call to access the next page of
  results.
"""
function list_privacy_budgets(
    membershipIdentifier,
    privacyBudgetType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "GET",
        "/memberships/$(membershipIdentifier)/privacybudgets",
        Dict{String,Any}("privacyBudgetType" => privacyBudgetType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_privacy_budgets(
    membershipIdentifier,
    privacyBudgetType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "GET",
        "/memberships/$(membershipIdentifier)/privacybudgets",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("privacyBudgetType" => privacyBudgetType), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_protected_queries(membership_identifier)
    list_protected_queries(membership_identifier, params::Dict{String,<:Any})

Lists protected queries, sorted by the most recent query.

# Arguments
- `membership_identifier`: The identifier for the membership in the collaboration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum size of the results that is returned per call. Service
  chooses a default if it has not been set. Service can return a nextToken even if the
  maximum results has not been met.
- `"nextToken"`: The token value retrieved from a previous call to access the next page of
  results.
- `"status"`: A filter on the status of the protected query.
"""
function list_protected_queries(
    membershipIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cleanrooms(
        "GET",
        "/memberships/$(membershipIdentifier)/protectedQueries";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_protected_queries(
    membershipIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "GET",
        "/memberships/$(membershipIdentifier)/protectedQueries",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_schemas(collaboration_identifier)
    list_schemas(collaboration_identifier, params::Dict{String,<:Any})

Lists the schemas for relations within a collaboration.

# Arguments
- `collaboration_identifier`: A unique identifier for the collaboration that the schema
  belongs to. Currently accepts a collaboration ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum size of the results that is returned per call.
- `"nextToken"`: The token value retrieved from a previous call to access the next page of
  results.
- `"schemaType"`: If present, filter schemas by schema type. The only valid schema type is
  currently `TABLE`.
"""
function list_schemas(
    collaborationIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cleanrooms(
        "GET",
        "/collaborations/$(collaborationIdentifier)/schemas";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_schemas(
    collaborationIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "GET",
        "/collaborations/$(collaborationIdentifier)/schemas",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists all of the tags that have been added to a resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) associated with the resource you want to
  list tags on.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cleanrooms(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    preview_privacy_impact(membership_identifier, parameters)
    preview_privacy_impact(membership_identifier, parameters, params::Dict{String,<:Any})

An estimate of the number of aggregation functions that the member who can query can run
given epsilon and noise parameters.

# Arguments
- `membership_identifier`: A unique identifier for one of your memberships for a
  collaboration. Accepts a membership ID.
- `parameters`: Specifies the desired epsilon and noise parameters to preview.

"""
function preview_privacy_impact(
    membershipIdentifier, parameters; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cleanrooms(
        "POST",
        "/memberships/$(membershipIdentifier)/previewprivacyimpact",
        Dict{String,Any}("parameters" => parameters);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function preview_privacy_impact(
    membershipIdentifier,
    parameters,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "POST",
        "/memberships/$(membershipIdentifier)/previewprivacyimpact",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("parameters" => parameters), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_protected_query(membership_identifier, sql_parameters, type)
    start_protected_query(membership_identifier, sql_parameters, type, params::Dict{String,<:Any})

Creates a protected query that is started by Clean Rooms.

# Arguments
- `membership_identifier`: A unique identifier for the membership to run this query
  against. Currently accepts a membership ID.
- `sql_parameters`: The protected SQL query parameters.
- `type`: The type of the protected query to be started.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"resultConfiguration"`: The details needed to write the query results.
"""
function start_protected_query(
    membershipIdentifier,
    sqlParameters,
    type;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "POST",
        "/memberships/$(membershipIdentifier)/protectedQueries",
        Dict{String,Any}("sqlParameters" => sqlParameters, "type" => type);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_protected_query(
    membershipIdentifier,
    sqlParameters,
    type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "POST",
        "/memberships/$(membershipIdentifier)/protectedQueries",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("sqlParameters" => sqlParameters, "type" => type),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Tags a resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) associated with the resource you want to
  tag.
- `tags`: A map of objects specifying each key name and value.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return cleanrooms(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes a tag or list of tags from a resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) associated with the resource you want to
  remove the tag from.
- `tag_keys`: A list of key names of tags to be removed.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cleanrooms(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_analysis_template(analysis_template_identifier, membership_identifier)
    update_analysis_template(analysis_template_identifier, membership_identifier, params::Dict{String,<:Any})

Updates the analysis template metadata.

# Arguments
- `analysis_template_identifier`: The identifier for the analysis template resource.
- `membership_identifier`: The identifier for a membership resource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A new description for the analysis template.
"""
function update_analysis_template(
    analysisTemplateIdentifier,
    membershipIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "PATCH",
        "/memberships/$(membershipIdentifier)/analysistemplates/$(analysisTemplateIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_analysis_template(
    analysisTemplateIdentifier,
    membershipIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "PATCH",
        "/memberships/$(membershipIdentifier)/analysistemplates/$(analysisTemplateIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_collaboration(collaboration_identifier)
    update_collaboration(collaboration_identifier, params::Dict{String,<:Any})

Updates collaboration metadata and can only be called by the collaboration owner.

# Arguments
- `collaboration_identifier`: The identifier for the collaboration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A description of the collaboration.
- `"name"`: A human-readable identifier provided by the collaboration owner. Display names
  are not unique.
"""
function update_collaboration(
    collaborationIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cleanrooms(
        "PATCH",
        "/collaborations/$(collaborationIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_collaboration(
    collaborationIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "PATCH",
        "/collaborations/$(collaborationIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_configured_audience_model_association(configured_audience_model_association_identifier, membership_identifier)
    update_configured_audience_model_association(configured_audience_model_association_identifier, membership_identifier, params::Dict{String,<:Any})

Provides the details necessary to update a configured audience model association.

# Arguments
- `configured_audience_model_association_identifier`: A unique identifier for the
  configured audience model association that you want to update.
- `membership_identifier`: A unique identifier of the membership that contains the
  configured audience model association that you want to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A new description for the configured audience model association.
- `"name"`: A new name for the configured audience model association.
"""
function update_configured_audience_model_association(
    configuredAudienceModelAssociationIdentifier,
    membershipIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "PATCH",
        "/memberships/$(membershipIdentifier)/configuredaudiencemodelassociations/$(configuredAudienceModelAssociationIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_configured_audience_model_association(
    configuredAudienceModelAssociationIdentifier,
    membershipIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "PATCH",
        "/memberships/$(membershipIdentifier)/configuredaudiencemodelassociations/$(configuredAudienceModelAssociationIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_configured_table(configured_table_identifier)
    update_configured_table(configured_table_identifier, params::Dict{String,<:Any})

Updates a configured table.

# Arguments
- `configured_table_identifier`: The identifier for the configured table to update.
  Currently accepts the configured table ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A new description for the configured table.
- `"name"`: A new name for the configured table.
"""
function update_configured_table(
    configuredTableIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cleanrooms(
        "PATCH",
        "/configuredTables/$(configuredTableIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_configured_table(
    configuredTableIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "PATCH",
        "/configuredTables/$(configuredTableIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_configured_table_analysis_rule(analysis_rule_policy, analysis_rule_type, configured_table_identifier)
    update_configured_table_analysis_rule(analysis_rule_policy, analysis_rule_type, configured_table_identifier, params::Dict{String,<:Any})

Updates a configured table analysis rule.

# Arguments
- `analysis_rule_policy`: The new analysis rule policy for the configured table analysis
  rule.
- `analysis_rule_type`: The analysis rule type to be updated. Configured table analysis
  rules are uniquely identified by their configured table identifier and analysis rule type.
- `configured_table_identifier`: The unique identifier for the configured table that the
  analysis rule applies to. Currently accepts the configured table ID.

"""
function update_configured_table_analysis_rule(
    analysisRulePolicy,
    analysisRuleType,
    configuredTableIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "PATCH",
        "/configuredTables/$(configuredTableIdentifier)/analysisRule/$(analysisRuleType)",
        Dict{String,Any}("analysisRulePolicy" => analysisRulePolicy);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_configured_table_analysis_rule(
    analysisRulePolicy,
    analysisRuleType,
    configuredTableIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "PATCH",
        "/configuredTables/$(configuredTableIdentifier)/analysisRule/$(analysisRuleType)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("analysisRulePolicy" => analysisRulePolicy), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_configured_table_association(configured_table_association_identifier, membership_identifier)
    update_configured_table_association(configured_table_association_identifier, membership_identifier, params::Dict{String,<:Any})

Updates a configured table association.

# Arguments
- `configured_table_association_identifier`: The unique identifier for the configured table
  association to update. Currently accepts the configured table association ID.
- `membership_identifier`: The unique ID for the membership that the configured table
  association belongs to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A new description for the configured table association.
- `"roleArn"`: The service will assume this role to access catalog metadata and query the
  table.
"""
function update_configured_table_association(
    configuredTableAssociationIdentifier,
    membershipIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "PATCH",
        "/memberships/$(membershipIdentifier)/configuredTableAssociations/$(configuredTableAssociationIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_configured_table_association(
    configuredTableAssociationIdentifier,
    membershipIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "PATCH",
        "/memberships/$(membershipIdentifier)/configuredTableAssociations/$(configuredTableAssociationIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_membership(membership_identifier)
    update_membership(membership_identifier, params::Dict{String,<:Any})

Updates a membership.

# Arguments
- `membership_identifier`: The unique identifier of the membership.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"defaultResultConfiguration"`: The default protected query result configuration as
  specified by the member who can receive results.
- `"queryLogStatus"`: An indicator as to whether query logging has been enabled or disabled
  for the membership.
"""
function update_membership(
    membershipIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cleanrooms(
        "PATCH",
        "/memberships/$(membershipIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_membership(
    membershipIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "PATCH",
        "/memberships/$(membershipIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_privacy_budget_template(membership_identifier, privacy_budget_template_identifier, privacy_budget_type)
    update_privacy_budget_template(membership_identifier, privacy_budget_template_identifier, privacy_budget_type, params::Dict{String,<:Any})

Updates the privacy budget template for the specified membership.

# Arguments
- `membership_identifier`: A unique identifier for one of your memberships for a
  collaboration. The privacy budget template is updated in the collaboration that this
  membership belongs to. Accepts a membership ID.
- `privacy_budget_template_identifier`: A unique identifier for your privacy budget
  template that you want to update.
- `privacy_budget_type`: Specifies the type of the privacy budget template.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"parameters"`: Specifies the epsilon and noise parameters for the privacy budget
  template.
"""
function update_privacy_budget_template(
    membershipIdentifier,
    privacyBudgetTemplateIdentifier,
    privacyBudgetType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "PATCH",
        "/memberships/$(membershipIdentifier)/privacybudgettemplates/$(privacyBudgetTemplateIdentifier)",
        Dict{String,Any}("privacyBudgetType" => privacyBudgetType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_privacy_budget_template(
    membershipIdentifier,
    privacyBudgetTemplateIdentifier,
    privacyBudgetType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "PATCH",
        "/memberships/$(membershipIdentifier)/privacybudgettemplates/$(privacyBudgetTemplateIdentifier)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("privacyBudgetType" => privacyBudgetType), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_protected_query(membership_identifier, protected_query_identifier, target_status)
    update_protected_query(membership_identifier, protected_query_identifier, target_status, params::Dict{String,<:Any})

Updates the processing of a currently running query.

# Arguments
- `membership_identifier`: The identifier for a member of a protected query instance.
- `protected_query_identifier`: The identifier for a protected query instance.
- `target_status`: The target status of a query. Used to update the execution status of a
  currently running query.

"""
function update_protected_query(
    membershipIdentifier,
    protectedQueryIdentifier,
    targetStatus;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "PATCH",
        "/memberships/$(membershipIdentifier)/protectedQueries/$(protectedQueryIdentifier)",
        Dict{String,Any}("targetStatus" => targetStatus);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_protected_query(
    membershipIdentifier,
    protectedQueryIdentifier,
    targetStatus,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cleanrooms(
        "PATCH",
        "/memberships/$(membershipIdentifier)/protectedQueries/$(protectedQueryIdentifier)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("targetStatus" => targetStatus), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: mediapackage
using AWS.Compat
using AWS.UUIDs

"""
    configure_logs(id)
    configure_logs(id, params::Dict{String,<:Any})

Changes the Channel's properities to configure log subscription

# Arguments
- `id`: The ID of the channel to log subscription.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"egressAccessLogs"`:
- `"ingressAccessLogs"`:
"""
function configure_logs(id; aws_config::AbstractAWSConfig=current_aws_config())
    return mediapackage(
        "PUT",
        "/channels/$(id)/configure_logs";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function configure_logs(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediapackage(
        "PUT",
        "/channels/$(id)/configure_logs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_channel(id)
    create_channel(id, params::Dict{String,<:Any})

Creates a new Channel.

# Arguments
- `id`: The ID of the Channel. The ID must be unique within the region and it
cannot be
  changed after a Channel is created.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A short text description of the Channel.
- `"tags"`:
"""
function create_channel(id; aws_config::AbstractAWSConfig=current_aws_config())
    return mediapackage(
        "POST",
        "/channels",
        Dict{String,Any}("id" => id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_channel(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediapackage(
        "POST",
        "/channels",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("id" => id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_harvest_job(end_time, id, origin_endpoint_id, s3_destination, start_time)
    create_harvest_job(end_time, id, origin_endpoint_id, s3_destination, start_time, params::Dict{String,<:Any})

Creates a new HarvestJob record.

# Arguments
- `end_time`: The end of the time-window which will be harvested
- `id`: The ID of the HarvestJob. The ID must be unique within the region
and it cannot be
  changed after the HarvestJob is submitted
- `origin_endpoint_id`: The ID of the OriginEndpoint that the HarvestJob will harvest
  from.
This cannot be changed after the HarvestJob is submitted.
- `s3_destination`:
- `start_time`: The start of the time-window which will be harvested

"""
function create_harvest_job(
    endTime,
    id,
    originEndpointId,
    s3Destination,
    startTime;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediapackage(
        "POST",
        "/harvest_jobs",
        Dict{String,Any}(
            "endTime" => endTime,
            "id" => id,
            "originEndpointId" => originEndpointId,
            "s3Destination" => s3Destination,
            "startTime" => startTime,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_harvest_job(
    endTime,
    id,
    originEndpointId,
    s3Destination,
    startTime,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediapackage(
        "POST",
        "/harvest_jobs",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "endTime" => endTime,
                    "id" => id,
                    "originEndpointId" => originEndpointId,
                    "s3Destination" => s3Destination,
                    "startTime" => startTime,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_origin_endpoint(channel_id, id)
    create_origin_endpoint(channel_id, id, params::Dict{String,<:Any})

Creates a new OriginEndpoint record.

# Arguments
- `channel_id`: The ID of the Channel that the OriginEndpoint will be associated with.
This
  cannot be changed after the OriginEndpoint is created.
- `id`: The ID of the OriginEndpoint.  The ID must be unique within the region
and it
  cannot be changed after the OriginEndpoint is created.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"authorization"`:
- `"cmafPackage"`:
- `"dashPackage"`:
- `"description"`: A short text description of the OriginEndpoint.
- `"hlsPackage"`:
- `"manifestName"`: A short string that will be used as the filename of the OriginEndpoint
  URL (defaults to \"index\").
- `"mssPackage"`:
- `"origination"`: Control whether origination of video is allowed for this OriginEndpoint.
  If set to ALLOW, the OriginEndpoint
may by requested, pursuant to any other form of access
  control. If set to DENY, the OriginEndpoint may not be
requested. This can be helpful for
  Live to VOD harvesting, or for temporarily disabling origination
- `"startoverWindowSeconds"`: Maximum duration (seconds) of content to retain for startover
  playback.
If not specified, startover playback will be disabled for the OriginEndpoint.
- `"tags"`:
- `"timeDelaySeconds"`: Amount of delay (seconds) to enforce on the playback of live
  content.
If not specified, there will be no time delay in effect for the OriginEndpoint.
- `"whitelist"`: A list of source IP CIDR blocks that will be allowed to access the
  OriginEndpoint.
"""
function create_origin_endpoint(
    channelId, id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediapackage(
        "POST",
        "/origin_endpoints",
        Dict{String,Any}("channelId" => channelId, "id" => id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_origin_endpoint(
    channelId,
    id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediapackage(
        "POST",
        "/origin_endpoints",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("channelId" => channelId, "id" => id), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_channel(id)
    delete_channel(id, params::Dict{String,<:Any})

Deletes an existing Channel.

# Arguments
- `id`: The ID of the Channel to delete.

"""
function delete_channel(id; aws_config::AbstractAWSConfig=current_aws_config())
    return mediapackage(
        "DELETE", "/channels/$(id)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function delete_channel(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediapackage(
        "DELETE",
        "/channels/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_origin_endpoint(id)
    delete_origin_endpoint(id, params::Dict{String,<:Any})

Deletes an existing OriginEndpoint.

# Arguments
- `id`: The ID of the OriginEndpoint to delete.

"""
function delete_origin_endpoint(id; aws_config::AbstractAWSConfig=current_aws_config())
    return mediapackage(
        "DELETE",
        "/origin_endpoints/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_origin_endpoint(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediapackage(
        "DELETE",
        "/origin_endpoints/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_channel(id)
    describe_channel(id, params::Dict{String,<:Any})

Gets details about a Channel.

# Arguments
- `id`: The ID of a Channel.

"""
function describe_channel(id; aws_config::AbstractAWSConfig=current_aws_config())
    return mediapackage(
        "GET", "/channels/$(id)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_channel(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediapackage(
        "GET",
        "/channels/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_harvest_job(id)
    describe_harvest_job(id, params::Dict{String,<:Any})

Gets details about an existing HarvestJob.

# Arguments
- `id`: The ID of the HarvestJob.

"""
function describe_harvest_job(id; aws_config::AbstractAWSConfig=current_aws_config())
    return mediapackage(
        "GET", "/harvest_jobs/$(id)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_harvest_job(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediapackage(
        "GET",
        "/harvest_jobs/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_origin_endpoint(id)
    describe_origin_endpoint(id, params::Dict{String,<:Any})

Gets details about an existing OriginEndpoint.

# Arguments
- `id`: The ID of the OriginEndpoint.

"""
function describe_origin_endpoint(id; aws_config::AbstractAWSConfig=current_aws_config())
    return mediapackage(
        "GET",
        "/origin_endpoints/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_origin_endpoint(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediapackage(
        "GET",
        "/origin_endpoints/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_channels()
    list_channels(params::Dict{String,<:Any})

Returns a collection of Channels.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Upper bound on number of records to return.
- `"nextToken"`: A token used to resume pagination from the end of a previous request.
"""
function list_channels(; aws_config::AbstractAWSConfig=current_aws_config())
    return mediapackage(
        "GET", "/channels"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_channels(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediapackage(
        "GET", "/channels", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_harvest_jobs()
    list_harvest_jobs(params::Dict{String,<:Any})

Returns a collection of HarvestJob records.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"includeChannelId"`: When specified, the request will return only HarvestJobs associated
  with the given Channel ID.
- `"includeStatus"`: When specified, the request will return only HarvestJobs in the given
  status.
- `"maxResults"`: The upper bound on the number of records to return.
- `"nextToken"`: A token used to resume pagination from the end of a previous request.
"""
function list_harvest_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return mediapackage(
        "GET", "/harvest_jobs"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_harvest_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediapackage(
        "GET",
        "/harvest_jobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_origin_endpoints()
    list_origin_endpoints(params::Dict{String,<:Any})

Returns a collection of OriginEndpoint records.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"channelId"`: When specified, the request will return only OriginEndpoints associated
  with the given Channel ID.
- `"maxResults"`: The upper bound on the number of records to return.
- `"nextToken"`: A token used to resume pagination from the end of a previous request.
"""
function list_origin_endpoints(; aws_config::AbstractAWSConfig=current_aws_config())
    return mediapackage(
        "GET", "/origin_endpoints"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_origin_endpoints(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediapackage(
        "GET",
        "/origin_endpoints",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource-arn)
    list_tags_for_resource(resource-arn, params::Dict{String,<:Any})



# Arguments
- `resource-arn`:

"""
function list_tags_for_resource(
    resource_arn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediapackage(
        "GET",
        "/tags/$(resource-arn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resource_arn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediapackage(
        "GET",
        "/tags/$(resource-arn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    rotate_channel_credentials(id)
    rotate_channel_credentials(id, params::Dict{String,<:Any})

Changes the Channel's first IngestEndpoint's username and password. WARNING - This API is
deprecated. Please use RotateIngestEndpointCredentials instead

# Arguments
- `id`: The ID of the channel to update.

"""
function rotate_channel_credentials(id; aws_config::AbstractAWSConfig=current_aws_config())
    return mediapackage(
        "PUT",
        "/channels/$(id)/credentials";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function rotate_channel_credentials(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediapackage(
        "PUT",
        "/channels/$(id)/credentials",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    rotate_ingest_endpoint_credentials(id, ingest_endpoint_id)
    rotate_ingest_endpoint_credentials(id, ingest_endpoint_id, params::Dict{String,<:Any})

Rotate the IngestEndpoint's username and password, as specified by the IngestEndpoint's id.

# Arguments
- `id`: The ID of the channel the IngestEndpoint is on.
- `ingest_endpoint_id`: The id of the IngestEndpoint whose credentials should be rotated

"""
function rotate_ingest_endpoint_credentials(
    id, ingest_endpoint_id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediapackage(
        "PUT",
        "/channels/$(id)/ingest_endpoints/$(ingest_endpoint_id)/credentials";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function rotate_ingest_endpoint_credentials(
    id,
    ingest_endpoint_id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediapackage(
        "PUT",
        "/channels/$(id)/ingest_endpoints/$(ingest_endpoint_id)/credentials",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource-arn, tags)
    tag_resource(resource-arn, tags, params::Dict{String,<:Any})



# Arguments
- `resource-arn`:
- `tags`:

"""
function tag_resource(
    resource_arn, tags; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediapackage(
        "POST",
        "/tags/$(resource-arn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resource_arn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediapackage(
        "POST",
        "/tags/$(resource-arn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource-arn, tag_keys)
    untag_resource(resource-arn, tag_keys, params::Dict{String,<:Any})



# Arguments
- `resource-arn`:
- `tag_keys`: The key(s) of tag to be deleted

"""
function untag_resource(
    resource_arn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediapackage(
        "DELETE",
        "/tags/$(resource-arn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resource_arn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediapackage(
        "DELETE",
        "/tags/$(resource-arn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_channel(id)
    update_channel(id, params::Dict{String,<:Any})

Updates an existing Channel.

# Arguments
- `id`: The ID of the Channel to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A short text description of the Channel.
"""
function update_channel(id; aws_config::AbstractAWSConfig=current_aws_config())
    return mediapackage(
        "PUT", "/channels/$(id)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function update_channel(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediapackage(
        "PUT",
        "/channels/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_origin_endpoint(id)
    update_origin_endpoint(id, params::Dict{String,<:Any})

Updates an existing OriginEndpoint.

# Arguments
- `id`: The ID of the OriginEndpoint to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"authorization"`:
- `"cmafPackage"`:
- `"dashPackage"`:
- `"description"`: A short text description of the OriginEndpoint.
- `"hlsPackage"`:
- `"manifestName"`: A short string that will be appended to the end of the Endpoint URL.
- `"mssPackage"`:
- `"origination"`: Control whether origination of video is allowed for this OriginEndpoint.
  If set to ALLOW, the OriginEndpoint
may by requested, pursuant to any other form of access
  control. If set to DENY, the OriginEndpoint may not be
requested. This can be helpful for
  Live to VOD harvesting, or for temporarily disabling origination
- `"startoverWindowSeconds"`: Maximum duration (in seconds) of content to retain for
  startover playback.
If not specified, startover playback will be disabled for the
  OriginEndpoint.
- `"timeDelaySeconds"`: Amount of delay (in seconds) to enforce on the playback of live
  content.
If not specified, there will be no time delay in effect for the OriginEndpoint.
- `"whitelist"`: A list of source IP CIDR blocks that will be allowed to access the
  OriginEndpoint.
"""
function update_origin_endpoint(id; aws_config::AbstractAWSConfig=current_aws_config())
    return mediapackage(
        "PUT",
        "/origin_endpoints/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_origin_endpoint(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediapackage(
        "PUT",
        "/origin_endpoints/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: codecommit
using AWS.Compat
using AWS.UUIDs

"""
    associate_approval_rule_template_with_repository(approval_rule_template_name, repository_name)
    associate_approval_rule_template_with_repository(approval_rule_template_name, repository_name, params::Dict{String,<:Any})

Creates an association between an approval rule template and a specified repository. Then,
the next time a pull request is created in the repository where the destination reference
(if specified) matches the destination reference (branch) for the pull request, an approval
rule that matches the template conditions is automatically created for that pull request.
If no destination references are specified in the template, an approval rule that matches
the template contents is created for all pull requests in that repository.

# Arguments
- `approval_rule_template_name`: The name for the approval rule template.
- `repository_name`: The name of the repository that you want to associate with the
  template.

"""
function associate_approval_rule_template_with_repository(
    approvalRuleTemplateName,
    repositoryName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "AssociateApprovalRuleTemplateWithRepository",
        Dict{String,Any}(
            "approvalRuleTemplateName" => approvalRuleTemplateName,
            "repositoryName" => repositoryName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_approval_rule_template_with_repository(
    approvalRuleTemplateName,
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "AssociateApprovalRuleTemplateWithRepository",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "approvalRuleTemplateName" => approvalRuleTemplateName,
                    "repositoryName" => repositoryName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_associate_approval_rule_template_with_repositories(approval_rule_template_name, repository_names)
    batch_associate_approval_rule_template_with_repositories(approval_rule_template_name, repository_names, params::Dict{String,<:Any})

Creates an association between an approval rule template and one or more specified
repositories.

# Arguments
- `approval_rule_template_name`: The name of the template you want to associate with one or
  more repositories.
- `repository_names`: The names of the repositories you want to associate with the
  template.  The length constraint limit is for each string in the array. The array itself
  can be empty.

"""
function batch_associate_approval_rule_template_with_repositories(
    approvalRuleTemplateName,
    repositoryNames;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "BatchAssociateApprovalRuleTemplateWithRepositories",
        Dict{String,Any}(
            "approvalRuleTemplateName" => approvalRuleTemplateName,
            "repositoryNames" => repositoryNames,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_associate_approval_rule_template_with_repositories(
    approvalRuleTemplateName,
    repositoryNames,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "BatchAssociateApprovalRuleTemplateWithRepositories",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "approvalRuleTemplateName" => approvalRuleTemplateName,
                    "repositoryNames" => repositoryNames,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_describe_merge_conflicts(destination_commit_specifier, merge_option, repository_name, source_commit_specifier)
    batch_describe_merge_conflicts(destination_commit_specifier, merge_option, repository_name, source_commit_specifier, params::Dict{String,<:Any})

Returns information about one or more merge conflicts in the attempted merge of two commit
specifiers using the squash or three-way merge strategy.

# Arguments
- `destination_commit_specifier`: The branch, tag, HEAD, or other fully qualified reference
  used to identify a commit (for example, a branch name or a full commit ID).
- `merge_option`: The merge option or strategy you want to use to merge the code.
- `repository_name`: The name of the repository that contains the merge conflicts you want
  to review.
- `source_commit_specifier`: The branch, tag, HEAD, or other fully qualified reference used
  to identify a commit (for example, a branch name or a full commit ID).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"conflictDetailLevel"`: The level of conflict detail to use. If unspecified, the default
  FILE_LEVEL is used, which returns a not-mergeable result if the same file has differences
  in both branches. If LINE_LEVEL is specified, a conflict is considered not mergeable if the
  same file in both branches has differences on the same line.
- `"conflictResolutionStrategy"`: Specifies which branch to use when resolving conflicts,
  or whether to attempt automatically merging two versions of a file. The default is NONE,
  which requires any conflicts to be resolved manually before the merge operation is
  successful.
- `"filePaths"`: The path of the target files used to describe the conflicts. If not
  specified, the default is all conflict files.
- `"maxConflictFiles"`: The maximum number of files to include in the output.
- `"maxMergeHunks"`: The maximum number of merge hunks to include in the output.
- `"nextToken"`: An enumeration token that, when provided in a request, returns the next
  batch of the results.
"""
function batch_describe_merge_conflicts(
    destinationCommitSpecifier,
    mergeOption,
    repositoryName,
    sourceCommitSpecifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "BatchDescribeMergeConflicts",
        Dict{String,Any}(
            "destinationCommitSpecifier" => destinationCommitSpecifier,
            "mergeOption" => mergeOption,
            "repositoryName" => repositoryName,
            "sourceCommitSpecifier" => sourceCommitSpecifier,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_describe_merge_conflicts(
    destinationCommitSpecifier,
    mergeOption,
    repositoryName,
    sourceCommitSpecifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "BatchDescribeMergeConflicts",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "destinationCommitSpecifier" => destinationCommitSpecifier,
                    "mergeOption" => mergeOption,
                    "repositoryName" => repositoryName,
                    "sourceCommitSpecifier" => sourceCommitSpecifier,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_disassociate_approval_rule_template_from_repositories(approval_rule_template_name, repository_names)
    batch_disassociate_approval_rule_template_from_repositories(approval_rule_template_name, repository_names, params::Dict{String,<:Any})

Removes the association between an approval rule template and one or more specified
repositories.

# Arguments
- `approval_rule_template_name`: The name of the template that you want to disassociate
  from one or more repositories.
- `repository_names`: The repository names that you want to disassociate from the approval
  rule template.  The length constraint limit is for each string in the array. The array
  itself can be empty.

"""
function batch_disassociate_approval_rule_template_from_repositories(
    approvalRuleTemplateName,
    repositoryNames;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "BatchDisassociateApprovalRuleTemplateFromRepositories",
        Dict{String,Any}(
            "approvalRuleTemplateName" => approvalRuleTemplateName,
            "repositoryNames" => repositoryNames,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_disassociate_approval_rule_template_from_repositories(
    approvalRuleTemplateName,
    repositoryNames,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "BatchDisassociateApprovalRuleTemplateFromRepositories",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "approvalRuleTemplateName" => approvalRuleTemplateName,
                    "repositoryNames" => repositoryNames,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_get_commits(commit_ids, repository_name)
    batch_get_commits(commit_ids, repository_name, params::Dict{String,<:Any})

Returns information about the contents of one or more commits in a repository.

# Arguments
- `commit_ids`: The full commit IDs of the commits to get information about.  You must
  supply the full SHA IDs of each commit. You cannot use shortened SHA IDs.
- `repository_name`: The name of the repository that contains the commits.

"""
function batch_get_commits(
    commitIds, repositoryName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecommit(
        "BatchGetCommits",
        Dict{String,Any}("commitIds" => commitIds, "repositoryName" => repositoryName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_commits(
    commitIds,
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "BatchGetCommits",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "commitIds" => commitIds, "repositoryName" => repositoryName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_get_repositories(repository_names)
    batch_get_repositories(repository_names, params::Dict{String,<:Any})

Returns information about one or more repositories.  The description field for a repository
accepts all HTML characters and all valid Unicode characters. Applications that do not
HTML-encode the description and display it in a webpage can expose users to potentially
malicious code. Make sure that you HTML-encode the description field in any application
that uses this API to display the repository description on a webpage.

# Arguments
- `repository_names`: The names of the repositories to get information about.  The length
  constraint limit is for each string in the array. The array itself can be empty.

"""
function batch_get_repositories(
    repositoryNames; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecommit(
        "BatchGetRepositories",
        Dict{String,Any}("repositoryNames" => repositoryNames);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_repositories(
    repositoryNames,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "BatchGetRepositories",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("repositoryNames" => repositoryNames), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_approval_rule_template(approval_rule_template_content, approval_rule_template_name)
    create_approval_rule_template(approval_rule_template_content, approval_rule_template_name, params::Dict{String,<:Any})

Creates a template for approval rules that can then be associated with one or more
repositories in your Amazon Web Services account. When you associate a template with a
repository, CodeCommit creates an approval rule that matches the conditions of the template
for all pull requests that meet the conditions of the template. For more information, see
AssociateApprovalRuleTemplateWithRepository.

# Arguments
- `approval_rule_template_content`: The content of the approval rule that is created on
  pull requests in associated repositories. If you specify one or more destination references
  (branches), approval rules are created in an associated repository only if their
  destination references (branches) match those specified in the template.  When you create
  the content of the approval rule template, you can specify approvers in an approval pool in
  one of two ways:    CodeCommitApprovers: This option only requires an Amazon Web Services
  account and a resource. It can be used for both IAM users and federated access users whose
  name matches the provided resource name. This is a very powerful option that offers a great
  deal of flexibility. For example, if you specify the Amazon Web Services account
  123456789012 and Mary_Major, all of the following are counted as approvals coming from that
  user:   An IAM user in the account (arn:aws:iam::123456789012:user/Mary_Major)   A
  federated user identified in IAM as Mary_Major
  (arn:aws:sts::123456789012:federated-user/Mary_Major)   This option does not recognize an
  active session of someone assuming the role of CodeCommitReview with a role session name of
  Mary_Major (arn:aws:sts::123456789012:assumed-role/CodeCommitReview/Mary_Major) unless you
  include a wildcard (*Mary_Major).    Fully qualified ARN: This option allows you to specify
  the fully qualified Amazon Resource Name (ARN) of the IAM user or role.    For more
  information about IAM ARNs, wildcards, and formats, see IAM Identifiers in the IAM User
  Guide.
- `approval_rule_template_name`: The name of the approval rule template. Provide
  descriptive names, because this name is applied to the approval rules created automatically
  in associated repositories.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"approvalRuleTemplateDescription"`: The description of the approval rule template.
  Consider providing a description that explains what this template does and when it might be
  appropriate to associate it with repositories.
"""
function create_approval_rule_template(
    approvalRuleTemplateContent,
    approvalRuleTemplateName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "CreateApprovalRuleTemplate",
        Dict{String,Any}(
            "approvalRuleTemplateContent" => approvalRuleTemplateContent,
            "approvalRuleTemplateName" => approvalRuleTemplateName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_approval_rule_template(
    approvalRuleTemplateContent,
    approvalRuleTemplateName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "CreateApprovalRuleTemplate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "approvalRuleTemplateContent" => approvalRuleTemplateContent,
                    "approvalRuleTemplateName" => approvalRuleTemplateName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_branch(branch_name, commit_id, repository_name)
    create_branch(branch_name, commit_id, repository_name, params::Dict{String,<:Any})

Creates a branch in a repository and points the branch to a commit.  Calling the create
branch operation does not set a repository's default branch. To do this, call the update
default branch operation.

# Arguments
- `branch_name`: The name of the new branch to create.
- `commit_id`: The ID of the commit to point the new branch to.
- `repository_name`: The name of the repository in which you want to create the new branch.

"""
function create_branch(
    branchName, commitId, repositoryName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecommit(
        "CreateBranch",
        Dict{String,Any}(
            "branchName" => branchName,
            "commitId" => commitId,
            "repositoryName" => repositoryName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_branch(
    branchName,
    commitId,
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "CreateBranch",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "branchName" => branchName,
                    "commitId" => commitId,
                    "repositoryName" => repositoryName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_commit(branch_name, repository_name)
    create_commit(branch_name, repository_name, params::Dict{String,<:Any})

Creates a commit for a repository on the tip of a specified branch.

# Arguments
- `branch_name`: The name of the branch where you create the commit.
- `repository_name`: The name of the repository where you create the commit.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"authorName"`: The name of the author who created the commit. This information is used
  as both the author and committer for the commit.
- `"commitMessage"`: The commit message you want to include in the commit. Commit messages
  are limited to 256 KB. If no message is specified, a default message is used.
- `"deleteFiles"`: The files to delete in this commit. These files still exist in earlier
  commits.
- `"email"`: The email address of the person who created the commit.
- `"keepEmptyFolders"`: If the commit contains deletions, whether to keep a folder or
  folder structure if the changes leave the folders empty. If true, a ..gitkeep file is
  created for empty folders. The default is false.
- `"parentCommitId"`: The ID of the commit that is the parent of the commit you create. Not
  required if this is an empty repository.
- `"putFiles"`: The files to add or update in this commit.
- `"setFileModes"`: The file modes to update for files in this commit.
"""
function create_commit(
    branchName, repositoryName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecommit(
        "CreateCommit",
        Dict{String,Any}("branchName" => branchName, "repositoryName" => repositoryName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_commit(
    branchName,
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "CreateCommit",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "branchName" => branchName, "repositoryName" => repositoryName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_pull_request(targets, title)
    create_pull_request(targets, title, params::Dict{String,<:Any})

Creates a pull request in the specified repository.

# Arguments
- `targets`: The targets for the pull request, including the source of the code to be
  reviewed (the source branch) and the destination where the creator of the pull request
  intends the code to be merged after the pull request is closed (the destination branch).
- `title`: The title of the pull request. This title is used to identify the pull request
  to other users in the repository.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientRequestToken"`: A unique, client-generated idempotency token that, when provided
  in a request, ensures the request cannot be repeated with a changed parameter. If a request
  is received with the same parameters and a token is included, the request returns
  information about the initial request that used that token.  The Amazon Web ServicesSDKs
  prepopulate client request tokens. If you are using an Amazon Web ServicesSDK, an
  idempotency token is created for you.
- `"description"`: A description of the pull request.
"""
function create_pull_request(
    targets, title; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecommit(
        "CreatePullRequest",
        Dict{String,Any}(
            "targets" => targets, "title" => title, "clientRequestToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_pull_request(
    targets,
    title,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "CreatePullRequest",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "targets" => targets,
                    "title" => title,
                    "clientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_pull_request_approval_rule(approval_rule_content, approval_rule_name, pull_request_id)
    create_pull_request_approval_rule(approval_rule_content, approval_rule_name, pull_request_id, params::Dict{String,<:Any})

Creates an approval rule for a pull request.

# Arguments
- `approval_rule_content`: The content of the approval rule, including the number of
  approvals needed and the structure of an approval pool defined for approvals, if any. For
  more information about approval pools, see the CodeCommit User Guide.  When you create the
  content of the approval rule, you can specify approvers in an approval pool in one of two
  ways:    CodeCommitApprovers: This option only requires an Amazon Web Services account and
  a resource. It can be used for both IAM users and federated access users whose name matches
  the provided resource name. This is a very powerful option that offers a great deal of
  flexibility. For example, if you specify the Amazon Web Services account 123456789012 and
  Mary_Major, all of the following would be counted as approvals coming from that user:   An
  IAM user in the account (arn:aws:iam::123456789012:user/Mary_Major)   A federated user
  identified in IAM as Mary_Major (arn:aws:sts::123456789012:federated-user/Mary_Major)
  This option does not recognize an active session of someone assuming the role of
  CodeCommitReview with a role session name of Mary_Major
  (arn:aws:sts::123456789012:assumed-role/CodeCommitReview/Mary_Major) unless you include a
  wildcard (*Mary_Major).    Fully qualified ARN: This option allows you to specify the fully
  qualified Amazon Resource Name (ARN) of the IAM user or role.    For more information about
  IAM ARNs, wildcards, and formats, see IAM Identifiers in the IAM User Guide.
- `approval_rule_name`: The name for the approval rule.
- `pull_request_id`: The system-generated ID of the pull request for which you want to
  create the approval rule.

"""
function create_pull_request_approval_rule(
    approvalRuleContent,
    approvalRuleName,
    pullRequestId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "CreatePullRequestApprovalRule",
        Dict{String,Any}(
            "approvalRuleContent" => approvalRuleContent,
            "approvalRuleName" => approvalRuleName,
            "pullRequestId" => pullRequestId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_pull_request_approval_rule(
    approvalRuleContent,
    approvalRuleName,
    pullRequestId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "CreatePullRequestApprovalRule",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "approvalRuleContent" => approvalRuleContent,
                    "approvalRuleName" => approvalRuleName,
                    "pullRequestId" => pullRequestId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_repository(repository_name)
    create_repository(repository_name, params::Dict{String,<:Any})

Creates a new, empty repository.

# Arguments
- `repository_name`: The name of the new repository to be created.  The repository name
  must be unique across the calling Amazon Web Services account. Repository names are limited
  to 100 alphanumeric, dash, and underscore characters, and cannot include certain
  characters. For more information about the limits on repository names, see Quotas in the
  CodeCommit User Guide. The suffix .git is prohibited.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"kmsKeyId"`: The ID of the encryption key. You can view the ID of an encryption key in
  the KMS console, or use the KMS APIs to programmatically retrieve a key ID. For more
  information about acceptable values for kmsKeyID, see KeyId in the Decrypt API description
  in the Key Management Service API Reference. If no key is specified, the default
  aws/codecommit Amazon Web Services managed key is used.
- `"repositoryDescription"`: A comment or description about the new repository.  The
  description field for a repository accepts all HTML characters and all valid Unicode
  characters. Applications that do not HTML-encode the description and display it in a
  webpage can expose users to potentially malicious code. Make sure that you HTML-encode the
  description field in any application that uses this API to display the repository
  description on a webpage.
- `"tags"`: One or more tag key-value pairs to use when tagging this repository.
"""
function create_repository(
    repositoryName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecommit(
        "CreateRepository",
        Dict{String,Any}("repositoryName" => repositoryName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_repository(
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "CreateRepository",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("repositoryName" => repositoryName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_unreferenced_merge_commit(destination_commit_specifier, merge_option, repository_name, source_commit_specifier)
    create_unreferenced_merge_commit(destination_commit_specifier, merge_option, repository_name, source_commit_specifier, params::Dict{String,<:Any})

Creates an unreferenced commit that represents the result of merging two branches using a
specified merge strategy. This can help you determine the outcome of a potential merge.
This API cannot be used with the fast-forward merge strategy because that strategy does not
create a merge commit.  This unreferenced merge commit can only be accessed using the
GetCommit API or through git commands such as git fetch. To retrieve this commit, you must
specify its commit ID or otherwise reference it.

# Arguments
- `destination_commit_specifier`: The branch, tag, HEAD, or other fully qualified reference
  used to identify a commit (for example, a branch name or a full commit ID).
- `merge_option`: The merge option or strategy you want to use to merge the code.
- `repository_name`: The name of the repository where you want to create the unreferenced
  merge commit.
- `source_commit_specifier`: The branch, tag, HEAD, or other fully qualified reference used
  to identify a commit (for example, a branch name or a full commit ID).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"authorName"`: The name of the author who created the unreferenced commit. This
  information is used as both the author and committer for the commit.
- `"commitMessage"`: The commit message for the unreferenced commit.
- `"conflictDetailLevel"`: The level of conflict detail to use. If unspecified, the default
  FILE_LEVEL is used, which returns a not-mergeable result if the same file has differences
  in both branches. If LINE_LEVEL is specified, a conflict is considered not mergeable if the
  same file in both branches has differences on the same line.
- `"conflictResolution"`: If AUTOMERGE is the conflict resolution strategy, a list of
  inputs to use when resolving conflicts during a merge.
- `"conflictResolutionStrategy"`: Specifies which branch to use when resolving conflicts,
  or whether to attempt automatically merging two versions of a file. The default is NONE,
  which requires any conflicts to be resolved manually before the merge operation is
  successful.
- `"email"`: The email address for the person who created the unreferenced commit.
- `"keepEmptyFolders"`: If the commit contains deletions, whether to keep a folder or
  folder structure if the changes leave the folders empty. If this is specified as true, a
  .gitkeep file is created for empty folders. The default is false.
"""
function create_unreferenced_merge_commit(
    destinationCommitSpecifier,
    mergeOption,
    repositoryName,
    sourceCommitSpecifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "CreateUnreferencedMergeCommit",
        Dict{String,Any}(
            "destinationCommitSpecifier" => destinationCommitSpecifier,
            "mergeOption" => mergeOption,
            "repositoryName" => repositoryName,
            "sourceCommitSpecifier" => sourceCommitSpecifier,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_unreferenced_merge_commit(
    destinationCommitSpecifier,
    mergeOption,
    repositoryName,
    sourceCommitSpecifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "CreateUnreferencedMergeCommit",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "destinationCommitSpecifier" => destinationCommitSpecifier,
                    "mergeOption" => mergeOption,
                    "repositoryName" => repositoryName,
                    "sourceCommitSpecifier" => sourceCommitSpecifier,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_approval_rule_template(approval_rule_template_name)
    delete_approval_rule_template(approval_rule_template_name, params::Dict{String,<:Any})

Deletes a specified approval rule template. Deleting a template does not remove approval
rules on pull requests already created with the template.

# Arguments
- `approval_rule_template_name`: The name of the approval rule template to delete.

"""
function delete_approval_rule_template(
    approvalRuleTemplateName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecommit(
        "DeleteApprovalRuleTemplate",
        Dict{String,Any}("approvalRuleTemplateName" => approvalRuleTemplateName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_approval_rule_template(
    approvalRuleTemplateName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "DeleteApprovalRuleTemplate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("approvalRuleTemplateName" => approvalRuleTemplateName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_branch(branch_name, repository_name)
    delete_branch(branch_name, repository_name, params::Dict{String,<:Any})

Deletes a branch from a repository, unless that branch is the default branch for the
repository.

# Arguments
- `branch_name`: The name of the branch to delete.
- `repository_name`: The name of the repository that contains the branch to be deleted.

"""
function delete_branch(
    branchName, repositoryName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecommit(
        "DeleteBranch",
        Dict{String,Any}("branchName" => branchName, "repositoryName" => repositoryName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_branch(
    branchName,
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "DeleteBranch",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "branchName" => branchName, "repositoryName" => repositoryName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_comment_content(comment_id)
    delete_comment_content(comment_id, params::Dict{String,<:Any})

Deletes the content of a comment made on a change, file, or commit in a repository.

# Arguments
- `comment_id`: The unique, system-generated ID of the comment. To get this ID, use
  GetCommentsForComparedCommit or GetCommentsForPullRequest.

"""
function delete_comment_content(
    commentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecommit(
        "DeleteCommentContent",
        Dict{String,Any}("commentId" => commentId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_comment_content(
    commentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "DeleteCommentContent",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("commentId" => commentId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_file(branch_name, file_path, parent_commit_id, repository_name)
    delete_file(branch_name, file_path, parent_commit_id, repository_name, params::Dict{String,<:Any})

Deletes a specified file from a specified branch. A commit is created on the branch that
contains the revision. The file still exists in the commits earlier to the commit that
contains the deletion.

# Arguments
- `branch_name`: The name of the branch where the commit that deletes the file is made.
- `file_path`: The fully qualified path to the file that to be deleted, including the full
  name and extension of that file. For example, /examples/file.md is a fully qualified path
  to a file named file.md in a folder named examples.
- `parent_commit_id`: The ID of the commit that is the tip of the branch where you want to
  create the commit that deletes the file. This must be the HEAD commit for the branch. The
  commit that deletes the file is created from this commit ID.
- `repository_name`: The name of the repository that contains the file to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"commitMessage"`: The commit message you want to include as part of deleting the file.
  Commit messages are limited to 256 KB. If no message is specified, a default message is
  used.
- `"email"`: The email address for the commit that deletes the file. If no email address is
  specified, the email address is left blank.
- `"keepEmptyFolders"`: If a file is the only object in the folder or directory, specifies
  whether to delete the folder or directory that contains the file. By default, empty folders
  are deleted. This includes empty folders that are part of the directory structure. For
  example, if the path to a file is dir1/dir2/dir3/dir4, and dir2 and dir3 are empty,
  deleting the last file in dir4 also deletes the empty folders dir4, dir3, and dir2.
- `"name"`: The name of the author of the commit that deletes the file. If no name is
  specified, the user's ARN is used as the author name and committer name.
"""
function delete_file(
    branchName,
    filePath,
    parentCommitId,
    repositoryName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "DeleteFile",
        Dict{String,Any}(
            "branchName" => branchName,
            "filePath" => filePath,
            "parentCommitId" => parentCommitId,
            "repositoryName" => repositoryName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_file(
    branchName,
    filePath,
    parentCommitId,
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "DeleteFile",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "branchName" => branchName,
                    "filePath" => filePath,
                    "parentCommitId" => parentCommitId,
                    "repositoryName" => repositoryName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_pull_request_approval_rule(approval_rule_name, pull_request_id)
    delete_pull_request_approval_rule(approval_rule_name, pull_request_id, params::Dict{String,<:Any})

Deletes an approval rule from a specified pull request. Approval rules can be deleted from
a pull request only if the pull request is open, and if the approval rule was created
specifically for a pull request and not generated from an approval rule template associated
with the repository where the pull request was created. You cannot delete an approval rule
from a merged or closed pull request.

# Arguments
- `approval_rule_name`: The name of the approval rule you want to delete.
- `pull_request_id`: The system-generated ID of the pull request that contains the approval
  rule you want to delete.

"""
function delete_pull_request_approval_rule(
    approvalRuleName, pullRequestId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecommit(
        "DeletePullRequestApprovalRule",
        Dict{String,Any}(
            "approvalRuleName" => approvalRuleName, "pullRequestId" => pullRequestId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_pull_request_approval_rule(
    approvalRuleName,
    pullRequestId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "DeletePullRequestApprovalRule",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "approvalRuleName" => approvalRuleName, "pullRequestId" => pullRequestId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_repository(repository_name)
    delete_repository(repository_name, params::Dict{String,<:Any})

Deletes a repository. If a specified repository was already deleted, a null repository ID
is returned.  Deleting a repository also deletes all associated objects and metadata. After
a repository is deleted, all future push calls to the deleted repository fail.

# Arguments
- `repository_name`: The name of the repository to delete.

"""
function delete_repository(
    repositoryName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecommit(
        "DeleteRepository",
        Dict{String,Any}("repositoryName" => repositoryName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_repository(
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "DeleteRepository",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("repositoryName" => repositoryName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_merge_conflicts(destination_commit_specifier, file_path, merge_option, repository_name, source_commit_specifier)
    describe_merge_conflicts(destination_commit_specifier, file_path, merge_option, repository_name, source_commit_specifier, params::Dict{String,<:Any})

Returns information about one or more merge conflicts in the attempted merge of two commit
specifiers using the squash or three-way merge strategy. If the merge option for the
attempted merge is specified as FAST_FORWARD_MERGE, an exception is thrown.

# Arguments
- `destination_commit_specifier`: The branch, tag, HEAD, or other fully qualified reference
  used to identify a commit (for example, a branch name or a full commit ID).
- `file_path`: The path of the target files used to describe the conflicts.
- `merge_option`: The merge option or strategy you want to use to merge the code.
- `repository_name`: The name of the repository where you want to get information about a
  merge conflict.
- `source_commit_specifier`: The branch, tag, HEAD, or other fully qualified reference used
  to identify a commit (for example, a branch name or a full commit ID).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"conflictDetailLevel"`: The level of conflict detail to use. If unspecified, the default
  FILE_LEVEL is used, which returns a not-mergeable result if the same file has differences
  in both branches. If LINE_LEVEL is specified, a conflict is considered not mergeable if the
  same file in both branches has differences on the same line.
- `"conflictResolutionStrategy"`: Specifies which branch to use when resolving conflicts,
  or whether to attempt automatically merging two versions of a file. The default is NONE,
  which requires any conflicts to be resolved manually before the merge operation is
  successful.
- `"maxMergeHunks"`: The maximum number of merge hunks to include in the output.
- `"nextToken"`: An enumeration token that, when provided in a request, returns the next
  batch of the results.
"""
function describe_merge_conflicts(
    destinationCommitSpecifier,
    filePath,
    mergeOption,
    repositoryName,
    sourceCommitSpecifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "DescribeMergeConflicts",
        Dict{String,Any}(
            "destinationCommitSpecifier" => destinationCommitSpecifier,
            "filePath" => filePath,
            "mergeOption" => mergeOption,
            "repositoryName" => repositoryName,
            "sourceCommitSpecifier" => sourceCommitSpecifier,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_merge_conflicts(
    destinationCommitSpecifier,
    filePath,
    mergeOption,
    repositoryName,
    sourceCommitSpecifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "DescribeMergeConflicts",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "destinationCommitSpecifier" => destinationCommitSpecifier,
                    "filePath" => filePath,
                    "mergeOption" => mergeOption,
                    "repositoryName" => repositoryName,
                    "sourceCommitSpecifier" => sourceCommitSpecifier,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_pull_request_events(pull_request_id)
    describe_pull_request_events(pull_request_id, params::Dict{String,<:Any})

Returns information about one or more pull request events.

# Arguments
- `pull_request_id`: The system-generated ID of the pull request. To get this ID, use
  ListPullRequests.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"actorArn"`: The Amazon Resource Name (ARN) of the user whose actions resulted in the
  event. Examples include updating the pull request with more commits or changing the status
  of a pull request.
- `"maxResults"`: A non-zero, non-negative integer used to limit the number of returned
  results. The default is 100 events, which is also the maximum number of events that can be
  returned in a result.
- `"nextToken"`: An enumeration token that, when provided in a request, returns the next
  batch of the results.
- `"pullRequestEventType"`: Optional. The pull request event type about which you want to
  return information.
"""
function describe_pull_request_events(
    pullRequestId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecommit(
        "DescribePullRequestEvents",
        Dict{String,Any}("pullRequestId" => pullRequestId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_pull_request_events(
    pullRequestId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "DescribePullRequestEvents",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("pullRequestId" => pullRequestId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_approval_rule_template_from_repository(approval_rule_template_name, repository_name)
    disassociate_approval_rule_template_from_repository(approval_rule_template_name, repository_name, params::Dict{String,<:Any})

Removes the association between a template and a repository so that approval rules based on
the template are not automatically created when pull requests are created in the specified
repository. This does not delete any approval rules previously created for pull requests
through the template association.

# Arguments
- `approval_rule_template_name`: The name of the approval rule template to disassociate
  from a specified repository.
- `repository_name`: The name of the repository you want to disassociate from the template.

"""
function disassociate_approval_rule_template_from_repository(
    approvalRuleTemplateName,
    repositoryName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "DisassociateApprovalRuleTemplateFromRepository",
        Dict{String,Any}(
            "approvalRuleTemplateName" => approvalRuleTemplateName,
            "repositoryName" => repositoryName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_approval_rule_template_from_repository(
    approvalRuleTemplateName,
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "DisassociateApprovalRuleTemplateFromRepository",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "approvalRuleTemplateName" => approvalRuleTemplateName,
                    "repositoryName" => repositoryName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    evaluate_pull_request_approval_rules(pull_request_id, revision_id)
    evaluate_pull_request_approval_rules(pull_request_id, revision_id, params::Dict{String,<:Any})

Evaluates whether a pull request has met all the conditions specified in its associated
approval rules.

# Arguments
- `pull_request_id`: The system-generated ID of the pull request you want to evaluate.
- `revision_id`: The system-generated ID for the pull request revision. To retrieve the
  most recent revision ID for a pull request, use GetPullRequest.

"""
function evaluate_pull_request_approval_rules(
    pullRequestId, revisionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecommit(
        "EvaluatePullRequestApprovalRules",
        Dict{String,Any}("pullRequestId" => pullRequestId, "revisionId" => revisionId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function evaluate_pull_request_approval_rules(
    pullRequestId,
    revisionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "EvaluatePullRequestApprovalRules",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "pullRequestId" => pullRequestId, "revisionId" => revisionId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_approval_rule_template(approval_rule_template_name)
    get_approval_rule_template(approval_rule_template_name, params::Dict{String,<:Any})

Returns information about a specified approval rule template.

# Arguments
- `approval_rule_template_name`: The name of the approval rule template for which you want
  to get information.

"""
function get_approval_rule_template(
    approvalRuleTemplateName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecommit(
        "GetApprovalRuleTemplate",
        Dict{String,Any}("approvalRuleTemplateName" => approvalRuleTemplateName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_approval_rule_template(
    approvalRuleTemplateName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "GetApprovalRuleTemplate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("approvalRuleTemplateName" => approvalRuleTemplateName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_blob(blob_id, repository_name)
    get_blob(blob_id, repository_name, params::Dict{String,<:Any})

Returns the base-64 encoded content of an individual blob in a repository.

# Arguments
- `blob_id`: The ID of the blob, which is its SHA-1 pointer.
- `repository_name`: The name of the repository that contains the blob.

"""
function get_blob(
    blobId, repositoryName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecommit(
        "GetBlob",
        Dict{String,Any}("blobId" => blobId, "repositoryName" => repositoryName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_blob(
    blobId,
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "GetBlob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("blobId" => blobId, "repositoryName" => repositoryName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_branch()
    get_branch(params::Dict{String,<:Any})

Returns information about a repository branch, including its name and the last commit ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"branchName"`: The name of the branch for which you want to retrieve information.
- `"repositoryName"`: The name of the repository that contains the branch for which you
  want to retrieve information.
"""
function get_branch(; aws_config::AbstractAWSConfig=current_aws_config())
    return codecommit("GetBranch"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function get_branch(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecommit(
        "GetBranch", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_comment(comment_id)
    get_comment(comment_id, params::Dict{String,<:Any})

Returns the content of a comment made on a change, file, or commit in a repository.
Reaction counts might include numbers from user identities who were deleted after the
reaction was made. For a count of reactions from active identities, use
GetCommentReactions.

# Arguments
- `comment_id`: The unique, system-generated ID of the comment. To get this ID, use
  GetCommentsForComparedCommit or GetCommentsForPullRequest.

"""
function get_comment(commentId; aws_config::AbstractAWSConfig=current_aws_config())
    return codecommit(
        "GetComment",
        Dict{String,Any}("commentId" => commentId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_comment(
    commentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "GetComment",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("commentId" => commentId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_comment_reactions(comment_id)
    get_comment_reactions(comment_id, params::Dict{String,<:Any})

Returns information about reactions to a specified comment ID. Reactions from users who
have been deleted will not be included in the count.

# Arguments
- `comment_id`: The ID of the comment for which you want to get reactions information.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: A non-zero, non-negative integer used to limit the number of returned
  results. The default is the same as the allowed maximum, 1,000.
- `"nextToken"`: An enumeration token that, when provided in a request, returns the next
  batch of the results.
- `"reactionUserArn"`: Optional. The Amazon Resource Name (ARN) of the user or identity for
  which you want to get reaction information.
"""
function get_comment_reactions(
    commentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecommit(
        "GetCommentReactions",
        Dict{String,Any}("commentId" => commentId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_comment_reactions(
    commentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "GetCommentReactions",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("commentId" => commentId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_comments_for_compared_commit(after_commit_id, repository_name)
    get_comments_for_compared_commit(after_commit_id, repository_name, params::Dict{String,<:Any})

Returns information about comments made on the comparison between two commits.  Reaction
counts might include numbers from user identities who were deleted after the reaction was
made. For a count of reactions from active identities, use GetCommentReactions.

# Arguments
- `after_commit_id`: To establish the directionality of the comparison, the full commit ID
  of the after commit.
- `repository_name`: The name of the repository where you want to compare commits.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"beforeCommitId"`: To establish the directionality of the comparison, the full commit ID
  of the before commit.
- `"maxResults"`: A non-zero, non-negative integer used to limit the number of returned
  results. The default is 100 comments, but you can configure up to 500.
- `"nextToken"`: An enumeration token that when provided in a request, returns the next
  batch of the results.
"""
function get_comments_for_compared_commit(
    afterCommitId, repositoryName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecommit(
        "GetCommentsForComparedCommit",
        Dict{String,Any}(
            "afterCommitId" => afterCommitId, "repositoryName" => repositoryName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_comments_for_compared_commit(
    afterCommitId,
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "GetCommentsForComparedCommit",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "afterCommitId" => afterCommitId, "repositoryName" => repositoryName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_comments_for_pull_request(pull_request_id)
    get_comments_for_pull_request(pull_request_id, params::Dict{String,<:Any})

Returns comments made on a pull request.  Reaction counts might include numbers from user
identities who were deleted after the reaction was made. For a count of reactions from
active identities, use GetCommentReactions.

# Arguments
- `pull_request_id`: The system-generated ID of the pull request. To get this ID, use
  ListPullRequests.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"afterCommitId"`: The full commit ID of the commit in the source branch that was the tip
  of the branch at the time the comment was made. Requirement is conditional: afterCommitId
  must be specified when repositoryName is included.
- `"beforeCommitId"`: The full commit ID of the commit in the destination branch that was
  the tip of the branch at the time the pull request was created. Requirement is conditional:
  beforeCommitId must be specified when repositoryName is included.
- `"maxResults"`: A non-zero, non-negative integer used to limit the number of returned
  results. The default is 100 comments. You can return up to 500 comments with a single
  request.
- `"nextToken"`: An enumeration token that, when provided in a request, returns the next
  batch of the results.
- `"repositoryName"`: The name of the repository that contains the pull request.
  Requirement is conditional: repositoryName must be specified when beforeCommitId and
  afterCommitId are included.
"""
function get_comments_for_pull_request(
    pullRequestId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecommit(
        "GetCommentsForPullRequest",
        Dict{String,Any}("pullRequestId" => pullRequestId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_comments_for_pull_request(
    pullRequestId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "GetCommentsForPullRequest",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("pullRequestId" => pullRequestId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_commit(commit_id, repository_name)
    get_commit(commit_id, repository_name, params::Dict{String,<:Any})

Returns information about a commit, including commit message and committer information.

# Arguments
- `commit_id`: The commit ID. Commit IDs are the full SHA ID of the commit.
- `repository_name`: The name of the repository to which the commit was made.

"""
function get_commit(
    commitId, repositoryName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecommit(
        "GetCommit",
        Dict{String,Any}("commitId" => commitId, "repositoryName" => repositoryName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_commit(
    commitId,
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "GetCommit",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "commitId" => commitId, "repositoryName" => repositoryName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_differences(after_commit_specifier, repository_name)
    get_differences(after_commit_specifier, repository_name, params::Dict{String,<:Any})

Returns information about the differences in a valid commit specifier (such as a branch,
tag, HEAD, commit ID, or other fully qualified reference). Results can be limited to a
specified path.

# Arguments
- `after_commit_specifier`: The branch, tag, HEAD, or other fully qualified reference used
  to identify a commit.
- `repository_name`: The name of the repository where you want to get differences.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: A non-zero, non-negative integer used to limit the number of returned
  results.
- `"NextToken"`: An enumeration token that, when provided in a request, returns the next
  batch of the results.
- `"afterPath"`: The file path in which to check differences. Limits the results to this
  path. Can also be used to specify the changed name of a directory or folder, if it has
  changed. If not specified, differences are shown for all paths.
- `"beforeCommitSpecifier"`: The branch, tag, HEAD, or other fully qualified reference used
  to identify a commit (for example, the full commit ID). Optional. If not specified, all
  changes before the afterCommitSpecifier value are shown. If you do not use
  beforeCommitSpecifier in your request, consider limiting the results with maxResults.
- `"beforePath"`: The file path in which to check for differences. Limits the results to
  this path. Can also be used to specify the previous name of a directory or folder. If
  beforePath and afterPath are not specified, differences are shown for all paths.
"""
function get_differences(
    afterCommitSpecifier, repositoryName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecommit(
        "GetDifferences",
        Dict{String,Any}(
            "afterCommitSpecifier" => afterCommitSpecifier,
            "repositoryName" => repositoryName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_differences(
    afterCommitSpecifier,
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "GetDifferences",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "afterCommitSpecifier" => afterCommitSpecifier,
                    "repositoryName" => repositoryName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_file(file_path, repository_name)
    get_file(file_path, repository_name, params::Dict{String,<:Any})

Returns the base-64 encoded contents of a specified file and its metadata.

# Arguments
- `file_path`: The fully qualified path to the file, including the full name and extension
  of the file. For example, /examples/file.md is the fully qualified path to a file named
  file.md in a folder named examples.
- `repository_name`: The name of the repository that contains the file.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"commitSpecifier"`: The fully quaified reference that identifies the commit that
  contains the file. For example, you can specify a full commit ID, a tag, a branch name, or
  a reference such as refs/heads/main. If none is provided, the head commit is used.
"""
function get_file(
    filePath, repositoryName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecommit(
        "GetFile",
        Dict{String,Any}("filePath" => filePath, "repositoryName" => repositoryName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_file(
    filePath,
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "GetFile",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "filePath" => filePath, "repositoryName" => repositoryName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_folder(folder_path, repository_name)
    get_folder(folder_path, repository_name, params::Dict{String,<:Any})

Returns the contents of a specified folder in a repository.

# Arguments
- `folder_path`: The fully qualified path to the folder whose contents are returned,
  including the folder name. For example, /examples is a fully-qualified path to a folder
  named examples that was created off of the root directory (/) of a repository.
- `repository_name`: The name of the repository.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"commitSpecifier"`: A fully qualified reference used to identify a commit that contains
  the version of the folder's content to return. A fully qualified reference can be a commit
  ID, branch name, tag, or reference such as HEAD. If no specifier is provided, the folder
  content is returned as it exists in the HEAD commit.
"""
function get_folder(
    folderPath, repositoryName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecommit(
        "GetFolder",
        Dict{String,Any}("folderPath" => folderPath, "repositoryName" => repositoryName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_folder(
    folderPath,
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "GetFolder",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "folderPath" => folderPath, "repositoryName" => repositoryName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_merge_commit(destination_commit_specifier, repository_name, source_commit_specifier)
    get_merge_commit(destination_commit_specifier, repository_name, source_commit_specifier, params::Dict{String,<:Any})

Returns information about a specified merge commit.

# Arguments
- `destination_commit_specifier`: The branch, tag, HEAD, or other fully qualified reference
  used to identify a commit (for example, a branch name or a full commit ID).
- `repository_name`: The name of the repository that contains the merge commit about which
  you want to get information.
- `source_commit_specifier`: The branch, tag, HEAD, or other fully qualified reference used
  to identify a commit (for example, a branch name or a full commit ID).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"conflictDetailLevel"`: The level of conflict detail to use. If unspecified, the default
  FILE_LEVEL is used, which returns a not-mergeable result if the same file has differences
  in both branches. If LINE_LEVEL is specified, a conflict is considered not mergeable if the
  same file in both branches has differences on the same line.
- `"conflictResolutionStrategy"`: Specifies which branch to use when resolving conflicts,
  or whether to attempt automatically merging two versions of a file. The default is NONE,
  which requires any conflicts to be resolved manually before the merge operation is
  successful.
"""
function get_merge_commit(
    destinationCommitSpecifier,
    repositoryName,
    sourceCommitSpecifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "GetMergeCommit",
        Dict{String,Any}(
            "destinationCommitSpecifier" => destinationCommitSpecifier,
            "repositoryName" => repositoryName,
            "sourceCommitSpecifier" => sourceCommitSpecifier,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_merge_commit(
    destinationCommitSpecifier,
    repositoryName,
    sourceCommitSpecifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "GetMergeCommit",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "destinationCommitSpecifier" => destinationCommitSpecifier,
                    "repositoryName" => repositoryName,
                    "sourceCommitSpecifier" => sourceCommitSpecifier,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_merge_conflicts(destination_commit_specifier, merge_option, repository_name, source_commit_specifier)
    get_merge_conflicts(destination_commit_specifier, merge_option, repository_name, source_commit_specifier, params::Dict{String,<:Any})

Returns information about merge conflicts between the before and after commit IDs for a
pull request in a repository.

# Arguments
- `destination_commit_specifier`: The branch, tag, HEAD, or other fully qualified reference
  used to identify a commit (for example, a branch name or a full commit ID).
- `merge_option`: The merge option or strategy you want to use to merge the code.
- `repository_name`: The name of the repository where the pull request was created.
- `source_commit_specifier`: The branch, tag, HEAD, or other fully qualified reference used
  to identify a commit (for example, a branch name or a full commit ID).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"conflictDetailLevel"`: The level of conflict detail to use. If unspecified, the default
  FILE_LEVEL is used, which returns a not-mergeable result if the same file has differences
  in both branches. If LINE_LEVEL is specified, a conflict is considered not mergeable if the
  same file in both branches has differences on the same line.
- `"conflictResolutionStrategy"`: Specifies which branch to use when resolving conflicts,
  or whether to attempt automatically merging two versions of a file. The default is NONE,
  which requires any conflicts to be resolved manually before the merge operation is
  successful.
- `"maxConflictFiles"`: The maximum number of files to include in the output.
- `"nextToken"`: An enumeration token that, when provided in a request, returns the next
  batch of the results.
"""
function get_merge_conflicts(
    destinationCommitSpecifier,
    mergeOption,
    repositoryName,
    sourceCommitSpecifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "GetMergeConflicts",
        Dict{String,Any}(
            "destinationCommitSpecifier" => destinationCommitSpecifier,
            "mergeOption" => mergeOption,
            "repositoryName" => repositoryName,
            "sourceCommitSpecifier" => sourceCommitSpecifier,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_merge_conflicts(
    destinationCommitSpecifier,
    mergeOption,
    repositoryName,
    sourceCommitSpecifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "GetMergeConflicts",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "destinationCommitSpecifier" => destinationCommitSpecifier,
                    "mergeOption" => mergeOption,
                    "repositoryName" => repositoryName,
                    "sourceCommitSpecifier" => sourceCommitSpecifier,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_merge_options(destination_commit_specifier, repository_name, source_commit_specifier)
    get_merge_options(destination_commit_specifier, repository_name, source_commit_specifier, params::Dict{String,<:Any})

Returns information about the merge options available for merging two specified branches.
For details about why a merge option is not available, use GetMergeConflicts or
DescribeMergeConflicts.

# Arguments
- `destination_commit_specifier`: The branch, tag, HEAD, or other fully qualified reference
  used to identify a commit (for example, a branch name or a full commit ID).
- `repository_name`: The name of the repository that contains the commits about which you
  want to get merge options.
- `source_commit_specifier`: The branch, tag, HEAD, or other fully qualified reference used
  to identify a commit (for example, a branch name or a full commit ID).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"conflictDetailLevel"`: The level of conflict detail to use. If unspecified, the default
  FILE_LEVEL is used, which returns a not-mergeable result if the same file has differences
  in both branches. If LINE_LEVEL is specified, a conflict is considered not mergeable if the
  same file in both branches has differences on the same line.
- `"conflictResolutionStrategy"`: Specifies which branch to use when resolving conflicts,
  or whether to attempt automatically merging two versions of a file. The default is NONE,
  which requires any conflicts to be resolved manually before the merge operation is
  successful.
"""
function get_merge_options(
    destinationCommitSpecifier,
    repositoryName,
    sourceCommitSpecifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "GetMergeOptions",
        Dict{String,Any}(
            "destinationCommitSpecifier" => destinationCommitSpecifier,
            "repositoryName" => repositoryName,
            "sourceCommitSpecifier" => sourceCommitSpecifier,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_merge_options(
    destinationCommitSpecifier,
    repositoryName,
    sourceCommitSpecifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "GetMergeOptions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "destinationCommitSpecifier" => destinationCommitSpecifier,
                    "repositoryName" => repositoryName,
                    "sourceCommitSpecifier" => sourceCommitSpecifier,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_pull_request(pull_request_id)
    get_pull_request(pull_request_id, params::Dict{String,<:Any})

Gets information about a pull request in a specified repository.

# Arguments
- `pull_request_id`: The system-generated ID of the pull request. To get this ID, use
  ListPullRequests.

"""
function get_pull_request(pullRequestId; aws_config::AbstractAWSConfig=current_aws_config())
    return codecommit(
        "GetPullRequest",
        Dict{String,Any}("pullRequestId" => pullRequestId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_pull_request(
    pullRequestId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "GetPullRequest",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("pullRequestId" => pullRequestId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_pull_request_approval_states(pull_request_id, revision_id)
    get_pull_request_approval_states(pull_request_id, revision_id, params::Dict{String,<:Any})

Gets information about the approval states for a specified pull request. Approval states
only apply to pull requests that have one or more approval rules applied to them.

# Arguments
- `pull_request_id`: The system-generated ID for the pull request.
- `revision_id`: The system-generated ID for the pull request revision.

"""
function get_pull_request_approval_states(
    pullRequestId, revisionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecommit(
        "GetPullRequestApprovalStates",
        Dict{String,Any}("pullRequestId" => pullRequestId, "revisionId" => revisionId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_pull_request_approval_states(
    pullRequestId,
    revisionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "GetPullRequestApprovalStates",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "pullRequestId" => pullRequestId, "revisionId" => revisionId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_pull_request_override_state(pull_request_id, revision_id)
    get_pull_request_override_state(pull_request_id, revision_id, params::Dict{String,<:Any})

Returns information about whether approval rules have been set aside (overridden) for a
pull request, and if so, the Amazon Resource Name (ARN) of the user or identity that
overrode the rules and their requirements for the pull request.

# Arguments
- `pull_request_id`: The ID of the pull request for which you want to get information about
  whether approval rules have been set aside (overridden).
- `revision_id`: The system-generated ID of the revision for the pull request. To retrieve
  the most recent revision ID, use GetPullRequest.

"""
function get_pull_request_override_state(
    pullRequestId, revisionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecommit(
        "GetPullRequestOverrideState",
        Dict{String,Any}("pullRequestId" => pullRequestId, "revisionId" => revisionId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_pull_request_override_state(
    pullRequestId,
    revisionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "GetPullRequestOverrideState",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "pullRequestId" => pullRequestId, "revisionId" => revisionId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_repository(repository_name)
    get_repository(repository_name, params::Dict{String,<:Any})

Returns information about a repository.  The description field for a repository accepts all
HTML characters and all valid Unicode characters. Applications that do not HTML-encode the
description and display it in a webpage can expose users to potentially malicious code.
Make sure that you HTML-encode the description field in any application that uses this API
to display the repository description on a webpage.

# Arguments
- `repository_name`: The name of the repository to get information about.

"""
function get_repository(repositoryName; aws_config::AbstractAWSConfig=current_aws_config())
    return codecommit(
        "GetRepository",
        Dict{String,Any}("repositoryName" => repositoryName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_repository(
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "GetRepository",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("repositoryName" => repositoryName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_repository_triggers(repository_name)
    get_repository_triggers(repository_name, params::Dict{String,<:Any})

Gets information about triggers configured for a repository.

# Arguments
- `repository_name`: The name of the repository for which the trigger is configured.

"""
function get_repository_triggers(
    repositoryName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecommit(
        "GetRepositoryTriggers",
        Dict{String,Any}("repositoryName" => repositoryName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_repository_triggers(
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "GetRepositoryTriggers",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("repositoryName" => repositoryName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_approval_rule_templates()
    list_approval_rule_templates(params::Dict{String,<:Any})

Lists all approval rule templates in the specified Amazon Web Services Region in your
Amazon Web Services account. If an Amazon Web Services Region is not specified, the Amazon
Web Services Region where you are signed in is used.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: A non-zero, non-negative integer used to limit the number of returned
  results.
- `"nextToken"`: An enumeration token that, when provided in a request, returns the next
  batch of the results.
"""
function list_approval_rule_templates(; aws_config::AbstractAWSConfig=current_aws_config())
    return codecommit(
        "ListApprovalRuleTemplates"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_approval_rule_templates(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecommit(
        "ListApprovalRuleTemplates",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_associated_approval_rule_templates_for_repository(repository_name)
    list_associated_approval_rule_templates_for_repository(repository_name, params::Dict{String,<:Any})

Lists all approval rule templates that are associated with a specified repository.

# Arguments
- `repository_name`: The name of the repository for which you want to list all associated
  approval rule templates.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: A non-zero, non-negative integer used to limit the number of returned
  results.
- `"nextToken"`: An enumeration token that, when provided in a request, returns the next
  batch of the results.
"""
function list_associated_approval_rule_templates_for_repository(
    repositoryName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecommit(
        "ListAssociatedApprovalRuleTemplatesForRepository",
        Dict{String,Any}("repositoryName" => repositoryName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_associated_approval_rule_templates_for_repository(
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "ListAssociatedApprovalRuleTemplatesForRepository",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("repositoryName" => repositoryName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_branches(repository_name)
    list_branches(repository_name, params::Dict{String,<:Any})

Gets information about one or more branches in a repository.

# Arguments
- `repository_name`: The name of the repository that contains the branches.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: An enumeration token that allows the operation to batch the results.
"""
function list_branches(repositoryName; aws_config::AbstractAWSConfig=current_aws_config())
    return codecommit(
        "ListBranches",
        Dict{String,Any}("repositoryName" => repositoryName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_branches(
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "ListBranches",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("repositoryName" => repositoryName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_file_commit_history(file_path, repository_name)
    list_file_commit_history(file_path, repository_name, params::Dict{String,<:Any})

Retrieves a list of commits and changes to a specified file.

# Arguments
- `file_path`: The full path of the file whose history you want to retrieve, including the
  name of the file.
- `repository_name`: The name of the repository that contains the file.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"commitSpecifier"`: The fully quaified reference that identifies the commit that
  contains the file. For example, you can specify a full commit ID, a tag, a branch name, or
  a reference such as refs/heads/main. If none is provided, the head commit is used.
- `"maxResults"`: A non-zero, non-negative integer used to limit the number of returned
  results.
- `"nextToken"`: An enumeration token that allows the operation to batch the results.
"""
function list_file_commit_history(
    filePath, repositoryName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecommit(
        "ListFileCommitHistory",
        Dict{String,Any}("filePath" => filePath, "repositoryName" => repositoryName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_file_commit_history(
    filePath,
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "ListFileCommitHistory",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "filePath" => filePath, "repositoryName" => repositoryName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_pull_requests(repository_name)
    list_pull_requests(repository_name, params::Dict{String,<:Any})

Returns a list of pull requests for a specified repository. The return list can be refined
by pull request status or pull request author ARN.

# Arguments
- `repository_name`: The name of the repository for which you want to list pull requests.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"authorArn"`: Optional. The Amazon Resource Name (ARN) of the user who created the pull
  request. If used, this filters the results to pull requests created by that user.
- `"maxResults"`: A non-zero, non-negative integer used to limit the number of returned
  results.
- `"nextToken"`: An enumeration token that, when provided in a request, returns the next
  batch of the results.
- `"pullRequestStatus"`: Optional. The status of the pull request. If used, this refines
  the results to the pull requests that match the specified status.
"""
function list_pull_requests(
    repositoryName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecommit(
        "ListPullRequests",
        Dict{String,Any}("repositoryName" => repositoryName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_pull_requests(
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "ListPullRequests",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("repositoryName" => repositoryName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_repositories()
    list_repositories(params::Dict{String,<:Any})

Gets information about one or more repositories.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: An enumeration token that allows the operation to batch the results of the
  operation. Batch sizes are 1,000 for list repository operations. When the client sends the
  token back to CodeCommit, another page of 1,000 records is retrieved.
- `"order"`: The order in which to sort the results of a list repositories operation.
- `"sortBy"`: The criteria used to sort the results of a list repositories operation.
"""
function list_repositories(; aws_config::AbstractAWSConfig=current_aws_config())
    return codecommit(
        "ListRepositories"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_repositories(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecommit(
        "ListRepositories", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_repositories_for_approval_rule_template(approval_rule_template_name)
    list_repositories_for_approval_rule_template(approval_rule_template_name, params::Dict{String,<:Any})

Lists all repositories associated with the specified approval rule template.

# Arguments
- `approval_rule_template_name`: The name of the approval rule template for which you want
  to list repositories that are associated with that template.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: A non-zero, non-negative integer used to limit the number of returned
  results.
- `"nextToken"`: An enumeration token that, when provided in a request, returns the next
  batch of the results.
"""
function list_repositories_for_approval_rule_template(
    approvalRuleTemplateName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecommit(
        "ListRepositoriesForApprovalRuleTemplate",
        Dict{String,Any}("approvalRuleTemplateName" => approvalRuleTemplateName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_repositories_for_approval_rule_template(
    approvalRuleTemplateName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "ListRepositoriesForApprovalRuleTemplate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("approvalRuleTemplateName" => approvalRuleTemplateName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Gets information about Amazon Web Servicestags for a specified Amazon Resource Name (ARN)
in CodeCommit. For a list of valid resources in CodeCommit, see CodeCommit Resources and
Operations in the CodeCommit User Guide.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource for which you want to get
  information about tags, if any.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: An enumeration token that, when provided in a request, returns the next
  batch of the results.
"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecommit(
        "ListTagsForResource",
        Dict{String,Any}("resourceArn" => resourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceArn" => resourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    merge_branches_by_fast_forward(destination_commit_specifier, repository_name, source_commit_specifier)
    merge_branches_by_fast_forward(destination_commit_specifier, repository_name, source_commit_specifier, params::Dict{String,<:Any})

Merges two branches using the fast-forward merge strategy.

# Arguments
- `destination_commit_specifier`: The branch, tag, HEAD, or other fully qualified reference
  used to identify a commit (for example, a branch name or a full commit ID).
- `repository_name`: The name of the repository where you want to merge two branches.
- `source_commit_specifier`: The branch, tag, HEAD, or other fully qualified reference used
  to identify a commit (for example, a branch name or a full commit ID).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"targetBranch"`: The branch where the merge is applied.
"""
function merge_branches_by_fast_forward(
    destinationCommitSpecifier,
    repositoryName,
    sourceCommitSpecifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "MergeBranchesByFastForward",
        Dict{String,Any}(
            "destinationCommitSpecifier" => destinationCommitSpecifier,
            "repositoryName" => repositoryName,
            "sourceCommitSpecifier" => sourceCommitSpecifier,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function merge_branches_by_fast_forward(
    destinationCommitSpecifier,
    repositoryName,
    sourceCommitSpecifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "MergeBranchesByFastForward",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "destinationCommitSpecifier" => destinationCommitSpecifier,
                    "repositoryName" => repositoryName,
                    "sourceCommitSpecifier" => sourceCommitSpecifier,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    merge_branches_by_squash(destination_commit_specifier, repository_name, source_commit_specifier)
    merge_branches_by_squash(destination_commit_specifier, repository_name, source_commit_specifier, params::Dict{String,<:Any})

Merges two branches using the squash merge strategy.

# Arguments
- `destination_commit_specifier`: The branch, tag, HEAD, or other fully qualified reference
  used to identify a commit (for example, a branch name or a full commit ID).
- `repository_name`: The name of the repository where you want to merge two branches.
- `source_commit_specifier`: The branch, tag, HEAD, or other fully qualified reference used
  to identify a commit (for example, a branch name or a full commit ID).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"authorName"`: The name of the author who created the commit. This information is used
  as both the author and committer for the commit.
- `"commitMessage"`: The commit message for the merge.
- `"conflictDetailLevel"`: The level of conflict detail to use. If unspecified, the default
  FILE_LEVEL is used, which returns a not-mergeable result if the same file has differences
  in both branches. If LINE_LEVEL is specified, a conflict is considered not mergeable if the
  same file in both branches has differences on the same line.
- `"conflictResolution"`: If AUTOMERGE is the conflict resolution strategy, a list of
  inputs to use when resolving conflicts during a merge.
- `"conflictResolutionStrategy"`: Specifies which branch to use when resolving conflicts,
  or whether to attempt automatically merging two versions of a file. The default is NONE,
  which requires any conflicts to be resolved manually before the merge operation is
  successful.
- `"email"`: The email address of the person merging the branches. This information is used
  in the commit information for the merge.
- `"keepEmptyFolders"`: If the commit contains deletions, whether to keep a folder or
  folder structure if the changes leave the folders empty. If this is specified as true, a
  .gitkeep file is created for empty folders. The default is false.
- `"targetBranch"`: The branch where the merge is applied.
"""
function merge_branches_by_squash(
    destinationCommitSpecifier,
    repositoryName,
    sourceCommitSpecifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "MergeBranchesBySquash",
        Dict{String,Any}(
            "destinationCommitSpecifier" => destinationCommitSpecifier,
            "repositoryName" => repositoryName,
            "sourceCommitSpecifier" => sourceCommitSpecifier,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function merge_branches_by_squash(
    destinationCommitSpecifier,
    repositoryName,
    sourceCommitSpecifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "MergeBranchesBySquash",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "destinationCommitSpecifier" => destinationCommitSpecifier,
                    "repositoryName" => repositoryName,
                    "sourceCommitSpecifier" => sourceCommitSpecifier,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    merge_branches_by_three_way(destination_commit_specifier, repository_name, source_commit_specifier)
    merge_branches_by_three_way(destination_commit_specifier, repository_name, source_commit_specifier, params::Dict{String,<:Any})

Merges two specified branches using the three-way merge strategy.

# Arguments
- `destination_commit_specifier`: The branch, tag, HEAD, or other fully qualified reference
  used to identify a commit (for example, a branch name or a full commit ID).
- `repository_name`: The name of the repository where you want to merge two branches.
- `source_commit_specifier`: The branch, tag, HEAD, or other fully qualified reference used
  to identify a commit (for example, a branch name or a full commit ID).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"authorName"`: The name of the author who created the commit. This information is used
  as both the author and committer for the commit.
- `"commitMessage"`: The commit message to include in the commit information for the merge.
- `"conflictDetailLevel"`: The level of conflict detail to use. If unspecified, the default
  FILE_LEVEL is used, which returns a not-mergeable result if the same file has differences
  in both branches. If LINE_LEVEL is specified, a conflict is considered not mergeable if the
  same file in both branches has differences on the same line.
- `"conflictResolution"`: If AUTOMERGE is the conflict resolution strategy, a list of
  inputs to use when resolving conflicts during a merge.
- `"conflictResolutionStrategy"`: Specifies which branch to use when resolving conflicts,
  or whether to attempt automatically merging two versions of a file. The default is NONE,
  which requires any conflicts to be resolved manually before the merge operation is
  successful.
- `"email"`: The email address of the person merging the branches. This information is used
  in the commit information for the merge.
- `"keepEmptyFolders"`: If the commit contains deletions, whether to keep a folder or
  folder structure if the changes leave the folders empty. If true, a .gitkeep file is
  created for empty folders. The default is false.
- `"targetBranch"`: The branch where the merge is applied.
"""
function merge_branches_by_three_way(
    destinationCommitSpecifier,
    repositoryName,
    sourceCommitSpecifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "MergeBranchesByThreeWay",
        Dict{String,Any}(
            "destinationCommitSpecifier" => destinationCommitSpecifier,
            "repositoryName" => repositoryName,
            "sourceCommitSpecifier" => sourceCommitSpecifier,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function merge_branches_by_three_way(
    destinationCommitSpecifier,
    repositoryName,
    sourceCommitSpecifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "MergeBranchesByThreeWay",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "destinationCommitSpecifier" => destinationCommitSpecifier,
                    "repositoryName" => repositoryName,
                    "sourceCommitSpecifier" => sourceCommitSpecifier,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    merge_pull_request_by_fast_forward(pull_request_id, repository_name)
    merge_pull_request_by_fast_forward(pull_request_id, repository_name, params::Dict{String,<:Any})

Attempts to merge the source commit of a pull request into the specified destination branch
for that pull request at the specified commit using the fast-forward merge strategy. If the
merge is successful, it closes the pull request.

# Arguments
- `pull_request_id`: The system-generated ID of the pull request. To get this ID, use
  ListPullRequests.
- `repository_name`: The name of the repository where the pull request was created.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"sourceCommitId"`: The full commit ID of the original or updated commit in the pull
  request source branch. Pass this value if you want an exception thrown if the current
  commit ID of the tip of the source branch does not match this commit ID.
"""
function merge_pull_request_by_fast_forward(
    pullRequestId, repositoryName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecommit(
        "MergePullRequestByFastForward",
        Dict{String,Any}(
            "pullRequestId" => pullRequestId, "repositoryName" => repositoryName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function merge_pull_request_by_fast_forward(
    pullRequestId,
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "MergePullRequestByFastForward",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "pullRequestId" => pullRequestId, "repositoryName" => repositoryName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    merge_pull_request_by_squash(pull_request_id, repository_name)
    merge_pull_request_by_squash(pull_request_id, repository_name, params::Dict{String,<:Any})

Attempts to merge the source commit of a pull request into the specified destination branch
for that pull request at the specified commit using the squash merge strategy. If the merge
is successful, it closes the pull request.

# Arguments
- `pull_request_id`: The system-generated ID of the pull request. To get this ID, use
  ListPullRequests.
- `repository_name`: The name of the repository where the pull request was created.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"authorName"`: The name of the author who created the commit. This information is used
  as both the author and committer for the commit.
- `"commitMessage"`: The commit message to include in the commit information for the merge.
- `"conflictDetailLevel"`: The level of conflict detail to use. If unspecified, the default
  FILE_LEVEL is used, which returns a not-mergeable result if the same file has differences
  in both branches. If LINE_LEVEL is specified, a conflict is considered not mergeable if the
  same file in both branches has differences on the same line.
- `"conflictResolution"`: If AUTOMERGE is the conflict resolution strategy, a list of
  inputs to use when resolving conflicts during a merge.
- `"conflictResolutionStrategy"`: Specifies which branch to use when resolving conflicts,
  or whether to attempt automatically merging two versions of a file. The default is NONE,
  which requires any conflicts to be resolved manually before the merge operation is
  successful.
- `"email"`: The email address of the person merging the branches. This information is used
  in the commit information for the merge.
- `"keepEmptyFolders"`: If the commit contains deletions, whether to keep a folder or
  folder structure if the changes leave the folders empty. If true, a .gitkeep file is
  created for empty folders. The default is false.
- `"sourceCommitId"`: The full commit ID of the original or updated commit in the pull
  request source branch. Pass this value if you want an exception thrown if the current
  commit ID of the tip of the source branch does not match this commit ID.
"""
function merge_pull_request_by_squash(
    pullRequestId, repositoryName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecommit(
        "MergePullRequestBySquash",
        Dict{String,Any}(
            "pullRequestId" => pullRequestId, "repositoryName" => repositoryName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function merge_pull_request_by_squash(
    pullRequestId,
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "MergePullRequestBySquash",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "pullRequestId" => pullRequestId, "repositoryName" => repositoryName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    merge_pull_request_by_three_way(pull_request_id, repository_name)
    merge_pull_request_by_three_way(pull_request_id, repository_name, params::Dict{String,<:Any})

Attempts to merge the source commit of a pull request into the specified destination branch
for that pull request at the specified commit using the three-way merge strategy. If the
merge is successful, it closes the pull request.

# Arguments
- `pull_request_id`: The system-generated ID of the pull request. To get this ID, use
  ListPullRequests.
- `repository_name`: The name of the repository where the pull request was created.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"authorName"`: The name of the author who created the commit. This information is used
  as both the author and committer for the commit.
- `"commitMessage"`: The commit message to include in the commit information for the merge.
- `"conflictDetailLevel"`: The level of conflict detail to use. If unspecified, the default
  FILE_LEVEL is used, which returns a not-mergeable result if the same file has differences
  in both branches. If LINE_LEVEL is specified, a conflict is considered not mergeable if the
  same file in both branches has differences on the same line.
- `"conflictResolution"`: If AUTOMERGE is the conflict resolution strategy, a list of
  inputs to use when resolving conflicts during a merge.
- `"conflictResolutionStrategy"`: Specifies which branch to use when resolving conflicts,
  or whether to attempt automatically merging two versions of a file. The default is NONE,
  which requires any conflicts to be resolved manually before the merge operation is
  successful.
- `"email"`: The email address of the person merging the branches. This information is used
  in the commit information for the merge.
- `"keepEmptyFolders"`: If the commit contains deletions, whether to keep a folder or
  folder structure if the changes leave the folders empty. If true, a .gitkeep file is
  created for empty folders. The default is false.
- `"sourceCommitId"`: The full commit ID of the original or updated commit in the pull
  request source branch. Pass this value if you want an exception thrown if the current
  commit ID of the tip of the source branch does not match this commit ID.
"""
function merge_pull_request_by_three_way(
    pullRequestId, repositoryName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecommit(
        "MergePullRequestByThreeWay",
        Dict{String,Any}(
            "pullRequestId" => pullRequestId, "repositoryName" => repositoryName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function merge_pull_request_by_three_way(
    pullRequestId,
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "MergePullRequestByThreeWay",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "pullRequestId" => pullRequestId, "repositoryName" => repositoryName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    override_pull_request_approval_rules(override_status, pull_request_id, revision_id)
    override_pull_request_approval_rules(override_status, pull_request_id, revision_id, params::Dict{String,<:Any})

Sets aside (overrides) all approval rule requirements for a specified pull request.

# Arguments
- `override_status`: Whether you want to set aside approval rule requirements for the pull
  request (OVERRIDE) or revoke a previous override and apply approval rule requirements
  (REVOKE). REVOKE status is not stored.
- `pull_request_id`: The system-generated ID of the pull request for which you want to
  override all approval rule requirements. To get this information, use GetPullRequest.
- `revision_id`: The system-generated ID of the most recent revision of the pull request.
  You cannot override approval rules for anything but the most recent revision of a pull
  request. To get the revision ID, use GetPullRequest.

"""
function override_pull_request_approval_rules(
    overrideStatus,
    pullRequestId,
    revisionId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "OverridePullRequestApprovalRules",
        Dict{String,Any}(
            "overrideStatus" => overrideStatus,
            "pullRequestId" => pullRequestId,
            "revisionId" => revisionId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function override_pull_request_approval_rules(
    overrideStatus,
    pullRequestId,
    revisionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "OverridePullRequestApprovalRules",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "overrideStatus" => overrideStatus,
                    "pullRequestId" => pullRequestId,
                    "revisionId" => revisionId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    post_comment_for_compared_commit(after_commit_id, content, repository_name)
    post_comment_for_compared_commit(after_commit_id, content, repository_name, params::Dict{String,<:Any})

Posts a comment on the comparison between two commits.

# Arguments
- `after_commit_id`: To establish the directionality of the comparison, the full commit ID
  of the after commit.
- `content`: The content of the comment you want to make.
- `repository_name`: The name of the repository where you want to post a comment on the
  comparison between commits.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"beforeCommitId"`: To establish the directionality of the comparison, the full commit ID
  of the before commit. Required for commenting on any commit unless that commit is the
  initial commit.
- `"clientRequestToken"`: A unique, client-generated idempotency token that, when provided
  in a request, ensures the request cannot be repeated with a changed parameter. If a request
  is received with the same parameters and a token is included, the request returns
  information about the initial request that used that token.
- `"location"`: The location of the comparison where you want to comment.
"""
function post_comment_for_compared_commit(
    afterCommitId,
    content,
    repositoryName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "PostCommentForComparedCommit",
        Dict{String,Any}(
            "afterCommitId" => afterCommitId,
            "content" => content,
            "repositoryName" => repositoryName,
            "clientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function post_comment_for_compared_commit(
    afterCommitId,
    content,
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "PostCommentForComparedCommit",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "afterCommitId" => afterCommitId,
                    "content" => content,
                    "repositoryName" => repositoryName,
                    "clientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    post_comment_for_pull_request(after_commit_id, before_commit_id, content, pull_request_id, repository_name)
    post_comment_for_pull_request(after_commit_id, before_commit_id, content, pull_request_id, repository_name, params::Dict{String,<:Any})

Posts a comment on a pull request.

# Arguments
- `after_commit_id`: The full commit ID of the commit in the source branch that is the
  current tip of the branch for the pull request when you post the comment.
- `before_commit_id`: The full commit ID of the commit in the destination branch that was
  the tip of the branch at the time the pull request was created.
- `content`: The content of your comment on the change.
- `pull_request_id`: The system-generated ID of the pull request. To get this ID, use
  ListPullRequests.
- `repository_name`: The name of the repository where you want to post a comment on a pull
  request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientRequestToken"`: A unique, client-generated idempotency token that, when provided
  in a request, ensures the request cannot be repeated with a changed parameter. If a request
  is received with the same parameters and a token is included, the request returns
  information about the initial request that used that token.
- `"location"`: The location of the change where you want to post your comment. If no
  location is provided, the comment is posted as a general comment on the pull request
  difference between the before commit ID and the after commit ID.
"""
function post_comment_for_pull_request(
    afterCommitId,
    beforeCommitId,
    content,
    pullRequestId,
    repositoryName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "PostCommentForPullRequest",
        Dict{String,Any}(
            "afterCommitId" => afterCommitId,
            "beforeCommitId" => beforeCommitId,
            "content" => content,
            "pullRequestId" => pullRequestId,
            "repositoryName" => repositoryName,
            "clientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function post_comment_for_pull_request(
    afterCommitId,
    beforeCommitId,
    content,
    pullRequestId,
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "PostCommentForPullRequest",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "afterCommitId" => afterCommitId,
                    "beforeCommitId" => beforeCommitId,
                    "content" => content,
                    "pullRequestId" => pullRequestId,
                    "repositoryName" => repositoryName,
                    "clientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    post_comment_reply(content, in_reply_to)
    post_comment_reply(content, in_reply_to, params::Dict{String,<:Any})

Posts a comment in reply to an existing comment on a comparison between commits or a pull
request.

# Arguments
- `content`: The contents of your reply to a comment.
- `in_reply_to`: The system-generated ID of the comment to which you want to reply. To get
  this ID, use GetCommentsForComparedCommit or GetCommentsForPullRequest.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientRequestToken"`: A unique, client-generated idempotency token that, when provided
  in a request, ensures the request cannot be repeated with a changed parameter. If a request
  is received with the same parameters and a token is included, the request returns
  information about the initial request that used that token.
"""
function post_comment_reply(
    content, inReplyTo; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecommit(
        "PostCommentReply",
        Dict{String,Any}(
            "content" => content,
            "inReplyTo" => inReplyTo,
            "clientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function post_comment_reply(
    content,
    inReplyTo,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "PostCommentReply",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "content" => content,
                    "inReplyTo" => inReplyTo,
                    "clientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_comment_reaction(comment_id, reaction_value)
    put_comment_reaction(comment_id, reaction_value, params::Dict{String,<:Any})

Adds or updates a reaction to a specified comment for the user whose identity is used to
make the request. You can only add or update a reaction for yourself. You cannot add,
modify, or delete a reaction for another user.

# Arguments
- `comment_id`: The ID of the comment to which you want to add or update a reaction.
- `reaction_value`: The emoji reaction you want to add or update. To remove a reaction,
  provide a value of blank or null. You can also provide the value of none. For information
  about emoji reaction values supported in CodeCommit, see the CodeCommit User Guide.

"""
function put_comment_reaction(
    commentId, reactionValue; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecommit(
        "PutCommentReaction",
        Dict{String,Any}("commentId" => commentId, "reactionValue" => reactionValue);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_comment_reaction(
    commentId,
    reactionValue,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "PutCommentReaction",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "commentId" => commentId, "reactionValue" => reactionValue
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_file(branch_name, file_content, file_path, repository_name)
    put_file(branch_name, file_content, file_path, repository_name, params::Dict{String,<:Any})

Adds or updates a file in a branch in an CodeCommit repository, and generates a commit for
the addition in the specified branch.

# Arguments
- `branch_name`: The name of the branch where you want to add or update the file. If this
  is an empty repository, this branch is created.
- `file_content`: The content of the file, in binary object format.
- `file_path`: The name of the file you want to add or update, including the relative path
  to the file in the repository.  If the path does not currently exist in the repository, the
  path is created as part of adding the file.
- `repository_name`: The name of the repository where you want to add or update the file.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"commitMessage"`: A message about why this file was added or updated. Although it is
  optional, a message makes the commit history for your repository more useful.
- `"email"`: An email address for the person adding or updating the file.
- `"fileMode"`: The file mode permissions of the blob. Valid file mode permissions are
  listed here.
- `"name"`: The name of the person adding or updating the file. Although it is optional, a
  name makes the commit history for your repository more useful.
- `"parentCommitId"`: The full commit ID of the head commit in the branch where you want to
  add or update the file. If this is an empty repository, no commit ID is required. If this
  is not an empty repository, a commit ID is required.  The commit ID must match the ID of
  the head commit at the time of the operation. Otherwise, an error occurs, and the file is
  not added or updated.
"""
function put_file(
    branchName,
    fileContent,
    filePath,
    repositoryName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "PutFile",
        Dict{String,Any}(
            "branchName" => branchName,
            "fileContent" => fileContent,
            "filePath" => filePath,
            "repositoryName" => repositoryName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_file(
    branchName,
    fileContent,
    filePath,
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "PutFile",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "branchName" => branchName,
                    "fileContent" => fileContent,
                    "filePath" => filePath,
                    "repositoryName" => repositoryName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_repository_triggers(repository_name, triggers)
    put_repository_triggers(repository_name, triggers, params::Dict{String,<:Any})

Replaces all triggers for a repository. Used to create or delete triggers.

# Arguments
- `repository_name`: The name of the repository where you want to create or update the
  trigger.
- `triggers`: The JSON block of configuration information for each trigger.

"""
function put_repository_triggers(
    repositoryName, triggers; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecommit(
        "PutRepositoryTriggers",
        Dict{String,Any}("repositoryName" => repositoryName, "triggers" => triggers);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_repository_triggers(
    repositoryName,
    triggers,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "PutRepositoryTriggers",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "repositoryName" => repositoryName, "triggers" => triggers
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds or updates tags for a resource in CodeCommit. For a list of valid resources in
CodeCommit, see CodeCommit Resources and Operations in the CodeCommit User Guide.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource to which you want to add
  or update tags.
- `tags`: The key-value pair to use when tagging this repository.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return codecommit(
        "TagResource",
        Dict{String,Any}("resourceArn" => resourceArn, "tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceArn" => resourceArn, "tags" => tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    test_repository_triggers(repository_name, triggers)
    test_repository_triggers(repository_name, triggers, params::Dict{String,<:Any})

Tests the functionality of repository triggers by sending information to the trigger
target. If real data is available in the repository, the test sends data from the last
commit. If no data is available, sample data is generated.

# Arguments
- `repository_name`: The name of the repository in which to test the triggers.
- `triggers`: The list of triggers to test.

"""
function test_repository_triggers(
    repositoryName, triggers; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecommit(
        "TestRepositoryTriggers",
        Dict{String,Any}("repositoryName" => repositoryName, "triggers" => triggers);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function test_repository_triggers(
    repositoryName,
    triggers,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "TestRepositoryTriggers",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "repositoryName" => repositoryName, "triggers" => triggers
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes tags for a resource in CodeCommit. For a list of valid resources in CodeCommit, see
CodeCommit Resources and Operations in the CodeCommit User Guide.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource to which you want to
  remove tags.
- `tag_keys`: The tag key for each tag that you want to remove from the resource.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecommit(
        "UntagResource",
        Dict{String,Any}("resourceArn" => resourceArn, "tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceArn" => resourceArn, "tagKeys" => tagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_approval_rule_template_content(approval_rule_template_name, new_rule_content)
    update_approval_rule_template_content(approval_rule_template_name, new_rule_content, params::Dict{String,<:Any})

Updates the content of an approval rule template. You can change the number of required
approvals, the membership of the approval rule, and whether an approval pool is defined.

# Arguments
- `approval_rule_template_name`: The name of the approval rule template where you want to
  update the content of the rule.
- `new_rule_content`: The content that replaces the existing content of the rule. Content
  statements must be complete. You cannot provide only the changes.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"existingRuleContentSha256"`: The SHA-256 hash signature for the content of the approval
  rule. You can retrieve this information by using GetPullRequest.
"""
function update_approval_rule_template_content(
    approvalRuleTemplateName,
    newRuleContent;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "UpdateApprovalRuleTemplateContent",
        Dict{String,Any}(
            "approvalRuleTemplateName" => approvalRuleTemplateName,
            "newRuleContent" => newRuleContent,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_approval_rule_template_content(
    approvalRuleTemplateName,
    newRuleContent,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "UpdateApprovalRuleTemplateContent",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "approvalRuleTemplateName" => approvalRuleTemplateName,
                    "newRuleContent" => newRuleContent,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_approval_rule_template_description(approval_rule_template_description, approval_rule_template_name)
    update_approval_rule_template_description(approval_rule_template_description, approval_rule_template_name, params::Dict{String,<:Any})

Updates the description for a specified approval rule template.

# Arguments
- `approval_rule_template_description`: The updated description of the approval rule
  template.
- `approval_rule_template_name`: The name of the template for which you want to update the
  description.

"""
function update_approval_rule_template_description(
    approvalRuleTemplateDescription,
    approvalRuleTemplateName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "UpdateApprovalRuleTemplateDescription",
        Dict{String,Any}(
            "approvalRuleTemplateDescription" => approvalRuleTemplateDescription,
            "approvalRuleTemplateName" => approvalRuleTemplateName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_approval_rule_template_description(
    approvalRuleTemplateDescription,
    approvalRuleTemplateName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "UpdateApprovalRuleTemplateDescription",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "approvalRuleTemplateDescription" => approvalRuleTemplateDescription,
                    "approvalRuleTemplateName" => approvalRuleTemplateName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_approval_rule_template_name(new_approval_rule_template_name, old_approval_rule_template_name)
    update_approval_rule_template_name(new_approval_rule_template_name, old_approval_rule_template_name, params::Dict{String,<:Any})

Updates the name of a specified approval rule template.

# Arguments
- `new_approval_rule_template_name`: The new name you want to apply to the approval rule
  template.
- `old_approval_rule_template_name`: The current name of the approval rule template.

"""
function update_approval_rule_template_name(
    newApprovalRuleTemplateName,
    oldApprovalRuleTemplateName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "UpdateApprovalRuleTemplateName",
        Dict{String,Any}(
            "newApprovalRuleTemplateName" => newApprovalRuleTemplateName,
            "oldApprovalRuleTemplateName" => oldApprovalRuleTemplateName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_approval_rule_template_name(
    newApprovalRuleTemplateName,
    oldApprovalRuleTemplateName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "UpdateApprovalRuleTemplateName",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "newApprovalRuleTemplateName" => newApprovalRuleTemplateName,
                    "oldApprovalRuleTemplateName" => oldApprovalRuleTemplateName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_comment(comment_id, content)
    update_comment(comment_id, content, params::Dict{String,<:Any})

Replaces the contents of a comment.

# Arguments
- `comment_id`: The system-generated ID of the comment you want to update. To get this ID,
  use GetCommentsForComparedCommit or GetCommentsForPullRequest.
- `content`: The updated content to replace the existing content of the comment.

"""
function update_comment(
    commentId, content; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecommit(
        "UpdateComment",
        Dict{String,Any}("commentId" => commentId, "content" => content);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_comment(
    commentId,
    content,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "UpdateComment",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("commentId" => commentId, "content" => content),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_default_branch(default_branch_name, repository_name)
    update_default_branch(default_branch_name, repository_name, params::Dict{String,<:Any})

Sets or changes the default branch name for the specified repository.  If you use this
operation to change the default branch name to the current default branch name, a success
message is returned even though the default branch did not change.

# Arguments
- `default_branch_name`: The name of the branch to set as the default branch.
- `repository_name`: The name of the repository for which you want to set or change the
  default branch.

"""
function update_default_branch(
    defaultBranchName, repositoryName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecommit(
        "UpdateDefaultBranch",
        Dict{String,Any}(
            "defaultBranchName" => defaultBranchName, "repositoryName" => repositoryName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_default_branch(
    defaultBranchName,
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "UpdateDefaultBranch",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "defaultBranchName" => defaultBranchName,
                    "repositoryName" => repositoryName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_pull_request_approval_rule_content(approval_rule_name, new_rule_content, pull_request_id)
    update_pull_request_approval_rule_content(approval_rule_name, new_rule_content, pull_request_id, params::Dict{String,<:Any})

Updates the structure of an approval rule created specifically for a pull request. For
example, you can change the number of required approvers and the approval pool for
approvers.

# Arguments
- `approval_rule_name`: The name of the approval rule you want to update.
- `new_rule_content`: The updated content for the approval rule.  When you update the
  content of the approval rule, you can specify approvers in an approval pool in one of two
  ways:    CodeCommitApprovers: This option only requires an Amazon Web Services account and
  a resource. It can be used for both IAM users and federated access users whose name matches
  the provided resource name. This is a very powerful option that offers a great deal of
  flexibility. For example, if you specify the Amazon Web Services account 123456789012 and
  Mary_Major, all of the following are counted as approvals coming from that user:   An IAM
  user in the account (arn:aws:iam::123456789012:user/Mary_Major)   A federated user
  identified in IAM as Mary_Major (arn:aws:sts::123456789012:federated-user/Mary_Major)
  This option does not recognize an active session of someone assuming the role of
  CodeCommitReview with a role session name of Mary_Major
  (arn:aws:sts::123456789012:assumed-role/CodeCommitReview/Mary_Major) unless you include a
  wildcard (*Mary_Major).    Fully qualified ARN: This option allows you to specify the fully
  qualified Amazon Resource Name (ARN) of the IAM user or role.    For more information about
  IAM ARNs, wildcards, and formats, see IAM Identifiers in the IAM User Guide.
- `pull_request_id`: The system-generated ID of the pull request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"existingRuleContentSha256"`: The SHA-256 hash signature for the content of the approval
  rule. You can retrieve this information by using GetPullRequest.
"""
function update_pull_request_approval_rule_content(
    approvalRuleName,
    newRuleContent,
    pullRequestId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "UpdatePullRequestApprovalRuleContent",
        Dict{String,Any}(
            "approvalRuleName" => approvalRuleName,
            "newRuleContent" => newRuleContent,
            "pullRequestId" => pullRequestId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_pull_request_approval_rule_content(
    approvalRuleName,
    newRuleContent,
    pullRequestId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "UpdatePullRequestApprovalRuleContent",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "approvalRuleName" => approvalRuleName,
                    "newRuleContent" => newRuleContent,
                    "pullRequestId" => pullRequestId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_pull_request_approval_state(approval_state, pull_request_id, revision_id)
    update_pull_request_approval_state(approval_state, pull_request_id, revision_id, params::Dict{String,<:Any})

Updates the state of a user's approval on a pull request. The user is derived from the
signed-in account when the request is made.

# Arguments
- `approval_state`: The approval state to associate with the user on the pull request.
- `pull_request_id`: The system-generated ID of the pull request.
- `revision_id`: The system-generated ID of the revision.

"""
function update_pull_request_approval_state(
    approvalState,
    pullRequestId,
    revisionId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "UpdatePullRequestApprovalState",
        Dict{String,Any}(
            "approvalState" => approvalState,
            "pullRequestId" => pullRequestId,
            "revisionId" => revisionId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_pull_request_approval_state(
    approvalState,
    pullRequestId,
    revisionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "UpdatePullRequestApprovalState",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "approvalState" => approvalState,
                    "pullRequestId" => pullRequestId,
                    "revisionId" => revisionId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_pull_request_description(description, pull_request_id)
    update_pull_request_description(description, pull_request_id, params::Dict{String,<:Any})

Replaces the contents of the description of a pull request.

# Arguments
- `description`: The updated content of the description for the pull request. This content
  replaces the existing description.
- `pull_request_id`: The system-generated ID of the pull request. To get this ID, use
  ListPullRequests.

"""
function update_pull_request_description(
    description, pullRequestId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecommit(
        "UpdatePullRequestDescription",
        Dict{String,Any}("description" => description, "pullRequestId" => pullRequestId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_pull_request_description(
    description,
    pullRequestId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "UpdatePullRequestDescription",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "description" => description, "pullRequestId" => pullRequestId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_pull_request_status(pull_request_id, pull_request_status)
    update_pull_request_status(pull_request_id, pull_request_status, params::Dict{String,<:Any})

Updates the status of a pull request.

# Arguments
- `pull_request_id`: The system-generated ID of the pull request. To get this ID, use
  ListPullRequests.
- `pull_request_status`: The status of the pull request. The only valid operations are to
  update the status from OPEN to OPEN, OPEN to CLOSED or from CLOSED to CLOSED.

"""
function update_pull_request_status(
    pullRequestId, pullRequestStatus; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecommit(
        "UpdatePullRequestStatus",
        Dict{String,Any}(
            "pullRequestId" => pullRequestId, "pullRequestStatus" => pullRequestStatus
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_pull_request_status(
    pullRequestId,
    pullRequestStatus,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "UpdatePullRequestStatus",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "pullRequestId" => pullRequestId,
                    "pullRequestStatus" => pullRequestStatus,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_pull_request_title(pull_request_id, title)
    update_pull_request_title(pull_request_id, title, params::Dict{String,<:Any})

Replaces the title of a pull request.

# Arguments
- `pull_request_id`: The system-generated ID of the pull request. To get this ID, use
  ListPullRequests.
- `title`: The updated title of the pull request. This replaces the existing title.

"""
function update_pull_request_title(
    pullRequestId, title; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecommit(
        "UpdatePullRequestTitle",
        Dict{String,Any}("pullRequestId" => pullRequestId, "title" => title);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_pull_request_title(
    pullRequestId,
    title,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "UpdatePullRequestTitle",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("pullRequestId" => pullRequestId, "title" => title),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_repository_description(repository_name)
    update_repository_description(repository_name, params::Dict{String,<:Any})

Sets or changes the comment or description for a repository.  The description field for a
repository accepts all HTML characters and all valid Unicode characters. Applications that
do not HTML-encode the description and display it in a webpage can expose users to
potentially malicious code. Make sure that you HTML-encode the description field in any
application that uses this API to display the repository description on a webpage.

# Arguments
- `repository_name`: The name of the repository to set or change the comment or description
  for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"repositoryDescription"`: The new comment or description for the specified repository.
  Repository descriptions are limited to 1,000 characters.
"""
function update_repository_description(
    repositoryName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecommit(
        "UpdateRepositoryDescription",
        Dict{String,Any}("repositoryName" => repositoryName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_repository_description(
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "UpdateRepositoryDescription",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("repositoryName" => repositoryName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_repository_encryption_key(kms_key_id, repository_name)
    update_repository_encryption_key(kms_key_id, repository_name, params::Dict{String,<:Any})

Updates the Key Management Service encryption key used to encrypt and decrypt a CodeCommit
repository.

# Arguments
- `kms_key_id`: The ID of the encryption key. You can view the ID of an encryption key in
  the KMS console, or use the KMS APIs to programmatically retrieve a key ID. For more
  information about acceptable values for keyID, see KeyId in the Decrypt API description in
  the Key Management Service API Reference.
- `repository_name`: The name of the repository for which you want to update the KMS
  encryption key used to encrypt and decrypt the repository.

"""
function update_repository_encryption_key(
    kmsKeyId, repositoryName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecommit(
        "UpdateRepositoryEncryptionKey",
        Dict{String,Any}("kmsKeyId" => kmsKeyId, "repositoryName" => repositoryName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_repository_encryption_key(
    kmsKeyId,
    repositoryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "UpdateRepositoryEncryptionKey",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "kmsKeyId" => kmsKeyId, "repositoryName" => repositoryName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_repository_name(new_name, old_name)
    update_repository_name(new_name, old_name, params::Dict{String,<:Any})

Renames a repository. The repository name must be unique across the calling Amazon Web
Services account. Repository names are limited to 100 alphanumeric, dash, and underscore
characters, and cannot include certain characters. The suffix .git is prohibited. For more
information about the limits on repository names, see Quotas in the CodeCommit User Guide.

# Arguments
- `new_name`: The new name for the repository.
- `old_name`: The current name of the repository.

"""
function update_repository_name(
    newName, oldName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codecommit(
        "UpdateRepositoryName",
        Dict{String,Any}("newName" => newName, "oldName" => oldName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_repository_name(
    newName,
    oldName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codecommit(
        "UpdateRepositoryName",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("newName" => newName, "oldName" => oldName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: kinesis_video_archived_media
using AWS.Compat
using AWS.UUIDs

"""
    get_clip(clip_fragment_selector)
    get_clip(clip_fragment_selector, params::Dict{String,<:Any})

Downloads an MP4 file (clip) containing the archived, on-demand media from the specified
video stream over the specified time range.  Both the StreamName and the StreamARN
parameters are optional, but you must specify either the StreamName or the StreamARN when
invoking this API operation.  As a prerequisite to using GetCLip API, you must obtain an
endpoint using GetDataEndpoint, specifying GET_CLIP for the APIName parameter.  An Amazon
Kinesis video stream has the following requirements for providing data through MP4:   The
media must contain h.264 or h.265 encoded video and, optionally, AAC or G.711 encoded
audio. Specifically, the codec ID of track 1 should be V_MPEG/ISO/AVC (for h.264) or
V_MPEGH/ISO/HEVC (for H.265). Optionally, the codec ID of track 2 should be A_AAC (for AAC)
or A_MS/ACM (for G.711).   Data retention must be greater than 0.   The video track of each
fragment must contain codec private data in the Advanced Video Coding (AVC) for H.264
format and HEVC for H.265 format. For more information, see MPEG-4 specification ISO/IEC
14496-15. For information about adapting stream data to a given format, see NAL Adaptation
Flags.   The audio track (if present) of each fragment must contain codec private data in
the AAC format (AAC specification ISO/IEC 13818-7) or the MS Wave format.   You can monitor
the amount of outgoing data by monitoring the GetClip.OutgoingBytes Amazon CloudWatch
metric. For information about using CloudWatch to monitor Kinesis Video Streams, see
Monitoring Kinesis Video Streams. For pricing information, see Amazon Kinesis Video Streams
Pricing and  Amazon Web Services Pricing. Charges for outgoing Amazon Web Services data
apply.

# Arguments
- `clip_fragment_selector`: The time range of the requested clip and the source of the
  timestamps.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"StreamARN"`: The Amazon Resource Name (ARN) of the stream for which to retrieve the
  media clip.  You must specify either the StreamName or the StreamARN.
- `"StreamName"`: The name of the stream for which to retrieve the media clip.  You must
  specify either the StreamName or the StreamARN.
"""
function get_clip(ClipFragmentSelector; aws_config::AbstractAWSConfig=current_aws_config())
    return kinesis_video_archived_media(
        "POST",
        "/getClip",
        Dict{String,Any}("ClipFragmentSelector" => ClipFragmentSelector);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_clip(
    ClipFragmentSelector,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_video_archived_media(
        "POST",
        "/getClip",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ClipFragmentSelector" => ClipFragmentSelector),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_dashstreaming_session_url()
    get_dashstreaming_session_url(params::Dict{String,<:Any})

Retrieves an MPEG Dynamic Adaptive Streaming over HTTP (DASH) URL for the stream. You can
then open the URL in a media player to view the stream contents. Both the StreamName and
the StreamARN parameters are optional, but you must specify either the StreamName or the
StreamARN when invoking this API operation. An Amazon Kinesis video stream has the
following requirements for providing data through MPEG-DASH:   The media must contain h.264
or h.265 encoded video and, optionally, AAC or G.711 encoded audio. Specifically, the codec
ID of track 1 should be V_MPEG/ISO/AVC (for h.264) or V_MPEGH/ISO/HEVC (for H.265).
Optionally, the codec ID of track 2 should be A_AAC (for AAC) or A_MS/ACM (for G.711).
Data retention must be greater than 0.   The video track of each fragment must contain
codec private data in the Advanced Video Coding (AVC) for H.264 format and HEVC for H.265
format. For more information, see MPEG-4 specification ISO/IEC 14496-15. For information
about adapting stream data to a given format, see NAL Adaptation Flags.   The audio track
(if present) of each fragment must contain codec private data in the AAC format (AAC
specification ISO/IEC 13818-7) or the MS Wave format.   The following procedure shows how
to use MPEG-DASH with Kinesis Video Streams:   Get an endpoint using GetDataEndpoint,
specifying GET_DASH_STREAMING_SESSION_URL for the APIName parameter.   Retrieve the
MPEG-DASH URL using GetDASHStreamingSessionURL. Kinesis Video Streams creates an MPEG-DASH
streaming session to be used for accessing content in a stream using the MPEG-DASH
protocol. GetDASHStreamingSessionURL returns an authenticated URL (that includes an
encrypted session token) for the session's MPEG-DASH manifest (the root resource needed for
streaming with MPEG-DASH).  Don't share or store this token where an unauthorized entity
can access it. The token provides access to the content of the stream. Safeguard the token
with the same measures that you use with your Amazon Web Services credentials.  The media
that is made available through the manifest consists only of the requested stream, time
range, and format. No other media data (such as frames outside the requested window or
alternate bitrates) is made available.   Provide the URL (containing the encrypted session
token) for the MPEG-DASH manifest to a media player that supports the MPEG-DASH protocol.
Kinesis Video Streams makes the initialization fragment and media fragments available
through the manifest URL. The initialization fragment contains the codec private data for
the stream, and other data needed to set up the video or audio decoder and renderer. The
media fragments contain encoded video frames or encoded audio samples.   The media player
receives the authenticated URL and requests stream metadata and media data normally. When
the media player requests data, it calls the following actions:    GetDASHManifest:
Retrieves an MPEG DASH manifest, which contains the metadata for the media that you want to
playback.    GetMP4InitFragment: Retrieves the MP4 initialization fragment. The media
player typically loads the initialization fragment before loading any media fragments. This
fragment contains the \"fytp\" and \"moov\" MP4 atoms, and the child atoms that are needed
to initialize the media player decoder. The initialization fragment does not correspond to
a fragment in a Kinesis video stream. It contains only the codec private data for the
stream and respective track, which the media player needs to decode the media frames.
GetMP4MediaFragment: Retrieves MP4 media fragments. These fragments contain the \"moof\"
and \"mdat\" MP4 atoms and their child atoms, containing the encoded fragment's media
frames and their timestamps.   After the first media fragment is made available in a
streaming session, any fragments that don't contain the same codec private data cause an
error to be returned when those different media fragments are loaded. Therefore, the codec
private data should not change between fragments in a session. This also means that the
session fails if the fragments in a stream change from having only video to having both
audio and video.  Data retrieved with this action is billable. See Pricing for details.
 For restrictions that apply to MPEG-DASH sessions, see Kinesis Video Streams Limits.  You
can monitor the amount of data that the media player consumes by monitoring the
GetMP4MediaFragment.OutgoingBytes Amazon CloudWatch metric. For information about using
CloudWatch to monitor Kinesis Video Streams, see Monitoring Kinesis Video Streams. For
pricing information, see Amazon Kinesis Video Streams Pricing and Amazon Web Services
Pricing. Charges for both HLS sessions and outgoing Amazon Web Services data apply. For
more information about HLS, see HTTP Live Streaming on the Apple Developer site.  If an
error is thrown after invoking a Kinesis Video Streams archived media API, in addition to
the HTTP status code and the response body, it includes the following pieces of
information:     x-amz-ErrorType HTTP header – contains a more specific error type in
addition to what the HTTP status code provides.     x-amz-RequestId HTTP header – if you
want to report an issue to Amazon Web Services the support team can better diagnose the
problem if given the Request Id.   Both the HTTP status code and the ErrorType header can
be utilized to make programmatic decisions about whether errors are retry-able and under
what conditions, as well as provide information on what actions the client programmer might
need to take in order to successfully try again. For more information, see the Errors
section at the bottom of this topic, as well as Common Errors.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DASHFragmentSelector"`: The time range of the requested fragment and the source of the
  timestamps. This parameter is required if PlaybackMode is ON_DEMAND or LIVE_REPLAY. This
  parameter is optional if PlaybackMode is LIVE. If PlaybackMode is LIVE, the
  FragmentSelectorType can be set, but the TimestampRange should not be set. If PlaybackMode
  is ON_DEMAND or LIVE_REPLAY, both FragmentSelectorType and TimestampRange must be set.
- `"DisplayFragmentNumber"`: Fragments are identified in the manifest file based on their
  sequence number in the session. If DisplayFragmentNumber is set to ALWAYS, the Kinesis
  Video Streams fragment number is added to each S element in the manifest file with the
  attribute name “kvs:fn”. These fragment numbers can be used for logging or for use with
  other APIs (e.g. GetMedia and GetMediaForFragmentList). A custom MPEG-DASH media player is
  necessary to leverage these this custom attribute. The default value is NEVER.
- `"DisplayFragmentTimestamp"`: Per the MPEG-DASH specification, the wall-clock time of
  fragments in the manifest file can be derived using attributes in the manifest itself.
  However, typically, MPEG-DASH compatible media players do not properly handle gaps in the
  media timeline. Kinesis Video Streams adjusts the media timeline in the manifest file to
  enable playback of media with discontinuities. Therefore, the wall-clock time derived from
  the manifest file may be inaccurate. If DisplayFragmentTimestamp is set to ALWAYS, the
  accurate fragment timestamp is added to each S element in the manifest file with the
  attribute name “kvs:ts”. A custom MPEG-DASH media player is necessary to leverage this
  custom attribute. The default value is NEVER. When DASHFragmentSelector is
  SERVER_TIMESTAMP, the timestamps will be the server start timestamps. Similarly, when
  DASHFragmentSelector is PRODUCER_TIMESTAMP, the timestamps will be the producer start
  timestamps.
- `"Expires"`: The time in seconds until the requested session expires. This value can be
  between 300 (5 minutes) and 43200 (12 hours). When a session expires, no new calls to
  GetDashManifest, GetMP4InitFragment, or GetMP4MediaFragment can be made for that session.
  The default is 300 (5 minutes).
- `"MaxManifestFragmentResults"`: The maximum number of fragments that are returned in the
  MPEG-DASH manifest. When the PlaybackMode is LIVE, the most recent fragments are returned
  up to this value. When the PlaybackMode is ON_DEMAND, the oldest fragments are returned, up
  to this maximum number. When there are a higher number of fragments available in a live
  MPEG-DASH manifest, video players often buffer content before starting playback. Increasing
  the buffer size increases the playback latency, but it decreases the likelihood that
  rebuffering will occur during playback. We recommend that a live MPEG-DASH manifest have a
  minimum of 3 fragments and a maximum of 10 fragments. The default is 5 fragments if
  PlaybackMode is LIVE or LIVE_REPLAY, and 1,000 if PlaybackMode is ON_DEMAND.  The maximum
  value of 1,000 fragments corresponds to more than 16 minutes of video on streams with
  1-second fragments, and more than 2 1/2 hours of video on streams with 10-second fragments.
- `"PlaybackMode"`: Whether to retrieve live, live replay, or archived, on-demand data.
  Features of the three types of sessions include the following:     LIVE : For sessions of
  this type, the MPEG-DASH manifest is continually updated with the latest fragments as they
  become available. We recommend that the media player retrieve a new manifest on a
  one-second interval. When this type of session is played in a media player, the user
  interface typically displays a \"live\" notification, with no scrubber control for choosing
  the position in the playback window to display.  In LIVE mode, the newest available
  fragments are included in an MPEG-DASH manifest, even if there is a gap between fragments
  (that is, if a fragment is missing). A gap like this might cause a media player to halt or
  cause a jump in playback. In this mode, fragments are not added to the MPEG-DASH manifest
  if they are older than the newest fragment in the playlist. If the missing fragment becomes
  available after a subsequent fragment is added to the manifest, the older fragment is not
  added, and the gap is not filled.      LIVE_REPLAY : For sessions of this type, the
  MPEG-DASH manifest is updated similarly to how it is updated for LIVE mode except that it
  starts by including fragments from a given start time. Instead of fragments being added as
  they are ingested, fragments are added as the duration of the next fragment elapses. For
  example, if the fragments in the session are two seconds long, then a new fragment is added
  to the manifest every two seconds. This mode is useful to be able to start playback from
  when an event is detected and continue live streaming media that has not yet been ingested
  as of the time of the session creation. This mode is also useful to stream previously
  archived media without being limited by the 1,000 fragment limit in the ON_DEMAND mode.
   ON_DEMAND : For sessions of this type, the MPEG-DASH manifest contains all the fragments
  for the session, up to the number that is specified in MaxManifestFragmentResults. The
  manifest must be retrieved only once for each session. When this type of session is played
  in a media player, the user interface typically displays a scrubber control for choosing
  the position in the playback window to display.   In all playback modes, if
  FragmentSelectorType is PRODUCER_TIMESTAMP, and if there are multiple fragments with the
  same start timestamp, the fragment that has the larger fragment number (that is, the newer
  fragment) is included in the MPEG-DASH manifest. The other fragments are not included.
  Fragments that have different timestamps but have overlapping durations are still included
  in the MPEG-DASH manifest. This can lead to unexpected behavior in the media player. The
  default is LIVE.
- `"StreamARN"`: The Amazon Resource Name (ARN) of the stream for which to retrieve the
  MPEG-DASH manifest URL. You must specify either the StreamName or the StreamARN.
- `"StreamName"`: The name of the stream for which to retrieve the MPEG-DASH manifest URL.
  You must specify either the StreamName or the StreamARN.
"""
function get_dashstreaming_session_url(; aws_config::AbstractAWSConfig=current_aws_config())
    return kinesis_video_archived_media(
        "POST",
        "/getDASHStreamingSessionURL";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_dashstreaming_session_url(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_video_archived_media(
        "POST",
        "/getDASHStreamingSessionURL",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_hlsstreaming_session_url()
    get_hlsstreaming_session_url(params::Dict{String,<:Any})

Retrieves an HTTP Live Streaming (HLS) URL for the stream. You can then open the URL in a
browser or media player to view the stream contents. Both the StreamName and the StreamARN
parameters are optional, but you must specify either the StreamName or the StreamARN when
invoking this API operation. An Amazon Kinesis video stream has the following requirements
for providing data through HLS:   For streaming video, the media must contain H.264 or
H.265 encoded video and, optionally, AAC encoded audio. Specifically, the codec ID of track
1 should be V_MPEG/ISO/AVC (for H.264) or V_MPEG/ISO/HEVC (for H.265). Optionally, the
codec ID of track 2 should be A_AAC. For audio only streaming, the codec ID of track 1
should be A_AAC.   Data retention must be greater than 0.   The video track of each
fragment must contain codec private data in the Advanced Video Coding (AVC) for H.264
format or HEVC for H.265 format (MPEG-4 specification ISO/IEC 14496-15). For information
about adapting stream data to a given format, see NAL Adaptation Flags.   The audio track
(if present) of each fragment must contain codec private data in the AAC format (AAC
specification ISO/IEC 13818-7).   Kinesis Video Streams HLS sessions contain fragments in
the fragmented MPEG-4 form (also called fMP4 or CMAF) or the MPEG-2 form (also called TS
chunks, which the HLS specification also supports). For more information about HLS fragment
types, see the HLS specification. The following procedure shows how to use HLS with Kinesis
Video Streams:   Get an endpoint using GetDataEndpoint, specifying
GET_HLS_STREAMING_SESSION_URL for the APIName parameter.   Retrieve the HLS URL using
GetHLSStreamingSessionURL. Kinesis Video Streams creates an HLS streaming session to be
used for accessing content in a stream using the HLS protocol. GetHLSStreamingSessionURL
returns an authenticated URL (that includes an encrypted session token) for the session's
HLS master playlist (the root resource needed for streaming with HLS).  Don't share or
store this token where an unauthorized entity could access it. The token provides access to
the content of the stream. Safeguard the token with the same measures that you would use
with your Amazon Web Services credentials.  The media that is made available through the
playlist consists only of the requested stream, time range, and format. No other media data
(such as frames outside the requested window or alternate bitrates) is made available.
Provide the URL (containing the encrypted session token) for the HLS master playlist to a
media player that supports the HLS protocol. Kinesis Video Streams makes the HLS media
playlist, initialization fragment, and media fragments available through the master
playlist URL. The initialization fragment contains the codec private data for the stream,
and other data needed to set up the video or audio decoder and renderer. The media
fragments contain H.264-encoded video frames or AAC-encoded audio samples.   The media
player receives the authenticated URL and requests stream metadata and media data normally.
When the media player requests data, it calls the following actions:
GetHLSMasterPlaylist: Retrieves an HLS master playlist, which contains a URL for the
GetHLSMediaPlaylist action for each track, and additional metadata for the media player,
including estimated bitrate and resolution.    GetHLSMediaPlaylist: Retrieves an HLS media
playlist, which contains a URL to access the MP4 initialization fragment with the
GetMP4InitFragment action, and URLs to access the MP4 media fragments with the
GetMP4MediaFragment actions. The HLS media playlist also contains metadata about the stream
that the player needs to play it, such as whether the PlaybackMode is LIVE or ON_DEMAND.
The HLS media playlist is typically static for sessions with a PlaybackType of ON_DEMAND.
The HLS media playlist is continually updated with new fragments for sessions with a
PlaybackType of LIVE. There is a distinct HLS media playlist for the video track and the
audio track (if applicable) that contains MP4 media URLs for the specific track.
GetMP4InitFragment: Retrieves the MP4 initialization fragment. The media player typically
loads the initialization fragment before loading any media fragments. This fragment
contains the \"fytp\" and \"moov\" MP4 atoms, and the child atoms that are needed to
initialize the media player decoder. The initialization fragment does not correspond to a
fragment in a Kinesis video stream. It contains only the codec private data for the stream
and respective track, which the media player needs to decode the media frames.
GetMP4MediaFragment: Retrieves MP4 media fragments. These fragments contain the \"moof\"
and \"mdat\" MP4 atoms and their child atoms, containing the encoded fragment's media
frames and their timestamps.   For the HLS streaming session, in-track codec private data
(CPD) changes are supported. After the first media fragment is made available in a
streaming session, fragments can contain CPD changes for each track. Therefore, the
fragments in a session can have a different resolution, bit rate, or other information in
the CPD without interrupting playback. However, any change made in the track number or
track codec format can return an error when those different media fragments are loaded. For
example, streaming will fail if the fragments in the stream change from having only video
to having both audio and video, or if an AAC audio track is changed to an ALAW audio track.
For each streaming session, only 500 CPD changes are allowed.  Data retrieved with this
action is billable. For information, see Pricing.    GetTSFragment: Retrieves MPEG TS
fragments containing both initialization and media data for all tracks in the stream.  If
the ContainerFormat is MPEG_TS, this API is used instead of GetMP4InitFragment and
GetMP4MediaFragment to retrieve stream media.  Data retrieved with this action is billable.
For more information, see Kinesis Video Streams pricing.     A streaming session URL must
not be shared between players. The service might throttle a session if multiple media
players are sharing it. For connection limits, see Kinesis Video Streams Limits. You can
monitor the amount of data that the media player consumes by monitoring the
GetMP4MediaFragment.OutgoingBytes Amazon CloudWatch metric. For information about using
CloudWatch to monitor Kinesis Video Streams, see Monitoring Kinesis Video Streams. For
pricing information, see Amazon Kinesis Video Streams Pricing and Amazon Web Services
Pricing. Charges for both HLS sessions and outgoing Amazon Web Services data apply. For
more information about HLS, see HTTP Live Streaming on the Apple Developer site.  If an
error is thrown after invoking a Kinesis Video Streams archived media API, in addition to
the HTTP status code and the response body, it includes the following pieces of
information:     x-amz-ErrorType HTTP header – contains a more specific error type in
addition to what the HTTP status code provides.     x-amz-RequestId HTTP header – if you
want to report an issue to Amazon Web Services, the support team can better diagnose the
problem if given the Request Id.   Both the HTTP status code and the ErrorType header can
be utilized to make programmatic decisions about whether errors are retry-able and under
what conditions, as well as provide information on what actions the client programmer might
need to take in order to successfully try again. For more information, see the Errors
section at the bottom of this topic, as well as Common Errors.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ContainerFormat"`: Specifies which format should be used for packaging the media.
  Specifying the FRAGMENTED_MP4 container format packages the media into MP4 fragments (fMP4
  or CMAF). This is the recommended packaging because there is minimal packaging overhead.
  The other container format option is MPEG_TS. HLS has supported MPEG TS chunks since it was
  released and is sometimes the only supported packaging on older HLS players. MPEG TS
  typically has a 5-25 percent packaging overhead. This means MPEG TS typically requires 5-25
  percent more bandwidth and cost than fMP4. The default is FRAGMENTED_MP4.
- `"DiscontinuityMode"`: Specifies when flags marking discontinuities between fragments are
  added to the media playlists. Media players typically build a timeline of media content to
  play, based on the timestamps of each fragment. This means that if there is any overlap or
  gap between fragments (as is typical if HLSFragmentSelector is set to SERVER_TIMESTAMP),
  the media player timeline will also have small gaps between fragments in some places, and
  will overwrite frames in other places. Gaps in the media player timeline can cause playback
  to stall and overlaps can cause playback to be jittery. When there are discontinuity flags
  between fragments, the media player is expected to reset the timeline, resulting in the
  next fragment being played immediately after the previous fragment.  The following modes
  are supported:    ALWAYS: a discontinuity marker is placed between every fragment in the
  HLS media playlist. It is recommended to use a value of ALWAYS if the fragment timestamps
  are not accurate.    NEVER: no discontinuity markers are placed anywhere. It is recommended
  to use a value of NEVER to ensure the media player timeline most accurately maps to the
  producer timestamps.     ON_DISCONTINUITY: a discontinuity marker is placed between
  fragments that have a gap or overlap of more than 50 milliseconds. For most playback
  scenarios, it is recommended to use a value of ON_DISCONTINUITY so that the media player
  timeline is only reset when there is a significant issue with the media timeline (e.g. a
  missing fragment).   The default is ALWAYS when HLSFragmentSelector is set to
  SERVER_TIMESTAMP, and NEVER when it is set to PRODUCER_TIMESTAMP.
- `"DisplayFragmentTimestamp"`: Specifies when the fragment start timestamps should be
  included in the HLS media playlist. Typically, media players report the playhead position
  as a time relative to the start of the first fragment in the playback session. However,
  when the start timestamps are included in the HLS media playlist, some media players might
  report the current playhead as an absolute time based on the fragment timestamps. This can
  be useful for creating a playback experience that shows viewers the wall-clock time of the
  media. The default is NEVER. When HLSFragmentSelector is SERVER_TIMESTAMP, the timestamps
  will be the server start timestamps. Similarly, when HLSFragmentSelector is
  PRODUCER_TIMESTAMP, the timestamps will be the producer start timestamps.
- `"Expires"`: The time in seconds until the requested session expires. This value can be
  between 300 (5 minutes) and 43200 (12 hours). When a session expires, no new calls to
  GetHLSMasterPlaylist, GetHLSMediaPlaylist, GetMP4InitFragment, GetMP4MediaFragment, or
  GetTSFragment can be made for that session. The default is 300 (5 minutes).
- `"HLSFragmentSelector"`: The time range of the requested fragment and the source of the
  timestamps. This parameter is required if PlaybackMode is ON_DEMAND or LIVE_REPLAY. This
  parameter is optional if PlaybackMode is LIVE. If PlaybackMode is LIVE, the
  FragmentSelectorType can be set, but the TimestampRange should not be set. If PlaybackMode
  is ON_DEMAND or LIVE_REPLAY, both FragmentSelectorType and TimestampRange must be set.
- `"MaxMediaPlaylistFragmentResults"`: The maximum number of fragments that are returned in
  the HLS media playlists. When the PlaybackMode is LIVE, the most recent fragments are
  returned up to this value. When the PlaybackMode is ON_DEMAND, the oldest fragments are
  returned, up to this maximum number. When there are a higher number of fragments available
  in a live HLS media playlist, video players often buffer content before starting playback.
  Increasing the buffer size increases the playback latency, but it decreases the likelihood
  that rebuffering will occur during playback. We recommend that a live HLS media playlist
  have a minimum of 3 fragments and a maximum of 10 fragments. The default is 5 fragments if
  PlaybackMode is LIVE or LIVE_REPLAY, and 1,000 if PlaybackMode is ON_DEMAND.  The maximum
  value of 5,000 fragments corresponds to more than 80 minutes of video on streams with
  1-second fragments, and more than 13 hours of video on streams with 10-second fragments.
- `"PlaybackMode"`: Whether to retrieve live, live replay, or archived, on-demand data.
  Features of the three types of sessions include the following:     LIVE : For sessions of
  this type, the HLS media playlist is continually updated with the latest fragments as they
  become available. We recommend that the media player retrieve a new playlist on a
  one-second interval. When this type of session is played in a media player, the user
  interface typically displays a \"live\" notification, with no scrubber control for choosing
  the position in the playback window to display.  In LIVE mode, the newest available
  fragments are included in an HLS media playlist, even if there is a gap between fragments
  (that is, if a fragment is missing). A gap like this might cause a media player to halt or
  cause a jump in playback. In this mode, fragments are not added to the HLS media playlist
  if they are older than the newest fragment in the playlist. If the missing fragment becomes
  available after a subsequent fragment is added to the playlist, the older fragment is not
  added, and the gap is not filled.      LIVE_REPLAY : For sessions of this type, the HLS
  media playlist is updated similarly to how it is updated for LIVE mode except that it
  starts by including fragments from a given start time. Instead of fragments being added as
  they are ingested, fragments are added as the duration of the next fragment elapses. For
  example, if the fragments in the session are two seconds long, then a new fragment is added
  to the media playlist every two seconds. This mode is useful to be able to start playback
  from when an event is detected and continue live streaming media that has not yet been
  ingested as of the time of the session creation. This mode is also useful to stream
  previously archived media without being limited by the 1,000 fragment limit in the
  ON_DEMAND mode.      ON_DEMAND : For sessions of this type, the HLS media playlist contains
  all the fragments for the session, up to the number that is specified in
  MaxMediaPlaylistFragmentResults. The playlist must be retrieved only once for each session.
  When this type of session is played in a media player, the user interface typically
  displays a scrubber control for choosing the position in the playback window to display.
  In all playback modes, if FragmentSelectorType is PRODUCER_TIMESTAMP, and if there are
  multiple fragments with the same start timestamp, the fragment that has the largest
  fragment number (that is, the newest fragment) is included in the HLS media playlist. The
  other fragments are not included. Fragments that have different timestamps but have
  overlapping durations are still included in the HLS media playlist. This can lead to
  unexpected behavior in the media player. The default is LIVE.
- `"StreamARN"`: The Amazon Resource Name (ARN) of the stream for which to retrieve the HLS
  master playlist URL. You must specify either the StreamName or the StreamARN.
- `"StreamName"`: The name of the stream for which to retrieve the HLS master playlist URL.
  You must specify either the StreamName or the StreamARN.
"""
function get_hlsstreaming_session_url(; aws_config::AbstractAWSConfig=current_aws_config())
    return kinesis_video_archived_media(
        "POST",
        "/getHLSStreamingSessionURL";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_hlsstreaming_session_url(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_video_archived_media(
        "POST",
        "/getHLSStreamingSessionURL",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_images(end_timestamp, format, image_selector_type, start_timestamp)
    get_images(end_timestamp, format, image_selector_type, start_timestamp, params::Dict{String,<:Any})

Retrieves a list of images corresponding to each timestamp for a given time range, sampling
interval, and image format configuration.

# Arguments
- `end_timestamp`: The end timestamp for the range of images to be generated. If the time
  range between StartTimestamp and EndTimestamp is more than 300 seconds above
  StartTimestamp, you will receive an IllegalArgumentException.
- `format`: The format that will be used to encode the image.
- `image_selector_type`: The origin of the Server or Producer timestamps to use to generate
  the images.
- `start_timestamp`: The starting point from which the images should be generated. This
  StartTimestamp must be within an inclusive range of timestamps for an image to be returned.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FormatConfig"`: The list of a key-value pair structure that contains extra parameters
  that can be applied when the image is generated. The FormatConfig key is the JPEGQuality,
  which indicates the JPEG quality key to be used to generate the image. The FormatConfig
  value accepts ints from 1 to 100. If the value is 1, the image will be generated with less
  quality and the best compression. If the value is 100, the image will be generated with the
  best quality and less compression. If no value is provided, the default value of the
  JPEGQuality key will be set to 80.
- `"HeightPixels"`: The height of the output image that is used in conjunction with the
  WidthPixels parameter. When both HeightPixels and WidthPixels parameters are provided, the
  image will be stretched to fit the specified aspect ratio. If only the HeightPixels
  parameter is provided, its original aspect ratio will be used to calculate the WidthPixels
  ratio. If neither parameter is provided, the original image size will be returned.
- `"MaxResults"`: The maximum number of images to be returned by the API.   The default
  limit is 25 images per API response. Providing a MaxResults greater than this value will
  result in a page size of 25. Any additional results will be paginated.
- `"NextToken"`: A token that specifies where to start paginating the next set of Images.
  This is the GetImages:NextToken from a previously truncated response.
- `"SamplingInterval"`: The time interval in milliseconds (ms) at which the images need to
  be generated from the stream. The minimum value that can be provided is 200 ms (5 images
  per second). If the timestamp range is less than the sampling interval, the image from the
  startTimestamp will be returned if available.
- `"StreamARN"`: The Amazon Resource Name (ARN) of the stream from which to retrieve the
  images. You must specify either the StreamName or the StreamARN.
- `"StreamName"`: The name of the stream from which to retrieve the images. You must
  specify either the StreamName or the StreamARN.
- `"WidthPixels"`: The width of the output image that is used in conjunction with the
  HeightPixels parameter. When both WidthPixels and HeightPixels parameters are provided, the
  image will be stretched to fit the specified aspect ratio. If only the WidthPixels
  parameter is provided or if only the HeightPixels is provided, a ValidationException will
  be thrown. If neither parameter is provided, the original image size from the stream will
  be returned.
"""
function get_images(
    EndTimestamp,
    Format,
    ImageSelectorType,
    StartTimestamp;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_video_archived_media(
        "POST",
        "/getImages",
        Dict{String,Any}(
            "EndTimestamp" => EndTimestamp,
            "Format" => Format,
            "ImageSelectorType" => ImageSelectorType,
            "StartTimestamp" => StartTimestamp,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_images(
    EndTimestamp,
    Format,
    ImageSelectorType,
    StartTimestamp,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_video_archived_media(
        "POST",
        "/getImages",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EndTimestamp" => EndTimestamp,
                    "Format" => Format,
                    "ImageSelectorType" => ImageSelectorType,
                    "StartTimestamp" => StartTimestamp,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_media_for_fragment_list(fragments)
    get_media_for_fragment_list(fragments, params::Dict{String,<:Any})

Gets media for a list of fragments (specified by fragment number) from the archived data in
an Amazon Kinesis video stream.  You must first call the GetDataEndpoint API to get an
endpoint. Then send the GetMediaForFragmentList requests to this endpoint using the
--endpoint-url parameter.   For limits, see Kinesis Video Streams Limits.  If an error is
thrown after invoking a Kinesis Video Streams archived media API, in addition to the HTTP
status code and the response body, it includes the following pieces of information:
x-amz-ErrorType HTTP header – contains a more specific error type in addition to what the
HTTP status code provides.     x-amz-RequestId HTTP header – if you want to report an
issue to Amazon Web Services, the support team can better diagnose the problem if given the
Request Id.   Both the HTTP status code and the ErrorType header can be utilized to make
programmatic decisions about whether errors are retry-able and under what conditions, as
well as provide information on what actions the client programmer might need to take in
order to successfully try again. For more information, see the Errors section at the bottom
of this topic, as well as Common Errors.

# Arguments
- `fragments`: A list of the numbers of fragments for which to retrieve media. You retrieve
  these values with ListFragments.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"StreamARN"`: The Amazon Resource Name (ARN) of the stream from which to retrieve
  fragment media. Specify either this parameter or the StreamName parameter.
- `"StreamName"`: The name of the stream from which to retrieve fragment media. Specify
  either this parameter or the StreamARN parameter.
"""
function get_media_for_fragment_list(
    Fragments; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_video_archived_media(
        "POST",
        "/getMediaForFragmentList",
        Dict{String,Any}("Fragments" => Fragments);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_media_for_fragment_list(
    Fragments,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_video_archived_media(
        "POST",
        "/getMediaForFragmentList",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Fragments" => Fragments), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_fragments()
    list_fragments(params::Dict{String,<:Any})

Returns a list of Fragment objects from the specified stream and timestamp range within the
archived data. Listing fragments is eventually consistent. This means that even if the
producer receives an acknowledgment that a fragment is persisted, the result might not be
returned immediately from a request to ListFragments. However, results are typically
available in less than one second.  You must first call the GetDataEndpoint API to get an
endpoint. Then send the ListFragments requests to this endpoint using the --endpoint-url
parameter.    If an error is thrown after invoking a Kinesis Video Streams archived media
API, in addition to the HTTP status code and the response body, it includes the following
pieces of information:     x-amz-ErrorType HTTP header – contains a more specific error
type in addition to what the HTTP status code provides.     x-amz-RequestId HTTP header –
if you want to report an issue to Amazon Web Services, the support team can better diagnose
the problem if given the Request Id.   Both the HTTP status code and the ErrorType header
can be utilized to make programmatic decisions about whether errors are retry-able and
under what conditions, as well as provide information on what actions the client programmer
might need to take in order to successfully try again. For more information, see the Errors
section at the bottom of this topic, as well as Common Errors.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FragmentSelector"`: Describes the timestamp range and timestamp origin for the range of
  fragments to return.  This is only required when the NextToken isn't passed in the API.
- `"MaxResults"`: The total number of fragments to return. If the total number of fragments
  available is more than the value specified in max-results, then a
  ListFragmentsOutputNextToken is provided in the output that you can use to resume
  pagination.
- `"NextToken"`: A token to specify where to start paginating. This is the
  ListFragmentsOutputNextToken from a previously truncated response.
- `"StreamARN"`: The Amazon Resource Name (ARN) of the stream from which to retrieve a
  fragment list. Specify either this parameter or the StreamName parameter.
- `"StreamName"`: The name of the stream from which to retrieve a fragment list. Specify
  either this parameter or the StreamARN parameter.
"""
function list_fragments(; aws_config::AbstractAWSConfig=current_aws_config())
    return kinesis_video_archived_media(
        "POST", "/listFragments"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_fragments(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_video_archived_media(
        "POST",
        "/listFragments",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: applicationcostprofiler
using AWS.Compat
using AWS.UUIDs

"""
    delete_report_definition(report_id)
    delete_report_definition(report_id, params::Dict{String,<:Any})

Deletes the specified report definition in AWS Application Cost Profiler. This stops the
report from being generated.

# Arguments
- `report_id`: Required. ID of the report to delete.

"""
function delete_report_definition(
    reportId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return applicationcostprofiler(
        "DELETE",
        "/reportDefinition/$(reportId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_report_definition(
    reportId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return applicationcostprofiler(
        "DELETE",
        "/reportDefinition/$(reportId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_report_definition(report_id)
    get_report_definition(report_id, params::Dict{String,<:Any})

Retrieves the definition of a report already configured in AWS Application Cost Profiler.

# Arguments
- `report_id`: ID of the report to retrieve.

"""
function get_report_definition(reportId; aws_config::AbstractAWSConfig=current_aws_config())
    return applicationcostprofiler(
        "GET",
        "/reportDefinition/$(reportId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_report_definition(
    reportId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return applicationcostprofiler(
        "GET",
        "/reportDefinition/$(reportId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    import_application_usage(source_s3_location)
    import_application_usage(source_s3_location, params::Dict{String,<:Any})

Ingests application usage data from Amazon Simple Storage Service (Amazon S3). The data
must already exist in the S3 location. As part of the action, AWS Application Cost Profiler
copies the object from your S3 bucket to an S3 bucket owned by Amazon for processing
asynchronously.

# Arguments
- `source_s3_location`: Amazon S3 location to import application usage data from.

"""
function import_application_usage(
    sourceS3Location; aws_config::AbstractAWSConfig=current_aws_config()
)
    return applicationcostprofiler(
        "POST",
        "/importApplicationUsage",
        Dict{String,Any}("sourceS3Location" => sourceS3Location);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function import_application_usage(
    sourceS3Location,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return applicationcostprofiler(
        "POST",
        "/importApplicationUsage",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("sourceS3Location" => sourceS3Location), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_report_definitions()
    list_report_definitions(params::Dict{String,<:Any})

Retrieves a list of all reports and their configurations for your AWS account. The maximum
number of reports is one.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return.
- `"nextToken"`: The token value from a previous call to access the next page of results.
"""
function list_report_definitions(; aws_config::AbstractAWSConfig=current_aws_config())
    return applicationcostprofiler(
        "GET", "/reportDefinition"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_report_definitions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return applicationcostprofiler(
        "GET",
        "/reportDefinition",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_report_definition(destination_s3_location, format, report_description, report_frequency, report_id)
    put_report_definition(destination_s3_location, format, report_description, report_frequency, report_id, params::Dict{String,<:Any})

Creates the report definition for a report in Application Cost Profiler.

# Arguments
- `destination_s3_location`: Required. Amazon Simple Storage Service (Amazon S3) location
  where Application Cost Profiler uploads the report.
- `format`: Required. The format to use for the generated report.
- `report_description`: Required. Description of the report.
- `report_frequency`: Required. The cadence to generate the report.
- `report_id`: Required. ID of the report. You can choose any valid string matching the
  pattern for the ID.

"""
function put_report_definition(
    destinationS3Location,
    format,
    reportDescription,
    reportFrequency,
    reportId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return applicationcostprofiler(
        "POST",
        "/reportDefinition",
        Dict{String,Any}(
            "destinationS3Location" => destinationS3Location,
            "format" => format,
            "reportDescription" => reportDescription,
            "reportFrequency" => reportFrequency,
            "reportId" => reportId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_report_definition(
    destinationS3Location,
    format,
    reportDescription,
    reportFrequency,
    reportId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return applicationcostprofiler(
        "POST",
        "/reportDefinition",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "destinationS3Location" => destinationS3Location,
                    "format" => format,
                    "reportDescription" => reportDescription,
                    "reportFrequency" => reportFrequency,
                    "reportId" => reportId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_report_definition(destination_s3_location, format, report_description, report_frequency, report_id)
    update_report_definition(destination_s3_location, format, report_description, report_frequency, report_id, params::Dict{String,<:Any})

Updates existing report in AWS Application Cost Profiler.

# Arguments
- `destination_s3_location`: Required. Amazon Simple Storage Service (Amazon S3) location
  where Application Cost Profiler uploads the report.
- `format`: Required. The format to use for the generated report.
- `report_description`: Required. Description of the report.
- `report_frequency`: Required. The cadence to generate the report.
- `report_id`: Required. ID of the report to update.

"""
function update_report_definition(
    destinationS3Location,
    format,
    reportDescription,
    reportFrequency,
    reportId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return applicationcostprofiler(
        "PUT",
        "/reportDefinition/$(reportId)",
        Dict{String,Any}(
            "destinationS3Location" => destinationS3Location,
            "format" => format,
            "reportDescription" => reportDescription,
            "reportFrequency" => reportFrequency,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_report_definition(
    destinationS3Location,
    format,
    reportDescription,
    reportFrequency,
    reportId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return applicationcostprofiler(
        "PUT",
        "/reportDefinition/$(reportId)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "destinationS3Location" => destinationS3Location,
                    "format" => format,
                    "reportDescription" => reportDescription,
                    "reportFrequency" => reportFrequency,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: dynamodb_streams
using AWS.Compat
using AWS.UUIDs

"""
    describe_stream(stream_arn)
    describe_stream(stream_arn, params::Dict{String,<:Any})

Returns information about a stream, including the current status of the stream, its Amazon
Resource Name (ARN), the composition of its shards, and its corresponding DynamoDB table.
You can call DescribeStream at a maximum rate of 10 times per second.  Each shard in the
stream has a SequenceNumberRange associated with it. If the SequenceNumberRange has a
StartingSequenceNumber but no EndingSequenceNumber, then the shard is still open (able to
receive more stream records). If both StartingSequenceNumber and EndingSequenceNumber are
present, then that shard is closed and can no longer receive more data.

# Arguments
- `stream_arn`: The Amazon Resource Name (ARN) for the stream.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ExclusiveStartShardId"`: The shard ID of the first item that this operation will
  evaluate. Use the value that was returned for LastEvaluatedShardId in the previous
  operation.
- `"Limit"`: The maximum number of shard objects to return. The upper limit is 100.
"""
function describe_stream(StreamArn; aws_config::AbstractAWSConfig=current_aws_config())
    return dynamodb_streams(
        "DescribeStream",
        Dict{String,Any}("StreamArn" => StreamArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_stream(
    StreamArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dynamodb_streams(
        "DescribeStream",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("StreamArn" => StreamArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_records(shard_iterator)
    get_records(shard_iterator, params::Dict{String,<:Any})

Retrieves the stream records from a given shard. Specify a shard iterator using the
ShardIterator parameter. The shard iterator specifies the position in the shard from which
you want to start reading stream records sequentially. If there are no stream records
available in the portion of the shard that the iterator points to, GetRecords returns an
empty list. Note that it might take multiple calls to get to a portion of the shard that
contains stream records.   GetRecords can retrieve a maximum of 1 MB of data or 1000 stream
records, whichever comes first.

# Arguments
- `shard_iterator`: A shard iterator that was retrieved from a previous GetShardIterator
  operation. This iterator can be used to access the stream records in this shard.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: The maximum number of records to return from the shard. The upper limit is
  1000.
"""
function get_records(ShardIterator; aws_config::AbstractAWSConfig=current_aws_config())
    return dynamodb_streams(
        "GetRecords",
        Dict{String,Any}("ShardIterator" => ShardIterator);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_records(
    ShardIterator,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dynamodb_streams(
        "GetRecords",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ShardIterator" => ShardIterator), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_shard_iterator(shard_id, shard_iterator_type, stream_arn)
    get_shard_iterator(shard_id, shard_iterator_type, stream_arn, params::Dict{String,<:Any})

Returns a shard iterator. A shard iterator provides information about how to retrieve the
stream records from within a shard. Use the shard iterator in a subsequent GetRecords
request to read the stream records from the shard.  A shard iterator expires 15 minutes
after it is returned to the requester.

# Arguments
- `shard_id`: The identifier of the shard. The iterator will be returned for this shard ID.
- `shard_iterator_type`: Determines how the shard iterator is used to start reading stream
  records from the shard:    AT_SEQUENCE_NUMBER - Start reading exactly from the position
  denoted by a specific sequence number.    AFTER_SEQUENCE_NUMBER - Start reading right after
  the position denoted by a specific sequence number.    TRIM_HORIZON - Start reading at the
  last (untrimmed) stream record, which is the oldest record in the shard. In DynamoDB
  Streams, there is a 24 hour limit on data retention. Stream records whose age exceeds this
  limit are subject to removal (trimming) from the stream.    LATEST - Start reading just
  after the most recent stream record in the shard, so that you always read the most recent
  data in the shard.
- `stream_arn`: The Amazon Resource Name (ARN) for the stream.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"SequenceNumber"`: The sequence number of a stream record in the shard from which to
  start reading.
"""
function get_shard_iterator(
    ShardId,
    ShardIteratorType,
    StreamArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dynamodb_streams(
        "GetShardIterator",
        Dict{String,Any}(
            "ShardId" => ShardId,
            "ShardIteratorType" => ShardIteratorType,
            "StreamArn" => StreamArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_shard_iterator(
    ShardId,
    ShardIteratorType,
    StreamArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return dynamodb_streams(
        "GetShardIterator",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ShardId" => ShardId,
                    "ShardIteratorType" => ShardIteratorType,
                    "StreamArn" => StreamArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_streams()
    list_streams(params::Dict{String,<:Any})

Returns an array of stream ARNs associated with the current account and endpoint. If the
TableName parameter is present, then ListStreams will return only the streams ARNs for that
table.  You can call ListStreams at a maximum rate of 5 times per second.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ExclusiveStartStreamArn"`: The ARN (Amazon Resource Name) of the first item that this
  operation will evaluate. Use the value that was returned for LastEvaluatedStreamArn in the
  previous operation.
- `"Limit"`: The maximum number of streams to return. The upper limit is 100.
- `"TableName"`: If this parameter is provided, then only the streams associated with this
  table name are returned.
"""
function list_streams(; aws_config::AbstractAWSConfig=current_aws_config())
    return dynamodb_streams(
        "ListStreams"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_streams(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return dynamodb_streams(
        "ListStreams", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: ec2_instance_connect
using AWS.Compat
using AWS.UUIDs

"""
    send_serial_console_sshpublic_key(instance_id, sshpublic_key)
    send_serial_console_sshpublic_key(instance_id, sshpublic_key, params::Dict{String,<:Any})

Pushes an SSH public key to the specified EC2 instance. The key remains for 60 seconds,
which gives you 60 seconds to establish a serial console connection to the instance using
SSH. For more information, see EC2 Serial Console in the Amazon EC2 User Guide.

# Arguments
- `instance_id`: The ID of the EC2 instance.
- `sshpublic_key`: The public key material. To use the public key, you must have the
  matching private key. For information about the supported key formats and lengths, see
  Requirements for key pairs in the Amazon EC2 User Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"SerialPort"`: The serial port of the EC2 instance. Currently only port 0 is supported.
  Default: 0
"""
function send_serial_console_sshpublic_key(
    InstanceId, SSHPublicKey; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ec2_instance_connect(
        "SendSerialConsoleSSHPublicKey",
        Dict{String,Any}("InstanceId" => InstanceId, "SSHPublicKey" => SSHPublicKey);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function send_serial_console_sshpublic_key(
    InstanceId,
    SSHPublicKey,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ec2_instance_connect(
        "SendSerialConsoleSSHPublicKey",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "InstanceId" => InstanceId, "SSHPublicKey" => SSHPublicKey
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    send_sshpublic_key(instance_id, instance_osuser, sshpublic_key)
    send_sshpublic_key(instance_id, instance_osuser, sshpublic_key, params::Dict{String,<:Any})

Pushes an SSH public key to the specified EC2 instance for use by the specified user. The
key remains for 60 seconds. For more information, see Connect to your Linux instance using
EC2 Instance Connect in the Amazon EC2 User Guide.

# Arguments
- `instance_id`: The ID of the EC2 instance.
- `instance_osuser`: The OS user on the EC2 instance for whom the key can be used to
  authenticate.
- `sshpublic_key`: The public key material. To use the public key, you must have the
  matching private key.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AvailabilityZone"`: The Availability Zone in which the EC2 instance was launched.
"""
function send_sshpublic_key(
    InstanceId,
    InstanceOSUser,
    SSHPublicKey;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ec2_instance_connect(
        "SendSSHPublicKey",
        Dict{String,Any}(
            "InstanceId" => InstanceId,
            "InstanceOSUser" => InstanceOSUser,
            "SSHPublicKey" => SSHPublicKey,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function send_sshpublic_key(
    InstanceId,
    InstanceOSUser,
    SSHPublicKey,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ec2_instance_connect(
        "SendSSHPublicKey",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "InstanceId" => InstanceId,
                    "InstanceOSUser" => InstanceOSUser,
                    "SSHPublicKey" => SSHPublicKey,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: transfer
using AWS.Compat
using AWS.UUIDs

"""
    create_access(external_id, role, server_id)
    create_access(external_id, role, server_id, params::Dict{String,<:Any})

Used by administrators to choose which groups in the directory should have access to upload
and download files over the enabled protocols using Transfer Family. For example, a
Microsoft Active Directory might contain 50,000 users, but only a small fraction might need
the ability to transfer files to the server. An administrator can use CreateAccess to limit
the access to the correct set of users who need this ability.

# Arguments
- `external_id`: A unique identifier that is required to identify specific groups within
  your directory. The users of the group that you associate have access to your Amazon S3 or
  Amazon EFS resources over the enabled protocols using Transfer Family. If you know the
  group name, you can view the SID values by running the following command using Windows
  PowerShell.  Get-ADGroup -Filter {samAccountName -like \"YourGroupName*\"} -Properties * |
  Select SamAccountName,ObjectSid  In that command, replace YourGroupName with the name of
  your Active Directory group. The regular expression used to validate this parameter is a
  string of characters consisting of uppercase and lowercase alphanumeric characters with no
  spaces. You can also include underscores or any of the following characters: =,.@:/-
- `role`: The Amazon Resource Name (ARN) of the Identity and Access Management (IAM) role
  that controls your users' access to your Amazon S3 bucket or Amazon EFS file system. The
  policies attached to this role determine the level of access that you want to provide your
  users when transferring files into and out of your Amazon S3 bucket or Amazon EFS file
  system. The IAM role should also contain a trust relationship that allows the server to
  access your resources when servicing your users' transfer requests.
- `server_id`: A system-assigned unique identifier for a server instance. This is the
  specific server that you added your user to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"HomeDirectory"`: The landing directory (folder) for a user when they log in to the
  server using the client. A HomeDirectory example is /bucket_name/home/mydirectory.  The
  HomeDirectory parameter is only used if HomeDirectoryType is set to PATH.
- `"HomeDirectoryMappings"`: Logical directory mappings that specify what Amazon S3 or
  Amazon EFS paths and keys should be visible to your user and how you want to make them
  visible. You must specify the Entry and Target pair, where Entry shows how the path is made
  visible and Target is the actual Amazon S3 or Amazon EFS path. If you only specify a
  target, it is displayed as is. You also must ensure that your Identity and Access
  Management (IAM) role provides access to paths in Target. This value can be set only when
  HomeDirectoryType is set to LOGICAL. The following is an Entry and Target pair example.  [
  { \"Entry\": \"/directory1\", \"Target\": \"/bucket_name/home/mydirectory\" } ]  In most
  cases, you can use this value instead of the session policy to lock down your user to the
  designated home directory (\"chroot\"). To do this, you can set Entry to / and set Target
  to the HomeDirectory parameter value. The following is an Entry and Target pair example for
  chroot.  [ { \"Entry\": \"/\", \"Target\": \"/bucket_name/home/mydirectory\" } ]
- `"HomeDirectoryType"`: The type of landing directory (folder) that you want your users'
  home directory to be when they log in to the server. If you set it to PATH, the user will
  see the absolute Amazon S3 bucket or Amazon EFS path as is in their file transfer protocol
  clients. If you set it to LOGICAL, you need to provide mappings in the
  HomeDirectoryMappings for how you want to make Amazon S3 or Amazon EFS paths visible to
  your users.  If HomeDirectoryType is LOGICAL, you must provide mappings, using the
  HomeDirectoryMappings parameter. If, on the other hand, HomeDirectoryType is PATH, you
  provide an absolute path using the HomeDirectory parameter. You cannot have both
  HomeDirectory and HomeDirectoryMappings in your template.
- `"Policy"`: A session policy for your user so that you can use the same Identity and
  Access Management (IAM) role across multiple users. This policy scopes down a user's access
  to portions of their Amazon S3 bucket. Variables that you can use inside this policy
  include {Transfer:UserName}, {Transfer:HomeDirectory}, and {Transfer:HomeBucket}.  This
  policy applies only when the domain of ServerId is Amazon S3. Amazon EFS does not use
  session policies. For session policies, Transfer Family stores the policy as a JSON blob,
  instead of the Amazon Resource Name (ARN) of the policy. You save the policy as a JSON blob
  and pass it in the Policy argument. For an example of a session policy, see Example session
  policy. For more information, see AssumeRole in the Security Token Service API Reference.
- `"PosixProfile"`:
"""
function create_access(
    ExternalId, Role, ServerId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transfer(
        "CreateAccess",
        Dict{String,Any}(
            "ExternalId" => ExternalId, "Role" => Role, "ServerId" => ServerId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_access(
    ExternalId,
    Role,
    ServerId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transfer(
        "CreateAccess",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ExternalId" => ExternalId, "Role" => Role, "ServerId" => ServerId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_agreement(access_role, base_directory, local_profile_id, partner_profile_id, server_id)
    create_agreement(access_role, base_directory, local_profile_id, partner_profile_id, server_id, params::Dict{String,<:Any})

Creates an agreement. An agreement is a bilateral trading partner agreement, or
partnership, between an Transfer Family server and an AS2 process. The agreement defines
the file and message transfer relationship between the server and the AS2 process. To
define an agreement, Transfer Family combines a server, local profile, partner profile,
certificate, and other attributes. The partner is identified with the PartnerProfileId, and
the AS2 process is identified with the LocalProfileId.

# Arguments
- `access_role`: Connectors are used to send files using either the AS2 or SFTP protocol.
  For the access role, provide the Amazon Resource Name (ARN) of the Identity and Access
  Management role to use.  For AS2 connectors  With AS2, you can send files by calling
  StartFileTransfer and specifying the file paths in the request parameter, SendFilePaths. We
  use the file’s parent directory (for example, for --send-file-paths /bucket/dir/file.txt,
  parent directory is /bucket/dir/) to temporarily store a processed AS2 message file, store
  the MDN when we receive them from the partner, and write a final JSON file containing
  relevant metadata of the transmission. So, the AccessRole needs to provide read and write
  access to the parent directory of the file location used in the StartFileTransfer request.
  Additionally, you need to provide read and write access to the parent directory of the
  files that you intend to send with StartFileTransfer. If you are using Basic authentication
  for your AS2 connector, the access role requires the secretsmanager:GetSecretValue
  permission for the secret. If the secret is encrypted using a customer-managed key instead
  of the Amazon Web Services managed key in Secrets Manager, then the role also needs the
  kms:Decrypt permission for that key.  For SFTP connectors  Make sure that the access role
  provides read and write access to the parent directory of the file location that's used in
  the StartFileTransfer request. Additionally, make sure that the role provides
  secretsmanager:GetSecretValue permission to Secrets Manager.
- `base_directory`: The landing directory (folder) for files transferred by using the AS2
  protocol. A BaseDirectory example is /DOC-EXAMPLE-BUCKET/home/mydirectory.
- `local_profile_id`: A unique identifier for the AS2 local profile.
- `partner_profile_id`: A unique identifier for the partner profile used in the agreement.
- `server_id`: A system-assigned unique identifier for a server instance. This is the
  specific server that the agreement uses.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A name or short description to identify the agreement.
- `"Status"`: The status of the agreement. The agreement can be either ACTIVE or INACTIVE.
- `"Tags"`: Key-value pairs that can be used to group and search for agreements.
"""
function create_agreement(
    AccessRole,
    BaseDirectory,
    LocalProfileId,
    PartnerProfileId,
    ServerId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transfer(
        "CreateAgreement",
        Dict{String,Any}(
            "AccessRole" => AccessRole,
            "BaseDirectory" => BaseDirectory,
            "LocalProfileId" => LocalProfileId,
            "PartnerProfileId" => PartnerProfileId,
            "ServerId" => ServerId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_agreement(
    AccessRole,
    BaseDirectory,
    LocalProfileId,
    PartnerProfileId,
    ServerId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transfer(
        "CreateAgreement",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AccessRole" => AccessRole,
                    "BaseDirectory" => BaseDirectory,
                    "LocalProfileId" => LocalProfileId,
                    "PartnerProfileId" => PartnerProfileId,
                    "ServerId" => ServerId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_connector(access_role, url)
    create_connector(access_role, url, params::Dict{String,<:Any})

Creates the connector, which captures the parameters for a connection for the AS2 or SFTP
protocol. For AS2, the connector is required for sending files to an externally hosted AS2
server. For SFTP, the connector is required when sending files to an SFTP server or
receiving files from an SFTP server. For more details about connectors, see Configure AS2
connectors and Create SFTP connectors.  You must specify exactly one configuration object:
either for AS2 (As2Config) or SFTP (SftpConfig).

# Arguments
- `access_role`: Connectors are used to send files using either the AS2 or SFTP protocol.
  For the access role, provide the Amazon Resource Name (ARN) of the Identity and Access
  Management role to use.  For AS2 connectors  With AS2, you can send files by calling
  StartFileTransfer and specifying the file paths in the request parameter, SendFilePaths. We
  use the file’s parent directory (for example, for --send-file-paths /bucket/dir/file.txt,
  parent directory is /bucket/dir/) to temporarily store a processed AS2 message file, store
  the MDN when we receive them from the partner, and write a final JSON file containing
  relevant metadata of the transmission. So, the AccessRole needs to provide read and write
  access to the parent directory of the file location used in the StartFileTransfer request.
  Additionally, you need to provide read and write access to the parent directory of the
  files that you intend to send with StartFileTransfer. If you are using Basic authentication
  for your AS2 connector, the access role requires the secretsmanager:GetSecretValue
  permission for the secret. If the secret is encrypted using a customer-managed key instead
  of the Amazon Web Services managed key in Secrets Manager, then the role also needs the
  kms:Decrypt permission for that key.  For SFTP connectors  Make sure that the access role
  provides read and write access to the parent directory of the file location that's used in
  the StartFileTransfer request. Additionally, make sure that the role provides
  secretsmanager:GetSecretValue permission to Secrets Manager.
- `url`: The URL of the partner's AS2 or SFTP endpoint.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"As2Config"`: A structure that contains the parameters for an AS2 connector object.
- `"LoggingRole"`: The Amazon Resource Name (ARN) of the Identity and Access Management
  (IAM) role that allows a connector to turn on CloudWatch logging for Amazon S3 events. When
  set, you can view connector activity in your CloudWatch logs.
- `"SecurityPolicyName"`: Specifies the name of the security policy for the connector.
- `"SftpConfig"`: A structure that contains the parameters for an SFTP connector object.
- `"Tags"`: Key-value pairs that can be used to group and search for connectors. Tags are
  metadata attached to connectors for any purpose.
"""
function create_connector(
    AccessRole, Url; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transfer(
        "CreateConnector",
        Dict{String,Any}("AccessRole" => AccessRole, "Url" => Url);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_connector(
    AccessRole,
    Url,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transfer(
        "CreateConnector",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("AccessRole" => AccessRole, "Url" => Url), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_profile(as2_id, profile_type)
    create_profile(as2_id, profile_type, params::Dict{String,<:Any})

Creates the local or partner profile to use for AS2 transfers.

# Arguments
- `as2_id`: The As2Id is the AS2-name, as defined in the RFC 4130. For inbound transfers,
  this is the AS2-From header for the AS2 messages sent from the partner. For outbound
  connectors, this is the AS2-To header for the AS2 messages sent to the partner using the
  StartFileTransfer API operation. This ID cannot include spaces.
- `profile_type`: Determines the type of profile to create:   Specify LOCAL to create a
  local profile. A local profile represents the AS2-enabled Transfer Family server
  organization or party.   Specify PARTNER to create a partner profile. A partner profile
  represents a remote organization, external to Transfer Family.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CertificateIds"`: An array of identifiers for the imported certificates. You use this
  identifier for working with profiles and partner profiles.
- `"Tags"`: Key-value pairs that can be used to group and search for AS2 profiles.
"""
function create_profile(
    As2Id, ProfileType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transfer(
        "CreateProfile",
        Dict{String,Any}("As2Id" => As2Id, "ProfileType" => ProfileType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_profile(
    As2Id,
    ProfileType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transfer(
        "CreateProfile",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("As2Id" => As2Id, "ProfileType" => ProfileType),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_server()
    create_server(params::Dict{String,<:Any})

Instantiates an auto-scaling virtual server based on the selected file transfer protocol in
Amazon Web Services. When you make updates to your file transfer protocol-enabled server or
when you work with users, use the service-generated ServerId property that is assigned to
the newly created server.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Certificate"`: The Amazon Resource Name (ARN) of the Certificate Manager (ACM)
  certificate. Required when Protocols is set to FTPS. To request a new public certificate,
  see Request a public certificate in the Certificate Manager User Guide. To import an
  existing certificate into ACM, see Importing certificates into ACM in the Certificate
  Manager User Guide. To request a private certificate to use FTPS through private IP
  addresses, see Request a private certificate in the Certificate Manager User Guide.
  Certificates with the following cryptographic algorithms and key sizes are supported:
  2048-bit RSA (RSA_2048)   4096-bit RSA (RSA_4096)   Elliptic Prime Curve 256 bit
  (EC_prime256v1)   Elliptic Prime Curve 384 bit (EC_secp384r1)   Elliptic Prime Curve 521
  bit (EC_secp521r1)    The certificate must be a valid SSL/TLS X.509 version 3 certificate
  with FQDN or IP address specified and information about the issuer.
- `"Domain"`: The domain of the storage system that is used for file transfers. There are
  two domains available: Amazon Simple Storage Service (Amazon S3) and Amazon Elastic File
  System (Amazon EFS). The default value is S3.  After the server is created, the domain
  cannot be changed.
- `"EndpointDetails"`: The virtual private cloud (VPC) endpoint settings that are
  configured for your server. When you host your endpoint within your VPC, you can make your
  endpoint accessible only to resources within your VPC, or you can attach Elastic IP
  addresses and make your endpoint accessible to clients over the internet. Your VPC's
  default security groups are automatically assigned to your endpoint.
- `"EndpointType"`: The type of endpoint that you want your server to use. You can choose
  to make your server's endpoint publicly accessible (PUBLIC) or host it inside your VPC.
  With an endpoint that is hosted in a VPC, you can restrict access to your server and
  resources only within your VPC or choose to make it internet facing by attaching Elastic IP
  addresses directly to it.   After May 19, 2021, you won't be able to create a server using
  EndpointType=VPC_ENDPOINT in your Amazon Web Services account if your account hasn't
  already done so before May 19, 2021. If you have already created servers with
  EndpointType=VPC_ENDPOINT in your Amazon Web Services account on or before May 19, 2021,
  you will not be affected. After this date, use EndpointType=VPC. For more information, see
  https://docs.aws.amazon.com/transfer/latest/userguide/create-server-in-vpc.html#deprecate-vp
  c-endpoint. It is recommended that you use VPC as the EndpointType. With this endpoint
  type, you have the option to directly associate up to three Elastic IPv4 addresses (BYO IP
  included) with your server's endpoint and use VPC security groups to restrict traffic by
  the client's public IP address. This is not possible with EndpointType set to VPC_ENDPOINT.
- `"HostKey"`: The RSA, ECDSA, or ED25519 private key to use for your SFTP-enabled server.
  You can add multiple host keys, in case you want to rotate keys, or have a set of active
  keys that use different algorithms. Use the following command to generate an RSA 2048 bit
  key with no passphrase:  ssh-keygen -t rsa -b 2048 -N \"\" -m PEM -f my-new-server-key. Use
  a minimum value of 2048 for the -b option. You can create a stronger key by using 3072 or
  4096. Use the following command to generate an ECDSA 256 bit key with no passphrase:
  ssh-keygen -t ecdsa -b 256 -N \"\" -m PEM -f my-new-server-key. Valid values for the -b
  option for ECDSA are 256, 384, and 521. Use the following command to generate an ED25519
  key with no passphrase:  ssh-keygen -t ed25519 -N \"\" -f my-new-server-key. For all of
  these commands, you can replace my-new-server-key with a string of your choice.  If you
  aren't planning to migrate existing users from an existing SFTP-enabled server to a new
  server, don't update the host key. Accidentally changing a server's host key can be
  disruptive.  For more information, see Manage host keys for your SFTP-enabled server in the
  Transfer Family User Guide.
- `"IdentityProviderDetails"`: Required when IdentityProviderType is set to
  AWS_DIRECTORY_SERVICE, Amazon Web Services_LAMBDA or API_GATEWAY. Accepts an array
  containing all of the information required to use a directory in AWS_DIRECTORY_SERVICE or
  invoke a customer-supplied authentication API, including the API Gateway URL. Not required
  when IdentityProviderType is set to SERVICE_MANAGED.
- `"IdentityProviderType"`: The mode of authentication for a server. The default value is
  SERVICE_MANAGED, which allows you to store and access user credentials within the Transfer
  Family service. Use AWS_DIRECTORY_SERVICE to provide access to Active Directory groups in
  Directory Service for Microsoft Active Directory or Microsoft Active Directory in your
  on-premises environment or in Amazon Web Services using AD Connector. This option also
  requires you to provide a Directory ID by using the IdentityProviderDetails parameter. Use
  the API_GATEWAY value to integrate with an identity provider of your choosing. The
  API_GATEWAY setting requires you to provide an Amazon API Gateway endpoint URL to call for
  authentication by using the IdentityProviderDetails parameter. Use the AWS_LAMBDA value to
  directly use an Lambda function as your identity provider. If you choose this value, you
  must specify the ARN for the Lambda function in the Function parameter for the
  IdentityProviderDetails data type.
- `"LoggingRole"`: The Amazon Resource Name (ARN) of the Identity and Access Management
  (IAM) role that allows a server to turn on Amazon CloudWatch logging for Amazon S3 or
  Amazon EFSevents. When set, you can view user activity in your CloudWatch logs.
- `"PostAuthenticationLoginBanner"`: Specifies a string to display when users connect to a
  server. This string is displayed after the user authenticates.  The SFTP protocol does not
  support post-authentication display banners.
- `"PreAuthenticationLoginBanner"`: Specifies a string to display when users connect to a
  server. This string is displayed before the user authenticates. For example, the following
  banner displays details about using the system:  This system is for the use of authorized
  users only. Individuals using this computer system without authority, or in excess of their
  authority, are subject to having all of their activities on this system monitored and
  recorded by system personnel.
- `"ProtocolDetails"`: The protocol settings that are configured for your server.    To
  indicate passive mode (for FTP and FTPS protocols), use the PassiveIp parameter. Enter a
  single dotted-quad IPv4 address, such as the external IP address of a firewall, router, or
  load balancer.    To ignore the error that is generated when the client attempts to use the
  SETSTAT command on a file that you are uploading to an Amazon S3 bucket, use the
  SetStatOption parameter. To have the Transfer Family server ignore the SETSTAT command and
  upload files without needing to make any changes to your SFTP client, set the value to
  ENABLE_NO_OP. If you set the SetStatOption parameter to ENABLE_NO_OP, Transfer Family
  generates a log entry to Amazon CloudWatch Logs, so that you can determine when the client
  is making a SETSTAT call.   To determine whether your Transfer Family server resumes
  recent, negotiated sessions through a unique session ID, use the TlsSessionResumptionMode
  parameter.    As2Transports indicates the transport method for the AS2 messages. Currently,
  only HTTP is supported.
- `"Protocols"`: Specifies the file transfer protocol or protocols over which your file
  transfer protocol client can connect to your server's endpoint. The available protocols
  are:    SFTP (Secure Shell (SSH) File Transfer Protocol): File transfer over SSH    FTPS
  (File Transfer Protocol Secure): File transfer with TLS encryption    FTP (File Transfer
  Protocol): Unencrypted file transfer    AS2 (Applicability Statement 2): used for
  transporting structured business-to-business data      If you select FTPS, you must choose
  a certificate stored in Certificate Manager (ACM) which is used to identify your server
  when clients connect to it over FTPS.   If Protocol includes either FTP or FTPS, then the
  EndpointType must be VPC and the IdentityProviderType must be either AWS_DIRECTORY_SERVICE,
  AWS_LAMBDA, or API_GATEWAY.   If Protocol includes FTP, then AddressAllocationIds cannot be
  associated.   If Protocol is set only to SFTP, the EndpointType can be set to PUBLIC and
  the IdentityProviderType can be set any of the supported identity types: SERVICE_MANAGED,
  AWS_DIRECTORY_SERVICE, AWS_LAMBDA, or API_GATEWAY.   If Protocol includes AS2, then the
  EndpointType must be VPC, and domain must be Amazon S3.
- `"S3StorageOptions"`: Specifies whether or not performance for your Amazon S3 directories
  is optimized. This is disabled by default. By default, home directory mappings have a TYPE
  of DIRECTORY. If you enable this option, you would then need to explicitly set the
  HomeDirectoryMapEntry Type to FILE if you want a mapping to have a file target.
- `"SecurityPolicyName"`: Specifies the name of the security policy for the server.
- `"StructuredLogDestinations"`: Specifies the log groups to which your server logs are
  sent. To specify a log group, you must provide the ARN for an existing log group. In this
  case, the format of the log group is as follows:
  arn:aws:logs:region-name:amazon-account-id:log-group:log-group-name:*  For example,
  arn:aws:logs:us-east-1:111122223333:log-group:mytestgroup:*  If you have previously
  specified a log group for a server, you can clear it, and in effect turn off structured
  logging, by providing an empty value for this parameter in an update-server call. For
  example:  update-server --server-id s-1234567890abcdef0 --structured-log-destinations
- `"Tags"`: Key-value pairs that can be used to group and search for servers.
- `"WorkflowDetails"`: Specifies the workflow ID for the workflow to assign and the
  execution role that's used for executing the workflow. In addition to a workflow to execute
  when a file is uploaded completely, WorkflowDetails can also contain a workflow ID (and
  execution role) for a workflow to execute on partial upload. A partial upload occurs when
  the server session disconnects while the file is still being uploaded.
"""
function create_server(; aws_config::AbstractAWSConfig=current_aws_config())
    return transfer("CreateServer"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function create_server(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transfer(
        "CreateServer", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    create_user(role, server_id, user_name)
    create_user(role, server_id, user_name, params::Dict{String,<:Any})

Creates a user and associates them with an existing file transfer protocol-enabled server.
You can only create and associate users with servers that have the IdentityProviderType set
to SERVICE_MANAGED. Using parameters for CreateUser, you can specify the user name, set the
home directory, store the user's public key, and assign the user's Identity and Access
Management (IAM) role. You can also optionally add a session policy, and assign metadata
with tags that can be used to group and search for users.

# Arguments
- `role`: The Amazon Resource Name (ARN) of the Identity and Access Management (IAM) role
  that controls your users' access to your Amazon S3 bucket or Amazon EFS file system. The
  policies attached to this role determine the level of access that you want to provide your
  users when transferring files into and out of your Amazon S3 bucket or Amazon EFS file
  system. The IAM role should also contain a trust relationship that allows the server to
  access your resources when servicing your users' transfer requests.
- `server_id`: A system-assigned unique identifier for a server instance. This is the
  specific server that you added your user to.
- `user_name`: A unique string that identifies a user and is associated with a ServerId.
  This user name must be a minimum of 3 and a maximum of 100 characters long. The following
  are valid characters: a-z, A-Z, 0-9, underscore '_', hyphen '-', period '.', and at sign
  '@'. The user name can't start with a hyphen, period, or at sign.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"HomeDirectory"`: The landing directory (folder) for a user when they log in to the
  server using the client. A HomeDirectory example is /bucket_name/home/mydirectory.  The
  HomeDirectory parameter is only used if HomeDirectoryType is set to PATH.
- `"HomeDirectoryMappings"`: Logical directory mappings that specify what Amazon S3 or
  Amazon EFS paths and keys should be visible to your user and how you want to make them
  visible. You must specify the Entry and Target pair, where Entry shows how the path is made
  visible and Target is the actual Amazon S3 or Amazon EFS path. If you only specify a
  target, it is displayed as is. You also must ensure that your Identity and Access
  Management (IAM) role provides access to paths in Target. This value can be set only when
  HomeDirectoryType is set to LOGICAL. The following is an Entry and Target pair example.  [
  { \"Entry\": \"/directory1\", \"Target\": \"/bucket_name/home/mydirectory\" } ]  In most
  cases, you can use this value instead of the session policy to lock your user down to the
  designated home directory (\"chroot\"). To do this, you can set Entry to / and set Target
  to the value the user should see for their home directory when they log in. The following
  is an Entry and Target pair example for chroot.  [ { \"Entry\": \"/\", \"Target\":
  \"/bucket_name/home/mydirectory\" } ]
- `"HomeDirectoryType"`: The type of landing directory (folder) that you want your users'
  home directory to be when they log in to the server. If you set it to PATH, the user will
  see the absolute Amazon S3 bucket or Amazon EFS path as is in their file transfer protocol
  clients. If you set it to LOGICAL, you need to provide mappings in the
  HomeDirectoryMappings for how you want to make Amazon S3 or Amazon EFS paths visible to
  your users.  If HomeDirectoryType is LOGICAL, you must provide mappings, using the
  HomeDirectoryMappings parameter. If, on the other hand, HomeDirectoryType is PATH, you
  provide an absolute path using the HomeDirectory parameter. You cannot have both
  HomeDirectory and HomeDirectoryMappings in your template.
- `"Policy"`: A session policy for your user so that you can use the same Identity and
  Access Management (IAM) role across multiple users. This policy scopes down a user's access
  to portions of their Amazon S3 bucket. Variables that you can use inside this policy
  include {Transfer:UserName}, {Transfer:HomeDirectory}, and {Transfer:HomeBucket}.  This
  policy applies only when the domain of ServerId is Amazon S3. Amazon EFS does not use
  session policies. For session policies, Transfer Family stores the policy as a JSON blob,
  instead of the Amazon Resource Name (ARN) of the policy. You save the policy as a JSON blob
  and pass it in the Policy argument. For an example of a session policy, see Example session
  policy. For more information, see AssumeRole in the Amazon Web Services Security Token
  Service API Reference.
- `"PosixProfile"`: Specifies the full POSIX identity, including user ID (Uid), group ID
  (Gid), and any secondary groups IDs (SecondaryGids), that controls your users' access to
  your Amazon EFS file systems. The POSIX permissions that are set on files and directories
  in Amazon EFS determine the level of access your users get when transferring files into and
  out of your Amazon EFS file systems.
- `"SshPublicKeyBody"`: The public portion of the Secure Shell (SSH) key used to
  authenticate the user to the server. The three standard SSH public key format elements are
  &lt;key type&gt;, &lt;body base64&gt;, and an optional &lt;comment&gt;, with spaces between
  each element. Transfer Family accepts RSA, ECDSA, and ED25519 keys.   For RSA keys, the key
  type is ssh-rsa.   For ED25519 keys, the key type is ssh-ed25519.   For ECDSA keys, the key
  type is either ecdsa-sha2-nistp256, ecdsa-sha2-nistp384, or ecdsa-sha2-nistp521, depending
  on the size of the key you generated.
- `"Tags"`: Key-value pairs that can be used to group and search for users. Tags are
  metadata attached to users for any purpose.
"""
function create_user(
    Role, ServerId, UserName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transfer(
        "CreateUser",
        Dict{String,Any}("Role" => Role, "ServerId" => ServerId, "UserName" => UserName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_user(
    Role,
    ServerId,
    UserName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transfer(
        "CreateUser",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Role" => Role, "ServerId" => ServerId, "UserName" => UserName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_workflow(steps)
    create_workflow(steps, params::Dict{String,<:Any})

 Allows you to create a workflow with specified steps and step details the workflow invokes
after file transfer completes. After creating a workflow, you can associate the workflow
created with any transfer servers by specifying the workflow-details field in CreateServer
and UpdateServer operations.

# Arguments
- `steps`: Specifies the details for the steps that are in the specified workflow.  The
  TYPE specifies which of the following actions is being taken for this step.      COPY  -
  Copy the file to another location.     CUSTOM  - Perform a custom step with an Lambda
  function target.     DECRYPT  - Decrypt a file that was encrypted before it was uploaded.
    DELETE  - Delete the file.     TAG  - Add a tag to the file.     Currently, copying and
  tagging are supported only on S3.    For file location, you specify either the Amazon S3
  bucket and key, or the Amazon EFS file system ID and path.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A textual description for the workflow.
- `"OnExceptionSteps"`: Specifies the steps (actions) to take if errors are encountered
  during execution of the workflow.  For custom steps, the Lambda function needs to send
  FAILURE to the call back API to kick off the exception steps. Additionally, if the Lambda
  does not send SUCCESS before it times out, the exception steps are executed.
- `"Tags"`: Key-value pairs that can be used to group and search for workflows. Tags are
  metadata attached to workflows for any purpose.
"""
function create_workflow(Steps; aws_config::AbstractAWSConfig=current_aws_config())
    return transfer(
        "CreateWorkflow",
        Dict{String,Any}("Steps" => Steps);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_workflow(
    Steps, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transfer(
        "CreateWorkflow",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Steps" => Steps), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_access(external_id, server_id)
    delete_access(external_id, server_id, params::Dict{String,<:Any})

Allows you to delete the access specified in the ServerID and ExternalID parameters.

# Arguments
- `external_id`: A unique identifier that is required to identify specific groups within
  your directory. The users of the group that you associate have access to your Amazon S3 or
  Amazon EFS resources over the enabled protocols using Transfer Family. If you know the
  group name, you can view the SID values by running the following command using Windows
  PowerShell.  Get-ADGroup -Filter {samAccountName -like \"YourGroupName*\"} -Properties * |
  Select SamAccountName,ObjectSid  In that command, replace YourGroupName with the name of
  your Active Directory group. The regular expression used to validate this parameter is a
  string of characters consisting of uppercase and lowercase alphanumeric characters with no
  spaces. You can also include underscores or any of the following characters: =,.@:/-
- `server_id`: A system-assigned unique identifier for a server that has this user assigned.

"""
function delete_access(
    ExternalId, ServerId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transfer(
        "DeleteAccess",
        Dict{String,Any}("ExternalId" => ExternalId, "ServerId" => ServerId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_access(
    ExternalId,
    ServerId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transfer(
        "DeleteAccess",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ExternalId" => ExternalId, "ServerId" => ServerId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_agreement(agreement_id, server_id)
    delete_agreement(agreement_id, server_id, params::Dict{String,<:Any})

Delete the agreement that's specified in the provided AgreementId.

# Arguments
- `agreement_id`: A unique identifier for the agreement. This identifier is returned when
  you create an agreement.
- `server_id`: The server identifier associated with the agreement that you are deleting.

"""
function delete_agreement(
    AgreementId, ServerId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transfer(
        "DeleteAgreement",
        Dict{String,Any}("AgreementId" => AgreementId, "ServerId" => ServerId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_agreement(
    AgreementId,
    ServerId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transfer(
        "DeleteAgreement",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("AgreementId" => AgreementId, "ServerId" => ServerId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_certificate(certificate_id)
    delete_certificate(certificate_id, params::Dict{String,<:Any})

Deletes the certificate that's specified in the CertificateId parameter.

# Arguments
- `certificate_id`: The identifier of the certificate object that you are deleting.

"""
function delete_certificate(
    CertificateId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transfer(
        "DeleteCertificate",
        Dict{String,Any}("CertificateId" => CertificateId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_certificate(
    CertificateId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transfer(
        "DeleteCertificate",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("CertificateId" => CertificateId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_connector(connector_id)
    delete_connector(connector_id, params::Dict{String,<:Any})

Deletes the connector that's specified in the provided ConnectorId.

# Arguments
- `connector_id`: The unique identifier for the connector.

"""
function delete_connector(ConnectorId; aws_config::AbstractAWSConfig=current_aws_config())
    return transfer(
        "DeleteConnector",
        Dict{String,Any}("ConnectorId" => ConnectorId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_connector(
    ConnectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transfer(
        "DeleteConnector",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ConnectorId" => ConnectorId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_host_key(host_key_id, server_id)
    delete_host_key(host_key_id, server_id, params::Dict{String,<:Any})

Deletes the host key that's specified in the HostKeyId parameter.

# Arguments
- `host_key_id`: The identifier of the host key that you are deleting.
- `server_id`: The identifier of the server that contains the host key that you are
  deleting.

"""
function delete_host_key(
    HostKeyId, ServerId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transfer(
        "DeleteHostKey",
        Dict{String,Any}("HostKeyId" => HostKeyId, "ServerId" => ServerId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_host_key(
    HostKeyId,
    ServerId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transfer(
        "DeleteHostKey",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("HostKeyId" => HostKeyId, "ServerId" => ServerId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_profile(profile_id)
    delete_profile(profile_id, params::Dict{String,<:Any})

Deletes the profile that's specified in the ProfileId parameter.

# Arguments
- `profile_id`: The identifier of the profile that you are deleting.

"""
function delete_profile(ProfileId; aws_config::AbstractAWSConfig=current_aws_config())
    return transfer(
        "DeleteProfile",
        Dict{String,Any}("ProfileId" => ProfileId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_profile(
    ProfileId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transfer(
        "DeleteProfile",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ProfileId" => ProfileId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_server(server_id)
    delete_server(server_id, params::Dict{String,<:Any})

Deletes the file transfer protocol-enabled server that you specify. No response returns
from this operation.

# Arguments
- `server_id`: A unique system-assigned identifier for a server instance.

"""
function delete_server(ServerId; aws_config::AbstractAWSConfig=current_aws_config())
    return transfer(
        "DeleteServer",
        Dict{String,Any}("ServerId" => ServerId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_server(
    ServerId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transfer(
        "DeleteServer",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ServerId" => ServerId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_ssh_public_key(server_id, ssh_public_key_id, user_name)
    delete_ssh_public_key(server_id, ssh_public_key_id, user_name, params::Dict{String,<:Any})

Deletes a user's Secure Shell (SSH) public key.

# Arguments
- `server_id`: A system-assigned unique identifier for a file transfer protocol-enabled
  server instance that has the user assigned to it.
- `ssh_public_key_id`: A unique identifier used to reference your user's specific SSH key.
- `user_name`: A unique string that identifies a user whose public key is being deleted.

"""
function delete_ssh_public_key(
    ServerId, SshPublicKeyId, UserName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transfer(
        "DeleteSshPublicKey",
        Dict{String,Any}(
            "ServerId" => ServerId,
            "SshPublicKeyId" => SshPublicKeyId,
            "UserName" => UserName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_ssh_public_key(
    ServerId,
    SshPublicKeyId,
    UserName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transfer(
        "DeleteSshPublicKey",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ServerId" => ServerId,
                    "SshPublicKeyId" => SshPublicKeyId,
                    "UserName" => UserName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_user(server_id, user_name)
    delete_user(server_id, user_name, params::Dict{String,<:Any})

Deletes the user belonging to a file transfer protocol-enabled server you specify. No
response returns from this operation.  When you delete a user from a server, the user's
information is lost.

# Arguments
- `server_id`: A system-assigned unique identifier for a server instance that has the user
  assigned to it.
- `user_name`: A unique string that identifies a user that is being deleted from a server.

"""
function delete_user(ServerId, UserName; aws_config::AbstractAWSConfig=current_aws_config())
    return transfer(
        "DeleteUser",
        Dict{String,Any}("ServerId" => ServerId, "UserName" => UserName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_user(
    ServerId,
    UserName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transfer(
        "DeleteUser",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ServerId" => ServerId, "UserName" => UserName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_workflow(workflow_id)
    delete_workflow(workflow_id, params::Dict{String,<:Any})

Deletes the specified workflow.

# Arguments
- `workflow_id`: A unique identifier for the workflow.

"""
function delete_workflow(WorkflowId; aws_config::AbstractAWSConfig=current_aws_config())
    return transfer(
        "DeleteWorkflow",
        Dict{String,Any}("WorkflowId" => WorkflowId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_workflow(
    WorkflowId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transfer(
        "DeleteWorkflow",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("WorkflowId" => WorkflowId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_access(external_id, server_id)
    describe_access(external_id, server_id, params::Dict{String,<:Any})

Describes the access that is assigned to the specific file transfer protocol-enabled
server, as identified by its ServerId property and its ExternalId. The response from this
call returns the properties of the access that is associated with the ServerId value that
was specified.

# Arguments
- `external_id`: A unique identifier that is required to identify specific groups within
  your directory. The users of the group that you associate have access to your Amazon S3 or
  Amazon EFS resources over the enabled protocols using Transfer Family. If you know the
  group name, you can view the SID values by running the following command using Windows
  PowerShell.  Get-ADGroup -Filter {samAccountName -like \"YourGroupName*\"} -Properties * |
  Select SamAccountName,ObjectSid  In that command, replace YourGroupName with the name of
  your Active Directory group. The regular expression used to validate this parameter is a
  string of characters consisting of uppercase and lowercase alphanumeric characters with no
  spaces. You can also include underscores or any of the following characters: =,.@:/-
- `server_id`: A system-assigned unique identifier for a server that has this access
  assigned.

"""
function describe_access(
    ExternalId, ServerId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transfer(
        "DescribeAccess",
        Dict{String,Any}("ExternalId" => ExternalId, "ServerId" => ServerId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_access(
    ExternalId,
    ServerId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transfer(
        "DescribeAccess",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ExternalId" => ExternalId, "ServerId" => ServerId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_agreement(agreement_id, server_id)
    describe_agreement(agreement_id, server_id, params::Dict{String,<:Any})

Describes the agreement that's identified by the AgreementId.

# Arguments
- `agreement_id`: A unique identifier for the agreement. This identifier is returned when
  you create an agreement.
- `server_id`: The server identifier that's associated with the agreement.

"""
function describe_agreement(
    AgreementId, ServerId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transfer(
        "DescribeAgreement",
        Dict{String,Any}("AgreementId" => AgreementId, "ServerId" => ServerId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_agreement(
    AgreementId,
    ServerId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transfer(
        "DescribeAgreement",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("AgreementId" => AgreementId, "ServerId" => ServerId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_certificate(certificate_id)
    describe_certificate(certificate_id, params::Dict{String,<:Any})

Describes the certificate that's identified by the CertificateId.

# Arguments
- `certificate_id`: An array of identifiers for the imported certificates. You use this
  identifier for working with profiles and partner profiles.

"""
function describe_certificate(
    CertificateId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transfer(
        "DescribeCertificate",
        Dict{String,Any}("CertificateId" => CertificateId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_certificate(
    CertificateId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transfer(
        "DescribeCertificate",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("CertificateId" => CertificateId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_connector(connector_id)
    describe_connector(connector_id, params::Dict{String,<:Any})

Describes the connector that's identified by the ConnectorId.

# Arguments
- `connector_id`: The unique identifier for the connector.

"""
function describe_connector(ConnectorId; aws_config::AbstractAWSConfig=current_aws_config())
    return transfer(
        "DescribeConnector",
        Dict{String,Any}("ConnectorId" => ConnectorId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_connector(
    ConnectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transfer(
        "DescribeConnector",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ConnectorId" => ConnectorId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_execution(execution_id, workflow_id)
    describe_execution(execution_id, workflow_id, params::Dict{String,<:Any})

You can use DescribeExecution to check the details of the execution of the specified
workflow.  This API call only returns details for in-progress workflows.  If you provide an
ID for an execution that is not in progress, or if the execution doesn't match the
specified workflow ID, you receive a ResourceNotFound exception.

# Arguments
- `execution_id`: A unique identifier for the execution of a workflow.
- `workflow_id`: A unique identifier for the workflow.

"""
function describe_execution(
    ExecutionId, WorkflowId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transfer(
        "DescribeExecution",
        Dict{String,Any}("ExecutionId" => ExecutionId, "WorkflowId" => WorkflowId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_execution(
    ExecutionId,
    WorkflowId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transfer(
        "DescribeExecution",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ExecutionId" => ExecutionId, "WorkflowId" => WorkflowId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_host_key(host_key_id, server_id)
    describe_host_key(host_key_id, server_id, params::Dict{String,<:Any})

Returns the details of the host key that's specified by the HostKeyId and ServerId.

# Arguments
- `host_key_id`: The identifier of the host key that you want described.
- `server_id`: The identifier of the server that contains the host key that you want
  described.

"""
function describe_host_key(
    HostKeyId, ServerId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transfer(
        "DescribeHostKey",
        Dict{String,Any}("HostKeyId" => HostKeyId, "ServerId" => ServerId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_host_key(
    HostKeyId,
    ServerId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transfer(
        "DescribeHostKey",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("HostKeyId" => HostKeyId, "ServerId" => ServerId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_profile(profile_id)
    describe_profile(profile_id, params::Dict{String,<:Any})

Returns the details of the profile that's specified by the ProfileId.

# Arguments
- `profile_id`: The identifier of the profile that you want described.

"""
function describe_profile(ProfileId; aws_config::AbstractAWSConfig=current_aws_config())
    return transfer(
        "DescribeProfile",
        Dict{String,Any}("ProfileId" => ProfileId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_profile(
    ProfileId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transfer(
        "DescribeProfile",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ProfileId" => ProfileId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_security_policy(security_policy_name)
    describe_security_policy(security_policy_name, params::Dict{String,<:Any})

Describes the security policy that is attached to your server or SFTP connector. The
response contains a description of the security policy's properties. For more information
about security policies, see Working with security policies for servers or Working with
security policies for SFTP connectors.

# Arguments
- `security_policy_name`: Specify the text name of the security policy for which you want
  the details.

"""
function describe_security_policy(
    SecurityPolicyName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transfer(
        "DescribeSecurityPolicy",
        Dict{String,Any}("SecurityPolicyName" => SecurityPolicyName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_security_policy(
    SecurityPolicyName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transfer(
        "DescribeSecurityPolicy",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("SecurityPolicyName" => SecurityPolicyName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_server(server_id)
    describe_server(server_id, params::Dict{String,<:Any})

Describes a file transfer protocol-enabled server that you specify by passing the ServerId
parameter. The response contains a description of a server's properties. When you set
EndpointType to VPC, the response will contain the EndpointDetails.

# Arguments
- `server_id`: A system-assigned unique identifier for a server.

"""
function describe_server(ServerId; aws_config::AbstractAWSConfig=current_aws_config())
    return transfer(
        "DescribeServer",
        Dict{String,Any}("ServerId" => ServerId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_server(
    ServerId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transfer(
        "DescribeServer",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ServerId" => ServerId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_user(server_id, user_name)
    describe_user(server_id, user_name, params::Dict{String,<:Any})

Describes the user assigned to the specific file transfer protocol-enabled server, as
identified by its ServerId property. The response from this call returns the properties of
the user associated with the ServerId value that was specified.

# Arguments
- `server_id`: A system-assigned unique identifier for a server that has this user assigned.
- `user_name`: The name of the user assigned to one or more servers. User names are part of
  the sign-in credentials to use the Transfer Family service and perform file transfer tasks.

"""
function describe_user(
    ServerId, UserName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transfer(
        "DescribeUser",
        Dict{String,Any}("ServerId" => ServerId, "UserName" => UserName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_user(
    ServerId,
    UserName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transfer(
        "DescribeUser",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ServerId" => ServerId, "UserName" => UserName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_workflow(workflow_id)
    describe_workflow(workflow_id, params::Dict{String,<:Any})

Describes the specified workflow.

# Arguments
- `workflow_id`: A unique identifier for the workflow.

"""
function describe_workflow(WorkflowId; aws_config::AbstractAWSConfig=current_aws_config())
    return transfer(
        "DescribeWorkflow",
        Dict{String,Any}("WorkflowId" => WorkflowId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_workflow(
    WorkflowId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transfer(
        "DescribeWorkflow",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("WorkflowId" => WorkflowId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    import_certificate(certificate, usage)
    import_certificate(certificate, usage, params::Dict{String,<:Any})

Imports the signing and encryption certificates that you need to create local (AS2)
profiles and partner profiles.

# Arguments
- `certificate`:   For the CLI, provide a file path for a certificate in URI format. For
  example, --certificate file://encryption-cert.pem. Alternatively, you can provide the raw
  content.   For the SDK, specify the raw content of a certificate file. For example,
  --certificate \"`cat encryption-cert.pem`\".
- `usage`: Specifies how this certificate is used. It can be used in the following ways:
  SIGNING: For signing AS2 messages    ENCRYPTION: For encrypting AS2 messages    TLS: For
  securing AS2 communications sent over HTTPS

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ActiveDate"`: An optional date that specifies when the certificate becomes active.
- `"CertificateChain"`: An optional list of certificates that make up the chain for the
  certificate that's being imported.
- `"Description"`: A short description that helps identify the certificate.
- `"InactiveDate"`: An optional date that specifies when the certificate becomes inactive.
- `"PrivateKey"`:   For the CLI, provide a file path for a private key in URI format.For
  example, --private-key file://encryption-key.pem. Alternatively, you can provide the raw
  content of the private key file.   For the SDK, specify the raw content of a private key
  file. For example, --private-key \"`cat encryption-key.pem`\"
- `"Tags"`: Key-value pairs that can be used to group and search for certificates.
"""
function import_certificate(
    Certificate, Usage; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transfer(
        "ImportCertificate",
        Dict{String,Any}("Certificate" => Certificate, "Usage" => Usage);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function import_certificate(
    Certificate,
    Usage,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transfer(
        "ImportCertificate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Certificate" => Certificate, "Usage" => Usage),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    import_host_key(host_key_body, server_id)
    import_host_key(host_key_body, server_id, params::Dict{String,<:Any})

Adds a host key to the server that's specified by the ServerId parameter.

# Arguments
- `host_key_body`: The private key portion of an SSH key pair. Transfer Family accepts RSA,
  ECDSA, and ED25519 keys.
- `server_id`: The identifier of the server that contains the host key that you are
  importing.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: The text description that identifies this host key.
- `"Tags"`: Key-value pairs that can be used to group and search for host keys.
"""
function import_host_key(
    HostKeyBody, ServerId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transfer(
        "ImportHostKey",
        Dict{String,Any}("HostKeyBody" => HostKeyBody, "ServerId" => ServerId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function import_host_key(
    HostKeyBody,
    ServerId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transfer(
        "ImportHostKey",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("HostKeyBody" => HostKeyBody, "ServerId" => ServerId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    import_ssh_public_key(server_id, ssh_public_key_body, user_name)
    import_ssh_public_key(server_id, ssh_public_key_body, user_name, params::Dict{String,<:Any})

Adds a Secure Shell (SSH) public key to a Transfer Family user identified by a UserName
value assigned to the specific file transfer protocol-enabled server, identified by
ServerId. The response returns the UserName value, the ServerId value, and the name of the
SshPublicKeyId.

# Arguments
- `server_id`: A system-assigned unique identifier for a server.
- `ssh_public_key_body`: The public key portion of an SSH key pair. Transfer Family accepts
  RSA, ECDSA, and ED25519 keys.
- `user_name`: The name of the Transfer Family user that is assigned to one or more servers.

"""
function import_ssh_public_key(
    ServerId, SshPublicKeyBody, UserName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transfer(
        "ImportSshPublicKey",
        Dict{String,Any}(
            "ServerId" => ServerId,
            "SshPublicKeyBody" => SshPublicKeyBody,
            "UserName" => UserName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function import_ssh_public_key(
    ServerId,
    SshPublicKeyBody,
    UserName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transfer(
        "ImportSshPublicKey",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ServerId" => ServerId,
                    "SshPublicKeyBody" => SshPublicKeyBody,
                    "UserName" => UserName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_accesses(server_id)
    list_accesses(server_id, params::Dict{String,<:Any})

Lists the details for all the accesses you have on your server.

# Arguments
- `server_id`: A system-assigned unique identifier for a server that has users assigned to
  it.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Specifies the maximum number of access SIDs to return.
- `"NextToken"`: When you can get additional results from the ListAccesses call, a
  NextToken parameter is returned in the output. You can then pass in a subsequent command to
  the NextToken parameter to continue listing additional accesses.
"""
function list_accesses(ServerId; aws_config::AbstractAWSConfig=current_aws_config())
    return transfer(
        "ListAccesses",
        Dict{String,Any}("ServerId" => ServerId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_accesses(
    ServerId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transfer(
        "ListAccesses",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ServerId" => ServerId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_agreements(server_id)
    list_agreements(server_id, params::Dict{String,<:Any})

Returns a list of the agreements for the server that's identified by the ServerId that you
supply. If you want to limit the results to a certain number, supply a value for the
MaxResults parameter. If you ran the command previously and received a value for NextToken,
you can supply that value to continue listing agreements from where you left off.

# Arguments
- `server_id`: The identifier of the server for which you want a list of agreements.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of agreements to return.
- `"NextToken"`: When you can get additional results from the ListAgreements call, a
  NextToken parameter is returned in the output. You can then pass in a subsequent command to
  the NextToken parameter to continue listing additional agreements.
"""
function list_agreements(ServerId; aws_config::AbstractAWSConfig=current_aws_config())
    return transfer(
        "ListAgreements",
        Dict{String,Any}("ServerId" => ServerId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_agreements(
    ServerId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transfer(
        "ListAgreements",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ServerId" => ServerId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_certificates()
    list_certificates(params::Dict{String,<:Any})

Returns a list of the current certificates that have been imported into Transfer Family. If
you want to limit the results to a certain number, supply a value for the MaxResults
parameter. If you ran the command previously and received a value for the NextToken
parameter, you can supply that value to continue listing certificates from where you left
off.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of certificates to return.
- `"NextToken"`: When you can get additional results from the ListCertificates call, a
  NextToken parameter is returned in the output. You can then pass in a subsequent command to
  the NextToken parameter to continue listing additional certificates.
"""
function list_certificates(; aws_config::AbstractAWSConfig=current_aws_config())
    return transfer(
        "ListCertificates"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_certificates(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transfer(
        "ListCertificates", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_connectors()
    list_connectors(params::Dict{String,<:Any})

Lists the connectors for the specified Region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of connectors to return.
- `"NextToken"`: When you can get additional results from the ListConnectors call, a
  NextToken parameter is returned in the output. You can then pass in a subsequent command to
  the NextToken parameter to continue listing additional connectors.
"""
function list_connectors(; aws_config::AbstractAWSConfig=current_aws_config())
    return transfer(
        "ListConnectors"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_connectors(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transfer(
        "ListConnectors", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_executions(workflow_id)
    list_executions(workflow_id, params::Dict{String,<:Any})

Lists all in-progress executions for the specified workflow.  If the specified workflow ID
cannot be found, ListExecutions returns a ResourceNotFound exception.

# Arguments
- `workflow_id`: A unique identifier for the workflow.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Specifies the maximum number of executions to return.
- `"NextToken"`:  ListExecutions returns the NextToken parameter in the output. You can
  then pass the NextToken parameter in a subsequent command to continue listing additional
  executions.  This is useful for pagination, for instance. If you have 100 executions for a
  workflow, you might only want to list first 10. If so, call the API by specifying the
  max-results:   aws transfer list-executions --max-results 10   This returns details for the
  first 10 executions, as well as the pointer (NextToken) to the eleventh execution. You can
  now call the API again, supplying the NextToken value you received:   aws transfer
  list-executions --max-results 10 --next-token somePointerReturnedFromPreviousListResult
  This call returns the next 10 executions, the 11th through the 20th. You can then repeat
  the call until the details for all 100 executions have been returned.
"""
function list_executions(WorkflowId; aws_config::AbstractAWSConfig=current_aws_config())
    return transfer(
        "ListExecutions",
        Dict{String,Any}("WorkflowId" => WorkflowId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_executions(
    WorkflowId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transfer(
        "ListExecutions",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("WorkflowId" => WorkflowId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_host_keys(server_id)
    list_host_keys(server_id, params::Dict{String,<:Any})

Returns a list of host keys for the server that's specified by the ServerId parameter.

# Arguments
- `server_id`: The identifier of the server that contains the host keys that you want to
  view.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of host keys to return.
- `"NextToken"`: When there are additional results that were not returned, a NextToken
  parameter is returned. You can use that value for a subsequent call to ListHostKeys to
  continue listing results.
"""
function list_host_keys(ServerId; aws_config::AbstractAWSConfig=current_aws_config())
    return transfer(
        "ListHostKeys",
        Dict{String,Any}("ServerId" => ServerId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_host_keys(
    ServerId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transfer(
        "ListHostKeys",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ServerId" => ServerId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_profiles()
    list_profiles(params::Dict{String,<:Any})

Returns a list of the profiles for your system. If you want to limit the results to a
certain number, supply a value for the MaxResults parameter. If you ran the command
previously and received a value for NextToken, you can supply that value to continue
listing profiles from where you left off.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of profiles to return.
- `"NextToken"`: When there are additional results that were not returned, a NextToken
  parameter is returned. You can use that value for a subsequent call to ListProfiles to
  continue listing results.
- `"ProfileType"`: Indicates whether to list only LOCAL type profiles or only PARTNER type
  profiles. If not supplied in the request, the command lists all types of profiles.
"""
function list_profiles(; aws_config::AbstractAWSConfig=current_aws_config())
    return transfer("ListProfiles"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_profiles(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transfer(
        "ListProfiles", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_security_policies()
    list_security_policies(params::Dict{String,<:Any})

Lists the security policies that are attached to your servers and SFTP connectors. For more
information about security policies, see Working with security policies for servers or
Working with security policies for SFTP connectors.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Specifies the number of security policies to return as a response to the
  ListSecurityPolicies query.
- `"NextToken"`: When additional results are obtained from the ListSecurityPolicies
  command, a NextToken parameter is returned in the output. You can then pass the NextToken
  parameter in a subsequent command to continue listing additional security policies.
"""
function list_security_policies(; aws_config::AbstractAWSConfig=current_aws_config())
    return transfer(
        "ListSecurityPolicies"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_security_policies(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transfer(
        "ListSecurityPolicies",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_servers()
    list_servers(params::Dict{String,<:Any})

Lists the file transfer protocol-enabled servers that are associated with your Amazon Web
Services account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Specifies the number of servers to return as a response to the
  ListServers query.
- `"NextToken"`: When additional results are obtained from the ListServers command, a
  NextToken parameter is returned in the output. You can then pass the NextToken parameter in
  a subsequent command to continue listing additional servers.
"""
function list_servers(; aws_config::AbstractAWSConfig=current_aws_config())
    return transfer("ListServers"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_servers(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transfer(
        "ListServers", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(arn)
    list_tags_for_resource(arn, params::Dict{String,<:Any})

Lists all of the tags associated with the Amazon Resource Name (ARN) that you specify. The
resource can be a user, server, or role.

# Arguments
- `arn`: Requests the tags associated with a particular Amazon Resource Name (ARN). An ARN
  is an identifier for a specific Amazon Web Services resource, such as a server, user, or
  role.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Specifies the number of tags to return as a response to the
  ListTagsForResource request.
- `"NextToken"`: When you request additional results from the ListTagsForResource
  operation, a NextToken parameter is returned in the input. You can then pass in a
  subsequent command to the NextToken parameter to continue listing additional tags.
"""
function list_tags_for_resource(Arn; aws_config::AbstractAWSConfig=current_aws_config())
    return transfer(
        "ListTagsForResource",
        Dict{String,Any}("Arn" => Arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    Arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transfer(
        "ListTagsForResource",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Arn" => Arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_users(server_id)
    list_users(server_id, params::Dict{String,<:Any})

Lists the users for a file transfer protocol-enabled server that you specify by passing the
ServerId parameter.

# Arguments
- `server_id`: A system-assigned unique identifier for a server that has users assigned to
  it.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Specifies the number of users to return as a response to the ListUsers
  request.
- `"NextToken"`: If there are additional results from the ListUsers call, a NextToken
  parameter is returned in the output. You can then pass the NextToken to a subsequent
  ListUsers command, to continue listing additional users.
"""
function list_users(ServerId; aws_config::AbstractAWSConfig=current_aws_config())
    return transfer(
        "ListUsers",
        Dict{String,Any}("ServerId" => ServerId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_users(
    ServerId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transfer(
        "ListUsers",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ServerId" => ServerId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_workflows()
    list_workflows(params::Dict{String,<:Any})

Lists all workflows associated with your Amazon Web Services account for your current
region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Specifies the maximum number of workflows to return.
- `"NextToken"`:  ListWorkflows returns the NextToken parameter in the output. You can then
  pass the NextToken parameter in a subsequent command to continue listing additional
  workflows.
"""
function list_workflows(; aws_config::AbstractAWSConfig=current_aws_config())
    return transfer("ListWorkflows"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_workflows(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transfer(
        "ListWorkflows", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    send_workflow_step_state(execution_id, status, token, workflow_id)
    send_workflow_step_state(execution_id, status, token, workflow_id, params::Dict{String,<:Any})

Sends a callback for asynchronous custom steps.  The ExecutionId, WorkflowId, and Token are
passed to the target resource during execution of a custom step of a workflow. You must
include those with their callback as well as providing a status.

# Arguments
- `execution_id`: A unique identifier for the execution of a workflow.
- `status`: Indicates whether the specified step succeeded or failed.
- `token`: Used to distinguish between multiple callbacks for multiple Lambda steps within
  the same execution.
- `workflow_id`: A unique identifier for the workflow.

"""
function send_workflow_step_state(
    ExecutionId,
    Status,
    Token,
    WorkflowId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transfer(
        "SendWorkflowStepState",
        Dict{String,Any}(
            "ExecutionId" => ExecutionId,
            "Status" => Status,
            "Token" => Token,
            "WorkflowId" => WorkflowId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function send_workflow_step_state(
    ExecutionId,
    Status,
    Token,
    WorkflowId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transfer(
        "SendWorkflowStepState",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ExecutionId" => ExecutionId,
                    "Status" => Status,
                    "Token" => Token,
                    "WorkflowId" => WorkflowId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_directory_listing(connector_id, output_directory_path, remote_directory_path)
    start_directory_listing(connector_id, output_directory_path, remote_directory_path, params::Dict{String,<:Any})

Retrieves a list of the contents of a directory from a remote SFTP server. You specify the
connector ID, the output path, and the remote directory path. You can also specify the
optional MaxItems value to control the maximum number of items that are listed from the
remote directory. This API returns a list of all files and directories in the remote
directory (up to the maximum value), but does not return files or folders in
sub-directories. That is, it only returns a list of files and directories one-level deep.
After you receive the listing file, you can provide the files that you want to transfer to
the RetrieveFilePaths parameter of the StartFileTransfer API call. The naming convention
for the output file is  connector-ID-listing-ID.json. The output file contains the
following information:    filePath: the complete path of a remote file, relative to the
directory of the listing request for your SFTP connector on the remote server.
modifiedTimestamp: the last time the file was modified, in UTC time format. This field is
optional. If the remote file attributes don't contain a timestamp, it is omitted from the
file listing.    size: the size of the file, in bytes. This field is optional. If the
remote file attributes don't contain a file size, it is omitted from the file listing.
path: the complete path of a remote directory, relative to the directory of the listing
request for your SFTP connector on the remote server.    truncated: a flag indicating
whether the list output contains all of the items contained in the remote directory or not.
If your Truncated output value is true, you can increase the value provided in the optional
max-items input attribute to be able to list more items (up to the maximum allowed list
size of 10,000 items).

# Arguments
- `connector_id`: The unique identifier for the connector.
- `output_directory_path`: Specifies the path (bucket and prefix) in Amazon S3 storage to
  store the results of the directory listing.
- `remote_directory_path`: Specifies the directory on the remote SFTP server for which you
  want to list its contents.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxItems"`: An optional parameter where you can specify the maximum number of
  file/directory names to retrieve. The default value is 1,000.
"""
function start_directory_listing(
    ConnectorId,
    OutputDirectoryPath,
    RemoteDirectoryPath;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transfer(
        "StartDirectoryListing",
        Dict{String,Any}(
            "ConnectorId" => ConnectorId,
            "OutputDirectoryPath" => OutputDirectoryPath,
            "RemoteDirectoryPath" => RemoteDirectoryPath,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_directory_listing(
    ConnectorId,
    OutputDirectoryPath,
    RemoteDirectoryPath,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transfer(
        "StartDirectoryListing",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ConnectorId" => ConnectorId,
                    "OutputDirectoryPath" => OutputDirectoryPath,
                    "RemoteDirectoryPath" => RemoteDirectoryPath,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_file_transfer(connector_id)
    start_file_transfer(connector_id, params::Dict{String,<:Any})

Begins a file transfer between local Amazon Web Services storage and a remote AS2 or SFTP
server.   For an AS2 connector, you specify the ConnectorId and one or more SendFilePaths
to identify the files you want to transfer.   For an SFTP connector, the file transfer can
be either outbound or inbound. In both cases, you specify the ConnectorId. Depending on the
direction of the transfer, you also specify the following items:   If you are transferring
file from a partner's SFTP server to Amazon Web Services storage, you specify one or more
RetrieveFilePaths to identify the files you want to transfer, and a LocalDirectoryPath to
specify the destination folder.   If you are transferring file to a partner's SFTP server
from Amazon Web Services storage, you specify one or more SendFilePaths to identify the
files you want to transfer, and a RemoteDirectoryPath to specify the destination folder.

# Arguments
- `connector_id`: The unique identifier for the connector.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"LocalDirectoryPath"`: For an inbound transfer, the LocaDirectoryPath specifies the
  destination for one or more files that are transferred from the partner's SFTP server.
- `"RemoteDirectoryPath"`: For an outbound transfer, the RemoteDirectoryPath specifies the
  destination for one or more files that are transferred to the partner's SFTP server. If you
  don't specify a RemoteDirectoryPath, the destination for transferred files is the SFTP
  user's home directory.
- `"RetrieveFilePaths"`: One or more source paths for the partner's SFTP server. Each
  string represents a source file path for one inbound file transfer.
- `"SendFilePaths"`: One or more source paths for the Amazon S3 storage. Each string
  represents a source file path for one outbound file transfer. For example,
  DOC-EXAMPLE-BUCKET/myfile.txt .  Replace  DOC-EXAMPLE-BUCKET  with one of your actual
  buckets.
"""
function start_file_transfer(
    ConnectorId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transfer(
        "StartFileTransfer",
        Dict{String,Any}("ConnectorId" => ConnectorId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_file_transfer(
    ConnectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transfer(
        "StartFileTransfer",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ConnectorId" => ConnectorId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_server(server_id)
    start_server(server_id, params::Dict{String,<:Any})

Changes the state of a file transfer protocol-enabled server from OFFLINE to ONLINE. It has
no impact on a server that is already ONLINE. An ONLINE server can accept and process file
transfer jobs. The state of STARTING indicates that the server is in an intermediate state,
either not fully able to respond, or not fully online. The values of START_FAILED can
indicate an error condition. No response is returned from this call.

# Arguments
- `server_id`: A system-assigned unique identifier for a server that you start.

"""
function start_server(ServerId; aws_config::AbstractAWSConfig=current_aws_config())
    return transfer(
        "StartServer",
        Dict{String,Any}("ServerId" => ServerId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_server(
    ServerId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transfer(
        "StartServer",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ServerId" => ServerId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_server(server_id)
    stop_server(server_id, params::Dict{String,<:Any})

Changes the state of a file transfer protocol-enabled server from ONLINE to OFFLINE. An
OFFLINE server cannot accept and process file transfer jobs. Information tied to your
server, such as server and user properties, are not affected by stopping your server.
Stopping the server does not reduce or impact your file transfer protocol endpoint billing;
you must delete the server to stop being billed.  The state of STOPPING indicates that the
server is in an intermediate state, either not fully able to respond, or not fully offline.
The values of STOP_FAILED can indicate an error condition. No response is returned from
this call.

# Arguments
- `server_id`: A system-assigned unique identifier for a server that you stopped.

"""
function stop_server(ServerId; aws_config::AbstractAWSConfig=current_aws_config())
    return transfer(
        "StopServer",
        Dict{String,Any}("ServerId" => ServerId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_server(
    ServerId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transfer(
        "StopServer",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ServerId" => ServerId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(arn, tags)
    tag_resource(arn, tags, params::Dict{String,<:Any})

Attaches a key-value pair to a resource, as identified by its Amazon Resource Name (ARN).
Resources are users, servers, roles, and other entities. There is no response returned from
this call.

# Arguments
- `arn`: An Amazon Resource Name (ARN) for a specific Amazon Web Services resource, such as
  a server, user, or role.
- `tags`: Key-value pairs assigned to ARNs that you can use to group and search for
  resources by type. You can attach this metadata to resources (servers, users, workflows,
  and so on) for any purpose.

"""
function tag_resource(Arn, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return transfer(
        "TagResource",
        Dict{String,Any}("Arn" => Arn, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    Arn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transfer(
        "TagResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Arn" => Arn, "Tags" => Tags), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    test_connection(connector_id)
    test_connection(connector_id, params::Dict{String,<:Any})

Tests whether your SFTP connector is set up successfully. We highly recommend that you call
this operation to test your ability to transfer files between local Amazon Web Services
storage and a trading partner's SFTP server.

# Arguments
- `connector_id`: The unique identifier for the connector.

"""
function test_connection(ConnectorId; aws_config::AbstractAWSConfig=current_aws_config())
    return transfer(
        "TestConnection",
        Dict{String,Any}("ConnectorId" => ConnectorId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function test_connection(
    ConnectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transfer(
        "TestConnection",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ConnectorId" => ConnectorId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    test_identity_provider(server_id, user_name)
    test_identity_provider(server_id, user_name, params::Dict{String,<:Any})

If the IdentityProviderType of a file transfer protocol-enabled server is
AWS_DIRECTORY_SERVICE or API_Gateway, tests whether your identity provider is set up
successfully. We highly recommend that you call this operation to test your authentication
method as soon as you create your server. By doing so, you can troubleshoot issues with the
identity provider integration to ensure that your users can successfully use the service.
The ServerId and UserName parameters are required. The ServerProtocol, SourceIp, and
UserPassword are all optional.  Note the following:    You cannot use TestIdentityProvider
if the IdentityProviderType of your server is SERVICE_MANAGED.    TestIdentityProvider does
not work with keys: it only accepts passwords.    TestIdentityProvider can test the
password operation for a custom Identity Provider that handles keys and passwords.    If
you provide any incorrect values for any parameters, the Response field is empty.     If
you provide a server ID for a server that uses service-managed users, you get an error:
An error occurred (InvalidRequestException) when calling the TestIdentityProvider
operation: s-server-ID not configured for external auth      If you enter a Server ID for
the --server-id parameter that does not identify an actual Transfer server, you receive the
following error:   An error occurred (ResourceNotFoundException) when calling the
TestIdentityProvider operation: Unknown server.  It is possible your sever is in a
different region. You can specify a region by adding the following: --region region-code,
such as --region us-east-2 to specify a server in US East (Ohio).

# Arguments
- `server_id`: A system-assigned identifier for a specific server. That server's user
  authentication method is tested with a user name and password.
- `user_name`: The name of the account to be tested.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ServerProtocol"`: The type of file transfer protocol to be tested. The available
  protocols are:   Secure Shell (SSH) File Transfer Protocol (SFTP)   File Transfer Protocol
  Secure (FTPS)   File Transfer Protocol (FTP)   Applicability Statement 2 (AS2)
- `"SourceIp"`: The source IP address of the account to be tested.
- `"UserPassword"`: The password of the account to be tested.
"""
function test_identity_provider(
    ServerId, UserName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transfer(
        "TestIdentityProvider",
        Dict{String,Any}("ServerId" => ServerId, "UserName" => UserName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function test_identity_provider(
    ServerId,
    UserName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transfer(
        "TestIdentityProvider",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ServerId" => ServerId, "UserName" => UserName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(arn, tag_keys)
    untag_resource(arn, tag_keys, params::Dict{String,<:Any})

Detaches a key-value pair from a resource, as identified by its Amazon Resource Name (ARN).
Resources are users, servers, roles, and other entities. No response is returned from this
call.

# Arguments
- `arn`: The value of the resource that will have the tag removed. An Amazon Resource Name
  (ARN) is an identifier for a specific Amazon Web Services resource, such as a server, user,
  or role.
- `tag_keys`: TagKeys are key-value pairs assigned to ARNs that can be used to group and
  search for resources by type. This metadata can be attached to resources for any purpose.

"""
function untag_resource(Arn, TagKeys; aws_config::AbstractAWSConfig=current_aws_config())
    return transfer(
        "UntagResource",
        Dict{String,Any}("Arn" => Arn, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    Arn,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transfer(
        "UntagResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Arn" => Arn, "TagKeys" => TagKeys), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_access(external_id, server_id)
    update_access(external_id, server_id, params::Dict{String,<:Any})

Allows you to update parameters for the access specified in the ServerID and ExternalID
parameters.

# Arguments
- `external_id`: A unique identifier that is required to identify specific groups within
  your directory. The users of the group that you associate have access to your Amazon S3 or
  Amazon EFS resources over the enabled protocols using Transfer Family. If you know the
  group name, you can view the SID values by running the following command using Windows
  PowerShell.  Get-ADGroup -Filter {samAccountName -like \"YourGroupName*\"} -Properties * |
  Select SamAccountName,ObjectSid  In that command, replace YourGroupName with the name of
  your Active Directory group. The regular expression used to validate this parameter is a
  string of characters consisting of uppercase and lowercase alphanumeric characters with no
  spaces. You can also include underscores or any of the following characters: =,.@:/-
- `server_id`: A system-assigned unique identifier for a server instance. This is the
  specific server that you added your user to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"HomeDirectory"`: The landing directory (folder) for a user when they log in to the
  server using the client. A HomeDirectory example is /bucket_name/home/mydirectory.  The
  HomeDirectory parameter is only used if HomeDirectoryType is set to PATH.
- `"HomeDirectoryMappings"`: Logical directory mappings that specify what Amazon S3 or
  Amazon EFS paths and keys should be visible to your user and how you want to make them
  visible. You must specify the Entry and Target pair, where Entry shows how the path is made
  visible and Target is the actual Amazon S3 or Amazon EFS path. If you only specify a
  target, it is displayed as is. You also must ensure that your Identity and Access
  Management (IAM) role provides access to paths in Target. This value can be set only when
  HomeDirectoryType is set to LOGICAL. The following is an Entry and Target pair example.  [
  { \"Entry\": \"/directory1\", \"Target\": \"/bucket_name/home/mydirectory\" } ]  In most
  cases, you can use this value instead of the session policy to lock down your user to the
  designated home directory (\"chroot\"). To do this, you can set Entry to / and set Target
  to the HomeDirectory parameter value. The following is an Entry and Target pair example for
  chroot.  [ { \"Entry\": \"/\", \"Target\": \"/bucket_name/home/mydirectory\" } ]
- `"HomeDirectoryType"`: The type of landing directory (folder) that you want your users'
  home directory to be when they log in to the server. If you set it to PATH, the user will
  see the absolute Amazon S3 bucket or Amazon EFS path as is in their file transfer protocol
  clients. If you set it to LOGICAL, you need to provide mappings in the
  HomeDirectoryMappings for how you want to make Amazon S3 or Amazon EFS paths visible to
  your users.  If HomeDirectoryType is LOGICAL, you must provide mappings, using the
  HomeDirectoryMappings parameter. If, on the other hand, HomeDirectoryType is PATH, you
  provide an absolute path using the HomeDirectory parameter. You cannot have both
  HomeDirectory and HomeDirectoryMappings in your template.
- `"Policy"`: A session policy for your user so that you can use the same Identity and
  Access Management (IAM) role across multiple users. This policy scopes down a user's access
  to portions of their Amazon S3 bucket. Variables that you can use inside this policy
  include {Transfer:UserName}, {Transfer:HomeDirectory}, and {Transfer:HomeBucket}.  This
  policy applies only when the domain of ServerId is Amazon S3. Amazon EFS does not use
  session policies. For session policies, Transfer Family stores the policy as a JSON blob,
  instead of the Amazon Resource Name (ARN) of the policy. You save the policy as a JSON blob
  and pass it in the Policy argument. For an example of a session policy, see Example session
  policy. For more information, see AssumeRole in the Amazon Web ServicesSecurity Token
  Service API Reference.
- `"PosixProfile"`:
- `"Role"`: The Amazon Resource Name (ARN) of the Identity and Access Management (IAM) role
  that controls your users' access to your Amazon S3 bucket or Amazon EFS file system. The
  policies attached to this role determine the level of access that you want to provide your
  users when transferring files into and out of your Amazon S3 bucket or Amazon EFS file
  system. The IAM role should also contain a trust relationship that allows the server to
  access your resources when servicing your users' transfer requests.
"""
function update_access(
    ExternalId, ServerId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transfer(
        "UpdateAccess",
        Dict{String,Any}("ExternalId" => ExternalId, "ServerId" => ServerId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_access(
    ExternalId,
    ServerId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transfer(
        "UpdateAccess",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ExternalId" => ExternalId, "ServerId" => ServerId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_agreement(agreement_id, server_id)
    update_agreement(agreement_id, server_id, params::Dict{String,<:Any})

Updates some of the parameters for an existing agreement. Provide the AgreementId and the
ServerId for the agreement that you want to update, along with the new values for the
parameters to update.

# Arguments
- `agreement_id`: A unique identifier for the agreement. This identifier is returned when
  you create an agreement.
- `server_id`: A system-assigned unique identifier for a server instance. This is the
  specific server that the agreement uses.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccessRole"`: Connectors are used to send files using either the AS2 or SFTP protocol.
  For the access role, provide the Amazon Resource Name (ARN) of the Identity and Access
  Management role to use.  For AS2 connectors  With AS2, you can send files by calling
  StartFileTransfer and specifying the file paths in the request parameter, SendFilePaths. We
  use the file’s parent directory (for example, for --send-file-paths /bucket/dir/file.txt,
  parent directory is /bucket/dir/) to temporarily store a processed AS2 message file, store
  the MDN when we receive them from the partner, and write a final JSON file containing
  relevant metadata of the transmission. So, the AccessRole needs to provide read and write
  access to the parent directory of the file location used in the StartFileTransfer request.
  Additionally, you need to provide read and write access to the parent directory of the
  files that you intend to send with StartFileTransfer. If you are using Basic authentication
  for your AS2 connector, the access role requires the secretsmanager:GetSecretValue
  permission for the secret. If the secret is encrypted using a customer-managed key instead
  of the Amazon Web Services managed key in Secrets Manager, then the role also needs the
  kms:Decrypt permission for that key.  For SFTP connectors  Make sure that the access role
  provides read and write access to the parent directory of the file location that's used in
  the StartFileTransfer request. Additionally, make sure that the role provides
  secretsmanager:GetSecretValue permission to Secrets Manager.
- `"BaseDirectory"`: To change the landing directory (folder) for files that are
  transferred, provide the bucket folder that you want to use; for example,
  /DOC-EXAMPLE-BUCKET/home/mydirectory .
- `"Description"`: To replace the existing description, provide a short description for the
  agreement.
- `"LocalProfileId"`: A unique identifier for the AS2 local profile. To change the local
  profile identifier, provide a new value here.
- `"PartnerProfileId"`: A unique identifier for the partner profile. To change the partner
  profile identifier, provide a new value here.
- `"Status"`: You can update the status for the agreement, either activating an inactive
  agreement or the reverse.
"""
function update_agreement(
    AgreementId, ServerId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transfer(
        "UpdateAgreement",
        Dict{String,Any}("AgreementId" => AgreementId, "ServerId" => ServerId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_agreement(
    AgreementId,
    ServerId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transfer(
        "UpdateAgreement",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("AgreementId" => AgreementId, "ServerId" => ServerId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_certificate(certificate_id)
    update_certificate(certificate_id, params::Dict{String,<:Any})

Updates the active and inactive dates for a certificate.

# Arguments
- `certificate_id`: The identifier of the certificate object that you are updating.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ActiveDate"`: An optional date that specifies when the certificate becomes active.
- `"Description"`: A short description to help identify the certificate.
- `"InactiveDate"`: An optional date that specifies when the certificate becomes inactive.
"""
function update_certificate(
    CertificateId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transfer(
        "UpdateCertificate",
        Dict{String,Any}("CertificateId" => CertificateId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_certificate(
    CertificateId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transfer(
        "UpdateCertificate",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("CertificateId" => CertificateId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_connector(connector_id)
    update_connector(connector_id, params::Dict{String,<:Any})

Updates some of the parameters for an existing connector. Provide the ConnectorId for the
connector that you want to update, along with the new values for the parameters to update.

# Arguments
- `connector_id`: The unique identifier for the connector.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccessRole"`: Connectors are used to send files using either the AS2 or SFTP protocol.
  For the access role, provide the Amazon Resource Name (ARN) of the Identity and Access
  Management role to use.  For AS2 connectors  With AS2, you can send files by calling
  StartFileTransfer and specifying the file paths in the request parameter, SendFilePaths. We
  use the file’s parent directory (for example, for --send-file-paths /bucket/dir/file.txt,
  parent directory is /bucket/dir/) to temporarily store a processed AS2 message file, store
  the MDN when we receive them from the partner, and write a final JSON file containing
  relevant metadata of the transmission. So, the AccessRole needs to provide read and write
  access to the parent directory of the file location used in the StartFileTransfer request.
  Additionally, you need to provide read and write access to the parent directory of the
  files that you intend to send with StartFileTransfer. If you are using Basic authentication
  for your AS2 connector, the access role requires the secretsmanager:GetSecretValue
  permission for the secret. If the secret is encrypted using a customer-managed key instead
  of the Amazon Web Services managed key in Secrets Manager, then the role also needs the
  kms:Decrypt permission for that key.  For SFTP connectors  Make sure that the access role
  provides read and write access to the parent directory of the file location that's used in
  the StartFileTransfer request. Additionally, make sure that the role provides
  secretsmanager:GetSecretValue permission to Secrets Manager.
- `"As2Config"`: A structure that contains the parameters for an AS2 connector object.
- `"LoggingRole"`: The Amazon Resource Name (ARN) of the Identity and Access Management
  (IAM) role that allows a connector to turn on CloudWatch logging for Amazon S3 events. When
  set, you can view connector activity in your CloudWatch logs.
- `"SecurityPolicyName"`: Specifies the name of the security policy for the connector.
- `"SftpConfig"`: A structure that contains the parameters for an SFTP connector object.
- `"Url"`: The URL of the partner's AS2 or SFTP endpoint.
"""
function update_connector(ConnectorId; aws_config::AbstractAWSConfig=current_aws_config())
    return transfer(
        "UpdateConnector",
        Dict{String,Any}("ConnectorId" => ConnectorId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_connector(
    ConnectorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transfer(
        "UpdateConnector",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ConnectorId" => ConnectorId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_host_key(description, host_key_id, server_id)
    update_host_key(description, host_key_id, server_id, params::Dict{String,<:Any})

Updates the description for the host key that's specified by the ServerId and HostKeyId
parameters.

# Arguments
- `description`: An updated description for the host key.
- `host_key_id`: The identifier of the host key that you are updating.
- `server_id`: The identifier of the server that contains the host key that you are
  updating.

"""
function update_host_key(
    Description, HostKeyId, ServerId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return transfer(
        "UpdateHostKey",
        Dict{String,Any}(
            "Description" => Description, "HostKeyId" => HostKeyId, "ServerId" => ServerId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_host_key(
    Description,
    HostKeyId,
    ServerId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transfer(
        "UpdateHostKey",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Description" => Description,
                    "HostKeyId" => HostKeyId,
                    "ServerId" => ServerId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_profile(profile_id)
    update_profile(profile_id, params::Dict{String,<:Any})

Updates some of the parameters for an existing profile. Provide the ProfileId for the
profile that you want to update, along with the new values for the parameters to update.

# Arguments
- `profile_id`: The identifier of the profile object that you are updating.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CertificateIds"`: An array of identifiers for the imported certificates. You use this
  identifier for working with profiles and partner profiles.
"""
function update_profile(ProfileId; aws_config::AbstractAWSConfig=current_aws_config())
    return transfer(
        "UpdateProfile",
        Dict{String,Any}("ProfileId" => ProfileId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_profile(
    ProfileId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transfer(
        "UpdateProfile",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ProfileId" => ProfileId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_server(server_id)
    update_server(server_id, params::Dict{String,<:Any})

Updates the file transfer protocol-enabled server's properties after that server has been
created. The UpdateServer call returns the ServerId of the server you updated.

# Arguments
- `server_id`: A system-assigned unique identifier for a server instance that the Transfer
  Family user is assigned to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Certificate"`: The Amazon Resource Name (ARN) of the Amazon Web ServicesCertificate
  Manager (ACM) certificate. Required when Protocols is set to FTPS. To request a new public
  certificate, see Request a public certificate in the  Amazon Web ServicesCertificate
  Manager User Guide. To import an existing certificate into ACM, see Importing certificates
  into ACM in the  Amazon Web ServicesCertificate Manager User Guide. To request a private
  certificate to use FTPS through private IP addresses, see Request a private certificate in
  the  Amazon Web ServicesCertificate Manager User Guide. Certificates with the following
  cryptographic algorithms and key sizes are supported:   2048-bit RSA (RSA_2048)   4096-bit
  RSA (RSA_4096)   Elliptic Prime Curve 256 bit (EC_prime256v1)   Elliptic Prime Curve 384
  bit (EC_secp384r1)   Elliptic Prime Curve 521 bit (EC_secp521r1)    The certificate must be
  a valid SSL/TLS X.509 version 3 certificate with FQDN or IP address specified and
  information about the issuer.
- `"EndpointDetails"`: The virtual private cloud (VPC) endpoint settings that are
  configured for your server. When you host your endpoint within your VPC, you can make your
  endpoint accessible only to resources within your VPC, or you can attach Elastic IP
  addresses and make your endpoint accessible to clients over the internet. Your VPC's
  default security groups are automatically assigned to your endpoint.
- `"EndpointType"`: The type of endpoint that you want your server to use. You can choose
  to make your server's endpoint publicly accessible (PUBLIC) or host it inside your VPC.
  With an endpoint that is hosted in a VPC, you can restrict access to your server and
  resources only within your VPC or choose to make it internet facing by attaching Elastic IP
  addresses directly to it.   After May 19, 2021, you won't be able to create a server using
  EndpointType=VPC_ENDPOINT in your Amazon Web Servicesaccount if your account hasn't already
  done so before May 19, 2021. If you have already created servers with
  EndpointType=VPC_ENDPOINT in your Amazon Web Servicesaccount on or before May 19, 2021, you
  will not be affected. After this date, use EndpointType=VPC. For more information, see
  https://docs.aws.amazon.com/transfer/latest/userguide/create-server-in-vpc.html#deprecate-vp
  c-endpoint. It is recommended that you use VPC as the EndpointType. With this endpoint
  type, you have the option to directly associate up to three Elastic IPv4 addresses (BYO IP
  included) with your server's endpoint and use VPC security groups to restrict traffic by
  the client's public IP address. This is not possible with EndpointType set to VPC_ENDPOINT.
- `"HostKey"`: The RSA, ECDSA, or ED25519 private key to use for your SFTP-enabled server.
  You can add multiple host keys, in case you want to rotate keys, or have a set of active
  keys that use different algorithms. Use the following command to generate an RSA 2048 bit
  key with no passphrase:  ssh-keygen -t rsa -b 2048 -N \"\" -m PEM -f my-new-server-key. Use
  a minimum value of 2048 for the -b option. You can create a stronger key by using 3072 or
  4096. Use the following command to generate an ECDSA 256 bit key with no passphrase:
  ssh-keygen -t ecdsa -b 256 -N \"\" -m PEM -f my-new-server-key. Valid values for the -b
  option for ECDSA are 256, 384, and 521. Use the following command to generate an ED25519
  key with no passphrase:  ssh-keygen -t ed25519 -N \"\" -f my-new-server-key. For all of
  these commands, you can replace my-new-server-key with a string of your choice.  If you
  aren't planning to migrate existing users from an existing SFTP-enabled server to a new
  server, don't update the host key. Accidentally changing a server's host key can be
  disruptive.  For more information, see Manage host keys for your SFTP-enabled server in the
  Transfer Family User Guide.
- `"IdentityProviderDetails"`: An array containing all of the information required to call
  a customer's authentication API method.
- `"LoggingRole"`: The Amazon Resource Name (ARN) of the Identity and Access Management
  (IAM) role that allows a server to turn on Amazon CloudWatch logging for Amazon S3 or
  Amazon EFSevents. When set, you can view user activity in your CloudWatch logs.
- `"PostAuthenticationLoginBanner"`: Specifies a string to display when users connect to a
  server. This string is displayed after the user authenticates.  The SFTP protocol does not
  support post-authentication display banners.
- `"PreAuthenticationLoginBanner"`: Specifies a string to display when users connect to a
  server. This string is displayed before the user authenticates. For example, the following
  banner displays details about using the system:  This system is for the use of authorized
  users only. Individuals using this computer system without authority, or in excess of their
  authority, are subject to having all of their activities on this system monitored and
  recorded by system personnel.
- `"ProtocolDetails"`: The protocol settings that are configured for your server.    To
  indicate passive mode (for FTP and FTPS protocols), use the PassiveIp parameter. Enter a
  single dotted-quad IPv4 address, such as the external IP address of a firewall, router, or
  load balancer.    To ignore the error that is generated when the client attempts to use the
  SETSTAT command on a file that you are uploading to an Amazon S3 bucket, use the
  SetStatOption parameter. To have the Transfer Family server ignore the SETSTAT command and
  upload files without needing to make any changes to your SFTP client, set the value to
  ENABLE_NO_OP. If you set the SetStatOption parameter to ENABLE_NO_OP, Transfer Family
  generates a log entry to Amazon CloudWatch Logs, so that you can determine when the client
  is making a SETSTAT call.   To determine whether your Transfer Family server resumes
  recent, negotiated sessions through a unique session ID, use the TlsSessionResumptionMode
  parameter.    As2Transports indicates the transport method for the AS2 messages. Currently,
  only HTTP is supported.
- `"Protocols"`: Specifies the file transfer protocol or protocols over which your file
  transfer protocol client can connect to your server's endpoint. The available protocols
  are:    SFTP (Secure Shell (SSH) File Transfer Protocol): File transfer over SSH    FTPS
  (File Transfer Protocol Secure): File transfer with TLS encryption    FTP (File Transfer
  Protocol): Unencrypted file transfer    AS2 (Applicability Statement 2): used for
  transporting structured business-to-business data      If you select FTPS, you must choose
  a certificate stored in Certificate Manager (ACM) which is used to identify your server
  when clients connect to it over FTPS.   If Protocol includes either FTP or FTPS, then the
  EndpointType must be VPC and the IdentityProviderType must be either AWS_DIRECTORY_SERVICE,
  AWS_LAMBDA, or API_GATEWAY.   If Protocol includes FTP, then AddressAllocationIds cannot be
  associated.   If Protocol is set only to SFTP, the EndpointType can be set to PUBLIC and
  the IdentityProviderType can be set any of the supported identity types: SERVICE_MANAGED,
  AWS_DIRECTORY_SERVICE, AWS_LAMBDA, or API_GATEWAY.   If Protocol includes AS2, then the
  EndpointType must be VPC, and domain must be Amazon S3.
- `"S3StorageOptions"`: Specifies whether or not performance for your Amazon S3 directories
  is optimized. This is disabled by default. By default, home directory mappings have a TYPE
  of DIRECTORY. If you enable this option, you would then need to explicitly set the
  HomeDirectoryMapEntry Type to FILE if you want a mapping to have a file target.
- `"SecurityPolicyName"`: Specifies the name of the security policy for the server.
- `"StructuredLogDestinations"`: Specifies the log groups to which your server logs are
  sent. To specify a log group, you must provide the ARN for an existing log group. In this
  case, the format of the log group is as follows:
  arn:aws:logs:region-name:amazon-account-id:log-group:log-group-name:*  For example,
  arn:aws:logs:us-east-1:111122223333:log-group:mytestgroup:*  If you have previously
  specified a log group for a server, you can clear it, and in effect turn off structured
  logging, by providing an empty value for this parameter in an update-server call. For
  example:  update-server --server-id s-1234567890abcdef0 --structured-log-destinations
- `"WorkflowDetails"`: Specifies the workflow ID for the workflow to assign and the
  execution role that's used for executing the workflow. In addition to a workflow to execute
  when a file is uploaded completely, WorkflowDetails can also contain a workflow ID (and
  execution role) for a workflow to execute on partial upload. A partial upload occurs when
  the server session disconnects while the file is still being uploaded. To remove an
  associated workflow from a server, you can provide an empty OnUpload object, as in the
  following example.  aws transfer update-server --server-id s-01234567890abcdef
  --workflow-details '{\"OnUpload\":[]}'
"""
function update_server(ServerId; aws_config::AbstractAWSConfig=current_aws_config())
    return transfer(
        "UpdateServer",
        Dict{String,Any}("ServerId" => ServerId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_server(
    ServerId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transfer(
        "UpdateServer",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ServerId" => ServerId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_user(server_id, user_name)
    update_user(server_id, user_name, params::Dict{String,<:Any})

Assigns new properties to a user. Parameters you pass modify any or all of the following:
the home directory, role, and policy for the UserName and ServerId you specify. The
response returns the ServerId and the UserName for the updated user. In the console, you
can select Restricted when you create or update a user. This ensures that the user can't
access anything outside of their home directory. The programmatic way to configure this
behavior is to update the user. Set their HomeDirectoryType to LOGICAL, and specify
HomeDirectoryMappings with Entry as root (/) and Target as their home directory. For
example, if the user's home directory is /test/admin-user, the following command updates
the user so that their configuration in the console shows the Restricted flag as selected.
 aws transfer update-user --server-id &lt;server-id&gt; --user-name admin-user
--home-directory-type LOGICAL --home-directory-mappings \"[{\"Entry\":\"/\",
\"Target\":\"/test/admin-user\"}]\"

# Arguments
- `server_id`: A system-assigned unique identifier for a Transfer Family server instance
  that the user is assigned to.
- `user_name`: A unique string that identifies a user and is associated with a server as
  specified by the ServerId. This user name must be a minimum of 3 and a maximum of 100
  characters long. The following are valid characters: a-z, A-Z, 0-9, underscore '_', hyphen
  '-', period '.', and at sign '@'. The user name can't start with a hyphen, period, or at
  sign.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"HomeDirectory"`: The landing directory (folder) for a user when they log in to the
  server using the client. A HomeDirectory example is /bucket_name/home/mydirectory.  The
  HomeDirectory parameter is only used if HomeDirectoryType is set to PATH.
- `"HomeDirectoryMappings"`: Logical directory mappings that specify what Amazon S3 or
  Amazon EFS paths and keys should be visible to your user and how you want to make them
  visible. You must specify the Entry and Target pair, where Entry shows how the path is made
  visible and Target is the actual Amazon S3 or Amazon EFS path. If you only specify a
  target, it is displayed as is. You also must ensure that your Identity and Access
  Management (IAM) role provides access to paths in Target. This value can be set only when
  HomeDirectoryType is set to LOGICAL. The following is an Entry and Target pair example.  [
  { \"Entry\": \"/directory1\", \"Target\": \"/bucket_name/home/mydirectory\" } ]  In most
  cases, you can use this value instead of the session policy to lock down your user to the
  designated home directory (\"chroot\"). To do this, you can set Entry to '/' and set Target
  to the HomeDirectory parameter value. The following is an Entry and Target pair example for
  chroot.  [ { \"Entry\": \"/\", \"Target\": \"/bucket_name/home/mydirectory\" } ]
- `"HomeDirectoryType"`: The type of landing directory (folder) that you want your users'
  home directory to be when they log in to the server. If you set it to PATH, the user will
  see the absolute Amazon S3 bucket or Amazon EFS path as is in their file transfer protocol
  clients. If you set it to LOGICAL, you need to provide mappings in the
  HomeDirectoryMappings for how you want to make Amazon S3 or Amazon EFS paths visible to
  your users.  If HomeDirectoryType is LOGICAL, you must provide mappings, using the
  HomeDirectoryMappings parameter. If, on the other hand, HomeDirectoryType is PATH, you
  provide an absolute path using the HomeDirectory parameter. You cannot have both
  HomeDirectory and HomeDirectoryMappings in your template.
- `"Policy"`: A session policy for your user so that you can use the same Identity and
  Access Management (IAM) role across multiple users. This policy scopes down a user's access
  to portions of their Amazon S3 bucket. Variables that you can use inside this policy
  include {Transfer:UserName}, {Transfer:HomeDirectory}, and {Transfer:HomeBucket}.  This
  policy applies only when the domain of ServerId is Amazon S3. Amazon EFS does not use
  session policies. For session policies, Transfer Family stores the policy as a JSON blob,
  instead of the Amazon Resource Name (ARN) of the policy. You save the policy as a JSON blob
  and pass it in the Policy argument. For an example of a session policy, see Creating a
  session policy. For more information, see AssumeRole in the Amazon Web Services Security
  Token Service API Reference.
- `"PosixProfile"`: Specifies the full POSIX identity, including user ID (Uid), group ID
  (Gid), and any secondary groups IDs (SecondaryGids), that controls your users' access to
  your Amazon Elastic File Systems (Amazon EFS). The POSIX permissions that are set on files
  and directories in your file system determines the level of access your users get when
  transferring files into and out of your Amazon EFS file systems.
- `"Role"`: The Amazon Resource Name (ARN) of the Identity and Access Management (IAM) role
  that controls your users' access to your Amazon S3 bucket or Amazon EFS file system. The
  policies attached to this role determine the level of access that you want to provide your
  users when transferring files into and out of your Amazon S3 bucket or Amazon EFS file
  system. The IAM role should also contain a trust relationship that allows the server to
  access your resources when servicing your users' transfer requests.
"""
function update_user(ServerId, UserName; aws_config::AbstractAWSConfig=current_aws_config())
    return transfer(
        "UpdateUser",
        Dict{String,Any}("ServerId" => ServerId, "UserName" => UserName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_user(
    ServerId,
    UserName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return transfer(
        "UpdateUser",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ServerId" => ServerId, "UserName" => UserName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: comprehendmedical
using AWS.Compat
using AWS.UUIDs

"""
    describe_entities_detection_v2_job(job_id)
    describe_entities_detection_v2_job(job_id, params::Dict{String,<:Any})

Gets the properties associated with a medical entities detection job. Use this operation to
get the status of a detection job.

# Arguments
- `job_id`: The identifier that Amazon Comprehend Medical generated for the job. The
  StartEntitiesDetectionV2Job operation returns this identifier in its response.

"""
function describe_entities_detection_v2_job(
    JobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehendmedical(
        "DescribeEntitiesDetectionV2Job",
        Dict{String,Any}("JobId" => JobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_entities_detection_v2_job(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehendmedical(
        "DescribeEntitiesDetectionV2Job",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("JobId" => JobId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_icd10_cminference_job(job_id)
    describe_icd10_cminference_job(job_id, params::Dict{String,<:Any})

Gets the properties associated with an InferICD10CM job. Use this operation to get the
status of an inference job.

# Arguments
- `job_id`: The identifier that Amazon Comprehend Medical generated for the job. The
  StartICD10CMInferenceJob operation returns this identifier in its response.

"""
function describe_icd10_cminference_job(
    JobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehendmedical(
        "DescribeICD10CMInferenceJob",
        Dict{String,Any}("JobId" => JobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_icd10_cminference_job(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehendmedical(
        "DescribeICD10CMInferenceJob",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("JobId" => JobId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_phidetection_job(job_id)
    describe_phidetection_job(job_id, params::Dict{String,<:Any})

Gets the properties associated with a protected health information (PHI) detection job. Use
this operation to get the status of a detection job.

# Arguments
- `job_id`: The identifier that Amazon Comprehend Medical generated for the job. The
  StartPHIDetectionJob operation returns this identifier in its response.

"""
function describe_phidetection_job(
    JobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehendmedical(
        "DescribePHIDetectionJob",
        Dict{String,Any}("JobId" => JobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_phidetection_job(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehendmedical(
        "DescribePHIDetectionJob",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("JobId" => JobId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_rx_norm_inference_job(job_id)
    describe_rx_norm_inference_job(job_id, params::Dict{String,<:Any})

Gets the properties associated with an InferRxNorm job. Use this operation to get the
status of an inference job.

# Arguments
- `job_id`: The identifier that Amazon Comprehend Medical generated for the job. The
  StartRxNormInferenceJob operation returns this identifier in its response.

"""
function describe_rx_norm_inference_job(
    JobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehendmedical(
        "DescribeRxNormInferenceJob",
        Dict{String,Any}("JobId" => JobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_rx_norm_inference_job(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehendmedical(
        "DescribeRxNormInferenceJob",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("JobId" => JobId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_snomedctinference_job(job_id)
    describe_snomedctinference_job(job_id, params::Dict{String,<:Any})

 Gets the properties associated with an InferSNOMEDCT job. Use this operation to get the
status of an inference job.

# Arguments
- `job_id`:  The identifier that Amazon Comprehend Medical generated for the job. The
  StartSNOMEDCTInferenceJob operation returns this identifier in its response.

"""
function describe_snomedctinference_job(
    JobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehendmedical(
        "DescribeSNOMEDCTInferenceJob",
        Dict{String,Any}("JobId" => JobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_snomedctinference_job(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehendmedical(
        "DescribeSNOMEDCTInferenceJob",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("JobId" => JobId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    detect_entities(text)
    detect_entities(text, params::Dict{String,<:Any})

The DetectEntities operation is deprecated. You should use the DetectEntitiesV2 operation
instead. Inspects the clinical text for a variety of medical entities and returns specific
information about them such as entity category, location, and confidence score on that
information.

# Arguments
- `text`:  A UTF-8 text string containing the clinical content being examined for entities.

"""
function detect_entities(Text; aws_config::AbstractAWSConfig=current_aws_config())
    return comprehendmedical(
        "DetectEntities",
        Dict{String,Any}("Text" => Text);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function detect_entities(
    Text, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehendmedical(
        "DetectEntities",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Text" => Text), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    detect_entities_v2(text)
    detect_entities_v2(text, params::Dict{String,<:Any})

Inspects the clinical text for a variety of medical entities and returns specific
information about them such as entity category, location, and confidence score on that
information. Amazon Comprehend Medical only detects medical entities in English language
texts. The DetectEntitiesV2 operation replaces the DetectEntities operation. This new
action uses a different model for determining the entities in your medical text and changes
the way that some entities are returned in the output. You should use the DetectEntitiesV2
operation in all new applications. The DetectEntitiesV2 operation returns the Acuity and
Direction entities as attributes instead of types.

# Arguments
- `text`: A UTF-8 string containing the clinical content being examined for entities.

"""
function detect_entities_v2(Text; aws_config::AbstractAWSConfig=current_aws_config())
    return comprehendmedical(
        "DetectEntitiesV2",
        Dict{String,Any}("Text" => Text);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function detect_entities_v2(
    Text, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehendmedical(
        "DetectEntitiesV2",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Text" => Text), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    detect_phi(text)
    detect_phi(text, params::Dict{String,<:Any})

Inspects the clinical text for protected health information (PHI) entities and returns the
entity category, location, and confidence score for each entity. Amazon Comprehend Medical
only detects entities in English language texts.

# Arguments
- `text`: A UTF-8 text string containing the clinical content being examined for PHI
  entities.

"""
function detect_phi(Text; aws_config::AbstractAWSConfig=current_aws_config())
    return comprehendmedical(
        "DetectPHI",
        Dict{String,Any}("Text" => Text);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function detect_phi(
    Text, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehendmedical(
        "DetectPHI",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Text" => Text), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    infer_icd10_cm(text)
    infer_icd10_cm(text, params::Dict{String,<:Any})

InferICD10CM detects medical conditions as entities listed in a patient record and links
those entities to normalized concept identifiers in the ICD-10-CM knowledge base from the
Centers for Disease Control. Amazon Comprehend Medical only detects medical entities in
English language texts.

# Arguments
- `text`: The input text used for analysis.

"""
function infer_icd10_cm(Text; aws_config::AbstractAWSConfig=current_aws_config())
    return comprehendmedical(
        "InferICD10CM",
        Dict{String,Any}("Text" => Text);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function infer_icd10_cm(
    Text, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehendmedical(
        "InferICD10CM",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Text" => Text), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    infer_rx_norm(text)
    infer_rx_norm(text, params::Dict{String,<:Any})

InferRxNorm detects medications as entities listed in a patient record and links to the
normalized concept identifiers in the RxNorm database from the National Library of
Medicine. Amazon Comprehend Medical only detects medical entities in English language
texts.

# Arguments
- `text`: The input text used for analysis.

"""
function infer_rx_norm(Text; aws_config::AbstractAWSConfig=current_aws_config())
    return comprehendmedical(
        "InferRxNorm",
        Dict{String,Any}("Text" => Text);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function infer_rx_norm(
    Text, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehendmedical(
        "InferRxNorm",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Text" => Text), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    infer_snomedct(text)
    infer_snomedct(text, params::Dict{String,<:Any})

 InferSNOMEDCT detects possible medical concepts as entities and links them to codes from
the Systematized Nomenclature of Medicine, Clinical Terms (SNOMED-CT) ontology

# Arguments
- `text`: The input text to be analyzed using InferSNOMEDCT.

"""
function infer_snomedct(Text; aws_config::AbstractAWSConfig=current_aws_config())
    return comprehendmedical(
        "InferSNOMEDCT",
        Dict{String,Any}("Text" => Text);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function infer_snomedct(
    Text, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehendmedical(
        "InferSNOMEDCT",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Text" => Text), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_entities_detection_v2_jobs()
    list_entities_detection_v2_jobs(params::Dict{String,<:Any})

Gets a list of medical entity detection jobs that you have submitted.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filter"`: Filters the jobs that are returned. You can filter jobs based on their names,
  status, or the date and time that they were submitted. You can only set one filter at a
  time.
- `"MaxResults"`: The maximum number of results to return in each page. The default is 100.
- `"NextToken"`: Identifies the next page of results to return.
"""
function list_entities_detection_v2_jobs(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehendmedical(
        "ListEntitiesDetectionV2Jobs";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_entities_detection_v2_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehendmedical(
        "ListEntitiesDetectionV2Jobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_icd10_cminference_jobs()
    list_icd10_cminference_jobs(params::Dict{String,<:Any})

Gets a list of InferICD10CM jobs that you have submitted.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filter"`: Filters the jobs that are returned. You can filter jobs based on their names,
  status, or the date and time that they were submitted. You can only set one filter at a
  time.
- `"MaxResults"`: The maximum number of results to return in each page. The default is 100.
- `"NextToken"`: Identifies the next page of results to return.
"""
function list_icd10_cminference_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return comprehendmedical(
        "ListICD10CMInferenceJobs"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_icd10_cminference_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehendmedical(
        "ListICD10CMInferenceJobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_phidetection_jobs()
    list_phidetection_jobs(params::Dict{String,<:Any})

Gets a list of protected health information (PHI) detection jobs you have submitted.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filter"`: Filters the jobs that are returned. You can filter jobs based on their names,
  status, or the date and time that they were submitted. You can only set one filter at a
  time.
- `"MaxResults"`: The maximum number of results to return in each page. The default is 100.
- `"NextToken"`: Identifies the next page of results to return.
"""
function list_phidetection_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return comprehendmedical(
        "ListPHIDetectionJobs"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_phidetection_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehendmedical(
        "ListPHIDetectionJobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_rx_norm_inference_jobs()
    list_rx_norm_inference_jobs(params::Dict{String,<:Any})

Gets a list of InferRxNorm jobs that you have submitted.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filter"`: Filters the jobs that are returned. You can filter jobs based on their names,
  status, or the date and time that they were submitted. You can only set one filter at a
  time.
- `"MaxResults"`: Identifies the next page of results to return.
- `"NextToken"`: Identifies the next page of results to return.
"""
function list_rx_norm_inference_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return comprehendmedical(
        "ListRxNormInferenceJobs"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_rx_norm_inference_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehendmedical(
        "ListRxNormInferenceJobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_snomedctinference_jobs()
    list_snomedctinference_jobs(params::Dict{String,<:Any})

 Gets a list of InferSNOMEDCT jobs a user has submitted.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filter"`:
- `"MaxResults"`:  The maximum number of results to return in each page. The default is
  100.
- `"NextToken"`:  Identifies the next page of InferSNOMEDCT results to return.
"""
function list_snomedctinference_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return comprehendmedical(
        "ListSNOMEDCTInferenceJobs"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_snomedctinference_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehendmedical(
        "ListSNOMEDCTInferenceJobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_entities_detection_v2_job(data_access_role_arn, input_data_config, language_code, output_data_config)
    start_entities_detection_v2_job(data_access_role_arn, input_data_config, language_code, output_data_config, params::Dict{String,<:Any})

Starts an asynchronous medical entity detection job for a collection of documents. Use the
DescribeEntitiesDetectionV2Job operation to track the status of a job.

# Arguments
- `data_access_role_arn`: The Amazon Resource Name (ARN) of the AWS Identity and Access
  Management (IAM) role that grants Amazon Comprehend Medical read access to your input data.
  For more information, see Role-Based Permissions Required for Asynchronous Operations.
- `input_data_config`: The input configuration that specifies the format and location of
  the input data for the job.
- `language_code`: The language of the input documents. All documents must be in the same
  language. Amazon Comprehend Medical processes files in US English (en).
- `output_data_config`: The output configuration that specifies where to send the output
  files.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: A unique identifier for the request. If you don't set the client
  request token, Amazon Comprehend Medical generates one for you.
- `"JobName"`: The identifier of the job.
- `"KMSKey"`: An AWS Key Management Service key to encrypt your output files. If you do not
  specify a key, the files are written in plain text.
"""
function start_entities_detection_v2_job(
    DataAccessRoleArn,
    InputDataConfig,
    LanguageCode,
    OutputDataConfig;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehendmedical(
        "StartEntitiesDetectionV2Job",
        Dict{String,Any}(
            "DataAccessRoleArn" => DataAccessRoleArn,
            "InputDataConfig" => InputDataConfig,
            "LanguageCode" => LanguageCode,
            "OutputDataConfig" => OutputDataConfig,
            "ClientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_entities_detection_v2_job(
    DataAccessRoleArn,
    InputDataConfig,
    LanguageCode,
    OutputDataConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehendmedical(
        "StartEntitiesDetectionV2Job",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DataAccessRoleArn" => DataAccessRoleArn,
                    "InputDataConfig" => InputDataConfig,
                    "LanguageCode" => LanguageCode,
                    "OutputDataConfig" => OutputDataConfig,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_icd10_cminference_job(data_access_role_arn, input_data_config, language_code, output_data_config)
    start_icd10_cminference_job(data_access_role_arn, input_data_config, language_code, output_data_config, params::Dict{String,<:Any})

Starts an asynchronous job to detect medical conditions and link them to the ICD-10-CM
ontology. Use the DescribeICD10CMInferenceJob operation to track the status of a job.

# Arguments
- `data_access_role_arn`: The Amazon Resource Name (ARN) of the AWS Identity and Access
  Management (IAM) role that grants Amazon Comprehend Medical read access to your input data.
  For more information, see  Role-Based Permissions Required for Asynchronous Operations.
- `input_data_config`: Specifies the format and location of the input data for the job.
- `language_code`: The language of the input documents. All documents must be in the same
  language.
- `output_data_config`: Specifies where to send the output files.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: A unique identifier for the request. If you don't set the client
  request token, Amazon Comprehend Medical generates one.
- `"JobName"`: The identifier of the job.
- `"KMSKey"`: An AWS Key Management Service key to encrypt your output files. If you do not
  specify a key, the files are written in plain text.
"""
function start_icd10_cminference_job(
    DataAccessRoleArn,
    InputDataConfig,
    LanguageCode,
    OutputDataConfig;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehendmedical(
        "StartICD10CMInferenceJob",
        Dict{String,Any}(
            "DataAccessRoleArn" => DataAccessRoleArn,
            "InputDataConfig" => InputDataConfig,
            "LanguageCode" => LanguageCode,
            "OutputDataConfig" => OutputDataConfig,
            "ClientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_icd10_cminference_job(
    DataAccessRoleArn,
    InputDataConfig,
    LanguageCode,
    OutputDataConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehendmedical(
        "StartICD10CMInferenceJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DataAccessRoleArn" => DataAccessRoleArn,
                    "InputDataConfig" => InputDataConfig,
                    "LanguageCode" => LanguageCode,
                    "OutputDataConfig" => OutputDataConfig,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_phidetection_job(data_access_role_arn, input_data_config, language_code, output_data_config)
    start_phidetection_job(data_access_role_arn, input_data_config, language_code, output_data_config, params::Dict{String,<:Any})

Starts an asynchronous job to detect protected health information (PHI). Use the
DescribePHIDetectionJob operation to track the status of a job.

# Arguments
- `data_access_role_arn`: The Amazon Resource Name (ARN) of the AWS Identity and Access
  Management (IAM) role that grants Amazon Comprehend Medical read access to your input data.
  For more information, see  Role-Based Permissions Required for Asynchronous Operations.
- `input_data_config`: Specifies the format and location of the input data for the job.
- `language_code`: The language of the input documents. All documents must be in the same
  language.
- `output_data_config`: Specifies where to send the output files.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: A unique identifier for the request. If you don't set the client
  request token, Amazon Comprehend Medical generates one.
- `"JobName"`: The identifier of the job.
- `"KMSKey"`: An AWS Key Management Service key to encrypt your output files. If you do not
  specify a key, the files are written in plain text.
"""
function start_phidetection_job(
    DataAccessRoleArn,
    InputDataConfig,
    LanguageCode,
    OutputDataConfig;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehendmedical(
        "StartPHIDetectionJob",
        Dict{String,Any}(
            "DataAccessRoleArn" => DataAccessRoleArn,
            "InputDataConfig" => InputDataConfig,
            "LanguageCode" => LanguageCode,
            "OutputDataConfig" => OutputDataConfig,
            "ClientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_phidetection_job(
    DataAccessRoleArn,
    InputDataConfig,
    LanguageCode,
    OutputDataConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehendmedical(
        "StartPHIDetectionJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DataAccessRoleArn" => DataAccessRoleArn,
                    "InputDataConfig" => InputDataConfig,
                    "LanguageCode" => LanguageCode,
                    "OutputDataConfig" => OutputDataConfig,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_rx_norm_inference_job(data_access_role_arn, input_data_config, language_code, output_data_config)
    start_rx_norm_inference_job(data_access_role_arn, input_data_config, language_code, output_data_config, params::Dict{String,<:Any})

Starts an asynchronous job to detect medication entities and link them to the RxNorm
ontology. Use the DescribeRxNormInferenceJob operation to track the status of a job.

# Arguments
- `data_access_role_arn`: The Amazon Resource Name (ARN) of the AWS Identity and Access
  Management (IAM) role that grants Amazon Comprehend Medical read access to your input data.
  For more information, see  Role-Based Permissions Required for Asynchronous Operations.
- `input_data_config`: Specifies the format and location of the input data for the job.
- `language_code`: The language of the input documents. All documents must be in the same
  language.
- `output_data_config`: Specifies where to send the output files.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: A unique identifier for the request. If you don't set the client
  request token, Amazon Comprehend Medical generates one.
- `"JobName"`: The identifier of the job.
- `"KMSKey"`: An AWS Key Management Service key to encrypt your output files. If you do not
  specify a key, the files are written in plain text.
"""
function start_rx_norm_inference_job(
    DataAccessRoleArn,
    InputDataConfig,
    LanguageCode,
    OutputDataConfig;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehendmedical(
        "StartRxNormInferenceJob",
        Dict{String,Any}(
            "DataAccessRoleArn" => DataAccessRoleArn,
            "InputDataConfig" => InputDataConfig,
            "LanguageCode" => LanguageCode,
            "OutputDataConfig" => OutputDataConfig,
            "ClientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_rx_norm_inference_job(
    DataAccessRoleArn,
    InputDataConfig,
    LanguageCode,
    OutputDataConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehendmedical(
        "StartRxNormInferenceJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DataAccessRoleArn" => DataAccessRoleArn,
                    "InputDataConfig" => InputDataConfig,
                    "LanguageCode" => LanguageCode,
                    "OutputDataConfig" => OutputDataConfig,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_snomedctinference_job(data_access_role_arn, input_data_config, language_code, output_data_config)
    start_snomedctinference_job(data_access_role_arn, input_data_config, language_code, output_data_config, params::Dict{String,<:Any})

 Starts an asynchronous job to detect medical concepts and link them to the SNOMED-CT
ontology. Use the DescribeSNOMEDCTInferenceJob operation to track the status of a job.

# Arguments
- `data_access_role_arn`:  The Amazon Resource Name (ARN) of the AWS Identity and Access
  Management (IAM) role that grants Amazon Comprehend Medical read access to your input data.
- `input_data_config`:
- `language_code`:  The language of the input documents. All documents must be in the same
  language.
- `output_data_config`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`:  A unique identifier for the request. If you don't set the client
  request token, Amazon Comprehend Medical generates one.
- `"JobName"`:  The user generated name the asynchronous InferSNOMEDCT job.
- `"KMSKey"`:  An AWS Key Management Service key used to encrypt your output files. If you
  do not specify a key, the files are written in plain text.
"""
function start_snomedctinference_job(
    DataAccessRoleArn,
    InputDataConfig,
    LanguageCode,
    OutputDataConfig;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehendmedical(
        "StartSNOMEDCTInferenceJob",
        Dict{String,Any}(
            "DataAccessRoleArn" => DataAccessRoleArn,
            "InputDataConfig" => InputDataConfig,
            "LanguageCode" => LanguageCode,
            "OutputDataConfig" => OutputDataConfig,
            "ClientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_snomedctinference_job(
    DataAccessRoleArn,
    InputDataConfig,
    LanguageCode,
    OutputDataConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehendmedical(
        "StartSNOMEDCTInferenceJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DataAccessRoleArn" => DataAccessRoleArn,
                    "InputDataConfig" => InputDataConfig,
                    "LanguageCode" => LanguageCode,
                    "OutputDataConfig" => OutputDataConfig,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_entities_detection_v2_job(job_id)
    stop_entities_detection_v2_job(job_id, params::Dict{String,<:Any})

Stops a medical entities detection job in progress.

# Arguments
- `job_id`: The identifier of the medical entities job to stop.

"""
function stop_entities_detection_v2_job(
    JobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehendmedical(
        "StopEntitiesDetectionV2Job",
        Dict{String,Any}("JobId" => JobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_entities_detection_v2_job(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehendmedical(
        "StopEntitiesDetectionV2Job",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("JobId" => JobId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_icd10_cminference_job(job_id)
    stop_icd10_cminference_job(job_id, params::Dict{String,<:Any})

Stops an InferICD10CM inference job in progress.

# Arguments
- `job_id`: The identifier of the job.

"""
function stop_icd10_cminference_job(
    JobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehendmedical(
        "StopICD10CMInferenceJob",
        Dict{String,Any}("JobId" => JobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_icd10_cminference_job(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehendmedical(
        "StopICD10CMInferenceJob",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("JobId" => JobId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_phidetection_job(job_id)
    stop_phidetection_job(job_id, params::Dict{String,<:Any})

Stops a protected health information (PHI) detection job in progress.

# Arguments
- `job_id`: The identifier of the PHI detection job to stop.

"""
function stop_phidetection_job(JobId; aws_config::AbstractAWSConfig=current_aws_config())
    return comprehendmedical(
        "StopPHIDetectionJob",
        Dict{String,Any}("JobId" => JobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_phidetection_job(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehendmedical(
        "StopPHIDetectionJob",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("JobId" => JobId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_rx_norm_inference_job(job_id)
    stop_rx_norm_inference_job(job_id, params::Dict{String,<:Any})

Stops an InferRxNorm inference job in progress.

# Arguments
- `job_id`: The identifier of the job.

"""
function stop_rx_norm_inference_job(
    JobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehendmedical(
        "StopRxNormInferenceJob",
        Dict{String,Any}("JobId" => JobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_rx_norm_inference_job(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehendmedical(
        "StopRxNormInferenceJob",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("JobId" => JobId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_snomedctinference_job(job_id)
    stop_snomedctinference_job(job_id, params::Dict{String,<:Any})

 Stops an InferSNOMEDCT inference job in progress.

# Arguments
- `job_id`:  The job id of the asynchronous InferSNOMEDCT job to be stopped.

"""
function stop_snomedctinference_job(
    JobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehendmedical(
        "StopSNOMEDCTInferenceJob",
        Dict{String,Any}("JobId" => JobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_snomedctinference_job(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehendmedical(
        "StopSNOMEDCTInferenceJob",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("JobId" => JobId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: artifact
using AWS.Compat
using AWS.UUIDs

"""
    get_account_settings()
    get_account_settings(params::Dict{String,<:Any})

Get the account settings for Artifact.

"""
function get_account_settings(; aws_config::AbstractAWSConfig=current_aws_config())
    return artifact(
        "GET",
        "/v1/account-settings/get";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_account_settings(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return artifact(
        "GET",
        "/v1/account-settings/get",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_report(report_id, term_token)
    get_report(report_id, term_token, params::Dict{String,<:Any})

Get the content for a single report.

# Arguments
- `report_id`: Unique resource ID for the report resource.
- `term_token`: Unique download token provided by GetTermForReport API.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"reportVersion"`: Version for the report resource.
"""
function get_report(reportId, termToken; aws_config::AbstractAWSConfig=current_aws_config())
    return artifact(
        "GET",
        "/v1/report/get",
        Dict{String,Any}("reportId" => reportId, "termToken" => termToken);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_report(
    reportId,
    termToken,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return artifact(
        "GET",
        "/v1/report/get",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("reportId" => reportId, "termToken" => termToken),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_report_metadata(report_id)
    get_report_metadata(report_id, params::Dict{String,<:Any})

Get the metadata for a single report.

# Arguments
- `report_id`: Unique resource ID for the report resource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"reportVersion"`: Version for the report resource.
"""
function get_report_metadata(reportId; aws_config::AbstractAWSConfig=current_aws_config())
    return artifact(
        "GET",
        "/v1/report/getMetadata",
        Dict{String,Any}("reportId" => reportId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_report_metadata(
    reportId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return artifact(
        "GET",
        "/v1/report/getMetadata",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("reportId" => reportId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_term_for_report(report_id)
    get_term_for_report(report_id, params::Dict{String,<:Any})

Get the Term content associated with a single report.

# Arguments
- `report_id`: Unique resource ID for the report resource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"reportVersion"`: Version for the report resource.
"""
function get_term_for_report(reportId; aws_config::AbstractAWSConfig=current_aws_config())
    return artifact(
        "GET",
        "/v1/report/getTermForReport",
        Dict{String,Any}("reportId" => reportId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_term_for_report(
    reportId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return artifact(
        "GET",
        "/v1/report/getTermForReport",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("reportId" => reportId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_reports()
    list_reports(params::Dict{String,<:Any})

List available reports.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Maximum number of resources to return in the paginated response.
- `"nextToken"`: Pagination token to request the next page of resources.
"""
function list_reports(; aws_config::AbstractAWSConfig=current_aws_config())
    return artifact(
        "GET", "/v1/report/list"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_reports(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return artifact(
        "GET",
        "/v1/report/list",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_account_settings()
    put_account_settings(params::Dict{String,<:Any})

Put the account settings for Artifact.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"notificationSubscriptionStatus"`: Desired notification subscription status.
"""
function put_account_settings(; aws_config::AbstractAWSConfig=current_aws_config())
    return artifact(
        "PUT",
        "/v1/account-settings/put";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_account_settings(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return artifact(
        "PUT",
        "/v1/account-settings/put",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: machine_learning
using AWS.Compat
using AWS.UUIDs

"""
    add_tags(resource_id, resource_type, tags)
    add_tags(resource_id, resource_type, tags, params::Dict{String,<:Any})

Adds one or more tags to an object, up to a limit of 10. Each tag consists of a key and an
optional value. If you add a tag using a key that is already associated with the ML object,
AddTags updates the tag's value.

# Arguments
- `resource_id`: The ID of the ML object to tag. For example, exampleModelId.
- `resource_type`: The type of the ML object to tag.
- `tags`: The key-value pairs to use to create tags. If you specify a key without
  specifying a value, Amazon ML creates a tag with the specified key and a value of null.

"""
function add_tags(
    ResourceId, ResourceType, Tags; aws_config::AbstractAWSConfig=current_aws_config()
)
    return machine_learning(
        "AddTags",
        Dict{String,Any}(
            "ResourceId" => ResourceId, "ResourceType" => ResourceType, "Tags" => Tags
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_tags(
    ResourceId,
    ResourceType,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return machine_learning(
        "AddTags",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ResourceId" => ResourceId,
                    "ResourceType" => ResourceType,
                    "Tags" => Tags,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_batch_prediction(batch_prediction_data_source_id, batch_prediction_id, mlmodel_id, output_uri)
    create_batch_prediction(batch_prediction_data_source_id, batch_prediction_id, mlmodel_id, output_uri, params::Dict{String,<:Any})

Generates predictions for a group of observations. The observations to process exist in one
or more data files referenced by a DataSource. This operation creates a new
BatchPrediction, and uses an MLModel and the data files referenced by the DataSource as
information sources.   CreateBatchPrediction is an asynchronous operation. In response to
CreateBatchPrediction, Amazon Machine Learning (Amazon ML) immediately returns and sets the
BatchPrediction status to PENDING. After the BatchPrediction completes, Amazon ML sets the
status to COMPLETED.  You can poll for status updates by using the GetBatchPrediction
operation and checking the Status parameter of the result. After the COMPLETED status
appears, the results are available in the location specified by the OutputUri parameter.

# Arguments
- `batch_prediction_data_source_id`: The ID of the DataSource that points to the group of
  observations to predict.
- `batch_prediction_id`: A user-supplied ID that uniquely identifies the BatchPrediction.
- `mlmodel_id`: The ID of the MLModel that will generate predictions for the group of
  observations.
- `output_uri`: The location of an Amazon Simple Storage Service (Amazon S3) bucket or
  directory to store the batch prediction results. The following substrings are not allowed
  in the s3 key portion of the outputURI field: ':', '//', '/./', '/../'. Amazon ML needs
  permissions to store and retrieve the logs on your behalf. For information about how to set
  permissions, see the Amazon Machine Learning Developer Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"BatchPredictionName"`: A user-supplied name or description of the BatchPrediction.
  BatchPredictionName can only use the UTF-8 character set.
"""
function create_batch_prediction(
    BatchPredictionDataSourceId,
    BatchPredictionId,
    MLModelId,
    OutputUri;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return machine_learning(
        "CreateBatchPrediction",
        Dict{String,Any}(
            "BatchPredictionDataSourceId" => BatchPredictionDataSourceId,
            "BatchPredictionId" => BatchPredictionId,
            "MLModelId" => MLModelId,
            "OutputUri" => OutputUri,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_batch_prediction(
    BatchPredictionDataSourceId,
    BatchPredictionId,
    MLModelId,
    OutputUri,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return machine_learning(
        "CreateBatchPrediction",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "BatchPredictionDataSourceId" => BatchPredictionDataSourceId,
                    "BatchPredictionId" => BatchPredictionId,
                    "MLModelId" => MLModelId,
                    "OutputUri" => OutputUri,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_data_source_from_rds(data_source_id, rdsdata, role_arn)
    create_data_source_from_rds(data_source_id, rdsdata, role_arn, params::Dict{String,<:Any})

Creates a DataSource object from an  Amazon Relational Database Service (Amazon RDS). A
DataSource references data that can be used to perform CreateMLModel, CreateEvaluation, or
CreateBatchPrediction operations.  CreateDataSourceFromRDS is an asynchronous operation. In
response to CreateDataSourceFromRDS, Amazon Machine Learning (Amazon ML) immediately
returns and sets the DataSource status to PENDING. After the DataSource is created and
ready for use, Amazon ML sets the Status parameter to COMPLETED. DataSource in the
COMPLETED or PENDING state can be used only to perform &gt;CreateMLModel&gt;,
CreateEvaluation, or CreateBatchPrediction operations.   If Amazon ML cannot accept the
input source, it sets the Status parameter to FAILED and includes an error message in the
Message attribute of the GetDataSource operation response.

# Arguments
- `data_source_id`: A user-supplied ID that uniquely identifies the DataSource. Typically,
  an Amazon Resource Number (ARN) becomes the ID for a DataSource.
- `rdsdata`: The data specification of an Amazon RDS DataSource:   DatabaseInformation -
  DatabaseName - The name of the Amazon RDS database.    InstanceIdentifier  - A unique
  identifier for the Amazon RDS database instance.     DatabaseCredentials - AWS Identity and
  Access Management (IAM) credentials that are used to connect to the Amazon RDS database.
  ResourceRole - A role (DataPipelineDefaultResourceRole) assumed by an EC2 instance to carry
  out the copy task from Amazon RDS to Amazon Simple Storage Service (Amazon S3). For more
  information, see Role templates for data pipelines.   ServiceRole - A role
  (DataPipelineDefaultRole) assumed by the AWS Data Pipeline service to monitor the progress
  of the copy task from Amazon RDS to Amazon S3. For more information, see Role templates for
  data pipelines.   SecurityInfo - The security information to use to access an RDS DB
  instance. You need to set up appropriate ingress rules for the security entity IDs provided
  to allow access to the Amazon RDS instance. Specify a [SubnetId, SecurityGroupIds] pair for
  a VPC-based RDS DB instance.   SelectSqlQuery - A query that is used to retrieve the
  observation data for the Datasource.   S3StagingLocation - The Amazon S3 location for
  staging Amazon RDS data. The data retrieved from Amazon RDS using SelectSqlQuery is stored
  in this location.   DataSchemaUri - The Amazon S3 location of the DataSchema.   DataSchema
  - A JSON string representing the schema. This is not required if DataSchemaUri is
  specified.    DataRearrangement - A JSON string that represents the splitting and
  rearrangement requirements for the Datasource.   Sample -
  \"{\"splitting\":{\"percentBegin\":10,\"percentEnd\":60}}\"
- `role_arn`: The role that Amazon ML assumes on behalf of the user to create and activate
  a data pipeline in the user's account and copy data using the SelectSqlQuery query from
  Amazon RDS to Amazon S3.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ComputeStatistics"`: The compute statistics for a DataSource. The statistics are
  generated from the observation data referenced by a DataSource. Amazon ML uses the
  statistics internally during MLModel training. This parameter must be set to true if the
  DataSource needs to be used for MLModel training.
- `"DataSourceName"`: A user-supplied name or description of the DataSource.
"""
function create_data_source_from_rds(
    DataSourceId, RDSData, RoleARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return machine_learning(
        "CreateDataSourceFromRDS",
        Dict{String,Any}(
            "DataSourceId" => DataSourceId, "RDSData" => RDSData, "RoleARN" => RoleARN
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_data_source_from_rds(
    DataSourceId,
    RDSData,
    RoleARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return machine_learning(
        "CreateDataSourceFromRDS",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DataSourceId" => DataSourceId,
                    "RDSData" => RDSData,
                    "RoleARN" => RoleARN,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_data_source_from_redshift(data_source_id, data_spec, role_arn)
    create_data_source_from_redshift(data_source_id, data_spec, role_arn, params::Dict{String,<:Any})

Creates a DataSource from a database hosted on an Amazon Redshift cluster. A DataSource
references data that can be used to perform either CreateMLModel, CreateEvaluation, or
CreateBatchPrediction operations.  CreateDataSourceFromRedshift is an asynchronous
operation. In response to CreateDataSourceFromRedshift, Amazon Machine Learning (Amazon ML)
immediately returns and sets the DataSource status to PENDING. After the DataSource is
created and ready for use, Amazon ML sets the Status parameter to COMPLETED. DataSource in
COMPLETED or PENDING states can be used to perform only CreateMLModel, CreateEvaluation, or
CreateBatchPrediction operations.   If Amazon ML can't accept the input source, it sets the
Status parameter to FAILED and includes an error message in the Message attribute of the
GetDataSource operation response.  The observations should be contained in the database
hosted on an Amazon Redshift cluster and should be specified by a SelectSqlQuery query.
Amazon ML executes an Unload command in Amazon Redshift to transfer the result set of the
SelectSqlQuery query to S3StagingLocation. After the DataSource has been created, it's
ready for use in evaluations and batch predictions. If you plan to use the DataSource to
train an MLModel, the DataSource also requires a recipe. A recipe describes how each input
variable will be used in training an MLModel. Will the variable be included or excluded
from training? Will the variable be manipulated; for example, will it be combined with
another variable or will it be split apart into word combinations? The recipe provides
answers to these questions. You can't change an existing datasource, but you can copy and
modify the settings from an existing Amazon Redshift datasource to create a new datasource.
To do so, call GetDataSource for an existing datasource and copy the values to a
CreateDataSource call. Change the settings that you want to change and make sure that all
required fields have the appropriate values.

# Arguments
- `data_source_id`: A user-supplied ID that uniquely identifies the DataSource.
- `data_spec`: The data specification of an Amazon Redshift DataSource:
  DatabaseInformation -    DatabaseName - The name of the Amazon Redshift database.
  ClusterIdentifier - The unique ID for the Amazon Redshift cluster.     DatabaseCredentials
  - The AWS Identity and Access Management (IAM) credentials that are used to connect to the
  Amazon Redshift database.   SelectSqlQuery - The query that is used to retrieve the
  observation data for the Datasource.   S3StagingLocation - The Amazon Simple Storage
  Service (Amazon S3) location for staging Amazon Redshift data. The data retrieved from
  Amazon Redshift using the SelectSqlQuery query is stored in this location.   DataSchemaUri
  - The Amazon S3 location of the DataSchema.   DataSchema - A JSON string representing the
  schema. This is not required if DataSchemaUri is specified.    DataRearrangement - A JSON
  string that represents the splitting and rearrangement requirements for the DataSource.
  Sample -  \"{\"splitting\":{\"percentBegin\":10,\"percentEnd\":60}}\"
- `role_arn`: A fully specified role Amazon Resource Name (ARN). Amazon ML assumes the role
  on behalf of the user to create the following:   A security group to allow Amazon ML to
  execute the SelectSqlQuery query on an Amazon Redshift cluster   An Amazon S3 bucket policy
  to grant Amazon ML read/write permissions on the S3StagingLocation

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ComputeStatistics"`: The compute statistics for a DataSource. The statistics are
  generated from the observation data referenced by a DataSource. Amazon ML uses the
  statistics internally during MLModel training. This parameter must be set to true if the
  DataSource needs to be used for MLModel training.
- `"DataSourceName"`: A user-supplied name or description of the DataSource.
"""
function create_data_source_from_redshift(
    DataSourceId, DataSpec, RoleARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return machine_learning(
        "CreateDataSourceFromRedshift",
        Dict{String,Any}(
            "DataSourceId" => DataSourceId, "DataSpec" => DataSpec, "RoleARN" => RoleARN
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_data_source_from_redshift(
    DataSourceId,
    DataSpec,
    RoleARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return machine_learning(
        "CreateDataSourceFromRedshift",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DataSourceId" => DataSourceId,
                    "DataSpec" => DataSpec,
                    "RoleARN" => RoleARN,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_data_source_from_s3(data_source_id, data_spec)
    create_data_source_from_s3(data_source_id, data_spec, params::Dict{String,<:Any})

Creates a DataSource object. A DataSource references data that can be used to perform
CreateMLModel, CreateEvaluation, or CreateBatchPrediction operations.
CreateDataSourceFromS3 is an asynchronous operation. In response to CreateDataSourceFromS3,
Amazon Machine Learning (Amazon ML) immediately returns and sets the DataSource status to
PENDING. After the DataSource has been created and is ready for use, Amazon ML sets the
Status parameter to COMPLETED. DataSource in the COMPLETED or PENDING state can be used to
perform only CreateMLModel, CreateEvaluation or CreateBatchPrediction operations.   If
Amazon ML can't accept the input source, it sets the Status parameter to FAILED and
includes an error message in the Message attribute of the GetDataSource operation response.
 The observation data used in a DataSource should be ready to use; that is, it should have
a consistent structure, and missing data values should be kept to a minimum. The
observation data must reside in one or more .csv files in an Amazon Simple Storage Service
(Amazon S3) location, along with a schema that describes the data items by name and type.
The same schema must be used for all of the data files referenced by the DataSource.  After
the DataSource has been created, it's ready to use in evaluations and batch predictions. If
you plan to use the DataSource to train an MLModel, the DataSource also needs a recipe. A
recipe describes how each input variable will be used in training an MLModel. Will the
variable be included or excluded from training? Will the variable be manipulated; for
example, will it be combined with another variable or will it be split apart into word
combinations? The recipe provides answers to these questions.

# Arguments
- `data_source_id`: A user-supplied identifier that uniquely identifies the DataSource.
- `data_spec`: The data specification of a DataSource:   DataLocationS3 - The Amazon S3
  location of the observation data.   DataSchemaLocationS3 - The Amazon S3 location of the
  DataSchema.   DataSchema - A JSON string representing the schema. This is not required if
  DataSchemaUri is specified.    DataRearrangement - A JSON string that represents the
  splitting and rearrangement requirements for the Datasource.   Sample -
  \"{\"splitting\":{\"percentBegin\":10,\"percentEnd\":60}}\"

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ComputeStatistics"`: The compute statistics for a DataSource. The statistics are
  generated from the observation data referenced by a DataSource. Amazon ML uses the
  statistics internally during MLModel training. This parameter must be set to true if the
  DataSource needs to be used for MLModel training.
- `"DataSourceName"`: A user-supplied name or description of the DataSource.
"""
function create_data_source_from_s3(
    DataSourceId, DataSpec; aws_config::AbstractAWSConfig=current_aws_config()
)
    return machine_learning(
        "CreateDataSourceFromS3",
        Dict{String,Any}("DataSourceId" => DataSourceId, "DataSpec" => DataSpec);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_data_source_from_s3(
    DataSourceId,
    DataSpec,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return machine_learning(
        "CreateDataSourceFromS3",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DataSourceId" => DataSourceId, "DataSpec" => DataSpec),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_evaluation(evaluation_data_source_id, evaluation_id, mlmodel_id)
    create_evaluation(evaluation_data_source_id, evaluation_id, mlmodel_id, params::Dict{String,<:Any})

Creates a new Evaluation of an MLModel. An MLModel is evaluated on a set of observations
associated to a DataSource. Like a DataSource for an MLModel, the DataSource for an
Evaluation contains values for the Target Variable. The Evaluation compares the predicted
result for each observation to the actual outcome and provides a summary so that you know
how effective the MLModel functions on the test data. Evaluation generates a relevant
performance metric, such as BinaryAUC, RegressionRMSE or MulticlassAvgFScore based on the
corresponding MLModelType: BINARY, REGRESSION or MULTICLASS.   CreateEvaluation is an
asynchronous operation. In response to CreateEvaluation, Amazon Machine Learning (Amazon
ML) immediately returns and sets the evaluation status to PENDING. After the Evaluation is
created and ready for use, Amazon ML sets the status to COMPLETED.  You can use the
GetEvaluation operation to check progress of the evaluation during the creation operation.

# Arguments
- `evaluation_data_source_id`: The ID of the DataSource for the evaluation. The schema of
  the DataSource must match the schema used to create the MLModel.
- `evaluation_id`: A user-supplied ID that uniquely identifies the Evaluation.
- `mlmodel_id`: The ID of the MLModel to evaluate. The schema used in creating the MLModel
  must match the schema of the DataSource used in the Evaluation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EvaluationName"`: A user-supplied name or description of the Evaluation.
"""
function create_evaluation(
    EvaluationDataSourceId,
    EvaluationId,
    MLModelId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return machine_learning(
        "CreateEvaluation",
        Dict{String,Any}(
            "EvaluationDataSourceId" => EvaluationDataSourceId,
            "EvaluationId" => EvaluationId,
            "MLModelId" => MLModelId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_evaluation(
    EvaluationDataSourceId,
    EvaluationId,
    MLModelId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return machine_learning(
        "CreateEvaluation",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EvaluationDataSourceId" => EvaluationDataSourceId,
                    "EvaluationId" => EvaluationId,
                    "MLModelId" => MLModelId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_mlmodel(mlmodel_id, mlmodel_type, training_data_source_id)
    create_mlmodel(mlmodel_id, mlmodel_type, training_data_source_id, params::Dict{String,<:Any})

Creates a new MLModel using the DataSource and the recipe as information sources.  An
MLModel is nearly immutable. Users can update only the MLModelName and the ScoreThreshold
in an MLModel without creating a new MLModel.   CreateMLModel is an asynchronous operation.
In response to CreateMLModel, Amazon Machine Learning (Amazon ML) immediately returns and
sets the MLModel status to PENDING. After the MLModel has been created and ready is for
use, Amazon ML sets the status to COMPLETED.  You can use the GetMLModel operation to check
the progress of the MLModel during the creation operation.  CreateMLModel requires a
DataSource with computed statistics, which can be created by setting ComputeStatistics to
true in CreateDataSourceFromRDS, CreateDataSourceFromS3, or CreateDataSourceFromRedshift
operations.

# Arguments
- `mlmodel_id`: A user-supplied ID that uniquely identifies the MLModel.
- `mlmodel_type`: The category of supervised learning that this MLModel will address.
  Choose from the following types:   Choose REGRESSION if the MLModel will be used to predict
  a numeric value.   Choose BINARY if the MLModel result has two possible values.   Choose
  MULTICLASS if the MLModel result has a limited number of values.    For more information,
  see the Amazon Machine Learning Developer Guide.
- `training_data_source_id`: The DataSource that points to the training data.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MLModelName"`: A user-supplied name or description of the MLModel.
- `"Parameters"`: A list of the training parameters in the MLModel. The list is implemented
  as a map of key-value pairs. The following is the current set of training parameters:
  sgd.maxMLModelSizeInBytes - The maximum allowed size of the model. Depending on the input
  data, the size of the model might affect its performance.  The value is an integer that
  ranges from 100000 to 2147483648. The default value is 33554432.    sgd.maxPasses - The
  number of times that the training process traverses the observations to build the MLModel.
  The value is an integer that ranges from 1 to 10000. The default value is 10.
  sgd.shuffleType - Whether Amazon ML shuffles the training data. Shuffling the data improves
  a model's ability to find the optimal solution for a variety of data types. The valid
  values are auto and none. The default value is none. We strongly recommend that you shuffle
  your data.    sgd.l1RegularizationAmount - The coefficient regularization L1 norm. It
  controls overfitting the data by penalizing large coefficients. This tends to drive
  coefficients to zero, resulting in a sparse feature set. If you use this parameter, start
  by specifying a small value, such as 1.0E-08. The value is a double that ranges from 0 to
  MAX_DOUBLE. The default is to not use L1 normalization. This parameter can't be used when
  L2 is specified. Use this parameter sparingly.    sgd.l2RegularizationAmount - The
  coefficient regularization L2 norm. It controls overfitting the data by penalizing large
  coefficients. This tends to drive coefficients to small, nonzero values. If you use this
  parameter, start by specifying a small value, such as 1.0E-08. The value is a double that
  ranges from 0 to MAX_DOUBLE. The default is to not use L2 normalization. This parameter
  can't be used when L1 is specified. Use this parameter sparingly.
- `"Recipe"`: The data recipe for creating the MLModel. You must specify either the recipe
  or its URI. If you don't specify a recipe or its URI, Amazon ML creates a default.
- `"RecipeUri"`: The Amazon Simple Storage Service (Amazon S3) location and file name that
  contains the MLModel recipe. You must specify either the recipe or its URI. If you don't
  specify a recipe or its URI, Amazon ML creates a default.
"""
function create_mlmodel(
    MLModelId,
    MLModelType,
    TrainingDataSourceId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return machine_learning(
        "CreateMLModel",
        Dict{String,Any}(
            "MLModelId" => MLModelId,
            "MLModelType" => MLModelType,
            "TrainingDataSourceId" => TrainingDataSourceId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_mlmodel(
    MLModelId,
    MLModelType,
    TrainingDataSourceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return machine_learning(
        "CreateMLModel",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "MLModelId" => MLModelId,
                    "MLModelType" => MLModelType,
                    "TrainingDataSourceId" => TrainingDataSourceId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_realtime_endpoint(mlmodel_id)
    create_realtime_endpoint(mlmodel_id, params::Dict{String,<:Any})

Creates a real-time endpoint for the MLModel. The endpoint contains the URI of the MLModel;
that is, the location to send real-time prediction requests for the specified MLModel.

# Arguments
- `mlmodel_id`: The ID assigned to the MLModel during creation.

"""
function create_realtime_endpoint(
    MLModelId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return machine_learning(
        "CreateRealtimeEndpoint",
        Dict{String,Any}("MLModelId" => MLModelId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_realtime_endpoint(
    MLModelId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return machine_learning(
        "CreateRealtimeEndpoint",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("MLModelId" => MLModelId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_batch_prediction(batch_prediction_id)
    delete_batch_prediction(batch_prediction_id, params::Dict{String,<:Any})

Assigns the DELETED status to a BatchPrediction, rendering it unusable. After using the
DeleteBatchPrediction operation, you can use the GetBatchPrediction operation to verify
that the status of the BatchPrediction changed to DELETED.  Caution: The result of the
DeleteBatchPrediction operation is irreversible.

# Arguments
- `batch_prediction_id`: A user-supplied ID that uniquely identifies the BatchPrediction.

"""
function delete_batch_prediction(
    BatchPredictionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return machine_learning(
        "DeleteBatchPrediction",
        Dict{String,Any}("BatchPredictionId" => BatchPredictionId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_batch_prediction(
    BatchPredictionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return machine_learning(
        "DeleteBatchPrediction",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("BatchPredictionId" => BatchPredictionId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_data_source(data_source_id)
    delete_data_source(data_source_id, params::Dict{String,<:Any})

Assigns the DELETED status to a DataSource, rendering it unusable. After using the
DeleteDataSource operation, you can use the GetDataSource operation to verify that the
status of the DataSource changed to DELETED.  Caution: The results of the DeleteDataSource
operation are irreversible.

# Arguments
- `data_source_id`: A user-supplied ID that uniquely identifies the DataSource.

"""
function delete_data_source(
    DataSourceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return machine_learning(
        "DeleteDataSource",
        Dict{String,Any}("DataSourceId" => DataSourceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_data_source(
    DataSourceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return machine_learning(
        "DeleteDataSource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DataSourceId" => DataSourceId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_evaluation(evaluation_id)
    delete_evaluation(evaluation_id, params::Dict{String,<:Any})

Assigns the DELETED status to an Evaluation, rendering it unusable. After invoking the
DeleteEvaluation operation, you can use the GetEvaluation operation to verify that the
status of the Evaluation changed to DELETED.  Caution: The results of the DeleteEvaluation
operation are irreversible.

# Arguments
- `evaluation_id`: A user-supplied ID that uniquely identifies the Evaluation to delete.

"""
function delete_evaluation(EvaluationId; aws_config::AbstractAWSConfig=current_aws_config())
    return machine_learning(
        "DeleteEvaluation",
        Dict{String,Any}("EvaluationId" => EvaluationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_evaluation(
    EvaluationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return machine_learning(
        "DeleteEvaluation",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("EvaluationId" => EvaluationId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_mlmodel(mlmodel_id)
    delete_mlmodel(mlmodel_id, params::Dict{String,<:Any})

Assigns the DELETED status to an MLModel, rendering it unusable. After using the
DeleteMLModel operation, you can use the GetMLModel operation to verify that the status of
the MLModel changed to DELETED.  Caution: The result of the DeleteMLModel operation is
irreversible.

# Arguments
- `mlmodel_id`: A user-supplied ID that uniquely identifies the MLModel.

"""
function delete_mlmodel(MLModelId; aws_config::AbstractAWSConfig=current_aws_config())
    return machine_learning(
        "DeleteMLModel",
        Dict{String,Any}("MLModelId" => MLModelId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_mlmodel(
    MLModelId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return machine_learning(
        "DeleteMLModel",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("MLModelId" => MLModelId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_realtime_endpoint(mlmodel_id)
    delete_realtime_endpoint(mlmodel_id, params::Dict{String,<:Any})

Deletes a real time endpoint of an MLModel.

# Arguments
- `mlmodel_id`: The ID assigned to the MLModel during creation.

"""
function delete_realtime_endpoint(
    MLModelId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return machine_learning(
        "DeleteRealtimeEndpoint",
        Dict{String,Any}("MLModelId" => MLModelId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_realtime_endpoint(
    MLModelId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return machine_learning(
        "DeleteRealtimeEndpoint",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("MLModelId" => MLModelId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_tags(resource_id, resource_type, tag_keys)
    delete_tags(resource_id, resource_type, tag_keys, params::Dict{String,<:Any})

Deletes the specified tags associated with an ML object. After this operation is complete,
you can't recover deleted tags. If you specify a tag that doesn't exist, Amazon ML ignores
it.

# Arguments
- `resource_id`: The ID of the tagged ML object. For example, exampleModelId.
- `resource_type`: The type of the tagged ML object.
- `tag_keys`: One or more tags to delete.

"""
function delete_tags(
    ResourceId, ResourceType, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return machine_learning(
        "DeleteTags",
        Dict{String,Any}(
            "ResourceId" => ResourceId, "ResourceType" => ResourceType, "TagKeys" => TagKeys
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_tags(
    ResourceId,
    ResourceType,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return machine_learning(
        "DeleteTags",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ResourceId" => ResourceId,
                    "ResourceType" => ResourceType,
                    "TagKeys" => TagKeys,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_batch_predictions()
    describe_batch_predictions(params::Dict{String,<:Any})

Returns a list of BatchPrediction operations that match the search criteria in the request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EQ"`: The equal to operator. The BatchPrediction results will have FilterVariable
  values that exactly match the value specified with EQ.
- `"FilterVariable"`: Use one of the following variables to filter a list of
  BatchPrediction:    CreatedAt - Sets the search criteria to the BatchPrediction creation
  date.    Status - Sets the search criteria to the BatchPrediction status.    Name - Sets
  the search criteria to the contents of the BatchPrediction   Name.    IAMUser - Sets the
  search criteria to the user account that invoked the BatchPrediction creation.    MLModelId
  - Sets the search criteria to the MLModel used in the BatchPrediction.    DataSourceId -
  Sets the search criteria to the DataSource used in the BatchPrediction.    DataURI - Sets
  the search criteria to the data file(s) used in the BatchPrediction. The URL can identify
  either a file or an Amazon Simple Storage Solution (Amazon S3) bucket or directory.
- `"GE"`: The greater than or equal to operator. The BatchPrediction results will have
  FilterVariable values that are greater than or equal to the value specified with GE.
- `"GT"`: The greater than operator. The BatchPrediction results will have FilterVariable
  values that are greater than the value specified with GT.
- `"LE"`: The less than or equal to operator. The BatchPrediction results will have
  FilterVariable values that are less than or equal to the value specified with LE.
- `"LT"`: The less than operator. The BatchPrediction results will have FilterVariable
  values that are less than the value specified with LT.
- `"Limit"`: The number of pages of information to include in the result. The range of
  acceptable values is 1 through 100. The default value is 100.
- `"NE"`: The not equal to operator. The BatchPrediction results will have FilterVariable
  values not equal to the value specified with NE.
- `"NextToken"`: An ID of the page in the paginated results.
- `"Prefix"`: A string that is found at the beginning of a variable, such as Name or Id.
  For example, a Batch Prediction operation could have the Name 2014-09-09-HolidayGiftMailer.
  To search for this BatchPrediction, select Name for the FilterVariable and any of the
  following strings for the Prefix:    2014-09   2014-09-09   2014-09-09-Holiday
- `"SortOrder"`: A two-value parameter that determines the sequence of the resulting list
  of MLModels.    asc - Arranges the list in ascending order (A-Z, 0-9).    dsc - Arranges
  the list in descending order (Z-A, 9-0).   Results are sorted by FilterVariable.
"""
function describe_batch_predictions(; aws_config::AbstractAWSConfig=current_aws_config())
    return machine_learning(
        "DescribeBatchPredictions"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_batch_predictions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return machine_learning(
        "DescribeBatchPredictions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_data_sources()
    describe_data_sources(params::Dict{String,<:Any})

Returns a list of DataSource that match the search criteria in the request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EQ"`: The equal to operator. The DataSource results will have FilterVariable values
  that exactly match the value specified with EQ.
- `"FilterVariable"`: Use one of the following variables to filter a list of DataSource:
  CreatedAt - Sets the search criteria to DataSource creation dates.    Status - Sets the
  search criteria to DataSource statuses.    Name - Sets the search criteria to the contents
  of DataSource Name.    DataUri - Sets the search criteria to the URI of data files used to
  create the DataSource. The URI can identify either a file or an Amazon Simple Storage
  Service (Amazon S3) bucket or directory.    IAMUser - Sets the search criteria to the user
  account that invoked the DataSource creation.
- `"GE"`: The greater than or equal to operator. The DataSource results will have
  FilterVariable values that are greater than or equal to the value specified with GE.
- `"GT"`: The greater than operator. The DataSource results will have FilterVariable values
  that are greater than the value specified with GT.
- `"LE"`: The less than or equal to operator. The DataSource results will have
  FilterVariable values that are less than or equal to the value specified with LE.
- `"LT"`: The less than operator. The DataSource results will have FilterVariable values
  that are less than the value specified with LT.
- `"Limit"`:  The maximum number of DataSource to include in the result.
- `"NE"`: The not equal to operator. The DataSource results will have FilterVariable values
  not equal to the value specified with NE.
- `"NextToken"`: The ID of the page in the paginated results.
- `"Prefix"`: A string that is found at the beginning of a variable, such as Name or Id.
  For example, a DataSource could have the Name 2014-09-09-HolidayGiftMailer. To search for
  this DataSource, select Name for the FilterVariable and any of the following strings for
  the Prefix:    2014-09   2014-09-09   2014-09-09-Holiday
- `"SortOrder"`: A two-value parameter that determines the sequence of the resulting list
  of DataSource.    asc - Arranges the list in ascending order (A-Z, 0-9).    dsc - Arranges
  the list in descending order (Z-A, 9-0).   Results are sorted by FilterVariable.
"""
function describe_data_sources(; aws_config::AbstractAWSConfig=current_aws_config())
    return machine_learning(
        "DescribeDataSources"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_data_sources(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return machine_learning(
        "DescribeDataSources",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_evaluations()
    describe_evaluations(params::Dict{String,<:Any})

Returns a list of DescribeEvaluations that match the search criteria in the request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EQ"`: The equal to operator. The Evaluation results will have FilterVariable values
  that exactly match the value specified with EQ.
- `"FilterVariable"`: Use one of the following variable to filter a list of Evaluation
  objects:    CreatedAt - Sets the search criteria to the Evaluation creation date.    Status
  - Sets the search criteria to the Evaluation status.    Name - Sets the search criteria to
  the contents of Evaluation   Name.    IAMUser - Sets the search criteria to the user
  account that invoked an Evaluation.    MLModelId - Sets the search criteria to the MLModel
  that was evaluated.    DataSourceId - Sets the search criteria to the DataSource used in
  Evaluation.    DataUri - Sets the search criteria to the data file(s) used in Evaluation.
  The URL can identify either a file or an Amazon Simple Storage Solution (Amazon S3) bucket
  or directory.
- `"GE"`: The greater than or equal to operator. The Evaluation results will have
  FilterVariable values that are greater than or equal to the value specified with GE.
- `"GT"`: The greater than operator. The Evaluation results will have FilterVariable values
  that are greater than the value specified with GT.
- `"LE"`: The less than or equal to operator. The Evaluation results will have
  FilterVariable values that are less than or equal to the value specified with LE.
- `"LT"`: The less than operator. The Evaluation results will have FilterVariable values
  that are less than the value specified with LT.
- `"Limit"`:  The maximum number of Evaluation to include in the result.
- `"NE"`: The not equal to operator. The Evaluation results will have FilterVariable values
  not equal to the value specified with NE.
- `"NextToken"`: The ID of the page in the paginated results.
- `"Prefix"`: A string that is found at the beginning of a variable, such as Name or Id.
  For example, an Evaluation could have the Name 2014-09-09-HolidayGiftMailer. To search for
  this Evaluation, select Name for the FilterVariable and any of the following strings for
  the Prefix:    2014-09   2014-09-09   2014-09-09-Holiday
- `"SortOrder"`: A two-value parameter that determines the sequence of the resulting list
  of Evaluation.    asc - Arranges the list in ascending order (A-Z, 0-9).    dsc - Arranges
  the list in descending order (Z-A, 9-0).   Results are sorted by FilterVariable.
"""
function describe_evaluations(; aws_config::AbstractAWSConfig=current_aws_config())
    return machine_learning(
        "DescribeEvaluations"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_evaluations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return machine_learning(
        "DescribeEvaluations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_mlmodels()
    describe_mlmodels(params::Dict{String,<:Any})

Returns a list of MLModel that match the search criteria in the request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EQ"`: The equal to operator. The MLModel results will have FilterVariable values that
  exactly match the value specified with EQ.
- `"FilterVariable"`: Use one of the following variables to filter a list of MLModel:
  CreatedAt - Sets the search criteria to MLModel creation date.    Status - Sets the search
  criteria to MLModel status.    Name - Sets the search criteria to the contents of MLModel
  Name.    IAMUser - Sets the search criteria to the user account that invoked the MLModel
  creation.    TrainingDataSourceId - Sets the search criteria to the DataSource used to
  train one or more MLModel.    RealtimeEndpointStatus - Sets the search criteria to the
  MLModel real-time endpoint status.    MLModelType - Sets the search criteria to MLModel
  type: binary, regression, or multi-class.    Algorithm - Sets the search criteria to the
  algorithm that the MLModel uses.    TrainingDataURI - Sets the search criteria to the data
  file(s) used in training a MLModel. The URL can identify either a file or an Amazon Simple
  Storage Service (Amazon S3) bucket or directory.
- `"GE"`: The greater than or equal to operator. The MLModel results will have
  FilterVariable values that are greater than or equal to the value specified with GE.
- `"GT"`: The greater than operator. The MLModel results will have FilterVariable values
  that are greater than the value specified with GT.
- `"LE"`: The less than or equal to operator. The MLModel results will have FilterVariable
  values that are less than or equal to the value specified with LE.
- `"LT"`: The less than operator. The MLModel results will have FilterVariable values that
  are less than the value specified with LT.
- `"Limit"`: The number of pages of information to include in the result. The range of
  acceptable values is 1 through 100. The default value is 100.
- `"NE"`: The not equal to operator. The MLModel results will have FilterVariable values
  not equal to the value specified with NE.
- `"NextToken"`: The ID of the page in the paginated results.
- `"Prefix"`: A string that is found at the beginning of a variable, such as Name or Id.
  For example, an MLModel could have the Name 2014-09-09-HolidayGiftMailer. To search for
  this MLModel, select Name for the FilterVariable and any of the following strings for the
  Prefix:    2014-09   2014-09-09   2014-09-09-Holiday
- `"SortOrder"`: A two-value parameter that determines the sequence of the resulting list
  of MLModel.    asc - Arranges the list in ascending order (A-Z, 0-9).    dsc - Arranges the
  list in descending order (Z-A, 9-0).   Results are sorted by FilterVariable.
"""
function describe_mlmodels(; aws_config::AbstractAWSConfig=current_aws_config())
    return machine_learning(
        "DescribeMLModels"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_mlmodels(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return machine_learning(
        "DescribeMLModels", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_tags(resource_id, resource_type)
    describe_tags(resource_id, resource_type, params::Dict{String,<:Any})

Describes one or more of the tags for your Amazon ML object.

# Arguments
- `resource_id`: The ID of the ML object. For example, exampleModelId.
- `resource_type`: The type of the ML object.

"""
function describe_tags(
    ResourceId, ResourceType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return machine_learning(
        "DescribeTags",
        Dict{String,Any}("ResourceId" => ResourceId, "ResourceType" => ResourceType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_tags(
    ResourceId,
    ResourceType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return machine_learning(
        "DescribeTags",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ResourceId" => ResourceId, "ResourceType" => ResourceType
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_batch_prediction(batch_prediction_id)
    get_batch_prediction(batch_prediction_id, params::Dict{String,<:Any})

Returns a BatchPrediction that includes detailed metadata, status, and data file
information for a Batch Prediction request.

# Arguments
- `batch_prediction_id`: An ID assigned to the BatchPrediction at creation.

"""
function get_batch_prediction(
    BatchPredictionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return machine_learning(
        "GetBatchPrediction",
        Dict{String,Any}("BatchPredictionId" => BatchPredictionId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_batch_prediction(
    BatchPredictionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return machine_learning(
        "GetBatchPrediction",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("BatchPredictionId" => BatchPredictionId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_data_source(data_source_id)
    get_data_source(data_source_id, params::Dict{String,<:Any})

Returns a DataSource that includes metadata and data file information, as well as the
current status of the DataSource.  GetDataSource provides results in normal or verbose
format. The verbose format adds the schema description and the list of files pointed to by
the DataSource to the normal format.

# Arguments
- `data_source_id`: The ID assigned to the DataSource at creation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Verbose"`: Specifies whether the GetDataSource operation should return
  DataSourceSchema. If true, DataSourceSchema is returned. If false, DataSourceSchema is not
  returned.
"""
function get_data_source(DataSourceId; aws_config::AbstractAWSConfig=current_aws_config())
    return machine_learning(
        "GetDataSource",
        Dict{String,Any}("DataSourceId" => DataSourceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_data_source(
    DataSourceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return machine_learning(
        "GetDataSource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DataSourceId" => DataSourceId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_evaluation(evaluation_id)
    get_evaluation(evaluation_id, params::Dict{String,<:Any})

Returns an Evaluation that includes metadata as well as the current status of the
Evaluation.

# Arguments
- `evaluation_id`: The ID of the Evaluation to retrieve. The evaluation of each MLModel is
  recorded and cataloged. The ID provides the means to access the information.

"""
function get_evaluation(EvaluationId; aws_config::AbstractAWSConfig=current_aws_config())
    return machine_learning(
        "GetEvaluation",
        Dict{String,Any}("EvaluationId" => EvaluationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_evaluation(
    EvaluationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return machine_learning(
        "GetEvaluation",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("EvaluationId" => EvaluationId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_mlmodel(mlmodel_id)
    get_mlmodel(mlmodel_id, params::Dict{String,<:Any})

Returns an MLModel that includes detailed metadata, data source information, and the
current status of the MLModel.  GetMLModel provides results in normal or verbose format.

# Arguments
- `mlmodel_id`: The ID assigned to the MLModel at creation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Verbose"`: Specifies whether the GetMLModel operation should return Recipe. If true,
  Recipe is returned. If false, Recipe is not returned.
"""
function get_mlmodel(MLModelId; aws_config::AbstractAWSConfig=current_aws_config())
    return machine_learning(
        "GetMLModel",
        Dict{String,Any}("MLModelId" => MLModelId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_mlmodel(
    MLModelId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return machine_learning(
        "GetMLModel",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("MLModelId" => MLModelId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    predict(mlmodel_id, predict_endpoint, record)
    predict(mlmodel_id, predict_endpoint, record, params::Dict{String,<:Any})

Generates a prediction for the observation using the specified ML Model.  Note: Not all
response parameters will be populated. Whether a response parameter is populated depends on
the type of model requested.

# Arguments
- `mlmodel_id`: A unique identifier of the MLModel.
- `predict_endpoint`:
- `record`:

"""
function predict(
    MLModelId, PredictEndpoint, Record; aws_config::AbstractAWSConfig=current_aws_config()
)
    return machine_learning(
        "Predict",
        Dict{String,Any}(
            "MLModelId" => MLModelId,
            "PredictEndpoint" => PredictEndpoint,
            "Record" => Record,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function predict(
    MLModelId,
    PredictEndpoint,
    Record,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return machine_learning(
        "Predict",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "MLModelId" => MLModelId,
                    "PredictEndpoint" => PredictEndpoint,
                    "Record" => Record,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_batch_prediction(batch_prediction_id, batch_prediction_name)
    update_batch_prediction(batch_prediction_id, batch_prediction_name, params::Dict{String,<:Any})

Updates the BatchPredictionName of a BatchPrediction. You can use the GetBatchPrediction
operation to view the contents of the updated data element.

# Arguments
- `batch_prediction_id`: The ID assigned to the BatchPrediction during creation.
- `batch_prediction_name`: A new user-supplied name or description of the BatchPrediction.

"""
function update_batch_prediction(
    BatchPredictionId,
    BatchPredictionName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return machine_learning(
        "UpdateBatchPrediction",
        Dict{String,Any}(
            "BatchPredictionId" => BatchPredictionId,
            "BatchPredictionName" => BatchPredictionName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_batch_prediction(
    BatchPredictionId,
    BatchPredictionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return machine_learning(
        "UpdateBatchPrediction",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "BatchPredictionId" => BatchPredictionId,
                    "BatchPredictionName" => BatchPredictionName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_data_source(data_source_id, data_source_name)
    update_data_source(data_source_id, data_source_name, params::Dict{String,<:Any})

Updates the DataSourceName of a DataSource. You can use the GetDataSource operation to view
the contents of the updated data element.

# Arguments
- `data_source_id`: The ID assigned to the DataSource during creation.
- `data_source_name`: A new user-supplied name or description of the DataSource that will
  replace the current description.

"""
function update_data_source(
    DataSourceId, DataSourceName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return machine_learning(
        "UpdateDataSource",
        Dict{String,Any}(
            "DataSourceId" => DataSourceId, "DataSourceName" => DataSourceName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_data_source(
    DataSourceId,
    DataSourceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return machine_learning(
        "UpdateDataSource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DataSourceId" => DataSourceId, "DataSourceName" => DataSourceName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_evaluation(evaluation_id, evaluation_name)
    update_evaluation(evaluation_id, evaluation_name, params::Dict{String,<:Any})

Updates the EvaluationName of an Evaluation. You can use the GetEvaluation operation to
view the contents of the updated data element.

# Arguments
- `evaluation_id`: The ID assigned to the Evaluation during creation.
- `evaluation_name`: A new user-supplied name or description of the Evaluation that will
  replace the current content.

"""
function update_evaluation(
    EvaluationId, EvaluationName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return machine_learning(
        "UpdateEvaluation",
        Dict{String,Any}(
            "EvaluationId" => EvaluationId, "EvaluationName" => EvaluationName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_evaluation(
    EvaluationId,
    EvaluationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return machine_learning(
        "UpdateEvaluation",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EvaluationId" => EvaluationId, "EvaluationName" => EvaluationName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_mlmodel(mlmodel_id)
    update_mlmodel(mlmodel_id, params::Dict{String,<:Any})

Updates the MLModelName and the ScoreThreshold of an MLModel. You can use the GetMLModel
operation to view the contents of the updated data element.

# Arguments
- `mlmodel_id`: The ID assigned to the MLModel during creation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MLModelName"`: A user-supplied name or description of the MLModel.
- `"ScoreThreshold"`: The ScoreThreshold used in binary classification MLModel that marks
  the boundary between a positive prediction and a negative prediction. Output values greater
  than or equal to the ScoreThreshold receive a positive result from the MLModel, such as
  true. Output values less than the ScoreThreshold receive a negative response from the
  MLModel, such as false.
"""
function update_mlmodel(MLModelId; aws_config::AbstractAWSConfig=current_aws_config())
    return machine_learning(
        "UpdateMLModel",
        Dict{String,Any}("MLModelId" => MLModelId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_mlmodel(
    MLModelId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return machine_learning(
        "UpdateMLModel",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("MLModelId" => MLModelId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: location
using AWS.Compat
using AWS.UUIDs

"""
    associate_tracker_consumer(consumer_arn, tracker_name)
    associate_tracker_consumer(consumer_arn, tracker_name, params::Dict{String,<:Any})

Creates an association between a geofence collection and a tracker resource. This allows
the tracker resource to communicate location data to the linked geofence collection.  You
can associate up to five geofence collections to each tracker resource.  Currently not
supported — Cross-account configurations, such as creating associations between a tracker
resource in one account and a geofence collection in another account.

# Arguments
- `consumer_arn`: The Amazon Resource Name (ARN) for the geofence collection to be
  associated to tracker resource. Used when you need to specify a resource across all Amazon
  Web Services.   Format example:
  arn:aws:geo:region:account-id:geofence-collection/ExampleGeofenceCollectionConsumer
- `tracker_name`: The name of the tracker resource to be associated with a geofence
  collection.

"""
function associate_tracker_consumer(
    ConsumerArn, TrackerName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return location(
        "POST",
        "/tracking/v0/trackers/$(TrackerName)/consumers",
        Dict{String,Any}("ConsumerArn" => ConsumerArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_tracker_consumer(
    ConsumerArn,
    TrackerName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return location(
        "POST",
        "/tracking/v0/trackers/$(TrackerName)/consumers",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ConsumerArn" => ConsumerArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_delete_device_position_history(device_ids, tracker_name)
    batch_delete_device_position_history(device_ids, tracker_name, params::Dict{String,<:Any})

Deletes the position history of one or more devices from a tracker resource.

# Arguments
- `device_ids`: Devices whose position history you want to delete.   For example, for two
  devices: “DeviceIds” : [DeviceId1,DeviceId2]
- `tracker_name`: The name of the tracker resource to delete the device position history
  from.

"""
function batch_delete_device_position_history(
    DeviceIds, TrackerName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return location(
        "POST",
        "/tracking/v0/trackers/$(TrackerName)/delete-positions",
        Dict{String,Any}("DeviceIds" => DeviceIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_delete_device_position_history(
    DeviceIds,
    TrackerName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return location(
        "POST",
        "/tracking/v0/trackers/$(TrackerName)/delete-positions",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DeviceIds" => DeviceIds), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_delete_geofence(collection_name, geofence_ids)
    batch_delete_geofence(collection_name, geofence_ids, params::Dict{String,<:Any})

Deletes a batch of geofences from a geofence collection.  This operation deletes the
resource permanently.

# Arguments
- `collection_name`: The geofence collection storing the geofences to be deleted.
- `geofence_ids`: The batch of geofences to be deleted.

"""
function batch_delete_geofence(
    CollectionName, GeofenceIds; aws_config::AbstractAWSConfig=current_aws_config()
)
    return location(
        "POST",
        "/geofencing/v0/collections/$(CollectionName)/delete-geofences",
        Dict{String,Any}("GeofenceIds" => GeofenceIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_delete_geofence(
    CollectionName,
    GeofenceIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return location(
        "POST",
        "/geofencing/v0/collections/$(CollectionName)/delete-geofences",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("GeofenceIds" => GeofenceIds), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_evaluate_geofences(collection_name, device_position_updates)
    batch_evaluate_geofences(collection_name, device_position_updates, params::Dict{String,<:Any})

Evaluates device positions against the geofence geometries from a given geofence
collection. This operation always returns an empty response because geofences are
asynchronously evaluated. The evaluation determines if the device has entered or exited a
geofenced area, and then publishes one of the following events to Amazon EventBridge:
ENTER if Amazon Location determines that the tracked device has entered a geofenced area.
 EXIT if Amazon Location determines that the tracked device has exited a geofenced area.
The last geofence that a device was observed within is tracked for 30 days after the most
recent device position update.   Geofence evaluation uses the given device position. It
does not account for the optional Accuracy of a DevicePositionUpdate.   The DeviceID is
used as a string to represent the device. You do not need to have a Tracker associated with
the DeviceID.

# Arguments
- `collection_name`: The geofence collection used in evaluating the position of devices
  against its geofences.
- `device_position_updates`: Contains device details for each device to be evaluated
  against the given geofence collection.

"""
function batch_evaluate_geofences(
    CollectionName,
    DevicePositionUpdates;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return location(
        "POST",
        "/geofencing/v0/collections/$(CollectionName)/positions",
        Dict{String,Any}("DevicePositionUpdates" => DevicePositionUpdates);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_evaluate_geofences(
    CollectionName,
    DevicePositionUpdates,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return location(
        "POST",
        "/geofencing/v0/collections/$(CollectionName)/positions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DevicePositionUpdates" => DevicePositionUpdates),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_get_device_position(device_ids, tracker_name)
    batch_get_device_position(device_ids, tracker_name, params::Dict{String,<:Any})

Lists the latest device positions for requested devices.

# Arguments
- `device_ids`: Devices whose position you want to retrieve.   For example, for two
  devices: device-ids=DeviceId1&amp;device-ids=DeviceId2
- `tracker_name`: The tracker resource retrieving the device position.

"""
function batch_get_device_position(
    DeviceIds, TrackerName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return location(
        "POST",
        "/tracking/v0/trackers/$(TrackerName)/get-positions",
        Dict{String,Any}("DeviceIds" => DeviceIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_device_position(
    DeviceIds,
    TrackerName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return location(
        "POST",
        "/tracking/v0/trackers/$(TrackerName)/get-positions",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DeviceIds" => DeviceIds), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_put_geofence(collection_name, entries)
    batch_put_geofence(collection_name, entries, params::Dict{String,<:Any})

A batch request for storing geofence geometries into a given geofence collection, or
updates the geometry of an existing geofence if a geofence ID is included in the request.

# Arguments
- `collection_name`: The geofence collection storing the geofences.
- `entries`: The batch of geofences to be stored in a geofence collection.

"""
function batch_put_geofence(
    CollectionName, Entries; aws_config::AbstractAWSConfig=current_aws_config()
)
    return location(
        "POST",
        "/geofencing/v0/collections/$(CollectionName)/put-geofences",
        Dict{String,Any}("Entries" => Entries);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_put_geofence(
    CollectionName,
    Entries,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return location(
        "POST",
        "/geofencing/v0/collections/$(CollectionName)/put-geofences",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Entries" => Entries), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_update_device_position(tracker_name, updates)
    batch_update_device_position(tracker_name, updates, params::Dict{String,<:Any})

Uploads position update data for one or more devices to a tracker resource (up to 10
devices per batch). Amazon Location uses the data when it reports the last known device
position and position history. Amazon Location retains location data for 30 days.  Position
updates are handled based on the PositionFiltering property of the tracker. When
PositionFiltering is set to TimeBased, updates are evaluated against linked geofence
collections, and location data is stored at a maximum of one position per 30 second
interval. If your update frequency is more often than every 30 seconds, only one update per
30 seconds is stored for each unique device ID. When PositionFiltering is set to
DistanceBased filtering, location data is stored and evaluated against linked geofence
collections only if the device has moved more than 30 m (98.4 ft). When PositionFiltering
is set to AccuracyBased filtering, location data is stored and evaluated against linked
geofence collections only if the device has moved more than the measured accuracy. For
example, if two consecutive updates from a device have a horizontal accuracy of 5 m and 10
m, the second update is neither stored or evaluated if the device has moved less than 15 m.
If PositionFiltering is set to AccuracyBased filtering, Amazon Location uses the default
value { \"Horizontal\": 0} when accuracy is not provided on a DevicePositionUpdate.

# Arguments
- `tracker_name`: The name of the tracker resource to update.
- `updates`: Contains the position update details for each device, up to 10 devices.

"""
function batch_update_device_position(
    TrackerName, Updates; aws_config::AbstractAWSConfig=current_aws_config()
)
    return location(
        "POST",
        "/tracking/v0/trackers/$(TrackerName)/positions",
        Dict{String,Any}("Updates" => Updates);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_update_device_position(
    TrackerName,
    Updates,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return location(
        "POST",
        "/tracking/v0/trackers/$(TrackerName)/positions",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Updates" => Updates), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    calculate_route(calculator_name, departure_position, destination_position)
    calculate_route(calculator_name, departure_position, destination_position, params::Dict{String,<:Any})

 Calculates a route given the following required parameters: DeparturePosition and
DestinationPosition. Requires that you first create a route calculator resource. By
default, a request that doesn't specify a departure time uses the best time of day to
travel with the best traffic conditions when calculating the route. Additional options
include:    Specifying a departure time using either DepartureTime or DepartNow. This
calculates a route based on predictive traffic data at the given time.   You can't specify
both DepartureTime and DepartNow in a single request. Specifying both parameters returns a
validation error.     Specifying a travel mode using TravelMode sets the transportation
mode used to calculate the routes. This also lets you specify additional route preferences
in CarModeOptions if traveling by Car, or TruckModeOptions if traveling by Truck.  If you
specify walking for the travel mode and your data provider is Esri, the start and
destination must be within 40km.

# Arguments
- `calculator_name`: The name of the route calculator resource that you want to use to
  calculate the route.
- `departure_position`: The start position for the route. Defined in World Geodetic System
  (WGS 84) format: [longitude, latitude].   For example, [-123.115, 49.285]     If you
  specify a departure that's not located on a road, Amazon Location moves the position to the
  nearest road. If Esri is the provider for your route calculator, specifying a route that is
  longer than 400 km returns a 400 RoutesValidationException error.  Valid Values: [-180 to
  180,-90 to 90]
- `destination_position`: The finish position for the route. Defined in World Geodetic
  System (WGS 84) format: [longitude, latitude].    For example, [-122.339, 47.615]     If
  you specify a destination that's not located on a road, Amazon Location moves the position
  to the nearest road.   Valid Values: [-180 to 180,-90 to 90]

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ArrivalTime"`: Specifies the desired time of arrival. Uses the given time to calculate
  the route. Otherwise, the best time of day to travel with the best traffic conditions is
  used to calculate the route.  ArrivalTime is not supported Esri.
- `"CarModeOptions"`: Specifies route preferences when traveling by Car, such as avoiding
  routes that use ferries or tolls. Requirements: TravelMode must be specified as Car.
- `"DepartNow"`: Sets the time of departure as the current time. Uses the current time to
  calculate a route. Otherwise, the best time of day to travel with the best traffic
  conditions is used to calculate the route. Default Value: false  Valid Values: false | true
- `"DepartureTime"`: Specifies the desired time of departure. Uses the given time to
  calculate the route. Otherwise, the best time of day to travel with the best traffic
  conditions is used to calculate the route.   In ISO 8601 format: YYYY-MM-DDThh:mm:ss.sssZ.
  For example, 2020–07-2T12:15:20.000Z+01:00
- `"DistanceUnit"`: Set the unit system to specify the distance. Default Value: Kilometers
- `"IncludeLegGeometry"`: Set to include the geometry details in the result for each path
  between a pair of positions. Default Value: false  Valid Values: false | true
- `"OptimizeFor"`: Specifies the distance to optimize for when calculating a route.
- `"TravelMode"`: Specifies the mode of transport when calculating a route. Used in
  estimating the speed of travel and road compatibility. You can choose Car, Truck, Walking,
  Bicycle or Motorcycle as options for the TravelMode.   Bicycle and Motorcycle are only
  valid when using Grab as a data provider, and only within Southeast Asia.  Truck is not
  available for Grab. For more details on the using Grab for routing, including areas of
  coverage, see GrabMaps in the Amazon Location Service Developer Guide.  The TravelMode you
  specify also determines how you specify route preferences:    If traveling by Car use the
  CarModeOptions parameter.   If traveling by Truck use the TruckModeOptions parameter.
  Default Value: Car
- `"TruckModeOptions"`: Specifies route preferences when traveling by Truck, such as
  avoiding routes that use ferries or tolls, and truck specifications to consider when
  choosing an optimal road. Requirements: TravelMode must be specified as Truck.
- `"WaypointPositions"`: Specifies an ordered list of up to 23 intermediate positions to
  include along a route between the departure position and destination position.    For
  example, from the DeparturePosition [-123.115, 49.285], the route follows the order that
  the waypoint positions are given [[-122.757, 49.0021],[-122.349, 47.620]]     If you
  specify a waypoint position that's not located on a road, Amazon Location moves the
  position to the nearest road.  Specifying more than 23 waypoints returns a 400
  ValidationException error. If Esri is the provider for your route calculator, specifying a
  route that is longer than 400 km returns a 400 RoutesValidationException error.  Valid
  Values: [-180 to 180,-90 to 90]
- `"key"`: The optional API key to authorize the request.
"""
function calculate_route(
    CalculatorName,
    DeparturePosition,
    DestinationPosition;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return location(
        "POST",
        "/routes/v0/calculators/$(CalculatorName)/calculate/route",
        Dict{String,Any}(
            "DeparturePosition" => DeparturePosition,
            "DestinationPosition" => DestinationPosition,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function calculate_route(
    CalculatorName,
    DeparturePosition,
    DestinationPosition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return location(
        "POST",
        "/routes/v0/calculators/$(CalculatorName)/calculate/route",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DeparturePosition" => DeparturePosition,
                    "DestinationPosition" => DestinationPosition,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    calculate_route_matrix(calculator_name, departure_positions, destination_positions)
    calculate_route_matrix(calculator_name, departure_positions, destination_positions, params::Dict{String,<:Any})

  Calculates a route matrix given the following required parameters: DeparturePositions and
DestinationPositions. CalculateRouteMatrix calculates routes and returns the travel time
and travel distance from each departure position to each destination position in the
request. For example, given departure positions A and B, and destination positions X and Y,
CalculateRouteMatrix will return time and distance for routes from A to X, A to Y, B to X,
and B to Y (in that order). The number of results returned (and routes calculated) will be
the number of DeparturePositions times the number of DestinationPositions.  Your account is
charged for each route calculated, not the number of requests.  Requires that you first
create a route calculator resource. By default, a request that doesn't specify a departure
time uses the best time of day to travel with the best traffic conditions when calculating
routes. Additional options include:     Specifying a departure time using either
DepartureTime or DepartNow. This calculates routes based on predictive traffic data at the
given time.   You can't specify both DepartureTime and DepartNow in a single request.
Specifying both parameters returns a validation error.     Specifying a travel mode using
TravelMode sets the transportation mode used to calculate the routes. This also lets you
specify additional route preferences in CarModeOptions if traveling by Car, or
TruckModeOptions if traveling by Truck.

# Arguments
- `calculator_name`: The name of the route calculator resource that you want to use to
  calculate the route matrix.
- `departure_positions`: The list of departure (origin) positions for the route matrix. An
  array of points, each of which is itself a 2-value array defined in WGS 84 format:
  [longitude, latitude]. For example, [-123.115, 49.285].  Depending on the data provider
  selected in the route calculator resource there may be additional restrictions on the
  inputs you can choose. See  Position restrictions in the Amazon Location Service Developer
  Guide.   For route calculators that use Esri as the data provider, if you specify a
  departure that's not located on a road, Amazon Location  moves the position to the nearest
  road. The snapped value is available in the result in SnappedDeparturePositions.  Valid
  Values: [-180 to 180,-90 to 90]
- `destination_positions`: The list of destination positions for the route matrix. An array
  of points, each of which is itself a 2-value array defined in WGS 84 format: [longitude,
  latitude]. For example, [-122.339, 47.615]   Depending on the data provider selected in the
  route calculator resource there may be additional restrictions on the inputs you can
  choose. See  Position restrictions in the Amazon Location Service Developer Guide.   For
  route calculators that use Esri as the data provider, if you specify a destination that's
  not located on a road, Amazon Location  moves the position to the nearest road. The snapped
  value is available in the result in SnappedDestinationPositions.  Valid Values: [-180 to
  180,-90 to 90]

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CarModeOptions"`: Specifies route preferences when traveling by Car, such as avoiding
  routes that use ferries or tolls. Requirements: TravelMode must be specified as Car.
- `"DepartNow"`: Sets the time of departure as the current time. Uses the current time to
  calculate the route matrix. You can't set both DepartureTime and DepartNow. If neither is
  set, the best time of day to travel with the best traffic conditions is used to calculate
  the route matrix. Default Value: false  Valid Values: false | true
- `"DepartureTime"`: Specifies the desired time of departure. Uses the given time to
  calculate the route matrix. You can't set both DepartureTime and DepartNow. If neither is
  set, the best time of day to travel with the best traffic conditions is used to calculate
  the route matrix.  Setting a departure time in the past returns a 400 ValidationException
  error.    In ISO 8601 format: YYYY-MM-DDThh:mm:ss.sssZ. For example,
  2020–07-2T12:15:20.000Z+01:00
- `"DistanceUnit"`: Set the unit system to specify the distance. Default Value: Kilometers
- `"TravelMode"`: Specifies the mode of transport when calculating a route. Used in
  estimating the speed of travel and road compatibility. The TravelMode you specify also
  determines how you specify route preferences:    If traveling by Car use the CarModeOptions
  parameter.   If traveling by Truck use the TruckModeOptions parameter.     Bicycle or
  Motorcycle are only valid when using Grab as a data provider, and only within Southeast
  Asia.  Truck is not available for Grab. For more information about using Grab as a data
  provider, see GrabMaps in the Amazon Location Service Developer Guide.  Default Value: Car
- `"TruckModeOptions"`: Specifies route preferences when traveling by Truck, such as
  avoiding routes that use ferries or tolls, and truck specifications to consider when
  choosing an optimal road. Requirements: TravelMode must be specified as Truck.
- `"key"`: The optional API key to authorize the request.
"""
function calculate_route_matrix(
    CalculatorName,
    DeparturePositions,
    DestinationPositions;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return location(
        "POST",
        "/routes/v0/calculators/$(CalculatorName)/calculate/route-matrix",
        Dict{String,Any}(
            "DeparturePositions" => DeparturePositions,
            "DestinationPositions" => DestinationPositions,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function calculate_route_matrix(
    CalculatorName,
    DeparturePositions,
    DestinationPositions,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return location(
        "POST",
        "/routes/v0/calculators/$(CalculatorName)/calculate/route-matrix",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DeparturePositions" => DeparturePositions,
                    "DestinationPositions" => DestinationPositions,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_geofence_collection(collection_name)
    create_geofence_collection(collection_name, params::Dict{String,<:Any})

Creates a geofence collection, which manages and stores geofences.

# Arguments
- `collection_name`: A custom name for the geofence collection. Requirements:   Contain
  only alphanumeric characters (A–Z, a–z, 0–9), hyphens (-), periods (.), and
  underscores (_).    Must be a unique geofence collection name.   No spaces allowed. For
  example, ExampleGeofenceCollection.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: An optional description for the geofence collection.
- `"KmsKeyId"`: A key identifier for an Amazon Web Services KMS customer managed key. Enter
  a key ID, key ARN, alias name, or alias ARN.
- `"PricingPlan"`: No longer used. If included, the only allowed value is RequestBasedUsage.
- `"PricingPlanDataSource"`: This parameter is no longer used.
- `"Tags"`: Applies one or more tags to the geofence collection. A tag is a key-value pair
  helps manage, identify, search, and filter your resources by labelling them. Format:
  \"key\" : \"value\"  Restrictions:   Maximum 50 tags per resource   Each resource tag must
  be unique with a maximum of one value.   Maximum key length: 128 Unicode characters in
  UTF-8   Maximum value length: 256 Unicode characters in UTF-8   Can use alphanumeric
  characters (A–Z, a–z, 0–9), and the following characters: + - = . _ : / @.    Cannot
  use \"aws:\" as a prefix for a key.
"""
function create_geofence_collection(
    CollectionName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return location(
        "POST",
        "/geofencing/v0/collections",
        Dict{String,Any}("CollectionName" => CollectionName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_geofence_collection(
    CollectionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return location(
        "POST",
        "/geofencing/v0/collections",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("CollectionName" => CollectionName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_key(key_name, restrictions)
    create_key(key_name, restrictions, params::Dict{String,<:Any})

Creates an API key resource in your Amazon Web Services account, which lets you grant
actions for Amazon Location resources to the API key bearer.  For more information, see
Using API keys.

# Arguments
- `key_name`: A custom name for the API key resource. Requirements:   Contain only
  alphanumeric characters (A–Z, a–z, 0–9), hyphens (-), periods (.), and underscores
  (_).    Must be a unique API key name.   No spaces allowed. For example, ExampleAPIKey.
- `restrictions`: The API key restrictions for the API key resource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: An optional description for the API key resource.
- `"ExpireTime"`: The optional timestamp for when the API key resource will expire in  ISO
  8601 format: YYYY-MM-DDThh:mm:ss.sssZ. One of NoExpiry or ExpireTime must be set.
- `"NoExpiry"`: Optionally set to true to set no expiration time for the API key. One of
  NoExpiry or ExpireTime must be set.
- `"Tags"`: Applies one or more tags to the map resource. A tag is a key-value pair that
  helps manage, identify, search, and filter your resources by labelling them. Format:
  \"key\" : \"value\"  Restrictions:   Maximum 50 tags per resource   Each resource tag must
  be unique with a maximum of one value.   Maximum key length: 128 Unicode characters in
  UTF-8   Maximum value length: 256 Unicode characters in UTF-8   Can use alphanumeric
  characters (A–Z, a–z, 0–9), and the following characters: + - = . _ : / @.    Cannot
  use \"aws:\" as a prefix for a key.
"""
function create_key(
    KeyName, Restrictions; aws_config::AbstractAWSConfig=current_aws_config()
)
    return location(
        "POST",
        "/metadata/v0/keys",
        Dict{String,Any}("KeyName" => KeyName, "Restrictions" => Restrictions);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_key(
    KeyName,
    Restrictions,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return location(
        "POST",
        "/metadata/v0/keys",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("KeyName" => KeyName, "Restrictions" => Restrictions),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_map(configuration, map_name)
    create_map(configuration, map_name, params::Dict{String,<:Any})

Creates a map resource in your Amazon Web Services account, which provides map tiles of
different styles sourced from global location data providers.  If your application is
tracking or routing assets you use in your business, such as delivery vehicles or
employees, you must not use Esri as your geolocation provider. See section 82 of the Amazon
Web Services service terms for more details.

# Arguments
- `configuration`: Specifies the MapConfiguration, including the map style, for the map
  resource that you create. The map style defines the look of maps and the data provider for
  your map resource.
- `map_name`: The name for the map resource. Requirements:   Must contain only alphanumeric
  characters (A–Z, a–z, 0–9), hyphens (-), periods (.), and underscores (_).    Must be
  a unique map resource name.    No spaces allowed. For example, ExampleMap.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: An optional description for the map resource.
- `"PricingPlan"`: No longer used. If included, the only allowed value is RequestBasedUsage.
- `"Tags"`: Applies one or more tags to the map resource. A tag is a key-value pair helps
  manage, identify, search, and filter your resources by labelling them. Format: \"key\" :
  \"value\"  Restrictions:   Maximum 50 tags per resource   Each resource tag must be unique
  with a maximum of one value.   Maximum key length: 128 Unicode characters in UTF-8
  Maximum value length: 256 Unicode characters in UTF-8   Can use alphanumeric characters
  (A–Z, a–z, 0–9), and the following characters: + - = . _ : / @.    Cannot use
  \"aws:\" as a prefix for a key.
"""
function create_map(
    Configuration, MapName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return location(
        "POST",
        "/maps/v0/maps",
        Dict{String,Any}("Configuration" => Configuration, "MapName" => MapName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_map(
    Configuration,
    MapName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return location(
        "POST",
        "/maps/v0/maps",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Configuration" => Configuration, "MapName" => MapName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_place_index(data_source, index_name)
    create_place_index(data_source, index_name, params::Dict{String,<:Any})

Creates a place index resource in your Amazon Web Services account. Use a place index
resource to geocode addresses and other text queries by using the SearchPlaceIndexForText
operation, and reverse geocode coordinates by using the SearchPlaceIndexForPosition
operation, and enable autosuggestions by using the SearchPlaceIndexForSuggestions
operation.  If your application is tracking or routing assets you use in your business,
such as delivery vehicles or employees, you must not use Esri as your geolocation provider.
See section 82 of the Amazon Web Services service terms for more details.

# Arguments
- `data_source`: Specifies the geospatial data provider for the new place index.  This
  field is case-sensitive. Enter the valid values as shown. For example, entering HERE
  returns an error.  Valid values include:    Esri – For additional information about
  Esri's coverage in your region of interest, see Esri details on geocoding coverage.    Grab
  – Grab provides place index functionality for Southeast Asia. For additional information
  about GrabMaps' coverage, see GrabMaps countries and areas covered.    Here – For
  additional information about HERE Technologies' coverage in your region of interest, see
  HERE details on goecoding coverage.  If you specify HERE Technologies (Here) as the data
  provider, you may not store results for locations in Japan. For more information, see the
  Amazon Web Services Service Terms for Amazon Location Service.    For additional
  information , see Data providers on the Amazon Location Service Developer Guide.
- `index_name`: The name of the place index resource.  Requirements:   Contain only
  alphanumeric characters (A–Z, a–z, 0–9), hyphens (-), periods (.), and underscores
  (_).   Must be a unique place index resource name.   No spaces allowed. For example,
  ExamplePlaceIndex.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DataSourceConfiguration"`: Specifies the data storage option requesting Places.
- `"Description"`: The optional description for the place index resource.
- `"PricingPlan"`: No longer used. If included, the only allowed value is RequestBasedUsage.
- `"Tags"`: Applies one or more tags to the place index resource. A tag is a key-value pair
  that helps you manage, identify, search, and filter your resources. Format: \"key\" :
  \"value\"  Restrictions:   Maximum 50 tags per resource.   Each tag key must be unique and
  must have exactly one associated value.   Maximum key length: 128 Unicode characters in
  UTF-8.   Maximum value length: 256 Unicode characters in UTF-8.   Can use alphanumeric
  characters (A–Z, a–z, 0–9), and the following characters: + - = . _ : / @   Cannot
  use \"aws:\" as a prefix for a key.
"""
function create_place_index(
    DataSource, IndexName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return location(
        "POST",
        "/places/v0/indexes",
        Dict{String,Any}("DataSource" => DataSource, "IndexName" => IndexName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_place_index(
    DataSource,
    IndexName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return location(
        "POST",
        "/places/v0/indexes",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DataSource" => DataSource, "IndexName" => IndexName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_route_calculator(calculator_name, data_source)
    create_route_calculator(calculator_name, data_source, params::Dict{String,<:Any})

Creates a route calculator resource in your Amazon Web Services account. You can send
requests to a route calculator resource to estimate travel time, distance, and get
directions. A route calculator sources traffic and road network data from your chosen data
provider.  If your application is tracking or routing assets you use in your business, such
as delivery vehicles or employees, you must not use Esri as your geolocation provider. See
section 82 of the Amazon Web Services service terms for more details.

# Arguments
- `calculator_name`: The name of the route calculator resource.  Requirements:   Can use
  alphanumeric characters (A–Z, a–z, 0–9) , hyphens (-), periods (.), and underscores
  (_).   Must be a unique Route calculator resource name.   No spaces allowed. For example,
  ExampleRouteCalculator.
- `data_source`: Specifies the data provider of traffic and road network data.  This field
  is case-sensitive. Enter the valid values as shown. For example, entering HERE returns an
  error.  Valid values include:    Esri – For additional information about Esri's coverage
  in your region of interest, see Esri details on street networks and traffic coverage. Route
  calculators that use Esri as a data source only calculate routes that are shorter than 400
  km.    Grab – Grab provides routing functionality for Southeast Asia. For additional
  information about GrabMaps' coverage, see GrabMaps countries and areas covered.    Here –
  For additional information about HERE Technologies' coverage in your region of interest,
  see HERE car routing coverage and HERE truck routing coverage.   For additional information
  , see Data providers on the Amazon Location Service Developer Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: The optional description for the route calculator resource.
- `"PricingPlan"`: No longer used. If included, the only allowed value is RequestBasedUsage.
- `"Tags"`: Applies one or more tags to the route calculator resource. A tag is a key-value
  pair helps manage, identify, search, and filter your resources by labelling them.   For
  example: { \"tag1\" : \"value1\", \"tag2\" : \"value2\"}   Format: \"key\" : \"value\"
  Restrictions:   Maximum 50 tags per resource   Each resource tag must be unique with a
  maximum of one value.   Maximum key length: 128 Unicode characters in UTF-8   Maximum value
  length: 256 Unicode characters in UTF-8   Can use alphanumeric characters (A–Z, a–z,
  0–9), and the following characters: + - = . _ : / @.    Cannot use \"aws:\" as a prefix
  for a key.
"""
function create_route_calculator(
    CalculatorName, DataSource; aws_config::AbstractAWSConfig=current_aws_config()
)
    return location(
        "POST",
        "/routes/v0/calculators",
        Dict{String,Any}("CalculatorName" => CalculatorName, "DataSource" => DataSource);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_route_calculator(
    CalculatorName,
    DataSource,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return location(
        "POST",
        "/routes/v0/calculators",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CalculatorName" => CalculatorName, "DataSource" => DataSource
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_tracker(tracker_name)
    create_tracker(tracker_name, params::Dict{String,<:Any})

Creates a tracker resource in your Amazon Web Services account, which lets you retrieve
current and historical location of devices.

# Arguments
- `tracker_name`: The name for the tracker resource. Requirements:   Contain only
  alphanumeric characters (A-Z, a-z, 0-9) , hyphens (-), periods (.), and underscores (_).
  Must be a unique tracker resource name.   No spaces allowed. For example, ExampleTracker.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: An optional description for the tracker resource.
- `"EventBridgeEnabled"`: Whether to enable position UPDATE events from this tracker to be
  sent to EventBridge.  You do not need enable this feature to get ENTER and EXIT events for
  geofences with this tracker. Those events are always sent to EventBridge.
- `"KmsKeyEnableGeospatialQueries"`: Enables GeospatialQueries for a tracker that uses a
  Amazon Web Services KMS customer managed key. This parameter is only used if you are using
  a KMS customer managed key.  If you wish to encrypt your data using your own KMS customer
  managed key, then the Bounding Polygon Queries feature will be disabled by default. This is
  because by using this feature, a representation of your device positions will not be
  encrypted using the your KMS managed key. The exact device position, however; is still
  encrypted using your managed key. You can choose to opt-in to the Bounding Polygon Quseries
  feature. This is done by setting the KmsKeyEnableGeospatialQueries parameter to true when
  creating or updating a Tracker.
- `"KmsKeyId"`: A key identifier for an Amazon Web Services KMS customer managed key. Enter
  a key ID, key ARN, alias name, or alias ARN.
- `"PositionFiltering"`: Specifies the position filtering for the tracker resource. Valid
  values:    TimeBased - Location updates are evaluated against linked geofence collections,
  but not every location update is stored. If your update frequency is more often than 30
  seconds, only one update per 30 seconds is stored for each unique device ID.
  DistanceBased - If the device has moved less than 30 m (98.4 ft), location updates are
  ignored. Location updates within this area are neither evaluated against linked geofence
  collections, nor stored. This helps control costs by reducing the number of geofence
  evaluations and historical device positions to paginate through. Distance-based filtering
  can also reduce the effects of GPS noise when displaying device trajectories on a map.
  AccuracyBased - If the device has moved less than the measured accuracy, location updates
  are ignored. For example, if two consecutive updates from a device have a horizontal
  accuracy of 5 m and 10 m, the second update is ignored if the device has moved less than 15
  m. Ignored location updates are neither evaluated against linked geofence collections, nor
  stored. This can reduce the effects of GPS noise when displaying device trajectories on a
  map, and can help control your costs by reducing the number of geofence evaluations.
  This field is optional. If not specified, the default value is TimeBased.
- `"PricingPlan"`: No longer used. If included, the only allowed value is RequestBasedUsage.
- `"PricingPlanDataSource"`: This parameter is no longer used.
- `"Tags"`: Applies one or more tags to the tracker resource. A tag is a key-value pair
  helps manage, identify, search, and filter your resources by labelling them. Format:
  \"key\" : \"value\"  Restrictions:   Maximum 50 tags per resource   Each resource tag must
  be unique with a maximum of one value.   Maximum key length: 128 Unicode characters in
  UTF-8   Maximum value length: 256 Unicode characters in UTF-8   Can use alphanumeric
  characters (A–Z, a–z, 0–9), and the following characters: + - = . _ : / @.    Cannot
  use \"aws:\" as a prefix for a key.
"""
function create_tracker(TrackerName; aws_config::AbstractAWSConfig=current_aws_config())
    return location(
        "POST",
        "/tracking/v0/trackers",
        Dict{String,Any}("TrackerName" => TrackerName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_tracker(
    TrackerName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return location(
        "POST",
        "/tracking/v0/trackers",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TrackerName" => TrackerName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_geofence_collection(collection_name)
    delete_geofence_collection(collection_name, params::Dict{String,<:Any})

Deletes a geofence collection from your Amazon Web Services account.  This operation
deletes the resource permanently. If the geofence collection is the target of a tracker
resource, the devices will no longer be monitored.

# Arguments
- `collection_name`: The name of the geofence collection to be deleted.

"""
function delete_geofence_collection(
    CollectionName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return location(
        "DELETE",
        "/geofencing/v0/collections/$(CollectionName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_geofence_collection(
    CollectionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return location(
        "DELETE",
        "/geofencing/v0/collections/$(CollectionName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_key(key_name)
    delete_key(key_name, params::Dict{String,<:Any})

Deletes the specified API key. The API key must have been deactivated more than 90 days
previously.

# Arguments
- `key_name`: The name of the API key to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"forceDelete"`: ForceDelete bypasses an API key's expiry conditions and deletes the key.
  Set the parameter true to delete the key or to false to not preemptively delete the API
  key. Valid values: true, or false. Required: No  This action is irreversible. Only use
  ForceDelete if you are certain the key is no longer in use.
"""
function delete_key(KeyName; aws_config::AbstractAWSConfig=current_aws_config())
    return location(
        "DELETE",
        "/metadata/v0/keys/$(KeyName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_key(
    KeyName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return location(
        "DELETE",
        "/metadata/v0/keys/$(KeyName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_map(map_name)
    delete_map(map_name, params::Dict{String,<:Any})

Deletes a map resource from your Amazon Web Services account.  This operation deletes the
resource permanently. If the map is being used in an application, the map may not render.

# Arguments
- `map_name`: The name of the map resource to be deleted.

"""
function delete_map(MapName; aws_config::AbstractAWSConfig=current_aws_config())
    return location(
        "DELETE",
        "/maps/v0/maps/$(MapName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_map(
    MapName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return location(
        "DELETE",
        "/maps/v0/maps/$(MapName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_place_index(index_name)
    delete_place_index(index_name, params::Dict{String,<:Any})

Deletes a place index resource from your Amazon Web Services account.  This operation
deletes the resource permanently.

# Arguments
- `index_name`: The name of the place index resource to be deleted.

"""
function delete_place_index(IndexName; aws_config::AbstractAWSConfig=current_aws_config())
    return location(
        "DELETE",
        "/places/v0/indexes/$(IndexName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_place_index(
    IndexName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return location(
        "DELETE",
        "/places/v0/indexes/$(IndexName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_route_calculator(calculator_name)
    delete_route_calculator(calculator_name, params::Dict{String,<:Any})

Deletes a route calculator resource from your Amazon Web Services account.  This operation
deletes the resource permanently.

# Arguments
- `calculator_name`: The name of the route calculator resource to be deleted.

"""
function delete_route_calculator(
    CalculatorName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return location(
        "DELETE",
        "/routes/v0/calculators/$(CalculatorName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_route_calculator(
    CalculatorName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return location(
        "DELETE",
        "/routes/v0/calculators/$(CalculatorName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_tracker(tracker_name)
    delete_tracker(tracker_name, params::Dict{String,<:Any})

Deletes a tracker resource from your Amazon Web Services account.  This operation deletes
the resource permanently. If the tracker resource is in use, you may encounter an error.
Make sure that the target resource isn't a dependency for your applications.

# Arguments
- `tracker_name`: The name of the tracker resource to be deleted.

"""
function delete_tracker(TrackerName; aws_config::AbstractAWSConfig=current_aws_config())
    return location(
        "DELETE",
        "/tracking/v0/trackers/$(TrackerName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_tracker(
    TrackerName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return location(
        "DELETE",
        "/tracking/v0/trackers/$(TrackerName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_geofence_collection(collection_name)
    describe_geofence_collection(collection_name, params::Dict{String,<:Any})

Retrieves the geofence collection details.

# Arguments
- `collection_name`: The name of the geofence collection.

"""
function describe_geofence_collection(
    CollectionName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return location(
        "GET",
        "/geofencing/v0/collections/$(CollectionName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_geofence_collection(
    CollectionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return location(
        "GET",
        "/geofencing/v0/collections/$(CollectionName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_key(key_name)
    describe_key(key_name, params::Dict{String,<:Any})

Retrieves the API key resource details.

# Arguments
- `key_name`: The name of the API key resource.

"""
function describe_key(KeyName; aws_config::AbstractAWSConfig=current_aws_config())
    return location(
        "GET",
        "/metadata/v0/keys/$(KeyName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_key(
    KeyName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return location(
        "GET",
        "/metadata/v0/keys/$(KeyName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_map(map_name)
    describe_map(map_name, params::Dict{String,<:Any})

Retrieves the map resource details.

# Arguments
- `map_name`: The name of the map resource.

"""
function describe_map(MapName; aws_config::AbstractAWSConfig=current_aws_config())
    return location(
        "GET",
        "/maps/v0/maps/$(MapName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_map(
    MapName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return location(
        "GET",
        "/maps/v0/maps/$(MapName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_place_index(index_name)
    describe_place_index(index_name, params::Dict{String,<:Any})

Retrieves the place index resource details.

# Arguments
- `index_name`: The name of the place index resource.

"""
function describe_place_index(IndexName; aws_config::AbstractAWSConfig=current_aws_config())
    return location(
        "GET",
        "/places/v0/indexes/$(IndexName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_place_index(
    IndexName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return location(
        "GET",
        "/places/v0/indexes/$(IndexName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_route_calculator(calculator_name)
    describe_route_calculator(calculator_name, params::Dict{String,<:Any})

Retrieves the route calculator resource details.

# Arguments
- `calculator_name`: The name of the route calculator resource.

"""
function describe_route_calculator(
    CalculatorName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return location(
        "GET",
        "/routes/v0/calculators/$(CalculatorName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_route_calculator(
    CalculatorName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return location(
        "GET",
        "/routes/v0/calculators/$(CalculatorName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_tracker(tracker_name)
    describe_tracker(tracker_name, params::Dict{String,<:Any})

Retrieves the tracker resource details.

# Arguments
- `tracker_name`: The name of the tracker resource.

"""
function describe_tracker(TrackerName; aws_config::AbstractAWSConfig=current_aws_config())
    return location(
        "GET",
        "/tracking/v0/trackers/$(TrackerName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_tracker(
    TrackerName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return location(
        "GET",
        "/tracking/v0/trackers/$(TrackerName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_tracker_consumer(consumer_arn, tracker_name)
    disassociate_tracker_consumer(consumer_arn, tracker_name, params::Dict{String,<:Any})

Removes the association between a tracker resource and a geofence collection.  Once you
unlink a tracker resource from a geofence collection, the tracker positions will no longer
be automatically evaluated against geofences.

# Arguments
- `consumer_arn`: The Amazon Resource Name (ARN) for the geofence collection to be
  disassociated from the tracker resource. Used when you need to specify a resource across
  all Amazon Web Services.    Format example:
  arn:aws:geo:region:account-id:geofence-collection/ExampleGeofenceCollectionConsumer
- `tracker_name`: The name of the tracker resource to be dissociated from the consumer.

"""
function disassociate_tracker_consumer(
    ConsumerArn, TrackerName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return location(
        "DELETE",
        "/tracking/v0/trackers/$(TrackerName)/consumers/$(ConsumerArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_tracker_consumer(
    ConsumerArn,
    TrackerName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return location(
        "DELETE",
        "/tracking/v0/trackers/$(TrackerName)/consumers/$(ConsumerArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    forecast_geofence_events(collection_name, device_state)
    forecast_geofence_events(collection_name, device_state, params::Dict{String,<:Any})

Evaluates device positions against geofence geometries from a given geofence collection.
The event forecasts three states for which a device can be in relative to a geofence:
ENTER: If a device is outside of a geofence, but would breach the fence if the device is
moving at its current speed within time horizon window.  EXIT: If a device is inside of a
geofence, but would breach the fence if the device is moving at its current speed within
time horizon window.  IDLE: If a device is inside of a geofence, and the device is not
moving.

# Arguments
- `collection_name`: The name of the geofence collection.
- `device_state`: The device's state, including current position and speed.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DistanceUnit"`: The distance unit used for the NearestDistance property returned in a
  forecasted event. The measurement system must match for DistanceUnit and SpeedUnit; if
  Kilometers is specified for DistanceUnit, then SpeedUnit must be KilometersPerHour.
  Default Value: Kilometers
- `"MaxResults"`: An optional limit for the number of resources returned in a single call.
  Default value: 20
- `"NextToken"`: The pagination token specifying which page of results to return in the
  response. If no token is provided, the default page is the first page. Default value: null
- `"SpeedUnit"`: The speed unit for the device captured by the device state. The
  measurement system must match for DistanceUnit and SpeedUnit; if Kilometers is specified
  for DistanceUnit, then SpeedUnit must be KilometersPerHour. Default Value:
  KilometersPerHour.
- `"TimeHorizonMinutes"`: Specifies the time horizon in minutes for the forecasted events.
"""
function forecast_geofence_events(
    CollectionName, DeviceState; aws_config::AbstractAWSConfig=current_aws_config()
)
    return location(
        "POST",
        "/geofencing/v0/collections/$(CollectionName)/forecast-geofence-events",
        Dict{String,Any}("DeviceState" => DeviceState);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function forecast_geofence_events(
    CollectionName,
    DeviceState,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return location(
        "POST",
        "/geofencing/v0/collections/$(CollectionName)/forecast-geofence-events",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DeviceState" => DeviceState), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_device_position(device_id, tracker_name)
    get_device_position(device_id, tracker_name, params::Dict{String,<:Any})

Retrieves a device's most recent position according to its sample time.  Device positions
are deleted after 30 days.

# Arguments
- `device_id`: The device whose position you want to retrieve.
- `tracker_name`: The tracker resource receiving the position update.

"""
function get_device_position(
    DeviceId, TrackerName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return location(
        "GET",
        "/tracking/v0/trackers/$(TrackerName)/devices/$(DeviceId)/positions/latest";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_device_position(
    DeviceId,
    TrackerName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return location(
        "GET",
        "/tracking/v0/trackers/$(TrackerName)/devices/$(DeviceId)/positions/latest",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_device_position_history(device_id, tracker_name)
    get_device_position_history(device_id, tracker_name, params::Dict{String,<:Any})

Retrieves the device position history from a tracker resource within a specified range of
time.  Device positions are deleted after 30 days.

# Arguments
- `device_id`: The device whose position history you want to retrieve.
- `tracker_name`: The tracker resource receiving the request for the device position
  history.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EndTimeExclusive"`: Specify the end time for the position history in  ISO 8601 format:
  YYYY-MM-DDThh:mm:ss.sssZ. By default, the value will be the time that the request is made.
  Requirement:   The time specified for EndTimeExclusive must be after the time for
  StartTimeInclusive.
- `"MaxResults"`: An optional limit for the number of device positions returned in a single
  call. Default value: 100
- `"NextToken"`: The pagination token specifying which page of results to return in the
  response. If no token is provided, the default page is the first page.  Default value: null
- `"StartTimeInclusive"`: Specify the start time for the position history in  ISO 8601
  format: YYYY-MM-DDThh:mm:ss.sssZ. By default, the value will be 24 hours prior to the time
  that the request is made. Requirement:   The time specified for StartTimeInclusive must be
  before EndTimeExclusive.
"""
function get_device_position_history(
    DeviceId, TrackerName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return location(
        "POST",
        "/tracking/v0/trackers/$(TrackerName)/devices/$(DeviceId)/list-positions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_device_position_history(
    DeviceId,
    TrackerName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return location(
        "POST",
        "/tracking/v0/trackers/$(TrackerName)/devices/$(DeviceId)/list-positions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_geofence(collection_name, geofence_id)
    get_geofence(collection_name, geofence_id, params::Dict{String,<:Any})

Retrieves the geofence details from a geofence collection.  The returned geometry will
always match the geometry format used when the geofence was created.

# Arguments
- `collection_name`: The geofence collection storing the target geofence.
- `geofence_id`: The geofence you're retrieving details for.

"""
function get_geofence(
    CollectionName, GeofenceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return location(
        "GET",
        "/geofencing/v0/collections/$(CollectionName)/geofences/$(GeofenceId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_geofence(
    CollectionName,
    GeofenceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return location(
        "GET",
        "/geofencing/v0/collections/$(CollectionName)/geofences/$(GeofenceId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_map_glyphs(font_stack, font_unicode_range, map_name)
    get_map_glyphs(font_stack, font_unicode_range, map_name, params::Dict{String,<:Any})

Retrieves glyphs used to display labels on a map.

# Arguments
- `font_stack`: A comma-separated list of fonts to load glyphs from in order of preference.
  For example, Noto Sans Regular, Arial Unicode. Valid font stacks for Esri styles:
  VectorEsriDarkGrayCanvas – Ubuntu Medium Italic | Ubuntu Medium | Ubuntu Italic | Ubuntu
  Regular | Ubuntu Bold    VectorEsriLightGrayCanvas – Ubuntu Italic | Ubuntu Regular |
  Ubuntu Light | Ubuntu Bold    VectorEsriTopographic – Noto Sans Italic | Noto Sans
  Regular | Noto Sans Bold | Noto Serif Regular | Roboto Condensed Light Italic
  VectorEsriStreets – Arial Regular | Arial Italic | Arial Bold    VectorEsriNavigation –
  Arial Regular | Arial Italic | Arial Bold    Valid font stacks for HERE Technologies
  styles:   VectorHereContrast – Fira GO Regular | Fira GO Bold    VectorHereExplore,
  VectorHereExploreTruck, HybridHereExploreSatellite – Fira GO Italic | Fira GO Map | Fira
  GO Map Bold | Noto Sans CJK JP Bold | Noto Sans CJK JP Light | Noto Sans CJK JP Regular
  Valid font stacks for GrabMaps styles:   VectorGrabStandardLight, VectorGrabStandardDark
  – Noto Sans Regular | Noto Sans Medium | Noto Sans Bold    Valid font stacks for Open
  Data styles:   VectorOpenDataStandardLight, VectorOpenDataStandardDark,
  VectorOpenDataVisualizationLight, VectorOpenDataVisualizationDark – Amazon Ember
  Regular,Noto Sans Regular | Amazon Ember Bold,Noto Sans Bold | Amazon Ember Medium,Noto
  Sans Medium | Amazon Ember Regular Italic,Noto Sans Italic | Amazon Ember Condensed RC
  Regular,Noto Sans Regular | Amazon Ember Condensed RC Bold,Noto Sans Bold | Amazon Ember
  Regular,Noto Sans Regular,Noto Sans Arabic Regular | Amazon Ember Condensed RC Bold,Noto
  Sans Bold,Noto Sans Arabic Condensed Bold | Amazon Ember Bold,Noto Sans Bold,Noto Sans
  Arabic Bold | Amazon Ember Regular Italic,Noto Sans Italic,Noto Sans Arabic Regular |
  Amazon Ember Condensed RC Regular,Noto Sans Regular,Noto Sans Arabic Condensed Regular |
  Amazon Ember Medium,Noto Sans Medium,Noto Sans Arabic Medium     The fonts used by the Open
  Data map styles are combined fonts that use Amazon Ember for most glyphs but Noto Sans for
  glyphs unsupported by Amazon Ember.
- `font_unicode_range`: A Unicode range of characters to download glyphs for. Each response
  will contain 256 characters. For example, 0–255 includes all characters from range U+0000
  to 00FF. Must be aligned to multiples of 256.
- `map_name`: The map resource associated with the glyph ﬁle.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"key"`: The optional API key to authorize the request.
"""
function get_map_glyphs(
    FontStack, FontUnicodeRange, MapName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return location(
        "GET",
        "/maps/v0/maps/$(MapName)/glyphs/$(FontStack)/$(FontUnicodeRange)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_map_glyphs(
    FontStack,
    FontUnicodeRange,
    MapName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return location(
        "GET",
        "/maps/v0/maps/$(MapName)/glyphs/$(FontStack)/$(FontUnicodeRange)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_map_sprites(file_name, map_name)
    get_map_sprites(file_name, map_name, params::Dict{String,<:Any})

Retrieves the sprite sheet corresponding to a map resource. The sprite sheet is a PNG image
paired with a JSON document describing the offsets of individual icons that will be
displayed on a rendered map.

# Arguments
- `file_name`: The name of the sprite ﬁle. Use the following ﬁle names for the sprite
  sheet:    sprites.png     sprites@2x.png for high pixel density displays   For the JSON
  document containing image offsets. Use the following ﬁle names:    sprites.json
  sprites@2x.json for high pixel density displays
- `map_name`: The map resource associated with the sprite ﬁle.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"key"`: The optional API key to authorize the request.
"""
function get_map_sprites(
    FileName, MapName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return location(
        "GET",
        "/maps/v0/maps/$(MapName)/sprites/$(FileName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_map_sprites(
    FileName,
    MapName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return location(
        "GET",
        "/maps/v0/maps/$(MapName)/sprites/$(FileName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_map_style_descriptor(map_name)
    get_map_style_descriptor(map_name, params::Dict{String,<:Any})

Retrieves the map style descriptor from a map resource.  The style descriptor contains
speciﬁcations on how features render on a map. For example, what data to display, what
order to display the data in, and the style for the data. Style descriptors follow the
Mapbox Style Specification.

# Arguments
- `map_name`: The map resource to retrieve the style descriptor from.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"key"`: The optional API key to authorize the request.
"""
function get_map_style_descriptor(
    MapName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return location(
        "GET",
        "/maps/v0/maps/$(MapName)/style-descriptor";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_map_style_descriptor(
    MapName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return location(
        "GET",
        "/maps/v0/maps/$(MapName)/style-descriptor",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_map_tile(map_name, x, y, z)
    get_map_tile(map_name, x, y, z, params::Dict{String,<:Any})

Retrieves a vector data tile from the map resource. Map tiles are used by clients to render
a map. they're addressed using a grid arrangement with an X coordinate, Y coordinate, and Z
(zoom) level.  The origin (0, 0) is the top left of the map. Increasing the zoom level by 1
doubles both the X and Y dimensions, so a tile containing data for the entire world at
(0/0/0) will be split into 4 tiles at zoom 1 (1/0/0, 1/0/1, 1/1/0, 1/1/1).

# Arguments
- `map_name`: The map resource to retrieve the map tiles from.
- `x`: The X axis value for the map tile.
- `y`: The Y axis value for the map tile.
- `z`: The zoom value for the map tile.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"key"`: The optional API key to authorize the request.
"""
function get_map_tile(MapName, X, Y, Z; aws_config::AbstractAWSConfig=current_aws_config())
    return location(
        "GET",
        "/maps/v0/maps/$(MapName)/tiles/$(Z)/$(X)/$(Y)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_map_tile(
    MapName,
    X,
    Y,
    Z,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return location(
        "GET",
        "/maps/v0/maps/$(MapName)/tiles/$(Z)/$(X)/$(Y)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_place(index_name, place_id)
    get_place(index_name, place_id, params::Dict{String,<:Any})

Finds a place by its unique ID. A PlaceId is returned by other search operations.  A
PlaceId is valid only if all of the following are the same in the original search request
and the call to GetPlace.   Customer Amazon Web Services account   Amazon Web Services
Region   Data provider specified in the place index resource

# Arguments
- `index_name`: The name of the place index resource that you want to use for the search.
- `place_id`: The identifier of the place to find.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"key"`: The optional API key to authorize the request.
- `"language"`: The preferred language used to return results. The value must be a valid
  BCP 47 language tag, for example, en for English. This setting affects the languages used
  in the results, but not the results themselves. If no language is specified, or not
  supported for a particular result, the partner automatically chooses a language for the
  result. For an example, we'll use the Greek language. You search for a location around
  Athens, Greece, with the language parameter set to en. The city in the results will most
  likely be returned as Athens. If you set the language parameter to el, for Greek, then the
  city in the results will more likely be returned as Αθήνα. If the data provider does
  not have a value for Greek, the result will be in a language that the provider does support.
"""
function get_place(IndexName, PlaceId; aws_config::AbstractAWSConfig=current_aws_config())
    return location(
        "GET",
        "/places/v0/indexes/$(IndexName)/places/$(PlaceId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_place(
    IndexName,
    PlaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return location(
        "GET",
        "/places/v0/indexes/$(IndexName)/places/$(PlaceId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_device_positions(tracker_name)
    list_device_positions(tracker_name, params::Dict{String,<:Any})

A batch request to retrieve all device positions.

# Arguments
- `tracker_name`: The tracker resource containing the requested devices.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FilterGeometry"`: The geometry used to filter device positions.
- `"MaxResults"`: An optional limit for the number of entries returned in a single call.
  Default value: 100
- `"NextToken"`: The pagination token specifying which page of results to return in the
  response. If no token is provided, the default page is the first page. Default value: null
"""
function list_device_positions(
    TrackerName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return location(
        "POST",
        "/tracking/v0/trackers/$(TrackerName)/list-positions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_device_positions(
    TrackerName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return location(
        "POST",
        "/tracking/v0/trackers/$(TrackerName)/list-positions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_geofence_collections()
    list_geofence_collections(params::Dict{String,<:Any})

Lists geofence collections in your Amazon Web Services account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: An optional limit for the number of resources returned in a single call.
  Default value: 100
- `"NextToken"`: The pagination token specifying which page of results to return in the
  response. If no token is provided, the default page is the first page.  Default value: null
"""
function list_geofence_collections(; aws_config::AbstractAWSConfig=current_aws_config())
    return location(
        "POST",
        "/geofencing/v0/list-collections";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_geofence_collections(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return location(
        "POST",
        "/geofencing/v0/list-collections",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_geofences(collection_name)
    list_geofences(collection_name, params::Dict{String,<:Any})

Lists geofences stored in a given geofence collection.

# Arguments
- `collection_name`: The name of the geofence collection storing the list of geofences.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: An optional limit for the number of geofences returned in a single call.
  Default value: 100
- `"NextToken"`: The pagination token specifying which page of results to return in the
  response. If no token is provided, the default page is the first page.  Default value: null
"""
function list_geofences(CollectionName; aws_config::AbstractAWSConfig=current_aws_config())
    return location(
        "POST",
        "/geofencing/v0/collections/$(CollectionName)/list-geofences";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_geofences(
    CollectionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return location(
        "POST",
        "/geofencing/v0/collections/$(CollectionName)/list-geofences",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_keys()
    list_keys(params::Dict{String,<:Any})

Lists API key resources in your Amazon Web Services account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filter"`: Optionally filter the list to only Active or Expired API keys.
- `"MaxResults"`: An optional limit for the number of resources returned in a single call.
  Default value: 100
- `"NextToken"`: The pagination token specifying which page of results to return in the
  response. If no token is provided, the default page is the first page.  Default value: null
"""
function list_keys(; aws_config::AbstractAWSConfig=current_aws_config())
    return location(
        "POST",
        "/metadata/v0/list-keys";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_keys(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return location(
        "POST",
        "/metadata/v0/list-keys",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_maps()
    list_maps(params::Dict{String,<:Any})

Lists map resources in your Amazon Web Services account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: An optional limit for the number of resources returned in a single call.
  Default value: 100
- `"NextToken"`: The pagination token specifying which page of results to return in the
  response. If no token is provided, the default page is the first page. Default value: null
"""
function list_maps(; aws_config::AbstractAWSConfig=current_aws_config())
    return location(
        "POST", "/maps/v0/list-maps"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_maps(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return location(
        "POST",
        "/maps/v0/list-maps",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_place_indexes()
    list_place_indexes(params::Dict{String,<:Any})

Lists place index resources in your Amazon Web Services account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: An optional limit for the maximum number of results returned in a single
  call. Default value: 100
- `"NextToken"`: The pagination token specifying which page of results to return in the
  response. If no token is provided, the default page is the first page. Default value: null
"""
function list_place_indexes(; aws_config::AbstractAWSConfig=current_aws_config())
    return location(
        "POST",
        "/places/v0/list-indexes";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_place_indexes(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return location(
        "POST",
        "/places/v0/list-indexes",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_route_calculators()
    list_route_calculators(params::Dict{String,<:Any})

Lists route calculator resources in your Amazon Web Services account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: An optional maximum number of results returned in a single call. Default
  Value: 100
- `"NextToken"`: The pagination token specifying which page of results to return in the
  response. If no token is provided, the default page is the first page. Default Value: null
"""
function list_route_calculators(; aws_config::AbstractAWSConfig=current_aws_config())
    return location(
        "POST",
        "/routes/v0/list-calculators";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_route_calculators(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return location(
        "POST",
        "/routes/v0/list-calculators",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Returns a list of tags that are applied to the specified Amazon Location resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource whose tags you want to
  retrieve.   Format example: arn:aws:geo:region:account-id:resourcetype/ExampleResource

"""
function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return location(
        "GET",
        "/tags/$(ResourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return location(
        "GET",
        "/tags/$(ResourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tracker_consumers(tracker_name)
    list_tracker_consumers(tracker_name, params::Dict{String,<:Any})

Lists geofence collections currently associated to the given tracker resource.

# Arguments
- `tracker_name`: The tracker resource whose associated geofence collections you want to
  list.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: An optional limit for the number of resources returned in a single call.
  Default value: 100
- `"NextToken"`: The pagination token specifying which page of results to return in the
  response. If no token is provided, the default page is the first page.  Default value: null
"""
function list_tracker_consumers(
    TrackerName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return location(
        "POST",
        "/tracking/v0/trackers/$(TrackerName)/list-consumers";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tracker_consumers(
    TrackerName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return location(
        "POST",
        "/tracking/v0/trackers/$(TrackerName)/list-consumers",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_trackers()
    list_trackers(params::Dict{String,<:Any})

Lists tracker resources in your Amazon Web Services account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: An optional limit for the number of resources returned in a single call.
  Default value: 100
- `"NextToken"`: The pagination token specifying which page of results to return in the
  response. If no token is provided, the default page is the first page.  Default value: null
"""
function list_trackers(; aws_config::AbstractAWSConfig=current_aws_config())
    return location(
        "POST",
        "/tracking/v0/list-trackers";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_trackers(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return location(
        "POST",
        "/tracking/v0/list-trackers",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_geofence(collection_name, geofence_id, geometry)
    put_geofence(collection_name, geofence_id, geometry, params::Dict{String,<:Any})

Stores a geofence geometry in a given geofence collection, or updates the geometry of an
existing geofence if a geofence ID is included in the request.

# Arguments
- `collection_name`: The geofence collection to store the geofence in.
- `geofence_id`: An identifier for the geofence. For example, ExampleGeofence-1.
- `geometry`: Contains the details to specify the position of the geofence. Can be a
  polygon, a circle or a polygon encoded in Geobuf format. Including multiple selections will
  return a validation error.  The  geofence polygon format supports a maximum of 1,000
  vertices. The Geofence Geobuf format supports a maximum of 100,000 vertices.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"GeofenceProperties"`: Associates one of more properties with the geofence. A property
  is a key-value pair stored with the geofence and added to any geofence event triggered with
  that geofence. Format: \"key\" : \"value\"
"""
function put_geofence(
    CollectionName, GeofenceId, Geometry; aws_config::AbstractAWSConfig=current_aws_config()
)
    return location(
        "PUT",
        "/geofencing/v0/collections/$(CollectionName)/geofences/$(GeofenceId)",
        Dict{String,Any}("Geometry" => Geometry);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_geofence(
    CollectionName,
    GeofenceId,
    Geometry,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return location(
        "PUT",
        "/geofencing/v0/collections/$(CollectionName)/geofences/$(GeofenceId)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Geometry" => Geometry), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    search_place_index_for_position(index_name, position)
    search_place_index_for_position(index_name, position, params::Dict{String,<:Any})

Reverse geocodes a given coordinate and returns a legible address. Allows you to search for
Places or points of interest near a given position.

# Arguments
- `index_name`: The name of the place index resource you want to use for the search.
- `position`: Specifies the longitude and latitude of the position to query.  This
  parameter must contain a pair of numbers. The first number represents the X coordinate, or
  longitude; the second number represents the Y coordinate, or latitude. For example,
  [-123.1174, 49.2847] represents a position with longitude -123.1174 and latitude 49.2847.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Language"`: The preferred language used to return results. The value must be a valid
  BCP 47 language tag, for example, en for English. This setting affects the languages used
  in the results, but not the results themselves. If no language is specified, or not
  supported for a particular result, the partner automatically chooses a language for the
  result. For an example, we'll use the Greek language. You search for a location around
  Athens, Greece, with the language parameter set to en. The city in the results will most
  likely be returned as Athens. If you set the language parameter to el, for Greek, then the
  city in the results will more likely be returned as Αθήνα. If the data provider does
  not have a value for Greek, the result will be in a language that the provider does support.
- `"MaxResults"`: An optional parameter. The maximum number of results returned per
  request. Default value: 50
- `"key"`: The optional API key to authorize the request.
"""
function search_place_index_for_position(
    IndexName, Position; aws_config::AbstractAWSConfig=current_aws_config()
)
    return location(
        "POST",
        "/places/v0/indexes/$(IndexName)/search/position",
        Dict{String,Any}("Position" => Position);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function search_place_index_for_position(
    IndexName,
    Position,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return location(
        "POST",
        "/places/v0/indexes/$(IndexName)/search/position",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Position" => Position), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    search_place_index_for_suggestions(index_name, text)
    search_place_index_for_suggestions(index_name, text, params::Dict{String,<:Any})

Generates suggestions for addresses and points of interest based on partial or misspelled
free-form text. This operation is also known as autocomplete, autosuggest, or fuzzy
matching. Optional parameters let you narrow your search results by bounding box or
country, or bias your search toward a specific position on the globe.  You can search for
suggested place names near a specified position by using BiasPosition, or filter results
within a bounding box by using FilterBBox. These parameters are mutually exclusive; using
both BiasPosition and FilterBBox in the same command returns an error.

# Arguments
- `index_name`: The name of the place index resource you want to use for the search.
- `text`: The free-form partial text to use to generate place suggestions. For example,
  eiffel tow.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"BiasPosition"`: An optional parameter that indicates a preference for place suggestions
  that are closer to a specified position.  If provided, this parameter must contain a pair
  of numbers. The first number represents the X coordinate, or longitude; the second number
  represents the Y coordinate, or latitude. For example, [-123.1174, 49.2847] represents the
  position with longitude -123.1174 and latitude 49.2847.   BiasPosition and FilterBBox are
  mutually exclusive. Specifying both options results in an error.
- `"FilterBBox"`: An optional parameter that limits the search results by returning only
  suggestions within a specified bounding box.  If provided, this parameter must contain a
  total of four consecutive numbers in two pairs. The first pair of numbers represents the X
  and Y coordinates (longitude and latitude, respectively) of the southwest corner of the
  bounding box; the second pair of numbers represents the X and Y coordinates (longitude and
  latitude, respectively) of the northeast corner of the bounding box. For example,
  [-12.7935, -37.4835, -12.0684, -36.9542] represents a bounding box where the southwest
  corner has longitude -12.7935 and latitude -37.4835, and the northeast corner has longitude
  -12.0684 and latitude -36.9542.   FilterBBox and BiasPosition are mutually exclusive.
  Specifying both options results in an error.
- `"FilterCategories"`: A list of one or more Amazon Location categories to filter the
  returned places. If you include more than one category, the results will include results
  that match any of the categories listed. For more information about using categories,
  including a list of Amazon Location categories, see Categories and filtering, in the Amazon
  Location Service Developer Guide.
- `"FilterCountries"`: An optional parameter that limits the search results by returning
  only suggestions within the provided list of countries.   Use the ISO 3166 3-digit country
  code. For example, Australia uses three upper-case characters: AUS.
- `"Language"`: The preferred language used to return results. The value must be a valid
  BCP 47 language tag, for example, en for English. This setting affects the languages used
  in the results. If no language is specified, or not supported for a particular result, the
  partner automatically chooses a language for the result. For an example, we'll use the
  Greek language. You search for Athens, Gr to get suggestions with the language parameter
  set to en. The results found will most likely be returned as Athens, Greece. If you set the
  language parameter to el, for Greek, then the result found will more likely be returned as
  Αθήνα, Ελλάδα. If the data provider does not have a value for Greek, the result
  will be in a language that the provider does support.
- `"MaxResults"`: An optional parameter. The maximum number of results returned per
  request.  The default: 5
- `"key"`: The optional API key to authorize the request.
"""
function search_place_index_for_suggestions(
    IndexName, Text; aws_config::AbstractAWSConfig=current_aws_config()
)
    return location(
        "POST",
        "/places/v0/indexes/$(IndexName)/search/suggestions",
        Dict{String,Any}("Text" => Text);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function search_place_index_for_suggestions(
    IndexName,
    Text,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return location(
        "POST",
        "/places/v0/indexes/$(IndexName)/search/suggestions",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Text" => Text), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    search_place_index_for_text(index_name, text)
    search_place_index_for_text(index_name, text, params::Dict{String,<:Any})

Geocodes free-form text, such as an address, name, city, or region to allow you to search
for Places or points of interest.  Optional parameters let you narrow your search results
by bounding box or country, or bias your search toward a specific position on the globe.
You can search for places near a given position using BiasPosition, or filter results
within a bounding box using FilterBBox. Providing both parameters simultaneously returns an
error.  Search results are returned in order of highest to lowest relevance.

# Arguments
- `index_name`: The name of the place index resource you want to use for the search.
- `text`: The address, name, city, or region to be used in the search in free-form text
  format. For example, 123 Any Street.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"BiasPosition"`: An optional parameter that indicates a preference for places that are
  closer to a specified position.  If provided, this parameter must contain a pair of
  numbers. The first number represents the X coordinate, or longitude; the second number
  represents the Y coordinate, or latitude. For example, [-123.1174, 49.2847] represents the
  position with longitude -123.1174 and latitude 49.2847.   BiasPosition and FilterBBox are
  mutually exclusive. Specifying both options results in an error.
- `"FilterBBox"`: An optional parameter that limits the search results by returning only
  places that are within the provided bounding box.  If provided, this parameter must contain
  a total of four consecutive numbers in two pairs. The first pair of numbers represents the
  X and Y coordinates (longitude and latitude, respectively) of the southwest corner of the
  bounding box; the second pair of numbers represents the X and Y coordinates (longitude and
  latitude, respectively) of the northeast corner of the bounding box. For example,
  [-12.7935, -37.4835, -12.0684, -36.9542] represents a bounding box where the southwest
  corner has longitude -12.7935 and latitude -37.4835, and the northeast corner has longitude
  -12.0684 and latitude -36.9542.   FilterBBox and BiasPosition are mutually exclusive.
  Specifying both options results in an error.
- `"FilterCategories"`: A list of one or more Amazon Location categories to filter the
  returned places. If you include more than one category, the results will include results
  that match any of the categories listed. For more information about using categories,
  including a list of Amazon Location categories, see Categories and filtering, in the Amazon
  Location Service Developer Guide.
- `"FilterCountries"`: An optional parameter that limits the search results by returning
  only places that are in a specified list of countries.   Valid values include ISO 3166
  3-digit country codes. For example, Australia uses three upper-case characters: AUS.
- `"Language"`: The preferred language used to return results. The value must be a valid
  BCP 47 language tag, for example, en for English. This setting affects the languages used
  in the results, but not the results themselves. If no language is specified, or not
  supported for a particular result, the partner automatically chooses a language for the
  result. For an example, we'll use the Greek language. You search for Athens, Greece, with
  the language parameter set to en. The result found will most likely be returned as Athens.
  If you set the language parameter to el, for Greek, then the result found will more likely
  be returned as Αθήνα. If the data provider does not have a value for Greek, the result
  will be in a language that the provider does support.
- `"MaxResults"`: An optional parameter. The maximum number of results returned per
  request.  The default: 50
- `"key"`: The optional API key to authorize the request.
"""
function search_place_index_for_text(
    IndexName, Text; aws_config::AbstractAWSConfig=current_aws_config()
)
    return location(
        "POST",
        "/places/v0/indexes/$(IndexName)/search/text",
        Dict{String,Any}("Text" => Text);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function search_place_index_for_text(
    IndexName,
    Text,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return location(
        "POST",
        "/places/v0/indexes/$(IndexName)/search/text",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Text" => Text), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Assigns one or more tags (key-value pairs) to the specified Amazon Location Service
resource. Tags can help you organize and categorize your resources. You can also use them
to scope user permissions, by granting a user permission to access or change only resources
with certain tag values. You can use the TagResource operation with an Amazon Location
Service resource that already has tags. If you specify a new tag key for the resource, this
tag is appended to the tags already associated with the resource. If you specify a tag key
that's already associated with the resource, the new tag value that you specify replaces
the previous value for that tag.  You can associate up to 50 tags with a resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource whose tags you want to
  update.   Format example: arn:aws:geo:region:account-id:resourcetype/ExampleResource
- `tags`: Applies one or more tags to specific resource. A tag is a key-value pair that
  helps you manage, identify, search, and filter your resources. Format: \"key\" : \"value\"
  Restrictions:   Maximum 50 tags per resource.   Each tag key must be unique and must have
  exactly one associated value.   Maximum key length: 128 Unicode characters in UTF-8.
  Maximum value length: 256 Unicode characters in UTF-8.   Can use alphanumeric characters
  (A–Z, a–z, 0–9), and the following characters: + - = . _ : / @   Cannot use \"aws:\"
  as a prefix for a key.

"""
function tag_resource(ResourceArn, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return location(
        "POST",
        "/tags/$(ResourceArn)",
        Dict{String,Any}("Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceArn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return location(
        "POST",
        "/tags/$(ResourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Tags" => Tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes one or more tags from the specified Amazon Location resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource from which you want to
  remove tags.   Format example: arn:aws:geo:region:account-id:resourcetype/ExampleResource
- `tag_keys`: The list of tag keys to remove from the specified resource.

"""
function untag_resource(
    ResourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return location(
        "DELETE",
        "/tags/$(ResourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return location(
        "DELETE",
        "/tags/$(ResourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_geofence_collection(collection_name)
    update_geofence_collection(collection_name, params::Dict{String,<:Any})

Updates the specified properties of a given geofence collection.

# Arguments
- `collection_name`: The name of the geofence collection to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: Updates the description for the geofence collection.
- `"PricingPlan"`: No longer used. If included, the only allowed value is RequestBasedUsage.
- `"PricingPlanDataSource"`: This parameter is no longer used.
"""
function update_geofence_collection(
    CollectionName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return location(
        "PATCH",
        "/geofencing/v0/collections/$(CollectionName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_geofence_collection(
    CollectionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return location(
        "PATCH",
        "/geofencing/v0/collections/$(CollectionName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_key(key_name)
    update_key(key_name, params::Dict{String,<:Any})

Updates the specified properties of a given API key resource.

# Arguments
- `key_name`: The name of the API key resource to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: Updates the description for the API key resource.
- `"ExpireTime"`: Updates the timestamp for when the API key resource will expire in  ISO
  8601 format: YYYY-MM-DDThh:mm:ss.sssZ.
- `"ForceUpdate"`: The boolean flag to be included for updating ExpireTime or Restrictions
  details. Must be set to true to update an API key resource that has been used in the past 7
  days.  False if force update is not preferred Default value: False
- `"NoExpiry"`: Whether the API key should expire. Set to true to set the API key to have
  no expiration time.
- `"Restrictions"`: Updates the API key restrictions for the API key resource.
"""
function update_key(KeyName; aws_config::AbstractAWSConfig=current_aws_config())
    return location(
        "PATCH",
        "/metadata/v0/keys/$(KeyName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_key(
    KeyName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return location(
        "PATCH",
        "/metadata/v0/keys/$(KeyName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_map(map_name)
    update_map(map_name, params::Dict{String,<:Any})

Updates the specified properties of a given map resource.

# Arguments
- `map_name`: The name of the map resource to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConfigurationUpdate"`: Updates the parts of the map configuration that can be updated,
  including the political view.
- `"Description"`: Updates the description for the map resource.
- `"PricingPlan"`: No longer used. If included, the only allowed value is RequestBasedUsage.
"""
function update_map(MapName; aws_config::AbstractAWSConfig=current_aws_config())
    return location(
        "PATCH",
        "/maps/v0/maps/$(MapName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_map(
    MapName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return location(
        "PATCH",
        "/maps/v0/maps/$(MapName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_place_index(index_name)
    update_place_index(index_name, params::Dict{String,<:Any})

Updates the specified properties of a given place index resource.

# Arguments
- `index_name`: The name of the place index resource to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DataSourceConfiguration"`: Updates the data storage option for the place index resource.
- `"Description"`: Updates the description for the place index resource.
- `"PricingPlan"`: No longer used. If included, the only allowed value is RequestBasedUsage.
"""
function update_place_index(IndexName; aws_config::AbstractAWSConfig=current_aws_config())
    return location(
        "PATCH",
        "/places/v0/indexes/$(IndexName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_place_index(
    IndexName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return location(
        "PATCH",
        "/places/v0/indexes/$(IndexName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_route_calculator(calculator_name)
    update_route_calculator(calculator_name, params::Dict{String,<:Any})

Updates the specified properties for a given route calculator resource.

# Arguments
- `calculator_name`: The name of the route calculator resource to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: Updates the description for the route calculator resource.
- `"PricingPlan"`: No longer used. If included, the only allowed value is RequestBasedUsage.
"""
function update_route_calculator(
    CalculatorName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return location(
        "PATCH",
        "/routes/v0/calculators/$(CalculatorName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_route_calculator(
    CalculatorName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return location(
        "PATCH",
        "/routes/v0/calculators/$(CalculatorName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_tracker(tracker_name)
    update_tracker(tracker_name, params::Dict{String,<:Any})

Updates the specified properties of a given tracker resource.

# Arguments
- `tracker_name`: The name of the tracker resource to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: Updates the description for the tracker resource.
- `"EventBridgeEnabled"`: Whether to enable position UPDATE events from this tracker to be
  sent to EventBridge.  You do not need enable this feature to get ENTER and EXIT events for
  geofences with this tracker. Those events are always sent to EventBridge.
- `"KmsKeyEnableGeospatialQueries"`: Enables GeospatialQueries for a tracker that uses a
  Amazon Web Services KMS customer managed key. This parameter is only used if you are using
  a KMS customer managed key.
- `"PositionFiltering"`: Updates the position filtering for the tracker resource. Valid
  values:    TimeBased - Location updates are evaluated against linked geofence collections,
  but not every location update is stored. If your update frequency is more often than 30
  seconds, only one update per 30 seconds is stored for each unique device ID.
  DistanceBased - If the device has moved less than 30 m (98.4 ft), location updates are
  ignored. Location updates within this distance are neither evaluated against linked
  geofence collections, nor stored. This helps control costs by reducing the number of
  geofence evaluations and historical device positions to paginate through. Distance-based
  filtering can also reduce the effects of GPS noise when displaying device trajectories on a
  map.     AccuracyBased - If the device has moved less than the measured accuracy, location
  updates are ignored. For example, if two consecutive updates from a device have a
  horizontal accuracy of 5 m and 10 m, the second update is ignored if the device has moved
  less than 15 m. Ignored location updates are neither evaluated against linked geofence
  collections, nor stored. This helps educe the effects of GPS noise when displaying device
  trajectories on a map, and can help control costs by reducing the number of geofence
  evaluations.
- `"PricingPlan"`: No longer used. If included, the only allowed value is RequestBasedUsage.
- `"PricingPlanDataSource"`: This parameter is no longer used.
"""
function update_tracker(TrackerName; aws_config::AbstractAWSConfig=current_aws_config())
    return location(
        "PATCH",
        "/tracking/v0/trackers/$(TrackerName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_tracker(
    TrackerName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return location(
        "PATCH",
        "/tracking/v0/trackers/$(TrackerName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    verify_device_position(device_state, tracker_name)
    verify_device_position(device_state, tracker_name, params::Dict{String,<:Any})

Verifies the integrity of the device's position by determining if it was reported behind a
proxy, and by comparing it to an inferred position estimated based on the device's state.

# Arguments
- `device_state`: The device's state, including position, IP address, cell signals and
  Wi-Fi access points.
- `tracker_name`: The name of the tracker resource to be associated with verification
  request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DistanceUnit"`: The distance unit for the verification request. Default Value:
  Kilometers
"""
function verify_device_position(
    DeviceState, TrackerName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return location(
        "POST",
        "/tracking/v0/trackers/$(TrackerName)/positions/verify",
        Dict{String,Any}("DeviceState" => DeviceState);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function verify_device_position(
    DeviceState,
    TrackerName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return location(
        "POST",
        "/tracking/v0/trackers/$(TrackerName)/positions/verify",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DeviceState" => DeviceState), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: config_service
using AWS.Compat
using AWS.UUIDs

"""
    batch_get_aggregate_resource_config(configuration_aggregator_name, resource_identifiers)
    batch_get_aggregate_resource_config(configuration_aggregator_name, resource_identifiers, params::Dict{String,<:Any})

Returns the current configuration items for resources that are present in your Config
aggregator. The operation also returns a list of resources that are not processed in the
current request. If there are no unprocessed resources, the operation returns an empty
unprocessedResourceIdentifiers list.     The API does not return results for deleted
resources.    The API does not return tags and relationships.

# Arguments
- `configuration_aggregator_name`: The name of the configuration aggregator.
- `resource_identifiers`: A list of aggregate ResourceIdentifiers objects.

"""
function batch_get_aggregate_resource_config(
    ConfigurationAggregatorName,
    ResourceIdentifiers;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "BatchGetAggregateResourceConfig",
        Dict{String,Any}(
            "ConfigurationAggregatorName" => ConfigurationAggregatorName,
            "ResourceIdentifiers" => ResourceIdentifiers,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_aggregate_resource_config(
    ConfigurationAggregatorName,
    ResourceIdentifiers,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "BatchGetAggregateResourceConfig",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ConfigurationAggregatorName" => ConfigurationAggregatorName,
                    "ResourceIdentifiers" => ResourceIdentifiers,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_get_resource_config(resource_keys)
    batch_get_resource_config(resource_keys, params::Dict{String,<:Any})

Returns the BaseConfigurationItem for one or more requested resources. The operation also
returns a list of resources that are not processed in the current request. If there are no
unprocessed resources, the operation returns an empty unprocessedResourceKeys list.     The
API does not return results for deleted resources.    The API does not return any tags for
the requested resources. This information is filtered out of the supplementaryConfiguration
section of the API response.

# Arguments
- `resource_keys`: A list of resource keys to be processed with the current request. Each
  element in the list consists of the resource type and resource ID.

"""
function batch_get_resource_config(
    resourceKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "BatchGetResourceConfig",
        Dict{String,Any}("resourceKeys" => resourceKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_resource_config(
    resourceKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "BatchGetResourceConfig",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceKeys" => resourceKeys), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_aggregation_authorization(authorized_account_id, authorized_aws_region)
    delete_aggregation_authorization(authorized_account_id, authorized_aws_region, params::Dict{String,<:Any})

Deletes the authorization granted to the specified configuration aggregator account in a
specified region.

# Arguments
- `authorized_account_id`: The 12-digit account ID of the account authorized to aggregate
  data.
- `authorized_aws_region`: The region authorized to collect aggregated data.

"""
function delete_aggregation_authorization(
    AuthorizedAccountId,
    AuthorizedAwsRegion;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "DeleteAggregationAuthorization",
        Dict{String,Any}(
            "AuthorizedAccountId" => AuthorizedAccountId,
            "AuthorizedAwsRegion" => AuthorizedAwsRegion,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_aggregation_authorization(
    AuthorizedAccountId,
    AuthorizedAwsRegion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "DeleteAggregationAuthorization",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AuthorizedAccountId" => AuthorizedAccountId,
                    "AuthorizedAwsRegion" => AuthorizedAwsRegion,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_config_rule(config_rule_name)
    delete_config_rule(config_rule_name, params::Dict{String,<:Any})

Deletes the specified Config rule and all of its evaluation results. Config sets the state
of a rule to DELETING until the deletion is complete. You cannot update a rule while it is
in this state. If you make a PutConfigRule or DeleteConfigRule request for the rule, you
will receive a ResourceInUseException. You can check the state of a rule by using the
DescribeConfigRules request.

# Arguments
- `config_rule_name`: The name of the Config rule that you want to delete.

"""
function delete_config_rule(
    ConfigRuleName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "DeleteConfigRule",
        Dict{String,Any}("ConfigRuleName" => ConfigRuleName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_config_rule(
    ConfigRuleName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "DeleteConfigRule",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ConfigRuleName" => ConfigRuleName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_configuration_aggregator(configuration_aggregator_name)
    delete_configuration_aggregator(configuration_aggregator_name, params::Dict{String,<:Any})

Deletes the specified configuration aggregator and the aggregated data associated with the
aggregator.

# Arguments
- `configuration_aggregator_name`: The name of the configuration aggregator.

"""
function delete_configuration_aggregator(
    ConfigurationAggregatorName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "DeleteConfigurationAggregator",
        Dict{String,Any}("ConfigurationAggregatorName" => ConfigurationAggregatorName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_configuration_aggregator(
    ConfigurationAggregatorName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "DeleteConfigurationAggregator",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ConfigurationAggregatorName" => ConfigurationAggregatorName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_configuration_recorder(configuration_recorder_name)
    delete_configuration_recorder(configuration_recorder_name, params::Dict{String,<:Any})

Deletes the configuration recorder. After the configuration recorder is deleted, Config
will not record resource configuration changes until you create a new configuration
recorder. This action does not delete the configuration information that was previously
recorded. You will be able to access the previously recorded information by using the
GetResourceConfigHistory action, but you will not be able to access this information in the
Config console until you create a new configuration recorder.

# Arguments
- `configuration_recorder_name`: The name of the configuration recorder to be deleted. You
  can retrieve the name of your configuration recorder by using the
  DescribeConfigurationRecorders action.

"""
function delete_configuration_recorder(
    ConfigurationRecorderName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "DeleteConfigurationRecorder",
        Dict{String,Any}("ConfigurationRecorderName" => ConfigurationRecorderName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_configuration_recorder(
    ConfigurationRecorderName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "DeleteConfigurationRecorder",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ConfigurationRecorderName" => ConfigurationRecorderName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_conformance_pack(conformance_pack_name)
    delete_conformance_pack(conformance_pack_name, params::Dict{String,<:Any})

Deletes the specified conformance pack and all the Config rules, remediation actions, and
all evaluation results within that conformance pack. Config sets the conformance pack to
DELETE_IN_PROGRESS until the deletion is complete. You cannot update a conformance pack
while it is in this state.

# Arguments
- `conformance_pack_name`: Name of the conformance pack you want to delete.

"""
function delete_conformance_pack(
    ConformancePackName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "DeleteConformancePack",
        Dict{String,Any}("ConformancePackName" => ConformancePackName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_conformance_pack(
    ConformancePackName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "DeleteConformancePack",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ConformancePackName" => ConformancePackName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_delivery_channel(delivery_channel_name)
    delete_delivery_channel(delivery_channel_name, params::Dict{String,<:Any})

Deletes the delivery channel. Before you can delete the delivery channel, you must stop the
configuration recorder by using the StopConfigurationRecorder action.

# Arguments
- `delivery_channel_name`: The name of the delivery channel to delete.

"""
function delete_delivery_channel(
    DeliveryChannelName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "DeleteDeliveryChannel",
        Dict{String,Any}("DeliveryChannelName" => DeliveryChannelName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_delivery_channel(
    DeliveryChannelName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "DeleteDeliveryChannel",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DeliveryChannelName" => DeliveryChannelName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_evaluation_results(config_rule_name)
    delete_evaluation_results(config_rule_name, params::Dict{String,<:Any})

Deletes the evaluation results for the specified Config rule. You can specify one Config
rule per request. After you delete the evaluation results, you can call the
StartConfigRulesEvaluation API to start evaluating your Amazon Web Services resources
against the rule.

# Arguments
- `config_rule_name`: The name of the Config rule for which you want to delete the
  evaluation results.

"""
function delete_evaluation_results(
    ConfigRuleName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "DeleteEvaluationResults",
        Dict{String,Any}("ConfigRuleName" => ConfigRuleName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_evaluation_results(
    ConfigRuleName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "DeleteEvaluationResults",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ConfigRuleName" => ConfigRuleName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_organization_config_rule(organization_config_rule_name)
    delete_organization_config_rule(organization_config_rule_name, params::Dict{String,<:Any})

Deletes the specified organization Config rule and all of its evaluation results from all
member accounts in that organization.  Only a management account and a delegated
administrator account can delete an organization Config rule. When calling this API with a
delegated administrator, you must ensure Organizations ListDelegatedAdministrator
permissions are added. Config sets the state of a rule to DELETE_IN_PROGRESS until the
deletion is complete. You cannot update a rule while it is in this state.

# Arguments
- `organization_config_rule_name`: The name of organization Config rule that you want to
  delete.

"""
function delete_organization_config_rule(
    OrganizationConfigRuleName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "DeleteOrganizationConfigRule",
        Dict{String,Any}("OrganizationConfigRuleName" => OrganizationConfigRuleName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_organization_config_rule(
    OrganizationConfigRuleName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "DeleteOrganizationConfigRule",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "OrganizationConfigRuleName" => OrganizationConfigRuleName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_organization_conformance_pack(organization_conformance_pack_name)
    delete_organization_conformance_pack(organization_conformance_pack_name, params::Dict{String,<:Any})

Deletes the specified organization conformance pack and all of the Config rules and
remediation actions from all member accounts in that organization.   Only a management
account or a delegated administrator account can delete an organization conformance pack.
When calling this API with a delegated administrator, you must ensure Organizations
ListDelegatedAdministrator permissions are added. Config sets the state of a conformance
pack to DELETE_IN_PROGRESS until the deletion is complete. You cannot update a conformance
pack while it is in this state.

# Arguments
- `organization_conformance_pack_name`: The name of organization conformance pack that you
  want to delete.

"""
function delete_organization_conformance_pack(
    OrganizationConformancePackName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "DeleteOrganizationConformancePack",
        Dict{String,Any}(
            "OrganizationConformancePackName" => OrganizationConformancePackName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_organization_conformance_pack(
    OrganizationConformancePackName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "DeleteOrganizationConformancePack",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "OrganizationConformancePackName" => OrganizationConformancePackName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_pending_aggregation_request(requester_account_id, requester_aws_region)
    delete_pending_aggregation_request(requester_account_id, requester_aws_region, params::Dict{String,<:Any})

Deletes pending authorization requests for a specified aggregator account in a specified
region.

# Arguments
- `requester_account_id`: The 12-digit account ID of the account requesting to aggregate
  data.
- `requester_aws_region`: The region requesting to aggregate data.

"""
function delete_pending_aggregation_request(
    RequesterAccountId,
    RequesterAwsRegion;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "DeletePendingAggregationRequest",
        Dict{String,Any}(
            "RequesterAccountId" => RequesterAccountId,
            "RequesterAwsRegion" => RequesterAwsRegion,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_pending_aggregation_request(
    RequesterAccountId,
    RequesterAwsRegion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "DeletePendingAggregationRequest",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "RequesterAccountId" => RequesterAccountId,
                    "RequesterAwsRegion" => RequesterAwsRegion,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_remediation_configuration(config_rule_name)
    delete_remediation_configuration(config_rule_name, params::Dict{String,<:Any})

Deletes the remediation configuration.

# Arguments
- `config_rule_name`: The name of the Config rule for which you want to delete remediation
  configuration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ResourceType"`: The type of a resource.
"""
function delete_remediation_configuration(
    ConfigRuleName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "DeleteRemediationConfiguration",
        Dict{String,Any}("ConfigRuleName" => ConfigRuleName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_remediation_configuration(
    ConfigRuleName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "DeleteRemediationConfiguration",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ConfigRuleName" => ConfigRuleName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_remediation_exceptions(config_rule_name, resource_keys)
    delete_remediation_exceptions(config_rule_name, resource_keys, params::Dict{String,<:Any})

Deletes one or more remediation exceptions mentioned in the resource keys.  Config
generates a remediation exception when a problem occurs executing a remediation action to a
specific resource. Remediation exceptions blocks auto-remediation until the exception is
cleared.

# Arguments
- `config_rule_name`: The name of the Config rule for which you want to delete remediation
  exception configuration.
- `resource_keys`: An exception list of resource exception keys to be processed with the
  current request. Config adds exception for each resource key. For example, Config adds 3
  exceptions for 3 resource keys.

"""
function delete_remediation_exceptions(
    ConfigRuleName, ResourceKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "DeleteRemediationExceptions",
        Dict{String,Any}(
            "ConfigRuleName" => ConfigRuleName, "ResourceKeys" => ResourceKeys
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_remediation_exceptions(
    ConfigRuleName,
    ResourceKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "DeleteRemediationExceptions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ConfigRuleName" => ConfigRuleName, "ResourceKeys" => ResourceKeys
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_resource_config(resource_id, resource_type)
    delete_resource_config(resource_id, resource_type, params::Dict{String,<:Any})

Records the configuration state for a custom resource that has been deleted. This API
records a new ConfigurationItem with a ResourceDeleted status. You can retrieve the
ConfigurationItems recorded for this resource in your Config History.

# Arguments
- `resource_id`: Unique identifier of the resource.
- `resource_type`: The type of the resource.

"""
function delete_resource_config(
    ResourceId, ResourceType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "DeleteResourceConfig",
        Dict{String,Any}("ResourceId" => ResourceId, "ResourceType" => ResourceType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_resource_config(
    ResourceId,
    ResourceType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "DeleteResourceConfig",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ResourceId" => ResourceId, "ResourceType" => ResourceType
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_retention_configuration(retention_configuration_name)
    delete_retention_configuration(retention_configuration_name, params::Dict{String,<:Any})

Deletes the retention configuration.

# Arguments
- `retention_configuration_name`: The name of the retention configuration to delete.

"""
function delete_retention_configuration(
    RetentionConfigurationName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "DeleteRetentionConfiguration",
        Dict{String,Any}("RetentionConfigurationName" => RetentionConfigurationName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_retention_configuration(
    RetentionConfigurationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "DeleteRetentionConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "RetentionConfigurationName" => RetentionConfigurationName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_stored_query(query_name)
    delete_stored_query(query_name, params::Dict{String,<:Any})

Deletes the stored query for a single Amazon Web Services account and a single Amazon Web
Services Region.

# Arguments
- `query_name`: The name of the query that you want to delete.

"""
function delete_stored_query(QueryName; aws_config::AbstractAWSConfig=current_aws_config())
    return config_service(
        "DeleteStoredQuery",
        Dict{String,Any}("QueryName" => QueryName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_stored_query(
    QueryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "DeleteStoredQuery",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("QueryName" => QueryName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    deliver_config_snapshot(delivery_channel_name)
    deliver_config_snapshot(delivery_channel_name, params::Dict{String,<:Any})

Schedules delivery of a configuration snapshot to the Amazon S3 bucket in the specified
delivery channel. After the delivery has started, Config sends the following notifications
using an Amazon SNS topic that you have specified.   Notification of the start of the
delivery.   Notification of the completion of the delivery, if the delivery was
successfully completed.   Notification of delivery failure, if the delivery failed.

# Arguments
- `delivery_channel_name`: The name of the delivery channel through which the snapshot is
  delivered.

"""
function deliver_config_snapshot(
    deliveryChannelName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "DeliverConfigSnapshot",
        Dict{String,Any}("deliveryChannelName" => deliveryChannelName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function deliver_config_snapshot(
    deliveryChannelName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "DeliverConfigSnapshot",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("deliveryChannelName" => deliveryChannelName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_aggregate_compliance_by_config_rules(configuration_aggregator_name)
    describe_aggregate_compliance_by_config_rules(configuration_aggregator_name, params::Dict{String,<:Any})

Returns a list of compliant and noncompliant rules with the number of resources for
compliant and noncompliant rules. Does not display rules that do not have compliance
results.   The results can return an empty result page, but if you have a nextToken, the
results are displayed on the next page.

# Arguments
- `configuration_aggregator_name`: The name of the configuration aggregator.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: Filters the results by ConfigRuleComplianceFilters object.
- `"Limit"`: The maximum number of evaluation results returned on each page. The default is
  maximum. If you specify 0, Config uses the default.
- `"NextToken"`: The nextToken string returned on a previous page that you use to get the
  next page of results in a paginated response.
"""
function describe_aggregate_compliance_by_config_rules(
    ConfigurationAggregatorName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "DescribeAggregateComplianceByConfigRules",
        Dict{String,Any}("ConfigurationAggregatorName" => ConfigurationAggregatorName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_aggregate_compliance_by_config_rules(
    ConfigurationAggregatorName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "DescribeAggregateComplianceByConfigRules",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ConfigurationAggregatorName" => ConfigurationAggregatorName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_aggregate_compliance_by_conformance_packs(configuration_aggregator_name)
    describe_aggregate_compliance_by_conformance_packs(configuration_aggregator_name, params::Dict{String,<:Any})

Returns a list of the conformance packs and their associated compliance status with the
count of compliant and noncompliant Config rules within each conformance pack. Also returns
the total rule count which includes compliant rules, noncompliant rules, and rules that
cannot be evaluated due to insufficient data.  The results can return an empty result page,
but if you have a nextToken, the results are displayed on the next page.

# Arguments
- `configuration_aggregator_name`: The name of the configuration aggregator.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: Filters the result by AggregateConformancePackComplianceFilters object.
- `"Limit"`: The maximum number of conformance packs compliance details returned on each
  page. The default is maximum. If you specify 0, Config uses the default.
- `"NextToken"`: The nextToken string returned on a previous page that you use to get the
  next page of results in a paginated response.
"""
function describe_aggregate_compliance_by_conformance_packs(
    ConfigurationAggregatorName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "DescribeAggregateComplianceByConformancePacks",
        Dict{String,Any}("ConfigurationAggregatorName" => ConfigurationAggregatorName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_aggregate_compliance_by_conformance_packs(
    ConfigurationAggregatorName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "DescribeAggregateComplianceByConformancePacks",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ConfigurationAggregatorName" => ConfigurationAggregatorName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_aggregation_authorizations()
    describe_aggregation_authorizations(params::Dict{String,<:Any})

Returns a list of authorizations granted to various aggregator accounts and regions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: The maximum number of AggregationAuthorizations returned on each page. The
  default is maximum. If you specify 0, Config uses the default.
- `"NextToken"`: The nextToken string returned on a previous page that you use to get the
  next page of results in a paginated response.
"""
function describe_aggregation_authorizations(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "DescribeAggregationAuthorizations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_aggregation_authorizations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "DescribeAggregationAuthorizations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_compliance_by_config_rule()
    describe_compliance_by_config_rule(params::Dict{String,<:Any})

Indicates whether the specified Config rules are compliant. If a rule is noncompliant, this
action returns the number of Amazon Web Services resources that do not comply with the
rule. A rule is compliant if all of the evaluated resources comply with it. It is
noncompliant if any of these resources do not comply. If Config has no current evaluation
results for the rule, it returns INSUFFICIENT_DATA. This result might indicate one of the
following conditions:   Config has never invoked an evaluation for the rule. To check
whether it has, use the DescribeConfigRuleEvaluationStatus action to get the
LastSuccessfulInvocationTime and LastFailedInvocationTime.   The rule's Lambda function is
failing to send evaluation results to Config. Verify that the role you assigned to your
configuration recorder includes the config:PutEvaluations permission. If the rule is a
custom rule, verify that the Lambda execution role includes the config:PutEvaluations
permission.   The rule's Lambda function has returned NOT_APPLICABLE for all evaluation
results. This can occur if the resources were deleted or removed from the rule's scope.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ComplianceTypes"`: Filters the results by compliance.
- `"ConfigRuleNames"`: Specify one or more Config rule names to filter the results by rule.
- `"NextToken"`: The nextToken string returned on a previous page that you use to get the
  next page of results in a paginated response.
"""
function describe_compliance_by_config_rule(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "DescribeComplianceByConfigRule";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_compliance_by_config_rule(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "DescribeComplianceByConfigRule",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_compliance_by_resource()
    describe_compliance_by_resource(params::Dict{String,<:Any})

Indicates whether the specified Amazon Web Services resources are compliant. If a resource
is noncompliant, this action returns the number of Config rules that the resource does not
comply with. A resource is compliant if it complies with all the Config rules that evaluate
it. It is noncompliant if it does not comply with one or more of these rules. If Config has
no current evaluation results for the resource, it returns INSUFFICIENT_DATA. This result
might indicate one of the following conditions about the rules that evaluate the resource:
 Config has never invoked an evaluation for the rule. To check whether it has, use the
DescribeConfigRuleEvaluationStatus action to get the LastSuccessfulInvocationTime and
LastFailedInvocationTime.   The rule's Lambda function is failing to send evaluation
results to Config. Verify that the role that you assigned to your configuration recorder
includes the config:PutEvaluations permission. If the rule is a custom rule, verify that
the Lambda execution role includes the config:PutEvaluations permission.   The rule's
Lambda function has returned NOT_APPLICABLE for all evaluation results. This can occur if
the resources were deleted or removed from the rule's scope.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ComplianceTypes"`: Filters the results by compliance.
- `"Limit"`: The maximum number of evaluation results returned on each page. The default is
  10. You cannot specify a number greater than 100. If you specify 0, Config uses the default.
- `"NextToken"`: The nextToken string returned on a previous page that you use to get the
  next page of results in a paginated response.
- `"ResourceId"`: The ID of the Amazon Web Services resource for which you want compliance
  information. You can specify only one resource ID. If you specify a resource ID, you must
  also specify a type for ResourceType.
- `"ResourceType"`: The types of Amazon Web Services resources for which you want
  compliance information (for example, AWS::EC2::Instance). For this action, you can specify
  that the resource type is an Amazon Web Services account by specifying AWS::::Account.
"""
function describe_compliance_by_resource(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "DescribeComplianceByResource";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_compliance_by_resource(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "DescribeComplianceByResource",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_config_rule_evaluation_status()
    describe_config_rule_evaluation_status(params::Dict{String,<:Any})

Returns status information for each of your Config managed rules. The status includes
information such as the last time Config invoked the rule, the last time Config failed to
invoke the rule, and the related error for the last failure.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConfigRuleNames"`: The name of the Config managed rules for which you want status
  information. If you do not specify any names, Config returns status information for all
  Config managed rules that you use.
- `"Limit"`: The number of rule evaluation results that you want returned. This parameter
  is required if the rule limit for your account is more than the default of 1000 rules. For
  information about requesting a rule limit increase, see Config Limits in the Amazon Web
  Services General Reference Guide.
- `"NextToken"`: The nextToken string returned on a previous page that you use to get the
  next page of results in a paginated response.
"""
function describe_config_rule_evaluation_status(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "DescribeConfigRuleEvaluationStatus";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_config_rule_evaluation_status(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "DescribeConfigRuleEvaluationStatus",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_config_rules()
    describe_config_rules(params::Dict{String,<:Any})

Returns details about your Config rules.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConfigRuleNames"`: The names of the Config rules for which you want details. If you do
  not specify any names, Config returns details for all your rules.
- `"Filters"`: Returns a list of Detective or Proactive Config rules. By default, this API
  returns an unfiltered list. For more information on Detective or Proactive Config rules,
  see  Evaluation Mode  in the Config Developer Guide.
- `"NextToken"`: The nextToken string returned on a previous page that you use to get the
  next page of results in a paginated response.
"""
function describe_config_rules(; aws_config::AbstractAWSConfig=current_aws_config())
    return config_service(
        "DescribeConfigRules"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_config_rules(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "DescribeConfigRules",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_configuration_aggregator_sources_status(configuration_aggregator_name)
    describe_configuration_aggregator_sources_status(configuration_aggregator_name, params::Dict{String,<:Any})

Returns status information for sources within an aggregator. The status includes
information about the last time Config verified authorization between the source account
and an aggregator account. In case of a failure, the status contains the related error code
or message.

# Arguments
- `configuration_aggregator_name`: The name of the configuration aggregator.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: The maximum number of AggregatorSourceStatus returned on each page. The
  default is maximum. If you specify 0, Config uses the default.
- `"NextToken"`: The nextToken string returned on a previous page that you use to get the
  next page of results in a paginated response.
- `"UpdateStatus"`: Filters the status type.   Valid value FAILED indicates errors while
  moving data.   Valid value SUCCEEDED indicates the data was successfully moved.   Valid
  value OUTDATED indicates the data is not the most recent.
"""
function describe_configuration_aggregator_sources_status(
    ConfigurationAggregatorName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "DescribeConfigurationAggregatorSourcesStatus",
        Dict{String,Any}("ConfigurationAggregatorName" => ConfigurationAggregatorName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_configuration_aggregator_sources_status(
    ConfigurationAggregatorName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "DescribeConfigurationAggregatorSourcesStatus",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ConfigurationAggregatorName" => ConfigurationAggregatorName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_configuration_aggregators()
    describe_configuration_aggregators(params::Dict{String,<:Any})

Returns the details of one or more configuration aggregators. If the configuration
aggregator is not specified, this action returns the details for all the configuration
aggregators associated with the account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConfigurationAggregatorNames"`: The name of the configuration aggregators.
- `"Limit"`: The maximum number of configuration aggregators returned on each page. The
  default is maximum. If you specify 0, Config uses the default.
- `"NextToken"`: The nextToken string returned on a previous page that you use to get the
  next page of results in a paginated response.
"""
function describe_configuration_aggregators(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "DescribeConfigurationAggregators";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_configuration_aggregators(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "DescribeConfigurationAggregators",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_configuration_recorder_status()
    describe_configuration_recorder_status(params::Dict{String,<:Any})

Returns the current status of the specified configuration recorder as well as the status of
the last recording event for the recorder. If a configuration recorder is not specified,
this action returns the status of all configuration recorders associated with the account.
&gt;You can specify only one configuration recorder for each Amazon Web Services Region for
each account. For a detailed status of recording events over time, add your Config events
to Amazon CloudWatch metrics and use CloudWatch metrics.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConfigurationRecorderNames"`: The name(s) of the configuration recorder. If the name is
  not specified, the action returns the current status of all the configuration recorders
  associated with the account.
"""
function describe_configuration_recorder_status(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "DescribeConfigurationRecorderStatus";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_configuration_recorder_status(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "DescribeConfigurationRecorderStatus",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_configuration_recorders()
    describe_configuration_recorders(params::Dict{String,<:Any})

Returns the details for the specified configuration recorders. If the configuration
recorder is not specified, this action returns the details for all configuration recorders
associated with the account.  You can specify only one configuration recorder for each
Amazon Web Services Region for each account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConfigurationRecorderNames"`: A list of configuration recorder names.
"""
function describe_configuration_recorders(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "DescribeConfigurationRecorders";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_configuration_recorders(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "DescribeConfigurationRecorders",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_conformance_pack_compliance(conformance_pack_name)
    describe_conformance_pack_compliance(conformance_pack_name, params::Dict{String,<:Any})

Returns compliance details for each rule in that conformance pack.  You must provide exact
rule names.

# Arguments
- `conformance_pack_name`: Name of the conformance pack.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: A ConformancePackComplianceFilters object.
- `"Limit"`: The maximum number of Config rules within a conformance pack are returned on
  each page.
- `"NextToken"`: The nextToken string returned in a previous request that you use to
  request the next page of results in a paginated response.
"""
function describe_conformance_pack_compliance(
    ConformancePackName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "DescribeConformancePackCompliance",
        Dict{String,Any}("ConformancePackName" => ConformancePackName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_conformance_pack_compliance(
    ConformancePackName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "DescribeConformancePackCompliance",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ConformancePackName" => ConformancePackName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_conformance_pack_status()
    describe_conformance_pack_status(params::Dict{String,<:Any})

Provides one or more conformance packs deployment status.  If there are no conformance
packs then you will see an empty result.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConformancePackNames"`: Comma-separated list of conformance pack names.
- `"Limit"`: The maximum number of conformance packs status returned on each page.
- `"NextToken"`: The nextToken string returned in a previous request that you use to
  request the next page of results in a paginated response.
"""
function describe_conformance_pack_status(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "DescribeConformancePackStatus";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_conformance_pack_status(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "DescribeConformancePackStatus",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_conformance_packs()
    describe_conformance_packs(params::Dict{String,<:Any})

Returns a list of one or more conformance packs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConformancePackNames"`: Comma-separated list of conformance pack names for which you
  want details. If you do not specify any names, Config returns details for all your
  conformance packs.
- `"Limit"`: The maximum number of conformance packs returned on each page.
- `"NextToken"`: The nextToken string returned in a previous request that you use to
  request the next page of results in a paginated response.
"""
function describe_conformance_packs(; aws_config::AbstractAWSConfig=current_aws_config())
    return config_service(
        "DescribeConformancePacks"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_conformance_packs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "DescribeConformancePacks",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_delivery_channel_status()
    describe_delivery_channel_status(params::Dict{String,<:Any})

Returns the current status of the specified delivery channel. If a delivery channel is not
specified, this action returns the current status of all delivery channels associated with
the account.  Currently, you can specify only one delivery channel per region in your
account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DeliveryChannelNames"`: A list of delivery channel names.
"""
function describe_delivery_channel_status(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "DescribeDeliveryChannelStatus";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_delivery_channel_status(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "DescribeDeliveryChannelStatus",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_delivery_channels()
    describe_delivery_channels(params::Dict{String,<:Any})

Returns details about the specified delivery channel. If a delivery channel is not
specified, this action returns the details of all delivery channels associated with the
account.  Currently, you can specify only one delivery channel per region in your account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DeliveryChannelNames"`: A list of delivery channel names.
"""
function describe_delivery_channels(; aws_config::AbstractAWSConfig=current_aws_config())
    return config_service(
        "DescribeDeliveryChannels"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_delivery_channels(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "DescribeDeliveryChannels",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_organization_config_rule_statuses()
    describe_organization_config_rule_statuses(params::Dict{String,<:Any})

Provides organization Config rule deployment status for an organization.  The status is not
considered successful until organization Config rule is successfully deployed in all the
member accounts with an exception of excluded accounts. When you specify the limit and the
next token, you receive a paginated response. Limit and next token are not applicable if
you specify organization Config rule names. It is only applicable, when you request all the
organization Config rules.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: The maximum number of OrganizationConfigRuleStatuses returned on each page. If
  you do no specify a number, Config uses the default. The default is 100.
- `"NextToken"`: The nextToken string returned on a previous page that you use to get the
  next page of results in a paginated response.
- `"OrganizationConfigRuleNames"`: The names of organization Config rules for which you
  want status details. If you do not specify any names, Config returns details for all your
  organization Config rules.
"""
function describe_organization_config_rule_statuses(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "DescribeOrganizationConfigRuleStatuses";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_organization_config_rule_statuses(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "DescribeOrganizationConfigRuleStatuses",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_organization_config_rules()
    describe_organization_config_rules(params::Dict{String,<:Any})

Returns a list of organization Config rules.   When you specify the limit and the next
token, you receive a paginated response. Limit and next token are not applicable if you
specify organization Config rule names. It is only applicable, when you request all the
organization Config rules.  For accounts within an organization  If you deploy an
organizational rule or conformance pack in an organization administrator account, and then
establish a delegated administrator and deploy an organizational rule or conformance pack
in the delegated administrator account, you won't be able to see the organizational rule or
conformance pack in the organization administrator account from the delegated administrator
account or see the organizational rule or conformance pack in the delegated administrator
account from organization administrator account. The DescribeOrganizationConfigRules and
DescribeOrganizationConformancePacks APIs can only see and interact with the
organization-related resource that were deployed from within the account calling those
APIs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: The maximum number of organization Config rules returned on each page. If you
  do no specify a number, Config uses the default. The default is 100.
- `"NextToken"`: The nextToken string returned on a previous page that you use to get the
  next page of results in a paginated response.
- `"OrganizationConfigRuleNames"`: The names of organization Config rules for which you
  want details. If you do not specify any names, Config returns details for all your
  organization Config rules.
"""
function describe_organization_config_rules(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "DescribeOrganizationConfigRules";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_organization_config_rules(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "DescribeOrganizationConfigRules",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_organization_conformance_pack_statuses()
    describe_organization_conformance_pack_statuses(params::Dict{String,<:Any})

Provides organization conformance pack deployment status for an organization.   The status
is not considered successful until organization conformance pack is successfully deployed
in all the member accounts with an exception of excluded accounts. When you specify the
limit and the next token, you receive a paginated response. Limit and next token are not
applicable if you specify organization conformance pack names. They are only applicable,
when you request all the organization conformance packs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: The maximum number of OrganizationConformancePackStatuses returned on each
  page. If you do no specify a number, Config uses the default. The default is 100.
- `"NextToken"`: The nextToken string returned on a previous page that you use to get the
  next page of results in a paginated response.
- `"OrganizationConformancePackNames"`: The names of organization conformance packs for
  which you want status details. If you do not specify any names, Config returns details for
  all your organization conformance packs.
"""
function describe_organization_conformance_pack_statuses(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "DescribeOrganizationConformancePackStatuses";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_organization_conformance_pack_statuses(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "DescribeOrganizationConformancePackStatuses",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_organization_conformance_packs()
    describe_organization_conformance_packs(params::Dict{String,<:Any})

Returns a list of organization conformance packs.   When you specify the limit and the next
token, you receive a paginated response.  Limit and next token are not applicable if you
specify organization conformance packs names. They are only applicable, when you request
all the organization conformance packs.   For accounts within an organization  If you
deploy an organizational rule or conformance pack in an organization administrator account,
and then establish a delegated administrator and deploy an organizational rule or
conformance pack in the delegated administrator account, you won't be able to see the
organizational rule or conformance pack in the organization administrator account from the
delegated administrator account or see the organizational rule or conformance pack in the
delegated administrator account from organization administrator account. The
DescribeOrganizationConfigRules and DescribeOrganizationConformancePacks APIs can only see
and interact with the organization-related resource that were deployed from within the
account calling those APIs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: The maximum number of organization config packs returned on each page. If you
  do no specify a number, Config uses the default. The default is 100.
- `"NextToken"`: The nextToken string returned on a previous page that you use to get the
  next page of results in a paginated response.
- `"OrganizationConformancePackNames"`: The name that you assign to an organization
  conformance pack.
"""
function describe_organization_conformance_packs(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "DescribeOrganizationConformancePacks";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_organization_conformance_packs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "DescribeOrganizationConformancePacks",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_pending_aggregation_requests()
    describe_pending_aggregation_requests(params::Dict{String,<:Any})

Returns a list of all pending aggregation requests.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: The maximum number of evaluation results returned on each page. The default is
  maximum. If you specify 0, Config uses the default.
- `"NextToken"`: The nextToken string returned on a previous page that you use to get the
  next page of results in a paginated response.
"""
function describe_pending_aggregation_requests(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "DescribePendingAggregationRequests";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_pending_aggregation_requests(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "DescribePendingAggregationRequests",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_remediation_configurations(config_rule_names)
    describe_remediation_configurations(config_rule_names, params::Dict{String,<:Any})

Returns the details of one or more remediation configurations.

# Arguments
- `config_rule_names`: A list of Config rule names of remediation configurations for which
  you want details.

"""
function describe_remediation_configurations(
    ConfigRuleNames; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "DescribeRemediationConfigurations",
        Dict{String,Any}("ConfigRuleNames" => ConfigRuleNames);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_remediation_configurations(
    ConfigRuleNames,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "DescribeRemediationConfigurations",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ConfigRuleNames" => ConfigRuleNames), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_remediation_exceptions(config_rule_name)
    describe_remediation_exceptions(config_rule_name, params::Dict{String,<:Any})

Returns the details of one or more remediation exceptions. A detailed view of a remediation
exception for a set of resources that includes an explanation of an exception and the time
when the exception will be deleted. When you specify the limit and the next token, you
receive a paginated response.   Config generates a remediation exception when a problem
occurs executing a remediation action to a specific resource. Remediation exceptions blocks
auto-remediation until the exception is cleared. When you specify the limit and the next
token, you receive a paginated response.  Limit and next token are not applicable if you
request resources in batch. It is only applicable, when you request all resources.

# Arguments
- `config_rule_name`: The name of the Config rule.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: The maximum number of RemediationExceptionResourceKey returned on each page.
  The default is 25. If you specify 0, Config uses the default.
- `"NextToken"`: The nextToken string returned in a previous request that you use to
  request the next page of results in a paginated response.
- `"ResourceKeys"`: An exception list of resource exception keys to be processed with the
  current request. Config adds exception for each resource key. For example, Config adds 3
  exceptions for 3 resource keys.
"""
function describe_remediation_exceptions(
    ConfigRuleName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "DescribeRemediationExceptions",
        Dict{String,Any}("ConfigRuleName" => ConfigRuleName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_remediation_exceptions(
    ConfigRuleName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "DescribeRemediationExceptions",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ConfigRuleName" => ConfigRuleName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_remediation_execution_status(config_rule_name)
    describe_remediation_execution_status(config_rule_name, params::Dict{String,<:Any})

Provides a detailed view of a Remediation Execution for a set of resources including state,
timestamps for when steps for the remediation execution occur, and any error messages for
steps that have failed. When you specify the limit and the next token, you receive a
paginated response.

# Arguments
- `config_rule_name`: A list of Config rule names.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: The maximum number of RemediationExecutionStatuses returned on each page. The
  default is maximum. If you specify 0, Config uses the default.
- `"NextToken"`: The nextToken string returned on a previous page that you use to get the
  next page of results in a paginated response.
- `"ResourceKeys"`: A list of resource keys to be processed with the current request. Each
  element in the list consists of the resource type and resource ID.
"""
function describe_remediation_execution_status(
    ConfigRuleName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "DescribeRemediationExecutionStatus",
        Dict{String,Any}("ConfigRuleName" => ConfigRuleName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_remediation_execution_status(
    ConfigRuleName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "DescribeRemediationExecutionStatus",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ConfigRuleName" => ConfigRuleName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_retention_configurations()
    describe_retention_configurations(params::Dict{String,<:Any})

Returns the details of one or more retention configurations. If the retention configuration
name is not specified, this action returns the details for all the retention configurations
for that account.  Currently, Config supports only one retention configuration per region
in your account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: The nextToken string returned on a previous page that you use to get the
  next page of results in a paginated response.
- `"RetentionConfigurationNames"`: A list of names of retention configurations for which
  you want details. If you do not specify a name, Config returns details for all the
  retention configurations for that account.  Currently, Config supports only one retention
  configuration per region in your account.
"""
function describe_retention_configurations(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "DescribeRetentionConfigurations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_retention_configurations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "DescribeRetentionConfigurations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_aggregate_compliance_details_by_config_rule(account_id, aws_region, config_rule_name, configuration_aggregator_name)
    get_aggregate_compliance_details_by_config_rule(account_id, aws_region, config_rule_name, configuration_aggregator_name, params::Dict{String,<:Any})

Returns the evaluation results for the specified Config rule for a specific resource in a
rule. The results indicate which Amazon Web Services resources were evaluated by the rule,
when each resource was last evaluated, and whether each resource complies with the rule.
The results can return an empty result page. But if you have a nextToken, the results are
displayed on the next page.

# Arguments
- `account_id`: The 12-digit account ID of the source account.
- `aws_region`: The source region from where the data is aggregated.
- `config_rule_name`: The name of the Config rule for which you want compliance information.
- `configuration_aggregator_name`: The name of the configuration aggregator.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ComplianceType"`: The resource compliance status.  For the
  GetAggregateComplianceDetailsByConfigRuleRequest data type, Config supports only the
  COMPLIANT and NON_COMPLIANT. Config does not support the NOT_APPLICABLE and
  INSUFFICIENT_DATA values.
- `"Limit"`: The maximum number of evaluation results returned on each page. The default is
  50. You cannot specify a number greater than 100. If you specify 0, Config uses the default.
- `"NextToken"`: The nextToken string returned on a previous page that you use to get the
  next page of results in a paginated response.
"""
function get_aggregate_compliance_details_by_config_rule(
    AccountId,
    AwsRegion,
    ConfigRuleName,
    ConfigurationAggregatorName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "GetAggregateComplianceDetailsByConfigRule",
        Dict{String,Any}(
            "AccountId" => AccountId,
            "AwsRegion" => AwsRegion,
            "ConfigRuleName" => ConfigRuleName,
            "ConfigurationAggregatorName" => ConfigurationAggregatorName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_aggregate_compliance_details_by_config_rule(
    AccountId,
    AwsRegion,
    ConfigRuleName,
    ConfigurationAggregatorName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "GetAggregateComplianceDetailsByConfigRule",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AccountId" => AccountId,
                    "AwsRegion" => AwsRegion,
                    "ConfigRuleName" => ConfigRuleName,
                    "ConfigurationAggregatorName" => ConfigurationAggregatorName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_aggregate_config_rule_compliance_summary(configuration_aggregator_name)
    get_aggregate_config_rule_compliance_summary(configuration_aggregator_name, params::Dict{String,<:Any})

Returns the number of compliant and noncompliant rules for one or more accounts and regions
in an aggregator.  The results can return an empty result page, but if you have a
nextToken, the results are displayed on the next page.

# Arguments
- `configuration_aggregator_name`: The name of the configuration aggregator.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: Filters the results based on the ConfigRuleComplianceSummaryFilters object.
- `"GroupByKey"`: Groups the result based on ACCOUNT_ID or AWS_REGION.
- `"Limit"`: The maximum number of evaluation results returned on each page. The default is
  1000. You cannot specify a number greater than 1000. If you specify 0, Config uses the
  default.
- `"NextToken"`: The nextToken string returned on a previous page that you use to get the
  next page of results in a paginated response.
"""
function get_aggregate_config_rule_compliance_summary(
    ConfigurationAggregatorName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "GetAggregateConfigRuleComplianceSummary",
        Dict{String,Any}("ConfigurationAggregatorName" => ConfigurationAggregatorName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_aggregate_config_rule_compliance_summary(
    ConfigurationAggregatorName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "GetAggregateConfigRuleComplianceSummary",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ConfigurationAggregatorName" => ConfigurationAggregatorName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_aggregate_conformance_pack_compliance_summary(configuration_aggregator_name)
    get_aggregate_conformance_pack_compliance_summary(configuration_aggregator_name, params::Dict{String,<:Any})

Returns the count of compliant and noncompliant conformance packs across all Amazon Web
Services accounts and Amazon Web Services Regions in an aggregator. You can filter based on
Amazon Web Services account ID or Amazon Web Services Region.  The results can return an
empty result page, but if you have a nextToken, the results are displayed on the next page.

# Arguments
- `configuration_aggregator_name`: The name of the configuration aggregator.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: Filters the results based on the
  AggregateConformancePackComplianceSummaryFilters object.
- `"GroupByKey"`: Groups the result based on Amazon Web Services account ID or Amazon Web
  Services Region.
- `"Limit"`: The maximum number of results returned on each page. The default is maximum.
  If you specify 0, Config uses the default.
- `"NextToken"`: The nextToken string returned on a previous page that you use to get the
  next page of results in a paginated response.
"""
function get_aggregate_conformance_pack_compliance_summary(
    ConfigurationAggregatorName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "GetAggregateConformancePackComplianceSummary",
        Dict{String,Any}("ConfigurationAggregatorName" => ConfigurationAggregatorName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_aggregate_conformance_pack_compliance_summary(
    ConfigurationAggregatorName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "GetAggregateConformancePackComplianceSummary",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ConfigurationAggregatorName" => ConfigurationAggregatorName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_aggregate_discovered_resource_counts(configuration_aggregator_name)
    get_aggregate_discovered_resource_counts(configuration_aggregator_name, params::Dict{String,<:Any})

Returns the resource counts across accounts and regions that are present in your Config
aggregator. You can request the resource counts by providing filters and GroupByKey. For
example, if the input contains accountID 12345678910 and region us-east-1 in filters, the
API returns the count of resources in account ID 12345678910 and region us-east-1. If the
input contains ACCOUNT_ID as a GroupByKey, the API returns resource counts for all source
accounts that are present in your aggregator.

# Arguments
- `configuration_aggregator_name`: The name of the configuration aggregator.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: Filters the results based on the ResourceCountFilters object.
- `"GroupByKey"`: The key to group the resource counts.
- `"Limit"`: The maximum number of GroupedResourceCount objects returned on each page. The
  default is 1000. You cannot specify a number greater than 1000. If you specify 0, Config
  uses the default.
- `"NextToken"`: The nextToken string returned on a previous page that you use to get the
  next page of results in a paginated response.
"""
function get_aggregate_discovered_resource_counts(
    ConfigurationAggregatorName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "GetAggregateDiscoveredResourceCounts",
        Dict{String,Any}("ConfigurationAggregatorName" => ConfigurationAggregatorName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_aggregate_discovered_resource_counts(
    ConfigurationAggregatorName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "GetAggregateDiscoveredResourceCounts",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ConfigurationAggregatorName" => ConfigurationAggregatorName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_aggregate_resource_config(configuration_aggregator_name, resource_identifier)
    get_aggregate_resource_config(configuration_aggregator_name, resource_identifier, params::Dict{String,<:Any})

Returns configuration item that is aggregated for your specific resource in a specific
source account and region.

# Arguments
- `configuration_aggregator_name`: The name of the configuration aggregator.
- `resource_identifier`: An object that identifies aggregate resource.

"""
function get_aggregate_resource_config(
    ConfigurationAggregatorName,
    ResourceIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "GetAggregateResourceConfig",
        Dict{String,Any}(
            "ConfigurationAggregatorName" => ConfigurationAggregatorName,
            "ResourceIdentifier" => ResourceIdentifier,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_aggregate_resource_config(
    ConfigurationAggregatorName,
    ResourceIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "GetAggregateResourceConfig",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ConfigurationAggregatorName" => ConfigurationAggregatorName,
                    "ResourceIdentifier" => ResourceIdentifier,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_compliance_details_by_config_rule(config_rule_name)
    get_compliance_details_by_config_rule(config_rule_name, params::Dict{String,<:Any})

Returns the evaluation results for the specified Config rule. The results indicate which
Amazon Web Services resources were evaluated by the rule, when each resource was last
evaluated, and whether each resource complies with the rule.

# Arguments
- `config_rule_name`: The name of the Config rule for which you want compliance information.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ComplianceTypes"`: Filters the results by compliance.  INSUFFICIENT_DATA is a valid
  ComplianceType that is returned when an Config rule cannot be evaluated. However,
  INSUFFICIENT_DATA cannot be used as a ComplianceType for filtering results.
- `"Limit"`: The maximum number of evaluation results returned on each page. The default is
  10. You cannot specify a number greater than 100. If you specify 0, Config uses the default.
- `"NextToken"`: The nextToken string returned on a previous page that you use to get the
  next page of results in a paginated response.
"""
function get_compliance_details_by_config_rule(
    ConfigRuleName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "GetComplianceDetailsByConfigRule",
        Dict{String,Any}("ConfigRuleName" => ConfigRuleName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_compliance_details_by_config_rule(
    ConfigRuleName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "GetComplianceDetailsByConfigRule",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ConfigRuleName" => ConfigRuleName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_compliance_details_by_resource()
    get_compliance_details_by_resource(params::Dict{String,<:Any})

Returns the evaluation results for the specified Amazon Web Services resource. The results
indicate which Config rules were used to evaluate the resource, when each rule was last
invoked, and whether the resource complies with each rule.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ComplianceTypes"`: Filters the results by compliance.  INSUFFICIENT_DATA is a valid
  ComplianceType that is returned when an Config rule cannot be evaluated. However,
  INSUFFICIENT_DATA cannot be used as a ComplianceType for filtering results.
- `"NextToken"`: The nextToken string returned on a previous page that you use to get the
  next page of results in a paginated response.
- `"ResourceEvaluationId"`: The unique ID of Amazon Web Services resource execution for
  which you want to retrieve evaluation results.   You need to only provide either a
  ResourceEvaluationID or a ResourceID and ResourceType.
- `"ResourceId"`: The ID of the Amazon Web Services resource for which you want compliance
  information.
- `"ResourceType"`: The type of the Amazon Web Services resource for which you want
  compliance information.
"""
function get_compliance_details_by_resource(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "GetComplianceDetailsByResource";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_compliance_details_by_resource(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "GetComplianceDetailsByResource",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_compliance_summary_by_config_rule()
    get_compliance_summary_by_config_rule(params::Dict{String,<:Any})

Returns the number of Config rules that are compliant and noncompliant, up to a maximum of
25 for each.

"""
function get_compliance_summary_by_config_rule(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "GetComplianceSummaryByConfigRule";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_compliance_summary_by_config_rule(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "GetComplianceSummaryByConfigRule",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_compliance_summary_by_resource_type()
    get_compliance_summary_by_resource_type(params::Dict{String,<:Any})

Returns the number of resources that are compliant and the number that are noncompliant.
You can specify one or more resource types to get these numbers for each resource type. The
maximum number returned is 100.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ResourceTypes"`: Specify one or more resource types to get the number of resources that
  are compliant and the number that are noncompliant for each resource type. For this
  request, you can specify an Amazon Web Services resource type such as AWS::EC2::Instance.
  You can specify that the resource type is an Amazon Web Services account by specifying
  AWS::::Account.
"""
function get_compliance_summary_by_resource_type(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "GetComplianceSummaryByResourceType";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_compliance_summary_by_resource_type(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "GetComplianceSummaryByResourceType",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_conformance_pack_compliance_details(conformance_pack_name)
    get_conformance_pack_compliance_details(conformance_pack_name, params::Dict{String,<:Any})

Returns compliance details of a conformance pack for all Amazon Web Services resources that
are monitered by conformance pack.

# Arguments
- `conformance_pack_name`: Name of the conformance pack.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: A ConformancePackEvaluationFilters object.
- `"Limit"`: The maximum number of evaluation results returned on each page. If you do no
  specify a number, Config uses the default. The default is 100.
- `"NextToken"`: The nextToken string returned in a previous request that you use to
  request the next page of results in a paginated response.
"""
function get_conformance_pack_compliance_details(
    ConformancePackName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "GetConformancePackComplianceDetails",
        Dict{String,Any}("ConformancePackName" => ConformancePackName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_conformance_pack_compliance_details(
    ConformancePackName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "GetConformancePackComplianceDetails",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ConformancePackName" => ConformancePackName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_conformance_pack_compliance_summary(conformance_pack_names)
    get_conformance_pack_compliance_summary(conformance_pack_names, params::Dict{String,<:Any})

Returns compliance details for the conformance pack based on the cumulative compliance
results of all the rules in that conformance pack.

# Arguments
- `conformance_pack_names`: Names of conformance packs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: The maximum number of conformance packs returned on each page.
- `"NextToken"`: The nextToken string returned on a previous page that you use to get the
  next page of results in a paginated response.
"""
function get_conformance_pack_compliance_summary(
    ConformancePackNames; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "GetConformancePackComplianceSummary",
        Dict{String,Any}("ConformancePackNames" => ConformancePackNames);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_conformance_pack_compliance_summary(
    ConformancePackNames,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "GetConformancePackComplianceSummary",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ConformancePackNames" => ConformancePackNames),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_custom_rule_policy()
    get_custom_rule_policy(params::Dict{String,<:Any})

Returns the policy definition containing the logic for your Config Custom Policy rule.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConfigRuleName"`: The name of your Config Custom Policy rule.
"""
function get_custom_rule_policy(; aws_config::AbstractAWSConfig=current_aws_config())
    return config_service(
        "GetCustomRulePolicy"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_custom_rule_policy(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "GetCustomRulePolicy",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_discovered_resource_counts()
    get_discovered_resource_counts(params::Dict{String,<:Any})

Returns the resource types, the number of each resource type, and the total number of
resources that Config is recording in this region for your Amazon Web Services account.
Example    Config is recording three resource types in the US East (Ohio) Region for your
account: 25 EC2 instances, 20 IAM users, and 15 S3 buckets.   You make a call to the
GetDiscoveredResourceCounts action and specify that you want all resource types.    Config
returns the following:   The resource types (EC2 instances, IAM users, and S3 buckets).
The number of each resource type (25, 20, and 15).   The total number of all resources
(60).     The response is paginated. By default, Config lists 100 ResourceCount objects on
each page. You can customize this number with the limit parameter. The response includes a
nextToken string. To get the next page of results, run the request again and specify the
string for the nextToken parameter.  If you make a call to the GetDiscoveredResourceCounts
action, you might not immediately receive resource counts in the following situations:
You are a new Config customer.   You just enabled resource recording.   It might take a few
minutes for Config to record and count your resources. Wait a few minutes and then retry
the GetDiscoveredResourceCounts action.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"limit"`: The maximum number of ResourceCount objects returned on each page. The default
  is 100. You cannot specify a number greater than 100. If you specify 0, Config uses the
  default.
- `"nextToken"`: The nextToken string returned on a previous page that you use to get the
  next page of results in a paginated response.
- `"resourceTypes"`: The comma-separated list that specifies the resource types that you
  want Config to return (for example, \"AWS::EC2::Instance\", \"AWS::IAM::User\"). If a value
  for resourceTypes is not specified, Config returns all resource types that Config is
  recording in the region for your account.  If the configuration recorder is turned off,
  Config returns an empty list of ResourceCount objects. If the configuration recorder is not
  recording a specific resource type (for example, S3 buckets), that resource type is not
  returned in the list of ResourceCount objects.
"""
function get_discovered_resource_counts(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "GetDiscoveredResourceCounts";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_discovered_resource_counts(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "GetDiscoveredResourceCounts",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_organization_config_rule_detailed_status(organization_config_rule_name)
    get_organization_config_rule_detailed_status(organization_config_rule_name, params::Dict{String,<:Any})

Returns detailed status for each member account within an organization for a given
organization Config rule.

# Arguments
- `organization_config_rule_name`: The name of your organization Config rule for which you
  want status details for member accounts.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: A StatusDetailFilters object.
- `"Limit"`: The maximum number of OrganizationConfigRuleDetailedStatus returned on each
  page. If you do not specify a number, Config uses the default. The default is 100.
- `"NextToken"`: The nextToken string returned on a previous page that you use to get the
  next page of results in a paginated response.
"""
function get_organization_config_rule_detailed_status(
    OrganizationConfigRuleName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "GetOrganizationConfigRuleDetailedStatus",
        Dict{String,Any}("OrganizationConfigRuleName" => OrganizationConfigRuleName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_organization_config_rule_detailed_status(
    OrganizationConfigRuleName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "GetOrganizationConfigRuleDetailedStatus",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "OrganizationConfigRuleName" => OrganizationConfigRuleName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_organization_conformance_pack_detailed_status(organization_conformance_pack_name)
    get_organization_conformance_pack_detailed_status(organization_conformance_pack_name, params::Dict{String,<:Any})

Returns detailed status for each member account within an organization for a given
organization conformance pack.

# Arguments
- `organization_conformance_pack_name`: The name of organization conformance pack for which
  you want status details for member accounts.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: An OrganizationResourceDetailedStatusFilters object.
- `"Limit"`: The maximum number of OrganizationConformancePackDetailedStatuses returned on
  each page. If you do not specify a number, Config uses the default. The default is 100.
- `"NextToken"`: The nextToken string returned on a previous page that you use to get the
  next page of results in a paginated response.
"""
function get_organization_conformance_pack_detailed_status(
    OrganizationConformancePackName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "GetOrganizationConformancePackDetailedStatus",
        Dict{String,Any}(
            "OrganizationConformancePackName" => OrganizationConformancePackName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_organization_conformance_pack_detailed_status(
    OrganizationConformancePackName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "GetOrganizationConformancePackDetailedStatus",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "OrganizationConformancePackName" => OrganizationConformancePackName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_organization_custom_rule_policy(organization_config_rule_name)
    get_organization_custom_rule_policy(organization_config_rule_name, params::Dict{String,<:Any})

Returns the policy definition containing the logic for your organization Config Custom
Policy rule.

# Arguments
- `organization_config_rule_name`: The name of your organization Config Custom Policy rule.

"""
function get_organization_custom_rule_policy(
    OrganizationConfigRuleName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "GetOrganizationCustomRulePolicy",
        Dict{String,Any}("OrganizationConfigRuleName" => OrganizationConfigRuleName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_organization_custom_rule_policy(
    OrganizationConfigRuleName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "GetOrganizationCustomRulePolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "OrganizationConfigRuleName" => OrganizationConfigRuleName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_resource_config_history(resource_id, resource_type)
    get_resource_config_history(resource_id, resource_type, params::Dict{String,<:Any})

 For accurate reporting on the compliance status, you must record the
AWS::Config::ResourceCompliance resource type. For more information, see Selecting Which
Resources Config Records.  Returns a list of ConfigurationItems for the specified resource.
The list contains details about each state of the resource during the specified time
interval. If you specified a retention period to retain your ConfigurationItems between a
minimum of 30 days and a maximum of 7 years (2557 days), Config returns the
ConfigurationItems for the specified retention period.  The response is paginated. By
default, Config returns a limit of 10 configuration items per page. You can customize this
number with the limit parameter. The response includes a nextToken string. To get the next
page of results, run the request again and specify the string for the nextToken parameter.
Each call to the API is limited to span a duration of seven days. It is likely that the
number of records returned is smaller than the specified limit. In such cases, you can make
another call, using the nextToken.

# Arguments
- `resource_id`: The ID of the resource (for example., sg-xxxxxx).
- `resource_type`: The resource type.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"chronologicalOrder"`: The chronological order for configuration items listed. By
  default, the results are listed in reverse chronological order.
- `"earlierTime"`: The chronologically earliest time in the time range for which the
  history requested. If not specified, the action returns paginated results that contain
  configuration items that start when the first configuration item was recorded.
- `"laterTime"`: The chronologically latest time in the time range for which the history
  requested. If not specified, current time is taken.
- `"limit"`: The maximum number of configuration items returned on each page. The default
  is 10. You cannot specify a number greater than 100. If you specify 0, Config uses the
  default.
- `"nextToken"`: The nextToken string returned on a previous page that you use to get the
  next page of results in a paginated response.
"""
function get_resource_config_history(
    resourceId, resourceType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "GetResourceConfigHistory",
        Dict{String,Any}("resourceId" => resourceId, "resourceType" => resourceType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_resource_config_history(
    resourceId,
    resourceType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "GetResourceConfigHistory",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "resourceId" => resourceId, "resourceType" => resourceType
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_resource_evaluation_summary(resource_evaluation_id)
    get_resource_evaluation_summary(resource_evaluation_id, params::Dict{String,<:Any})

Returns a summary of resource evaluation for the specified resource evaluation ID from the
proactive rules that were run. The results indicate which evaluation context was used to
evaluate the rules, which resource details were evaluated, the evaluation mode that was
run, and whether the resource details comply with the configuration of the proactive rules.
  To see additional information about the evaluation result, such as which rule flagged a
resource as NON_COMPLIANT, use the GetComplianceDetailsByResource API. For more
information, see the Examples section.

# Arguments
- `resource_evaluation_id`: The unique ResourceEvaluationId of Amazon Web Services resource
  execution for which you want to retrieve the evaluation summary.

"""
function get_resource_evaluation_summary(
    ResourceEvaluationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "GetResourceEvaluationSummary",
        Dict{String,Any}("ResourceEvaluationId" => ResourceEvaluationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_resource_evaluation_summary(
    ResourceEvaluationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "GetResourceEvaluationSummary",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceEvaluationId" => ResourceEvaluationId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_stored_query(query_name)
    get_stored_query(query_name, params::Dict{String,<:Any})

Returns the details of a specific stored query.

# Arguments
- `query_name`: The name of the query.

"""
function get_stored_query(QueryName; aws_config::AbstractAWSConfig=current_aws_config())
    return config_service(
        "GetStoredQuery",
        Dict{String,Any}("QueryName" => QueryName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_stored_query(
    QueryName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "GetStoredQuery",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("QueryName" => QueryName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_aggregate_discovered_resources(configuration_aggregator_name, resource_type)
    list_aggregate_discovered_resources(configuration_aggregator_name, resource_type, params::Dict{String,<:Any})

Accepts a resource type and returns a list of resource identifiers that are aggregated for
a specific resource type across accounts and regions. A resource identifier includes the
resource type, ID, (if available) the custom resource name, source account, and source
region. You can narrow the results to include only resources that have specific resource
IDs, or a resource name, or source account ID, or source region. For example, if the input
consists of accountID 12345678910 and the region is us-east-1 for resource type
AWS::EC2::Instance then the API returns all the EC2 instance identifiers of accountID
12345678910 and region us-east-1.

# Arguments
- `configuration_aggregator_name`: The name of the configuration aggregator.
- `resource_type`: The type of resources that you want Config to list in the response.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: Filters the results based on the ResourceFilters object.
- `"Limit"`: The maximum number of resource identifiers returned on each page. You cannot
  specify a number greater than 100. If you specify 0, Config uses the default.
- `"NextToken"`: The nextToken string returned on a previous page that you use to get the
  next page of results in a paginated response.
"""
function list_aggregate_discovered_resources(
    ConfigurationAggregatorName,
    ResourceType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "ListAggregateDiscoveredResources",
        Dict{String,Any}(
            "ConfigurationAggregatorName" => ConfigurationAggregatorName,
            "ResourceType" => ResourceType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_aggregate_discovered_resources(
    ConfigurationAggregatorName,
    ResourceType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "ListAggregateDiscoveredResources",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ConfigurationAggregatorName" => ConfigurationAggregatorName,
                    "ResourceType" => ResourceType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_conformance_pack_compliance_scores()
    list_conformance_pack_compliance_scores(params::Dict{String,<:Any})

Returns a list of conformance pack compliance scores. A compliance score is the percentage
of the number of compliant rule-resource combinations in a conformance pack compared to the
number of total possible rule-resource combinations in the conformance pack. This metric
provides you with a high-level view of the compliance state of your conformance packs. You
can use it to identify, investigate, and understand the level of compliance in your
conformance packs.  Conformance packs with no evaluation results will have a compliance
score of INSUFFICIENT_DATA.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: Filters the results based on the ConformancePackComplianceScoresFilters.
- `"Limit"`: The maximum number of conformance pack compliance scores returned on each page.
- `"NextToken"`: The nextToken string in a prior request that you can use to get the
  paginated response for the next set of conformance pack compliance scores.
- `"SortBy"`: Sorts your conformance pack compliance scores in either ascending or
  descending order, depending on SortOrder. By default, conformance pack compliance scores
  are sorted in alphabetical order by name of the conformance pack. Enter SCORE, to sort
  conformance pack compliance scores by the numerical value of the compliance score.
- `"SortOrder"`: Determines the order in which conformance pack compliance scores are
  sorted. Either in ascending or descending order. By default, conformance pack compliance
  scores are sorted in alphabetical order by name of the conformance pack. Conformance pack
  compliance scores are sorted in reverse alphabetical order if you enter DESCENDING. You can
  sort conformance pack compliance scores by the numerical value of the compliance score by
  entering SCORE in the SortBy action. When compliance scores are sorted by SCORE,
  conformance packs with a compliance score of INSUFFICIENT_DATA will be last when sorting by
  ascending order and first when sorting by descending order.
"""
function list_conformance_pack_compliance_scores(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "ListConformancePackComplianceScores";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_conformance_pack_compliance_scores(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "ListConformancePackComplianceScores",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_discovered_resources(resource_type)
    list_discovered_resources(resource_type, params::Dict{String,<:Any})

Accepts a resource type and returns a list of resource identifiers for the resources of
that type. A resource identifier includes the resource type, ID, and (if available) the
custom resource name. The results consist of resources that Config has discovered,
including those that Config is not currently recording. You can narrow the results to
include only resources that have specific resource IDs or a resource name.  You can specify
either resource IDs or a resource name, but not both, in the same request.  The response is
paginated. By default, Config lists 100 resource identifiers on each page. You can
customize this number with the limit parameter. The response includes a nextToken string.
To get the next page of results, run the request again and specify the string for the
nextToken parameter.

# Arguments
- `resource_type`: The type of resources that you want Config to list in the response.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"includeDeletedResources"`: Specifies whether Config includes deleted resources in the
  results. By default, deleted resources are not included.
- `"limit"`: The maximum number of resource identifiers returned on each page. The default
  is 100. You cannot specify a number greater than 100. If you specify 0, Config uses the
  default.
- `"nextToken"`: The nextToken string returned on a previous page that you use to get the
  next page of results in a paginated response.
- `"resourceIds"`: The IDs of only those resources that you want Config to list in the
  response. If you do not specify this parameter, Config lists all resources of the specified
  type that it has discovered. You can list a minimum of 1 resourceID and a maximum of 20
  resourceIds.
- `"resourceName"`: The custom name of only those resources that you want Config to list in
  the response. If you do not specify this parameter, Config lists all resources of the
  specified type that it has discovered.
"""
function list_discovered_resources(
    resourceType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "ListDiscoveredResources",
        Dict{String,Any}("resourceType" => resourceType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_discovered_resources(
    resourceType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "ListDiscoveredResources",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceType" => resourceType), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_resource_evaluations()
    list_resource_evaluations(params::Dict{String,<:Any})

Returns a list of proactive resource evaluations.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: Returns a ResourceEvaluationFilters object.
- `"Limit"`: The maximum number of evaluations returned on each page. The default is 10.
  You cannot specify a number greater than 100. If you specify 0, Config uses the default.
- `"NextToken"`: The nextToken string returned on a previous page that you use to get the
  next page of results in a paginated response.
"""
function list_resource_evaluations(; aws_config::AbstractAWSConfig=current_aws_config())
    return config_service(
        "ListResourceEvaluations"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_resource_evaluations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "ListResourceEvaluations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_stored_queries()
    list_stored_queries(params::Dict{String,<:Any})

Lists the stored queries for a single Amazon Web Services account and a single Amazon Web
Services Region. The default is 100.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to be returned with a single call.
- `"NextToken"`: The nextToken string returned in a previous request that you use to
  request the next page of results in a paginated response.
"""
function list_stored_queries(; aws_config::AbstractAWSConfig=current_aws_config())
    return config_service(
        "ListStoredQueries"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_stored_queries(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "ListStoredQueries", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

List the tags for Config resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) that identifies the resource for which to
  list the tags. Currently, the supported resources are ConfigRule, ConfigurationAggregator
  and AggregatorAuthorization.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: The maximum number of tags returned on each page. The limit maximum is 50. You
  cannot specify a number greater than 50. If you specify 0, Config uses the default.
- `"NextToken"`: The nextToken string returned on a previous page that you use to get the
  next page of results in a paginated response.
"""
function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "ListTagsForResource",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_aggregation_authorization(authorized_account_id, authorized_aws_region)
    put_aggregation_authorization(authorized_account_id, authorized_aws_region, params::Dict{String,<:Any})

Authorizes the aggregator account and region to collect data from the source account and
region.    PutAggregationAuthorization is an idempotent API. Subsequent requests won’t
create a duplicate resource if one was already created. If a following request has
different tags values, Config will ignore these differences and treat it as an idempotent
request of the previous. In this case, tags will not be updated, even if they are
different.

# Arguments
- `authorized_account_id`: The 12-digit account ID of the account authorized to aggregate
  data.
- `authorized_aws_region`: The region authorized to collect aggregated data.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: An array of tag object.
"""
function put_aggregation_authorization(
    AuthorizedAccountId,
    AuthorizedAwsRegion;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "PutAggregationAuthorization",
        Dict{String,Any}(
            "AuthorizedAccountId" => AuthorizedAccountId,
            "AuthorizedAwsRegion" => AuthorizedAwsRegion,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_aggregation_authorization(
    AuthorizedAccountId,
    AuthorizedAwsRegion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "PutAggregationAuthorization",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AuthorizedAccountId" => AuthorizedAccountId,
                    "AuthorizedAwsRegion" => AuthorizedAwsRegion,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_config_rule(config_rule)
    put_config_rule(config_rule, params::Dict{String,<:Any})

Adds or updates an Config rule to evaluate if your Amazon Web Services resources comply
with your desired configurations. For information on how many Config rules you can have per
account, see  Service Limits  in the Config Developer Guide. There are two types of rules:
Config Managed Rules and Config Custom Rules. You can use PutConfigRule to create both
Config Managed Rules and Config Custom Rules. Config Managed Rules are predefined,
customizable rules created by Config. For a list of managed rules, see List of Config
Managed Rules. If you are adding an Config managed rule, you must specify the rule's
identifier for the SourceIdentifier key. Config Custom Rules are rules that you create from
scratch. There are two ways to create Config custom rules: with Lambda functions ( Lambda
Developer Guide) and with Guard (Guard GitHub Repository), a policy-as-code language.
Config custom rules created with Lambda are called Config Custom Lambda Rules and Config
custom rules created with Guard are called Config Custom Policy Rules. If you are adding a
new Config Custom Lambda rule, you first need to create an Lambda function that the rule
invokes to evaluate your resources. When you use PutConfigRule to add a Custom Lambda rule
to Config, you must specify the Amazon Resource Name (ARN) that Lambda assigns to the
function. You specify the ARN in the SourceIdentifier key. This key is part of the Source
object, which is part of the ConfigRule object.  For any new Config rule that you add,
specify the ConfigRuleName in the ConfigRule object. Do not specify the ConfigRuleArn or
the ConfigRuleId. These values are generated by Config for new rules. If you are updating a
rule that you added previously, you can specify the rule by ConfigRuleName, ConfigRuleId,
or ConfigRuleArn in the ConfigRule data type that you use in this request. For more
information about developing and using Config rules, see Evaluating Resources with Config
Rules in the Config Developer Guide.   PutConfigRule is an idempotent API. Subsequent
requests won’t create a duplicate resource if one was already created. If a following
request has different tags values, Config will ignore these differences and treat it as an
idempotent request of the previous. In this case, tags will not be updated, even if they
are different.

# Arguments
- `config_rule`: The rule that you want to add to your account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: An array of tag object.
"""
function put_config_rule(ConfigRule; aws_config::AbstractAWSConfig=current_aws_config())
    return config_service(
        "PutConfigRule",
        Dict{String,Any}("ConfigRule" => ConfigRule);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_config_rule(
    ConfigRule,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "PutConfigRule",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ConfigRule" => ConfigRule), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_configuration_aggregator(configuration_aggregator_name)
    put_configuration_aggregator(configuration_aggregator_name, params::Dict{String,<:Any})

Creates and updates the configuration aggregator with the selected source accounts and
regions. The source account can be individual account(s) or an organization.  accountIds
that are passed will be replaced with existing accounts. If you want to add additional
accounts into the aggregator, call DescribeConfigurationAggregators to get the previous
accounts and then append new ones.  Config should be enabled in source accounts and regions
you want to aggregate. If your source type is an organization, you must be signed in to the
management account or a registered delegated administrator and all the features must be
enabled in your organization. If the caller is a management account, Config calls
EnableAwsServiceAccess API to enable integration between Config and Organizations. If the
caller is a registered delegated administrator, Config calls ListDelegatedAdministrators
API to verify whether the caller is a valid delegated administrator. To register a
delegated administrator, see Register a Delegated Administrator in the Config developer
guide.     PutConfigurationAggregator is an idempotent API. Subsequent requests won’t
create a duplicate resource if one was already created. If a following request has
different tags values, Config will ignore these differences and treat it as an idempotent
request of the previous. In this case, tags will not be updated, even if they are
different.

# Arguments
- `configuration_aggregator_name`: The name of the configuration aggregator.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccountAggregationSources"`: A list of AccountAggregationSource object.
- `"OrganizationAggregationSource"`: An OrganizationAggregationSource object.
- `"Tags"`: An array of tag object.
"""
function put_configuration_aggregator(
    ConfigurationAggregatorName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "PutConfigurationAggregator",
        Dict{String,Any}("ConfigurationAggregatorName" => ConfigurationAggregatorName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_configuration_aggregator(
    ConfigurationAggregatorName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "PutConfigurationAggregator",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ConfigurationAggregatorName" => ConfigurationAggregatorName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_configuration_recorder(configuration_recorder)
    put_configuration_recorder(configuration_recorder, params::Dict{String,<:Any})

Creates a new configuration recorder to record configuration changes for specified resource
types. You can also use this action to change the roleARN or the recordingGroup of an
existing recorder. For more information, see  Managing the Configuration Recorder  in the
Config Developer Guide.  You can specify only one configuration recorder for each Amazon
Web Services Region for each account. If the configuration recorder does not have the
recordingGroup field specified, the default is to record all supported resource types.

# Arguments
- `configuration_recorder`: An object for the configuration recorder to record
  configuration changes for specified resource types.

"""
function put_configuration_recorder(
    ConfigurationRecorder; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "PutConfigurationRecorder",
        Dict{String,Any}("ConfigurationRecorder" => ConfigurationRecorder);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_configuration_recorder(
    ConfigurationRecorder,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "PutConfigurationRecorder",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ConfigurationRecorder" => ConfigurationRecorder),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_conformance_pack(conformance_pack_name)
    put_conformance_pack(conformance_pack_name, params::Dict{String,<:Any})

Creates or updates a conformance pack. A conformance pack is a collection of Config rules
that can be easily deployed in an account and a region and across an organization. For
information on how many conformance packs you can have per account, see  Service Limits  in
the Config Developer Guide. This API creates a service-linked role
AWSServiceRoleForConfigConforms in your account. The service-linked role is created only
when the role does not exist in your account.   You must specify only one of the follow
parameters: TemplateS3Uri, TemplateBody or TemplateSSMDocumentDetails.

# Arguments
- `conformance_pack_name`: The unique name of the conformance pack you want to deploy.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConformancePackInputParameters"`: A list of ConformancePackInputParameter objects.
- `"DeliveryS3Bucket"`: The name of the Amazon S3 bucket where Config stores conformance
  pack templates.  This field is optional.
- `"DeliveryS3KeyPrefix"`: The prefix for the Amazon S3 bucket.   This field is optional.
- `"TemplateBody"`: A string containing the full conformance pack template body. The
  structure containing the template body has a minimum length of 1 byte and a maximum length
  of 51,200 bytes.  You can use a YAML template with two resource types: Config rule
  (AWS::Config::ConfigRule) and remediation action (AWS::Config::RemediationConfiguration).
- `"TemplateS3Uri"`: The location of the file containing the template body
  (s3://bucketname/prefix). The uri must point to a conformance pack template (max size: 300
  KB) that is located in an Amazon S3 bucket in the same Region as the conformance pack.
  You must have access to read Amazon S3 bucket. In addition, in order to ensure a successful
  deployment, the template object must not be in an archived storage class if this parameter
  is passed.
- `"TemplateSSMDocumentDetails"`: An object of type TemplateSSMDocumentDetails, which
  contains the name or the Amazon Resource Name (ARN) of the Amazon Web Services Systems
  Manager document (SSM document) and the version of the SSM document that is used to create
  a conformance pack.
"""
function put_conformance_pack(
    ConformancePackName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "PutConformancePack",
        Dict{String,Any}("ConformancePackName" => ConformancePackName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_conformance_pack(
    ConformancePackName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "PutConformancePack",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ConformancePackName" => ConformancePackName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_delivery_channel(delivery_channel)
    put_delivery_channel(delivery_channel, params::Dict{String,<:Any})

Creates a delivery channel object to deliver configuration information and other compliance
information to an Amazon S3 bucket and Amazon SNS topic. For more information, see
Notifications that Config Sends to an Amazon SNS topic. Before you can create a delivery
channel, you must create a configuration recorder. You can use this action to change the
Amazon S3 bucket or an Amazon SNS topic of the existing delivery channel. To change the
Amazon S3 bucket or an Amazon SNS topic, call this action and specify the changed values
for the S3 bucket and the SNS topic. If you specify a different value for either the S3
bucket or the SNS topic, this action will keep the existing value for the parameter that is
not changed.  You can have only one delivery channel per region in your account.

# Arguments
- `delivery_channel`: The configuration delivery channel object that delivers the
  configuration information to an Amazon S3 bucket and to an Amazon SNS topic.

"""
function put_delivery_channel(
    DeliveryChannel; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "PutDeliveryChannel",
        Dict{String,Any}("DeliveryChannel" => DeliveryChannel);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_delivery_channel(
    DeliveryChannel,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "PutDeliveryChannel",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("DeliveryChannel" => DeliveryChannel), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_evaluations(result_token)
    put_evaluations(result_token, params::Dict{String,<:Any})

Used by an Lambda function to deliver evaluation results to Config. This action is required
in every Lambda function that is invoked by an Config rule.

# Arguments
- `result_token`: An encrypted token that associates an evaluation with an Config rule.
  Identifies the rule and the event that triggered the evaluation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Evaluations"`: The assessments that the Lambda function performs. Each evaluation
  identifies an Amazon Web Services resource and indicates whether it complies with the
  Config rule that invokes the Lambda function.
- `"TestMode"`: Use this parameter to specify a test run for PutEvaluations. You can verify
  whether your Lambda function will deliver evaluation results to Config. No updates occur to
  your existing evaluations, and evaluation results are not sent to Config.  When TestMode is
  true, PutEvaluations doesn't require a valid value for the ResultToken parameter, but the
  value cannot be null.
"""
function put_evaluations(ResultToken; aws_config::AbstractAWSConfig=current_aws_config())
    return config_service(
        "PutEvaluations",
        Dict{String,Any}("ResultToken" => ResultToken);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_evaluations(
    ResultToken,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "PutEvaluations",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResultToken" => ResultToken), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_external_evaluation(config_rule_name, external_evaluation)
    put_external_evaluation(config_rule_name, external_evaluation, params::Dict{String,<:Any})

Add or updates the evaluations for process checks. This API checks if the rule is a process
check when the name of the Config rule is provided.

# Arguments
- `config_rule_name`: The name of the Config rule.
- `external_evaluation`: An ExternalEvaluation object that provides details about
  compliance.

"""
function put_external_evaluation(
    ConfigRuleName, ExternalEvaluation; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "PutExternalEvaluation",
        Dict{String,Any}(
            "ConfigRuleName" => ConfigRuleName, "ExternalEvaluation" => ExternalEvaluation
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_external_evaluation(
    ConfigRuleName,
    ExternalEvaluation,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "PutExternalEvaluation",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ConfigRuleName" => ConfigRuleName,
                    "ExternalEvaluation" => ExternalEvaluation,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_organization_config_rule(organization_config_rule_name)
    put_organization_config_rule(organization_config_rule_name, params::Dict{String,<:Any})

Adds or updates an Config rule for your entire organization to evaluate if your Amazon Web
Services resources comply with your desired configurations. For information on how many
organization Config rules you can have per account, see  Service Limits  in the Config
Developer Guide.  Only a management account and a delegated administrator can create or
update an organization Config rule. When calling this API with a delegated administrator,
you must ensure Organizations ListDelegatedAdministrator permissions are added. An
organization can have up to 3 delegated administrators. This API enables organization
service access through the EnableAWSServiceAccess action and creates a service-linked role
AWSServiceRoleForConfigMultiAccountSetup in the management or delegated administrator
account of your organization. The service-linked role is created only when the role does
not exist in the caller account. Config verifies the existence of role with GetRole action.
To use this API with delegated administrator, register a delegated administrator by calling
Amazon Web Services Organization register-delegated-administrator for
config-multiaccountsetup.amazonaws.com.  There are two types of rules: Config Managed Rules
and Config Custom Rules. You can use PutOrganizationConfigRule to create both Config
Managed Rules and Config Custom Rules. Config Managed Rules are predefined, customizable
rules created by Config. For a list of managed rules, see List of Config Managed Rules. If
you are adding an Config managed rule, you must specify the rule's identifier for the
RuleIdentifier key. Config Custom Rules are rules that you create from scratch. There are
two ways to create Config custom rules: with Lambda functions ( Lambda Developer Guide) and
with Guard (Guard GitHub Repository), a policy-as-code language. Config custom rules
created with Lambda are called Config Custom Lambda Rules and Config custom rules created
with Guard are called Config Custom Policy Rules. If you are adding a new Config Custom
Lambda rule, you first need to create an Lambda function in the management account or a
delegated administrator that the rule invokes to evaluate your resources. You also need to
create an IAM role in the managed account that can be assumed by the Lambda function. When
you use PutOrganizationConfigRule to add a Custom Lambda rule to Config, you must specify
the Amazon Resource Name (ARN) that Lambda assigns to the function.  Prerequisite: Ensure
you call EnableAllFeatures API to enable all features in an organization. Make sure to
specify one of either OrganizationCustomPolicyRuleMetadata for Custom Policy rules,
OrganizationCustomRuleMetadata for Custom Lambda rules, or OrganizationManagedRuleMetadata
for managed rules.

# Arguments
- `organization_config_rule_name`: The name that you assign to an organization Config rule.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ExcludedAccounts"`: A comma-separated list of accounts that you want to exclude from an
  organization Config rule.
- `"OrganizationCustomPolicyRuleMetadata"`: An OrganizationCustomPolicyRuleMetadata object.
  This object specifies metadata for your organization's Config Custom Policy rule. The
  metadata includes the runtime system in use, which accounts have debug logging enabled, and
  other custom rule metadata, such as resource type, resource ID of Amazon Web Services
  resource, and organization trigger types that initiate Config to evaluate Amazon Web
  Services resources against a rule.
- `"OrganizationCustomRuleMetadata"`: An OrganizationCustomRuleMetadata object. This object
  specifies organization custom rule metadata such as resource type, resource ID of Amazon
  Web Services resource, Lambda function ARN, and organization trigger types that trigger
  Config to evaluate your Amazon Web Services resources against a rule. It also provides the
  frequency with which you want Config to run evaluations for the rule if the trigger type is
  periodic.
- `"OrganizationManagedRuleMetadata"`: An OrganizationManagedRuleMetadata object. This
  object specifies organization managed rule metadata such as resource type and ID of Amazon
  Web Services resource along with the rule identifier. It also provides the frequency with
  which you want Config to run evaluations for the rule if the trigger type is periodic.
"""
function put_organization_config_rule(
    OrganizationConfigRuleName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "PutOrganizationConfigRule",
        Dict{String,Any}("OrganizationConfigRuleName" => OrganizationConfigRuleName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_organization_config_rule(
    OrganizationConfigRuleName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "PutOrganizationConfigRule",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "OrganizationConfigRuleName" => OrganizationConfigRuleName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_organization_conformance_pack(organization_conformance_pack_name)
    put_organization_conformance_pack(organization_conformance_pack_name, params::Dict{String,<:Any})

Deploys conformance packs across member accounts in an Amazon Web Services Organization.
For information on how many organization conformance packs and how many Config rules you
can have per account, see  Service Limits  in the Config Developer Guide. Only a management
account and a delegated administrator can call this API. When calling this API with a
delegated administrator, you must ensure Organizations ListDelegatedAdministrator
permissions are added. An organization can have up to 3 delegated administrators. This API
enables organization service access for config-multiaccountsetup.amazonaws.com through the
EnableAWSServiceAccess action and creates a service-linked role
AWSServiceRoleForConfigMultiAccountSetup in the management or delegated administrator
account of your organization. The service-linked role is created only when the role does
not exist in the caller account. To use this API with delegated administrator, register a
delegated administrator by calling Amazon Web Services Organization register-delegate-admin
for config-multiaccountsetup.amazonaws.com.  Prerequisite: Ensure you call
EnableAllFeatures API to enable all features in an organization. You must specify either
the TemplateS3Uri or the TemplateBody parameter, but not both. If you provide both Config
uses the TemplateS3Uri parameter and ignores the TemplateBody parameter. Config sets the
state of a conformance pack to CREATE_IN_PROGRESS and UPDATE_IN_PROGRESS until the
conformance pack is created or updated. You cannot update a conformance pack while it is in
this state.

# Arguments
- `organization_conformance_pack_name`: Name of the organization conformance pack you want
  to create.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConformancePackInputParameters"`: A list of ConformancePackInputParameter objects.
- `"DeliveryS3Bucket"`: The name of the Amazon S3 bucket where Config stores conformance
  pack templates.  This field is optional. If used, it must be prefixed with
  awsconfigconforms.
- `"DeliveryS3KeyPrefix"`: The prefix for the Amazon S3 bucket.  This field is optional.
- `"ExcludedAccounts"`: A list of Amazon Web Services accounts to be excluded from an
  organization conformance pack while deploying a conformance pack.
- `"TemplateBody"`: A string containing full conformance pack template body. Structure
  containing the template body with a minimum length of 1 byte and a maximum length of 51,200
  bytes.
- `"TemplateS3Uri"`: Location of file containing the template body. The uri must point to
  the conformance pack template (max size: 300 KB).  You must have access to read Amazon S3
  bucket. In addition, in order to ensure a successful deployment, the template object must
  not be in an archived storage class if this parameter is passed.
"""
function put_organization_conformance_pack(
    OrganizationConformancePackName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "PutOrganizationConformancePack",
        Dict{String,Any}(
            "OrganizationConformancePackName" => OrganizationConformancePackName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_organization_conformance_pack(
    OrganizationConformancePackName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "PutOrganizationConformancePack",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "OrganizationConformancePackName" => OrganizationConformancePackName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_remediation_configurations(remediation_configurations)
    put_remediation_configurations(remediation_configurations, params::Dict{String,<:Any})

Adds or updates the remediation configuration with a specific Config rule with the selected
target or action. The API creates the RemediationConfiguration object for the Config rule.
The Config rule must already exist for you to add a remediation configuration. The target
(SSM document) must exist and have permissions to use the target.    Be aware of backward
incompatible changes  If you make backward incompatible changes to the SSM document, you
must call this again to ensure the remediations can run. This API does not support adding
remediation configurations for service-linked Config Rules such as Organization Config
rules, the rules deployed by conformance packs, and rules deployed by Amazon Web Services
Security Hub.    Required fields  For manual remediation configuration, you need to provide
a value for automationAssumeRole or use a value in the assumeRolefield to remediate your
resources. The SSM automation document can use either as long as it maps to a valid
parameter. However, for automatic remediation configuration, the only valid assumeRole
field value is AutomationAssumeRole and you need to provide a value for
AutomationAssumeRole to remediate your resources.    Auto remediation can be initiated even
for compliant resources  If you enable auto remediation for a specific Config rule using
the PutRemediationConfigurations API or the Config console, it initiates the remediation
process for all non-compliant resources for that specific rule. The auto remediation
process relies on the compliance data snapshot which is captured on a periodic basis. Any
non-compliant resource that is updated between the snapshot schedule will continue to be
remediated based on the last known compliance data snapshot. This means that in some cases
auto remediation can be initiated even for compliant resources, since the bootstrap
processor uses a database that can have stale evaluation results based on the last known
compliance data snapshot.

# Arguments
- `remediation_configurations`: A list of remediation configuration objects.

"""
function put_remediation_configurations(
    RemediationConfigurations; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "PutRemediationConfigurations",
        Dict{String,Any}("RemediationConfigurations" => RemediationConfigurations);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_remediation_configurations(
    RemediationConfigurations,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "PutRemediationConfigurations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("RemediationConfigurations" => RemediationConfigurations),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_remediation_exceptions(config_rule_name, resource_keys)
    put_remediation_exceptions(config_rule_name, resource_keys, params::Dict{String,<:Any})

A remediation exception is when a specified resource is no longer considered for
auto-remediation. This API adds a new exception or updates an existing exception for a
specified resource with a specified Config rule.    Exceptions block auto remediation
Config generates a remediation exception when a problem occurs running a remediation action
for a specified resource. Remediation exceptions blocks auto-remediation until the
exception is cleared.    Manual remediation is recommended when placing an exception  When
placing an exception on an Amazon Web Services resource, it is recommended that remediation
is set as manual remediation until the given Config rule for the specified resource
evaluates the resource as NON_COMPLIANT. Once the resource has been evaluated as
NON_COMPLIANT, you can add remediation exceptions and change the remediation type back from
Manual to Auto if you want to use auto-remediation. Otherwise, using auto-remediation
before a NON_COMPLIANT evaluation result can delete resources before the exception is
applied.    Exceptions can only be performed on non-compliant resources  Placing an
exception can only be performed on resources that are NON_COMPLIANT. If you use this API
for COMPLIANT resources or resources that are NOT_APPLICABLE, a remediation exception will
not be generated. For more information on the conditions that initiate the possible Config
evaluation results, see Concepts | Config Rules in the Config Developer Guide.    Auto
remediation can be initiated even for compliant resources  If you enable auto remediation
for a specific Config rule using the PutRemediationConfigurations API or the Config
console, it initiates the remediation process for all non-compliant resources for that
specific rule. The auto remediation process relies on the compliance data snapshot which is
captured on a periodic basis. Any non-compliant resource that is updated between the
snapshot schedule will continue to be remediated based on the last known compliance data
snapshot. This means that in some cases auto remediation can be initiated even for
compliant resources, since the bootstrap processor uses a database that can have stale
evaluation results based on the last known compliance data snapshot.

# Arguments
- `config_rule_name`: The name of the Config rule for which you want to create remediation
  exception.
- `resource_keys`: An exception list of resource exception keys to be processed with the
  current request. Config adds exception for each resource key. For example, Config adds 3
  exceptions for 3 resource keys.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ExpirationTime"`: The exception is automatically deleted after the expiration date.
- `"Message"`: The message contains an explanation of the exception.
"""
function put_remediation_exceptions(
    ConfigRuleName, ResourceKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "PutRemediationExceptions",
        Dict{String,Any}(
            "ConfigRuleName" => ConfigRuleName, "ResourceKeys" => ResourceKeys
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_remediation_exceptions(
    ConfigRuleName,
    ResourceKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "PutRemediationExceptions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ConfigRuleName" => ConfigRuleName, "ResourceKeys" => ResourceKeys
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_resource_config(configuration, resource_id, resource_type, schema_version_id)
    put_resource_config(configuration, resource_id, resource_type, schema_version_id, params::Dict{String,<:Any})

Records the configuration state for the resource provided in the request. The configuration
state of a resource is represented in Config as Configuration Items. Once this API records
the configuration item, you can retrieve the list of configuration items for the custom
resource type using existing Config APIs.   The custom resource type must be registered
with CloudFormation. This API accepts the configuration item registered with
CloudFormation. When you call this API, Config only stores configuration state of the
resource provided in the request. This API does not change or remediate the configuration
of the resource.  Write-only schema properites are not recorded as part of the published
configuration item.

# Arguments
- `configuration`: The configuration object of the resource in valid JSON format. It must
  match the schema registered with CloudFormation.  The configuration JSON must not exceed 64
  KB.
- `resource_id`: Unique identifier of the resource.
- `resource_type`: The type of the resource. The custom resource type must be registered
  with CloudFormation.   You cannot use the organization names “amzn”, “amazon”,
  “alexa”, “custom” with custom resource types. It is the first part of the
  ResourceType up to the first ::.
- `schema_version_id`: Version of the schema registered for the ResourceType in
  CloudFormation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ResourceName"`: Name of the resource.
- `"Tags"`: Tags associated with the resource.  This field is not to be confused with the
  Amazon Web Services-wide tag feature for Amazon Web Services resources. Tags for
  PutResourceConfig are tags that you supply for the configuration items of your custom
  resources.
"""
function put_resource_config(
    Configuration,
    ResourceId,
    ResourceType,
    SchemaVersionId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "PutResourceConfig",
        Dict{String,Any}(
            "Configuration" => Configuration,
            "ResourceId" => ResourceId,
            "ResourceType" => ResourceType,
            "SchemaVersionId" => SchemaVersionId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_resource_config(
    Configuration,
    ResourceId,
    ResourceType,
    SchemaVersionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "PutResourceConfig",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Configuration" => Configuration,
                    "ResourceId" => ResourceId,
                    "ResourceType" => ResourceType,
                    "SchemaVersionId" => SchemaVersionId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_retention_configuration(retention_period_in_days)
    put_retention_configuration(retention_period_in_days, params::Dict{String,<:Any})

Creates and updates the retention configuration with details about retention period (number
of days) that Config stores your historical information. The API creates the
RetentionConfiguration object and names the object as default. When you have a
RetentionConfiguration object named default, calling the API modifies the default object.
Currently, Config supports only one retention configuration per region in your account.

# Arguments
- `retention_period_in_days`: Number of days Config stores your historical information.
  Currently, only applicable to the configuration item history.

"""
function put_retention_configuration(
    RetentionPeriodInDays; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "PutRetentionConfiguration",
        Dict{String,Any}("RetentionPeriodInDays" => RetentionPeriodInDays);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_retention_configuration(
    RetentionPeriodInDays,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "PutRetentionConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("RetentionPeriodInDays" => RetentionPeriodInDays),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_stored_query(stored_query)
    put_stored_query(stored_query, params::Dict{String,<:Any})

Saves a new query or updates an existing saved query. The QueryName must be unique for a
single Amazon Web Services account and a single Amazon Web Services Region. You can create
upto 300 queries in a single Amazon Web Services account and a single Amazon Web Services
Region.   PutStoredQuery is an idempotent API. Subsequent requests won’t create a
duplicate resource if one was already created. If a following request has different tags
values, Config will ignore these differences and treat it as an idempotent request of the
previous. In this case, tags will not be updated, even if they are different.

# Arguments
- `stored_query`: A list of StoredQuery objects. The mandatory fields are QueryName and
  Expression.  When you are creating a query, you must provide a query name and an
  expression. When you are updating a query, you must provide a query name but updating the
  description is optional.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: A list of Tags object.
"""
function put_stored_query(StoredQuery; aws_config::AbstractAWSConfig=current_aws_config())
    return config_service(
        "PutStoredQuery",
        Dict{String,Any}("StoredQuery" => StoredQuery);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_stored_query(
    StoredQuery,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "PutStoredQuery",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("StoredQuery" => StoredQuery), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    select_aggregate_resource_config(configuration_aggregator_name, expression)
    select_aggregate_resource_config(configuration_aggregator_name, expression, params::Dict{String,<:Any})

Accepts a structured query language (SQL) SELECT command and an aggregator to query
configuration state of Amazon Web Services resources across multiple accounts and regions,
performs the corresponding search, and returns resource configurations matching the
properties. For more information about query components, see the  Query Components  section
in the Config Developer Guide.  If you run an aggregation query (i.e., using GROUP BY or
using aggregate functions such as COUNT; e.g., SELECT resourceId, COUNT(*) WHERE
resourceType = 'AWS::IAM::Role' GROUP BY resourceId) and do not specify the MaxResults or
the Limit query parameters, the default page size is set to 500. If you run a
non-aggregation query (i.e., not using GROUP BY or aggregate function; e.g., SELECT * WHERE
resourceType = 'AWS::IAM::Role') and do not specify the MaxResults or the Limit query
parameters, the default page size is set to 25.

# Arguments
- `configuration_aggregator_name`: The name of the configuration aggregator.
- `expression`: The SQL query SELECT command.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: The maximum number of query results returned on each page.
- `"MaxResults"`: The maximum number of query results returned on each page. Config also
  allows the Limit request parameter.
- `"NextToken"`: The nextToken string returned in a previous request that you use to
  request the next page of results in a paginated response.
"""
function select_aggregate_resource_config(
    ConfigurationAggregatorName,
    Expression;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "SelectAggregateResourceConfig",
        Dict{String,Any}(
            "ConfigurationAggregatorName" => ConfigurationAggregatorName,
            "Expression" => Expression,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function select_aggregate_resource_config(
    ConfigurationAggregatorName,
    Expression,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "SelectAggregateResourceConfig",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ConfigurationAggregatorName" => ConfigurationAggregatorName,
                    "Expression" => Expression,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    select_resource_config(expression)
    select_resource_config(expression, params::Dict{String,<:Any})

Accepts a structured query language (SQL) SELECT command, performs the corresponding
search, and returns resource configurations matching the properties. For more information
about query components, see the  Query Components  section in the Config Developer Guide.

# Arguments
- `expression`: The SQL query SELECT command.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: The maximum number of query results returned on each page.
- `"NextToken"`: The nextToken string returned in a previous request that you use to
  request the next page of results in a paginated response.
"""
function select_resource_config(
    Expression; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "SelectResourceConfig",
        Dict{String,Any}("Expression" => Expression);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function select_resource_config(
    Expression,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "SelectResourceConfig",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Expression" => Expression), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_config_rules_evaluation()
    start_config_rules_evaluation(params::Dict{String,<:Any})

Runs an on-demand evaluation for the specified Config rules against the last known
configuration state of the resources. Use StartConfigRulesEvaluation when you want to test
that a rule you updated is working as expected. StartConfigRulesEvaluation does not
re-record the latest configuration state for your resources. It re-runs an evaluation
against the last known state of your resources.  You can specify up to 25 Config rules per
request.  An existing StartConfigRulesEvaluation call for the specified rules must complete
before you can call the API again. If you chose to have Config stream to an Amazon SNS
topic, you will receive a ConfigRuleEvaluationStarted notification when the evaluation
starts.  You don't need to call the StartConfigRulesEvaluation API to run an evaluation for
a new rule. When you create a rule, Config evaluates your resources against the rule
automatically.   The StartConfigRulesEvaluation API is useful if you want to run on-demand
evaluations, such as the following example:   You have a custom rule that evaluates your
IAM resources every 24 hours.   You update your Lambda function to add additional
conditions to your rule.   Instead of waiting for the next periodic evaluation, you call
the StartConfigRulesEvaluation API.   Config invokes your Lambda function and evaluates
your IAM resources.   Your custom rule will still run periodic evaluations every 24 hours.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConfigRuleNames"`: The list of names of Config rules that you want to run evaluations
  for.
"""
function start_config_rules_evaluation(; aws_config::AbstractAWSConfig=current_aws_config())
    return config_service(
        "StartConfigRulesEvaluation"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function start_config_rules_evaluation(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "StartConfigRulesEvaluation",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_configuration_recorder(configuration_recorder_name)
    start_configuration_recorder(configuration_recorder_name, params::Dict{String,<:Any})

Starts recording configurations of the Amazon Web Services resources you have selected to
record in your Amazon Web Services account. You must have created at least one delivery
channel to successfully start the configuration recorder.

# Arguments
- `configuration_recorder_name`: The name of the recorder object that records each
  configuration change made to the resources.

"""
function start_configuration_recorder(
    ConfigurationRecorderName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "StartConfigurationRecorder",
        Dict{String,Any}("ConfigurationRecorderName" => ConfigurationRecorderName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_configuration_recorder(
    ConfigurationRecorderName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "StartConfigurationRecorder",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ConfigurationRecorderName" => ConfigurationRecorderName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_remediation_execution(config_rule_name, resource_keys)
    start_remediation_execution(config_rule_name, resource_keys, params::Dict{String,<:Any})

Runs an on-demand remediation for the specified Config rules against the last known
remediation configuration. It runs an execution against the current state of your
resources. Remediation execution is asynchronous. You can specify up to 100 resource keys
per request. An existing StartRemediationExecution call for the specified resource keys
must complete before you can call the API again.

# Arguments
- `config_rule_name`: The list of names of Config rules that you want to run remediation
  execution for.
- `resource_keys`: A list of resource keys to be processed with the current request. Each
  element in the list consists of the resource type and resource ID.

"""
function start_remediation_execution(
    ConfigRuleName, ResourceKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "StartRemediationExecution",
        Dict{String,Any}(
            "ConfigRuleName" => ConfigRuleName, "ResourceKeys" => ResourceKeys
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_remediation_execution(
    ConfigRuleName,
    ResourceKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "StartRemediationExecution",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ConfigRuleName" => ConfigRuleName, "ResourceKeys" => ResourceKeys
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_resource_evaluation(evaluation_mode, resource_details)
    start_resource_evaluation(evaluation_mode, resource_details, params::Dict{String,<:Any})

Runs an on-demand evaluation for the specified resource to determine whether the resource
details will comply with configured Config rules. You can also use it for evaluation
purposes. Config recommends using an evaluation context. It runs an execution against the
resource details with all of the Config rules in your account that match with the specified
proactive mode and resource type.  Ensure you have the cloudformation:DescribeType role
setup to validate the resource type schema. You can find the Resource type schema in
\"Amazon Web Services public extensions\" within the CloudFormation registry or with the
following CLI commmand: aws cloudformation describe-type --type-name \"AWS::S3::Bucket\"
--type RESOURCE. For more information, see Managing extensions through the CloudFormation
registry and Amazon Web Services resource and property types reference in the
CloudFormation User Guide.

# Arguments
- `evaluation_mode`: The mode of an evaluation. The valid values for this API are DETECTIVE
  and PROACTIVE.
- `resource_details`: Returns a ResourceDetails object.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: A client token is a unique, case-sensitive string of up to 64 ASCII
  characters. To make an idempotent API request using one of these actions, specify a client
  token in the request.  Avoid reusing the same client token for other API requests. If you
  retry a request that completed successfully using the same client token and the same
  parameters, the retry succeeds without performing any further actions. If you retry a
  successful request using the same client token, but one or more of the parameters are
  different, other than the Region or Availability Zone, the retry fails with an
  IdempotentParameterMismatch error.
- `"EvaluationContext"`: Returns an EvaluationContext object.
- `"EvaluationTimeout"`: The timeout for an evaluation. The default is 900 seconds. You
  cannot specify a number greater than 3600. If you specify 0, Config uses the default.
"""
function start_resource_evaluation(
    EvaluationMode, ResourceDetails; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "StartResourceEvaluation",
        Dict{String,Any}(
            "EvaluationMode" => EvaluationMode, "ResourceDetails" => ResourceDetails
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_resource_evaluation(
    EvaluationMode,
    ResourceDetails,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "StartResourceEvaluation",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EvaluationMode" => EvaluationMode, "ResourceDetails" => ResourceDetails
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_configuration_recorder(configuration_recorder_name)
    stop_configuration_recorder(configuration_recorder_name, params::Dict{String,<:Any})

Stops recording configurations of the Amazon Web Services resources you have selected to
record in your Amazon Web Services account.

# Arguments
- `configuration_recorder_name`: The name of the recorder object that records each
  configuration change made to the resources.

"""
function stop_configuration_recorder(
    ConfigurationRecorderName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "StopConfigurationRecorder",
        Dict{String,Any}("ConfigurationRecorderName" => ConfigurationRecorderName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_configuration_recorder(
    ConfigurationRecorderName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "StopConfigurationRecorder",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ConfigurationRecorderName" => ConfigurationRecorderName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Associates the specified tags to a resource with the specified resourceArn. If existing
tags on a resource are not specified in the request parameters, they are not changed. If
existing tags are specified, however, then their values will be updated. When a resource is
deleted, the tags associated with that resource are deleted as well.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) that identifies the resource for which to
  list the tags. Currently, the supported resources are ConfigRule, ConfigurationAggregator
  and AggregatorAuthorization.
- `tags`: An array of tag object.

"""
function tag_resource(ResourceArn, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return config_service(
        "TagResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceArn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Deletes specified tags from a resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) that identifies the resource for which to
  list the tags. Currently, the supported resources are ConfigRule, ConfigurationAggregator
  and AggregatorAuthorization.
- `tag_keys`: The keys of the tags to be removed.

"""
function untag_resource(
    ResourceArn, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return config_service(
        "UntagResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceArn,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return config_service(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: securityhub
using AWS.Compat
using AWS.UUIDs

"""
    accept_administrator_invitation(administrator_id, invitation_id)
    accept_administrator_invitation(administrator_id, invitation_id, params::Dict{String,<:Any})

Accepts the invitation to be a member account and be monitored by the Security Hub
administrator account that the invitation was sent from. This operation is only used by
member accounts that are not added through Organizations. When the member account accepts
the invitation, permission is granted to the administrator account to view findings
generated in the member account.

# Arguments
- `administrator_id`: The account ID of the Security Hub administrator account that sent
  the invitation.
- `invitation_id`: The identifier of the invitation sent from the Security Hub
  administrator account.

"""
function accept_administrator_invitation(
    AdministratorId, InvitationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "POST",
        "/administrator",
        Dict{String,Any}(
            "AdministratorId" => AdministratorId, "InvitationId" => InvitationId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function accept_administrator_invitation(
    AdministratorId,
    InvitationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securityhub(
        "POST",
        "/administrator",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AdministratorId" => AdministratorId, "InvitationId" => InvitationId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    accept_invitation(invitation_id, master_id)
    accept_invitation(invitation_id, master_id, params::Dict{String,<:Any})

This method is deprecated. Instead, use AcceptAdministratorInvitation. The Security Hub
console continues to use AcceptInvitation. It will eventually change to use
AcceptAdministratorInvitation. Any IAM policies that specifically control access to this
function must continue to use AcceptInvitation. You should also add
AcceptAdministratorInvitation to your policies to ensure that the correct permissions are
in place after the console begins to use AcceptAdministratorInvitation. Accepts the
invitation to be a member account and be monitored by the Security Hub administrator
account that the invitation was sent from. This operation is only used by member accounts
that are not added through Organizations. When the member account accepts the invitation,
permission is granted to the administrator account to view findings generated in the member
account.

# Arguments
- `invitation_id`: The identifier of the invitation sent from the Security Hub
  administrator account.
- `master_id`: The account ID of the Security Hub administrator account that sent the
  invitation.

"""
function accept_invitation(
    InvitationId, MasterId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "POST",
        "/master",
        Dict{String,Any}("InvitationId" => InvitationId, "MasterId" => MasterId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function accept_invitation(
    InvitationId,
    MasterId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securityhub(
        "POST",
        "/master",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("InvitationId" => InvitationId, "MasterId" => MasterId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_delete_automation_rules(automation_rules_arns)
    batch_delete_automation_rules(automation_rules_arns, params::Dict{String,<:Any})

 Deletes one or more automation rules.

# Arguments
- `automation_rules_arns`:  A list of Amazon Resource Names (ARNs) for the rules that are
  to be deleted.

"""
function batch_delete_automation_rules(
    AutomationRulesArns; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "POST",
        "/automationrules/delete",
        Dict{String,Any}("AutomationRulesArns" => AutomationRulesArns);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_delete_automation_rules(
    AutomationRulesArns,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securityhub(
        "POST",
        "/automationrules/delete",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("AutomationRulesArns" => AutomationRulesArns),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_disable_standards(standards_subscription_arns)
    batch_disable_standards(standards_subscription_arns, params::Dict{String,<:Any})

Disables the standards specified by the provided StandardsSubscriptionArns. For more
information, see Security Standards section of the Security Hub User Guide.

# Arguments
- `standards_subscription_arns`: The ARNs of the standards subscriptions to disable.

"""
function batch_disable_standards(
    StandardsSubscriptionArns; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "POST",
        "/standards/deregister",
        Dict{String,Any}("StandardsSubscriptionArns" => StandardsSubscriptionArns);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_disable_standards(
    StandardsSubscriptionArns,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securityhub(
        "POST",
        "/standards/deregister",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("StandardsSubscriptionArns" => StandardsSubscriptionArns),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_enable_standards(standards_subscription_requests)
    batch_enable_standards(standards_subscription_requests, params::Dict{String,<:Any})

Enables the standards specified by the provided StandardsArn. To obtain the ARN for a
standard, use the DescribeStandards operation. For more information, see the Security
Standards section of the Security Hub User Guide.

# Arguments
- `standards_subscription_requests`: The list of standards checks to enable.

"""
function batch_enable_standards(
    StandardsSubscriptionRequests; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "POST",
        "/standards/register",
        Dict{String,Any}("StandardsSubscriptionRequests" => StandardsSubscriptionRequests);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_enable_standards(
    StandardsSubscriptionRequests,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securityhub(
        "POST",
        "/standards/register",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "StandardsSubscriptionRequests" => StandardsSubscriptionRequests
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_get_automation_rules(automation_rules_arns)
    batch_get_automation_rules(automation_rules_arns, params::Dict{String,<:Any})

 Retrieves a list of details for automation rules based on rule Amazon Resource Names
(ARNs).

# Arguments
- `automation_rules_arns`:  A list of rule ARNs to get details for.

"""
function batch_get_automation_rules(
    AutomationRulesArns; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "POST",
        "/automationrules/get",
        Dict{String,Any}("AutomationRulesArns" => AutomationRulesArns);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_automation_rules(
    AutomationRulesArns,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securityhub(
        "POST",
        "/automationrules/get",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("AutomationRulesArns" => AutomationRulesArns),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_get_configuration_policy_associations(configuration_policy_association_identifiers)
    batch_get_configuration_policy_associations(configuration_policy_association_identifiers, params::Dict{String,<:Any})

 Returns associations between an Security Hub configuration and a batch of target accounts,
organizational units, or the root. Only the Security Hub delegated administrator can invoke
this operation from the home Region. A configuration can refer to a configuration policy or
to a self-managed configuration.

# Arguments
- `configuration_policy_association_identifiers`:  Specifies one or more target account
  IDs, organizational unit (OU) IDs, or the root ID to retrieve associations for.

"""
function batch_get_configuration_policy_associations(
    ConfigurationPolicyAssociationIdentifiers;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securityhub(
        "POST",
        "/configurationPolicyAssociation/batchget",
        Dict{String,Any}(
            "ConfigurationPolicyAssociationIdentifiers" =>
                ConfigurationPolicyAssociationIdentifiers,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_configuration_policy_associations(
    ConfigurationPolicyAssociationIdentifiers,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securityhub(
        "POST",
        "/configurationPolicyAssociation/batchget",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ConfigurationPolicyAssociationIdentifiers" =>
                        ConfigurationPolicyAssociationIdentifiers,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_get_security_controls(security_control_ids)
    batch_get_security_controls(security_control_ids, params::Dict{String,<:Any})

 Provides details about a batch of security controls for the current Amazon Web Services
account and Amazon Web Services Region.

# Arguments
- `security_control_ids`:  A list of security controls (identified with SecurityControlId,
  SecurityControlArn, or a mix of both parameters). The security control ID or Amazon
  Resource Name (ARN) is the same across standards.

"""
function batch_get_security_controls(
    SecurityControlIds; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "POST",
        "/securityControls/batchGet",
        Dict{String,Any}("SecurityControlIds" => SecurityControlIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_security_controls(
    SecurityControlIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securityhub(
        "POST",
        "/securityControls/batchGet",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("SecurityControlIds" => SecurityControlIds), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_get_standards_control_associations(standards_control_association_ids)
    batch_get_standards_control_associations(standards_control_association_ids, params::Dict{String,<:Any})

 For a batch of security controls and standards, identifies whether each control is
currently enabled or disabled in a standard.

# Arguments
- `standards_control_association_ids`:  An array with one or more objects that includes a
  security control (identified with SecurityControlId, SecurityControlArn, or a mix of both
  parameters) and the Amazon Resource Name (ARN) of a standard. This field is used to query
  the enablement status of a control in a specified standard. The security control ID or ARN
  is the same across standards.

"""
function batch_get_standards_control_associations(
    StandardsControlAssociationIds; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "POST",
        "/associations/batchGet",
        Dict{String,Any}(
            "StandardsControlAssociationIds" => StandardsControlAssociationIds
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_standards_control_associations(
    StandardsControlAssociationIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securityhub(
        "POST",
        "/associations/batchGet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "StandardsControlAssociationIds" => StandardsControlAssociationIds
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_import_findings(findings)
    batch_import_findings(findings, params::Dict{String,<:Any})

Imports security findings generated by a finding provider into Security Hub. This action is
requested by the finding provider to import its findings into Security Hub.
BatchImportFindings must be called by one of the following:   The Amazon Web Services
account that is associated with a finding if you are using the default product ARN or are a
partner sending findings from within a customer's Amazon Web Services account. In these
cases, the identifier of the account that you are calling BatchImportFindings from needs to
be the same as the AwsAccountId attribute for the finding.   An Amazon Web Services account
that Security Hub has allow-listed for an official partner integration. In this case, you
can call BatchImportFindings from the allow-listed account and send findings from different
customer accounts in the same batch.   The maximum allowed size for a finding is 240 Kb. An
error is returned for any finding larger than 240 Kb. After a finding is created,
BatchImportFindings cannot be used to update the following finding fields and objects,
which Security Hub customers use to manage their investigation workflow.    Note
UserDefinedFields     VerificationState     Workflow    Finding providers also should not
use BatchImportFindings to update the following attributes.    Confidence     Criticality
  RelatedFindings     Severity     Types    Instead, finding providers use
FindingProviderFields to provide values for these attributes.

# Arguments
- `findings`: A list of findings to import. To successfully import a finding, it must
  follow the Amazon Web Services Security Finding Format. Maximum of 100 findings per request.

"""
function batch_import_findings(Findings; aws_config::AbstractAWSConfig=current_aws_config())
    return securityhub(
        "POST",
        "/findings/import",
        Dict{String,Any}("Findings" => Findings);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_import_findings(
    Findings,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securityhub(
        "POST",
        "/findings/import",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Findings" => Findings), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_update_automation_rules(update_automation_rules_request_items)
    batch_update_automation_rules(update_automation_rules_request_items, params::Dict{String,<:Any})

 Updates one or more automation rules based on rule Amazon Resource Names (ARNs) and input
parameters.

# Arguments
- `update_automation_rules_request_items`:  An array of ARNs for the rules that are to be
  updated. Optionally, you can also include RuleStatus and RuleOrder.

"""
function batch_update_automation_rules(
    UpdateAutomationRulesRequestItems; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "PATCH",
        "/automationrules/update",
        Dict{String,Any}(
            "UpdateAutomationRulesRequestItems" => UpdateAutomationRulesRequestItems
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_update_automation_rules(
    UpdateAutomationRulesRequestItems,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securityhub(
        "PATCH",
        "/automationrules/update",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "UpdateAutomationRulesRequestItems" => UpdateAutomationRulesRequestItems
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_update_findings(finding_identifiers)
    batch_update_findings(finding_identifiers, params::Dict{String,<:Any})

Used by Security Hub customers to update information about their investigation into a
finding. Requested by administrator accounts or member accounts. Administrator accounts can
update findings for their account and their member accounts. Member accounts can update
findings for their account. Updates from BatchUpdateFindings do not affect the value of
UpdatedAt for a finding. Administrator and member accounts can use BatchUpdateFindings to
update the following finding fields and objects.    Confidence     Criticality     Note
RelatedFindings     Severity     Types     UserDefinedFields     VerificationState
Workflow    You can configure IAM policies to restrict access to fields and field values.
For example, you might not want member accounts to be able to suppress findings or change
the finding severity. See Configuring access to BatchUpdateFindings in the Security Hub
User Guide.

# Arguments
- `finding_identifiers`: The list of findings to update. BatchUpdateFindings can be used to
  update up to 100 findings at a time. For each finding, the list provides the finding
  identifier and the ARN of the finding provider.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Confidence"`: The updated value for the finding confidence. Confidence is defined as
  the likelihood that a finding accurately identifies the behavior or issue that it was
  intended to identify. Confidence is scored on a 0-100 basis using a ratio scale, where 0
  means zero percent confidence and 100 means 100 percent confidence.
- `"Criticality"`: The updated value for the level of importance assigned to the resources
  associated with the findings. A score of 0 means that the underlying resources have no
  criticality, and a score of 100 is reserved for the most critical resources.
- `"Note"`:
- `"RelatedFindings"`: A list of findings that are related to the updated findings.
- `"Severity"`: Used to update the finding severity.
- `"Types"`: One or more finding types in the format of namespace/category/classifier that
  classify a finding. Valid namespace values are as follows.   Software and Configuration
  Checks   TTPs   Effects   Unusual Behaviors   Sensitive Data Identifications
- `"UserDefinedFields"`: A list of name/value string pairs associated with the finding.
  These are custom, user-defined fields added to a finding.
- `"VerificationState"`: Indicates the veracity of a finding. The available values for
  VerificationState are as follows.    UNKNOWN – The default disposition of a security
  finding    TRUE_POSITIVE – The security finding is confirmed    FALSE_POSITIVE – The
  security finding was determined to be a false alarm    BENIGN_POSITIVE – A special case
  of TRUE_POSITIVE where the finding doesn't pose any threat, is expected, or both
- `"Workflow"`: Used to update the workflow status of a finding. The workflow status
  indicates the progress of the investigation into the finding.
"""
function batch_update_findings(
    FindingIdentifiers; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "PATCH",
        "/findings/batchupdate",
        Dict{String,Any}("FindingIdentifiers" => FindingIdentifiers);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_update_findings(
    FindingIdentifiers,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securityhub(
        "PATCH",
        "/findings/batchupdate",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("FindingIdentifiers" => FindingIdentifiers), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_update_standards_control_associations(standards_control_association_updates)
    batch_update_standards_control_associations(standards_control_association_updates, params::Dict{String,<:Any})

 For a batch of security controls and standards, this operation updates the enablement
status of a control in a standard.

# Arguments
- `standards_control_association_updates`:  Updates the enablement status of a security
  control in a specified standard.

"""
function batch_update_standards_control_associations(
    StandardsControlAssociationUpdates; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "PATCH",
        "/associations",
        Dict{String,Any}(
            "StandardsControlAssociationUpdates" => StandardsControlAssociationUpdates
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_update_standards_control_associations(
    StandardsControlAssociationUpdates,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securityhub(
        "PATCH",
        "/associations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "StandardsControlAssociationUpdates" =>
                        StandardsControlAssociationUpdates,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_action_target(description, id, name)
    create_action_target(description, id, name, params::Dict{String,<:Any})

Creates a custom action target in Security Hub. You can use custom actions on findings and
insights in Security Hub to trigger target actions in Amazon CloudWatch Events.

# Arguments
- `description`: The description for the custom action target.
- `id`: The ID for the custom action target. Can contain up to 20 alphanumeric characters.
- `name`: The name of the custom action target. Can contain up to 20 characters.

"""
function create_action_target(
    Description, Id, Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "POST",
        "/actionTargets",
        Dict{String,Any}("Description" => Description, "Id" => Id, "Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_action_target(
    Description,
    Id,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securityhub(
        "POST",
        "/actionTargets",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Description" => Description, "Id" => Id, "Name" => Name),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_automation_rule(actions, criteria, description, rule_name, rule_order)
    create_automation_rule(actions, criteria, description, rule_name, rule_order, params::Dict{String,<:Any})

 Creates an automation rule based on input parameters.

# Arguments
- `actions`:  One or more actions to update finding fields if a finding matches the
  conditions specified in Criteria.
- `criteria`:  A set of ASFF finding field attributes and corresponding expected values
  that Security Hub uses to filter findings. If a rule is enabled and a finding matches the
  conditions specified in this parameter, Security Hub applies the rule action to the
  finding.
- `description`:  A description of the rule.
- `rule_name`:  The name of the rule.
- `rule_order`: An integer ranging from 1 to 1000 that represents the order in which the
  rule action is applied to findings. Security Hub applies rules with lower values for this
  parameter first.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"IsTerminal"`: Specifies whether a rule is the last to be applied with respect to a
  finding that matches the rule criteria. This is useful when a finding matches the criteria
  for multiple rules, and each rule has different actions. If a rule is terminal, Security
  Hub applies the rule action to a finding that matches the rule criteria and doesn't
  evaluate other rules for the finding. By default, a rule isn't terminal.
- `"RuleStatus"`:  Whether the rule is active after it is created. If this parameter is
  equal to ENABLED, Security Hub starts applying the rule to findings and finding updates
  after the rule is created. To change the value of this parameter after creating a rule, use
   BatchUpdateAutomationRules .
- `"Tags"`:  User-defined tags associated with an automation rule.
"""
function create_automation_rule(
    Actions,
    Criteria,
    Description,
    RuleName,
    RuleOrder;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securityhub(
        "POST",
        "/automationrules/create",
        Dict{String,Any}(
            "Actions" => Actions,
            "Criteria" => Criteria,
            "Description" => Description,
            "RuleName" => RuleName,
            "RuleOrder" => RuleOrder,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_automation_rule(
    Actions,
    Criteria,
    Description,
    RuleName,
    RuleOrder,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securityhub(
        "POST",
        "/automationrules/create",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Actions" => Actions,
                    "Criteria" => Criteria,
                    "Description" => Description,
                    "RuleName" => RuleName,
                    "RuleOrder" => RuleOrder,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_configuration_policy(configuration_policy, name)
    create_configuration_policy(configuration_policy, name, params::Dict{String,<:Any})

 Creates a configuration policy with the defined configuration. Only the Security Hub
delegated administrator can invoke this operation from the home Region.

# Arguments
- `configuration_policy`:  An object that defines how Security Hub is configured. It
  includes whether Security Hub is enabled or disabled, a list of enabled security standards,
  a list of enabled or disabled security controls, and a list of custom parameter values for
  specified controls. If you provide a list of security controls that are enabled in the
  configuration policy, Security Hub disables all other controls (including newly released
  controls). If you provide a list of security controls that are disabled in the
  configuration policy, Security Hub enables all other controls (including newly released
  controls).
- `name`:  The name of the configuration policy. Alphanumeric characters and the following
  ASCII characters are permitted: -, ., !, *, /.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`:  The description of the configuration policy.
- `"Tags"`:  User-defined tags associated with a configuration policy. For more
  information, see Tagging Security Hub resources in the Security Hub user guide.
"""
function create_configuration_policy(
    ConfigurationPolicy, Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "POST",
        "/configurationPolicy/create",
        Dict{String,Any}("ConfigurationPolicy" => ConfigurationPolicy, "Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_configuration_policy(
    ConfigurationPolicy,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securityhub(
        "POST",
        "/configurationPolicy/create",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ConfigurationPolicy" => ConfigurationPolicy, "Name" => Name
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_finding_aggregator(region_linking_mode)
    create_finding_aggregator(region_linking_mode, params::Dict{String,<:Any})

Used to enable finding aggregation. Must be called from the aggregation Region. For more
details about cross-Region replication, see Configuring finding aggregation in the Security
Hub User Guide.

# Arguments
- `region_linking_mode`: Indicates whether to aggregate findings from all of the available
  Regions in the current partition. Also determines whether to automatically aggregate
  findings from new Regions as Security Hub supports them and you opt into them. The selected
  option also determines how to use the Regions provided in the Regions list. The options are
  as follows:    ALL_REGIONS - Indicates to aggregate findings from all of the Regions where
  Security Hub is enabled. When you choose this option, Security Hub also automatically
  aggregates findings from new Regions as Security Hub supports them and you opt into them.
    ALL_REGIONS_EXCEPT_SPECIFIED - Indicates to aggregate findings from all of the Regions
  where Security Hub is enabled, except for the Regions listed in the Regions parameter. When
  you choose this option, Security Hub also automatically aggregates findings from new
  Regions as Security Hub supports them and you opt into them.     SPECIFIED_REGIONS -
  Indicates to aggregate findings only from the Regions listed in the Regions parameter.
  Security Hub does not automatically aggregate findings from new Regions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Regions"`: If RegionLinkingMode is ALL_REGIONS_EXCEPT_SPECIFIED, then this is a
  space-separated list of Regions that do not aggregate findings to the aggregation Region.
  If RegionLinkingMode is SPECIFIED_REGIONS, then this is a space-separated list of Regions
  that do aggregate findings to the aggregation Region.
"""
function create_finding_aggregator(
    RegionLinkingMode; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "POST",
        "/findingAggregator/create",
        Dict{String,Any}("RegionLinkingMode" => RegionLinkingMode);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_finding_aggregator(
    RegionLinkingMode,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securityhub(
        "POST",
        "/findingAggregator/create",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("RegionLinkingMode" => RegionLinkingMode), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_insight(filters, group_by_attribute, name)
    create_insight(filters, group_by_attribute, name, params::Dict{String,<:Any})

Creates a custom insight in Security Hub. An insight is a consolidation of findings that
relate to a security issue that requires attention or remediation. To group the related
findings in the insight, use the GroupByAttribute.

# Arguments
- `filters`: One or more attributes used to filter the findings included in the insight.
  The insight only includes findings that match the criteria defined in the filters.
- `group_by_attribute`: The attribute used to group the findings for the insight. The
  grouping attribute identifies the type of item that the insight applies to. For example, if
  an insight is grouped by resource identifier, then the insight produces a list of resource
  identifiers.
- `name`: The name of the custom insight to create.

"""
function create_insight(
    Filters, GroupByAttribute, Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "POST",
        "/insights",
        Dict{String,Any}(
            "Filters" => Filters, "GroupByAttribute" => GroupByAttribute, "Name" => Name
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_insight(
    Filters,
    GroupByAttribute,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securityhub(
        "POST",
        "/insights",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Filters" => Filters,
                    "GroupByAttribute" => GroupByAttribute,
                    "Name" => Name,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_members(account_details)
    create_members(account_details, params::Dict{String,<:Any})

Creates a member association in Security Hub between the specified accounts and the account
used to make the request, which is the administrator account. If you are integrated with
Organizations, then the administrator account is designated by the organization management
account.  CreateMembers is always used to add accounts that are not organization members.
For accounts that are managed using Organizations, CreateMembers is only used in the
following cases:   Security Hub is not configured to automatically add new organization
accounts.   The account was disassociated or deleted in Security Hub.   This action can
only be used by an account that has Security Hub enabled. To enable Security Hub, you can
use the EnableSecurityHub operation. For accounts that are not organization members, you
create the account association and then send an invitation to the member account. To send
the invitation, you use the InviteMembers operation. If the account owner accepts the
invitation, the account becomes a member account in Security Hub. Accounts that are managed
using Organizations do not receive an invitation. They automatically become a member
account in Security Hub.   If the organization account does not have Security Hub enabled,
then Security Hub and the default standards are automatically enabled. Note that Security
Hub cannot be enabled automatically for the organization management account. The
organization management account must enable Security Hub before the administrator account
enables it as a member account.   For organization accounts that already have Security Hub
enabled, Security Hub does not make any other changes to those accounts. It does not change
their enabled standards or controls.   A permissions policy is added that permits the
administrator account to view the findings generated in the member account. To remove the
association between the administrator and member accounts, use the
DisassociateFromMasterAccount or DisassociateMembers operation.

# Arguments
- `account_details`: The list of accounts to associate with the Security Hub administrator
  account. For each account, the list includes the account ID and optionally the email
  address.

"""
function create_members(AccountDetails; aws_config::AbstractAWSConfig=current_aws_config())
    return securityhub(
        "POST",
        "/members",
        Dict{String,Any}("AccountDetails" => AccountDetails);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_members(
    AccountDetails,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securityhub(
        "POST",
        "/members",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AccountDetails" => AccountDetails), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    decline_invitations(account_ids)
    decline_invitations(account_ids, params::Dict{String,<:Any})

Declines invitations to become a member account. A prospective member account uses this
operation to decline an invitation to become a member. This operation is only called by
member accounts that aren't part of an organization. Organization accounts don't receive
invitations.

# Arguments
- `account_ids`: The list of prospective member account IDs for which to decline an
  invitation.

"""
function decline_invitations(AccountIds; aws_config::AbstractAWSConfig=current_aws_config())
    return securityhub(
        "POST",
        "/invitations/decline",
        Dict{String,Any}("AccountIds" => AccountIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function decline_invitations(
    AccountIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securityhub(
        "POST",
        "/invitations/decline",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AccountIds" => AccountIds), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_action_target(action_target_arn)
    delete_action_target(action_target_arn, params::Dict{String,<:Any})

Deletes a custom action target from Security Hub. Deleting a custom action target does not
affect any findings or insights that were already sent to Amazon CloudWatch Events using
the custom action.

# Arguments
- `action_target_arn`: The Amazon Resource Name (ARN) of the custom action target to delete.

"""
function delete_action_target(
    ActionTargetArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "DELETE",
        "/actionTargets/$(ActionTargetArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_action_target(
    ActionTargetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securityhub(
        "DELETE",
        "/actionTargets/$(ActionTargetArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_configuration_policy(identifier)
    delete_configuration_policy(identifier, params::Dict{String,<:Any})

 Deletes a configuration policy. Only the Security Hub delegated administrator can invoke
this operation from the home Region. For the deletion to succeed, you must first
disassociate a configuration policy from target accounts, organizational units, or the root
by invoking the StartConfigurationPolicyDisassociation operation.

# Arguments
- `identifier`:  The Amazon Resource Name (ARN) or universally unique identifier (UUID) of
  the configuration policy.

"""
function delete_configuration_policy(
    Identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "DELETE",
        "/configurationPolicy/$(Identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_configuration_policy(
    Identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securityhub(
        "DELETE",
        "/configurationPolicy/$(Identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_finding_aggregator(finding_aggregator_arn)
    delete_finding_aggregator(finding_aggregator_arn, params::Dict{String,<:Any})

Deletes a finding aggregator. When you delete the finding aggregator, you stop finding
aggregation. When you stop finding aggregation, findings that were already aggregated to
the aggregation Region are still visible from the aggregation Region. New findings and
finding updates are not aggregated.

# Arguments
- `finding_aggregator_arn`: The ARN of the finding aggregator to delete. To obtain the ARN,
  use ListFindingAggregators.

"""
function delete_finding_aggregator(
    FindingAggregatorArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "DELETE",
        "/findingAggregator/delete/$(FindingAggregatorArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_finding_aggregator(
    FindingAggregatorArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securityhub(
        "DELETE",
        "/findingAggregator/delete/$(FindingAggregatorArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_insight(insight_arn)
    delete_insight(insight_arn, params::Dict{String,<:Any})

Deletes the insight specified by the InsightArn.

# Arguments
- `insight_arn`: The ARN of the insight to delete.

"""
function delete_insight(InsightArn; aws_config::AbstractAWSConfig=current_aws_config())
    return securityhub(
        "DELETE",
        "/insights/$(InsightArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_insight(
    InsightArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securityhub(
        "DELETE",
        "/insights/$(InsightArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_invitations(account_ids)
    delete_invitations(account_ids, params::Dict{String,<:Any})

Deletes invitations received by the Amazon Web Services account to become a member account.
A Security Hub administrator account can use this operation to delete invitations sent to
one or more member accounts. This operation is only used to delete invitations that are
sent to member accounts that aren't part of an organization. Organization accounts don't
receive invitations.

# Arguments
- `account_ids`: The list of member account IDs that received the invitations you want to
  delete.

"""
function delete_invitations(AccountIds; aws_config::AbstractAWSConfig=current_aws_config())
    return securityhub(
        "POST",
        "/invitations/delete",
        Dict{String,Any}("AccountIds" => AccountIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_invitations(
    AccountIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securityhub(
        "POST",
        "/invitations/delete",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AccountIds" => AccountIds), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_members(account_ids)
    delete_members(account_ids, params::Dict{String,<:Any})

Deletes the specified member accounts from Security Hub. You can invoke this API only to
delete accounts that became members through invitation. You can't invoke this API to delete
accounts that belong to an Organizations organization.

# Arguments
- `account_ids`: The list of account IDs for the member accounts to delete.

"""
function delete_members(AccountIds; aws_config::AbstractAWSConfig=current_aws_config())
    return securityhub(
        "POST",
        "/members/delete",
        Dict{String,Any}("AccountIds" => AccountIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_members(
    AccountIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securityhub(
        "POST",
        "/members/delete",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AccountIds" => AccountIds), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_action_targets()
    describe_action_targets(params::Dict{String,<:Any})

Returns a list of the custom action targets in Security Hub in your account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ActionTargetArns"`: A list of custom action target ARNs for the custom action targets
  to retrieve.
- `"MaxResults"`: The maximum number of results to return.
- `"NextToken"`: The token that is required for pagination. On your first call to the
  DescribeActionTargets operation, set the value of this parameter to NULL. For subsequent
  calls to the operation, to continue listing data, set the value of this parameter to the
  value returned from the previous response.
"""
function describe_action_targets(; aws_config::AbstractAWSConfig=current_aws_config())
    return securityhub(
        "POST", "/actionTargets/get"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_action_targets(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "POST",
        "/actionTargets/get",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_hub()
    describe_hub(params::Dict{String,<:Any})

Returns details about the Hub resource in your account, including the HubArn and the time
when you enabled Security Hub.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"HubArn"`: The ARN of the Hub resource to retrieve.
"""
function describe_hub(; aws_config::AbstractAWSConfig=current_aws_config())
    return securityhub(
        "GET", "/accounts"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_hub(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "GET", "/accounts", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_organization_configuration()
    describe_organization_configuration(params::Dict{String,<:Any})

Returns information about the way your organization is configured in Security Hub. Only the
Security Hub administrator account can invoke this operation.

"""
function describe_organization_configuration(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "GET",
        "/organization/configuration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_organization_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "GET",
        "/organization/configuration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_products()
    describe_products(params::Dict{String,<:Any})

Returns information about product integrations in Security Hub. You can optionally provide
an integration ARN. If you provide an integration ARN, then the results only include that
integration. If you do not provide an integration ARN, then the results include all of the
available product integrations.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to return.
- `"NextToken"`: The token that is required for pagination. On your first call to the
  DescribeProducts operation, set the value of this parameter to NULL. For subsequent calls
  to the operation, to continue listing data, set the value of this parameter to the value
  returned from the previous response.
- `"ProductArn"`: The ARN of the integration to return.
"""
function describe_products(; aws_config::AbstractAWSConfig=current_aws_config())
    return securityhub(
        "GET", "/products"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_products(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "GET", "/products", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_standards()
    describe_standards(params::Dict{String,<:Any})

Returns a list of the available standards in Security Hub. For each standard, the results
include the standard ARN, the name, and a description.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of standards to return.
- `"NextToken"`: The token that is required for pagination. On your first call to the
  DescribeStandards operation, set the value of this parameter to NULL. For subsequent calls
  to the operation, to continue listing data, set the value of this parameter to the value
  returned from the previous response.
"""
function describe_standards(; aws_config::AbstractAWSConfig=current_aws_config())
    return securityhub(
        "GET", "/standards"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_standards(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "GET", "/standards", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_standards_controls(standards_subscription_arn)
    describe_standards_controls(standards_subscription_arn, params::Dict{String,<:Any})

Returns a list of security standards controls. For each control, the results include
information about whether it is currently enabled, the severity, and a link to remediation
information.

# Arguments
- `standards_subscription_arn`: The ARN of a resource that represents your subscription to
  a supported standard. To get the subscription ARNs of the standards you have enabled, use
  the GetEnabledStandards operation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of security standard controls to return.
- `"NextToken"`: The token that is required for pagination. On your first call to the
  DescribeStandardsControls operation, set the value of this parameter to NULL. For
  subsequent calls to the operation, to continue listing data, set the value of this
  parameter to the value returned from the previous response.
"""
function describe_standards_controls(
    StandardsSubscriptionArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "GET",
        "/standards/controls/$(StandardsSubscriptionArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_standards_controls(
    StandardsSubscriptionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securityhub(
        "GET",
        "/standards/controls/$(StandardsSubscriptionArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disable_import_findings_for_product(product_subscription_arn)
    disable_import_findings_for_product(product_subscription_arn, params::Dict{String,<:Any})

Disables the integration of the specified product with Security Hub. After the integration
is disabled, findings from that product are no longer sent to Security Hub.

# Arguments
- `product_subscription_arn`: The ARN of the integrated product to disable the integration
  for.

"""
function disable_import_findings_for_product(
    ProductSubscriptionArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "DELETE",
        "/productSubscriptions/$(ProductSubscriptionArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disable_import_findings_for_product(
    ProductSubscriptionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securityhub(
        "DELETE",
        "/productSubscriptions/$(ProductSubscriptionArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disable_organization_admin_account(admin_account_id)
    disable_organization_admin_account(admin_account_id, params::Dict{String,<:Any})

Disables a Security Hub administrator account. Can only be called by the organization
management account.

# Arguments
- `admin_account_id`: The Amazon Web Services account identifier of the Security Hub
  administrator account.

"""
function disable_organization_admin_account(
    AdminAccountId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "POST",
        "/organization/admin/disable",
        Dict{String,Any}("AdminAccountId" => AdminAccountId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disable_organization_admin_account(
    AdminAccountId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securityhub(
        "POST",
        "/organization/admin/disable",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AdminAccountId" => AdminAccountId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disable_security_hub()
    disable_security_hub(params::Dict{String,<:Any})

Disables Security Hub in your account only in the current Amazon Web Services Region. To
disable Security Hub in all Regions, you must submit one request per Region where you have
enabled Security Hub. You can't disable Security Hub in an account that is currently the
Security Hub administrator. When you disable Security Hub, your existing findings and
insights and any Security Hub configuration settings are deleted after 90 days and cannot
be recovered. Any standards that were enabled are disabled, and your administrator and
member account associations are removed. If you want to save your existing findings, you
must export them before you disable Security Hub.

"""
function disable_security_hub(; aws_config::AbstractAWSConfig=current_aws_config())
    return securityhub(
        "DELETE", "/accounts"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function disable_security_hub(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "DELETE",
        "/accounts",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_from_administrator_account()
    disassociate_from_administrator_account(params::Dict{String,<:Any})

Disassociates the current Security Hub member account from the associated administrator
account. This operation is only used by accounts that are not part of an organization. For
organization accounts, only the administrator account can disassociate a member account.

"""
function disassociate_from_administrator_account(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "POST",
        "/administrator/disassociate";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_from_administrator_account(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "POST",
        "/administrator/disassociate",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_from_master_account()
    disassociate_from_master_account(params::Dict{String,<:Any})

This method is deprecated. Instead, use DisassociateFromAdministratorAccount. The Security
Hub console continues to use DisassociateFromMasterAccount. It will eventually change to
use DisassociateFromAdministratorAccount. Any IAM policies that specifically control access
to this function must continue to use DisassociateFromMasterAccount. You should also add
DisassociateFromAdministratorAccount to your policies to ensure that the correct
permissions are in place after the console begins to use
DisassociateFromAdministratorAccount. Disassociates the current Security Hub member account
from the associated administrator account. This operation is only used by accounts that are
not part of an organization. For organization accounts, only the administrator account can
disassociate a member account.

"""
function disassociate_from_master_account(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "POST",
        "/master/disassociate";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_from_master_account(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "POST",
        "/master/disassociate",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_members(account_ids)
    disassociate_members(account_ids, params::Dict{String,<:Any})

Disassociates the specified member accounts from the associated administrator account. Can
be used to disassociate both accounts that are managed using Organizations and accounts
that were invited manually.

# Arguments
- `account_ids`: The account IDs of the member accounts to disassociate from the
  administrator account.

"""
function disassociate_members(
    AccountIds; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "POST",
        "/members/disassociate",
        Dict{String,Any}("AccountIds" => AccountIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_members(
    AccountIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securityhub(
        "POST",
        "/members/disassociate",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AccountIds" => AccountIds), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    enable_import_findings_for_product(product_arn)
    enable_import_findings_for_product(product_arn, params::Dict{String,<:Any})

Enables the integration of a partner product with Security Hub. Integrated products send
findings to Security Hub. When you enable a product integration, a permissions policy that
grants permission for the product to send findings to Security Hub is applied.

# Arguments
- `product_arn`: The ARN of the product to enable the integration for.

"""
function enable_import_findings_for_product(
    ProductArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "POST",
        "/productSubscriptions",
        Dict{String,Any}("ProductArn" => ProductArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function enable_import_findings_for_product(
    ProductArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securityhub(
        "POST",
        "/productSubscriptions",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ProductArn" => ProductArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    enable_organization_admin_account(admin_account_id)
    enable_organization_admin_account(admin_account_id, params::Dict{String,<:Any})

Designates the Security Hub administrator account for an organization. Can only be called
by the organization management account.

# Arguments
- `admin_account_id`: The Amazon Web Services account identifier of the account to
  designate as the Security Hub administrator account.

"""
function enable_organization_admin_account(
    AdminAccountId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "POST",
        "/organization/admin/enable",
        Dict{String,Any}("AdminAccountId" => AdminAccountId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function enable_organization_admin_account(
    AdminAccountId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securityhub(
        "POST",
        "/organization/admin/enable",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AdminAccountId" => AdminAccountId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    enable_security_hub()
    enable_security_hub(params::Dict{String,<:Any})

Enables Security Hub for your account in the current Region or the Region you specify in
the request. When you enable Security Hub, you grant to Security Hub the permissions
necessary to gather findings from other services that are integrated with Security Hub.
When you use the EnableSecurityHub operation to enable Security Hub, you also automatically
enable the following standards:   Center for Internet Security (CIS) Amazon Web Services
Foundations Benchmark v1.2.0   Amazon Web Services Foundational Security Best Practices
Other standards are not automatically enabled.  To opt out of automatically enabled
standards, set EnableDefaultStandards to false. After you enable Security Hub, to enable a
standard, use the BatchEnableStandards operation. To disable a standard, use the
BatchDisableStandards operation. To learn more, see the setup information in the Security
Hub User Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ControlFindingGenerator"`: This field, used when enabling Security Hub, specifies
  whether the calling account has consolidated control findings turned on. If the value for
  this field is set to SECURITY_CONTROL, Security Hub generates a single finding for a
  control check even when the check applies to multiple enabled standards. If the value for
  this field is set to STANDARD_CONTROL, Security Hub generates separate findings for a
  control check when the check applies to multiple enabled standards. The value for this
  field in a member account matches the value in the administrator account. For accounts that
  aren't part of an organization, the default value of this field is SECURITY_CONTROL if you
  enabled Security Hub on or after February 23, 2023.
- `"EnableDefaultStandards"`: Whether to enable the security standards that Security Hub
  has designated as automatically enabled. If you do not provide a value for
  EnableDefaultStandards, it is set to true. To not enable the automatically enabled
  standards, set EnableDefaultStandards to false.
- `"Tags"`: The tags to add to the hub resource when you enable Security Hub.
"""
function enable_security_hub(; aws_config::AbstractAWSConfig=current_aws_config())
    return securityhub(
        "POST", "/accounts"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function enable_security_hub(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "POST", "/accounts", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_administrator_account()
    get_administrator_account(params::Dict{String,<:Any})

Provides the details for the Security Hub administrator account for the current member
account. Can be used by both member accounts that are managed using Organizations and
accounts that were invited manually.

"""
function get_administrator_account(; aws_config::AbstractAWSConfig=current_aws_config())
    return securityhub(
        "GET", "/administrator"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_administrator_account(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "GET",
        "/administrator",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_configuration_policy(identifier)
    get_configuration_policy(identifier, params::Dict{String,<:Any})

 Provides information about a configuration policy. Only the Security Hub delegated
administrator can invoke this operation from the home Region.

# Arguments
- `identifier`:  The Amazon Resource Name (ARN) or universally unique identifier (UUID) of
  the configuration policy.

"""
function get_configuration_policy(
    Identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "GET",
        "/configurationPolicy/get/$(Identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_configuration_policy(
    Identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securityhub(
        "GET",
        "/configurationPolicy/get/$(Identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_configuration_policy_association(target)
    get_configuration_policy_association(target, params::Dict{String,<:Any})

 Returns the association between a configuration and a target account, organizational unit,
or the root. The configuration can be a configuration policy or self-managed behavior. Only
the Security Hub delegated administrator can invoke this operation from the home Region.

# Arguments
- `target`:  The target account ID, organizational unit ID, or the root ID to retrieve the
  association for.

"""
function get_configuration_policy_association(
    Target; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "POST",
        "/configurationPolicyAssociation/get",
        Dict{String,Any}("Target" => Target);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_configuration_policy_association(
    Target, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "POST",
        "/configurationPolicyAssociation/get",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Target" => Target), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_enabled_standards()
    get_enabled_standards(params::Dict{String,<:Any})

Returns a list of the standards that are currently enabled.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to return in the response.
- `"NextToken"`: The token that is required for pagination. On your first call to the
  GetEnabledStandards operation, set the value of this parameter to NULL. For subsequent
  calls to the operation, to continue listing data, set the value of this parameter to the
  value returned from the previous response.
- `"StandardsSubscriptionArns"`: The list of the standards subscription ARNs for the
  standards to retrieve.
"""
function get_enabled_standards(; aws_config::AbstractAWSConfig=current_aws_config())
    return securityhub(
        "POST", "/standards/get"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_enabled_standards(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "POST",
        "/standards/get",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_finding_aggregator(finding_aggregator_arn)
    get_finding_aggregator(finding_aggregator_arn, params::Dict{String,<:Any})

Returns the current finding aggregation configuration.

# Arguments
- `finding_aggregator_arn`: The ARN of the finding aggregator to return details for. To
  obtain the ARN, use ListFindingAggregators.

"""
function get_finding_aggregator(
    FindingAggregatorArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "GET",
        "/findingAggregator/get/$(FindingAggregatorArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_finding_aggregator(
    FindingAggregatorArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securityhub(
        "GET",
        "/findingAggregator/get/$(FindingAggregatorArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_finding_history(finding_identifier)
    get_finding_history(finding_identifier, params::Dict{String,<:Any})

 Returns history for a Security Hub finding in the last 90 days. The history includes
changes made to any fields in the Amazon Web Services Security Finding Format (ASFF).

# Arguments
- `finding_identifier`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EndTime"`:  An ISO 8601-formatted timestamp that indicates the end time of the
  requested finding history. If you provide values for both StartTime and EndTime, Security
  Hub returns finding history for the specified time period. If you provide a value for
  StartTime but not for EndTime, Security Hub returns finding history from the StartTime to
  the time at which the API is called. If you provide a value for EndTime but not for
  StartTime, Security Hub returns finding history from the CreatedAt timestamp of the finding
  to the EndTime. If you provide neither StartTime nor EndTime, Security Hub returns finding
  history from the CreatedAt timestamp of the finding to the time at which the API is called.
  In all of these scenarios, the response is limited to 100 results, and the maximum time
  period is limited to 90 days. This field accepts only the specified formats. Timestamps can
  end with Z or (\"+\" / \"-\") time-hour [\":\" time-minute]. The time-secfrac after seconds
  is limited to a maximum of 9 digits. The offset is bounded by +/-18:00. Here are valid
  timestamp formats with examples:    YYYY-MM-DDTHH:MM:SSZ (for example,
  2019-01-31T23:00:00Z)    YYYY-MM-DDTHH:MM:SS.mmmmmmmmmZ (for example,
  2019-01-31T23:00:00.123456789Z)    YYYY-MM-DDTHH:MM:SS+HH:MM (for example,
  2024-01-04T15:25:10+17:59)    YYYY-MM-DDTHH:MM:SS-HHMM (for example,
  2024-01-04T15:25:10-1759)    YYYY-MM-DDTHH:MM:SS.mmmmmmmmm+HH:MM (for example,
  2024-01-04T15:25:10.123456789+17:59)
- `"MaxResults"`:  The maximum number of results to be returned. If you don’t provide it,
  Security Hub returns up to 100 results of finding history.
- `"NextToken"`:  A token for pagination purposes. Provide NULL as the initial value. In
  subsequent requests, provide the token included in the response to get up to an additional
  100 results of finding history. If you don’t provide NextToken, Security Hub returns up
  to 100 results of finding history for each request.
- `"StartTime"`: A timestamp that indicates the start time of the requested finding
  history. If you provide values for both StartTime and EndTime, Security Hub returns finding
  history for the specified time period. If you provide a value for StartTime but not for
  EndTime, Security Hub returns finding history from the StartTime to the time at which the
  API is called. If you provide a value for EndTime but not for StartTime, Security Hub
  returns finding history from the CreatedAt timestamp of the finding to the EndTime. If you
  provide neither StartTime nor EndTime, Security Hub returns finding history from the
  CreatedAt timestamp of the finding to the time at which the API is called. In all of these
  scenarios, the response is limited to 100 results, and the maximum time period is limited
  to 90 days. This field accepts only the specified formats. Timestamps can end with Z or
  (\"+\" / \"-\") time-hour [\":\" time-minute]. The time-secfrac after seconds is limited to
  a maximum of 9 digits. The offset is bounded by +/-18:00. Here are valid timestamp formats
  with examples:    YYYY-MM-DDTHH:MM:SSZ (for example, 2019-01-31T23:00:00Z)
  YYYY-MM-DDTHH:MM:SS.mmmmmmmmmZ (for example, 2019-01-31T23:00:00.123456789Z)
  YYYY-MM-DDTHH:MM:SS+HH:MM (for example, 2024-01-04T15:25:10+17:59)
  YYYY-MM-DDTHH:MM:SS-HHMM (for example, 2024-01-04T15:25:10-1759)
  YYYY-MM-DDTHH:MM:SS.mmmmmmmmm+HH:MM (for example, 2024-01-04T15:25:10.123456789+17:59)
"""
function get_finding_history(
    FindingIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "POST",
        "/findingHistory/get",
        Dict{String,Any}("FindingIdentifier" => FindingIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_finding_history(
    FindingIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securityhub(
        "POST",
        "/findingHistory/get",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("FindingIdentifier" => FindingIdentifier), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_findings()
    get_findings(params::Dict{String,<:Any})

Returns a list of findings that match the specified criteria. If finding aggregation is
enabled, then when you call GetFindings from the aggregation Region, the results include
all of the matching findings from both the aggregation Region and the linked Regions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: The finding attributes used to define a condition to filter the returned
  findings. You can filter by up to 10 finding attributes. For each attribute, you can
  provide up to 20 filter values. Note that in the available filter fields, WorkflowState is
  deprecated. To search for a finding based on its workflow status, use WorkflowStatus.
- `"MaxResults"`: The maximum number of findings to return.
- `"NextToken"`: The token that is required for pagination. On your first call to the
  GetFindings operation, set the value of this parameter to NULL. For subsequent calls to the
  operation, to continue listing data, set the value of this parameter to the value returned
  from the previous response.
- `"SortCriteria"`: The finding attributes used to sort the list of returned findings.
"""
function get_findings(; aws_config::AbstractAWSConfig=current_aws_config())
    return securityhub(
        "POST", "/findings"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_findings(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "POST", "/findings", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_insight_results(insight_arn)
    get_insight_results(insight_arn, params::Dict{String,<:Any})

Lists the results of the Security Hub insight specified by the insight ARN.

# Arguments
- `insight_arn`: The ARN of the insight for which to return results.

"""
function get_insight_results(InsightArn; aws_config::AbstractAWSConfig=current_aws_config())
    return securityhub(
        "GET",
        "/insights/results/$(InsightArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_insight_results(
    InsightArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securityhub(
        "GET",
        "/insights/results/$(InsightArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_insights()
    get_insights(params::Dict{String,<:Any})

Lists and describes insights for the specified insight ARNs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"InsightArns"`: The ARNs of the insights to describe. If you do not provide any insight
  ARNs, then GetInsights returns all of your custom insights. It does not return any managed
  insights.
- `"MaxResults"`: The maximum number of items to return in the response.
- `"NextToken"`: The token that is required for pagination. On your first call to the
  GetInsights operation, set the value of this parameter to NULL. For subsequent calls to the
  operation, to continue listing data, set the value of this parameter to the value returned
  from the previous response.
"""
function get_insights(; aws_config::AbstractAWSConfig=current_aws_config())
    return securityhub(
        "POST", "/insights/get"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_insights(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "POST",
        "/insights/get",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_invitations_count()
    get_invitations_count(params::Dict{String,<:Any})

Returns the count of all Security Hub membership invitations that were sent to the current
member account, not including the currently accepted invitation.

"""
function get_invitations_count(; aws_config::AbstractAWSConfig=current_aws_config())
    return securityhub(
        "GET", "/invitations/count"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_invitations_count(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "GET",
        "/invitations/count",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_master_account()
    get_master_account(params::Dict{String,<:Any})

This method is deprecated. Instead, use GetAdministratorAccount. The Security Hub console
continues to use GetMasterAccount. It will eventually change to use
GetAdministratorAccount. Any IAM policies that specifically control access to this function
must continue to use GetMasterAccount. You should also add GetAdministratorAccount to your
policies to ensure that the correct permissions are in place after the console begins to
use GetAdministratorAccount. Provides the details for the Security Hub administrator
account for the current member account. Can be used by both member accounts that are
managed using Organizations and accounts that were invited manually.

"""
function get_master_account(; aws_config::AbstractAWSConfig=current_aws_config())
    return securityhub(
        "GET", "/master"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_master_account(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "GET", "/master", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_members(account_ids)
    get_members(account_ids, params::Dict{String,<:Any})

Returns the details for the Security Hub member accounts for the specified account IDs. An
administrator account can be either the delegated Security Hub administrator account for an
organization or an administrator account that enabled Security Hub manually. The results
include both member accounts that are managed using Organizations and accounts that were
invited manually.

# Arguments
- `account_ids`: The list of account IDs for the Security Hub member accounts to return the
  details for.

"""
function get_members(AccountIds; aws_config::AbstractAWSConfig=current_aws_config())
    return securityhub(
        "POST",
        "/members/get",
        Dict{String,Any}("AccountIds" => AccountIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_members(
    AccountIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securityhub(
        "POST",
        "/members/get",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AccountIds" => AccountIds), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_security_control_definition(security_control_id)
    get_security_control_definition(security_control_id, params::Dict{String,<:Any})

 Retrieves the definition of a security control. The definition includes the control title,
description, Region availability, parameter definitions, and other details.

# Arguments
- `security_control_id`:  The ID of the security control to retrieve the definition for.
  This field doesn’t accept an Amazon Resource Name (ARN).

"""
function get_security_control_definition(
    SecurityControlId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "GET",
        "/securityControl/definition",
        Dict{String,Any}("SecurityControlId" => SecurityControlId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_security_control_definition(
    SecurityControlId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securityhub(
        "GET",
        "/securityControl/definition",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("SecurityControlId" => SecurityControlId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    invite_members(account_ids)
    invite_members(account_ids, params::Dict{String,<:Any})

Invites other Amazon Web Services accounts to become member accounts for the Security Hub
administrator account that the invitation is sent from. This operation is only used to
invite accounts that do not belong to an organization. Organization accounts do not receive
invitations. Before you can use this action to invite a member, you must first use the
CreateMembers action to create the member account in Security Hub. When the account owner
enables Security Hub and accepts the invitation to become a member account, the
administrator account can view the findings generated from the member account.

# Arguments
- `account_ids`: The list of account IDs of the Amazon Web Services accounts to invite to
  Security Hub as members.

"""
function invite_members(AccountIds; aws_config::AbstractAWSConfig=current_aws_config())
    return securityhub(
        "POST",
        "/members/invite",
        Dict{String,Any}("AccountIds" => AccountIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function invite_members(
    AccountIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securityhub(
        "POST",
        "/members/invite",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AccountIds" => AccountIds), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_automation_rules()
    list_automation_rules(params::Dict{String,<:Any})

 A list of automation rules and their metadata for the calling account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`:  The maximum number of rules to return in the response. This currently
  ranges from 1 to 100.
- `"NextToken"`:  A token to specify where to start paginating the response. This is the
  NextToken from a previously truncated response. On your first call to the
  ListAutomationRules API, set the value of this parameter to NULL.
"""
function list_automation_rules(; aws_config::AbstractAWSConfig=current_aws_config())
    return securityhub(
        "GET",
        "/automationrules/list";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_automation_rules(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "GET",
        "/automationrules/list",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_configuration_policies()
    list_configuration_policies(params::Dict{String,<:Any})

 Lists the configuration policies that the Security Hub delegated administrator has created
for your organization. Only the delegated administrator can invoke this operation from the
home Region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`:  The maximum number of results that's returned by
  ListConfigurationPolicies in each page of the response. When this parameter is used,
  ListConfigurationPolicies returns the specified number of results in a single page and a
  NextToken response element. You can see the remaining results of the initial request by
  sending another ListConfigurationPolicies request with the returned NextToken value. A
  valid range for MaxResults is between 1 and 100.
- `"NextToken"`:  The NextToken value that's returned from a previous paginated
  ListConfigurationPolicies request where MaxResults was used but the results exceeded the
  value of that parameter. Pagination continues from the MaxResults was used but the results
  exceeded the value of that parameter. Pagination continues from the end of the previous
  response that returned the NextToken value. This value is null when there are no more
  results to return.
"""
function list_configuration_policies(; aws_config::AbstractAWSConfig=current_aws_config())
    return securityhub(
        "GET",
        "/configurationPolicy/list";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_configuration_policies(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "GET",
        "/configurationPolicy/list",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_configuration_policy_associations()
    list_configuration_policy_associations(params::Dict{String,<:Any})

 Provides information about the associations for your configuration policies and
self-managed behavior. Only the Security Hub delegated administrator can invoke this
operation from the home Region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`:  Options for filtering the ListConfigurationPolicyAssociations response. You
  can filter by the Amazon Resource Name (ARN) or universally unique identifier (UUID) of a
  configuration, AssociationType, or AssociationStatus.
- `"MaxResults"`:  The maximum number of results that's returned by
  ListConfigurationPolicies in each page of the response. When this parameter is used,
  ListConfigurationPolicyAssociations returns the specified number of results in a single
  page and a NextToken response element. You can see the remaining results of the initial
  request by sending another ListConfigurationPolicyAssociations request with the returned
  NextToken value. A valid range for MaxResults is between 1 and 100.
- `"NextToken"`:  The NextToken value that's returned from a previous paginated
  ListConfigurationPolicyAssociations request where MaxResults was used but the results
  exceeded the value of that parameter. Pagination continues from the end of the previous
  response that returned the NextToken value. This value is null when there are no more
  results to return.
"""
function list_configuration_policy_associations(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "POST",
        "/configurationPolicyAssociation/list";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_configuration_policy_associations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "POST",
        "/configurationPolicyAssociation/list",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_enabled_products_for_import()
    list_enabled_products_for_import(params::Dict{String,<:Any})

Lists all findings-generating solutions (products) that you are subscribed to receive
findings from in Security Hub.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of items to return in the response.
- `"NextToken"`: The token that is required for pagination. On your first call to the
  ListEnabledProductsForImport operation, set the value of this parameter to NULL. For
  subsequent calls to the operation, to continue listing data, set the value of this
  parameter to the value returned from the previous response.
"""
function list_enabled_products_for_import(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "GET",
        "/productSubscriptions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_enabled_products_for_import(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "GET",
        "/productSubscriptions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_finding_aggregators()
    list_finding_aggregators(params::Dict{String,<:Any})

If finding aggregation is enabled, then ListFindingAggregators returns the ARN of the
finding aggregator. You can run this operation from any Region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to return. This operation currently only
  returns a single result.
- `"NextToken"`: The token returned with the previous set of results. Identifies the next
  set of results to return.
"""
function list_finding_aggregators(; aws_config::AbstractAWSConfig=current_aws_config())
    return securityhub(
        "GET",
        "/findingAggregator/list";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_finding_aggregators(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "GET",
        "/findingAggregator/list",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_invitations()
    list_invitations(params::Dict{String,<:Any})

Lists all Security Hub membership invitations that were sent to the current Amazon Web
Services account. This operation is only used by accounts that are managed by invitation.
Accounts that are managed using the integration with Organizations do not receive
invitations.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of items to return in the response.
- `"NextToken"`: The token that is required for pagination. On your first call to the
  ListInvitations operation, set the value of this parameter to NULL. For subsequent calls to
  the operation, to continue listing data, set the value of this parameter to the value
  returned from the previous response.
"""
function list_invitations(; aws_config::AbstractAWSConfig=current_aws_config())
    return securityhub(
        "GET", "/invitations"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_invitations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "GET",
        "/invitations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_members()
    list_members(params::Dict{String,<:Any})

Lists details about all member accounts for the current Security Hub administrator account.
The results include both member accounts that belong to an organization and member accounts
that were invited manually.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of items to return in the response.
- `"NextToken"`: The token that is required for pagination. On your first call to the
  ListMembers operation, set the value of this parameter to NULL. For subsequent calls to the
  operation, to continue listing data, set the value of this parameter to the value returned
  from the previous response.
- `"OnlyAssociated"`: Specifies which member accounts to include in the response based on
  their relationship status with the administrator account. The default value is TRUE. If
  OnlyAssociated is set to TRUE, the response includes member accounts whose relationship
  status with the administrator account is set to ENABLED. If OnlyAssociated is set to FALSE,
  the response includes all existing member accounts.
"""
function list_members(; aws_config::AbstractAWSConfig=current_aws_config())
    return securityhub(
        "GET", "/members"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_members(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "GET", "/members", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_organization_admin_accounts()
    list_organization_admin_accounts(params::Dict{String,<:Any})

Lists the Security Hub administrator accounts. Can only be called by the organization
management account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of items to return in the response.
- `"NextToken"`: The token that is required for pagination. On your first call to the
  ListOrganizationAdminAccounts operation, set the value of this parameter to NULL. For
  subsequent calls to the operation, to continue listing data, set the value of this
  parameter to the value returned from the previous response.
"""
function list_organization_admin_accounts(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "GET", "/organization/admin"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_organization_admin_accounts(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "GET",
        "/organization/admin",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_security_control_definitions()
    list_security_control_definitions(params::Dict{String,<:Any})

 Lists all of the security controls that apply to a specified standard.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`:  An optional parameter that limits the total results of the API response
  to the specified number. If this parameter isn't provided in the request, the results
  include the first 25 security controls that apply to the specified standard. The results
  also include a NextToken parameter that you can use in a subsequent API call to get the
  next 25 controls. This repeats until all controls for the standard are returned.
- `"NextToken"`:  Optional pagination parameter.
- `"StandardsArn"`:  The Amazon Resource Name (ARN) of the standard that you want to view
  controls for.
"""
function list_security_control_definitions(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "GET",
        "/securityControls/definitions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_security_control_definitions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "GET",
        "/securityControls/definitions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_standards_control_associations(security_control_id)
    list_standards_control_associations(security_control_id, params::Dict{String,<:Any})

 Specifies whether a control is currently enabled or disabled in each enabled standard in
the calling account.

# Arguments
- `security_control_id`:  The identifier of the control (identified with SecurityControlId,
  SecurityControlArn, or a mix of both parameters) that you want to determine the enablement
  status of in each enabled standard.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`:  An optional parameter that limits the total results of the API response
  to the specified number. If this parameter isn't provided in the request, the results
  include the first 25 standard and control associations. The results also include a
  NextToken parameter that you can use in a subsequent API call to get the next 25
  associations. This repeats until all associations for the specified control are returned.
  The number of results is limited by the number of supported Security Hub standards that
  you've enabled in the calling account.
- `"NextToken"`:  Optional pagination parameter.
"""
function list_standards_control_associations(
    SecurityControlId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "GET",
        "/associations",
        Dict{String,Any}("SecurityControlId" => SecurityControlId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_standards_control_associations(
    SecurityControlId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securityhub(
        "GET",
        "/associations",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("SecurityControlId" => SecurityControlId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Returns a list of tags associated with a resource.

# Arguments
- `resource_arn`: The ARN of the resource to retrieve tags for.

"""
function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "GET",
        "/tags/$(ResourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securityhub(
        "GET",
        "/tags/$(ResourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_configuration_policy_association(configuration_policy_identifier, target)
    start_configuration_policy_association(configuration_policy_identifier, target, params::Dict{String,<:Any})

 Associates a target account, organizational unit, or the root with a specified
configuration. The target can be associated with a configuration policy or self-managed
behavior. Only the Security Hub delegated administrator can invoke this operation from the
home Region.

# Arguments
- `configuration_policy_identifier`:  The Amazon Resource Name (ARN) of a configuration
  policy, the universally unique identifier (UUID) of a configuration policy, or a value of
  SELF_MANAGED_SECURITY_HUB for a self-managed configuration.
- `target`:  The identifier of the target account, organizational unit, or the root to
  associate with the specified configuration.

"""
function start_configuration_policy_association(
    ConfigurationPolicyIdentifier,
    Target;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securityhub(
        "POST",
        "/configurationPolicyAssociation/associate",
        Dict{String,Any}(
            "ConfigurationPolicyIdentifier" => ConfigurationPolicyIdentifier,
            "Target" => Target,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_configuration_policy_association(
    ConfigurationPolicyIdentifier,
    Target,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securityhub(
        "POST",
        "/configurationPolicyAssociation/associate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ConfigurationPolicyIdentifier" => ConfigurationPolicyIdentifier,
                    "Target" => Target,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_configuration_policy_disassociation(configuration_policy_identifier)
    start_configuration_policy_disassociation(configuration_policy_identifier, params::Dict{String,<:Any})

 Disassociates a target account, organizational unit, or the root from a specified
configuration. When you disassociate a configuration from its target, the target inherits
the configuration of the closest parent. If there’s no configuration to inherit, the
target retains its settings but becomes a self-managed account. A target can be
disassociated from a configuration policy or self-managed behavior. Only the Security Hub
delegated administrator can invoke this operation from the home Region.

# Arguments
- `configuration_policy_identifier`:  The Amazon Resource Name (ARN) of a configuration
  policy, the universally unique identifier (UUID) of a configuration policy, or a value of
  SELF_MANAGED_SECURITY_HUB for a self-managed configuration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Target"`:  The identifier of the target account, organizational unit, or the root to
  disassociate from the specified configuration.
"""
function start_configuration_policy_disassociation(
    ConfigurationPolicyIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "POST",
        "/configurationPolicyAssociation/disassociate",
        Dict{String,Any}("ConfigurationPolicyIdentifier" => ConfigurationPolicyIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_configuration_policy_disassociation(
    ConfigurationPolicyIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securityhub(
        "POST",
        "/configurationPolicyAssociation/disassociate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ConfigurationPolicyIdentifier" => ConfigurationPolicyIdentifier
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds one or more tags to a resource.

# Arguments
- `resource_arn`: The ARN of the resource to apply the tags to.
- `tags`: The tags to add to the resource. You can add up to 50 tags at a time. The tag
  keys can be no longer than 128 characters. The tag values can be no longer than 256
  characters.

"""
function tag_resource(ResourceArn, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return securityhub(
        "POST",
        "/tags/$(ResourceArn)",
        Dict{String,Any}("Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceArn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securityhub(
        "POST",
        "/tags/$(ResourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Tags" => Tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes one or more tags from a resource.

# Arguments
- `resource_arn`: The ARN of the resource to remove the tags from.
- `tag_keys`: The tag keys associated with the tags to remove from the resource. You can
  remove up to 50 tags at a time.

"""
function untag_resource(
    ResourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "DELETE",
        "/tags/$(ResourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securityhub(
        "DELETE",
        "/tags/$(ResourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_action_target(action_target_arn)
    update_action_target(action_target_arn, params::Dict{String,<:Any})

Updates the name and description of a custom action target in Security Hub.

# Arguments
- `action_target_arn`: The ARN of the custom action target to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: The updated description for the custom action target.
- `"Name"`: The updated name of the custom action target.
"""
function update_action_target(
    ActionTargetArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "PATCH",
        "/actionTargets/$(ActionTargetArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_action_target(
    ActionTargetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securityhub(
        "PATCH",
        "/actionTargets/$(ActionTargetArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_configuration_policy(identifier)
    update_configuration_policy(identifier, params::Dict{String,<:Any})

 Updates a configuration policy. Only the Security Hub delegated administrator can invoke
this operation from the home Region.

# Arguments
- `identifier`:  The Amazon Resource Name (ARN) or universally unique identifier (UUID) of
  the configuration policy.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConfigurationPolicy"`:  An object that defines how Security Hub is configured. It
  includes whether Security Hub is enabled or disabled, a list of enabled security standards,
  a list of enabled or disabled security controls, and a list of custom parameter values for
  specified controls. If you provide a list of security controls that are enabled in the
  configuration policy, Security Hub disables all other controls (including newly released
  controls). If you provide a list of security controls that are disabled in the
  configuration policy, Security Hub enables all other controls (including newly released
  controls).  When updating a configuration policy, provide a complete list of standards that
  you want to enable and a complete list of controls that you want to enable or disable. The
  updated configuration replaces the current configuration.
- `"Description"`:  The description of the configuration policy.
- `"Name"`:  The name of the configuration policy. Alphanumeric characters and the
  following ASCII characters are permitted: -, ., !, *, /.
- `"UpdatedReason"`:  The reason for updating the configuration policy.
"""
function update_configuration_policy(
    Identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "PATCH",
        "/configurationPolicy/$(Identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_configuration_policy(
    Identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securityhub(
        "PATCH",
        "/configurationPolicy/$(Identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_finding_aggregator(finding_aggregator_arn, region_linking_mode)
    update_finding_aggregator(finding_aggregator_arn, region_linking_mode, params::Dict{String,<:Any})

Updates the finding aggregation configuration. Used to update the Region linking mode and
the list of included or excluded Regions. You cannot use UpdateFindingAggregator to change
the aggregation Region. You must run UpdateFindingAggregator from the current aggregation
Region.

# Arguments
- `finding_aggregator_arn`: The ARN of the finding aggregator. To obtain the ARN, use
  ListFindingAggregators.
- `region_linking_mode`: Indicates whether to aggregate findings from all of the available
  Regions in the current partition. Also determines whether to automatically aggregate
  findings from new Regions as Security Hub supports them and you opt into them. The selected
  option also determines how to use the Regions provided in the Regions list. The options are
  as follows:    ALL_REGIONS - Indicates to aggregate findings from all of the Regions where
  Security Hub is enabled. When you choose this option, Security Hub also automatically
  aggregates findings from new Regions as Security Hub supports them and you opt into them.
    ALL_REGIONS_EXCEPT_SPECIFIED - Indicates to aggregate findings from all of the Regions
  where Security Hub is enabled, except for the Regions listed in the Regions parameter. When
  you choose this option, Security Hub also automatically aggregates findings from new
  Regions as Security Hub supports them and you opt into them.     SPECIFIED_REGIONS -
  Indicates to aggregate findings only from the Regions listed in the Regions parameter.
  Security Hub does not automatically aggregate findings from new Regions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Regions"`: If RegionLinkingMode is ALL_REGIONS_EXCEPT_SPECIFIED, then this is a
  space-separated list of Regions that do not aggregate findings to the aggregation Region.
  If RegionLinkingMode is SPECIFIED_REGIONS, then this is a space-separated list of Regions
  that do aggregate findings to the aggregation Region.
"""
function update_finding_aggregator(
    FindingAggregatorArn,
    RegionLinkingMode;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securityhub(
        "PATCH",
        "/findingAggregator/update",
        Dict{String,Any}(
            "FindingAggregatorArn" => FindingAggregatorArn,
            "RegionLinkingMode" => RegionLinkingMode,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_finding_aggregator(
    FindingAggregatorArn,
    RegionLinkingMode,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securityhub(
        "PATCH",
        "/findingAggregator/update",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "FindingAggregatorArn" => FindingAggregatorArn,
                    "RegionLinkingMode" => RegionLinkingMode,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_findings(filters)
    update_findings(filters, params::Dict{String,<:Any})

 UpdateFindings is a deprecated operation. Instead of UpdateFindings, use the
BatchUpdateFindings operation. Updates the Note and RecordState of the Security
Hub-aggregated findings that the filter attributes specify. Any member account that can
view the finding also sees the update to the finding. Finding updates made with
UpdateFindings might not be persisted if the same finding is later updated by the finding
provider through the BatchImportFindings operation.

# Arguments
- `filters`: A collection of attributes that specify which findings you want to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Note"`: The updated note for the finding.
- `"RecordState"`: The updated record state for the finding.
"""
function update_findings(Filters; aws_config::AbstractAWSConfig=current_aws_config())
    return securityhub(
        "PATCH",
        "/findings",
        Dict{String,Any}("Filters" => Filters);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_findings(
    Filters,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securityhub(
        "PATCH",
        "/findings",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Filters" => Filters), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_insight(insight_arn)
    update_insight(insight_arn, params::Dict{String,<:Any})

Updates the Security Hub insight identified by the specified insight ARN.

# Arguments
- `insight_arn`: The ARN of the insight that you want to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: The updated filters that define this insight.
- `"GroupByAttribute"`: The updated GroupBy attribute that defines this insight.
- `"Name"`: The updated name for the insight.
"""
function update_insight(InsightArn; aws_config::AbstractAWSConfig=current_aws_config())
    return securityhub(
        "PATCH",
        "/insights/$(InsightArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_insight(
    InsightArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securityhub(
        "PATCH",
        "/insights/$(InsightArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_organization_configuration(auto_enable)
    update_organization_configuration(auto_enable, params::Dict{String,<:Any})

Updates the configuration of your organization in Security Hub. Only the Security Hub
administrator account can invoke this operation.

# Arguments
- `auto_enable`: Whether to automatically enable Security Hub in new member accounts when
  they join the organization. If set to true, then Security Hub is automatically enabled in
  new accounts. If set to false, then Security Hub isn't enabled in new accounts
  automatically. The default value is false. If the ConfigurationType of your organization is
  set to CENTRAL, then this field is set to false and can't be changed in the home Region and
  linked Regions. However, in that case, the delegated administrator can create a
  configuration policy in which Security Hub is enabled and associate the policy with new
  organization accounts.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AutoEnableStandards"`: Whether to automatically enable Security Hub default standards
  in new member accounts when they join the organization. The default value of this parameter
  is equal to DEFAULT. If equal to DEFAULT, then Security Hub default standards are
  automatically enabled for new member accounts. If equal to NONE, then default standards are
  not automatically enabled for new member accounts. If the ConfigurationType of your
  organization is set to CENTRAL, then this field is set to NONE and can't be changed in the
  home Region and linked Regions. However, in that case, the delegated administrator can
  create a configuration policy in which specific security standards are enabled and
  associate the policy with new organization accounts.
- `"OrganizationConfiguration"`:
"""
function update_organization_configuration(
    AutoEnable; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "POST",
        "/organization/configuration",
        Dict{String,Any}("AutoEnable" => AutoEnable);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_organization_configuration(
    AutoEnable,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securityhub(
        "POST",
        "/organization/configuration",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AutoEnable" => AutoEnable), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_security_control(parameters, security_control_id)
    update_security_control(parameters, security_control_id, params::Dict{String,<:Any})

 Updates the properties of a security control.

# Arguments
- `parameters`:  An object that specifies which security control parameters to update.
- `security_control_id`:  The Amazon Resource Name (ARN) or ID of the control to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"LastUpdateReason"`:  The most recent reason for updating the properties of the security
  control. This field accepts alphanumeric characters in addition to white spaces, dashes,
  and underscores.
"""
function update_security_control(
    Parameters, SecurityControlId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "PATCH",
        "/securityControl/update",
        Dict{String,Any}(
            "Parameters" => Parameters, "SecurityControlId" => SecurityControlId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_security_control(
    Parameters,
    SecurityControlId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securityhub(
        "PATCH",
        "/securityControl/update",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Parameters" => Parameters, "SecurityControlId" => SecurityControlId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_security_hub_configuration()
    update_security_hub_configuration(params::Dict{String,<:Any})

Updates configuration options for Security Hub.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AutoEnableControls"`: Whether to automatically enable new controls when they are added
  to standards that are enabled. By default, this is set to true, and new controls are
  enabled automatically. To not automatically enable new controls, set this to false.
- `"ControlFindingGenerator"`: Updates whether the calling account has consolidated control
  findings turned on. If the value for this field is set to SECURITY_CONTROL, Security Hub
  generates a single finding for a control check even when the check applies to multiple
  enabled standards. If the value for this field is set to STANDARD_CONTROL, Security Hub
  generates separate findings for a control check when the check applies to multiple enabled
  standards. For accounts that are part of an organization, this value can only be updated in
  the administrator account.
"""
function update_security_hub_configuration(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "PATCH", "/accounts"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function update_security_hub_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "PATCH", "/accounts", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    update_standards_control(standards_control_arn)
    update_standards_control(standards_control_arn, params::Dict{String,<:Any})

Used to control whether an individual security standard control is enabled or disabled.

# Arguments
- `standards_control_arn`: The ARN of the security standard control to enable or disable.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ControlStatus"`: The updated status of the security standard control.
- `"DisabledReason"`: A description of the reason why you are disabling a security standard
  control. If you are disabling a control, then this is required.
"""
function update_standards_control(
    StandardsControlArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return securityhub(
        "PATCH",
        "/standards/control/$(StandardsControlArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_standards_control(
    StandardsControlArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return securityhub(
        "PATCH",
        "/standards/control/$(StandardsControlArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

@testset "_merge - AbstractDict" begin
    @testset "Simple" begin
        expected = Dict("a" => 1, "b" => 2)

        a = Dict("a" => 1)
        b = Dict("b" => 2)

        @test AWS._merge(a, b) == expected
    end

    @testset "Complex Different Nested Dict Keys" begin
        expected = Dict("common" => Dict("b" => 2))

        a = Dict("common" => Dict("a" => 1))
        b = Dict("common" => Dict("b" => 2))

        @test AWS._merge(a, b) == expected
    end

    @testset "Complex Same Nested Dict Keys" begin
        expected = Dict("common" => Dict("a" => 2))

        a1 = Dict("common" => Dict("a" => 1))
        a2 = Dict("common" => Dict("a" => 2))

        @test AWS._merge(a1, a2) == expected
    end
end

@testset "mergewith(_merge) - AbstractDict" begin
    @testset "Simple" begin
        expected = Dict("a" => 1, "b" => 2)

        a = Dict("a" => 1)
        b = Dict("b" => 2)

        @test mergewith(AWS._merge, a, b) == expected
    end

    @testset "Complex Differed Nested Dict Keys" begin
        expected = Dict("common" => Dict("a" => 1, "b" => 2))

        a = Dict("common" => Dict("a" => 1))
        b = Dict("common" => Dict("b" => 2))

        @test mergewith(AWS._merge, a, b) == expected
    end

    @testset "Complex Same Nested Dict Keys" begin
        expected = Dict("common" => Dict("a" => 2))

        a1 = Dict("common" => Dict("a" => 1))
        a2 = Dict("common" => Dict("a" => 2))

        @test mergewith(AWS._merge, a1, a2) == expected
    end
end

@testset "_merge - AbstractString" begin
    expected = "b"

    @test AWS._merge("a", "b") == expected
end

@testset "_assignment_to_kw!" begin
    @testset "non-expression" begin
        ex = :(true)
        @test_throws ArgumentError AWS._assignment_to_kw!(ex)
    end

    @testset "non-assignment" begin
        ex = :(a => true)
        @test_throws ArgumentError AWS._assignment_to_kw!(ex)
    end

    @testset "assignment" begin
        ex = :(a = true)
        @test AWS._assignment_to_kw!(ex) == Expr(:kw, :a, true)
        @test ex == Expr(:kw, :a, true)
    end
end

# Count the elements in an iterator without using `length`
function count_len(itr)
    c = 0
    for _ in itr
        c += 1
    end
    return c
end

@testset "AWSExponentialBackoff" begin
    for (n, max_backoff) in [(3, 5.0), (10, 20.0)]
        itr = AWS.AWSExponentialBackoff(;
            max_attempts=n, max_backoff=max_backoff, rng=StableRNG(1)
        )
        @test count_len(itr) == n - 1
        @test length(collect(itr)) == n - 1
        @test all(>(0), itr)
        @test all(<=(max_backoff), itr)
    end
end

@testset "_clean_s3_uri" begin
    @test AWS._clean_s3_uri("/ !'()*+,:=@") == "/%20%21%27%28%29%2A%2B%2C%3A%3D%40"
    @test AWS._clean_s3_uri("/bucket/!'()*+,:=@ /file") ==
        "/bucket/%21%27%28%29%2A%2B%2C%3A%3D%40%20/file"
    @test AWS._clean_s3_uri("/📁/📁") == "/%F0%9F%93%81/%F0%9F%93%81"
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: finspace_data
using AWS.Compat
using AWS.UUIDs

"""
    associate_user_to_permission_group(permission_group_id, user_id)
    associate_user_to_permission_group(permission_group_id, user_id, params::Dict{String,<:Any})

Adds a user to a permission group to grant permissions for actions a user can perform in
FinSpace.

# Arguments
- `permission_group_id`: The unique identifier for the permission group.
- `user_id`: The unique identifier for the user.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A token that ensures idempotency. This token expires in 10 minutes.
"""
function associate_user_to_permission_group(
    permissionGroupId, userId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return finspace_data(
        "POST",
        "/permission-group/$(permissionGroupId)/users/$(userId)",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_user_to_permission_group(
    permissionGroupId,
    userId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace_data(
        "POST",
        "/permission-group/$(permissionGroupId)/users/$(userId)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_changeset(change_type, dataset_id, format_params, source_params)
    create_changeset(change_type, dataset_id, format_params, source_params, params::Dict{String,<:Any})

Creates a new Changeset in a FinSpace Dataset.

# Arguments
- `change_type`: The option to indicate how a Changeset will be applied to a Dataset.
  REPLACE – Changeset will be considered as a replacement to all prior loaded Changesets.
   APPEND – Changeset will be considered as an addition to the end of all prior loaded
  Changesets.    MODIFY – Changeset is considered as a replacement to a specific prior
  ingested Changeset.
- `dataset_id`: The unique identifier for the FinSpace Dataset where the Changeset will be
  created.
- `format_params`: Options that define the structure of the source file(s) including the
  format type (formatType), header row (withHeader), data separation character (separator)
  and the type of compression (compression).   formatType is a required attribute and can
  have the following values:     PARQUET – Parquet source file format.    CSV – CSV
  source file format.    JSON – JSON source file format.    XML – XML source file format.
    Here is an example of how you could specify the formatParams:   \"formatParams\": {
  \"formatType\": \"CSV\", \"withHeader\": \"true\", \"separator\": \",\",
  \"compression\":\"None\" }   Note that if you only provide formatType as CSV, the rest of
  the attributes will automatically default to CSV values as following:   { \"withHeader\":
  \"true\", \"separator\": \",\" }    For more information about supported file formats, see
  Supported Data Types and File Formats in the FinSpace User Guide.
- `source_params`: Options that define the location of the data being ingested
  (s3SourcePath) and the source of the changeset (sourceType). Both s3SourcePath and
  sourceType are required attributes. Here is an example of how you could specify the
  sourceParams:   \"sourceParams\": { \"s3SourcePath\":
  \"s3://finspace-landing-us-east-2-bk7gcfvitndqa6ebnvys4d/scratch/wr5hh8pwkpqqkxa4sxrmcw/inge
  stion/equity.csv\", \"sourceType\": \"S3\" }   The S3 path that you specify must allow the
  FinSpace role access. To do that, you first need to configure the IAM policy on S3 bucket.
  For more information, see Loading data from an Amazon S3 Bucket using the FinSpace API
  section.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A token that ensures idempotency. This token expires in 10 minutes.
"""
function create_changeset(
    changeType,
    datasetId,
    formatParams,
    sourceParams;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace_data(
        "POST",
        "/datasets/$(datasetId)/changesetsv2",
        Dict{String,Any}(
            "changeType" => changeType,
            "formatParams" => formatParams,
            "sourceParams" => sourceParams,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_changeset(
    changeType,
    datasetId,
    formatParams,
    sourceParams,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace_data(
        "POST",
        "/datasets/$(datasetId)/changesetsv2",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "changeType" => changeType,
                    "formatParams" => formatParams,
                    "sourceParams" => sourceParams,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_data_view(dataset_id, destination_type_params)
    create_data_view(dataset_id, destination_type_params, params::Dict{String,<:Any})

Creates a Dataview for a Dataset.

# Arguments
- `dataset_id`: The unique Dataset identifier that is used to create a Dataview.
- `destination_type_params`: Options that define the destination type for the Dataview.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"asOfTimestamp"`: Beginning time to use for the Dataview. The value is determined as
  epoch time in milliseconds. For example, the value for Monday, November 1, 2021 12:00:00 PM
  UTC is specified as 1635768000000.
- `"autoUpdate"`: Flag to indicate Dataview should be updated automatically.
- `"clientToken"`: A token that ensures idempotency. This token expires in 10 minutes.
- `"partitionColumns"`: Ordered set of column names used to partition data.
- `"sortColumns"`: Columns to be used for sorting the data.
"""
function create_data_view(
    datasetId, destinationTypeParams; aws_config::AbstractAWSConfig=current_aws_config()
)
    return finspace_data(
        "POST",
        "/datasets/$(datasetId)/dataviewsv2",
        Dict{String,Any}(
            "destinationTypeParams" => destinationTypeParams,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_data_view(
    datasetId,
    destinationTypeParams,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace_data(
        "POST",
        "/datasets/$(datasetId)/dataviewsv2",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "destinationTypeParams" => destinationTypeParams,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_dataset(dataset_title, kind, permission_group_params)
    create_dataset(dataset_title, kind, permission_group_params, params::Dict{String,<:Any})

Creates a new FinSpace Dataset.

# Arguments
- `dataset_title`: Display title for a FinSpace Dataset.
- `kind`: The format in which Dataset data is structured.    TABULAR – Data is structured
  in a tabular format.    NON_TABULAR – Data is structured in a non-tabular format.
- `permission_group_params`: Permission group parameters for Dataset permissions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"alias"`: The unique resource identifier for a Dataset.
- `"clientToken"`: A token that ensures idempotency. This token expires in 10 minutes.
- `"datasetDescription"`: Description of a Dataset.
- `"ownerInfo"`: Contact information for a Dataset owner.
- `"schemaDefinition"`: Definition for a schema on a tabular Dataset.
"""
function create_dataset(
    datasetTitle,
    kind,
    permissionGroupParams;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace_data(
        "POST",
        "/datasetsv2",
        Dict{String,Any}(
            "datasetTitle" => datasetTitle,
            "kind" => kind,
            "permissionGroupParams" => permissionGroupParams,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_dataset(
    datasetTitle,
    kind,
    permissionGroupParams,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace_data(
        "POST",
        "/datasetsv2",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "datasetTitle" => datasetTitle,
                    "kind" => kind,
                    "permissionGroupParams" => permissionGroupParams,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_permission_group(application_permissions, name)
    create_permission_group(application_permissions, name, params::Dict{String,<:Any})

Creates a group of permissions for various actions that a user can perform in FinSpace.

# Arguments
- `application_permissions`: The option to indicate FinSpace application permissions that
  are granted to a specific group.  When assigning application permissions, be aware that the
  permission ManageUsersAndGroups allows users to grant themselves or others access to any
  functionality in their FinSpace environment's application. It should only be granted to
  trusted users.     CreateDataset – Group members can create new datasets.
  ManageClusters – Group members can manage Apache Spark clusters from FinSpace notebooks.
    ManageUsersAndGroups – Group members can manage users and permission groups. This is a
  privileged permission that allows users to grant themselves or others access to any
  functionality in the application. It should only be granted to trusted users.
  ManageAttributeSets – Group members can manage attribute sets.    ViewAuditData – Group
  members can view audit data.    AccessNotebooks – Group members will have access to
  FinSpace notebooks.    GetTemporaryCredentials – Group members can get temporary API
  credentials.
- `name`: The name of the permission group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A token that ensures idempotency. This token expires in 10 minutes.
- `"description"`: A brief description for the permission group.
"""
function create_permission_group(
    applicationPermissions, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return finspace_data(
        "POST",
        "/permission-group",
        Dict{String,Any}(
            "applicationPermissions" => applicationPermissions,
            "name" => name,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_permission_group(
    applicationPermissions,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace_data(
        "POST",
        "/permission-group",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "applicationPermissions" => applicationPermissions,
                    "name" => name,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_user(email_address, type)
    create_user(email_address, type, params::Dict{String,<:Any})

Creates a new user in FinSpace.

# Arguments
- `email_address`: The email address of the user that you want to register. The email
  address serves as a uniquer identifier for each user and cannot be changed after it's
  created.
- `type`: The option to indicate the type of user. Use one of the following options to
  specify this parameter:    SUPER_USER – A user with permission to all the functionality
  and data in FinSpace.    APP_USER – A user with specific permissions in FinSpace. The
  users are assigned permissions by adding them to a permission group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"apiAccess"`: The option to indicate whether the user can use the
  GetProgrammaticAccessCredentials API to obtain credentials that can then be used to access
  other FinSpace Data API operations.    ENABLED – The user has permissions to use the
  APIs.    DISABLED – The user does not have permissions to use any APIs.
- `"apiAccessPrincipalArn"`: The ARN identifier of an AWS user or role that is allowed to
  call the GetProgrammaticAccessCredentials API to obtain a credentials token for a specific
  FinSpace user. This must be an IAM role within your FinSpace account.
- `"clientToken"`: A token that ensures idempotency. This token expires in 10 minutes.
- `"firstName"`: The first name of the user that you want to register.
- `"lastName"`: The last name of the user that you want to register.
"""
function create_user(emailAddress, type; aws_config::AbstractAWSConfig=current_aws_config())
    return finspace_data(
        "POST",
        "/user",
        Dict{String,Any}(
            "emailAddress" => emailAddress, "type" => type, "clientToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_user(
    emailAddress,
    type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace_data(
        "POST",
        "/user",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "emailAddress" => emailAddress,
                    "type" => type,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_dataset(dataset_id)
    delete_dataset(dataset_id, params::Dict{String,<:Any})

Deletes a FinSpace Dataset.

# Arguments
- `dataset_id`: The unique identifier of the Dataset to be deleted.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A token that ensures idempotency. This token expires in 10 minutes.
"""
function delete_dataset(datasetId; aws_config::AbstractAWSConfig=current_aws_config())
    return finspace_data(
        "DELETE",
        "/datasetsv2/$(datasetId)",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_dataset(
    datasetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace_data(
        "DELETE",
        "/datasetsv2/$(datasetId)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_permission_group(permission_group_id)
    delete_permission_group(permission_group_id, params::Dict{String,<:Any})

Deletes a permission group. This action is irreversible.

# Arguments
- `permission_group_id`: The unique identifier for the permission group that you want to
  delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A token that ensures idempotency. This token expires in 10 minutes.
"""
function delete_permission_group(
    permissionGroupId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return finspace_data(
        "DELETE",
        "/permission-group/$(permissionGroupId)",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_permission_group(
    permissionGroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace_data(
        "DELETE",
        "/permission-group/$(permissionGroupId)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disable_user(user_id)
    disable_user(user_id, params::Dict{String,<:Any})

Denies access to the FinSpace web application and API for the specified user.

# Arguments
- `user_id`: The unique identifier for the user that you want to deactivate.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A token that ensures idempotency. This token expires in 10 minutes.
"""
function disable_user(userId; aws_config::AbstractAWSConfig=current_aws_config())
    return finspace_data(
        "POST",
        "/user/$(userId)/disable",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disable_user(
    userId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return finspace_data(
        "POST",
        "/user/$(userId)/disable",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_user_from_permission_group(permission_group_id, user_id)
    disassociate_user_from_permission_group(permission_group_id, user_id, params::Dict{String,<:Any})

Removes a user from a permission group.

# Arguments
- `permission_group_id`: The unique identifier for the permission group.
- `user_id`: The unique identifier for the user.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A token that ensures idempotency. This token expires in 10 minutes.
"""
function disassociate_user_from_permission_group(
    permissionGroupId, userId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return finspace_data(
        "DELETE",
        "/permission-group/$(permissionGroupId)/users/$(userId)",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_user_from_permission_group(
    permissionGroupId,
    userId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace_data(
        "DELETE",
        "/permission-group/$(permissionGroupId)/users/$(userId)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    enable_user(user_id)
    enable_user(user_id, params::Dict{String,<:Any})

 Allows the specified user to access the FinSpace web application and API.

# Arguments
- `user_id`: The unique identifier for the user that you want to activate.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A token that ensures idempotency. This token expires in 10 minutes.
"""
function enable_user(userId; aws_config::AbstractAWSConfig=current_aws_config())
    return finspace_data(
        "POST",
        "/user/$(userId)/enable",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function enable_user(
    userId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return finspace_data(
        "POST",
        "/user/$(userId)/enable",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_changeset(changeset_id, dataset_id)
    get_changeset(changeset_id, dataset_id, params::Dict{String,<:Any})

Get information about a Changeset.

# Arguments
- `changeset_id`: The unique identifier of the Changeset for which to get data.
- `dataset_id`: The unique identifier for the FinSpace Dataset where the Changeset is
  created.

"""
function get_changeset(
    changesetId, datasetId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return finspace_data(
        "GET",
        "/datasets/$(datasetId)/changesetsv2/$(changesetId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_changeset(
    changesetId,
    datasetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace_data(
        "GET",
        "/datasets/$(datasetId)/changesetsv2/$(changesetId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_data_view(dataset_id, dataview_id)
    get_data_view(dataset_id, dataview_id, params::Dict{String,<:Any})

Gets information about a Dataview.

# Arguments
- `dataset_id`: The unique identifier for the Dataset used in the Dataview.
- `dataview_id`: The unique identifier for the Dataview.

"""
function get_data_view(
    datasetId, dataviewId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return finspace_data(
        "GET",
        "/datasets/$(datasetId)/dataviewsv2/$(dataviewId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_data_view(
    datasetId,
    dataviewId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace_data(
        "GET",
        "/datasets/$(datasetId)/dataviewsv2/$(dataviewId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_dataset(dataset_id)
    get_dataset(dataset_id, params::Dict{String,<:Any})

Returns information about a Dataset.

# Arguments
- `dataset_id`: The unique identifier for a Dataset.

"""
function get_dataset(datasetId; aws_config::AbstractAWSConfig=current_aws_config())
    return finspace_data(
        "GET",
        "/datasetsv2/$(datasetId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_dataset(
    datasetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace_data(
        "GET",
        "/datasetsv2/$(datasetId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_external_data_view_access_details(dataset_id, dataview_id)
    get_external_data_view_access_details(dataset_id, dataview_id, params::Dict{String,<:Any})

Returns the credentials to access the external Dataview from an S3 location. To call this
API:   You must retrieve the programmatic credentials.   You must be a member of a FinSpace
user group, where the dataset that you want to access has Read Dataset Data permissions.

# Arguments
- `dataset_id`: The unique identifier for the Dataset.
- `dataview_id`: The unique identifier for the Dataview that you want to access.

"""
function get_external_data_view_access_details(
    datasetId, dataviewId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return finspace_data(
        "POST",
        "/datasets/$(datasetId)/dataviewsv2/$(dataviewId)/external-access-details";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_external_data_view_access_details(
    datasetId,
    dataviewId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace_data(
        "POST",
        "/datasets/$(datasetId)/dataviewsv2/$(dataviewId)/external-access-details",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_permission_group(permission_group_id)
    get_permission_group(permission_group_id, params::Dict{String,<:Any})

Retrieves the details of a specific permission group.

# Arguments
- `permission_group_id`: The unique identifier for the permission group.

"""
function get_permission_group(
    permissionGroupId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return finspace_data(
        "GET",
        "/permission-group/$(permissionGroupId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_permission_group(
    permissionGroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace_data(
        "GET",
        "/permission-group/$(permissionGroupId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_programmatic_access_credentials(environment_id)
    get_programmatic_access_credentials(environment_id, params::Dict{String,<:Any})

Request programmatic credentials to use with FinSpace SDK. For more information, see Step
2. Access credentials programmatically using IAM access key id and secret access key.

# Arguments
- `environment_id`: The FinSpace environment identifier.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"durationInMinutes"`: The time duration in which the credentials remain valid.
"""
function get_programmatic_access_credentials(
    environmentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return finspace_data(
        "GET",
        "/credentials/programmatic",
        Dict{String,Any}("environmentId" => environmentId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_programmatic_access_credentials(
    environmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace_data(
        "GET",
        "/credentials/programmatic",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("environmentId" => environmentId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_user(user_id)
    get_user(user_id, params::Dict{String,<:Any})

Retrieves details for a specific user.

# Arguments
- `user_id`: The unique identifier of the user to get data for.

"""
function get_user(userId; aws_config::AbstractAWSConfig=current_aws_config())
    return finspace_data(
        "GET", "/user/$(userId)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_user(
    userId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return finspace_data(
        "GET",
        "/user/$(userId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_working_location()
    get_working_location(params::Dict{String,<:Any})

A temporary Amazon S3 location, where you can copy your files from a source location to
stage or use as a scratch space in FinSpace notebook.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"locationType"`: Specify the type of the working location.    SAGEMAKER – Use the
  Amazon S3 location as a temporary location to store data content when working with FinSpace
  Notebooks that run on SageMaker studio.    INGESTION – Use the Amazon S3 location as a
  staging location to copy your data content and then use the location with the Changeset
  creation operation.
"""
function get_working_location(; aws_config::AbstractAWSConfig=current_aws_config())
    return finspace_data(
        "POST", "/workingLocationV1"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_working_location(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return finspace_data(
        "POST",
        "/workingLocationV1",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_changesets(dataset_id)
    list_changesets(dataset_id, params::Dict{String,<:Any})

Lists the FinSpace Changesets for a Dataset.

# Arguments
- `dataset_id`: The unique identifier for the FinSpace Dataset to which the Changeset
  belongs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results per page.
- `"nextToken"`: A token that indicates where a results page should begin.
"""
function list_changesets(datasetId; aws_config::AbstractAWSConfig=current_aws_config())
    return finspace_data(
        "GET",
        "/datasets/$(datasetId)/changesetsv2";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_changesets(
    datasetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace_data(
        "GET",
        "/datasets/$(datasetId)/changesetsv2",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_data_views(dataset_id)
    list_data_views(dataset_id, params::Dict{String,<:Any})

Lists all available Dataviews for a Dataset.

# Arguments
- `dataset_id`: The unique identifier of the Dataset for which to retrieve Dataviews.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results per page.
- `"nextToken"`: A token that indicates where a results page should begin.
"""
function list_data_views(datasetId; aws_config::AbstractAWSConfig=current_aws_config())
    return finspace_data(
        "GET",
        "/datasets/$(datasetId)/dataviewsv2";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_data_views(
    datasetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace_data(
        "GET",
        "/datasets/$(datasetId)/dataviewsv2",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_datasets()
    list_datasets(params::Dict{String,<:Any})

Lists all of the active Datasets that a user has access to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results per page.
- `"nextToken"`: A token that indicates where a results page should begin.
"""
function list_datasets(; aws_config::AbstractAWSConfig=current_aws_config())
    return finspace_data(
        "GET", "/datasetsv2"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_datasets(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return finspace_data(
        "GET", "/datasetsv2", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_permission_groups(max_results)
    list_permission_groups(max_results, params::Dict{String,<:Any})

Lists all available permission groups in FinSpace.

# Arguments
- `max_results`: The maximum number of results per page.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: A token that indicates where a results page should begin.
"""
function list_permission_groups(
    maxResults; aws_config::AbstractAWSConfig=current_aws_config()
)
    return finspace_data(
        "GET",
        "/permission-group",
        Dict{String,Any}("maxResults" => maxResults);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_permission_groups(
    maxResults,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace_data(
        "GET",
        "/permission-group",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("maxResults" => maxResults), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_permission_groups_by_user(max_results, user_id)
    list_permission_groups_by_user(max_results, user_id, params::Dict{String,<:Any})

Lists all the permission groups that are associated with a specific user.

# Arguments
- `max_results`: The maximum number of results per page.
- `user_id`: The unique identifier for the user.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: A token that indicates where a results page should begin.
"""
function list_permission_groups_by_user(
    maxResults, userId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return finspace_data(
        "GET",
        "/user/$(userId)/permission-groups",
        Dict{String,Any}("maxResults" => maxResults);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_permission_groups_by_user(
    maxResults,
    userId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace_data(
        "GET",
        "/user/$(userId)/permission-groups",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("maxResults" => maxResults), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_users(max_results)
    list_users(max_results, params::Dict{String,<:Any})

Lists all available users in FinSpace.

# Arguments
- `max_results`: The maximum number of results per page.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: A token that indicates where a results page should begin.
"""
function list_users(maxResults; aws_config::AbstractAWSConfig=current_aws_config())
    return finspace_data(
        "GET",
        "/user",
        Dict{String,Any}("maxResults" => maxResults);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_users(
    maxResults,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace_data(
        "GET",
        "/user",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("maxResults" => maxResults), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_users_by_permission_group(max_results, permission_group_id)
    list_users_by_permission_group(max_results, permission_group_id, params::Dict{String,<:Any})

Lists details of all the users in a specific permission group.

# Arguments
- `max_results`: The maximum number of results per page.
- `permission_group_id`: The unique identifier for the permission group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: A token that indicates where a results page should begin.
"""
function list_users_by_permission_group(
    maxResults, permissionGroupId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return finspace_data(
        "GET",
        "/permission-group/$(permissionGroupId)/users",
        Dict{String,Any}("maxResults" => maxResults);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_users_by_permission_group(
    maxResults,
    permissionGroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace_data(
        "GET",
        "/permission-group/$(permissionGroupId)/users",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("maxResults" => maxResults), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    reset_user_password(user_id)
    reset_user_password(user_id, params::Dict{String,<:Any})

Resets the password for a specified user ID and generates a temporary one. Only a superuser
can reset password for other users. Resetting the password immediately invalidates the
previous password associated with the user.

# Arguments
- `user_id`: The unique identifier of the user that a temporary password is requested for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A token that ensures idempotency. This token expires in 10 minutes.
"""
function reset_user_password(userId; aws_config::AbstractAWSConfig=current_aws_config())
    return finspace_data(
        "POST",
        "/user/$(userId)/password",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function reset_user_password(
    userId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return finspace_data(
        "POST",
        "/user/$(userId)/password",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_changeset(changeset_id, dataset_id, format_params, source_params)
    update_changeset(changeset_id, dataset_id, format_params, source_params, params::Dict{String,<:Any})

Updates a FinSpace Changeset.

# Arguments
- `changeset_id`: The unique identifier for the Changeset to update.
- `dataset_id`: The unique identifier for the FinSpace Dataset in which the Changeset is
  created.
- `format_params`: Options that define the structure of the source file(s) including the
  format type (formatType), header row (withHeader), data separation character (separator)
  and the type of compression (compression).   formatType is a required attribute and can
  have the following values:     PARQUET – Parquet source file format.    CSV – CSV
  source file format.    JSON – JSON source file format.    XML – XML source file format.
    Here is an example of how you could specify the formatParams:   \"formatParams\": {
  \"formatType\": \"CSV\", \"withHeader\": \"true\", \"separator\": \",\",
  \"compression\":\"None\" }   Note that if you only provide formatType as CSV, the rest of
  the attributes will automatically default to CSV values as following:   { \"withHeader\":
  \"true\", \"separator\": \",\" }    For more information about supported file formats, see
  Supported Data Types and File Formats in the FinSpace User Guide.
- `source_params`: Options that define the location of the data being ingested
  (s3SourcePath) and the source of the changeset (sourceType). Both s3SourcePath and
  sourceType are required attributes. Here is an example of how you could specify the
  sourceParams:   \"sourceParams\": { \"s3SourcePath\":
  \"s3://finspace-landing-us-east-2-bk7gcfvitndqa6ebnvys4d/scratch/wr5hh8pwkpqqkxa4sxrmcw/inge
  stion/equity.csv\", \"sourceType\": \"S3\" }   The S3 path that you specify must allow the
  FinSpace role access. To do that, you first need to configure the IAM policy on S3 bucket.
  For more information, see Loading data from an Amazon S3 Bucket using the FinSpace
  APIsection.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A token that ensures idempotency. This token expires in 10 minutes.
"""
function update_changeset(
    changesetId,
    datasetId,
    formatParams,
    sourceParams;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace_data(
        "PUT",
        "/datasets/$(datasetId)/changesetsv2/$(changesetId)",
        Dict{String,Any}(
            "formatParams" => formatParams,
            "sourceParams" => sourceParams,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_changeset(
    changesetId,
    datasetId,
    formatParams,
    sourceParams,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace_data(
        "PUT",
        "/datasets/$(datasetId)/changesetsv2/$(changesetId)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "formatParams" => formatParams,
                    "sourceParams" => sourceParams,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_dataset(dataset_id, dataset_title, kind)
    update_dataset(dataset_id, dataset_title, kind, params::Dict{String,<:Any})

Updates a FinSpace Dataset.

# Arguments
- `dataset_id`: The unique identifier for the Dataset to update.
- `dataset_title`: A display title for the Dataset.
- `kind`: The format in which the Dataset data is structured.    TABULAR – Data is
  structured in a tabular format.    NON_TABULAR – Data is structured in a non-tabular
  format.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"alias"`: The unique resource identifier for a Dataset.
- `"clientToken"`: A token that ensures idempotency. This token expires in 10 minutes.
- `"datasetDescription"`: A description for the Dataset.
- `"schemaDefinition"`: Definition for a schema on a tabular Dataset.
"""
function update_dataset(
    datasetId, datasetTitle, kind; aws_config::AbstractAWSConfig=current_aws_config()
)
    return finspace_data(
        "PUT",
        "/datasetsv2/$(datasetId)",
        Dict{String,Any}(
            "datasetTitle" => datasetTitle, "kind" => kind, "clientToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_dataset(
    datasetId,
    datasetTitle,
    kind,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace_data(
        "PUT",
        "/datasetsv2/$(datasetId)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "datasetTitle" => datasetTitle,
                    "kind" => kind,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_permission_group(permission_group_id)
    update_permission_group(permission_group_id, params::Dict{String,<:Any})

Modifies the details of a permission group. You cannot modify a permissionGroupID.

# Arguments
- `permission_group_id`: The unique identifier for the permission group to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"applicationPermissions"`: The permissions that are granted to a specific group for
  accessing the FinSpace application.  When assigning application permissions, be aware that
  the permission ManageUsersAndGroups allows users to grant themselves or others access to
  any functionality in their FinSpace environment's application. It should only be granted to
  trusted users.     CreateDataset – Group members can create new datasets.
  ManageClusters – Group members can manage Apache Spark clusters from FinSpace notebooks.
    ManageUsersAndGroups – Group members can manage users and permission groups. This is a
  privileged permission that allows users to grant themselves or others access to any
  functionality in the application. It should only be granted to trusted users.
  ManageAttributeSets – Group members can manage attribute sets.    ViewAuditData – Group
  members can view audit data.    AccessNotebooks – Group members will have access to
  FinSpace notebooks.    GetTemporaryCredentials – Group members can get temporary API
  credentials.
- `"clientToken"`: A token that ensures idempotency. This token expires in 10 minutes.
- `"description"`: A brief description for the permission group.
- `"name"`: The name of the permission group.
"""
function update_permission_group(
    permissionGroupId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return finspace_data(
        "PUT",
        "/permission-group/$(permissionGroupId)",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_permission_group(
    permissionGroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return finspace_data(
        "PUT",
        "/permission-group/$(permissionGroupId)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_user(user_id)
    update_user(user_id, params::Dict{String,<:Any})

Modifies the details of the specified user. You cannot update the userId for a user.

# Arguments
- `user_id`: The unique identifier for the user that you want to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"apiAccess"`: The option to indicate whether the user can use the
  GetProgrammaticAccessCredentials API to obtain credentials that can then be used to access
  other FinSpace Data API operations.    ENABLED – The user has permissions to use the
  APIs.    DISABLED – The user does not have permissions to use any APIs.
- `"apiAccessPrincipalArn"`: The ARN identifier of an AWS user or role that is allowed to
  call the GetProgrammaticAccessCredentials API to obtain a credentials token for a specific
  FinSpace user. This must be an IAM role within your FinSpace account.
- `"clientToken"`: A token that ensures idempotency. This token expires in 10 minutes.
- `"firstName"`: The first name of the user.
- `"lastName"`: The last name of the user.
- `"type"`: The option to indicate the type of user.    SUPER_USER– A user with
  permission to all the functionality and data in FinSpace.    APP_USER – A user with
  specific permissions in FinSpace. The users are assigned permissions by adding them to a
  permission group.
"""
function update_user(userId; aws_config::AbstractAWSConfig=current_aws_config())
    return finspace_data(
        "PUT",
        "/user/$(userId)",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_user(
    userId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return finspace_data(
        "PUT",
        "/user/$(userId)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: secrets_manager
using AWS.Compat
using AWS.UUIDs

"""
    batch_get_secret_value()
    batch_get_secret_value(params::Dict{String,<:Any})

Retrieves the contents of the encrypted fields SecretString or SecretBinary for up to 20
secrets. To retrieve a single secret, call GetSecretValue.  To choose which secrets to
retrieve, you can specify a list of secrets by name or ARN, or you can use filters. If
Secrets Manager encounters errors such as AccessDeniedException while attempting to
retrieve any of the secrets, you can see the errors in Errors in the response. Secrets
Manager generates CloudTrail GetSecretValue log entries for each secret you request when
you call this action. Do not include sensitive information in request parameters because it
might be logged. For more information, see Logging Secrets Manager events with CloudTrail.
Required permissions:  secretsmanager:BatchGetSecretValue, and you must have
secretsmanager:GetSecretValue for each secret. If you use filters, you must also have
secretsmanager:ListSecrets. If the secrets are encrypted using customer-managed keys
instead of the Amazon Web Services managed key aws/secretsmanager, then you also need
kms:Decrypt permissions for the keys. For more information, see  IAM policy actions for
Secrets Manager and Authentication and access control in Secrets Manager.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: The filters to choose which secrets to retrieve. You must include Filters or
  SecretIdList, but not both.
- `"MaxResults"`: The number of results to include in the response. If there are more
  results available, in the response, Secrets Manager includes NextToken. To get the next
  results, call BatchGetSecretValue again with the value from NextToken. To use this
  parameter, you must also use the Filters parameter.
- `"NextToken"`: A token that indicates where the output should continue from, if a
  previous call did not show all results. To get the next results, call BatchGetSecretValue
  again with this value.
- `"SecretIdList"`: The ARN or names of the secrets to retrieve. You must include Filters
  or SecretIdList, but not both.
"""
function batch_get_secret_value(; aws_config::AbstractAWSConfig=current_aws_config())
    return secrets_manager(
        "BatchGetSecretValue"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function batch_get_secret_value(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return secrets_manager(
        "BatchGetSecretValue",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_rotate_secret(secret_id)
    cancel_rotate_secret(secret_id, params::Dict{String,<:Any})

Turns off automatic rotation, and if a rotation is currently in progress, cancels the
rotation. If you cancel a rotation in progress, it can leave the VersionStage labels in an
unexpected state. You might need to remove the staging label AWSPENDING from the partially
created version. You also need to determine whether to roll back to the previous version of
the secret by moving the staging label AWSCURRENT to the version that has AWSPENDING. To
determine which version has a specific staging label, call ListSecretVersionIds. Then use
UpdateSecretVersionStage to change staging labels. For more information, see How rotation
works. To turn on automatic rotation again, call RotateSecret. Secrets Manager generates a
CloudTrail log entry when you call this action. Do not include sensitive information in
request parameters because it might be logged. For more information, see Logging Secrets
Manager events with CloudTrail.  Required permissions:  secretsmanager:CancelRotateSecret.
For more information, see  IAM policy actions for Secrets Manager and Authentication and
access control in Secrets Manager.

# Arguments
- `secret_id`: The ARN or name of the secret. For an ARN, we recommend that you specify a
  complete ARN rather than a partial ARN. See Finding a secret from a partial ARN.

"""
function cancel_rotate_secret(SecretId; aws_config::AbstractAWSConfig=current_aws_config())
    return secrets_manager(
        "CancelRotateSecret",
        Dict{String,Any}("SecretId" => SecretId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_rotate_secret(
    SecretId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return secrets_manager(
        "CancelRotateSecret",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("SecretId" => SecretId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_secret(name)
    create_secret(name, params::Dict{String,<:Any})

Creates a new secret. A secret can be a password, a set of credentials such as a user name
and password, an OAuth token, or other secret information that you store in an encrypted
form in Secrets Manager. The secret also includes the connection information to access a
database or other service, which Secrets Manager doesn't encrypt. A secret in Secrets
Manager consists of both the protected secret data and the important information needed to
manage the secret. For secrets that use managed rotation, you need to create the secret
through the managing service. For more information, see Secrets Manager secrets managed by
other Amazon Web Services services.  For information about creating a secret in the
console, see Create a secret. To create a secret, you can provide the secret value to be
encrypted in either the SecretString parameter or the SecretBinary parameter, but not both.
If you include SecretString or SecretBinary then Secrets Manager creates an initial secret
version and automatically attaches the staging label AWSCURRENT to it. For database
credentials you want to rotate, for Secrets Manager to be able to rotate the secret, you
must make sure the JSON you store in the SecretString matches the JSON structure of a
database secret. If you don't specify an KMS encryption key, Secrets Manager uses the
Amazon Web Services managed key aws/secretsmanager. If this key doesn't already exist in
your account, then Secrets Manager creates it for you automatically. All users and roles in
the Amazon Web Services account automatically have access to use aws/secretsmanager.
Creating aws/secretsmanager can result in a one-time significant delay in returning the
result. If the secret is in a different Amazon Web Services account from the credentials
calling the API, then you can't use aws/secretsmanager to encrypt the secret, and you must
create and use a customer managed KMS key.  Secrets Manager generates a CloudTrail log
entry when you call this action. Do not include sensitive information in request parameters
except SecretBinary or SecretString because it might be logged. For more information, see
Logging Secrets Manager events with CloudTrail.  Required permissions:
secretsmanager:CreateSecret. If you include tags in the secret, you also need
secretsmanager:TagResource. To add replica Regions, you must also have
secretsmanager:ReplicateSecretToRegions. For more information, see  IAM policy actions for
Secrets Manager and Authentication and access control in Secrets Manager.  To encrypt the
secret with a KMS key other than aws/secretsmanager, you need kms:GenerateDataKey and
kms:Decrypt permission to the key.

# Arguments
- `name`: The name of the new secret. The secret name can contain ASCII letters, numbers,
  and the following characters: /_+=.@- Do not end your secret name with a hyphen followed by
  six characters. If you do so, you risk confusion and unexpected results when searching for
  a secret by partial ARN. Secrets Manager automatically adds a hyphen and six random
  characters after the secret name at the end of the ARN.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AddReplicaRegions"`: A list of Regions and KMS keys to replicate secrets.
- `"ClientRequestToken"`: If you include SecretString or SecretBinary, then Secrets Manager
  creates an initial version for the secret, and this parameter specifies the unique
  identifier for the new version.   If you use the Amazon Web Services CLI or one of the
  Amazon Web Services SDKs to call this operation, then you can leave this parameter empty.
  The CLI or SDK generates a random UUID for you and includes it as the value for this
  parameter in the request.   If you generate a raw HTTP request to the Secrets Manager
  service endpoint, then you must generate a ClientRequestToken and include it in the
  request. This value helps ensure idempotency. Secrets Manager uses this value to prevent
  the accidental creation of duplicate versions if there are failures and retries during a
  rotation. We recommend that you generate a UUID-type value to ensure uniqueness of your
  versions within the specified secret.    If the ClientRequestToken value isn't already
  associated with a version of the secret then a new version of the secret is created.    If
  a version with this value already exists and the version SecretString and SecretBinary
  values are the same as those in the request, then the request is ignored.   If a version
  with this value already exists and that version's SecretString and SecretBinary values are
  different from those in the request, then the request fails because you cannot modify an
  existing version. Instead, use PutSecretValue to create a new version.   This value becomes
  the VersionId of the new version.
- `"Description"`: The description of the secret.
- `"ForceOverwriteReplicaSecret"`: Specifies whether to overwrite a secret with the same
  name in the destination Region. By default, secrets aren't overwritten.
- `"KmsKeyId"`: The ARN, key ID, or alias of the KMS key that Secrets Manager uses to
  encrypt the secret value in the secret. An alias is always prefixed by alias/, for example
  alias/aws/secretsmanager. For more information, see About aliases. To use a KMS key in a
  different account, use the key ARN or the alias ARN. If you don't specify this value, then
  Secrets Manager uses the key aws/secretsmanager. If that key doesn't yet exist, then
  Secrets Manager creates it for you automatically the first time it encrypts the secret
  value. If the secret is in a different Amazon Web Services account from the credentials
  calling the API, then you can't use aws/secretsmanager to encrypt the secret, and you must
  create and use a customer managed KMS key.
- `"SecretBinary"`: The binary data to encrypt and store in the new version of the secret.
  We recommend that you store your binary data in a file and then pass the contents of the
  file as a parameter. Either SecretString or SecretBinary must have a value, but not both.
  This parameter is not available in the Secrets Manager console. Sensitive: This field
  contains sensitive information, so the service does not include it in CloudTrail log
  entries. If you create your own log entries, you must also avoid logging the information in
  this field.
- `"SecretString"`: The text data to encrypt and store in this new version of the secret.
  We recommend you use a JSON structure of key/value pairs for your secret value. Either
  SecretString or SecretBinary must have a value, but not both. If you create a secret by
  using the Secrets Manager console then Secrets Manager puts the protected secret text in
  only the SecretString parameter. The Secrets Manager console stores the information as a
  JSON structure of key/value pairs that a Lambda rotation function can parse. Sensitive:
  This field contains sensitive information, so the service does not include it in CloudTrail
  log entries. If you create your own log entries, you must also avoid logging the
  information in this field.
- `"Tags"`: A list of tags to attach to the secret. Each tag is a key and value pair of
  strings in a JSON text string, for example:
  [{\"Key\":\"CostCenter\",\"Value\":\"12345\"},{\"Key\":\"environment\",\"Value\":\"productio
  n\"}]  Secrets Manager tag key names are case sensitive. A tag with the key \"ABC\" is a
  different tag from one with key \"abc\". If you check tags in permissions policies as part
  of your security strategy, then adding or removing a tag can change permissions. If the
  completion of this operation would result in you losing your permissions for this secret,
  then Secrets Manager blocks the operation and returns an Access Denied error. For more
  information, see Control access to secrets using tags and Limit access to identities with
  tags that match secrets' tags. For information about how to format a JSON parameter for the
  various command line tool environments, see Using JSON for Parameters. If your command-line
  tool or SDK requires quotation marks around the parameter, you should use single quotes to
  avoid confusion with the double quotes required in the JSON text. For tag quotas and naming
  restrictions, see Service quotas for Tagging in the Amazon Web Services General Reference
  guide.
"""
function create_secret(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return secrets_manager(
        "CreateSecret",
        Dict{String,Any}("Name" => Name, "ClientRequestToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_secret(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return secrets_manager(
        "CreateSecret",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Name" => Name, "ClientRequestToken" => string(uuid4())),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_resource_policy(secret_id)
    delete_resource_policy(secret_id, params::Dict{String,<:Any})

Deletes the resource-based permission policy attached to the secret. To attach a policy to
a secret, use PutResourcePolicy. Secrets Manager generates a CloudTrail log entry when you
call this action. Do not include sensitive information in request parameters because it
might be logged. For more information, see Logging Secrets Manager events with CloudTrail.
Required permissions:  secretsmanager:DeleteResourcePolicy. For more information, see  IAM
policy actions for Secrets Manager and Authentication and access control in Secrets
Manager.

# Arguments
- `secret_id`: The ARN or name of the secret to delete the attached resource-based policy
  for. For an ARN, we recommend that you specify a complete ARN rather than a partial ARN.
  See Finding a secret from a partial ARN.

"""
function delete_resource_policy(
    SecretId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return secrets_manager(
        "DeleteResourcePolicy",
        Dict{String,Any}("SecretId" => SecretId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_resource_policy(
    SecretId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return secrets_manager(
        "DeleteResourcePolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("SecretId" => SecretId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_secret(secret_id)
    delete_secret(secret_id, params::Dict{String,<:Any})

Deletes a secret and all of its versions. You can specify a recovery window during which
you can restore the secret. The minimum recovery window is 7 days. The default recovery
window is 30 days. Secrets Manager attaches a DeletionDate stamp to the secret that
specifies the end of the recovery window. At the end of the recovery window, Secrets
Manager deletes the secret permanently. You can't delete a primary secret that is
replicated to other Regions. You must first delete the replicas using
RemoveRegionsFromReplication, and then delete the primary secret. When you delete a
replica, it is deleted immediately. You can't directly delete a version of a secret.
Instead, you remove all staging labels from the version using UpdateSecretVersionStage.
This marks the version as deprecated, and then Secrets Manager can automatically delete the
version in the background. To determine whether an application still uses a secret, you can
create an Amazon CloudWatch alarm to alert you to any attempts to access a secret during
the recovery window. For more information, see  Monitor secrets scheduled for deletion.
Secrets Manager performs the permanent secret deletion at the end of the waiting period as
a background task with low priority. There is no guarantee of a specific time after the
recovery window for the permanent delete to occur. At any time before recovery window ends,
you can use RestoreSecret to remove the DeletionDate and cancel the deletion of the secret.
When a secret is scheduled for deletion, you cannot retrieve the secret value. You must
first cancel the deletion with RestoreSecret and then you can retrieve the secret. Secrets
Manager generates a CloudTrail log entry when you call this action. Do not include
sensitive information in request parameters because it might be logged. For more
information, see Logging Secrets Manager events with CloudTrail.  Required permissions:
secretsmanager:DeleteSecret. For more information, see  IAM policy actions for Secrets
Manager and Authentication and access control in Secrets Manager.

# Arguments
- `secret_id`: The ARN or name of the secret to delete. For an ARN, we recommend that you
  specify a complete ARN rather than a partial ARN. See Finding a secret from a partial ARN.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ForceDeleteWithoutRecovery"`: Specifies whether to delete the secret without any
  recovery window. You can't use both this parameter and RecoveryWindowInDays in the same
  call. If you don't use either, then by default Secrets Manager uses a 30 day recovery
  window. Secrets Manager performs the actual deletion with an asynchronous background
  process, so there might be a short delay before the secret is permanently deleted. If you
  delete a secret and then immediately create a secret with the same name, use appropriate
  back off and retry logic. If you forcibly delete an already deleted or nonexistent secret,
  the operation does not return ResourceNotFoundException.  Use this parameter with caution.
  This parameter causes the operation to skip the normal recovery window before the permanent
  deletion that Secrets Manager would normally impose with the RecoveryWindowInDays
  parameter. If you delete a secret with the ForceDeleteWithoutRecovery parameter, then you
  have no opportunity to recover the secret. You lose the secret permanently.
- `"RecoveryWindowInDays"`: The number of days from 7 to 30 that Secrets Manager waits
  before permanently deleting the secret. You can't use both this parameter and
  ForceDeleteWithoutRecovery in the same call. If you don't use either, then by default
  Secrets Manager uses a 30 day recovery window.
"""
function delete_secret(SecretId; aws_config::AbstractAWSConfig=current_aws_config())
    return secrets_manager(
        "DeleteSecret",
        Dict{String,Any}("SecretId" => SecretId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_secret(
    SecretId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return secrets_manager(
        "DeleteSecret",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("SecretId" => SecretId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_secret(secret_id)
    describe_secret(secret_id, params::Dict{String,<:Any})

Retrieves the details of a secret. It does not include the encrypted secret value. Secrets
Manager only returns fields that have a value in the response.  Secrets Manager generates a
CloudTrail log entry when you call this action. Do not include sensitive information in
request parameters because it might be logged. For more information, see Logging Secrets
Manager events with CloudTrail.  Required permissions:  secretsmanager:DescribeSecret. For
more information, see  IAM policy actions for Secrets Manager and Authentication and access
control in Secrets Manager.

# Arguments
- `secret_id`: The ARN or name of the secret.  For an ARN, we recommend that you specify a
  complete ARN rather than a partial ARN. See Finding a secret from a partial ARN.

"""
function describe_secret(SecretId; aws_config::AbstractAWSConfig=current_aws_config())
    return secrets_manager(
        "DescribeSecret",
        Dict{String,Any}("SecretId" => SecretId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_secret(
    SecretId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return secrets_manager(
        "DescribeSecret",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("SecretId" => SecretId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_random_password()
    get_random_password(params::Dict{String,<:Any})

Generates a random password. We recommend that you specify the maximum length and include
every character type that the system you are generating a password for can support. By
default, Secrets Manager uses uppercase and lowercase letters, numbers, and the following
characters in passwords: !\"#%&amp;'()*+,-./:;&lt;=&gt;?@[]^_`{|}~  Secrets Manager
generates a CloudTrail log entry when you call this action.  Required permissions:
secretsmanager:GetRandomPassword. For more information, see  IAM policy actions for Secrets
Manager and Authentication and access control in Secrets Manager.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ExcludeCharacters"`: A string of the characters that you don't want in the password.
- `"ExcludeLowercase"`: Specifies whether to exclude lowercase letters from the password.
  If you don't include this switch, the password can contain lowercase letters.
- `"ExcludeNumbers"`: Specifies whether to exclude numbers from the password. If you don't
  include this switch, the password can contain numbers.
- `"ExcludePunctuation"`: Specifies whether to exclude the following punctuation characters
  from the password: ! \" #  % &amp; ' ( ) * + , - . / : ; &lt; = &gt; ? @ [  ] ^ _ ` { | }
  ~. If you don't include this switch, the password can contain punctuation.
- `"ExcludeUppercase"`: Specifies whether to exclude uppercase letters from the password.
  If you don't include this switch, the password can contain uppercase letters.
- `"IncludeSpace"`: Specifies whether to include the space character. If you include this
  switch, the password can contain space characters.
- `"PasswordLength"`: The length of the password. If you don't include this parameter, the
  default length is 32 characters.
- `"RequireEachIncludedType"`: Specifies whether to include at least one upper and
  lowercase letter, one number, and one punctuation. If you don't include this switch, the
  password contains at least one of every character type.
"""
function get_random_password(; aws_config::AbstractAWSConfig=current_aws_config())
    return secrets_manager(
        "GetRandomPassword"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_random_password(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return secrets_manager(
        "GetRandomPassword", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_resource_policy(secret_id)
    get_resource_policy(secret_id, params::Dict{String,<:Any})

Retrieves the JSON text of the resource-based policy document attached to the secret. For
more information about permissions policies attached to a secret, see Permissions policies
attached to a secret. Secrets Manager generates a CloudTrail log entry when you call this
action. Do not include sensitive information in request parameters because it might be
logged. For more information, see Logging Secrets Manager events with CloudTrail.  Required
permissions:  secretsmanager:GetResourcePolicy. For more information, see  IAM policy
actions for Secrets Manager and Authentication and access control in Secrets Manager.

# Arguments
- `secret_id`: The ARN or name of the secret to retrieve the attached resource-based policy
  for. For an ARN, we recommend that you specify a complete ARN rather than a partial ARN.
  See Finding a secret from a partial ARN.

"""
function get_resource_policy(SecretId; aws_config::AbstractAWSConfig=current_aws_config())
    return secrets_manager(
        "GetResourcePolicy",
        Dict{String,Any}("SecretId" => SecretId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_resource_policy(
    SecretId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return secrets_manager(
        "GetResourcePolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("SecretId" => SecretId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_secret_value(secret_id)
    get_secret_value(secret_id, params::Dict{String,<:Any})

Retrieves the contents of the encrypted fields SecretString or SecretBinary from the
specified version of a secret, whichever contains content. To retrieve the values for a
group of secrets, call BatchGetSecretValue. We recommend that you cache your secret values
by using client-side caching. Caching secrets improves speed and reduces your costs. For
more information, see Cache secrets for your applications. To retrieve the previous version
of a secret, use VersionStage and specify AWSPREVIOUS. To revert to the previous version of
a secret, call UpdateSecretVersionStage. Secrets Manager generates a CloudTrail log entry
when you call this action. Do not include sensitive information in request parameters
because it might be logged. For more information, see Logging Secrets Manager events with
CloudTrail.  Required permissions:  secretsmanager:GetSecretValue. If the secret is
encrypted using a customer-managed key instead of the Amazon Web Services managed key
aws/secretsmanager, then you also need kms:Decrypt permissions for that key. For more
information, see  IAM policy actions for Secrets Manager and Authentication and access
control in Secrets Manager.

# Arguments
- `secret_id`: The ARN or name of the secret to retrieve. To retrieve a secret from another
  account, you must use an ARN. For an ARN, we recommend that you specify a complete ARN
  rather than a partial ARN. See Finding a secret from a partial ARN.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"VersionId"`: The unique identifier of the version of the secret to retrieve. If you
  include both this parameter and VersionStage, the two parameters must refer to the same
  secret version. If you don't specify either a VersionStage or VersionId, then Secrets
  Manager returns the AWSCURRENT version. This value is typically a UUID-type value with 32
  hexadecimal digits.
- `"VersionStage"`: The staging label of the version of the secret to retrieve.  Secrets
  Manager uses staging labels to keep track of different versions during the rotation
  process. If you include both this parameter and VersionId, the two parameters must refer to
  the same secret version. If you don't specify either a VersionStage or VersionId, Secrets
  Manager returns the AWSCURRENT version.
"""
function get_secret_value(SecretId; aws_config::AbstractAWSConfig=current_aws_config())
    return secrets_manager(
        "GetSecretValue",
        Dict{String,Any}("SecretId" => SecretId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_secret_value(
    SecretId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return secrets_manager(
        "GetSecretValue",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("SecretId" => SecretId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_secret_version_ids(secret_id)
    list_secret_version_ids(secret_id, params::Dict{String,<:Any})

Lists the versions of a secret. Secrets Manager uses staging labels to indicate the
different versions of a secret. For more information, see  Secrets Manager concepts:
Versions. To list the secrets in the account, use ListSecrets. Secrets Manager generates a
CloudTrail log entry when you call this action. Do not include sensitive information in
request parameters because it might be logged. For more information, see Logging Secrets
Manager events with CloudTrail.  Required permissions:
secretsmanager:ListSecretVersionIds. For more information, see  IAM policy actions for
Secrets Manager and Authentication and access control in Secrets Manager.

# Arguments
- `secret_id`: The ARN or name of the secret whose versions you want to list. For an ARN,
  we recommend that you specify a complete ARN rather than a partial ARN. See Finding a
  secret from a partial ARN.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"IncludeDeprecated"`: Specifies whether to include versions of secrets that don't have
  any staging labels attached to them. Versions without staging labels are considered
  deprecated and are subject to deletion by Secrets Manager. By default, versions without
  staging labels aren't included.
- `"MaxResults"`: The number of results to include in the response. If there are more
  results available, in the response, Secrets Manager includes NextToken. To get the next
  results, call ListSecretVersionIds again with the value from NextToken.
- `"NextToken"`: A token that indicates where the output should continue from, if a
  previous call did not show all results. To get the next results, call ListSecretVersionIds
  again with this value.
"""
function list_secret_version_ids(
    SecretId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return secrets_manager(
        "ListSecretVersionIds",
        Dict{String,Any}("SecretId" => SecretId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_secret_version_ids(
    SecretId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return secrets_manager(
        "ListSecretVersionIds",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("SecretId" => SecretId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_secrets()
    list_secrets(params::Dict{String,<:Any})

Lists the secrets that are stored by Secrets Manager in the Amazon Web Services account,
not including secrets that are marked for deletion. To see secrets marked for deletion, use
the Secrets Manager console. All Secrets Manager operations are eventually consistent.
ListSecrets might not reflect changes from the last five minutes. You can get more recent
information for a specific secret by calling DescribeSecret. To list the versions of a
secret, use ListSecretVersionIds. To retrieve the values for the secrets, call
BatchGetSecretValue or GetSecretValue. For information about finding secrets in the
console, see Find secrets in Secrets Manager. Secrets Manager generates a CloudTrail log
entry when you call this action. Do not include sensitive information in request parameters
because it might be logged. For more information, see Logging Secrets Manager events with
CloudTrail.  Required permissions:  secretsmanager:ListSecrets. For more information, see
IAM policy actions for Secrets Manager and Authentication and access control in Secrets
Manager.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: The filters to apply to the list of secrets.
- `"IncludePlannedDeletion"`: Specifies whether to include secrets scheduled for deletion.
  By default, secrets scheduled for deletion aren't included.
- `"MaxResults"`: The number of results to include in the response. If there are more
  results available, in the response, Secrets Manager includes NextToken. To get the next
  results, call ListSecrets again with the value from NextToken.
- `"NextToken"`: A token that indicates where the output should continue from, if a
  previous call did not show all results. To get the next results, call ListSecrets again
  with this value.
- `"SortOrder"`: Secrets are listed by CreatedDate.
"""
function list_secrets(; aws_config::AbstractAWSConfig=current_aws_config())
    return secrets_manager(
        "ListSecrets"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_secrets(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return secrets_manager(
        "ListSecrets", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    put_resource_policy(resource_policy, secret_id)
    put_resource_policy(resource_policy, secret_id, params::Dict{String,<:Any})

Attaches a resource-based permission policy to a secret. A resource-based policy is
optional. For more information, see Authentication and access control for Secrets Manager
For information about attaching a policy in the console, see Attach a permissions policy to
a secret. Secrets Manager generates a CloudTrail log entry when you call this action. Do
not include sensitive information in request parameters because it might be logged. For
more information, see Logging Secrets Manager events with CloudTrail.  Required
permissions:  secretsmanager:PutResourcePolicy. For more information, see  IAM policy
actions for Secrets Manager and Authentication and access control in Secrets Manager.

# Arguments
- `resource_policy`: A JSON-formatted string for an Amazon Web Services resource-based
  policy. For example policies, see Permissions policy examples.
- `secret_id`: The ARN or name of the secret to attach the resource-based policy. For an
  ARN, we recommend that you specify a complete ARN rather than a partial ARN. See Finding a
  secret from a partial ARN.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"BlockPublicPolicy"`: Specifies whether to block resource-based policies that allow
  broad access to the secret, for example those that use a wildcard for the principal. By
  default, public policies aren't blocked.  Resource policy validation and the
  BlockPublicPolicy parameter help protect your resources by preventing public access from
  being granted through the resource policies that are directly attached to your secrets. In
  addition to using these features, carefully inspect the following policies to confirm that
  they do not grant public access:   Identity-based policies attached to associated Amazon
  Web Services principals (for example, IAM roles)   Resource-based policies attached to
  associated Amazon Web Services resources (for example, Key Management Service (KMS) keys)
  To review permissions to your secrets, see Determine who has permissions to your secrets.
"""
function put_resource_policy(
    ResourcePolicy, SecretId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return secrets_manager(
        "PutResourcePolicy",
        Dict{String,Any}("ResourcePolicy" => ResourcePolicy, "SecretId" => SecretId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_resource_policy(
    ResourcePolicy,
    SecretId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return secrets_manager(
        "PutResourcePolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ResourcePolicy" => ResourcePolicy, "SecretId" => SecretId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_secret_value(secret_id)
    put_secret_value(secret_id, params::Dict{String,<:Any})

Creates a new version with a new encrypted secret value and attaches it to the secret. The
version can contain a new SecretString value or a new SecretBinary value.  We recommend you
avoid calling PutSecretValue at a sustained rate of more than once every 10 minutes. When
you update the secret value, Secrets Manager creates a new version of the secret. Secrets
Manager removes outdated versions when there are more than 100, but it does not remove
versions created less than 24 hours ago. If you call PutSecretValue more than once every 10
minutes, you create more versions than Secrets Manager removes, and you will reach the
quota for secret versions. You can specify the staging labels to attach to the new version
in VersionStages. If you don't include VersionStages, then Secrets Manager automatically
moves the staging label AWSCURRENT to this version. If this operation creates the first
version for the secret, then Secrets Manager automatically attaches the staging label
AWSCURRENT to it. If this operation moves the staging label AWSCURRENT from another version
to this version, then Secrets Manager also automatically moves the staging label
AWSPREVIOUS to the version that AWSCURRENT was removed from. This operation is idempotent.
If you call this operation with a ClientRequestToken that matches an existing version's
VersionId, and you specify the same secret data, the operation succeeds but does nothing.
However, if the secret data is different, then the operation fails because you can't modify
an existing version; you can only create new ones. Secrets Manager generates a CloudTrail
log entry when you call this action. Do not include sensitive information in request
parameters except SecretBinary, SecretString, or RotationToken because it might be logged.
For more information, see Logging Secrets Manager events with CloudTrail.  Required
permissions:  secretsmanager:PutSecretValue. For more information, see  IAM policy actions
for Secrets Manager and Authentication and access control in Secrets Manager.

# Arguments
- `secret_id`: The ARN or name of the secret to add a new version to. For an ARN, we
  recommend that you specify a complete ARN rather than a partial ARN. See Finding a secret
  from a partial ARN. If the secret doesn't already exist, use CreateSecret instead.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: A unique identifier for the new version of the secret.   If you
  use the Amazon Web Services CLI or one of the Amazon Web Services SDKs to call this
  operation, then you can leave this parameter empty. The CLI or SDK generates a random UUID
  for you and includes it as the value for this parameter in the request.   If you generate a
  raw HTTP request to the Secrets Manager service endpoint, then you must generate a
  ClientRequestToken and include it in the request. This value helps ensure idempotency.
  Secrets Manager uses this value to prevent the accidental creation of duplicate versions if
  there are failures and retries during a rotation. We recommend that you generate a
  UUID-type value to ensure uniqueness of your versions within the specified secret.    If
  the ClientRequestToken value isn't already associated with a version of the secret then a
  new version of the secret is created.    If a version with this value already exists and
  that version's SecretString or SecretBinary values are the same as those in the request
  then the request is ignored. The operation is idempotent.    If a version with this value
  already exists and the version of the SecretString and SecretBinary values are different
  from those in the request, then the request fails because you can't modify a secret
  version. You can only create new versions to store new secret values.   This value becomes
  the VersionId of the new version.
- `"RotationToken"`: A unique identifier that indicates the source of the request. For
  cross-account rotation (when you rotate a secret in one account by using a Lambda rotation
  function in another account) and the Lambda rotation function assumes an IAM role to call
  Secrets Manager, Secrets Manager validates the identity with the rotation token. For more
  information, see How rotation works. Sensitive: This field contains sensitive information,
  so the service does not include it in CloudTrail log entries. If you create your own log
  entries, you must also avoid logging the information in this field.
- `"SecretBinary"`: The binary data to encrypt and store in the new version of the secret.
  To use this parameter in the command-line tools, we recommend that you store your binary
  data in a file and then pass the contents of the file as a parameter.  You must include
  SecretBinary or SecretString, but not both. You can't access this value from the Secrets
  Manager console. Sensitive: This field contains sensitive information, so the service does
  not include it in CloudTrail log entries. If you create your own log entries, you must also
  avoid logging the information in this field.
- `"SecretString"`: The text to encrypt and store in the new version of the secret.  You
  must include SecretBinary or SecretString, but not both. We recommend you create the secret
  string as JSON key/value pairs, as shown in the example. Sensitive: This field contains
  sensitive information, so the service does not include it in CloudTrail log entries. If you
  create your own log entries, you must also avoid logging the information in this field.
- `"VersionStages"`: A list of staging labels to attach to this version of the secret.
  Secrets Manager uses staging labels to track versions of a secret through the rotation
  process. If you specify a staging label that's already associated with a different version
  of the same secret, then Secrets Manager removes the label from the other version and
  attaches it to this version. If you specify AWSCURRENT, and it is already attached to
  another version, then Secrets Manager also moves the staging label AWSPREVIOUS to the
  version that AWSCURRENT was removed from. If you don't include VersionStages, then Secrets
  Manager automatically moves the staging label AWSCURRENT to this version.
"""
function put_secret_value(SecretId; aws_config::AbstractAWSConfig=current_aws_config())
    return secrets_manager(
        "PutSecretValue",
        Dict{String,Any}("SecretId" => SecretId, "ClientRequestToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_secret_value(
    SecretId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return secrets_manager(
        "PutSecretValue",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "SecretId" => SecretId, "ClientRequestToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_regions_from_replication(remove_replica_regions, secret_id)
    remove_regions_from_replication(remove_replica_regions, secret_id, params::Dict{String,<:Any})

For a secret that is replicated to other Regions, deletes the secret replicas from the
Regions you specify. Secrets Manager generates a CloudTrail log entry when you call this
action. Do not include sensitive information in request parameters because it might be
logged. For more information, see Logging Secrets Manager events with CloudTrail.  Required
permissions:  secretsmanager:RemoveRegionsFromReplication. For more information, see  IAM
policy actions for Secrets Manager and Authentication and access control in Secrets
Manager.

# Arguments
- `remove_replica_regions`: The Regions of the replicas to remove.
- `secret_id`: The ARN or name of the secret.

"""
function remove_regions_from_replication(
    RemoveReplicaRegions, SecretId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return secrets_manager(
        "RemoveRegionsFromReplication",
        Dict{String,Any}(
            "RemoveReplicaRegions" => RemoveReplicaRegions, "SecretId" => SecretId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_regions_from_replication(
    RemoveReplicaRegions,
    SecretId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return secrets_manager(
        "RemoveRegionsFromReplication",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "RemoveReplicaRegions" => RemoveReplicaRegions, "SecretId" => SecretId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    replicate_secret_to_regions(add_replica_regions, secret_id)
    replicate_secret_to_regions(add_replica_regions, secret_id, params::Dict{String,<:Any})

Replicates the secret to a new Regions. See Multi-Region secrets. Secrets Manager generates
a CloudTrail log entry when you call this action. Do not include sensitive information in
request parameters because it might be logged. For more information, see Logging Secrets
Manager events with CloudTrail.  Required permissions:
secretsmanager:ReplicateSecretToRegions. If the primary secret is encrypted with a KMS key
other than aws/secretsmanager, you also need kms:Decrypt permission to the key. To encrypt
the replicated secret with a KMS key other than aws/secretsmanager, you need
kms:GenerateDataKey and kms:Encrypt to the key. For more information, see  IAM policy
actions for Secrets Manager and Authentication and access control in Secrets Manager.

# Arguments
- `add_replica_regions`: A list of Regions in which to replicate the secret.
- `secret_id`: The ARN or name of the secret to replicate.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ForceOverwriteReplicaSecret"`: Specifies whether to overwrite a secret with the same
  name in the destination Region. By default, secrets aren't overwritten.
"""
function replicate_secret_to_regions(
    AddReplicaRegions, SecretId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return secrets_manager(
        "ReplicateSecretToRegions",
        Dict{String,Any}("AddReplicaRegions" => AddReplicaRegions, "SecretId" => SecretId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function replicate_secret_to_regions(
    AddReplicaRegions,
    SecretId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return secrets_manager(
        "ReplicateSecretToRegions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AddReplicaRegions" => AddReplicaRegions, "SecretId" => SecretId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    restore_secret(secret_id)
    restore_secret(secret_id, params::Dict{String,<:Any})

Cancels the scheduled deletion of a secret by removing the DeletedDate time stamp. You can
access a secret again after it has been restored. Secrets Manager generates a CloudTrail
log entry when you call this action. Do not include sensitive information in request
parameters because it might be logged. For more information, see Logging Secrets Manager
events with CloudTrail.  Required permissions:  secretsmanager:RestoreSecret. For more
information, see  IAM policy actions for Secrets Manager and Authentication and access
control in Secrets Manager.

# Arguments
- `secret_id`: The ARN or name of the secret to restore. For an ARN, we recommend that you
  specify a complete ARN rather than a partial ARN. See Finding a secret from a partial ARN.

"""
function restore_secret(SecretId; aws_config::AbstractAWSConfig=current_aws_config())
    return secrets_manager(
        "RestoreSecret",
        Dict{String,Any}("SecretId" => SecretId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function restore_secret(
    SecretId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return secrets_manager(
        "RestoreSecret",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("SecretId" => SecretId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    rotate_secret(secret_id)
    rotate_secret(secret_id, params::Dict{String,<:Any})

Configures and starts the asynchronous process of rotating the secret. For information
about rotation, see Rotate secrets in the Secrets Manager User Guide. If you include the
configuration parameters, the operation sets the values for the secret and then immediately
starts a rotation. If you don't include the configuration parameters, the operation starts
a rotation with the values already stored in the secret.  When rotation is successful, the
AWSPENDING staging label might be attached to the same version as the AWSCURRENT version,
or it might not be attached to any version. If the AWSPENDING staging label is present but
not attached to the same version as AWSCURRENT, then any later invocation of RotateSecret
assumes that a previous rotation request is still in progress and returns an error. When
rotation is unsuccessful, the AWSPENDING staging label might be attached to an empty secret
version. For more information, see Troubleshoot rotation in the Secrets Manager User Guide.
Secrets Manager generates a CloudTrail log entry when you call this action. Do not include
sensitive information in request parameters because it might be logged. For more
information, see Logging Secrets Manager events with CloudTrail.  Required permissions:
secretsmanager:RotateSecret. For more information, see  IAM policy actions for Secrets
Manager and Authentication and access control in Secrets Manager. You also need
lambda:InvokeFunction permissions on the rotation function. For more information, see
Permissions for rotation.

# Arguments
- `secret_id`: The ARN or name of the secret to rotate. For an ARN, we recommend that you
  specify a complete ARN rather than a partial ARN. See Finding a secret from a partial ARN.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: A unique identifier for the new version of the secret. You only
  need to specify this value if you implement your own retry logic and you want to ensure
  that Secrets Manager doesn't attempt to create a secret version twice.  If you use the
  Amazon Web Services CLI or one of the Amazon Web Services SDKs to call this operation, then
  you can leave this parameter empty. The CLI or SDK generates a random UUID for you and
  includes it as the value for this parameter in the request.   If you generate a raw HTTP
  request to the Secrets Manager service endpoint, then you must generate a
  ClientRequestToken and include it in the request. This value helps ensure idempotency.
  Secrets Manager uses this value to prevent the accidental creation of duplicate versions if
  there are failures and retries during a rotation. We recommend that you generate a
  UUID-type value to ensure uniqueness of your versions within the specified secret.
- `"RotateImmediately"`: Specifies whether to rotate the secret immediately or wait until
  the next scheduled rotation window. The rotation schedule is defined in
  RotateSecretRequestRotationRules. For secrets that use a Lambda rotation function to
  rotate, if you don't immediately rotate the secret, Secrets Manager tests the rotation
  configuration by running the  testSecret step of the Lambda rotation function. The test
  creates an AWSPENDING version of the secret and then removes it. By default, Secrets
  Manager rotates the secret immediately.
- `"RotationLambdaARN"`: For secrets that use a Lambda rotation function to rotate, the ARN
  of the Lambda rotation function.  For secrets that use managed rotation, omit this field.
  For more information, see Managed rotation in the Secrets Manager User Guide.
- `"RotationRules"`: A structure that defines the rotation configuration for this secret.
"""
function rotate_secret(SecretId; aws_config::AbstractAWSConfig=current_aws_config())
    return secrets_manager(
        "RotateSecret",
        Dict{String,Any}("SecretId" => SecretId, "ClientRequestToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function rotate_secret(
    SecretId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return secrets_manager(
        "RotateSecret",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "SecretId" => SecretId, "ClientRequestToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_replication_to_replica(secret_id)
    stop_replication_to_replica(secret_id, params::Dict{String,<:Any})

Removes the link between the replica secret and the primary secret and promotes the replica
to a primary secret in the replica Region. You must call this operation from the Region in
which you want to promote the replica to a primary secret. Secrets Manager generates a
CloudTrail log entry when you call this action. Do not include sensitive information in
request parameters because it might be logged. For more information, see Logging Secrets
Manager events with CloudTrail.  Required permissions:
secretsmanager:StopReplicationToReplica. For more information, see  IAM policy actions for
Secrets Manager and Authentication and access control in Secrets Manager.

# Arguments
- `secret_id`: The ARN of the primary secret.

"""
function stop_replication_to_replica(
    SecretId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return secrets_manager(
        "StopReplicationToReplica",
        Dict{String,Any}("SecretId" => SecretId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_replication_to_replica(
    SecretId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return secrets_manager(
        "StopReplicationToReplica",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("SecretId" => SecretId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(secret_id, tags)
    tag_resource(secret_id, tags, params::Dict{String,<:Any})

Attaches tags to a secret. Tags consist of a key name and a value. Tags are part of the
secret's metadata. They are not associated with specific versions of the secret. This
operation appends tags to the existing list of tags. For tag quotas and naming
restrictions, see Service quotas for Tagging in the Amazon Web Services General Reference
guide.  If you use tags as part of your security strategy, then adding or removing a tag
can change permissions. If successfully completing this operation would result in you
losing your permissions for this secret, then the operation is blocked and returns an
Access Denied error.  Secrets Manager generates a CloudTrail log entry when you call this
action. Do not include sensitive information in request parameters because it might be
logged. For more information, see Logging Secrets Manager events with CloudTrail.  Required
permissions:  secretsmanager:TagResource. For more information, see  IAM policy actions for
Secrets Manager and Authentication and access control in Secrets Manager.

# Arguments
- `secret_id`: The identifier for the secret to attach tags to. You can specify either the
  Amazon Resource Name (ARN) or the friendly name of the secret. For an ARN, we recommend
  that you specify a complete ARN rather than a partial ARN. See Finding a secret from a
  partial ARN.
- `tags`: The tags to attach to the secret as a JSON text string argument. Each element in
  the list consists of a Key and a Value. For storing multiple values, we recommend that you
  use a JSON text string argument and specify key/value pairs. For more information, see
  Specifying parameter values for the Amazon Web Services CLI in the Amazon Web Services CLI
  User Guide.

"""
function tag_resource(SecretId, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return secrets_manager(
        "TagResource",
        Dict{String,Any}("SecretId" => SecretId, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    SecretId,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return secrets_manager(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("SecretId" => SecretId, "Tags" => Tags), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(secret_id, tag_keys)
    untag_resource(secret_id, tag_keys, params::Dict{String,<:Any})

Removes specific tags from a secret. This operation is idempotent. If a requested tag is
not attached to the secret, no error is returned and the secret metadata is unchanged.  If
you use tags as part of your security strategy, then removing a tag can change permissions.
If successfully completing this operation would result in you losing your permissions for
this secret, then the operation is blocked and returns an Access Denied error.  Secrets
Manager generates a CloudTrail log entry when you call this action. Do not include
sensitive information in request parameters because it might be logged. For more
information, see Logging Secrets Manager events with CloudTrail.  Required permissions:
secretsmanager:UntagResource. For more information, see  IAM policy actions for Secrets
Manager and Authentication and access control in Secrets Manager.

# Arguments
- `secret_id`: The ARN or name of the secret. For an ARN, we recommend that you specify a
  complete ARN rather than a partial ARN. See Finding a secret from a partial ARN.
- `tag_keys`: A list of tag key names to remove from the secret. You don't specify the
  value. Both the key and its associated value are removed. This parameter requires a JSON
  text string argument. For storing multiple values, we recommend that you use a JSON text
  string argument and specify key/value pairs. For more information, see Specifying parameter
  values for the Amazon Web Services CLI in the Amazon Web Services CLI User Guide.

"""
function untag_resource(
    SecretId, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return secrets_manager(
        "UntagResource",
        Dict{String,Any}("SecretId" => SecretId, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    SecretId,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return secrets_manager(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("SecretId" => SecretId, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_secret(secret_id)
    update_secret(secret_id, params::Dict{String,<:Any})

Modifies the details of a secret, including metadata and the secret value. To change the
secret value, you can also use PutSecretValue. To change the rotation configuration of a
secret, use RotateSecret instead. To change a secret so that it is managed by another
service, you need to recreate the secret in that service. See Secrets Manager secrets
managed by other Amazon Web Services services. We recommend you avoid calling UpdateSecret
at a sustained rate of more than once every 10 minutes. When you call UpdateSecret to
update the secret value, Secrets Manager creates a new version of the secret. Secrets
Manager removes outdated versions when there are more than 100, but it does not remove
versions created less than 24 hours ago. If you update the secret value more than once
every 10 minutes, you create more versions than Secrets Manager removes, and you will reach
the quota for secret versions. If you include SecretString or SecretBinary to create a new
secret version, Secrets Manager automatically moves the staging label AWSCURRENT to the new
version. Then it attaches the label AWSPREVIOUS to the version that AWSCURRENT was removed
from. If you call this operation with a ClientRequestToken that matches an existing
version's VersionId, the operation results in an error. You can't modify an existing
version, you can only create a new version. To remove a version, remove all staging labels
from it. See UpdateSecretVersionStage. Secrets Manager generates a CloudTrail log entry
when you call this action. Do not include sensitive information in request parameters
except SecretBinary or SecretString because it might be logged. For more information, see
Logging Secrets Manager events with CloudTrail.  Required permissions:
secretsmanager:UpdateSecret. For more information, see  IAM policy actions for Secrets
Manager and Authentication and access control in Secrets Manager. If you use a customer
managed key, you must also have kms:GenerateDataKey, kms:Encrypt, and kms:Decrypt
permissions on the key. If you change the KMS key and you don't have kms:Encrypt permission
to the new key, Secrets Manager does not re-ecrypt existing secret versions with the new
key. For more information, see  Secret encryption and decryption.

# Arguments
- `secret_id`: The ARN or name of the secret. For an ARN, we recommend that you specify a
  complete ARN rather than a partial ARN. See Finding a secret from a partial ARN.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: If you include SecretString or SecretBinary, then Secrets Manager
  creates a new version for the secret, and this parameter specifies the unique identifier
  for the new version.  If you use the Amazon Web Services CLI or one of the Amazon Web
  Services SDKs to call this operation, then you can leave this parameter empty. The CLI or
  SDK generates a random UUID for you and includes it as the value for this parameter in the
  request.   If you generate a raw HTTP request to the Secrets Manager service endpoint, then
  you must generate a ClientRequestToken and include it in the request. This value helps
  ensure idempotency. Secrets Manager uses this value to prevent the accidental creation of
  duplicate versions if there are failures and retries during a rotation. We recommend that
  you generate a UUID-type value to ensure uniqueness of your versions within the specified
  secret.
- `"Description"`: The description of the secret.
- `"KmsKeyId"`: The ARN, key ID, or alias of the KMS key that Secrets Manager uses to
  encrypt new secret versions as well as any existing versions with the staging labels
  AWSCURRENT, AWSPENDING, or AWSPREVIOUS. If you don't have kms:Encrypt permission to the new
  key, Secrets Manager does not re-ecrypt existing secret versions with the new key. For more
  information about versions and staging labels, see Concepts: Version. A key alias is always
  prefixed by alias/, for example alias/aws/secretsmanager. For more information, see About
  aliases. If you set this to an empty string, Secrets Manager uses the Amazon Web Services
  managed key aws/secretsmanager. If this key doesn't already exist in your account, then
  Secrets Manager creates it for you automatically. All users and roles in the Amazon Web
  Services account automatically have access to use aws/secretsmanager. Creating
  aws/secretsmanager can result in a one-time significant delay in returning the result.
  You can only use the Amazon Web Services managed key aws/secretsmanager if you call this
  operation using credentials from the same Amazon Web Services account that owns the secret.
  If the secret is in a different account, then you must use a customer managed key and
  provide the ARN of that KMS key in this field. The user making the call must have
  permissions to both the secret and the KMS key in their respective accounts.
- `"SecretBinary"`: The binary data to encrypt and store in the new version of the secret.
  We recommend that you store your binary data in a file and then pass the contents of the
  file as a parameter.  Either SecretBinary or SecretString must have a value, but not both.
  You can't access this parameter in the Secrets Manager console. Sensitive: This field
  contains sensitive information, so the service does not include it in CloudTrail log
  entries. If you create your own log entries, you must also avoid logging the information in
  this field.
- `"SecretString"`: The text data to encrypt and store in the new version of the secret. We
  recommend you use a JSON structure of key/value pairs for your secret value.  Either
  SecretBinary or SecretString must have a value, but not both.  Sensitive: This field
  contains sensitive information, so the service does not include it in CloudTrail log
  entries. If you create your own log entries, you must also avoid logging the information in
  this field.
"""
function update_secret(SecretId; aws_config::AbstractAWSConfig=current_aws_config())
    return secrets_manager(
        "UpdateSecret",
        Dict{String,Any}("SecretId" => SecretId, "ClientRequestToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_secret(
    SecretId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return secrets_manager(
        "UpdateSecret",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "SecretId" => SecretId, "ClientRequestToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_secret_version_stage(secret_id, version_stage)
    update_secret_version_stage(secret_id, version_stage, params::Dict{String,<:Any})

Modifies the staging labels attached to a version of a secret. Secrets Manager uses staging
labels to track a version as it progresses through the secret rotation process. Each
staging label can be attached to only one version at a time. To add a staging label to a
version when it is already attached to another version, Secrets Manager first removes it
from the other version first and then attaches it to this one. For more information about
versions and staging labels, see Concepts: Version.  The staging labels that you specify in
the VersionStage parameter are added to the existing list of staging labels for the
version.  You can move the AWSCURRENT staging label to this version by including it in this
call.  Whenever you move AWSCURRENT, Secrets Manager automatically moves the label
AWSPREVIOUS to the version that AWSCURRENT was removed from.  If this action results in the
last label being removed from a version, then the version is considered to be 'deprecated'
and can be deleted by Secrets Manager. Secrets Manager generates a CloudTrail log entry
when you call this action. Do not include sensitive information in request parameters
because it might be logged. For more information, see Logging Secrets Manager events with
CloudTrail.  Required permissions:  secretsmanager:UpdateSecretVersionStage. For more
information, see  IAM policy actions for Secrets Manager and Authentication and access
control in Secrets Manager.

# Arguments
- `secret_id`: The ARN or the name of the secret with the version and staging labelsto
  modify. For an ARN, we recommend that you specify a complete ARN rather than a partial ARN.
  See Finding a secret from a partial ARN.
- `version_stage`: The staging label to add to this version.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MoveToVersionId"`: The ID of the version to add the staging label to. To remove a label
  from a version, then do not specify this parameter. If the staging label is already
  attached to a different version of the secret, then you must also specify the
  RemoveFromVersionId parameter.
- `"RemoveFromVersionId"`: The ID of the version that the staging label is to be removed
  from. If the staging label you are trying to attach to one version is already attached to a
  different version, then you must include this parameter and specify the version that the
  label is to be removed from. If the label is attached and you either do not specify this
  parameter, or the version ID does not match, then the operation fails.
"""
function update_secret_version_stage(
    SecretId, VersionStage; aws_config::AbstractAWSConfig=current_aws_config()
)
    return secrets_manager(
        "UpdateSecretVersionStage",
        Dict{String,Any}("SecretId" => SecretId, "VersionStage" => VersionStage);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_secret_version_stage(
    SecretId,
    VersionStage,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return secrets_manager(
        "UpdateSecretVersionStage",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("SecretId" => SecretId, "VersionStage" => VersionStage),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    validate_resource_policy(resource_policy)
    validate_resource_policy(resource_policy, params::Dict{String,<:Any})

Validates that a resource policy does not grant a wide range of principals access to your
secret. A resource-based policy is optional for secrets. The API performs three checks when
validating the policy:   Sends a call to Zelkova, an automated reasoning engine, to ensure
your resource policy does not allow broad access to your secret, for example policies that
use a wildcard for the principal.   Checks for correct syntax in a policy.   Verifies the
policy does not lock out a caller.   Secrets Manager generates a CloudTrail log entry when
you call this action. Do not include sensitive information in request parameters because it
might be logged. For more information, see Logging Secrets Manager events with CloudTrail.
Required permissions:  secretsmanager:ValidateResourcePolicy and
secretsmanager:PutResourcePolicy. For more information, see  IAM policy actions for Secrets
Manager and Authentication and access control in Secrets Manager.

# Arguments
- `resource_policy`: A JSON-formatted string that contains an Amazon Web Services
  resource-based policy. The policy in the string identifies who can access or manage this
  secret and its versions. For example policies, see Permissions policy examples.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"SecretId"`: The ARN or name of the secret with the resource-based policy you want to
  validate.
"""
function validate_resource_policy(
    ResourcePolicy; aws_config::AbstractAWSConfig=current_aws_config()
)
    return secrets_manager(
        "ValidateResourcePolicy",
        Dict{String,Any}("ResourcePolicy" => ResourcePolicy);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function validate_resource_policy(
    ResourcePolicy,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return secrets_manager(
        "ValidateResourcePolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourcePolicy" => ResourcePolicy), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: kafkaconnect
using AWS.Compat
using AWS.UUIDs

"""
    create_connector(capacity, connector_configuration, connector_name, kafka_cluster, kafka_cluster_client_authentication, kafka_cluster_encryption_in_transit, kafka_connect_version, plugins, service_execution_role_arn)
    create_connector(capacity, connector_configuration, connector_name, kafka_cluster, kafka_cluster_client_authentication, kafka_cluster_encryption_in_transit, kafka_connect_version, plugins, service_execution_role_arn, params::Dict{String,<:Any})

Creates a connector using the specified properties.

# Arguments
- `capacity`: Information about the capacity allocated to the connector. Exactly one of the
  two properties must be specified.
- `connector_configuration`: A map of keys to values that represent the configuration for
  the connector.
- `connector_name`: The name of the connector.
- `kafka_cluster`: Specifies which Apache Kafka cluster to connect to.
- `kafka_cluster_client_authentication`: Details of the client authentication used by the
  Apache Kafka cluster.
- `kafka_cluster_encryption_in_transit`: Details of encryption in transit to the Apache
  Kafka cluster.
- `kafka_connect_version`: The version of Kafka Connect. It has to be compatible with both
  the Apache Kafka cluster's version and the plugins.
- `plugins`:  Amazon MSK Connect does not currently support specifying multiple plugins as
  a list. To use more than one plugin for your connector, you can create a single custom
  plugin using a ZIP file that bundles multiple plugins together.  Specifies which plugin to
  use for the connector. You must specify a single-element list containing one customPlugin
  object.
- `service_execution_role_arn`: The Amazon Resource Name (ARN) of the IAM role used by the
  connector to access the Amazon Web Services resources that it needs. The types of resources
  depends on the logic of the connector. For example, a connector that has Amazon S3 as a
  destination must have permissions that allow it to write to the S3 destination bucket.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"connectorDescription"`: A summary description of the connector.
- `"logDelivery"`: Details about log delivery.
- `"tags"`: The tags you want to attach to the connector.
- `"workerConfiguration"`: Specifies which worker configuration to use with the connector.
"""
function create_connector(
    capacity,
    connectorConfiguration,
    connectorName,
    kafkaCluster,
    kafkaClusterClientAuthentication,
    kafkaClusterEncryptionInTransit,
    kafkaConnectVersion,
    plugins,
    serviceExecutionRoleArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafkaconnect(
        "POST",
        "/v1/connectors",
        Dict{String,Any}(
            "capacity" => capacity,
            "connectorConfiguration" => connectorConfiguration,
            "connectorName" => connectorName,
            "kafkaCluster" => kafkaCluster,
            "kafkaClusterClientAuthentication" => kafkaClusterClientAuthentication,
            "kafkaClusterEncryptionInTransit" => kafkaClusterEncryptionInTransit,
            "kafkaConnectVersion" => kafkaConnectVersion,
            "plugins" => plugins,
            "serviceExecutionRoleArn" => serviceExecutionRoleArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_connector(
    capacity,
    connectorConfiguration,
    connectorName,
    kafkaCluster,
    kafkaClusterClientAuthentication,
    kafkaClusterEncryptionInTransit,
    kafkaConnectVersion,
    plugins,
    serviceExecutionRoleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafkaconnect(
        "POST",
        "/v1/connectors",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "capacity" => capacity,
                    "connectorConfiguration" => connectorConfiguration,
                    "connectorName" => connectorName,
                    "kafkaCluster" => kafkaCluster,
                    "kafkaClusterClientAuthentication" => kafkaClusterClientAuthentication,
                    "kafkaClusterEncryptionInTransit" => kafkaClusterEncryptionInTransit,
                    "kafkaConnectVersion" => kafkaConnectVersion,
                    "plugins" => plugins,
                    "serviceExecutionRoleArn" => serviceExecutionRoleArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_custom_plugin(content_type, location, name)
    create_custom_plugin(content_type, location, name, params::Dict{String,<:Any})

Creates a custom plugin using the specified properties.

# Arguments
- `content_type`: The type of the plugin file.
- `location`: Information about the location of a custom plugin.
- `name`: The name of the custom plugin.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A summary description of the custom plugin.
- `"tags"`: The tags you want to attach to the custom plugin.
"""
function create_custom_plugin(
    contentType, location, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kafkaconnect(
        "POST",
        "/v1/custom-plugins",
        Dict{String,Any}(
            "contentType" => contentType, "location" => location, "name" => name
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_custom_plugin(
    contentType,
    location,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafkaconnect(
        "POST",
        "/v1/custom-plugins",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "contentType" => contentType, "location" => location, "name" => name
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_worker_configuration(name, properties_file_content)
    create_worker_configuration(name, properties_file_content, params::Dict{String,<:Any})

Creates a worker configuration using the specified properties.

# Arguments
- `name`: The name of the worker configuration.
- `properties_file_content`: Base64 encoded contents of connect-distributed.properties file.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A summary description of the worker configuration.
- `"tags"`: The tags you want to attach to the worker configuration.
"""
function create_worker_configuration(
    name, propertiesFileContent; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kafkaconnect(
        "POST",
        "/v1/worker-configurations",
        Dict{String,Any}("name" => name, "propertiesFileContent" => propertiesFileContent);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_worker_configuration(
    name,
    propertiesFileContent,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafkaconnect(
        "POST",
        "/v1/worker-configurations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "name" => name, "propertiesFileContent" => propertiesFileContent
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_connector(connector_arn)
    delete_connector(connector_arn, params::Dict{String,<:Any})

Deletes the specified connector.

# Arguments
- `connector_arn`: The Amazon Resource Name (ARN) of the connector that you want to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"currentVersion"`: The current version of the connector that you want to delete.
"""
function delete_connector(connectorArn; aws_config::AbstractAWSConfig=current_aws_config())
    return kafkaconnect(
        "DELETE",
        "/v1/connectors/$(connectorArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_connector(
    connectorArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafkaconnect(
        "DELETE",
        "/v1/connectors/$(connectorArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_custom_plugin(custom_plugin_arn)
    delete_custom_plugin(custom_plugin_arn, params::Dict{String,<:Any})

Deletes a custom plugin.

# Arguments
- `custom_plugin_arn`: The Amazon Resource Name (ARN) of the custom plugin that you want to
  delete.

"""
function delete_custom_plugin(
    customPluginArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kafkaconnect(
        "DELETE",
        "/v1/custom-plugins/$(customPluginArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_custom_plugin(
    customPluginArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafkaconnect(
        "DELETE",
        "/v1/custom-plugins/$(customPluginArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_worker_configuration(worker_configuration_arn)
    delete_worker_configuration(worker_configuration_arn, params::Dict{String,<:Any})

Deletes the specified worker configuration.

# Arguments
- `worker_configuration_arn`: The Amazon Resource Name (ARN) of the worker configuration
  that you want to delete.

"""
function delete_worker_configuration(
    workerConfigurationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kafkaconnect(
        "DELETE",
        "/v1/worker-configurations/$(workerConfigurationArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_worker_configuration(
    workerConfigurationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafkaconnect(
        "DELETE",
        "/v1/worker-configurations/$(workerConfigurationArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_connector(connector_arn)
    describe_connector(connector_arn, params::Dict{String,<:Any})

Returns summary information about the connector.

# Arguments
- `connector_arn`: The Amazon Resource Name (ARN) of the connector that you want to
  describe.

"""
function describe_connector(
    connectorArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kafkaconnect(
        "GET",
        "/v1/connectors/$(connectorArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_connector(
    connectorArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafkaconnect(
        "GET",
        "/v1/connectors/$(connectorArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_custom_plugin(custom_plugin_arn)
    describe_custom_plugin(custom_plugin_arn, params::Dict{String,<:Any})

A summary description of the custom plugin.

# Arguments
- `custom_plugin_arn`: Returns information about a custom plugin.

"""
function describe_custom_plugin(
    customPluginArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kafkaconnect(
        "GET",
        "/v1/custom-plugins/$(customPluginArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_custom_plugin(
    customPluginArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafkaconnect(
        "GET",
        "/v1/custom-plugins/$(customPluginArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_worker_configuration(worker_configuration_arn)
    describe_worker_configuration(worker_configuration_arn, params::Dict{String,<:Any})

Returns information about a worker configuration.

# Arguments
- `worker_configuration_arn`: The Amazon Resource Name (ARN) of the worker configuration
  that you want to get information about.

"""
function describe_worker_configuration(
    workerConfigurationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kafkaconnect(
        "GET",
        "/v1/worker-configurations/$(workerConfigurationArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_worker_configuration(
    workerConfigurationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafkaconnect(
        "GET",
        "/v1/worker-configurations/$(workerConfigurationArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_connectors()
    list_connectors(params::Dict{String,<:Any})

Returns a list of all the connectors in this account and Region. The list is limited to
connectors whose name starts with the specified prefix. The response also includes a
description of each of the listed connectors.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"connectorNamePrefix"`: The name prefix that you want to use to search for and list
  connectors.
- `"maxResults"`: The maximum number of connectors to list in one response.
- `"nextToken"`: If the response of a ListConnectors operation is truncated, it will
  include a NextToken. Send this NextToken in a subsequent request to continue listing from
  where the previous operation left off.
"""
function list_connectors(; aws_config::AbstractAWSConfig=current_aws_config())
    return kafkaconnect(
        "GET", "/v1/connectors"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_connectors(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kafkaconnect(
        "GET",
        "/v1/connectors",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_custom_plugins()
    list_custom_plugins(params::Dict{String,<:Any})

Returns a list of all of the custom plugins in this account and Region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of custom plugins to list in one response.
- `"namePrefix"`: Lists custom plugin names that start with the specified text string.
- `"nextToken"`: If the response of a ListCustomPlugins operation is truncated, it will
  include a NextToken. Send this NextToken in a subsequent request to continue listing from
  where the previous operation left off.
"""
function list_custom_plugins(; aws_config::AbstractAWSConfig=current_aws_config())
    return kafkaconnect(
        "GET", "/v1/custom-plugins"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_custom_plugins(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kafkaconnect(
        "GET",
        "/v1/custom-plugins",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists all the tags attached to the specified resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource for which you want to list
  all attached tags.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kafkaconnect(
        "GET",
        "/v1/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafkaconnect(
        "GET",
        "/v1/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_worker_configurations()
    list_worker_configurations(params::Dict{String,<:Any})

Returns a list of all of the worker configurations in this account and Region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of worker configurations to list in one response.
- `"namePrefix"`: Lists worker configuration names that start with the specified text
  string.
- `"nextToken"`: If the response of a ListWorkerConfigurations operation is truncated, it
  will include a NextToken. Send this NextToken in a subsequent request to continue listing
  from where the previous operation left off.
"""
function list_worker_configurations(; aws_config::AbstractAWSConfig=current_aws_config())
    return kafkaconnect(
        "GET",
        "/v1/worker-configurations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_worker_configurations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kafkaconnect(
        "GET",
        "/v1/worker-configurations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Attaches tags to the specified resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource to which you want to
  attach tags.
- `tags`: The tags that you want to attach to the resource.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return kafkaconnect(
        "POST",
        "/v1/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafkaconnect(
        "POST",
        "/v1/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes tags from the specified resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource from which you want to
  remove tags.
- `tag_keys`: The keys of the tags that you want to remove from the resource.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kafkaconnect(
        "DELETE",
        "/v1/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafkaconnect(
        "DELETE",
        "/v1/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_connector(capacity, connector_arn, current_version)
    update_connector(capacity, connector_arn, current_version, params::Dict{String,<:Any})

Updates the specified connector.

# Arguments
- `capacity`: The target capacity.
- `connector_arn`: The Amazon Resource Name (ARN) of the connector that you want to update.
- `current_version`: The current version of the connector that you want to update.

"""
function update_connector(
    capacity,
    connectorArn,
    currentVersion;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafkaconnect(
        "PUT",
        "/v1/connectors/$(connectorArn)",
        Dict{String,Any}("capacity" => capacity, "currentVersion" => currentVersion);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_connector(
    capacity,
    connectorArn,
    currentVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kafkaconnect(
        "PUT",
        "/v1/connectors/$(connectorArn)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "capacity" => capacity, "currentVersion" => currentVersion
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: route53profiles
using AWS.Compat
using AWS.UUIDs

"""
    associate_profile(name, profile_id, resource_id)
    associate_profile(name, profile_id, resource_id, params::Dict{String,<:Any})

 Associates a Route 53 Profiles profile with a VPC. A VPC can have only one Profile
associated with it, but a Profile can be associated with 1000 of VPCs (and you can request
a higher quota). For more information, see
https://docs.aws.amazon.com/Route53/latest/DeveloperGuide/DNSLimitations.html#limits-api-ent
ities.

# Arguments
- `name`:  A name for the association.
- `profile_id`:  ID of the Profile.
- `resource_id`:  The ID of the VPC.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`:  A list of the tag keys and values that you want to identify the Profile
  association.
"""
function associate_profile(
    Name, ProfileId, ResourceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53profiles(
        "POST",
        "/profileassociation",
        Dict{String,Any}(
            "Name" => Name, "ProfileId" => ProfileId, "ResourceId" => ResourceId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_profile(
    Name,
    ProfileId,
    ResourceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53profiles(
        "POST",
        "/profileassociation",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Name" => Name, "ProfileId" => ProfileId, "ResourceId" => ResourceId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_resource_to_profile(name, profile_id, resource_arn)
    associate_resource_to_profile(name, profile_id, resource_arn, params::Dict{String,<:Any})

 Associates a DNS reource configuration to a Route 53 Profile.

# Arguments
- `name`:  Name for the resource association.
- `profile_id`:  ID of the Profile.
- `resource_arn`:  Amazon resource number, ARN, of the DNS resource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ResourceProperties"`:  If you are adding a DNS Firewall rule group, include also a
  priority. The priority indicates the processing order for the rule groups, starting with
  the priority assinged the lowest value.  The allowed values for priority are between 100
  and 9900.
"""
function associate_resource_to_profile(
    Name, ProfileId, ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53profiles(
        "POST",
        "/profileresourceassociation",
        Dict{String,Any}(
            "Name" => Name, "ProfileId" => ProfileId, "ResourceArn" => ResourceArn
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_resource_to_profile(
    Name,
    ProfileId,
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53profiles(
        "POST",
        "/profileresourceassociation",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Name" => Name, "ProfileId" => ProfileId, "ResourceArn" => ResourceArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_profile(client_token, name)
    create_profile(client_token, name, params::Dict{String,<:Any})

 Creates an empty Route 53 Profile.

# Arguments
- `client_token`:  ClientToken is an idempotency token that ensures a call to CreateProfile
  completes only once. You choose the value to pass. For example, an issue might prevent you
  from getting a response from CreateProfile. In this case, safely retry your call to
  CreateProfile by using the same CreateProfile parameter value.
- `name`:  A name for the Profile.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`:  A list of the tag keys and values that you want to associate with the Route 53
  Profile.
"""
function create_profile(
    ClientToken, Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53profiles(
        "POST",
        "/profile",
        Dict{String,Any}("ClientToken" => ClientToken, "Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_profile(
    ClientToken,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53profiles(
        "POST",
        "/profile",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ClientToken" => ClientToken, "Name" => Name),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_profile(profile_id)
    delete_profile(profile_id, params::Dict{String,<:Any})

 Deletes the specified Route 53 Profile. Before you can delete a profile, you must first
disassociate it from all VPCs.

# Arguments
- `profile_id`:  The ID of the Profile that you want to delete.

"""
function delete_profile(ProfileId; aws_config::AbstractAWSConfig=current_aws_config())
    return route53profiles(
        "DELETE",
        "/profile/$(ProfileId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_profile(
    ProfileId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53profiles(
        "DELETE",
        "/profile/$(ProfileId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_profile(profile_id, resource_id)
    disassociate_profile(profile_id, resource_id, params::Dict{String,<:Any})

 Dissociates a specified Route 53 Profile from the specified VPC.

# Arguments
- `profile_id`:  ID of the Profile.
- `resource_id`:  The ID of the VPC.

"""
function disassociate_profile(
    ProfileId, ResourceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53profiles(
        "DELETE",
        "/profileassociation/Profileid/$(ProfileId)/resourceid/$(ResourceId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_profile(
    ProfileId,
    ResourceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53profiles(
        "DELETE",
        "/profileassociation/Profileid/$(ProfileId)/resourceid/$(ResourceId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_resource_from_profile(profile_id, resource_arn)
    disassociate_resource_from_profile(profile_id, resource_arn, params::Dict{String,<:Any})

 Dissoaciated a specified resource, from the Route 53 Profile.

# Arguments
- `profile_id`:  The ID of the Profile.
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.

"""
function disassociate_resource_from_profile(
    ProfileId, ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53profiles(
        "DELETE",
        "/profileresourceassociation/profileid/$(ProfileId)/resourcearn/$(ResourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_resource_from_profile(
    ProfileId,
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53profiles(
        "DELETE",
        "/profileresourceassociation/profileid/$(ProfileId)/resourcearn/$(ResourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_profile(profile_id)
    get_profile(profile_id, params::Dict{String,<:Any})

 Returns information about a specified Route 53 Profile, such as whether whether the
Profile is shared, and the current status of the Profile.

# Arguments
- `profile_id`:  ID of the Profile.

"""
function get_profile(ProfileId; aws_config::AbstractAWSConfig=current_aws_config())
    return route53profiles(
        "GET",
        "/profile/$(ProfileId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_profile(
    ProfileId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53profiles(
        "GET",
        "/profile/$(ProfileId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_profile_association(profile_association_id)
    get_profile_association(profile_association_id, params::Dict{String,<:Any})

 Retrieves a Route 53 Profile association for a VPC. A VPC can have only one Profile
association, but a Profile can be associated with up to 5000 VPCs.

# Arguments
- `profile_association_id`:  The identifier of the association you want to get information
  about.

"""
function get_profile_association(
    ProfileAssociationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53profiles(
        "GET",
        "/profileassociation/$(ProfileAssociationId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_profile_association(
    ProfileAssociationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53profiles(
        "GET",
        "/profileassociation/$(ProfileAssociationId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_profile_resource_association(profile_resource_association_id)
    get_profile_resource_association(profile_resource_association_id, params::Dict{String,<:Any})

 Returns information about a specified Route 53 Profile resource association.

# Arguments
- `profile_resource_association_id`:  The ID of the profile resource association that you
  want to get information about.

"""
function get_profile_resource_association(
    ProfileResourceAssociationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53profiles(
        "GET",
        "/profileresourceassociation/$(ProfileResourceAssociationId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_profile_resource_association(
    ProfileResourceAssociationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53profiles(
        "GET",
        "/profileresourceassociation/$(ProfileResourceAssociationId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_profile_associations()
    list_profile_associations(params::Dict{String,<:Any})

 Lists all the VPCs that the specified Route 53 Profile is associated with.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:  The maximum number of objects that you want to return for this request.
  If more objects are available, in the response, a NextToken value, which you can use in a
  subsequent call to get the next batch of objects, is provided.  If you don't specify a
  value for MaxResults, up to 100 objects are returned.
- `"nextToken"`:  For the first call to this list request, omit this value.  When you
  request a list of objects, at most the number of objects specified by MaxResults is
  returned. If more objects are available for retrieval, a NextToken value is returned in the
  response. To retrieve the next batch of objects, use the token that was returned for the
  prior request in your next request.
- `"profileId"`:  ID of the Profile.
- `"resourceId"`:  ID of the VPC.
"""
function list_profile_associations(; aws_config::AbstractAWSConfig=current_aws_config())
    return route53profiles(
        "GET",
        "/profileassociations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_profile_associations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53profiles(
        "GET",
        "/profileassociations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_profile_resource_associations(profile_id)
    list_profile_resource_associations(profile_id, params::Dict{String,<:Any})

 Lists all the resource associations for the specified Route 53 Profile.

# Arguments
- `profile_id`:  The ID of the Profile.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:  The maximum number of objects that you want to return for this request.
  If more objects are available, in the response, a NextToken value, which you can use in a
  subsequent call to get the next batch of objects, is provided.  If you don't specify a
  value for MaxResults, up to 100 objects are returned.
- `"nextToken"`:  For the first call to this list request, omit this value.  When you
  request a list of objects, at most the number of objects specified by MaxResults is
  returned. If more objects are available for retrieval, a NextToken value is returned in the
  response. To retrieve the next batch of objects, use the token that was returned for the
  prior request in your next request.
- `"resourceType"`:  ID of a resource if you want information on only one type.
"""
function list_profile_resource_associations(
    ProfileId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53profiles(
        "GET",
        "/profileresourceassociations/profileid/$(ProfileId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_profile_resource_associations(
    ProfileId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53profiles(
        "GET",
        "/profileresourceassociations/profileid/$(ProfileId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_profiles()
    list_profiles(params::Dict{String,<:Any})

 Lists all the Route 53 Profiles associated with your Amazon Web Services account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:  The maximum number of objects that you want to return for this request.
  If more objects are available, in the response, a NextToken value, which you can use in a
  subsequent call to get the next batch of objects, is provided.  If you don't specify a
  value for MaxResults, up to 100 objects are returned.
- `"nextToken"`:  For the first call to this list request, omit this value.  When you
  request a list of objects, at most the number of objects specified by MaxResults is
  returned. If more objects are available for retrieval, a NextToken value is returned in the
  response. To retrieve the next batch of objects, use the token that was returned for the
  prior request in your next request.
"""
function list_profiles(; aws_config::AbstractAWSConfig=current_aws_config())
    return route53profiles(
        "GET", "/profiles"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_profiles(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53profiles(
        "GET", "/profiles", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

 Lists the tags that you associated with the specified resource.

# Arguments
- `resource_arn`:  The Amazon Resource Name (ARN) for the resource that you want to list
  the tags for.

"""
function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53profiles(
        "GET",
        "/tags/$(ResourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53profiles(
        "GET",
        "/tags/$(ResourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

 Adds one or more tags to a specified resource.

# Arguments
- `resource_arn`:  The Amazon Resource Name (ARN) for the resource that you want to add
  tags to.
- `tags`:  The tags that you want to add to the specified resource.

"""
function tag_resource(ResourceArn, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return route53profiles(
        "POST",
        "/tags/$(ResourceArn)",
        Dict{String,Any}("Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceArn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53profiles(
        "POST",
        "/tags/$(ResourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Tags" => Tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

 Removes one or more tags from a specified resource.

# Arguments
- `resource_arn`:  The Amazon Resource Name (ARN) for the resource that you want to remove
  tags from.
- `tag_keys`:  The tags that you want to remove to the specified resource.

"""
function untag_resource(
    ResourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53profiles(
        "DELETE",
        "/tags/$(ResourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53profiles(
        "DELETE",
        "/tags/$(ResourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_profile_resource_association(profile_resource_association_id)
    update_profile_resource_association(profile_resource_association_id, params::Dict{String,<:Any})

 Updates the specified Route 53 Profile resourse association.

# Arguments
- `profile_resource_association_id`:  ID of the resource association.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Name"`:  Name of the resource association.
- `"ResourceProperties"`:  If you are adding a DNS Firewall rule group, include also a
  priority. The priority indicates the processing order for the rule groups, starting with
  the priority assinged the lowest value.  The allowed values for priority are between 100
  and 9900.
"""
function update_profile_resource_association(
    ProfileResourceAssociationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route53profiles(
        "PATCH",
        "/profileresourceassociation/$(ProfileResourceAssociationId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_profile_resource_association(
    ProfileResourceAssociationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route53profiles(
        "PATCH",
        "/profileresourceassociation/$(ProfileResourceAssociationId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: bedrock_agent
using AWS.Compat
using AWS.UUIDs

"""
    associate_agent_knowledge_base(agent_id, agent_version, description, knowledge_base_id)
    associate_agent_knowledge_base(agent_id, agent_version, description, knowledge_base_id, params::Dict{String,<:Any})

Associates a knowledge base with an agent. If a knowledge base is associated and its
indexState is set to Enabled, the agent queries the knowledge base for information to
augment its response to the user.

# Arguments
- `agent_id`: The unique identifier of the agent with which you want to associate the
  knowledge base.
- `agent_version`: The version of the agent with which you want to associate the knowledge
  base.
- `description`: A description of what the agent should use the knowledge base for.
- `knowledge_base_id`: The unique identifier of the knowledge base to associate with the
  agent.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"knowledgeBaseState"`: Specifies whether to use the knowledge base or not when sending
  an InvokeAgent request.
"""
function associate_agent_knowledge_base(
    agentId,
    agentVersion,
    description,
    knowledgeBaseId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_agent(
        "PUT",
        "/agents/$(agentId)/agentversions/$(agentVersion)/knowledgebases/",
        Dict{String,Any}(
            "description" => description, "knowledgeBaseId" => knowledgeBaseId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_agent_knowledge_base(
    agentId,
    agentVersion,
    description,
    knowledgeBaseId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_agent(
        "PUT",
        "/agents/$(agentId)/agentversions/$(agentVersion)/knowledgebases/",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "description" => description, "knowledgeBaseId" => knowledgeBaseId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_agent(agent_name)
    create_agent(agent_name, params::Dict{String,<:Any})

Creates an agent that orchestrates interactions between foundation models, data sources,
software applications, user conversations, and APIs to carry out tasks to help customers.
Specify the following fields for security purposes.    agentResourceRoleArn – The Amazon
Resource Name (ARN) of the role with permissions to invoke API operations on an agent.
(Optional) customerEncryptionKeyArn – The Amazon Resource Name (ARN) of a KMS key to
encrypt the creation of the agent.   (Optional) idleSessionTTLinSeconds – Specify the
number of seconds for which the agent should maintain session information. After this time
expires, the subsequent InvokeAgent request begins a new session.     To override the
default prompt behavior for agent orchestration and to use advanced prompts, include a
promptOverrideConfiguration object. For more information, see Advanced prompts.   If you
agent fails to be created, the response returns a list of failureReasons alongside a list
of recommendedActions for you to troubleshoot.

# Arguments
- `agent_name`: A name for the agent that you create.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"agentResourceRoleArn"`: The Amazon Resource Name (ARN) of the IAM role with permissions
  to invoke API operations on the agent.
- `"clientToken"`: A unique, case-sensitive identifier to ensure that the API request
  completes no more than one time. If this token matches a previous request, Amazon Bedrock
  ignores the request, but does not return an error. For more information, see Ensuring
  idempotency.
- `"customerEncryptionKeyArn"`: The Amazon Resource Name (ARN) of the KMS key with which to
  encrypt the agent.
- `"description"`: A description of the agent.
- `"foundationModel"`: The foundation model to be used for orchestration by the agent you
  create.
- `"guardrailConfiguration"`: The unique Guardrail configuration assigned to the agent when
  it is created.
- `"idleSessionTTLInSeconds"`: The number of seconds for which Amazon Bedrock keeps
  information about a user's conversation with the agent. A user interaction remains active
  for the amount of time specified. If no conversation occurs during this time, the session
  expires and Amazon Bedrock deletes any data provided before the timeout.
- `"instruction"`: Instructions that tell the agent what it should do and how it should
  interact with users.
- `"promptOverrideConfiguration"`: Contains configurations to override prompts in different
  parts of an agent sequence. For more information, see Advanced prompts.
- `"tags"`: Any tags that you want to attach to the agent.
"""
function create_agent(agentName; aws_config::AbstractAWSConfig=current_aws_config())
    return bedrock_agent(
        "PUT",
        "/agents/",
        Dict{String,Any}("agentName" => agentName, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_agent(
    agentName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_agent(
        "PUT",
        "/agents/",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "agentName" => agentName, "clientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_agent_action_group(action_group_name, agent_id, agent_version)
    create_agent_action_group(action_group_name, agent_id, agent_version, params::Dict{String,<:Any})

Creates an action group for an agent. An action group represents the actions that an agent
can carry out for the customer by defining the APIs that an agent can call and the logic
for calling them. To allow your agent to request the user for additional information when
trying to complete a task, add an action group with the parentActionGroupSignature field
set to AMAZON.UserInput. You must leave the description, apiSchema, and actionGroupExecutor
fields blank for this action group. During orchestration, if your agent determines that it
needs to invoke an API in an action group, but doesn't have enough information to complete
the API request, it will invoke this action group instead and return an Observation
reprompting the user for more information.

# Arguments
- `action_group_name`: The name to give the action group.
- `agent_id`: The unique identifier of the agent for which to create the action group.
- `agent_version`: The version of the agent for which to create the action group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"actionGroupExecutor"`: The Amazon Resource Name (ARN) of the Lambda function containing
  the business logic that is carried out upon invoking the action or the custom control
  method for handling the information elicited from the user.
- `"actionGroupState"`: Specifies whether the action group is available for the agent to
  invoke or not when sending an InvokeAgent request.
- `"apiSchema"`: Contains either details about the S3 object containing the OpenAPI schema
  for the action group or the JSON or YAML-formatted payload defining the schema. For more
  information, see Action group OpenAPI schemas.
- `"clientToken"`: A unique, case-sensitive identifier to ensure that the API request
  completes no more than one time. If this token matches a previous request, Amazon Bedrock
  ignores the request, but does not return an error. For more information, see Ensuring
  idempotency.
- `"description"`: A description of the action group.
- `"functionSchema"`: Contains details about the function schema for the action group or
  the JSON or YAML-formatted payload defining the schema.
- `"parentActionGroupSignature"`: To allow your agent to request the user for additional
  information when trying to complete a task, set this field to AMAZON.UserInput. You must
  leave the description, apiSchema, and actionGroupExecutor fields blank for this action
  group. During orchestration, if your agent determines that it needs to invoke an API in an
  action group, but doesn't have enough information to complete the API request, it will
  invoke this action group instead and return an Observation reprompting the user for more
  information.
"""
function create_agent_action_group(
    actionGroupName,
    agentId,
    agentVersion;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_agent(
        "PUT",
        "/agents/$(agentId)/agentversions/$(agentVersion)/actiongroups/",
        Dict{String,Any}(
            "actionGroupName" => actionGroupName, "clientToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_agent_action_group(
    actionGroupName,
    agentId,
    agentVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_agent(
        "PUT",
        "/agents/$(agentId)/agentversions/$(agentVersion)/actiongroups/",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "actionGroupName" => actionGroupName, "clientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_agent_alias(agent_alias_name, agent_id)
    create_agent_alias(agent_alias_name, agent_id, params::Dict{String,<:Any})

Creates an alias of an agent that can be used to deploy the agent.

# Arguments
- `agent_alias_name`: The name of the alias.
- `agent_id`: The unique identifier of the agent.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier to ensure that the API request
  completes no more than one time. If this token matches a previous request, Amazon Bedrock
  ignores the request, but does not return an error. For more information, see Ensuring
  idempotency.
- `"description"`: A description of the alias of the agent.
- `"routingConfiguration"`: Contains details about the routing configuration of the alias.
- `"tags"`: Any tags that you want to attach to the alias of the agent.
"""
function create_agent_alias(
    agentAliasName, agentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock_agent(
        "PUT",
        "/agents/$(agentId)/agentaliases/",
        Dict{String,Any}(
            "agentAliasName" => agentAliasName, "clientToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_agent_alias(
    agentAliasName,
    agentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_agent(
        "PUT",
        "/agents/$(agentId)/agentaliases/",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "agentAliasName" => agentAliasName, "clientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_data_source(data_source_configuration, knowledge_base_id, name)
    create_data_source(data_source_configuration, knowledge_base_id, name, params::Dict{String,<:Any})

Sets up a data source to be added to a knowledge base.  You can't change the
chunkingConfiguration after you create the data source.

# Arguments
- `data_source_configuration`: Contains metadata about where the data source is stored.
- `knowledge_base_id`: The unique identifier of the knowledge base to which to add the data
  source.
- `name`: The name of the data source.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier to ensure that the API request
  completes no more than one time. If this token matches a previous request, Amazon Bedrock
  ignores the request, but does not return an error. For more information, see Ensuring
  idempotency.
- `"dataDeletionPolicy"`: The data deletion policy assigned to the data source.
- `"description"`: A description of the data source.
- `"serverSideEncryptionConfiguration"`: Contains details about the server-side encryption
  for the data source.
- `"vectorIngestionConfiguration"`: Contains details about how to ingest the documents in
  the data source.
"""
function create_data_source(
    dataSourceConfiguration,
    knowledgeBaseId,
    name;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_agent(
        "PUT",
        "/knowledgebases/$(knowledgeBaseId)/datasources/",
        Dict{String,Any}(
            "dataSourceConfiguration" => dataSourceConfiguration,
            "name" => name,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_data_source(
    dataSourceConfiguration,
    knowledgeBaseId,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_agent(
        "PUT",
        "/knowledgebases/$(knowledgeBaseId)/datasources/",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "dataSourceConfiguration" => dataSourceConfiguration,
                    "name" => name,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_knowledge_base(knowledge_base_configuration, name, role_arn, storage_configuration)
    create_knowledge_base(knowledge_base_configuration, name, role_arn, storage_configuration, params::Dict{String,<:Any})

Creates a knowledge base that contains data sources from which information can be queried
and used by LLMs. To create a knowledge base, you must first set up your data sources and
configure a supported vector store. For more information, see Set up your data for
ingestion.  If you prefer to let Amazon Bedrock create and manage a vector store for you in
Amazon OpenSearch Service, use the console. For more information, see Create a knowledge
base.    Provide the name and an optional description.   Provide the Amazon Resource Name
(ARN) with permissions to create a knowledge base in the roleArn field.   Provide the
embedding model to use in the embeddingModelArn field in the knowledgeBaseConfiguration
object.   Provide the configuration for your vector store in the storageConfiguration
object.   For an Amazon OpenSearch Service database, use the
opensearchServerlessConfiguration object. For more information, see Create a vector store
in Amazon OpenSearch Service.   For an Amazon Aurora database, use the RdsConfiguration
object. For more information, see Create a vector store in Amazon Aurora.   For a Pinecone
database, use the pineconeConfiguration object. For more information, see Create a vector
store in Pinecone.   For a Redis Enterprise Cloud database, use the
redisEnterpriseCloudConfiguration object. For more information, see Create a vector store
in Redis Enterprise Cloud.

# Arguments
- `knowledge_base_configuration`: Contains details about the embeddings model used for the
  knowledge base.
- `name`: A name for the knowledge base.
- `role_arn`: The Amazon Resource Name (ARN) of the IAM role with permissions to invoke API
  operations on the knowledge base.
- `storage_configuration`: Contains details about the configuration of the vector database
  used for the knowledge base.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier to ensure that the API request
  completes no more than one time. If this token matches a previous request, Amazon Bedrock
  ignores the request, but does not return an error. For more information, see Ensuring
  idempotency.
- `"description"`: A description of the knowledge base.
- `"tags"`: Specify the key-value pairs for the tags that you want to attach to your
  knowledge base in this object.
"""
function create_knowledge_base(
    knowledgeBaseConfiguration,
    name,
    roleArn,
    storageConfiguration;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_agent(
        "PUT",
        "/knowledgebases/",
        Dict{String,Any}(
            "knowledgeBaseConfiguration" => knowledgeBaseConfiguration,
            "name" => name,
            "roleArn" => roleArn,
            "storageConfiguration" => storageConfiguration,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_knowledge_base(
    knowledgeBaseConfiguration,
    name,
    roleArn,
    storageConfiguration,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_agent(
        "PUT",
        "/knowledgebases/",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "knowledgeBaseConfiguration" => knowledgeBaseConfiguration,
                    "name" => name,
                    "roleArn" => roleArn,
                    "storageConfiguration" => storageConfiguration,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_agent(agent_id)
    delete_agent(agent_id, params::Dict{String,<:Any})

Deletes an agent.

# Arguments
- `agent_id`: The unique identifier of the agent to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"skipResourceInUseCheck"`: By default, this value is false and deletion is stopped if
  the resource is in use. If you set it to true, the resource will be deleted even if the
  resource is in use.
"""
function delete_agent(agentId; aws_config::AbstractAWSConfig=current_aws_config())
    return bedrock_agent(
        "DELETE",
        "/agents/$(agentId)/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_agent(
    agentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_agent(
        "DELETE",
        "/agents/$(agentId)/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_agent_action_group(action_group_id, agent_id, agent_version)
    delete_agent_action_group(action_group_id, agent_id, agent_version, params::Dict{String,<:Any})

Deletes an action group in an agent.

# Arguments
- `action_group_id`: The unique identifier of the action group to delete.
- `agent_id`: The unique identifier of the agent that the action group belongs to.
- `agent_version`: The version of the agent that the action group belongs to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"skipResourceInUseCheck"`: By default, this value is false and deletion is stopped if
  the resource is in use. If you set it to true, the resource will be deleted even if the
  resource is in use.
"""
function delete_agent_action_group(
    actionGroupId, agentId, agentVersion; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock_agent(
        "DELETE",
        "/agents/$(agentId)/agentversions/$(agentVersion)/actiongroups/$(actionGroupId)/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_agent_action_group(
    actionGroupId,
    agentId,
    agentVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_agent(
        "DELETE",
        "/agents/$(agentId)/agentversions/$(agentVersion)/actiongroups/$(actionGroupId)/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_agent_alias(agent_alias_id, agent_id)
    delete_agent_alias(agent_alias_id, agent_id, params::Dict{String,<:Any})

Deletes an alias of an agent.

# Arguments
- `agent_alias_id`: The unique identifier of the alias to delete.
- `agent_id`: The unique identifier of the agent that the alias belongs to.

"""
function delete_agent_alias(
    agentAliasId, agentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock_agent(
        "DELETE",
        "/agents/$(agentId)/agentaliases/$(agentAliasId)/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_agent_alias(
    agentAliasId,
    agentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_agent(
        "DELETE",
        "/agents/$(agentId)/agentaliases/$(agentAliasId)/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_agent_version(agent_id, agent_version)
    delete_agent_version(agent_id, agent_version, params::Dict{String,<:Any})

Deletes a version of an agent.

# Arguments
- `agent_id`: The unique identifier of the agent that the version belongs to.
- `agent_version`: The version of the agent to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"skipResourceInUseCheck"`: By default, this value is false and deletion is stopped if
  the resource is in use. If you set it to true, the resource will be deleted even if the
  resource is in use.
"""
function delete_agent_version(
    agentId, agentVersion; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock_agent(
        "DELETE",
        "/agents/$(agentId)/agentversions/$(agentVersion)/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_agent_version(
    agentId,
    agentVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_agent(
        "DELETE",
        "/agents/$(agentId)/agentversions/$(agentVersion)/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_data_source(data_source_id, knowledge_base_id)
    delete_data_source(data_source_id, knowledge_base_id, params::Dict{String,<:Any})

Deletes a data source from a knowledge base.

# Arguments
- `data_source_id`: The unique identifier of the data source to delete.
- `knowledge_base_id`: The unique identifier of the knowledge base from which to delete the
  data source.

"""
function delete_data_source(
    dataSourceId, knowledgeBaseId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock_agent(
        "DELETE",
        "/knowledgebases/$(knowledgeBaseId)/datasources/$(dataSourceId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_data_source(
    dataSourceId,
    knowledgeBaseId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_agent(
        "DELETE",
        "/knowledgebases/$(knowledgeBaseId)/datasources/$(dataSourceId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_knowledge_base(knowledge_base_id)
    delete_knowledge_base(knowledge_base_id, params::Dict{String,<:Any})

Deletes a knowledge base. Before deleting a knowledge base, you should disassociate the
knowledge base from any agents that it is associated with by making a
DisassociateAgentKnowledgeBase request.

# Arguments
- `knowledge_base_id`: The unique identifier of the knowledge base to delete.

"""
function delete_knowledge_base(
    knowledgeBaseId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock_agent(
        "DELETE",
        "/knowledgebases/$(knowledgeBaseId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_knowledge_base(
    knowledgeBaseId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_agent(
        "DELETE",
        "/knowledgebases/$(knowledgeBaseId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_agent_knowledge_base(agent_id, agent_version, knowledge_base_id)
    disassociate_agent_knowledge_base(agent_id, agent_version, knowledge_base_id, params::Dict{String,<:Any})

Disassociates a knowledge base from an agent.

# Arguments
- `agent_id`: The unique identifier of the agent from which to disassociate the knowledge
  base.
- `agent_version`: The version of the agent from which to disassociate the knowledge base.
- `knowledge_base_id`: The unique identifier of the knowledge base to disassociate.

"""
function disassociate_agent_knowledge_base(
    agentId,
    agentVersion,
    knowledgeBaseId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_agent(
        "DELETE",
        "/agents/$(agentId)/agentversions/$(agentVersion)/knowledgebases/$(knowledgeBaseId)/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_agent_knowledge_base(
    agentId,
    agentVersion,
    knowledgeBaseId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_agent(
        "DELETE",
        "/agents/$(agentId)/agentversions/$(agentVersion)/knowledgebases/$(knowledgeBaseId)/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_agent(agent_id)
    get_agent(agent_id, params::Dict{String,<:Any})

Gets information about an agent.

# Arguments
- `agent_id`: The unique identifier of the agent.

"""
function get_agent(agentId; aws_config::AbstractAWSConfig=current_aws_config())
    return bedrock_agent(
        "GET", "/agents/$(agentId)/"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_agent(
    agentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_agent(
        "GET",
        "/agents/$(agentId)/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_agent_action_group(action_group_id, agent_id, agent_version)
    get_agent_action_group(action_group_id, agent_id, agent_version, params::Dict{String,<:Any})

Gets information about an action group for an agent.

# Arguments
- `action_group_id`: The unique identifier of the action group for which to get information.
- `agent_id`: The unique identifier of the agent that the action group belongs to.
- `agent_version`: The version of the agent that the action group belongs to.

"""
function get_agent_action_group(
    actionGroupId, agentId, agentVersion; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock_agent(
        "GET",
        "/agents/$(agentId)/agentversions/$(agentVersion)/actiongroups/$(actionGroupId)/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_agent_action_group(
    actionGroupId,
    agentId,
    agentVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_agent(
        "GET",
        "/agents/$(agentId)/agentversions/$(agentVersion)/actiongroups/$(actionGroupId)/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_agent_alias(agent_alias_id, agent_id)
    get_agent_alias(agent_alias_id, agent_id, params::Dict{String,<:Any})

Gets information about an alias of an agent.

# Arguments
- `agent_alias_id`: The unique identifier of the alias for which to get information.
- `agent_id`: The unique identifier of the agent to which the alias to get information
  belongs.

"""
function get_agent_alias(
    agentAliasId, agentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock_agent(
        "GET",
        "/agents/$(agentId)/agentaliases/$(agentAliasId)/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_agent_alias(
    agentAliasId,
    agentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_agent(
        "GET",
        "/agents/$(agentId)/agentaliases/$(agentAliasId)/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_agent_knowledge_base(agent_id, agent_version, knowledge_base_id)
    get_agent_knowledge_base(agent_id, agent_version, knowledge_base_id, params::Dict{String,<:Any})

Gets information about a knowledge base associated with an agent.

# Arguments
- `agent_id`: The unique identifier of the agent with which the knowledge base is
  associated.
- `agent_version`: The version of the agent with which the knowledge base is associated.
- `knowledge_base_id`: The unique identifier of the knowledge base associated with the
  agent.

"""
function get_agent_knowledge_base(
    agentId,
    agentVersion,
    knowledgeBaseId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_agent(
        "GET",
        "/agents/$(agentId)/agentversions/$(agentVersion)/knowledgebases/$(knowledgeBaseId)/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_agent_knowledge_base(
    agentId,
    agentVersion,
    knowledgeBaseId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_agent(
        "GET",
        "/agents/$(agentId)/agentversions/$(agentVersion)/knowledgebases/$(knowledgeBaseId)/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_agent_version(agent_id, agent_version)
    get_agent_version(agent_id, agent_version, params::Dict{String,<:Any})

Gets details about a version of an agent.

# Arguments
- `agent_id`: The unique identifier of the agent.
- `agent_version`: The version of the agent.

"""
function get_agent_version(
    agentId, agentVersion; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock_agent(
        "GET",
        "/agents/$(agentId)/agentversions/$(agentVersion)/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_agent_version(
    agentId,
    agentVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_agent(
        "GET",
        "/agents/$(agentId)/agentversions/$(agentVersion)/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_data_source(data_source_id, knowledge_base_id)
    get_data_source(data_source_id, knowledge_base_id, params::Dict{String,<:Any})

Gets information about a data source.

# Arguments
- `data_source_id`: The unique identifier of the data source.
- `knowledge_base_id`: The unique identifier of the knowledge base that the data source was
  added to.

"""
function get_data_source(
    dataSourceId, knowledgeBaseId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock_agent(
        "GET",
        "/knowledgebases/$(knowledgeBaseId)/datasources/$(dataSourceId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_data_source(
    dataSourceId,
    knowledgeBaseId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_agent(
        "GET",
        "/knowledgebases/$(knowledgeBaseId)/datasources/$(dataSourceId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_ingestion_job(data_source_id, ingestion_job_id, knowledge_base_id)
    get_ingestion_job(data_source_id, ingestion_job_id, knowledge_base_id, params::Dict{String,<:Any})

Gets information about a ingestion job, in which a data source is added to a knowledge base.

# Arguments
- `data_source_id`: The unique identifier of the data source in the ingestion job.
- `ingestion_job_id`: The unique identifier of the ingestion job.
- `knowledge_base_id`: The unique identifier of the knowledge base for which the ingestion
  job applies.

"""
function get_ingestion_job(
    dataSourceId,
    ingestionJobId,
    knowledgeBaseId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_agent(
        "GET",
        "/knowledgebases/$(knowledgeBaseId)/datasources/$(dataSourceId)/ingestionjobs/$(ingestionJobId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_ingestion_job(
    dataSourceId,
    ingestionJobId,
    knowledgeBaseId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_agent(
        "GET",
        "/knowledgebases/$(knowledgeBaseId)/datasources/$(dataSourceId)/ingestionjobs/$(ingestionJobId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_knowledge_base(knowledge_base_id)
    get_knowledge_base(knowledge_base_id, params::Dict{String,<:Any})

Gets information about a knoweldge base.

# Arguments
- `knowledge_base_id`: The unique identifier of the knowledge base for which to get
  information.

"""
function get_knowledge_base(
    knowledgeBaseId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock_agent(
        "GET",
        "/knowledgebases/$(knowledgeBaseId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_knowledge_base(
    knowledgeBaseId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_agent(
        "GET",
        "/knowledgebases/$(knowledgeBaseId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_agent_action_groups(agent_id, agent_version)
    list_agent_action_groups(agent_id, agent_version, params::Dict{String,<:Any})

Lists the action groups for an agent and information about each one.

# Arguments
- `agent_id`: The unique identifier of the agent.
- `agent_version`: The version of the agent.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in the response. If the total
  number of results is greater than this value, use the token returned in the response in the
  nextToken field when making another request to return the next batch of results.
- `"nextToken"`: If the total number of results is greater than the maxResults value
  provided in the request, enter the token returned in the nextToken field in the response in
  this field to return the next batch of results.
"""
function list_agent_action_groups(
    agentId, agentVersion; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock_agent(
        "POST",
        "/agents/$(agentId)/agentversions/$(agentVersion)/actiongroups/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_agent_action_groups(
    agentId,
    agentVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_agent(
        "POST",
        "/agents/$(agentId)/agentversions/$(agentVersion)/actiongroups/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_agent_aliases(agent_id)
    list_agent_aliases(agent_id, params::Dict{String,<:Any})

Lists the aliases of an agent and information about each one.

# Arguments
- `agent_id`: The unique identifier of the agent.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in the response. If the total
  number of results is greater than this value, use the token returned in the response in the
  nextToken field when making another request to return the next batch of results.
- `"nextToken"`: If the total number of results is greater than the maxResults value
  provided in the request, enter the token returned in the nextToken field in the response in
  this field to return the next batch of results.
"""
function list_agent_aliases(agentId; aws_config::AbstractAWSConfig=current_aws_config())
    return bedrock_agent(
        "POST",
        "/agents/$(agentId)/agentaliases/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_agent_aliases(
    agentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_agent(
        "POST",
        "/agents/$(agentId)/agentaliases/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_agent_knowledge_bases(agent_id, agent_version)
    list_agent_knowledge_bases(agent_id, agent_version, params::Dict{String,<:Any})

Lists knowledge bases associated with an agent and information about each one.

# Arguments
- `agent_id`: The unique identifier of the agent for which to return information about
  knowledge bases associated with it.
- `agent_version`: The version of the agent for which to return information about knowledge
  bases associated with it.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in the response. If the total
  number of results is greater than this value, use the token returned in the response in the
  nextToken field when making another request to return the next batch of results.
- `"nextToken"`: If the total number of results is greater than the maxResults value
  provided in the request, enter the token returned in the nextToken field in the response in
  this field to return the next batch of results.
"""
function list_agent_knowledge_bases(
    agentId, agentVersion; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock_agent(
        "POST",
        "/agents/$(agentId)/agentversions/$(agentVersion)/knowledgebases/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_agent_knowledge_bases(
    agentId,
    agentVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_agent(
        "POST",
        "/agents/$(agentId)/agentversions/$(agentVersion)/knowledgebases/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_agent_versions(agent_id)
    list_agent_versions(agent_id, params::Dict{String,<:Any})

Lists the versions of an agent and information about each version.

# Arguments
- `agent_id`: The unique identifier of the agent.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in the response. If the total
  number of results is greater than this value, use the token returned in the response in the
  nextToken field when making another request to return the next batch of results.
- `"nextToken"`: If the total number of results is greater than the maxResults value
  provided in the request, enter the token returned in the nextToken field in the response in
  this field to return the next batch of results.
"""
function list_agent_versions(agentId; aws_config::AbstractAWSConfig=current_aws_config())
    return bedrock_agent(
        "POST",
        "/agents/$(agentId)/agentversions/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_agent_versions(
    agentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_agent(
        "POST",
        "/agents/$(agentId)/agentversions/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_agents()
    list_agents(params::Dict{String,<:Any})

Lists the agents belonging to an account and information about each agent.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in the response. If the total
  number of results is greater than this value, use the token returned in the response in the
  nextToken field when making another request to return the next batch of results.
- `"nextToken"`: If the total number of results is greater than the maxResults value
  provided in the request, enter the token returned in the nextToken field in the response in
  this field to return the next batch of results.
"""
function list_agents(; aws_config::AbstractAWSConfig=current_aws_config())
    return bedrock_agent(
        "POST", "/agents/"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_agents(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock_agent(
        "POST", "/agents/", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_data_sources(knowledge_base_id)
    list_data_sources(knowledge_base_id, params::Dict{String,<:Any})

Lists the data sources in a knowledge base and information about each one.

# Arguments
- `knowledge_base_id`: The unique identifier of the knowledge base for which to return a
  list of information.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in the response. If the total
  number of results is greater than this value, use the token returned in the response in the
  nextToken field when making another request to return the next batch of results.
- `"nextToken"`: If the total number of results is greater than the maxResults value
  provided in the request, enter the token returned in the nextToken field in the response in
  this field to return the next batch of results.
"""
function list_data_sources(
    knowledgeBaseId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock_agent(
        "POST",
        "/knowledgebases/$(knowledgeBaseId)/datasources/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_data_sources(
    knowledgeBaseId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_agent(
        "POST",
        "/knowledgebases/$(knowledgeBaseId)/datasources/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_ingestion_jobs(data_source_id, knowledge_base_id)
    list_ingestion_jobs(data_source_id, knowledge_base_id, params::Dict{String,<:Any})

Lists the ingestion jobs for a data source and information about each of them.

# Arguments
- `data_source_id`: The unique identifier of the data source for which to return ingestion
  jobs.
- `knowledge_base_id`: The unique identifier of the knowledge base for which to return
  ingestion jobs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: Contains a definition of a filter for which to filter the results.
- `"maxResults"`: The maximum number of results to return in the response. If the total
  number of results is greater than this value, use the token returned in the response in the
  nextToken field when making another request to return the next batch of results.
- `"nextToken"`: If the total number of results is greater than the maxResults value
  provided in the request, enter the token returned in the nextToken field in the response in
  this field to return the next batch of results.
- `"sortBy"`: Contains details about how to sort the results.
"""
function list_ingestion_jobs(
    dataSourceId, knowledgeBaseId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock_agent(
        "POST",
        "/knowledgebases/$(knowledgeBaseId)/datasources/$(dataSourceId)/ingestionjobs/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_ingestion_jobs(
    dataSourceId,
    knowledgeBaseId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_agent(
        "POST",
        "/knowledgebases/$(knowledgeBaseId)/datasources/$(dataSourceId)/ingestionjobs/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_knowledge_bases()
    list_knowledge_bases(params::Dict{String,<:Any})

Lists the knowledge bases in an account and information about each of them.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in the response. If the total
  number of results is greater than this value, use the token returned in the response in the
  nextToken field when making another request to return the next batch of results.
- `"nextToken"`: If the total number of results is greater than the maxResults value
  provided in the request, enter the token returned in the nextToken field in the response in
  this field to return the next batch of results.
"""
function list_knowledge_bases(; aws_config::AbstractAWSConfig=current_aws_config())
    return bedrock_agent(
        "POST", "/knowledgebases/"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_knowledge_bases(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock_agent(
        "POST",
        "/knowledgebases/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

List all the tags for the resource you specify.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource for which to list tags.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock_agent(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_agent(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    prepare_agent(agent_id)
    prepare_agent(agent_id, params::Dict{String,<:Any})

Creates a DRAFT version of the agent that can be used for internal testing.

# Arguments
- `agent_id`: The unique identifier of the agent for which to create a DRAFT version.

"""
function prepare_agent(agentId; aws_config::AbstractAWSConfig=current_aws_config())
    return bedrock_agent(
        "POST",
        "/agents/$(agentId)/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function prepare_agent(
    agentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_agent(
        "POST",
        "/agents/$(agentId)/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_ingestion_job(data_source_id, knowledge_base_id)
    start_ingestion_job(data_source_id, knowledge_base_id, params::Dict{String,<:Any})

Begins an ingestion job, in which a data source is added to a knowledge base.

# Arguments
- `data_source_id`: The unique identifier of the data source to ingest.
- `knowledge_base_id`: The unique identifier of the knowledge base to which to add the data
  source.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier to ensure that the API request
  completes no more than one time. If this token matches a previous request, Amazon Bedrock
  ignores the request, but does not return an error. For more information, see Ensuring
  idempotency.
- `"description"`: A description of the ingestion job.
"""
function start_ingestion_job(
    dataSourceId, knowledgeBaseId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock_agent(
        "PUT",
        "/knowledgebases/$(knowledgeBaseId)/datasources/$(dataSourceId)/ingestionjobs/",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_ingestion_job(
    dataSourceId,
    knowledgeBaseId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_agent(
        "PUT",
        "/knowledgebases/$(knowledgeBaseId)/datasources/$(dataSourceId)/ingestionjobs/",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Associate tags with a resource. For more information, see Tagging resources in the Amazon
Bedrock User Guide.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource to tag.
- `tags`: An object containing key-value pairs that define the tags to attach to the
  resource.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return bedrock_agent(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_agent(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Remove tags from a resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource from which to remove tags.
- `tag_keys`: A list of keys of the tags to remove from the resource.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock_agent(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_agent(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_agent(agent_id, agent_name, agent_resource_role_arn, foundation_model)
    update_agent(agent_id, agent_name, agent_resource_role_arn, foundation_model, params::Dict{String,<:Any})

Updates the configuration of an agent.

# Arguments
- `agent_id`: The unique identifier of the agent.
- `agent_name`: Specifies a new name for the agent.
- `agent_resource_role_arn`: The Amazon Resource Name (ARN) of the IAM role with
  permissions to invoke API operations on the agent.
- `foundation_model`: Specifies a new foundation model to be used for orchestration by the
  agent.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"customerEncryptionKeyArn"`: The Amazon Resource Name (ARN) of the KMS key with which to
  encrypt the agent.
- `"description"`: Specifies a new description of the agent.
- `"guardrailConfiguration"`: The unique Guardrail configuration assigned to the agent when
  it is updated.
- `"idleSessionTTLInSeconds"`: The number of seconds for which Amazon Bedrock keeps
  information about a user's conversation with the agent. A user interaction remains active
  for the amount of time specified. If no conversation occurs during this time, the session
  expires and Amazon Bedrock deletes any data provided before the timeout.
- `"instruction"`: Specifies new instructions that tell the agent what it should do and how
  it should interact with users.
- `"promptOverrideConfiguration"`: Contains configurations to override prompts in different
  parts of an agent sequence. For more information, see Advanced prompts.
"""
function update_agent(
    agentId,
    agentName,
    agentResourceRoleArn,
    foundationModel;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_agent(
        "PUT",
        "/agents/$(agentId)/",
        Dict{String,Any}(
            "agentName" => agentName,
            "agentResourceRoleArn" => agentResourceRoleArn,
            "foundationModel" => foundationModel,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_agent(
    agentId,
    agentName,
    agentResourceRoleArn,
    foundationModel,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_agent(
        "PUT",
        "/agents/$(agentId)/",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "agentName" => agentName,
                    "agentResourceRoleArn" => agentResourceRoleArn,
                    "foundationModel" => foundationModel,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_agent_action_group(action_group_id, action_group_name, agent_id, agent_version)
    update_agent_action_group(action_group_id, action_group_name, agent_id, agent_version, params::Dict{String,<:Any})

Updates the configuration for an action group for an agent.

# Arguments
- `action_group_id`: The unique identifier of the action group.
- `action_group_name`: Specifies a new name for the action group.
- `agent_id`: The unique identifier of the agent for which to update the action group.
- `agent_version`: The unique identifier of the agent version for which to update the
  action group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"actionGroupExecutor"`: The Amazon Resource Name (ARN) of the Lambda function containing
  the business logic that is carried out upon invoking the action.
- `"actionGroupState"`: Specifies whether the action group is available for the agent to
  invoke or not when sending an InvokeAgent request.
- `"apiSchema"`: Contains either details about the S3 object containing the OpenAPI schema
  for the action group or the JSON or YAML-formatted payload defining the schema. For more
  information, see Action group OpenAPI schemas.
- `"description"`: Specifies a new name for the action group.
- `"functionSchema"`: Contains details about the function schema for the action group or
  the JSON or YAML-formatted payload defining the schema.
- `"parentActionGroupSignature"`: To allow your agent to request the user for additional
  information when trying to complete a task, set this field to AMAZON.UserInput. You must
  leave the description, apiSchema, and actionGroupExecutor fields blank for this action
  group. During orchestration, if your agent determines that it needs to invoke an API in an
  action group, but doesn't have enough information to complete the API request, it will
  invoke this action group instead and return an Observation reprompting the user for more
  information.
"""
function update_agent_action_group(
    actionGroupId,
    actionGroupName,
    agentId,
    agentVersion;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_agent(
        "PUT",
        "/agents/$(agentId)/agentversions/$(agentVersion)/actiongroups/$(actionGroupId)/",
        Dict{String,Any}("actionGroupName" => actionGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_agent_action_group(
    actionGroupId,
    actionGroupName,
    agentId,
    agentVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_agent(
        "PUT",
        "/agents/$(agentId)/agentversions/$(agentVersion)/actiongroups/$(actionGroupId)/",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("actionGroupName" => actionGroupName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_agent_alias(agent_alias_id, agent_alias_name, agent_id)
    update_agent_alias(agent_alias_id, agent_alias_name, agent_id, params::Dict{String,<:Any})

Updates configurations for an alias of an agent.

# Arguments
- `agent_alias_id`: The unique identifier of the alias.
- `agent_alias_name`: Specifies a new name for the alias.
- `agent_id`: The unique identifier of the agent.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: Specifies a new description for the alias.
- `"routingConfiguration"`: Contains details about the routing configuration of the alias.
"""
function update_agent_alias(
    agentAliasId,
    agentAliasName,
    agentId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_agent(
        "PUT",
        "/agents/$(agentId)/agentaliases/$(agentAliasId)/",
        Dict{String,Any}("agentAliasName" => agentAliasName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_agent_alias(
    agentAliasId,
    agentAliasName,
    agentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_agent(
        "PUT",
        "/agents/$(agentId)/agentaliases/$(agentAliasId)/",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("agentAliasName" => agentAliasName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_agent_knowledge_base(agent_id, agent_version, knowledge_base_id)
    update_agent_knowledge_base(agent_id, agent_version, knowledge_base_id, params::Dict{String,<:Any})

Updates the configuration for a knowledge base that has been associated with an agent.

# Arguments
- `agent_id`: The unique identifier of the agent associated with the knowledge base that
  you want to update.
- `agent_version`: The version of the agent associated with the knowledge base that you
  want to update.
- `knowledge_base_id`: The unique identifier of the knowledge base that has been associated
  with an agent.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: Specifies a new description for the knowledge base associated with an
  agent.
- `"knowledgeBaseState"`: Specifies whether the agent uses the knowledge base or not when
  sending an InvokeAgent request.
"""
function update_agent_knowledge_base(
    agentId,
    agentVersion,
    knowledgeBaseId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_agent(
        "PUT",
        "/agents/$(agentId)/agentversions/$(agentVersion)/knowledgebases/$(knowledgeBaseId)/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_agent_knowledge_base(
    agentId,
    agentVersion,
    knowledgeBaseId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_agent(
        "PUT",
        "/agents/$(agentId)/agentversions/$(agentVersion)/knowledgebases/$(knowledgeBaseId)/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_data_source(data_source_configuration, data_source_id, knowledge_base_id, name)
    update_data_source(data_source_configuration, data_source_id, knowledge_base_id, name, params::Dict{String,<:Any})

Updates configurations for a data source.  You can't change the chunkingConfiguration after
you create the data source. Specify the existing chunkingConfiguration.

# Arguments
- `data_source_configuration`: Contains details about the storage configuration of the data
  source.
- `data_source_id`: The unique identifier of the data source.
- `knowledge_base_id`: The unique identifier of the knowledge base to which the data source
  belongs.
- `name`: Specifies a new name for the data source.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"dataDeletionPolicy"`: The data deletion policy of the updated data source.
- `"description"`: Specifies a new description for the data source.
- `"serverSideEncryptionConfiguration"`: Contains details about server-side encryption of
  the data source.
- `"vectorIngestionConfiguration"`: Contains details about how to ingest the documents in
  the data source.
"""
function update_data_source(
    dataSourceConfiguration,
    dataSourceId,
    knowledgeBaseId,
    name;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_agent(
        "PUT",
        "/knowledgebases/$(knowledgeBaseId)/datasources/$(dataSourceId)",
        Dict{String,Any}(
            "dataSourceConfiguration" => dataSourceConfiguration, "name" => name
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_data_source(
    dataSourceConfiguration,
    dataSourceId,
    knowledgeBaseId,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_agent(
        "PUT",
        "/knowledgebases/$(knowledgeBaseId)/datasources/$(dataSourceId)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "dataSourceConfiguration" => dataSourceConfiguration, "name" => name
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_knowledge_base(knowledge_base_configuration, knowledge_base_id, name, role_arn, storage_configuration)
    update_knowledge_base(knowledge_base_configuration, knowledge_base_id, name, role_arn, storage_configuration, params::Dict{String,<:Any})

Updates the configuration of a knowledge base with the fields that you specify. Because all
fields will be overwritten, you must include the same values for fields that you want to
keep the same. You can change the following fields:    name     description     roleArn
You can't change the knowledgeBaseConfiguration or storageConfiguration fields, so you must
specify the same configurations as when you created the knowledge base. You can send a
GetKnowledgeBase request and copy the same configurations.

# Arguments
- `knowledge_base_configuration`: Specifies the configuration for the embeddings model used
  for the knowledge base. You must use the same configuration as when the knowledge base was
  created.
- `knowledge_base_id`: The unique identifier of the knowledge base to update.
- `name`: Specifies a new name for the knowledge base.
- `role_arn`: Specifies a different Amazon Resource Name (ARN) of the IAM role with
  permissions to invoke API operations on the knowledge base.
- `storage_configuration`: Specifies the configuration for the vector store used for the
  knowledge base. You must use the same configuration as when the knowledge base was created.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: Specifies a new description for the knowledge base.
"""
function update_knowledge_base(
    knowledgeBaseConfiguration,
    knowledgeBaseId,
    name,
    roleArn,
    storageConfiguration;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_agent(
        "PUT",
        "/knowledgebases/$(knowledgeBaseId)",
        Dict{String,Any}(
            "knowledgeBaseConfiguration" => knowledgeBaseConfiguration,
            "name" => name,
            "roleArn" => roleArn,
            "storageConfiguration" => storageConfiguration,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_knowledge_base(
    knowledgeBaseConfiguration,
    knowledgeBaseId,
    name,
    roleArn,
    storageConfiguration,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_agent(
        "PUT",
        "/knowledgebases/$(knowledgeBaseId)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "knowledgeBaseConfiguration" => knowledgeBaseConfiguration,
                    "name" => name,
                    "roleArn" => roleArn,
                    "storageConfiguration" => storageConfiguration,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: memorydb
using AWS.Compat
using AWS.UUIDs

"""
    batch_update_cluster(cluster_names)
    batch_update_cluster(cluster_names, params::Dict{String,<:Any})

Apply the service update to a list of clusters supplied. For more information on service
updates and applying them, see Applying the service updates.

# Arguments
- `cluster_names`: The cluster names to apply the updates.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ServiceUpdate"`: The unique ID of the service update
"""
function batch_update_cluster(
    ClusterNames; aws_config::AbstractAWSConfig=current_aws_config()
)
    return memorydb(
        "BatchUpdateCluster",
        Dict{String,Any}("ClusterNames" => ClusterNames);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_update_cluster(
    ClusterNames,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return memorydb(
        "BatchUpdateCluster",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ClusterNames" => ClusterNames), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    copy_snapshot(source_snapshot_name, target_snapshot_name)
    copy_snapshot(source_snapshot_name, target_snapshot_name, params::Dict{String,<:Any})

Makes a copy of an existing snapshot.

# Arguments
- `source_snapshot_name`: The name of an existing snapshot from which to make a copy.
- `target_snapshot_name`: A name for the snapshot copy. MemoryDB does not permit
  overwriting a snapshot, therefore this name must be unique within its context - MemoryDB or
  an Amazon S3 bucket if exporting.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"KmsKeyId"`: The ID of the KMS key used to encrypt the target snapshot.
- `"Tags"`: A list of tags to be added to this resource. A tag is a key-value pair. A tag
  key must be accompanied by a tag value, although null is accepted.
- `"TargetBucket"`: The Amazon S3 bucket to which the snapshot is exported. This parameter
  is used only when exporting a snapshot for external access. When using this parameter to
  export a snapshot, be sure MemoryDB has the needed permissions to this S3 bucket. For more
  information, see Step 2: Grant MemoryDB Access to Your Amazon S3 Bucket.
"""
function copy_snapshot(
    SourceSnapshotName,
    TargetSnapshotName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return memorydb(
        "CopySnapshot",
        Dict{String,Any}(
            "SourceSnapshotName" => SourceSnapshotName,
            "TargetSnapshotName" => TargetSnapshotName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function copy_snapshot(
    SourceSnapshotName,
    TargetSnapshotName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return memorydb(
        "CopySnapshot",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "SourceSnapshotName" => SourceSnapshotName,
                    "TargetSnapshotName" => TargetSnapshotName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_acl(aclname)
    create_acl(aclname, params::Dict{String,<:Any})

Creates an Access Control List. For more information, see Authenticating users with Access
Contol Lists (ACLs).

# Arguments
- `aclname`: The name of the Access Control List.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: A list of tags to be added to this resource. A tag is a key-value pair. A tag
  key must be accompanied by a tag value, although null is accepted.
- `"UserNames"`: The list of users that belong to the Access Control List.
"""
function create_acl(ACLName; aws_config::AbstractAWSConfig=current_aws_config())
    return memorydb(
        "CreateACL",
        Dict{String,Any}("ACLName" => ACLName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_acl(
    ACLName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return memorydb(
        "CreateACL",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("ACLName" => ACLName), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_cluster(aclname, cluster_name, node_type)
    create_cluster(aclname, cluster_name, node_type, params::Dict{String,<:Any})

Creates a cluster. All nodes in the cluster run the same protocol-compliant engine software.

# Arguments
- `aclname`: The name of the Access Control List to associate with the cluster.
- `cluster_name`: The name of the cluster. This value must be unique as it also serves as
  the cluster identifier.
- `node_type`: The compute and memory capacity of the nodes in the cluster.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AutoMinorVersionUpgrade"`: When set to true, the cluster will automatically receive
  minor engine version upgrades after launch.
- `"DataTiering"`: Enables data tiering. Data tiering is only supported for clusters using
  the r6gd node type. This parameter must be set when using r6gd nodes. For more information,
  see Data tiering.
- `"Description"`: An optional description of the cluster.
- `"EngineVersion"`: The version number of the Redis engine to be used for the cluster.
- `"KmsKeyId"`: The ID of the KMS key used to encrypt the cluster.
- `"MaintenanceWindow"`: Specifies the weekly time range during which maintenance on the
  cluster is performed. It is specified as a range in the format ddd:hh24:mi-ddd:hh24:mi (24H
  Clock UTC). The minimum maintenance window is a 60 minute period. Valid values for ddd are:
     sun     mon     tue     wed     thu     fri     sat    Example: sun:23:00-mon:01:30
- `"NumReplicasPerShard"`: The number of replicas to apply to each shard. The default value
  is 1. The maximum is 5.
- `"NumShards"`: The number of shards the cluster will contain. The default value is 1.
- `"ParameterGroupName"`: The name of the parameter group associated with the cluster.
- `"Port"`: The port number on which each of the nodes accepts connections.
- `"SecurityGroupIds"`: A list of security group names to associate with this cluster.
- `"SnapshotArns"`: A list of Amazon Resource Names (ARN) that uniquely identify the RDB
  snapshot files stored in Amazon S3. The snapshot files are used to populate the new
  cluster. The Amazon S3 object name in the ARN cannot contain any commas.
- `"SnapshotName"`: The name of a snapshot from which to restore data into the new cluster.
  The snapshot status changes to restoring while the new cluster is being created.
- `"SnapshotRetentionLimit"`: The number of days for which MemoryDB retains automatic
  snapshots before deleting them. For example, if you set SnapshotRetentionLimit to 5, a
  snapshot that was taken today is retained for 5 days before being deleted.
- `"SnapshotWindow"`: The daily time range (in UTC) during which MemoryDB begins taking a
  daily snapshot of your shard.  Example: 05:00-09:00  If you do not specify this parameter,
  MemoryDB automatically chooses an appropriate time range.
- `"SnsTopicArn"`: The Amazon Resource Name (ARN) of the Amazon Simple Notification Service
  (SNS) topic to which notifications are sent.
- `"SubnetGroupName"`: The name of the subnet group to be used for the cluster.
- `"TLSEnabled"`: A flag to enable in-transit encryption on the cluster.
- `"Tags"`: A list of tags to be added to this resource. Tags are comma-separated key,value
  pairs (e.g. Key=myKey, Value=myKeyValue. You can include multiple tags as shown following:
  Key=myKey, Value=myKeyValue Key=mySecondKey, Value=mySecondKeyValue.
"""
function create_cluster(
    ACLName, ClusterName, NodeType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return memorydb(
        "CreateCluster",
        Dict{String,Any}(
            "ACLName" => ACLName, "ClusterName" => ClusterName, "NodeType" => NodeType
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_cluster(
    ACLName,
    ClusterName,
    NodeType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return memorydb(
        "CreateCluster",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ACLName" => ACLName,
                    "ClusterName" => ClusterName,
                    "NodeType" => NodeType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_parameter_group(family, parameter_group_name)
    create_parameter_group(family, parameter_group_name, params::Dict{String,<:Any})

Creates a new MemoryDB parameter group. A parameter group is a collection of parameters and
their values that are applied to all of the nodes in any cluster. For more information, see
Configuring engine parameters using parameter groups.

# Arguments
- `family`: The name of the parameter group family that the parameter group can be used
  with.
- `parameter_group_name`: The name of the parameter group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: An optional description of the parameter group.
- `"Tags"`: A list of tags to be added to this resource. A tag is a key-value pair. A tag
  key must be accompanied by a tag value, although null is accepted.
"""
function create_parameter_group(
    Family, ParameterGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return memorydb(
        "CreateParameterGroup",
        Dict{String,Any}("Family" => Family, "ParameterGroupName" => ParameterGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_parameter_group(
    Family,
    ParameterGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return memorydb(
        "CreateParameterGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Family" => Family, "ParameterGroupName" => ParameterGroupName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_snapshot(cluster_name, snapshot_name)
    create_snapshot(cluster_name, snapshot_name, params::Dict{String,<:Any})

Creates a copy of an entire cluster at a specific moment in time.

# Arguments
- `cluster_name`: The snapshot is created from this cluster.
- `snapshot_name`: A name for the snapshot being created.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"KmsKeyId"`: The ID of the KMS key used to encrypt the snapshot.
- `"Tags"`: A list of tags to be added to this resource. A tag is a key-value pair. A tag
  key must be accompanied by a tag value, although null is accepted.
"""
function create_snapshot(
    ClusterName, SnapshotName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return memorydb(
        "CreateSnapshot",
        Dict{String,Any}("ClusterName" => ClusterName, "SnapshotName" => SnapshotName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_snapshot(
    ClusterName,
    SnapshotName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return memorydb(
        "CreateSnapshot",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClusterName" => ClusterName, "SnapshotName" => SnapshotName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_subnet_group(subnet_group_name, subnet_ids)
    create_subnet_group(subnet_group_name, subnet_ids, params::Dict{String,<:Any})

Creates a subnet group. A subnet group is a collection of subnets (typically private) that
you can designate for your clusters running in an Amazon Virtual Private Cloud (VPC)
environment. When you create a cluster in an Amazon VPC, you must specify a subnet group.
MemoryDB uses that subnet group to choose a subnet and IP addresses within that subnet to
associate with your nodes. For more information, see Subnets and subnet groups.

# Arguments
- `subnet_group_name`: The name of the subnet group.
- `subnet_ids`: A list of VPC subnet IDs for the subnet group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description for the subnet group.
- `"Tags"`: A list of tags to be added to this resource. A tag is a key-value pair. A tag
  key must be accompanied by a tag value, although null is accepted.
"""
function create_subnet_group(
    SubnetGroupName, SubnetIds; aws_config::AbstractAWSConfig=current_aws_config()
)
    return memorydb(
        "CreateSubnetGroup",
        Dict{String,Any}("SubnetGroupName" => SubnetGroupName, "SubnetIds" => SubnetIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_subnet_group(
    SubnetGroupName,
    SubnetIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return memorydb(
        "CreateSubnetGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "SubnetGroupName" => SubnetGroupName, "SubnetIds" => SubnetIds
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_user(access_string, authentication_mode, user_name)
    create_user(access_string, authentication_mode, user_name, params::Dict{String,<:Any})

Creates a MemoryDB user. For more information, see Authenticating users with Access Contol
Lists (ACLs).

# Arguments
- `access_string`: Access permissions string used for this user.
- `authentication_mode`: Denotes the user's authentication properties, such as whether it
  requires a password to authenticate.
- `user_name`: The name of the user. This value must be unique as it also serves as the
  user identifier.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: A list of tags to be added to this resource. A tag is a key-value pair. A tag
  key must be accompanied by a tag value, although null is accepted.
"""
function create_user(
    AccessString,
    AuthenticationMode,
    UserName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return memorydb(
        "CreateUser",
        Dict{String,Any}(
            "AccessString" => AccessString,
            "AuthenticationMode" => AuthenticationMode,
            "UserName" => UserName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_user(
    AccessString,
    AuthenticationMode,
    UserName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return memorydb(
        "CreateUser",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AccessString" => AccessString,
                    "AuthenticationMode" => AuthenticationMode,
                    "UserName" => UserName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_acl(aclname)
    delete_acl(aclname, params::Dict{String,<:Any})

Deletes an Access Control List. The ACL must first be disassociated from the cluster before
it can be deleted. For more information, see Authenticating users with Access Contol Lists
(ACLs).

# Arguments
- `aclname`: The name of the Access Control List to delete

"""
function delete_acl(ACLName; aws_config::AbstractAWSConfig=current_aws_config())
    return memorydb(
        "DeleteACL",
        Dict{String,Any}("ACLName" => ACLName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_acl(
    ACLName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return memorydb(
        "DeleteACL",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("ACLName" => ACLName), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_cluster(cluster_name)
    delete_cluster(cluster_name, params::Dict{String,<:Any})

Deletes a cluster. It also deletes all associated nodes and node endpoints

# Arguments
- `cluster_name`: The name of the cluster to be deleted

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FinalSnapshotName"`: The user-supplied name of a final cluster snapshot. This is the
  unique name that identifies the snapshot. MemoryDB creates the snapshot, and then deletes
  the cluster immediately afterward.
"""
function delete_cluster(ClusterName; aws_config::AbstractAWSConfig=current_aws_config())
    return memorydb(
        "DeleteCluster",
        Dict{String,Any}("ClusterName" => ClusterName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_cluster(
    ClusterName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return memorydb(
        "DeleteCluster",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ClusterName" => ClusterName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_parameter_group(parameter_group_name)
    delete_parameter_group(parameter_group_name, params::Dict{String,<:Any})

Deletes the specified parameter group. You cannot delete a parameter group if it is
associated with any clusters. You cannot delete the default parameter groups in your
account.

# Arguments
- `parameter_group_name`: The name of the parameter group to delete.

"""
function delete_parameter_group(
    ParameterGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return memorydb(
        "DeleteParameterGroup",
        Dict{String,Any}("ParameterGroupName" => ParameterGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_parameter_group(
    ParameterGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return memorydb(
        "DeleteParameterGroup",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ParameterGroupName" => ParameterGroupName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_snapshot(snapshot_name)
    delete_snapshot(snapshot_name, params::Dict{String,<:Any})

Deletes an existing snapshot. When you receive a successful response from this operation,
MemoryDB immediately begins deleting the snapshot; you cannot cancel or revert this
operation.

# Arguments
- `snapshot_name`: The name of the snapshot to delete

"""
function delete_snapshot(SnapshotName; aws_config::AbstractAWSConfig=current_aws_config())
    return memorydb(
        "DeleteSnapshot",
        Dict{String,Any}("SnapshotName" => SnapshotName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_snapshot(
    SnapshotName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return memorydb(
        "DeleteSnapshot",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("SnapshotName" => SnapshotName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_subnet_group(subnet_group_name)
    delete_subnet_group(subnet_group_name, params::Dict{String,<:Any})

Deletes a subnet group. You cannot delete a default subnet group or one that is associated
with any clusters.

# Arguments
- `subnet_group_name`: The name of the subnet group to delete

"""
function delete_subnet_group(
    SubnetGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return memorydb(
        "DeleteSubnetGroup",
        Dict{String,Any}("SubnetGroupName" => SubnetGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_subnet_group(
    SubnetGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return memorydb(
        "DeleteSubnetGroup",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("SubnetGroupName" => SubnetGroupName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_user(user_name)
    delete_user(user_name, params::Dict{String,<:Any})

Deletes a user. The user will be removed from all ACLs and in turn removed from all
clusters.

# Arguments
- `user_name`: The name of the user to delete

"""
function delete_user(UserName; aws_config::AbstractAWSConfig=current_aws_config())
    return memorydb(
        "DeleteUser",
        Dict{String,Any}("UserName" => UserName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_user(
    UserName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return memorydb(
        "DeleteUser",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("UserName" => UserName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_acls()
    describe_acls(params::Dict{String,<:Any})

Returns a list of ACLs

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ACLName"`: The name of the ACL
- `"MaxResults"`: The maximum number of records to include in the response. If more records
  exist than the specified MaxResults value, a token is included in the response so that the
  remaining results can be retrieved.
- `"NextToken"`: An optional argument to pass in case the total number of records exceeds
  the value of MaxResults. If nextToken is returned, there are more results available. The
  value of nextToken is a unique pagination token for each page. Make the call again using
  the returned token to retrieve the next page. Keep all other arguments unchanged.
"""
function describe_acls(; aws_config::AbstractAWSConfig=current_aws_config())
    return memorydb("DescribeACLs"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function describe_acls(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return memorydb(
        "DescribeACLs", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_clusters()
    describe_clusters(params::Dict{String,<:Any})

Returns information about all provisioned clusters if no cluster identifier is specified,
or about a specific cluster if a cluster name is supplied.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClusterName"`: The name of the cluster
- `"MaxResults"`: The maximum number of records to include in the response. If more records
  exist than the specified MaxResults value, a token is included in the response so that the
  remaining results can be retrieved.
- `"NextToken"`: An optional argument to pass in case the total number of records exceeds
  the value of MaxResults. If nextToken is returned, there are more results available. The
  value of nextToken is a unique pagination token for each page. Make the call again using
  the returned token to retrieve the next page. Keep all other arguments unchanged.
- `"ShowShardDetails"`: An optional flag that can be included in the request to retrieve
  information about the individual shard(s).
"""
function describe_clusters(; aws_config::AbstractAWSConfig=current_aws_config())
    return memorydb(
        "DescribeClusters"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_clusters(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return memorydb(
        "DescribeClusters", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_engine_versions()
    describe_engine_versions(params::Dict{String,<:Any})

Returns a list of the available Redis engine versions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DefaultOnly"`: If true, specifies that only the default version of the specified engine
  or engine and major version combination is to be returned.
- `"EngineVersion"`: The Redis engine version
- `"MaxResults"`: The maximum number of records to include in the response. If more records
  exist than the specified MaxResults value, a token is included in the response so that the
  remaining results can be retrieved.
- `"NextToken"`: An optional argument to pass in case the total number of records exceeds
  the value of MaxResults. If nextToken is returned, there are more results available. The
  value of nextToken is a unique pagination token for each page. Make the call again using
  the returned token to retrieve the next page. Keep all other arguments unchanged.
- `"ParameterGroupFamily"`: The name of a specific parameter group family to return details
  for.
"""
function describe_engine_versions(; aws_config::AbstractAWSConfig=current_aws_config())
    return memorydb(
        "DescribeEngineVersions"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_engine_versions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return memorydb(
        "DescribeEngineVersions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_events()
    describe_events(params::Dict{String,<:Any})

Returns events related to clusters, security groups, and parameter groups. You can obtain
events specific to a particular cluster, security group, or parameter group by providing
the name as a parameter. By default, only the events occurring within the last hour are
returned; however, you can retrieve up to 14 days' worth of events if necessary.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Duration"`: The number of minutes worth of events to retrieve.
- `"EndTime"`: The end of the time interval for which to retrieve events, specified in ISO
  8601 format. Example: 2017-03-30T07:03:49.555Z
- `"MaxResults"`: The maximum number of records to include in the response. If more records
  exist than the specified MaxResults value, a token is included in the response so that the
  remaining results can be retrieved.
- `"NextToken"`: An optional argument to pass in case the total number of records exceeds
  the value of MaxResults. If nextToken is returned, there are more results available. The
  value of nextToken is a unique pagination token for each page. Make the call again using
  the returned token to retrieve the next page. Keep all other arguments unchanged.
- `"SourceName"`: The identifier of the event source for which events are returned. If not
  specified, all sources are included in the response.
- `"SourceType"`: The event source to retrieve events for. If no value is specified, all
  events are returned.
- `"StartTime"`: The beginning of the time interval to retrieve events for, specified in
  ISO 8601 format. Example: 2017-03-30T07:03:49.555Z
"""
function describe_events(; aws_config::AbstractAWSConfig=current_aws_config())
    return memorydb(
        "DescribeEvents"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_events(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return memorydb(
        "DescribeEvents", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_parameter_groups()
    describe_parameter_groups(params::Dict{String,<:Any})

Returns a list of parameter group descriptions. If a parameter group name is specified, the
list contains only the descriptions for that group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of records to include in the response. If more records
  exist than the specified MaxResults value, a token is included in the response so that the
  remaining results can be retrieved.
- `"NextToken"`: An optional argument to pass in case the total number of records exceeds
  the value of MaxResults. If nextToken is returned, there are more results available. The
  value of nextToken is a unique pagination token for each page. Make the call again using
  the returned token to retrieve the next page. Keep all other arguments unchanged.
- `"ParameterGroupName"`: The name of a specific parameter group to return details for.
"""
function describe_parameter_groups(; aws_config::AbstractAWSConfig=current_aws_config())
    return memorydb(
        "DescribeParameterGroups"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_parameter_groups(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return memorydb(
        "DescribeParameterGroups",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_parameters(parameter_group_name)
    describe_parameters(parameter_group_name, params::Dict{String,<:Any})

Returns the detailed parameter list for a particular parameter group.

# Arguments
- `parameter_group_name`: he name of a specific parameter group to return details for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of records to include in the response. If more records
  exist than the specified MaxResults value, a token is included in the response so that the
  remaining results can be retrieved.
- `"NextToken"`: An optional argument to pass in case the total number of records exceeds
  the value of MaxResults. If nextToken is returned, there are more results available. The
  value of nextToken is a unique pagination token for each page. Make the call again using
  the returned token to retrieve the next page. Keep all other arguments unchanged.
"""
function describe_parameters(
    ParameterGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return memorydb(
        "DescribeParameters",
        Dict{String,Any}("ParameterGroupName" => ParameterGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_parameters(
    ParameterGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return memorydb(
        "DescribeParameters",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ParameterGroupName" => ParameterGroupName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_reserved_nodes()
    describe_reserved_nodes(params::Dict{String,<:Any})

Returns information about reserved nodes for this account, or about a specified reserved
node.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Duration"`: The duration filter value, specified in years or seconds. Use this
  parameter to show only reservations for this duration.
- `"MaxResults"`: The maximum number of records to include in the response. If more records
  exist than the specified MaxRecords value, a marker is included in the response so that the
  remaining results can be retrieved.
- `"NextToken"`: An optional marker returned from a prior request. Use this marker for
  pagination of results from this operation. If this parameter is specified, the response
  includes only records beyond the marker, up to the value specified by MaxRecords.
- `"NodeType"`: The node type filter value. Use this parameter to show only those
  reservations matching the specified node type. For more information, see Supported node
  types.
- `"OfferingType"`: The offering type filter value. Use this parameter to show only the
  available offerings matching the specified offering type. Valid values: \"All
  Upfront\"|\"Partial Upfront\"| \"No Upfront\"
- `"ReservationId"`: The reserved node identifier filter value. Use this parameter to show
  only the reservation that matches the specified reservation ID.
- `"ReservedNodesOfferingId"`: The offering identifier filter value. Use this parameter to
  show only purchased reservations matching the specified offering identifier.
"""
function describe_reserved_nodes(; aws_config::AbstractAWSConfig=current_aws_config())
    return memorydb(
        "DescribeReservedNodes"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_reserved_nodes(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return memorydb(
        "DescribeReservedNodes",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_reserved_nodes_offerings()
    describe_reserved_nodes_offerings(params::Dict{String,<:Any})

Lists available reserved node offerings.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Duration"`: Duration filter value, specified in years or seconds. Use this parameter to
  show only reservations for a given duration.
- `"MaxResults"`: The maximum number of records to include in the response. If more records
  exist than the specified MaxRecords value, a marker is included in the response so that the
  remaining results can be retrieved.
- `"NextToken"`: An optional marker returned from a prior request. Use this marker for
  pagination of results from this operation. If this parameter is specified, the response
  includes only records beyond the marker, up to the value specified by MaxRecords.
- `"NodeType"`: The node type for the reserved nodes. For more information, see Supported
  node types.
- `"OfferingType"`: The offering type filter value. Use this parameter to show only the
  available offerings matching the specified offering type. Valid values: \"All
  Upfront\"|\"Partial Upfront\"| \"No Upfront\"
- `"ReservedNodesOfferingId"`: The offering identifier filter value. Use this parameter to
  show only the available offering that matches the specified reservation identifier.
"""
function describe_reserved_nodes_offerings(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return memorydb(
        "DescribeReservedNodesOfferings";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_reserved_nodes_offerings(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return memorydb(
        "DescribeReservedNodesOfferings",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_service_updates()
    describe_service_updates(params::Dict{String,<:Any})

Returns details of the service updates

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClusterNames"`: The list of cluster names to identify service updates to apply
- `"MaxResults"`: The maximum number of records to include in the response. If more records
  exist than the specified MaxResults value, a token is included in the response so that the
  remaining results can be retrieved.
- `"NextToken"`: An optional argument to pass in case the total number of records exceeds
  the value of MaxResults. If nextToken is returned, there are more results available. The
  value of nextToken is a unique pagination token for each page. Make the call again using
  the returned token to retrieve the next page. Keep all other arguments unchanged.
- `"ServiceUpdateName"`: The unique ID of the service update to describe.
- `"Status"`: The status(es) of the service updates to filter on
"""
function describe_service_updates(; aws_config::AbstractAWSConfig=current_aws_config())
    return memorydb(
        "DescribeServiceUpdates"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_service_updates(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return memorydb(
        "DescribeServiceUpdates",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_snapshots()
    describe_snapshots(params::Dict{String,<:Any})

Returns information about cluster snapshots. By default, DescribeSnapshots lists all of
your snapshots; it can optionally describe a single snapshot, or just the snapshots
associated with a particular cluster.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClusterName"`: A user-supplied cluster identifier. If this parameter is specified, only
  snapshots associated with that specific cluster are described.
- `"MaxResults"`: The maximum number of records to include in the response. If more records
  exist than the specified MaxResults value, a token is included in the response so that the
  remaining results can be retrieved.
- `"NextToken"`: An optional argument to pass in case the total number of records exceeds
  the value of MaxResults. If nextToken is returned, there are more results available. The
  value of nextToken is a unique pagination token for each page. Make the call again using
  the returned token to retrieve the next page. Keep all other arguments unchanged.
- `"ShowDetail"`: A Boolean value which if true, the shard configuration is included in the
  snapshot description.
- `"SnapshotName"`: A user-supplied name of the snapshot. If this parameter is specified,
  only this named snapshot is described.
- `"Source"`: If set to system, the output shows snapshots that were automatically created
  by MemoryDB. If set to user the output shows snapshots that were manually created. If
  omitted, the output shows both automatically and manually created snapshots.
"""
function describe_snapshots(; aws_config::AbstractAWSConfig=current_aws_config())
    return memorydb(
        "DescribeSnapshots"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_snapshots(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return memorydb(
        "DescribeSnapshots", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_subnet_groups()
    describe_subnet_groups(params::Dict{String,<:Any})

Returns a list of subnet group descriptions. If a subnet group name is specified, the list
contains only the description of that group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of records to include in the response. If more records
  exist than the specified MaxResults value, a token is included in the response so that the
  remaining results can be retrieved.
- `"NextToken"`: An optional argument to pass in case the total number of records exceeds
  the value of MaxResults. If nextToken is returned, there are more results available. The
  value of nextToken is a unique pagination token for each page. Make the call again using
  the returned token to retrieve the next page. Keep all other arguments unchanged.
- `"SubnetGroupName"`: The name of the subnet group to return details for.
"""
function describe_subnet_groups(; aws_config::AbstractAWSConfig=current_aws_config())
    return memorydb(
        "DescribeSubnetGroups"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_subnet_groups(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return memorydb(
        "DescribeSubnetGroups",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_users()
    describe_users(params::Dict{String,<:Any})

Returns a list of users.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: Filter to determine the list of users to return.
- `"MaxResults"`: The maximum number of records to include in the response. If more records
  exist than the specified MaxResults value, a token is included in the response so that the
  remaining results can be retrieved.
- `"NextToken"`: An optional argument to pass in case the total number of records exceeds
  the value of MaxResults. If nextToken is returned, there are more results available. The
  value of nextToken is a unique pagination token for each page. Make the call again using
  the returned token to retrieve the next page. Keep all other arguments unchanged.
- `"UserName"`: The name of the user
"""
function describe_users(; aws_config::AbstractAWSConfig=current_aws_config())
    return memorydb("DescribeUsers"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function describe_users(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return memorydb(
        "DescribeUsers", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    failover_shard(cluster_name, shard_name)
    failover_shard(cluster_name, shard_name, params::Dict{String,<:Any})

Used to failover a shard. This API is designed for testing the behavior of your application
in case of MemoryDB failover. It is not designed to be used as a production-level tool for
initiating a failover to overcome a problem you may have with the cluster. Moreover, in
certain conditions such as large scale operational events, Amazon may block this API.

# Arguments
- `cluster_name`: The cluster being failed over
- `shard_name`: The name of the shard

"""
function failover_shard(
    ClusterName, ShardName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return memorydb(
        "FailoverShard",
        Dict{String,Any}("ClusterName" => ClusterName, "ShardName" => ShardName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function failover_shard(
    ClusterName,
    ShardName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return memorydb(
        "FailoverShard",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ClusterName" => ClusterName, "ShardName" => ShardName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_allowed_node_type_updates(cluster_name)
    list_allowed_node_type_updates(cluster_name, params::Dict{String,<:Any})

Lists all available node types that you can scale to from your cluster's current node type.
When you use the UpdateCluster operation to scale your cluster, the value of the NodeType
parameter must be one of the node types returned by this operation.

# Arguments
- `cluster_name`: The name of the cluster you want to scale. MemoryDB uses the cluster name
  to identify the current node type being used by this cluster, and from that to create a
  list of node types you can scale up to.

"""
function list_allowed_node_type_updates(
    ClusterName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return memorydb(
        "ListAllowedNodeTypeUpdates",
        Dict{String,Any}("ClusterName" => ClusterName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_allowed_node_type_updates(
    ClusterName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return memorydb(
        "ListAllowedNodeTypeUpdates",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ClusterName" => ClusterName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags(resource_arn)
    list_tags(resource_arn, params::Dict{String,<:Any})

Lists all tags currently on a named resource. A tag is a key-value pair where the key and
value are case-sensitive. You can use tags to categorize and track your MemoryDB resources.
For more information, see Tagging your MemoryDB resources

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource for which you want the
  list of tags

"""
function list_tags(ResourceArn; aws_config::AbstractAWSConfig=current_aws_config())
    return memorydb(
        "ListTags",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return memorydb(
        "ListTags",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    purchase_reserved_nodes_offering(reserved_nodes_offering_id)
    purchase_reserved_nodes_offering(reserved_nodes_offering_id, params::Dict{String,<:Any})

Allows you to purchase a reserved node offering. Reserved nodes are not eligible for
cancellation and are non-refundable.

# Arguments
- `reserved_nodes_offering_id`: The ID of the reserved node offering to purchase.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NodeCount"`: The number of node instances to reserve.
- `"ReservationId"`: A customer-specified identifier to track this reservation.
- `"Tags"`: A list of tags to be added to this resource. A tag is a key-value pair. A tag
  key must be accompanied by a tag value, although null is accepted.
"""
function purchase_reserved_nodes_offering(
    ReservedNodesOfferingId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return memorydb(
        "PurchaseReservedNodesOffering",
        Dict{String,Any}("ReservedNodesOfferingId" => ReservedNodesOfferingId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function purchase_reserved_nodes_offering(
    ReservedNodesOfferingId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return memorydb(
        "PurchaseReservedNodesOffering",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ReservedNodesOfferingId" => ReservedNodesOfferingId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    reset_parameter_group(parameter_group_name)
    reset_parameter_group(parameter_group_name, params::Dict{String,<:Any})

Modifies the parameters of a parameter group to the engine or system default value. You can
reset specific parameters by submitting a list of parameter names. To reset the entire
parameter group, specify the AllParameters and ParameterGroupName parameters.

# Arguments
- `parameter_group_name`: The name of the parameter group to reset.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AllParameters"`: If true, all parameters in the parameter group are reset to their
  default values. If false, only the parameters listed by ParameterNames are reset to their
  default values.
- `"ParameterNames"`: An array of parameter names to reset to their default values. If
  AllParameters is true, do not use ParameterNames. If AllParameters is false, you must
  specify the name of at least one parameter to reset.
"""
function reset_parameter_group(
    ParameterGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return memorydb(
        "ResetParameterGroup",
        Dict{String,Any}("ParameterGroupName" => ParameterGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function reset_parameter_group(
    ParameterGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return memorydb(
        "ResetParameterGroup",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ParameterGroupName" => ParameterGroupName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

A tag is a key-value pair where the key and value are case-sensitive. You can use tags to
categorize and track all your MemoryDB resources. When you add or remove tags on clusters,
those actions will be replicated to all nodes in the cluster. For more information, see
Resource-level permissions. For example, you can use cost-allocation tags to your MemoryDB
resources, Amazon generates a cost allocation report as a comma-separated value (CSV) file
with your usage and costs aggregated by your tags. You can apply tags that represent
business categories (such as cost centers, application names, or owners) to organize your
costs across multiple services. For more information, see Using Cost Allocation Tags.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource to which the tags are to
  be added
- `tags`: A list of tags to be added to this resource. A tag is a key-value pair. A tag key
  must be accompanied by a tag value, although null is accepted.

"""
function tag_resource(ResourceArn, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return memorydb(
        "TagResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceArn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return memorydb(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Use this operation to remove tags on a resource

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource to which the tags are to
  be removed
- `tag_keys`: The list of keys of the tags that are to be removed

"""
function untag_resource(
    ResourceArn, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return memorydb(
        "UntagResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceArn,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return memorydb(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_acl(aclname)
    update_acl(aclname, params::Dict{String,<:Any})

Changes the list of users that belong to the Access Control List.

# Arguments
- `aclname`: The name of the Access Control List

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"UserNamesToAdd"`: The list of users to add to the Access Control List
- `"UserNamesToRemove"`: The list of users to remove from the Access Control List
"""
function update_acl(ACLName; aws_config::AbstractAWSConfig=current_aws_config())
    return memorydb(
        "UpdateACL",
        Dict{String,Any}("ACLName" => ACLName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_acl(
    ACLName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return memorydb(
        "UpdateACL",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("ACLName" => ACLName), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_cluster(cluster_name)
    update_cluster(cluster_name, params::Dict{String,<:Any})

Modifies the settings for a cluster. You can use this operation to change one or more
cluster configuration settings by specifying the settings and the new values.

# Arguments
- `cluster_name`: The name of the cluster to update

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ACLName"`: The Access Control List that is associated with the cluster
- `"Description"`: The description of the cluster to update
- `"EngineVersion"`: The upgraded version of the engine to be run on the nodes. You can
  upgrade to a newer engine version, but you cannot downgrade to an earlier engine version.
  If you want to use an earlier engine version, you must delete the existing cluster and
  create it anew with the earlier engine version.
- `"MaintenanceWindow"`: Specifies the weekly time range during which maintenance on the
  cluster is performed. It is specified as a range in the format ddd:hh24:mi-ddd:hh24:mi (24H
  Clock UTC). The minimum maintenance window is a 60 minute period. Valid values for ddd are:
     sun     mon     tue     wed     thu     fri     sat    Example: sun:23:00-mon:01:30
- `"NodeType"`: A valid node type that you want to scale this cluster up or down to.
- `"ParameterGroupName"`: The name of the parameter group to update
- `"ReplicaConfiguration"`: The number of replicas that will reside in each shard
- `"SecurityGroupIds"`: The SecurityGroupIds to update
- `"ShardConfiguration"`: The number of shards in the cluster
- `"SnapshotRetentionLimit"`: The number of days for which MemoryDB retains automatic
  cluster snapshots before deleting them. For example, if you set SnapshotRetentionLimit to
  5, a snapshot that was taken today is retained for 5 days before being deleted.
- `"SnapshotWindow"`: The daily time range (in UTC) during which MemoryDB begins taking a
  daily snapshot of your cluster.
- `"SnsTopicArn"`: The SNS topic ARN to update
- `"SnsTopicStatus"`: The status of the Amazon SNS notification topic. Notifications are
  sent only if the status is active.
"""
function update_cluster(ClusterName; aws_config::AbstractAWSConfig=current_aws_config())
    return memorydb(
        "UpdateCluster",
        Dict{String,Any}("ClusterName" => ClusterName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_cluster(
    ClusterName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return memorydb(
        "UpdateCluster",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ClusterName" => ClusterName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_parameter_group(parameter_group_name, parameter_name_values)
    update_parameter_group(parameter_group_name, parameter_name_values, params::Dict{String,<:Any})

Updates the parameters of a parameter group. You can modify up to 20 parameters in a single
request by submitting a list parameter name and value pairs.

# Arguments
- `parameter_group_name`: The name of the parameter group to update.
- `parameter_name_values`: An array of parameter names and values for the parameter update.
  You must supply at least one parameter name and value; subsequent arguments are optional. A
  maximum of 20 parameters may be updated per request.

"""
function update_parameter_group(
    ParameterGroupName,
    ParameterNameValues;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return memorydb(
        "UpdateParameterGroup",
        Dict{String,Any}(
            "ParameterGroupName" => ParameterGroupName,
            "ParameterNameValues" => ParameterNameValues,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_parameter_group(
    ParameterGroupName,
    ParameterNameValues,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return memorydb(
        "UpdateParameterGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ParameterGroupName" => ParameterGroupName,
                    "ParameterNameValues" => ParameterNameValues,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_subnet_group(subnet_group_name)
    update_subnet_group(subnet_group_name, params::Dict{String,<:Any})

Updates a subnet group. For more information, see Updating a subnet group

# Arguments
- `subnet_group_name`: The name of the subnet group

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description of the subnet group
- `"SubnetIds"`: The EC2 subnet IDs for the subnet group.
"""
function update_subnet_group(
    SubnetGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return memorydb(
        "UpdateSubnetGroup",
        Dict{String,Any}("SubnetGroupName" => SubnetGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_subnet_group(
    SubnetGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return memorydb(
        "UpdateSubnetGroup",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("SubnetGroupName" => SubnetGroupName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_user(user_name)
    update_user(user_name, params::Dict{String,<:Any})

Changes user password(s) and/or access string.

# Arguments
- `user_name`: The name of the user

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccessString"`: Access permissions string used for this user.
- `"AuthenticationMode"`: Denotes the user's authentication properties, such as whether it
  requires a password to authenticate.
"""
function update_user(UserName; aws_config::AbstractAWSConfig=current_aws_config())
    return memorydb(
        "UpdateUser",
        Dict{String,Any}("UserName" => UserName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_user(
    UserName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return memorydb(
        "UpdateUser",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("UserName" => UserName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

module AWS

using Compat: Compat, @compat, @something, pkgversion
using Base64
using Dates
using Downloads: Downloads, Downloader, Curl
using HTTP
using MbedTLS
using Mocking
using OrderedCollections: LittleDict, OrderedDict
using Random
using SHA
using ScopedValues: ScopedValues, ScopedValue, @with
using Sockets
using URIs
using UUIDs: UUIDs
using XMLDict

export @service
export _merge
export AbstractAWSConfig, AWSConfig, AWSExceptions, AWSServices, Request
export IMDS
export current_aws_config, default_aws_config, with_aws_config
export assume_role, generate_service_url, set_user_agent
export sign!, sign_aws2!, sign_aws4!
export JSONService, RestJSONService, RestXMLService, QueryService, set_features

const DEFAULT_REGION = "us-east-1"

include(joinpath("utilities", "utilities.jl"))

include("AWSExceptions.jl")
include("AWSCredentials.jl")
include("AWSConfig.jl")
include("AWSMetadata.jl")
include("IMDS.jl")

include(joinpath("utilities", "request.jl"))
include(joinpath("utilities", "response.jl"))
include(joinpath("utilities", "sign.jl"))
include(joinpath("utilities", "downloads_backend.jl"))
include(joinpath("utilities", "role.jl"))

include("deprecated.jl")

using ..AWSExceptions
using ..AWSExceptions: AWSException

const user_agent = Ref{String}("AWS.jl/$(pkgversion(@__MODULE__()))")
const aws_config = Ref{AbstractAWSConfig}()

"""
    FeatureSet

Allows end users to opt-in to new breaking behaviors prior before a major/breaking package
release. Each field of this struct contains a default which specifies uses the original
non-breaking behavior.

# Features

- `use_response_type::Bool=false`: When enabled, service calls will return an `AWS.Response`
  which provides streaming/raw/parsed access to the response. When disabled, the service
  call response typically be parsed but will vary depending on the following parameters:
  "return_headers", "return_stream", "return_raw", "response_dict_type".
"""
Base.@kwdef struct FeatureSet
    use_response_type::Bool = false
end

"""
    set_user_agent(new_user_agent::String)

Set the global user agent when making HTTP requests.

# Arguments
- `new_user_agent::String`: User agent to set when making HTTP requests

# Return
- `String`: The global user agent
"""
set_user_agent(new_user_agent::String) = return user_agent[] = new_user_agent

"""
    @service service_id feature=val...
    @service service_id as module_name feature=val...

Include the high-level service wrapper for `service_id` in a module. The module name will
match the `service_id` or can be specified using the `as` syntax.

An optional list of features can be specified for this service include. See
[`FeatureSet`](@ref) for a list of available features.

The module name cannot match the binding name used for the low-level API. The low-level API
binding name is equivalent to the lowercase `service_id` where spaces are replace with
underscores (e.g. the service ID `Secrets_Manager` can be used but `secrets_manager`
cannot).

# Extended Help

## Arguments

- `service_id::Symbol`: The high-level API wrappers service ID to include in the current
  module. Note the service ID is case insensitive.
- `module_name::Symbol`: The name of the module containing the high-level API wrappers.
  Useful to avoiding name conflicts. Defaults to using `service_id`.
- `features=val...`: A list of features to enable/disable for this high-level API include.
  See `FeatureSet` for a list of available features.

## Returns

- `Module`: The module containging the high-level service API wrapper functions.

## Examples

```julia
julia> using AWS: @service

julia> @service STS
STS

julia> STS.get_caller_identity()
OrderedCollections.LittleDict{Union{String, Symbol}, Any, Vector{Union{String, Symbol}}, Vector{Any}} with 2 entries:
  "GetCallerIdentityResult" => LittleDict{Union{String, Symbol}, Any, Vector{Un…
  "ResponseMetadata"        => LittleDict{Union{String, Symbol}, Any, Vector{Un…
```

Specify the module name and use a feature:

```julia
julia> @service STS as SecurityTokenService use_response_type = true
SecurityTokenService

julia> SecurityTokenService.get_caller_identity()
AWS.Response: application/xml interpreted as:
OrderedCollections.LittleDict{Union{String, Symbol}, Any, Vector{Union{String, Symbol}}, Vector{Any}} with 2 entries:
  "GetCallerIdentityResult" => LittleDict{Union{String, Symbol}, Any, Vector{Un…
  "ResponseMetadata"        => LittleDict{Union{String, Symbol}, Any, Vector{Un…
```

Service IDs are case insensitive:

```jldoctest; setup = :(using AWS: @service)
julia> @service Secrets_Manager
Secrets_Manager

julia> @service SECRETS_MANAGER
SECRETS_MANAGER

julia> @service sECRETS_MANAGER
sECRETS_MANAGER
```

Using an all lowercase service ID does not work as it conflicts with the low-level API
binding name:

```julia
julia> @service sts
WARNING: import of AWSServices.sts into sts conflicts with an existing identifier; ignored.
sts

julia> sts.get_caller_identity()
ERROR: MethodError: objects of type Module are not callable
[...]
```
"""
macro service(exprs...)
    if length(exprs) >= 3 && exprs[2] === :as
        # e.g. `@service Secrets_Manager as SM ...`. Note the expression structure here differs
        # from what is used by `import` and `using`.
        exprs[1] isa Symbol || throw(_expected_symbol_exception(:service_id, exprs[1]))
        exprs[3] isa Symbol || throw(_expected_symbol_exception(:module_name, exprs[3]))

        service_name = exprs[1]
        module_name = exprs[3]
        features = exprs[4:end]
    elseif length(exprs) >= 1
        # e.g. `@service Secrets_Manager ...`
        exprs[1] isa Symbol || throw(_expected_symbol_exception(:service_id, exprs[1]))

        service_name = exprs[1]
        module_name = exprs[1]
        features = exprs[2:end]
    else
        throw(MethodError(var"@service", (__source__, __module__)))
    end

    service_file = joinpath(@__DIR__, "services", lowercase(string(service_name)) * ".jl")
    map(_assignment_to_kw!, features)

    module_block = quote
        using AWS: FeatureSet
        const SERVICE_FEATURE_SET = FeatureSet(; $(features...))
        include($service_file)
    end

    return Expr(:toplevel, Expr(:module, true, esc(module_name), esc(module_block)))
end

abstract type Service end

struct RestXMLService <: Service
    signing_name::String
    endpoint_prefix::String
    api_version::String
end

struct QueryService <: Service
    signing_name::String
    endpoint_prefix::String
    api_version::String
end

struct JSONService <: Service
    signing_name::String
    endpoint_prefix::String
    api_version::String

    json_version::String
    target::String
end

struct RestJSONService <: Service
    signing_name::String
    endpoint_prefix::String
    api_version::String

    service_specific_headers::LittleDict{String,String}
end

function RestJSONService(signing_name::String, endpoint_prefix::String, api_version::String)
    return RestJSONService(
        signing_name, endpoint_prefix, api_version, LittleDict{String,String}()
    )
end

struct ServiceWrapper{S<:Service}
    service::S
    feature_set::FeatureSet
end

function set_features(service::Service; features...)
    return ServiceWrapper(service, FeatureSet(; features...))
end

# Needs to be included after the definition of struct otherwise it cannot find them
include("AWSServices.jl")

function generate_service_url(aws::AbstractAWSConfig, service::String, resource::String)
    SERVICE_HOST = "amazonaws.com"
    reg = region(aws)

    regionless_services = ("iam", "route53")

    if service in regionless_services || (service == "sdb" && reg == DEFAULT_REGION)
        reg = ""
    end

    return string(
        "https://", service, ".", isempty(reg) ? "" : "$reg.", SERVICE_HOST, resource
    )
end

"""
    (service::RestXMLService)(
        request_method::String, request_uri::String, args::AbstractDict{String, <:Any}=Dict{String, String}();
        aws_config::AbstractAWSConfig=aws_config
    )

Perform a RestXML request to AWS.

# Arguments
- `request_method::String`: RESTful request type, e.g.: `GET`, `HEAD`, `PUT`, etc.
- `request_uri::String`: AWS URI for the endpoint
- `args::AbstractDict{String, <:Any}`: Additional arguments to be included in the request

# Keywords
- `aws_config::AbstractAWSConfig`: AWSConfig containing credentials and other information for fulfilling the request, default value is the global configuration
- `feature_set::FeatureSet`: Specifies opt-in functionality for this specific API call.

# Returns
- `Tuple` or `Dict`: If `return_headers` is passed in through `args` a Tuple containing the headers and response will be returned, otherwise just a `Dict`
"""
function (service::RestXMLService)(
    request_method::String,
    request_uri::String,
    args::AbstractDict{String,<:Any}=Dict{String,Any}();
    aws_config::AbstractAWSConfig=current_aws_config(),
    feature_set::FeatureSet=FeatureSet(),
)
    feature_set.use_response_type && _delete_legacy_response_kw_args!(args)

    return_headers = _pop!(args, "return_headers", nothing)

    request = Request(;
        _extract_common_kw_args(service, args)...,
        use_response_type=feature_set.use_response_type,
        request_method=request_method,
        content=_pop!(args, "body", ""),
    )

    if request.service == "s3"
        request_uri = _clean_s3_uri(request_uri)
    end
    request.resource = _generate_rest_resource(request_uri, args)
    query_str = HTTP.escapeuri(args)

    if !isempty(query_str)
        if occursin('?', request.resource)
            request.resource *= "&$query_str"
        else
            request.resource *= "?$query_str"
        end
    end

    request.url = generate_service_url(
        aws_config, service.endpoint_prefix, request.resource
    )

    return submit_request(aws_config, request; return_headers=return_headers)
end

"""
    (service::QueryService)(
        operation::String, args::AbstractDict{String, <:Any}=Dict{String, Any}();
        aws_config::AbstractAWSConfig=aws_config
    )

Perform a Query request to AWS.

# Arguments
- `operation::String`:
- `args::AbstractDict{String, <:Any}`: Additional arguments to be included in the request

# Keywords
- `aws_config::AbstractAWSConfig`: AWSConfig containing credentials and other information for fulfilling the request, default value is the global configuration
- `feature_set::FeatureSet`: Specifies opt-in functionality for this specific API call.

# Returns
- `Tuple` or `Dict`: If `return_headers` is passed in through `args` a Tuple containing the headers and response will be returned, otherwise just a `Dict`
"""
function (service::QueryService)(
    operation::String,
    args::AbstractDict{String,<:Any}=Dict{String,Any}();
    aws_config::AbstractAWSConfig=current_aws_config(),
    feature_set::FeatureSet=FeatureSet(),
)
    feature_set.use_response_type && _delete_legacy_response_kw_args!(args)

    POST_RESOURCE = "/"
    return_headers = _pop!(args, "return_headers", nothing)

    request = Request(;
        _extract_common_kw_args(service, args)...,
        use_response_type=feature_set.use_response_type,
        resource=POST_RESOURCE,
        request_method="POST",
        url=generate_service_url(aws_config, service.endpoint_prefix, POST_RESOURCE),
    )

    request.headers["Content-Type"] = "application/x-www-form-urlencoded; charset=utf-8"

    args["Action"] = operation
    args["Version"] = service.api_version
    request.content = HTTP.escapeuri(_flatten_query(service.signing_name, args))

    return submit_request(aws_config, request; return_headers=return_headers)
end

"""
    (service::JSONService)(
        operation::String, args::AbstractDict{String, <:Any}=Dict{String, Any}();
        aws_config::AbstractAWSConfig=aws_config
    )

Perform a JSON request to AWS.

# Arguments
- `operation::String`: Name of the operation to perform
- `args::AbstractDict{String, <:Any}`: Additional arguments to be included in the request

# Keywords
- `aws_config::AbstractAWSConfig`: AWSConfig containing credentials and other information for fulfilling the request, default value is the global configuration
- `feature_set::FeatureSet`: Specifies opt-in functionality for this specific API call.

# Returns
- `Tuple` or `Dict`: If `return_headers` is passed in through `args` a Tuple containing the headers and response will be returned, otherwise just a `Dict`
"""
function (service::JSONService)(
    operation::String,
    args::AbstractDict{String,<:Any}=Dict{String,Any}();
    aws_config::AbstractAWSConfig=current_aws_config(),
    feature_set::FeatureSet=FeatureSet(),
)
    feature_set.use_response_type && _delete_legacy_response_kw_args!(args)

    POST_RESOURCE = "/"
    return_headers = _pop!(args, "return_headers", nothing)

    request = Request(;
        _extract_common_kw_args(service, args)...,
        use_response_type=feature_set.use_response_type,
        resource=POST_RESOURCE,
        request_method="POST",
        content=json(args),
        url=generate_service_url(aws_config, service.endpoint_prefix, POST_RESOURCE),
    )

    request.headers["Content-Type"] = "application/x-amz-json-$(service.json_version)"
    request.headers["X-Amz-Target"] = "$(service.target).$(operation)"

    return submit_request(aws_config, request; return_headers=return_headers)
end

"""
    (service::RestJSONService)(
        request_method::String, request_uri::String, args::AbstractDict{String, <:Any}=Dict{String, String}();
        aws_config::AbstractAWSConfig=aws_config
    )

Perform a RestJSON request to AWS.

# Arguments
- `request_method::String`: RESTful request type, e.g.: `GET`, `HEAD`, `PUT`, etc.
- `request_uri::String`: AWS URI for the endpoint
- `args::AbstractDict{String, <:Any}`: Additional arguments to be included in the request

# Keywords
- `aws_config::AbstractAWSConfig`: AWSConfig containing credentials and other information for fulfilling the request, default value is the global configuration
- `feature_set::FeatureSet`: Specifies opt-in functionality for this specific API call.

# Returns
- `Tuple` or `Dict`: If `return_headers` is passed in through `args` a Tuple containing the headers and response will be returned, otherwise just a `Dict`
"""
function (service::RestJSONService)(
    request_method::String,
    request_uri::String,
    args::AbstractDict{String,<:Any}=Dict{String,String}();
    aws_config::AbstractAWSConfig=current_aws_config(),
    feature_set::FeatureSet=FeatureSet(),
)
    feature_set.use_response_type && _delete_legacy_response_kw_args!(args)

    return_headers = _pop!(args, "return_headers", nothing)

    request = Request(;
        _extract_common_kw_args(service, args)...,
        use_response_type=feature_set.use_response_type,
        request_method=request_method,
        resource=_generate_rest_resource(request_uri, args),
    )

    request.url = generate_service_url(
        aws_config, service.endpoint_prefix, request.resource
    )

    if !isempty(service.service_specific_headers)
        merge!(request.headers, service.service_specific_headers)
    end

    request.headers["Content-Type"] = "application/json"
    request.content = json(args)

    return submit_request(aws_config, request; return_headers=return_headers)
end

function (service::ServiceWrapper)(args...; feature_set=nothing, kwargs...)
    feature_set = something(feature_set, service.feature_set)
    return service.service(args...; feature_set=feature_set, kwargs...)
end

function __init__()
    DEFAULT_BACKEND[] = HTTPBackend()
    return nothing
end

end  # module AWS

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: mediapackagev2
using AWS.Compat
using AWS.UUIDs

"""
    create_channel(channel_group_name, channel_name)
    create_channel(channel_group_name, channel_name, params::Dict{String,<:Any})

Create a channel to start receiving content streams. The channel represents the input to
MediaPackage for incoming live content from an encoder such as AWS Elemental MediaLive. The
channel receives content, and after packaging it, outputs it through an origin endpoint to
downstream devices (such as video players or CDNs) that request the content. You can create
only one channel with each request. We recommend that you spread out channels between
channel groups, such as putting redundant channels in the same AWS Region in different
channel groups.

# Arguments
- `channel_group_name`: The name that describes the channel group. The name is the primary
  identifier for the channel group, and must be unique for your account in the AWS Region.
- `channel_name`: The name that describes the channel. The name is the primary identifier
  for the channel, and must be unique for your account in the AWS Region and channel group.
  You can't change the name after you create the channel.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: Enter any descriptive text that helps you to identify the channel.
- `"InputType"`: The input type will be an immutable field which will be used to define
  whether the channel will allow CMAF ingest or HLS ingest. If unprovided, it will default to
  HLS to preserve current behavior. The allowed values are:    HLS - The HLS streaming
  specification (which defines M3U8 manifests and TS segments).    CMAF - The DASH-IF CMAF
  Ingest specification (which defines CMAF segments with optional DASH manifests).
- `"tags"`: A comma-separated list of tag key:value pairs that you define. For example:
  \"Key1\": \"Value1\",   \"Key2\": \"Value2\"
- `"x-amzn-client-token"`: A unique, case-sensitive token that you provide to ensure the
  idempotency of the request.
"""
function create_channel(
    ChannelGroupName, ChannelName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediapackagev2(
        "POST",
        "/channelGroup/$(ChannelGroupName)/channel",
        Dict{String,Any}(
            "ChannelName" => ChannelName, "x-amzn-client-token" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_channel(
    ChannelGroupName,
    ChannelName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediapackagev2(
        "POST",
        "/channelGroup/$(ChannelGroupName)/channel",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ChannelName" => ChannelName, "x-amzn-client-token" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_channel_group(channel_group_name)
    create_channel_group(channel_group_name, params::Dict{String,<:Any})

Create a channel group to group your channels and origin endpoints. A channel group is the
top-level resource that consists of channels and origin endpoints that are associated with
it and that provides predictable URLs for stream delivery. All channels and origin
endpoints within the channel group are guaranteed to share the DNS. You can create only one
channel group with each request.

# Arguments
- `channel_group_name`: The name that describes the channel group. The name is the primary
  identifier for the channel group, and must be unique for your account in the AWS Region.
  You can't use spaces in the name. You can't change the name after you create the channel
  group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: Enter any descriptive text that helps you to identify the channel group.
- `"tags"`: A comma-separated list of tag key:value pairs that you define. For example:
  \"Key1\": \"Value1\",   \"Key2\": \"Value2\"
- `"x-amzn-client-token"`: A unique, case-sensitive token that you provide to ensure the
  idempotency of the request.
"""
function create_channel_group(
    ChannelGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediapackagev2(
        "POST",
        "/channelGroup",
        Dict{String,Any}(
            "ChannelGroupName" => ChannelGroupName, "x-amzn-client-token" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_channel_group(
    ChannelGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediapackagev2(
        "POST",
        "/channelGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ChannelGroupName" => ChannelGroupName,
                    "x-amzn-client-token" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_origin_endpoint(channel_group_name, channel_name, container_type, origin_endpoint_name)
    create_origin_endpoint(channel_group_name, channel_name, container_type, origin_endpoint_name, params::Dict{String,<:Any})

The endpoint is attached to a channel, and represents the output of the live content. You
can associate multiple endpoints to a single channel. Each endpoint gives players and
downstream CDNs (such as Amazon CloudFront) access to the content for playback. Content
can't be served from a channel until it has an endpoint. You can create only one endpoint
with each request.

# Arguments
- `channel_group_name`: The name that describes the channel group. The name is the primary
  identifier for the channel group, and must be unique for your account in the AWS Region.
- `channel_name`: The name that describes the channel. The name is the primary identifier
  for the channel, and must be unique for your account in the AWS Region and channel group.
- `container_type`: The type of container to attach to this origin endpoint. A container
  type is a file format that encapsulates one or more media streams, such as audio and video,
  into a single file. You can't change the container type after you create the endpoint.
- `origin_endpoint_name`: The name that describes the origin endpoint. The name is the
  primary identifier for the origin endpoint, and must be unique for your account in the AWS
  Region and channel. You can't use spaces in the name. You can't change the name after you
  create the endpoint.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DashManifests"`: A DASH manifest configuration.
- `"Description"`: Enter any descriptive text that helps you to identify the origin
  endpoint.
- `"ForceEndpointErrorConfiguration"`: The failover settings for the endpoint.
- `"HlsManifests"`: An HTTP live streaming (HLS) manifest configuration.
- `"LowLatencyHlsManifests"`: A low-latency HLS manifest configuration.
- `"Segment"`: The segment configuration, including the segment name, duration, and other
  configuration values.
- `"StartoverWindowSeconds"`: The size of the window (in seconds) to create a window of the
  live stream that's available for on-demand viewing. Viewers can start-over or catch-up on
  content that falls within the window. The maximum startover window is 1,209,600 seconds (14
  days).
- `"Tags"`: A comma-separated list of tag key:value pairs that you define. For example:
  \"Key1\": \"Value1\",   \"Key2\": \"Value2\"
- `"x-amzn-client-token"`: A unique, case-sensitive token that you provide to ensure the
  idempotency of the request.
"""
function create_origin_endpoint(
    ChannelGroupName,
    ChannelName,
    ContainerType,
    OriginEndpointName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediapackagev2(
        "POST",
        "/channelGroup/$(ChannelGroupName)/channel/$(ChannelName)/originEndpoint",
        Dict{String,Any}(
            "ContainerType" => ContainerType,
            "OriginEndpointName" => OriginEndpointName,
            "x-amzn-client-token" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_origin_endpoint(
    ChannelGroupName,
    ChannelName,
    ContainerType,
    OriginEndpointName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediapackagev2(
        "POST",
        "/channelGroup/$(ChannelGroupName)/channel/$(ChannelName)/originEndpoint",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ContainerType" => ContainerType,
                    "OriginEndpointName" => OriginEndpointName,
                    "x-amzn-client-token" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_channel(channel_group_name, channel_name)
    delete_channel(channel_group_name, channel_name, params::Dict{String,<:Any})

Delete a channel to stop AWS Elemental MediaPackage from receiving further content. You
must delete the channel's origin endpoints before you can delete the channel.

# Arguments
- `channel_group_name`: The name that describes the channel group. The name is the primary
  identifier for the channel group, and must be unique for your account in the AWS Region.
- `channel_name`: The name that describes the channel. The name is the primary identifier
  for the channel, and must be unique for your account in the AWS Region and channel group.

"""
function delete_channel(
    ChannelGroupName, ChannelName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediapackagev2(
        "DELETE",
        "/channelGroup/$(ChannelGroupName)/channel/$(ChannelName)/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_channel(
    ChannelGroupName,
    ChannelName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediapackagev2(
        "DELETE",
        "/channelGroup/$(ChannelGroupName)/channel/$(ChannelName)/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_channel_group(channel_group_name)
    delete_channel_group(channel_group_name, params::Dict{String,<:Any})

Delete a channel group. You must delete the channel group's channels and origin endpoints
before you can delete the channel group. If you delete a channel group, you'll lose access
to the egress domain and will have to create a new channel group to replace it.

# Arguments
- `channel_group_name`: The name that describes the channel group. The name is the primary
  identifier for the channel group, and must be unique for your account in the AWS Region.

"""
function delete_channel_group(
    ChannelGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediapackagev2(
        "DELETE",
        "/channelGroup/$(ChannelGroupName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_channel_group(
    ChannelGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediapackagev2(
        "DELETE",
        "/channelGroup/$(ChannelGroupName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_channel_policy(channel_group_name, channel_name)
    delete_channel_policy(channel_group_name, channel_name, params::Dict{String,<:Any})

Delete a channel policy.

# Arguments
- `channel_group_name`: The name that describes the channel group. The name is the primary
  identifier for the channel group, and must be unique for your account in the AWS Region.
- `channel_name`: The name that describes the channel. The name is the primary identifier
  for the channel, and must be unique for your account in the AWS Region and channel group.

"""
function delete_channel_policy(
    ChannelGroupName, ChannelName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediapackagev2(
        "DELETE",
        "/channelGroup/$(ChannelGroupName)/channel/$(ChannelName)/policy";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_channel_policy(
    ChannelGroupName,
    ChannelName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediapackagev2(
        "DELETE",
        "/channelGroup/$(ChannelGroupName)/channel/$(ChannelName)/policy",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_origin_endpoint(channel_group_name, channel_name, origin_endpoint_name)
    delete_origin_endpoint(channel_group_name, channel_name, origin_endpoint_name, params::Dict{String,<:Any})

Origin endpoints can serve content until they're deleted. Delete the endpoint if it should
no longer respond to playback requests. You must delete all endpoints from a channel before
you can delete the channel.

# Arguments
- `channel_group_name`: The name that describes the channel group. The name is the primary
  identifier for the channel group, and must be unique for your account in the AWS Region.
- `channel_name`: The name that describes the channel. The name is the primary identifier
  for the channel, and must be unique for your account in the AWS Region and channel group.
- `origin_endpoint_name`: The name that describes the origin endpoint. The name is the
  primary identifier for the origin endpoint, and and must be unique for your account in the
  AWS Region and channel.

"""
function delete_origin_endpoint(
    ChannelGroupName,
    ChannelName,
    OriginEndpointName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediapackagev2(
        "DELETE",
        "/channelGroup/$(ChannelGroupName)/channel/$(ChannelName)/originEndpoint/$(OriginEndpointName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_origin_endpoint(
    ChannelGroupName,
    ChannelName,
    OriginEndpointName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediapackagev2(
        "DELETE",
        "/channelGroup/$(ChannelGroupName)/channel/$(ChannelName)/originEndpoint/$(OriginEndpointName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_origin_endpoint_policy(channel_group_name, channel_name, origin_endpoint_name)
    delete_origin_endpoint_policy(channel_group_name, channel_name, origin_endpoint_name, params::Dict{String,<:Any})

Delete an origin endpoint policy.

# Arguments
- `channel_group_name`: The name that describes the channel group. The name is the primary
  identifier for the channel group, and must be unique for your account in the AWS Region.
- `channel_name`: The name that describes the channel. The name is the primary identifier
  for the channel, and must be unique for your account in the AWS Region and channel group.
- `origin_endpoint_name`: The name that describes the origin endpoint. The name is the
  primary identifier for the origin endpoint, and and must be unique for your account in the
  AWS Region and channel.

"""
function delete_origin_endpoint_policy(
    ChannelGroupName,
    ChannelName,
    OriginEndpointName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediapackagev2(
        "DELETE",
        "/channelGroup/$(ChannelGroupName)/channel/$(ChannelName)/originEndpoint/$(OriginEndpointName)/policy";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_origin_endpoint_policy(
    ChannelGroupName,
    ChannelName,
    OriginEndpointName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediapackagev2(
        "DELETE",
        "/channelGroup/$(ChannelGroupName)/channel/$(ChannelName)/originEndpoint/$(OriginEndpointName)/policy",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_channel(channel_group_name, channel_name)
    get_channel(channel_group_name, channel_name, params::Dict{String,<:Any})

Retrieves the specified channel that's configured in AWS Elemental MediaPackage, including
the origin endpoints that are associated with it.

# Arguments
- `channel_group_name`: The name that describes the channel group. The name is the primary
  identifier for the channel group, and must be unique for your account in the AWS Region.
- `channel_name`: The name that describes the channel. The name is the primary identifier
  for the channel, and must be unique for your account in the AWS Region and channel group.

"""
function get_channel(
    ChannelGroupName, ChannelName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediapackagev2(
        "GET",
        "/channelGroup/$(ChannelGroupName)/channel/$(ChannelName)/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_channel(
    ChannelGroupName,
    ChannelName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediapackagev2(
        "GET",
        "/channelGroup/$(ChannelGroupName)/channel/$(ChannelName)/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_channel_group(channel_group_name)
    get_channel_group(channel_group_name, params::Dict{String,<:Any})

Retrieves the specified channel group that's configured in AWS Elemental MediaPackage,
including the channels and origin endpoints that are associated with it.

# Arguments
- `channel_group_name`: The name that describes the channel group. The name is the primary
  identifier for the channel group, and must be unique for your account in the AWS Region.

"""
function get_channel_group(
    ChannelGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediapackagev2(
        "GET",
        "/channelGroup/$(ChannelGroupName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_channel_group(
    ChannelGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediapackagev2(
        "GET",
        "/channelGroup/$(ChannelGroupName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_channel_policy(channel_group_name, channel_name)
    get_channel_policy(channel_group_name, channel_name, params::Dict{String,<:Any})

Retrieves the specified channel policy that's configured in AWS Elemental MediaPackage.
With policies, you can specify who has access to AWS resources and what actions they can
perform on those resources.

# Arguments
- `channel_group_name`: The name that describes the channel group. The name is the primary
  identifier for the channel group, and must be unique for your account in the AWS Region.
- `channel_name`: The name that describes the channel. The name is the primary identifier
  for the channel, and must be unique for your account in the AWS Region and channel group.

"""
function get_channel_policy(
    ChannelGroupName, ChannelName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediapackagev2(
        "GET",
        "/channelGroup/$(ChannelGroupName)/channel/$(ChannelName)/policy";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_channel_policy(
    ChannelGroupName,
    ChannelName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediapackagev2(
        "GET",
        "/channelGroup/$(ChannelGroupName)/channel/$(ChannelName)/policy",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_origin_endpoint(channel_group_name, channel_name, origin_endpoint_name)
    get_origin_endpoint(channel_group_name, channel_name, origin_endpoint_name, params::Dict{String,<:Any})

Retrieves the specified origin endpoint that's configured in AWS Elemental MediaPackage to
obtain its playback URL and to view the packaging settings that it's currently using.

# Arguments
- `channel_group_name`: The name that describes the channel group. The name is the primary
  identifier for the channel group, and must be unique for your account in the AWS Region.
- `channel_name`: The name that describes the channel. The name is the primary identifier
  for the channel, and must be unique for your account in the AWS Region and channel group.
- `origin_endpoint_name`: The name that describes the origin endpoint. The name is the
  primary identifier for the origin endpoint, and and must be unique for your account in the
  AWS Region and channel.

"""
function get_origin_endpoint(
    ChannelGroupName,
    ChannelName,
    OriginEndpointName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediapackagev2(
        "GET",
        "/channelGroup/$(ChannelGroupName)/channel/$(ChannelName)/originEndpoint/$(OriginEndpointName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_origin_endpoint(
    ChannelGroupName,
    ChannelName,
    OriginEndpointName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediapackagev2(
        "GET",
        "/channelGroup/$(ChannelGroupName)/channel/$(ChannelName)/originEndpoint/$(OriginEndpointName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_origin_endpoint_policy(channel_group_name, channel_name, origin_endpoint_name)
    get_origin_endpoint_policy(channel_group_name, channel_name, origin_endpoint_name, params::Dict{String,<:Any})

Retrieves the specified origin endpoint policy that's configured in AWS Elemental
MediaPackage.

# Arguments
- `channel_group_name`: The name that describes the channel group. The name is the primary
  identifier for the channel group, and must be unique for your account in the AWS Region.
- `channel_name`: The name that describes the channel. The name is the primary identifier
  for the channel, and must be unique for your account in the AWS Region and channel group.
- `origin_endpoint_name`: The name that describes the origin endpoint. The name is the
  primary identifier for the origin endpoint, and and must be unique for your account in the
  AWS Region and channel.

"""
function get_origin_endpoint_policy(
    ChannelGroupName,
    ChannelName,
    OriginEndpointName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediapackagev2(
        "GET",
        "/channelGroup/$(ChannelGroupName)/channel/$(ChannelName)/originEndpoint/$(OriginEndpointName)/policy";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_origin_endpoint_policy(
    ChannelGroupName,
    ChannelName,
    OriginEndpointName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediapackagev2(
        "GET",
        "/channelGroup/$(ChannelGroupName)/channel/$(ChannelName)/originEndpoint/$(OriginEndpointName)/policy",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_channel_groups()
    list_channel_groups(params::Dict{String,<:Any})

Retrieves all channel groups that are configured in AWS Elemental MediaPackage, including
the channels and origin endpoints that are associated with it.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in the response.
- `"nextToken"`: The pagination token from the GET list request. Use the token to fetch the
  next page of results.
"""
function list_channel_groups(; aws_config::AbstractAWSConfig=current_aws_config())
    return mediapackagev2(
        "GET", "/channelGroup"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_channel_groups(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediapackagev2(
        "GET",
        "/channelGroup",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_channels(channel_group_name)
    list_channels(channel_group_name, params::Dict{String,<:Any})

Retrieves all channels in a specific channel group that are configured in AWS Elemental
MediaPackage, including the origin endpoints that are associated with it.

# Arguments
- `channel_group_name`: The name that describes the channel group. The name is the primary
  identifier for the channel group, and must be unique for your account in the AWS Region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in the response.
- `"nextToken"`: The pagination token from the GET list request. Use the token to fetch the
  next page of results.
"""
function list_channels(ChannelGroupName; aws_config::AbstractAWSConfig=current_aws_config())
    return mediapackagev2(
        "GET",
        "/channelGroup/$(ChannelGroupName)/channel";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_channels(
    ChannelGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediapackagev2(
        "GET",
        "/channelGroup/$(ChannelGroupName)/channel",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_origin_endpoints(channel_group_name, channel_name)
    list_origin_endpoints(channel_group_name, channel_name, params::Dict{String,<:Any})

Retrieves all origin endpoints in a specific channel that are configured in AWS Elemental
MediaPackage.

# Arguments
- `channel_group_name`: The name that describes the channel group. The name is the primary
  identifier for the channel group, and must be unique for your account in the AWS Region.
- `channel_name`: The name that describes the channel. The name is the primary identifier
  for the channel, and must be unique for your account in the AWS Region and channel group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in the response.
- `"nextToken"`: The pagination token from the GET list request. Use the token to fetch the
  next page of results.
"""
function list_origin_endpoints(
    ChannelGroupName, ChannelName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediapackagev2(
        "GET",
        "/channelGroup/$(ChannelGroupName)/channel/$(ChannelName)/originEndpoint";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_origin_endpoints(
    ChannelGroupName,
    ChannelName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediapackagev2(
        "GET",
        "/channelGroup/$(ChannelGroupName)/channel/$(ChannelName)/originEndpoint",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists the tags assigned to a resource.

# Arguments
- `resource_arn`: The ARN of the CloudWatch resource that you want to view tags for.

"""
function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediapackagev2(
        "GET",
        "/tags/$(ResourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediapackagev2(
        "GET",
        "/tags/$(ResourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_channel_policy(channel_group_name, channel_name, policy)
    put_channel_policy(channel_group_name, channel_name, policy, params::Dict{String,<:Any})

Attaches an IAM policy to the specified channel. With policies, you can specify who has
access to AWS resources and what actions they can perform on those resources. You can
attach only one policy with each request.

# Arguments
- `channel_group_name`: The name that describes the channel group. The name is the primary
  identifier for the channel group, and must be unique for your account in the AWS Region.
- `channel_name`: The name that describes the channel. The name is the primary identifier
  for the channel, and must be unique for your account in the AWS Region and channel group.
- `policy`: The policy to attach to the specified channel.

"""
function put_channel_policy(
    ChannelGroupName,
    ChannelName,
    Policy;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediapackagev2(
        "PUT",
        "/channelGroup/$(ChannelGroupName)/channel/$(ChannelName)/policy",
        Dict{String,Any}("Policy" => Policy);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_channel_policy(
    ChannelGroupName,
    ChannelName,
    Policy,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediapackagev2(
        "PUT",
        "/channelGroup/$(ChannelGroupName)/channel/$(ChannelName)/policy",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Policy" => Policy), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_origin_endpoint_policy(channel_group_name, channel_name, origin_endpoint_name, policy)
    put_origin_endpoint_policy(channel_group_name, channel_name, origin_endpoint_name, policy, params::Dict{String,<:Any})

Attaches an IAM policy to the specified origin endpoint. You can attach only one policy
with each request.

# Arguments
- `channel_group_name`: The name that describes the channel group. The name is the primary
  identifier for the channel group, and must be unique for your account in the AWS Region.
- `channel_name`: The name that describes the channel. The name is the primary identifier
  for the channel, and must be unique for your account in the AWS Region and channel group.
- `origin_endpoint_name`: The name that describes the origin endpoint. The name is the
  primary identifier for the origin endpoint, and and must be unique for your account in the
  AWS Region and channel.
- `policy`: The policy to attach to the specified origin endpoint.

"""
function put_origin_endpoint_policy(
    ChannelGroupName,
    ChannelName,
    OriginEndpointName,
    Policy;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediapackagev2(
        "POST",
        "/channelGroup/$(ChannelGroupName)/channel/$(ChannelName)/originEndpoint/$(OriginEndpointName)/policy",
        Dict{String,Any}("Policy" => Policy);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_origin_endpoint_policy(
    ChannelGroupName,
    ChannelName,
    OriginEndpointName,
    Policy,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediapackagev2(
        "POST",
        "/channelGroup/$(ChannelGroupName)/channel/$(ChannelName)/originEndpoint/$(OriginEndpointName)/policy",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Policy" => Policy), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Assigns one of more tags (key-value pairs) to the specified MediaPackage resource. Tags can
help you organize and categorize your resources. You can also use them to scope user
permissions, by granting a user permission to access or change only resources with certain
tag values. You can use the TagResource operation with a resource that already has tags. If
you specify a new tag key for the resource, this tag is appended to the list of tags
associated with the resource. If you specify a tag key that is already associated with the
resource, the new tag value that you specify replaces the previous value for that tag.

# Arguments
- `resource_arn`: The ARN of the MediaPackage resource that you're adding tags to.
- `tags`: Contains a map of the key-value pairs for the resource tag or tags assigned to
  the resource.

"""
function tag_resource(ResourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return mediapackagev2(
        "POST",
        "/tags/$(ResourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediapackagev2(
        "POST",
        "/tags/$(ResourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes one or more tags from the specified resource.

# Arguments
- `resource_arn`: The ARN of the MediaPackage resource that you're removing tags from.
- `tag_keys`: The list of tag keys to remove from the resource.

"""
function untag_resource(
    ResourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediapackagev2(
        "DELETE",
        "/tags/$(ResourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediapackagev2(
        "DELETE",
        "/tags/$(ResourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_channel(channel_group_name, channel_name)
    update_channel(channel_group_name, channel_name, params::Dict{String,<:Any})

Update the specified channel. You can edit if MediaPackage sends ingest or egress access
logs to the CloudWatch log group, if content will be encrypted, the description on a
channel, and your channel's policy settings. You can't edit the name of the channel or
CloudFront distribution details. Any edits you make that impact the video output may not be
reflected for a few minutes.

# Arguments
- `channel_group_name`: The name that describes the channel group. The name is the primary
  identifier for the channel group, and must be unique for your account in the AWS Region.
- `channel_name`: The name that describes the channel. The name is the primary identifier
  for the channel, and must be unique for your account in the AWS Region and channel group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: Any descriptive information that you want to add to the channel for
  future identification purposes.
- `"x-amzn-update-if-match"`: The expected current Entity Tag (ETag) for the resource. If
  the specified ETag does not match the resource's current entity tag, the update request
  will be rejected.
"""
function update_channel(
    ChannelGroupName, ChannelName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediapackagev2(
        "PUT",
        "/channelGroup/$(ChannelGroupName)/channel/$(ChannelName)/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_channel(
    ChannelGroupName,
    ChannelName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediapackagev2(
        "PUT",
        "/channelGroup/$(ChannelGroupName)/channel/$(ChannelName)/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_channel_group(channel_group_name)
    update_channel_group(channel_group_name, params::Dict{String,<:Any})

Update the specified channel group. You can edit the description on a channel group for
easier identification later from the AWS Elemental MediaPackage console. You can't edit the
name of the channel group. Any edits you make that impact the video output may not be
reflected for a few minutes.

# Arguments
- `channel_group_name`: The name that describes the channel group. The name is the primary
  identifier for the channel group, and must be unique for your account in the AWS Region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: Any descriptive information that you want to add to the channel group
  for future identification purposes.
- `"x-amzn-update-if-match"`: The expected current Entity Tag (ETag) for the resource. If
  the specified ETag does not match the resource's current entity tag, the update request
  will be rejected.
"""
function update_channel_group(
    ChannelGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mediapackagev2(
        "PUT",
        "/channelGroup/$(ChannelGroupName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_channel_group(
    ChannelGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediapackagev2(
        "PUT",
        "/channelGroup/$(ChannelGroupName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_origin_endpoint(channel_group_name, channel_name, container_type, origin_endpoint_name)
    update_origin_endpoint(channel_group_name, channel_name, container_type, origin_endpoint_name, params::Dict{String,<:Any})

Update the specified origin endpoint. Edit the packaging preferences on an endpoint to
optimize the viewing experience. You can't edit the name of the endpoint. Any edits you
make that impact the video output may not be reflected for a few minutes.

# Arguments
- `channel_group_name`: The name that describes the channel group. The name is the primary
  identifier for the channel group, and must be unique for your account in the AWS Region.
- `channel_name`: The name that describes the channel. The name is the primary identifier
  for the channel, and must be unique for your account in the AWS Region and channel group.
- `container_type`: The type of container attached to this origin endpoint. A container
  type is a file format that encapsulates one or more media streams, such as audio and video,
  into a single file.
- `origin_endpoint_name`: The name that describes the origin endpoint. The name is the
  primary identifier for the origin endpoint, and and must be unique for your account in the
  AWS Region and channel.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DashManifests"`: A DASH manifest configuration.
- `"Description"`: Any descriptive information that you want to add to the origin endpoint
  for future identification purposes.
- `"ForceEndpointErrorConfiguration"`: The failover settings for the endpoint.
- `"HlsManifests"`: An HTTP live streaming (HLS) manifest configuration.
- `"LowLatencyHlsManifests"`: A low-latency HLS manifest configuration.
- `"Segment"`: The segment configuration, including the segment name, duration, and other
  configuration values.
- `"StartoverWindowSeconds"`: The size of the window (in seconds) to create a window of the
  live stream that's available for on-demand viewing. Viewers can start-over or catch-up on
  content that falls within the window. The maximum startover window is 1,209,600 seconds (14
  days).
- `"x-amzn-update-if-match"`: The expected current Entity Tag (ETag) for the resource. If
  the specified ETag does not match the resource's current entity tag, the update request
  will be rejected.
"""
function update_origin_endpoint(
    ChannelGroupName,
    ChannelName,
    ContainerType,
    OriginEndpointName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediapackagev2(
        "PUT",
        "/channelGroup/$(ChannelGroupName)/channel/$(ChannelName)/originEndpoint/$(OriginEndpointName)",
        Dict{String,Any}("ContainerType" => ContainerType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_origin_endpoint(
    ChannelGroupName,
    ChannelName,
    ContainerType,
    OriginEndpointName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mediapackagev2(
        "PUT",
        "/channelGroup/$(ChannelGroupName)/channel/$(ChannelName)/originEndpoint/$(OriginEndpointName)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ContainerType" => ContainerType), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: greengrassv2
using AWS.Compat
using AWS.UUIDs

"""
    associate_service_role_to_account(role_arn)
    associate_service_role_to_account(role_arn, params::Dict{String,<:Any})

Associates a Greengrass service role with IoT Greengrass for your Amazon Web Services
account in this Amazon Web Services Region. IoT Greengrass uses this role to verify the
identity of client devices and manage core device connectivity information. The role must
include the AWSGreengrassResourceAccessRolePolicy managed policy or a custom policy that
defines equivalent permissions for the IoT Greengrass features that you use. For more
information, see Greengrass service role in the IoT Greengrass Version 2 Developer Guide.

# Arguments
- `role_arn`: The Amazon Resource Name (ARN) of the service role to associate with IoT
  Greengrass for your Amazon Web Services account in this Amazon Web Services Region.

"""
function associate_service_role_to_account(
    RoleArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrassv2(
        "PUT",
        "/greengrass/servicerole",
        Dict{String,Any}("RoleArn" => RoleArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_service_role_to_account(
    RoleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrassv2(
        "PUT",
        "/greengrass/servicerole",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("RoleArn" => RoleArn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_associate_client_device_with_core_device(core_device_thing_name)
    batch_associate_client_device_with_core_device(core_device_thing_name, params::Dict{String,<:Any})

Associates a list of client devices with a core device. Use this API operation to specify
which client devices can discover a core device through cloud discovery. With cloud
discovery, client devices connect to IoT Greengrass to retrieve associated core devices'
connectivity information and certificates. For more information, see Configure cloud
discovery in the IoT Greengrass V2 Developer Guide.  Client devices are local IoT devices
that connect to and communicate with an IoT Greengrass core device over MQTT. You can
connect client devices to a core device to sync MQTT messages and data to Amazon Web
Services IoT Core and interact with client devices in Greengrass components. For more
information, see Interact with local IoT devices in the IoT Greengrass V2 Developer Guide.

# Arguments
- `core_device_thing_name`: The name of the core device. This is also the name of the IoT
  thing.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"entries"`: The list of client devices to associate.
"""
function batch_associate_client_device_with_core_device(
    coreDeviceThingName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrassv2(
        "POST",
        "/greengrass/v2/coreDevices/$(coreDeviceThingName)/associateClientDevices";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_associate_client_device_with_core_device(
    coreDeviceThingName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrassv2(
        "POST",
        "/greengrass/v2/coreDevices/$(coreDeviceThingName)/associateClientDevices",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_disassociate_client_device_from_core_device(core_device_thing_name)
    batch_disassociate_client_device_from_core_device(core_device_thing_name, params::Dict{String,<:Any})

Disassociates a list of client devices from a core device. After you disassociate a client
device from a core device, the client device won't be able to use cloud discovery to
retrieve the core device's connectivity information and certificates.

# Arguments
- `core_device_thing_name`: The name of the core device. This is also the name of the IoT
  thing.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"entries"`: The list of client devices to disassociate.
"""
function batch_disassociate_client_device_from_core_device(
    coreDeviceThingName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrassv2(
        "POST",
        "/greengrass/v2/coreDevices/$(coreDeviceThingName)/disassociateClientDevices";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_disassociate_client_device_from_core_device(
    coreDeviceThingName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrassv2(
        "POST",
        "/greengrass/v2/coreDevices/$(coreDeviceThingName)/disassociateClientDevices",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_deployment(deployment_id)
    cancel_deployment(deployment_id, params::Dict{String,<:Any})

Cancels a deployment. This operation cancels the deployment for devices that haven't yet
received it. If a device already received the deployment, this operation doesn't change
anything for that device.

# Arguments
- `deployment_id`: The ID of the deployment.

"""
function cancel_deployment(deploymentId; aws_config::AbstractAWSConfig=current_aws_config())
    return greengrassv2(
        "POST",
        "/greengrass/v2/deployments/$(deploymentId)/cancel";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_deployment(
    deploymentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrassv2(
        "POST",
        "/greengrass/v2/deployments/$(deploymentId)/cancel",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_component_version()
    create_component_version(params::Dict{String,<:Any})

Creates a component. Components are software that run on Greengrass core devices. After you
develop and test a component on your core device, you can use this operation to upload your
component to IoT Greengrass. Then, you can deploy the component to other core devices. You
can use this operation to do the following:    Create components from recipes  Create a
component from a recipe, which is a file that defines the component's metadata, parameters,
dependencies, lifecycle, artifacts, and platform capability. For more information, see IoT
Greengrass component recipe reference in the IoT Greengrass V2 Developer Guide. To create a
component from a recipe, specify inlineRecipe when you call this operation.    Create
components from Lambda functions  Create a component from an Lambda function that runs on
IoT Greengrass. This creates a recipe and artifacts from the Lambda function's deployment
package. You can use this operation to migrate Lambda functions from IoT Greengrass V1 to
IoT Greengrass V2. This function accepts Lambda functions in all supported versions of
Python, Node.js, and Java runtimes. IoT Greengrass doesn't apply any additional
restrictions on deprecated Lambda runtime versions. To create a component from a Lambda
function, specify lambdaFunction when you call this operation.  IoT Greengrass currently
supports Lambda functions on only Linux core devices.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier that you can provide to ensure that
  the request is idempotent. Idempotency means that the request is successfully processed
  only once, even if you send the request multiple times. When a request succeeds, and you
  specify the same client token for subsequent successful requests, the IoT Greengrass V2
  service returns the successful response that it caches from the previous request. IoT
  Greengrass V2 caches successful responses for idempotent requests for up to 8 hours.
- `"inlineRecipe"`: The recipe to use to create the component. The recipe defines the
  component's metadata, parameters, dependencies, lifecycle, artifacts, and platform
  compatibility. You must specify either inlineRecipe or lambdaFunction.
- `"lambdaFunction"`: The parameters to create a component from a Lambda function. You must
  specify either inlineRecipe or lambdaFunction.
- `"tags"`: A list of key-value pairs that contain metadata for the resource. For more
  information, see Tag your resources in the IoT Greengrass V2 Developer Guide.
"""
function create_component_version(; aws_config::AbstractAWSConfig=current_aws_config())
    return greengrassv2(
        "POST",
        "/greengrass/v2/createComponentVersion",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_component_version(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrassv2(
        "POST",
        "/greengrass/v2/createComponentVersion",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_deployment(target_arn)
    create_deployment(target_arn, params::Dict{String,<:Any})

Creates a continuous deployment for a target, which is a Greengrass core device or group of
core devices. When you add a new core device to a group of core devices that has a
deployment, IoT Greengrass deploys that group's deployment to the new device. You can
define one deployment for each target. When you create a new deployment for a target that
has an existing deployment, you replace the previous deployment. IoT Greengrass applies the
new deployment to the target devices. Every deployment has a revision number that indicates
how many deployment revisions you define for a target. Use this operation to create a new
revision of an existing deployment. For more information, see the Create deployments in the
IoT Greengrass V2 Developer Guide.

# Arguments
- `target_arn`: The ARN of the target IoT thing or thing group. When creating a
  subdeployment, the targetARN can only be a thing group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier that you can provide to ensure that
  the request is idempotent. Idempotency means that the request is successfully processed
  only once, even if you send the request multiple times. When a request succeeds, and you
  specify the same client token for subsequent successful requests, the IoT Greengrass V2
  service returns the successful response that it caches from the previous request. IoT
  Greengrass V2 caches successful responses for idempotent requests for up to 8 hours.
- `"components"`: The components to deploy. This is a dictionary, where each key is the
  name of a component, and each key's value is the version and configuration to deploy for
  that component.
- `"deploymentName"`: The name of the deployment.
- `"deploymentPolicies"`: The deployment policies for the deployment. These policies define
  how the deployment updates components and handles failure.
- `"iotJobConfiguration"`: The job configuration for the deployment configuration. The job
  configuration specifies the rollout, timeout, and stop configurations for the deployment
  configuration.
- `"parentTargetArn"`: The parent deployment's target ARN within a subdeployment.
- `"tags"`: A list of key-value pairs that contain metadata for the resource. For more
  information, see Tag your resources in the IoT Greengrass V2 Developer Guide.
"""
function create_deployment(targetArn; aws_config::AbstractAWSConfig=current_aws_config())
    return greengrassv2(
        "POST",
        "/greengrass/v2/deployments",
        Dict{String,Any}("targetArn" => targetArn, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_deployment(
    targetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrassv2(
        "POST",
        "/greengrass/v2/deployments",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "targetArn" => targetArn, "clientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_component(arn)
    delete_component(arn, params::Dict{String,<:Any})

Deletes a version of a component from IoT Greengrass.  This operation deletes the
component's recipe and artifacts. As a result, deployments that refer to this component
version will fail. If you have deployments that use this component version, you can remove
the component from the deployment or update the deployment to use a valid version.

# Arguments
- `arn`: The ARN of the component version.

"""
function delete_component(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return greengrassv2(
        "DELETE",
        "/greengrass/v2/components/$(arn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_component(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrassv2(
        "DELETE",
        "/greengrass/v2/components/$(arn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_core_device(core_device_thing_name)
    delete_core_device(core_device_thing_name, params::Dict{String,<:Any})

Deletes a Greengrass core device, which is an IoT thing. This operation removes the core
device from the list of core devices. This operation doesn't delete the IoT thing. For more
information about how to delete the IoT thing, see DeleteThing in the IoT API Reference.

# Arguments
- `core_device_thing_name`: The name of the core device. This is also the name of the IoT
  thing.

"""
function delete_core_device(
    coreDeviceThingName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrassv2(
        "DELETE",
        "/greengrass/v2/coreDevices/$(coreDeviceThingName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_core_device(
    coreDeviceThingName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrassv2(
        "DELETE",
        "/greengrass/v2/coreDevices/$(coreDeviceThingName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_deployment(deployment_id)
    delete_deployment(deployment_id, params::Dict{String,<:Any})

Deletes a deployment. To delete an active deployment, you must first cancel it. For more
information, see CancelDeployment. Deleting a deployment doesn't affect core devices that
run that deployment, because core devices store the deployment's configuration on the
device. Additionally, core devices can roll back to a previous deployment that has been
deleted.

# Arguments
- `deployment_id`: The ID of the deployment.

"""
function delete_deployment(deploymentId; aws_config::AbstractAWSConfig=current_aws_config())
    return greengrassv2(
        "DELETE",
        "/greengrass/v2/deployments/$(deploymentId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_deployment(
    deploymentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrassv2(
        "DELETE",
        "/greengrass/v2/deployments/$(deploymentId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_component(arn)
    describe_component(arn, params::Dict{String,<:Any})

Retrieves metadata for a version of a component.

# Arguments
- `arn`: The ARN of the component version.

"""
function describe_component(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return greengrassv2(
        "GET",
        "/greengrass/v2/components/$(arn)/metadata";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_component(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrassv2(
        "GET",
        "/greengrass/v2/components/$(arn)/metadata",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_service_role_from_account()
    disassociate_service_role_from_account(params::Dict{String,<:Any})

Disassociates the Greengrass service role from IoT Greengrass for your Amazon Web Services
account in this Amazon Web Services Region. Without a service role, IoT Greengrass can't
verify the identity of client devices or manage core device connectivity information. For
more information, see Greengrass service role in the IoT Greengrass Version 2 Developer
Guide.

"""
function disassociate_service_role_from_account(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrassv2(
        "DELETE",
        "/greengrass/servicerole";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_service_role_from_account(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrassv2(
        "DELETE",
        "/greengrass/servicerole",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_component(arn)
    get_component(arn, params::Dict{String,<:Any})

Gets the recipe for a version of a component.

# Arguments
- `arn`: The ARN of the component version.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"recipeOutputFormat"`: The format of the recipe.
"""
function get_component(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return greengrassv2(
        "GET",
        "/greengrass/v2/components/$(arn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_component(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrassv2(
        "GET",
        "/greengrass/v2/components/$(arn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_component_version_artifact(arn, artifact_name)
    get_component_version_artifact(arn, artifact_name, params::Dict{String,<:Any})

Gets the pre-signed URL to download a public or a Lambda component artifact. Core devices
call this operation to identify the URL that they can use to download an artifact to
install.

# Arguments
- `arn`: The ARN of the component version. Specify the ARN of a public or a Lambda
  component version.
- `artifact_name`: The name of the artifact. You can use the GetComponent operation to
  download the component recipe, which includes the URI of the artifact. The artifact name is
  the section of the URI after the scheme. For example, in the artifact URI
  greengrass:SomeArtifact.zip, the artifact name is SomeArtifact.zip.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"s3EndpointType"`: Specifies the endpoint to use when getting Amazon S3 pre-signed URLs.
  All Amazon Web Services Regions except US East (N. Virginia) use REGIONAL in all cases. In
  the US East (N. Virginia) Region the default is GLOBAL, but you can change it to REGIONAL
  with this parameter.
- `"x-amz-iot-endpoint-type"`: Determines if the Amazon S3 URL returned is a FIPS
  pre-signed URL endpoint. Specify fips if you want the returned Amazon S3 pre-signed URL to
  point to an Amazon S3 FIPS endpoint. If you don't specify a value, the default is standard.
"""
function get_component_version_artifact(
    arn, artifactName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrassv2(
        "GET",
        "/greengrass/v2/components/$(arn)/artifacts/$(artifactName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_component_version_artifact(
    arn,
    artifactName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrassv2(
        "GET",
        "/greengrass/v2/components/$(arn)/artifacts/$(artifactName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_connectivity_info(thing_name)
    get_connectivity_info(thing_name, params::Dict{String,<:Any})

Retrieves connectivity information for a Greengrass core device. Connectivity information
includes endpoints and ports where client devices can connect to an MQTT broker on the core
device. When a client device calls the IoT Greengrass discovery API, IoT Greengrass returns
connectivity information for all of the core devices where the client device can connect.
For more information, see Connect client devices to core devices in the IoT Greengrass
Version 2 Developer Guide.

# Arguments
- `thing_name`: The name of the core device. This is also the name of the IoT thing.

"""
function get_connectivity_info(
    thingName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrassv2(
        "GET",
        "/greengrass/things/$(thingName)/connectivityInfo";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_connectivity_info(
    thingName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrassv2(
        "GET",
        "/greengrass/things/$(thingName)/connectivityInfo",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_core_device(core_device_thing_name)
    get_core_device(core_device_thing_name, params::Dict{String,<:Any})

Retrieves metadata for a Greengrass core device.  IoT Greengrass relies on individual
devices to send status updates to the Amazon Web Services Cloud. If the IoT Greengrass Core
software isn't running on the device, or if device isn't connected to the Amazon Web
Services Cloud, then the reported status of that device might not reflect its current
status. The status timestamp indicates when the device status was last updated. Core
devices send status updates at the following times:   When the IoT Greengrass Core software
starts   When the core device receives a deployment from the Amazon Web Services Cloud
When the status of any component on the core device becomes BROKEN    At a regular interval
that you can configure, which defaults to 24 hours   For IoT Greengrass Core v2.7.0, the
core device sends status updates upon local deployment and cloud deployment

# Arguments
- `core_device_thing_name`: The name of the core device. This is also the name of the IoT
  thing.

"""
function get_core_device(
    coreDeviceThingName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrassv2(
        "GET",
        "/greengrass/v2/coreDevices/$(coreDeviceThingName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_core_device(
    coreDeviceThingName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrassv2(
        "GET",
        "/greengrass/v2/coreDevices/$(coreDeviceThingName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_deployment(deployment_id)
    get_deployment(deployment_id, params::Dict{String,<:Any})

Gets a deployment. Deployments define the components that run on Greengrass core devices.

# Arguments
- `deployment_id`: The ID of the deployment.

"""
function get_deployment(deploymentId; aws_config::AbstractAWSConfig=current_aws_config())
    return greengrassv2(
        "GET",
        "/greengrass/v2/deployments/$(deploymentId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_deployment(
    deploymentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrassv2(
        "GET",
        "/greengrass/v2/deployments/$(deploymentId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_service_role_for_account()
    get_service_role_for_account(params::Dict{String,<:Any})

Gets the service role associated with IoT Greengrass for your Amazon Web Services account
in this Amazon Web Services Region. IoT Greengrass uses this role to verify the identity of
client devices and manage core device connectivity information. For more information, see
Greengrass service role in the IoT Greengrass Version 2 Developer Guide.

"""
function get_service_role_for_account(; aws_config::AbstractAWSConfig=current_aws_config())
    return greengrassv2(
        "GET",
        "/greengrass/servicerole";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_service_role_for_account(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrassv2(
        "GET",
        "/greengrass/servicerole",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_client_devices_associated_with_core_device(core_device_thing_name)
    list_client_devices_associated_with_core_device(core_device_thing_name, params::Dict{String,<:Any})

Retrieves a paginated list of client devices that are associated with a core device.

# Arguments
- `core_device_thing_name`: The name of the core device. This is also the name of the IoT
  thing.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to be returned per paginated request.
- `"nextToken"`: The token to be used for the next set of paginated results.
"""
function list_client_devices_associated_with_core_device(
    coreDeviceThingName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrassv2(
        "GET",
        "/greengrass/v2/coreDevices/$(coreDeviceThingName)/associatedClientDevices";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_client_devices_associated_with_core_device(
    coreDeviceThingName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrassv2(
        "GET",
        "/greengrass/v2/coreDevices/$(coreDeviceThingName)/associatedClientDevices",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_component_versions(arn)
    list_component_versions(arn, params::Dict{String,<:Any})

Retrieves a paginated list of all versions for a component. Greater versions are listed
first.

# Arguments
- `arn`: The ARN of the component.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to be returned per paginated request.
- `"nextToken"`: The token to be used for the next set of paginated results.
"""
function list_component_versions(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return greengrassv2(
        "GET",
        "/greengrass/v2/components/$(arn)/versions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_component_versions(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrassv2(
        "GET",
        "/greengrass/v2/components/$(arn)/versions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_components()
    list_components(params::Dict{String,<:Any})

Retrieves a paginated list of component summaries. This list includes components that you
have permission to view.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to be returned per paginated request.
- `"nextToken"`: The token to be used for the next set of paginated results.
- `"scope"`: The scope of the components to list. Default: PRIVATE
"""
function list_components(; aws_config::AbstractAWSConfig=current_aws_config())
    return greengrassv2(
        "GET",
        "/greengrass/v2/components";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_components(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrassv2(
        "GET",
        "/greengrass/v2/components",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_core_devices()
    list_core_devices(params::Dict{String,<:Any})

Retrieves a paginated list of Greengrass core devices.  IoT Greengrass relies on individual
devices to send status updates to the Amazon Web Services Cloud. If the IoT Greengrass Core
software isn't running on the device, or if device isn't connected to the Amazon Web
Services Cloud, then the reported status of that device might not reflect its current
status. The status timestamp indicates when the device status was last updated. Core
devices send status updates at the following times:   When the IoT Greengrass Core software
starts   When the core device receives a deployment from the Amazon Web Services Cloud
When the status of any component on the core device becomes BROKEN    At a regular interval
that you can configure, which defaults to 24 hours   For IoT Greengrass Core v2.7.0, the
core device sends status updates upon local deployment and cloud deployment

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to be returned per paginated request.
- `"nextToken"`: The token to be used for the next set of paginated results.
- `"status"`: The core device status by which to filter. If you specify this parameter, the
  list includes only core devices that have this status. Choose one of the following options:
     HEALTHY – The IoT Greengrass Core software and all components run on the core device
  without issue.    UNHEALTHY – The IoT Greengrass Core software or a component is in a
  failed state on the core device.
- `"thingGroupArn"`: The ARN of the IoT thing group by which to filter. If you specify this
  parameter, the list includes only core devices that have successfully deployed a deployment
  that targets the thing group. When you remove a core device from a thing group, the list
  continues to include that core device.
"""
function list_core_devices(; aws_config::AbstractAWSConfig=current_aws_config())
    return greengrassv2(
        "GET",
        "/greengrass/v2/coreDevices";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_core_devices(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrassv2(
        "GET",
        "/greengrass/v2/coreDevices",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_deployments()
    list_deployments(params::Dict{String,<:Any})

Retrieves a paginated list of deployments.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"historyFilter"`: The filter for the list of deployments. Choose one of the following
  options:    ALL – The list includes all deployments.    LATEST_ONLY – The list includes
  only the latest revision of each deployment.   Default: LATEST_ONLY
- `"maxResults"`: The maximum number of results to be returned per paginated request.
  Default: 50
- `"nextToken"`: The token to be used for the next set of paginated results.
- `"parentTargetArn"`: The parent deployment's target ARN within a subdeployment.
- `"targetArn"`: The ARN of the target IoT thing or thing group.
"""
function list_deployments(; aws_config::AbstractAWSConfig=current_aws_config())
    return greengrassv2(
        "GET",
        "/greengrass/v2/deployments";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_deployments(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrassv2(
        "GET",
        "/greengrass/v2/deployments",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_effective_deployments(core_device_thing_name)
    list_effective_deployments(core_device_thing_name, params::Dict{String,<:Any})

Retrieves a paginated list of deployment jobs that IoT Greengrass sends to Greengrass core
devices.

# Arguments
- `core_device_thing_name`: The name of the core device. This is also the name of the IoT
  thing.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to be returned per paginated request.
- `"nextToken"`: The token to be used for the next set of paginated results.
"""
function list_effective_deployments(
    coreDeviceThingName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrassv2(
        "GET",
        "/greengrass/v2/coreDevices/$(coreDeviceThingName)/effectiveDeployments";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_effective_deployments(
    coreDeviceThingName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrassv2(
        "GET",
        "/greengrass/v2/coreDevices/$(coreDeviceThingName)/effectiveDeployments",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_installed_components(core_device_thing_name)
    list_installed_components(core_device_thing_name, params::Dict{String,<:Any})

Retrieves a paginated list of the components that a Greengrass core device runs. By
default, this list doesn't include components that are deployed as dependencies of other
components. To include dependencies in the response, set the topologyFilter parameter to
ALL.  IoT Greengrass relies on individual devices to send status updates to the Amazon Web
Services Cloud. If the IoT Greengrass Core software isn't running on the device, or if
device isn't connected to the Amazon Web Services Cloud, then the reported status of that
device might not reflect its current status. The status timestamp indicates when the device
status was last updated. Core devices send status updates at the following times:   When
the IoT Greengrass Core software starts   When the core device receives a deployment from
the Amazon Web Services Cloud   When the status of any component on the core device becomes
BROKEN    At a regular interval that you can configure, which defaults to 24 hours   For
IoT Greengrass Core v2.7.0, the core device sends status updates upon local deployment and
cloud deployment

# Arguments
- `core_device_thing_name`: The name of the core device. This is also the name of the IoT
  thing.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to be returned per paginated request.
- `"nextToken"`: The token to be used for the next set of paginated results.
- `"topologyFilter"`: The filter for the list of components. Choose from the following
  options:    ALL – The list includes all components installed on the core device.    ROOT
  – The list includes only root components, which are components that you specify in a
  deployment. When you choose this option, the list doesn't include components that the core
  device installs as dependencies of other components.   Default: ROOT
"""
function list_installed_components(
    coreDeviceThingName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrassv2(
        "GET",
        "/greengrass/v2/coreDevices/$(coreDeviceThingName)/installedComponents";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_installed_components(
    coreDeviceThingName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrassv2(
        "GET",
        "/greengrass/v2/coreDevices/$(coreDeviceThingName)/installedComponents",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Retrieves the list of tags for an IoT Greengrass resource.

# Arguments
- `resource_arn`: The ARN of the resource.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrassv2(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrassv2(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    resolve_component_candidates()
    resolve_component_candidates(params::Dict{String,<:Any})

Retrieves a list of components that meet the component, version, and platform requirements
of a deployment. Greengrass core devices call this operation when they receive a deployment
to identify the components to install. This operation identifies components that meet all
dependency requirements for a deployment. If the requirements conflict, then this operation
returns an error and the deployment fails. For example, this occurs if component A requires
version &gt;2.0.0 and component B requires version &lt;2.0.0 of a component dependency.
When you specify the component candidates to resolve, IoT Greengrass compares each
component's digest from the core device with the component's digest in the Amazon Web
Services Cloud. If the digests don't match, then IoT Greengrass specifies to use the
version from the Amazon Web Services Cloud.  To use this operation, you must use the data
plane API endpoint and authenticate with an IoT device certificate. For more information,
see IoT Greengrass endpoints and quotas.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"componentCandidates"`: The list of components to resolve.
- `"platform"`: The platform to use to resolve compatible components.
"""
function resolve_component_candidates(; aws_config::AbstractAWSConfig=current_aws_config())
    return greengrassv2(
        "POST",
        "/greengrass/v2/resolveComponentCandidates";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function resolve_component_candidates(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrassv2(
        "POST",
        "/greengrass/v2/resolveComponentCandidates",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds tags to an IoT Greengrass resource. If a tag already exists for the resource, this
operation updates the tag's value.

# Arguments
- `resource_arn`: The ARN of the resource to tag.
- `tags`: A list of key-value pairs that contain metadata for the resource. For more
  information, see Tag your resources in the IoT Greengrass V2 Developer Guide.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return greengrassv2(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrassv2(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes a tag from an IoT Greengrass resource.

# Arguments
- `resource_arn`: The ARN of the resource to untag.
- `tag_keys`: A list of keys for tags to remove from the resource.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrassv2(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrassv2(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_connectivity_info(connectivity_info, thing_name)
    update_connectivity_info(connectivity_info, thing_name, params::Dict{String,<:Any})

Updates connectivity information for a Greengrass core device. Connectivity information
includes endpoints and ports where client devices can connect to an MQTT broker on the core
device. When a client device calls the IoT Greengrass discovery API, IoT Greengrass returns
connectivity information for all of the core devices where the client device can connect.
For more information, see Connect client devices to core devices in the IoT Greengrass
Version 2 Developer Guide.

# Arguments
- `connectivity_info`: The connectivity information for the core device.
- `thing_name`: The name of the core device. This is also the name of the IoT thing.

"""
function update_connectivity_info(
    ConnectivityInfo, thingName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrassv2(
        "PUT",
        "/greengrass/things/$(thingName)/connectivityInfo",
        Dict{String,Any}("ConnectivityInfo" => ConnectivityInfo);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_connectivity_info(
    ConnectivityInfo,
    thingName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrassv2(
        "PUT",
        "/greengrass/things/$(thingName)/connectivityInfo",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ConnectivityInfo" => ConnectivityInfo), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: sfn
using AWS.Compat
using AWS.UUIDs

"""
    create_activity(name)
    create_activity(name, params::Dict{String,<:Any})

Creates an activity. An activity is a task that you write in any programming language and
host on any machine that has access to Step Functions. Activities must poll Step Functions
using the GetActivityTask API action and respond using SendTask* API actions. This function
lets Step Functions know the existence of your activity and returns an identifier for use
in a state machine and when polling from the activity.  This operation is eventually
consistent. The results are best effort and may not reflect very recent updates and
changes.    CreateActivity is an idempotent API. Subsequent requests won’t create a
duplicate resource if it was already created. CreateActivity's idempotency check is based
on the activity name. If a following request has different tags values, Step Functions will
ignore these differences and treat it as an idempotent request of the previous. In this
case, tags will not be updated, even if they are different.

# Arguments
- `name`: The name of the activity to create. This name must be unique for your Amazon Web
  Services account and region for 90 days. For more information, see  Limits Related to State
  Machine Executions in the Step Functions Developer Guide. A name must not contain:   white
  space   brackets &lt; &gt; { } [ ]    wildcard characters ? *    special characters \" # %
  ^ | ~ `  &amp; , ; : /    control characters (U+0000-001F, U+007F-009F)   To enable logging
  with CloudWatch Logs, the name should only contain 0-9, A-Z, a-z, - and _.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tags"`: The list of tags to add to a resource. An array of key-value pairs. For more
  information, see Using Cost Allocation Tags in the Amazon Web Services Billing and Cost
  Management User Guide, and Controlling Access Using IAM Tags. Tags may only contain Unicode
  letters, digits, white space, or these symbols: _ . : / = + - @.
"""
function create_activity(name; aws_config::AbstractAWSConfig=current_aws_config())
    return sfn(
        "CreateActivity",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_activity(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sfn(
        "CreateActivity",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_state_machine(definition, name, role_arn)
    create_state_machine(definition, name, role_arn, params::Dict{String,<:Any})

Creates a state machine. A state machine consists of a collection of states that can do
work (Task states), determine to which states to transition next (Choice states), stop an
execution with an error (Fail states), and so on. State machines are specified using a
JSON-based, structured language. For more information, see Amazon States Language in the
Step Functions User Guide. If you set the publish parameter of this API action to true, it
publishes version 1 as the first revision of the state machine.  This operation is
eventually consistent. The results are best effort and may not reflect very recent updates
and changes.    CreateStateMachine is an idempotent API. Subsequent requests won’t create
a duplicate resource if it was already created. CreateStateMachine's idempotency check is
based on the state machine name, definition, type, LoggingConfiguration, and
TracingConfiguration. The check is also based on the publish and versionDescription
parameters. If a following request has a different roleArn or tags, Step Functions will
ignore these differences and treat it as an idempotent request of the previous. In this
case, roleArn and tags will not be updated, even if they are different.

# Arguments
- `definition`: The Amazon States Language definition of the state machine. See Amazon
  States Language.
- `name`: The name of the state machine.  A name must not contain:   white space   brackets
  &lt; &gt; { } [ ]    wildcard characters ? *    special characters \" # %  ^ | ~ `  &amp; ,
  ; : /    control characters (U+0000-001F, U+007F-009F)   To enable logging with CloudWatch
  Logs, the name should only contain 0-9, A-Z, a-z, - and _.
- `role_arn`: The Amazon Resource Name (ARN) of the IAM role to use for this state machine.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"loggingConfiguration"`: Defines what execution history events are logged and where they
  are logged.  By default, the level is set to OFF. For more information see Log Levels in
  the Step Functions User Guide.
- `"publish"`: Set to true to publish the first version of the state machine during
  creation. The default is false.
- `"tags"`: Tags to be added when creating a state machine. An array of key-value pairs.
  For more information, see Using Cost Allocation Tags in the Amazon Web Services Billing and
  Cost Management User Guide, and Controlling Access Using IAM Tags. Tags may only contain
  Unicode letters, digits, white space, or these symbols: _ . : / = + - @.
- `"tracingConfiguration"`: Selects whether X-Ray tracing is enabled.
- `"type"`: Determines whether a Standard or Express state machine is created. The default
  is STANDARD. You cannot update the type of a state machine once it has been created.
- `"versionDescription"`: Sets description about the state machine version. You can only
  set the description if the publish parameter is set to true. Otherwise, if you set
  versionDescription, but publish to false, this API action throws ValidationException.
"""
function create_state_machine(
    definition, name, roleArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sfn(
        "CreateStateMachine",
        Dict{String,Any}("definition" => definition, "name" => name, "roleArn" => roleArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_state_machine(
    definition,
    name,
    roleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sfn(
        "CreateStateMachine",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "definition" => definition, "name" => name, "roleArn" => roleArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_state_machine_alias(name, routing_configuration)
    create_state_machine_alias(name, routing_configuration, params::Dict{String,<:Any})

Creates an alias for a state machine that points to one or two versions of the same state
machine. You can set your application to call StartExecution with an alias and update the
version the alias uses without changing the client's code. You can also map an alias to
split StartExecution requests between two versions of a state machine. To do this, add a
second RoutingConfig object in the routingConfiguration parameter. You must also specify
the percentage of execution run requests each version should receive in both RoutingConfig
objects. Step Functions randomly chooses which version runs a given execution based on the
percentage you specify. To create an alias that points to a single version, specify a
single RoutingConfig object with a weight set to 100. You can create up to 100 aliases for
each state machine. You must delete unused aliases using the DeleteStateMachineAlias API
action.  CreateStateMachineAlias is an idempotent API. Step Functions bases the idempotency
check on the stateMachineArn, description, name, and routingConfiguration parameters.
Requests that contain the same values for these parameters return a successful idempotent
response without creating a duplicate resource.  Related operations:
DescribeStateMachineAlias     ListStateMachineAliases     UpdateStateMachineAlias
DeleteStateMachineAlias

# Arguments
- `name`: The name of the state machine alias. To avoid conflict with version ARNs, don't
  use an integer in the name of the alias.
- `routing_configuration`: The routing configuration of a state machine alias. The routing
  configuration shifts execution traffic between two state machine versions.
  routingConfiguration contains an array of RoutingConfig objects that specify up to two
  state machine versions. Step Functions then randomly choses which version to run an
  execution with based on the weight assigned to each RoutingConfig.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A description for the state machine alias.
"""
function create_state_machine_alias(
    name, routingConfiguration; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sfn(
        "CreateStateMachineAlias",
        Dict{String,Any}("name" => name, "routingConfiguration" => routingConfiguration);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_state_machine_alias(
    name,
    routingConfiguration,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sfn(
        "CreateStateMachineAlias",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "name" => name, "routingConfiguration" => routingConfiguration
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_activity(activity_arn)
    delete_activity(activity_arn, params::Dict{String,<:Any})

Deletes an activity.

# Arguments
- `activity_arn`: The Amazon Resource Name (ARN) of the activity to delete.

"""
function delete_activity(activityArn; aws_config::AbstractAWSConfig=current_aws_config())
    return sfn(
        "DeleteActivity",
        Dict{String,Any}("activityArn" => activityArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_activity(
    activityArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sfn(
        "DeleteActivity",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("activityArn" => activityArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_state_machine(state_machine_arn)
    delete_state_machine(state_machine_arn, params::Dict{String,<:Any})

Deletes a state machine. This is an asynchronous operation. It sets the state machine's
status to DELETING and begins the deletion process. A state machine is deleted only when
all its executions are completed. On the next state transition, the state machine's
executions are terminated. A qualified state machine ARN can either refer to a Distributed
Map state defined within a state machine, a version ARN, or an alias ARN. The following are
some examples of qualified and unqualified state machine ARNs:   The following qualified
state machine ARN refers to a Distributed Map state with a label mapStateLabel in a state
machine named myStateMachine.
arn:partition:states:region:account-id:stateMachine:myStateMachine/mapStateLabel   If you
provide a qualified state machine ARN that refers to a Distributed Map state, the request
fails with ValidationException.    The following unqualified state machine ARN refers to a
state machine named myStateMachine.
arn:partition:states:region:account-id:stateMachine:myStateMachine    This API action also
deletes all versions and aliases associated with a state machine.  For EXPRESS state
machines, the deletion happens eventually (usually in less than a minute). Running
executions may emit logs after DeleteStateMachine API is called.

# Arguments
- `state_machine_arn`: The Amazon Resource Name (ARN) of the state machine to delete.

"""
function delete_state_machine(
    stateMachineArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sfn(
        "DeleteStateMachine",
        Dict{String,Any}("stateMachineArn" => stateMachineArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_state_machine(
    stateMachineArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sfn(
        "DeleteStateMachine",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("stateMachineArn" => stateMachineArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_state_machine_alias(state_machine_alias_arn)
    delete_state_machine_alias(state_machine_alias_arn, params::Dict{String,<:Any})

Deletes a state machine alias. After you delete a state machine alias, you can't use it to
start executions. When you delete a state machine alias, Step Functions doesn't delete the
state machine versions that alias references.  Related operations:
CreateStateMachineAlias     DescribeStateMachineAlias     ListStateMachineAliases
UpdateStateMachineAlias

# Arguments
- `state_machine_alias_arn`: The Amazon Resource Name (ARN) of the state machine alias to
  delete.

"""
function delete_state_machine_alias(
    stateMachineAliasArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sfn(
        "DeleteStateMachineAlias",
        Dict{String,Any}("stateMachineAliasArn" => stateMachineAliasArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_state_machine_alias(
    stateMachineAliasArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sfn(
        "DeleteStateMachineAlias",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("stateMachineAliasArn" => stateMachineAliasArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_state_machine_version(state_machine_version_arn)
    delete_state_machine_version(state_machine_version_arn, params::Dict{String,<:Any})

Deletes a state machine version. After you delete a version, you can't call StartExecution
using that version's ARN or use the version with a state machine alias.  Deleting a state
machine version won't terminate its in-progress executions.   You can't delete a state
machine version currently referenced by one or more aliases. Before you delete a version,
you must either delete the aliases or update them to point to another state machine
version.   Related operations:     PublishStateMachineVersion     ListStateMachineVersions


# Arguments
- `state_machine_version_arn`: The Amazon Resource Name (ARN) of the state machine version
  to delete.

"""
function delete_state_machine_version(
    stateMachineVersionArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sfn(
        "DeleteStateMachineVersion",
        Dict{String,Any}("stateMachineVersionArn" => stateMachineVersionArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_state_machine_version(
    stateMachineVersionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sfn(
        "DeleteStateMachineVersion",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("stateMachineVersionArn" => stateMachineVersionArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_activity(activity_arn)
    describe_activity(activity_arn, params::Dict{String,<:Any})

Describes an activity.  This operation is eventually consistent. The results are best
effort and may not reflect very recent updates and changes.

# Arguments
- `activity_arn`: The Amazon Resource Name (ARN) of the activity to describe.

"""
function describe_activity(activityArn; aws_config::AbstractAWSConfig=current_aws_config())
    return sfn(
        "DescribeActivity",
        Dict{String,Any}("activityArn" => activityArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_activity(
    activityArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sfn(
        "DescribeActivity",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("activityArn" => activityArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_execution(execution_arn)
    describe_execution(execution_arn, params::Dict{String,<:Any})

Provides information about a state machine execution, such as the state machine associated
with the execution, the execution input and output, and relevant execution metadata. If
you've redriven an execution, you can use this API action to return information about the
redrives of that execution. In addition, you can use this API action to return the Map Run
Amazon Resource Name (ARN) if the execution was dispatched by a Map Run. If you specify a
version or alias ARN when you call the StartExecution API action, DescribeExecution returns
that ARN.  This operation is eventually consistent. The results are best effort and may not
reflect very recent updates and changes.  Executions of an EXPRESS state machine aren't
supported by DescribeExecution unless a Map Run dispatched them.

# Arguments
- `execution_arn`: The Amazon Resource Name (ARN) of the execution to describe.

"""
function describe_execution(
    executionArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sfn(
        "DescribeExecution",
        Dict{String,Any}("executionArn" => executionArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_execution(
    executionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sfn(
        "DescribeExecution",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("executionArn" => executionArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_map_run(map_run_arn)
    describe_map_run(map_run_arn, params::Dict{String,<:Any})

Provides information about a Map Run's configuration, progress, and results. If you've
redriven a Map Run, this API action also returns information about the redrives of that Map
Run. For more information, see Examining Map Run in the Step Functions Developer Guide.

# Arguments
- `map_run_arn`: The Amazon Resource Name (ARN) that identifies a Map Run.

"""
function describe_map_run(mapRunArn; aws_config::AbstractAWSConfig=current_aws_config())
    return sfn(
        "DescribeMapRun",
        Dict{String,Any}("mapRunArn" => mapRunArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_map_run(
    mapRunArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sfn(
        "DescribeMapRun",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("mapRunArn" => mapRunArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_state_machine(state_machine_arn)
    describe_state_machine(state_machine_arn, params::Dict{String,<:Any})

Provides information about a state machine's definition, its IAM role Amazon Resource Name
(ARN), and configuration. A qualified state machine ARN can either refer to a Distributed
Map state defined within a state machine, a version ARN, or an alias ARN. The following are
some examples of qualified and unqualified state machine ARNs:   The following qualified
state machine ARN refers to a Distributed Map state with a label mapStateLabel in a state
machine named myStateMachine.
arn:partition:states:region:account-id:stateMachine:myStateMachine/mapStateLabel   If you
provide a qualified state machine ARN that refers to a Distributed Map state, the request
fails with ValidationException.    The following qualified state machine ARN refers to an
alias named PROD.
arn:&lt;partition&gt;:states:&lt;region&gt;:&lt;account-id&gt;:stateMachine:&lt;myStateMachi
ne:PROD&gt;   If you provide a qualified state machine ARN that refers to a version ARN or
an alias ARN, the request starts execution for that version or alias.    The following
unqualified state machine ARN refers to a state machine named myStateMachine.
arn:&lt;partition&gt;:states:&lt;region&gt;:&lt;account-id&gt;:stateMachine:&lt;myStateMachi
ne&gt;    This API action returns the details for a state machine version if the
stateMachineArn you specify is a state machine version ARN.  This operation is eventually
consistent. The results are best effort and may not reflect very recent updates and
changes.

# Arguments
- `state_machine_arn`: The Amazon Resource Name (ARN) of the state machine for which you
  want the information. If you specify a state machine version ARN, this API returns details
  about that version. The version ARN is a combination of state machine ARN and the version
  number separated by a colon (:). For example, stateMachineARN:1.

"""
function describe_state_machine(
    stateMachineArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sfn(
        "DescribeStateMachine",
        Dict{String,Any}("stateMachineArn" => stateMachineArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_state_machine(
    stateMachineArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sfn(
        "DescribeStateMachine",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("stateMachineArn" => stateMachineArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_state_machine_alias(state_machine_alias_arn)
    describe_state_machine_alias(state_machine_alias_arn, params::Dict{String,<:Any})

Returns details about a state machine alias.  Related operations:
CreateStateMachineAlias     ListStateMachineAliases     UpdateStateMachineAlias
DeleteStateMachineAlias

# Arguments
- `state_machine_alias_arn`: The Amazon Resource Name (ARN) of the state machine alias.

"""
function describe_state_machine_alias(
    stateMachineAliasArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sfn(
        "DescribeStateMachineAlias",
        Dict{String,Any}("stateMachineAliasArn" => stateMachineAliasArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_state_machine_alias(
    stateMachineAliasArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sfn(
        "DescribeStateMachineAlias",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("stateMachineAliasArn" => stateMachineAliasArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_state_machine_for_execution(execution_arn)
    describe_state_machine_for_execution(execution_arn, params::Dict{String,<:Any})

Provides information about a state machine's definition, its execution role ARN, and
configuration. If a Map Run dispatched the execution, this action returns the Map Run
Amazon Resource Name (ARN) in the response. The state machine returned is the state machine
associated with the Map Run.  This operation is eventually consistent. The results are best
effort and may not reflect very recent updates and changes.  This API action is not
supported by EXPRESS state machines.

# Arguments
- `execution_arn`: The Amazon Resource Name (ARN) of the execution you want state machine
  information for.

"""
function describe_state_machine_for_execution(
    executionArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sfn(
        "DescribeStateMachineForExecution",
        Dict{String,Any}("executionArn" => executionArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_state_machine_for_execution(
    executionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sfn(
        "DescribeStateMachineForExecution",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("executionArn" => executionArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_activity_task(activity_arn)
    get_activity_task(activity_arn, params::Dict{String,<:Any})

Used by workers to retrieve a task (with the specified activity ARN) which has been
scheduled for execution by a running state machine. This initiates a long poll, where the
service holds the HTTP connection open and responds as soon as a task becomes available
(i.e. an execution of a task of this type is needed.) The maximum time the service holds on
to the request before responding is 60 seconds. If no task is available within 60 seconds,
the poll returns a taskToken with a null string.  This API action isn't logged in
CloudTrail.   Workers should set their client side socket timeout to at least 65 seconds (5
seconds higher than the maximum time the service may hold the poll request). Polling with
GetActivityTask can cause latency in some implementations. See Avoid Latency When Polling
for Activity Tasks in the Step Functions Developer Guide.

# Arguments
- `activity_arn`: The Amazon Resource Name (ARN) of the activity to retrieve tasks from
  (assigned when you create the task using CreateActivity.)

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"workerName"`: You can provide an arbitrary name in order to identify the worker that
  the task is assigned to. This name is used when it is logged in the execution history.
"""
function get_activity_task(activityArn; aws_config::AbstractAWSConfig=current_aws_config())
    return sfn(
        "GetActivityTask",
        Dict{String,Any}("activityArn" => activityArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_activity_task(
    activityArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sfn(
        "GetActivityTask",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("activityArn" => activityArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_execution_history(execution_arn)
    get_execution_history(execution_arn, params::Dict{String,<:Any})

Returns the history of the specified execution as a list of events. By default, the results
are returned in ascending order of the timeStamp of the events. Use the reverseOrder
parameter to get the latest events first. If nextToken is returned, there are more results
available. The value of nextToken is a unique pagination token for each page. Make the call
again using the returned token to retrieve the next page. Keep all other arguments
unchanged. Each pagination token expires after 24 hours. Using an expired pagination token
will return an HTTP 400 InvalidToken error. This API action is not supported by EXPRESS
state machines.

# Arguments
- `execution_arn`: The Amazon Resource Name (ARN) of the execution.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"includeExecutionData"`: You can select whether execution data (input or output of a
  history event) is returned. The default is true.
- `"maxResults"`: The maximum number of results that are returned per call. You can use
  nextToken to obtain further pages of results. The default is 100 and the maximum allowed
  page size is 1000. A value of 0 uses the default. This is only an upper limit. The actual
  number of results returned per call might be fewer than the specified maximum.
- `"nextToken"`: If nextToken is returned, there are more results available. The value of
  nextToken is a unique pagination token for each page. Make the call again using the
  returned token to retrieve the next page. Keep all other arguments unchanged. Each
  pagination token expires after 24 hours. Using an expired pagination token will return an
  HTTP 400 InvalidToken error.
- `"reverseOrder"`: Lists events in descending order of their timeStamp.
"""
function get_execution_history(
    executionArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sfn(
        "GetExecutionHistory",
        Dict{String,Any}("executionArn" => executionArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_execution_history(
    executionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sfn(
        "GetExecutionHistory",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("executionArn" => executionArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_activities()
    list_activities(params::Dict{String,<:Any})

Lists the existing activities. If nextToken is returned, there are more results available.
The value of nextToken is a unique pagination token for each page. Make the call again
using the returned token to retrieve the next page. Keep all other arguments unchanged.
Each pagination token expires after 24 hours. Using an expired pagination token will return
an HTTP 400 InvalidToken error.  This operation is eventually consistent. The results are
best effort and may not reflect very recent updates and changes.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results that are returned per call. You can use
  nextToken to obtain further pages of results. The default is 100 and the maximum allowed
  page size is 1000. A value of 0 uses the default. This is only an upper limit. The actual
  number of results returned per call might be fewer than the specified maximum.
- `"nextToken"`: If nextToken is returned, there are more results available. The value of
  nextToken is a unique pagination token for each page. Make the call again using the
  returned token to retrieve the next page. Keep all other arguments unchanged. Each
  pagination token expires after 24 hours. Using an expired pagination token will return an
  HTTP 400 InvalidToken error.
"""
function list_activities(; aws_config::AbstractAWSConfig=current_aws_config())
    return sfn("ListActivities"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_activities(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sfn(
        "ListActivities", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_executions()
    list_executions(params::Dict{String,<:Any})

Lists all executions of a state machine or a Map Run. You can list all executions related
to a state machine by specifying a state machine Amazon Resource Name (ARN), or those
related to a Map Run by specifying a Map Run ARN. Using this API action, you can also list
all redriven executions. You can also provide a state machine alias ARN or version ARN to
list the executions associated with a specific alias or version. Results are sorted by
time, with the most recent execution first. If nextToken is returned, there are more
results available. The value of nextToken is a unique pagination token for each page. Make
the call again using the returned token to retrieve the next page. Keep all other arguments
unchanged. Each pagination token expires after 24 hours. Using an expired pagination token
will return an HTTP 400 InvalidToken error.  This operation is eventually consistent. The
results are best effort and may not reflect very recent updates and changes.  This API
action is not supported by EXPRESS state machines.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"mapRunArn"`: The Amazon Resource Name (ARN) of the Map Run that started the child
  workflow executions. If the mapRunArn field is specified, a list of all of the child
  workflow executions started by a Map Run is returned. For more information, see Examining
  Map Run in the Step Functions Developer Guide. You can specify either a mapRunArn or a
  stateMachineArn, but not both.
- `"maxResults"`: The maximum number of results that are returned per call. You can use
  nextToken to obtain further pages of results. The default is 100 and the maximum allowed
  page size is 1000. A value of 0 uses the default. This is only an upper limit. The actual
  number of results returned per call might be fewer than the specified maximum.
- `"nextToken"`: If nextToken is returned, there are more results available. The value of
  nextToken is a unique pagination token for each page. Make the call again using the
  returned token to retrieve the next page. Keep all other arguments unchanged. Each
  pagination token expires after 24 hours. Using an expired pagination token will return an
  HTTP 400 InvalidToken error.
- `"redriveFilter"`: Sets a filter to list executions based on whether or not they have
  been redriven. For a Distributed Map, redriveFilter sets a filter to list child workflow
  executions based on whether or not they have been redriven. If you do not provide a
  redriveFilter, Step Functions returns a list of both redriven and non-redriven executions.
  If you provide a state machine ARN in redriveFilter, the API returns a validation exception.
- `"stateMachineArn"`: The Amazon Resource Name (ARN) of the state machine whose executions
  is listed. You can specify either a mapRunArn or a stateMachineArn, but not both. You can
  also return a list of executions associated with a specific alias or version, by specifying
  an alias ARN or a version ARN in the stateMachineArn parameter.
- `"statusFilter"`: If specified, only list the executions whose current execution status
  matches the given filter.
"""
function list_executions(; aws_config::AbstractAWSConfig=current_aws_config())
    return sfn("ListExecutions"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_executions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sfn(
        "ListExecutions", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_map_runs(execution_arn)
    list_map_runs(execution_arn, params::Dict{String,<:Any})

Lists all Map Runs that were started by a given state machine execution. Use this API
action to obtain Map Run ARNs, and then call DescribeMapRun to obtain more information, if
needed.

# Arguments
- `execution_arn`: The Amazon Resource Name (ARN) of the execution for which the Map Runs
  must be listed.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results that are returned per call. You can use
  nextToken to obtain further pages of results. The default is 100 and the maximum allowed
  page size is 1000. A value of 0 uses the default. This is only an upper limit. The actual
  number of results returned per call might be fewer than the specified maximum.
- `"nextToken"`: If nextToken is returned, there are more results available. The value of
  nextToken is a unique pagination token for each page. Make the call again using the
  returned token to retrieve the next page. Keep all other arguments unchanged. Each
  pagination token expires after 24 hours. Using an expired pagination token will return an
  HTTP 400 InvalidToken error.
"""
function list_map_runs(executionArn; aws_config::AbstractAWSConfig=current_aws_config())
    return sfn(
        "ListMapRuns",
        Dict{String,Any}("executionArn" => executionArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_map_runs(
    executionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sfn(
        "ListMapRuns",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("executionArn" => executionArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_state_machine_aliases(state_machine_arn)
    list_state_machine_aliases(state_machine_arn, params::Dict{String,<:Any})

Lists aliases for a specified state machine ARN. Results are sorted by time, with the most
recently created aliases listed first.  To list aliases that reference a state machine
version, you can specify the version ARN in the stateMachineArn parameter. If nextToken is
returned, there are more results available. The value of nextToken is a unique pagination
token for each page. Make the call again using the returned token to retrieve the next
page. Keep all other arguments unchanged. Each pagination token expires after 24 hours.
Using an expired pagination token will return an HTTP 400 InvalidToken error.  Related
operations:     CreateStateMachineAlias     DescribeStateMachineAlias
UpdateStateMachineAlias     DeleteStateMachineAlias

# Arguments
- `state_machine_arn`: The Amazon Resource Name (ARN) of the state machine for which you
  want to list aliases. If you specify a state machine version ARN, this API returns a list
  of aliases for that version.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results that are returned per call. You can use
  nextToken to obtain further pages of results. The default is 100 and the maximum allowed
  page size is 1000. A value of 0 uses the default. This is only an upper limit. The actual
  number of results returned per call might be fewer than the specified maximum.
- `"nextToken"`: If nextToken is returned, there are more results available. The value of
  nextToken is a unique pagination token for each page. Make the call again using the
  returned token to retrieve the next page. Keep all other arguments unchanged. Each
  pagination token expires after 24 hours. Using an expired pagination token will return an
  HTTP 400 InvalidToken error.
"""
function list_state_machine_aliases(
    stateMachineArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sfn(
        "ListStateMachineAliases",
        Dict{String,Any}("stateMachineArn" => stateMachineArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_state_machine_aliases(
    stateMachineArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sfn(
        "ListStateMachineAliases",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("stateMachineArn" => stateMachineArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_state_machine_versions(state_machine_arn)
    list_state_machine_versions(state_machine_arn, params::Dict{String,<:Any})

Lists versions for the specified state machine Amazon Resource Name (ARN). The results are
sorted in descending order of the version creation time. If nextToken is returned, there
are more results available. The value of nextToken is a unique pagination token for each
page. Make the call again using the returned token to retrieve the next page. Keep all
other arguments unchanged. Each pagination token expires after 24 hours. Using an expired
pagination token will return an HTTP 400 InvalidToken error.  Related operations:
PublishStateMachineVersion     DeleteStateMachineVersion

# Arguments
- `state_machine_arn`: The Amazon Resource Name (ARN) of the state machine.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results that are returned per call. You can use
  nextToken to obtain further pages of results. The default is 100 and the maximum allowed
  page size is 1000. A value of 0 uses the default. This is only an upper limit. The actual
  number of results returned per call might be fewer than the specified maximum.
- `"nextToken"`: If nextToken is returned, there are more results available. The value of
  nextToken is a unique pagination token for each page. Make the call again using the
  returned token to retrieve the next page. Keep all other arguments unchanged. Each
  pagination token expires after 24 hours. Using an expired pagination token will return an
  HTTP 400 InvalidToken error.
"""
function list_state_machine_versions(
    stateMachineArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sfn(
        "ListStateMachineVersions",
        Dict{String,Any}("stateMachineArn" => stateMachineArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_state_machine_versions(
    stateMachineArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sfn(
        "ListStateMachineVersions",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("stateMachineArn" => stateMachineArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_state_machines()
    list_state_machines(params::Dict{String,<:Any})

Lists the existing state machines. If nextToken is returned, there are more results
available. The value of nextToken is a unique pagination token for each page. Make the call
again using the returned token to retrieve the next page. Keep all other arguments
unchanged. Each pagination token expires after 24 hours. Using an expired pagination token
will return an HTTP 400 InvalidToken error.  This operation is eventually consistent. The
results are best effort and may not reflect very recent updates and changes.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results that are returned per call. You can use
  nextToken to obtain further pages of results. The default is 100 and the maximum allowed
  page size is 1000. A value of 0 uses the default. This is only an upper limit. The actual
  number of results returned per call might be fewer than the specified maximum.
- `"nextToken"`: If nextToken is returned, there are more results available. The value of
  nextToken is a unique pagination token for each page. Make the call again using the
  returned token to retrieve the next page. Keep all other arguments unchanged. Each
  pagination token expires after 24 hours. Using an expired pagination token will return an
  HTTP 400 InvalidToken error.
"""
function list_state_machines(; aws_config::AbstractAWSConfig=current_aws_config())
    return sfn("ListStateMachines"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_state_machines(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sfn(
        "ListStateMachines", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

List tags for a given resource. Tags may only contain Unicode letters, digits, white space,
or these symbols: _ . : / = + - @.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) for the Step Functions state machine or
  activity.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sfn(
        "ListTagsForResource",
        Dict{String,Any}("resourceArn" => resourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sfn(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceArn" => resourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    publish_state_machine_version(state_machine_arn)
    publish_state_machine_version(state_machine_arn, params::Dict{String,<:Any})

Creates a version from the current revision of a state machine. Use versions to create
immutable snapshots of your state machine. You can start executions from versions either
directly or with an alias. To create an alias, use CreateStateMachineAlias. You can publish
up to 1000 versions for each state machine. You must manually delete unused versions using
the DeleteStateMachineVersion API action.  PublishStateMachineVersion is an idempotent API.
It doesn't create a duplicate state machine version if it already exists for the current
revision. Step Functions bases PublishStateMachineVersion's idempotency check on the
stateMachineArn, name, and revisionId parameters. Requests with the same parameters return
a successful idempotent response. If you don't specify a revisionId, Step Functions checks
for a previously published version of the state machine's current revision.  Related
operations:     DeleteStateMachineVersion     ListStateMachineVersions

# Arguments
- `state_machine_arn`: The Amazon Resource Name (ARN) of the state machine.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: An optional description of the state machine version.
- `"revisionId"`: Only publish the state machine version if the current state machine's
  revision ID matches the specified ID. Use this option to avoid publishing a version if the
  state machine changed since you last updated it. If the specified revision ID doesn't match
  the state machine's current revision ID, the API returns ConflictException.  To specify an
  initial revision ID for a state machine with no revision ID assigned, specify the string
  INITIAL for the revisionId parameter. For example, you can specify a revisionID of INITIAL
  when you create a state machine using the CreateStateMachine API action.
"""
function publish_state_machine_version(
    stateMachineArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sfn(
        "PublishStateMachineVersion",
        Dict{String,Any}("stateMachineArn" => stateMachineArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function publish_state_machine_version(
    stateMachineArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sfn(
        "PublishStateMachineVersion",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("stateMachineArn" => stateMachineArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    redrive_execution(execution_arn)
    redrive_execution(execution_arn, params::Dict{String,<:Any})

Restarts unsuccessful executions of Standard workflows that didn't complete successfully in
the last 14 days. These include failed, aborted, or timed out executions. When you redrive
an execution, it continues the failed execution from the unsuccessful step and uses the
same input. Step Functions preserves the results and execution history of the successful
steps, and doesn't rerun these steps when you redrive an execution. Redriven executions use
the same state machine definition and execution ARN as the original execution attempt. For
workflows that include an Inline Map or Parallel state, RedriveExecution API action
reschedules and redrives only the iterations and branches that failed or aborted. To
redrive a workflow that includes a Distributed Map state whose Map Run failed, you must
redrive the parent workflow. The parent workflow redrives all the unsuccessful states,
including a failed Map Run. If a Map Run was not started in the original execution attempt,
the redriven parent workflow starts the Map Run.  This API action is not supported by
EXPRESS state machines. However, you can restart the unsuccessful executions of Express
child workflows in a Distributed Map by redriving its Map Run. When you redrive a Map Run,
the Express child workflows are rerun using the StartExecution API action. For more
information, see Redriving Map Runs.  You can redrive executions if your original execution
meets the following conditions:   The execution status isn't SUCCEEDED.   Your workflow
execution has not exceeded the redrivable period of 14 days. Redrivable period refers to
the time during which you can redrive a given execution. This period starts from the day a
state machine completes its execution.   The workflow execution has not exceeded the
maximum open time of one year. For more information about state machine quotas, see Quotas
related to state machine executions.   The execution event history count is less than
24,999. Redriven executions append their event history to the existing event history. Make
sure your workflow execution contains less than 24,999 events to accommodate the
ExecutionRedriven history event and at least one other history event.

# Arguments
- `execution_arn`: The Amazon Resource Name (ARN) of the execution to be redriven.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If you don’t specify a client token, the Amazon Web Services
  SDK automatically generates a client token and uses it for the request to ensure
  idempotency. The API will return idempotent responses for the last 10 client tokens used to
  successfully redrive the execution. These client tokens are valid for up to 15 minutes
  after they are first used.
"""
function redrive_execution(executionArn; aws_config::AbstractAWSConfig=current_aws_config())
    return sfn(
        "RedriveExecution",
        Dict{String,Any}("executionArn" => executionArn, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function redrive_execution(
    executionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sfn(
        "RedriveExecution",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "executionArn" => executionArn, "clientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    send_task_failure(task_token)
    send_task_failure(task_token, params::Dict{String,<:Any})

Used by activity workers, Task states using the callback pattern, and optionally Task
states using the job run pattern to report that the task identified by the taskToken failed.

# Arguments
- `task_token`: The token that represents this task. Task tokens are generated by Step
  Functions when tasks are assigned to a worker, or in the context object when a workflow
  enters a task state. See GetActivityTaskOutputtaskToken.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"cause"`: A more detailed explanation of the cause of the failure.
- `"error"`: The error code of the failure.
"""
function send_task_failure(taskToken; aws_config::AbstractAWSConfig=current_aws_config())
    return sfn(
        "SendTaskFailure",
        Dict{String,Any}("taskToken" => taskToken);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function send_task_failure(
    taskToken,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sfn(
        "SendTaskFailure",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("taskToken" => taskToken), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    send_task_heartbeat(task_token)
    send_task_heartbeat(task_token, params::Dict{String,<:Any})

Used by activity workers and Task states using the callback pattern, and optionally Task
states using the job run pattern to report to Step Functions that the task represented by
the specified taskToken is still making progress. This action resets the Heartbeat clock.
The Heartbeat threshold is specified in the state machine's Amazon States Language
definition (HeartbeatSeconds). This action does not in itself create an event in the
execution history. However, if the task times out, the execution history contains an
ActivityTimedOut entry for activities, or a TaskTimedOut entry for tasks using the job run
or callback pattern.  The Timeout of a task, defined in the state machine's Amazon States
Language definition, is its maximum allowed duration, regardless of the number of
SendTaskHeartbeat requests received. Use HeartbeatSeconds to configure the timeout interval
for heartbeats.

# Arguments
- `task_token`: The token that represents this task. Task tokens are generated by Step
  Functions when tasks are assigned to a worker, or in the context object when a workflow
  enters a task state. See GetActivityTaskOutputtaskToken.

"""
function send_task_heartbeat(taskToken; aws_config::AbstractAWSConfig=current_aws_config())
    return sfn(
        "SendTaskHeartbeat",
        Dict{String,Any}("taskToken" => taskToken);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function send_task_heartbeat(
    taskToken,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sfn(
        "SendTaskHeartbeat",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("taskToken" => taskToken), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    send_task_success(output, task_token)
    send_task_success(output, task_token, params::Dict{String,<:Any})

Used by activity workers, Task states using the callback pattern, and optionally Task
states using the job run pattern to report that the task identified by the taskToken
completed successfully.

# Arguments
- `output`: The JSON output of the task. Length constraints apply to the payload size, and
  are expressed as bytes in UTF-8 encoding.
- `task_token`: The token that represents this task. Task tokens are generated by Step
  Functions when tasks are assigned to a worker, or in the context object when a workflow
  enters a task state. See GetActivityTaskOutputtaskToken.

"""
function send_task_success(
    output, taskToken; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sfn(
        "SendTaskSuccess",
        Dict{String,Any}("output" => output, "taskToken" => taskToken);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function send_task_success(
    output,
    taskToken,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sfn(
        "SendTaskSuccess",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("output" => output, "taskToken" => taskToken),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_execution(state_machine_arn)
    start_execution(state_machine_arn, params::Dict{String,<:Any})

Starts a state machine execution. A qualified state machine ARN can either refer to a
Distributed Map state defined within a state machine, a version ARN, or an alias ARN. The
following are some examples of qualified and unqualified state machine ARNs:   The
following qualified state machine ARN refers to a Distributed Map state with a label
mapStateLabel in a state machine named myStateMachine.
arn:partition:states:region:account-id:stateMachine:myStateMachine/mapStateLabel   If you
provide a qualified state machine ARN that refers to a Distributed Map state, the request
fails with ValidationException.    The following qualified state machine ARN refers to an
alias named PROD.
arn:&lt;partition&gt;:states:&lt;region&gt;:&lt;account-id&gt;:stateMachine:&lt;myStateMachi
ne:PROD&gt;   If you provide a qualified state machine ARN that refers to a version ARN or
an alias ARN, the request starts execution for that version or alias.    The following
unqualified state machine ARN refers to a state machine named myStateMachine.
arn:&lt;partition&gt;:states:&lt;region&gt;:&lt;account-id&gt;:stateMachine:&lt;myStateMachi
ne&gt;    If you start an execution with an unqualified state machine ARN, Step Functions
uses the latest revision of the state machine for the execution. To start executions of a
state machine version, call StartExecution and provide the version ARN or the ARN of an
alias that points to the version.   StartExecution is idempotent for STANDARD workflows.
For a STANDARD workflow, if you call StartExecution with the same name and input as a
running execution, the call succeeds and return the same response as the original request.
If the execution is closed or if the input is different, it returns a 400
ExecutionAlreadyExists error. You can reuse names after 90 days.   StartExecution isn't
idempotent for EXPRESS workflows.

# Arguments
- `state_machine_arn`: The Amazon Resource Name (ARN) of the state machine to execute. The
  stateMachineArn parameter accepts one of the following inputs:    An unqualified state
  machine ARN – Refers to a state machine ARN that isn't qualified with a version or alias
  ARN. The following is an example of an unqualified state machine ARN.
  arn:&lt;partition&gt;:states:&lt;region&gt;:&lt;account-id&gt;:stateMachine:&lt;myStateMachi
  ne&gt;  Step Functions doesn't associate state machine executions that you start with an
  unqualified ARN with a version. This is true even if that version uses the same revision
  that the execution used.    A state machine version ARN – Refers to a version ARN, which
  is a combination of state machine ARN and the version number separated by a colon (:). The
  following is an example of the ARN for version 10.
  arn:&lt;partition&gt;:states:&lt;region&gt;:&lt;account-id&gt;:stateMachine:&lt;myStateMachi
  ne&gt;:10  Step Functions doesn't associate executions that you start with a version ARN
  with any aliases that point to that version.    A state machine alias ARN – Refers to an
  alias ARN, which is a combination of state machine ARN and the alias name separated by a
  colon (:). The following is an example of the ARN for an alias named PROD.
  arn:&lt;partition&gt;:states:&lt;region&gt;:&lt;account-id&gt;:stateMachine:&lt;myStateMachi
  ne:PROD&gt;  Step Functions associates executions that you start with an alias ARN with
  that alias and the state machine version used for that execution.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"input"`: The string that contains the JSON input data for the execution, for example:
  \"input\": \"{\"first_name\" : \"test\"}\"   If you don't include any JSON input data, you
  still must include the two braces, for example: \"input\": \"{}\"   Length constraints
  apply to the payload size, and are expressed as bytes in UTF-8 encoding.
- `"name"`: Optional name of the execution. This name must be unique for your Amazon Web
  Services account, Region, and state machine for 90 days. For more information, see  Limits
  Related to State Machine Executions in the Step Functions Developer Guide. If you don't
  provide a name for the execution, Step Functions automatically generates a universally
  unique identifier (UUID) as the execution name. A name must not contain:   white space
  brackets &lt; &gt; { } [ ]    wildcard characters ? *    special characters \" # %  ^ | ~ `
   &amp; , ; : /    control characters (U+0000-001F, U+007F-009F)   To enable logging with
  CloudWatch Logs, the name should only contain 0-9, A-Z, a-z, - and _.
- `"traceHeader"`: Passes the X-Ray trace header. The trace header can also be passed in
  the request payload.
"""
function start_execution(
    stateMachineArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sfn(
        "StartExecution",
        Dict{String,Any}("stateMachineArn" => stateMachineArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_execution(
    stateMachineArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sfn(
        "StartExecution",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("stateMachineArn" => stateMachineArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_sync_execution(state_machine_arn)
    start_sync_execution(state_machine_arn, params::Dict{String,<:Any})

Starts a Synchronous Express state machine execution. StartSyncExecution is not available
for STANDARD workflows.   StartSyncExecution will return a 200 OK response, even if your
execution fails, because the status code in the API response doesn't reflect function
errors. Error codes are reserved for errors that prevent your execution from running, such
as permissions errors, limit errors, or issues with your state machine code and
configuration.    This API action isn't logged in CloudTrail.

# Arguments
- `state_machine_arn`: The Amazon Resource Name (ARN) of the state machine to execute.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"input"`: The string that contains the JSON input data for the execution, for example:
  \"input\": \"{\"first_name\" : \"test\"}\"   If you don't include any JSON input data, you
  still must include the two braces, for example: \"input\": \"{}\"   Length constraints
  apply to the payload size, and are expressed as bytes in UTF-8 encoding.
- `"name"`: The name of the execution.
- `"traceHeader"`: Passes the X-Ray trace header. The trace header can also be passed in
  the request payload.
"""
function start_sync_execution(
    stateMachineArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sfn(
        "StartSyncExecution",
        Dict{String,Any}("stateMachineArn" => stateMachineArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_sync_execution(
    stateMachineArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sfn(
        "StartSyncExecution",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("stateMachineArn" => stateMachineArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_execution(execution_arn)
    stop_execution(execution_arn, params::Dict{String,<:Any})

Stops an execution. This API action is not supported by EXPRESS state machines.

# Arguments
- `execution_arn`: The Amazon Resource Name (ARN) of the execution to stop.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"cause"`: A more detailed explanation of the cause of the failure.
- `"error"`: The error code of the failure.
"""
function stop_execution(executionArn; aws_config::AbstractAWSConfig=current_aws_config())
    return sfn(
        "StopExecution",
        Dict{String,Any}("executionArn" => executionArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_execution(
    executionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sfn(
        "StopExecution",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("executionArn" => executionArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Add a tag to a Step Functions resource. An array of key-value pairs. For more information,
see Using Cost Allocation Tags in the Amazon Web Services Billing and Cost Management User
Guide, and Controlling Access Using IAM Tags. Tags may only contain Unicode letters,
digits, white space, or these symbols: _ . : / = + - @.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) for the Step Functions state machine or
  activity.
- `tags`: The list of tags to add to a resource. Tags may only contain Unicode letters,
  digits, white space, or these symbols: _ . : / = + - @.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return sfn(
        "TagResource",
        Dict{String,Any}("resourceArn" => resourceArn, "tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sfn(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceArn" => resourceArn, "tags" => tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    test_state(definition, role_arn)
    test_state(definition, role_arn, params::Dict{String,<:Any})

Accepts the definition of a single state and executes it. You can test a state without
creating a state machine or updating an existing state machine. Using this API, you can
test the following:   A state's input and output processing data flow   An Amazon Web
Services service integration request and response   An HTTP Task request and response   You
can call this API on only one state at a time. The states that you can test include the
following:    All Task types except Activity     Pass     Wait     Choice     Succeed
Fail    The TestState API assumes an IAM role which must contain the required IAM
permissions for the resources your state is accessing. For information about the
permissions a state might need, see IAM permissions to test a state. The TestState API can
run for up to five minutes. If the execution of a state exceeds this duration, it fails
with the States.Timeout error.  TestState doesn't support Activity tasks, .sync or
.waitForTaskToken service integration patterns, Parallel, or Map states.

# Arguments
- `definition`: The Amazon States Language (ASL) definition of the state.
- `role_arn`: The Amazon Resource Name (ARN) of the execution role with the required IAM
  permissions for the state.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"input"`: A string that contains the JSON input data for the state.
- `"inspectionLevel"`: Determines the values to return when a state is tested. You can
  specify one of the following types:    INFO: Shows the final state output. By default, Step
  Functions sets inspectionLevel to INFO if you don't specify a level.    DEBUG: Shows the
  final state output along with the input and output data processing result.    TRACE: Shows
  the HTTP request and response for an HTTP Task. This level also shows the final state
  output along with the input and output data processing result.   Each of these levels also
  provide information about the status of the state execution and the next state to
  transition to.
- `"revealSecrets"`: Specifies whether or not to include secret information in the test
  result. For HTTP Tasks, a secret includes the data that an EventBridge connection adds to
  modify the HTTP request headers, query parameters, and body. Step Functions doesn't omit
  any information included in the state definition or the HTTP response. If you set
  revealSecrets to true, you must make sure that the IAM user that calls the TestState API
  has permission for the states:RevealSecrets action. For an example of IAM policy that sets
  the states:RevealSecrets permission, see IAM permissions to test a state. Without this
  permission, Step Functions throws an access denied error. By default, revealSecrets is set
  to false.
"""
function test_state(definition, roleArn; aws_config::AbstractAWSConfig=current_aws_config())
    return sfn(
        "TestState",
        Dict{String,Any}("definition" => definition, "roleArn" => roleArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function test_state(
    definition,
    roleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sfn(
        "TestState",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("definition" => definition, "roleArn" => roleArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Remove a tag from a Step Functions resource

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) for the Step Functions state machine or
  activity.
- `tag_keys`: The list of tags to remove from the resource.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sfn(
        "UntagResource",
        Dict{String,Any}("resourceArn" => resourceArn, "tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sfn(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceArn" => resourceArn, "tagKeys" => tagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_map_run(map_run_arn)
    update_map_run(map_run_arn, params::Dict{String,<:Any})

Updates an in-progress Map Run's configuration to include changes to the settings that
control maximum concurrency and Map Run failure.

# Arguments
- `map_run_arn`: The Amazon Resource Name (ARN) of a Map Run.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxConcurrency"`: The maximum number of child workflow executions that can be specified
  to run in parallel for the Map Run at the same time.
- `"toleratedFailureCount"`: The maximum number of failed items before the Map Run fails.
- `"toleratedFailurePercentage"`: The maximum percentage of failed items before the Map Run
  fails.
"""
function update_map_run(mapRunArn; aws_config::AbstractAWSConfig=current_aws_config())
    return sfn(
        "UpdateMapRun",
        Dict{String,Any}("mapRunArn" => mapRunArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_map_run(
    mapRunArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sfn(
        "UpdateMapRun",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("mapRunArn" => mapRunArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_state_machine(state_machine_arn)
    update_state_machine(state_machine_arn, params::Dict{String,<:Any})

Updates an existing state machine by modifying its definition, roleArn, or
loggingConfiguration. Running executions will continue to use the previous definition and
roleArn. You must include at least one of definition or roleArn or you will receive a
MissingRequiredParameter error. A qualified state machine ARN refers to a Distributed Map
state defined within a state machine. For example, the qualified state machine ARN
arn:partition:states:region:account-id:stateMachine:stateMachineName/mapStateLabel refers
to a Distributed Map state with a label mapStateLabel in the state machine named
stateMachineName. A qualified state machine ARN can either refer to a Distributed Map state
defined within a state machine, a version ARN, or an alias ARN. The following are some
examples of qualified and unqualified state machine ARNs:   The following qualified state
machine ARN refers to a Distributed Map state with a label mapStateLabel in a state machine
named myStateMachine.
arn:partition:states:region:account-id:stateMachine:myStateMachine/mapStateLabel   If you
provide a qualified state machine ARN that refers to a Distributed Map state, the request
fails with ValidationException.    The following qualified state machine ARN refers to an
alias named PROD.
arn:&lt;partition&gt;:states:&lt;region&gt;:&lt;account-id&gt;:stateMachine:&lt;myStateMachi
ne:PROD&gt;   If you provide a qualified state machine ARN that refers to a version ARN or
an alias ARN, the request starts execution for that version or alias.    The following
unqualified state machine ARN refers to a state machine named myStateMachine.
arn:&lt;partition&gt;:states:&lt;region&gt;:&lt;account-id&gt;:stateMachine:&lt;myStateMachi
ne&gt;    After you update your state machine, you can set the publish parameter to true in
the same action to publish a new version. This way, you can opt-in to strict versioning of
your state machine.  Step Functions assigns monotonically increasing integers for state
machine versions, starting at version number 1.   All StartExecution calls within a few
seconds use the updated definition and roleArn. Executions started immediately after you
call UpdateStateMachine may use the previous state machine definition and roleArn.

# Arguments
- `state_machine_arn`: The Amazon Resource Name (ARN) of the state machine.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"definition"`: The Amazon States Language definition of the state machine. See Amazon
  States Language.
- `"loggingConfiguration"`: Use the LoggingConfiguration data type to set CloudWatch Logs
  options.
- `"publish"`: Specifies whether the state machine version is published. The default is
  false. To publish a version after updating the state machine, set publish to true.
- `"roleArn"`: The Amazon Resource Name (ARN) of the IAM role of the state machine.
- `"tracingConfiguration"`: Selects whether X-Ray tracing is enabled.
- `"versionDescription"`: An optional description of the state machine version to publish.
  You can only specify the versionDescription parameter if you've set publish to true.
"""
function update_state_machine(
    stateMachineArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sfn(
        "UpdateStateMachine",
        Dict{String,Any}("stateMachineArn" => stateMachineArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_state_machine(
    stateMachineArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sfn(
        "UpdateStateMachine",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("stateMachineArn" => stateMachineArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_state_machine_alias(state_machine_alias_arn)
    update_state_machine_alias(state_machine_alias_arn, params::Dict{String,<:Any})

Updates the configuration of an existing state machine alias by modifying its description
or routingConfiguration. You must specify at least one of the description or
routingConfiguration parameters to update a state machine alias.   UpdateStateMachineAlias
is an idempotent API. Step Functions bases the idempotency check on the
stateMachineAliasArn, description, and routingConfiguration parameters. Requests with the
same parameters return an idempotent response.   This operation is eventually consistent.
All StartExecution requests made within a few seconds use the latest alias configuration.
Executions started immediately after calling UpdateStateMachineAlias may use the previous
routing configuration.   Related operations:     CreateStateMachineAlias
DescribeStateMachineAlias     ListStateMachineAliases     DeleteStateMachineAlias

# Arguments
- `state_machine_alias_arn`: The Amazon Resource Name (ARN) of the state machine alias.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A description of the state machine alias.
- `"routingConfiguration"`: The routing configuration of the state machine alias. An array
  of RoutingConfig objects that specifies up to two state machine versions that the alias
  starts executions for.
"""
function update_state_machine_alias(
    stateMachineAliasArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sfn(
        "UpdateStateMachineAlias",
        Dict{String,Any}("stateMachineAliasArn" => stateMachineAliasArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_state_machine_alias(
    stateMachineAliasArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sfn(
        "UpdateStateMachineAlias",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("stateMachineAliasArn" => stateMachineAliasArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    validate_state_machine_definition(definition)
    validate_state_machine_definition(definition, params::Dict{String,<:Any})

Validates the syntax of a state machine definition. You can validate that a state machine
definition is correct without creating a state machine resource. Step Functions will
implicitly perform the same syntax check when you invoke CreateStateMachine and
UpdateStateMachine. State machine definitions are specified using a JSON-based, structured
language. For more information on Amazon States Language see Amazon States Language (ASL).
Suggested uses for ValidateStateMachineDefinition:   Integrate automated checks into your
code review or Continuous Integration (CI) process to validate state machine definitions
before starting deployments.   Run the validation from a Git pre-commit hook to check your
state machine definitions before committing them to your source repository.    Errors found
in the state machine definition will be returned in the response as a list of diagnostic
elements, rather than raise an exception.

# Arguments
- `definition`: The Amazon States Language definition of the state machine. For more
  information, see Amazon States Language (ASL).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"type"`: The target type of state machine for this definition. The default is STANDARD.
"""
function validate_state_machine_definition(
    definition; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sfn(
        "ValidateStateMachineDefinition",
        Dict{String,Any}("definition" => definition);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function validate_state_machine_definition(
    definition,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sfn(
        "ValidateStateMachineDefinition",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("definition" => definition), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: directory_service
using AWS.Compat
using AWS.UUIDs

"""
    accept_shared_directory(shared_directory_id)
    accept_shared_directory(shared_directory_id, params::Dict{String,<:Any})

Accepts a directory sharing request that was sent from the directory owner account.

# Arguments
- `shared_directory_id`: Identifier of the shared directory in the directory consumer
  account. This identifier is different for each directory owner account.

"""
function accept_shared_directory(
    SharedDirectoryId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return directory_service(
        "AcceptSharedDirectory",
        Dict{String,Any}("SharedDirectoryId" => SharedDirectoryId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function accept_shared_directory(
    SharedDirectoryId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "AcceptSharedDirectory",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("SharedDirectoryId" => SharedDirectoryId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    add_ip_routes(directory_id, ip_routes)
    add_ip_routes(directory_id, ip_routes, params::Dict{String,<:Any})

If the DNS server for your self-managed domain uses a publicly addressable IP address, you
must add a CIDR address block to correctly route traffic to and from your Microsoft AD on
Amazon Web Services. AddIpRoutes adds this address block. You can also use AddIpRoutes to
facilitate routing traffic that uses public IP ranges from your Microsoft AD on Amazon Web
Services to a peer VPC.  Before you call AddIpRoutes, ensure that all of the required
permissions have been explicitly granted through a policy. For details about what
permissions are required to run the AddIpRoutes operation, see Directory Service API
Permissions: Actions, Resources, and Conditions Reference.

# Arguments
- `directory_id`: Identifier (ID) of the directory to which to add the address block.
- `ip_routes`: IP address blocks, using CIDR format, of the traffic to route. This is often
  the IP address block of the DNS server used for your self-managed domain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"UpdateSecurityGroupForDirectoryControllers"`: If set to true, updates the inbound and
  outbound rules of the security group that has the description: \"Amazon Web Services
  created security group for directory ID directory controllers.\" Following are the new
  rules:  Inbound:   Type: Custom UDP Rule, Protocol: UDP, Range: 88, Source: 0.0.0.0/0
  Type: Custom UDP Rule, Protocol: UDP, Range: 123, Source: 0.0.0.0/0   Type: Custom UDP
  Rule, Protocol: UDP, Range: 138, Source: 0.0.0.0/0   Type: Custom UDP Rule, Protocol: UDP,
  Range: 389, Source: 0.0.0.0/0   Type: Custom UDP Rule, Protocol: UDP, Range: 464, Source:
  0.0.0.0/0   Type: Custom UDP Rule, Protocol: UDP, Range: 445, Source: 0.0.0.0/0   Type:
  Custom TCP Rule, Protocol: TCP, Range: 88, Source: 0.0.0.0/0   Type: Custom TCP Rule,
  Protocol: TCP, Range: 135, Source: 0.0.0.0/0   Type: Custom TCP Rule, Protocol: TCP, Range:
  445, Source: 0.0.0.0/0   Type: Custom TCP Rule, Protocol: TCP, Range: 464, Source:
  0.0.0.0/0   Type: Custom TCP Rule, Protocol: TCP, Range: 636, Source: 0.0.0.0/0   Type:
  Custom TCP Rule, Protocol: TCP, Range: 1024-65535, Source: 0.0.0.0/0   Type: Custom TCP
  Rule, Protocol: TCP, Range: 3268-33269, Source: 0.0.0.0/0   Type: DNS (UDP), Protocol: UDP,
  Range: 53, Source: 0.0.0.0/0   Type: DNS (TCP), Protocol: TCP, Range: 53, Source: 0.0.0.0/0
    Type: LDAP, Protocol: TCP, Range: 389, Source: 0.0.0.0/0   Type: All ICMP, Protocol: All,
  Range: N/A, Source: 0.0.0.0/0    Outbound:   Type: All traffic, Protocol: All, Range: All,
  Destination: 0.0.0.0/0   These security rules impact an internal network interface that is
  not exposed publicly.
"""
function add_ip_routes(
    DirectoryId, IpRoutes; aws_config::AbstractAWSConfig=current_aws_config()
)
    return directory_service(
        "AddIpRoutes",
        Dict{String,Any}("DirectoryId" => DirectoryId, "IpRoutes" => IpRoutes);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_ip_routes(
    DirectoryId,
    IpRoutes,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "AddIpRoutes",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DirectoryId" => DirectoryId, "IpRoutes" => IpRoutes),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    add_region(directory_id, region_name, vpcsettings)
    add_region(directory_id, region_name, vpcsettings, params::Dict{String,<:Any})

Adds two domain controllers in the specified Region for the specified directory.

# Arguments
- `directory_id`: The identifier of the directory to which you want to add Region
  replication.
- `region_name`: The name of the Region where you want to add domain controllers for
  replication. For example, us-east-1.
- `vpcsettings`:

"""
function add_region(
    DirectoryId, RegionName, VPCSettings; aws_config::AbstractAWSConfig=current_aws_config()
)
    return directory_service(
        "AddRegion",
        Dict{String,Any}(
            "DirectoryId" => DirectoryId,
            "RegionName" => RegionName,
            "VPCSettings" => VPCSettings,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_region(
    DirectoryId,
    RegionName,
    VPCSettings,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "AddRegion",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DirectoryId" => DirectoryId,
                    "RegionName" => RegionName,
                    "VPCSettings" => VPCSettings,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    add_tags_to_resource(resource_id, tags)
    add_tags_to_resource(resource_id, tags, params::Dict{String,<:Any})

Adds or overwrites one or more tags for the specified directory. Each directory can have a
maximum of 50 tags. Each tag consists of a key and optional value. Tag keys must be unique
to each resource.

# Arguments
- `resource_id`: Identifier (ID) for the directory to which to add the tag.
- `tags`: The tags to be assigned to the directory.

"""
function add_tags_to_resource(
    ResourceId, Tags; aws_config::AbstractAWSConfig=current_aws_config()
)
    return directory_service(
        "AddTagsToResource",
        Dict{String,Any}("ResourceId" => ResourceId, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_tags_to_resource(
    ResourceId,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "AddTagsToResource",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ResourceId" => ResourceId, "Tags" => Tags), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_schema_extension(directory_id, schema_extension_id)
    cancel_schema_extension(directory_id, schema_extension_id, params::Dict{String,<:Any})

Cancels an in-progress schema extension to a Microsoft AD directory. Once a schema
extension has started replicating to all domain controllers, the task can no longer be
canceled. A schema extension can be canceled during any of the following states;
Initializing, CreatingSnapshot, and UpdatingSchema.

# Arguments
- `directory_id`: The identifier of the directory whose schema extension will be canceled.
- `schema_extension_id`: The identifier of the schema extension that will be canceled.

"""
function cancel_schema_extension(
    DirectoryId, SchemaExtensionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return directory_service(
        "CancelSchemaExtension",
        Dict{String,Any}(
            "DirectoryId" => DirectoryId, "SchemaExtensionId" => SchemaExtensionId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_schema_extension(
    DirectoryId,
    SchemaExtensionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "CancelSchemaExtension",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DirectoryId" => DirectoryId, "SchemaExtensionId" => SchemaExtensionId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    connect_directory(connect_settings, name, password, size)
    connect_directory(connect_settings, name, password, size, params::Dict{String,<:Any})

Creates an AD Connector to connect to a self-managed directory. Before you call
ConnectDirectory, ensure that all of the required permissions have been explicitly granted
through a policy. For details about what permissions are required to run the
ConnectDirectory operation, see Directory Service API Permissions: Actions, Resources, and
Conditions Reference.

# Arguments
- `connect_settings`: A DirectoryConnectSettings object that contains additional
  information for the operation.
- `name`: The fully qualified name of your self-managed directory, such as corp.example.com.
- `password`: The password for your self-managed user account.
- `size`: The size of the directory.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description for the directory.
- `"ShortName"`: The NetBIOS name of your self-managed directory, such as CORP.
- `"Tags"`: The tags to be assigned to AD Connector.
"""
function connect_directory(
    ConnectSettings,
    Name,
    Password,
    Size;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "ConnectDirectory",
        Dict{String,Any}(
            "ConnectSettings" => ConnectSettings,
            "Name" => Name,
            "Password" => Password,
            "Size" => Size,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function connect_directory(
    ConnectSettings,
    Name,
    Password,
    Size,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "ConnectDirectory",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ConnectSettings" => ConnectSettings,
                    "Name" => Name,
                    "Password" => Password,
                    "Size" => Size,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_alias(alias, directory_id)
    create_alias(alias, directory_id, params::Dict{String,<:Any})

Creates an alias for a directory and assigns the alias to the directory. The alias is used
to construct the access URL for the directory, such as http://&lt;alias&gt;.awsapps.com.
After an alias has been created, it cannot be deleted or reused, so this operation should
only be used when absolutely necessary.

# Arguments
- `alias`: The requested alias. The alias must be unique amongst all aliases in Amazon Web
  Services. This operation throws an EntityAlreadyExistsException error if the alias already
  exists.
- `directory_id`: The identifier of the directory for which to create the alias.

"""
function create_alias(
    Alias, DirectoryId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return directory_service(
        "CreateAlias",
        Dict{String,Any}("Alias" => Alias, "DirectoryId" => DirectoryId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_alias(
    Alias,
    DirectoryId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "CreateAlias",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Alias" => Alias, "DirectoryId" => DirectoryId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_computer(computer_name, directory_id, password)
    create_computer(computer_name, directory_id, password, params::Dict{String,<:Any})

Creates an Active Directory computer object in the specified directory.

# Arguments
- `computer_name`: The name of the computer account.
- `directory_id`: The identifier of the directory in which to create the computer account.
- `password`: A one-time password that is used to join the computer to the directory. You
  should generate a random, strong password to use for this parameter.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ComputerAttributes"`: An array of Attribute objects that contain any LDAP attributes to
  apply to the computer account.
- `"OrganizationalUnitDistinguishedName"`: The fully-qualified distinguished name of the
  organizational unit to place the computer account in.
"""
function create_computer(
    ComputerName, DirectoryId, Password; aws_config::AbstractAWSConfig=current_aws_config()
)
    return directory_service(
        "CreateComputer",
        Dict{String,Any}(
            "ComputerName" => ComputerName,
            "DirectoryId" => DirectoryId,
            "Password" => Password,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_computer(
    ComputerName,
    DirectoryId,
    Password,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "CreateComputer",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ComputerName" => ComputerName,
                    "DirectoryId" => DirectoryId,
                    "Password" => Password,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_conditional_forwarder(directory_id, dns_ip_addrs, remote_domain_name)
    create_conditional_forwarder(directory_id, dns_ip_addrs, remote_domain_name, params::Dict{String,<:Any})

Creates a conditional forwarder associated with your Amazon Web Services directory.
Conditional forwarders are required in order to set up a trust relationship with another
domain. The conditional forwarder points to the trusted domain.

# Arguments
- `directory_id`: The directory ID of the Amazon Web Services directory for which you are
  creating the conditional forwarder.
- `dns_ip_addrs`: The IP addresses of the remote DNS server associated with
  RemoteDomainName.
- `remote_domain_name`: The fully qualified domain name (FQDN) of the remote domain with
  which you will set up a trust relationship.

"""
function create_conditional_forwarder(
    DirectoryId,
    DnsIpAddrs,
    RemoteDomainName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "CreateConditionalForwarder",
        Dict{String,Any}(
            "DirectoryId" => DirectoryId,
            "DnsIpAddrs" => DnsIpAddrs,
            "RemoteDomainName" => RemoteDomainName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_conditional_forwarder(
    DirectoryId,
    DnsIpAddrs,
    RemoteDomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "CreateConditionalForwarder",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DirectoryId" => DirectoryId,
                    "DnsIpAddrs" => DnsIpAddrs,
                    "RemoteDomainName" => RemoteDomainName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_directory(name, password, size)
    create_directory(name, password, size, params::Dict{String,<:Any})

Creates a Simple AD directory. For more information, see Simple Active Directory in the
Directory Service Admin Guide. Before you call CreateDirectory, ensure that all of the
required permissions have been explicitly granted through a policy. For details about what
permissions are required to run the CreateDirectory operation, see Directory Service API
Permissions: Actions, Resources, and Conditions Reference.

# Arguments
- `name`: The fully qualified name for the directory, such as corp.example.com.
- `password`: The password for the directory administrator. The directory creation process
  creates a directory administrator account with the user name Administrator and this
  password. If you need to change the password for the administrator account, you can use the
  ResetUserPassword API call. The regex pattern for this string is made up of the following
  conditions:   Length (?=^.{8,64}) – Must be between 8 and 64 characters   AND any 3 of
  the following password complexity rules required by Active Directory:   Numbers and upper
  case and lowercase (?=.*d)(?=.*[A-Z])(?=.*[a-z])   Numbers and special characters and lower
  case (?=.*d)(?=.*[^A-Za-z0-9s])(?=.*[a-z])   Special characters and upper case and lower
  case (?=.*[^A-Za-z0-9s])(?=.*[A-Z])(?=.*[a-z])   Numbers and upper case and special
  characters (?=.*d)(?=.*[A-Z])(?=.*[^A-Za-z0-9s])   For additional information about how
  Active Directory passwords are enforced, see Password must meet complexity requirements on
  the Microsoft website.
- `size`: The size of the directory.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description for the directory.
- `"ShortName"`: The NetBIOS name of the directory, such as CORP.
- `"Tags"`: The tags to be assigned to the Simple AD directory.
- `"VpcSettings"`: A DirectoryVpcSettings object that contains additional information for
  the operation.
"""
function create_directory(
    Name, Password, Size; aws_config::AbstractAWSConfig=current_aws_config()
)
    return directory_service(
        "CreateDirectory",
        Dict{String,Any}("Name" => Name, "Password" => Password, "Size" => Size);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_directory(
    Name,
    Password,
    Size,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "CreateDirectory",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Name" => Name, "Password" => Password, "Size" => Size),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_log_subscription(directory_id, log_group_name)
    create_log_subscription(directory_id, log_group_name, params::Dict{String,<:Any})

Creates a subscription to forward real-time Directory Service domain controller security
logs to the specified Amazon CloudWatch log group in your Amazon Web Services account.

# Arguments
- `directory_id`: Identifier of the directory to which you want to subscribe and receive
  real-time logs to your specified CloudWatch log group.
- `log_group_name`: The name of the CloudWatch log group where the real-time domain
  controller logs are forwarded.

"""
function create_log_subscription(
    DirectoryId, LogGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return directory_service(
        "CreateLogSubscription",
        Dict{String,Any}("DirectoryId" => DirectoryId, "LogGroupName" => LogGroupName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_log_subscription(
    DirectoryId,
    LogGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "CreateLogSubscription",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DirectoryId" => DirectoryId, "LogGroupName" => LogGroupName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_microsoft_ad(name, password, vpc_settings)
    create_microsoft_ad(name, password, vpc_settings, params::Dict{String,<:Any})

Creates a Microsoft AD directory in the Amazon Web Services Cloud. For more information,
see Managed Microsoft AD in the Directory Service Admin Guide. Before you call
CreateMicrosoftAD, ensure that all of the required permissions have been explicitly granted
through a policy. For details about what permissions are required to run the
CreateMicrosoftAD operation, see Directory Service API Permissions: Actions, Resources, and
Conditions Reference.

# Arguments
- `name`: The fully qualified domain name for the Managed Microsoft AD directory, such as
  corp.example.com. This name will resolve inside your VPC only. It does not need to be
  publicly resolvable.
- `password`: The password for the default administrative user named Admin. If you need to
  change the password for the administrator account, you can use the ResetUserPassword API
  call.
- `vpc_settings`: Contains VPC information for the CreateDirectory or CreateMicrosoftAD
  operation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description for the directory. This label will appear on the Amazon
  Web Services console Directory Details page after the directory is created.
- `"Edition"`: Managed Microsoft AD is available in two editions: Standard and Enterprise.
  Enterprise is the default.
- `"ShortName"`: The NetBIOS name for your domain, such as CORP. If you don't specify a
  NetBIOS name, it will default to the first part of your directory DNS. For example, CORP
  for the directory DNS corp.example.com.
- `"Tags"`: The tags to be assigned to the Managed Microsoft AD directory.
"""
function create_microsoft_ad(
    Name, Password, VpcSettings; aws_config::AbstractAWSConfig=current_aws_config()
)
    return directory_service(
        "CreateMicrosoftAD",
        Dict{String,Any}(
            "Name" => Name, "Password" => Password, "VpcSettings" => VpcSettings
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_microsoft_ad(
    Name,
    Password,
    VpcSettings,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "CreateMicrosoftAD",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Name" => Name, "Password" => Password, "VpcSettings" => VpcSettings
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_snapshot(directory_id)
    create_snapshot(directory_id, params::Dict{String,<:Any})

Creates a snapshot of a Simple AD or Microsoft AD directory in the Amazon Web Services
cloud.  You cannot take snapshots of AD Connector directories.

# Arguments
- `directory_id`: The identifier of the directory of which to take a snapshot.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Name"`: The descriptive name to apply to the snapshot.
"""
function create_snapshot(DirectoryId; aws_config::AbstractAWSConfig=current_aws_config())
    return directory_service(
        "CreateSnapshot",
        Dict{String,Any}("DirectoryId" => DirectoryId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_snapshot(
    DirectoryId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "CreateSnapshot",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DirectoryId" => DirectoryId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_trust(directory_id, remote_domain_name, trust_direction, trust_password)
    create_trust(directory_id, remote_domain_name, trust_direction, trust_password, params::Dict{String,<:Any})

Directory Service for Microsoft Active Directory allows you to configure trust
relationships. For example, you can establish a trust between your Managed Microsoft AD
directory, and your existing self-managed Microsoft Active Directory. This would allow you
to provide users and groups access to resources in either domain, with a single set of
credentials. This action initiates the creation of the Amazon Web Services side of a trust
relationship between an Managed Microsoft AD directory and an external domain. You can
create either a forest trust or an external trust.

# Arguments
- `directory_id`: The Directory ID of the Managed Microsoft AD directory for which to
  establish the trust relationship.
- `remote_domain_name`: The Fully Qualified Domain Name (FQDN) of the external domain for
  which to create the trust relationship.
- `trust_direction`: The direction of the trust relationship.
- `trust_password`: The trust password. The must be the same password that was used when
  creating the trust relationship on the external domain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConditionalForwarderIpAddrs"`: The IP addresses of the remote DNS server associated
  with RemoteDomainName.
- `"SelectiveAuth"`: Optional parameter to enable selective authentication for the trust.
- `"TrustType"`: The trust relationship type. Forest is the default.
"""
function create_trust(
    DirectoryId,
    RemoteDomainName,
    TrustDirection,
    TrustPassword;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "CreateTrust",
        Dict{String,Any}(
            "DirectoryId" => DirectoryId,
            "RemoteDomainName" => RemoteDomainName,
            "TrustDirection" => TrustDirection,
            "TrustPassword" => TrustPassword,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_trust(
    DirectoryId,
    RemoteDomainName,
    TrustDirection,
    TrustPassword,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "CreateTrust",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DirectoryId" => DirectoryId,
                    "RemoteDomainName" => RemoteDomainName,
                    "TrustDirection" => TrustDirection,
                    "TrustPassword" => TrustPassword,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_conditional_forwarder(directory_id, remote_domain_name)
    delete_conditional_forwarder(directory_id, remote_domain_name, params::Dict{String,<:Any})

Deletes a conditional forwarder that has been set up for your Amazon Web Services directory.

# Arguments
- `directory_id`: The directory ID for which you are deleting the conditional forwarder.
- `remote_domain_name`: The fully qualified domain name (FQDN) of the remote domain with
  which you are deleting the conditional forwarder.

"""
function delete_conditional_forwarder(
    DirectoryId, RemoteDomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return directory_service(
        "DeleteConditionalForwarder",
        Dict{String,Any}(
            "DirectoryId" => DirectoryId, "RemoteDomainName" => RemoteDomainName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_conditional_forwarder(
    DirectoryId,
    RemoteDomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "DeleteConditionalForwarder",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DirectoryId" => DirectoryId, "RemoteDomainName" => RemoteDomainName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_directory(directory_id)
    delete_directory(directory_id, params::Dict{String,<:Any})

Deletes an Directory Service directory. Before you call DeleteDirectory, ensure that all of
the required permissions have been explicitly granted through a policy. For details about
what permissions are required to run the DeleteDirectory operation, see Directory Service
API Permissions: Actions, Resources, and Conditions Reference.

# Arguments
- `directory_id`: The identifier of the directory to delete.

"""
function delete_directory(DirectoryId; aws_config::AbstractAWSConfig=current_aws_config())
    return directory_service(
        "DeleteDirectory",
        Dict{String,Any}("DirectoryId" => DirectoryId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_directory(
    DirectoryId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "DeleteDirectory",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DirectoryId" => DirectoryId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_log_subscription(directory_id)
    delete_log_subscription(directory_id, params::Dict{String,<:Any})

Deletes the specified log subscription.

# Arguments
- `directory_id`: Identifier of the directory whose log subscription you want to delete.

"""
function delete_log_subscription(
    DirectoryId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return directory_service(
        "DeleteLogSubscription",
        Dict{String,Any}("DirectoryId" => DirectoryId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_log_subscription(
    DirectoryId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "DeleteLogSubscription",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DirectoryId" => DirectoryId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_snapshot(snapshot_id)
    delete_snapshot(snapshot_id, params::Dict{String,<:Any})

Deletes a directory snapshot.

# Arguments
- `snapshot_id`: The identifier of the directory snapshot to be deleted.

"""
function delete_snapshot(SnapshotId; aws_config::AbstractAWSConfig=current_aws_config())
    return directory_service(
        "DeleteSnapshot",
        Dict{String,Any}("SnapshotId" => SnapshotId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_snapshot(
    SnapshotId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "DeleteSnapshot",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("SnapshotId" => SnapshotId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_trust(trust_id)
    delete_trust(trust_id, params::Dict{String,<:Any})

Deletes an existing trust relationship between your Managed Microsoft AD directory and an
external domain.

# Arguments
- `trust_id`: The Trust ID of the trust relationship to be deleted.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DeleteAssociatedConditionalForwarder"`: Delete a conditional forwarder as part of a
  DeleteTrustRequest.
"""
function delete_trust(TrustId; aws_config::AbstractAWSConfig=current_aws_config())
    return directory_service(
        "DeleteTrust",
        Dict{String,Any}("TrustId" => TrustId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_trust(
    TrustId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "DeleteTrust",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("TrustId" => TrustId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    deregister_certificate(certificate_id, directory_id)
    deregister_certificate(certificate_id, directory_id, params::Dict{String,<:Any})

Deletes from the system the certificate that was registered for secure LDAP or client
certificate authentication.

# Arguments
- `certificate_id`: The identifier of the certificate.
- `directory_id`: The identifier of the directory.

"""
function deregister_certificate(
    CertificateId, DirectoryId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return directory_service(
        "DeregisterCertificate",
        Dict{String,Any}("CertificateId" => CertificateId, "DirectoryId" => DirectoryId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function deregister_certificate(
    CertificateId,
    DirectoryId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "DeregisterCertificate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CertificateId" => CertificateId, "DirectoryId" => DirectoryId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    deregister_event_topic(directory_id, topic_name)
    deregister_event_topic(directory_id, topic_name, params::Dict{String,<:Any})

Removes the specified directory as a publisher to the specified Amazon SNS topic.

# Arguments
- `directory_id`: The Directory ID to remove as a publisher. This directory will no longer
  send messages to the specified Amazon SNS topic.
- `topic_name`: The name of the Amazon SNS topic from which to remove the directory as a
  publisher.

"""
function deregister_event_topic(
    DirectoryId, TopicName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return directory_service(
        "DeregisterEventTopic",
        Dict{String,Any}("DirectoryId" => DirectoryId, "TopicName" => TopicName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function deregister_event_topic(
    DirectoryId,
    TopicName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "DeregisterEventTopic",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DirectoryId" => DirectoryId, "TopicName" => TopicName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_certificate(certificate_id, directory_id)
    describe_certificate(certificate_id, directory_id, params::Dict{String,<:Any})

Displays information about the certificate registered for secure LDAP or client certificate
authentication.

# Arguments
- `certificate_id`: The identifier of the certificate.
- `directory_id`: The identifier of the directory.

"""
function describe_certificate(
    CertificateId, DirectoryId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return directory_service(
        "DescribeCertificate",
        Dict{String,Any}("CertificateId" => CertificateId, "DirectoryId" => DirectoryId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_certificate(
    CertificateId,
    DirectoryId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "DescribeCertificate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CertificateId" => CertificateId, "DirectoryId" => DirectoryId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_client_authentication_settings(directory_id)
    describe_client_authentication_settings(directory_id, params::Dict{String,<:Any})

Retrieves information about the type of client authentication for the specified directory,
if the type is specified. If no type is specified, information about all client
authentication types that are supported for the specified directory is retrieved.
Currently, only SmartCard is supported.

# Arguments
- `directory_id`: The identifier of the directory for which to retrieve information.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: The maximum number of items to return. If this value is zero, the maximum
  number of items is specified by the limitations of the operation.
- `"NextToken"`: The DescribeClientAuthenticationSettingsResult.NextToken value from a
  previous call to DescribeClientAuthenticationSettings. Pass null if this is the first call.
- `"Type"`: The type of client authentication for which to retrieve information. If no type
  is specified, a list of all client authentication types that are supported for the
  specified directory is retrieved.
"""
function describe_client_authentication_settings(
    DirectoryId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return directory_service(
        "DescribeClientAuthenticationSettings",
        Dict{String,Any}("DirectoryId" => DirectoryId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_client_authentication_settings(
    DirectoryId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "DescribeClientAuthenticationSettings",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DirectoryId" => DirectoryId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_conditional_forwarders(directory_id)
    describe_conditional_forwarders(directory_id, params::Dict{String,<:Any})

Obtains information about the conditional forwarders for this account. If no input
parameters are provided for RemoteDomainNames, this request describes all conditional
forwarders for the specified directory ID.

# Arguments
- `directory_id`: The directory ID for which to get the list of associated conditional
  forwarders.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"RemoteDomainNames"`: The fully qualified domain names (FQDN) of the remote domains for
  which to get the list of associated conditional forwarders. If this member is null, all
  conditional forwarders are returned.
"""
function describe_conditional_forwarders(
    DirectoryId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return directory_service(
        "DescribeConditionalForwarders",
        Dict{String,Any}("DirectoryId" => DirectoryId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_conditional_forwarders(
    DirectoryId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "DescribeConditionalForwarders",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DirectoryId" => DirectoryId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_directories()
    describe_directories(params::Dict{String,<:Any})

Obtains information about the directories that belong to this account. You can retrieve
information about specific directories by passing the directory identifiers in the
DirectoryIds parameter. Otherwise, all directories that belong to the current account are
returned. This operation supports pagination with the use of the NextToken request and
response parameters. If more results are available, the DescribeDirectoriesResult.NextToken
member contains a token that you pass in the next call to DescribeDirectories to retrieve
the next set of items. You can also specify a maximum number of return results with the
Limit parameter.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DirectoryIds"`: A list of identifiers of the directories for which to obtain the
  information. If this member is null, all directories that belong to the current account are
  returned. An empty list results in an InvalidParameterException being thrown.
- `"Limit"`: The maximum number of items to return. If this value is zero, the maximum
  number of items is specified by the limitations of the operation.
- `"NextToken"`: The DescribeDirectoriesResult.NextToken value from a previous call to
  DescribeDirectories. Pass null if this is the first call.
"""
function describe_directories(; aws_config::AbstractAWSConfig=current_aws_config())
    return directory_service(
        "DescribeDirectories"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_directories(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return directory_service(
        "DescribeDirectories",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_domain_controllers(directory_id)
    describe_domain_controllers(directory_id, params::Dict{String,<:Any})

Provides information about any domain controllers in your directory.

# Arguments
- `directory_id`: Identifier of the directory for which to retrieve the domain controller
  information.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DomainControllerIds"`: A list of identifiers for the domain controllers whose
  information will be provided.
- `"Limit"`: The maximum number of items to return.
- `"NextToken"`: The DescribeDomainControllers.NextToken value from a previous call to
  DescribeDomainControllers. Pass null if this is the first call.
"""
function describe_domain_controllers(
    DirectoryId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return directory_service(
        "DescribeDomainControllers",
        Dict{String,Any}("DirectoryId" => DirectoryId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_domain_controllers(
    DirectoryId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "DescribeDomainControllers",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DirectoryId" => DirectoryId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_event_topics()
    describe_event_topics(params::Dict{String,<:Any})

Obtains information about which Amazon SNS topics receive status messages from the
specified directory. If no input parameters are provided, such as DirectoryId or TopicName,
this request describes all of the associations in the account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DirectoryId"`: The Directory ID for which to get the list of associated Amazon SNS
  topics. If this member is null, associations for all Directory IDs are returned.
- `"TopicNames"`: A list of Amazon SNS topic names for which to obtain the information. If
  this member is null, all associations for the specified Directory ID are returned. An empty
  list results in an InvalidParameterException being thrown.
"""
function describe_event_topics(; aws_config::AbstractAWSConfig=current_aws_config())
    return directory_service(
        "DescribeEventTopics"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_event_topics(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return directory_service(
        "DescribeEventTopics",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_ldapssettings(directory_id)
    describe_ldapssettings(directory_id, params::Dict{String,<:Any})

Describes the status of LDAP security for the specified directory.

# Arguments
- `directory_id`: The identifier of the directory.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: Specifies the number of items that should be displayed on one page.
- `"NextToken"`: The type of next token used for pagination.
- `"Type"`: The type of LDAP security to enable. Currently only the value Client is
  supported.
"""
function describe_ldapssettings(
    DirectoryId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return directory_service(
        "DescribeLDAPSSettings",
        Dict{String,Any}("DirectoryId" => DirectoryId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_ldapssettings(
    DirectoryId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "DescribeLDAPSSettings",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DirectoryId" => DirectoryId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_regions(directory_id)
    describe_regions(directory_id, params::Dict{String,<:Any})

Provides information about the Regions that are configured for multi-Region replication.

# Arguments
- `directory_id`: The identifier of the directory.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: The DescribeRegionsResult.NextToken value from a previous call to
  DescribeRegions. Pass null if this is the first call.
- `"RegionName"`: The name of the Region. For example, us-east-1.
"""
function describe_regions(DirectoryId; aws_config::AbstractAWSConfig=current_aws_config())
    return directory_service(
        "DescribeRegions",
        Dict{String,Any}("DirectoryId" => DirectoryId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_regions(
    DirectoryId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "DescribeRegions",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DirectoryId" => DirectoryId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_settings(directory_id)
    describe_settings(directory_id, params::Dict{String,<:Any})

Retrieves information about the configurable settings for the specified directory.

# Arguments
- `directory_id`: The identifier of the directory for which to retrieve information.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: The DescribeSettingsResult.NextToken value from a previous call to
  DescribeSettings. Pass null if this is the first call.
- `"Status"`: The status of the directory settings for which to retrieve information.
"""
function describe_settings(DirectoryId; aws_config::AbstractAWSConfig=current_aws_config())
    return directory_service(
        "DescribeSettings",
        Dict{String,Any}("DirectoryId" => DirectoryId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_settings(
    DirectoryId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "DescribeSettings",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DirectoryId" => DirectoryId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_shared_directories(owner_directory_id)
    describe_shared_directories(owner_directory_id, params::Dict{String,<:Any})

Returns the shared directories in your account.

# Arguments
- `owner_directory_id`: Returns the identifier of the directory in the directory owner
  account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: The number of shared directories to return in the response object.
- `"NextToken"`: The DescribeSharedDirectoriesResult.NextToken value from a previous call
  to DescribeSharedDirectories. Pass null if this is the first call.
- `"SharedDirectoryIds"`: A list of identifiers of all shared directories in your account.
"""
function describe_shared_directories(
    OwnerDirectoryId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return directory_service(
        "DescribeSharedDirectories",
        Dict{String,Any}("OwnerDirectoryId" => OwnerDirectoryId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_shared_directories(
    OwnerDirectoryId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "DescribeSharedDirectories",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("OwnerDirectoryId" => OwnerDirectoryId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_snapshots()
    describe_snapshots(params::Dict{String,<:Any})

Obtains information about the directory snapshots that belong to this account. This
operation supports pagination with the use of the NextToken request and response
parameters. If more results are available, the DescribeSnapshots.NextToken member contains
a token that you pass in the next call to DescribeSnapshots to retrieve the next set of
items. You can also specify a maximum number of return results with the Limit parameter.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DirectoryId"`: The identifier of the directory for which to retrieve snapshot
  information.
- `"Limit"`: The maximum number of objects to return.
- `"NextToken"`: The DescribeSnapshotsResult.NextToken value from a previous call to
  DescribeSnapshots. Pass null if this is the first call.
- `"SnapshotIds"`: A list of identifiers of the snapshots to obtain the information for. If
  this member is null or empty, all snapshots are returned using the Limit and NextToken
  members.
"""
function describe_snapshots(; aws_config::AbstractAWSConfig=current_aws_config())
    return directory_service(
        "DescribeSnapshots"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_snapshots(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return directory_service(
        "DescribeSnapshots", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_trusts()
    describe_trusts(params::Dict{String,<:Any})

Obtains information about the trust relationships for this account. If no input parameters
are provided, such as DirectoryId or TrustIds, this request describes all the trust
relationships belonging to the account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DirectoryId"`: The Directory ID of the Amazon Web Services directory that is a part of
  the requested trust relationship.
- `"Limit"`: The maximum number of objects to return.
- `"NextToken"`: The DescribeTrustsResult.NextToken value from a previous call to
  DescribeTrusts. Pass null if this is the first call.
- `"TrustIds"`: A list of identifiers of the trust relationships for which to obtain the
  information. If this member is null, all trust relationships that belong to the current
  account are returned. An empty list results in an InvalidParameterException being thrown.
"""
function describe_trusts(; aws_config::AbstractAWSConfig=current_aws_config())
    return directory_service(
        "DescribeTrusts"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_trusts(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return directory_service(
        "DescribeTrusts", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_update_directory(directory_id, update_type)
    describe_update_directory(directory_id, update_type, params::Dict{String,<:Any})

 Describes the updates of a directory for a particular update type.

# Arguments
- `directory_id`:  The unique identifier of the directory.
- `update_type`:  The type of updates you want to describe for the directory.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`:  The DescribeUpdateDirectoryResult. NextToken value from a previous call
  to DescribeUpdateDirectory. Pass null if this is the first call.
- `"RegionName"`:  The name of the Region.
"""
function describe_update_directory(
    DirectoryId, UpdateType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return directory_service(
        "DescribeUpdateDirectory",
        Dict{String,Any}("DirectoryId" => DirectoryId, "UpdateType" => UpdateType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_update_directory(
    DirectoryId,
    UpdateType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "DescribeUpdateDirectory",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DirectoryId" => DirectoryId, "UpdateType" => UpdateType),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disable_client_authentication(directory_id, type)
    disable_client_authentication(directory_id, type, params::Dict{String,<:Any})

Disables alternative client authentication methods for the specified directory.

# Arguments
- `directory_id`: The identifier of the directory
- `type`: The type of client authentication to disable. Currently, only the parameter,
  SmartCard is supported.

"""
function disable_client_authentication(
    DirectoryId, Type; aws_config::AbstractAWSConfig=current_aws_config()
)
    return directory_service(
        "DisableClientAuthentication",
        Dict{String,Any}("DirectoryId" => DirectoryId, "Type" => Type);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disable_client_authentication(
    DirectoryId,
    Type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "DisableClientAuthentication",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DirectoryId" => DirectoryId, "Type" => Type),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disable_ldaps(directory_id, type)
    disable_ldaps(directory_id, type, params::Dict{String,<:Any})

Deactivates LDAP secure calls for the specified directory.

# Arguments
- `directory_id`: The identifier of the directory.
- `type`: The type of LDAP security to enable. Currently only the value Client is supported.

"""
function disable_ldaps(
    DirectoryId, Type; aws_config::AbstractAWSConfig=current_aws_config()
)
    return directory_service(
        "DisableLDAPS",
        Dict{String,Any}("DirectoryId" => DirectoryId, "Type" => Type);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disable_ldaps(
    DirectoryId,
    Type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "DisableLDAPS",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DirectoryId" => DirectoryId, "Type" => Type),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disable_radius(directory_id)
    disable_radius(directory_id, params::Dict{String,<:Any})

Disables multi-factor authentication (MFA) with the Remote Authentication Dial In User
Service (RADIUS) server for an AD Connector or Microsoft AD directory.

# Arguments
- `directory_id`: The identifier of the directory for which to disable MFA.

"""
function disable_radius(DirectoryId; aws_config::AbstractAWSConfig=current_aws_config())
    return directory_service(
        "DisableRadius",
        Dict{String,Any}("DirectoryId" => DirectoryId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disable_radius(
    DirectoryId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "DisableRadius",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DirectoryId" => DirectoryId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disable_sso(directory_id)
    disable_sso(directory_id, params::Dict{String,<:Any})

Disables single-sign on for a directory.

# Arguments
- `directory_id`: The identifier of the directory for which to disable single-sign on.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Password"`: The password of an alternate account to use to disable single-sign on. This
  is only used for AD Connector directories. For more information, see the UserName parameter.
- `"UserName"`: The username of an alternate account to use to disable single-sign on. This
  is only used for AD Connector directories. This account must have privileges to remove a
  service principal name. If the AD Connector service account does not have privileges to
  remove a service principal name, you can specify an alternate account with the UserName and
  Password parameters. These credentials are only used to disable single sign-on and are not
  stored by the service. The AD Connector service account is not changed.
"""
function disable_sso(DirectoryId; aws_config::AbstractAWSConfig=current_aws_config())
    return directory_service(
        "DisableSso",
        Dict{String,Any}("DirectoryId" => DirectoryId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disable_sso(
    DirectoryId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "DisableSso",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DirectoryId" => DirectoryId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    enable_client_authentication(directory_id, type)
    enable_client_authentication(directory_id, type, params::Dict{String,<:Any})

Enables alternative client authentication methods for the specified directory.

# Arguments
- `directory_id`: The identifier of the specified directory.
- `type`: The type of client authentication to enable. Currently only the value SmartCard
  is supported. Smart card authentication in AD Connector requires that you enable Kerberos
  Constrained Delegation for the Service User to the LDAP service in your self-managed AD.

"""
function enable_client_authentication(
    DirectoryId, Type; aws_config::AbstractAWSConfig=current_aws_config()
)
    return directory_service(
        "EnableClientAuthentication",
        Dict{String,Any}("DirectoryId" => DirectoryId, "Type" => Type);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function enable_client_authentication(
    DirectoryId,
    Type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "EnableClientAuthentication",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DirectoryId" => DirectoryId, "Type" => Type),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    enable_ldaps(directory_id, type)
    enable_ldaps(directory_id, type, params::Dict{String,<:Any})

Activates the switch for the specific directory to always use LDAP secure calls.

# Arguments
- `directory_id`: The identifier of the directory.
- `type`: The type of LDAP security to enable. Currently only the value Client is supported.

"""
function enable_ldaps(DirectoryId, Type; aws_config::AbstractAWSConfig=current_aws_config())
    return directory_service(
        "EnableLDAPS",
        Dict{String,Any}("DirectoryId" => DirectoryId, "Type" => Type);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function enable_ldaps(
    DirectoryId,
    Type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "EnableLDAPS",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DirectoryId" => DirectoryId, "Type" => Type),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    enable_radius(directory_id, radius_settings)
    enable_radius(directory_id, radius_settings, params::Dict{String,<:Any})

Enables multi-factor authentication (MFA) with the Remote Authentication Dial In User
Service (RADIUS) server for an AD Connector or Microsoft AD directory.

# Arguments
- `directory_id`: The identifier of the directory for which to enable MFA.
- `radius_settings`: A RadiusSettings object that contains information about the RADIUS
  server.

"""
function enable_radius(
    DirectoryId, RadiusSettings; aws_config::AbstractAWSConfig=current_aws_config()
)
    return directory_service(
        "EnableRadius",
        Dict{String,Any}("DirectoryId" => DirectoryId, "RadiusSettings" => RadiusSettings);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function enable_radius(
    DirectoryId,
    RadiusSettings,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "EnableRadius",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DirectoryId" => DirectoryId, "RadiusSettings" => RadiusSettings
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    enable_sso(directory_id)
    enable_sso(directory_id, params::Dict{String,<:Any})

Enables single sign-on for a directory. Single sign-on allows users in your directory to
access certain Amazon Web Services services from a computer joined to the directory without
having to enter their credentials separately.

# Arguments
- `directory_id`: The identifier of the directory for which to enable single-sign on.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Password"`: The password of an alternate account to use to enable single-sign on. This
  is only used for AD Connector directories. For more information, see the UserName parameter.
- `"UserName"`: The username of an alternate account to use to enable single-sign on. This
  is only used for AD Connector directories. This account must have privileges to add a
  service principal name. If the AD Connector service account does not have privileges to add
  a service principal name, you can specify an alternate account with the UserName and
  Password parameters. These credentials are only used to enable single sign-on and are not
  stored by the service. The AD Connector service account is not changed.
"""
function enable_sso(DirectoryId; aws_config::AbstractAWSConfig=current_aws_config())
    return directory_service(
        "EnableSso",
        Dict{String,Any}("DirectoryId" => DirectoryId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function enable_sso(
    DirectoryId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "EnableSso",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DirectoryId" => DirectoryId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_directory_limits()
    get_directory_limits(params::Dict{String,<:Any})

Obtains directory limit information for the current Region.

"""
function get_directory_limits(; aws_config::AbstractAWSConfig=current_aws_config())
    return directory_service(
        "GetDirectoryLimits"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_directory_limits(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return directory_service(
        "GetDirectoryLimits", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_snapshot_limits(directory_id)
    get_snapshot_limits(directory_id, params::Dict{String,<:Any})

Obtains the manual snapshot limits for a directory.

# Arguments
- `directory_id`: Contains the identifier of the directory to obtain the limits for.

"""
function get_snapshot_limits(
    DirectoryId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return directory_service(
        "GetSnapshotLimits",
        Dict{String,Any}("DirectoryId" => DirectoryId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_snapshot_limits(
    DirectoryId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "GetSnapshotLimits",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DirectoryId" => DirectoryId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_certificates(directory_id)
    list_certificates(directory_id, params::Dict{String,<:Any})

For the specified directory, lists all the certificates registered for a secure LDAP or
client certificate authentication.

# Arguments
- `directory_id`: The identifier of the directory.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: The number of items that should show up on one page
- `"NextToken"`: A token for requesting another page of certificates if the NextToken
  response element indicates that more certificates are available. Use the value of the
  returned NextToken element in your request until the token comes back as null. Pass null if
  this is the first call.
"""
function list_certificates(DirectoryId; aws_config::AbstractAWSConfig=current_aws_config())
    return directory_service(
        "ListCertificates",
        Dict{String,Any}("DirectoryId" => DirectoryId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_certificates(
    DirectoryId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "ListCertificates",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DirectoryId" => DirectoryId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_ip_routes(directory_id)
    list_ip_routes(directory_id, params::Dict{String,<:Any})

Lists the address blocks that you have added to a directory.

# Arguments
- `directory_id`: Identifier (ID) of the directory for which you want to retrieve the IP
  addresses.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: Maximum number of items to return. If this value is zero, the maximum number
  of items is specified by the limitations of the operation.
- `"NextToken"`: The ListIpRoutes.NextToken value from a previous call to ListIpRoutes.
  Pass null if this is the first call.
"""
function list_ip_routes(DirectoryId; aws_config::AbstractAWSConfig=current_aws_config())
    return directory_service(
        "ListIpRoutes",
        Dict{String,Any}("DirectoryId" => DirectoryId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_ip_routes(
    DirectoryId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "ListIpRoutes",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DirectoryId" => DirectoryId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_log_subscriptions()
    list_log_subscriptions(params::Dict{String,<:Any})

Lists the active log subscriptions for the Amazon Web Services account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DirectoryId"`: If a DirectoryID is provided, lists only the log subscription associated
  with that directory. If no DirectoryId is provided, lists all log subscriptions associated
  with your Amazon Web Services account. If there are no log subscriptions for the Amazon Web
  Services account or the directory, an empty list will be returned.
- `"Limit"`: The maximum number of items returned.
- `"NextToken"`: The token for the next set of items to return.
"""
function list_log_subscriptions(; aws_config::AbstractAWSConfig=current_aws_config())
    return directory_service(
        "ListLogSubscriptions"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_log_subscriptions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return directory_service(
        "ListLogSubscriptions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_schema_extensions(directory_id)
    list_schema_extensions(directory_id, params::Dict{String,<:Any})

Lists all schema extensions applied to a Microsoft AD Directory.

# Arguments
- `directory_id`: The identifier of the directory from which to retrieve the schema
  extension information.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: The maximum number of items to return.
- `"NextToken"`: The ListSchemaExtensions.NextToken value from a previous call to
  ListSchemaExtensions. Pass null if this is the first call.
"""
function list_schema_extensions(
    DirectoryId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return directory_service(
        "ListSchemaExtensions",
        Dict{String,Any}("DirectoryId" => DirectoryId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_schema_extensions(
    DirectoryId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "ListSchemaExtensions",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DirectoryId" => DirectoryId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_id)
    list_tags_for_resource(resource_id, params::Dict{String,<:Any})

Lists all tags on a directory.

# Arguments
- `resource_id`: Identifier (ID) of the directory for which you want to retrieve tags.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: Reserved for future use.
- `"NextToken"`: Reserved for future use.
"""
function list_tags_for_resource(
    ResourceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return directory_service(
        "ListTagsForResource",
        Dict{String,Any}("ResourceId" => ResourceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceId" => ResourceId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    register_certificate(certificate_data, directory_id)
    register_certificate(certificate_data, directory_id, params::Dict{String,<:Any})

Registers a certificate for a secure LDAP or client certificate authentication.

# Arguments
- `certificate_data`: The certificate PEM string that needs to be registered.
- `directory_id`: The identifier of the directory.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientCertAuthSettings"`: A ClientCertAuthSettings object that contains client
  certificate authentication settings.
- `"Type"`: The function that the registered certificate performs. Valid values include
  ClientLDAPS or ClientCertAuth. The default value is ClientLDAPS.
"""
function register_certificate(
    CertificateData, DirectoryId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return directory_service(
        "RegisterCertificate",
        Dict{String,Any}(
            "CertificateData" => CertificateData, "DirectoryId" => DirectoryId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function register_certificate(
    CertificateData,
    DirectoryId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "RegisterCertificate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CertificateData" => CertificateData, "DirectoryId" => DirectoryId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    register_event_topic(directory_id, topic_name)
    register_event_topic(directory_id, topic_name, params::Dict{String,<:Any})

Associates a directory with an Amazon SNS topic. This establishes the directory as a
publisher to the specified Amazon SNS topic. You can then receive email or text (SMS)
messages when the status of your directory changes. You get notified if your directory goes
from an Active status to an Impaired or Inoperable status. You also receive a notification
when the directory returns to an Active status.

# Arguments
- `directory_id`: The Directory ID that will publish status messages to the Amazon SNS
  topic.
- `topic_name`: The Amazon SNS topic name to which the directory will publish status
  messages. This Amazon SNS topic must be in the same region as the specified Directory ID.

"""
function register_event_topic(
    DirectoryId, TopicName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return directory_service(
        "RegisterEventTopic",
        Dict{String,Any}("DirectoryId" => DirectoryId, "TopicName" => TopicName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function register_event_topic(
    DirectoryId,
    TopicName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "RegisterEventTopic",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DirectoryId" => DirectoryId, "TopicName" => TopicName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    reject_shared_directory(shared_directory_id)
    reject_shared_directory(shared_directory_id, params::Dict{String,<:Any})

Rejects a directory sharing request that was sent from the directory owner account.

# Arguments
- `shared_directory_id`: Identifier of the shared directory in the directory consumer
  account. This identifier is different for each directory owner account.

"""
function reject_shared_directory(
    SharedDirectoryId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return directory_service(
        "RejectSharedDirectory",
        Dict{String,Any}("SharedDirectoryId" => SharedDirectoryId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function reject_shared_directory(
    SharedDirectoryId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "RejectSharedDirectory",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("SharedDirectoryId" => SharedDirectoryId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_ip_routes(cidr_ips, directory_id)
    remove_ip_routes(cidr_ips, directory_id, params::Dict{String,<:Any})

Removes IP address blocks from a directory.

# Arguments
- `cidr_ips`: IP address blocks that you want to remove.
- `directory_id`: Identifier (ID) of the directory from which you want to remove the IP
  addresses.

"""
function remove_ip_routes(
    CidrIps, DirectoryId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return directory_service(
        "RemoveIpRoutes",
        Dict{String,Any}("CidrIps" => CidrIps, "DirectoryId" => DirectoryId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_ip_routes(
    CidrIps,
    DirectoryId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "RemoveIpRoutes",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("CidrIps" => CidrIps, "DirectoryId" => DirectoryId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_region(directory_id)
    remove_region(directory_id, params::Dict{String,<:Any})

Stops all replication and removes the domain controllers from the specified Region. You
cannot remove the primary Region with this operation. Instead, use the DeleteDirectory API.

# Arguments
- `directory_id`: The identifier of the directory for which you want to remove Region
  replication.

"""
function remove_region(DirectoryId; aws_config::AbstractAWSConfig=current_aws_config())
    return directory_service(
        "RemoveRegion",
        Dict{String,Any}("DirectoryId" => DirectoryId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_region(
    DirectoryId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "RemoveRegion",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DirectoryId" => DirectoryId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_tags_from_resource(resource_id, tag_keys)
    remove_tags_from_resource(resource_id, tag_keys, params::Dict{String,<:Any})

Removes tags from a directory.

# Arguments
- `resource_id`: Identifier (ID) of the directory from which to remove the tag.
- `tag_keys`: The tag key (name) of the tag to be removed.

"""
function remove_tags_from_resource(
    ResourceId, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return directory_service(
        "RemoveTagsFromResource",
        Dict{String,Any}("ResourceId" => ResourceId, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_tags_from_resource(
    ResourceId,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "RemoveTagsFromResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceId" => ResourceId, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    reset_user_password(directory_id, new_password, user_name)
    reset_user_password(directory_id, new_password, user_name, params::Dict{String,<:Any})

Resets the password for any user in your Managed Microsoft AD or Simple AD directory. You
can reset the password for any user in your directory with the following exceptions:   For
Simple AD, you cannot reset the password for any user that is a member of either the Domain
Admins or Enterprise Admins group except for the administrator user.   For Managed
Microsoft AD, you can only reset the password for a user that is in an OU based off of the
NetBIOS name that you typed when you created your directory. For example, you cannot reset
the password for a user in the Amazon Web Services Reserved OU. For more information about
the OU structure for an Managed Microsoft AD directory, see What Gets Created in the
Directory Service Administration Guide.

# Arguments
- `directory_id`: Identifier of the Managed Microsoft AD or Simple AD directory in which
  the user resides.
- `new_password`: The new password that will be reset.
- `user_name`: The user name of the user whose password will be reset.

"""
function reset_user_password(
    DirectoryId, NewPassword, UserName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return directory_service(
        "ResetUserPassword",
        Dict{String,Any}(
            "DirectoryId" => DirectoryId,
            "NewPassword" => NewPassword,
            "UserName" => UserName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function reset_user_password(
    DirectoryId,
    NewPassword,
    UserName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "ResetUserPassword",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DirectoryId" => DirectoryId,
                    "NewPassword" => NewPassword,
                    "UserName" => UserName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    restore_from_snapshot(snapshot_id)
    restore_from_snapshot(snapshot_id, params::Dict{String,<:Any})

Restores a directory using an existing directory snapshot. When you restore a directory
from a snapshot, any changes made to the directory after the snapshot date are overwritten.
This action returns as soon as the restore operation is initiated. You can monitor the
progress of the restore operation by calling the DescribeDirectories operation with the
directory identifier. When the DirectoryDescription.Stage value changes to Active, the
restore operation is complete.

# Arguments
- `snapshot_id`: The identifier of the snapshot to restore from.

"""
function restore_from_snapshot(
    SnapshotId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return directory_service(
        "RestoreFromSnapshot",
        Dict{String,Any}("SnapshotId" => SnapshotId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function restore_from_snapshot(
    SnapshotId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "RestoreFromSnapshot",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("SnapshotId" => SnapshotId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    share_directory(directory_id, share_method, share_target)
    share_directory(directory_id, share_method, share_target, params::Dict{String,<:Any})

Shares a specified directory (DirectoryId) in your Amazon Web Services account (directory
owner) with another Amazon Web Services account (directory consumer). With this operation
you can use your directory from any Amazon Web Services account and from any Amazon VPC
within an Amazon Web Services Region. When you share your Managed Microsoft AD directory,
Directory Service creates a shared directory in the directory consumer account. This shared
directory contains the metadata to provide access to the directory within the directory
owner account. The shared directory is visible in all VPCs in the directory consumer
account. The ShareMethod parameter determines whether the specified directory can be shared
between Amazon Web Services accounts inside the same Amazon Web Services organization
(ORGANIZATIONS). It also determines whether you can share the directory with any other
Amazon Web Services account either inside or outside of the organization (HANDSHAKE). The
ShareNotes parameter is only used when HANDSHAKE is called, which sends a directory sharing
request to the directory consumer.

# Arguments
- `directory_id`: Identifier of the Managed Microsoft AD directory that you want to share
  with other Amazon Web Services accounts.
- `share_method`: The method used when sharing a directory to determine whether the
  directory should be shared within your Amazon Web Services organization (ORGANIZATIONS) or
  with any Amazon Web Services account by sending a directory sharing request (HANDSHAKE).
- `share_target`: Identifier for the directory consumer account with whom the directory is
  to be shared.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ShareNotes"`: A directory share request that is sent by the directory owner to the
  directory consumer. The request includes a typed message to help the directory consumer
  administrator determine whether to approve or reject the share invitation.
"""
function share_directory(
    DirectoryId,
    ShareMethod,
    ShareTarget;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "ShareDirectory",
        Dict{String,Any}(
            "DirectoryId" => DirectoryId,
            "ShareMethod" => ShareMethod,
            "ShareTarget" => ShareTarget,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function share_directory(
    DirectoryId,
    ShareMethod,
    ShareTarget,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "ShareDirectory",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DirectoryId" => DirectoryId,
                    "ShareMethod" => ShareMethod,
                    "ShareTarget" => ShareTarget,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_schema_extension(create_snapshot_before_schema_extension, description, directory_id, ldif_content)
    start_schema_extension(create_snapshot_before_schema_extension, description, directory_id, ldif_content, params::Dict{String,<:Any})

Applies a schema extension to a Microsoft AD directory.

# Arguments
- `create_snapshot_before_schema_extension`: If true, creates a snapshot of the directory
  before applying the schema extension.
- `description`: A description of the schema extension.
- `directory_id`: The identifier of the directory for which the schema extension will be
  applied to.
- `ldif_content`: The LDIF file represented as a string. To construct the LdifContent
  string, precede each line as it would be formatted in an ldif file with n. See the example
  request below for more details. The file size can be no larger than 1MB.

"""
function start_schema_extension(
    CreateSnapshotBeforeSchemaExtension,
    Description,
    DirectoryId,
    LdifContent;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "StartSchemaExtension",
        Dict{String,Any}(
            "CreateSnapshotBeforeSchemaExtension" => CreateSnapshotBeforeSchemaExtension,
            "Description" => Description,
            "DirectoryId" => DirectoryId,
            "LdifContent" => LdifContent,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_schema_extension(
    CreateSnapshotBeforeSchemaExtension,
    Description,
    DirectoryId,
    LdifContent,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "StartSchemaExtension",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CreateSnapshotBeforeSchemaExtension" =>
                        CreateSnapshotBeforeSchemaExtension,
                    "Description" => Description,
                    "DirectoryId" => DirectoryId,
                    "LdifContent" => LdifContent,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    unshare_directory(directory_id, unshare_target)
    unshare_directory(directory_id, unshare_target, params::Dict{String,<:Any})

Stops the directory sharing between the directory owner and consumer accounts.

# Arguments
- `directory_id`: The identifier of the Managed Microsoft AD directory that you want to
  stop sharing.
- `unshare_target`: Identifier for the directory consumer account with whom the directory
  has to be unshared.

"""
function unshare_directory(
    DirectoryId, UnshareTarget; aws_config::AbstractAWSConfig=current_aws_config()
)
    return directory_service(
        "UnshareDirectory",
        Dict{String,Any}("DirectoryId" => DirectoryId, "UnshareTarget" => UnshareTarget);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function unshare_directory(
    DirectoryId,
    UnshareTarget,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "UnshareDirectory",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DirectoryId" => DirectoryId, "UnshareTarget" => UnshareTarget
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_conditional_forwarder(directory_id, dns_ip_addrs, remote_domain_name)
    update_conditional_forwarder(directory_id, dns_ip_addrs, remote_domain_name, params::Dict{String,<:Any})

Updates a conditional forwarder that has been set up for your Amazon Web Services directory.

# Arguments
- `directory_id`: The directory ID of the Amazon Web Services directory for which to update
  the conditional forwarder.
- `dns_ip_addrs`: The updated IP addresses of the remote DNS server associated with the
  conditional forwarder.
- `remote_domain_name`: The fully qualified domain name (FQDN) of the remote domain with
  which you will set up a trust relationship.

"""
function update_conditional_forwarder(
    DirectoryId,
    DnsIpAddrs,
    RemoteDomainName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "UpdateConditionalForwarder",
        Dict{String,Any}(
            "DirectoryId" => DirectoryId,
            "DnsIpAddrs" => DnsIpAddrs,
            "RemoteDomainName" => RemoteDomainName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_conditional_forwarder(
    DirectoryId,
    DnsIpAddrs,
    RemoteDomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "UpdateConditionalForwarder",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DirectoryId" => DirectoryId,
                    "DnsIpAddrs" => DnsIpAddrs,
                    "RemoteDomainName" => RemoteDomainName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_directory_setup(directory_id, update_type)
    update_directory_setup(directory_id, update_type, params::Dict{String,<:Any})

 Updates the directory for a particular update type.

# Arguments
- `directory_id`:  The identifier of the directory on which you want to perform the update.
- `update_type`:  The type of update that needs to be performed on the directory. For
  example, OS.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CreateSnapshotBeforeUpdate"`:  The boolean that specifies if a snapshot for the
  directory needs to be taken before updating the directory.
- `"OSUpdateSettings"`:  The settings for the OS update that needs to be performed on the
  directory.
"""
function update_directory_setup(
    DirectoryId, UpdateType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return directory_service(
        "UpdateDirectorySetup",
        Dict{String,Any}("DirectoryId" => DirectoryId, "UpdateType" => UpdateType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_directory_setup(
    DirectoryId,
    UpdateType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "UpdateDirectorySetup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DirectoryId" => DirectoryId, "UpdateType" => UpdateType),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_number_of_domain_controllers(desired_number, directory_id)
    update_number_of_domain_controllers(desired_number, directory_id, params::Dict{String,<:Any})

Adds or removes domain controllers to or from the directory. Based on the difference
between current value and new value (provided through this API call), domain controllers
will be added or removed. It may take up to 45 minutes for any new domain controllers to
become fully active once the requested number of domain controllers is updated. During this
time, you cannot make another update request.

# Arguments
- `desired_number`: The number of domain controllers desired in the directory.
- `directory_id`: Identifier of the directory to which the domain controllers will be added
  or removed.

"""
function update_number_of_domain_controllers(
    DesiredNumber, DirectoryId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return directory_service(
        "UpdateNumberOfDomainControllers",
        Dict{String,Any}("DesiredNumber" => DesiredNumber, "DirectoryId" => DirectoryId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_number_of_domain_controllers(
    DesiredNumber,
    DirectoryId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "UpdateNumberOfDomainControllers",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DesiredNumber" => DesiredNumber, "DirectoryId" => DirectoryId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_radius(directory_id, radius_settings)
    update_radius(directory_id, radius_settings, params::Dict{String,<:Any})

Updates the Remote Authentication Dial In User Service (RADIUS) server information for an
AD Connector or Microsoft AD directory.

# Arguments
- `directory_id`: The identifier of the directory for which to update the RADIUS server
  information.
- `radius_settings`: A RadiusSettings object that contains information about the RADIUS
  server.

"""
function update_radius(
    DirectoryId, RadiusSettings; aws_config::AbstractAWSConfig=current_aws_config()
)
    return directory_service(
        "UpdateRadius",
        Dict{String,Any}("DirectoryId" => DirectoryId, "RadiusSettings" => RadiusSettings);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_radius(
    DirectoryId,
    RadiusSettings,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "UpdateRadius",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DirectoryId" => DirectoryId, "RadiusSettings" => RadiusSettings
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_settings(directory_id, settings)
    update_settings(directory_id, settings, params::Dict{String,<:Any})

Updates the configurable settings for the specified directory.

# Arguments
- `directory_id`: The identifier of the directory for which to update settings.
- `settings`: The list of Setting objects.

"""
function update_settings(
    DirectoryId, Settings; aws_config::AbstractAWSConfig=current_aws_config()
)
    return directory_service(
        "UpdateSettings",
        Dict{String,Any}("DirectoryId" => DirectoryId, "Settings" => Settings);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_settings(
    DirectoryId,
    Settings,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "UpdateSettings",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DirectoryId" => DirectoryId, "Settings" => Settings),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_trust(trust_id)
    update_trust(trust_id, params::Dict{String,<:Any})

Updates the trust that has been set up between your Managed Microsoft AD directory and an
self-managed Active Directory.

# Arguments
- `trust_id`: Identifier of the trust relationship.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"SelectiveAuth"`: Updates selective authentication for the trust.
"""
function update_trust(TrustId; aws_config::AbstractAWSConfig=current_aws_config())
    return directory_service(
        "UpdateTrust",
        Dict{String,Any}("TrustId" => TrustId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_trust(
    TrustId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "UpdateTrust",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("TrustId" => TrustId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    verify_trust(trust_id)
    verify_trust(trust_id, params::Dict{String,<:Any})

Directory Service for Microsoft Active Directory allows you to configure and verify trust
relationships. This action verifies a trust relationship between your Managed Microsoft AD
directory and an external domain.

# Arguments
- `trust_id`: The unique Trust ID of the trust relationship to verify.

"""
function verify_trust(TrustId; aws_config::AbstractAWSConfig=current_aws_config())
    return directory_service(
        "VerifyTrust",
        Dict{String,Any}("TrustId" => TrustId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function verify_trust(
    TrustId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return directory_service(
        "VerifyTrust",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("TrustId" => TrustId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: iotsecuretunneling
using AWS.Compat
using AWS.UUIDs

"""
    close_tunnel(tunnel_id)
    close_tunnel(tunnel_id, params::Dict{String,<:Any})

Closes a tunnel identified by the unique tunnel id. When a CloseTunnel request is received,
we close the WebSocket connections between the client and proxy server so no data can be
transmitted. Requires permission to access the CloseTunnel action.

# Arguments
- `tunnel_id`: The ID of the tunnel to close.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"delete"`: When set to true, IoT Secure Tunneling deletes the tunnel data immediately.
"""
function close_tunnel(tunnelId; aws_config::AbstractAWSConfig=current_aws_config())
    return iotsecuretunneling(
        "CloseTunnel",
        Dict{String,Any}("tunnelId" => tunnelId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function close_tunnel(
    tunnelId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsecuretunneling(
        "CloseTunnel",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("tunnelId" => tunnelId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_tunnel(tunnel_id)
    describe_tunnel(tunnel_id, params::Dict{String,<:Any})

Gets information about a tunnel identified by the unique tunnel id. Requires permission to
access the DescribeTunnel action.

# Arguments
- `tunnel_id`: The tunnel to describe.

"""
function describe_tunnel(tunnelId; aws_config::AbstractAWSConfig=current_aws_config())
    return iotsecuretunneling(
        "DescribeTunnel",
        Dict{String,Any}("tunnelId" => tunnelId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_tunnel(
    tunnelId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsecuretunneling(
        "DescribeTunnel",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("tunnelId" => tunnelId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists the tags for the specified resource.

# Arguments
- `resource_arn`: The resource ARN.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotsecuretunneling(
        "ListTagsForResource",
        Dict{String,Any}("resourceArn" => resourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsecuretunneling(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceArn" => resourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tunnels()
    list_tunnels(params::Dict{String,<:Any})

List all tunnels for an Amazon Web Services account. Tunnels are listed by creation time in
descending order, newer tunnels will be listed before older tunnels. Requires permission to
access the ListTunnels action.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return at once.
- `"nextToken"`: To retrieve the next set of results, the nextToken value from a previous
  response; otherwise null to receive the first set of results.
- `"thingName"`: The name of the IoT thing associated with the destination device.
"""
function list_tunnels(; aws_config::AbstractAWSConfig=current_aws_config())
    return iotsecuretunneling(
        "ListTunnels"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_tunnels(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotsecuretunneling(
        "ListTunnels", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    open_tunnel()
    open_tunnel(params::Dict{String,<:Any})

Creates a new tunnel, and returns two client access tokens for clients to use to connect to
the IoT Secure Tunneling proxy server. Requires permission to access the OpenTunnel action.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A short text description of the tunnel.
- `"destinationConfig"`: The destination configuration for the OpenTunnel request.
- `"tags"`: A collection of tag metadata.
- `"timeoutConfig"`: Timeout configuration for a tunnel.
"""
function open_tunnel(; aws_config::AbstractAWSConfig=current_aws_config())
    return iotsecuretunneling(
        "OpenTunnel"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function open_tunnel(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotsecuretunneling(
        "OpenTunnel", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    rotate_tunnel_access_token(client_mode, tunnel_id)
    rotate_tunnel_access_token(client_mode, tunnel_id, params::Dict{String,<:Any})

Revokes the current client access token (CAT) and returns new CAT for clients to use when
reconnecting to secure tunneling to access the same tunnel. Requires permission to access
the RotateTunnelAccessToken action.  Rotating the CAT doesn't extend the tunnel duration.
For example, say the tunnel duration is 12 hours and the tunnel has already been open for 4
hours. When you rotate the access tokens, the new tokens that are generated can only be
used for the remaining 8 hours.

# Arguments
- `client_mode`: The mode of the client that will use the client token, which can be either
  the source or destination, or both source and destination.
- `tunnel_id`: The tunnel for which you want to rotate the access tokens.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"destinationConfig"`:
"""
function rotate_tunnel_access_token(
    clientMode, tunnelId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotsecuretunneling(
        "RotateTunnelAccessToken",
        Dict{String,Any}("clientMode" => clientMode, "tunnelId" => tunnelId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function rotate_tunnel_access_token(
    clientMode,
    tunnelId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsecuretunneling(
        "RotateTunnelAccessToken",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("clientMode" => clientMode, "tunnelId" => tunnelId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

A resource tag.

# Arguments
- `resource_arn`: The ARN of the resource.
- `tags`: The tags for the resource.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return iotsecuretunneling(
        "TagResource",
        Dict{String,Any}("resourceArn" => resourceArn, "tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsecuretunneling(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceArn" => resourceArn, "tags" => tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes a tag from a resource.

# Arguments
- `resource_arn`: The resource ARN.
- `tag_keys`: The keys of the tags to remove.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iotsecuretunneling(
        "UntagResource",
        Dict{String,Any}("resourceArn" => resourceArn, "tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iotsecuretunneling(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceArn" => resourceArn, "tagKeys" => tagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: workmail
using AWS.Compat
using AWS.UUIDs

"""
    associate_delegate_to_resource(entity_id, organization_id, resource_id)
    associate_delegate_to_resource(entity_id, organization_id, resource_id, params::Dict{String,<:Any})

Adds a member (user or group) to the resource's set of delegates.

# Arguments
- `entity_id`: The member (user or group) to associate to the resource. The entity ID can
  accept UserId or GroupID, Username or Groupname, or email.   Entity:
  12345678-1234-1234-1234-123456789012 or S-1-1-12-1234567890-123456789-123456789-1234
  Email address: entity@domain.tld   Entity: entity
- `organization_id`: The organization under which the resource exists.
- `resource_id`: The resource for which members (users or groups) are associated. The
  identifier can accept ResourceId, Resourcename, or email. The following identity formats
  are available:   Resource ID: r-0123456789a0123456789b0123456789   Email address:
  resource@domain.tld   Resource name: resource

"""
function associate_delegate_to_resource(
    EntityId, OrganizationId, ResourceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "AssociateDelegateToResource",
        Dict{String,Any}(
            "EntityId" => EntityId,
            "OrganizationId" => OrganizationId,
            "ResourceId" => ResourceId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_delegate_to_resource(
    EntityId,
    OrganizationId,
    ResourceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "AssociateDelegateToResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EntityId" => EntityId,
                    "OrganizationId" => OrganizationId,
                    "ResourceId" => ResourceId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_member_to_group(group_id, member_id, organization_id)
    associate_member_to_group(group_id, member_id, organization_id, params::Dict{String,<:Any})

Adds a member (user or group) to the group's set.

# Arguments
- `group_id`: The group to which the member (user or group) is associated. The identifier
  can accept GroupId, Groupname, or email. The following identity formats are available:
  Group ID: 12345678-1234-1234-1234-123456789012 or
  S-1-1-12-1234567890-123456789-123456789-1234   Email address: group@domain.tld   Group
  name: group
- `member_id`: The member (user or group) to associate to the group. The member ID can
  accept UserID or GroupId, Username or Groupname, or email.   Member:
  12345678-1234-1234-1234-123456789012 or S-1-1-12-1234567890-123456789-123456789-1234
  Email address: member@domain.tld   Member name: member
- `organization_id`: The organization under which the group exists.

"""
function associate_member_to_group(
    GroupId, MemberId, OrganizationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "AssociateMemberToGroup",
        Dict{String,Any}(
            "GroupId" => GroupId, "MemberId" => MemberId, "OrganizationId" => OrganizationId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_member_to_group(
    GroupId,
    MemberId,
    OrganizationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "AssociateMemberToGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "GroupId" => GroupId,
                    "MemberId" => MemberId,
                    "OrganizationId" => OrganizationId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    assume_impersonation_role(impersonation_role_id, organization_id)
    assume_impersonation_role(impersonation_role_id, organization_id, params::Dict{String,<:Any})

Assumes an impersonation role for the given WorkMail organization. This method returns an
authentication token you can use to make impersonated calls.

# Arguments
- `impersonation_role_id`: The impersonation role ID to assume.
- `organization_id`: The WorkMail organization under which the impersonation role will be
  assumed.

"""
function assume_impersonation_role(
    ImpersonationRoleId, OrganizationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "AssumeImpersonationRole",
        Dict{String,Any}(
            "ImpersonationRoleId" => ImpersonationRoleId, "OrganizationId" => OrganizationId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function assume_impersonation_role(
    ImpersonationRoleId,
    OrganizationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "AssumeImpersonationRole",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ImpersonationRoleId" => ImpersonationRoleId,
                    "OrganizationId" => OrganizationId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_mailbox_export_job(client_token, job_id, organization_id)
    cancel_mailbox_export_job(client_token, job_id, organization_id, params::Dict{String,<:Any})

Cancels a mailbox export job.  If the mailbox export job is near completion, it might not
be possible to cancel it.

# Arguments
- `client_token`: The idempotency token for the client request.
- `job_id`: The job ID.
- `organization_id`: The organization ID.

"""
function cancel_mailbox_export_job(
    ClientToken, JobId, OrganizationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "CancelMailboxExportJob",
        Dict{String,Any}(
            "ClientToken" => ClientToken,
            "JobId" => JobId,
            "OrganizationId" => OrganizationId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_mailbox_export_job(
    ClientToken,
    JobId,
    OrganizationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "CancelMailboxExportJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClientToken" => ClientToken,
                    "JobId" => JobId,
                    "OrganizationId" => OrganizationId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_alias(alias, entity_id, organization_id)
    create_alias(alias, entity_id, organization_id, params::Dict{String,<:Any})

Adds an alias to the set of a given member (user or group) of WorkMail.

# Arguments
- `alias`: The alias to add to the member set.
- `entity_id`: The member (user or group) to which this alias is added.
- `organization_id`: The organization under which the member (user or group) exists.

"""
function create_alias(
    Alias, EntityId, OrganizationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "CreateAlias",
        Dict{String,Any}(
            "Alias" => Alias, "EntityId" => EntityId, "OrganizationId" => OrganizationId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_alias(
    Alias,
    EntityId,
    OrganizationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "CreateAlias",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Alias" => Alias,
                    "EntityId" => EntityId,
                    "OrganizationId" => OrganizationId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_availability_configuration(domain_name, organization_id)
    create_availability_configuration(domain_name, organization_id, params::Dict{String,<:Any})

Creates an AvailabilityConfiguration for the given WorkMail organization and domain.

# Arguments
- `domain_name`: The domain to which the provider applies.
- `organization_id`: The WorkMail organization for which the AvailabilityConfiguration will
  be created.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: An idempotent token that ensures that an API request is executed only
  once.
- `"EwsProvider"`: Exchange Web Services (EWS) availability provider definition. The
  request must contain exactly one provider definition, either EwsProvider or LambdaProvider.
- `"LambdaProvider"`: Lambda availability provider definition. The request must contain
  exactly one provider definition, either EwsProvider or LambdaProvider.
"""
function create_availability_configuration(
    DomainName, OrganizationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "CreateAvailabilityConfiguration",
        Dict{String,Any}(
            "DomainName" => DomainName,
            "OrganizationId" => OrganizationId,
            "ClientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_availability_configuration(
    DomainName,
    OrganizationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "CreateAvailabilityConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DomainName" => DomainName,
                    "OrganizationId" => OrganizationId,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_group(name, organization_id)
    create_group(name, organization_id, params::Dict{String,<:Any})

Creates a group that can be used in WorkMail by calling the RegisterToWorkMail operation.

# Arguments
- `name`: The name of the group.
- `organization_id`: The organization under which the group is to be created.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"HiddenFromGlobalAddressList"`: If this parameter is enabled, the group will be hidden
  from the address book.
"""
function create_group(
    Name, OrganizationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "CreateGroup",
        Dict{String,Any}("Name" => Name, "OrganizationId" => OrganizationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_group(
    Name,
    OrganizationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "CreateGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Name" => Name, "OrganizationId" => OrganizationId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_impersonation_role(name, organization_id, rules, type)
    create_impersonation_role(name, organization_id, rules, type, params::Dict{String,<:Any})

Creates an impersonation role for the given WorkMail organization.  Idempotency ensures
that an API request completes no more than one time. With an idempotent request, if the
original request completes successfully, any subsequent retries also complete successfully
without performing any further actions.

# Arguments
- `name`: The name of the new impersonation role.
- `organization_id`: The WorkMail organization to create the new impersonation role within.
- `rules`: The list of rules for the impersonation role.
- `type`: The impersonation role's type. The available impersonation role types are
  READ_ONLY or FULL_ACCESS.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: The idempotency token for the client request.
- `"Description"`: The description of the new impersonation role.
"""
function create_impersonation_role(
    Name, OrganizationId, Rules, Type; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "CreateImpersonationRole",
        Dict{String,Any}(
            "Name" => Name,
            "OrganizationId" => OrganizationId,
            "Rules" => Rules,
            "Type" => Type,
            "ClientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_impersonation_role(
    Name,
    OrganizationId,
    Rules,
    Type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "CreateImpersonationRole",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Name" => Name,
                    "OrganizationId" => OrganizationId,
                    "Rules" => Rules,
                    "Type" => Type,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_mobile_device_access_rule(effect, name, organization_id)
    create_mobile_device_access_rule(effect, name, organization_id, params::Dict{String,<:Any})

Creates a new mobile device access rule for the specified WorkMail organization.

# Arguments
- `effect`: The effect of the rule when it matches. Allowed values are ALLOW or DENY.
- `name`: The rule name.
- `organization_id`: The WorkMail organization under which the rule will be created.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: The idempotency token for the client request.
- `"Description"`: The rule description.
- `"DeviceModels"`: Device models that the rule will match.
- `"DeviceOperatingSystems"`: Device operating systems that the rule will match.
- `"DeviceTypes"`: Device types that the rule will match.
- `"DeviceUserAgents"`: Device user agents that the rule will match.
- `"NotDeviceModels"`: Device models that the rule will not match. All other device models
  will match.
- `"NotDeviceOperatingSystems"`: Device operating systems that the rule will not match. All
  other device operating systems will match.
- `"NotDeviceTypes"`: Device types that the rule will not match. All other device types
  will match.
- `"NotDeviceUserAgents"`: Device user agents that the rule will not match. All other
  device user agents will match.
"""
function create_mobile_device_access_rule(
    Effect, Name, OrganizationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "CreateMobileDeviceAccessRule",
        Dict{String,Any}(
            "Effect" => Effect,
            "Name" => Name,
            "OrganizationId" => OrganizationId,
            "ClientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_mobile_device_access_rule(
    Effect,
    Name,
    OrganizationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "CreateMobileDeviceAccessRule",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Effect" => Effect,
                    "Name" => Name,
                    "OrganizationId" => OrganizationId,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_organization(alias)
    create_organization(alias, params::Dict{String,<:Any})

Creates a new WorkMail organization. Optionally, you can choose to associate an existing
AWS Directory Service directory with your organization. If an AWS Directory Service
directory ID is specified, the organization alias must match the directory alias. If you
choose not to associate an existing directory with your organization, then we create a new
WorkMail directory for you. For more information, see Adding an organization in the
WorkMail Administrator Guide. You can associate multiple email domains with an
organization, then choose your default email domain from the WorkMail console. You can also
associate a domain that is managed in an Amazon Route 53 public hosted zone. For more
information, see Adding a domain and Choosing the default domain in the WorkMail
Administrator Guide. Optionally, you can use a customer managed key from AWS Key Management
Service (AWS KMS) to encrypt email for your organization. If you don't associate an AWS KMS
key, WorkMail creates a default, AWS managed key for you.

# Arguments
- `alias`: The organization alias.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: The idempotency token associated with the request.
- `"DirectoryId"`: The AWS Directory Service directory ID.
- `"Domains"`: The email domains to associate with the organization.
- `"EnableInteroperability"`: When true, allows organization interoperability between
  WorkMail and Microsoft Exchange. If true, you must include a AD Connector directory ID in
  the request.
- `"KmsKeyArn"`: The Amazon Resource Name (ARN) of a customer managed key from AWS KMS.
"""
function create_organization(Alias; aws_config::AbstractAWSConfig=current_aws_config())
    return workmail(
        "CreateOrganization",
        Dict{String,Any}("Alias" => Alias, "ClientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_organization(
    Alias, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "CreateOrganization",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Alias" => Alias, "ClientToken" => string(uuid4())),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_resource(name, organization_id, type)
    create_resource(name, organization_id, type, params::Dict{String,<:Any})

Creates a new WorkMail resource.

# Arguments
- `name`: The name of the new resource.
- `organization_id`: The identifier associated with the organization for which the resource
  is created.
- `type`: The type of the new resource. The available types are equipment and room.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: Resource description.
- `"HiddenFromGlobalAddressList"`: If this parameter is enabled, the resource will be
  hidden from the address book.
"""
function create_resource(
    Name, OrganizationId, Type; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "CreateResource",
        Dict{String,Any}(
            "Name" => Name, "OrganizationId" => OrganizationId, "Type" => Type
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_resource(
    Name,
    OrganizationId,
    Type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "CreateResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Name" => Name, "OrganizationId" => OrganizationId, "Type" => Type
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_user(display_name, name, organization_id)
    create_user(display_name, name, organization_id, params::Dict{String,<:Any})

Creates a user who can be used in WorkMail by calling the RegisterToWorkMail operation.

# Arguments
- `display_name`: The display name for the new user.
- `name`: The name for the new user. WorkMail directory user names have a maximum length of
  64. All others have a maximum length of 20.
- `organization_id`: The identifier of the organization for which the user is created.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FirstName"`: The first name of the new user.
- `"HiddenFromGlobalAddressList"`: If this parameter is enabled, the user will be hidden
  from the address book.
- `"LastName"`: The last name of the new user.
- `"Password"`: The password for the new user.
- `"Role"`: The role of the new user. You cannot pass SYSTEM_USER or RESOURCE role in a
  single request. When a user role is not selected, the default role of USER is selected.
"""
function create_user(
    DisplayName, Name, OrganizationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "CreateUser",
        Dict{String,Any}(
            "DisplayName" => DisplayName, "Name" => Name, "OrganizationId" => OrganizationId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_user(
    DisplayName,
    Name,
    OrganizationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "CreateUser",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DisplayName" => DisplayName,
                    "Name" => Name,
                    "OrganizationId" => OrganizationId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_access_control_rule(name, organization_id)
    delete_access_control_rule(name, organization_id, params::Dict{String,<:Any})

Deletes an access control rule for the specified WorkMail organization.  Deleting already
deleted and non-existing rules does not produce an error. In those cases, the service sends
back an HTTP 200 response with an empty HTTP body.

# Arguments
- `name`: The name of the access control rule.
- `organization_id`: The identifier for the organization.

"""
function delete_access_control_rule(
    Name, OrganizationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "DeleteAccessControlRule",
        Dict{String,Any}("Name" => Name, "OrganizationId" => OrganizationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_access_control_rule(
    Name,
    OrganizationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "DeleteAccessControlRule",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Name" => Name, "OrganizationId" => OrganizationId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_alias(alias, entity_id, organization_id)
    delete_alias(alias, entity_id, organization_id, params::Dict{String,<:Any})

Remove one or more specified aliases from a set of aliases for a given user.

# Arguments
- `alias`: The aliases to be removed from the user's set of aliases. Duplicate entries in
  the list are collapsed into single entries (the list is transformed into a set).
- `entity_id`: The identifier for the member (user or group) from which to have the aliases
  removed.
- `organization_id`: The identifier for the organization under which the user exists.

"""
function delete_alias(
    Alias, EntityId, OrganizationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "DeleteAlias",
        Dict{String,Any}(
            "Alias" => Alias, "EntityId" => EntityId, "OrganizationId" => OrganizationId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_alias(
    Alias,
    EntityId,
    OrganizationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "DeleteAlias",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Alias" => Alias,
                    "EntityId" => EntityId,
                    "OrganizationId" => OrganizationId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_availability_configuration(domain_name, organization_id)
    delete_availability_configuration(domain_name, organization_id, params::Dict{String,<:Any})

Deletes the AvailabilityConfiguration for the given WorkMail organization and domain.

# Arguments
- `domain_name`: The domain for which the AvailabilityConfiguration will be deleted.
- `organization_id`: The WorkMail organization for which the AvailabilityConfiguration will
  be deleted.

"""
function delete_availability_configuration(
    DomainName, OrganizationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "DeleteAvailabilityConfiguration",
        Dict{String,Any}("DomainName" => DomainName, "OrganizationId" => OrganizationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_availability_configuration(
    DomainName,
    OrganizationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "DeleteAvailabilityConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DomainName" => DomainName, "OrganizationId" => OrganizationId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_email_monitoring_configuration(organization_id)
    delete_email_monitoring_configuration(organization_id, params::Dict{String,<:Any})

Deletes the email monitoring configuration for a specified organization.

# Arguments
- `organization_id`: The ID of the organization from which the email monitoring
  configuration is deleted.

"""
function delete_email_monitoring_configuration(
    OrganizationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "DeleteEmailMonitoringConfiguration",
        Dict{String,Any}("OrganizationId" => OrganizationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_email_monitoring_configuration(
    OrganizationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "DeleteEmailMonitoringConfiguration",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("OrganizationId" => OrganizationId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_group(group_id, organization_id)
    delete_group(group_id, organization_id, params::Dict{String,<:Any})

Deletes a group from WorkMail.

# Arguments
- `group_id`: The identifier of the group to be deleted. The identifier can be the GroupId,
  or Groupname. The following identity formats are available:   Group ID:
  12345678-1234-1234-1234-123456789012 or S-1-1-12-1234567890-123456789-123456789-1234
  Group name: group
- `organization_id`: The organization that contains the group.

"""
function delete_group(
    GroupId, OrganizationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "DeleteGroup",
        Dict{String,Any}("GroupId" => GroupId, "OrganizationId" => OrganizationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_group(
    GroupId,
    OrganizationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "DeleteGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("GroupId" => GroupId, "OrganizationId" => OrganizationId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_impersonation_role(impersonation_role_id, organization_id)
    delete_impersonation_role(impersonation_role_id, organization_id, params::Dict{String,<:Any})

Deletes an impersonation role for the given WorkMail organization.

# Arguments
- `impersonation_role_id`: The ID of the impersonation role to delete.
- `organization_id`: The WorkMail organization from which to delete the impersonation role.

"""
function delete_impersonation_role(
    ImpersonationRoleId, OrganizationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "DeleteImpersonationRole",
        Dict{String,Any}(
            "ImpersonationRoleId" => ImpersonationRoleId, "OrganizationId" => OrganizationId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_impersonation_role(
    ImpersonationRoleId,
    OrganizationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "DeleteImpersonationRole",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ImpersonationRoleId" => ImpersonationRoleId,
                    "OrganizationId" => OrganizationId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_mailbox_permissions(entity_id, grantee_id, organization_id)
    delete_mailbox_permissions(entity_id, grantee_id, organization_id, params::Dict{String,<:Any})

Deletes permissions granted to a member (user or group).

# Arguments
- `entity_id`: The identifier of the entity that owns the mailbox. The identifier can be
  UserId or Group Id, Username or Groupname, or email.   Entity ID:
  12345678-1234-1234-1234-123456789012, r-0123456789a0123456789b0123456789, or
  S-1-1-12-1234567890-123456789-123456789-1234   Email address: entity@domain.tld   Entity
  name: entity
- `grantee_id`: The identifier of the entity for which to delete granted permissions. The
  identifier can be UserId, ResourceID, or Group Id, Username or Groupname, or email.
  Grantee ID: 12345678-1234-1234-1234-123456789012,r-0123456789a0123456789b0123456789, or
  S-1-1-12-1234567890-123456789-123456789-1234   Email address: grantee@domain.tld   Grantee
  name: grantee
- `organization_id`: The identifier of the organization under which the member (user or
  group) exists.

"""
function delete_mailbox_permissions(
    EntityId, GranteeId, OrganizationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "DeleteMailboxPermissions",
        Dict{String,Any}(
            "EntityId" => EntityId,
            "GranteeId" => GranteeId,
            "OrganizationId" => OrganizationId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_mailbox_permissions(
    EntityId,
    GranteeId,
    OrganizationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "DeleteMailboxPermissions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EntityId" => EntityId,
                    "GranteeId" => GranteeId,
                    "OrganizationId" => OrganizationId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_mobile_device_access_override(device_id, organization_id, user_id)
    delete_mobile_device_access_override(device_id, organization_id, user_id, params::Dict{String,<:Any})

Deletes the mobile device access override for the given WorkMail organization, user, and
device.  Deleting already deleted and non-existing overrides does not produce an error. In
those cases, the service sends back an HTTP 200 response with an empty HTTP body.

# Arguments
- `device_id`: The mobile device for which you delete the override. DeviceId is case
  insensitive.
- `organization_id`: The WorkMail organization for which the access override will be
  deleted.
- `user_id`: The WorkMail user for which you want to delete the override. Accepts the
  following types of user identities:   User ID: 12345678-1234-1234-1234-123456789012 or
  S-1-1-12-1234567890-123456789-123456789-1234    Email address: user@domain.tld    User
  name: user

"""
function delete_mobile_device_access_override(
    DeviceId, OrganizationId, UserId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "DeleteMobileDeviceAccessOverride",
        Dict{String,Any}(
            "DeviceId" => DeviceId, "OrganizationId" => OrganizationId, "UserId" => UserId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_mobile_device_access_override(
    DeviceId,
    OrganizationId,
    UserId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "DeleteMobileDeviceAccessOverride",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DeviceId" => DeviceId,
                    "OrganizationId" => OrganizationId,
                    "UserId" => UserId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_mobile_device_access_rule(mobile_device_access_rule_id, organization_id)
    delete_mobile_device_access_rule(mobile_device_access_rule_id, organization_id, params::Dict{String,<:Any})

Deletes a mobile device access rule for the specified WorkMail organization.  Deleting
already deleted and non-existing rules does not produce an error. In those cases, the
service sends back an HTTP 200 response with an empty HTTP body.

# Arguments
- `mobile_device_access_rule_id`: The identifier of the rule to be deleted.
- `organization_id`: The WorkMail organization under which the rule will be deleted.

"""
function delete_mobile_device_access_rule(
    MobileDeviceAccessRuleId,
    OrganizationId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "DeleteMobileDeviceAccessRule",
        Dict{String,Any}(
            "MobileDeviceAccessRuleId" => MobileDeviceAccessRuleId,
            "OrganizationId" => OrganizationId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_mobile_device_access_rule(
    MobileDeviceAccessRuleId,
    OrganizationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "DeleteMobileDeviceAccessRule",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "MobileDeviceAccessRuleId" => MobileDeviceAccessRuleId,
                    "OrganizationId" => OrganizationId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_organization(delete_directory, organization_id)
    delete_organization(delete_directory, organization_id, params::Dict{String,<:Any})

Deletes an WorkMail organization and all underlying AWS resources managed by WorkMail as
part of the organization. You can choose whether to delete the associated directory. For
more information, see Removing an organization in the WorkMail Administrator Guide.

# Arguments
- `delete_directory`: If true, deletes the AWS Directory Service directory associated with
  the organization.
- `organization_id`: The organization ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: The idempotency token associated with the request.
- `"ForceDelete"`: Deletes a WorkMail organization even if the organization has enabled
  users.
"""
function delete_organization(
    DeleteDirectory, OrganizationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "DeleteOrganization",
        Dict{String,Any}(
            "DeleteDirectory" => DeleteDirectory,
            "OrganizationId" => OrganizationId,
            "ClientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_organization(
    DeleteDirectory,
    OrganizationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "DeleteOrganization",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DeleteDirectory" => DeleteDirectory,
                    "OrganizationId" => OrganizationId,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_resource(organization_id, resource_id)
    delete_resource(organization_id, resource_id, params::Dict{String,<:Any})

Deletes the specified resource.

# Arguments
- `organization_id`: The identifier associated with the organization from which the
  resource is deleted.
- `resource_id`: The identifier of the resource to be deleted. The identifier can accept
  ResourceId, or Resourcename. The following identity formats are available:   Resource ID:
  r-0123456789a0123456789b0123456789   Resource name: resource

"""
function delete_resource(
    OrganizationId, ResourceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "DeleteResource",
        Dict{String,Any}("OrganizationId" => OrganizationId, "ResourceId" => ResourceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_resource(
    OrganizationId,
    ResourceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "DeleteResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "OrganizationId" => OrganizationId, "ResourceId" => ResourceId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_retention_policy(id, organization_id)
    delete_retention_policy(id, organization_id, params::Dict{String,<:Any})

Deletes the specified retention policy from the specified organization.

# Arguments
- `id`: The retention policy ID.
- `organization_id`: The organization ID.

"""
function delete_retention_policy(
    Id, OrganizationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "DeleteRetentionPolicy",
        Dict{String,Any}("Id" => Id, "OrganizationId" => OrganizationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_retention_policy(
    Id,
    OrganizationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "DeleteRetentionPolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Id" => Id, "OrganizationId" => OrganizationId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_user(organization_id, user_id)
    delete_user(organization_id, user_id, params::Dict{String,<:Any})

Deletes a user from WorkMail and all subsequent systems. Before you can delete a user, the
user state must be DISABLED. Use the DescribeUser action to confirm the user state.
Deleting a user is permanent and cannot be undone. WorkMail archives user mailboxes for 30
days before they are permanently removed.

# Arguments
- `organization_id`: The organization that contains the user to be deleted.
- `user_id`: The identifier of the user to be deleted. The identifier can be the UserId or
  Username. The following identity formats are available:   User ID:
  12345678-1234-1234-1234-123456789012 or S-1-1-12-1234567890-123456789-123456789-1234   User
  name: user

"""
function delete_user(
    OrganizationId, UserId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "DeleteUser",
        Dict{String,Any}("OrganizationId" => OrganizationId, "UserId" => UserId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_user(
    OrganizationId,
    UserId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "DeleteUser",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("OrganizationId" => OrganizationId, "UserId" => UserId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    deregister_from_work_mail(entity_id, organization_id)
    deregister_from_work_mail(entity_id, organization_id, params::Dict{String,<:Any})

Mark a user, group, or resource as no longer used in WorkMail. This action disassociates
the mailbox and schedules it for clean-up. WorkMail keeps mailboxes for 30 days before they
are permanently removed. The functionality in the console is Disable.

# Arguments
- `entity_id`: The identifier for the member to be updated. The identifier can be UserId,
  ResourceId, or Group Id, Username, Resourcename, or Groupname, or email.   Entity ID:
  12345678-1234-1234-1234-123456789012, r-0123456789a0123456789b0123456789, or
  S-1-1-12-1234567890-123456789-123456789-1234   Email address: entity@domain.tld   Entity
  name: entity
- `organization_id`: The identifier for the organization under which the WorkMail entity
  exists.

"""
function deregister_from_work_mail(
    EntityId, OrganizationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "DeregisterFromWorkMail",
        Dict{String,Any}("EntityId" => EntityId, "OrganizationId" => OrganizationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function deregister_from_work_mail(
    EntityId,
    OrganizationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "DeregisterFromWorkMail",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EntityId" => EntityId, "OrganizationId" => OrganizationId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    deregister_mail_domain(domain_name, organization_id)
    deregister_mail_domain(domain_name, organization_id, params::Dict{String,<:Any})

Removes a domain from WorkMail, stops email routing to WorkMail, and removes the
authorization allowing WorkMail use. SES keeps the domain because other applications may
use it. You must first remove any email address used by WorkMail entities before you remove
the domain.

# Arguments
- `domain_name`: The domain to deregister in WorkMail and SES.
- `organization_id`: The WorkMail organization for which the domain will be deregistered.

"""
function deregister_mail_domain(
    DomainName, OrganizationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "DeregisterMailDomain",
        Dict{String,Any}("DomainName" => DomainName, "OrganizationId" => OrganizationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function deregister_mail_domain(
    DomainName,
    OrganizationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "DeregisterMailDomain",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DomainName" => DomainName, "OrganizationId" => OrganizationId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_email_monitoring_configuration(organization_id)
    describe_email_monitoring_configuration(organization_id, params::Dict{String,<:Any})

Describes the current email monitoring configuration for a specified organization.

# Arguments
- `organization_id`: The ID of the organization for which the email monitoring
  configuration is described.

"""
function describe_email_monitoring_configuration(
    OrganizationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "DescribeEmailMonitoringConfiguration",
        Dict{String,Any}("OrganizationId" => OrganizationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_email_monitoring_configuration(
    OrganizationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "DescribeEmailMonitoringConfiguration",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("OrganizationId" => OrganizationId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_entity(email, organization_id)
    describe_entity(email, organization_id, params::Dict{String,<:Any})

Returns basic details about an entity in WorkMail.

# Arguments
- `email`: The email under which the entity exists.
- `organization_id`: The identifier for the organization under which the entity exists.

"""
function describe_entity(
    Email, OrganizationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "DescribeEntity",
        Dict{String,Any}("Email" => Email, "OrganizationId" => OrganizationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_entity(
    Email,
    OrganizationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "DescribeEntity",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Email" => Email, "OrganizationId" => OrganizationId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_group(group_id, organization_id)
    describe_group(group_id, organization_id, params::Dict{String,<:Any})

Returns the data available for the group.

# Arguments
- `group_id`: The identifier for the group to be described. The identifier can accept
  GroupId, Groupname, or email. The following identity formats are available:   Group ID:
  12345678-1234-1234-1234-123456789012 or S-1-1-12-1234567890-123456789-123456789-1234
  Email address: group@domain.tld   Group name: group
- `organization_id`: The identifier for the organization under which the group exists.

"""
function describe_group(
    GroupId, OrganizationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "DescribeGroup",
        Dict{String,Any}("GroupId" => GroupId, "OrganizationId" => OrganizationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_group(
    GroupId,
    OrganizationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "DescribeGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("GroupId" => GroupId, "OrganizationId" => OrganizationId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_inbound_dmarc_settings(organization_id)
    describe_inbound_dmarc_settings(organization_id, params::Dict{String,<:Any})

Lists the settings in a DMARC policy for a specified organization.

# Arguments
- `organization_id`: Lists the ID of the given organization.

"""
function describe_inbound_dmarc_settings(
    OrganizationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "DescribeInboundDmarcSettings",
        Dict{String,Any}("OrganizationId" => OrganizationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_inbound_dmarc_settings(
    OrganizationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "DescribeInboundDmarcSettings",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("OrganizationId" => OrganizationId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_mailbox_export_job(job_id, organization_id)
    describe_mailbox_export_job(job_id, organization_id, params::Dict{String,<:Any})

Describes the current status of a mailbox export job.

# Arguments
- `job_id`: The mailbox export job ID.
- `organization_id`: The organization ID.

"""
function describe_mailbox_export_job(
    JobId, OrganizationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "DescribeMailboxExportJob",
        Dict{String,Any}("JobId" => JobId, "OrganizationId" => OrganizationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_mailbox_export_job(
    JobId,
    OrganizationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "DescribeMailboxExportJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("JobId" => JobId, "OrganizationId" => OrganizationId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_organization(organization_id)
    describe_organization(organization_id, params::Dict{String,<:Any})

Provides more information regarding a given organization based on its identifier.

# Arguments
- `organization_id`: The identifier for the organization to be described.

"""
function describe_organization(
    OrganizationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "DescribeOrganization",
        Dict{String,Any}("OrganizationId" => OrganizationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_organization(
    OrganizationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "DescribeOrganization",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("OrganizationId" => OrganizationId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_resource(organization_id, resource_id)
    describe_resource(organization_id, resource_id, params::Dict{String,<:Any})

Returns the data available for the resource.

# Arguments
- `organization_id`: The identifier associated with the organization for which the resource
  is described.
- `resource_id`: The identifier of the resource to be described. The identifier can accept
  ResourceId, Resourcename, or email. The following identity formats are available:
  Resource ID: r-0123456789a0123456789b0123456789   Email address: resource@domain.tld
  Resource name: resource

"""
function describe_resource(
    OrganizationId, ResourceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "DescribeResource",
        Dict{String,Any}("OrganizationId" => OrganizationId, "ResourceId" => ResourceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_resource(
    OrganizationId,
    ResourceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "DescribeResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "OrganizationId" => OrganizationId, "ResourceId" => ResourceId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_user(organization_id, user_id)
    describe_user(organization_id, user_id, params::Dict{String,<:Any})

Provides information regarding the user.

# Arguments
- `organization_id`: The identifier for the organization under which the user exists.
- `user_id`: The identifier for the user to be described. The identifier can be the UserId,
  Username, or email. The following identity formats are available:   User ID:
  12345678-1234-1234-1234-123456789012 or S-1-1-12-1234567890-123456789-123456789-1234
  Email address: user@domain.tld   User name: user

"""
function describe_user(
    OrganizationId, UserId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "DescribeUser",
        Dict{String,Any}("OrganizationId" => OrganizationId, "UserId" => UserId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_user(
    OrganizationId,
    UserId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "DescribeUser",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("OrganizationId" => OrganizationId, "UserId" => UserId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_delegate_from_resource(entity_id, organization_id, resource_id)
    disassociate_delegate_from_resource(entity_id, organization_id, resource_id, params::Dict{String,<:Any})

Removes a member from the resource's set of delegates.

# Arguments
- `entity_id`: The identifier for the member (user, group) to be removed from the
  resource's delegates. The entity ID can accept UserId or GroupID, Username or Groupname, or
  email.   Entity: 12345678-1234-1234-1234-123456789012 or
  S-1-1-12-1234567890-123456789-123456789-1234   Email address: entity@domain.tld   Entity:
  entity
- `organization_id`: The identifier for the organization under which the resource exists.
- `resource_id`: The identifier of the resource from which delegates' set members are
  removed.  The identifier can accept ResourceId, Resourcename, or email. The following
  identity formats are available:   Resource ID: r-0123456789a0123456789b0123456789   Email
  address: resource@domain.tld   Resource name: resource

"""
function disassociate_delegate_from_resource(
    EntityId, OrganizationId, ResourceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "DisassociateDelegateFromResource",
        Dict{String,Any}(
            "EntityId" => EntityId,
            "OrganizationId" => OrganizationId,
            "ResourceId" => ResourceId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_delegate_from_resource(
    EntityId,
    OrganizationId,
    ResourceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "DisassociateDelegateFromResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EntityId" => EntityId,
                    "OrganizationId" => OrganizationId,
                    "ResourceId" => ResourceId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_member_from_group(group_id, member_id, organization_id)
    disassociate_member_from_group(group_id, member_id, organization_id, params::Dict{String,<:Any})

Removes a member from a group.

# Arguments
- `group_id`: The identifier for the group from which members are removed. The identifier
  can accept GroupId, Groupname, or email. The following identity formats are available:
  Group ID: 12345678-1234-1234-1234-123456789012 or
  S-1-1-12-1234567890-123456789-123456789-1234   Email address: group@domain.tld   Group
  name: group
- `member_id`: The identifier for the member to be removed from the group. The member ID
  can accept UserID or GroupId, Username or Groupname, or email.   Member ID:
  12345678-1234-1234-1234-123456789012 or S-1-1-12-1234567890-123456789-123456789-1234
  Email address: member@domain.tld   Member name: member
- `organization_id`: The identifier for the organization under which the group exists.

"""
function disassociate_member_from_group(
    GroupId, MemberId, OrganizationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "DisassociateMemberFromGroup",
        Dict{String,Any}(
            "GroupId" => GroupId, "MemberId" => MemberId, "OrganizationId" => OrganizationId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_member_from_group(
    GroupId,
    MemberId,
    OrganizationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "DisassociateMemberFromGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "GroupId" => GroupId,
                    "MemberId" => MemberId,
                    "OrganizationId" => OrganizationId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_access_control_effect(action, ip_address, organization_id)
    get_access_control_effect(action, ip_address, organization_id, params::Dict{String,<:Any})

Gets the effects of an organization's access control rules as they apply to a specified
IPv4 address, access protocol action, and user ID or impersonation role ID. You must
provide either the user ID or impersonation role ID. Impersonation role ID can only be used
with Action EWS.

# Arguments
- `action`: The access protocol action. Valid values include ActiveSync, AutoDiscover, EWS,
  IMAP, SMTP, WindowsOutlook, and WebMail.
- `ip_address`: The IPv4 address.
- `organization_id`: The identifier for the organization.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ImpersonationRoleId"`: The impersonation role ID.
- `"UserId"`: The user ID.
"""
function get_access_control_effect(
    Action, IpAddress, OrganizationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "GetAccessControlEffect",
        Dict{String,Any}(
            "Action" => Action, "IpAddress" => IpAddress, "OrganizationId" => OrganizationId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_access_control_effect(
    Action,
    IpAddress,
    OrganizationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "GetAccessControlEffect",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Action" => Action,
                    "IpAddress" => IpAddress,
                    "OrganizationId" => OrganizationId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_default_retention_policy(organization_id)
    get_default_retention_policy(organization_id, params::Dict{String,<:Any})

Gets the default retention policy details for the specified organization.

# Arguments
- `organization_id`: The organization ID.

"""
function get_default_retention_policy(
    OrganizationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "GetDefaultRetentionPolicy",
        Dict{String,Any}("OrganizationId" => OrganizationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_default_retention_policy(
    OrganizationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "GetDefaultRetentionPolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("OrganizationId" => OrganizationId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_impersonation_role(impersonation_role_id, organization_id)
    get_impersonation_role(impersonation_role_id, organization_id, params::Dict{String,<:Any})

Gets the impersonation role details for the given WorkMail organization.

# Arguments
- `impersonation_role_id`: The impersonation role ID to retrieve.
- `organization_id`: The WorkMail organization from which to retrieve the impersonation
  role.

"""
function get_impersonation_role(
    ImpersonationRoleId, OrganizationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "GetImpersonationRole",
        Dict{String,Any}(
            "ImpersonationRoleId" => ImpersonationRoleId, "OrganizationId" => OrganizationId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_impersonation_role(
    ImpersonationRoleId,
    OrganizationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "GetImpersonationRole",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ImpersonationRoleId" => ImpersonationRoleId,
                    "OrganizationId" => OrganizationId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_impersonation_role_effect(impersonation_role_id, organization_id, target_user)
    get_impersonation_role_effect(impersonation_role_id, organization_id, target_user, params::Dict{String,<:Any})

Tests whether the given impersonation role can impersonate a target user.

# Arguments
- `impersonation_role_id`: The impersonation role ID to test.
- `organization_id`: The WorkMail organization where the impersonation role is defined.
- `target_user`: The WorkMail organization user chosen to test the impersonation role. The
  following identity formats are available:   User ID: 12345678-1234-1234-1234-123456789012
  or S-1-1-12-1234567890-123456789-123456789-1234    Email address: user@domain.tld    User
  name: user

"""
function get_impersonation_role_effect(
    ImpersonationRoleId,
    OrganizationId,
    TargetUser;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "GetImpersonationRoleEffect",
        Dict{String,Any}(
            "ImpersonationRoleId" => ImpersonationRoleId,
            "OrganizationId" => OrganizationId,
            "TargetUser" => TargetUser,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_impersonation_role_effect(
    ImpersonationRoleId,
    OrganizationId,
    TargetUser,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "GetImpersonationRoleEffect",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ImpersonationRoleId" => ImpersonationRoleId,
                    "OrganizationId" => OrganizationId,
                    "TargetUser" => TargetUser,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_mail_domain(domain_name, organization_id)
    get_mail_domain(domain_name, organization_id, params::Dict{String,<:Any})

Gets details for a mail domain, including domain records required to configure your domain
with recommended security.

# Arguments
- `domain_name`: The domain from which you want to retrieve details.
- `organization_id`: The WorkMail organization for which the domain is retrieved.

"""
function get_mail_domain(
    DomainName, OrganizationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "GetMailDomain",
        Dict{String,Any}("DomainName" => DomainName, "OrganizationId" => OrganizationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_mail_domain(
    DomainName,
    OrganizationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "GetMailDomain",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DomainName" => DomainName, "OrganizationId" => OrganizationId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_mailbox_details(organization_id, user_id)
    get_mailbox_details(organization_id, user_id, params::Dict{String,<:Any})

Requests a user's mailbox details for a specified organization and user.

# Arguments
- `organization_id`: The identifier for the organization that contains the user whose
  mailbox details are being requested.
- `user_id`: The identifier for the user whose mailbox details are being requested. The
  identifier can be the UserId, Username, or email. The following identity formats are
  available:   User ID: 12345678-1234-1234-1234-123456789012 or
  S-1-1-12-1234567890-123456789-123456789-1234   Email address: user@domain.tld   User name:
  user

"""
function get_mailbox_details(
    OrganizationId, UserId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "GetMailboxDetails",
        Dict{String,Any}("OrganizationId" => OrganizationId, "UserId" => UserId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_mailbox_details(
    OrganizationId,
    UserId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "GetMailboxDetails",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("OrganizationId" => OrganizationId, "UserId" => UserId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_mobile_device_access_effect(organization_id)
    get_mobile_device_access_effect(organization_id, params::Dict{String,<:Any})

Simulates the effect of the mobile device access rules for the given attributes of a sample
access event. Use this method to test the effects of the current set of mobile device
access rules for the WorkMail organization for a particular user's attributes.

# Arguments
- `organization_id`: The WorkMail organization to simulate the access effect for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DeviceModel"`: Device model the simulated user will report.
- `"DeviceOperatingSystem"`: Device operating system the simulated user will report.
- `"DeviceType"`: Device type the simulated user will report.
- `"DeviceUserAgent"`: Device user agent the simulated user will report.
"""
function get_mobile_device_access_effect(
    OrganizationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "GetMobileDeviceAccessEffect",
        Dict{String,Any}("OrganizationId" => OrganizationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_mobile_device_access_effect(
    OrganizationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "GetMobileDeviceAccessEffect",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("OrganizationId" => OrganizationId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_mobile_device_access_override(device_id, organization_id, user_id)
    get_mobile_device_access_override(device_id, organization_id, user_id, params::Dict{String,<:Any})

Gets the mobile device access override for the given WorkMail organization, user, and
device.

# Arguments
- `device_id`: The mobile device to which the override applies. DeviceId is case
  insensitive.
- `organization_id`: The WorkMail organization to which you want to apply the override.
- `user_id`: Identifies the WorkMail user for the override. Accepts the following types of
  user identities:    User ID: 12345678-1234-1234-1234-123456789012 or
  S-1-1-12-1234567890-123456789-123456789-1234    Email address: user@domain.tld    User
  name: user

"""
function get_mobile_device_access_override(
    DeviceId, OrganizationId, UserId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "GetMobileDeviceAccessOverride",
        Dict{String,Any}(
            "DeviceId" => DeviceId, "OrganizationId" => OrganizationId, "UserId" => UserId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_mobile_device_access_override(
    DeviceId,
    OrganizationId,
    UserId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "GetMobileDeviceAccessOverride",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DeviceId" => DeviceId,
                    "OrganizationId" => OrganizationId,
                    "UserId" => UserId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_access_control_rules(organization_id)
    list_access_control_rules(organization_id, params::Dict{String,<:Any})

Lists the access control rules for the specified organization.

# Arguments
- `organization_id`: The identifier for the organization.

"""
function list_access_control_rules(
    OrganizationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "ListAccessControlRules",
        Dict{String,Any}("OrganizationId" => OrganizationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_access_control_rules(
    OrganizationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "ListAccessControlRules",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("OrganizationId" => OrganizationId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_aliases(entity_id, organization_id)
    list_aliases(entity_id, organization_id, params::Dict{String,<:Any})

Creates a paginated call to list the aliases associated with a given entity.

# Arguments
- `entity_id`: The identifier for the entity for which to list the aliases.
- `organization_id`: The identifier for the organization under which the entity exists.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to return in a single call.
- `"NextToken"`: The token to use to retrieve the next page of results. The first call does
  not contain any tokens.
"""
function list_aliases(
    EntityId, OrganizationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "ListAliases",
        Dict{String,Any}("EntityId" => EntityId, "OrganizationId" => OrganizationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_aliases(
    EntityId,
    OrganizationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "ListAliases",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EntityId" => EntityId, "OrganizationId" => OrganizationId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_availability_configurations(organization_id)
    list_availability_configurations(organization_id, params::Dict{String,<:Any})

List all the AvailabilityConfiguration's for the given WorkMail organization.

# Arguments
- `organization_id`: The WorkMail organization for which the AvailabilityConfiguration's
  will be listed.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to return in a single call.
- `"NextToken"`: The token to use to retrieve the next page of results. The first call does
  not require a token.
"""
function list_availability_configurations(
    OrganizationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "ListAvailabilityConfigurations",
        Dict{String,Any}("OrganizationId" => OrganizationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_availability_configurations(
    OrganizationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "ListAvailabilityConfigurations",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("OrganizationId" => OrganizationId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_group_members(group_id, organization_id)
    list_group_members(group_id, organization_id, params::Dict{String,<:Any})

Returns an overview of the members of a group. Users and groups can be members of a group.

# Arguments
- `group_id`: The identifier for the group to which the members (users or groups) are
  associated. The identifier can accept GroupId, Groupname, or email. The following identity
  formats are available:   Group ID: 12345678-1234-1234-1234-123456789012 or
  S-1-1-12-1234567890-123456789-123456789-1234   Email address: group@domain.tld   Group
  name: group
- `organization_id`: The identifier for the organization under which the group exists.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to return in a single call.
- `"NextToken"`:  The token to use to retrieve the next page of results. The first call
  does not contain any tokens.
"""
function list_group_members(
    GroupId, OrganizationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "ListGroupMembers",
        Dict{String,Any}("GroupId" => GroupId, "OrganizationId" => OrganizationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_group_members(
    GroupId,
    OrganizationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "ListGroupMembers",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("GroupId" => GroupId, "OrganizationId" => OrganizationId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_groups(organization_id)
    list_groups(organization_id, params::Dict{String,<:Any})

Returns summaries of the organization's groups.

# Arguments
- `organization_id`: The identifier for the organization under which the groups exist.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: Limit the search results based on the filter criteria. Only one filter per
  request is supported.
- `"MaxResults"`: The maximum number of results to return in a single call.
- `"NextToken"`: The token to use to retrieve the next page of results. The first call does
  not contain any tokens.
"""
function list_groups(OrganizationId; aws_config::AbstractAWSConfig=current_aws_config())
    return workmail(
        "ListGroups",
        Dict{String,Any}("OrganizationId" => OrganizationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_groups(
    OrganizationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "ListGroups",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("OrganizationId" => OrganizationId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_groups_for_entity(entity_id, organization_id)
    list_groups_for_entity(entity_id, organization_id, params::Dict{String,<:Any})

Returns all the groups to which an entity belongs.

# Arguments
- `entity_id`: The identifier for the entity. The entity ID can accept UserId or GroupID,
  Username or Groupname, or email.   Entity ID: 12345678-1234-1234-1234-123456789012 or
  S-1-1-12-1234567890-123456789-123456789-1234   Email address: entity@domain.tld   Entity
  name: entity
- `organization_id`: The identifier for the organization under which the entity exists.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: Limit the search results based on the filter criteria.
- `"MaxResults"`: The maximum number of results to return in a single call.
- `"NextToken"`: The token to use to retrieve the next page of results. The first call does
  not contain any tokens.
"""
function list_groups_for_entity(
    EntityId, OrganizationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "ListGroupsForEntity",
        Dict{String,Any}("EntityId" => EntityId, "OrganizationId" => OrganizationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_groups_for_entity(
    EntityId,
    OrganizationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "ListGroupsForEntity",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EntityId" => EntityId, "OrganizationId" => OrganizationId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_impersonation_roles(organization_id)
    list_impersonation_roles(organization_id, params::Dict{String,<:Any})

Lists all the impersonation roles for the given WorkMail organization.

# Arguments
- `organization_id`: The WorkMail organization to which the listed impersonation roles
  belong.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results returned in a single call.
- `"NextToken"`: The token used to retrieve the next page of results. The first call
  doesn't require a token.
"""
function list_impersonation_roles(
    OrganizationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "ListImpersonationRoles",
        Dict{String,Any}("OrganizationId" => OrganizationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_impersonation_roles(
    OrganizationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "ListImpersonationRoles",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("OrganizationId" => OrganizationId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_mail_domains(organization_id)
    list_mail_domains(organization_id, params::Dict{String,<:Any})

Lists the mail domains in a given WorkMail organization.

# Arguments
- `organization_id`: The WorkMail organization for which to list domains.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to return in a single call.
- `"NextToken"`: The token to use to retrieve the next page of results. The first call does
  not require a token.
"""
function list_mail_domains(
    OrganizationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "ListMailDomains",
        Dict{String,Any}("OrganizationId" => OrganizationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_mail_domains(
    OrganizationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "ListMailDomains",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("OrganizationId" => OrganizationId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_mailbox_export_jobs(organization_id)
    list_mailbox_export_jobs(organization_id, params::Dict{String,<:Any})

Lists the mailbox export jobs started for the specified organization within the last seven
days.

# Arguments
- `organization_id`: The organization ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to return in a single call.
- `"NextToken"`: The token to use to retrieve the next page of results.
"""
function list_mailbox_export_jobs(
    OrganizationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "ListMailboxExportJobs",
        Dict{String,Any}("OrganizationId" => OrganizationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_mailbox_export_jobs(
    OrganizationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "ListMailboxExportJobs",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("OrganizationId" => OrganizationId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_mailbox_permissions(entity_id, organization_id)
    list_mailbox_permissions(entity_id, organization_id, params::Dict{String,<:Any})

Lists the mailbox permissions associated with a user, group, or resource mailbox.

# Arguments
- `entity_id`: The identifier of the user, or resource for which to list mailbox
  permissions. The entity ID can accept UserId or ResourceId, Username or Resourcename, or
  email.   Entity ID: 12345678-1234-1234-1234-123456789012, or
  r-0123456789a0123456789b0123456789   Email address: entity@domain.tld   Entity name: entity
  
- `organization_id`: The identifier of the organization under which the user, group, or
  resource exists.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to return in a single call.
- `"NextToken"`: The token to use to retrieve the next page of results. The first call does
  not contain any tokens.
"""
function list_mailbox_permissions(
    EntityId, OrganizationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "ListMailboxPermissions",
        Dict{String,Any}("EntityId" => EntityId, "OrganizationId" => OrganizationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_mailbox_permissions(
    EntityId,
    OrganizationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "ListMailboxPermissions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EntityId" => EntityId, "OrganizationId" => OrganizationId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_mobile_device_access_overrides(organization_id)
    list_mobile_device_access_overrides(organization_id, params::Dict{String,<:Any})

Lists all the mobile device access overrides for any given combination of WorkMail
organization, user, or device.

# Arguments
- `organization_id`: The WorkMail organization under which to list mobile device access
  overrides.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DeviceId"`: The mobile device to which the access override applies.
- `"MaxResults"`: The maximum number of results to return in a single call.
- `"NextToken"`: The token to use to retrieve the next page of results. The first call does
  not require a token.
- `"UserId"`: The WorkMail user under which you list the mobile device access overrides.
  Accepts the following types of user identities:   User ID:
  12345678-1234-1234-1234-123456789012 or S-1-1-12-1234567890-123456789-123456789-1234
  Email address: user@domain.tld    User name: user
"""
function list_mobile_device_access_overrides(
    OrganizationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "ListMobileDeviceAccessOverrides",
        Dict{String,Any}("OrganizationId" => OrganizationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_mobile_device_access_overrides(
    OrganizationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "ListMobileDeviceAccessOverrides",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("OrganizationId" => OrganizationId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_mobile_device_access_rules(organization_id)
    list_mobile_device_access_rules(organization_id, params::Dict{String,<:Any})

Lists the mobile device access rules for the specified WorkMail organization.

# Arguments
- `organization_id`: The WorkMail organization for which to list the rules.

"""
function list_mobile_device_access_rules(
    OrganizationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "ListMobileDeviceAccessRules",
        Dict{String,Any}("OrganizationId" => OrganizationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_mobile_device_access_rules(
    OrganizationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "ListMobileDeviceAccessRules",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("OrganizationId" => OrganizationId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_organizations()
    list_organizations(params::Dict{String,<:Any})

Returns summaries of the customer's organizations.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to return in a single call.
- `"NextToken"`: The token to use to retrieve the next page of results. The first call does
  not contain any tokens.
"""
function list_organizations(; aws_config::AbstractAWSConfig=current_aws_config())
    return workmail(
        "ListOrganizations"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_organizations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "ListOrganizations", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_resource_delegates(organization_id, resource_id)
    list_resource_delegates(organization_id, resource_id, params::Dict{String,<:Any})

Lists the delegates associated with a resource. Users and groups can be resource delegates
and answer requests on behalf of the resource.

# Arguments
- `organization_id`: The identifier for the organization that contains the resource for
  which delegates are listed.
- `resource_id`: The identifier for the resource whose delegates are listed. The identifier
  can accept ResourceId, Resourcename, or email. The following identity formats are
  available:   Resource ID: r-0123456789a0123456789b0123456789   Email address:
  resource@domain.tld   Resource name: resource

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The number of maximum results in a page.
- `"NextToken"`: The token used to paginate through the delegates associated with a
  resource.
"""
function list_resource_delegates(
    OrganizationId, ResourceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "ListResourceDelegates",
        Dict{String,Any}("OrganizationId" => OrganizationId, "ResourceId" => ResourceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_resource_delegates(
    OrganizationId,
    ResourceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "ListResourceDelegates",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "OrganizationId" => OrganizationId, "ResourceId" => ResourceId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_resources(organization_id)
    list_resources(organization_id, params::Dict{String,<:Any})

Returns summaries of the organization's resources.

# Arguments
- `organization_id`: The identifier for the organization under which the resources exist.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: Limit the resource search results based on the filter criteria. You can only
  use one filter per request.
- `"MaxResults"`: The maximum number of results to return in a single call.
- `"NextToken"`: The token to use to retrieve the next page of results. The first call does
  not contain any tokens.
"""
function list_resources(OrganizationId; aws_config::AbstractAWSConfig=current_aws_config())
    return workmail(
        "ListResources",
        Dict{String,Any}("OrganizationId" => OrganizationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_resources(
    OrganizationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "ListResources",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("OrganizationId" => OrganizationId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists the tags applied to an WorkMail organization resource.

# Arguments
- `resource_arn`: The resource ARN.

"""
function list_tags_for_resource(
    ResourceARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "ListTagsForResource",
        Dict{String,Any}("ResourceARN" => ResourceARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceARN" => ResourceARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_users(organization_id)
    list_users(organization_id, params::Dict{String,<:Any})

Returns summaries of the organization's users.

# Arguments
- `organization_id`: The identifier for the organization under which the users exist.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: Limit the user search results based on the filter criteria. You can only use
  one filter per request.
- `"MaxResults"`: The maximum number of results to return in a single call.
- `"NextToken"`: The token to use to retrieve the next page of results. The first call does
  not contain any tokens.
"""
function list_users(OrganizationId; aws_config::AbstractAWSConfig=current_aws_config())
    return workmail(
        "ListUsers",
        Dict{String,Any}("OrganizationId" => OrganizationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_users(
    OrganizationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "ListUsers",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("OrganizationId" => OrganizationId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_access_control_rule(description, effect, name, organization_id)
    put_access_control_rule(description, effect, name, organization_id, params::Dict{String,<:Any})

Adds a new access control rule for the specified organization. The rule allows or denies
access to the organization for the specified IPv4 addresses, access protocol actions, user
IDs and impersonation IDs. Adding a new rule with the same name as an existing rule
replaces the older rule.

# Arguments
- `description`: The rule description.
- `effect`: The rule effect.
- `name`: The rule name.
- `organization_id`: The identifier of the organization.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Actions"`: Access protocol actions to include in the rule. Valid values include
  ActiveSync, AutoDiscover, EWS, IMAP, SMTP, WindowsOutlook, and WebMail.
- `"ImpersonationRoleIds"`: Impersonation role IDs to include in the rule.
- `"IpRanges"`: IPv4 CIDR ranges to include in the rule.
- `"NotActions"`: Access protocol actions to exclude from the rule. Valid values include
  ActiveSync, AutoDiscover, EWS, IMAP, SMTP, WindowsOutlook, and WebMail.
- `"NotImpersonationRoleIds"`: Impersonation role IDs to exclude from the rule.
- `"NotIpRanges"`: IPv4 CIDR ranges to exclude from the rule.
- `"NotUserIds"`: User IDs to exclude from the rule.
- `"UserIds"`: User IDs to include in the rule.
"""
function put_access_control_rule(
    Description,
    Effect,
    Name,
    OrganizationId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "PutAccessControlRule",
        Dict{String,Any}(
            "Description" => Description,
            "Effect" => Effect,
            "Name" => Name,
            "OrganizationId" => OrganizationId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_access_control_rule(
    Description,
    Effect,
    Name,
    OrganizationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "PutAccessControlRule",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Description" => Description,
                    "Effect" => Effect,
                    "Name" => Name,
                    "OrganizationId" => OrganizationId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_email_monitoring_configuration(log_group_arn, organization_id, role_arn)
    put_email_monitoring_configuration(log_group_arn, organization_id, role_arn, params::Dict{String,<:Any})

Creates or updates the email monitoring configuration for a specified organization.

# Arguments
- `log_group_arn`: The Amazon Resource Name (ARN) of the CloudWatch Log group associated
  with the email monitoring configuration.
- `organization_id`: The ID of the organization for which the email monitoring
  configuration is set.
- `role_arn`: The Amazon Resource Name (ARN) of the IAM Role associated with the email
  monitoring configuration.

"""
function put_email_monitoring_configuration(
    LogGroupArn, OrganizationId, RoleArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "PutEmailMonitoringConfiguration",
        Dict{String,Any}(
            "LogGroupArn" => LogGroupArn,
            "OrganizationId" => OrganizationId,
            "RoleArn" => RoleArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_email_monitoring_configuration(
    LogGroupArn,
    OrganizationId,
    RoleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "PutEmailMonitoringConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "LogGroupArn" => LogGroupArn,
                    "OrganizationId" => OrganizationId,
                    "RoleArn" => RoleArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_inbound_dmarc_settings(enforced, organization_id)
    put_inbound_dmarc_settings(enforced, organization_id, params::Dict{String,<:Any})

Enables or disables a DMARC policy for a given organization.

# Arguments
- `enforced`: Enforces or suspends a policy after it's applied.
- `organization_id`: The ID of the organization that you are applying the DMARC policy to.

"""
function put_inbound_dmarc_settings(
    Enforced, OrganizationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "PutInboundDmarcSettings",
        Dict{String,Any}("Enforced" => Enforced, "OrganizationId" => OrganizationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_inbound_dmarc_settings(
    Enforced,
    OrganizationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "PutInboundDmarcSettings",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Enforced" => Enforced, "OrganizationId" => OrganizationId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_mailbox_permissions(entity_id, grantee_id, organization_id, permission_values)
    put_mailbox_permissions(entity_id, grantee_id, organization_id, permission_values, params::Dict{String,<:Any})

Sets permissions for a user, group, or resource. This replaces any pre-existing permissions.

# Arguments
- `entity_id`: The identifier of the user or resource for which to update mailbox
  permissions. The identifier can be UserId, ResourceID, or Group Id, Username, Resourcename,
  or Groupname, or email.   Entity ID: 12345678-1234-1234-1234-123456789012,
  r-0123456789a0123456789b0123456789, or S-1-1-12-1234567890-123456789-123456789-1234   Email
  address: entity@domain.tld   Entity name: entity
- `grantee_id`: The identifier of the user, group, or resource to which to grant the
  permissions. The identifier can be UserId, ResourceID, or Group Id, Username, Resourcename,
  or Groupname, or email.   Grantee ID: 12345678-1234-1234-1234-123456789012,
  r-0123456789a0123456789b0123456789, or S-1-1-12-1234567890-123456789-123456789-1234   Email
  address: grantee@domain.tld   Grantee name: grantee
- `organization_id`: The identifier of the organization under which the user, group, or
  resource exists.
- `permission_values`: The permissions granted to the grantee. SEND_AS allows the grantee
  to send email as the owner of the mailbox (the grantee is not mentioned on these emails).
  SEND_ON_BEHALF allows the grantee to send email on behalf of the owner of the mailbox (the
  grantee is not mentioned as the physical sender of these emails). FULL_ACCESS allows the
  grantee full access to the mailbox, irrespective of other folder-level permissions set on
  the mailbox.

"""
function put_mailbox_permissions(
    EntityId,
    GranteeId,
    OrganizationId,
    PermissionValues;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "PutMailboxPermissions",
        Dict{String,Any}(
            "EntityId" => EntityId,
            "GranteeId" => GranteeId,
            "OrganizationId" => OrganizationId,
            "PermissionValues" => PermissionValues,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_mailbox_permissions(
    EntityId,
    GranteeId,
    OrganizationId,
    PermissionValues,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "PutMailboxPermissions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EntityId" => EntityId,
                    "GranteeId" => GranteeId,
                    "OrganizationId" => OrganizationId,
                    "PermissionValues" => PermissionValues,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_mobile_device_access_override(device_id, effect, organization_id, user_id)
    put_mobile_device_access_override(device_id, effect, organization_id, user_id, params::Dict{String,<:Any})

Creates or updates a mobile device access override for the given WorkMail organization,
user, and device.

# Arguments
- `device_id`: The mobile device for which you create the override. DeviceId is case
  insensitive.
- `effect`: The effect of the override, ALLOW or DENY.
- `organization_id`: Identifies the WorkMail organization for which you create the override.
- `user_id`: The WorkMail user for which you create the override. Accepts the following
  types of user identities:   User ID: 12345678-1234-1234-1234-123456789012 or
  S-1-1-12-1234567890-123456789-123456789-1234    Email address: user@domain.tld    User
  name: user

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description of the override.
"""
function put_mobile_device_access_override(
    DeviceId,
    Effect,
    OrganizationId,
    UserId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "PutMobileDeviceAccessOverride",
        Dict{String,Any}(
            "DeviceId" => DeviceId,
            "Effect" => Effect,
            "OrganizationId" => OrganizationId,
            "UserId" => UserId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_mobile_device_access_override(
    DeviceId,
    Effect,
    OrganizationId,
    UserId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "PutMobileDeviceAccessOverride",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DeviceId" => DeviceId,
                    "Effect" => Effect,
                    "OrganizationId" => OrganizationId,
                    "UserId" => UserId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_retention_policy(folder_configurations, name, organization_id)
    put_retention_policy(folder_configurations, name, organization_id, params::Dict{String,<:Any})

Puts a retention policy to the specified organization.

# Arguments
- `folder_configurations`: The retention policy folder configurations.
- `name`: The retention policy name.
- `organization_id`: The organization ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: The retention policy description.
- `"Id"`: The retention policy ID.
"""
function put_retention_policy(
    FolderConfigurations,
    Name,
    OrganizationId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "PutRetentionPolicy",
        Dict{String,Any}(
            "FolderConfigurations" => FolderConfigurations,
            "Name" => Name,
            "OrganizationId" => OrganizationId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_retention_policy(
    FolderConfigurations,
    Name,
    OrganizationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "PutRetentionPolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "FolderConfigurations" => FolderConfigurations,
                    "Name" => Name,
                    "OrganizationId" => OrganizationId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    register_mail_domain(domain_name, organization_id)
    register_mail_domain(domain_name, organization_id, params::Dict{String,<:Any})

Registers a new domain in WorkMail and SES, and configures it for use by WorkMail. Emails
received by SES for this domain are routed to the specified WorkMail organization, and
WorkMail has permanent permission to use the specified domain for sending your users'
emails.

# Arguments
- `domain_name`: The name of the mail domain to create in WorkMail and SES.
- `organization_id`: The WorkMail organization under which you're creating the domain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: Idempotency token used when retrying requests.
"""
function register_mail_domain(
    DomainName, OrganizationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "RegisterMailDomain",
        Dict{String,Any}(
            "DomainName" => DomainName,
            "OrganizationId" => OrganizationId,
            "ClientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function register_mail_domain(
    DomainName,
    OrganizationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "RegisterMailDomain",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DomainName" => DomainName,
                    "OrganizationId" => OrganizationId,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    register_to_work_mail(email, entity_id, organization_id)
    register_to_work_mail(email, entity_id, organization_id, params::Dict{String,<:Any})

Registers an existing and disabled user, group, or resource for WorkMail use by associating
a mailbox and calendaring capabilities. It performs no change if the user, group, or
resource is enabled and fails if the user, group, or resource is deleted. This operation
results in the accumulation of costs. For more information, see Pricing. The equivalent
console functionality for this operation is Enable. Users can either be created by calling
the CreateUser API operation or they can be synchronized from your directory. For more
information, see DeregisterFromWorkMail.

# Arguments
- `email`: The email for the user, group, or resource to be updated.
- `entity_id`: The identifier for the user, group, or resource to be updated. The
  identifier can accept UserId, ResourceId, or GroupId, or Username, Resourcename, or
  Groupname. The following identity formats are available:   Entity ID:
  12345678-1234-1234-1234-123456789012, r-0123456789a0123456789b0123456789, or
  S-1-1-12-1234567890-123456789-123456789-1234   Entity name: entity
- `organization_id`: The identifier for the organization under which the user, group, or
  resource exists.

"""
function register_to_work_mail(
    Email, EntityId, OrganizationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "RegisterToWorkMail",
        Dict{String,Any}(
            "Email" => Email, "EntityId" => EntityId, "OrganizationId" => OrganizationId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function register_to_work_mail(
    Email,
    EntityId,
    OrganizationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "RegisterToWorkMail",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Email" => Email,
                    "EntityId" => EntityId,
                    "OrganizationId" => OrganizationId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    reset_password(organization_id, password, user_id)
    reset_password(organization_id, password, user_id, params::Dict{String,<:Any})

Allows the administrator to reset the password for a user.

# Arguments
- `organization_id`: The identifier of the organization that contains the user for which
  the password is reset.
- `password`: The new password for the user.
- `user_id`: The identifier of the user for whom the password is reset.

"""
function reset_password(
    OrganizationId, Password, UserId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "ResetPassword",
        Dict{String,Any}(
            "OrganizationId" => OrganizationId, "Password" => Password, "UserId" => UserId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function reset_password(
    OrganizationId,
    Password,
    UserId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "ResetPassword",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "OrganizationId" => OrganizationId,
                    "Password" => Password,
                    "UserId" => UserId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_mailbox_export_job(client_token, entity_id, kms_key_arn, organization_id, role_arn, s3_bucket_name, s3_prefix)
    start_mailbox_export_job(client_token, entity_id, kms_key_arn, organization_id, role_arn, s3_bucket_name, s3_prefix, params::Dict{String,<:Any})

Starts a mailbox export job to export MIME-format email messages and calendar items from
the specified mailbox to the specified Amazon Simple Storage Service (Amazon S3) bucket.
For more information, see Exporting mailbox content in the WorkMail Administrator Guide.

# Arguments
- `client_token`: The idempotency token for the client request.
- `entity_id`: The identifier of the user or resource associated with the mailbox. The
  identifier can accept UserId or ResourceId, Username or Resourcename, or email. The
  following identity formats are available:   Entity ID:
  12345678-1234-1234-1234-123456789012, r-0123456789a0123456789b0123456789 , or
  S-1-1-12-1234567890-123456789-123456789-1234   Email address: entity@domain.tld   Entity
  name: entity
- `kms_key_arn`: The Amazon Resource Name (ARN) of the symmetric AWS Key Management Service
  (AWS KMS) key that encrypts the exported mailbox content.
- `organization_id`: The identifier associated with the organization.
- `role_arn`: The ARN of the AWS Identity and Access Management (IAM) role that grants
  write permission to the S3 bucket.
- `s3_bucket_name`: The name of the S3 bucket.
- `s3_prefix`: The S3 bucket prefix.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: The mailbox export job description.
"""
function start_mailbox_export_job(
    ClientToken,
    EntityId,
    KmsKeyArn,
    OrganizationId,
    RoleArn,
    S3BucketName,
    S3Prefix;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "StartMailboxExportJob",
        Dict{String,Any}(
            "ClientToken" => ClientToken,
            "EntityId" => EntityId,
            "KmsKeyArn" => KmsKeyArn,
            "OrganizationId" => OrganizationId,
            "RoleArn" => RoleArn,
            "S3BucketName" => S3BucketName,
            "S3Prefix" => S3Prefix,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_mailbox_export_job(
    ClientToken,
    EntityId,
    KmsKeyArn,
    OrganizationId,
    RoleArn,
    S3BucketName,
    S3Prefix,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "StartMailboxExportJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClientToken" => ClientToken,
                    "EntityId" => EntityId,
                    "KmsKeyArn" => KmsKeyArn,
                    "OrganizationId" => OrganizationId,
                    "RoleArn" => RoleArn,
                    "S3BucketName" => S3BucketName,
                    "S3Prefix" => S3Prefix,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Applies the specified tags to the specified WorkMailorganization resource.

# Arguments
- `resource_arn`: The resource ARN.
- `tags`: The tag key-value pairs.

"""
function tag_resource(ResourceARN, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return workmail(
        "TagResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceARN,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    test_availability_configuration(organization_id)
    test_availability_configuration(organization_id, params::Dict{String,<:Any})

Performs a test on an availability provider to ensure that access is allowed. For EWS, it
verifies the provided credentials can be used to successfully log in. For Lambda, it
verifies that the Lambda function can be invoked and that the resource access policy was
configured to deny anonymous access. An anonymous invocation is one done without providing
either a SourceArn or SourceAccount header.  The request must contain either one provider
definition (EwsProvider or LambdaProvider) or the DomainName parameter. If the DomainName
parameter is provided, the configuration stored under the DomainName will be tested.

# Arguments
- `organization_id`: The WorkMail organization where the availability provider will be
  tested.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DomainName"`: The domain to which the provider applies. If this field is provided, a
  stored availability provider associated to this domain name will be tested.
- `"EwsProvider"`:
- `"LambdaProvider"`:
"""
function test_availability_configuration(
    OrganizationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "TestAvailabilityConfiguration",
        Dict{String,Any}("OrganizationId" => OrganizationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function test_availability_configuration(
    OrganizationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "TestAvailabilityConfiguration",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("OrganizationId" => OrganizationId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Untags the specified tags from the specified WorkMail organization resource.

# Arguments
- `resource_arn`: The resource ARN.
- `tag_keys`: The tag keys.

"""
function untag_resource(
    ResourceARN, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "UntagResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceARN,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_availability_configuration(domain_name, organization_id)
    update_availability_configuration(domain_name, organization_id, params::Dict{String,<:Any})

Updates an existing AvailabilityConfiguration for the given WorkMail organization and
domain.

# Arguments
- `domain_name`: The domain to which the provider applies the availability configuration.
- `organization_id`: The WorkMail organization for which the AvailabilityConfiguration will
  be updated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EwsProvider"`: The EWS availability provider definition. The request must contain
  exactly one provider definition, either EwsProvider or LambdaProvider. The previously
  stored provider will be overridden by the one provided.
- `"LambdaProvider"`: The Lambda availability provider definition. The request must contain
  exactly one provider definition, either EwsProvider or LambdaProvider. The previously
  stored provider will be overridden by the one provided.
"""
function update_availability_configuration(
    DomainName, OrganizationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "UpdateAvailabilityConfiguration",
        Dict{String,Any}("DomainName" => DomainName, "OrganizationId" => OrganizationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_availability_configuration(
    DomainName,
    OrganizationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "UpdateAvailabilityConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DomainName" => DomainName, "OrganizationId" => OrganizationId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_default_mail_domain(domain_name, organization_id)
    update_default_mail_domain(domain_name, organization_id, params::Dict{String,<:Any})

Updates the default mail domain for an organization. The default mail domain is used by the
WorkMail AWS Console to suggest an email address when enabling a mail user. You can only
have one default domain.

# Arguments
- `domain_name`: The domain name that will become the default domain.
- `organization_id`: The WorkMail organization for which to list domains.

"""
function update_default_mail_domain(
    DomainName, OrganizationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "UpdateDefaultMailDomain",
        Dict{String,Any}("DomainName" => DomainName, "OrganizationId" => OrganizationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_default_mail_domain(
    DomainName,
    OrganizationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "UpdateDefaultMailDomain",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DomainName" => DomainName, "OrganizationId" => OrganizationId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_group(group_id, organization_id)
    update_group(group_id, organization_id, params::Dict{String,<:Any})

Updates attibutes in a group.

# Arguments
- `group_id`: The identifier for the group to be updated. The identifier can accept
  GroupId, Groupname, or email. The following identity formats are available:   Group ID:
  12345678-1234-1234-1234-123456789012 or S-1-1-12-1234567890-123456789-123456789-1234
  Email address: group@domain.tld   Group name: group
- `organization_id`: The identifier for the organization under which the group exists.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"HiddenFromGlobalAddressList"`: If enabled, the group is hidden from the global address
  list.
"""
function update_group(
    GroupId, OrganizationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "UpdateGroup",
        Dict{String,Any}("GroupId" => GroupId, "OrganizationId" => OrganizationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_group(
    GroupId,
    OrganizationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "UpdateGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("GroupId" => GroupId, "OrganizationId" => OrganizationId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_impersonation_role(impersonation_role_id, name, organization_id, rules, type)
    update_impersonation_role(impersonation_role_id, name, organization_id, rules, type, params::Dict{String,<:Any})

Updates an impersonation role for the given WorkMail organization.

# Arguments
- `impersonation_role_id`: The ID of the impersonation role to update.
- `name`: The updated impersonation role name.
- `organization_id`: The WorkMail organization that contains the impersonation role to
  update.
- `rules`: The updated list of rules.
- `type`: The updated impersonation role type.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: The updated impersonation role description.
"""
function update_impersonation_role(
    ImpersonationRoleId,
    Name,
    OrganizationId,
    Rules,
    Type;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "UpdateImpersonationRole",
        Dict{String,Any}(
            "ImpersonationRoleId" => ImpersonationRoleId,
            "Name" => Name,
            "OrganizationId" => OrganizationId,
            "Rules" => Rules,
            "Type" => Type,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_impersonation_role(
    ImpersonationRoleId,
    Name,
    OrganizationId,
    Rules,
    Type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "UpdateImpersonationRole",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ImpersonationRoleId" => ImpersonationRoleId,
                    "Name" => Name,
                    "OrganizationId" => OrganizationId,
                    "Rules" => Rules,
                    "Type" => Type,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_mailbox_quota(mailbox_quota, organization_id, user_id)
    update_mailbox_quota(mailbox_quota, organization_id, user_id, params::Dict{String,<:Any})

Updates a user's current mailbox quota for a specified organization and user.

# Arguments
- `mailbox_quota`: The updated mailbox quota, in MB, for the specified user.
- `organization_id`: The identifier for the organization that contains the user for whom to
  update the mailbox quota.
- `user_id`: The identifer for the user for whom to update the mailbox quota. The
  identifier can be the UserId, Username, or email. The following identity formats are
  available:   User ID: 12345678-1234-1234-1234-123456789012 or
  S-1-1-12-1234567890-123456789-123456789-1234   Email address: user@domain.tld   User name:
  user

"""
function update_mailbox_quota(
    MailboxQuota, OrganizationId, UserId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "UpdateMailboxQuota",
        Dict{String,Any}(
            "MailboxQuota" => MailboxQuota,
            "OrganizationId" => OrganizationId,
            "UserId" => UserId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_mailbox_quota(
    MailboxQuota,
    OrganizationId,
    UserId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "UpdateMailboxQuota",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "MailboxQuota" => MailboxQuota,
                    "OrganizationId" => OrganizationId,
                    "UserId" => UserId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_mobile_device_access_rule(effect, mobile_device_access_rule_id, name, organization_id)
    update_mobile_device_access_rule(effect, mobile_device_access_rule_id, name, organization_id, params::Dict{String,<:Any})

Updates a mobile device access rule for the specified WorkMail organization.

# Arguments
- `effect`: The effect of the rule when it matches. Allowed values are ALLOW or DENY.
- `mobile_device_access_rule_id`: The identifier of the rule to be updated.
- `name`: The updated rule name.
- `organization_id`: The WorkMail organization under which the rule will be updated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: The updated rule description.
- `"DeviceModels"`: Device models that the updated rule will match.
- `"DeviceOperatingSystems"`: Device operating systems that the updated rule will match.
- `"DeviceTypes"`: Device types that the updated rule will match.
- `"DeviceUserAgents"`: User agents that the updated rule will match.
- `"NotDeviceModels"`: Device models that the updated rule will not match. All other device
  models will match.
- `"NotDeviceOperatingSystems"`: Device operating systems that the updated rule will not
  match. All other device operating systems will match.
- `"NotDeviceTypes"`: Device types that the updated rule will not match. All other device
  types will match.
- `"NotDeviceUserAgents"`: User agents that the updated rule will not match. All other user
  agents will match.
"""
function update_mobile_device_access_rule(
    Effect,
    MobileDeviceAccessRuleId,
    Name,
    OrganizationId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "UpdateMobileDeviceAccessRule",
        Dict{String,Any}(
            "Effect" => Effect,
            "MobileDeviceAccessRuleId" => MobileDeviceAccessRuleId,
            "Name" => Name,
            "OrganizationId" => OrganizationId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_mobile_device_access_rule(
    Effect,
    MobileDeviceAccessRuleId,
    Name,
    OrganizationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "UpdateMobileDeviceAccessRule",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Effect" => Effect,
                    "MobileDeviceAccessRuleId" => MobileDeviceAccessRuleId,
                    "Name" => Name,
                    "OrganizationId" => OrganizationId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_primary_email_address(email, entity_id, organization_id)
    update_primary_email_address(email, entity_id, organization_id, params::Dict{String,<:Any})

Updates the primary email for a user, group, or resource. The current email is moved into
the list of aliases (or swapped between an existing alias and the current primary email),
and the email provided in the input is promoted as the primary.

# Arguments
- `email`: The value of the email to be updated as primary.
- `entity_id`: The user, group, or resource to update. The identifier can accept UseriD,
  ResourceId, or GroupId, Username, Resourcename, or Groupname, or email. The following
  identity formats are available:   Entity ID: 12345678-1234-1234-1234-123456789012,
  r-0123456789a0123456789b0123456789, or S-1-1-12-1234567890-123456789-123456789-1234   Email
  address: entity@domain.tld   Entity name: entity
- `organization_id`: The organization that contains the user, group, or resource to update.

"""
function update_primary_email_address(
    Email, EntityId, OrganizationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "UpdatePrimaryEmailAddress",
        Dict{String,Any}(
            "Email" => Email, "EntityId" => EntityId, "OrganizationId" => OrganizationId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_primary_email_address(
    Email,
    EntityId,
    OrganizationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "UpdatePrimaryEmailAddress",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Email" => Email,
                    "EntityId" => EntityId,
                    "OrganizationId" => OrganizationId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_resource(organization_id, resource_id)
    update_resource(organization_id, resource_id, params::Dict{String,<:Any})

Updates data for the resource. To have the latest information, it must be preceded by a
DescribeResource call. The dataset in the request should be the one expected when
performing another DescribeResource call.

# Arguments
- `organization_id`: The identifier associated with the organization for which the resource
  is updated.
- `resource_id`: The identifier of the resource to be updated. The identifier can accept
  ResourceId, Resourcename, or email. The following identity formats are available:
  Resource ID: r-0123456789a0123456789b0123456789   Email address: resource@domain.tld
  Resource name: resource

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"BookingOptions"`: The resource's booking options to be updated.
- `"Description"`: Updates the resource description.
- `"HiddenFromGlobalAddressList"`: If enabled, the resource is hidden from the global
  address list.
- `"Name"`: The name of the resource to be updated.
- `"Type"`: Updates the resource type.
"""
function update_resource(
    OrganizationId, ResourceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "UpdateResource",
        Dict{String,Any}("OrganizationId" => OrganizationId, "ResourceId" => ResourceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_resource(
    OrganizationId,
    ResourceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "UpdateResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "OrganizationId" => OrganizationId, "ResourceId" => ResourceId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_user(organization_id, user_id)
    update_user(organization_id, user_id, params::Dict{String,<:Any})

Updates data for the user. To have the latest information, it must be preceded by a
DescribeUser call. The dataset in the request should be the one expected when performing
another DescribeUser call.

# Arguments
- `organization_id`: The identifier for the organization under which the user exists.
- `user_id`: The identifier for the user to be updated. The identifier can be the UserId,
  Username, or email. The following identity formats are available:   User ID:
  12345678-1234-1234-1234-123456789012 or S-1-1-12-1234567890-123456789-123456789-1234
  Email address: user@domain.tld   User name: user

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"City"`: Updates the user's city.
- `"Company"`: Updates the user's company.
- `"Country"`: Updates the user's country.
- `"Department"`: Updates the user's department.
- `"DisplayName"`: Updates the display name of the user.
- `"FirstName"`: Updates the user's first name.
- `"HiddenFromGlobalAddressList"`: If enabled, the user is hidden from the global address
  list.
- `"Initials"`: Updates the user's initials.
- `"JobTitle"`: Updates the user's job title.
- `"LastName"`: Updates the user's last name.
- `"Office"`: Updates the user's office.
- `"Role"`: Updates the user role. You cannot pass SYSTEM_USER or RESOURCE.
- `"Street"`: Updates the user's street address.
- `"Telephone"`: Updates the user's contact details.
- `"ZipCode"`: Updates the user's zipcode.
"""
function update_user(
    OrganizationId, UserId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return workmail(
        "UpdateUser",
        Dict{String,Any}("OrganizationId" => OrganizationId, "UserId" => UserId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_user(
    OrganizationId,
    UserId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return workmail(
        "UpdateUser",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("OrganizationId" => OrganizationId, "UserId" => UserId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: cloud9
using AWS.Compat
using AWS.UUIDs

"""
    create_environment_ec2(image_id, instance_type, name)
    create_environment_ec2(image_id, instance_type, name, params::Dict{String,<:Any})

Creates an Cloud9 development environment, launches an Amazon Elastic Compute Cloud (Amazon
EC2) instance, and then connects from the instance to the environment.

# Arguments
- `image_id`: The identifier for the Amazon Machine Image (AMI) that's used to create the
  EC2 instance. To choose an AMI for the instance, you must specify a valid AMI alias or a
  valid Amazon EC2 Systems Manager (SSM) path. From December 04, 2023, you will be required
  to include the imageId parameter for the CreateEnvironmentEC2 action. This change will be
  reflected across all direct methods of communicating with the API, such as Amazon Web
  Services SDK, Amazon Web Services CLI and Amazon Web Services CloudFormation. This change
  will only affect direct API consumers, and not Cloud9 console users. We recommend using
  Amazon Linux 2023 as the AMI to create your environment as it is fully supported.  Since
  Ubuntu 18.04 has ended standard support as of May 31, 2023, we recommend you choose Ubuntu
  22.04.  AMI aliases     Amazon Linux 2: amazonlinux-2-x86_64    Amazon Linux 2023
  (recommended): amazonlinux-2023-x86_64    Ubuntu 18.04: ubuntu-18.04-x86_64    Ubuntu
  22.04: ubuntu-22.04-x86_64     SSM paths    Amazon Linux 2:
  resolve:ssm:/aws/service/cloud9/amis/amazonlinux-2-x86_64    Amazon Linux 2023
  (recommended): resolve:ssm:/aws/service/cloud9/amis/amazonlinux-2023-x86_64    Ubuntu
  18.04: resolve:ssm:/aws/service/cloud9/amis/ubuntu-18.04-x86_64    Ubuntu 22.04:
  resolve:ssm:/aws/service/cloud9/amis/ubuntu-22.04-x86_64
- `instance_type`: The type of instance to connect to the environment (for example,
  t2.micro).
- `name`: The name of the environment to create. This name is visible to other IAM users in
  the same Amazon Web Services account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"automaticStopTimeMinutes"`: The number of minutes until the running instance is shut
  down after the environment has last been used.
- `"clientRequestToken"`: A unique, case-sensitive string that helps Cloud9 to ensure this
  operation completes no more than one time. For more information, see Client Tokens in the
  Amazon EC2 API Reference.
- `"connectionType"`: The connection type used for connecting to an Amazon EC2 environment.
  Valid values are CONNECT_SSH (default) and CONNECT_SSM (connected through Amazon EC2
  Systems Manager). For more information, see Accessing no-ingress EC2 instances with Amazon
  EC2 Systems Manager in the Cloud9 User Guide.
- `"description"`: The description of the environment to create.
- `"dryRun"`: Checks whether you have the required permissions for the action, without
  actually making the request, and provides an error response. If you have the required
  permissions, the error response is DryRunOperation. Otherwise, it is UnauthorizedOperation.
- `"ownerArn"`: The Amazon Resource Name (ARN) of the environment owner. This ARN can be
  the ARN of any IAM principal. If this value is not specified, the ARN defaults to this
  environment's creator.
- `"subnetId"`: The ID of the subnet in Amazon VPC that Cloud9 will use to communicate with
  the Amazon EC2 instance.
- `"tags"`: An array of key-value pairs that will be associated with the new Cloud9
  development environment.
"""
function create_environment_ec2(
    imageId, instanceType, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloud9(
        "CreateEnvironmentEC2",
        Dict{String,Any}(
            "imageId" => imageId, "instanceType" => instanceType, "name" => name
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_environment_ec2(
    imageId,
    instanceType,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloud9(
        "CreateEnvironmentEC2",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "imageId" => imageId, "instanceType" => instanceType, "name" => name
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_environment_membership(environment_id, permissions, user_arn)
    create_environment_membership(environment_id, permissions, user_arn, params::Dict{String,<:Any})

Adds an environment member to an Cloud9 development environment.

# Arguments
- `environment_id`: The ID of the environment that contains the environment member you want
  to add.
- `permissions`: The type of environment member permissions you want to associate with this
  environment member. Available values include:    read-only: Has read-only access to the
  environment.    read-write: Has read-write access to the environment.
- `user_arn`: The Amazon Resource Name (ARN) of the environment member you want to add.

"""
function create_environment_membership(
    environmentId, permissions, userArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloud9(
        "CreateEnvironmentMembership",
        Dict{String,Any}(
            "environmentId" => environmentId,
            "permissions" => permissions,
            "userArn" => userArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_environment_membership(
    environmentId,
    permissions,
    userArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloud9(
        "CreateEnvironmentMembership",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "environmentId" => environmentId,
                    "permissions" => permissions,
                    "userArn" => userArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_environment(environment_id)
    delete_environment(environment_id, params::Dict{String,<:Any})

Deletes an Cloud9 development environment. If an Amazon EC2 instance is connected to the
environment, also terminates the instance.

# Arguments
- `environment_id`: The ID of the environment to delete.

"""
function delete_environment(
    environmentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloud9(
        "DeleteEnvironment",
        Dict{String,Any}("environmentId" => environmentId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_environment(
    environmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloud9(
        "DeleteEnvironment",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("environmentId" => environmentId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_environment_membership(environment_id, user_arn)
    delete_environment_membership(environment_id, user_arn, params::Dict{String,<:Any})

Deletes an environment member from a development environment.

# Arguments
- `environment_id`: The ID of the environment to delete the environment member from.
- `user_arn`: The Amazon Resource Name (ARN) of the environment member to delete from the
  environment.

"""
function delete_environment_membership(
    environmentId, userArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloud9(
        "DeleteEnvironmentMembership",
        Dict{String,Any}("environmentId" => environmentId, "userArn" => userArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_environment_membership(
    environmentId,
    userArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloud9(
        "DeleteEnvironmentMembership",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("environmentId" => environmentId, "userArn" => userArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_environment_memberships()
    describe_environment_memberships(params::Dict{String,<:Any})

Gets information about environment members for an Cloud9 development environment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"environmentId"`: The ID of the environment to get environment member information about.
- `"maxResults"`: The maximum number of environment members to get information about.
- `"nextToken"`: During a previous call, if there are more than 25 items in the list, only
  the first 25 items are returned, along with a unique string called a next token. To get the
  next batch of items in the list, call this operation again, adding the next token to the
  call. To get all of the items in the list, keep calling this operation with each subsequent
  next token that is returned, until no more next tokens are returned.
- `"permissions"`: The type of environment member permissions to get information about.
  Available values include:    owner: Owns the environment.    read-only: Has read-only
  access to the environment.    read-write: Has read-write access to the environment.   If no
  value is specified, information about all environment members are returned.
- `"userArn"`: The Amazon Resource Name (ARN) of an individual environment member to get
  information about. If no value is specified, information about all environment members are
  returned.
"""
function describe_environment_memberships(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloud9(
        "DescribeEnvironmentMemberships";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_environment_memberships(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloud9(
        "DescribeEnvironmentMemberships",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_environment_status(environment_id)
    describe_environment_status(environment_id, params::Dict{String,<:Any})

Gets status information for an Cloud9 development environment.

# Arguments
- `environment_id`: The ID of the environment to get status information about.

"""
function describe_environment_status(
    environmentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloud9(
        "DescribeEnvironmentStatus",
        Dict{String,Any}("environmentId" => environmentId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_environment_status(
    environmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloud9(
        "DescribeEnvironmentStatus",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("environmentId" => environmentId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_environments(environment_ids)
    describe_environments(environment_ids, params::Dict{String,<:Any})

Gets information about Cloud9 development environments.

# Arguments
- `environment_ids`: The IDs of individual environments to get information about.

"""
function describe_environments(
    environmentIds; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloud9(
        "DescribeEnvironments",
        Dict{String,Any}("environmentIds" => environmentIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_environments(
    environmentIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloud9(
        "DescribeEnvironments",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("environmentIds" => environmentIds), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_environments()
    list_environments(params::Dict{String,<:Any})

Gets a list of Cloud9 development environment identifiers.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of environments to get identifiers for.
- `"nextToken"`: During a previous call, if there are more than 25 items in the list, only
  the first 25 items are returned, along with a unique string called a next token. To get the
  next batch of items in the list, call this operation again, adding the next token to the
  call. To get all of the items in the list, keep calling this operation with each subsequent
  next token that is returned, until no more next tokens are returned.
"""
function list_environments(; aws_config::AbstractAWSConfig=current_aws_config())
    return cloud9(
        "ListEnvironments"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_environments(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloud9(
        "ListEnvironments", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Gets a list of the tags associated with an Cloud9 development environment.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the Cloud9 development environment to
  get the tags for.

"""
function list_tags_for_resource(
    ResourceARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloud9(
        "ListTagsForResource",
        Dict{String,Any}("ResourceARN" => ResourceARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloud9(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceARN" => ResourceARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds tags to an Cloud9 development environment.  Tags that you add to an Cloud9 environment
by using this method will NOT be automatically propagated to underlying resources.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the Cloud9 development environment to
  add tags to.
- `tags`: The list of tags to add to the given Cloud9 development environment.

"""
function tag_resource(ResourceARN, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return cloud9(
        "TagResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceARN,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloud9(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes tags from an Cloud9 development environment.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the Cloud9 development environment to
  remove tags from.
- `tag_keys`: The tag names of the tags to remove from the given Cloud9 development
  environment.

"""
function untag_resource(
    ResourceARN, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloud9(
        "UntagResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceARN,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloud9(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_environment(environment_id)
    update_environment(environment_id, params::Dict{String,<:Any})

Changes the settings of an existing Cloud9 development environment.

# Arguments
- `environment_id`: The ID of the environment to change settings.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: Any new or replacement description for the environment.
- `"managedCredentialsAction"`: Allows the environment owner to turn on or turn off the
  Amazon Web Services managed temporary credentials for an Cloud9 environment by using one of
  the following values:    ENABLE     DISABLE     Only the environment owner can change the
  status of managed temporary credentials. An AccessDeniedException is thrown if an attempt
  to turn on or turn off managed temporary credentials is made by an account that's not the
  environment owner.
- `"name"`: A replacement name for the environment.
"""
function update_environment(
    environmentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloud9(
        "UpdateEnvironment",
        Dict{String,Any}("environmentId" => environmentId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_environment(
    environmentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloud9(
        "UpdateEnvironment",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("environmentId" => environmentId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_environment_membership(environment_id, permissions, user_arn)
    update_environment_membership(environment_id, permissions, user_arn, params::Dict{String,<:Any})

Changes the settings of an existing environment member for an Cloud9 development
environment.

# Arguments
- `environment_id`: The ID of the environment for the environment member whose settings you
  want to change.
- `permissions`: The replacement type of environment member permissions you want to
  associate with this environment member. Available values include:    read-only: Has
  read-only access to the environment.    read-write: Has read-write access to the
  environment.
- `user_arn`: The Amazon Resource Name (ARN) of the environment member whose settings you
  want to change.

"""
function update_environment_membership(
    environmentId, permissions, userArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloud9(
        "UpdateEnvironmentMembership",
        Dict{String,Any}(
            "environmentId" => environmentId,
            "permissions" => permissions,
            "userArn" => userArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_environment_membership(
    environmentId,
    permissions,
    userArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloud9(
        "UpdateEnvironmentMembership",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "environmentId" => environmentId,
                    "permissions" => permissions,
                    "userArn" => userArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: qldb
using AWS.Compat
using AWS.UUIDs

"""
    cancel_journal_kinesis_stream(name, stream_id)
    cancel_journal_kinesis_stream(name, stream_id, params::Dict{String,<:Any})

Ends a given Amazon QLDB journal stream. Before a stream can be canceled, its current
status must be ACTIVE. You can't restart a stream after you cancel it. Canceled QLDB stream
resources are subject to a 7-day retention period, so they are automatically deleted after
this limit expires.

# Arguments
- `name`: The name of the ledger.
- `stream_id`: The UUID (represented in Base62-encoded text) of the QLDB journal stream to
  be canceled.

"""
function cancel_journal_kinesis_stream(
    name, streamId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qldb(
        "DELETE",
        "/ledgers/$(name)/journal-kinesis-streams/$(streamId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_journal_kinesis_stream(
    name,
    streamId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qldb(
        "DELETE",
        "/ledgers/$(name)/journal-kinesis-streams/$(streamId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_ledger(name, permissions_mode)
    create_ledger(name, permissions_mode, params::Dict{String,<:Any})

Creates a new ledger in your Amazon Web Services account in the current Region.

# Arguments
- `name`: The name of the ledger that you want to create. The name must be unique among all
  of the ledgers in your Amazon Web Services account in the current Region. Naming
  constraints for ledger names are defined in Quotas in Amazon QLDB in the Amazon QLDB
  Developer Guide.
- `permissions_mode`: The permissions mode to assign to the ledger that you want to create.
  This parameter can have one of the following values:    ALLOW_ALL: A legacy permissions
  mode that enables access control with API-level granularity for ledgers. This mode allows
  users who have the SendCommand API permission for this ledger to run all PartiQL commands
  (hence, ALLOW_ALL) on any tables in the specified ledger. This mode disregards any
  table-level or command-level IAM permissions policies that you create for the ledger.
  STANDARD: (Recommended) A permissions mode that enables access control with finer
  granularity for ledgers, tables, and PartiQL commands. By default, this mode denies all
  user requests to run any PartiQL commands on any tables in this ledger. To allow PartiQL
  commands to run, you must create IAM permissions policies for specific table resources and
  PartiQL actions, in addition to the SendCommand API permission for the ledger. For
  information, see Getting started with the standard permissions mode in the Amazon QLDB
  Developer Guide.    We strongly recommend using the STANDARD permissions mode to maximize
  the security of your ledger data.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DeletionProtection"`: Specifies whether the ledger is protected from being deleted by
  any user. If not defined during ledger creation, this feature is enabled (true) by default.
  If deletion protection is enabled, you must first disable it before you can delete the
  ledger. You can disable it by calling the UpdateLedger operation to set this parameter to
  false.
- `"KmsKey"`: The key in Key Management Service (KMS) to use for encryption of data at rest
  in the ledger. For more information, see Encryption at rest in the Amazon QLDB Developer
  Guide. Use one of the following options to specify this parameter:    AWS_OWNED_KMS_KEY:
  Use an KMS key that is owned and managed by Amazon Web Services on your behalf.
  Undefined: By default, use an Amazon Web Services owned KMS key.    A valid symmetric
  customer managed KMS key: Use the specified symmetric encryption KMS key in your account
  that you create, own, and manage. Amazon QLDB does not support asymmetric keys. For more
  information, see Using symmetric and asymmetric keys in the Key Management Service
  Developer Guide.   To specify a customer managed KMS key, you can use its key ID, Amazon
  Resource Name (ARN), alias name, or alias ARN. When using an alias name, prefix it with
  \"alias/\". To specify a key in a different Amazon Web Services account, you must use the
  key ARN or alias ARN. For example:   Key ID: 1234abcd-12ab-34cd-56ef-1234567890ab    Key
  ARN: arn:aws:kms:us-east-2:111122223333:key/1234abcd-12ab-34cd-56ef-1234567890ab    Alias
  name: alias/ExampleAlias    Alias ARN:
  arn:aws:kms:us-east-2:111122223333:alias/ExampleAlias    For more information, see Key
  identifiers (KeyId) in the Key Management Service Developer Guide.
- `"Tags"`: The key-value pairs to add as tags to the ledger that you want to create. Tag
  keys are case sensitive. Tag values are case sensitive and can be null.
"""
function create_ledger(
    Name, PermissionsMode; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qldb(
        "POST",
        "/ledgers",
        Dict{String,Any}("Name" => Name, "PermissionsMode" => PermissionsMode);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_ledger(
    Name,
    PermissionsMode,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qldb(
        "POST",
        "/ledgers",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Name" => Name, "PermissionsMode" => PermissionsMode),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_ledger(name)
    delete_ledger(name, params::Dict{String,<:Any})

Deletes a ledger and all of its contents. This action is irreversible. If deletion
protection is enabled, you must first disable it before you can delete the ledger. You can
disable it by calling the UpdateLedger operation to set this parameter to false.

# Arguments
- `name`: The name of the ledger that you want to delete.

"""
function delete_ledger(name; aws_config::AbstractAWSConfig=current_aws_config())
    return qldb(
        "DELETE", "/ledgers/$(name)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function delete_ledger(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qldb(
        "DELETE",
        "/ledgers/$(name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_journal_kinesis_stream(name, stream_id)
    describe_journal_kinesis_stream(name, stream_id, params::Dict{String,<:Any})

Returns detailed information about a given Amazon QLDB journal stream. The output includes
the Amazon Resource Name (ARN), stream name, current status, creation time, and the
parameters of the original stream creation request. This action does not return any expired
journal streams. For more information, see Expiration for terminal streams in the Amazon
QLDB Developer Guide.

# Arguments
- `name`: The name of the ledger.
- `stream_id`: The UUID (represented in Base62-encoded text) of the QLDB journal stream to
  describe.

"""
function describe_journal_kinesis_stream(
    name, streamId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qldb(
        "GET",
        "/ledgers/$(name)/journal-kinesis-streams/$(streamId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_journal_kinesis_stream(
    name,
    streamId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qldb(
        "GET",
        "/ledgers/$(name)/journal-kinesis-streams/$(streamId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_journal_s3_export(export_id, name)
    describe_journal_s3_export(export_id, name, params::Dict{String,<:Any})

Returns information about a journal export job, including the ledger name, export ID,
creation time, current status, and the parameters of the original export creation request.
This action does not return any expired export jobs. For more information, see Export job
expiration in the Amazon QLDB Developer Guide. If the export job with the given ExportId
doesn't exist, then throws ResourceNotFoundException. If the ledger with the given Name
doesn't exist, then throws ResourceNotFoundException.

# Arguments
- `export_id`: The UUID (represented in Base62-encoded text) of the journal export job to
  describe.
- `name`: The name of the ledger.

"""
function describe_journal_s3_export(
    exportId, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qldb(
        "GET",
        "/ledgers/$(name)/journal-s3-exports/$(exportId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_journal_s3_export(
    exportId,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qldb(
        "GET",
        "/ledgers/$(name)/journal-s3-exports/$(exportId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_ledger(name)
    describe_ledger(name, params::Dict{String,<:Any})

Returns information about a ledger, including its state, permissions mode, encryption at
rest settings, and when it was created.

# Arguments
- `name`: The name of the ledger that you want to describe.

"""
function describe_ledger(name; aws_config::AbstractAWSConfig=current_aws_config())
    return qldb(
        "GET", "/ledgers/$(name)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_ledger(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qldb(
        "GET",
        "/ledgers/$(name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    export_journal_to_s3(exclusive_end_time, inclusive_start_time, role_arn, s3_export_configuration, name)
    export_journal_to_s3(exclusive_end_time, inclusive_start_time, role_arn, s3_export_configuration, name, params::Dict{String,<:Any})

Exports journal contents within a date and time range from a ledger into a specified Amazon
Simple Storage Service (Amazon S3) bucket. A journal export job can write the data objects
in either the text or binary representation of Amazon Ion format, or in JSON Lines text
format. If the ledger with the given Name doesn't exist, then throws
ResourceNotFoundException. If the ledger with the given Name is in CREATING status, then
throws ResourcePreconditionNotMetException. You can initiate up to two concurrent journal
export requests for each ledger. Beyond this limit, journal export requests throw
LimitExceededException.

# Arguments
- `exclusive_end_time`: The exclusive end date and time for the range of journal contents
  to export. The ExclusiveEndTime must be in ISO 8601 date and time format and in Universal
  Coordinated Time (UTC). For example: 2019-06-13T21:36:34Z. The ExclusiveEndTime must be
  less than or equal to the current UTC date and time.
- `inclusive_start_time`: The inclusive start date and time for the range of journal
  contents to export. The InclusiveStartTime must be in ISO 8601 date and time format and in
  Universal Coordinated Time (UTC). For example: 2019-06-13T21:36:34Z. The InclusiveStartTime
  must be before ExclusiveEndTime. If you provide an InclusiveStartTime that is before the
  ledger's CreationDateTime, Amazon QLDB defaults it to the ledger's CreationDateTime.
- `role_arn`: The Amazon Resource Name (ARN) of the IAM role that grants QLDB permissions
  for a journal export job to do the following:   Write objects into your Amazon S3 bucket.
  (Optional) Use your customer managed key in Key Management Service (KMS) for server-side
  encryption of your exported data.   To pass a role to QLDB when requesting a journal
  export, you must have permissions to perform the iam:PassRole action on the IAM role
  resource. This is required for all journal export requests.
- `s3_export_configuration`: The configuration settings of the Amazon S3 bucket destination
  for your export request.
- `name`: The name of the ledger.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"OutputFormat"`: The output format of your exported journal data. A journal export job
  can write the data objects in either the text or binary representation of Amazon Ion
  format, or in JSON Lines text format. Default: ION_TEXT  In JSON Lines format, each journal
  block in an exported data object is a valid JSON object that is delimited by a newline. You
  can use this format to directly integrate JSON exports with analytics tools such as Amazon
  Athena and Glue because these services can parse newline-delimited JSON automatically.
"""
function export_journal_to_s3(
    ExclusiveEndTime,
    InclusiveStartTime,
    RoleArn,
    S3ExportConfiguration,
    name;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qldb(
        "POST",
        "/ledgers/$(name)/journal-s3-exports",
        Dict{String,Any}(
            "ExclusiveEndTime" => ExclusiveEndTime,
            "InclusiveStartTime" => InclusiveStartTime,
            "RoleArn" => RoleArn,
            "S3ExportConfiguration" => S3ExportConfiguration,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function export_journal_to_s3(
    ExclusiveEndTime,
    InclusiveStartTime,
    RoleArn,
    S3ExportConfiguration,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qldb(
        "POST",
        "/ledgers/$(name)/journal-s3-exports",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ExclusiveEndTime" => ExclusiveEndTime,
                    "InclusiveStartTime" => InclusiveStartTime,
                    "RoleArn" => RoleArn,
                    "S3ExportConfiguration" => S3ExportConfiguration,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_block(block_address, name)
    get_block(block_address, name, params::Dict{String,<:Any})

Returns a block object at a specified address in a journal. Also returns a proof of the
specified block for verification if DigestTipAddress is provided. For information about the
data contents in a block, see Journal contents in the Amazon QLDB Developer Guide. If the
specified ledger doesn't exist or is in DELETING status, then throws
ResourceNotFoundException. If the specified ledger is in CREATING status, then throws
ResourcePreconditionNotMetException. If no block exists with the specified address, then
throws InvalidParameterException.

# Arguments
- `block_address`: The location of the block that you want to request. An address is an
  Amazon Ion structure that has two fields: strandId and sequenceNo. For example:
  {strandId:\"BlFTjlSXze9BIh1KOszcE3\",sequenceNo:14}.
- `name`: The name of the ledger.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DigestTipAddress"`: The latest block location covered by the digest for which to
  request a proof. An address is an Amazon Ion structure that has two fields: strandId and
  sequenceNo. For example: {strandId:\"BlFTjlSXze9BIh1KOszcE3\",sequenceNo:49}.
"""
function get_block(BlockAddress, name; aws_config::AbstractAWSConfig=current_aws_config())
    return qldb(
        "POST",
        "/ledgers/$(name)/block",
        Dict{String,Any}("BlockAddress" => BlockAddress);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_block(
    BlockAddress,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qldb(
        "POST",
        "/ledgers/$(name)/block",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("BlockAddress" => BlockAddress), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_digest(name)
    get_digest(name, params::Dict{String,<:Any})

Returns the digest of a ledger at the latest committed block in the journal. The response
includes a 256-bit hash value and a block address.

# Arguments
- `name`: The name of the ledger.

"""
function get_digest(name; aws_config::AbstractAWSConfig=current_aws_config())
    return qldb(
        "POST",
        "/ledgers/$(name)/digest";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_digest(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qldb(
        "POST",
        "/ledgers/$(name)/digest",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_revision(block_address, document_id, name)
    get_revision(block_address, document_id, name, params::Dict{String,<:Any})

Returns a revision data object for a specified document ID and block address. Also returns
a proof of the specified revision for verification if DigestTipAddress is provided.

# Arguments
- `block_address`: The block location of the document revision to be verified. An address
  is an Amazon Ion structure that has two fields: strandId and sequenceNo. For example:
  {strandId:\"BlFTjlSXze9BIh1KOszcE3\",sequenceNo:14}.
- `document_id`: The UUID (represented in Base62-encoded text) of the document to be
  verified.
- `name`: The name of the ledger.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DigestTipAddress"`: The latest block location covered by the digest for which to
  request a proof. An address is an Amazon Ion structure that has two fields: strandId and
  sequenceNo. For example: {strandId:\"BlFTjlSXze9BIh1KOszcE3\",sequenceNo:49}.
"""
function get_revision(
    BlockAddress, DocumentId, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qldb(
        "POST",
        "/ledgers/$(name)/revision",
        Dict{String,Any}("BlockAddress" => BlockAddress, "DocumentId" => DocumentId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_revision(
    BlockAddress,
    DocumentId,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qldb(
        "POST",
        "/ledgers/$(name)/revision",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "BlockAddress" => BlockAddress, "DocumentId" => DocumentId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_journal_kinesis_streams_for_ledger(name)
    list_journal_kinesis_streams_for_ledger(name, params::Dict{String,<:Any})

Returns all Amazon QLDB journal streams for a given ledger. This action does not return any
expired journal streams. For more information, see Expiration for terminal streams in the
Amazon QLDB Developer Guide. This action returns a maximum of MaxResults items. It is
paginated so that you can retrieve all the items by calling
ListJournalKinesisStreamsForLedger multiple times.

# Arguments
- `name`: The name of the ledger.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"max_results"`: The maximum number of results to return in a single
  ListJournalKinesisStreamsForLedger request. (The actual number of results returned might be
  fewer.)
- `"next_token"`: A pagination token, indicating that you want to retrieve the next page of
  results. If you received a value for NextToken in the response from a previous
  ListJournalKinesisStreamsForLedger call, you should use that value as input here.
"""
function list_journal_kinesis_streams_for_ledger(
    name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qldb(
        "GET",
        "/ledgers/$(name)/journal-kinesis-streams";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_journal_kinesis_streams_for_ledger(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qldb(
        "GET",
        "/ledgers/$(name)/journal-kinesis-streams",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_journal_s3_exports()
    list_journal_s3_exports(params::Dict{String,<:Any})

Returns all journal export jobs for all ledgers that are associated with the current Amazon
Web Services account and Region. This action returns a maximum of MaxResults items, and is
paginated so that you can retrieve all the items by calling ListJournalS3Exports multiple
times. This action does not return any expired export jobs. For more information, see
Export job expiration in the Amazon QLDB Developer Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"max_results"`: The maximum number of results to return in a single ListJournalS3Exports
  request. (The actual number of results returned might be fewer.)
- `"next_token"`: A pagination token, indicating that you want to retrieve the next page of
  results. If you received a value for NextToken in the response from a previous
  ListJournalS3Exports call, then you should use that value as input here.
"""
function list_journal_s3_exports(; aws_config::AbstractAWSConfig=current_aws_config())
    return qldb(
        "GET", "/journal-s3-exports"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_journal_s3_exports(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qldb(
        "GET",
        "/journal-s3-exports",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_journal_s3_exports_for_ledger(name)
    list_journal_s3_exports_for_ledger(name, params::Dict{String,<:Any})

Returns all journal export jobs for a specified ledger. This action returns a maximum of
MaxResults items, and is paginated so that you can retrieve all the items by calling
ListJournalS3ExportsForLedger multiple times. This action does not return any expired
export jobs. For more information, see Export job expiration in the Amazon QLDB Developer
Guide.

# Arguments
- `name`: The name of the ledger.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"max_results"`: The maximum number of results to return in a single
  ListJournalS3ExportsForLedger request. (The actual number of results returned might be
  fewer.)
- `"next_token"`: A pagination token, indicating that you want to retrieve the next page of
  results. If you received a value for NextToken in the response from a previous
  ListJournalS3ExportsForLedger call, then you should use that value as input here.
"""
function list_journal_s3_exports_for_ledger(
    name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qldb(
        "GET",
        "/ledgers/$(name)/journal-s3-exports";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_journal_s3_exports_for_ledger(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qldb(
        "GET",
        "/ledgers/$(name)/journal-s3-exports",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_ledgers()
    list_ledgers(params::Dict{String,<:Any})

Returns all ledgers that are associated with the current Amazon Web Services account and
Region. This action returns a maximum of MaxResults items and is paginated so that you can
retrieve all the items by calling ListLedgers multiple times.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"max_results"`: The maximum number of results to return in a single ListLedgers request.
  (The actual number of results returned might be fewer.)
- `"next_token"`: A pagination token, indicating that you want to retrieve the next page of
  results. If you received a value for NextToken in the response from a previous ListLedgers
  call, then you should use that value as input here.
"""
function list_ledgers(; aws_config::AbstractAWSConfig=current_aws_config())
    return qldb("GET", "/ledgers"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_ledgers(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qldb(
        "GET", "/ledgers", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Returns all tags for a specified Amazon QLDB resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) for which to list the tags. For example:
  arn:aws:qldb:us-east-1:123456789012:ledger/exampleLedger

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qldb(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qldb(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stream_journal_to_kinesis(inclusive_start_time, kinesis_configuration, role_arn, stream_name, name)
    stream_journal_to_kinesis(inclusive_start_time, kinesis_configuration, role_arn, stream_name, name, params::Dict{String,<:Any})

Creates a journal stream for a given Amazon QLDB ledger. The stream captures every document
revision that is committed to the ledger's journal and delivers the data to a specified
Amazon Kinesis Data Streams resource.

# Arguments
- `inclusive_start_time`: The inclusive start date and time from which to start streaming
  journal data. This parameter must be in ISO 8601 date and time format and in Universal
  Coordinated Time (UTC). For example: 2019-06-13T21:36:34Z. The InclusiveStartTime cannot be
  in the future and must be before ExclusiveEndTime. If you provide an InclusiveStartTime
  that is before the ledger's CreationDateTime, QLDB effectively defaults it to the ledger's
  CreationDateTime.
- `kinesis_configuration`: The configuration settings of the Kinesis Data Streams
  destination for your stream request.
- `role_arn`: The Amazon Resource Name (ARN) of the IAM role that grants QLDB permissions
  for a journal stream to write data records to a Kinesis Data Streams resource. To pass a
  role to QLDB when requesting a journal stream, you must have permissions to perform the
  iam:PassRole action on the IAM role resource. This is required for all journal stream
  requests.
- `stream_name`: The name that you want to assign to the QLDB journal stream. User-defined
  names can help identify and indicate the purpose of a stream. Your stream name must be
  unique among other active streams for a given ledger. Stream names have the same naming
  constraints as ledger names, as defined in Quotas in Amazon QLDB in the Amazon QLDB
  Developer Guide.
- `name`: The name of the ledger.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ExclusiveEndTime"`: The exclusive date and time that specifies when the stream ends. If
  you don't define this parameter, the stream runs indefinitely until you cancel it. The
  ExclusiveEndTime must be in ISO 8601 date and time format and in Universal Coordinated Time
  (UTC). For example: 2019-06-13T21:36:34Z.
- `"Tags"`: The key-value pairs to add as tags to the stream that you want to create. Tag
  keys are case sensitive. Tag values are case sensitive and can be null.
"""
function stream_journal_to_kinesis(
    InclusiveStartTime,
    KinesisConfiguration,
    RoleArn,
    StreamName,
    name;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qldb(
        "POST",
        "/ledgers/$(name)/journal-kinesis-streams",
        Dict{String,Any}(
            "InclusiveStartTime" => InclusiveStartTime,
            "KinesisConfiguration" => KinesisConfiguration,
            "RoleArn" => RoleArn,
            "StreamName" => StreamName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stream_journal_to_kinesis(
    InclusiveStartTime,
    KinesisConfiguration,
    RoleArn,
    StreamName,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qldb(
        "POST",
        "/ledgers/$(name)/journal-kinesis-streams",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "InclusiveStartTime" => InclusiveStartTime,
                    "KinesisConfiguration" => KinesisConfiguration,
                    "RoleArn" => RoleArn,
                    "StreamName" => StreamName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(tags, resource_arn)
    tag_resource(tags, resource_arn, params::Dict{String,<:Any})

Adds one or more tags to a specified Amazon QLDB resource. A resource can have up to 50
tags. If you try to create more than 50 tags for a resource, your request fails and returns
an error.

# Arguments
- `tags`: The key-value pairs to add as tags to the specified QLDB resource. Tag keys are
  case sensitive. If you specify a key that already exists for the resource, your request
  fails and returns an error. Tag values are case sensitive and can be null.
- `resource_arn`: The Amazon Resource Name (ARN) to which you want to add the tags. For
  example:  arn:aws:qldb:us-east-1:123456789012:ledger/exampleLedger

"""
function tag_resource(Tags, resourceArn; aws_config::AbstractAWSConfig=current_aws_config())
    return qldb(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    Tags,
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qldb(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Tags" => Tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes one or more tags from a specified Amazon QLDB resource. You can specify up to 50
tag keys to remove.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) from which to remove the tags. For
  example:  arn:aws:qldb:us-east-1:123456789012:ledger/exampleLedger
- `tag_keys`: The list of tag keys to remove.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qldb(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qldb(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_ledger(name)
    update_ledger(name, params::Dict{String,<:Any})

Updates properties on a ledger.

# Arguments
- `name`: The name of the ledger.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DeletionProtection"`: Specifies whether the ledger is protected from being deleted by
  any user. If not defined during ledger creation, this feature is enabled (true) by default.
  If deletion protection is enabled, you must first disable it before you can delete the
  ledger. You can disable it by calling the UpdateLedger operation to set this parameter to
  false.
- `"KmsKey"`: The key in Key Management Service (KMS) to use for encryption of data at rest
  in the ledger. For more information, see Encryption at rest in the Amazon QLDB Developer
  Guide. Use one of the following options to specify this parameter:    AWS_OWNED_KMS_KEY:
  Use an KMS key that is owned and managed by Amazon Web Services on your behalf.
  Undefined: Make no changes to the KMS key of the ledger.    A valid symmetric customer
  managed KMS key: Use the specified symmetric encryption KMS key in your account that you
  create, own, and manage. Amazon QLDB does not support asymmetric keys. For more
  information, see Using symmetric and asymmetric keys in the Key Management Service
  Developer Guide.   To specify a customer managed KMS key, you can use its key ID, Amazon
  Resource Name (ARN), alias name, or alias ARN. When using an alias name, prefix it with
  \"alias/\". To specify a key in a different Amazon Web Services account, you must use the
  key ARN or alias ARN. For example:   Key ID: 1234abcd-12ab-34cd-56ef-1234567890ab    Key
  ARN: arn:aws:kms:us-east-2:111122223333:key/1234abcd-12ab-34cd-56ef-1234567890ab    Alias
  name: alias/ExampleAlias    Alias ARN:
  arn:aws:kms:us-east-2:111122223333:alias/ExampleAlias    For more information, see Key
  identifiers (KeyId) in the Key Management Service Developer Guide.
"""
function update_ledger(name; aws_config::AbstractAWSConfig=current_aws_config())
    return qldb(
        "PATCH", "/ledgers/$(name)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function update_ledger(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qldb(
        "PATCH",
        "/ledgers/$(name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_ledger_permissions_mode(permissions_mode, name)
    update_ledger_permissions_mode(permissions_mode, name, params::Dict{String,<:Any})

Updates the permissions mode of a ledger.  Before you switch to the STANDARD permissions
mode, you must first create all required IAM policies and table tags to avoid disruption to
your users. To learn more, see Migrating to the standard permissions mode in the Amazon
QLDB Developer Guide.

# Arguments
- `permissions_mode`: The permissions mode to assign to the ledger. This parameter can have
  one of the following values:    ALLOW_ALL: A legacy permissions mode that enables access
  control with API-level granularity for ledgers. This mode allows users who have the
  SendCommand API permission for this ledger to run all PartiQL commands (hence, ALLOW_ALL)
  on any tables in the specified ledger. This mode disregards any table-level or
  command-level IAM permissions policies that you create for the ledger.    STANDARD:
  (Recommended) A permissions mode that enables access control with finer granularity for
  ledgers, tables, and PartiQL commands. By default, this mode denies all user requests to
  run any PartiQL commands on any tables in this ledger. To allow PartiQL commands to run,
  you must create IAM permissions policies for specific table resources and PartiQL actions,
  in addition to the SendCommand API permission for the ledger. For information, see Getting
  started with the standard permissions mode in the Amazon QLDB Developer Guide.    We
  strongly recommend using the STANDARD permissions mode to maximize the security of your
  ledger data.
- `name`: The name of the ledger.

"""
function update_ledger_permissions_mode(
    PermissionsMode, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qldb(
        "PATCH",
        "/ledgers/$(name)/permissions-mode",
        Dict{String,Any}("PermissionsMode" => PermissionsMode);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_ledger_permissions_mode(
    PermissionsMode,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return qldb(
        "PATCH",
        "/ledgers/$(name)/permissions-mode",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("PermissionsMode" => PermissionsMode), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

@testset "_whoami" begin
    user = AWS._whoami()
    @test user isa AbstractString
    @test !isempty(user)
end

@testset "assume_role / assume_role_creds" begin
    # In order to mitigate the effects of using `assume_role` in order to test itself we'll
    # use the lowest-level call with as many defaults as possible.
    base_config = current_aws_config()
    creds = assume_role_creds(base_config, testset_role("AssumeRoleTestset"))
    config = AWSConfig(; creds)
    @test get_assumed_role(config) == testset_role("AssumeRoleTestset")

    role_a = testset_role("RoleA")
    role_b = testset_role("RoleB")

    @testset "basic" begin
        creds = assume_role_creds(config, role_a)
        @test creds isa AWSCredentials
        @test creds.token != ""  # Temporary credentials
        @test creds.renew !== nothing

        cfg = assume_role(config, role_a)
        @test cfg isa AWSConfig
        @test cfg.credentials isa AWSCredentials
        @test cfg.region == config.region
        @test cfg.output == config.output
        @test cfg.max_attempts == config.max_attempts
    end

    @testset "role name/ARN" begin
        account_id = aws_account_number(config)

        creds = assume_role_creds(config, role_a)
        @test contains(creds.user_arn, r":assumed-role/" * (role_a * '/'))
        @test creds.account_number == account_id

        creds = assume_role_creds(config, "arn:aws:iam::$account_id:role/$role_a")
        @test contains(creds.user_arn, r":assumed-role/" * (role_a * '/'))
        @test creds.account_number == ""
    end

    @testset "duration" begin
        # Have seen up to 3 seconds of drift on CI jobs
        drift = Second(5)

        creds = assume_role_creds(config, role_a; duration=nothing)
        t = floor(now(UTC), Second)
        @test t <= creds.expiry <= t + Second(3600) + drift

        duration = 900  # Minimum allowed duration
        creds = assume_role_creds(config, role_a; duration)
        t = floor(now(UTC), Second)
        @test t <= creds.expiry <= t + Second(duration) + drift
    end

    @testset "session_name" begin
        session_prefix = "AWS.jl-"
        creds = assume_role_creds(config, role_a; session_name=nothing)
        regex = r":assumed-role/" * (role_a * '/' * session_prefix) * r".*-\d{8}T\d{6}Z$"
        @test contains(creds.user_arn, regex)
        @test get_assumed_role(creds) == role_a

        session_name = "assume-role-session-name-testset-" * randstring(5)
        creds = assume_role_creds(config, role_a; session_name)
        regex = r":assumed-role/" * (role_a * '/' * session_name) * r"$"
        @test contains(creds.user_arn, regex)
        @test get_assumed_role(creds) == role_a
    end

    @testset "mfa_serial / token" begin
        mfa_user_cfg, mfa_devices = mfa_user_credentials(config)

        # User policy should deny "sts:AssumeRole" when MFA is not present.
        @test_throws AWSException assume_role_creds(mfa_user_cfg, role_a)

        creds = mfa_device_pool(mfa_devices) do mfa_serial, token
            assume_role_creds(mfa_user_cfg, role_a; mfa_serial, token)
        end
        @test get_assumed_role(creds) == role_a
    end

    @testset "renew" begin
        creds = assume_role_creds(config, role_a; duration=nothing)
        @test creds.renew isa Function
        @test get_assumed_role(creds) == role_a

        new_creds = creds.renew()
        @test new_creds isa AWSCredentials
        @test get_assumed_role(new_creds) == role_a
        @test new_creds.access_key_id != creds.access_key_id
        @test new_creds.secret_key != creds.secret_key
        @test new_creds.expiry >= creds.expiry
    end

    @testset "role chaining" begin
        cfg = assume_role(assume_role(config, role_a), role_b)
        @test get_assumed_role(cfg) == role_b

        #! format: off
        cfg = config |> assume_role(role_a) |> assume_role(role_b)
        #! format: on
        @test get_assumed_role(cfg) == role_b
    end
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: deadline
using AWS.Compat
using AWS.UUIDs

"""
    associate_member_to_farm(farm_id, identity_store_id, membership_level, principal_id, principal_type)
    associate_member_to_farm(farm_id, identity_store_id, membership_level, principal_id, principal_type, params::Dict{String,<:Any})

Assigns a farm membership level to a member.

# Arguments
- `farm_id`: The ID of the farm to associate with the member.
- `identity_store_id`: The identity store ID of the member to associate with the farm.
- `membership_level`: The principal's membership level for the associated farm.
- `principal_id`: The member's principal ID to associate with the farm.
- `principal_type`: The principal type of the member to associate with the farm.

"""
function associate_member_to_farm(
    farmId,
    identityStoreId,
    membershipLevel,
    principalId,
    principalType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "PUT",
        "/2023-10-12/farms/$(farmId)/members/$(principalId)",
        Dict{String,Any}(
            "identityStoreId" => identityStoreId,
            "membershipLevel" => membershipLevel,
            "principalType" => principalType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_member_to_farm(
    farmId,
    identityStoreId,
    membershipLevel,
    principalId,
    principalType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "PUT",
        "/2023-10-12/farms/$(farmId)/members/$(principalId)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "identityStoreId" => identityStoreId,
                    "membershipLevel" => membershipLevel,
                    "principalType" => principalType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_member_to_fleet(farm_id, fleet_id, identity_store_id, membership_level, principal_id, principal_type)
    associate_member_to_fleet(farm_id, fleet_id, identity_store_id, membership_level, principal_id, principal_type, params::Dict{String,<:Any})

Assigns a fleet membership level to a member.

# Arguments
- `farm_id`: The farm ID of the fleet to associate with the member.
- `fleet_id`: The ID of the fleet to associate with a member.
- `identity_store_id`: The member's identity store ID to associate with the fleet.
- `membership_level`: The principal's membership level for the associated fleet.
- `principal_id`: The member's principal ID to associate with a fleet.
- `principal_type`: The member's principal type to associate with the fleet.

"""
function associate_member_to_fleet(
    farmId,
    fleetId,
    identityStoreId,
    membershipLevel,
    principalId,
    principalType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "PUT",
        "/2023-10-12/farms/$(farmId)/fleets/$(fleetId)/members/$(principalId)",
        Dict{String,Any}(
            "identityStoreId" => identityStoreId,
            "membershipLevel" => membershipLevel,
            "principalType" => principalType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_member_to_fleet(
    farmId,
    fleetId,
    identityStoreId,
    membershipLevel,
    principalId,
    principalType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "PUT",
        "/2023-10-12/farms/$(farmId)/fleets/$(fleetId)/members/$(principalId)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "identityStoreId" => identityStoreId,
                    "membershipLevel" => membershipLevel,
                    "principalType" => principalType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_member_to_job(farm_id, identity_store_id, job_id, membership_level, principal_id, principal_type, queue_id)
    associate_member_to_job(farm_id, identity_store_id, job_id, membership_level, principal_id, principal_type, queue_id, params::Dict{String,<:Any})

Assigns a job membership level to a member

# Arguments
- `farm_id`: The farm ID of the job to associate with the member.
- `identity_store_id`: The member's identity store ID to associate with the job.
- `job_id`: The job ID to associate with the member.
- `membership_level`: The principal's membership level for the associated job.
- `principal_id`: The member's principal ID to associate with the job.
- `principal_type`: The member's principal type to associate with the job.
- `queue_id`: The queue ID to associate to the member.

"""
function associate_member_to_job(
    farmId,
    identityStoreId,
    jobId,
    membershipLevel,
    principalId,
    principalType,
    queueId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "PUT",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/jobs/$(jobId)/members/$(principalId)",
        Dict{String,Any}(
            "identityStoreId" => identityStoreId,
            "membershipLevel" => membershipLevel,
            "principalType" => principalType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_member_to_job(
    farmId,
    identityStoreId,
    jobId,
    membershipLevel,
    principalId,
    principalType,
    queueId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "PUT",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/jobs/$(jobId)/members/$(principalId)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "identityStoreId" => identityStoreId,
                    "membershipLevel" => membershipLevel,
                    "principalType" => principalType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_member_to_queue(farm_id, identity_store_id, membership_level, principal_id, principal_type, queue_id)
    associate_member_to_queue(farm_id, identity_store_id, membership_level, principal_id, principal_type, queue_id, params::Dict{String,<:Any})

Assigns a queue membership level to a member

# Arguments
- `farm_id`: The farm ID of the queue to associate with the member.
- `identity_store_id`: The member's identity store ID to associate with the queue.
- `membership_level`: The principal's membership level for the associated queue.
- `principal_id`: The member's principal ID to associate with the queue.
- `principal_type`: The member's principal type to associate with the queue.
- `queue_id`: The ID of the queue to associate to the member.

"""
function associate_member_to_queue(
    farmId,
    identityStoreId,
    membershipLevel,
    principalId,
    principalType,
    queueId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "PUT",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/members/$(principalId)",
        Dict{String,Any}(
            "identityStoreId" => identityStoreId,
            "membershipLevel" => membershipLevel,
            "principalType" => principalType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_member_to_queue(
    farmId,
    identityStoreId,
    membershipLevel,
    principalId,
    principalType,
    queueId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "PUT",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/members/$(principalId)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "identityStoreId" => identityStoreId,
                    "membershipLevel" => membershipLevel,
                    "principalType" => principalType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    assume_fleet_role_for_read(farm_id, fleet_id)
    assume_fleet_role_for_read(farm_id, fleet_id, params::Dict{String,<:Any})

Get Amazon Web Services credentials from the fleet role. The IAM permissions of the
credentials are scoped down to have read-only access.

# Arguments
- `farm_id`: The farm ID for the fleet's farm.
- `fleet_id`: The fleet ID.

"""
function assume_fleet_role_for_read(
    farmId, fleetId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/fleets/$(fleetId)/read-roles";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function assume_fleet_role_for_read(
    farmId,
    fleetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/fleets/$(fleetId)/read-roles",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    assume_fleet_role_for_worker(farm_id, fleet_id, worker_id)
    assume_fleet_role_for_worker(farm_id, fleet_id, worker_id, params::Dict{String,<:Any})

Get credentials from the fleet role for a worker.

# Arguments
- `farm_id`: The farm ID for the fleet's farm.
- `fleet_id`: The fleet ID that contains the worker.
- `worker_id`: The ID of the worker assuming the fleet role.

"""
function assume_fleet_role_for_worker(
    farmId, fleetId, workerId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/fleets/$(fleetId)/workers/$(workerId)/fleet-roles";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function assume_fleet_role_for_worker(
    farmId,
    fleetId,
    workerId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/fleets/$(fleetId)/workers/$(workerId)/fleet-roles",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    assume_queue_role_for_read(farm_id, queue_id)
    assume_queue_role_for_read(farm_id, queue_id, params::Dict{String,<:Any})

Gets Amazon Web Services credentials from the queue role. The IAM permissions of the
credentials are scoped down to have read-only access.

# Arguments
- `farm_id`: The farm ID of the farm containing the queue.
- `queue_id`: The queue ID.

"""
function assume_queue_role_for_read(
    farmId, queueId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/read-roles";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function assume_queue_role_for_read(
    farmId,
    queueId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/read-roles",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    assume_queue_role_for_user(farm_id, queue_id)
    assume_queue_role_for_user(farm_id, queue_id, params::Dict{String,<:Any})

Allows a user to assume a role for a queue.

# Arguments
- `farm_id`: The farm ID of the queue that the user assumes the role for.
- `queue_id`: The queue ID of the queue that the user assumes the role for.

"""
function assume_queue_role_for_user(
    farmId, queueId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/user-roles";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function assume_queue_role_for_user(
    farmId,
    queueId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/user-roles",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    assume_queue_role_for_worker(farm_id, fleet_id, queue_id, worker_id)
    assume_queue_role_for_worker(farm_id, fleet_id, queue_id, worker_id, params::Dict{String,<:Any})

Allows a worker to assume a queue role.

# Arguments
- `farm_id`: The farm ID of the worker assuming the queue role.
- `fleet_id`: The fleet ID of the worker assuming the queue role.
- `queue_id`: The queue ID of the worker assuming the queue role.
- `worker_id`: The worker ID of the worker assuming the queue role.

"""
function assume_queue_role_for_worker(
    farmId, fleetId, queueId, workerId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/fleets/$(fleetId)/workers/$(workerId)/queue-roles",
        Dict{String,Any}("queueId" => queueId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function assume_queue_role_for_worker(
    farmId,
    fleetId,
    queueId,
    workerId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/fleets/$(fleetId)/workers/$(workerId)/queue-roles",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("queueId" => queueId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_get_job_entity(farm_id, fleet_id, identifiers, worker_id)
    batch_get_job_entity(farm_id, fleet_id, identifiers, worker_id, params::Dict{String,<:Any})

Get batched job details for a worker.

# Arguments
- `farm_id`: The farm ID of the worker that's fetching job details. The worker must have an
  assignment on a job to fetch job details.
- `fleet_id`: The fleet ID of the worker that's fetching job details. The worker must have
  an assignment on a job to fetch job details.
- `identifiers`: The job identifiers to include within the job entity batch details.
- `worker_id`: The worker ID of the worker containing the job details to get.

"""
function batch_get_job_entity(
    farmId,
    fleetId,
    identifiers,
    workerId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "POST",
        "/2023-10-12/farms/$(farmId)/fleets/$(fleetId)/workers/$(workerId)/batchGetJobEntity",
        Dict{String,Any}("identifiers" => identifiers);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_job_entity(
    farmId,
    fleetId,
    identifiers,
    workerId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "POST",
        "/2023-10-12/farms/$(farmId)/fleets/$(fleetId)/workers/$(workerId)/batchGetJobEntity",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("identifiers" => identifiers), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    copy_job_template(farm_id, job_id, queue_id, target_s3_location)
    copy_job_template(farm_id, job_id, queue_id, target_s3_location, params::Dict{String,<:Any})

Copies a job template to an Amazon S3 bucket.

# Arguments
- `farm_id`: The farm ID to copy.
- `job_id`: The job ID to copy.
- `queue_id`: The queue ID to copy.
- `target_s3_location`: The Amazon S3 bucket name and key where you would like to add a
  copy of the job template.

"""
function copy_job_template(
    farmId,
    jobId,
    queueId,
    targetS3Location;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "POST",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/jobs/$(jobId)/template",
        Dict{String,Any}("targetS3Location" => targetS3Location);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function copy_job_template(
    farmId,
    jobId,
    queueId,
    targetS3Location,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "POST",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/jobs/$(jobId)/template",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("targetS3Location" => targetS3Location), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_budget(actions, approximate_dollar_limit, display_name, farm_id, schedule, usage_tracking_resource)
    create_budget(actions, approximate_dollar_limit, display_name, farm_id, schedule, usage_tracking_resource, params::Dict{String,<:Any})

Creates a budget to set spending thresholds for your rendering activity.

# Arguments
- `actions`: The budget actions to specify what happens when the budget runs out.
- `approximate_dollar_limit`: The dollar limit based on consumed usage.
- `display_name`: The display name of the budget.
- `farm_id`: The farm ID to include in this budget.
- `schedule`: The schedule to associate with this budget.
- `usage_tracking_resource`: The queue ID provided to this budget to track usage.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"X-Amz-Client-Token"`: The unique token which the server uses to recognize retries of
  the same request.
- `"description"`: The description of the budget.
"""
function create_budget(
    actions,
    approximateDollarLimit,
    displayName,
    farmId,
    schedule,
    usageTrackingResource;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "POST",
        "/2023-10-12/farms/$(farmId)/budgets",
        Dict{String,Any}(
            "actions" => actions,
            "approximateDollarLimit" => approximateDollarLimit,
            "displayName" => displayName,
            "schedule" => schedule,
            "usageTrackingResource" => usageTrackingResource,
            "X-Amz-Client-Token" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_budget(
    actions,
    approximateDollarLimit,
    displayName,
    farmId,
    schedule,
    usageTrackingResource,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "POST",
        "/2023-10-12/farms/$(farmId)/budgets",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "actions" => actions,
                    "approximateDollarLimit" => approximateDollarLimit,
                    "displayName" => displayName,
                    "schedule" => schedule,
                    "usageTrackingResource" => usageTrackingResource,
                    "X-Amz-Client-Token" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_farm(display_name)
    create_farm(display_name, params::Dict{String,<:Any})

Creates a farm to allow space for queues and fleets. Farms are the space where the
components of your renders gather and are pieced together in the cloud. Farms contain
budgets and allow you to enforce permissions. Deadline Cloud farms are a useful container
for large projects.

# Arguments
- `display_name`: The display name of the farm.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"X-Amz-Client-Token"`: The unique token which the server uses to recognize retries of
  the same request.
- `"description"`: The description of the farm.
- `"kmsKeyArn"`: The ARN of the KMS key to use on the farm.
- `"tags"`: The tags to add to your farm. Each tag consists of a tag key and a tag value.
  Tag keys and values are both required, but tag values can be empty strings.
"""
function create_farm(displayName; aws_config::AbstractAWSConfig=current_aws_config())
    return deadline(
        "POST",
        "/2023-10-12/farms",
        Dict{String,Any}(
            "displayName" => displayName, "X-Amz-Client-Token" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_farm(
    displayName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "POST",
        "/2023-10-12/farms",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "displayName" => displayName, "X-Amz-Client-Token" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_fleet(configuration, display_name, farm_id, max_worker_count, role_arn)
    create_fleet(configuration, display_name, farm_id, max_worker_count, role_arn, params::Dict{String,<:Any})

Creates a fleet. Fleets gather information relating to compute, or capacity, for renders
within your farms. You can choose to manage your own capacity or opt to have fleets fully
managed by Deadline Cloud.

# Arguments
- `configuration`: The configuration settings for the fleet. Customer managed fleets are
  self-managed. Service managed Amazon EC2 fleets are managed by Deadline Cloud.
- `display_name`: The display name of the fleet.
- `farm_id`: The farm ID of the farm to connect to the fleet.
- `max_worker_count`: The maximum number of workers for the fleet.
- `role_arn`: The IAM role ARN for the role that the fleet's workers will use.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"X-Amz-Client-Token"`: The unique token which the server uses to recognize retries of
  the same request.
- `"description"`: The description of the fleet.
- `"minWorkerCount"`: The minimum number of workers for the fleet.
- `"tags"`: Each tag consists of a tag key and a tag value. Tag keys and values are both
  required, but tag values can be empty strings.
"""
function create_fleet(
    configuration,
    displayName,
    farmId,
    maxWorkerCount,
    roleArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "POST",
        "/2023-10-12/farms/$(farmId)/fleets",
        Dict{String,Any}(
            "configuration" => configuration,
            "displayName" => displayName,
            "maxWorkerCount" => maxWorkerCount,
            "roleArn" => roleArn,
            "X-Amz-Client-Token" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_fleet(
    configuration,
    displayName,
    farmId,
    maxWorkerCount,
    roleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "POST",
        "/2023-10-12/farms/$(farmId)/fleets",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "configuration" => configuration,
                    "displayName" => displayName,
                    "maxWorkerCount" => maxWorkerCount,
                    "roleArn" => roleArn,
                    "X-Amz-Client-Token" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_job(farm_id, priority, queue_id, template, template_type)
    create_job(farm_id, priority, queue_id, template, template_type, params::Dict{String,<:Any})

Creates a job. A job is a render submission submitted by a user. It contains specific job
properties outlined as steps and tasks.

# Arguments
- `farm_id`: The farm ID of the farm to connect to the job.
- `priority`: The priority of the job on a scale of 1 to 100. The highest priority is 1.
- `queue_id`: The ID of the queue that the job is submitted to.
- `template`: The job template to use for this job.
- `template_type`: The file type for the job template.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"X-Amz-Client-Token"`: The unique token which the server uses to recognize retries of
  the same request.
- `"attachments"`: The attachments for the job. Attach files required for the job to run to
  a render job.
- `"maxFailedTasksCount"`: The number of task failures before the job stops running and is
  marked as FAILED.
- `"maxRetriesPerTask"`: The maximum number of retries for a job.
- `"parameters"`: The parameters for the job.
- `"storageProfileId"`: The storage profile ID for the storage profile to connect to the
  job.
- `"targetTaskRunStatus"`: The initial status of the job's tasks when they are created.
  Tasks that are created with a SUSPENDED status will not run until you update their status.
"""
function create_job(
    farmId,
    priority,
    queueId,
    template,
    templateType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "POST",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/jobs",
        Dict{String,Any}(
            "priority" => priority,
            "template" => template,
            "templateType" => templateType,
            "X-Amz-Client-Token" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_job(
    farmId,
    priority,
    queueId,
    template,
    templateType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "POST",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/jobs",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "priority" => priority,
                    "template" => template,
                    "templateType" => templateType,
                    "X-Amz-Client-Token" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_license_endpoint(security_group_ids, subnet_ids, vpc_id)
    create_license_endpoint(security_group_ids, subnet_ids, vpc_id, params::Dict{String,<:Any})

Creates a license endpoint to integrate your various licensed software used for rendering
on Deadline Cloud.

# Arguments
- `security_group_ids`: The security group IDs.
- `subnet_ids`: The subnet IDs.
- `vpc_id`: The VPC (virtual private cloud) ID to use with the license endpoint.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"X-Amz-Client-Token"`: The unique token which the server uses to recognize retries of
  the same request.
- `"tags"`: Each tag consists of a tag key and a tag value. Tag keys and values are both
  required, but tag values can be empty strings.
"""
function create_license_endpoint(
    securityGroupIds, subnetIds, vpcId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "POST",
        "/2023-10-12/license-endpoints",
        Dict{String,Any}(
            "securityGroupIds" => securityGroupIds,
            "subnetIds" => subnetIds,
            "vpcId" => vpcId,
            "X-Amz-Client-Token" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_license_endpoint(
    securityGroupIds,
    subnetIds,
    vpcId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "POST",
        "/2023-10-12/license-endpoints",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "securityGroupIds" => securityGroupIds,
                    "subnetIds" => subnetIds,
                    "vpcId" => vpcId,
                    "X-Amz-Client-Token" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_monitor(display_name, identity_center_instance_arn, role_arn, subdomain)
    create_monitor(display_name, identity_center_instance_arn, role_arn, subdomain, params::Dict{String,<:Any})

Creates an Amazon Web Services Deadline Cloud monitor that you can use to view your farms,
queues, and fleets. After you submit a job, you can track the progress of the tasks and
steps that make up the job, and then download the job's results.

# Arguments
- `display_name`: The name that you give the monitor that is displayed in the Deadline
  Cloud console.
- `identity_center_instance_arn`: The Amazon Resource Name (ARN) of the IAM Identity Center
  instance that authenticates monitor users.
- `role_arn`: The Amazon Resource Name (ARN) of the IAM role that the monitor uses to
  connect to Deadline Cloud. Every user that signs in to the monitor using IAM Identity
  Center uses this role to access Deadline Cloud resources.
- `subdomain`: The subdomain to use when creating the monitor URL. The full URL of the
  monitor is subdomain.Region.deadlinecloud.amazonaws.com.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"X-Amz-Client-Token"`: The unique token which the server uses to recognize retries of
  the same request.
"""
function create_monitor(
    displayName,
    identityCenterInstanceArn,
    roleArn,
    subdomain;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "POST",
        "/2023-10-12/monitors",
        Dict{String,Any}(
            "displayName" => displayName,
            "identityCenterInstanceArn" => identityCenterInstanceArn,
            "roleArn" => roleArn,
            "subdomain" => subdomain,
            "X-Amz-Client-Token" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_monitor(
    displayName,
    identityCenterInstanceArn,
    roleArn,
    subdomain,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "POST",
        "/2023-10-12/monitors",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "displayName" => displayName,
                    "identityCenterInstanceArn" => identityCenterInstanceArn,
                    "roleArn" => roleArn,
                    "subdomain" => subdomain,
                    "X-Amz-Client-Token" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_queue(display_name, farm_id)
    create_queue(display_name, farm_id, params::Dict{String,<:Any})

Creates a queue to coordinate the order in which jobs run on a farm. A queue can also
specify where to pull resources and indicate where to output completed jobs.

# Arguments
- `display_name`: The display name of the queue.
- `farm_id`: The farm ID of the farm to connect to the queue.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"X-Amz-Client-Token"`: The unique token which the server uses to recognize retries of
  the same request.
- `"allowedStorageProfileIds"`: The storage profile IDs to include in the queue.
- `"defaultBudgetAction"`: The default action to take on a queue if a budget isn't
  configured.
- `"description"`: The description of the queue.
- `"jobAttachmentSettings"`: The job attachment settings for the queue. These are the
  Amazon S3 bucket name and the Amazon S3 prefix.
- `"jobRunAsUser"`: The jobs in the queue run as the specified POSIX user.
- `"requiredFileSystemLocationNames"`: The file system location name to include in the
  queue.
- `"roleArn"`: The IAM role ARN that workers will use while running jobs for this queue.
- `"tags"`: Each tag consists of a tag key and a tag value. Tag keys and values are both
  required, but tag values can be empty strings.
"""
function create_queue(
    displayName, farmId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "POST",
        "/2023-10-12/farms/$(farmId)/queues",
        Dict{String,Any}(
            "displayName" => displayName, "X-Amz-Client-Token" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_queue(
    displayName,
    farmId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "POST",
        "/2023-10-12/farms/$(farmId)/queues",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "displayName" => displayName, "X-Amz-Client-Token" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_queue_environment(farm_id, priority, queue_id, template, template_type)
    create_queue_environment(farm_id, priority, queue_id, template, template_type, params::Dict{String,<:Any})

Creates an environment for a queue that defines how jobs in the queue run.

# Arguments
- `farm_id`: The farm ID of the farm to connect to the environment.
- `priority`: Sets the priority of the environments in the queue from 0 to 10,000, where 0
  is the highest priority. If two environments share the same priority value, the environment
  created first takes higher priority.
- `queue_id`: The queue ID to connect the queue and environment.
- `template`: The environment template to use in the queue.
- `template_type`: The template's file type, JSON or YAML.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"X-Amz-Client-Token"`: The unique token which the server uses to recognize retries of
  the same request.
"""
function create_queue_environment(
    farmId,
    priority,
    queueId,
    template,
    templateType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "POST",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/environments",
        Dict{String,Any}(
            "priority" => priority,
            "template" => template,
            "templateType" => templateType,
            "X-Amz-Client-Token" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_queue_environment(
    farmId,
    priority,
    queueId,
    template,
    templateType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "POST",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/environments",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "priority" => priority,
                    "template" => template,
                    "templateType" => templateType,
                    "X-Amz-Client-Token" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_queue_fleet_association(farm_id, fleet_id, queue_id)
    create_queue_fleet_association(farm_id, fleet_id, queue_id, params::Dict{String,<:Any})

Creates an association between a queue and a fleet.

# Arguments
- `farm_id`: The ID of the farm that the queue and fleet belong to.
- `fleet_id`: The fleet ID.
- `queue_id`: The queue ID.

"""
function create_queue_fleet_association(
    farmId, fleetId, queueId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "PUT",
        "/2023-10-12/farms/$(farmId)/queue-fleet-associations",
        Dict{String,Any}("fleetId" => fleetId, "queueId" => queueId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_queue_fleet_association(
    farmId,
    fleetId,
    queueId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "PUT",
        "/2023-10-12/farms/$(farmId)/queue-fleet-associations",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("fleetId" => fleetId, "queueId" => queueId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_storage_profile(display_name, farm_id, os_family)
    create_storage_profile(display_name, farm_id, os_family, params::Dict{String,<:Any})

Creates a storage profile that specifies the operating system, file type, and file location
of resources used on a farm.

# Arguments
- `display_name`: The display name of the storage profile.
- `farm_id`: The farm ID of the farm to connect to the storage profile.
- `os_family`: The type of operating system (OS) for the storage profile.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"X-Amz-Client-Token"`: The unique token which the server uses to recognize retries of
  the same request.
- `"fileSystemLocations"`: File system paths to include in the storage profile.
"""
function create_storage_profile(
    displayName, farmId, osFamily; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "POST",
        "/2023-10-12/farms/$(farmId)/storage-profiles",
        Dict{String,Any}(
            "displayName" => displayName,
            "osFamily" => osFamily,
            "X-Amz-Client-Token" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_storage_profile(
    displayName,
    farmId,
    osFamily,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "POST",
        "/2023-10-12/farms/$(farmId)/storage-profiles",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "displayName" => displayName,
                    "osFamily" => osFamily,
                    "X-Amz-Client-Token" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_worker(farm_id, fleet_id)
    create_worker(farm_id, fleet_id, params::Dict{String,<:Any})

Creates a worker. A worker tells your instance how much processing power (vCPU), and memory
(GiB) you’ll need to assemble the digital assets held within a particular instance. You
can specify certain instance types to use, or let the worker know which instances types to
exclude.

# Arguments
- `farm_id`: The farm ID of the farm to connect to the worker.
- `fleet_id`: The fleet ID to connect to the worker.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"X-Amz-Client-Token"`: The unique token which the server uses to recognize retries of
  the same request.
- `"hostProperties"`: The IP address and host name of the worker.
"""
function create_worker(farmId, fleetId; aws_config::AbstractAWSConfig=current_aws_config())
    return deadline(
        "POST",
        "/2023-10-12/farms/$(farmId)/fleets/$(fleetId)/workers",
        Dict{String,Any}("X-Amz-Client-Token" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_worker(
    farmId,
    fleetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "POST",
        "/2023-10-12/farms/$(farmId)/fleets/$(fleetId)/workers",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("X-Amz-Client-Token" => string(uuid4())), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_budget(budget_id, farm_id)
    delete_budget(budget_id, farm_id, params::Dict{String,<:Any})

Deletes a budget.

# Arguments
- `budget_id`: The budget ID of the budget to delete.
- `farm_id`: The farm ID of the farm to remove from the budget.

"""
function delete_budget(budgetId, farmId; aws_config::AbstractAWSConfig=current_aws_config())
    return deadline(
        "DELETE",
        "/2023-10-12/farms/$(farmId)/budgets/$(budgetId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_budget(
    budgetId,
    farmId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "DELETE",
        "/2023-10-12/farms/$(farmId)/budgets/$(budgetId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_farm(farm_id)
    delete_farm(farm_id, params::Dict{String,<:Any})

Deletes a farm.

# Arguments
- `farm_id`: The farm ID of the farm to delete.

"""
function delete_farm(farmId; aws_config::AbstractAWSConfig=current_aws_config())
    return deadline(
        "DELETE",
        "/2023-10-12/farms/$(farmId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_farm(
    farmId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "DELETE",
        "/2023-10-12/farms/$(farmId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_fleet(farm_id, fleet_id)
    delete_fleet(farm_id, fleet_id, params::Dict{String,<:Any})

Deletes a fleet.

# Arguments
- `farm_id`: The farm ID of the farm to remove from the fleet.
- `fleet_id`: The fleet ID of the fleet to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"X-Amz-Client-Token"`: The unique token which the server uses to recognize retries of
  the same request.
"""
function delete_fleet(farmId, fleetId; aws_config::AbstractAWSConfig=current_aws_config())
    return deadline(
        "DELETE",
        "/2023-10-12/farms/$(farmId)/fleets/$(fleetId)",
        Dict{String,Any}("X-Amz-Client-Token" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_fleet(
    farmId,
    fleetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "DELETE",
        "/2023-10-12/farms/$(farmId)/fleets/$(fleetId)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("X-Amz-Client-Token" => string(uuid4())), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_license_endpoint(license_endpoint_id)
    delete_license_endpoint(license_endpoint_id, params::Dict{String,<:Any})

Deletes a license endpoint.

# Arguments
- `license_endpoint_id`: The license endpoint ID of the license endpoint to delete.

"""
function delete_license_endpoint(
    licenseEndpointId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "DELETE",
        "/2023-10-12/license-endpoints/$(licenseEndpointId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_license_endpoint(
    licenseEndpointId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "DELETE",
        "/2023-10-12/license-endpoints/$(licenseEndpointId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_metered_product(license_endpoint_id, product_id)
    delete_metered_product(license_endpoint_id, product_id, params::Dict{String,<:Any})

Deletes a metered product.

# Arguments
- `license_endpoint_id`: The ID of the license endpoint from which to remove the metered
  product.
- `product_id`: The product ID to remove from the license endpoint.

"""
function delete_metered_product(
    licenseEndpointId, productId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "DELETE",
        "/2023-10-12/license-endpoints/$(licenseEndpointId)/metered-products/$(productId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_metered_product(
    licenseEndpointId,
    productId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "DELETE",
        "/2023-10-12/license-endpoints/$(licenseEndpointId)/metered-products/$(productId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_monitor(monitor_id)
    delete_monitor(monitor_id, params::Dict{String,<:Any})

Removes a Deadline Cloud monitor. After you delete a monitor, you can create a new one and
attach farms to the monitor.

# Arguments
- `monitor_id`: The unique identifier of the monitor to delete. This ID is returned by the
  CreateMonitor operation, and is included in the response to the GetMonitor operation.

"""
function delete_monitor(monitorId; aws_config::AbstractAWSConfig=current_aws_config())
    return deadline(
        "DELETE",
        "/2023-10-12/monitors/$(monitorId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_monitor(
    monitorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "DELETE",
        "/2023-10-12/monitors/$(monitorId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_queue(farm_id, queue_id)
    delete_queue(farm_id, queue_id, params::Dict{String,<:Any})

Deletes a queue.

# Arguments
- `farm_id`: The ID of the farm from which to remove the queue.
- `queue_id`: The queue ID of the queue to delete.

"""
function delete_queue(farmId, queueId; aws_config::AbstractAWSConfig=current_aws_config())
    return deadline(
        "DELETE",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_queue(
    farmId,
    queueId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "DELETE",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_queue_environment(farm_id, queue_environment_id, queue_id)
    delete_queue_environment(farm_id, queue_environment_id, queue_id, params::Dict{String,<:Any})

Deletes a queue environment.

# Arguments
- `farm_id`: The farm ID of the farm from which to remove the queue environment.
- `queue_environment_id`: The queue environment ID of the queue environment to delete.
- `queue_id`: The queue ID of the queue environment to delete.

"""
function delete_queue_environment(
    farmId, queueEnvironmentId, queueId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "DELETE",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/environments/$(queueEnvironmentId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_queue_environment(
    farmId,
    queueEnvironmentId,
    queueId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "DELETE",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/environments/$(queueEnvironmentId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_queue_fleet_association(farm_id, fleet_id, queue_id)
    delete_queue_fleet_association(farm_id, fleet_id, queue_id, params::Dict{String,<:Any})

Deletes a queue-fleet association.

# Arguments
- `farm_id`: The farm ID of the farm that holds the queue-fleet association.
- `fleet_id`: The fleet ID of the queue-fleet association.
- `queue_id`: The queue ID of the queue-fleet association.

"""
function delete_queue_fleet_association(
    farmId, fleetId, queueId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "DELETE",
        "/2023-10-12/farms/$(farmId)/queue-fleet-associations/$(queueId)/$(fleetId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_queue_fleet_association(
    farmId,
    fleetId,
    queueId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "DELETE",
        "/2023-10-12/farms/$(farmId)/queue-fleet-associations/$(queueId)/$(fleetId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_storage_profile(farm_id, storage_profile_id)
    delete_storage_profile(farm_id, storage_profile_id, params::Dict{String,<:Any})

Deletes a storage profile.

# Arguments
- `farm_id`: The farm ID of the farm from which to remove the storage profile.
- `storage_profile_id`: The storage profile ID of the storage profile to delete.

"""
function delete_storage_profile(
    farmId, storageProfileId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "DELETE",
        "/2023-10-12/farms/$(farmId)/storage-profiles/$(storageProfileId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_storage_profile(
    farmId,
    storageProfileId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "DELETE",
        "/2023-10-12/farms/$(farmId)/storage-profiles/$(storageProfileId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_worker(farm_id, fleet_id, worker_id)
    delete_worker(farm_id, fleet_id, worker_id, params::Dict{String,<:Any})

Deletes a worker.

# Arguments
- `farm_id`: The farm ID of the worker to delete.
- `fleet_id`: The fleet ID of the worker to delete.
- `worker_id`: The worker ID of the worker to delete.

"""
function delete_worker(
    farmId, fleetId, workerId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "DELETE",
        "/2023-10-12/farms/$(farmId)/fleets/$(fleetId)/workers/$(workerId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_worker(
    farmId,
    fleetId,
    workerId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "DELETE",
        "/2023-10-12/farms/$(farmId)/fleets/$(fleetId)/workers/$(workerId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_member_from_farm(farm_id, principal_id)
    disassociate_member_from_farm(farm_id, principal_id, params::Dict{String,<:Any})

Disassociates a member from a farm.

# Arguments
- `farm_id`: The farm ID of the farm to disassociate from the member.
- `principal_id`: A member's principal ID to disassociate from a farm.

"""
function disassociate_member_from_farm(
    farmId, principalId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "DELETE",
        "/2023-10-12/farms/$(farmId)/members/$(principalId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_member_from_farm(
    farmId,
    principalId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "DELETE",
        "/2023-10-12/farms/$(farmId)/members/$(principalId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_member_from_fleet(farm_id, fleet_id, principal_id)
    disassociate_member_from_fleet(farm_id, fleet_id, principal_id, params::Dict{String,<:Any})

Disassociates a member from a fleet.

# Arguments
- `farm_id`: The farm ID of the fleet to disassociate a member from.
- `fleet_id`: The fleet ID of the fleet to from which to disassociate a member.
- `principal_id`: A member's principal ID to disassociate from a fleet.

"""
function disassociate_member_from_fleet(
    farmId, fleetId, principalId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "DELETE",
        "/2023-10-12/farms/$(farmId)/fleets/$(fleetId)/members/$(principalId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_member_from_fleet(
    farmId,
    fleetId,
    principalId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "DELETE",
        "/2023-10-12/farms/$(farmId)/fleets/$(fleetId)/members/$(principalId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_member_from_job(farm_id, job_id, principal_id, queue_id)
    disassociate_member_from_job(farm_id, job_id, principal_id, queue_id, params::Dict{String,<:Any})

Disassociates a member from a job.

# Arguments
- `farm_id`: The farm ID for the job to disassociate from the member.
- `job_id`: The job ID to disassociate from a member in a job.
- `principal_id`: A member's principal ID to disassociate from a job.
- `queue_id`: The queue ID connected to a job for which you're disassociating a member.

"""
function disassociate_member_from_job(
    farmId, jobId, principalId, queueId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "DELETE",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/jobs/$(jobId)/members/$(principalId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_member_from_job(
    farmId,
    jobId,
    principalId,
    queueId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "DELETE",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/jobs/$(jobId)/members/$(principalId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_member_from_queue(farm_id, principal_id, queue_id)
    disassociate_member_from_queue(farm_id, principal_id, queue_id, params::Dict{String,<:Any})

Disassociates a member from a queue.

# Arguments
- `farm_id`: The farm ID for the queue to disassociate from a member.
- `principal_id`: A member's principal ID to disassociate from a queue.
- `queue_id`: The queue ID of the queue in which you're disassociating from a member.

"""
function disassociate_member_from_queue(
    farmId, principalId, queueId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "DELETE",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/members/$(principalId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_member_from_queue(
    farmId,
    principalId,
    queueId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "DELETE",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/members/$(principalId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_budget(budget_id, farm_id)
    get_budget(budget_id, farm_id, params::Dict{String,<:Any})

Get a budget.

# Arguments
- `budget_id`: The budget ID.
- `farm_id`: The farm ID of the farm connected to the budget.

"""
function get_budget(budgetId, farmId; aws_config::AbstractAWSConfig=current_aws_config())
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/budgets/$(budgetId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_budget(
    budgetId,
    farmId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/budgets/$(budgetId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_farm(farm_id)
    get_farm(farm_id, params::Dict{String,<:Any})

Get a farm.

# Arguments
- `farm_id`: The farm ID of the farm.

"""
function get_farm(farmId; aws_config::AbstractAWSConfig=current_aws_config())
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_farm(
    farmId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_fleet(farm_id, fleet_id)
    get_fleet(farm_id, fleet_id, params::Dict{String,<:Any})

Get a fleet.

# Arguments
- `farm_id`: The farm ID of the farm in the fleet.
- `fleet_id`: The fleet ID of the fleet to get.

"""
function get_fleet(farmId, fleetId; aws_config::AbstractAWSConfig=current_aws_config())
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/fleets/$(fleetId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_fleet(
    farmId,
    fleetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/fleets/$(fleetId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_job(farm_id, job_id, queue_id)
    get_job(farm_id, job_id, queue_id, params::Dict{String,<:Any})

Gets a Deadline Cloud job.

# Arguments
- `farm_id`: The farm ID of the farm in the job.
- `job_id`: The job ID.
- `queue_id`: The queue ID associated with the job.

"""
function get_job(farmId, jobId, queueId; aws_config::AbstractAWSConfig=current_aws_config())
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/jobs/$(jobId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_job(
    farmId,
    jobId,
    queueId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/jobs/$(jobId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_license_endpoint(license_endpoint_id)
    get_license_endpoint(license_endpoint_id, params::Dict{String,<:Any})

Gets a licence endpoint.

# Arguments
- `license_endpoint_id`: The license endpoint ID.

"""
function get_license_endpoint(
    licenseEndpointId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "GET",
        "/2023-10-12/license-endpoints/$(licenseEndpointId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_license_endpoint(
    licenseEndpointId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "GET",
        "/2023-10-12/license-endpoints/$(licenseEndpointId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_monitor(monitor_id)
    get_monitor(monitor_id, params::Dict{String,<:Any})

Gets information about the specified monitor.

# Arguments
- `monitor_id`: The unique identifier for the monitor. This ID is returned by the
  CreateMonitor operation.

"""
function get_monitor(monitorId; aws_config::AbstractAWSConfig=current_aws_config())
    return deadline(
        "GET",
        "/2023-10-12/monitors/$(monitorId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_monitor(
    monitorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "GET",
        "/2023-10-12/monitors/$(monitorId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_queue(farm_id, queue_id)
    get_queue(farm_id, queue_id, params::Dict{String,<:Any})

Gets a queue.

# Arguments
- `farm_id`: The farm ID of the farm in the queue.
- `queue_id`: The queue ID for the queue to retrieve.

"""
function get_queue(farmId, queueId; aws_config::AbstractAWSConfig=current_aws_config())
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_queue(
    farmId,
    queueId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_queue_environment(farm_id, queue_environment_id, queue_id)
    get_queue_environment(farm_id, queue_environment_id, queue_id, params::Dict{String,<:Any})

Gets a queue environment.

# Arguments
- `farm_id`: The farm ID for the queue environment.
- `queue_environment_id`: The queue environment ID.
- `queue_id`: The queue ID for the queue environment.

"""
function get_queue_environment(
    farmId, queueEnvironmentId, queueId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/environments/$(queueEnvironmentId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_queue_environment(
    farmId,
    queueEnvironmentId,
    queueId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/environments/$(queueEnvironmentId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_queue_fleet_association(farm_id, fleet_id, queue_id)
    get_queue_fleet_association(farm_id, fleet_id, queue_id, params::Dict{String,<:Any})

Gets a queue-fleet association.

# Arguments
- `farm_id`: The farm ID of the farm that contains the queue-fleet association.
- `fleet_id`: The fleet ID for the queue-fleet association.
- `queue_id`: The queue ID for the queue-fleet association.

"""
function get_queue_fleet_association(
    farmId, fleetId, queueId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/queue-fleet-associations/$(queueId)/$(fleetId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_queue_fleet_association(
    farmId,
    fleetId,
    queueId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/queue-fleet-associations/$(queueId)/$(fleetId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_session(farm_id, job_id, queue_id, session_id)
    get_session(farm_id, job_id, queue_id, session_id, params::Dict{String,<:Any})

Gets a session.

# Arguments
- `farm_id`: The farm ID for the session.
- `job_id`: The job ID for the session.
- `queue_id`: The queue ID for the session.
- `session_id`: The session ID.

"""
function get_session(
    farmId, jobId, queueId, sessionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/jobs/$(jobId)/sessions/$(sessionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_session(
    farmId,
    jobId,
    queueId,
    sessionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/jobs/$(jobId)/sessions/$(sessionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_session_action(farm_id, job_id, queue_id, session_action_id)
    get_session_action(farm_id, job_id, queue_id, session_action_id, params::Dict{String,<:Any})

Gets a session action for the job.

# Arguments
- `farm_id`: The farm ID for the session action.
- `job_id`: The job ID for the session.
- `queue_id`: The queue ID for the session action.
- `session_action_id`: The session action ID for the session.

"""
function get_session_action(
    farmId,
    jobId,
    queueId,
    sessionActionId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/jobs/$(jobId)/session-actions/$(sessionActionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_session_action(
    farmId,
    jobId,
    queueId,
    sessionActionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/jobs/$(jobId)/session-actions/$(sessionActionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_sessions_statistics_aggregation(aggregation_id, farm_id)
    get_sessions_statistics_aggregation(aggregation_id, farm_id, params::Dict{String,<:Any})

Gets a set of statistics for queues or farms. Before you can call the
GetSessionStatisticsAggregation operation, you must first call the
StartSessionsStatisticsAggregation operation. Statistics are available for 1 hour after you
call the StartSessionsStatisticsAggregation operation.

# Arguments
- `aggregation_id`: The identifier returned by the StartSessionsStatisticsAggregation
  operation that identifies the aggregated statistics.
- `farm_id`: The identifier of the farm to include in the statistics. This should be the
  same as the farm ID used in the call to the StartSessionsStatisticsAggregation operation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return. Use this parameter with
  NextToken to get results as a set of sequential pages.
- `"nextToken"`: The token for the next set of results, or null to start from the beginning.
"""
function get_sessions_statistics_aggregation(
    aggregationId, farmId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/sessions-statistics-aggregation",
        Dict{String,Any}("aggregationId" => aggregationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_sessions_statistics_aggregation(
    aggregationId,
    farmId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/sessions-statistics-aggregation",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("aggregationId" => aggregationId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_step(farm_id, job_id, queue_id, step_id)
    get_step(farm_id, job_id, queue_id, step_id, params::Dict{String,<:Any})

Gets a step.

# Arguments
- `farm_id`: The farm ID for the step.
- `job_id`: The job ID for the step.
- `queue_id`: The queue ID for the step.
- `step_id`: The step ID.

"""
function get_step(
    farmId, jobId, queueId, stepId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/jobs/$(jobId)/steps/$(stepId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_step(
    farmId,
    jobId,
    queueId,
    stepId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/jobs/$(jobId)/steps/$(stepId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_storage_profile(farm_id, storage_profile_id)
    get_storage_profile(farm_id, storage_profile_id, params::Dict{String,<:Any})

Gets a storage profile.

# Arguments
- `farm_id`: The farm ID for the storage profile.
- `storage_profile_id`: The storage profile ID.

"""
function get_storage_profile(
    farmId, storageProfileId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/storage-profiles/$(storageProfileId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_storage_profile(
    farmId,
    storageProfileId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/storage-profiles/$(storageProfileId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_storage_profile_for_queue(farm_id, queue_id, storage_profile_id)
    get_storage_profile_for_queue(farm_id, queue_id, storage_profile_id, params::Dict{String,<:Any})

Gets a storage profile for a queue.

# Arguments
- `farm_id`: The farm ID for the queue in storage profile.
- `queue_id`: The queue ID the queue in the storage profile.
- `storage_profile_id`: The storage profile ID for the storage profile in the queue.

"""
function get_storage_profile_for_queue(
    farmId, queueId, storageProfileId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/storage-profiles/$(storageProfileId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_storage_profile_for_queue(
    farmId,
    queueId,
    storageProfileId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/storage-profiles/$(storageProfileId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_task(farm_id, job_id, queue_id, step_id, task_id)
    get_task(farm_id, job_id, queue_id, step_id, task_id, params::Dict{String,<:Any})

Gets a task.

# Arguments
- `farm_id`: The farm ID of the farm connected to the task.
- `job_id`: The job ID of the job connected to the task.
- `queue_id`: The queue ID for the queue connected to the task.
- `step_id`: The step ID for the step connected to the task.
- `task_id`: The task ID.

"""
function get_task(
    farmId,
    jobId,
    queueId,
    stepId,
    taskId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/jobs/$(jobId)/steps/$(stepId)/tasks/$(taskId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_task(
    farmId,
    jobId,
    queueId,
    stepId,
    taskId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/jobs/$(jobId)/steps/$(stepId)/tasks/$(taskId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_worker(farm_id, fleet_id, worker_id)
    get_worker(farm_id, fleet_id, worker_id, params::Dict{String,<:Any})

Gets a worker.

# Arguments
- `farm_id`: The farm ID for the worker.
- `fleet_id`: The fleet ID of the worker.
- `worker_id`: The worker ID.

"""
function get_worker(
    farmId, fleetId, workerId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/fleets/$(fleetId)/workers/$(workerId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_worker(
    farmId,
    fleetId,
    workerId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/fleets/$(fleetId)/workers/$(workerId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_available_metered_products()
    list_available_metered_products(params::Dict{String,<:Any})

A list of the available metered products.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return. Use this parameter with
  NextToken to get results as a set of sequential pages.
- `"nextToken"`: The token for the next set of results, or null to start from the beginning.
"""
function list_available_metered_products(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "GET",
        "/2023-10-12/metered-products";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_available_metered_products(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "GET",
        "/2023-10-12/metered-products",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_budgets(farm_id)
    list_budgets(farm_id, params::Dict{String,<:Any})

A list of budgets in a farm.

# Arguments
- `farm_id`: The farm ID associated with the budgets.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return. Use this parameter with
  NextToken to get results as a set of sequential pages.
- `"nextToken"`: The token for the next set of results, or null to start from the beginning.
- `"status"`: The status to list for the budgets.
"""
function list_budgets(farmId; aws_config::AbstractAWSConfig=current_aws_config())
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/budgets";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_budgets(
    farmId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/budgets",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_farm_members(farm_id)
    list_farm_members(farm_id, params::Dict{String,<:Any})

Lists the members of a farm.

# Arguments
- `farm_id`: The farm ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return. Use this parameter with
  NextToken to get results as a set of sequential pages.
- `"nextToken"`: The token for the next set of results, or null to start from the beginning.
"""
function list_farm_members(farmId; aws_config::AbstractAWSConfig=current_aws_config())
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/members";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_farm_members(
    farmId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/members",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_farms()
    list_farms(params::Dict{String,<:Any})

Lists farms.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return. Use this parameter with
  NextToken to get results as a set of sequential pages.
- `"nextToken"`: The token for the next set of results, or null to start from the beginning.
- `"principalId"`: The principal ID of the member to list on the farm.
"""
function list_farms(; aws_config::AbstractAWSConfig=current_aws_config())
    return deadline(
        "GET", "/2023-10-12/farms"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_farms(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "GET",
        "/2023-10-12/farms",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_fleet_members(farm_id, fleet_id)
    list_fleet_members(farm_id, fleet_id, params::Dict{String,<:Any})

Lists fleet members.

# Arguments
- `farm_id`: The farm ID of the fleet.
- `fleet_id`: The fleet ID to include on the list.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return. Use this parameter with
  NextToken to get results as a set of sequential pages.
- `"nextToken"`: The token for the next set of results, or null to start from the beginning.
"""
function list_fleet_members(
    farmId, fleetId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/fleets/$(fleetId)/members";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_fleet_members(
    farmId,
    fleetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/fleets/$(fleetId)/members",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_fleets(farm_id)
    list_fleets(farm_id, params::Dict{String,<:Any})

Lists fleets.

# Arguments
- `farm_id`: The farm ID of the fleets.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"displayName"`: The display names of a list of fleets.
- `"maxResults"`: The maximum number of results to return. Use this parameter with
  NextToken to get results as a set of sequential pages.
- `"nextToken"`: The token for the next set of results, or null to start from the beginning.
- `"principalId"`: The principal ID of the members to include in the fleet.
- `"status"`: The status of the fleet.
"""
function list_fleets(farmId; aws_config::AbstractAWSConfig=current_aws_config())
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/fleets";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_fleets(
    farmId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/fleets",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_job_members(farm_id, job_id, queue_id)
    list_job_members(farm_id, job_id, queue_id, params::Dict{String,<:Any})

Lists members on a job.

# Arguments
- `farm_id`: The farm ID of the job to list.
- `job_id`: The job ID to include on the list.
- `queue_id`: The queue ID to include on the list.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return. Use this parameter with
  NextToken to get results as a set of sequential pages.
- `"nextToken"`: The token for the next set of results, or null to start from the beginning.
"""
function list_job_members(
    farmId, jobId, queueId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/jobs/$(jobId)/members";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_job_members(
    farmId,
    jobId,
    queueId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/jobs/$(jobId)/members",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_jobs(farm_id, queue_id)
    list_jobs(farm_id, queue_id, params::Dict{String,<:Any})

Lists jobs.

# Arguments
- `farm_id`: The farm ID for the jobs.
- `queue_id`: The queue ID for the job.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return. Use this parameter with
  NextToken to get results as a set of sequential pages.
- `"nextToken"`: The token for the next set of results, or null to start from the beginning.
- `"principalId"`: The principal ID of the members on the jobs.
"""
function list_jobs(farmId, queueId; aws_config::AbstractAWSConfig=current_aws_config())
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/jobs";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_jobs(
    farmId,
    queueId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/jobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_license_endpoints()
    list_license_endpoints(params::Dict{String,<:Any})

Lists license endpoints.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return. Use this parameter with
  NextToken to get results as a set of sequential pages.
- `"nextToken"`: The token for the next set of results, or null to start from the beginning.
"""
function list_license_endpoints(; aws_config::AbstractAWSConfig=current_aws_config())
    return deadline(
        "GET",
        "/2023-10-12/license-endpoints";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_license_endpoints(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "GET",
        "/2023-10-12/license-endpoints",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_metered_products(license_endpoint_id)
    list_metered_products(license_endpoint_id, params::Dict{String,<:Any})

Lists metered products.

# Arguments
- `license_endpoint_id`: The license endpoint ID to include on the list of metered products.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return. Use this parameter with
  NextToken to get results as a set of sequential pages.
- `"nextToken"`: The token for the next set of results, or null to start from the beginning.
"""
function list_metered_products(
    licenseEndpointId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "GET",
        "/2023-10-12/license-endpoints/$(licenseEndpointId)/metered-products";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_metered_products(
    licenseEndpointId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "GET",
        "/2023-10-12/license-endpoints/$(licenseEndpointId)/metered-products",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_monitors()
    list_monitors(params::Dict{String,<:Any})

Gets a list of your monitors in Deadline Cloud.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return. Use this parameter with
  NextToken to get results as a set of sequential pages.
- `"nextToken"`: The token for the next set of results, or null to start from the beginning.
"""
function list_monitors(; aws_config::AbstractAWSConfig=current_aws_config())
    return deadline(
        "GET",
        "/2023-10-12/monitors";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_monitors(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "GET",
        "/2023-10-12/monitors",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_queue_environments(farm_id, queue_id)
    list_queue_environments(farm_id, queue_id, params::Dict{String,<:Any})

Lists queue environments.

# Arguments
- `farm_id`: The farm ID for the queue environment list.
- `queue_id`: The queue ID for the queue environment list.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return. Use this parameter with
  NextToken to get results as a set of sequential pages.
- `"nextToken"`: The token for the next set of results, or null to start from the beginning.
"""
function list_queue_environments(
    farmId, queueId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/environments";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_queue_environments(
    farmId,
    queueId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/environments",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_queue_fleet_associations(farm_id)
    list_queue_fleet_associations(farm_id, params::Dict{String,<:Any})

Lists queue-fleet associations.

# Arguments
- `farm_id`: The farm ID for the queue-fleet association list.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"fleetId"`: The fleet ID for the queue-fleet association list.
- `"maxResults"`: The maximum number of results to return. Use this parameter with
  NextToken to get results as a set of sequential pages.
- `"nextToken"`: The token for the next set of results, or null to start from the beginning.
- `"queueId"`: The queue ID for the queue-fleet association list.
"""
function list_queue_fleet_associations(
    farmId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/queue-fleet-associations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_queue_fleet_associations(
    farmId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/queue-fleet-associations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_queue_members(farm_id, queue_id)
    list_queue_members(farm_id, queue_id, params::Dict{String,<:Any})

Lists the members in a queue.

# Arguments
- `farm_id`: The farm ID for the queue.
- `queue_id`: The queue ID to include on the list.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return. Use this parameter with
  NextToken to get results as a set of sequential pages.
- `"nextToken"`: The token for the next set of results, or null to start from the beginning.
"""
function list_queue_members(
    farmId, queueId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/members";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_queue_members(
    farmId,
    queueId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/members",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_queues(farm_id)
    list_queues(farm_id, params::Dict{String,<:Any})

Lists queues.

# Arguments
- `farm_id`: The farm ID of the queue.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return. Use this parameter with
  NextToken to get results as a set of sequential pages.
- `"nextToken"`: The token for the next set of results, or null to start from the beginning.
- `"principalId"`: The principal ID. This filter is only valid when using Nimble Studio
  credentials and should match the user ID in the credentials of the caller.
- `"status"`: The status of the queues listed.    ACTIVE–The queues are active.
  SCHEDULING–The queues are scheduling.    SCHEDULING_BLOCKED–The queue scheduling is
  blocked for these queues.
"""
function list_queues(farmId; aws_config::AbstractAWSConfig=current_aws_config())
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/queues";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_queues(
    farmId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/queues",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_session_actions(farm_id, job_id, queue_id)
    list_session_actions(farm_id, job_id, queue_id, params::Dict{String,<:Any})

Lists session actions.

# Arguments
- `farm_id`: The farm ID for the session actions list.
- `job_id`: The job ID for the session actions list.
- `queue_id`: The queue ID for the session actions list.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return. Use this parameter with
  NextToken to get results as a set of sequential pages.
- `"nextToken"`: The token for the next set of results, or null to start from the beginning.
- `"sessionId"`: The session ID to include on the sessions action list.
- `"taskId"`: The task ID for the session actions list.
"""
function list_session_actions(
    farmId, jobId, queueId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/jobs/$(jobId)/session-actions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_session_actions(
    farmId,
    jobId,
    queueId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/jobs/$(jobId)/session-actions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_sessions(farm_id, job_id, queue_id)
    list_sessions(farm_id, job_id, queue_id, params::Dict{String,<:Any})

Lists sessions.

# Arguments
- `farm_id`: The farm ID for the list of sessions.
- `job_id`: The job ID for the list of sessions.
- `queue_id`: The queue ID for the list of sessions

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return. Use this parameter with
  NextToken to get results as a set of sequential pages.
- `"nextToken"`: The token for the next set of results, or null to start from the beginning.
"""
function list_sessions(
    farmId, jobId, queueId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/jobs/$(jobId)/sessions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_sessions(
    farmId,
    jobId,
    queueId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/jobs/$(jobId)/sessions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_sessions_for_worker(farm_id, fleet_id, worker_id)
    list_sessions_for_worker(farm_id, fleet_id, worker_id, params::Dict{String,<:Any})

Lists sessions for a worker.

# Arguments
- `farm_id`: The farm ID for the session.
- `fleet_id`: The fleet ID for the session.
- `worker_id`: The worker ID for the session.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return. Use this parameter with
  NextToken to get results as a set of sequential pages.
- `"nextToken"`: The token for the next set of results, or null to start from the beginning.
"""
function list_sessions_for_worker(
    farmId, fleetId, workerId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/fleets/$(fleetId)/workers/$(workerId)/sessions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_sessions_for_worker(
    farmId,
    fleetId,
    workerId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/fleets/$(fleetId)/workers/$(workerId)/sessions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_step_consumers(farm_id, job_id, queue_id, step_id)
    list_step_consumers(farm_id, job_id, queue_id, step_id, params::Dict{String,<:Any})

Lists step consumers.

# Arguments
- `farm_id`: The farm ID for the list of step consumers.
- `job_id`: The job ID for the step consumer.
- `queue_id`: The queue ID for the step consumer.
- `step_id`: The step ID to include on the list.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return. Use this parameter with
  NextToken to get results as a set of sequential pages.
- `"nextToken"`: The token for the next set of results, or null to start from the beginning.
"""
function list_step_consumers(
    farmId, jobId, queueId, stepId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/jobs/$(jobId)/steps/$(stepId)/consumers";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_step_consumers(
    farmId,
    jobId,
    queueId,
    stepId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/jobs/$(jobId)/steps/$(stepId)/consumers",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_step_dependencies(farm_id, job_id, queue_id, step_id)
    list_step_dependencies(farm_id, job_id, queue_id, step_id, params::Dict{String,<:Any})

Lists the dependencies for a step.

# Arguments
- `farm_id`: The farm ID for the step dependencies list.
- `job_id`: The job ID for the step dependencies list.
- `queue_id`: The queue ID for the step dependencies list.
- `step_id`: The step ID to include on the list.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return. Use this parameter with
  NextToken to get results as a set of sequential pages.
- `"nextToken"`: The token for the next set of results, or null to start from the beginning.
"""
function list_step_dependencies(
    farmId, jobId, queueId, stepId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/jobs/$(jobId)/steps/$(stepId)/dependencies";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_step_dependencies(
    farmId,
    jobId,
    queueId,
    stepId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/jobs/$(jobId)/steps/$(stepId)/dependencies",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_steps(farm_id, job_id, queue_id)
    list_steps(farm_id, job_id, queue_id, params::Dict{String,<:Any})

Lists steps for a job.

# Arguments
- `farm_id`: The farm ID to include on the list of steps.
- `job_id`: The job ID to include on the list of steps.
- `queue_id`: The queue ID to include on the list of steps.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return. Use this parameter with
  NextToken to get results as a set of sequential pages.
- `"nextToken"`: The token for the next set of results, or null to start from the beginning.
"""
function list_steps(
    farmId, jobId, queueId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/jobs/$(jobId)/steps";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_steps(
    farmId,
    jobId,
    queueId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/jobs/$(jobId)/steps",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_storage_profiles(farm_id)
    list_storage_profiles(farm_id, params::Dict{String,<:Any})

Lists storage profiles.

# Arguments
- `farm_id`: The farm ID of the storage profile.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return. Use this parameter with
  NextToken to get results as a set of sequential pages.
- `"nextToken"`: The token for the next set of results, or null to start from the beginning.
"""
function list_storage_profiles(farmId; aws_config::AbstractAWSConfig=current_aws_config())
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/storage-profiles";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_storage_profiles(
    farmId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/storage-profiles",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_storage_profiles_for_queue(farm_id, queue_id)
    list_storage_profiles_for_queue(farm_id, queue_id, params::Dict{String,<:Any})

Lists storage profiles for a queue.

# Arguments
- `farm_id`: The farm ID of the queue's storage profile.
- `queue_id`: The queue ID for the storage profile.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return. Use this parameter with
  NextToken to get results as a set of sequential pages.
- `"nextToken"`: The token for the next set of results, or null to start from the beginning.
"""
function list_storage_profiles_for_queue(
    farmId, queueId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/storage-profiles";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_storage_profiles_for_queue(
    farmId,
    queueId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/storage-profiles",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists tags for a resource.

# Arguments
- `resource_arn`: The resource ARN to list tags for.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "GET",
        "/2023-10-12/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "GET",
        "/2023-10-12/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tasks(farm_id, job_id, queue_id, step_id)
    list_tasks(farm_id, job_id, queue_id, step_id, params::Dict{String,<:Any})

Lists tasks for a job.

# Arguments
- `farm_id`: The farm ID connected to the tasks.
- `job_id`: The job ID for the tasks.
- `queue_id`: The queue ID connected to the tasks.
- `step_id`: The step ID for the tasks.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return. Use this parameter with
  NextToken to get results as a set of sequential pages.
- `"nextToken"`: The token for the next set of results, or null to start from the beginning.
"""
function list_tasks(
    farmId, jobId, queueId, stepId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/jobs/$(jobId)/steps/$(stepId)/tasks";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tasks(
    farmId,
    jobId,
    queueId,
    stepId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/jobs/$(jobId)/steps/$(stepId)/tasks",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_workers(farm_id, fleet_id)
    list_workers(farm_id, fleet_id, params::Dict{String,<:Any})

Lists workers.

# Arguments
- `farm_id`: The farm ID connected to the workers.
- `fleet_id`: The fleet ID of the workers.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return. Use this parameter with
  NextToken to get results as a set of sequential pages.
- `"nextToken"`: The token for the next set of results, or null to start from the beginning.
"""
function list_workers(farmId, fleetId; aws_config::AbstractAWSConfig=current_aws_config())
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/fleets/$(fleetId)/workers";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_workers(
    farmId,
    fleetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "GET",
        "/2023-10-12/farms/$(farmId)/fleets/$(fleetId)/workers",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_metered_product(license_endpoint_id, product_id)
    put_metered_product(license_endpoint_id, product_id, params::Dict{String,<:Any})

Adds a metered product.

# Arguments
- `license_endpoint_id`: The license endpoint ID to add to the metered product.
- `product_id`: The product ID to add to the metered product.

"""
function put_metered_product(
    licenseEndpointId, productId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "PUT",
        "/2023-10-12/license-endpoints/$(licenseEndpointId)/metered-products/$(productId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_metered_product(
    licenseEndpointId,
    productId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "PUT",
        "/2023-10-12/license-endpoints/$(licenseEndpointId)/metered-products/$(productId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    search_jobs(farm_id, item_offset, queue_ids)
    search_jobs(farm_id, item_offset, queue_ids, params::Dict{String,<:Any})

Searches for jobs.

# Arguments
- `farm_id`: The farm ID of the job.
- `item_offset`: Defines how far into the scrollable list to start the return of results.
- `queue_ids`: The queue ID to use in the job search.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filterExpressions"`: The filter expression, AND or OR, to use when searching among a
  group of search strings in a resource. You can use two groupings per search each within
  parenthesis ().
- `"pageSize"`: Specifies the number of items per page for the resource.
- `"sortExpressions"`: The search terms for a resource.
"""
function search_jobs(
    farmId, itemOffset, queueIds; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "POST",
        "/2023-10-12/farms/$(farmId)/search/jobs",
        Dict{String,Any}("itemOffset" => itemOffset, "queueIds" => queueIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function search_jobs(
    farmId,
    itemOffset,
    queueIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "POST",
        "/2023-10-12/farms/$(farmId)/search/jobs",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("itemOffset" => itemOffset, "queueIds" => queueIds),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    search_steps(farm_id, item_offset, queue_ids)
    search_steps(farm_id, item_offset, queue_ids, params::Dict{String,<:Any})

Searches for steps.

# Arguments
- `farm_id`: The farm ID to use for the step search.
- `item_offset`: Defines how far into the scrollable list to start the return of results.
- `queue_ids`: The queue IDs in the step search.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filterExpressions"`: The filter expression, AND or OR, to use when searching among a
  group of search strings in a resource. You can use two groupings per search each within
  parenthesis ().
- `"jobId"`: The job ID to use in the step search.
- `"pageSize"`: Specifies the number of items per page for the resource.
- `"sortExpressions"`: The search terms for a resource.
"""
function search_steps(
    farmId, itemOffset, queueIds; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "POST",
        "/2023-10-12/farms/$(farmId)/search/steps",
        Dict{String,Any}("itemOffset" => itemOffset, "queueIds" => queueIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function search_steps(
    farmId,
    itemOffset,
    queueIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "POST",
        "/2023-10-12/farms/$(farmId)/search/steps",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("itemOffset" => itemOffset, "queueIds" => queueIds),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    search_tasks(farm_id, item_offset, queue_ids)
    search_tasks(farm_id, item_offset, queue_ids, params::Dict{String,<:Any})

Searches for tasks.

# Arguments
- `farm_id`: The farm ID of the task.
- `item_offset`: Defines how far into the scrollable list to start the return of results.
- `queue_ids`: The queue IDs to include in the search.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filterExpressions"`: The filter expression, AND or OR, to use when searching among a
  group of search strings in a resource. You can use two groupings per search each within
  parenthesis ().
- `"jobId"`: The job ID for the task search.
- `"pageSize"`: Specifies the number of items per page for the resource.
- `"sortExpressions"`: The search terms for a resource.
"""
function search_tasks(
    farmId, itemOffset, queueIds; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "POST",
        "/2023-10-12/farms/$(farmId)/search/tasks",
        Dict{String,Any}("itemOffset" => itemOffset, "queueIds" => queueIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function search_tasks(
    farmId,
    itemOffset,
    queueIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "POST",
        "/2023-10-12/farms/$(farmId)/search/tasks",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("itemOffset" => itemOffset, "queueIds" => queueIds),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    search_workers(farm_id, fleet_ids, item_offset)
    search_workers(farm_id, fleet_ids, item_offset, params::Dict{String,<:Any})

Searches for workers.

# Arguments
- `farm_id`: The farm ID in the workers search.
- `fleet_ids`: The fleet ID of the workers to search for.
- `item_offset`: Defines how far into the scrollable list to start the return of results.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filterExpressions"`: The filter expression, AND or OR, to use when searching among a
  group of search strings in a resource. You can use two groupings per search each within
  parenthesis ().
- `"pageSize"`: Specifies the number of items per page for the resource.
- `"sortExpressions"`: The search terms for a resource.
"""
function search_workers(
    farmId, fleetIds, itemOffset; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "POST",
        "/2023-10-12/farms/$(farmId)/search/workers",
        Dict{String,Any}("fleetIds" => fleetIds, "itemOffset" => itemOffset);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function search_workers(
    farmId,
    fleetIds,
    itemOffset,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "POST",
        "/2023-10-12/farms/$(farmId)/search/workers",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("fleetIds" => fleetIds, "itemOffset" => itemOffset),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_sessions_statistics_aggregation(end_time, farm_id, group_by, resource_ids, start_time, statistics)
    start_sessions_statistics_aggregation(end_time, farm_id, group_by, resource_ids, start_time, statistics, params::Dict{String,<:Any})

Starts an asynchronous request for getting aggregated statistics about queues and farms.
Get the statistics using the GetSessionsStatisticsAggregation operation. Statistics are
available for 1 hour after you call the StartSessionsStatisticsAggregation operation.

# Arguments
- `end_time`: The Linux timestamp of the date and time that the statistics end.
- `farm_id`: The identifier of the farm that contains queues or fleets to return statistics
  for.
- `group_by`: The field to use to group the statistics.
- `resource_ids`: A list of fleet IDs or queue IDs to gather statistics for.
- `start_time`: The Linux timestamp of the date and time that the statistics start.
- `statistics`: One to four statistics to return.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"period"`: The period to aggregate the statistics.
- `"timezone"`: The timezone to use for the statistics. Use UTC notation such as \"UTC+8.\"
"""
function start_sessions_statistics_aggregation(
    endTime,
    farmId,
    groupBy,
    resourceIds,
    startTime,
    statistics;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "POST",
        "/2023-10-12/farms/$(farmId)/sessions-statistics-aggregation",
        Dict{String,Any}(
            "endTime" => endTime,
            "groupBy" => groupBy,
            "resourceIds" => resourceIds,
            "startTime" => startTime,
            "statistics" => statistics,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_sessions_statistics_aggregation(
    endTime,
    farmId,
    groupBy,
    resourceIds,
    startTime,
    statistics,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "POST",
        "/2023-10-12/farms/$(farmId)/sessions-statistics-aggregation",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "endTime" => endTime,
                    "groupBy" => groupBy,
                    "resourceIds" => resourceIds,
                    "startTime" => startTime,
                    "statistics" => statistics,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn)
    tag_resource(resource_arn, params::Dict{String,<:Any})

Tags a resource using the resource's ARN and desired tags.

# Arguments
- `resource_arn`: The ARN of the resource to apply tags to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tags"`: Each tag consists of a tag key and a tag value. Tag keys and values are both
  required, but tag values can be empty strings.
"""
function tag_resource(resourceArn; aws_config::AbstractAWSConfig=current_aws_config())
    return deadline(
        "POST",
        "/2023-10-12/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "POST",
        "/2023-10-12/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes a tag from a resource using the resource's ARN and tag to remove.

# Arguments
- `resource_arn`: The ARN of the resource to remove the tag from.
- `tag_keys`: They keys of the tag.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "DELETE",
        "/2023-10-12/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "DELETE",
        "/2023-10-12/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_budget(budget_id, farm_id)
    update_budget(budget_id, farm_id, params::Dict{String,<:Any})

Updates a budget that sets spending thresholds for rendering activity.

# Arguments
- `budget_id`: The budget ID to update.
- `farm_id`: The farm ID of the budget to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"X-Amz-Client-Token"`: The unique token which the server uses to recognize retries of
  the same request.
- `"actionsToAdd"`: The budget actions to add. Budget actions specify what happens when the
  budget runs out.
- `"actionsToRemove"`: The budget actions to remove from the budget.
- `"approximateDollarLimit"`: The dollar limit to update on the budget. Based on consumed
  usage.
- `"description"`: The description of the budget to update.
- `"displayName"`: The display name of the budget to update.
- `"schedule"`: The schedule to update.
- `"status"`: Updates the status of the budget.    ACTIVE–The budget is being evaluated.
    INACTIVE–The budget is inactive. This can include Expired, Canceled, or deleted Deleted
  statuses.
"""
function update_budget(budgetId, farmId; aws_config::AbstractAWSConfig=current_aws_config())
    return deadline(
        "PATCH",
        "/2023-10-12/farms/$(farmId)/budgets/$(budgetId)",
        Dict{String,Any}("X-Amz-Client-Token" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_budget(
    budgetId,
    farmId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "PATCH",
        "/2023-10-12/farms/$(farmId)/budgets/$(budgetId)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("X-Amz-Client-Token" => string(uuid4())), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_farm(farm_id)
    update_farm(farm_id, params::Dict{String,<:Any})

Updates a farm.

# Arguments
- `farm_id`: The farm ID to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description of the farm to update.
- `"displayName"`: The display name of the farm to update.
"""
function update_farm(farmId; aws_config::AbstractAWSConfig=current_aws_config())
    return deadline(
        "PATCH",
        "/2023-10-12/farms/$(farmId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_farm(
    farmId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "PATCH",
        "/2023-10-12/farms/$(farmId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_fleet(farm_id, fleet_id)
    update_fleet(farm_id, fleet_id, params::Dict{String,<:Any})

Updates a fleet.

# Arguments
- `farm_id`: The farm ID to update.
- `fleet_id`: The fleet ID to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"X-Amz-Client-Token"`: The unique token which the server uses to recognize retries of
  the same request.
- `"configuration"`: The fleet configuration to update.
- `"description"`: The description of the fleet to update.
- `"displayName"`: The display name of the fleet to update.
- `"maxWorkerCount"`: The maximum number of workers in the fleet.
- `"minWorkerCount"`: The minimum number of workers in the fleet.
- `"roleArn"`: The IAM role ARN that the fleet's workers assume while running jobs.
"""
function update_fleet(farmId, fleetId; aws_config::AbstractAWSConfig=current_aws_config())
    return deadline(
        "PATCH",
        "/2023-10-12/farms/$(farmId)/fleets/$(fleetId)",
        Dict{String,Any}("X-Amz-Client-Token" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_fleet(
    farmId,
    fleetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "PATCH",
        "/2023-10-12/farms/$(farmId)/fleets/$(fleetId)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("X-Amz-Client-Token" => string(uuid4())), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_job(farm_id, job_id, queue_id)
    update_job(farm_id, job_id, queue_id, params::Dict{String,<:Any})

Updates a job.

# Arguments
- `farm_id`: The farm ID of the job to update.
- `job_id`: The job ID to update.
- `queue_id`: The queue ID of the job to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"X-Amz-Client-Token"`: The unique token which the server uses to recognize retries of
  the same request.
- `"lifecycleStatus"`: The status of a job in its lifecycle.
- `"maxFailedTasksCount"`: The number of task failures before the job stops running and is
  marked as FAILED.
- `"maxRetriesPerTask"`: The maximum number of retries for a job.
- `"priority"`: The job priority to update.
- `"targetTaskRunStatus"`: The task status to update the job's tasks to.
"""
function update_job(
    farmId, jobId, queueId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "PATCH",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/jobs/$(jobId)",
        Dict{String,Any}("X-Amz-Client-Token" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_job(
    farmId,
    jobId,
    queueId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "PATCH",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/jobs/$(jobId)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("X-Amz-Client-Token" => string(uuid4())), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_monitor(monitor_id)
    update_monitor(monitor_id, params::Dict{String,<:Any})

Modifies the settings for a Deadline Cloud monitor. You can modify one or all of the
settings when you call UpdateMonitor.

# Arguments
- `monitor_id`: The unique identifier of the monitor to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"displayName"`: The new value to use for the monitor's display name.
- `"roleArn"`: The Amazon Resource Name (ARN) of the new IAM role to use with the monitor.
- `"subdomain"`: The new value of the subdomain to use when forming the monitor URL.
"""
function update_monitor(monitorId; aws_config::AbstractAWSConfig=current_aws_config())
    return deadline(
        "PATCH",
        "/2023-10-12/monitors/$(monitorId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_monitor(
    monitorId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "PATCH",
        "/2023-10-12/monitors/$(monitorId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_queue(farm_id, queue_id)
    update_queue(farm_id, queue_id, params::Dict{String,<:Any})

Updates a queue.

# Arguments
- `farm_id`: The farm ID to update in the queue.
- `queue_id`: The queue ID to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"X-Amz-Client-Token"`: The idempotency token to update in the queue.
- `"allowedStorageProfileIdsToAdd"`: The storage profile IDs to add.
- `"allowedStorageProfileIdsToRemove"`: The storage profile ID to remove.
- `"defaultBudgetAction"`: The default action to take for a queue update if a budget isn't
  configured.
- `"description"`: The description of the queue to update.
- `"displayName"`: The display name of the queue to update.
- `"jobAttachmentSettings"`: The job attachment settings to update for the queue.
- `"jobRunAsUser"`: Update the jobs in the queue to run as a specified POSIX user.
- `"requiredFileSystemLocationNamesToAdd"`: The required file system location names to add
  to the queue.
- `"requiredFileSystemLocationNamesToRemove"`: The required file system location names to
  remove from the queue.
- `"roleArn"`: The IAM role ARN that's used to run jobs from this queue.
"""
function update_queue(farmId, queueId; aws_config::AbstractAWSConfig=current_aws_config())
    return deadline(
        "PATCH",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)",
        Dict{String,Any}("X-Amz-Client-Token" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_queue(
    farmId,
    queueId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "PATCH",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("X-Amz-Client-Token" => string(uuid4())), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_queue_environment(farm_id, queue_environment_id, queue_id)
    update_queue_environment(farm_id, queue_environment_id, queue_id, params::Dict{String,<:Any})

Updates the queue environment.

# Arguments
- `farm_id`: The farm ID of the queue environment to update.
- `queue_environment_id`: The queue environment ID to update.
- `queue_id`: The queue ID of the queue environment to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"X-Amz-Client-Token"`: The unique token which the server uses to recognize retries of
  the same request.
- `"priority"`: The priority to update.
- `"template"`: The template to update.
- `"templateType"`: The template type to update.
"""
function update_queue_environment(
    farmId, queueEnvironmentId, queueId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "PATCH",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/environments/$(queueEnvironmentId)",
        Dict{String,Any}("X-Amz-Client-Token" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_queue_environment(
    farmId,
    queueEnvironmentId,
    queueId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "PATCH",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/environments/$(queueEnvironmentId)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("X-Amz-Client-Token" => string(uuid4())), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_queue_fleet_association(farm_id, fleet_id, queue_id, status)
    update_queue_fleet_association(farm_id, fleet_id, queue_id, status, params::Dict{String,<:Any})

Updates a queue-fleet association.

# Arguments
- `farm_id`: The farm ID to update.
- `fleet_id`: The fleet ID to update.
- `queue_id`: The queue ID to update.
- `status`: The status to update.

"""
function update_queue_fleet_association(
    farmId, fleetId, queueId, status; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "PATCH",
        "/2023-10-12/farms/$(farmId)/queue-fleet-associations/$(queueId)/$(fleetId)",
        Dict{String,Any}("status" => status);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_queue_fleet_association(
    farmId,
    fleetId,
    queueId,
    status,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "PATCH",
        "/2023-10-12/farms/$(farmId)/queue-fleet-associations/$(queueId)/$(fleetId)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("status" => status), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_session(farm_id, job_id, queue_id, session_id, target_lifecycle_status)
    update_session(farm_id, job_id, queue_id, session_id, target_lifecycle_status, params::Dict{String,<:Any})

Updates a session.

# Arguments
- `farm_id`: The farm ID to update in the session.
- `job_id`: The job ID to update in the session.
- `queue_id`: The queue ID to update in the session.
- `session_id`: The session ID to update.
- `target_lifecycle_status`: The life cycle status to update in the session.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"X-Amz-Client-Token"`: The unique token which the server uses to recognize retries of
  the same request.
"""
function update_session(
    farmId,
    jobId,
    queueId,
    sessionId,
    targetLifecycleStatus;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "PATCH",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/jobs/$(jobId)/sessions/$(sessionId)",
        Dict{String,Any}(
            "targetLifecycleStatus" => targetLifecycleStatus,
            "X-Amz-Client-Token" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_session(
    farmId,
    jobId,
    queueId,
    sessionId,
    targetLifecycleStatus,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "PATCH",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/jobs/$(jobId)/sessions/$(sessionId)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "targetLifecycleStatus" => targetLifecycleStatus,
                    "X-Amz-Client-Token" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_step(farm_id, job_id, queue_id, step_id, target_task_run_status)
    update_step(farm_id, job_id, queue_id, step_id, target_task_run_status, params::Dict{String,<:Any})

Updates a step.

# Arguments
- `farm_id`: The farm ID to update.
- `job_id`: The job ID to update.
- `queue_id`: The queue ID to update.
- `step_id`: The step ID to update.
- `target_task_run_status`: The task status to update the step's tasks to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"X-Amz-Client-Token"`: The unique token which the server uses to recognize retries of
  the same request.
"""
function update_step(
    farmId,
    jobId,
    queueId,
    stepId,
    targetTaskRunStatus;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "PATCH",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/jobs/$(jobId)/steps/$(stepId)",
        Dict{String,Any}(
            "targetTaskRunStatus" => targetTaskRunStatus,
            "X-Amz-Client-Token" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_step(
    farmId,
    jobId,
    queueId,
    stepId,
    targetTaskRunStatus,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "PATCH",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/jobs/$(jobId)/steps/$(stepId)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "targetTaskRunStatus" => targetTaskRunStatus,
                    "X-Amz-Client-Token" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_storage_profile(farm_id, storage_profile_id)
    update_storage_profile(farm_id, storage_profile_id, params::Dict{String,<:Any})

Updates a storage profile.

# Arguments
- `farm_id`: The farm ID to update.
- `storage_profile_id`: The storage profile ID to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"X-Amz-Client-Token"`: The unique token which the server uses to recognize retries of
  the same request.
- `"displayName"`: The display name of the storage profile to update.
- `"fileSystemLocationsToAdd"`: The file system location names to add.
- `"fileSystemLocationsToRemove"`: The file system location names to remove.
- `"osFamily"`: The OS system to update.
"""
function update_storage_profile(
    farmId, storageProfileId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "PATCH",
        "/2023-10-12/farms/$(farmId)/storage-profiles/$(storageProfileId)",
        Dict{String,Any}("X-Amz-Client-Token" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_storage_profile(
    farmId,
    storageProfileId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "PATCH",
        "/2023-10-12/farms/$(farmId)/storage-profiles/$(storageProfileId)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("X-Amz-Client-Token" => string(uuid4())), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_task(farm_id, job_id, queue_id, step_id, target_run_status, task_id)
    update_task(farm_id, job_id, queue_id, step_id, target_run_status, task_id, params::Dict{String,<:Any})

Updates a task.

# Arguments
- `farm_id`: The farm ID to update.
- `job_id`: The job ID to update.
- `queue_id`: The queue ID to update.
- `step_id`: The step ID to update.
- `target_run_status`: The run status with which to start the task.
- `task_id`: The task ID to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"X-Amz-Client-Token"`: The unique token which the server uses to recognize retries of
  the same request.
"""
function update_task(
    farmId,
    jobId,
    queueId,
    stepId,
    targetRunStatus,
    taskId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "PATCH",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/jobs/$(jobId)/steps/$(stepId)/tasks/$(taskId)",
        Dict{String,Any}(
            "targetRunStatus" => targetRunStatus, "X-Amz-Client-Token" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_task(
    farmId,
    jobId,
    queueId,
    stepId,
    targetRunStatus,
    taskId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "PATCH",
        "/2023-10-12/farms/$(farmId)/queues/$(queueId)/jobs/$(jobId)/steps/$(stepId)/tasks/$(taskId)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "targetRunStatus" => targetRunStatus,
                    "X-Amz-Client-Token" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_worker(farm_id, fleet_id, worker_id)
    update_worker(farm_id, fleet_id, worker_id, params::Dict{String,<:Any})

Updates a worker.

# Arguments
- `farm_id`: The farm ID to update.
- `fleet_id`: The fleet ID to update.
- `worker_id`: The worker ID to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"capabilities"`: The worker capabilities to update.
- `"hostProperties"`: The host properties to update.
- `"status"`: The worker status to update.
"""
function update_worker(
    farmId, fleetId, workerId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "PATCH",
        "/2023-10-12/farms/$(farmId)/fleets/$(fleetId)/workers/$(workerId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_worker(
    farmId,
    fleetId,
    workerId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "PATCH",
        "/2023-10-12/farms/$(farmId)/fleets/$(fleetId)/workers/$(workerId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_worker_schedule(farm_id, fleet_id, worker_id)
    update_worker_schedule(farm_id, fleet_id, worker_id, params::Dict{String,<:Any})

Updates the schedule for a worker.

# Arguments
- `farm_id`: The farm ID to update.
- `fleet_id`: The fleet ID to update.
- `worker_id`: The worker ID to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"updatedSessionActions"`: The session actions associated with the worker schedule to
  update.
"""
function update_worker_schedule(
    farmId, fleetId, workerId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return deadline(
        "PATCH",
        "/2023-10-12/farms/$(farmId)/fleets/$(fleetId)/workers/$(workerId)/schedule";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_worker_schedule(
    farmId,
    fleetId,
    workerId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return deadline(
        "PATCH",
        "/2023-10-12/farms/$(farmId)/fleets/$(fleetId)/workers/$(workerId)/schedule",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: sso
using AWS.Compat
using AWS.UUIDs

"""
    get_role_credentials(account_id, role_name, x-amz-sso_bearer_token)
    get_role_credentials(account_id, role_name, x-amz-sso_bearer_token, params::Dict{String,<:Any})

Returns the STS short-term credentials for a given role name that is assigned to the user.

# Arguments
- `account_id`: The identifier for the AWS account that is assigned to the user.
- `role_name`: The friendly name of the role that is assigned to the user.
- `x-amz-sso_bearer_token`: The token issued by the CreateToken API call. For more
  information, see CreateToken in the IAM Identity Center OIDC API Reference Guide.

"""
function get_role_credentials(
    account_id,
    role_name,
    x_amz_sso_bearer_token;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso(
        "GET",
        "/federation/credentials",
        Dict{String,Any}(
            "account_id" => account_id,
            "role_name" => role_name,
            "headers" =>
                Dict{String,Any}("x-amz-sso_bearer_token" => x_amz_sso_bearer_token),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_role_credentials(
    account_id,
    role_name,
    x_amz_sso_bearer_token,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso(
        "GET",
        "/federation/credentials",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "account_id" => account_id,
                    "role_name" => role_name,
                    "headers" => Dict{String,Any}(
                        "x-amz-sso_bearer_token" => x_amz_sso_bearer_token
                    ),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_account_roles(account_id, x-amz-sso_bearer_token)
    list_account_roles(account_id, x-amz-sso_bearer_token, params::Dict{String,<:Any})

Lists all roles that are assigned to the user for a given AWS account.

# Arguments
- `account_id`: The identifier for the AWS account that is assigned to the user.
- `x-amz-sso_bearer_token`: The token issued by the CreateToken API call. For more
  information, see CreateToken in the IAM Identity Center OIDC API Reference Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"max_result"`: The number of items that clients can request per page.
- `"next_token"`: The page token from the previous response output when you request
  subsequent pages.
"""
function list_account_roles(
    account_id, x_amz_sso_bearer_token; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sso(
        "GET",
        "/assignment/roles",
        Dict{String,Any}(
            "account_id" => account_id,
            "headers" =>
                Dict{String,Any}("x-amz-sso_bearer_token" => x_amz_sso_bearer_token),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_account_roles(
    account_id,
    x_amz_sso_bearer_token,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso(
        "GET",
        "/assignment/roles",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "account_id" => account_id,
                    "headers" => Dict{String,Any}(
                        "x-amz-sso_bearer_token" => x_amz_sso_bearer_token
                    ),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_accounts(x-amz-sso_bearer_token)
    list_accounts(x-amz-sso_bearer_token, params::Dict{String,<:Any})

Lists all AWS accounts assigned to the user. These AWS accounts are assigned by the
administrator of the account. For more information, see Assign User Access in the IAM
Identity Center User Guide. This operation returns a paginated response.

# Arguments
- `x-amz-sso_bearer_token`: The token issued by the CreateToken API call. For more
  information, see CreateToken in the IAM Identity Center OIDC API Reference Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"max_result"`: This is the number of items clients can request per page.
- `"next_token"`: (Optional) When requesting subsequent pages, this is the page token from
  the previous response output.
"""
function list_accounts(
    x_amz_sso_bearer_token; aws_config::AbstractAWSConfig=current_aws_config()
)
    return sso(
        "GET",
        "/assignment/accounts",
        Dict{String,Any}(
            "headers" =>
                Dict{String,Any}("x-amz-sso_bearer_token" => x_amz_sso_bearer_token),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_accounts(
    x_amz_sso_bearer_token,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso(
        "GET",
        "/assignment/accounts",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "headers" => Dict{String,Any}(
                        "x-amz-sso_bearer_token" => x_amz_sso_bearer_token
                    ),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    logout(x-amz-sso_bearer_token)
    logout(x-amz-sso_bearer_token, params::Dict{String,<:Any})

Removes the locally stored SSO tokens from the client-side cache and sends an API call to
the IAM Identity Center service to invalidate the corresponding server-side IAM Identity
Center sign in session.  If a user uses IAM Identity Center to access the AWS CLI, the
user’s IAM Identity Center sign in session is used to obtain an IAM session, as specified
in the corresponding IAM Identity Center permission set. More specifically, IAM Identity
Center assumes an IAM role in the target account on behalf of the user, and the
corresponding temporary AWS credentials are returned to the client. After user logout, any
existing IAM role sessions that were created by using IAM Identity Center permission sets
continue based on the duration configured in the permission set. For more information, see
User authentications in the IAM Identity Center User Guide.

# Arguments
- `x-amz-sso_bearer_token`: The token issued by the CreateToken API call. For more
  information, see CreateToken in the IAM Identity Center OIDC API Reference Guide.

"""
function logout(x_amz_sso_bearer_token; aws_config::AbstractAWSConfig=current_aws_config())
    return sso(
        "POST",
        "/logout",
        Dict{String,Any}(
            "headers" =>
                Dict{String,Any}("x-amz-sso_bearer_token" => x_amz_sso_bearer_token),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function logout(
    x_amz_sso_bearer_token,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return sso(
        "POST",
        "/logout",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "headers" => Dict{String,Any}(
                        "x-amz-sso_bearer_token" => x_amz_sso_bearer_token
                    ),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: codeguru_reviewer
using AWS.Compat
using AWS.UUIDs

"""
    associate_repository(repository)
    associate_repository(repository, params::Dict{String,<:Any})

Use to associate an Amazon Web Services CodeCommit repository or a repository managed by
Amazon Web Services CodeStar Connections with Amazon CodeGuru Reviewer. When you associate
a repository, CodeGuru Reviewer reviews source code changes in the repository's pull
requests and provides automatic recommendations. You can view recommendations using the
CodeGuru Reviewer console. For more information, see Recommendations in Amazon CodeGuru
Reviewer in the Amazon CodeGuru Reviewer User Guide.  If you associate a CodeCommit or S3
repository, it must be in the same Amazon Web Services Region and Amazon Web Services
account where its CodeGuru Reviewer code reviews are configured. Bitbucket and GitHub
Enterprise Server repositories are managed by Amazon Web Services CodeStar Connections to
connect to CodeGuru Reviewer. For more information, see Associate a repository in the
Amazon CodeGuru Reviewer User Guide.   You cannot use the CodeGuru Reviewer SDK or the
Amazon Web Services CLI to associate a GitHub repository with Amazon CodeGuru Reviewer. To
associate a GitHub repository, use the console. For more information, see Getting started
with CodeGuru Reviewer in the CodeGuru Reviewer User Guide.

# Arguments
- `repository`: The repository to associate.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: Amazon CodeGuru Reviewer uses this value to prevent the
  accidental creation of duplicate repository associations if there are failures and retries.
- `"KMSKeyDetails"`: A KMSKeyDetails object that contains:   The encryption option for this
  repository association. It is either owned by Amazon Web Services Key Management Service
  (KMS) (AWS_OWNED_CMK) or customer managed (CUSTOMER_MANAGED_CMK).   The ID of the Amazon
  Web Services KMS key that is associated with this repository association.
- `"Tags"`: An array of key-value pairs used to tag an associated repository. A tag is a
  custom attribute label with two parts:   A tag key (for example, CostCenter, Environment,
  Project, or Secret). Tag keys are case sensitive.   An optional field known as a tag value
  (for example, 111122223333, Production, or a team name). Omitting the tag value is the same
  as using an empty string. Like tag keys, tag values are case sensitive.
"""
function associate_repository(
    Repository; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeguru_reviewer(
        "POST",
        "/associations",
        Dict{String,Any}(
            "Repository" => Repository, "ClientRequestToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_repository(
    Repository,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeguru_reviewer(
        "POST",
        "/associations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Repository" => Repository, "ClientRequestToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_code_review(name, repository_association_arn, type)
    create_code_review(name, repository_association_arn, type, params::Dict{String,<:Any})

Use to create a code review with a CodeReviewType of RepositoryAnalysis. This type of code
review analyzes all code under a specified branch in an associated repository. PullRequest
code reviews are automatically triggered by a pull request.

# Arguments
- `name`: The name of the code review. The name of each code review in your Amazon Web
  Services account must be unique.
- `repository_association_arn`: The Amazon Resource Name (ARN) of the RepositoryAssociation
  object. You can retrieve this ARN by calling ListRepositoryAssociations. A code review can
  only be created on an associated repository. This is the ARN of the associated repository.
- `type`: The type of code review to create. This is specified using a CodeReviewType
  object. You can create a code review only of type RepositoryAnalysis.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: Amazon CodeGuru Reviewer uses this value to prevent the
  accidental creation of duplicate code reviews if there are failures and retries.
"""
function create_code_review(
    Name, RepositoryAssociationArn, Type; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeguru_reviewer(
        "POST",
        "/codereviews",
        Dict{String,Any}(
            "Name" => Name,
            "RepositoryAssociationArn" => RepositoryAssociationArn,
            "Type" => Type,
            "ClientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_code_review(
    Name,
    RepositoryAssociationArn,
    Type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeguru_reviewer(
        "POST",
        "/codereviews",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Name" => Name,
                    "RepositoryAssociationArn" => RepositoryAssociationArn,
                    "Type" => Type,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_code_review(code_review_arn)
    describe_code_review(code_review_arn, params::Dict{String,<:Any})

Returns the metadata associated with the code review along with its status.

# Arguments
- `code_review_arn`: The Amazon Resource Name (ARN) of the CodeReview object.

"""
function describe_code_review(
    CodeReviewArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeguru_reviewer(
        "GET",
        "/codereviews/$(CodeReviewArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_code_review(
    CodeReviewArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeguru_reviewer(
        "GET",
        "/codereviews/$(CodeReviewArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_recommendation_feedback(code_review_arn, recommendation_id)
    describe_recommendation_feedback(code_review_arn, recommendation_id, params::Dict{String,<:Any})

Describes the customer feedback for a CodeGuru Reviewer recommendation.

# Arguments
- `code_review_arn`: The Amazon Resource Name (ARN) of the CodeReview object.
- `recommendation_id`: The recommendation ID that can be used to track the provided
  recommendations and then to collect the feedback.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"UserId"`: Optional parameter to describe the feedback for a given user. If this is not
  supplied, it defaults to the user making the request.  The UserId is an IAM principal that
  can be specified as an Amazon Web Services account ID or an Amazon Resource Name (ARN). For
  more information, see  Specifying a Principal in the Amazon Web Services Identity and
  Access Management User Guide.
"""
function describe_recommendation_feedback(
    CodeReviewArn, RecommendationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeguru_reviewer(
        "GET",
        "/feedback/$(CodeReviewArn)",
        Dict{String,Any}("RecommendationId" => RecommendationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_recommendation_feedback(
    CodeReviewArn,
    RecommendationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeguru_reviewer(
        "GET",
        "/feedback/$(CodeReviewArn)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("RecommendationId" => RecommendationId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_repository_association(association_arn)
    describe_repository_association(association_arn, params::Dict{String,<:Any})

Returns a RepositoryAssociation object that contains information about the requested
repository association.

# Arguments
- `association_arn`: The Amazon Resource Name (ARN) of the RepositoryAssociation object.
  You can retrieve this ARN by calling ListRepositoryAssociations.

"""
function describe_repository_association(
    AssociationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeguru_reviewer(
        "GET",
        "/associations/$(AssociationArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_repository_association(
    AssociationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeguru_reviewer(
        "GET",
        "/associations/$(AssociationArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_repository(association_arn)
    disassociate_repository(association_arn, params::Dict{String,<:Any})

Removes the association between Amazon CodeGuru Reviewer and a repository.

# Arguments
- `association_arn`: The Amazon Resource Name (ARN) of the RepositoryAssociation object.
  You can retrieve this ARN by calling ListRepositoryAssociations.

"""
function disassociate_repository(
    AssociationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeguru_reviewer(
        "DELETE",
        "/associations/$(AssociationArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_repository(
    AssociationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeguru_reviewer(
        "DELETE",
        "/associations/$(AssociationArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_code_reviews(type)
    list_code_reviews(type, params::Dict{String,<:Any})

Lists all the code reviews that the customer has created in the past 90 days.

# Arguments
- `type`: The type of code reviews to list in the response.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results that are returned per call. The default is
  100.
- `"NextToken"`: If nextToken is returned, there are more results available. The value of
  nextToken is a unique pagination token for each page. Make the call again using the
  returned token to retrieve the next page. Keep all other arguments unchanged.
- `"ProviderTypes"`: List of provider types for filtering that needs to be applied before
  displaying the result. For example, providerTypes=[GitHub] lists code reviews from GitHub.
- `"RepositoryNames"`: List of repository names for filtering that needs to be applied
  before displaying the result.
- `"States"`: List of states for filtering that needs to be applied before displaying the
  result. For example, states=[Pending] lists code reviews in the Pending state. The valid
  code review states are:    Completed: The code review is complete.    Pending: The code
  review started and has not completed or failed.    Failed: The code review failed.
  Deleting: The code review is being deleted.
"""
function list_code_reviews(Type; aws_config::AbstractAWSConfig=current_aws_config())
    return codeguru_reviewer(
        "GET",
        "/codereviews",
        Dict{String,Any}("Type" => Type);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_code_reviews(
    Type, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeguru_reviewer(
        "GET",
        "/codereviews",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Type" => Type), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_recommendation_feedback(code_review_arn)
    list_recommendation_feedback(code_review_arn, params::Dict{String,<:Any})

Returns a list of RecommendationFeedbackSummary objects that contain customer
recommendation feedback for all CodeGuru Reviewer users.

# Arguments
- `code_review_arn`: The Amazon Resource Name (ARN) of the CodeReview object.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results that are returned per call. The default is
  100.
- `"NextToken"`: If nextToken is returned, there are more results available. The value of
  nextToken is a unique pagination token for each page. Make the call again using the
  returned token to retrieve the next page. Keep all other arguments unchanged.
- `"RecommendationIds"`: Used to query the recommendation feedback for a given
  recommendation.
- `"UserIds"`: An Amazon Web Services user's account ID or Amazon Resource Name (ARN). Use
  this ID to query the recommendation feedback for a code review from that user.  The UserId
  is an IAM principal that can be specified as an Amazon Web Services account ID or an Amazon
  Resource Name (ARN). For more information, see  Specifying a Principal in the Amazon Web
  Services Identity and Access Management User Guide.
"""
function list_recommendation_feedback(
    CodeReviewArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeguru_reviewer(
        "GET",
        "/feedback/$(CodeReviewArn)/RecommendationFeedback";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_recommendation_feedback(
    CodeReviewArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeguru_reviewer(
        "GET",
        "/feedback/$(CodeReviewArn)/RecommendationFeedback",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_recommendations(code_review_arn)
    list_recommendations(code_review_arn, params::Dict{String,<:Any})

Returns the list of all recommendations for a completed code review.

# Arguments
- `code_review_arn`: The Amazon Resource Name (ARN) of the CodeReview object.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results that are returned per call. The default is
  100.
- `"NextToken"`: Pagination token.
"""
function list_recommendations(
    CodeReviewArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeguru_reviewer(
        "GET",
        "/codereviews/$(CodeReviewArn)/Recommendations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_recommendations(
    CodeReviewArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeguru_reviewer(
        "GET",
        "/codereviews/$(CodeReviewArn)/Recommendations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_repository_associations()
    list_repository_associations(params::Dict{String,<:Any})

Returns a list of RepositoryAssociationSummary objects that contain summary information
about a repository association. You can filter the returned list by ProviderType, Name,
State, and Owner.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of repository association results returned by
  ListRepositoryAssociations in paginated output. When this parameter is used,
  ListRepositoryAssociations only returns maxResults results in a single page with a
  nextToken response element. The remaining results of the initial request can be seen by
  sending another ListRepositoryAssociations request with the returned nextToken value. This
  value can be between 1 and 100. If this parameter is not used, ListRepositoryAssociations
  returns up to 100 results and a nextToken value if applicable.
- `"Name"`: List of repository names to use as a filter.
- `"NextToken"`: The nextToken value returned from a previous paginated
  ListRepositoryAssociations request where maxResults was used and the results exceeded the
  value of that parameter. Pagination continues from the end of the previous results that
  returned the nextToken value.   Treat this token as an opaque identifier that is only used
  to retrieve the next items in a list and not for other programmatic purposes.
- `"Owner"`: List of owners to use as a filter. For Amazon Web Services CodeCommit, it is
  the name of the CodeCommit account that was used to associate the repository. For other
  repository source providers, such as Bitbucket and GitHub Enterprise Server, this is name
  of the account that was used to associate the repository.
- `"ProviderType"`: List of provider types to use as a filter.
- `"State"`: List of repository association states to use as a filter. The valid repository
  association states are:    Associated: The repository association is complete.
  Associating: CodeGuru Reviewer is:   Setting up pull request notifications. This is
  required for pull requests to trigger a CodeGuru Reviewer review.  If your repository
  ProviderType is GitHub, GitHub Enterprise Server, or Bitbucket, CodeGuru Reviewer creates
  webhooks in your repository to trigger CodeGuru Reviewer reviews. If you delete these
  webhooks, reviews of code in your repository cannot be triggered.    Setting up source code
  access. This is required for CodeGuru Reviewer to securely clone code in your repository.
     Failed: The repository failed to associate or disassociate.    Disassociating: CodeGuru
  Reviewer is removing the repository's pull request notifications and source code access.
  Disassociated: CodeGuru Reviewer successfully disassociated the repository. You can create
  a new association with this repository if you want to review source code in it later. You
  can control access to code reviews created in anassociated repository with tags after it
  has been disassociated. For more information, see Using tags to control access to
  associated repositories in the Amazon CodeGuru Reviewer User Guide.
"""
function list_repository_associations(; aws_config::AbstractAWSConfig=current_aws_config())
    return codeguru_reviewer(
        "GET", "/associations"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_repository_associations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeguru_reviewer(
        "GET",
        "/associations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Returns the list of tags associated with an associated repository resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the RepositoryAssociation object. You
  can retrieve this ARN by calling ListRepositoryAssociations.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeguru_reviewer(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeguru_reviewer(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_recommendation_feedback(code_review_arn, reactions, recommendation_id)
    put_recommendation_feedback(code_review_arn, reactions, recommendation_id, params::Dict{String,<:Any})

Stores customer feedback for a CodeGuru Reviewer recommendation. When this API is called
again with different reactions the previous feedback is overwritten.

# Arguments
- `code_review_arn`: The Amazon Resource Name (ARN) of the CodeReview object.
- `reactions`: List for storing reactions. Reactions are utf-8 text code for emojis. If you
  send an empty list it clears all your feedback.
- `recommendation_id`: The recommendation ID that can be used to track the provided
  recommendations and then to collect the feedback.

"""
function put_recommendation_feedback(
    CodeReviewArn,
    Reactions,
    RecommendationId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeguru_reviewer(
        "PUT",
        "/feedback",
        Dict{String,Any}(
            "CodeReviewArn" => CodeReviewArn,
            "Reactions" => Reactions,
            "RecommendationId" => RecommendationId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_recommendation_feedback(
    CodeReviewArn,
    Reactions,
    RecommendationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeguru_reviewer(
        "PUT",
        "/feedback",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CodeReviewArn" => CodeReviewArn,
                    "Reactions" => Reactions,
                    "RecommendationId" => RecommendationId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(tags, resource_arn)
    tag_resource(tags, resource_arn, params::Dict{String,<:Any})

Adds one or more tags to an associated repository.

# Arguments
- `tags`: An array of key-value pairs used to tag an associated repository. A tag is a
  custom attribute label with two parts:   A tag key (for example, CostCenter, Environment,
  Project, or Secret). Tag keys are case sensitive.   An optional field known as a tag value
  (for example, 111122223333, Production, or a team name). Omitting the tag value is the same
  as using an empty string. Like tag keys, tag values are case sensitive.
- `resource_arn`: The Amazon Resource Name (ARN) of the RepositoryAssociation object. You
  can retrieve this ARN by calling ListRepositoryAssociations.

"""
function tag_resource(Tags, resourceArn; aws_config::AbstractAWSConfig=current_aws_config())
    return codeguru_reviewer(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    Tags,
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeguru_reviewer(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Tags" => Tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes a tag from an associated repository.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the RepositoryAssociation object. You
  can retrieve this ARN by calling ListRepositoryAssociations.
- `tag_keys`: A list of the keys for each tag you want to remove from an associated
  repository.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeguru_reviewer(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeguru_reviewer(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: wellarchitected
using AWS.Compat
using AWS.UUIDs

"""
    associate_lenses(lens_aliases, workload_id)
    associate_lenses(lens_aliases, workload_id, params::Dict{String,<:Any})

Associate a lens to a workload. Up to 10 lenses can be associated with a workload in a
single API operation. A maximum of 20 lenses can be associated with a workload.
Disclaimer  By accessing and/or applying custom lenses created by another Amazon Web
Services user or account, you acknowledge that custom lenses created by other users and
shared with you are Third Party Content as defined in the Amazon Web Services Customer
Agreement.

# Arguments
- `lens_aliases`:
- `workload_id`:

"""
function associate_lenses(
    LensAliases, WorkloadId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wellarchitected(
        "PATCH",
        "/workloads/$(WorkloadId)/associateLenses",
        Dict{String,Any}("LensAliases" => LensAliases);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_lenses(
    LensAliases,
    WorkloadId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "PATCH",
        "/workloads/$(WorkloadId)/associateLenses",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("LensAliases" => LensAliases), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_profiles(profile_arns, workload_id)
    associate_profiles(profile_arns, workload_id, params::Dict{String,<:Any})

Associate a profile with a workload.

# Arguments
- `profile_arns`: The list of profile ARNs to associate with the workload.
- `workload_id`:

"""
function associate_profiles(
    ProfileArns, WorkloadId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wellarchitected(
        "PATCH",
        "/workloads/$(WorkloadId)/associateProfiles",
        Dict{String,Any}("ProfileArns" => ProfileArns);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_profiles(
    ProfileArns,
    WorkloadId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "PATCH",
        "/workloads/$(WorkloadId)/associateProfiles",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ProfileArns" => ProfileArns), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_lens_share(client_request_token, lens_alias, shared_with)
    create_lens_share(client_request_token, lens_alias, shared_with, params::Dict{String,<:Any})

Create a lens share. The owner of a lens can share it with other Amazon Web Services
accounts, users, an organization, and organizational units (OUs) in the same Amazon Web
Services Region. Lenses provided by Amazon Web Services (Amazon Web Services Official
Content) cannot be shared.  Shared access to a lens is not removed until the lens
invitation is deleted. If you share a lens with an organization or OU, all accounts in the
organization or OU are granted access to the lens. For more information, see Sharing a
custom lens in the Well-Architected Tool User Guide.   Disclaimer  By sharing your custom
lenses with other Amazon Web Services accounts, you acknowledge that Amazon Web Services
will make your custom lenses available to those other accounts. Those other accounts may
continue to access and use your shared custom lenses even if you delete the custom lenses
from your own Amazon Web Services account or terminate your Amazon Web Services account.

# Arguments
- `client_request_token`:
- `lens_alias`:
- `shared_with`:

"""
function create_lens_share(
    ClientRequestToken,
    LensAlias,
    SharedWith;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "POST",
        "/lenses/$(LensAlias)/shares",
        Dict{String,Any}(
            "ClientRequestToken" => ClientRequestToken, "SharedWith" => SharedWith
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_lens_share(
    ClientRequestToken,
    LensAlias,
    SharedWith,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "POST",
        "/lenses/$(LensAlias)/shares",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClientRequestToken" => ClientRequestToken, "SharedWith" => SharedWith
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_lens_version(client_request_token, lens_alias, lens_version)
    create_lens_version(client_request_token, lens_alias, lens_version, params::Dict{String,<:Any})

Create a new lens version. A lens can have up to 100 versions. Use this operation to
publish a new lens version after you have imported a lens. The LensAlias is used to
identify the lens to be published. The owner of a lens can share the lens with other Amazon
Web Services accounts and users in the same Amazon Web Services Region. Only the owner of a
lens can delete it.

# Arguments
- `client_request_token`:
- `lens_alias`:
- `lens_version`: The version of the lens being created.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"IsMajorVersion"`: Set to true if this new major lens version.
"""
function create_lens_version(
    ClientRequestToken,
    LensAlias,
    LensVersion;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "POST",
        "/lenses/$(LensAlias)/versions",
        Dict{String,Any}(
            "ClientRequestToken" => ClientRequestToken, "LensVersion" => LensVersion
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_lens_version(
    ClientRequestToken,
    LensAlias,
    LensVersion,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "POST",
        "/lenses/$(LensAlias)/versions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClientRequestToken" => ClientRequestToken, "LensVersion" => LensVersion
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_milestone(client_request_token, milestone_name, workload_id)
    create_milestone(client_request_token, milestone_name, workload_id, params::Dict{String,<:Any})

Create a milestone for an existing workload.

# Arguments
- `client_request_token`:
- `milestone_name`:
- `workload_id`:

"""
function create_milestone(
    ClientRequestToken,
    MilestoneName,
    WorkloadId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "POST",
        "/workloads/$(WorkloadId)/milestones",
        Dict{String,Any}(
            "ClientRequestToken" => ClientRequestToken, "MilestoneName" => MilestoneName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_milestone(
    ClientRequestToken,
    MilestoneName,
    WorkloadId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "POST",
        "/workloads/$(WorkloadId)/milestones",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClientRequestToken" => ClientRequestToken,
                    "MilestoneName" => MilestoneName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_profile(client_request_token, profile_description, profile_name, profile_questions)
    create_profile(client_request_token, profile_description, profile_name, profile_questions, params::Dict{String,<:Any})

Create a profile.

# Arguments
- `client_request_token`:
- `profile_description`: The profile description.
- `profile_name`: Name of the profile.
- `profile_questions`: The profile questions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: The tags assigned to the profile.
"""
function create_profile(
    ClientRequestToken,
    ProfileDescription,
    ProfileName,
    ProfileQuestions;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "POST",
        "/profiles",
        Dict{String,Any}(
            "ClientRequestToken" => ClientRequestToken,
            "ProfileDescription" => ProfileDescription,
            "ProfileName" => ProfileName,
            "ProfileQuestions" => ProfileQuestions,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_profile(
    ClientRequestToken,
    ProfileDescription,
    ProfileName,
    ProfileQuestions,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "POST",
        "/profiles",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClientRequestToken" => ClientRequestToken,
                    "ProfileDescription" => ProfileDescription,
                    "ProfileName" => ProfileName,
                    "ProfileQuestions" => ProfileQuestions,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_profile_share(client_request_token, profile_arn, shared_with)
    create_profile_share(client_request_token, profile_arn, shared_with, params::Dict{String,<:Any})

Create a profile share.

# Arguments
- `client_request_token`:
- `profile_arn`: The profile ARN.
- `shared_with`:

"""
function create_profile_share(
    ClientRequestToken,
    ProfileArn,
    SharedWith;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "POST",
        "/profiles/$(ProfileArn)/shares",
        Dict{String,Any}(
            "ClientRequestToken" => ClientRequestToken, "SharedWith" => SharedWith
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_profile_share(
    ClientRequestToken,
    ProfileArn,
    SharedWith,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "POST",
        "/profiles/$(ProfileArn)/shares",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClientRequestToken" => ClientRequestToken, "SharedWith" => SharedWith
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_review_template(client_request_token, description, lenses, template_name)
    create_review_template(client_request_token, description, lenses, template_name, params::Dict{String,<:Any})

Create a review template.   Disclaimer  Do not include or gather personal identifiable
information (PII) of end users or other identifiable individuals in or via your review
templates. If your review template or those shared with you and used in your account do
include or collect PII you are responsible for: ensuring that the included PII is processed
in accordance with applicable law, providing adequate privacy notices, and obtaining
necessary consents for processing such data.

# Arguments
- `client_request_token`:
- `description`: The review template description.
- `lenses`: Lenses applied to the review template.
- `template_name`: Name of the review template.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Notes"`:
- `"Tags"`: The tags assigned to the review template.
"""
function create_review_template(
    ClientRequestToken,
    Description,
    Lenses,
    TemplateName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "POST",
        "/reviewTemplates",
        Dict{String,Any}(
            "ClientRequestToken" => ClientRequestToken,
            "Description" => Description,
            "Lenses" => Lenses,
            "TemplateName" => TemplateName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_review_template(
    ClientRequestToken,
    Description,
    Lenses,
    TemplateName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "POST",
        "/reviewTemplates",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClientRequestToken" => ClientRequestToken,
                    "Description" => Description,
                    "Lenses" => Lenses,
                    "TemplateName" => TemplateName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_template_share(client_request_token, shared_with, template_arn)
    create_template_share(client_request_token, shared_with, template_arn, params::Dict{String,<:Any})

Create a review template share. The owner of a review template can share it with other
Amazon Web Services accounts, users, an organization, and organizational units (OUs) in the
same Amazon Web Services Region.   Shared access to a review template is not removed until
the review template share invitation is deleted. If you share a review template with an
organization or OU, all accounts in the organization or OU are granted access to the review
template.   Disclaimer  By sharing your review template with other Amazon Web Services
accounts, you acknowledge that Amazon Web Services will make your review template available
to those other accounts.

# Arguments
- `client_request_token`:
- `shared_with`:
- `template_arn`: The review template ARN.

"""
function create_template_share(
    ClientRequestToken,
    SharedWith,
    TemplateArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "POST",
        "/templates/shares/$(TemplateArn)",
        Dict{String,Any}(
            "ClientRequestToken" => ClientRequestToken, "SharedWith" => SharedWith
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_template_share(
    ClientRequestToken,
    SharedWith,
    TemplateArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "POST",
        "/templates/shares/$(TemplateArn)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClientRequestToken" => ClientRequestToken, "SharedWith" => SharedWith
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_workload(client_request_token, description, environment, lenses, workload_name)
    create_workload(client_request_token, description, environment, lenses, workload_name, params::Dict{String,<:Any})

Create a new workload. The owner of a workload can share the workload with other Amazon Web
Services accounts, users, an organization, and organizational units (OUs) in the same
Amazon Web Services Region. Only the owner of a workload can delete it. For more
information, see Defining a Workload in the Well-Architected Tool User Guide.  Either
AwsRegions, NonAwsRegions, or both must be specified when creating a workload. You also
must specify ReviewOwner, even though the parameter is listed as not being required in the
following section.   When creating a workload using a review template, you must have the
following IAM permissions:    wellarchitected:GetReviewTemplate
wellarchitected:GetReviewTemplateAnswer     wellarchitected:ListReviewTemplateAnswers
wellarchitected:GetReviewTemplateLensReview

# Arguments
- `client_request_token`:
- `description`:
- `environment`:
- `lenses`:
- `workload_name`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccountIds"`:
- `"Applications"`: List of AppRegistry application ARNs associated to the workload.
- `"ArchitecturalDesign"`:
- `"AwsRegions"`:
- `"DiscoveryConfig"`: Well-Architected discovery configuration settings associated to the
  workload.
- `"Industry"`:
- `"IndustryType"`:
- `"JiraConfiguration"`: Jira configuration settings when creating a workload.
- `"NonAwsRegions"`:
- `"Notes"`:
- `"PillarPriorities"`:
- `"ProfileArns"`: The list of profile ARNs associated with the workload.
- `"ReviewOwner"`:
- `"ReviewTemplateArns"`: The list of review template ARNs to associate with the workload.
- `"Tags"`: The tags to be associated with the workload.
"""
function create_workload(
    ClientRequestToken,
    Description,
    Environment,
    Lenses,
    WorkloadName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "POST",
        "/workloads",
        Dict{String,Any}(
            "ClientRequestToken" => ClientRequestToken,
            "Description" => Description,
            "Environment" => Environment,
            "Lenses" => Lenses,
            "WorkloadName" => WorkloadName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_workload(
    ClientRequestToken,
    Description,
    Environment,
    Lenses,
    WorkloadName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "POST",
        "/workloads",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClientRequestToken" => ClientRequestToken,
                    "Description" => Description,
                    "Environment" => Environment,
                    "Lenses" => Lenses,
                    "WorkloadName" => WorkloadName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_workload_share(client_request_token, permission_type, shared_with, workload_id)
    create_workload_share(client_request_token, permission_type, shared_with, workload_id, params::Dict{String,<:Any})

Create a workload share. The owner of a workload can share it with other Amazon Web
Services accounts and users in the same Amazon Web Services Region. Shared access to a
workload is not removed until the workload invitation is deleted. If you share a workload
with an organization or OU, all accounts in the organization or OU are granted access to
the workload. For more information, see Sharing a workload in the Well-Architected Tool
User Guide.

# Arguments
- `client_request_token`:
- `permission_type`:
- `shared_with`:
- `workload_id`:

"""
function create_workload_share(
    ClientRequestToken,
    PermissionType,
    SharedWith,
    WorkloadId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "POST",
        "/workloads/$(WorkloadId)/shares",
        Dict{String,Any}(
            "ClientRequestToken" => ClientRequestToken,
            "PermissionType" => PermissionType,
            "SharedWith" => SharedWith,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_workload_share(
    ClientRequestToken,
    PermissionType,
    SharedWith,
    WorkloadId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "POST",
        "/workloads/$(WorkloadId)/shares",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClientRequestToken" => ClientRequestToken,
                    "PermissionType" => PermissionType,
                    "SharedWith" => SharedWith,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_lens(client_request_token, lens_alias, lens_status)
    delete_lens(client_request_token, lens_alias, lens_status, params::Dict{String,<:Any})

Delete an existing lens. Only the owner of a lens can delete it. After the lens is deleted,
Amazon Web Services accounts and users that you shared the lens with can continue to use
it, but they will no longer be able to apply it to new workloads.    Disclaimer  By sharing
your custom lenses with other Amazon Web Services accounts, you acknowledge that Amazon Web
Services will make your custom lenses available to those other accounts. Those other
accounts may continue to access and use your shared custom lenses even if you delete the
custom lenses from your own Amazon Web Services account or terminate your Amazon Web
Services account.

# Arguments
- `client_request_token`:
- `lens_alias`:
- `lens_status`: The status of the lens to be deleted.

"""
function delete_lens(
    ClientRequestToken,
    LensAlias,
    LensStatus;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "DELETE",
        "/lenses/$(LensAlias)",
        Dict{String,Any}(
            "ClientRequestToken" => ClientRequestToken, "LensStatus" => LensStatus
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_lens(
    ClientRequestToken,
    LensAlias,
    LensStatus,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "DELETE",
        "/lenses/$(LensAlias)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClientRequestToken" => ClientRequestToken, "LensStatus" => LensStatus
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_lens_share(client_request_token, lens_alias, share_id)
    delete_lens_share(client_request_token, lens_alias, share_id, params::Dict{String,<:Any})

Delete a lens share. After the lens share is deleted, Amazon Web Services accounts, users,
organizations, and organizational units (OUs) that you shared the lens with can continue to
use it, but they will no longer be able to apply it to new workloads.   Disclaimer  By
sharing your custom lenses with other Amazon Web Services accounts, you acknowledge that
Amazon Web Services will make your custom lenses available to those other accounts. Those
other accounts may continue to access and use your shared custom lenses even if you delete
the custom lenses from your own Amazon Web Services account or terminate your Amazon Web
Services account.

# Arguments
- `client_request_token`:
- `lens_alias`:
- `share_id`:

"""
function delete_lens_share(
    ClientRequestToken,
    LensAlias,
    ShareId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "DELETE",
        "/lenses/$(LensAlias)/shares/$(ShareId)",
        Dict{String,Any}("ClientRequestToken" => ClientRequestToken);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_lens_share(
    ClientRequestToken,
    LensAlias,
    ShareId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "DELETE",
        "/lenses/$(LensAlias)/shares/$(ShareId)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ClientRequestToken" => ClientRequestToken), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_profile(client_request_token, profile_arn)
    delete_profile(client_request_token, profile_arn, params::Dict{String,<:Any})

Delete a profile.   Disclaimer  By sharing your profile with other Amazon Web Services
accounts, you acknowledge that Amazon Web Services will make your profile available to
those other accounts. Those other accounts may continue to access and use your shared
profile even if you delete the profile from your own Amazon Web Services account or
terminate your Amazon Web Services account.

# Arguments
- `client_request_token`:
- `profile_arn`: The profile ARN.

"""
function delete_profile(
    ClientRequestToken, ProfileArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wellarchitected(
        "DELETE",
        "/profiles/$(ProfileArn)",
        Dict{String,Any}("ClientRequestToken" => ClientRequestToken);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_profile(
    ClientRequestToken,
    ProfileArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "DELETE",
        "/profiles/$(ProfileArn)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ClientRequestToken" => ClientRequestToken), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_profile_share(client_request_token, profile_arn, share_id)
    delete_profile_share(client_request_token, profile_arn, share_id, params::Dict{String,<:Any})

Delete a profile share.

# Arguments
- `client_request_token`:
- `profile_arn`: The profile ARN.
- `share_id`:

"""
function delete_profile_share(
    ClientRequestToken,
    ProfileArn,
    ShareId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "DELETE",
        "/profiles/$(ProfileArn)/shares/$(ShareId)",
        Dict{String,Any}("ClientRequestToken" => ClientRequestToken);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_profile_share(
    ClientRequestToken,
    ProfileArn,
    ShareId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "DELETE",
        "/profiles/$(ProfileArn)/shares/$(ShareId)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ClientRequestToken" => ClientRequestToken), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_review_template(client_request_token, template_arn)
    delete_review_template(client_request_token, template_arn, params::Dict{String,<:Any})

Delete a review template. Only the owner of a review template can delete it. After the
review template is deleted, Amazon Web Services accounts, users, organizations, and
organizational units (OUs) that you shared the review template with will no longer be able
to apply it to new workloads.

# Arguments
- `client_request_token`:
- `template_arn`: The review template ARN.

"""
function delete_review_template(
    ClientRequestToken, TemplateArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wellarchitected(
        "DELETE",
        "/reviewTemplates/$(TemplateArn)",
        Dict{String,Any}("ClientRequestToken" => ClientRequestToken);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_review_template(
    ClientRequestToken,
    TemplateArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "DELETE",
        "/reviewTemplates/$(TemplateArn)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ClientRequestToken" => ClientRequestToken), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_template_share(client_request_token, share_id, template_arn)
    delete_template_share(client_request_token, share_id, template_arn, params::Dict{String,<:Any})

Delete a review template share. After the review template share is deleted, Amazon Web
Services accounts, users, organizations, and organizational units (OUs) that you shared the
review template with will no longer be able to apply it to new workloads.

# Arguments
- `client_request_token`:
- `share_id`:
- `template_arn`: The review template ARN.

"""
function delete_template_share(
    ClientRequestToken,
    ShareId,
    TemplateArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "DELETE",
        "/templates/shares/$(TemplateArn)/$(ShareId)",
        Dict{String,Any}("ClientRequestToken" => ClientRequestToken);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_template_share(
    ClientRequestToken,
    ShareId,
    TemplateArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "DELETE",
        "/templates/shares/$(TemplateArn)/$(ShareId)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ClientRequestToken" => ClientRequestToken), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_workload(client_request_token, workload_id)
    delete_workload(client_request_token, workload_id, params::Dict{String,<:Any})

Delete an existing workload.

# Arguments
- `client_request_token`:
- `workload_id`:

"""
function delete_workload(
    ClientRequestToken, WorkloadId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wellarchitected(
        "DELETE",
        "/workloads/$(WorkloadId)",
        Dict{String,Any}("ClientRequestToken" => ClientRequestToken);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_workload(
    ClientRequestToken,
    WorkloadId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "DELETE",
        "/workloads/$(WorkloadId)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ClientRequestToken" => ClientRequestToken), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_workload_share(client_request_token, share_id, workload_id)
    delete_workload_share(client_request_token, share_id, workload_id, params::Dict{String,<:Any})

Delete a workload share.

# Arguments
- `client_request_token`:
- `share_id`:
- `workload_id`:

"""
function delete_workload_share(
    ClientRequestToken,
    ShareId,
    WorkloadId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "DELETE",
        "/workloads/$(WorkloadId)/shares/$(ShareId)",
        Dict{String,Any}("ClientRequestToken" => ClientRequestToken);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_workload_share(
    ClientRequestToken,
    ShareId,
    WorkloadId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "DELETE",
        "/workloads/$(WorkloadId)/shares/$(ShareId)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ClientRequestToken" => ClientRequestToken), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_lenses(lens_aliases, workload_id)
    disassociate_lenses(lens_aliases, workload_id, params::Dict{String,<:Any})

Disassociate a lens from a workload. Up to 10 lenses can be disassociated from a workload
in a single API operation.  The Amazon Web Services Well-Architected Framework lens
(wellarchitected) cannot be removed from a workload.

# Arguments
- `lens_aliases`:
- `workload_id`:

"""
function disassociate_lenses(
    LensAliases, WorkloadId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wellarchitected(
        "PATCH",
        "/workloads/$(WorkloadId)/disassociateLenses",
        Dict{String,Any}("LensAliases" => LensAliases);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_lenses(
    LensAliases,
    WorkloadId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "PATCH",
        "/workloads/$(WorkloadId)/disassociateLenses",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("LensAliases" => LensAliases), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_profiles(profile_arns, workload_id)
    disassociate_profiles(profile_arns, workload_id, params::Dict{String,<:Any})

Disassociate a profile from a workload.

# Arguments
- `profile_arns`: The list of profile ARNs to disassociate from the workload.
- `workload_id`:

"""
function disassociate_profiles(
    ProfileArns, WorkloadId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wellarchitected(
        "PATCH",
        "/workloads/$(WorkloadId)/disassociateProfiles",
        Dict{String,Any}("ProfileArns" => ProfileArns);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_profiles(
    ProfileArns,
    WorkloadId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "PATCH",
        "/workloads/$(WorkloadId)/disassociateProfiles",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ProfileArns" => ProfileArns), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    export_lens(lens_alias)
    export_lens(lens_alias, params::Dict{String,<:Any})

Export an existing lens. Only the owner of a lens can export it. Lenses provided by Amazon
Web Services (Amazon Web Services Official Content) cannot be exported. Lenses are defined
in JSON. For more information, see JSON format specification in the Well-Architected Tool
User Guide.   Disclaimer  Do not include or gather personal identifiable information (PII)
of end users or other identifiable individuals in or via your custom lenses. If your custom
lens or those shared with you and used in your account do include or collect PII you are
responsible for: ensuring that the included PII is processed in accordance with applicable
law, providing adequate privacy notices, and obtaining necessary consents for processing
such data.

# Arguments
- `lens_alias`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"LensVersion"`: The lens version to be exported.
"""
function export_lens(LensAlias; aws_config::AbstractAWSConfig=current_aws_config())
    return wellarchitected(
        "GET",
        "/lenses/$(LensAlias)/export";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function export_lens(
    LensAlias,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "GET",
        "/lenses/$(LensAlias)/export",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_answer(lens_alias, question_id, workload_id)
    get_answer(lens_alias, question_id, workload_id, params::Dict{String,<:Any})

Get the answer to a specific question in a workload review.

# Arguments
- `lens_alias`:
- `question_id`:
- `workload_id`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MilestoneNumber"`:
"""
function get_answer(
    LensAlias, QuestionId, WorkloadId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wellarchitected(
        "GET",
        "/workloads/$(WorkloadId)/lensReviews/$(LensAlias)/answers/$(QuestionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_answer(
    LensAlias,
    QuestionId,
    WorkloadId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "GET",
        "/workloads/$(WorkloadId)/lensReviews/$(LensAlias)/answers/$(QuestionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_consolidated_report(format)
    get_consolidated_report(format, params::Dict{String,<:Any})

Get a consolidated report of your workloads. You can optionally choose to include workloads
that have been shared with you.

# Arguments
- `format`: The format of the consolidated report. For PDF, Base64String is returned. For
  JSON, Metrics is returned.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"IncludeSharedResources"`: Set to true to have shared resources included in the report.
- `"MaxResults"`: The maximum number of results to return for this request.
- `"NextToken"`:
"""
function get_consolidated_report(Format; aws_config::AbstractAWSConfig=current_aws_config())
    return wellarchitected(
        "GET",
        "/consolidatedReport",
        Dict{String,Any}("Format" => Format);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_consolidated_report(
    Format, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wellarchitected(
        "GET",
        "/consolidatedReport",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Format" => Format), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_global_settings()
    get_global_settings(params::Dict{String,<:Any})

Global settings for all workloads.

"""
function get_global_settings(; aws_config::AbstractAWSConfig=current_aws_config())
    return wellarchitected(
        "GET", "/global-settings"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_global_settings(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wellarchitected(
        "GET",
        "/global-settings",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_lens(lens_alias)
    get_lens(lens_alias, params::Dict{String,<:Any})

Get an existing lens.

# Arguments
- `lens_alias`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"LensVersion"`: The lens version to be retrieved.
"""
function get_lens(LensAlias; aws_config::AbstractAWSConfig=current_aws_config())
    return wellarchitected(
        "GET",
        "/lenses/$(LensAlias)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_lens(
    LensAlias,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "GET",
        "/lenses/$(LensAlias)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_lens_review(lens_alias, workload_id)
    get_lens_review(lens_alias, workload_id, params::Dict{String,<:Any})

Get lens review.

# Arguments
- `lens_alias`:
- `workload_id`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MilestoneNumber"`:
"""
function get_lens_review(
    LensAlias, WorkloadId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wellarchitected(
        "GET",
        "/workloads/$(WorkloadId)/lensReviews/$(LensAlias)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_lens_review(
    LensAlias,
    WorkloadId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "GET",
        "/workloads/$(WorkloadId)/lensReviews/$(LensAlias)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_lens_review_report(lens_alias, workload_id)
    get_lens_review_report(lens_alias, workload_id, params::Dict{String,<:Any})

Get lens review report.

# Arguments
- `lens_alias`:
- `workload_id`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MilestoneNumber"`:
"""
function get_lens_review_report(
    LensAlias, WorkloadId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wellarchitected(
        "GET",
        "/workloads/$(WorkloadId)/lensReviews/$(LensAlias)/report";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_lens_review_report(
    LensAlias,
    WorkloadId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "GET",
        "/workloads/$(WorkloadId)/lensReviews/$(LensAlias)/report",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_lens_version_difference(lens_alias)
    get_lens_version_difference(lens_alias, params::Dict{String,<:Any})

Get lens version differences.

# Arguments
- `lens_alias`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"BaseLensVersion"`: The base version of the lens.
- `"TargetLensVersion"`: The lens version to target a difference for.
"""
function get_lens_version_difference(
    LensAlias; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wellarchitected(
        "GET",
        "/lenses/$(LensAlias)/versionDifference";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_lens_version_difference(
    LensAlias,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "GET",
        "/lenses/$(LensAlias)/versionDifference",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_milestone(milestone_number, workload_id)
    get_milestone(milestone_number, workload_id, params::Dict{String,<:Any})

Get a milestone for an existing workload.

# Arguments
- `milestone_number`:
- `workload_id`:

"""
function get_milestone(
    MilestoneNumber, WorkloadId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wellarchitected(
        "GET",
        "/workloads/$(WorkloadId)/milestones/$(MilestoneNumber)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_milestone(
    MilestoneNumber,
    WorkloadId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "GET",
        "/workloads/$(WorkloadId)/milestones/$(MilestoneNumber)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_profile(profile_arn)
    get_profile(profile_arn, params::Dict{String,<:Any})

Get profile information.

# Arguments
- `profile_arn`: The profile ARN.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ProfileVersion"`: The profile version.
"""
function get_profile(ProfileArn; aws_config::AbstractAWSConfig=current_aws_config())
    return wellarchitected(
        "GET",
        "/profiles/$(ProfileArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_profile(
    ProfileArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "GET",
        "/profiles/$(ProfileArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_profile_template()
    get_profile_template(params::Dict{String,<:Any})

Get profile template.

"""
function get_profile_template(; aws_config::AbstractAWSConfig=current_aws_config())
    return wellarchitected(
        "GET", "/profileTemplate"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_profile_template(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wellarchitected(
        "GET",
        "/profileTemplate",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_review_template(template_arn)
    get_review_template(template_arn, params::Dict{String,<:Any})

Get review template.

# Arguments
- `template_arn`: The review template ARN.

"""
function get_review_template(
    TemplateArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wellarchitected(
        "GET",
        "/reviewTemplates/$(TemplateArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_review_template(
    TemplateArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "GET",
        "/reviewTemplates/$(TemplateArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_review_template_answer(lens_alias, question_id, template_arn)
    get_review_template_answer(lens_alias, question_id, template_arn, params::Dict{String,<:Any})

Get review template answer.

# Arguments
- `lens_alias`:
- `question_id`:
- `template_arn`: The review template ARN.

"""
function get_review_template_answer(
    LensAlias, QuestionId, TemplateArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wellarchitected(
        "GET",
        "/reviewTemplates/$(TemplateArn)/lensReviews/$(LensAlias)/answers/$(QuestionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_review_template_answer(
    LensAlias,
    QuestionId,
    TemplateArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "GET",
        "/reviewTemplates/$(TemplateArn)/lensReviews/$(LensAlias)/answers/$(QuestionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_review_template_lens_review(lens_alias, template_arn)
    get_review_template_lens_review(lens_alias, template_arn, params::Dict{String,<:Any})

Get a lens review associated with a review template.

# Arguments
- `lens_alias`:
- `template_arn`: The review template ARN.

"""
function get_review_template_lens_review(
    LensAlias, TemplateArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wellarchitected(
        "GET",
        "/reviewTemplates/$(TemplateArn)/lensReviews/$(LensAlias)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_review_template_lens_review(
    LensAlias,
    TemplateArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "GET",
        "/reviewTemplates/$(TemplateArn)/lensReviews/$(LensAlias)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_workload(workload_id)
    get_workload(workload_id, params::Dict{String,<:Any})

Get an existing workload.

# Arguments
- `workload_id`:

"""
function get_workload(WorkloadId; aws_config::AbstractAWSConfig=current_aws_config())
    return wellarchitected(
        "GET",
        "/workloads/$(WorkloadId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_workload(
    WorkloadId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "GET",
        "/workloads/$(WorkloadId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    import_lens(client_request_token, jsonstring)
    import_lens(client_request_token, jsonstring, params::Dict{String,<:Any})

Import a new custom lens or update an existing custom lens. To update an existing custom
lens, specify its ARN as the LensAlias. If no ARN is specified, a new custom lens is
created. The new or updated lens will have a status of DRAFT. The lens cannot be applied to
workloads or shared with other Amazon Web Services accounts until it's published with
CreateLensVersion. Lenses are defined in JSON. For more information, see JSON format
specification in the Well-Architected Tool User Guide. A custom lens cannot exceed 500 KB
in size.   Disclaimer  Do not include or gather personal identifiable information (PII) of
end users or other identifiable individuals in or via your custom lenses. If your custom
lens or those shared with you and used in your account do include or collect PII you are
responsible for: ensuring that the included PII is processed in accordance with applicable
law, providing adequate privacy notices, and obtaining necessary consents for processing
such data.

# Arguments
- `client_request_token`:
- `jsonstring`: The JSON representation of a lens.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"LensAlias"`:
- `"Tags"`: Tags to associate to a lens.
"""
function import_lens(
    ClientRequestToken, JSONString; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wellarchitected(
        "PUT",
        "/importLens",
        Dict{String,Any}(
            "ClientRequestToken" => ClientRequestToken, "JSONString" => JSONString
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function import_lens(
    ClientRequestToken,
    JSONString,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "PUT",
        "/importLens",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClientRequestToken" => ClientRequestToken, "JSONString" => JSONString
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_answers(lens_alias, workload_id)
    list_answers(lens_alias, workload_id, params::Dict{String,<:Any})

List of answers for a particular workload and lens.

# Arguments
- `lens_alias`:
- `workload_id`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to return for this request.
- `"MilestoneNumber"`:
- `"NextToken"`:
- `"PillarId"`:
- `"QuestionPriority"`: The priority of the question.
"""
function list_answers(
    LensAlias, WorkloadId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wellarchitected(
        "GET",
        "/workloads/$(WorkloadId)/lensReviews/$(LensAlias)/answers";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_answers(
    LensAlias,
    WorkloadId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "GET",
        "/workloads/$(WorkloadId)/lensReviews/$(LensAlias)/answers",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_check_details(choice_id, lens_arn, pillar_id, question_id, workload_id)
    list_check_details(choice_id, lens_arn, pillar_id, question_id, workload_id, params::Dict{String,<:Any})

List of Trusted Advisor check details by account related to the workload.

# Arguments
- `choice_id`:
- `lens_arn`: Well-Architected Lens ARN.
- `pillar_id`:
- `question_id`:
- `workload_id`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`:
- `"NextToken"`:
"""
function list_check_details(
    ChoiceId,
    LensArn,
    PillarId,
    QuestionId,
    WorkloadId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "POST",
        "/workloads/$(WorkloadId)/checks",
        Dict{String,Any}(
            "ChoiceId" => ChoiceId,
            "LensArn" => LensArn,
            "PillarId" => PillarId,
            "QuestionId" => QuestionId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_check_details(
    ChoiceId,
    LensArn,
    PillarId,
    QuestionId,
    WorkloadId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "POST",
        "/workloads/$(WorkloadId)/checks",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ChoiceId" => ChoiceId,
                    "LensArn" => LensArn,
                    "PillarId" => PillarId,
                    "QuestionId" => QuestionId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_check_summaries(choice_id, lens_arn, pillar_id, question_id, workload_id)
    list_check_summaries(choice_id, lens_arn, pillar_id, question_id, workload_id, params::Dict{String,<:Any})

List of Trusted Advisor checks summarized for all accounts related to the workload.

# Arguments
- `choice_id`:
- `lens_arn`: Well-Architected Lens ARN.
- `pillar_id`:
- `question_id`:
- `workload_id`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`:
- `"NextToken"`:
"""
function list_check_summaries(
    ChoiceId,
    LensArn,
    PillarId,
    QuestionId,
    WorkloadId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "POST",
        "/workloads/$(WorkloadId)/checkSummaries",
        Dict{String,Any}(
            "ChoiceId" => ChoiceId,
            "LensArn" => LensArn,
            "PillarId" => PillarId,
            "QuestionId" => QuestionId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_check_summaries(
    ChoiceId,
    LensArn,
    PillarId,
    QuestionId,
    WorkloadId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "POST",
        "/workloads/$(WorkloadId)/checkSummaries",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ChoiceId" => ChoiceId,
                    "LensArn" => LensArn,
                    "PillarId" => PillarId,
                    "QuestionId" => QuestionId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_lens_review_improvements(lens_alias, workload_id)
    list_lens_review_improvements(lens_alias, workload_id, params::Dict{String,<:Any})

List the improvements of a particular lens review.

# Arguments
- `lens_alias`:
- `workload_id`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to return for this request.
- `"MilestoneNumber"`:
- `"NextToken"`:
- `"PillarId"`:
- `"QuestionPriority"`: The priority of the question.
"""
function list_lens_review_improvements(
    LensAlias, WorkloadId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wellarchitected(
        "GET",
        "/workloads/$(WorkloadId)/lensReviews/$(LensAlias)/improvements";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_lens_review_improvements(
    LensAlias,
    WorkloadId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "GET",
        "/workloads/$(WorkloadId)/lensReviews/$(LensAlias)/improvements",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_lens_reviews(workload_id)
    list_lens_reviews(workload_id, params::Dict{String,<:Any})

List lens reviews for a particular workload.

# Arguments
- `workload_id`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`:
- `"MilestoneNumber"`:
- `"NextToken"`:
"""
function list_lens_reviews(WorkloadId; aws_config::AbstractAWSConfig=current_aws_config())
    return wellarchitected(
        "GET",
        "/workloads/$(WorkloadId)/lensReviews";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_lens_reviews(
    WorkloadId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "GET",
        "/workloads/$(WorkloadId)/lensReviews",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_lens_shares(lens_alias)
    list_lens_shares(lens_alias, params::Dict{String,<:Any})

List the lens shares associated with the lens.

# Arguments
- `lens_alias`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to return for this request.
- `"NextToken"`:
- `"SharedWithPrefix"`: The Amazon Web Services account ID, organization ID, or
  organizational unit (OU) ID with which the lens is shared.
- `"Status"`:
"""
function list_lens_shares(LensAlias; aws_config::AbstractAWSConfig=current_aws_config())
    return wellarchitected(
        "GET",
        "/lenses/$(LensAlias)/shares";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_lens_shares(
    LensAlias,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "GET",
        "/lenses/$(LensAlias)/shares",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_lenses()
    list_lenses(params::Dict{String,<:Any})

List the available lenses.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"LensName"`:
- `"LensStatus"`: The status of lenses to be returned.
- `"LensType"`: The type of lenses to be returned.
- `"MaxResults"`:
- `"NextToken"`:
"""
function list_lenses(; aws_config::AbstractAWSConfig=current_aws_config())
    return wellarchitected(
        "GET", "/lenses"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_lenses(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wellarchitected(
        "GET", "/lenses", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_milestones(workload_id)
    list_milestones(workload_id, params::Dict{String,<:Any})

List all milestones for an existing workload.

# Arguments
- `workload_id`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`:
- `"NextToken"`:
"""
function list_milestones(WorkloadId; aws_config::AbstractAWSConfig=current_aws_config())
    return wellarchitected(
        "POST",
        "/workloads/$(WorkloadId)/milestonesSummaries";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_milestones(
    WorkloadId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "POST",
        "/workloads/$(WorkloadId)/milestonesSummaries",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_notifications()
    list_notifications(params::Dict{String,<:Any})

List lens notifications.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to return for this request.
- `"NextToken"`:
- `"ResourceArn"`: The ARN for the related resource for the notification.  Only one of
  WorkloadID or ResourceARN should be specified.
- `"WorkloadId"`:
"""
function list_notifications(; aws_config::AbstractAWSConfig=current_aws_config())
    return wellarchitected(
        "POST", "/notifications"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_notifications(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wellarchitected(
        "POST",
        "/notifications",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_profile_notifications()
    list_profile_notifications(params::Dict{String,<:Any})

List profile notifications.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`:
- `"NextToken"`:
- `"WorkloadId"`:
"""
function list_profile_notifications(; aws_config::AbstractAWSConfig=current_aws_config())
    return wellarchitected(
        "GET",
        "/profileNotifications/";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_profile_notifications(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wellarchitected(
        "GET",
        "/profileNotifications/",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_profile_shares(profile_arn)
    list_profile_shares(profile_arn, params::Dict{String,<:Any})

List profile shares.

# Arguments
- `profile_arn`: The profile ARN.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to return for this request.
- `"NextToken"`:
- `"SharedWithPrefix"`: The Amazon Web Services account ID, organization ID, or
  organizational unit (OU) ID with which the profile is shared.
- `"Status"`:
"""
function list_profile_shares(ProfileArn; aws_config::AbstractAWSConfig=current_aws_config())
    return wellarchitected(
        "GET",
        "/profiles/$(ProfileArn)/shares";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_profile_shares(
    ProfileArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "GET",
        "/profiles/$(ProfileArn)/shares",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_profiles()
    list_profiles(params::Dict{String,<:Any})

List profiles.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`:
- `"NextToken"`:
- `"ProfileNamePrefix"`: An optional string added to the beginning of each profile name
  returned in the results.
- `"ProfileOwnerType"`: Profile owner type.
"""
function list_profiles(; aws_config::AbstractAWSConfig=current_aws_config())
    return wellarchitected(
        "GET", "/profileSummaries"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_profiles(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wellarchitected(
        "GET",
        "/profileSummaries",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_review_template_answers(lens_alias, template_arn)
    list_review_template_answers(lens_alias, template_arn, params::Dict{String,<:Any})

List the answers of a review template.

# Arguments
- `lens_alias`:
- `template_arn`: The ARN of the review template.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to return for this request.
- `"NextToken"`:
- `"PillarId"`:
"""
function list_review_template_answers(
    LensAlias, TemplateArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wellarchitected(
        "GET",
        "/reviewTemplates/$(TemplateArn)/lensReviews/$(LensAlias)/answers";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_review_template_answers(
    LensAlias,
    TemplateArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "GET",
        "/reviewTemplates/$(TemplateArn)/lensReviews/$(LensAlias)/answers",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_review_templates()
    list_review_templates(params::Dict{String,<:Any})

List review templates.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`:
- `"NextToken"`:
"""
function list_review_templates(; aws_config::AbstractAWSConfig=current_aws_config())
    return wellarchitected(
        "GET", "/reviewTemplates"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_review_templates(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wellarchitected(
        "GET",
        "/reviewTemplates",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_share_invitations()
    list_share_invitations(params::Dict{String,<:Any})

List the share invitations.  WorkloadNamePrefix, LensNamePrefix, ProfileNamePrefix, and
TemplateNamePrefix are mutually exclusive. Use the parameter that matches your
ShareResourceType.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"LensNamePrefix"`: An optional string added to the beginning of each lens name returned
  in the results.
- `"MaxResults"`: The maximum number of results to return for this request.
- `"NextToken"`:
- `"ProfileNamePrefix"`: An optional string added to the beginning of each profile name
  returned in the results.
- `"ShareResourceType"`: The type of share invitations to be returned.
- `"TemplateNamePrefix"`: An optional string added to the beginning of each review template
  name returned in the results.
- `"WorkloadNamePrefix"`:
"""
function list_share_invitations(; aws_config::AbstractAWSConfig=current_aws_config())
    return wellarchitected(
        "GET", "/shareInvitations"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_share_invitations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wellarchitected(
        "GET",
        "/shareInvitations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(workload_arn)
    list_tags_for_resource(workload_arn, params::Dict{String,<:Any})

List the tags for a resource.  The WorkloadArn parameter can be a workload ARN, a custom
lens ARN, a profile ARN, or review template ARN.

# Arguments
- `workload_arn`:

"""
function list_tags_for_resource(
    WorkloadArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wellarchitected(
        "GET",
        "/tags/$(WorkloadArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    WorkloadArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "GET",
        "/tags/$(WorkloadArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_template_shares(template_arn)
    list_template_shares(template_arn, params::Dict{String,<:Any})

List review template shares.

# Arguments
- `template_arn`: The review template ARN.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to return for this request.
- `"NextToken"`:
- `"SharedWithPrefix"`: The Amazon Web Services account ID, organization ID, or
  organizational unit (OU) ID with which the profile is shared.
- `"Status"`:
"""
function list_template_shares(
    TemplateArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wellarchitected(
        "GET",
        "/templates/shares/$(TemplateArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_template_shares(
    TemplateArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "GET",
        "/templates/shares/$(TemplateArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_workload_shares(workload_id)
    list_workload_shares(workload_id, params::Dict{String,<:Any})

List the workload shares associated with the workload.

# Arguments
- `workload_id`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to return for this request.
- `"NextToken"`:
- `"SharedWithPrefix"`: The Amazon Web Services account ID, organization ID, or
  organizational unit (OU) ID with which the workload is shared.
- `"Status"`:
"""
function list_workload_shares(
    WorkloadId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wellarchitected(
        "GET",
        "/workloads/$(WorkloadId)/shares";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_workload_shares(
    WorkloadId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "GET",
        "/workloads/$(WorkloadId)/shares",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_workloads()
    list_workloads(params::Dict{String,<:Any})

Paginated list of workloads.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to return for this request.
- `"NextToken"`:
- `"WorkloadNamePrefix"`:
"""
function list_workloads(; aws_config::AbstractAWSConfig=current_aws_config())
    return wellarchitected(
        "POST",
        "/workloadsSummaries";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_workloads(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wellarchitected(
        "POST",
        "/workloadsSummaries",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(tags, workload_arn)
    tag_resource(tags, workload_arn, params::Dict{String,<:Any})

Adds one or more tags to the specified resource.  The WorkloadArn parameter can be a
workload ARN, a custom lens ARN, a profile ARN, or review template ARN.

# Arguments
- `tags`: The tags for the resource.
- `workload_arn`:

"""
function tag_resource(Tags, WorkloadArn; aws_config::AbstractAWSConfig=current_aws_config())
    return wellarchitected(
        "POST",
        "/tags/$(WorkloadArn)",
        Dict{String,Any}("Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    Tags,
    WorkloadArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "POST",
        "/tags/$(WorkloadArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Tags" => Tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(workload_arn, tag_keys)
    untag_resource(workload_arn, tag_keys, params::Dict{String,<:Any})

Deletes specified tags from a resource.  The WorkloadArn parameter can be a workload ARN, a
custom lens ARN, a profile ARN, or review template ARN.  To specify multiple tags, use
separate tagKeys parameters, for example:  DELETE
/tags/WorkloadArn?tagKeys=key1&amp;tagKeys=key2

# Arguments
- `workload_arn`:
- `tag_keys`: A list of tag keys. Existing tags of the resource whose keys are members of
  this list are removed from the resource.

"""
function untag_resource(
    WorkloadArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wellarchitected(
        "DELETE",
        "/tags/$(WorkloadArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    WorkloadArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "DELETE",
        "/tags/$(WorkloadArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_answer(lens_alias, question_id, workload_id)
    update_answer(lens_alias, question_id, workload_id, params::Dict{String,<:Any})

Update the answer to a specific question in a workload review.

# Arguments
- `lens_alias`:
- `question_id`:
- `workload_id`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ChoiceUpdates"`: A list of choices to update on a question in your workload. The String
  key corresponds to the choice ID to be updated.
- `"IsApplicable"`:
- `"Notes"`:
- `"Reason"`: The reason why a question is not applicable to your workload.
- `"SelectedChoices"`:
"""
function update_answer(
    LensAlias, QuestionId, WorkloadId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wellarchitected(
        "PATCH",
        "/workloads/$(WorkloadId)/lensReviews/$(LensAlias)/answers/$(QuestionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_answer(
    LensAlias,
    QuestionId,
    WorkloadId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "PATCH",
        "/workloads/$(WorkloadId)/lensReviews/$(LensAlias)/answers/$(QuestionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_global_settings()
    update_global_settings(params::Dict{String,<:Any})

Update whether the Amazon Web Services account is opted into organization sharing and
discovery integration features.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DiscoveryIntegrationStatus"`: The status of discovery support settings.
- `"JiraConfiguration"`: The status of Jira integration settings.
- `"OrganizationSharingStatus"`: The status of organization sharing settings.
"""
function update_global_settings(; aws_config::AbstractAWSConfig=current_aws_config())
    return wellarchitected(
        "PATCH", "/global-settings"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function update_global_settings(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wellarchitected(
        "PATCH",
        "/global-settings",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_integration(client_request_token, integrating_service, workload_id)
    update_integration(client_request_token, integrating_service, workload_id, params::Dict{String,<:Any})

Update integration features.

# Arguments
- `client_request_token`:
- `integrating_service`: Which integrated service to update.
- `workload_id`:

"""
function update_integration(
    ClientRequestToken,
    IntegratingService,
    WorkloadId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "POST",
        "/workloads/$(WorkloadId)/updateIntegration",
        Dict{String,Any}(
            "ClientRequestToken" => ClientRequestToken,
            "IntegratingService" => IntegratingService,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_integration(
    ClientRequestToken,
    IntegratingService,
    WorkloadId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "POST",
        "/workloads/$(WorkloadId)/updateIntegration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ClientRequestToken" => ClientRequestToken,
                    "IntegratingService" => IntegratingService,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_lens_review(lens_alias, workload_id)
    update_lens_review(lens_alias, workload_id, params::Dict{String,<:Any})

Update lens review for a particular workload.

# Arguments
- `lens_alias`:
- `workload_id`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"JiraConfiguration"`: Configuration of the Jira integration.
- `"LensNotes"`:
- `"PillarNotes"`:
"""
function update_lens_review(
    LensAlias, WorkloadId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wellarchitected(
        "PATCH",
        "/workloads/$(WorkloadId)/lensReviews/$(LensAlias)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_lens_review(
    LensAlias,
    WorkloadId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "PATCH",
        "/workloads/$(WorkloadId)/lensReviews/$(LensAlias)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_profile(profile_arn)
    update_profile(profile_arn, params::Dict{String,<:Any})

Update a profile.

# Arguments
- `profile_arn`: The profile ARN.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ProfileDescription"`: The profile description.
- `"ProfileQuestions"`: Profile questions.
"""
function update_profile(ProfileArn; aws_config::AbstractAWSConfig=current_aws_config())
    return wellarchitected(
        "PATCH",
        "/profiles/$(ProfileArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_profile(
    ProfileArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "PATCH",
        "/profiles/$(ProfileArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_review_template(template_arn)
    update_review_template(template_arn, params::Dict{String,<:Any})

Update a review template.

# Arguments
- `template_arn`: The review template ARN.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: The review template description.
- `"LensesToAssociate"`: A list of lens aliases or ARNs to apply to the review template.
- `"LensesToDisassociate"`: A list of lens aliases or ARNs to unapply to the review
  template. The wellarchitected lens cannot be unapplied.
- `"Notes"`:
- `"TemplateName"`: The review template name.
"""
function update_review_template(
    TemplateArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wellarchitected(
        "PATCH",
        "/reviewTemplates/$(TemplateArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_review_template(
    TemplateArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "PATCH",
        "/reviewTemplates/$(TemplateArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_review_template_answer(lens_alias, question_id, template_arn)
    update_review_template_answer(lens_alias, question_id, template_arn, params::Dict{String,<:Any})

Update a review template answer.

# Arguments
- `lens_alias`:
- `question_id`:
- `template_arn`: The review template ARN.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ChoiceUpdates"`: A list of choices to be updated.
- `"IsApplicable"`:
- `"Notes"`:
- `"Reason"`: The update reason.
- `"SelectedChoices"`:
"""
function update_review_template_answer(
    LensAlias, QuestionId, TemplateArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wellarchitected(
        "PATCH",
        "/reviewTemplates/$(TemplateArn)/lensReviews/$(LensAlias)/answers/$(QuestionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_review_template_answer(
    LensAlias,
    QuestionId,
    TemplateArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "PATCH",
        "/reviewTemplates/$(TemplateArn)/lensReviews/$(LensAlias)/answers/$(QuestionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_review_template_lens_review(lens_alias, template_arn)
    update_review_template_lens_review(lens_alias, template_arn, params::Dict{String,<:Any})

Update a lens review associated with a review template.

# Arguments
- `lens_alias`:
- `template_arn`: The review template ARN.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"LensNotes"`:
- `"PillarNotes"`:
"""
function update_review_template_lens_review(
    LensAlias, TemplateArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wellarchitected(
        "PATCH",
        "/reviewTemplates/$(TemplateArn)/lensReviews/$(LensAlias)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_review_template_lens_review(
    LensAlias,
    TemplateArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "PATCH",
        "/reviewTemplates/$(TemplateArn)/lensReviews/$(LensAlias)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_share_invitation(share_invitation_action, share_invitation_id)
    update_share_invitation(share_invitation_action, share_invitation_id, params::Dict{String,<:Any})

Update a workload or custom lens share invitation.  This API operation can be called
independently of any resource. Previous documentation implied that a workload ARN must be
specified.

# Arguments
- `share_invitation_action`:
- `share_invitation_id`: The ID assigned to the share invitation.

"""
function update_share_invitation(
    ShareInvitationAction,
    ShareInvitationId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "PATCH",
        "/shareInvitations/$(ShareInvitationId)",
        Dict{String,Any}("ShareInvitationAction" => ShareInvitationAction);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_share_invitation(
    ShareInvitationAction,
    ShareInvitationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "PATCH",
        "/shareInvitations/$(ShareInvitationId)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ShareInvitationAction" => ShareInvitationAction),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_workload(workload_id)
    update_workload(workload_id, params::Dict{String,<:Any})

Update an existing workload.

# Arguments
- `workload_id`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AccountIds"`:
- `"Applications"`: List of AppRegistry application ARNs to associate to the workload.
- `"ArchitecturalDesign"`:
- `"AwsRegions"`:
- `"Description"`:
- `"DiscoveryConfig"`: Well-Architected discovery configuration settings to associate to
  the workload.
- `"Environment"`:
- `"ImprovementStatus"`:
- `"Industry"`:
- `"IndustryType"`:
- `"IsReviewOwnerUpdateAcknowledged"`: Flag indicating whether the workload owner has
  acknowledged that the Review owner field is required. If a Review owner is not added to the
  workload within 60 days of acknowledgement, access to the workload is restricted until an
  owner is added.
- `"JiraConfiguration"`: Configuration of the Jira integration.
- `"NonAwsRegions"`:
- `"Notes"`:
- `"PillarPriorities"`:
- `"ReviewOwner"`:
- `"WorkloadName"`:
"""
function update_workload(WorkloadId; aws_config::AbstractAWSConfig=current_aws_config())
    return wellarchitected(
        "PATCH",
        "/workloads/$(WorkloadId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_workload(
    WorkloadId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "PATCH",
        "/workloads/$(WorkloadId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_workload_share(permission_type, share_id, workload_id)
    update_workload_share(permission_type, share_id, workload_id, params::Dict{String,<:Any})

Update a workload share.

# Arguments
- `permission_type`:
- `share_id`:
- `workload_id`:

"""
function update_workload_share(
    PermissionType, ShareId, WorkloadId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wellarchitected(
        "PATCH",
        "/workloads/$(WorkloadId)/shares/$(ShareId)",
        Dict{String,Any}("PermissionType" => PermissionType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_workload_share(
    PermissionType,
    ShareId,
    WorkloadId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "PATCH",
        "/workloads/$(WorkloadId)/shares/$(ShareId)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("PermissionType" => PermissionType), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    upgrade_lens_review(lens_alias, milestone_name, workload_id)
    upgrade_lens_review(lens_alias, milestone_name, workload_id, params::Dict{String,<:Any})

Upgrade lens review for a particular workload.

# Arguments
- `lens_alias`:
- `milestone_name`:
- `workload_id`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`:
"""
function upgrade_lens_review(
    LensAlias, MilestoneName, WorkloadId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wellarchitected(
        "PUT",
        "/workloads/$(WorkloadId)/lensReviews/$(LensAlias)/upgrade",
        Dict{String,Any}("MilestoneName" => MilestoneName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function upgrade_lens_review(
    LensAlias,
    MilestoneName,
    WorkloadId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "PUT",
        "/workloads/$(WorkloadId)/lensReviews/$(LensAlias)/upgrade",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("MilestoneName" => MilestoneName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    upgrade_profile_version(profile_arn, workload_id)
    upgrade_profile_version(profile_arn, workload_id, params::Dict{String,<:Any})

Upgrade a profile.

# Arguments
- `profile_arn`: The profile ARN.
- `workload_id`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`:
- `"MilestoneName"`:
"""
function upgrade_profile_version(
    ProfileArn, WorkloadId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wellarchitected(
        "PUT",
        "/workloads/$(WorkloadId)/profiles/$(ProfileArn)/upgrade",
        Dict{String,Any}("ClientRequestToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function upgrade_profile_version(
    ProfileArn,
    WorkloadId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "PUT",
        "/workloads/$(WorkloadId)/profiles/$(ProfileArn)/upgrade",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ClientRequestToken" => string(uuid4())), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    upgrade_review_template_lens_review(lens_alias, template_arn)
    upgrade_review_template_lens_review(lens_alias, template_arn, params::Dict{String,<:Any})

Upgrade the lens review of a review template.

# Arguments
- `lens_alias`:
- `template_arn`: The ARN of the review template.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`:
"""
function upgrade_review_template_lens_review(
    LensAlias, TemplateArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return wellarchitected(
        "PUT",
        "/reviewTemplates/$(TemplateArn)/lensReviews/$(LensAlias)/upgrade";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function upgrade_review_template_lens_review(
    LensAlias,
    TemplateArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return wellarchitected(
        "PUT",
        "/reviewTemplates/$(TemplateArn)/lensReviews/$(LensAlias)/upgrade",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: acm
using AWS.Compat
using AWS.UUIDs

"""
    add_tags_to_certificate(certificate_arn, tags)
    add_tags_to_certificate(certificate_arn, tags, params::Dict{String,<:Any})

Adds one or more tags to an ACM certificate. Tags are labels that you can use to identify
and organize your Amazon Web Services resources. Each tag consists of a key and an optional
value. You specify the certificate on input by its Amazon Resource Name (ARN). You specify
the tag by using a key-value pair.  You can apply a tag to just one certificate if you want
to identify a specific characteristic of that certificate, or you can apply the same tag to
multiple certificates if you want to filter for a common relationship among those
certificates. Similarly, you can apply the same tag to multiple resources if you want to
specify a relationship among those resources. For example, you can add the same tag to an
ACM certificate and an Elastic Load Balancing load balancer to indicate that they are both
used by the same website. For more information, see Tagging ACM certificates.  To remove
one or more tags, use the RemoveTagsFromCertificate action. To view all of the tags that
have been applied to the certificate, use the ListTagsForCertificate action.

# Arguments
- `certificate_arn`: String that contains the ARN of the ACM certificate to which the tag
  is to be applied. This must be of the form:
  arn:aws:acm:region:123456789012:certificate/12345678-1234-1234-1234-123456789012  For more
  information about ARNs, see Amazon Resource Names (ARNs).
- `tags`: The key-value pair that defines the tag. The tag value is optional.

"""
function add_tags_to_certificate(
    CertificateArn, Tags; aws_config::AbstractAWSConfig=current_aws_config()
)
    return acm(
        "AddTagsToCertificate",
        Dict{String,Any}("CertificateArn" => CertificateArn, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_tags_to_certificate(
    CertificateArn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return acm(
        "AddTagsToCertificate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("CertificateArn" => CertificateArn, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_certificate(certificate_arn)
    delete_certificate(certificate_arn, params::Dict{String,<:Any})

Deletes a certificate and its associated private key. If this action succeeds, the
certificate no longer appears in the list that can be displayed by calling the
ListCertificates action or be retrieved by calling the GetCertificate action. The
certificate will not be available for use by Amazon Web Services services integrated with
ACM.   You cannot delete an ACM certificate that is being used by another Amazon Web
Services service. To delete a certificate that is in use, the certificate association must
first be removed.

# Arguments
- `certificate_arn`: String that contains the ARN of the ACM certificate to be deleted.
  This must be of the form:
  arn:aws:acm:region:123456789012:certificate/12345678-1234-1234-1234-123456789012  For more
  information about ARNs, see Amazon Resource Names (ARNs).

"""
function delete_certificate(
    CertificateArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return acm(
        "DeleteCertificate",
        Dict{String,Any}("CertificateArn" => CertificateArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_certificate(
    CertificateArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return acm(
        "DeleteCertificate",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("CertificateArn" => CertificateArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_certificate(certificate_arn)
    describe_certificate(certificate_arn, params::Dict{String,<:Any})

Returns detailed metadata about the specified ACM certificate. If you have just created a
certificate using the RequestCertificate action, there is a delay of several seconds before
you can retrieve information about it.

# Arguments
- `certificate_arn`: The Amazon Resource Name (ARN) of the ACM certificate. The ARN must
  have the following form:
  arn:aws:acm:region:123456789012:certificate/12345678-1234-1234-1234-123456789012  For more
  information about ARNs, see Amazon Resource Names (ARNs).

"""
function describe_certificate(
    CertificateArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return acm(
        "DescribeCertificate",
        Dict{String,Any}("CertificateArn" => CertificateArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_certificate(
    CertificateArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return acm(
        "DescribeCertificate",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("CertificateArn" => CertificateArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    export_certificate(certificate_arn, passphrase)
    export_certificate(certificate_arn, passphrase, params::Dict{String,<:Any})

Exports a private certificate issued by a private certificate authority (CA) for use
anywhere. The exported file contains the certificate, the certificate chain, and the
encrypted private 2048-bit RSA key associated with the public key that is embedded in the
certificate. For security, you must assign a passphrase for the private key when exporting
it.  For information about exporting and formatting a certificate using the ACM console or
CLI, see Export a Private Certificate.

# Arguments
- `certificate_arn`: An Amazon Resource Name (ARN) of the issued certificate. This must be
  of the form:  arn:aws:acm:region:account:certificate/12345678-1234-1234-1234-123456789012
- `passphrase`: Passphrase to associate with the encrypted exported private key.   When
  creating your passphrase, you can use any ASCII character except #, , or %.  If you want to
  later decrypt the private key, you must have the passphrase. You can use the following
  OpenSSL command to decrypt a private key. After entering the command, you are prompted for
  the passphrase.  openssl rsa -in encrypted_key.pem -out decrypted_key.pem

"""
function export_certificate(
    CertificateArn, Passphrase; aws_config::AbstractAWSConfig=current_aws_config()
)
    return acm(
        "ExportCertificate",
        Dict{String,Any}("CertificateArn" => CertificateArn, "Passphrase" => Passphrase);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function export_certificate(
    CertificateArn,
    Passphrase,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return acm(
        "ExportCertificate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CertificateArn" => CertificateArn, "Passphrase" => Passphrase
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_account_configuration()
    get_account_configuration(params::Dict{String,<:Any})

Returns the account configuration options associated with an Amazon Web Services account.

"""
function get_account_configuration(; aws_config::AbstractAWSConfig=current_aws_config())
    return acm(
        "GetAccountConfiguration"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_account_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return acm(
        "GetAccountConfiguration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_certificate(certificate_arn)
    get_certificate(certificate_arn, params::Dict{String,<:Any})

Retrieves an Amazon-issued certificate and its certificate chain. The chain consists of the
certificate of the issuing CA and the intermediate certificates of any other subordinate
CAs. All of the certificates are base64 encoded. You can use OpenSSL to decode the
certificates and inspect individual fields.

# Arguments
- `certificate_arn`: String that contains a certificate ARN in the following format:
  arn:aws:acm:region:123456789012:certificate/12345678-1234-1234-1234-123456789012  For more
  information about ARNs, see Amazon Resource Names (ARNs).

"""
function get_certificate(CertificateArn; aws_config::AbstractAWSConfig=current_aws_config())
    return acm(
        "GetCertificate",
        Dict{String,Any}("CertificateArn" => CertificateArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_certificate(
    CertificateArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return acm(
        "GetCertificate",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("CertificateArn" => CertificateArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    import_certificate(certificate, private_key)
    import_certificate(certificate, private_key, params::Dict{String,<:Any})

Imports a certificate into Certificate Manager (ACM) to use with services that are
integrated with ACM. Note that integrated services allow only certificate types and keys
they support to be associated with their resources. Further, their support differs
depending on whether the certificate is imported into IAM or into ACM. For more
information, see the documentation for each service. For more information about importing
certificates into ACM, see Importing Certificates in the Certificate Manager User Guide.
ACM does not provide managed renewal for certificates that you import.  Note the following
guidelines when importing third party certificates:   You must enter the private key that
matches the certificate you are importing.   The private key must be unencrypted. You
cannot import a private key that is protected by a password or a passphrase.   The private
key must be no larger than 5 KB (5,120 bytes).   If the certificate you are importing is
not self-signed, you must enter its certificate chain.   If a certificate chain is
included, the issuer must be the subject of one of the certificates in the chain.   The
certificate, private key, and certificate chain must be PEM-encoded.   The current time
must be between the Not Before and Not After certificate fields.   The Issuer field must
not be empty.   The OCSP authority URL, if present, must not exceed 1000 characters.   To
import a new certificate, omit the CertificateArn argument. Include this argument only when
you want to replace a previously imported certificate.   When you import a certificate by
using the CLI, you must specify the certificate, the certificate chain, and the private key
by their file names preceded by fileb://. For example, you can specify a certificate saved
in the C:temp folder as fileb://C:tempcertificate_to_import.pem. If you are making an HTTP
or HTTPS Query request, include these arguments as BLOBs.    When you import a certificate
by using an SDK, you must specify the certificate, the certificate chain, and the private
key files in the manner required by the programming language you're using.    The
cryptographic algorithm of an imported certificate must match the algorithm of the signing
CA. For example, if the signing CA key type is RSA, then the certificate key type must also
be RSA.   This operation returns the Amazon Resource Name (ARN) of the imported certificate.

# Arguments
- `certificate`: The certificate to import.
- `private_key`: The private key that matches the public key in the certificate.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CertificateArn"`: The Amazon Resource Name (ARN) of an imported certificate to replace.
  To import a new certificate, omit this field.
- `"CertificateChain"`: The PEM encoded certificate chain.
- `"Tags"`: One or more resource tags to associate with the imported certificate.  Note:
  You cannot apply tags when reimporting a certificate.
"""
function import_certificate(
    Certificate, PrivateKey; aws_config::AbstractAWSConfig=current_aws_config()
)
    return acm(
        "ImportCertificate",
        Dict{String,Any}("Certificate" => Certificate, "PrivateKey" => PrivateKey);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function import_certificate(
    Certificate,
    PrivateKey,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return acm(
        "ImportCertificate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Certificate" => Certificate, "PrivateKey" => PrivateKey),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_certificates()
    list_certificates(params::Dict{String,<:Any})

Retrieves a list of certificate ARNs and domain names. You can request that only
certificates that match a specific status be listed. You can also filter by specific
attributes of the certificate. Default filtering returns only RSA_2048 certificates. For
more information, see Filters.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CertificateStatuses"`: Filter the certificate list by status value.
- `"Includes"`: Filter the certificate list. For more information, see the Filters
  structure.
- `"MaxItems"`: Use this parameter when paginating results to specify the maximum number of
  items to return in the response. If additional items exist beyond the number you specify,
  the NextToken element is sent in the response. Use this NextToken value in a subsequent
  request to retrieve additional items.
- `"NextToken"`: Use this parameter only when paginating results and only in a subsequent
  request after you receive a response with truncated results. Set it to the value of
  NextToken from the response you just received.
- `"SortBy"`: Specifies the field to sort results by. If you specify SortBy, you must also
  specify SortOrder.
- `"SortOrder"`: Specifies the order of sorted results. If you specify SortOrder, you must
  also specify SortBy.
"""
function list_certificates(; aws_config::AbstractAWSConfig=current_aws_config())
    return acm("ListCertificates"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_certificates(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return acm(
        "ListCertificates", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_certificate(certificate_arn)
    list_tags_for_certificate(certificate_arn, params::Dict{String,<:Any})

Lists the tags that have been applied to the ACM certificate. Use the certificate's Amazon
Resource Name (ARN) to specify the certificate. To add a tag to an ACM certificate, use the
AddTagsToCertificate action. To delete a tag, use the RemoveTagsFromCertificate action.

# Arguments
- `certificate_arn`: String that contains the ARN of the ACM certificate for which you want
  to list the tags. This must have the following form:
  arn:aws:acm:region:123456789012:certificate/12345678-1234-1234-1234-123456789012  For more
  information about ARNs, see Amazon Resource Names (ARNs).

"""
function list_tags_for_certificate(
    CertificateArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return acm(
        "ListTagsForCertificate",
        Dict{String,Any}("CertificateArn" => CertificateArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_certificate(
    CertificateArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return acm(
        "ListTagsForCertificate",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("CertificateArn" => CertificateArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_account_configuration(idempotency_token)
    put_account_configuration(idempotency_token, params::Dict{String,<:Any})

Adds or modifies account-level configurations in ACM.  The supported configuration option
is DaysBeforeExpiry. This option specifies the number of days prior to certificate
expiration when ACM starts generating EventBridge events. ACM sends one event per day per
certificate until the certificate expires. By default, accounts receive events starting 45
days before certificate expiration.

# Arguments
- `idempotency_token`: Customer-chosen string used to distinguish between calls to
  PutAccountConfiguration. Idempotency tokens time out after one hour. If you call
  PutAccountConfiguration multiple times with the same unexpired idempotency token, ACM
  treats it as the same request and returns the original result. If you change the
  idempotency token for each call, ACM treats each call as a new request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ExpiryEvents"`: Specifies expiration events associated with an account.
"""
function put_account_configuration(
    IdempotencyToken; aws_config::AbstractAWSConfig=current_aws_config()
)
    return acm(
        "PutAccountConfiguration",
        Dict{String,Any}("IdempotencyToken" => IdempotencyToken);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_account_configuration(
    IdempotencyToken,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return acm(
        "PutAccountConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("IdempotencyToken" => IdempotencyToken), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_tags_from_certificate(certificate_arn, tags)
    remove_tags_from_certificate(certificate_arn, tags, params::Dict{String,<:Any})

Remove one or more tags from an ACM certificate. A tag consists of a key-value pair. If you
do not specify the value portion of the tag when calling this function, the tag will be
removed regardless of value. If you specify a value, the tag is removed only if it is
associated with the specified value.  To add tags to a certificate, use the
AddTagsToCertificate action. To view all of the tags that have been applied to a specific
ACM certificate, use the ListTagsForCertificate action.

# Arguments
- `certificate_arn`: String that contains the ARN of the ACM Certificate with one or more
  tags that you want to remove. This must be of the form:
  arn:aws:acm:region:123456789012:certificate/12345678-1234-1234-1234-123456789012  For more
  information about ARNs, see Amazon Resource Names (ARNs).
- `tags`: The key-value pair that defines the tag to remove.

"""
function remove_tags_from_certificate(
    CertificateArn, Tags; aws_config::AbstractAWSConfig=current_aws_config()
)
    return acm(
        "RemoveTagsFromCertificate",
        Dict{String,Any}("CertificateArn" => CertificateArn, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_tags_from_certificate(
    CertificateArn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return acm(
        "RemoveTagsFromCertificate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("CertificateArn" => CertificateArn, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    renew_certificate(certificate_arn)
    renew_certificate(certificate_arn, params::Dict{String,<:Any})

Renews an eligible ACM certificate. At this time, only exported private certificates can be
renewed with this operation. In order to renew your Amazon Web Services Private CA
certificates with ACM, you must first grant the ACM service principal permission to do so.
For more information, see Testing Managed Renewal in the ACM User Guide.

# Arguments
- `certificate_arn`: String that contains the ARN of the ACM certificate to be renewed.
  This must be of the form:
  arn:aws:acm:region:123456789012:certificate/12345678-1234-1234-1234-123456789012  For more
  information about ARNs, see Amazon Resource Names (ARNs).

"""
function renew_certificate(
    CertificateArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return acm(
        "RenewCertificate",
        Dict{String,Any}("CertificateArn" => CertificateArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function renew_certificate(
    CertificateArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return acm(
        "RenewCertificate",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("CertificateArn" => CertificateArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    request_certificate(domain_name)
    request_certificate(domain_name, params::Dict{String,<:Any})

Requests an ACM certificate for use with other Amazon Web Services services. To request an
ACM certificate, you must specify a fully qualified domain name (FQDN) in the DomainName
parameter. You can also specify additional FQDNs in the SubjectAlternativeNames parameter.
If you are requesting a private certificate, domain validation is not required. If you are
requesting a public certificate, each domain name that you specify must be validated to
verify that you own or control the domain. You can use DNS validation or email validation.
We recommend that you use DNS validation. ACM issues public certificates after receiving
approval from the domain owner.   ACM behavior differs from the RFC 6125 specification of
the certificate validation process. ACM first checks for a Subject Alternative Name, and,
if it finds one, ignores the common name (CN).  After successful completion of the
RequestCertificate action, there is a delay of several seconds before you can retrieve
information about the new certificate.

# Arguments
- `domain_name`: Fully qualified domain name (FQDN), such as www.example.com, that you want
  to secure with an ACM certificate. Use an asterisk (*) to create a wildcard certificate
  that protects several sites in the same domain. For example, *.example.com protects
  www.example.com, site.example.com, and images.example.com.  In compliance with RFC 5280,
  the length of the domain name (technically, the Common Name) that you provide cannot exceed
  64 octets (characters), including periods. To add a longer domain name, specify it in the
  Subject Alternative Name field, which supports names up to 253 octets in length.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CertificateAuthorityArn"`: The Amazon Resource Name (ARN) of the private certificate
  authority (CA) that will be used to issue the certificate. If you do not provide an ARN and
  you are trying to request a private certificate, ACM will attempt to issue a public
  certificate. For more information about private CAs, see the Amazon Web Services Private
  Certificate Authority user guide. The ARN must have the following form:
  arn:aws:acm-pca:region:account:certificate-authority/12345678-1234-1234-1234-123456789012
- `"DomainValidationOptions"`: The domain name that you want ACM to use to send you emails
  so that you can validate domain ownership.
- `"IdempotencyToken"`: Customer chosen string that can be used to distinguish between
  calls to RequestCertificate. Idempotency tokens time out after one hour. Therefore, if you
  call RequestCertificate multiple times with the same idempotency token within one hour, ACM
  recognizes that you are requesting only one certificate and will issue only one. If you
  change the idempotency token for each call, ACM recognizes that you are requesting multiple
  certificates.
- `"KeyAlgorithm"`: Specifies the algorithm of the public and private key pair that your
  certificate uses to encrypt data. RSA is the default key algorithm for ACM certificates.
  Elliptic Curve Digital Signature Algorithm (ECDSA) keys are smaller, offering security
  comparable to RSA keys but with greater computing efficiency. However, ECDSA is not
  supported by all network clients. Some AWS services may require RSA keys, or only support
  ECDSA keys of a particular size, while others allow the use of either RSA and ECDSA keys to
  ensure that compatibility is not broken. Check the requirements for the AWS service where
  you plan to deploy your certificate. Default: RSA_2048
- `"Options"`: Currently, you can use this parameter to specify whether to add the
  certificate to a certificate transparency log. Certificate transparency makes it possible
  to detect SSL/TLS certificates that have been mistakenly or maliciously issued.
  Certificates that have not been logged typically produce an error message in a browser. For
  more information, see Opting Out of Certificate Transparency Logging.
- `"SubjectAlternativeNames"`: Additional FQDNs to be included in the Subject Alternative
  Name extension of the ACM certificate. For example, add the name www.example.net to a
  certificate for which the DomainName field is www.example.com if users can reach your site
  by using either name. The maximum number of domain names that you can add to an ACM
  certificate is 100. However, the initial quota is 10 domain names. If you need more than 10
  names, you must request a quota increase. For more information, see Quotas.  The maximum
  length of a SAN DNS name is 253 octets. The name is made up of multiple labels separated by
  periods. No label can be longer than 63 octets. Consider the following examples:     (63
  octets).(63 octets).(63 octets).(61 octets) is legal because the total length is 253 octets
  (63+1+63+1+63+1+61) and no label exceeds 63 octets.    (64 octets).(63 octets).(63
  octets).(61 octets) is not legal because the total length exceeds 253 octets
  (64+1+63+1+63+1+61) and the first label exceeds 63 octets.    (63 octets).(63 octets).(63
  octets).(62 octets) is not legal because the total length of the DNS name
  (63+1+63+1+63+1+62) exceeds 253 octets.
- `"Tags"`: One or more resource tags to associate with the certificate.
- `"ValidationMethod"`: The method you want to use if you are requesting a public
  certificate to validate that you own or control domain. You can validate with DNS or
  validate with email. We recommend that you use DNS validation.
"""
function request_certificate(DomainName; aws_config::AbstractAWSConfig=current_aws_config())
    return acm(
        "RequestCertificate",
        Dict{String,Any}("DomainName" => DomainName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function request_certificate(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return acm(
        "RequestCertificate",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DomainName" => DomainName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    resend_validation_email(certificate_arn, domain, validation_domain)
    resend_validation_email(certificate_arn, domain, validation_domain, params::Dict{String,<:Any})

Resends the email that requests domain ownership validation. The domain owner or an
authorized representative must approve the ACM certificate before it can be issued. The
certificate can be approved by clicking a link in the mail to navigate to the Amazon
certificate approval website and then clicking I Approve. However, the validation email can
be blocked by spam filters. Therefore, if you do not receive the original mail, you can
request that the mail be resent within 72 hours of requesting the ACM certificate. If more
than 72 hours have elapsed since your original request or since your last attempt to resend
validation mail, you must request a new certificate. For more information about setting up
your contact email addresses, see Configure Email for your Domain.

# Arguments
- `certificate_arn`: String that contains the ARN of the requested certificate. The
  certificate ARN is generated and returned by the RequestCertificate action as soon as the
  request is made. By default, using this parameter causes email to be sent to all top-level
  domains you specified in the certificate request. The ARN must be of the form:
  arn:aws:acm:us-east-1:123456789012:certificate/12345678-1234-1234-1234-123456789012
- `domain`: The fully qualified domain name (FQDN) of the certificate that needs to be
  validated.
- `validation_domain`: The base validation domain that will act as the suffix of the email
  addresses that are used to send the emails. This must be the same as the Domain value or a
  superdomain of the Domain value. For example, if you requested a certificate for
  site.subdomain.example.com and specify a ValidationDomain of subdomain.example.com, ACM
  sends email to the domain registrant, technical contact, and administrative contact in
  WHOIS and the following five addresses:   admin@subdomain.example.com
  administrator@subdomain.example.com   hostmaster@subdomain.example.com
  postmaster@subdomain.example.com   webmaster@subdomain.example.com

"""
function resend_validation_email(
    CertificateArn,
    Domain,
    ValidationDomain;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return acm(
        "ResendValidationEmail",
        Dict{String,Any}(
            "CertificateArn" => CertificateArn,
            "Domain" => Domain,
            "ValidationDomain" => ValidationDomain,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function resend_validation_email(
    CertificateArn,
    Domain,
    ValidationDomain,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return acm(
        "ResendValidationEmail",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CertificateArn" => CertificateArn,
                    "Domain" => Domain,
                    "ValidationDomain" => ValidationDomain,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_certificate_options(certificate_arn, options)
    update_certificate_options(certificate_arn, options, params::Dict{String,<:Any})

Updates a certificate. Currently, you can use this function to specify whether to opt in to
or out of recording your certificate in a certificate transparency log. For more
information, see  Opting Out of Certificate Transparency Logging.

# Arguments
- `certificate_arn`: ARN of the requested certificate to update. This must be of the form:
  arn:aws:acm:us-east-1:account:certificate/12345678-1234-1234-1234-123456789012
- `options`: Use to update the options for your certificate. Currently, you can specify
  whether to add your certificate to a transparency log. Certificate transparency makes it
  possible to detect SSL/TLS certificates that have been mistakenly or maliciously issued.
  Certificates that have not been logged typically produce an error message in a browser.

"""
function update_certificate_options(
    CertificateArn, Options; aws_config::AbstractAWSConfig=current_aws_config()
)
    return acm(
        "UpdateCertificateOptions",
        Dict{String,Any}("CertificateArn" => CertificateArn, "Options" => Options);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_certificate_options(
    CertificateArn,
    Options,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return acm(
        "UpdateCertificateOptions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("CertificateArn" => CertificateArn, "Options" => Options),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: opsworks
using AWS.Compat
using AWS.UUIDs

"""
    assign_instance(instance_id, layer_ids)
    assign_instance(instance_id, layer_ids, params::Dict{String,<:Any})

Assign a registered instance to a layer.   You can assign registered on-premises instances
to any layer type.   You can assign registered Amazon EC2 instances only to custom layers.
 You cannot use this action with instances that were created with OpsWorks Stacks.
Required Permissions: To use this action, an Identity and Access Management (IAM) user must
have a Manage permissions level for the stack or an attached policy that explicitly grants
permissions. For more information on user permissions, see Managing User Permissions.

# Arguments
- `instance_id`: The instance ID.
- `layer_ids`: The layer ID, which must correspond to a custom layer. You cannot assign a
  registered instance to a built-in layer.

"""
function assign_instance(
    InstanceId, LayerIds; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opsworks(
        "AssignInstance",
        Dict{String,Any}("InstanceId" => InstanceId, "LayerIds" => LayerIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function assign_instance(
    InstanceId,
    LayerIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworks(
        "AssignInstance",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("InstanceId" => InstanceId, "LayerIds" => LayerIds),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    assign_volume(volume_id)
    assign_volume(volume_id, params::Dict{String,<:Any})

Assigns one of the stack's registered Amazon EBS volumes to a specified instance. The
volume must first be registered with the stack by calling RegisterVolume. After you
register the volume, you must call UpdateVolume to specify a mount point before calling
AssignVolume. For more information, see Resource Management.  Required Permissions: To use
this action, an IAM user must have a Manage permissions level for the stack, or an attached
policy that explicitly grants permissions. For more information on user permissions, see
Managing User Permissions.

# Arguments
- `volume_id`: The volume ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"InstanceId"`: The instance ID.
"""
function assign_volume(VolumeId; aws_config::AbstractAWSConfig=current_aws_config())
    return opsworks(
        "AssignVolume",
        Dict{String,Any}("VolumeId" => VolumeId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function assign_volume(
    VolumeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworks(
        "AssignVolume",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("VolumeId" => VolumeId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_elastic_ip(elastic_ip)
    associate_elastic_ip(elastic_ip, params::Dict{String,<:Any})

Associates one of the stack's registered Elastic IP addresses with a specified instance.
The address must first be registered with the stack by calling RegisterElasticIp. For more
information, see Resource Management.  Required Permissions: To use this action, an IAM
user must have a Manage permissions level for the stack, or an attached policy that
explicitly grants permissions. For more information on user permissions, see Managing User
Permissions.

# Arguments
- `elastic_ip`: The Elastic IP address.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"InstanceId"`: The instance ID.
"""
function associate_elastic_ip(ElasticIp; aws_config::AbstractAWSConfig=current_aws_config())
    return opsworks(
        "AssociateElasticIp",
        Dict{String,Any}("ElasticIp" => ElasticIp);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_elastic_ip(
    ElasticIp,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworks(
        "AssociateElasticIp",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ElasticIp" => ElasticIp), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    attach_elastic_load_balancer(elastic_load_balancer_name, layer_id)
    attach_elastic_load_balancer(elastic_load_balancer_name, layer_id, params::Dict{String,<:Any})

Attaches an Elastic Load Balancing load balancer to a specified layer. OpsWorks Stacks does
not support Application Load Balancer. You can only use Classic Load Balancer with OpsWorks
Stacks. For more information, see Elastic Load Balancing.  You must create the Elastic Load
Balancing instance separately, by using the Elastic Load Balancing console, API, or CLI.
For more information, see the Elastic Load Balancing Developer Guide.   Required
Permissions: To use this action, an IAM user must have a Manage permissions level for the
stack, or an attached policy that explicitly grants permissions. For more information on
user permissions, see Managing User Permissions.

# Arguments
- `elastic_load_balancer_name`: The Elastic Load Balancing instance's name.
- `layer_id`: The ID of the layer to which the Elastic Load Balancing instance is to be
  attached.

"""
function attach_elastic_load_balancer(
    ElasticLoadBalancerName, LayerId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opsworks(
        "AttachElasticLoadBalancer",
        Dict{String,Any}(
            "ElasticLoadBalancerName" => ElasticLoadBalancerName, "LayerId" => LayerId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function attach_elastic_load_balancer(
    ElasticLoadBalancerName,
    LayerId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworks(
        "AttachElasticLoadBalancer",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ElasticLoadBalancerName" => ElasticLoadBalancerName,
                    "LayerId" => LayerId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    clone_stack(service_role_arn, source_stack_id)
    clone_stack(service_role_arn, source_stack_id, params::Dict{String,<:Any})

Creates a clone of a specified stack. For more information, see Clone a Stack. By default,
all parameters are set to the values used by the parent stack.  Required Permissions: To
use this action, an IAM user must have an attached policy that explicitly grants
permissions. For more information about user permissions, see Managing User Permissions.

# Arguments
- `service_role_arn`: The stack Identity and Access Management (IAM) role, which allows
  OpsWorks Stacks to work with Amazon Web Services resources on your behalf. You must set
  this parameter to the Amazon Resource Name (ARN) for an existing IAM role. If you create a
  stack by using the OpsWorkss Stacks console, it creates the role for you. You can obtain an
  existing stack's IAM ARN programmatically by calling DescribePermissions. For more
  information about IAM ARNs, see Using Identifiers.  You must set this parameter to a valid
  service role ARN or the action will fail; there is no default value. You can specify the
  source stack's service role ARN, if you prefer, but you must do so explicitly.
- `source_stack_id`: The source stack ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AgentVersion"`: The default OpsWorks Stacks agent version. You have the following
  options:   Auto-update - Set this parameter to LATEST. OpsWorks Stacks automatically
  installs new agent versions on the stack's instances as soon as they are available.   Fixed
  version - Set this parameter to your preferred agent version. To update the agent version,
  you must edit the stack configuration and specify a new version. OpsWorks Stacks
  automatically installs that version on the stack's instances.   The default setting is
  LATEST. To specify an agent version, you must use the complete version number, not the
  abbreviated number shown on the console. For a list of available agent version numbers,
  call DescribeAgentVersions. AgentVersion cannot be set to Chef 12.2.  You can also specify
  an agent version when you create or update an instance, which overrides the stack's default
  setting.
- `"Attributes"`: A list of stack attributes and values as key/value pairs to be added to
  the cloned stack.
- `"ChefConfiguration"`: A ChefConfiguration object that specifies whether to enable
  Berkshelf and the Berkshelf version on Chef 11.10 stacks. For more information, see Create
  a New Stack.
- `"CloneAppIds"`: A list of source stack app IDs to be included in the cloned stack.
- `"ClonePermissions"`: Whether to clone the source stack's permissions.
- `"ConfigurationManager"`: The configuration manager. When you clone a stack we recommend
  that you use the configuration manager to specify the Chef version: 12, 11.10, or 11.4 for
  Linux stacks, or 12.2 for Windows stacks. The default value for Linux stacks is currently
  12.
- `"CustomCookbooksSource"`: Contains the information required to retrieve an app or
  cookbook from a repository. For more information, see Adding Apps or Cookbooks and Recipes.
- `"CustomJson"`: A string that contains user-defined, custom JSON. It is used to override
  the corresponding default stack configuration JSON values. The string should be in the
  following format:  \"{\"key1\": \"value1\", \"key2\": \"value2\",...}\"  For more
  information about custom JSON, see Use Custom JSON to Modify the Stack Configuration
  Attributes
- `"DefaultAvailabilityZone"`: The cloned stack's default Availability Zone, which must be
  in the specified region. For more information, see Regions and Endpoints. If you also
  specify a value for DefaultSubnetId, the subnet must be in the same zone. For more
  information, see the VpcId parameter description.
- `"DefaultInstanceProfileArn"`: The Amazon Resource Name (ARN) of an IAM profile that is
  the default profile for all of the stack's EC2 instances. For more information about IAM
  ARNs, see Using Identifiers.
- `"DefaultOs"`: The stack's operating system, which must be set to one of the following.
  A supported Linux operating system: An Amazon Linux version, such as Amazon Linux 2, Amazon
  Linux 2018.03, Amazon Linux 2017.09, Amazon Linux 2017.03, Amazon Linux 2016.09, Amazon
  Linux 2016.03, Amazon Linux 2015.09, or Amazon Linux 2015.03.   A supported Ubuntu
  operating system, such as Ubuntu 18.04 LTS, Ubuntu 16.04 LTS, Ubuntu 14.04 LTS, or Ubuntu
  12.04 LTS.    CentOS Linux 7     Red Hat Enterprise Linux 7     Microsoft Windows Server
  2012 R2 Base, Microsoft Windows Server 2012 R2 with SQL Server Express, Microsoft Windows
  Server 2012 R2 with SQL Server Standard, or Microsoft Windows Server 2012 R2 with SQL
  Server Web.   A custom AMI: Custom. You specify the custom AMI you want to use when you
  create instances. For more information about how to use custom AMIs with OpsWorks, see
  Using Custom AMIs.   The default option is the parent stack's operating system. Not all
  operating systems are supported with all versions of Chef. For more information about
  supported operating systems, see OpsWorks Stacks Operating Systems.  You can specify a
  different Linux operating system for the cloned stack, but you cannot change from Linux to
  Windows or Windows to Linux.
- `"DefaultRootDeviceType"`: The default root device type. This value is used by default
  for all instances in the cloned stack, but you can override it when you create an instance.
  For more information, see Storage for the Root Device.
- `"DefaultSshKeyName"`: A default Amazon EC2 key pair name. The default value is none. If
  you specify a key pair name, OpsWorks installs the public key on the instance and you can
  use the private key with an SSH client to log in to the instance. For more information, see
   Using SSH to Communicate with an Instance and  Managing SSH Access. You can override this
  setting by specifying a different key pair, or no key pair, when you  create an instance.
- `"DefaultSubnetId"`: The stack's default VPC subnet ID. This parameter is required if you
  specify a value for the VpcId parameter. All instances are launched into this subnet unless
  you specify otherwise when you create the instance. If you also specify a value for
  DefaultAvailabilityZone, the subnet must be in that zone. For information on default values
  and when this parameter is required, see the VpcId parameter description.
- `"HostnameTheme"`: The stack's host name theme, with spaces are replaced by underscores.
  The theme is used to generate host names for the stack's instances. By default,
  HostnameTheme is set to Layer_Dependent, which creates host names by appending integers to
  the layer's short name. The other themes are:    Baked_Goods     Clouds     Europe_Cities
    Fruits     Greek_Deities_and_Titans     Legendary_creatures_from_Japan
  Planets_and_Moons     Roman_Deities     Scottish_Islands     US_Cities     Wild_Cats    To
  obtain a generated host name, call GetHostNameSuggestion, which returns a host name based
  on the current theme.
- `"Name"`: The cloned stack name. Stack names can be a maximum of 64 characters.
- `"Region"`: The cloned stack Amazon Web Services Region, such as ap-northeast-2. For more
  information about Amazon Web Services Regions, see Regions and Endpoints.
- `"UseCustomCookbooks"`: Whether to use custom cookbooks.
- `"UseOpsworksSecurityGroups"`: Whether to associate the OpsWorks Stacks built-in security
  groups with the stack's layers. OpsWorks Stacks provides a standard set of security groups,
  one for each layer, which are associated with layers by default. With
  UseOpsworksSecurityGroups you can instead provide your own custom security groups.
  UseOpsworksSecurityGroups has the following settings:    True - OpsWorks Stacks
  automatically associates the appropriate built-in security group with each layer (default
  setting). You can associate additional security groups with a layer after you create it but
  you cannot delete the built-in security group.   False - OpsWorks Stacks does not associate
  built-in security groups with layers. You must create appropriate Amazon EC2 security
  groups and associate a security group with each layer that you create. However, you can
  still manually associate a built-in security group with a layer on creation; custom
  security groups are required only for those layers that need custom settings.   For more
  information, see Create a New Stack.
- `"VpcId"`: The ID of the VPC that the cloned stack is to be launched into. It must be in
  the specified region. All instances are launched into this VPC, and you cannot change the
  ID later.   If your account supports EC2 Classic, the default value is no VPC.   If your
  account does not support EC2 Classic, the default value is the default VPC for the
  specified region.   If the VPC ID corresponds to a default VPC and you have specified
  either the DefaultAvailabilityZone or the DefaultSubnetId parameter only, OpsWorks Stacks
  infers the value of the other parameter. If you specify neither parameter, OpsWorks Stacks
  sets these parameters to the first valid Availability Zone for the specified region and the
  corresponding default VPC subnet ID, respectively.  If you specify a nondefault VPC ID,
  note the following:   It must belong to a VPC in your account that is in the specified
  region.   You must specify a value for DefaultSubnetId.   For more information about how to
  use OpsWorks Stacks with a VPC, see Running a Stack in a VPC. For more information about
  default VPC and EC2 Classic, see Supported Platforms.
"""
function clone_stack(
    ServiceRoleArn, SourceStackId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opsworks(
        "CloneStack",
        Dict{String,Any}(
            "ServiceRoleArn" => ServiceRoleArn, "SourceStackId" => SourceStackId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function clone_stack(
    ServiceRoleArn,
    SourceStackId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworks(
        "CloneStack",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ServiceRoleArn" => ServiceRoleArn, "SourceStackId" => SourceStackId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_app(name, stack_id, type)
    create_app(name, stack_id, type, params::Dict{String,<:Any})

Creates an app for a specified stack. For more information, see Creating Apps.  Required
Permissions: To use this action, an IAM user must have a Manage permissions level for the
stack, or an attached policy that explicitly grants permissions. For more information on
user permissions, see Managing User Permissions.

# Arguments
- `name`: The app name.
- `stack_id`: The stack ID.
- `type`: The app type. Each supported type is associated with a particular layer. For
  example, PHP applications are associated with a PHP layer. OpsWorks Stacks deploys an
  application to those instances that are members of the corresponding layer. If your app
  isn't one of the standard types, or you prefer to implement your own Deploy recipes,
  specify other.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AppSource"`: A Source object that specifies the app repository.
- `"Attributes"`: One or more user-defined key/value pairs to be added to the stack
  attributes.
- `"DataSources"`: The app's data source.
- `"Description"`: A description of the app.
- `"Domains"`: The app virtual host settings, with multiple domains separated by commas.
  For example: 'www.example.com, example.com'
- `"EnableSsl"`: Whether to enable SSL for the app.
- `"Environment"`: An array of EnvironmentVariable objects that specify environment
  variables to be associated with the app. After you deploy the app, these variables are
  defined on the associated app server instance. For more information, see  Environment
  Variables. There is no specific limit on the number of environment variables. However, the
  size of the associated data structure - which includes the variables' names, values, and
  protected flag values - cannot exceed 20 KB. This limit should accommodate most if not all
  use cases. Exceeding it will cause an exception with the message, \"Environment: is too
  large (maximum is 20KB).\"  If you have specified one or more environment variables, you
  cannot modify the stack's Chef version.
- `"Shortname"`: The app's short name.
- `"SslConfiguration"`: An SslConfiguration object with the SSL configuration.
"""
function create_app(Name, StackId, Type; aws_config::AbstractAWSConfig=current_aws_config())
    return opsworks(
        "CreateApp",
        Dict{String,Any}("Name" => Name, "StackId" => StackId, "Type" => Type);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_app(
    Name,
    StackId,
    Type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworks(
        "CreateApp",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Name" => Name, "StackId" => StackId, "Type" => Type),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_deployment(command, stack_id)
    create_deployment(command, stack_id, params::Dict{String,<:Any})

Runs deployment or stack commands. For more information, see Deploying Apps and Run Stack
Commands.  Required Permissions: To use this action, an IAM user must have a Deploy or
Manage permissions level for the stack, or an attached policy that explicitly grants
permissions. For more information on user permissions, see Managing User Permissions.

# Arguments
- `command`: A DeploymentCommand object that specifies the deployment command and any
  associated arguments.
- `stack_id`: The stack ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AppId"`: The app ID. This parameter is required for app deployments, but not for other
  deployment commands.
- `"Comment"`: A user-defined comment.
- `"CustomJson"`: A string that contains user-defined, custom JSON. You can use this
  parameter to override some corresponding default stack configuration JSON values. The
  string should be in the following format:  \"{\"key1\": \"value1\", \"key2\":
  \"value2\",...}\"  For more information about custom JSON, see Use Custom JSON to Modify
  the Stack Configuration Attributes and Overriding Attributes With Custom JSON.
- `"InstanceIds"`: The instance IDs for the deployment targets.
- `"LayerIds"`: The layer IDs for the deployment targets.
"""
function create_deployment(
    Command, StackId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opsworks(
        "CreateDeployment",
        Dict{String,Any}("Command" => Command, "StackId" => StackId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_deployment(
    Command,
    StackId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworks(
        "CreateDeployment",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("Command" => Command, "StackId" => StackId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_instance(instance_type, layer_ids, stack_id)
    create_instance(instance_type, layer_ids, stack_id, params::Dict{String,<:Any})

Creates an instance in a specified stack. For more information, see Adding an Instance to a
Layer.  Required Permissions: To use this action, an IAM user must have a Manage
permissions level for the stack, or an attached policy that explicitly grants permissions.
For more information on user permissions, see Managing User Permissions.

# Arguments
- `instance_type`: The instance type, such as t2.micro. For a list of supported instance
  types, open the stack in the console, choose Instances, and choose + Instance. The Size
  list contains the currently supported types. For more information, see Instance Families
  and Types. The parameter values that you use to specify the various types are in the API
  Name column of the Available Instance Types table.
- `layer_ids`: An array that contains the instance's layer IDs.
- `stack_id`: The stack ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AgentVersion"`: The default OpsWorks Stacks agent version. You have the following
  options:    INHERIT - Use the stack's default agent version setting.    version_number -
  Use the specified agent version. This value overrides the stack's default setting. To
  update the agent version, edit the instance configuration and specify a new version.
  OpsWorks Stacks installs that version on the instance.   The default setting is INHERIT. To
  specify an agent version, you must use the complete version number, not the abbreviated
  number shown on the console. For a list of available agent version numbers, call
  DescribeAgentVersions. AgentVersion cannot be set to Chef 12.2.
- `"AmiId"`: A custom AMI ID to be used to create the instance. The AMI should be based on
  one of the supported operating systems. For more information, see Using Custom AMIs.  If
  you specify a custom AMI, you must set Os to Custom.
- `"Architecture"`: The instance architecture. The default option is x86_64. Instance types
  do not necessarily support both architectures. For a list of the architectures that are
  supported by the different instance types, see Instance Families and Types.
- `"AutoScalingType"`: For load-based or time-based instances, the type. Windows stacks can
  use only time-based instances.
- `"AvailabilityZone"`: The instance Availability Zone. For more information, see Regions
  and Endpoints.
- `"BlockDeviceMappings"`: An array of BlockDeviceMapping objects that specify the
  instance's block devices. For more information, see Block Device Mapping. Note that block
  device mappings are not supported for custom AMIs.
- `"EbsOptimized"`: Whether to create an Amazon EBS-optimized instance.
- `"Hostname"`: The instance host name. The following are character limits for instance
  host names.   Linux-based instances: 63 characters   Windows-based instances: 15 characters
  
- `"InstallUpdatesOnBoot"`: Whether to install operating system and package updates when
  the instance boots. The default value is true. To control when updates are installed, set
  this value to false. You must then update your instances manually by using CreateDeployment
  to run the update_dependencies stack command or by manually running yum (Amazon Linux) or
  apt-get (Ubuntu) on the instances.   We strongly recommend using the default value of true
  to ensure that your instances have the latest security updates.
- `"Os"`: The instance's operating system, which must be set to one of the following.   A
  supported Linux operating system: An Amazon Linux version, such as Amazon Linux 2, Amazon
  Linux 2018.03, Amazon Linux 2017.09, Amazon Linux 2017.03, Amazon Linux 2016.09, Amazon
  Linux 2016.03, Amazon Linux 2015.09, or Amazon Linux 2015.03.   A supported Ubuntu
  operating system, such as Ubuntu 18.04 LTS, Ubuntu 16.04 LTS, Ubuntu 14.04 LTS, or Ubuntu
  12.04 LTS.    CentOS Linux 7     Red Hat Enterprise Linux 7    A supported Windows
  operating system, such as Microsoft Windows Server 2012 R2 Base, Microsoft Windows Server
  2012 R2 with SQL Server Express, Microsoft Windows Server 2012 R2 with SQL Server Standard,
  or Microsoft Windows Server 2012 R2 with SQL Server Web.   A custom AMI: Custom.   Not all
  operating systems are supported with all versions of Chef. For more information about the
  supported operating systems, see OpsWorks Stacks Operating Systems. The default option is
  the current Amazon Linux version. If you set this parameter to Custom, you must use the
  CreateInstance action's AmiId parameter to specify the custom AMI that you want to use.
  Block device mappings are not supported if the value is Custom. For more information about
  how to use custom AMIs with OpsWorks Stacks, see Using Custom AMIs.
- `"RootDeviceType"`: The instance root device type. For more information, see Storage for
  the Root Device.
- `"SshKeyName"`: The instance's Amazon EC2 key-pair name.
- `"SubnetId"`: The ID of the instance's subnet. If the stack is running in a VPC, you can
  use this parameter to override the stack's default subnet ID value and direct OpsWorks
  Stacks to launch the instance in a different subnet.
- `"Tenancy"`: The instance's tenancy option. The default option is no tenancy, or if the
  instance is running in a VPC, inherit tenancy settings from the VPC. The following are
  valid values for this parameter: dedicated, default, or host. Because there are costs
  associated with changes in tenancy options, we recommend that you research tenancy options
  before choosing them for your instances. For more information about dedicated hosts, see
  Dedicated Hosts Overview and Amazon EC2 Dedicated Hosts. For more information about
  dedicated instances, see Dedicated Instances and Amazon EC2 Dedicated Instances.
- `"VirtualizationType"`: The instance's virtualization type, paravirtual or hvm.
"""
function create_instance(
    InstanceType, LayerIds, StackId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opsworks(
        "CreateInstance",
        Dict{String,Any}(
            "InstanceType" => InstanceType, "LayerIds" => LayerIds, "StackId" => StackId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_instance(
    InstanceType,
    LayerIds,
    StackId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworks(
        "CreateInstance",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "InstanceType" => InstanceType,
                    "LayerIds" => LayerIds,
                    "StackId" => StackId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_layer(name, shortname, stack_id, type)
    create_layer(name, shortname, stack_id, type, params::Dict{String,<:Any})

Creates a layer. For more information, see How to Create a Layer.  You should use
CreateLayer for noncustom layer types such as PHP App Server only if the stack does not
have an existing layer of that type. A stack can have at most one instance of each
noncustom layer; if you attempt to create a second instance, CreateLayer fails. A stack can
have an arbitrary number of custom layers, so you can call CreateLayer as many times as you
like for that layer type.   Required Permissions: To use this action, an IAM user must have
a Manage permissions level for the stack, or an attached policy that explicitly grants
permissions. For more information on user permissions, see Managing User Permissions.

# Arguments
- `name`: The layer name, which is used by the console. Layer names can be a maximum of 32
  characters.
- `shortname`: For custom layers only, use this parameter to specify the layer's short
  name, which is used internally by OpsWorks Stacks and by Chef recipes. The short name is
  also used as the name for the directory where your app files are installed. It can have a
  maximum of 32 characters, which are limited to the alphanumeric characters, '-', '_', and
  '.'. Built-in layer short names are defined by OpsWorks Stacks. For more information, see
  the Layer Reference.
- `stack_id`: The layer stack ID.
- `type`: The layer type. A stack cannot have more than one built-in layer of the same
  type. It can have any number of custom layers. Built-in layers are not available in Chef 12
  stacks.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Attributes"`: One or more user-defined key-value pairs to be added to the stack
  attributes. To create a cluster layer, set the EcsClusterArn attribute to the cluster's ARN.
- `"AutoAssignElasticIps"`: Whether to automatically assign an Elastic IP address to the
  layer's instances. For more information, see How to Edit a Layer.
- `"AutoAssignPublicIps"`: For stacks that are running in a VPC, whether to automatically
  assign a public IP address to the layer's instances. For more information, see How to Edit
  a Layer.
- `"CloudWatchLogsConfiguration"`: Specifies CloudWatch Logs configuration options for the
  layer. For more information, see CloudWatchLogsLogStream.
- `"CustomInstanceProfileArn"`: The ARN of an IAM profile to be used for the layer's EC2
  instances. For more information about IAM ARNs, see Using Identifiers.
- `"CustomJson"`: A JSON-formatted string containing custom stack configuration and
  deployment attributes to be installed on the layer's instances. For more information, see
  Using Custom JSON. This feature is supported as of version 1.7.42 of the CLI.
- `"CustomRecipes"`: A LayerCustomRecipes object that specifies the layer custom recipes.
- `"CustomSecurityGroupIds"`: An array containing the layer custom security group IDs.
- `"EnableAutoHealing"`: Whether to disable auto healing for the layer.
- `"InstallUpdatesOnBoot"`: Whether to install operating system and package updates when
  the instance boots. The default value is true. To control when updates are installed, set
  this value to false. You must then update your instances manually by using CreateDeployment
  to run the update_dependencies stack command or by manually running yum (Amazon Linux) or
  apt-get (Ubuntu) on the instances.   To ensure that your instances have the latest security
  updates, we strongly recommend using the default value of true.
- `"LifecycleEventConfiguration"`: A LifeCycleEventConfiguration object that you can use to
  configure the Shutdown event to specify an execution timeout and enable or disable Elastic
  Load Balancer connection draining.
- `"Packages"`: An array of Package objects that describes the layer packages.
- `"UseEbsOptimizedInstances"`: Whether to use Amazon EBS-optimized instances.
- `"VolumeConfigurations"`: A VolumeConfigurations object that describes the layer's Amazon
  EBS volumes.
"""
function create_layer(
    Name, Shortname, StackId, Type; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opsworks(
        "CreateLayer",
        Dict{String,Any}(
            "Name" => Name, "Shortname" => Shortname, "StackId" => StackId, "Type" => Type
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_layer(
    Name,
    Shortname,
    StackId,
    Type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworks(
        "CreateLayer",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Name" => Name,
                    "Shortname" => Shortname,
                    "StackId" => StackId,
                    "Type" => Type,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_stack(default_instance_profile_arn, name, region, service_role_arn)
    create_stack(default_instance_profile_arn, name, region, service_role_arn, params::Dict{String,<:Any})

Creates a new stack. For more information, see Create a New Stack.  Required Permissions:
To use this action, an IAM user must have an attached policy that explicitly grants
permissions. For more information about user permissions, see Managing User Permissions.

# Arguments
- `default_instance_profile_arn`: The Amazon Resource Name (ARN) of an IAM profile that is
  the default profile for all of the stack's EC2 instances. For more information about IAM
  ARNs, see Using Identifiers.
- `name`: The stack name. Stack names can be a maximum of 64 characters.
- `region`: The stack's Amazon Web Services Region, such as ap-south-1. For more
  information about Amazon Web Services Regions, see Regions and Endpoints.  In the CLI, this
  API maps to the --stack-region parameter. If the --stack-region parameter and the CLI
  common parameter --region are set to the same value, the stack uses a regional endpoint. If
  the --stack-region parameter is not set, but the CLI --region parameter is, this also
  results in a stack with a regional endpoint. However, if the --region parameter is set to
  us-east-1, and the --stack-region parameter is set to one of the following, then the stack
  uses a legacy or classic region: us-west-1, us-west-2, sa-east-1, eu-central-1, eu-west-1,
  ap-northeast-1, ap-southeast-1, ap-southeast-2. In this case, the actual API endpoint of
  the stack is in us-east-1. Only the preceding regions are supported as classic regions in
  the us-east-1 API endpoint. Because it is a best practice to choose the regional endpoint
  that is closest to where you manage Amazon Web Services, we recommend that you use regional
  endpoints for new stacks. The CLI common --region parameter always specifies a regional API
  endpoint; it cannot be used to specify a classic OpsWorks Stacks region.
- `service_role_arn`: The stack's IAM role, which allows OpsWorks Stacks to work with
  Amazon Web Services resources on your behalf. You must set this parameter to the Amazon
  Resource Name (ARN) for an existing IAM role. For more information about IAM ARNs, see
  Using Identifiers.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AgentVersion"`: The default OpsWorks Stacks agent version. You have the following
  options:   Auto-update - Set this parameter to LATEST. OpsWorks Stacks automatically
  installs new agent versions on the stack's instances as soon as they are available.   Fixed
  version - Set this parameter to your preferred agent version. To update the agent version,
  you must edit the stack configuration and specify a new version. OpsWorks Stacks installs
  that version on the stack's instances.   The default setting is the most recent release of
  the agent. To specify an agent version, you must use the complete version number, not the
  abbreviated number shown on the console. For a list of available agent version numbers,
  call DescribeAgentVersions. AgentVersion cannot be set to Chef 12.2.  You can also specify
  an agent version when you create or update an instance, which overrides the stack's default
  setting.
- `"Attributes"`: One or more user-defined key-value pairs to be added to the stack
  attributes.
- `"ChefConfiguration"`: A ChefConfiguration object that specifies whether to enable
  Berkshelf and the Berkshelf version on Chef 11.10 stacks. For more information, see Create
  a New Stack.
- `"ConfigurationManager"`: The configuration manager. When you create a stack we recommend
  that you use the configuration manager to specify the Chef version: 12, 11.10, or 11.4 for
  Linux stacks, or 12.2 for Windows stacks. The default value for Linux stacks is currently
  12.
- `"CustomCookbooksSource"`: Contains the information required to retrieve an app or
  cookbook from a repository. For more information, see Adding Apps or Cookbooks and Recipes.
- `"CustomJson"`: A string that contains user-defined, custom JSON. It can be used to
  override the corresponding default stack configuration attribute values or to pass data to
  recipes. The string should be in the following format:  \"{\"key1\": \"value1\", \"key2\":
  \"value2\",...}\"  For more information about custom JSON, see Use Custom JSON to Modify
  the Stack Configuration Attributes.
- `"DefaultAvailabilityZone"`: The stack's default Availability Zone, which must be in the
  specified region. For more information, see Regions and Endpoints. If you also specify a
  value for DefaultSubnetId, the subnet must be in the same zone. For more information, see
  the VpcId parameter description.
- `"DefaultOs"`: The stack's default operating system, which is installed on every instance
  unless you specify a different operating system when you create the instance. You can
  specify one of the following.   A supported Linux operating system: An Amazon Linux
  version, such as Amazon Linux 2, Amazon Linux 2018.03, Amazon Linux 2017.09, Amazon Linux
  2017.03, Amazon Linux 2016.09, Amazon Linux 2016.03, Amazon Linux 2015.09, or Amazon Linux
  2015.03.   A supported Ubuntu operating system, such as Ubuntu 18.04 LTS, Ubuntu 16.04 LTS,
  Ubuntu 14.04 LTS, or Ubuntu 12.04 LTS.    CentOS Linux 7     Red Hat Enterprise Linux 7
  A supported Windows operating system, such as Microsoft Windows Server 2012 R2 Base,
  Microsoft Windows Server 2012 R2 with SQL Server Express, Microsoft Windows Server 2012 R2
  with SQL Server Standard, or Microsoft Windows Server 2012 R2 with SQL Server Web.   A
  custom AMI: Custom. You specify the custom AMI you want to use when you create instances.
  For more information, see  Using Custom AMIs.   The default option is the current Amazon
  Linux version. Not all operating systems are supported with all versions of Chef. For more
  information about supported operating systems, see OpsWorks Stacks Operating Systems.
- `"DefaultRootDeviceType"`: The default root device type. This value is the default for
  all instances in the stack, but you can override it when you create an instance. The
  default option is instance-store. For more information, see Storage for the Root Device.
- `"DefaultSshKeyName"`: A default Amazon EC2 key pair name. The default value is none. If
  you specify a key pair name, OpsWorks installs the public key on the instance and you can
  use the private key with an SSH client to log in to the instance. For more information, see
   Using SSH to Communicate with an Instance and  Managing SSH Access. You can override this
  setting by specifying a different key pair, or no key pair, when you  create an instance.
- `"DefaultSubnetId"`: The stack's default VPC subnet ID. This parameter is required if you
  specify a value for the VpcId parameter. All instances are launched into this subnet unless
  you specify otherwise when you create the instance. If you also specify a value for
  DefaultAvailabilityZone, the subnet must be in that zone. For information on default values
  and when this parameter is required, see the VpcId parameter description.
- `"HostnameTheme"`: The stack's host name theme, with spaces replaced by underscores. The
  theme is used to generate host names for the stack's instances. By default, HostnameTheme
  is set to Layer_Dependent, which creates host names by appending integers to the layer's
  short name. The other themes are:    Baked_Goods     Clouds     Europe_Cities     Fruits
   Greek_Deities_and_Titans     Legendary_creatures_from_Japan     Planets_and_Moons
  Roman_Deities     Scottish_Islands     US_Cities     Wild_Cats    To obtain a generated
  host name, call GetHostNameSuggestion, which returns a host name based on the current theme.
- `"UseCustomCookbooks"`: Whether the stack uses custom cookbooks.
- `"UseOpsworksSecurityGroups"`: Whether to associate the OpsWorks Stacks built-in security
  groups with the stack's layers. OpsWorks Stacks provides a standard set of built-in
  security groups, one for each layer, which are associated with layers by default. With
  UseOpsworksSecurityGroups you can instead provide your own custom security groups.
  UseOpsworksSecurityGroups has the following settings:    True - OpsWorks Stacks
  automatically associates the appropriate built-in security group with each layer (default
  setting). You can associate additional security groups with a layer after you create it,
  but you cannot delete the built-in security group.   False - OpsWorks Stacks does not
  associate built-in security groups with layers. You must create appropriate EC2 security
  groups and associate a security group with each layer that you create. However, you can
  still manually associate a built-in security group with a layer on creation; custom
  security groups are required only for those layers that need custom settings.   For more
  information, see Create a New Stack.
- `"VpcId"`: The ID of the VPC that the stack is to be launched into. The VPC must be in
  the stack's region. All instances are launched into this VPC. You cannot change the ID
  later.   If your account supports EC2-Classic, the default value is no VPC.   If your
  account does not support EC2-Classic, the default value is the default VPC for the
  specified region.   If the VPC ID corresponds to a default VPC and you have specified
  either the DefaultAvailabilityZone or the DefaultSubnetId parameter only, OpsWorks Stacks
  infers the value of the other parameter. If you specify neither parameter, OpsWorks Stacks
  sets these parameters to the first valid Availability Zone for the specified region and the
  corresponding default VPC subnet ID, respectively. If you specify a nondefault VPC ID, note
  the following:   It must belong to a VPC in your account that is in the specified region.
  You must specify a value for DefaultSubnetId.   For more information about how to use
  OpsWorks Stacks with a VPC, see Running a Stack in a VPC. For more information about
  default VPC and EC2-Classic, see Supported Platforms.
"""
function create_stack(
    DefaultInstanceProfileArn,
    Name,
    Region,
    ServiceRoleArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworks(
        "CreateStack",
        Dict{String,Any}(
            "DefaultInstanceProfileArn" => DefaultInstanceProfileArn,
            "Name" => Name,
            "Region" => Region,
            "ServiceRoleArn" => ServiceRoleArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_stack(
    DefaultInstanceProfileArn,
    Name,
    Region,
    ServiceRoleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworks(
        "CreateStack",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DefaultInstanceProfileArn" => DefaultInstanceProfileArn,
                    "Name" => Name,
                    "Region" => Region,
                    "ServiceRoleArn" => ServiceRoleArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_user_profile(iam_user_arn)
    create_user_profile(iam_user_arn, params::Dict{String,<:Any})

Creates a new user profile.  Required Permissions: To use this action, an IAM user must
have an attached policy that explicitly grants permissions. For more information about user
permissions, see Managing User Permissions.

# Arguments
- `iam_user_arn`: The user's IAM ARN; this can also be a federated user's ARN.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AllowSelfManagement"`: Whether users can specify their own SSH public key through the
  My Settings page. For more information, see Setting an IAM User's Public SSH Key.
- `"SshPublicKey"`: The user's public SSH key.
- `"SshUsername"`: The user's SSH user name. The allowable characters are [a-z], [A-Z],
  [0-9], '-', and '_'. If the specified name includes other punctuation marks, OpsWorks
  Stacks removes them. For example, my.name is changed to myname. If you do not specify an
  SSH user name, OpsWorks Stacks generates one from the IAM user name.
"""
function create_user_profile(IamUserArn; aws_config::AbstractAWSConfig=current_aws_config())
    return opsworks(
        "CreateUserProfile",
        Dict{String,Any}("IamUserArn" => IamUserArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_user_profile(
    IamUserArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworks(
        "CreateUserProfile",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("IamUserArn" => IamUserArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_app(app_id)
    delete_app(app_id, params::Dict{String,<:Any})

Deletes a specified app.  Required Permissions: To use this action, an IAM user must have a
Manage permissions level for the stack, or an attached policy that explicitly grants
permissions. For more information on user permissions, see Managing User Permissions.

# Arguments
- `app_id`: The app ID.

"""
function delete_app(AppId; aws_config::AbstractAWSConfig=current_aws_config())
    return opsworks(
        "DeleteApp",
        Dict{String,Any}("AppId" => AppId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_app(
    AppId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opsworks(
        "DeleteApp",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("AppId" => AppId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_instance(instance_id)
    delete_instance(instance_id, params::Dict{String,<:Any})

Deletes a specified instance, which terminates the associated Amazon EC2 instance. You must
stop an instance before you can delete it. For more information, see Deleting Instances.
Required Permissions: To use this action, an IAM user must have a Manage permissions level
for the stack, or an attached policy that explicitly grants permissions. For more
information on user permissions, see Managing User Permissions.

# Arguments
- `instance_id`: The instance ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DeleteElasticIp"`: Whether to delete the instance Elastic IP address.
- `"DeleteVolumes"`: Whether to delete the instance's Amazon EBS volumes.
"""
function delete_instance(InstanceId; aws_config::AbstractAWSConfig=current_aws_config())
    return opsworks(
        "DeleteInstance",
        Dict{String,Any}("InstanceId" => InstanceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_instance(
    InstanceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworks(
        "DeleteInstance",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("InstanceId" => InstanceId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_layer(layer_id)
    delete_layer(layer_id, params::Dict{String,<:Any})

Deletes a specified layer. You must first stop and then delete all associated instances or
unassign registered instances. For more information, see How to Delete a Layer.  Required
Permissions: To use this action, an IAM user must have a Manage permissions level for the
stack, or an attached policy that explicitly grants permissions. For more information on
user permissions, see Managing User Permissions.

# Arguments
- `layer_id`: The layer ID.

"""
function delete_layer(LayerId; aws_config::AbstractAWSConfig=current_aws_config())
    return opsworks(
        "DeleteLayer",
        Dict{String,Any}("LayerId" => LayerId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_layer(
    LayerId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworks(
        "DeleteLayer",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("LayerId" => LayerId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_stack(stack_id)
    delete_stack(stack_id, params::Dict{String,<:Any})

Deletes a specified stack. You must first delete all instances, layers, and apps or
deregister registered instances. For more information, see Shut Down a Stack.  Required
Permissions: To use this action, an IAM user must have a Manage permissions level for the
stack, or an attached policy that explicitly grants permissions. For more information on
user permissions, see Managing User Permissions.

# Arguments
- `stack_id`: The stack ID.

"""
function delete_stack(StackId; aws_config::AbstractAWSConfig=current_aws_config())
    return opsworks(
        "DeleteStack",
        Dict{String,Any}("StackId" => StackId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_stack(
    StackId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworks(
        "DeleteStack",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("StackId" => StackId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_user_profile(iam_user_arn)
    delete_user_profile(iam_user_arn, params::Dict{String,<:Any})

Deletes a user profile.  Required Permissions: To use this action, an IAM user must have an
attached policy that explicitly grants permissions. For more information about user
permissions, see Managing User Permissions.

# Arguments
- `iam_user_arn`: The user's IAM ARN. This can also be a federated user's ARN.

"""
function delete_user_profile(IamUserArn; aws_config::AbstractAWSConfig=current_aws_config())
    return opsworks(
        "DeleteUserProfile",
        Dict{String,Any}("IamUserArn" => IamUserArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_user_profile(
    IamUserArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworks(
        "DeleteUserProfile",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("IamUserArn" => IamUserArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    deregister_ecs_cluster(ecs_cluster_arn)
    deregister_ecs_cluster(ecs_cluster_arn, params::Dict{String,<:Any})

Deregisters a specified Amazon ECS cluster from a stack. For more information, see
Resource Management.  Required Permissions: To use this action, an IAM user must have a
Manage permissions level for the stack or an attached policy that explicitly grants
permissions. For more information on user permissions, see
https://docs.aws.amazon.com/opsworks/latest/userguide/opsworks-security-users.html.

# Arguments
- `ecs_cluster_arn`: The cluster's Amazon Resource Number (ARN).

"""
function deregister_ecs_cluster(
    EcsClusterArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opsworks(
        "DeregisterEcsCluster",
        Dict{String,Any}("EcsClusterArn" => EcsClusterArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function deregister_ecs_cluster(
    EcsClusterArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworks(
        "DeregisterEcsCluster",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("EcsClusterArn" => EcsClusterArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    deregister_elastic_ip(elastic_ip)
    deregister_elastic_ip(elastic_ip, params::Dict{String,<:Any})

Deregisters a specified Elastic IP address. The address can be registered by another stack
after it is deregistered. For more information, see Resource Management.  Required
Permissions: To use this action, an IAM user must have a Manage permissions level for the
stack, or an attached policy that explicitly grants permissions. For more information on
user permissions, see Managing User Permissions.

# Arguments
- `elastic_ip`: The Elastic IP address.

"""
function deregister_elastic_ip(
    ElasticIp; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opsworks(
        "DeregisterElasticIp",
        Dict{String,Any}("ElasticIp" => ElasticIp);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function deregister_elastic_ip(
    ElasticIp,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworks(
        "DeregisterElasticIp",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ElasticIp" => ElasticIp), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    deregister_instance(instance_id)
    deregister_instance(instance_id, params::Dict{String,<:Any})

Deregister an instance from OpsWorks Stacks. The instance can be a registered instance
(Amazon EC2 or on-premises) or an instance created with OpsWorks. This action removes the
instance from the stack and returns it to your control.  Required Permissions: To use this
action, an IAM user must have a Manage permissions level for the stack or an attached
policy that explicitly grants permissions. For more information on user permissions, see
Managing User Permissions.

# Arguments
- `instance_id`: The instance ID.

"""
function deregister_instance(InstanceId; aws_config::AbstractAWSConfig=current_aws_config())
    return opsworks(
        "DeregisterInstance",
        Dict{String,Any}("InstanceId" => InstanceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function deregister_instance(
    InstanceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworks(
        "DeregisterInstance",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("InstanceId" => InstanceId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    deregister_rds_db_instance(rds_db_instance_arn)
    deregister_rds_db_instance(rds_db_instance_arn, params::Dict{String,<:Any})

Deregisters an Amazon RDS instance.  Required Permissions: To use this action, an IAM user
must have a Manage permissions level for the stack, or an attached policy that explicitly
grants permissions. For more information on user permissions, see Managing User Permissions.

# Arguments
- `rds_db_instance_arn`: The Amazon RDS instance's ARN.

"""
function deregister_rds_db_instance(
    RdsDbInstanceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opsworks(
        "DeregisterRdsDbInstance",
        Dict{String,Any}("RdsDbInstanceArn" => RdsDbInstanceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function deregister_rds_db_instance(
    RdsDbInstanceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworks(
        "DeregisterRdsDbInstance",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("RdsDbInstanceArn" => RdsDbInstanceArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    deregister_volume(volume_id)
    deregister_volume(volume_id, params::Dict{String,<:Any})

Deregisters an Amazon EBS volume. The volume can then be registered by another stack. For
more information, see Resource Management.  Required Permissions: To use this action, an
IAM user must have a Manage permissions level for the stack, or an attached policy that
explicitly grants permissions. For more information on user permissions, see Managing User
Permissions.

# Arguments
- `volume_id`: The OpsWorks Stacks volume ID, which is the GUID that OpsWorks Stacks
  assigned to the instance when you registered the volume with the stack, not the Amazon EC2
  volume ID.

"""
function deregister_volume(VolumeId; aws_config::AbstractAWSConfig=current_aws_config())
    return opsworks(
        "DeregisterVolume",
        Dict{String,Any}("VolumeId" => VolumeId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function deregister_volume(
    VolumeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworks(
        "DeregisterVolume",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("VolumeId" => VolumeId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_agent_versions()
    describe_agent_versions(params::Dict{String,<:Any})

Describes the available OpsWorks Stacks agent versions. You must specify a stack ID or a
configuration manager. DescribeAgentVersions returns a list of available agent versions for
the specified stack or configuration manager.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConfigurationManager"`: The configuration manager.
- `"StackId"`: The stack ID.
"""
function describe_agent_versions(; aws_config::AbstractAWSConfig=current_aws_config())
    return opsworks(
        "DescribeAgentVersions"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_agent_versions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opsworks(
        "DescribeAgentVersions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_apps()
    describe_apps(params::Dict{String,<:Any})

Requests a description of a specified set of apps.  This call accepts only one
resource-identifying parameter.   Required Permissions: To use this action, an IAM user
must have a Show, Deploy, or Manage permissions level for the stack, or an attached policy
that explicitly grants permissions. For more information about user permissions, see
Managing User Permissions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AppIds"`: An array of app IDs for the apps to be described. If you use this parameter,
  DescribeApps returns a description of the specified apps. Otherwise, it returns a
  description of every app.
- `"StackId"`: The app stack ID. If you use this parameter, DescribeApps returns a
  description of the apps in the specified stack.
"""
function describe_apps(; aws_config::AbstractAWSConfig=current_aws_config())
    return opsworks("DescribeApps"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function describe_apps(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opsworks(
        "DescribeApps", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_commands()
    describe_commands(params::Dict{String,<:Any})

Describes the results of specified commands.  This call accepts only one
resource-identifying parameter.   Required Permissions: To use this action, an IAM user
must have a Show, Deploy, or Manage permissions level for the stack, or an attached policy
that explicitly grants permissions. For more information about user permissions, see
Managing User Permissions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CommandIds"`: An array of command IDs. If you include this parameter, DescribeCommands
  returns a description of the specified commands. Otherwise, it returns a description of
  every command.
- `"DeploymentId"`: The deployment ID. If you include this parameter, DescribeCommands
  returns a description of the commands associated with the specified deployment.
- `"InstanceId"`: The instance ID. If you include this parameter, DescribeCommands returns
  a description of the commands associated with the specified instance.
"""
function describe_commands(; aws_config::AbstractAWSConfig=current_aws_config())
    return opsworks(
        "DescribeCommands"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_commands(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opsworks(
        "DescribeCommands", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_deployments()
    describe_deployments(params::Dict{String,<:Any})

Requests a description of a specified set of deployments.  This call accepts only one
resource-identifying parameter.   Required Permissions: To use this action, an IAM user
must have a Show, Deploy, or Manage permissions level for the stack, or an attached policy
that explicitly grants permissions. For more information about user permissions, see
Managing User Permissions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AppId"`: The app ID. If you include this parameter, the command returns a description
  of the commands associated with the specified app.
- `"DeploymentIds"`: An array of deployment IDs to be described. If you include this
  parameter, the command returns a description of the specified deployments. Otherwise, it
  returns a description of every deployment.
- `"StackId"`: The stack ID. If you include this parameter, the command returns a
  description of the commands associated with the specified stack.
"""
function describe_deployments(; aws_config::AbstractAWSConfig=current_aws_config())
    return opsworks(
        "DescribeDeployments"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_deployments(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opsworks(
        "DescribeDeployments",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_ecs_clusters()
    describe_ecs_clusters(params::Dict{String,<:Any})

Describes Amazon ECS clusters that are registered with a stack. If you specify only a stack
ID, you can use the MaxResults and NextToken parameters to paginate the response. However,
OpsWorks Stacks currently supports only one cluster per layer, so the result set has a
maximum of one element.  Required Permissions: To use this action, an IAM user must have a
Show, Deploy, or Manage permissions level for the stack or an attached policy that
explicitly grants permission. For more information about user permissions, see Managing
User Permissions. This call accepts only one resource-identifying parameter.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EcsClusterArns"`: A list of ARNs, one for each cluster to be described.
- `"MaxResults"`: To receive a paginated response, use this parameter to specify the
  maximum number of results to be returned with a single call. If the number of available
  results exceeds this maximum, the response includes a NextToken value that you can assign
  to the NextToken request parameter to get the next set of results.
- `"NextToken"`: If the previous paginated request did not return all of the remaining
  results, the response object'sNextToken parameter value is set to a token. To retrieve the
  next set of results, call DescribeEcsClusters again and assign that token to the request
  object's NextToken parameter. If there are no remaining results, the previous response
  object's NextToken parameter is set to null.
- `"StackId"`: A stack ID. DescribeEcsClusters returns a description of the cluster that is
  registered with the stack.
"""
function describe_ecs_clusters(; aws_config::AbstractAWSConfig=current_aws_config())
    return opsworks(
        "DescribeEcsClusters"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_ecs_clusters(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opsworks(
        "DescribeEcsClusters",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_elastic_ips()
    describe_elastic_ips(params::Dict{String,<:Any})

Describes Elastic IP addresses.  This call accepts only one resource-identifying parameter.
  Required Permissions: To use this action, an IAM user must have a Show, Deploy, or Manage
permissions level for the stack, or an attached policy that explicitly grants permissions.
For more information about user permissions, see Managing User Permissions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"InstanceId"`: The instance ID. If you include this parameter, DescribeElasticIps
  returns a description of the Elastic IP addresses associated with the specified instance.
- `"Ips"`: An array of Elastic IP addresses to be described. If you include this parameter,
  DescribeElasticIps returns a description of the specified Elastic IP addresses. Otherwise,
  it returns a description of every Elastic IP address.
- `"StackId"`: A stack ID. If you include this parameter, DescribeElasticIps returns a
  description of the Elastic IP addresses that are registered with the specified stack.
"""
function describe_elastic_ips(; aws_config::AbstractAWSConfig=current_aws_config())
    return opsworks(
        "DescribeElasticIps"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_elastic_ips(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opsworks(
        "DescribeElasticIps", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_elastic_load_balancers()
    describe_elastic_load_balancers(params::Dict{String,<:Any})

Describes a stack's Elastic Load Balancing instances.  This call accepts only one
resource-identifying parameter.   Required Permissions: To use this action, an IAM user
must have a Show, Deploy, or Manage permissions level for the stack, or an attached policy
that explicitly grants permissions. For more information about user permissions, see
Managing User Permissions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"LayerIds"`: A list of layer IDs. The action describes the Elastic Load Balancing
  instances for the specified layers.
- `"StackId"`: A stack ID. The action describes the stack's Elastic Load Balancing
  instances.
"""
function describe_elastic_load_balancers(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return opsworks(
        "DescribeElasticLoadBalancers";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_elastic_load_balancers(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opsworks(
        "DescribeElasticLoadBalancers",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_instances()
    describe_instances(params::Dict{String,<:Any})

Requests a description of a set of instances.  This call accepts only one
resource-identifying parameter.   Required Permissions: To use this action, an IAM user
must have a Show, Deploy, or Manage permissions level for the stack, or an attached policy
that explicitly grants permissions. For more information about user permissions, see
Managing User Permissions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"InstanceIds"`: An array of instance IDs to be described. If you use this parameter,
  DescribeInstances returns a description of the specified instances. Otherwise, it returns a
  description of every instance.
- `"LayerId"`: A layer ID. If you use this parameter, DescribeInstances returns
  descriptions of the instances associated with the specified layer.
- `"StackId"`: A stack ID. If you use this parameter, DescribeInstances returns
  descriptions of the instances associated with the specified stack.
"""
function describe_instances(; aws_config::AbstractAWSConfig=current_aws_config())
    return opsworks(
        "DescribeInstances"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_instances(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opsworks(
        "DescribeInstances", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_layers()
    describe_layers(params::Dict{String,<:Any})

Requests a description of one or more layers in a specified stack.  This call accepts only
one resource-identifying parameter.   Required Permissions: To use this action, an IAM user
must have a Show, Deploy, or Manage permissions level for the stack, or an attached policy
that explicitly grants permissions. For more information about user permissions, see
Managing User Permissions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"LayerIds"`: An array of layer IDs that specify the layers to be described. If you omit
  this parameter, DescribeLayers returns a description of every layer in the specified stack.
- `"StackId"`: The stack ID.
"""
function describe_layers(; aws_config::AbstractAWSConfig=current_aws_config())
    return opsworks(
        "DescribeLayers"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_layers(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opsworks(
        "DescribeLayers", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_load_based_auto_scaling(layer_ids)
    describe_load_based_auto_scaling(layer_ids, params::Dict{String,<:Any})

Describes load-based auto scaling configurations for specified layers.  You must specify at
least one of the parameters.   Required Permissions: To use this action, an IAM user must
have a Show, Deploy, or Manage permissions level for the stack, or an attached policy that
explicitly grants permissions. For more information about user permissions, see Managing
User Permissions.

# Arguments
- `layer_ids`: An array of layer IDs.

"""
function describe_load_based_auto_scaling(
    LayerIds; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opsworks(
        "DescribeLoadBasedAutoScaling",
        Dict{String,Any}("LayerIds" => LayerIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_load_based_auto_scaling(
    LayerIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworks(
        "DescribeLoadBasedAutoScaling",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("LayerIds" => LayerIds), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_my_user_profile()
    describe_my_user_profile(params::Dict{String,<:Any})

Describes a user's SSH information.  Required Permissions: To use this action, an IAM user
must have self-management enabled or an attached policy that explicitly grants permissions.
For more information about user permissions, see Managing User Permissions.

"""
function describe_my_user_profile(; aws_config::AbstractAWSConfig=current_aws_config())
    return opsworks(
        "DescribeMyUserProfile"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_my_user_profile(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opsworks(
        "DescribeMyUserProfile",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_operating_systems()
    describe_operating_systems(params::Dict{String,<:Any})

Describes the operating systems that are supported by OpsWorks Stacks.

"""
function describe_operating_systems(; aws_config::AbstractAWSConfig=current_aws_config())
    return opsworks(
        "DescribeOperatingSystems"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_operating_systems(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opsworks(
        "DescribeOperatingSystems",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_permissions()
    describe_permissions(params::Dict{String,<:Any})

Describes the permissions for a specified stack.  Required Permissions: To use this action,
an IAM user must have a Manage permissions level for the stack, or an attached policy that
explicitly grants permissions. For more information on user permissions, see Managing User
Permissions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"IamUserArn"`: The user's IAM ARN. This can also be a federated user's ARN. For more
  information about IAM ARNs, see Using Identifiers.
- `"StackId"`: The stack ID.
"""
function describe_permissions(; aws_config::AbstractAWSConfig=current_aws_config())
    return opsworks(
        "DescribePermissions"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_permissions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opsworks(
        "DescribePermissions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_raid_arrays()
    describe_raid_arrays(params::Dict{String,<:Any})

Describe an instance's RAID arrays.  This call accepts only one resource-identifying
parameter.   Required Permissions: To use this action, an IAM user must have a Show,
Deploy, or Manage permissions level for the stack, or an attached policy that explicitly
grants permissions. For more information about user permissions, see Managing User
Permissions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"InstanceId"`: The instance ID. If you use this parameter, DescribeRaidArrays returns
  descriptions of the RAID arrays associated with the specified instance.
- `"RaidArrayIds"`: An array of RAID array IDs. If you use this parameter,
  DescribeRaidArrays returns descriptions of the specified arrays. Otherwise, it returns a
  description of every array.
- `"StackId"`: The stack ID.
"""
function describe_raid_arrays(; aws_config::AbstractAWSConfig=current_aws_config())
    return opsworks(
        "DescribeRaidArrays"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_raid_arrays(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opsworks(
        "DescribeRaidArrays", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_rds_db_instances(stack_id)
    describe_rds_db_instances(stack_id, params::Dict{String,<:Any})

Describes Amazon RDS instances.  Required Permissions: To use this action, an IAM user must
have a Show, Deploy, or Manage permissions level for the stack, or an attached policy that
explicitly grants permissions. For more information about user permissions, see Managing
User Permissions. This call accepts only one resource-identifying parameter.

# Arguments
- `stack_id`: The ID of the stack with which the instances are registered. The operation
  returns descriptions of all registered Amazon RDS instances.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"RdsDbInstanceArns"`: An array containing the ARNs of the instances to be described.
"""
function describe_rds_db_instances(
    StackId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opsworks(
        "DescribeRdsDbInstances",
        Dict{String,Any}("StackId" => StackId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_rds_db_instances(
    StackId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworks(
        "DescribeRdsDbInstances",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("StackId" => StackId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_service_errors()
    describe_service_errors(params::Dict{String,<:Any})

Describes OpsWorks Stacks service errors.  Required Permissions: To use this action, an IAM
user must have a Show, Deploy, or Manage permissions level for the stack, or an attached
policy that explicitly grants permissions. For more information about user permissions, see
Managing User Permissions. This call accepts only one resource-identifying parameter.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"InstanceId"`: The instance ID. If you use this parameter, DescribeServiceErrors returns
  descriptions of the errors associated with the specified instance.
- `"ServiceErrorIds"`: An array of service error IDs. If you use this parameter,
  DescribeServiceErrors returns descriptions of the specified errors. Otherwise, it returns a
  description of every error.
- `"StackId"`: The stack ID. If you use this parameter, DescribeServiceErrors returns
  descriptions of the errors associated with the specified stack.
"""
function describe_service_errors(; aws_config::AbstractAWSConfig=current_aws_config())
    return opsworks(
        "DescribeServiceErrors"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_service_errors(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opsworks(
        "DescribeServiceErrors",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_stack_provisioning_parameters(stack_id)
    describe_stack_provisioning_parameters(stack_id, params::Dict{String,<:Any})

Requests a description of a stack's provisioning parameters.  Required Permissions: To use
this action, an IAM user must have a Show, Deploy, or Manage permissions level for the
stack or an attached policy that explicitly grants permissions. For more information about
user permissions, see Managing User Permissions.

# Arguments
- `stack_id`: The stack ID.

"""
function describe_stack_provisioning_parameters(
    StackId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opsworks(
        "DescribeStackProvisioningParameters",
        Dict{String,Any}("StackId" => StackId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_stack_provisioning_parameters(
    StackId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworks(
        "DescribeStackProvisioningParameters",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("StackId" => StackId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_stack_summary(stack_id)
    describe_stack_summary(stack_id, params::Dict{String,<:Any})

Describes the number of layers and apps in a specified stack, and the number of instances
in each state, such as running_setup or online.  Required Permissions: To use this action,
an IAM user must have a Show, Deploy, or Manage permissions level for the stack, or an
attached policy that explicitly grants permissions. For more information about user
permissions, see Managing User Permissions.

# Arguments
- `stack_id`: The stack ID.

"""
function describe_stack_summary(StackId; aws_config::AbstractAWSConfig=current_aws_config())
    return opsworks(
        "DescribeStackSummary",
        Dict{String,Any}("StackId" => StackId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_stack_summary(
    StackId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworks(
        "DescribeStackSummary",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("StackId" => StackId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_stacks()
    describe_stacks(params::Dict{String,<:Any})

Requests a description of one or more stacks.  Required Permissions: To use this action, an
IAM user must have a Show, Deploy, or Manage permissions level for the stack, or an
attached policy that explicitly grants permissions. For more information about user
permissions, see Managing User Permissions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"StackIds"`: An array of stack IDs that specify the stacks to be described. If you omit
  this parameter, and have permissions to get information about all stacks, DescribeStacks
  returns a description of every stack. If the IAM policy that is attached to an IAM user
  limits the DescribeStacks action to specific stack ARNs, this parameter is required, and
  the user must specify a stack ARN that is allowed by the policy. Otherwise, DescribeStacks
  returns an AccessDenied error.
"""
function describe_stacks(; aws_config::AbstractAWSConfig=current_aws_config())
    return opsworks(
        "DescribeStacks"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_stacks(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opsworks(
        "DescribeStacks", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_time_based_auto_scaling(instance_ids)
    describe_time_based_auto_scaling(instance_ids, params::Dict{String,<:Any})

Describes time-based auto scaling configurations for specified instances.  You must specify
at least one of the parameters.   Required Permissions: To use this action, an IAM user
must have a Show, Deploy, or Manage permissions level for the stack, or an attached policy
that explicitly grants permissions. For more information about user permissions, see
Managing User Permissions.

# Arguments
- `instance_ids`: An array of instance IDs.

"""
function describe_time_based_auto_scaling(
    InstanceIds; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opsworks(
        "DescribeTimeBasedAutoScaling",
        Dict{String,Any}("InstanceIds" => InstanceIds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_time_based_auto_scaling(
    InstanceIds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworks(
        "DescribeTimeBasedAutoScaling",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("InstanceIds" => InstanceIds), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_user_profiles()
    describe_user_profiles(params::Dict{String,<:Any})

Describe specified users.  Required Permissions: To use this action, an IAM user must have
an attached policy that explicitly grants permissions. For more information about user
permissions, see Managing User Permissions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"IamUserArns"`: An array of IAM or federated user ARNs that identify the users to be
  described.
"""
function describe_user_profiles(; aws_config::AbstractAWSConfig=current_aws_config())
    return opsworks(
        "DescribeUserProfiles"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_user_profiles(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opsworks(
        "DescribeUserProfiles",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_volumes()
    describe_volumes(params::Dict{String,<:Any})

Describes an instance's Amazon EBS volumes.  This call accepts only one
resource-identifying parameter.   Required Permissions: To use this action, an IAM user
must have a Show, Deploy, or Manage permissions level for the stack, or an attached policy
that explicitly grants permissions. For more information about user permissions, see
Managing User Permissions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"InstanceId"`: The instance ID. If you use this parameter, DescribeVolumes returns
  descriptions of the volumes associated with the specified instance.
- `"RaidArrayId"`: The RAID array ID. If you use this parameter, DescribeVolumes returns
  descriptions of the volumes associated with the specified RAID array.
- `"StackId"`: A stack ID. The action describes the stack's registered Amazon EBS volumes.
- `"VolumeIds"`: Am array of volume IDs. If you use this parameter, DescribeVolumes returns
  descriptions of the specified volumes. Otherwise, it returns a description of every volume.
"""
function describe_volumes(; aws_config::AbstractAWSConfig=current_aws_config())
    return opsworks(
        "DescribeVolumes"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_volumes(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opsworks(
        "DescribeVolumes", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    detach_elastic_load_balancer(elastic_load_balancer_name, layer_id)
    detach_elastic_load_balancer(elastic_load_balancer_name, layer_id, params::Dict{String,<:Any})

Detaches a specified Elastic Load Balancing instance from its layer.  Required Permissions:
To use this action, an IAM user must have a Manage permissions level for the stack, or an
attached policy that explicitly grants permissions. For more information on user
permissions, see Managing User Permissions.

# Arguments
- `elastic_load_balancer_name`: The Elastic Load Balancing instance's name.
- `layer_id`: The ID of the layer that the Elastic Load Balancing instance is attached to.

"""
function detach_elastic_load_balancer(
    ElasticLoadBalancerName, LayerId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opsworks(
        "DetachElasticLoadBalancer",
        Dict{String,Any}(
            "ElasticLoadBalancerName" => ElasticLoadBalancerName, "LayerId" => LayerId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function detach_elastic_load_balancer(
    ElasticLoadBalancerName,
    LayerId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworks(
        "DetachElasticLoadBalancer",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ElasticLoadBalancerName" => ElasticLoadBalancerName,
                    "LayerId" => LayerId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_elastic_ip(elastic_ip)
    disassociate_elastic_ip(elastic_ip, params::Dict{String,<:Any})

Disassociates an Elastic IP address from its instance. The address remains registered with
the stack. For more information, see Resource Management.  Required Permissions: To use
this action, an IAM user must have a Manage permissions level for the stack, or an attached
policy that explicitly grants permissions. For more information on user permissions, see
Managing User Permissions.

# Arguments
- `elastic_ip`: The Elastic IP address.

"""
function disassociate_elastic_ip(
    ElasticIp; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opsworks(
        "DisassociateElasticIp",
        Dict{String,Any}("ElasticIp" => ElasticIp);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_elastic_ip(
    ElasticIp,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworks(
        "DisassociateElasticIp",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ElasticIp" => ElasticIp), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_hostname_suggestion(layer_id)
    get_hostname_suggestion(layer_id, params::Dict{String,<:Any})

Gets a generated host name for the specified layer, based on the current host name theme.
Required Permissions: To use this action, an IAM user must have a Manage permissions level
for the stack, or an attached policy that explicitly grants permissions. For more
information on user permissions, see Managing User Permissions.

# Arguments
- `layer_id`: The layer ID.

"""
function get_hostname_suggestion(
    LayerId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opsworks(
        "GetHostnameSuggestion",
        Dict{String,Any}("LayerId" => LayerId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_hostname_suggestion(
    LayerId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworks(
        "GetHostnameSuggestion",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("LayerId" => LayerId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    grant_access(instance_id)
    grant_access(instance_id, params::Dict{String,<:Any})

 This action can be used only with Windows stacks.  Grants RDP access to a Windows instance
for a specified time period.

# Arguments
- `instance_id`: The instance's OpsWorks Stacks ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ValidForInMinutes"`: The length of time (in minutes) that the grant is valid. When the
  grant expires at the end of this period, the user will no longer be able to use the
  credentials to log in. If the user is logged in at the time, they are logged out.
"""
function grant_access(InstanceId; aws_config::AbstractAWSConfig=current_aws_config())
    return opsworks(
        "GrantAccess",
        Dict{String,Any}("InstanceId" => InstanceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function grant_access(
    InstanceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworks(
        "GrantAccess",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("InstanceId" => InstanceId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags(resource_arn)
    list_tags(resource_arn, params::Dict{String,<:Any})

Returns a list of tags that are applied to the specified stack or layer.

# Arguments
- `resource_arn`: The stack or layer's Amazon Resource Number (ARN).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Do not use. A validation exception occurs if you add a MaxResults
  parameter to a ListTagsRequest call.
- `"NextToken"`: Do not use. A validation exception occurs if you add a NextToken parameter
  to a ListTagsRequest call.
"""
function list_tags(ResourceArn; aws_config::AbstractAWSConfig=current_aws_config())
    return opsworks(
        "ListTags",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworks(
        "ListTags",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    reboot_instance(instance_id)
    reboot_instance(instance_id, params::Dict{String,<:Any})

Reboots a specified instance. For more information, see Starting, Stopping, and Rebooting
Instances.  Required Permissions: To use this action, an IAM user must have a Manage
permissions level for the stack, or an attached policy that explicitly grants permissions.
For more information on user permissions, see Managing User Permissions.

# Arguments
- `instance_id`: The instance ID.

"""
function reboot_instance(InstanceId; aws_config::AbstractAWSConfig=current_aws_config())
    return opsworks(
        "RebootInstance",
        Dict{String,Any}("InstanceId" => InstanceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function reboot_instance(
    InstanceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworks(
        "RebootInstance",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("InstanceId" => InstanceId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    register_ecs_cluster(ecs_cluster_arn, stack_id)
    register_ecs_cluster(ecs_cluster_arn, stack_id, params::Dict{String,<:Any})

Registers a specified Amazon ECS cluster with a stack. You can register only one cluster
with a stack. A cluster can be registered with only one stack. For more information, see
Resource Management.  Required Permissions: To use this action, an IAM user must have a
Manage permissions level for the stack or an attached policy that explicitly grants
permissions. For more information on user permissions, see  Managing User Permissions.

# Arguments
- `ecs_cluster_arn`: The cluster's ARN.
- `stack_id`: The stack ID.

"""
function register_ecs_cluster(
    EcsClusterArn, StackId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opsworks(
        "RegisterEcsCluster",
        Dict{String,Any}("EcsClusterArn" => EcsClusterArn, "StackId" => StackId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function register_ecs_cluster(
    EcsClusterArn,
    StackId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworks(
        "RegisterEcsCluster",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("EcsClusterArn" => EcsClusterArn, "StackId" => StackId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    register_elastic_ip(elastic_ip, stack_id)
    register_elastic_ip(elastic_ip, stack_id, params::Dict{String,<:Any})

Registers an Elastic IP address with a specified stack. An address can be registered with
only one stack at a time. If the address is already registered, you must first deregister
it by calling DeregisterElasticIp. For more information, see Resource Management.  Required
Permissions: To use this action, an IAM user must have a Manage permissions level for the
stack, or an attached policy that explicitly grants permissions. For more information on
user permissions, see Managing User Permissions.

# Arguments
- `elastic_ip`: The Elastic IP address.
- `stack_id`: The stack ID.

"""
function register_elastic_ip(
    ElasticIp, StackId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opsworks(
        "RegisterElasticIp",
        Dict{String,Any}("ElasticIp" => ElasticIp, "StackId" => StackId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function register_elastic_ip(
    ElasticIp,
    StackId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworks(
        "RegisterElasticIp",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ElasticIp" => ElasticIp, "StackId" => StackId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    register_instance(stack_id)
    register_instance(stack_id, params::Dict{String,<:Any})

Registers instances that were created outside of OpsWorks Stacks with a specified stack.
We do not recommend using this action to register instances. The complete registration
operation includes two tasks: installing the OpsWorks Stacks agent on the instance, and
registering the instance with the stack. RegisterInstance handles only the second step. You
should instead use the CLI register command, which performs the entire registration
operation. For more information, see  Registering an Instance with an OpsWorks Stacks
Stack.  Registered instances have the same requirements as instances that are created by
using the CreateInstance API. For example, registered instances must be running a supported
Linux-based operating system, and they must have a supported instance type. For more
information about requirements for instances that you want to register, see  Preparing the
Instance.  Required Permissions: To use this action, an IAM user must have a Manage
permissions level for the stack or an attached policy that explicitly grants permissions.
For more information on user permissions, see Managing User Permissions.

# Arguments
- `stack_id`: The ID of the stack that the instance is to be registered with.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Hostname"`: The instance's host name. The following are character limits for instance
  host names.   Linux-based instances: 63 characters   Windows-based instances: 15 characters
  
- `"InstanceIdentity"`: An InstanceIdentity object that contains the instance's identity.
- `"PrivateIp"`: The instance's private IP address.
- `"PublicIp"`: The instance's public IP address.
- `"RsaPublicKey"`: The instances public RSA key. This key is used to encrypt communication
  between the instance and the service.
- `"RsaPublicKeyFingerprint"`: The instances public RSA key fingerprint.
"""
function register_instance(StackId; aws_config::AbstractAWSConfig=current_aws_config())
    return opsworks(
        "RegisterInstance",
        Dict{String,Any}("StackId" => StackId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function register_instance(
    StackId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworks(
        "RegisterInstance",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("StackId" => StackId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    register_rds_db_instance(db_password, db_user, rds_db_instance_arn, stack_id)
    register_rds_db_instance(db_password, db_user, rds_db_instance_arn, stack_id, params::Dict{String,<:Any})

Registers an Amazon RDS instance with a stack.  Required Permissions: To use this action,
an IAM user must have a Manage permissions level for the stack, or an attached policy that
explicitly grants permissions. For more information on user permissions, see Managing User
Permissions.

# Arguments
- `db_password`: The database password.
- `db_user`: The database's master user name.
- `rds_db_instance_arn`: The Amazon RDS instance's ARN.
- `stack_id`: The stack ID.

"""
function register_rds_db_instance(
    DbPassword,
    DbUser,
    RdsDbInstanceArn,
    StackId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworks(
        "RegisterRdsDbInstance",
        Dict{String,Any}(
            "DbPassword" => DbPassword,
            "DbUser" => DbUser,
            "RdsDbInstanceArn" => RdsDbInstanceArn,
            "StackId" => StackId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function register_rds_db_instance(
    DbPassword,
    DbUser,
    RdsDbInstanceArn,
    StackId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworks(
        "RegisterRdsDbInstance",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DbPassword" => DbPassword,
                    "DbUser" => DbUser,
                    "RdsDbInstanceArn" => RdsDbInstanceArn,
                    "StackId" => StackId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    register_volume(stack_id)
    register_volume(stack_id, params::Dict{String,<:Any})

Registers an Amazon EBS volume with a specified stack. A volume can be registered with only
one stack at a time. If the volume is already registered, you must first deregister it by
calling DeregisterVolume. For more information, see Resource Management.  Required
Permissions: To use this action, an IAM user must have a Manage permissions level for the
stack, or an attached policy that explicitly grants permissions. For more information on
user permissions, see Managing User Permissions.

# Arguments
- `stack_id`: The stack ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Ec2VolumeId"`: The Amazon EBS volume ID.
"""
function register_volume(StackId; aws_config::AbstractAWSConfig=current_aws_config())
    return opsworks(
        "RegisterVolume",
        Dict{String,Any}("StackId" => StackId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function register_volume(
    StackId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworks(
        "RegisterVolume",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("StackId" => StackId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    set_load_based_auto_scaling(layer_id)
    set_load_based_auto_scaling(layer_id, params::Dict{String,<:Any})

Specify the load-based auto scaling configuration for a specified layer. For more
information, see Managing Load with Time-based and Load-based Instances.  To use load-based
auto scaling, you must create a set of load-based auto scaling instances. Load-based auto
scaling operates only on the instances from that set, so you must ensure that you have
created enough instances to handle the maximum anticipated load.   Required Permissions: To
use this action, an IAM user must have a Manage permissions level for the stack, or an
attached policy that explicitly grants permissions. For more information on user
permissions, see Managing User Permissions.

# Arguments
- `layer_id`: The layer ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DownScaling"`: An AutoScalingThresholds object with the downscaling threshold
  configuration. If the load falls below these thresholds for a specified amount of time,
  OpsWorks Stacks stops a specified number of instances.
- `"Enable"`: Enables load-based auto scaling for the layer.
- `"UpScaling"`: An AutoScalingThresholds object with the upscaling threshold
  configuration. If the load exceeds these thresholds for a specified amount of time,
  OpsWorks Stacks starts a specified number of instances.
"""
function set_load_based_auto_scaling(
    LayerId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opsworks(
        "SetLoadBasedAutoScaling",
        Dict{String,Any}("LayerId" => LayerId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function set_load_based_auto_scaling(
    LayerId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworks(
        "SetLoadBasedAutoScaling",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("LayerId" => LayerId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    set_permission(iam_user_arn, stack_id)
    set_permission(iam_user_arn, stack_id, params::Dict{String,<:Any})

Specifies a user's permissions. For more information, see Security and Permissions.
Required Permissions: To use this action, an IAM user must have a Manage permissions level
for the stack, or an attached policy that explicitly grants permissions. For more
information on user permissions, see Managing User Permissions.

# Arguments
- `iam_user_arn`: The user's IAM ARN. This can also be a federated user's ARN.
- `stack_id`: The stack ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AllowSsh"`: The user is allowed to use SSH to communicate with the instance.
- `"AllowSudo"`: The user is allowed to use sudo to elevate privileges.
- `"Level"`: The user's permission level, which must be set to one of the following
  strings. You cannot set your own permissions level.    deny     show     deploy     manage
     iam_only    For more information about the permissions associated with these levels, see
  Managing User Permissions.
"""
function set_permission(
    IamUserArn, StackId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opsworks(
        "SetPermission",
        Dict{String,Any}("IamUserArn" => IamUserArn, "StackId" => StackId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function set_permission(
    IamUserArn,
    StackId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworks(
        "SetPermission",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("IamUserArn" => IamUserArn, "StackId" => StackId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    set_time_based_auto_scaling(instance_id)
    set_time_based_auto_scaling(instance_id, params::Dict{String,<:Any})

Specify the time-based auto scaling configuration for a specified instance. For more
information, see Managing Load with Time-based and Load-based Instances.  Required
Permissions: To use this action, an IAM user must have a Manage permissions level for the
stack, or an attached policy that explicitly grants permissions. For more information on
user permissions, see Managing User Permissions.

# Arguments
- `instance_id`: The instance ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AutoScalingSchedule"`: An AutoScalingSchedule with the instance schedule.
"""
function set_time_based_auto_scaling(
    InstanceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opsworks(
        "SetTimeBasedAutoScaling",
        Dict{String,Any}("InstanceId" => InstanceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function set_time_based_auto_scaling(
    InstanceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworks(
        "SetTimeBasedAutoScaling",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("InstanceId" => InstanceId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_instance(instance_id)
    start_instance(instance_id, params::Dict{String,<:Any})

Starts a specified instance. For more information, see Starting, Stopping, and Rebooting
Instances.  Required Permissions: To use this action, an IAM user must have a Manage
permissions level for the stack, or an attached policy that explicitly grants permissions.
For more information on user permissions, see Managing User Permissions.

# Arguments
- `instance_id`: The instance ID.

"""
function start_instance(InstanceId; aws_config::AbstractAWSConfig=current_aws_config())
    return opsworks(
        "StartInstance",
        Dict{String,Any}("InstanceId" => InstanceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_instance(
    InstanceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworks(
        "StartInstance",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("InstanceId" => InstanceId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_stack(stack_id)
    start_stack(stack_id, params::Dict{String,<:Any})

Starts a stack's instances.  Required Permissions: To use this action, an IAM user must
have a Manage permissions level for the stack, or an attached policy that explicitly grants
permissions. For more information on user permissions, see Managing User Permissions.

# Arguments
- `stack_id`: The stack ID.

"""
function start_stack(StackId; aws_config::AbstractAWSConfig=current_aws_config())
    return opsworks(
        "StartStack",
        Dict{String,Any}("StackId" => StackId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_stack(
    StackId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworks(
        "StartStack",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("StackId" => StackId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_instance(instance_id)
    stop_instance(instance_id, params::Dict{String,<:Any})

Stops a specified instance. When you stop a standard instance, the data disappears and must
be reinstalled when you restart the instance. You can stop an Amazon EBS-backed instance
without losing data. For more information, see Starting, Stopping, and Rebooting Instances.
 Required Permissions: To use this action, an IAM user must have a Manage permissions level
for the stack, or an attached policy that explicitly grants permissions. For more
information on user permissions, see Managing User Permissions.

# Arguments
- `instance_id`: The instance ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Force"`: Specifies whether to force an instance to stop. If the instance's root device
  type is ebs, or EBS-backed, adding the Force parameter to the StopInstances API call
  disassociates the OpsWorks Stacks instance from EC2, and forces deletion of only the
  OpsWorks Stacks instance. You must also delete the formerly-associated instance in EC2
  after troubleshooting and replacing the OpsWorks Stacks instance with a new one.
"""
function stop_instance(InstanceId; aws_config::AbstractAWSConfig=current_aws_config())
    return opsworks(
        "StopInstance",
        Dict{String,Any}("InstanceId" => InstanceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_instance(
    InstanceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworks(
        "StopInstance",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("InstanceId" => InstanceId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_stack(stack_id)
    stop_stack(stack_id, params::Dict{String,<:Any})

Stops a specified stack.  Required Permissions: To use this action, an IAM user must have a
Manage permissions level for the stack, or an attached policy that explicitly grants
permissions. For more information on user permissions, see Managing User Permissions.

# Arguments
- `stack_id`: The stack ID.

"""
function stop_stack(StackId; aws_config::AbstractAWSConfig=current_aws_config())
    return opsworks(
        "StopStack",
        Dict{String,Any}("StackId" => StackId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_stack(
    StackId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworks(
        "StopStack",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("StackId" => StackId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Apply cost-allocation tags to a specified stack or layer in OpsWorks Stacks. For more
information about how tagging works, see Tags in the OpsWorks User Guide.

# Arguments
- `resource_arn`: The stack or layer's Amazon Resource Number (ARN).
- `tags`: A map that contains tag keys and tag values that are attached to a stack or
  layer.   The key cannot be empty.   The key can be a maximum of 127 characters, and can
  contain only Unicode letters, numbers, or separators, or the following special characters:
  + - = . _ : /    The value can be a maximum 255 characters, and contain only Unicode
  letters, numbers, or separators, or the following special characters: + - = . _ : /
  Leading and trailing white spaces are trimmed from both the key and value.   A maximum of
  40 tags is allowed for any resource.

"""
function tag_resource(ResourceArn, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return opsworks(
        "TagResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceArn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworks(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    unassign_instance(instance_id)
    unassign_instance(instance_id, params::Dict{String,<:Any})

Unassigns a registered instance from all layers that are using the instance. The instance
remains in the stack as an unassigned instance, and can be assigned to another layer as
needed. You cannot use this action with instances that were created with OpsWorks Stacks.
Required Permissions: To use this action, an IAM user must have a Manage permissions level
for the stack or an attached policy that explicitly grants permissions. For more
information about user permissions, see Managing User Permissions.

# Arguments
- `instance_id`: The instance ID.

"""
function unassign_instance(InstanceId; aws_config::AbstractAWSConfig=current_aws_config())
    return opsworks(
        "UnassignInstance",
        Dict{String,Any}("InstanceId" => InstanceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function unassign_instance(
    InstanceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworks(
        "UnassignInstance",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("InstanceId" => InstanceId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    unassign_volume(volume_id)
    unassign_volume(volume_id, params::Dict{String,<:Any})

Unassigns an assigned Amazon EBS volume. The volume remains registered with the stack. For
more information, see Resource Management.  Required Permissions: To use this action, an
IAM user must have a Manage permissions level for the stack, or an attached policy that
explicitly grants permissions. For more information on user permissions, see Managing User
Permissions.

# Arguments
- `volume_id`: The volume ID.

"""
function unassign_volume(VolumeId; aws_config::AbstractAWSConfig=current_aws_config())
    return opsworks(
        "UnassignVolume",
        Dict{String,Any}("VolumeId" => VolumeId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function unassign_volume(
    VolumeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworks(
        "UnassignVolume",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("VolumeId" => VolumeId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes tags from a specified stack or layer.

# Arguments
- `resource_arn`: The stack or layer's Amazon Resource Number (ARN).
- `tag_keys`: A list of the keys of tags to be removed from a stack or layer.

"""
function untag_resource(
    ResourceArn, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opsworks(
        "UntagResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceArn,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworks(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_app(app_id)
    update_app(app_id, params::Dict{String,<:Any})

Updates a specified app.  Required Permissions: To use this action, an IAM user must have a
Deploy or Manage permissions level for the stack, or an attached policy that explicitly
grants permissions. For more information on user permissions, see Managing User Permissions.

# Arguments
- `app_id`: The app ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AppSource"`: A Source object that specifies the app repository.
- `"Attributes"`: One or more user-defined key/value pairs to be added to the stack
  attributes.
- `"DataSources"`: The app's data sources.
- `"Description"`: A description of the app.
- `"Domains"`: The app's virtual host settings, with multiple domains separated by commas.
  For example: 'www.example.com, example.com'
- `"EnableSsl"`: Whether SSL is enabled for the app.
- `"Environment"`: An array of EnvironmentVariable objects that specify environment
  variables to be associated with the app. After you deploy the app, these variables are
  defined on the associated app server instances.For more information, see  Environment
  Variables. There is no specific limit on the number of environment variables. However, the
  size of the associated data structure - which includes the variables' names, values, and
  protected flag values - cannot exceed 20 KB. This limit should accommodate most if not all
  use cases. Exceeding it will cause an exception with the message, \"Environment: is too
  large (maximum is 20 KB).\"  If you have specified one or more environment variables, you
  cannot modify the stack's Chef version.
- `"Name"`: The app name.
- `"SslConfiguration"`: An SslConfiguration object with the SSL configuration.
- `"Type"`: The app type.
"""
function update_app(AppId; aws_config::AbstractAWSConfig=current_aws_config())
    return opsworks(
        "UpdateApp",
        Dict{String,Any}("AppId" => AppId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_app(
    AppId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opsworks(
        "UpdateApp",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("AppId" => AppId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_elastic_ip(elastic_ip)
    update_elastic_ip(elastic_ip, params::Dict{String,<:Any})

Updates a registered Elastic IP address's name. For more information, see Resource
Management.  Required Permissions: To use this action, an IAM user must have a Manage
permissions level for the stack, or an attached policy that explicitly grants permissions.
For more information on user permissions, see Managing User Permissions.

# Arguments
- `elastic_ip`: The IP address for which you want to update the name.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Name"`: The new name, which can be a maximum of 32 characters.
"""
function update_elastic_ip(ElasticIp; aws_config::AbstractAWSConfig=current_aws_config())
    return opsworks(
        "UpdateElasticIp",
        Dict{String,Any}("ElasticIp" => ElasticIp);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_elastic_ip(
    ElasticIp,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworks(
        "UpdateElasticIp",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ElasticIp" => ElasticIp), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_instance(instance_id)
    update_instance(instance_id, params::Dict{String,<:Any})

Updates a specified instance.  Required Permissions: To use this action, an IAM user must
have a Manage permissions level for the stack, or an attached policy that explicitly grants
permissions. For more information on user permissions, see Managing User Permissions.

# Arguments
- `instance_id`: The instance ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AgentVersion"`: The default OpsWorks Stacks agent version. You have the following
  options:    INHERIT - Use the stack's default agent version setting.    version_number -
  Use the specified agent version. This value overrides the stack's default setting. To
  update the agent version, you must edit the instance configuration and specify a new
  version. OpsWorks Stacks installs that version on the instance.   The default setting is
  INHERIT. To specify an agent version, you must use the complete version number, not the
  abbreviated number shown on the console. For a list of available agent version numbers,
  call DescribeAgentVersions. AgentVersion cannot be set to Chef 12.2.
- `"AmiId"`: The ID of the AMI that was used to create the instance. The value of this
  parameter must be the same AMI ID that the instance is already using. You cannot apply a
  new AMI to an instance by running UpdateInstance. UpdateInstance does not work on instances
  that are using custom AMIs.
- `"Architecture"`: The instance architecture. Instance types do not necessarily support
  both architectures. For a list of the architectures that are supported by the different
  instance types, see Instance Families and Types.
- `"AutoScalingType"`: For load-based or time-based instances, the type. Windows stacks can
  use only time-based instances.
- `"EbsOptimized"`: This property cannot be updated.
- `"Hostname"`: The instance host name. The following are character limits for instance
  host names.   Linux-based instances: 63 characters   Windows-based instances: 15 characters
  
- `"InstallUpdatesOnBoot"`: Whether to install operating system and package updates when
  the instance boots. The default value is true. To control when updates are installed, set
  this value to false. You must then update your instances manually by using CreateDeployment
  to run the update_dependencies stack command or by manually running yum (Amazon Linux) or
  apt-get (Ubuntu) on the instances.   We strongly recommend using the default value of true,
  to ensure that your instances have the latest security updates.
- `"InstanceType"`: The instance type, such as t2.micro. For a list of supported instance
  types, open the stack in the console, choose Instances, and choose + Instance. The Size
  list contains the currently supported types. For more information, see Instance Families
  and Types. The parameter values that you use to specify the various types are in the API
  Name column of the Available Instance Types table.
- `"LayerIds"`: The instance's layer IDs.
- `"Os"`: The instance's operating system, which must be set to one of the following. You
  cannot update an instance that is using a custom AMI.   A supported Linux operating system:
  An Amazon Linux version, such as Amazon Linux 2, Amazon Linux 2018.03, Amazon Linux
  2017.09, Amazon Linux 2017.03, Amazon Linux 2016.09, Amazon Linux 2016.03, Amazon Linux
  2015.09, or Amazon Linux 2015.03.   A supported Ubuntu operating system, such as Ubuntu
  18.04 LTS, Ubuntu 16.04 LTS, Ubuntu 14.04 LTS, or Ubuntu 12.04 LTS.    CentOS Linux 7
  Red Hat Enterprise Linux 7    A supported Windows operating system, such as Microsoft
  Windows Server 2012 R2 Base, Microsoft Windows Server 2012 R2 with SQL Server Express,
  Microsoft Windows Server 2012 R2 with SQL Server Standard, or Microsoft Windows Server 2012
  R2 with SQL Server Web.   Not all operating systems are supported with all versions of
  Chef. For more information about supported operating systems, see OpsWorks Stacks Operating
  Systems. The default option is the current Amazon Linux version. If you set this parameter
  to Custom, you must use the AmiId parameter to specify the custom AMI that you want to use.
  For more information about how to use custom AMIs with OpsWorks, see Using Custom AMIs.
  You can specify a different Linux operating system for the updated stack, but you cannot
  change from Linux to Windows or Windows to Linux.
- `"SshKeyName"`: The instance's Amazon EC2 key name.
"""
function update_instance(InstanceId; aws_config::AbstractAWSConfig=current_aws_config())
    return opsworks(
        "UpdateInstance",
        Dict{String,Any}("InstanceId" => InstanceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_instance(
    InstanceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworks(
        "UpdateInstance",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("InstanceId" => InstanceId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_layer(layer_id)
    update_layer(layer_id, params::Dict{String,<:Any})

Updates a specified layer.  Required Permissions: To use this action, an IAM user must have
a Manage permissions level for the stack, or an attached policy that explicitly grants
permissions. For more information on user permissions, see Managing User Permissions.

# Arguments
- `layer_id`: The layer ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Attributes"`: One or more user-defined key/value pairs to be added to the stack
  attributes.
- `"AutoAssignElasticIps"`: Whether to automatically assign an Elastic IP address to the
  layer's instances. For more information, see How to Edit a Layer.
- `"AutoAssignPublicIps"`: For stacks that are running in a VPC, whether to automatically
  assign a public IP address to the layer's instances. For more information, see How to Edit
  a Layer.
- `"CloudWatchLogsConfiguration"`: Specifies CloudWatch Logs configuration options for the
  layer. For more information, see CloudWatchLogsLogStream.
- `"CustomInstanceProfileArn"`: The ARN of an IAM profile to be used for all of the layer's
  EC2 instances. For more information about IAM ARNs, see Using Identifiers.
- `"CustomJson"`: A JSON-formatted string containing custom stack configuration and
  deployment attributes to be installed on the layer's instances. For more information, see
  Using Custom JSON.
- `"CustomRecipes"`: A LayerCustomRecipes object that specifies the layer's custom recipes.
- `"CustomSecurityGroupIds"`: An array containing the layer's custom security group IDs.
- `"EnableAutoHealing"`: Whether to disable auto healing for the layer.
- `"InstallUpdatesOnBoot"`: Whether to install operating system and package updates when
  the instance boots. The default value is true. To control when updates are installed, set
  this value to false. You must then update your instances manually by using CreateDeployment
  to run the update_dependencies stack command or manually running yum (Amazon Linux) or
  apt-get (Ubuntu) on the instances.   We strongly recommend using the default value of true,
  to ensure that your instances have the latest security updates.
- `"LifecycleEventConfiguration"`:
- `"Name"`: The layer name, which is used by the console. Layer names can be a maximum of
  32 characters.
- `"Packages"`: An array of Package objects that describe the layer's packages.
- `"Shortname"`: For custom layers only, use this parameter to specify the layer's short
  name, which is used internally by OpsWorks Stacks and by Chef. The short name is also used
  as the name for the directory where your app files are installed. It can have a maximum of
  32 characters and must be in the following format: /A[a-z0-9-_.]+Z/. Built-in layer short
  names are defined by OpsWorks Stacks. For more information, see the Layer reference in the
  OpsWorks User Guide.
- `"UseEbsOptimizedInstances"`: Whether to use Amazon EBS-optimized instances.
- `"VolumeConfigurations"`: A VolumeConfigurations object that describes the layer's Amazon
  EBS volumes.
"""
function update_layer(LayerId; aws_config::AbstractAWSConfig=current_aws_config())
    return opsworks(
        "UpdateLayer",
        Dict{String,Any}("LayerId" => LayerId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_layer(
    LayerId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworks(
        "UpdateLayer",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("LayerId" => LayerId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_my_user_profile()
    update_my_user_profile(params::Dict{String,<:Any})

Updates a user's SSH public key.  Required Permissions: To use this action, an IAM user
must have self-management enabled or an attached policy that explicitly grants permissions.
For more information about user permissions, see Managing User Permissions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"SshPublicKey"`: The user's SSH public key.
"""
function update_my_user_profile(; aws_config::AbstractAWSConfig=current_aws_config())
    return opsworks(
        "UpdateMyUserProfile"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function update_my_user_profile(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opsworks(
        "UpdateMyUserProfile",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_rds_db_instance(rds_db_instance_arn)
    update_rds_db_instance(rds_db_instance_arn, params::Dict{String,<:Any})

Updates an Amazon RDS instance.  Required Permissions: To use this action, an IAM user must
have a Manage permissions level for the stack, or an attached policy that explicitly grants
permissions. For more information on user permissions, see Managing User Permissions.

# Arguments
- `rds_db_instance_arn`: The Amazon RDS instance's ARN.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DbPassword"`: The database password.
- `"DbUser"`: The master user name.
"""
function update_rds_db_instance(
    RdsDbInstanceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return opsworks(
        "UpdateRdsDbInstance",
        Dict{String,Any}("RdsDbInstanceArn" => RdsDbInstanceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_rds_db_instance(
    RdsDbInstanceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworks(
        "UpdateRdsDbInstance",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("RdsDbInstanceArn" => RdsDbInstanceArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_stack(stack_id)
    update_stack(stack_id, params::Dict{String,<:Any})

Updates a specified stack.  Required Permissions: To use this action, an IAM user must have
a Manage permissions level for the stack, or an attached policy that explicitly grants
permissions. For more information on user permissions, see Managing User Permissions.

# Arguments
- `stack_id`: The stack ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AgentVersion"`: The default OpsWorks Stacks agent version. You have the following
  options:   Auto-update - Set this parameter to LATEST. OpsWorks Stacks automatically
  installs new agent versions on the stack's instances as soon as they are available.   Fixed
  version - Set this parameter to your preferred agent version. To update the agent version,
  you must edit the stack configuration and specify a new version. OpsWorks Stacks installs
  that version on the stack's instances.   The default setting is LATEST. To specify an agent
  version, you must use the complete version number, not the abbreviated number shown on the
  console. For a list of available agent version numbers, call DescribeAgentVersions.
  AgentVersion cannot be set to Chef 12.2.  You can also specify an agent version when you
  create or update an instance, which overrides the stack's default setting.
- `"Attributes"`: One or more user-defined key-value pairs to be added to the stack
  attributes.
- `"ChefConfiguration"`: A ChefConfiguration object that specifies whether to enable
  Berkshelf and the Berkshelf version on Chef 11.10 stacks. For more information, see Create
  a New Stack.
- `"ConfigurationManager"`: The configuration manager. When you update a stack, we
  recommend that you use the configuration manager to specify the Chef version: 12, 11.10, or
  11.4 for Linux stacks, or 12.2 for Windows stacks. The default value for Linux stacks is
  currently 12.
- `"CustomCookbooksSource"`: Contains the information required to retrieve an app or
  cookbook from a repository. For more information, see Adding Apps or Cookbooks and Recipes.
- `"CustomJson"`: A string that contains user-defined, custom JSON. It can be used to
  override the corresponding default stack configuration JSON values or to pass data to
  recipes. The string should be in the following format:  \"{\"key1\": \"value1\", \"key2\":
  \"value2\",...}\"  For more information about custom JSON, see Use Custom JSON to Modify
  the Stack Configuration Attributes.
- `"DefaultAvailabilityZone"`: The stack's default Availability Zone, which must be in the
  stack's region. For more information, see Regions and Endpoints. If you also specify a
  value for DefaultSubnetId, the subnet must be in the same zone. For more information, see
  CreateStack.
- `"DefaultInstanceProfileArn"`: The ARN of an IAM profile that is the default profile for
  all of the stack's EC2 instances. For more information about IAM ARNs, see Using
  Identifiers.
- `"DefaultOs"`: The stack's operating system, which must be set to one of the following:
  A supported Linux operating system: An Amazon Linux version, such as Amazon Linux 2, Amazon
  Linux 2018.03, Amazon Linux 2017.09, Amazon Linux 2017.03, Amazon Linux 2016.09, Amazon
  Linux 2016.03, Amazon Linux 2015.09, or Amazon Linux 2015.03.   A supported Ubuntu
  operating system, such as Ubuntu 18.04 LTS, Ubuntu 16.04 LTS, Ubuntu 14.04 LTS, or Ubuntu
  12.04 LTS.    CentOS Linux 7     Red Hat Enterprise Linux 7    A supported Windows
  operating system, such as Microsoft Windows Server 2012 R2 Base, Microsoft Windows Server
  2012 R2 with SQL Server Express, Microsoft Windows Server 2012 R2 with SQL Server Standard,
  or Microsoft Windows Server 2012 R2 with SQL Server Web.   A custom AMI: Custom. You
  specify the custom AMI you want to use when you create instances. For more information
  about how to use custom AMIs with OpsWorks, see Using Custom AMIs.   The default option is
  the stack's current operating system. Not all operating systems are supported with all
  versions of Chef. For more information about supported operating systems, see OpsWorks
  Stacks Operating Systems.
- `"DefaultRootDeviceType"`: The default root device type. This value is used by default
  for all instances in the stack, but you can override it when you create an instance. For
  more information, see Storage for the Root Device.
- `"DefaultSshKeyName"`: A default Amazon EC2 key-pair name. The default value is none. If
  you specify a key-pair name, OpsWorks Stacks installs the public key on the instance and
  you can use the private key with an SSH client to log in to the instance. For more
  information, see  Using SSH to Communicate with an Instance and  Managing SSH Access. You
  can override this setting by specifying a different key pair, or no key pair, when you
  create an instance.
- `"DefaultSubnetId"`: The stack's default VPC subnet ID. This parameter is required if you
  specify a value for the VpcId parameter. All instances are launched into this subnet unless
  you specify otherwise when you create the instance. If you also specify a value for
  DefaultAvailabilityZone, the subnet must be in that zone. For information on default values
  and when this parameter is required, see the VpcId parameter description.
- `"HostnameTheme"`: The stack's new host name theme, with spaces replaced by underscores.
  The theme is used to generate host names for the stack's instances. By default,
  HostnameTheme is set to Layer_Dependent, which creates host names by appending integers to
  the layer's short name. The other themes are:    Baked_Goods     Clouds     Europe_Cities
    Fruits     Greek_Deities_and_Titans     Legendary_creatures_from_Japan
  Planets_and_Moons     Roman_Deities     Scottish_Islands     US_Cities     Wild_Cats    To
  obtain a generated host name, call GetHostNameSuggestion, which returns a host name based
  on the current theme.
- `"Name"`: The stack's new name. Stack names can be a maximum of 64 characters.
- `"ServiceRoleArn"`: Do not use this parameter. You cannot update a stack's service role.
- `"UseCustomCookbooks"`: Whether the stack uses custom cookbooks.
- `"UseOpsworksSecurityGroups"`: Whether to associate the OpsWorks Stacks built-in security
  groups with the stack's layers. OpsWorks Stacks provides a standard set of built-in
  security groups, one for each layer, which are associated with layers by default.
  UseOpsworksSecurityGroups allows you to provide your own custom security groups instead of
  using the built-in groups. UseOpsworksSecurityGroups has the following settings:    True -
  OpsWorks Stacks automatically associates the appropriate built-in security group with each
  layer (default setting). You can associate additional security groups with a layer after
  you create it, but you cannot delete the built-in security group.   False - OpsWorks Stacks
  does not associate built-in security groups with layers. You must create appropriate EC2
  security groups and associate a security group with each layer that you create. However,
  you can still manually associate a built-in security group with a layer on. Custom security
  groups are required only for those layers that need custom settings.   For more
  information, see Create a New Stack.
"""
function update_stack(StackId; aws_config::AbstractAWSConfig=current_aws_config())
    return opsworks(
        "UpdateStack",
        Dict{String,Any}("StackId" => StackId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_stack(
    StackId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworks(
        "UpdateStack",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("StackId" => StackId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_user_profile(iam_user_arn)
    update_user_profile(iam_user_arn, params::Dict{String,<:Any})

Updates a specified user profile.  Required Permissions: To use this action, an IAM user
must have an attached policy that explicitly grants permissions. For more information about
user permissions, see Managing User Permissions.

# Arguments
- `iam_user_arn`: The user IAM ARN. This can also be a federated user's ARN.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AllowSelfManagement"`: Whether users can specify their own SSH public key through the
  My Settings page. For more information, see Managing User Permissions.
- `"SshPublicKey"`: The user's new SSH public key.
- `"SshUsername"`: The user's SSH user name. The allowable characters are [a-z], [A-Z],
  [0-9], '-', and '_'. If the specified name includes other punctuation marks, OpsWorks
  Stacks removes them. For example, my.name will be changed to myname. If you do not specify
  an SSH user name, OpsWorks Stacks generates one from the IAM user name.
"""
function update_user_profile(IamUserArn; aws_config::AbstractAWSConfig=current_aws_config())
    return opsworks(
        "UpdateUserProfile",
        Dict{String,Any}("IamUserArn" => IamUserArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_user_profile(
    IamUserArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworks(
        "UpdateUserProfile",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("IamUserArn" => IamUserArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_volume(volume_id)
    update_volume(volume_id, params::Dict{String,<:Any})

Updates an Amazon EBS volume's name or mount point. For more information, see Resource
Management.  Required Permissions: To use this action, an IAM user must have a Manage
permissions level for the stack, or an attached policy that explicitly grants permissions.
For more information on user permissions, see Managing User Permissions.

# Arguments
- `volume_id`: The volume ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MountPoint"`: The new mount point.
- `"Name"`: The new name. Volume names can be a maximum of 128 characters.
"""
function update_volume(VolumeId; aws_config::AbstractAWSConfig=current_aws_config())
    return opsworks(
        "UpdateVolume",
        Dict{String,Any}("VolumeId" => VolumeId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_volume(
    VolumeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return opsworks(
        "UpdateVolume",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("VolumeId" => VolumeId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: appflow
using AWS.Compat
using AWS.UUIDs

"""
    cancel_flow_executions(flow_name)
    cancel_flow_executions(flow_name, params::Dict{String,<:Any})

Cancels active runs for a flow. You can cancel all of the active runs for a flow, or you
can cancel specific runs by providing their IDs. You can cancel a flow run only when the
run is in progress. You can't cancel a run that has already completed or failed. You also
can't cancel a run that's scheduled to occur but hasn't started yet. To prevent a scheduled
run, you can deactivate the flow with the StopFlow action. You cannot resume a run after
you cancel it. When you send your request, the status for each run becomes CancelStarted.
When the cancellation completes, the status becomes Canceled.  When you cancel a run, you
still incur charges for any data that the run already processed before the cancellation. If
the run had already written some data to the flow destination, then that data remains in
the destination. If you configured the flow to use a batch API (such as the Salesforce Bulk
API 2.0), then the run will finish reading or writing its entire batch of data after the
cancellation. For these operations, the data processing charges for Amazon AppFlow apply.
For the pricing information, see Amazon AppFlow pricing.

# Arguments
- `flow_name`: The name of a flow with active runs that you want to cancel.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"executionIds"`: The ID of each active run to cancel. These runs must belong to the flow
  you specify in your request. If you omit this parameter, your request ends all active runs
  that belong to the flow.
"""
function cancel_flow_executions(
    flowName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appflow(
        "POST",
        "/cancel-flow-executions",
        Dict{String,Any}("flowName" => flowName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_flow_executions(
    flowName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appflow(
        "POST",
        "/cancel-flow-executions",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("flowName" => flowName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_connector_profile(connection_mode, connector_profile_config, connector_profile_name, connector_type)
    create_connector_profile(connection_mode, connector_profile_config, connector_profile_name, connector_type, params::Dict{String,<:Any})

 Creates a new connector profile associated with your Amazon Web Services account. There is
a soft quota of 100 connector profiles per Amazon Web Services account. If you need more
connector profiles than this quota allows, you can submit a request to the Amazon AppFlow
team through the Amazon AppFlow support channel. In each connector profile that you create,
you can provide the credentials and properties for only one connector.

# Arguments
- `connection_mode`:  Indicates the connection mode and specifies whether it is public or
  private. Private flows use Amazon Web Services PrivateLink to route data over Amazon Web
  Services infrastructure without exposing it to the public internet.
- `connector_profile_config`:  Defines the connector-specific configuration and
  credentials.
- `connector_profile_name`:  The name of the connector profile. The name is unique for each
  ConnectorProfile in your Amazon Web Services account.
- `connector_type`:  The type of connector, such as Salesforce, Amplitude, and so on.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: The clientToken parameter is an idempotency token. It ensures that your
  CreateConnectorProfile request completes only once. You choose the value to pass. For
  example, if you don't receive a response from your request, you can safely retry the
  request with the same clientToken parameter value. If you omit a clientToken value, the
  Amazon Web Services SDK that you are using inserts a value for you. This way, the SDK can
  safely retry requests multiple times after a network error. You must provide your own value
  for other use cases. If you specify input parameters that differ from your first request,
  an error occurs. If you use a different value for clientToken, Amazon AppFlow considers it
  a new call to CreateConnectorProfile. The token is active for 8 hours.
- `"connectorLabel"`: The label of the connector. The label is unique for each
  ConnectorRegistration in your Amazon Web Services account. Only needed if calling for
  CUSTOMCONNECTOR connector type/.
- `"kmsArn"`:  The ARN (Amazon Resource Name) of the Key Management Service (KMS) key you
  provide for encryption. This is required if you do not want to use the Amazon
  AppFlow-managed KMS key. If you don't provide anything here, Amazon AppFlow uses the Amazon
  AppFlow-managed KMS key.
"""
function create_connector_profile(
    connectionMode,
    connectorProfileConfig,
    connectorProfileName,
    connectorType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appflow(
        "POST",
        "/create-connector-profile",
        Dict{String,Any}(
            "connectionMode" => connectionMode,
            "connectorProfileConfig" => connectorProfileConfig,
            "connectorProfileName" => connectorProfileName,
            "connectorType" => connectorType,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_connector_profile(
    connectionMode,
    connectorProfileConfig,
    connectorProfileName,
    connectorType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appflow(
        "POST",
        "/create-connector-profile",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "connectionMode" => connectionMode,
                    "connectorProfileConfig" => connectorProfileConfig,
                    "connectorProfileName" => connectorProfileName,
                    "connectorType" => connectorType,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_flow(destination_flow_config_list, flow_name, source_flow_config, tasks, trigger_config)
    create_flow(destination_flow_config_list, flow_name, source_flow_config, tasks, trigger_config, params::Dict{String,<:Any})

 Enables your application to create a new flow using Amazon AppFlow. You must create a
connector profile before calling this API. Please note that the Request Syntax below shows
syntax for multiple destinations, however, you can only transfer data to one item in this
list at a time. Amazon AppFlow does not currently support flows to multiple destinations at
once.

# Arguments
- `destination_flow_config_list`:  The configuration that controls how Amazon AppFlow
  places data in the destination connector.
- `flow_name`:  The specified name of the flow. Spaces are not allowed. Use underscores (_)
  or hyphens (-) only.
- `source_flow_config`:  The configuration that controls how Amazon AppFlow retrieves data
  from the source connector.
- `tasks`:  A list of tasks that Amazon AppFlow performs while transferring the data in the
  flow run.
- `trigger_config`:  The trigger settings that determine how and when the flow runs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: The clientToken parameter is an idempotency token. It ensures that your
  CreateFlow request completes only once. You choose the value to pass. For example, if you
  don't receive a response from your request, you can safely retry the request with the same
  clientToken parameter value. If you omit a clientToken value, the Amazon Web Services SDK
  that you are using inserts a value for you. This way, the SDK can safely retry requests
  multiple times after a network error. You must provide your own value for other use cases.
  If you specify input parameters that differ from your first request, an error occurs. If
  you use a different value for clientToken, Amazon AppFlow considers it a new call to
  CreateFlow. The token is active for 8 hours.
- `"description"`:  A description of the flow you want to create.
- `"kmsArn"`:  The ARN (Amazon Resource Name) of the Key Management Service (KMS) key you
  provide for encryption. This is required if you do not want to use the Amazon
  AppFlow-managed KMS key. If you don't provide anything here, Amazon AppFlow uses the Amazon
  AppFlow-managed KMS key.
- `"metadataCatalogConfig"`: Specifies the configuration that Amazon AppFlow uses when it
  catalogs the data that's transferred by the associated flow. When Amazon AppFlow catalogs
  the data from a flow, it stores metadata in a data catalog.
- `"tags"`:  The tags used to organize, track, or control access for your flow.
"""
function create_flow(
    destinationFlowConfigList,
    flowName,
    sourceFlowConfig,
    tasks,
    triggerConfig;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appflow(
        "POST",
        "/create-flow",
        Dict{String,Any}(
            "destinationFlowConfigList" => destinationFlowConfigList,
            "flowName" => flowName,
            "sourceFlowConfig" => sourceFlowConfig,
            "tasks" => tasks,
            "triggerConfig" => triggerConfig,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_flow(
    destinationFlowConfigList,
    flowName,
    sourceFlowConfig,
    tasks,
    triggerConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appflow(
        "POST",
        "/create-flow",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "destinationFlowConfigList" => destinationFlowConfigList,
                    "flowName" => flowName,
                    "sourceFlowConfig" => sourceFlowConfig,
                    "tasks" => tasks,
                    "triggerConfig" => triggerConfig,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_connector_profile(connector_profile_name)
    delete_connector_profile(connector_profile_name, params::Dict{String,<:Any})

 Enables you to delete an existing connector profile.

# Arguments
- `connector_profile_name`:  The name of the connector profile. The name is unique for each
  ConnectorProfile in your account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"forceDelete"`:  Indicates whether Amazon AppFlow should delete the profile, even if it
  is currently in use in one or more flows.
"""
function delete_connector_profile(
    connectorProfileName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appflow(
        "POST",
        "/delete-connector-profile",
        Dict{String,Any}("connectorProfileName" => connectorProfileName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_connector_profile(
    connectorProfileName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appflow(
        "POST",
        "/delete-connector-profile",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("connectorProfileName" => connectorProfileName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_flow(flow_name)
    delete_flow(flow_name, params::Dict{String,<:Any})

 Enables your application to delete an existing flow. Before deleting the flow, Amazon
AppFlow validates the request by checking the flow configuration and status. You can delete
flows one at a time.

# Arguments
- `flow_name`:  The specified name of the flow. Spaces are not allowed. Use underscores (_)
  or hyphens (-) only.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"forceDelete"`:  Indicates whether Amazon AppFlow should delete the flow, even if it is
  currently in use.
"""
function delete_flow(flowName; aws_config::AbstractAWSConfig=current_aws_config())
    return appflow(
        "POST",
        "/delete-flow",
        Dict{String,Any}("flowName" => flowName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_flow(
    flowName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appflow(
        "POST",
        "/delete-flow",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("flowName" => flowName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_connector(connector_type)
    describe_connector(connector_type, params::Dict{String,<:Any})

Describes the given custom connector registered in your Amazon Web Services account. This
API can be used for custom connectors that are registered in your account and also for
Amazon authored connectors.

# Arguments
- `connector_type`: The connector type, such as CUSTOMCONNECTOR, Saleforce, Marketo. Please
  choose CUSTOMCONNECTOR for Lambda based custom connectors.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"connectorLabel"`: The label of the connector. The label is unique for each
  ConnectorRegistration in your Amazon Web Services account. Only needed if calling for
  CUSTOMCONNECTOR connector type/.
"""
function describe_connector(
    connectorType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appflow(
        "POST",
        "/describe-connector",
        Dict{String,Any}("connectorType" => connectorType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_connector(
    connectorType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appflow(
        "POST",
        "/describe-connector",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("connectorType" => connectorType), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_connector_entity(connector_entity_name)
    describe_connector_entity(connector_entity_name, params::Dict{String,<:Any})

 Provides details regarding the entity used with the connector, with a description of the
data model for each field in that entity.

# Arguments
- `connector_entity_name`:  The entity name for that connector.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"apiVersion"`: The version of the API that's used by the connector.
- `"connectorProfileName"`:  The name of the connector profile. The name is unique for each
  ConnectorProfile in the Amazon Web Services account.
- `"connectorType"`:  The type of connector application, such as Salesforce, Amplitude, and
  so on.
"""
function describe_connector_entity(
    connectorEntityName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appflow(
        "POST",
        "/describe-connector-entity",
        Dict{String,Any}("connectorEntityName" => connectorEntityName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_connector_entity(
    connectorEntityName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appflow(
        "POST",
        "/describe-connector-entity",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("connectorEntityName" => connectorEntityName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_connector_profiles()
    describe_connector_profiles(params::Dict{String,<:Any})

 Returns a list of connector-profile details matching the provided connector-profile names
and connector-types. Both input lists are optional, and you can use them to filter the
result.  If no names or connector-types are provided, returns all connector profiles in a
paginated form. If there is no match, this operation returns an empty list.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"connectorLabel"`: The name of the connector. The name is unique for each
  ConnectorRegistration in your Amazon Web Services account. Only needed if calling for
  CUSTOMCONNECTOR connector type/.
- `"connectorProfileNames"`:  The name of the connector profile. The name is unique for
  each ConnectorProfile in the Amazon Web Services account.
- `"connectorType"`:  The type of connector, such as Salesforce, Amplitude, and so on.
- `"maxResults"`:  Specifies the maximum number of items that should be returned in the
  result set. The default for maxResults is 20 (for all paginated API operations).
- `"nextToken"`:  The pagination token for the next page of data.
"""
function describe_connector_profiles(; aws_config::AbstractAWSConfig=current_aws_config())
    return appflow(
        "POST",
        "/describe-connector-profiles";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_connector_profiles(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appflow(
        "POST",
        "/describe-connector-profiles",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_connectors()
    describe_connectors(params::Dict{String,<:Any})

 Describes the connectors vended by Amazon AppFlow for specified connector types. If you
don't specify a connector type, this operation describes all connectors vended by Amazon
AppFlow. If there are more connectors than can be returned in one page, the response
contains a nextToken object, which can be be passed in to the next call to the
DescribeConnectors API operation to retrieve the next page.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"connectorTypes"`:  The type of connector, such as Salesforce, Amplitude, and so on.
- `"maxResults"`: The maximum number of items that should be returned in the result set.
  The default is 20.
- `"nextToken"`:  The pagination token for the next page of data.
"""
function describe_connectors(; aws_config::AbstractAWSConfig=current_aws_config())
    return appflow(
        "POST",
        "/describe-connectors";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_connectors(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appflow(
        "POST",
        "/describe-connectors",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_flow(flow_name)
    describe_flow(flow_name, params::Dict{String,<:Any})

 Provides a description of the specified flow.

# Arguments
- `flow_name`:  The specified name of the flow. Spaces are not allowed. Use underscores (_)
  or hyphens (-) only.

"""
function describe_flow(flowName; aws_config::AbstractAWSConfig=current_aws_config())
    return appflow(
        "POST",
        "/describe-flow",
        Dict{String,Any}("flowName" => flowName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_flow(
    flowName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appflow(
        "POST",
        "/describe-flow",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("flowName" => flowName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_flow_execution_records(flow_name)
    describe_flow_execution_records(flow_name, params::Dict{String,<:Any})

 Fetches the execution history of the flow.

# Arguments
- `flow_name`:  The specified name of the flow. Spaces are not allowed. Use underscores (_)
  or hyphens (-) only.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:  Specifies the maximum number of items that should be returned in the
  result set. The default for maxResults is 20 (for all paginated API operations).
- `"nextToken"`:  The pagination token for the next page of data.
"""
function describe_flow_execution_records(
    flowName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appflow(
        "POST",
        "/describe-flow-execution-records",
        Dict{String,Any}("flowName" => flowName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_flow_execution_records(
    flowName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appflow(
        "POST",
        "/describe-flow-execution-records",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("flowName" => flowName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_connector_entities()
    list_connector_entities(params::Dict{String,<:Any})

 Returns the list of available connector entities supported by Amazon AppFlow. For example,
you can query Salesforce for Account and Opportunity entities, or query ServiceNow for the
Incident entity.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"apiVersion"`: The version of the API that's used by the connector.
- `"connectorProfileName"`:  The name of the connector profile. The name is unique for each
  ConnectorProfile in the Amazon Web Services account, and is used to query the downstream
  connector.
- `"connectorType"`:  The type of connector, such as Salesforce, Amplitude, and so on.
- `"entitiesPath"`:  This optional parameter is specific to connector implementation. Some
  connectors support multiple levels or categories of entities. You can find out the list of
  roots for such providers by sending a request without the entitiesPath parameter. If the
  connector supports entities at different roots, this initial request returns the list of
  roots. Otherwise, this request returns all entities supported by the provider.
- `"maxResults"`: The maximum number of items that the operation returns in the response.
- `"nextToken"`: A token that was provided by your prior ListConnectorEntities operation if
  the response was too big for the page size. You specify this token to get the next page of
  results in paginated response.
"""
function list_connector_entities(; aws_config::AbstractAWSConfig=current_aws_config())
    return appflow(
        "POST",
        "/list-connector-entities";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_connector_entities(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appflow(
        "POST",
        "/list-connector-entities",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_connectors()
    list_connectors(params::Dict{String,<:Any})

Returns the list of all registered custom connectors in your Amazon Web Services account.
This API lists only custom connectors registered in this account, not the Amazon Web
Services authored connectors.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Specifies the maximum number of items that should be returned in the
  result set. The default for maxResults is 20 (for all paginated API operations).
- `"nextToken"`: The pagination token for the next page of data.
"""
function list_connectors(; aws_config::AbstractAWSConfig=current_aws_config())
    return appflow(
        "POST", "/list-connectors"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_connectors(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appflow(
        "POST",
        "/list-connectors",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_flows()
    list_flows(params::Dict{String,<:Any})

 Lists all of the flows associated with your account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:  Specifies the maximum number of items that should be returned in the
  result set.
- `"nextToken"`:  The pagination token for next page of data.
"""
function list_flows(; aws_config::AbstractAWSConfig=current_aws_config())
    return appflow(
        "POST", "/list-flows"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_flows(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appflow(
        "POST",
        "/list-flows",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

 Retrieves the tags that are associated with a specified flow.

# Arguments
- `resource_arn`:  The Amazon Resource Name (ARN) of the specified flow.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appflow(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appflow(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    register_connector()
    register_connector(params::Dict{String,<:Any})

Registers a new custom connector with your Amazon Web Services account. Before you can
register the connector, you must deploy the associated AWS lambda function in your account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: The clientToken parameter is an idempotency token. It ensures that your
  RegisterConnector request completes only once. You choose the value to pass. For example,
  if you don't receive a response from your request, you can safely retry the request with
  the same clientToken parameter value. If you omit a clientToken value, the Amazon Web
  Services SDK that you are using inserts a value for you. This way, the SDK can safely retry
  requests multiple times after a network error. You must provide your own value for other
  use cases. If you specify input parameters that differ from your first request, an error
  occurs. If you use a different value for clientToken, Amazon AppFlow considers it a new
  call to RegisterConnector. The token is active for 8 hours.
- `"connectorLabel"`:  The name of the connector. The name is unique for each
  ConnectorRegistration in your Amazon Web Services account.
- `"connectorProvisioningConfig"`: The provisioning type of the connector. Currently the
  only supported value is LAMBDA.
- `"connectorProvisioningType"`: The provisioning type of the connector. Currently the only
  supported value is LAMBDA.
- `"description"`: A description about the connector that's being registered.
"""
function register_connector(; aws_config::AbstractAWSConfig=current_aws_config())
    return appflow(
        "POST",
        "/register-connector",
        Dict{String,Any}("clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function register_connector(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appflow(
        "POST",
        "/register-connector",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    reset_connector_metadata_cache()
    reset_connector_metadata_cache(params::Dict{String,<:Any})

Resets metadata about your connector entities that Amazon AppFlow stored in its cache. Use
this action when you want Amazon AppFlow to return the latest information about the data
that you have in a source application. Amazon AppFlow returns metadata about your entities
when you use the ListConnectorEntities or DescribeConnectorEntities actions. Following
these actions, Amazon AppFlow caches the metadata to reduce the number of API requests that
it must send to the source application. Amazon AppFlow automatically resets the cache once
every hour, but you can use this action when you want to get the latest metadata right away.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"apiVersion"`: The API version that you specified in the connector profile that you’re
  resetting cached metadata for. You must use this parameter only if the connector supports
  multiple API versions or if the connector type is CustomConnector. To look up how many
  versions a connector supports, use the DescribeConnectors action. In the response, find the
  value that Amazon AppFlow returns for the connectorVersion parameter. To look up the
  connector type, use the DescribeConnectorProfiles action. In the response, find the value
  that Amazon AppFlow returns for the connectorType parameter. To look up the API version
  that you specified in a connector profile, use the DescribeConnectorProfiles action.
- `"connectorEntityName"`: Use this parameter if you want to reset cached metadata about
  the details for an individual entity. If you don't include this parameter in your request,
  Amazon AppFlow only resets cached metadata about entity names, not entity details.
- `"connectorProfileName"`: The name of the connector profile that you want to reset cached
  metadata for. You can omit this parameter if you're resetting the cache for any of the
  following connectors: Amazon Connect, Amazon EventBridge, Amazon Lookout for Metrics,
  Amazon S3, or Upsolver. If you're resetting the cache for any other connector, you must
  include this parameter in your request.
- `"connectorType"`: The type of connector to reset cached metadata for. You must include
  this parameter in your request if you're resetting the cache for any of the following
  connectors: Amazon Connect, Amazon EventBridge, Amazon Lookout for Metrics, Amazon S3, or
  Upsolver. If you're resetting the cache for any other connector, you can omit this
  parameter from your request.
- `"entitiesPath"`: Use this parameter only if you’re resetting the cached metadata about
  a nested entity. Only some connectors support nested entities. A nested entity is one that
  has another entity as a parent. To use this parameter, specify the name of the parent
  entity. To look up the parent-child relationship of entities, you can send a
  ListConnectorEntities request that omits the entitiesPath parameter. Amazon AppFlow will
  return a list of top-level entities. For each one, it indicates whether the entity has
  nested entities. Then, in a subsequent ListConnectorEntities request, you can specify a
  parent entity name for the entitiesPath parameter. Amazon AppFlow will return a list of the
  child entities for that parent.
"""
function reset_connector_metadata_cache(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return appflow(
        "POST",
        "/reset-connector-metadata-cache";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function reset_connector_metadata_cache(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appflow(
        "POST",
        "/reset-connector-metadata-cache",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_flow(flow_name)
    start_flow(flow_name, params::Dict{String,<:Any})

 Activates an existing flow. For on-demand flows, this operation runs the flow immediately.
For schedule and event-triggered flows, this operation activates the flow.

# Arguments
- `flow_name`:  The specified name of the flow. Spaces are not allowed. Use underscores (_)
  or hyphens (-) only.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: The clientToken parameter is an idempotency token. It ensures that your
  StartFlow request completes only once. You choose the value to pass. For example, if you
  don't receive a response from your request, you can safely retry the request with the same
  clientToken parameter value. If you omit a clientToken value, the Amazon Web Services SDK
  that you are using inserts a value for you. This way, the SDK can safely retry requests
  multiple times after a network error. You must provide your own value for other use cases.
  If you specify input parameters that differ from your first request, an error occurs for
  flows that run on a schedule or based on an event. However, the error doesn't occur for
  flows that run on demand. You set the conditions that initiate your flow for the
  triggerConfig parameter. If you use a different value for clientToken, Amazon AppFlow
  considers it a new call to StartFlow. The token is active for 8 hours.
"""
function start_flow(flowName; aws_config::AbstractAWSConfig=current_aws_config())
    return appflow(
        "POST",
        "/start-flow",
        Dict{String,Any}("flowName" => flowName, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_flow(
    flowName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appflow(
        "POST",
        "/start-flow",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("flowName" => flowName, "clientToken" => string(uuid4())),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_flow(flow_name)
    stop_flow(flow_name, params::Dict{String,<:Any})

 Deactivates the existing flow. For on-demand flows, this operation returns an
unsupportedOperationException error message. For schedule and event-triggered flows, this
operation deactivates the flow.

# Arguments
- `flow_name`:  The specified name of the flow. Spaces are not allowed. Use underscores (_)
  or hyphens (-) only.

"""
function stop_flow(flowName; aws_config::AbstractAWSConfig=current_aws_config())
    return appflow(
        "POST",
        "/stop-flow",
        Dict{String,Any}("flowName" => flowName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_flow(
    flowName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appflow(
        "POST",
        "/stop-flow",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("flowName" => flowName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

 Applies a tag to the specified flow.

# Arguments
- `resource_arn`:  The Amazon Resource Name (ARN) of the flow that you want to tag.
- `tags`:  The tags used to organize, track, or control access for your flow.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return appflow(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appflow(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    unregister_connector(connector_label)
    unregister_connector(connector_label, params::Dict{String,<:Any})

Unregisters the custom connector registered in your account that matches the connector
label provided in the request.

# Arguments
- `connector_label`: The label of the connector. The label is unique for each
  ConnectorRegistration in your Amazon Web Services account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"forceDelete"`: Indicates whether Amazon AppFlow should unregister the connector, even
  if it is currently in use in one or more connector profiles. The default value is false.
"""
function unregister_connector(
    connectorLabel; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appflow(
        "POST",
        "/unregister-connector",
        Dict{String,Any}("connectorLabel" => connectorLabel);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function unregister_connector(
    connectorLabel,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appflow(
        "POST",
        "/unregister-connector",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("connectorLabel" => connectorLabel), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

 Removes a tag from the specified flow.

# Arguments
- `resource_arn`:  The Amazon Resource Name (ARN) of the flow that you want to untag.
- `tag_keys`:  The tag keys associated with the tag that you want to remove from your flow.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appflow(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appflow(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_connector_profile(connection_mode, connector_profile_config, connector_profile_name)
    update_connector_profile(connection_mode, connector_profile_config, connector_profile_name, params::Dict{String,<:Any})

 Updates a given connector profile associated with your account.

# Arguments
- `connection_mode`:  Indicates the connection mode and if it is public or private.
- `connector_profile_config`:  Defines the connector-specific profile configuration and
  credentials.
- `connector_profile_name`:  The name of the connector profile and is unique for each
  ConnectorProfile in the Amazon Web Services account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: The clientToken parameter is an idempotency token. It ensures that your
  UpdateConnectorProfile request completes only once. You choose the value to pass. For
  example, if you don't receive a response from your request, you can safely retry the
  request with the same clientToken parameter value. If you omit a clientToken value, the
  Amazon Web Services SDK that you are using inserts a value for you. This way, the SDK can
  safely retry requests multiple times after a network error. You must provide your own value
  for other use cases. If you specify input parameters that differ from your first request,
  an error occurs. If you use a different value for clientToken, Amazon AppFlow considers it
  a new call to UpdateConnectorProfile. The token is active for 8 hours.
"""
function update_connector_profile(
    connectionMode,
    connectorProfileConfig,
    connectorProfileName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appflow(
        "POST",
        "/update-connector-profile",
        Dict{String,Any}(
            "connectionMode" => connectionMode,
            "connectorProfileConfig" => connectorProfileConfig,
            "connectorProfileName" => connectorProfileName,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_connector_profile(
    connectionMode,
    connectorProfileConfig,
    connectorProfileName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appflow(
        "POST",
        "/update-connector-profile",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "connectionMode" => connectionMode,
                    "connectorProfileConfig" => connectorProfileConfig,
                    "connectorProfileName" => connectorProfileName,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_connector_registration(connector_label)
    update_connector_registration(connector_label, params::Dict{String,<:Any})

Updates a custom connector that you've previously registered. This operation updates the
connector with one of the following:   The latest version of the AWS Lambda function that's
assigned to the connector   A new AWS Lambda function that you specify

# Arguments
- `connector_label`: The name of the connector. The name is unique for each connector
  registration in your AWS account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: The clientToken parameter is an idempotency token. It ensures that your
  UpdateConnectorRegistration request completes only once. You choose the value to pass. For
  example, if you don't receive a response from your request, you can safely retry the
  request with the same clientToken parameter value. If you omit a clientToken value, the
  Amazon Web Services SDK that you are using inserts a value for you. This way, the SDK can
  safely retry requests multiple times after a network error. You must provide your own value
  for other use cases. If you specify input parameters that differ from your first request,
  an error occurs. If you use a different value for clientToken, Amazon AppFlow considers it
  a new call to UpdateConnectorRegistration. The token is active for 8 hours.
- `"connectorProvisioningConfig"`:
- `"description"`: A description about the update that you're applying to the connector.
"""
function update_connector_registration(
    connectorLabel; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appflow(
        "POST",
        "/update-connector-registration",
        Dict{String,Any}(
            "connectorLabel" => connectorLabel, "clientToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_connector_registration(
    connectorLabel,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appflow(
        "POST",
        "/update-connector-registration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "connectorLabel" => connectorLabel, "clientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_flow(destination_flow_config_list, flow_name, source_flow_config, tasks, trigger_config)
    update_flow(destination_flow_config_list, flow_name, source_flow_config, tasks, trigger_config, params::Dict{String,<:Any})

 Updates an existing flow.

# Arguments
- `destination_flow_config_list`:  The configuration that controls how Amazon AppFlow
  transfers data to the destination connector.
- `flow_name`:  The specified name of the flow. Spaces are not allowed. Use underscores (_)
  or hyphens (-) only.
- `source_flow_config`:
- `tasks`:  A list of tasks that Amazon AppFlow performs while transferring the data in the
  flow run.
- `trigger_config`:  The trigger settings that determine how and when the flow runs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: The clientToken parameter is an idempotency token. It ensures that your
  UpdateFlow request completes only once. You choose the value to pass. For example, if you
  don't receive a response from your request, you can safely retry the request with the same
  clientToken parameter value. If you omit a clientToken value, the Amazon Web Services SDK
  that you are using inserts a value for you. This way, the SDK can safely retry requests
  multiple times after a network error. You must provide your own value for other use cases.
  If you specify input parameters that differ from your first request, an error occurs. If
  you use a different value for clientToken, Amazon AppFlow considers it a new call to
  UpdateFlow. The token is active for 8 hours.
- `"description"`:  A description of the flow.
- `"metadataCatalogConfig"`: Specifies the configuration that Amazon AppFlow uses when it
  catalogs the data that's transferred by the associated flow. When Amazon AppFlow catalogs
  the data from a flow, it stores metadata in a data catalog.
"""
function update_flow(
    destinationFlowConfigList,
    flowName,
    sourceFlowConfig,
    tasks,
    triggerConfig;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appflow(
        "POST",
        "/update-flow",
        Dict{String,Any}(
            "destinationFlowConfigList" => destinationFlowConfigList,
            "flowName" => flowName,
            "sourceFlowConfig" => sourceFlowConfig,
            "tasks" => tasks,
            "triggerConfig" => triggerConfig,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_flow(
    destinationFlowConfigList,
    flowName,
    sourceFlowConfig,
    tasks,
    triggerConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appflow(
        "POST",
        "/update-flow",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "destinationFlowConfigList" => destinationFlowConfigList,
                    "flowName" => flowName,
                    "sourceFlowConfig" => sourceFlowConfig,
                    "tasks" => tasks,
                    "triggerConfig" => triggerConfig,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: keyspaces
using AWS.Compat
using AWS.UUIDs

"""
    create_keyspace(keyspace_name)
    create_keyspace(keyspace_name, params::Dict{String,<:Any})

The CreateKeyspace operation adds a new keyspace to your account. In an Amazon Web Services
account, keyspace names must be unique within each Region.  CreateKeyspace is an
asynchronous operation. You can monitor the creation status of the new keyspace by using
the GetKeyspace operation. For more information, see Creating keyspaces in the Amazon
Keyspaces Developer Guide.

# Arguments
- `keyspace_name`: The name of the keyspace to be created.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"replicationSpecification"`:  The replication specification of the keyspace includes:
  replicationStrategy - the required value is SINGLE_REGION or MULTI_REGION.    regionList -
  if the replicationStrategy is MULTI_REGION, the regionList requires the current Region and
  at least one additional Amazon Web Services Region where the keyspace is going to be
  replicated in. The maximum number of supported replication Regions including the current
  Region is six.
- `"tags"`: A list of key-value pair tags to be attached to the keyspace. For more
  information, see Adding tags and labels to Amazon Keyspaces resources in the Amazon
  Keyspaces Developer Guide.
"""
function create_keyspace(keyspaceName; aws_config::AbstractAWSConfig=current_aws_config())
    return keyspaces(
        "CreateKeyspace",
        Dict{String,Any}("keyspaceName" => keyspaceName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_keyspace(
    keyspaceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return keyspaces(
        "CreateKeyspace",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("keyspaceName" => keyspaceName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_table(keyspace_name, schema_definition, table_name)
    create_table(keyspace_name, schema_definition, table_name, params::Dict{String,<:Any})

The CreateTable operation adds a new table to the specified keyspace. Within a keyspace,
table names must be unique.  CreateTable is an asynchronous operation. When the request is
received, the status of the table is set to CREATING. You can monitor the creation status
of the new table by using the GetTable operation, which returns the current status of the
table. You can start using a table when the status is ACTIVE. For more information, see
Creating tables in the Amazon Keyspaces Developer Guide.

# Arguments
- `keyspace_name`: The name of the keyspace that the table is going to be created in.
- `schema_definition`: The schemaDefinition consists of the following parameters. For each
  column to be created:    name - The name of the column.    type - An Amazon Keyspaces data
  type. For more information, see Data types in the Amazon Keyspaces Developer Guide.   The
  primary key of the table consists of the following columns:    partitionKeys - The
  partition key can be a single column, or it can be a compound value composed of two or more
  columns. The partition key portion of the primary key is required and determines how Amazon
  Keyspaces stores your data.    name - The name of each partition key column.
  clusteringKeys - The optional clustering column portion of your primary key determines how
  the data is clustered and sorted within each partition.    name - The name of the
  clustering column.     orderBy - Sets the ascendant (ASC) or descendant (DESC) order
  modifier. To define a column as static use staticColumns - Static columns store values that
  are shared by all rows in the same partition:    name - The name of the column.    type -
  An Amazon Keyspaces data type.
- `table_name`: The name of the table.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"autoScalingSpecification"`: The optional auto scaling settings for a table in
  provisioned capacity mode. Specifies if the service can manage throughput capacity
  automatically on your behalf. Auto scaling helps you provision throughput capacity for
  variable workloads efficiently by increasing and decreasing your table's read and write
  capacity automatically in response to application traffic. For more information, see
  Managing throughput capacity automatically with Amazon Keyspaces auto scaling in the Amazon
  Keyspaces Developer Guide. By default, auto scaling is disabled for a table.
- `"capacitySpecification"`: Specifies the read/write throughput capacity mode for the
  table. The options are:    throughputMode:PAY_PER_REQUEST and
  throughputMode:PROVISIONED - Provisioned capacity mode requires readCapacityUnits and
  writeCapacityUnits as input.   The default is throughput_mode:PAY_PER_REQUEST. For more
  information, see Read/write capacity modes in the Amazon Keyspaces Developer Guide.
- `"clientSideTimestamps"`:  Enables client-side timestamps for the table. By default, the
  setting is disabled. You can enable client-side timestamps with the following option:
  status: \"enabled\"    Once client-side timestamps are enabled for a table, this setting
  cannot be disabled.
- `"comment"`: This parameter allows to enter a description of the table.
- `"defaultTimeToLive"`: The default Time to Live setting in seconds for the table. For
  more information, see Setting the default TTL value for a table in the Amazon Keyspaces
  Developer Guide.
- `"encryptionSpecification"`: Specifies how the encryption key for encryption at rest is
  managed for the table. You can choose one of the following KMS key (KMS key):
  type:AWS_OWNED_KMS_KEY - This key is owned by Amazon Keyspaces.
  type:CUSTOMER_MANAGED_KMS_KEY - This key is stored in your account and is created, owned,
  and managed by you. This option requires the kms_key_identifier of the KMS key in Amazon
  Resource Name (ARN) format as input.   The default is type:AWS_OWNED_KMS_KEY. For more
  information, see Encryption at rest in the Amazon Keyspaces Developer Guide.
- `"pointInTimeRecovery"`: Specifies if pointInTimeRecovery is enabled or disabled for the
  table. The options are:    status=ENABLED     status=DISABLED    If it's not specified, the
  default is status=DISABLED. For more information, see Point-in-time recovery in the Amazon
  Keyspaces Developer Guide.
- `"replicaSpecifications"`: The optional Amazon Web Services Region specific settings of a
  multi-Region table. These settings overwrite the general settings of the table for the
  specified Region.  For a multi-Region table in provisioned capacity mode, you can configure
  the table's read capacity differently for each Region's replica. The write capacity,
  however, remains synchronized between all replicas to ensure that there's enough capacity
  to replicate writes across all Regions. To define the read capacity for a table replica in
  a specific Region, you can do so by configuring the following parameters.    region: The
  Region where these settings are applied. (Required)    readCapacityUnits: The provisioned
  read capacity units. (Optional)    readCapacityAutoScaling: The read capacity auto scaling
  settings for the table. (Optional)
- `"tags"`: A list of key-value pair tags to be attached to the resource.  For more
  information, see Adding tags and labels to Amazon Keyspaces resources in the Amazon
  Keyspaces Developer Guide.
- `"ttl"`: Enables Time to Live custom settings for the table. The options are:
  status:enabled     status:disabled    The default is status:disabled. After ttl is enabled,
  you can't disable it for the table. For more information, see Expiring data by using Amazon
  Keyspaces Time to Live (TTL) in the Amazon Keyspaces Developer Guide.
"""
function create_table(
    keyspaceName,
    schemaDefinition,
    tableName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return keyspaces(
        "CreateTable",
        Dict{String,Any}(
            "keyspaceName" => keyspaceName,
            "schemaDefinition" => schemaDefinition,
            "tableName" => tableName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_table(
    keyspaceName,
    schemaDefinition,
    tableName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return keyspaces(
        "CreateTable",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "keyspaceName" => keyspaceName,
                    "schemaDefinition" => schemaDefinition,
                    "tableName" => tableName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_keyspace(keyspace_name)
    delete_keyspace(keyspace_name, params::Dict{String,<:Any})

The DeleteKeyspace operation deletes a keyspace and all of its tables.

# Arguments
- `keyspace_name`: The name of the keyspace to be deleted.

"""
function delete_keyspace(keyspaceName; aws_config::AbstractAWSConfig=current_aws_config())
    return keyspaces(
        "DeleteKeyspace",
        Dict{String,Any}("keyspaceName" => keyspaceName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_keyspace(
    keyspaceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return keyspaces(
        "DeleteKeyspace",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("keyspaceName" => keyspaceName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_table(keyspace_name, table_name)
    delete_table(keyspace_name, table_name, params::Dict{String,<:Any})

The DeleteTable operation deletes a table and all of its data. After a DeleteTable request
is received, the specified table is in the DELETING state until Amazon Keyspaces completes
the deletion. If the table is in the ACTIVE state, you can delete it. If a table is either
in the CREATING or UPDATING states, then Amazon Keyspaces returns a ResourceInUseException.
If the specified table does not exist, Amazon Keyspaces returns a
ResourceNotFoundException. If the table is already in the DELETING state, no error is
returned.

# Arguments
- `keyspace_name`: The name of the keyspace of the to be deleted table.
- `table_name`: The name of the table to be deleted.

"""
function delete_table(
    keyspaceName, tableName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return keyspaces(
        "DeleteTable",
        Dict{String,Any}("keyspaceName" => keyspaceName, "tableName" => tableName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_table(
    keyspaceName,
    tableName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return keyspaces(
        "DeleteTable",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("keyspaceName" => keyspaceName, "tableName" => tableName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_keyspace(keyspace_name)
    get_keyspace(keyspace_name, params::Dict{String,<:Any})

Returns the name and the Amazon Resource Name (ARN) of the specified table.

# Arguments
- `keyspace_name`: The name of the keyspace.

"""
function get_keyspace(keyspaceName; aws_config::AbstractAWSConfig=current_aws_config())
    return keyspaces(
        "GetKeyspace",
        Dict{String,Any}("keyspaceName" => keyspaceName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_keyspace(
    keyspaceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return keyspaces(
        "GetKeyspace",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("keyspaceName" => keyspaceName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_table(keyspace_name, table_name)
    get_table(keyspace_name, table_name, params::Dict{String,<:Any})

Returns information about the table, including the table's name and current status, the
keyspace name, configuration settings, and metadata. To read table metadata using GetTable,
Select action permissions for the table and system tables are required to complete the
operation.

# Arguments
- `keyspace_name`: The name of the keyspace that the table is stored in.
- `table_name`: The name of the table.

"""
function get_table(
    keyspaceName, tableName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return keyspaces(
        "GetTable",
        Dict{String,Any}("keyspaceName" => keyspaceName, "tableName" => tableName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_table(
    keyspaceName,
    tableName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return keyspaces(
        "GetTable",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("keyspaceName" => keyspaceName, "tableName" => tableName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_table_auto_scaling_settings(keyspace_name, table_name)
    get_table_auto_scaling_settings(keyspace_name, table_name, params::Dict{String,<:Any})

Returns auto scaling related settings of the specified table in JSON format. If the table
is a multi-Region table, the Amazon Web Services Region specific auto scaling settings of
the table are included. Amazon Keyspaces auto scaling helps you provision throughput
capacity for variable workloads efficiently by increasing and decreasing your table's read
and write capacity automatically in response to application traffic. For more information,
see Managing throughput capacity automatically with Amazon Keyspaces auto scaling in the
Amazon Keyspaces Developer Guide.   GetTableAutoScalingSettings can't be used as an action
in an IAM policy.  To define permissions for GetTableAutoScalingSettings, you must allow
the following two actions in the IAM policy statement's Action element:
application-autoscaling:DescribeScalableTargets
application-autoscaling:DescribeScalingPolicies

# Arguments
- `keyspace_name`: The name of the keyspace.
- `table_name`: The name of the table.

"""
function get_table_auto_scaling_settings(
    keyspaceName, tableName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return keyspaces(
        "GetTableAutoScalingSettings",
        Dict{String,Any}("keyspaceName" => keyspaceName, "tableName" => tableName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_table_auto_scaling_settings(
    keyspaceName,
    tableName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return keyspaces(
        "GetTableAutoScalingSettings",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("keyspaceName" => keyspaceName, "tableName" => tableName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_keyspaces()
    list_keyspaces(params::Dict{String,<:Any})

Returns a list of keyspaces.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The total number of keyspaces to return in the output. If the total
  number of keyspaces available is more than the value specified, a NextToken is provided in
  the output. To resume pagination, provide the NextToken value as an argument of a
  subsequent API invocation.
- `"nextToken"`: The pagination token. To resume pagination, provide the NextToken value as
  argument of a subsequent API invocation.
"""
function list_keyspaces(; aws_config::AbstractAWSConfig=current_aws_config())
    return keyspaces(
        "ListKeyspaces"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_keyspaces(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return keyspaces(
        "ListKeyspaces", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tables(keyspace_name)
    list_tables(keyspace_name, params::Dict{String,<:Any})

Returns a list of tables for a specified keyspace.

# Arguments
- `keyspace_name`: The name of the keyspace.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The total number of tables to return in the output. If the total number
  of tables available is more than the value specified, a NextToken is provided in the
  output. To resume pagination, provide the NextToken value as an argument of a subsequent
  API invocation.
- `"nextToken"`: The pagination token. To resume pagination, provide the NextToken value as
  an argument of a subsequent API invocation.
"""
function list_tables(keyspaceName; aws_config::AbstractAWSConfig=current_aws_config())
    return keyspaces(
        "ListTables",
        Dict{String,Any}("keyspaceName" => keyspaceName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tables(
    keyspaceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return keyspaces(
        "ListTables",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("keyspaceName" => keyspaceName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Returns a list of all tags associated with the specified Amazon Keyspaces resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the Amazon Keyspaces resource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The total number of tags to return in the output. If the total number of
  tags available is more than the value specified, a NextToken is provided in the output. To
  resume pagination, provide the NextToken value as an argument of a subsequent API
  invocation.
- `"nextToken"`: The pagination token. To resume pagination, provide the NextToken value as
  argument of a subsequent API invocation.
"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return keyspaces(
        "ListTagsForResource",
        Dict{String,Any}("resourceArn" => resourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return keyspaces(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceArn" => resourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    restore_table(source_keyspace_name, source_table_name, target_keyspace_name, target_table_name)
    restore_table(source_keyspace_name, source_table_name, target_keyspace_name, target_table_name, params::Dict{String,<:Any})

Restores the table to the specified point in time within the earliest_restorable_timestamp
and the current time. For more information about restore points, see  Time window for PITR
continuous backups in the Amazon Keyspaces Developer Guide. Any number of users can execute
up to 4 concurrent restores (any type of restore) in a given account. When you restore
using point in time recovery, Amazon Keyspaces restores your source table's schema and data
to the state based on the selected timestamp (day:hour:minute:second) to a new table. The
Time to Live (TTL) settings are also restored to the state based on the selected timestamp.
In addition to the table's schema, data, and TTL settings, RestoreTable restores the
capacity mode, auto scaling settings, encryption settings, and point-in-time recovery
settings from the source table. Unlike the table's schema data and TTL settings, which are
restored based on the selected timestamp, these settings are always restored based on the
table's settings as of the current time or when the table was deleted. You can also
overwrite these settings during restore:   Read/write capacity mode   Provisioned
throughput capacity units   Auto scaling settings   Point-in-time (PITR) settings   Tags
For more information, see PITR restore settings in the Amazon Keyspaces Developer Guide.
Note that the following settings are not restored, and you must configure them manually for
the new table:   Identity and Access Management (IAM) policies   Amazon CloudWatch metrics
and alarms

# Arguments
- `source_keyspace_name`: The keyspace name of the source table.
- `source_table_name`: The name of the source table.
- `target_keyspace_name`: The name of the target keyspace.
- `target_table_name`: The name of the target table.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"autoScalingSpecification"`: The optional auto scaling settings for the restored table
  in provisioned capacity mode. Specifies if the service can manage throughput capacity of a
  provisioned table automatically on your behalf. Amazon Keyspaces auto scaling helps you
  provision throughput capacity for variable workloads efficiently by increasing and
  decreasing your table's read and write capacity automatically in response to application
  traffic. For more information, see Managing throughput capacity automatically with Amazon
  Keyspaces auto scaling in the Amazon Keyspaces Developer Guide.
- `"capacitySpecificationOverride"`: Specifies the read/write throughput capacity mode for
  the target table. The options are:    throughputMode:PAY_PER_REQUEST
  throughputMode:PROVISIONED - Provisioned capacity mode requires readCapacityUnits and
  writeCapacityUnits as input.   The default is throughput_mode:PAY_PER_REQUEST. For more
  information, see Read/write capacity modes in the Amazon Keyspaces Developer Guide.
- `"encryptionSpecificationOverride"`: Specifies the encryption settings for the target
  table. You can choose one of the following KMS key (KMS key):    type:AWS_OWNED_KMS_KEY -
  This key is owned by Amazon Keyspaces.     type:CUSTOMER_MANAGED_KMS_KEY - This key is
  stored in your account and is created, owned, and managed by you. This option requires the
  kms_key_identifier of the KMS key in Amazon Resource Name (ARN) format as input.    The
  default is type:AWS_OWNED_KMS_KEY. For more information, see Encryption at rest in the
  Amazon Keyspaces Developer Guide.
- `"pointInTimeRecoveryOverride"`: Specifies the pointInTimeRecovery settings for the
  target table. The options are:    status=ENABLED     status=DISABLED    If it's not
  specified, the default is status=DISABLED. For more information, see Point-in-time recovery
  in the Amazon Keyspaces Developer Guide.
- `"replicaSpecifications"`: The optional Region specific settings of a multi-Regional
  table.
- `"restoreTimestamp"`: The restore timestamp in ISO 8601 format.
- `"tagsOverride"`: A list of key-value pair tags to be attached to the restored table.
  For more information, see Adding tags and labels to Amazon Keyspaces resources in the
  Amazon Keyspaces Developer Guide.
"""
function restore_table(
    sourceKeyspaceName,
    sourceTableName,
    targetKeyspaceName,
    targetTableName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return keyspaces(
        "RestoreTable",
        Dict{String,Any}(
            "sourceKeyspaceName" => sourceKeyspaceName,
            "sourceTableName" => sourceTableName,
            "targetKeyspaceName" => targetKeyspaceName,
            "targetTableName" => targetTableName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function restore_table(
    sourceKeyspaceName,
    sourceTableName,
    targetKeyspaceName,
    targetTableName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return keyspaces(
        "RestoreTable",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "sourceKeyspaceName" => sourceKeyspaceName,
                    "sourceTableName" => sourceTableName,
                    "targetKeyspaceName" => targetKeyspaceName,
                    "targetTableName" => targetTableName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Associates a set of tags with a Amazon Keyspaces resource. You can then activate these
user-defined tags so that they appear on the Cost Management Console for cost allocation
tracking. For more information, see Adding tags and labels to Amazon Keyspaces resources in
the Amazon Keyspaces Developer Guide. For IAM policy examples that show how to control
access to Amazon Keyspaces resources based on tags, see Amazon Keyspaces resource access
based on tags in the Amazon Keyspaces Developer Guide.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the Amazon Keyspaces resource to which
  to add tags.
- `tags`: The tags to be assigned to the Amazon Keyspaces resource.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return keyspaces(
        "TagResource",
        Dict{String,Any}("resourceArn" => resourceArn, "tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return keyspaces(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceArn" => resourceArn, "tags" => tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tags)
    untag_resource(resource_arn, tags, params::Dict{String,<:Any})

Removes the association of tags from a Amazon Keyspaces resource.

# Arguments
- `resource_arn`: The Amazon Keyspaces resource that the tags will be removed from. This
  value is an Amazon Resource Name (ARN).
- `tags`: A list of existing tags to be removed from the Amazon Keyspaces resource.

"""
function untag_resource(
    resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config()
)
    return keyspaces(
        "UntagResource",
        Dict{String,Any}("resourceArn" => resourceArn, "tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return keyspaces(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceArn" => resourceArn, "tags" => tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_table(keyspace_name, table_name)
    update_table(keyspace_name, table_name, params::Dict{String,<:Any})

Adds new columns to the table or updates one of the table's settings, for example capacity
mode, auto scaling, encryption, point-in-time recovery, or ttl settings. Note that you can
only update one specific table setting per update operation.

# Arguments
- `keyspace_name`: The name of the keyspace the specified table is stored in.
- `table_name`: The name of the table.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"addColumns"`: For each column to be added to the specified table:    name - The name of
  the column.    type - An Amazon Keyspaces data type. For more information, see Data types
  in the Amazon Keyspaces Developer Guide.
- `"autoScalingSpecification"`: The optional auto scaling settings to update for a table in
  provisioned capacity mode. Specifies if the service can manage throughput capacity of a
  provisioned table automatically on your behalf. Amazon Keyspaces auto scaling helps you
  provision throughput capacity for variable workloads efficiently by increasing and
  decreasing your table's read and write capacity automatically in response to application
  traffic. If auto scaling is already enabled for the table, you can use UpdateTable to
  update the minimum and maximum values or the auto scaling policy settings independently.
  For more information, see Managing throughput capacity automatically with Amazon Keyspaces
  auto scaling in the Amazon Keyspaces Developer Guide.
- `"capacitySpecification"`: Modifies the read/write throughput capacity mode for the
  table. The options are:    throughputMode:PAY_PER_REQUEST and
  throughputMode:PROVISIONED - Provisioned capacity mode requires readCapacityUnits and
  writeCapacityUnits as input.   The default is throughput_mode:PAY_PER_REQUEST. For more
  information, see Read/write capacity modes in the Amazon Keyspaces Developer Guide.
- `"clientSideTimestamps"`: Enables client-side timestamps for the table. By default, the
  setting is disabled. You can enable client-side timestamps with the following option:
  status: \"enabled\"    Once client-side timestamps are enabled for a table, this setting
  cannot be disabled.
- `"defaultTimeToLive"`: The default Time to Live setting in seconds for the table. For
  more information, see Setting the default TTL value for a table in the Amazon Keyspaces
  Developer Guide.
- `"encryptionSpecification"`: Modifies the encryption settings of the table. You can
  choose one of the following KMS key (KMS key):    type:AWS_OWNED_KMS_KEY - This key is
  owned by Amazon Keyspaces.     type:CUSTOMER_MANAGED_KMS_KEY - This key is stored in your
  account and is created, owned, and managed by you. This option requires the
  kms_key_identifier of the KMS key in Amazon Resource Name (ARN) format as input.    The
  default is AWS_OWNED_KMS_KEY. For more information, see Encryption at rest in the Amazon
  Keyspaces Developer Guide.
- `"pointInTimeRecovery"`: Modifies the pointInTimeRecovery settings of the table. The
  options are:    status=ENABLED     status=DISABLED    If it's not specified, the default is
  status=DISABLED. For more information, see Point-in-time recovery in the Amazon Keyspaces
  Developer Guide.
- `"replicaSpecifications"`: The Region specific settings of a multi-Regional table.
- `"ttl"`: Modifies Time to Live custom settings for the table. The options are:
  status:enabled     status:disabled    The default is status:disabled. After ttl is enabled,
  you can't disable it for the table. For more information, see Expiring data by using Amazon
  Keyspaces Time to Live (TTL) in the Amazon Keyspaces Developer Guide.
"""
function update_table(
    keyspaceName, tableName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return keyspaces(
        "UpdateTable",
        Dict{String,Any}("keyspaceName" => keyspaceName, "tableName" => tableName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_table(
    keyspaceName,
    tableName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return keyspaces(
        "UpdateTable",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("keyspaceName" => keyspaceName, "tableName" => tableName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: elastic_inference
using AWS.Compat
using AWS.UUIDs

"""
    describe_accelerator_offerings(location_type)
    describe_accelerator_offerings(location_type, params::Dict{String,<:Any})

 Describes the locations in which a given accelerator type or set of types is present in a
given region.   February 15, 2023: Starting April 15, 2023, AWS will not onboard new
customers to Amazon Elastic Inference (EI), and will help current customers migrate their
workloads to options that offer better price and performance. After April 15, 2023, new
customers will not be able to launch instances with Amazon EI accelerators in Amazon
SageMaker, Amazon ECS, or Amazon EC2. However, customers who have used Amazon EI at least
once during the past 30-day period are considered current customers and will be able to
continue using the service.

# Arguments
- `location_type`:  The location type that you want to describe accelerator type offerings
  for. It can assume the following values: region: will return the accelerator type offering
  at the regional level. availability-zone: will return the accelerator type offering at the
  availability zone level. availability-zone-id: will return the accelerator type offering at
  the availability zone level returning the availability zone id.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"acceleratorTypes"`:  The list of accelerator types to describe.
"""
function describe_accelerator_offerings(
    locationType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_inference(
        "POST",
        "/describe-accelerator-offerings",
        Dict{String,Any}("locationType" => locationType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_accelerator_offerings(
    locationType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_inference(
        "POST",
        "/describe-accelerator-offerings",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("locationType" => locationType), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_accelerator_types()
    describe_accelerator_types(params::Dict{String,<:Any})

 Describes the accelerator types available in a given region, as well as their
characteristics, such as memory and throughput.   February 15, 2023: Starting April 15,
2023, AWS will not onboard new customers to Amazon Elastic Inference (EI), and will help
current customers migrate their workloads to options that offer better price and
performance. After April 15, 2023, new customers will not be able to launch instances with
Amazon EI accelerators in Amazon SageMaker, Amazon ECS, or Amazon EC2. However, customers
who have used Amazon EI at least once during the past 30-day period are considered current
customers and will be able to continue using the service.

"""
function describe_accelerator_types(; aws_config::AbstractAWSConfig=current_aws_config())
    return elastic_inference(
        "GET",
        "/describe-accelerator-types";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_accelerator_types(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_inference(
        "GET",
        "/describe-accelerator-types",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_accelerators()
    describe_accelerators(params::Dict{String,<:Any})

 Describes information over a provided set of accelerators belonging to an account.
February 15, 2023: Starting April 15, 2023, AWS will not onboard new customers to Amazon
Elastic Inference (EI), and will help current customers migrate their workloads to options
that offer better price and performance. After April 15, 2023, new customers will not be
able to launch instances with Amazon EI accelerators in Amazon SageMaker, Amazon ECS, or
Amazon EC2. However, customers who have used Amazon EI at least once during the past 30-day
period are considered current customers and will be able to continue using the service.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"acceleratorIds"`:  The IDs of the accelerators to describe.
- `"filters"`:  One or more filters. Filter names and values are case-sensitive. Valid
  filter names are: accelerator-types: can provide a list of accelerator type names to filter
  for. instance-id: can provide a list of EC2 instance ids to filter for.
- `"maxResults"`:  The total number of items to return in the command's output. If the
  total number of items available is more than the value specified, a NextToken is provided
  in the command's output. To resume pagination, provide the NextToken value in the
  starting-token argument of a subsequent command. Do not use the NextToken response element
  directly outside of the AWS CLI.
- `"nextToken"`:  A token to specify where to start paginating. This is the NextToken from
  a previously truncated response.
"""
function describe_accelerators(; aws_config::AbstractAWSConfig=current_aws_config())
    return elastic_inference(
        "POST",
        "/describe-accelerators";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_accelerators(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_inference(
        "POST",
        "/describe-accelerators",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

 Returns all tags of an Elastic Inference Accelerator.   February 15, 2023: Starting April
15, 2023, AWS will not onboard new customers to Amazon Elastic Inference (EI), and will
help current customers migrate their workloads to options that offer better price and
performance. After April 15, 2023, new customers will not be able to launch instances with
Amazon EI accelerators in Amazon SageMaker, Amazon ECS, or Amazon EC2. However, customers
who have used Amazon EI at least once during the past 30-day period are considered current
customers and will be able to continue using the service.

# Arguments
- `resource_arn`:  The ARN of the Elastic Inference Accelerator to list the tags for.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_inference(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_inference(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

 Adds the specified tags to an Elastic Inference Accelerator.   February 15, 2023: Starting
April 15, 2023, AWS will not onboard new customers to Amazon Elastic Inference (EI), and
will help current customers migrate their workloads to options that offer better price and
performance. After April 15, 2023, new customers will not be able to launch instances with
Amazon EI accelerators in Amazon SageMaker, Amazon ECS, or Amazon EC2. However, customers
who have used Amazon EI at least once during the past 30-day period are considered current
customers and will be able to continue using the service.

# Arguments
- `resource_arn`:  The ARN of the Elastic Inference Accelerator to tag.
- `tags`:  The tags to add to the Elastic Inference Accelerator.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return elastic_inference(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_inference(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

 Removes the specified tags from an Elastic Inference Accelerator.   February 15, 2023:
Starting April 15, 2023, AWS will not onboard new customers to Amazon Elastic Inference
(EI), and will help current customers migrate their workloads to options that offer better
price and performance. After April 15, 2023, new customers will not be able to launch
instances with Amazon EI accelerators in Amazon SageMaker, Amazon ECS, or Amazon EC2.
However, customers who have used Amazon EI at least once during the past 30-day period are
considered current customers and will be able to continue using the service.

# Arguments
- `resource_arn`:  The ARN of the Elastic Inference Accelerator to untag.
- `tag_keys`:  The list of tags to remove from the Elastic Inference Accelerator.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_inference(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_inference(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: medialive
using AWS.Compat
using AWS.UUIDs

"""
    accept_input_device_transfer(input_device_id)
    accept_input_device_transfer(input_device_id, params::Dict{String,<:Any})

Accept an incoming input device transfer. The ownership of the device will transfer to your
AWS account.

# Arguments
- `input_device_id`: The unique ID of the input device to accept. For example,
  hd-123456789abcdef.

"""
function accept_input_device_transfer(
    inputDeviceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "POST",
        "/prod/inputDevices/$(inputDeviceId)/accept";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function accept_input_device_transfer(
    inputDeviceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "POST",
        "/prod/inputDevices/$(inputDeviceId)/accept",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_delete()
    batch_delete(params::Dict{String,<:Any})

Starts delete of resources.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"channelIds"`: List of channel IDs
- `"inputIds"`: List of input IDs
- `"inputSecurityGroupIds"`: List of input security group IDs
- `"multiplexIds"`: List of multiplex IDs
"""
function batch_delete(; aws_config::AbstractAWSConfig=current_aws_config())
    return medialive(
        "POST", "/prod/batch/delete"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function batch_delete(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "POST",
        "/prod/batch/delete",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_start()
    batch_start(params::Dict{String,<:Any})

Starts existing resources

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"channelIds"`: List of channel IDs
- `"multiplexIds"`: List of multiplex IDs
"""
function batch_start(; aws_config::AbstractAWSConfig=current_aws_config())
    return medialive(
        "POST", "/prod/batch/start"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function batch_start(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "POST",
        "/prod/batch/start",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_stop()
    batch_stop(params::Dict{String,<:Any})

Stops running resources

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"channelIds"`: List of channel IDs
- `"multiplexIds"`: List of multiplex IDs
"""
function batch_stop(; aws_config::AbstractAWSConfig=current_aws_config())
    return medialive(
        "POST", "/prod/batch/stop"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function batch_stop(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "POST",
        "/prod/batch/stop",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_update_schedule(channel_id)
    batch_update_schedule(channel_id, params::Dict{String,<:Any})

Update a channel schedule

# Arguments
- `channel_id`: Id of the channel whose schedule is being updated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"creates"`: Schedule actions to create in the schedule.
- `"deletes"`: Schedule actions to delete from the schedule.
"""
function batch_update_schedule(
    channelId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "PUT",
        "/prod/channels/$(channelId)/schedule";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_update_schedule(
    channelId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "PUT",
        "/prod/channels/$(channelId)/schedule",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_input_device_transfer(input_device_id)
    cancel_input_device_transfer(input_device_id, params::Dict{String,<:Any})

Cancel an input device transfer that you have requested.

# Arguments
- `input_device_id`: The unique ID of the input device to cancel. For example,
  hd-123456789abcdef.

"""
function cancel_input_device_transfer(
    inputDeviceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "POST",
        "/prod/inputDevices/$(inputDeviceId)/cancel";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_input_device_transfer(
    inputDeviceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "POST",
        "/prod/inputDevices/$(inputDeviceId)/cancel",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    claim_device()
    claim_device(params::Dict{String,<:Any})

Send a request to claim an AWS Elemental device that you have purchased from a third-party
vendor. After the request succeeds, you will own the device.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"id"`: The id of the device you want to claim.
"""
function claim_device(; aws_config::AbstractAWSConfig=current_aws_config())
    return medialive(
        "POST", "/prod/claimDevice"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function claim_device(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "POST",
        "/prod/claimDevice",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_channel()
    create_channel(params::Dict{String,<:Any})

Creates a new channel

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"cdiInputSpecification"`: Specification of CDI inputs for this channel
- `"channelClass"`: The class for this channel. STANDARD for a channel with two pipelines
  or SINGLE_PIPELINE for a channel with one pipeline.
- `"destinations"`:
- `"encoderSettings"`:
- `"inputAttachments"`: List of input attachments for channel.
- `"inputSpecification"`: Specification of network and file inputs for this channel
- `"logLevel"`: The log level to write to CloudWatch Logs.
- `"maintenance"`: Maintenance settings for this channel.
- `"name"`: Name of channel.
- `"requestId"`: Unique request ID to be specified. This is needed to prevent retries
  from
creating multiple resources.
- `"reserved"`: Deprecated field that's only usable by whitelisted customers.
- `"roleArn"`: An optional Amazon Resource Name (ARN) of the role to assume when running
  the Channel.
- `"tags"`: A collection of key-value pairs.
- `"vpc"`: Settings for the VPC outputs
"""
function create_channel(; aws_config::AbstractAWSConfig=current_aws_config())
    return medialive(
        "POST",
        "/prod/channels",
        Dict{String,Any}("requestId" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_channel(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "POST",
        "/prod/channels",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("requestId" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_cloud_watch_alarm_template(comparison_operator, evaluation_periods, group_identifier, metric_name, name, period, statistic, target_resource_type, threshold, treat_missing_data)
    create_cloud_watch_alarm_template(comparison_operator, evaluation_periods, group_identifier, metric_name, name, period, statistic, target_resource_type, threshold, treat_missing_data, params::Dict{String,<:Any})

Creates a cloudwatch alarm template to dynamically generate cloudwatch metric alarms on
targeted resource types.

# Arguments
- `comparison_operator`:
- `evaluation_periods`: The number of periods over which data is compared to the specified
  threshold.
- `group_identifier`: A cloudwatch alarm template group's identifier. Can be either be its
  id or current name.
- `metric_name`: The name of the metric associated with the alarm. Must be compatible with
  targetResourceType.
- `name`: A resource's name. Names must be unique within the scope of a resource type in a
  specific region.
- `period`: The period, in seconds, over which the specified statistic is applied.
- `statistic`:
- `target_resource_type`:
- `threshold`: The threshold value to compare with the specified statistic.
- `treat_missing_data`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"datapointsToAlarm"`: The number of datapoints within the evaluation period that must be
  breaching to trigger the alarm.
- `"description"`: A resource's optional description.
- `"tags"`:
"""
function create_cloud_watch_alarm_template(
    comparisonOperator,
    evaluationPeriods,
    groupIdentifier,
    metricName,
    name,
    period,
    statistic,
    targetResourceType,
    threshold,
    treatMissingData;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "POST",
        "/prod/cloudwatch-alarm-templates",
        Dict{String,Any}(
            "comparisonOperator" => comparisonOperator,
            "evaluationPeriods" => evaluationPeriods,
            "groupIdentifier" => groupIdentifier,
            "metricName" => metricName,
            "name" => name,
            "period" => period,
            "statistic" => statistic,
            "targetResourceType" => targetResourceType,
            "threshold" => threshold,
            "treatMissingData" => treatMissingData,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_cloud_watch_alarm_template(
    comparisonOperator,
    evaluationPeriods,
    groupIdentifier,
    metricName,
    name,
    period,
    statistic,
    targetResourceType,
    threshold,
    treatMissingData,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "POST",
        "/prod/cloudwatch-alarm-templates",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "comparisonOperator" => comparisonOperator,
                    "evaluationPeriods" => evaluationPeriods,
                    "groupIdentifier" => groupIdentifier,
                    "metricName" => metricName,
                    "name" => name,
                    "period" => period,
                    "statistic" => statistic,
                    "targetResourceType" => targetResourceType,
                    "threshold" => threshold,
                    "treatMissingData" => treatMissingData,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_cloud_watch_alarm_template_group(name)
    create_cloud_watch_alarm_template_group(name, params::Dict{String,<:Any})

Creates a cloudwatch alarm template group to group your cloudwatch alarm templates and to
attach to signal maps for dynamically creating alarms.

# Arguments
- `name`: A resource's name. Names must be unique within the scope of a resource type in a
  specific region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A resource's optional description.
- `"tags"`:
"""
function create_cloud_watch_alarm_template_group(
    name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "POST",
        "/prod/cloudwatch-alarm-template-groups",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_cloud_watch_alarm_template_group(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "POST",
        "/prod/cloudwatch-alarm-template-groups",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_event_bridge_rule_template(event_type, group_identifier, name)
    create_event_bridge_rule_template(event_type, group_identifier, name, params::Dict{String,<:Any})

Creates an eventbridge rule template to monitor events and send notifications to your
targeted resources.

# Arguments
- `event_type`:
- `group_identifier`: An eventbridge rule template group's identifier. Can be either be its
  id or current name.
- `name`: A resource's name. Names must be unique within the scope of a resource type in a
  specific region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A resource's optional description.
- `"eventTargets"`:
- `"tags"`:
"""
function create_event_bridge_rule_template(
    eventType, groupIdentifier, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "POST",
        "/prod/eventbridge-rule-templates",
        Dict{String,Any}(
            "eventType" => eventType, "groupIdentifier" => groupIdentifier, "name" => name
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_event_bridge_rule_template(
    eventType,
    groupIdentifier,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "POST",
        "/prod/eventbridge-rule-templates",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "eventType" => eventType,
                    "groupIdentifier" => groupIdentifier,
                    "name" => name,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_event_bridge_rule_template_group(name)
    create_event_bridge_rule_template_group(name, params::Dict{String,<:Any})

Creates an eventbridge rule template group to group your eventbridge rule templates and to
attach to signal maps for dynamically creating notification rules.

# Arguments
- `name`: A resource's name. Names must be unique within the scope of a resource type in a
  specific region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A resource's optional description.
- `"tags"`:
"""
function create_event_bridge_rule_template_group(
    name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "POST",
        "/prod/eventbridge-rule-template-groups",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_event_bridge_rule_template_group(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "POST",
        "/prod/eventbridge-rule-template-groups",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_input()
    create_input(params::Dict{String,<:Any})

Create an input

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"destinations"`: Destination settings for PUSH type inputs.
- `"inputDevices"`: Settings for the devices.
- `"inputSecurityGroups"`: A list of security groups referenced by IDs to attach to the
  input.
- `"mediaConnectFlows"`: A list of the MediaConnect Flows that you want to use in this
  input. You can specify as few as one
Flow and presently, as many as two. The only
  requirement is when you have more than one is that each Flow is in a
separate Availability
  Zone as this ensures your EML input is redundant to AZ issues.
- `"name"`: Name of the input.
- `"requestId"`: Unique identifier of the request to ensure the request is handled
exactly
  once in case of retries.
- `"roleArn"`: The Amazon Resource Name (ARN) of the role this input assumes during and
  after creation.
- `"sources"`: The source URLs for a PULL-type input. Every PULL type input needs
exactly
  two source URLs for redundancy.
Only specify sources for PULL type Inputs. Leave
  Destinations empty.
- `"tags"`: A collection of key-value pairs.
- `"type"`:
- `"vpc"`:
"""
function create_input(; aws_config::AbstractAWSConfig=current_aws_config())
    return medialive(
        "POST",
        "/prod/inputs",
        Dict{String,Any}("requestId" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_input(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "POST",
        "/prod/inputs",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("requestId" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_input_security_group()
    create_input_security_group(params::Dict{String,<:Any})

Creates a Input Security Group

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tags"`: A collection of key-value pairs.
- `"whitelistRules"`: List of IPv4 CIDR addresses to whitelist
"""
function create_input_security_group(; aws_config::AbstractAWSConfig=current_aws_config())
    return medialive(
        "POST",
        "/prod/inputSecurityGroups";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_input_security_group(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "POST",
        "/prod/inputSecurityGroups",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_multiplex(availability_zones, multiplex_settings, name, request_id)
    create_multiplex(availability_zones, multiplex_settings, name, request_id, params::Dict{String,<:Any})

Create a new multiplex.

# Arguments
- `availability_zones`: A list of availability zones for the multiplex. You must specify
  exactly two.
- `multiplex_settings`: Configuration for a multiplex event.
- `name`: Name of multiplex.
- `request_id`: Unique request ID. This prevents retries from creating multiple
resources.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tags"`: A collection of key-value pairs.
"""
function create_multiplex(
    availabilityZones,
    multiplexSettings,
    name,
    requestId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "POST",
        "/prod/multiplexes",
        Dict{String,Any}(
            "availabilityZones" => availabilityZones,
            "multiplexSettings" => multiplexSettings,
            "name" => name,
            "requestId" => requestId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_multiplex(
    availabilityZones,
    multiplexSettings,
    name,
    requestId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "POST",
        "/prod/multiplexes",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "availabilityZones" => availabilityZones,
                    "multiplexSettings" => multiplexSettings,
                    "name" => name,
                    "requestId" => requestId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_multiplex_program(multiplex_id, multiplex_program_settings, program_name, request_id)
    create_multiplex_program(multiplex_id, multiplex_program_settings, program_name, request_id, params::Dict{String,<:Any})

Create a new program in the multiplex.

# Arguments
- `multiplex_id`: ID of the multiplex where the program is to be created.
- `multiplex_program_settings`: The settings for this multiplex program.
- `program_name`: Name of multiplex program.
- `request_id`: Unique request ID. This prevents retries from creating multiple
resources.

"""
function create_multiplex_program(
    multiplexId,
    multiplexProgramSettings,
    programName,
    requestId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "POST",
        "/prod/multiplexes/$(multiplexId)/programs",
        Dict{String,Any}(
            "multiplexProgramSettings" => multiplexProgramSettings,
            "programName" => programName,
            "requestId" => requestId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_multiplex_program(
    multiplexId,
    multiplexProgramSettings,
    programName,
    requestId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "POST",
        "/prod/multiplexes/$(multiplexId)/programs",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "multiplexProgramSettings" => multiplexProgramSettings,
                    "programName" => programName,
                    "requestId" => requestId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_partner_input(input_id)
    create_partner_input(input_id, params::Dict{String,<:Any})

Create a partner input

# Arguments
- `input_id`: Unique ID of the input.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"requestId"`: Unique identifier of the request to ensure the request is handled
exactly
  once in case of retries.
- `"tags"`: A collection of key-value pairs.
"""
function create_partner_input(inputId; aws_config::AbstractAWSConfig=current_aws_config())
    return medialive(
        "POST",
        "/prod/inputs/$(inputId)/partners",
        Dict{String,Any}("requestId" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_partner_input(
    inputId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "POST",
        "/prod/inputs/$(inputId)/partners",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("requestId" => string(uuid4())), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_signal_map(discovery_entry_point_arn, name)
    create_signal_map(discovery_entry_point_arn, name, params::Dict{String,<:Any})

Initiates the creation of a new signal map. Will discover a new mediaResourceMap based on
the provided discoveryEntryPointArn.

# Arguments
- `discovery_entry_point_arn`: A top-level supported AWS resource ARN to discovery a signal
  map from.
- `name`: A resource's name. Names must be unique within the scope of a resource type in a
  specific region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"cloudWatchAlarmTemplateGroupIdentifiers"`:
- `"description"`: A resource's optional description.
- `"eventBridgeRuleTemplateGroupIdentifiers"`:
- `"tags"`:
"""
function create_signal_map(
    discoveryEntryPointArn, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "POST",
        "/prod/signal-maps",
        Dict{String,Any}(
            "discoveryEntryPointArn" => discoveryEntryPointArn, "name" => name
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_signal_map(
    discoveryEntryPointArn,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "POST",
        "/prod/signal-maps",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "discoveryEntryPointArn" => discoveryEntryPointArn, "name" => name
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_tags(resource-arn)
    create_tags(resource-arn, params::Dict{String,<:Any})

Create tags for a resource

# Arguments
- `resource-arn`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tags"`:
"""
function create_tags(resource_arn; aws_config::AbstractAWSConfig=current_aws_config())
    return medialive(
        "POST",
        "/prod/tags/$(resource-arn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_tags(
    resource_arn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "POST",
        "/prod/tags/$(resource-arn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_channel(channel_id)
    delete_channel(channel_id, params::Dict{String,<:Any})

Starts deletion of channel. The associated outputs are also deleted.

# Arguments
- `channel_id`: Unique ID of the channel.

"""
function delete_channel(channelId; aws_config::AbstractAWSConfig=current_aws_config())
    return medialive(
        "DELETE",
        "/prod/channels/$(channelId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_channel(
    channelId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "DELETE",
        "/prod/channels/$(channelId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_cloud_watch_alarm_template(identifier)
    delete_cloud_watch_alarm_template(identifier, params::Dict{String,<:Any})

Deletes a cloudwatch alarm template.

# Arguments
- `identifier`: A cloudwatch alarm template's identifier. Can be either be its id or
  current name.

"""
function delete_cloud_watch_alarm_template(
    identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "DELETE",
        "/prod/cloudwatch-alarm-templates/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_cloud_watch_alarm_template(
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "DELETE",
        "/prod/cloudwatch-alarm-templates/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_cloud_watch_alarm_template_group(identifier)
    delete_cloud_watch_alarm_template_group(identifier, params::Dict{String,<:Any})

Deletes a cloudwatch alarm template group. You must detach this group from all signal maps
and ensure its existing templates are moved to another group or deleted.

# Arguments
- `identifier`: A cloudwatch alarm template group's identifier. Can be either be its id or
  current name.

"""
function delete_cloud_watch_alarm_template_group(
    identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "DELETE",
        "/prod/cloudwatch-alarm-template-groups/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_cloud_watch_alarm_template_group(
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "DELETE",
        "/prod/cloudwatch-alarm-template-groups/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_event_bridge_rule_template(identifier)
    delete_event_bridge_rule_template(identifier, params::Dict{String,<:Any})

Deletes an eventbridge rule template.

# Arguments
- `identifier`: An eventbridge rule template's identifier. Can be either be its id or
  current name.

"""
function delete_event_bridge_rule_template(
    identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "DELETE",
        "/prod/eventbridge-rule-templates/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_event_bridge_rule_template(
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "DELETE",
        "/prod/eventbridge-rule-templates/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_event_bridge_rule_template_group(identifier)
    delete_event_bridge_rule_template_group(identifier, params::Dict{String,<:Any})

Deletes an eventbridge rule template group. You must detach this group from all signal maps
and ensure its existing templates are moved to another group or deleted.

# Arguments
- `identifier`: An eventbridge rule template group's identifier. Can be either be its id or
  current name.

"""
function delete_event_bridge_rule_template_group(
    identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "DELETE",
        "/prod/eventbridge-rule-template-groups/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_event_bridge_rule_template_group(
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "DELETE",
        "/prod/eventbridge-rule-template-groups/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_input(input_id)
    delete_input(input_id, params::Dict{String,<:Any})

Deletes the input end point

# Arguments
- `input_id`: Unique ID of the input

"""
function delete_input(inputId; aws_config::AbstractAWSConfig=current_aws_config())
    return medialive(
        "DELETE",
        "/prod/inputs/$(inputId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_input(
    inputId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "DELETE",
        "/prod/inputs/$(inputId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_input_security_group(input_security_group_id)
    delete_input_security_group(input_security_group_id, params::Dict{String,<:Any})

Deletes an Input Security Group

# Arguments
- `input_security_group_id`: The Input Security Group to delete

"""
function delete_input_security_group(
    inputSecurityGroupId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "DELETE",
        "/prod/inputSecurityGroups/$(inputSecurityGroupId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_input_security_group(
    inputSecurityGroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "DELETE",
        "/prod/inputSecurityGroups/$(inputSecurityGroupId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_multiplex(multiplex_id)
    delete_multiplex(multiplex_id, params::Dict{String,<:Any})

Delete a multiplex. The multiplex must be idle.

# Arguments
- `multiplex_id`: The ID of the multiplex.

"""
function delete_multiplex(multiplexId; aws_config::AbstractAWSConfig=current_aws_config())
    return medialive(
        "DELETE",
        "/prod/multiplexes/$(multiplexId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_multiplex(
    multiplexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "DELETE",
        "/prod/multiplexes/$(multiplexId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_multiplex_program(multiplex_id, program_name)
    delete_multiplex_program(multiplex_id, program_name, params::Dict{String,<:Any})

Delete a program from a multiplex.

# Arguments
- `multiplex_id`: The ID of the multiplex that the program belongs to.
- `program_name`: The multiplex program name.

"""
function delete_multiplex_program(
    multiplexId, programName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "DELETE",
        "/prod/multiplexes/$(multiplexId)/programs/$(programName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_multiplex_program(
    multiplexId,
    programName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "DELETE",
        "/prod/multiplexes/$(multiplexId)/programs/$(programName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_reservation(reservation_id)
    delete_reservation(reservation_id, params::Dict{String,<:Any})

Delete an expired reservation.

# Arguments
- `reservation_id`: Unique reservation ID, e.g. '1234567'

"""
function delete_reservation(
    reservationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "DELETE",
        "/prod/reservations/$(reservationId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_reservation(
    reservationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "DELETE",
        "/prod/reservations/$(reservationId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_schedule(channel_id)
    delete_schedule(channel_id, params::Dict{String,<:Any})

Delete all schedule actions on a channel.

# Arguments
- `channel_id`: Id of the channel whose schedule is being deleted.

"""
function delete_schedule(channelId; aws_config::AbstractAWSConfig=current_aws_config())
    return medialive(
        "DELETE",
        "/prod/channels/$(channelId)/schedule";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_schedule(
    channelId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "DELETE",
        "/prod/channels/$(channelId)/schedule",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_signal_map(identifier)
    delete_signal_map(identifier, params::Dict{String,<:Any})

Deletes the specified signal map.

# Arguments
- `identifier`: A signal map's identifier. Can be either be its id or current name.

"""
function delete_signal_map(identifier; aws_config::AbstractAWSConfig=current_aws_config())
    return medialive(
        "DELETE",
        "/prod/signal-maps/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_signal_map(
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "DELETE",
        "/prod/signal-maps/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_tags(resource-arn, tag_keys)
    delete_tags(resource-arn, tag_keys, params::Dict{String,<:Any})

Removes tags for a resource

# Arguments
- `resource-arn`:
- `tag_keys`: An array of tag keys to delete

"""
function delete_tags(
    resource_arn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "DELETE",
        "/prod/tags/$(resource-arn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_tags(
    resource_arn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "DELETE",
        "/prod/tags/$(resource-arn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_account_configuration()
    describe_account_configuration(params::Dict{String,<:Any})

Describe account configuration

"""
function describe_account_configuration(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "GET",
        "/prod/accountConfiguration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_account_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "GET",
        "/prod/accountConfiguration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_channel(channel_id)
    describe_channel(channel_id, params::Dict{String,<:Any})

Gets details about a channel

# Arguments
- `channel_id`: channel ID

"""
function describe_channel(channelId; aws_config::AbstractAWSConfig=current_aws_config())
    return medialive(
        "GET",
        "/prod/channels/$(channelId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_channel(
    channelId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "GET",
        "/prod/channels/$(channelId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_input(input_id)
    describe_input(input_id, params::Dict{String,<:Any})

Produces details about an input

# Arguments
- `input_id`: Unique ID of the input

"""
function describe_input(inputId; aws_config::AbstractAWSConfig=current_aws_config())
    return medialive(
        "GET",
        "/prod/inputs/$(inputId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_input(
    inputId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "GET",
        "/prod/inputs/$(inputId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_input_device(input_device_id)
    describe_input_device(input_device_id, params::Dict{String,<:Any})

Gets the details for the input device

# Arguments
- `input_device_id`: The unique ID of this input device. For example, hd-123456789abcdef.

"""
function describe_input_device(
    inputDeviceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "GET",
        "/prod/inputDevices/$(inputDeviceId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_input_device(
    inputDeviceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "GET",
        "/prod/inputDevices/$(inputDeviceId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_input_device_thumbnail(accept, input_device_id)
    describe_input_device_thumbnail(accept, input_device_id, params::Dict{String,<:Any})

Get the latest thumbnail data for the input device.

# Arguments
- `accept`: The HTTP Accept header. Indicates the requested type for the thumbnail.
- `input_device_id`: The unique ID of this input device. For example, hd-123456789abcdef.

"""
function describe_input_device_thumbnail(
    accept, inputDeviceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "GET",
        "/prod/inputDevices/$(inputDeviceId)/thumbnailData",
        Dict{String,Any}("headers" => Dict{String,Any}("accept" => accept));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_input_device_thumbnail(
    accept,
    inputDeviceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "GET",
        "/prod/inputDevices/$(inputDeviceId)/thumbnailData",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("headers" => Dict{String,Any}("accept" => accept)),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_input_security_group(input_security_group_id)
    describe_input_security_group(input_security_group_id, params::Dict{String,<:Any})

Produces a summary of an Input Security Group

# Arguments
- `input_security_group_id`: The id of the Input Security Group to describe

"""
function describe_input_security_group(
    inputSecurityGroupId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "GET",
        "/prod/inputSecurityGroups/$(inputSecurityGroupId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_input_security_group(
    inputSecurityGroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "GET",
        "/prod/inputSecurityGroups/$(inputSecurityGroupId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_multiplex(multiplex_id)
    describe_multiplex(multiplex_id, params::Dict{String,<:Any})

Gets details about a multiplex.

# Arguments
- `multiplex_id`: The ID of the multiplex.

"""
function describe_multiplex(multiplexId; aws_config::AbstractAWSConfig=current_aws_config())
    return medialive(
        "GET",
        "/prod/multiplexes/$(multiplexId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_multiplex(
    multiplexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "GET",
        "/prod/multiplexes/$(multiplexId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_multiplex_program(multiplex_id, program_name)
    describe_multiplex_program(multiplex_id, program_name, params::Dict{String,<:Any})

Get the details for a program in a multiplex.

# Arguments
- `multiplex_id`: The ID of the multiplex that the program belongs to.
- `program_name`: The name of the program.

"""
function describe_multiplex_program(
    multiplexId, programName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "GET",
        "/prod/multiplexes/$(multiplexId)/programs/$(programName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_multiplex_program(
    multiplexId,
    programName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "GET",
        "/prod/multiplexes/$(multiplexId)/programs/$(programName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_offering(offering_id)
    describe_offering(offering_id, params::Dict{String,<:Any})

Get details for an offering.

# Arguments
- `offering_id`: Unique offering ID, e.g. '87654321'

"""
function describe_offering(offeringId; aws_config::AbstractAWSConfig=current_aws_config())
    return medialive(
        "GET",
        "/prod/offerings/$(offeringId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_offering(
    offeringId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "GET",
        "/prod/offerings/$(offeringId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_reservation(reservation_id)
    describe_reservation(reservation_id, params::Dict{String,<:Any})

Get details for a reservation.

# Arguments
- `reservation_id`: Unique reservation ID, e.g. '1234567'

"""
function describe_reservation(
    reservationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "GET",
        "/prod/reservations/$(reservationId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_reservation(
    reservationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "GET",
        "/prod/reservations/$(reservationId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_schedule(channel_id)
    describe_schedule(channel_id, params::Dict{String,<:Any})

Get a channel schedule

# Arguments
- `channel_id`: Id of the channel whose schedule is being updated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:
- `"nextToken"`:
"""
function describe_schedule(channelId; aws_config::AbstractAWSConfig=current_aws_config())
    return medialive(
        "GET",
        "/prod/channels/$(channelId)/schedule";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_schedule(
    channelId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "GET",
        "/prod/channels/$(channelId)/schedule",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_thumbnails(channel_id, pipeline_id, thumbnail_type)
    describe_thumbnails(channel_id, pipeline_id, thumbnail_type, params::Dict{String,<:Any})

Describe the latest thumbnails data.

# Arguments
- `channel_id`: Unique ID of the channel
- `pipeline_id`: Pipeline ID (\"0\" or \"1\")
- `thumbnail_type`: thumbnail type

"""
function describe_thumbnails(
    channelId, pipelineId, thumbnailType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "GET",
        "/prod/channels/$(channelId)/thumbnails",
        Dict{String,Any}("pipelineId" => pipelineId, "thumbnailType" => thumbnailType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_thumbnails(
    channelId,
    pipelineId,
    thumbnailType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "GET",
        "/prod/channels/$(channelId)/thumbnails",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "pipelineId" => pipelineId, "thumbnailType" => thumbnailType
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_cloud_watch_alarm_template(identifier)
    get_cloud_watch_alarm_template(identifier, params::Dict{String,<:Any})

Retrieves the specified cloudwatch alarm template.

# Arguments
- `identifier`: A cloudwatch alarm template's identifier. Can be either be its id or
  current name.

"""
function get_cloud_watch_alarm_template(
    identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "GET",
        "/prod/cloudwatch-alarm-templates/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_cloud_watch_alarm_template(
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "GET",
        "/prod/cloudwatch-alarm-templates/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_cloud_watch_alarm_template_group(identifier)
    get_cloud_watch_alarm_template_group(identifier, params::Dict{String,<:Any})

Retrieves the specified cloudwatch alarm template group.

# Arguments
- `identifier`: A cloudwatch alarm template group's identifier. Can be either be its id or
  current name.

"""
function get_cloud_watch_alarm_template_group(
    identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "GET",
        "/prod/cloudwatch-alarm-template-groups/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_cloud_watch_alarm_template_group(
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "GET",
        "/prod/cloudwatch-alarm-template-groups/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_event_bridge_rule_template(identifier)
    get_event_bridge_rule_template(identifier, params::Dict{String,<:Any})

Retrieves the specified eventbridge rule template.

# Arguments
- `identifier`: An eventbridge rule template's identifier. Can be either be its id or
  current name.

"""
function get_event_bridge_rule_template(
    identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "GET",
        "/prod/eventbridge-rule-templates/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_event_bridge_rule_template(
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "GET",
        "/prod/eventbridge-rule-templates/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_event_bridge_rule_template_group(identifier)
    get_event_bridge_rule_template_group(identifier, params::Dict{String,<:Any})

Retrieves the specified eventbridge rule template group.

# Arguments
- `identifier`: An eventbridge rule template group's identifier. Can be either be its id or
  current name.

"""
function get_event_bridge_rule_template_group(
    identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "GET",
        "/prod/eventbridge-rule-template-groups/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_event_bridge_rule_template_group(
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "GET",
        "/prod/eventbridge-rule-template-groups/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_signal_map(identifier)
    get_signal_map(identifier, params::Dict{String,<:Any})

Retrieves the specified signal map.

# Arguments
- `identifier`: A signal map's identifier. Can be either be its id or current name.

"""
function get_signal_map(identifier; aws_config::AbstractAWSConfig=current_aws_config())
    return medialive(
        "GET",
        "/prod/signal-maps/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_signal_map(
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "GET",
        "/prod/signal-maps/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_channels()
    list_channels(params::Dict{String,<:Any})

Produces list of channels that have been created

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:
- `"nextToken"`:
"""
function list_channels(; aws_config::AbstractAWSConfig=current_aws_config())
    return medialive(
        "GET", "/prod/channels"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_channels(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "GET",
        "/prod/channels",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_cloud_watch_alarm_template_groups()
    list_cloud_watch_alarm_template_groups(params::Dict{String,<:Any})

Lists cloudwatch alarm template groups.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:
- `"nextToken"`: A token used to retrieve the next set of results in paginated list
  responses.
- `"scope"`: Represents the scope of a resource, with options for all scopes, AWS provided
  resources, or local resources.
- `"signalMapIdentifier"`: A signal map's identifier. Can be either be its id or current
  name.
"""
function list_cloud_watch_alarm_template_groups(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "GET",
        "/prod/cloudwatch-alarm-template-groups";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_cloud_watch_alarm_template_groups(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "GET",
        "/prod/cloudwatch-alarm-template-groups",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_cloud_watch_alarm_templates()
    list_cloud_watch_alarm_templates(params::Dict{String,<:Any})

Lists cloudwatch alarm templates.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"groupIdentifier"`: A cloudwatch alarm template group's identifier. Can be either be its
  id or current name.
- `"maxResults"`:
- `"nextToken"`: A token used to retrieve the next set of results in paginated list
  responses.
- `"scope"`: Represents the scope of a resource, with options for all scopes, AWS provided
  resources, or local resources.
- `"signalMapIdentifier"`: A signal map's identifier. Can be either be its id or current
  name.
"""
function list_cloud_watch_alarm_templates(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "GET",
        "/prod/cloudwatch-alarm-templates";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_cloud_watch_alarm_templates(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "GET",
        "/prod/cloudwatch-alarm-templates",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_event_bridge_rule_template_groups()
    list_event_bridge_rule_template_groups(params::Dict{String,<:Any})

Lists eventbridge rule template groups.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:
- `"nextToken"`: A token used to retrieve the next set of results in paginated list
  responses.
- `"signalMapIdentifier"`: A signal map's identifier. Can be either be its id or current
  name.
"""
function list_event_bridge_rule_template_groups(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "GET",
        "/prod/eventbridge-rule-template-groups";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_event_bridge_rule_template_groups(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "GET",
        "/prod/eventbridge-rule-template-groups",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_event_bridge_rule_templates()
    list_event_bridge_rule_templates(params::Dict{String,<:Any})

Lists eventbridge rule templates.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"groupIdentifier"`: An eventbridge rule template group's identifier. Can be either be
  its id or current name.
- `"maxResults"`:
- `"nextToken"`: A token used to retrieve the next set of results in paginated list
  responses.
- `"signalMapIdentifier"`: A signal map's identifier. Can be either be its id or current
  name.
"""
function list_event_bridge_rule_templates(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "GET",
        "/prod/eventbridge-rule-templates";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_event_bridge_rule_templates(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "GET",
        "/prod/eventbridge-rule-templates",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_input_device_transfers(transfer_type)
    list_input_device_transfers(transfer_type, params::Dict{String,<:Any})

List input devices that are currently being transferred. List input devices that you are
transferring from your AWS account or input devices that another AWS account is
transferring to you.

# Arguments
- `transfer_type`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:
- `"nextToken"`:
"""
function list_input_device_transfers(
    transferType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "GET",
        "/prod/inputDeviceTransfers",
        Dict{String,Any}("transferType" => transferType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_input_device_transfers(
    transferType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "GET",
        "/prod/inputDeviceTransfers",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("transferType" => transferType), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_input_devices()
    list_input_devices(params::Dict{String,<:Any})

List input devices

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:
- `"nextToken"`:
"""
function list_input_devices(; aws_config::AbstractAWSConfig=current_aws_config())
    return medialive(
        "GET", "/prod/inputDevices"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_input_devices(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "GET",
        "/prod/inputDevices",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_input_security_groups()
    list_input_security_groups(params::Dict{String,<:Any})

Produces a list of Input Security Groups for an account

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:
- `"nextToken"`:
"""
function list_input_security_groups(; aws_config::AbstractAWSConfig=current_aws_config())
    return medialive(
        "GET",
        "/prod/inputSecurityGroups";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_input_security_groups(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "GET",
        "/prod/inputSecurityGroups",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_inputs()
    list_inputs(params::Dict{String,<:Any})

Produces list of inputs that have been created

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:
- `"nextToken"`:
"""
function list_inputs(; aws_config::AbstractAWSConfig=current_aws_config())
    return medialive(
        "GET", "/prod/inputs"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_inputs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "GET",
        "/prod/inputs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_multiplex_programs(multiplex_id)
    list_multiplex_programs(multiplex_id, params::Dict{String,<:Any})

List the programs that currently exist for a specific multiplex.

# Arguments
- `multiplex_id`: The ID of the multiplex that the programs belong to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of items to return.
- `"nextToken"`: The token to retrieve the next page of results.
"""
function list_multiplex_programs(
    multiplexId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "GET",
        "/prod/multiplexes/$(multiplexId)/programs";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_multiplex_programs(
    multiplexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "GET",
        "/prod/multiplexes/$(multiplexId)/programs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_multiplexes()
    list_multiplexes(params::Dict{String,<:Any})

Retrieve a list of the existing multiplexes.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of items to return.
- `"nextToken"`: The token to retrieve the next page of results.
"""
function list_multiplexes(; aws_config::AbstractAWSConfig=current_aws_config())
    return medialive(
        "GET", "/prod/multiplexes"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_multiplexes(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "GET",
        "/prod/multiplexes",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_offerings()
    list_offerings(params::Dict{String,<:Any})

List offerings available for purchase.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"channelClass"`: Filter by channel class, 'STANDARD' or 'SINGLE_PIPELINE'
- `"channelConfiguration"`: Filter to offerings that match the configuration of an existing
  channel, e.g. '2345678' (a channel ID)
- `"codec"`: Filter by codec, 'AVC', 'HEVC', 'MPEG2', 'AUDIO', or 'LINK'
- `"duration"`: Filter by offering duration, e.g. '12'
- `"maxResults"`:
- `"maximumBitrate"`: Filter by bitrate, 'MAX_10_MBPS', 'MAX_20_MBPS', or 'MAX_50_MBPS'
- `"maximumFramerate"`: Filter by framerate, 'MAX_30_FPS' or 'MAX_60_FPS'
- `"nextToken"`:
- `"resolution"`: Filter by resolution, 'SD', 'HD', 'FHD', or 'UHD'
- `"resourceType"`: Filter by resource type, 'INPUT', 'OUTPUT', 'MULTIPLEX', or 'CHANNEL'
- `"specialFeature"`: Filter by special feature, 'ADVANCED_AUDIO' or 'AUDIO_NORMALIZATION'
- `"videoQuality"`: Filter by video quality, 'STANDARD', 'ENHANCED', or 'PREMIUM'
"""
function list_offerings(; aws_config::AbstractAWSConfig=current_aws_config())
    return medialive(
        "GET", "/prod/offerings"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_offerings(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "GET",
        "/prod/offerings",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_reservations()
    list_reservations(params::Dict{String,<:Any})

List purchased reservations.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"channelClass"`: Filter by channel class, 'STANDARD' or 'SINGLE_PIPELINE'
- `"codec"`: Filter by codec, 'AVC', 'HEVC', 'MPEG2', 'AUDIO', or 'LINK'
- `"maxResults"`:
- `"maximumBitrate"`: Filter by bitrate, 'MAX_10_MBPS', 'MAX_20_MBPS', or 'MAX_50_MBPS'
- `"maximumFramerate"`: Filter by framerate, 'MAX_30_FPS' or 'MAX_60_FPS'
- `"nextToken"`:
- `"resolution"`: Filter by resolution, 'SD', 'HD', 'FHD', or 'UHD'
- `"resourceType"`: Filter by resource type, 'INPUT', 'OUTPUT', 'MULTIPLEX', or 'CHANNEL'
- `"specialFeature"`: Filter by special feature, 'ADVANCED_AUDIO' or 'AUDIO_NORMALIZATION'
- `"videoQuality"`: Filter by video quality, 'STANDARD', 'ENHANCED', or 'PREMIUM'
"""
function list_reservations(; aws_config::AbstractAWSConfig=current_aws_config())
    return medialive(
        "GET", "/prod/reservations"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_reservations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "GET",
        "/prod/reservations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_signal_maps()
    list_signal_maps(params::Dict{String,<:Any})

Lists signal maps.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"cloudWatchAlarmTemplateGroupIdentifier"`: A cloudwatch alarm template group's
  identifier. Can be either be its id or current name.
- `"eventBridgeRuleTemplateGroupIdentifier"`: An eventbridge rule template group's
  identifier. Can be either be its id or current name.
- `"maxResults"`:
- `"nextToken"`: A token used to retrieve the next set of results in paginated list
  responses.
"""
function list_signal_maps(; aws_config::AbstractAWSConfig=current_aws_config())
    return medialive(
        "GET", "/prod/signal-maps"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_signal_maps(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "GET",
        "/prod/signal-maps",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource-arn)
    list_tags_for_resource(resource-arn, params::Dict{String,<:Any})

Produces list of tags that have been created for a resource

# Arguments
- `resource-arn`:

"""
function list_tags_for_resource(
    resource_arn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "GET",
        "/prod/tags/$(resource-arn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resource_arn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "GET",
        "/prod/tags/$(resource-arn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    purchase_offering(count, offering_id)
    purchase_offering(count, offering_id, params::Dict{String,<:Any})

Purchase an offering and create a reservation.

# Arguments
- `count`: Number of resources
- `offering_id`: Offering to purchase, e.g. '87654321'

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"name"`: Name for the new reservation
- `"renewalSettings"`: Renewal settings for the reservation
- `"requestId"`: Unique request ID to be specified. This is needed to prevent retries from
  creating multiple resources.
- `"start"`: Requested reservation start time (UTC) in ISO-8601 format. The specified time
  must be between the first day of the current month and one year from now. If no value is
  given, the default is now.
- `"tags"`: A collection of key-value pairs
"""
function purchase_offering(
    count, offeringId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "POST",
        "/prod/offerings/$(offeringId)/purchase",
        Dict{String,Any}("count" => count, "requestId" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function purchase_offering(
    count,
    offeringId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "POST",
        "/prod/offerings/$(offeringId)/purchase",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("count" => count, "requestId" => string(uuid4())),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    reboot_input_device(input_device_id)
    reboot_input_device(input_device_id, params::Dict{String,<:Any})

Send a reboot command to the specified input device. The device will begin rebooting within
a few seconds of sending the command. When the reboot is complete, the device’s
connection status will change to connected.

# Arguments
- `input_device_id`: The unique ID of the input device to reboot. For example,
  hd-123456789abcdef.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"force"`: Force a reboot of an input device. If the device is streaming, it will stop
  streaming and begin rebooting within a few seconds of sending the command. If the device
  was streaming prior to the reboot, the device will resume streaming when the reboot
  completes.
"""
function reboot_input_device(
    inputDeviceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "POST",
        "/prod/inputDevices/$(inputDeviceId)/reboot";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function reboot_input_device(
    inputDeviceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "POST",
        "/prod/inputDevices/$(inputDeviceId)/reboot",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    reject_input_device_transfer(input_device_id)
    reject_input_device_transfer(input_device_id, params::Dict{String,<:Any})

Reject the transfer of the specified input device to your AWS account.

# Arguments
- `input_device_id`: The unique ID of the input device to reject. For example,
  hd-123456789abcdef.

"""
function reject_input_device_transfer(
    inputDeviceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "POST",
        "/prod/inputDevices/$(inputDeviceId)/reject";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function reject_input_device_transfer(
    inputDeviceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "POST",
        "/prod/inputDevices/$(inputDeviceId)/reject",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    restart_channel_pipelines(channel_id)
    restart_channel_pipelines(channel_id, params::Dict{String,<:Any})

Restart pipelines in one channel that is currently running.

# Arguments
- `channel_id`: ID of channel

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"pipelineIds"`: An array of pipelines to restart in this channel. Format PIPELINE_0 or
  PIPELINE_1.
"""
function restart_channel_pipelines(
    channelId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "POST",
        "/prod/channels/$(channelId)/restartChannelPipelines";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function restart_channel_pipelines(
    channelId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "POST",
        "/prod/channels/$(channelId)/restartChannelPipelines",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_channel(channel_id)
    start_channel(channel_id, params::Dict{String,<:Any})

Starts an existing channel

# Arguments
- `channel_id`: A request to start a channel

"""
function start_channel(channelId; aws_config::AbstractAWSConfig=current_aws_config())
    return medialive(
        "POST",
        "/prod/channels/$(channelId)/start";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_channel(
    channelId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "POST",
        "/prod/channels/$(channelId)/start",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_delete_monitor_deployment(identifier)
    start_delete_monitor_deployment(identifier, params::Dict{String,<:Any})

Initiates a deployment to delete the monitor of the specified signal map.

# Arguments
- `identifier`: A signal map's identifier. Can be either be its id or current name.

"""
function start_delete_monitor_deployment(
    identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "DELETE",
        "/prod/signal-maps/$(identifier)/monitor-deployment";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_delete_monitor_deployment(
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "DELETE",
        "/prod/signal-maps/$(identifier)/monitor-deployment",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_input_device(input_device_id)
    start_input_device(input_device_id, params::Dict{String,<:Any})

Start an input device that is attached to a MediaConnect flow. (There is no need to start a
device that is attached to a MediaLive input; MediaLive starts the device when the channel
starts.)

# Arguments
- `input_device_id`: The unique ID of the input device to start. For example,
  hd-123456789abcdef.

"""
function start_input_device(
    inputDeviceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "POST",
        "/prod/inputDevices/$(inputDeviceId)/start";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_input_device(
    inputDeviceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "POST",
        "/prod/inputDevices/$(inputDeviceId)/start",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_input_device_maintenance_window(input_device_id)
    start_input_device_maintenance_window(input_device_id, params::Dict{String,<:Any})

Start a maintenance window for the specified input device. Starting a maintenance window
will give the device up to two hours to install software. If the device was streaming prior
to the maintenance, it will resume streaming when the software is fully installed. Devices
automatically install updates while they are powered on and their MediaLive channels are
stopped. A maintenance window allows you to update a device without having to stop
MediaLive channels that use the device. The device must remain powered on and connected to
the internet for the duration of the maintenance.

# Arguments
- `input_device_id`: The unique ID of the input device to start a maintenance window for.
  For example, hd-123456789abcdef.

"""
function start_input_device_maintenance_window(
    inputDeviceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "POST",
        "/prod/inputDevices/$(inputDeviceId)/startInputDeviceMaintenanceWindow";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_input_device_maintenance_window(
    inputDeviceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "POST",
        "/prod/inputDevices/$(inputDeviceId)/startInputDeviceMaintenanceWindow",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_monitor_deployment(identifier)
    start_monitor_deployment(identifier, params::Dict{String,<:Any})

Initiates a deployment to deploy the latest monitor of the specified signal map.

# Arguments
- `identifier`: A signal map's identifier. Can be either be its id or current name.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"dryRun"`:
"""
function start_monitor_deployment(
    identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "POST",
        "/prod/signal-maps/$(identifier)/monitor-deployment";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_monitor_deployment(
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "POST",
        "/prod/signal-maps/$(identifier)/monitor-deployment",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_multiplex(multiplex_id)
    start_multiplex(multiplex_id, params::Dict{String,<:Any})

Start (run) the multiplex. Starting the multiplex does not start the channels. You must
explicitly start each channel.

# Arguments
- `multiplex_id`: The ID of the multiplex.

"""
function start_multiplex(multiplexId; aws_config::AbstractAWSConfig=current_aws_config())
    return medialive(
        "POST",
        "/prod/multiplexes/$(multiplexId)/start";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_multiplex(
    multiplexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "POST",
        "/prod/multiplexes/$(multiplexId)/start",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_update_signal_map(identifier)
    start_update_signal_map(identifier, params::Dict{String,<:Any})

Initiates an update for the specified signal map. Will discover a new signal map if a
changed discoveryEntryPointArn is provided.

# Arguments
- `identifier`: A signal map's identifier. Can be either be its id or current name.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"cloudWatchAlarmTemplateGroupIdentifiers"`:
- `"description"`: A resource's optional description.
- `"discoveryEntryPointArn"`: A top-level supported AWS resource ARN to discovery a signal
  map from.
- `"eventBridgeRuleTemplateGroupIdentifiers"`:
- `"forceRediscovery"`: If true, will force a rediscovery of a signal map if an unchanged
  discoveryEntryPointArn is provided.
- `"name"`: A resource's name. Names must be unique within the scope of a resource type in
  a specific region.
"""
function start_update_signal_map(
    identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "PATCH",
        "/prod/signal-maps/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_update_signal_map(
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "PATCH",
        "/prod/signal-maps/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_channel(channel_id)
    stop_channel(channel_id, params::Dict{String,<:Any})

Stops a running channel

# Arguments
- `channel_id`: A request to stop a running channel

"""
function stop_channel(channelId; aws_config::AbstractAWSConfig=current_aws_config())
    return medialive(
        "POST",
        "/prod/channels/$(channelId)/stop";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_channel(
    channelId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "POST",
        "/prod/channels/$(channelId)/stop",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_input_device(input_device_id)
    stop_input_device(input_device_id, params::Dict{String,<:Any})

Stop an input device that is attached to a MediaConnect flow. (There is no need to stop a
device that is attached to a MediaLive input; MediaLive automatically stops the device when
the channel stops.)

# Arguments
- `input_device_id`: The unique ID of the input device to stop. For example,
  hd-123456789abcdef.

"""
function stop_input_device(
    inputDeviceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "POST",
        "/prod/inputDevices/$(inputDeviceId)/stop";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_input_device(
    inputDeviceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "POST",
        "/prod/inputDevices/$(inputDeviceId)/stop",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_multiplex(multiplex_id)
    stop_multiplex(multiplex_id, params::Dict{String,<:Any})

Stops a running multiplex. If the multiplex isn't running, this action has no effect.

# Arguments
- `multiplex_id`: The ID of the multiplex.

"""
function stop_multiplex(multiplexId; aws_config::AbstractAWSConfig=current_aws_config())
    return medialive(
        "POST",
        "/prod/multiplexes/$(multiplexId)/stop";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_multiplex(
    multiplexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "POST",
        "/prod/multiplexes/$(multiplexId)/stop",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    transfer_input_device(input_device_id)
    transfer_input_device(input_device_id, params::Dict{String,<:Any})

Start an input device transfer to another AWS account. After you make the request, the
other account must accept or reject the transfer.

# Arguments
- `input_device_id`: The unique ID of this input device. For example, hd-123456789abcdef.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"targetCustomerId"`: The AWS account ID (12 digits) for the recipient of the device
  transfer.
- `"targetRegion"`: The target AWS region to transfer the device.
- `"transferMessage"`: An optional message for the recipient. Maximum 280 characters.
"""
function transfer_input_device(
    inputDeviceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "POST",
        "/prod/inputDevices/$(inputDeviceId)/transfer";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function transfer_input_device(
    inputDeviceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "POST",
        "/prod/inputDevices/$(inputDeviceId)/transfer",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_account_configuration()
    update_account_configuration(params::Dict{String,<:Any})

Update account configuration

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountConfiguration"`:
"""
function update_account_configuration(; aws_config::AbstractAWSConfig=current_aws_config())
    return medialive(
        "PUT",
        "/prod/accountConfiguration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_account_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "PUT",
        "/prod/accountConfiguration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_channel(channel_id)
    update_channel(channel_id, params::Dict{String,<:Any})

Updates a channel.

# Arguments
- `channel_id`: channel ID

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"cdiInputSpecification"`: Specification of CDI inputs for this channel
- `"destinations"`: A list of output destinations for this channel.
- `"encoderSettings"`: The encoder settings for this channel.
- `"inputAttachments"`:
- `"inputSpecification"`: Specification of network and file inputs for this channel
- `"logLevel"`: The log level to write to CloudWatch Logs.
- `"maintenance"`: Maintenance settings for this channel.
- `"name"`: The name of the channel.
- `"roleArn"`: An optional Amazon Resource Name (ARN) of the role to assume when running
  the Channel. If you do not specify this on an update call but the role was previously set
  that role will be removed.
"""
function update_channel(channelId; aws_config::AbstractAWSConfig=current_aws_config())
    return medialive(
        "PUT",
        "/prod/channels/$(channelId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_channel(
    channelId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "PUT",
        "/prod/channels/$(channelId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_channel_class(channel_class, channel_id)
    update_channel_class(channel_class, channel_id, params::Dict{String,<:Any})

Changes the class of the channel.

# Arguments
- `channel_class`: The channel class that you wish to update this channel to use.
- `channel_id`: Channel Id of the channel whose class should be updated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"destinations"`: A list of output destinations for this channel.
"""
function update_channel_class(
    channelClass, channelId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "PUT",
        "/prod/channels/$(channelId)/channelClass",
        Dict{String,Any}("channelClass" => channelClass);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_channel_class(
    channelClass,
    channelId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "PUT",
        "/prod/channels/$(channelId)/channelClass",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("channelClass" => channelClass), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_cloud_watch_alarm_template(identifier)
    update_cloud_watch_alarm_template(identifier, params::Dict{String,<:Any})

Updates the specified cloudwatch alarm template.

# Arguments
- `identifier`: A cloudwatch alarm template's identifier. Can be either be its id or
  current name.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"comparisonOperator"`:
- `"datapointsToAlarm"`: The number of datapoints within the evaluation period that must be
  breaching to trigger the alarm.
- `"description"`: A resource's optional description.
- `"evaluationPeriods"`: The number of periods over which data is compared to the specified
  threshold.
- `"groupIdentifier"`: A cloudwatch alarm template group's identifier. Can be either be its
  id or current name.
- `"metricName"`: The name of the metric associated with the alarm. Must be compatible with
  targetResourceType.
- `"name"`: A resource's name. Names must be unique within the scope of a resource type in
  a specific region.
- `"period"`: The period, in seconds, over which the specified statistic is applied.
- `"statistic"`:
- `"targetResourceType"`:
- `"threshold"`: The threshold value to compare with the specified statistic.
- `"treatMissingData"`:
"""
function update_cloud_watch_alarm_template(
    identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "PATCH",
        "/prod/cloudwatch-alarm-templates/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_cloud_watch_alarm_template(
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "PATCH",
        "/prod/cloudwatch-alarm-templates/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_cloud_watch_alarm_template_group(identifier)
    update_cloud_watch_alarm_template_group(identifier, params::Dict{String,<:Any})

Updates the specified cloudwatch alarm template group.

# Arguments
- `identifier`: A cloudwatch alarm template group's identifier. Can be either be its id or
  current name.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A resource's optional description.
"""
function update_cloud_watch_alarm_template_group(
    identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "PATCH",
        "/prod/cloudwatch-alarm-template-groups/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_cloud_watch_alarm_template_group(
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "PATCH",
        "/prod/cloudwatch-alarm-template-groups/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_event_bridge_rule_template(identifier)
    update_event_bridge_rule_template(identifier, params::Dict{String,<:Any})

Updates the specified eventbridge rule template.

# Arguments
- `identifier`: An eventbridge rule template's identifier. Can be either be its id or
  current name.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A resource's optional description.
- `"eventTargets"`:
- `"eventType"`:
- `"groupIdentifier"`: An eventbridge rule template group's identifier. Can be either be
  its id or current name.
- `"name"`: A resource's name. Names must be unique within the scope of a resource type in
  a specific region.
"""
function update_event_bridge_rule_template(
    identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "PATCH",
        "/prod/eventbridge-rule-templates/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_event_bridge_rule_template(
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "PATCH",
        "/prod/eventbridge-rule-templates/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_event_bridge_rule_template_group(identifier)
    update_event_bridge_rule_template_group(identifier, params::Dict{String,<:Any})

Updates the specified eventbridge rule template group.

# Arguments
- `identifier`: An eventbridge rule template group's identifier. Can be either be its id or
  current name.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A resource's optional description.
"""
function update_event_bridge_rule_template_group(
    identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "PATCH",
        "/prod/eventbridge-rule-template-groups/$(identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_event_bridge_rule_template_group(
    identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "PATCH",
        "/prod/eventbridge-rule-template-groups/$(identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_input(input_id)
    update_input(input_id, params::Dict{String,<:Any})

Updates an input.

# Arguments
- `input_id`: Unique ID of the input.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"destinations"`: Destination settings for PUSH type inputs.
- `"inputDevices"`: Settings for the devices.
- `"inputSecurityGroups"`: A list of security groups referenced by IDs to attach to the
  input.
- `"mediaConnectFlows"`: A list of the MediaConnect Flow ARNs that you want to use as the
  source of the input. You can specify as few as one
Flow and presently, as many as two. The
  only requirement is when you have more than one is that each Flow is in a
separate
  Availability Zone as this ensures your EML input is redundant to AZ issues.
- `"name"`: Name of the input.
- `"roleArn"`: The Amazon Resource Name (ARN) of the role this input assumes during and
  after creation.
- `"sources"`: The source URLs for a PULL-type input. Every PULL type input needs
exactly
  two source URLs for redundancy.
Only specify sources for PULL type Inputs. Leave
  Destinations empty.
"""
function update_input(inputId; aws_config::AbstractAWSConfig=current_aws_config())
    return medialive(
        "PUT",
        "/prod/inputs/$(inputId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_input(
    inputId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "PUT",
        "/prod/inputs/$(inputId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_input_device(input_device_id)
    update_input_device(input_device_id, params::Dict{String,<:Any})

Updates the parameters for the input device.

# Arguments
- `input_device_id`: The unique ID of the input device. For example, hd-123456789abcdef.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"availabilityZone"`: The Availability Zone you want associated with this input device.
- `"hdDeviceSettings"`: The settings that you want to apply to the HD input device.
- `"name"`: The name that you assigned to this input device (not the unique ID).
- `"uhdDeviceSettings"`: The settings that you want to apply to the UHD input device.
"""
function update_input_device(
    inputDeviceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "PUT",
        "/prod/inputDevices/$(inputDeviceId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_input_device(
    inputDeviceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "PUT",
        "/prod/inputDevices/$(inputDeviceId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_input_security_group(input_security_group_id)
    update_input_security_group(input_security_group_id, params::Dict{String,<:Any})

Update an Input Security Group's Whilelists.

# Arguments
- `input_security_group_id`: The id of the Input Security Group to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tags"`: A collection of key-value pairs.
- `"whitelistRules"`: List of IPv4 CIDR addresses to whitelist
"""
function update_input_security_group(
    inputSecurityGroupId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "PUT",
        "/prod/inputSecurityGroups/$(inputSecurityGroupId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_input_security_group(
    inputSecurityGroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "PUT",
        "/prod/inputSecurityGroups/$(inputSecurityGroupId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_multiplex(multiplex_id)
    update_multiplex(multiplex_id, params::Dict{String,<:Any})

Updates a multiplex.

# Arguments
- `multiplex_id`: ID of the multiplex to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"multiplexSettings"`: The new settings for a multiplex.
- `"name"`: Name of the multiplex.
"""
function update_multiplex(multiplexId; aws_config::AbstractAWSConfig=current_aws_config())
    return medialive(
        "PUT",
        "/prod/multiplexes/$(multiplexId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_multiplex(
    multiplexId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "PUT",
        "/prod/multiplexes/$(multiplexId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_multiplex_program(multiplex_id, program_name)
    update_multiplex_program(multiplex_id, program_name, params::Dict{String,<:Any})

Update a program in a multiplex.

# Arguments
- `multiplex_id`: The ID of the multiplex of the program to update.
- `program_name`: The name of the program to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"multiplexProgramSettings"`: The new settings for a multiplex program.
"""
function update_multiplex_program(
    multiplexId, programName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "PUT",
        "/prod/multiplexes/$(multiplexId)/programs/$(programName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_multiplex_program(
    multiplexId,
    programName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "PUT",
        "/prod/multiplexes/$(multiplexId)/programs/$(programName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_reservation(reservation_id)
    update_reservation(reservation_id, params::Dict{String,<:Any})

Update reservation.

# Arguments
- `reservation_id`: Unique reservation ID, e.g. '1234567'

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"name"`: Name of the reservation
- `"renewalSettings"`: Renewal settings for the reservation
"""
function update_reservation(
    reservationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return medialive(
        "PUT",
        "/prod/reservations/$(reservationId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_reservation(
    reservationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return medialive(
        "PUT",
        "/prod/reservations/$(reservationId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: kinesis_analytics_v2
using AWS.Compat
using AWS.UUIDs

"""
    add_application_cloud_watch_logging_option(application_name, cloud_watch_logging_option)
    add_application_cloud_watch_logging_option(application_name, cloud_watch_logging_option, params::Dict{String,<:Any})

Adds an Amazon CloudWatch log stream to monitor application configuration errors.

# Arguments
- `application_name`: The Kinesis Data Analytics application name.
- `cloud_watch_logging_option`: Provides the Amazon CloudWatch log stream Amazon Resource
  Name (ARN).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConditionalToken"`: A value you use to implement strong concurrency for application
  updates. You must provide the CurrentApplicationVersionId or the ConditionalToken. You get
  the application's current ConditionalToken using DescribeApplication. For better
  concurrency support, use the ConditionalToken parameter instead of
  CurrentApplicationVersionId.
- `"CurrentApplicationVersionId"`: The version ID of the SQL-based Kinesis Data Analytics
  application. You must provide the CurrentApplicationVersionId or the ConditionalToken.You
  can retrieve the application version ID using DescribeApplication. For better concurrency
  support, use the ConditionalToken parameter instead of CurrentApplicationVersionId.
"""
function add_application_cloud_watch_logging_option(
    ApplicationName,
    CloudWatchLoggingOption;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics_v2(
        "AddApplicationCloudWatchLoggingOption",
        Dict{String,Any}(
            "ApplicationName" => ApplicationName,
            "CloudWatchLoggingOption" => CloudWatchLoggingOption,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_application_cloud_watch_logging_option(
    ApplicationName,
    CloudWatchLoggingOption,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics_v2(
        "AddApplicationCloudWatchLoggingOption",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationName" => ApplicationName,
                    "CloudWatchLoggingOption" => CloudWatchLoggingOption,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    add_application_input(application_name, current_application_version_id, input)
    add_application_input(application_name, current_application_version_id, input, params::Dict{String,<:Any})

 Adds a streaming source to your SQL-based Kinesis Data Analytics application.  You can add
a streaming source when you create an application, or you can use this operation to add a
streaming source after you create an application. For more information, see
CreateApplication. Any configuration update, including adding a streaming source using this
operation, results in a new version of the application. You can use the DescribeApplication
operation to find the current application version.

# Arguments
- `application_name`: The name of your existing application to which you want to add the
  streaming source.
- `current_application_version_id`: The current version of your application. You must
  provide the ApplicationVersionID or the ConditionalToken.You can use the
  DescribeApplication operation to find the current application version.
- `input`: The Input to add.

"""
function add_application_input(
    ApplicationName,
    CurrentApplicationVersionId,
    Input;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics_v2(
        "AddApplicationInput",
        Dict{String,Any}(
            "ApplicationName" => ApplicationName,
            "CurrentApplicationVersionId" => CurrentApplicationVersionId,
            "Input" => Input,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_application_input(
    ApplicationName,
    CurrentApplicationVersionId,
    Input,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics_v2(
        "AddApplicationInput",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationName" => ApplicationName,
                    "CurrentApplicationVersionId" => CurrentApplicationVersionId,
                    "Input" => Input,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    add_application_input_processing_configuration(application_name, current_application_version_id, input_id, input_processing_configuration)
    add_application_input_processing_configuration(application_name, current_application_version_id, input_id, input_processing_configuration, params::Dict{String,<:Any})

Adds an InputProcessingConfiguration to a SQL-based Kinesis Data Analytics application. An
input processor pre-processes records on the input stream before the application's SQL code
executes. Currently, the only input processor available is Amazon Lambda.

# Arguments
- `application_name`: The name of the application to which you want to add the input
  processing configuration.
- `current_application_version_id`: The version of the application to which you want to add
  the input processing configuration. You can use the DescribeApplication operation to get
  the current application version. If the version specified is not the current version, the
  ConcurrentModificationException is returned.
- `input_id`: The ID of the input configuration to add the input processing configuration
  to. You can get a list of the input IDs for an application using the DescribeApplication
  operation.
- `input_processing_configuration`: The InputProcessingConfiguration to add to the
  application.

"""
function add_application_input_processing_configuration(
    ApplicationName,
    CurrentApplicationVersionId,
    InputId,
    InputProcessingConfiguration;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics_v2(
        "AddApplicationInputProcessingConfiguration",
        Dict{String,Any}(
            "ApplicationName" => ApplicationName,
            "CurrentApplicationVersionId" => CurrentApplicationVersionId,
            "InputId" => InputId,
            "InputProcessingConfiguration" => InputProcessingConfiguration,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_application_input_processing_configuration(
    ApplicationName,
    CurrentApplicationVersionId,
    InputId,
    InputProcessingConfiguration,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics_v2(
        "AddApplicationInputProcessingConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationName" => ApplicationName,
                    "CurrentApplicationVersionId" => CurrentApplicationVersionId,
                    "InputId" => InputId,
                    "InputProcessingConfiguration" => InputProcessingConfiguration,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    add_application_output(application_name, current_application_version_id, output)
    add_application_output(application_name, current_application_version_id, output, params::Dict{String,<:Any})

Adds an external destination to your SQL-based Kinesis Data Analytics application. If you
want Kinesis Data Analytics to deliver data from an in-application stream within your
application to an external destination (such as an Kinesis data stream, a Kinesis Data
Firehose delivery stream, or an Amazon Lambda function), you add the relevant configuration
to your application using this operation. You can configure one or more outputs for your
application. Each output configuration maps an in-application stream and an external
destination.  You can use one of the output configurations to deliver data from your
in-application error stream to an external destination so that you can analyze the errors.
 Any configuration update, including adding a streaming source using this operation,
results in a new version of the application. You can use the DescribeApplication operation
to find the current application version.

# Arguments
- `application_name`: The name of the application to which you want to add the output
  configuration.
- `current_application_version_id`: The version of the application to which you want to add
  the output configuration. You can use the DescribeApplication operation to get the current
  application version. If the version specified is not the current version, the
  ConcurrentModificationException is returned.
- `output`: An array of objects, each describing one output configuration. In the output
  configuration, you specify the name of an in-application stream, a destination (that is, a
  Kinesis data stream, a Kinesis Data Firehose delivery stream, or an Amazon Lambda
  function), and record the formation to use when writing to the destination.

"""
function add_application_output(
    ApplicationName,
    CurrentApplicationVersionId,
    Output;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics_v2(
        "AddApplicationOutput",
        Dict{String,Any}(
            "ApplicationName" => ApplicationName,
            "CurrentApplicationVersionId" => CurrentApplicationVersionId,
            "Output" => Output,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_application_output(
    ApplicationName,
    CurrentApplicationVersionId,
    Output,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics_v2(
        "AddApplicationOutput",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationName" => ApplicationName,
                    "CurrentApplicationVersionId" => CurrentApplicationVersionId,
                    "Output" => Output,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    add_application_reference_data_source(application_name, current_application_version_id, reference_data_source)
    add_application_reference_data_source(application_name, current_application_version_id, reference_data_source, params::Dict{String,<:Any})

Adds a reference data source to an existing SQL-based Kinesis Data Analytics application.
Kinesis Data Analytics reads reference data (that is, an Amazon S3 object) and creates an
in-application table within your application. In the request, you provide the source (S3
bucket name and object key name), name of the in-application table to create, and the
necessary mapping information that describes how data in an Amazon S3 object maps to
columns in the resulting in-application table.

# Arguments
- `application_name`: The name of an existing application.
- `current_application_version_id`: The version of the application for which you are adding
  the reference data source. You can use the DescribeApplication operation to get the current
  application version. If the version specified is not the current version, the
  ConcurrentModificationException is returned.
- `reference_data_source`: The reference data source can be an object in your Amazon S3
  bucket. Kinesis Data Analytics reads the object and copies the data into the in-application
  table that is created. You provide an S3 bucket, object key name, and the resulting
  in-application table that is created.

"""
function add_application_reference_data_source(
    ApplicationName,
    CurrentApplicationVersionId,
    ReferenceDataSource;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics_v2(
        "AddApplicationReferenceDataSource",
        Dict{String,Any}(
            "ApplicationName" => ApplicationName,
            "CurrentApplicationVersionId" => CurrentApplicationVersionId,
            "ReferenceDataSource" => ReferenceDataSource,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_application_reference_data_source(
    ApplicationName,
    CurrentApplicationVersionId,
    ReferenceDataSource,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics_v2(
        "AddApplicationReferenceDataSource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationName" => ApplicationName,
                    "CurrentApplicationVersionId" => CurrentApplicationVersionId,
                    "ReferenceDataSource" => ReferenceDataSource,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    add_application_vpc_configuration(application_name, vpc_configuration)
    add_application_vpc_configuration(application_name, vpc_configuration, params::Dict{String,<:Any})

Adds a Virtual Private Cloud (VPC) configuration to the application. Applications can use
VPCs to store and access resources securely. Note the following about VPC configurations
for Managed Service for Apache Flink applications:   VPC configurations are not supported
for SQL applications.   When a VPC is added to a Managed Service for Apache Flink
application, the application can no longer be accessed from the Internet directly. To
enable Internet access to the application, add an Internet gateway to your VPC.

# Arguments
- `application_name`: The name of an existing application.
- `vpc_configuration`: Description of the VPC to add to the application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConditionalToken"`: A value you use to implement strong concurrency for application
  updates. You must provide the ApplicationVersionID or the ConditionalToken. You get the
  application's current ConditionalToken using DescribeApplication. For better concurrency
  support, use the ConditionalToken parameter instead of CurrentApplicationVersionId.
- `"CurrentApplicationVersionId"`: The version of the application to which you want to add
  the VPC configuration. You must provide the CurrentApplicationVersionId or the
  ConditionalToken. You can use the DescribeApplication operation to get the current
  application version. If the version specified is not the current version, the
  ConcurrentModificationException is returned. For better concurrency support, use the
  ConditionalToken parameter instead of CurrentApplicationVersionId.
"""
function add_application_vpc_configuration(
    ApplicationName, VpcConfiguration; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_analytics_v2(
        "AddApplicationVpcConfiguration",
        Dict{String,Any}(
            "ApplicationName" => ApplicationName, "VpcConfiguration" => VpcConfiguration
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_application_vpc_configuration(
    ApplicationName,
    VpcConfiguration,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics_v2(
        "AddApplicationVpcConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationName" => ApplicationName,
                    "VpcConfiguration" => VpcConfiguration,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_application(application_name, runtime_environment, service_execution_role)
    create_application(application_name, runtime_environment, service_execution_role, params::Dict{String,<:Any})

Creates a Managed Service for Apache Flink application. For information about creating a
Managed Service for Apache Flink application, see Creating an Application.

# Arguments
- `application_name`: The name of your application (for example, sample-app).
- `runtime_environment`: The runtime environment for the application.
- `service_execution_role`: The IAM role used by the application to access Kinesis data
  streams, Kinesis Data Firehose delivery streams, Amazon S3 objects, and other external
  resources.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ApplicationConfiguration"`: Use this parameter to configure the application.
- `"ApplicationDescription"`: A summary description of the application.
- `"ApplicationMode"`: Use the STREAMING mode to create a Managed Service for Apache Flink
  application. To create a Managed Service for Apache Flink Studio notebook, use the
  INTERACTIVE mode.
- `"CloudWatchLoggingOptions"`: Use this parameter to configure an Amazon CloudWatch log
  stream to monitor application configuration errors.
- `"Tags"`: A list of one or more tags to assign to the application. A tag is a key-value
  pair that identifies an application. Note that the maximum number of application tags
  includes system tags. The maximum number of user-defined application tags is 50. For more
  information, see Using Tagging.
"""
function create_application(
    ApplicationName,
    RuntimeEnvironment,
    ServiceExecutionRole;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics_v2(
        "CreateApplication",
        Dict{String,Any}(
            "ApplicationName" => ApplicationName,
            "RuntimeEnvironment" => RuntimeEnvironment,
            "ServiceExecutionRole" => ServiceExecutionRole,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_application(
    ApplicationName,
    RuntimeEnvironment,
    ServiceExecutionRole,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics_v2(
        "CreateApplication",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationName" => ApplicationName,
                    "RuntimeEnvironment" => RuntimeEnvironment,
                    "ServiceExecutionRole" => ServiceExecutionRole,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_application_presigned_url(application_name, url_type)
    create_application_presigned_url(application_name, url_type, params::Dict{String,<:Any})

Creates and returns a URL that you can use to connect to an application's extension. The
IAM role or user used to call this API defines the permissions to access the extension.
After the presigned URL is created, no additional permission is required to access this
URL. IAM authorization policies for this API are also enforced for every HTTP request that
attempts to connect to the extension.  You control the amount of time that the URL will be
valid using the SessionExpirationDurationInSeconds parameter. If you do not provide this
parameter, the returned URL is valid for twelve hours.  The URL that you get from a call to
CreateApplicationPresignedUrl must be used within 3 minutes to be valid. If you first try
to use the URL after the 3-minute limit expires, the service returns an HTTP 403 Forbidden
error.

# Arguments
- `application_name`: The name of the application.
- `url_type`: The type of the extension for which to create and return a URL. Currently,
  the only valid extension URL type is FLINK_DASHBOARD_URL.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"SessionExpirationDurationInSeconds"`: The duration in seconds for which the returned
  URL will be valid.
"""
function create_application_presigned_url(
    ApplicationName, UrlType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_analytics_v2(
        "CreateApplicationPresignedUrl",
        Dict{String,Any}("ApplicationName" => ApplicationName, "UrlType" => UrlType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_application_presigned_url(
    ApplicationName,
    UrlType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics_v2(
        "CreateApplicationPresignedUrl",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationName" => ApplicationName, "UrlType" => UrlType
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_application_snapshot(application_name, snapshot_name)
    create_application_snapshot(application_name, snapshot_name, params::Dict{String,<:Any})

Creates a snapshot of the application's state data.

# Arguments
- `application_name`: The name of an existing application
- `snapshot_name`: An identifier for the application snapshot.

"""
function create_application_snapshot(
    ApplicationName, SnapshotName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_analytics_v2(
        "CreateApplicationSnapshot",
        Dict{String,Any}(
            "ApplicationName" => ApplicationName, "SnapshotName" => SnapshotName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_application_snapshot(
    ApplicationName,
    SnapshotName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics_v2(
        "CreateApplicationSnapshot",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationName" => ApplicationName, "SnapshotName" => SnapshotName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_application(application_name, create_timestamp)
    delete_application(application_name, create_timestamp, params::Dict{String,<:Any})

Deletes the specified application. Managed Service for Apache Flink halts application
execution and deletes the application.

# Arguments
- `application_name`: The name of the application to delete.
- `create_timestamp`: Use the DescribeApplication operation to get this value.

"""
function delete_application(
    ApplicationName, CreateTimestamp; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_analytics_v2(
        "DeleteApplication",
        Dict{String,Any}(
            "ApplicationName" => ApplicationName, "CreateTimestamp" => CreateTimestamp
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_application(
    ApplicationName,
    CreateTimestamp,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics_v2(
        "DeleteApplication",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationName" => ApplicationName,
                    "CreateTimestamp" => CreateTimestamp,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_application_cloud_watch_logging_option(application_name, cloud_watch_logging_option_id)
    delete_application_cloud_watch_logging_option(application_name, cloud_watch_logging_option_id, params::Dict{String,<:Any})

Deletes an Amazon CloudWatch log stream from an SQL-based Kinesis Data Analytics
application.

# Arguments
- `application_name`: The application name.
- `cloud_watch_logging_option_id`: The CloudWatchLoggingOptionId of the Amazon CloudWatch
  logging option to delete. You can get the CloudWatchLoggingOptionId by using the
  DescribeApplication operation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConditionalToken"`: A value you use to implement strong concurrency for application
  updates. You must provide the CurrentApplicationVersionId or the ConditionalToken. You get
  the application's current ConditionalToken using DescribeApplication. For better
  concurrency support, use the ConditionalToken parameter instead of
  CurrentApplicationVersionId.
- `"CurrentApplicationVersionId"`: The version ID of the application. You must provide the
  CurrentApplicationVersionId or the ConditionalToken. You can retrieve the application
  version ID using DescribeApplication. For better concurrency support, use the
  ConditionalToken parameter instead of CurrentApplicationVersionId.
"""
function delete_application_cloud_watch_logging_option(
    ApplicationName,
    CloudWatchLoggingOptionId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics_v2(
        "DeleteApplicationCloudWatchLoggingOption",
        Dict{String,Any}(
            "ApplicationName" => ApplicationName,
            "CloudWatchLoggingOptionId" => CloudWatchLoggingOptionId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_application_cloud_watch_logging_option(
    ApplicationName,
    CloudWatchLoggingOptionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics_v2(
        "DeleteApplicationCloudWatchLoggingOption",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationName" => ApplicationName,
                    "CloudWatchLoggingOptionId" => CloudWatchLoggingOptionId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_application_input_processing_configuration(application_name, current_application_version_id, input_id)
    delete_application_input_processing_configuration(application_name, current_application_version_id, input_id, params::Dict{String,<:Any})

Deletes an InputProcessingConfiguration from an input.

# Arguments
- `application_name`: The name of the application.
- `current_application_version_id`: The application version. You can use the
  DescribeApplication operation to get the current application version. If the version
  specified is not the current version, the ConcurrentModificationException is returned.
- `input_id`: The ID of the input configuration from which to delete the input processing
  configuration. You can get a list of the input IDs for an application by using the
  DescribeApplication operation.

"""
function delete_application_input_processing_configuration(
    ApplicationName,
    CurrentApplicationVersionId,
    InputId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics_v2(
        "DeleteApplicationInputProcessingConfiguration",
        Dict{String,Any}(
            "ApplicationName" => ApplicationName,
            "CurrentApplicationVersionId" => CurrentApplicationVersionId,
            "InputId" => InputId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_application_input_processing_configuration(
    ApplicationName,
    CurrentApplicationVersionId,
    InputId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics_v2(
        "DeleteApplicationInputProcessingConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationName" => ApplicationName,
                    "CurrentApplicationVersionId" => CurrentApplicationVersionId,
                    "InputId" => InputId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_application_output(application_name, current_application_version_id, output_id)
    delete_application_output(application_name, current_application_version_id, output_id, params::Dict{String,<:Any})

Deletes the output destination configuration from your SQL-based Kinesis Data Analytics
application's configuration. Kinesis Data Analytics will no longer write data from the
corresponding in-application stream to the external output destination.

# Arguments
- `application_name`: The application name.
- `current_application_version_id`: The application version. You can use the
  DescribeApplication operation to get the current application version. If the version
  specified is not the current version, the ConcurrentModificationException is returned.
- `output_id`: The ID of the configuration to delete. Each output configuration that is
  added to the application (either when the application is created or later) using the
  AddApplicationOutput operation has a unique ID. You need to provide the ID to uniquely
  identify the output configuration that you want to delete from the application
  configuration. You can use the DescribeApplication operation to get the specific OutputId.

"""
function delete_application_output(
    ApplicationName,
    CurrentApplicationVersionId,
    OutputId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics_v2(
        "DeleteApplicationOutput",
        Dict{String,Any}(
            "ApplicationName" => ApplicationName,
            "CurrentApplicationVersionId" => CurrentApplicationVersionId,
            "OutputId" => OutputId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_application_output(
    ApplicationName,
    CurrentApplicationVersionId,
    OutputId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics_v2(
        "DeleteApplicationOutput",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationName" => ApplicationName,
                    "CurrentApplicationVersionId" => CurrentApplicationVersionId,
                    "OutputId" => OutputId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_application_reference_data_source(application_name, current_application_version_id, reference_id)
    delete_application_reference_data_source(application_name, current_application_version_id, reference_id, params::Dict{String,<:Any})

Deletes a reference data source configuration from the specified SQL-based Kinesis Data
Analytics application's configuration. If the application is running, Kinesis Data
Analytics immediately removes the in-application table that you created using the
AddApplicationReferenceDataSource operation.

# Arguments
- `application_name`: The name of an existing application.
- `current_application_version_id`: The current application version. You can use the
  DescribeApplication operation to get the current application version. If the version
  specified is not the current version, the ConcurrentModificationException is returned.
- `reference_id`: The ID of the reference data source. When you add a reference data source
  to your application using the AddApplicationReferenceDataSource, Kinesis Data Analytics
  assigns an ID. You can use the DescribeApplication operation to get the reference ID.

"""
function delete_application_reference_data_source(
    ApplicationName,
    CurrentApplicationVersionId,
    ReferenceId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics_v2(
        "DeleteApplicationReferenceDataSource",
        Dict{String,Any}(
            "ApplicationName" => ApplicationName,
            "CurrentApplicationVersionId" => CurrentApplicationVersionId,
            "ReferenceId" => ReferenceId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_application_reference_data_source(
    ApplicationName,
    CurrentApplicationVersionId,
    ReferenceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics_v2(
        "DeleteApplicationReferenceDataSource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationName" => ApplicationName,
                    "CurrentApplicationVersionId" => CurrentApplicationVersionId,
                    "ReferenceId" => ReferenceId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_application_snapshot(application_name, snapshot_creation_timestamp, snapshot_name)
    delete_application_snapshot(application_name, snapshot_creation_timestamp, snapshot_name, params::Dict{String,<:Any})

Deletes a snapshot of application state.

# Arguments
- `application_name`: The name of an existing application.
- `snapshot_creation_timestamp`: The creation timestamp of the application snapshot to
  delete. You can retrieve this value using or .
- `snapshot_name`: The identifier for the snapshot delete.

"""
function delete_application_snapshot(
    ApplicationName,
    SnapshotCreationTimestamp,
    SnapshotName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics_v2(
        "DeleteApplicationSnapshot",
        Dict{String,Any}(
            "ApplicationName" => ApplicationName,
            "SnapshotCreationTimestamp" => SnapshotCreationTimestamp,
            "SnapshotName" => SnapshotName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_application_snapshot(
    ApplicationName,
    SnapshotCreationTimestamp,
    SnapshotName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics_v2(
        "DeleteApplicationSnapshot",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationName" => ApplicationName,
                    "SnapshotCreationTimestamp" => SnapshotCreationTimestamp,
                    "SnapshotName" => SnapshotName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_application_vpc_configuration(application_name, vpc_configuration_id)
    delete_application_vpc_configuration(application_name, vpc_configuration_id, params::Dict{String,<:Any})

Removes a VPC configuration from a Managed Service for Apache Flink application.

# Arguments
- `application_name`: The name of an existing application.
- `vpc_configuration_id`: The ID of the VPC configuration to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConditionalToken"`: A value you use to implement strong concurrency for application
  updates. You must provide the CurrentApplicationVersionId or the ConditionalToken. You get
  the application's current ConditionalToken using DescribeApplication. For better
  concurrency support, use the ConditionalToken parameter instead of
  CurrentApplicationVersionId.
- `"CurrentApplicationVersionId"`: The current application version ID. You must provide the
  CurrentApplicationVersionId or the ConditionalToken. You can retrieve the application
  version ID using DescribeApplication. For better concurrency support, use the
  ConditionalToken parameter instead of CurrentApplicationVersionId.
"""
function delete_application_vpc_configuration(
    ApplicationName, VpcConfigurationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_analytics_v2(
        "DeleteApplicationVpcConfiguration",
        Dict{String,Any}(
            "ApplicationName" => ApplicationName, "VpcConfigurationId" => VpcConfigurationId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_application_vpc_configuration(
    ApplicationName,
    VpcConfigurationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics_v2(
        "DeleteApplicationVpcConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationName" => ApplicationName,
                    "VpcConfigurationId" => VpcConfigurationId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_application(application_name)
    describe_application(application_name, params::Dict{String,<:Any})

Returns information about a specific Managed Service for Apache Flink application. If you
want to retrieve a list of all applications in your account, use the ListApplications
operation.

# Arguments
- `application_name`: The name of the application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"IncludeAdditionalDetails"`: Displays verbose information about a Managed Service for
  Apache Flink application, including the application's job plan.
"""
function describe_application(
    ApplicationName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_analytics_v2(
        "DescribeApplication",
        Dict{String,Any}("ApplicationName" => ApplicationName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_application(
    ApplicationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics_v2(
        "DescribeApplication",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ApplicationName" => ApplicationName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_application_snapshot(application_name, snapshot_name)
    describe_application_snapshot(application_name, snapshot_name, params::Dict{String,<:Any})

Returns information about a snapshot of application state data.

# Arguments
- `application_name`: The name of an existing application.
- `snapshot_name`: The identifier of an application snapshot. You can retrieve this value
  using .

"""
function describe_application_snapshot(
    ApplicationName, SnapshotName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_analytics_v2(
        "DescribeApplicationSnapshot",
        Dict{String,Any}(
            "ApplicationName" => ApplicationName, "SnapshotName" => SnapshotName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_application_snapshot(
    ApplicationName,
    SnapshotName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics_v2(
        "DescribeApplicationSnapshot",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationName" => ApplicationName, "SnapshotName" => SnapshotName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_application_version(application_name, application_version_id)
    describe_application_version(application_name, application_version_id, params::Dict{String,<:Any})

Provides a detailed description of a specified version of the application. To see a list of
all the versions of an application, invoke the ListApplicationVersions operation.  This
operation is supported only for Managed Service for Apache Flink.

# Arguments
- `application_name`: The name of the application for which you want to get the version
  description.
- `application_version_id`: The ID of the application version for which you want to get the
  description.

"""
function describe_application_version(
    ApplicationName,
    ApplicationVersionId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics_v2(
        "DescribeApplicationVersion",
        Dict{String,Any}(
            "ApplicationName" => ApplicationName,
            "ApplicationVersionId" => ApplicationVersionId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_application_version(
    ApplicationName,
    ApplicationVersionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics_v2(
        "DescribeApplicationVersion",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationName" => ApplicationName,
                    "ApplicationVersionId" => ApplicationVersionId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    discover_input_schema(service_execution_role)
    discover_input_schema(service_execution_role, params::Dict{String,<:Any})

Infers a schema for a SQL-based Kinesis Data Analytics application by evaluating sample
records on the specified streaming source (Kinesis data stream or Kinesis Data Firehose
delivery stream) or Amazon S3 object. In the response, the operation returns the inferred
schema and also the sample records that the operation used to infer the schema.  You can
use the inferred schema when configuring a streaming source for your application. When you
create an application using the Kinesis Data Analytics console, the console uses this
operation to infer a schema and show it in the console user interface.

# Arguments
- `service_execution_role`: The ARN of the role that is used to access the streaming source.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"InputProcessingConfiguration"`: The InputProcessingConfiguration to use to preprocess
  the records before discovering the schema of the records.
- `"InputStartingPositionConfiguration"`: The point at which you want Kinesis Data
  Analytics to start reading records from the specified streaming source for discovery
  purposes.
- `"ResourceARN"`: The Amazon Resource Name (ARN) of the streaming source.
- `"S3Configuration"`: Specify this parameter to discover a schema from data in an Amazon
  S3 object.
"""
function discover_input_schema(
    ServiceExecutionRole; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_analytics_v2(
        "DiscoverInputSchema",
        Dict{String,Any}("ServiceExecutionRole" => ServiceExecutionRole);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function discover_input_schema(
    ServiceExecutionRole,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics_v2(
        "DiscoverInputSchema",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ServiceExecutionRole" => ServiceExecutionRole),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_application_snapshots(application_name)
    list_application_snapshots(application_name, params::Dict{String,<:Any})

Lists information about the current application snapshots.

# Arguments
- `application_name`: The name of an existing application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: The maximum number of application snapshots to list.
- `"NextToken"`: Use this parameter if you receive a NextToken response in a previous
  request that indicates that there is more output available. Set it to the value of the
  previous call's NextToken response to indicate where the output should continue from.
"""
function list_application_snapshots(
    ApplicationName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_analytics_v2(
        "ListApplicationSnapshots",
        Dict{String,Any}("ApplicationName" => ApplicationName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_application_snapshots(
    ApplicationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics_v2(
        "ListApplicationSnapshots",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ApplicationName" => ApplicationName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_application_versions(application_name)
    list_application_versions(application_name, params::Dict{String,<:Any})

Lists all the versions for the specified application, including versions that were rolled
back. The response also includes a summary of the configuration associated with each
version. To get the complete description of a specific application version, invoke the
DescribeApplicationVersion operation.  This operation is supported only for Managed Service
for Apache Flink.

# Arguments
- `application_name`: The name of the application for which you want to list all versions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: The maximum number of versions to list in this invocation of the operation.
- `"NextToken"`: If a previous invocation of this operation returned a pagination token,
  pass it into this value to retrieve the next set of results. For more information about
  pagination, see Using the Amazon Command Line Interface's Pagination Options.
"""
function list_application_versions(
    ApplicationName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_analytics_v2(
        "ListApplicationVersions",
        Dict{String,Any}("ApplicationName" => ApplicationName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_application_versions(
    ApplicationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics_v2(
        "ListApplicationVersions",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ApplicationName" => ApplicationName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_applications()
    list_applications(params::Dict{String,<:Any})

Returns a list of Managed Service for Apache Flink applications in your account. For each
application, the response includes the application name, Amazon Resource Name (ARN), and
status.  If you want detailed information about a specific application, use
DescribeApplication.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Limit"`: The maximum number of applications to list.
- `"NextToken"`: If a previous command returned a pagination token, pass it into this value
  to retrieve the next set of results. For more information about pagination, see Using the
  Amazon Command Line Interface's Pagination Options.
"""
function list_applications(; aws_config::AbstractAWSConfig=current_aws_config())
    return kinesis_analytics_v2(
        "ListApplications"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_applications(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_analytics_v2(
        "ListApplications", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Retrieves the list of key-value tags assigned to the application. For more information, see
Using Tagging.

# Arguments
- `resource_arn`: The ARN of the application for which to retrieve tags.

"""
function list_tags_for_resource(
    ResourceARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_analytics_v2(
        "ListTagsForResource",
        Dict{String,Any}("ResourceARN" => ResourceARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics_v2(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceARN" => ResourceARN), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    rollback_application(application_name, current_application_version_id)
    rollback_application(application_name, current_application_version_id, params::Dict{String,<:Any})

Reverts the application to the previous running version. You can roll back an application
if you suspect it is stuck in a transient status.  You can roll back an application only if
it is in the UPDATING or AUTOSCALING status. When you rollback an application, it loads
state data from the last successful snapshot. If the application has no snapshots, Managed
Service for Apache Flink rejects the rollback request. This action is not supported for
Managed Service for Apache Flink for SQL applications.

# Arguments
- `application_name`: The name of the application.
- `current_application_version_id`: The current application version ID. You can retrieve
  the application version ID using DescribeApplication.

"""
function rollback_application(
    ApplicationName,
    CurrentApplicationVersionId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics_v2(
        "RollbackApplication",
        Dict{String,Any}(
            "ApplicationName" => ApplicationName,
            "CurrentApplicationVersionId" => CurrentApplicationVersionId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function rollback_application(
    ApplicationName,
    CurrentApplicationVersionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics_v2(
        "RollbackApplication",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationName" => ApplicationName,
                    "CurrentApplicationVersionId" => CurrentApplicationVersionId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_application(application_name)
    start_application(application_name, params::Dict{String,<:Any})

Starts the specified Managed Service for Apache Flink application. After creating an
application, you must exclusively call this operation to start your application.

# Arguments
- `application_name`: The name of the application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"RunConfiguration"`: Identifies the run configuration (start parameters) of a Managed
  Service for Apache Flink application.
"""
function start_application(
    ApplicationName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_analytics_v2(
        "StartApplication",
        Dict{String,Any}("ApplicationName" => ApplicationName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_application(
    ApplicationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics_v2(
        "StartApplication",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ApplicationName" => ApplicationName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_application(application_name)
    stop_application(application_name, params::Dict{String,<:Any})

Stops the application from processing data. You can stop an application only if it is in
the running status, unless you set the Force parameter to true. You can use the
DescribeApplication operation to find the application status.  Managed Service for Apache
Flink takes a snapshot when the application is stopped, unless Force is set to true.

# Arguments
- `application_name`: The name of the running application to stop.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Force"`: Set to true to force the application to stop. If you set Force to true,
  Managed Service for Apache Flink stops the application without taking a snapshot.
  Force-stopping your application may lead to data loss or duplication. To prevent data loss
  or duplicate processing of data during application restarts, we recommend you to take
  frequent snapshots of your application.  You can only force stop a Managed Service for
  Apache Flink application. You can't force stop a SQL-based Kinesis Data Analytics
  application. The application must be in the STARTING, UPDATING, STOPPING, AUTOSCALING, or
  RUNNING status.
"""
function stop_application(
    ApplicationName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_analytics_v2(
        "StopApplication",
        Dict{String,Any}("ApplicationName" => ApplicationName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_application(
    ApplicationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics_v2(
        "StopApplication",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ApplicationName" => ApplicationName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds one or more key-value tags to a Managed Service for Apache Flink application. Note
that the maximum number of application tags includes system tags. The maximum number of
user-defined application tags is 50. For more information, see Using Tagging.

# Arguments
- `resource_arn`: The ARN of the application to assign the tags.
- `tags`: The key-value tags to assign to the application.

"""
function tag_resource(ResourceARN, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return kinesis_analytics_v2(
        "TagResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceARN,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics_v2(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes one or more tags from a Managed Service for Apache Flink application. For more
information, see Using Tagging.

# Arguments
- `resource_arn`: The ARN of the Managed Service for Apache Flink application from which to
  remove the tags.
- `tag_keys`: A list of keys of tags to remove from the specified application.

"""
function untag_resource(
    ResourceARN, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_analytics_v2(
        "UntagResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceARN,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics_v2(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceARN" => ResourceARN, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_application(application_name)
    update_application(application_name, params::Dict{String,<:Any})

Updates an existing Managed Service for Apache Flink application. Using this operation, you
can update application code, input configuration, and output configuration.  Managed
Service for Apache Flink updates the ApplicationVersionId each time you update your
application.

# Arguments
- `application_name`: The name of the application to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ApplicationConfigurationUpdate"`: Describes application configuration updates.
- `"CloudWatchLoggingOptionUpdates"`: Describes application Amazon CloudWatch logging
  option updates. You can only update existing CloudWatch logging options with this action.
  To add a new CloudWatch logging option, use AddApplicationCloudWatchLoggingOption.
- `"ConditionalToken"`: A value you use to implement strong concurrency for application
  updates. You must provide the CurrentApplicationVersionId or the ConditionalToken. You get
  the application's current ConditionalToken using DescribeApplication. For better
  concurrency support, use the ConditionalToken parameter instead of
  CurrentApplicationVersionId.
- `"CurrentApplicationVersionId"`: The current application version ID. You must provide the
  CurrentApplicationVersionId or the ConditionalToken.You can retrieve the application
  version ID using DescribeApplication. For better concurrency support, use the
  ConditionalToken parameter instead of CurrentApplicationVersionId.
- `"RunConfigurationUpdate"`: Describes updates to the application's starting parameters.
- `"RuntimeEnvironmentUpdate"`: Updates the Managed Service for Apache Flink runtime
  environment used to run your code. To avoid issues you must:   Ensure your new jar and
  dependencies are compatible with the new runtime selected.   Ensure your new code's state
  is compatible with the snapshot from which your application will start
- `"ServiceExecutionRoleUpdate"`: Describes updates to the service execution role.
"""
function update_application(
    ApplicationName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return kinesis_analytics_v2(
        "UpdateApplication",
        Dict{String,Any}("ApplicationName" => ApplicationName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_application(
    ApplicationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics_v2(
        "UpdateApplication",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ApplicationName" => ApplicationName), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_application_maintenance_configuration(application_maintenance_configuration_update, application_name)
    update_application_maintenance_configuration(application_maintenance_configuration_update, application_name, params::Dict{String,<:Any})

Updates the maintenance configuration of the Managed Service for Apache Flink application.
You can invoke this operation on an application that is in one of the two following states:
READY or RUNNING. If you invoke it when the application is in a state other than these two
states, it throws a ResourceInUseException. The service makes use of the updated
configuration the next time it schedules maintenance for the application. If you invoke
this operation after the service schedules maintenance, the service will apply the
configuration update the next time it schedules maintenance for the application. This means
that you might not see the maintenance configuration update applied to the maintenance
process that follows a successful invocation of this operation, but to the following
maintenance process instead. To see the current maintenance configuration of your
application, invoke the DescribeApplication operation. For information about application
maintenance, see Managed Service for Apache Flink for Apache Flink Maintenance.  This
operation is supported only for Managed Service for Apache Flink.

# Arguments
- `application_maintenance_configuration_update`: Describes the application maintenance
  configuration update.
- `application_name`: The name of the application for which you want to update the
  maintenance configuration.

"""
function update_application_maintenance_configuration(
    ApplicationMaintenanceConfigurationUpdate,
    ApplicationName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics_v2(
        "UpdateApplicationMaintenanceConfiguration",
        Dict{String,Any}(
            "ApplicationMaintenanceConfigurationUpdate" =>
                ApplicationMaintenanceConfigurationUpdate,
            "ApplicationName" => ApplicationName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_application_maintenance_configuration(
    ApplicationMaintenanceConfigurationUpdate,
    ApplicationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return kinesis_analytics_v2(
        "UpdateApplicationMaintenanceConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationMaintenanceConfigurationUpdate" =>
                        ApplicationMaintenanceConfigurationUpdate,
                    "ApplicationName" => ApplicationName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

@testset "@service" begin
    @testset "ID only" begin
        #! format: off
        @eval baremodule __service_id_only
            using AWS: @service
            @service STS
        end
        #! format: on

        @test :STS in names(__service_id_only; all=true)
        @test __service_id_only.STS isa Module
    end

    @testset "non-existent service" begin
        #! format: off
        @eval module __service_non_existent_service
            using AWS: @service
            const ex = try
                @service x
            catch e
                e
            end
        end
        #! format: on

        @test __service_non_existent_service.ex isa SystemError
        @test :x in names(__service_non_existent_service; all=true)
    end

    @testset "returns module" begin
        #! format: off
        @eval baremodule __service_returns_module
            using AWS: @service
            const M = @service STS
        end
        #! format: on

        @test :STS in names(__service_returns_module; all=true)
        @test :M in names(__service_returns_module; all=true)
        @test nameof(__service_returns_module.M) === :STS
        @test __service_returns_module.M isa Module
        @test __service_returns_module.M === __service_returns_module.STS
    end

    @testset "case-insensitive" begin
        #! format: off
        @eval module __service_case_insenstive
            using AWS: @service
            @service Secrets_Manager
            @service SECRETS_MANAGER
            @service sECRETS_MANAGER
        end
        #! format: on

        @test :Secrets_Manager in names(__service_case_insenstive; all=true)
        @test :SECRETS_MANAGER in names(__service_case_insenstive; all=true)
        @test :sECRETS_MANAGER in names(__service_case_insenstive; all=true)

        @test __service_case_insenstive.Secrets_Manager !==
            __service_case_insenstive.SECRETS_MANAGER
        @test __service_case_insenstive.Secrets_Manager !==
            __service_case_insenstive.sECRETS_MANAGER
        @test __service_case_insenstive.SECRETS_MANAGER !==
            __service_case_insenstive.sECRETS_MANAGER
    end

    # The lowercase service ID conflicts with the low-level API binding name
    # (e.g. `using AWS.AWSServices: sts`)
    @testset "lowercase" begin
        # Produces this warning:
        # WARNING: import of AWSServices.sts into sts conflicts with an existing identifier; ignored
        #! format: off
        err = @capture_err begin
            @eval module __service_lowercase
                using AWS: @service
                @service sts
            end
        end
        #! format: on

        @test :sts in names(__service_lowercase; all=true)
        @test __service_lowercase.sts isa Module
        @test_broken __service_lowercase.sts.sts isa AWS.Service
        @test_broken isempty(err)
    end

    @testset "as" begin
        #! format: off
        @eval module __service_as
            using AWS: @service
            @service STS as SecurityTokenService
        end
        #! format: on

        @test nameof(__service_as.SecurityTokenService) === :SecurityTokenService
        @test __service_as.SecurityTokenService isa Module
        @test !(:STS in names(__service_as))
    end

    # These uses of the `@service` macro should not create a module
    @testset "invalid syntax" begin
        @test_throws MethodError @macroexpand @service()

        # These tests should always fail and never actually load a service. Ensure that we
        # are using a service which has not already been loaded.
        @test !(:Lambda in names(@__MODULE__; all=true))

        # Service ID is an expression
        @test_throws ArgumentError @macroexpand @service Lambda.X
        @test !(Symbol("Lambda.X") in names(@__MODULE__; all=true))

        # Module name is an expression
        @test_throws ArgumentError @macroexpand @service Lambda as Lambda.X
        @test !(:Lambda in names(@__MODULE__; all=true))
        @test !(Symbol("Lambda.X") in names(@__MODULE__; all=true))
    end
end

@testset "set user agent" begin
    old_user_agent = AWS.user_agent[]
    new_user_agent = "new user agent"

    try
        @test AWS.user_agent[] == "AWS.jl/$(pkgversion(AWS))"
        set_user_agent(new_user_agent)
        @test AWS.user_agent[] == new_user_agent
    finally
        set_user_agent(old_user_agent)
    end
end

@testset "sign" begin
    access_key = "access-key"
    secret_key = "ssh... it is a secret"

    creds = AWSCredentials(access_key, secret_key)
    aws = AWSConfig(; creds, region="us-east-1")

    time = DateTime(2020)
    date = Dates.format(time, dateformat"yyyymmdd")

    request = Request(;
        service="s3",
        api_version="api_version",
        request_method="GET",
        headers=LittleDict(
            "Host" => "s3.us-east-1.amazonaws.com", "User-Agent" => "AWS.jl/1.0.0"
        ),
        resource="/test-resource",
        url="https://s3.us-east-1.amazonaws.com/test-resource",
    )

    @testset "sign v2" begin
        result = AWS.sign_aws2!(aws, request, time)
        @test result === request
        content = result.content
        content_type = result.headers["Content-Type"]

        expected_access_key = "AWSAccessKeyId=$access_key"
        expected_expires = "Expires=2020-01-01T00%3A02%3A00Z"
        expected_signature_method = "SignatureMethod=HmacSHA256"
        expected_signature_version = "SignatureVersion=2"
        expected_signature = "Signature=O0MLzMKpEcfVZeHy0tyxVAuZF%2BvrvbgIGgqbWtJLTQ0%3D"

        expected_content = join(
            [
                expected_access_key,
                expected_expires,
                expected_signature_method,
                expected_signature_version,
                expected_signature,
            ],
            '&',
        )

        @test content == expected_content
    end

    @testset "sign v4" begin
        @testset "basic" begin
            expected_x_amz_content_sha256 = bytes2hex(digest(MD_SHA256, request.content))
            expected_content_md5 = base64encode(digest(MD_MD5, request.content))
            expected_x_amz_date = Dates.format(time, dateformat"yyyymmdd\THHMMSS\Z")

            result = AWS.sign_aws4!(aws, request, time)
            @test result === request
            headers = result.headers

            @test headers["x-amz-content-sha256"] == expected_x_amz_content_sha256
            @test headers["Content-MD5"] == expected_content_md5
            @test headers["x-amz-date"] == expected_x_amz_date

            authorization_header = split(headers["Authorization"], ' ')
            @test length(authorization_header) == 4
            @test authorization_header[1] == "AWS4-HMAC-SHA256"
            @test authorization_header[2] ==
                "Credential=$access_key/$date/us-east-1/$(request.service)/aws4_request,"
            @test authorization_header[3] ==
                "SignedHeaders=content-md5;content-type;host;user-agent;x-amz-content-sha256;x-amz-date,"
            @test authorization_header[4] ==
                "Signature=0f292eaf0b66cf353bafcb1b9b6d90ee27064236a60f17f6fc5bd7d40173a0be"
        end

        @testset "duplicate query params" begin
            request_query = deepcopy(request)
            request_query.url = "https://s3.us-east-1.amazonaws.com/test-resource?versions"

            request_dup = deepcopy(request)
            request_dup.url = "https://s3.us-east-1.amazonaws.com/test-resource?versions&versions="

            AWS.sign_aws4!(aws, request_query, time)
            AWS.sign_aws4!(aws, request_dup, time)

            authorization_header_query = split(request_query.headers["Authorization"], ' ')
            authorization_header_dup = split(request_dup.headers["Authorization"], ' ')

            @test length(authorization_header_query) == 4
            @test length(authorization_header_dup) == 4

            # Signatures should differ
            @test authorization_header_query[4] != authorization_header_dup[4]
        end
    end
end

@testset "submit_request" begin
    aws = AWSConfig(; creds=nothing, region="us-east-1")

    function _expected_xml(body::AbstractString, dict_type::Type)
        parsed = parse_xml(body)
        return xml_dict(XMLDict.root(parsed.x), dict_type)
    end

    @testset "301 redirect" begin
        request = Request(;
            service="s3",
            api_version="api_version",
            request_method="HEAD",
            url="https://s3.us-east-1.amazonaws.com/sample-bucket",
            use_response_type=true,
        )
        apply(Patches._aws_http_request_patch(Patches._response(; status=301))) do
            @test_throws AWSException AWS.submit_request(aws, request)
        end
    end

    @testset "HEAD response" begin
        request = Request(;
            service="s3",
            api_version="api_version",
            request_method="HEAD",
            url="https://s3.us-east-1.amazonaws.com/sample-bucket",
            use_response_type=true,
        )

        response = apply(Patches._aws_http_request_patch()) do
            AWS.submit_request(aws, request)
        end

        # Access to response headers
        @test response.response.headers == Patches.headers
        @test response.response.headers isa Vector

        # Access to streaming content
        @test response.io isa IO

        # Content as a string
        @test String(take!(response.io)) == Patches.body

        # Backwards compatibility with those expecting an `HTTP.Response`
        @test response.headers == Patches.headers
        @test response.headers isa Vector
        @test String(response.body) == Patches.body
    end

    @testset "GET response" begin
        request = Request(;
            service="s3",
            api_version="api_version",
            request_method="GET",
            url="https://s3.us-east-1.amazonaws.com/sample-bucket",
            use_response_type=true,
        )

        response = apply(Patches._aws_http_request_patch()) do
            AWS.submit_request(aws, request)
        end

        # Access to response headers
        @test response.response.headers == Patches.headers
        @test response.response.headers isa Vector

        # Access to streaming content
        @test response.io isa IO

        # Content as a string
        @test String(take!(response.io)) == Patches.body

        # Backwards compatibility with those expecting an `HTTP.Response`
        @test response.headers == Patches.headers
        @test response.headers isa Vector
        @test String(response.body) == Patches.body
    end

    @testset "Default throttling" begin
        request = Request(;
            service="s3",
            api_version="api_version",
            request_method="GET",
            url="https://s3.us-east-1.amazonaws.com/sample-bucket",
            use_response_type=true,
        )

        retries = Ref{Int}(0)
        exception = apply(Patches._throttling_patch(retries)) do
            try
                AWS.submit_request(aws, request)
                return nothing
            catch e
                if e isa AWSException
                    return e
                else
                    rethrow()
                end
            end
        end

        @test exception isa AWSException
        @test exception.code == "SlowDown"
        @test retries[] == AWS.max_attempts(aws)
    end

    @testset "Custom throttling" begin
        aws = AWSConfig(; creds=nothing, region="us-east-1", max_attempts=1)
        @test AWS.max_attempts(aws) == 1

        request = Request(;
            service="s3",
            api_version="api_version",
            request_method="GET",
            url="https://s3.us-east-1.amazonaws.com/sample-bucket",
            use_response_type=true,
        )

        retries = Ref{Int}(0)
        exception = apply(Patches._throttling_patch(retries)) do
            try
                AWS.submit_request(aws, request)
                return nothing
            catch e
                if e isa AWSException
                    return e
                else
                    rethrow()
                end
            end
        end

        @test exception isa AWSException
        @test exception.code == "SlowDown"
        @test retries[] == AWS.max_attempts(aws)
    end

    @testset "Not authorized" begin
        request = Request(;
            service="s3",
            api_version="api_version",
            request_method="GET",
            url="https://s3.us-east-1.amazonaws.com/sample-bucket",
            use_response_type=true,
        )

        message = "User is not authorized to perform: action on resource with an explicit deny"

        # Simulate the HTTP.request behaviour with a HTTP 400 response
        exception = apply(Patches.gen_http_options_400_patches(message)) do
            try
                AWS.submit_request(aws, request)
                return nothing
            catch e
                if e isa AWSException
                    return e
                else
                    rethrow()
                end
            end
        end

        @test exception isa AWSException

        # If handled incorrectly using a `response_stream` may result in the body data being
        # lost. Mainly, this is a problem when using a temporary I/O stream instead of
        # writing directly to the `response_stream`.
        @test exception.message == message
        @test exception.streamed_body !== nothing
    end

    @testset "Not authorized with BufferStream response_stream" begin
        buf = Base.BufferStream()
        request = Request(;
            service="s3",
            api_version="api_version",
            request_method="GET",
            url="https://s3.us-east-1.amazonaws.com/sample-bucket",
            response_stream=buf,
            use_response_type=true,
        )
        message = "User is not authorized to perform: action on resource with an explicit deny"
        # Simulate the HTTP.request behaviour with a HTTP 400 response
        exception = apply(Patches.gen_http_options_400_patches(message)) do
            try
                AWS.submit_request(aws, request)
                return nothing
            catch e
                if e isa AWSException
                    return e
                else
                    rethrow()
                end
            end
        end
        @test exception isa AWSException
        # If handled incorrectly using a `response_stream` may result in the body data being
        # lost. Mainly, this is a problem when using a temporary I/O stream instead of
        # writing directly to the `response_stream`.
        @test exception.message == message
        @test exception.streamed_body !== nothing
    end

    @testset "read MIME-type" begin
        request = Request(;
            service="s3",
            api_version="api_version",
            request_method="GET",
            url="https://s3.us-east-1.amazonaws.com/sample-bucket",
            use_response_type=true,
        )

        @testset "invalid content type" begin
            headers = Pair["Content-Type" => ""]
            body = ""
            expected_body_type = Vector{UInt8}
            expected_body = b""

            r = Patches._response(; headers=headers, body=body)
            response = apply(Patches._aws_http_request_patch(r)) do
                AWS.submit_request(aws, request)
            end

            content = parse(response)
            @test content isa expected_body_type
            @test content == expected_body
        end

        @testset "text/xml" begin
            headers = Pair["Content-Type" => "text/xml"]
            expected_body_type = LittleDict{Union{String,Symbol},Any}
            expected_body = _expected_xml(Patches.body, expected_body_type)

            r = Patches._response(; headers=headers)
            response = apply(Patches._aws_http_request_patch(r)) do
                AWS.submit_request(aws, request)
            end

            content = parse(response)
            @test content isa expected_body_type
            @test content == expected_body
        end

        @testset "application/xml" begin
            headers = Pair["Content-Type" => "application/xml"]
            expected_body_type = LittleDict{Union{String,Symbol},Any}
            expected_body = _expected_xml(Patches.body, expected_body_type)

            r = Patches._response(; headers=headers)
            response = apply(Patches._aws_http_request_patch(r)) do
                AWS.submit_request(aws, request)
            end

            content = parse(response)
            @test content isa expected_body_type
            @test content == expected_body
        end

        @testset "application/json" begin
            headers = ["Content-Type" => "application/json"]
            body = JSON.json(
                Dict{String,Any}(
                    "Marker" => nothing,
                    "VaultList" => Any[Dict{String,Any}(
                        "VaultName" => "test",
                        "SizeInBytes" => 0,
                        "NumberOfArchives" => 0,
                        "CreationDate" => "2020-06-22T03:14:41.754Z",
                        "VaultARN" => "arn:aws:glacier:us-east-1:000:vaults/test",
                        "LastInventoryDate" => nothing,
                    )],
                ),
            )

            expected_body_type = LittleDict{String,Any}
            expected_body = JSON.parse(body; dicttype=expected_body_type)

            r = Patches._response(; body=body, headers=headers)
            response = apply(Patches._aws_http_request_patch(r)) do
                AWS.submit_request(aws, request)
            end

            content = parse(response)
            @test content isa expected_body_type
            @test content == expected_body
        end

        @testset "text/html" begin
            headers = ["Content-Type" => "text/html"]
            expected_body = Patches.body

            r = Patches._response(; headers=headers)
            response = apply(Patches._aws_http_request_patch(r)) do
                AWS.submit_request(aws, request)
            end

            content = parse(response)
            @test content isa String
            @test content == expected_body
        end

        # Note: `S3.create_multipart_upload` is an example of a response type that doesn't
        # specify a Content-Type.
        @testset "missing content type" begin
            headers = Pair[]
            body = """
                <?xml version="1.0" encoding="UTF-8"?>
                <root><body>text</body></root>
                """
            expected_body_type = AbstractDict
            expected_body = Dict{String,Any}("body" => "text")

            r = Patches._response(; headers=headers, body=body)
            response = apply(Patches._aws_http_request_patch(r)) do
                AWS.submit_request(aws, request)
            end

            content = parse(response)
            @test content isa expected_body_type
            @test content == expected_body

            content = parse(response, MIME"text/plain"())
            @test content isa String
            @test content == body
        end
    end
end

struct TestBackend <: AWS.AbstractBackend
    param::Int
end

function AWS._http_request(backend::TestBackend, ::AWS.Request, ::IO)
    return backend.param
end

@testset "HTTPBackend" begin
    request = Request(;
        service="s3",
        api_version="api_version",
        request_method="GET",
        url="https://s3.us-east-1.amazonaws.com/sample-bucket",
        backend=AWS.HTTPBackend(),
    )
    io = IOBuffer()

    apply(Patches._http_options_patches) do
        # No default options
        @test isempty(AWS._http_request(request.backend, request, io))

        # We can pass HTTP options via the backend
        custom_backend = AWS.HTTPBackend(Dict(:connection_limit => 5))
        @test custom_backend isa AWS.AbstractBackend
        @test AWS._http_request(custom_backend, request, io) == Dict(:connection_limit => 5)

        # We can pass options per-request
        request.http_options = Dict(:pipeline_limit => 20)
        @test AWS._http_request(request.backend, request, io) == Dict(:pipeline_limit => 20)
        @test AWS._http_request(custom_backend, request, io) ==
            Dict(:pipeline_limit => 20, :connection_limit => 5)

        # per-request options override backend options:
        custom_backend = AWS.HTTPBackend(Dict(:pipeline_limit => 5))
        @test AWS._http_request(custom_backend, request, io) == Dict(:pipeline_limit => 20)
    end

    request.backend = TestBackend(2)
    @test AWS._http_request(request.backend, request, io) == 2

    request = Request(;
        service="s3",
        api_version="api_version",
        request_method="GET",
        url="https://s3.us-east-1.amazonaws.com/sample-bucket",
        backend=TestBackend(4),
    )
    @test AWS._http_request(request.backend, request, io) == 4

    # Let's test setting the default backend
    prev_backend = AWS.DEFAULT_BACKEND[]
    try
        AWS.DEFAULT_BACKEND[] = TestBackend(3)
        request = Request(;
            service="s3",
            api_version="api_version",
            request_method="GET",
            url="https://s3.us-east-1.amazonaws.com/sample-bucket",
        )
        @test AWS._http_request(request.backend, request, io) == 3
    finally
        AWS.DEFAULT_BACKEND[] = prev_backend
    end
end

@testset "_generate_rest_resource" begin
    request_uri = "/{Bucket}/{Key+}"
    args = Dict{String,Any}("Bucket" => "aws.jl-test", "Key" => "Test-Key")

    expected = "/$(args["Bucket"])/$(args["Key"])"
    result = AWS._generate_rest_resource(request_uri, args)
    @test result == expected
end

@testset "generate_service_url" begin
    region = "us-east-2"
    resource = "/aws.jl-test---timestamp"
    config = AWSConfig(; creds=nothing, region)

    request = Request(;
        service="service",
        api_version="api_version",
        request_method="GET",
        resource=resource,
    )

    @testset "regionless endpoints" for regionless_endpoint in ("iam", "route53")
        endpoint = "sdb"
        request.service = regionless_endpoint
        expected_result = "https://$regionless_endpoint.amazonaws.com$resource"
        result = AWS.generate_service_url(config, request.service, request.resource)

        @test result == expected_result
    end

    @testset "region service" begin
        endpoint = "sdb"
        request.service = endpoint
        expected_result = "https://$endpoint.$region.amazonaws.com$resource"
        result = AWS.generate_service_url(config, request.service, request.resource)

        @test result == expected_result
    end

    @testset "sdb -- us-east-1 region exception" begin
        endpoint = "sdb"
        request.service = endpoint
        expected_result = "https://$endpoint.amazonaws.com$resource"
        config.region = "us-east-1"
        result = AWS.generate_service_url(config, request.service, request.resource)

        @test result == expected_result
    end
end

@testset "_flatten_query" begin
    high_level_value = "high_level_value"
    entry_1 = LittleDict(
        "low_level_key_1" => "low_level_value_1", "low_level_key_2" => "low_level_value_2"
    )
    entry_2 = LittleDict(
        "low_level_key_3" => "low_level_value_3", "low_level_key_4" => "low_level_value_4"
    )

    args = LittleDict(
        "high_level_key" => high_level_value, "high_level_array" => [entry_1, entry_2]
    )

    @testset "non-special case suffix" begin
        service = "sts"
        result = AWS._flatten_query(service, args)

        expected = Pair{String,String}[
            "high_level_key" => "high_level_value",
            "high_level_array.member.1.low_level_key_1" => "low_level_value_1",
            "high_level_array.member.1.low_level_key_2" => "low_level_value_2",
            "high_level_array.member.2.low_level_key_3" => "low_level_value_3",
            "high_level_array.member.2.low_level_key_4" => "low_level_value_4",
        ]

        @test result == expected
    end

    @testset "sqs - special casing suffix" begin
        service = "sqs"
        result = AWS._flatten_query(service, args)

        expected = Pair{String,String}[
            "high_level_key" => "high_level_value",
            "high_level_array.1.low_level_key_1" => "low_level_value_1",
            "high_level_array.1.low_level_key_2" => "low_level_value_2",
            "high_level_array.2.low_level_key_3" => "low_level_value_3",
            "high_level_array.2.low_level_key_4" => "low_level_value_4",
        ]

        @test result == expected
    end
end

@testset "_clean_s3_uri" begin
    uri = "/test-bucket/*)=('! +@,:.txt?list-objects=v2"
    expected_uri = "/test-bucket/%2A%29%3D%28%27%21%20%2B%40%2C%3A.txt?list-objects=v2"
    @test AWS._clean_s3_uri(uri) == expected_uri

    # make sure that other parts of the uri aren't changed by `_clean_s3_uri`
    for uri in (
        "https://julialang.org",
        "http://julialang.org",
        "http://julialang.org:8080",
        "/onlypath",
        "/path?query=  +99",
        "/anchor?query=yes#anchor1",
    )
        @test AWS._clean_s3_uri(uri) == uri
    end
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: emr_containers
using AWS.Compat
using AWS.UUIDs

"""
    cancel_job_run(job_run_id, virtual_cluster_id)
    cancel_job_run(job_run_id, virtual_cluster_id, params::Dict{String,<:Any})

Cancels a job run. A job run is a unit of work, such as a Spark jar, PySpark script, or
SparkSQL query, that you submit to Amazon EMR on EKS.

# Arguments
- `job_run_id`: The ID of the job run to cancel.
- `virtual_cluster_id`: The ID of the virtual cluster for which the job run will be
  canceled.

"""
function cancel_job_run(
    jobRunId, virtualClusterId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr_containers(
        "DELETE",
        "/virtualclusters/$(virtualClusterId)/jobruns/$(jobRunId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_job_run(
    jobRunId,
    virtualClusterId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr_containers(
        "DELETE",
        "/virtualclusters/$(virtualClusterId)/jobruns/$(jobRunId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_job_template(client_token, job_template_data, name)
    create_job_template(client_token, job_template_data, name, params::Dict{String,<:Any})

Creates a job template. Job template stores values of StartJobRun API request in a template
and can be used to start a job run. Job template allows two use cases: avoid repeating
recurring StartJobRun API request values, enforcing certain values in StartJobRun API
request.

# Arguments
- `client_token`: The client token of the job template.
- `job_template_data`: The job template data which holds values of StartJobRun API request.
- `name`: The specified name of the job template.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"kmsKeyArn"`: The KMS key ARN used to encrypt the job template.
- `"tags"`: The tags that are associated with the job template.
"""
function create_job_template(
    clientToken, jobTemplateData, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr_containers(
        "POST",
        "/jobtemplates",
        Dict{String,Any}(
            "clientToken" => clientToken,
            "jobTemplateData" => jobTemplateData,
            "name" => name,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_job_template(
    clientToken,
    jobTemplateData,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr_containers(
        "POST",
        "/jobtemplates",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "clientToken" => clientToken,
                    "jobTemplateData" => jobTemplateData,
                    "name" => name,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_managed_endpoint(client_token, execution_role_arn, name, release_label, type, virtual_cluster_id)
    create_managed_endpoint(client_token, execution_role_arn, name, release_label, type, virtual_cluster_id, params::Dict{String,<:Any})

Creates a managed endpoint. A managed endpoint is a gateway that connects Amazon EMR Studio
to Amazon EMR on EKS so that Amazon EMR Studio can communicate with your virtual cluster.

# Arguments
- `client_token`: The client idempotency token for this create call.
- `execution_role_arn`: The ARN of the execution role.
- `name`: The name of the managed endpoint.
- `release_label`: The Amazon EMR release version.
- `type`: The type of the managed endpoint.
- `virtual_cluster_id`: The ID of the virtual cluster for which a managed endpoint is
  created.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"certificateArn"`: The certificate ARN provided by users for the managed endpoint. This
  field is under deprecation and will be removed in future releases.
- `"configurationOverrides"`: The configuration settings that will be used to override
  existing configurations.
- `"tags"`: The tags of the managed endpoint.
"""
function create_managed_endpoint(
    clientToken,
    executionRoleArn,
    name,
    releaseLabel,
    type,
    virtualClusterId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr_containers(
        "POST",
        "/virtualclusters/$(virtualClusterId)/endpoints",
        Dict{String,Any}(
            "clientToken" => clientToken,
            "executionRoleArn" => executionRoleArn,
            "name" => name,
            "releaseLabel" => releaseLabel,
            "type" => type,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_managed_endpoint(
    clientToken,
    executionRoleArn,
    name,
    releaseLabel,
    type,
    virtualClusterId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr_containers(
        "POST",
        "/virtualclusters/$(virtualClusterId)/endpoints",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "clientToken" => clientToken,
                    "executionRoleArn" => executionRoleArn,
                    "name" => name,
                    "releaseLabel" => releaseLabel,
                    "type" => type,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_security_configuration(client_token, name, security_configuration_data)
    create_security_configuration(client_token, name, security_configuration_data, params::Dict{String,<:Any})

Creates a security configuration. Security configurations in Amazon EMR on EKS are
templates for different security setups. You can use security configurations to configure
the Lake Formation integration setup. You can also create a security configuration to
re-use a security setup each time you create a virtual cluster.

# Arguments
- `client_token`: The client idempotency token to use when creating the security
  configuration.
- `name`: The name of the security configuration.
- `security_configuration_data`: Security configuration input for the request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tags"`: The tags to add to the security configuration.
"""
function create_security_configuration(
    clientToken,
    name,
    securityConfigurationData;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr_containers(
        "POST",
        "/securityconfigurations",
        Dict{String,Any}(
            "clientToken" => clientToken,
            "name" => name,
            "securityConfigurationData" => securityConfigurationData,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_security_configuration(
    clientToken,
    name,
    securityConfigurationData,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr_containers(
        "POST",
        "/securityconfigurations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "clientToken" => clientToken,
                    "name" => name,
                    "securityConfigurationData" => securityConfigurationData,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_virtual_cluster(client_token, container_provider, name)
    create_virtual_cluster(client_token, container_provider, name, params::Dict{String,<:Any})

Creates a virtual cluster. Virtual cluster is a managed entity on Amazon EMR on EKS. You
can create, describe, list and delete virtual clusters. They do not consume any additional
resource in your system. A single virtual cluster maps to a single Kubernetes namespace.
Given this relationship, you can model virtual clusters the same way you model Kubernetes
namespaces to meet your requirements.

# Arguments
- `client_token`: The client token of the virtual cluster.
- `container_provider`: The container provider of the virtual cluster.
- `name`: The specified name of the virtual cluster.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"securityConfigurationId"`: The ID of the security configuration.
- `"tags"`: The tags assigned to the virtual cluster.
"""
function create_virtual_cluster(
    clientToken, containerProvider, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr_containers(
        "POST",
        "/virtualclusters",
        Dict{String,Any}(
            "clientToken" => clientToken,
            "containerProvider" => containerProvider,
            "name" => name,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_virtual_cluster(
    clientToken,
    containerProvider,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr_containers(
        "POST",
        "/virtualclusters",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "clientToken" => clientToken,
                    "containerProvider" => containerProvider,
                    "name" => name,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_job_template(template_id)
    delete_job_template(template_id, params::Dict{String,<:Any})

Deletes a job template. Job template stores values of StartJobRun API request in a template
and can be used to start a job run. Job template allows two use cases: avoid repeating
recurring StartJobRun API request values, enforcing certain values in StartJobRun API
request.

# Arguments
- `template_id`: The ID of the job template that will be deleted.

"""
function delete_job_template(templateId; aws_config::AbstractAWSConfig=current_aws_config())
    return emr_containers(
        "DELETE",
        "/jobtemplates/$(templateId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_job_template(
    templateId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr_containers(
        "DELETE",
        "/jobtemplates/$(templateId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_managed_endpoint(endpoint_id, virtual_cluster_id)
    delete_managed_endpoint(endpoint_id, virtual_cluster_id, params::Dict{String,<:Any})

Deletes a managed endpoint. A managed endpoint is a gateway that connects Amazon EMR Studio
to Amazon EMR on EKS so that Amazon EMR Studio can communicate with your virtual cluster.

# Arguments
- `endpoint_id`: The ID of the managed endpoint.
- `virtual_cluster_id`: The ID of the endpoint's virtual cluster.

"""
function delete_managed_endpoint(
    endpointId, virtualClusterId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr_containers(
        "DELETE",
        "/virtualclusters/$(virtualClusterId)/endpoints/$(endpointId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_managed_endpoint(
    endpointId,
    virtualClusterId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr_containers(
        "DELETE",
        "/virtualclusters/$(virtualClusterId)/endpoints/$(endpointId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_virtual_cluster(virtual_cluster_id)
    delete_virtual_cluster(virtual_cluster_id, params::Dict{String,<:Any})

Deletes a virtual cluster. Virtual cluster is a managed entity on Amazon EMR on EKS. You
can create, describe, list and delete virtual clusters. They do not consume any additional
resource in your system. A single virtual cluster maps to a single Kubernetes namespace.
Given this relationship, you can model virtual clusters the same way you model Kubernetes
namespaces to meet your requirements.

# Arguments
- `virtual_cluster_id`: The ID of the virtual cluster that will be deleted.

"""
function delete_virtual_cluster(
    virtualClusterId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr_containers(
        "DELETE",
        "/virtualclusters/$(virtualClusterId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_virtual_cluster(
    virtualClusterId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr_containers(
        "DELETE",
        "/virtualclusters/$(virtualClusterId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_job_run(job_run_id, virtual_cluster_id)
    describe_job_run(job_run_id, virtual_cluster_id, params::Dict{String,<:Any})

Displays detailed information about a job run. A job run is a unit of work, such as a Spark
jar, PySpark script, or SparkSQL query, that you submit to Amazon EMR on EKS.

# Arguments
- `job_run_id`: The ID of the job run request.
- `virtual_cluster_id`: The ID of the virtual cluster for which the job run is submitted.

"""
function describe_job_run(
    jobRunId, virtualClusterId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr_containers(
        "GET",
        "/virtualclusters/$(virtualClusterId)/jobruns/$(jobRunId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_job_run(
    jobRunId,
    virtualClusterId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr_containers(
        "GET",
        "/virtualclusters/$(virtualClusterId)/jobruns/$(jobRunId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_job_template(template_id)
    describe_job_template(template_id, params::Dict{String,<:Any})

Displays detailed information about a specified job template. Job template stores values of
StartJobRun API request in a template and can be used to start a job run. Job template
allows two use cases: avoid repeating recurring StartJobRun API request values, enforcing
certain values in StartJobRun API request.

# Arguments
- `template_id`: The ID of the job template that will be described.

"""
function describe_job_template(
    templateId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr_containers(
        "GET",
        "/jobtemplates/$(templateId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_job_template(
    templateId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr_containers(
        "GET",
        "/jobtemplates/$(templateId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_managed_endpoint(endpoint_id, virtual_cluster_id)
    describe_managed_endpoint(endpoint_id, virtual_cluster_id, params::Dict{String,<:Any})

Displays detailed information about a managed endpoint. A managed endpoint is a gateway
that connects Amazon EMR Studio to Amazon EMR on EKS so that Amazon EMR Studio can
communicate with your virtual cluster.

# Arguments
- `endpoint_id`: This output displays ID of the managed endpoint.
- `virtual_cluster_id`: The ID of the endpoint's virtual cluster.

"""
function describe_managed_endpoint(
    endpointId, virtualClusterId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr_containers(
        "GET",
        "/virtualclusters/$(virtualClusterId)/endpoints/$(endpointId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_managed_endpoint(
    endpointId,
    virtualClusterId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr_containers(
        "GET",
        "/virtualclusters/$(virtualClusterId)/endpoints/$(endpointId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_security_configuration(security_configuration_id)
    describe_security_configuration(security_configuration_id, params::Dict{String,<:Any})

Displays detailed information about a specified security configuration. Security
configurations in Amazon EMR on EKS are templates for different security setups. You can
use security configurations to configure the Lake Formation integration setup. You can also
create a security configuration to re-use a security setup each time you create a virtual
cluster.

# Arguments
- `security_configuration_id`: The ID of the security configuration.

"""
function describe_security_configuration(
    securityConfigurationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr_containers(
        "GET",
        "/securityconfigurations/$(securityConfigurationId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_security_configuration(
    securityConfigurationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr_containers(
        "GET",
        "/securityconfigurations/$(securityConfigurationId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_virtual_cluster(virtual_cluster_id)
    describe_virtual_cluster(virtual_cluster_id, params::Dict{String,<:Any})

Displays detailed information about a specified virtual cluster. Virtual cluster is a
managed entity on Amazon EMR on EKS. You can create, describe, list and delete virtual
clusters. They do not consume any additional resource in your system. A single virtual
cluster maps to a single Kubernetes namespace. Given this relationship, you can model
virtual clusters the same way you model Kubernetes namespaces to meet your requirements.

# Arguments
- `virtual_cluster_id`: The ID of the virtual cluster that will be described.

"""
function describe_virtual_cluster(
    virtualClusterId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr_containers(
        "GET",
        "/virtualclusters/$(virtualClusterId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_virtual_cluster(
    virtualClusterId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr_containers(
        "GET",
        "/virtualclusters/$(virtualClusterId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_managed_endpoint_session_credentials(credential_type, endpoint_id, execution_role_arn, virtual_cluster_id)
    get_managed_endpoint_session_credentials(credential_type, endpoint_id, execution_role_arn, virtual_cluster_id, params::Dict{String,<:Any})

Generate a session token to connect to a managed endpoint.

# Arguments
- `credential_type`: Type of the token requested. Currently supported and default value of
  this field is “TOKEN.”
- `endpoint_id`: The ARN of the managed endpoint for which the request is submitted.
- `execution_role_arn`: The IAM Execution Role ARN that will be used by the job run.
- `virtual_cluster_id`: The ARN of the Virtual Cluster which the Managed Endpoint belongs
  to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: The client idempotency token of the job run request.
- `"durationInSeconds"`: Duration in seconds for which the session token is valid. The
  default duration is 15 minutes and the maximum is 12 hours.
- `"logContext"`: String identifier used to separate sections of the execution logs
  uploaded to S3.
"""
function get_managed_endpoint_session_credentials(
    credentialType,
    endpointId,
    executionRoleArn,
    virtualClusterId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr_containers(
        "POST",
        "/virtualclusters/$(virtualClusterId)/endpoints/$(endpointId)/credentials",
        Dict{String,Any}(
            "credentialType" => credentialType,
            "executionRoleArn" => executionRoleArn,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_managed_endpoint_session_credentials(
    credentialType,
    endpointId,
    executionRoleArn,
    virtualClusterId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr_containers(
        "POST",
        "/virtualclusters/$(virtualClusterId)/endpoints/$(endpointId)/credentials",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "credentialType" => credentialType,
                    "executionRoleArn" => executionRoleArn,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_job_runs(virtual_cluster_id)
    list_job_runs(virtual_cluster_id, params::Dict{String,<:Any})

Lists job runs based on a set of parameters. A job run is a unit of work, such as a Spark
jar, PySpark script, or SparkSQL query, that you submit to Amazon EMR on EKS.

# Arguments
- `virtual_cluster_id`: The ID of the virtual cluster for which to list the job run.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"createdAfter"`: The date and time after which the job runs were submitted.
- `"createdBefore"`: The date and time before which the job runs were submitted.
- `"maxResults"`: The maximum number of job runs that can be listed.
- `"name"`: The name of the job run.
- `"nextToken"`: The token for the next set of job runs to return.
- `"states"`: The states of the job run.
"""
function list_job_runs(virtualClusterId; aws_config::AbstractAWSConfig=current_aws_config())
    return emr_containers(
        "GET",
        "/virtualclusters/$(virtualClusterId)/jobruns";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_job_runs(
    virtualClusterId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr_containers(
        "GET",
        "/virtualclusters/$(virtualClusterId)/jobruns",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_job_templates()
    list_job_templates(params::Dict{String,<:Any})

Lists job templates based on a set of parameters. Job template stores values of StartJobRun
API request in a template and can be used to start a job run. Job template allows two use
cases: avoid repeating recurring StartJobRun API request values, enforcing certain values
in StartJobRun API request.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"createdAfter"`: The date and time after which the job templates were created.
- `"createdBefore"`:  The date and time before which the job templates were created.
- `"maxResults"`:  The maximum number of job templates that can be listed.
- `"nextToken"`:  The token for the next set of job templates to return.
"""
function list_job_templates(; aws_config::AbstractAWSConfig=current_aws_config())
    return emr_containers(
        "GET", "/jobtemplates"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_job_templates(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr_containers(
        "GET",
        "/jobtemplates",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_managed_endpoints(virtual_cluster_id)
    list_managed_endpoints(virtual_cluster_id, params::Dict{String,<:Any})

Lists managed endpoints based on a set of parameters. A managed endpoint is a gateway that
connects Amazon EMR Studio to Amazon EMR on EKS so that Amazon EMR Studio can communicate
with your virtual cluster.

# Arguments
- `virtual_cluster_id`: The ID of the virtual cluster.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"createdAfter"`:  The date and time after which the endpoints are created.
- `"createdBefore"`: The date and time before which the endpoints are created.
- `"maxResults"`: The maximum number of managed endpoints that can be listed.
- `"nextToken"`:  The token for the next set of managed endpoints to return.
- `"states"`: The states of the managed endpoints.
- `"types"`: The types of the managed endpoints.
"""
function list_managed_endpoints(
    virtualClusterId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr_containers(
        "GET",
        "/virtualclusters/$(virtualClusterId)/endpoints";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_managed_endpoints(
    virtualClusterId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr_containers(
        "GET",
        "/virtualclusters/$(virtualClusterId)/endpoints",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_security_configurations()
    list_security_configurations(params::Dict{String,<:Any})

Lists security configurations based on a set of parameters. Security configurations in
Amazon EMR on EKS are templates for different security setups. You can use security
configurations to configure the Lake Formation integration setup. You can also create a
security configuration to re-use a security setup each time you create a virtual cluster.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"createdAfter"`: The date and time after which the security configuration was created.
- `"createdBefore"`: The date and time before which the security configuration was created.
- `"maxResults"`: The maximum number of security configurations the operation can list.
- `"nextToken"`: The token for the next set of security configurations to return.
"""
function list_security_configurations(; aws_config::AbstractAWSConfig=current_aws_config())
    return emr_containers(
        "GET",
        "/securityconfigurations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_security_configurations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr_containers(
        "GET",
        "/securityconfigurations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists the tags assigned to the resources.

# Arguments
- `resource_arn`: The ARN of tagged resources.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr_containers(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr_containers(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_virtual_clusters()
    list_virtual_clusters(params::Dict{String,<:Any})

Lists information about the specified virtual cluster. Virtual cluster is a managed entity
on Amazon EMR on EKS. You can create, describe, list and delete virtual clusters. They do
not consume any additional resource in your system. A single virtual cluster maps to a
single Kubernetes namespace. Given this relationship, you can model virtual clusters the
same way you model Kubernetes namespaces to meet your requirements.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"containerProviderId"`: The container provider ID of the virtual cluster.
- `"containerProviderType"`: The container provider type of the virtual cluster. Amazon EKS
  is the only supported type as of now.
- `"createdAfter"`: The date and time after which the virtual clusters are created.
- `"createdBefore"`: The date and time before which the virtual clusters are created.
- `"eksAccessEntryIntegrated"`: Optional Boolean that specifies whether the operation
  should return the virtual clusters that have the access entry integration enabled or
  disabled. If not specified, the operation returns all applicable virtual clusters.
- `"maxResults"`: The maximum number of virtual clusters that can be listed.
- `"nextToken"`: The token for the next set of virtual clusters to return.
- `"states"`: The states of the requested virtual clusters.
"""
function list_virtual_clusters(; aws_config::AbstractAWSConfig=current_aws_config())
    return emr_containers(
        "GET", "/virtualclusters"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_virtual_clusters(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr_containers(
        "GET",
        "/virtualclusters",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_job_run(client_token, virtual_cluster_id)
    start_job_run(client_token, virtual_cluster_id, params::Dict{String,<:Any})

Starts a job run. A job run is a unit of work, such as a Spark jar, PySpark script, or
SparkSQL query, that you submit to Amazon EMR on EKS.

# Arguments
- `client_token`: The client idempotency token of the job run request.
- `virtual_cluster_id`: The virtual cluster ID for which the job run request is submitted.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"configurationOverrides"`: The configuration overrides for the job run.
- `"executionRoleArn"`: The execution role ARN for the job run.
- `"jobDriver"`: The job driver for the job run.
- `"jobTemplateId"`: The job template ID to be used to start the job run.
- `"jobTemplateParameters"`: The values of job template parameters to start a job run.
- `"name"`: The name of the job run.
- `"releaseLabel"`: The Amazon EMR release version to use for the job run.
- `"retryPolicyConfiguration"`: The retry policy configuration for the job run.
- `"tags"`: The tags assigned to job runs.
"""
function start_job_run(
    clientToken, virtualClusterId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr_containers(
        "POST",
        "/virtualclusters/$(virtualClusterId)/jobruns",
        Dict{String,Any}("clientToken" => clientToken);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_job_run(
    clientToken,
    virtualClusterId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr_containers(
        "POST",
        "/virtualclusters/$(virtualClusterId)/jobruns",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => clientToken), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Assigns tags to resources. A tag is a label that you assign to an Amazon Web Services
resource. Each tag consists of a key and an optional value, both of which you define. Tags
enable you to categorize your Amazon Web Services resources by attributes such as purpose,
owner, or environment. When you have many resources of the same type, you can quickly
identify a specific resource based on the tags you've assigned to it. For example, you can
define a set of tags for your Amazon EMR on EKS clusters to help you track each cluster's
owner and stack level. We recommend that you devise a consistent set of tag keys for each
resource type. You can then search and filter the resources based on the tags that you add.

# Arguments
- `resource_arn`: The ARN of resources.
- `tags`: The tags assigned to resources.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return emr_containers(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr_containers(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes tags from resources.

# Arguments
- `resource_arn`: The ARN of resources.
- `tag_keys`: The tag keys of the resources.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return emr_containers(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return emr_containers(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: grafana
using AWS.Compat
using AWS.UUIDs

"""
    associate_license(license_type, workspace_id)
    associate_license(license_type, workspace_id, params::Dict{String,<:Any})

Assigns a Grafana Enterprise license to a workspace. To upgrade, you must use ENTERPRISE
for the licenseType, and pass in a valid Grafana Labs token for the grafanaToken. Upgrading
to Grafana Enterprise incurs additional fees. For more information, see Upgrade a workspace
to Grafana Enterprise.

# Arguments
- `license_type`: The type of license to associate with the workspace.  Amazon Managed
  Grafana workspaces no longer support Grafana Enterprise free trials.
- `workspace_id`: The ID of the workspace to associate the license with.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Grafana-Token"`: A token from Grafana Labs that ties your Amazon Web Services account
  with a Grafana Labs account. For more information, see Link your account with Grafana Labs.
"""
function associate_license(
    licenseType, workspaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return grafana(
        "POST",
        "/workspaces/$(workspaceId)/licenses/$(licenseType)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_license(
    licenseType,
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return grafana(
        "POST",
        "/workspaces/$(workspaceId)/licenses/$(licenseType)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_workspace(account_access_type, authentication_providers, permission_type)
    create_workspace(account_access_type, authentication_providers, permission_type, params::Dict{String,<:Any})

Creates a workspace. In a workspace, you can create Grafana dashboards and visualizations
to analyze your metrics, logs, and traces. You don't have to build, package, or deploy any
hardware to run the Grafana server. Don't use CreateWorkspace to modify an existing
workspace. Instead, use UpdateWorkspace.

# Arguments
- `account_access_type`: Specifies whether the workspace can access Amazon Web Services
  resources in this Amazon Web Services account only, or whether it can also access Amazon
  Web Services resources in other accounts in the same organization. If you specify
  ORGANIZATION, you must specify which organizational units the workspace can access in the
  workspaceOrganizationalUnits parameter.
- `authentication_providers`: Specifies whether this workspace uses SAML 2.0, IAM Identity
  Center, or both to authenticate users for using the Grafana console within a workspace. For
  more information, see User authentication in Amazon Managed Grafana.
- `permission_type`: When creating a workspace through the Amazon Web Services API, CLI or
  Amazon Web Services CloudFormation, you must manage IAM roles and provision the permissions
  that the workspace needs to use Amazon Web Services data sources and notification channels.
  You must also specify a workspaceRoleArn for a role that you will manage for the workspace
  to use when accessing those datasources and notification channels. The ability for Amazon
  Managed Grafana to create and update IAM roles on behalf of the user is supported only in
  the Amazon Managed Grafana console, where this value may be set to SERVICE_MANAGED.  Use
  only the CUSTOMER_MANAGED permission type when creating a workspace with the API, CLI or
  Amazon Web Services CloudFormation.   For more information, see Amazon Managed Grafana
  permissions and policies for Amazon Web Services data sources and notification channels.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive, user-provided identifier to ensure the
  idempotency of the request.
- `"configuration"`: The configuration string for the workspace that you create. For more
  information about the format and configuration options available, see Working in your
  Grafana workspace.
- `"grafanaVersion"`: Specifies the version of Grafana to support in the new workspace. If
  not specified, defaults to the latest version (for example, 10.4). To get a list of
  supported versions, use the ListVersions operation.
- `"networkAccessControl"`: Configuration for network access to your workspace. When this
  is configured, only listed IP addresses and VPC endpoints will be able to access your
  workspace. Standard Grafana authentication and authorization will still be required. If
  this is not configured, or is removed, then all IP addresses and VPC endpoints will be
  allowed. Standard Grafana authentication and authorization will still be required.
- `"organizationRoleName"`: The name of an IAM role that already exists to use with
  Organizations to access Amazon Web Services data sources and notification channels in other
  accounts in an organization.
- `"stackSetName"`: The name of the CloudFormation stack set to use to generate IAM roles
  to be used for this workspace.
- `"tags"`: The list of tags associated with the workspace.
- `"vpcConfiguration"`: The configuration settings for an Amazon VPC that contains data
  sources for your Grafana workspace to connect to.  Connecting to a private VPC is not yet
  available in the Asia Pacific (Seoul) Region (ap-northeast-2).
- `"workspaceDataSources"`: This parameter is for internal use only, and should not be used.
- `"workspaceDescription"`: A description for the workspace. This is used only to help you
  identify this workspace. Pattern: ^[p{L}p{Z}p{N}p{P}]{0,2048}
- `"workspaceName"`: The name for the workspace. It does not have to be unique.
- `"workspaceNotificationDestinations"`: Specify the Amazon Web Services notification
  channels that you plan to use in this workspace. Specifying these data sources here enables
  Amazon Managed Grafana to create IAM roles and permissions that allow Amazon Managed
  Grafana to use these channels.
- `"workspaceOrganizationalUnits"`: Specifies the organizational units that this workspace
  is allowed to use data sources from, if this workspace is in an account that is part of an
  organization.
- `"workspaceRoleArn"`: Specified the IAM role that grants permissions to the Amazon Web
  Services resources that the workspace will view data from, including both data sources and
  notification channels. You are responsible for managing the permissions for this role as
  new data sources or notification channels are added.
"""
function create_workspace(
    accountAccessType,
    authenticationProviders,
    permissionType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return grafana(
        "POST",
        "/workspaces",
        Dict{String,Any}(
            "accountAccessType" => accountAccessType,
            "authenticationProviders" => authenticationProviders,
            "permissionType" => permissionType,
            "clientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_workspace(
    accountAccessType,
    authenticationProviders,
    permissionType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return grafana(
        "POST",
        "/workspaces",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "accountAccessType" => accountAccessType,
                    "authenticationProviders" => authenticationProviders,
                    "permissionType" => permissionType,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_workspace_api_key(key_name, key_role, seconds_to_live, workspace_id)
    create_workspace_api_key(key_name, key_role, seconds_to_live, workspace_id, params::Dict{String,<:Any})

Creates a Grafana API key for the workspace. This key can be used to authenticate requests
sent to the workspace's HTTP API. See
https://docs.aws.amazon.com/grafana/latest/userguide/Using-Grafana-APIs.html for available
APIs and example requests.  In workspaces compatible with Grafana version 9 or above, use
workspace service accounts instead of API keys. API keys will be removed in a future
release.

# Arguments
- `key_name`: Specifies the name of the key. Keynames must be unique to the workspace.
- `key_role`: Specifies the permission level of the key.  Valid values: ADMIN|EDITOR|VIEWER
- `seconds_to_live`: Specifies the time in seconds until the key expires. Keys can be valid
  for up to 30 days.
- `workspace_id`: The ID of the workspace to create an API key.

"""
function create_workspace_api_key(
    keyName,
    keyRole,
    secondsToLive,
    workspaceId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return grafana(
        "POST",
        "/workspaces/$(workspaceId)/apikeys",
        Dict{String,Any}(
            "keyName" => keyName, "keyRole" => keyRole, "secondsToLive" => secondsToLive
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_workspace_api_key(
    keyName,
    keyRole,
    secondsToLive,
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return grafana(
        "POST",
        "/workspaces/$(workspaceId)/apikeys",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "keyName" => keyName,
                    "keyRole" => keyRole,
                    "secondsToLive" => secondsToLive,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_workspace_service_account(grafana_role, name, workspace_id)
    create_workspace_service_account(grafana_role, name, workspace_id, params::Dict{String,<:Any})

Creates a service account for the workspace. A service account can be used to call Grafana
HTTP APIs, and run automated workloads. After creating the service account with the correct
GrafanaRole for your use case, use CreateWorkspaceServiceAccountToken to create a token
that can be used to authenticate and authorize Grafana HTTP API calls. You can only create
service accounts for workspaces that are compatible with Grafana version 9 and above.  For
more information about service accounts, see Service accounts in the Amazon Managed Grafana
User Guide. For more information about the Grafana HTTP APIs, see Using Grafana HTTP APIs
in the Amazon Managed Grafana User Guide.

# Arguments
- `grafana_role`: The permission level to use for this service account.  For more
  information about the roles and the permissions each has, see User roles in the Amazon
  Managed Grafana User Guide.
- `name`: A name for the service account. The name must be unique within the workspace, as
  it determines the ID associated with the service account.
- `workspace_id`: The ID of the workspace within which to create the service account.

"""
function create_workspace_service_account(
    grafanaRole, name, workspaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return grafana(
        "POST",
        "/workspaces/$(workspaceId)/serviceaccounts",
        Dict{String,Any}("grafanaRole" => grafanaRole, "name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_workspace_service_account(
    grafanaRole,
    name,
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return grafana(
        "POST",
        "/workspaces/$(workspaceId)/serviceaccounts",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("grafanaRole" => grafanaRole, "name" => name),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_workspace_service_account_token(name, seconds_to_live, service_account_id, workspace_id)
    create_workspace_service_account_token(name, seconds_to_live, service_account_id, workspace_id, params::Dict{String,<:Any})

Creates a token that can be used to authenticate and authorize Grafana HTTP API operations
for the given workspace service account. The service account acts as a user for the API
operations, and defines the permissions that are used by the API.  When you create the
service account token, you will receive a key that is used when calling Grafana APIs. Do
not lose this key, as it will not be retrievable again. If you do lose the key, you can
delete the token and recreate it to receive a new key. This will disable the initial key.
Service accounts are only available for workspaces that are compatible with Grafana version
9 and above.

# Arguments
- `name`: A name for the token to create.
- `seconds_to_live`: Sets how long the token will be valid, in seconds. You can set the
  time up to 30 days in the future.
- `service_account_id`: The ID of the service account for which to create a token.
- `workspace_id`: The ID of the workspace the service account resides within.

"""
function create_workspace_service_account_token(
    name,
    secondsToLive,
    serviceAccountId,
    workspaceId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return grafana(
        "POST",
        "/workspaces/$(workspaceId)/serviceaccounts/$(serviceAccountId)/tokens",
        Dict{String,Any}("name" => name, "secondsToLive" => secondsToLive);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_workspace_service_account_token(
    name,
    secondsToLive,
    serviceAccountId,
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return grafana(
        "POST",
        "/workspaces/$(workspaceId)/serviceaccounts/$(serviceAccountId)/tokens",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("name" => name, "secondsToLive" => secondsToLive),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_workspace(workspace_id)
    delete_workspace(workspace_id, params::Dict{String,<:Any})

Deletes an Amazon Managed Grafana workspace.

# Arguments
- `workspace_id`: The ID of the workspace to delete.

"""
function delete_workspace(workspaceId; aws_config::AbstractAWSConfig=current_aws_config())
    return grafana(
        "DELETE",
        "/workspaces/$(workspaceId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_workspace(
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return grafana(
        "DELETE",
        "/workspaces/$(workspaceId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_workspace_api_key(key_name, workspace_id)
    delete_workspace_api_key(key_name, workspace_id, params::Dict{String,<:Any})

Deletes a Grafana API key for the workspace.  In workspaces compatible with Grafana version
9 or above, use workspace service accounts instead of API keys. API keys will be removed in
a future release.

# Arguments
- `key_name`: The name of the API key to delete.
- `workspace_id`: The ID of the workspace to delete.

"""
function delete_workspace_api_key(
    keyName, workspaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return grafana(
        "DELETE",
        "/workspaces/$(workspaceId)/apikeys/$(keyName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_workspace_api_key(
    keyName,
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return grafana(
        "DELETE",
        "/workspaces/$(workspaceId)/apikeys/$(keyName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_workspace_service_account(service_account_id, workspace_id)
    delete_workspace_service_account(service_account_id, workspace_id, params::Dict{String,<:Any})

Deletes a workspace service account from the workspace. This will delete any tokens created
for the service account, as well. If the tokens are currently in use, the will fail to
authenticate / authorize after they are deleted. Service accounts are only available for
workspaces that are compatible with Grafana version 9 and above.

# Arguments
- `service_account_id`: The ID of the service account to delete.
- `workspace_id`: The ID of the workspace where the service account resides.

"""
function delete_workspace_service_account(
    serviceAccountId, workspaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return grafana(
        "DELETE",
        "/workspaces/$(workspaceId)/serviceaccounts/$(serviceAccountId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_workspace_service_account(
    serviceAccountId,
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return grafana(
        "DELETE",
        "/workspaces/$(workspaceId)/serviceaccounts/$(serviceAccountId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_workspace_service_account_token(service_account_id, token_id, workspace_id)
    delete_workspace_service_account_token(service_account_id, token_id, workspace_id, params::Dict{String,<:Any})

Deletes a token for the workspace service account. This will disable the key associated
with the token. If any automation is currently using the key, it will no longer be
authenticated or authorized to perform actions with the Grafana HTTP APIs. Service accounts
are only available for workspaces that are compatible with Grafana version 9 and above.

# Arguments
- `service_account_id`: The ID of the service account from which to delete the token.
- `token_id`: The ID of the token to delete.
- `workspace_id`: The ID of the workspace from which to delete the token.

"""
function delete_workspace_service_account_token(
    serviceAccountId,
    tokenId,
    workspaceId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return grafana(
        "DELETE",
        "/workspaces/$(workspaceId)/serviceaccounts/$(serviceAccountId)/tokens/$(tokenId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_workspace_service_account_token(
    serviceAccountId,
    tokenId,
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return grafana(
        "DELETE",
        "/workspaces/$(workspaceId)/serviceaccounts/$(serviceAccountId)/tokens/$(tokenId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_workspace(workspace_id)
    describe_workspace(workspace_id, params::Dict{String,<:Any})

Displays information about one Amazon Managed Grafana workspace.

# Arguments
- `workspace_id`: The ID of the workspace to display information about.

"""
function describe_workspace(workspaceId; aws_config::AbstractAWSConfig=current_aws_config())
    return grafana(
        "GET",
        "/workspaces/$(workspaceId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_workspace(
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return grafana(
        "GET",
        "/workspaces/$(workspaceId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_workspace_authentication(workspace_id)
    describe_workspace_authentication(workspace_id, params::Dict{String,<:Any})

Displays information about the authentication methods used in one Amazon Managed Grafana
workspace.

# Arguments
- `workspace_id`: The ID of the workspace to return authentication information about.

"""
function describe_workspace_authentication(
    workspaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return grafana(
        "GET",
        "/workspaces/$(workspaceId)/authentication";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_workspace_authentication(
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return grafana(
        "GET",
        "/workspaces/$(workspaceId)/authentication",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_workspace_configuration(workspace_id)
    describe_workspace_configuration(workspace_id, params::Dict{String,<:Any})

Gets the current configuration string for the given workspace.

# Arguments
- `workspace_id`: The ID of the workspace to get configuration information for.

"""
function describe_workspace_configuration(
    workspaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return grafana(
        "GET",
        "/workspaces/$(workspaceId)/configuration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_workspace_configuration(
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return grafana(
        "GET",
        "/workspaces/$(workspaceId)/configuration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_license(license_type, workspace_id)
    disassociate_license(license_type, workspace_id, params::Dict{String,<:Any})

Removes the Grafana Enterprise license from a workspace.

# Arguments
- `license_type`: The type of license to remove from the workspace.
- `workspace_id`: The ID of the workspace to remove the Grafana Enterprise license from.

"""
function disassociate_license(
    licenseType, workspaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return grafana(
        "DELETE",
        "/workspaces/$(workspaceId)/licenses/$(licenseType)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_license(
    licenseType,
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return grafana(
        "DELETE",
        "/workspaces/$(workspaceId)/licenses/$(licenseType)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_permissions(workspace_id)
    list_permissions(workspace_id, params::Dict{String,<:Any})

Lists the users and groups who have the Grafana Admin and Editor roles in this workspace.
If you use this operation without specifying userId or groupId, the operation returns the
roles of all users and groups. If you specify a userId or a groupId, only the roles for
that user or group are returned. If you do this, you can specify only one userId or one
groupId.

# Arguments
- `workspace_id`: The ID of the workspace to list permissions for. This parameter is
  required.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"groupId"`: (Optional) Limits the results to only the group that matches this ID.
- `"maxResults"`: The maximum number of results to include in the response.
- `"nextToken"`: The token to use when requesting the next set of results. You received
  this token from a previous ListPermissions operation.
- `"userId"`: (Optional) Limits the results to only the user that matches this ID.
- `"userType"`: (Optional) If you specify SSO_USER, then only the permissions of IAM
  Identity Center users are returned. If you specify SSO_GROUP, only the permissions of IAM
  Identity Center groups are returned.
"""
function list_permissions(workspaceId; aws_config::AbstractAWSConfig=current_aws_config())
    return grafana(
        "GET",
        "/workspaces/$(workspaceId)/permissions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_permissions(
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return grafana(
        "GET",
        "/workspaces/$(workspaceId)/permissions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

The ListTagsForResource operation returns the tags that are associated with the Amazon
Managed Service for Grafana resource specified by the resourceArn. Currently, the only
resource that can be tagged is a workspace.

# Arguments
- `resource_arn`: The ARN of the resource the list of tags are associated with.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return grafana(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return grafana(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_versions()
    list_versions(params::Dict{String,<:Any})

Lists available versions of Grafana. These are available when calling CreateWorkspace.
Optionally, include a workspace to list the versions to which it can be upgraded.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to include in the response.
- `"nextToken"`: The token to use when requesting the next set of results. You receive this
  token from a previous ListVersions operation.
- `"workspace-id"`: The ID of the workspace to list the available upgrade versions. If not
  included, lists all versions of Grafana that are supported for CreateWorkspace.
"""
function list_versions(; aws_config::AbstractAWSConfig=current_aws_config())
    return grafana(
        "GET", "/versions"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_versions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return grafana(
        "GET", "/versions", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_workspace_service_account_tokens(service_account_id, workspace_id)
    list_workspace_service_account_tokens(service_account_id, workspace_id, params::Dict{String,<:Any})

Returns a list of tokens for a workspace service account.  This does not return the key for
each token. You cannot access keys after they are created. To create a new key, delete the
token and recreate it.  Service accounts are only available for workspaces that are
compatible with Grafana version 9 and above.

# Arguments
- `service_account_id`: The ID of the service account for which to return tokens.
- `workspace_id`: The ID of the workspace for which to return tokens.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of tokens to include in the results.
- `"nextToken"`: The token for the next set of service accounts to return. (You receive
  this token from a previous ListWorkspaceServiceAccountTokens operation.)
"""
function list_workspace_service_account_tokens(
    serviceAccountId, workspaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return grafana(
        "GET",
        "/workspaces/$(workspaceId)/serviceaccounts/$(serviceAccountId)/tokens";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_workspace_service_account_tokens(
    serviceAccountId,
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return grafana(
        "GET",
        "/workspaces/$(workspaceId)/serviceaccounts/$(serviceAccountId)/tokens",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_workspace_service_accounts(workspace_id)
    list_workspace_service_accounts(workspace_id, params::Dict{String,<:Any})

Returns a list of service accounts for a workspace. Service accounts are only available for
workspaces that are compatible with Grafana version 9 and above.

# Arguments
- `workspace_id`: The workspace for which to list service accounts.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of service accounts to include in the results.
- `"nextToken"`: The token for the next set of service accounts to return. (You receive
  this token from a previous ListWorkspaceServiceAccounts operation.)
"""
function list_workspace_service_accounts(
    workspaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return grafana(
        "GET",
        "/workspaces/$(workspaceId)/serviceaccounts";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_workspace_service_accounts(
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return grafana(
        "GET",
        "/workspaces/$(workspaceId)/serviceaccounts",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_workspaces()
    list_workspaces(params::Dict{String,<:Any})

Returns a list of Amazon Managed Grafana workspaces in the account, with some information
about each workspace. For more complete information about one workspace, use
DescribeWorkspace.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of workspaces to include in the results.
- `"nextToken"`: The token for the next set of workspaces to return. (You receive this
  token from a previous ListWorkspaces operation.)
"""
function list_workspaces(; aws_config::AbstractAWSConfig=current_aws_config())
    return grafana(
        "GET", "/workspaces"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_workspaces(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return grafana(
        "GET", "/workspaces", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

The TagResource operation associates tags with an Amazon Managed Grafana resource.
Currently, the only resource that can be tagged is workspaces.  If you specify a new tag
key for the resource, this tag is appended to the list of tags associated with the
resource. If you specify a tag key that is already associated with the resource, the new
tag value that you specify replaces the previous value for that tag.

# Arguments
- `resource_arn`: The ARN of the resource the tag is associated with.
- `tags`: The list of tag keys and values to associate with the resource. You can associate
  tag keys only, tags (key and values) only or a combination of tag keys and tags.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return grafana(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return grafana(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

The UntagResource operation removes the association of the tag with the Amazon Managed
Grafana resource.

# Arguments
- `resource_arn`: The ARN of the resource the tag association is removed from.
- `tag_keys`: The key values of the tag to be removed from the resource.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return grafana(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return grafana(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_permissions(update_instruction_batch, workspace_id)
    update_permissions(update_instruction_batch, workspace_id, params::Dict{String,<:Any})

Updates which users in a workspace have the Grafana Admin or Editor roles.

# Arguments
- `update_instruction_batch`: An array of structures that contain the permission updates to
  make.
- `workspace_id`: The ID of the workspace to update.

"""
function update_permissions(
    updateInstructionBatch, workspaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return grafana(
        "PATCH",
        "/workspaces/$(workspaceId)/permissions",
        Dict{String,Any}("updateInstructionBatch" => updateInstructionBatch);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_permissions(
    updateInstructionBatch,
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return grafana(
        "PATCH",
        "/workspaces/$(workspaceId)/permissions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("updateInstructionBatch" => updateInstructionBatch),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_workspace(workspace_id)
    update_workspace(workspace_id, params::Dict{String,<:Any})

Modifies an existing Amazon Managed Grafana workspace. If you use this operation and omit
any optional parameters, the existing values of those parameters are not changed. To modify
the user authentication methods that the workspace uses, such as SAML or IAM Identity
Center, use UpdateWorkspaceAuthentication. To modify which users in the workspace have the
Admin and Editor Grafana roles, use UpdatePermissions.

# Arguments
- `workspace_id`: The ID of the workspace to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"accountAccessType"`: Specifies whether the workspace can access Amazon Web Services
  resources in this Amazon Web Services account only, or whether it can also access Amazon
  Web Services resources in other accounts in the same organization. If you specify
  ORGANIZATION, you must specify which organizational units the workspace can access in the
  workspaceOrganizationalUnits parameter.
- `"networkAccessControl"`: The configuration settings for network access to your
  workspace. When this is configured, only listed IP addresses and VPC endpoints will be able
  to access your workspace. Standard Grafana authentication and authorization will still be
  required. If this is not configured, or is removed, then all IP addresses and VPC endpoints
  will be allowed. Standard Grafana authentication and authorization will still be required.
- `"organizationRoleName"`: The name of an IAM role that already exists to use to access
  resources through Organizations. This can only be used with a workspace that has the
  permissionType set to CUSTOMER_MANAGED.
- `"permissionType"`: Use this parameter if you want to change a workspace from
  SERVICE_MANAGED to CUSTOMER_MANAGED. This allows you to manage the permissions that the
  workspace uses to access datasources and notification channels. If the workspace is in a
  member Amazon Web Services account of an organization, and that account is not a delegated
  administrator account, and you want the workspace to access data sources in other Amazon
  Web Services accounts in the organization, you must choose CUSTOMER_MANAGED. If you specify
  this as CUSTOMER_MANAGED, you must also specify a workspaceRoleArn that the workspace will
  use for accessing Amazon Web Services resources. For more information on the role and
  permissions needed, see Amazon Managed Grafana permissions and policies for Amazon Web
  Services data sources and notification channels   Do not use this to convert a
  CUSTOMER_MANAGED workspace to SERVICE_MANAGED. Do not include this parameter if you want to
  leave the workspace as SERVICE_MANAGED. You can convert a CUSTOMER_MANAGED workspace to
  SERVICE_MANAGED using the Amazon Managed Grafana console. For more information, see
  Managing permissions for data sources and notification channels.
- `"removeNetworkAccessConfiguration"`: Whether to remove the network access configuration
  from the workspace. Setting this to true and providing a networkAccessControl to set will
  return an error. If you remove this configuration by setting this to true, then all IP
  addresses and VPC endpoints will be allowed. Standard Grafana authentication and
  authorization will still be required.
- `"removeVpcConfiguration"`: Whether to remove the VPC configuration from the workspace.
  Setting this to true and providing a vpcConfiguration to set will return an error.
- `"stackSetName"`: The name of the CloudFormation stack set to use to generate IAM roles
  to be used for this workspace.
- `"vpcConfiguration"`: The configuration settings for an Amazon VPC that contains data
  sources for your Grafana workspace to connect to.
- `"workspaceDataSources"`: This parameter is for internal use only, and should not be used.
- `"workspaceDescription"`: A description for the workspace. This is used only to help you
  identify this workspace.
- `"workspaceName"`: A new name for the workspace to update.
- `"workspaceNotificationDestinations"`: Specify the Amazon Web Services notification
  channels that you plan to use in this workspace. Specifying these data sources here enables
  Amazon Managed Grafana to create IAM roles and permissions that allow Amazon Managed
  Grafana to use these channels.
- `"workspaceOrganizationalUnits"`: Specifies the organizational units that this workspace
  is allowed to use data sources from, if this workspace is in an account that is part of an
  organization.
- `"workspaceRoleArn"`: Specifies an IAM role that grants permissions to Amazon Web
  Services resources that the workspace accesses, such as data sources and notification
  channels. If this workspace has permissionType CUSTOMER_MANAGED, then this role is required.
"""
function update_workspace(workspaceId; aws_config::AbstractAWSConfig=current_aws_config())
    return grafana(
        "PUT",
        "/workspaces/$(workspaceId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_workspace(
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return grafana(
        "PUT",
        "/workspaces/$(workspaceId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_workspace_authentication(authentication_providers, workspace_id)
    update_workspace_authentication(authentication_providers, workspace_id, params::Dict{String,<:Any})

Use this operation to define the identity provider (IdP) that this workspace authenticates
users from, using SAML. You can also map SAML assertion attributes to workspace user
information and define which groups in the assertion attribute are to have the Admin and
Editor roles in the workspace.  Changes to the authentication method for a workspace may
take a few minutes to take effect.

# Arguments
- `authentication_providers`: Specifies whether this workspace uses SAML 2.0, IAM Identity
  Center, or both to authenticate users for using the Grafana console within a workspace. For
  more information, see User authentication in Amazon Managed Grafana.
- `workspace_id`: The ID of the workspace to update the authentication for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"samlConfiguration"`: If the workspace uses SAML, use this structure to map SAML
  assertion attributes to workspace user information and define which groups in the assertion
  attribute are to have the Admin and Editor roles in the workspace.
"""
function update_workspace_authentication(
    authenticationProviders, workspaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return grafana(
        "POST",
        "/workspaces/$(workspaceId)/authentication",
        Dict{String,Any}("authenticationProviders" => authenticationProviders);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_workspace_authentication(
    authenticationProviders,
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return grafana(
        "POST",
        "/workspaces/$(workspaceId)/authentication",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("authenticationProviders" => authenticationProviders),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_workspace_configuration(configuration, workspace_id)
    update_workspace_configuration(configuration, workspace_id, params::Dict{String,<:Any})

Updates the configuration string for the given workspace

# Arguments
- `configuration`: The new configuration string for the workspace. For more information
  about the format and configuration options available, see Working in your Grafana workspace.
- `workspace_id`: The ID of the workspace to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"grafanaVersion"`: Specifies the version of Grafana to support in the workspace. If not
  specified, keeps the current version of the workspace. Can only be used to upgrade (for
  example, from 8.4 to 9.4), not downgrade (for example, from 9.4 to 8.4). To know what
  versions are available to upgrade to for a specific workspace, see the ListVersions
  operation.
"""
function update_workspace_configuration(
    configuration, workspaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return grafana(
        "PUT",
        "/workspaces/$(workspaceId)/configuration",
        Dict{String,Any}("configuration" => configuration);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_workspace_configuration(
    configuration,
    workspaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return grafana(
        "PUT",
        "/workspaces/$(workspaceId)/configuration",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("configuration" => configuration), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: mailmanager
using AWS.Compat
using AWS.UUIDs

"""
    create_addon_instance(addon_subscription_id)
    create_addon_instance(addon_subscription_id, params::Dict{String,<:Any})

Creates an Add On instance for the subscription indicated in the request. The resulting
Amazon Resource Name (ARN) can be used in a conditional statement for a rule set or traffic
policy.

# Arguments
- `addon_subscription_id`: The unique ID of a previously created subscription that an Add
  On instance is created for. You can only have one instance per subscription.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: A unique token that Amazon SES uses to recognize subsequent retries of
  the same request.
- `"Tags"`: The tags used to organize, track, or control access for the resource. For
  example, { \"tags\": {\"key1\":\"value1\", \"key2\":\"value2\"} }.
"""
function create_addon_instance(
    AddonSubscriptionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mailmanager(
        "CreateAddonInstance",
        Dict{String,Any}(
            "AddonSubscriptionId" => AddonSubscriptionId, "ClientToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_addon_instance(
    AddonSubscriptionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mailmanager(
        "CreateAddonInstance",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AddonSubscriptionId" => AddonSubscriptionId,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_addon_subscription(addon_name)
    create_addon_subscription(addon_name, params::Dict{String,<:Any})

Creates a subscription for an Add On representing the acceptance of its terms of use and
additional pricing. The subscription can then be used to create an instance for use in rule
sets or traffic policies.

# Arguments
- `addon_name`: The name of the Add On to subscribe to. You can only have one subscription
  for each Add On name.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: A unique token that Amazon SES uses to recognize subsequent retries of
  the same request.
- `"Tags"`: The tags used to organize, track, or control access for the resource. For
  example, { \"tags\": {\"key1\":\"value1\", \"key2\":\"value2\"} }.
"""
function create_addon_subscription(
    AddonName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mailmanager(
        "CreateAddonSubscription",
        Dict{String,Any}("AddonName" => AddonName, "ClientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_addon_subscription(
    AddonName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mailmanager(
        "CreateAddonSubscription",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AddonName" => AddonName, "ClientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_archive(archive_name)
    create_archive(archive_name, params::Dict{String,<:Any})

Creates a new email archive resource for storing and retaining emails.

# Arguments
- `archive_name`: A unique name for the new archive.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: A unique token Amazon SES uses to recognize retries of this request.
- `"KmsKeyArn"`: The Amazon Resource Name (ARN) of the KMS key for encrypting emails in the
  archive.
- `"Retention"`: The period for retaining emails in the archive before automatic deletion.
- `"Tags"`: The tags used to organize, track, or control access for the resource. For
  example, { \"tags\": {\"key1\":\"value1\", \"key2\":\"value2\"} }.
"""
function create_archive(ArchiveName; aws_config::AbstractAWSConfig=current_aws_config())
    return mailmanager(
        "CreateArchive",
        Dict{String,Any}("ArchiveName" => ArchiveName, "ClientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_archive(
    ArchiveName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mailmanager(
        "CreateArchive",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ArchiveName" => ArchiveName, "ClientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_ingress_point(ingress_point_name, rule_set_id, traffic_policy_id, type)
    create_ingress_point(ingress_point_name, rule_set_id, traffic_policy_id, type, params::Dict{String,<:Any})

Provision a new ingress endpoint resource.

# Arguments
- `ingress_point_name`: A user friendly name for an ingress endpoint resource.
- `rule_set_id`: The identifier of an existing rule set that you attach to an ingress
  endpoint resource.
- `traffic_policy_id`: The identifier of an existing traffic policy that you attach to an
  ingress endpoint resource.
- `type`: The type of the ingress endpoint to create.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: A unique token that Amazon SES uses to recognize subsequent retries of
  the same request.
- `"IngressPointConfiguration"`: If you choose an Authenticated ingress endpoint, you must
  configure either an SMTP password or a secret ARN.
- `"Tags"`: The tags used to organize, track, or control access for the resource. For
  example, { \"tags\": {\"key1\":\"value1\", \"key2\":\"value2\"} }.
"""
function create_ingress_point(
    IngressPointName,
    RuleSetId,
    TrafficPolicyId,
    Type;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mailmanager(
        "CreateIngressPoint",
        Dict{String,Any}(
            "IngressPointName" => IngressPointName,
            "RuleSetId" => RuleSetId,
            "TrafficPolicyId" => TrafficPolicyId,
            "Type" => Type,
            "ClientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_ingress_point(
    IngressPointName,
    RuleSetId,
    TrafficPolicyId,
    Type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mailmanager(
        "CreateIngressPoint",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "IngressPointName" => IngressPointName,
                    "RuleSetId" => RuleSetId,
                    "TrafficPolicyId" => TrafficPolicyId,
                    "Type" => Type,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_relay(authentication, relay_name, server_name, server_port)
    create_relay(authentication, relay_name, server_name, server_port, params::Dict{String,<:Any})

Creates a relay resource which can be used in rules to relay incoming emails to defined
relay destinations.

# Arguments
- `authentication`: Authentication for the relay destination server—specify the secretARN
  where the SMTP credentials are stored.
- `relay_name`: The unique name of the relay resource.
- `server_name`: The destination relay server address.
- `server_port`: The destination relay server port.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: A unique token that Amazon SES uses to recognize subsequent retries of
  the same request.
- `"Tags"`: The tags used to organize, track, or control access for the resource. For
  example, { \"tags\": {\"key1\":\"value1\", \"key2\":\"value2\"} }.
"""
function create_relay(
    Authentication,
    RelayName,
    ServerName,
    ServerPort;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mailmanager(
        "CreateRelay",
        Dict{String,Any}(
            "Authentication" => Authentication,
            "RelayName" => RelayName,
            "ServerName" => ServerName,
            "ServerPort" => ServerPort,
            "ClientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_relay(
    Authentication,
    RelayName,
    ServerName,
    ServerPort,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mailmanager(
        "CreateRelay",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Authentication" => Authentication,
                    "RelayName" => RelayName,
                    "ServerName" => ServerName,
                    "ServerPort" => ServerPort,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_rule_set(rule_set_name, rules)
    create_rule_set(rule_set_name, rules, params::Dict{String,<:Any})

Provision a new rule set.

# Arguments
- `rule_set_name`: A user-friendly name for the rule set.
- `rules`: Conditional rules that are evaluated for determining actions on email.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: A unique token that Amazon SES uses to recognize subsequent retries of
  the same request.
- `"Tags"`: The tags used to organize, track, or control access for the resource. For
  example, { \"tags\": {\"key1\":\"value1\", \"key2\":\"value2\"} }.
"""
function create_rule_set(
    RuleSetName, Rules; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mailmanager(
        "CreateRuleSet",
        Dict{String,Any}(
            "RuleSetName" => RuleSetName, "Rules" => Rules, "ClientToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_rule_set(
    RuleSetName,
    Rules,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mailmanager(
        "CreateRuleSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "RuleSetName" => RuleSetName,
                    "Rules" => Rules,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_traffic_policy(default_action, policy_statements, traffic_policy_name)
    create_traffic_policy(default_action, policy_statements, traffic_policy_name, params::Dict{String,<:Any})

Provision a new traffic policy resource.

# Arguments
- `default_action`: Default action instructs the traﬃc policy to either Allow or Deny
  (block) messages that fall outside of (or not addressed by) the conditions of your policy
  statements
- `policy_statements`: Conditional statements for filtering email traffic.
- `traffic_policy_name`: A user-friendly name for the traffic policy resource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: A unique token that Amazon SES uses to recognize subsequent retries of
  the same request.
- `"MaxMessageSizeBytes"`: The maximum message size in bytes of email which is allowed in
  by this traffic policy—anything larger will be blocked.
- `"Tags"`: The tags used to organize, track, or control access for the resource. For
  example, { \"tags\": {\"key1\":\"value1\", \"key2\":\"value2\"} }.
"""
function create_traffic_policy(
    DefaultAction,
    PolicyStatements,
    TrafficPolicyName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mailmanager(
        "CreateTrafficPolicy",
        Dict{String,Any}(
            "DefaultAction" => DefaultAction,
            "PolicyStatements" => PolicyStatements,
            "TrafficPolicyName" => TrafficPolicyName,
            "ClientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_traffic_policy(
    DefaultAction,
    PolicyStatements,
    TrafficPolicyName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mailmanager(
        "CreateTrafficPolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DefaultAction" => DefaultAction,
                    "PolicyStatements" => PolicyStatements,
                    "TrafficPolicyName" => TrafficPolicyName,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_addon_instance(addon_instance_id)
    delete_addon_instance(addon_instance_id, params::Dict{String,<:Any})

Deletes an Add On instance.

# Arguments
- `addon_instance_id`: The Add On instance ID to delete.

"""
function delete_addon_instance(
    AddonInstanceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mailmanager(
        "DeleteAddonInstance",
        Dict{String,Any}("AddonInstanceId" => AddonInstanceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_addon_instance(
    AddonInstanceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mailmanager(
        "DeleteAddonInstance",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("AddonInstanceId" => AddonInstanceId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_addon_subscription(addon_subscription_id)
    delete_addon_subscription(addon_subscription_id, params::Dict{String,<:Any})

Deletes an Add On subscription.

# Arguments
- `addon_subscription_id`: The Add On subscription ID to delete.

"""
function delete_addon_subscription(
    AddonSubscriptionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mailmanager(
        "DeleteAddonSubscription",
        Dict{String,Any}("AddonSubscriptionId" => AddonSubscriptionId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_addon_subscription(
    AddonSubscriptionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mailmanager(
        "DeleteAddonSubscription",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("AddonSubscriptionId" => AddonSubscriptionId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_archive(archive_id)
    delete_archive(archive_id, params::Dict{String,<:Any})

Initiates deletion of an email archive. This changes the archive state to pending deletion.
In this state, no new emails can be added, and existing archived emails become inaccessible
(search, export, download). The archive and all of its contents will be permanently deleted
30 days after entering the pending deletion state, regardless of the configured retention
period.

# Arguments
- `archive_id`: The identifier of the archive to delete.

"""
function delete_archive(ArchiveId; aws_config::AbstractAWSConfig=current_aws_config())
    return mailmanager(
        "DeleteArchive",
        Dict{String,Any}("ArchiveId" => ArchiveId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_archive(
    ArchiveId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mailmanager(
        "DeleteArchive",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ArchiveId" => ArchiveId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_ingress_point(ingress_point_id)
    delete_ingress_point(ingress_point_id, params::Dict{String,<:Any})

Delete an ingress endpoint resource.

# Arguments
- `ingress_point_id`: The identifier of the ingress endpoint resource that you want to
  delete.

"""
function delete_ingress_point(
    IngressPointId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mailmanager(
        "DeleteIngressPoint",
        Dict{String,Any}("IngressPointId" => IngressPointId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_ingress_point(
    IngressPointId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mailmanager(
        "DeleteIngressPoint",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("IngressPointId" => IngressPointId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_relay(relay_id)
    delete_relay(relay_id, params::Dict{String,<:Any})

Deletes an existing relay resource.

# Arguments
- `relay_id`: The unique relay identifier.

"""
function delete_relay(RelayId; aws_config::AbstractAWSConfig=current_aws_config())
    return mailmanager(
        "DeleteRelay",
        Dict{String,Any}("RelayId" => RelayId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_relay(
    RelayId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mailmanager(
        "DeleteRelay",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("RelayId" => RelayId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_rule_set(rule_set_id)
    delete_rule_set(rule_set_id, params::Dict{String,<:Any})

Delete a rule set.

# Arguments
- `rule_set_id`: The identifier of an existing rule set resource to delete.

"""
function delete_rule_set(RuleSetId; aws_config::AbstractAWSConfig=current_aws_config())
    return mailmanager(
        "DeleteRuleSet",
        Dict{String,Any}("RuleSetId" => RuleSetId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_rule_set(
    RuleSetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mailmanager(
        "DeleteRuleSet",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("RuleSetId" => RuleSetId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_traffic_policy(traffic_policy_id)
    delete_traffic_policy(traffic_policy_id, params::Dict{String,<:Any})

Delete a traffic policy resource.

# Arguments
- `traffic_policy_id`: The identifier of the traffic policy that you want to delete.

"""
function delete_traffic_policy(
    TrafficPolicyId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mailmanager(
        "DeleteTrafficPolicy",
        Dict{String,Any}("TrafficPolicyId" => TrafficPolicyId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_traffic_policy(
    TrafficPolicyId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mailmanager(
        "DeleteTrafficPolicy",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("TrafficPolicyId" => TrafficPolicyId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_addon_instance(addon_instance_id)
    get_addon_instance(addon_instance_id, params::Dict{String,<:Any})

Gets detailed information about an Add On instance.

# Arguments
- `addon_instance_id`: The Add On instance ID to retrieve information for.

"""
function get_addon_instance(
    AddonInstanceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mailmanager(
        "GetAddonInstance",
        Dict{String,Any}("AddonInstanceId" => AddonInstanceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_addon_instance(
    AddonInstanceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mailmanager(
        "GetAddonInstance",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("AddonInstanceId" => AddonInstanceId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_addon_subscription(addon_subscription_id)
    get_addon_subscription(addon_subscription_id, params::Dict{String,<:Any})

Gets detailed information about an Add On subscription.

# Arguments
- `addon_subscription_id`: The Add On subscription ID to retrieve information for.

"""
function get_addon_subscription(
    AddonSubscriptionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mailmanager(
        "GetAddonSubscription",
        Dict{String,Any}("AddonSubscriptionId" => AddonSubscriptionId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_addon_subscription(
    AddonSubscriptionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mailmanager(
        "GetAddonSubscription",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("AddonSubscriptionId" => AddonSubscriptionId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_archive(archive_id)
    get_archive(archive_id, params::Dict{String,<:Any})

Retrieves the full details and current state of a specified email archive.

# Arguments
- `archive_id`: The identifier of the archive to retrieve.

"""
function get_archive(ArchiveId; aws_config::AbstractAWSConfig=current_aws_config())
    return mailmanager(
        "GetArchive",
        Dict{String,Any}("ArchiveId" => ArchiveId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_archive(
    ArchiveId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mailmanager(
        "GetArchive",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ArchiveId" => ArchiveId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_archive_export(export_id)
    get_archive_export(export_id, params::Dict{String,<:Any})

Retrieves the details and current status of a specific email archive export job.

# Arguments
- `export_id`: The identifier of the export job to get details for.

"""
function get_archive_export(ExportId; aws_config::AbstractAWSConfig=current_aws_config())
    return mailmanager(
        "GetArchiveExport",
        Dict{String,Any}("ExportId" => ExportId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_archive_export(
    ExportId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mailmanager(
        "GetArchiveExport",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ExportId" => ExportId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_archive_message(archived_message_id)
    get_archive_message(archived_message_id, params::Dict{String,<:Any})

Returns a pre-signed URL that provides temporary download access to the specific email
message stored in the archive.

# Arguments
- `archived_message_id`: The unique identifier of the archived email message.

"""
function get_archive_message(
    ArchivedMessageId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mailmanager(
        "GetArchiveMessage",
        Dict{String,Any}("ArchivedMessageId" => ArchivedMessageId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_archive_message(
    ArchivedMessageId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mailmanager(
        "GetArchiveMessage",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ArchivedMessageId" => ArchivedMessageId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_archive_message_content(archived_message_id)
    get_archive_message_content(archived_message_id, params::Dict{String,<:Any})

Returns the textual content of a specific email message stored in the archive. Attachments
are not included.

# Arguments
- `archived_message_id`: The unique identifier of the archived email message.

"""
function get_archive_message_content(
    ArchivedMessageId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mailmanager(
        "GetArchiveMessageContent",
        Dict{String,Any}("ArchivedMessageId" => ArchivedMessageId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_archive_message_content(
    ArchivedMessageId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mailmanager(
        "GetArchiveMessageContent",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ArchivedMessageId" => ArchivedMessageId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_archive_search(search_id)
    get_archive_search(search_id, params::Dict{String,<:Any})

Retrieves the details and current status of a specific email archive search job.

# Arguments
- `search_id`: The identifier of the search job to get details for.

"""
function get_archive_search(SearchId; aws_config::AbstractAWSConfig=current_aws_config())
    return mailmanager(
        "GetArchiveSearch",
        Dict{String,Any}("SearchId" => SearchId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_archive_search(
    SearchId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mailmanager(
        "GetArchiveSearch",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("SearchId" => SearchId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_archive_search_results(search_id)
    get_archive_search_results(search_id, params::Dict{String,<:Any})

Returns the results of a completed email archive search job.

# Arguments
- `search_id`: The identifier of the completed search job.

"""
function get_archive_search_results(
    SearchId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mailmanager(
        "GetArchiveSearchResults",
        Dict{String,Any}("SearchId" => SearchId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_archive_search_results(
    SearchId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mailmanager(
        "GetArchiveSearchResults",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("SearchId" => SearchId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_ingress_point(ingress_point_id)
    get_ingress_point(ingress_point_id, params::Dict{String,<:Any})

Fetch ingress endpoint resource attributes.

# Arguments
- `ingress_point_id`: The identifier of an ingress endpoint.

"""
function get_ingress_point(
    IngressPointId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mailmanager(
        "GetIngressPoint",
        Dict{String,Any}("IngressPointId" => IngressPointId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_ingress_point(
    IngressPointId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mailmanager(
        "GetIngressPoint",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("IngressPointId" => IngressPointId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_relay(relay_id)
    get_relay(relay_id, params::Dict{String,<:Any})

Fetch the relay resource and it's attributes.

# Arguments
- `relay_id`: A unique relay identifier.

"""
function get_relay(RelayId; aws_config::AbstractAWSConfig=current_aws_config())
    return mailmanager(
        "GetRelay",
        Dict{String,Any}("RelayId" => RelayId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_relay(
    RelayId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mailmanager(
        "GetRelay",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("RelayId" => RelayId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_rule_set(rule_set_id)
    get_rule_set(rule_set_id, params::Dict{String,<:Any})

Fetch attributes of a rule set.

# Arguments
- `rule_set_id`: The identifier of an existing rule set to be retrieved.

"""
function get_rule_set(RuleSetId; aws_config::AbstractAWSConfig=current_aws_config())
    return mailmanager(
        "GetRuleSet",
        Dict{String,Any}("RuleSetId" => RuleSetId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_rule_set(
    RuleSetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mailmanager(
        "GetRuleSet",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("RuleSetId" => RuleSetId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_traffic_policy(traffic_policy_id)
    get_traffic_policy(traffic_policy_id, params::Dict{String,<:Any})

Fetch attributes of a traffic policy resource.

# Arguments
- `traffic_policy_id`: The identifier of the traffic policy resource.

"""
function get_traffic_policy(
    TrafficPolicyId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mailmanager(
        "GetTrafficPolicy",
        Dict{String,Any}("TrafficPolicyId" => TrafficPolicyId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_traffic_policy(
    TrafficPolicyId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mailmanager(
        "GetTrafficPolicy",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("TrafficPolicyId" => TrafficPolicyId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_addon_instances()
    list_addon_instances(params::Dict{String,<:Any})

Lists all Add On instances in your account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: If you received a pagination token from a previous call to this API, you
  can provide it here to continue paginating through the next page of results.
- `"PageSize"`: The maximum number of ingress endpoint resources that are returned per
  call. You can use NextToken to obtain further ingress endpoints.
"""
function list_addon_instances(; aws_config::AbstractAWSConfig=current_aws_config())
    return mailmanager(
        "ListAddonInstances"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_addon_instances(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mailmanager(
        "ListAddonInstances", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_addon_subscriptions()
    list_addon_subscriptions(params::Dict{String,<:Any})

Lists all Add On subscriptions in your account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: If you received a pagination token from a previous call to this API, you
  can provide it here to continue paginating through the next page of results.
- `"PageSize"`: The maximum number of ingress endpoint resources that are returned per
  call. You can use NextToken to obtain further ingress endpoints.
"""
function list_addon_subscriptions(; aws_config::AbstractAWSConfig=current_aws_config())
    return mailmanager(
        "ListAddonSubscriptions"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_addon_subscriptions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mailmanager(
        "ListAddonSubscriptions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_archive_exports(archive_id)
    list_archive_exports(archive_id, params::Dict{String,<:Any})

Returns a list of email archive export jobs.

# Arguments
- `archive_id`: The identifier of the archive.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: If NextToken is returned, there are more results available. The value of
  NextToken is a unique pagination token for each page. Make the call again using the
  returned token to retrieve the next page.
- `"PageSize"`: The maximum number of archive export jobs that are returned per call. You
  can use NextToken to obtain further pages of archives.
"""
function list_archive_exports(ArchiveId; aws_config::AbstractAWSConfig=current_aws_config())
    return mailmanager(
        "ListArchiveExports",
        Dict{String,Any}("ArchiveId" => ArchiveId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_archive_exports(
    ArchiveId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mailmanager(
        "ListArchiveExports",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ArchiveId" => ArchiveId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_archive_searches(archive_id)
    list_archive_searches(archive_id, params::Dict{String,<:Any})

Returns a list of email archive search jobs.

# Arguments
- `archive_id`: The identifier of the archive.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: If NextToken is returned, there are more results available. The value of
  NextToken is a unique pagination token for each page. Make the call again using the
  returned token to retrieve the next page.
- `"PageSize"`: The maximum number of archive search jobs that are returned per call. You
  can use NextToken to obtain further pages of archives.
"""
function list_archive_searches(
    ArchiveId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mailmanager(
        "ListArchiveSearches",
        Dict{String,Any}("ArchiveId" => ArchiveId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_archive_searches(
    ArchiveId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mailmanager(
        "ListArchiveSearches",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ArchiveId" => ArchiveId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_archives()
    list_archives(params::Dict{String,<:Any})

Returns a list of all email archives in your account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: If NextToken is returned, there are more results available. The value of
  NextToken is a unique pagination token for each page. Make the call again using the
  returned token to retrieve the next page.
- `"PageSize"`: The maximum number of archives that are returned per call. You can use
  NextToken to obtain further pages of archives.
"""
function list_archives(; aws_config::AbstractAWSConfig=current_aws_config())
    return mailmanager(
        "ListArchives"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_archives(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mailmanager(
        "ListArchives", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_ingress_points()
    list_ingress_points(params::Dict{String,<:Any})

List all ingress endpoint resources.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: If you received a pagination token from a previous call to this API, you
  can provide it here to continue paginating through the next page of results.
- `"PageSize"`: The maximum number of ingress endpoint resources that are returned per
  call. You can use NextToken to obtain further ingress endpoints.
"""
function list_ingress_points(; aws_config::AbstractAWSConfig=current_aws_config())
    return mailmanager(
        "ListIngressPoints"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_ingress_points(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mailmanager(
        "ListIngressPoints", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_relays()
    list_relays(params::Dict{String,<:Any})

Lists all the existing relay resources.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: If you received a pagination token from a previous call to this API, you
  can provide it here to continue paginating through the next page of results.
- `"PageSize"`: The number of relays to be returned in one request.
"""
function list_relays(; aws_config::AbstractAWSConfig=current_aws_config())
    return mailmanager("ListRelays"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_relays(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mailmanager(
        "ListRelays", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_rule_sets()
    list_rule_sets(params::Dict{String,<:Any})

List rule sets for this account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: If you received a pagination token from a previous call to this API, you
  can provide it here to continue paginating through the next page of results.
- `"PageSize"`: The maximum number of rule set resources that are returned per call. You
  can use NextToken to obtain further rule sets.
"""
function list_rule_sets(; aws_config::AbstractAWSConfig=current_aws_config())
    return mailmanager(
        "ListRuleSets"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_rule_sets(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mailmanager(
        "ListRuleSets", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

 Retrieves the list of tags (keys and values) assigned to the resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource to retrieve tags from.

"""
function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mailmanager(
        "ListTagsForResource",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mailmanager(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_traffic_policies()
    list_traffic_policies(params::Dict{String,<:Any})

List traffic policy resources.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: If you received a pagination token from a previous call to this API, you
  can provide it here to continue paginating through the next page of results.
- `"PageSize"`: The maximum number of traffic policy resources that are returned per call.
  You can use NextToken to obtain further traffic policies.
"""
function list_traffic_policies(; aws_config::AbstractAWSConfig=current_aws_config())
    return mailmanager(
        "ListTrafficPolicies"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_traffic_policies(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mailmanager(
        "ListTrafficPolicies",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_archive_export(archive_id, export_destination_configuration, from_timestamp, to_timestamp)
    start_archive_export(archive_id, export_destination_configuration, from_timestamp, to_timestamp, params::Dict{String,<:Any})

Initiates an export of emails from the specified archive.

# Arguments
- `archive_id`: The identifier of the archive to export emails from.
- `export_destination_configuration`: Details on where to deliver the exported email data.
- `from_timestamp`: The start of the timestamp range to include emails from.
- `to_timestamp`: The end of the timestamp range to include emails from.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: Criteria to filter which emails are included in the export.
- `"MaxResults"`: The maximum number of email items to include in the export.
"""
function start_archive_export(
    ArchiveId,
    ExportDestinationConfiguration,
    FromTimestamp,
    ToTimestamp;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mailmanager(
        "StartArchiveExport",
        Dict{String,Any}(
            "ArchiveId" => ArchiveId,
            "ExportDestinationConfiguration" => ExportDestinationConfiguration,
            "FromTimestamp" => FromTimestamp,
            "ToTimestamp" => ToTimestamp,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_archive_export(
    ArchiveId,
    ExportDestinationConfiguration,
    FromTimestamp,
    ToTimestamp,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mailmanager(
        "StartArchiveExport",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ArchiveId" => ArchiveId,
                    "ExportDestinationConfiguration" => ExportDestinationConfiguration,
                    "FromTimestamp" => FromTimestamp,
                    "ToTimestamp" => ToTimestamp,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_archive_search(archive_id, from_timestamp, max_results, to_timestamp)
    start_archive_search(archive_id, from_timestamp, max_results, to_timestamp, params::Dict{String,<:Any})

Initiates a search across emails in the specified archive.

# Arguments
- `archive_id`: The identifier of the archive to search emails in.
- `from_timestamp`: The start timestamp of the range to search emails from.
- `max_results`: The maximum number of search results to return.
- `to_timestamp`: The end timestamp of the range to search emails from.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: Criteria to filter which emails are included in the search results.
"""
function start_archive_search(
    ArchiveId,
    FromTimestamp,
    MaxResults,
    ToTimestamp;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mailmanager(
        "StartArchiveSearch",
        Dict{String,Any}(
            "ArchiveId" => ArchiveId,
            "FromTimestamp" => FromTimestamp,
            "MaxResults" => MaxResults,
            "ToTimestamp" => ToTimestamp,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_archive_search(
    ArchiveId,
    FromTimestamp,
    MaxResults,
    ToTimestamp,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mailmanager(
        "StartArchiveSearch",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ArchiveId" => ArchiveId,
                    "FromTimestamp" => FromTimestamp,
                    "MaxResults" => MaxResults,
                    "ToTimestamp" => ToTimestamp,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_archive_export(export_id)
    stop_archive_export(export_id, params::Dict{String,<:Any})

Stops an in-progress export of emails from an archive.

# Arguments
- `export_id`: The identifier of the export job to stop.

"""
function stop_archive_export(ExportId; aws_config::AbstractAWSConfig=current_aws_config())
    return mailmanager(
        "StopArchiveExport",
        Dict{String,Any}("ExportId" => ExportId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_archive_export(
    ExportId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mailmanager(
        "StopArchiveExport",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ExportId" => ExportId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_archive_search(search_id)
    stop_archive_search(search_id, params::Dict{String,<:Any})

Stops an in-progress archive search job.

# Arguments
- `search_id`: The identifier of the search job to stop.

"""
function stop_archive_search(SearchId; aws_config::AbstractAWSConfig=current_aws_config())
    return mailmanager(
        "StopArchiveSearch",
        Dict{String,Any}("SearchId" => SearchId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_archive_search(
    SearchId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mailmanager(
        "StopArchiveSearch",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("SearchId" => SearchId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

 Adds one or more tags (keys and values) to a specified resource.

# Arguments
- `resource_arn`:  The Amazon Resource Name (ARN) of the resource that you want to tag.
- `tags`:  The tags used to organize, track, or control access for the resource. For
  example, { \"tags\": {\"key1\":\"value1\", \"key2\":\"value2\"} }.

"""
function tag_resource(ResourceArn, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return mailmanager(
        "TagResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceArn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mailmanager(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

 Remove one or more tags (keys and values) from a specified resource.

# Arguments
- `resource_arn`:  The Amazon Resource Name (ARN) of the resource that you want to untag.
- `tag_keys`:  The keys of the key-value pairs for the tag or tags you want to remove from
  the specified resource.

"""
function untag_resource(
    ResourceArn, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mailmanager(
        "UntagResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceArn,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mailmanager(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_archive(archive_id)
    update_archive(archive_id, params::Dict{String,<:Any})

Updates the attributes of an existing email archive.

# Arguments
- `archive_id`: The identifier of the archive to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ArchiveName"`: A new, unique name for the archive.
- `"Retention"`: A new retention period for emails in the archive.
"""
function update_archive(ArchiveId; aws_config::AbstractAWSConfig=current_aws_config())
    return mailmanager(
        "UpdateArchive",
        Dict{String,Any}("ArchiveId" => ArchiveId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_archive(
    ArchiveId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mailmanager(
        "UpdateArchive",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ArchiveId" => ArchiveId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_ingress_point(ingress_point_id)
    update_ingress_point(ingress_point_id, params::Dict{String,<:Any})

Update attributes of a provisioned ingress endpoint resource.

# Arguments
- `ingress_point_id`: The identifier for the ingress endpoint you want to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"IngressPointConfiguration"`: If you choose an Authenticated ingress endpoint, you must
  configure either an SMTP password or a secret ARN.
- `"IngressPointName"`: A user friendly name for the ingress endpoint resource.
- `"RuleSetId"`: The identifier of an existing rule set that you attach to an ingress
  endpoint resource.
- `"StatusToUpdate"`: The update status of an ingress endpoint.
- `"TrafficPolicyId"`: The identifier of an existing traffic policy that you attach to an
  ingress endpoint resource.
"""
function update_ingress_point(
    IngressPointId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mailmanager(
        "UpdateIngressPoint",
        Dict{String,Any}("IngressPointId" => IngressPointId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_ingress_point(
    IngressPointId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mailmanager(
        "UpdateIngressPoint",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("IngressPointId" => IngressPointId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_relay(relay_id)
    update_relay(relay_id, params::Dict{String,<:Any})

Updates the attributes of an existing relay resource.

# Arguments
- `relay_id`: The unique relay identifier.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Authentication"`: Authentication for the relay destination server—specify the
  secretARN where the SMTP credentials are stored.
- `"RelayName"`: The name of the relay resource.
- `"ServerName"`: The destination relay server address.
- `"ServerPort"`: The destination relay server port.
"""
function update_relay(RelayId; aws_config::AbstractAWSConfig=current_aws_config())
    return mailmanager(
        "UpdateRelay",
        Dict{String,Any}("RelayId" => RelayId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_relay(
    RelayId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mailmanager(
        "UpdateRelay",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("RelayId" => RelayId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_rule_set(rule_set_id)
    update_rule_set(rule_set_id, params::Dict{String,<:Any})

&gt;Update attributes of an already provisioned rule set.

# Arguments
- `rule_set_id`: The identifier of a rule set you want to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"RuleSetName"`: A user-friendly name for the rule set resource.
- `"Rules"`: A new set of rules to replace the current rules of the rule set—these rules
  will override all the rules of the rule set.
"""
function update_rule_set(RuleSetId; aws_config::AbstractAWSConfig=current_aws_config())
    return mailmanager(
        "UpdateRuleSet",
        Dict{String,Any}("RuleSetId" => RuleSetId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_rule_set(
    RuleSetId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mailmanager(
        "UpdateRuleSet",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("RuleSetId" => RuleSetId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_traffic_policy(traffic_policy_id)
    update_traffic_policy(traffic_policy_id, params::Dict{String,<:Any})

Update attributes of an already provisioned traffic policy resource.

# Arguments
- `traffic_policy_id`: The identifier of the traffic policy that you want to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DefaultAction"`: Default action instructs the traﬃc policy to either Allow or Deny
  (block) messages that fall outside of (or not addressed by) the conditions of your policy
  statements
- `"MaxMessageSizeBytes"`: The maximum message size in bytes of email which is allowed in
  by this traffic policy—anything larger will be blocked.
- `"PolicyStatements"`: The list of conditions to be updated for filtering email traffic.
- `"TrafficPolicyName"`: A user-friendly name for the traffic policy resource.
"""
function update_traffic_policy(
    TrafficPolicyId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mailmanager(
        "UpdateTrafficPolicy",
        Dict{String,Any}("TrafficPolicyId" => TrafficPolicyId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_traffic_policy(
    TrafficPolicyId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mailmanager(
        "UpdateTrafficPolicy",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("TrafficPolicyId" => TrafficPolicyId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWS.jl
using AWS
using AWS.AWSServices: ssm_quicksetup
using AWS.Compat
using AWS.UUIDs

"""
    create_configuration_manager(configuration_definitions)
    create_configuration_manager(configuration_definitions, params::Dict{String,<:Any})

Creates a Quick Setup configuration manager resource. This object is a collection of
desired state configurations for multiple configuration definitions and summaries
describing the deployments of those definitions.

# Arguments
- `configuration_definitions`: The definition of the Quick Setup configuration that the
  configuration manager deploys.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description of the configuration manager.
- `"Name"`: A name for the configuration manager.
- `"Tags"`: Key-value pairs of metadata to assign to the configuration manager.
"""
function create_configuration_manager end

function create_configuration_manager(
    ConfigurationDefinitions; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_quicksetup(
        "POST",
        "/configurationManager",
        Dict{String,Any}("ConfigurationDefinitions" => ConfigurationDefinitions);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function create_configuration_manager(
    ConfigurationDefinitions,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_quicksetup(
        "POST",
        "/configurationManager",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ConfigurationDefinitions" => ConfigurationDefinitions),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_configuration_manager(manager_arn)
    delete_configuration_manager(manager_arn, params::Dict{String,<:Any})

Deletes a configuration manager.

# Arguments
- `manager_arn`: The ID of the configuration manager.

"""
function delete_configuration_manager end

function delete_configuration_manager(
    ManagerArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_quicksetup(
        "DELETE",
        "/configurationManager/$(ManagerArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function delete_configuration_manager(
    ManagerArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_quicksetup(
        "DELETE",
        "/configurationManager/$(ManagerArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_configuration_manager(manager_arn)
    get_configuration_manager(manager_arn, params::Dict{String,<:Any})

Returns a configuration manager.

# Arguments
- `manager_arn`: The ARN of the configuration manager.

"""
function get_configuration_manager end

function get_configuration_manager(
    ManagerArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_quicksetup(
        "GET",
        "/configurationManager/$(ManagerArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function get_configuration_manager(
    ManagerArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_quicksetup(
        "GET",
        "/configurationManager/$(ManagerArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_service_settings()
    get_service_settings(params::Dict{String,<:Any})

Returns settings configured for Quick Setup in the requesting Amazon Web Services account
and Amazon Web Services Region.

"""
function get_service_settings end

function get_service_settings(; aws_config::AbstractAWSConfig=current_aws_config())
    return ssm_quicksetup(
        "GET", "/serviceSettings"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

function get_service_settings(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_quicksetup(
        "GET",
        "/serviceSettings",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_configuration_managers()
    list_configuration_managers(params::Dict{String,<:Any})

Returns Quick Setup configuration managers.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filters"`: Filters the results returned by the request.
- `"MaxItems"`: Specifies the maximum number of configuration managers that are returned by
  the request.
- `"StartingToken"`: The token to use when requesting a specific set of items from a list.
"""
function list_configuration_managers end

function list_configuration_managers(; aws_config::AbstractAWSConfig=current_aws_config())
    return ssm_quicksetup(
        "POST",
        "/listConfigurationManagers";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function list_configuration_managers(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_quicksetup(
        "POST",
        "/listConfigurationManagers",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_quick_setup_types()
    list_quick_setup_types(params::Dict{String,<:Any})

Returns the available Quick Setup types.

"""
function list_quick_setup_types end

function list_quick_setup_types(; aws_config::AbstractAWSConfig=current_aws_config())
    return ssm_quicksetup(
        "GET",
        "/listQuickSetupTypes";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function list_quick_setup_types(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_quicksetup(
        "GET",
        "/listQuickSetupTypes",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Returns tags assigned to the resource.

# Arguments
- `resource_arn`: The ARN of the resource the tag is assigned to.

"""
function list_tags_for_resource end

function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_quicksetup(
        "GET",
        "/tags/$(ResourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_quicksetup(
        "GET",
        "/tags/$(ResourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Assigns key-value pairs of metadata to Amazon Web Services resources.

# Arguments
- `resource_arn`: The ARN of the resource to tag.
- `tags`: Key-value pairs of metadata to assign to the resource.

"""
function tag_resource end

function tag_resource(ResourceArn, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return ssm_quicksetup(
        "PUT",
        "/tags/$(ResourceArn)",
        Dict{String,Any}("Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function tag_resource(
    ResourceArn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_quicksetup(
        "PUT",
        "/tags/$(ResourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Tags" => Tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes tags from the specified resource.

# Arguments
- `resource_arn`: The ARN of the resource to remove tags from.
- `tag_keys`: The keys of the tags to remove from the resource.

"""
function untag_resource end

function untag_resource(
    ResourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_quicksetup(
        "DELETE",
        "/tags/$(ResourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function untag_resource(
    ResourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_quicksetup(
        "DELETE",
        "/tags/$(ResourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_configuration_definition(id, manager_arn)
    update_configuration_definition(id, manager_arn, params::Dict{String,<:Any})

Updates a Quick Setup configuration definition.

# Arguments
- `id`: The ID of the configuration definition you want to update.
- `manager_arn`: The ARN of the configuration manager associated with the definition to
  update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"LocalDeploymentAdministrationRoleArn"`: The ARN of the IAM role used to administrate
  local configuration deployments.
- `"LocalDeploymentExecutionRoleName"`: The name of the IAM role used to deploy local
  configurations.
- `"Parameters"`: The parameters for the configuration definition type.
- `"TypeVersion"`: The version of the Quick Setup type to use.
"""
function update_configuration_definition end

function update_configuration_definition(
    Id, ManagerArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_quicksetup(
        "PUT",
        "/configurationDefinition/$(ManagerArn)/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function update_configuration_definition(
    Id,
    ManagerArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_quicksetup(
        "PUT",
        "/configurationDefinition/$(ManagerArn)/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_configuration_manager(manager_arn)
    update_configuration_manager(manager_arn, params::Dict{String,<:Any})

Updates a Quick Setup configuration manager.

# Arguments
- `manager_arn`: The ARN of the configuration manager.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description of the configuration manager.
- `"Name"`: A name for the configuration manager.
"""
function update_configuration_manager end

function update_configuration_manager(
    ManagerArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_quicksetup(
        "PUT",
        "/configurationManager/$(ManagerArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function update_configuration_manager(
    ManagerArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ssm_quicksetup(
        "PUT",
        "/configurationManager/$(ManagerArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_service_settings()
    update_service_settings(params::Dict{String,<:Any})

Updates settings configured for Quick Setup.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ExplorerEnablingRoleArn"`: The IAM role used to enable Explorer.
"""
function update_service_settings end

function update_service_settings(; aws_config::AbstractAWSConfig=current_aws_config())
    return ssm_quicksetup(
        "PUT", "/serviceSettings"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

function update_service_settings(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ssm_quicksetup(
        "PUT",
        "/serviceSettings",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: synthetics
using AWS.Compat
using AWS.UUIDs

"""
    associate_resource(resource_arn, group_identifier)
    associate_resource(resource_arn, group_identifier, params::Dict{String,<:Any})

Associates a canary with a group. Using groups can help you with managing and automating
your canaries, and you can also view aggregated run results and statistics for all canaries
in a group.  You must run this operation in the Region where the canary exists.

# Arguments
- `resource_arn`: The ARN of the canary that you want to associate with the specified group.
- `group_identifier`: Specifies the group. You can specify the group name, the ARN, or the
  group ID as the GroupIdentifier.

"""
function associate_resource(
    ResourceArn, groupIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return synthetics(
        "PATCH",
        "/group/$(groupIdentifier)/associate",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_resource(
    ResourceArn,
    groupIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return synthetics(
        "PATCH",
        "/group/$(groupIdentifier)/associate",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_canary(artifact_s3_location, code, execution_role_arn, name, runtime_version, schedule)
    create_canary(artifact_s3_location, code, execution_role_arn, name, runtime_version, schedule, params::Dict{String,<:Any})

Creates a canary. Canaries are scripts that monitor your endpoints and APIs from the
outside-in. Canaries help you check the availability and latency of your web services and
troubleshoot anomalies by investigating load time data, screenshots of the UI, logs, and
metrics. You can set up a canary to run continuously or just once.  Do not use CreateCanary
to modify an existing canary. Use UpdateCanary instead. To create canaries, you must have
the CloudWatchSyntheticsFullAccess policy. If you are creating a new IAM role for the
canary, you also need the iam:CreateRole, iam:CreatePolicy and iam:AttachRolePolicy
permissions. For more information, see Necessary Roles and Permissions. Do not include
secrets or proprietary information in your canary names. The canary name makes up part of
the Amazon Resource Name (ARN) for the canary, and the ARN is included in outbound calls
over the internet. For more information, see Security Considerations for Synthetics
Canaries.

# Arguments
- `artifact_s3_location`: The location in Amazon S3 where Synthetics stores artifacts from
  the test runs of this canary. Artifacts include the log file, screenshots, and HAR files.
  The name of the S3 bucket can't include a period (.).
- `code`: A structure that includes the entry point from which the canary should start
  running your script. If the script is stored in an S3 bucket, the bucket name, key, and
  version are also included.
- `execution_role_arn`: The ARN of the IAM role to be used to run the canary. This role
  must already exist, and must include lambda.amazonaws.com as a principal in the trust
  policy. The role must also have the following permissions:    s3:PutObject
  s3:GetBucketLocation     s3:ListAllMyBuckets     cloudwatch:PutMetricData
  logs:CreateLogGroup     logs:CreateLogStream     logs:PutLogEvents
- `name`: The name for this canary. Be sure to give it a descriptive name that
  distinguishes it from other canaries in your account. Do not include secrets or proprietary
  information in your canary names. The canary name makes up part of the canary ARN, and the
  ARN is included in outbound calls over the internet. For more information, see Security
  Considerations for Synthetics Canaries.
- `runtime_version`: Specifies the runtime version to use for the canary. For a list of
  valid runtime versions and more information about runtime versions, see  Canary Runtime
  Versions.
- `schedule`: A structure that contains information about how often the canary is to run
  and when these test runs are to stop.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ArtifactConfig"`: A structure that contains the configuration for canary artifacts,
  including the encryption-at-rest settings for artifacts that the canary uploads to Amazon
  S3.
- `"FailureRetentionPeriodInDays"`: The number of days to retain data about failed runs of
  this canary. If you omit this field, the default of 31 days is used. The valid range is 1
  to 455 days.
- `"RunConfig"`: A structure that contains the configuration for individual canary runs,
  such as timeout value and environment variables.  The environment variables keys and values
  are not encrypted. Do not store sensitive information in this field.
- `"SuccessRetentionPeriodInDays"`: The number of days to retain data about successful runs
  of this canary. If you omit this field, the default of 31 days is used. The valid range is
  1 to 455 days.
- `"Tags"`: A list of key-value pairs to associate with the canary. You can associate as
  many as 50 tags with a canary. Tags can help you organize and categorize your resources.
  You can also use them to scope user permissions, by granting a user permission to access or
  change only the resources that have certain tag values.
- `"VpcConfig"`: If this canary is to test an endpoint in a VPC, this structure contains
  information about the subnet and security groups of the VPC endpoint. For more information,
  see  Running a Canary in a VPC.
"""
function create_canary(
    ArtifactS3Location,
    Code,
    ExecutionRoleArn,
    Name,
    RuntimeVersion,
    Schedule;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return synthetics(
        "POST",
        "/canary",
        Dict{String,Any}(
            "ArtifactS3Location" => ArtifactS3Location,
            "Code" => Code,
            "ExecutionRoleArn" => ExecutionRoleArn,
            "Name" => Name,
            "RuntimeVersion" => RuntimeVersion,
            "Schedule" => Schedule,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_canary(
    ArtifactS3Location,
    Code,
    ExecutionRoleArn,
    Name,
    RuntimeVersion,
    Schedule,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return synthetics(
        "POST",
        "/canary",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ArtifactS3Location" => ArtifactS3Location,
                    "Code" => Code,
                    "ExecutionRoleArn" => ExecutionRoleArn,
                    "Name" => Name,
                    "RuntimeVersion" => RuntimeVersion,
                    "Schedule" => Schedule,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_group(name)
    create_group(name, params::Dict{String,<:Any})

Creates a group which you can use to associate canaries with each other, including
cross-Region canaries. Using groups can help you with managing and automating your
canaries, and you can also view aggregated run results and statistics for all canaries in a
group.  Groups are global resources. When you create a group, it is replicated across
Amazon Web Services Regions, and you can view it and add canaries to it from any Region.
Although the group ARN format reflects the Region name where it was created, a group is not
constrained to any Region. This means that you can put canaries from multiple Regions into
the same group, and then use that group to view and manage all of those canaries in a
single view. Groups are supported in all Regions except the Regions that are disabled by
default. For more information about these Regions, see Enabling a Region. Each group can
contain as many as 10 canaries. You can have as many as 20 groups in your account. Any
single canary can be a member of up to 10 groups.

# Arguments
- `name`: The name for the group. It can include any Unicode characters. The names for all
  groups in your account, across all Regions, must be unique.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: A list of key-value pairs to associate with the group. You can associate as
  many as 50 tags with a group. Tags can help you organize and categorize your resources. You
  can also use them to scope user permissions, by granting a user permission to access or
  change only the resources that have certain tag values.
"""
function create_group(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return synthetics(
        "POST",
        "/group",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_group(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return synthetics(
        "POST",
        "/group",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_canary(name)
    delete_canary(name, params::Dict{String,<:Any})

Permanently deletes the specified canary. If you specify DeleteLambda to true, CloudWatch
Synthetics also deletes the Lambda functions and layers that are used by the canary. Other
resources used and created by the canary are not automatically deleted. After you delete a
canary that you do not intend to use again, you should also delete the following:   The
CloudWatch alarms created for this canary. These alarms have a name of
Synthetics-SharpDrop-Alarm-MyCanaryName .   Amazon S3 objects and buckets, such as the
canary's artifact location.   IAM roles created for the canary. If they were created in the
console, these roles have the name  role/service-role/CloudWatchSyntheticsRole-MyCanaryName
.   CloudWatch Logs log groups created for the canary. These logs groups have the name
/aws/lambda/cwsyn-MyCanaryName .    Before you delete a canary, you might want to use
GetCanary to display the information about this canary. Make note of the information
returned by this operation so that you can delete these resources after you delete the
canary.

# Arguments
- `name`: The name of the canary that you want to delete. To find the names of your
  canaries, use DescribeCanaries.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"deleteLambda"`: Specifies whether to also delete the Lambda functions and layers used
  by this canary. The default is false. Type: Boolean
"""
function delete_canary(name; aws_config::AbstractAWSConfig=current_aws_config())
    return synthetics(
        "DELETE", "/canary/$(name)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function delete_canary(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return synthetics(
        "DELETE",
        "/canary/$(name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_group(group_identifier)
    delete_group(group_identifier, params::Dict{String,<:Any})

Deletes a group. The group doesn't need to be empty to be deleted. If there are canaries in
the group, they are not deleted when you delete the group.  Groups are a global resource
that appear in all Regions, but the request to delete a group must be made from its home
Region. You can find the home Region of a group within its ARN.

# Arguments
- `group_identifier`: Specifies which group to delete. You can specify the group name, the
  ARN, or the group ID as the GroupIdentifier.

"""
function delete_group(groupIdentifier; aws_config::AbstractAWSConfig=current_aws_config())
    return synthetics(
        "DELETE",
        "/group/$(groupIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_group(
    groupIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return synthetics(
        "DELETE",
        "/group/$(groupIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_canaries()
    describe_canaries(params::Dict{String,<:Any})

This operation returns a list of the canaries in your account, along with full details
about each canary. This operation supports resource-level authorization using an IAM policy
and the Names parameter. If you specify the Names parameter, the operation is successful
only if you have authorization to view all the canaries that you specify in your request.
If you do not have permission to view any of the canaries, the request fails with a 403
response. You are required to use the Names parameter if you are logged on to a user or
role that has an IAM policy that restricts which canaries that you are allowed to view. For
more information, see  Limiting a user to viewing specific canaries.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Specify this parameter to limit how many canaries are returned each time
  you use the DescribeCanaries operation. If you omit this parameter, the default of 100 is
  used.
- `"Names"`: Use this parameter to return only canaries that match the names that you
  specify here. You can specify as many as five canary names. If you specify this parameter,
  the operation is successful only if you have authorization to view all the canaries that
  you specify in your request. If you do not have permission to view any of the canaries, the
  request fails with a 403 response. You are required to use this parameter if you are logged
  on to a user or role that has an IAM policy that restricts which canaries that you are
  allowed to view. For more information, see  Limiting a user to viewing specific canaries.
- `"NextToken"`: A token that indicates that there is more data available. You can use this
  token in a subsequent operation to retrieve the next set of results.
"""
function describe_canaries(; aws_config::AbstractAWSConfig=current_aws_config())
    return synthetics(
        "POST", "/canaries"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_canaries(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return synthetics(
        "POST", "/canaries", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_canaries_last_run()
    describe_canaries_last_run(params::Dict{String,<:Any})

Use this operation to see information from the most recent run of each canary that you have
created. This operation supports resource-level authorization using an IAM policy and the
Names parameter. If you specify the Names parameter, the operation is successful only if
you have authorization to view all the canaries that you specify in your request. If you do
not have permission to view any of the canaries, the request fails with a 403 response. You
are required to use the Names parameter if you are logged on to a user or role that has an
IAM policy that restricts which canaries that you are allowed to view. For more
information, see  Limiting a user to viewing specific canaries.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Specify this parameter to limit how many runs are returned each time you
  use the DescribeLastRun operation. If you omit this parameter, the default of 100 is used.
- `"Names"`: Use this parameter to return only canaries that match the names that you
  specify here. You can specify as many as five canary names. If you specify this parameter,
  the operation is successful only if you have authorization to view all the canaries that
  you specify in your request. If you do not have permission to view any of the canaries, the
  request fails with a 403 response. You are required to use the Names parameter if you are
  logged on to a user or role that has an IAM policy that restricts which canaries that you
  are allowed to view. For more information, see  Limiting a user to viewing specific
  canaries.
- `"NextToken"`: A token that indicates that there is more data available. You can use this
  token in a subsequent DescribeCanariesLastRun operation to retrieve the next set of results.
"""
function describe_canaries_last_run(; aws_config::AbstractAWSConfig=current_aws_config())
    return synthetics(
        "POST", "/canaries/last-run"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_canaries_last_run(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return synthetics(
        "POST",
        "/canaries/last-run",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_runtime_versions()
    describe_runtime_versions(params::Dict{String,<:Any})

Returns a list of Synthetics canary runtime versions. For more information, see  Canary
Runtime Versions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Specify this parameter to limit how many runs are returned each time you
  use the DescribeRuntimeVersions operation. If you omit this parameter, the default of 100
  is used.
- `"NextToken"`: A token that indicates that there is more data available. You can use this
  token in a subsequent DescribeRuntimeVersions operation to retrieve the next set of results.
"""
function describe_runtime_versions(; aws_config::AbstractAWSConfig=current_aws_config())
    return synthetics(
        "POST", "/runtime-versions"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_runtime_versions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return synthetics(
        "POST",
        "/runtime-versions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_resource(resource_arn, group_identifier)
    disassociate_resource(resource_arn, group_identifier, params::Dict{String,<:Any})

Removes a canary from a group. You must run this operation in the Region where the canary
exists.

# Arguments
- `resource_arn`: The ARN of the canary that you want to remove from the specified group.
- `group_identifier`: Specifies the group. You can specify the group name, the ARN, or the
  group ID as the GroupIdentifier.

"""
function disassociate_resource(
    ResourceArn, groupIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return synthetics(
        "PATCH",
        "/group/$(groupIdentifier)/disassociate",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_resource(
    ResourceArn,
    groupIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return synthetics(
        "PATCH",
        "/group/$(groupIdentifier)/disassociate",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_canary(name)
    get_canary(name, params::Dict{String,<:Any})

Retrieves complete information about one canary. You must specify the name of the canary
that you want. To get a list of canaries and their names, use DescribeCanaries.

# Arguments
- `name`: The name of the canary that you want details for.

"""
function get_canary(name; aws_config::AbstractAWSConfig=current_aws_config())
    return synthetics(
        "GET", "/canary/$(name)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_canary(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return synthetics(
        "GET",
        "/canary/$(name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_canary_runs(name)
    get_canary_runs(name, params::Dict{String,<:Any})

Retrieves a list of runs for a specified canary.

# Arguments
- `name`: The name of the canary that you want to see runs for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Specify this parameter to limit how many runs are returned each time you
  use the GetCanaryRuns operation. If you omit this parameter, the default of 100 is used.
- `"NextToken"`: A token that indicates that there is more data available. You can use this
  token in a subsequent GetCanaryRuns operation to retrieve the next set of results.
"""
function get_canary_runs(name; aws_config::AbstractAWSConfig=current_aws_config())
    return synthetics(
        "POST",
        "/canary/$(name)/runs";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_canary_runs(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return synthetics(
        "POST",
        "/canary/$(name)/runs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_group(group_identifier)
    get_group(group_identifier, params::Dict{String,<:Any})

Returns information about one group. Groups are a global resource, so you can use this
operation from any Region.

# Arguments
- `group_identifier`: Specifies the group to return information for. You can specify the
  group name, the ARN, or the group ID as the GroupIdentifier.

"""
function get_group(groupIdentifier; aws_config::AbstractAWSConfig=current_aws_config())
    return synthetics(
        "GET",
        "/group/$(groupIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_group(
    groupIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return synthetics(
        "GET",
        "/group/$(groupIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_associated_groups(resource_arn)
    list_associated_groups(resource_arn, params::Dict{String,<:Any})

Returns a list of the groups that the specified canary is associated with. The canary that
you specify must be in the current Region.

# Arguments
- `resource_arn`: The ARN of the canary that you want to view groups for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Specify this parameter to limit how many groups are returned each time
  you use the ListAssociatedGroups operation. If you omit this parameter, the default of 20
  is used.
- `"NextToken"`: A token that indicates that there is more data available. You can use this
  token in a subsequent operation to retrieve the next set of results.
"""
function list_associated_groups(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return synthetics(
        "POST",
        "/resource/$(resourceArn)/groups";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_associated_groups(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return synthetics(
        "POST",
        "/resource/$(resourceArn)/groups",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_group_resources(group_identifier)
    list_group_resources(group_identifier, params::Dict{String,<:Any})

This operation returns a list of the ARNs of the canaries that are associated with the
specified group.

# Arguments
- `group_identifier`: Specifies the group to return information for. You can specify the
  group name, the ARN, or the group ID as the GroupIdentifier.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Specify this parameter to limit how many canary ARNs are returned each
  time you use the ListGroupResources operation. If you omit this parameter, the default of
  20 is used.
- `"NextToken"`: A token that indicates that there is more data available. You can use this
  token in a subsequent operation to retrieve the next set of results.
"""
function list_group_resources(
    groupIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return synthetics(
        "POST",
        "/group/$(groupIdentifier)/resources";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_group_resources(
    groupIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return synthetics(
        "POST",
        "/group/$(groupIdentifier)/resources",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_groups()
    list_groups(params::Dict{String,<:Any})

Returns a list of all groups in the account, displaying their names, unique IDs, and ARNs.
The groups from all Regions are returned.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: Specify this parameter to limit how many groups are returned each time
  you use the ListGroups operation. If you omit this parameter, the default of 20 is used.
- `"NextToken"`: A token that indicates that there is more data available. You can use this
  token in a subsequent operation to retrieve the next set of results.
"""
function list_groups(; aws_config::AbstractAWSConfig=current_aws_config())
    return synthetics(
        "POST", "/groups"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_groups(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return synthetics(
        "POST", "/groups", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Displays the tags associated with a canary or group.

# Arguments
- `resource_arn`: The ARN of the canary or group that you want to view tags for. The ARN
  format of a canary is arn:aws:synthetics:Region:account-id:canary:canary-name . The ARN
  format of a group is arn:aws:synthetics:Region:account-id:group:group-name

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return synthetics(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return synthetics(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_canary(name)
    start_canary(name, params::Dict{String,<:Any})

Use this operation to run a canary that has already been created. The frequency of the
canary runs is determined by the value of the canary's Schedule. To see a canary's
schedule, use GetCanary.

# Arguments
- `name`: The name of the canary that you want to run. To find canary names, use
  DescribeCanaries.

"""
function start_canary(name; aws_config::AbstractAWSConfig=current_aws_config())
    return synthetics(
        "POST",
        "/canary/$(name)/start";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_canary(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return synthetics(
        "POST",
        "/canary/$(name)/start",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_canary(name)
    stop_canary(name, params::Dict{String,<:Any})

Stops the canary to prevent all future runs. If the canary is currently running,the run
that is in progress completes on its own, publishes metrics, and uploads artifacts, but it
is not recorded in Synthetics as a completed run. You can use StartCanary to start it
running again with the canary’s current schedule at any point in the future.

# Arguments
- `name`: The name of the canary that you want to stop. To find the names of your canaries,
  use ListCanaries.

"""
function stop_canary(name; aws_config::AbstractAWSConfig=current_aws_config())
    return synthetics(
        "POST",
        "/canary/$(name)/stop";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_canary(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return synthetics(
        "POST",
        "/canary/$(name)/stop",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(tags, resource_arn)
    tag_resource(tags, resource_arn, params::Dict{String,<:Any})

Assigns one or more tags (key-value pairs) to the specified canary or group.  Tags can help
you organize and categorize your resources. You can also use them to scope user
permissions, by granting a user permission to access or change only resources with certain
tag values. Tags don't have any semantic meaning to Amazon Web Services and are interpreted
strictly as strings of characters. You can use the TagResource action with a resource that
already has tags. If you specify a new tag key for the resource, this tag is appended to
the list of tags associated with the resource. If you specify a tag key that is already
associated with the resource, the new tag value that you specify replaces the previous
value for that tag. You can associate as many as 50 tags with a canary or group.

# Arguments
- `tags`: The list of key-value pairs to associate with the resource.
- `resource_arn`: The ARN of the canary or group that you're adding tags to. The ARN format
  of a canary is arn:aws:synthetics:Region:account-id:canary:canary-name . The ARN format of
  a group is arn:aws:synthetics:Region:account-id:group:group-name

"""
function tag_resource(Tags, resourceArn; aws_config::AbstractAWSConfig=current_aws_config())
    return synthetics(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    Tags,
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return synthetics(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Tags" => Tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes one or more tags from the specified resource.

# Arguments
- `resource_arn`: The ARN of the canary or group that you're removing tags from. The ARN
  format of a canary is arn:aws:synthetics:Region:account-id:canary:canary-name . The ARN
  format of a group is arn:aws:synthetics:Region:account-id:group:group-name
- `tag_keys`: The list of tag keys to remove from the resource.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return synthetics(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return synthetics(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_canary(name)
    update_canary(name, params::Dict{String,<:Any})

Updates the configuration of a canary that has already been created. You can't use this
operation to update the tags of an existing canary. To change the tags of an existing
canary, use TagResource.

# Arguments
- `name`: The name of the canary that you want to update. To find the names of your
  canaries, use DescribeCanaries. You cannot change the name of a canary that has already
  been created.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ArtifactConfig"`: A structure that contains the configuration for canary artifacts,
  including the encryption-at-rest settings for artifacts that the canary uploads to Amazon
  S3.
- `"ArtifactS3Location"`: The location in Amazon S3 where Synthetics stores artifacts from
  the test runs of this canary. Artifacts include the log file, screenshots, and HAR files.
  The name of the S3 bucket can't include a period (.).
- `"Code"`: A structure that includes the entry point from which the canary should start
  running your script. If the script is stored in an S3 bucket, the bucket name, key, and
  version are also included.
- `"ExecutionRoleArn"`: The ARN of the IAM role to be used to run the canary. This role
  must already exist, and must include lambda.amazonaws.com as a principal in the trust
  policy. The role must also have the following permissions:    s3:PutObject
  s3:GetBucketLocation     s3:ListAllMyBuckets     cloudwatch:PutMetricData
  logs:CreateLogGroup     logs:CreateLogStream     logs:CreateLogStream
- `"FailureRetentionPeriodInDays"`: The number of days to retain data about failed runs of
  this canary.
- `"RunConfig"`: A structure that contains the timeout value that is used for each
  individual run of the canary.  The environment variables keys and values are not encrypted.
  Do not store sensitive information in this field.
- `"RuntimeVersion"`: Specifies the runtime version to use for the canary. For a list of
  valid runtime versions and for more information about runtime versions, see  Canary Runtime
  Versions.
- `"Schedule"`: A structure that contains information about how often the canary is to run,
  and when these runs are to stop.
- `"SuccessRetentionPeriodInDays"`: The number of days to retain data about successful runs
  of this canary.
- `"VisualReference"`: Defines the screenshots to use as the baseline for comparisons
  during visual monitoring comparisons during future runs of this canary. If you omit this
  parameter, no changes are made to any baseline screenshots that the canary might be using
  already. Visual monitoring is supported only on canaries running the syn-puppeteer-node-3.2
  runtime or later. For more information, see  Visual monitoring and  Visual monitoring
  blueprint
- `"VpcConfig"`: If this canary is to test an endpoint in a VPC, this structure contains
  information about the subnet and security groups of the VPC endpoint. For more information,
  see  Running a Canary in a VPC.
"""
function update_canary(name; aws_config::AbstractAWSConfig=current_aws_config())
    return synthetics(
        "PATCH", "/canary/$(name)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function update_canary(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return synthetics(
        "PATCH",
        "/canary/$(name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: robomaker
using AWS.Compat
using AWS.UUIDs

"""
    batch_delete_worlds(worlds)
    batch_delete_worlds(worlds, params::Dict{String,<:Any})

Deletes one or more worlds in a batch operation.

# Arguments
- `worlds`: A list of Amazon Resource Names (arns) that correspond to worlds to delete.

"""
function batch_delete_worlds(worlds; aws_config::AbstractAWSConfig=current_aws_config())
    return robomaker(
        "POST",
        "/batchDeleteWorlds",
        Dict{String,Any}("worlds" => worlds);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_delete_worlds(
    worlds, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return robomaker(
        "POST",
        "/batchDeleteWorlds",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("worlds" => worlds), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_describe_simulation_job(jobs)
    batch_describe_simulation_job(jobs, params::Dict{String,<:Any})

Describes one or more simulation jobs.

# Arguments
- `jobs`: A list of Amazon Resource Names (ARNs) of simulation jobs to describe.

"""
function batch_describe_simulation_job(
    jobs; aws_config::AbstractAWSConfig=current_aws_config()
)
    return robomaker(
        "POST",
        "/batchDescribeSimulationJob",
        Dict{String,Any}("jobs" => jobs);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_describe_simulation_job(
    jobs, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return robomaker(
        "POST",
        "/batchDescribeSimulationJob",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("jobs" => jobs), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_deployment_job(job)
    cancel_deployment_job(job, params::Dict{String,<:Any})

Cancels the specified deployment job.  This API will no longer be supported as of May 2,
2022. Use it to remove resources that were created for Deployment Service.

# Arguments
- `job`: The deployment job ARN to cancel.

"""
function cancel_deployment_job(job; aws_config::AbstractAWSConfig=current_aws_config())
    return robomaker(
        "POST",
        "/cancelDeploymentJob",
        Dict{String,Any}("job" => job);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_deployment_job(
    job, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return robomaker(
        "POST",
        "/cancelDeploymentJob",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("job" => job), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_simulation_job(job)
    cancel_simulation_job(job, params::Dict{String,<:Any})

Cancels the specified simulation job.

# Arguments
- `job`: The simulation job ARN to cancel.

"""
function cancel_simulation_job(job; aws_config::AbstractAWSConfig=current_aws_config())
    return robomaker(
        "POST",
        "/cancelSimulationJob",
        Dict{String,Any}("job" => job);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_simulation_job(
    job, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return robomaker(
        "POST",
        "/cancelSimulationJob",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("job" => job), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_simulation_job_batch(batch)
    cancel_simulation_job_batch(batch, params::Dict{String,<:Any})

Cancels a simulation job batch. When you cancel a simulation job batch, you are also
cancelling all of the active simulation jobs created as part of the batch.

# Arguments
- `batch`: The id of the batch to cancel.

"""
function cancel_simulation_job_batch(
    batch; aws_config::AbstractAWSConfig=current_aws_config()
)
    return robomaker(
        "POST",
        "/cancelSimulationJobBatch",
        Dict{String,Any}("batch" => batch);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_simulation_job_batch(
    batch, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return robomaker(
        "POST",
        "/cancelSimulationJobBatch",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("batch" => batch), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_world_export_job(job)
    cancel_world_export_job(job, params::Dict{String,<:Any})

Cancels the specified export job.

# Arguments
- `job`: The Amazon Resource Name (arn) of the world export job to cancel.

"""
function cancel_world_export_job(job; aws_config::AbstractAWSConfig=current_aws_config())
    return robomaker(
        "POST",
        "/cancelWorldExportJob",
        Dict{String,Any}("job" => job);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_world_export_job(
    job, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return robomaker(
        "POST",
        "/cancelWorldExportJob",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("job" => job), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_world_generation_job(job)
    cancel_world_generation_job(job, params::Dict{String,<:Any})

Cancels the specified world generator job.

# Arguments
- `job`: The Amazon Resource Name (arn) of the world generator job to cancel.

"""
function cancel_world_generation_job(
    job; aws_config::AbstractAWSConfig=current_aws_config()
)
    return robomaker(
        "POST",
        "/cancelWorldGenerationJob",
        Dict{String,Any}("job" => job);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_world_generation_job(
    job, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return robomaker(
        "POST",
        "/cancelWorldGenerationJob",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("job" => job), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_deployment_job(client_request_token, deployment_application_configs, fleet)
    create_deployment_job(client_request_token, deployment_application_configs, fleet, params::Dict{String,<:Any})

Deploys a specific version of a robot application to robots in a fleet.  This API is no
longer supported and will throw an error if used.  The robot application must have a
numbered applicationVersion for consistency reasons. To create a new version, use
CreateRobotApplicationVersion or see Creating a Robot Application Version.   After 90 days,
deployment jobs expire and will be deleted. They will no longer be accessible.

# Arguments
- `client_request_token`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request.
- `deployment_application_configs`: The deployment application configuration.
- `fleet`: The Amazon Resource Name (ARN) of the fleet to deploy.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"deploymentConfig"`: The requested deployment configuration.
- `"tags"`: A map that contains tag keys and tag values that are attached to the deployment
  job.
"""
function create_deployment_job(
    clientRequestToken,
    deploymentApplicationConfigs,
    fleet;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return robomaker(
        "POST",
        "/createDeploymentJob",
        Dict{String,Any}(
            "clientRequestToken" => clientRequestToken,
            "deploymentApplicationConfigs" => deploymentApplicationConfigs,
            "fleet" => fleet,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_deployment_job(
    clientRequestToken,
    deploymentApplicationConfigs,
    fleet,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return robomaker(
        "POST",
        "/createDeploymentJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "clientRequestToken" => clientRequestToken,
                    "deploymentApplicationConfigs" => deploymentApplicationConfigs,
                    "fleet" => fleet,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_fleet(name)
    create_fleet(name, params::Dict{String,<:Any})

Creates a fleet, a logical group of robots running the same robot application.  This API is
no longer supported and will throw an error if used.

# Arguments
- `name`: The name of the fleet.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tags"`: A map that contains tag keys and tag values that are attached to the fleet.
"""
function create_fleet(name; aws_config::AbstractAWSConfig=current_aws_config())
    return robomaker(
        "POST",
        "/createFleet",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_fleet(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return robomaker(
        "POST",
        "/createFleet",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_robot(architecture, greengrass_group_id, name)
    create_robot(architecture, greengrass_group_id, name, params::Dict{String,<:Any})

Creates a robot.  This API is no longer supported and will throw an error if used.

# Arguments
- `architecture`: The target architecture of the robot.
- `greengrass_group_id`: The Greengrass group id.
- `name`: The name for the robot.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tags"`: A map that contains tag keys and tag values that are attached to the robot.
"""
function create_robot(
    architecture,
    greengrassGroupId,
    name;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return robomaker(
        "POST",
        "/createRobot",
        Dict{String,Any}(
            "architecture" => architecture,
            "greengrassGroupId" => greengrassGroupId,
            "name" => name,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_robot(
    architecture,
    greengrassGroupId,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return robomaker(
        "POST",
        "/createRobot",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "architecture" => architecture,
                    "greengrassGroupId" => greengrassGroupId,
                    "name" => name,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_robot_application(name, robot_software_suite)
    create_robot_application(name, robot_software_suite, params::Dict{String,<:Any})

Creates a robot application.

# Arguments
- `name`: The name of the robot application.
- `robot_software_suite`: The robot software suite (ROS distribuition) used by the robot
  application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"environment"`: The object that contains that URI of the Docker image that you use for
  your robot application.
- `"sources"`: The sources of the robot application.
- `"tags"`: A map that contains tag keys and tag values that are attached to the robot
  application.
"""
function create_robot_application(
    name, robotSoftwareSuite; aws_config::AbstractAWSConfig=current_aws_config()
)
    return robomaker(
        "POST",
        "/createRobotApplication",
        Dict{String,Any}("name" => name, "robotSoftwareSuite" => robotSoftwareSuite);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_robot_application(
    name,
    robotSoftwareSuite,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return robomaker(
        "POST",
        "/createRobotApplication",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "name" => name, "robotSoftwareSuite" => robotSoftwareSuite
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_robot_application_version(application)
    create_robot_application_version(application, params::Dict{String,<:Any})

Creates a version of a robot application.

# Arguments
- `application`: The application information for the robot application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"currentRevisionId"`: The current revision id for the robot application. If you provide
  a value and it matches the latest revision ID, a new version will be created.
- `"imageDigest"`: A SHA256 identifier for the Docker image that you use for your robot
  application.
- `"s3Etags"`: The Amazon S3 identifier for the zip file bundle that you use for your robot
  application.
"""
function create_robot_application_version(
    application; aws_config::AbstractAWSConfig=current_aws_config()
)
    return robomaker(
        "POST",
        "/createRobotApplicationVersion",
        Dict{String,Any}("application" => application);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_robot_application_version(
    application,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return robomaker(
        "POST",
        "/createRobotApplicationVersion",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("application" => application), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_simulation_application(name, robot_software_suite, simulation_software_suite)
    create_simulation_application(name, robot_software_suite, simulation_software_suite, params::Dict{String,<:Any})

Creates a simulation application.

# Arguments
- `name`: The name of the simulation application.
- `robot_software_suite`: The robot software suite (ROS distribution) used by the
  simulation application.
- `simulation_software_suite`: The simulation software suite used by the simulation
  application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"environment"`: The object that contains the Docker image URI used to create your
  simulation application.
- `"renderingEngine"`: The rendering engine for the simulation application.
- `"sources"`: The sources of the simulation application.
- `"tags"`: A map that contains tag keys and tag values that are attached to the simulation
  application.
"""
function create_simulation_application(
    name,
    robotSoftwareSuite,
    simulationSoftwareSuite;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return robomaker(
        "POST",
        "/createSimulationApplication",
        Dict{String,Any}(
            "name" => name,
            "robotSoftwareSuite" => robotSoftwareSuite,
            "simulationSoftwareSuite" => simulationSoftwareSuite,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_simulation_application(
    name,
    robotSoftwareSuite,
    simulationSoftwareSuite,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return robomaker(
        "POST",
        "/createSimulationApplication",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "name" => name,
                    "robotSoftwareSuite" => robotSoftwareSuite,
                    "simulationSoftwareSuite" => simulationSoftwareSuite,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_simulation_application_version(application)
    create_simulation_application_version(application, params::Dict{String,<:Any})

Creates a simulation application with a specific revision id.

# Arguments
- `application`: The application information for the simulation application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"currentRevisionId"`: The current revision id for the simulation application. If you
  provide a value and it matches the latest revision ID, a new version will be created.
- `"imageDigest"`: The SHA256 digest used to identify the Docker image URI used to created
  the simulation application.
- `"s3Etags"`: The Amazon S3 eTag identifier for the zip file bundle that you use to create
  the simulation application.
"""
function create_simulation_application_version(
    application; aws_config::AbstractAWSConfig=current_aws_config()
)
    return robomaker(
        "POST",
        "/createSimulationApplicationVersion",
        Dict{String,Any}("application" => application);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_simulation_application_version(
    application,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return robomaker(
        "POST",
        "/createSimulationApplicationVersion",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("application" => application), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_simulation_job(iam_role, max_job_duration_in_seconds)
    create_simulation_job(iam_role, max_job_duration_in_seconds, params::Dict{String,<:Any})

Creates a simulation job.  After 90 days, simulation jobs expire and will be deleted. They
will no longer be accessible.

# Arguments
- `iam_role`: The IAM role name that allows the simulation instance to call the AWS APIs
  that are specified in its associated policies on your behalf. This is how credentials are
  passed in to your simulation job.
- `max_job_duration_in_seconds`: The maximum simulation job duration in seconds (up to 14
  days or 1,209,600 seconds. When maxJobDurationInSeconds is reached, the simulation job will
  status will transition to Completed.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientRequestToken"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request.
- `"compute"`: Compute information for the simulation job.
- `"dataSources"`: Specify data sources to mount read-only files from S3 into your
  simulation. These files are available under /opt/robomaker/datasources/data_source_name.
  There is a limit of 100 files and a combined size of 25GB for all DataSourceConfig objects.
  
- `"failureBehavior"`: The failure behavior the simulation job.  Continue  Leaves the
  instance running for its maximum timeout duration after a 4XX error code.  Fail  Stop the
  simulation job and terminate the instance.
- `"loggingConfig"`: The logging configuration.
- `"outputLocation"`: Location for output files generated by the simulation job.
- `"robotApplications"`: The robot application to use in the simulation job.
- `"simulationApplications"`: The simulation application to use in the simulation job.
- `"tags"`: A map that contains tag keys and tag values that are attached to the simulation
  job.
- `"vpcConfig"`: If your simulation job accesses resources in a VPC, you provide this
  parameter identifying the list of security group IDs and subnet IDs. These must belong to
  the same VPC. You must provide at least one security group and one subnet ID.
"""
function create_simulation_job(
    iamRole, maxJobDurationInSeconds; aws_config::AbstractAWSConfig=current_aws_config()
)
    return robomaker(
        "POST",
        "/createSimulationJob",
        Dict{String,Any}(
            "iamRole" => iamRole,
            "maxJobDurationInSeconds" => maxJobDurationInSeconds,
            "clientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_simulation_job(
    iamRole,
    maxJobDurationInSeconds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return robomaker(
        "POST",
        "/createSimulationJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "iamRole" => iamRole,
                    "maxJobDurationInSeconds" => maxJobDurationInSeconds,
                    "clientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_world_export_job(iam_role, output_location, worlds)
    create_world_export_job(iam_role, output_location, worlds, params::Dict{String,<:Any})

Creates a world export job.

# Arguments
- `iam_role`: The IAM role that the world export process uses to access the Amazon S3
  bucket and put the export.
- `output_location`:
- `worlds`: A list of Amazon Resource Names (arns) that correspond to worlds to export.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientRequestToken"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request.
- `"tags"`: A map that contains tag keys and tag values that are attached to the world
  export job.
"""
function create_world_export_job(
    iamRole, outputLocation, worlds; aws_config::AbstractAWSConfig=current_aws_config()
)
    return robomaker(
        "POST",
        "/createWorldExportJob",
        Dict{String,Any}(
            "iamRole" => iamRole,
            "outputLocation" => outputLocation,
            "worlds" => worlds,
            "clientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_world_export_job(
    iamRole,
    outputLocation,
    worlds,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return robomaker(
        "POST",
        "/createWorldExportJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "iamRole" => iamRole,
                    "outputLocation" => outputLocation,
                    "worlds" => worlds,
                    "clientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_world_generation_job(template, world_count)
    create_world_generation_job(template, world_count, params::Dict{String,<:Any})

Creates worlds using the specified template.

# Arguments
- `template`: The Amazon Resource Name (arn) of the world template describing the worlds
  you want to create.
- `world_count`: Information about the world count.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientRequestToken"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request.
- `"tags"`: A map that contains tag keys and tag values that are attached to the world
  generator job.
- `"worldTags"`: A map that contains tag keys and tag values that are attached to the
  generated worlds.
"""
function create_world_generation_job(
    template, worldCount; aws_config::AbstractAWSConfig=current_aws_config()
)
    return robomaker(
        "POST",
        "/createWorldGenerationJob",
        Dict{String,Any}(
            "template" => template,
            "worldCount" => worldCount,
            "clientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_world_generation_job(
    template,
    worldCount,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return robomaker(
        "POST",
        "/createWorldGenerationJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "template" => template,
                    "worldCount" => worldCount,
                    "clientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_world_template()
    create_world_template(params::Dict{String,<:Any})

Creates a world template.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientRequestToken"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request.
- `"name"`: The name of the world template.
- `"tags"`: A map that contains tag keys and tag values that are attached to the world
  template.
- `"templateBody"`: The world template body.
- `"templateLocation"`: The location of the world template.
"""
function create_world_template(; aws_config::AbstractAWSConfig=current_aws_config())
    return robomaker(
        "POST",
        "/createWorldTemplate";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_world_template(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return robomaker(
        "POST",
        "/createWorldTemplate",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_fleet(fleet)
    delete_fleet(fleet, params::Dict{String,<:Any})

Deletes a fleet.  This API will no longer be supported as of May 2, 2022. Use it to remove
resources that were created for Deployment Service.

# Arguments
- `fleet`: The Amazon Resource Name (ARN) of the fleet.

"""
function delete_fleet(fleet; aws_config::AbstractAWSConfig=current_aws_config())
    return robomaker(
        "POST",
        "/deleteFleet",
        Dict{String,Any}("fleet" => fleet);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_fleet(
    fleet, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return robomaker(
        "POST",
        "/deleteFleet",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("fleet" => fleet), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_robot(robot)
    delete_robot(robot, params::Dict{String,<:Any})

Deletes a robot.  This API will no longer be supported as of May 2, 2022. Use it to remove
resources that were created for Deployment Service.

# Arguments
- `robot`: The Amazon Resource Name (ARN) of the robot.

"""
function delete_robot(robot; aws_config::AbstractAWSConfig=current_aws_config())
    return robomaker(
        "POST",
        "/deleteRobot",
        Dict{String,Any}("robot" => robot);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_robot(
    robot, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return robomaker(
        "POST",
        "/deleteRobot",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("robot" => robot), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_robot_application(application)
    delete_robot_application(application, params::Dict{String,<:Any})

Deletes a robot application.

# Arguments
- `application`: The Amazon Resource Name (ARN) of the the robot application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"applicationVersion"`: The version of the robot application to delete.
"""
function delete_robot_application(
    application; aws_config::AbstractAWSConfig=current_aws_config()
)
    return robomaker(
        "POST",
        "/deleteRobotApplication",
        Dict{String,Any}("application" => application);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_robot_application(
    application,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return robomaker(
        "POST",
        "/deleteRobotApplication",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("application" => application), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_simulation_application(application)
    delete_simulation_application(application, params::Dict{String,<:Any})

Deletes a simulation application.

# Arguments
- `application`: The application information for the simulation application to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"applicationVersion"`: The version of the simulation application to delete.
"""
function delete_simulation_application(
    application; aws_config::AbstractAWSConfig=current_aws_config()
)
    return robomaker(
        "POST",
        "/deleteSimulationApplication",
        Dict{String,Any}("application" => application);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_simulation_application(
    application,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return robomaker(
        "POST",
        "/deleteSimulationApplication",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("application" => application), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_world_template(template)
    delete_world_template(template, params::Dict{String,<:Any})

Deletes a world template.

# Arguments
- `template`: The Amazon Resource Name (arn) of the world template you want to delete.

"""
function delete_world_template(template; aws_config::AbstractAWSConfig=current_aws_config())
    return robomaker(
        "POST",
        "/deleteWorldTemplate",
        Dict{String,Any}("template" => template);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_world_template(
    template,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return robomaker(
        "POST",
        "/deleteWorldTemplate",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("template" => template), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    deregister_robot(fleet, robot)
    deregister_robot(fleet, robot, params::Dict{String,<:Any})

Deregisters a robot.  This API will no longer be supported as of May 2, 2022. Use it to
remove resources that were created for Deployment Service.

# Arguments
- `fleet`: The Amazon Resource Name (ARN) of the fleet.
- `robot`: The Amazon Resource Name (ARN) of the robot.

"""
function deregister_robot(fleet, robot; aws_config::AbstractAWSConfig=current_aws_config())
    return robomaker(
        "POST",
        "/deregisterRobot",
        Dict{String,Any}("fleet" => fleet, "robot" => robot);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function deregister_robot(
    fleet,
    robot,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return robomaker(
        "POST",
        "/deregisterRobot",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("fleet" => fleet, "robot" => robot), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_deployment_job(job)
    describe_deployment_job(job, params::Dict{String,<:Any})

Describes a deployment job.  This API will no longer be supported as of May 2, 2022. Use it
to remove resources that were created for Deployment Service.

# Arguments
- `job`: The Amazon Resource Name (ARN) of the deployment job.

"""
function describe_deployment_job(job; aws_config::AbstractAWSConfig=current_aws_config())
    return robomaker(
        "POST",
        "/describeDeploymentJob",
        Dict{String,Any}("job" => job);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_deployment_job(
    job, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return robomaker(
        "POST",
        "/describeDeploymentJob",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("job" => job), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_fleet(fleet)
    describe_fleet(fleet, params::Dict{String,<:Any})

Describes a fleet.  This API will no longer be supported as of May 2, 2022. Use it to
remove resources that were created for Deployment Service.

# Arguments
- `fleet`: The Amazon Resource Name (ARN) of the fleet.

"""
function describe_fleet(fleet; aws_config::AbstractAWSConfig=current_aws_config())
    return robomaker(
        "POST",
        "/describeFleet",
        Dict{String,Any}("fleet" => fleet);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_fleet(
    fleet, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return robomaker(
        "POST",
        "/describeFleet",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("fleet" => fleet), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_robot(robot)
    describe_robot(robot, params::Dict{String,<:Any})

Describes a robot.  This API will no longer be supported as of May 2, 2022. Use it to
remove resources that were created for Deployment Service.

# Arguments
- `robot`: The Amazon Resource Name (ARN) of the robot to be described.

"""
function describe_robot(robot; aws_config::AbstractAWSConfig=current_aws_config())
    return robomaker(
        "POST",
        "/describeRobot",
        Dict{String,Any}("robot" => robot);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_robot(
    robot, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return robomaker(
        "POST",
        "/describeRobot",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("robot" => robot), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_robot_application(application)
    describe_robot_application(application, params::Dict{String,<:Any})

Describes a robot application.

# Arguments
- `application`: The Amazon Resource Name (ARN) of the robot application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"applicationVersion"`: The version of the robot application to describe.
"""
function describe_robot_application(
    application; aws_config::AbstractAWSConfig=current_aws_config()
)
    return robomaker(
        "POST",
        "/describeRobotApplication",
        Dict{String,Any}("application" => application);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_robot_application(
    application,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return robomaker(
        "POST",
        "/describeRobotApplication",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("application" => application), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_simulation_application(application)
    describe_simulation_application(application, params::Dict{String,<:Any})

Describes a simulation application.

# Arguments
- `application`: The application information for the simulation application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"applicationVersion"`: The version of the simulation application to describe.
"""
function describe_simulation_application(
    application; aws_config::AbstractAWSConfig=current_aws_config()
)
    return robomaker(
        "POST",
        "/describeSimulationApplication",
        Dict{String,Any}("application" => application);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_simulation_application(
    application,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return robomaker(
        "POST",
        "/describeSimulationApplication",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("application" => application), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_simulation_job(job)
    describe_simulation_job(job, params::Dict{String,<:Any})

Describes a simulation job.

# Arguments
- `job`: The Amazon Resource Name (ARN) of the simulation job to be described.

"""
function describe_simulation_job(job; aws_config::AbstractAWSConfig=current_aws_config())
    return robomaker(
        "POST",
        "/describeSimulationJob",
        Dict{String,Any}("job" => job);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_simulation_job(
    job, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return robomaker(
        "POST",
        "/describeSimulationJob",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("job" => job), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_simulation_job_batch(batch)
    describe_simulation_job_batch(batch, params::Dict{String,<:Any})

Describes a simulation job batch.

# Arguments
- `batch`: The id of the batch to describe.

"""
function describe_simulation_job_batch(
    batch; aws_config::AbstractAWSConfig=current_aws_config()
)
    return robomaker(
        "POST",
        "/describeSimulationJobBatch",
        Dict{String,Any}("batch" => batch);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_simulation_job_batch(
    batch, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return robomaker(
        "POST",
        "/describeSimulationJobBatch",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("batch" => batch), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_world(world)
    describe_world(world, params::Dict{String,<:Any})

Describes a world.

# Arguments
- `world`: The Amazon Resource Name (arn) of the world you want to describe.

"""
function describe_world(world; aws_config::AbstractAWSConfig=current_aws_config())
    return robomaker(
        "POST",
        "/describeWorld",
        Dict{String,Any}("world" => world);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_world(
    world, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return robomaker(
        "POST",
        "/describeWorld",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("world" => world), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_world_export_job(job)
    describe_world_export_job(job, params::Dict{String,<:Any})

Describes a world export job.

# Arguments
- `job`: The Amazon Resource Name (arn) of the world export job to describe.

"""
function describe_world_export_job(job; aws_config::AbstractAWSConfig=current_aws_config())
    return robomaker(
        "POST",
        "/describeWorldExportJob",
        Dict{String,Any}("job" => job);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_world_export_job(
    job, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return robomaker(
        "POST",
        "/describeWorldExportJob",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("job" => job), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_world_generation_job(job)
    describe_world_generation_job(job, params::Dict{String,<:Any})

Describes a world generation job.

# Arguments
- `job`: The Amazon Resource Name (arn) of the world generation job to describe.

"""
function describe_world_generation_job(
    job; aws_config::AbstractAWSConfig=current_aws_config()
)
    return robomaker(
        "POST",
        "/describeWorldGenerationJob",
        Dict{String,Any}("job" => job);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_world_generation_job(
    job, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return robomaker(
        "POST",
        "/describeWorldGenerationJob",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("job" => job), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_world_template(template)
    describe_world_template(template, params::Dict{String,<:Any})

Describes a world template.

# Arguments
- `template`: The Amazon Resource Name (arn) of the world template you want to describe.

"""
function describe_world_template(
    template; aws_config::AbstractAWSConfig=current_aws_config()
)
    return robomaker(
        "POST",
        "/describeWorldTemplate",
        Dict{String,Any}("template" => template);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_world_template(
    template,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return robomaker(
        "POST",
        "/describeWorldTemplate",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("template" => template), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_world_template_body()
    get_world_template_body(params::Dict{String,<:Any})

Gets the world template body.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"generationJob"`: The Amazon Resource Name (arn) of the world generator job.
- `"template"`: The Amazon Resource Name (arn) of the world template.
"""
function get_world_template_body(; aws_config::AbstractAWSConfig=current_aws_config())
    return robomaker(
        "POST",
        "/getWorldTemplateBody";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_world_template_body(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return robomaker(
        "POST",
        "/getWorldTemplateBody",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_deployment_jobs()
    list_deployment_jobs(params::Dict{String,<:Any})

Returns a list of deployment jobs for a fleet. You can optionally provide filters to
retrieve specific deployment jobs.  This API will no longer be supported as of May 2, 2022.
Use it to remove resources that were created for Deployment Service.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: Optional filters to limit results. The filter names status and fleetName are
  supported. When filtering, you must use the complete value of the filtered item. You can
  use up to three filters, but they must be for the same named item. For example, if you are
  looking for items with the status InProgress or the status Pending.
- `"maxResults"`: When this parameter is used, ListDeploymentJobs only returns maxResults
  results in a single page along with a nextToken response element. The remaining results of
  the initial request can be seen by sending another ListDeploymentJobs request with the
  returned nextToken value. This value can be between 1 and 200. If this parameter is not
  used, then ListDeploymentJobs returns up to 200 results and a nextToken value if
  applicable.
- `"nextToken"`: If the previous paginated request did not return all of the remaining
  results, the response object's nextToken parameter value is set to a token. To retrieve the
  next set of results, call ListDeploymentJobs again and assign that token to the request
  object's nextToken parameter. If there are no remaining results, the previous response
  object's NextToken parameter is set to null.
"""
function list_deployment_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return robomaker(
        "POST",
        "/listDeploymentJobs";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_deployment_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return robomaker(
        "POST",
        "/listDeploymentJobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_fleets()
    list_fleets(params::Dict{String,<:Any})

Returns a list of fleets. You can optionally provide filters to retrieve specific fleets.
This API will no longer be supported as of May 2, 2022. Use it to remove resources that
were created for Deployment Service.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: Optional filters to limit results. The filter name name is supported. When
  filtering, you must use the complete value of the filtered item. You can use up to three
  filters.
- `"maxResults"`: When this parameter is used, ListFleets only returns maxResults results
  in a single page along with a nextToken response element. The remaining results of the
  initial request can be seen by sending another ListFleets request with the returned
  nextToken value. This value can be between 1 and 200. If this parameter is not used, then
  ListFleets returns up to 200 results and a nextToken value if applicable.
- `"nextToken"`: If the previous paginated request did not return all of the remaining
  results, the response object's nextToken parameter value is set to a token. To retrieve the
  next set of results, call ListFleets again and assign that token to the request object's
  nextToken parameter. If there are no remaining results, the previous response object's
  NextToken parameter is set to null.   This token should be treated as an opaque identifier
  that is only used to retrieve the next items in a list and not for other programmatic
  purposes.
"""
function list_fleets(; aws_config::AbstractAWSConfig=current_aws_config())
    return robomaker(
        "POST", "/listFleets"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_fleets(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return robomaker(
        "POST",
        "/listFleets",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_robot_applications()
    list_robot_applications(params::Dict{String,<:Any})

Returns a list of robot application. You can optionally provide filters to retrieve
specific robot applications.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: Optional filters to limit results. The filter name name is supported. When
  filtering, you must use the complete value of the filtered item. You can use up to three
  filters.
- `"maxResults"`: When this parameter is used, ListRobotApplications only returns
  maxResults results in a single page along with a nextToken response element. The remaining
  results of the initial request can be seen by sending another ListRobotApplications request
  with the returned nextToken value. This value can be between 1 and 100. If this parameter
  is not used, then ListRobotApplications returns up to 100 results and a nextToken value if
  applicable.
- `"nextToken"`: If the previous paginated request did not return all of the remaining
  results, the response object's nextToken parameter value is set to a token. To retrieve the
  next set of results, call ListRobotApplications again and assign that token to the request
  object's nextToken parameter. If there are no remaining results, the previous response
  object's NextToken parameter is set to null.
- `"versionQualifier"`: The version qualifier of the robot application.
"""
function list_robot_applications(; aws_config::AbstractAWSConfig=current_aws_config())
    return robomaker(
        "POST",
        "/listRobotApplications";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_robot_applications(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return robomaker(
        "POST",
        "/listRobotApplications",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_robots()
    list_robots(params::Dict{String,<:Any})

Returns a list of robots. You can optionally provide filters to retrieve specific robots.
This API will no longer be supported as of May 2, 2022. Use it to remove resources that
were created for Deployment Service.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: Optional filters to limit results. The filter names status and fleetName are
  supported. When filtering, you must use the complete value of the filtered item. You can
  use up to three filters, but they must be for the same named item. For example, if you are
  looking for items with the status Registered or the status Available.
- `"maxResults"`: When this parameter is used, ListRobots only returns maxResults results
  in a single page along with a nextToken response element. The remaining results of the
  initial request can be seen by sending another ListRobots request with the returned
  nextToken value. This value can be between 1 and 200. If this parameter is not used, then
  ListRobots returns up to 200 results and a nextToken value if applicable.
- `"nextToken"`: If the previous paginated request did not return all of the remaining
  results, the response object's nextToken parameter value is set to a token. To retrieve the
  next set of results, call ListRobots again and assign that token to the request object's
  nextToken parameter. If there are no remaining results, the previous response object's
  NextToken parameter is set to null.
"""
function list_robots(; aws_config::AbstractAWSConfig=current_aws_config())
    return robomaker(
        "POST", "/listRobots"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_robots(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return robomaker(
        "POST",
        "/listRobots",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_simulation_applications()
    list_simulation_applications(params::Dict{String,<:Any})

Returns a list of simulation applications. You can optionally provide filters to retrieve
specific simulation applications.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: Optional list of filters to limit results. The filter name name is
  supported. When filtering, you must use the complete value of the filtered item. You can
  use up to three filters.
- `"maxResults"`: When this parameter is used, ListSimulationApplications only returns
  maxResults results in a single page along with a nextToken response element. The remaining
  results of the initial request can be seen by sending another ListSimulationApplications
  request with the returned nextToken value. This value can be between 1 and 100. If this
  parameter is not used, then ListSimulationApplications returns up to 100 results and a
  nextToken value if applicable.
- `"nextToken"`: If the previous paginated request did not return all of the remaining
  results, the response object's nextToken parameter value is set to a token. To retrieve the
  next set of results, call ListSimulationApplications again and assign that token to the
  request object's nextToken parameter. If there are no remaining results, the previous
  response object's NextToken parameter is set to null.
- `"versionQualifier"`: The version qualifier of the simulation application.
"""
function list_simulation_applications(; aws_config::AbstractAWSConfig=current_aws_config())
    return robomaker(
        "POST",
        "/listSimulationApplications";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_simulation_applications(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return robomaker(
        "POST",
        "/listSimulationApplications",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_simulation_job_batches()
    list_simulation_job_batches(params::Dict{String,<:Any})

Returns a list simulation job batches. You can optionally provide filters to retrieve
specific simulation batch jobs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: Optional filters to limit results.
- `"maxResults"`: When this parameter is used, ListSimulationJobBatches only returns
  maxResults results in a single page along with a nextToken response element. The remaining
  results of the initial request can be seen by sending another ListSimulationJobBatches
  request with the returned nextToken value.
- `"nextToken"`: If the previous paginated request did not return all of the remaining
  results, the response object's nextToken parameter value is set to a token. To retrieve the
  next set of results, call ListSimulationJobBatches again and assign that token to the
  request object's nextToken parameter. If there are no remaining results, the previous
  response object's NextToken parameter is set to null.
"""
function list_simulation_job_batches(; aws_config::AbstractAWSConfig=current_aws_config())
    return robomaker(
        "POST",
        "/listSimulationJobBatches";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_simulation_job_batches(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return robomaker(
        "POST",
        "/listSimulationJobBatches",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_simulation_jobs()
    list_simulation_jobs(params::Dict{String,<:Any})

Returns a list of simulation jobs. You can optionally provide filters to retrieve specific
simulation jobs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: Optional filters to limit results. The filter names status and
  simulationApplicationName and robotApplicationName are supported. When filtering, you must
  use the complete value of the filtered item. You can use up to three filters, but they must
  be for the same named item. For example, if you are looking for items with the status
  Preparing or the status Running.
- `"maxResults"`: When this parameter is used, ListSimulationJobs only returns maxResults
  results in a single page along with a nextToken response element. The remaining results of
  the initial request can be seen by sending another ListSimulationJobs request with the
  returned nextToken value. This value can be between 1 and 1000. If this parameter is not
  used, then ListSimulationJobs returns up to 1000 results and a nextToken value if
  applicable.
- `"nextToken"`: If the previous paginated request did not return all of the remaining
  results, the response object's nextToken parameter value is set to a token. To retrieve the
  next set of results, call ListSimulationJobs again and assign that token to the request
  object's nextToken parameter. If there are no remaining results, the previous response
  object's NextToken parameter is set to null.
"""
function list_simulation_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return robomaker(
        "POST",
        "/listSimulationJobs";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_simulation_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return robomaker(
        "POST",
        "/listSimulationJobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists all tags on a AWS RoboMaker resource.

# Arguments
- `resource_arn`: The AWS RoboMaker Amazon Resource Name (ARN) with tags to be listed.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return robomaker(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return robomaker(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_world_export_jobs()
    list_world_export_jobs(params::Dict{String,<:Any})

Lists world export jobs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: Optional filters to limit results. You can use generationJobId and
  templateId.
- `"maxResults"`: When this parameter is used, ListWorldExportJobs only returns maxResults
  results in a single page along with a nextToken response element. The remaining results of
  the initial request can be seen by sending another ListWorldExportJobs request with the
  returned nextToken value. This value can be between 1 and 100. If this parameter is not
  used, then ListWorldExportJobs returns up to 100 results and a nextToken value if
  applicable.
- `"nextToken"`: If the previous paginated request did not return all of the remaining
  results, the response object's nextToken parameter value is set to a token. To retrieve the
  next set of results, call ListWorldExportJobs again and assign that token to the request
  object's nextToken parameter. If there are no remaining results, the previous response
  object's NextToken parameter is set to null.
"""
function list_world_export_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return robomaker(
        "POST",
        "/listWorldExportJobs";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_world_export_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return robomaker(
        "POST",
        "/listWorldExportJobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_world_generation_jobs()
    list_world_generation_jobs(params::Dict{String,<:Any})

Lists world generator jobs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: Optional filters to limit results. You can use status and templateId.
- `"maxResults"`: When this parameter is used, ListWorldGeneratorJobs only returns
  maxResults results in a single page along with a nextToken response element. The remaining
  results of the initial request can be seen by sending another ListWorldGeneratorJobs
  request with the returned nextToken value. This value can be between 1 and 100. If this
  parameter is not used, then ListWorldGeneratorJobs returns up to 100 results and a
  nextToken value if applicable.
- `"nextToken"`: If the previous paginated request did not return all of the remaining
  results, the response object's nextToken parameter value is set to a token. To retrieve the
  next set of results, call ListWorldGenerationJobsRequest again and assign that token to the
  request object's nextToken parameter. If there are no remaining results, the previous
  response object's NextToken parameter is set to null.
"""
function list_world_generation_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return robomaker(
        "POST",
        "/listWorldGenerationJobs";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_world_generation_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return robomaker(
        "POST",
        "/listWorldGenerationJobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_world_templates()
    list_world_templates(params::Dict{String,<:Any})

Lists world templates.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: When this parameter is used, ListWorldTemplates only returns maxResults
  results in a single page along with a nextToken response element. The remaining results of
  the initial request can be seen by sending another ListWorldTemplates request with the
  returned nextToken value. This value can be between 1 and 100. If this parameter is not
  used, then ListWorldTemplates returns up to 100 results and a nextToken value if
  applicable.
- `"nextToken"`: If the previous paginated request did not return all of the remaining
  results, the response object's nextToken parameter value is set to a token. To retrieve the
  next set of results, call ListWorldTemplates again and assign that token to the request
  object's nextToken parameter. If there are no remaining results, the previous response
  object's NextToken parameter is set to null.
"""
function list_world_templates(; aws_config::AbstractAWSConfig=current_aws_config())
    return robomaker(
        "POST",
        "/listWorldTemplates";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_world_templates(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return robomaker(
        "POST",
        "/listWorldTemplates",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_worlds()
    list_worlds(params::Dict{String,<:Any})

Lists worlds.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: Optional filters to limit results. You can use status.
- `"maxResults"`: When this parameter is used, ListWorlds only returns maxResults results
  in a single page along with a nextToken response element. The remaining results of the
  initial request can be seen by sending another ListWorlds request with the returned
  nextToken value. This value can be between 1 and 100. If this parameter is not used, then
  ListWorlds returns up to 100 results and a nextToken value if applicable.
- `"nextToken"`: If the previous paginated request did not return all of the remaining
  results, the response object's nextToken parameter value is set to a token. To retrieve the
  next set of results, call ListWorlds again and assign that token to the request object's
  nextToken parameter. If there are no remaining results, the previous response object's
  NextToken parameter is set to null.
"""
function list_worlds(; aws_config::AbstractAWSConfig=current_aws_config())
    return robomaker(
        "POST", "/listWorlds"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_worlds(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return robomaker(
        "POST",
        "/listWorlds",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    register_robot(fleet, robot)
    register_robot(fleet, robot, params::Dict{String,<:Any})

Registers a robot with a fleet.  This API is no longer supported and will throw an error if
used.

# Arguments
- `fleet`: The Amazon Resource Name (ARN) of the fleet.
- `robot`: The Amazon Resource Name (ARN) of the robot.

"""
function register_robot(fleet, robot; aws_config::AbstractAWSConfig=current_aws_config())
    return robomaker(
        "POST",
        "/registerRobot",
        Dict{String,Any}("fleet" => fleet, "robot" => robot);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function register_robot(
    fleet,
    robot,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return robomaker(
        "POST",
        "/registerRobot",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("fleet" => fleet, "robot" => robot), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    restart_simulation_job(job)
    restart_simulation_job(job, params::Dict{String,<:Any})

Restarts a running simulation job.

# Arguments
- `job`: The Amazon Resource Name (ARN) of the simulation job.

"""
function restart_simulation_job(job; aws_config::AbstractAWSConfig=current_aws_config())
    return robomaker(
        "POST",
        "/restartSimulationJob",
        Dict{String,Any}("job" => job);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function restart_simulation_job(
    job, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return robomaker(
        "POST",
        "/restartSimulationJob",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("job" => job), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_simulation_job_batch(create_simulation_job_requests)
    start_simulation_job_batch(create_simulation_job_requests, params::Dict{String,<:Any})

Starts a new simulation job batch. The batch is defined using one or more
SimulationJobRequest objects.

# Arguments
- `create_simulation_job_requests`: A list of simulation job requests to create in the
  batch.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"batchPolicy"`: The batch policy.
- `"clientRequestToken"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request.
- `"tags"`: A map that contains tag keys and tag values that are attached to the deployment
  job batch.
"""
function start_simulation_job_batch(
    createSimulationJobRequests; aws_config::AbstractAWSConfig=current_aws_config()
)
    return robomaker(
        "POST",
        "/startSimulationJobBatch",
        Dict{String,Any}(
            "createSimulationJobRequests" => createSimulationJobRequests,
            "clientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_simulation_job_batch(
    createSimulationJobRequests,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return robomaker(
        "POST",
        "/startSimulationJobBatch",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "createSimulationJobRequests" => createSimulationJobRequests,
                    "clientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    sync_deployment_job(client_request_token, fleet)
    sync_deployment_job(client_request_token, fleet, params::Dict{String,<:Any})

Syncrhonizes robots in a fleet to the latest deployment. This is helpful if robots were
added after a deployment.  This API will no longer be supported as of May 2, 2022. Use it
to remove resources that were created for Deployment Service.

# Arguments
- `client_request_token`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request.
- `fleet`: The target fleet for the synchronization.

"""
function sync_deployment_job(
    clientRequestToken, fleet; aws_config::AbstractAWSConfig=current_aws_config()
)
    return robomaker(
        "POST",
        "/syncDeploymentJob",
        Dict{String,Any}("clientRequestToken" => clientRequestToken, "fleet" => fleet);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function sync_deployment_job(
    clientRequestToken,
    fleet,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return robomaker(
        "POST",
        "/syncDeploymentJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "clientRequestToken" => clientRequestToken, "fleet" => fleet
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds or edits tags for a AWS RoboMaker resource. Each tag consists of a tag key and a tag
value. Tag keys and tag values are both required, but tag values can be empty strings.  For
information about the rules that apply to tag keys and tag values, see User-Defined Tag
Restrictions in the AWS Billing and Cost Management User Guide.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the AWS RoboMaker resource you are
  tagging.
- `tags`: A map that contains tag keys and tag values that are attached to the resource.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return robomaker(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return robomaker(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes the specified tags from the specified AWS RoboMaker resource. To remove a tag,
specify the tag key. To change the tag value of an existing tag key, use  TagResource .

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the AWS RoboMaker resource you are
  removing tags.
- `tag_keys`: A map that contains tag keys and tag values that will be unattached from the
  resource.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return robomaker(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return robomaker(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_robot_application(application, robot_software_suite)
    update_robot_application(application, robot_software_suite, params::Dict{String,<:Any})

Updates a robot application.

# Arguments
- `application`: The application information for the robot application.
- `robot_software_suite`: The robot software suite (ROS distribution) used by the robot
  application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"currentRevisionId"`: The revision id for the robot application.
- `"environment"`: The object that contains the Docker image URI for your robot application.
- `"sources"`: The sources of the robot application.
"""
function update_robot_application(
    application, robotSoftwareSuite; aws_config::AbstractAWSConfig=current_aws_config()
)
    return robomaker(
        "POST",
        "/updateRobotApplication",
        Dict{String,Any}(
            "application" => application, "robotSoftwareSuite" => robotSoftwareSuite
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_robot_application(
    application,
    robotSoftwareSuite,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return robomaker(
        "POST",
        "/updateRobotApplication",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "application" => application, "robotSoftwareSuite" => robotSoftwareSuite
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_simulation_application(application, robot_software_suite, simulation_software_suite)
    update_simulation_application(application, robot_software_suite, simulation_software_suite, params::Dict{String,<:Any})

Updates a simulation application.

# Arguments
- `application`: The application information for the simulation application.
- `robot_software_suite`: Information about the robot software suite (ROS distribution).
- `simulation_software_suite`: The simulation software suite used by the simulation
  application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"currentRevisionId"`: The revision id for the robot application.
- `"environment"`: The object that contains the Docker image URI for your simulation
  application.
- `"renderingEngine"`: The rendering engine for the simulation application.
- `"sources"`: The sources of the simulation application.
"""
function update_simulation_application(
    application,
    robotSoftwareSuite,
    simulationSoftwareSuite;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return robomaker(
        "POST",
        "/updateSimulationApplication",
        Dict{String,Any}(
            "application" => application,
            "robotSoftwareSuite" => robotSoftwareSuite,
            "simulationSoftwareSuite" => simulationSoftwareSuite,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_simulation_application(
    application,
    robotSoftwareSuite,
    simulationSoftwareSuite,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return robomaker(
        "POST",
        "/updateSimulationApplication",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "application" => application,
                    "robotSoftwareSuite" => robotSoftwareSuite,
                    "simulationSoftwareSuite" => simulationSoftwareSuite,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_world_template(template)
    update_world_template(template, params::Dict{String,<:Any})

Updates a world template.

# Arguments
- `template`: The Amazon Resource Name (arn) of the world template to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"name"`: The name of the template.
- `"templateBody"`: The world template body.
- `"templateLocation"`: The location of the world template.
"""
function update_world_template(template; aws_config::AbstractAWSConfig=current_aws_config())
    return robomaker(
        "POST",
        "/updateWorldTemplate",
        Dict{String,Any}("template" => template);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_world_template(
    template,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return robomaker(
        "POST",
        "/updateWorldTemplate",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("template" => template), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: migration_hub_refactor_spaces
using AWS.Compat
using AWS.UUIDs

"""
    create_application(environment_identifier, name, proxy_type, vpc_id)
    create_application(environment_identifier, name, proxy_type, vpc_id, params::Dict{String,<:Any})

Creates an Amazon Web Services Migration Hub Refactor Spaces application. The account that
owns the environment also owns the applications created inside the environment, regardless
of the account that creates the application. Refactor Spaces provisions an Amazon API
Gateway, API Gateway VPC link, and Network Load Balancer for the application proxy inside
your account. In environments created with a CreateEnvironment:NetworkFabricType of NONE
you need to configure  VPC to VPC connectivity between your service VPC and the application
proxy VPC to route traffic through the application proxy to a service with a private URL
endpoint. For more information, see  Create an application in the Refactor Spaces User
Guide.

# Arguments
- `environment_identifier`: The unique identifier of the environment.
- `name`: The name to use for the application.
- `proxy_type`: The proxy type of the proxy created within the application.
- `vpc_id`: The ID of the virtual private cloud (VPC).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ApiGatewayProxy"`: A wrapper object holding the API Gateway endpoint type and stage
  name for the proxy.
- `"ClientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request.
- `"Tags"`: The tags to assign to the application. A tag is a label that you assign to an
  Amazon Web Services resource. Each tag consists of a key-value pair.
"""
function create_application(
    EnvironmentIdentifier,
    Name,
    ProxyType,
    VpcId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migration_hub_refactor_spaces(
        "POST",
        "/environments/$(EnvironmentIdentifier)/applications",
        Dict{String,Any}(
            "Name" => Name,
            "ProxyType" => ProxyType,
            "VpcId" => VpcId,
            "ClientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_application(
    EnvironmentIdentifier,
    Name,
    ProxyType,
    VpcId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migration_hub_refactor_spaces(
        "POST",
        "/environments/$(EnvironmentIdentifier)/applications",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Name" => Name,
                    "ProxyType" => ProxyType,
                    "VpcId" => VpcId,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_environment(name, network_fabric_type)
    create_environment(name, network_fabric_type, params::Dict{String,<:Any})

Creates an Amazon Web Services Migration Hub Refactor Spaces environment. The caller owns
the environment resource, and all Refactor Spaces applications, services, and routes
created within the environment. They are referred to as the environment owner. The
environment owner has cross-account visibility and control of Refactor Spaces resources
that are added to the environment by other accounts that the environment is shared with.
When creating an environment with a CreateEnvironment:NetworkFabricType of TRANSIT_GATEWAY,
Refactor Spaces provisions a transit gateway to enable services in VPCs to communicate
directly across accounts. If CreateEnvironment:NetworkFabricType is NONE, Refactor Spaces
does not create a transit gateway and you must use your network infrastructure to route
traffic to services with private URL endpoints.

# Arguments
- `name`: The name of the environment.
- `network_fabric_type`: The network fabric type of the environment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request.
- `"Description"`: The description of the environment.
- `"Tags"`: The tags to assign to the environment. A tag is a label that you assign to an
  Amazon Web Services resource. Each tag consists of a key-value pair.
"""
function create_environment(
    Name, NetworkFabricType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migration_hub_refactor_spaces(
        "POST",
        "/environments",
        Dict{String,Any}(
            "Name" => Name,
            "NetworkFabricType" => NetworkFabricType,
            "ClientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_environment(
    Name,
    NetworkFabricType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migration_hub_refactor_spaces(
        "POST",
        "/environments",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Name" => Name,
                    "NetworkFabricType" => NetworkFabricType,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_route(application_identifier, environment_identifier, route_type, service_identifier)
    create_route(application_identifier, environment_identifier, route_type, service_identifier, params::Dict{String,<:Any})

Creates an Amazon Web Services Migration Hub Refactor Spaces route. The account owner of
the service resource is always the environment owner, regardless of which account creates
the route. Routes target a service in the application. If an application does not have any
routes, then the first route must be created as a DEFAULT RouteType. When created, the
default route defaults to an active state so state is not a required input. However, like
all other state values the state of the default route can be updated after creation, but
only when all other routes are also inactive. Conversely, no route can be active without
the default route also being active. When you create a route, Refactor Spaces configures
the Amazon API Gateway to send traffic to the target service as follows:    URL Endpoints
If the service has a URL endpoint, and the endpoint resolves to a private IP address,
Refactor Spaces routes traffic using the API Gateway VPC link. If a service endpoint
resolves to a public IP address, Refactor Spaces routes traffic over the public internet.
Services can have HTTP or HTTPS URL endpoints. For HTTPS URLs, publicly-signed certificates
are supported. Private Certificate Authorities (CAs) are permitted only if the CA's domain
is also publicly resolvable.  Refactor Spaces automatically resolves the public Domain Name
System (DNS) names that are set in CreateService:UrlEndpoint when you create a service. The
DNS names resolve when the DNS time-to-live (TTL) expires, or every 60 seconds for TTLs
less than 60 seconds. This periodic DNS resolution ensures that the route configuration
remains up-to-date.    One-time health check  A one-time health check is performed on the
service when either the route is updated from inactive to active, or when it is created
with an active state. If the health check fails, the route transitions the route state to
FAILED, an error code of SERVICE_ENDPOINT_HEALTH_CHECK_FAILURE is provided, and no traffic
is sent to the service. For private URLs, a target group is created on the Network Load
Balancer and the load balancer target group runs default target health checks. By default,
the health check is run against the service endpoint URL. Optionally, the health check can
be performed against a different protocol, port, and/or path using the
CreateService:UrlEndpoint parameter. All other health check settings for the load balancer
use the default values described in the Health checks for your target groups in the Elastic
Load Balancing guide. The health check is considered successful if at least one target
within the target group transitions to a healthy state.     Lambda function endpoints  If
the service has an Lambda function endpoint, then Refactor Spaces configures the Lambda
function's resource policy to allow the application's API Gateway to invoke the function.
The Lambda function state is checked. If the function is not active, the function
configuration is updated so that Lambda resources are provisioned. If the Lambda state is
Failed, then the route creation fails. For more information, see the
GetFunctionConfiguration's State response parameter in the Lambda Developer Guide. A check
is performed to determine that a Lambda function with the specified ARN exists. If it does
not exist, the health check fails. For public URLs, a connection is opened to the public
endpoint. If the URL is not reachable, the health check fails.     Environments without a
network bridge  When you create environments without a network bridge
(CreateEnvironment:NetworkFabricType is NONE) and you use your own networking
infrastructure, you need to configure VPC to VPC connectivity between your network and the
application proxy VPC. Route creation from the application proxy to service endpoints will
fail if your network is not configured to connect to the application proxy VPC. For more
information, see  Create a route in the Refactor Spaces User Guide.

# Arguments
- `application_identifier`: The ID of the application within which the route is being
  created.
- `environment_identifier`: The ID of the environment in which the route is created.
- `route_type`: The route type of the route. DEFAULT indicates that all traffic that does
  not match another route is forwarded to the default route. Applications must have a default
  route before any other routes can be created. URI_PATH indicates a route that is based on a
  URI path.
- `service_identifier`: The ID of the service in which the route is created. Traffic that
  matches this route is forwarded to this service.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request.
- `"DefaultRoute"`:  Configuration for the default route type.
- `"Tags"`: The tags to assign to the route. A tag is a label that you assign to an Amazon
  Web Services resource. Each tag consists of a key-value pair..
- `"UriPathRoute"`: The configuration for the URI path route type.
"""
function create_route(
    ApplicationIdentifier,
    EnvironmentIdentifier,
    RouteType,
    ServiceIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migration_hub_refactor_spaces(
        "POST",
        "/environments/$(EnvironmentIdentifier)/applications/$(ApplicationIdentifier)/routes",
        Dict{String,Any}(
            "RouteType" => RouteType,
            "ServiceIdentifier" => ServiceIdentifier,
            "ClientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_route(
    ApplicationIdentifier,
    EnvironmentIdentifier,
    RouteType,
    ServiceIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migration_hub_refactor_spaces(
        "POST",
        "/environments/$(EnvironmentIdentifier)/applications/$(ApplicationIdentifier)/routes",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "RouteType" => RouteType,
                    "ServiceIdentifier" => ServiceIdentifier,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_service(application_identifier, endpoint_type, environment_identifier, name)
    create_service(application_identifier, endpoint_type, environment_identifier, name, params::Dict{String,<:Any})

Creates an Amazon Web Services Migration Hub Refactor Spaces service. The account owner of
the service is always the environment owner, regardless of which account in the environment
creates the service. Services have either a URL endpoint in a virtual private cloud (VPC),
or a Lambda function endpoint.  If an Amazon Web Services resource is launched in a service
VPC, and you want it to be accessible to all of an environment’s services with VPCs and
routes, apply the RefactorSpacesSecurityGroup to the resource. Alternatively, to add more
cross-account constraints, apply your own security group.

# Arguments
- `application_identifier`: The ID of the application which the service is created.
- `endpoint_type`: The type of endpoint to use for the service. The type can be a URL in a
  VPC or an Lambda function.
- `environment_identifier`: The ID of the environment in which the service is created.
- `name`: The name of the service.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request.
- `"Description"`: The description of the service.
- `"LambdaEndpoint"`: The configuration for the Lambda endpoint type.
- `"Tags"`: The tags to assign to the service. A tag is a label that you assign to an
  Amazon Web Services resource. Each tag consists of a key-value pair..
- `"UrlEndpoint"`: The configuration for the URL endpoint type. When creating a route to a
  service, Refactor Spaces automatically resolves the address in the UrlEndpointInput object
  URL when the Domain Name System (DNS) time-to-live (TTL) expires, or every 60 seconds for
  TTLs less than 60 seconds.
- `"VpcId"`: The ID of the VPC.
"""
function create_service(
    ApplicationIdentifier,
    EndpointType,
    EnvironmentIdentifier,
    Name;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migration_hub_refactor_spaces(
        "POST",
        "/environments/$(EnvironmentIdentifier)/applications/$(ApplicationIdentifier)/services",
        Dict{String,Any}(
            "EndpointType" => EndpointType, "Name" => Name, "ClientToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_service(
    ApplicationIdentifier,
    EndpointType,
    EnvironmentIdentifier,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migration_hub_refactor_spaces(
        "POST",
        "/environments/$(EnvironmentIdentifier)/applications/$(ApplicationIdentifier)/services",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EndpointType" => EndpointType,
                    "Name" => Name,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_application(application_identifier, environment_identifier)
    delete_application(application_identifier, environment_identifier, params::Dict{String,<:Any})

Deletes an Amazon Web Services Migration Hub Refactor Spaces application. Before you can
delete an application, you must first delete any services or routes within the application.

# Arguments
- `application_identifier`: The ID of the application.
- `environment_identifier`: The ID of the environment.

"""
function delete_application(
    ApplicationIdentifier,
    EnvironmentIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migration_hub_refactor_spaces(
        "DELETE",
        "/environments/$(EnvironmentIdentifier)/applications/$(ApplicationIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_application(
    ApplicationIdentifier,
    EnvironmentIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migration_hub_refactor_spaces(
        "DELETE",
        "/environments/$(EnvironmentIdentifier)/applications/$(ApplicationIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_environment(environment_identifier)
    delete_environment(environment_identifier, params::Dict{String,<:Any})

Deletes an Amazon Web Services Migration Hub Refactor Spaces environment. Before you can
delete an environment, you must first delete any applications and services within the
environment.

# Arguments
- `environment_identifier`: The ID of the environment.

"""
function delete_environment(
    EnvironmentIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migration_hub_refactor_spaces(
        "DELETE",
        "/environments/$(EnvironmentIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_environment(
    EnvironmentIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migration_hub_refactor_spaces(
        "DELETE",
        "/environments/$(EnvironmentIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_resource_policy(identifier)
    delete_resource_policy(identifier, params::Dict{String,<:Any})

Deletes the resource policy set for the environment.

# Arguments
- `identifier`: Amazon Resource Name (ARN) of the resource associated with the policy.

"""
function delete_resource_policy(
    Identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migration_hub_refactor_spaces(
        "DELETE",
        "/resourcepolicy/$(Identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_resource_policy(
    Identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migration_hub_refactor_spaces(
        "DELETE",
        "/resourcepolicy/$(Identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_route(application_identifier, environment_identifier, route_identifier)
    delete_route(application_identifier, environment_identifier, route_identifier, params::Dict{String,<:Any})

Deletes an Amazon Web Services Migration Hub Refactor Spaces route.

# Arguments
- `application_identifier`: The ID of the application to delete the route from.
- `environment_identifier`: The ID of the environment to delete the route from.
- `route_identifier`: The ID of the route to delete.

"""
function delete_route(
    ApplicationIdentifier,
    EnvironmentIdentifier,
    RouteIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migration_hub_refactor_spaces(
        "DELETE",
        "/environments/$(EnvironmentIdentifier)/applications/$(ApplicationIdentifier)/routes/$(RouteIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_route(
    ApplicationIdentifier,
    EnvironmentIdentifier,
    RouteIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migration_hub_refactor_spaces(
        "DELETE",
        "/environments/$(EnvironmentIdentifier)/applications/$(ApplicationIdentifier)/routes/$(RouteIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_service(application_identifier, environment_identifier, service_identifier)
    delete_service(application_identifier, environment_identifier, service_identifier, params::Dict{String,<:Any})

Deletes an Amazon Web Services Migration Hub Refactor Spaces service.

# Arguments
- `application_identifier`: Deletes a Refactor Spaces service.  The
  RefactorSpacesSecurityGroup security group must be removed from all Amazon Web Services
  resources in the virtual private cloud (VPC) prior to deleting a service with a URL
  endpoint in a VPC.
- `environment_identifier`: The ID of the environment that the service is in.
- `service_identifier`: The ID of the service to delete.

"""
function delete_service(
    ApplicationIdentifier,
    EnvironmentIdentifier,
    ServiceIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migration_hub_refactor_spaces(
        "DELETE",
        "/environments/$(EnvironmentIdentifier)/applications/$(ApplicationIdentifier)/services/$(ServiceIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_service(
    ApplicationIdentifier,
    EnvironmentIdentifier,
    ServiceIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migration_hub_refactor_spaces(
        "DELETE",
        "/environments/$(EnvironmentIdentifier)/applications/$(ApplicationIdentifier)/services/$(ServiceIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_application(application_identifier, environment_identifier)
    get_application(application_identifier, environment_identifier, params::Dict{String,<:Any})

Gets an Amazon Web Services Migration Hub Refactor Spaces application.

# Arguments
- `application_identifier`: The ID of the application.
- `environment_identifier`: The ID of the environment.

"""
function get_application(
    ApplicationIdentifier,
    EnvironmentIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migration_hub_refactor_spaces(
        "GET",
        "/environments/$(EnvironmentIdentifier)/applications/$(ApplicationIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_application(
    ApplicationIdentifier,
    EnvironmentIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migration_hub_refactor_spaces(
        "GET",
        "/environments/$(EnvironmentIdentifier)/applications/$(ApplicationIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_environment(environment_identifier)
    get_environment(environment_identifier, params::Dict{String,<:Any})

Gets an Amazon Web Services Migration Hub Refactor Spaces environment.

# Arguments
- `environment_identifier`: The ID of the environment.

"""
function get_environment(
    EnvironmentIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migration_hub_refactor_spaces(
        "GET",
        "/environments/$(EnvironmentIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_environment(
    EnvironmentIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migration_hub_refactor_spaces(
        "GET",
        "/environments/$(EnvironmentIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_resource_policy(identifier)
    get_resource_policy(identifier, params::Dict{String,<:Any})

Gets the resource-based permission policy that is set for the given environment.

# Arguments
- `identifier`: The Amazon Resource Name (ARN) of the resource associated with the policy.

"""
function get_resource_policy(Identifier; aws_config::AbstractAWSConfig=current_aws_config())
    return migration_hub_refactor_spaces(
        "GET",
        "/resourcepolicy/$(Identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_resource_policy(
    Identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migration_hub_refactor_spaces(
        "GET",
        "/resourcepolicy/$(Identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_route(application_identifier, environment_identifier, route_identifier)
    get_route(application_identifier, environment_identifier, route_identifier, params::Dict{String,<:Any})

Gets an Amazon Web Services Migration Hub Refactor Spaces route.

# Arguments
- `application_identifier`: The ID of the application.
- `environment_identifier`: The ID of the environment.
- `route_identifier`: The ID of the route.

"""
function get_route(
    ApplicationIdentifier,
    EnvironmentIdentifier,
    RouteIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migration_hub_refactor_spaces(
        "GET",
        "/environments/$(EnvironmentIdentifier)/applications/$(ApplicationIdentifier)/routes/$(RouteIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_route(
    ApplicationIdentifier,
    EnvironmentIdentifier,
    RouteIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migration_hub_refactor_spaces(
        "GET",
        "/environments/$(EnvironmentIdentifier)/applications/$(ApplicationIdentifier)/routes/$(RouteIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_service(application_identifier, environment_identifier, service_identifier)
    get_service(application_identifier, environment_identifier, service_identifier, params::Dict{String,<:Any})

Gets an Amazon Web Services Migration Hub Refactor Spaces service.

# Arguments
- `application_identifier`: The ID of the application.
- `environment_identifier`: The ID of the environment.
- `service_identifier`: The ID of the service.

"""
function get_service(
    ApplicationIdentifier,
    EnvironmentIdentifier,
    ServiceIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migration_hub_refactor_spaces(
        "GET",
        "/environments/$(EnvironmentIdentifier)/applications/$(ApplicationIdentifier)/services/$(ServiceIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_service(
    ApplicationIdentifier,
    EnvironmentIdentifier,
    ServiceIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migration_hub_refactor_spaces(
        "GET",
        "/environments/$(EnvironmentIdentifier)/applications/$(ApplicationIdentifier)/services/$(ServiceIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_applications(environment_identifier)
    list_applications(environment_identifier, params::Dict{String,<:Any})

Lists all the Amazon Web Services Migration Hub Refactor Spaces applications within an
environment.

# Arguments
- `environment_identifier`: The ID of the environment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return with a single call. To retrieve
  the remaining results, make another call with the returned nextToken value.
- `"nextToken"`: The token for the next page of results.
"""
function list_applications(
    EnvironmentIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migration_hub_refactor_spaces(
        "GET",
        "/environments/$(EnvironmentIdentifier)/applications";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_applications(
    EnvironmentIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migration_hub_refactor_spaces(
        "GET",
        "/environments/$(EnvironmentIdentifier)/applications",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_environment_vpcs(environment_identifier)
    list_environment_vpcs(environment_identifier, params::Dict{String,<:Any})

Lists all Amazon Web Services Migration Hub Refactor Spaces service virtual private clouds
(VPCs) that are part of the environment.

# Arguments
- `environment_identifier`: The ID of the environment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return with a single call. To retrieve
  the remaining results, make another call with the returned nextToken value.
- `"nextToken"`: The token for the next page of results.
"""
function list_environment_vpcs(
    EnvironmentIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migration_hub_refactor_spaces(
        "GET",
        "/environments/$(EnvironmentIdentifier)/vpcs";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_environment_vpcs(
    EnvironmentIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migration_hub_refactor_spaces(
        "GET",
        "/environments/$(EnvironmentIdentifier)/vpcs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_environments()
    list_environments(params::Dict{String,<:Any})

Lists Amazon Web Services Migration Hub Refactor Spaces environments owned by a caller
account or shared with the caller account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return with a single call. To retrieve
  the remaining results, make another call with the returned nextToken value.
- `"nextToken"`: The token for the next page of results.
"""
function list_environments(; aws_config::AbstractAWSConfig=current_aws_config())
    return migration_hub_refactor_spaces(
        "GET", "/environments"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_environments(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migration_hub_refactor_spaces(
        "GET",
        "/environments",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_routes(application_identifier, environment_identifier)
    list_routes(application_identifier, environment_identifier, params::Dict{String,<:Any})

Lists all the Amazon Web Services Migration Hub Refactor Spaces routes within an
application.

# Arguments
- `application_identifier`: The ID of the application.
- `environment_identifier`: The ID of the environment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return with a single call. To retrieve
  the remaining results, make another call with the returned nextToken value.
- `"nextToken"`: The token for the next page of results.
"""
function list_routes(
    ApplicationIdentifier,
    EnvironmentIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migration_hub_refactor_spaces(
        "GET",
        "/environments/$(EnvironmentIdentifier)/applications/$(ApplicationIdentifier)/routes";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_routes(
    ApplicationIdentifier,
    EnvironmentIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migration_hub_refactor_spaces(
        "GET",
        "/environments/$(EnvironmentIdentifier)/applications/$(ApplicationIdentifier)/routes",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_services(application_identifier, environment_identifier)
    list_services(application_identifier, environment_identifier, params::Dict{String,<:Any})

Lists all the Amazon Web Services Migration Hub Refactor Spaces services within an
application.

# Arguments
- `application_identifier`: The ID of the application.
- `environment_identifier`: The ID of the environment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return with a single call. To retrieve
  the remaining results, make another call with the returned nextToken value.
- `"nextToken"`: The token for the next page of results.
"""
function list_services(
    ApplicationIdentifier,
    EnvironmentIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migration_hub_refactor_spaces(
        "GET",
        "/environments/$(EnvironmentIdentifier)/applications/$(ApplicationIdentifier)/services";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_services(
    ApplicationIdentifier,
    EnvironmentIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migration_hub_refactor_spaces(
        "GET",
        "/environments/$(EnvironmentIdentifier)/applications/$(ApplicationIdentifier)/services",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists the tags of a resource. The caller account must be the same as the resource’s
OwnerAccountId. Listing tags in other accounts is not supported.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.

"""
function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migration_hub_refactor_spaces(
        "GET",
        "/tags/$(ResourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migration_hub_refactor_spaces(
        "GET",
        "/tags/$(ResourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_resource_policy(policy, resource_arn)
    put_resource_policy(policy, resource_arn, params::Dict{String,<:Any})

Attaches a resource-based permission policy to the Amazon Web Services Migration Hub
Refactor Spaces environment. The policy must contain the same actions and condition
statements as the
arn:aws:ram::aws:permission/AWSRAMDefaultPermissionRefactorSpacesEnvironment permission in
Resource Access Manager. The policy must not contain new lines or blank lines.

# Arguments
- `policy`: A JSON-formatted string for an Amazon Web Services resource-based policy.
- `resource_arn`: The Amazon Resource Name (ARN) of the resource to which the policy is
  being attached.

"""
function put_resource_policy(
    Policy, ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migration_hub_refactor_spaces(
        "PUT",
        "/resourcepolicy",
        Dict{String,Any}("Policy" => Policy, "ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_resource_policy(
    Policy,
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migration_hub_refactor_spaces(
        "PUT",
        "/resourcepolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Policy" => Policy, "ResourceArn" => ResourceArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Removes the tags of a given resource. Tags are metadata which can be used to manage a
resource. To tag a resource, the caller account must be the same as the resource’s
OwnerAccountId. Tagging resources in other accounts is not supported.  Amazon Web Services
Migration Hub Refactor Spaces does not propagate tags to orchestrated resources, such as an
environment’s transit gateway.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.
- `tags`: The new or modified tags for the resource.

"""
function tag_resource(ResourceArn, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return migration_hub_refactor_spaces(
        "POST",
        "/tags/$(ResourceArn)",
        Dict{String,Any}("Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceArn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migration_hub_refactor_spaces(
        "POST",
        "/tags/$(ResourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Tags" => Tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Adds to or modifies the tags of the given resource. Tags are metadata which can be used to
manage a resource. To untag a resource, the caller account must be the same as the
resource’s OwnerAccountId. Untagging resources across accounts is not supported.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.
- `tag_keys`: The list of keys of the tags to be removed from the resource.

"""
function untag_resource(
    ResourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return migration_hub_refactor_spaces(
        "DELETE",
        "/tags/$(ResourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migration_hub_refactor_spaces(
        "DELETE",
        "/tags/$(ResourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_route(activation_state, application_identifier, environment_identifier, route_identifier)
    update_route(activation_state, application_identifier, environment_identifier, route_identifier, params::Dict{String,<:Any})

 Updates an Amazon Web Services Migration Hub Refactor Spaces route.

# Arguments
- `activation_state`:  If set to ACTIVE, traffic is forwarded to this route’s service
  after the route is updated.
- `application_identifier`:  The ID of the application within which the route is being
  updated.
- `environment_identifier`:  The ID of the environment in which the route is being updated.
- `route_identifier`:  The unique identifier of the route to update.

"""
function update_route(
    ActivationState,
    ApplicationIdentifier,
    EnvironmentIdentifier,
    RouteIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migration_hub_refactor_spaces(
        "PATCH",
        "/environments/$(EnvironmentIdentifier)/applications/$(ApplicationIdentifier)/routes/$(RouteIdentifier)",
        Dict{String,Any}("ActivationState" => ActivationState);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_route(
    ActivationState,
    ApplicationIdentifier,
    EnvironmentIdentifier,
    RouteIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return migration_hub_refactor_spaces(
        "PATCH",
        "/environments/$(EnvironmentIdentifier)/applications/$(ApplicationIdentifier)/routes/$(RouteIdentifier)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ActivationState" => ActivationState), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function _clean_high_level_definition(definition::String)
    # Required Julia 1.5 or higher with how triple quoted strings are dealt with.
    definition = replace(definition, " " => "")
    definition = replace(definition, "\n" => "")

    return definition
end

@testset "_get_service_files" begin
    apply(Patches._github_tree_patch) do
        service_files = _get_service_files("foobar", GitHub.OAuth2("foobar"))

        @test length(service_files) == 1
        @test service_files[1] ==
            ServiceFile("foobar", "test-2020-01-01.normal.json", "test-sha", nothing)
    end
end

@testset "_filter_latest_service_version" begin
    migration_hub_v1 = Dict("path" => "AWSMigrationHub-2017-05-31.normal.json")
    migration_hub_v2 = Dict("path" => "AWSMigrationHub-2020-01-01.normal.json")

    access_analyzer_v1 = Dict("path" => "accessanalyzer-2019-11-01.normal.json")
    access_analyzer_v2 = Dict("path" => "accessanalyzer-2020-01-01.normal.json")

    @testset "empty" begin
        @test isempty(_filter_latest_service_version([]))
    end

    @testset "single service - single version" begin
        result = _filter_latest_service_version([migration_hub_v1])
        @test result == [migration_hub_v1]
    end

    @testset "single service - multiple versions" begin
        result = _filter_latest_service_version([migration_hub_v1, migration_hub_v2])
        @test result == [migration_hub_v2]
    end

    @testset "multiple service - single version" begin
        result = _filter_latest_service_version([migration_hub_v1, access_analyzer_v1])
        @test result == [access_analyzer_v1, migration_hub_v1]
    end

    @testset "multiple services - multiple versions" begin
        result = _filter_latest_service_version([
            migration_hub_v1, migration_hub_v2, access_analyzer_v1, access_analyzer_v2
        ])
        @test result == [access_analyzer_v2, migration_hub_v2]
    end
end

@testset "_get_service_and_version" begin
    @testset "empty string" begin
        filename = ""
        @test_throws InvalidFileName _get_service_and_version(filename)
    end

    @testset "invalid filename" begin
        filename = "This is an invalid file name."
        @test_throws InvalidFileName _get_service_and_version(filename)
    end

    @testset "valid filename" begin
        filename = "AWSMigrationHub-2017-05-31.normal.json"
        service, version = _get_service_and_version(filename)

        @test service == "AWSMigrationHub"
        @test version == "2017-05-31"
    end
end

@testset "_generate_low_level_definitions" begin
    services = JSON.parsefile(joinpath(@__DIR__, "..", "resource", "services.json"))

    @testset "rest-xml" begin
        expected = "const s3 = AWS.RestXMLService(\"s3\", \"s3\", \"2006-03-01\")"
        response = _generate_low_level_definition(services["s3"])

        @test response == expected
    end

    @testset "rest-json" begin
        expected = "const glacier = AWS.RestJSONService(\"glacier\", \"glacier\", \"2012-06-01\", LittleDict(\"x-amz-glacier-version\" => \"2012-06-01\"))"
        response = _generate_low_level_definition(services["glacier"])

        @test response == expected
    end

    @testset "ec2 / query" begin
        expected = "const ec2 = AWS.QueryService(\"ec2\", \"ec2\", \"2016-11-15\")"
        response = _generate_low_level_definition(services["ec2"])

        @test response == expected
    end

    @testset "json" begin
        expected = "const budgets = AWS.JSONService(\"budgets\", \"budgets\", \"2016-10-20\", \"1.1\", \"AWSBudgetServiceGateway\")"
        response = _generate_low_level_definition(services["budgets"])

        @test response == expected
    end

    @testset "signingName matches endpointPrefix" begin
        expected = "const serviceid = AWS.RestXMLService(\"signingName\", \"signingName\", \"2021-04-09\")"
        response = _generate_low_level_definition(services["signingNameMatch"])

        @test response == expected
    end

    @testset "signingName does not match endpointPrefix" begin
        expected = "const serviceid = AWS.RestXMLService(\"signingName\", \"endpointPrefix\", \"2021-04-09\")"
        response = _generate_low_level_definition(services["signingNameNonMatch"])

        @test response == expected
    end

    @testset "invalid protocol" begin
        @test_throws ProtocolNotDefined _generate_low_level_definition(services["invalid"])
    end
end

@testset "_generate_low_level_definition" begin
    service = Dict(
        "serviceId" => "sample_service",
        "protocol" => "invalid-protocol",
        "endpointPrefix" => "endpoint",
        "apiVersion" => "api_version",
        "jsonVersion" => "json_version",
        "targetPrefix" => "target",
    )

    @testset "Invalid Protocol" begin
        @test_throws ProtocolNotDefined _generate_low_level_definition(service)
    end

    @testset "rest-xml" begin
        service["protocol"] = "rest-xml"
        expected_result = "const sample_service = AWS.RestXMLService(\"endpoint\", \"endpoint\", \"api_version\")"
        result = _generate_low_level_definition(service)

        @test result == expected_result
    end

    @testset "rest-json" begin
        service["protocol"] = "rest-json"
        expected_result = "const sample_service = AWS.RestJSONService(\"endpoint\", \"endpoint\", \"api_version\")"
        result = _generate_low_level_definition(service)

        @test result == expected_result
    end

    @testset "json" begin
        service["protocol"] = "json"
        expected_result = "const sample_service = AWS.JSONService(\"endpoint\", \"endpoint\", \"api_version\", \"json_version\", \"target\")"
        result = _generate_low_level_definition(service)

        @test result == expected_result
    end

    @testset "query" begin
        service["protocol"] = "query"
        expected_result = "const sample_service = AWS.QueryService(\"endpoint\", \"endpoint\", \"api_version\")"
        result = _generate_low_level_definition(service)

        @test result == expected_result
    end

    @testset "ec2" begin
        service["protocol"] = "ec2"
        expected_result = "const sample_service = AWS.QueryService(\"endpoint\", \"endpoint\", \"api_version\")"
        result = _generate_low_level_definition(service)

        @test result == expected_result
    end
end

@testset "_clean_documentation" begin
    documentation = "<p>To remove one or more tags, use the <a>RemoveTagsFromCertificate</a> action. \$ \\ To view all of the tags that have been applied to the certificate, use the <a>ListTagsForCertificate</a> action."
    expected_result = "To remove one or more tags, use the RemoveTagsFromCertificate action.   To view all of the tags that have been applied to the certificate, use the ListTagsForCertificate action."
    result = _clean_documentation(documentation)

    @test result == expected_result
end

@testset "_clean_uri" begin
    @testset "no parameters" begin
        uri = "/v1/configurations/"
        expected = "/v1/configurations/"

        @test _clean_uri(uri) == expected
    end

    @testset "single parameter" begin
        uri = "/v1/configurations/{parameter-one}"
        expected = "/v1/configurations/\$(parameter_one)"

        @test _clean_uri(uri) == expected
    end

    @testset "multiple parameters" begin
        uri = "/v1/configurations/{parameter_one}/{parameter_two}"
        expected = "/v1/configurations/\$(parameter_one)/\$(parameter_two)"

        @test _clean_uri(uri) == expected
    end

    @testset "hyphen not in parameter" begin
        uri = "/v1/configuration-parameters/{parameter-one}"
        expected = "/v1/configuration-parameters/\$(parameter_one)"

        @test _clean_uri(uri) == expected
    end

    @testset "remove plus signs" begin
        uri = "/v1/configuration-parameters/{parameter-one+}"
        expected = "/v1/configuration-parameters/\$(parameter_one)"

        @test _clean_uri(uri) == expected
    end
end

@testset "_format_name" begin
    @testset "single captial" begin
        function_name = "Testfunctionname"
        expected = "testfunctionname"

        @test _format_name(function_name) == expected
    end

    @testset "all capitals" begin
        function_name = "TESTFUNCTIONNAME"
        expected = "testfunctionname"

        @test _format_name(function_name) == expected
    end

    @testset "subsequent capitals" begin
        function_name = "TestFUNCTIONName"
        expected = "test_functionname"

        @test _format_name(function_name) == expected
    end

    @testset "normal" begin
        function_name = "TestFunctionName"
        expected = "test_function_name"

        @test _format_name(function_name) == expected
    end
end

@testset "_get_function_parameters" begin
    shapes = JSON.parsefile(joinpath(@__DIR__, "..", "resource", "shapes.json"))

    @testset "required params" begin
        input = "RequiredParams"

        required_params, optional_params = _get_function_parameters(input, shapes)

        @test required_params == Dict(
            "RequiredParam" =>
                LittleDict("location" => "", "documentation" => "Required param"),
        )
        @test isempty(optional_params)
    end

    @testset "optional params" begin
        input = "OptionalParams"

        required_params, optional_params = _get_function_parameters(input, shapes)

        @test isempty(required_params)
        @test optional_params == Dict(
            "OptionalParam1" =>
                Dict("documentation" => "Optional param 1", "idempotent" => false),
            "OptionalParam2" =>
                Dict("documentation" => "Optional param 2", "idempotent" => false),
        )
    end

    @testset "required and optional params" begin
        input = "RequiredAndOptionalParams"

        required_params, optional_params = _get_function_parameters(input, shapes)

        @test required_params == Dict(
            "RequiredParam1" =>
                LittleDict("location" => "", "documentation" => "Required param 1"),
            "RequiredParam2" =>
                LittleDict("location" => "", "documentation" => "Required param 2"),
        )

        @test optional_params == Dict(
            "OptionalParam" =>
                Dict("documentation" => "Optional param", "idempotent" => false),
        )
    end

    @testset "no params" begin
        input = "NoParams"

        required_params, optional_params = _get_function_parameters(input, shapes)

        @test isempty(required_params)
        @test isempty(optional_params)
    end
end

@testset "_generate_high_level_definitions" begin
    service_name = "sample_service"
    protocol = "rest-xml"
    operations = JSON.parsefile(joinpath(@__DIR__, "..", "resource", "operations.json"))
    shapes = JSON.parsefile(joinpath(@__DIR__, "..", "resource", "shapes.json"))

    expected_result = """
    \"\"\"
        sample_operation(required_param1, required_param2)
        sample_operation(required_param1, required_param2, params::Dict{String,<:Any})

    The documentation for this operation.

    # Arguments
    - `required_param1`: Required param 1
    - `required_param2`: Required param 2

    # Optional Parameters
    Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
    - `"OptionalParam"`: Optional param
    \"\"\"
    sample_operation(RequiredParam1, RequiredParam2; aws_config::AbstractAWSConfig=current_aws_config()) = sample_service("POST", "/", Dict{String, Any}("RequiredParam1"=>RequiredParam1, "RequiredParam2"=>RequiredParam2); aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
    sample_operation(RequiredParam1, RequiredParam2, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()) = sample_service("POST", "/", Dict{String, Any}(mergewith(_merge, Dict{String, Any}("RequiredParam1"=>RequiredParam1, "RequiredParam2"=>RequiredParam2), params)); aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
    """

    result = _generate_high_level_definitions(service_name, protocol, operations, shapes)

    @test size(result)[1] == 1

    expected_result = _clean_high_level_definition(expected_result)
    result = _clean_high_level_definition(result[1])

    @test result == expected_result
end

@testset "_generate_high_level_definition" begin
    service_name = "service_name"
    name = "FunctionName"
    method = "GET"
    request_uri = "request_uri"
    documentation = "Documentation for $name."

    @testset "locationless and non-idempotent" begin
        required_params = Dict(
            "RequiredParam" =>
                Dict("location" => "", "documentation" => "This parameter is required."),
        )
        optional_params = Dict(
            "OptionalParam" => Dict(
                "idempotent" => false, "documentation" => "This parameter is optional."
            ),
        )

        @testset "rest protocol" begin
            protocol = "rest-xml"
            expected_result = """
            \"\"\"
                function_name(required_param)
                function_name(required_param, params::Dict{String,<:Any})

            Documentation for FunctionName.

            # Arguments
            - `required_param`: This parameter is required.

            # Optional Parameters
            Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
            - `"OptionalParam"`: This parameter is optional.
            \"\"\"
            function_name(RequiredParam; aws_config::AbstractAWSConfig=current_aws_config()) = service_name("GET", "request_uri", Dict{String, Any}("RequiredParam"=>RequiredParam); aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
            function_name(RequiredParam, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()) = service_name("GET", "request_uri", Dict{String, Any}(mergewith(_merge, Dict{String, Any}("RequiredParam"=>RequiredParam), params)); aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
            """

            result = _generate_high_level_definition(
                service_name,
                protocol,
                name,
                method,
                request_uri,
                required_params,
                optional_params,
                documentation,
            )

            expected_result = _clean_high_level_definition(expected_result)
            result = _clean_high_level_definition(result)

            @test result == expected_result
        end

        @testset "json, query, ec2 protocol" begin
            protocol = "ec2"
            expected_result = """
            \"\"\"
                function_name(required_param)
                function_name(required_param, params::Dict{String,<:Any})

            Documentation for FunctionName.

            # Arguments
            - `required_param`: This parameter is required.

            # Optional Parameters
            Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
            - `"OptionalParam"`: This parameter is optional.
            \"\"\"
            function_name(RequiredParam; aws_config::AbstractAWSConfig=current_aws_config()) = service_name("FunctionName", Dict{String, Any}("RequiredParam"=>RequiredParam); aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
            function_name(RequiredParam, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()) = service_name("FunctionName", Dict{String, Any}(mergewith(_merge, Dict{String, Any}("RequiredParam"=>RequiredParam), params)); aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
            """

            result = _generate_high_level_definition(
                service_name,
                protocol,
                name,
                method,
                request_uri,
                required_params,
                optional_params,
                documentation,
            )

            expected_result = _clean_high_level_definition(expected_result)
            result = _clean_high_level_definition(result)

            @test result == expected_result
        end
    end

    @testset "header location and idempotent" begin
        required_params = Dict(
            "RequiredParam" => Dict(
                "location" => "header", "documentation" => "This parameter is required."
            ),
        )
        optional_params = Dict(
            "OptionalParam" => Dict(
                "idempotent" => true, "documentation" => "This parameter is optional."
            ),
        )

        @testset "rest protocol" begin
            protocol = "rest-xml"
            expected_result = """
            \"\"\"
                function_name(required_param)
                function_name(required_param, params::Dict{String,<:Any})

            Documentation for FunctionName.

            # Arguments
            - `required_param`: This parameter   is required.

            # Optional Parameters
            Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
            - `"OptionalParam"`: This parameter i  s optional.
            \"\"\"
            function_name(RequiredParam; aws_config::AbstractAWSConfig=current_aws_config()) = service_name("GET", "request_uri", Dict{String, Any}("OptionalParam"=>string(uuid4()), "headers"=>Dict{String, Any}("RequiredParam"=>RequiredParam)); aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
            function_name(RequiredParam, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()) = service_name("GET", "request_uri", Dict{String, Any}(mergewith(_merge, Dict{String, Any}("OptionalParam"=>string(uuid4()), "headers"=>Dict{String, Any}("RequiredParam"=>RequiredParam)), params)); aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
            """
            result = _generate_high_level_definition(
                service_name,
                protocol,
                name,
                method,
                request_uri,
                required_params,
                optional_params,
                documentation,
            )

            expected_result = _clean_high_level_definition(expected_result)
            result = _clean_high_level_definition(result)

            @test result == expected_result
        end

        @testset "json, query, ec2 protocol" begin
            protocol = "ec2"
            expected_result = """
            \"\"\"
                function_name(required_param)
                function_name(required_param, params::Dict{String,<:Any})

            Documentation for FunctionName.

            # Arguments
            - `required_param`: This parameter   is required.

            # Optional Parameters
            Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
            - `"OptionalParam"`: This parameter i  s optional.
            \"\"\"
            function_name(RequiredParam; aws_config::AbstractAWSConfig=current_aws_config()) = service_name("FunctionName", Dict{String, Any}("RequiredParam"=>RequiredParam, "OptionalParam"=>string(uuid4())); aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
            function_name(RequiredParam, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()) = service_name("FunctionName", Dict{String, Any}(mergewith(_merge, Dict{String, Any}("RequiredParam"=>RequiredParam, "OptionalParam"=>string(uuid4())), params)); aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
            """

            result = _generate_high_level_definition(
                service_name,
                protocol,
                name,
                method,
                request_uri,
                required_params,
                optional_params,
                documentation,
            )

            expected_result = _clean_high_level_definition(expected_result)
            result = _clean_high_level_definition(result)

            @test result == expected_result
        end
    end
end

@testset "string wrapping functionality" begin
    @testset "_validindex" begin
        str = "jμΛIα"  # μ, Λ, α have 2 codeunits.
        @test _validindex(str, 1) == 1 # j
        @test _validindex(str, 2) == 2 # μ
        @test _validindex(str, 3) == 2 # μ still
        @test _validindex(str, 4) == 4 # Λ
        @test_throws BoundsError _validindex(str, 0)
        @test_throws BoundsError _validindex(str, 10)
    end

    @testset "_splitline" begin
        str = "This is a short sentence."

        @testset "limit < 1" begin
            @test_throws DomainError _splitline(str, 0)
            @test_throws DomainError _splitline(str, -1)
        end

        @testset "limit == 1" begin
            result = _splitline(str, 1)
            @test result isa Tuple{String,String}
            line1, line2 = result
            @test line1 == string(first(str)) == "T"
            @test line2 == str[2:end] == "his is a short sentence."
        end

        @testset "limit >= ncodeunits" begin
            for limit in (ncodeunits(str), ncodeunits(str) + 1)
                result = _splitline(str, limit)
                @test result isa Tuple{String,String}
                line1, line2 = result
                @test line1 == str
                @test line2 == ""
            end
        end

        @testset "split on whitespace when possible" begin
            abc = "Aa Bb Cc"
            @test _splitline(abc, 1) == ("A", "a Bb Cc")  # No preceding whitespace to split on
            @test _splitline(abc, 2) == ("Aa", " Bb Cc")
            @test _splitline(abc, 3) == ("Aa ", "Bb Cc")
            @test _splitline(abc, 4) == ("Aa ", "Bb Cc")  # 4 == `B`, split on preceding whitespace
            @test _splitline(abc, 5) == ("Aa ", "Bb Cc")  # 5 == 'b', split on preceding whitespace
            @test _splitline(abc, 6) == ("Aa Bb ", "Cc")
            @test _splitline(abc, ncodeunits(abc) - 1) == ("Aa Bb ", "Cc")
        end

        @testset "does not try to split mid-character" begin
            str = "jμΛIα"  # 'μ' starts at str[2], 'Λ' starts at str[4]
            @test _splitline(str, 2) == ("jμ", "ΛIα")
            @test _splitline(str, 3) == ("jμ", "ΛIα") # should not try to split mid-'μ'
            @test _splitline(str, 4) == ("jμΛ", "Iα")
        end

        @testset "does not split on punctuation" begin
            str = "\"arn:aws:health:us-west-1::event/EBS/AWS\""
            result = _splitline(str, ncodeunits(str) - 1)
            # don't split escaped closing quote `\"` into `\` and `"`
            @test result == ("\"arn:aws:health:us-west-1::event/EBS/AWS", "\"")
        end
    end

    @testset "_wraplines" begin
        str = "This sentence contains exactly `η = 50` codeunits"

        @testset "limit < 1" begin
            @test_throws DomainError _wraplines(str, 0)
            @test_throws DomainError _wraplines(str, -1)
        end

        @testset "limit == 1" begin
            wrapped = _wraplines(str, 1)
            @test wrapped isa String
            @test startswith(wrapped, "T\nh\ni\ns\n\ns\ne")
        end

        @testset "limit >= ncodeunits" begin
            for limit in (50, 99)
                wrapped = _wraplines(str, limit)
                @test wrapped isa String
                @test wrapped == str
            end
        end

        @testset "1 < limit < ncodeunits" begin
            @test _wraplines(str, 20) == """
                This sentence
                contains exactly
                `η = 50` codeunits"""
            @test _wraplines(str, 25) == """
                This sentence contains
                exactly `η = 50`
                codeunits"""
            @test _wraplines(str, 30) == """
                This sentence contains
                exactly `η = 50` codeunits"""
        end

        @testset "trailing whitespace is stripped" begin
            str = "16charactersthen    fourspaces "
            @test _wraplines(str, 16) == "16charactersthen\n    fourspaces"
            @test _wraplines(str, 17) == "16charactersthen\n   fourspaces"
            @test _wraplines(str, 18) == "16charactersthen\n  fourspaces"
        end

        @testset "has default `limit=92` argument" begin
            str = string(
                "Lorem ipsum dolor sit amet, consectetur adipiscing elit, ",
                "sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.",
            )
            @test _wraplines(str) == _wraplines(str, 92)
        end

        @testset "optional `delim` keyword" begin
            str = string(
                "- Lorem ipsum dolor sit amet, consectetur adipiscing elit, ",
                "sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.",
            )
            @test _wraplines(str, 50; delim="\n  ") == """
                - Lorem ipsum dolor sit amet, consectetur
                  adipiscing elit, sed do eiusmod tempor incididunt
                  ut labore et dolore magna aliqua."""
        end
    end
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: iot_wireless
using AWS.Compat
using AWS.UUIDs

"""
    associate_aws_account_with_partner_account(sidewalk)
    associate_aws_account_with_partner_account(sidewalk, params::Dict{String,<:Any})

Associates a partner account with your AWS account.

# Arguments
- `sidewalk`: The Sidewalk account credentials.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: Each resource must have a unique client request token. The client
  token is used to implement idempotency. It ensures that the request completes no more than
  one time. If you retry a request with the same token and the same parameters, the request
  will complete successfully. However, if you try to create a new resource using the same
  token but different parameters, an HTTP 409 conflict occurs. If you omit this value, AWS
  SDKs will automatically generate a unique client request. For more information about
  idempotency, see Ensuring idempotency in Amazon EC2 API requests.
- `"Tags"`: The tags to attach to the specified resource. Tags are metadata that you can
  use to manage a resource.
"""
function associate_aws_account_with_partner_account(
    Sidewalk; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "POST",
        "/partner-accounts",
        Dict{String,Any}("Sidewalk" => Sidewalk, "ClientRequestToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_aws_account_with_partner_account(
    Sidewalk,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_wireless(
        "POST",
        "/partner-accounts",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Sidewalk" => Sidewalk, "ClientRequestToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_multicast_group_with_fuota_task(id, multicast_group_id)
    associate_multicast_group_with_fuota_task(id, multicast_group_id, params::Dict{String,<:Any})

Associate a multicast group with a FUOTA task.

# Arguments
- `id`:
- `multicast_group_id`:

"""
function associate_multicast_group_with_fuota_task(
    Id, MulticastGroupId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "PUT",
        "/fuota-tasks/$(Id)/multicast-group",
        Dict{String,Any}("MulticastGroupId" => MulticastGroupId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_multicast_group_with_fuota_task(
    Id,
    MulticastGroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_wireless(
        "PUT",
        "/fuota-tasks/$(Id)/multicast-group",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("MulticastGroupId" => MulticastGroupId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_wireless_device_with_fuota_task(id, wireless_device_id)
    associate_wireless_device_with_fuota_task(id, wireless_device_id, params::Dict{String,<:Any})

Associate a wireless device with a FUOTA task.

# Arguments
- `id`:
- `wireless_device_id`:

"""
function associate_wireless_device_with_fuota_task(
    Id, WirelessDeviceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "PUT",
        "/fuota-tasks/$(Id)/wireless-device",
        Dict{String,Any}("WirelessDeviceId" => WirelessDeviceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_wireless_device_with_fuota_task(
    Id,
    WirelessDeviceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_wireless(
        "PUT",
        "/fuota-tasks/$(Id)/wireless-device",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("WirelessDeviceId" => WirelessDeviceId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_wireless_device_with_multicast_group(id, wireless_device_id)
    associate_wireless_device_with_multicast_group(id, wireless_device_id, params::Dict{String,<:Any})

Associates a wireless device with a multicast group.

# Arguments
- `id`:
- `wireless_device_id`:

"""
function associate_wireless_device_with_multicast_group(
    Id, WirelessDeviceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "PUT",
        "/multicast-groups/$(Id)/wireless-device",
        Dict{String,Any}("WirelessDeviceId" => WirelessDeviceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_wireless_device_with_multicast_group(
    Id,
    WirelessDeviceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_wireless(
        "PUT",
        "/multicast-groups/$(Id)/wireless-device",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("WirelessDeviceId" => WirelessDeviceId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_wireless_device_with_thing(id, thing_arn)
    associate_wireless_device_with_thing(id, thing_arn, params::Dict{String,<:Any})

Associates a wireless device with a thing.

# Arguments
- `id`: The ID of the resource to update.
- `thing_arn`: The ARN of the thing to associate with the wireless device.

"""
function associate_wireless_device_with_thing(
    Id, ThingArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "PUT",
        "/wireless-devices/$(Id)/thing",
        Dict{String,Any}("ThingArn" => ThingArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_wireless_device_with_thing(
    Id,
    ThingArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_wireless(
        "PUT",
        "/wireless-devices/$(Id)/thing",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ThingArn" => ThingArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_wireless_gateway_with_certificate(id, iot_certificate_id)
    associate_wireless_gateway_with_certificate(id, iot_certificate_id, params::Dict{String,<:Any})

Associates a wireless gateway with a certificate.

# Arguments
- `id`: The ID of the resource to update.
- `iot_certificate_id`: The ID of the certificate to associate with the wireless gateway.

"""
function associate_wireless_gateway_with_certificate(
    Id, IotCertificateId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "PUT",
        "/wireless-gateways/$(Id)/certificate",
        Dict{String,Any}("IotCertificateId" => IotCertificateId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_wireless_gateway_with_certificate(
    Id,
    IotCertificateId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_wireless(
        "PUT",
        "/wireless-gateways/$(Id)/certificate",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("IotCertificateId" => IotCertificateId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_wireless_gateway_with_thing(id, thing_arn)
    associate_wireless_gateway_with_thing(id, thing_arn, params::Dict{String,<:Any})

Associates a wireless gateway with a thing.

# Arguments
- `id`: The ID of the resource to update.
- `thing_arn`: The ARN of the thing to associate with the wireless gateway.

"""
function associate_wireless_gateway_with_thing(
    Id, ThingArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "PUT",
        "/wireless-gateways/$(Id)/thing",
        Dict{String,Any}("ThingArn" => ThingArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_wireless_gateway_with_thing(
    Id,
    ThingArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_wireless(
        "PUT",
        "/wireless-gateways/$(Id)/thing",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ThingArn" => ThingArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_multicast_group_session(id)
    cancel_multicast_group_session(id, params::Dict{String,<:Any})

Cancels an existing multicast group session.

# Arguments
- `id`:

"""
function cancel_multicast_group_session(
    Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "DELETE",
        "/multicast-groups/$(Id)/session";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_multicast_group_session(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "DELETE",
        "/multicast-groups/$(Id)/session",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_destination(expression, expression_type, name, role_arn)
    create_destination(expression, expression_type, name, role_arn, params::Dict{String,<:Any})

Creates a new destination that maps a device message to an AWS IoT rule.

# Arguments
- `expression`: The rule name or topic rule to send messages to.
- `expression_type`: The type of value in Expression.
- `name`: The name of the new resource.
- `role_arn`: The ARN of the IAM Role that authorizes the destination.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: Each resource must have a unique client request token. The client
  token is used to implement idempotency. It ensures that the request completes no more than
  one time. If you retry a request with the same token and the same parameters, the request
  will complete successfully. However, if you try to create a new resource using the same
  token but different parameters, an HTTP 409 conflict occurs. If you omit this value, AWS
  SDKs will automatically generate a unique client request. For more information about
  idempotency, see Ensuring idempotency in Amazon EC2 API requests.
- `"Description"`: The description of the new resource.
- `"Tags"`: The tags to attach to the new destination. Tags are metadata that you can use
  to manage a resource.
"""
function create_destination(
    Expression,
    ExpressionType,
    Name,
    RoleArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_wireless(
        "POST",
        "/destinations",
        Dict{String,Any}(
            "Expression" => Expression,
            "ExpressionType" => ExpressionType,
            "Name" => Name,
            "RoleArn" => RoleArn,
            "ClientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_destination(
    Expression,
    ExpressionType,
    Name,
    RoleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_wireless(
        "POST",
        "/destinations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Expression" => Expression,
                    "ExpressionType" => ExpressionType,
                    "Name" => Name,
                    "RoleArn" => RoleArn,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_device_profile()
    create_device_profile(params::Dict{String,<:Any})

Creates a new device profile.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: Each resource must have a unique client request token. The client
  token is used to implement idempotency. It ensures that the request completes no more than
  one time. If you retry a request with the same token and the same parameters, the request
  will complete successfully. However, if you try to create a new resource using the same
  token but different parameters, an HTTP 409 conflict occurs. If you omit this value, AWS
  SDKs will automatically generate a unique client request. For more information about
  idempotency, see Ensuring idempotency in Amazon EC2 API requests.
- `"LoRaWAN"`: The device profile information to use to create the device profile.
- `"Name"`: The name of the new resource.
- `"Sidewalk"`: The Sidewalk-related information for creating the Sidewalk device profile.
- `"Tags"`: The tags to attach to the new device profile. Tags are metadata that you can
  use to manage a resource.
"""
function create_device_profile(; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_wireless(
        "POST",
        "/device-profiles",
        Dict{String,Any}("ClientRequestToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_device_profile(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "POST",
        "/device-profiles",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ClientRequestToken" => string(uuid4())), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_fuota_task(firmware_update_image, firmware_update_role)
    create_fuota_task(firmware_update_image, firmware_update_role, params::Dict{String,<:Any})

Creates a FUOTA task.

# Arguments
- `firmware_update_image`:
- `firmware_update_role`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`:
- `"Description"`:
- `"FragmentIntervalMS"`:
- `"FragmentSizeBytes"`:
- `"LoRaWAN"`:
- `"Name"`:
- `"RedundancyPercent"`:
- `"Tags"`:
"""
function create_fuota_task(
    FirmwareUpdateImage,
    FirmwareUpdateRole;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_wireless(
        "POST",
        "/fuota-tasks",
        Dict{String,Any}(
            "FirmwareUpdateImage" => FirmwareUpdateImage,
            "FirmwareUpdateRole" => FirmwareUpdateRole,
            "ClientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_fuota_task(
    FirmwareUpdateImage,
    FirmwareUpdateRole,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_wireless(
        "POST",
        "/fuota-tasks",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "FirmwareUpdateImage" => FirmwareUpdateImage,
                    "FirmwareUpdateRole" => FirmwareUpdateRole,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_multicast_group(lo_ra_wan)
    create_multicast_group(lo_ra_wan, params::Dict{String,<:Any})

Creates a multicast group.

# Arguments
- `lo_ra_wan`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: Each resource must have a unique client request token. The client
  token is used to implement idempotency. It ensures that the request completes no more than
  one time. If you retry a request with the same token and the same parameters, the request
  will complete successfully. However, if you try to create a new resource using the same
  token but different parameters, an HTTP 409 conflict occurs. If you omit this value, AWS
  SDKs will automatically generate a unique client request. For more information about
  idempotency, see Ensuring idempotency in Amazon EC2 API requests.
- `"Description"`: The description of the multicast group.
- `"Name"`:
- `"Tags"`:
"""
function create_multicast_group(LoRaWAN; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_wireless(
        "POST",
        "/multicast-groups",
        Dict{String,Any}("LoRaWAN" => LoRaWAN, "ClientRequestToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_multicast_group(
    LoRaWAN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_wireless(
        "POST",
        "/multicast-groups",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "LoRaWAN" => LoRaWAN, "ClientRequestToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_network_analyzer_configuration(name)
    create_network_analyzer_configuration(name, params::Dict{String,<:Any})

Creates a new network analyzer configuration.

# Arguments
- `name`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`:
- `"Description"`:
- `"MulticastGroups"`: Multicast Group resources to add to the network analyzer
  configruation. Provide the MulticastGroupId of the resource to add in the input array.
- `"Tags"`:
- `"TraceContent"`:
- `"WirelessDevices"`: Wireless device resources to add to the network analyzer
  configuration. Provide the WirelessDeviceId of the resource to add in the input array.
- `"WirelessGateways"`: Wireless gateway resources to add to the network analyzer
  configuration. Provide the WirelessGatewayId of the resource to add in the input array.
"""
function create_network_analyzer_configuration(
    Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "POST",
        "/network-analyzer-configurations",
        Dict{String,Any}("Name" => Name, "ClientRequestToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_network_analyzer_configuration(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "POST",
        "/network-analyzer-configurations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Name" => Name, "ClientRequestToken" => string(uuid4())),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_service_profile()
    create_service_profile(params::Dict{String,<:Any})

Creates a new service profile.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: Each resource must have a unique client request token. The client
  token is used to implement idempotency. It ensures that the request completes no more than
  one time. If you retry a request with the same token and the same parameters, the request
  will complete successfully. However, if you try to create a new resource using the same
  token but different parameters, an HTTP 409 conflict occurs. If you omit this value, AWS
  SDKs will automatically generate a unique client request. For more information about
  idempotency, see Ensuring idempotency in Amazon EC2 API requests.
- `"LoRaWAN"`: The service profile information to use to create the service profile.
- `"Name"`: The name of the new resource.
- `"Tags"`: The tags to attach to the new service profile. Tags are metadata that you can
  use to manage a resource.
"""
function create_service_profile(; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_wireless(
        "POST",
        "/service-profiles",
        Dict{String,Any}("ClientRequestToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_service_profile(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "POST",
        "/service-profiles",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("ClientRequestToken" => string(uuid4())), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_wireless_device(destination_name, type)
    create_wireless_device(destination_name, type, params::Dict{String,<:Any})

Provisions a wireless device.

# Arguments
- `destination_name`: The name of the destination to assign to the new wireless device.
- `type`: The wireless device type.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: Each resource must have a unique client request token. The client
  token is used to implement idempotency. It ensures that the request completes no more than
  one time. If you retry a request with the same token and the same parameters, the request
  will complete successfully. However, if you try to create a new resource using the same
  token but different parameters, an HTTP 409 conflict occurs. If you omit this value, AWS
  SDKs will automatically generate a unique client request. For more information about
  idempotency, see Ensuring idempotency in Amazon EC2 API requests.
- `"Description"`: The description of the new resource.
- `"LoRaWAN"`: The device configuration information to use to create the wireless device.
- `"Name"`: The name of the new resource.
- `"Positioning"`: FPort values for the GNSS, stream, and ClockSync functions of the
  positioning information.
- `"Sidewalk"`: The device configuration information to use to create the Sidewalk device.
- `"Tags"`: The tags to attach to the new wireless device. Tags are metadata that you can
  use to manage a resource.
"""
function create_wireless_device(
    DestinationName, Type; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "POST",
        "/wireless-devices",
        Dict{String,Any}(
            "DestinationName" => DestinationName,
            "Type" => Type,
            "ClientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_wireless_device(
    DestinationName,
    Type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_wireless(
        "POST",
        "/wireless-devices",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DestinationName" => DestinationName,
                    "Type" => Type,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_wireless_gateway(lo_ra_wan)
    create_wireless_gateway(lo_ra_wan, params::Dict{String,<:Any})

Provisions a wireless gateway.  When provisioning a wireless gateway, you might run into
duplication errors for the following reasons.   If you specify a GatewayEui value that
already exists.   If you used a ClientRequestToken with the same parameters within the last
10 minutes.   To avoid this error, make sure that you use unique identifiers and parameters
for each request within the specified time period.

# Arguments
- `lo_ra_wan`: The gateway configuration information to use to create the wireless gateway.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: Each resource must have a unique client request token. The client
  token is used to implement idempotency. It ensures that the request completes no more than
  one time. If you retry a request with the same token and the same parameters, the request
  will complete successfully. However, if you try to create a new resource using the same
  token but different parameters, an HTTP 409 conflict occurs. If you omit this value, AWS
  SDKs will automatically generate a unique client request. For more information about
  idempotency, see Ensuring idempotency in Amazon EC2 API requests.
- `"Description"`: The description of the new resource.
- `"Name"`: The name of the new resource.
- `"Tags"`: The tags to attach to the new wireless gateway. Tags are metadata that you can
  use to manage a resource.
"""
function create_wireless_gateway(
    LoRaWAN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "POST",
        "/wireless-gateways",
        Dict{String,Any}("LoRaWAN" => LoRaWAN, "ClientRequestToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_wireless_gateway(
    LoRaWAN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_wireless(
        "POST",
        "/wireless-gateways",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "LoRaWAN" => LoRaWAN, "ClientRequestToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_wireless_gateway_task(id, wireless_gateway_task_definition_id)
    create_wireless_gateway_task(id, wireless_gateway_task_definition_id, params::Dict{String,<:Any})

Creates a task for a wireless gateway.

# Arguments
- `id`: The ID of the resource to update.
- `wireless_gateway_task_definition_id`: The ID of the WirelessGatewayTaskDefinition.

"""
function create_wireless_gateway_task(
    Id, WirelessGatewayTaskDefinitionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "POST",
        "/wireless-gateways/$(Id)/tasks",
        Dict{String,Any}(
            "WirelessGatewayTaskDefinitionId" => WirelessGatewayTaskDefinitionId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_wireless_gateway_task(
    Id,
    WirelessGatewayTaskDefinitionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_wireless(
        "POST",
        "/wireless-gateways/$(Id)/tasks",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "WirelessGatewayTaskDefinitionId" => WirelessGatewayTaskDefinitionId
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_wireless_gateway_task_definition(auto_create_tasks)
    create_wireless_gateway_task_definition(auto_create_tasks, params::Dict{String,<:Any})

Creates a gateway task definition.

# Arguments
- `auto_create_tasks`: Whether to automatically create tasks using this task definition for
  all gateways with the specified current version. If false, the task must me created by
  calling CreateWirelessGatewayTask.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: Each resource must have a unique client request token. The client
  token is used to implement idempotency. It ensures that the request completes no more than
  one time. If you retry a request with the same token and the same parameters, the request
  will complete successfully. However, if you try to create a new resource using the same
  token but different parameters, an HTTP 409 conflict occurs. If you omit this value, AWS
  SDKs will automatically generate a unique client request. For more information about
  idempotency, see Ensuring idempotency in Amazon EC2 API requests.
- `"Name"`: The name of the new resource.
- `"Tags"`: The tags to attach to the specified resource. Tags are metadata that you can
  use to manage a resource.
- `"Update"`: Information about the gateways to update.
"""
function create_wireless_gateway_task_definition(
    AutoCreateTasks; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "POST",
        "/wireless-gateway-task-definitions",
        Dict{String,Any}(
            "AutoCreateTasks" => AutoCreateTasks, "ClientRequestToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_wireless_gateway_task_definition(
    AutoCreateTasks,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_wireless(
        "POST",
        "/wireless-gateway-task-definitions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AutoCreateTasks" => AutoCreateTasks,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_destination(name)
    delete_destination(name, params::Dict{String,<:Any})

Deletes a destination.

# Arguments
- `name`: The name of the resource to delete.

"""
function delete_destination(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_wireless(
        "DELETE",
        "/destinations/$(Name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_destination(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "DELETE",
        "/destinations/$(Name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_device_profile(id)
    delete_device_profile(id, params::Dict{String,<:Any})

Deletes a device profile.

# Arguments
- `id`: The ID of the resource to delete.

"""
function delete_device_profile(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_wireless(
        "DELETE",
        "/device-profiles/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_device_profile(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "DELETE",
        "/device-profiles/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_fuota_task(id)
    delete_fuota_task(id, params::Dict{String,<:Any})

Deletes a FUOTA task.

# Arguments
- `id`:

"""
function delete_fuota_task(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_wireless(
        "DELETE",
        "/fuota-tasks/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_fuota_task(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "DELETE",
        "/fuota-tasks/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_multicast_group(id)
    delete_multicast_group(id, params::Dict{String,<:Any})

Deletes a multicast group if it is not in use by a fuota task.

# Arguments
- `id`:

"""
function delete_multicast_group(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_wireless(
        "DELETE",
        "/multicast-groups/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_multicast_group(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "DELETE",
        "/multicast-groups/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_network_analyzer_configuration(configuration_name)
    delete_network_analyzer_configuration(configuration_name, params::Dict{String,<:Any})

Deletes a network analyzer configuration.

# Arguments
- `configuration_name`:

"""
function delete_network_analyzer_configuration(
    ConfigurationName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "DELETE",
        "/network-analyzer-configurations/$(ConfigurationName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_network_analyzer_configuration(
    ConfigurationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_wireless(
        "DELETE",
        "/network-analyzer-configurations/$(ConfigurationName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_queued_messages(id, message_id)
    delete_queued_messages(id, message_id, params::Dict{String,<:Any})

Remove queued messages from the downlink queue.

# Arguments
- `id`: The ID of a given wireless device for which downlink messages will be deleted.
- `message_id`: If message ID is \"*\", it cleares the entire downlink queue for a given
  device, specified by the wireless device ID. Otherwise, the downlink message with the
  specified message ID will be deleted.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"WirelessDeviceType"`: The wireless device type, which can be either Sidewalk or LoRaWAN.
"""
function delete_queued_messages(
    Id, messageId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "DELETE",
        "/wireless-devices/$(Id)/data",
        Dict{String,Any}("messageId" => messageId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_queued_messages(
    Id,
    messageId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_wireless(
        "DELETE",
        "/wireless-devices/$(Id)/data",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("messageId" => messageId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_service_profile(id)
    delete_service_profile(id, params::Dict{String,<:Any})

Deletes a service profile.

# Arguments
- `id`: The ID of the resource to delete.

"""
function delete_service_profile(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_wireless(
        "DELETE",
        "/service-profiles/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_service_profile(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "DELETE",
        "/service-profiles/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_wireless_device(id)
    delete_wireless_device(id, params::Dict{String,<:Any})

Deletes a wireless device.

# Arguments
- `id`: The ID of the resource to delete.

"""
function delete_wireless_device(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_wireless(
        "DELETE",
        "/wireless-devices/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_wireless_device(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "DELETE",
        "/wireless-devices/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_wireless_device_import_task(id)
    delete_wireless_device_import_task(id, params::Dict{String,<:Any})

Delete an import task.

# Arguments
- `id`: The unique identifier of the import task to be deleted.

"""
function delete_wireless_device_import_task(
    Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "DELETE",
        "/wireless_device_import_task/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_wireless_device_import_task(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "DELETE",
        "/wireless_device_import_task/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_wireless_gateway(id)
    delete_wireless_gateway(id, params::Dict{String,<:Any})

Deletes a wireless gateway.  When deleting a wireless gateway, you might run into
duplication errors for the following reasons.   If you specify a GatewayEui value that
already exists.   If you used a ClientRequestToken with the same parameters within the last
10 minutes.   To avoid this error, make sure that you use unique identifiers and parameters
for each request within the specified time period.

# Arguments
- `id`: The ID of the resource to delete.

"""
function delete_wireless_gateway(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_wireless(
        "DELETE",
        "/wireless-gateways/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_wireless_gateway(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "DELETE",
        "/wireless-gateways/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_wireless_gateway_task(id)
    delete_wireless_gateway_task(id, params::Dict{String,<:Any})

Deletes a wireless gateway task.

# Arguments
- `id`: The ID of the resource to delete.

"""
function delete_wireless_gateway_task(
    Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "DELETE",
        "/wireless-gateways/$(Id)/tasks";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_wireless_gateway_task(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "DELETE",
        "/wireless-gateways/$(Id)/tasks",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_wireless_gateway_task_definition(id)
    delete_wireless_gateway_task_definition(id, params::Dict{String,<:Any})

Deletes a wireless gateway task definition. Deleting this task definition does not affect
tasks that are currently in progress.

# Arguments
- `id`: The ID of the resource to delete.

"""
function delete_wireless_gateway_task_definition(
    Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "DELETE",
        "/wireless-gateway-task-definitions/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_wireless_gateway_task_definition(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "DELETE",
        "/wireless-gateway-task-definitions/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    deregister_wireless_device(identifier)
    deregister_wireless_device(identifier, params::Dict{String,<:Any})

Deregister a wireless device from AWS IoT Wireless.

# Arguments
- `identifier`: The identifier of the wireless device to deregister from AWS IoT Wireless.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"WirelessDeviceType"`: The type of wireless device to deregister from AWS IoT Wireless,
  which can be LoRaWAN or Sidewalk.
"""
function deregister_wireless_device(
    Identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "PATCH",
        "/wireless-devices/$(Identifier)/deregister";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function deregister_wireless_device(
    Identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_wireless(
        "PATCH",
        "/wireless-devices/$(Identifier)/deregister",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_aws_account_from_partner_account(partner_account_id, partner_type)
    disassociate_aws_account_from_partner_account(partner_account_id, partner_type, params::Dict{String,<:Any})

Disassociates your AWS account from a partner account. If PartnerAccountId and PartnerType
are null, disassociates your AWS account from all partner accounts.

# Arguments
- `partner_account_id`: The partner account ID to disassociate from the AWS account.
- `partner_type`: The partner type.

"""
function disassociate_aws_account_from_partner_account(
    PartnerAccountId, partnerType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "DELETE",
        "/partner-accounts/$(PartnerAccountId)",
        Dict{String,Any}("partnerType" => partnerType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_aws_account_from_partner_account(
    PartnerAccountId,
    partnerType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_wireless(
        "DELETE",
        "/partner-accounts/$(PartnerAccountId)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("partnerType" => partnerType), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_multicast_group_from_fuota_task(id, multicast_group_id)
    disassociate_multicast_group_from_fuota_task(id, multicast_group_id, params::Dict{String,<:Any})

Disassociates a multicast group from a fuota task.

# Arguments
- `id`:
- `multicast_group_id`:

"""
function disassociate_multicast_group_from_fuota_task(
    Id, MulticastGroupId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "DELETE",
        "/fuota-tasks/$(Id)/multicast-groups/$(MulticastGroupId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_multicast_group_from_fuota_task(
    Id,
    MulticastGroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_wireless(
        "DELETE",
        "/fuota-tasks/$(Id)/multicast-groups/$(MulticastGroupId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_wireless_device_from_fuota_task(id, wireless_device_id)
    disassociate_wireless_device_from_fuota_task(id, wireless_device_id, params::Dict{String,<:Any})

Disassociates a wireless device from a FUOTA task.

# Arguments
- `id`:
- `wireless_device_id`:

"""
function disassociate_wireless_device_from_fuota_task(
    Id, WirelessDeviceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "DELETE",
        "/fuota-tasks/$(Id)/wireless-devices/$(WirelessDeviceId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_wireless_device_from_fuota_task(
    Id,
    WirelessDeviceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_wireless(
        "DELETE",
        "/fuota-tasks/$(Id)/wireless-devices/$(WirelessDeviceId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_wireless_device_from_multicast_group(id, wireless_device_id)
    disassociate_wireless_device_from_multicast_group(id, wireless_device_id, params::Dict{String,<:Any})

Disassociates a wireless device from a multicast group.

# Arguments
- `id`:
- `wireless_device_id`:

"""
function disassociate_wireless_device_from_multicast_group(
    Id, WirelessDeviceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "DELETE",
        "/multicast-groups/$(Id)/wireless-devices/$(WirelessDeviceId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_wireless_device_from_multicast_group(
    Id,
    WirelessDeviceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_wireless(
        "DELETE",
        "/multicast-groups/$(Id)/wireless-devices/$(WirelessDeviceId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_wireless_device_from_thing(id)
    disassociate_wireless_device_from_thing(id, params::Dict{String,<:Any})

Disassociates a wireless device from its currently associated thing.

# Arguments
- `id`: The ID of the resource to update.

"""
function disassociate_wireless_device_from_thing(
    Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "DELETE",
        "/wireless-devices/$(Id)/thing";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_wireless_device_from_thing(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "DELETE",
        "/wireless-devices/$(Id)/thing",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_wireless_gateway_from_certificate(id)
    disassociate_wireless_gateway_from_certificate(id, params::Dict{String,<:Any})

Disassociates a wireless gateway from its currently associated certificate.

# Arguments
- `id`: The ID of the resource to update.

"""
function disassociate_wireless_gateway_from_certificate(
    Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "DELETE",
        "/wireless-gateways/$(Id)/certificate";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_wireless_gateway_from_certificate(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "DELETE",
        "/wireless-gateways/$(Id)/certificate",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_wireless_gateway_from_thing(id)
    disassociate_wireless_gateway_from_thing(id, params::Dict{String,<:Any})

Disassociates a wireless gateway from its currently associated thing.

# Arguments
- `id`: The ID of the resource to update.

"""
function disassociate_wireless_gateway_from_thing(
    Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "DELETE",
        "/wireless-gateways/$(Id)/thing";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_wireless_gateway_from_thing(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "DELETE",
        "/wireless-gateways/$(Id)/thing",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_destination(name)
    get_destination(name, params::Dict{String,<:Any})

Gets information about a destination.

# Arguments
- `name`: The name of the resource to get.

"""
function get_destination(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_wireless(
        "GET",
        "/destinations/$(Name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_destination(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "GET",
        "/destinations/$(Name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_device_profile(id)
    get_device_profile(id, params::Dict{String,<:Any})

Gets information about a device profile.

# Arguments
- `id`: The ID of the resource to get.

"""
function get_device_profile(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_wireless(
        "GET",
        "/device-profiles/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_device_profile(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "GET",
        "/device-profiles/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_event_configuration_by_resource_types()
    get_event_configuration_by_resource_types(params::Dict{String,<:Any})

Get the event configuration based on resource types.

"""
function get_event_configuration_by_resource_types(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "GET",
        "/event-configurations-resource-types";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_event_configuration_by_resource_types(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "GET",
        "/event-configurations-resource-types",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_fuota_task(id)
    get_fuota_task(id, params::Dict{String,<:Any})

Gets information about a FUOTA task.

# Arguments
- `id`:

"""
function get_fuota_task(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_wireless(
        "GET", "/fuota-tasks/$(Id)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_fuota_task(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "GET",
        "/fuota-tasks/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_log_levels_by_resource_types()
    get_log_levels_by_resource_types(params::Dict{String,<:Any})

Returns current default log levels or log levels by resource types. Based on resource
types, log levels can be for wireless device log options or wireless gateway log options.

"""
function get_log_levels_by_resource_types(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "GET", "/log-levels"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_log_levels_by_resource_types(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "GET", "/log-levels", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_metric_configuration()
    get_metric_configuration(params::Dict{String,<:Any})

Get the metric configuration status for this AWS account.

"""
function get_metric_configuration(; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_wireless(
        "GET",
        "/metric-configuration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_metric_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "GET",
        "/metric-configuration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_metrics()
    get_metrics(params::Dict{String,<:Any})

Get the summary metrics for this AWS account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"SummaryMetricQueries"`: The list of queries to retrieve the summary metrics.
"""
function get_metrics(; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_wireless(
        "POST", "/metrics"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_metrics(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "POST", "/metrics", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    get_multicast_group(id)
    get_multicast_group(id, params::Dict{String,<:Any})

Gets information about a multicast group.

# Arguments
- `id`:

"""
function get_multicast_group(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_wireless(
        "GET",
        "/multicast-groups/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_multicast_group(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "GET",
        "/multicast-groups/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_multicast_group_session(id)
    get_multicast_group_session(id, params::Dict{String,<:Any})

Gets information about a multicast group session.

# Arguments
- `id`:

"""
function get_multicast_group_session(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_wireless(
        "GET",
        "/multicast-groups/$(Id)/session";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_multicast_group_session(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "GET",
        "/multicast-groups/$(Id)/session",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_network_analyzer_configuration(configuration_name)
    get_network_analyzer_configuration(configuration_name, params::Dict{String,<:Any})

Get network analyzer configuration.

# Arguments
- `configuration_name`:

"""
function get_network_analyzer_configuration(
    ConfigurationName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "GET",
        "/network-analyzer-configurations/$(ConfigurationName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_network_analyzer_configuration(
    ConfigurationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_wireless(
        "GET",
        "/network-analyzer-configurations/$(ConfigurationName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_partner_account(partner_account_id, partner_type)
    get_partner_account(partner_account_id, partner_type, params::Dict{String,<:Any})

Gets information about a partner account. If PartnerAccountId and PartnerType are null,
returns all partner accounts.

# Arguments
- `partner_account_id`: The partner account ID to disassociate from the AWS account.
- `partner_type`: The partner type.

"""
function get_partner_account(
    PartnerAccountId, partnerType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "GET",
        "/partner-accounts/$(PartnerAccountId)",
        Dict{String,Any}("partnerType" => partnerType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_partner_account(
    PartnerAccountId,
    partnerType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_wireless(
        "GET",
        "/partner-accounts/$(PartnerAccountId)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("partnerType" => partnerType), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_position(resource_identifier, resource_type)
    get_position(resource_identifier, resource_type, params::Dict{String,<:Any})

Get the position information for a given resource.  This action is no longer supported.
Calls to retrieve the position information should use the GetResourcePosition API operation
instead.

# Arguments
- `resource_identifier`: Resource identifier used to retrieve the position information.
- `resource_type`: Resource type of the resource for which position information is
  retrieved.

"""
function get_position(
    ResourceIdentifier, resourceType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "GET",
        "/positions/$(ResourceIdentifier)",
        Dict{String,Any}("resourceType" => resourceType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_position(
    ResourceIdentifier,
    resourceType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_wireless(
        "GET",
        "/positions/$(ResourceIdentifier)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceType" => resourceType), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_position_configuration(resource_identifier, resource_type)
    get_position_configuration(resource_identifier, resource_type, params::Dict{String,<:Any})

Get position configuration for a given resource.  This action is no longer supported. Calls
to retrieve the position configuration should use the GetResourcePosition API operation
instead.

# Arguments
- `resource_identifier`: Resource identifier used in a position configuration.
- `resource_type`: Resource type of the resource for which position configuration is
  retrieved.

"""
function get_position_configuration(
    ResourceIdentifier, resourceType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "GET",
        "/position-configurations/$(ResourceIdentifier)",
        Dict{String,Any}("resourceType" => resourceType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_position_configuration(
    ResourceIdentifier,
    resourceType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_wireless(
        "GET",
        "/position-configurations/$(ResourceIdentifier)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceType" => resourceType), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_position_estimate()
    get_position_estimate(params::Dict{String,<:Any})

Get estimated position information as a payload in GeoJSON format. The payload measurement
data is resolved using solvers that are provided by third-party vendors.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CellTowers"`: Retrieves an estimated device position by resolving measurement data from
  cellular radio towers. The position is resolved using HERE's cellular-based solver.
- `"Gnss"`: Retrieves an estimated device position by resolving the global navigation
  satellite system (GNSS) scan data. The position is resolved using the GNSS solver powered
  by LoRa Cloud.
- `"Ip"`: Retrieves an estimated device position by resolving the IP address information
  from the device. The position is resolved using MaxMind's IP-based solver.
- `"Timestamp"`: Optional information that specifies the time when the position information
  will be resolved. It uses the Unix timestamp format. If not specified, the time at which
  the request was received will be used.
- `"WiFiAccessPoints"`: Retrieves an estimated device position by resolving WLAN
  measurement data. The position is resolved using HERE's Wi-Fi based solver.
"""
function get_position_estimate(; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_wireless(
        "POST", "/position-estimate"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_position_estimate(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "POST",
        "/position-estimate",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_resource_event_configuration(identifier, identifier_type)
    get_resource_event_configuration(identifier, identifier_type, params::Dict{String,<:Any})

Get the event configuration for a particular resource identifier.

# Arguments
- `identifier`: Resource identifier to opt in for event messaging.
- `identifier_type`: Identifier type of the particular resource identifier for event
  configuration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"partnerType"`: Partner type of the resource if the identifier type is PartnerAccountId.
"""
function get_resource_event_configuration(
    Identifier, identifierType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "GET",
        "/event-configurations/$(Identifier)",
        Dict{String,Any}("identifierType" => identifierType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_resource_event_configuration(
    Identifier,
    identifierType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_wireless(
        "GET",
        "/event-configurations/$(Identifier)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("identifierType" => identifierType), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_resource_log_level(resource_identifier, resource_type)
    get_resource_log_level(resource_identifier, resource_type, params::Dict{String,<:Any})

Fetches the log-level override, if any, for a given resource-ID and resource-type. It can
be used for a wireless device or a wireless gateway.

# Arguments
- `resource_identifier`:
- `resource_type`: The type of the resource, which can be WirelessDevice or WirelessGateway.

"""
function get_resource_log_level(
    ResourceIdentifier, resourceType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "GET",
        "/log-levels/$(ResourceIdentifier)",
        Dict{String,Any}("resourceType" => resourceType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_resource_log_level(
    ResourceIdentifier,
    resourceType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_wireless(
        "GET",
        "/log-levels/$(ResourceIdentifier)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceType" => resourceType), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_resource_position(resource_identifier, resource_type)
    get_resource_position(resource_identifier, resource_type, params::Dict{String,<:Any})

Get the position information for a given wireless device or a wireless gateway resource.
The position information uses the  World Geodetic System (WGS84).

# Arguments
- `resource_identifier`: The identifier of the resource for which position information is
  retrieved. It can be the wireless device ID or the wireless gateway ID, depending on the
  resource type.
- `resource_type`: The type of resource for which position information is retrieved, which
  can be a wireless device or a wireless gateway.

"""
function get_resource_position(
    ResourceIdentifier, resourceType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "GET",
        "/resource-positions/$(ResourceIdentifier)",
        Dict{String,Any}("resourceType" => resourceType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_resource_position(
    ResourceIdentifier,
    resourceType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_wireless(
        "GET",
        "/resource-positions/$(ResourceIdentifier)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceType" => resourceType), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_service_endpoint()
    get_service_endpoint(params::Dict{String,<:Any})

Gets the account-specific endpoint for Configuration and Update Server (CUPS) protocol or
LoRaWAN Network Server (LNS) connections.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"serviceType"`: The service type for which to get endpoint information about. Can be
  CUPS for the Configuration and Update Server endpoint, or LNS for the LoRaWAN Network
  Server endpoint or CLAIM for the global endpoint.
"""
function get_service_endpoint(; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_wireless(
        "GET", "/service-endpoint"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_service_endpoint(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "GET",
        "/service-endpoint",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_service_profile(id)
    get_service_profile(id, params::Dict{String,<:Any})

Gets information about a service profile.

# Arguments
- `id`: The ID of the resource to get.

"""
function get_service_profile(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_wireless(
        "GET",
        "/service-profiles/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_service_profile(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "GET",
        "/service-profiles/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_wireless_device(identifier, identifier_type)
    get_wireless_device(identifier, identifier_type, params::Dict{String,<:Any})

Gets information about a wireless device.

# Arguments
- `identifier`: The identifier of the wireless device to get.
- `identifier_type`: The type of identifier used in identifier.

"""
function get_wireless_device(
    Identifier, identifierType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "GET",
        "/wireless-devices/$(Identifier)",
        Dict{String,Any}("identifierType" => identifierType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_wireless_device(
    Identifier,
    identifierType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_wireless(
        "GET",
        "/wireless-devices/$(Identifier)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("identifierType" => identifierType), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_wireless_device_import_task(id)
    get_wireless_device_import_task(id, params::Dict{String,<:Any})

Get information about an import task and count of device onboarding summary information for
the import task.

# Arguments
- `id`: The identifier of the import task for which information is requested.

"""
function get_wireless_device_import_task(
    Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "GET",
        "/wireless_device_import_task/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_wireless_device_import_task(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "GET",
        "/wireless_device_import_task/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_wireless_device_statistics(id)
    get_wireless_device_statistics(id, params::Dict{String,<:Any})

Gets operating information about a wireless device.

# Arguments
- `id`: The ID of the wireless device for which to get the data.

"""
function get_wireless_device_statistics(
    Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "GET",
        "/wireless-devices/$(Id)/statistics";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_wireless_device_statistics(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "GET",
        "/wireless-devices/$(Id)/statistics",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_wireless_gateway(identifier, identifier_type)
    get_wireless_gateway(identifier, identifier_type, params::Dict{String,<:Any})

Gets information about a wireless gateway.

# Arguments
- `identifier`: The identifier of the wireless gateway to get.
- `identifier_type`: The type of identifier used in identifier.

"""
function get_wireless_gateway(
    Identifier, identifierType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "GET",
        "/wireless-gateways/$(Identifier)",
        Dict{String,Any}("identifierType" => identifierType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_wireless_gateway(
    Identifier,
    identifierType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_wireless(
        "GET",
        "/wireless-gateways/$(Identifier)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("identifierType" => identifierType), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_wireless_gateway_certificate(id)
    get_wireless_gateway_certificate(id, params::Dict{String,<:Any})

Gets the ID of the certificate that is currently associated with a wireless gateway.

# Arguments
- `id`: The ID of the resource to get.

"""
function get_wireless_gateway_certificate(
    Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "GET",
        "/wireless-gateways/$(Id)/certificate";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_wireless_gateway_certificate(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "GET",
        "/wireless-gateways/$(Id)/certificate",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_wireless_gateway_firmware_information(id)
    get_wireless_gateway_firmware_information(id, params::Dict{String,<:Any})

Gets the firmware version and other information about a wireless gateway.

# Arguments
- `id`: The ID of the resource to get.

"""
function get_wireless_gateway_firmware_information(
    Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "GET",
        "/wireless-gateways/$(Id)/firmware-information";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_wireless_gateway_firmware_information(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "GET",
        "/wireless-gateways/$(Id)/firmware-information",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_wireless_gateway_statistics(id)
    get_wireless_gateway_statistics(id, params::Dict{String,<:Any})

Gets operating information about a wireless gateway.

# Arguments
- `id`: The ID of the wireless gateway for which to get the data.

"""
function get_wireless_gateway_statistics(
    Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "GET",
        "/wireless-gateways/$(Id)/statistics";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_wireless_gateway_statistics(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "GET",
        "/wireless-gateways/$(Id)/statistics",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_wireless_gateway_task(id)
    get_wireless_gateway_task(id, params::Dict{String,<:Any})

Gets information about a wireless gateway task.

# Arguments
- `id`: The ID of the resource to get.

"""
function get_wireless_gateway_task(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_wireless(
        "GET",
        "/wireless-gateways/$(Id)/tasks";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_wireless_gateway_task(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "GET",
        "/wireless-gateways/$(Id)/tasks",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_wireless_gateway_task_definition(id)
    get_wireless_gateway_task_definition(id, params::Dict{String,<:Any})

Gets information about a wireless gateway task definition.

# Arguments
- `id`: The ID of the resource to get.

"""
function get_wireless_gateway_task_definition(
    Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "GET",
        "/wireless-gateway-task-definitions/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_wireless_gateway_task_definition(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "GET",
        "/wireless-gateway-task-definitions/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_destinations()
    list_destinations(params::Dict{String,<:Any})

Lists the destinations registered to your AWS account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in this operation.
- `"nextToken"`: To retrieve the next set of results, the nextToken value from a previous
  response; otherwise null to receive the first set of results.
"""
function list_destinations(; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_wireless(
        "GET", "/destinations"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_destinations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "GET",
        "/destinations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_device_profiles()
    list_device_profiles(params::Dict{String,<:Any})

Lists the device profiles registered to your AWS account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"deviceProfileType"`: A filter to list only device profiles that use this type, which
  can be LoRaWAN or Sidewalk.
- `"maxResults"`: The maximum number of results to return in this operation.
- `"nextToken"`: To retrieve the next set of results, the nextToken value from a previous
  response; otherwise null to receive the first set of results.
"""
function list_device_profiles(; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_wireless(
        "GET", "/device-profiles"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_device_profiles(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "GET",
        "/device-profiles",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_devices_for_wireless_device_import_task(id)
    list_devices_for_wireless_device_import_task(id, params::Dict{String,<:Any})

List the Sidewalk devices in an import task and their onboarding status.

# Arguments
- `id`: The identifier of the import task for which wireless devices are listed.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:
- `"nextToken"`: To retrieve the next set of results, the nextToken value from a previous
  response; otherwise null to receive the first set of results.
- `"status"`: The status of the devices in the import task.
"""
function list_devices_for_wireless_device_import_task(
    id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "GET",
        "/wireless_device_import_task",
        Dict{String,Any}("id" => id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_devices_for_wireless_device_import_task(
    id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "GET",
        "/wireless_device_import_task",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("id" => id), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_event_configurations(resource_type)
    list_event_configurations(resource_type, params::Dict{String,<:Any})

List event configurations where at least one event topic has been enabled.

# Arguments
- `resource_type`: Resource type to filter event configurations.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:
- `"nextToken"`: To retrieve the next set of results, the nextToken value from a previous
  response; otherwise null to receive the first set of results.
"""
function list_event_configurations(
    resourceType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "GET",
        "/event-configurations",
        Dict{String,Any}("resourceType" => resourceType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_event_configurations(
    resourceType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_wireless(
        "GET",
        "/event-configurations",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceType" => resourceType), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_fuota_tasks()
    list_fuota_tasks(params::Dict{String,<:Any})

Lists the FUOTA tasks registered to your AWS account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:
- `"nextToken"`: To retrieve the next set of results, the nextToken value from a previous
  response; otherwise null to receive the first set of results.
"""
function list_fuota_tasks(; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_wireless(
        "GET", "/fuota-tasks"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_fuota_tasks(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "GET",
        "/fuota-tasks",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_multicast_groups()
    list_multicast_groups(params::Dict{String,<:Any})

Lists the multicast groups registered to your AWS account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:
- `"nextToken"`: To retrieve the next set of results, the nextToken value from a previous
  response; otherwise null to receive the first set of results.
"""
function list_multicast_groups(; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_wireless(
        "GET", "/multicast-groups"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_multicast_groups(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "GET",
        "/multicast-groups",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_multicast_groups_by_fuota_task(id)
    list_multicast_groups_by_fuota_task(id, params::Dict{String,<:Any})

List all multicast groups associated with a fuota task.

# Arguments
- `id`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:
- `"nextToken"`: To retrieve the next set of results, the nextToken value from a previous
  response; otherwise null to receive the first set of results.
"""
function list_multicast_groups_by_fuota_task(
    Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "GET",
        "/fuota-tasks/$(Id)/multicast-groups";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_multicast_groups_by_fuota_task(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "GET",
        "/fuota-tasks/$(Id)/multicast-groups",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_network_analyzer_configurations()
    list_network_analyzer_configurations(params::Dict{String,<:Any})

Lists the network analyzer configurations.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:
- `"nextToken"`: To retrieve the next set of results, the nextToken value from a previous
  response; otherwise null to receive the first set of results.
"""
function list_network_analyzer_configurations(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "GET",
        "/network-analyzer-configurations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_network_analyzer_configurations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "GET",
        "/network-analyzer-configurations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_partner_accounts()
    list_partner_accounts(params::Dict{String,<:Any})

Lists the partner accounts associated with your AWS account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in this operation.
- `"nextToken"`: To retrieve the next set of results, the nextToken value from a previous
  response; otherwise null to receive the first set of results.
"""
function list_partner_accounts(; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_wireless(
        "GET", "/partner-accounts"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_partner_accounts(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "GET",
        "/partner-accounts",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_position_configurations()
    list_position_configurations(params::Dict{String,<:Any})

List position configurations for a given resource, such as positioning solvers.  This
action is no longer supported. Calls to retrieve position information should use the
GetResourcePosition API operation instead.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:
- `"nextToken"`: To retrieve the next set of results, the nextToken value from a previous
  response; otherwise null to receive the first set of results.
- `"resourceType"`: Resource type for which position configurations are listed.
"""
function list_position_configurations(; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_wireless(
        "GET",
        "/position-configurations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_position_configurations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "GET",
        "/position-configurations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_queued_messages(id)
    list_queued_messages(id, params::Dict{String,<:Any})

List queued messages in the downlink queue.

# Arguments
- `id`: The ID of a given wireless device which the downlink message packets are being sent.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"WirelessDeviceType"`: The wireless device type, whic can be either Sidewalk or LoRaWAN.
- `"maxResults"`: The maximum number of results to return in this operation.
- `"nextToken"`: To retrieve the next set of results, the nextToken value from a previous
  response; otherwise null to receive the first set of results.
"""
function list_queued_messages(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_wireless(
        "GET",
        "/wireless-devices/$(Id)/data";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_queued_messages(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "GET",
        "/wireless-devices/$(Id)/data",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_service_profiles()
    list_service_profiles(params::Dict{String,<:Any})

Lists the service profiles registered to your AWS account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in this operation.
- `"nextToken"`: To retrieve the next set of results, the nextToken value from a previous
  response; otherwise null to receive the first set of results.
"""
function list_service_profiles(; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_wireless(
        "GET", "/service-profiles"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_service_profiles(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "GET",
        "/service-profiles",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists the tags (metadata) you have assigned to the resource.

# Arguments
- `resource_arn`: The ARN of the resource for which you want to list tags.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "GET",
        "/tags",
        Dict{String,Any}("resourceArn" => resourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_wireless(
        "GET",
        "/tags",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceArn" => resourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_wireless_device_import_tasks()
    list_wireless_device_import_tasks(params::Dict{String,<:Any})

List wireless devices that have been added to an import task.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:
- `"nextToken"`: To retrieve the next set of results, the nextToken value from a previous
  response; otherwise null to receive the first set of results.
"""
function list_wireless_device_import_tasks(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "GET",
        "/wireless_device_import_tasks";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_wireless_device_import_tasks(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "GET",
        "/wireless_device_import_tasks",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_wireless_devices()
    list_wireless_devices(params::Dict{String,<:Any})

Lists the wireless devices registered to your AWS account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"destinationName"`: A filter to list only the wireless devices that use this destination.
- `"deviceProfileId"`: A filter to list only the wireless devices that use this device
  profile.
- `"fuotaTaskId"`:
- `"maxResults"`: The maximum number of results to return in this operation.
- `"multicastGroupId"`:
- `"nextToken"`: To retrieve the next set of results, the nextToken value from a previous
  response; otherwise null to receive the first set of results.
- `"serviceProfileId"`: A filter to list only the wireless devices that use this service
  profile.
- `"wirelessDeviceType"`: A filter to list only the wireless devices that use this wireless
  device type.
"""
function list_wireless_devices(; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_wireless(
        "GET", "/wireless-devices"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_wireless_devices(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "GET",
        "/wireless-devices",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_wireless_gateway_task_definitions()
    list_wireless_gateway_task_definitions(params::Dict{String,<:Any})

List the wireless gateway tasks definitions registered to your AWS account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in this operation.
- `"nextToken"`: To retrieve the next set of results, the nextToken value from a previous
  response; otherwise null to receive the first set of results.
- `"taskDefinitionType"`: A filter to list only the wireless gateway task definitions that
  use this task definition type.
"""
function list_wireless_gateway_task_definitions(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "GET",
        "/wireless-gateway-task-definitions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_wireless_gateway_task_definitions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "GET",
        "/wireless-gateway-task-definitions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_wireless_gateways()
    list_wireless_gateways(params::Dict{String,<:Any})

Lists the wireless gateways registered to your AWS account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in this operation.
- `"nextToken"`: To retrieve the next set of results, the nextToken value from a previous
  response; otherwise null to receive the first set of results.
"""
function list_wireless_gateways(; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_wireless(
        "GET", "/wireless-gateways"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_wireless_gateways(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "GET",
        "/wireless-gateways",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_position_configuration(resource_identifier, resource_type)
    put_position_configuration(resource_identifier, resource_type, params::Dict{String,<:Any})

Put position configuration for a given resource.  This action is no longer supported. Calls
to update the position configuration should use the UpdateResourcePosition API operation
instead.

# Arguments
- `resource_identifier`: Resource identifier used to update the position configuration.
- `resource_type`: Resource type of the resource for which you want to update the position
  configuration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Destination"`: The position data destination that describes the AWS IoT rule that
  processes the device's position data for use by AWS IoT Core for LoRaWAN.
- `"Solvers"`: The positioning solvers used to update the position configuration of the
  resource.
"""
function put_position_configuration(
    ResourceIdentifier, resourceType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "PUT",
        "/position-configurations/$(ResourceIdentifier)",
        Dict{String,Any}("resourceType" => resourceType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_position_configuration(
    ResourceIdentifier,
    resourceType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_wireless(
        "PUT",
        "/position-configurations/$(ResourceIdentifier)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceType" => resourceType), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_resource_log_level(log_level, resource_identifier, resource_type)
    put_resource_log_level(log_level, resource_identifier, resource_type, params::Dict{String,<:Any})

Sets the log-level override for a resource-ID and resource-type. This option can be
specified for a wireless gateway or a wireless device. A limit of 200 log level override
can be set per account.

# Arguments
- `log_level`:
- `resource_identifier`:
- `resource_type`: The type of the resource, which can be WirelessDevice or WirelessGateway.

"""
function put_resource_log_level(
    LogLevel,
    ResourceIdentifier,
    resourceType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_wireless(
        "PUT",
        "/log-levels/$(ResourceIdentifier)",
        Dict{String,Any}("LogLevel" => LogLevel, "resourceType" => resourceType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_resource_log_level(
    LogLevel,
    ResourceIdentifier,
    resourceType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_wireless(
        "PUT",
        "/log-levels/$(ResourceIdentifier)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("LogLevel" => LogLevel, "resourceType" => resourceType),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    reset_all_resource_log_levels()
    reset_all_resource_log_levels(params::Dict{String,<:Any})

Removes the log-level overrides for all resources; both wireless devices and wireless
gateways.

"""
function reset_all_resource_log_levels(; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_wireless(
        "DELETE", "/log-levels"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function reset_all_resource_log_levels(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "DELETE",
        "/log-levels",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    reset_resource_log_level(resource_identifier, resource_type)
    reset_resource_log_level(resource_identifier, resource_type, params::Dict{String,<:Any})

Removes the log-level override, if any, for a specific resource-ID and resource-type. It
can be used for a wireless device or a wireless gateway.

# Arguments
- `resource_identifier`:
- `resource_type`: The type of the resource, which can be WirelessDevice or WirelessGateway.

"""
function reset_resource_log_level(
    ResourceIdentifier, resourceType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "DELETE",
        "/log-levels/$(ResourceIdentifier)",
        Dict{String,Any}("resourceType" => resourceType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function reset_resource_log_level(
    ResourceIdentifier,
    resourceType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_wireless(
        "DELETE",
        "/log-levels/$(ResourceIdentifier)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceType" => resourceType), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    send_data_to_multicast_group(id, payload_data, wireless_metadata)
    send_data_to_multicast_group(id, payload_data, wireless_metadata, params::Dict{String,<:Any})

Sends the specified data to a multicast group.

# Arguments
- `id`:
- `payload_data`:
- `wireless_metadata`:

"""
function send_data_to_multicast_group(
    Id, PayloadData, WirelessMetadata; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "POST",
        "/multicast-groups/$(Id)/data",
        Dict{String,Any}(
            "PayloadData" => PayloadData, "WirelessMetadata" => WirelessMetadata
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function send_data_to_multicast_group(
    Id,
    PayloadData,
    WirelessMetadata,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_wireless(
        "POST",
        "/multicast-groups/$(Id)/data",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "PayloadData" => PayloadData, "WirelessMetadata" => WirelessMetadata
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    send_data_to_wireless_device(id, payload_data, transmit_mode)
    send_data_to_wireless_device(id, payload_data, transmit_mode, params::Dict{String,<:Any})

Sends a decrypted application data frame to a device.

# Arguments
- `id`: The ID of the wireless device to receive the data.
- `payload_data`:
- `transmit_mode`: The transmit mode to use to send data to the wireless device. Can be: 0
  for UM (unacknowledge mode) or 1 for AM (acknowledge mode).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"WirelessMetadata"`: Metadata about the message request.
"""
function send_data_to_wireless_device(
    Id, PayloadData, TransmitMode; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "POST",
        "/wireless-devices/$(Id)/data",
        Dict{String,Any}("PayloadData" => PayloadData, "TransmitMode" => TransmitMode);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function send_data_to_wireless_device(
    Id,
    PayloadData,
    TransmitMode,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_wireless(
        "POST",
        "/wireless-devices/$(Id)/data",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "PayloadData" => PayloadData, "TransmitMode" => TransmitMode
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_bulk_associate_wireless_device_with_multicast_group(id)
    start_bulk_associate_wireless_device_with_multicast_group(id, params::Dict{String,<:Any})

Starts a bulk association of all qualifying wireless devices with a multicast group.

# Arguments
- `id`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"QueryString"`:
- `"Tags"`:
"""
function start_bulk_associate_wireless_device_with_multicast_group(
    Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "PATCH",
        "/multicast-groups/$(Id)/bulk";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_bulk_associate_wireless_device_with_multicast_group(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "PATCH",
        "/multicast-groups/$(Id)/bulk",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_bulk_disassociate_wireless_device_from_multicast_group(id)
    start_bulk_disassociate_wireless_device_from_multicast_group(id, params::Dict{String,<:Any})

Starts a bulk disassociatin of all qualifying wireless devices from a multicast group.

# Arguments
- `id`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"QueryString"`:
- `"Tags"`:
"""
function start_bulk_disassociate_wireless_device_from_multicast_group(
    Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "POST",
        "/multicast-groups/$(Id)/bulk";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_bulk_disassociate_wireless_device_from_multicast_group(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "POST",
        "/multicast-groups/$(Id)/bulk",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_fuota_task(id)
    start_fuota_task(id, params::Dict{String,<:Any})

Starts a FUOTA task.

# Arguments
- `id`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"LoRaWAN"`:
"""
function start_fuota_task(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_wireless(
        "PUT", "/fuota-tasks/$(Id)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function start_fuota_task(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "PUT",
        "/fuota-tasks/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_multicast_group_session(id, lo_ra_wan)
    start_multicast_group_session(id, lo_ra_wan, params::Dict{String,<:Any})

Starts a multicast group session.

# Arguments
- `id`:
- `lo_ra_wan`:

"""
function start_multicast_group_session(
    Id, LoRaWAN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "PUT",
        "/multicast-groups/$(Id)/session",
        Dict{String,Any}("LoRaWAN" => LoRaWAN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_multicast_group_session(
    Id,
    LoRaWAN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_wireless(
        "PUT",
        "/multicast-groups/$(Id)/session",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("LoRaWAN" => LoRaWAN), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_single_wireless_device_import_task(destination_name, sidewalk)
    start_single_wireless_device_import_task(destination_name, sidewalk, params::Dict{String,<:Any})

Start import task for a single wireless device.

# Arguments
- `destination_name`: The name of the Sidewalk destination that describes the IoT rule to
  route messages from the device in the import task that will be onboarded to AWS IoT
  Wireless.
- `sidewalk`: The Sidewalk-related parameters for importing a single wireless device.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`:
- `"DeviceName"`: The name of the wireless device for which an import task is being started.
- `"Tags"`:
"""
function start_single_wireless_device_import_task(
    DestinationName, Sidewalk; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "POST",
        "/wireless_single_device_import_task",
        Dict{String,Any}(
            "DestinationName" => DestinationName,
            "Sidewalk" => Sidewalk,
            "ClientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_single_wireless_device_import_task(
    DestinationName,
    Sidewalk,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_wireless(
        "POST",
        "/wireless_single_device_import_task",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DestinationName" => DestinationName,
                    "Sidewalk" => Sidewalk,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_wireless_device_import_task(destination_name, sidewalk)
    start_wireless_device_import_task(destination_name, sidewalk, params::Dict{String,<:Any})

Start import task for provisioning Sidewalk devices in bulk using an S3 CSV file.

# Arguments
- `destination_name`: The name of the Sidewalk destination that describes the IoT rule to
  route messages from the devices in the import task that are onboarded to AWS IoT Wireless.
- `sidewalk`: The Sidewalk-related parameters for importing wireless devices that need to
  be provisioned in bulk.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`:
- `"Tags"`:
"""
function start_wireless_device_import_task(
    DestinationName, Sidewalk; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "POST",
        "/wireless_device_import_task",
        Dict{String,Any}(
            "DestinationName" => DestinationName,
            "Sidewalk" => Sidewalk,
            "ClientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_wireless_device_import_task(
    DestinationName,
    Sidewalk,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_wireless(
        "POST",
        "/wireless_device_import_task",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DestinationName" => DestinationName,
                    "Sidewalk" => Sidewalk,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(tags, resource_arn)
    tag_resource(tags, resource_arn, params::Dict{String,<:Any})

Adds a tag to a resource.

# Arguments
- `tags`: Adds to or modifies the tags of the given resource. Tags are metadata that you
  can use to manage a resource.
- `resource_arn`: The ARN of the resource to add tags to.

"""
function tag_resource(Tags, resourceArn; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_wireless(
        "POST",
        "/tags",
        Dict{String,Any}("Tags" => Tags, "resourceArn" => resourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    Tags,
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_wireless(
        "POST",
        "/tags",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Tags" => Tags, "resourceArn" => resourceArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    test_wireless_device(id)
    test_wireless_device(id, params::Dict{String,<:Any})

Simulates a provisioned device by sending an uplink data payload of Hello.

# Arguments
- `id`: The ID of the wireless device to test.

"""
function test_wireless_device(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_wireless(
        "POST",
        "/wireless-devices/$(Id)/test";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function test_wireless_device(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "POST",
        "/wireless-devices/$(Id)/test",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes one or more tags from a resource.

# Arguments
- `resource_arn`: The ARN of the resource to remove tags from.
- `tag_keys`: A list of the keys of the tags to remove from the resource.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "DELETE",
        "/tags",
        Dict{String,Any}("resourceArn" => resourceArn, "tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_wireless(
        "DELETE",
        "/tags",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceArn" => resourceArn, "tagKeys" => tagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_destination(name)
    update_destination(name, params::Dict{String,<:Any})

Updates properties of a destination.

# Arguments
- `name`: The new name of the resource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A new description of the resource.
- `"Expression"`: The new rule name or topic rule to send messages to.
- `"ExpressionType"`: The type of value in Expression.
- `"RoleArn"`: The ARN of the IAM Role that authorizes the destination.
"""
function update_destination(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_wireless(
        "PATCH",
        "/destinations/$(Name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_destination(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "PATCH",
        "/destinations/$(Name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_event_configuration_by_resource_types()
    update_event_configuration_by_resource_types(params::Dict{String,<:Any})

Update the event configuration based on resource types.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConnectionStatus"`: Connection status resource type event configuration object for
  enabling and disabling wireless gateway topic.
- `"DeviceRegistrationState"`: Device registration state resource type event configuration
  object for enabling and disabling wireless gateway topic.
- `"Join"`: Join resource type event configuration object for enabling and disabling
  wireless device topic.
- `"MessageDeliveryStatus"`: Message delivery status resource type event configuration
  object for enabling and disabling wireless device topic.
- `"Proximity"`: Proximity resource type event configuration object for enabling and
  disabling wireless gateway topic.
"""
function update_event_configuration_by_resource_types(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "PATCH",
        "/event-configurations-resource-types";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_event_configuration_by_resource_types(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "PATCH",
        "/event-configurations-resource-types",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_fuota_task(id)
    update_fuota_task(id, params::Dict{String,<:Any})

Updates properties of a FUOTA task.

# Arguments
- `id`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`:
- `"FirmwareUpdateImage"`:
- `"FirmwareUpdateRole"`:
- `"FragmentIntervalMS"`:
- `"FragmentSizeBytes"`:
- `"LoRaWAN"`:
- `"Name"`:
- `"RedundancyPercent"`:
"""
function update_fuota_task(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_wireless(
        "PATCH",
        "/fuota-tasks/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_fuota_task(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "PATCH",
        "/fuota-tasks/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_log_levels_by_resource_types()
    update_log_levels_by_resource_types(params::Dict{String,<:Any})

Set default log level, or log levels by resource types. This can be for wireless device log
options or wireless gateways log options and is used to control the log messages that'll be
displayed in CloudWatch.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DefaultLogLevel"`:
- `"WirelessDeviceLogOptions"`:
- `"WirelessGatewayLogOptions"`:
"""
function update_log_levels_by_resource_types(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "POST", "/log-levels"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function update_log_levels_by_resource_types(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "POST",
        "/log-levels",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_metric_configuration()
    update_metric_configuration(params::Dict{String,<:Any})

Update the summary metric configuration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"SummaryMetric"`: The value to be used to set summary metric configuration.
"""
function update_metric_configuration(; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_wireless(
        "PUT",
        "/metric-configuration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_metric_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "PUT",
        "/metric-configuration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_multicast_group(id)
    update_multicast_group(id, params::Dict{String,<:Any})

Updates properties of a multicast group session.

# Arguments
- `id`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`:
- `"LoRaWAN"`:
- `"Name"`:
"""
function update_multicast_group(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_wireless(
        "PATCH",
        "/multicast-groups/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_multicast_group(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "PATCH",
        "/multicast-groups/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_network_analyzer_configuration(configuration_name)
    update_network_analyzer_configuration(configuration_name, params::Dict{String,<:Any})

Update network analyzer configuration.

# Arguments
- `configuration_name`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`:
- `"MulticastGroupsToAdd"`: Multicast group resources to add to the network analyzer
  configuration. Provide the MulticastGroupId of the resource to add in the input array.
- `"MulticastGroupsToRemove"`: Multicast group resources to remove from the network
  analyzer configuration. Provide the MulticastGroupId of the resources to remove in the
  input array.
- `"TraceContent"`:
- `"WirelessDevicesToAdd"`: Wireless device resources to add to the network analyzer
  configuration. Provide the WirelessDeviceId of the resource to add in the input array.
- `"WirelessDevicesToRemove"`: Wireless device resources to remove from the network
  analyzer configuration. Provide the WirelessDeviceId of the resources to remove in the
  input array.
- `"WirelessGatewaysToAdd"`: Wireless gateway resources to add to the network analyzer
  configuration. Provide the WirelessGatewayId of the resource to add in the input array.
- `"WirelessGatewaysToRemove"`: Wireless gateway resources to remove from the network
  analyzer configuration. Provide the WirelessGatewayId of the resources to remove in the
  input array.
"""
function update_network_analyzer_configuration(
    ConfigurationName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "PATCH",
        "/network-analyzer-configurations/$(ConfigurationName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_network_analyzer_configuration(
    ConfigurationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_wireless(
        "PATCH",
        "/network-analyzer-configurations/$(ConfigurationName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_partner_account(partner_account_id, sidewalk, partner_type)
    update_partner_account(partner_account_id, sidewalk, partner_type, params::Dict{String,<:Any})

Updates properties of a partner account.

# Arguments
- `partner_account_id`: The ID of the partner account to update.
- `sidewalk`: The Sidewalk account credentials.
- `partner_type`: The partner type.

"""
function update_partner_account(
    PartnerAccountId,
    Sidewalk,
    partnerType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_wireless(
        "PATCH",
        "/partner-accounts/$(PartnerAccountId)",
        Dict{String,Any}("Sidewalk" => Sidewalk, "partnerType" => partnerType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_partner_account(
    PartnerAccountId,
    Sidewalk,
    partnerType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_wireless(
        "PATCH",
        "/partner-accounts/$(PartnerAccountId)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Sidewalk" => Sidewalk, "partnerType" => partnerType),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_position(position, resource_identifier, resource_type)
    update_position(position, resource_identifier, resource_type, params::Dict{String,<:Any})

Update the position information of a resource.  This action is no longer supported. Calls
to update the position information should use the UpdateResourcePosition API operation
instead.

# Arguments
- `position`: The position information of the resource.
- `resource_identifier`: Resource identifier of the resource for which position is updated.
- `resource_type`: Resource type of the resource for which position is updated.

"""
function update_position(
    Position,
    ResourceIdentifier,
    resourceType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_wireless(
        "PATCH",
        "/positions/$(ResourceIdentifier)",
        Dict{String,Any}("Position" => Position, "resourceType" => resourceType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_position(
    Position,
    ResourceIdentifier,
    resourceType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_wireless(
        "PATCH",
        "/positions/$(ResourceIdentifier)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Position" => Position, "resourceType" => resourceType),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_resource_event_configuration(identifier, identifier_type)
    update_resource_event_configuration(identifier, identifier_type, params::Dict{String,<:Any})

Update the event configuration for a particular resource identifier.

# Arguments
- `identifier`: Resource identifier to opt in for event messaging.
- `identifier_type`: Identifier type of the particular resource identifier for event
  configuration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConnectionStatus"`: Event configuration for the connection status event.
- `"DeviceRegistrationState"`: Event configuration for the device registration state event.
- `"Join"`: Event configuration for the join event.
- `"MessageDeliveryStatus"`: Event configuration for the message delivery status event.
- `"Proximity"`: Event configuration for the proximity event.
- `"partnerType"`: Partner type of the resource if the identifier type is PartnerAccountId
"""
function update_resource_event_configuration(
    Identifier, identifierType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "PATCH",
        "/event-configurations/$(Identifier)",
        Dict{String,Any}("identifierType" => identifierType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_resource_event_configuration(
    Identifier,
    identifierType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_wireless(
        "PATCH",
        "/event-configurations/$(Identifier)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("identifierType" => identifierType), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_resource_position(resource_identifier, resource_type)
    update_resource_position(resource_identifier, resource_type, params::Dict{String,<:Any})

Update the position information of a given wireless device or a wireless gateway resource.
The position coordinates are based on the  World Geodetic System (WGS84).

# Arguments
- `resource_identifier`: The identifier of the resource for which position information is
  updated. It can be the wireless device ID or the wireless gateway ID, depending on the
  resource type.
- `resource_type`: The type of resource for which position information is updated, which
  can be a wireless device or a wireless gateway.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"GeoJsonPayload"`: The position information of the resource, displayed as a JSON
  payload. The payload uses the GeoJSON format, which a format that's used to encode
  geographic data structures. For more information, see GeoJSON.
"""
function update_resource_position(
    ResourceIdentifier, resourceType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "PATCH",
        "/resource-positions/$(ResourceIdentifier)",
        Dict{String,Any}("resourceType" => resourceType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_resource_position(
    ResourceIdentifier,
    resourceType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_wireless(
        "PATCH",
        "/resource-positions/$(ResourceIdentifier)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceType" => resourceType), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_wireless_device(id)
    update_wireless_device(id, params::Dict{String,<:Any})

Updates properties of a wireless device.

# Arguments
- `id`: The ID of the resource to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A new description of the resource.
- `"DestinationName"`: The name of the new destination for the device.
- `"LoRaWAN"`: The updated wireless device's configuration.
- `"Name"`: The new name of the resource.
- `"Positioning"`: FPort values for the GNSS, stream, and ClockSync functions of the
  positioning information.
"""
function update_wireless_device(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_wireless(
        "PATCH",
        "/wireless-devices/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_wireless_device(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "PATCH",
        "/wireless-devices/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_wireless_device_import_task(id, sidewalk)
    update_wireless_device_import_task(id, sidewalk, params::Dict{String,<:Any})

Update an import task to add more devices to the task.

# Arguments
- `id`: The identifier of the import task to be updated.
- `sidewalk`: The Sidewalk-related parameters of the import task to be updated.

"""
function update_wireless_device_import_task(
    Id, Sidewalk; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "PATCH",
        "/wireless_device_import_task/$(Id)",
        Dict{String,Any}("Sidewalk" => Sidewalk);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_wireless_device_import_task(
    Id,
    Sidewalk,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return iot_wireless(
        "PATCH",
        "/wireless_device_import_task/$(Id)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Sidewalk" => Sidewalk), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_wireless_gateway(id)
    update_wireless_gateway(id, params::Dict{String,<:Any})

Updates properties of a wireless gateway.

# Arguments
- `id`: The ID of the resource to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A new description of the resource.
- `"JoinEuiFilters"`:
- `"MaxEirp"`: The MaxEIRP value.
- `"Name"`: The new name of the resource.
- `"NetIdFilters"`:
"""
function update_wireless_gateway(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return iot_wireless(
        "PATCH",
        "/wireless-gateways/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_wireless_gateway(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return iot_wireless(
        "PATCH",
        "/wireless-gateways/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: connectcases
using AWS.Compat
using AWS.UUIDs

"""
    batch_get_field(domain_id, fields)
    batch_get_field(domain_id, fields, params::Dict{String,<:Any})

Returns the description for the list of fields in the request parameters.

# Arguments
- `domain_id`: The unique identifier of the Cases domain.
- `fields`: A list of unique field identifiers.

"""
function batch_get_field(
    domainId, fields; aws_config::AbstractAWSConfig=current_aws_config()
)
    return connectcases(
        "POST",
        "/domains/$(domainId)/fields-batch",
        Dict{String,Any}("fields" => fields);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_field(
    domainId,
    fields,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return connectcases(
        "POST",
        "/domains/$(domainId)/fields-batch",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("fields" => fields), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_put_field_options(domain_id, field_id, options)
    batch_put_field_options(domain_id, field_id, options, params::Dict{String,<:Any})

Creates and updates a set of field options for a single select field in a Cases domain.

# Arguments
- `domain_id`: The unique identifier of the Cases domain.
- `field_id`: The unique identifier of a field.
- `options`: A list of FieldOption objects.

"""
function batch_put_field_options(
    domainId, fieldId, options; aws_config::AbstractAWSConfig=current_aws_config()
)
    return connectcases(
        "PUT",
        "/domains/$(domainId)/fields/$(fieldId)/options",
        Dict{String,Any}("options" => options);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_put_field_options(
    domainId,
    fieldId,
    options,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return connectcases(
        "PUT",
        "/domains/$(domainId)/fields/$(fieldId)/options",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("options" => options), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_case(domain_id, fields, template_id)
    create_case(domain_id, fields, template_id, params::Dict{String,<:Any})

 If you provide a value for PerformedBy.UserArn you must also have connect:DescribeUser
permission on the User ARN resource that you provide   &lt;p&gt;Creates a case in the
specified Cases domain. Case system and custom fields are taken as an array id/value pairs
with a declared data types.&lt;/p&gt; &lt;p&gt;The following fields are required when
creating a case:&lt;/p&gt; &lt;ul&gt; &lt;li&gt; &lt;p&gt;
&lt;code&gt;customer_id&lt;/code&gt; - You must provide the full customer profile ARN in
this format: &lt;code&gt;arn:aws:profile:your_AWS_Region:your_AWS_account
ID:domains/your_profiles_domain_name/profiles/profile_ID&lt;/code&gt; &lt;/p&gt;
&lt;/li&gt; &lt;li&gt; &lt;p&gt; &lt;code&gt;title&lt;/code&gt; &lt;/p&gt; &lt;/li&gt;
&lt;/ul&gt;

# Arguments
- `domain_id`: The unique identifier of the Cases domain.
- `fields`: An array of objects with field ID (matching ListFields/DescribeField) and value
  union data.
- `template_id`: A unique identifier of a template.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If not provided, the Amazon Web Services SDK populates this
  field. For more information about idempotency, see Making retries safe with idempotent APIs.
- `"performedBy"`:
"""
function create_case(
    domainId, fields, templateId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return connectcases(
        "POST",
        "/domains/$(domainId)/cases",
        Dict{String,Any}(
            "fields" => fields, "templateId" => templateId, "clientToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_case(
    domainId,
    fields,
    templateId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return connectcases(
        "POST",
        "/domains/$(domainId)/cases",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "fields" => fields,
                    "templateId" => templateId,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_domain(name)
    create_domain(name, params::Dict{String,<:Any})

Creates a domain, which is a container for all case data, such as cases, fields, templates
and layouts. Each Amazon Connect instance can be associated with only one Cases domain.
This will not associate your connect instance to Cases domain. Instead, use the Amazon
Connect CreateIntegrationAssociation API. You need specific IAM permissions to successfully
associate the Cases domain. For more information, see Onboard to Cases.  &lt;/important&gt;

# Arguments
- `name`: The name for your Cases domain. It must be unique for your Amazon Web Services
  account.

"""
function create_domain(name; aws_config::AbstractAWSConfig=current_aws_config())
    return connectcases(
        "POST",
        "/domains",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_domain(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return connectcases(
        "POST",
        "/domains",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_field(domain_id, name, type)
    create_field(domain_id, name, type, params::Dict{String,<:Any})

Creates a field in the Cases domain. This field is used to define the case object model
(that is, defines what data can be captured on cases) in a Cases domain.

# Arguments
- `domain_id`: The unique identifier of the Cases domain.
- `name`: The name of the field.
- `type`: Defines the data type, some system constraints, and default display of the field.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description of the field.
"""
function create_field(
    domainId, name, type; aws_config::AbstractAWSConfig=current_aws_config()
)
    return connectcases(
        "POST",
        "/domains/$(domainId)/fields",
        Dict{String,Any}("name" => name, "type" => type);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_field(
    domainId,
    name,
    type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return connectcases(
        "POST",
        "/domains/$(domainId)/fields",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("name" => name, "type" => type), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_layout(content, domain_id, name)
    create_layout(content, domain_id, name, params::Dict{String,<:Any})

Creates a layout in the Cases domain. Layouts define the following configuration in the top
section and More Info tab of the Cases user interface:   Fields to display to the users
Field ordering    Title and Status fields cannot be part of layouts since they are not
configurable.

# Arguments
- `content`: Information about which fields will be present in the layout, and information
  about the order of the fields.
- `domain_id`: The unique identifier of the Cases domain.
- `name`: The name of the layout. It must be unique for the Cases domain.

"""
function create_layout(
    content, domainId, name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return connectcases(
        "POST",
        "/domains/$(domainId)/layouts",
        Dict{String,Any}("content" => content, "name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_layout(
    content,
    domainId,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return connectcases(
        "POST",
        "/domains/$(domainId)/layouts",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("content" => content, "name" => name), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_related_item(case_id, content, domain_id, type)
    create_related_item(case_id, content, domain_id, type, params::Dict{String,<:Any})

Creates a related item (comments, tasks, and contacts) and associates it with a case.    A
Related Item is a resource that is associated with a case. It may or may not have an
external identifier linking it to an external resource (for example, a contactArn). All
Related Items have their own internal identifier, the relatedItemArn. Examples of related
items include comments and contacts.   If you provide a value for performedBy.userArn you
must also have DescribeUser permission on the ARN of the user that you provide.
&lt;/note&gt;

# Arguments
- `case_id`: A unique identifier of the case.
- `content`: The content of a related item to be created.
- `domain_id`: The unique identifier of the Cases domain.
- `type`: The type of a related item.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"performedBy"`: Represents the creator of the related item.
"""
function create_related_item(
    caseId, content, domainId, type; aws_config::AbstractAWSConfig=current_aws_config()
)
    return connectcases(
        "POST",
        "/domains/$(domainId)/cases/$(caseId)/related-items/",
        Dict{String,Any}("content" => content, "type" => type);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_related_item(
    caseId,
    content,
    domainId,
    type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return connectcases(
        "POST",
        "/domains/$(domainId)/cases/$(caseId)/related-items/",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("content" => content, "type" => type), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_template(domain_id, name)
    create_template(domain_id, name, params::Dict{String,<:Any})

Creates a template in the Cases domain. This template is used to define the case object
model (that is, to define what data can be captured on cases) in a Cases domain. A template
must have a unique name within a domain, and it must reference existing field IDs and
layout IDs. Additionally, multiple fields with same IDs are not allowed within the same
Template. A template can be either Active or Inactive, as indicated by its status. Inactive
templates cannot be used to create cases.

# Arguments
- `domain_id`: The unique identifier of the Cases domain.
- `name`: A name for the template. It must be unique per domain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A brief description of the template.
- `"layoutConfiguration"`: Configuration of layouts associated to the template.
- `"requiredFields"`: A list of fields that must contain a value for a case to be
  successfully created with this template.
- `"status"`: The status of the template.
"""
function create_template(domainId, name; aws_config::AbstractAWSConfig=current_aws_config())
    return connectcases(
        "POST",
        "/domains/$(domainId)/templates",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_template(
    domainId,
    name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return connectcases(
        "POST",
        "/domains/$(domainId)/templates",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_domain(domain_id)
    delete_domain(domain_id, params::Dict{String,<:Any})

Deletes a Cases domain.  &lt;note&gt; &lt;p&gt;After deleting your domain you must
disassociate the deleted domain from your Amazon Connect instance with another API call
before being able to use Cases again with this Amazon Connect instance. See &lt;a
href=&quot;https://docs.aws.amazon.com/connect/latest/APIReference/API_DeleteIntegrationAsso
ciation.html&quot;&gt;DeleteIntegrationAssociation&lt;/a&gt;.&lt;/p&gt; &lt;/note&gt;

# Arguments
- `domain_id`: The unique identifier of the Cases domain.

"""
function delete_domain(domainId; aws_config::AbstractAWSConfig=current_aws_config())
    return connectcases(
        "DELETE",
        "/domains/$(domainId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_domain(
    domainId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return connectcases(
        "DELETE",
        "/domains/$(domainId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_field(domain_id, field_id)
    delete_field(domain_id, field_id, params::Dict{String,<:Any})

Deletes a field from a cases template. You can delete up to 100 fields per domain. After a
field is deleted:   You can still retrieve the field by calling BatchGetField.   You cannot
update a deleted field by calling UpdateField; it throws a ValidationException.   Deleted
fields are not included in the ListFields response.   Calling CreateCase with a deleted
field throws a ValidationException denoting which field IDs in the request have been
deleted.   Calling GetCase with a deleted field ID returns the deleted field's value if one
exists.   Calling UpdateCase with a deleted field ID throws a ValidationException if the
case does not already contain a value for the deleted field. Otherwise it succeeds,
allowing you to update or remove (using emptyValue: {}) the field's value from the case.
GetTemplate does not return field IDs for deleted fields.    GetLayout does not return
field IDs for deleted fields.   Calling SearchCases with the deleted field ID as a filter
returns any cases that have a value for the deleted field that matches the filter criteria.
  Calling SearchCases with a searchTerm value that matches a deleted field's value on a
case returns the case in the response.   Calling BatchPutFieldOptions with a deleted field
ID throw a ValidationException.   Calling GetCaseEventConfiguration does not return field
IDs for deleted fields.

# Arguments
- `domain_id`: The unique identifier of the Cases domain.
- `field_id`: Unique identifier of the field.

"""
function delete_field(domainId, fieldId; aws_config::AbstractAWSConfig=current_aws_config())
    return connectcases(
        "DELETE",
        "/domains/$(domainId)/fields/$(fieldId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_field(
    domainId,
    fieldId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return connectcases(
        "DELETE",
        "/domains/$(domainId)/fields/$(fieldId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_layout(domain_id, layout_id)
    delete_layout(domain_id, layout_id, params::Dict{String,<:Any})

Deletes a layout from a cases template. You can delete up to 100 layouts per domain.
&lt;p&gt;After a layout is deleted:&lt;/p&gt; &lt;ul&gt; &lt;li&gt; &lt;p&gt;You can still
retrieve the layout by calling &lt;code&gt;GetLayout&lt;/code&gt;.&lt;/p&gt; &lt;/li&gt;
&lt;li&gt; &lt;p&gt;You cannot update a deleted layout by calling
&lt;code&gt;UpdateLayout&lt;/code&gt;; it throws a
&lt;code&gt;ValidationException&lt;/code&gt;.&lt;/p&gt; &lt;/li&gt; &lt;li&gt;
&lt;p&gt;Deleted layouts are not included in the &lt;code&gt;ListLayouts&lt;/code&gt;
response.&lt;/p&gt; &lt;/li&gt; &lt;/ul&gt;

# Arguments
- `domain_id`: The unique identifier of the Cases domain.
- `layout_id`: The unique identifier of the layout.

"""
function delete_layout(
    domainId, layoutId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return connectcases(
        "DELETE",
        "/domains/$(domainId)/layouts/$(layoutId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_layout(
    domainId,
    layoutId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return connectcases(
        "DELETE",
        "/domains/$(domainId)/layouts/$(layoutId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_template(domain_id, template_id)
    delete_template(domain_id, template_id, params::Dict{String,<:Any})

Deletes a cases template. You can delete up to 100 templates per domain.  &lt;p&gt;After a
cases template is deleted:&lt;/p&gt; &lt;ul&gt; &lt;li&gt; &lt;p&gt;You can still retrieve
the template by calling &lt;code&gt;GetTemplate&lt;/code&gt;.&lt;/p&gt; &lt;/li&gt;
&lt;li&gt; &lt;p&gt;You cannot update the template. &lt;/p&gt; &lt;/li&gt; &lt;li&gt;
&lt;p&gt;You cannot create a case by using the deleted template.&lt;/p&gt; &lt;/li&gt;
&lt;li&gt; &lt;p&gt;Deleted templates are not included in the
&lt;code&gt;ListTemplates&lt;/code&gt; response.&lt;/p&gt; &lt;/li&gt; &lt;/ul&gt;

# Arguments
- `domain_id`: The unique identifier of the Cases domain.
- `template_id`: A unique identifier of a template.

"""
function delete_template(
    domainId, templateId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return connectcases(
        "DELETE",
        "/domains/$(domainId)/templates/$(templateId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_template(
    domainId,
    templateId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return connectcases(
        "DELETE",
        "/domains/$(domainId)/templates/$(templateId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_case(case_id, domain_id, fields)
    get_case(case_id, domain_id, fields, params::Dict{String,<:Any})

Returns information about a specific case if it exists.

# Arguments
- `case_id`: A unique identifier of the case.
- `domain_id`: The unique identifier of the Cases domain.
- `fields`: A list of unique field identifiers.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: The token for the next set of results. Use the value returned in the
  previous response in the next request to retrieve the next set of results.
"""
function get_case(
    caseId, domainId, fields; aws_config::AbstractAWSConfig=current_aws_config()
)
    return connectcases(
        "POST",
        "/domains/$(domainId)/cases/$(caseId)",
        Dict{String,Any}("fields" => fields);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_case(
    caseId,
    domainId,
    fields,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return connectcases(
        "POST",
        "/domains/$(domainId)/cases/$(caseId)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("fields" => fields), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_case_audit_events(case_id, domain_id)
    get_case_audit_events(case_id, domain_id, params::Dict{String,<:Any})

Returns the audit history about a specific case if it exists.

# Arguments
- `case_id`: A unique identifier of the case.
- `domain_id`: The unique identifier of the Cases domain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of audit events to return. The current maximum
  supported value is 25. This is also the default when no other value is provided.
- `"nextToken"`: The token for the next set of results. Use the value returned in the
  previous response in the next request to retrieve the next set of results.
"""
function get_case_audit_events(
    caseId, domainId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return connectcases(
        "POST",
        "/domains/$(domainId)/cases/$(caseId)/audit-history";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_case_audit_events(
    caseId,
    domainId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return connectcases(
        "POST",
        "/domains/$(domainId)/cases/$(caseId)/audit-history",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_case_event_configuration(domain_id)
    get_case_event_configuration(domain_id, params::Dict{String,<:Any})

Returns the case event publishing configuration.

# Arguments
- `domain_id`: The unique identifier of the Cases domain.

"""
function get_case_event_configuration(
    domainId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return connectcases(
        "POST",
        "/domains/$(domainId)/case-event-configuration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_case_event_configuration(
    domainId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return connectcases(
        "POST",
        "/domains/$(domainId)/case-event-configuration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_domain(domain_id)
    get_domain(domain_id, params::Dict{String,<:Any})

Returns information about a specific domain if it exists.

# Arguments
- `domain_id`: The unique identifier of the Cases domain.

"""
function get_domain(domainId; aws_config::AbstractAWSConfig=current_aws_config())
    return connectcases(
        "POST",
        "/domains/$(domainId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_domain(
    domainId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return connectcases(
        "POST",
        "/domains/$(domainId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_layout(domain_id, layout_id)
    get_layout(domain_id, layout_id, params::Dict{String,<:Any})

Returns the details for the requested layout.

# Arguments
- `domain_id`: The unique identifier of the Cases domain.
- `layout_id`: The unique identifier of the layout.

"""
function get_layout(domainId, layoutId; aws_config::AbstractAWSConfig=current_aws_config())
    return connectcases(
        "POST",
        "/domains/$(domainId)/layouts/$(layoutId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_layout(
    domainId,
    layoutId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return connectcases(
        "POST",
        "/domains/$(domainId)/layouts/$(layoutId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_template(domain_id, template_id)
    get_template(domain_id, template_id, params::Dict{String,<:Any})

Returns the details for the requested template.

# Arguments
- `domain_id`: The unique identifier of the Cases domain.
- `template_id`: A unique identifier of a template.

"""
function get_template(
    domainId, templateId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return connectcases(
        "POST",
        "/domains/$(domainId)/templates/$(templateId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_template(
    domainId,
    templateId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return connectcases(
        "POST",
        "/domains/$(domainId)/templates/$(templateId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_cases_for_contact(contact_arn, domain_id)
    list_cases_for_contact(contact_arn, domain_id, params::Dict{String,<:Any})

Lists cases for a given contact.

# Arguments
- `contact_arn`: A unique identifier of a contact in Amazon Connect.
- `domain_id`: The unique identifier of the Cases domain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return per page.
- `"nextToken"`: The token for the next set of results. Use the value returned in the
  previous response in the next request to retrieve the next set of results.
"""
function list_cases_for_contact(
    contactArn, domainId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return connectcases(
        "POST",
        "/domains/$(domainId)/list-cases-for-contact",
        Dict{String,Any}("contactArn" => contactArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_cases_for_contact(
    contactArn,
    domainId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return connectcases(
        "POST",
        "/domains/$(domainId)/list-cases-for-contact",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("contactArn" => contactArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_domains()
    list_domains(params::Dict{String,<:Any})

Lists all cases domains in the Amazon Web Services account. Each list item is a condensed
summary object of the domain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return per page.
- `"nextToken"`: The token for the next set of results. Use the value returned in the
  previous response in the next request to retrieve the next set of results.
"""
function list_domains(; aws_config::AbstractAWSConfig=current_aws_config())
    return connectcases(
        "POST", "/domains-list"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_domains(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return connectcases(
        "POST",
        "/domains-list",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_field_options(domain_id, field_id)
    list_field_options(domain_id, field_id, params::Dict{String,<:Any})

Lists all of the field options for a field identifier in the domain.

# Arguments
- `domain_id`: The unique identifier of the Cases domain.
- `field_id`: The unique identifier of a field.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return per page.
- `"nextToken"`: The token for the next set of results. Use the value returned in the
  previous response in the next request to retrieve the next set of results.
- `"values"`: A list of FieldOption values to filter on for ListFieldOptions.
"""
function list_field_options(
    domainId, fieldId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return connectcases(
        "POST",
        "/domains/$(domainId)/fields/$(fieldId)/options-list";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_field_options(
    domainId,
    fieldId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return connectcases(
        "POST",
        "/domains/$(domainId)/fields/$(fieldId)/options-list",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_fields(domain_id)
    list_fields(domain_id, params::Dict{String,<:Any})

Lists all fields in a Cases domain.

# Arguments
- `domain_id`: The unique identifier of the Cases domain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return per page.
- `"nextToken"`: The token for the next set of results. Use the value returned in the
  previous response in the next request to retrieve the next set of results.
"""
function list_fields(domainId; aws_config::AbstractAWSConfig=current_aws_config())
    return connectcases(
        "POST",
        "/domains/$(domainId)/fields-list";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_fields(
    domainId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return connectcases(
        "POST",
        "/domains/$(domainId)/fields-list",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_layouts(domain_id)
    list_layouts(domain_id, params::Dict{String,<:Any})

Lists all layouts in the given cases domain. Each list item is a condensed summary object
of the layout.

# Arguments
- `domain_id`: The unique identifier of the Cases domain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return per page.
- `"nextToken"`: The token for the next set of results. Use the value returned in the
  previous response in the next request to retrieve the next set of results.
"""
function list_layouts(domainId; aws_config::AbstractAWSConfig=current_aws_config())
    return connectcases(
        "POST",
        "/domains/$(domainId)/layouts-list";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_layouts(
    domainId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return connectcases(
        "POST",
        "/domains/$(domainId)/layouts-list",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(arn)
    list_tags_for_resource(arn, params::Dict{String,<:Any})

Lists tags for a resource.

# Arguments
- `arn`: The Amazon Resource Name (ARN)

"""
function list_tags_for_resource(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return connectcases(
        "GET", "/tags/$(arn)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_tags_for_resource(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return connectcases(
        "GET",
        "/tags/$(arn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_templates(domain_id)
    list_templates(domain_id, params::Dict{String,<:Any})

Lists all of the templates in a Cases domain. Each list item is a condensed summary object
of the template.

# Arguments
- `domain_id`: The unique identifier of the Cases domain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return per page.
- `"nextToken"`: The token for the next set of results. Use the value returned in the
  previous response in the next request to retrieve the next set of results.
- `"status"`: A list of status values to filter on.
"""
function list_templates(domainId; aws_config::AbstractAWSConfig=current_aws_config())
    return connectcases(
        "POST",
        "/domains/$(domainId)/templates-list";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_templates(
    domainId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return connectcases(
        "POST",
        "/domains/$(domainId)/templates-list",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_case_event_configuration(domain_id, event_bridge)
    put_case_event_configuration(domain_id, event_bridge, params::Dict{String,<:Any})

Adds case event publishing configuration. For a complete list of fields you can add to the
event message, see Create case fields in the Amazon Connect Administrator Guide

# Arguments
- `domain_id`: The unique identifier of the Cases domain.
- `event_bridge`: Configuration to enable EventBridge case event delivery and determine
  what data is delivered.

"""
function put_case_event_configuration(
    domainId, eventBridge; aws_config::AbstractAWSConfig=current_aws_config()
)
    return connectcases(
        "PUT",
        "/domains/$(domainId)/case-event-configuration",
        Dict{String,Any}("eventBridge" => eventBridge);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_case_event_configuration(
    domainId,
    eventBridge,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return connectcases(
        "PUT",
        "/domains/$(domainId)/case-event-configuration",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("eventBridge" => eventBridge), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    search_cases(domain_id)
    search_cases(domain_id, params::Dict{String,<:Any})

Searches for cases within their associated Cases domain. Search results are returned as a
paginated list of abridged case documents.  For customer_id you must provide the full
customer profile ARN in this format:  arn:aws:profile:your AWS Region:your AWS account
ID:domains/profiles domain name/profiles/profile ID.

# Arguments
- `domain_id`: The unique identifier of the Cases domain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"fields"`: The list of field identifiers to be returned as part of the response.
- `"filter"`: A list of filter objects.
- `"maxResults"`: The maximum number of cases to return. The current maximum supported
  value is 25. This is also the default value when no other value is provided.
- `"nextToken"`: The token for the next set of results. Use the value returned in the
  previous response in the next request to retrieve the next set of results.
- `"searchTerm"`: A word or phrase used to perform a quick search.
- `"sorts"`: A list of sorts where each sort specifies a field and their sort order to be
  applied to the results.
"""
function search_cases(domainId; aws_config::AbstractAWSConfig=current_aws_config())
    return connectcases(
        "POST",
        "/domains/$(domainId)/cases-search";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function search_cases(
    domainId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return connectcases(
        "POST",
        "/domains/$(domainId)/cases-search",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    search_related_items(case_id, domain_id)
    search_related_items(case_id, domain_id, params::Dict{String,<:Any})

Searches for related items that are associated with a case.  If no filters are provided,
this returns all related items associated with a case.

# Arguments
- `case_id`: A unique identifier of the case.
- `domain_id`: The unique identifier of the Cases domain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: The list of types of related items and their parameters to use for filtering.
- `"maxResults"`: The maximum number of results to return per page.
- `"nextToken"`: The token for the next set of results. Use the value returned in the
  previous response in the next request to retrieve the next set of results.
"""
function search_related_items(
    caseId, domainId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return connectcases(
        "POST",
        "/domains/$(domainId)/cases/$(caseId)/related-items-search";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function search_related_items(
    caseId,
    domainId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return connectcases(
        "POST",
        "/domains/$(domainId)/cases/$(caseId)/related-items-search",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(arn, tags)
    tag_resource(arn, tags, params::Dict{String,<:Any})

Adds tags to a resource.

# Arguments
- `arn`: The Amazon Resource Name (ARN)
- `tags`: A map of of key-value pairs that represent tags on a resource. Tags are used to
  organize, track, or control access for this resource.

"""
function tag_resource(arn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return connectcases(
        "POST",
        "/tags/$(arn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    arn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return connectcases(
        "POST",
        "/tags/$(arn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(arn, tag_keys)
    untag_resource(arn, tag_keys, params::Dict{String,<:Any})

Untags a resource.

# Arguments
- `arn`: The Amazon Resource Name (ARN)
- `tag_keys`: List of tag keys.

"""
function untag_resource(arn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config())
    return connectcases(
        "DELETE",
        "/tags/$(arn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    arn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return connectcases(
        "DELETE",
        "/tags/$(arn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_case(case_id, domain_id, fields)
    update_case(case_id, domain_id, fields, params::Dict{String,<:Any})

 If you provide a value for PerformedBy.UserArn you must also have connect:DescribeUser
permission on the User ARN resource that you provide   &lt;p&gt;Updates the values of
fields on a case. Fields to be updated are received as an array of id/value pairs identical
to the &lt;code&gt;CreateCase&lt;/code&gt; input .&lt;/p&gt; &lt;p&gt;If the action is
successful, the service sends back an HTTP 200 response with an empty HTTP body.&lt;/p&gt;

# Arguments
- `case_id`: A unique identifier of the case.
- `domain_id`: The unique identifier of the Cases domain.
- `fields`: An array of objects with fieldId (matching ListFields/DescribeField) and value
  union data, structured identical to CreateCase.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"performedBy"`:
"""
function update_case(
    caseId, domainId, fields; aws_config::AbstractAWSConfig=current_aws_config()
)
    return connectcases(
        "PUT",
        "/domains/$(domainId)/cases/$(caseId)",
        Dict{String,Any}("fields" => fields);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_case(
    caseId,
    domainId,
    fields,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return connectcases(
        "PUT",
        "/domains/$(domainId)/cases/$(caseId)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("fields" => fields), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_field(domain_id, field_id)
    update_field(domain_id, field_id, params::Dict{String,<:Any})

Updates the properties of an existing field.

# Arguments
- `domain_id`: The unique identifier of the Cases domain.
- `field_id`: The unique identifier of a field.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description of a field.
- `"name"`: The name of the field.
"""
function update_field(domainId, fieldId; aws_config::AbstractAWSConfig=current_aws_config())
    return connectcases(
        "PUT",
        "/domains/$(domainId)/fields/$(fieldId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_field(
    domainId,
    fieldId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return connectcases(
        "PUT",
        "/domains/$(domainId)/fields/$(fieldId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_layout(domain_id, layout_id)
    update_layout(domain_id, layout_id, params::Dict{String,<:Any})

Updates the attributes of an existing layout. If the action is successful, the service
sends back an HTTP 200 response with an empty HTTP body. A ValidationException is returned
when you add non-existent fieldIds to a layout.  Title and Status fields cannot be part of
layouts because they are not configurable.

# Arguments
- `domain_id`: The unique identifier of the Cases domain.
- `layout_id`: The unique identifier of the layout.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"content"`: Information about which fields will be present in the layout, the order of
  the fields.
- `"name"`: The name of the layout. It must be unique per domain.
"""
function update_layout(
    domainId, layoutId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return connectcases(
        "PUT",
        "/domains/$(domainId)/layouts/$(layoutId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_layout(
    domainId,
    layoutId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return connectcases(
        "PUT",
        "/domains/$(domainId)/layouts/$(layoutId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_template(domain_id, template_id)
    update_template(domain_id, template_id, params::Dict{String,<:Any})

Updates the attributes of an existing template. The template attributes that can be
modified include name, description, layoutConfiguration, requiredFields, and status. At
least one of these attributes must not be null. If a null value is provided for a given
attribute, that attribute is ignored and its current value is preserved.

# Arguments
- `domain_id`: The unique identifier of the Cases domain.
- `template_id`: A unique identifier for the template.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: A brief description of the template.
- `"layoutConfiguration"`: Configuration of layouts associated to the template.
- `"name"`: The name of the template. It must be unique per domain.
- `"requiredFields"`: A list of fields that must contain a value for a case to be
  successfully created with this template.
- `"status"`: The status of the template.
"""
function update_template(
    domainId, templateId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return connectcases(
        "PUT",
        "/domains/$(domainId)/templates/$(templateId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_template(
    domainId,
    templateId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return connectcases(
        "PUT",
        "/domains/$(domainId)/templates/$(templateId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: appintegrations
using AWS.Compat
using AWS.UUIDs

"""
    create_application(application_source_config, name, namespace)
    create_application(application_source_config, name, namespace, params::Dict{String,<:Any})

This API is in preview release and subject to change. Creates and persists an Application
resource.

# Arguments
- `application_source_config`: The configuration for where the application should be loaded
  from.
- `name`: The name of the application.
- `namespace`: The namespace of the application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If not provided, the Amazon Web Services SDK populates this
  field. For more information about idempotency, see Making retries safe with idempotent APIs.
- `"Description"`: The description of the application.
- `"Permissions"`: The configuration of events or requests that the application has access
  to.
- `"Publications"`: The events that the application publishes.
- `"Subscriptions"`: The events that the application subscribes.
- `"Tags"`: The tags used to organize, track, or control access for this resource. For
  example, { \"tags\": {\"key1\":\"value1\", \"key2\":\"value2\"} }.
"""
function create_application(
    ApplicationSourceConfig,
    Name,
    Namespace;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appintegrations(
        "POST",
        "/applications",
        Dict{String,Any}(
            "ApplicationSourceConfig" => ApplicationSourceConfig,
            "Name" => Name,
            "Namespace" => Namespace,
            "ClientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_application(
    ApplicationSourceConfig,
    Name,
    Namespace,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appintegrations(
        "POST",
        "/applications",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ApplicationSourceConfig" => ApplicationSourceConfig,
                    "Name" => Name,
                    "Namespace" => Namespace,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_data_integration(kms_key, name, source_uri)
    create_data_integration(kms_key, name, source_uri, params::Dict{String,<:Any})

Creates and persists a DataIntegration resource.  You cannot create a DataIntegration
association for a DataIntegration that has been previously associated. Use a different
DataIntegration, or recreate the DataIntegration using the CreateDataIntegration API.

# Arguments
- `kms_key`: The KMS key for the DataIntegration.
- `name`: The name of the DataIntegration.
- `source_uri`: The URI of the data source.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If not provided, the Amazon Web Services SDK populates this
  field. For more information about idempotency, see Making retries safe with idempotent APIs.
- `"Description"`: A description of the DataIntegration.
- `"FileConfiguration"`: The configuration for what files should be pulled from the source.
- `"ObjectConfiguration"`: The configuration for what data should be pulled from the source.
- `"ScheduleConfig"`: The name of the data and how often it should be pulled from the
  source.
- `"Tags"`: The tags used to organize, track, or control access for this resource. For
  example, { \"tags\": {\"key1\":\"value1\", \"key2\":\"value2\"} }.
"""
function create_data_integration(
    KmsKey, Name, SourceURI; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appintegrations(
        "POST",
        "/dataIntegrations",
        Dict{String,Any}(
            "KmsKey" => KmsKey,
            "Name" => Name,
            "SourceURI" => SourceURI,
            "ClientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_data_integration(
    KmsKey,
    Name,
    SourceURI,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appintegrations(
        "POST",
        "/dataIntegrations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "KmsKey" => KmsKey,
                    "Name" => Name,
                    "SourceURI" => SourceURI,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_event_integration(event_bridge_bus, event_filter, name)
    create_event_integration(event_bridge_bus, event_filter, name, params::Dict{String,<:Any})

Creates an EventIntegration, given a specified name, description, and a reference to an
Amazon EventBridge bus in your account and a partner event source that pushes events to
that bus. No objects are created in the your account, only metadata that is persisted on
the EventIntegration control plane.

# Arguments
- `event_bridge_bus`: The EventBridge bus.
- `event_filter`: The event filter.
- `name`: The name of the event integration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientToken"`: A unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If not provided, the Amazon Web Services SDK populates this
  field. For more information about idempotency, see Making retries safe with idempotent APIs.
- `"Description"`: The description of the event integration.
- `"Tags"`: The tags used to organize, track, or control access for this resource. For
  example, { \"tags\": {\"key1\":\"value1\", \"key2\":\"value2\"} }.
"""
function create_event_integration(
    EventBridgeBus, EventFilter, Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appintegrations(
        "POST",
        "/eventIntegrations",
        Dict{String,Any}(
            "EventBridgeBus" => EventBridgeBus,
            "EventFilter" => EventFilter,
            "Name" => Name,
            "ClientToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_event_integration(
    EventBridgeBus,
    EventFilter,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appintegrations(
        "POST",
        "/eventIntegrations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EventBridgeBus" => EventBridgeBus,
                    "EventFilter" => EventFilter,
                    "Name" => Name,
                    "ClientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_application(application_identifier)
    delete_application(application_identifier, params::Dict{String,<:Any})

Deletes the Application. Only Applications that don't have any Application Associations can
be deleted.

# Arguments
- `application_identifier`: The Amazon Resource Name (ARN) of the Application.

"""
function delete_application(
    ApplicationIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appintegrations(
        "DELETE",
        "/applications/$(ApplicationIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_application(
    ApplicationIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appintegrations(
        "DELETE",
        "/applications/$(ApplicationIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_data_integration(identifier)
    delete_data_integration(identifier, params::Dict{String,<:Any})

Deletes the DataIntegration. Only DataIntegrations that don't have any
DataIntegrationAssociations can be deleted. Deleting a DataIntegration also deletes the
underlying Amazon AppFlow flow and service linked role.   You cannot create a
DataIntegration association for a DataIntegration that has been previously associated. Use
a different DataIntegration, or recreate the DataIntegration using the
CreateDataIntegration API.

# Arguments
- `identifier`: A unique identifier for the DataIntegration.

"""
function delete_data_integration(
    Identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appintegrations(
        "DELETE",
        "/dataIntegrations/$(Identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_data_integration(
    Identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appintegrations(
        "DELETE",
        "/dataIntegrations/$(Identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_event_integration(name)
    delete_event_integration(name, params::Dict{String,<:Any})

Deletes the specified existing event integration. If the event integration is associated
with clients, the request is rejected.

# Arguments
- `name`: The name of the event integration.

"""
function delete_event_integration(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return appintegrations(
        "DELETE",
        "/eventIntegrations/$(Name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_event_integration(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appintegrations(
        "DELETE",
        "/eventIntegrations/$(Name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_application(application_identifier)
    get_application(application_identifier, params::Dict{String,<:Any})

This API is in preview release and subject to change. Get an Application resource.

# Arguments
- `application_identifier`: The Amazon Resource Name (ARN) of the Application.

"""
function get_application(
    ApplicationIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appintegrations(
        "GET",
        "/applications/$(ApplicationIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_application(
    ApplicationIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appintegrations(
        "GET",
        "/applications/$(ApplicationIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_data_integration(identifier)
    get_data_integration(identifier, params::Dict{String,<:Any})

Returns information about the DataIntegration.  You cannot create a DataIntegration
association for a DataIntegration that has been previously associated. Use a different
DataIntegration, or recreate the DataIntegration using the CreateDataIntegration API.

# Arguments
- `identifier`: A unique identifier.

"""
function get_data_integration(
    Identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appintegrations(
        "GET",
        "/dataIntegrations/$(Identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_data_integration(
    Identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appintegrations(
        "GET",
        "/dataIntegrations/$(Identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_event_integration(name)
    get_event_integration(name, params::Dict{String,<:Any})

Returns information about the event integration.

# Arguments
- `name`: The name of the event integration.

"""
function get_event_integration(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return appintegrations(
        "GET",
        "/eventIntegrations/$(Name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_event_integration(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appintegrations(
        "GET",
        "/eventIntegrations/$(Name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_application_associations(application_identifier)
    list_application_associations(application_identifier, params::Dict{String,<:Any})

Returns a paginated list of application associations for an application.

# Arguments
- `application_identifier`: A unique identifier for the Application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return per page.
- `"nextToken"`: The token for the next set of results. Use the value returned in the
  previous response in the next request to retrieve the next set of results.
"""
function list_application_associations(
    ApplicationIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appintegrations(
        "GET",
        "/applications/$(ApplicationIdentifier)/associations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_application_associations(
    ApplicationIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appintegrations(
        "GET",
        "/applications/$(ApplicationIdentifier)/associations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_applications()
    list_applications(params::Dict{String,<:Any})

This API is in preview release and subject to change. Lists applications in the account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return per page.
- `"nextToken"`: The token for the next set of results. Use the value returned in the
  previous response in the next request to retrieve the next set of results.
"""
function list_applications(; aws_config::AbstractAWSConfig=current_aws_config())
    return appintegrations(
        "GET", "/applications"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_applications(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appintegrations(
        "GET",
        "/applications",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_data_integration_associations(identifier)
    list_data_integration_associations(identifier, params::Dict{String,<:Any})

Returns a paginated list of DataIntegration associations in the account.  You cannot create
a DataIntegration association for a DataIntegration that has been previously associated.
Use a different DataIntegration, or recreate the DataIntegration using the
CreateDataIntegration API.

# Arguments
- `identifier`: A unique identifier for the DataIntegration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return per page.
- `"nextToken"`: The token for the next set of results. Use the value returned in the
  previous response in the next request to retrieve the next set of results.
"""
function list_data_integration_associations(
    Identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appintegrations(
        "GET",
        "/dataIntegrations/$(Identifier)/associations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_data_integration_associations(
    Identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appintegrations(
        "GET",
        "/dataIntegrations/$(Identifier)/associations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_data_integrations()
    list_data_integrations(params::Dict{String,<:Any})

Returns a paginated list of DataIntegrations in the account.  You cannot create a
DataIntegration association for a DataIntegration that has been previously associated. Use
a different DataIntegration, or recreate the DataIntegration using the
CreateDataIntegration API.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return per page.
- `"nextToken"`: The token for the next set of results. Use the value returned in the
  previous response in the next request to retrieve the next set of results.
"""
function list_data_integrations(; aws_config::AbstractAWSConfig=current_aws_config())
    return appintegrations(
        "GET", "/dataIntegrations"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_data_integrations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appintegrations(
        "GET",
        "/dataIntegrations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_event_integration_associations(name)
    list_event_integration_associations(name, params::Dict{String,<:Any})

Returns a paginated list of event integration associations in the account.

# Arguments
- `name`: The name of the event integration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return per page.
- `"nextToken"`: The token for the next set of results. Use the value returned in the
  previous response in the next request to retrieve the next set of results.
"""
function list_event_integration_associations(
    Name; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appintegrations(
        "GET",
        "/eventIntegrations/$(Name)/associations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_event_integration_associations(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appintegrations(
        "GET",
        "/eventIntegrations/$(Name)/associations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_event_integrations()
    list_event_integrations(params::Dict{String,<:Any})

Returns a paginated list of event integrations in the account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return per page.
- `"nextToken"`: The token for the next set of results. Use the value returned in the
  previous response in the next request to retrieve the next set of results.
"""
function list_event_integrations(; aws_config::AbstractAWSConfig=current_aws_config())
    return appintegrations(
        "GET", "/eventIntegrations"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_event_integrations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appintegrations(
        "GET",
        "/eventIntegrations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists the tags for the specified resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appintegrations(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appintegrations(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds the specified tags to the specified resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.
- `tags`: The tags used to organize, track, or control access for this resource. For
  example, { \"tags\": {\"key1\":\"value1\", \"key2\":\"value2\"} }.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return appintegrations(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appintegrations(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes the specified tags from the specified resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.
- `tag_keys`: The tag keys.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appintegrations(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appintegrations(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_application(application_identifier)
    update_application(application_identifier, params::Dict{String,<:Any})

This API is in preview release and subject to change. Updates and persists an Application
resource.

# Arguments
- `application_identifier`: The Amazon Resource Name (ARN) of the Application.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ApplicationSourceConfig"`: The configuration for where the application should be loaded
  from.
- `"Description"`: The description of the application.
- `"Name"`: The name of the application.
- `"Permissions"`: The configuration of events or requests that the application has access
  to.
- `"Publications"`: The events that the application publishes.
- `"Subscriptions"`: The events that the application subscribes.
"""
function update_application(
    ApplicationIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appintegrations(
        "PATCH",
        "/applications/$(ApplicationIdentifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_application(
    ApplicationIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appintegrations(
        "PATCH",
        "/applications/$(ApplicationIdentifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_data_integration(identifier)
    update_data_integration(identifier, params::Dict{String,<:Any})

Updates the description of a DataIntegration.  You cannot create a DataIntegration
association for a DataIntegration that has been previously associated. Use a different
DataIntegration, or recreate the DataIntegration using the CreateDataIntegration API.

# Arguments
- `identifier`: A unique identifier for the DataIntegration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description of the DataIntegration.
- `"Name"`: The name of the DataIntegration.
"""
function update_data_integration(
    Identifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appintegrations(
        "PATCH",
        "/dataIntegrations/$(Identifier)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_data_integration(
    Identifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return appintegrations(
        "PATCH",
        "/dataIntegrations/$(Identifier)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_event_integration(name)
    update_event_integration(name, params::Dict{String,<:Any})

Updates the description of an event integration.

# Arguments
- `name`: The name of the event integration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: The description of the event integration.
"""
function update_event_integration(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return appintegrations(
        "PATCH",
        "/eventIntegrations/$(Name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_event_integration(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return appintegrations(
        "PATCH",
        "/eventIntegrations/$(Name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: apptest
using AWS.Compat
using AWS.UUIDs

"""
    create_test_case(name, steps)
    create_test_case(name, steps, params::Dict{String,<:Any})

Creates a test case.

# Arguments
- `name`: The name of the test case.
- `steps`: The steps in the test case.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: The client token of the test case.
- `"description"`: The description of the test case.
- `"tags"`: The specified tags of the test case.
"""
function create_test_case(name, steps; aws_config::AbstractAWSConfig=current_aws_config())
    return apptest(
        "POST",
        "/testcase",
        Dict{String,Any}(
            "name" => name, "steps" => steps, "clientToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_test_case(
    name,
    steps,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apptest(
        "POST",
        "/testcase",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "name" => name, "steps" => steps, "clientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_test_configuration(name, resources)
    create_test_configuration(name, resources, params::Dict{String,<:Any})

Creates a test configuration.

# Arguments
- `name`: The name of the test configuration.
- `resources`: The defined resources of the test configuration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: The client token of the test configuration.
- `"description"`: The description of the test configuration.
- `"properties"`: The properties of the test configuration.
- `"serviceSettings"`: The service settings of the test configuration.
- `"tags"`: The tags of the test configuration.
"""
function create_test_configuration(
    name, resources; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apptest(
        "POST",
        "/testconfiguration",
        Dict{String,Any}(
            "name" => name, "resources" => resources, "clientToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_test_configuration(
    name,
    resources,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apptest(
        "POST",
        "/testconfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "name" => name,
                    "resources" => resources,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_test_suite(name, test_cases)
    create_test_suite(name, test_cases, params::Dict{String,<:Any})

Creates a test suite.

# Arguments
- `name`: The name of the test suite.
- `test_cases`: The test cases in the test suite.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"afterSteps"`: The after steps of the test suite.
- `"beforeSteps"`: The before steps of the test suite.
- `"clientToken"`: The client token of the test suite.
- `"description"`: The description of the test suite.
- `"tags"`: The tags of the test suite.
"""
function create_test_suite(
    name, testCases; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apptest(
        "POST",
        "/testsuite",
        Dict{String,Any}(
            "name" => name, "testCases" => testCases, "clientToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_test_suite(
    name,
    testCases,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apptest(
        "POST",
        "/testsuite",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "name" => name,
                    "testCases" => testCases,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_test_case(test_case_id)
    delete_test_case(test_case_id, params::Dict{String,<:Any})

Deletes a test case.

# Arguments
- `test_case_id`: The test case ID of the test case.

"""
function delete_test_case(testCaseId; aws_config::AbstractAWSConfig=current_aws_config())
    return apptest(
        "DELETE",
        "/testcases/$(testCaseId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_test_case(
    testCaseId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apptest(
        "DELETE",
        "/testcases/$(testCaseId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_test_configuration(test_configuration_id)
    delete_test_configuration(test_configuration_id, params::Dict{String,<:Any})

Deletes a test configuration.

# Arguments
- `test_configuration_id`: The test ID of the test configuration.

"""
function delete_test_configuration(
    testConfigurationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apptest(
        "DELETE",
        "/testconfigurations/$(testConfigurationId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_test_configuration(
    testConfigurationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apptest(
        "DELETE",
        "/testconfigurations/$(testConfigurationId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_test_run(test_run_id)
    delete_test_run(test_run_id, params::Dict{String,<:Any})

Deletes a test run.

# Arguments
- `test_run_id`: The run ID of the test run.

"""
function delete_test_run(testRunId; aws_config::AbstractAWSConfig=current_aws_config())
    return apptest(
        "DELETE",
        "/testruns/$(testRunId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_test_run(
    testRunId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apptest(
        "DELETE",
        "/testruns/$(testRunId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_test_suite(test_suite_id)
    delete_test_suite(test_suite_id, params::Dict{String,<:Any})

Deletes a test suite.

# Arguments
- `test_suite_id`: The test ID of the test suite.

"""
function delete_test_suite(testSuiteId; aws_config::AbstractAWSConfig=current_aws_config())
    return apptest(
        "DELETE",
        "/testsuites/$(testSuiteId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_test_suite(
    testSuiteId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apptest(
        "DELETE",
        "/testsuites/$(testSuiteId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_test_case(test_case_id)
    get_test_case(test_case_id, params::Dict{String,<:Any})

Gets a test case.

# Arguments
- `test_case_id`: The request test ID of the test case.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"testCaseVersion"`: The test case version of the test case.
"""
function get_test_case(testCaseId; aws_config::AbstractAWSConfig=current_aws_config())
    return apptest(
        "GET",
        "/testcases/$(testCaseId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_test_case(
    testCaseId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apptest(
        "GET",
        "/testcases/$(testCaseId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_test_configuration(test_configuration_id)
    get_test_configuration(test_configuration_id, params::Dict{String,<:Any})

Gets a test configuration.

# Arguments
- `test_configuration_id`: The request test configuration ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"testConfigurationVersion"`: The test configuration version.
"""
function get_test_configuration(
    testConfigurationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apptest(
        "GET",
        "/testconfigurations/$(testConfigurationId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_test_configuration(
    testConfigurationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apptest(
        "GET",
        "/testconfigurations/$(testConfigurationId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_test_run_step(step_name, test_run_id)
    get_test_run_step(step_name, test_run_id, params::Dict{String,<:Any})

Gets a test run step.

# Arguments
- `step_name`: The step name of the test run step.
- `test_run_id`: The test run ID of the test run step.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"testCaseId"`: The test case ID of a test run step.
- `"testSuiteId"`: The test suite ID of a test run step.
"""
function get_test_run_step(
    stepName, testRunId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apptest(
        "GET",
        "/testruns/$(testRunId)/steps/$(stepName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_test_run_step(
    stepName,
    testRunId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apptest(
        "GET",
        "/testruns/$(testRunId)/steps/$(stepName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_test_suite(test_suite_id)
    get_test_suite(test_suite_id, params::Dict{String,<:Any})

Gets a test suite.

# Arguments
- `test_suite_id`: The ID of the test suite.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"testSuiteVersion"`: The version of the test suite.
"""
function get_test_suite(testSuiteId; aws_config::AbstractAWSConfig=current_aws_config())
    return apptest(
        "GET",
        "/testsuites/$(testSuiteId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_test_suite(
    testSuiteId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apptest(
        "GET",
        "/testsuites/$(testSuiteId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists tags for a resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apptest(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apptest(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_test_cases()
    list_test_cases(params::Dict{String,<:Any})

Lists test cases.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum results of the test case.
- `"nextToken"`: The next token of the test cases.
- `"testCaseIds"`: The IDs of the test cases.
"""
function list_test_cases(; aws_config::AbstractAWSConfig=current_aws_config())
    return apptest(
        "GET", "/testcases"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_test_cases(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apptest(
        "GET", "/testcases", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_test_configurations()
    list_test_configurations(params::Dict{String,<:Any})

Lists test configurations.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum results of the test configuration.
- `"nextToken"`: The next token for the test configurations.
- `"testConfigurationIds"`: The configuration IDs of the test configurations.
"""
function list_test_configurations(; aws_config::AbstractAWSConfig=current_aws_config())
    return apptest(
        "GET", "/testconfigurations"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_test_configurations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apptest(
        "GET",
        "/testconfigurations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_test_run_steps(test_run_id)
    list_test_run_steps(test_run_id, params::Dict{String,<:Any})

Lists test run steps.

# Arguments
- `test_run_id`: The test run ID of the test run steps.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of test run steps to return in one page of results.
- `"nextToken"`: The token from a previous step to retrieve the next page of results.
- `"testCaseId"`: The test case ID of the test run steps.
- `"testSuiteId"`: The test suite ID of the test run steps.
"""
function list_test_run_steps(testRunId; aws_config::AbstractAWSConfig=current_aws_config())
    return apptest(
        "GET",
        "/testruns/$(testRunId)/steps";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_test_run_steps(
    testRunId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apptest(
        "GET",
        "/testruns/$(testRunId)/steps",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_test_run_test_cases(test_run_id)
    list_test_run_test_cases(test_run_id, params::Dict{String,<:Any})

Lists test run test cases.

# Arguments
- `test_run_id`: The test run ID of the test cases.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of test run test cases to return in one page of
  results.
- `"nextToken"`: The token from a previous request to retrieve the next page of results.
"""
function list_test_run_test_cases(
    testRunId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apptest(
        "GET",
        "/testruns/$(testRunId)/testcases";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_test_run_test_cases(
    testRunId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apptest(
        "GET",
        "/testruns/$(testRunId)/testcases",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_test_runs()
    list_test_runs(params::Dict{String,<:Any})

Lists test runs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of test runs to return in one page of results.
- `"nextToken"`: The token from the previous request to retrieve the next page of test run
  results.
- `"testSuiteId"`: The test suite ID of the test runs.
- `"testrunIds"`: The test run IDs of the test runs.
"""
function list_test_runs(; aws_config::AbstractAWSConfig=current_aws_config())
    return apptest(
        "GET", "/testruns"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_test_runs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apptest(
        "GET", "/testruns", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_test_suites()
    list_test_suites(params::Dict{String,<:Any})

Lists test suites.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of test suites to return in one page of results.
- `"nextToken"`: The token from a previous request to retrieve the next page of results.
- `"testSuiteIds"`: The suite ID of the test suites.
"""
function list_test_suites(; aws_config::AbstractAWSConfig=current_aws_config())
    return apptest(
        "GET", "/testsuites"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_test_suites(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apptest(
        "GET", "/testsuites", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    start_test_run(test_suite_id)
    start_test_run(test_suite_id, params::Dict{String,<:Any})

Starts a test run.

# Arguments
- `test_suite_id`: The test suite ID of the test run.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: The client token of the test run.
- `"tags"`: The tags of the test run.
- `"testConfigurationId"`: The configuration ID of the test run.
"""
function start_test_run(testSuiteId; aws_config::AbstractAWSConfig=current_aws_config())
    return apptest(
        "POST",
        "/testrun",
        Dict{String,Any}("testSuiteId" => testSuiteId, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_test_run(
    testSuiteId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apptest(
        "POST",
        "/testrun",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "testSuiteId" => testSuiteId, "clientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Specifies tags of a resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the tag resource.
- `tags`: The tags of the resource.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return apptest(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apptest(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Untags a resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.
- `tag_keys`: The tag keys of the resource.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apptest(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apptest(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_test_case(test_case_id)
    update_test_case(test_case_id, params::Dict{String,<:Any})

Updates a test case.

# Arguments
- `test_case_id`: The test case ID of the test case.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description of the test case.
- `"steps"`: The steps of the test case.
"""
function update_test_case(testCaseId; aws_config::AbstractAWSConfig=current_aws_config())
    return apptest(
        "PATCH",
        "/testcases/$(testCaseId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_test_case(
    testCaseId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apptest(
        "PATCH",
        "/testcases/$(testCaseId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_test_configuration(test_configuration_id)
    update_test_configuration(test_configuration_id, params::Dict{String,<:Any})

Updates a test configuration.

# Arguments
- `test_configuration_id`: The test configuration ID of the test configuration.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: The description of the test configuration.
- `"properties"`: The properties of the test configuration.
- `"resources"`: The resources of the test configuration.
- `"serviceSettings"`: The service settings of the test configuration.
"""
function update_test_configuration(
    testConfigurationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apptest(
        "PATCH",
        "/testconfigurations/$(testConfigurationId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_test_configuration(
    testConfigurationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apptest(
        "PATCH",
        "/testconfigurations/$(testConfigurationId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_test_suite(test_suite_id)
    update_test_suite(test_suite_id, params::Dict{String,<:Any})

Updates a test suite.

# Arguments
- `test_suite_id`: The test suite ID of the test suite.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"afterSteps"`: The after steps of the test suite.
- `"beforeSteps"`: The before steps for the test suite.
- `"description"`: The description of the test suite.
- `"testCases"`: The test cases in the test suite.
"""
function update_test_suite(testSuiteId; aws_config::AbstractAWSConfig=current_aws_config())
    return apptest(
        "PATCH",
        "/testsuites/$(testSuiteId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_test_suite(
    testSuiteId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apptest(
        "PATCH",
        "/testsuites/$(testSuiteId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWS.jl
using AWS
using AWS.AWSServices: bedrock_agent_runtime
using AWS.Compat
using AWS.UUIDs

"""
    delete_agent_memory(agent_alias_id, agent_id)
    delete_agent_memory(agent_alias_id, agent_id, params::Dict{String,<:Any})

Deletes memory from the specified memory identifier.

# Arguments
- `agent_alias_id`: The unique identifier of an alias of an agent.
- `agent_id`: The unique identifier of the agent to which the alias belongs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"memoryId"`: The unique identifier of the memory.
"""
function delete_agent_memory end

function delete_agent_memory(
    agentAliasId, agentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock_agent_runtime(
        "DELETE",
        "/agents/$(agentId)/agentAliases/$(agentAliasId)/memories";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function delete_agent_memory(
    agentAliasId,
    agentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_agent_runtime(
        "DELETE",
        "/agents/$(agentId)/agentAliases/$(agentAliasId)/memories",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_agent_memory(agent_alias_id, agent_id, memory_id, memory_type)
    get_agent_memory(agent_alias_id, agent_id, memory_id, memory_type, params::Dict{String,<:Any})

Gets the sessions stored in the memory of the agent.

# Arguments
- `agent_alias_id`: The unique identifier of an alias of an agent.
- `agent_id`: The unique identifier of the agent to which the alias belongs.
- `memory_id`: The unique identifier of the memory.
- `memory_type`: The type of memory.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxItems"`: The maximum number of items to return in the response. If the total number
  of results is greater than this value, use the token returned in the response in the
  nextToken field when making another request to return the next batch of results.
- `"nextToken"`: If the total number of results is greater than the maxItems value provided
  in the request, enter the token returned in the nextToken field in the response in this
  field to return the next batch of results.
"""
function get_agent_memory end

function get_agent_memory(
    agentAliasId,
    agentId,
    memoryId,
    memoryType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_agent_runtime(
        "GET",
        "/agents/$(agentId)/agentAliases/$(agentAliasId)/memories",
        Dict{String,Any}("memoryId" => memoryId, "memoryType" => memoryType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function get_agent_memory(
    agentAliasId,
    agentId,
    memoryId,
    memoryType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_agent_runtime(
        "GET",
        "/agents/$(agentId)/agentAliases/$(agentAliasId)/memories",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("memoryId" => memoryId, "memoryType" => memoryType),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    invoke_agent(agent_alias_id, agent_id, session_id)
    invoke_agent(agent_alias_id, agent_id, session_id, params::Dict{String,<:Any})

 The CLI doesn't support streaming operations in Amazon Bedrock, including InvokeAgent.
Sends a prompt for the agent to process and respond to. Note the following fields for the
request:   To continue the same conversation with an agent, use the same sessionId value in
the request.   To activate trace enablement, turn enableTrace to true. Trace enablement
helps you follow the agent's reasoning process that led it to the information it processed,
the actions it took, and the final result it yielded. For more information, see Trace
enablement.   End a conversation by setting endSession to true.   In the sessionState
object, you can include attributes for the session or prompt or, if you configured an
action group to return control, results from invocation of the action group.   The response
is returned in the bytes field of the chunk object.   The attribution object contains
citations for parts of the response.   If you set enableTrace to true in the request, you
can trace the agent's steps and reasoning process that led it to the response.   If the
action predicted was configured to return control, the response returns parameters for the
action, elicited from the user, in the returnControl field.   Errors are also surfaced in
the response.

# Arguments
- `agent_alias_id`: The alias of the agent to use.
- `agent_id`: The unique identifier of the agent to use.
- `session_id`: The unique identifier of the session. Use the same value across requests to
  continue the same conversation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"enableTrace"`: Specifies whether to turn on the trace or not to track the agent's
  reasoning process. For more information, see Trace enablement.
- `"endSession"`: Specifies whether to end the session with the agent or not.
- `"inputText"`: The prompt text to send the agent.  If you include
  returnControlInvocationResults in the sessionState field, the inputText field will be
  ignored.
- `"memoryId"`: The unique identifier of the agent memory.
- `"sessionState"`: Contains parameters that specify various attributes of the session. For
  more information, see Control session context.  If you include
  returnControlInvocationResults in the sessionState field, the inputText field will be
  ignored.
"""
function invoke_agent end

function invoke_agent(
    agentAliasId, agentId, sessionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock_agent_runtime(
        "POST",
        "/agents/$(agentId)/agentAliases/$(agentAliasId)/sessions/$(sessionId)/text";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function invoke_agent(
    agentAliasId,
    agentId,
    sessionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_agent_runtime(
        "POST",
        "/agents/$(agentId)/agentAliases/$(agentAliasId)/sessions/$(sessionId)/text",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    invoke_flow(flow_alias_identifier, flow_identifier, inputs)
    invoke_flow(flow_alias_identifier, flow_identifier, inputs, params::Dict{String,<:Any})

Invokes an alias of a flow to run the inputs that you specify and return the output of each
node as a stream. If there's an error, the error is returned. For more information, see
Test a flow in Amazon Bedrock in the Amazon Bedrock User Guide.  The CLI doesn't support
streaming operations in Amazon Bedrock, including InvokeFlow.

# Arguments
- `flow_alias_identifier`: The unique identifier of the flow alias.
- `flow_identifier`: The unique identifier of the flow.
- `inputs`: A list of objects, each containing information about an input into the flow.

"""
function invoke_flow end

function invoke_flow(
    flowAliasIdentifier,
    flowIdentifier,
    inputs;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_agent_runtime(
        "POST",
        "/flows/$(flowIdentifier)/aliases/$(flowAliasIdentifier)",
        Dict{String,Any}("inputs" => inputs);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function invoke_flow(
    flowAliasIdentifier,
    flowIdentifier,
    inputs,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_agent_runtime(
        "POST",
        "/flows/$(flowIdentifier)/aliases/$(flowAliasIdentifier)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("inputs" => inputs), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    retrieve(knowledge_base_id, retrieval_query)
    retrieve(knowledge_base_id, retrieval_query, params::Dict{String,<:Any})

Queries a knowledge base and retrieves information from it.

# Arguments
- `knowledge_base_id`: The unique identifier of the knowledge base to query.
- `retrieval_query`: Contains the query to send the knowledge base.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: If there are more results than can fit in the response, the response
  returns a nextToken. Use this token in the nextToken field of another request to retrieve
  the next batch of results.
- `"retrievalConfiguration"`: Contains configurations for the knowledge base query and
  retrieval process. For more information, see Query configurations.
"""
function retrieve end

function retrieve(
    knowledgeBaseId, retrievalQuery; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock_agent_runtime(
        "POST",
        "/knowledgebases/$(knowledgeBaseId)/retrieve",
        Dict{String,Any}("retrievalQuery" => retrievalQuery);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function retrieve(
    knowledgeBaseId,
    retrievalQuery,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return bedrock_agent_runtime(
        "POST",
        "/knowledgebases/$(knowledgeBaseId)/retrieve",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("retrievalQuery" => retrievalQuery), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    retrieve_and_generate(input)
    retrieve_and_generate(input, params::Dict{String,<:Any})

Queries a knowledge base and generates responses based on the retrieved results. The
response only cites sources that are relevant to the query.

# Arguments
- `input`: Contains the query to be made to the knowledge base.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"retrieveAndGenerateConfiguration"`: Contains configurations for the knowledge base
  query and retrieval process. For more information, see Query configurations.
- `"sessionConfiguration"`: Contains details about the session with the knowledge base.
- `"sessionId"`: The unique identifier of the session. When you first make a
  RetrieveAndGenerate request, Amazon Bedrock automatically generates this value. You must
  reuse this value for all subsequent requests in the same conversational session. This value
  allows Amazon Bedrock to maintain context and knowledge from previous interactions. You
  can't explicitly set the sessionId yourself.
"""
function retrieve_and_generate end

function retrieve_and_generate(input; aws_config::AbstractAWSConfig=current_aws_config())
    return bedrock_agent_runtime(
        "POST",
        "/retrieveAndGenerate",
        Dict{String,Any}("input" => input);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

function retrieve_and_generate(
    input, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return bedrock_agent_runtime(
        "POST",
        "/retrieveAndGenerate",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("input" => input), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: pi
using AWS.Compat
using AWS.UUIDs

"""
    create_performance_analysis_report(end_time, identifier, service_type, start_time)
    create_performance_analysis_report(end_time, identifier, service_type, start_time, params::Dict{String,<:Any})

Creates a new performance analysis report for a specific time period for the DB instance.

# Arguments
- `end_time`: The end time defined for the analysis report.
- `identifier`: An immutable, Amazon Web Services Region-unique identifier for a data
  source. Performance Insights gathers metrics from this data source. To use an Amazon RDS
  instance as a data source, you specify its DbiResourceId value. For example, specify
  db-ADECBTYHKTSAUMUZQYPDS2GW4A.
- `service_type`: The Amazon Web Services service for which Performance Insights will
  return metrics. Valid value is RDS.
- `start_time`: The start time defined for the analysis report.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: The metadata assigned to the analysis report consisting of a key-value pair.
"""
function create_performance_analysis_report(
    EndTime,
    Identifier,
    ServiceType,
    StartTime;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pi(
        "CreatePerformanceAnalysisReport",
        Dict{String,Any}(
            "EndTime" => EndTime,
            "Identifier" => Identifier,
            "ServiceType" => ServiceType,
            "StartTime" => StartTime,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_performance_analysis_report(
    EndTime,
    Identifier,
    ServiceType,
    StartTime,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pi(
        "CreatePerformanceAnalysisReport",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EndTime" => EndTime,
                    "Identifier" => Identifier,
                    "ServiceType" => ServiceType,
                    "StartTime" => StartTime,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_performance_analysis_report(analysis_report_id, identifier, service_type)
    delete_performance_analysis_report(analysis_report_id, identifier, service_type, params::Dict{String,<:Any})

Deletes a performance analysis report.

# Arguments
- `analysis_report_id`: The unique identifier of the analysis report for deletion.
- `identifier`: An immutable identifier for a data source that is unique for an Amazon Web
  Services Region. Performance Insights gathers metrics from this data source. In the
  console, the identifier is shown as ResourceID. When you call DescribeDBInstances, the
  identifier is returned as DbiResourceId. To use a DB instance as a data source, specify its
  DbiResourceId value. For example, specify db-ABCDEFGHIJKLMNOPQRSTU1VW2X.
- `service_type`: The Amazon Web Services service for which Performance Insights will
  return metrics. Valid value is RDS.

"""
function delete_performance_analysis_report(
    AnalysisReportId,
    Identifier,
    ServiceType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pi(
        "DeletePerformanceAnalysisReport",
        Dict{String,Any}(
            "AnalysisReportId" => AnalysisReportId,
            "Identifier" => Identifier,
            "ServiceType" => ServiceType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_performance_analysis_report(
    AnalysisReportId,
    Identifier,
    ServiceType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pi(
        "DeletePerformanceAnalysisReport",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AnalysisReportId" => AnalysisReportId,
                    "Identifier" => Identifier,
                    "ServiceType" => ServiceType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_dimension_keys(end_time, group_by, identifier, metric, service_type, start_time)
    describe_dimension_keys(end_time, group_by, identifier, metric, service_type, start_time, params::Dict{String,<:Any})

For a specific time period, retrieve the top N dimension keys for a metric.   Each response
element returns a maximum of 500 bytes. For larger elements, such as SQL statements, only
the first 500 bytes are returned.

# Arguments
- `end_time`: The date and time specifying the end of the requested time series data. The
  value specified is exclusive, which means that data points less than (but not equal to)
  EndTime are returned. The value for EndTime must be later than the value for StartTime.
- `group_by`: A specification for how to aggregate the data points from a query result. You
  must specify a valid dimension group. Performance Insights returns all dimensions within
  this group, unless you provide the names of specific dimensions within this group. You can
  also request that Performance Insights return a limited number of values for a dimension.
- `identifier`: An immutable, Amazon Web Services Region-unique identifier for a data
  source. Performance Insights gathers metrics from this data source. To use an Amazon RDS
  instance as a data source, you specify its DbiResourceId value. For example, specify
  db-FAIHNTYBKTGAUSUZQYPDS2GW4A.
- `metric`: The name of a Performance Insights metric to be measured. Valid values for
  Metric are:    db.load.avg - A scaled representation of the number of active sessions for
  the database engine.     db.sampledload.avg - The raw number of active sessions for the
  database engine.    If the number of active sessions is less than an internal Performance
  Insights threshold, db.load.avg and db.sampledload.avg are the same value. If the number of
  active sessions is greater than the internal threshold, Performance Insights samples the
  active sessions, with db.load.avg showing the scaled values, db.sampledload.avg showing the
  raw values, and db.sampledload.avg less than db.load.avg. For most use cases, you can query
  db.load.avg only.
- `service_type`: The Amazon Web Services service for which Performance Insights will
  return metrics. Valid values are as follows:    RDS     DOCDB
- `start_time`: The date and time specifying the beginning of the requested time series
  data. You must specify a StartTime within the past 7 days. The value specified is
  inclusive, which means that data points equal to or greater than StartTime are returned.
  The value for StartTime must be earlier than the value for EndTime.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AdditionalMetrics"`: Additional metrics for the top N dimension keys. If the specified
  dimension group in the GroupBy parameter is db.sql_tokenized, you can specify per-SQL
  metrics to get the values for the top N SQL digests. The response syntax is as follows:
  \"AdditionalMetrics\" : { \"string\" : \"string\" }.
- `"Filter"`: One or more filters to apply in the request. Restrictions:   Any number of
  filters by the same dimension, as specified in the GroupBy or Partition parameters.   A
  single filter for any other dimension in this dimension group.
- `"MaxResults"`: The maximum number of items to return in the response. If more items
  exist than the specified MaxRecords value, a pagination token is included in the response
  so that the remaining results can be retrieved.
- `"NextToken"`: An optional pagination token provided by a previous request. If this
  parameter is specified, the response includes only records beyond the token, up to the
  value specified by MaxRecords.
- `"PartitionBy"`: For each dimension specified in GroupBy, specify a secondary dimension
  to further subdivide the partition keys in the response.
- `"PeriodInSeconds"`: The granularity, in seconds, of the data points returned from
  Performance Insights. A period can be as short as one second, or as long as one day (86400
  seconds). Valid values are:     1 (one second)    60 (one minute)    300 (five minutes)
  3600 (one hour)    86400 (twenty-four hours)   If you don't specify PeriodInSeconds, then
  Performance Insights chooses a value for you, with a goal of returning roughly 100-200 data
  points in the response.
"""
function describe_dimension_keys(
    EndTime,
    GroupBy,
    Identifier,
    Metric,
    ServiceType,
    StartTime;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pi(
        "DescribeDimensionKeys",
        Dict{String,Any}(
            "EndTime" => EndTime,
            "GroupBy" => GroupBy,
            "Identifier" => Identifier,
            "Metric" => Metric,
            "ServiceType" => ServiceType,
            "StartTime" => StartTime,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_dimension_keys(
    EndTime,
    GroupBy,
    Identifier,
    Metric,
    ServiceType,
    StartTime,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pi(
        "DescribeDimensionKeys",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EndTime" => EndTime,
                    "GroupBy" => GroupBy,
                    "Identifier" => Identifier,
                    "Metric" => Metric,
                    "ServiceType" => ServiceType,
                    "StartTime" => StartTime,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_dimension_key_details(group, group_identifier, identifier, service_type)
    get_dimension_key_details(group, group_identifier, identifier, service_type, params::Dict{String,<:Any})

Get the attributes of the specified dimension group for a DB instance or data source. For
example, if you specify a SQL ID, GetDimensionKeyDetails retrieves the full text of the
dimension db.sql.statement associated with this ID. This operation is useful because
GetResourceMetrics and DescribeDimensionKeys don't support retrieval of large SQL statement
text.

# Arguments
- `group`: The name of the dimension group. Performance Insights searches the specified
  group for the dimension group ID. The following group name values are valid:    db.query
  (Amazon DocumentDB only)    db.sql (Amazon RDS and Aurora only)
- `group_identifier`: The ID of the dimension group from which to retrieve dimension
  details. For dimension group db.sql, the group ID is db.sql.id. The following group ID
  values are valid:    db.sql.id for dimension group db.sql (Aurora and RDS only)
  db.query.id for dimension group db.query (DocumentDB only)
- `identifier`: The ID for a data source from which to gather dimension data. This ID must
  be immutable and unique within an Amazon Web Services Region. When a DB instance is the
  data source, specify its DbiResourceId value. For example, specify
  db-ABCDEFGHIJKLMNOPQRSTU1VW2X.
- `service_type`: The Amazon Web Services service for which Performance Insights returns
  data. The only valid value is RDS.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"RequestedDimensions"`: A list of dimensions to retrieve the detail data for within the
  given dimension group. If you don't specify this parameter, Performance Insights returns
  all dimension data within the specified dimension group. Specify dimension names for the
  following dimension groups:    db.sql - Specify either the full dimension name
  db.sql.statement or the short dimension name statement (Aurora and RDS only).    db.query -
  Specify either the full dimension name db.query.statement or the short dimension name
  statement (DocumentDB only).
"""
function get_dimension_key_details(
    Group,
    GroupIdentifier,
    Identifier,
    ServiceType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pi(
        "GetDimensionKeyDetails",
        Dict{String,Any}(
            "Group" => Group,
            "GroupIdentifier" => GroupIdentifier,
            "Identifier" => Identifier,
            "ServiceType" => ServiceType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_dimension_key_details(
    Group,
    GroupIdentifier,
    Identifier,
    ServiceType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pi(
        "GetDimensionKeyDetails",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Group" => Group,
                    "GroupIdentifier" => GroupIdentifier,
                    "Identifier" => Identifier,
                    "ServiceType" => ServiceType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_performance_analysis_report(analysis_report_id, identifier, service_type)
    get_performance_analysis_report(analysis_report_id, identifier, service_type, params::Dict{String,<:Any})

Retrieves the report including the report ID, status, time details, and the insights with
recommendations. The report status can be RUNNING, SUCCEEDED, or FAILED. The insights
include the description and recommendation fields.

# Arguments
- `analysis_report_id`: A unique identifier of the created analysis report. For example,
  report-12345678901234567
- `identifier`: An immutable identifier for a data source that is unique for an Amazon Web
  Services Region. Performance Insights gathers metrics from this data source. In the
  console, the identifier is shown as ResourceID. When you call DescribeDBInstances, the
  identifier is returned as DbiResourceId. To use a DB instance as a data source, specify its
  DbiResourceId value. For example, specify db-ABCDEFGHIJKLMNOPQRSTU1VW2X.
- `service_type`: The Amazon Web Services service for which Performance Insights will
  return metrics. Valid value is RDS.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AcceptLanguage"`: The text language in the report. The default language is EN_US
  (English).
- `"TextFormat"`: Indicates the text format in the report. The options are PLAIN_TEXT or
  MARKDOWN. The default value is plain text.
"""
function get_performance_analysis_report(
    AnalysisReportId,
    Identifier,
    ServiceType;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pi(
        "GetPerformanceAnalysisReport",
        Dict{String,Any}(
            "AnalysisReportId" => AnalysisReportId,
            "Identifier" => Identifier,
            "ServiceType" => ServiceType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_performance_analysis_report(
    AnalysisReportId,
    Identifier,
    ServiceType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pi(
        "GetPerformanceAnalysisReport",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AnalysisReportId" => AnalysisReportId,
                    "Identifier" => Identifier,
                    "ServiceType" => ServiceType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_resource_metadata(identifier, service_type)
    get_resource_metadata(identifier, service_type, params::Dict{String,<:Any})

Retrieve the metadata for different features. For example, the metadata might indicate that
a feature is turned on or off on a specific DB instance.

# Arguments
- `identifier`: An immutable identifier for a data source that is unique for an Amazon Web
  Services Region. Performance Insights gathers metrics from this data source. To use a DB
  instance as a data source, specify its DbiResourceId value. For example, specify
  db-ABCDEFGHIJKLMNOPQRSTU1VW2X.
- `service_type`: The Amazon Web Services service for which Performance Insights returns
  metrics.

"""
function get_resource_metadata(
    Identifier, ServiceType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pi(
        "GetResourceMetadata",
        Dict{String,Any}("Identifier" => Identifier, "ServiceType" => ServiceType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_resource_metadata(
    Identifier,
    ServiceType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pi(
        "GetResourceMetadata",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Identifier" => Identifier, "ServiceType" => ServiceType),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_resource_metrics(end_time, identifier, metric_queries, service_type, start_time)
    get_resource_metrics(end_time, identifier, metric_queries, service_type, start_time, params::Dict{String,<:Any})

Retrieve Performance Insights metrics for a set of data sources over a time period. You can
provide specific dimension groups and dimensions, and provide filtering criteria for each
group. You must specify an aggregate function for each metric.  Each response element
returns a maximum of 500 bytes. For larger elements, such as SQL statements, only the first
500 bytes are returned.

# Arguments
- `end_time`: The date and time specifying the end of the requested time series query
  range. The value specified is exclusive. Thus, the command returns data points less than
  (but not equal to) EndTime. The value for EndTime must be later than the value for
  StartTime.
- `identifier`: An immutable identifier for a data source that is unique for an Amazon Web
  Services Region. Performance Insights gathers metrics from this data source. In the
  console, the identifier is shown as ResourceID. When you call DescribeDBInstances, the
  identifier is returned as DbiResourceId. To use a DB instance as a data source, specify its
  DbiResourceId value. For example, specify db-ABCDEFGHIJKLMNOPQRSTU1VW2X.
- `metric_queries`: An array of one or more queries to perform. Each query must specify a
  Performance Insights metric and specify an aggregate function, and you can provide
  filtering criteria. You must append the aggregate function to the metric. For example, to
  find the average for the metric db.load you must use db.load.avg. Valid values for
  aggregate functions include .avg, .min, .max, and .sum.
- `service_type`: The Amazon Web Services service for which Performance Insights returns
  metrics. Valid values are as follows:    RDS     DOCDB
- `start_time`: The date and time specifying the beginning of the requested time series
  query range. You can't specify a StartTime that is earlier than 7 days ago. By default,
  Performance Insights has 7 days of retention, but you can extend this range up to 2 years.
  The value specified is inclusive. Thus, the command returns data points equal to or greater
  than StartTime. The value for StartTime must be earlier than the value for EndTime.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of items to return in the response. If more items
  exist than the specified MaxRecords value, a pagination token is included in the response
  so that the remaining results can be retrieved.
- `"NextToken"`: An optional pagination token provided by a previous request. If this
  parameter is specified, the response includes only records beyond the token, up to the
  value specified by MaxRecords.
- `"PeriodAlignment"`: The returned timestamp which is the start or end time of the time
  periods. The default value is END_TIME.
- `"PeriodInSeconds"`: The granularity, in seconds, of the data points returned from
  Performance Insights. A period can be as short as one second, or as long as one day (86400
  seconds). Valid values are:    1 (one second)    60 (one minute)    300 (five minutes)
  3600 (one hour)    86400 (twenty-four hours)   If you don't specify PeriodInSeconds, then
  Performance Insights will choose a value for you, with a goal of returning roughly 100-200
  data points in the response.
"""
function get_resource_metrics(
    EndTime,
    Identifier,
    MetricQueries,
    ServiceType,
    StartTime;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pi(
        "GetResourceMetrics",
        Dict{String,Any}(
            "EndTime" => EndTime,
            "Identifier" => Identifier,
            "MetricQueries" => MetricQueries,
            "ServiceType" => ServiceType,
            "StartTime" => StartTime,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_resource_metrics(
    EndTime,
    Identifier,
    MetricQueries,
    ServiceType,
    StartTime,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pi(
        "GetResourceMetrics",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "EndTime" => EndTime,
                    "Identifier" => Identifier,
                    "MetricQueries" => MetricQueries,
                    "ServiceType" => ServiceType,
                    "StartTime" => StartTime,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_available_resource_dimensions(identifier, metrics, service_type)
    list_available_resource_dimensions(identifier, metrics, service_type, params::Dict{String,<:Any})

Retrieve the dimensions that can be queried for each specified metric type on a specified
DB instance.

# Arguments
- `identifier`: An immutable identifier for a data source that is unique within an Amazon
  Web Services Region. Performance Insights gathers metrics from this data source. To use an
  Amazon RDS DB instance as a data source, specify its DbiResourceId value. For example,
  specify db-ABCDEFGHIJKLMNOPQRSTU1VWZ.
- `metrics`: The types of metrics for which to retrieve dimensions. Valid values include
  db.load.
- `service_type`: The Amazon Web Services service for which Performance Insights returns
  metrics.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AuthorizedActions"`: The actions to discover the dimensions you are authorized to
  access. If you specify multiple actions, then the response will contain the dimensions
  common for all the actions. When you don't specify this request parameter or provide an
  empty list, the response contains all the available dimensions for the target database
  engine whether or not you are authorized to access them.
- `"MaxResults"`: The maximum number of items to return in the response. If more items
  exist than the specified MaxRecords value, a pagination token is included in the response
  so that the remaining results can be retrieved.
- `"NextToken"`: An optional pagination token provided by a previous request. If this
  parameter is specified, the response includes only records beyond the token, up to the
  value specified by MaxRecords.
"""
function list_available_resource_dimensions(
    Identifier, Metrics, ServiceType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pi(
        "ListAvailableResourceDimensions",
        Dict{String,Any}(
            "Identifier" => Identifier, "Metrics" => Metrics, "ServiceType" => ServiceType
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_available_resource_dimensions(
    Identifier,
    Metrics,
    ServiceType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pi(
        "ListAvailableResourceDimensions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Identifier" => Identifier,
                    "Metrics" => Metrics,
                    "ServiceType" => ServiceType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_available_resource_metrics(identifier, metric_types, service_type)
    list_available_resource_metrics(identifier, metric_types, service_type, params::Dict{String,<:Any})

Retrieve metrics of the specified types that can be queried for a specified DB instance.

# Arguments
- `identifier`: An immutable identifier for a data source that is unique within an Amazon
  Web Services Region. Performance Insights gathers metrics from this data source. To use an
  Amazon RDS DB instance as a data source, specify its DbiResourceId value. For example,
  specify db-ABCDEFGHIJKLMNOPQRSTU1VWZ.
- `metric_types`: The types of metrics to return in the response. Valid values in the array
  include the following:    os (OS counter metrics) - All engines    db (DB load metrics) -
  All engines except for Amazon DocumentDB    db.sql.stats (per-SQL metrics) - All engines
  except for Amazon DocumentDB    db.sql_tokenized.stats (per-SQL digest metrics) - All
  engines except for Amazon DocumentDB
- `service_type`: The Amazon Web Services service for which Performance Insights returns
  metrics.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of items to return. If the MaxRecords value is less
  than the number of existing items, the response includes a pagination token.
- `"NextToken"`: An optional pagination token provided by a previous request. If this
  parameter is specified, the response includes only records beyond the token, up to the
  value specified by MaxRecords.
"""
function list_available_resource_metrics(
    Identifier, MetricTypes, ServiceType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pi(
        "ListAvailableResourceMetrics",
        Dict{String,Any}(
            "Identifier" => Identifier,
            "MetricTypes" => MetricTypes,
            "ServiceType" => ServiceType,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_available_resource_metrics(
    Identifier,
    MetricTypes,
    ServiceType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pi(
        "ListAvailableResourceMetrics",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Identifier" => Identifier,
                    "MetricTypes" => MetricTypes,
                    "ServiceType" => ServiceType,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_performance_analysis_reports(identifier, service_type)
    list_performance_analysis_reports(identifier, service_type, params::Dict{String,<:Any})

Lists all the analysis reports created for the DB instance. The reports are sorted based on
the start time of each report.

# Arguments
- `identifier`: An immutable identifier for a data source that is unique for an Amazon Web
  Services Region. Performance Insights gathers metrics from this data source. In the
  console, the identifier is shown as ResourceID. When you call DescribeDBInstances, the
  identifier is returned as DbiResourceId. To use a DB instance as a data source, specify its
  DbiResourceId value. For example, specify db-ABCDEFGHIJKLMNOPQRSTU1VW2X.
- `service_type`: The Amazon Web Services service for which Performance Insights returns
  metrics. Valid value is RDS.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ListTags"`: Specifies whether or not to include the list of tags in the response.
- `"MaxResults"`: The maximum number of items to return in the response. If more items
  exist than the specified MaxResults value, a pagination token is included in the response
  so that the remaining results can be retrieved.
- `"NextToken"`: An optional pagination token provided by a previous request. If this
  parameter is specified, the response includes only records beyond the token, up to the
  value specified by MaxResults.
"""
function list_performance_analysis_reports(
    Identifier, ServiceType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pi(
        "ListPerformanceAnalysisReports",
        Dict{String,Any}("Identifier" => Identifier, "ServiceType" => ServiceType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_performance_analysis_reports(
    Identifier,
    ServiceType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pi(
        "ListPerformanceAnalysisReports",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("Identifier" => Identifier, "ServiceType" => ServiceType),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn, service_type)
    list_tags_for_resource(resource_arn, service_type, params::Dict{String,<:Any})

Retrieves all the metadata tags associated with Amazon RDS Performance Insights resource.

# Arguments
- `resource_arn`: Lists all the tags for the Amazon RDS Performance Insights resource. This
  value is an Amazon Resource Name (ARN). For information about creating an ARN, see
  Constructing an RDS Amazon Resource Name (ARN).
- `service_type`: List the tags for the Amazon Web Services service for which Performance
  Insights returns metrics. Valid value is RDS.

"""
function list_tags_for_resource(
    ResourceARN, ServiceType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pi(
        "ListTagsForResource",
        Dict{String,Any}("ResourceARN" => ResourceARN, "ServiceType" => ServiceType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceARN,
    ServiceType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pi(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ResourceARN" => ResourceARN, "ServiceType" => ServiceType
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, service_type, tags)
    tag_resource(resource_arn, service_type, tags, params::Dict{String,<:Any})

Adds metadata tags to the Amazon RDS Performance Insights resource.

# Arguments
- `resource_arn`: The Amazon RDS Performance Insights resource that the tags are added to.
  This value is an Amazon Resource Name (ARN). For information about creating an ARN, see
  Constructing an RDS Amazon Resource Name (ARN).
- `service_type`: The Amazon Web Services service for which Performance Insights returns
  metrics. Valid value is RDS.
- `tags`: The metadata assigned to an Amazon RDS resource consisting of a key-value pair.

"""
function tag_resource(
    ResourceARN, ServiceType, Tags; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pi(
        "TagResource",
        Dict{String,Any}(
            "ResourceARN" => ResourceARN, "ServiceType" => ServiceType, "Tags" => Tags
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceARN,
    ServiceType,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pi(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ResourceARN" => ResourceARN,
                    "ServiceType" => ServiceType,
                    "Tags" => Tags,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, service_type, tag_keys)
    untag_resource(resource_arn, service_type, tag_keys, params::Dict{String,<:Any})

Deletes the metadata tags from the Amazon RDS Performance Insights resource.

# Arguments
- `resource_arn`: The Amazon RDS Performance Insights resource that the tags are added to.
  This value is an Amazon Resource Name (ARN). For information about creating an ARN, see
  Constructing an RDS Amazon Resource Name (ARN).
- `service_type`: List the tags for the Amazon Web Services service for which Performance
  Insights returns metrics. Valid value is RDS.
- `tag_keys`: The metadata assigned to an Amazon RDS Performance Insights resource
  consisting of a key-value pair.

"""
function untag_resource(
    ResourceARN, ServiceType, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pi(
        "UntagResource",
        Dict{String,Any}(
            "ResourceARN" => ResourceARN, "ServiceType" => ServiceType, "TagKeys" => TagKeys
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceARN,
    ServiceType,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pi(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ResourceARN" => ResourceARN,
                    "ServiceType" => ServiceType,
                    "TagKeys" => TagKeys,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: comprehend
using AWS.Compat
using AWS.UUIDs

"""
    batch_detect_dominant_language(text_list)
    batch_detect_dominant_language(text_list, params::Dict{String,<:Any})

Determines the dominant language of the input text for a batch of documents. For a list of
languages that Amazon Comprehend can detect, see Amazon Comprehend Supported Languages.

# Arguments
- `text_list`: A list containing the UTF-8 encoded text of the input documents. The list
  can contain a maximum of 25 documents. Each document should contain at least 20 characters.
  The maximum size of each document is 5 KB.

"""
function batch_detect_dominant_language(
    TextList; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "BatchDetectDominantLanguage",
        Dict{String,Any}("TextList" => TextList);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_detect_dominant_language(
    TextList,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "BatchDetectDominantLanguage",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("TextList" => TextList), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_detect_entities(language_code, text_list)
    batch_detect_entities(language_code, text_list, params::Dict{String,<:Any})

Inspects the text of a batch of documents for named entities and returns information about
them. For more information about named entities, see Entities in the Comprehend Developer
Guide.

# Arguments
- `language_code`: The language of the input documents. You can specify any of the primary
  languages supported by Amazon Comprehend. All documents must be in the same language.
- `text_list`: A list containing the UTF-8 encoded text of the input documents. The list
  can contain a maximum of 25 documents. The maximum size of each document is 5 KB.

"""
function batch_detect_entities(
    LanguageCode, TextList; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "BatchDetectEntities",
        Dict{String,Any}("LanguageCode" => LanguageCode, "TextList" => TextList);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_detect_entities(
    LanguageCode,
    TextList,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "BatchDetectEntities",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("LanguageCode" => LanguageCode, "TextList" => TextList),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_detect_key_phrases(language_code, text_list)
    batch_detect_key_phrases(language_code, text_list, params::Dict{String,<:Any})

Detects the key noun phrases found in a batch of documents.

# Arguments
- `language_code`: The language of the input documents. You can specify any of the primary
  languages supported by Amazon Comprehend. All documents must be in the same language.
- `text_list`: A list containing the UTF-8 encoded text of the input documents. The list
  can contain a maximum of 25 documents. The maximum size of each document is 5 KB.

"""
function batch_detect_key_phrases(
    LanguageCode, TextList; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "BatchDetectKeyPhrases",
        Dict{String,Any}("LanguageCode" => LanguageCode, "TextList" => TextList);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_detect_key_phrases(
    LanguageCode,
    TextList,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "BatchDetectKeyPhrases",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("LanguageCode" => LanguageCode, "TextList" => TextList),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_detect_sentiment(language_code, text_list)
    batch_detect_sentiment(language_code, text_list, params::Dict{String,<:Any})

Inspects a batch of documents and returns an inference of the prevailing sentiment,
POSITIVE, NEUTRAL, MIXED, or NEGATIVE, in each one.

# Arguments
- `language_code`: The language of the input documents. You can specify any of the primary
  languages supported by Amazon Comprehend. All documents must be in the same language.
- `text_list`: A list containing the UTF-8 encoded text of the input documents. The list
  can contain a maximum of 25 documents. The maximum size of each document is 5 KB.

"""
function batch_detect_sentiment(
    LanguageCode, TextList; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "BatchDetectSentiment",
        Dict{String,Any}("LanguageCode" => LanguageCode, "TextList" => TextList);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_detect_sentiment(
    LanguageCode,
    TextList,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "BatchDetectSentiment",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("LanguageCode" => LanguageCode, "TextList" => TextList),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_detect_syntax(language_code, text_list)
    batch_detect_syntax(language_code, text_list, params::Dict{String,<:Any})

Inspects the text of a batch of documents for the syntax and part of speech of the words in
the document and returns information about them. For more information, see Syntax in the
Comprehend Developer Guide.

# Arguments
- `language_code`: The language of the input documents. You can specify any of the
  following languages supported by Amazon Comprehend: German (\"de\"), English (\"en\"),
  Spanish (\"es\"), French (\"fr\"), Italian (\"it\"), or Portuguese (\"pt\"). All documents
  must be in the same language.
- `text_list`: A list containing the UTF-8 encoded text of the input documents. The list
  can contain a maximum of 25 documents. The maximum size for each document is 5 KB.

"""
function batch_detect_syntax(
    LanguageCode, TextList; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "BatchDetectSyntax",
        Dict{String,Any}("LanguageCode" => LanguageCode, "TextList" => TextList);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_detect_syntax(
    LanguageCode,
    TextList,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "BatchDetectSyntax",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("LanguageCode" => LanguageCode, "TextList" => TextList),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_detect_targeted_sentiment(language_code, text_list)
    batch_detect_targeted_sentiment(language_code, text_list, params::Dict{String,<:Any})

Inspects a batch of documents and returns a sentiment analysis for each entity identified
in the documents. For more information about targeted sentiment, see Targeted sentiment in
the Amazon Comprehend Developer Guide.

# Arguments
- `language_code`: The language of the input documents. Currently, English is the only
  supported language.
- `text_list`: A list containing the UTF-8 encoded text of the input documents. The list
  can contain a maximum of 25 documents. The maximum size of each document is 5 KB.

"""
function batch_detect_targeted_sentiment(
    LanguageCode, TextList; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "BatchDetectTargetedSentiment",
        Dict{String,Any}("LanguageCode" => LanguageCode, "TextList" => TextList);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_detect_targeted_sentiment(
    LanguageCode,
    TextList,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "BatchDetectTargetedSentiment",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("LanguageCode" => LanguageCode, "TextList" => TextList),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    classify_document(endpoint_arn)
    classify_document(endpoint_arn, params::Dict{String,<:Any})

Creates a classification request to analyze a single document in real-time.
ClassifyDocument supports the following model types:   Custom classifier - a custom model
that you have created and trained. For input, you can provide plain text, a single-page
document (PDF, Word, or image), or Amazon Textract API output. For more information, see
Custom classification in the Amazon Comprehend Developer Guide.   Prompt safety classifier
- Amazon Comprehend provides a pre-trained model for classifying input prompts for
generative AI applications. For input, you provide English plain text input. For prompt
safety classification, the response includes only the Classes field. For more information
about prompt safety classifiers, see Prompt safety classification in the Amazon Comprehend
Developer Guide.   If the system detects errors while processing a page in the input
document, the API response includes an Errors field that describes the errors. If the
system detects a document-level error in your input document, the API returns an
InvalidRequestException error response. For details about this exception, see  Errors in
semi-structured documents in the Comprehend Developer Guide.

# Arguments
- `endpoint_arn`: The Amazon Resource Number (ARN) of the endpoint.  For prompt safety
  classification, Amazon Comprehend provides the endpoint ARN. For more information about
  prompt safety classifiers, see Prompt safety classification in the Amazon Comprehend
  Developer Guide  For custom classification, you create an endpoint for your custom model.
  For more information, see Using Amazon Comprehend endpoints.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Bytes"`: Use the Bytes parameter to input a text, PDF, Word or image file. When you
  classify a document using a custom model, you can also use the Bytes parameter to input an
  Amazon Textract DetectDocumentText or AnalyzeDocument output file. To classify a document
  using the prompt safety classifier, use the Text parameter for input. Provide the input
  document as a sequence of base64-encoded bytes. If your code uses an Amazon Web Services
  SDK to classify documents, the SDK may encode the document file bytes for you.  The maximum
  length of this field depends on the input document type. For details, see  Inputs for
  real-time custom analysis in the Comprehend Developer Guide.  If you use the Bytes
  parameter, do not use the Text parameter.
- `"DocumentReaderConfig"`: Provides configuration parameters to override the default
  actions for extracting text from PDF documents and image files.
- `"Text"`: The document text to be analyzed. If you enter text using this parameter, do
  not use the Bytes parameter.
"""
function classify_document(EndpointArn; aws_config::AbstractAWSConfig=current_aws_config())
    return comprehend(
        "ClassifyDocument",
        Dict{String,Any}("EndpointArn" => EndpointArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function classify_document(
    EndpointArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "ClassifyDocument",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("EndpointArn" => EndpointArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    contains_pii_entities(language_code, text)
    contains_pii_entities(language_code, text, params::Dict{String,<:Any})

Analyzes input text for the presence of personally identifiable information (PII) and
returns the labels of identified PII entity types such as name, address, bank account
number, or phone number.

# Arguments
- `language_code`: The language of the input documents.
- `text`: A UTF-8 text string. The maximum string size is 100 KB.

"""
function contains_pii_entities(
    LanguageCode, Text; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "ContainsPiiEntities",
        Dict{String,Any}("LanguageCode" => LanguageCode, "Text" => Text);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function contains_pii_entities(
    LanguageCode,
    Text,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "ContainsPiiEntities",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("LanguageCode" => LanguageCode, "Text" => Text),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_dataset(dataset_name, flywheel_arn, input_data_config)
    create_dataset(dataset_name, flywheel_arn, input_data_config, params::Dict{String,<:Any})

Creates a dataset to upload training or test data for a model associated with a flywheel.
For more information about datasets, see  Flywheel overview in the Amazon Comprehend
Developer Guide.

# Arguments
- `dataset_name`: Name of the dataset.
- `flywheel_arn`: The Amazon Resource Number (ARN) of the flywheel of the flywheel to
  receive the data.
- `input_data_config`: Information about the input data configuration. The type of input
  data varies based on the format of the input and whether the data is for a classifier model
  or an entity recognition model.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: A unique identifier for the request. If you don't set the client
  request token, Amazon Comprehend generates one.
- `"DatasetType"`: The dataset type. You can specify that the data in a dataset is for
  training the model or for testing the model.
- `"Description"`: Description of the dataset.
- `"Tags"`: Tags for the dataset.
"""
function create_dataset(
    DatasetName,
    FlywheelArn,
    InputDataConfig;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "CreateDataset",
        Dict{String,Any}(
            "DatasetName" => DatasetName,
            "FlywheelArn" => FlywheelArn,
            "InputDataConfig" => InputDataConfig,
            "ClientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_dataset(
    DatasetName,
    FlywheelArn,
    InputDataConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "CreateDataset",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DatasetName" => DatasetName,
                    "FlywheelArn" => FlywheelArn,
                    "InputDataConfig" => InputDataConfig,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_document_classifier(data_access_role_arn, document_classifier_name, input_data_config, language_code)
    create_document_classifier(data_access_role_arn, document_classifier_name, input_data_config, language_code, params::Dict{String,<:Any})

Creates a new document classifier that you can use to categorize documents. To create a
classifier, you provide a set of training documents that are labeled with the categories
that you want to use. For more information, see Training classifier models in the
Comprehend Developer Guide.

# Arguments
- `data_access_role_arn`: The Amazon Resource Name (ARN) of the IAM role that grants Amazon
  Comprehend read access to your input data.
- `document_classifier_name`: The name of the document classifier.
- `input_data_config`: Specifies the format and location of the input data for the job.
- `language_code`: The language of the input documents. You can specify any of the
  languages supported by Amazon Comprehend. All documents must be in the same language.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: A unique identifier for the request. If you don't set the client
  request token, Amazon Comprehend generates one.
- `"Mode"`: Indicates the mode in which the classifier will be trained. The classifier can
  be trained in multi-class (single-label) mode or multi-label mode. Multi-class mode
  identifies a single class label for each document and multi-label mode identifies one or
  more class labels for each document. Multiple labels for an individual document are
  separated by a delimiter. The default delimiter between labels is a pipe (|).
- `"ModelKmsKeyId"`: ID for the KMS key that Amazon Comprehend uses to encrypt trained
  custom models. The ModelKmsKeyId can be either of the following formats:   KMS Key ID:
  \"1234abcd-12ab-34cd-56ef-1234567890ab\"    Amazon Resource Name (ARN) of a KMS Key:
  \"arn:aws:kms:us-west-2:111122223333:key/1234abcd-12ab-34cd-56ef-1234567890ab\"
- `"ModelPolicy"`: The resource-based policy to attach to your custom document classifier
  model. You can use this policy to allow another Amazon Web Services account to import your
  custom model. Provide your policy as a JSON body that you enter as a UTF-8 encoded string
  without line breaks. To provide valid JSON, enclose the attribute names and values in
  double quotes. If the JSON body is also enclosed in double quotes, then you must escape the
  double quotes that are inside the policy:  \"{\"attribute\": \"value\", \"attribute\":
  [\"value\"]}\"  To avoid escaping quotes, you can use single quotes to enclose the policy
  and double quotes to enclose the JSON names and values:  '{\"attribute\": \"value\",
  \"attribute\": [\"value\"]}'
- `"OutputDataConfig"`: Specifies the location for the output files from a custom
  classifier job. This parameter is required for a request that creates a native document
  model.
- `"Tags"`: Tags to associate with the document classifier. A tag is a key-value pair that
  adds as a metadata to a resource used by Amazon Comprehend. For example, a tag with
  \"Sales\" as the key might be added to a resource to indicate its use by the sales
  department.
- `"VersionName"`: The version name given to the newly created classifier. Version names
  can have a maximum of 256 characters. Alphanumeric characters, hyphens (-) and underscores
  (_) are allowed. The version name must be unique among all models with the same classifier
  name in the Amazon Web Services account/Amazon Web Services Region.
- `"VolumeKmsKeyId"`: ID for the Amazon Web Services Key Management Service (KMS) key that
  Amazon Comprehend uses to encrypt data on the storage volume attached to the ML compute
  instance(s) that process the analysis job. The VolumeKmsKeyId can be either of the
  following formats:   KMS Key ID: \"1234abcd-12ab-34cd-56ef-1234567890ab\"    Amazon
  Resource Name (ARN) of a KMS Key:
  \"arn:aws:kms:us-west-2:111122223333:key/1234abcd-12ab-34cd-56ef-1234567890ab\"
- `"VpcConfig"`: Configuration parameters for an optional private Virtual Private Cloud
  (VPC) containing the resources you are using for your custom classifier. For more
  information, see Amazon VPC.
"""
function create_document_classifier(
    DataAccessRoleArn,
    DocumentClassifierName,
    InputDataConfig,
    LanguageCode;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "CreateDocumentClassifier",
        Dict{String,Any}(
            "DataAccessRoleArn" => DataAccessRoleArn,
            "DocumentClassifierName" => DocumentClassifierName,
            "InputDataConfig" => InputDataConfig,
            "LanguageCode" => LanguageCode,
            "ClientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_document_classifier(
    DataAccessRoleArn,
    DocumentClassifierName,
    InputDataConfig,
    LanguageCode,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "CreateDocumentClassifier",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DataAccessRoleArn" => DataAccessRoleArn,
                    "DocumentClassifierName" => DocumentClassifierName,
                    "InputDataConfig" => InputDataConfig,
                    "LanguageCode" => LanguageCode,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_endpoint(desired_inference_units, endpoint_name)
    create_endpoint(desired_inference_units, endpoint_name, params::Dict{String,<:Any})

Creates a model-specific endpoint for synchronous inference for a previously trained custom
model For information about endpoints, see Managing endpoints.

# Arguments
- `desired_inference_units`:  The desired number of inference units to be used by the model
  using this endpoint. Each inference unit represents of a throughput of 100 characters per
  second.
- `endpoint_name`: This is the descriptive suffix that becomes part of the EndpointArn used
  for all subsequent requests to this resource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: An idempotency token provided by the customer. If this token
  matches a previous endpoint creation request, Amazon Comprehend will not return a
  ResourceInUseException.
- `"DataAccessRoleArn"`: The Amazon Resource Name (ARN) of the IAM role that grants Amazon
  Comprehend read access to trained custom models encrypted with a customer managed key
  (ModelKmsKeyId).
- `"FlywheelArn"`: The Amazon Resource Number (ARN) of the flywheel to which the endpoint
  will be attached.
- `"ModelArn"`: The Amazon Resource Number (ARN) of the model to which the endpoint will be
  attached.
- `"Tags"`: Tags to associate with the endpoint. A tag is a key-value pair that adds
  metadata to the endpoint. For example, a tag with \"Sales\" as the key might be added to an
  endpoint to indicate its use by the sales department.
"""
function create_endpoint(
    DesiredInferenceUnits, EndpointName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "CreateEndpoint",
        Dict{String,Any}(
            "DesiredInferenceUnits" => DesiredInferenceUnits,
            "EndpointName" => EndpointName,
            "ClientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_endpoint(
    DesiredInferenceUnits,
    EndpointName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "CreateEndpoint",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DesiredInferenceUnits" => DesiredInferenceUnits,
                    "EndpointName" => EndpointName,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_entity_recognizer(data_access_role_arn, input_data_config, language_code, recognizer_name)
    create_entity_recognizer(data_access_role_arn, input_data_config, language_code, recognizer_name, params::Dict{String,<:Any})

Creates an entity recognizer using submitted files. After your CreateEntityRecognizer
request is submitted, you can check job status using the DescribeEntityRecognizer API.

# Arguments
- `data_access_role_arn`: The Amazon Resource Name (ARN) of the IAM role that grants Amazon
  Comprehend read access to your input data.
- `input_data_config`: Specifies the format and location of the input data. The S3 bucket
  containing the input data must be located in the same Region as the entity recognizer being
  created.
- `language_code`:  You can specify any of the following languages: English (\"en\"),
  Spanish (\"es\"), French (\"fr\"), Italian (\"it\"), German (\"de\"), or Portuguese
  (\"pt\"). If you plan to use this entity recognizer with PDF, Word, or image input files,
  you must specify English as the language. All training documents must be in the same
  language.
- `recognizer_name`: The name given to the newly created recognizer. Recognizer names can
  be a maximum of 256 characters. Alphanumeric characters, hyphens (-) and underscores (_)
  are allowed. The name must be unique in the account/Region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`:  A unique identifier for the request. If you don't set the client
  request token, Amazon Comprehend generates one.
- `"ModelKmsKeyId"`: ID for the KMS key that Amazon Comprehend uses to encrypt trained
  custom models. The ModelKmsKeyId can be either of the following formats:   KMS Key ID:
  \"1234abcd-12ab-34cd-56ef-1234567890ab\"    Amazon Resource Name (ARN) of a KMS Key:
  \"arn:aws:kms:us-west-2:111122223333:key/1234abcd-12ab-34cd-56ef-1234567890ab\"
- `"ModelPolicy"`: The JSON resource-based policy to attach to your custom entity
  recognizer model. You can use this policy to allow another Amazon Web Services account to
  import your custom model. Provide your JSON as a UTF-8 encoded string without line breaks.
  To provide valid JSON for your policy, enclose the attribute names and values in double
  quotes. If the JSON body is also enclosed in double quotes, then you must escape the double
  quotes that are inside the policy:  \"{\"attribute\": \"value\", \"attribute\":
  [\"value\"]}\"  To avoid escaping quotes, you can use single quotes to enclose the policy
  and double quotes to enclose the JSON names and values:  '{\"attribute\": \"value\",
  \"attribute\": [\"value\"]}'
- `"Tags"`: Tags to associate with the entity recognizer. A tag is a key-value pair that
  adds as a metadata to a resource used by Amazon Comprehend. For example, a tag with
  \"Sales\" as the key might be added to a resource to indicate its use by the sales
  department.
- `"VersionName"`: The version name given to the newly created recognizer. Version names
  can be a maximum of 256 characters. Alphanumeric characters, hyphens (-) and underscores
  (_) are allowed. The version name must be unique among all models with the same recognizer
  name in the account/Region.
- `"VolumeKmsKeyId"`: ID for the Amazon Web Services Key Management Service (KMS) key that
  Amazon Comprehend uses to encrypt data on the storage volume attached to the ML compute
  instance(s) that process the analysis job. The VolumeKmsKeyId can be either of the
  following formats:   KMS Key ID: \"1234abcd-12ab-34cd-56ef-1234567890ab\"    Amazon
  Resource Name (ARN) of a KMS Key:
  \"arn:aws:kms:us-west-2:111122223333:key/1234abcd-12ab-34cd-56ef-1234567890ab\"
- `"VpcConfig"`: Configuration parameters for an optional private Virtual Private Cloud
  (VPC) containing the resources you are using for your custom entity recognizer. For more
  information, see Amazon VPC.
"""
function create_entity_recognizer(
    DataAccessRoleArn,
    InputDataConfig,
    LanguageCode,
    RecognizerName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "CreateEntityRecognizer",
        Dict{String,Any}(
            "DataAccessRoleArn" => DataAccessRoleArn,
            "InputDataConfig" => InputDataConfig,
            "LanguageCode" => LanguageCode,
            "RecognizerName" => RecognizerName,
            "ClientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_entity_recognizer(
    DataAccessRoleArn,
    InputDataConfig,
    LanguageCode,
    RecognizerName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "CreateEntityRecognizer",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DataAccessRoleArn" => DataAccessRoleArn,
                    "InputDataConfig" => InputDataConfig,
                    "LanguageCode" => LanguageCode,
                    "RecognizerName" => RecognizerName,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_flywheel(data_access_role_arn, data_lake_s3_uri, flywheel_name)
    create_flywheel(data_access_role_arn, data_lake_s3_uri, flywheel_name, params::Dict{String,<:Any})

A flywheel is an Amazon Web Services resource that orchestrates the ongoing training of a
model for custom classification or custom entity recognition. You can create a flywheel to
start with an existing trained model, or Comprehend can create and train a new model. When
you create the flywheel, Comprehend creates a data lake in your account. The data lake
holds the training data and test data for all versions of the model. To use a flywheel with
an existing trained model, you specify the active model version. Comprehend copies the
model's training data and test data into the flywheel's data lake. To use the flywheel with
a new model, you need to provide a dataset for training data (and optional test data) when
you create the flywheel. For more information about flywheels, see  Flywheel overview in
the Amazon Comprehend Developer Guide.

# Arguments
- `data_access_role_arn`: The Amazon Resource Name (ARN) of the IAM role that grants Amazon
  Comprehend the permissions required to access the flywheel data in the data lake.
- `data_lake_s3_uri`: Enter the S3 location for the data lake. You can specify a new S3
  bucket or a new folder of an existing S3 bucket. The flywheel creates the data lake at this
  location.
- `flywheel_name`: Name for the flywheel.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ActiveModelArn"`: To associate an existing model with the flywheel, specify the Amazon
  Resource Number (ARN) of the model version. Do not set TaskConfig or ModelType if you
  specify an ActiveModelArn.
- `"ClientRequestToken"`: A unique identifier for the request. If you don't set the client
  request token, Amazon Comprehend generates one.
- `"DataSecurityConfig"`: Data security configurations.
- `"ModelType"`: The model type. You need to set ModelType if you are creating a flywheel
  for a new model.
- `"Tags"`: The tags to associate with this flywheel.
- `"TaskConfig"`: Configuration about the model associated with the flywheel. You need to
  set TaskConfig if you are creating a flywheel for a new model.
"""
function create_flywheel(
    DataAccessRoleArn,
    DataLakeS3Uri,
    FlywheelName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "CreateFlywheel",
        Dict{String,Any}(
            "DataAccessRoleArn" => DataAccessRoleArn,
            "DataLakeS3Uri" => DataLakeS3Uri,
            "FlywheelName" => FlywheelName,
            "ClientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_flywheel(
    DataAccessRoleArn,
    DataLakeS3Uri,
    FlywheelName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "CreateFlywheel",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DataAccessRoleArn" => DataAccessRoleArn,
                    "DataLakeS3Uri" => DataLakeS3Uri,
                    "FlywheelName" => FlywheelName,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_document_classifier(document_classifier_arn)
    delete_document_classifier(document_classifier_arn, params::Dict{String,<:Any})

Deletes a previously created document classifier Only those classifiers that are in
terminated states (IN_ERROR, TRAINED) will be deleted. If an active inference job is using
the model, a ResourceInUseException will be returned. This is an asynchronous action that
puts the classifier into a DELETING state, and it is then removed by a background job. Once
removed, the classifier disappears from your account and is no longer available for use.

# Arguments
- `document_classifier_arn`: The Amazon Resource Name (ARN) that identifies the document
  classifier.

"""
function delete_document_classifier(
    DocumentClassifierArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "DeleteDocumentClassifier",
        Dict{String,Any}("DocumentClassifierArn" => DocumentClassifierArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_document_classifier(
    DocumentClassifierArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "DeleteDocumentClassifier",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DocumentClassifierArn" => DocumentClassifierArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_endpoint(endpoint_arn)
    delete_endpoint(endpoint_arn, params::Dict{String,<:Any})

Deletes a model-specific endpoint for a previously-trained custom model. All endpoints must
be deleted in order for the model to be deleted. For information about endpoints, see
Managing endpoints.

# Arguments
- `endpoint_arn`: The Amazon Resource Number (ARN) of the endpoint being deleted.

"""
function delete_endpoint(EndpointArn; aws_config::AbstractAWSConfig=current_aws_config())
    return comprehend(
        "DeleteEndpoint",
        Dict{String,Any}("EndpointArn" => EndpointArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_endpoint(
    EndpointArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "DeleteEndpoint",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("EndpointArn" => EndpointArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_entity_recognizer(entity_recognizer_arn)
    delete_entity_recognizer(entity_recognizer_arn, params::Dict{String,<:Any})

Deletes an entity recognizer. Only those recognizers that are in terminated states
(IN_ERROR, TRAINED) will be deleted. If an active inference job is using the model, a
ResourceInUseException will be returned. This is an asynchronous action that puts the
recognizer into a DELETING state, and it is then removed by a background job. Once removed,
the recognizer disappears from your account and is no longer available for use.

# Arguments
- `entity_recognizer_arn`: The Amazon Resource Name (ARN) that identifies the entity
  recognizer.

"""
function delete_entity_recognizer(
    EntityRecognizerArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "DeleteEntityRecognizer",
        Dict{String,Any}("EntityRecognizerArn" => EntityRecognizerArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_entity_recognizer(
    EntityRecognizerArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "DeleteEntityRecognizer",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("EntityRecognizerArn" => EntityRecognizerArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_flywheel(flywheel_arn)
    delete_flywheel(flywheel_arn, params::Dict{String,<:Any})

Deletes a flywheel. When you delete the flywheel, Amazon Comprehend does not delete the
data lake or the model associated with the flywheel. For more information about flywheels,
see  Flywheel overview in the Amazon Comprehend Developer Guide.

# Arguments
- `flywheel_arn`: The Amazon Resource Number (ARN) of the flywheel to delete.

"""
function delete_flywheel(FlywheelArn; aws_config::AbstractAWSConfig=current_aws_config())
    return comprehend(
        "DeleteFlywheel",
        Dict{String,Any}("FlywheelArn" => FlywheelArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_flywheel(
    FlywheelArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "DeleteFlywheel",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("FlywheelArn" => FlywheelArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_resource_policy(resource_arn)
    delete_resource_policy(resource_arn, params::Dict{String,<:Any})

Deletes a resource-based policy that is attached to a custom model.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the custom model version that has the
  policy to delete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"PolicyRevisionId"`: The revision ID of the policy to delete.
"""
function delete_resource_policy(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "DeleteResourcePolicy",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_resource_policy(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "DeleteResourcePolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_dataset(dataset_arn)
    describe_dataset(dataset_arn, params::Dict{String,<:Any})

Returns information about the dataset that you specify. For more information about
datasets, see  Flywheel overview in the Amazon Comprehend Developer Guide.

# Arguments
- `dataset_arn`: The ARN of the dataset.

"""
function describe_dataset(DatasetArn; aws_config::AbstractAWSConfig=current_aws_config())
    return comprehend(
        "DescribeDataset",
        Dict{String,Any}("DatasetArn" => DatasetArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_dataset(
    DatasetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "DescribeDataset",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DatasetArn" => DatasetArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_document_classification_job(job_id)
    describe_document_classification_job(job_id, params::Dict{String,<:Any})

Gets the properties associated with a document classification job. Use this operation to
get the status of a classification job.

# Arguments
- `job_id`: The identifier that Amazon Comprehend generated for the job. The
  StartDocumentClassificationJob operation returns this identifier in its response.

"""
function describe_document_classification_job(
    JobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "DescribeDocumentClassificationJob",
        Dict{String,Any}("JobId" => JobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_document_classification_job(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "DescribeDocumentClassificationJob",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("JobId" => JobId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_document_classifier(document_classifier_arn)
    describe_document_classifier(document_classifier_arn, params::Dict{String,<:Any})

Gets the properties associated with a document classifier.

# Arguments
- `document_classifier_arn`: The Amazon Resource Name (ARN) that identifies the document
  classifier. The CreateDocumentClassifier operation returns this identifier in its response.

"""
function describe_document_classifier(
    DocumentClassifierArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "DescribeDocumentClassifier",
        Dict{String,Any}("DocumentClassifierArn" => DocumentClassifierArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_document_classifier(
    DocumentClassifierArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "DescribeDocumentClassifier",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DocumentClassifierArn" => DocumentClassifierArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_dominant_language_detection_job(job_id)
    describe_dominant_language_detection_job(job_id, params::Dict{String,<:Any})

Gets the properties associated with a dominant language detection job. Use this operation
to get the status of a detection job.

# Arguments
- `job_id`: The identifier that Amazon Comprehend generated for the job. The
  StartDominantLanguageDetectionJob operation returns this identifier in its response.

"""
function describe_dominant_language_detection_job(
    JobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "DescribeDominantLanguageDetectionJob",
        Dict{String,Any}("JobId" => JobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_dominant_language_detection_job(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "DescribeDominantLanguageDetectionJob",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("JobId" => JobId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_endpoint(endpoint_arn)
    describe_endpoint(endpoint_arn, params::Dict{String,<:Any})

Gets the properties associated with a specific endpoint. Use this operation to get the
status of an endpoint. For information about endpoints, see Managing endpoints.

# Arguments
- `endpoint_arn`: The Amazon Resource Number (ARN) of the endpoint being described.

"""
function describe_endpoint(EndpointArn; aws_config::AbstractAWSConfig=current_aws_config())
    return comprehend(
        "DescribeEndpoint",
        Dict{String,Any}("EndpointArn" => EndpointArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_endpoint(
    EndpointArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "DescribeEndpoint",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("EndpointArn" => EndpointArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_entities_detection_job(job_id)
    describe_entities_detection_job(job_id, params::Dict{String,<:Any})

Gets the properties associated with an entities detection job. Use this operation to get
the status of a detection job.

# Arguments
- `job_id`: The identifier that Amazon Comprehend generated for the job. The
  StartEntitiesDetectionJob operation returns this identifier in its response.

"""
function describe_entities_detection_job(
    JobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "DescribeEntitiesDetectionJob",
        Dict{String,Any}("JobId" => JobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_entities_detection_job(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "DescribeEntitiesDetectionJob",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("JobId" => JobId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_entity_recognizer(entity_recognizer_arn)
    describe_entity_recognizer(entity_recognizer_arn, params::Dict{String,<:Any})

Provides details about an entity recognizer including status, S3 buckets containing
training data, recognizer metadata, metrics, and so on.

# Arguments
- `entity_recognizer_arn`: The Amazon Resource Name (ARN) that identifies the entity
  recognizer.

"""
function describe_entity_recognizer(
    EntityRecognizerArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "DescribeEntityRecognizer",
        Dict{String,Any}("EntityRecognizerArn" => EntityRecognizerArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_entity_recognizer(
    EntityRecognizerArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "DescribeEntityRecognizer",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("EntityRecognizerArn" => EntityRecognizerArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_events_detection_job(job_id)
    describe_events_detection_job(job_id, params::Dict{String,<:Any})

Gets the status and details of an events detection job.

# Arguments
- `job_id`: The identifier of the events detection job.

"""
function describe_events_detection_job(
    JobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "DescribeEventsDetectionJob",
        Dict{String,Any}("JobId" => JobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_events_detection_job(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "DescribeEventsDetectionJob",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("JobId" => JobId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_flywheel(flywheel_arn)
    describe_flywheel(flywheel_arn, params::Dict{String,<:Any})

Provides configuration information about the flywheel. For more information about
flywheels, see  Flywheel overview in the Amazon Comprehend Developer Guide.

# Arguments
- `flywheel_arn`: The Amazon Resource Number (ARN) of the flywheel.

"""
function describe_flywheel(FlywheelArn; aws_config::AbstractAWSConfig=current_aws_config())
    return comprehend(
        "DescribeFlywheel",
        Dict{String,Any}("FlywheelArn" => FlywheelArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_flywheel(
    FlywheelArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "DescribeFlywheel",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("FlywheelArn" => FlywheelArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_flywheel_iteration(flywheel_arn, flywheel_iteration_id)
    describe_flywheel_iteration(flywheel_arn, flywheel_iteration_id, params::Dict{String,<:Any})

Retrieve the configuration properties of a flywheel iteration. For more information about
flywheels, see  Flywheel overview in the Amazon Comprehend Developer Guide.

# Arguments
- `flywheel_arn`:
- `flywheel_iteration_id`:

"""
function describe_flywheel_iteration(
    FlywheelArn, FlywheelIterationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "DescribeFlywheelIteration",
        Dict{String,Any}(
            "FlywheelArn" => FlywheelArn, "FlywheelIterationId" => FlywheelIterationId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_flywheel_iteration(
    FlywheelArn,
    FlywheelIterationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "DescribeFlywheelIteration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "FlywheelArn" => FlywheelArn,
                    "FlywheelIterationId" => FlywheelIterationId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_key_phrases_detection_job(job_id)
    describe_key_phrases_detection_job(job_id, params::Dict{String,<:Any})

Gets the properties associated with a key phrases detection job. Use this operation to get
the status of a detection job.

# Arguments
- `job_id`: The identifier that Amazon Comprehend generated for the job. The
  StartKeyPhrasesDetectionJob operation returns this identifier in its response.

"""
function describe_key_phrases_detection_job(
    JobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "DescribeKeyPhrasesDetectionJob",
        Dict{String,Any}("JobId" => JobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_key_phrases_detection_job(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "DescribeKeyPhrasesDetectionJob",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("JobId" => JobId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_pii_entities_detection_job(job_id)
    describe_pii_entities_detection_job(job_id, params::Dict{String,<:Any})

Gets the properties associated with a PII entities detection job. For example, you can use
this operation to get the job status.

# Arguments
- `job_id`: The identifier that Amazon Comprehend generated for the job. The operation
  returns this identifier in its response.

"""
function describe_pii_entities_detection_job(
    JobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "DescribePiiEntitiesDetectionJob",
        Dict{String,Any}("JobId" => JobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_pii_entities_detection_job(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "DescribePiiEntitiesDetectionJob",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("JobId" => JobId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_resource_policy(resource_arn)
    describe_resource_policy(resource_arn, params::Dict{String,<:Any})

Gets the details of a resource-based policy that is attached to a custom model, including
the JSON body of the policy.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the custom model version that has the
  resource policy.

"""
function describe_resource_policy(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "DescribeResourcePolicy",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_resource_policy(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "DescribeResourcePolicy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_sentiment_detection_job(job_id)
    describe_sentiment_detection_job(job_id, params::Dict{String,<:Any})

Gets the properties associated with a sentiment detection job. Use this operation to get
the status of a detection job.

# Arguments
- `job_id`: The identifier that Amazon Comprehend generated for the job. The operation
  returns this identifier in its response.

"""
function describe_sentiment_detection_job(
    JobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "DescribeSentimentDetectionJob",
        Dict{String,Any}("JobId" => JobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_sentiment_detection_job(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "DescribeSentimentDetectionJob",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("JobId" => JobId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_targeted_sentiment_detection_job(job_id)
    describe_targeted_sentiment_detection_job(job_id, params::Dict{String,<:Any})

Gets the properties associated with a targeted sentiment detection job. Use this operation
to get the status of the job.

# Arguments
- `job_id`: The identifier that Amazon Comprehend generated for the job. The
  StartTargetedSentimentDetectionJob operation returns this identifier in its response.

"""
function describe_targeted_sentiment_detection_job(
    JobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "DescribeTargetedSentimentDetectionJob",
        Dict{String,Any}("JobId" => JobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_targeted_sentiment_detection_job(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "DescribeTargetedSentimentDetectionJob",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("JobId" => JobId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_topics_detection_job(job_id)
    describe_topics_detection_job(job_id, params::Dict{String,<:Any})

Gets the properties associated with a topic detection job. Use this operation to get the
status of a detection job.

# Arguments
- `job_id`: The identifier assigned by the user to the detection job.

"""
function describe_topics_detection_job(
    JobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "DescribeTopicsDetectionJob",
        Dict{String,Any}("JobId" => JobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_topics_detection_job(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "DescribeTopicsDetectionJob",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("JobId" => JobId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    detect_dominant_language(text)
    detect_dominant_language(text, params::Dict{String,<:Any})

Determines the dominant language of the input text. For a list of languages that Amazon
Comprehend can detect, see Amazon Comprehend Supported Languages.

# Arguments
- `text`: A UTF-8 text string. The string must contain at least 20 characters. The maximum
  string size is 100 KB.

"""
function detect_dominant_language(Text; aws_config::AbstractAWSConfig=current_aws_config())
    return comprehend(
        "DetectDominantLanguage",
        Dict{String,Any}("Text" => Text);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function detect_dominant_language(
    Text, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "DetectDominantLanguage",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Text" => Text), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    detect_entities()
    detect_entities(params::Dict{String,<:Any})

Detects named entities in input text when you use the pre-trained model. Detects custom
entities if you have a custom entity recognition model.   When detecting named entities
using the pre-trained model, use plain text as the input. For more information about named
entities, see Entities in the Comprehend Developer Guide. When you use a custom entity
recognition model, you can input plain text or you can upload a single-page input document
(text, PDF, Word, or image).  If the system detects errors while processing a page in the
input document, the API response includes an entry in Errors for each error.  If the system
detects a document-level error in your input document, the API returns an
InvalidRequestException error response. For details about this exception, see  Errors in
semi-structured documents in the Comprehend Developer Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Bytes"`: This field applies only when you use a custom entity recognition model that
  was trained with PDF annotations. For other cases, enter your text input in the Text field.
   Use the Bytes parameter to input a text, PDF, Word or image file. Using a plain-text file
  in the Bytes parameter is equivelent to using the Text parameter (the Entities field in the
  response is identical). You can also use the Bytes parameter to input an Amazon Textract
  DetectDocumentText or AnalyzeDocument output file. Provide the input document as a sequence
  of base64-encoded bytes. If your code uses an Amazon Web Services SDK to detect entities,
  the SDK may encode the document file bytes for you.  The maximum length of this field
  depends on the input document type. For details, see  Inputs for real-time custom analysis
  in the Comprehend Developer Guide.  If you use the Bytes parameter, do not use the Text
  parameter.
- `"DocumentReaderConfig"`: Provides configuration parameters to override the default
  actions for extracting text from PDF documents and image files.
- `"EndpointArn"`: The Amazon Resource Name of an endpoint that is associated with a custom
  entity recognition model. Provide an endpoint if you want to detect entities by using your
  own custom model instead of the default model that is used by Amazon Comprehend. If you
  specify an endpoint, Amazon Comprehend uses the language of your custom model, and it
  ignores any language code that you provide in your request. For information about
  endpoints, see Managing endpoints.
- `"LanguageCode"`: The language of the input documents. You can specify any of the primary
  languages supported by Amazon Comprehend. If your request includes the endpoint for a
  custom entity recognition model, Amazon Comprehend uses the language of your custom model,
  and it ignores any language code that you specify here. All input documents must be in the
  same language.
- `"Text"`: A UTF-8 text string. The maximum string size is 100 KB. If you enter text using
  this parameter, do not use the Bytes parameter.
"""
function detect_entities(; aws_config::AbstractAWSConfig=current_aws_config())
    return comprehend(
        "DetectEntities"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function detect_entities(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "DetectEntities", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    detect_key_phrases(language_code, text)
    detect_key_phrases(language_code, text, params::Dict{String,<:Any})

Detects the key noun phrases found in the text.

# Arguments
- `language_code`: The language of the input documents. You can specify any of the primary
  languages supported by Amazon Comprehend. All documents must be in the same language.
- `text`: A UTF-8 text string. The string must contain less than 100 KB of UTF-8 encoded
  characters.

"""
function detect_key_phrases(
    LanguageCode, Text; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "DetectKeyPhrases",
        Dict{String,Any}("LanguageCode" => LanguageCode, "Text" => Text);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function detect_key_phrases(
    LanguageCode,
    Text,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "DetectKeyPhrases",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("LanguageCode" => LanguageCode, "Text" => Text),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    detect_pii_entities(language_code, text)
    detect_pii_entities(language_code, text, params::Dict{String,<:Any})

Inspects the input text for entities that contain personally identifiable information (PII)
and returns information about them.

# Arguments
- `language_code`: The language of the input text. Enter the language code for English (en)
  or Spanish (es).
- `text`: A UTF-8 text string. The maximum string size is 100 KB.

"""
function detect_pii_entities(
    LanguageCode, Text; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "DetectPiiEntities",
        Dict{String,Any}("LanguageCode" => LanguageCode, "Text" => Text);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function detect_pii_entities(
    LanguageCode,
    Text,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "DetectPiiEntities",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("LanguageCode" => LanguageCode, "Text" => Text),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    detect_sentiment(language_code, text)
    detect_sentiment(language_code, text, params::Dict{String,<:Any})

Inspects text and returns an inference of the prevailing sentiment (POSITIVE, NEUTRAL,
MIXED, or NEGATIVE).

# Arguments
- `language_code`: The language of the input documents. You can specify any of the primary
  languages supported by Amazon Comprehend. All documents must be in the same language.
- `text`: A UTF-8 text string. The maximum string size is 5 KB.

"""
function detect_sentiment(
    LanguageCode, Text; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "DetectSentiment",
        Dict{String,Any}("LanguageCode" => LanguageCode, "Text" => Text);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function detect_sentiment(
    LanguageCode,
    Text,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "DetectSentiment",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("LanguageCode" => LanguageCode, "Text" => Text),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    detect_syntax(language_code, text)
    detect_syntax(language_code, text, params::Dict{String,<:Any})

Inspects text for syntax and the part of speech of words in the document. For more
information, see Syntax in the Comprehend Developer Guide.

# Arguments
- `language_code`: The language code of the input documents. You can specify any of the
  following languages supported by Amazon Comprehend: German (\"de\"), English (\"en\"),
  Spanish (\"es\"), French (\"fr\"), Italian (\"it\"), or Portuguese (\"pt\").
- `text`: A UTF-8 string. The maximum string size is 5 KB.

"""
function detect_syntax(
    LanguageCode, Text; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "DetectSyntax",
        Dict{String,Any}("LanguageCode" => LanguageCode, "Text" => Text);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function detect_syntax(
    LanguageCode,
    Text,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "DetectSyntax",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("LanguageCode" => LanguageCode, "Text" => Text),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    detect_targeted_sentiment(language_code, text)
    detect_targeted_sentiment(language_code, text, params::Dict{String,<:Any})

Inspects the input text and returns a sentiment analysis for each entity identified in the
text. For more information about targeted sentiment, see Targeted sentiment in the Amazon
Comprehend Developer Guide.

# Arguments
- `language_code`: The language of the input documents. Currently, English is the only
  supported language.
- `text`: A UTF-8 text string. The maximum string length is 5 KB.

"""
function detect_targeted_sentiment(
    LanguageCode, Text; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "DetectTargetedSentiment",
        Dict{String,Any}("LanguageCode" => LanguageCode, "Text" => Text);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function detect_targeted_sentiment(
    LanguageCode,
    Text,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "DetectTargetedSentiment",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("LanguageCode" => LanguageCode, "Text" => Text),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    detect_toxic_content(language_code, text_segments)
    detect_toxic_content(language_code, text_segments, params::Dict{String,<:Any})

Performs toxicity analysis on the list of text strings that you provide as input. The API
response contains a results list that matches the size of the input list. For more
information about toxicity detection, see Toxicity detection in the Amazon Comprehend
Developer Guide.

# Arguments
- `language_code`: The language of the input text. Currently, English is the only supported
  language.
- `text_segments`: A list of up to 10 text strings. Each string has a maximum size of 1 KB,
  and the maximum size of the list is 10 KB.

"""
function detect_toxic_content(
    LanguageCode, TextSegments; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "DetectToxicContent",
        Dict{String,Any}("LanguageCode" => LanguageCode, "TextSegments" => TextSegments);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function detect_toxic_content(
    LanguageCode,
    TextSegments,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "DetectToxicContent",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "LanguageCode" => LanguageCode, "TextSegments" => TextSegments
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    import_model(source_model_arn)
    import_model(source_model_arn, params::Dict{String,<:Any})

Creates a new custom model that replicates a source custom model that you import. The
source model can be in your Amazon Web Services account or another one. If the source model
is in another Amazon Web Services account, then it must have a resource-based policy that
authorizes you to import it. The source model must be in the same Amazon Web Services
Region that you're using when you import. You can't import a model that's in a different
Region.

# Arguments
- `source_model_arn`: The Amazon Resource Name (ARN) of the custom model to import.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DataAccessRoleArn"`: The Amazon Resource Name (ARN) of the IAM role that grants Amazon
  Comprehend permission to use Amazon Key Management Service (KMS) to encrypt or decrypt the
  custom model.
- `"ModelKmsKeyId"`: ID for the KMS key that Amazon Comprehend uses to encrypt trained
  custom models. The ModelKmsKeyId can be either of the following formats:   KMS Key ID:
  \"1234abcd-12ab-34cd-56ef-1234567890ab\"    Amazon Resource Name (ARN) of a KMS Key:
  \"arn:aws:kms:us-west-2:111122223333:key/1234abcd-12ab-34cd-56ef-1234567890ab\"
- `"ModelName"`: The name to assign to the custom model that is created in Amazon
  Comprehend by this import.
- `"Tags"`: Tags to associate with the custom model that is created by this import. A tag
  is a key-value pair that adds as a metadata to a resource used by Amazon Comprehend. For
  example, a tag with \"Sales\" as the key might be added to a resource to indicate its use
  by the sales department.
- `"VersionName"`: The version name given to the custom model that is created by this
  import. Version names can have a maximum of 256 characters. Alphanumeric characters,
  hyphens (-) and underscores (_) are allowed. The version name must be unique among all
  models with the same classifier name in the account/Region.
"""
function import_model(SourceModelArn; aws_config::AbstractAWSConfig=current_aws_config())
    return comprehend(
        "ImportModel",
        Dict{String,Any}("SourceModelArn" => SourceModelArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function import_model(
    SourceModelArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "ImportModel",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("SourceModelArn" => SourceModelArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_datasets()
    list_datasets(params::Dict{String,<:Any})

List the datasets that you have configured in this Region. For more information about
datasets, see  Flywheel overview in the Amazon Comprehend Developer Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filter"`: Filters the datasets to be returned in the response.
- `"FlywheelArn"`: The Amazon Resource Number (ARN) of the flywheel.
- `"MaxResults"`: Maximum number of results to return in a response. The default is 100.
- `"NextToken"`: Identifies the next page of results to return.
"""
function list_datasets(; aws_config::AbstractAWSConfig=current_aws_config())
    return comprehend(
        "ListDatasets"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_datasets(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "ListDatasets", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_document_classification_jobs()
    list_document_classification_jobs(params::Dict{String,<:Any})

Gets a list of the documentation classification jobs that you have submitted.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filter"`: Filters the jobs that are returned. You can filter jobs on their names,
  status, or the date and time that they were submitted. You can only set one filter at a
  time.
- `"MaxResults"`: The maximum number of results to return in each page. The default is 100.
- `"NextToken"`: Identifies the next page of results to return.
"""
function list_document_classification_jobs(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "ListDocumentClassificationJobs";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_document_classification_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "ListDocumentClassificationJobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_document_classifier_summaries()
    list_document_classifier_summaries(params::Dict{String,<:Any})

Gets a list of summaries of the document classifiers that you have created

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to return on each page. The default is 100.
- `"NextToken"`: Identifies the next page of results to return.
"""
function list_document_classifier_summaries(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "ListDocumentClassifierSummaries";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_document_classifier_summaries(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "ListDocumentClassifierSummaries",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_document_classifiers()
    list_document_classifiers(params::Dict{String,<:Any})

Gets a list of the document classifiers that you have created.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filter"`: Filters the jobs that are returned. You can filter jobs on their name,
  status, or the date and time that they were submitted. You can only set one filter at a
  time.
- `"MaxResults"`: The maximum number of results to return in each page. The default is 100.
- `"NextToken"`: Identifies the next page of results to return.
"""
function list_document_classifiers(; aws_config::AbstractAWSConfig=current_aws_config())
    return comprehend(
        "ListDocumentClassifiers"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_document_classifiers(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "ListDocumentClassifiers",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_dominant_language_detection_jobs()
    list_dominant_language_detection_jobs(params::Dict{String,<:Any})

Gets a list of the dominant language detection jobs that you have submitted.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filter"`: Filters that jobs that are returned. You can filter jobs on their name,
  status, or the date and time that they were submitted. You can only set one filter at a
  time.
- `"MaxResults"`: The maximum number of results to return in each page. The default is 100.
- `"NextToken"`: Identifies the next page of results to return.
"""
function list_dominant_language_detection_jobs(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "ListDominantLanguageDetectionJobs";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_dominant_language_detection_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "ListDominantLanguageDetectionJobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_endpoints()
    list_endpoints(params::Dict{String,<:Any})

Gets a list of all existing endpoints that you've created. For information about endpoints,
see Managing endpoints.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filter"`: Filters the endpoints that are returned. You can filter endpoints on their
  name, model, status, or the date and time that they were created. You can only set one
  filter at a time.
- `"MaxResults"`: The maximum number of results to return in each page. The default is 100.
- `"NextToken"`: Identifies the next page of results to return.
"""
function list_endpoints(; aws_config::AbstractAWSConfig=current_aws_config())
    return comprehend(
        "ListEndpoints"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_endpoints(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "ListEndpoints", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_entities_detection_jobs()
    list_entities_detection_jobs(params::Dict{String,<:Any})

Gets a list of the entity detection jobs that you have submitted.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filter"`: Filters the jobs that are returned. You can filter jobs on their name,
  status, or the date and time that they were submitted. You can only set one filter at a
  time.
- `"MaxResults"`: The maximum number of results to return in each page. The default is 100.
- `"NextToken"`: Identifies the next page of results to return.
"""
function list_entities_detection_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return comprehend(
        "ListEntitiesDetectionJobs"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_entities_detection_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "ListEntitiesDetectionJobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_entity_recognizer_summaries()
    list_entity_recognizer_summaries(params::Dict{String,<:Any})

Gets a list of summaries for the entity recognizers that you have created.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to return on each page. The default is 100.
- `"NextToken"`: Identifies the next page of results to return.
"""
function list_entity_recognizer_summaries(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "ListEntityRecognizerSummaries";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_entity_recognizer_summaries(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "ListEntityRecognizerSummaries",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_entity_recognizers()
    list_entity_recognizers(params::Dict{String,<:Any})

Gets a list of the properties of all entity recognizers that you created, including
recognizers currently in training. Allows you to filter the list of recognizers based on
criteria such as status and submission time. This call returns up to 500 entity recognizers
in the list, with a default number of 100 recognizers in the list. The results of this list
are not in any particular order. Please get the list and sort locally if needed.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filter"`: Filters the list of entities returned. You can filter on Status,
  SubmitTimeBefore, or SubmitTimeAfter. You can only set one filter at a time.
- `"MaxResults"`:  The maximum number of results to return on each page. The default is 100.
- `"NextToken"`: Identifies the next page of results to return.
"""
function list_entity_recognizers(; aws_config::AbstractAWSConfig=current_aws_config())
    return comprehend(
        "ListEntityRecognizers"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_entity_recognizers(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "ListEntityRecognizers",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_events_detection_jobs()
    list_events_detection_jobs(params::Dict{String,<:Any})

Gets a list of the events detection jobs that you have submitted.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filter"`: Filters the jobs that are returned. You can filter jobs on their name,
  status, or the date and time that they were submitted. You can only set one filter at a
  time.
- `"MaxResults"`: The maximum number of results to return in each page.
- `"NextToken"`: Identifies the next page of results to return.
"""
function list_events_detection_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return comprehend(
        "ListEventsDetectionJobs"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_events_detection_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "ListEventsDetectionJobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_flywheel_iteration_history(flywheel_arn)
    list_flywheel_iteration_history(flywheel_arn, params::Dict{String,<:Any})

Information about the history of a flywheel iteration. For more information about
flywheels, see  Flywheel overview in the Amazon Comprehend Developer Guide.

# Arguments
- `flywheel_arn`: The ARN of the flywheel.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filter"`: Filter the flywheel iteration history based on creation time.
- `"MaxResults"`: Maximum number of iteration history results to return
- `"NextToken"`: Next token
"""
function list_flywheel_iteration_history(
    FlywheelArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "ListFlywheelIterationHistory",
        Dict{String,Any}("FlywheelArn" => FlywheelArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_flywheel_iteration_history(
    FlywheelArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "ListFlywheelIterationHistory",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("FlywheelArn" => FlywheelArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_flywheels()
    list_flywheels(params::Dict{String,<:Any})

Gets a list of the flywheels that you have created.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filter"`: Filters the flywheels that are returned. You can filter flywheels on their
  status, or the date and time that they were submitted. You can only set one filter at a
  time.
- `"MaxResults"`: Maximum number of results to return in a response. The default is 100.
- `"NextToken"`: Identifies the next page of results to return.
"""
function list_flywheels(; aws_config::AbstractAWSConfig=current_aws_config())
    return comprehend(
        "ListFlywheels"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_flywheels(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "ListFlywheels", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_key_phrases_detection_jobs()
    list_key_phrases_detection_jobs(params::Dict{String,<:Any})

Get a list of key phrase detection jobs that you have submitted.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filter"`: Filters the jobs that are returned. You can filter jobs on their name,
  status, or the date and time that they were submitted. You can only set one filter at a
  time.
- `"MaxResults"`: The maximum number of results to return in each page. The default is 100.
- `"NextToken"`: Identifies the next page of results to return.
"""
function list_key_phrases_detection_jobs(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "ListKeyPhrasesDetectionJobs";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_key_phrases_detection_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "ListKeyPhrasesDetectionJobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_pii_entities_detection_jobs()
    list_pii_entities_detection_jobs(params::Dict{String,<:Any})

Gets a list of the PII entity detection jobs that you have submitted.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filter"`: Filters the jobs that are returned. You can filter jobs on their name,
  status, or the date and time that they were submitted. You can only set one filter at a
  time.
- `"MaxResults"`: The maximum number of results to return in each page.
- `"NextToken"`: Identifies the next page of results to return.
"""
function list_pii_entities_detection_jobs(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "ListPiiEntitiesDetectionJobs";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_pii_entities_detection_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "ListPiiEntitiesDetectionJobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_sentiment_detection_jobs()
    list_sentiment_detection_jobs(params::Dict{String,<:Any})

Gets a list of sentiment detection jobs that you have submitted.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filter"`: Filters the jobs that are returned. You can filter jobs on their name,
  status, or the date and time that they were submitted. You can only set one filter at a
  time.
- `"MaxResults"`: The maximum number of results to return in each page. The default is 100.
- `"NextToken"`: Identifies the next page of results to return.
"""
function list_sentiment_detection_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return comprehend(
        "ListSentimentDetectionJobs"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_sentiment_detection_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "ListSentimentDetectionJobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists all tags associated with a given Amazon Comprehend resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the given Amazon Comprehend resource
  you are querying.

"""
function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "ListTagsForResource",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_targeted_sentiment_detection_jobs()
    list_targeted_sentiment_detection_jobs(params::Dict{String,<:Any})

Gets a list of targeted sentiment detection jobs that you have submitted.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filter"`: Filters the jobs that are returned. You can filter jobs on their name,
  status, or the date and time that they were submitted. You can only set one filter at a
  time.
- `"MaxResults"`: The maximum number of results to return in each page. The default is 100.
- `"NextToken"`: Identifies the next page of results to return.
"""
function list_targeted_sentiment_detection_jobs(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "ListTargetedSentimentDetectionJobs";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_targeted_sentiment_detection_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "ListTargetedSentimentDetectionJobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_topics_detection_jobs()
    list_topics_detection_jobs(params::Dict{String,<:Any})

Gets a list of the topic detection jobs that you have submitted.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filter"`: Filters the jobs that are returned. Jobs can be filtered on their name,
  status, or the date and time that they were submitted. You can set only one filter at a
  time.
- `"MaxResults"`: The maximum number of results to return in each page. The default is 100.
- `"NextToken"`: Identifies the next page of results to return.
"""
function list_topics_detection_jobs(; aws_config::AbstractAWSConfig=current_aws_config())
    return comprehend(
        "ListTopicsDetectionJobs"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_topics_detection_jobs(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "ListTopicsDetectionJobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_resource_policy(resource_arn, resource_policy)
    put_resource_policy(resource_arn, resource_policy, params::Dict{String,<:Any})

Attaches a resource-based policy to a custom model. You can use this policy to authorize an
entity in another Amazon Web Services account to import the custom model, which replicates
it in Amazon Comprehend in their account.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the custom model to attach the policy
  to.
- `resource_policy`: The JSON resource-based policy to attach to your custom model. Provide
  your JSON as a UTF-8 encoded string without line breaks. To provide valid JSON for your
  policy, enclose the attribute names and values in double quotes. If the JSON body is also
  enclosed in double quotes, then you must escape the double quotes that are inside the
  policy:  \"{\"attribute\": \"value\", \"attribute\": [\"value\"]}\"  To avoid escaping
  quotes, you can use single quotes to enclose the policy and double quotes to enclose the
  JSON names and values:  '{\"attribute\": \"value\", \"attribute\": [\"value\"]}'

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"PolicyRevisionId"`: The revision ID that Amazon Comprehend assigned to the policy that
  you are updating. If you are creating a new policy that has no prior version, don't use
  this parameter. Amazon Comprehend creates the revision ID for you.
"""
function put_resource_policy(
    ResourceArn, ResourcePolicy; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "PutResourcePolicy",
        Dict{String,Any}("ResourceArn" => ResourceArn, "ResourcePolicy" => ResourcePolicy);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_resource_policy(
    ResourceArn,
    ResourcePolicy,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "PutResourcePolicy",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ResourceArn" => ResourceArn, "ResourcePolicy" => ResourcePolicy
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_document_classification_job(data_access_role_arn, input_data_config, output_data_config)
    start_document_classification_job(data_access_role_arn, input_data_config, output_data_config, params::Dict{String,<:Any})

Starts an asynchronous document classification job using a custom classification model. Use
the DescribeDocumentClassificationJob operation to track the progress of the job.

# Arguments
- `data_access_role_arn`: The Amazon Resource Name (ARN) of the IAM role that grants Amazon
  Comprehend read access to your input data.
- `input_data_config`: Specifies the format and location of the input data for the job.
- `output_data_config`: Specifies where to send the output files.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: A unique identifier for the request. If you do not set the client
  request token, Amazon Comprehend generates one.
- `"DocumentClassifierArn"`: The Amazon Resource Name (ARN) of the document classifier to
  use to process the job.
- `"FlywheelArn"`: The Amazon Resource Number (ARN) of the flywheel associated with the
  model to use.
- `"JobName"`: The identifier of the job.
- `"Tags"`: Tags to associate with the document classification job. A tag is a key-value
  pair that adds metadata to a resource used by Amazon Comprehend. For example, a tag with
  \"Sales\" as the key might be added to a resource to indicate its use by the sales
  department.
- `"VolumeKmsKeyId"`: ID for the Amazon Web Services Key Management Service (KMS) key that
  Amazon Comprehend uses to encrypt data on the storage volume attached to the ML compute
  instance(s) that process the analysis job. The VolumeKmsKeyId can be either of the
  following formats:   KMS Key ID: \"1234abcd-12ab-34cd-56ef-1234567890ab\"    Amazon
  Resource Name (ARN) of a KMS Key:
  \"arn:aws:kms:us-west-2:111122223333:key/1234abcd-12ab-34cd-56ef-1234567890ab\"
- `"VpcConfig"`: Configuration parameters for an optional private Virtual Private Cloud
  (VPC) containing the resources you are using for your document classification job. For more
  information, see Amazon VPC.
"""
function start_document_classification_job(
    DataAccessRoleArn,
    InputDataConfig,
    OutputDataConfig;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "StartDocumentClassificationJob",
        Dict{String,Any}(
            "DataAccessRoleArn" => DataAccessRoleArn,
            "InputDataConfig" => InputDataConfig,
            "OutputDataConfig" => OutputDataConfig,
            "ClientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_document_classification_job(
    DataAccessRoleArn,
    InputDataConfig,
    OutputDataConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "StartDocumentClassificationJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DataAccessRoleArn" => DataAccessRoleArn,
                    "InputDataConfig" => InputDataConfig,
                    "OutputDataConfig" => OutputDataConfig,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_dominant_language_detection_job(data_access_role_arn, input_data_config, output_data_config)
    start_dominant_language_detection_job(data_access_role_arn, input_data_config, output_data_config, params::Dict{String,<:Any})

Starts an asynchronous dominant language detection job for a collection of documents. Use
the operation to track the status of a job.

# Arguments
- `data_access_role_arn`: The Amazon Resource Name (ARN) of the IAM role that grants Amazon
  Comprehend read access to your input data. For more information, see Role-based permissions.
- `input_data_config`: Specifies the format and location of the input data for the job.
- `output_data_config`: Specifies where to send the output files.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: A unique identifier for the request. If you do not set the client
  request token, Amazon Comprehend generates one.
- `"JobName"`: An identifier for the job.
- `"Tags"`: Tags to associate with the dominant language detection job. A tag is a
  key-value pair that adds metadata to a resource used by Amazon Comprehend. For example, a
  tag with \"Sales\" as the key might be added to a resource to indicate its use by the sales
  department.
- `"VolumeKmsKeyId"`: ID for the Amazon Web Services Key Management Service (KMS) key that
  Amazon Comprehend uses to encrypt data on the storage volume attached to the ML compute
  instance(s) that process the analysis job. The VolumeKmsKeyId can be either of the
  following formats:   KMS Key ID: \"1234abcd-12ab-34cd-56ef-1234567890ab\"    Amazon
  Resource Name (ARN) of a KMS Key:
  \"arn:aws:kms:us-west-2:111122223333:key/1234abcd-12ab-34cd-56ef-1234567890ab\"
- `"VpcConfig"`: Configuration parameters for an optional private Virtual Private Cloud
  (VPC) containing the resources you are using for your dominant language detection job. For
  more information, see Amazon VPC.
"""
function start_dominant_language_detection_job(
    DataAccessRoleArn,
    InputDataConfig,
    OutputDataConfig;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "StartDominantLanguageDetectionJob",
        Dict{String,Any}(
            "DataAccessRoleArn" => DataAccessRoleArn,
            "InputDataConfig" => InputDataConfig,
            "OutputDataConfig" => OutputDataConfig,
            "ClientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_dominant_language_detection_job(
    DataAccessRoleArn,
    InputDataConfig,
    OutputDataConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "StartDominantLanguageDetectionJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DataAccessRoleArn" => DataAccessRoleArn,
                    "InputDataConfig" => InputDataConfig,
                    "OutputDataConfig" => OutputDataConfig,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_entities_detection_job(data_access_role_arn, input_data_config, language_code, output_data_config)
    start_entities_detection_job(data_access_role_arn, input_data_config, language_code, output_data_config, params::Dict{String,<:Any})

Starts an asynchronous entity detection job for a collection of documents. Use the
operation to track the status of a job. This API can be used for either standard entity
detection or custom entity recognition. In order to be used for custom entity recognition,
the optional EntityRecognizerArn must be used in order to provide access to the recognizer
being used to detect the custom entity.

# Arguments
- `data_access_role_arn`: The Amazon Resource Name (ARN) of the IAM role that grants Amazon
  Comprehend read access to your input data. For more information, see Role-based permissions.
- `input_data_config`: Specifies the format and location of the input data for the job.
- `language_code`: The language of the input documents. All documents must be in the same
  language. You can specify any of the languages supported by Amazon Comprehend. If custom
  entities recognition is used, this parameter is ignored and the language used for training
  the model is used instead.
- `output_data_config`: Specifies where to send the output files.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: A unique identifier for the request. If you don't set the client
  request token, Amazon Comprehend generates one.
- `"EntityRecognizerArn"`: The Amazon Resource Name (ARN) that identifies the specific
  entity recognizer to be used by the StartEntitiesDetectionJob. This ARN is optional and is
  only used for a custom entity recognition job.
- `"FlywheelArn"`: The Amazon Resource Number (ARN) of the flywheel associated with the
  model to use.
- `"JobName"`: The identifier of the job.
- `"Tags"`: Tags to associate with the entities detection job. A tag is a key-value pair
  that adds metadata to a resource used by Amazon Comprehend. For example, a tag with
  \"Sales\" as the key might be added to a resource to indicate its use by the sales
  department.
- `"VolumeKmsKeyId"`: ID for the Amazon Web Services Key Management Service (KMS) key that
  Amazon Comprehend uses to encrypt data on the storage volume attached to the ML compute
  instance(s) that process the analysis job. The VolumeKmsKeyId can be either of the
  following formats:   KMS Key ID: \"1234abcd-12ab-34cd-56ef-1234567890ab\"    Amazon
  Resource Name (ARN) of a KMS Key:
  \"arn:aws:kms:us-west-2:111122223333:key/1234abcd-12ab-34cd-56ef-1234567890ab\"
- `"VpcConfig"`: Configuration parameters for an optional private Virtual Private Cloud
  (VPC) containing the resources you are using for your entity detection job. For more
  information, see Amazon VPC.
"""
function start_entities_detection_job(
    DataAccessRoleArn,
    InputDataConfig,
    LanguageCode,
    OutputDataConfig;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "StartEntitiesDetectionJob",
        Dict{String,Any}(
            "DataAccessRoleArn" => DataAccessRoleArn,
            "InputDataConfig" => InputDataConfig,
            "LanguageCode" => LanguageCode,
            "OutputDataConfig" => OutputDataConfig,
            "ClientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_entities_detection_job(
    DataAccessRoleArn,
    InputDataConfig,
    LanguageCode,
    OutputDataConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "StartEntitiesDetectionJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DataAccessRoleArn" => DataAccessRoleArn,
                    "InputDataConfig" => InputDataConfig,
                    "LanguageCode" => LanguageCode,
                    "OutputDataConfig" => OutputDataConfig,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_events_detection_job(data_access_role_arn, input_data_config, language_code, output_data_config, target_event_types)
    start_events_detection_job(data_access_role_arn, input_data_config, language_code, output_data_config, target_event_types, params::Dict{String,<:Any})

Starts an asynchronous event detection job for a collection of documents.

# Arguments
- `data_access_role_arn`: The Amazon Resource Name (ARN) of the IAM role that grants Amazon
  Comprehend read access to your input data.
- `input_data_config`: Specifies the format and location of the input data for the job.
- `language_code`: The language code of the input documents.
- `output_data_config`: Specifies where to send the output files.
- `target_event_types`: The types of events to detect in the input documents.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: An unique identifier for the request. If you don't set the client
  request token, Amazon Comprehend generates one.
- `"JobName"`: The identifier of the events detection job.
- `"Tags"`: Tags to associate with the events detection job. A tag is a key-value pair that
  adds metadata to a resource used by Amazon Comprehend. For example, a tag with \"Sales\" as
  the key might be added to a resource to indicate its use by the sales department.
"""
function start_events_detection_job(
    DataAccessRoleArn,
    InputDataConfig,
    LanguageCode,
    OutputDataConfig,
    TargetEventTypes;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "StartEventsDetectionJob",
        Dict{String,Any}(
            "DataAccessRoleArn" => DataAccessRoleArn,
            "InputDataConfig" => InputDataConfig,
            "LanguageCode" => LanguageCode,
            "OutputDataConfig" => OutputDataConfig,
            "TargetEventTypes" => TargetEventTypes,
            "ClientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_events_detection_job(
    DataAccessRoleArn,
    InputDataConfig,
    LanguageCode,
    OutputDataConfig,
    TargetEventTypes,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "StartEventsDetectionJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DataAccessRoleArn" => DataAccessRoleArn,
                    "InputDataConfig" => InputDataConfig,
                    "LanguageCode" => LanguageCode,
                    "OutputDataConfig" => OutputDataConfig,
                    "TargetEventTypes" => TargetEventTypes,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_flywheel_iteration(flywheel_arn)
    start_flywheel_iteration(flywheel_arn, params::Dict{String,<:Any})

Start the flywheel iteration.This operation uses any new datasets to train a new model
version. For more information about flywheels, see  Flywheel overview in the Amazon
Comprehend Developer Guide.

# Arguments
- `flywheel_arn`: The ARN of the flywheel.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: A unique identifier for the request. If you don't set the client
  request token, Amazon Comprehend generates one.
"""
function start_flywheel_iteration(
    FlywheelArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "StartFlywheelIteration",
        Dict{String,Any}("FlywheelArn" => FlywheelArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_flywheel_iteration(
    FlywheelArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "StartFlywheelIteration",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("FlywheelArn" => FlywheelArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_key_phrases_detection_job(data_access_role_arn, input_data_config, language_code, output_data_config)
    start_key_phrases_detection_job(data_access_role_arn, input_data_config, language_code, output_data_config, params::Dict{String,<:Any})

Starts an asynchronous key phrase detection job for a collection of documents. Use the
operation to track the status of a job.

# Arguments
- `data_access_role_arn`: The Amazon Resource Name (ARN) of the IAM role that grants Amazon
  Comprehend read access to your input data. For more information, see Role-based permissions.
- `input_data_config`: Specifies the format and location of the input data for the job.
- `language_code`: The language of the input documents. You can specify any of the primary
  languages supported by Amazon Comprehend. All documents must be in the same language.
- `output_data_config`: Specifies where to send the output files.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: A unique identifier for the request. If you don't set the client
  request token, Amazon Comprehend generates one.
- `"JobName"`: The identifier of the job.
- `"Tags"`: Tags to associate with the key phrases detection job. A tag is a key-value pair
  that adds metadata to a resource used by Amazon Comprehend. For example, a tag with
  \"Sales\" as the key might be added to a resource to indicate its use by the sales
  department.
- `"VolumeKmsKeyId"`: ID for the Amazon Web Services Key Management Service (KMS) key that
  Amazon Comprehend uses to encrypt data on the storage volume attached to the ML compute
  instance(s) that process the analysis job. The VolumeKmsKeyId can be either of the
  following formats:   KMS Key ID: \"1234abcd-12ab-34cd-56ef-1234567890ab\"    Amazon
  Resource Name (ARN) of a KMS Key:
  \"arn:aws:kms:us-west-2:111122223333:key/1234abcd-12ab-34cd-56ef-1234567890ab\"
- `"VpcConfig"`:  Configuration parameters for an optional private Virtual Private Cloud
  (VPC) containing the resources you are using for your key phrases detection job. For more
  information, see Amazon VPC.
"""
function start_key_phrases_detection_job(
    DataAccessRoleArn,
    InputDataConfig,
    LanguageCode,
    OutputDataConfig;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "StartKeyPhrasesDetectionJob",
        Dict{String,Any}(
            "DataAccessRoleArn" => DataAccessRoleArn,
            "InputDataConfig" => InputDataConfig,
            "LanguageCode" => LanguageCode,
            "OutputDataConfig" => OutputDataConfig,
            "ClientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_key_phrases_detection_job(
    DataAccessRoleArn,
    InputDataConfig,
    LanguageCode,
    OutputDataConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "StartKeyPhrasesDetectionJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DataAccessRoleArn" => DataAccessRoleArn,
                    "InputDataConfig" => InputDataConfig,
                    "LanguageCode" => LanguageCode,
                    "OutputDataConfig" => OutputDataConfig,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_pii_entities_detection_job(data_access_role_arn, input_data_config, language_code, mode, output_data_config)
    start_pii_entities_detection_job(data_access_role_arn, input_data_config, language_code, mode, output_data_config, params::Dict{String,<:Any})

Starts an asynchronous PII entity detection job for a collection of documents.

# Arguments
- `data_access_role_arn`: The Amazon Resource Name (ARN) of the IAM role that grants Amazon
  Comprehend read access to your input data.
- `input_data_config`: The input properties for a PII entities detection job.
- `language_code`: The language of the input documents. Enter the language code for English
  (en) or Spanish (es).
- `mode`: Specifies whether the output provides the locations (offsets) of PII entities or
  a file in which PII entities are redacted.
- `output_data_config`: Provides conﬁguration parameters for the output of PII entity
  detection jobs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: A unique identifier for the request. If you don't set the client
  request token, Amazon Comprehend generates one.
- `"JobName"`: The identifier of the job.
- `"RedactionConfig"`: Provides configuration parameters for PII entity redaction. This
  parameter is required if you set the Mode parameter to ONLY_REDACTION. In that case, you
  must provide a RedactionConfig definition that includes the PiiEntityTypes parameter.
- `"Tags"`: Tags to associate with the PII entities detection job. A tag is a key-value
  pair that adds metadata to a resource used by Amazon Comprehend. For example, a tag with
  \"Sales\" as the key might be added to a resource to indicate its use by the sales
  department.
"""
function start_pii_entities_detection_job(
    DataAccessRoleArn,
    InputDataConfig,
    LanguageCode,
    Mode,
    OutputDataConfig;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "StartPiiEntitiesDetectionJob",
        Dict{String,Any}(
            "DataAccessRoleArn" => DataAccessRoleArn,
            "InputDataConfig" => InputDataConfig,
            "LanguageCode" => LanguageCode,
            "Mode" => Mode,
            "OutputDataConfig" => OutputDataConfig,
            "ClientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_pii_entities_detection_job(
    DataAccessRoleArn,
    InputDataConfig,
    LanguageCode,
    Mode,
    OutputDataConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "StartPiiEntitiesDetectionJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DataAccessRoleArn" => DataAccessRoleArn,
                    "InputDataConfig" => InputDataConfig,
                    "LanguageCode" => LanguageCode,
                    "Mode" => Mode,
                    "OutputDataConfig" => OutputDataConfig,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_sentiment_detection_job(data_access_role_arn, input_data_config, language_code, output_data_config)
    start_sentiment_detection_job(data_access_role_arn, input_data_config, language_code, output_data_config, params::Dict{String,<:Any})

Starts an asynchronous sentiment detection job for a collection of documents. Use the
operation to track the status of a job.

# Arguments
- `data_access_role_arn`: The Amazon Resource Name (ARN) of the IAM role that grants Amazon
  Comprehend read access to your input data. For more information, see Role-based permissions.
- `input_data_config`: Specifies the format and location of the input data for the job.
- `language_code`: The language of the input documents. You can specify any of the primary
  languages supported by Amazon Comprehend. All documents must be in the same language.
- `output_data_config`: Specifies where to send the output files.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: A unique identifier for the request. If you don't set the client
  request token, Amazon Comprehend generates one.
- `"JobName"`: The identifier of the job.
- `"Tags"`: Tags to associate with the sentiment detection job. A tag is a key-value pair
  that adds metadata to a resource used by Amazon Comprehend. For example, a tag with
  \"Sales\" as the key might be added to a resource to indicate its use by the sales
  department.
- `"VolumeKmsKeyId"`: ID for the Amazon Web Services Key Management Service (KMS) key that
  Amazon Comprehend uses to encrypt data on the storage volume attached to the ML compute
  instance(s) that process the analysis job. The VolumeKmsKeyId can be either of the
  following formats:   KMS Key ID: \"1234abcd-12ab-34cd-56ef-1234567890ab\"    Amazon
  Resource Name (ARN) of a KMS Key:
  \"arn:aws:kms:us-west-2:111122223333:key/1234abcd-12ab-34cd-56ef-1234567890ab\"
- `"VpcConfig"`: Configuration parameters for an optional private Virtual Private Cloud
  (VPC) containing the resources you are using for your sentiment detection job. For more
  information, see Amazon VPC.
"""
function start_sentiment_detection_job(
    DataAccessRoleArn,
    InputDataConfig,
    LanguageCode,
    OutputDataConfig;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "StartSentimentDetectionJob",
        Dict{String,Any}(
            "DataAccessRoleArn" => DataAccessRoleArn,
            "InputDataConfig" => InputDataConfig,
            "LanguageCode" => LanguageCode,
            "OutputDataConfig" => OutputDataConfig,
            "ClientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_sentiment_detection_job(
    DataAccessRoleArn,
    InputDataConfig,
    LanguageCode,
    OutputDataConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "StartSentimentDetectionJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DataAccessRoleArn" => DataAccessRoleArn,
                    "InputDataConfig" => InputDataConfig,
                    "LanguageCode" => LanguageCode,
                    "OutputDataConfig" => OutputDataConfig,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_targeted_sentiment_detection_job(data_access_role_arn, input_data_config, language_code, output_data_config)
    start_targeted_sentiment_detection_job(data_access_role_arn, input_data_config, language_code, output_data_config, params::Dict{String,<:Any})

Starts an asynchronous targeted sentiment detection job for a collection of documents. Use
the DescribeTargetedSentimentDetectionJob operation to track the status of a job.

# Arguments
- `data_access_role_arn`: The Amazon Resource Name (ARN) of the IAM role that grants Amazon
  Comprehend read access to your input data. For more information, see Role-based permissions.
- `input_data_config`:
- `language_code`: The language of the input documents. Currently, English is the only
  supported language.
- `output_data_config`: Specifies where to send the output files.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: A unique identifier for the request. If you don't set the client
  request token, Amazon Comprehend generates one.
- `"JobName"`: The identifier of the job.
- `"Tags"`: Tags to associate with the targeted sentiment detection job. A tag is a
  key-value pair that adds metadata to a resource used by Amazon Comprehend. For example, a
  tag with \"Sales\" as the key might be added to a resource to indicate its use by the sales
  department.
- `"VolumeKmsKeyId"`: ID for the KMS key that Amazon Comprehend uses to encrypt data on the
  storage volume attached to the ML compute instance(s) that process the analysis job. The
  VolumeKmsKeyId can be either of the following formats:   KMS Key ID:
  \"1234abcd-12ab-34cd-56ef-1234567890ab\"    Amazon Resource Name (ARN) of a KMS Key:
  \"arn:aws:kms:us-west-2:111122223333:key/1234abcd-12ab-34cd-56ef-1234567890ab\"
- `"VpcConfig"`:
"""
function start_targeted_sentiment_detection_job(
    DataAccessRoleArn,
    InputDataConfig,
    LanguageCode,
    OutputDataConfig;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "StartTargetedSentimentDetectionJob",
        Dict{String,Any}(
            "DataAccessRoleArn" => DataAccessRoleArn,
            "InputDataConfig" => InputDataConfig,
            "LanguageCode" => LanguageCode,
            "OutputDataConfig" => OutputDataConfig,
            "ClientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_targeted_sentiment_detection_job(
    DataAccessRoleArn,
    InputDataConfig,
    LanguageCode,
    OutputDataConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "StartTargetedSentimentDetectionJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DataAccessRoleArn" => DataAccessRoleArn,
                    "InputDataConfig" => InputDataConfig,
                    "LanguageCode" => LanguageCode,
                    "OutputDataConfig" => OutputDataConfig,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_topics_detection_job(data_access_role_arn, input_data_config, output_data_config)
    start_topics_detection_job(data_access_role_arn, input_data_config, output_data_config, params::Dict{String,<:Any})

Starts an asynchronous topic detection job. Use the DescribeTopicDetectionJob operation to
track the status of a job.

# Arguments
- `data_access_role_arn`: The Amazon Resource Name (ARN) of the IAM role that grants Amazon
  Comprehend read access to your input data. For more information, see Role-based permissions.
- `input_data_config`: Specifies the format and location of the input data for the job.
- `output_data_config`: Specifies where to send the output files. The output is a
  compressed archive with two files, topic-terms.csv that lists the terms associated with
  each topic, and doc-topics.csv that lists the documents associated with each topic

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ClientRequestToken"`: A unique identifier for the request. If you do not set the client
  request token, Amazon Comprehend generates one.
- `"JobName"`: The identifier of the job.
- `"NumberOfTopics"`: The number of topics to detect.
- `"Tags"`: Tags to associate with the topics detection job. A tag is a key-value pair that
  adds metadata to a resource used by Amazon Comprehend. For example, a tag with \"Sales\" as
  the key might be added to a resource to indicate its use by the sales department.
- `"VolumeKmsKeyId"`: ID for the Amazon Web Services Key Management Service (KMS) key that
  Amazon Comprehend uses to encrypt data on the storage volume attached to the ML compute
  instance(s) that process the analysis job. The VolumeKmsKeyId can be either of the
  following formats:   KMS Key ID: \"1234abcd-12ab-34cd-56ef-1234567890ab\"    Amazon
  Resource Name (ARN) of a KMS Key:
  \"arn:aws:kms:us-west-2:111122223333:key/1234abcd-12ab-34cd-56ef-1234567890ab\"
- `"VpcConfig"`: Configuration parameters for an optional private Virtual Private Cloud
  (VPC) containing the resources you are using for your topic detection job. For more
  information, see Amazon VPC.
"""
function start_topics_detection_job(
    DataAccessRoleArn,
    InputDataConfig,
    OutputDataConfig;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "StartTopicsDetectionJob",
        Dict{String,Any}(
            "DataAccessRoleArn" => DataAccessRoleArn,
            "InputDataConfig" => InputDataConfig,
            "OutputDataConfig" => OutputDataConfig,
            "ClientRequestToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_topics_detection_job(
    DataAccessRoleArn,
    InputDataConfig,
    OutputDataConfig,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "StartTopicsDetectionJob",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DataAccessRoleArn" => DataAccessRoleArn,
                    "InputDataConfig" => InputDataConfig,
                    "OutputDataConfig" => OutputDataConfig,
                    "ClientRequestToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_dominant_language_detection_job(job_id)
    stop_dominant_language_detection_job(job_id, params::Dict{String,<:Any})

Stops a dominant language detection job in progress. If the job state is IN_PROGRESS the
job is marked for termination and put into the STOP_REQUESTED state. If the job completes
before it can be stopped, it is put into the COMPLETED state; otherwise the job is stopped
and put into the STOPPED state. If the job is in the COMPLETED or FAILED state when you
call the StopDominantLanguageDetectionJob operation, the operation returns a 400 Internal
Request Exception.  When a job is stopped, any documents already processed are written to
the output location.

# Arguments
- `job_id`: The identifier of the dominant language detection job to stop.

"""
function stop_dominant_language_detection_job(
    JobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "StopDominantLanguageDetectionJob",
        Dict{String,Any}("JobId" => JobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_dominant_language_detection_job(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "StopDominantLanguageDetectionJob",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("JobId" => JobId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_entities_detection_job(job_id)
    stop_entities_detection_job(job_id, params::Dict{String,<:Any})

Stops an entities detection job in progress. If the job state is IN_PROGRESS the job is
marked for termination and put into the STOP_REQUESTED state. If the job completes before
it can be stopped, it is put into the COMPLETED state; otherwise the job is stopped and put
into the STOPPED state. If the job is in the COMPLETED or FAILED state when you call the
StopDominantLanguageDetectionJob operation, the operation returns a 400 Internal Request
Exception.  When a job is stopped, any documents already processed are written to the
output location.

# Arguments
- `job_id`: The identifier of the entities detection job to stop.

"""
function stop_entities_detection_job(
    JobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "StopEntitiesDetectionJob",
        Dict{String,Any}("JobId" => JobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_entities_detection_job(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "StopEntitiesDetectionJob",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("JobId" => JobId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_events_detection_job(job_id)
    stop_events_detection_job(job_id, params::Dict{String,<:Any})

Stops an events detection job in progress.

# Arguments
- `job_id`: The identifier of the events detection job to stop.

"""
function stop_events_detection_job(
    JobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "StopEventsDetectionJob",
        Dict{String,Any}("JobId" => JobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_events_detection_job(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "StopEventsDetectionJob",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("JobId" => JobId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_key_phrases_detection_job(job_id)
    stop_key_phrases_detection_job(job_id, params::Dict{String,<:Any})

Stops a key phrases detection job in progress. If the job state is IN_PROGRESS the job is
marked for termination and put into the STOP_REQUESTED state. If the job completes before
it can be stopped, it is put into the COMPLETED state; otherwise the job is stopped and put
into the STOPPED state. If the job is in the COMPLETED or FAILED state when you call the
StopDominantLanguageDetectionJob operation, the operation returns a 400 Internal Request
Exception.  When a job is stopped, any documents already processed are written to the
output location.

# Arguments
- `job_id`: The identifier of the key phrases detection job to stop.

"""
function stop_key_phrases_detection_job(
    JobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "StopKeyPhrasesDetectionJob",
        Dict{String,Any}("JobId" => JobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_key_phrases_detection_job(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "StopKeyPhrasesDetectionJob",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("JobId" => JobId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_pii_entities_detection_job(job_id)
    stop_pii_entities_detection_job(job_id, params::Dict{String,<:Any})

Stops a PII entities detection job in progress.

# Arguments
- `job_id`: The identifier of the PII entities detection job to stop.

"""
function stop_pii_entities_detection_job(
    JobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "StopPiiEntitiesDetectionJob",
        Dict{String,Any}("JobId" => JobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_pii_entities_detection_job(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "StopPiiEntitiesDetectionJob",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("JobId" => JobId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_sentiment_detection_job(job_id)
    stop_sentiment_detection_job(job_id, params::Dict{String,<:Any})

Stops a sentiment detection job in progress. If the job state is IN_PROGRESS, the job is
marked for termination and put into the STOP_REQUESTED state. If the job completes before
it can be stopped, it is put into the COMPLETED state; otherwise the job is be stopped and
put into the STOPPED state. If the job is in the COMPLETED or FAILED state when you call
the StopDominantLanguageDetectionJob operation, the operation returns a 400 Internal
Request Exception.  When a job is stopped, any documents already processed are written to
the output location.

# Arguments
- `job_id`: The identifier of the sentiment detection job to stop.

"""
function stop_sentiment_detection_job(
    JobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "StopSentimentDetectionJob",
        Dict{String,Any}("JobId" => JobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_sentiment_detection_job(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "StopSentimentDetectionJob",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("JobId" => JobId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_targeted_sentiment_detection_job(job_id)
    stop_targeted_sentiment_detection_job(job_id, params::Dict{String,<:Any})

Stops a targeted sentiment detection job in progress. If the job state is IN_PROGRESS, the
job is marked for termination and put into the STOP_REQUESTED state. If the job completes
before it can be stopped, it is put into the COMPLETED state; otherwise the job is be
stopped and put into the STOPPED state. If the job is in the COMPLETED or FAILED state when
you call the StopDominantLanguageDetectionJob operation, the operation returns a 400
Internal Request Exception.  When a job is stopped, any documents already processed are
written to the output location.

# Arguments
- `job_id`: The identifier of the targeted sentiment detection job to stop.

"""
function stop_targeted_sentiment_detection_job(
    JobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "StopTargetedSentimentDetectionJob",
        Dict{String,Any}("JobId" => JobId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_targeted_sentiment_detection_job(
    JobId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "StopTargetedSentimentDetectionJob",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("JobId" => JobId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_training_document_classifier(document_classifier_arn)
    stop_training_document_classifier(document_classifier_arn, params::Dict{String,<:Any})

Stops a document classifier training job while in progress. If the training job state is
TRAINING, the job is marked for termination and put into the STOP_REQUESTED state. If the
training job completes before it can be stopped, it is put into the TRAINED; otherwise the
training job is stopped and put into the STOPPED state and the service sends back an HTTP
200 response with an empty HTTP body.

# Arguments
- `document_classifier_arn`: The Amazon Resource Name (ARN) that identifies the document
  classifier currently being trained.

"""
function stop_training_document_classifier(
    DocumentClassifierArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "StopTrainingDocumentClassifier",
        Dict{String,Any}("DocumentClassifierArn" => DocumentClassifierArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_training_document_classifier(
    DocumentClassifierArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "StopTrainingDocumentClassifier",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DocumentClassifierArn" => DocumentClassifierArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_training_entity_recognizer(entity_recognizer_arn)
    stop_training_entity_recognizer(entity_recognizer_arn, params::Dict{String,<:Any})

Stops an entity recognizer training job while in progress. If the training job state is
TRAINING, the job is marked for termination and put into the STOP_REQUESTED state. If the
training job completes before it can be stopped, it is put into the TRAINED; otherwise the
training job is stopped and putted into the STOPPED state and the service sends back an
HTTP 200 response with an empty HTTP body.

# Arguments
- `entity_recognizer_arn`: The Amazon Resource Name (ARN) that identifies the entity
  recognizer currently being trained.

"""
function stop_training_entity_recognizer(
    EntityRecognizerArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "StopTrainingEntityRecognizer",
        Dict{String,Any}("EntityRecognizerArn" => EntityRecognizerArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_training_entity_recognizer(
    EntityRecognizerArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "StopTrainingEntityRecognizer",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("EntityRecognizerArn" => EntityRecognizerArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Associates a specific tag with an Amazon Comprehend resource. A tag is a key-value pair
that adds as a metadata to a resource used by Amazon Comprehend. For example, a tag with
\"Sales\" as the key might be added to a resource to indicate its use by the sales
department.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the given Amazon Comprehend resource to
  which you want to associate the tags.
- `tags`: Tags being associated with a specific Amazon Comprehend resource. There can be a
  maximum of 50 tags (both existing and pending) associated with a specific resource.

"""
function tag_resource(ResourceArn, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return comprehend(
        "TagResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceArn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes a specific tag associated with an Amazon Comprehend resource.

# Arguments
- `resource_arn`:  The Amazon Resource Name (ARN) of the given Amazon Comprehend resource
  from which you want to remove the tags.
- `tag_keys`: The initial part of a key-value pair that forms a tag being removed from a
  given resource. For example, a tag with \"Sales\" as the key might be added to a resource
  to indicate its use by the sales department. Keys must be unique and cannot be duplicated
  for a particular resource.

"""
function untag_resource(
    ResourceArn, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return comprehend(
        "UntagResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceArn,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_endpoint(endpoint_arn)
    update_endpoint(endpoint_arn, params::Dict{String,<:Any})

Updates information about the specified endpoint. For information about endpoints, see
Managing endpoints.

# Arguments
- `endpoint_arn`: The Amazon Resource Number (ARN) of the endpoint being updated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DesiredDataAccessRoleArn"`: Data access role ARN to use in case the new model is
  encrypted with a customer CMK.
- `"DesiredInferenceUnits"`:  The desired number of inference units to be used by the model
  using this endpoint. Each inference unit represents of a throughput of 100 characters per
  second.
- `"DesiredModelArn"`: The ARN of the new model to use when updating an existing endpoint.
- `"FlywheelArn"`: The Amazon Resource Number (ARN) of the flywheel
"""
function update_endpoint(EndpointArn; aws_config::AbstractAWSConfig=current_aws_config())
    return comprehend(
        "UpdateEndpoint",
        Dict{String,Any}("EndpointArn" => EndpointArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_endpoint(
    EndpointArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "UpdateEndpoint",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("EndpointArn" => EndpointArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_flywheel(flywheel_arn)
    update_flywheel(flywheel_arn, params::Dict{String,<:Any})

Update the configuration information for an existing flywheel.

# Arguments
- `flywheel_arn`: The Amazon Resource Number (ARN) of the flywheel to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ActiveModelArn"`: The Amazon Resource Number (ARN) of the active model version.
- `"DataAccessRoleArn"`: The Amazon Resource Name (ARN) of the IAM role that grants Amazon
  Comprehend permission to access the flywheel data.
- `"DataSecurityConfig"`: Flywheel data security configuration.
"""
function update_flywheel(FlywheelArn; aws_config::AbstractAWSConfig=current_aws_config())
    return comprehend(
        "UpdateFlywheel",
        Dict{String,Any}("FlywheelArn" => FlywheelArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_flywheel(
    FlywheelArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return comprehend(
        "UpdateFlywheel",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("FlywheelArn" => FlywheelArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: support_app
using AWS.Compat
using AWS.UUIDs

"""
    create_slack_channel_configuration(channel_id, channel_role_arn, notify_on_case_severity, team_id)
    create_slack_channel_configuration(channel_id, channel_role_arn, notify_on_case_severity, team_id, params::Dict{String,<:Any})

Creates a Slack channel configuration for your Amazon Web Services account.    You can add
up to 5 Slack workspaces for your account.   You can add up to 20 Slack channels for your
account.    A Slack channel can have up to 100 Amazon Web Services accounts. This means
that only 100 accounts can add the same Slack channel to the Amazon Web Services Support
App. We recommend that you only add the accounts that you need to manage support cases for
your organization. This can reduce the notifications about case updates that you receive in
the Slack channel.  We recommend that you choose a private Slack channel so that only
members in that channel have read and write access to your support cases. Anyone in your
Slack channel can create, update, or resolve support cases for your account. Users require
an invitation to join private channels.

# Arguments
- `channel_id`: The channel ID in Slack. This ID identifies a channel within a Slack
  workspace.
- `channel_role_arn`: The Amazon Resource Name (ARN) of an IAM role that you want to use to
  perform operations on Amazon Web Services. For more information, see Managing access to the
  Amazon Web Services Support App in the Amazon Web Services Support User Guide.
- `notify_on_case_severity`: The case severity for a support case that you want to receive
  notifications. If you specify high or all, you must specify true for at least one of the
  following parameters:    notifyOnAddCorrespondenceToCase     notifyOnCreateOrReopenCase
  notifyOnResolveCase    If you specify none, the following parameters must be null or false:
     notifyOnAddCorrespondenceToCase     notifyOnCreateOrReopenCase     notifyOnResolveCase
    If you don't specify these parameters in your request, they default to false.
- `team_id`: The team ID in Slack. This ID uniquely identifies a Slack workspace, such as
  T012ABCDEFG.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"channelName"`: The name of the Slack channel that you configure for the Amazon Web
  Services Support App.
- `"notifyOnAddCorrespondenceToCase"`: Whether you want to get notified when a support case
  has a new correspondence.
- `"notifyOnCreateOrReopenCase"`: Whether you want to get notified when a support case is
  created or reopened.
- `"notifyOnResolveCase"`: Whether you want to get notified when a support case is resolved.
"""
function create_slack_channel_configuration(
    channelId,
    channelRoleArn,
    notifyOnCaseSeverity,
    teamId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return support_app(
        "POST",
        "/control/create-slack-channel-configuration",
        Dict{String,Any}(
            "channelId" => channelId,
            "channelRoleArn" => channelRoleArn,
            "notifyOnCaseSeverity" => notifyOnCaseSeverity,
            "teamId" => teamId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_slack_channel_configuration(
    channelId,
    channelRoleArn,
    notifyOnCaseSeverity,
    teamId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return support_app(
        "POST",
        "/control/create-slack-channel-configuration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "channelId" => channelId,
                    "channelRoleArn" => channelRoleArn,
                    "notifyOnCaseSeverity" => notifyOnCaseSeverity,
                    "teamId" => teamId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_account_alias()
    delete_account_alias(params::Dict{String,<:Any})

Deletes an alias for an Amazon Web Services account ID. The alias appears in the Amazon Web
Services Support App page of the Amazon Web Services Support Center. The alias also appears
in Slack messages from the Amazon Web Services Support App.

"""
function delete_account_alias(; aws_config::AbstractAWSConfig=current_aws_config())
    return support_app(
        "POST",
        "/control/delete-account-alias";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_account_alias(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return support_app(
        "POST",
        "/control/delete-account-alias",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_slack_channel_configuration(channel_id, team_id)
    delete_slack_channel_configuration(channel_id, team_id, params::Dict{String,<:Any})

Deletes a Slack channel configuration from your Amazon Web Services account. This operation
doesn't delete your Slack channel.

# Arguments
- `channel_id`: The channel ID in Slack. This ID identifies a channel within a Slack
  workspace.
- `team_id`: The team ID in Slack. This ID uniquely identifies a Slack workspace, such as
  T012ABCDEFG.

"""
function delete_slack_channel_configuration(
    channelId, teamId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return support_app(
        "POST",
        "/control/delete-slack-channel-configuration",
        Dict{String,Any}("channelId" => channelId, "teamId" => teamId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_slack_channel_configuration(
    channelId,
    teamId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return support_app(
        "POST",
        "/control/delete-slack-channel-configuration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("channelId" => channelId, "teamId" => teamId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_slack_workspace_configuration(team_id)
    delete_slack_workspace_configuration(team_id, params::Dict{String,<:Any})

Deletes a Slack workspace configuration from your Amazon Web Services account. This
operation doesn't delete your Slack workspace.

# Arguments
- `team_id`: The team ID in Slack. This ID uniquely identifies a Slack workspace, such as
  T012ABCDEFG.

"""
function delete_slack_workspace_configuration(
    teamId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return support_app(
        "POST",
        "/control/delete-slack-workspace-configuration",
        Dict{String,Any}("teamId" => teamId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_slack_workspace_configuration(
    teamId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return support_app(
        "POST",
        "/control/delete-slack-workspace-configuration",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("teamId" => teamId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_account_alias()
    get_account_alias(params::Dict{String,<:Any})

Retrieves the alias from an Amazon Web Services account ID. The alias appears in the Amazon
Web Services Support App page of the Amazon Web Services Support Center. The alias also
appears in Slack messages from the Amazon Web Services Support App.

"""
function get_account_alias(; aws_config::AbstractAWSConfig=current_aws_config())
    return support_app(
        "POST",
        "/control/get-account-alias";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_account_alias(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return support_app(
        "POST",
        "/control/get-account-alias",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_slack_channel_configurations()
    list_slack_channel_configurations(params::Dict{String,<:Any})

Lists the Slack channel configurations for an Amazon Web Services account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: If the results of a search are large, the API only returns a portion of
  the results and includes a nextToken pagination token in the response. To retrieve the next
  batch of results, reissue the search request and include the returned token. When the API
  returns the last set of results, the response doesn't include a pagination token value.
"""
function list_slack_channel_configurations(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return support_app(
        "POST",
        "/control/list-slack-channel-configurations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_slack_channel_configurations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return support_app(
        "POST",
        "/control/list-slack-channel-configurations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_slack_workspace_configurations()
    list_slack_workspace_configurations(params::Dict{String,<:Any})

Lists the Slack workspace configurations for an Amazon Web Services account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: If the results of a search are large, the API only returns a portion of
  the results and includes a nextToken pagination token in the response. To retrieve the next
  batch of results, reissue the search request and include the returned token. When the API
  returns the last set of results, the response doesn't include a pagination token value.
"""
function list_slack_workspace_configurations(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return support_app(
        "POST",
        "/control/list-slack-workspace-configurations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_slack_workspace_configurations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return support_app(
        "POST",
        "/control/list-slack-workspace-configurations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_account_alias(account_alias)
    put_account_alias(account_alias, params::Dict{String,<:Any})

Creates or updates an individual alias for each Amazon Web Services account ID. The alias
appears in the Amazon Web Services Support App page of the Amazon Web Services Support
Center. The alias also appears in Slack messages from the Amazon Web Services Support App.

# Arguments
- `account_alias`: An alias or short name for an Amazon Web Services account.

"""
function put_account_alias(accountAlias; aws_config::AbstractAWSConfig=current_aws_config())
    return support_app(
        "POST",
        "/control/put-account-alias",
        Dict{String,Any}("accountAlias" => accountAlias);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_account_alias(
    accountAlias,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return support_app(
        "POST",
        "/control/put-account-alias",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("accountAlias" => accountAlias), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    register_slack_workspace_for_organization(team_id)
    register_slack_workspace_for_organization(team_id, params::Dict{String,<:Any})

Registers a Slack workspace for your Amazon Web Services account. To call this API, your
account must be part of an organization in Organizations. If you're the management account
and you want to register Slack workspaces for your organization, you must complete the
following tasks:   Sign in to the Amazon Web Services Support Center and authorize the
Slack workspaces where you want your organization to have access to. See Authorize a Slack
workspace in the Amazon Web Services Support User Guide.   Call the
RegisterSlackWorkspaceForOrganization API to authorize each Slack workspace for the
organization.   After the management account authorizes the Slack workspace, member
accounts can call this API to authorize the same Slack workspace for their individual
accounts. Member accounts don't need to authorize the Slack workspace manually through the
Amazon Web Services Support Center. To use the Amazon Web Services Support App, each
account must then complete the following tasks:   Create an Identity and Access Management
(IAM) role with the required permission. For more information, see Managing access to the
Amazon Web Services Support App.   Configure a Slack channel to use the Amazon Web Services
Support App for support cases for that account. For more information, see Configuring a
Slack channel.

# Arguments
- `team_id`: The team ID in Slack. This ID uniquely identifies a Slack workspace, such as
  T012ABCDEFG. Specify the Slack workspace that you want to use for your organization.

"""
function register_slack_workspace_for_organization(
    teamId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return support_app(
        "POST",
        "/control/register-slack-workspace-for-organization",
        Dict{String,Any}("teamId" => teamId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function register_slack_workspace_for_organization(
    teamId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return support_app(
        "POST",
        "/control/register-slack-workspace-for-organization",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("teamId" => teamId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_slack_channel_configuration(channel_id, team_id)
    update_slack_channel_configuration(channel_id, team_id, params::Dict{String,<:Any})

Updates the configuration for a Slack channel, such as case update notifications.

# Arguments
- `channel_id`: The channel ID in Slack. This ID identifies a channel within a Slack
  workspace.
- `team_id`: The team ID in Slack. This ID uniquely identifies a Slack workspace, such as
  T012ABCDEFG.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"channelName"`: The Slack channel name that you want to update.
- `"channelRoleArn"`: The Amazon Resource Name (ARN) of an IAM role that you want to use to
  perform operations on Amazon Web Services. For more information, see Managing access to the
  Amazon Web Services Support App in the Amazon Web Services Support User Guide.
- `"notifyOnAddCorrespondenceToCase"`: Whether you want to get notified when a support case
  has a new correspondence.
- `"notifyOnCaseSeverity"`: The case severity for a support case that you want to receive
  notifications. If you specify high or all, at least one of the following parameters must be
  true:    notifyOnAddCorrespondenceToCase     notifyOnCreateOrReopenCase
  notifyOnResolveCase    If you specify none, any of the following parameters that you
  specify in your request must be false:    notifyOnAddCorrespondenceToCase
  notifyOnCreateOrReopenCase     notifyOnResolveCase     If you don't specify these
  parameters in your request, the Amazon Web Services Support App uses the current values by
  default.
- `"notifyOnCreateOrReopenCase"`: Whether you want to get notified when a support case is
  created or reopened.
- `"notifyOnResolveCase"`: Whether you want to get notified when a support case is resolved.
"""
function update_slack_channel_configuration(
    channelId, teamId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return support_app(
        "POST",
        "/control/update-slack-channel-configuration",
        Dict{String,Any}("channelId" => channelId, "teamId" => teamId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_slack_channel_configuration(
    channelId,
    teamId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return support_app(
        "POST",
        "/control/update-slack-channel-configuration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("channelId" => channelId, "teamId" => teamId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: braket
using AWS.Compat
using AWS.UUIDs

"""
    cancel_job(job_arn)
    cancel_job(job_arn, params::Dict{String,<:Any})

Cancels an Amazon Braket job.

# Arguments
- `job_arn`: The ARN of the Amazon Braket job to cancel.

"""
function cancel_job(jobArn; aws_config::AbstractAWSConfig=current_aws_config())
    return braket(
        "PUT",
        "/job/$(jobArn)/cancel";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_job(
    jobArn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return braket(
        "PUT",
        "/job/$(jobArn)/cancel",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_quantum_task(client_token, quantum_task_arn)
    cancel_quantum_task(client_token, quantum_task_arn, params::Dict{String,<:Any})

Cancels the specified task.

# Arguments
- `client_token`: The client token associated with the request.
- `quantum_task_arn`: The ARN of the task to cancel.

"""
function cancel_quantum_task(
    clientToken, quantumTaskArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return braket(
        "PUT",
        "/quantum-task/$(quantumTaskArn)/cancel",
        Dict{String,Any}("clientToken" => clientToken);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_quantum_task(
    clientToken,
    quantumTaskArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return braket(
        "PUT",
        "/quantum-task/$(quantumTaskArn)/cancel",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("clientToken" => clientToken), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_job(algorithm_specification, client_token, device_config, instance_config, job_name, output_data_config, role_arn)
    create_job(algorithm_specification, client_token, device_config, instance_config, job_name, output_data_config, role_arn, params::Dict{String,<:Any})

Creates an Amazon Braket job.

# Arguments
- `algorithm_specification`: Definition of the Amazon Braket job to be created. Specifies
  the container image the job uses and information about the Python scripts used for entry
  and training.
- `client_token`: A unique token that guarantees that the call to this API is idempotent.
- `device_config`: The quantum processing unit (QPU) or simulator used to create an Amazon
  Braket job.
- `instance_config`: Configuration of the resource instances to use while running the
  hybrid job on Amazon Braket.
- `job_name`: The name of the Amazon Braket job.
- `output_data_config`: The path to the S3 location where you want to store job artifacts
  and the encryption key used to store them.
- `role_arn`: The Amazon Resource Name (ARN) of an IAM role that Amazon Braket can assume
  to perform tasks on behalf of a user. It can access user resources, run an Amazon Braket
  job container on behalf of user, and output resources to the users' s3 buckets.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"associations"`: The list of Amazon Braket resources associated with the hybrid job.
- `"checkpointConfig"`: Information about the output locations for job checkpoint data.
- `"hyperParameters"`: Algorithm-specific parameters used by an Amazon Braket job that
  influence the quality of the training job. The values are set with a string of JSON
  key:value pairs, where the key is the name of the hyperparameter and the value is the value
  of th hyperparameter.
- `"inputDataConfig"`: A list of parameters that specify the name and type of input data
  and where it is located.
- `"stoppingCondition"`:  The user-defined criteria that specifies when a job stops running.
- `"tags"`: A tag object that consists of a key and an optional value, used to manage
  metadata for Amazon Braket resources.
"""
function create_job(
    algorithmSpecification,
    clientToken,
    deviceConfig,
    instanceConfig,
    jobName,
    outputDataConfig,
    roleArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return braket(
        "POST",
        "/job",
        Dict{String,Any}(
            "algorithmSpecification" => algorithmSpecification,
            "clientToken" => clientToken,
            "deviceConfig" => deviceConfig,
            "instanceConfig" => instanceConfig,
            "jobName" => jobName,
            "outputDataConfig" => outputDataConfig,
            "roleArn" => roleArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_job(
    algorithmSpecification,
    clientToken,
    deviceConfig,
    instanceConfig,
    jobName,
    outputDataConfig,
    roleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return braket(
        "POST",
        "/job",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "algorithmSpecification" => algorithmSpecification,
                    "clientToken" => clientToken,
                    "deviceConfig" => deviceConfig,
                    "instanceConfig" => instanceConfig,
                    "jobName" => jobName,
                    "outputDataConfig" => outputDataConfig,
                    "roleArn" => roleArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_quantum_task(action, client_token, device_arn, output_s3_bucket, output_s3_key_prefix, shots)
    create_quantum_task(action, client_token, device_arn, output_s3_bucket, output_s3_key_prefix, shots, params::Dict{String,<:Any})

Creates a quantum task.

# Arguments
- `action`: The action associated with the task.
- `client_token`: The client token associated with the request.
- `device_arn`: The ARN of the device to run the task on.
- `output_s3_bucket`: The S3 bucket to store task result files in.
- `output_s3_key_prefix`: The key prefix for the location in the S3 bucket to store task
  results in.
- `shots`: The number of shots to use for the task.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"associations"`: The list of Amazon Braket resources associated with the quantum task.
- `"deviceParameters"`: The parameters for the device to run the task on.
- `"jobToken"`: The token for an Amazon Braket job that associates it with the quantum task.
- `"tags"`: Tags to be added to the quantum task you're creating.
"""
function create_quantum_task(
    action,
    clientToken,
    deviceArn,
    outputS3Bucket,
    outputS3KeyPrefix,
    shots;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return braket(
        "POST",
        "/quantum-task",
        Dict{String,Any}(
            "action" => action,
            "clientToken" => clientToken,
            "deviceArn" => deviceArn,
            "outputS3Bucket" => outputS3Bucket,
            "outputS3KeyPrefix" => outputS3KeyPrefix,
            "shots" => shots,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_quantum_task(
    action,
    clientToken,
    deviceArn,
    outputS3Bucket,
    outputS3KeyPrefix,
    shots,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return braket(
        "POST",
        "/quantum-task",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "action" => action,
                    "clientToken" => clientToken,
                    "deviceArn" => deviceArn,
                    "outputS3Bucket" => outputS3Bucket,
                    "outputS3KeyPrefix" => outputS3KeyPrefix,
                    "shots" => shots,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_device(device_arn)
    get_device(device_arn, params::Dict{String,<:Any})

Retrieves the devices available in Amazon Braket.  For backwards compatibility with older
versions of BraketSchemas, OpenQASM information is omitted from GetDevice API calls. To get
this information the user-agent needs to present a recent version of the BraketSchemas
(1.8.0 or later). The Braket SDK automatically reports this for you. If you do not see
OpenQASM results in the GetDevice response when using a Braket SDK, you may need to set
AWS_EXECUTION_ENV environment variable to configure user-agent. See the code examples
provided below for how to do this for the AWS CLI, Boto3, and the Go, Java, and
JavaScript/TypeScript SDKs.

# Arguments
- `device_arn`: The ARN of the device to retrieve.

"""
function get_device(deviceArn; aws_config::AbstractAWSConfig=current_aws_config())
    return braket(
        "GET",
        "/device/$(deviceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_device(
    deviceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return braket(
        "GET",
        "/device/$(deviceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_job(job_arn)
    get_job(job_arn, params::Dict{String,<:Any})

Retrieves the specified Amazon Braket job.

# Arguments
- `job_arn`: The ARN of the job to retrieve.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"additionalAttributeNames"`: A list of attributes to return information for.
"""
function get_job(jobArn; aws_config::AbstractAWSConfig=current_aws_config())
    return braket(
        "GET", "/job/$(jobArn)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_job(
    jobArn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return braket(
        "GET",
        "/job/$(jobArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_quantum_task(quantum_task_arn)
    get_quantum_task(quantum_task_arn, params::Dict{String,<:Any})

Retrieves the specified quantum task.

# Arguments
- `quantum_task_arn`: The ARN of the task to retrieve.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"additionalAttributeNames"`: A list of attributes to return information for.
"""
function get_quantum_task(
    quantumTaskArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return braket(
        "GET",
        "/quantum-task/$(quantumTaskArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_quantum_task(
    quantumTaskArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return braket(
        "GET",
        "/quantum-task/$(quantumTaskArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Shows the tags associated with this resource.

# Arguments
- `resource_arn`: Specify the resourceArn for the resource whose tags to display.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return braket(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return braket(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    search_devices(filters)
    search_devices(filters, params::Dict{String,<:Any})

Searches for devices using the specified filters.

# Arguments
- `filters`: The filter values to use to search for a device.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in the response.
- `"nextToken"`: A token used for pagination of results returned in the response. Use the
  token returned from the previous request continue results where the previous request ended.
"""
function search_devices(filters; aws_config::AbstractAWSConfig=current_aws_config())
    return braket(
        "POST",
        "/devices",
        Dict{String,Any}("filters" => filters);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function search_devices(
    filters,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return braket(
        "POST",
        "/devices",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("filters" => filters), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    search_jobs(filters)
    search_jobs(filters, params::Dict{String,<:Any})

Searches for Amazon Braket jobs that match the specified filter values.

# Arguments
- `filters`: The filter values to use when searching for a job.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return in the response.
- `"nextToken"`: A token used for pagination of results returned in the response. Use the
  token returned from the previous request to continue results where the previous request
  ended.
"""
function search_jobs(filters; aws_config::AbstractAWSConfig=current_aws_config())
    return braket(
        "POST",
        "/jobs",
        Dict{String,Any}("filters" => filters);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function search_jobs(
    filters,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return braket(
        "POST",
        "/jobs",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("filters" => filters), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    search_quantum_tasks(filters)
    search_quantum_tasks(filters, params::Dict{String,<:Any})

Searches for tasks that match the specified filter values.

# Arguments
- `filters`: Array of SearchQuantumTasksFilter objects.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Maximum number of results to return in the response.
- `"nextToken"`: A token used for pagination of results returned in the response. Use the
  token returned from the previous request continue results where the previous request ended.
"""
function search_quantum_tasks(filters; aws_config::AbstractAWSConfig=current_aws_config())
    return braket(
        "POST",
        "/quantum-tasks",
        Dict{String,Any}("filters" => filters);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function search_quantum_tasks(
    filters,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return braket(
        "POST",
        "/quantum-tasks",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("filters" => filters), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Add a tag to the specified resource.

# Arguments
- `resource_arn`: Specify the resourceArn of the resource to which a tag will be added.
- `tags`: Specify the tags to add to the resource.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return braket(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return braket(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Remove tags from a resource.

# Arguments
- `resource_arn`: Specify the resourceArn for the resource from which to remove the tags.
- `tag_keys`: Specify the keys for the tags to remove from the resource.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return braket(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return braket(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: networkmonitor
using AWS.Compat
using AWS.UUIDs

"""
    create_monitor(monitor_name)
    create_monitor(monitor_name, params::Dict{String,<:Any})

Creates a monitor between a source subnet and destination IP address. Within a monitor
you'll create one or more probes that monitor network traffic between your source Amazon
Web Services VPC subnets and your destination IP addresses. Each probe then aggregates and
sends metrics to Amazon CloudWatch. You can also create a monitor with probes using this
command. For each probe, you define the following:    source—The subnet IDs where the
probes will be created.    destination— The target destination IP address for the probe.
  destinationPort—Required only if the protocol is TCP.    protocol—The communication
protocol between the source and destination. This will be either TCP or ICMP.
packetSize—The size of the packets. This must be a number between 56 and 8500.
(Optional) tags —Key-value pairs created and assigned to the probe.

# Arguments
- `monitor_name`: The name identifying the monitor. It can contain only letters,
  underscores (_), or dashes (-), and can be up to 200 characters.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"aggregationPeriod"`: The time, in seconds, that metrics are aggregated and sent to
  Amazon CloudWatch. Valid values are either 30 or 60. 60 is the default if no period is
  chosen.
- `"clientToken"`: Unique, case-sensitive identifier to ensure the idempotency of the
  request. Only returned if a client token was provided in the request.
- `"probes"`: Displays a list of all of the probes created for a monitor.
- `"tags"`: The list of key-value pairs created and assigned to the monitor.
"""
function create_monitor(monitorName; aws_config::AbstractAWSConfig=current_aws_config())
    return networkmonitor(
        "POST",
        "/monitors",
        Dict{String,Any}("monitorName" => monitorName, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_monitor(
    monitorName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmonitor(
        "POST",
        "/monitors",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "monitorName" => monitorName, "clientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_probe(monitor_name, probe)
    create_probe(monitor_name, probe, params::Dict{String,<:Any})

Create a probe within a monitor. Once you create a probe, and it begins monitoring your
network traffic, you'll incur billing charges for that probe. This action requires the
monitorName parameter. Run ListMonitors to get a list of monitor names. Note the name of
the monitorName you want to create the probe for.

# Arguments
- `monitor_name`: The name of the monitor to associated with the probe.
- `probe`: Describes the details of an individual probe for a monitor.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Unique, case-sensitive identifier to ensure the idempotency of the
  request. Only returned if a client token was provided in the request.
- `"tags"`: The list of key-value pairs created and assigned to the probe.
"""
function create_probe(
    monitorName, probe; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmonitor(
        "POST",
        "/monitors/$(monitorName)/probes",
        Dict{String,Any}("probe" => probe, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_probe(
    monitorName,
    probe,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmonitor(
        "POST",
        "/monitors/$(monitorName)/probes",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("probe" => probe, "clientToken" => string(uuid4())),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_monitor(monitor_name)
    delete_monitor(monitor_name, params::Dict{String,<:Any})

Deletes a specified monitor. This action requires the monitorName parameter. Run
ListMonitors to get a list of monitor names.

# Arguments
- `monitor_name`: The name of the monitor to delete.

"""
function delete_monitor(monitorName; aws_config::AbstractAWSConfig=current_aws_config())
    return networkmonitor(
        "DELETE",
        "/monitors/$(monitorName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_monitor(
    monitorName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmonitor(
        "DELETE",
        "/monitors/$(monitorName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_probe(monitor_name, probe_id)
    delete_probe(monitor_name, probe_id, params::Dict{String,<:Any})

Deletes the specified probe. Once a probe is deleted you'll no longer incur any billing
fees for that probe. This action requires both the monitorName and probeId parameters. Run
ListMonitors to get a list of monitor names. Run GetMonitor to get a list of probes and
probe IDs. You can only delete a single probe at a time using this action.

# Arguments
- `monitor_name`: The name of the monitor to delete.
- `probe_id`: The ID of the probe to delete.

"""
function delete_probe(
    monitorName, probeId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmonitor(
        "DELETE",
        "/monitors/$(monitorName)/probes/$(probeId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_probe(
    monitorName,
    probeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmonitor(
        "DELETE",
        "/monitors/$(monitorName)/probes/$(probeId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_monitor(monitor_name)
    get_monitor(monitor_name, params::Dict{String,<:Any})

Returns details about a specific monitor.  This action requires the monitorName parameter.
Run ListMonitors to get a list of monitor names.

# Arguments
- `monitor_name`: The name of the monitor that details are returned for.

"""
function get_monitor(monitorName; aws_config::AbstractAWSConfig=current_aws_config())
    return networkmonitor(
        "GET",
        "/monitors/$(monitorName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_monitor(
    monitorName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmonitor(
        "GET",
        "/monitors/$(monitorName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_probe(monitor_name, probe_id)
    get_probe(monitor_name, probe_id, params::Dict{String,<:Any})

Returns the details about a probe. This action requires both the monitorName and probeId
parameters. Run ListMonitors to get a list of monitor names. Run GetMonitor to get a list
of probes and probe IDs.

# Arguments
- `monitor_name`: The name of the monitor associated with the probe. Run ListMonitors to
  get a list of monitor names.
- `probe_id`: The ID of the probe to get information about. Run GetMonitor action to get a
  list of probes and probe IDs for the monitor.

"""
function get_probe(monitorName, probeId; aws_config::AbstractAWSConfig=current_aws_config())
    return networkmonitor(
        "GET",
        "/monitors/$(monitorName)/probes/$(probeId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_probe(
    monitorName,
    probeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmonitor(
        "GET",
        "/monitors/$(monitorName)/probes/$(probeId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_monitors()
    list_monitors(params::Dict{String,<:Any})

Returns a list of all of your monitors.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to return with a single call. To retrieve
  the remaining results, make another call with the returned nextToken value. If MaxResults
  is given a value larger than 100, only 100 results are returned.
- `"nextToken"`: The token for the next page of results.
- `"state"`: The list of all monitors and their states.
"""
function list_monitors(; aws_config::AbstractAWSConfig=current_aws_config())
    return networkmonitor(
        "GET", "/monitors"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_monitors(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmonitor(
        "GET", "/monitors", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists the tags assigned to this resource.

# Arguments
- `resource_arn`: The

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmonitor(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmonitor(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds key-value pairs to a monitor or probe.

# Arguments
- `resource_arn`: The ARN of the monitor or probe to tag.
- `tags`: The list of key-value pairs assigned to the monitor or probe.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return networkmonitor(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmonitor(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes a key-value pair from a monitor or probe.

# Arguments
- `resource_arn`: The ARN of the monitor or probe that the tag should be removed from.
- `tag_keys`: The key-value pa

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmonitor(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmonitor(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_monitor(aggregation_period, monitor_name)
    update_monitor(aggregation_period, monitor_name, params::Dict{String,<:Any})

Updates the aggregationPeriod for a monitor. Monitors support an aggregationPeriod of
either 30 or 60 seconds. This action requires the monitorName and probeId parameter. Run
ListMonitors to get a list of monitor names.

# Arguments
- `aggregation_period`: The aggregation time, in seconds, to change to. This must be either
  30 or 60.
- `monitor_name`: The name of the monitor to update.

"""
function update_monitor(
    aggregationPeriod, monitorName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmonitor(
        "PATCH",
        "/monitors/$(monitorName)",
        Dict{String,Any}("aggregationPeriod" => aggregationPeriod);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_monitor(
    aggregationPeriod,
    monitorName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmonitor(
        "PATCH",
        "/monitors/$(monitorName)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("aggregationPeriod" => aggregationPeriod), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_probe(monitor_name, probe_id)
    update_probe(monitor_name, probe_id, params::Dict{String,<:Any})

Updates a monitor probe. This action requires both the monitorName and probeId parameters.
Run ListMonitors to get a list of monitor names. Run GetMonitor to get a list of probes and
probe IDs.  You can update the following para create a monitor with probes using this
command. For each probe, you define the following:    state—The state of the probe.
destination— The target destination IP address for the probe.
destinationPort—Required only if the protocol is TCP.    protocol—The communication
protocol between the source and destination. This will be either TCP or ICMP.
packetSize—The size of the packets. This must be a number between 56 and 8500.
(Optional) tags —Key-value pairs created and assigned to the probe.

# Arguments
- `monitor_name`: The name of the monitor that the probe was updated for.
- `probe_id`: The ID of the probe to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"destination"`: The updated IP address for the probe destination. This must be either an
  IPv4 or IPv6 address.
- `"destinationPort"`: The updated port for the probe destination. This is required only if
  the protocol is TCP and must be a number between 1 and 65536.
- `"packetSize"`: he updated packets size for network traffic between the source and
  destination. This must be a number between 56 and 8500.
- `"protocol"`: The updated network protocol for the destination. This can be either TCP or
  ICMP. If the protocol is TCP, then port is also required.
- `"state"`: The state of the probe update.
"""
function update_probe(
    monitorName, probeId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return networkmonitor(
        "PATCH",
        "/monitors/$(monitorName)/probes/$(probeId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_probe(
    monitorName,
    probeId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return networkmonitor(
        "PATCH",
        "/monitors/$(monitorName)/probes/$(probeId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

using CodecBase: Base32Decoder, Base64Decoder, transcode
using Dates: UTC, now
using SHA: hmac_sha1

# As defined in https://datatracker.ietf.org/doc/html/rfc4226#section-5
# Using fixed number of digits (6)
function hotp(k, c)
    digits = 6
    hs = hmac_sha1(k, c)
    dbc1 = dynamic_truncation(hs)
    otp = Int32(dbc1 % 10^digits)
    return lpad(otp, digits, '0')
end

function dynamic_truncation(hmac_result::Vector{UInt8})
    offset = hmac_result[20] & 0x0f  # lower 4-bits
    return (
        UInt32(hmac_result[offset + 1] & 0x7f) << 24 |
        UInt32(hmac_result[offset + 2] & 0xff) << 16 |
        UInt32(hmac_result[offset + 3] & 0xff) << 8 |
        UInt32(hmac_result[offset + 4] & 0xff)
    )  # big-endian
end

# As defined in https://datatracker.ietf.org/doc/html/rfc6238#section-4
function totp(k::Vector{UInt8}; duration=30, offset=0)
    t = time_step_window(; duration)
    c = reinterpret(UInt8, [hton(t + offset)]) # Convert to big-endian
    return hotp(k, c)
end

totp(k::AbstractString; kwargs...) = totp(transcode(Base32Decoder(), k); kwargs...)

function consumed_totp(k; duration=30, offset=0)
    last_window = 0
    function ()
        t = time()
        window = time_step_window(; duration, t)

        if window <= last_window
            sleep(duration - (t % duration) + 1)
            window += 1
        end

        last_window = window
        return totp(k; duration, offset)
    end
end

"""
    time_step_window(; duration=30, t=time(), t0=0) -> Int

# Keywords
- `duration::Integer`: Time step in seconds.
- `t::Number=time()`: Number of seconds since midnight UTC of January 1, 1970 (UNIX epoch).
- `t0::Number=0`: UNIX time to start counting time steps (default 0 is the UNIX epoch).
"""
time_step_window(; duration=30, t=time(), t0=0) = div(floor(Int64, t - t0), duration)

# Utilize all MFA devices associated with a user in order to reduce throttling due to TOTP
# tokens being consumed.
function mfa_device_pool(f, mfa_devices; duration=30, max_windows=3, debug=false)
    num_windows = 0
    while num_windows < max_windows
        num_windows += 1

        # Attempt to authenticate with each MFA device associated with the user until one
        # succeeds. If an invalid MFA OTP error is found then the OTP has been already
        # consumed.
        for d in shuffle(mfa_devices)
            token = totp(d.seed; duration)
            debug && println("$(now(UTC))Z - $(d.mfa_serial) - $token")
            try
                return f(d.mfa_serial, token)
            catch e
                # Examples of MFA token failures to retry:
                # "MultiFactorAuthentication failed with invalid MFA one time pass code."
                # "MultiFactorAuthentication failed, unable to validate MFA code.  Please verify your MFA serial number is valid and associated with this user."
                if (
                    e isa AWSException &&
                    contains(e.message, "MultiFactorAuthentication failed")
                )
                    debug && println("MFA token has been consumed")
                    continue
                else
                    rethrow()
                end
            end
        end

        # Wait until the next time step window as the MFA device's OTP codes have been
        # consumed for this window.
        debug && println("All MFA tokens have been consumed. Waiting for next window...")
        sleep(duration - (time() % duration) + 1)
    end

    error(
        "Unable to find a working TOTP token after $(length(mfa_devices) * max_windows) " *
        "attempts over $(duration * (max_windows - 1)) seconds.",
    )

    return nothing
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: apprunner
using AWS.Compat
using AWS.UUIDs

"""
    associate_custom_domain(domain_name, service_arn)
    associate_custom_domain(domain_name, service_arn, params::Dict{String,<:Any})

Associate your own domain name with the App Runner subdomain URL of your App Runner
service. After you call AssociateCustomDomain and receive a successful response, use the
information in the CustomDomain record that's returned to add CNAME records to your Domain
Name System (DNS). For each mapped domain name, add a mapping to the target App Runner
subdomain and one or more certificate validation records. App Runner then performs DNS
validation to verify that you own or control the domain name that you associated. App
Runner tracks domain validity in a certificate stored in AWS Certificate Manager (ACM).

# Arguments
- `domain_name`: A custom domain endpoint to associate. Specify a root domain (for example,
  example.com), a subdomain (for example, login.example.com or admin.login.example.com), or a
  wildcard (for example, *.example.com).
- `service_arn`: The Amazon Resource Name (ARN) of the App Runner service that you want to
  associate a custom domain name with.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"EnableWWWSubdomain"`: Set to true to associate the subdomain www.DomainName  with the
  App Runner service in addition to the base domain. Default: true
"""
function associate_custom_domain(
    DomainName, ServiceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apprunner(
        "AssociateCustomDomain",
        Dict{String,Any}("DomainName" => DomainName, "ServiceArn" => ServiceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_custom_domain(
    DomainName,
    ServiceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apprunner(
        "AssociateCustomDomain",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DomainName" => DomainName, "ServiceArn" => ServiceArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_auto_scaling_configuration(auto_scaling_configuration_name)
    create_auto_scaling_configuration(auto_scaling_configuration_name, params::Dict{String,<:Any})

Create an App Runner automatic scaling configuration resource. App Runner requires this
resource when you create or update App Runner services and you require non-default auto
scaling settings. You can share an auto scaling configuration across multiple services.
Create multiple revisions of a configuration by calling this action multiple times using
the same AutoScalingConfigurationName. The call returns incremental
AutoScalingConfigurationRevision values. When you create a service and configure an auto
scaling configuration resource, the service uses the latest active revision of the auto
scaling configuration by default. You can optionally configure the service to use a
specific revision. Configure a higher MinSize to increase the spread of your App Runner
service over more Availability Zones in the Amazon Web Services Region. The tradeoff is a
higher minimal cost. Configure a lower MaxSize to control your cost. The tradeoff is lower
responsiveness during peak demand.

# Arguments
- `auto_scaling_configuration_name`: A name for the auto scaling configuration. When you
  use it for the first time in an Amazon Web Services Region, App Runner creates revision
  number 1 of this name. When you use the same name in subsequent calls, App Runner creates
  incremental revisions of the configuration.  Prior to the release of Auto scale
  configuration enhancements, the name DefaultConfiguration was reserved.  This restriction
  is no longer in place. You can now manage DefaultConfiguration the same way you manage your
  custom auto scaling configurations. This means you can do the following with the
  DefaultConfiguration that App Runner provides:   Create new revisions of the
  DefaultConfiguration.   Delete the revisions of the DefaultConfiguration.   Delete the auto
  scaling configuration for which the App Runner DefaultConfiguration was created.   If you
  delete the auto scaling configuration you can create another custom auto scaling
  configuration with the same DefaultConfiguration name. The original DefaultConfiguration
  resource provided by App Runner remains in your account unless you make changes to it.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxConcurrency"`: The maximum number of concurrent requests that you want an instance
  to process. If the number of concurrent requests exceeds this limit, App Runner scales up
  your service. Default: 100
- `"MaxSize"`: The maximum number of instances that your service scales up to. At most
  MaxSize instances actively serve traffic for your service. Default: 25
- `"MinSize"`: The minimum number of instances that App Runner provisions for your service.
  The service always has at least MinSize provisioned instances. Some of them actively serve
  traffic. The rest of them (provisioned and inactive instances) are a cost-effective compute
  capacity reserve and are ready to be quickly activated. You pay for memory usage of all the
  provisioned instances. You pay for CPU usage of only the active subset. App Runner
  temporarily doubles the number of provisioned instances during deployments, to maintain the
  same capacity for both old and new code. Default: 1
- `"Tags"`: A list of metadata items that you can associate with your auto scaling
  configuration resource. A tag is a key-value pair.
"""
function create_auto_scaling_configuration(
    AutoScalingConfigurationName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apprunner(
        "CreateAutoScalingConfiguration",
        Dict{String,Any}("AutoScalingConfigurationName" => AutoScalingConfigurationName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_auto_scaling_configuration(
    AutoScalingConfigurationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apprunner(
        "CreateAutoScalingConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AutoScalingConfigurationName" => AutoScalingConfigurationName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_connection(connection_name, provider_type)
    create_connection(connection_name, provider_type, params::Dict{String,<:Any})

Create an App Runner connection resource. App Runner requires a connection resource when
you create App Runner services that access private repositories from certain third-party
providers. You can share a connection across multiple services. A connection resource is
needed to access GitHub and Bitbucket repositories. Both require a user interface approval
process through the App Runner console before you can use the connection.

# Arguments
- `connection_name`: A name for the new connection. It must be unique across all App Runner
  connections for the Amazon Web Services account in the Amazon Web Services Region.
- `provider_type`: The source repository provider.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: A list of metadata items that you can associate with your connection resource.
  A tag is a key-value pair.
"""
function create_connection(
    ConnectionName, ProviderType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apprunner(
        "CreateConnection",
        Dict{String,Any}(
            "ConnectionName" => ConnectionName, "ProviderType" => ProviderType
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_connection(
    ConnectionName,
    ProviderType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apprunner(
        "CreateConnection",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ConnectionName" => ConnectionName, "ProviderType" => ProviderType
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_observability_configuration(observability_configuration_name)
    create_observability_configuration(observability_configuration_name, params::Dict{String,<:Any})

Create an App Runner observability configuration resource. App Runner requires this
resource when you create or update App Runner services and you want to enable non-default
observability features. You can share an observability configuration across multiple
services. Create multiple revisions of a configuration by calling this action multiple
times using the same ObservabilityConfigurationName. The call returns incremental
ObservabilityConfigurationRevision values. When you create a service and configure an
observability configuration resource, the service uses the latest active revision of the
observability configuration by default. You can optionally configure the service to use a
specific revision. The observability configuration resource is designed to configure
multiple features (currently one feature, tracing). This action takes optional parameters
that describe the configuration of these features (currently one parameter,
TraceConfiguration). If you don't specify a feature parameter, App Runner doesn't enable
the feature.

# Arguments
- `observability_configuration_name`: A name for the observability configuration. When you
  use it for the first time in an Amazon Web Services Region, App Runner creates revision
  number 1 of this name. When you use the same name in subsequent calls, App Runner creates
  incremental revisions of the configuration.  The name DefaultConfiguration is reserved. You
  can't use it to create a new observability configuration, and you can't create a revision
  of it. When you want to use your own observability configuration for your App Runner
  service, create a configuration with a different name, and then provide it when you create
  or update your service.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: A list of metadata items that you can associate with your observability
  configuration resource. A tag is a key-value pair.
- `"TraceConfiguration"`: The configuration of the tracing feature within this
  observability configuration. If you don't specify it, App Runner doesn't enable tracing.
"""
function create_observability_configuration(
    ObservabilityConfigurationName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apprunner(
        "CreateObservabilityConfiguration",
        Dict{String,Any}(
            "ObservabilityConfigurationName" => ObservabilityConfigurationName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_observability_configuration(
    ObservabilityConfigurationName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apprunner(
        "CreateObservabilityConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ObservabilityConfigurationName" => ObservabilityConfigurationName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_service(service_name, source_configuration)
    create_service(service_name, source_configuration, params::Dict{String,<:Any})

Create an App Runner service. After the service is created, the action also automatically
starts a deployment. This is an asynchronous operation. On a successful call, you can use
the returned OperationId and the ListOperations call to track the operation's progress.

# Arguments
- `service_name`: A name for the App Runner service. It must be unique across all the
  running App Runner services in your Amazon Web Services account in the Amazon Web Services
  Region.
- `source_configuration`: The source to deploy to the App Runner service. It can be a code
  or an image repository.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AutoScalingConfigurationArn"`: The Amazon Resource Name (ARN) of an App Runner
  automatic scaling configuration resource that you want to associate with your service. If
  not provided, App Runner associates the latest revision of a default auto scaling
  configuration. Specify an ARN with a name and a revision number to associate that revision.
  For example:
  arn:aws:apprunner:us-east-1:123456789012:autoscalingconfiguration/high-availability/3
  Specify just the name to associate the latest revision. For example:
  arn:aws:apprunner:us-east-1:123456789012:autoscalingconfiguration/high-availability
- `"EncryptionConfiguration"`: An optional custom encryption key that App Runner uses to
  encrypt the copy of your source repository that it maintains and your service logs. By
  default, App Runner uses an Amazon Web Services managed key.
- `"HealthCheckConfiguration"`: The settings for the health check that App Runner performs
  to monitor the health of the App Runner service.
- `"InstanceConfiguration"`: The runtime configuration of instances (scaling units) of your
  service.
- `"NetworkConfiguration"`: Configuration settings related to network traffic of the web
  application that the App Runner service runs.
- `"ObservabilityConfiguration"`: The observability configuration of your service.
- `"Tags"`: An optional list of metadata items that you can associate with the App Runner
  service resource. A tag is a key-value pair.
"""
function create_service(
    ServiceName, SourceConfiguration; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apprunner(
        "CreateService",
        Dict{String,Any}(
            "ServiceName" => ServiceName, "SourceConfiguration" => SourceConfiguration
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_service(
    ServiceName,
    SourceConfiguration,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apprunner(
        "CreateService",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ServiceName" => ServiceName,
                    "SourceConfiguration" => SourceConfiguration,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_vpc_connector(subnets, vpc_connector_name)
    create_vpc_connector(subnets, vpc_connector_name, params::Dict{String,<:Any})

Create an App Runner VPC connector resource. App Runner requires this resource when you
want to associate your App Runner service to a custom Amazon Virtual Private Cloud (Amazon
VPC).

# Arguments
- `subnets`: A list of IDs of subnets that App Runner should use when it associates your
  service with a custom Amazon VPC. Specify IDs of subnets of a single Amazon VPC. App Runner
  determines the Amazon VPC from the subnets you specify.   App Runner currently only
  provides support for IPv4.
- `vpc_connector_name`: A name for the VPC connector.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"SecurityGroups"`: A list of IDs of security groups that App Runner should use for
  access to Amazon Web Services resources under the specified subnets. If not specified, App
  Runner uses the default security group of the Amazon VPC. The default security group allows
  all outbound traffic.
- `"Tags"`: A list of metadata items that you can associate with your VPC connector
  resource. A tag is a key-value pair.
"""
function create_vpc_connector(
    Subnets, VpcConnectorName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apprunner(
        "CreateVpcConnector",
        Dict{String,Any}("Subnets" => Subnets, "VpcConnectorName" => VpcConnectorName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_vpc_connector(
    Subnets,
    VpcConnectorName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apprunner(
        "CreateVpcConnector",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Subnets" => Subnets, "VpcConnectorName" => VpcConnectorName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_vpc_ingress_connection(ingress_vpc_configuration, service_arn, vpc_ingress_connection_name)
    create_vpc_ingress_connection(ingress_vpc_configuration, service_arn, vpc_ingress_connection_name, params::Dict{String,<:Any})

Create an App Runner VPC Ingress Connection resource. App Runner requires this resource
when you want to associate your App Runner service with an Amazon VPC endpoint.

# Arguments
- `ingress_vpc_configuration`: Specifications for the customer’s Amazon VPC and the
  related Amazon Web Services PrivateLink VPC endpoint that are used to create the VPC
  Ingress Connection resource.
- `service_arn`: The Amazon Resource Name (ARN) for this App Runner service that is used to
  create the VPC Ingress Connection resource.
- `vpc_ingress_connection_name`: A name for the VPC Ingress Connection resource. It must be
  unique across all the active VPC Ingress Connections in your Amazon Web Services account in
  the Amazon Web Services Region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Tags"`: An optional list of metadata items that you can associate with the VPC Ingress
  Connection resource. A tag is a key-value pair.
"""
function create_vpc_ingress_connection(
    IngressVpcConfiguration,
    ServiceArn,
    VpcIngressConnectionName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apprunner(
        "CreateVpcIngressConnection",
        Dict{String,Any}(
            "IngressVpcConfiguration" => IngressVpcConfiguration,
            "ServiceArn" => ServiceArn,
            "VpcIngressConnectionName" => VpcIngressConnectionName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_vpc_ingress_connection(
    IngressVpcConfiguration,
    ServiceArn,
    VpcIngressConnectionName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apprunner(
        "CreateVpcIngressConnection",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "IngressVpcConfiguration" => IngressVpcConfiguration,
                    "ServiceArn" => ServiceArn,
                    "VpcIngressConnectionName" => VpcIngressConnectionName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_auto_scaling_configuration(auto_scaling_configuration_arn)
    delete_auto_scaling_configuration(auto_scaling_configuration_arn, params::Dict{String,<:Any})

Delete an App Runner automatic scaling configuration resource. You can delete a top level
auto scaling configuration, a specific revision of one, or all revisions associated with
the top level configuration. You can't delete the default auto scaling configuration or a
configuration that's used by one or more App Runner services.

# Arguments
- `auto_scaling_configuration_arn`: The Amazon Resource Name (ARN) of the App Runner auto
  scaling configuration that you want to delete. The ARN can be a full auto scaling
  configuration ARN, or a partial ARN ending with either .../name  or .../name/revision . If
  a revision isn't specified, the latest active revision is deleted.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DeleteAllRevisions"`: Set to true to delete all of the revisions associated with the
  AutoScalingConfigurationArn parameter value. When DeleteAllRevisions is set to true, the
  only valid value for the Amazon Resource Name (ARN) is a partial ARN ending with: .../name.
"""
function delete_auto_scaling_configuration(
    AutoScalingConfigurationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apprunner(
        "DeleteAutoScalingConfiguration",
        Dict{String,Any}("AutoScalingConfigurationArn" => AutoScalingConfigurationArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_auto_scaling_configuration(
    AutoScalingConfigurationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apprunner(
        "DeleteAutoScalingConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AutoScalingConfigurationArn" => AutoScalingConfigurationArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_connection(connection_arn)
    delete_connection(connection_arn, params::Dict{String,<:Any})

Delete an App Runner connection. You must first ensure that there are no running App Runner
services that use this connection. If there are any, the DeleteConnection action fails.

# Arguments
- `connection_arn`: The Amazon Resource Name (ARN) of the App Runner connection that you
  want to delete.

"""
function delete_connection(
    ConnectionArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apprunner(
        "DeleteConnection",
        Dict{String,Any}("ConnectionArn" => ConnectionArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_connection(
    ConnectionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apprunner(
        "DeleteConnection",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ConnectionArn" => ConnectionArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_observability_configuration(observability_configuration_arn)
    delete_observability_configuration(observability_configuration_arn, params::Dict{String,<:Any})

Delete an App Runner observability configuration resource. You can delete a specific
revision or the latest active revision. You can't delete a configuration that's used by one
or more App Runner services.

# Arguments
- `observability_configuration_arn`: The Amazon Resource Name (ARN) of the App Runner
  observability configuration that you want to delete. The ARN can be a full observability
  configuration ARN, or a partial ARN ending with either .../name  or .../name/revision . If
  a revision isn't specified, the latest active revision is deleted.

"""
function delete_observability_configuration(
    ObservabilityConfigurationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apprunner(
        "DeleteObservabilityConfiguration",
        Dict{String,Any}("ObservabilityConfigurationArn" => ObservabilityConfigurationArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_observability_configuration(
    ObservabilityConfigurationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apprunner(
        "DeleteObservabilityConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ObservabilityConfigurationArn" => ObservabilityConfigurationArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_service(service_arn)
    delete_service(service_arn, params::Dict{String,<:Any})

Delete an App Runner service. This is an asynchronous operation. On a successful call, you
can use the returned OperationId and the ListOperations call to track the operation's
progress.  Make sure that you don't have any active VPCIngressConnections associated with
the service you want to delete.

# Arguments
- `service_arn`: The Amazon Resource Name (ARN) of the App Runner service that you want to
  delete.

"""
function delete_service(ServiceArn; aws_config::AbstractAWSConfig=current_aws_config())
    return apprunner(
        "DeleteService",
        Dict{String,Any}("ServiceArn" => ServiceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_service(
    ServiceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apprunner(
        "DeleteService",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ServiceArn" => ServiceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_vpc_connector(vpc_connector_arn)
    delete_vpc_connector(vpc_connector_arn, params::Dict{String,<:Any})

Delete an App Runner VPC connector resource. You can't delete a connector that's used by
one or more App Runner services.

# Arguments
- `vpc_connector_arn`: The Amazon Resource Name (ARN) of the App Runner VPC connector that
  you want to delete. The ARN must be a full VPC connector ARN.

"""
function delete_vpc_connector(
    VpcConnectorArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apprunner(
        "DeleteVpcConnector",
        Dict{String,Any}("VpcConnectorArn" => VpcConnectorArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_vpc_connector(
    VpcConnectorArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apprunner(
        "DeleteVpcConnector",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("VpcConnectorArn" => VpcConnectorArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_vpc_ingress_connection(vpc_ingress_connection_arn)
    delete_vpc_ingress_connection(vpc_ingress_connection_arn, params::Dict{String,<:Any})

Delete an App Runner VPC Ingress Connection resource that's associated with an App Runner
service. The VPC Ingress Connection must be in one of the following states to be deleted:
  AVAILABLE     FAILED_CREATION     FAILED_UPDATE     FAILED_DELETION

# Arguments
- `vpc_ingress_connection_arn`: The Amazon Resource Name (ARN) of the App Runner VPC
  Ingress Connection that you want to delete.

"""
function delete_vpc_ingress_connection(
    VpcIngressConnectionArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apprunner(
        "DeleteVpcIngressConnection",
        Dict{String,Any}("VpcIngressConnectionArn" => VpcIngressConnectionArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_vpc_ingress_connection(
    VpcIngressConnectionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apprunner(
        "DeleteVpcIngressConnection",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("VpcIngressConnectionArn" => VpcIngressConnectionArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_auto_scaling_configuration(auto_scaling_configuration_arn)
    describe_auto_scaling_configuration(auto_scaling_configuration_arn, params::Dict{String,<:Any})

Return a full description of an App Runner automatic scaling configuration resource.

# Arguments
- `auto_scaling_configuration_arn`: The Amazon Resource Name (ARN) of the App Runner auto
  scaling configuration that you want a description for. The ARN can be a full auto scaling
  configuration ARN, or a partial ARN ending with either .../name  or .../name/revision . If
  a revision isn't specified, the latest active revision is described.

"""
function describe_auto_scaling_configuration(
    AutoScalingConfigurationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apprunner(
        "DescribeAutoScalingConfiguration",
        Dict{String,Any}("AutoScalingConfigurationArn" => AutoScalingConfigurationArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_auto_scaling_configuration(
    AutoScalingConfigurationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apprunner(
        "DescribeAutoScalingConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AutoScalingConfigurationArn" => AutoScalingConfigurationArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_custom_domains(service_arn)
    describe_custom_domains(service_arn, params::Dict{String,<:Any})

Return a description of custom domain names that are associated with an App Runner service.

# Arguments
- `service_arn`: The Amazon Resource Name (ARN) of the App Runner service that you want
  associated custom domain names to be described for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results that each response (result page) can
  include. It's used for a paginated request. If you don't specify MaxResults, the request
  retrieves all available results in a single response.
- `"NextToken"`: A token from a previous result page. It's used for a paginated request.
  The request retrieves the next result page. All other parameter values must be identical to
  the ones that are specified in the initial request. If you don't specify NextToken, the
  request retrieves the first result page.
"""
function describe_custom_domains(
    ServiceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apprunner(
        "DescribeCustomDomains",
        Dict{String,Any}("ServiceArn" => ServiceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_custom_domains(
    ServiceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apprunner(
        "DescribeCustomDomains",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ServiceArn" => ServiceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_observability_configuration(observability_configuration_arn)
    describe_observability_configuration(observability_configuration_arn, params::Dict{String,<:Any})

Return a full description of an App Runner observability configuration resource.

# Arguments
- `observability_configuration_arn`: The Amazon Resource Name (ARN) of the App Runner
  observability configuration that you want a description for. The ARN can be a full
  observability configuration ARN, or a partial ARN ending with either .../name  or
  .../name/revision . If a revision isn't specified, the latest active revision is described.

"""
function describe_observability_configuration(
    ObservabilityConfigurationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apprunner(
        "DescribeObservabilityConfiguration",
        Dict{String,Any}("ObservabilityConfigurationArn" => ObservabilityConfigurationArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_observability_configuration(
    ObservabilityConfigurationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apprunner(
        "DescribeObservabilityConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ObservabilityConfigurationArn" => ObservabilityConfigurationArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_service(service_arn)
    describe_service(service_arn, params::Dict{String,<:Any})

Return a full description of an App Runner service.

# Arguments
- `service_arn`: The Amazon Resource Name (ARN) of the App Runner service that you want a
  description for.

"""
function describe_service(ServiceArn; aws_config::AbstractAWSConfig=current_aws_config())
    return apprunner(
        "DescribeService",
        Dict{String,Any}("ServiceArn" => ServiceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_service(
    ServiceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apprunner(
        "DescribeService",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ServiceArn" => ServiceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_vpc_connector(vpc_connector_arn)
    describe_vpc_connector(vpc_connector_arn, params::Dict{String,<:Any})

Return a description of an App Runner VPC connector resource.

# Arguments
- `vpc_connector_arn`: The Amazon Resource Name (ARN) of the App Runner VPC connector that
  you want a description for. The ARN must be a full VPC connector ARN.

"""
function describe_vpc_connector(
    VpcConnectorArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apprunner(
        "DescribeVpcConnector",
        Dict{String,Any}("VpcConnectorArn" => VpcConnectorArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_vpc_connector(
    VpcConnectorArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apprunner(
        "DescribeVpcConnector",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("VpcConnectorArn" => VpcConnectorArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_vpc_ingress_connection(vpc_ingress_connection_arn)
    describe_vpc_ingress_connection(vpc_ingress_connection_arn, params::Dict{String,<:Any})

Return a full description of an App Runner VPC Ingress Connection resource.

# Arguments
- `vpc_ingress_connection_arn`: The Amazon Resource Name (ARN) of the App Runner VPC
  Ingress Connection that you want a description for.

"""
function describe_vpc_ingress_connection(
    VpcIngressConnectionArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apprunner(
        "DescribeVpcIngressConnection",
        Dict{String,Any}("VpcIngressConnectionArn" => VpcIngressConnectionArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_vpc_ingress_connection(
    VpcIngressConnectionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apprunner(
        "DescribeVpcIngressConnection",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("VpcIngressConnectionArn" => VpcIngressConnectionArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_custom_domain(domain_name, service_arn)
    disassociate_custom_domain(domain_name, service_arn, params::Dict{String,<:Any})

Disassociate a custom domain name from an App Runner service. Certificates tracking domain
validity are associated with a custom domain and are stored in AWS Certificate Manager
(ACM). These certificates aren't deleted as part of this action. App Runner delays
certificate deletion for 30 days after a domain is disassociated from your service.

# Arguments
- `domain_name`: The domain name that you want to disassociate from the App Runner service.
- `service_arn`: The Amazon Resource Name (ARN) of the App Runner service that you want to
  disassociate a custom domain name from.

"""
function disassociate_custom_domain(
    DomainName, ServiceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apprunner(
        "DisassociateCustomDomain",
        Dict{String,Any}("DomainName" => DomainName, "ServiceArn" => ServiceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_custom_domain(
    DomainName,
    ServiceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apprunner(
        "DisassociateCustomDomain",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DomainName" => DomainName, "ServiceArn" => ServiceArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_auto_scaling_configurations()
    list_auto_scaling_configurations(params::Dict{String,<:Any})

Returns a list of active App Runner automatic scaling configurations in your Amazon Web
Services account. You can query the revisions for a specific configuration name or the
revisions for all active configurations in your account. You can optionally query only the
latest revision of each requested name. To retrieve a full description of a particular
configuration revision, call and provide one of the ARNs returned by
ListAutoScalingConfigurations.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AutoScalingConfigurationName"`: The name of the App Runner auto scaling configuration
  that you want to list. If specified, App Runner lists revisions that share this name. If
  not specified, App Runner returns revisions of all active configurations.
- `"LatestOnly"`: Set to true to list only the latest revision for each requested
  configuration name. Set to false to list all revisions for each requested configuration
  name. Default: true
- `"MaxResults"`: The maximum number of results to include in each response (result page).
  It's used for a paginated request. If you don't specify MaxResults, the request retrieves
  all available results in a single response.
- `"NextToken"`: A token from a previous result page. It's used for a paginated request.
  The request retrieves the next result page. All other parameter values must be identical to
  the ones that are specified in the initial request. If you don't specify NextToken, the
  request retrieves the first result page.
"""
function list_auto_scaling_configurations(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return apprunner(
        "ListAutoScalingConfigurations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_auto_scaling_configurations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apprunner(
        "ListAutoScalingConfigurations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_connections()
    list_connections(params::Dict{String,<:Any})

Returns a list of App Runner connections that are associated with your Amazon Web Services
account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConnectionName"`: If specified, only this connection is returned. If not specified, the
  result isn't filtered by name.
- `"MaxResults"`: The maximum number of results to include in each response (result page).
  Used for a paginated request. If you don't specify MaxResults, the request retrieves all
  available results in a single response.
- `"NextToken"`: A token from a previous result page. Used for a paginated request. The
  request retrieves the next result page. All other parameter values must be identical to the
  ones specified in the initial request. If you don't specify NextToken, the request
  retrieves the first result page.
"""
function list_connections(; aws_config::AbstractAWSConfig=current_aws_config())
    return apprunner(
        "ListConnections"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_connections(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apprunner(
        "ListConnections", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_observability_configurations()
    list_observability_configurations(params::Dict{String,<:Any})

Returns a list of active App Runner observability configurations in your Amazon Web
Services account. You can query the revisions for a specific configuration name or the
revisions for all active configurations in your account. You can optionally query only the
latest revision of each requested name. To retrieve a full description of a particular
configuration revision, call and provide one of the ARNs returned by
ListObservabilityConfigurations.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"LatestOnly"`: Set to true to list only the latest revision for each requested
  configuration name. Set to false to list all revisions for each requested configuration
  name. Default: true
- `"MaxResults"`: The maximum number of results to include in each response (result page).
  It's used for a paginated request. If you don't specify MaxResults, the request retrieves
  all available results in a single response.
- `"NextToken"`: A token from a previous result page. It's used for a paginated request.
  The request retrieves the next result page. All other parameter values must be identical to
  the ones that are specified in the initial request. If you don't specify NextToken, the
  request retrieves the first result page.
- `"ObservabilityConfigurationName"`: The name of the App Runner observability
  configuration that you want to list. If specified, App Runner lists revisions that share
  this name. If not specified, App Runner returns revisions of all active configurations.
"""
function list_observability_configurations(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return apprunner(
        "ListObservabilityConfigurations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_observability_configurations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apprunner(
        "ListObservabilityConfigurations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_operations(service_arn)
    list_operations(service_arn, params::Dict{String,<:Any})

Return a list of operations that occurred on an App Runner service. The resulting list of
OperationSummary objects is sorted in reverse chronological order. The first object on the
list represents the last started operation.

# Arguments
- `service_arn`: The Amazon Resource Name (ARN) of the App Runner service that you want a
  list of operations for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to include in each response (result page).
  It's used for a paginated request. If you don't specify MaxResults, the request retrieves
  all available results in a single response.
- `"NextToken"`: A token from a previous result page. It's used for a paginated request.
  The request retrieves the next result page. All other parameter values must be identical to
  the ones specified in the initial request. If you don't specify NextToken, the request
  retrieves the first result page.
"""
function list_operations(ServiceArn; aws_config::AbstractAWSConfig=current_aws_config())
    return apprunner(
        "ListOperations",
        Dict{String,Any}("ServiceArn" => ServiceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_operations(
    ServiceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apprunner(
        "ListOperations",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ServiceArn" => ServiceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_services()
    list_services(params::Dict{String,<:Any})

Returns a list of running App Runner services in your Amazon Web Services account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to include in each response (result page).
  It's used for a paginated request. If you don't specify MaxResults, the request retrieves
  all available results in a single response.
- `"NextToken"`: A token from a previous result page. Used for a paginated request. The
  request retrieves the next result page. All other parameter values must be identical to the
  ones specified in the initial request. If you don't specify NextToken, the request
  retrieves the first result page.
"""
function list_services(; aws_config::AbstractAWSConfig=current_aws_config())
    return apprunner("ListServices"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_services(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apprunner(
        "ListServices", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_services_for_auto_scaling_configuration(auto_scaling_configuration_arn)
    list_services_for_auto_scaling_configuration(auto_scaling_configuration_arn, params::Dict{String,<:Any})

Returns a list of the associated App Runner services using an auto scaling configuration.

# Arguments
- `auto_scaling_configuration_arn`: The Amazon Resource Name (ARN) of the App Runner auto
  scaling configuration that you want to list the services for. The ARN can be a full auto
  scaling configuration ARN, or a partial ARN ending with either .../name  or
  .../name/revision . If a revision isn't specified, the latest active revision is used.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to include in each response (result page).
  It's used for a paginated request. If you don't specify MaxResults, the request retrieves
  all available results in a single response.
- `"NextToken"`: A token from a previous result page. It's used for a paginated request.
  The request retrieves the next result page. All other parameter values must be identical to
  the ones specified in the initial request. If you don't specify NextToken, the request
  retrieves the first result page.
"""
function list_services_for_auto_scaling_configuration(
    AutoScalingConfigurationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apprunner(
        "ListServicesForAutoScalingConfiguration",
        Dict{String,Any}("AutoScalingConfigurationArn" => AutoScalingConfigurationArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_services_for_auto_scaling_configuration(
    AutoScalingConfigurationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apprunner(
        "ListServicesForAutoScalingConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AutoScalingConfigurationArn" => AutoScalingConfigurationArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

List tags that are associated with for an App Runner resource. The response contains a list
of tag key-value pairs.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource that a tag list is
  requested for. It must be the ARN of an App Runner resource.

"""
function list_tags_for_resource(
    ResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apprunner(
        "ListTagsForResource",
        Dict{String,Any}("ResourceArn" => ResourceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    ResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apprunner(
        "ListTagsForResource",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ResourceArn" => ResourceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_vpc_connectors()
    list_vpc_connectors(params::Dict{String,<:Any})

Returns a list of App Runner VPC connectors in your Amazon Web Services account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to include in each response (result page).
  It's used for a paginated request. If you don't specify MaxResults, the request retrieves
  all available results in a single response.
- `"NextToken"`: A token from a previous result page. It's used for a paginated request.
  The request retrieves the next result page. All other parameter values must be identical to
  the ones that are specified in the initial request. If you don't specify NextToken, the
  request retrieves the first result page.
"""
function list_vpc_connectors(; aws_config::AbstractAWSConfig=current_aws_config())
    return apprunner(
        "ListVpcConnectors"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_vpc_connectors(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apprunner(
        "ListVpcConnectors", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_vpc_ingress_connections()
    list_vpc_ingress_connections(params::Dict{String,<:Any})

Return a list of App Runner VPC Ingress Connections in your Amazon Web Services account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Filter"`: The VPC Ingress Connections to be listed based on either the Service Arn or
  Vpc Endpoint Id, or both.
- `"MaxResults"`: The maximum number of results to include in each response (result page).
  It's used for a paginated request. If you don't specify MaxResults, the request retrieves
  all available results in a single response.
- `"NextToken"`: A token from a previous result page. It's used for a paginated request.
  The request retrieves the next result page. All other parameter values must be identical to
  the ones that are specified in the initial request. If you don't specify NextToken, the
  request retrieves the first result page.
"""
function list_vpc_ingress_connections(; aws_config::AbstractAWSConfig=current_aws_config())
    return apprunner(
        "ListVpcIngressConnections"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_vpc_ingress_connections(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apprunner(
        "ListVpcIngressConnections",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    pause_service(service_arn)
    pause_service(service_arn, params::Dict{String,<:Any})

Pause an active App Runner service. App Runner reduces compute capacity for the service to
zero and loses state (for example, ephemeral storage is removed). This is an asynchronous
operation. On a successful call, you can use the returned OperationId and the
ListOperations call to track the operation's progress.

# Arguments
- `service_arn`: The Amazon Resource Name (ARN) of the App Runner service that you want to
  pause.

"""
function pause_service(ServiceArn; aws_config::AbstractAWSConfig=current_aws_config())
    return apprunner(
        "PauseService",
        Dict{String,Any}("ServiceArn" => ServiceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function pause_service(
    ServiceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apprunner(
        "PauseService",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ServiceArn" => ServiceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    resume_service(service_arn)
    resume_service(service_arn, params::Dict{String,<:Any})

Resume an active App Runner service. App Runner provisions compute capacity for the
service. This is an asynchronous operation. On a successful call, you can use the returned
OperationId and the ListOperations call to track the operation's progress.

# Arguments
- `service_arn`: The Amazon Resource Name (ARN) of the App Runner service that you want to
  resume.

"""
function resume_service(ServiceArn; aws_config::AbstractAWSConfig=current_aws_config())
    return apprunner(
        "ResumeService",
        Dict{String,Any}("ServiceArn" => ServiceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function resume_service(
    ServiceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apprunner(
        "ResumeService",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ServiceArn" => ServiceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_deployment(service_arn)
    start_deployment(service_arn, params::Dict{String,<:Any})

Initiate a manual deployment of the latest commit in a source code repository or the latest
image in a source image repository to an App Runner service. For a source code repository,
App Runner retrieves the commit and builds a Docker image. For a source image repository,
App Runner retrieves the latest Docker image. In both cases, App Runner then deploys the
new image to your service and starts a new container instance. This is an asynchronous
operation. On a successful call, you can use the returned OperationId and the
ListOperations call to track the operation's progress.

# Arguments
- `service_arn`: The Amazon Resource Name (ARN) of the App Runner service that you want to
  manually deploy to.

"""
function start_deployment(ServiceArn; aws_config::AbstractAWSConfig=current_aws_config())
    return apprunner(
        "StartDeployment",
        Dict{String,Any}("ServiceArn" => ServiceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_deployment(
    ServiceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apprunner(
        "StartDeployment",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ServiceArn" => ServiceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Add tags to, or update the tag values of, an App Runner resource. A tag is a key-value pair.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource that you want to update
  tags for. It must be the ARN of an App Runner resource.
- `tags`: A list of tag key-value pairs to add or update. If a key is new to the resource,
  the tag is added with the provided value. If a key is already associated with the resource,
  the value of the tag is updated.

"""
function tag_resource(ResourceArn, Tags; aws_config::AbstractAWSConfig=current_aws_config())
    return apprunner(
        "TagResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    ResourceArn,
    Tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apprunner(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "Tags" => Tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Remove tags from an App Runner resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource that you want to remove
  tags from. It must be the ARN of an App Runner resource.
- `tag_keys`: A list of tag keys that you want to remove.

"""
function untag_resource(
    ResourceArn, TagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apprunner(
        "UntagResource",
        Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    ResourceArn,
    TagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apprunner(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("ResourceArn" => ResourceArn, "TagKeys" => TagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_default_auto_scaling_configuration(auto_scaling_configuration_arn)
    update_default_auto_scaling_configuration(auto_scaling_configuration_arn, params::Dict{String,<:Any})

Update an auto scaling configuration to be the default. The existing default auto scaling
configuration will be set to non-default automatically.

# Arguments
- `auto_scaling_configuration_arn`: The Amazon Resource Name (ARN) of the App Runner auto
  scaling configuration that you want to set as the default. The ARN can be a full auto
  scaling configuration ARN, or a partial ARN ending with either .../name  or
  .../name/revision . If a revision isn't specified, the latest active revision is set as the
  default.

"""
function update_default_auto_scaling_configuration(
    AutoScalingConfigurationArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return apprunner(
        "UpdateDefaultAutoScalingConfiguration",
        Dict{String,Any}("AutoScalingConfigurationArn" => AutoScalingConfigurationArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_default_auto_scaling_configuration(
    AutoScalingConfigurationArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apprunner(
        "UpdateDefaultAutoScalingConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AutoScalingConfigurationArn" => AutoScalingConfigurationArn
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_service(service_arn)
    update_service(service_arn, params::Dict{String,<:Any})

Update an App Runner service. You can update the source configuration and instance
configuration of the service. You can also update the ARN of the auto scaling configuration
resource that's associated with the service. However, you can't change the name or the
encryption configuration of the service. These can be set only when you create the service.
To update the tags applied to your service, use the separate actions TagResource and
UntagResource. This is an asynchronous operation. On a successful call, you can use the
returned OperationId and the ListOperations call to track the operation's progress.

# Arguments
- `service_arn`: The Amazon Resource Name (ARN) of the App Runner service that you want to
  update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AutoScalingConfigurationArn"`: The Amazon Resource Name (ARN) of an App Runner
  automatic scaling configuration resource that you want to associate with the App Runner
  service.
- `"HealthCheckConfiguration"`: The settings for the health check that App Runner performs
  to monitor the health of the App Runner service.
- `"InstanceConfiguration"`: The runtime configuration to apply to instances (scaling
  units) of your service.
- `"NetworkConfiguration"`: Configuration settings related to network traffic of the web
  application that the App Runner service runs.
- `"ObservabilityConfiguration"`: The observability configuration of your service.
- `"SourceConfiguration"`: The source configuration to apply to the App Runner service. You
  can change the configuration of the code or image repository that the service uses.
  However, you can't switch from code to image or the other way around. This means that you
  must provide the same structure member of SourceConfiguration that you originally included
  when you created the service. Specifically, you can include either CodeRepository or
  ImageRepository. To update the source configuration, set the values to members of the
  structure that you include.
"""
function update_service(ServiceArn; aws_config::AbstractAWSConfig=current_aws_config())
    return apprunner(
        "UpdateService",
        Dict{String,Any}("ServiceArn" => ServiceArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_service(
    ServiceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apprunner(
        "UpdateService",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("ServiceArn" => ServiceArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_vpc_ingress_connection(ingress_vpc_configuration, vpc_ingress_connection_arn)
    update_vpc_ingress_connection(ingress_vpc_configuration, vpc_ingress_connection_arn, params::Dict{String,<:Any})

Update an existing App Runner VPC Ingress Connection resource. The VPC Ingress Connection
must be in one of the following states to be updated:    AVAILABLE     FAILED_CREATION
FAILED_UPDATE

# Arguments
- `ingress_vpc_configuration`: Specifications for the customer’s Amazon VPC and the
  related Amazon Web Services PrivateLink VPC endpoint that are used to update the VPC
  Ingress Connection resource.
- `vpc_ingress_connection_arn`: The Amazon Resource Name (Arn) for the App Runner VPC
  Ingress Connection resource that you want to update.

"""
function update_vpc_ingress_connection(
    IngressVpcConfiguration,
    VpcIngressConnectionArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apprunner(
        "UpdateVpcIngressConnection",
        Dict{String,Any}(
            "IngressVpcConfiguration" => IngressVpcConfiguration,
            "VpcIngressConnectionArn" => VpcIngressConnectionArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_vpc_ingress_connection(
    IngressVpcConfiguration,
    VpcIngressConnectionArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return apprunner(
        "UpdateVpcIngressConnection",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "IngressVpcConfiguration" => IngressVpcConfiguration,
                    "VpcIngressConnectionArn" => VpcIngressConnectionArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: mobile
using AWS.Compat
using AWS.UUIDs

"""
    create_project()
    create_project(params::Dict{String,<:Any})

 Creates an AWS Mobile Hub project.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"contents"`:  ZIP or YAML file which contains configuration settings to be used when
  creating the project. This may be the contents of the file downloaded from the URL provided
  in an export project operation.
- `"name"`:  Name of the project.
- `"region"`:  Default region where project resources should be created.
- `"snapshotId"`:  Unique identifier for an exported snapshot of project configuration.
  This snapshot identifier is included in the share URL when a project is exported.
"""
function create_project(; aws_config::AbstractAWSConfig=current_aws_config())
    return mobile(
        "POST", "/projects"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function create_project(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mobile(
        "POST", "/projects", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    delete_project(project_id)
    delete_project(project_id, params::Dict{String,<:Any})

 Delets a project in AWS Mobile Hub.

# Arguments
- `project_id`:  Unique project identifier.

"""
function delete_project(projectId; aws_config::AbstractAWSConfig=current_aws_config())
    return mobile(
        "DELETE",
        "/projects/$(projectId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_project(
    projectId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mobile(
        "DELETE",
        "/projects/$(projectId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_bundle(bundle_id)
    describe_bundle(bundle_id, params::Dict{String,<:Any})

 Get the bundle details for the requested bundle id.

# Arguments
- `bundle_id`:  Unique bundle identifier.

"""
function describe_bundle(bundleId; aws_config::AbstractAWSConfig=current_aws_config())
    return mobile(
        "GET",
        "/bundles/$(bundleId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_bundle(
    bundleId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mobile(
        "GET",
        "/bundles/$(bundleId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_project(project_id)
    describe_project(project_id, params::Dict{String,<:Any})

 Gets details about a project in AWS Mobile Hub.

# Arguments
- `project_id`:  Unique project identifier.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"syncFromResources"`:  If set to true, causes AWS Mobile Hub to synchronize information
  from other services, e.g., update state of AWS CloudFormation stacks in the AWS Mobile Hub
  project.
"""
function describe_project(projectId; aws_config::AbstractAWSConfig=current_aws_config())
    return mobile(
        "GET",
        "/project",
        Dict{String,Any}("projectId" => projectId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_project(
    projectId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mobile(
        "GET",
        "/project",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("projectId" => projectId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    export_bundle(bundle_id)
    export_bundle(bundle_id, params::Dict{String,<:Any})

 Generates customized software development kit (SDK) and or tool packages used to integrate
mobile web or mobile app clients with backend AWS resources.

# Arguments
- `bundle_id`:  Unique bundle identifier.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"platform"`:  Developer desktop or target application platform.
- `"projectId"`:  Unique project identifier.
"""
function export_bundle(bundleId; aws_config::AbstractAWSConfig=current_aws_config())
    return mobile(
        "POST",
        "/bundles/$(bundleId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function export_bundle(
    bundleId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mobile(
        "POST",
        "/bundles/$(bundleId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    export_project(project_id)
    export_project(project_id, params::Dict{String,<:Any})

 Exports project configuration to a snapshot which can be downloaded and shared. Note that
mobile app push credentials are encrypted in exported projects, so they can only be shared
successfully within the same AWS account.

# Arguments
- `project_id`:  Unique project identifier.

"""
function export_project(projectId; aws_config::AbstractAWSConfig=current_aws_config())
    return mobile(
        "POST",
        "/exports/$(projectId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function export_project(
    projectId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mobile(
        "POST",
        "/exports/$(projectId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_bundles()
    list_bundles(params::Dict{String,<:Any})

 List all available bundles.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:  Maximum number of records to list in a single response.
- `"nextToken"`:  Pagination token. Set to null to start listing bundles from start. If
  non-null pagination token is returned in a result, then pass its value in here in another
  request to list more bundles.
"""
function list_bundles(; aws_config::AbstractAWSConfig=current_aws_config())
    return mobile("GET", "/bundles"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_bundles(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mobile(
        "GET", "/bundles", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_projects()
    list_projects(params::Dict{String,<:Any})

 Lists projects in AWS Mobile Hub.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`:  Maximum number of records to list in a single response.
- `"nextToken"`:  Pagination token. Set to null to start listing projects from start. If
  non-null pagination token is returned in a result, then pass its value in here in another
  request to list more projects.
"""
function list_projects(; aws_config::AbstractAWSConfig=current_aws_config())
    return mobile(
        "GET", "/projects"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_projects(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return mobile(
        "GET", "/projects", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    update_project(project_id)
    update_project(project_id, params::Dict{String,<:Any})

 Update an existing project.

# Arguments
- `project_id`:  Unique project identifier.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"contents"`:  ZIP or YAML file which contains project configuration to be updated. This
  should be the contents of the file downloaded from the URL provided in an export project
  operation.
"""
function update_project(projectId; aws_config::AbstractAWSConfig=current_aws_config())
    return mobile(
        "POST",
        "/update",
        Dict{String,Any}("projectId" => projectId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_project(
    projectId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return mobile(
        "POST",
        "/update",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("projectId" => projectId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: elastic_transcoder
using AWS.Compat
using AWS.UUIDs

"""
    cancel_job(id)
    cancel_job(id, params::Dict{String,<:Any})

The CancelJob operation cancels an unfinished job.  You can only cancel a job that has a
status of Submitted. To prevent a pipeline from starting to process a job while you're
getting the job identifier, use UpdatePipelineStatus to temporarily pause the pipeline.

# Arguments
- `id`: The identifier of the job that you want to cancel. To get a list of the jobs
  (including their jobId) that have a status of Submitted, use the ListJobsByStatus API
  action.

"""
function cancel_job(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return elastic_transcoder(
        "DELETE",
        "/2012-09-25/jobs/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_job(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_transcoder(
        "DELETE",
        "/2012-09-25/jobs/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_job(pipeline_id)
    create_job(pipeline_id, params::Dict{String,<:Any})

When you create a job, Elastic Transcoder returns JSON data that includes the values that
you specified plus information about the job that is created. If you have specified more
than one output for your jobs (for example, one output for the Kindle Fire and another
output for the Apple iPhone 4s), you currently must use the Elastic Transcoder API to list
the jobs (as opposed to the AWS Console).

# Arguments
- `pipeline_id`: The Id of the pipeline that you want Elastic Transcoder to use for
  transcoding. The pipeline determines several settings, including the Amazon S3 bucket from
  which Elastic Transcoder gets the files to transcode and the bucket into which Elastic
  Transcoder puts the transcoded files.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Input"`: A section of the request body that provides information about the file that is
  being transcoded.
- `"Inputs"`: A section of the request body that provides information about the files that
  are being transcoded.
- `"Output"`:  A section of the request body that provides information about the transcoded
  (target) file. We strongly recommend that you use the Outputs syntax instead of the Output
  syntax.
- `"OutputKeyPrefix"`: The value, if any, that you want Elastic Transcoder to prepend to
  the names of all files that this job creates, including output files, thumbnails, and
  playlists.
- `"Outputs"`:  A section of the request body that provides information about the
  transcoded (target) files. We recommend that you use the Outputs syntax instead of the
  Output syntax.
- `"Playlists"`: If you specify a preset in PresetId for which the value of Container is
  fmp4 (Fragmented MP4) or ts (MPEG-TS), Playlists contains information about the master
  playlists that you want Elastic Transcoder to create. The maximum number of master
  playlists in a job is 30.
- `"UserMetadata"`: User-defined metadata that you want to associate with an Elastic
  Transcoder job. You specify metadata in key/value pairs, and you can add up to 10 key/value
  pairs per job. Elastic Transcoder does not guarantee that key/value pairs are returned in
  the same order in which you specify them.
"""
function create_job(PipelineId; aws_config::AbstractAWSConfig=current_aws_config())
    return elastic_transcoder(
        "POST",
        "/2012-09-25/jobs",
        Dict{String,Any}("PipelineId" => PipelineId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_job(
    PipelineId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_transcoder(
        "POST",
        "/2012-09-25/jobs",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("PipelineId" => PipelineId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_pipeline(input_bucket, name, role)
    create_pipeline(input_bucket, name, role, params::Dict{String,<:Any})

The CreatePipeline operation creates a pipeline with settings that you specify.

# Arguments
- `input_bucket`: The Amazon S3 bucket in which you saved the media files that you want to
  transcode.
- `name`: The name of the pipeline. We recommend that the name be unique within the AWS
  account, but uniqueness is not enforced. Constraints: Maximum 40 characters.
- `role`: The IAM Amazon Resource Name (ARN) for the role that you want Elastic Transcoder
  to use to create the pipeline.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AwsKmsKeyArn"`: The AWS Key Management Service (AWS KMS) key that you want to use with
  this pipeline. If you use either s3 or s3-aws-kms as your Encryption:Mode, you don't need
  to provide a key with your job because a default key, known as an AWS-KMS key, is created
  for you automatically. You need to provide an AWS-KMS key only if you want to use a
  non-default AWS-KMS key, or if you are using an Encryption:Mode of aes-cbc-pkcs7, aes-ctr,
  or aes-gcm.
- `"ContentConfig"`: The optional ContentConfig object specifies information about the
  Amazon S3 bucket in which you want Elastic Transcoder to save transcoded files and
  playlists: which bucket to use, which users you want to have access to the files, the type
  of access you want users to have, and the storage class that you want to assign to the
  files. If you specify values for ContentConfig, you must also specify values for
  ThumbnailConfig. If you specify values for ContentConfig and ThumbnailConfig, omit the
  OutputBucket object.    Bucket: The Amazon S3 bucket in which you want Elastic Transcoder
  to save transcoded files and playlists.    Permissions (Optional): The Permissions object
  specifies which users you want to have access to transcoded files and the type of access
  you want them to have. You can grant permissions to a maximum of 30 users and/or predefined
  Amazon S3 groups.    Grantee Type: Specify the type of value that appears in the Grantee
  object:     Canonical: The value in the Grantee object is either the canonical user ID for
  an AWS account or an origin access identity for an Amazon CloudFront distribution. For more
  information about canonical user IDs, see Access Control List (ACL) Overview in the Amazon
  Simple Storage Service Developer Guide. For more information about using CloudFront origin
  access identities to require that users use CloudFront URLs instead of Amazon S3 URLs, see
  Using an Origin Access Identity to Restrict Access to Your Amazon S3 Content.  A canonical
  user ID is not the same as an AWS account number.     Email: The value in the Grantee
  object is the registered email address of an AWS account.    Group: The value in the
  Grantee object is one of the following predefined Amazon S3 groups: AllUsers,
  AuthenticatedUsers, or LogDelivery.      Grantee: The AWS user or group that you want to
  have access to transcoded files and playlists. To identify the user or group, you can
  specify the canonical user ID for an AWS account, an origin access identity for a
  CloudFront distribution, the registered email address of an AWS account, or a predefined
  Amazon S3 group     Access: The permission that you want to give to the AWS user that you
  specified in Grantee. Permissions are granted on the files that Elastic Transcoder adds to
  the bucket, including playlists and video files. Valid values include:     READ: The
  grantee can read the objects and metadata for objects that Elastic Transcoder adds to the
  Amazon S3 bucket.    READ_ACP: The grantee can read the object ACL for objects that Elastic
  Transcoder adds to the Amazon S3 bucket.    WRITE_ACP: The grantee can write the ACL for
  the objects that Elastic Transcoder adds to the Amazon S3 bucket.    FULL_CONTROL: The
  grantee has READ, READ_ACP, and WRITE_ACP permissions for the objects that Elastic
  Transcoder adds to the Amazon S3 bucket.      StorageClass: The Amazon S3 storage class,
  Standard or ReducedRedundancy, that you want Elastic Transcoder to assign to the video
  files and playlists that it stores in your Amazon S3 bucket.
- `"Notifications"`: The Amazon Simple Notification Service (Amazon SNS) topic that you
  want to notify to report job status.  To receive notifications, you must also subscribe to
  the new topic in the Amazon SNS console.     Progressing: The topic ARN for the Amazon
  Simple Notification Service (Amazon SNS) topic that you want to notify when Elastic
  Transcoder has started to process a job in this pipeline. This is the ARN that Amazon SNS
  returned when you created the topic. For more information, see Create a Topic in the Amazon
  Simple Notification Service Developer Guide.    Complete: The topic ARN for the Amazon SNS
  topic that you want to notify when Elastic Transcoder has finished processing a job in this
  pipeline. This is the ARN that Amazon SNS returned when you created the topic.    Warning:
  The topic ARN for the Amazon SNS topic that you want to notify when Elastic Transcoder
  encounters a warning condition while processing a job in this pipeline. This is the ARN
  that Amazon SNS returned when you created the topic.    Error: The topic ARN for the Amazon
  SNS topic that you want to notify when Elastic Transcoder encounters an error condition
  while processing a job in this pipeline. This is the ARN that Amazon SNS returned when you
  created the topic.
- `"OutputBucket"`: The Amazon S3 bucket in which you want Elastic Transcoder to save the
  transcoded files. (Use this, or use ContentConfig:Bucket plus ThumbnailConfig:Bucket.)
  Specify this value when all of the following are true:   You want to save transcoded files,
  thumbnails (if any), and playlists (if any) together in one bucket.   You do not want to
  specify the users or groups who have access to the transcoded files, thumbnails, and
  playlists.   You do not want to specify the permissions that Elastic Transcoder grants to
  the files.   When Elastic Transcoder saves files in OutputBucket, it grants full control
  over the files only to the AWS account that owns the role that is specified by Role.    You
  want to associate the transcoded files and thumbnails with the Amazon S3 Standard storage
  class.   If you want to save transcoded files and playlists in one bucket and thumbnails in
  another bucket, specify which users can access the transcoded files or the permissions the
  users have, or change the Amazon S3 storage class, omit OutputBucket and specify values for
  ContentConfig and ThumbnailConfig instead.
- `"ThumbnailConfig"`: The ThumbnailConfig object specifies several values, including the
  Amazon S3 bucket in which you want Elastic Transcoder to save thumbnail files, which users
  you want to have access to the files, the type of access you want users to have, and the
  storage class that you want to assign to the files. If you specify values for
  ContentConfig, you must also specify values for ThumbnailConfig even if you don't want to
  create thumbnails. If you specify values for ContentConfig and ThumbnailConfig, omit the
  OutputBucket object.    Bucket: The Amazon S3 bucket in which you want Elastic Transcoder
  to save thumbnail files.    Permissions (Optional): The Permissions object specifies which
  users and/or predefined Amazon S3 groups you want to have access to thumbnail files, and
  the type of access you want them to have. You can grant permissions to a maximum of 30
  users and/or predefined Amazon S3 groups.    GranteeType: Specify the type of value that
  appears in the Grantee object:     Canonical: The value in the Grantee object is either the
  canonical user ID for an AWS account or an origin access identity for an Amazon CloudFront
  distribution.  A canonical user ID is not the same as an AWS account number.     Email: The
  value in the Grantee object is the registered email address of an AWS account.     Group:
  The value in the Grantee object is one of the following predefined Amazon S3 groups:
  AllUsers, AuthenticatedUsers, or LogDelivery.      Grantee: The AWS user or group that you
  want to have access to thumbnail files. To identify the user or group, you can specify the
  canonical user ID for an AWS account, an origin access identity for a CloudFront
  distribution, the registered email address of an AWS account, or a predefined Amazon S3
  group.     Access: The permission that you want to give to the AWS user that you specified
  in Grantee. Permissions are granted on the thumbnail files that Elastic Transcoder adds to
  the bucket. Valid values include:     READ: The grantee can read the thumbnails and
  metadata for objects that Elastic Transcoder adds to the Amazon S3 bucket.    READ_ACP: The
  grantee can read the object ACL for thumbnails that Elastic Transcoder adds to the Amazon
  S3 bucket.    WRITE_ACP: The grantee can write the ACL for the thumbnails that Elastic
  Transcoder adds to the Amazon S3 bucket.    FULL_CONTROL: The grantee has READ, READ_ACP,
  and WRITE_ACP permissions for the thumbnails that Elastic Transcoder adds to the Amazon S3
  bucket.      StorageClass: The Amazon S3 storage class, Standard or ReducedRedundancy, that
  you want Elastic Transcoder to assign to the thumbnails that it stores in your Amazon S3
  bucket.
"""
function create_pipeline(
    InputBucket, Name, Role; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_transcoder(
        "POST",
        "/2012-09-25/pipelines",
        Dict{String,Any}("InputBucket" => InputBucket, "Name" => Name, "Role" => Role);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_pipeline(
    InputBucket,
    Name,
    Role,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_transcoder(
        "POST",
        "/2012-09-25/pipelines",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "InputBucket" => InputBucket, "Name" => Name, "Role" => Role
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_preset(container, name)
    create_preset(container, name, params::Dict{String,<:Any})

The CreatePreset operation creates a preset with settings that you specify.  Elastic
Transcoder checks the CreatePreset settings to ensure that they meet Elastic Transcoder
requirements and to determine whether they comply with H.264 standards. If your settings
are not valid for Elastic Transcoder, Elastic Transcoder returns an HTTP 400 response
(ValidationException) and does not create the preset. If the settings are valid for Elastic
Transcoder but aren't strictly compliant with the H.264 standard, Elastic Transcoder
creates the preset and returns a warning message in the response. This helps you determine
whether your settings comply with the H.264 standard while giving you greater flexibility
with respect to the video that Elastic Transcoder produces.  Elastic Transcoder uses the
H.264 video-compression format. For more information, see the International
Telecommunication Union publication Recommendation ITU-T H.264: Advanced video coding for
generic audiovisual services.

# Arguments
- `container`: The container type for the output file. Valid values include flac, flv,
  fmp4, gif, mp3, mp4, mpg, mxf, oga, ogg, ts, and webm.
- `name`: The name of the preset. We recommend that the name be unique within the AWS
  account, but uniqueness is not enforced.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Audio"`: A section of the request body that specifies the audio parameters.
- `"Description"`: A description of the preset.
- `"Thumbnails"`: A section of the request body that specifies the thumbnail parameters, if
  any.
- `"Video"`: A section of the request body that specifies the video parameters.
"""
function create_preset(Container, Name; aws_config::AbstractAWSConfig=current_aws_config())
    return elastic_transcoder(
        "POST",
        "/2012-09-25/presets",
        Dict{String,Any}("Container" => Container, "Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_preset(
    Container,
    Name,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_transcoder(
        "POST",
        "/2012-09-25/presets",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("Container" => Container, "Name" => Name), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_pipeline(id)
    delete_pipeline(id, params::Dict{String,<:Any})

The DeletePipeline operation removes a pipeline.  You can only delete a pipeline that has
never been used or that is not currently in use (doesn't contain any active jobs). If the
pipeline is currently in use, DeletePipeline returns an error.

# Arguments
- `id`: The identifier of the pipeline that you want to delete.

"""
function delete_pipeline(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return elastic_transcoder(
        "DELETE",
        "/2012-09-25/pipelines/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_pipeline(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_transcoder(
        "DELETE",
        "/2012-09-25/pipelines/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_preset(id)
    delete_preset(id, params::Dict{String,<:Any})

The DeletePreset operation removes a preset that you've added in an AWS region.  You can't
delete the default presets that are included with Elastic Transcoder.

# Arguments
- `id`: The identifier of the preset for which you want to get detailed information.

"""
function delete_preset(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return elastic_transcoder(
        "DELETE",
        "/2012-09-25/presets/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_preset(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_transcoder(
        "DELETE",
        "/2012-09-25/presets/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_jobs_by_pipeline(pipeline_id)
    list_jobs_by_pipeline(pipeline_id, params::Dict{String,<:Any})

The ListJobsByPipeline operation gets a list of the jobs currently in a pipeline. Elastic
Transcoder returns all of the jobs currently in the specified pipeline. The response body
contains one element for each job that satisfies the search criteria.

# Arguments
- `pipeline_id`: The ID of the pipeline for which you want to get job information.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Ascending"`:  To list jobs in chronological order by the date and time that they were
  submitted, enter true. To list jobs in reverse chronological order, enter false.
- `"PageToken"`:  When Elastic Transcoder returns more than one page of results, use
  pageToken in subsequent GET requests to get each successive page of results.
"""
function list_jobs_by_pipeline(
    PipelineId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_transcoder(
        "GET",
        "/2012-09-25/jobsByPipeline/$(PipelineId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_jobs_by_pipeline(
    PipelineId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_transcoder(
        "GET",
        "/2012-09-25/jobsByPipeline/$(PipelineId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_jobs_by_status(status)
    list_jobs_by_status(status, params::Dict{String,<:Any})

The ListJobsByStatus operation gets a list of jobs that have a specified status. The
response body contains one element for each job that satisfies the search criteria.

# Arguments
- `status`: To get information about all of the jobs associated with the current AWS
  account that have a given status, specify the following status: Submitted, Progressing,
  Complete, Canceled, or Error.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Ascending"`:  To list jobs in chronological order by the date and time that they were
  submitted, enter true. To list jobs in reverse chronological order, enter false.
- `"PageToken"`:  When Elastic Transcoder returns more than one page of results, use
  pageToken in subsequent GET requests to get each successive page of results.
"""
function list_jobs_by_status(Status; aws_config::AbstractAWSConfig=current_aws_config())
    return elastic_transcoder(
        "GET",
        "/2012-09-25/jobsByStatus/$(Status)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_jobs_by_status(
    Status, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_transcoder(
        "GET",
        "/2012-09-25/jobsByStatus/$(Status)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_pipelines()
    list_pipelines(params::Dict{String,<:Any})

The ListPipelines operation gets a list of the pipelines associated with the current AWS
account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Ascending"`: To list pipelines in chronological order by the date and time that they
  were created, enter true. To list pipelines in reverse chronological order, enter false.
- `"PageToken"`: When Elastic Transcoder returns more than one page of results, use
  pageToken in subsequent GET requests to get each successive page of results.
"""
function list_pipelines(; aws_config::AbstractAWSConfig=current_aws_config())
    return elastic_transcoder(
        "GET",
        "/2012-09-25/pipelines";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_pipelines(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_transcoder(
        "GET",
        "/2012-09-25/pipelines",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_presets()
    list_presets(params::Dict{String,<:Any})

The ListPresets operation gets a list of the default presets included with Elastic
Transcoder and the presets that you've added in an AWS region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Ascending"`: To list presets in chronological order by the date and time that they were
  created, enter true. To list presets in reverse chronological order, enter false.
- `"PageToken"`: When Elastic Transcoder returns more than one page of results, use
  pageToken in subsequent GET requests to get each successive page of results.
"""
function list_presets(; aws_config::AbstractAWSConfig=current_aws_config())
    return elastic_transcoder(
        "GET", "/2012-09-25/presets"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_presets(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_transcoder(
        "GET",
        "/2012-09-25/presets",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    read_job(id)
    read_job(id, params::Dict{String,<:Any})

The ReadJob operation returns detailed information about a job.

# Arguments
- `id`: The identifier of the job for which you want to get detailed information.

"""
function read_job(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return elastic_transcoder(
        "GET",
        "/2012-09-25/jobs/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function read_job(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_transcoder(
        "GET",
        "/2012-09-25/jobs/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    read_pipeline(id)
    read_pipeline(id, params::Dict{String,<:Any})

The ReadPipeline operation gets detailed information about a pipeline.

# Arguments
- `id`: The identifier of the pipeline to read.

"""
function read_pipeline(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return elastic_transcoder(
        "GET",
        "/2012-09-25/pipelines/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function read_pipeline(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_transcoder(
        "GET",
        "/2012-09-25/pipelines/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    read_preset(id)
    read_preset(id, params::Dict{String,<:Any})

The ReadPreset operation gets detailed information about a preset.

# Arguments
- `id`: The identifier of the preset for which you want to get detailed information.

"""
function read_preset(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return elastic_transcoder(
        "GET",
        "/2012-09-25/presets/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function read_preset(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_transcoder(
        "GET",
        "/2012-09-25/presets/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    test_role(input_bucket, output_bucket, role, topics)
    test_role(input_bucket, output_bucket, role, topics, params::Dict{String,<:Any})

The TestRole operation tests the IAM role used to create the pipeline. The TestRole action
lets you determine whether the IAM role you are using has sufficient permissions to let
Elastic Transcoder perform tasks associated with the transcoding process. The action
attempts to assume the specified IAM role, checks read access to the input and output
buckets, and tries to send a test notification to Amazon SNS topics that you specify.

# Arguments
- `input_bucket`: The Amazon S3 bucket that contains media files to be transcoded. The
  action attempts to read from this bucket.
- `output_bucket`: The Amazon S3 bucket that Elastic Transcoder writes transcoded media
  files to. The action attempts to read from this bucket.
- `role`: The IAM Amazon Resource Name (ARN) for the role that you want Elastic Transcoder
  to test.
- `topics`: The ARNs of one or more Amazon Simple Notification Service (Amazon SNS) topics
  that you want the action to send a test notification to.

"""
function test_role(
    InputBucket,
    OutputBucket,
    Role,
    Topics;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_transcoder(
        "POST",
        "/2012-09-25/roleTests",
        Dict{String,Any}(
            "InputBucket" => InputBucket,
            "OutputBucket" => OutputBucket,
            "Role" => Role,
            "Topics" => Topics,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function test_role(
    InputBucket,
    OutputBucket,
    Role,
    Topics,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_transcoder(
        "POST",
        "/2012-09-25/roleTests",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "InputBucket" => InputBucket,
                    "OutputBucket" => OutputBucket,
                    "Role" => Role,
                    "Topics" => Topics,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_pipeline(id)
    update_pipeline(id, params::Dict{String,<:Any})

 Use the UpdatePipeline operation to update settings for a pipeline.  When you change
pipeline settings, your changes take effect immediately. Jobs that you have already
submitted and that Elastic Transcoder has not started to process are affected in addition
to jobs that you submit after you change settings.

# Arguments
- `id`: The ID of the pipeline that you want to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AwsKmsKeyArn"`: The AWS Key Management Service (AWS KMS) key that you want to use with
  this pipeline. If you use either s3 or s3-aws-kms as your Encryption:Mode, you don't need
  to provide a key with your job because a default key, known as an AWS-KMS key, is created
  for you automatically. You need to provide an AWS-KMS key only if you want to use a
  non-default AWS-KMS key, or if you are using an Encryption:Mode of aes-cbc-pkcs7, aes-ctr,
  or aes-gcm.
- `"ContentConfig"`: The optional ContentConfig object specifies information about the
  Amazon S3 bucket in which you want Elastic Transcoder to save transcoded files and
  playlists: which bucket to use, which users you want to have access to the files, the type
  of access you want users to have, and the storage class that you want to assign to the
  files. If you specify values for ContentConfig, you must also specify values for
  ThumbnailConfig. If you specify values for ContentConfig and ThumbnailConfig, omit the
  OutputBucket object.    Bucket: The Amazon S3 bucket in which you want Elastic Transcoder
  to save transcoded files and playlists.    Permissions (Optional): The Permissions object
  specifies which users you want to have access to transcoded files and the type of access
  you want them to have. You can grant permissions to a maximum of 30 users and/or predefined
  Amazon S3 groups.    Grantee Type: Specify the type of value that appears in the Grantee
  object:    Canonical: The value in the Grantee object is either the canonical user ID for
  an AWS account or an origin access identity for an Amazon CloudFront distribution. For more
  information about canonical user IDs, see Access Control List (ACL) Overview in the Amazon
  Simple Storage Service Developer Guide. For more information about using CloudFront origin
  access identities to require that users use CloudFront URLs instead of Amazon S3 URLs, see
  Using an Origin Access Identity to Restrict Access to Your Amazon S3 Content.  A canonical
  user ID is not the same as an AWS account number.     Email: The value in the Grantee
  object is the registered email address of an AWS account.    Group: The value in the
  Grantee object is one of the following predefined Amazon S3 groups: AllUsers,
  AuthenticatedUsers, or LogDelivery.      Grantee: The AWS user or group that you want to
  have access to transcoded files and playlists. To identify the user or group, you can
  specify the canonical user ID for an AWS account, an origin access identity for a
  CloudFront distribution, the registered email address of an AWS account, or a predefined
  Amazon S3 group     Access: The permission that you want to give to the AWS user that you
  specified in Grantee. Permissions are granted on the files that Elastic Transcoder adds to
  the bucket, including playlists and video files. Valid values include:     READ: The
  grantee can read the objects and metadata for objects that Elastic Transcoder adds to the
  Amazon S3 bucket.    READ_ACP: The grantee can read the object ACL for objects that Elastic
  Transcoder adds to the Amazon S3 bucket.     WRITE_ACP: The grantee can write the ACL for
  the objects that Elastic Transcoder adds to the Amazon S3 bucket.    FULL_CONTROL: The
  grantee has READ, READ_ACP, and WRITE_ACP permissions for the objects that Elastic
  Transcoder adds to the Amazon S3 bucket.      StorageClass: The Amazon S3 storage class,
  Standard or ReducedRedundancy, that you want Elastic Transcoder to assign to the video
  files and playlists that it stores in your Amazon S3 bucket.
- `"InputBucket"`: The Amazon S3 bucket in which you saved the media files that you want to
  transcode and the graphics that you want to use as watermarks.
- `"Name"`: The name of the pipeline. We recommend that the name be unique within the AWS
  account, but uniqueness is not enforced. Constraints: Maximum 40 characters
- `"Notifications"`: The topic ARN for the Amazon Simple Notification Service (Amazon SNS)
  topic that you want to notify to report job status.  To receive notifications, you must
  also subscribe to the new topic in the Amazon SNS console.     Progressing: The topic ARN
  for the Amazon Simple Notification Service (Amazon SNS) topic that you want to notify when
  Elastic Transcoder has started to process jobs that are added to this pipeline. This is the
  ARN that Amazon SNS returned when you created the topic.    Complete: The topic ARN for the
  Amazon SNS topic that you want to notify when Elastic Transcoder has finished processing a
  job. This is the ARN that Amazon SNS returned when you created the topic.    Warning: The
  topic ARN for the Amazon SNS topic that you want to notify when Elastic Transcoder
  encounters a warning condition. This is the ARN that Amazon SNS returned when you created
  the topic.    Error: The topic ARN for the Amazon SNS topic that you want to notify when
  Elastic Transcoder encounters an error condition. This is the ARN that Amazon SNS returned
  when you created the topic.
- `"Role"`: The IAM Amazon Resource Name (ARN) for the role that you want Elastic
  Transcoder to use to transcode jobs for this pipeline.
- `"ThumbnailConfig"`: The ThumbnailConfig object specifies several values, including the
  Amazon S3 bucket in which you want Elastic Transcoder to save thumbnail files, which users
  you want to have access to the files, the type of access you want users to have, and the
  storage class that you want to assign to the files. If you specify values for
  ContentConfig, you must also specify values for ThumbnailConfig even if you don't want to
  create thumbnails. If you specify values for ContentConfig and ThumbnailConfig, omit the
  OutputBucket object.    Bucket: The Amazon S3 bucket in which you want Elastic Transcoder
  to save thumbnail files.    Permissions (Optional): The Permissions object specifies which
  users and/or predefined Amazon S3 groups you want to have access to thumbnail files, and
  the type of access you want them to have. You can grant permissions to a maximum of 30
  users and/or predefined Amazon S3 groups.    GranteeType: Specify the type of value that
  appears in the Grantee object:    Canonical: The value in the Grantee object is either the
  canonical user ID for an AWS account or an origin access identity for an Amazon CloudFront
  distribution.  A canonical user ID is not the same as an AWS account number.     Email: The
  value in the Grantee object is the registered email address of an AWS account.    Group:
  The value in the Grantee object is one of the following predefined Amazon S3 groups:
  AllUsers, AuthenticatedUsers, or LogDelivery.      Grantee: The AWS user or group that you
  want to have access to thumbnail files. To identify the user or group, you can specify the
  canonical user ID for an AWS account, an origin access identity for a CloudFront
  distribution, the registered email address of an AWS account, or a predefined Amazon S3
  group.     Access: The permission that you want to give to the AWS user that you specified
  in Grantee. Permissions are granted on the thumbnail files that Elastic Transcoder adds to
  the bucket. Valid values include:     READ: The grantee can read the thumbnails and
  metadata for objects that Elastic Transcoder adds to the Amazon S3 bucket.    READ_ACP: The
  grantee can read the object ACL for thumbnails that Elastic Transcoder adds to the Amazon
  S3 bucket.    WRITE_ACP: The grantee can write the ACL for the thumbnails that Elastic
  Transcoder adds to the Amazon S3 bucket.    FULL_CONTROL: The grantee has READ, READ_ACP,
  and WRITE_ACP permissions for the thumbnails that Elastic Transcoder adds to the Amazon S3
  bucket.       StorageClass: The Amazon S3 storage class, Standard or ReducedRedundancy,
  that you want Elastic Transcoder to assign to the thumbnails that it stores in your Amazon
  S3 bucket.
"""
function update_pipeline(Id; aws_config::AbstractAWSConfig=current_aws_config())
    return elastic_transcoder(
        "PUT",
        "/2012-09-25/pipelines/$(Id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_pipeline(
    Id, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_transcoder(
        "PUT",
        "/2012-09-25/pipelines/$(Id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_pipeline_notifications(id, notifications)
    update_pipeline_notifications(id, notifications, params::Dict{String,<:Any})

With the UpdatePipelineNotifications operation, you can update Amazon Simple Notification
Service (Amazon SNS) notifications for a pipeline. When you update notifications for a
pipeline, Elastic Transcoder returns the values that you specified in the request.

# Arguments
- `id`: The identifier of the pipeline for which you want to change notification settings.
- `notifications`: The topic ARN for the Amazon Simple Notification Service (Amazon SNS)
  topic that you want to notify to report job status.  To receive notifications, you must
  also subscribe to the new topic in the Amazon SNS console.     Progressing: The topic ARN
  for the Amazon Simple Notification Service (Amazon SNS) topic that you want to notify when
  Elastic Transcoder has started to process jobs that are added to this pipeline. This is the
  ARN that Amazon SNS returned when you created the topic.    Complete: The topic ARN for the
  Amazon SNS topic that you want to notify when Elastic Transcoder has finished processing a
  job. This is the ARN that Amazon SNS returned when you created the topic.    Warning: The
  topic ARN for the Amazon SNS topic that you want to notify when Elastic Transcoder
  encounters a warning condition. This is the ARN that Amazon SNS returned when you created
  the topic.    Error: The topic ARN for the Amazon SNS topic that you want to notify when
  Elastic Transcoder encounters an error condition. This is the ARN that Amazon SNS returned
  when you created the topic.

"""
function update_pipeline_notifications(
    Id, Notifications; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_transcoder(
        "POST",
        "/2012-09-25/pipelines/$(Id)/notifications",
        Dict{String,Any}("Notifications" => Notifications);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_pipeline_notifications(
    Id,
    Notifications,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_transcoder(
        "POST",
        "/2012-09-25/pipelines/$(Id)/notifications",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("Notifications" => Notifications), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_pipeline_status(id, status)
    update_pipeline_status(id, status, params::Dict{String,<:Any})

The UpdatePipelineStatus operation pauses or reactivates a pipeline, so that the pipeline
stops or restarts the processing of jobs. Changing the pipeline status is useful if you
want to cancel one or more jobs. You can't cancel jobs after Elastic Transcoder has started
processing them; if you pause the pipeline to which you submitted the jobs, you have more
time to get the job IDs for the jobs that you want to cancel, and to send a CancelJob
request.

# Arguments
- `id`: The identifier of the pipeline to update.
- `status`: The desired status of the pipeline:    Active: The pipeline is processing jobs.
     Paused: The pipeline is not currently processing jobs.

"""
function update_pipeline_status(
    Id, Status; aws_config::AbstractAWSConfig=current_aws_config()
)
    return elastic_transcoder(
        "POST",
        "/2012-09-25/pipelines/$(Id)/status",
        Dict{String,Any}("Status" => Status);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_pipeline_status(
    Id,
    Status,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return elastic_transcoder(
        "POST",
        "/2012-09-25/pipelines/$(Id)/status",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Status" => Status), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: lookoutmetrics
using AWS.Compat
using AWS.UUIDs

"""
    activate_anomaly_detector(anomaly_detector_arn)
    activate_anomaly_detector(anomaly_detector_arn, params::Dict{String,<:Any})

Activates an anomaly detector.

# Arguments
- `anomaly_detector_arn`: The ARN of the anomaly detector.

"""
function activate_anomaly_detector(
    AnomalyDetectorArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutmetrics(
        "POST",
        "/ActivateAnomalyDetector",
        Dict{String,Any}("AnomalyDetectorArn" => AnomalyDetectorArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function activate_anomaly_detector(
    AnomalyDetectorArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutmetrics(
        "POST",
        "/ActivateAnomalyDetector",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("AnomalyDetectorArn" => AnomalyDetectorArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    back_test_anomaly_detector(anomaly_detector_arn)
    back_test_anomaly_detector(anomaly_detector_arn, params::Dict{String,<:Any})

Runs a backtest for anomaly detection for the specified resource.

# Arguments
- `anomaly_detector_arn`: The Amazon Resource Name (ARN) of the anomaly detector.

"""
function back_test_anomaly_detector(
    AnomalyDetectorArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutmetrics(
        "POST",
        "/BackTestAnomalyDetector",
        Dict{String,Any}("AnomalyDetectorArn" => AnomalyDetectorArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function back_test_anomaly_detector(
    AnomalyDetectorArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutmetrics(
        "POST",
        "/BackTestAnomalyDetector",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("AnomalyDetectorArn" => AnomalyDetectorArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_alert(action, alert_name, anomaly_detector_arn)
    create_alert(action, alert_name, anomaly_detector_arn, params::Dict{String,<:Any})

Creates an alert for an anomaly detector.

# Arguments
- `action`: Action that will be triggered when there is an alert.
- `alert_name`: The name of the alert.
- `anomaly_detector_arn`: The ARN of the detector to which the alert is attached.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AlertDescription"`: A description of the alert.
- `"AlertFilters"`: The configuration of the alert filters, containing MetricList and
  DimensionFilterList.
- `"AlertSensitivityThreshold"`: An integer from 0 to 100 specifying the alert sensitivity
  threshold.
- `"Tags"`: A list of tags to apply to the alert.
"""
function create_alert(
    Action,
    AlertName,
    AnomalyDetectorArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutmetrics(
        "POST",
        "/CreateAlert",
        Dict{String,Any}(
            "Action" => Action,
            "AlertName" => AlertName,
            "AnomalyDetectorArn" => AnomalyDetectorArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_alert(
    Action,
    AlertName,
    AnomalyDetectorArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutmetrics(
        "POST",
        "/CreateAlert",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "Action" => Action,
                    "AlertName" => AlertName,
                    "AnomalyDetectorArn" => AnomalyDetectorArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_anomaly_detector(anomaly_detector_config, anomaly_detector_name)
    create_anomaly_detector(anomaly_detector_config, anomaly_detector_name, params::Dict{String,<:Any})

Creates an anomaly detector.

# Arguments
- `anomaly_detector_config`: Contains information about the configuration of the anomaly
  detector.
- `anomaly_detector_name`: The name of the detector.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AnomalyDetectorDescription"`: A description of the detector.
- `"KmsKeyArn"`: The ARN of the KMS key to use to encrypt your data.
- `"Tags"`: A list of tags to apply to the anomaly detector.
"""
function create_anomaly_detector(
    AnomalyDetectorConfig,
    AnomalyDetectorName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutmetrics(
        "POST",
        "/CreateAnomalyDetector",
        Dict{String,Any}(
            "AnomalyDetectorConfig" => AnomalyDetectorConfig,
            "AnomalyDetectorName" => AnomalyDetectorName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_anomaly_detector(
    AnomalyDetectorConfig,
    AnomalyDetectorName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutmetrics(
        "POST",
        "/CreateAnomalyDetector",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AnomalyDetectorConfig" => AnomalyDetectorConfig,
                    "AnomalyDetectorName" => AnomalyDetectorName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_metric_set(anomaly_detector_arn, metric_list, metric_set_name, metric_source)
    create_metric_set(anomaly_detector_arn, metric_list, metric_set_name, metric_source, params::Dict{String,<:Any})

Creates a dataset.

# Arguments
- `anomaly_detector_arn`: The ARN of the anomaly detector that will use the dataset.
- `metric_list`: A list of metrics that the dataset will contain.
- `metric_set_name`: The name of the dataset.
- `metric_source`: Contains information about how the source data should be interpreted.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DimensionFilterList"`: A list of filters that specify which data is kept for anomaly
  detection.
- `"DimensionList"`: A list of the fields you want to treat as dimensions.
- `"MetricSetDescription"`: A description of the dataset you are creating.
- `"MetricSetFrequency"`: The frequency with which the source data will be analyzed for
  anomalies.
- `"Offset"`: After an interval ends, the amount of seconds that the detector waits before
  importing data. Offset is only supported for S3, Redshift, Athena and datasources.
- `"Tags"`: A list of tags to apply to the dataset.
- `"TimestampColumn"`: Contains information about the column used for tracking time in your
  source data.
- `"Timezone"`: The time zone in which your source data was recorded.
"""
function create_metric_set(
    AnomalyDetectorArn,
    MetricList,
    MetricSetName,
    MetricSource;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutmetrics(
        "POST",
        "/CreateMetricSet",
        Dict{String,Any}(
            "AnomalyDetectorArn" => AnomalyDetectorArn,
            "MetricList" => MetricList,
            "MetricSetName" => MetricSetName,
            "MetricSource" => MetricSource,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_metric_set(
    AnomalyDetectorArn,
    MetricList,
    MetricSetName,
    MetricSource,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutmetrics(
        "POST",
        "/CreateMetricSet",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AnomalyDetectorArn" => AnomalyDetectorArn,
                    "MetricList" => MetricList,
                    "MetricSetName" => MetricSetName,
                    "MetricSource" => MetricSource,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    deactivate_anomaly_detector(anomaly_detector_arn)
    deactivate_anomaly_detector(anomaly_detector_arn, params::Dict{String,<:Any})

Deactivates an anomaly detector.

# Arguments
- `anomaly_detector_arn`: The Amazon Resource Name (ARN) of the anomaly detector.

"""
function deactivate_anomaly_detector(
    AnomalyDetectorArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutmetrics(
        "POST",
        "/DeactivateAnomalyDetector",
        Dict{String,Any}("AnomalyDetectorArn" => AnomalyDetectorArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function deactivate_anomaly_detector(
    AnomalyDetectorArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutmetrics(
        "POST",
        "/DeactivateAnomalyDetector",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("AnomalyDetectorArn" => AnomalyDetectorArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_alert(alert_arn)
    delete_alert(alert_arn, params::Dict{String,<:Any})

Deletes an alert.

# Arguments
- `alert_arn`: The ARN of the alert to delete.

"""
function delete_alert(AlertArn; aws_config::AbstractAWSConfig=current_aws_config())
    return lookoutmetrics(
        "POST",
        "/DeleteAlert",
        Dict{String,Any}("AlertArn" => AlertArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_alert(
    AlertArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutmetrics(
        "POST",
        "/DeleteAlert",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AlertArn" => AlertArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_anomaly_detector(anomaly_detector_arn)
    delete_anomaly_detector(anomaly_detector_arn, params::Dict{String,<:Any})

Deletes a detector. Deleting an anomaly detector will delete all of its corresponding
resources including any configured datasets and alerts.

# Arguments
- `anomaly_detector_arn`: The ARN of the detector to delete.

"""
function delete_anomaly_detector(
    AnomalyDetectorArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutmetrics(
        "POST",
        "/DeleteAnomalyDetector",
        Dict{String,Any}("AnomalyDetectorArn" => AnomalyDetectorArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_anomaly_detector(
    AnomalyDetectorArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutmetrics(
        "POST",
        "/DeleteAnomalyDetector",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("AnomalyDetectorArn" => AnomalyDetectorArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_alert(alert_arn)
    describe_alert(alert_arn, params::Dict{String,<:Any})

Describes an alert. Amazon Lookout for Metrics API actions are eventually consistent. If
you do a read operation on a resource immediately after creating or modifying it, use
retries to allow time for the write operation to complete.

# Arguments
- `alert_arn`: The ARN of the alert to describe.

"""
function describe_alert(AlertArn; aws_config::AbstractAWSConfig=current_aws_config())
    return lookoutmetrics(
        "POST",
        "/DescribeAlert",
        Dict{String,Any}("AlertArn" => AlertArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_alert(
    AlertArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutmetrics(
        "POST",
        "/DescribeAlert",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AlertArn" => AlertArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_anomaly_detection_executions(anomaly_detector_arn)
    describe_anomaly_detection_executions(anomaly_detector_arn, params::Dict{String,<:Any})

Returns information about the status of the specified anomaly detection jobs.

# Arguments
- `anomaly_detector_arn`: The Amazon Resource Name (ARN) of the anomaly detector.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The number of items to return in the response.
- `"NextToken"`: Specify the pagination token that's returned by a previous request to
  retrieve the next page of results.
- `"Timestamp"`: The timestamp of the anomaly detection job.
"""
function describe_anomaly_detection_executions(
    AnomalyDetectorArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutmetrics(
        "POST",
        "/DescribeAnomalyDetectionExecutions",
        Dict{String,Any}("AnomalyDetectorArn" => AnomalyDetectorArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_anomaly_detection_executions(
    AnomalyDetectorArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutmetrics(
        "POST",
        "/DescribeAnomalyDetectionExecutions",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("AnomalyDetectorArn" => AnomalyDetectorArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_anomaly_detector(anomaly_detector_arn)
    describe_anomaly_detector(anomaly_detector_arn, params::Dict{String,<:Any})

Describes a detector. Amazon Lookout for Metrics API actions are eventually consistent. If
you do a read operation on a resource immediately after creating or modifying it, use
retries to allow time for the write operation to complete.

# Arguments
- `anomaly_detector_arn`: The ARN of the detector to describe.

"""
function describe_anomaly_detector(
    AnomalyDetectorArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutmetrics(
        "POST",
        "/DescribeAnomalyDetector",
        Dict{String,Any}("AnomalyDetectorArn" => AnomalyDetectorArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_anomaly_detector(
    AnomalyDetectorArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutmetrics(
        "POST",
        "/DescribeAnomalyDetector",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("AnomalyDetectorArn" => AnomalyDetectorArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_metric_set(metric_set_arn)
    describe_metric_set(metric_set_arn, params::Dict{String,<:Any})

Describes a dataset. Amazon Lookout for Metrics API actions are eventually consistent. If
you do a read operation on a resource immediately after creating or modifying it, use
retries to allow time for the write operation to complete.

# Arguments
- `metric_set_arn`: The ARN of the dataset.

"""
function describe_metric_set(
    MetricSetArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutmetrics(
        "POST",
        "/DescribeMetricSet",
        Dict{String,Any}("MetricSetArn" => MetricSetArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_metric_set(
    MetricSetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutmetrics(
        "POST",
        "/DescribeMetricSet",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("MetricSetArn" => MetricSetArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    detect_metric_set_config(anomaly_detector_arn, auto_detection_metric_source)
    detect_metric_set_config(anomaly_detector_arn, auto_detection_metric_source, params::Dict{String,<:Any})

Detects an Amazon S3 dataset's file format, interval, and offset.

# Arguments
- `anomaly_detector_arn`: An anomaly detector ARN.
- `auto_detection_metric_source`: A data source.

"""
function detect_metric_set_config(
    AnomalyDetectorArn,
    AutoDetectionMetricSource;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutmetrics(
        "POST",
        "/DetectMetricSetConfig",
        Dict{String,Any}(
            "AnomalyDetectorArn" => AnomalyDetectorArn,
            "AutoDetectionMetricSource" => AutoDetectionMetricSource,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function detect_metric_set_config(
    AnomalyDetectorArn,
    AutoDetectionMetricSource,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutmetrics(
        "POST",
        "/DetectMetricSetConfig",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AnomalyDetectorArn" => AnomalyDetectorArn,
                    "AutoDetectionMetricSource" => AutoDetectionMetricSource,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_anomaly_group(anomaly_detector_arn, anomaly_group_id)
    get_anomaly_group(anomaly_detector_arn, anomaly_group_id, params::Dict{String,<:Any})

Returns details about a group of anomalous metrics.

# Arguments
- `anomaly_detector_arn`: The Amazon Resource Name (ARN) of the anomaly detector.
- `anomaly_group_id`: The ID of the anomaly group.

"""
function get_anomaly_group(
    AnomalyDetectorArn, AnomalyGroupId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutmetrics(
        "POST",
        "/GetAnomalyGroup",
        Dict{String,Any}(
            "AnomalyDetectorArn" => AnomalyDetectorArn, "AnomalyGroupId" => AnomalyGroupId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_anomaly_group(
    AnomalyDetectorArn,
    AnomalyGroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutmetrics(
        "POST",
        "/GetAnomalyGroup",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AnomalyDetectorArn" => AnomalyDetectorArn,
                    "AnomalyGroupId" => AnomalyGroupId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_data_quality_metrics(anomaly_detector_arn)
    get_data_quality_metrics(anomaly_detector_arn, params::Dict{String,<:Any})

Returns details about the requested data quality metrics.

# Arguments
- `anomaly_detector_arn`: The Amazon Resource Name (ARN) of the anomaly detector that you
  want to investigate.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MetricSetArn"`: The Amazon Resource Name (ARN) of a specific data quality metric set.
"""
function get_data_quality_metrics(
    AnomalyDetectorArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutmetrics(
        "POST",
        "/GetDataQualityMetrics",
        Dict{String,Any}("AnomalyDetectorArn" => AnomalyDetectorArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_data_quality_metrics(
    AnomalyDetectorArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutmetrics(
        "POST",
        "/GetDataQualityMetrics",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("AnomalyDetectorArn" => AnomalyDetectorArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_feedback(anomaly_detector_arn, anomaly_group_time_series_feedback)
    get_feedback(anomaly_detector_arn, anomaly_group_time_series_feedback, params::Dict{String,<:Any})

Get feedback for an anomaly group.

# Arguments
- `anomaly_detector_arn`: The Amazon Resource Name (ARN) of the anomaly detector.
- `anomaly_group_time_series_feedback`: The anomalous metric and group ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to return.
- `"NextToken"`: Specify the pagination token that's returned by a previous request to
  retrieve the next page of results.
"""
function get_feedback(
    AnomalyDetectorArn,
    AnomalyGroupTimeSeriesFeedback;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutmetrics(
        "POST",
        "/GetFeedback",
        Dict{String,Any}(
            "AnomalyDetectorArn" => AnomalyDetectorArn,
            "AnomalyGroupTimeSeriesFeedback" => AnomalyGroupTimeSeriesFeedback,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_feedback(
    AnomalyDetectorArn,
    AnomalyGroupTimeSeriesFeedback,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutmetrics(
        "POST",
        "/GetFeedback",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AnomalyDetectorArn" => AnomalyDetectorArn,
                    "AnomalyGroupTimeSeriesFeedback" => AnomalyGroupTimeSeriesFeedback,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_sample_data()
    get_sample_data(params::Dict{String,<:Any})

Returns a selection of sample records from an Amazon S3 datasource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"S3SourceConfig"`: A datasource bucket in Amazon S3.
"""
function get_sample_data(; aws_config::AbstractAWSConfig=current_aws_config())
    return lookoutmetrics(
        "POST", "/GetSampleData"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function get_sample_data(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutmetrics(
        "POST",
        "/GetSampleData",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_alerts()
    list_alerts(params::Dict{String,<:Any})

Lists the alerts attached to a detector. Amazon Lookout for Metrics API actions are
eventually consistent. If you do a read operation on a resource immediately after creating
or modifying it, use retries to allow time for the write operation to complete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AnomalyDetectorArn"`: The ARN of the alert's detector.
- `"MaxResults"`: The maximum number of results that will be displayed by the request.
- `"NextToken"`: If the result of the previous request is truncated, the response includes
  a NextToken. To retrieve the next set of results, use the token in the next request. Tokens
  expire after 24 hours.
"""
function list_alerts(; aws_config::AbstractAWSConfig=current_aws_config())
    return lookoutmetrics(
        "POST", "/ListAlerts"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_alerts(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutmetrics(
        "POST",
        "/ListAlerts",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_anomaly_detectors()
    list_anomaly_detectors(params::Dict{String,<:Any})

Lists the detectors in the current AWS Region. Amazon Lookout for Metrics API actions are
eventually consistent. If you do a read operation on a resource immediately after creating
or modifying it, use retries to allow time for the write operation to complete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to return.
- `"NextToken"`: If the result of the previous request was truncated, the response includes
  a NextToken. To retrieve the next set of results, use the token in the next request. Tokens
  expire after 24 hours.
"""
function list_anomaly_detectors(; aws_config::AbstractAWSConfig=current_aws_config())
    return lookoutmetrics(
        "POST",
        "/ListAnomalyDetectors";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_anomaly_detectors(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutmetrics(
        "POST",
        "/ListAnomalyDetectors",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_anomaly_group_related_metrics(anomaly_detector_arn, anomaly_group_id)
    list_anomaly_group_related_metrics(anomaly_detector_arn, anomaly_group_id, params::Dict{String,<:Any})

Returns a list of measures that are potential causes or effects of an anomaly group.

# Arguments
- `anomaly_detector_arn`: The Amazon Resource Name (ARN) of the anomaly detector.
- `anomaly_group_id`: The ID of the anomaly group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to return.
- `"NextToken"`: Specify the pagination token that's returned by a previous request to
  retrieve the next page of results.
- `"RelationshipTypeFilter"`: Filter for potential causes (CAUSE_OF_INPUT_ANOMALY_GROUP) or
  downstream effects (EFFECT_OF_INPUT_ANOMALY_GROUP) of the anomaly group.
"""
function list_anomaly_group_related_metrics(
    AnomalyDetectorArn, AnomalyGroupId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutmetrics(
        "POST",
        "/ListAnomalyGroupRelatedMetrics",
        Dict{String,Any}(
            "AnomalyDetectorArn" => AnomalyDetectorArn, "AnomalyGroupId" => AnomalyGroupId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_anomaly_group_related_metrics(
    AnomalyDetectorArn,
    AnomalyGroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutmetrics(
        "POST",
        "/ListAnomalyGroupRelatedMetrics",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AnomalyDetectorArn" => AnomalyDetectorArn,
                    "AnomalyGroupId" => AnomalyGroupId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_anomaly_group_summaries(anomaly_detector_arn, sensitivity_threshold)
    list_anomaly_group_summaries(anomaly_detector_arn, sensitivity_threshold, params::Dict{String,<:Any})

Returns a list of anomaly groups.

# Arguments
- `anomaly_detector_arn`: The Amazon Resource Name (ARN) of the anomaly detector.
- `sensitivity_threshold`: The minimum severity score for inclusion in the output.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to return.
- `"NextToken"`: Specify the pagination token that's returned by a previous request to
  retrieve the next page of results.
"""
function list_anomaly_group_summaries(
    AnomalyDetectorArn,
    SensitivityThreshold;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutmetrics(
        "POST",
        "/ListAnomalyGroupSummaries",
        Dict{String,Any}(
            "AnomalyDetectorArn" => AnomalyDetectorArn,
            "SensitivityThreshold" => SensitivityThreshold,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_anomaly_group_summaries(
    AnomalyDetectorArn,
    SensitivityThreshold,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutmetrics(
        "POST",
        "/ListAnomalyGroupSummaries",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AnomalyDetectorArn" => AnomalyDetectorArn,
                    "SensitivityThreshold" => SensitivityThreshold,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_anomaly_group_time_series(anomaly_detector_arn, anomaly_group_id, metric_name)
    list_anomaly_group_time_series(anomaly_detector_arn, anomaly_group_id, metric_name, params::Dict{String,<:Any})

Gets a list of anomalous metrics for a measure in an anomaly group.

# Arguments
- `anomaly_detector_arn`: The Amazon Resource Name (ARN) of the anomaly detector.
- `anomaly_group_id`: The ID of the anomaly group.
- `metric_name`: The name of the measure field.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to return.
- `"NextToken"`: Specify the pagination token that's returned by a previous request to
  retrieve the next page of results.
"""
function list_anomaly_group_time_series(
    AnomalyDetectorArn,
    AnomalyGroupId,
    MetricName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutmetrics(
        "POST",
        "/ListAnomalyGroupTimeSeries",
        Dict{String,Any}(
            "AnomalyDetectorArn" => AnomalyDetectorArn,
            "AnomalyGroupId" => AnomalyGroupId,
            "MetricName" => MetricName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_anomaly_group_time_series(
    AnomalyDetectorArn,
    AnomalyGroupId,
    MetricName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutmetrics(
        "POST",
        "/ListAnomalyGroupTimeSeries",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AnomalyDetectorArn" => AnomalyDetectorArn,
                    "AnomalyGroupId" => AnomalyGroupId,
                    "MetricName" => MetricName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_metric_sets()
    list_metric_sets(params::Dict{String,<:Any})

Lists the datasets in the current AWS Region. Amazon Lookout for Metrics API actions are
eventually consistent. If you do a read operation on a resource immediately after creating
or modifying it, use retries to allow time for the write operation to complete.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AnomalyDetectorArn"`: The ARN of the anomaly detector containing the metrics sets to
  list.
- `"MaxResults"`: The maximum number of results to return.
- `"NextToken"`: If the result of the previous request was truncated, the response includes
  a NextToken. To retrieve the next set of results, use the token in the next request. Tokens
  expire after 24 hours.
"""
function list_metric_sets(; aws_config::AbstractAWSConfig=current_aws_config())
    return lookoutmetrics(
        "POST", "/ListMetricSets"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_metric_sets(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutmetrics(
        "POST",
        "/ListMetricSets",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Gets a list of tags for a detector, dataset, or alert.

# Arguments
- `resource_arn`: The resource's Amazon Resource Name (ARN).

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutmetrics(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutmetrics(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_feedback(anomaly_detector_arn, anomaly_group_time_series_feedback)
    put_feedback(anomaly_detector_arn, anomaly_group_time_series_feedback, params::Dict{String,<:Any})

Add feedback for an anomalous metric.

# Arguments
- `anomaly_detector_arn`: The Amazon Resource Name (ARN) of the anomaly detector.
- `anomaly_group_time_series_feedback`: Feedback for an anomalous metric.

"""
function put_feedback(
    AnomalyDetectorArn,
    AnomalyGroupTimeSeriesFeedback;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutmetrics(
        "POST",
        "/PutFeedback",
        Dict{String,Any}(
            "AnomalyDetectorArn" => AnomalyDetectorArn,
            "AnomalyGroupTimeSeriesFeedback" => AnomalyGroupTimeSeriesFeedback,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_feedback(
    AnomalyDetectorArn,
    AnomalyGroupTimeSeriesFeedback,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutmetrics(
        "POST",
        "/PutFeedback",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AnomalyDetectorArn" => AnomalyDetectorArn,
                    "AnomalyGroupTimeSeriesFeedback" => AnomalyGroupTimeSeriesFeedback,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds tags to a detector, dataset, or alert.

# Arguments
- `resource_arn`: The resource's Amazon Resource Name (ARN).
- `tags`: Tags to apply to the resource. Tag keys and values can contain letters, numbers,
  spaces, and the following symbols: _.:/=+@-

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return lookoutmetrics(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutmetrics(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes tags from a detector, dataset, or alert.

# Arguments
- `resource_arn`: The resource's Amazon Resource Name (ARN).
- `tag_keys`: Keys to remove from the resource's tags.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutmetrics(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutmetrics(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_alert(alert_arn)
    update_alert(alert_arn, params::Dict{String,<:Any})

Make changes to an existing alert.

# Arguments
- `alert_arn`: The ARN of the alert to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Action"`: Action that will be triggered when there is an alert.
- `"AlertDescription"`: A description of the alert.
- `"AlertFilters"`: The configuration of the alert filters, containing MetricList and
  DimensionFilterList.
- `"AlertSensitivityThreshold"`: An integer from 0 to 100 specifying the alert sensitivity
  threshold.
"""
function update_alert(AlertArn; aws_config::AbstractAWSConfig=current_aws_config())
    return lookoutmetrics(
        "POST",
        "/UpdateAlert",
        Dict{String,Any}("AlertArn" => AlertArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_alert(
    AlertArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutmetrics(
        "POST",
        "/UpdateAlert",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("AlertArn" => AlertArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_anomaly_detector(anomaly_detector_arn)
    update_anomaly_detector(anomaly_detector_arn, params::Dict{String,<:Any})

Updates a detector. After activation, you can only change a detector's ingestion delay and
description.

# Arguments
- `anomaly_detector_arn`: The ARN of the detector to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AnomalyDetectorConfig"`: Contains information about the configuration to which the
  detector will be updated.
- `"AnomalyDetectorDescription"`: The updated detector description.
- `"KmsKeyArn"`: The Amazon Resource Name (ARN) of an AWS KMS encryption key.
"""
function update_anomaly_detector(
    AnomalyDetectorArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return lookoutmetrics(
        "POST",
        "/UpdateAnomalyDetector",
        Dict{String,Any}("AnomalyDetectorArn" => AnomalyDetectorArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_anomaly_detector(
    AnomalyDetectorArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutmetrics(
        "POST",
        "/UpdateAnomalyDetector",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("AnomalyDetectorArn" => AnomalyDetectorArn), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_metric_set(metric_set_arn)
    update_metric_set(metric_set_arn, params::Dict{String,<:Any})

Updates a dataset.

# Arguments
- `metric_set_arn`: The ARN of the dataset to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DimensionFilterList"`: Describes a list of filters for choosing specific dimensions and
  specific values. Each filter consists of the dimension and one of its values that you want
  to include. When multiple dimensions or values are specified, the dimensions are joined
  with an AND operation and the values are joined with an OR operation.
- `"DimensionList"`: The dimension list.
- `"MetricList"`: The metric list.
- `"MetricSetDescription"`: The dataset's description.
- `"MetricSetFrequency"`: The dataset's interval.
- `"MetricSource"`:
- `"Offset"`: After an interval ends, the amount of seconds that the detector waits before
  importing data. Offset is only supported for S3, Redshift, Athena and datasources.
- `"TimestampColumn"`: The timestamp column.
"""
function update_metric_set(MetricSetArn; aws_config::AbstractAWSConfig=current_aws_config())
    return lookoutmetrics(
        "POST",
        "/UpdateMetricSet",
        Dict{String,Any}("MetricSetArn" => MetricSetArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_metric_set(
    MetricSetArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return lookoutmetrics(
        "POST",
        "/UpdateMetricSet",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("MetricSetArn" => MetricSetArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: ivs_realtime
using AWS.Compat
using AWS.UUIDs

"""
    create_encoder_configuration()
    create_encoder_configuration(params::Dict{String,<:Any})

Creates an EncoderConfiguration object.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"name"`: Optional name to identify the resource.
- `"tags"`: Tags attached to the resource. Array of maps, each of the form string:string
  (key:value). See Tagging AWS Resources for details, including restrictions that apply to
  tags and \"Tag naming limits and requirements\"; Amazon IVS has no constraints on tags
  beyond what is documented there.
- `"video"`: Video configuration. Default: video resolution 1280x720, bitrate 2500 kbps, 30
  fps.
"""
function create_encoder_configuration(; aws_config::AbstractAWSConfig=current_aws_config())
    return ivs_realtime(
        "POST",
        "/CreateEncoderConfiguration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_encoder_configuration(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs_realtime(
        "POST",
        "/CreateEncoderConfiguration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_participant_token(stage_arn)
    create_participant_token(stage_arn, params::Dict{String,<:Any})

Creates an additional token for a specified stage. This can be done after stage creation or
when tokens expire. Tokens always are scoped to the stage for which they are created.
Encryption keys are owned by Amazon IVS and never used directly by your application.

# Arguments
- `stage_arn`: ARN of the stage to which this token is scoped.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"attributes"`: Application-provided attributes to encode into the token and attach to a
  stage. Map keys and values can contain UTF-8 encoded text. The maximum length of this field
  is 1 KB total. This field is exposed to all stage participants and should not be used for
  personally identifying, confidential, or sensitive information.
- `"capabilities"`: Set of capabilities that the user is allowed to perform in the stage.
  Default: PUBLISH, SUBSCRIBE.
- `"duration"`: Duration (in minutes), after which the token expires. Default: 720 (12
  hours).
- `"userId"`: Name that can be specified to help identify the token. This can be any UTF-8
  encoded text. This field is exposed to all stage participants and should not be used for
  personally identifying, confidential, or sensitive information.
"""
function create_participant_token(
    stageArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs_realtime(
        "POST",
        "/CreateParticipantToken",
        Dict{String,Any}("stageArn" => stageArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_participant_token(
    stageArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ivs_realtime(
        "POST",
        "/CreateParticipantToken",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("stageArn" => stageArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_stage()
    create_stage(params::Dict{String,<:Any})

Creates a new stage (and optionally participant tokens).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"autoParticipantRecordingConfiguration"`: Auto participant recording configuration
  object attached to the stage.
- `"name"`: Optional name that can be specified for the stage being created.
- `"participantTokenConfigurations"`: Array of participant token configuration objects to
  attach to the new stage.
- `"tags"`: Tags attached to the resource. Array of maps, each of the form string:string
  (key:value). See Tagging AWS Resources for details, including restrictions that apply to
  tags and \"Tag naming limits and requirements\"; Amazon IVS has no constraints on tags
  beyond what is documented there.
"""
function create_stage(; aws_config::AbstractAWSConfig=current_aws_config())
    return ivs_realtime(
        "POST", "/CreateStage"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function create_stage(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs_realtime(
        "POST",
        "/CreateStage",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_storage_configuration(s3)
    create_storage_configuration(s3, params::Dict{String,<:Any})

Creates a new storage configuration, used to enable recording to Amazon S3. When a
StorageConfiguration is created, IVS will modify the S3 bucketPolicy of the provided
bucket. This will ensure that IVS has sufficient permissions to write content to the
provided bucket.

# Arguments
- `s3`: A complex type that contains a storage configuration for where recorded video will
  be stored.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"name"`: Storage configuration name. The value does not need to be unique.
- `"tags"`: Tags attached to the resource. Array of maps, each of the form string:string
  (key:value). See Tagging AWS Resources for details, including restrictions that apply to
  tags and \"Tag naming limits and requirements\"; Amazon IVS has no constraints on tags
  beyond what is documented there.
"""
function create_storage_configuration(
    s3; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs_realtime(
        "POST",
        "/CreateStorageConfiguration",
        Dict{String,Any}("s3" => s3);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_storage_configuration(
    s3, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs_realtime(
        "POST",
        "/CreateStorageConfiguration",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("s3" => s3), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_encoder_configuration(arn)
    delete_encoder_configuration(arn, params::Dict{String,<:Any})

Deletes an EncoderConfiguration resource. Ensures that no Compositions are using this
template; otherwise, returns an error.

# Arguments
- `arn`: ARN of the EncoderConfiguration.

"""
function delete_encoder_configuration(
    arn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs_realtime(
        "POST",
        "/DeleteEncoderConfiguration",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_encoder_configuration(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs_realtime(
        "POST",
        "/DeleteEncoderConfiguration",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_stage(arn)
    delete_stage(arn, params::Dict{String,<:Any})

Shuts down and deletes the specified stage (disconnecting all participants).

# Arguments
- `arn`: ARN of the stage to be deleted.

"""
function delete_stage(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return ivs_realtime(
        "POST",
        "/DeleteStage",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_stage(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs_realtime(
        "POST",
        "/DeleteStage",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_storage_configuration(arn)
    delete_storage_configuration(arn, params::Dict{String,<:Any})

Deletes the storage configuration for the specified ARN. If you try to delete a storage
configuration that is used by a Composition, you will get an error (409 ConflictException).
To avoid this, for all Compositions that reference the storage configuration, first use
StopComposition and wait for it to complete, then use DeleteStorageConfiguration.

# Arguments
- `arn`: ARN of the storage configuration to be deleted.

"""
function delete_storage_configuration(
    arn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs_realtime(
        "POST",
        "/DeleteStorageConfiguration",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_storage_configuration(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs_realtime(
        "POST",
        "/DeleteStorageConfiguration",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disconnect_participant(participant_id, stage_arn)
    disconnect_participant(participant_id, stage_arn, params::Dict{String,<:Any})

Disconnects a specified participant and revokes the participant permanently from a
specified stage.

# Arguments
- `participant_id`: Identifier of the participant to be disconnected. This is assigned by
  IVS and returned by CreateParticipantToken.
- `stage_arn`: ARN of the stage to which the participant is attached.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"reason"`: Description of why this participant is being disconnected.
"""
function disconnect_participant(
    participantId, stageArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs_realtime(
        "POST",
        "/DisconnectParticipant",
        Dict{String,Any}("participantId" => participantId, "stageArn" => stageArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disconnect_participant(
    participantId,
    stageArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ivs_realtime(
        "POST",
        "/DisconnectParticipant",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("participantId" => participantId, "stageArn" => stageArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_composition(arn)
    get_composition(arn, params::Dict{String,<:Any})

Get information about the specified Composition resource.

# Arguments
- `arn`: ARN of the Composition resource.

"""
function get_composition(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return ivs_realtime(
        "POST",
        "/GetComposition",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_composition(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs_realtime(
        "POST",
        "/GetComposition",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_encoder_configuration(arn)
    get_encoder_configuration(arn, params::Dict{String,<:Any})

Gets information about the specified EncoderConfiguration resource.

# Arguments
- `arn`: ARN of the EncoderConfiguration resource.

"""
function get_encoder_configuration(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return ivs_realtime(
        "POST",
        "/GetEncoderConfiguration",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_encoder_configuration(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs_realtime(
        "POST",
        "/GetEncoderConfiguration",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_participant(participant_id, session_id, stage_arn)
    get_participant(participant_id, session_id, stage_arn, params::Dict{String,<:Any})

Gets information about the specified participant token.

# Arguments
- `participant_id`: Unique identifier for the participant. This is assigned by IVS and
  returned by CreateParticipantToken.
- `session_id`: ID of a session within the stage.
- `stage_arn`: Stage ARN.

"""
function get_participant(
    participantId, sessionId, stageArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs_realtime(
        "POST",
        "/GetParticipant",
        Dict{String,Any}(
            "participantId" => participantId,
            "sessionId" => sessionId,
            "stageArn" => stageArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_participant(
    participantId,
    sessionId,
    stageArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ivs_realtime(
        "POST",
        "/GetParticipant",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "participantId" => participantId,
                    "sessionId" => sessionId,
                    "stageArn" => stageArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_stage(arn)
    get_stage(arn, params::Dict{String,<:Any})

Gets information for the specified stage.

# Arguments
- `arn`: ARN of the stage for which the information is to be retrieved.

"""
function get_stage(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return ivs_realtime(
        "POST",
        "/GetStage",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_stage(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs_realtime(
        "POST",
        "/GetStage",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_stage_session(session_id, stage_arn)
    get_stage_session(session_id, stage_arn, params::Dict{String,<:Any})

Gets information for the specified stage session.

# Arguments
- `session_id`: ID of a session within the stage.
- `stage_arn`: ARN of the stage for which the information is to be retrieved.

"""
function get_stage_session(
    sessionId, stageArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs_realtime(
        "POST",
        "/GetStageSession",
        Dict{String,Any}("sessionId" => sessionId, "stageArn" => stageArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_stage_session(
    sessionId,
    stageArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ivs_realtime(
        "POST",
        "/GetStageSession",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("sessionId" => sessionId, "stageArn" => stageArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_storage_configuration(arn)
    get_storage_configuration(arn, params::Dict{String,<:Any})

Gets the storage configuration for the specified ARN.

# Arguments
- `arn`: ARN of the storage configuration to be retrieved.

"""
function get_storage_configuration(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return ivs_realtime(
        "POST",
        "/GetStorageConfiguration",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_storage_configuration(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs_realtime(
        "POST",
        "/GetStorageConfiguration",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_compositions()
    list_compositions(params::Dict{String,<:Any})

Gets summary information about all Compositions in your account, in the AWS region where
the API request is processed.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filterByEncoderConfigurationArn"`: Filters the Composition list to match the specified
  EncoderConfiguration attached to at least one of its output.
- `"filterByStageArn"`: Filters the Composition list to match the specified Stage ARN.
- `"maxResults"`: Maximum number of results to return. Default: 100.
- `"nextToken"`: The first Composition to retrieve. This is used for pagination; see the
  nextToken response field.
"""
function list_compositions(; aws_config::AbstractAWSConfig=current_aws_config())
    return ivs_realtime(
        "POST", "/ListCompositions"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_compositions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs_realtime(
        "POST",
        "/ListCompositions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_encoder_configurations()
    list_encoder_configurations(params::Dict{String,<:Any})

Gets summary information about all EncoderConfigurations in your account, in the AWS region
where the API request is processed.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Maximum number of results to return. Default: 100.
- `"nextToken"`: The first encoder configuration to retrieve. This is used for pagination;
  see the nextToken response field.
"""
function list_encoder_configurations(; aws_config::AbstractAWSConfig=current_aws_config())
    return ivs_realtime(
        "POST",
        "/ListEncoderConfigurations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_encoder_configurations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs_realtime(
        "POST",
        "/ListEncoderConfigurations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_participant_events(participant_id, session_id, stage_arn)
    list_participant_events(participant_id, session_id, stage_arn, params::Dict{String,<:Any})

Lists events for a specified participant that occurred during a specified stage session.

# Arguments
- `participant_id`: Unique identifier for this participant. This is assigned by IVS and
  returned by CreateParticipantToken.
- `session_id`: ID of a session within the stage.
- `stage_arn`: Stage ARN.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Maximum number of results to return. Default: 50.
- `"nextToken"`: The first participant event to retrieve. This is used for pagination; see
  the nextToken response field.
"""
function list_participant_events(
    participantId, sessionId, stageArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs_realtime(
        "POST",
        "/ListParticipantEvents",
        Dict{String,Any}(
            "participantId" => participantId,
            "sessionId" => sessionId,
            "stageArn" => stageArn,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_participant_events(
    participantId,
    sessionId,
    stageArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ivs_realtime(
        "POST",
        "/ListParticipantEvents",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "participantId" => participantId,
                    "sessionId" => sessionId,
                    "stageArn" => stageArn,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_participants(session_id, stage_arn)
    list_participants(session_id, stage_arn, params::Dict{String,<:Any})

Lists all participants in a specified stage session.

# Arguments
- `session_id`: ID of the session within the stage.
- `stage_arn`: Stage ARN.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filterByPublished"`: Filters the response list to only show participants who published
  during the stage session. Only one of filterByUserId, filterByPublished, filterByState, or
  filterByRecordingState can be provided per request.
- `"filterByRecordingState"`: Filters the response list to only show participants with the
  specified recording state. Only one of filterByUserId, filterByPublished, filterByState, or
  filterByRecordingState can be provided per request.
- `"filterByState"`: Filters the response list to only show participants in the specified
  state. Only one of filterByUserId, filterByPublished, filterByState, or
  filterByRecordingState can be provided per request.
- `"filterByUserId"`: Filters the response list to match the specified user ID. Only one of
  filterByUserId, filterByPublished, filterByState, or filterByRecordingState can be provided
  per request. A userId is a customer-assigned name to help identify the token; this can be
  used to link a participant to a user in the customer’s own systems.
- `"maxResults"`: Maximum number of results to return. Default: 50.
- `"nextToken"`: The first participant to retrieve. This is used for pagination; see the
  nextToken response field.
"""
function list_participants(
    sessionId, stageArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs_realtime(
        "POST",
        "/ListParticipants",
        Dict{String,Any}("sessionId" => sessionId, "stageArn" => stageArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_participants(
    sessionId,
    stageArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ivs_realtime(
        "POST",
        "/ListParticipants",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("sessionId" => sessionId, "stageArn" => stageArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_stage_sessions(stage_arn)
    list_stage_sessions(stage_arn, params::Dict{String,<:Any})

Gets all sessions for a specified stage.

# Arguments
- `stage_arn`: Stage ARN.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Maximum number of results to return. Default: 50.
- `"nextToken"`: The first stage session to retrieve. This is used for pagination; see the
  nextToken response field.
"""
function list_stage_sessions(stageArn; aws_config::AbstractAWSConfig=current_aws_config())
    return ivs_realtime(
        "POST",
        "/ListStageSessions",
        Dict{String,Any}("stageArn" => stageArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_stage_sessions(
    stageArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ivs_realtime(
        "POST",
        "/ListStageSessions",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("stageArn" => stageArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_stages()
    list_stages(params::Dict{String,<:Any})

Gets summary information about all stages in your account, in the AWS region where the API
request is processed.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Maximum number of results to return. Default: 50.
- `"nextToken"`: The first stage to retrieve. This is used for pagination; see the
  nextToken response field.
"""
function list_stages(; aws_config::AbstractAWSConfig=current_aws_config())
    return ivs_realtime(
        "POST", "/ListStages"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_stages(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs_realtime(
        "POST",
        "/ListStages",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_storage_configurations()
    list_storage_configurations(params::Dict{String,<:Any})

Gets summary information about all storage configurations in your account, in the AWS
region where the API request is processed.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: Maximum number of storage configurations to return. Default: your service
  quota or 100, whichever is smaller.
- `"nextToken"`: The first storage configuration to retrieve. This is used for pagination;
  see the nextToken response field.
"""
function list_storage_configurations(; aws_config::AbstractAWSConfig=current_aws_config())
    return ivs_realtime(
        "POST",
        "/ListStorageConfigurations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_storage_configurations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs_realtime(
        "POST",
        "/ListStorageConfigurations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Gets information about AWS tags for the specified ARN.

# Arguments
- `resource_arn`: The ARN of the resource to be retrieved. The ARN must be URL-encoded.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs_realtime(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ivs_realtime(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_composition(destinations, stage_arn)
    start_composition(destinations, stage_arn, params::Dict{String,<:Any})

Starts a Composition from a stage based on the configuration provided in the request. A
Composition is an ephemeral resource that exists after this endpoint returns successfully.
Composition stops and the resource is deleted:   When StopComposition is called.   After a
1-minute timeout, when all participants are disconnected from the stage.   After a 1-minute
timeout, if there are no participants in the stage when StartComposition is called.   When
broadcasting to the IVS channel fails and all retries are exhausted.   When broadcasting is
disconnected and all attempts to reconnect are exhausted.

# Arguments
- `destinations`: Array of destination configuration.
- `stage_arn`: ARN of the stage to be used for compositing.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"idempotencyToken"`: Idempotency token.
- `"layout"`: Layout object to configure composition parameters.
- `"tags"`: Tags attached to the resource. Array of maps, each of the form string:string
  (key:value). See Tagging AWS Resources for details, including restrictions that apply to
  tags and \"Tag naming limits and requirements\"; Amazon IVS has no constraints on tags
  beyond what is documented there.
"""
function start_composition(
    destinations, stageArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs_realtime(
        "POST",
        "/StartComposition",
        Dict{String,Any}(
            "destinations" => destinations,
            "stageArn" => stageArn,
            "idempotencyToken" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_composition(
    destinations,
    stageArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ivs_realtime(
        "POST",
        "/StartComposition",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "destinations" => destinations,
                    "stageArn" => stageArn,
                    "idempotencyToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_composition(arn)
    stop_composition(arn, params::Dict{String,<:Any})

Stops and deletes a Composition resource. Any broadcast from the Composition resource is
stopped.

# Arguments
- `arn`: ARN of the Composition.

"""
function stop_composition(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return ivs_realtime(
        "POST",
        "/StopComposition",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_composition(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs_realtime(
        "POST",
        "/StopComposition",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds or updates tags for the AWS resource with the specified ARN.

# Arguments
- `resource_arn`: The ARN of the resource to be tagged. The ARN must be URL-encoded.
- `tags`: Array of tags to be added or updated. Array of maps, each of the form
  string:string (key:value). See Tagging AWS Resources for details, including restrictions
  that apply to tags and \"Tag naming limits and requirements\"; Amazon IVS has no
  constraints beyond what is documented there.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return ivs_realtime(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ivs_realtime(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes tags from the resource with the specified ARN.

# Arguments
- `resource_arn`: The ARN of the resource to be untagged. The ARN must be URL-encoded.
- `tag_keys`: Array of tags to be removed. Array of maps, each of the form string:string
  (key:value). See Tagging AWS Resources for details, including restrictions that apply to
  tags and \"Tag naming limits and requirements\"; Amazon IVS has no constraints beyond what
  is documented there.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs_realtime(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return ivs_realtime(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_stage(arn)
    update_stage(arn, params::Dict{String,<:Any})

Updates a stage’s configuration.

# Arguments
- `arn`: ARN of the stage to be updated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"autoParticipantRecordingConfiguration"`: Auto-participant-recording configuration
  object to attach to the stage. Auto-participant-recording configuration cannot be updated
  while recording is active.
- `"name"`: Name of the stage to be updated.
"""
function update_stage(arn; aws_config::AbstractAWSConfig=current_aws_config())
    return ivs_realtime(
        "POST",
        "/UpdateStage",
        Dict{String,Any}("arn" => arn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_stage(
    arn, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return ivs_realtime(
        "POST",
        "/UpdateStage",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("arn" => arn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# Must be executed in the same region where the CloudFormation template `aws_jl_test.yaml`
# was deployed into.
@testset "Load Credentials" begin
    config = current_aws_config()
    user = aws_user_arn(config)
    @test occursin(r"^arn:aws:(iam|sts)::[0-9]+:[^:]+$", user)

    @test_ecode("InvalidAction", AWSServices.iam("GetFoo"))

    @test_ecode(
        ["AccessDenied", "NoSuchEntity"],
        AWSServices.iam("GetUser", Dict("UserName" => "notauser"))
    )

    @test_ecode("ValidationError", AWSServices.iam("GetUser", Dict("UserName" => "@#!%%!")))

    # Please note: If testing in a managed Corporate AWS environment, this can set off alarms...
    @test_ecode(
        ["AccessDenied", "EntityAlreadyExists"],
        AWSServices.iam("CreateUser", Dict("UserName" => "root"))
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: direct_connect
using AWS.Compat
using AWS.UUIDs

"""
    accept_direct_connect_gateway_association_proposal(associated_gateway_owner_account, direct_connect_gateway_id, proposal_id)
    accept_direct_connect_gateway_association_proposal(associated_gateway_owner_account, direct_connect_gateway_id, proposal_id, params::Dict{String,<:Any})

Accepts a proposal request to attach a virtual private gateway or transit gateway to a
Direct Connect gateway.

# Arguments
- `associated_gateway_owner_account`: The ID of the Amazon Web Services account that owns
  the virtual private gateway or transit gateway.
- `direct_connect_gateway_id`: The ID of the Direct Connect gateway.
- `proposal_id`: The ID of the request proposal.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"overrideAllowedPrefixesToDirectConnectGateway"`: Overrides the Amazon VPC prefixes
  advertised to the Direct Connect gateway. For information about how to set the prefixes,
  see Allowed Prefixes in the Direct Connect User Guide.
"""
function accept_direct_connect_gateway_association_proposal(
    associatedGatewayOwnerAccount,
    directConnectGatewayId,
    proposalId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return direct_connect(
        "AcceptDirectConnectGatewayAssociationProposal",
        Dict{String,Any}(
            "associatedGatewayOwnerAccount" => associatedGatewayOwnerAccount,
            "directConnectGatewayId" => directConnectGatewayId,
            "proposalId" => proposalId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function accept_direct_connect_gateway_association_proposal(
    associatedGatewayOwnerAccount,
    directConnectGatewayId,
    proposalId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return direct_connect(
        "AcceptDirectConnectGatewayAssociationProposal",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "associatedGatewayOwnerAccount" => associatedGatewayOwnerAccount,
                    "directConnectGatewayId" => directConnectGatewayId,
                    "proposalId" => proposalId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    allocate_connection_on_interconnect(bandwidth, connection_name, interconnect_id, owner_account, vlan)
    allocate_connection_on_interconnect(bandwidth, connection_name, interconnect_id, owner_account, vlan, params::Dict{String,<:Any})

Deprecated. Use AllocateHostedConnection instead. Creates a hosted connection on an
interconnect. Allocates a VLAN number and a specified amount of bandwidth for use by a
hosted connection on the specified interconnect.  Intended for use by Direct Connect
Partners only.

# Arguments
- `bandwidth`: The bandwidth of the connection. The possible values are 50Mbps, 100Mbps,
  200Mbps, 300Mbps, 400Mbps, 500Mbps, 1Gbps, 2Gbps, 5Gbps, and 10Gbps. Note that only those
  Direct Connect Partners who have met specific requirements are allowed to create a 1Gbps,
  2Gbps, 5Gbps or 10Gbps hosted connection.
- `connection_name`: The name of the provisioned connection.
- `interconnect_id`: The ID of the interconnect on which the connection will be provisioned.
- `owner_account`: The ID of the Amazon Web Services account of the customer for whom the
  connection will be provisioned.
- `vlan`: The dedicated VLAN provisioned to the connection.

"""
function allocate_connection_on_interconnect(
    bandwidth,
    connectionName,
    interconnectId,
    ownerAccount,
    vlan;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return direct_connect(
        "AllocateConnectionOnInterconnect",
        Dict{String,Any}(
            "bandwidth" => bandwidth,
            "connectionName" => connectionName,
            "interconnectId" => interconnectId,
            "ownerAccount" => ownerAccount,
            "vlan" => vlan,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function allocate_connection_on_interconnect(
    bandwidth,
    connectionName,
    interconnectId,
    ownerAccount,
    vlan,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return direct_connect(
        "AllocateConnectionOnInterconnect",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "bandwidth" => bandwidth,
                    "connectionName" => connectionName,
                    "interconnectId" => interconnectId,
                    "ownerAccount" => ownerAccount,
                    "vlan" => vlan,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    allocate_hosted_connection(bandwidth, connection_id, connection_name, owner_account, vlan)
    allocate_hosted_connection(bandwidth, connection_id, connection_name, owner_account, vlan, params::Dict{String,<:Any})

Creates a hosted connection on the specified interconnect or a link aggregation group (LAG)
of interconnects. Allocates a VLAN number and a specified amount of capacity (bandwidth)
for use by a hosted connection on the specified interconnect or LAG of interconnects.
Amazon Web Services polices the hosted connection for the specified capacity and the Direct
Connect Partner must also police the hosted connection for the specified capacity.
Intended for use by Direct Connect Partners only.

# Arguments
- `bandwidth`: The bandwidth of the connection. The possible values are 50Mbps, 100Mbps,
  200Mbps, 300Mbps, 400Mbps, 500Mbps, 1Gbps, 2Gbps, 5Gbps, and 10Gbps. Note that only those
  Direct Connect Partners who have met specific requirements are allowed to create a 1Gbps,
  2Gbps, 5Gbps or 10Gbps hosted connection.
- `connection_id`: The ID of the interconnect or LAG.
- `connection_name`: The name of the hosted connection.
- `owner_account`: The ID of the Amazon Web Services account ID of the customer for the
  connection.
- `vlan`: The dedicated VLAN provisioned to the hosted connection.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tags"`: The tags associated with the connection.
"""
function allocate_hosted_connection(
    bandwidth,
    connectionId,
    connectionName,
    ownerAccount,
    vlan;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return direct_connect(
        "AllocateHostedConnection",
        Dict{String,Any}(
            "bandwidth" => bandwidth,
            "connectionId" => connectionId,
            "connectionName" => connectionName,
            "ownerAccount" => ownerAccount,
            "vlan" => vlan,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function allocate_hosted_connection(
    bandwidth,
    connectionId,
    connectionName,
    ownerAccount,
    vlan,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return direct_connect(
        "AllocateHostedConnection",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "bandwidth" => bandwidth,
                    "connectionId" => connectionId,
                    "connectionName" => connectionName,
                    "ownerAccount" => ownerAccount,
                    "vlan" => vlan,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    allocate_private_virtual_interface(connection_id, new_private_virtual_interface_allocation, owner_account)
    allocate_private_virtual_interface(connection_id, new_private_virtual_interface_allocation, owner_account, params::Dict{String,<:Any})

Provisions a private virtual interface to be owned by the specified Amazon Web Services
account. Virtual interfaces created using this action must be confirmed by the owner using
ConfirmPrivateVirtualInterface. Until then, the virtual interface is in the Confirming
state and is not available to handle traffic.

# Arguments
- `connection_id`: The ID of the connection on which the private virtual interface is
  provisioned.
- `new_private_virtual_interface_allocation`: Information about the private virtual
  interface.
- `owner_account`: The ID of the Amazon Web Services account that owns the virtual private
  interface.

"""
function allocate_private_virtual_interface(
    connectionId,
    newPrivateVirtualInterfaceAllocation,
    ownerAccount;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return direct_connect(
        "AllocatePrivateVirtualInterface",
        Dict{String,Any}(
            "connectionId" => connectionId,
            "newPrivateVirtualInterfaceAllocation" => newPrivateVirtualInterfaceAllocation,
            "ownerAccount" => ownerAccount,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function allocate_private_virtual_interface(
    connectionId,
    newPrivateVirtualInterfaceAllocation,
    ownerAccount,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return direct_connect(
        "AllocatePrivateVirtualInterface",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "connectionId" => connectionId,
                    "newPrivateVirtualInterfaceAllocation" =>
                        newPrivateVirtualInterfaceAllocation,
                    "ownerAccount" => ownerAccount,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    allocate_public_virtual_interface(connection_id, new_public_virtual_interface_allocation, owner_account)
    allocate_public_virtual_interface(connection_id, new_public_virtual_interface_allocation, owner_account, params::Dict{String,<:Any})

Provisions a public virtual interface to be owned by the specified Amazon Web Services
account. The owner of a connection calls this function to provision a public virtual
interface to be owned by the specified Amazon Web Services account. Virtual interfaces
created using this function must be confirmed by the owner using
ConfirmPublicVirtualInterface. Until this step has been completed, the virtual interface is
in the confirming state and is not available to handle traffic. When creating an IPv6
public virtual interface, omit the Amazon address and customer address. IPv6 addresses are
automatically assigned from the Amazon pool of IPv6 addresses; you cannot specify custom
IPv6 addresses.

# Arguments
- `connection_id`: The ID of the connection on which the public virtual interface is
  provisioned.
- `new_public_virtual_interface_allocation`: Information about the public virtual interface.
- `owner_account`: The ID of the Amazon Web Services account that owns the public virtual
  interface.

"""
function allocate_public_virtual_interface(
    connectionId,
    newPublicVirtualInterfaceAllocation,
    ownerAccount;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return direct_connect(
        "AllocatePublicVirtualInterface",
        Dict{String,Any}(
            "connectionId" => connectionId,
            "newPublicVirtualInterfaceAllocation" => newPublicVirtualInterfaceAllocation,
            "ownerAccount" => ownerAccount,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function allocate_public_virtual_interface(
    connectionId,
    newPublicVirtualInterfaceAllocation,
    ownerAccount,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return direct_connect(
        "AllocatePublicVirtualInterface",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "connectionId" => connectionId,
                    "newPublicVirtualInterfaceAllocation" =>
                        newPublicVirtualInterfaceAllocation,
                    "ownerAccount" => ownerAccount,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    allocate_transit_virtual_interface(connection_id, new_transit_virtual_interface_allocation, owner_account)
    allocate_transit_virtual_interface(connection_id, new_transit_virtual_interface_allocation, owner_account, params::Dict{String,<:Any})

Provisions a transit virtual interface to be owned by the specified Amazon Web Services
account. Use this type of interface to connect a transit gateway to your Direct Connect
gateway. The owner of a connection provisions a transit virtual interface to be owned by
the specified Amazon Web Services account. After you create a transit virtual interface, it
must be confirmed by the owner using ConfirmTransitVirtualInterface. Until this step has
been completed, the transit virtual interface is in the requested state and is not
available to handle traffic.

# Arguments
- `connection_id`: The ID of the connection on which the transit virtual interface is
  provisioned.
- `new_transit_virtual_interface_allocation`: Information about the transit virtual
  interface.
- `owner_account`: The ID of the Amazon Web Services account that owns the transit virtual
  interface.

"""
function allocate_transit_virtual_interface(
    connectionId,
    newTransitVirtualInterfaceAllocation,
    ownerAccount;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return direct_connect(
        "AllocateTransitVirtualInterface",
        Dict{String,Any}(
            "connectionId" => connectionId,
            "newTransitVirtualInterfaceAllocation" => newTransitVirtualInterfaceAllocation,
            "ownerAccount" => ownerAccount,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function allocate_transit_virtual_interface(
    connectionId,
    newTransitVirtualInterfaceAllocation,
    ownerAccount,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return direct_connect(
        "AllocateTransitVirtualInterface",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "connectionId" => connectionId,
                    "newTransitVirtualInterfaceAllocation" =>
                        newTransitVirtualInterfaceAllocation,
                    "ownerAccount" => ownerAccount,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_connection_with_lag(connection_id, lag_id)
    associate_connection_with_lag(connection_id, lag_id, params::Dict{String,<:Any})

Associates an existing connection with a link aggregation group (LAG). The connection is
interrupted and re-established as a member of the LAG (connectivity to Amazon Web Services
is interrupted). The connection must be hosted on the same Direct Connect endpoint as the
LAG, and its bandwidth must match the bandwidth for the LAG. You can re-associate a
connection that's currently associated with a different LAG; however, if removing the
connection would cause the original LAG to fall below its setting for minimum number of
operational connections, the request fails. Any virtual interfaces that are directly
associated with the connection are automatically re-associated with the LAG. If the
connection was originally associated with a different LAG, the virtual interfaces remain
associated with the original LAG. For interconnects, any hosted connections are
automatically re-associated with the LAG. If the interconnect was originally associated
with a different LAG, the hosted connections remain associated with the original LAG.

# Arguments
- `connection_id`: The ID of the connection.
- `lag_id`: The ID of the LAG with which to associate the connection.

"""
function associate_connection_with_lag(
    connectionId, lagId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return direct_connect(
        "AssociateConnectionWithLag",
        Dict{String,Any}("connectionId" => connectionId, "lagId" => lagId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_connection_with_lag(
    connectionId,
    lagId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return direct_connect(
        "AssociateConnectionWithLag",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("connectionId" => connectionId, "lagId" => lagId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_hosted_connection(connection_id, parent_connection_id)
    associate_hosted_connection(connection_id, parent_connection_id, params::Dict{String,<:Any})

Associates a hosted connection and its virtual interfaces with a link aggregation group
(LAG) or interconnect. If the target interconnect or LAG has an existing hosted connection
with a conflicting VLAN number or IP address, the operation fails. This action temporarily
interrupts the hosted connection's connectivity to Amazon Web Services as it is being
migrated.  Intended for use by Direct Connect Partners only.

# Arguments
- `connection_id`: The ID of the hosted connection.
- `parent_connection_id`: The ID of the interconnect or the LAG.

"""
function associate_hosted_connection(
    connectionId, parentConnectionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return direct_connect(
        "AssociateHostedConnection",
        Dict{String,Any}(
            "connectionId" => connectionId, "parentConnectionId" => parentConnectionId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_hosted_connection(
    connectionId,
    parentConnectionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return direct_connect(
        "AssociateHostedConnection",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "connectionId" => connectionId,
                    "parentConnectionId" => parentConnectionId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_mac_sec_key(connection_id)
    associate_mac_sec_key(connection_id, params::Dict{String,<:Any})

Associates a MAC Security (MACsec) Connection Key Name (CKN)/ Connectivity Association Key
(CAK) pair with an Direct Connect dedicated connection. You must supply either the
secretARN, or the CKN/CAK (ckn and cak) pair in the request. For information about MAC
Security (MACsec) key considerations, see MACsec pre-shared CKN/CAK key considerations  in
the Direct Connect User Guide.

# Arguments
- `connection_id`: The ID of the dedicated connection (dxcon-xxxx), or the ID of the LAG
  (dxlag-xxxx). You can use DescribeConnections or DescribeLags to retrieve connection ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"cak"`: The MAC Security (MACsec) CAK to associate with the dedicated connection. You
  can create the CKN/CAK pair using an industry standard tool.  The valid values are 64
  hexadecimal characters (0-9, A-E). If you use this request parameter, you must use the ckn
  request parameter and not use the secretARN request parameter.
- `"ckn"`: The MAC Security (MACsec) CKN to associate with the dedicated connection. You
  can create the CKN/CAK pair using an industry standard tool.  The valid values are 64
  hexadecimal characters (0-9, A-E). If you use this request parameter, you must use the cak
  request parameter and not use the secretARN request parameter.
- `"secretARN"`: The Amazon Resource Name (ARN) of the MAC Security (MACsec) secret key to
  associate with the dedicated connection. You can use DescribeConnections or DescribeLags to
  retrieve the MAC Security (MACsec) secret key. If you use this request parameter, you do
  not use the ckn and cak request parameters.
"""
function associate_mac_sec_key(
    connectionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return direct_connect(
        "AssociateMacSecKey",
        Dict{String,Any}("connectionId" => connectionId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_mac_sec_key(
    connectionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return direct_connect(
        "AssociateMacSecKey",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("connectionId" => connectionId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_virtual_interface(connection_id, virtual_interface_id)
    associate_virtual_interface(connection_id, virtual_interface_id, params::Dict{String,<:Any})

Associates a virtual interface with a specified link aggregation group (LAG) or connection.
Connectivity to Amazon Web Services is temporarily interrupted as the virtual interface is
being migrated. If the target connection or LAG has an associated virtual interface with a
conflicting VLAN number or a conflicting IP address, the operation fails. Virtual
interfaces associated with a hosted connection cannot be associated with a LAG; hosted
connections must be migrated along with their virtual interfaces using
AssociateHostedConnection. To reassociate a virtual interface to a new connection or LAG,
the requester must own either the virtual interface itself or the connection to which the
virtual interface is currently associated. Additionally, the requester must own the
connection or LAG for the association.

# Arguments
- `connection_id`: The ID of the LAG or connection.
- `virtual_interface_id`: The ID of the virtual interface.

"""
function associate_virtual_interface(
    connectionId, virtualInterfaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return direct_connect(
        "AssociateVirtualInterface",
        Dict{String,Any}(
            "connectionId" => connectionId, "virtualInterfaceId" => virtualInterfaceId
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_virtual_interface(
    connectionId,
    virtualInterfaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return direct_connect(
        "AssociateVirtualInterface",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "connectionId" => connectionId,
                    "virtualInterfaceId" => virtualInterfaceId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    confirm_connection(connection_id)
    confirm_connection(connection_id, params::Dict{String,<:Any})

Confirms the creation of the specified hosted connection on an interconnect. Upon creation,
the hosted connection is initially in the Ordering state, and remains in this state until
the owner confirms creation of the hosted connection.

# Arguments
- `connection_id`: The ID of the hosted connection.

"""
function confirm_connection(
    connectionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return direct_connect(
        "ConfirmConnection",
        Dict{String,Any}("connectionId" => connectionId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function confirm_connection(
    connectionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return direct_connect(
        "ConfirmConnection",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("connectionId" => connectionId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    confirm_customer_agreement()
    confirm_customer_agreement(params::Dict{String,<:Any})

 The confirmation of the terms of agreement when creating the connection/link aggregation
group (LAG).

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"agreementName"`:  The name of the customer agreement.
"""
function confirm_customer_agreement(; aws_config::AbstractAWSConfig=current_aws_config())
    return direct_connect(
        "ConfirmCustomerAgreement"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function confirm_customer_agreement(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return direct_connect(
        "ConfirmCustomerAgreement",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    confirm_private_virtual_interface(virtual_interface_id)
    confirm_private_virtual_interface(virtual_interface_id, params::Dict{String,<:Any})

Accepts ownership of a private virtual interface created by another Amazon Web Services
account. After the virtual interface owner makes this call, the virtual interface is
created and attached to the specified virtual private gateway or Direct Connect gateway,
and is made available to handle traffic.

# Arguments
- `virtual_interface_id`: The ID of the virtual interface.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"directConnectGatewayId"`: The ID of the Direct Connect gateway.
- `"virtualGatewayId"`: The ID of the virtual private gateway.
"""
function confirm_private_virtual_interface(
    virtualInterfaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return direct_connect(
        "ConfirmPrivateVirtualInterface",
        Dict{String,Any}("virtualInterfaceId" => virtualInterfaceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function confirm_private_virtual_interface(
    virtualInterfaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return direct_connect(
        "ConfirmPrivateVirtualInterface",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("virtualInterfaceId" => virtualInterfaceId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    confirm_public_virtual_interface(virtual_interface_id)
    confirm_public_virtual_interface(virtual_interface_id, params::Dict{String,<:Any})

Accepts ownership of a public virtual interface created by another Amazon Web Services
account. After the virtual interface owner makes this call, the specified virtual interface
is created and made available to handle traffic.

# Arguments
- `virtual_interface_id`: The ID of the virtual interface.

"""
function confirm_public_virtual_interface(
    virtualInterfaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return direct_connect(
        "ConfirmPublicVirtualInterface",
        Dict{String,Any}("virtualInterfaceId" => virtualInterfaceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function confirm_public_virtual_interface(
    virtualInterfaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return direct_connect(
        "ConfirmPublicVirtualInterface",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("virtualInterfaceId" => virtualInterfaceId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    confirm_transit_virtual_interface(direct_connect_gateway_id, virtual_interface_id)
    confirm_transit_virtual_interface(direct_connect_gateway_id, virtual_interface_id, params::Dict{String,<:Any})

Accepts ownership of a transit virtual interface created by another Amazon Web Services
account.  After the owner of the transit virtual interface makes this call, the specified
transit virtual interface is created and made available to handle traffic.

# Arguments
- `direct_connect_gateway_id`: The ID of the Direct Connect gateway.
- `virtual_interface_id`: The ID of the virtual interface.

"""
function confirm_transit_virtual_interface(
    directConnectGatewayId,
    virtualInterfaceId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return direct_connect(
        "ConfirmTransitVirtualInterface",
        Dict{String,Any}(
            "directConnectGatewayId" => directConnectGatewayId,
            "virtualInterfaceId" => virtualInterfaceId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function confirm_transit_virtual_interface(
    directConnectGatewayId,
    virtualInterfaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return direct_connect(
        "ConfirmTransitVirtualInterface",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "directConnectGatewayId" => directConnectGatewayId,
                    "virtualInterfaceId" => virtualInterfaceId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_bgppeer()
    create_bgppeer(params::Dict{String,<:Any})

Creates a BGP peer on the specified virtual interface. You must create a BGP peer for the
corresponding address family (IPv4/IPv6) in order to access Amazon Web Services resources
that also use that address family. If logical redundancy is not supported by the
connection, interconnect, or LAG, the BGP peer cannot be in the same address family as an
existing BGP peer on the virtual interface. When creating a IPv6 BGP peer, omit the Amazon
address and customer address. IPv6 addresses are automatically assigned from the Amazon
pool of IPv6 addresses; you cannot specify custom IPv6 addresses.  If you let Amazon Web
Services auto-assign IPv4 addresses, a /30 CIDR will be allocated from 169.254.0.0/16.
Amazon Web Services does not recommend this option if you intend to use the customer router
peer IP address as the source and destination for traffic. Instead you should use RFC 1918
or other addressing, and specify the address yourself. For more information about RFC 1918
see  Address Allocation for Private Internets.  For a public virtual interface, the
Autonomous System Number (ASN) must be private or already on the allow list for the virtual
interface.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"newBGPPeer"`: Information about the BGP peer.
- `"virtualInterfaceId"`: The ID of the virtual interface.
"""
function create_bgppeer(; aws_config::AbstractAWSConfig=current_aws_config())
    return direct_connect(
        "CreateBGPPeer"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function create_bgppeer(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return direct_connect(
        "CreateBGPPeer", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    create_connection(bandwidth, connection_name, location)
    create_connection(bandwidth, connection_name, location, params::Dict{String,<:Any})

Creates a connection between a customer network and a specific Direct Connect location. A
connection links your internal network to an Direct Connect location over a standard
Ethernet fiber-optic cable. One end of the cable is connected to your router, the other to
an Direct Connect router. To find the locations for your Region, use DescribeLocations. You
can automatically add the new connection to a link aggregation group (LAG) by specifying a
LAG ID in the request. This ensures that the new connection is allocated on the same Direct
Connect endpoint that hosts the specified LAG. If there are no available ports on the
endpoint, the request fails and no connection is created.

# Arguments
- `bandwidth`: The bandwidth of the connection.
- `connection_name`: The name of the connection.
- `location`: The location of the connection.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"lagId"`: The ID of the LAG.
- `"providerName"`: The name of the service provider associated with the requested
  connection.
- `"requestMACSec"`: Indicates whether you want the connection to support MAC Security
  (MACsec). MAC Security (MACsec) is only available on dedicated connections. For information
  about MAC Security (MACsec) prerequisties, see MACsec prerequisties in the Direct Connect
  User Guide.
- `"tags"`: The tags to associate with the lag.
"""
function create_connection(
    bandwidth, connectionName, location; aws_config::AbstractAWSConfig=current_aws_config()
)
    return direct_connect(
        "CreateConnection",
        Dict{String,Any}(
            "bandwidth" => bandwidth,
            "connectionName" => connectionName,
            "location" => location,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_connection(
    bandwidth,
    connectionName,
    location,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return direct_connect(
        "CreateConnection",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "bandwidth" => bandwidth,
                    "connectionName" => connectionName,
                    "location" => location,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_direct_connect_gateway(direct_connect_gateway_name)
    create_direct_connect_gateway(direct_connect_gateway_name, params::Dict{String,<:Any})

Creates a Direct Connect gateway, which is an intermediate object that enables you to
connect a set of virtual interfaces and virtual private gateways. A Direct Connect gateway
is global and visible in any Amazon Web Services Region after it is created. The virtual
interfaces and virtual private gateways that are connected through a Direct Connect gateway
can be in different Amazon Web Services Regions. This enables you to connect to a VPC in
any Region, regardless of the Region in which the virtual interfaces are located, and pass
traffic between them.

# Arguments
- `direct_connect_gateway_name`: The name of the Direct Connect gateway.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"amazonSideAsn"`: The autonomous system number (ASN) for Border Gateway Protocol (BGP)
  to be configured on the Amazon side of the connection. The ASN must be in the private range
  of 64,512 to 65,534 or 4,200,000,000 to 4,294,967,294. The default is 64512.
"""
function create_direct_connect_gateway(
    directConnectGatewayName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return direct_connect(
        "CreateDirectConnectGateway",
        Dict{String,Any}("directConnectGatewayName" => directConnectGatewayName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_direct_connect_gateway(
    directConnectGatewayName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return direct_connect(
        "CreateDirectConnectGateway",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("directConnectGatewayName" => directConnectGatewayName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_direct_connect_gateway_association(direct_connect_gateway_id)
    create_direct_connect_gateway_association(direct_connect_gateway_id, params::Dict{String,<:Any})

Creates an association between a Direct Connect gateway and a virtual private gateway. The
virtual private gateway must be attached to a VPC and must not be associated with another
Direct Connect gateway.

# Arguments
- `direct_connect_gateway_id`: The ID of the Direct Connect gateway.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"addAllowedPrefixesToDirectConnectGateway"`: The Amazon VPC prefixes to advertise to the
  Direct Connect gateway This parameter is required when you create an association to a
  transit gateway. For information about how to set the prefixes, see Allowed Prefixes in the
  Direct Connect User Guide.
- `"gatewayId"`: The ID of the virtual private gateway or transit gateway.
- `"virtualGatewayId"`: The ID of the virtual private gateway.
"""
function create_direct_connect_gateway_association(
    directConnectGatewayId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return direct_connect(
        "CreateDirectConnectGatewayAssociation",
        Dict{String,Any}("directConnectGatewayId" => directConnectGatewayId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_direct_connect_gateway_association(
    directConnectGatewayId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return direct_connect(
        "CreateDirectConnectGatewayAssociation",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("directConnectGatewayId" => directConnectGatewayId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_direct_connect_gateway_association_proposal(direct_connect_gateway_id, direct_connect_gateway_owner_account, gateway_id)
    create_direct_connect_gateway_association_proposal(direct_connect_gateway_id, direct_connect_gateway_owner_account, gateway_id, params::Dict{String,<:Any})

Creates a proposal to associate the specified virtual private gateway or transit gateway
with the specified Direct Connect gateway. You can associate a Direct Connect gateway and
virtual private gateway or transit gateway that is owned by any Amazon Web Services
account.

# Arguments
- `direct_connect_gateway_id`: The ID of the Direct Connect gateway.
- `direct_connect_gateway_owner_account`: The ID of the Amazon Web Services account that
  owns the Direct Connect gateway.
- `gateway_id`: The ID of the virtual private gateway or transit gateway.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"addAllowedPrefixesToDirectConnectGateway"`: The Amazon VPC prefixes to advertise to the
  Direct Connect gateway.
- `"removeAllowedPrefixesToDirectConnectGateway"`: The Amazon VPC prefixes to no longer
  advertise to the Direct Connect gateway.
"""
function create_direct_connect_gateway_association_proposal(
    directConnectGatewayId,
    directConnectGatewayOwnerAccount,
    gatewayId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return direct_connect(
        "CreateDirectConnectGatewayAssociationProposal",
        Dict{String,Any}(
            "directConnectGatewayId" => directConnectGatewayId,
            "directConnectGatewayOwnerAccount" => directConnectGatewayOwnerAccount,
            "gatewayId" => gatewayId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_direct_connect_gateway_association_proposal(
    directConnectGatewayId,
    directConnectGatewayOwnerAccount,
    gatewayId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return direct_connect(
        "CreateDirectConnectGatewayAssociationProposal",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "directConnectGatewayId" => directConnectGatewayId,
                    "directConnectGatewayOwnerAccount" => directConnectGatewayOwnerAccount,
                    "gatewayId" => gatewayId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_interconnect(bandwidth, interconnect_name, location)
    create_interconnect(bandwidth, interconnect_name, location, params::Dict{String,<:Any})

Creates an interconnect between an Direct Connect Partner's network and a specific Direct
Connect location. An interconnect is a connection that is capable of hosting other
connections. The Direct Connect Partner can use an interconnect to provide Direct Connect
hosted connections to customers through their own network services. Like a standard
connection, an interconnect links the partner's network to an Direct Connect location over
a standard Ethernet fiber-optic cable. One end is connected to the partner's router, the
other to an Direct Connect router. You can automatically add the new interconnect to a link
aggregation group (LAG) by specifying a LAG ID in the request. This ensures that the new
interconnect is allocated on the same Direct Connect endpoint that hosts the specified LAG.
If there are no available ports on the endpoint, the request fails and no interconnect is
created. For each end customer, the Direct Connect Partner provisions a connection on their
interconnect by calling AllocateHostedConnection. The end customer can then connect to
Amazon Web Services resources by creating a virtual interface on their connection, using
the VLAN assigned to them by the Direct Connect Partner.  Intended for use by Direct
Connect Partners only.

# Arguments
- `bandwidth`: The port bandwidth, in Gbps. The possible values are 1 and 10.
- `interconnect_name`: The name of the interconnect.
- `location`: The location of the interconnect.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"lagId"`: The ID of the LAG.
- `"providerName"`: The name of the service provider associated with the interconnect.
- `"tags"`: The tags to associate with the interconnect.
"""
function create_interconnect(
    bandwidth,
    interconnectName,
    location;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return direct_connect(
        "CreateInterconnect",
        Dict{String,Any}(
            "bandwidth" => bandwidth,
            "interconnectName" => interconnectName,
            "location" => location,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_interconnect(
    bandwidth,
    interconnectName,
    location,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return direct_connect(
        "CreateInterconnect",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "bandwidth" => bandwidth,
                    "interconnectName" => interconnectName,
                    "location" => location,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_lag(connections_bandwidth, lag_name, location, number_of_connections)
    create_lag(connections_bandwidth, lag_name, location, number_of_connections, params::Dict{String,<:Any})

Creates a link aggregation group (LAG) with the specified number of bundled physical
dedicated connections between the customer network and a specific Direct Connect location.
A LAG is a logical interface that uses the Link Aggregation Control Protocol (LACP) to
aggregate multiple interfaces, enabling you to treat them as a single interface. All
connections in a LAG must use the same bandwidth (either 1Gbps or 10Gbps) and must
terminate at the same Direct Connect endpoint. You can have up to 10 dedicated connections
per LAG. Regardless of this limit, if you request more connections for the LAG than Direct
Connect can allocate on a single endpoint, no LAG is created. You can specify an existing
physical dedicated connection or interconnect to include in the LAG (which counts towards
the total number of connections). Doing so interrupts the current physical dedicated
connection, and re-establishes them as a member of the LAG. The LAG will be created on the
same Direct Connect endpoint to which the dedicated connection terminates. Any virtual
interfaces associated with the dedicated connection are automatically disassociated and
re-associated with the LAG. The connection ID does not change. If the Amazon Web Services
account used to create a LAG is a registered Direct Connect Partner, the LAG is
automatically enabled to host sub-connections. For a LAG owned by a partner, any associated
virtual interfaces cannot be directly configured.

# Arguments
- `connections_bandwidth`: The bandwidth of the individual physical dedicated connections
  bundled by the LAG. The possible values are 1Gbps and 10Gbps.
- `lag_name`: The name of the LAG.
- `location`: The location for the LAG.
- `number_of_connections`: The number of physical dedicated connections initially
  provisioned and bundled by the LAG. You can have a maximum of four connections when the
  port speed is 1G or 10G, or two when the port speed is 100G.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"childConnectionTags"`: The tags to associate with the automtically created LAGs.
- `"connectionId"`: The ID of an existing dedicated connection to migrate to the LAG.
- `"providerName"`: The name of the service provider associated with the LAG.
- `"requestMACSec"`: Indicates whether the connection will support MAC Security (MACsec).
  All connections in the LAG must be capable of supporting MAC Security (MACsec). For
  information about MAC Security (MACsec) prerequisties, see MACsec prerequisties in the
  Direct Connect User Guide.
- `"tags"`: The tags to associate with the LAG.
"""
function create_lag(
    connectionsBandwidth,
    lagName,
    location,
    numberOfConnections;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return direct_connect(
        "CreateLag",
        Dict{String,Any}(
            "connectionsBandwidth" => connectionsBandwidth,
            "lagName" => lagName,
            "location" => location,
            "numberOfConnections" => numberOfConnections,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_lag(
    connectionsBandwidth,
    lagName,
    location,
    numberOfConnections,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return direct_connect(
        "CreateLag",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "connectionsBandwidth" => connectionsBandwidth,
                    "lagName" => lagName,
                    "location" => location,
                    "numberOfConnections" => numberOfConnections,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_private_virtual_interface(connection_id, new_private_virtual_interface)
    create_private_virtual_interface(connection_id, new_private_virtual_interface, params::Dict{String,<:Any})

Creates a private virtual interface. A virtual interface is the VLAN that transports Direct
Connect traffic. A private virtual interface can be connected to either a Direct Connect
gateway or a Virtual Private Gateway (VGW). Connecting the private virtual interface to a
Direct Connect gateway enables the possibility for connecting to multiple VPCs, including
VPCs in different Amazon Web Services Regions. Connecting the private virtual interface to
a VGW only provides access to a single VPC within the same Region. Setting the MTU of a
virtual interface to 9001 (jumbo frames) can cause an update to the underlying physical
connection if it wasn't updated to support jumbo frames. Updating the connection disrupts
network connectivity for all virtual interfaces associated with the connection for up to 30
seconds. To check whether your connection supports jumbo frames, call DescribeConnections.
To check whether your virtual interface supports jumbo frames, call
DescribeVirtualInterfaces.

# Arguments
- `connection_id`: The ID of the connection.
- `new_private_virtual_interface`: Information about the private virtual interface.

"""
function create_private_virtual_interface(
    connectionId,
    newPrivateVirtualInterface;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return direct_connect(
        "CreatePrivateVirtualInterface",
        Dict{String,Any}(
            "connectionId" => connectionId,
            "newPrivateVirtualInterface" => newPrivateVirtualInterface,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_private_virtual_interface(
    connectionId,
    newPrivateVirtualInterface,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return direct_connect(
        "CreatePrivateVirtualInterface",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "connectionId" => connectionId,
                    "newPrivateVirtualInterface" => newPrivateVirtualInterface,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_public_virtual_interface(connection_id, new_public_virtual_interface)
    create_public_virtual_interface(connection_id, new_public_virtual_interface, params::Dict{String,<:Any})

Creates a public virtual interface. A virtual interface is the VLAN that transports Direct
Connect traffic. A public virtual interface supports sending traffic to public services of
Amazon Web Services such as Amazon S3. When creating an IPv6 public virtual interface
(addressFamily is ipv6), leave the customer and amazon address fields blank to use
auto-assigned IPv6 space. Custom IPv6 addresses are not supported.

# Arguments
- `connection_id`: The ID of the connection.
- `new_public_virtual_interface`: Information about the public virtual interface.

"""
function create_public_virtual_interface(
    connectionId,
    newPublicVirtualInterface;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return direct_connect(
        "CreatePublicVirtualInterface",
        Dict{String,Any}(
            "connectionId" => connectionId,
            "newPublicVirtualInterface" => newPublicVirtualInterface,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_public_virtual_interface(
    connectionId,
    newPublicVirtualInterface,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return direct_connect(
        "CreatePublicVirtualInterface",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "connectionId" => connectionId,
                    "newPublicVirtualInterface" => newPublicVirtualInterface,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_transit_virtual_interface(connection_id, new_transit_virtual_interface)
    create_transit_virtual_interface(connection_id, new_transit_virtual_interface, params::Dict{String,<:Any})

Creates a transit virtual interface. A transit virtual interface should be used to access
one or more transit gateways associated with Direct Connect gateways. A transit virtual
interface enables the connection of multiple VPCs attached to a transit gateway to a Direct
Connect gateway.  If you associate your transit gateway with one or more Direct Connect
gateways, the Autonomous System Number (ASN) used by the transit gateway and the Direct
Connect gateway must be different. For example, if you use the default ASN 64512 for both
your the transit gateway and Direct Connect gateway, the association request fails.  A
jumbo MTU value must be either 1500 or 8500. No other values will be accepted. Setting the
MTU of a virtual interface to 8500 (jumbo frames) can cause an update to the underlying
physical connection if it wasn't updated to support jumbo frames. Updating the connection
disrupts network connectivity for all virtual interfaces associated with the connection for
up to 30 seconds. To check whether your connection supports jumbo frames, call
DescribeConnections. To check whether your virtual interface supports jumbo frames, call
DescribeVirtualInterfaces.

# Arguments
- `connection_id`: The ID of the connection.
- `new_transit_virtual_interface`: Information about the transit virtual interface.

"""
function create_transit_virtual_interface(
    connectionId,
    newTransitVirtualInterface;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return direct_connect(
        "CreateTransitVirtualInterface",
        Dict{String,Any}(
            "connectionId" => connectionId,
            "newTransitVirtualInterface" => newTransitVirtualInterface,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_transit_virtual_interface(
    connectionId,
    newTransitVirtualInterface,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return direct_connect(
        "CreateTransitVirtualInterface",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "connectionId" => connectionId,
                    "newTransitVirtualInterface" => newTransitVirtualInterface,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_bgppeer()
    delete_bgppeer(params::Dict{String,<:Any})

Deletes the specified BGP peer on the specified virtual interface with the specified
customer address and ASN. You cannot delete the last BGP peer from a virtual interface.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"asn"`: The autonomous system (AS) number for Border Gateway Protocol (BGP)
  configuration.
- `"bgpPeerId"`: The ID of the BGP peer.
- `"customerAddress"`: The IP address assigned to the customer interface.
- `"virtualInterfaceId"`: The ID of the virtual interface.
"""
function delete_bgppeer(; aws_config::AbstractAWSConfig=current_aws_config())
    return direct_connect(
        "DeleteBGPPeer"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function delete_bgppeer(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return direct_connect(
        "DeleteBGPPeer", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    delete_connection(connection_id)
    delete_connection(connection_id, params::Dict{String,<:Any})

Deletes the specified connection. Deleting a connection only stops the Direct Connect port
hour and data transfer charges. If you are partnering with any third parties to connect
with the Direct Connect location, you must cancel your service with them separately.

# Arguments
- `connection_id`: The ID of the connection.

"""
function delete_connection(connectionId; aws_config::AbstractAWSConfig=current_aws_config())
    return direct_connect(
        "DeleteConnection",
        Dict{String,Any}("connectionId" => connectionId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_connection(
    connectionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return direct_connect(
        "DeleteConnection",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("connectionId" => connectionId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_direct_connect_gateway(direct_connect_gateway_id)
    delete_direct_connect_gateway(direct_connect_gateway_id, params::Dict{String,<:Any})

Deletes the specified Direct Connect gateway. You must first delete all virtual interfaces
that are attached to the Direct Connect gateway and disassociate all virtual private
gateways associated with the Direct Connect gateway.

# Arguments
- `direct_connect_gateway_id`: The ID of the Direct Connect gateway.

"""
function delete_direct_connect_gateway(
    directConnectGatewayId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return direct_connect(
        "DeleteDirectConnectGateway",
        Dict{String,Any}("directConnectGatewayId" => directConnectGatewayId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_direct_connect_gateway(
    directConnectGatewayId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return direct_connect(
        "DeleteDirectConnectGateway",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("directConnectGatewayId" => directConnectGatewayId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_direct_connect_gateway_association()
    delete_direct_connect_gateway_association(params::Dict{String,<:Any})

Deletes the association between the specified Direct Connect gateway and virtual private
gateway. We recommend that you specify the associationID to delete the association.
Alternatively, if you own virtual gateway and a Direct Connect gateway association, you can
specify the virtualGatewayId and directConnectGatewayId to delete an association.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"associationId"`: The ID of the Direct Connect gateway association.
- `"directConnectGatewayId"`: The ID of the Direct Connect gateway.
- `"virtualGatewayId"`: The ID of the virtual private gateway.
"""
function delete_direct_connect_gateway_association(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return direct_connect(
        "DeleteDirectConnectGatewayAssociation";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_direct_connect_gateway_association(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return direct_connect(
        "DeleteDirectConnectGatewayAssociation",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_direct_connect_gateway_association_proposal(proposal_id)
    delete_direct_connect_gateway_association_proposal(proposal_id, params::Dict{String,<:Any})

Deletes the association proposal request between the specified Direct Connect gateway and
virtual private gateway or transit gateway.

# Arguments
- `proposal_id`: The ID of the proposal.

"""
function delete_direct_connect_gateway_association_proposal(
    proposalId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return direct_connect(
        "DeleteDirectConnectGatewayAssociationProposal",
        Dict{String,Any}("proposalId" => proposalId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_direct_connect_gateway_association_proposal(
    proposalId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return direct_connect(
        "DeleteDirectConnectGatewayAssociationProposal",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("proposalId" => proposalId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_interconnect(interconnect_id)
    delete_interconnect(interconnect_id, params::Dict{String,<:Any})

Deletes the specified interconnect.  Intended for use by Direct Connect Partners only.

# Arguments
- `interconnect_id`: The ID of the interconnect.

"""
function delete_interconnect(
    interconnectId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return direct_connect(
        "DeleteInterconnect",
        Dict{String,Any}("interconnectId" => interconnectId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_interconnect(
    interconnectId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return direct_connect(
        "DeleteInterconnect",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("interconnectId" => interconnectId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_lag(lag_id)
    delete_lag(lag_id, params::Dict{String,<:Any})

Deletes the specified link aggregation group (LAG). You cannot delete a LAG if it has
active virtual interfaces or hosted connections.

# Arguments
- `lag_id`: The ID of the LAG.

"""
function delete_lag(lagId; aws_config::AbstractAWSConfig=current_aws_config())
    return direct_connect(
        "DeleteLag",
        Dict{String,Any}("lagId" => lagId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_lag(
    lagId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return direct_connect(
        "DeleteLag",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("lagId" => lagId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_virtual_interface(virtual_interface_id)
    delete_virtual_interface(virtual_interface_id, params::Dict{String,<:Any})

Deletes a virtual interface.

# Arguments
- `virtual_interface_id`: The ID of the virtual interface.

"""
function delete_virtual_interface(
    virtualInterfaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return direct_connect(
        "DeleteVirtualInterface",
        Dict{String,Any}("virtualInterfaceId" => virtualInterfaceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_virtual_interface(
    virtualInterfaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return direct_connect(
        "DeleteVirtualInterface",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("virtualInterfaceId" => virtualInterfaceId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_connection_loa(connection_id)
    describe_connection_loa(connection_id, params::Dict{String,<:Any})

Deprecated. Use DescribeLoa instead. Gets the LOA-CFA for a connection. The Letter of
Authorization - Connecting Facility Assignment (LOA-CFA) is a document that your APN
partner or service provider uses when establishing your cross connect to Amazon Web
Services at the colocation facility. For more information, see Requesting Cross Connects at
Direct Connect Locations in the Direct Connect User Guide.

# Arguments
- `connection_id`: The ID of the connection.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"loaContentType"`: The standard media type for the LOA-CFA document. The only supported
  value is application/pdf.
- `"providerName"`: The name of the APN partner or service provider who establishes
  connectivity on your behalf. If you specify this parameter, the LOA-CFA lists the provider
  name alongside your company name as the requester of the cross connect.
"""
function describe_connection_loa(
    connectionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return direct_connect(
        "DescribeConnectionLoa",
        Dict{String,Any}("connectionId" => connectionId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_connection_loa(
    connectionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return direct_connect(
        "DescribeConnectionLoa",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("connectionId" => connectionId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_connections()
    describe_connections(params::Dict{String,<:Any})

Displays the specified connection or all connections in this Region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"connectionId"`: The ID of the connection.
"""
function describe_connections(; aws_config::AbstractAWSConfig=current_aws_config())
    return direct_connect(
        "DescribeConnections"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_connections(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return direct_connect(
        "DescribeConnections",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_connections_on_interconnect(interconnect_id)
    describe_connections_on_interconnect(interconnect_id, params::Dict{String,<:Any})

Deprecated. Use DescribeHostedConnections instead. Lists the connections that have been
provisioned on the specified interconnect.  Intended for use by Direct Connect Partners
only.

# Arguments
- `interconnect_id`: The ID of the interconnect.

"""
function describe_connections_on_interconnect(
    interconnectId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return direct_connect(
        "DescribeConnectionsOnInterconnect",
        Dict{String,Any}("interconnectId" => interconnectId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_connections_on_interconnect(
    interconnectId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return direct_connect(
        "DescribeConnectionsOnInterconnect",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("interconnectId" => interconnectId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_customer_metadata()
    describe_customer_metadata(params::Dict{String,<:Any})

Get and view a list of customer agreements, along with their signed status and whether the
customer is an NNIPartner, NNIPartnerV2, or a nonPartner.

"""
function describe_customer_metadata(; aws_config::AbstractAWSConfig=current_aws_config())
    return direct_connect(
        "DescribeCustomerMetadata"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_customer_metadata(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return direct_connect(
        "DescribeCustomerMetadata",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_direct_connect_gateway_association_proposals()
    describe_direct_connect_gateway_association_proposals(params::Dict{String,<:Any})

Describes one or more association proposals for connection between a virtual private
gateway or transit gateway and a Direct Connect gateway.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"associatedGatewayId"`: The ID of the associated gateway.
- `"directConnectGatewayId"`: The ID of the Direct Connect gateway.
- `"maxResults"`: The maximum number of results to return with a single call. To retrieve
  the remaining results, make another call with the returned nextToken value. If MaxResults
  is given a value larger than 100, only 100 results are returned.
- `"nextToken"`: The token for the next page of results.
- `"proposalId"`: The ID of the proposal.
"""
function describe_direct_connect_gateway_association_proposals(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return direct_connect(
        "DescribeDirectConnectGatewayAssociationProposals";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_direct_connect_gateway_association_proposals(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return direct_connect(
        "DescribeDirectConnectGatewayAssociationProposals",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_direct_connect_gateway_associations()
    describe_direct_connect_gateway_associations(params::Dict{String,<:Any})

Lists the associations between your Direct Connect gateways and virtual private gateways
and transit gateways. You must specify one of the following:   A Direct Connect gateway The
response contains all virtual private gateways and transit gateways associated with the
Direct Connect gateway.   A virtual private gateway The response contains the Direct
Connect gateway.   A transit gateway The response contains the Direct Connect gateway.   A
Direct Connect gateway and a virtual private gateway The response contains the association
between the Direct Connect gateway and virtual private gateway.   A Direct Connect gateway
and a transit gateway The response contains the association between the Direct Connect
gateway and transit gateway.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"associatedGatewayId"`: The ID of the associated gateway.
- `"associationId"`: The ID of the Direct Connect gateway association.
- `"directConnectGatewayId"`: The ID of the Direct Connect gateway.
- `"maxResults"`: The maximum number of results to return with a single call. To retrieve
  the remaining results, make another call with the returned nextToken value. If MaxResults
  is given a value larger than 100, only 100 results are returned.
- `"nextToken"`: The token provided in the previous call to retrieve the next page.
- `"virtualGatewayId"`: The ID of the virtual private gateway or transit gateway.
"""
function describe_direct_connect_gateway_associations(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return direct_connect(
        "DescribeDirectConnectGatewayAssociations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_direct_connect_gateway_associations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return direct_connect(
        "DescribeDirectConnectGatewayAssociations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_direct_connect_gateway_attachments()
    describe_direct_connect_gateway_attachments(params::Dict{String,<:Any})

Lists the attachments between your Direct Connect gateways and virtual interfaces. You must
specify a Direct Connect gateway, a virtual interface, or both. If you specify a Direct
Connect gateway, the response contains all virtual interfaces attached to the Direct
Connect gateway. If you specify a virtual interface, the response contains all Direct
Connect gateways attached to the virtual interface. If you specify both, the response
contains the attachment between the Direct Connect gateway and the virtual interface.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"directConnectGatewayId"`: The ID of the Direct Connect gateway.
- `"maxResults"`: The maximum number of results to return with a single call. To retrieve
  the remaining results, make another call with the returned nextToken value. If MaxResults
  is given a value larger than 100, only 100 results are returned.
- `"nextToken"`: The token provided in the previous call to retrieve the next page.
- `"virtualInterfaceId"`: The ID of the virtual interface.
"""
function describe_direct_connect_gateway_attachments(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return direct_connect(
        "DescribeDirectConnectGatewayAttachments";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_direct_connect_gateway_attachments(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return direct_connect(
        "DescribeDirectConnectGatewayAttachments",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_direct_connect_gateways()
    describe_direct_connect_gateways(params::Dict{String,<:Any})

Lists all your Direct Connect gateways or only the specified Direct Connect gateway.
Deleted Direct Connect gateways are not returned.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"directConnectGatewayId"`: The ID of the Direct Connect gateway.
- `"maxResults"`: The maximum number of results to return with a single call. To retrieve
  the remaining results, make another call with the returned nextToken value. If MaxResults
  is given a value larger than 100, only 100 results are returned.
- `"nextToken"`: The token provided in the previous call to retrieve the next page.
"""
function describe_direct_connect_gateways(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return direct_connect(
        "DescribeDirectConnectGateways";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_direct_connect_gateways(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return direct_connect(
        "DescribeDirectConnectGateways",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_hosted_connections(connection_id)
    describe_hosted_connections(connection_id, params::Dict{String,<:Any})

Lists the hosted connections that have been provisioned on the specified interconnect or
link aggregation group (LAG).  Intended for use by Direct Connect Partners only.

# Arguments
- `connection_id`: The ID of the interconnect or LAG.

"""
function describe_hosted_connections(
    connectionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return direct_connect(
        "DescribeHostedConnections",
        Dict{String,Any}("connectionId" => connectionId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_hosted_connections(
    connectionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return direct_connect(
        "DescribeHostedConnections",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("connectionId" => connectionId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_interconnect_loa(interconnect_id)
    describe_interconnect_loa(interconnect_id, params::Dict{String,<:Any})

Deprecated. Use DescribeLoa instead. Gets the LOA-CFA for the specified interconnect. The
Letter of Authorization - Connecting Facility Assignment (LOA-CFA) is a document that is
used when establishing your cross connect to Amazon Web Services at the colocation
facility. For more information, see Requesting Cross Connects at Direct Connect Locations
in the Direct Connect User Guide.

# Arguments
- `interconnect_id`: The ID of the interconnect.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"loaContentType"`: The standard media type for the LOA-CFA document. The only supported
  value is application/pdf.
- `"providerName"`: The name of the service provider who establishes connectivity on your
  behalf. If you supply this parameter, the LOA-CFA lists the provider name alongside your
  company name as the requester of the cross connect.
"""
function describe_interconnect_loa(
    interconnectId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return direct_connect(
        "DescribeInterconnectLoa",
        Dict{String,Any}("interconnectId" => interconnectId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_interconnect_loa(
    interconnectId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return direct_connect(
        "DescribeInterconnectLoa",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("interconnectId" => interconnectId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_interconnects()
    describe_interconnects(params::Dict{String,<:Any})

Lists the interconnects owned by the Amazon Web Services account or only the specified
interconnect.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"interconnectId"`: The ID of the interconnect.
"""
function describe_interconnects(; aws_config::AbstractAWSConfig=current_aws_config())
    return direct_connect(
        "DescribeInterconnects"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_interconnects(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return direct_connect(
        "DescribeInterconnects",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_lags()
    describe_lags(params::Dict{String,<:Any})

Describes all your link aggregation groups (LAG) or the specified LAG.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"lagId"`: The ID of the LAG.
"""
function describe_lags(; aws_config::AbstractAWSConfig=current_aws_config())
    return direct_connect(
        "DescribeLags"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_lags(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return direct_connect(
        "DescribeLags", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_loa(connection_id)
    describe_loa(connection_id, params::Dict{String,<:Any})

Gets the LOA-CFA for a connection, interconnect, or link aggregation group (LAG). The
Letter of Authorization - Connecting Facility Assignment (LOA-CFA) is a document that is
used when establishing your cross connect to Amazon Web Services at the colocation
facility. For more information, see Requesting Cross Connects at Direct Connect Locations
in the Direct Connect User Guide.

# Arguments
- `connection_id`: The ID of a connection, LAG, or interconnect.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"loaContentType"`: The standard media type for the LOA-CFA document. The only supported
  value is application/pdf.
- `"providerName"`: The name of the service provider who establishes connectivity on your
  behalf. If you specify this parameter, the LOA-CFA lists the provider name alongside your
  company name as the requester of the cross connect.
"""
function describe_loa(connectionId; aws_config::AbstractAWSConfig=current_aws_config())
    return direct_connect(
        "DescribeLoa",
        Dict{String,Any}("connectionId" => connectionId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_loa(
    connectionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return direct_connect(
        "DescribeLoa",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("connectionId" => connectionId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_locations()
    describe_locations(params::Dict{String,<:Any})

Lists the Direct Connect locations in the current Amazon Web Services Region. These are the
locations that can be selected when calling CreateConnection or CreateInterconnect.

"""
function describe_locations(; aws_config::AbstractAWSConfig=current_aws_config())
    return direct_connect(
        "DescribeLocations"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_locations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return direct_connect(
        "DescribeLocations", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    describe_router_configuration(virtual_interface_id)
    describe_router_configuration(virtual_interface_id, params::Dict{String,<:Any})

 Details about the router.

# Arguments
- `virtual_interface_id`: The ID of the virtual interface.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"routerTypeIdentifier"`: Identifies the router by a combination of vendor, platform, and
  software version. For example, CiscoSystemsInc-2900SeriesRouters-IOS124.
"""
function describe_router_configuration(
    virtualInterfaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return direct_connect(
        "DescribeRouterConfiguration",
        Dict{String,Any}("virtualInterfaceId" => virtualInterfaceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_router_configuration(
    virtualInterfaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return direct_connect(
        "DescribeRouterConfiguration",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("virtualInterfaceId" => virtualInterfaceId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_tags(resource_arns)
    describe_tags(resource_arns, params::Dict{String,<:Any})

Describes the tags associated with the specified Direct Connect resources.

# Arguments
- `resource_arns`: The Amazon Resource Names (ARNs) of the resources.

"""
function describe_tags(resourceArns; aws_config::AbstractAWSConfig=current_aws_config())
    return direct_connect(
        "DescribeTags",
        Dict{String,Any}("resourceArns" => resourceArns);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_tags(
    resourceArns,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return direct_connect(
        "DescribeTags",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceArns" => resourceArns), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_virtual_gateways()
    describe_virtual_gateways(params::Dict{String,<:Any})

Lists the virtual private gateways owned by the Amazon Web Services account. You can create
one or more Direct Connect private virtual interfaces linked to a virtual private gateway.

"""
function describe_virtual_gateways(; aws_config::AbstractAWSConfig=current_aws_config())
    return direct_connect(
        "DescribeVirtualGateways"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_virtual_gateways(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return direct_connect(
        "DescribeVirtualGateways",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_virtual_interfaces()
    describe_virtual_interfaces(params::Dict{String,<:Any})

Displays all virtual interfaces for an Amazon Web Services account. Virtual interfaces
deleted fewer than 15 minutes before you make the request are also returned. If you specify
a connection ID, only the virtual interfaces associated with the connection are returned.
If you specify a virtual interface ID, then only a single virtual interface is returned. A
virtual interface (VLAN) transmits the traffic between the Direct Connect location and the
customer network.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"connectionId"`: The ID of the connection.
- `"virtualInterfaceId"`: The ID of the virtual interface.
"""
function describe_virtual_interfaces(; aws_config::AbstractAWSConfig=current_aws_config())
    return direct_connect(
        "DescribeVirtualInterfaces"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_virtual_interfaces(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return direct_connect(
        "DescribeVirtualInterfaces",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_connection_from_lag(connection_id, lag_id)
    disassociate_connection_from_lag(connection_id, lag_id, params::Dict{String,<:Any})

Disassociates a connection from a link aggregation group (LAG). The connection is
interrupted and re-established as a standalone connection (the connection is not deleted;
to delete the connection, use the DeleteConnection request). If the LAG has associated
virtual interfaces or hosted connections, they remain associated with the LAG. A
disassociated connection owned by an Direct Connect Partner is automatically converted to
an interconnect. If disassociating the connection would cause the LAG to fall below its
setting for minimum number of operational connections, the request fails, except when it's
the last member of the LAG. If all connections are disassociated, the LAG continues to
exist as an empty LAG with no physical connections.

# Arguments
- `connection_id`: The ID of the connection.
- `lag_id`: The ID of the LAG.

"""
function disassociate_connection_from_lag(
    connectionId, lagId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return direct_connect(
        "DisassociateConnectionFromLag",
        Dict{String,Any}("connectionId" => connectionId, "lagId" => lagId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_connection_from_lag(
    connectionId,
    lagId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return direct_connect(
        "DisassociateConnectionFromLag",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("connectionId" => connectionId, "lagId" => lagId),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_mac_sec_key(connection_id, secret_arn)
    disassociate_mac_sec_key(connection_id, secret_arn, params::Dict{String,<:Any})

Removes the association between a MAC Security (MACsec) security key and an Direct Connect
dedicated connection.

# Arguments
- `connection_id`: The ID of the dedicated connection (dxcon-xxxx), or the ID of the LAG
  (dxlag-xxxx). You can use DescribeConnections or DescribeLags to retrieve connection ID.
- `secret_arn`: The Amazon Resource Name (ARN) of the MAC Security (MACsec) secret key. You
  can use DescribeConnections to retrieve the ARN of the MAC Security (MACsec) secret key.

"""
function disassociate_mac_sec_key(
    connectionId, secretARN; aws_config::AbstractAWSConfig=current_aws_config()
)
    return direct_connect(
        "DisassociateMacSecKey",
        Dict{String,Any}("connectionId" => connectionId, "secretARN" => secretARN);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_mac_sec_key(
    connectionId,
    secretARN,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return direct_connect(
        "DisassociateMacSecKey",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("connectionId" => connectionId, "secretARN" => secretARN),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_virtual_interface_test_history()
    list_virtual_interface_test_history(params::Dict{String,<:Any})

Lists the virtual interface failover test history.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"bgpPeers"`: The BGP peers that were placed in the DOWN state during the virtual
  interface failover test.
- `"maxResults"`: The maximum number of results to return with a single call. To retrieve
  the remaining results, make another call with the returned nextToken value. If MaxResults
  is given a value larger than 100, only 100 results are returned.
- `"nextToken"`: The token for the next page of results.
- `"status"`: The status of the virtual interface failover test.
- `"testId"`: The ID of the virtual interface failover test.
- `"virtualInterfaceId"`: The ID of the virtual interface that was tested.
"""
function list_virtual_interface_test_history(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return direct_connect(
        "ListVirtualInterfaceTestHistory";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_virtual_interface_test_history(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return direct_connect(
        "ListVirtualInterfaceTestHistory",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_bgp_failover_test(virtual_interface_id)
    start_bgp_failover_test(virtual_interface_id, params::Dict{String,<:Any})

Starts the virtual interface failover test that verifies your configuration meets your
resiliency requirements by placing the BGP peering session in the DOWN state. You can then
send traffic to verify that there are no outages. You can run the test on public, private,
transit, and hosted virtual interfaces. You can use ListVirtualInterfaceTestHistory to view
the virtual interface test history. If you need to stop the test before the test interval
completes, use StopBgpFailoverTest.

# Arguments
- `virtual_interface_id`: The ID of the virtual interface you want to test.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"bgpPeers"`: The BGP peers to place in the DOWN state.
- `"testDurationInMinutes"`: The time in minutes that the virtual interface failover test
  will last. Maximum value: 4,320 minutes (72 hours). Default: 180 minutes (3 hours).
"""
function start_bgp_failover_test(
    virtualInterfaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return direct_connect(
        "StartBgpFailoverTest",
        Dict{String,Any}("virtualInterfaceId" => virtualInterfaceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_bgp_failover_test(
    virtualInterfaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return direct_connect(
        "StartBgpFailoverTest",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("virtualInterfaceId" => virtualInterfaceId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_bgp_failover_test(virtual_interface_id)
    stop_bgp_failover_test(virtual_interface_id, params::Dict{String,<:Any})

Stops the virtual interface failover test.

# Arguments
- `virtual_interface_id`: The ID of the virtual interface you no longer want to test.

"""
function stop_bgp_failover_test(
    virtualInterfaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return direct_connect(
        "StopBgpFailoverTest",
        Dict{String,Any}("virtualInterfaceId" => virtualInterfaceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_bgp_failover_test(
    virtualInterfaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return direct_connect(
        "StopBgpFailoverTest",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("virtualInterfaceId" => virtualInterfaceId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Adds the specified tags to the specified Direct Connect resource. Each resource can have a
maximum of 50 tags. Each tag consists of a key and an optional value. If a tag with the
same key is already associated with the resource, this action updates its value.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.
- `tags`: The tags to add.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return direct_connect(
        "TagResource",
        Dict{String,Any}("resourceArn" => resourceArn, "tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return direct_connect(
        "TagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceArn" => resourceArn, "tags" => tags),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes one or more tags from the specified Direct Connect resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.
- `tag_keys`: The tag keys of the tags to remove.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return direct_connect(
        "UntagResource",
        Dict{String,Any}("resourceArn" => resourceArn, "tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return direct_connect(
        "UntagResource",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("resourceArn" => resourceArn, "tagKeys" => tagKeys),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_connection(connection_id)
    update_connection(connection_id, params::Dict{String,<:Any})

Updates the Direct Connect dedicated connection configuration. You can update the following
parameters for a connection:   The connection name   The connection's MAC Security (MACsec)
encryption mode.

# Arguments
- `connection_id`: The ID of the dedicated connection. You can use DescribeConnections to
  retrieve the connection ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"connectionName"`: The name of the connection.
- `"encryptionMode"`: The connection MAC Security (MACsec) encryption mode. The valid
  values are no_encrypt, should_encrypt, and must_encrypt.
"""
function update_connection(connectionId; aws_config::AbstractAWSConfig=current_aws_config())
    return direct_connect(
        "UpdateConnection",
        Dict{String,Any}("connectionId" => connectionId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_connection(
    connectionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return direct_connect(
        "UpdateConnection",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("connectionId" => connectionId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_direct_connect_gateway(direct_connect_gateway_id, new_direct_connect_gateway_name)
    update_direct_connect_gateway(direct_connect_gateway_id, new_direct_connect_gateway_name, params::Dict{String,<:Any})

Updates the name of a current Direct Connect gateway.

# Arguments
- `direct_connect_gateway_id`: The ID of the Direct Connect gateway to update.
- `new_direct_connect_gateway_name`: The new name for the Direct Connect gateway.

"""
function update_direct_connect_gateway(
    directConnectGatewayId,
    newDirectConnectGatewayName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return direct_connect(
        "UpdateDirectConnectGateway",
        Dict{String,Any}(
            "directConnectGatewayId" => directConnectGatewayId,
            "newDirectConnectGatewayName" => newDirectConnectGatewayName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_direct_connect_gateway(
    directConnectGatewayId,
    newDirectConnectGatewayName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return direct_connect(
        "UpdateDirectConnectGateway",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "directConnectGatewayId" => directConnectGatewayId,
                    "newDirectConnectGatewayName" => newDirectConnectGatewayName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_direct_connect_gateway_association()
    update_direct_connect_gateway_association(params::Dict{String,<:Any})

Updates the specified attributes of the Direct Connect gateway association. Add or remove
prefixes from the association.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"addAllowedPrefixesToDirectConnectGateway"`: The Amazon VPC prefixes to advertise to the
  Direct Connect gateway.
- `"associationId"`: The ID of the Direct Connect gateway association.
- `"removeAllowedPrefixesToDirectConnectGateway"`: The Amazon VPC prefixes to no longer
  advertise to the Direct Connect gateway.
"""
function update_direct_connect_gateway_association(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return direct_connect(
        "UpdateDirectConnectGatewayAssociation";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_direct_connect_gateway_association(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return direct_connect(
        "UpdateDirectConnectGatewayAssociation",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_lag(lag_id)
    update_lag(lag_id, params::Dict{String,<:Any})

Updates the attributes of the specified link aggregation group (LAG). You can update the
following LAG attributes:   The name of the LAG.   The value for the minimum number of
connections that must be operational for the LAG itself to be operational.    The LAG's
MACsec encryption mode. Amazon Web Services assigns this value to each connection which is
part of the LAG.   The tags    If you adjust the threshold value for the minimum number of
operational connections, ensure that the new value does not cause the LAG to fall below the
threshold and become non-operational.

# Arguments
- `lag_id`: The ID of the LAG.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"encryptionMode"`: The LAG MAC Security (MACsec) encryption mode. Amazon Web Services
  applies the value to all connections which are part of the LAG.
- `"lagName"`: The name of the LAG.
- `"minimumLinks"`: The minimum number of physical connections that must be operational for
  the LAG itself to be operational.
"""
function update_lag(lagId; aws_config::AbstractAWSConfig=current_aws_config())
    return direct_connect(
        "UpdateLag",
        Dict{String,Any}("lagId" => lagId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_lag(
    lagId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return direct_connect(
        "UpdateLag",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("lagId" => lagId), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_virtual_interface_attributes(virtual_interface_id)
    update_virtual_interface_attributes(virtual_interface_id, params::Dict{String,<:Any})

Updates the specified attributes of the specified virtual private interface. Setting the
MTU of a virtual interface to 9001 (jumbo frames) can cause an update to the underlying
physical connection if it wasn't updated to support jumbo frames. Updating the connection
disrupts network connectivity for all virtual interfaces associated with the connection for
up to 30 seconds. To check whether your connection supports jumbo frames, call
DescribeConnections. To check whether your virtual interface supports jumbo frames, call
DescribeVirtualInterfaces.

# Arguments
- `virtual_interface_id`: The ID of the virtual private interface.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"enableSiteLink"`: Indicates whether to enable or disable SiteLink.
- `"mtu"`: The maximum transmission unit (MTU), in bytes. The supported values are 1500 and
  9001. The default value is 1500.
- `"virtualInterfaceName"`: The name of the virtual private interface.
"""
function update_virtual_interface_attributes(
    virtualInterfaceId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return direct_connect(
        "UpdateVirtualInterfaceAttributes",
        Dict{String,Any}("virtualInterfaceId" => virtualInterfaceId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_virtual_interface_attributes(
    virtualInterfaceId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return direct_connect(
        "UpdateVirtualInterfaceAttributes",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("virtualInterfaceId" => virtualInterfaceId), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: greengrass
using AWS.Compat
using AWS.UUIDs

"""
    associate_role_to_group(group_id, role_arn)
    associate_role_to_group(group_id, role_arn, params::Dict{String,<:Any})

Associates a role with a group. Your Greengrass core will use the role to access AWS cloud
services. The role's permissions should allow Greengrass core Lambda functions to perform
actions against the cloud.

# Arguments
- `group_id`: The ID of the Greengrass group.
- `role_arn`: The ARN of the role you wish to associate with this group. The existence of
  the role is not validated.

"""
function associate_role_to_group(
    GroupId, RoleArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "PUT",
        "/greengrass/groups/$(GroupId)/role",
        Dict{String,Any}("RoleArn" => RoleArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_role_to_group(
    GroupId,
    RoleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "PUT",
        "/greengrass/groups/$(GroupId)/role",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("RoleArn" => RoleArn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_service_role_to_account(role_arn)
    associate_service_role_to_account(role_arn, params::Dict{String,<:Any})

Associates a role with your account. AWS IoT Greengrass will use the role to access your
Lambda functions and AWS IoT resources. This is necessary for deployments to succeed. The
role must have at least minimum permissions in the policy
''AWSGreengrassResourceAccessRolePolicy''.

# Arguments
- `role_arn`: The ARN of the service role you wish to associate with your account.

"""
function associate_service_role_to_account(
    RoleArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "PUT",
        "/greengrass/servicerole",
        Dict{String,Any}("RoleArn" => RoleArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_service_role_to_account(
    RoleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "PUT",
        "/greengrass/servicerole",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("RoleArn" => RoleArn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_connector_definition()
    create_connector_definition(params::Dict{String,<:Any})

Creates a connector definition. You may provide the initial version of the connector
definition now or use ''CreateConnectorDefinitionVersion'' at a later time.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"InitialVersion"`: Information about the initial version of the connector definition.
- `"Name"`: The name of the connector definition.
- `"X-Amzn-Client-Token"`: A client token used to correlate requests and responses.
- `"tags"`: Tag(s) to add to the new resource.
"""
function create_connector_definition(; aws_config::AbstractAWSConfig=current_aws_config())
    return greengrass(
        "POST",
        "/greengrass/definition/connectors";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_connector_definition(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "POST",
        "/greengrass/definition/connectors",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_connector_definition_version(connector_definition_id)
    create_connector_definition_version(connector_definition_id, params::Dict{String,<:Any})

Creates a version of a connector definition which has already been defined.

# Arguments
- `connector_definition_id`: The ID of the connector definition.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Connectors"`: A list of references to connectors in this version, with their
  corresponding configuration settings.
- `"X-Amzn-Client-Token"`: A client token used to correlate requests and responses.
"""
function create_connector_definition_version(
    ConnectorDefinitionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "POST",
        "/greengrass/definition/connectors/$(ConnectorDefinitionId)/versions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_connector_definition_version(
    ConnectorDefinitionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "POST",
        "/greengrass/definition/connectors/$(ConnectorDefinitionId)/versions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_core_definition()
    create_core_definition(params::Dict{String,<:Any})

Creates a core definition. You may provide the initial version of the core definition now
or use ''CreateCoreDefinitionVersion'' at a later time. Greengrass groups must each contain
exactly one Greengrass core.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"InitialVersion"`: Information about the initial version of the core definition.
- `"Name"`: The name of the core definition.
- `"X-Amzn-Client-Token"`: A client token used to correlate requests and responses.
- `"tags"`: Tag(s) to add to the new resource.
"""
function create_core_definition(; aws_config::AbstractAWSConfig=current_aws_config())
    return greengrass(
        "POST",
        "/greengrass/definition/cores";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_core_definition(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "POST",
        "/greengrass/definition/cores",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_core_definition_version(core_definition_id)
    create_core_definition_version(core_definition_id, params::Dict{String,<:Any})

Creates a version of a core definition that has already been defined. Greengrass groups
must each contain exactly one Greengrass core.

# Arguments
- `core_definition_id`: The ID of the core definition.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Cores"`: A list of cores in the core definition version.
- `"X-Amzn-Client-Token"`: A client token used to correlate requests and responses.
"""
function create_core_definition_version(
    CoreDefinitionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "POST",
        "/greengrass/definition/cores/$(CoreDefinitionId)/versions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_core_definition_version(
    CoreDefinitionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "POST",
        "/greengrass/definition/cores/$(CoreDefinitionId)/versions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_deployment(deployment_type, group_id)
    create_deployment(deployment_type, group_id, params::Dict{String,<:Any})

Creates a deployment. ''CreateDeployment'' requests are idempotent with respect to the
''X-Amzn-Client-Token'' token and the request parameters.

# Arguments
- `deployment_type`: The type of deployment. When used for ''CreateDeployment'', only
  ''NewDeployment'' and ''Redeployment'' are valid.
- `group_id`: The ID of the Greengrass group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DeploymentId"`: The ID of the deployment if you wish to redeploy a previous deployment.
- `"GroupVersionId"`: The ID of the group version to be deployed.
- `"X-Amzn-Client-Token"`: A client token used to correlate requests and responses.
"""
function create_deployment(
    DeploymentType, GroupId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "POST",
        "/greengrass/groups/$(GroupId)/deployments",
        Dict{String,Any}("DeploymentType" => DeploymentType);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_deployment(
    DeploymentType,
    GroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "POST",
        "/greengrass/groups/$(GroupId)/deployments",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DeploymentType" => DeploymentType), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_device_definition()
    create_device_definition(params::Dict{String,<:Any})

Creates a device definition. You may provide the initial version of the device definition
now or use ''CreateDeviceDefinitionVersion'' at a later time.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"InitialVersion"`: Information about the initial version of the device definition.
- `"Name"`: The name of the device definition.
- `"X-Amzn-Client-Token"`: A client token used to correlate requests and responses.
- `"tags"`: Tag(s) to add to the new resource.
"""
function create_device_definition(; aws_config::AbstractAWSConfig=current_aws_config())
    return greengrass(
        "POST",
        "/greengrass/definition/devices";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_device_definition(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "POST",
        "/greengrass/definition/devices",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_device_definition_version(device_definition_id)
    create_device_definition_version(device_definition_id, params::Dict{String,<:Any})

Creates a version of a device definition that has already been defined.

# Arguments
- `device_definition_id`: The ID of the device definition.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Devices"`: A list of devices in the definition version.
- `"X-Amzn-Client-Token"`: A client token used to correlate requests and responses.
"""
function create_device_definition_version(
    DeviceDefinitionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "POST",
        "/greengrass/definition/devices/$(DeviceDefinitionId)/versions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_device_definition_version(
    DeviceDefinitionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "POST",
        "/greengrass/definition/devices/$(DeviceDefinitionId)/versions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_function_definition()
    create_function_definition(params::Dict{String,<:Any})

Creates a Lambda function definition which contains a list of Lambda functions and their
configurations to be used in a group. You can create an initial version of the definition
by providing a list of Lambda functions and their configurations now, or use
''CreateFunctionDefinitionVersion'' later.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"InitialVersion"`: Information about the initial version of the function definition.
- `"Name"`: The name of the function definition.
- `"X-Amzn-Client-Token"`: A client token used to correlate requests and responses.
- `"tags"`: Tag(s) to add to the new resource.
"""
function create_function_definition(; aws_config::AbstractAWSConfig=current_aws_config())
    return greengrass(
        "POST",
        "/greengrass/definition/functions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_function_definition(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "POST",
        "/greengrass/definition/functions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_function_definition_version(function_definition_id)
    create_function_definition_version(function_definition_id, params::Dict{String,<:Any})

Creates a version of a Lambda function definition that has already been defined.

# Arguments
- `function_definition_id`: The ID of the Lambda function definition.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DefaultConfig"`: The default configuration that applies to all Lambda functions in this
  function definition version. Individual Lambda functions can override these settings.
- `"Functions"`: A list of Lambda functions in this function definition version.
- `"X-Amzn-Client-Token"`: A client token used to correlate requests and responses.
"""
function create_function_definition_version(
    FunctionDefinitionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "POST",
        "/greengrass/definition/functions/$(FunctionDefinitionId)/versions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_function_definition_version(
    FunctionDefinitionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "POST",
        "/greengrass/definition/functions/$(FunctionDefinitionId)/versions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_group(name)
    create_group(name, params::Dict{String,<:Any})

Creates a group. You may provide the initial version of the group or use
''CreateGroupVersion'' at a later time. Tip: You can use the ''gg_group_setup'' package
(https://github.com/awslabs/aws-greengrass-group-setup) as a library or command-line
application to create and deploy Greengrass groups.

# Arguments
- `name`: The name of the group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"InitialVersion"`: Information about the initial version of the group.
- `"X-Amzn-Client-Token"`: A client token used to correlate requests and responses.
- `"tags"`: Tag(s) to add to the new resource.
"""
function create_group(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return greengrass(
        "POST",
        "/greengrass/groups",
        Dict{String,Any}("Name" => Name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_group(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "POST",
        "/greengrass/groups",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("Name" => Name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_group_certificate_authority(group_id)
    create_group_certificate_authority(group_id, params::Dict{String,<:Any})

Creates a CA for the group. If a CA already exists, it will rotate the existing CA.

# Arguments
- `group_id`: The ID of the Greengrass group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"X-Amzn-Client-Token"`: A client token used to correlate requests and responses.
"""
function create_group_certificate_authority(
    GroupId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "POST",
        "/greengrass/groups/$(GroupId)/certificateauthorities";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_group_certificate_authority(
    GroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "POST",
        "/greengrass/groups/$(GroupId)/certificateauthorities",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_group_version(group_id)
    create_group_version(group_id, params::Dict{String,<:Any})

Creates a version of a group which has already been defined.

# Arguments
- `group_id`: The ID of the Greengrass group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConnectorDefinitionVersionArn"`: The ARN of the connector definition version for this
  group.
- `"CoreDefinitionVersionArn"`: The ARN of the core definition version for this group.
- `"DeviceDefinitionVersionArn"`: The ARN of the device definition version for this group.
- `"FunctionDefinitionVersionArn"`: The ARN of the function definition version for this
  group.
- `"LoggerDefinitionVersionArn"`: The ARN of the logger definition version for this group.
- `"ResourceDefinitionVersionArn"`: The ARN of the resource definition version for this
  group.
- `"SubscriptionDefinitionVersionArn"`: The ARN of the subscription definition version for
  this group.
- `"X-Amzn-Client-Token"`: A client token used to correlate requests and responses.
"""
function create_group_version(GroupId; aws_config::AbstractAWSConfig=current_aws_config())
    return greengrass(
        "POST",
        "/greengrass/groups/$(GroupId)/versions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_group_version(
    GroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "POST",
        "/greengrass/groups/$(GroupId)/versions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_logger_definition()
    create_logger_definition(params::Dict{String,<:Any})

Creates a logger definition. You may provide the initial version of the logger definition
now or use ''CreateLoggerDefinitionVersion'' at a later time.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"InitialVersion"`: Information about the initial version of the logger definition.
- `"Name"`: The name of the logger definition.
- `"X-Amzn-Client-Token"`: A client token used to correlate requests and responses.
- `"tags"`: Tag(s) to add to the new resource.
"""
function create_logger_definition(; aws_config::AbstractAWSConfig=current_aws_config())
    return greengrass(
        "POST",
        "/greengrass/definition/loggers";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_logger_definition(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "POST",
        "/greengrass/definition/loggers",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_logger_definition_version(logger_definition_id)
    create_logger_definition_version(logger_definition_id, params::Dict{String,<:Any})

Creates a version of a logger definition that has already been defined.

# Arguments
- `logger_definition_id`: The ID of the logger definition.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Loggers"`: A list of loggers.
- `"X-Amzn-Client-Token"`: A client token used to correlate requests and responses.
"""
function create_logger_definition_version(
    LoggerDefinitionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "POST",
        "/greengrass/definition/loggers/$(LoggerDefinitionId)/versions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_logger_definition_version(
    LoggerDefinitionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "POST",
        "/greengrass/definition/loggers/$(LoggerDefinitionId)/versions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_resource_definition()
    create_resource_definition(params::Dict{String,<:Any})

Creates a resource definition which contains a list of resources to be used in a group. You
can create an initial version of the definition by providing a list of resources now, or
use ''CreateResourceDefinitionVersion'' later.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"InitialVersion"`: Information about the initial version of the resource definition.
- `"Name"`: The name of the resource definition.
- `"X-Amzn-Client-Token"`: A client token used to correlate requests and responses.
- `"tags"`: Tag(s) to add to the new resource.
"""
function create_resource_definition(; aws_config::AbstractAWSConfig=current_aws_config())
    return greengrass(
        "POST",
        "/greengrass/definition/resources";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_resource_definition(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "POST",
        "/greengrass/definition/resources",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_resource_definition_version(resource_definition_id)
    create_resource_definition_version(resource_definition_id, params::Dict{String,<:Any})

Creates a version of a resource definition that has already been defined.

# Arguments
- `resource_definition_id`: The ID of the resource definition.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Resources"`: A list of resources.
- `"X-Amzn-Client-Token"`: A client token used to correlate requests and responses.
"""
function create_resource_definition_version(
    ResourceDefinitionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "POST",
        "/greengrass/definition/resources/$(ResourceDefinitionId)/versions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_resource_definition_version(
    ResourceDefinitionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "POST",
        "/greengrass/definition/resources/$(ResourceDefinitionId)/versions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_software_update_job(s3_url_signer_role, software_to_update, update_targets, update_targets_architecture, update_targets_operating_system)
    create_software_update_job(s3_url_signer_role, software_to_update, update_targets, update_targets_architecture, update_targets_operating_system, params::Dict{String,<:Any})

Creates a software update for a core or group of cores (specified as an IoT thing group.)
Use this to update the OTA Agent as well as the Greengrass core software. It makes use of
the IoT Jobs feature which provides additional commands to manage a Greengrass core
software update job.

# Arguments
- `s3_url_signer_role`:
- `software_to_update`:
- `update_targets`:
- `update_targets_architecture`:
- `update_targets_operating_system`:

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"UpdateAgentLogLevel"`:
- `"X-Amzn-Client-Token"`: A client token used to correlate requests and responses.
"""
function create_software_update_job(
    S3UrlSignerRole,
    SoftwareToUpdate,
    UpdateTargets,
    UpdateTargetsArchitecture,
    UpdateTargetsOperatingSystem;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "POST",
        "/greengrass/updates",
        Dict{String,Any}(
            "S3UrlSignerRole" => S3UrlSignerRole,
            "SoftwareToUpdate" => SoftwareToUpdate,
            "UpdateTargets" => UpdateTargets,
            "UpdateTargetsArchitecture" => UpdateTargetsArchitecture,
            "UpdateTargetsOperatingSystem" => UpdateTargetsOperatingSystem,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_software_update_job(
    S3UrlSignerRole,
    SoftwareToUpdate,
    UpdateTargets,
    UpdateTargetsArchitecture,
    UpdateTargetsOperatingSystem,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "POST",
        "/greengrass/updates",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "S3UrlSignerRole" => S3UrlSignerRole,
                    "SoftwareToUpdate" => SoftwareToUpdate,
                    "UpdateTargets" => UpdateTargets,
                    "UpdateTargetsArchitecture" => UpdateTargetsArchitecture,
                    "UpdateTargetsOperatingSystem" => UpdateTargetsOperatingSystem,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_subscription_definition()
    create_subscription_definition(params::Dict{String,<:Any})

Creates a subscription definition. You may provide the initial version of the subscription
definition now or use ''CreateSubscriptionDefinitionVersion'' at a later time.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"InitialVersion"`: Information about the initial version of the subscription definition.
- `"Name"`: The name of the subscription definition.
- `"X-Amzn-Client-Token"`: A client token used to correlate requests and responses.
- `"tags"`: Tag(s) to add to the new resource.
"""
function create_subscription_definition(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "POST",
        "/greengrass/definition/subscriptions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_subscription_definition(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "POST",
        "/greengrass/definition/subscriptions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_subscription_definition_version(subscription_definition_id)
    create_subscription_definition_version(subscription_definition_id, params::Dict{String,<:Any})

Creates a version of a subscription definition which has already been defined.

# Arguments
- `subscription_definition_id`: The ID of the subscription definition.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Subscriptions"`: A list of subscriptions.
- `"X-Amzn-Client-Token"`: A client token used to correlate requests and responses.
"""
function create_subscription_definition_version(
    SubscriptionDefinitionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "POST",
        "/greengrass/definition/subscriptions/$(SubscriptionDefinitionId)/versions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_subscription_definition_version(
    SubscriptionDefinitionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "POST",
        "/greengrass/definition/subscriptions/$(SubscriptionDefinitionId)/versions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_connector_definition(connector_definition_id)
    delete_connector_definition(connector_definition_id, params::Dict{String,<:Any})

Deletes a connector definition.

# Arguments
- `connector_definition_id`: The ID of the connector definition.

"""
function delete_connector_definition(
    ConnectorDefinitionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "DELETE",
        "/greengrass/definition/connectors/$(ConnectorDefinitionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_connector_definition(
    ConnectorDefinitionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "DELETE",
        "/greengrass/definition/connectors/$(ConnectorDefinitionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_core_definition(core_definition_id)
    delete_core_definition(core_definition_id, params::Dict{String,<:Any})

Deletes a core definition.

# Arguments
- `core_definition_id`: The ID of the core definition.

"""
function delete_core_definition(
    CoreDefinitionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "DELETE",
        "/greengrass/definition/cores/$(CoreDefinitionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_core_definition(
    CoreDefinitionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "DELETE",
        "/greengrass/definition/cores/$(CoreDefinitionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_device_definition(device_definition_id)
    delete_device_definition(device_definition_id, params::Dict{String,<:Any})

Deletes a device definition.

# Arguments
- `device_definition_id`: The ID of the device definition.

"""
function delete_device_definition(
    DeviceDefinitionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "DELETE",
        "/greengrass/definition/devices/$(DeviceDefinitionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_device_definition(
    DeviceDefinitionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "DELETE",
        "/greengrass/definition/devices/$(DeviceDefinitionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_function_definition(function_definition_id)
    delete_function_definition(function_definition_id, params::Dict{String,<:Any})

Deletes a Lambda function definition.

# Arguments
- `function_definition_id`: The ID of the Lambda function definition.

"""
function delete_function_definition(
    FunctionDefinitionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "DELETE",
        "/greengrass/definition/functions/$(FunctionDefinitionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_function_definition(
    FunctionDefinitionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "DELETE",
        "/greengrass/definition/functions/$(FunctionDefinitionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_group(group_id)
    delete_group(group_id, params::Dict{String,<:Any})

Deletes a group.

# Arguments
- `group_id`: The ID of the Greengrass group.

"""
function delete_group(GroupId; aws_config::AbstractAWSConfig=current_aws_config())
    return greengrass(
        "DELETE",
        "/greengrass/groups/$(GroupId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_group(
    GroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "DELETE",
        "/greengrass/groups/$(GroupId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_logger_definition(logger_definition_id)
    delete_logger_definition(logger_definition_id, params::Dict{String,<:Any})

Deletes a logger definition.

# Arguments
- `logger_definition_id`: The ID of the logger definition.

"""
function delete_logger_definition(
    LoggerDefinitionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "DELETE",
        "/greengrass/definition/loggers/$(LoggerDefinitionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_logger_definition(
    LoggerDefinitionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "DELETE",
        "/greengrass/definition/loggers/$(LoggerDefinitionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_resource_definition(resource_definition_id)
    delete_resource_definition(resource_definition_id, params::Dict{String,<:Any})

Deletes a resource definition.

# Arguments
- `resource_definition_id`: The ID of the resource definition.

"""
function delete_resource_definition(
    ResourceDefinitionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "DELETE",
        "/greengrass/definition/resources/$(ResourceDefinitionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_resource_definition(
    ResourceDefinitionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "DELETE",
        "/greengrass/definition/resources/$(ResourceDefinitionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_subscription_definition(subscription_definition_id)
    delete_subscription_definition(subscription_definition_id, params::Dict{String,<:Any})

Deletes a subscription definition.

# Arguments
- `subscription_definition_id`: The ID of the subscription definition.

"""
function delete_subscription_definition(
    SubscriptionDefinitionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "DELETE",
        "/greengrass/definition/subscriptions/$(SubscriptionDefinitionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_subscription_definition(
    SubscriptionDefinitionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "DELETE",
        "/greengrass/definition/subscriptions/$(SubscriptionDefinitionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_role_from_group(group_id)
    disassociate_role_from_group(group_id, params::Dict{String,<:Any})

Disassociates the role from a group.

# Arguments
- `group_id`: The ID of the Greengrass group.

"""
function disassociate_role_from_group(
    GroupId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "DELETE",
        "/greengrass/groups/$(GroupId)/role";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_role_from_group(
    GroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "DELETE",
        "/greengrass/groups/$(GroupId)/role",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_service_role_from_account()
    disassociate_service_role_from_account(params::Dict{String,<:Any})

Disassociates the service role from your account. Without a service role, deployments will
not work.

"""
function disassociate_service_role_from_account(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "DELETE",
        "/greengrass/servicerole";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_service_role_from_account(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "DELETE",
        "/greengrass/servicerole",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_associated_role(group_id)
    get_associated_role(group_id, params::Dict{String,<:Any})

Retrieves the role associated with a particular group.

# Arguments
- `group_id`: The ID of the Greengrass group.

"""
function get_associated_role(GroupId; aws_config::AbstractAWSConfig=current_aws_config())
    return greengrass(
        "GET",
        "/greengrass/groups/$(GroupId)/role";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_associated_role(
    GroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "GET",
        "/greengrass/groups/$(GroupId)/role",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_bulk_deployment_status(bulk_deployment_id)
    get_bulk_deployment_status(bulk_deployment_id, params::Dict{String,<:Any})

Returns the status of a bulk deployment.

# Arguments
- `bulk_deployment_id`: The ID of the bulk deployment.

"""
function get_bulk_deployment_status(
    BulkDeploymentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "GET",
        "/greengrass/bulk/deployments/$(BulkDeploymentId)/status";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_bulk_deployment_status(
    BulkDeploymentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "GET",
        "/greengrass/bulk/deployments/$(BulkDeploymentId)/status",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_connectivity_info(thing_name)
    get_connectivity_info(thing_name, params::Dict{String,<:Any})

Retrieves the connectivity information for a core.

# Arguments
- `thing_name`: The thing name.

"""
function get_connectivity_info(
    ThingName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "GET",
        "/greengrass/things/$(ThingName)/connectivityInfo";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_connectivity_info(
    ThingName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "GET",
        "/greengrass/things/$(ThingName)/connectivityInfo",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_connector_definition(connector_definition_id)
    get_connector_definition(connector_definition_id, params::Dict{String,<:Any})

Retrieves information about a connector definition.

# Arguments
- `connector_definition_id`: The ID of the connector definition.

"""
function get_connector_definition(
    ConnectorDefinitionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "GET",
        "/greengrass/definition/connectors/$(ConnectorDefinitionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_connector_definition(
    ConnectorDefinitionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "GET",
        "/greengrass/definition/connectors/$(ConnectorDefinitionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_connector_definition_version(connector_definition_id, connector_definition_version_id)
    get_connector_definition_version(connector_definition_id, connector_definition_version_id, params::Dict{String,<:Any})

Retrieves information about a connector definition version, including the connectors that
the version contains. Connectors are prebuilt modules that interact with local
infrastructure, device protocols, AWS, and other cloud services.

# Arguments
- `connector_definition_id`: The ID of the connector definition.
- `connector_definition_version_id`: The ID of the connector definition version. This value
  maps to the ''Version'' property of the corresponding ''VersionInformation'' object, which
  is returned by ''ListConnectorDefinitionVersions'' requests. If the version is the last one
  that was associated with a connector definition, the value also maps to the
  ''LatestVersion'' property of the corresponding ''DefinitionInformation'' object.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: The token for the next set of results, or ''null'' if there are no
  additional results.
"""
function get_connector_definition_version(
    ConnectorDefinitionId,
    ConnectorDefinitionVersionId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "GET",
        "/greengrass/definition/connectors/$(ConnectorDefinitionId)/versions/$(ConnectorDefinitionVersionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_connector_definition_version(
    ConnectorDefinitionId,
    ConnectorDefinitionVersionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "GET",
        "/greengrass/definition/connectors/$(ConnectorDefinitionId)/versions/$(ConnectorDefinitionVersionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_core_definition(core_definition_id)
    get_core_definition(core_definition_id, params::Dict{String,<:Any})

Retrieves information about a core definition version.

# Arguments
- `core_definition_id`: The ID of the core definition.

"""
function get_core_definition(
    CoreDefinitionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "GET",
        "/greengrass/definition/cores/$(CoreDefinitionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_core_definition(
    CoreDefinitionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "GET",
        "/greengrass/definition/cores/$(CoreDefinitionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_core_definition_version(core_definition_id, core_definition_version_id)
    get_core_definition_version(core_definition_id, core_definition_version_id, params::Dict{String,<:Any})

Retrieves information about a core definition version.

# Arguments
- `core_definition_id`: The ID of the core definition.
- `core_definition_version_id`: The ID of the core definition version. This value maps to
  the ''Version'' property of the corresponding ''VersionInformation'' object, which is
  returned by ''ListCoreDefinitionVersions'' requests. If the version is the last one that
  was associated with a core definition, the value also maps to the ''LatestVersion''
  property of the corresponding ''DefinitionInformation'' object.

"""
function get_core_definition_version(
    CoreDefinitionId,
    CoreDefinitionVersionId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "GET",
        "/greengrass/definition/cores/$(CoreDefinitionId)/versions/$(CoreDefinitionVersionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_core_definition_version(
    CoreDefinitionId,
    CoreDefinitionVersionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "GET",
        "/greengrass/definition/cores/$(CoreDefinitionId)/versions/$(CoreDefinitionVersionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_deployment_status(deployment_id, group_id)
    get_deployment_status(deployment_id, group_id, params::Dict{String,<:Any})

Returns the status of a deployment.

# Arguments
- `deployment_id`: The ID of the deployment.
- `group_id`: The ID of the Greengrass group.

"""
function get_deployment_status(
    DeploymentId, GroupId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "GET",
        "/greengrass/groups/$(GroupId)/deployments/$(DeploymentId)/status";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_deployment_status(
    DeploymentId,
    GroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "GET",
        "/greengrass/groups/$(GroupId)/deployments/$(DeploymentId)/status",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_device_definition(device_definition_id)
    get_device_definition(device_definition_id, params::Dict{String,<:Any})

Retrieves information about a device definition.

# Arguments
- `device_definition_id`: The ID of the device definition.

"""
function get_device_definition(
    DeviceDefinitionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "GET",
        "/greengrass/definition/devices/$(DeviceDefinitionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_device_definition(
    DeviceDefinitionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "GET",
        "/greengrass/definition/devices/$(DeviceDefinitionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_device_definition_version(device_definition_id, device_definition_version_id)
    get_device_definition_version(device_definition_id, device_definition_version_id, params::Dict{String,<:Any})

Retrieves information about a device definition version.

# Arguments
- `device_definition_id`: The ID of the device definition.
- `device_definition_version_id`: The ID of the device definition version. This value maps
  to the ''Version'' property of the corresponding ''VersionInformation'' object, which is
  returned by ''ListDeviceDefinitionVersions'' requests. If the version is the last one that
  was associated with a device definition, the value also maps to the ''LatestVersion''
  property of the corresponding ''DefinitionInformation'' object.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: The token for the next set of results, or ''null'' if there are no
  additional results.
"""
function get_device_definition_version(
    DeviceDefinitionId,
    DeviceDefinitionVersionId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "GET",
        "/greengrass/definition/devices/$(DeviceDefinitionId)/versions/$(DeviceDefinitionVersionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_device_definition_version(
    DeviceDefinitionId,
    DeviceDefinitionVersionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "GET",
        "/greengrass/definition/devices/$(DeviceDefinitionId)/versions/$(DeviceDefinitionVersionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_function_definition(function_definition_id)
    get_function_definition(function_definition_id, params::Dict{String,<:Any})

Retrieves information about a Lambda function definition, including its creation time and
latest version.

# Arguments
- `function_definition_id`: The ID of the Lambda function definition.

"""
function get_function_definition(
    FunctionDefinitionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "GET",
        "/greengrass/definition/functions/$(FunctionDefinitionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_function_definition(
    FunctionDefinitionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "GET",
        "/greengrass/definition/functions/$(FunctionDefinitionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_function_definition_version(function_definition_id, function_definition_version_id)
    get_function_definition_version(function_definition_id, function_definition_version_id, params::Dict{String,<:Any})

Retrieves information about a Lambda function definition version, including which Lambda
functions are included in the version and their configurations.

# Arguments
- `function_definition_id`: The ID of the Lambda function definition.
- `function_definition_version_id`: The ID of the function definition version. This value
  maps to the ''Version'' property of the corresponding ''VersionInformation'' object, which
  is returned by ''ListFunctionDefinitionVersions'' requests. If the version is the last one
  that was associated with a function definition, the value also maps to the
  ''LatestVersion'' property of the corresponding ''DefinitionInformation'' object.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: The token for the next set of results, or ''null'' if there are no
  additional results.
"""
function get_function_definition_version(
    FunctionDefinitionId,
    FunctionDefinitionVersionId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "GET",
        "/greengrass/definition/functions/$(FunctionDefinitionId)/versions/$(FunctionDefinitionVersionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_function_definition_version(
    FunctionDefinitionId,
    FunctionDefinitionVersionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "GET",
        "/greengrass/definition/functions/$(FunctionDefinitionId)/versions/$(FunctionDefinitionVersionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_group(group_id)
    get_group(group_id, params::Dict{String,<:Any})

Retrieves information about a group.

# Arguments
- `group_id`: The ID of the Greengrass group.

"""
function get_group(GroupId; aws_config::AbstractAWSConfig=current_aws_config())
    return greengrass(
        "GET",
        "/greengrass/groups/$(GroupId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_group(
    GroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "GET",
        "/greengrass/groups/$(GroupId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_group_certificate_authority(certificate_authority_id, group_id)
    get_group_certificate_authority(certificate_authority_id, group_id, params::Dict{String,<:Any})

Retreives the CA associated with a group. Returns the public key of the CA.

# Arguments
- `certificate_authority_id`: The ID of the certificate authority.
- `group_id`: The ID of the Greengrass group.

"""
function get_group_certificate_authority(
    CertificateAuthorityId, GroupId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "GET",
        "/greengrass/groups/$(GroupId)/certificateauthorities/$(CertificateAuthorityId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_group_certificate_authority(
    CertificateAuthorityId,
    GroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "GET",
        "/greengrass/groups/$(GroupId)/certificateauthorities/$(CertificateAuthorityId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_group_certificate_configuration(group_id)
    get_group_certificate_configuration(group_id, params::Dict{String,<:Any})

Retrieves the current configuration for the CA used by the group.

# Arguments
- `group_id`: The ID of the Greengrass group.

"""
function get_group_certificate_configuration(
    GroupId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "GET",
        "/greengrass/groups/$(GroupId)/certificateauthorities/configuration/expiry";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_group_certificate_configuration(
    GroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "GET",
        "/greengrass/groups/$(GroupId)/certificateauthorities/configuration/expiry",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_group_version(group_id, group_version_id)
    get_group_version(group_id, group_version_id, params::Dict{String,<:Any})

Retrieves information about a group version.

# Arguments
- `group_id`: The ID of the Greengrass group.
- `group_version_id`: The ID of the group version. This value maps to the ''Version''
  property of the corresponding ''VersionInformation'' object, which is returned by
  ''ListGroupVersions'' requests. If the version is the last one that was associated with a
  group, the value also maps to the ''LatestVersion'' property of the corresponding
  ''GroupInformation'' object.

"""
function get_group_version(
    GroupId, GroupVersionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "GET",
        "/greengrass/groups/$(GroupId)/versions/$(GroupVersionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_group_version(
    GroupId,
    GroupVersionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "GET",
        "/greengrass/groups/$(GroupId)/versions/$(GroupVersionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_logger_definition(logger_definition_id)
    get_logger_definition(logger_definition_id, params::Dict{String,<:Any})

Retrieves information about a logger definition.

# Arguments
- `logger_definition_id`: The ID of the logger definition.

"""
function get_logger_definition(
    LoggerDefinitionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "GET",
        "/greengrass/definition/loggers/$(LoggerDefinitionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_logger_definition(
    LoggerDefinitionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "GET",
        "/greengrass/definition/loggers/$(LoggerDefinitionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_logger_definition_version(logger_definition_id, logger_definition_version_id)
    get_logger_definition_version(logger_definition_id, logger_definition_version_id, params::Dict{String,<:Any})

Retrieves information about a logger definition version.

# Arguments
- `logger_definition_id`: The ID of the logger definition.
- `logger_definition_version_id`: The ID of the logger definition version. This value maps
  to the ''Version'' property of the corresponding ''VersionInformation'' object, which is
  returned by ''ListLoggerDefinitionVersions'' requests. If the version is the last one that
  was associated with a logger definition, the value also maps to the ''LatestVersion''
  property of the corresponding ''DefinitionInformation'' object.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: The token for the next set of results, or ''null'' if there are no
  additional results.
"""
function get_logger_definition_version(
    LoggerDefinitionId,
    LoggerDefinitionVersionId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "GET",
        "/greengrass/definition/loggers/$(LoggerDefinitionId)/versions/$(LoggerDefinitionVersionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_logger_definition_version(
    LoggerDefinitionId,
    LoggerDefinitionVersionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "GET",
        "/greengrass/definition/loggers/$(LoggerDefinitionId)/versions/$(LoggerDefinitionVersionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_resource_definition(resource_definition_id)
    get_resource_definition(resource_definition_id, params::Dict{String,<:Any})

Retrieves information about a resource definition, including its creation time and latest
version.

# Arguments
- `resource_definition_id`: The ID of the resource definition.

"""
function get_resource_definition(
    ResourceDefinitionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "GET",
        "/greengrass/definition/resources/$(ResourceDefinitionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_resource_definition(
    ResourceDefinitionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "GET",
        "/greengrass/definition/resources/$(ResourceDefinitionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_resource_definition_version(resource_definition_id, resource_definition_version_id)
    get_resource_definition_version(resource_definition_id, resource_definition_version_id, params::Dict{String,<:Any})

Retrieves information about a resource definition version, including which resources are
included in the version.

# Arguments
- `resource_definition_id`: The ID of the resource definition.
- `resource_definition_version_id`: The ID of the resource definition version. This value
  maps to the ''Version'' property of the corresponding ''VersionInformation'' object, which
  is returned by ''ListResourceDefinitionVersions'' requests. If the version is the last one
  that was associated with a resource definition, the value also maps to the
  ''LatestVersion'' property of the corresponding ''DefinitionInformation'' object.

"""
function get_resource_definition_version(
    ResourceDefinitionId,
    ResourceDefinitionVersionId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "GET",
        "/greengrass/definition/resources/$(ResourceDefinitionId)/versions/$(ResourceDefinitionVersionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_resource_definition_version(
    ResourceDefinitionId,
    ResourceDefinitionVersionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "GET",
        "/greengrass/definition/resources/$(ResourceDefinitionId)/versions/$(ResourceDefinitionVersionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_service_role_for_account()
    get_service_role_for_account(params::Dict{String,<:Any})

Retrieves the service role that is attached to your account.

"""
function get_service_role_for_account(; aws_config::AbstractAWSConfig=current_aws_config())
    return greengrass(
        "GET",
        "/greengrass/servicerole";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_service_role_for_account(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "GET",
        "/greengrass/servicerole",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_subscription_definition(subscription_definition_id)
    get_subscription_definition(subscription_definition_id, params::Dict{String,<:Any})

Retrieves information about a subscription definition.

# Arguments
- `subscription_definition_id`: The ID of the subscription definition.

"""
function get_subscription_definition(
    SubscriptionDefinitionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "GET",
        "/greengrass/definition/subscriptions/$(SubscriptionDefinitionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_subscription_definition(
    SubscriptionDefinitionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "GET",
        "/greengrass/definition/subscriptions/$(SubscriptionDefinitionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_subscription_definition_version(subscription_definition_id, subscription_definition_version_id)
    get_subscription_definition_version(subscription_definition_id, subscription_definition_version_id, params::Dict{String,<:Any})

Retrieves information about a subscription definition version.

# Arguments
- `subscription_definition_id`: The ID of the subscription definition.
- `subscription_definition_version_id`: The ID of the subscription definition version. This
  value maps to the ''Version'' property of the corresponding ''VersionInformation'' object,
  which is returned by ''ListSubscriptionDefinitionVersions'' requests. If the version is the
  last one that was associated with a subscription definition, the value also maps to the
  ''LatestVersion'' property of the corresponding ''DefinitionInformation'' object.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"NextToken"`: The token for the next set of results, or ''null'' if there are no
  additional results.
"""
function get_subscription_definition_version(
    SubscriptionDefinitionId,
    SubscriptionDefinitionVersionId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "GET",
        "/greengrass/definition/subscriptions/$(SubscriptionDefinitionId)/versions/$(SubscriptionDefinitionVersionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_subscription_definition_version(
    SubscriptionDefinitionId,
    SubscriptionDefinitionVersionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "GET",
        "/greengrass/definition/subscriptions/$(SubscriptionDefinitionId)/versions/$(SubscriptionDefinitionVersionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_thing_runtime_configuration(thing_name)
    get_thing_runtime_configuration(thing_name, params::Dict{String,<:Any})

Get the runtime configuration of a thing.

# Arguments
- `thing_name`: The thing name.

"""
function get_thing_runtime_configuration(
    ThingName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "GET",
        "/greengrass/things/$(ThingName)/runtimeconfig";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_thing_runtime_configuration(
    ThingName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "GET",
        "/greengrass/things/$(ThingName)/runtimeconfig",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_bulk_deployment_detailed_reports(bulk_deployment_id)
    list_bulk_deployment_detailed_reports(bulk_deployment_id, params::Dict{String,<:Any})

Gets a paginated list of the deployments that have been started in a bulk deployment
operation, and their current deployment status.

# Arguments
- `bulk_deployment_id`: The ID of the bulk deployment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to be returned per request.
- `"NextToken"`: The token for the next set of results, or ''null'' if there are no
  additional results.
"""
function list_bulk_deployment_detailed_reports(
    BulkDeploymentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "GET",
        "/greengrass/bulk/deployments/$(BulkDeploymentId)/detailed-reports";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_bulk_deployment_detailed_reports(
    BulkDeploymentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "GET",
        "/greengrass/bulk/deployments/$(BulkDeploymentId)/detailed-reports",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_bulk_deployments()
    list_bulk_deployments(params::Dict{String,<:Any})

Returns a list of bulk deployments.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to be returned per request.
- `"NextToken"`: The token for the next set of results, or ''null'' if there are no
  additional results.
"""
function list_bulk_deployments(; aws_config::AbstractAWSConfig=current_aws_config())
    return greengrass(
        "GET",
        "/greengrass/bulk/deployments";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_bulk_deployments(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "GET",
        "/greengrass/bulk/deployments",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_connector_definition_versions(connector_definition_id)
    list_connector_definition_versions(connector_definition_id, params::Dict{String,<:Any})

Lists the versions of a connector definition, which are containers for connectors.
Connectors run on the Greengrass core and contain built-in integration with local
infrastructure, device protocols, AWS, and other cloud services.

# Arguments
- `connector_definition_id`: The ID of the connector definition.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to be returned per request.
- `"NextToken"`: The token for the next set of results, or ''null'' if there are no
  additional results.
"""
function list_connector_definition_versions(
    ConnectorDefinitionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "GET",
        "/greengrass/definition/connectors/$(ConnectorDefinitionId)/versions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_connector_definition_versions(
    ConnectorDefinitionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "GET",
        "/greengrass/definition/connectors/$(ConnectorDefinitionId)/versions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_connector_definitions()
    list_connector_definitions(params::Dict{String,<:Any})

Retrieves a list of connector definitions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to be returned per request.
- `"NextToken"`: The token for the next set of results, or ''null'' if there are no
  additional results.
"""
function list_connector_definitions(; aws_config::AbstractAWSConfig=current_aws_config())
    return greengrass(
        "GET",
        "/greengrass/definition/connectors";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_connector_definitions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "GET",
        "/greengrass/definition/connectors",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_core_definition_versions(core_definition_id)
    list_core_definition_versions(core_definition_id, params::Dict{String,<:Any})

Lists the versions of a core definition.

# Arguments
- `core_definition_id`: The ID of the core definition.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to be returned per request.
- `"NextToken"`: The token for the next set of results, or ''null'' if there are no
  additional results.
"""
function list_core_definition_versions(
    CoreDefinitionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "GET",
        "/greengrass/definition/cores/$(CoreDefinitionId)/versions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_core_definition_versions(
    CoreDefinitionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "GET",
        "/greengrass/definition/cores/$(CoreDefinitionId)/versions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_core_definitions()
    list_core_definitions(params::Dict{String,<:Any})

Retrieves a list of core definitions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to be returned per request.
- `"NextToken"`: The token for the next set of results, or ''null'' if there are no
  additional results.
"""
function list_core_definitions(; aws_config::AbstractAWSConfig=current_aws_config())
    return greengrass(
        "GET",
        "/greengrass/definition/cores";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_core_definitions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "GET",
        "/greengrass/definition/cores",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_deployments(group_id)
    list_deployments(group_id, params::Dict{String,<:Any})

Returns a history of deployments for the group.

# Arguments
- `group_id`: The ID of the Greengrass group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to be returned per request.
- `"NextToken"`: The token for the next set of results, or ''null'' if there are no
  additional results.
"""
function list_deployments(GroupId; aws_config::AbstractAWSConfig=current_aws_config())
    return greengrass(
        "GET",
        "/greengrass/groups/$(GroupId)/deployments";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_deployments(
    GroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "GET",
        "/greengrass/groups/$(GroupId)/deployments",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_device_definition_versions(device_definition_id)
    list_device_definition_versions(device_definition_id, params::Dict{String,<:Any})

Lists the versions of a device definition.

# Arguments
- `device_definition_id`: The ID of the device definition.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to be returned per request.
- `"NextToken"`: The token for the next set of results, or ''null'' if there are no
  additional results.
"""
function list_device_definition_versions(
    DeviceDefinitionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "GET",
        "/greengrass/definition/devices/$(DeviceDefinitionId)/versions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_device_definition_versions(
    DeviceDefinitionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "GET",
        "/greengrass/definition/devices/$(DeviceDefinitionId)/versions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_device_definitions()
    list_device_definitions(params::Dict{String,<:Any})

Retrieves a list of device definitions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to be returned per request.
- `"NextToken"`: The token for the next set of results, or ''null'' if there are no
  additional results.
"""
function list_device_definitions(; aws_config::AbstractAWSConfig=current_aws_config())
    return greengrass(
        "GET",
        "/greengrass/definition/devices";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_device_definitions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "GET",
        "/greengrass/definition/devices",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_function_definition_versions(function_definition_id)
    list_function_definition_versions(function_definition_id, params::Dict{String,<:Any})

Lists the versions of a Lambda function definition.

# Arguments
- `function_definition_id`: The ID of the Lambda function definition.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to be returned per request.
- `"NextToken"`: The token for the next set of results, or ''null'' if there are no
  additional results.
"""
function list_function_definition_versions(
    FunctionDefinitionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "GET",
        "/greengrass/definition/functions/$(FunctionDefinitionId)/versions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_function_definition_versions(
    FunctionDefinitionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "GET",
        "/greengrass/definition/functions/$(FunctionDefinitionId)/versions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_function_definitions()
    list_function_definitions(params::Dict{String,<:Any})

Retrieves a list of Lambda function definitions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to be returned per request.
- `"NextToken"`: The token for the next set of results, or ''null'' if there are no
  additional results.
"""
function list_function_definitions(; aws_config::AbstractAWSConfig=current_aws_config())
    return greengrass(
        "GET",
        "/greengrass/definition/functions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_function_definitions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "GET",
        "/greengrass/definition/functions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_group_certificate_authorities(group_id)
    list_group_certificate_authorities(group_id, params::Dict{String,<:Any})

Retrieves the current CAs for a group.

# Arguments
- `group_id`: The ID of the Greengrass group.

"""
function list_group_certificate_authorities(
    GroupId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "GET",
        "/greengrass/groups/$(GroupId)/certificateauthorities";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_group_certificate_authorities(
    GroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "GET",
        "/greengrass/groups/$(GroupId)/certificateauthorities",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_group_versions(group_id)
    list_group_versions(group_id, params::Dict{String,<:Any})

Lists the versions of a group.

# Arguments
- `group_id`: The ID of the Greengrass group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to be returned per request.
- `"NextToken"`: The token for the next set of results, or ''null'' if there are no
  additional results.
"""
function list_group_versions(GroupId; aws_config::AbstractAWSConfig=current_aws_config())
    return greengrass(
        "GET",
        "/greengrass/groups/$(GroupId)/versions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_group_versions(
    GroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "GET",
        "/greengrass/groups/$(GroupId)/versions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_groups()
    list_groups(params::Dict{String,<:Any})

Retrieves a list of groups.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to be returned per request.
- `"NextToken"`: The token for the next set of results, or ''null'' if there are no
  additional results.
"""
function list_groups(; aws_config::AbstractAWSConfig=current_aws_config())
    return greengrass(
        "GET", "/greengrass/groups"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_groups(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "GET",
        "/greengrass/groups",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_logger_definition_versions(logger_definition_id)
    list_logger_definition_versions(logger_definition_id, params::Dict{String,<:Any})

Lists the versions of a logger definition.

# Arguments
- `logger_definition_id`: The ID of the logger definition.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to be returned per request.
- `"NextToken"`: The token for the next set of results, or ''null'' if there are no
  additional results.
"""
function list_logger_definition_versions(
    LoggerDefinitionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "GET",
        "/greengrass/definition/loggers/$(LoggerDefinitionId)/versions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_logger_definition_versions(
    LoggerDefinitionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "GET",
        "/greengrass/definition/loggers/$(LoggerDefinitionId)/versions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_logger_definitions()
    list_logger_definitions(params::Dict{String,<:Any})

Retrieves a list of logger definitions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to be returned per request.
- `"NextToken"`: The token for the next set of results, or ''null'' if there are no
  additional results.
"""
function list_logger_definitions(; aws_config::AbstractAWSConfig=current_aws_config())
    return greengrass(
        "GET",
        "/greengrass/definition/loggers";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_logger_definitions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "GET",
        "/greengrass/definition/loggers",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_resource_definition_versions(resource_definition_id)
    list_resource_definition_versions(resource_definition_id, params::Dict{String,<:Any})

Lists the versions of a resource definition.

# Arguments
- `resource_definition_id`: The ID of the resource definition.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to be returned per request.
- `"NextToken"`: The token for the next set of results, or ''null'' if there are no
  additional results.
"""
function list_resource_definition_versions(
    ResourceDefinitionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "GET",
        "/greengrass/definition/resources/$(ResourceDefinitionId)/versions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_resource_definition_versions(
    ResourceDefinitionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "GET",
        "/greengrass/definition/resources/$(ResourceDefinitionId)/versions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_resource_definitions()
    list_resource_definitions(params::Dict{String,<:Any})

Retrieves a list of resource definitions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to be returned per request.
- `"NextToken"`: The token for the next set of results, or ''null'' if there are no
  additional results.
"""
function list_resource_definitions(; aws_config::AbstractAWSConfig=current_aws_config())
    return greengrass(
        "GET",
        "/greengrass/definition/resources";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_resource_definitions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "GET",
        "/greengrass/definition/resources",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_subscription_definition_versions(subscription_definition_id)
    list_subscription_definition_versions(subscription_definition_id, params::Dict{String,<:Any})

Lists the versions of a subscription definition.

# Arguments
- `subscription_definition_id`: The ID of the subscription definition.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to be returned per request.
- `"NextToken"`: The token for the next set of results, or ''null'' if there are no
  additional results.
"""
function list_subscription_definition_versions(
    SubscriptionDefinitionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "GET",
        "/greengrass/definition/subscriptions/$(SubscriptionDefinitionId)/versions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_subscription_definition_versions(
    SubscriptionDefinitionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "GET",
        "/greengrass/definition/subscriptions/$(SubscriptionDefinitionId)/versions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_subscription_definitions()
    list_subscription_definitions(params::Dict{String,<:Any})

Retrieves a list of subscription definitions.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"MaxResults"`: The maximum number of results to be returned per request.
- `"NextToken"`: The token for the next set of results, or ''null'' if there are no
  additional results.
"""
function list_subscription_definitions(; aws_config::AbstractAWSConfig=current_aws_config())
    return greengrass(
        "GET",
        "/greengrass/definition/subscriptions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_subscription_definitions(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "GET",
        "/greengrass/definition/subscriptions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource-arn)
    list_tags_for_resource(resource-arn, params::Dict{String,<:Any})

Retrieves a list of resource tags for a resource arn.

# Arguments
- `resource-arn`: The Amazon Resource Name (ARN) of the resource.

"""
function list_tags_for_resource(
    resource_arn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "GET",
        "/tags/$(resource-arn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resource_arn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "GET",
        "/tags/$(resource-arn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    reset_deployments(group_id)
    reset_deployments(group_id, params::Dict{String,<:Any})

Resets a group's deployments.

# Arguments
- `group_id`: The ID of the Greengrass group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Force"`: If true, performs a best-effort only core reset.
- `"X-Amzn-Client-Token"`: A client token used to correlate requests and responses.
"""
function reset_deployments(GroupId; aws_config::AbstractAWSConfig=current_aws_config())
    return greengrass(
        "POST",
        "/greengrass/groups/$(GroupId)/deployments/$reset";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function reset_deployments(
    GroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "POST",
        "/greengrass/groups/$(GroupId)/deployments/$reset",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_bulk_deployment(execution_role_arn, input_file_uri)
    start_bulk_deployment(execution_role_arn, input_file_uri, params::Dict{String,<:Any})

Deploys multiple groups in one operation. This action starts the bulk deployment of a
specified set of group versions. Each group version deployment will be triggered with an
adaptive rate that has a fixed upper limit. We recommend that you include an
''X-Amzn-Client-Token'' token in every ''StartBulkDeployment'' request. These requests are
idempotent with respect to the token and the request parameters.

# Arguments
- `execution_role_arn`: The ARN of the execution role to associate with the bulk deployment
  operation. This IAM role must allow the ''greengrass:CreateDeployment'' action for all
  group versions that are listed in the input file. This IAM role must have access to the S3
  bucket containing the input file.
- `input_file_uri`: The URI of the input file contained in the S3 bucket. The execution
  role must have ''getObject'' permissions on this bucket to access the input file. The input
  file is a JSON-serialized, line delimited file with UTF-8 encoding that provides a list of
  group and version IDs and the deployment type. This file must be less than 100 MB.
  Currently, AWS IoT Greengrass supports only ''NewDeployment'' deployment types.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"X-Amzn-Client-Token"`: A client token used to correlate requests and responses.
- `"tags"`: Tag(s) to add to the new resource.
"""
function start_bulk_deployment(
    ExecutionRoleArn, InputFileUri; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "POST",
        "/greengrass/bulk/deployments",
        Dict{String,Any}(
            "ExecutionRoleArn" => ExecutionRoleArn, "InputFileUri" => InputFileUri
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_bulk_deployment(
    ExecutionRoleArn,
    InputFileUri,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "POST",
        "/greengrass/bulk/deployments",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ExecutionRoleArn" => ExecutionRoleArn, "InputFileUri" => InputFileUri
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_bulk_deployment(bulk_deployment_id)
    stop_bulk_deployment(bulk_deployment_id, params::Dict{String,<:Any})

Stops the execution of a bulk deployment. This action returns a status of ''Stopping''
until the deployment is stopped. You cannot start a new bulk deployment while a previous
deployment is in the ''Stopping'' state. This action doesn't rollback completed deployments
or cancel pending deployments.

# Arguments
- `bulk_deployment_id`: The ID of the bulk deployment.

"""
function stop_bulk_deployment(
    BulkDeploymentId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "PUT",
        "/greengrass/bulk/deployments/$(BulkDeploymentId)/$stop";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_bulk_deployment(
    BulkDeploymentId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "PUT",
        "/greengrass/bulk/deployments/$(BulkDeploymentId)/$stop",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource-arn)
    tag_resource(resource-arn, params::Dict{String,<:Any})

Adds tags to a Greengrass resource. Valid resources are 'Group', 'ConnectorDefinition',
'CoreDefinition', 'DeviceDefinition', 'FunctionDefinition', 'LoggerDefinition',
'SubscriptionDefinition', 'ResourceDefinition', and 'BulkDeployment'.

# Arguments
- `resource-arn`: The Amazon Resource Name (ARN) of the resource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tags"`:
"""
function tag_resource(resource_arn; aws_config::AbstractAWSConfig=current_aws_config())
    return greengrass(
        "POST",
        "/tags/$(resource-arn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resource_arn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "POST",
        "/tags/$(resource-arn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource-arn, tag_keys)
    untag_resource(resource-arn, tag_keys, params::Dict{String,<:Any})

Remove resource tags from a Greengrass Resource.

# Arguments
- `resource-arn`: The Amazon Resource Name (ARN) of the resource.
- `tag_keys`: An array of tag keys to delete

"""
function untag_resource(
    resource_arn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "DELETE",
        "/tags/$(resource-arn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resource_arn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "DELETE",
        "/tags/$(resource-arn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_connectivity_info(thing_name)
    update_connectivity_info(thing_name, params::Dict{String,<:Any})

Updates the connectivity information for the core. Any devices that belong to the group
which has this core will receive this information in order to find the location of the core
and connect to it.

# Arguments
- `thing_name`: The thing name.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"ConnectivityInfo"`: A list of connectivity info.
"""
function update_connectivity_info(
    ThingName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "PUT",
        "/greengrass/things/$(ThingName)/connectivityInfo";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_connectivity_info(
    ThingName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "PUT",
        "/greengrass/things/$(ThingName)/connectivityInfo",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_connector_definition(connector_definition_id)
    update_connector_definition(connector_definition_id, params::Dict{String,<:Any})

Updates a connector definition.

# Arguments
- `connector_definition_id`: The ID of the connector definition.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Name"`: The name of the definition.
"""
function update_connector_definition(
    ConnectorDefinitionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "PUT",
        "/greengrass/definition/connectors/$(ConnectorDefinitionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_connector_definition(
    ConnectorDefinitionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "PUT",
        "/greengrass/definition/connectors/$(ConnectorDefinitionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_core_definition(core_definition_id)
    update_core_definition(core_definition_id, params::Dict{String,<:Any})

Updates a core definition.

# Arguments
- `core_definition_id`: The ID of the core definition.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Name"`: The name of the definition.
"""
function update_core_definition(
    CoreDefinitionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "PUT",
        "/greengrass/definition/cores/$(CoreDefinitionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_core_definition(
    CoreDefinitionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "PUT",
        "/greengrass/definition/cores/$(CoreDefinitionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_device_definition(device_definition_id)
    update_device_definition(device_definition_id, params::Dict{String,<:Any})

Updates a device definition.

# Arguments
- `device_definition_id`: The ID of the device definition.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Name"`: The name of the definition.
"""
function update_device_definition(
    DeviceDefinitionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "PUT",
        "/greengrass/definition/devices/$(DeviceDefinitionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_device_definition(
    DeviceDefinitionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "PUT",
        "/greengrass/definition/devices/$(DeviceDefinitionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_function_definition(function_definition_id)
    update_function_definition(function_definition_id, params::Dict{String,<:Any})

Updates a Lambda function definition.

# Arguments
- `function_definition_id`: The ID of the Lambda function definition.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Name"`: The name of the definition.
"""
function update_function_definition(
    FunctionDefinitionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "PUT",
        "/greengrass/definition/functions/$(FunctionDefinitionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_function_definition(
    FunctionDefinitionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "PUT",
        "/greengrass/definition/functions/$(FunctionDefinitionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_group(group_id)
    update_group(group_id, params::Dict{String,<:Any})

Updates a group.

# Arguments
- `group_id`: The ID of the Greengrass group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Name"`: The name of the definition.
"""
function update_group(GroupId; aws_config::AbstractAWSConfig=current_aws_config())
    return greengrass(
        "PUT",
        "/greengrass/groups/$(GroupId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_group(
    GroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "PUT",
        "/greengrass/groups/$(GroupId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_group_certificate_configuration(group_id)
    update_group_certificate_configuration(group_id, params::Dict{String,<:Any})

Updates the Certificate expiry time for a group.

# Arguments
- `group_id`: The ID of the Greengrass group.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CertificateExpiryInMilliseconds"`: The amount of time remaining before the certificate
  expires, in milliseconds.
"""
function update_group_certificate_configuration(
    GroupId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "PUT",
        "/greengrass/groups/$(GroupId)/certificateauthorities/configuration/expiry";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_group_certificate_configuration(
    GroupId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "PUT",
        "/greengrass/groups/$(GroupId)/certificateauthorities/configuration/expiry",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_logger_definition(logger_definition_id)
    update_logger_definition(logger_definition_id, params::Dict{String,<:Any})

Updates a logger definition.

# Arguments
- `logger_definition_id`: The ID of the logger definition.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Name"`: The name of the definition.
"""
function update_logger_definition(
    LoggerDefinitionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "PUT",
        "/greengrass/definition/loggers/$(LoggerDefinitionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_logger_definition(
    LoggerDefinitionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "PUT",
        "/greengrass/definition/loggers/$(LoggerDefinitionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_resource_definition(resource_definition_id)
    update_resource_definition(resource_definition_id, params::Dict{String,<:Any})

Updates a resource definition.

# Arguments
- `resource_definition_id`: The ID of the resource definition.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Name"`: The name of the definition.
"""
function update_resource_definition(
    ResourceDefinitionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "PUT",
        "/greengrass/definition/resources/$(ResourceDefinitionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_resource_definition(
    ResourceDefinitionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "PUT",
        "/greengrass/definition/resources/$(ResourceDefinitionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_subscription_definition(subscription_definition_id)
    update_subscription_definition(subscription_definition_id, params::Dict{String,<:Any})

Updates a subscription definition.

# Arguments
- `subscription_definition_id`: The ID of the subscription definition.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Name"`: The name of the definition.
"""
function update_subscription_definition(
    SubscriptionDefinitionId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "PUT",
        "/greengrass/definition/subscriptions/$(SubscriptionDefinitionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_subscription_definition(
    SubscriptionDefinitionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "PUT",
        "/greengrass/definition/subscriptions/$(SubscriptionDefinitionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_thing_runtime_configuration(thing_name)
    update_thing_runtime_configuration(thing_name, params::Dict{String,<:Any})

Updates the runtime configuration of a thing.

# Arguments
- `thing_name`: The thing name.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"TelemetryConfiguration"`: Configuration for telemetry service.
"""
function update_thing_runtime_configuration(
    ThingName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return greengrass(
        "PUT",
        "/greengrass/things/$(ThingName)/runtimeconfig";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_thing_runtime_configuration(
    ThingName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return greengrass(
        "PUT",
        "/greengrass/things/$(ThingName)/runtimeconfig",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: nimble
using AWS.Compat
using AWS.UUIDs

"""
    accept_eulas(studio_id)
    accept_eulas(studio_id, params::Dict{String,<:Any})

Accept EULAs.

# Arguments
- `studio_id`: The studio ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"X-Amz-Client-Token"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If you don’t specify a client token, the Amazon Web Services
  SDK automatically generates a client token and uses it for the request to ensure
  idempotency.
- `"eulaIds"`: The EULA ID.
"""
function accept_eulas(studioId; aws_config::AbstractAWSConfig=current_aws_config())
    return nimble(
        "POST",
        "/2020-08-01/studios/$(studioId)/eula-acceptances",
        Dict{String,Any}("X-Amz-Client-Token" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function accept_eulas(
    studioId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return nimble(
        "POST",
        "/2020-08-01/studios/$(studioId)/eula-acceptances",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("X-Amz-Client-Token" => string(uuid4())), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_launch_profile(ec2_subnet_ids, launch_profile_protocol_versions, name, stream_configuration, studio_component_ids, studio_id)
    create_launch_profile(ec2_subnet_ids, launch_profile_protocol_versions, name, stream_configuration, studio_component_ids, studio_id, params::Dict{String,<:Any})

Create a launch profile.

# Arguments
- `ec2_subnet_ids`: Specifies the IDs of the EC2 subnets where streaming sessions will be
  accessible from. These subnets must support the specified instance types.
- `launch_profile_protocol_versions`: The version number of the protocol that is used by
  the launch profile. The only valid version is \"2021-03-31\".
- `name`: The name for the launch profile.
- `stream_configuration`: A configuration for a streaming session.
- `studio_component_ids`: Unique identifiers for a collection of studio components that can
  be used with this launch profile.
- `studio_id`: The studio ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"X-Amz-Client-Token"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If you don’t specify a client token, the Amazon Web Services
  SDK automatically generates a client token and uses it for the request to ensure
  idempotency.
- `"description"`: The description.
- `"tags"`: A collection of labels, in the form of key-value pairs, that apply to this
  resource.
"""
function create_launch_profile(
    ec2SubnetIds,
    launchProfileProtocolVersions,
    name,
    streamConfiguration,
    studioComponentIds,
    studioId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return nimble(
        "POST",
        "/2020-08-01/studios/$(studioId)/launch-profiles",
        Dict{String,Any}(
            "ec2SubnetIds" => ec2SubnetIds,
            "launchProfileProtocolVersions" => launchProfileProtocolVersions,
            "name" => name,
            "streamConfiguration" => streamConfiguration,
            "studioComponentIds" => studioComponentIds,
            "X-Amz-Client-Token" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_launch_profile(
    ec2SubnetIds,
    launchProfileProtocolVersions,
    name,
    streamConfiguration,
    studioComponentIds,
    studioId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return nimble(
        "POST",
        "/2020-08-01/studios/$(studioId)/launch-profiles",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ec2SubnetIds" => ec2SubnetIds,
                    "launchProfileProtocolVersions" => launchProfileProtocolVersions,
                    "name" => name,
                    "streamConfiguration" => streamConfiguration,
                    "studioComponentIds" => studioComponentIds,
                    "X-Amz-Client-Token" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_streaming_image(ec2_image_id, name, studio_id)
    create_streaming_image(ec2_image_id, name, studio_id, params::Dict{String,<:Any})

Creates a streaming image resource in a studio.

# Arguments
- `ec2_image_id`: The ID of an EC2 machine image with which to create this streaming image.
- `name`: A friendly name for a streaming image resource.
- `studio_id`: The studio ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"X-Amz-Client-Token"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If you don’t specify a client token, the Amazon Web Services
  SDK automatically generates a client token and uses it for the request to ensure
  idempotency.
- `"description"`: A human-readable description of the streaming image.
- `"tags"`: A collection of labels, in the form of key-value pairs, that apply to this
  resource.
"""
function create_streaming_image(
    ec2ImageId, name, studioId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return nimble(
        "POST",
        "/2020-08-01/studios/$(studioId)/streaming-images",
        Dict{String,Any}(
            "ec2ImageId" => ec2ImageId,
            "name" => name,
            "X-Amz-Client-Token" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_streaming_image(
    ec2ImageId,
    name,
    studioId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return nimble(
        "POST",
        "/2020-08-01/studios/$(studioId)/streaming-images",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "ec2ImageId" => ec2ImageId,
                    "name" => name,
                    "X-Amz-Client-Token" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_streaming_session(launch_profile_id, studio_id)
    create_streaming_session(launch_profile_id, studio_id, params::Dict{String,<:Any})

Creates a streaming session in a studio. After invoking this operation, you must poll
GetStreamingSession until the streaming session is in the READY state.

# Arguments
- `launch_profile_id`: The ID of the launch profile used to control access from the
  streaming session.
- `studio_id`: The studio ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"X-Amz-Client-Token"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If you don’t specify a client token, the Amazon Web Services
  SDK automatically generates a client token and uses it for the request to ensure
  idempotency.
- `"ec2InstanceType"`: The EC2 Instance type used for the streaming session.
- `"ownedBy"`: The user ID of the user that owns the streaming session. The user that owns
  the session will be logging into the session and interacting with the virtual workstation.
- `"streamingImageId"`: The ID of the streaming image.
- `"tags"`: A collection of labels, in the form of key-value pairs, that apply to this
  resource.
"""
function create_streaming_session(
    launchProfileId, studioId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return nimble(
        "POST",
        "/2020-08-01/studios/$(studioId)/streaming-sessions",
        Dict{String,Any}(
            "launchProfileId" => launchProfileId, "X-Amz-Client-Token" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_streaming_session(
    launchProfileId,
    studioId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return nimble(
        "POST",
        "/2020-08-01/studios/$(studioId)/streaming-sessions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "launchProfileId" => launchProfileId,
                    "X-Amz-Client-Token" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_streaming_session_stream(session_id, studio_id)
    create_streaming_session_stream(session_id, studio_id, params::Dict{String,<:Any})

Creates a streaming session stream for a streaming session. After invoking this API, invoke
GetStreamingSessionStream with the returned streamId to poll the resource until it is in
the READY state.

# Arguments
- `session_id`: The streaming session ID.
- `studio_id`: The studio ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"X-Amz-Client-Token"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If you don’t specify a client token, the Amazon Web Services
  SDK automatically generates a client token and uses it for the request to ensure
  idempotency.
- `"expirationInSeconds"`: The expiration time in seconds.
"""
function create_streaming_session_stream(
    sessionId, studioId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return nimble(
        "POST",
        "/2020-08-01/studios/$(studioId)/streaming-sessions/$(sessionId)/streams",
        Dict{String,Any}("X-Amz-Client-Token" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_streaming_session_stream(
    sessionId,
    studioId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return nimble(
        "POST",
        "/2020-08-01/studios/$(studioId)/streaming-sessions/$(sessionId)/streams",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("X-Amz-Client-Token" => string(uuid4())), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_studio(admin_role_arn, display_name, studio_name, user_role_arn)
    create_studio(admin_role_arn, display_name, studio_name, user_role_arn, params::Dict{String,<:Any})

Create a new studio. When creating a studio, two IAM roles must be provided: the admin role
and the user role. These roles are assumed by your users when they log in to the Nimble
Studio portal. The user role must have the AmazonNimbleStudio-StudioUser managed policy
attached for the portal to function properly. The admin role must have the
AmazonNimbleStudio-StudioAdmin managed policy attached for the portal to function properly.
You may optionally specify a KMS key in the StudioEncryptionConfiguration. In Nimble
Studio, resource names, descriptions, initialization scripts, and other data you provide
are always encrypted at rest using an KMS key. By default, this key is owned by Amazon Web
Services and managed on your behalf. You may provide your own KMS key when calling
CreateStudio to encrypt this data using a key you own and manage. When providing an KMS key
during studio creation, Nimble Studio creates KMS grants in your account to provide your
studio user and admin roles access to these KMS keys. If you delete this grant, the studio
will no longer be accessible to your portal users. If you delete the studio KMS key, your
studio will no longer be accessible.

# Arguments
- `admin_role_arn`: The IAM role that studio admins will assume when logging in to the
  Nimble Studio portal.
- `display_name`: A friendly name for the studio.
- `studio_name`: The studio name that is used in the URL of the Nimble Studio portal when
  accessed by Nimble Studio users.
- `user_role_arn`: The IAM role that studio users will assume when logging in to the Nimble
  Studio portal.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"X-Amz-Client-Token"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If you don’t specify a client token, the Amazon Web Services
  SDK automatically generates a client token and uses it for the request to ensure
  idempotency.
- `"studioEncryptionConfiguration"`: The studio encryption configuration.
- `"tags"`: A collection of labels, in the form of key-value pairs, that apply to this
  resource.
"""
function create_studio(
    adminRoleArn,
    displayName,
    studioName,
    userRoleArn;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return nimble(
        "POST",
        "/2020-08-01/studios",
        Dict{String,Any}(
            "adminRoleArn" => adminRoleArn,
            "displayName" => displayName,
            "studioName" => studioName,
            "userRoleArn" => userRoleArn,
            "X-Amz-Client-Token" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_studio(
    adminRoleArn,
    displayName,
    studioName,
    userRoleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return nimble(
        "POST",
        "/2020-08-01/studios",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "adminRoleArn" => adminRoleArn,
                    "displayName" => displayName,
                    "studioName" => studioName,
                    "userRoleArn" => userRoleArn,
                    "X-Amz-Client-Token" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_studio_component(name, studio_id, type)
    create_studio_component(name, studio_id, type, params::Dict{String,<:Any})

Creates a studio component resource.

# Arguments
- `name`: The name for the studio component.
- `studio_id`: The studio ID.
- `type`: The type of the studio component.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"X-Amz-Client-Token"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If you don’t specify a client token, the Amazon Web Services
  SDK automatically generates a client token and uses it for the request to ensure
  idempotency.
- `"configuration"`: The configuration of the studio component, based on component type.
- `"description"`: The description.
- `"ec2SecurityGroupIds"`: The EC2 security groups that control access to the studio
  component.
- `"initializationScripts"`: Initialization scripts for studio components.
- `"runtimeRoleArn"`: An IAM role attached to a Studio Component that gives the studio
  component access to Amazon Web Services resources at anytime while the instance is running.
- `"scriptParameters"`: Parameters for the studio component scripts.
- `"secureInitializationRoleArn"`: An IAM role attached to Studio Component when the system
  initialization script runs which give the studio component access to Amazon Web Services
  resources when the system initialization script runs.
- `"subtype"`: The specific subtype of a studio component.
- `"tags"`: A collection of labels, in the form of key-value pairs, that apply to this
  resource.
"""
function create_studio_component(
    name, studioId, type; aws_config::AbstractAWSConfig=current_aws_config()
)
    return nimble(
        "POST",
        "/2020-08-01/studios/$(studioId)/studio-components",
        Dict{String,Any}(
            "name" => name, "type" => type, "X-Amz-Client-Token" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_studio_component(
    name,
    studioId,
    type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return nimble(
        "POST",
        "/2020-08-01/studios/$(studioId)/studio-components",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "name" => name, "type" => type, "X-Amz-Client-Token" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_launch_profile(launch_profile_id, studio_id)
    delete_launch_profile(launch_profile_id, studio_id, params::Dict{String,<:Any})

Permanently delete a launch profile.

# Arguments
- `launch_profile_id`: The ID of the launch profile used to control access from the
  streaming session.
- `studio_id`: The studio ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"X-Amz-Client-Token"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If you don’t specify a client token, the Amazon Web Services
  SDK automatically generates a client token and uses it for the request to ensure
  idempotency.
"""
function delete_launch_profile(
    launchProfileId, studioId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return nimble(
        "DELETE",
        "/2020-08-01/studios/$(studioId)/launch-profiles/$(launchProfileId)",
        Dict{String,Any}("X-Amz-Client-Token" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_launch_profile(
    launchProfileId,
    studioId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return nimble(
        "DELETE",
        "/2020-08-01/studios/$(studioId)/launch-profiles/$(launchProfileId)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("X-Amz-Client-Token" => string(uuid4())), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_launch_profile_member(launch_profile_id, principal_id, studio_id)
    delete_launch_profile_member(launch_profile_id, principal_id, studio_id, params::Dict{String,<:Any})

Delete a user from launch profile membership.

# Arguments
- `launch_profile_id`: The ID of the launch profile used to control access from the
  streaming session.
- `principal_id`: The principal ID. This currently supports a IAM Identity Center UserId.
- `studio_id`: The studio ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"X-Amz-Client-Token"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If you don’t specify a client token, the Amazon Web Services
  SDK automatically generates a client token and uses it for the request to ensure
  idempotency.
"""
function delete_launch_profile_member(
    launchProfileId,
    principalId,
    studioId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return nimble(
        "DELETE",
        "/2020-08-01/studios/$(studioId)/launch-profiles/$(launchProfileId)/membership/$(principalId)",
        Dict{String,Any}("X-Amz-Client-Token" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_launch_profile_member(
    launchProfileId,
    principalId,
    studioId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return nimble(
        "DELETE",
        "/2020-08-01/studios/$(studioId)/launch-profiles/$(launchProfileId)/membership/$(principalId)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("X-Amz-Client-Token" => string(uuid4())), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_streaming_image(streaming_image_id, studio_id)
    delete_streaming_image(streaming_image_id, studio_id, params::Dict{String,<:Any})

Delete streaming image.

# Arguments
- `streaming_image_id`: The streaming image ID.
- `studio_id`: The studio ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"X-Amz-Client-Token"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If you don’t specify a client token, the Amazon Web Services
  SDK automatically generates a client token and uses it for the request to ensure
  idempotency.
"""
function delete_streaming_image(
    streamingImageId, studioId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return nimble(
        "DELETE",
        "/2020-08-01/studios/$(studioId)/streaming-images/$(streamingImageId)",
        Dict{String,Any}("X-Amz-Client-Token" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_streaming_image(
    streamingImageId,
    studioId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return nimble(
        "DELETE",
        "/2020-08-01/studios/$(studioId)/streaming-images/$(streamingImageId)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("X-Amz-Client-Token" => string(uuid4())), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_streaming_session(session_id, studio_id)
    delete_streaming_session(session_id, studio_id, params::Dict{String,<:Any})

Deletes streaming session resource. After invoking this operation, use GetStreamingSession
to poll the resource until it transitions to a DELETED state. A streaming session will
count against your streaming session quota until it is marked DELETED.

# Arguments
- `session_id`: The streaming session ID.
- `studio_id`: The studio ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"X-Amz-Client-Token"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If you don’t specify a client token, the Amazon Web Services
  SDK automatically generates a client token and uses it for the request to ensure
  idempotency.
"""
function delete_streaming_session(
    sessionId, studioId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return nimble(
        "DELETE",
        "/2020-08-01/studios/$(studioId)/streaming-sessions/$(sessionId)",
        Dict{String,Any}("X-Amz-Client-Token" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_streaming_session(
    sessionId,
    studioId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return nimble(
        "DELETE",
        "/2020-08-01/studios/$(studioId)/streaming-sessions/$(sessionId)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("X-Amz-Client-Token" => string(uuid4())), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_studio(studio_id)
    delete_studio(studio_id, params::Dict{String,<:Any})

Delete a studio resource.

# Arguments
- `studio_id`: The studio ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"X-Amz-Client-Token"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If you don’t specify a client token, the Amazon Web Services
  SDK automatically generates a client token and uses it for the request to ensure
  idempotency.
"""
function delete_studio(studioId; aws_config::AbstractAWSConfig=current_aws_config())
    return nimble(
        "DELETE",
        "/2020-08-01/studios/$(studioId)",
        Dict{String,Any}("X-Amz-Client-Token" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_studio(
    studioId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return nimble(
        "DELETE",
        "/2020-08-01/studios/$(studioId)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("X-Amz-Client-Token" => string(uuid4())), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_studio_component(studio_component_id, studio_id)
    delete_studio_component(studio_component_id, studio_id, params::Dict{String,<:Any})

Deletes a studio component resource.

# Arguments
- `studio_component_id`: The studio component ID.
- `studio_id`: The studio ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"X-Amz-Client-Token"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If you don’t specify a client token, the Amazon Web Services
  SDK automatically generates a client token and uses it for the request to ensure
  idempotency.
"""
function delete_studio_component(
    studioComponentId, studioId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return nimble(
        "DELETE",
        "/2020-08-01/studios/$(studioId)/studio-components/$(studioComponentId)",
        Dict{String,Any}("X-Amz-Client-Token" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_studio_component(
    studioComponentId,
    studioId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return nimble(
        "DELETE",
        "/2020-08-01/studios/$(studioId)/studio-components/$(studioComponentId)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("X-Amz-Client-Token" => string(uuid4())), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_studio_member(principal_id, studio_id)
    delete_studio_member(principal_id, studio_id, params::Dict{String,<:Any})

Delete a user from studio membership.

# Arguments
- `principal_id`: The principal ID. This currently supports a IAM Identity Center UserId.
- `studio_id`: The studio ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"X-Amz-Client-Token"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If you don’t specify a client token, the Amazon Web Services
  SDK automatically generates a client token and uses it for the request to ensure
  idempotency.
"""
function delete_studio_member(
    principalId, studioId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return nimble(
        "DELETE",
        "/2020-08-01/studios/$(studioId)/membership/$(principalId)",
        Dict{String,Any}("X-Amz-Client-Token" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_studio_member(
    principalId,
    studioId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return nimble(
        "DELETE",
        "/2020-08-01/studios/$(studioId)/membership/$(principalId)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("X-Amz-Client-Token" => string(uuid4())), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_eula(eula_id)
    get_eula(eula_id, params::Dict{String,<:Any})

Get EULA.

# Arguments
- `eula_id`: The EULA ID.

"""
function get_eula(eulaId; aws_config::AbstractAWSConfig=current_aws_config())
    return nimble(
        "GET",
        "/2020-08-01/eulas/$(eulaId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_eula(
    eulaId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return nimble(
        "GET",
        "/2020-08-01/eulas/$(eulaId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_launch_profile(launch_profile_id, studio_id)
    get_launch_profile(launch_profile_id, studio_id, params::Dict{String,<:Any})

Get a launch profile.

# Arguments
- `launch_profile_id`: The ID of the launch profile used to control access from the
  streaming session.
- `studio_id`: The studio ID.

"""
function get_launch_profile(
    launchProfileId, studioId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return nimble(
        "GET",
        "/2020-08-01/studios/$(studioId)/launch-profiles/$(launchProfileId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_launch_profile(
    launchProfileId,
    studioId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return nimble(
        "GET",
        "/2020-08-01/studios/$(studioId)/launch-profiles/$(launchProfileId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_launch_profile_details(launch_profile_id, studio_id)
    get_launch_profile_details(launch_profile_id, studio_id, params::Dict{String,<:Any})

Launch profile details include the launch profile resource and summary information of
resources that are used by, or available to, the launch profile. This includes the name and
description of all studio components used by the launch profiles, and the name and
description of streaming images that can be used with this launch profile.

# Arguments
- `launch_profile_id`: The ID of the launch profile used to control access from the
  streaming session.
- `studio_id`: The studio ID.

"""
function get_launch_profile_details(
    launchProfileId, studioId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return nimble(
        "GET",
        "/2020-08-01/studios/$(studioId)/launch-profiles/$(launchProfileId)/details";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_launch_profile_details(
    launchProfileId,
    studioId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return nimble(
        "GET",
        "/2020-08-01/studios/$(studioId)/launch-profiles/$(launchProfileId)/details",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_launch_profile_initialization(launch_profile_id, launch_profile_protocol_versions, launch_purpose, platform, studio_id)
    get_launch_profile_initialization(launch_profile_id, launch_profile_protocol_versions, launch_purpose, platform, studio_id, params::Dict{String,<:Any})

Get a launch profile initialization.

# Arguments
- `launch_profile_id`: The ID of the launch profile used to control access from the
  streaming session.
- `launch_profile_protocol_versions`: The launch profile protocol versions supported by the
  client.
- `launch_purpose`: The launch purpose.
- `platform`: The platform where this Launch Profile will be used, either Windows or Linux.
- `studio_id`: The studio ID.

"""
function get_launch_profile_initialization(
    launchProfileId,
    launchProfileProtocolVersions,
    launchPurpose,
    platform,
    studioId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return nimble(
        "GET",
        "/2020-08-01/studios/$(studioId)/launch-profiles/$(launchProfileId)/init",
        Dict{String,Any}(
            "launchProfileProtocolVersions" => launchProfileProtocolVersions,
            "launchPurpose" => launchPurpose,
            "platform" => platform,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_launch_profile_initialization(
    launchProfileId,
    launchProfileProtocolVersions,
    launchPurpose,
    platform,
    studioId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return nimble(
        "GET",
        "/2020-08-01/studios/$(studioId)/launch-profiles/$(launchProfileId)/init",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "launchProfileProtocolVersions" => launchProfileProtocolVersions,
                    "launchPurpose" => launchPurpose,
                    "platform" => platform,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_launch_profile_member(launch_profile_id, principal_id, studio_id)
    get_launch_profile_member(launch_profile_id, principal_id, studio_id, params::Dict{String,<:Any})

Get a user persona in launch profile membership.

# Arguments
- `launch_profile_id`: The ID of the launch profile used to control access from the
  streaming session.
- `principal_id`: The principal ID. This currently supports a IAM Identity Center UserId.
- `studio_id`: The studio ID.

"""
function get_launch_profile_member(
    launchProfileId,
    principalId,
    studioId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return nimble(
        "GET",
        "/2020-08-01/studios/$(studioId)/launch-profiles/$(launchProfileId)/membership/$(principalId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_launch_profile_member(
    launchProfileId,
    principalId,
    studioId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return nimble(
        "GET",
        "/2020-08-01/studios/$(studioId)/launch-profiles/$(launchProfileId)/membership/$(principalId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_streaming_image(streaming_image_id, studio_id)
    get_streaming_image(streaming_image_id, studio_id, params::Dict{String,<:Any})

Get streaming image.

# Arguments
- `streaming_image_id`: The streaming image ID.
- `studio_id`: The studio ID.

"""
function get_streaming_image(
    streamingImageId, studioId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return nimble(
        "GET",
        "/2020-08-01/studios/$(studioId)/streaming-images/$(streamingImageId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_streaming_image(
    streamingImageId,
    studioId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return nimble(
        "GET",
        "/2020-08-01/studios/$(studioId)/streaming-images/$(streamingImageId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_streaming_session(session_id, studio_id)
    get_streaming_session(session_id, studio_id, params::Dict{String,<:Any})

Gets StreamingSession resource. Invoke this operation to poll for a streaming session state
while creating or deleting a session.

# Arguments
- `session_id`: The streaming session ID.
- `studio_id`: The studio ID.

"""
function get_streaming_session(
    sessionId, studioId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return nimble(
        "GET",
        "/2020-08-01/studios/$(studioId)/streaming-sessions/$(sessionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_streaming_session(
    sessionId,
    studioId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return nimble(
        "GET",
        "/2020-08-01/studios/$(studioId)/streaming-sessions/$(sessionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_streaming_session_backup(backup_id, studio_id)
    get_streaming_session_backup(backup_id, studio_id, params::Dict{String,<:Any})

Gets StreamingSessionBackup resource. Invoke this operation to poll for a streaming session
backup while stopping a streaming session.

# Arguments
- `backup_id`: The ID of the backup.
- `studio_id`: The studio ID.

"""
function get_streaming_session_backup(
    backupId, studioId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return nimble(
        "GET",
        "/2020-08-01/studios/$(studioId)/streaming-session-backups/$(backupId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_streaming_session_backup(
    backupId,
    studioId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return nimble(
        "GET",
        "/2020-08-01/studios/$(studioId)/streaming-session-backups/$(backupId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_streaming_session_stream(session_id, stream_id, studio_id)
    get_streaming_session_stream(session_id, stream_id, studio_id, params::Dict{String,<:Any})

Gets a StreamingSessionStream for a streaming session. Invoke this operation to poll the
resource after invoking CreateStreamingSessionStream. After the StreamingSessionStream
changes to the READY state, the url property will contain a stream to be used with the DCV
streaming client.

# Arguments
- `session_id`: The streaming session ID.
- `stream_id`: The streaming session stream ID.
- `studio_id`: The studio ID.

"""
function get_streaming_session_stream(
    sessionId, streamId, studioId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return nimble(
        "GET",
        "/2020-08-01/studios/$(studioId)/streaming-sessions/$(sessionId)/streams/$(streamId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_streaming_session_stream(
    sessionId,
    streamId,
    studioId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return nimble(
        "GET",
        "/2020-08-01/studios/$(studioId)/streaming-sessions/$(sessionId)/streams/$(streamId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_studio(studio_id)
    get_studio(studio_id, params::Dict{String,<:Any})

Get a studio resource.

# Arguments
- `studio_id`: The studio ID.

"""
function get_studio(studioId; aws_config::AbstractAWSConfig=current_aws_config())
    return nimble(
        "GET",
        "/2020-08-01/studios/$(studioId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_studio(
    studioId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return nimble(
        "GET",
        "/2020-08-01/studios/$(studioId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_studio_component(studio_component_id, studio_id)
    get_studio_component(studio_component_id, studio_id, params::Dict{String,<:Any})

Gets a studio component resource.

# Arguments
- `studio_component_id`: The studio component ID.
- `studio_id`: The studio ID.

"""
function get_studio_component(
    studioComponentId, studioId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return nimble(
        "GET",
        "/2020-08-01/studios/$(studioId)/studio-components/$(studioComponentId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_studio_component(
    studioComponentId,
    studioId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return nimble(
        "GET",
        "/2020-08-01/studios/$(studioId)/studio-components/$(studioComponentId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_studio_member(principal_id, studio_id)
    get_studio_member(principal_id, studio_id, params::Dict{String,<:Any})

Get a user's membership in a studio.

# Arguments
- `principal_id`: The principal ID. This currently supports a IAM Identity Center UserId.
- `studio_id`: The studio ID.

"""
function get_studio_member(
    principalId, studioId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return nimble(
        "GET",
        "/2020-08-01/studios/$(studioId)/membership/$(principalId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_studio_member(
    principalId,
    studioId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return nimble(
        "GET",
        "/2020-08-01/studios/$(studioId)/membership/$(principalId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_eula_acceptances(studio_id)
    list_eula_acceptances(studio_id, params::Dict{String,<:Any})

List EULA acceptances.

# Arguments
- `studio_id`: The studio ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"eulaIds"`: The list of EULA IDs that have been previously accepted.
- `"nextToken"`: The token for the next set of results, or null if there are no more
  results.
"""
function list_eula_acceptances(studioId; aws_config::AbstractAWSConfig=current_aws_config())
    return nimble(
        "GET",
        "/2020-08-01/studios/$(studioId)/eula-acceptances";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_eula_acceptances(
    studioId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return nimble(
        "GET",
        "/2020-08-01/studios/$(studioId)/eula-acceptances",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_eulas()
    list_eulas(params::Dict{String,<:Any})

List EULAs.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"eulaIds"`: The list of EULA IDs that should be returned
- `"nextToken"`: The token for the next set of results, or null if there are no more
  results.
"""
function list_eulas(; aws_config::AbstractAWSConfig=current_aws_config())
    return nimble(
        "GET", "/2020-08-01/eulas"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_eulas(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return nimble(
        "GET",
        "/2020-08-01/eulas",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_launch_profile_members(launch_profile_id, studio_id)
    list_launch_profile_members(launch_profile_id, studio_id, params::Dict{String,<:Any})

Get all users in a given launch profile membership.

# Arguments
- `launch_profile_id`: The ID of the launch profile used to control access from the
  streaming session.
- `studio_id`: The studio ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The max number of results to return in the response.
- `"nextToken"`: The token for the next set of results, or null if there are no more
  results.
"""
function list_launch_profile_members(
    launchProfileId, studioId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return nimble(
        "GET",
        "/2020-08-01/studios/$(studioId)/launch-profiles/$(launchProfileId)/membership";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_launch_profile_members(
    launchProfileId,
    studioId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return nimble(
        "GET",
        "/2020-08-01/studios/$(studioId)/launch-profiles/$(launchProfileId)/membership",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_launch_profiles(studio_id)
    list_launch_profiles(studio_id, params::Dict{String,<:Any})

List all the launch profiles a studio.

# Arguments
- `studio_id`: The studio ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The max number of results to return in the response.
- `"nextToken"`: The token for the next set of results, or null if there are no more
  results.
- `"principalId"`: The principal ID. This currently supports a IAM Identity Center UserId.
- `"states"`: Filter this request to launch profiles in any of the given states.
"""
function list_launch_profiles(studioId; aws_config::AbstractAWSConfig=current_aws_config())
    return nimble(
        "GET",
        "/2020-08-01/studios/$(studioId)/launch-profiles";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_launch_profiles(
    studioId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return nimble(
        "GET",
        "/2020-08-01/studios/$(studioId)/launch-profiles",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_streaming_images(studio_id)
    list_streaming_images(studio_id, params::Dict{String,<:Any})

List the streaming image resources available to this studio. This list will contain both
images provided by Amazon Web Services, as well as streaming images that you have created
in your studio.

# Arguments
- `studio_id`: The studio ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: The token for the next set of results, or null if there are no more
  results.
- `"owner"`: Filter this request to streaming images with the given owner
"""
function list_streaming_images(studioId; aws_config::AbstractAWSConfig=current_aws_config())
    return nimble(
        "GET",
        "/2020-08-01/studios/$(studioId)/streaming-images";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_streaming_images(
    studioId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return nimble(
        "GET",
        "/2020-08-01/studios/$(studioId)/streaming-images",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_streaming_session_backups(studio_id)
    list_streaming_session_backups(studio_id, params::Dict{String,<:Any})

Lists the backups of a streaming session in a studio.

# Arguments
- `studio_id`: The studio ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: The token for the next set of results, or null if there are no more
  results.
- `"ownedBy"`: The user ID of the user that owns the streaming session.
"""
function list_streaming_session_backups(
    studioId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return nimble(
        "GET",
        "/2020-08-01/studios/$(studioId)/streaming-session-backups";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_streaming_session_backups(
    studioId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return nimble(
        "GET",
        "/2020-08-01/studios/$(studioId)/streaming-session-backups",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_streaming_sessions(studio_id)
    list_streaming_sessions(studio_id, params::Dict{String,<:Any})

Lists the streaming sessions in a studio.

# Arguments
- `studio_id`: The studio ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"createdBy"`: Filters the request to streaming sessions created by the given user.
- `"nextToken"`: The token for the next set of results, or null if there are no more
  results.
- `"ownedBy"`: Filters the request to streaming session owned by the given user
- `"sessionIds"`: Filters the request to only the provided session IDs.
"""
function list_streaming_sessions(
    studioId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return nimble(
        "GET",
        "/2020-08-01/studios/$(studioId)/streaming-sessions";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_streaming_sessions(
    studioId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return nimble(
        "GET",
        "/2020-08-01/studios/$(studioId)/streaming-sessions",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_studio_components(studio_id)
    list_studio_components(studio_id, params::Dict{String,<:Any})

Lists the StudioComponents in a studio.

# Arguments
- `studio_id`: The studio ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The max number of results to return in the response.
- `"nextToken"`: The token for the next set of results, or null if there are no more
  results.
- `"states"`: Filters the request to studio components that are in one of the given states.
- `"types"`: Filters the request to studio components that are of one of the given types.
"""
function list_studio_components(
    studioId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return nimble(
        "GET",
        "/2020-08-01/studios/$(studioId)/studio-components";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_studio_components(
    studioId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return nimble(
        "GET",
        "/2020-08-01/studios/$(studioId)/studio-components",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_studio_members(studio_id)
    list_studio_members(studio_id, params::Dict{String,<:Any})

Get all users in a given studio membership.   ListStudioMembers only returns admin members.

# Arguments
- `studio_id`: The studio ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The max number of results to return in the response.
- `"nextToken"`: The token for the next set of results, or null if there are no more
  results.
"""
function list_studio_members(studioId; aws_config::AbstractAWSConfig=current_aws_config())
    return nimble(
        "GET",
        "/2020-08-01/studios/$(studioId)/membership";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_studio_members(
    studioId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return nimble(
        "GET",
        "/2020-08-01/studios/$(studioId)/membership",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_studios()
    list_studios(params::Dict{String,<:Any})

List studios in your Amazon Web Services accounts in the requested Amazon Web Services
Region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: The token for the next set of results, or null if there are no more
  results.
"""
function list_studios(; aws_config::AbstractAWSConfig=current_aws_config())
    return nimble(
        "GET", "/2020-08-01/studios"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_studios(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return nimble(
        "GET",
        "/2020-08-01/studios",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Gets the tags for a resource, given its Amazon Resource Names (ARN). This operation
supports ARNs for all resource types in Nimble Studio that support tags, including studio,
studio component, launch profile, streaming image, and streaming session. All resources
that can be tagged will contain an ARN property, so you do not have to create this ARN
yourself.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource for which you want to list
  tags.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return nimble(
        "GET",
        "/2020-08-01/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return nimble(
        "GET",
        "/2020-08-01/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_launch_profile_members(identity_store_id, launch_profile_id, members, studio_id)
    put_launch_profile_members(identity_store_id, launch_profile_id, members, studio_id, params::Dict{String,<:Any})

Add/update users with given persona to launch profile membership.

# Arguments
- `identity_store_id`: The ID of the identity store.
- `launch_profile_id`: The ID of the launch profile used to control access from the
  streaming session.
- `members`: A list of members.
- `studio_id`: The studio ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"X-Amz-Client-Token"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If you don’t specify a client token, the Amazon Web Services
  SDK automatically generates a client token and uses it for the request to ensure
  idempotency.
"""
function put_launch_profile_members(
    identityStoreId,
    launchProfileId,
    members,
    studioId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return nimble(
        "POST",
        "/2020-08-01/studios/$(studioId)/launch-profiles/$(launchProfileId)/membership",
        Dict{String,Any}(
            "identityStoreId" => identityStoreId,
            "members" => members,
            "X-Amz-Client-Token" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_launch_profile_members(
    identityStoreId,
    launchProfileId,
    members,
    studioId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return nimble(
        "POST",
        "/2020-08-01/studios/$(studioId)/launch-profiles/$(launchProfileId)/membership",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "identityStoreId" => identityStoreId,
                    "members" => members,
                    "X-Amz-Client-Token" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_studio_members(identity_store_id, members, studio_id)
    put_studio_members(identity_store_id, members, studio_id, params::Dict{String,<:Any})

Add/update users with given persona to studio membership.

# Arguments
- `identity_store_id`: The ID of the identity store.
- `members`: A list of members.
- `studio_id`: The studio ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"X-Amz-Client-Token"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If you don’t specify a client token, the Amazon Web Services
  SDK automatically generates a client token and uses it for the request to ensure
  idempotency.
"""
function put_studio_members(
    identityStoreId, members, studioId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return nimble(
        "POST",
        "/2020-08-01/studios/$(studioId)/membership",
        Dict{String,Any}(
            "identityStoreId" => identityStoreId,
            "members" => members,
            "X-Amz-Client-Token" => string(uuid4()),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_studio_members(
    identityStoreId,
    members,
    studioId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return nimble(
        "POST",
        "/2020-08-01/studios/$(studioId)/membership",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "identityStoreId" => identityStoreId,
                    "members" => members,
                    "X-Amz-Client-Token" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_streaming_session(session_id, studio_id)
    start_streaming_session(session_id, studio_id, params::Dict{String,<:Any})

Transitions sessions from the STOPPED state into the READY state. The START_IN_PROGRESS
state is the intermediate state between the STOPPED and READY states.

# Arguments
- `session_id`: The streaming session ID for the StartStreamingSessionRequest.
- `studio_id`: The studio ID for the StartStreamingSessionRequest.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"X-Amz-Client-Token"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If you don’t specify a client token, the Amazon Web Services
  SDK automatically generates a client token and uses it for the request to ensure
  idempotency.
- `"backupId"`: The ID of the backup.
"""
function start_streaming_session(
    sessionId, studioId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return nimble(
        "POST",
        "/2020-08-01/studios/$(studioId)/streaming-sessions/$(sessionId)/start",
        Dict{String,Any}("X-Amz-Client-Token" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_streaming_session(
    sessionId,
    studioId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return nimble(
        "POST",
        "/2020-08-01/studios/$(studioId)/streaming-sessions/$(sessionId)/start",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("X-Amz-Client-Token" => string(uuid4())), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_studio_ssoconfiguration_repair(studio_id)
    start_studio_ssoconfiguration_repair(studio_id, params::Dict{String,<:Any})

Repairs the IAM Identity Center configuration for a given studio. If the studio has a valid
IAM Identity Center configuration currently associated with it, this operation will fail
with a validation error. If the studio does not have a valid IAM Identity Center
configuration currently associated with it, then a new IAM Identity Center application is
created for the studio and the studio is changed to the READY state. After the IAM Identity
Center application is repaired, you must use the Amazon Nimble Studio console to add
administrators and users to your studio.

# Arguments
- `studio_id`: The studio ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"X-Amz-Client-Token"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If you don’t specify a client token, the Amazon Web Services
  SDK automatically generates a client token and uses it for the request to ensure
  idempotency.
"""
function start_studio_ssoconfiguration_repair(
    studioId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return nimble(
        "PUT",
        "/2020-08-01/studios/$(studioId)/sso-configuration",
        Dict{String,Any}("X-Amz-Client-Token" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_studio_ssoconfiguration_repair(
    studioId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return nimble(
        "PUT",
        "/2020-08-01/studios/$(studioId)/sso-configuration",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("X-Amz-Client-Token" => string(uuid4())), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_streaming_session(session_id, studio_id)
    stop_streaming_session(session_id, studio_id, params::Dict{String,<:Any})

Transitions sessions from the READY state into the STOPPED state. The STOP_IN_PROGRESS
state is the intermediate state between the READY and STOPPED states.

# Arguments
- `session_id`: The streaming session ID for the StopStreamingSessionRequest.
- `studio_id`: The studioId for the StopStreamingSessionRequest.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"X-Amz-Client-Token"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If you don’t specify a client token, the Amazon Web Services
  SDK automatically generates a client token and uses it for the request to ensure
  idempotency.
- `"volumeRetentionMode"`: Adds additional instructions to a streaming session stop action
  to either retain the EBS volumes or delete the EBS volumes.
"""
function stop_streaming_session(
    sessionId, studioId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return nimble(
        "POST",
        "/2020-08-01/studios/$(studioId)/streaming-sessions/$(sessionId)/stop",
        Dict{String,Any}("X-Amz-Client-Token" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_streaming_session(
    sessionId,
    studioId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return nimble(
        "POST",
        "/2020-08-01/studios/$(studioId)/streaming-sessions/$(sessionId)/stop",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("X-Amz-Client-Token" => string(uuid4())), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn)
    tag_resource(resource_arn, params::Dict{String,<:Any})

Creates tags for a resource, given its ARN.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource you want to add tags to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tags"`: A collection of labels, in the form of key-value pairs, that apply to this
  resource.
"""
function tag_resource(resourceArn; aws_config::AbstractAWSConfig=current_aws_config())
    return nimble(
        "POST",
        "/2020-08-01/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return nimble(
        "POST",
        "/2020-08-01/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Deletes the tags for a resource.

# Arguments
- `resource_arn`: Identifies the Amazon Resource Name(ARN) key from which you are removing
  tags.
- `tag_keys`: One or more tag keys. Specify only the tag keys, not the tag values.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return nimble(
        "DELETE",
        "/2020-08-01/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return nimble(
        "DELETE",
        "/2020-08-01/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_launch_profile(launch_profile_id, studio_id)
    update_launch_profile(launch_profile_id, studio_id, params::Dict{String,<:Any})

Update a launch profile.

# Arguments
- `launch_profile_id`: The ID of the launch profile used to control access from the
  streaming session.
- `studio_id`: The studio ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"X-Amz-Client-Token"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If you don’t specify a client token, the Amazon Web Services
  SDK automatically generates a client token and uses it for the request to ensure
  idempotency.
- `"description"`: The description.
- `"launchProfileProtocolVersions"`: The version number of the protocol that is used by the
  launch profile. The only valid version is \"2021-03-31\".
- `"name"`: The name for the launch profile.
- `"streamConfiguration"`: A configuration for a streaming session.
- `"studioComponentIds"`: Unique identifiers for a collection of studio components that can
  be used with this launch profile.
"""
function update_launch_profile(
    launchProfileId, studioId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return nimble(
        "PATCH",
        "/2020-08-01/studios/$(studioId)/launch-profiles/$(launchProfileId)",
        Dict{String,Any}("X-Amz-Client-Token" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_launch_profile(
    launchProfileId,
    studioId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return nimble(
        "PATCH",
        "/2020-08-01/studios/$(studioId)/launch-profiles/$(launchProfileId)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("X-Amz-Client-Token" => string(uuid4())), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_launch_profile_member(launch_profile_id, persona, principal_id, studio_id)
    update_launch_profile_member(launch_profile_id, persona, principal_id, studio_id, params::Dict{String,<:Any})

Update a user persona in launch profile membership.

# Arguments
- `launch_profile_id`: The ID of the launch profile used to control access from the
  streaming session.
- `persona`: The persona.
- `principal_id`: The principal ID. This currently supports a IAM Identity Center UserId.
- `studio_id`: The studio ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"X-Amz-Client-Token"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If you don’t specify a client token, the Amazon Web Services
  SDK automatically generates a client token and uses it for the request to ensure
  idempotency.
"""
function update_launch_profile_member(
    launchProfileId,
    persona,
    principalId,
    studioId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return nimble(
        "PATCH",
        "/2020-08-01/studios/$(studioId)/launch-profiles/$(launchProfileId)/membership/$(principalId)",
        Dict{String,Any}("persona" => persona, "X-Amz-Client-Token" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_launch_profile_member(
    launchProfileId,
    persona,
    principalId,
    studioId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return nimble(
        "PATCH",
        "/2020-08-01/studios/$(studioId)/launch-profiles/$(launchProfileId)/membership/$(principalId)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "persona" => persona, "X-Amz-Client-Token" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_streaming_image(streaming_image_id, studio_id)
    update_streaming_image(streaming_image_id, studio_id, params::Dict{String,<:Any})

Update streaming image.

# Arguments
- `streaming_image_id`: The streaming image ID.
- `studio_id`: The studio ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"X-Amz-Client-Token"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If you don’t specify a client token, the Amazon Web Services
  SDK automatically generates a client token and uses it for the request to ensure
  idempotency.
- `"description"`: The description.
- `"name"`: The name for the streaming image.
"""
function update_streaming_image(
    streamingImageId, studioId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return nimble(
        "PATCH",
        "/2020-08-01/studios/$(studioId)/streaming-images/$(streamingImageId)",
        Dict{String,Any}("X-Amz-Client-Token" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_streaming_image(
    streamingImageId,
    studioId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return nimble(
        "PATCH",
        "/2020-08-01/studios/$(studioId)/streaming-images/$(streamingImageId)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("X-Amz-Client-Token" => string(uuid4())), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_studio(studio_id)
    update_studio(studio_id, params::Dict{String,<:Any})

Update a Studio resource. Currently, this operation only supports updating the displayName
of your studio.

# Arguments
- `studio_id`: The studio ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"X-Amz-Client-Token"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If you don’t specify a client token, the Amazon Web Services
  SDK automatically generates a client token and uses it for the request to ensure
  idempotency.
- `"adminRoleArn"`: The IAM role that Studio Admins will assume when logging in to the
  Nimble Studio portal.
- `"displayName"`: A friendly name for the studio.
- `"userRoleArn"`: The IAM role that Studio Users will assume when logging in to the Nimble
  Studio portal.
"""
function update_studio(studioId; aws_config::AbstractAWSConfig=current_aws_config())
    return nimble(
        "PATCH",
        "/2020-08-01/studios/$(studioId)",
        Dict{String,Any}("X-Amz-Client-Token" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_studio(
    studioId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return nimble(
        "PATCH",
        "/2020-08-01/studios/$(studioId)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("X-Amz-Client-Token" => string(uuid4())), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_studio_component(studio_component_id, studio_id)
    update_studio_component(studio_component_id, studio_id, params::Dict{String,<:Any})

Updates a studio component resource.

# Arguments
- `studio_component_id`: The studio component ID.
- `studio_id`: The studio ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"X-Amz-Client-Token"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. If you don’t specify a client token, the Amazon Web Services
  SDK automatically generates a client token and uses it for the request to ensure
  idempotency.
- `"configuration"`: The configuration of the studio component, based on component type.
- `"description"`: The description.
- `"ec2SecurityGroupIds"`: The EC2 security groups that control access to the studio
  component.
- `"initializationScripts"`: Initialization scripts for studio components.
- `"name"`: The name for the studio component.
- `"runtimeRoleArn"`: An IAM role attached to a Studio Component that gives the studio
  component access to Amazon Web Services resources at anytime while the instance is running.
- `"scriptParameters"`: Parameters for the studio component scripts.
- `"secureInitializationRoleArn"`: An IAM role attached to Studio Component when the system
  initialization script runs which give the studio component access to Amazon Web Services
  resources when the system initialization script runs.
- `"subtype"`: The specific subtype of a studio component.
- `"type"`: The type of the studio component.
"""
function update_studio_component(
    studioComponentId, studioId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return nimble(
        "PATCH",
        "/2020-08-01/studios/$(studioId)/studio-components/$(studioComponentId)",
        Dict{String,Any}("X-Amz-Client-Token" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_studio_component(
    studioComponentId,
    studioId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return nimble(
        "PATCH",
        "/2020-08-01/studios/$(studioId)/studio-components/$(studioComponentId)",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("X-Amz-Client-Token" => string(uuid4())), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: privatenetworks
using AWS.Compat
using AWS.UUIDs

"""
    acknowledge_order_receipt(order_arn)
    acknowledge_order_receipt(order_arn, params::Dict{String,<:Any})

Acknowledges that the specified network order was received.

# Arguments
- `order_arn`: The Amazon Resource Name (ARN) of the order.

"""
function acknowledge_order_receipt(
    orderArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return privatenetworks(
        "POST",
        "/v1/orders/acknowledge",
        Dict{String,Any}("orderArn" => orderArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function acknowledge_order_receipt(
    orderArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return privatenetworks(
        "POST",
        "/v1/orders/acknowledge",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("orderArn" => orderArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    activate_device_identifier(device_identifier_arn)
    activate_device_identifier(device_identifier_arn, params::Dict{String,<:Any})

Activates the specified device identifier.

# Arguments
- `device_identifier_arn`: The Amazon Resource Name (ARN) of the device identifier.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. For more information, see How to ensure idempotency.
"""
function activate_device_identifier(
    deviceIdentifierArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return privatenetworks(
        "POST",
        "/v1/device-identifiers/activate",
        Dict{String,Any}("deviceIdentifierArn" => deviceIdentifierArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function activate_device_identifier(
    deviceIdentifierArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return privatenetworks(
        "POST",
        "/v1/device-identifiers/activate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("deviceIdentifierArn" => deviceIdentifierArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    activate_network_site(network_site_arn, shipping_address)
    activate_network_site(network_site_arn, shipping_address, params::Dict{String,<:Any})

Activates the specified network site.

# Arguments
- `network_site_arn`: The Amazon Resource Name (ARN) of the network site.
- `shipping_address`: The shipping address of the network site.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. For more information, see How to ensure idempotency.
- `"commitmentConfiguration"`: Determines the duration and renewal status of the commitment
  period for all pending radio units. If you include commitmentConfiguration in the
  ActivateNetworkSiteRequest action, you must specify the following:   The commitment period
  for the radio unit. You can choose a 60-day, 1-year, or 3-year period.   Whether you want
  your commitment period to automatically renew for one more year after your current
  commitment period expires.   For pricing, see Amazon Web Services Private 5G Pricing. If
  you do not include commitmentConfiguration in the ActivateNetworkSiteRequest action, the
  commitment period is set to 60-days.
"""
function activate_network_site(
    networkSiteArn, shippingAddress; aws_config::AbstractAWSConfig=current_aws_config()
)
    return privatenetworks(
        "POST",
        "/v1/network-sites/activate",
        Dict{String,Any}(
            "networkSiteArn" => networkSiteArn, "shippingAddress" => shippingAddress
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function activate_network_site(
    networkSiteArn,
    shippingAddress,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return privatenetworks(
        "POST",
        "/v1/network-sites/activate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "networkSiteArn" => networkSiteArn, "shippingAddress" => shippingAddress
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    configure_access_point(access_point_arn)
    configure_access_point(access_point_arn, params::Dict{String,<:Any})

Configures the specified network resource.   Use this action to specify the geographic
position of the hardware. You must provide Certified Professional Installer (CPI)
credentials in the request so that we can obtain spectrum grants. For more information, see
Radio units in the Amazon Web Services Private 5G User Guide.

# Arguments
- `access_point_arn`: The Amazon Resource Name (ARN) of the network resource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"cpiSecretKey"`: A Base64 encoded string of the CPI certificate associated with the CPI
  user who is certifying the coordinates of the network resource.
- `"cpiUserId"`: The CPI user ID of the CPI user who is certifying the coordinates of the
  network resource.
- `"cpiUserPassword"`: The CPI password associated with the CPI certificate in cpiSecretKey.
- `"cpiUsername"`: The CPI user name of the CPI user who is certifying the coordinates of
  the radio unit.
- `"position"`: The position of the network resource.
"""
function configure_access_point(
    accessPointArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return privatenetworks(
        "POST",
        "/v1/network-resources/configure",
        Dict{String,Any}("accessPointArn" => accessPointArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function configure_access_point(
    accessPointArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return privatenetworks(
        "POST",
        "/v1/network-resources/configure",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("accessPointArn" => accessPointArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_network(network_name)
    create_network(network_name, params::Dict{String,<:Any})

Creates a network.

# Arguments
- `network_name`: The name of the network. You can't change the name after you create the
  network.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. For more information, see How to ensure idempotency.
- `"description"`: The description of the network.
- `"tags"`:  The tags to apply to the network.
"""
function create_network(networkName; aws_config::AbstractAWSConfig=current_aws_config())
    return privatenetworks(
        "POST",
        "/v1/networks",
        Dict{String,Any}("networkName" => networkName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_network(
    networkName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return privatenetworks(
        "POST",
        "/v1/networks",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("networkName" => networkName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_network_site(network_arn, network_site_name)
    create_network_site(network_arn, network_site_name, params::Dict{String,<:Any})

Creates a network site.

# Arguments
- `network_arn`: The Amazon Resource Name (ARN) of the network.
- `network_site_name`: The name of the site. You can't change the name after you create the
  site.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"availabilityZone"`: The Availability Zone that is the parent of this site. You can't
  change the Availability Zone after you create the site.
- `"availabilityZoneId"`: The ID of the Availability Zone that is the parent of this site.
  You can't change the Availability Zone after you create the site.
- `"clientToken"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. For more information, see How to ensure idempotency.
- `"description"`: The description of the site.
- `"pendingPlan"`: Information about the pending plan for this site.
- `"tags"`:  The tags to apply to the network site.
"""
function create_network_site(
    networkArn, networkSiteName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return privatenetworks(
        "POST",
        "/v1/network-sites",
        Dict{String,Any}("networkArn" => networkArn, "networkSiteName" => networkSiteName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_network_site(
    networkArn,
    networkSiteName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return privatenetworks(
        "POST",
        "/v1/network-sites",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "networkArn" => networkArn, "networkSiteName" => networkSiteName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    deactivate_device_identifier(device_identifier_arn)
    deactivate_device_identifier(device_identifier_arn, params::Dict{String,<:Any})

Deactivates the specified device identifier.

# Arguments
- `device_identifier_arn`: The Amazon Resource Name (ARN) of the device identifier.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. For more information, see How to ensure idempotency.
"""
function deactivate_device_identifier(
    deviceIdentifierArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return privatenetworks(
        "POST",
        "/v1/device-identifiers/deactivate",
        Dict{String,Any}("deviceIdentifierArn" => deviceIdentifierArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function deactivate_device_identifier(
    deviceIdentifierArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return privatenetworks(
        "POST",
        "/v1/device-identifiers/deactivate",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("deviceIdentifierArn" => deviceIdentifierArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_network(network_arn)
    delete_network(network_arn, params::Dict{String,<:Any})

Deletes the specified network. You must delete network sites before you delete the network.
For more information, see DeleteNetworkSite in the API Reference for Amazon Web Services
Private 5G.

# Arguments
- `network_arn`: The Amazon Resource Name (ARN) of the network.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. For more information, see How to ensure idempotency.
"""
function delete_network(networkArn; aws_config::AbstractAWSConfig=current_aws_config())
    return privatenetworks(
        "DELETE",
        "/v1/networks/$(networkArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_network(
    networkArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return privatenetworks(
        "DELETE",
        "/v1/networks/$(networkArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_network_site(network_site_arn)
    delete_network_site(network_site_arn, params::Dict{String,<:Any})

Deletes the specified network site. Return the hardware after you delete the network site.
You are responsible for minimum charges. For more information, see Hardware returns in the
Amazon Web Services Private 5G User Guide.

# Arguments
- `network_site_arn`: The Amazon Resource Name (ARN) of the network site.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. For more information, see How to ensure idempotency.
"""
function delete_network_site(
    networkSiteArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return privatenetworks(
        "DELETE",
        "/v1/network-sites/$(networkSiteArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_network_site(
    networkSiteArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return privatenetworks(
        "DELETE",
        "/v1/network-sites/$(networkSiteArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_device_identifier(device_identifier_arn)
    get_device_identifier(device_identifier_arn, params::Dict{String,<:Any})

Gets the specified device identifier.

# Arguments
- `device_identifier_arn`: The Amazon Resource Name (ARN) of the device identifier.

"""
function get_device_identifier(
    deviceIdentifierArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return privatenetworks(
        "GET",
        "/v1/device-identifiers/$(deviceIdentifierArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_device_identifier(
    deviceIdentifierArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return privatenetworks(
        "GET",
        "/v1/device-identifiers/$(deviceIdentifierArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_network(network_arn)
    get_network(network_arn, params::Dict{String,<:Any})

Gets the specified network.

# Arguments
- `network_arn`: The Amazon Resource Name (ARN) of the network.

"""
function get_network(networkArn; aws_config::AbstractAWSConfig=current_aws_config())
    return privatenetworks(
        "GET",
        "/v1/networks/$(networkArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_network(
    networkArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return privatenetworks(
        "GET",
        "/v1/networks/$(networkArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_network_resource(network_resource_arn)
    get_network_resource(network_resource_arn, params::Dict{String,<:Any})

Gets the specified network resource.

# Arguments
- `network_resource_arn`: The Amazon Resource Name (ARN) of the network resource.

"""
function get_network_resource(
    networkResourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return privatenetworks(
        "GET",
        "/v1/network-resources/$(networkResourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_network_resource(
    networkResourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return privatenetworks(
        "GET",
        "/v1/network-resources/$(networkResourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_network_site(network_site_arn)
    get_network_site(network_site_arn, params::Dict{String,<:Any})

Gets the specified network site.

# Arguments
- `network_site_arn`: The Amazon Resource Name (ARN) of the network site.

"""
function get_network_site(
    networkSiteArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return privatenetworks(
        "GET",
        "/v1/network-sites/$(networkSiteArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_network_site(
    networkSiteArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return privatenetworks(
        "GET",
        "/v1/network-sites/$(networkSiteArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_order(order_arn)
    get_order(order_arn, params::Dict{String,<:Any})

Gets the specified order.

# Arguments
- `order_arn`: The Amazon Resource Name (ARN) of the order.

"""
function get_order(orderArn; aws_config::AbstractAWSConfig=current_aws_config())
    return privatenetworks(
        "GET",
        "/v1/orders/$(orderArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_order(
    orderArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return privatenetworks(
        "GET",
        "/v1/orders/$(orderArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_device_identifiers(network_arn)
    list_device_identifiers(network_arn, params::Dict{String,<:Any})

Lists device identifiers. Add filters to your request to return a more specific list of
results. Use filters to match the Amazon Resource Name (ARN) of an order, the status of
device identifiers, or the ARN of the traffic group. If you specify multiple filters,
filters are joined with an OR, and the request returns results that match all of the
specified filters.

# Arguments
- `network_arn`: The Amazon Resource Name (ARN) of the network.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: The filters.    ORDER - The Amazon Resource Name (ARN) of the order.
  STATUS - The status (ACTIVE | INACTIVE).    TRAFFIC_GROUP - The Amazon Resource Name (ARN)
  of the traffic group.   Filter values are case sensitive. If you specify multiple values
  for a filter, the values are joined with an OR, and the request returns all results that
  match any of the specified values.
- `"maxResults"`: The maximum number of results to return.
- `"startToken"`: The token for the next page of results.
"""
function list_device_identifiers(
    networkArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return privatenetworks(
        "POST",
        "/v1/device-identifiers/list",
        Dict{String,Any}("networkArn" => networkArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_device_identifiers(
    networkArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return privatenetworks(
        "POST",
        "/v1/device-identifiers/list",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("networkArn" => networkArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_network_resources(network_arn)
    list_network_resources(network_arn, params::Dict{String,<:Any})

Lists network resources. Add filters to your request to return a more specific list of
results. Use filters to match the Amazon Resource Name (ARN) of an order or the status of
network resources. If you specify multiple filters, filters are joined with an OR, and the
request returns results that match all of the specified filters.

# Arguments
- `network_arn`: The Amazon Resource Name (ARN) of the network.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: The filters.    ORDER - The Amazon Resource Name (ARN) of the order.
  STATUS - The status (AVAILABLE | DELETED | DELETING | PENDING | PENDING_RETURN |
  PROVISIONING | SHIPPED).   Filter values are case sensitive. If you specify multiple values
  for a filter, the values are joined with an OR, and the request returns all results that
  match any of the specified values.
- `"maxResults"`: The maximum number of results to return.
- `"startToken"`: The token for the next page of results.
"""
function list_network_resources(
    networkArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return privatenetworks(
        "POST",
        "/v1/network-resources",
        Dict{String,Any}("networkArn" => networkArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_network_resources(
    networkArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return privatenetworks(
        "POST",
        "/v1/network-resources",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("networkArn" => networkArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_network_sites(network_arn)
    list_network_sites(network_arn, params::Dict{String,<:Any})

Lists network sites. Add filters to your request to return a more specific list of results.
Use filters to match the status of the network site.

# Arguments
- `network_arn`: The Amazon Resource Name (ARN) of the network.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: The filters. Add filters to your request to return a more specific list of
  results. Use filters to match the status of the network sites.    STATUS - The status
  (AVAILABLE | CREATED | DELETED | DEPROVISIONING | PROVISIONING).   Filter values are case
  sensitive. If you specify multiple values for a filter, the values are joined with an OR,
  and the request returns all results that match any of the specified values.
- `"maxResults"`: The maximum number of results to return.
- `"startToken"`: The token for the next page of results.
"""
function list_network_sites(networkArn; aws_config::AbstractAWSConfig=current_aws_config())
    return privatenetworks(
        "POST",
        "/v1/network-sites/list",
        Dict{String,Any}("networkArn" => networkArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_network_sites(
    networkArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return privatenetworks(
        "POST",
        "/v1/network-sites/list",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("networkArn" => networkArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_networks()
    list_networks(params::Dict{String,<:Any})

Lists networks. Add filters to your request to return a more specific list of results. Use
filters to match the status of the network.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: The filters.    STATUS - The status (AVAILABLE | CREATED | DELETED |
  DEPROVISIONING | PROVISIONING).   Filter values are case sensitive. If you specify multiple
  values for a filter, the values are joined with an OR, and the request returns all results
  that match any of the specified values.
- `"maxResults"`: The maximum number of results to return.
- `"startToken"`: The token for the next page of results.
"""
function list_networks(; aws_config::AbstractAWSConfig=current_aws_config())
    return privatenetworks(
        "POST", "/v1/networks/list"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_networks(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return privatenetworks(
        "POST",
        "/v1/networks/list",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_orders(network_arn)
    list_orders(network_arn, params::Dict{String,<:Any})

Lists orders. Add filters to your request to return a more specific list of results. Use
filters to match the Amazon Resource Name (ARN) of the network site or the status of the
order. If you specify multiple filters, filters are joined with an OR, and the request
returns results that match all of the specified filters.

# Arguments
- `network_arn`: The Amazon Resource Name (ARN) of the network.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filters"`: The filters.    NETWORK_SITE - The Amazon Resource Name (ARN) of the network
  site.    STATUS - The status (ACKNOWLEDGING | ACKNOWLEDGED | UNACKNOWLEDGED).   Filter
  values are case sensitive. If you specify multiple values for a filter, the values are
  joined with an OR, and the request returns all results that match any of the specified
  values.
- `"maxResults"`: The maximum number of results to return.
- `"startToken"`: The token for the next page of results.
"""
function list_orders(networkArn; aws_config::AbstractAWSConfig=current_aws_config())
    return privatenetworks(
        "POST",
        "/v1/orders/list",
        Dict{String,Any}("networkArn" => networkArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_orders(
    networkArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return privatenetworks(
        "POST",
        "/v1/orders/list",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("networkArn" => networkArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Lists the tags for the specified resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return privatenetworks(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return privatenetworks(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    ping()
    ping(params::Dict{String,<:Any})

Checks the health of the service.

"""
function ping(; aws_config::AbstractAWSConfig=current_aws_config())
    return privatenetworks(
        "GET", "/ping"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function ping(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return privatenetworks(
        "GET", "/ping", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    start_network_resource_update(network_resource_arn, update_type)
    start_network_resource_update(network_resource_arn, update_type, params::Dict{String,<:Any})

Use this action to do the following tasks:   Update the duration and renewal status of the
commitment period for a radio unit. The update goes into effect immediately.   Request a
replacement for a network resource.   Request that you return a network resource.   After
you submit a request to replace or return a network resource, the status of the network
resource changes to CREATING_SHIPPING_LABEL. The shipping label is available when the
status of the network resource is PENDING_RETURN. After the network resource is
successfully returned, its status changes to DELETED. For more information, see Return a
radio unit.

# Arguments
- `network_resource_arn`: The Amazon Resource Name (ARN) of the network resource.
- `update_type`: The update type.    REPLACE - Submits a request to replace a defective
  radio unit. We provide a shipping label that you can use for the return process and we ship
  a replacement radio unit to you.    RETURN - Submits a request to return a radio unit that
  you no longer need. We provide a shipping label that you can use for the return process.
  COMMITMENT - Submits a request to change or renew the commitment period. If you choose this
  value, then you must set  commitmentConfiguration .

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"commitmentConfiguration"`: Use this action to extend and automatically renew the
  commitment period for the radio unit. You can do the following:   Change a 60-day
  commitment to a 1-year or 3-year commitment. The change is immediate and the hourly rate
  decreases to the rate for the new commitment period.   Change a 1-year commitment to a
  3-year commitment. The change is immediate and the hourly rate decreases to the rate for
  the 3-year commitment period.   Set a 1-year commitment to automatically renew for an
  additional 1 year. The hourly rate for the additional year will continue to be the same as
  your existing 1-year rate.   Set a 3-year commitment to automatically renew for an
  additional 1 year. The hourly rate for the additional year will continue to be the same as
  your existing 3-year rate.   Turn off a previously-enabled automatic renewal on a 1-year or
  3-year commitment. You cannot use the automatic-renewal option for a 60-day commitment.
  For pricing, see Amazon Web Services Private 5G Pricing.
- `"returnReason"`: The reason for the return. Providing a reason for a return is optional.
- `"shippingAddress"`: The shipping address. If you don't provide a shipping address when
  replacing or returning a network resource, we use the address from the original order for
  the network resource.
"""
function start_network_resource_update(
    networkResourceArn, updateType; aws_config::AbstractAWSConfig=current_aws_config()
)
    return privatenetworks(
        "POST",
        "/v1/network-resources/update",
        Dict{String,Any}(
            "networkResourceArn" => networkResourceArn, "updateType" => updateType
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_network_resource_update(
    networkResourceArn,
    updateType,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return privatenetworks(
        "POST",
        "/v1/network-resources/update",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "networkResourceArn" => networkResourceArn, "updateType" => updateType
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

 Adds tags to the specified resource.

# Arguments
- `resource_arn`:  The Amazon Resource Name (ARN) of the resource.
- `tags`: The tags to add to the resource.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return privatenetworks(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return privatenetworks(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes tags from the specified resource.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) of the resource.
- `tag_keys`: The tag keys.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return privatenetworks(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return privatenetworks(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_network_site(network_site_arn)
    update_network_site(network_site_arn, params::Dict{String,<:Any})

Updates the specified network site.

# Arguments
- `network_site_arn`: The Amazon Resource Name (ARN) of the network site.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. For more information, see How to ensure idempotency.
- `"description"`: The description.
"""
function update_network_site(
    networkSiteArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return privatenetworks(
        "PUT",
        "/v1/network-sites/site",
        Dict{String,Any}("networkSiteArn" => networkSiteArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_network_site(
    networkSiteArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return privatenetworks(
        "PUT",
        "/v1/network-sites/site",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("networkSiteArn" => networkSiteArn), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_network_site_plan(network_site_arn, pending_plan)
    update_network_site_plan(network_site_arn, pending_plan, params::Dict{String,<:Any})

Updates the specified network site plan.

# Arguments
- `network_site_arn`: The Amazon Resource Name (ARN) of the network site.
- `pending_plan`: The pending plan.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: Unique, case-sensitive identifier that you provide to ensure the
  idempotency of the request. For more information, see How to ensure idempotency.
"""
function update_network_site_plan(
    networkSiteArn, pendingPlan; aws_config::AbstractAWSConfig=current_aws_config()
)
    return privatenetworks(
        "PUT",
        "/v1/network-sites/plan",
        Dict{String,Any}("networkSiteArn" => networkSiteArn, "pendingPlan" => pendingPlan);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_network_site_plan(
    networkSiteArn,
    pendingPlan,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return privatenetworks(
        "PUT",
        "/v1/network-sites/plan",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "networkSiteArn" => networkSiteArn, "pendingPlan" => pendingPlan
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: amplifybackend
using AWS.Compat
using AWS.UUIDs

"""
    clone_backend(app_id, backend_environment_name, target_environment_name)
    clone_backend(app_id, backend_environment_name, target_environment_name, params::Dict{String,<:Any})

This operation clones an existing backend.

# Arguments
- `app_id`: The app ID.
- `backend_environment_name`: The name of the backend environment.
- `target_environment_name`: The name of the destination backend environment to be created.

"""
function clone_backend(
    appId,
    backendEnvironmentName,
    targetEnvironmentName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifybackend(
        "POST",
        "/backend/$(appId)/environments/$(backendEnvironmentName)/clone",
        Dict{String,Any}("targetEnvironmentName" => targetEnvironmentName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function clone_backend(
    appId,
    backendEnvironmentName,
    targetEnvironmentName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifybackend(
        "POST",
        "/backend/$(appId)/environments/$(backendEnvironmentName)/clone",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("targetEnvironmentName" => targetEnvironmentName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_backend(app_id, app_name, backend_environment_name)
    create_backend(app_id, app_name, backend_environment_name, params::Dict{String,<:Any})

This operation creates a backend for an Amplify app. Backends are automatically created at
the time of app creation.

# Arguments
- `app_id`: The app ID.
- `app_name`: The name of the app.
- `backend_environment_name`: The name of the backend environment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"resourceConfig"`: The resource configuration for creating a backend.
- `"resourceName"`: The name of the resource.
"""
function create_backend(
    appId,
    appName,
    backendEnvironmentName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifybackend(
        "POST",
        "/backend",
        Dict{String,Any}(
            "appId" => appId,
            "appName" => appName,
            "backendEnvironmentName" => backendEnvironmentName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_backend(
    appId,
    appName,
    backendEnvironmentName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifybackend(
        "POST",
        "/backend",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "appId" => appId,
                    "appName" => appName,
                    "backendEnvironmentName" => backendEnvironmentName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_backend_api(app_id, backend_environment_name, resource_config, resource_name)
    create_backend_api(app_id, backend_environment_name, resource_config, resource_name, params::Dict{String,<:Any})

Creates a new backend API resource.

# Arguments
- `app_id`: The app ID.
- `backend_environment_name`: The name of the backend environment.
- `resource_config`: The resource configuration for this request.
- `resource_name`: The name of this resource.

"""
function create_backend_api(
    appId,
    backendEnvironmentName,
    resourceConfig,
    resourceName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifybackend(
        "POST",
        "/backend/$(appId)/api",
        Dict{String,Any}(
            "backendEnvironmentName" => backendEnvironmentName,
            "resourceConfig" => resourceConfig,
            "resourceName" => resourceName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_backend_api(
    appId,
    backendEnvironmentName,
    resourceConfig,
    resourceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifybackend(
        "POST",
        "/backend/$(appId)/api",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "backendEnvironmentName" => backendEnvironmentName,
                    "resourceConfig" => resourceConfig,
                    "resourceName" => resourceName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_backend_auth(app_id, backend_environment_name, resource_config, resource_name)
    create_backend_auth(app_id, backend_environment_name, resource_config, resource_name, params::Dict{String,<:Any})

Creates a new backend authentication resource.

# Arguments
- `app_id`: The app ID.
- `backend_environment_name`: The name of the backend environment.
- `resource_config`: The resource configuration for this request object.
- `resource_name`: The name of this resource.

"""
function create_backend_auth(
    appId,
    backendEnvironmentName,
    resourceConfig,
    resourceName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifybackend(
        "POST",
        "/backend/$(appId)/auth",
        Dict{String,Any}(
            "backendEnvironmentName" => backendEnvironmentName,
            "resourceConfig" => resourceConfig,
            "resourceName" => resourceName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_backend_auth(
    appId,
    backendEnvironmentName,
    resourceConfig,
    resourceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifybackend(
        "POST",
        "/backend/$(appId)/auth",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "backendEnvironmentName" => backendEnvironmentName,
                    "resourceConfig" => resourceConfig,
                    "resourceName" => resourceName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_backend_config(app_id)
    create_backend_config(app_id, params::Dict{String,<:Any})

Creates a config object for a backend.

# Arguments
- `app_id`: The app ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"backendManagerAppId"`: The app ID for the backend manager.
"""
function create_backend_config(appId; aws_config::AbstractAWSConfig=current_aws_config())
    return amplifybackend(
        "POST",
        "/backend/$(appId)/config";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_backend_config(
    appId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplifybackend(
        "POST",
        "/backend/$(appId)/config",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_backend_storage(app_id, backend_environment_name, resource_config, resource_name)
    create_backend_storage(app_id, backend_environment_name, resource_config, resource_name, params::Dict{String,<:Any})

Creates a backend storage resource.

# Arguments
- `app_id`: The app ID.
- `backend_environment_name`: The name of the backend environment.
- `resource_config`: The resource configuration for creating backend storage.
- `resource_name`: The name of the storage resource.

"""
function create_backend_storage(
    appId,
    backendEnvironmentName,
    resourceConfig,
    resourceName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifybackend(
        "POST",
        "/backend/$(appId)/storage",
        Dict{String,Any}(
            "backendEnvironmentName" => backendEnvironmentName,
            "resourceConfig" => resourceConfig,
            "resourceName" => resourceName,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_backend_storage(
    appId,
    backendEnvironmentName,
    resourceConfig,
    resourceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifybackend(
        "POST",
        "/backend/$(appId)/storage",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "backendEnvironmentName" => backendEnvironmentName,
                    "resourceConfig" => resourceConfig,
                    "resourceName" => resourceName,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_token(app_id)
    create_token(app_id, params::Dict{String,<:Any})

Generates a one-time challenge code to authenticate a user into your Amplify Admin UI.

# Arguments
- `app_id`: The app ID.

"""
function create_token(appId; aws_config::AbstractAWSConfig=current_aws_config())
    return amplifybackend(
        "POST",
        "/backend/$(appId)/challenge";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_token(
    appId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplifybackend(
        "POST",
        "/backend/$(appId)/challenge",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_backend(app_id, backend_environment_name)
    delete_backend(app_id, backend_environment_name, params::Dict{String,<:Any})

Removes an existing environment from your Amplify project.

# Arguments
- `app_id`: The app ID.
- `backend_environment_name`: The name of the backend environment.

"""
function delete_backend(
    appId, backendEnvironmentName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplifybackend(
        "POST",
        "/backend/$(appId)/environments/$(backendEnvironmentName)/remove";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_backend(
    appId,
    backendEnvironmentName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifybackend(
        "POST",
        "/backend/$(appId)/environments/$(backendEnvironmentName)/remove",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_backend_api(app_id, backend_environment_name, resource_name)
    delete_backend_api(app_id, backend_environment_name, resource_name, params::Dict{String,<:Any})

Deletes an existing backend API resource.

# Arguments
- `app_id`: The app ID.
- `backend_environment_name`: The name of the backend environment.
- `resource_name`: The name of this resource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"resourceConfig"`: Defines the resource configuration for the data model in your Amplify
  project.
"""
function delete_backend_api(
    appId,
    backendEnvironmentName,
    resourceName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifybackend(
        "POST",
        "/backend/$(appId)/api/$(backendEnvironmentName)/remove",
        Dict{String,Any}("resourceName" => resourceName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_backend_api(
    appId,
    backendEnvironmentName,
    resourceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifybackend(
        "POST",
        "/backend/$(appId)/api/$(backendEnvironmentName)/remove",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceName" => resourceName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_backend_auth(app_id, backend_environment_name, resource_name)
    delete_backend_auth(app_id, backend_environment_name, resource_name, params::Dict{String,<:Any})

Deletes an existing backend authentication resource.

# Arguments
- `app_id`: The app ID.
- `backend_environment_name`: The name of the backend environment.
- `resource_name`: The name of this resource.

"""
function delete_backend_auth(
    appId,
    backendEnvironmentName,
    resourceName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifybackend(
        "POST",
        "/backend/$(appId)/auth/$(backendEnvironmentName)/remove",
        Dict{String,Any}("resourceName" => resourceName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_backend_auth(
    appId,
    backendEnvironmentName,
    resourceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifybackend(
        "POST",
        "/backend/$(appId)/auth/$(backendEnvironmentName)/remove",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceName" => resourceName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_backend_storage(app_id, backend_environment_name, resource_name, service_name)
    delete_backend_storage(app_id, backend_environment_name, resource_name, service_name, params::Dict{String,<:Any})

Removes the specified backend storage resource.

# Arguments
- `app_id`: The app ID.
- `backend_environment_name`: The name of the backend environment.
- `resource_name`: The name of the storage resource.
- `service_name`: The name of the storage service.

"""
function delete_backend_storage(
    appId,
    backendEnvironmentName,
    resourceName,
    serviceName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifybackend(
        "POST",
        "/backend/$(appId)/storage/$(backendEnvironmentName)/remove",
        Dict{String,Any}("resourceName" => resourceName, "serviceName" => serviceName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_backend_storage(
    appId,
    backendEnvironmentName,
    resourceName,
    serviceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifybackend(
        "POST",
        "/backend/$(appId)/storage/$(backendEnvironmentName)/remove",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "resourceName" => resourceName, "serviceName" => serviceName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_token(app_id, session_id)
    delete_token(app_id, session_id, params::Dict{String,<:Any})

Deletes the challenge token based on the given appId and sessionId.

# Arguments
- `app_id`: The app ID.
- `session_id`: The session ID.

"""
function delete_token(appId, sessionId; aws_config::AbstractAWSConfig=current_aws_config())
    return amplifybackend(
        "POST",
        "/backend/$(appId)/challenge/$(sessionId)/remove";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_token(
    appId,
    sessionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifybackend(
        "POST",
        "/backend/$(appId)/challenge/$(sessionId)/remove",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    generate_backend_apimodels(app_id, backend_environment_name, resource_name)
    generate_backend_apimodels(app_id, backend_environment_name, resource_name, params::Dict{String,<:Any})

Generates a model schema for an existing backend API resource.

# Arguments
- `app_id`: The app ID.
- `backend_environment_name`: The name of the backend environment.
- `resource_name`: The name of this resource.

"""
function generate_backend_apimodels(
    appId,
    backendEnvironmentName,
    resourceName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifybackend(
        "POST",
        "/backend/$(appId)/api/$(backendEnvironmentName)/generateModels",
        Dict{String,Any}("resourceName" => resourceName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function generate_backend_apimodels(
    appId,
    backendEnvironmentName,
    resourceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifybackend(
        "POST",
        "/backend/$(appId)/api/$(backendEnvironmentName)/generateModels",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceName" => resourceName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_backend(app_id)
    get_backend(app_id, params::Dict{String,<:Any})

Provides project-level details for your Amplify UI project.

# Arguments
- `app_id`: The app ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"backendEnvironmentName"`: The name of the backend environment.
"""
function get_backend(appId; aws_config::AbstractAWSConfig=current_aws_config())
    return amplifybackend(
        "POST",
        "/backend/$(appId)/details";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_backend(
    appId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplifybackend(
        "POST",
        "/backend/$(appId)/details",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_backend_api(app_id, backend_environment_name, resource_name)
    get_backend_api(app_id, backend_environment_name, resource_name, params::Dict{String,<:Any})

Gets the details for a backend API.

# Arguments
- `app_id`: The app ID.
- `backend_environment_name`: The name of the backend environment.
- `resource_name`: The name of this resource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"resourceConfig"`: Defines the resource configuration for the data model in your Amplify
  project.
"""
function get_backend_api(
    appId,
    backendEnvironmentName,
    resourceName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifybackend(
        "POST",
        "/backend/$(appId)/api/$(backendEnvironmentName)/details",
        Dict{String,Any}("resourceName" => resourceName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_backend_api(
    appId,
    backendEnvironmentName,
    resourceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifybackend(
        "POST",
        "/backend/$(appId)/api/$(backendEnvironmentName)/details",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceName" => resourceName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_backend_apimodels(app_id, backend_environment_name, resource_name)
    get_backend_apimodels(app_id, backend_environment_name, resource_name, params::Dict{String,<:Any})

Gets a model introspection schema for an existing backend API resource.

# Arguments
- `app_id`: The app ID.
- `backend_environment_name`: The name of the backend environment.
- `resource_name`: The name of this resource.

"""
function get_backend_apimodels(
    appId,
    backendEnvironmentName,
    resourceName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifybackend(
        "POST",
        "/backend/$(appId)/api/$(backendEnvironmentName)/getModels",
        Dict{String,Any}("resourceName" => resourceName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_backend_apimodels(
    appId,
    backendEnvironmentName,
    resourceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifybackend(
        "POST",
        "/backend/$(appId)/api/$(backendEnvironmentName)/getModels",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceName" => resourceName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_backend_auth(app_id, backend_environment_name, resource_name)
    get_backend_auth(app_id, backend_environment_name, resource_name, params::Dict{String,<:Any})

Gets a backend auth details.

# Arguments
- `app_id`: The app ID.
- `backend_environment_name`: The name of the backend environment.
- `resource_name`: The name of this resource.

"""
function get_backend_auth(
    appId,
    backendEnvironmentName,
    resourceName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifybackend(
        "POST",
        "/backend/$(appId)/auth/$(backendEnvironmentName)/details",
        Dict{String,Any}("resourceName" => resourceName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_backend_auth(
    appId,
    backendEnvironmentName,
    resourceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifybackend(
        "POST",
        "/backend/$(appId)/auth/$(backendEnvironmentName)/details",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceName" => resourceName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_backend_job(app_id, backend_environment_name, job_id)
    get_backend_job(app_id, backend_environment_name, job_id, params::Dict{String,<:Any})

Returns information about a specific job.

# Arguments
- `app_id`: The app ID.
- `backend_environment_name`: The name of the backend environment.
- `job_id`: The ID for the job.

"""
function get_backend_job(
    appId, backendEnvironmentName, jobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplifybackend(
        "GET",
        "/backend/$(appId)/job/$(backendEnvironmentName)/$(jobId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_backend_job(
    appId,
    backendEnvironmentName,
    jobId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifybackend(
        "GET",
        "/backend/$(appId)/job/$(backendEnvironmentName)/$(jobId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_backend_storage(app_id, backend_environment_name, resource_name)
    get_backend_storage(app_id, backend_environment_name, resource_name, params::Dict{String,<:Any})

Gets details for a backend storage resource.

# Arguments
- `app_id`: The app ID.
- `backend_environment_name`: The name of the backend environment.
- `resource_name`: The name of the storage resource.

"""
function get_backend_storage(
    appId,
    backendEnvironmentName,
    resourceName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifybackend(
        "POST",
        "/backend/$(appId)/storage/$(backendEnvironmentName)/details",
        Dict{String,Any}("resourceName" => resourceName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_backend_storage(
    appId,
    backendEnvironmentName,
    resourceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifybackend(
        "POST",
        "/backend/$(appId)/storage/$(backendEnvironmentName)/details",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceName" => resourceName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_token(app_id, session_id)
    get_token(app_id, session_id, params::Dict{String,<:Any})

Gets the challenge token based on the given appId and sessionId.

# Arguments
- `app_id`: The app ID.
- `session_id`: The session ID.

"""
function get_token(appId, sessionId; aws_config::AbstractAWSConfig=current_aws_config())
    return amplifybackend(
        "GET",
        "/backend/$(appId)/challenge/$(sessionId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_token(
    appId,
    sessionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifybackend(
        "GET",
        "/backend/$(appId)/challenge/$(sessionId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    import_backend_auth(app_id, backend_environment_name, native_client_id, user_pool_id, web_client_id)
    import_backend_auth(app_id, backend_environment_name, native_client_id, user_pool_id, web_client_id, params::Dict{String,<:Any})

Imports an existing backend authentication resource.

# Arguments
- `app_id`: The app ID.
- `backend_environment_name`: The name of the backend environment.
- `native_client_id`: The ID of the Amazon Cognito native client.
- `user_pool_id`: The ID of the Amazon Cognito user pool.
- `web_client_id`: The ID of the Amazon Cognito web client.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"identityPoolId"`: The ID of the Amazon Cognito identity pool.
"""
function import_backend_auth(
    appId,
    backendEnvironmentName,
    nativeClientId,
    userPoolId,
    webClientId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifybackend(
        "POST",
        "/backend/$(appId)/auth/$(backendEnvironmentName)/import",
        Dict{String,Any}(
            "nativeClientId" => nativeClientId,
            "userPoolId" => userPoolId,
            "webClientId" => webClientId,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function import_backend_auth(
    appId,
    backendEnvironmentName,
    nativeClientId,
    userPoolId,
    webClientId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifybackend(
        "POST",
        "/backend/$(appId)/auth/$(backendEnvironmentName)/import",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "nativeClientId" => nativeClientId,
                    "userPoolId" => userPoolId,
                    "webClientId" => webClientId,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    import_backend_storage(app_id, backend_environment_name, service_name)
    import_backend_storage(app_id, backend_environment_name, service_name, params::Dict{String,<:Any})

Imports an existing backend storage resource.

# Arguments
- `app_id`: The app ID.
- `backend_environment_name`: The name of the backend environment.
- `service_name`: The name of the storage service.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"bucketName"`: The name of the S3 bucket.
"""
function import_backend_storage(
    appId,
    backendEnvironmentName,
    serviceName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifybackend(
        "POST",
        "/backend/$(appId)/storage/$(backendEnvironmentName)/import",
        Dict{String,Any}("serviceName" => serviceName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function import_backend_storage(
    appId,
    backendEnvironmentName,
    serviceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifybackend(
        "POST",
        "/backend/$(appId)/storage/$(backendEnvironmentName)/import",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("serviceName" => serviceName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_backend_jobs(app_id, backend_environment_name)
    list_backend_jobs(app_id, backend_environment_name, params::Dict{String,<:Any})

Lists the jobs for the backend of an Amplify app.

# Arguments
- `app_id`: The app ID.
- `backend_environment_name`: The name of the backend environment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"jobId"`: The ID for the job.
- `"maxResults"`: The maximum number of results that you want in the response.
- `"nextToken"`: The token for the next set of results.
- `"operation"`: Filters the list of response objects to include only those with the
  specified operation name.
- `"status"`: Filters the list of response objects to include only those with the specified
  status.
"""
function list_backend_jobs(
    appId, backendEnvironmentName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplifybackend(
        "POST",
        "/backend/$(appId)/job/$(backendEnvironmentName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_backend_jobs(
    appId,
    backendEnvironmentName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifybackend(
        "POST",
        "/backend/$(appId)/job/$(backendEnvironmentName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_s3_buckets()
    list_s3_buckets(params::Dict{String,<:Any})

The list of S3 buckets in your account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: Reserved for future use.
"""
function list_s3_buckets(; aws_config::AbstractAWSConfig=current_aws_config())
    return amplifybackend(
        "POST", "/s3Buckets"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_s3_buckets(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplifybackend(
        "POST", "/s3Buckets", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    remove_all_backends(app_id)
    remove_all_backends(app_id, params::Dict{String,<:Any})

Removes all backend environments from your Amplify project.

# Arguments
- `app_id`: The app ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"cleanAmplifyApp"`: Cleans up the Amplify Console app if this value is set to true.
"""
function remove_all_backends(appId; aws_config::AbstractAWSConfig=current_aws_config())
    return amplifybackend(
        "POST",
        "/backend/$(appId)/remove";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_all_backends(
    appId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplifybackend(
        "POST",
        "/backend/$(appId)/remove",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_backend_config(app_id)
    remove_backend_config(app_id, params::Dict{String,<:Any})

Removes the AWS resources required to access the Amplify Admin UI.

# Arguments
- `app_id`: The app ID.

"""
function remove_backend_config(appId; aws_config::AbstractAWSConfig=current_aws_config())
    return amplifybackend(
        "POST",
        "/backend/$(appId)/config/remove";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_backend_config(
    appId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplifybackend(
        "POST",
        "/backend/$(appId)/config/remove",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_backend_api(app_id, backend_environment_name, resource_name)
    update_backend_api(app_id, backend_environment_name, resource_name, params::Dict{String,<:Any})

Updates an existing backend API resource.

# Arguments
- `app_id`: The app ID.
- `backend_environment_name`: The name of the backend environment.
- `resource_name`: The name of this resource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"resourceConfig"`: Defines the resource configuration for the data model in your Amplify
  project.
"""
function update_backend_api(
    appId,
    backendEnvironmentName,
    resourceName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifybackend(
        "POST",
        "/backend/$(appId)/api/$(backendEnvironmentName)",
        Dict{String,Any}("resourceName" => resourceName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_backend_api(
    appId,
    backendEnvironmentName,
    resourceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifybackend(
        "POST",
        "/backend/$(appId)/api/$(backendEnvironmentName)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("resourceName" => resourceName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_backend_auth(app_id, backend_environment_name, resource_config, resource_name)
    update_backend_auth(app_id, backend_environment_name, resource_config, resource_name, params::Dict{String,<:Any})

Updates an existing backend authentication resource.

# Arguments
- `app_id`: The app ID.
- `backend_environment_name`: The name of the backend environment.
- `resource_config`: The resource configuration for this request object.
- `resource_name`: The name of this resource.

"""
function update_backend_auth(
    appId,
    backendEnvironmentName,
    resourceConfig,
    resourceName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifybackend(
        "POST",
        "/backend/$(appId)/auth/$(backendEnvironmentName)",
        Dict{String,Any}(
            "resourceConfig" => resourceConfig, "resourceName" => resourceName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_backend_auth(
    appId,
    backendEnvironmentName,
    resourceConfig,
    resourceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifybackend(
        "POST",
        "/backend/$(appId)/auth/$(backendEnvironmentName)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "resourceConfig" => resourceConfig, "resourceName" => resourceName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_backend_config(app_id)
    update_backend_config(app_id, params::Dict{String,<:Any})

Updates the AWS resources required to access the Amplify Admin UI.

# Arguments
- `app_id`: The app ID.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"loginAuthConfig"`: Describes the Amazon Cognito configuration for Admin UI access.
"""
function update_backend_config(appId; aws_config::AbstractAWSConfig=current_aws_config())
    return amplifybackend(
        "POST",
        "/backend/$(appId)/config/update";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_backend_config(
    appId, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplifybackend(
        "POST",
        "/backend/$(appId)/config/update",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_backend_job(app_id, backend_environment_name, job_id)
    update_backend_job(app_id, backend_environment_name, job_id, params::Dict{String,<:Any})

Updates a specific job.

# Arguments
- `app_id`: The app ID.
- `backend_environment_name`: The name of the backend environment.
- `job_id`: The ID for the job.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"operation"`: Filters the list of response objects to include only those with the
  specified operation name.
- `"status"`: Filters the list of response objects to include only those with the specified
  status.
"""
function update_backend_job(
    appId, backendEnvironmentName, jobId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplifybackend(
        "POST",
        "/backend/$(appId)/job/$(backendEnvironmentName)/$(jobId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_backend_job(
    appId,
    backendEnvironmentName,
    jobId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifybackend(
        "POST",
        "/backend/$(appId)/job/$(backendEnvironmentName)/$(jobId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_backend_storage(app_id, backend_environment_name, resource_config, resource_name)
    update_backend_storage(app_id, backend_environment_name, resource_config, resource_name, params::Dict{String,<:Any})

Updates an existing backend storage resource.

# Arguments
- `app_id`: The app ID.
- `backend_environment_name`: The name of the backend environment.
- `resource_config`: The resource configuration for updating backend storage.
- `resource_name`: The name of the storage resource.

"""
function update_backend_storage(
    appId,
    backendEnvironmentName,
    resourceConfig,
    resourceName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifybackend(
        "POST",
        "/backend/$(appId)/storage/$(backendEnvironmentName)",
        Dict{String,Any}(
            "resourceConfig" => resourceConfig, "resourceName" => resourceName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_backend_storage(
    appId,
    backendEnvironmentName,
    resourceConfig,
    resourceName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifybackend(
        "POST",
        "/backend/$(appId)/storage/$(backendEnvironmentName)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "resourceConfig" => resourceConfig, "resourceName" => resourceName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: evidently
using AWS.Compat
using AWS.UUIDs

"""
    batch_evaluate_feature(project, requests)
    batch_evaluate_feature(project, requests, params::Dict{String,<:Any})

This operation assigns feature variation to user sessions. For each user session, you pass
in an entityID that represents the user. Evidently then checks the evaluation rules and
assigns the variation. The first rules that are evaluated are the override rules. If the
user's entityID matches an override rule, the user is served the variation specified by
that rule. Next, if there is a launch of the feature, the user might be assigned to a
variation in the launch. The chance of this depends on the percentage of users that are
allocated to that launch. If the user is enrolled in the launch, the variation they are
served depends on the allocation of the various feature variations used for the launch. If
the user is not assigned to a launch, and there is an ongoing experiment for this feature,
the user might be assigned to a variation in the experiment. The chance of this depends on
the percentage of users that are allocated to that experiment. If the user is enrolled in
the experiment, the variation they are served depends on the allocation of the various
feature variations used for the experiment.  If the user is not assigned to a launch or
experiment, they are served the default variation.

# Arguments
- `project`: The name or ARN of the project that contains the feature being evaluated.
- `requests`: An array of structures, where each structure assigns a feature variation to
  one user session.

"""
function batch_evaluate_feature(
    project, requests; aws_config::AbstractAWSConfig=current_aws_config()
)
    return evidently(
        "POST",
        "/projects/$(project)/evaluations",
        Dict{String,Any}("requests" => requests);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_evaluate_feature(
    project,
    requests,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return evidently(
        "POST",
        "/projects/$(project)/evaluations",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("requests" => requests), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_experiment(metric_goals, name, project, treatments)
    create_experiment(metric_goals, name, project, treatments, params::Dict{String,<:Any})

Creates an Evidently experiment. Before you create an experiment, you must create the
feature to use for the experiment. An experiment helps you make feature design decisions
based on evidence and data. An experiment can test as many as five variations at once.
Evidently collects experiment data and analyzes it by statistical methods, and provides
clear recommendations about which variations perform better. You can optionally specify a
segment to have the experiment consider only certain audience types in the experiment, such
as using only user sessions from a certain location or who use a certain internet browser.
Don't use this operation to update an existing experiment. Instead, use UpdateExperiment.

# Arguments
- `metric_goals`: An array of structures that defines the metrics used for the experiment,
  and whether a higher or lower value for each metric is the goal.
- `name`: A name for the new experiment.
- `project`: The name or ARN of the project that you want to create the new experiment in.
- `treatments`: An array of structures that describe the configuration of each feature
  variation used in the experiment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: An optional description of the experiment.
- `"onlineAbConfig"`: A structure that contains the configuration of which variation to use
  as the \"control\" version. tThe \"control\" version is used for comparison with other
  variations. This structure also specifies how much experiment traffic is allocated to each
  variation.
- `"randomizationSalt"`: When Evidently assigns a particular user session to an experiment,
  it must use a randomization ID to determine which variation the user session is served.
  This randomization ID is a combination of the entity ID and randomizationSalt. If you omit
  randomizationSalt, Evidently uses the experiment name as the randomizationSalt.
- `"samplingRate"`: The portion of the available audience that you want to allocate to this
  experiment, in thousandths of a percent. The available audience is the total audience minus
  the audience that you have allocated to overrides or current launches of this feature. This
  is represented in thousandths of a percent. For example, specify 10,000 to allocate 10% of
  the available audience.
- `"segment"`: Specifies an audience segment to use in the experiment. When a segment is
  used in an experiment, only user sessions that match the segment pattern are used in the
  experiment.
- `"tags"`: Assigns one or more tags (key-value pairs) to the experiment. Tags can help you
  organize and categorize your resources. You can also use them to scope user permissions by
  granting a user permission to access or change only resources with certain tag values. Tags
  don't have any semantic meaning to Amazon Web Services and are interpreted strictly as
  strings of characters. You can associate as many as 50 tags with an experiment. For more
  information, see Tagging Amazon Web Services resources.
"""
function create_experiment(
    metricGoals,
    name,
    project,
    treatments;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return evidently(
        "POST",
        "/projects/$(project)/experiments",
        Dict{String,Any}(
            "metricGoals" => metricGoals, "name" => name, "treatments" => treatments
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_experiment(
    metricGoals,
    name,
    project,
    treatments,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return evidently(
        "POST",
        "/projects/$(project)/experiments",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "metricGoals" => metricGoals, "name" => name, "treatments" => treatments
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_feature(name, project, variations)
    create_feature(name, project, variations, params::Dict{String,<:Any})

Creates an Evidently feature that you want to launch or test. You can define up to five
variations of a feature, and use these variations in your launches and experiments. A
feature must be created in a project. For information about creating a project, see
CreateProject. Don't use this operation to update an existing feature. Instead, use
UpdateFeature.

# Arguments
- `name`: The name for the new feature.
- `project`: The name or ARN of the project that is to contain the new feature.
- `variations`: An array of structures that contain the configuration of the feature's
  different variations.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"defaultVariation"`: The name of the variation to use as the default variation. The
  default variation is served to users who are not allocated to any ongoing launches or
  experiments of this feature. This variation must also be listed in the variations
  structure. If you omit defaultVariation, the first variation listed in the variations
  structure is used as the default variation.
- `"description"`: An optional description of the feature.
- `"entityOverrides"`: Specify users that should always be served a specific variation of a
  feature. Each user is specified by a key-value pair . For each key, specify a user by
  entering their user ID, account ID, or some other identifier. For the value, specify the
  name of the variation that they are to be served. This parameter is limited to 2500
  overrides or a total of 40KB. The 40KB limit includes an overhead of 6 bytes per override.
- `"evaluationStrategy"`: Specify ALL_RULES to activate the traffic allocation specified by
  any ongoing launches or experiments. Specify DEFAULT_VARIATION to serve the default
  variation to all users instead.
- `"tags"`: Assigns one or more tags (key-value pairs) to the feature. Tags can help you
  organize and categorize your resources. You can also use them to scope user permissions by
  granting a user permission to access or change only resources with certain tag values. Tags
  don't have any semantic meaning to Amazon Web Services and are interpreted strictly as
  strings of characters. You can associate as many as 50 tags with a feature. For more
  information, see Tagging Amazon Web Services resources.
"""
function create_feature(
    name, project, variations; aws_config::AbstractAWSConfig=current_aws_config()
)
    return evidently(
        "POST",
        "/projects/$(project)/features",
        Dict{String,Any}("name" => name, "variations" => variations);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_feature(
    name,
    project,
    variations,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return evidently(
        "POST",
        "/projects/$(project)/features",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("name" => name, "variations" => variations), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_launch(groups, name, project)
    create_launch(groups, name, project, params::Dict{String,<:Any})

Creates a launch of a given feature. Before you create a launch, you must create the
feature to use for the launch. You can use a launch to safely validate new features by
serving them to a specified percentage of your users while you roll out the feature. You
can monitor the performance of the new feature to help you decide when to ramp up traffic
to more users. This helps you reduce risk and identify unintended consequences before you
fully launch the feature. Don't use this operation to update an existing launch. Instead,
use UpdateLaunch.

# Arguments
- `groups`: An array of structures that contains the feature and variations that are to be
  used for the launch.
- `name`: The name for the new launch.
- `project`: The name or ARN of the project that you want to create the launch in.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: An optional description for the launch.
- `"metricMonitors"`: An array of structures that define the metrics that will be used to
  monitor the launch performance.
- `"randomizationSalt"`: When Evidently assigns a particular user session to a launch, it
  must use a randomization ID to determine which variation the user session is served. This
  randomization ID is a combination of the entity ID and randomizationSalt. If you omit
  randomizationSalt, Evidently uses the launch name as the randomizationSalt.
- `"scheduledSplitsConfig"`: An array of structures that define the traffic allocation
  percentages among the feature variations during each step of the launch.
- `"tags"`: Assigns one or more tags (key-value pairs) to the launch. Tags can help you
  organize and categorize your resources. You can also use them to scope user permissions by
  granting a user permission to access or change only resources with certain tag values. Tags
  don't have any semantic meaning to Amazon Web Services and are interpreted strictly as
  strings of characters. You can associate as many as 50 tags with a launch. For more
  information, see Tagging Amazon Web Services resources.
"""
function create_launch(
    groups, name, project; aws_config::AbstractAWSConfig=current_aws_config()
)
    return evidently(
        "POST",
        "/projects/$(project)/launches",
        Dict{String,Any}("groups" => groups, "name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_launch(
    groups,
    name,
    project,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return evidently(
        "POST",
        "/projects/$(project)/launches",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("groups" => groups, "name" => name), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_project(name)
    create_project(name, params::Dict{String,<:Any})

Creates a project, which is the logical object in Evidently that can contain features,
launches, and experiments. Use projects to group similar features together. To update an
existing project, use UpdateProject.

# Arguments
- `name`: The name for the project.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"appConfigResource"`: Use this parameter if the project will use client-side evaluation
  powered by AppConfig. Client-side evaluation allows your application to assign variations
  to user sessions locally instead of by calling the EvaluateFeature operation. This
  mitigates the latency and availability risks that come with an API call. For more
  information, see  Client-side evaluation - powered by AppConfig.  This parameter is a
  structure that contains information about the AppConfig application and environment that
  will be used as for client-side evaluation. To create a project that uses client-side
  evaluation, you must have the evidently:ExportProjectAsConfiguration permission.
- `"dataDelivery"`: A structure that contains information about where Evidently is to store
  evaluation events for longer term storage, if you choose to do so. If you choose not to
  store these events, Evidently deletes them after using them to produce metrics and other
  experiment results that you can view.
- `"description"`: An optional description of the project.
- `"tags"`: Assigns one or more tags (key-value pairs) to the project. Tags can help you
  organize and categorize your resources. You can also use them to scope user permissions by
  granting a user permission to access or change only resources with certain tag values. Tags
  don't have any semantic meaning to Amazon Web Services and are interpreted strictly as
  strings of characters. You can associate as many as 50 tags with a project. For more
  information, see Tagging Amazon Web Services resources.
"""
function create_project(name; aws_config::AbstractAWSConfig=current_aws_config())
    return evidently(
        "POST",
        "/projects",
        Dict{String,Any}("name" => name);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_project(
    name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return evidently(
        "POST",
        "/projects",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("name" => name), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_segment(name, pattern)
    create_segment(name, pattern, params::Dict{String,<:Any})

Use this operation to define a segment of your audience. A segment is a portion of your
audience that share one or more characteristics. Examples could be Chrome browser users,
users in Europe, or Firefox browser users in Europe who also fit other criteria that your
application collects, such as age. Using a segment in an experiment limits that experiment
to evaluate only the users who match the segment criteria. Using one or more segments in a
launch allows you to define different traffic splits for the different audience segments.
For more information about segment pattern syntax, see  Segment rule pattern syntax. The
pattern that you define for a segment is matched against the value of evaluationContext,
which is passed into Evidently in the EvaluateFeature operation, when Evidently assigns a
feature variation to a user.

# Arguments
- `name`: A name for the segment.
- `pattern`: The pattern to use for the segment. For more information about pattern syntax,
  see  Segment rule pattern syntax.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: An optional description for this segment.
- `"tags"`: Assigns one or more tags (key-value pairs) to the segment. Tags can help you
  organize and categorize your resources. You can also use them to scope user permissions by
  granting a user permission to access or change only resources with certain tag values. Tags
  don't have any semantic meaning to Amazon Web Services and are interpreted strictly as
  strings of characters. You can associate as many as 50 tags with a segment. For more
  information, see Tagging Amazon Web Services resources.
"""
function create_segment(name, pattern; aws_config::AbstractAWSConfig=current_aws_config())
    return evidently(
        "POST",
        "/segments",
        Dict{String,Any}("name" => name, "pattern" => pattern);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_segment(
    name,
    pattern,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return evidently(
        "POST",
        "/segments",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("name" => name, "pattern" => pattern), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_experiment(experiment, project)
    delete_experiment(experiment, project, params::Dict{String,<:Any})

Deletes an Evidently experiment. The feature used for the experiment is not deleted. To
stop an experiment without deleting it, use StopExperiment.

# Arguments
- `experiment`: The name of the experiment to delete.
- `project`: The name or ARN of the project that contains the experiment to delete.

"""
function delete_experiment(
    experiment, project; aws_config::AbstractAWSConfig=current_aws_config()
)
    return evidently(
        "DELETE",
        "/projects/$(project)/experiments/$(experiment)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_experiment(
    experiment,
    project,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return evidently(
        "DELETE",
        "/projects/$(project)/experiments/$(experiment)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_feature(feature, project)
    delete_feature(feature, project, params::Dict{String,<:Any})

Deletes an Evidently feature.

# Arguments
- `feature`: The name of the feature to delete.
- `project`: The name or ARN of the project that contains the feature to delete.

"""
function delete_feature(
    feature, project; aws_config::AbstractAWSConfig=current_aws_config()
)
    return evidently(
        "DELETE",
        "/projects/$(project)/features/$(feature)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_feature(
    feature,
    project,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return evidently(
        "DELETE",
        "/projects/$(project)/features/$(feature)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_launch(launch, project)
    delete_launch(launch, project, params::Dict{String,<:Any})

Deletes an Evidently launch. The feature used for the launch is not deleted. To stop a
launch without deleting it, use StopLaunch.

# Arguments
- `launch`: The name of the launch to delete.
- `project`: The name or ARN of the project that contains the launch to delete.

"""
function delete_launch(launch, project; aws_config::AbstractAWSConfig=current_aws_config())
    return evidently(
        "DELETE",
        "/projects/$(project)/launches/$(launch)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_launch(
    launch,
    project,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return evidently(
        "DELETE",
        "/projects/$(project)/launches/$(launch)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_project(project)
    delete_project(project, params::Dict{String,<:Any})

Deletes an Evidently project. Before you can delete a project, you must delete all the
features that the project contains. To delete a feature, use DeleteFeature.

# Arguments
- `project`: The name or ARN of the project to delete.

"""
function delete_project(project; aws_config::AbstractAWSConfig=current_aws_config())
    return evidently(
        "DELETE",
        "/projects/$(project)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_project(
    project,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return evidently(
        "DELETE",
        "/projects/$(project)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_segment(segment)
    delete_segment(segment, params::Dict{String,<:Any})

Deletes a segment. You can't delete a segment that is being used in a launch or experiment,
even if that launch or experiment is not currently running.

# Arguments
- `segment`: Specifies the segment to delete.

"""
function delete_segment(segment; aws_config::AbstractAWSConfig=current_aws_config())
    return evidently(
        "DELETE",
        "/segments/$(segment)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_segment(
    segment,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return evidently(
        "DELETE",
        "/segments/$(segment)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    evaluate_feature(entity_id, feature, project)
    evaluate_feature(entity_id, feature, project, params::Dict{String,<:Any})

This operation assigns a feature variation to one given user session. You pass in an
entityID that represents the user. Evidently then checks the evaluation rules and assigns
the variation. The first rules that are evaluated are the override rules. If the user's
entityID matches an override rule, the user is served the variation specified by that rule.
If there is a current launch with this feature that uses segment overrides, and if the user
session's evaluationContext matches a segment rule defined in a segment override, the
configuration in the segment overrides is used. For more information about segments, see
CreateSegment and Use segments to focus your audience. If there is a launch with no segment
overrides, the user might be assigned to a variation in the launch. The chance of this
depends on the percentage of users that are allocated to that launch. If the user is
enrolled in the launch, the variation they are served depends on the allocation of the
various feature variations used for the launch. If the user is not assigned to a launch,
and there is an ongoing experiment for this feature, the user might be assigned to a
variation in the experiment. The chance of this depends on the percentage of users that are
allocated to that experiment. If the experiment uses a segment, then only user sessions
with evaluationContext values that match the segment rule are used in the experiment. If
the user is enrolled in the experiment, the variation they are served depends on the
allocation of the various feature variations used for the experiment.  If the user is not
assigned to a launch or experiment, they are served the default variation.

# Arguments
- `entity_id`: An internal ID that represents a unique user of the application. This
  entityID is checked against any override rules assigned for this feature.
- `feature`: The name of the feature being evaluated.
- `project`: The name or ARN of the project that contains this feature.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"evaluationContext"`: A JSON object of attributes that you can optionally pass in as
  part of the evaluation event sent to Evidently from the user session. Evidently can use
  this value to match user sessions with defined audience segments. For more information, see
  Use segments to focus your audience. If you include this parameter, the value must be a
  JSON object. A JSON array is not supported.
"""
function evaluate_feature(
    entityId, feature, project; aws_config::AbstractAWSConfig=current_aws_config()
)
    return evidently(
        "POST",
        "/projects/$(project)/evaluations/$(feature)",
        Dict{String,Any}("entityId" => entityId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function evaluate_feature(
    entityId,
    feature,
    project,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return evidently(
        "POST",
        "/projects/$(project)/evaluations/$(feature)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("entityId" => entityId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_experiment(experiment, project)
    get_experiment(experiment, project, params::Dict{String,<:Any})

Returns the details about one experiment. You must already know the experiment name. To
retrieve a list of experiments in your account, use ListExperiments.

# Arguments
- `experiment`: The name of the experiment that you want to see the details of.
- `project`: The name or ARN of the project that contains the experiment.

"""
function get_experiment(
    experiment, project; aws_config::AbstractAWSConfig=current_aws_config()
)
    return evidently(
        "GET",
        "/projects/$(project)/experiments/$(experiment)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_experiment(
    experiment,
    project,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return evidently(
        "GET",
        "/projects/$(project)/experiments/$(experiment)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_experiment_results(experiment, metric_names, project, treatment_names)
    get_experiment_results(experiment, metric_names, project, treatment_names, params::Dict{String,<:Any})

Retrieves the results of a running or completed experiment. No results are available until
there have been 100 events for each variation and at least 10 minutes have passed since the
start of the experiment. To increase the statistical power, Evidently performs an
additional offline p-value analysis at the end of the experiment. Offline p-value analysis
can detect statistical significance in some cases where the anytime p-values used during
the experiment do not find statistical significance. Experiment results are available up to
63 days after the start of the experiment. They are not available after that because of
CloudWatch data retention policies.

# Arguments
- `experiment`: The name of the experiment to retrieve the results of.
- `metric_names`: The names of the experiment metrics that you want to see the results of.
- `project`: The name or ARN of the project that contains the experiment that you want to
  see the results of.
- `treatment_names`: The names of the experiment treatments that you want to see the
  results for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"baseStat"`: The statistic used to calculate experiment results. Currently the only
  valid value is mean, which uses the mean of the collected values as the statistic.
- `"endTime"`: The date and time that the experiment ended, if it is completed. This must
  be no longer than 30 days after the experiment start time.
- `"period"`: In seconds, the amount of time to aggregate results together.
- `"reportNames"`: The names of the report types that you want to see. Currently,
  BayesianInference is the only valid value.
- `"resultStats"`: The statistics that you want to see in the returned results.    PValue
  specifies to use p-values for the results. A p-value is used in hypothesis testing to
  measure how often you are willing to make a mistake in rejecting the null hypothesis. A
  general practice is to reject the null hypothesis and declare that the results are
  statistically significant when the p-value is less than 0.05.    ConfidenceInterval
  specifies a confidence interval for the results. The confidence interval represents the
  range of values for the chosen metric that is likely to contain the true difference between
  the baseStat of a variation and the baseline. Evidently returns the 95% confidence
  interval.     TreatmentEffect is the difference in the statistic specified by the baseStat
  parameter between each variation and the default variation.     BaseStat returns the
  statistical values collected for the metric for each variation. The statistic uses the same
  statistic specified in the baseStat parameter. Therefore, if baseStat is mean, this returns
  the mean of the values collected for each variation.
- `"startTime"`: The date and time that the experiment started.
"""
function get_experiment_results(
    experiment,
    metricNames,
    project,
    treatmentNames;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return evidently(
        "POST",
        "/projects/$(project)/experiments/$(experiment)/results",
        Dict{String,Any}("metricNames" => metricNames, "treatmentNames" => treatmentNames);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_experiment_results(
    experiment,
    metricNames,
    project,
    treatmentNames,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return evidently(
        "POST",
        "/projects/$(project)/experiments/$(experiment)/results",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "metricNames" => metricNames, "treatmentNames" => treatmentNames
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_feature(feature, project)
    get_feature(feature, project, params::Dict{String,<:Any})

Returns the details about one feature. You must already know the feature name. To retrieve
a list of features in your account, use ListFeatures.

# Arguments
- `feature`: The name of the feature that you want to retrieve information for.
- `project`: The name or ARN of the project that contains the feature.

"""
function get_feature(feature, project; aws_config::AbstractAWSConfig=current_aws_config())
    return evidently(
        "GET",
        "/projects/$(project)/features/$(feature)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_feature(
    feature,
    project,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return evidently(
        "GET",
        "/projects/$(project)/features/$(feature)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_launch(launch, project)
    get_launch(launch, project, params::Dict{String,<:Any})

Returns the details about one launch. You must already know the launch name. To retrieve a
list of launches in your account, use ListLaunches.

# Arguments
- `launch`: The name of the launch that you want to see the details of.
- `project`: The name or ARN of the project that contains the launch.

"""
function get_launch(launch, project; aws_config::AbstractAWSConfig=current_aws_config())
    return evidently(
        "GET",
        "/projects/$(project)/launches/$(launch)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_launch(
    launch,
    project,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return evidently(
        "GET",
        "/projects/$(project)/launches/$(launch)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_project(project)
    get_project(project, params::Dict{String,<:Any})

Returns the details about one launch. You must already know the project name. To retrieve a
list of projects in your account, use ListProjects.

# Arguments
- `project`: The name or ARN of the project that you want to see the details of.

"""
function get_project(project; aws_config::AbstractAWSConfig=current_aws_config())
    return evidently(
        "GET",
        "/projects/$(project)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_project(
    project,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return evidently(
        "GET",
        "/projects/$(project)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_segment(segment)
    get_segment(segment, params::Dict{String,<:Any})

Returns information about the specified segment. Specify the segment you want to view by
specifying its ARN.

# Arguments
- `segment`: The ARN of the segment to return information for.

"""
function get_segment(segment; aws_config::AbstractAWSConfig=current_aws_config())
    return evidently(
        "GET",
        "/segments/$(segment)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_segment(
    segment,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return evidently(
        "GET",
        "/segments/$(segment)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_experiments(project)
    list_experiments(project, params::Dict{String,<:Any})

Returns configuration details about all the experiments in the specified project.

# Arguments
- `project`: The name or ARN of the project to return the experiment list from.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to include in the response.
- `"nextToken"`: The token to use when requesting the next set of results. You received
  this token from a previous ListExperiments operation.
- `"status"`: Use this optional parameter to limit the returned results to only the
  experiments with the status that you specify here.
"""
function list_experiments(project; aws_config::AbstractAWSConfig=current_aws_config())
    return evidently(
        "GET",
        "/projects/$(project)/experiments";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_experiments(
    project,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return evidently(
        "GET",
        "/projects/$(project)/experiments",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_features(project)
    list_features(project, params::Dict{String,<:Any})

Returns configuration details about all the features in the specified project.

# Arguments
- `project`: The name or ARN of the project to return the feature list from.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to include in the response.
- `"nextToken"`: The token to use when requesting the next set of results. You received
  this token from a previous ListFeatures operation.
"""
function list_features(project; aws_config::AbstractAWSConfig=current_aws_config())
    return evidently(
        "GET",
        "/projects/$(project)/features";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_features(
    project,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return evidently(
        "GET",
        "/projects/$(project)/features",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_launches(project)
    list_launches(project, params::Dict{String,<:Any})

Returns configuration details about all the launches in the specified project.

# Arguments
- `project`: The name or ARN of the project to return the launch list from.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to include in the response.
- `"nextToken"`: The token to use when requesting the next set of results. You received
  this token from a previous ListLaunches operation.
- `"status"`: Use this optional parameter to limit the returned results to only the
  launches with the status that you specify here.
"""
function list_launches(project; aws_config::AbstractAWSConfig=current_aws_config())
    return evidently(
        "GET",
        "/projects/$(project)/launches";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_launches(
    project,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return evidently(
        "GET",
        "/projects/$(project)/launches",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_projects()
    list_projects(params::Dict{String,<:Any})

Returns configuration details about all the projects in the current Region in your account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to include in the response.
- `"nextToken"`: The token to use when requesting the next set of results. You received
  this token from a previous ListProjects operation.
"""
function list_projects(; aws_config::AbstractAWSConfig=current_aws_config())
    return evidently(
        "GET", "/projects"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_projects(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return evidently(
        "GET", "/projects", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_segment_references(segment, type)
    list_segment_references(segment, type, params::Dict{String,<:Any})

Use this operation to find which experiments or launches are using a specified segment.

# Arguments
- `segment`: The ARN of the segment that you want to view information for.
- `type`: Specifies whether to return information about launches or experiments that use
  this segment.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to include in the response. If you omit
  this, the default of 50 is used.
- `"nextToken"`: The token to use when requesting the next set of results. You received
  this token from a previous ListSegmentReferences operation.
"""
function list_segment_references(
    segment, type; aws_config::AbstractAWSConfig=current_aws_config()
)
    return evidently(
        "GET",
        "/segments/$(segment)/references",
        Dict{String,Any}("type" => type);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_segment_references(
    segment,
    type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return evidently(
        "GET",
        "/segments/$(segment)/references",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("type" => type), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_segments()
    list_segments(params::Dict{String,<:Any})

Returns a list of audience segments that you have created in your account in this Region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to include in the response. If you omit
  this, the default of 50 is used.
- `"nextToken"`: The token to use when requesting the next set of results. You received
  this token from a previous ListSegments operation.
"""
function list_segments(; aws_config::AbstractAWSConfig=current_aws_config())
    return evidently(
        "GET", "/segments"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_segments(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return evidently(
        "GET", "/segments", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Displays the tags associated with an Evidently resource.

# Arguments
- `resource_arn`: The ARN of the resource that you want to see the tags of.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return evidently(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return evidently(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_project_events(events, project)
    put_project_events(events, project, params::Dict{String,<:Any})

Sends performance events to Evidently. These events can be used to evaluate a launch or an
experiment.

# Arguments
- `events`: An array of event structures that contain the performance data that is being
  sent to Evidently.
- `project`: The name or ARN of the project to write the events to.

"""
function put_project_events(
    events, project; aws_config::AbstractAWSConfig=current_aws_config()
)
    return evidently(
        "POST",
        "/events/projects/$(project)",
        Dict{String,Any}("events" => events);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_project_events(
    events,
    project,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return evidently(
        "POST",
        "/events/projects/$(project)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("events" => events), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_experiment(analysis_complete_time, experiment, project)
    start_experiment(analysis_complete_time, experiment, project, params::Dict{String,<:Any})

Starts an existing experiment. To create an experiment, use CreateExperiment.

# Arguments
- `analysis_complete_time`: The date and time to end the experiment. This must be no more
  than 30 days after the experiment starts.
- `experiment`: The name of the experiment to start.
- `project`: The name or ARN of the project that contains the experiment to start.

"""
function start_experiment(
    analysisCompleteTime,
    experiment,
    project;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return evidently(
        "POST",
        "/projects/$(project)/experiments/$(experiment)/start",
        Dict{String,Any}("analysisCompleteTime" => analysisCompleteTime);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_experiment(
    analysisCompleteTime,
    experiment,
    project,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return evidently(
        "POST",
        "/projects/$(project)/experiments/$(experiment)/start",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("analysisCompleteTime" => analysisCompleteTime),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_launch(launch, project)
    start_launch(launch, project, params::Dict{String,<:Any})

Starts an existing launch. To create a launch, use CreateLaunch.

# Arguments
- `launch`: The name of the launch to start.
- `project`: The name or ARN of the project that contains the launch to start.

"""
function start_launch(launch, project; aws_config::AbstractAWSConfig=current_aws_config())
    return evidently(
        "POST",
        "/projects/$(project)/launches/$(launch)/start";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_launch(
    launch,
    project,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return evidently(
        "POST",
        "/projects/$(project)/launches/$(launch)/start",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_experiment(experiment, project)
    stop_experiment(experiment, project, params::Dict{String,<:Any})

Stops an experiment that is currently running. If you stop an experiment, you can't resume
it or restart it.

# Arguments
- `experiment`: The name of the experiment to stop.
- `project`: The name or ARN of the project that contains the experiment to stop.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"desiredState"`: Specify whether the experiment is to be considered COMPLETED or
  CANCELLED after it stops.
- `"reason"`: A string that describes why you are stopping the experiment.
"""
function stop_experiment(
    experiment, project; aws_config::AbstractAWSConfig=current_aws_config()
)
    return evidently(
        "POST",
        "/projects/$(project)/experiments/$(experiment)/cancel";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_experiment(
    experiment,
    project,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return evidently(
        "POST",
        "/projects/$(project)/experiments/$(experiment)/cancel",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_launch(launch, project)
    stop_launch(launch, project, params::Dict{String,<:Any})

Stops a launch that is currently running. After you stop a launch, you will not be able to
resume it or restart it. Also, it will not be evaluated as a rule for traffic allocation,
and the traffic that was allocated to the launch will instead be available to the feature's
experiment, if there is one. Otherwise, all traffic will be served the default variation
after the launch is stopped.

# Arguments
- `launch`: The name of the launch to stop.
- `project`: The name or ARN of the project that contains the launch that you want to stop.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"desiredState"`: Specify whether to consider the launch as COMPLETED or CANCELLED after
  it stops.
- `"reason"`: A string that describes why you are stopping the launch.
"""
function stop_launch(launch, project; aws_config::AbstractAWSConfig=current_aws_config())
    return evidently(
        "POST",
        "/projects/$(project)/launches/$(launch)/cancel";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_launch(
    launch,
    project,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return evidently(
        "POST",
        "/projects/$(project)/launches/$(launch)/cancel",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Assigns one or more tags (key-value pairs) to the specified CloudWatch Evidently resource.
Projects, features, launches, and experiments can be tagged. Tags can help you organize and
categorize your resources. You can also use them to scope user permissions by granting a
user permission to access or change only resources with certain tag values. Tags don't have
any semantic meaning to Amazon Web Services and are interpreted strictly as strings of
characters. You can use the TagResource action with a resource that already has tags. If
you specify a new tag key for the resource, this tag is appended to the list of tags
associated with the alarm. If you specify a tag key that is already associated with the
resource, the new tag value that you specify replaces the previous value for that tag. You
can associate as many as 50 tags with a resource. For more information, see Tagging Amazon
Web Services resources.

# Arguments
- `resource_arn`: The ARN of the CloudWatch Evidently resource that you're adding tags to.
- `tags`: The list of key-value pairs to associate with the resource.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return evidently(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return evidently(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    test_segment_pattern(pattern, payload)
    test_segment_pattern(pattern, payload, params::Dict{String,<:Any})

Use this operation to test a rules pattern that you plan to use to create an audience
segment. For more information about segments, see CreateSegment.

# Arguments
- `pattern`: The pattern to test.
- `payload`: A sample evaluationContext JSON block to test against the specified pattern.

"""
function test_segment_pattern(
    pattern, payload; aws_config::AbstractAWSConfig=current_aws_config()
)
    return evidently(
        "POST",
        "/test-segment-pattern",
        Dict{String,Any}("pattern" => pattern, "payload" => payload);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function test_segment_pattern(
    pattern,
    payload,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return evidently(
        "POST",
        "/test-segment-pattern",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("pattern" => pattern, "payload" => payload), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes one or more tags from the specified resource.

# Arguments
- `resource_arn`: The ARN of the CloudWatch Evidently resource that you're removing tags
  from.
- `tag_keys`: The list of tag keys to remove from the resource.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return evidently(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return evidently(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_experiment(experiment, project)
    update_experiment(experiment, project, params::Dict{String,<:Any})

Updates an Evidently experiment.  Don't use this operation to update an experiment's tag.
Instead, use TagResource.

# Arguments
- `experiment`: The name of the experiment to update.
- `project`: The name or ARN of the project that contains the experiment that you want to
  update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: An optional description of the experiment.
- `"metricGoals"`: An array of structures that defines the metrics used for the experiment,
  and whether a higher or lower value for each metric is the goal.
- `"onlineAbConfig"`: A structure that contains the configuration of which variation o use
  as the \"control\" version. The \"control\" version is used for comparison with other
  variations. This structure also specifies how much experiment traffic is allocated to each
  variation.
- `"randomizationSalt"`: When Evidently assigns a particular user session to an experiment,
  it must use a randomization ID to determine which variation the user session is served.
  This randomization ID is a combination of the entity ID and randomizationSalt. If you omit
  randomizationSalt, Evidently uses the experiment name as the randomizationSalt.
- `"removeSegment"`: Removes a segment from being used in an experiment. You can't use this
  parameter if the experiment is currently running.
- `"samplingRate"`: The portion of the available audience that you want to allocate to this
  experiment, in thousandths of a percent. The available audience is the total audience minus
  the audience that you have allocated to overrides or current launches of this feature. This
  is represented in thousandths of a percent. For example, specify 20,000 to allocate 20% of
  the available audience.
- `"segment"`: Adds an audience segment to an experiment. When a segment is used in an
  experiment, only user sessions that match the segment pattern are used in the experiment.
  You can't use this parameter if the experiment is currently running.
- `"treatments"`: An array of structures that define the variations being tested in the
  experiment.
"""
function update_experiment(
    experiment, project; aws_config::AbstractAWSConfig=current_aws_config()
)
    return evidently(
        "PATCH",
        "/projects/$(project)/experiments/$(experiment)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_experiment(
    experiment,
    project,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return evidently(
        "PATCH",
        "/projects/$(project)/experiments/$(experiment)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_feature(feature, project)
    update_feature(feature, project, params::Dict{String,<:Any})

Updates an existing feature. You can't use this operation to update the tags of an existing
feature. Instead, use TagResource.

# Arguments
- `feature`: The name of the feature to be updated.
- `project`: The name or ARN of the project that contains the feature to be updated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"addOrUpdateVariations"`: To update variation configurations for this feature, or add
  new ones, specify this structure. In this array, include any variations that you want to
  add or update. If the array includes a variation name that already exists for this feature,
  it is updated. If it includes a new variation name, it is added as a new variation.
- `"defaultVariation"`: The name of the variation to use as the default variation. The
  default variation is served to users who are not allocated to any ongoing launches or
  experiments of this feature.
- `"description"`: An optional description of the feature.
- `"entityOverrides"`: Specified users that should always be served a specific variation of
  a feature. Each user is specified by a key-value pair . For each key, specify a user by
  entering their user ID, account ID, or some other identifier. For the value, specify the
  name of the variation that they are to be served. This parameter is limited to 2500
  overrides or a total of 40KB. The 40KB limit includes an overhead of 6 bytes per override.
- `"evaluationStrategy"`: Specify ALL_RULES to activate the traffic allocation specified by
  any ongoing launches or experiments. Specify DEFAULT_VARIATION to serve the default
  variation to all users instead.
- `"removeVariations"`: Removes a variation from the feature. If the variation you specify
  doesn't exist, then this makes no change and does not report an error. This operation fails
  if you try to remove a variation that is part of an ongoing launch or experiment.
"""
function update_feature(
    feature, project; aws_config::AbstractAWSConfig=current_aws_config()
)
    return evidently(
        "PATCH",
        "/projects/$(project)/features/$(feature)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_feature(
    feature,
    project,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return evidently(
        "PATCH",
        "/projects/$(project)/features/$(feature)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_launch(launch, project)
    update_launch(launch, project, params::Dict{String,<:Any})

Updates a launch of a given feature.  Don't use this operation to update the tags of an
existing launch. Instead, use TagResource.

# Arguments
- `launch`: The name of the launch that is to be updated.
- `project`: The name or ARN of the project that contains the launch that you want to
  update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"description"`: An optional description for the launch.
- `"groups"`: An array of structures that contains the feature and variations that are to
  be used for the launch.
- `"metricMonitors"`: An array of structures that define the metrics that will be used to
  monitor the launch performance.
- `"randomizationSalt"`: When Evidently assigns a particular user session to a launch, it
  must use a randomization ID to determine which variation the user session is served. This
  randomization ID is a combination of the entity ID and randomizationSalt. If you omit
  randomizationSalt, Evidently uses the launch name as the randomizationSalt.
- `"scheduledSplitsConfig"`: An array of structures that define the traffic allocation
  percentages among the feature variations during each step of the launch.
"""
function update_launch(launch, project; aws_config::AbstractAWSConfig=current_aws_config())
    return evidently(
        "PATCH",
        "/projects/$(project)/launches/$(launch)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_launch(
    launch,
    project,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return evidently(
        "PATCH",
        "/projects/$(project)/launches/$(launch)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_project(project)
    update_project(project, params::Dict{String,<:Any})

Updates the description of an existing project. To create a new project, use CreateProject.
Don't use this operation to update the data storage options of a project. Instead, use
UpdateProjectDataDelivery.  Don't use this operation to update the tags of a project.
Instead, use TagResource.

# Arguments
- `project`: The name or ARN of the project to update.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"appConfigResource"`: Use this parameter if the project will use client-side evaluation
  powered by AppConfig. Client-side evaluation allows your application to assign variations
  to user sessions locally instead of by calling the EvaluateFeature operation. This
  mitigates the latency and availability risks that come with an API call. allows you to This
  parameter is a structure that contains information about the AppConfig application that
  will be used for client-side evaluation.
- `"description"`: An optional description of the project.
"""
function update_project(project; aws_config::AbstractAWSConfig=current_aws_config())
    return evidently(
        "PATCH",
        "/projects/$(project)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_project(
    project,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return evidently(
        "PATCH",
        "/projects/$(project)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_project_data_delivery(project)
    update_project_data_delivery(project, params::Dict{String,<:Any})

Updates the data storage options for this project. If you store evaluation events, you an
keep them and analyze them on your own. If you choose not to store evaluation events,
Evidently deletes them after using them to produce metrics and other experiment results
that you can view. You can't specify both cloudWatchLogs and s3Destination in the same
operation.

# Arguments
- `project`: The name or ARN of the project that you want to modify the data storage
  options for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"cloudWatchLogs"`: A structure containing the CloudWatch Logs log group where you want
  to store evaluation events.
- `"s3Destination"`: A structure containing the S3 bucket name and bucket prefix where you
  want to store evaluation events.
"""
function update_project_data_delivery(
    project; aws_config::AbstractAWSConfig=current_aws_config()
)
    return evidently(
        "PATCH",
        "/projects/$(project)/data-delivery";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_project_data_delivery(
    project,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return evidently(
        "PATCH",
        "/projects/$(project)/data-delivery",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: route_53_domains
using AWS.Compat
using AWS.UUIDs

"""
    accept_domain_transfer_from_another_aws_account(domain_name, password)
    accept_domain_transfer_from_another_aws_account(domain_name, password, params::Dict{String,<:Any})

Accepts the transfer of a domain from another Amazon Web Services account to the
currentAmazon Web Services account. You initiate a transfer between Amazon Web Services
accounts using TransferDomainToAnotherAwsAccount. If you use the CLI command at
accept-domain-transfer-from-another-aws-account, use JSON format as input instead of text
because otherwise CLI will throw an error from domain transfer input that includes single
quotes. Use either ListOperations or GetOperationDetail to determine whether the operation
succeeded. GetOperationDetail provides additional information, for example, Domain Transfer
from Aws Account 111122223333 has been cancelled.

# Arguments
- `domain_name`: The name of the domain that was specified when another Amazon Web Services
  account submitted a TransferDomainToAnotherAwsAccount request.
- `password`: The password that was returned by the TransferDomainToAnotherAwsAccount
  request.

"""
function accept_domain_transfer_from_another_aws_account(
    DomainName, Password; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53_domains(
        "AcceptDomainTransferFromAnotherAwsAccount",
        Dict{String,Any}("DomainName" => DomainName, "Password" => Password);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function accept_domain_transfer_from_another_aws_account(
    DomainName,
    Password,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53_domains(
        "AcceptDomainTransferFromAnotherAwsAccount",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DomainName" => DomainName, "Password" => Password),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    associate_delegation_signer_to_domain(domain_name, signing_attributes)
    associate_delegation_signer_to_domain(domain_name, signing_attributes, params::Dict{String,<:Any})

 Creates a delegation signer (DS) record in the registry zone for this domain name. Note
that creating DS record at the registry impacts DNSSEC validation of your DNS records. This
action may render your domain name unavailable on the internet if the steps are completed
in the wrong order, or with incorrect timing. For more information about DNSSEC signing,
see Configuring DNSSEC signing in the Route 53 developer guide.

# Arguments
- `domain_name`: The name of the domain.
- `signing_attributes`: The information about a key, including the algorithm, public
  key-value, and flags.

"""
function associate_delegation_signer_to_domain(
    DomainName, SigningAttributes; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53_domains(
        "AssociateDelegationSignerToDomain",
        Dict{String,Any}(
            "DomainName" => DomainName, "SigningAttributes" => SigningAttributes
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function associate_delegation_signer_to_domain(
    DomainName,
    SigningAttributes,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53_domains(
        "AssociateDelegationSignerToDomain",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DomainName" => DomainName, "SigningAttributes" => SigningAttributes
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    cancel_domain_transfer_to_another_aws_account(domain_name)
    cancel_domain_transfer_to_another_aws_account(domain_name, params::Dict{String,<:Any})

Cancels the transfer of a domain from the current Amazon Web Services account to another
Amazon Web Services account. You initiate a transfer betweenAmazon Web Services accounts
using TransferDomainToAnotherAwsAccount.   You must cancel the transfer before the other
Amazon Web Services account accepts the transfer using
AcceptDomainTransferFromAnotherAwsAccount.  Use either ListOperations or GetOperationDetail
to determine whether the operation succeeded. GetOperationDetail provides additional
information, for example, Domain Transfer from Aws Account 111122223333 has been cancelled.

# Arguments
- `domain_name`: The name of the domain for which you want to cancel the transfer to
  another Amazon Web Services account.

"""
function cancel_domain_transfer_to_another_aws_account(
    DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53_domains(
        "CancelDomainTransferToAnotherAwsAccount",
        Dict{String,Any}("DomainName" => DomainName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function cancel_domain_transfer_to_another_aws_account(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53_domains(
        "CancelDomainTransferToAnotherAwsAccount",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DomainName" => DomainName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    check_domain_availability(domain_name)
    check_domain_availability(domain_name, params::Dict{String,<:Any})

This operation checks the availability of one domain name. Note that if the availability
status of a domain is pending, you must submit another request to determine the
availability of the domain name.

# Arguments
- `domain_name`: The name of the domain that you want to get availability for. The
  top-level domain (TLD), such as .com, must be a TLD that Route 53 supports. For a list of
  supported TLDs, see Domains that You Can Register with Amazon Route 53 in the Amazon Route
  53 Developer Guide. The domain name can contain only the following characters:   Letters a
  through z. Domain names are not case sensitive.   Numbers 0 through 9.   Hyphen (-). You
  can't specify a hyphen at the beginning or end of a label.    Period (.) to separate the
  labels in the name, such as the . in example.com.   Internationalized domain names are not
  supported for some top-level domains. To determine whether the TLD that you want to use
  supports internationalized domain names, see Domains that You Can Register with Amazon
  Route 53. For more information, see Formatting Internationalized Domain Names.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"IdnLangCode"`: Reserved for future use.
"""
function check_domain_availability(
    DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53_domains(
        "CheckDomainAvailability",
        Dict{String,Any}("DomainName" => DomainName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function check_domain_availability(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53_domains(
        "CheckDomainAvailability",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DomainName" => DomainName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    check_domain_transferability(domain_name)
    check_domain_transferability(domain_name, params::Dict{String,<:Any})

Checks whether a domain name can be transferred to Amazon Route 53.

# Arguments
- `domain_name`: The name of the domain that you want to transfer to Route 53. The
  top-level domain (TLD), such as .com, must be a TLD that Route 53 supports. For a list of
  supported TLDs, see Domains that You Can Register with Amazon Route 53 in the Amazon Route
  53 Developer Guide. The domain name can contain only the following characters:   Letters a
  through z. Domain names are not case sensitive.   Numbers 0 through 9.   Hyphen (-). You
  can't specify a hyphen at the beginning or end of a label.    Period (.) to separate the
  labels in the name, such as the . in example.com.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AuthCode"`: If the registrar for the top-level domain (TLD) requires an authorization
  code to transfer the domain, the code that you got from the current registrar for the
  domain.
"""
function check_domain_transferability(
    DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53_domains(
        "CheckDomainTransferability",
        Dict{String,Any}("DomainName" => DomainName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function check_domain_transferability(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53_domains(
        "CheckDomainTransferability",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DomainName" => DomainName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_domain(domain_name)
    delete_domain(domain_name, params::Dict{String,<:Any})

This operation deletes the specified domain. This action is permanent. For more
information, see Deleting a domain name registration. To transfer the domain registration
to another registrar, use the transfer process that’s provided by the registrar to which
you want to transfer the registration. Otherwise, the following apply:   You can’t get a
refund for the cost of a deleted domain registration.   The registry for the top-level
domain might hold the domain name for a brief time before releasing it for other users to
register (varies by registry).    When the registration has been deleted, we'll send you a
confirmation to the registrant contact. The email will come from
noreply@domainnameverification.net or noreply@registrar.amazon.com.

# Arguments
- `domain_name`: Name of the domain to be deleted.

"""
function delete_domain(DomainName; aws_config::AbstractAWSConfig=current_aws_config())
    return route_53_domains(
        "DeleteDomain",
        Dict{String,Any}("DomainName" => DomainName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_domain(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53_domains(
        "DeleteDomain",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DomainName" => DomainName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_tags_for_domain(domain_name, tags_to_delete)
    delete_tags_for_domain(domain_name, tags_to_delete, params::Dict{String,<:Any})

This operation deletes the specified tags for a domain. All tag operations are eventually
consistent; subsequent operations might not immediately represent all issued operations.

# Arguments
- `domain_name`: The domain for which you want to delete one or more tags.
- `tags_to_delete`: A list of tag keys to delete.

"""
function delete_tags_for_domain(
    DomainName, TagsToDelete; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53_domains(
        "DeleteTagsForDomain",
        Dict{String,Any}("DomainName" => DomainName, "TagsToDelete" => TagsToDelete);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_tags_for_domain(
    DomainName,
    TagsToDelete,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53_domains(
        "DeleteTagsForDomain",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DomainName" => DomainName, "TagsToDelete" => TagsToDelete
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disable_domain_auto_renew(domain_name)
    disable_domain_auto_renew(domain_name, params::Dict{String,<:Any})

This operation disables automatic renewal of domain registration for the specified domain.

# Arguments
- `domain_name`: The name of the domain that you want to disable automatic renewal for.

"""
function disable_domain_auto_renew(
    DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53_domains(
        "DisableDomainAutoRenew",
        Dict{String,Any}("DomainName" => DomainName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disable_domain_auto_renew(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53_domains(
        "DisableDomainAutoRenew",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DomainName" => DomainName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disable_domain_transfer_lock(domain_name)
    disable_domain_transfer_lock(domain_name, params::Dict{String,<:Any})

This operation removes the transfer lock on the domain (specifically the
clientTransferProhibited status) to allow domain transfers. We recommend you refrain from
performing this action unless you intend to transfer the domain to a different registrar.
Successful submission returns an operation ID that you can use to track the progress and
completion of the action. If the request is not completed successfully, the domain
registrant will be notified by email.

# Arguments
- `domain_name`: The name of the domain that you want to remove the transfer lock for.

"""
function disable_domain_transfer_lock(
    DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53_domains(
        "DisableDomainTransferLock",
        Dict{String,Any}("DomainName" => DomainName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disable_domain_transfer_lock(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53_domains(
        "DisableDomainTransferLock",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DomainName" => DomainName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disassociate_delegation_signer_from_domain(domain_name, id)
    disassociate_delegation_signer_from_domain(domain_name, id, params::Dict{String,<:Any})

Deletes a delegation signer (DS) record in the registry zone for this domain name.

# Arguments
- `domain_name`: Name of the domain.
- `id`: An internal identification number assigned to each DS record after it’s created.
  You can retrieve it as part of DNSSEC information returned by GetDomainDetail.

"""
function disassociate_delegation_signer_from_domain(
    DomainName, Id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53_domains(
        "DisassociateDelegationSignerFromDomain",
        Dict{String,Any}("DomainName" => DomainName, "Id" => Id);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disassociate_delegation_signer_from_domain(
    DomainName,
    Id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53_domains(
        "DisassociateDelegationSignerFromDomain",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("DomainName" => DomainName, "Id" => Id), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    enable_domain_auto_renew(domain_name)
    enable_domain_auto_renew(domain_name, params::Dict{String,<:Any})

This operation configures Amazon Route 53 to automatically renew the specified domain
before the domain registration expires. The cost of renewing your domain registration is
billed to your Amazon Web Services account. The period during which you can renew a domain
name varies by TLD. For a list of TLDs and their renewal policies, see Domains That You Can
Register with Amazon Route 53 in the Amazon Route 53 Developer Guide. Route 53 requires
that you renew before the end of the renewal period so we can complete processing before
the deadline.

# Arguments
- `domain_name`: The name of the domain that you want to enable automatic renewal for.

"""
function enable_domain_auto_renew(
    DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53_domains(
        "EnableDomainAutoRenew",
        Dict{String,Any}("DomainName" => DomainName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function enable_domain_auto_renew(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53_domains(
        "EnableDomainAutoRenew",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DomainName" => DomainName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    enable_domain_transfer_lock(domain_name)
    enable_domain_transfer_lock(domain_name, params::Dict{String,<:Any})

This operation sets the transfer lock on the domain (specifically the
clientTransferProhibited status) to prevent domain transfers. Successful submission returns
an operation ID that you can use to track the progress and completion of the action. If the
request is not completed successfully, the domain registrant will be notified by email.

# Arguments
- `domain_name`: The name of the domain that you want to set the transfer lock for.

"""
function enable_domain_transfer_lock(
    DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53_domains(
        "EnableDomainTransferLock",
        Dict{String,Any}("DomainName" => DomainName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function enable_domain_transfer_lock(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53_domains(
        "EnableDomainTransferLock",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DomainName" => DomainName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_contact_reachability_status()
    get_contact_reachability_status(params::Dict{String,<:Any})

For operations that require confirmation that the email address for the registrant contact
is valid, such as registering a new domain, this operation returns information about
whether the registrant contact has responded. If you want us to resend the email, use the
ResendContactReachabilityEmail operation.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"domainName"`: The name of the domain for which you want to know whether the registrant
  contact has confirmed that the email address is valid.
"""
function get_contact_reachability_status(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53_domains(
        "GetContactReachabilityStatus";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_contact_reachability_status(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53_domains(
        "GetContactReachabilityStatus",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_domain_detail(domain_name)
    get_domain_detail(domain_name, params::Dict{String,<:Any})

This operation returns detailed information about a specified domain that is associated
with the current Amazon Web Services account. Contact information for the domain is also
returned as part of the output.

# Arguments
- `domain_name`: The name of the domain that you want to get detailed information about.

"""
function get_domain_detail(DomainName; aws_config::AbstractAWSConfig=current_aws_config())
    return route_53_domains(
        "GetDomainDetail",
        Dict{String,Any}("DomainName" => DomainName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_domain_detail(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53_domains(
        "GetDomainDetail",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DomainName" => DomainName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_domain_suggestions(domain_name, only_available, suggestion_count)
    get_domain_suggestions(domain_name, only_available, suggestion_count, params::Dict{String,<:Any})

The GetDomainSuggestions operation returns a list of suggested domain names.

# Arguments
- `domain_name`: A domain name that you want to use as the basis for a list of possible
  domain names. The top-level domain (TLD), such as .com, must be a TLD that Route 53
  supports. For a list of supported TLDs, see Domains that You Can Register with Amazon Route
  53 in the Amazon Route 53 Developer Guide. The domain name can contain only the following
  characters:   Letters a through z. Domain names are not case sensitive.   Numbers 0 through
  9.   Hyphen (-). You can't specify a hyphen at the beginning or end of a label.    Period
  (.) to separate the labels in the name, such as the . in example.com.   Internationalized
  domain names are not supported for some top-level domains. To determine whether the TLD
  that you want to use supports internationalized domain names, see Domains that You Can
  Register with Amazon Route 53.
- `only_available`: If OnlyAvailable is true, Route 53 returns only domain names that are
  available. If OnlyAvailable is false, Route 53 returns domain names without checking
  whether they're available to be registered. To determine whether the domain is available,
  you can call checkDomainAvailability for each suggestion.
- `suggestion_count`: The number of suggested domain names that you want Route 53 to
  return. Specify a value between 1 and 50.

"""
function get_domain_suggestions(
    DomainName,
    OnlyAvailable,
    SuggestionCount;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53_domains(
        "GetDomainSuggestions",
        Dict{String,Any}(
            "DomainName" => DomainName,
            "OnlyAvailable" => OnlyAvailable,
            "SuggestionCount" => SuggestionCount,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_domain_suggestions(
    DomainName,
    OnlyAvailable,
    SuggestionCount,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53_domains(
        "GetDomainSuggestions",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "DomainName" => DomainName,
                    "OnlyAvailable" => OnlyAvailable,
                    "SuggestionCount" => SuggestionCount,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_operation_detail(operation_id)
    get_operation_detail(operation_id, params::Dict{String,<:Any})

This operation returns the current status of an operation that is not completed.

# Arguments
- `operation_id`: The identifier for the operation for which you want to get the status.
  Route 53 returned the identifier in the response to the original request.

"""
function get_operation_detail(
    OperationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53_domains(
        "GetOperationDetail",
        Dict{String,Any}("OperationId" => OperationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_operation_detail(
    OperationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53_domains(
        "GetOperationDetail",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("OperationId" => OperationId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_domains()
    list_domains(params::Dict{String,<:Any})

This operation returns all the domain names registered with Amazon Route 53 for the current
Amazon Web Services account if no filtering conditions are used.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FilterConditions"`: A complex type that contains information about the filters applied
  during the ListDomains request. The filter conditions can include domain name and domain
  expiration.
- `"Marker"`: For an initial request for a list of domains, omit this element. If the
  number of domains that are associated with the current Amazon Web Services account is
  greater than the value that you specified for MaxItems, you can use Marker to return
  additional domains. Get the value of NextPageMarker from the previous response, and submit
  another request that includes the value of NextPageMarker in the Marker element.
  Constraints: The marker must match the value specified in the previous request.
- `"MaxItems"`: Number of domains to be returned. Default: 20
- `"SortCondition"`: A complex type that contains information about the requested ordering
  of domains in the returned list.
"""
function list_domains(; aws_config::AbstractAWSConfig=current_aws_config())
    return route_53_domains(
        "ListDomains"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_domains(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53_domains(
        "ListDomains", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_operations()
    list_operations(params::Dict{String,<:Any})

Returns information about all of the operations that return an operation ID and that have
ever been performed on domains that were registered by the current account.  This command
runs only in the us-east-1 Region.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Marker"`: For an initial request for a list of operations, omit this element. If the
  number of operations that are not yet complete is greater than the value that you specified
  for MaxItems, you can use Marker to return additional operations. Get the value of
  NextPageMarker from the previous response, and submit another request that includes the
  value of NextPageMarker in the Marker element.
- `"MaxItems"`: Number of domains to be returned. Default: 20
- `"SortBy"`:  The sort type for returned values.
- `"SortOrder"`:  The sort order for returned values, either ascending or descending.
- `"Status"`:  The status of the operations.
- `"SubmittedSince"`: An optional parameter that lets you get information about all the
  operations that you submitted after a specified date and time. Specify the date and time in
  Unix time format and Coordinated Universal time (UTC).
- `"Type"`:  An arrays of the domains operation types.
"""
function list_operations(; aws_config::AbstractAWSConfig=current_aws_config())
    return route_53_domains(
        "ListOperations"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_operations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53_domains(
        "ListOperations", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_prices()
    list_prices(params::Dict{String,<:Any})

Lists the following prices for either all the TLDs supported by Route 53, or the specified
TLD:   Registration   Transfer   Owner change   Domain renewal   Domain restoration

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Marker"`: For an initial request for a list of prices, omit this element. If the number
  of prices that are not yet complete is greater than the value that you specified for
  MaxItems, you can use Marker to return additional prices. Get the value of NextPageMarker
  from the previous response, and submit another request that includes the value of
  NextPageMarker in the Marker element.  Used only for all TLDs. If you specify a TLD, don't
  specify a Marker.
- `"MaxItems"`: Number of Prices to be returned. Used only for all TLDs. If you specify a
  TLD, don't specify a MaxItems.
- `"Tld"`: The TLD for which you want to receive the pricing information. For example.
  .net. If a Tld value is not provided, a list of prices for all TLDs supported by Route 53
  is returned.
"""
function list_prices(; aws_config::AbstractAWSConfig=current_aws_config())
    return route_53_domains(
        "ListPrices"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_prices(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53_domains(
        "ListPrices", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_domain(domain_name)
    list_tags_for_domain(domain_name, params::Dict{String,<:Any})

This operation returns all of the tags that are associated with the specified domain. All
tag operations are eventually consistent; subsequent operations might not immediately
represent all issued operations.

# Arguments
- `domain_name`: The domain for which you want to get a list of tags.

"""
function list_tags_for_domain(
    DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53_domains(
        "ListTagsForDomain",
        Dict{String,Any}("DomainName" => DomainName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_domain(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53_domains(
        "ListTagsForDomain",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DomainName" => DomainName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    push_domain(domain_name, target)
    push_domain(domain_name, target, params::Dict{String,<:Any})

 Moves a domain from Amazon Web Services to another registrar.  Supported actions:
Changes the IPS tags of a .uk domain, and pushes it to transit. Transit means that the
domain is ready to be transferred to another registrar.

# Arguments
- `domain_name`:  Name of the domain.
- `target`:  New IPS tag for the domain.

"""
function push_domain(DomainName, Target; aws_config::AbstractAWSConfig=current_aws_config())
    return route_53_domains(
        "PushDomain",
        Dict{String,Any}("DomainName" => DomainName, "Target" => Target);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function push_domain(
    DomainName,
    Target,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53_domains(
        "PushDomain",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DomainName" => DomainName, "Target" => Target),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    register_domain(admin_contact, domain_name, duration_in_years, registrant_contact, tech_contact)
    register_domain(admin_contact, domain_name, duration_in_years, registrant_contact, tech_contact, params::Dict{String,<:Any})

This operation registers a domain. For some top-level domains (TLDs), this operation
requires extra parameters. When you register a domain, Amazon Route 53 does the following:
 Creates a Route 53 hosted zone that has the same name as the domain. Route 53 assigns four
name servers to your hosted zone and automatically updates your domain registration with
the names of these name servers.   Enables auto renew, so your domain registration will
renew automatically each year. We'll notify you in advance of the renewal date so you can
choose whether to renew the registration.   Optionally enables privacy protection, so WHOIS
queries return contact for the registrar or the phrase \"REDACTED FOR PRIVACY\", or \"On
behalf of &lt;domain name&gt; owner.\" If you don't enable privacy protection, WHOIS
queries return the information that you entered for the administrative, registrant, and
technical contacts.  While some domains may allow different privacy settings per contact,
we recommend specifying the same privacy setting for all contacts.    If registration is
successful, returns an operation ID that you can use to track the progress and completion
of the action. If the request is not completed successfully, the domain registrant is
notified by email.   Charges your Amazon Web Services account an amount based on the
top-level domain. For more information, see Amazon Route 53 Pricing.

# Arguments
- `admin_contact`: Provides detailed contact information. For information about the values
  that you specify for each element, see ContactDetail.
- `domain_name`: The domain name that you want to register. The top-level domain (TLD),
  such as .com, must be a TLD that Route 53 supports. For a list of supported TLDs, see
  Domains that You Can Register with Amazon Route 53 in the Amazon Route 53 Developer Guide.
  The domain name can contain only the following characters:   Letters a through z. Domain
  names are not case sensitive.   Numbers 0 through 9.   Hyphen (-). You can't specify a
  hyphen at the beginning or end of a label.    Period (.) to separate the labels in the
  name, such as the . in example.com.   Internationalized domain names are not supported for
  some top-level domains. To determine whether the TLD that you want to use supports
  internationalized domain names, see Domains that You Can Register with Amazon Route 53. For
  more information, see Formatting Internationalized Domain Names.
- `duration_in_years`: The number of years that you want to register the domain for.
  Domains are registered for a minimum of one year. The maximum period depends on the
  top-level domain. For the range of valid values for your domain, see Domains that You Can
  Register with Amazon Route 53 in the Amazon Route 53 Developer Guide. Default: 1
- `registrant_contact`: Provides detailed contact information. For information about the
  values that you specify for each element, see ContactDetail.
- `tech_contact`: Provides detailed contact information. For information about the values
  that you specify for each element, see ContactDetail.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AutoRenew"`: Indicates whether the domain will be automatically renewed (true) or not
  (false). Auto renewal only takes effect after the account is charged. Default: true
- `"BillingContact"`: Provides detailed contact information. For information about the
  values that you specify for each element, see ContactDetail.
- `"IdnLangCode"`: Reserved for future use.
- `"PrivacyProtectAdminContact"`: Whether you want to conceal contact information from
  WHOIS queries. If you specify true, WHOIS (\"who is\") queries return contact information
  either for Amazon Registrar or for our registrar associate, Gandi. If you specify false,
  WHOIS queries return the information that you entered for the admin contact.  You must
  specify the same privacy setting for the administrative, billing, registrant, and technical
  contacts.  Default: true
- `"PrivacyProtectBillingContact"`: Whether you want to conceal contact information from
  WHOIS queries. If you specify true, WHOIS (\"who is\") queries return contact information
  either for Amazon Registrar or for our registrar associate, Gandi. If you specify false,
  WHOIS queries return the information that you entered for the billing contact.  You must
  specify the same privacy setting for the administrative, billing, registrant, and technical
  contacts.
- `"PrivacyProtectRegistrantContact"`: Whether you want to conceal contact information from
  WHOIS queries. If you specify true, WHOIS (\"who is\") queries return contact information
  either for Amazon Registrar or for our registrar associate, Gandi. If you specify false,
  WHOIS queries return the information that you entered for the registrant contact (the
  domain owner).  You must specify the same privacy setting for the administrative, billing,
  registrant, and technical contacts.  Default: true
- `"PrivacyProtectTechContact"`: Whether you want to conceal contact information from WHOIS
  queries. If you specify true, WHOIS (\"who is\") queries return contact information either
  for Amazon Registrar or for our registrar associate, Gandi. If you specify false, WHOIS
  queries return the information that you entered for the technical contact.  You must
  specify the same privacy setting for the administrative, billing, registrant, and technical
  contacts.  Default: true
"""
function register_domain(
    AdminContact,
    DomainName,
    DurationInYears,
    RegistrantContact,
    TechContact;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53_domains(
        "RegisterDomain",
        Dict{String,Any}(
            "AdminContact" => AdminContact,
            "DomainName" => DomainName,
            "DurationInYears" => DurationInYears,
            "RegistrantContact" => RegistrantContact,
            "TechContact" => TechContact,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function register_domain(
    AdminContact,
    DomainName,
    DurationInYears,
    RegistrantContact,
    TechContact,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53_domains(
        "RegisterDomain",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AdminContact" => AdminContact,
                    "DomainName" => DomainName,
                    "DurationInYears" => DurationInYears,
                    "RegistrantContact" => RegistrantContact,
                    "TechContact" => TechContact,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    reject_domain_transfer_from_another_aws_account(domain_name)
    reject_domain_transfer_from_another_aws_account(domain_name, params::Dict{String,<:Any})

Rejects the transfer of a domain from another Amazon Web Services account to the current
Amazon Web Services account. You initiate a transfer betweenAmazon Web Services accounts
using TransferDomainToAnotherAwsAccount.  Use either ListOperations or GetOperationDetail
to determine whether the operation succeeded. GetOperationDetail provides additional
information, for example, Domain Transfer from Aws Account 111122223333 has been cancelled.

# Arguments
- `domain_name`: The name of the domain that was specified when another Amazon Web Services
  account submitted a TransferDomainToAnotherAwsAccount request.

"""
function reject_domain_transfer_from_another_aws_account(
    DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53_domains(
        "RejectDomainTransferFromAnotherAwsAccount",
        Dict{String,Any}("DomainName" => DomainName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function reject_domain_transfer_from_another_aws_account(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53_domains(
        "RejectDomainTransferFromAnotherAwsAccount",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DomainName" => DomainName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    renew_domain(current_expiry_year, domain_name)
    renew_domain(current_expiry_year, domain_name, params::Dict{String,<:Any})

This operation renews a domain for the specified number of years. The cost of renewing your
domain is billed to your Amazon Web Services account. We recommend that you renew your
domain several weeks before the expiration date. Some TLD registries delete domains before
the expiration date if you haven't renewed far enough in advance. For more information
about renewing domain registration, see Renewing Registration for a Domain in the Amazon
Route 53 Developer Guide.

# Arguments
- `current_expiry_year`: The year when the registration for the domain is set to expire.
  This value must match the current expiration date for the domain.
- `domain_name`: The name of the domain that you want to renew.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"DurationInYears"`: The number of years that you want to renew the domain for. The
  maximum number of years depends on the top-level domain. For the range of valid values for
  your domain, see Domains that You Can Register with Amazon Route 53 in the Amazon Route 53
  Developer Guide. Default: 1
"""
function renew_domain(
    CurrentExpiryYear, DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53_domains(
        "RenewDomain",
        Dict{String,Any}(
            "CurrentExpiryYear" => CurrentExpiryYear, "DomainName" => DomainName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function renew_domain(
    CurrentExpiryYear,
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53_domains(
        "RenewDomain",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "CurrentExpiryYear" => CurrentExpiryYear, "DomainName" => DomainName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    resend_contact_reachability_email()
    resend_contact_reachability_email(params::Dict{String,<:Any})

For operations that require confirmation that the email address for the registrant contact
is valid, such as registering a new domain, this operation resends the confirmation email
to the current email address for the registrant contact.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"domainName"`: The name of the domain for which you want Route 53 to resend a
  confirmation email to the registrant contact.
"""
function resend_contact_reachability_email(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53_domains(
        "ResendContactReachabilityEmail";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function resend_contact_reachability_email(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53_domains(
        "ResendContactReachabilityEmail",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    resend_operation_authorization(operation_id)
    resend_operation_authorization(operation_id, params::Dict{String,<:Any})

 Resend the form of authorization email for this operation.

# Arguments
- `operation_id`:  Operation ID.

"""
function resend_operation_authorization(
    OperationId; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53_domains(
        "ResendOperationAuthorization",
        Dict{String,Any}("OperationId" => OperationId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function resend_operation_authorization(
    OperationId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53_domains(
        "ResendOperationAuthorization",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("OperationId" => OperationId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    retrieve_domain_auth_code(domain_name)
    retrieve_domain_auth_code(domain_name, params::Dict{String,<:Any})

This operation returns the authorization code for the domain. To transfer a domain to
another registrar, you provide this value to the new registrar.

# Arguments
- `domain_name`: The name of the domain that you want to get an authorization code for.

"""
function retrieve_domain_auth_code(
    DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53_domains(
        "RetrieveDomainAuthCode",
        Dict{String,Any}("DomainName" => DomainName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function retrieve_domain_auth_code(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53_domains(
        "RetrieveDomainAuthCode",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DomainName" => DomainName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    transfer_domain(admin_contact, domain_name, duration_in_years, registrant_contact, tech_contact)
    transfer_domain(admin_contact, domain_name, duration_in_years, registrant_contact, tech_contact, params::Dict{String,<:Any})

Transfers a domain from another registrar to Amazon Route 53.  For more information about
transferring domains, see the following topics:   For transfer requirements, a detailed
procedure, and information about viewing the status of a domain that you're transferring to
Route 53, see Transferring Registration for a Domain to Amazon Route 53 in the Amazon Route
53 Developer Guide.   For information about how to transfer a domain from one Amazon Web
Services account to another, see TransferDomainToAnotherAwsAccount.    For information
about how to transfer a domain to another domain registrar, see Transferring a Domain from
Amazon Route 53 to Another Registrar in the Amazon Route 53 Developer Guide.    During the
transfer of any country code top-level domains (ccTLDs) to Route 53, except for .cc and
.tv, updates to the owner contact are ignored and the owner contact data from the registry
is used. You can update the owner contact after the transfer is complete. For more
information, see UpdateDomainContact.  If the registrar for your domain is also the DNS
service provider for the domain, we highly recommend that you transfer your DNS service to
Route 53 or to another DNS service provider before you transfer your registration. Some
registrars provide free DNS service when you purchase a domain registration. When you
transfer the registration, the previous registrar will not renew your domain registration
and could end your DNS service at any time.  If the registrar for your domain is also the
DNS service provider for the domain and you don't transfer DNS service to another provider,
your website, email, and the web applications associated with the domain might become
unavailable.  If the transfer is successful, this method returns an operation ID that you
can use to track the progress and completion of the action. If the transfer doesn't
complete successfully, the domain registrant will be notified by email.

# Arguments
- `admin_contact`: Provides detailed contact information.
- `domain_name`: The name of the domain that you want to transfer to Route 53. The
  top-level domain (TLD), such as .com, must be a TLD that Route 53 supports. For a list of
  supported TLDs, see Domains that You Can Register with Amazon Route 53 in the Amazon Route
  53 Developer Guide. The domain name can contain only the following characters:   Letters a
  through z. Domain names are not case sensitive.   Numbers 0 through 9.   Hyphen (-). You
  can't specify a hyphen at the beginning or end of a label.    Period (.) to separate the
  labels in the name, such as the . in example.com.
- `duration_in_years`: The number of years that you want to register the domain for.
  Domains are registered for a minimum of one year. The maximum period depends on the
  top-level domain. Default: 1
- `registrant_contact`: Provides detailed contact information.
- `tech_contact`: Provides detailed contact information.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AuthCode"`: The authorization code for the domain. You get this value from the current
  registrar.
- `"AutoRenew"`: Indicates whether the domain will be automatically renewed (true) or not
  (false). Auto renewal only takes effect after the account is charged. Default: true
- `"BillingContact"`: Provides detailed contact information.
- `"IdnLangCode"`: Reserved for future use.
- `"Nameservers"`: Contains details for the host and glue IP addresses.
- `"PrivacyProtectAdminContact"`: Whether you want to conceal contact information from
  WHOIS queries. If you specify true, WHOIS (\"who is\") queries return contact information
  for the registrar, the phrase \"REDACTED FOR PRIVACY\", or \"On behalf of &lt;domain
  name&gt; owner.\".  While some domains may allow different privacy settings per contact, we
  recommend specifying the same privacy setting for all contacts.  Default: true
- `"PrivacyProtectBillingContact"`:  Whether you want to conceal contact information from
  WHOIS queries. If you specify true, WHOIS (\"who is\") queries return contact information
  either for Amazon Registrar or for our registrar associate, Gandi. If you specify false,
  WHOIS queries return the information that you entered for the billing contact.   You must
  specify the same privacy setting for the administrative, billing, registrant, and technical
  contacts.
- `"PrivacyProtectRegistrantContact"`: Whether you want to conceal contact information from
  WHOIS queries. If you specify true, WHOIS (\"who is\") queries return contact information
  either for Amazon Registrar or for our registrar associate, Gandi. If you specify false,
  WHOIS queries return the information that you entered for the registrant contact (domain
  owner).  You must specify the same privacy setting for the administrative, billing,
  registrant, and technical contacts.  Default: true
- `"PrivacyProtectTechContact"`: Whether you want to conceal contact information from WHOIS
  queries. If you specify true, WHOIS (\"who is\") queries return contact information either
  for Amazon Registrar or for our registrar associate, Gandi. If you specify false, WHOIS
  queries return the information that you entered for the technical contact.  You must
  specify the same privacy setting for the administrative, billing, registrant, and technical
  contacts.  Default: true
"""
function transfer_domain(
    AdminContact,
    DomainName,
    DurationInYears,
    RegistrantContact,
    TechContact;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53_domains(
        "TransferDomain",
        Dict{String,Any}(
            "AdminContact" => AdminContact,
            "DomainName" => DomainName,
            "DurationInYears" => DurationInYears,
            "RegistrantContact" => RegistrantContact,
            "TechContact" => TechContact,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function transfer_domain(
    AdminContact,
    DomainName,
    DurationInYears,
    RegistrantContact,
    TechContact,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53_domains(
        "TransferDomain",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "AdminContact" => AdminContact,
                    "DomainName" => DomainName,
                    "DurationInYears" => DurationInYears,
                    "RegistrantContact" => RegistrantContact,
                    "TechContact" => TechContact,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    transfer_domain_to_another_aws_account(account_id, domain_name)
    transfer_domain_to_another_aws_account(account_id, domain_name, params::Dict{String,<:Any})

Transfers a domain from the current Amazon Web Services account to another Amazon Web
Services account. Note the following:   The Amazon Web Services account that you're
transferring the domain to must accept the transfer. If the other account doesn't accept
the transfer within 3 days, we cancel the transfer. See
AcceptDomainTransferFromAnotherAwsAccount.    You can cancel the transfer before the other
account accepts it. See CancelDomainTransferToAnotherAwsAccount.    The other account can
reject the transfer. See RejectDomainTransferFromAnotherAwsAccount.     When you transfer a
domain from one Amazon Web Services account to another, Route 53 doesn't transfer the
hosted zone that is associated with the domain. DNS resolution isn't affected if the domain
and the hosted zone are owned by separate accounts, so transferring the hosted zone is
optional. For information about transferring the hosted zone to another Amazon Web Services
account, see Migrating a Hosted Zone to a Different Amazon Web Services Account in the
Amazon Route 53 Developer Guide.  Use either ListOperations or GetOperationDetail to
determine whether the operation succeeded. GetOperationDetail provides additional
information, for example, Domain Transfer from Aws Account 111122223333 has been cancelled.

# Arguments
- `account_id`: The account ID of the Amazon Web Services account that you want to transfer
  the domain to, for example, 111122223333.
- `domain_name`: The name of the domain that you want to transfer from the current Amazon
  Web Services account to another account.

"""
function transfer_domain_to_another_aws_account(
    AccountId, DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53_domains(
        "TransferDomainToAnotherAwsAccount",
        Dict{String,Any}("AccountId" => AccountId, "DomainName" => DomainName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function transfer_domain_to_another_aws_account(
    AccountId,
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53_domains(
        "TransferDomainToAnotherAwsAccount",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("AccountId" => AccountId, "DomainName" => DomainName),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_domain_contact(domain_name)
    update_domain_contact(domain_name, params::Dict{String,<:Any})

This operation updates the contact information for a particular domain. You must specify
information for at least one contact: registrant, administrator, or technical. If the
update is successful, this method returns an operation ID that you can use to track the
progress and completion of the operation. If the request is not completed successfully, the
domain registrant will be notified by email.

# Arguments
- `domain_name`: The name of the domain that you want to update contact information for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AdminContact"`: Provides detailed contact information.
- `"BillingContact"`: Provides detailed contact information.
- `"Consent"`:  Customer's consent for the owner change request. Required if the domain is
  not free (consent price is more than 0.00).
- `"RegistrantContact"`: Provides detailed contact information.
- `"TechContact"`: Provides detailed contact information.
"""
function update_domain_contact(
    DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53_domains(
        "UpdateDomainContact",
        Dict{String,Any}("DomainName" => DomainName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_domain_contact(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53_domains(
        "UpdateDomainContact",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DomainName" => DomainName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_domain_contact_privacy(domain_name)
    update_domain_contact_privacy(domain_name, params::Dict{String,<:Any})

This operation updates the specified domain contact's privacy setting. When privacy
protection is enabled, your contact information is replaced with contact information for
the registrar or with the phrase \"REDACTED FOR PRIVACY\", or \"On behalf of &lt;domain
name&gt; owner.\"  While some domains may allow different privacy settings per contact, we
recommend specifying the same privacy setting for all contacts.  This operation affects
only the contact information for the specified contact type (administrative, registrant, or
technical). If the request succeeds, Amazon Route 53 returns an operation ID that you can
use with GetOperationDetail to track the progress and completion of the action. If the
request doesn't complete successfully, the domain registrant will be notified by email.  By
disabling the privacy service via API, you consent to the publication of the contact
information provided for this domain via the public WHOIS database. You certify that you
are the registrant of this domain name and have the authority to make this decision. You
may withdraw your consent at any time by enabling privacy protection using either
UpdateDomainContactPrivacy or the Route 53 console. Enabling privacy protection removes the
contact information provided for this domain from the WHOIS database. For more information
on our privacy practices, see https://aws.amazon.com/privacy/.

# Arguments
- `domain_name`: The name of the domain that you want to update the privacy setting for.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AdminPrivacy"`: Whether you want to conceal contact information from WHOIS queries. If
  you specify true, WHOIS (\"who is\") queries return contact information either for Amazon
  Registrar or for our registrar associate, Gandi. If you specify false, WHOIS queries return
  the information that you entered for the admin contact.  You must specify the same privacy
  setting for the administrative, billing, registrant, and technical contacts.
- `"BillingPrivacy"`:  Whether you want to conceal contact information from WHOIS queries.
  If you specify true, WHOIS (\"who is\") queries return contact information either for
  Amazon Registrar or for our registrar associate, Gandi. If you specify false, WHOIS queries
  return the information that you entered for the billing contact.   You must specify the
  same privacy setting for the administrative, billing, registrant, and technical contacts.
- `"RegistrantPrivacy"`: Whether you want to conceal contact information from WHOIS
  queries. If you specify true, WHOIS (\"who is\") queries return contact information either
  for Amazon Registrar or for our registrar associate, Gandi. If you specify false, WHOIS
  queries return the information that you entered for the registrant contact (domain owner).
  You must specify the same privacy setting for the administrative, billing, registrant, and
  technical contacts.
- `"TechPrivacy"`: Whether you want to conceal contact information from WHOIS queries. If
  you specify true, WHOIS (\"who is\") queries return contact information either for Amazon
  Registrar or for our registrar associate, Gandi. If you specify false, WHOIS queries return
  the information that you entered for the technical contact.  You must specify the same
  privacy setting for the administrative, billing, registrant, and technical contacts.
"""
function update_domain_contact_privacy(
    DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53_domains(
        "UpdateDomainContactPrivacy",
        Dict{String,Any}("DomainName" => DomainName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_domain_contact_privacy(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53_domains(
        "UpdateDomainContactPrivacy",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DomainName" => DomainName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_domain_nameservers(domain_name, nameservers)
    update_domain_nameservers(domain_name, nameservers, params::Dict{String,<:Any})

This operation replaces the current set of name servers for the domain with the specified
set of name servers. If you use Amazon Route 53 as your DNS service, specify the four name
servers in the delegation set for the hosted zone for the domain. If successful, this
operation returns an operation ID that you can use to track the progress and completion of
the action. If the request is not completed successfully, the domain registrant will be
notified by email.

# Arguments
- `domain_name`: The name of the domain that you want to change name servers for.
- `nameservers`: A list of new name servers for the domain.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"FIAuthKey"`: The authorization key for .fi domains
"""
function update_domain_nameservers(
    DomainName, Nameservers; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53_domains(
        "UpdateDomainNameservers",
        Dict{String,Any}("DomainName" => DomainName, "Nameservers" => Nameservers);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_domain_nameservers(
    DomainName,
    Nameservers,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53_domains(
        "UpdateDomainNameservers",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("DomainName" => DomainName, "Nameservers" => Nameservers),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_tags_for_domain(domain_name)
    update_tags_for_domain(domain_name, params::Dict{String,<:Any})

This operation adds or updates tags for a specified domain. All tag operations are
eventually consistent; subsequent operations might not immediately represent all issued
operations.

# Arguments
- `domain_name`: The domain for which you want to add or update tags.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"TagsToUpdate"`: A list of the tag keys and values that you want to add or update. If
  you specify a key that already exists, the corresponding value will be replaced.
"""
function update_tags_for_domain(
    DomainName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53_domains(
        "UpdateTagsForDomain",
        Dict{String,Any}("DomainName" => DomainName);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_tags_for_domain(
    DomainName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return route_53_domains(
        "UpdateTagsForDomain",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("DomainName" => DomainName), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    view_billing()
    view_billing(params::Dict{String,<:Any})

Returns all the domain-related billing records for the current Amazon Web Services account
for a specified period

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"End"`: The end date and time for the time period for which you want a list of billing
  records. Specify the date and time in Unix time format and Coordinated Universal time (UTC).
- `"Marker"`: For an initial request for a list of billing records, omit this element. If
  the number of billing records that are associated with the current Amazon Web Services
  account during the specified period is greater than the value that you specified for
  MaxItems, you can use Marker to return additional billing records. Get the value of
  NextPageMarker from the previous response, and submit another request that includes the
  value of NextPageMarker in the Marker element.  Constraints: The marker must match the
  value of NextPageMarker that was returned in the previous response.
- `"MaxItems"`: The number of billing records to be returned. Default: 20
- `"Start"`: The beginning date and time for the time period for which you want a list of
  billing records. Specify the date and time in Unix time format and Coordinated Universal
  time (UTC).
"""
function view_billing(; aws_config::AbstractAWSConfig=current_aws_config())
    return route_53_domains(
        "ViewBilling"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function view_billing(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return route_53_domains(
        "ViewBilling", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: codeguruprofiler
using AWS.Compat
using AWS.UUIDs

"""
    add_notification_channels(channels, profiling_group_name)
    add_notification_channels(channels, profiling_group_name, params::Dict{String,<:Any})

Add up to 2 anomaly notifications channels for a profiling group.

# Arguments
- `channels`: One or 2 channels to report to when anomalies are detected.
- `profiling_group_name`: The name of the profiling group that we are setting up
  notifications for.

"""
function add_notification_channels(
    channels, profilingGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeguruprofiler(
        "POST",
        "/profilingGroups/$(profilingGroupName)/notificationConfiguration",
        Dict{String,Any}("channels" => channels);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function add_notification_channels(
    channels,
    profilingGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeguruprofiler(
        "POST",
        "/profilingGroups/$(profilingGroupName)/notificationConfiguration",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("channels" => channels), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    batch_get_frame_metric_data(profiling_group_name)
    batch_get_frame_metric_data(profiling_group_name, params::Dict{String,<:Any})

 Returns the time series of values for a requested list of frame metrics from a time period.

# Arguments
- `profiling_group_name`:  The name of the profiling group associated with the the frame
  metrics used to return the time series values.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"endTime"`:  The end time of the time period for the returned time series values. This
  is specified using the ISO 8601 format. For example, 2020-06-01T13:15:02.001Z represents 1
  millisecond past June 1, 2020 1:15:02 PM UTC.
- `"frameMetrics"`:  The details of the metrics that are used to request a time series of
  values. The metric includes the name of the frame, the aggregation type to calculate the
  metric value for the frame, and the thread states to use to get the count for the metric
  value of the frame.
- `"period"`:  The duration of the frame metrics used to return the time series values.
  Specify using the ISO 8601 format. The maximum period duration is one day (PT24H or P1D).
- `"startTime"`:  The start time of the time period for the frame metrics used to return
  the time series values. This is specified using the ISO 8601 format. For example,
  2020-06-01T13:15:02.001Z represents 1 millisecond past June 1, 2020 1:15:02 PM UTC.
- `"targetResolution"`: The requested resolution of time steps for the returned time series
  of values. If the requested target resolution is not available due to data not being
  retained we provide a best effort result by falling back to the most granular available
  resolution after the target resolution. There are 3 valid values.     P1D — 1 day
  PT1H — 1 hour     PT5M — 5 minutes
"""
function batch_get_frame_metric_data(
    profilingGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeguruprofiler(
        "POST",
        "/profilingGroups/$(profilingGroupName)/frames/-/metrics";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function batch_get_frame_metric_data(
    profilingGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeguruprofiler(
        "POST",
        "/profilingGroups/$(profilingGroupName)/frames/-/metrics",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    configure_agent(profiling_group_name)
    configure_agent(profiling_group_name, params::Dict{String,<:Any})

 Used by profiler agents to report their current state and to receive remote configuration
updates. For example, ConfigureAgent can be used to tell an agent whether to profile or not
and for how long to return profiling data.

# Arguments
- `profiling_group_name`:  The name of the profiling group for which the configured agent
  is collecting profiling data.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"fleetInstanceId"`:  A universally unique identifier (UUID) for a profiling instance.
  For example, if the profiling instance is an Amazon EC2 instance, it is the instance ID. If
  it is an AWS Fargate container, it is the container's task ID.
- `"metadata"`:  Metadata captured about the compute platform the agent is running on. It
  includes information about sampling and reporting. The valid fields are:
  COMPUTE_PLATFORM - The compute platform on which the agent is running     AGENT_ID - The ID
  for an agent instance.     AWS_REQUEST_ID - The AWS request ID of a Lambda invocation.
  EXECUTION_ENVIRONMENT - The execution environment a Lambda function is running on.
  LAMBDA_FUNCTION_ARN - The Amazon Resource Name (ARN) that is used to invoke a Lambda
  function.     LAMBDA_MEMORY_LIMIT_IN_MB - The memory allocated to a Lambda function.
  LAMBDA_REMAINING_TIME_IN_MILLISECONDS - The time in milliseconds before execution of a
  Lambda function times out.     LAMBDA_TIME_GAP_BETWEEN_INVOKES_IN_MILLISECONDS - The time
  in milliseconds between two invocations of a Lambda function.
  LAMBDA_PREVIOUS_EXECUTION_TIME_IN_MILLISECONDS - The time in milliseconds for the previous
  Lambda invocation.
"""
function configure_agent(
    profilingGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeguruprofiler(
        "POST",
        "/profilingGroups/$(profilingGroupName)/configureAgent";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function configure_agent(
    profilingGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeguruprofiler(
        "POST",
        "/profilingGroups/$(profilingGroupName)/configureAgent",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_profiling_group(client_token, profiling_group_name)
    create_profiling_group(client_token, profiling_group_name, params::Dict{String,<:Any})

Creates a profiling group.

# Arguments
- `client_token`:  Amazon CodeGuru Profiler uses this universally unique identifier (UUID)
  to prevent the accidental creation of duplicate profiling groups if there are failures and
  retries.
- `profiling_group_name`: The name of the profiling group to create.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"agentOrchestrationConfig"`:  Specifies whether profiling is enabled or disabled for the
  created profiling group.
- `"computePlatform"`:  The compute platform of the profiling group. Use AWSLambda if your
  application runs on AWS Lambda. Use Default if your application runs on a compute platform
  that is not AWS Lambda, such an Amazon EC2 instance, an on-premises server, or a different
  platform. If not specified, Default is used.
- `"tags"`:  A list of tags to add to the created profiling group.
"""
function create_profiling_group(
    clientToken, profilingGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeguruprofiler(
        "POST",
        "/profilingGroups",
        Dict{String,Any}(
            "clientToken" => clientToken, "profilingGroupName" => profilingGroupName
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_profiling_group(
    clientToken,
    profilingGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeguruprofiler(
        "POST",
        "/profilingGroups",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "clientToken" => clientToken, "profilingGroupName" => profilingGroupName
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_profiling_group(profiling_group_name)
    delete_profiling_group(profiling_group_name, params::Dict{String,<:Any})

Deletes a profiling group.

# Arguments
- `profiling_group_name`: The name of the profiling group to delete.

"""
function delete_profiling_group(
    profilingGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeguruprofiler(
        "DELETE",
        "/profilingGroups/$(profilingGroupName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_profiling_group(
    profilingGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeguruprofiler(
        "DELETE",
        "/profilingGroups/$(profilingGroupName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_profiling_group(profiling_group_name)
    describe_profiling_group(profiling_group_name, params::Dict{String,<:Any})

 Returns a  ProfilingGroupDescription  object that contains information about the requested
profiling group.

# Arguments
- `profiling_group_name`:  The name of the profiling group to get information about.

"""
function describe_profiling_group(
    profilingGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeguruprofiler(
        "GET",
        "/profilingGroups/$(profilingGroupName)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function describe_profiling_group(
    profilingGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeguruprofiler(
        "GET",
        "/profilingGroups/$(profilingGroupName)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_findings_report_account_summary()
    get_findings_report_account_summary(params::Dict{String,<:Any})

 Returns a list of  FindingsReportSummary  objects that contain analysis results for all
profiling groups in your AWS account.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"dailyReportsOnly"`: A Boolean value indicating whether to only return reports from
  daily profiles. If set to True, only analysis data from daily profiles is returned. If set
  to False, analysis data is returned from smaller time windows (for example, one hour).
- `"maxResults"`: The maximum number of results returned by
  GetFindingsReportAccountSummary in paginated output. When this parameter is used,
  GetFindingsReportAccountSummary only returns maxResults results in a single page along with
  a nextToken response element. The remaining results of the initial request can be seen by
  sending another GetFindingsReportAccountSummary request with the returned nextToken value.
- `"nextToken"`: The nextToken value returned from a previous paginated
  GetFindingsReportAccountSummary request where maxResults was used and the results exceeded
  the value of that parameter. Pagination continues from the end of the previous results that
  returned the nextToken value.   This token should be treated as an opaque identifier that
  is only used to retrieve the next items in a list and not for other programmatic purposes.
"""
function get_findings_report_account_summary(;
    aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeguruprofiler(
        "GET",
        "/internal/findingsReports";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_findings_report_account_summary(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeguruprofiler(
        "GET",
        "/internal/findingsReports",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_notification_configuration(profiling_group_name)
    get_notification_configuration(profiling_group_name, params::Dict{String,<:Any})

Get the current configuration for anomaly notifications for a profiling group.

# Arguments
- `profiling_group_name`: The name of the profiling group we want to get the notification
  configuration for.

"""
function get_notification_configuration(
    profilingGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeguruprofiler(
        "GET",
        "/profilingGroups/$(profilingGroupName)/notificationConfiguration";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_notification_configuration(
    profilingGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeguruprofiler(
        "GET",
        "/profilingGroups/$(profilingGroupName)/notificationConfiguration",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_policy(profiling_group_name)
    get_policy(profiling_group_name, params::Dict{String,<:Any})

 Returns the JSON-formatted resource-based policy on a profiling group.

# Arguments
- `profiling_group_name`: The name of the profiling group.

"""
function get_policy(profilingGroupName; aws_config::AbstractAWSConfig=current_aws_config())
    return codeguruprofiler(
        "GET",
        "/profilingGroups/$(profilingGroupName)/policy";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_policy(
    profilingGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeguruprofiler(
        "GET",
        "/profilingGroups/$(profilingGroupName)/policy",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_profile(profiling_group_name)
    get_profile(profiling_group_name, params::Dict{String,<:Any})

 Gets the aggregated profile of a profiling group for a specified time range. Amazon
CodeGuru Profiler collects posted agent profiles for a profiling group into aggregated
profiles.   &lt;note&gt; &lt;p&gt; Because aggregated profiles expire over time
&lt;code&gt;GetProfile&lt;/code&gt; is not idempotent. &lt;/p&gt; &lt;/note&gt; &lt;p&gt;
Specify the time range for the requested aggregated profile using 1 or 2 of the following
parameters: &lt;code&gt;startTime&lt;/code&gt;, &lt;code&gt;endTime&lt;/code&gt;,
&lt;code&gt;period&lt;/code&gt;. The maximum time range allowed is 7 days. If you specify
all 3 parameters, an exception is thrown. If you specify only
&lt;code&gt;period&lt;/code&gt;, the latest aggregated profile is returned. &lt;/p&gt;
&lt;p&gt; Aggregated profiles are available with aggregation periods of 5 minutes, 1 hour,
and 1 day, aligned to UTC. The aggregation period of an aggregated profile determines how
long it is retained. For more information, see &lt;a
href=&quot;https://docs.aws.amazon.com/codeguru/latest/profiler-api/API_AggregatedProfileTim
e.html&quot;&gt; &lt;code&gt;AggregatedProfileTime&lt;/code&gt; &lt;/a&gt;. The aggregated
profile's aggregation period determines how long it is retained by CodeGuru Profiler.
&lt;/p&gt; &lt;ul&gt; &lt;li&gt; &lt;p&gt; If the aggregation period is 5 minutes, the
aggregated profile is retained for 15 days. &lt;/p&gt; &lt;/li&gt; &lt;li&gt; &lt;p&gt; If
the aggregation period is 1 hour, the aggregated profile is retained for 60 days.
&lt;/p&gt; &lt;/li&gt; &lt;li&gt; &lt;p&gt; If the aggregation period is 1 day, the
aggregated profile is retained for 3 years. &lt;/p&gt; &lt;/li&gt; &lt;/ul&gt;
&lt;p&gt;There are two use cases for calling &lt;code&gt;GetProfile&lt;/code&gt;.&lt;/p&gt;
&lt;ol&gt; &lt;li&gt; &lt;p&gt; If you want to return an aggregated profile that already
exists, use &lt;a
href=&quot;https://docs.aws.amazon.com/codeguru/latest/profiler-api/API_ListProfileTimes.htm
l&quot;&gt; &lt;code&gt;ListProfileTimes&lt;/code&gt; &lt;/a&gt; to view the time ranges of
existing aggregated profiles. Use them in a &lt;code&gt;GetProfile&lt;/code&gt; request to
return a specific, existing aggregated profile. &lt;/p&gt; &lt;/li&gt; &lt;li&gt; &lt;p&gt;
If you want to return an aggregated profile for a time range that doesn't align with an
existing aggregated profile, then CodeGuru Profiler makes a best effort to combine existing
aggregated profiles from the requested time range and return them as one aggregated
profile. &lt;/p&gt; &lt;p&gt; If aggregated profiles do not exist for the full time range
requested, then aggregated profiles for a smaller time range are returned. For example, if
the requested time range is from 00:00 to 00:20, and the existing aggregated profiles are
from 00:15 and 00:25, then the aggregated profiles from 00:15 to 00:20 are returned.
&lt;/p&gt; &lt;/li&gt; &lt;/ol&gt;

# Arguments
- `profiling_group_name`: The name of the profiling group to get.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Accept"`:  The format of the returned profiling data. The format maps to the Accept and
  Content-Type headers of the HTTP request. You can specify one of the following: or the
  default .   &lt;ul&gt; &lt;li&gt; &lt;p&gt; &lt;code&gt;application/json&lt;/code&gt; —
  standard JSON format &lt;/p&gt; &lt;/li&gt; &lt;li&gt; &lt;p&gt;
  &lt;code&gt;application/x-amzn-ion&lt;/code&gt; — the Amazon Ion data format. For more
  information, see &lt;a href=&quot;http://amzn.github.io/ion-docs/&quot;&gt;Amazon
  Ion&lt;/a&gt;. &lt;/p&gt; &lt;/li&gt; &lt;/ul&gt;
- `"endTime"`:  The end time of the requested profile. Specify using the ISO 8601 format.
  For example, 2020-06-01T13:15:02.001Z represents 1 millisecond past June 1, 2020 1:15:02 PM
  UTC.   If you specify endTime, then you must also specify period or startTime, but not
  both.
- `"maxDepth"`:  The maximum depth of the stacks in the code that is represented in the
  aggregated profile. For example, if CodeGuru Profiler finds a method A, which calls method
  B, which calls method C, which calls method D, then the depth is 4. If the maxDepth is set
  to 2, then the aggregated profile contains representations of methods A and B.
- `"period"`:  Used with startTime or endTime to specify the time range for the returned
  aggregated profile. Specify using the ISO 8601 format. For example, P1DT1H1M1S.   &lt;p&gt;
  To get the latest aggregated profile, specify only &lt;code&gt;period&lt;/code&gt;.
  &lt;/p&gt;
- `"startTime"`: The start time of the profile to get. Specify using the ISO 8601 format.
  For example, 2020-06-01T13:15:02.001Z represents 1 millisecond past June 1, 2020 1:15:02 PM
  UTC.  &lt;p&gt; If you specify &lt;code&gt;startTime&lt;/code&gt;, then you must also
  specify &lt;code&gt;period&lt;/code&gt; or &lt;code&gt;endTime&lt;/code&gt;, but not both.
  &lt;/p&gt;
"""
function get_profile(profilingGroupName; aws_config::AbstractAWSConfig=current_aws_config())
    return codeguruprofiler(
        "GET",
        "/profilingGroups/$(profilingGroupName)/profile";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_profile(
    profilingGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeguruprofiler(
        "GET",
        "/profilingGroups/$(profilingGroupName)/profile",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_recommendations(end_time, profiling_group_name, start_time)
    get_recommendations(end_time, profiling_group_name, start_time, params::Dict{String,<:Any})

 Returns a list of  Recommendation  objects that contain recommendations for a profiling
group for a given time period. A list of  Anomaly  objects that contains details about
anomalies detected in the profiling group for the same time period is also returned.

# Arguments
- `end_time`:  The start time of the profile to get analysis data about. You must specify
  startTime and endTime. This is specified using the ISO 8601 format. For example,
  2020-06-01T13:15:02.001Z represents 1 millisecond past June 1, 2020 1:15:02 PM UTC.
- `profiling_group_name`:  The name of the profiling group to get analysis data about.
- `start_time`:  The end time of the profile to get analysis data about. You must specify
  startTime and endTime. This is specified using the ISO 8601 format. For example,
  2020-06-01T13:15:02.001Z represents 1 millisecond past June 1, 2020 1:15:02 PM UTC.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"locale"`:  The language used to provide analysis. Specify using a string that is one of
  the following BCP 47 language codes.     de-DE - German, Germany     en-GB - English,
  United Kingdom     en-US - English, United States     es-ES - Spanish, Spain     fr-FR -
  French, France     it-IT - Italian, Italy     ja-JP - Japanese, Japan     ko-KR - Korean,
  Republic of Korea     pt-BR - Portugese, Brazil     zh-CN - Chinese, China     zh-TW -
  Chinese, Taiwan
"""
function get_recommendations(
    endTime,
    profilingGroupName,
    startTime;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeguruprofiler(
        "GET",
        "/internal/profilingGroups/$(profilingGroupName)/recommendations",
        Dict{String,Any}("endTime" => endTime, "startTime" => startTime);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_recommendations(
    endTime,
    profilingGroupName,
    startTime,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeguruprofiler(
        "GET",
        "/internal/profilingGroups/$(profilingGroupName)/recommendations",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("endTime" => endTime, "startTime" => startTime),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_findings_reports(end_time, profiling_group_name, start_time)
    list_findings_reports(end_time, profiling_group_name, start_time, params::Dict{String,<:Any})

List the available reports for a given profiling group and time range.

# Arguments
- `end_time`:  The end time of the profile to get analysis data about. You must specify
  startTime and endTime. This is specified using the ISO 8601 format. For example,
  2020-06-01T13:15:02.001Z represents 1 millisecond past June 1, 2020 1:15:02 PM UTC.
- `profiling_group_name`: The name of the profiling group from which to search for analysis
  data.
- `start_time`:  The start time of the profile to get analysis data about. You must specify
  startTime and endTime. This is specified using the ISO 8601 format. For example,
  2020-06-01T13:15:02.001Z represents 1 millisecond past June 1, 2020 1:15:02 PM UTC.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"dailyReportsOnly"`: A Boolean value indicating whether to only return reports from
  daily profiles. If set to True, only analysis data from daily profiles is returned. If set
  to False, analysis data is returned from smaller time windows (for example, one hour).
- `"maxResults"`: The maximum number of report results returned by ListFindingsReports in
  paginated output. When this parameter is used, ListFindingsReports only returns maxResults
  results in a single page along with a nextToken response element. The remaining results of
  the initial request can be seen by sending another ListFindingsReports request with the
  returned nextToken value.
- `"nextToken"`: The nextToken value returned from a previous paginated
  ListFindingsReportsRequest request where maxResults was used and the results exceeded the
  value of that parameter. Pagination continues from the end of the previous results that
  returned the nextToken value.   This token should be treated as an opaque identifier that
  is only used to retrieve the next items in a list and not for other programmatic purposes.
"""
function list_findings_reports(
    endTime,
    profilingGroupName,
    startTime;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeguruprofiler(
        "GET",
        "/internal/profilingGroups/$(profilingGroupName)/findingsReports",
        Dict{String,Any}("endTime" => endTime, "startTime" => startTime);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_findings_reports(
    endTime,
    profilingGroupName,
    startTime,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeguruprofiler(
        "GET",
        "/internal/profilingGroups/$(profilingGroupName)/findingsReports",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("endTime" => endTime, "startTime" => startTime),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_profile_times(end_time, period, profiling_group_name, start_time)
    list_profile_times(end_time, period, profiling_group_name, start_time, params::Dict{String,<:Any})

Lists the start times of the available aggregated profiles of a profiling group for an
aggregation period within the specified time range.

# Arguments
- `end_time`: The end time of the time range from which to list the profiles.
- `period`:  The aggregation period. This specifies the period during which an aggregation
  profile collects posted agent profiles for a profiling group. There are 3 valid values.
  P1D — 1 day     PT1H — 1 hour     PT5M — 5 minutes
- `profiling_group_name`: The name of the profiling group.
- `start_time`: The start time of the time range from which to list the profiles.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of profile time results returned by ListProfileTimes
  in paginated output. When this parameter is used, ListProfileTimes only returns maxResults
  results in a single page with a nextToken response element. The remaining results of the
  initial request can be seen by sending another ListProfileTimes request with the returned
  nextToken value.
- `"nextToken"`: The nextToken value returned from a previous paginated ListProfileTimes
  request where maxResults was used and the results exceeded the value of that parameter.
  Pagination continues from the end of the previous results that returned the nextToken
  value.   This token should be treated as an opaque identifier that is only used to retrieve
  the next items in a list and not for other programmatic purposes.
- `"orderBy"`: The order (ascending or descending by start time of the profile) to use when
  listing profiles. Defaults to TIMESTAMP_DESCENDING.
"""
function list_profile_times(
    endTime,
    period,
    profilingGroupName,
    startTime;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeguruprofiler(
        "GET",
        "/profilingGroups/$(profilingGroupName)/profileTimes",
        Dict{String,Any}(
            "endTime" => endTime, "period" => period, "startTime" => startTime
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_profile_times(
    endTime,
    period,
    profilingGroupName,
    startTime,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeguruprofiler(
        "GET",
        "/profilingGroups/$(profilingGroupName)/profileTimes",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "endTime" => endTime, "period" => period, "startTime" => startTime
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_profiling_groups()
    list_profiling_groups(params::Dict{String,<:Any})

 Returns a list of profiling groups. The profiling groups are returned as
ProfilingGroupDescription  objects.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"includeDescription"`: A Boolean value indicating whether to include a description. If
  true, then a list of  ProfilingGroupDescription  objects that contain detailed information
  about profiling groups is returned. If false, then a list of profiling group names is
  returned.
- `"maxResults"`: The maximum number of profiling groups results returned by
  ListProfilingGroups in paginated output. When this parameter is used, ListProfilingGroups
  only returns maxResults results in a single page along with a nextToken response element.
  The remaining results of the initial request can be seen by sending another
  ListProfilingGroups request with the returned nextToken value.
- `"nextToken"`: The nextToken value returned from a previous paginated ListProfilingGroups
  request where maxResults was used and the results exceeded the value of that parameter.
  Pagination continues from the end of the previous results that returned the nextToken
  value.   This token should be treated as an opaque identifier that is only used to retrieve
  the next items in a list and not for other programmatic purposes.
"""
function list_profiling_groups(; aws_config::AbstractAWSConfig=current_aws_config())
    return codeguruprofiler(
        "GET", "/profilingGroups"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_profiling_groups(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeguruprofiler(
        "GET",
        "/profilingGroups",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

 Returns a list of the tags that are assigned to a specified resource.

# Arguments
- `resource_arn`:  The Amazon Resource Name (ARN) of the resource that contains the tags to
  return.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeguruprofiler(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeguruprofiler(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    post_agent_profile(content-_type, agent_profile, profiling_group_name)
    post_agent_profile(content-_type, agent_profile, profiling_group_name, params::Dict{String,<:Any})

 Submits profiling data to an aggregated profile of a profiling group. To get an aggregated
profile that is created with this profiling data, use  GetProfile .

# Arguments
- `content-_type`:  The format of the submitted profiling data. The format maps to the
  Accept and Content-Type headers of the HTTP request. You can specify one of the following:
  or the default .   &lt;ul&gt; &lt;li&gt; &lt;p&gt;
  &lt;code&gt;application/json&lt;/code&gt; — standard JSON format &lt;/p&gt; &lt;/li&gt;
  &lt;li&gt; &lt;p&gt; &lt;code&gt;application/x-amzn-ion&lt;/code&gt; — the Amazon Ion
  data format. For more information, see &lt;a
  href=&quot;http://amzn.github.io/ion-docs/&quot;&gt;Amazon Ion&lt;/a&gt;. &lt;/p&gt;
  &lt;/li&gt; &lt;/ul&gt;
- `agent_profile`:  The submitted profiling data.
- `profiling_group_name`:  The name of the profiling group with the aggregated profile that
  receives the submitted profiling data.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"profileToken"`:  Amazon CodeGuru Profiler uses this universally unique identifier
  (UUID) to prevent the accidental submission of duplicate profiling data if there are
  failures and retries.
"""
function post_agent_profile(
    Content_Type,
    agentProfile,
    profilingGroupName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeguruprofiler(
        "POST",
        "/profilingGroups/$(profilingGroupName)/agentProfile",
        Dict{String,Any}(
            "agentProfile" => agentProfile,
            "profileToken" => string(uuid4()),
            "headers" => Dict{String,Any}("Content-Type" => Content_Type),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function post_agent_profile(
    Content_Type,
    agentProfile,
    profilingGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeguruprofiler(
        "POST",
        "/profilingGroups/$(profilingGroupName)/agentProfile",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "agentProfile" => agentProfile,
                    "profileToken" => string(uuid4()),
                    "headers" => Dict{String,Any}("Content-Type" => Content_Type),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_permission(action_group, principals, profiling_group_name)
    put_permission(action_group, principals, profiling_group_name, params::Dict{String,<:Any})

 Adds permissions to a profiling group's resource-based policy that are provided using an
action group. If a profiling group doesn't have a resource-based policy, one is created for
it using the permissions in the action group and the roles and users in the principals
parameter.   &lt;p&gt; The one supported action group that can be added is
&lt;code&gt;agentPermission&lt;/code&gt; which grants
&lt;code&gt;ConfigureAgent&lt;/code&gt; and &lt;code&gt;PostAgent&lt;/code&gt; permissions.
For more information, see &lt;a
href=&quot;https://docs.aws.amazon.com/codeguru/latest/profiler-ug/resource-based-policies.h
tml&quot;&gt;Resource-based policies in CodeGuru Profiler&lt;/a&gt; in the &lt;i&gt;Amazon
CodeGuru Profiler User Guide&lt;/i&gt;, &lt;a
href=&quot;https://docs.aws.amazon.com/codeguru/latest/profiler-api/API_ConfigureAgent.html
&quot;&gt; &lt;code&gt;ConfigureAgent&lt;/code&gt; &lt;/a&gt;, and &lt;a
href=&quot;https://docs.aws.amazon.com/codeguru/latest/profiler-api/API_PostAgentProfile.htm
l&quot;&gt; &lt;code&gt;PostAgentProfile&lt;/code&gt; &lt;/a&gt;. &lt;/p&gt; &lt;p&gt; The
first time you call &lt;code&gt;PutPermission&lt;/code&gt; on a profiling group, do not
specify a &lt;code&gt;revisionId&lt;/code&gt; because it doesn't have a resource-based
policy. Subsequent calls must provide a &lt;code&gt;revisionId&lt;/code&gt; to specify
which revision of the resource-based policy to add the permissions to. &lt;/p&gt; &lt;p&gt;
The response contains the profiling group's JSON-formatted resource policy. &lt;/p&gt;

# Arguments
- `action_group`:  Specifies an action group that contains permissions to add to a
  profiling group resource. One action group is supported, agentPermissions, which grants
  permission to perform actions required by the profiling agent, ConfigureAgent and
  PostAgentProfile permissions.
- `principals`:  A list ARNs for the roles and users you want to grant access to the
  profiling group. Wildcards are not are supported in the ARNs.
- `profiling_group_name`: The name of the profiling group to grant access to.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"revisionId"`:  A universally unique identifier (UUID) for the revision of the policy
  you are adding to the profiling group. Do not specify this when you add permissions to a
  profiling group for the first time. If a policy already exists on the profiling group, you
  must specify the revisionId.
"""
function put_permission(
    actionGroup,
    principals,
    profilingGroupName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeguruprofiler(
        "PUT",
        "/profilingGroups/$(profilingGroupName)/policy/$(actionGroup)",
        Dict{String,Any}("principals" => principals);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_permission(
    actionGroup,
    principals,
    profilingGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeguruprofiler(
        "PUT",
        "/profilingGroups/$(profilingGroupName)/policy/$(actionGroup)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("principals" => principals), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_notification_channel(channel_id, profiling_group_name)
    remove_notification_channel(channel_id, profiling_group_name, params::Dict{String,<:Any})

Remove one anomaly notifications channel for a profiling group.

# Arguments
- `channel_id`: The id of the channel that we want to stop receiving notifications.
- `profiling_group_name`: The name of the profiling group we want to change notification
  configuration for.

"""
function remove_notification_channel(
    channelId, profilingGroupName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeguruprofiler(
        "DELETE",
        "/profilingGroups/$(profilingGroupName)/notificationConfiguration/$(channelId)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_notification_channel(
    channelId,
    profilingGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeguruprofiler(
        "DELETE",
        "/profilingGroups/$(profilingGroupName)/notificationConfiguration/$(channelId)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    remove_permission(action_group, profiling_group_name, revision_id)
    remove_permission(action_group, profiling_group_name, revision_id, params::Dict{String,<:Any})

 Removes permissions from a profiling group's resource-based policy that are provided using
an action group. The one supported action group that can be removed is agentPermission
which grants ConfigureAgent and PostAgent permissions. For more information, see
Resource-based policies in CodeGuru Profiler in the Amazon CodeGuru Profiler User Guide,
ConfigureAgent , and  PostAgentProfile .

# Arguments
- `action_group`:  Specifies an action group that contains the permissions to remove from a
  profiling group's resource-based policy. One action group is supported, agentPermissions,
  which grants ConfigureAgent and PostAgentProfile permissions.
- `profiling_group_name`: The name of the profiling group.
- `revision_id`:  A universally unique identifier (UUID) for the revision of the
  resource-based policy from which you want to remove permissions.

"""
function remove_permission(
    actionGroup,
    profilingGroupName,
    revisionId;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeguruprofiler(
        "DELETE",
        "/profilingGroups/$(profilingGroupName)/policy/$(actionGroup)",
        Dict{String,Any}("revisionId" => revisionId);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function remove_permission(
    actionGroup,
    profilingGroupName,
    revisionId,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeguruprofiler(
        "DELETE",
        "/profilingGroups/$(profilingGroupName)/policy/$(actionGroup)",
        Dict{String,Any}(
            mergewith(_merge, Dict{String,Any}("revisionId" => revisionId), params)
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    submit_feedback(anomaly_instance_id, profiling_group_name, type)
    submit_feedback(anomaly_instance_id, profiling_group_name, type, params::Dict{String,<:Any})

Sends feedback to CodeGuru Profiler about whether the anomaly detected by the analysis is
useful or not.

# Arguments
- `anomaly_instance_id`: The universally unique identifier (UUID) of the  AnomalyInstance
  object that is included in the analysis data.
- `profiling_group_name`: The name of the profiling group that is associated with the
  analysis data.
- `type`:  The feedback tpye. Thee are two valid values, Positive and Negative.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"comment"`: Optional feedback about this anomaly.
"""
function submit_feedback(
    anomalyInstanceId,
    profilingGroupName,
    type;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeguruprofiler(
        "POST",
        "/internal/profilingGroups/$(profilingGroupName)/anomalies/$(anomalyInstanceId)/feedback",
        Dict{String,Any}("type" => type);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function submit_feedback(
    anomalyInstanceId,
    profilingGroupName,
    type,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeguruprofiler(
        "POST",
        "/internal/profilingGroups/$(profilingGroupName)/anomalies/$(anomalyInstanceId)/feedback",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("type" => type), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

 Use to assign one or more tags to a resource.

# Arguments
- `resource_arn`:  The Amazon Resource Name (ARN) of the resource that the tags are added
  to.
- `tags`:  The list of tags that are added to the specified resource.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return codeguruprofiler(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeguruprofiler(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

 Use to remove one or more tags from a resource.

# Arguments
- `resource_arn`:  The Amazon Resource Name (ARN) of the resource that contains the tags to
  remove.
- `tag_keys`:  A list of tag keys. Existing tags of resources with keys in this list are
  removed from the specified resource.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return codeguruprofiler(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeguruprofiler(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_profiling_group(agent_orchestration_config, profiling_group_name)
    update_profiling_group(agent_orchestration_config, profiling_group_name, params::Dict{String,<:Any})

Updates a profiling group.

# Arguments
- `agent_orchestration_config`:  Specifies whether profiling is enabled or disabled for a
  profiling group.
- `profiling_group_name`: The name of the profiling group to update.

"""
function update_profiling_group(
    agentOrchestrationConfig,
    profilingGroupName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeguruprofiler(
        "PUT",
        "/profilingGroups/$(profilingGroupName)",
        Dict{String,Any}("agentOrchestrationConfig" => agentOrchestrationConfig);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_profiling_group(
    agentOrchestrationConfig,
    profilingGroupName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return codeguruprofiler(
        "PUT",
        "/profilingGroups/$(profilingGroupName)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("agentOrchestrationConfig" => agentOrchestrationConfig),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: pipes
using AWS.Compat
using AWS.UUIDs

"""
    create_pipe(name, role_arn, source, target)
    create_pipe(name, role_arn, source, target, params::Dict{String,<:Any})

Create a pipe. Amazon EventBridge Pipes connect event sources to targets and reduces the
need for specialized knowledge and integration code.

# Arguments
- `name`: The name of the pipe.
- `role_arn`: The ARN of the role that allows the pipe to send data to the target.
- `source`: The ARN of the source resource.
- `target`: The ARN of the target resource.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description of the pipe.
- `"DesiredState"`: The state the pipe should be in.
- `"Enrichment"`: The ARN of the enrichment resource.
- `"EnrichmentParameters"`: The parameters required to set up enrichment on your pipe.
- `"LogConfiguration"`: The logging configuration settings for the pipe.
- `"SourceParameters"`: The parameters required to set up a source for your pipe.
- `"Tags"`: The list of key-value pairs to associate with the pipe.
- `"TargetParameters"`: The parameters required to set up a target for your pipe. For more
  information about pipe target parameters, including how to use dynamic path parameters, see
  Target parameters in the Amazon EventBridge User Guide.
"""
function create_pipe(
    Name, RoleArn, Source, Target; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pipes(
        "POST",
        "/v1/pipes/$(Name)",
        Dict{String,Any}("RoleArn" => RoleArn, "Source" => Source, "Target" => Target);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_pipe(
    Name,
    RoleArn,
    Source,
    Target,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pipes(
        "POST",
        "/v1/pipes/$(Name)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "RoleArn" => RoleArn, "Source" => Source, "Target" => Target
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_pipe(name)
    delete_pipe(name, params::Dict{String,<:Any})

Delete an existing pipe. For more information about pipes, see Amazon EventBridge Pipes in
the Amazon EventBridge User Guide.

# Arguments
- `name`: The name of the pipe.

"""
function delete_pipe(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return pipes(
        "DELETE",
        "/v1/pipes/$(Name)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_pipe(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pipes(
        "DELETE",
        "/v1/pipes/$(Name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    describe_pipe(name)
    describe_pipe(name, params::Dict{String,<:Any})

Get the information about an existing pipe. For more information about pipes, see Amazon
EventBridge Pipes in the Amazon EventBridge User Guide.

# Arguments
- `name`: The name of the pipe.

"""
function describe_pipe(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return pipes(
        "GET", "/v1/pipes/$(Name)"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function describe_pipe(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pipes(
        "GET",
        "/v1/pipes/$(Name)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_pipes()
    list_pipes(params::Dict{String,<:Any})

Get the pipes associated with this account. For more information about pipes, see Amazon
EventBridge Pipes in the Amazon EventBridge User Guide.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"CurrentState"`: The state the pipe is in.
- `"DesiredState"`: The state the pipe should be in.
- `"Limit"`: The maximum number of pipes to include in the response.
- `"NamePrefix"`: A value that will return a subset of the pipes associated with this
  account. For example, \"NamePrefix\": \"ABC\" will return all endpoints with \"ABC\" in the
  name.
- `"NextToken"`: If nextToken is returned, there are more results available. The value of
  nextToken is a unique pagination token for each page. Make the call again using the
  returned token to retrieve the next page. Keep all other arguments unchanged. Each
  pagination token expires after 24 hours. Using an expired pagination token will return an
  HTTP 400 InvalidToken error.
- `"SourcePrefix"`: The prefix matching the pipe source.
- `"TargetPrefix"`: The prefix matching the pipe target.
"""
function list_pipes(; aws_config::AbstractAWSConfig=current_aws_config())
    return pipes("GET", "/v1/pipes"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET)
end
function list_pipes(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pipes(
        "GET", "/v1/pipes", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Displays the tags associated with a pipe.

# Arguments
- `resource_arn`: The ARN of the pipe for which you want to view tags.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pipes(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pipes(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_pipe(name)
    start_pipe(name, params::Dict{String,<:Any})

Start an existing pipe.

# Arguments
- `name`: The name of the pipe.

"""
function start_pipe(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return pipes(
        "POST",
        "/v1/pipes/$(Name)/start";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_pipe(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pipes(
        "POST",
        "/v1/pipes/$(Name)/start",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    stop_pipe(name)
    stop_pipe(name, params::Dict{String,<:Any})

Stop an existing pipe.

# Arguments
- `name`: The name of the pipe.

"""
function stop_pipe(Name; aws_config::AbstractAWSConfig=current_aws_config())
    return pipes(
        "POST",
        "/v1/pipes/$(Name)/stop";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function stop_pipe(
    Name, params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pipes(
        "POST",
        "/v1/pipes/$(Name)/stop",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Assigns one or more tags (key-value pairs) to the specified pipe. Tags can help you
organize and categorize your resources. You can also use them to scope user permissions by
granting a user permission to access or change only resources with certain tag values. Tags
don't have any semantic meaning to Amazon Web Services and are interpreted strictly as
strings of characters. You can use the TagResource action with a pipe that already has
tags. If you specify a new tag key, this tag is appended to the list of tags associated
with the pipe. If you specify a tag key that is already associated with the pipe, the new
tag value that you specify replaces the previous value for that tag. You can associate as
many as 50 tags with a pipe.

# Arguments
- `resource_arn`: The ARN of the pipe.
- `tags`: The list of key-value pairs associated with the pipe.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return pipes(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pipes(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes one or more tags from the specified pipes.

# Arguments
- `resource_arn`: The ARN of the pipe.
- `tag_keys`: The list of tag keys to remove from the pipe.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return pipes(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pipes(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_pipe(name, role_arn)
    update_pipe(name, role_arn, params::Dict{String,<:Any})

Update an existing pipe. When you call UpdatePipe, EventBridge only the updates fields you
have specified in the request; the rest remain unchanged. The exception to this is if you
modify any Amazon Web Services-service specific fields in the SourceParameters,
EnrichmentParameters, or TargetParameters objects. For example, DynamoDBStreamParameters or
EventBridgeEventBusParameters. EventBridge updates the fields in these objects atomically
as one and overrides existing values. This is by design, and means that if you don't
specify an optional field in one of these Parameters objects, EventBridge sets that field
to its system-default value during the update. For more information about pipes, see
Amazon EventBridge Pipes in the Amazon EventBridge User Guide.

# Arguments
- `name`: The name of the pipe.
- `role_arn`: The ARN of the role that allows the pipe to send data to the target.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"Description"`: A description of the pipe.
- `"DesiredState"`: The state the pipe should be in.
- `"Enrichment"`: The ARN of the enrichment resource.
- `"EnrichmentParameters"`: The parameters required to set up enrichment on your pipe.
- `"LogConfiguration"`: The logging configuration settings for the pipe.
- `"SourceParameters"`: The parameters required to set up a source for your pipe.
- `"Target"`: The ARN of the target resource.
- `"TargetParameters"`: The parameters required to set up a target for your pipe. For more
  information about pipe target parameters, including how to use dynamic path parameters, see
  Target parameters in the Amazon EventBridge User Guide.
"""
function update_pipe(Name, RoleArn; aws_config::AbstractAWSConfig=current_aws_config())
    return pipes(
        "PUT",
        "/v1/pipes/$(Name)",
        Dict{String,Any}("RoleArn" => RoleArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_pipe(
    Name,
    RoleArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return pipes(
        "PUT",
        "/v1/pipes/$(Name)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("RoleArn" => RoleArn), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: cloudtrail_data
using AWS.Compat
using AWS.UUIDs

"""
    put_audit_events(audit_events, channel_arn)
    put_audit_events(audit_events, channel_arn, params::Dict{String,<:Any})

Ingests your application events into CloudTrail Lake. A required parameter, auditEvents,
accepts the JSON records (also called payload) of events that you want CloudTrail to
ingest. You can add up to 100 of these events (or up to 1 MB) per PutAuditEvents request.

# Arguments
- `audit_events`: The JSON payload of events that you want to ingest. You can also point to
  the JSON event payload in a file.
- `channel_arn`: The ARN or ID (the ARN suffix) of a channel.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"externalId"`: A unique identifier that is conditionally required when the channel's
  resource policy includes an external ID. This value can be any string, such as a passphrase
  or account number.
"""
function put_audit_events(
    auditEvents, channelArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return cloudtrail_data(
        "POST",
        "/PutAuditEvents",
        Dict{String,Any}("auditEvents" => auditEvents, "channelArn" => channelArn);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_audit_events(
    auditEvents,
    channelArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return cloudtrail_data(
        "POST",
        "/PutAuditEvents",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("auditEvents" => auditEvents, "channelArn" => channelArn),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: controltower
using AWS.Compat
using AWS.UUIDs

"""
    create_landing_zone(manifest, version)
    create_landing_zone(manifest, version, params::Dict{String,<:Any})

Creates a new landing zone. This API call starts an asynchronous operation that creates and
configures a landing zone, based on the parameters specified in the manifest JSON file.

# Arguments
- `manifest`: The manifest JSON file is a text file that describes your Amazon Web Services
  resources. For examples, review Launch your landing zone.
- `version`: The landing zone version, for example, 3.0.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"tags"`: Tags to be applied to the landing zone.
"""
function create_landing_zone(
    manifest, version; aws_config::AbstractAWSConfig=current_aws_config()
)
    return controltower(
        "POST",
        "/create-landingzone",
        Dict{String,Any}("manifest" => manifest, "version" => version);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_landing_zone(
    manifest,
    version,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return controltower(
        "POST",
        "/create-landingzone",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("manifest" => manifest, "version" => version),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_landing_zone(landing_zone_identifier)
    delete_landing_zone(landing_zone_identifier, params::Dict{String,<:Any})

Decommissions a landing zone. This API call starts an asynchronous operation that deletes
Amazon Web Services Control Tower resources deployed in accounts managed by Amazon Web
Services Control Tower.

# Arguments
- `landing_zone_identifier`: The unique identifier of the landing zone.

"""
function delete_landing_zone(
    landingZoneIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return controltower(
        "POST",
        "/delete-landingzone",
        Dict{String,Any}("landingZoneIdentifier" => landingZoneIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_landing_zone(
    landingZoneIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return controltower(
        "POST",
        "/delete-landingzone",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("landingZoneIdentifier" => landingZoneIdentifier),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disable_baseline(enabled_baseline_identifier)
    disable_baseline(enabled_baseline_identifier, params::Dict{String,<:Any})

Disable an EnabledBaseline resource on the specified Target. This API starts an
asynchronous operation to remove all resources deployed as part of the baseline enablement.
The resource will vary depending on the enabled baseline. For usage examples, see  the
Amazon Web Services Control Tower User Guide .

# Arguments
- `enabled_baseline_identifier`: Identifier of the EnabledBaseline resource to be
  deactivated, in ARN format.

"""
function disable_baseline(
    enabledBaselineIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return controltower(
        "POST",
        "/disable-baseline",
        Dict{String,Any}("enabledBaselineIdentifier" => enabledBaselineIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disable_baseline(
    enabledBaselineIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return controltower(
        "POST",
        "/disable-baseline",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("enabledBaselineIdentifier" => enabledBaselineIdentifier),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    disable_control(control_identifier, target_identifier)
    disable_control(control_identifier, target_identifier, params::Dict{String,<:Any})

This API call turns off a control. It starts an asynchronous operation that deletes AWS
resources on the specified organizational unit and the accounts it contains. The resources
will vary according to the control that you specify. For usage examples, see  the Amazon
Web Services Control Tower User Guide .

# Arguments
- `control_identifier`: The ARN of the control. Only Strongly recommended and Elective
  controls are permitted, with the exception of the Region deny control. For information on
  how to find the controlIdentifier, see the overview page.
- `target_identifier`: The ARN of the organizational unit. For information on how to find
  the targetIdentifier, see the overview page.

"""
function disable_control(
    controlIdentifier, targetIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return controltower(
        "POST",
        "/disable-control",
        Dict{String,Any}(
            "controlIdentifier" => controlIdentifier, "targetIdentifier" => targetIdentifier
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function disable_control(
    controlIdentifier,
    targetIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return controltower(
        "POST",
        "/disable-control",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "controlIdentifier" => controlIdentifier,
                    "targetIdentifier" => targetIdentifier,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    enable_baseline(baseline_identifier, baseline_version, target_identifier)
    enable_baseline(baseline_identifier, baseline_version, target_identifier, params::Dict{String,<:Any})

Enable (apply) a Baseline to a Target. This API starts an asynchronous operation to deploy
resources specified by the Baseline to the specified Target. For usage examples, see  the
Amazon Web Services Control Tower User Guide .

# Arguments
- `baseline_identifier`: The ARN of the baseline to be enabled.
- `baseline_version`: The specific version to be enabled of the specified baseline.
- `target_identifier`: The ARN of the target on which the baseline will be enabled. Only
  OUs are supported as targets.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"parameters"`: A list of key-value objects that specify enablement parameters, where key
  is a string and value is a document of any type.
- `"tags"`: Tags associated with input to EnableBaseline.
"""
function enable_baseline(
    baselineIdentifier,
    baselineVersion,
    targetIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return controltower(
        "POST",
        "/enable-baseline",
        Dict{String,Any}(
            "baselineIdentifier" => baselineIdentifier,
            "baselineVersion" => baselineVersion,
            "targetIdentifier" => targetIdentifier,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function enable_baseline(
    baselineIdentifier,
    baselineVersion,
    targetIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return controltower(
        "POST",
        "/enable-baseline",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "baselineIdentifier" => baselineIdentifier,
                    "baselineVersion" => baselineVersion,
                    "targetIdentifier" => targetIdentifier,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    enable_control(control_identifier, target_identifier)
    enable_control(control_identifier, target_identifier, params::Dict{String,<:Any})

This API call activates a control. It starts an asynchronous operation that creates Amazon
Web Services resources on the specified organizational unit and the accounts it contains.
The resources created will vary according to the control that you specify. For usage
examples, see  the Amazon Web Services Control Tower User Guide .

# Arguments
- `control_identifier`: The ARN of the control. Only Strongly recommended and Elective
  controls are permitted, with the exception of the Region deny control. For information on
  how to find the controlIdentifier, see the overview page.
- `target_identifier`: The ARN of the organizational unit. For information on how to find
  the targetIdentifier, see the overview page.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"parameters"`: A list of input parameter values, which are specified to configure the
  control when you enable it.
- `"tags"`: Tags to be applied to the EnabledControl resource.
"""
function enable_control(
    controlIdentifier, targetIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return controltower(
        "POST",
        "/enable-control",
        Dict{String,Any}(
            "controlIdentifier" => controlIdentifier, "targetIdentifier" => targetIdentifier
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function enable_control(
    controlIdentifier,
    targetIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return controltower(
        "POST",
        "/enable-control",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "controlIdentifier" => controlIdentifier,
                    "targetIdentifier" => targetIdentifier,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_baseline(baseline_identifier)
    get_baseline(baseline_identifier, params::Dict{String,<:Any})

Retrieve details about an existing Baseline resource by specifying its identifier. For
usage examples, see  the Amazon Web Services Control Tower User Guide .

# Arguments
- `baseline_identifier`: The ARN of the Baseline resource to be retrieved.

"""
function get_baseline(
    baselineIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return controltower(
        "POST",
        "/get-baseline",
        Dict{String,Any}("baselineIdentifier" => baselineIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_baseline(
    baselineIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return controltower(
        "POST",
        "/get-baseline",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("baselineIdentifier" => baselineIdentifier), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_baseline_operation(operation_identifier)
    get_baseline_operation(operation_identifier, params::Dict{String,<:Any})

Returns the details of an asynchronous baseline operation, as initiated by any of these
APIs: EnableBaseline, DisableBaseline, UpdateEnabledBaseline, ResetEnabledBaseline. A
status message is displayed in case of operation failure. For usage examples, see  the
Amazon Web Services Control Tower User Guide .

# Arguments
- `operation_identifier`: The operation ID returned from mutating asynchronous APIs
  (Enable, Disable, Update, Reset).

"""
function get_baseline_operation(
    operationIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return controltower(
        "POST",
        "/get-baseline-operation",
        Dict{String,Any}("operationIdentifier" => operationIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_baseline_operation(
    operationIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return controltower(
        "POST",
        "/get-baseline-operation",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("operationIdentifier" => operationIdentifier),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_control_operation(operation_identifier)
    get_control_operation(operation_identifier, params::Dict{String,<:Any})

Returns the status of a particular EnableControl or DisableControl operation. Displays a
message in case of error. Details for an operation are available for 90 days. For usage
examples, see  the Amazon Web Services Control Tower User Guide .

# Arguments
- `operation_identifier`: The ID of the asynchronous operation, which is used to track
  status. The operation is available for 90 days.

"""
function get_control_operation(
    operationIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return controltower(
        "POST",
        "/get-control-operation",
        Dict{String,Any}("operationIdentifier" => operationIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_control_operation(
    operationIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return controltower(
        "POST",
        "/get-control-operation",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("operationIdentifier" => operationIdentifier),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_enabled_baseline(enabled_baseline_identifier)
    get_enabled_baseline(enabled_baseline_identifier, params::Dict{String,<:Any})

Retrieve details of an EnabledBaseline resource by specifying its identifier.

# Arguments
- `enabled_baseline_identifier`: Identifier of the EnabledBaseline resource to be
  retrieved, in ARN format.

"""
function get_enabled_baseline(
    enabledBaselineIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return controltower(
        "POST",
        "/get-enabled-baseline",
        Dict{String,Any}("enabledBaselineIdentifier" => enabledBaselineIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_enabled_baseline(
    enabledBaselineIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return controltower(
        "POST",
        "/get-enabled-baseline",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("enabledBaselineIdentifier" => enabledBaselineIdentifier),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_enabled_control(enabled_control_identifier)
    get_enabled_control(enabled_control_identifier, params::Dict{String,<:Any})

Retrieves details about an enabled control. For usage examples, see  the Amazon Web
Services Control Tower User Guide .

# Arguments
- `enabled_control_identifier`: The controlIdentifier of the enabled control.

"""
function get_enabled_control(
    enabledControlIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return controltower(
        "POST",
        "/get-enabled-control",
        Dict{String,Any}("enabledControlIdentifier" => enabledControlIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_enabled_control(
    enabledControlIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return controltower(
        "POST",
        "/get-enabled-control",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("enabledControlIdentifier" => enabledControlIdentifier),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_landing_zone(landing_zone_identifier)
    get_landing_zone(landing_zone_identifier, params::Dict{String,<:Any})

Returns details about the landing zone. Displays a message in case of error.

# Arguments
- `landing_zone_identifier`: The unique identifier of the landing zone.

"""
function get_landing_zone(
    landingZoneIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return controltower(
        "POST",
        "/get-landingzone",
        Dict{String,Any}("landingZoneIdentifier" => landingZoneIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_landing_zone(
    landingZoneIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return controltower(
        "POST",
        "/get-landingzone",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("landingZoneIdentifier" => landingZoneIdentifier),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_landing_zone_operation(operation_identifier)
    get_landing_zone_operation(operation_identifier, params::Dict{String,<:Any})

Returns the status of the specified landing zone operation. Details for an operation are
available for 90 days.

# Arguments
- `operation_identifier`: A unique identifier assigned to a landing zone operation.

"""
function get_landing_zone_operation(
    operationIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return controltower(
        "POST",
        "/get-landingzone-operation",
        Dict{String,Any}("operationIdentifier" => operationIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_landing_zone_operation(
    operationIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return controltower(
        "POST",
        "/get-landingzone-operation",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("operationIdentifier" => operationIdentifier),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_baselines()
    list_baselines(params::Dict{String,<:Any})

Returns a summary list of all available baselines. For usage examples, see  the Amazon Web
Services Control Tower User Guide .

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of results to be shown.
- `"nextToken"`: A pagination token.
"""
function list_baselines(; aws_config::AbstractAWSConfig=current_aws_config())
    return controltower(
        "POST", "/list-baselines"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_baselines(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return controltower(
        "POST",
        "/list-baselines",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_control_operations()
    list_control_operations(params::Dict{String,<:Any})

Provides a list of operations in progress or queued.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filter"`: An input filter for the ListControlOperations API that lets you select the
  types of control operations to view.
- `"maxResults"`: The maximum number of results to be shown.
- `"nextToken"`: A pagination token.
"""
function list_control_operations(; aws_config::AbstractAWSConfig=current_aws_config())
    return controltower(
        "POST",
        "/list-control-operations";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_control_operations(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return controltower(
        "POST",
        "/list-control-operations",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_enabled_baselines()
    list_enabled_baselines(params::Dict{String,<:Any})

Returns a list of summaries describing EnabledBaseline resources. You can filter the list
by the corresponding Baseline or Target of the EnabledBaseline resources. For usage
examples, see  the Amazon Web Services Control Tower User Guide .

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filter"`: A filter applied on the ListEnabledBaseline operation. Allowed filters are
  baselineIdentifiers and targetIdentifiers. The filter can be applied for either, or both.
- `"maxResults"`: The maximum number of results to be shown.
- `"nextToken"`: A pagination token.
"""
function list_enabled_baselines(; aws_config::AbstractAWSConfig=current_aws_config())
    return controltower(
        "POST",
        "/list-enabled-baselines";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_enabled_baselines(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return controltower(
        "POST",
        "/list-enabled-baselines",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_enabled_controls()
    list_enabled_controls(params::Dict{String,<:Any})

Lists the controls enabled by Amazon Web Services Control Tower on the specified
organizational unit and the accounts it contains. For usage examples, see  the Amazon Web
Services Control Tower User Guide .

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"filter"`: An input filter for the ListCEnabledControls API that lets you select the
  types of control operations to view.
- `"maxResults"`: How many results to return per API call.
- `"nextToken"`: The token to continue the list from a previous API call with the same
  parameters.
- `"targetIdentifier"`: The ARN of the organizational unit. For information on how to find
  the targetIdentifier, see the overview page.
"""
function list_enabled_controls(; aws_config::AbstractAWSConfig=current_aws_config())
    return controltower(
        "POST",
        "/list-enabled-controls";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_enabled_controls(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return controltower(
        "POST",
        "/list-enabled-controls",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_landing_zones()
    list_landing_zones(params::Dict{String,<:Any})

Returns the landing zone ARN for the landing zone deployed in your managed account. This
API also creates an ARN for existing accounts that do not yet have a landing zone ARN.
Returns one landing zone ARN.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of returned landing zone ARNs, which is one.
- `"nextToken"`: The token to continue the list from a previous API call with the same
  parameters.
"""
function list_landing_zones(; aws_config::AbstractAWSConfig=current_aws_config())
    return controltower(
        "POST", "/list-landingzones"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function list_landing_zones(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return controltower(
        "POST",
        "/list-landingzones",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Returns a list of tags associated with the resource. For usage examples, see  the Amazon
Web Services Control Tower User Guide .

# Arguments
- `resource_arn`:  The ARN of the resource.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return controltower(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return controltower(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    reset_enabled_baseline(enabled_baseline_identifier)
    reset_enabled_baseline(enabled_baseline_identifier, params::Dict{String,<:Any})

Re-enables an EnabledBaseline resource. For example, this API can re-apply the existing
Baseline after a new member account is moved to the target OU. For usage examples, see  the
Amazon Web Services Control Tower User Guide .

# Arguments
- `enabled_baseline_identifier`: Specifies the ID of the EnabledBaseline resource to be
  re-enabled, in ARN format.

"""
function reset_enabled_baseline(
    enabledBaselineIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return controltower(
        "POST",
        "/reset-enabled-baseline",
        Dict{String,Any}("enabledBaselineIdentifier" => enabledBaselineIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function reset_enabled_baseline(
    enabledBaselineIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return controltower(
        "POST",
        "/reset-enabled-baseline",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("enabledBaselineIdentifier" => enabledBaselineIdentifier),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    reset_landing_zone(landing_zone_identifier)
    reset_landing_zone(landing_zone_identifier, params::Dict{String,<:Any})

This API call resets a landing zone. It starts an asynchronous operation that resets the
landing zone to the parameters specified in its original configuration.

# Arguments
- `landing_zone_identifier`: The unique identifier of the landing zone.

"""
function reset_landing_zone(
    landingZoneIdentifier; aws_config::AbstractAWSConfig=current_aws_config()
)
    return controltower(
        "POST",
        "/reset-landingzone",
        Dict{String,Any}("landingZoneIdentifier" => landingZoneIdentifier);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function reset_landing_zone(
    landingZoneIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return controltower(
        "POST",
        "/reset-landingzone",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}("landingZoneIdentifier" => landingZoneIdentifier),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Applies tags to a resource. For usage examples, see  the Amazon Web Services Control Tower
User Guide .

# Arguments
- `resource_arn`: The ARN of the resource to be tagged.
- `tags`: Tags to be applied to the resource.

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return controltower(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return controltower(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Removes tags from a resource. For usage examples, see  the Amazon Web Services Control
Tower User Guide .

# Arguments
- `resource_arn`: The ARN of the resource.
- `tag_keys`: Tag keys to be removed from the resource.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return controltower(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return controltower(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_enabled_baseline(baseline_version, enabled_baseline_identifier)
    update_enabled_baseline(baseline_version, enabled_baseline_identifier, params::Dict{String,<:Any})

Updates an EnabledBaseline resource's applied parameters or version. For usage examples,
see  the Amazon Web Services Control Tower User Guide .

# Arguments
- `baseline_version`: Specifies the new Baseline version, to which the EnabledBaseline
  should be updated.
- `enabled_baseline_identifier`: Specifies the EnabledBaseline resource to be updated.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"parameters"`: Parameters to apply when making an update.
"""
function update_enabled_baseline(
    baselineVersion,
    enabledBaselineIdentifier;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return controltower(
        "POST",
        "/update-enabled-baseline",
        Dict{String,Any}(
            "baselineVersion" => baselineVersion,
            "enabledBaselineIdentifier" => enabledBaselineIdentifier,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_enabled_baseline(
    baselineVersion,
    enabledBaselineIdentifier,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return controltower(
        "POST",
        "/update-enabled-baseline",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "baselineVersion" => baselineVersion,
                    "enabledBaselineIdentifier" => enabledBaselineIdentifier,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_enabled_control(enabled_control_identifier, parameters)
    update_enabled_control(enabled_control_identifier, parameters, params::Dict{String,<:Any})

 Updates the configuration of an already enabled control. If the enabled control shows an
EnablementStatus of SUCCEEDED, supply parameters that are different from the currently
configured parameters. Otherwise, Amazon Web Services Control Tower will not accept the
request. If the enabled control shows an EnablementStatus of FAILED, Amazon Web Services
Control Tower will update the control to match any valid parameters that you supply. If the
DriftSummary status for the control shows as DRIFTED, you cannot call this API. Instead,
you can update the control by calling DisableControl and again calling EnableControl, or
you can run an extending governance operation. For usage examples, see  the Amazon Web
Services Control Tower User Guide

# Arguments
- `enabled_control_identifier`:  The ARN of the enabled control that will be updated.
- `parameters`: A key/value pair, where Key is of type String and Value is of type Document.

"""
function update_enabled_control(
    enabledControlIdentifier, parameters; aws_config::AbstractAWSConfig=current_aws_config()
)
    return controltower(
        "POST",
        "/update-enabled-control",
        Dict{String,Any}(
            "enabledControlIdentifier" => enabledControlIdentifier,
            "parameters" => parameters,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_enabled_control(
    enabledControlIdentifier,
    parameters,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return controltower(
        "POST",
        "/update-enabled-control",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "enabledControlIdentifier" => enabledControlIdentifier,
                    "parameters" => parameters,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_landing_zone(landing_zone_identifier, manifest, version)
    update_landing_zone(landing_zone_identifier, manifest, version, params::Dict{String,<:Any})

This API call updates the landing zone. It starts an asynchronous operation that updates
the landing zone based on the new landing zone version, or on the changed parameters
specified in the updated manifest file.

# Arguments
- `landing_zone_identifier`: The unique identifier of the landing zone.
- `manifest`: The manifest JSON file is a text file that describes your Amazon Web Services
  resources. For examples, review Launch your landing zone.
- `version`: The landing zone version, for example, 3.2.

"""
function update_landing_zone(
    landingZoneIdentifier,
    manifest,
    version;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return controltower(
        "POST",
        "/update-landingzone",
        Dict{String,Any}(
            "landingZoneIdentifier" => landingZoneIdentifier,
            "manifest" => manifest,
            "version" => version,
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_landing_zone(
    landingZoneIdentifier,
    manifest,
    version,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return controltower(
        "POST",
        "/update-landingzone",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "landingZoneIdentifier" => landingZoneIdentifier,
                    "manifest" => manifest,
                    "version" => version,
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: amplifyuibuilder
using AWS.Compat
using AWS.UUIDs

"""
    create_component(app_id, component_to_create, environment_name)
    create_component(app_id, component_to_create, environment_name, params::Dict{String,<:Any})

Creates a new component for an Amplify app.

# Arguments
- `app_id`: The unique ID of the Amplify app to associate with the component.
- `component_to_create`: Represents the configuration of the component to create.
- `environment_name`: The name of the backend environment that is a part of the Amplify app.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: The unique client token.
"""
function create_component(
    appId,
    componentToCreate,
    environmentName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifyuibuilder(
        "POST",
        "/app/$(appId)/environment/$(environmentName)/components",
        Dict{String,Any}(
            "componentToCreate" => componentToCreate, "clientToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_component(
    appId,
    componentToCreate,
    environmentName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifyuibuilder(
        "POST",
        "/app/$(appId)/environment/$(environmentName)/components",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "componentToCreate" => componentToCreate,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_form(app_id, environment_name, form_to_create)
    create_form(app_id, environment_name, form_to_create, params::Dict{String,<:Any})

Creates a new form for an Amplify app.

# Arguments
- `app_id`: The unique ID of the Amplify app to associate with the form.
- `environment_name`: The name of the backend environment that is a part of the Amplify app.
- `form_to_create`: Represents the configuration of the form to create.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: The unique client token.
"""
function create_form(
    appId, environmentName, formToCreate; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplifyuibuilder(
        "POST",
        "/app/$(appId)/environment/$(environmentName)/forms",
        Dict{String,Any}("formToCreate" => formToCreate, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_form(
    appId,
    environmentName,
    formToCreate,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifyuibuilder(
        "POST",
        "/app/$(appId)/environment/$(environmentName)/forms",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "formToCreate" => formToCreate, "clientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    create_theme(app_id, environment_name, theme_to_create)
    create_theme(app_id, environment_name, theme_to_create, params::Dict{String,<:Any})

Creates a theme to apply to the components in an Amplify app.

# Arguments
- `app_id`: The unique ID of the Amplify app associated with the theme.
- `environment_name`: The name of the backend environment that is a part of the Amplify app.
- `theme_to_create`: Represents the configuration of the theme to create.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: The unique client token.
"""
function create_theme(
    appId,
    environmentName,
    themeToCreate;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifyuibuilder(
        "POST",
        "/app/$(appId)/environment/$(environmentName)/themes",
        Dict{String,Any}(
            "themeToCreate" => themeToCreate, "clientToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function create_theme(
    appId,
    environmentName,
    themeToCreate,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifyuibuilder(
        "POST",
        "/app/$(appId)/environment/$(environmentName)/themes",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "themeToCreate" => themeToCreate, "clientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_component(app_id, environment_name, id)
    delete_component(app_id, environment_name, id, params::Dict{String,<:Any})

Deletes a component from an Amplify app.

# Arguments
- `app_id`: The unique ID of the Amplify app associated with the component to delete.
- `environment_name`: The name of the backend environment that is a part of the Amplify app.
- `id`: The unique ID of the component to delete.

"""
function delete_component(
    appId, environmentName, id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplifyuibuilder(
        "DELETE",
        "/app/$(appId)/environment/$(environmentName)/components/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_component(
    appId,
    environmentName,
    id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifyuibuilder(
        "DELETE",
        "/app/$(appId)/environment/$(environmentName)/components/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_form(app_id, environment_name, id)
    delete_form(app_id, environment_name, id, params::Dict{String,<:Any})

Deletes a form from an Amplify app.

# Arguments
- `app_id`: The unique ID of the Amplify app associated with the form to delete.
- `environment_name`: The name of the backend environment that is a part of the Amplify app.
- `id`: The unique ID of the form to delete.

"""
function delete_form(
    appId, environmentName, id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplifyuibuilder(
        "DELETE",
        "/app/$(appId)/environment/$(environmentName)/forms/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_form(
    appId,
    environmentName,
    id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifyuibuilder(
        "DELETE",
        "/app/$(appId)/environment/$(environmentName)/forms/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    delete_theme(app_id, environment_name, id)
    delete_theme(app_id, environment_name, id, params::Dict{String,<:Any})

Deletes a theme from an Amplify app.

# Arguments
- `app_id`: The unique ID of the Amplify app associated with the theme to delete.
- `environment_name`: The name of the backend environment that is a part of the Amplify app.
- `id`: The unique ID of the theme to delete.

"""
function delete_theme(
    appId, environmentName, id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplifyuibuilder(
        "DELETE",
        "/app/$(appId)/environment/$(environmentName)/themes/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function delete_theme(
    appId,
    environmentName,
    id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifyuibuilder(
        "DELETE",
        "/app/$(appId)/environment/$(environmentName)/themes/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    exchange_code_for_token(provider, request)
    exchange_code_for_token(provider, request, params::Dict{String,<:Any})

 This is for internal use.  Amplify uses this action to exchange an access code for a token.

# Arguments
- `provider`: The third-party provider for the token. The only valid value is figma.
- `request`: Describes the configuration of the request.

"""
function exchange_code_for_token(
    provider, request; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplifyuibuilder(
        "POST",
        "/tokens/$(provider)",
        Dict{String,Any}("request" => request);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function exchange_code_for_token(
    provider,
    request,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifyuibuilder(
        "POST",
        "/tokens/$(provider)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("request" => request), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    export_components(app_id, environment_name)
    export_components(app_id, environment_name, params::Dict{String,<:Any})

Exports component configurations to code that is ready to integrate into an Amplify app.

# Arguments
- `app_id`: The unique ID of the Amplify app to export components to.
- `environment_name`: The name of the backend environment that is a part of the Amplify app.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: The token to request the next page of results.
"""
function export_components(
    appId, environmentName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplifyuibuilder(
        "GET",
        "/export/app/$(appId)/environment/$(environmentName)/components";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function export_components(
    appId,
    environmentName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifyuibuilder(
        "GET",
        "/export/app/$(appId)/environment/$(environmentName)/components",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    export_forms(app_id, environment_name)
    export_forms(app_id, environment_name, params::Dict{String,<:Any})

Exports form configurations to code that is ready to integrate into an Amplify app.

# Arguments
- `app_id`: The unique ID of the Amplify app to export forms to.
- `environment_name`: The name of the backend environment that is a part of the Amplify app.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: The token to request the next page of results.
"""
function export_forms(
    appId, environmentName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplifyuibuilder(
        "GET",
        "/export/app/$(appId)/environment/$(environmentName)/forms";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function export_forms(
    appId,
    environmentName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifyuibuilder(
        "GET",
        "/export/app/$(appId)/environment/$(environmentName)/forms",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    export_themes(app_id, environment_name)
    export_themes(app_id, environment_name, params::Dict{String,<:Any})

Exports theme configurations to code that is ready to integrate into an Amplify app.

# Arguments
- `app_id`: The unique ID of the Amplify app to export the themes to.
- `environment_name`: The name of the backend environment that is part of the Amplify app.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"nextToken"`: The token to request the next page of results.
"""
function export_themes(
    appId, environmentName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplifyuibuilder(
        "GET",
        "/export/app/$(appId)/environment/$(environmentName)/themes";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function export_themes(
    appId,
    environmentName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifyuibuilder(
        "GET",
        "/export/app/$(appId)/environment/$(environmentName)/themes",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_codegen_job(app_id, environment_name, id)
    get_codegen_job(app_id, environment_name, id, params::Dict{String,<:Any})

Returns an existing code generation job.

# Arguments
- `app_id`: The unique ID of the Amplify app associated with the code generation job.
- `environment_name`: The name of the backend environment that is a part of the Amplify app
  associated with the code generation job.
- `id`: The unique ID of the code generation job.

"""
function get_codegen_job(
    appId, environmentName, id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplifyuibuilder(
        "GET",
        "/app/$(appId)/environment/$(environmentName)/codegen-jobs/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_codegen_job(
    appId,
    environmentName,
    id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifyuibuilder(
        "GET",
        "/app/$(appId)/environment/$(environmentName)/codegen-jobs/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_component(app_id, environment_name, id)
    get_component(app_id, environment_name, id, params::Dict{String,<:Any})

Returns an existing component for an Amplify app.

# Arguments
- `app_id`: The unique ID of the Amplify app.
- `environment_name`: The name of the backend environment that is part of the Amplify app.
- `id`: The unique ID of the component.

"""
function get_component(
    appId, environmentName, id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplifyuibuilder(
        "GET",
        "/app/$(appId)/environment/$(environmentName)/components/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_component(
    appId,
    environmentName,
    id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifyuibuilder(
        "GET",
        "/app/$(appId)/environment/$(environmentName)/components/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_form(app_id, environment_name, id)
    get_form(app_id, environment_name, id, params::Dict{String,<:Any})

Returns an existing form for an Amplify app.

# Arguments
- `app_id`: The unique ID of the Amplify app.
- `environment_name`: The name of the backend environment that is part of the Amplify app.
- `id`: The unique ID of the form.

"""
function get_form(
    appId, environmentName, id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplifyuibuilder(
        "GET",
        "/app/$(appId)/environment/$(environmentName)/forms/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_form(
    appId,
    environmentName,
    id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifyuibuilder(
        "GET",
        "/app/$(appId)/environment/$(environmentName)/forms/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_metadata(app_id, environment_name)
    get_metadata(app_id, environment_name, params::Dict{String,<:Any})

Returns existing metadata for an Amplify app.

# Arguments
- `app_id`: The unique ID of the Amplify app.
- `environment_name`: The name of the backend environment that is part of the Amplify app.

"""
function get_metadata(
    appId, environmentName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplifyuibuilder(
        "GET",
        "/app/$(appId)/environment/$(environmentName)/metadata";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_metadata(
    appId,
    environmentName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifyuibuilder(
        "GET",
        "/app/$(appId)/environment/$(environmentName)/metadata",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    get_theme(app_id, environment_name, id)
    get_theme(app_id, environment_name, id, params::Dict{String,<:Any})

Returns an existing theme for an Amplify app.

# Arguments
- `app_id`: The unique ID of the Amplify app.
- `environment_name`: The name of the backend environment that is part of the Amplify app.
- `id`: The unique ID for the theme.

"""
function get_theme(
    appId, environmentName, id; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplifyuibuilder(
        "GET",
        "/app/$(appId)/environment/$(environmentName)/themes/$(id)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function get_theme(
    appId,
    environmentName,
    id,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifyuibuilder(
        "GET",
        "/app/$(appId)/environment/$(environmentName)/themes/$(id)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_codegen_jobs(app_id, environment_name)
    list_codegen_jobs(app_id, environment_name, params::Dict{String,<:Any})

Retrieves a list of code generation jobs for a specified Amplify app and backend
environment.

# Arguments
- `app_id`: The unique ID for the Amplify app.
- `environment_name`: The name of the backend environment that is a part of the Amplify app.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of jobs to retrieve.
- `"nextToken"`: The token to request the next page of results.
"""
function list_codegen_jobs(
    appId, environmentName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplifyuibuilder(
        "GET",
        "/app/$(appId)/environment/$(environmentName)/codegen-jobs";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_codegen_jobs(
    appId,
    environmentName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifyuibuilder(
        "GET",
        "/app/$(appId)/environment/$(environmentName)/codegen-jobs",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_components(app_id, environment_name)
    list_components(app_id, environment_name, params::Dict{String,<:Any})

Retrieves a list of components for a specified Amplify app and backend environment.

# Arguments
- `app_id`: The unique ID for the Amplify app.
- `environment_name`: The name of the backend environment that is a part of the Amplify app.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of components to retrieve.
- `"nextToken"`: The token to request the next page of results.
"""
function list_components(
    appId, environmentName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplifyuibuilder(
        "GET",
        "/app/$(appId)/environment/$(environmentName)/components";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_components(
    appId,
    environmentName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifyuibuilder(
        "GET",
        "/app/$(appId)/environment/$(environmentName)/components",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_forms(app_id, environment_name)
    list_forms(app_id, environment_name, params::Dict{String,<:Any})

Retrieves a list of forms for a specified Amplify app and backend environment.

# Arguments
- `app_id`: The unique ID for the Amplify app.
- `environment_name`: The name of the backend environment that is a part of the Amplify app.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of forms to retrieve.
- `"nextToken"`: The token to request the next page of results.
"""
function list_forms(
    appId, environmentName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplifyuibuilder(
        "GET",
        "/app/$(appId)/environment/$(environmentName)/forms";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_forms(
    appId,
    environmentName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifyuibuilder(
        "GET",
        "/app/$(appId)/environment/$(environmentName)/forms",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_tags_for_resource(resource_arn)
    list_tags_for_resource(resource_arn, params::Dict{String,<:Any})

Returns a list of tags for a specified Amazon Resource Name (ARN).

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) to use to list tags.

"""
function list_tags_for_resource(
    resourceArn; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplifyuibuilder(
        "GET",
        "/tags/$(resourceArn)";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_tags_for_resource(
    resourceArn,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifyuibuilder(
        "GET",
        "/tags/$(resourceArn)",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    list_themes(app_id, environment_name)
    list_themes(app_id, environment_name, params::Dict{String,<:Any})

Retrieves a list of themes for a specified Amplify app and backend environment.

# Arguments
- `app_id`: The unique ID for the Amplify app.
- `environment_name`: The name of the backend environment that is a part of the Amplify app.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"maxResults"`: The maximum number of theme results to return in the response.
- `"nextToken"`: The token to request the next page of results.
"""
function list_themes(
    appId, environmentName; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplifyuibuilder(
        "GET",
        "/app/$(appId)/environment/$(environmentName)/themes";
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function list_themes(
    appId,
    environmentName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifyuibuilder(
        "GET",
        "/app/$(appId)/environment/$(environmentName)/themes",
        params;
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    put_metadata_flag(app_id, body, environment_name, feature_name)
    put_metadata_flag(app_id, body, environment_name, feature_name, params::Dict{String,<:Any})

Stores the metadata information about a feature on a form.

# Arguments
- `app_id`: The unique ID for the Amplify app.
- `body`: The metadata information to store.
- `environment_name`: The name of the backend environment that is part of the Amplify app.
- `feature_name`: The name of the feature associated with the metadata.

"""
function put_metadata_flag(
    appId,
    body,
    environmentName,
    featureName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifyuibuilder(
        "PUT",
        "/app/$(appId)/environment/$(environmentName)/metadata/features/$(featureName)",
        Dict{String,Any}("body" => body);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function put_metadata_flag(
    appId,
    body,
    environmentName,
    featureName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifyuibuilder(
        "PUT",
        "/app/$(appId)/environment/$(environmentName)/metadata/features/$(featureName)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("body" => body), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    refresh_token(provider, refresh_token_body)
    refresh_token(provider, refresh_token_body, params::Dict{String,<:Any})

 This is for internal use.  Amplify uses this action to refresh a previously issued access
token that might have expired.

# Arguments
- `provider`: The third-party provider for the token. The only valid value is figma.
- `refresh_token_body`: Information about the refresh token request.

"""
function refresh_token(
    provider, refreshTokenBody; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplifyuibuilder(
        "POST",
        "/tokens/$(provider)/refresh",
        Dict{String,Any}("refreshTokenBody" => refreshTokenBody);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function refresh_token(
    provider,
    refreshTokenBody,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifyuibuilder(
        "POST",
        "/tokens/$(provider)/refresh",
        Dict{String,Any}(
            mergewith(
                _merge, Dict{String,Any}("refreshTokenBody" => refreshTokenBody), params
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    start_codegen_job(app_id, codegen_job_to_create, environment_name)
    start_codegen_job(app_id, codegen_job_to_create, environment_name, params::Dict{String,<:Any})

Starts a code generation job for a specified Amplify app and backend environment.

# Arguments
- `app_id`: The unique ID for the Amplify app.
- `codegen_job_to_create`: The code generation job resource configuration.
- `environment_name`: The name of the backend environment that is a part of the Amplify app.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: The idempotency token used to ensure that the code generation job
  request completes only once.
"""
function start_codegen_job(
    appId,
    codegenJobToCreate,
    environmentName;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifyuibuilder(
        "POST",
        "/app/$(appId)/environment/$(environmentName)/codegen-jobs",
        Dict{String,Any}(
            "codegenJobToCreate" => codegenJobToCreate, "clientToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function start_codegen_job(
    appId,
    codegenJobToCreate,
    environmentName,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifyuibuilder(
        "POST",
        "/app/$(appId)/environment/$(environmentName)/codegen-jobs",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "codegenJobToCreate" => codegenJobToCreate,
                    "clientToken" => string(uuid4()),
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    tag_resource(resource_arn, tags)
    tag_resource(resource_arn, tags, params::Dict{String,<:Any})

Tags the resource with a tag key and value.

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) to use to tag a resource.
- `tags`: A list of tag key value pairs for a specified Amazon Resource Name (ARN).

"""
function tag_resource(resourceArn, tags; aws_config::AbstractAWSConfig=current_aws_config())
    return amplifyuibuilder(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tags" => tags);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function tag_resource(
    resourceArn,
    tags,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifyuibuilder(
        "POST",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tags" => tags), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    untag_resource(resource_arn, tag_keys)
    untag_resource(resource_arn, tag_keys, params::Dict{String,<:Any})

Untags a resource with a specified Amazon Resource Name (ARN).

# Arguments
- `resource_arn`: The Amazon Resource Name (ARN) to use to untag a resource.
- `tag_keys`: The tag keys to use to untag a resource.

"""
function untag_resource(
    resourceArn, tagKeys; aws_config::AbstractAWSConfig=current_aws_config()
)
    return amplifyuibuilder(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}("tagKeys" => tagKeys);
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function untag_resource(
    resourceArn,
    tagKeys,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifyuibuilder(
        "DELETE",
        "/tags/$(resourceArn)",
        Dict{String,Any}(mergewith(_merge, Dict{String,Any}("tagKeys" => tagKeys), params));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_component(app_id, environment_name, id, updated_component)
    update_component(app_id, environment_name, id, updated_component, params::Dict{String,<:Any})

Updates an existing component.

# Arguments
- `app_id`: The unique ID for the Amplify app.
- `environment_name`: The name of the backend environment that is part of the Amplify app.
- `id`: The unique ID for the component.
- `updated_component`: The configuration of the updated component.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: The unique client token.
"""
function update_component(
    appId,
    environmentName,
    id,
    updatedComponent;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifyuibuilder(
        "PATCH",
        "/app/$(appId)/environment/$(environmentName)/components/$(id)",
        Dict{String,Any}(
            "updatedComponent" => updatedComponent, "clientToken" => string(uuid4())
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_component(
    appId,
    environmentName,
    id,
    updatedComponent,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifyuibuilder(
        "PATCH",
        "/app/$(appId)/environment/$(environmentName)/components/$(id)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "updatedComponent" => updatedComponent, "clientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_form(app_id, environment_name, id, updated_form)
    update_form(app_id, environment_name, id, updated_form, params::Dict{String,<:Any})

Updates an existing form.

# Arguments
- `app_id`: The unique ID for the Amplify app.
- `environment_name`: The name of the backend environment that is part of the Amplify app.
- `id`: The unique ID for the form.
- `updated_form`: The request accepts the following data in JSON format.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: The unique client token.
"""
function update_form(
    appId,
    environmentName,
    id,
    updatedForm;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifyuibuilder(
        "PATCH",
        "/app/$(appId)/environment/$(environmentName)/forms/$(id)",
        Dict{String,Any}("updatedForm" => updatedForm, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_form(
    appId,
    environmentName,
    id,
    updatedForm,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifyuibuilder(
        "PATCH",
        "/app/$(appId)/environment/$(environmentName)/forms/$(id)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "updatedForm" => updatedForm, "clientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

"""
    update_theme(app_id, environment_name, id, updated_theme)
    update_theme(app_id, environment_name, id, updated_theme, params::Dict{String,<:Any})

Updates an existing theme.

# Arguments
- `app_id`: The unique ID for the Amplify app.
- `environment_name`: The name of the backend environment that is part of the Amplify app.
- `id`: The unique ID for the theme.
- `updated_theme`: The configuration of the updated theme.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"clientToken"`: The unique client token.
"""
function update_theme(
    appId,
    environmentName,
    id,
    updatedTheme;
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifyuibuilder(
        "PATCH",
        "/app/$(appId)/environment/$(environmentName)/themes/$(id)",
        Dict{String,Any}("updatedTheme" => updatedTheme, "clientToken" => string(uuid4()));
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end
function update_theme(
    appId,
    environmentName,
    id,
    updatedTheme,
    params::AbstractDict{String};
    aws_config::AbstractAWSConfig=current_aws_config(),
)
    return amplifyuibuilder(
        "PATCH",
        "/app/$(appId)/environment/$(environmentName)/themes/$(id)",
        Dict{String,Any}(
            mergewith(
                _merge,
                Dict{String,Any}(
                    "updatedTheme" => updatedTheme, "clientToken" => string(uuid4())
                ),
                params,
            ),
        );
        aws_config=aws_config,
        feature_set=SERVICE_FEATURE_SET,
    )
end

# This file is auto-generated by AWSMetadata.jl
using AWS
using AWS.AWSServices: qldb_session
using AWS.Compat
using AWS.UUIDs

"""
    send_command()
    send_command(params::Dict{String,<:Any})

Sends a command to an Amazon QLDB ledger.  Instead of interacting directly with this API,
we recommend using the QLDB driver or the QLDB shell to execute data transactions on a
ledger.   If you are working with an AWS SDK, use the QLDB driver. The driver provides a
high-level abstraction layer above this QLDB Session data plane and manages SendCommand API
calls for you. For information and a list of supported programming languages, see Getting
started with the driver in the Amazon QLDB Developer Guide.   If you are working with the
AWS Command Line Interface (AWS CLI), use the QLDB shell. The shell is a command line
interface that uses the QLDB driver to interact with a ledger. For information, see
Accessing Amazon QLDB using the QLDB shell.

# Optional Parameters
Optional parameters can be passed as a `params::Dict{String,<:Any}`. Valid keys are:
- `"AbortTransaction"`: Command to abort the current transaction.
- `"CommitTransaction"`: Command to commit the specified transaction.
- `"EndSession"`: Command to end the current session.
- `"ExecuteStatement"`: Command to execute a statement in the specified transaction.
- `"FetchPage"`: Command to fetch a page.
- `"SessionToken"`: Specifies the session token for the current command. A session token is
  constant throughout the life of the session. To obtain a session token, run the
  StartSession command. This SessionToken is required for every subsequent command that is
  issued during the current session.
- `"StartSession"`: Command to start a new session. A session token is obtained as part of
  the response.
- `"StartTransaction"`: Command to start a new transaction.
"""
function send_command(; aws_config::AbstractAWSConfig=current_aws_config())
    return qldb_session(
        "SendCommand"; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end
function send_command(
    params::AbstractDict{String}; aws_config::AbstractAWSConfig=current_aws_config()
)
    return qldb_session(
        "SendCommand", params; aws_config=aws_config, feature_set=SERVICE_FEATURE_SET
    )
end

# Backends

AWS.jl supports two "backends" which serve as HTTP clients to reach the AWS REST API.

The backend can be specified in two ways: by setting the global [`AWS.DEFAULT_BACKEND`](@ref), or by setting the backend on a per-request basis by setting the `"backend"` key in `params` dictionaries:

```julia
using AWS
@service S3 use_response_type = true
result = S3.get_object(bucket, key, Dict("backend" => AWS.DownloadsBackend()))

```
Note: `use_response_type=true` is not needed here for the backend selection to work; it is just a recommended option in general. See [`@service`](@ref) for more.

```@docs
AWS.AbstractBackend
AWS.DEFAULT_BACKEND
AWS.HTTPBackend
AWS.DownloadsBackend
```

# AWS

```@meta
CurrentModule = AWS
```

### Index
```@index
Modules = [AWS]
```

### Documentation
```@autodocs
Modules = [AWS]
Order = [:module, :macro, :type, :function, :constant]
Private = false
```

```@docs
FeatureSet
```

## AWS.jl

[![CI](https://github.com/JuliaCloud/AWS.jl/workflows/CI/badge.svg)](https://github.com/JuliaCloud/AWS.jl/actions?query=workflow%3ACI)
[![Code Style: Blue](https://img.shields.io/badge/code%20style-blue-4495d1.svg)](https://github.com/invenia/BlueStyle)
[![ColPrac: Contributor's Guide on Collaborative Practices for Community Packages](https://img.shields.io/badge/ColPrac-Contributor's%20Guide-blueviolet)](https://github.com/SciML/ColPrac)


[AWS.jl](https://github.com/JuliaCloud/AWS.jl) is a Julia interface for [Amazon Web Services](https://aws.amazon.com).

This package replaces [AWSCore.jl](https://github.com/JuliaCloud/AWSCore.jl) and [AWSSDK.jl](https://github.com/JuliaCloud/AWSSDK.jl) which previously provided low-level and high-level APIs respectively.
It includes automated code generation to ensure all new AWS services are available, as well as keeping existing services up to date.

To see an overview of the architecture see the [design document](https://github.com/JuliaCloud/AWS.jl/wiki/v1-Design-Document).

## Installation
You will need some form of AWS credentials to use this package.
The most simple way is to set up [AWS CLI](https://docs.aws.amazon.com/cli/latest/userguide/cli-configure-quickstart.html).

```julia
julia> Pkg.add("AWS")
```

## Usage
`AWS.jl` can be used with low-level and high-level API requests.
Please note when passing parameters for a request they must be a subtype of `AbstractDict{String, <:Any}`.

### Low-Level
To use the low-level API, you must know how to perform the request you are making.
If you do not know how to perform a request you can reference the [AWS Documentation](https://docs.aws.amazon.com/).
Alternatively you can look at `/src/services/{Service}.jl` to find a list of available requests, as well as their required and optional parameters.

For example, to list the objects in an S3 bucket you must pass in the request method (`"GET"`) and the endpoint (`"/${bucket}"`):

```julia
using AWS.AWSServices: s3

s3("GET", "/your-bucket")
```

### High-Level
To use the high-level API, you only need to know the name of the request you wish to make.
For example again, to list the objects in an S3 bucket:

```julia
using AWS: @service
@service S3

S3.list_objects("/your-bucket")
```

#### Documentation for High-Level APIs
```@contents
Pages = readdir("services"; join=true)
```
